/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 33,
  Feature_HasStdExtZicondBit = 34,
  Feature_HasStdExtZimopBit = 32,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 36,
  Feature_NoHasStdExtZilsdBit = 35,
  Feature_HasStdExtZmmulBit = 22,
  Feature_HasStdExtMBit = 23,
  Feature_HasStdExtABit = 25,
  Feature_HasStdExtZtsoBit = 27,
  Feature_NotHasStdExtZtsoBit = 26,
  Feature_HasStdExtZabhaBit = 30,
  Feature_HasStdExtZacasBit = 29,
  Feature_NoStdExtZacasBit = 28,
  Feature_HasStdExtZalasrBit = 31,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 37,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtCOrZcaBit = 20,
  Feature_HasStdExtZbaBit = 43,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 40,
  Feature_NoStdExtZbbBit = 42,
  Feature_HasStdExtZbcBit = 45,
  Feature_HasStdExtZbsBit = 39,
  Feature_HasStdExtZbkbBit = 41,
  Feature_NoStdExtZbkbBit = 94,
  Feature_HasStdExtZbkxBit = 46,
  Feature_HasStdExtZbbOrZbkbBit = 38,
  Feature_HasStdExtZbcOrZbkcBit = 44,
  Feature_HasStdExtZkndBit = 47,
  Feature_HasStdExtZkneBit = 49,
  Feature_HasStdExtZkndOrZkneBit = 48,
  Feature_HasStdExtZknhBit = 50,
  Feature_HasStdExtZksedBit = 51,
  Feature_HasStdExtZkshBit = 52,
  Feature_HasStdExtZvkbBit = 60,
  Feature_HasStdExtZvbbBit = 59,
  Feature_HasStdExtZvbcBit = 64,
  Feature_HasStdExtZvkgBit = 61,
  Feature_HasStdExtZvknedBit = 62,
  Feature_HasStdExtZvknhaBit = 65,
  Feature_HasStdExtZvknhbBit = 66,
  Feature_HasStdExtZvksedBit = 67,
  Feature_HasStdExtZvkshBit = 63,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 55,
  Feature_HasVInstructionsAnyFBit = 54,
  Feature_HasVInstructionsF16MinimalBit = 57,
  Feature_HasVInstructionsF16Bit = 53,
  Feature_HasVInstructionsF64Bit = 58,
  Feature_HasVInstructionsFullMultiplyBit = 56,
  Feature_HasVendorXVentanaCondOpsBit = 68,
  Feature_HasVendorXTHeadBaBit = 69,
  Feature_HasVendorXTHeadBbBit = 70,
  Feature_HasVendorXTHeadBsBit = 71,
  Feature_HasVendorXTHeadCondMovBit = 72,
  Feature_HasVendorXTHeadFMemIdxBit = 77,
  Feature_HasVendorXTHeadMacBit = 73,
  Feature_HasVendorXTHeadMemIdxBit = 76,
  Feature_HasVendorXTHeadMemPairBit = 75,
  Feature_HasVendorXTHeadVdotBit = 74,
  Feature_HasVendorXSfvcpBit = 78,
  Feature_HasVendorXSfvqmaccdodBit = 79,
  Feature_HasVendorXSfvqmaccqoqBit = 80,
  Feature_HasVendorXSfvfnrclipxfqfBit = 81,
  Feature_HasVendorXCVbitmanipBit = 83,
  Feature_HasVendorXCVmacBit = 86,
  Feature_HasVendorXCVmemBit = 82,
  Feature_HasVendorXCValuBit = 84,
  Feature_HasVendorXCVbiBit = 85,
  Feature_UseCCMovInsnBit = 92,
  Feature_HasVendorXqciaBit = 90,
  Feature_HasVendorXqciintBit = 91,
  Feature_HasVendorXqciliaBit = 87,
  Feature_HasVendorXqciloBit = 88,
  Feature_HasVendorXqcislsBit = 89,
  Feature_HasVendorXAndesPerfBit = 93,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 24,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 96,
  Feature_HwMode0Bit = 95,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (!Subtarget->hasStdExtZilsd())
    Features.set(Feature_NoHasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtCOrZca())
    Features.set(Feature_HasStdExtCOrZcaBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode0,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9942,
  GICXXPred_MI_Predicate_anonymous_9944,
  GICXXPred_MI_Predicate_anonymous_10032,
  GICXXPred_MI_Predicate_anonymous_10046,
  GICXXPred_MI_Predicate_anonymous_10050,
  GICXXPred_MI_Predicate_anonymous_10052,
  GICXXPred_MI_Predicate_anonymous_10054,
  GICXXPred_MI_Predicate_anonymous_10056,
  GICXXPred_MI_Predicate_anonymous_10059,
  GICXXPred_MI_Predicate_anonymous_10061,
  GICXXPred_MI_Predicate_anonymous_10074,
  GICXXPred_MI_Predicate_anonymous_10086,
  GICXXPred_MI_Predicate_anonymous_11275,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9942: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9944: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10032: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10046: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10050: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10052: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10054: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10056: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10059: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10061: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10074: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10086: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11275: {
     return hasAllHUsers(MI); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(333), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2439757),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1130),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61071),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80304),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107358),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110092),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(112826),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(115605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118339),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(127821),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(140442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(155349), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(155410), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(155471), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(155562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(155929),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(156127),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(156325),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(156905),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(157115),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(157313),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(157352),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(157391),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(167673),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(169643), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(171133), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(179337),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(184223),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(187133), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(190043),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(192953),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(193865),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(196775),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(199685),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(202595),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(205505),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(208415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(211325), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(211543),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2196930), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2198446), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     354 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2201567),
     /*     358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2205042),
     /*     362 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2205557),
     /*     366 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2209244),
     /*     370 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2217840),
     /*     374 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2220871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     386 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2223810),
     /*     390 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2226750),
     /*     394 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2229660),
     /*     398 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2256323), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     410 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2263785), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     454 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2268177),
     /*     458 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2270911),
     /*     462 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2273645),
     /*     466 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2276498),
     /*     470 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2279351),
     /*     474 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2282204),
     /*     478 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2285057),
     /*     482 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2285115), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2285173),
     /*     522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2287601),
     /*     526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2290029),
     /*     530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2292457), GIMT_Encode4(0),
     /*     538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2309102), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2311530),
     /*     590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2313501),
     /*     594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2313954),
     /*     598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2315490),
     /*     602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2320376),
     /*     606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2325262),
     /*     610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2330548), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     622 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2335834),
     /*     626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2337805), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2343867),
     /*     638 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2344057),
     /*     642 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2346142), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     654 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2348227),
     /*     658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2348353),
     /*     662 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2348479),
     /*     666 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2350564), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     702 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2352649),
     /*     706 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2355425),
     /*     710 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2358201),
     /*     714 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2360977),
     /*     718 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2363753),
     /*     722 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2363911),
     /*     726 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2364491),
     /*     730 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2364701), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     774 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2364717), GIMT_Encode4(0),
     /*     782 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2367237), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2369895),
     /*     794 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2372446),
     /*     798 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2374981),
     /*     802 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2377475), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     850 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2377673),
     /*     854 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2379849),
     /*     858 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2380047),
     /*     862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2380245), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2380443),
     /*     894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2382871),
     /*     898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2385299),
     /*     902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2387727), GIMT_Encode4(0),
     /*     910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2390155),
     /*     914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2406800), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     950 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2408976),
     /*     954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2408989), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1050 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2409002),
     /*    1054 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2409097),
     /*    1058 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2409127),
     /*    1062 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2409164),
     /*    1066 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2409201),
     /*    1070 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2409561),
     /*    1074 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2409759),
     /*    1078 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2409957),
     /*    1082 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2410017),
     /*    1086 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2410054),
     /*    1090 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2410179),
     /*    1094 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2410300), GIMT_Encode4(0),
     /*    1102 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2410347),
     /*    1106 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2410394),
     /*    1110 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2410441),
     /*    1114 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2411090),
     /*    1118 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2411739),
     /*    1122 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2415997),
     /*    1126 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2427877),
     /*    1130 */ // Label 0: @1130
     /*    1130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61070),
     /*    1141 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1265),
     /*    1145 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(3530), GIMT_Encode4(0),
     /*    1153 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11430),
     /*    1157 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(11825),
     /*    1161 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(14950),
     /*    1165 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18075), GIMT_Encode4(0),
     /*    1173 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21200),
     /*    1177 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(21595),
     /*    1181 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(24720),
     /*    1185 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(27845), GIMT_Encode4(0),
     /*    1193 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(30970),
     /*    1197 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31365),
     /*    1201 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34490),
     /*    1205 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(37615), GIMT_Encode4(0),
     /*    1213 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(40740),
     /*    1217 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41135),
     /*    1221 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44260),
     /*    1225 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47385), GIMT_Encode4(0),
     /*    1233 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50510),
     /*    1237 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(50905),
     /*    1241 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54030), GIMT_Encode4(0),
     /*    1249 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57155),
     /*    1253 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(57550), GIMT_Encode4(0),
     /*    1261 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(60675),
     /*    1265 */ // Label 126: @1265
     /*    1265 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3529),
     /*    1270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1276 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1324), // Rule ID 2562 //
     /*    1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1288 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1292 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1311 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1322 */     GIR_RootConstrainSelectedInstOperands,
     /*    1323 */     // GIR_Coverage, 2562,
     /*    1323 */     GIR_EraseRootFromParent_Done,
     /*    1324 */   // Label 152: @1324
     /*    1324 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1372), // Rule ID 2572 //
     /*    1329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1336 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1359 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1370 */     GIR_RootConstrainSelectedInstOperands,
     /*    1371 */     // GIR_Coverage, 2572,
     /*    1371 */     GIR_EraseRootFromParent_Done,
     /*    1372 */   // Label 153: @1372
     /*    1372 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1420), // Rule ID 2582 //
     /*    1377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1384 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1388 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1407 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1418 */     GIR_RootConstrainSelectedInstOperands,
     /*    1419 */     // GIR_Coverage, 2582,
     /*    1419 */     GIR_EraseRootFromParent_Done,
     /*    1420 */   // Label 154: @1420
     /*    1420 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1471), // Rule ID 62526 //
     /*    1425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1432 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1436 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1455 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1469 */     GIR_RootConstrainSelectedInstOperands,
     /*    1470 */     // GIR_Coverage, 62526,
     /*    1470 */     GIR_EraseRootFromParent_Done,
     /*    1471 */   // Label 155: @1471
     /*    1471 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1522), // Rule ID 62530 //
     /*    1476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1487 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1506 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1520 */     GIR_RootConstrainSelectedInstOperands,
     /*    1521 */     // GIR_Coverage, 62530,
     /*    1521 */     GIR_EraseRootFromParent_Done,
     /*    1522 */   // Label 156: @1522
     /*    1522 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1573), // Rule ID 62534 //
     /*    1527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1557 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1571 */     GIR_RootConstrainSelectedInstOperands,
     /*    1572 */     // GIR_Coverage, 62534,
     /*    1572 */     GIR_EraseRootFromParent_Done,
     /*    1573 */   // Label 157: @1573
     /*    1573 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1621), // Rule ID 64946 //
     /*    1578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1585 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    1589 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    1593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1608 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1619 */     GIR_RootConstrainSelectedInstOperands,
     /*    1620 */     // GIR_Coverage, 64946,
     /*    1620 */     GIR_EraseRootFromParent_Done,
     /*    1621 */   // Label 158: @1621
     /*    1621 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1669), // Rule ID 64956 //
     /*    1626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    1637 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    1641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1656 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1667 */     GIR_RootConstrainSelectedInstOperands,
     /*    1668 */     // GIR_Coverage, 64956,
     /*    1668 */     GIR_EraseRootFromParent_Done,
     /*    1669 */   // Label 159: @1669
     /*    1669 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1717), // Rule ID 64966 //
     /*    1674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1681 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    1685 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    1689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1704 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1715 */     GIR_RootConstrainSelectedInstOperands,
     /*    1716 */     // GIR_Coverage, 64966,
     /*    1716 */     GIR_EraseRootFromParent_Done,
     /*    1717 */   // Label 160: @1717
     /*    1717 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1765), // Rule ID 65267 //
     /*    1722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1752 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1763 */     GIR_RootConstrainSelectedInstOperands,
     /*    1764 */     // GIR_Coverage, 65267,
     /*    1764 */     GIR_EraseRootFromParent_Done,
     /*    1765 */   // Label 161: @1765
     /*    1765 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1813), // Rule ID 65275 //
     /*    1770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1777 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1785 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1800 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1811 */     GIR_RootConstrainSelectedInstOperands,
     /*    1812 */     // GIR_Coverage, 65275,
     /*    1812 */     GIR_EraseRootFromParent_Done,
     /*    1813 */   // Label 162: @1813
     /*    1813 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1861), // Rule ID 65283 //
     /*    1818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1825 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1833 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1848 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1859 */     GIR_RootConstrainSelectedInstOperands,
     /*    1860 */     // GIR_Coverage, 65283,
     /*    1860 */     GIR_EraseRootFromParent_Done,
     /*    1861 */   // Label 163: @1861
     /*    1861 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1912), // Rule ID 74099 //
     /*    1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1873 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1881 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1896 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1910 */     GIR_RootConstrainSelectedInstOperands,
     /*    1911 */     // GIR_Coverage, 74099,
     /*    1911 */     GIR_EraseRootFromParent_Done,
     /*    1912 */   // Label 164: @1912
     /*    1912 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1963), // Rule ID 74103 //
     /*    1917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1924 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1932 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1947 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1961 */     GIR_RootConstrainSelectedInstOperands,
     /*    1962 */     // GIR_Coverage, 74103,
     /*    1962 */     GIR_EraseRootFromParent_Done,
     /*    1963 */   // Label 165: @1963
     /*    1963 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2014), // Rule ID 74107 //
     /*    1968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1975 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1983 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1998 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2012 */     GIR_RootConstrainSelectedInstOperands,
     /*    2013 */     // GIR_Coverage, 74107,
     /*    2013 */     GIR_EraseRootFromParent_Done,
     /*    2014 */   // Label 166: @2014
     /*    2014 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2062), // Rule ID 74140 //
     /*    2019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2026 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2034 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2049 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, sh1add_op:{ *:[i32] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2060 */     GIR_RootConstrainSelectedInstOperands,
     /*    2061 */     // GIR_Coverage, 74140,
     /*    2061 */     GIR_EraseRootFromParent_Done,
     /*    2062 */   // Label 167: @2062
     /*    2062 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2110), // Rule ID 74148 //
     /*    2067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2074 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2082 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2097 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, sh2add_op:{ *:[i32] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2108 */     GIR_RootConstrainSelectedInstOperands,
     /*    2109 */     // GIR_Coverage, 74148,
     /*    2109 */     GIR_EraseRootFromParent_Done,
     /*    2110 */   // Label 168: @2110
     /*    2110 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2158), // Rule ID 74156 //
     /*    2115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2122 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2130 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2145 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, sh3add_op:{ *:[i32] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2156 */     GIR_RootConstrainSelectedInstOperands,
     /*    2157 */     // GIR_Coverage, 74156,
     /*    2157 */     GIR_EraseRootFromParent_Done,
     /*    2158 */   // Label 169: @2158
     /*    2158 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2226), // Rule ID 2556 //
     /*    2163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2170 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2199 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2213 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2224 */     GIR_RootConstrainSelectedInstOperands,
     /*    2225 */     // GIR_Coverage, 2556,
     /*    2225 */     GIR_EraseRootFromParent_Done,
     /*    2226 */   // Label 170: @2226
     /*    2226 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2294), // Rule ID 2566 //
     /*    2231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2267 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2281 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2292 */     GIR_RootConstrainSelectedInstOperands,
     /*    2293 */     // GIR_Coverage, 2566,
     /*    2293 */     GIR_EraseRootFromParent_Done,
     /*    2294 */   // Label 171: @2294
     /*    2294 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2362), // Rule ID 2576 //
     /*    2299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2306 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2335 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2349 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2360 */     GIR_RootConstrainSelectedInstOperands,
     /*    2361 */     // GIR_Coverage, 2576,
     /*    2361 */     GIR_EraseRootFromParent_Done,
     /*    2362 */   // Label 172: @2362
     /*    2362 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2430), // Rule ID 64940 //
     /*    2367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    2378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2399 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2403 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    2407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2417 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x, GPR:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2428 */     GIR_RootConstrainSelectedInstOperands,
     /*    2429 */     // GIR_Coverage, 64940,
     /*    2429 */     GIR_EraseRootFromParent_Done,
     /*    2430 */   // Label 173: @2430
     /*    2430 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2498), // Rule ID 64950 //
     /*    2435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2442 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    2446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2471 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    2475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2485 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2496 */     GIR_RootConstrainSelectedInstOperands,
     /*    2497 */     // GIR_Coverage, 64950,
     /*    2497 */     GIR_EraseRootFromParent_Done,
     /*    2498 */   // Label 174: @2498
     /*    2498 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2566), // Rule ID 64960 //
     /*    2503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2510 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    2514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    2543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2553 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2564 */     GIR_RootConstrainSelectedInstOperands,
     /*    2565 */     // GIR_Coverage, 64960,
     /*    2565 */     GIR_EraseRootFromParent_Done,
     /*    2566 */   // Label 175: @2566
     /*    2566 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2634), // Rule ID 65263 //
     /*    2571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2578 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2586 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2621 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2632 */     GIR_RootConstrainSelectedInstOperands,
     /*    2633 */     // GIR_Coverage, 65263,
     /*    2633 */     GIR_EraseRootFromParent_Done,
     /*    2634 */   // Label 176: @2634
     /*    2634 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2702), // Rule ID 65271 //
     /*    2639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2646 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2654 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2689 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2700 */     GIR_RootConstrainSelectedInstOperands,
     /*    2701 */     // GIR_Coverage, 65271,
     /*    2701 */     GIR_EraseRootFromParent_Done,
     /*    2702 */   // Label 177: @2702
     /*    2702 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2770), // Rule ID 65279 //
     /*    2707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2714 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2722 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2757 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2768 */     GIR_RootConstrainSelectedInstOperands,
     /*    2769 */     // GIR_Coverage, 65279,
     /*    2769 */     GIR_EraseRootFromParent_Done,
     /*    2770 */   // Label 178: @2770
     /*    2770 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2838), // Rule ID 74136 //
     /*    2775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2782 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    2786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2790 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    2794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2815 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2825 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2836 */     GIR_RootConstrainSelectedInstOperands,
     /*    2837 */     // GIR_Coverage, 74136,
     /*    2837 */     GIR_EraseRootFromParent_Done,
     /*    2838 */   // Label 179: @2838
     /*    2838 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2906), // Rule ID 74144 //
     /*    2843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2850 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2858 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2883 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2893 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2904 */     GIR_RootConstrainSelectedInstOperands,
     /*    2905 */     // GIR_Coverage, 74144,
     /*    2905 */     GIR_EraseRootFromParent_Done,
     /*    2906 */   // Label 180: @2906
     /*    2906 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2974), // Rule ID 74152 //
     /*    2911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2918 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2926 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2961 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2972 */     GIR_RootConstrainSelectedInstOperands,
     /*    2973 */     // GIR_Coverage, 74152,
     /*    2973 */     GIR_EraseRootFromParent_Done,
     /*    2974 */   // Label 181: @2974
     /*    2974 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3053), // Rule ID 62520 //
     /*    2979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    2990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3023 */     // MIs[2] Operand 1
     /*    3023 */     // No operand predicates
     /*    3023 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3037 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3051 */     GIR_RootConstrainSelectedInstOperands,
     /*    3052 */     // GIR_Coverage, 62520,
     /*    3052 */     GIR_EraseRootFromParent_Done,
     /*    3053 */   // Label 182: @3053
     /*    3053 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3132), // Rule ID 74095 //
     /*    3058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3065 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3110 */     // MIs[2] Operand 1
     /*    3110 */     // No operand predicates
     /*    3110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3116 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3130 */     GIR_RootConstrainSelectedInstOperands,
     /*    3131 */     // GIR_Coverage, 74095,
     /*    3131 */     GIR_EraseRootFromParent_Done,
     /*    3132 */   // Label 183: @3132
     /*    3132 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3181), // Rule ID 115 //
     /*    3137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3152 */     // MIs[1] Operand 1
     /*    3152 */     // No operand predicates
     /*    3152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3164 */     // MIs[2] Operand 1
     /*    3164 */     // No operand predicates
     /*    3164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3166 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3171 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3179 */     GIR_RootConstrainSelectedInstOperands,
     /*    3180 */     // GIR_Coverage, 115,
     /*    3180 */     GIR_EraseRootFromParent_Done,
     /*    3181 */   // Label 184: @3181
     /*    3181 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3223), // Rule ID 75 //
     /*    3186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3209 */     // MIs[1] Operand 1
     /*    3209 */     // No operand predicates
     /*    3209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3211 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3221 */     GIR_RootConstrainSelectedInstOperands,
     /*    3222 */     // GIR_Coverage, 75,
     /*    3222 */     GIR_EraseRootFromParent_Done,
     /*    3223 */   // Label 185: @3223
     /*    3223 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3295), // Rule ID 286 //
     /*    3228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3251 */     // MIs[1] Operand 1
     /*    3251 */     // No operand predicates
     /*    3251 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10074),
     /*    3255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3257 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10074>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3273 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3288 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3293 */     GIR_RootConstrainSelectedInstOperands,
     /*    3294 */     // GIR_Coverage, 286,
     /*    3294 */     GIR_EraseRootFromParent_Done,
     /*    3295 */   // Label 186: @3295
     /*    3295 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3337), // Rule ID 64518 //
     /*    3300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3323 */     // MIs[1] Operand 1
     /*    3323 */     // No operand predicates
     /*    3323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3325 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3335 */     GIR_RootConstrainSelectedInstOperands,
     /*    3336 */     // GIR_Coverage, 64518,
     /*    3336 */     GIR_EraseRootFromParent_Done,
     /*    3337 */   // Label 187: @3337
     /*    3337 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3379), // Rule ID 64522 //
     /*    3342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3365 */     // MIs[1] Operand 1
     /*    3365 */     // No operand predicates
     /*    3365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3367 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3377 */     GIR_RootConstrainSelectedInstOperands,
     /*    3378 */     // GIR_Coverage, 64522,
     /*    3378 */     GIR_EraseRootFromParent_Done,
     /*    3379 */   // Label 188: @3379
     /*    3379 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3440), // Rule ID 74109 //
     /*    3384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3423 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3438 */     GIR_RootConstrainSelectedInstOperands,
     /*    3439 */     // GIR_Coverage, 74109,
     /*    3439 */     GIR_EraseRootFromParent_Done,
     /*    3440 */   // Label 189: @3440
     /*    3440 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3501), // Rule ID 62587 //
     /*    3445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3484 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3499 */     GIR_RootConstrainSelectedInstOperands,
     /*    3500 */     // GIR_Coverage, 62587,
     /*    3500 */     GIR_EraseRootFromParent_Done,
     /*    3501 */   // Label 190: @3501
     /*    3501 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3528), // Rule ID 73 //
     /*    3506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3521 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    3526 */     GIR_RootConstrainSelectedInstOperands,
     /*    3527 */     // GIR_Coverage, 73,
     /*    3527 */     GIR_Done,
     /*    3528 */   // Label 191: @3528
     /*    3528 */   GIM_Reject,
     /*    3529 */ // Label 151: @3529
     /*    3529 */ GIM_Reject,
     /*    3530 */ // Label 127: @3530
     /*    3530 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(11429),
     /*    3535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    3538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    3541 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3636), // Rule ID 2600 //
     /*    3546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3598 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3609 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3623 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3634 */     GIR_RootConstrainSelectedInstOperands,
     /*    3635 */     // GIR_Coverage, 2600,
     /*    3635 */     GIR_EraseRootFromParent_Done,
     /*    3636 */   // Label 193: @3636
     /*    3636 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3731), // Rule ID 2604 //
     /*    3641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3648 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    3652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3693 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    3708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3718 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3729 */     GIR_RootConstrainSelectedInstOperands,
     /*    3730 */     // GIR_Coverage, 2604,
     /*    3730 */     GIR_EraseRootFromParent_Done,
     /*    3731 */   // Label 194: @3731
     /*    3731 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3826), // Rule ID 64994 //
     /*    3736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3743 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    3747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3788 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    3803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3813 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    3816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3824 */     GIR_RootConstrainSelectedInstOperands,
     /*    3825 */     // GIR_Coverage, 64994,
     /*    3825 */     GIR_EraseRootFromParent_Done,
     /*    3826 */   // Label 195: @3826
     /*    3826 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3921), // Rule ID 64998 //
     /*    3831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3838 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    3842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3883 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    3898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3908 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    3911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3919 */     GIR_RootConstrainSelectedInstOperands,
     /*    3920 */     // GIR_Coverage, 64998,
     /*    3920 */     GIR_EraseRootFromParent_Done,
     /*    3921 */   // Label 196: @3921
     /*    3921 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4016), // Rule ID 2595 //
     /*    3926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3933 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3974 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3985 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3989 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    3993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4003 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4014 */     GIR_RootConstrainSelectedInstOperands,
     /*    4015 */     // GIR_Coverage, 2595,
     /*    4015 */     GIR_EraseRootFromParent_Done,
     /*    4016 */   // Label 197: @4016
     /*    4016 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4111), // Rule ID 2614 //
     /*    4021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4028 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4069 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4084 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4098 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4109 */     GIR_RootConstrainSelectedInstOperands,
     /*    4110 */     // GIR_Coverage, 2614,
     /*    4110 */     GIR_EraseRootFromParent_Done,
     /*    4111 */   // Label 198: @4111
     /*    4111 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4206), // Rule ID 2619 //
     /*    4116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4123 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4164 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4179 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4193 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4204 */     GIR_RootConstrainSelectedInstOperands,
     /*    4205 */     // GIR_Coverage, 2619,
     /*    4205 */     GIR_EraseRootFromParent_Done,
     /*    4206 */   // Label 199: @4206
     /*    4206 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4301), // Rule ID 64979 //
     /*    4211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4218 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    4222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4259 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4270 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4274 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    4278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4288 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4299 */     GIR_RootConstrainSelectedInstOperands,
     /*    4300 */     // GIR_Coverage, 64979,
     /*    4300 */     GIR_EraseRootFromParent_Done,
     /*    4301 */   // Label 200: @4301
     /*    4301 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4396), // Rule ID 64984 //
     /*    4306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4313 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    4317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4354 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    4373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4383 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4394 */     GIR_RootConstrainSelectedInstOperands,
     /*    4395 */     // GIR_Coverage, 64984,
     /*    4395 */     GIR_EraseRootFromParent_Done,
     /*    4396 */   // Label 201: @4396
     /*    4396 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4491), // Rule ID 64989 //
     /*    4401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4408 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    4412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4449 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4464 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    4468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4478 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4489 */     GIR_RootConstrainSelectedInstOperands,
     /*    4490 */     // GIR_Coverage, 64989,
     /*    4490 */     GIR_EraseRootFromParent_Done,
     /*    4491 */   // Label 202: @4491
     /*    4491 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4586), // Rule ID 65291 //
     /*    4496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4503 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4511 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4552 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4556 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4573 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4584 */     GIR_RootConstrainSelectedInstOperands,
     /*    4585 */     // GIR_Coverage, 65291,
     /*    4585 */     GIR_EraseRootFromParent_Done,
     /*    4586 */   // Label 203: @4586
     /*    4586 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4681), // Rule ID 65295 //
     /*    4591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4598 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    4602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4606 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4651 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4668 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4679 */     GIR_RootConstrainSelectedInstOperands,
     /*    4680 */     // GIR_Coverage, 65295,
     /*    4680 */     GIR_EraseRootFromParent_Done,
     /*    4681 */   // Label 204: @4681
     /*    4681 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4776), // Rule ID 74172 //
     /*    4686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    4697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4701 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    4705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4746 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4763 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4774 */     GIR_RootConstrainSelectedInstOperands,
     /*    4775 */     // GIR_Coverage, 74172,
     /*    4775 */     GIR_EraseRootFromParent_Done,
     /*    4776 */   // Label 205: @4776
     /*    4776 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4871), // Rule ID 74176 //
     /*    4781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4788 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*    4792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*    4800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4841 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4858 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4869 */     GIR_RootConstrainSelectedInstOperands,
     /*    4870 */     // GIR_Coverage, 74176,
     /*    4870 */     GIR_EraseRootFromParent_Done,
     /*    4871 */   // Label 206: @4871
     /*    4871 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4966), // Rule ID 65287 //
     /*    4876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4883 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    4887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4891 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    4895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4932 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4953 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4964 */     GIR_RootConstrainSelectedInstOperands,
     /*    4965 */     // GIR_Coverage, 65287,
     /*    4965 */     GIR_EraseRootFromParent_Done,
     /*    4966 */   // Label 207: @4966
     /*    4966 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5061), // Rule ID 65303 //
     /*    4971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4978 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    4990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5027 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5048 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5059 */     GIR_RootConstrainSelectedInstOperands,
     /*    5060 */     // GIR_Coverage, 65303,
     /*    5060 */     GIR_EraseRootFromParent_Done,
     /*    5061 */   // Label 208: @5061
     /*    5061 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5156), // Rule ID 65307 //
     /*    5066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5122 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5143 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5154 */     GIR_RootConstrainSelectedInstOperands,
     /*    5155 */     // GIR_Coverage, 65307,
     /*    5155 */     GIR_EraseRootFromParent_Done,
     /*    5156 */   // Label 209: @5156
     /*    5156 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5251), // Rule ID 74160 //
     /*    5161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5168 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*    5172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*    5180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5217 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5238 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5249 */     GIR_RootConstrainSelectedInstOperands,
     /*    5250 */     // GIR_Coverage, 74160,
     /*    5250 */     GIR_EraseRootFromParent_Done,
     /*    5251 */   // Label 210: @5251
     /*    5251 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5346), // Rule ID 74164 //
     /*    5256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5263 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    5267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    5275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5312 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5333 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5344 */     GIR_RootConstrainSelectedInstOperands,
     /*    5345 */     // GIR_Coverage, 74164,
     /*    5345 */     GIR_EraseRootFromParent_Done,
     /*    5346 */   // Label 211: @5346
     /*    5346 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5441), // Rule ID 74168 //
     /*    5351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5358 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    5362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    5370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5407 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5428 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5439 */     GIR_RootConstrainSelectedInstOperands,
     /*    5440 */     // GIR_Coverage, 74168,
     /*    5440 */     GIR_EraseRootFromParent_Done,
     /*    5441 */   // Label 212: @5441
     /*    5441 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5489), // Rule ID 2561 //
     /*    5446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5453 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5457 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5476 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5487 */     GIR_RootConstrainSelectedInstOperands,
     /*    5488 */     // GIR_Coverage, 2561,
     /*    5488 */     GIR_EraseRootFromParent_Done,
     /*    5489 */   // Label 213: @5489
     /*    5489 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5537), // Rule ID 2571 //
     /*    5494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5501 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5505 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5524 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5535 */     GIR_RootConstrainSelectedInstOperands,
     /*    5536 */     // GIR_Coverage, 2571,
     /*    5536 */     GIR_EraseRootFromParent_Done,
     /*    5537 */   // Label 214: @5537
     /*    5537 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5585), // Rule ID 2581 //
     /*    5542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5549 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    5553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    5557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5572 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5583 */     GIR_RootConstrainSelectedInstOperands,
     /*    5584 */     // GIR_Coverage, 2581,
     /*    5584 */     GIR_EraseRootFromParent_Done,
     /*    5585 */   // Label 215: @5585
     /*    5585 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5633), // Rule ID 2598 //
     /*    5590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5597 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    5601 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    5605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    5620 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5631 */     GIR_RootConstrainSelectedInstOperands,
     /*    5632 */     // GIR_Coverage, 2598,
     /*    5632 */     GIR_EraseRootFromParent_Done,
     /*    5633 */   // Label 216: @5633
     /*    5633 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5681), // Rule ID 2617 //
     /*    5638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5645 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    5649 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    5653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    5668 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5679 */     GIR_RootConstrainSelectedInstOperands,
     /*    5680 */     // GIR_Coverage, 2617,
     /*    5680 */     GIR_EraseRootFromParent_Done,
     /*    5681 */   // Label 217: @5681
     /*    5681 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5729), // Rule ID 2622 //
     /*    5686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5697 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    5716 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5727 */     GIR_RootConstrainSelectedInstOperands,
     /*    5728 */     // GIR_Coverage, 2622,
     /*    5728 */     GIR_EraseRootFromParent_Done,
     /*    5729 */   // Label 218: @5729
     /*    5729 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5780), // Rule ID 62525 //
     /*    5734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5741 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    5745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    5749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5764 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    5764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    5778 */     GIR_RootConstrainSelectedInstOperands,
     /*    5779 */     // GIR_Coverage, 62525,
     /*    5779 */     GIR_EraseRootFromParent_Done,
     /*    5780 */   // Label 219: @5780
     /*    5780 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5831), // Rule ID 62529 //
     /*    5785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5792 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    5796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    5800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5815 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    5815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    5829 */     GIR_RootConstrainSelectedInstOperands,
     /*    5830 */     // GIR_Coverage, 62529,
     /*    5830 */     GIR_EraseRootFromParent_Done,
     /*    5831 */   // Label 220: @5831
     /*    5831 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5882), // Rule ID 62533 //
     /*    5836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    5847 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    5851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5866 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    5866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    5880 */     GIR_RootConstrainSelectedInstOperands,
     /*    5881 */     // GIR_Coverage, 62533,
     /*    5881 */     GIR_EraseRootFromParent_Done,
     /*    5882 */   // Label 221: @5882
     /*    5882 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5930), // Rule ID 64945 //
     /*    5887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    5898 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    5902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5917 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    5920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5928 */     GIR_RootConstrainSelectedInstOperands,
     /*    5929 */     // GIR_Coverage, 64945,
     /*    5929 */     GIR_EraseRootFromParent_Done,
     /*    5930 */   // Label 222: @5930
     /*    5930 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5978), // Rule ID 64955 //
     /*    5935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5942 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    5946 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    5950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5965 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    5968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5976 */     GIR_RootConstrainSelectedInstOperands,
     /*    5977 */     // GIR_Coverage, 64955,
     /*    5977 */     GIR_EraseRootFromParent_Done,
     /*    5978 */   // Label 223: @5978
     /*    5978 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6026), // Rule ID 64965 //
     /*    5983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5990 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    5994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    5998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6013 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6024 */     GIR_RootConstrainSelectedInstOperands,
     /*    6025 */     // GIR_Coverage, 64965,
     /*    6025 */     GIR_EraseRootFromParent_Done,
     /*    6026 */   // Label 224: @6026
     /*    6026 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6074), // Rule ID 64982 //
     /*    6031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6038 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    6042 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    6046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6061 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6072 */     GIR_RootConstrainSelectedInstOperands,
     /*    6073 */     // GIR_Coverage, 64982,
     /*    6073 */     GIR_EraseRootFromParent_Done,
     /*    6074 */   // Label 225: @6074
     /*    6074 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6122), // Rule ID 64987 //
     /*    6079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    6090 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    6094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6109 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6120 */     GIR_RootConstrainSelectedInstOperands,
     /*    6121 */     // GIR_Coverage, 64987,
     /*    6121 */     GIR_EraseRootFromParent_Done,
     /*    6122 */   // Label 226: @6122
     /*    6122 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6170), // Rule ID 64992 //
     /*    6127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6134 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    6138 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    6142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6157 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6168 */     GIR_RootConstrainSelectedInstOperands,
     /*    6169 */     // GIR_Coverage, 64992,
     /*    6169 */     GIR_EraseRootFromParent_Done,
     /*    6170 */   // Label 227: @6170
     /*    6170 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6218), // Rule ID 65266 //
     /*    6175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6182 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6190 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6205 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6216 */     GIR_RootConstrainSelectedInstOperands,
     /*    6217 */     // GIR_Coverage, 65266,
     /*    6217 */     GIR_EraseRootFromParent_Done,
     /*    6218 */   // Label 228: @6218
     /*    6218 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6266), // Rule ID 65274 //
     /*    6223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6230 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6253 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6264 */     GIR_RootConstrainSelectedInstOperands,
     /*    6265 */     // GIR_Coverage, 65274,
     /*    6265 */     GIR_EraseRootFromParent_Done,
     /*    6266 */   // Label 229: @6266
     /*    6266 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6314), // Rule ID 65282 //
     /*    6271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6301 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6312 */     GIR_RootConstrainSelectedInstOperands,
     /*    6313 */     // GIR_Coverage, 65282,
     /*    6313 */     GIR_EraseRootFromParent_Done,
     /*    6314 */   // Label 230: @6314
     /*    6314 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6362), // Rule ID 65289 //
     /*    6319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6326 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6334 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6349 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6360 */     GIR_RootConstrainSelectedInstOperands,
     /*    6361 */     // GIR_Coverage, 65289,
     /*    6361 */     GIR_EraseRootFromParent_Done,
     /*    6362 */   // Label 231: @6362
     /*    6362 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6410), // Rule ID 65305 //
     /*    6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6382 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6397 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6408 */     GIR_RootConstrainSelectedInstOperands,
     /*    6409 */     // GIR_Coverage, 65305,
     /*    6409 */     GIR_EraseRootFromParent_Done,
     /*    6410 */   // Label 232: @6410
     /*    6410 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6458), // Rule ID 65309 //
     /*    6415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6422 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6430 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6445 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6456 */     GIR_RootConstrainSelectedInstOperands,
     /*    6457 */     // GIR_Coverage, 65309,
     /*    6457 */     GIR_EraseRootFromParent_Done,
     /*    6458 */   // Label 233: @6458
     /*    6458 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6509), // Rule ID 74098 //
     /*    6463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6470 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6478 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6493 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6507 */     GIR_RootConstrainSelectedInstOperands,
     /*    6508 */     // GIR_Coverage, 74098,
     /*    6508 */     GIR_EraseRootFromParent_Done,
     /*    6509 */   // Label 234: @6509
     /*    6509 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6560), // Rule ID 74102 //
     /*    6514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6521 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6529 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    6533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6544 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6558 */     GIR_RootConstrainSelectedInstOperands,
     /*    6559 */     // GIR_Coverage, 74102,
     /*    6559 */     GIR_EraseRootFromParent_Done,
     /*    6560 */   // Label 235: @6560
     /*    6560 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6611), // Rule ID 74106 //
     /*    6565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6572 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    6576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6580 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    6584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6595 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6609 */     GIR_RootConstrainSelectedInstOperands,
     /*    6610 */     // GIR_Coverage, 74106,
     /*    6610 */     GIR_EraseRootFromParent_Done,
     /*    6611 */   // Label 236: @6611
     /*    6611 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6659), // Rule ID 74139 //
     /*    6616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6623 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    6627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6631 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    6635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6646 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, sh1add_op:{ *:[i64] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6657 */     GIR_RootConstrainSelectedInstOperands,
     /*    6658 */     // GIR_Coverage, 74139,
     /*    6658 */     GIR_EraseRootFromParent_Done,
     /*    6659 */   // Label 237: @6659
     /*    6659 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6707), // Rule ID 74147 //
     /*    6664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6671 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    6675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6679 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    6683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6694 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, sh2add_op:{ *:[i64] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6705 */     GIR_RootConstrainSelectedInstOperands,
     /*    6706 */     // GIR_Coverage, 74147,
     /*    6706 */     GIR_EraseRootFromParent_Done,
     /*    6707 */   // Label 238: @6707
     /*    6707 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6755), // Rule ID 74155 //
     /*    6712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6719 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    6723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6727 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    6731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6742 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, sh3add_op:{ *:[i64] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6753 */     GIR_RootConstrainSelectedInstOperands,
     /*    6754 */     // GIR_Coverage, 74155,
     /*    6754 */     GIR_EraseRootFromParent_Done,
     /*    6755 */   // Label 239: @6755
     /*    6755 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6803), // Rule ID 74162 //
     /*    6760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6767 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    6771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6775 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    6779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6790 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6801 */     GIR_RootConstrainSelectedInstOperands,
     /*    6802 */     // GIR_Coverage, 74162,
     /*    6802 */     GIR_EraseRootFromParent_Done,
     /*    6803 */   // Label 240: @6803
     /*    6803 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(6851), // Rule ID 74166 //
     /*    6808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    6819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    6827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6838 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6849 */     GIR_RootConstrainSelectedInstOperands,
     /*    6850 */     // GIR_Coverage, 74166,
     /*    6850 */     GIR_EraseRootFromParent_Done,
     /*    6851 */   // Label 241: @6851
     /*    6851 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(6899), // Rule ID 74170 //
     /*    6856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6863 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    6867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6871 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    6875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6886 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6897 */     GIR_RootConstrainSelectedInstOperands,
     /*    6898 */     // GIR_Coverage, 74170,
     /*    6898 */     GIR_EraseRootFromParent_Done,
     /*    6899 */   // Label 242: @6899
     /*    6899 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(6974), // Rule ID 2592 //
     /*    6904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6911 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    6915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    6947 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    6951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6961 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    6964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6972 */     GIR_RootConstrainSelectedInstOperands,
     /*    6973 */     // GIR_Coverage, 2592,
     /*    6973 */     GIR_EraseRootFromParent_Done,
     /*    6974 */   // Label 243: @6974
     /*    6974 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7069), // Rule ID 2602 //
     /*    6979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    6990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7011 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7022 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7036 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7067 */     GIR_RootConstrainSelectedInstOperands,
     /*    7068 */     // GIR_Coverage, 2602,
     /*    7068 */     GIR_EraseRootFromParent_Done,
     /*    7069 */   // Label 244: @7069
     /*    7069 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7164), // Rule ID 2606 //
     /*    7074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7117 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7131 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7162 */     GIR_RootConstrainSelectedInstOperands,
     /*    7163 */     // GIR_Coverage, 2606,
     /*    7163 */     GIR_EraseRootFromParent_Done,
     /*    7164 */   // Label 245: @7164
     /*    7164 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7259), // Rule ID 2608 //
     /*    7169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7201 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7212 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7226 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7257 */     GIR_RootConstrainSelectedInstOperands,
     /*    7258 */     // GIR_Coverage, 2608,
     /*    7258 */     GIR_EraseRootFromParent_Done,
     /*    7259 */   // Label 246: @7259
     /*    7259 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7354), // Rule ID 2610 //
     /*    7264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7296 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7307 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7321 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7352 */     GIR_RootConstrainSelectedInstOperands,
     /*    7353 */     // GIR_Coverage, 2610,
     /*    7353 */     GIR_EraseRootFromParent_Done,
     /*    7354 */   // Label 247: @7354
     /*    7354 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7449), // Rule ID 2624 //
     /*    7359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7391 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7402 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7416 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7447 */     GIR_RootConstrainSelectedInstOperands,
     /*    7448 */     // GIR_Coverage, 2624,
     /*    7448 */     GIR_EraseRootFromParent_Done,
     /*    7449 */   // Label 248: @7449
     /*    7449 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7544), // Rule ID 2626 //
     /*    7454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7461 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7486 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7497 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7511 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    7535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7542 */     GIR_RootConstrainSelectedInstOperands,
     /*    7543 */     // GIR_Coverage, 2626,
     /*    7543 */     GIR_EraseRootFromParent_Done,
     /*    7544 */   // Label 249: @7544
     /*    7544 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7639), // Rule ID 2628 //
     /*    7549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    7560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7581 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7592 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    7596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7606 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    7630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7637 */     GIR_RootConstrainSelectedInstOperands,
     /*    7638 */     // GIR_Coverage, 2628,
     /*    7638 */     GIR_EraseRootFromParent_Done,
     /*    7639 */   // Label 250: @7639
     /*    7639 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7714), // Rule ID 64976 //
     /*    7644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7651 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    7655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7676 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    7691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7701 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    7704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7712 */     GIR_RootConstrainSelectedInstOperands,
     /*    7713 */     // GIR_Coverage, 64976,
     /*    7713 */     GIR_EraseRootFromParent_Done,
     /*    7714 */   // Label 251: @7714
     /*    7714 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7809), // Rule ID 64996 //
     /*    7719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7726 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    7730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7751 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7762 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    7766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7776 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7807 */     GIR_RootConstrainSelectedInstOperands,
     /*    7808 */     // GIR_Coverage, 64996,
     /*    7808 */     GIR_EraseRootFromParent_Done,
     /*    7809 */   // Label 252: @7809
     /*    7809 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7904), // Rule ID 65000 //
     /*    7814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7821 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    7825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    7861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7871 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7902 */     GIR_RootConstrainSelectedInstOperands,
     /*    7903 */     // GIR_Coverage, 65000,
     /*    7903 */     GIR_EraseRootFromParent_Done,
     /*    7904 */   // Label 253: @7904
     /*    7904 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7999), // Rule ID 65002 //
     /*    7909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7916 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    7920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7941 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7952 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    7956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7966 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    7990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7997 */     GIR_RootConstrainSelectedInstOperands,
     /*    7998 */     // GIR_Coverage, 65002,
     /*    7998 */     GIR_EraseRootFromParent_Done,
     /*    7999 */   // Label 254: @7999
     /*    7999 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8094), // Rule ID 65004 //
     /*    8004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8011 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8036 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8061 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8092 */     GIR_RootConstrainSelectedInstOperands,
     /*    8093 */     // GIR_Coverage, 65004,
     /*    8093 */     GIR_EraseRootFromParent_Done,
     /*    8094 */   // Label 255: @8094
     /*    8094 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8189), // Rule ID 65006 //
     /*    8099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8106 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8131 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8142 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8156 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8187 */     GIR_RootConstrainSelectedInstOperands,
     /*    8188 */     // GIR_Coverage, 65006,
     /*    8188 */     GIR_EraseRootFromParent_Done,
     /*    8189 */   // Label 256: @8189
     /*    8189 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8284), // Rule ID 65008 //
     /*    8194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8201 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8226 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8237 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8251 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8282 */     GIR_RootConstrainSelectedInstOperands,
     /*    8283 */     // GIR_Coverage, 65008,
     /*    8283 */     GIR_EraseRootFromParent_Done,
     /*    8284 */   // Label 257: @8284
     /*    8284 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8379), // Rule ID 65010 //
     /*    8289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8296 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8321 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8332 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8346 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8377 */     GIR_RootConstrainSelectedInstOperands,
     /*    8378 */     // GIR_Coverage, 65010,
     /*    8378 */     GIR_EraseRootFromParent_Done,
     /*    8379 */   // Label 258: @8379
     /*    8379 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8447), // Rule ID 2555 //
     /*    8384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8434 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8445 */     GIR_RootConstrainSelectedInstOperands,
     /*    8446 */     // GIR_Coverage, 2555,
     /*    8446 */     GIR_EraseRootFromParent_Done,
     /*    8447 */   // Label 259: @8447
     /*    8447 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8515), // Rule ID 2565 //
     /*    8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8459 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8488 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8502 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8513 */     GIR_RootConstrainSelectedInstOperands,
     /*    8514 */     // GIR_Coverage, 2565,
     /*    8514 */     GIR_EraseRootFromParent_Done,
     /*    8515 */   // Label 260: @8515
     /*    8515 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8583), // Rule ID 2575 //
     /*    8520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8527 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    8531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    8560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8570 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8581 */     GIR_RootConstrainSelectedInstOperands,
     /*    8582 */     // GIR_Coverage, 2575,
     /*    8582 */     GIR_EraseRootFromParent_Done,
     /*    8583 */   // Label 261: @8583
     /*    8583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8651), // Rule ID 64939 //
     /*    8588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8595 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    8599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8624 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    8628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8638 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x, GPR:{ *:[i64] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    8641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8649 */     GIR_RootConstrainSelectedInstOperands,
     /*    8650 */     // GIR_Coverage, 64939,
     /*    8650 */     GIR_EraseRootFromParent_Done,
     /*    8651 */   // Label 262: @8651
     /*    8651 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8719), // Rule ID 64949 //
     /*    8656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8663 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    8667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8688 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8692 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    8696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8706 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    8709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8717 */     GIR_RootConstrainSelectedInstOperands,
     /*    8718 */     // GIR_Coverage, 64949,
     /*    8718 */     GIR_EraseRootFromParent_Done,
     /*    8719 */   // Label 263: @8719
     /*    8719 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8787), // Rule ID 64959 //
     /*    8724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8731 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    8764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8774 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    8777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8785 */     GIR_RootConstrainSelectedInstOperands,
     /*    8786 */     // GIR_Coverage, 64959,
     /*    8786 */     GIR_EraseRootFromParent_Done,
     /*    8787 */   // Label 264: @8787
     /*    8787 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8862), // Rule ID 65285 //
     /*    8792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    8803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8807 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    8811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8832 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8849 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    8852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8860 */     GIR_RootConstrainSelectedInstOperands,
     /*    8861 */     // GIR_Coverage, 65285,
     /*    8861 */     GIR_EraseRootFromParent_Done,
     /*    8862 */   // Label 265: @8862
     /*    8862 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8957), // Rule ID 65293 //
     /*    8867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    8878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    8886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8907 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8924 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8940 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    8948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8955 */     GIR_RootConstrainSelectedInstOperands,
     /*    8956 */     // GIR_Coverage, 65293,
     /*    8956 */     GIR_EraseRootFromParent_Done,
     /*    8957 */   // Label 266: @8957
     /*    8957 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9052), // Rule ID 65297 //
     /*    8962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8969 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    8973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8977 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    8981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9002 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9019 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9050 */     GIR_RootConstrainSelectedInstOperands,
     /*    9051 */     // GIR_Coverage, 65297,
     /*    9051 */     GIR_EraseRootFromParent_Done,
     /*    9052 */   // Label 267: @9052
     /*    9052 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9147), // Rule ID 65299 //
     /*    9057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9072 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9097 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9114 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9145 */     GIR_RootConstrainSelectedInstOperands,
     /*    9146 */     // GIR_Coverage, 65299,
     /*    9146 */     GIR_EraseRootFromParent_Done,
     /*    9147 */   // Label 268: @9147
     /*    9147 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9242), // Rule ID 65301 //
     /*    9152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9159 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9192 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9209 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9240 */     GIR_RootConstrainSelectedInstOperands,
     /*    9241 */     // GIR_Coverage, 65301,
     /*    9241 */     GIR_EraseRootFromParent_Done,
     /*    9242 */   // Label 269: @9242
     /*    9242 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9337), // Rule ID 65311 //
     /*    9247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9254 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9287 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9304 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9335 */     GIR_RootConstrainSelectedInstOperands,
     /*    9336 */     // GIR_Coverage, 65311,
     /*    9336 */     GIR_EraseRootFromParent_Done,
     /*    9337 */   // Label 270: @9337
     /*    9337 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9432), // Rule ID 65313 //
     /*    9342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9349 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9357 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9382 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9399 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9430 */     GIR_RootConstrainSelectedInstOperands,
     /*    9431 */     // GIR_Coverage, 65313,
     /*    9431 */     GIR_EraseRootFromParent_Done,
     /*    9432 */   // Label 271: @9432
     /*    9432 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9527), // Rule ID 65315 //
     /*    9437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9444 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9477 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9494 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9525 */     GIR_RootConstrainSelectedInstOperands,
     /*    9526 */     // GIR_Coverage, 65315,
     /*    9526 */     GIR_EraseRootFromParent_Done,
     /*    9527 */   // Label 272: @9527
     /*    9527 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9602), // Rule ID 74158 //
     /*    9532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    9543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    9551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9572 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9589 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    9592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9600 */     GIR_RootConstrainSelectedInstOperands,
     /*    9601 */     // GIR_Coverage, 74158,
     /*    9601 */     GIR_EraseRootFromParent_Done,
     /*    9602 */   // Label 273: @9602
     /*    9602 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9697), // Rule ID 74174 //
     /*    9607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    9618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9622 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    9626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9647 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9664 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    9688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9695 */     GIR_RootConstrainSelectedInstOperands,
     /*    9696 */     // GIR_Coverage, 74174,
     /*    9696 */     GIR_EraseRootFromParent_Done,
     /*    9697 */   // Label 274: @9697
     /*    9697 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9792), // Rule ID 74178 //
     /*    9702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9709 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    9713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9717 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    9721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9742 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9759 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    9783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9790 */     GIR_RootConstrainSelectedInstOperands,
     /*    9791 */     // GIR_Coverage, 74178,
     /*    9791 */     GIR_EraseRootFromParent_Done,
     /*    9792 */   // Label 275: @9792
     /*    9792 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9887), // Rule ID 74180 //
     /*    9797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9804 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*    9808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9812 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*    9816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9837 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9854 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9885 */     GIR_RootConstrainSelectedInstOperands,
     /*    9886 */     // GIR_Coverage, 74180,
     /*    9886 */     GIR_EraseRootFromParent_Done,
     /*    9887 */   // Label 276: @9887
     /*    9887 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9982), // Rule ID 74182 //
     /*    9892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9899 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*    9903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9907 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*    9911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9932 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9949 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9980 */     GIR_RootConstrainSelectedInstOperands,
     /*    9981 */     // GIR_Coverage, 74182,
     /*    9981 */     GIR_EraseRootFromParent_Done,
     /*    9982 */   // Label 277: @9982
     /*    9982 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10077), // Rule ID 74184 //
     /*    9987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*    9998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10027 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10044 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10075 */     GIR_RootConstrainSelectedInstOperands,
     /*   10076 */     // GIR_Coverage, 74184,
     /*   10076 */     GIR_EraseRootFromParent_Done,
     /*   10077 */   // Label 278: @10077
     /*   10077 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10172), // Rule ID 74186 //
     /*   10082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10122 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10139 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10170 */     GIR_RootConstrainSelectedInstOperands,
     /*   10171 */     // GIR_Coverage, 74186,
     /*   10171 */     GIR_EraseRootFromParent_Done,
     /*   10172 */   // Label 279: @10172
     /*   10172 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10267), // Rule ID 74188 //
     /*   10177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10184 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10192 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10217 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10234 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10265 */     GIR_RootConstrainSelectedInstOperands,
     /*   10266 */     // GIR_Coverage, 74188,
     /*   10266 */     GIR_EraseRootFromParent_Done,
     /*   10267 */   // Label 280: @10267
     /*   10267 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10335), // Rule ID 65262 //
     /*   10272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10279 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10287 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10312 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10322 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10333 */     GIR_RootConstrainSelectedInstOperands,
     /*   10334 */     // GIR_Coverage, 65262,
     /*   10334 */     GIR_EraseRootFromParent_Done,
     /*   10335 */   // Label 281: @10335
     /*   10335 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10403), // Rule ID 65270 //
     /*   10340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10347 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10355 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10390 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10401 */     GIR_RootConstrainSelectedInstOperands,
     /*   10402 */     // GIR_Coverage, 65270,
     /*   10402 */     GIR_EraseRootFromParent_Done,
     /*   10403 */   // Label 282: @10403
     /*   10403 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10471), // Rule ID 65278 //
     /*   10408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10415 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10423 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10458 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10469 */     GIR_RootConstrainSelectedInstOperands,
     /*   10470 */     // GIR_Coverage, 65278,
     /*   10470 */     GIR_EraseRootFromParent_Done,
     /*   10471 */   // Label 283: @10471
     /*   10471 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10539), // Rule ID 74135 //
     /*   10476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*   10487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10491 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*   10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10526 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:27:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   10529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10537 */     GIR_RootConstrainSelectedInstOperands,
     /*   10538 */     // GIR_Coverage, 74135,
     /*   10538 */     GIR_EraseRootFromParent_Done,
     /*   10539 */   // Label 284: @10539
     /*   10539 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10607), // Rule ID 74143 //
     /*   10544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10551 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*   10555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10559 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*   10563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10594 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   10597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10605 */     GIR_RootConstrainSelectedInstOperands,
     /*   10606 */     // GIR_Coverage, 74143,
     /*   10606 */     GIR_EraseRootFromParent_Done,
     /*   10607 */   // Label 285: @10607
     /*   10607 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10675), // Rule ID 74151 //
     /*   10612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10619 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*   10623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10627 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*   10631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10662 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   10665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10673 */     GIR_RootConstrainSelectedInstOperands,
     /*   10674 */     // GIR_Coverage, 74151,
     /*   10674 */     GIR_EraseRootFromParent_Done,
     /*   10675 */   // Label 286: @10675
     /*   10675 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10754), // Rule ID 62519 //
     /*   10680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   10691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10724 */     // MIs[2] Operand 1
     /*   10724 */     // No operand predicates
     /*   10724 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   10728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10738 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10752 */     GIR_RootConstrainSelectedInstOperands,
     /*   10753 */     // GIR_Coverage, 62519,
     /*   10753 */     GIR_EraseRootFromParent_Done,
     /*   10754 */   // Label 287: @10754
     /*   10754 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10833), // Rule ID 74094 //
     /*   10759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10766 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   10770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10774 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10811 */     // MIs[2] Operand 1
     /*   10811 */     // No operand predicates
     /*   10811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10817 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10831 */     GIR_RootConstrainSelectedInstOperands,
     /*   10832 */     // GIR_Coverage, 74094,
     /*   10832 */     GIR_EraseRootFromParent_Done,
     /*   10833 */   // Label 288: @10833
     /*   10833 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10882), // Rule ID 114 //
     /*   10838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   10841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   10853 */     // MIs[1] Operand 1
     /*   10853 */     // No operand predicates
     /*   10853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   10857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10865 */     // MIs[2] Operand 1
     /*   10865 */     // No operand predicates
     /*   10865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10867 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   10867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   10870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10872 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   10877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   10880 */     GIR_RootConstrainSelectedInstOperands,
     /*   10881 */     // GIR_Coverage, 114,
     /*   10881 */     GIR_EraseRootFromParent_Done,
     /*   10882 */   // Label 289: @10882
     /*   10882 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(10928), // Rule ID 265 //
     /*   10887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10910 */     // MIs[1] Operand 1
     /*   10910 */     // No operand predicates
     /*   10910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /*   10914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10916 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10046>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   10916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   10926 */     GIR_RootConstrainSelectedInstOperands,
     /*   10927 */     // GIR_Coverage, 265,
     /*   10927 */     GIR_EraseRootFromParent_Done,
     /*   10928 */   // Label 290: @10928
     /*   10928 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11004), // Rule ID 287 //
     /*   10933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   10956 */     // MIs[1] Operand 1
     /*   10956 */     // No operand predicates
     /*   10956 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10074),
     /*   10960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /*   10964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10966 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10074>>:$rs2)<<P:Predicate_anonymous_10046>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   10966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   10982 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   10987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10997 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11002 */     GIR_RootConstrainSelectedInstOperands,
     /*   11003 */     // GIR_Coverage, 287,
     /*   11003 */     GIR_EraseRootFromParent_Done,
     /*   11004 */   // Label 291: @11004
     /*   11004 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11069), // Rule ID 74110 //
     /*   11009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /*   11050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11052 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10046>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11067 */     GIR_RootConstrainSelectedInstOperands,
     /*   11068 */     // GIR_Coverage, 74110,
     /*   11068 */     GIR_EraseRootFromParent_Done,
     /*   11069 */   // Label 292: @11069
     /*   11069 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11134), // Rule ID 62590 //
     /*   11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /*   11115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11117 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10046>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11132 */     GIR_RootConstrainSelectedInstOperands,
     /*   11133 */     // GIR_Coverage, 62590,
     /*   11133 */     GIR_EraseRootFromParent_Done,
     /*   11134 */   // Label 293: @11134
     /*   11134 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11176), // Rule ID 74 //
     /*   11139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11162 */     // MIs[1] Operand 1
     /*   11162 */     // No operand predicates
     /*   11162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11164 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11174 */     GIR_RootConstrainSelectedInstOperands,
     /*   11175 */     // GIR_Coverage, 74,
     /*   11175 */     GIR_EraseRootFromParent_Done,
     /*   11176 */   // Label 294: @11176
     /*   11176 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11248), // Rule ID 285 //
     /*   11181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11204 */     // MIs[1] Operand 1
     /*   11204 */     // No operand predicates
     /*   11204 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10074),
     /*   11208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11210 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10074>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11226 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11241 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11246 */     GIR_RootConstrainSelectedInstOperands,
     /*   11247 */     // GIR_Coverage, 285,
     /*   11247 */     GIR_EraseRootFromParent_Done,
     /*   11248 */   // Label 295: @11248
     /*   11248 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11309), // Rule ID 74108 //
     /*   11253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11292 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11307 */     GIR_RootConstrainSelectedInstOperands,
     /*   11308 */     // GIR_Coverage, 74108,
     /*   11308 */     GIR_EraseRootFromParent_Done,
     /*   11309 */   // Label 296: @11309
     /*   11309 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11370), // Rule ID 62586 //
     /*   11314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11353 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11368 */     GIR_RootConstrainSelectedInstOperands,
     /*   11369 */     // GIR_Coverage, 62586,
     /*   11369 */     GIR_EraseRootFromParent_Done,
     /*   11370 */   // Label 297: @11370
     /*   11370 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11401), // Rule ID 264 //
     /*   11375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /*   11394 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10046>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11399 */     GIR_RootConstrainSelectedInstOperands,
     /*   11400 */     // GIR_Coverage, 264,
     /*   11400 */     GIR_Done,
     /*   11401 */   // Label 298: @11401
     /*   11401 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11428), // Rule ID 72 //
     /*   11406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11421 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11426 */     GIR_RootConstrainSelectedInstOperands,
     /*   11427 */     // GIR_Coverage, 72,
     /*   11427 */     GIR_Done,
     /*   11428 */   // Label 299: @11428
     /*   11428 */   GIM_Reject,
     /*   11429 */ // Label 192: @11429
     /*   11429 */ GIM_Reject,
     /*   11430 */ // Label 128: @11430
     /*   11430 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11824),
     /*   11435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11445 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11513), // Rule ID 69058 //
     /*   11450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11487 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11511 */     GIR_RootConstrainSelectedInstOperands,
     /*   11512 */     // GIR_Coverage, 69058,
     /*   11512 */     GIR_EraseRootFromParent_Done,
     /*   11513 */   // Label 301: @11513
     /*   11513 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11581), // Rule ID 69059 //
     /*   11518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11555 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11579 */     GIR_RootConstrainSelectedInstOperands,
     /*   11580 */     // GIR_Coverage, 69059,
     /*   11580 */     GIR_EraseRootFromParent_Done,
     /*   11581 */   // Label 302: @11581
     /*   11581 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11649), // Rule ID 45910 //
     /*   11586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11623 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11647 */     GIR_RootConstrainSelectedInstOperands,
     /*   11648 */     // GIR_Coverage, 45910,
     /*   11648 */     GIR_EraseRootFromParent_Done,
     /*   11649 */   // Label 303: @11649
     /*   11649 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11717), // Rule ID 45911 //
     /*   11654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11691 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11715 */     GIR_RootConstrainSelectedInstOperands,
     /*   11716 */     // GIR_Coverage, 45911,
     /*   11716 */     GIR_EraseRootFromParent_Done,
     /*   11717 */   // Label 304: @11717
     /*   11717 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11770), // Rule ID 45738 //
     /*   11722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11733 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11768 */     GIR_RootConstrainSelectedInstOperands,
     /*   11769 */     // GIR_Coverage, 45738,
     /*   11769 */     GIR_EraseRootFromParent_Done,
     /*   11770 */   // Label 305: @11770
     /*   11770 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11823), // Rule ID 45739 //
     /*   11775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11786 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11821 */     GIR_RootConstrainSelectedInstOperands,
     /*   11822 */     // GIR_Coverage, 45739,
     /*   11822 */     GIR_EraseRootFromParent_Done,
     /*   11823 */   // Label 306: @11823
     /*   11823 */   GIM_Reject,
     /*   11824 */ // Label 300: @11824
     /*   11824 */ GIM_Reject,
     /*   11825 */ // Label 129: @11825
     /*   11825 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14949),
     /*   11830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11840 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11936), // Rule ID 68972 //
     /*   11845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11864 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11893 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11897 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11910 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   11913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11934 */     GIR_RootConstrainSelectedInstOperands,
     /*   11935 */     // GIR_Coverage, 68972,
     /*   11935 */     GIR_EraseRootFromParent_Done,
     /*   11936 */   // Label 308: @11936
     /*   11936 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12032), // Rule ID 68973 //
     /*   11941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11993 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11995 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12006 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12030 */     GIR_RootConstrainSelectedInstOperands,
     /*   12031 */     // GIR_Coverage, 68973,
     /*   12031 */     GIR_EraseRootFromParent_Done,
     /*   12032 */   // Label 309: @12032
     /*   12032 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12128), // Rule ID 70798 //
     /*   12037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12089 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12102 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12126 */     GIR_RootConstrainSelectedInstOperands,
     /*   12127 */     // GIR_Coverage, 70798,
     /*   12127 */     GIR_EraseRootFromParent_Done,
     /*   12128 */   // Label 310: @12128
     /*   12128 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12224), // Rule ID 70799 //
     /*   12133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12185 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12198 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12222 */     GIR_RootConstrainSelectedInstOperands,
     /*   12223 */     // GIR_Coverage, 70799,
     /*   12223 */     GIR_EraseRootFromParent_Done,
     /*   12224 */   // Label 311: @12224
     /*   12224 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12320), // Rule ID 70800 //
     /*   12229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12281 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12294 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12318 */     GIR_RootConstrainSelectedInstOperands,
     /*   12319 */     // GIR_Coverage, 70800,
     /*   12319 */     GIR_EraseRootFromParent_Done,
     /*   12320 */   // Label 312: @12320
     /*   12320 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12416), // Rule ID 70801 //
     /*   12325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12358 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12377 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12390 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12414 */     GIR_RootConstrainSelectedInstOperands,
     /*   12415 */     // GIR_Coverage, 70801,
     /*   12415 */     GIR_EraseRootFromParent_Done,
     /*   12416 */   // Label 313: @12416
     /*   12416 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12512), // Rule ID 70676 //
     /*   12421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12469 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12473 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12475 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12486 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12510 */     GIR_RootConstrainSelectedInstOperands,
     /*   12511 */     // GIR_Coverage, 70676,
     /*   12511 */     GIR_EraseRootFromParent_Done,
     /*   12512 */   // Label 314: @12512
     /*   12512 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12608), // Rule ID 70677 //
     /*   12517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12569 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12571 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12582 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12606 */     GIR_RootConstrainSelectedInstOperands,
     /*   12607 */     // GIR_Coverage, 70677,
     /*   12607 */     GIR_EraseRootFromParent_Done,
     /*   12608 */   // Label 315: @12608
     /*   12608 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12704), // Rule ID 45822 //
     /*   12613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12636 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12669 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12678 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12702 */     GIR_RootConstrainSelectedInstOperands,
     /*   12703 */     // GIR_Coverage, 45822,
     /*   12703 */     GIR_EraseRootFromParent_Done,
     /*   12704 */   // Label 316: @12704
     /*   12704 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12800), // Rule ID 45823 //
     /*   12709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12746 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12761 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12765 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12774 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12798 */     GIR_RootConstrainSelectedInstOperands,
     /*   12799 */     // GIR_Coverage, 45823,
     /*   12799 */     GIR_EraseRootFromParent_Done,
     /*   12800 */   // Label 317: @12800
     /*   12800 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12896), // Rule ID 52142 //
     /*   12805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12828 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12857 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12861 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12870 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12894 */     GIR_RootConstrainSelectedInstOperands,
     /*   12895 */     // GIR_Coverage, 52142,
     /*   12895 */     GIR_EraseRootFromParent_Done,
     /*   12896 */   // Label 318: @12896
     /*   12896 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(12992), // Rule ID 52143 //
     /*   12901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12924 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12938 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12957 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12959 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12966 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12990 */     GIR_RootConstrainSelectedInstOperands,
     /*   12991 */     // GIR_Coverage, 52143,
     /*   12991 */     GIR_EraseRootFromParent_Done,
     /*   12992 */   // Label 319: @12992
     /*   12992 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13088), // Rule ID 70796 //
     /*   12997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13034 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13049 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13053 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13062 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13086 */     GIR_RootConstrainSelectedInstOperands,
     /*   13087 */     // GIR_Coverage, 70796,
     /*   13087 */     GIR_EraseRootFromParent_Done,
     /*   13088 */   // Label 320: @13088
     /*   13088 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13184), // Rule ID 70797 //
     /*   13093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13116 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13145 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13149 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13158 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13182 */     GIR_RootConstrainSelectedInstOperands,
     /*   13183 */     // GIR_Coverage, 70797,
     /*   13183 */     GIR_EraseRootFromParent_Done,
     /*   13184 */   // Label 321: @13184
     /*   13184 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13280), // Rule ID 52082 //
     /*   13189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13212 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13226 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13245 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13254 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13278 */     GIR_RootConstrainSelectedInstOperands,
     /*   13279 */     // GIR_Coverage, 52082,
     /*   13279 */     GIR_EraseRootFromParent_Done,
     /*   13280 */   // Label 322: @13280
     /*   13280 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13376), // Rule ID 52083 //
     /*   13285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13341 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13343 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13350 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13374 */     GIR_RootConstrainSelectedInstOperands,
     /*   13375 */     // GIR_Coverage, 52083,
     /*   13375 */     GIR_EraseRootFromParent_Done,
     /*   13376 */   // Label 323: @13376
     /*   13376 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13465), // Rule ID 46668 //
     /*   13381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13415 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13424 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13463 */     GIR_RootConstrainSelectedInstOperands,
     /*   13464 */     // GIR_Coverage, 46668,
     /*   13464 */     GIR_EraseRootFromParent_Done,
     /*   13465 */   // Label 324: @13465
     /*   13465 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13554), // Rule ID 46669 //
     /*   13470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13504 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13513 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13552 */     GIR_RootConstrainSelectedInstOperands,
     /*   13553 */     // GIR_Coverage, 46669,
     /*   13553 */     GIR_EraseRootFromParent_Done,
     /*   13554 */   // Label 325: @13554
     /*   13554 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13643), // Rule ID 45814 //
     /*   13559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13602 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13641 */     GIR_RootConstrainSelectedInstOperands,
     /*   13642 */     // GIR_Coverage, 45814,
     /*   13642 */     GIR_EraseRootFromParent_Done,
     /*   13643 */   // Label 326: @13643
     /*   13643 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13732), // Rule ID 45815 //
     /*   13648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13691 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13730 */     GIR_RootConstrainSelectedInstOperands,
     /*   13731 */     // GIR_Coverage, 45815,
     /*   13731 */     GIR_EraseRootFromParent_Done,
     /*   13732 */   // Label 327: @13732
     /*   13732 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13821), // Rule ID 46548 //
     /*   13737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13780 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13819 */     GIR_RootConstrainSelectedInstOperands,
     /*   13820 */     // GIR_Coverage, 46548,
     /*   13820 */     GIR_EraseRootFromParent_Done,
     /*   13821 */   // Label 328: @13821
     /*   13821 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13910), // Rule ID 46549 //
     /*   13826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13869 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13908 */     GIR_RootConstrainSelectedInstOperands,
     /*   13909 */     // GIR_Coverage, 46549,
     /*   13909 */     GIR_EraseRootFromParent_Done,
     /*   13910 */   // Label 329: @13910
     /*   13910 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13978), // Rule ID 70368 //
     /*   13915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13952 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   13955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13976 */     GIR_RootConstrainSelectedInstOperands,
     /*   13977 */     // GIR_Coverage, 70368,
     /*   13977 */     GIR_EraseRootFromParent_Done,
     /*   13978 */   // Label 330: @13978
     /*   13978 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14046), // Rule ID 70369 //
     /*   13983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14020 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14044 */     GIR_RootConstrainSelectedInstOperands,
     /*   14045 */     // GIR_Coverage, 70369,
     /*   14045 */     GIR_EraseRootFromParent_Done,
     /*   14046 */   // Label 331: @14046
     /*   14046 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14101), // Rule ID 69360 //
     /*   14051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14079 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14099 */     GIR_RootConstrainSelectedInstOperands,
     /*   14100 */     // GIR_Coverage, 69360,
     /*   14100 */     GIR_EraseRootFromParent_Done,
     /*   14101 */   // Label 332: @14101
     /*   14101 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14156), // Rule ID 69361 //
     /*   14106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14134 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14154 */     GIR_RootConstrainSelectedInstOperands,
     /*   14155 */     // GIR_Coverage, 69361,
     /*   14155 */     GIR_EraseRootFromParent_Done,
     /*   14156 */   // Label 333: @14156
     /*   14156 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14211), // Rule ID 68968 //
     /*   14161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14189 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14209 */     GIR_RootConstrainSelectedInstOperands,
     /*   14210 */     // GIR_Coverage, 68968,
     /*   14210 */     GIR_EraseRootFromParent_Done,
     /*   14211 */   // Label 334: @14211
     /*   14211 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14266), // Rule ID 68969 //
     /*   14216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14244 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14264 */     GIR_RootConstrainSelectedInstOperands,
     /*   14265 */     // GIR_Coverage, 68969,
     /*   14265 */     GIR_EraseRootFromParent_Done,
     /*   14266 */   // Label 335: @14266
     /*   14266 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14321), // Rule ID 69270 //
     /*   14271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14299 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14319 */     GIR_RootConstrainSelectedInstOperands,
     /*   14320 */     // GIR_Coverage, 69270,
     /*   14320 */     GIR_EraseRootFromParent_Done,
     /*   14321 */   // Label 336: @14321
     /*   14321 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14376), // Rule ID 69271 //
     /*   14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14354 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14374 */     GIR_RootConstrainSelectedInstOperands,
     /*   14375 */     // GIR_Coverage, 69271,
     /*   14375 */     GIR_EraseRootFromParent_Done,
     /*   14376 */   // Label 337: @14376
     /*   14376 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14444), // Rule ID 51862 //
     /*   14381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14418 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14442 */     GIR_RootConstrainSelectedInstOperands,
     /*   14443 */     // GIR_Coverage, 51862,
     /*   14443 */     GIR_EraseRootFromParent_Done,
     /*   14444 */   // Label 338: @14444
     /*   14444 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14512), // Rule ID 51863 //
     /*   14449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14486 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14510 */     GIR_RootConstrainSelectedInstOperands,
     /*   14511 */     // GIR_Coverage, 51863,
     /*   14511 */     GIR_EraseRootFromParent_Done,
     /*   14512 */   // Label 339: @14512
     /*   14512 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14567), // Rule ID 46728 //
     /*   14517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14545 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14565 */     GIR_RootConstrainSelectedInstOperands,
     /*   14566 */     // GIR_Coverage, 46728,
     /*   14566 */     GIR_EraseRootFromParent_Done,
     /*   14567 */   // Label 340: @14567
     /*   14567 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14622), // Rule ID 46729 //
     /*   14572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14600 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14620 */     GIR_RootConstrainSelectedInstOperands,
     /*   14621 */     // GIR_Coverage, 46729,
     /*   14621 */     GIR_EraseRootFromParent_Done,
     /*   14622 */   // Label 341: @14622
     /*   14622 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14677), // Rule ID 45818 //
     /*   14627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14655 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14675 */     GIR_RootConstrainSelectedInstOperands,
     /*   14676 */     // GIR_Coverage, 45818,
     /*   14676 */     GIR_EraseRootFromParent_Done,
     /*   14677 */   // Label 342: @14677
     /*   14677 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14732), // Rule ID 45819 //
     /*   14682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14710 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14730 */     GIR_RootConstrainSelectedInstOperands,
     /*   14731 */     // GIR_Coverage, 45819,
     /*   14731 */     GIR_EraseRootFromParent_Done,
     /*   14732 */   // Label 343: @14732
     /*   14732 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14787), // Rule ID 46608 //
     /*   14737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14765 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14785 */     GIR_RootConstrainSelectedInstOperands,
     /*   14786 */     // GIR_Coverage, 46608,
     /*   14786 */     GIR_EraseRootFromParent_Done,
     /*   14787 */   // Label 344: @14787
     /*   14787 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14842), // Rule ID 46609 //
     /*   14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14820 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14840 */     GIR_RootConstrainSelectedInstOperands,
     /*   14841 */     // GIR_Coverage, 46609,
     /*   14841 */     GIR_EraseRootFromParent_Done,
     /*   14842 */   // Label 345: @14842
     /*   14842 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(14895), // Rule ID 46094 //
     /*   14847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14858 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14893 */     GIR_RootConstrainSelectedInstOperands,
     /*   14894 */     // GIR_Coverage, 46094,
     /*   14894 */     GIR_EraseRootFromParent_Done,
     /*   14895 */   // Label 346: @14895
     /*   14895 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(14948), // Rule ID 46095 //
     /*   14900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14911 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14946 */     GIR_RootConstrainSelectedInstOperands,
     /*   14947 */     // GIR_Coverage, 46095,
     /*   14947 */     GIR_EraseRootFromParent_Done,
     /*   14948 */   // Label 347: @14948
     /*   14948 */   GIM_Reject,
     /*   14949 */ // Label 307: @14949
     /*   14949 */ GIM_Reject,
     /*   14950 */ // Label 130: @14950
     /*   14950 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18074),
     /*   14955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14965 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15061), // Rule ID 70574 //
     /*   14970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15018 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15022 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15024 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15035 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15059 */     GIR_RootConstrainSelectedInstOperands,
     /*   15060 */     // GIR_Coverage, 70574,
     /*   15060 */     GIR_EraseRootFromParent_Done,
     /*   15061 */   // Label 349: @15061
     /*   15061 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15157), // Rule ID 70575 //
     /*   15066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15118 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15120 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15131 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15155 */     GIR_RootConstrainSelectedInstOperands,
     /*   15156 */     // GIR_Coverage, 70575,
     /*   15156 */     GIR_EraseRootFromParent_Done,
     /*   15157 */   // Label 350: @15157
     /*   15157 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15253), // Rule ID 70834 //
     /*   15162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15195 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15214 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15216 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15227 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15251 */     GIR_RootConstrainSelectedInstOperands,
     /*   15252 */     // GIR_Coverage, 70834,
     /*   15252 */     GIR_EraseRootFromParent_Done,
     /*   15253 */   // Label 351: @15253
     /*   15253 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15349), // Rule ID 70835 //
     /*   15258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15310 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15312 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15323 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15347 */     GIR_RootConstrainSelectedInstOperands,
     /*   15348 */     // GIR_Coverage, 70835,
     /*   15348 */     GIR_EraseRootFromParent_Done,
     /*   15349 */   // Label 352: @15349
     /*   15349 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15445), // Rule ID 70836 //
     /*   15354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15406 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15419 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15443 */     GIR_RootConstrainSelectedInstOperands,
     /*   15444 */     // GIR_Coverage, 70836,
     /*   15444 */     GIR_EraseRootFromParent_Done,
     /*   15445 */   // Label 353: @15445
     /*   15445 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15541), // Rule ID 70837 //
     /*   15450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15502 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15515 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15539 */     GIR_RootConstrainSelectedInstOperands,
     /*   15540 */     // GIR_Coverage, 70837,
     /*   15540 */     GIR_EraseRootFromParent_Done,
     /*   15541 */   // Label 354: @15541
     /*   15541 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15637), // Rule ID 70688 //
     /*   15546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15598 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15600 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15611 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15635 */     GIR_RootConstrainSelectedInstOperands,
     /*   15636 */     // GIR_Coverage, 70688,
     /*   15636 */     GIR_EraseRootFromParent_Done,
     /*   15637 */   // Label 355: @15637
     /*   15637 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15733), // Rule ID 70689 //
     /*   15642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15694 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15696 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15707 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15731 */     GIR_RootConstrainSelectedInstOperands,
     /*   15732 */     // GIR_Coverage, 70689,
     /*   15732 */     GIR_EraseRootFromParent_Done,
     /*   15733 */   // Label 356: @15733
     /*   15733 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15829), // Rule ID 52036 //
     /*   15738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15794 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15803 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15827 */     GIR_RootConstrainSelectedInstOperands,
     /*   15828 */     // GIR_Coverage, 52036,
     /*   15828 */     GIR_EraseRootFromParent_Done,
     /*   15829 */   // Label 357: @15829
     /*   15829 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15925), // Rule ID 52037 //
     /*   15834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15890 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15892 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15899 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15923 */     GIR_RootConstrainSelectedInstOperands,
     /*   15924 */     // GIR_Coverage, 52037,
     /*   15924 */     GIR_EraseRootFromParent_Done,
     /*   15925 */   // Label 358: @15925
     /*   15925 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16021), // Rule ID 52154 //
     /*   15930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15986 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15988 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15995 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16019 */     GIR_RootConstrainSelectedInstOperands,
     /*   16020 */     // GIR_Coverage, 52154,
     /*   16020 */     GIR_EraseRootFromParent_Done,
     /*   16021 */   // Label 359: @16021
     /*   16021 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16117), // Rule ID 52155 //
     /*   16026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16063 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16082 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16091 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16115 */     GIR_RootConstrainSelectedInstOperands,
     /*   16116 */     // GIR_Coverage, 52155,
     /*   16116 */     GIR_EraseRootFromParent_Done,
     /*   16117 */   // Label 360: @16117
     /*   16117 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16213), // Rule ID 70832 //
     /*   16122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16145 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16178 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16187 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16211 */     GIR_RootConstrainSelectedInstOperands,
     /*   16212 */     // GIR_Coverage, 70832,
     /*   16212 */     GIR_EraseRootFromParent_Done,
     /*   16213 */   // Label 361: @16213
     /*   16213 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16309), // Rule ID 70833 //
     /*   16218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16274 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16276 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16283 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16307 */     GIR_RootConstrainSelectedInstOperands,
     /*   16308 */     // GIR_Coverage, 70833,
     /*   16308 */     GIR_EraseRootFromParent_Done,
     /*   16309 */   // Label 362: @16309
     /*   16309 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16405), // Rule ID 52094 //
     /*   16314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16370 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16379 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16403 */     GIR_RootConstrainSelectedInstOperands,
     /*   16404 */     // GIR_Coverage, 52094,
     /*   16404 */     GIR_EraseRootFromParent_Done,
     /*   16405 */   // Label 363: @16405
     /*   16405 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16501), // Rule ID 52095 //
     /*   16410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16466 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16468 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16475 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16499 */     GIR_RootConstrainSelectedInstOperands,
     /*   16500 */     // GIR_Coverage, 52095,
     /*   16500 */     GIR_EraseRootFromParent_Done,
     /*   16501 */   // Label 364: @16501
     /*   16501 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16590), // Rule ID 46692 //
     /*   16506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16549 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16588 */     GIR_RootConstrainSelectedInstOperands,
     /*   16589 */     // GIR_Coverage, 46692,
     /*   16589 */     GIR_EraseRootFromParent_Done,
     /*   16590 */   // Label 365: @16590
     /*   16590 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16679), // Rule ID 46693 //
     /*   16595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16638 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16677 */     GIR_RootConstrainSelectedInstOperands,
     /*   16678 */     // GIR_Coverage, 46693,
     /*   16678 */     GIR_EraseRootFromParent_Done,
     /*   16679 */   // Label 366: @16679
     /*   16679 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16768), // Rule ID 46456 //
     /*   16684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16727 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16766 */     GIR_RootConstrainSelectedInstOperands,
     /*   16767 */     // GIR_Coverage, 46456,
     /*   16767 */     GIR_EraseRootFromParent_Done,
     /*   16768 */   // Label 367: @16768
     /*   16768 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16857), // Rule ID 46457 //
     /*   16773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16816 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16855 */     GIR_RootConstrainSelectedInstOperands,
     /*   16856 */     // GIR_Coverage, 46457,
     /*   16856 */     GIR_EraseRootFromParent_Done,
     /*   16857 */   // Label 368: @16857
     /*   16857 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16946), // Rule ID 46572 //
     /*   16862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16905 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16944 */     GIR_RootConstrainSelectedInstOperands,
     /*   16945 */     // GIR_Coverage, 46572,
     /*   16945 */     GIR_EraseRootFromParent_Done,
     /*   16946 */   // Label 369: @16946
     /*   16946 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17035), // Rule ID 46573 //
     /*   16951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16994 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17033 */     GIR_RootConstrainSelectedInstOperands,
     /*   17034 */     // GIR_Coverage, 46573,
     /*   17034 */     GIR_EraseRootFromParent_Done,
     /*   17035 */   // Label 370: @17035
     /*   17035 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17103), // Rule ID 70384 //
     /*   17040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17077 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17101 */     GIR_RootConstrainSelectedInstOperands,
     /*   17102 */     // GIR_Coverage, 70384,
     /*   17102 */     GIR_EraseRootFromParent_Done,
     /*   17103 */   // Label 371: @17103
     /*   17103 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17171), // Rule ID 70385 //
     /*   17108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17145 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17169 */     GIR_RootConstrainSelectedInstOperands,
     /*   17170 */     // GIR_Coverage, 70385,
     /*   17170 */     GIR_EraseRootFromParent_Done,
     /*   17171 */   // Label 372: @17171
     /*   17171 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17226), // Rule ID 69384 //
     /*   17176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17204 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17224 */     GIR_RootConstrainSelectedInstOperands,
     /*   17225 */     // GIR_Coverage, 69384,
     /*   17225 */     GIR_EraseRootFromParent_Done,
     /*   17226 */   // Label 373: @17226
     /*   17226 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17281), // Rule ID 69385 //
     /*   17231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17259 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17279 */     GIR_RootConstrainSelectedInstOperands,
     /*   17280 */     // GIR_Coverage, 69385,
     /*   17280 */     GIR_EraseRootFromParent_Done,
     /*   17281 */   // Label 374: @17281
     /*   17281 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17336), // Rule ID 69204 //
     /*   17286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17314 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17334 */     GIR_RootConstrainSelectedInstOperands,
     /*   17335 */     // GIR_Coverage, 69204,
     /*   17335 */     GIR_EraseRootFromParent_Done,
     /*   17336 */   // Label 375: @17336
     /*   17336 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17391), // Rule ID 69205 //
     /*   17341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17369 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17389 */     GIR_RootConstrainSelectedInstOperands,
     /*   17390 */     // GIR_Coverage, 69205,
     /*   17390 */     GIR_EraseRootFromParent_Done,
     /*   17391 */   // Label 376: @17391
     /*   17391 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17446), // Rule ID 69294 //
     /*   17396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17424 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17444 */     GIR_RootConstrainSelectedInstOperands,
     /*   17445 */     // GIR_Coverage, 69294,
     /*   17445 */     GIR_EraseRootFromParent_Done,
     /*   17446 */   // Label 377: @17446
     /*   17446 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17501), // Rule ID 69295 //
     /*   17451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17479 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17499 */     GIR_RootConstrainSelectedInstOperands,
     /*   17500 */     // GIR_Coverage, 69295,
     /*   17500 */     GIR_EraseRootFromParent_Done,
     /*   17501 */   // Label 378: @17501
     /*   17501 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17569), // Rule ID 51870 //
     /*   17506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17543 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17567 */     GIR_RootConstrainSelectedInstOperands,
     /*   17568 */     // GIR_Coverage, 51870,
     /*   17568 */     GIR_EraseRootFromParent_Done,
     /*   17569 */   // Label 379: @17569
     /*   17569 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17637), // Rule ID 51871 //
     /*   17574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17611 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17635 */     GIR_RootConstrainSelectedInstOperands,
     /*   17636 */     // GIR_Coverage, 51871,
     /*   17636 */     GIR_EraseRootFromParent_Done,
     /*   17637 */   // Label 380: @17637
     /*   17637 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17692), // Rule ID 46752 //
     /*   17642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17670 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17690 */     GIR_RootConstrainSelectedInstOperands,
     /*   17691 */     // GIR_Coverage, 46752,
     /*   17691 */     GIR_EraseRootFromParent_Done,
     /*   17692 */   // Label 381: @17692
     /*   17692 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17747), // Rule ID 46753 //
     /*   17697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17725 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17745 */     GIR_RootConstrainSelectedInstOperands,
     /*   17746 */     // GIR_Coverage, 46753,
     /*   17746 */     GIR_EraseRootFromParent_Done,
     /*   17747 */   // Label 382: @17747
     /*   17747 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17802), // Rule ID 46512 //
     /*   17752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17780 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17800 */     GIR_RootConstrainSelectedInstOperands,
     /*   17801 */     // GIR_Coverage, 46512,
     /*   17801 */     GIR_EraseRootFromParent_Done,
     /*   17802 */   // Label 383: @17802
     /*   17802 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17857), // Rule ID 46513 //
     /*   17807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17835 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17855 */     GIR_RootConstrainSelectedInstOperands,
     /*   17856 */     // GIR_Coverage, 46513,
     /*   17856 */     GIR_EraseRootFromParent_Done,
     /*   17857 */   // Label 384: @17857
     /*   17857 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17912), // Rule ID 46632 //
     /*   17862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17890 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17910 */     GIR_RootConstrainSelectedInstOperands,
     /*   17911 */     // GIR_Coverage, 46632,
     /*   17911 */     GIR_EraseRootFromParent_Done,
     /*   17912 */   // Label 385: @17912
     /*   17912 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17967), // Rule ID 46633 //
     /*   17917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17945 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17965 */     GIR_RootConstrainSelectedInstOperands,
     /*   17966 */     // GIR_Coverage, 46633,
     /*   17966 */     GIR_EraseRootFromParent_Done,
     /*   17967 */   // Label 386: @17967
     /*   17967 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18020), // Rule ID 46102 //
     /*   17972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17983 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18018 */     GIR_RootConstrainSelectedInstOperands,
     /*   18019 */     // GIR_Coverage, 46102,
     /*   18019 */     GIR_EraseRootFromParent_Done,
     /*   18020 */   // Label 387: @18020
     /*   18020 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18073), // Rule ID 46103 //
     /*   18025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18036 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18071 */     GIR_RootConstrainSelectedInstOperands,
     /*   18072 */     // GIR_Coverage, 46103,
     /*   18072 */     GIR_EraseRootFromParent_Done,
     /*   18073 */   // Label 388: @18073
     /*   18073 */   GIM_Reject,
     /*   18074 */ // Label 348: @18074
     /*   18074 */ GIM_Reject,
     /*   18075 */ // Label 131: @18075
     /*   18075 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(21199),
     /*   18080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18090 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18186), // Rule ID 70584 //
     /*   18095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18160 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18184 */     GIR_RootConstrainSelectedInstOperands,
     /*   18185 */     // GIR_Coverage, 70584,
     /*   18185 */     GIR_EraseRootFromParent_Done,
     /*   18186 */   // Label 390: @18186
     /*   18186 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18282), // Rule ID 70585 //
     /*   18191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18256 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18280 */     GIR_RootConstrainSelectedInstOperands,
     /*   18281 */     // GIR_Coverage, 70585,
     /*   18281 */     GIR_EraseRootFromParent_Done,
     /*   18282 */   // Label 391: @18282
     /*   18282 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18378), // Rule ID 70864 //
     /*   18287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18352 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18376 */     GIR_RootConstrainSelectedInstOperands,
     /*   18377 */     // GIR_Coverage, 70864,
     /*   18377 */     GIR_EraseRootFromParent_Done,
     /*   18378 */   // Label 392: @18378
     /*   18378 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18474), // Rule ID 70865 //
     /*   18383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18435 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18448 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18472 */     GIR_RootConstrainSelectedInstOperands,
     /*   18473 */     // GIR_Coverage, 70865,
     /*   18473 */     GIR_EraseRootFromParent_Done,
     /*   18474 */   // Label 393: @18474
     /*   18474 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18570), // Rule ID 70866 //
     /*   18479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18512 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18531 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18533 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18544 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18568 */     GIR_RootConstrainSelectedInstOperands,
     /*   18569 */     // GIR_Coverage, 70866,
     /*   18569 */     GIR_EraseRootFromParent_Done,
     /*   18570 */   // Label 394: @18570
     /*   18570 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18666), // Rule ID 70867 //
     /*   18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18627 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18640 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18664 */     GIR_RootConstrainSelectedInstOperands,
     /*   18665 */     // GIR_Coverage, 70867,
     /*   18665 */     GIR_EraseRootFromParent_Done,
     /*   18666 */   // Label 395: @18666
     /*   18666 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18762), // Rule ID 70698 //
     /*   18671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18723 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18736 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18760 */     GIR_RootConstrainSelectedInstOperands,
     /*   18761 */     // GIR_Coverage, 70698,
     /*   18761 */     GIR_EraseRootFromParent_Done,
     /*   18762 */   // Label 396: @18762
     /*   18762 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18858), // Rule ID 70699 //
     /*   18767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18800 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18819 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18832 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18856 */     GIR_RootConstrainSelectedInstOperands,
     /*   18857 */     // GIR_Coverage, 70699,
     /*   18857 */     GIR_EraseRootFromParent_Done,
     /*   18858 */   // Label 397: @18858
     /*   18858 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18954), // Rule ID 52046 //
     /*   18863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18928 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18952 */     GIR_RootConstrainSelectedInstOperands,
     /*   18953 */     // GIR_Coverage, 52046,
     /*   18953 */     GIR_EraseRootFromParent_Done,
     /*   18954 */   // Label 398: @18954
     /*   18954 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19050), // Rule ID 52047 //
     /*   18959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19024 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19048 */     GIR_RootConstrainSelectedInstOperands,
     /*   19049 */     // GIR_Coverage, 52047,
     /*   19049 */     GIR_EraseRootFromParent_Done,
     /*   19050 */   // Label 399: @19050
     /*   19050 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19146), // Rule ID 52164 //
     /*   19055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19120 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19144 */     GIR_RootConstrainSelectedInstOperands,
     /*   19145 */     // GIR_Coverage, 52164,
     /*   19145 */     GIR_EraseRootFromParent_Done,
     /*   19146 */   // Label 400: @19146
     /*   19146 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19242), // Rule ID 52165 //
     /*   19151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19216 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19240 */     GIR_RootConstrainSelectedInstOperands,
     /*   19241 */     // GIR_Coverage, 52165,
     /*   19241 */     GIR_EraseRootFromParent_Done,
     /*   19242 */   // Label 401: @19242
     /*   19242 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19338), // Rule ID 70862 //
     /*   19247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19312 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19336 */     GIR_RootConstrainSelectedInstOperands,
     /*   19337 */     // GIR_Coverage, 70862,
     /*   19337 */     GIR_EraseRootFromParent_Done,
     /*   19338 */   // Label 402: @19338
     /*   19338 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19434), // Rule ID 70863 //
     /*   19343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19408 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19432 */     GIR_RootConstrainSelectedInstOperands,
     /*   19433 */     // GIR_Coverage, 70863,
     /*   19433 */     GIR_EraseRootFromParent_Done,
     /*   19434 */   // Label 403: @19434
     /*   19434 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19530), // Rule ID 52104 //
     /*   19439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19504 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19528 */     GIR_RootConstrainSelectedInstOperands,
     /*   19529 */     // GIR_Coverage, 52104,
     /*   19529 */     GIR_EraseRootFromParent_Done,
     /*   19530 */   // Label 404: @19530
     /*   19530 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19626), // Rule ID 52105 //
     /*   19535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19600 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19624 */     GIR_RootConstrainSelectedInstOperands,
     /*   19625 */     // GIR_Coverage, 52105,
     /*   19625 */     GIR_EraseRootFromParent_Done,
     /*   19626 */   // Label 405: @19626
     /*   19626 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19715), // Rule ID 46712 //
     /*   19631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19665 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19674 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19713 */     GIR_RootConstrainSelectedInstOperands,
     /*   19714 */     // GIR_Coverage, 46712,
     /*   19714 */     GIR_EraseRootFromParent_Done,
     /*   19715 */   // Label 406: @19715
     /*   19715 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19804), // Rule ID 46713 //
     /*   19720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19754 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19763 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19802 */     GIR_RootConstrainSelectedInstOperands,
     /*   19803 */     // GIR_Coverage, 46713,
     /*   19803 */     GIR_EraseRootFromParent_Done,
     /*   19804 */   // Label 407: @19804
     /*   19804 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19893), // Rule ID 46476 //
     /*   19809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19843 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19852 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19891 */     GIR_RootConstrainSelectedInstOperands,
     /*   19892 */     // GIR_Coverage, 46476,
     /*   19892 */     GIR_EraseRootFromParent_Done,
     /*   19893 */   // Label 408: @19893
     /*   19893 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19982), // Rule ID 46477 //
     /*   19898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19932 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19941 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19980 */     GIR_RootConstrainSelectedInstOperands,
     /*   19981 */     // GIR_Coverage, 46477,
     /*   19981 */     GIR_EraseRootFromParent_Done,
     /*   19982 */   // Label 409: @19982
     /*   19982 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20071), // Rule ID 46592 //
     /*   19987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20021 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20030 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20069 */     GIR_RootConstrainSelectedInstOperands,
     /*   20070 */     // GIR_Coverage, 46592,
     /*   20070 */     GIR_EraseRootFromParent_Done,
     /*   20071 */   // Label 410: @20071
     /*   20071 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20160), // Rule ID 46593 //
     /*   20076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20119 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20158 */     GIR_RootConstrainSelectedInstOperands,
     /*   20159 */     // GIR_Coverage, 46593,
     /*   20159 */     GIR_EraseRootFromParent_Done,
     /*   20160 */   // Label 411: @20160
     /*   20160 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20228), // Rule ID 70416 //
     /*   20165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20184 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20202 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20226 */     GIR_RootConstrainSelectedInstOperands,
     /*   20227 */     // GIR_Coverage, 70416,
     /*   20227 */     GIR_EraseRootFromParent_Done,
     /*   20228 */   // Label 412: @20228
     /*   20228 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20296), // Rule ID 70417 //
     /*   20233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20270 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20294 */     GIR_RootConstrainSelectedInstOperands,
     /*   20295 */     // GIR_Coverage, 70417,
     /*   20295 */     GIR_EraseRootFromParent_Done,
     /*   20296 */   // Label 413: @20296
     /*   20296 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20351), // Rule ID 69404 //
     /*   20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20329 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20349 */     GIR_RootConstrainSelectedInstOperands,
     /*   20350 */     // GIR_Coverage, 69404,
     /*   20350 */     GIR_EraseRootFromParent_Done,
     /*   20351 */   // Label 414: @20351
     /*   20351 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20406), // Rule ID 69405 //
     /*   20356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20384 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20404 */     GIR_RootConstrainSelectedInstOperands,
     /*   20405 */     // GIR_Coverage, 69405,
     /*   20405 */     GIR_EraseRootFromParent_Done,
     /*   20406 */   // Label 415: @20406
     /*   20406 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20461), // Rule ID 69224 //
     /*   20411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20439 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20459 */     GIR_RootConstrainSelectedInstOperands,
     /*   20460 */     // GIR_Coverage, 69224,
     /*   20460 */     GIR_EraseRootFromParent_Done,
     /*   20461 */   // Label 416: @20461
     /*   20461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20516), // Rule ID 69225 //
     /*   20466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20494 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20514 */     GIR_RootConstrainSelectedInstOperands,
     /*   20515 */     // GIR_Coverage, 69225,
     /*   20515 */     GIR_EraseRootFromParent_Done,
     /*   20516 */   // Label 417: @20516
     /*   20516 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20571), // Rule ID 69314 //
     /*   20521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20549 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20569 */     GIR_RootConstrainSelectedInstOperands,
     /*   20570 */     // GIR_Coverage, 69314,
     /*   20570 */     GIR_EraseRootFromParent_Done,
     /*   20571 */   // Label 418: @20571
     /*   20571 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20626), // Rule ID 69315 //
     /*   20576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20604 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20624 */     GIR_RootConstrainSelectedInstOperands,
     /*   20625 */     // GIR_Coverage, 69315,
     /*   20625 */     GIR_EraseRootFromParent_Done,
     /*   20626 */   // Label 419: @20626
     /*   20626 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20694), // Rule ID 51886 //
     /*   20631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20668 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20692 */     GIR_RootConstrainSelectedInstOperands,
     /*   20693 */     // GIR_Coverage, 51886,
     /*   20693 */     GIR_EraseRootFromParent_Done,
     /*   20694 */   // Label 420: @20694
     /*   20694 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20762), // Rule ID 51887 //
     /*   20699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20736 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20760 */     GIR_RootConstrainSelectedInstOperands,
     /*   20761 */     // GIR_Coverage, 51887,
     /*   20761 */     GIR_EraseRootFromParent_Done,
     /*   20762 */   // Label 421: @20762
     /*   20762 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20817), // Rule ID 46772 //
     /*   20767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20795 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20815 */     GIR_RootConstrainSelectedInstOperands,
     /*   20816 */     // GIR_Coverage, 46772,
     /*   20816 */     GIR_EraseRootFromParent_Done,
     /*   20817 */   // Label 422: @20817
     /*   20817 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20872), // Rule ID 46773 //
     /*   20822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20850 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20870 */     GIR_RootConstrainSelectedInstOperands,
     /*   20871 */     // GIR_Coverage, 46773,
     /*   20871 */     GIR_EraseRootFromParent_Done,
     /*   20872 */   // Label 423: @20872
     /*   20872 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20927), // Rule ID 46532 //
     /*   20877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20905 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20925 */     GIR_RootConstrainSelectedInstOperands,
     /*   20926 */     // GIR_Coverage, 46532,
     /*   20926 */     GIR_EraseRootFromParent_Done,
     /*   20927 */   // Label 424: @20927
     /*   20927 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20982), // Rule ID 46533 //
     /*   20932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20960 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20980 */     GIR_RootConstrainSelectedInstOperands,
     /*   20981 */     // GIR_Coverage, 46533,
     /*   20981 */     GIR_EraseRootFromParent_Done,
     /*   20982 */   // Label 425: @20982
     /*   20982 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21037), // Rule ID 46652 //
     /*   20987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21015 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21035 */     GIR_RootConstrainSelectedInstOperands,
     /*   21036 */     // GIR_Coverage, 46652,
     /*   21036 */     GIR_EraseRootFromParent_Done,
     /*   21037 */   // Label 426: @21037
     /*   21037 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21092), // Rule ID 46653 //
     /*   21042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21070 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21090 */     GIR_RootConstrainSelectedInstOperands,
     /*   21091 */     // GIR_Coverage, 46653,
     /*   21091 */     GIR_EraseRootFromParent_Done,
     /*   21092 */   // Label 427: @21092
     /*   21092 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21145), // Rule ID 46118 //
     /*   21097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21108 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21143 */     GIR_RootConstrainSelectedInstOperands,
     /*   21144 */     // GIR_Coverage, 46118,
     /*   21144 */     GIR_EraseRootFromParent_Done,
     /*   21145 */   // Label 428: @21145
     /*   21145 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21198), // Rule ID 46119 //
     /*   21150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21161 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21196 */     GIR_RootConstrainSelectedInstOperands,
     /*   21197 */     // GIR_Coverage, 46119,
     /*   21197 */     GIR_EraseRootFromParent_Done,
     /*   21198 */   // Label 429: @21198
     /*   21198 */   GIM_Reject,
     /*   21199 */ // Label 389: @21199
     /*   21199 */ GIM_Reject,
     /*   21200 */ // Label 132: @21200
     /*   21200 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21594),
     /*   21205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21215 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21283), // Rule ID 70352 //
     /*   21220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21257 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21281 */     GIR_RootConstrainSelectedInstOperands,
     /*   21282 */     // GIR_Coverage, 70352,
     /*   21282 */     GIR_EraseRootFromParent_Done,
     /*   21283 */   // Label 431: @21283
     /*   21283 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21351), // Rule ID 70353 //
     /*   21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21325 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21349 */     GIR_RootConstrainSelectedInstOperands,
     /*   21350 */     // GIR_Coverage, 70353,
     /*   21350 */     GIR_EraseRootFromParent_Done,
     /*   21351 */   // Label 432: @21351
     /*   21351 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21419), // Rule ID 51854 //
     /*   21356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21393 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21417 */     GIR_RootConstrainSelectedInstOperands,
     /*   21418 */     // GIR_Coverage, 51854,
     /*   21418 */     GIR_EraseRootFromParent_Done,
     /*   21419 */   // Label 433: @21419
     /*   21419 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21487), // Rule ID 51855 //
     /*   21424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21461 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21485 */     GIR_RootConstrainSelectedInstOperands,
     /*   21486 */     // GIR_Coverage, 51855,
     /*   21486 */     GIR_EraseRootFromParent_Done,
     /*   21487 */   // Label 434: @21487
     /*   21487 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21540), // Rule ID 46086 //
     /*   21492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21503 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21538 */     GIR_RootConstrainSelectedInstOperands,
     /*   21539 */     // GIR_Coverage, 46086,
     /*   21539 */     GIR_EraseRootFromParent_Done,
     /*   21540 */   // Label 435: @21540
     /*   21540 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21593), // Rule ID 46087 //
     /*   21545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21556 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21591 */     GIR_RootConstrainSelectedInstOperands,
     /*   21592 */     // GIR_Coverage, 46087,
     /*   21592 */     GIR_EraseRootFromParent_Done,
     /*   21593 */   // Label 436: @21593
     /*   21593 */   GIM_Reject,
     /*   21594 */ // Label 430: @21594
     /*   21594 */ GIM_Reject,
     /*   21595 */ // Label 133: @21595
     /*   21595 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(24719),
     /*   21600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21610 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21706), // Rule ID 70564 //
     /*   21615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21648 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21667 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21680 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21704 */     GIR_RootConstrainSelectedInstOperands,
     /*   21705 */     // GIR_Coverage, 70564,
     /*   21705 */     GIR_EraseRootFromParent_Done,
     /*   21706 */   // Label 438: @21706
     /*   21706 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21802), // Rule ID 70565 //
     /*   21711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21744 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21763 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21776 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21800 */     GIR_RootConstrainSelectedInstOperands,
     /*   21801 */     // GIR_Coverage, 70565,
     /*   21801 */     GIR_EraseRootFromParent_Done,
     /*   21802 */   // Label 439: @21802
     /*   21802 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21898), // Rule ID 70804 //
     /*   21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21859 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21861 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21872 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21896 */     GIR_RootConstrainSelectedInstOperands,
     /*   21897 */     // GIR_Coverage, 70804,
     /*   21897 */     GIR_EraseRootFromParent_Done,
     /*   21898 */   // Label 440: @21898
     /*   21898 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21994), // Rule ID 70805 //
     /*   21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21936 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21955 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21957 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21968 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21992 */     GIR_RootConstrainSelectedInstOperands,
     /*   21993 */     // GIR_Coverage, 70805,
     /*   21993 */     GIR_EraseRootFromParent_Done,
     /*   21994 */   // Label 441: @21994
     /*   21994 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22090), // Rule ID 70806 //
     /*   21999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22032 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22051 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22064 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22088 */     GIR_RootConstrainSelectedInstOperands,
     /*   22089 */     // GIR_Coverage, 70806,
     /*   22089 */     GIR_EraseRootFromParent_Done,
     /*   22090 */   // Label 442: @22090
     /*   22090 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22186), // Rule ID 70807 //
     /*   22095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22160 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22184 */     GIR_RootConstrainSelectedInstOperands,
     /*   22185 */     // GIR_Coverage, 70807,
     /*   22185 */     GIR_EraseRootFromParent_Done,
     /*   22186 */   // Label 443: @22186
     /*   22186 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22282), // Rule ID 70678 //
     /*   22191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22256 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22280 */     GIR_RootConstrainSelectedInstOperands,
     /*   22281 */     // GIR_Coverage, 70678,
     /*   22281 */     GIR_EraseRootFromParent_Done,
     /*   22282 */   // Label 444: @22282
     /*   22282 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22378), // Rule ID 70679 //
     /*   22287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22352 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22376 */     GIR_RootConstrainSelectedInstOperands,
     /*   22377 */     // GIR_Coverage, 70679,
     /*   22377 */     GIR_EraseRootFromParent_Done,
     /*   22378 */   // Label 445: @22378
     /*   22378 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22474), // Rule ID 52026 //
     /*   22383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22406 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22435 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22439 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22441 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22448 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22472 */     GIR_RootConstrainSelectedInstOperands,
     /*   22473 */     // GIR_Coverage, 52026,
     /*   22473 */     GIR_EraseRootFromParent_Done,
     /*   22474 */   // Label 446: @22474
     /*   22474 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22570), // Rule ID 52027 //
     /*   22479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22516 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22535 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22544 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22568 */     GIR_RootConstrainSelectedInstOperands,
     /*   22569 */     // GIR_Coverage, 52027,
     /*   22569 */     GIR_EraseRootFromParent_Done,
     /*   22570 */   // Label 447: @22570
     /*   22570 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22666), // Rule ID 52144 //
     /*   22575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22612 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22631 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22640 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22664 */     GIR_RootConstrainSelectedInstOperands,
     /*   22665 */     // GIR_Coverage, 52144,
     /*   22665 */     GIR_EraseRootFromParent_Done,
     /*   22666 */   // Label 448: @22666
     /*   22666 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22762), // Rule ID 52145 //
     /*   22671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22694 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22727 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22736 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22760 */     GIR_RootConstrainSelectedInstOperands,
     /*   22761 */     // GIR_Coverage, 52145,
     /*   22761 */     GIR_EraseRootFromParent_Done,
     /*   22762 */   // Label 449: @22762
     /*   22762 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22858), // Rule ID 70802 //
     /*   22767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22804 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22823 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22832 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22856 */     GIR_RootConstrainSelectedInstOperands,
     /*   22857 */     // GIR_Coverage, 70802,
     /*   22857 */     GIR_EraseRootFromParent_Done,
     /*   22858 */   // Label 450: @22858
     /*   22858 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22954), // Rule ID 70803 //
     /*   22863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22928 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22952 */     GIR_RootConstrainSelectedInstOperands,
     /*   22953 */     // GIR_Coverage, 70803,
     /*   22953 */     GIR_EraseRootFromParent_Done,
     /*   22954 */   // Label 451: @22954
     /*   22954 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23050), // Rule ID 52084 //
     /*   22959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23024 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23048 */     GIR_RootConstrainSelectedInstOperands,
     /*   23049 */     // GIR_Coverage, 52084,
     /*   23049 */     GIR_EraseRootFromParent_Done,
     /*   23050 */   // Label 452: @23050
     /*   23050 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23146), // Rule ID 52085 //
     /*   23055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23120 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23144 */     GIR_RootConstrainSelectedInstOperands,
     /*   23145 */     // GIR_Coverage, 52085,
     /*   23145 */     GIR_EraseRootFromParent_Done,
     /*   23146 */   // Label 453: @23146
     /*   23146 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23235), // Rule ID 46672 //
     /*   23151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23166 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23185 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23194 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23233 */     GIR_RootConstrainSelectedInstOperands,
     /*   23234 */     // GIR_Coverage, 46672,
     /*   23234 */     GIR_EraseRootFromParent_Done,
     /*   23235 */   // Label 454: @23235
     /*   23235 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23324), // Rule ID 46673 //
     /*   23240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23283 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23322 */     GIR_RootConstrainSelectedInstOperands,
     /*   23323 */     // GIR_Coverage, 46673,
     /*   23323 */     GIR_EraseRootFromParent_Done,
     /*   23324 */   // Label 455: @23324
     /*   23324 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23413), // Rule ID 46436 //
     /*   23329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23372 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23411 */     GIR_RootConstrainSelectedInstOperands,
     /*   23412 */     // GIR_Coverage, 46436,
     /*   23412 */     GIR_EraseRootFromParent_Done,
     /*   23413 */   // Label 456: @23413
     /*   23413 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23502), // Rule ID 46437 //
     /*   23418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23461 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23500 */     GIR_RootConstrainSelectedInstOperands,
     /*   23501 */     // GIR_Coverage, 46437,
     /*   23501 */     GIR_EraseRootFromParent_Done,
     /*   23502 */   // Label 457: @23502
     /*   23502 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23591), // Rule ID 46552 //
     /*   23507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23541 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23550 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23589 */     GIR_RootConstrainSelectedInstOperands,
     /*   23590 */     // GIR_Coverage, 46552,
     /*   23590 */     GIR_EraseRootFromParent_Done,
     /*   23591 */   // Label 458: @23591
     /*   23591 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23680), // Rule ID 46553 //
     /*   23596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23639 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23678 */     GIR_RootConstrainSelectedInstOperands,
     /*   23679 */     // GIR_Coverage, 46553,
     /*   23679 */     GIR_EraseRootFromParent_Done,
     /*   23680 */   // Label 459: @23680
     /*   23680 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23748), // Rule ID 70376 //
     /*   23685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23704 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23722 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23746 */     GIR_RootConstrainSelectedInstOperands,
     /*   23747 */     // GIR_Coverage, 70376,
     /*   23747 */     GIR_EraseRootFromParent_Done,
     /*   23748 */   // Label 460: @23748
     /*   23748 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23816), // Rule ID 70377 //
     /*   23753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23790 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23814 */     GIR_RootConstrainSelectedInstOperands,
     /*   23815 */     // GIR_Coverage, 70377,
     /*   23815 */     GIR_EraseRootFromParent_Done,
     /*   23816 */   // Label 461: @23816
     /*   23816 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23871), // Rule ID 69364 //
     /*   23821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23849 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23869 */     GIR_RootConstrainSelectedInstOperands,
     /*   23870 */     // GIR_Coverage, 69364,
     /*   23870 */     GIR_EraseRootFromParent_Done,
     /*   23871 */   // Label 462: @23871
     /*   23871 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23926), // Rule ID 69365 //
     /*   23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23904 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23924 */     GIR_RootConstrainSelectedInstOperands,
     /*   23925 */     // GIR_Coverage, 69365,
     /*   23925 */     GIR_EraseRootFromParent_Done,
     /*   23926 */   // Label 463: @23926
     /*   23926 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23981), // Rule ID 69184 //
     /*   23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23959 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   23962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23979 */     GIR_RootConstrainSelectedInstOperands,
     /*   23980 */     // GIR_Coverage, 69184,
     /*   23980 */     GIR_EraseRootFromParent_Done,
     /*   23981 */   // Label 464: @23981
     /*   23981 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24036), // Rule ID 69185 //
     /*   23986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24014 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24034 */     GIR_RootConstrainSelectedInstOperands,
     /*   24035 */     // GIR_Coverage, 69185,
     /*   24035 */     GIR_EraseRootFromParent_Done,
     /*   24036 */   // Label 465: @24036
     /*   24036 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24091), // Rule ID 69274 //
     /*   24041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24069 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24089 */     GIR_RootConstrainSelectedInstOperands,
     /*   24090 */     // GIR_Coverage, 69274,
     /*   24090 */     GIR_EraseRootFromParent_Done,
     /*   24091 */   // Label 466: @24091
     /*   24091 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24146), // Rule ID 69275 //
     /*   24096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24124 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24144 */     GIR_RootConstrainSelectedInstOperands,
     /*   24145 */     // GIR_Coverage, 69275,
     /*   24145 */     GIR_EraseRootFromParent_Done,
     /*   24146 */   // Label 467: @24146
     /*   24146 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24214), // Rule ID 51866 //
     /*   24151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24188 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24212 */     GIR_RootConstrainSelectedInstOperands,
     /*   24213 */     // GIR_Coverage, 51866,
     /*   24213 */     GIR_EraseRootFromParent_Done,
     /*   24214 */   // Label 468: @24214
     /*   24214 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24282), // Rule ID 51867 //
     /*   24219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24256 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24280 */     GIR_RootConstrainSelectedInstOperands,
     /*   24281 */     // GIR_Coverage, 51867,
     /*   24281 */     GIR_EraseRootFromParent_Done,
     /*   24282 */   // Label 469: @24282
     /*   24282 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24337), // Rule ID 46732 //
     /*   24287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24315 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24335 */     GIR_RootConstrainSelectedInstOperands,
     /*   24336 */     // GIR_Coverage, 46732,
     /*   24336 */     GIR_EraseRootFromParent_Done,
     /*   24337 */   // Label 470: @24337
     /*   24337 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24392), // Rule ID 46733 //
     /*   24342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24370 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24390 */     GIR_RootConstrainSelectedInstOperands,
     /*   24391 */     // GIR_Coverage, 46733,
     /*   24391 */     GIR_EraseRootFromParent_Done,
     /*   24392 */   // Label 471: @24392
     /*   24392 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24447), // Rule ID 46492 //
     /*   24397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24425 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24445 */     GIR_RootConstrainSelectedInstOperands,
     /*   24446 */     // GIR_Coverage, 46492,
     /*   24446 */     GIR_EraseRootFromParent_Done,
     /*   24447 */   // Label 472: @24447
     /*   24447 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24502), // Rule ID 46493 //
     /*   24452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24480 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24500 */     GIR_RootConstrainSelectedInstOperands,
     /*   24501 */     // GIR_Coverage, 46493,
     /*   24501 */     GIR_EraseRootFromParent_Done,
     /*   24502 */   // Label 473: @24502
     /*   24502 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24557), // Rule ID 46612 //
     /*   24507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24526 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24535 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24555 */     GIR_RootConstrainSelectedInstOperands,
     /*   24556 */     // GIR_Coverage, 46612,
     /*   24556 */     GIR_EraseRootFromParent_Done,
     /*   24557 */   // Label 474: @24557
     /*   24557 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24612), // Rule ID 46613 //
     /*   24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24590 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24610 */     GIR_RootConstrainSelectedInstOperands,
     /*   24611 */     // GIR_Coverage, 46613,
     /*   24611 */     GIR_EraseRootFromParent_Done,
     /*   24612 */   // Label 475: @24612
     /*   24612 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24665), // Rule ID 46098 //
     /*   24617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24628 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24663 */     GIR_RootConstrainSelectedInstOperands,
     /*   24664 */     // GIR_Coverage, 46098,
     /*   24664 */     GIR_EraseRootFromParent_Done,
     /*   24665 */   // Label 476: @24665
     /*   24665 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24718), // Rule ID 46099 //
     /*   24670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24681 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24716 */     GIR_RootConstrainSelectedInstOperands,
     /*   24717 */     // GIR_Coverage, 46099,
     /*   24717 */     GIR_EraseRootFromParent_Done,
     /*   24718 */   // Label 477: @24718
     /*   24718 */   GIM_Reject,
     /*   24719 */ // Label 437: @24719
     /*   24719 */ GIM_Reject,
     /*   24720 */ // Label 134: @24720
     /*   24720 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(27844),
     /*   24725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24735 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24831), // Rule ID 70576 //
     /*   24740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24759 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24773 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24792 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24794 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24805 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24829 */     GIR_RootConstrainSelectedInstOperands,
     /*   24830 */     // GIR_Coverage, 70576,
     /*   24830 */     GIR_EraseRootFromParent_Done,
     /*   24831 */   // Label 479: @24831
     /*   24831 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24927), // Rule ID 70577 //
     /*   24836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24869 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24888 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24901 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24925 */     GIR_RootConstrainSelectedInstOperands,
     /*   24926 */     // GIR_Coverage, 70577,
     /*   24926 */     GIR_EraseRootFromParent_Done,
     /*   24927 */   // Label 480: @24927
     /*   24927 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25023), // Rule ID 70840 //
     /*   24932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24984 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24997 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25021 */     GIR_RootConstrainSelectedInstOperands,
     /*   25022 */     // GIR_Coverage, 70840,
     /*   25022 */     GIR_EraseRootFromParent_Done,
     /*   25023 */   // Label 481: @25023
     /*   25023 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25119), // Rule ID 70841 //
     /*   25028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25061 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25080 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25082 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25093 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25117 */     GIR_RootConstrainSelectedInstOperands,
     /*   25118 */     // GIR_Coverage, 70841,
     /*   25118 */     GIR_EraseRootFromParent_Done,
     /*   25119 */   // Label 482: @25119
     /*   25119 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25215), // Rule ID 70842 //
     /*   25124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25157 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25176 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25178 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25189 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25213 */     GIR_RootConstrainSelectedInstOperands,
     /*   25214 */     // GIR_Coverage, 70842,
     /*   25214 */     GIR_EraseRootFromParent_Done,
     /*   25215 */   // Label 483: @25215
     /*   25215 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(25311), // Rule ID 70843 //
     /*   25220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25253 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25272 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25285 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25309 */     GIR_RootConstrainSelectedInstOperands,
     /*   25310 */     // GIR_Coverage, 70843,
     /*   25310 */     GIR_EraseRootFromParent_Done,
     /*   25311 */   // Label 484: @25311
     /*   25311 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25407), // Rule ID 70690 //
     /*   25316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25349 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25368 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25370 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25381 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25405 */     GIR_RootConstrainSelectedInstOperands,
     /*   25406 */     // GIR_Coverage, 70690,
     /*   25406 */     GIR_EraseRootFromParent_Done,
     /*   25407 */   // Label 485: @25407
     /*   25407 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25503), // Rule ID 70691 //
     /*   25412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25464 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25466 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25477 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25501 */     GIR_RootConstrainSelectedInstOperands,
     /*   25502 */     // GIR_Coverage, 70691,
     /*   25502 */     GIR_EraseRootFromParent_Done,
     /*   25503 */   // Label 486: @25503
     /*   25503 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25599), // Rule ID 52038 //
     /*   25508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25545 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25564 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25566 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25573 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25597 */     GIR_RootConstrainSelectedInstOperands,
     /*   25598 */     // GIR_Coverage, 52038,
     /*   25598 */     GIR_EraseRootFromParent_Done,
     /*   25599 */   // Label 487: @25599
     /*   25599 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25695), // Rule ID 52039 //
     /*   25604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25660 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25662 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25669 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25693 */     GIR_RootConstrainSelectedInstOperands,
     /*   25694 */     // GIR_Coverage, 52039,
     /*   25694 */     GIR_EraseRootFromParent_Done,
     /*   25695 */   // Label 488: @25695
     /*   25695 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25791), // Rule ID 52156 //
     /*   25700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25737 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25756 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25758 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25765 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25789 */     GIR_RootConstrainSelectedInstOperands,
     /*   25790 */     // GIR_Coverage, 52156,
     /*   25790 */     GIR_EraseRootFromParent_Done,
     /*   25791 */   // Label 489: @25791
     /*   25791 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25887), // Rule ID 52157 //
     /*   25796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25833 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25852 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25861 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25885 */     GIR_RootConstrainSelectedInstOperands,
     /*   25886 */     // GIR_Coverage, 52157,
     /*   25886 */     GIR_EraseRootFromParent_Done,
     /*   25887 */   // Label 490: @25887
     /*   25887 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25983), // Rule ID 70838 //
     /*   25892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25948 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25950 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25957 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25981 */     GIR_RootConstrainSelectedInstOperands,
     /*   25982 */     // GIR_Coverage, 70838,
     /*   25982 */     GIR_EraseRootFromParent_Done,
     /*   25983 */   // Label 491: @25983
     /*   25983 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(26079), // Rule ID 70839 //
     /*   25988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26025 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26044 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26053 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26077 */     GIR_RootConstrainSelectedInstOperands,
     /*   26078 */     // GIR_Coverage, 70839,
     /*   26078 */     GIR_EraseRootFromParent_Done,
     /*   26079 */   // Label 492: @26079
     /*   26079 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26175), // Rule ID 52096 //
     /*   26084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26121 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26140 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26149 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26173 */     GIR_RootConstrainSelectedInstOperands,
     /*   26174 */     // GIR_Coverage, 52096,
     /*   26174 */     GIR_EraseRootFromParent_Done,
     /*   26175 */   // Label 493: @26175
     /*   26175 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26271), // Rule ID 52097 //
     /*   26180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26236 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26238 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26245 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26269 */     GIR_RootConstrainSelectedInstOperands,
     /*   26270 */     // GIR_Coverage, 52097,
     /*   26270 */     GIR_EraseRootFromParent_Done,
     /*   26271 */   // Label 494: @26271
     /*   26271 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26360), // Rule ID 46696 //
     /*   26276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26319 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26358 */     GIR_RootConstrainSelectedInstOperands,
     /*   26359 */     // GIR_Coverage, 46696,
     /*   26359 */     GIR_EraseRootFromParent_Done,
     /*   26360 */   // Label 495: @26360
     /*   26360 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26449), // Rule ID 46697 //
     /*   26365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26408 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26447 */     GIR_RootConstrainSelectedInstOperands,
     /*   26448 */     // GIR_Coverage, 46697,
     /*   26448 */     GIR_EraseRootFromParent_Done,
     /*   26449 */   // Label 496: @26449
     /*   26449 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26538), // Rule ID 46460 //
     /*   26454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26497 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26536 */     GIR_RootConstrainSelectedInstOperands,
     /*   26537 */     // GIR_Coverage, 46460,
     /*   26537 */     GIR_EraseRootFromParent_Done,
     /*   26538 */   // Label 497: @26538
     /*   26538 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26627), // Rule ID 46461 //
     /*   26543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26586 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26625 */     GIR_RootConstrainSelectedInstOperands,
     /*   26626 */     // GIR_Coverage, 46461,
     /*   26626 */     GIR_EraseRootFromParent_Done,
     /*   26627 */   // Label 498: @26627
     /*   26627 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26716), // Rule ID 46576 //
     /*   26632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26666 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26675 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26714 */     GIR_RootConstrainSelectedInstOperands,
     /*   26715 */     // GIR_Coverage, 46576,
     /*   26715 */     GIR_EraseRootFromParent_Done,
     /*   26716 */   // Label 499: @26716
     /*   26716 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26805), // Rule ID 46577 //
     /*   26721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26764 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26803 */     GIR_RootConstrainSelectedInstOperands,
     /*   26804 */     // GIR_Coverage, 46577,
     /*   26804 */     GIR_EraseRootFromParent_Done,
     /*   26805 */   // Label 500: @26805
     /*   26805 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26873), // Rule ID 70408 //
     /*   26810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26847 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26871 */     GIR_RootConstrainSelectedInstOperands,
     /*   26872 */     // GIR_Coverage, 70408,
     /*   26872 */     GIR_EraseRootFromParent_Done,
     /*   26873 */   // Label 501: @26873
     /*   26873 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26941), // Rule ID 70409 //
     /*   26878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26915 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26939 */     GIR_RootConstrainSelectedInstOperands,
     /*   26940 */     // GIR_Coverage, 70409,
     /*   26940 */     GIR_EraseRootFromParent_Done,
     /*   26941 */   // Label 502: @26941
     /*   26941 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(26996), // Rule ID 69388 //
     /*   26946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26974 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   26977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26994 */     GIR_RootConstrainSelectedInstOperands,
     /*   26995 */     // GIR_Coverage, 69388,
     /*   26995 */     GIR_EraseRootFromParent_Done,
     /*   26996 */   // Label 503: @26996
     /*   26996 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27051), // Rule ID 69389 //
     /*   27001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27029 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27049 */     GIR_RootConstrainSelectedInstOperands,
     /*   27050 */     // GIR_Coverage, 69389,
     /*   27050 */     GIR_EraseRootFromParent_Done,
     /*   27051 */   // Label 504: @27051
     /*   27051 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27106), // Rule ID 69208 //
     /*   27056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27084 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27104 */     GIR_RootConstrainSelectedInstOperands,
     /*   27105 */     // GIR_Coverage, 69208,
     /*   27105 */     GIR_EraseRootFromParent_Done,
     /*   27106 */   // Label 505: @27106
     /*   27106 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27161), // Rule ID 69209 //
     /*   27111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27139 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27159 */     GIR_RootConstrainSelectedInstOperands,
     /*   27160 */     // GIR_Coverage, 69209,
     /*   27160 */     GIR_EraseRootFromParent_Done,
     /*   27161 */   // Label 506: @27161
     /*   27161 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27216), // Rule ID 69298 //
     /*   27166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27194 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27214 */     GIR_RootConstrainSelectedInstOperands,
     /*   27215 */     // GIR_Coverage, 69298,
     /*   27215 */     GIR_EraseRootFromParent_Done,
     /*   27216 */   // Label 507: @27216
     /*   27216 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27271), // Rule ID 69299 //
     /*   27221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27249 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27269 */     GIR_RootConstrainSelectedInstOperands,
     /*   27270 */     // GIR_Coverage, 69299,
     /*   27270 */     GIR_EraseRootFromParent_Done,
     /*   27271 */   // Label 508: @27271
     /*   27271 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27339), // Rule ID 51882 //
     /*   27276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27313 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27337 */     GIR_RootConstrainSelectedInstOperands,
     /*   27338 */     // GIR_Coverage, 51882,
     /*   27338 */     GIR_EraseRootFromParent_Done,
     /*   27339 */   // Label 509: @27339
     /*   27339 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27407), // Rule ID 51883 //
     /*   27344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27381 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27405 */     GIR_RootConstrainSelectedInstOperands,
     /*   27406 */     // GIR_Coverage, 51883,
     /*   27406 */     GIR_EraseRootFromParent_Done,
     /*   27407 */   // Label 510: @27407
     /*   27407 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27462), // Rule ID 46756 //
     /*   27412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27440 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27460 */     GIR_RootConstrainSelectedInstOperands,
     /*   27461 */     // GIR_Coverage, 46756,
     /*   27461 */     GIR_EraseRootFromParent_Done,
     /*   27462 */   // Label 511: @27462
     /*   27462 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27517), // Rule ID 46757 //
     /*   27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27495 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27515 */     GIR_RootConstrainSelectedInstOperands,
     /*   27516 */     // GIR_Coverage, 46757,
     /*   27516 */     GIR_EraseRootFromParent_Done,
     /*   27517 */   // Label 512: @27517
     /*   27517 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27572), // Rule ID 46516 //
     /*   27522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27550 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27570 */     GIR_RootConstrainSelectedInstOperands,
     /*   27571 */     // GIR_Coverage, 46516,
     /*   27571 */     GIR_EraseRootFromParent_Done,
     /*   27572 */   // Label 513: @27572
     /*   27572 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27627), // Rule ID 46517 //
     /*   27577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27605 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27625 */     GIR_RootConstrainSelectedInstOperands,
     /*   27626 */     // GIR_Coverage, 46517,
     /*   27626 */     GIR_EraseRootFromParent_Done,
     /*   27627 */   // Label 514: @27627
     /*   27627 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27682), // Rule ID 46636 //
     /*   27632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27660 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27680 */     GIR_RootConstrainSelectedInstOperands,
     /*   27681 */     // GIR_Coverage, 46636,
     /*   27681 */     GIR_EraseRootFromParent_Done,
     /*   27682 */   // Label 515: @27682
     /*   27682 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27737), // Rule ID 46637 //
     /*   27687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27715 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27735 */     GIR_RootConstrainSelectedInstOperands,
     /*   27736 */     // GIR_Coverage, 46637,
     /*   27736 */     GIR_EraseRootFromParent_Done,
     /*   27737 */   // Label 516: @27737
     /*   27737 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27790), // Rule ID 46114 //
     /*   27742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27753 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   27753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27788 */     GIR_RootConstrainSelectedInstOperands,
     /*   27789 */     // GIR_Coverage, 46114,
     /*   27789 */     GIR_EraseRootFromParent_Done,
     /*   27790 */   // Label 517: @27790
     /*   27790 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27843), // Rule ID 46115 //
     /*   27795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27806 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   27806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27841 */     GIR_RootConstrainSelectedInstOperands,
     /*   27842 */     // GIR_Coverage, 46115,
     /*   27842 */     GIR_EraseRootFromParent_Done,
     /*   27843 */   // Label 518: @27843
     /*   27843 */   GIM_Reject,
     /*   27844 */ // Label 478: @27844
     /*   27844 */ GIM_Reject,
     /*   27845 */ // Label 135: @27845
     /*   27845 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(30969),
     /*   27850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27860 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(27956), // Rule ID 70586 //
     /*   27865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   27868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27930 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   27933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27954 */     GIR_RootConstrainSelectedInstOperands,
     /*   27955 */     // GIR_Coverage, 70586,
     /*   27955 */     GIR_EraseRootFromParent_Done,
     /*   27956 */   // Label 520: @27956
     /*   27956 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28052), // Rule ID 70587 //
     /*   27961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   27964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28026 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28050 */     GIR_RootConstrainSelectedInstOperands,
     /*   28051 */     // GIR_Coverage, 70587,
     /*   28051 */     GIR_EraseRootFromParent_Done,
     /*   28052 */   // Label 521: @28052
     /*   28052 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28148), // Rule ID 70870 //
     /*   28057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28122 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28146 */     GIR_RootConstrainSelectedInstOperands,
     /*   28147 */     // GIR_Coverage, 70870,
     /*   28147 */     GIR_EraseRootFromParent_Done,
     /*   28148 */   // Label 522: @28148
     /*   28148 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28244), // Rule ID 70871 //
     /*   28153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28201 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28205 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28207 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28218 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28242 */     GIR_RootConstrainSelectedInstOperands,
     /*   28243 */     // GIR_Coverage, 70871,
     /*   28243 */     GIR_EraseRootFromParent_Done,
     /*   28244 */   // Label 523: @28244
     /*   28244 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28340), // Rule ID 70872 //
     /*   28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28282 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28301 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28314 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28338 */     GIR_RootConstrainSelectedInstOperands,
     /*   28339 */     // GIR_Coverage, 70872,
     /*   28339 */     GIR_EraseRootFromParent_Done,
     /*   28340 */   // Label 524: @28340
     /*   28340 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(28436), // Rule ID 70873 //
     /*   28345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28378 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28397 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28399 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28410 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28434 */     GIR_RootConstrainSelectedInstOperands,
     /*   28435 */     // GIR_Coverage, 70873,
     /*   28435 */     GIR_EraseRootFromParent_Done,
     /*   28436 */   // Label 525: @28436
     /*   28436 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28532), // Rule ID 70700 //
     /*   28441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28460 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28493 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28506 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28530 */     GIR_RootConstrainSelectedInstOperands,
     /*   28531 */     // GIR_Coverage, 70700,
     /*   28531 */     GIR_EraseRootFromParent_Done,
     /*   28532 */   // Label 526: @28532
     /*   28532 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28628), // Rule ID 70701 //
     /*   28537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28570 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28589 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28591 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28602 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28626 */     GIR_RootConstrainSelectedInstOperands,
     /*   28627 */     // GIR_Coverage, 70701,
     /*   28627 */     GIR_EraseRootFromParent_Done,
     /*   28628 */   // Label 527: @28628
     /*   28628 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28724), // Rule ID 52048 //
     /*   28633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28698 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28722 */     GIR_RootConstrainSelectedInstOperands,
     /*   28723 */     // GIR_Coverage, 52048,
     /*   28723 */     GIR_EraseRootFromParent_Done,
     /*   28724 */   // Label 528: @28724
     /*   28724 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28820), // Rule ID 52049 //
     /*   28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28794 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28818 */     GIR_RootConstrainSelectedInstOperands,
     /*   28819 */     // GIR_Coverage, 52049,
     /*   28819 */     GIR_EraseRootFromParent_Done,
     /*   28820 */   // Label 529: @28820
     /*   28820 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28916), // Rule ID 52166 //
     /*   28825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28890 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28914 */     GIR_RootConstrainSelectedInstOperands,
     /*   28915 */     // GIR_Coverage, 52166,
     /*   28915 */     GIR_EraseRootFromParent_Done,
     /*   28916 */   // Label 530: @28916
     /*   28916 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(29012), // Rule ID 52167 //
     /*   28921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28986 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29010 */     GIR_RootConstrainSelectedInstOperands,
     /*   29011 */     // GIR_Coverage, 52167,
     /*   29011 */     GIR_EraseRootFromParent_Done,
     /*   29012 */   // Label 531: @29012
     /*   29012 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29108), // Rule ID 70868 //
     /*   29017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29082 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29106 */     GIR_RootConstrainSelectedInstOperands,
     /*   29107 */     // GIR_Coverage, 70868,
     /*   29107 */     GIR_EraseRootFromParent_Done,
     /*   29108 */   // Label 532: @29108
     /*   29108 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29204), // Rule ID 70869 //
     /*   29113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29178 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29202 */     GIR_RootConstrainSelectedInstOperands,
     /*   29203 */     // GIR_Coverage, 70869,
     /*   29203 */     GIR_EraseRootFromParent_Done,
     /*   29204 */   // Label 533: @29204
     /*   29204 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29300), // Rule ID 52106 //
     /*   29209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29274 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29298 */     GIR_RootConstrainSelectedInstOperands,
     /*   29299 */     // GIR_Coverage, 52106,
     /*   29299 */     GIR_EraseRootFromParent_Done,
     /*   29300 */   // Label 534: @29300
     /*   29300 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29396), // Rule ID 52107 //
     /*   29305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29370 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29394 */     GIR_RootConstrainSelectedInstOperands,
     /*   29395 */     // GIR_Coverage, 52107,
     /*   29395 */     GIR_EraseRootFromParent_Done,
     /*   29396 */   // Label 535: @29396
     /*   29396 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29485), // Rule ID 46716 //
     /*   29401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29435 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29444 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29483 */     GIR_RootConstrainSelectedInstOperands,
     /*   29484 */     // GIR_Coverage, 46716,
     /*   29484 */     GIR_EraseRootFromParent_Done,
     /*   29485 */   // Label 536: @29485
     /*   29485 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29574), // Rule ID 46717 //
     /*   29490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29505 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29524 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29533 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29572 */     GIR_RootConstrainSelectedInstOperands,
     /*   29573 */     // GIR_Coverage, 46717,
     /*   29573 */     GIR_EraseRootFromParent_Done,
     /*   29574 */   // Label 537: @29574
     /*   29574 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29663), // Rule ID 46480 //
     /*   29579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29613 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29622 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29661 */     GIR_RootConstrainSelectedInstOperands,
     /*   29662 */     // GIR_Coverage, 46480,
     /*   29662 */     GIR_EraseRootFromParent_Done,
     /*   29663 */   // Label 538: @29663
     /*   29663 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29752), // Rule ID 46481 //
     /*   29668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29702 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29711 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29750 */     GIR_RootConstrainSelectedInstOperands,
     /*   29751 */     // GIR_Coverage, 46481,
     /*   29751 */     GIR_EraseRootFromParent_Done,
     /*   29752 */   // Label 539: @29752
     /*   29752 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29841), // Rule ID 46596 //
     /*   29757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29791 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29800 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29839 */     GIR_RootConstrainSelectedInstOperands,
     /*   29840 */     // GIR_Coverage, 46596,
     /*   29840 */     GIR_EraseRootFromParent_Done,
     /*   29841 */   // Label 540: @29841
     /*   29841 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29930), // Rule ID 46597 //
     /*   29846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29880 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29889 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29928 */     GIR_RootConstrainSelectedInstOperands,
     /*   29929 */     // GIR_Coverage, 46597,
     /*   29929 */     GIR_EraseRootFromParent_Done,
     /*   29930 */   // Label 541: @29930
     /*   29930 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29998), // Rule ID 70496 //
     /*   29935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   29938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29972 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   29972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   29975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   29993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29996 */     GIR_RootConstrainSelectedInstOperands,
     /*   29997 */     // GIR_Coverage, 70496,
     /*   29997 */     GIR_EraseRootFromParent_Done,
     /*   29998 */   // Label 542: @29998
     /*   29998 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30066), // Rule ID 70497 //
     /*   30003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30040 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30064 */     GIR_RootConstrainSelectedInstOperands,
     /*   30065 */     // GIR_Coverage, 70497,
     /*   30065 */     GIR_EraseRootFromParent_Done,
     /*   30066 */   // Label 543: @30066
     /*   30066 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30121), // Rule ID 69408 //
     /*   30071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30099 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30119 */     GIR_RootConstrainSelectedInstOperands,
     /*   30120 */     // GIR_Coverage, 69408,
     /*   30120 */     GIR_EraseRootFromParent_Done,
     /*   30121 */   // Label 544: @30121
     /*   30121 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30176), // Rule ID 69409 //
     /*   30126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30154 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30174 */     GIR_RootConstrainSelectedInstOperands,
     /*   30175 */     // GIR_Coverage, 69409,
     /*   30175 */     GIR_EraseRootFromParent_Done,
     /*   30176 */   // Label 545: @30176
     /*   30176 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30231), // Rule ID 69228 //
     /*   30181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30209 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30229 */     GIR_RootConstrainSelectedInstOperands,
     /*   30230 */     // GIR_Coverage, 69228,
     /*   30230 */     GIR_EraseRootFromParent_Done,
     /*   30231 */   // Label 546: @30231
     /*   30231 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30286), // Rule ID 69229 //
     /*   30236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30264 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30284 */     GIR_RootConstrainSelectedInstOperands,
     /*   30285 */     // GIR_Coverage, 69229,
     /*   30285 */     GIR_EraseRootFromParent_Done,
     /*   30286 */   // Label 547: @30286
     /*   30286 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30341), // Rule ID 69318 //
     /*   30291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30319 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30339 */     GIR_RootConstrainSelectedInstOperands,
     /*   30340 */     // GIR_Coverage, 69318,
     /*   30340 */     GIR_EraseRootFromParent_Done,
     /*   30341 */   // Label 548: @30341
     /*   30341 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30396), // Rule ID 69319 //
     /*   30346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30374 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30394 */     GIR_RootConstrainSelectedInstOperands,
     /*   30395 */     // GIR_Coverage, 69319,
     /*   30395 */     GIR_EraseRootFromParent_Done,
     /*   30396 */   // Label 549: @30396
     /*   30396 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30464), // Rule ID 51926 //
     /*   30401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30438 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30462 */     GIR_RootConstrainSelectedInstOperands,
     /*   30463 */     // GIR_Coverage, 51926,
     /*   30463 */     GIR_EraseRootFromParent_Done,
     /*   30464 */   // Label 550: @30464
     /*   30464 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30532), // Rule ID 51927 //
     /*   30469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30506 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30530 */     GIR_RootConstrainSelectedInstOperands,
     /*   30531 */     // GIR_Coverage, 51927,
     /*   30531 */     GIR_EraseRootFromParent_Done,
     /*   30532 */   // Label 551: @30532
     /*   30532 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30587), // Rule ID 46776 //
     /*   30537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30565 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30585 */     GIR_RootConstrainSelectedInstOperands,
     /*   30586 */     // GIR_Coverage, 46776,
     /*   30586 */     GIR_EraseRootFromParent_Done,
     /*   30587 */   // Label 552: @30587
     /*   30587 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30642), // Rule ID 46777 //
     /*   30592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30620 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30640 */     GIR_RootConstrainSelectedInstOperands,
     /*   30641 */     // GIR_Coverage, 46777,
     /*   30641 */     GIR_EraseRootFromParent_Done,
     /*   30642 */   // Label 553: @30642
     /*   30642 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30697), // Rule ID 46536 //
     /*   30647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30675 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30695 */     GIR_RootConstrainSelectedInstOperands,
     /*   30696 */     // GIR_Coverage, 46536,
     /*   30696 */     GIR_EraseRootFromParent_Done,
     /*   30697 */   // Label 554: @30697
     /*   30697 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30752), // Rule ID 46537 //
     /*   30702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30730 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30750 */     GIR_RootConstrainSelectedInstOperands,
     /*   30751 */     // GIR_Coverage, 46537,
     /*   30751 */     GIR_EraseRootFromParent_Done,
     /*   30752 */   // Label 555: @30752
     /*   30752 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30807), // Rule ID 46656 //
     /*   30757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30785 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30805 */     GIR_RootConstrainSelectedInstOperands,
     /*   30806 */     // GIR_Coverage, 46656,
     /*   30806 */     GIR_EraseRootFromParent_Done,
     /*   30807 */   // Label 556: @30807
     /*   30807 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30862), // Rule ID 46657 //
     /*   30812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30840 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30860 */     GIR_RootConstrainSelectedInstOperands,
     /*   30861 */     // GIR_Coverage, 46657,
     /*   30861 */     GIR_EraseRootFromParent_Done,
     /*   30862 */   // Label 557: @30862
     /*   30862 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(30915), // Rule ID 46158 //
     /*   30867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30878 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   30878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30913 */     GIR_RootConstrainSelectedInstOperands,
     /*   30914 */     // GIR_Coverage, 46158,
     /*   30914 */     GIR_EraseRootFromParent_Done,
     /*   30915 */   // Label 558: @30915
     /*   30915 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(30968), // Rule ID 46159 //
     /*   30920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30931 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   30931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30966 */     GIR_RootConstrainSelectedInstOperands,
     /*   30967 */     // GIR_Coverage, 46159,
     /*   30967 */     GIR_EraseRootFromParent_Done,
     /*   30968 */   // Label 559: @30968
     /*   30968 */   GIM_Reject,
     /*   30969 */ // Label 519: @30969
     /*   30969 */ GIM_Reject,
     /*   30970 */ // Label 136: @30970
     /*   30970 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31364),
     /*   30975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   30981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30985 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31053), // Rule ID 70360 //
     /*   30990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31027 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31051 */     GIR_RootConstrainSelectedInstOperands,
     /*   31052 */     // GIR_Coverage, 70360,
     /*   31052 */     GIR_EraseRootFromParent_Done,
     /*   31053 */   // Label 561: @31053
     /*   31053 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31121), // Rule ID 70361 //
     /*   31058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31095 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31119 */     GIR_RootConstrainSelectedInstOperands,
     /*   31120 */     // GIR_Coverage, 70361,
     /*   31120 */     GIR_EraseRootFromParent_Done,
     /*   31121 */   // Label 562: @31121
     /*   31121 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31189), // Rule ID 51858 //
     /*   31126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31163 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31187 */     GIR_RootConstrainSelectedInstOperands,
     /*   31188 */     // GIR_Coverage, 51858,
     /*   31188 */     GIR_EraseRootFromParent_Done,
     /*   31189 */   // Label 563: @31189
     /*   31189 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31257), // Rule ID 51859 //
     /*   31194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31231 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31255 */     GIR_RootConstrainSelectedInstOperands,
     /*   31256 */     // GIR_Coverage, 51859,
     /*   31256 */     GIR_EraseRootFromParent_Done,
     /*   31257 */   // Label 564: @31257
     /*   31257 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31310), // Rule ID 46090 //
     /*   31262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31273 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31308 */     GIR_RootConstrainSelectedInstOperands,
     /*   31309 */     // GIR_Coverage, 46090,
     /*   31309 */     GIR_EraseRootFromParent_Done,
     /*   31310 */   // Label 565: @31310
     /*   31310 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31363), // Rule ID 46091 //
     /*   31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31326 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31361 */     GIR_RootConstrainSelectedInstOperands,
     /*   31362 */     // GIR_Coverage, 46091,
     /*   31362 */     GIR_EraseRootFromParent_Done,
     /*   31363 */   // Label 566: @31363
     /*   31363 */   GIM_Reject,
     /*   31364 */ // Label 560: @31364
     /*   31364 */ GIM_Reject,
     /*   31365 */ // Label 137: @31365
     /*   31365 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34489),
     /*   31370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31380 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31476), // Rule ID 70566 //
     /*   31385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31437 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31439 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31450 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31474 */     GIR_RootConstrainSelectedInstOperands,
     /*   31475 */     // GIR_Coverage, 70566,
     /*   31475 */     GIR_EraseRootFromParent_Done,
     /*   31476 */   // Label 568: @31476
     /*   31476 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31572), // Rule ID 70567 //
     /*   31481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31514 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31529 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31533 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31546 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31570 */     GIR_RootConstrainSelectedInstOperands,
     /*   31571 */     // GIR_Coverage, 70567,
     /*   31571 */     GIR_EraseRootFromParent_Done,
     /*   31572 */   // Label 569: @31572
     /*   31572 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31668), // Rule ID 70810 //
     /*   31577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31625 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31629 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31642 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31666 */     GIR_RootConstrainSelectedInstOperands,
     /*   31667 */     // GIR_Coverage, 70810,
     /*   31667 */     GIR_EraseRootFromParent_Done,
     /*   31668 */   // Label 570: @31668
     /*   31668 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31764), // Rule ID 70811 //
     /*   31673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31692 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31725 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31738 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31762 */     GIR_RootConstrainSelectedInstOperands,
     /*   31763 */     // GIR_Coverage, 70811,
     /*   31763 */     GIR_EraseRootFromParent_Done,
     /*   31764 */   // Label 571: @31764
     /*   31764 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31860), // Rule ID 70812 //
     /*   31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31802 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31821 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31834 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31858 */     GIR_RootConstrainSelectedInstOperands,
     /*   31859 */     // GIR_Coverage, 70812,
     /*   31859 */     GIR_EraseRootFromParent_Done,
     /*   31860 */   // Label 572: @31860
     /*   31860 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(31956), // Rule ID 70813 //
     /*   31865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31930 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31954 */     GIR_RootConstrainSelectedInstOperands,
     /*   31955 */     // GIR_Coverage, 70813,
     /*   31955 */     GIR_EraseRootFromParent_Done,
     /*   31956 */   // Label 573: @31956
     /*   31956 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(32052), // Rule ID 70680 //
     /*   31961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32026 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32050 */     GIR_RootConstrainSelectedInstOperands,
     /*   32051 */     // GIR_Coverage, 70680,
     /*   32051 */     GIR_EraseRootFromParent_Done,
     /*   32052 */   // Label 574: @32052
     /*   32052 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32148), // Rule ID 70681 //
     /*   32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32122 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32146 */     GIR_RootConstrainSelectedInstOperands,
     /*   32147 */     // GIR_Coverage, 70681,
     /*   32147 */     GIR_EraseRootFromParent_Done,
     /*   32148 */   // Label 575: @32148
     /*   32148 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32244), // Rule ID 52028 //
     /*   32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32190 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32209 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32218 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32242 */     GIR_RootConstrainSelectedInstOperands,
     /*   32243 */     // GIR_Coverage, 52028,
     /*   32243 */     GIR_EraseRootFromParent_Done,
     /*   32244 */   // Label 576: @32244
     /*   32244 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32340), // Rule ID 52029 //
     /*   32249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32286 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32305 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32307 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32314 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32338 */     GIR_RootConstrainSelectedInstOperands,
     /*   32339 */     // GIR_Coverage, 52029,
     /*   32339 */     GIR_EraseRootFromParent_Done,
     /*   32340 */   // Label 577: @32340
     /*   32340 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32436), // Rule ID 52146 //
     /*   32345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32401 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32410 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32434 */     GIR_RootConstrainSelectedInstOperands,
     /*   32435 */     // GIR_Coverage, 52146,
     /*   32435 */     GIR_EraseRootFromParent_Done,
     /*   32436 */   // Label 578: @32436
     /*   32436 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32532), // Rule ID 52147 //
     /*   32441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32497 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32506 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32530 */     GIR_RootConstrainSelectedInstOperands,
     /*   32531 */     // GIR_Coverage, 52147,
     /*   32531 */     GIR_EraseRootFromParent_Done,
     /*   32532 */   // Label 579: @32532
     /*   32532 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32628), // Rule ID 70808 //
     /*   32537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32574 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32593 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32602 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32626 */     GIR_RootConstrainSelectedInstOperands,
     /*   32627 */     // GIR_Coverage, 70808,
     /*   32627 */     GIR_EraseRootFromParent_Done,
     /*   32628 */   // Label 580: @32628
     /*   32628 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32724), // Rule ID 70809 //
     /*   32633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32698 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32722 */     GIR_RootConstrainSelectedInstOperands,
     /*   32723 */     // GIR_Coverage, 70809,
     /*   32723 */     GIR_EraseRootFromParent_Done,
     /*   32724 */   // Label 581: @32724
     /*   32724 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32820), // Rule ID 52086 //
     /*   32729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32794 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32818 */     GIR_RootConstrainSelectedInstOperands,
     /*   32819 */     // GIR_Coverage, 52086,
     /*   32819 */     GIR_EraseRootFromParent_Done,
     /*   32820 */   // Label 582: @32820
     /*   32820 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32916), // Rule ID 52087 //
     /*   32825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32890 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32914 */     GIR_RootConstrainSelectedInstOperands,
     /*   32915 */     // GIR_Coverage, 52087,
     /*   32915 */     GIR_EraseRootFromParent_Done,
     /*   32916 */   // Label 583: @32916
     /*   32916 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(33005), // Rule ID 46676 //
     /*   32921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32955 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32964 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   32964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   32967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   32981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33003 */     GIR_RootConstrainSelectedInstOperands,
     /*   33004 */     // GIR_Coverage, 46676,
     /*   33004 */     GIR_EraseRootFromParent_Done,
     /*   33005 */   // Label 584: @33005
     /*   33005 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33094), // Rule ID 46677 //
     /*   33010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33025 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33044 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33053 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33092 */     GIR_RootConstrainSelectedInstOperands,
     /*   33093 */     // GIR_Coverage, 46677,
     /*   33093 */     GIR_EraseRootFromParent_Done,
     /*   33094 */   // Label 585: @33094
     /*   33094 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33183), // Rule ID 46440 //
     /*   33099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33133 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33142 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33181 */     GIR_RootConstrainSelectedInstOperands,
     /*   33182 */     // GIR_Coverage, 46440,
     /*   33182 */     GIR_EraseRootFromParent_Done,
     /*   33183 */   // Label 586: @33183
     /*   33183 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33272), // Rule ID 46441 //
     /*   33188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33222 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33231 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33270 */     GIR_RootConstrainSelectedInstOperands,
     /*   33271 */     // GIR_Coverage, 46441,
     /*   33271 */     GIR_EraseRootFromParent_Done,
     /*   33272 */   // Label 587: @33272
     /*   33272 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33361), // Rule ID 46556 //
     /*   33277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33311 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33320 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33359 */     GIR_RootConstrainSelectedInstOperands,
     /*   33360 */     // GIR_Coverage, 46556,
     /*   33360 */     GIR_EraseRootFromParent_Done,
     /*   33361 */   // Label 588: @33361
     /*   33361 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33450), // Rule ID 46557 //
     /*   33366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33400 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33409 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33448 */     GIR_RootConstrainSelectedInstOperands,
     /*   33449 */     // GIR_Coverage, 46557,
     /*   33449 */     GIR_EraseRootFromParent_Done,
     /*   33450 */   // Label 589: @33450
     /*   33450 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33518), // Rule ID 70400 //
     /*   33455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33492 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33516 */     GIR_RootConstrainSelectedInstOperands,
     /*   33517 */     // GIR_Coverage, 70400,
     /*   33517 */     GIR_EraseRootFromParent_Done,
     /*   33518 */   // Label 590: @33518
     /*   33518 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33586), // Rule ID 70401 //
     /*   33523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33560 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33584 */     GIR_RootConstrainSelectedInstOperands,
     /*   33585 */     // GIR_Coverage, 70401,
     /*   33585 */     GIR_EraseRootFromParent_Done,
     /*   33586 */   // Label 591: @33586
     /*   33586 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33641), // Rule ID 69368 //
     /*   33591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33619 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33639 */     GIR_RootConstrainSelectedInstOperands,
     /*   33640 */     // GIR_Coverage, 69368,
     /*   33640 */     GIR_EraseRootFromParent_Done,
     /*   33641 */   // Label 592: @33641
     /*   33641 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33696), // Rule ID 69369 //
     /*   33646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33674 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33694 */     GIR_RootConstrainSelectedInstOperands,
     /*   33695 */     // GIR_Coverage, 69369,
     /*   33695 */     GIR_EraseRootFromParent_Done,
     /*   33696 */   // Label 593: @33696
     /*   33696 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33751), // Rule ID 69188 //
     /*   33701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33729 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33749 */     GIR_RootConstrainSelectedInstOperands,
     /*   33750 */     // GIR_Coverage, 69188,
     /*   33750 */     GIR_EraseRootFromParent_Done,
     /*   33751 */   // Label 594: @33751
     /*   33751 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33806), // Rule ID 69189 //
     /*   33756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33784 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33804 */     GIR_RootConstrainSelectedInstOperands,
     /*   33805 */     // GIR_Coverage, 69189,
     /*   33805 */     GIR_EraseRootFromParent_Done,
     /*   33806 */   // Label 595: @33806
     /*   33806 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33861), // Rule ID 69278 //
     /*   33811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33839 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33859 */     GIR_RootConstrainSelectedInstOperands,
     /*   33860 */     // GIR_Coverage, 69278,
     /*   33860 */     GIR_EraseRootFromParent_Done,
     /*   33861 */   // Label 596: @33861
     /*   33861 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(33916), // Rule ID 69279 //
     /*   33866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33894 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33914 */     GIR_RootConstrainSelectedInstOperands,
     /*   33915 */     // GIR_Coverage, 69279,
     /*   33915 */     GIR_EraseRootFromParent_Done,
     /*   33916 */   // Label 597: @33916
     /*   33916 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(33984), // Rule ID 51878 //
     /*   33921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33958 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33982 */     GIR_RootConstrainSelectedInstOperands,
     /*   33983 */     // GIR_Coverage, 51878,
     /*   33983 */     GIR_EraseRootFromParent_Done,
     /*   33984 */   // Label 598: @33984
     /*   33984 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34052), // Rule ID 51879 //
     /*   33989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34026 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34050 */     GIR_RootConstrainSelectedInstOperands,
     /*   34051 */     // GIR_Coverage, 51879,
     /*   34051 */     GIR_EraseRootFromParent_Done,
     /*   34052 */   // Label 599: @34052
     /*   34052 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34107), // Rule ID 46736 //
     /*   34057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34085 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34105 */     GIR_RootConstrainSelectedInstOperands,
     /*   34106 */     // GIR_Coverage, 46736,
     /*   34106 */     GIR_EraseRootFromParent_Done,
     /*   34107 */   // Label 600: @34107
     /*   34107 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34162), // Rule ID 46737 //
     /*   34112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34140 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34160 */     GIR_RootConstrainSelectedInstOperands,
     /*   34161 */     // GIR_Coverage, 46737,
     /*   34161 */     GIR_EraseRootFromParent_Done,
     /*   34162 */   // Label 601: @34162
     /*   34162 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34217), // Rule ID 46496 //
     /*   34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34195 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34215 */     GIR_RootConstrainSelectedInstOperands,
     /*   34216 */     // GIR_Coverage, 46496,
     /*   34216 */     GIR_EraseRootFromParent_Done,
     /*   34217 */   // Label 602: @34217
     /*   34217 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34272), // Rule ID 46497 //
     /*   34222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34250 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34270 */     GIR_RootConstrainSelectedInstOperands,
     /*   34271 */     // GIR_Coverage, 46497,
     /*   34271 */     GIR_EraseRootFromParent_Done,
     /*   34272 */   // Label 603: @34272
     /*   34272 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34327), // Rule ID 46616 //
     /*   34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34305 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34325 */     GIR_RootConstrainSelectedInstOperands,
     /*   34326 */     // GIR_Coverage, 46616,
     /*   34326 */     GIR_EraseRootFromParent_Done,
     /*   34327 */   // Label 604: @34327
     /*   34327 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34382), // Rule ID 46617 //
     /*   34332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34360 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34380 */     GIR_RootConstrainSelectedInstOperands,
     /*   34381 */     // GIR_Coverage, 46617,
     /*   34381 */     GIR_EraseRootFromParent_Done,
     /*   34382 */   // Label 605: @34382
     /*   34382 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34435), // Rule ID 46110 //
     /*   34387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34398 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34433 */     GIR_RootConstrainSelectedInstOperands,
     /*   34434 */     // GIR_Coverage, 46110,
     /*   34434 */     GIR_EraseRootFromParent_Done,
     /*   34435 */   // Label 606: @34435
     /*   34435 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34488), // Rule ID 46111 //
     /*   34440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34451 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34486 */     GIR_RootConstrainSelectedInstOperands,
     /*   34487 */     // GIR_Coverage, 46111,
     /*   34487 */     GIR_EraseRootFromParent_Done,
     /*   34488 */   // Label 607: @34488
     /*   34488 */   GIM_Reject,
     /*   34489 */ // Label 567: @34489
     /*   34489 */ GIM_Reject,
     /*   34490 */ // Label 138: @34490
     /*   34490 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37614),
     /*   34495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34505 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34601), // Rule ID 70578 //
     /*   34510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34562 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34564 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34575 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34599 */     GIR_RootConstrainSelectedInstOperands,
     /*   34600 */     // GIR_Coverage, 70578,
     /*   34600 */     GIR_EraseRootFromParent_Done,
     /*   34601 */   // Label 609: @34601
     /*   34601 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34697), // Rule ID 70579 //
     /*   34606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34658 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34660 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34671 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34695 */     GIR_RootConstrainSelectedInstOperands,
     /*   34696 */     // GIR_Coverage, 70579,
     /*   34696 */     GIR_EraseRootFromParent_Done,
     /*   34697 */   // Label 610: @34697
     /*   34697 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34793), // Rule ID 70846 //
     /*   34702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34754 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34767 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34791 */     GIR_RootConstrainSelectedInstOperands,
     /*   34792 */     // GIR_Coverage, 70846,
     /*   34792 */     GIR_EraseRootFromParent_Done,
     /*   34793 */   // Label 611: @34793
     /*   34793 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34889), // Rule ID 70847 //
     /*   34798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34831 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34850 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34852 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34863 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34887 */     GIR_RootConstrainSelectedInstOperands,
     /*   34888 */     // GIR_Coverage, 70847,
     /*   34888 */     GIR_EraseRootFromParent_Done,
     /*   34889 */   // Label 612: @34889
     /*   34889 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34985), // Rule ID 70848 //
     /*   34894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34946 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34948 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34959 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34983 */     GIR_RootConstrainSelectedInstOperands,
     /*   34984 */     // GIR_Coverage, 70848,
     /*   34984 */     GIR_EraseRootFromParent_Done,
     /*   34985 */   // Label 613: @34985
     /*   34985 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(35081), // Rule ID 70849 //
     /*   34990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35023 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35042 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35044 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35055 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35079 */     GIR_RootConstrainSelectedInstOperands,
     /*   35080 */     // GIR_Coverage, 70849,
     /*   35080 */     GIR_EraseRootFromParent_Done,
     /*   35081 */   // Label 614: @35081
     /*   35081 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35177), // Rule ID 70692 //
     /*   35086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35138 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35151 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35175 */     GIR_RootConstrainSelectedInstOperands,
     /*   35176 */     // GIR_Coverage, 70692,
     /*   35176 */     GIR_EraseRootFromParent_Done,
     /*   35177 */   // Label 615: @35177
     /*   35177 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35273), // Rule ID 70693 //
     /*   35182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35234 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35247 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35271 */     GIR_RootConstrainSelectedInstOperands,
     /*   35272 */     // GIR_Coverage, 70693,
     /*   35272 */     GIR_EraseRootFromParent_Done,
     /*   35273 */   // Label 616: @35273
     /*   35273 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35369), // Rule ID 52040 //
     /*   35278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35315 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35334 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35343 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35367 */     GIR_RootConstrainSelectedInstOperands,
     /*   35368 */     // GIR_Coverage, 52040,
     /*   35368 */     GIR_EraseRootFromParent_Done,
     /*   35369 */   // Label 617: @35369
     /*   35369 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35465), // Rule ID 52041 //
     /*   35374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35411 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35430 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35432 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35439 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35463 */     GIR_RootConstrainSelectedInstOperands,
     /*   35464 */     // GIR_Coverage, 52041,
     /*   35464 */     GIR_EraseRootFromParent_Done,
     /*   35465 */   // Label 618: @35465
     /*   35465 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35561), // Rule ID 52158 //
     /*   35470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35522 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35526 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35535 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35559 */     GIR_RootConstrainSelectedInstOperands,
     /*   35560 */     // GIR_Coverage, 52158,
     /*   35560 */     GIR_EraseRootFromParent_Done,
     /*   35561 */   // Label 619: @35561
     /*   35561 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35657), // Rule ID 52159 //
     /*   35566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35631 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35655 */     GIR_RootConstrainSelectedInstOperands,
     /*   35656 */     // GIR_Coverage, 52159,
     /*   35656 */     GIR_EraseRootFromParent_Done,
     /*   35657 */   // Label 620: @35657
     /*   35657 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35753), // Rule ID 70844 //
     /*   35662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35727 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35751 */     GIR_RootConstrainSelectedInstOperands,
     /*   35752 */     // GIR_Coverage, 70844,
     /*   35752 */     GIR_EraseRootFromParent_Done,
     /*   35753 */   // Label 621: @35753
     /*   35753 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35849), // Rule ID 70845 //
     /*   35758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35823 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35847 */     GIR_RootConstrainSelectedInstOperands,
     /*   35848 */     // GIR_Coverage, 70845,
     /*   35848 */     GIR_EraseRootFromParent_Done,
     /*   35849 */   // Label 622: @35849
     /*   35849 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35945), // Rule ID 52098 //
     /*   35854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35919 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35943 */     GIR_RootConstrainSelectedInstOperands,
     /*   35944 */     // GIR_Coverage, 52098,
     /*   35944 */     GIR_EraseRootFromParent_Done,
     /*   35945 */   // Label 623: @35945
     /*   35945 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(36041), // Rule ID 52099 //
     /*   35950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36015 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36039 */     GIR_RootConstrainSelectedInstOperands,
     /*   36040 */     // GIR_Coverage, 52099,
     /*   36040 */     GIR_EraseRootFromParent_Done,
     /*   36041 */   // Label 624: @36041
     /*   36041 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36130), // Rule ID 46700 //
     /*   36046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36080 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36089 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36128 */     GIR_RootConstrainSelectedInstOperands,
     /*   36129 */     // GIR_Coverage, 46700,
     /*   36129 */     GIR_EraseRootFromParent_Done,
     /*   36130 */   // Label 625: @36130
     /*   36130 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36219), // Rule ID 46701 //
     /*   36135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36169 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36178 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36217 */     GIR_RootConstrainSelectedInstOperands,
     /*   36218 */     // GIR_Coverage, 46701,
     /*   36218 */     GIR_EraseRootFromParent_Done,
     /*   36219 */   // Label 626: @36219
     /*   36219 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36308), // Rule ID 46464 //
     /*   36224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36267 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36306 */     GIR_RootConstrainSelectedInstOperands,
     /*   36307 */     // GIR_Coverage, 46464,
     /*   36307 */     GIR_EraseRootFromParent_Done,
     /*   36308 */   // Label 627: @36308
     /*   36308 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36397), // Rule ID 46465 //
     /*   36313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36347 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36356 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36395 */     GIR_RootConstrainSelectedInstOperands,
     /*   36396 */     // GIR_Coverage, 46465,
     /*   36396 */     GIR_EraseRootFromParent_Done,
     /*   36397 */   // Label 628: @36397
     /*   36397 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36486), // Rule ID 46580 //
     /*   36402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36436 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36445 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36484 */     GIR_RootConstrainSelectedInstOperands,
     /*   36485 */     // GIR_Coverage, 46580,
     /*   36485 */     GIR_EraseRootFromParent_Done,
     /*   36486 */   // Label 629: @36486
     /*   36486 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36575), // Rule ID 46581 //
     /*   36491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36525 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36534 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36573 */     GIR_RootConstrainSelectedInstOperands,
     /*   36574 */     // GIR_Coverage, 46581,
     /*   36574 */     GIR_EraseRootFromParent_Done,
     /*   36575 */   // Label 630: @36575
     /*   36575 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36643), // Rule ID 70472 //
     /*   36580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36617 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36641 */     GIR_RootConstrainSelectedInstOperands,
     /*   36642 */     // GIR_Coverage, 70472,
     /*   36642 */     GIR_EraseRootFromParent_Done,
     /*   36643 */   // Label 631: @36643
     /*   36643 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36711), // Rule ID 70473 //
     /*   36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36685 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36709 */     GIR_RootConstrainSelectedInstOperands,
     /*   36710 */     // GIR_Coverage, 70473,
     /*   36710 */     GIR_EraseRootFromParent_Done,
     /*   36711 */   // Label 632: @36711
     /*   36711 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36766), // Rule ID 69392 //
     /*   36716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36744 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36764 */     GIR_RootConstrainSelectedInstOperands,
     /*   36765 */     // GIR_Coverage, 69392,
     /*   36765 */     GIR_EraseRootFromParent_Done,
     /*   36766 */   // Label 633: @36766
     /*   36766 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36821), // Rule ID 69393 //
     /*   36771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36799 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36819 */     GIR_RootConstrainSelectedInstOperands,
     /*   36820 */     // GIR_Coverage, 69393,
     /*   36820 */     GIR_EraseRootFromParent_Done,
     /*   36821 */   // Label 634: @36821
     /*   36821 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36876), // Rule ID 69212 //
     /*   36826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36854 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36874 */     GIR_RootConstrainSelectedInstOperands,
     /*   36875 */     // GIR_Coverage, 69212,
     /*   36875 */     GIR_EraseRootFromParent_Done,
     /*   36876 */   // Label 635: @36876
     /*   36876 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(36931), // Rule ID 69213 //
     /*   36881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36909 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36929 */     GIR_RootConstrainSelectedInstOperands,
     /*   36930 */     // GIR_Coverage, 69213,
     /*   36930 */     GIR_EraseRootFromParent_Done,
     /*   36931 */   // Label 636: @36931
     /*   36931 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(36986), // Rule ID 69302 //
     /*   36936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36964 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36984 */     GIR_RootConstrainSelectedInstOperands,
     /*   36985 */     // GIR_Coverage, 69302,
     /*   36985 */     GIR_EraseRootFromParent_Done,
     /*   36986 */   // Label 637: @36986
     /*   36986 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37041), // Rule ID 69303 //
     /*   36991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37019 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37039 */     GIR_RootConstrainSelectedInstOperands,
     /*   37040 */     // GIR_Coverage, 69303,
     /*   37040 */     GIR_EraseRootFromParent_Done,
     /*   37041 */   // Label 638: @37041
     /*   37041 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37109), // Rule ID 51914 //
     /*   37046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37083 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37107 */     GIR_RootConstrainSelectedInstOperands,
     /*   37108 */     // GIR_Coverage, 51914,
     /*   37108 */     GIR_EraseRootFromParent_Done,
     /*   37109 */   // Label 639: @37109
     /*   37109 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37177), // Rule ID 51915 //
     /*   37114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37151 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37175 */     GIR_RootConstrainSelectedInstOperands,
     /*   37176 */     // GIR_Coverage, 51915,
     /*   37176 */     GIR_EraseRootFromParent_Done,
     /*   37177 */   // Label 640: @37177
     /*   37177 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37232), // Rule ID 46760 //
     /*   37182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37210 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37230 */     GIR_RootConstrainSelectedInstOperands,
     /*   37231 */     // GIR_Coverage, 46760,
     /*   37231 */     GIR_EraseRootFromParent_Done,
     /*   37232 */   // Label 641: @37232
     /*   37232 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37287), // Rule ID 46761 //
     /*   37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37265 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37285 */     GIR_RootConstrainSelectedInstOperands,
     /*   37286 */     // GIR_Coverage, 46761,
     /*   37286 */     GIR_EraseRootFromParent_Done,
     /*   37287 */   // Label 642: @37287
     /*   37287 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37342), // Rule ID 46520 //
     /*   37292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37320 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37340 */     GIR_RootConstrainSelectedInstOperands,
     /*   37341 */     // GIR_Coverage, 46520,
     /*   37341 */     GIR_EraseRootFromParent_Done,
     /*   37342 */   // Label 643: @37342
     /*   37342 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37397), // Rule ID 46521 //
     /*   37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37375 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37395 */     GIR_RootConstrainSelectedInstOperands,
     /*   37396 */     // GIR_Coverage, 46521,
     /*   37396 */     GIR_EraseRootFromParent_Done,
     /*   37397 */   // Label 644: @37397
     /*   37397 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37452), // Rule ID 46640 //
     /*   37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37430 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37450 */     GIR_RootConstrainSelectedInstOperands,
     /*   37451 */     // GIR_Coverage, 46640,
     /*   37451 */     GIR_EraseRootFromParent_Done,
     /*   37452 */   // Label 645: @37452
     /*   37452 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37507), // Rule ID 46641 //
     /*   37457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37485 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37505 */     GIR_RootConstrainSelectedInstOperands,
     /*   37506 */     // GIR_Coverage, 46641,
     /*   37506 */     GIR_EraseRootFromParent_Done,
     /*   37507 */   // Label 646: @37507
     /*   37507 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37560), // Rule ID 46146 //
     /*   37512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37523 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37558 */     GIR_RootConstrainSelectedInstOperands,
     /*   37559 */     // GIR_Coverage, 46146,
     /*   37559 */     GIR_EraseRootFromParent_Done,
     /*   37560 */   // Label 647: @37560
     /*   37560 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37613), // Rule ID 46147 //
     /*   37565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37576 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   37576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37611 */     GIR_RootConstrainSelectedInstOperands,
     /*   37612 */     // GIR_Coverage, 46147,
     /*   37612 */     GIR_EraseRootFromParent_Done,
     /*   37613 */   // Label 648: @37613
     /*   37613 */   GIM_Reject,
     /*   37614 */ // Label 608: @37614
     /*   37614 */ GIM_Reject,
     /*   37615 */ // Label 139: @37615
     /*   37615 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40739),
     /*   37620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37630 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37726), // Rule ID 70588 //
     /*   37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37700 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37724 */     GIR_RootConstrainSelectedInstOperands,
     /*   37725 */     // GIR_Coverage, 70588,
     /*   37725 */     GIR_EraseRootFromParent_Done,
     /*   37726 */   // Label 650: @37726
     /*   37726 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37822), // Rule ID 70589 //
     /*   37731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37796 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37820 */     GIR_RootConstrainSelectedInstOperands,
     /*   37821 */     // GIR_Coverage, 70589,
     /*   37821 */     GIR_EraseRootFromParent_Done,
     /*   37822 */   // Label 651: @37822
     /*   37822 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37918), // Rule ID 70876 //
     /*   37827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37892 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37916 */     GIR_RootConstrainSelectedInstOperands,
     /*   37917 */     // GIR_Coverage, 70876,
     /*   37917 */     GIR_EraseRootFromParent_Done,
     /*   37918 */   // Label 652: @37918
     /*   37918 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38014), // Rule ID 70877 //
     /*   37923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37975 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37977 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37988 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38012 */     GIR_RootConstrainSelectedInstOperands,
     /*   38013 */     // GIR_Coverage, 70877,
     /*   38013 */     GIR_EraseRootFromParent_Done,
     /*   38014 */   // Label 653: @38014
     /*   38014 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38110), // Rule ID 70878 //
     /*   38019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38052 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38071 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38084 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38108 */     GIR_RootConstrainSelectedInstOperands,
     /*   38109 */     // GIR_Coverage, 70878,
     /*   38109 */     GIR_EraseRootFromParent_Done,
     /*   38110 */   // Label 654: @38110
     /*   38110 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(38206), // Rule ID 70879 //
     /*   38115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38167 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38180 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38204 */     GIR_RootConstrainSelectedInstOperands,
     /*   38205 */     // GIR_Coverage, 70879,
     /*   38205 */     GIR_EraseRootFromParent_Done,
     /*   38206 */   // Label 655: @38206
     /*   38206 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38302), // Rule ID 70702 //
     /*   38211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38263 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38276 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38300 */     GIR_RootConstrainSelectedInstOperands,
     /*   38301 */     // GIR_Coverage, 70702,
     /*   38301 */     GIR_EraseRootFromParent_Done,
     /*   38302 */   // Label 656: @38302
     /*   38302 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38398), // Rule ID 70703 //
     /*   38307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38340 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38359 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38361 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38372 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38396 */     GIR_RootConstrainSelectedInstOperands,
     /*   38397 */     // GIR_Coverage, 70703,
     /*   38397 */     GIR_EraseRootFromParent_Done,
     /*   38398 */   // Label 657: @38398
     /*   38398 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38494), // Rule ID 52050 //
     /*   38403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38468 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38492 */     GIR_RootConstrainSelectedInstOperands,
     /*   38493 */     // GIR_Coverage, 52050,
     /*   38493 */     GIR_EraseRootFromParent_Done,
     /*   38494 */   // Label 658: @38494
     /*   38494 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38590), // Rule ID 52051 //
     /*   38499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38564 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38588 */     GIR_RootConstrainSelectedInstOperands,
     /*   38589 */     // GIR_Coverage, 52051,
     /*   38589 */     GIR_EraseRootFromParent_Done,
     /*   38590 */   // Label 659: @38590
     /*   38590 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38686), // Rule ID 52168 //
     /*   38595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38660 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38684 */     GIR_RootConstrainSelectedInstOperands,
     /*   38685 */     // GIR_Coverage, 52168,
     /*   38685 */     GIR_EraseRootFromParent_Done,
     /*   38686 */   // Label 660: @38686
     /*   38686 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38782), // Rule ID 52169 //
     /*   38691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38747 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38749 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38756 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38780 */     GIR_RootConstrainSelectedInstOperands,
     /*   38781 */     // GIR_Coverage, 52169,
     /*   38781 */     GIR_EraseRootFromParent_Done,
     /*   38782 */   // Label 661: @38782
     /*   38782 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38878), // Rule ID 70874 //
     /*   38787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38843 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38852 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38876 */     GIR_RootConstrainSelectedInstOperands,
     /*   38877 */     // GIR_Coverage, 70874,
     /*   38877 */     GIR_EraseRootFromParent_Done,
     /*   38878 */   // Label 662: @38878
     /*   38878 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38974), // Rule ID 70875 //
     /*   38883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38939 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38948 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38972 */     GIR_RootConstrainSelectedInstOperands,
     /*   38973 */     // GIR_Coverage, 70875,
     /*   38973 */     GIR_EraseRootFromParent_Done,
     /*   38974 */   // Label 663: @38974
     /*   38974 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(39070), // Rule ID 52108 //
     /*   38979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39035 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39044 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39068 */     GIR_RootConstrainSelectedInstOperands,
     /*   39069 */     // GIR_Coverage, 52108,
     /*   39069 */     GIR_EraseRootFromParent_Done,
     /*   39070 */   // Label 664: @39070
     /*   39070 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39166), // Rule ID 52109 //
     /*   39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39112 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39131 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39140 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39164 */     GIR_RootConstrainSelectedInstOperands,
     /*   39165 */     // GIR_Coverage, 52109,
     /*   39165 */     GIR_EraseRootFromParent_Done,
     /*   39166 */   // Label 665: @39166
     /*   39166 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39255), // Rule ID 46720 //
     /*   39171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39214 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39253 */     GIR_RootConstrainSelectedInstOperands,
     /*   39254 */     // GIR_Coverage, 46720,
     /*   39254 */     GIR_EraseRootFromParent_Done,
     /*   39255 */   // Label 666: @39255
     /*   39255 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39344), // Rule ID 46721 //
     /*   39260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39294 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39303 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39342 */     GIR_RootConstrainSelectedInstOperands,
     /*   39343 */     // GIR_Coverage, 46721,
     /*   39343 */     GIR_EraseRootFromParent_Done,
     /*   39344 */   // Label 667: @39344
     /*   39344 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39433), // Rule ID 46484 //
     /*   39349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39383 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39392 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39431 */     GIR_RootConstrainSelectedInstOperands,
     /*   39432 */     // GIR_Coverage, 46484,
     /*   39432 */     GIR_EraseRootFromParent_Done,
     /*   39433 */   // Label 668: @39433
     /*   39433 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39522), // Rule ID 46485 //
     /*   39438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39472 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39481 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39520 */     GIR_RootConstrainSelectedInstOperands,
     /*   39521 */     // GIR_Coverage, 46485,
     /*   39521 */     GIR_EraseRootFromParent_Done,
     /*   39522 */   // Label 669: @39522
     /*   39522 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39611), // Rule ID 46600 //
     /*   39527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39561 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39570 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39609 */     GIR_RootConstrainSelectedInstOperands,
     /*   39610 */     // GIR_Coverage, 46600,
     /*   39610 */     GIR_EraseRootFromParent_Done,
     /*   39611 */   // Label 670: @39611
     /*   39611 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39700), // Rule ID 46601 //
     /*   39616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39659 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39698 */     GIR_RootConstrainSelectedInstOperands,
     /*   39699 */     // GIR_Coverage, 46601,
     /*   39699 */     GIR_EraseRootFromParent_Done,
     /*   39700 */   // Label 671: @39700
     /*   39700 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39768), // Rule ID 70504 //
     /*   39705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   39708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39742 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   39742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39766 */     GIR_RootConstrainSelectedInstOperands,
     /*   39767 */     // GIR_Coverage, 70504,
     /*   39767 */     GIR_EraseRootFromParent_Done,
     /*   39768 */   // Label 672: @39768
     /*   39768 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39836), // Rule ID 70505 //
     /*   39773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   39776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39810 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   39810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39834 */     GIR_RootConstrainSelectedInstOperands,
     /*   39835 */     // GIR_Coverage, 70505,
     /*   39835 */     GIR_EraseRootFromParent_Done,
     /*   39836 */   // Label 673: @39836
     /*   39836 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39891), // Rule ID 69412 //
     /*   39841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39869 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39889 */     GIR_RootConstrainSelectedInstOperands,
     /*   39890 */     // GIR_Coverage, 69412,
     /*   39890 */     GIR_EraseRootFromParent_Done,
     /*   39891 */   // Label 674: @39891
     /*   39891 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39946), // Rule ID 69413 //
     /*   39896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39924 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39944 */     GIR_RootConstrainSelectedInstOperands,
     /*   39945 */     // GIR_Coverage, 69413,
     /*   39945 */     GIR_EraseRootFromParent_Done,
     /*   39946 */   // Label 675: @39946
     /*   39946 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40001), // Rule ID 69232 //
     /*   39951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39979 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   39982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39999 */     GIR_RootConstrainSelectedInstOperands,
     /*   40000 */     // GIR_Coverage, 69232,
     /*   40000 */     GIR_EraseRootFromParent_Done,
     /*   40001 */   // Label 676: @40001
     /*   40001 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40056), // Rule ID 69233 //
     /*   40006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40034 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40054 */     GIR_RootConstrainSelectedInstOperands,
     /*   40055 */     // GIR_Coverage, 69233,
     /*   40055 */     GIR_EraseRootFromParent_Done,
     /*   40056 */   // Label 677: @40056
     /*   40056 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40111), // Rule ID 69322 //
     /*   40061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40089 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40109 */     GIR_RootConstrainSelectedInstOperands,
     /*   40110 */     // GIR_Coverage, 69322,
     /*   40110 */     GIR_EraseRootFromParent_Done,
     /*   40111 */   // Label 678: @40111
     /*   40111 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40166), // Rule ID 69323 //
     /*   40116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40144 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40164 */     GIR_RootConstrainSelectedInstOperands,
     /*   40165 */     // GIR_Coverage, 69323,
     /*   40165 */     GIR_EraseRootFromParent_Done,
     /*   40166 */   // Label 679: @40166
     /*   40166 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40234), // Rule ID 51930 //
     /*   40171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40208 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40232 */     GIR_RootConstrainSelectedInstOperands,
     /*   40233 */     // GIR_Coverage, 51930,
     /*   40233 */     GIR_EraseRootFromParent_Done,
     /*   40234 */   // Label 680: @40234
     /*   40234 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40302), // Rule ID 51931 //
     /*   40239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40276 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40300 */     GIR_RootConstrainSelectedInstOperands,
     /*   40301 */     // GIR_Coverage, 51931,
     /*   40301 */     GIR_EraseRootFromParent_Done,
     /*   40302 */   // Label 681: @40302
     /*   40302 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40357), // Rule ID 46780 //
     /*   40307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40335 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40355 */     GIR_RootConstrainSelectedInstOperands,
     /*   40356 */     // GIR_Coverage, 46780,
     /*   40356 */     GIR_EraseRootFromParent_Done,
     /*   40357 */   // Label 682: @40357
     /*   40357 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40412), // Rule ID 46781 //
     /*   40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40390 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40410 */     GIR_RootConstrainSelectedInstOperands,
     /*   40411 */     // GIR_Coverage, 46781,
     /*   40411 */     GIR_EraseRootFromParent_Done,
     /*   40412 */   // Label 683: @40412
     /*   40412 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40467), // Rule ID 46540 //
     /*   40417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40445 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40465 */     GIR_RootConstrainSelectedInstOperands,
     /*   40466 */     // GIR_Coverage, 46540,
     /*   40466 */     GIR_EraseRootFromParent_Done,
     /*   40467 */   // Label 684: @40467
     /*   40467 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40522), // Rule ID 46541 //
     /*   40472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40500 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40520 */     GIR_RootConstrainSelectedInstOperands,
     /*   40521 */     // GIR_Coverage, 46541,
     /*   40521 */     GIR_EraseRootFromParent_Done,
     /*   40522 */   // Label 685: @40522
     /*   40522 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40577), // Rule ID 46660 //
     /*   40527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40555 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40575 */     GIR_RootConstrainSelectedInstOperands,
     /*   40576 */     // GIR_Coverage, 46660,
     /*   40576 */     GIR_EraseRootFromParent_Done,
     /*   40577 */   // Label 686: @40577
     /*   40577 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40632), // Rule ID 46661 //
     /*   40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40610 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40630 */     GIR_RootConstrainSelectedInstOperands,
     /*   40631 */     // GIR_Coverage, 46661,
     /*   40631 */     GIR_EraseRootFromParent_Done,
     /*   40632 */   // Label 687: @40632
     /*   40632 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40685), // Rule ID 46162 //
     /*   40637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40648 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   40648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40683 */     GIR_RootConstrainSelectedInstOperands,
     /*   40684 */     // GIR_Coverage, 46162,
     /*   40684 */     GIR_EraseRootFromParent_Done,
     /*   40685 */   // Label 688: @40685
     /*   40685 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40738), // Rule ID 46163 //
     /*   40690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40701 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   40701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40736 */     GIR_RootConstrainSelectedInstOperands,
     /*   40737 */     // GIR_Coverage, 46163,
     /*   40737 */     GIR_EraseRootFromParent_Done,
     /*   40738 */   // Label 689: @40738
     /*   40738 */   GIM_Reject,
     /*   40739 */ // Label 649: @40739
     /*   40739 */ GIM_Reject,
     /*   40740 */ // Label 140: @40740
     /*   40740 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(41134),
     /*   40745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40755 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40823), // Rule ID 70392 //
     /*   40760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40797 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40821 */     GIR_RootConstrainSelectedInstOperands,
     /*   40822 */     // GIR_Coverage, 70392,
     /*   40822 */     GIR_EraseRootFromParent_Done,
     /*   40823 */   // Label 691: @40823
     /*   40823 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(40891), // Rule ID 70393 //
     /*   40828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40865 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   40865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40889 */     GIR_RootConstrainSelectedInstOperands,
     /*   40890 */     // GIR_Coverage, 70393,
     /*   40890 */     GIR_EraseRootFromParent_Done,
     /*   40891 */   // Label 692: @40891
     /*   40891 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(40959), // Rule ID 51874 //
     /*   40896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40933 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40957 */     GIR_RootConstrainSelectedInstOperands,
     /*   40958 */     // GIR_Coverage, 51874,
     /*   40958 */     GIR_EraseRootFromParent_Done,
     /*   40959 */   // Label 693: @40959
     /*   40959 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41027), // Rule ID 51875 //
     /*   40964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41001 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41025 */     GIR_RootConstrainSelectedInstOperands,
     /*   41026 */     // GIR_Coverage, 51875,
     /*   41026 */     GIR_EraseRootFromParent_Done,
     /*   41027 */   // Label 694: @41027
     /*   41027 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41080), // Rule ID 46106 //
     /*   41032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41043 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41078 */     GIR_RootConstrainSelectedInstOperands,
     /*   41079 */     // GIR_Coverage, 46106,
     /*   41079 */     GIR_EraseRootFromParent_Done,
     /*   41080 */   // Label 695: @41080
     /*   41080 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41133), // Rule ID 46107 //
     /*   41085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41096 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41131 */     GIR_RootConstrainSelectedInstOperands,
     /*   41132 */     // GIR_Coverage, 46107,
     /*   41132 */     GIR_EraseRootFromParent_Done,
     /*   41133 */   // Label 696: @41133
     /*   41133 */   GIM_Reject,
     /*   41134 */ // Label 690: @41134
     /*   41134 */ GIM_Reject,
     /*   41135 */ // Label 141: @41135
     /*   41135 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44259),
     /*   41140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41150 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41246), // Rule ID 70568 //
     /*   41155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41220 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41244 */     GIR_RootConstrainSelectedInstOperands,
     /*   41245 */     // GIR_Coverage, 70568,
     /*   41245 */     GIR_EraseRootFromParent_Done,
     /*   41246 */   // Label 698: @41246
     /*   41246 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41342), // Rule ID 70569 //
     /*   41251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41316 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41340 */     GIR_RootConstrainSelectedInstOperands,
     /*   41341 */     // GIR_Coverage, 70569,
     /*   41341 */     GIR_EraseRootFromParent_Done,
     /*   41342 */   // Label 699: @41342
     /*   41342 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41438), // Rule ID 70816 //
     /*   41347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41412 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41436 */     GIR_RootConstrainSelectedInstOperands,
     /*   41437 */     // GIR_Coverage, 70816,
     /*   41437 */     GIR_EraseRootFromParent_Done,
     /*   41438 */   // Label 700: @41438
     /*   41438 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41534), // Rule ID 70817 //
     /*   41443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41508 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41532 */     GIR_RootConstrainSelectedInstOperands,
     /*   41533 */     // GIR_Coverage, 70817,
     /*   41533 */     GIR_EraseRootFromParent_Done,
     /*   41534 */   // Label 701: @41534
     /*   41534 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41630), // Rule ID 70818 //
     /*   41539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41604 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41628 */     GIR_RootConstrainSelectedInstOperands,
     /*   41629 */     // GIR_Coverage, 70818,
     /*   41629 */     GIR_EraseRootFromParent_Done,
     /*   41630 */   // Label 702: @41630
     /*   41630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(41726), // Rule ID 70819 //
     /*   41635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41700 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41724 */     GIR_RootConstrainSelectedInstOperands,
     /*   41725 */     // GIR_Coverage, 70819,
     /*   41725 */     GIR_EraseRootFromParent_Done,
     /*   41726 */   // Label 703: @41726
     /*   41726 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41822), // Rule ID 70682 //
     /*   41731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41796 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41820 */     GIR_RootConstrainSelectedInstOperands,
     /*   41821 */     // GIR_Coverage, 70682,
     /*   41821 */     GIR_EraseRootFromParent_Done,
     /*   41822 */   // Label 704: @41822
     /*   41822 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41918), // Rule ID 70683 //
     /*   41827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41892 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41916 */     GIR_RootConstrainSelectedInstOperands,
     /*   41917 */     // GIR_Coverage, 70683,
     /*   41917 */     GIR_EraseRootFromParent_Done,
     /*   41918 */   // Label 705: @41918
     /*   41918 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(42014), // Rule ID 52030 //
     /*   41923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41979 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41988 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42012 */     GIR_RootConstrainSelectedInstOperands,
     /*   42013 */     // GIR_Coverage, 52030,
     /*   42013 */     GIR_EraseRootFromParent_Done,
     /*   42014 */   // Label 706: @42014
     /*   42014 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42110), // Rule ID 52031 //
     /*   42019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42075 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42077 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42084 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42108 */     GIR_RootConstrainSelectedInstOperands,
     /*   42109 */     // GIR_Coverage, 52031,
     /*   42109 */     GIR_EraseRootFromParent_Done,
     /*   42110 */   // Label 707: @42110
     /*   42110 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42206), // Rule ID 52148 //
     /*   42115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42167 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42171 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42180 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42204 */     GIR_RootConstrainSelectedInstOperands,
     /*   42205 */     // GIR_Coverage, 52148,
     /*   42205 */     GIR_EraseRootFromParent_Done,
     /*   42206 */   // Label 708: @42206
     /*   42206 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42302), // Rule ID 52149 //
     /*   42211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42234 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42267 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42276 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42300 */     GIR_RootConstrainSelectedInstOperands,
     /*   42301 */     // GIR_Coverage, 52149,
     /*   42301 */     GIR_EraseRootFromParent_Done,
     /*   42302 */   // Label 709: @42302
     /*   42302 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42398), // Rule ID 70814 //
     /*   42307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42359 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42363 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42372 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42396 */     GIR_RootConstrainSelectedInstOperands,
     /*   42397 */     // GIR_Coverage, 70814,
     /*   42397 */     GIR_EraseRootFromParent_Done,
     /*   42398 */   // Label 710: @42398
     /*   42398 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42494), // Rule ID 70815 //
     /*   42403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42468 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42492 */     GIR_RootConstrainSelectedInstOperands,
     /*   42493 */     // GIR_Coverage, 70815,
     /*   42493 */     GIR_EraseRootFromParent_Done,
     /*   42494 */   // Label 711: @42494
     /*   42494 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42590), // Rule ID 52088 //
     /*   42499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42564 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42588 */     GIR_RootConstrainSelectedInstOperands,
     /*   42589 */     // GIR_Coverage, 52088,
     /*   42589 */     GIR_EraseRootFromParent_Done,
     /*   42590 */   // Label 712: @42590
     /*   42590 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42686), // Rule ID 52089 //
     /*   42595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42660 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42684 */     GIR_RootConstrainSelectedInstOperands,
     /*   42685 */     // GIR_Coverage, 52089,
     /*   42685 */     GIR_EraseRootFromParent_Done,
     /*   42686 */   // Label 713: @42686
     /*   42686 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42775), // Rule ID 46680 //
     /*   42691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42725 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42734 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42773 */     GIR_RootConstrainSelectedInstOperands,
     /*   42774 */     // GIR_Coverage, 46680,
     /*   42774 */     GIR_EraseRootFromParent_Done,
     /*   42775 */   // Label 714: @42775
     /*   42775 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42864), // Rule ID 46681 //
     /*   42780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42814 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42823 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   42823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42862 */     GIR_RootConstrainSelectedInstOperands,
     /*   42863 */     // GIR_Coverage, 46681,
     /*   42863 */     GIR_EraseRootFromParent_Done,
     /*   42864 */   // Label 715: @42864
     /*   42864 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42953), // Rule ID 46444 //
     /*   42869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42903 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42912 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   42929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42951 */     GIR_RootConstrainSelectedInstOperands,
     /*   42952 */     // GIR_Coverage, 46444,
     /*   42952 */     GIR_EraseRootFromParent_Done,
     /*   42953 */   // Label 716: @42953
     /*   42953 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(43042), // Rule ID 46445 //
     /*   42958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42992 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43001 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43040 */     GIR_RootConstrainSelectedInstOperands,
     /*   43041 */     // GIR_Coverage, 46445,
     /*   43041 */     GIR_EraseRootFromParent_Done,
     /*   43042 */   // Label 717: @43042
     /*   43042 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43131), // Rule ID 46560 //
     /*   43047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43081 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43090 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43129 */     GIR_RootConstrainSelectedInstOperands,
     /*   43130 */     // GIR_Coverage, 46560,
     /*   43130 */     GIR_EraseRootFromParent_Done,
     /*   43131 */   // Label 718: @43131
     /*   43131 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43220), // Rule ID 46561 //
     /*   43136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43170 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43179 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43218 */     GIR_RootConstrainSelectedInstOperands,
     /*   43219 */     // GIR_Coverage, 46561,
     /*   43219 */     GIR_EraseRootFromParent_Done,
     /*   43220 */   // Label 719: @43220
     /*   43220 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43288), // Rule ID 70448 //
     /*   43225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43262 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43286 */     GIR_RootConstrainSelectedInstOperands,
     /*   43287 */     // GIR_Coverage, 70448,
     /*   43287 */     GIR_EraseRootFromParent_Done,
     /*   43288 */   // Label 720: @43288
     /*   43288 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43356), // Rule ID 70449 //
     /*   43293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43330 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43354 */     GIR_RootConstrainSelectedInstOperands,
     /*   43355 */     // GIR_Coverage, 70449,
     /*   43355 */     GIR_EraseRootFromParent_Done,
     /*   43356 */   // Label 721: @43356
     /*   43356 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43411), // Rule ID 69372 //
     /*   43361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43389 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43409 */     GIR_RootConstrainSelectedInstOperands,
     /*   43410 */     // GIR_Coverage, 69372,
     /*   43410 */     GIR_EraseRootFromParent_Done,
     /*   43411 */   // Label 722: @43411
     /*   43411 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43466), // Rule ID 69373 //
     /*   43416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43444 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43464 */     GIR_RootConstrainSelectedInstOperands,
     /*   43465 */     // GIR_Coverage, 69373,
     /*   43465 */     GIR_EraseRootFromParent_Done,
     /*   43466 */   // Label 723: @43466
     /*   43466 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43521), // Rule ID 69192 //
     /*   43471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43499 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43519 */     GIR_RootConstrainSelectedInstOperands,
     /*   43520 */     // GIR_Coverage, 69192,
     /*   43520 */     GIR_EraseRootFromParent_Done,
     /*   43521 */   // Label 724: @43521
     /*   43521 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43576), // Rule ID 69193 //
     /*   43526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43554 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43574 */     GIR_RootConstrainSelectedInstOperands,
     /*   43575 */     // GIR_Coverage, 69193,
     /*   43575 */     GIR_EraseRootFromParent_Done,
     /*   43576 */   // Label 725: @43576
     /*   43576 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43631), // Rule ID 69282 //
     /*   43581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43609 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43629 */     GIR_RootConstrainSelectedInstOperands,
     /*   43630 */     // GIR_Coverage, 69282,
     /*   43630 */     GIR_EraseRootFromParent_Done,
     /*   43631 */   // Label 726: @43631
     /*   43631 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43686), // Rule ID 69283 //
     /*   43636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43664 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43684 */     GIR_RootConstrainSelectedInstOperands,
     /*   43685 */     // GIR_Coverage, 69283,
     /*   43685 */     GIR_EraseRootFromParent_Done,
     /*   43686 */   // Label 727: @43686
     /*   43686 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43754), // Rule ID 51902 //
     /*   43691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43728 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43752 */     GIR_RootConstrainSelectedInstOperands,
     /*   43753 */     // GIR_Coverage, 51902,
     /*   43753 */     GIR_EraseRootFromParent_Done,
     /*   43754 */   // Label 728: @43754
     /*   43754 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43822), // Rule ID 51903 //
     /*   43759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43796 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43820 */     GIR_RootConstrainSelectedInstOperands,
     /*   43821 */     // GIR_Coverage, 51903,
     /*   43821 */     GIR_EraseRootFromParent_Done,
     /*   43822 */   // Label 729: @43822
     /*   43822 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43877), // Rule ID 46740 //
     /*   43827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43855 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43875 */     GIR_RootConstrainSelectedInstOperands,
     /*   43876 */     // GIR_Coverage, 46740,
     /*   43876 */     GIR_EraseRootFromParent_Done,
     /*   43877 */   // Label 730: @43877
     /*   43877 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(43932), // Rule ID 46741 //
     /*   43882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43910 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43930 */     GIR_RootConstrainSelectedInstOperands,
     /*   43931 */     // GIR_Coverage, 46741,
     /*   43931 */     GIR_EraseRootFromParent_Done,
     /*   43932 */   // Label 731: @43932
     /*   43932 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(43987), // Rule ID 46500 //
     /*   43937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43965 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43985 */     GIR_RootConstrainSelectedInstOperands,
     /*   43986 */     // GIR_Coverage, 46500,
     /*   43986 */     GIR_EraseRootFromParent_Done,
     /*   43987 */   // Label 732: @43987
     /*   43987 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44042), // Rule ID 46501 //
     /*   43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44020 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44040 */     GIR_RootConstrainSelectedInstOperands,
     /*   44041 */     // GIR_Coverage, 46501,
     /*   44041 */     GIR_EraseRootFromParent_Done,
     /*   44042 */   // Label 733: @44042
     /*   44042 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44097), // Rule ID 46620 //
     /*   44047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44075 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44095 */     GIR_RootConstrainSelectedInstOperands,
     /*   44096 */     // GIR_Coverage, 46620,
     /*   44096 */     GIR_EraseRootFromParent_Done,
     /*   44097 */   // Label 734: @44097
     /*   44097 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44152), // Rule ID 46621 //
     /*   44102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44130 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44150 */     GIR_RootConstrainSelectedInstOperands,
     /*   44151 */     // GIR_Coverage, 46621,
     /*   44151 */     GIR_EraseRootFromParent_Done,
     /*   44152 */   // Label 735: @44152
     /*   44152 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44205), // Rule ID 46134 //
     /*   44157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44168 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44203 */     GIR_RootConstrainSelectedInstOperands,
     /*   44204 */     // GIR_Coverage, 46134,
     /*   44204 */     GIR_EraseRootFromParent_Done,
     /*   44205 */   // Label 736: @44205
     /*   44205 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44258), // Rule ID 46135 //
     /*   44210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44221 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44256 */     GIR_RootConstrainSelectedInstOperands,
     /*   44257 */     // GIR_Coverage, 46135,
     /*   44257 */     GIR_EraseRootFromParent_Done,
     /*   44258 */   // Label 737: @44258
     /*   44258 */   GIM_Reject,
     /*   44259 */ // Label 697: @44259
     /*   44259 */ GIM_Reject,
     /*   44260 */ // Label 142: @44260
     /*   44260 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47384),
     /*   44265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44275 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44371), // Rule ID 70580 //
     /*   44280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44313 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44332 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44345 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44369 */     GIR_RootConstrainSelectedInstOperands,
     /*   44370 */     // GIR_Coverage, 70580,
     /*   44370 */     GIR_EraseRootFromParent_Done,
     /*   44371 */   // Label 739: @44371
     /*   44371 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44467), // Rule ID 70581 //
     /*   44376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44428 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44441 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44465 */     GIR_RootConstrainSelectedInstOperands,
     /*   44466 */     // GIR_Coverage, 70581,
     /*   44466 */     GIR_EraseRootFromParent_Done,
     /*   44467 */   // Label 740: @44467
     /*   44467 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44563), // Rule ID 70852 //
     /*   44472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44505 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44524 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44526 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44537 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44561 */     GIR_RootConstrainSelectedInstOperands,
     /*   44562 */     // GIR_Coverage, 70852,
     /*   44562 */     GIR_EraseRootFromParent_Done,
     /*   44563 */   // Label 741: @44563
     /*   44563 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44659), // Rule ID 70853 //
     /*   44568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44601 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44620 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44633 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44657 */     GIR_RootConstrainSelectedInstOperands,
     /*   44658 */     // GIR_Coverage, 70853,
     /*   44658 */     GIR_EraseRootFromParent_Done,
     /*   44659 */   // Label 742: @44659
     /*   44659 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44755), // Rule ID 70854 //
     /*   44664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44716 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44718 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44729 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44753 */     GIR_RootConstrainSelectedInstOperands,
     /*   44754 */     // GIR_Coverage, 70854,
     /*   44754 */     GIR_EraseRootFromParent_Done,
     /*   44755 */   // Label 743: @44755
     /*   44755 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(44851), // Rule ID 70855 //
     /*   44760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44793 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44812 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44825 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44849 */     GIR_RootConstrainSelectedInstOperands,
     /*   44850 */     // GIR_Coverage, 70855,
     /*   44850 */     GIR_EraseRootFromParent_Done,
     /*   44851 */   // Label 744: @44851
     /*   44851 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44947), // Rule ID 70694 //
     /*   44856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44889 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44908 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44910 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44921 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   44924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44945 */     GIR_RootConstrainSelectedInstOperands,
     /*   44946 */     // GIR_Coverage, 70694,
     /*   44946 */     GIR_EraseRootFromParent_Done,
     /*   44947 */   // Label 745: @44947
     /*   44947 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(45043), // Rule ID 70695 //
     /*   44952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45004 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45006 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45017 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45041 */     GIR_RootConstrainSelectedInstOperands,
     /*   45042 */     // GIR_Coverage, 70695,
     /*   45042 */     GIR_EraseRootFromParent_Done,
     /*   45043 */   // Label 746: @45043
     /*   45043 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45139), // Rule ID 52042 //
     /*   45048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45104 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45113 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45137 */     GIR_RootConstrainSelectedInstOperands,
     /*   45138 */     // GIR_Coverage, 52042,
     /*   45138 */     GIR_EraseRootFromParent_Done,
     /*   45139 */   // Label 747: @45139
     /*   45139 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45235), // Rule ID 52043 //
     /*   45144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45200 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45202 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45209 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45233 */     GIR_RootConstrainSelectedInstOperands,
     /*   45234 */     // GIR_Coverage, 52043,
     /*   45234 */     GIR_EraseRootFromParent_Done,
     /*   45235 */   // Label 748: @45235
     /*   45235 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45331), // Rule ID 52160 //
     /*   45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45296 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45305 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45329 */     GIR_RootConstrainSelectedInstOperands,
     /*   45330 */     // GIR_Coverage, 52160,
     /*   45330 */     GIR_EraseRootFromParent_Done,
     /*   45331 */   // Label 749: @45331
     /*   45331 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45427), // Rule ID 52161 //
     /*   45336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45373 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45392 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45401 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45425 */     GIR_RootConstrainSelectedInstOperands,
     /*   45426 */     // GIR_Coverage, 52161,
     /*   45426 */     GIR_EraseRootFromParent_Done,
     /*   45427 */   // Label 750: @45427
     /*   45427 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45523), // Rule ID 70850 //
     /*   45432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45488 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45490 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45497 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45521 */     GIR_RootConstrainSelectedInstOperands,
     /*   45522 */     // GIR_Coverage, 70850,
     /*   45522 */     GIR_EraseRootFromParent_Done,
     /*   45523 */   // Label 751: @45523
     /*   45523 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45619), // Rule ID 70851 //
     /*   45528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45584 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45593 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45617 */     GIR_RootConstrainSelectedInstOperands,
     /*   45618 */     // GIR_Coverage, 70851,
     /*   45618 */     GIR_EraseRootFromParent_Done,
     /*   45619 */   // Label 752: @45619
     /*   45619 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45715), // Rule ID 52100 //
     /*   45624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45680 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45689 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45713 */     GIR_RootConstrainSelectedInstOperands,
     /*   45714 */     // GIR_Coverage, 52100,
     /*   45714 */     GIR_EraseRootFromParent_Done,
     /*   45715 */   // Label 753: @45715
     /*   45715 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45811), // Rule ID 52101 //
     /*   45720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45776 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45778 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45785 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45809 */     GIR_RootConstrainSelectedInstOperands,
     /*   45810 */     // GIR_Coverage, 52101,
     /*   45810 */     GIR_EraseRootFromParent_Done,
     /*   45811 */   // Label 754: @45811
     /*   45811 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45900), // Rule ID 46704 //
     /*   45816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45859 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   45859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45898 */     GIR_RootConstrainSelectedInstOperands,
     /*   45899 */     // GIR_Coverage, 46704,
     /*   45899 */     GIR_EraseRootFromParent_Done,
     /*   45900 */   // Label 755: @45900
     /*   45900 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(45989), // Rule ID 46705 //
     /*   45905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45948 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   45948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45987 */     GIR_RootConstrainSelectedInstOperands,
     /*   45988 */     // GIR_Coverage, 46705,
     /*   45988 */     GIR_EraseRootFromParent_Done,
     /*   45989 */   // Label 756: @45989
     /*   45989 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46078), // Rule ID 46468 //
     /*   45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46037 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46076 */     GIR_RootConstrainSelectedInstOperands,
     /*   46077 */     // GIR_Coverage, 46468,
     /*   46077 */     GIR_EraseRootFromParent_Done,
     /*   46078 */   // Label 757: @46078
     /*   46078 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46167), // Rule ID 46469 //
     /*   46083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46126 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46165 */     GIR_RootConstrainSelectedInstOperands,
     /*   46166 */     // GIR_Coverage, 46469,
     /*   46166 */     GIR_EraseRootFromParent_Done,
     /*   46167 */   // Label 758: @46167
     /*   46167 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46256), // Rule ID 46584 //
     /*   46172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46215 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46254 */     GIR_RootConstrainSelectedInstOperands,
     /*   46255 */     // GIR_Coverage, 46584,
     /*   46255 */     GIR_EraseRootFromParent_Done,
     /*   46256 */   // Label 759: @46256
     /*   46256 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46345), // Rule ID 46585 //
     /*   46261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46304 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46343 */     GIR_RootConstrainSelectedInstOperands,
     /*   46344 */     // GIR_Coverage, 46585,
     /*   46344 */     GIR_EraseRootFromParent_Done,
     /*   46345 */   // Label 760: @46345
     /*   46345 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46413), // Rule ID 70480 //
     /*   46350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46387 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46411 */     GIR_RootConstrainSelectedInstOperands,
     /*   46412 */     // GIR_Coverage, 70480,
     /*   46412 */     GIR_EraseRootFromParent_Done,
     /*   46413 */   // Label 761: @46413
     /*   46413 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46481), // Rule ID 70481 //
     /*   46418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46455 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46479 */     GIR_RootConstrainSelectedInstOperands,
     /*   46480 */     // GIR_Coverage, 70481,
     /*   46480 */     GIR_EraseRootFromParent_Done,
     /*   46481 */   // Label 762: @46481
     /*   46481 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46536), // Rule ID 69396 //
     /*   46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46514 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46534 */     GIR_RootConstrainSelectedInstOperands,
     /*   46535 */     // GIR_Coverage, 69396,
     /*   46535 */     GIR_EraseRootFromParent_Done,
     /*   46536 */   // Label 763: @46536
     /*   46536 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46591), // Rule ID 69397 //
     /*   46541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46569 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46589 */     GIR_RootConstrainSelectedInstOperands,
     /*   46590 */     // GIR_Coverage, 69397,
     /*   46590 */     GIR_EraseRootFromParent_Done,
     /*   46591 */   // Label 764: @46591
     /*   46591 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46646), // Rule ID 69216 //
     /*   46596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46624 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46644 */     GIR_RootConstrainSelectedInstOperands,
     /*   46645 */     // GIR_Coverage, 69216,
     /*   46645 */     GIR_EraseRootFromParent_Done,
     /*   46646 */   // Label 765: @46646
     /*   46646 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46701), // Rule ID 69217 //
     /*   46651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46679 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46699 */     GIR_RootConstrainSelectedInstOperands,
     /*   46700 */     // GIR_Coverage, 69217,
     /*   46700 */     GIR_EraseRootFromParent_Done,
     /*   46701 */   // Label 766: @46701
     /*   46701 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46756), // Rule ID 69306 //
     /*   46706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46734 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46754 */     GIR_RootConstrainSelectedInstOperands,
     /*   46755 */     // GIR_Coverage, 69306,
     /*   46755 */     GIR_EraseRootFromParent_Done,
     /*   46756 */   // Label 767: @46756
     /*   46756 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46811), // Rule ID 69307 //
     /*   46761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46789 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46809 */     GIR_RootConstrainSelectedInstOperands,
     /*   46810 */     // GIR_Coverage, 69307,
     /*   46810 */     GIR_EraseRootFromParent_Done,
     /*   46811 */   // Label 768: @46811
     /*   46811 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(46879), // Rule ID 51918 //
     /*   46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46853 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46877 */     GIR_RootConstrainSelectedInstOperands,
     /*   46878 */     // GIR_Coverage, 51918,
     /*   46878 */     GIR_EraseRootFromParent_Done,
     /*   46879 */   // Label 769: @46879
     /*   46879 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(46947), // Rule ID 51919 //
     /*   46884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46921 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46945 */     GIR_RootConstrainSelectedInstOperands,
     /*   46946 */     // GIR_Coverage, 51919,
     /*   46946 */     GIR_EraseRootFromParent_Done,
     /*   46947 */   // Label 770: @46947
     /*   46947 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47002), // Rule ID 46764 //
     /*   46952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46980 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47000 */     GIR_RootConstrainSelectedInstOperands,
     /*   47001 */     // GIR_Coverage, 46764,
     /*   47001 */     GIR_EraseRootFromParent_Done,
     /*   47002 */   // Label 771: @47002
     /*   47002 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47057), // Rule ID 46765 //
     /*   47007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47035 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47055 */     GIR_RootConstrainSelectedInstOperands,
     /*   47056 */     // GIR_Coverage, 46765,
     /*   47056 */     GIR_EraseRootFromParent_Done,
     /*   47057 */   // Label 772: @47057
     /*   47057 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47112), // Rule ID 46524 //
     /*   47062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47090 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47110 */     GIR_RootConstrainSelectedInstOperands,
     /*   47111 */     // GIR_Coverage, 46524,
     /*   47111 */     GIR_EraseRootFromParent_Done,
     /*   47112 */   // Label 773: @47112
     /*   47112 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47167), // Rule ID 46525 //
     /*   47117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47145 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47165 */     GIR_RootConstrainSelectedInstOperands,
     /*   47166 */     // GIR_Coverage, 46525,
     /*   47166 */     GIR_EraseRootFromParent_Done,
     /*   47167 */   // Label 774: @47167
     /*   47167 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47222), // Rule ID 46644 //
     /*   47172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47200 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47220 */     GIR_RootConstrainSelectedInstOperands,
     /*   47221 */     // GIR_Coverage, 46644,
     /*   47221 */     GIR_EraseRootFromParent_Done,
     /*   47222 */   // Label 775: @47222
     /*   47222 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47277), // Rule ID 46645 //
     /*   47227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47255 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47275 */     GIR_RootConstrainSelectedInstOperands,
     /*   47276 */     // GIR_Coverage, 46645,
     /*   47276 */     GIR_EraseRootFromParent_Done,
     /*   47277 */   // Label 776: @47277
     /*   47277 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47330), // Rule ID 46150 //
     /*   47282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47293 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47328 */     GIR_RootConstrainSelectedInstOperands,
     /*   47329 */     // GIR_Coverage, 46150,
     /*   47329 */     GIR_EraseRootFromParent_Done,
     /*   47330 */   // Label 777: @47330
     /*   47330 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47383), // Rule ID 46151 //
     /*   47335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47346 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47381 */     GIR_RootConstrainSelectedInstOperands,
     /*   47382 */     // GIR_Coverage, 46151,
     /*   47382 */     GIR_EraseRootFromParent_Done,
     /*   47383 */   // Label 778: @47383
     /*   47383 */   GIM_Reject,
     /*   47384 */ // Label 738: @47384
     /*   47384 */ GIM_Reject,
     /*   47385 */ // Label 143: @47385
     /*   47385 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50509),
     /*   47390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47400 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47496), // Rule ID 70590 //
     /*   47405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47470 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47494 */     GIR_RootConstrainSelectedInstOperands,
     /*   47495 */     // GIR_Coverage, 70590,
     /*   47495 */     GIR_EraseRootFromParent_Done,
     /*   47496 */   // Label 780: @47496
     /*   47496 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47592), // Rule ID 70591 //
     /*   47501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47566 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47590 */     GIR_RootConstrainSelectedInstOperands,
     /*   47591 */     // GIR_Coverage, 70591,
     /*   47591 */     GIR_EraseRootFromParent_Done,
     /*   47592 */   // Label 781: @47592
     /*   47592 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47688), // Rule ID 70882 //
     /*   47597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47662 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47686 */     GIR_RootConstrainSelectedInstOperands,
     /*   47687 */     // GIR_Coverage, 70882,
     /*   47687 */     GIR_EraseRootFromParent_Done,
     /*   47688 */   // Label 782: @47688
     /*   47688 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47784), // Rule ID 70883 //
     /*   47693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47726 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47745 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47747 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47758 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47782 */     GIR_RootConstrainSelectedInstOperands,
     /*   47783 */     // GIR_Coverage, 70883,
     /*   47783 */     GIR_EraseRootFromParent_Done,
     /*   47784 */   // Label 783: @47784
     /*   47784 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47880), // Rule ID 70884 //
     /*   47789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47822 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47841 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47854 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47878 */     GIR_RootConstrainSelectedInstOperands,
     /*   47879 */     // GIR_Coverage, 70884,
     /*   47879 */     GIR_EraseRootFromParent_Done,
     /*   47880 */   // Label 784: @47880
     /*   47880 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(47976), // Rule ID 70885 //
     /*   47885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47937 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47950 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47974 */     GIR_RootConstrainSelectedInstOperands,
     /*   47975 */     // GIR_Coverage, 70885,
     /*   47975 */     GIR_EraseRootFromParent_Done,
     /*   47976 */   // Label 785: @47976
     /*   47976 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48072), // Rule ID 70704 //
     /*   47981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48000 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48033 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48046 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48070 */     GIR_RootConstrainSelectedInstOperands,
     /*   48071 */     // GIR_Coverage, 70704,
     /*   48071 */     GIR_EraseRootFromParent_Done,
     /*   48072 */   // Label 786: @48072
     /*   48072 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48168), // Rule ID 70705 //
     /*   48077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48129 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48142 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48166 */     GIR_RootConstrainSelectedInstOperands,
     /*   48167 */     // GIR_Coverage, 70705,
     /*   48167 */     GIR_EraseRootFromParent_Done,
     /*   48168 */   // Label 787: @48168
     /*   48168 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48264), // Rule ID 52052 //
     /*   48173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48238 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48262 */     GIR_RootConstrainSelectedInstOperands,
     /*   48263 */     // GIR_Coverage, 52052,
     /*   48263 */     GIR_EraseRootFromParent_Done,
     /*   48264 */   // Label 788: @48264
     /*   48264 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48360), // Rule ID 52053 //
     /*   48269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48334 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48358 */     GIR_RootConstrainSelectedInstOperands,
     /*   48359 */     // GIR_Coverage, 52053,
     /*   48359 */     GIR_EraseRootFromParent_Done,
     /*   48360 */   // Label 789: @48360
     /*   48360 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48456), // Rule ID 52170 //
     /*   48365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48430 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48454 */     GIR_RootConstrainSelectedInstOperands,
     /*   48455 */     // GIR_Coverage, 52170,
     /*   48455 */     GIR_EraseRootFromParent_Done,
     /*   48456 */   // Label 790: @48456
     /*   48456 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48552), // Rule ID 52171 //
     /*   48461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48517 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48526 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48550 */     GIR_RootConstrainSelectedInstOperands,
     /*   48551 */     // GIR_Coverage, 52171,
     /*   48551 */     GIR_EraseRootFromParent_Done,
     /*   48552 */   // Label 791: @48552
     /*   48552 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48648), // Rule ID 70880 //
     /*   48557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48622 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48646 */     GIR_RootConstrainSelectedInstOperands,
     /*   48647 */     // GIR_Coverage, 70880,
     /*   48647 */     GIR_EraseRootFromParent_Done,
     /*   48648 */   // Label 792: @48648
     /*   48648 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48744), // Rule ID 70881 //
     /*   48653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48718 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48742 */     GIR_RootConstrainSelectedInstOperands,
     /*   48743 */     // GIR_Coverage, 70881,
     /*   48743 */     GIR_EraseRootFromParent_Done,
     /*   48744 */   // Label 793: @48744
     /*   48744 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48840), // Rule ID 52110 //
     /*   48749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48805 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48814 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48838 */     GIR_RootConstrainSelectedInstOperands,
     /*   48839 */     // GIR_Coverage, 52110,
     /*   48839 */     GIR_EraseRootFromParent_Done,
     /*   48840 */   // Label 794: @48840
     /*   48840 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48936), // Rule ID 52111 //
     /*   48845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48882 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48901 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48910 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48934 */     GIR_RootConstrainSelectedInstOperands,
     /*   48935 */     // GIR_Coverage, 52111,
     /*   48935 */     GIR_EraseRootFromParent_Done,
     /*   48936 */   // Label 795: @48936
     /*   48936 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49025), // Rule ID 46724 //
     /*   48941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48984 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   48984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   48987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49023 */     GIR_RootConstrainSelectedInstOperands,
     /*   49024 */     // GIR_Coverage, 46724,
     /*   49024 */     GIR_EraseRootFromParent_Done,
     /*   49025 */   // Label 796: @49025
     /*   49025 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49114), // Rule ID 46725 //
     /*   49030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49073 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49112 */     GIR_RootConstrainSelectedInstOperands,
     /*   49113 */     // GIR_Coverage, 46725,
     /*   49113 */     GIR_EraseRootFromParent_Done,
     /*   49114 */   // Label 797: @49114
     /*   49114 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49203), // Rule ID 46488 //
     /*   49119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49162 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49201 */     GIR_RootConstrainSelectedInstOperands,
     /*   49202 */     // GIR_Coverage, 46488,
     /*   49202 */     GIR_EraseRootFromParent_Done,
     /*   49203 */   // Label 798: @49203
     /*   49203 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49292), // Rule ID 46489 //
     /*   49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49251 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49290 */     GIR_RootConstrainSelectedInstOperands,
     /*   49291 */     // GIR_Coverage, 46489,
     /*   49291 */     GIR_EraseRootFromParent_Done,
     /*   49292 */   // Label 799: @49292
     /*   49292 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49381), // Rule ID 46604 //
     /*   49297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49340 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49379 */     GIR_RootConstrainSelectedInstOperands,
     /*   49380 */     // GIR_Coverage, 46604,
     /*   49380 */     GIR_EraseRootFromParent_Done,
     /*   49381 */   // Label 800: @49381
     /*   49381 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49470), // Rule ID 46605 //
     /*   49386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49429 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49468 */     GIR_RootConstrainSelectedInstOperands,
     /*   49469 */     // GIR_Coverage, 46605,
     /*   49469 */     GIR_EraseRootFromParent_Done,
     /*   49470 */   // Label 801: @49470
     /*   49470 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49538), // Rule ID 70512 //
     /*   49475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49512 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49536 */     GIR_RootConstrainSelectedInstOperands,
     /*   49537 */     // GIR_Coverage, 70512,
     /*   49537 */     GIR_EraseRootFromParent_Done,
     /*   49538 */   // Label 802: @49538
     /*   49538 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49606), // Rule ID 70513 //
     /*   49543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   49546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49580 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   49580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49604 */     GIR_RootConstrainSelectedInstOperands,
     /*   49605 */     // GIR_Coverage, 70513,
     /*   49605 */     GIR_EraseRootFromParent_Done,
     /*   49606 */   // Label 803: @49606
     /*   49606 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49661), // Rule ID 69416 //
     /*   49611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49639 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49659 */     GIR_RootConstrainSelectedInstOperands,
     /*   49660 */     // GIR_Coverage, 69416,
     /*   49660 */     GIR_EraseRootFromParent_Done,
     /*   49661 */   // Label 804: @49661
     /*   49661 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49716), // Rule ID 69417 //
     /*   49666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49694 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49714 */     GIR_RootConstrainSelectedInstOperands,
     /*   49715 */     // GIR_Coverage, 69417,
     /*   49715 */     GIR_EraseRootFromParent_Done,
     /*   49716 */   // Label 805: @49716
     /*   49716 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49771), // Rule ID 69236 //
     /*   49721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49749 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49769 */     GIR_RootConstrainSelectedInstOperands,
     /*   49770 */     // GIR_Coverage, 69236,
     /*   49770 */     GIR_EraseRootFromParent_Done,
     /*   49771 */   // Label 806: @49771
     /*   49771 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49826), // Rule ID 69237 //
     /*   49776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49804 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49824 */     GIR_RootConstrainSelectedInstOperands,
     /*   49825 */     // GIR_Coverage, 69237,
     /*   49825 */     GIR_EraseRootFromParent_Done,
     /*   49826 */   // Label 807: @49826
     /*   49826 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49881), // Rule ID 69326 //
     /*   49831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49859 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49879 */     GIR_RootConstrainSelectedInstOperands,
     /*   49880 */     // GIR_Coverage, 69326,
     /*   49880 */     GIR_EraseRootFromParent_Done,
     /*   49881 */   // Label 808: @49881
     /*   49881 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(49936), // Rule ID 69327 //
     /*   49886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49914 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49934 */     GIR_RootConstrainSelectedInstOperands,
     /*   49935 */     // GIR_Coverage, 69327,
     /*   49935 */     GIR_EraseRootFromParent_Done,
     /*   49936 */   // Label 809: @49936
     /*   49936 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50004), // Rule ID 51934 //
     /*   49941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49978 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50002 */     GIR_RootConstrainSelectedInstOperands,
     /*   50003 */     // GIR_Coverage, 51934,
     /*   50003 */     GIR_EraseRootFromParent_Done,
     /*   50004 */   // Label 810: @50004
     /*   50004 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50072), // Rule ID 51935 //
     /*   50009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50046 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50070 */     GIR_RootConstrainSelectedInstOperands,
     /*   50071 */     // GIR_Coverage, 51935,
     /*   50071 */     GIR_EraseRootFromParent_Done,
     /*   50072 */   // Label 811: @50072
     /*   50072 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50127), // Rule ID 46784 //
     /*   50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50105 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50125 */     GIR_RootConstrainSelectedInstOperands,
     /*   50126 */     // GIR_Coverage, 46784,
     /*   50126 */     GIR_EraseRootFromParent_Done,
     /*   50127 */   // Label 812: @50127
     /*   50127 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50182), // Rule ID 46785 //
     /*   50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50160 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50180 */     GIR_RootConstrainSelectedInstOperands,
     /*   50181 */     // GIR_Coverage, 46785,
     /*   50181 */     GIR_EraseRootFromParent_Done,
     /*   50182 */   // Label 813: @50182
     /*   50182 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50237), // Rule ID 46544 //
     /*   50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50215 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50235 */     GIR_RootConstrainSelectedInstOperands,
     /*   50236 */     // GIR_Coverage, 46544,
     /*   50236 */     GIR_EraseRootFromParent_Done,
     /*   50237 */   // Label 814: @50237
     /*   50237 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50292), // Rule ID 46545 //
     /*   50242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50270 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50290 */     GIR_RootConstrainSelectedInstOperands,
     /*   50291 */     // GIR_Coverage, 46545,
     /*   50291 */     GIR_EraseRootFromParent_Done,
     /*   50292 */   // Label 815: @50292
     /*   50292 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50347), // Rule ID 46664 //
     /*   50297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50325 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50345 */     GIR_RootConstrainSelectedInstOperands,
     /*   50346 */     // GIR_Coverage, 46664,
     /*   50346 */     GIR_EraseRootFromParent_Done,
     /*   50347 */   // Label 816: @50347
     /*   50347 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50402), // Rule ID 46665 //
     /*   50352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50380 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50400 */     GIR_RootConstrainSelectedInstOperands,
     /*   50401 */     // GIR_Coverage, 46665,
     /*   50401 */     GIR_EraseRootFromParent_Done,
     /*   50402 */   // Label 817: @50402
     /*   50402 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50455), // Rule ID 46166 //
     /*   50407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50418 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50453 */     GIR_RootConstrainSelectedInstOperands,
     /*   50454 */     // GIR_Coverage, 46166,
     /*   50454 */     GIR_EraseRootFromParent_Done,
     /*   50455 */   // Label 818: @50455
     /*   50455 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50508), // Rule ID 46167 //
     /*   50460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50471 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50506 */     GIR_RootConstrainSelectedInstOperands,
     /*   50507 */     // GIR_Coverage, 46167,
     /*   50507 */     GIR_EraseRootFromParent_Done,
     /*   50508 */   // Label 819: @50508
     /*   50508 */   GIM_Reject,
     /*   50509 */ // Label 779: @50509
     /*   50509 */ GIM_Reject,
     /*   50510 */ // Label 144: @50510
     /*   50510 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50904),
     /*   50515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50525 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50593), // Rule ID 70424 //
     /*   50530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50567 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50591 */     GIR_RootConstrainSelectedInstOperands,
     /*   50592 */     // GIR_Coverage, 70424,
     /*   50592 */     GIR_EraseRootFromParent_Done,
     /*   50593 */   // Label 821: @50593
     /*   50593 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50661), // Rule ID 70425 //
     /*   50598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50635 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50659 */     GIR_RootConstrainSelectedInstOperands,
     /*   50660 */     // GIR_Coverage, 70425,
     /*   50660 */     GIR_EraseRootFromParent_Done,
     /*   50661 */   // Label 822: @50661
     /*   50661 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50729), // Rule ID 51890 //
     /*   50666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50703 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50727 */     GIR_RootConstrainSelectedInstOperands,
     /*   50728 */     // GIR_Coverage, 51890,
     /*   50728 */     GIR_EraseRootFromParent_Done,
     /*   50729 */   // Label 823: @50729
     /*   50729 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50797), // Rule ID 51891 //
     /*   50734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50771 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50795 */     GIR_RootConstrainSelectedInstOperands,
     /*   50796 */     // GIR_Coverage, 51891,
     /*   50796 */     GIR_EraseRootFromParent_Done,
     /*   50797 */   // Label 824: @50797
     /*   50797 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50850), // Rule ID 46122 //
     /*   50802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50813 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   50813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50848 */     GIR_RootConstrainSelectedInstOperands,
     /*   50849 */     // GIR_Coverage, 46122,
     /*   50849 */     GIR_EraseRootFromParent_Done,
     /*   50850 */   // Label 825: @50850
     /*   50850 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(50903), // Rule ID 46123 //
     /*   50855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50866 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   50866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50901 */     GIR_RootConstrainSelectedInstOperands,
     /*   50902 */     // GIR_Coverage, 46123,
     /*   50902 */     GIR_EraseRootFromParent_Done,
     /*   50903 */   // Label 826: @50903
     /*   50903 */   GIM_Reject,
     /*   50904 */ // Label 820: @50904
     /*   50904 */ GIM_Reject,
     /*   50905 */ // Label 145: @50905
     /*   50905 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(54029),
     /*   50910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50920 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51016), // Rule ID 70570 //
     /*   50925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50990 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   50993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51014 */     GIR_RootConstrainSelectedInstOperands,
     /*   51015 */     // GIR_Coverage, 70570,
     /*   51015 */     GIR_EraseRootFromParent_Done,
     /*   51016 */   // Label 828: @51016
     /*   51016 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51112), // Rule ID 70571 //
     /*   51021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51086 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51110 */     GIR_RootConstrainSelectedInstOperands,
     /*   51111 */     // GIR_Coverage, 70571,
     /*   51111 */     GIR_EraseRootFromParent_Done,
     /*   51112 */   // Label 829: @51112
     /*   51112 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51208), // Rule ID 70822 //
     /*   51117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51182 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51206 */     GIR_RootConstrainSelectedInstOperands,
     /*   51207 */     // GIR_Coverage, 70822,
     /*   51207 */     GIR_EraseRootFromParent_Done,
     /*   51208 */   // Label 830: @51208
     /*   51208 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51304), // Rule ID 70823 //
     /*   51213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51278 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51302 */     GIR_RootConstrainSelectedInstOperands,
     /*   51303 */     // GIR_Coverage, 70823,
     /*   51303 */     GIR_EraseRootFromParent_Done,
     /*   51304 */   // Label 831: @51304
     /*   51304 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51400), // Rule ID 70824 //
     /*   51309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51374 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51398 */     GIR_RootConstrainSelectedInstOperands,
     /*   51399 */     // GIR_Coverage, 70824,
     /*   51399 */     GIR_EraseRootFromParent_Done,
     /*   51400 */   // Label 832: @51400
     /*   51400 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(51496), // Rule ID 70825 //
     /*   51405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51470 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51494 */     GIR_RootConstrainSelectedInstOperands,
     /*   51495 */     // GIR_Coverage, 70825,
     /*   51495 */     GIR_EraseRootFromParent_Done,
     /*   51496 */   // Label 833: @51496
     /*   51496 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51592), // Rule ID 70684 //
     /*   51501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51566 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51590 */     GIR_RootConstrainSelectedInstOperands,
     /*   51591 */     // GIR_Coverage, 70684,
     /*   51591 */     GIR_EraseRootFromParent_Done,
     /*   51592 */   // Label 834: @51592
     /*   51592 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51688), // Rule ID 70685 //
     /*   51597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51662 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51686 */     GIR_RootConstrainSelectedInstOperands,
     /*   51687 */     // GIR_Coverage, 70685,
     /*   51687 */     GIR_EraseRootFromParent_Done,
     /*   51688 */   // Label 835: @51688
     /*   51688 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51784), // Rule ID 52032 //
     /*   51693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51749 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51758 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51782 */     GIR_RootConstrainSelectedInstOperands,
     /*   51783 */     // GIR_Coverage, 52032,
     /*   51783 */     GIR_EraseRootFromParent_Done,
     /*   51784 */   // Label 836: @51784
     /*   51784 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51880), // Rule ID 52033 //
     /*   51789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51826 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51845 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51854 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51878 */     GIR_RootConstrainSelectedInstOperands,
     /*   51879 */     // GIR_Coverage, 52033,
     /*   51879 */     GIR_EraseRootFromParent_Done,
     /*   51880 */   // Label 837: @51880
     /*   51880 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51976), // Rule ID 52150 //
     /*   51885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51922 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51941 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51943 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51950 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51974 */     GIR_RootConstrainSelectedInstOperands,
     /*   51975 */     // GIR_Coverage, 52150,
     /*   51975 */     GIR_EraseRootFromParent_Done,
     /*   51976 */   // Label 838: @51976
     /*   51976 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52072), // Rule ID 52151 //
     /*   51981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52037 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52046 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52070 */     GIR_RootConstrainSelectedInstOperands,
     /*   52071 */     // GIR_Coverage, 52151,
     /*   52071 */     GIR_EraseRootFromParent_Done,
     /*   52072 */   // Label 839: @52072
     /*   52072 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52168), // Rule ID 70820 //
     /*   52077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52142 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52166 */     GIR_RootConstrainSelectedInstOperands,
     /*   52167 */     // GIR_Coverage, 70820,
     /*   52167 */     GIR_EraseRootFromParent_Done,
     /*   52168 */   // Label 840: @52168
     /*   52168 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52264), // Rule ID 70821 //
     /*   52173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52238 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52262 */     GIR_RootConstrainSelectedInstOperands,
     /*   52263 */     // GIR_Coverage, 70821,
     /*   52263 */     GIR_EraseRootFromParent_Done,
     /*   52264 */   // Label 841: @52264
     /*   52264 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52360), // Rule ID 52090 //
     /*   52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52334 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52358 */     GIR_RootConstrainSelectedInstOperands,
     /*   52359 */     // GIR_Coverage, 52090,
     /*   52359 */     GIR_EraseRootFromParent_Done,
     /*   52360 */   // Label 842: @52360
     /*   52360 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52456), // Rule ID 52091 //
     /*   52365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52430 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52454 */     GIR_RootConstrainSelectedInstOperands,
     /*   52455 */     // GIR_Coverage, 52091,
     /*   52455 */     GIR_EraseRootFromParent_Done,
     /*   52456 */   // Label 843: @52456
     /*   52456 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52545), // Rule ID 46684 //
     /*   52461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52495 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52504 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52543 */     GIR_RootConstrainSelectedInstOperands,
     /*   52544 */     // GIR_Coverage, 46684,
     /*   52544 */     GIR_EraseRootFromParent_Done,
     /*   52545 */   // Label 844: @52545
     /*   52545 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52634), // Rule ID 46685 //
     /*   52550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52593 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52632 */     GIR_RootConstrainSelectedInstOperands,
     /*   52633 */     // GIR_Coverage, 46685,
     /*   52633 */     GIR_EraseRootFromParent_Done,
     /*   52634 */   // Label 845: @52634
     /*   52634 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52723), // Rule ID 46448 //
     /*   52639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52673 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52682 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52721 */     GIR_RootConstrainSelectedInstOperands,
     /*   52722 */     // GIR_Coverage, 46448,
     /*   52722 */     GIR_EraseRootFromParent_Done,
     /*   52723 */   // Label 846: @52723
     /*   52723 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52812), // Rule ID 46449 //
     /*   52728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52762 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52771 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52810 */     GIR_RootConstrainSelectedInstOperands,
     /*   52811 */     // GIR_Coverage, 46449,
     /*   52811 */     GIR_EraseRootFromParent_Done,
     /*   52812 */   // Label 847: @52812
     /*   52812 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52901), // Rule ID 46564 //
     /*   52817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52851 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52860 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52899 */     GIR_RootConstrainSelectedInstOperands,
     /*   52900 */     // GIR_Coverage, 46564,
     /*   52900 */     GIR_EraseRootFromParent_Done,
     /*   52901 */   // Label 848: @52901
     /*   52901 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52990), // Rule ID 46565 //
     /*   52906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52949 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52988 */     GIR_RootConstrainSelectedInstOperands,
     /*   52989 */     // GIR_Coverage, 46565,
     /*   52989 */     GIR_EraseRootFromParent_Done,
     /*   52990 */   // Label 849: @52990
     /*   52990 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53058), // Rule ID 70456 //
     /*   52995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53032 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53056 */     GIR_RootConstrainSelectedInstOperands,
     /*   53057 */     // GIR_Coverage, 70456,
     /*   53057 */     GIR_EraseRootFromParent_Done,
     /*   53058 */   // Label 850: @53058
     /*   53058 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53126), // Rule ID 70457 //
     /*   53063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53100 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53124 */     GIR_RootConstrainSelectedInstOperands,
     /*   53125 */     // GIR_Coverage, 70457,
     /*   53125 */     GIR_EraseRootFromParent_Done,
     /*   53126 */   // Label 851: @53126
     /*   53126 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53181), // Rule ID 69376 //
     /*   53131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53159 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53179 */     GIR_RootConstrainSelectedInstOperands,
     /*   53180 */     // GIR_Coverage, 69376,
     /*   53180 */     GIR_EraseRootFromParent_Done,
     /*   53181 */   // Label 852: @53181
     /*   53181 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53236), // Rule ID 69377 //
     /*   53186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53214 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53234 */     GIR_RootConstrainSelectedInstOperands,
     /*   53235 */     // GIR_Coverage, 69377,
     /*   53235 */     GIR_EraseRootFromParent_Done,
     /*   53236 */   // Label 853: @53236
     /*   53236 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53291), // Rule ID 69196 //
     /*   53241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53269 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53289 */     GIR_RootConstrainSelectedInstOperands,
     /*   53290 */     // GIR_Coverage, 69196,
     /*   53290 */     GIR_EraseRootFromParent_Done,
     /*   53291 */   // Label 854: @53291
     /*   53291 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53346), // Rule ID 69197 //
     /*   53296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53324 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53344 */     GIR_RootConstrainSelectedInstOperands,
     /*   53345 */     // GIR_Coverage, 69197,
     /*   53345 */     GIR_EraseRootFromParent_Done,
     /*   53346 */   // Label 855: @53346
     /*   53346 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53401), // Rule ID 69286 //
     /*   53351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53379 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53399 */     GIR_RootConstrainSelectedInstOperands,
     /*   53400 */     // GIR_Coverage, 69286,
     /*   53400 */     GIR_EraseRootFromParent_Done,
     /*   53401 */   // Label 856: @53401
     /*   53401 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53456), // Rule ID 69287 //
     /*   53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53434 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53454 */     GIR_RootConstrainSelectedInstOperands,
     /*   53455 */     // GIR_Coverage, 69287,
     /*   53455 */     GIR_EraseRootFromParent_Done,
     /*   53456 */   // Label 857: @53456
     /*   53456 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53524), // Rule ID 51906 //
     /*   53461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53498 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53522 */     GIR_RootConstrainSelectedInstOperands,
     /*   53523 */     // GIR_Coverage, 51906,
     /*   53523 */     GIR_EraseRootFromParent_Done,
     /*   53524 */   // Label 858: @53524
     /*   53524 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53592), // Rule ID 51907 //
     /*   53529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53566 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53590 */     GIR_RootConstrainSelectedInstOperands,
     /*   53591 */     // GIR_Coverage, 51907,
     /*   53591 */     GIR_EraseRootFromParent_Done,
     /*   53592 */   // Label 859: @53592
     /*   53592 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53647), // Rule ID 46744 //
     /*   53597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53625 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53645 */     GIR_RootConstrainSelectedInstOperands,
     /*   53646 */     // GIR_Coverage, 46744,
     /*   53646 */     GIR_EraseRootFromParent_Done,
     /*   53647 */   // Label 860: @53647
     /*   53647 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53702), // Rule ID 46745 //
     /*   53652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53680 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53700 */     GIR_RootConstrainSelectedInstOperands,
     /*   53701 */     // GIR_Coverage, 46745,
     /*   53701 */     GIR_EraseRootFromParent_Done,
     /*   53702 */   // Label 861: @53702
     /*   53702 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53757), // Rule ID 46504 //
     /*   53707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53735 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53755 */     GIR_RootConstrainSelectedInstOperands,
     /*   53756 */     // GIR_Coverage, 46504,
     /*   53756 */     GIR_EraseRootFromParent_Done,
     /*   53757 */   // Label 862: @53757
     /*   53757 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53812), // Rule ID 46505 //
     /*   53762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53790 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53810 */     GIR_RootConstrainSelectedInstOperands,
     /*   53811 */     // GIR_Coverage, 46505,
     /*   53811 */     GIR_EraseRootFromParent_Done,
     /*   53812 */   // Label 863: @53812
     /*   53812 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53867), // Rule ID 46624 //
     /*   53817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53845 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53865 */     GIR_RootConstrainSelectedInstOperands,
     /*   53866 */     // GIR_Coverage, 46624,
     /*   53866 */     GIR_EraseRootFromParent_Done,
     /*   53867 */   // Label 864: @53867
     /*   53867 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53922), // Rule ID 46625 //
     /*   53872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53900 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53920 */     GIR_RootConstrainSelectedInstOperands,
     /*   53921 */     // GIR_Coverage, 46625,
     /*   53921 */     GIR_EraseRootFromParent_Done,
     /*   53922 */   // Label 865: @53922
     /*   53922 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53975), // Rule ID 46138 //
     /*   53927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53938 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   53938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53973 */     GIR_RootConstrainSelectedInstOperands,
     /*   53974 */     // GIR_Coverage, 46138,
     /*   53974 */     GIR_EraseRootFromParent_Done,
     /*   53975 */   // Label 866: @53975
     /*   53975 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54028), // Rule ID 46139 //
     /*   53980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53991 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   53991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54026 */     GIR_RootConstrainSelectedInstOperands,
     /*   54027 */     // GIR_Coverage, 46139,
     /*   54027 */     GIR_EraseRootFromParent_Done,
     /*   54028 */   // Label 867: @54028
     /*   54028 */   GIM_Reject,
     /*   54029 */ // Label 827: @54029
     /*   54029 */ GIM_Reject,
     /*   54030 */ // Label 146: @54030
     /*   54030 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(57154),
     /*   54035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54045 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54141), // Rule ID 70582 //
     /*   54050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54115 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54139 */     GIR_RootConstrainSelectedInstOperands,
     /*   54140 */     // GIR_Coverage, 70582,
     /*   54140 */     GIR_EraseRootFromParent_Done,
     /*   54141 */   // Label 869: @54141
     /*   54141 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54237), // Rule ID 70583 //
     /*   54146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54211 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54235 */     GIR_RootConstrainSelectedInstOperands,
     /*   54236 */     // GIR_Coverage, 70583,
     /*   54236 */     GIR_EraseRootFromParent_Done,
     /*   54237 */   // Label 870: @54237
     /*   54237 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54333), // Rule ID 70858 //
     /*   54242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54307 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54331 */     GIR_RootConstrainSelectedInstOperands,
     /*   54332 */     // GIR_Coverage, 70858,
     /*   54332 */     GIR_EraseRootFromParent_Done,
     /*   54333 */   // Label 871: @54333
     /*   54333 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54429), // Rule ID 70859 //
     /*   54338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54371 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54390 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54403 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54427 */     GIR_RootConstrainSelectedInstOperands,
     /*   54428 */     // GIR_Coverage, 70859,
     /*   54428 */     GIR_EraseRootFromParent_Done,
     /*   54429 */   // Label 872: @54429
     /*   54429 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54525), // Rule ID 70860 //
     /*   54434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54467 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54486 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54488 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54499 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54523 */     GIR_RootConstrainSelectedInstOperands,
     /*   54524 */     // GIR_Coverage, 70860,
     /*   54524 */     GIR_EraseRootFromParent_Done,
     /*   54525 */   // Label 873: @54525
     /*   54525 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54621), // Rule ID 70861 //
     /*   54530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54582 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54584 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54595 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54619 */     GIR_RootConstrainSelectedInstOperands,
     /*   54620 */     // GIR_Coverage, 70861,
     /*   54620 */     GIR_EraseRootFromParent_Done,
     /*   54621 */   // Label 874: @54621
     /*   54621 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54717), // Rule ID 70696 //
     /*   54626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54678 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54691 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54715 */     GIR_RootConstrainSelectedInstOperands,
     /*   54716 */     // GIR_Coverage, 70696,
     /*   54716 */     GIR_EraseRootFromParent_Done,
     /*   54717 */   // Label 875: @54717
     /*   54717 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54813), // Rule ID 70697 //
     /*   54722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54774 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54787 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54811 */     GIR_RootConstrainSelectedInstOperands,
     /*   54812 */     // GIR_Coverage, 70697,
     /*   54812 */     GIR_EraseRootFromParent_Done,
     /*   54813 */   // Label 876: @54813
     /*   54813 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54909), // Rule ID 52044 //
     /*   54818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54883 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54907 */     GIR_RootConstrainSelectedInstOperands,
     /*   54908 */     // GIR_Coverage, 52044,
     /*   54908 */     GIR_EraseRootFromParent_Done,
     /*   54909 */   // Label 877: @54909
     /*   54909 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55005), // Rule ID 52045 //
     /*   54914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54979 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55003 */     GIR_RootConstrainSelectedInstOperands,
     /*   55004 */     // GIR_Coverage, 52045,
     /*   55004 */     GIR_EraseRootFromParent_Done,
     /*   55005 */   // Label 878: @55005
     /*   55005 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55101), // Rule ID 52162 //
     /*   55010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55075 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55099 */     GIR_RootConstrainSelectedInstOperands,
     /*   55100 */     // GIR_Coverage, 52162,
     /*   55100 */     GIR_EraseRootFromParent_Done,
     /*   55101 */   // Label 879: @55101
     /*   55101 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55197), // Rule ID 52163 //
     /*   55106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55162 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55171 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55195 */     GIR_RootConstrainSelectedInstOperands,
     /*   55196 */     // GIR_Coverage, 52163,
     /*   55196 */     GIR_EraseRootFromParent_Done,
     /*   55197 */   // Label 880: @55197
     /*   55197 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55293), // Rule ID 70856 //
     /*   55202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55258 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55267 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55291 */     GIR_RootConstrainSelectedInstOperands,
     /*   55292 */     // GIR_Coverage, 70856,
     /*   55292 */     GIR_EraseRootFromParent_Done,
     /*   55293 */   // Label 881: @55293
     /*   55293 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55389), // Rule ID 70857 //
     /*   55298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55354 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55356 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55363 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55387 */     GIR_RootConstrainSelectedInstOperands,
     /*   55388 */     // GIR_Coverage, 70857,
     /*   55388 */     GIR_EraseRootFromParent_Done,
     /*   55389 */   // Label 882: @55389
     /*   55389 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55485), // Rule ID 52102 //
     /*   55394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55450 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55452 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55459 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55483 */     GIR_RootConstrainSelectedInstOperands,
     /*   55484 */     // GIR_Coverage, 52102,
     /*   55484 */     GIR_EraseRootFromParent_Done,
     /*   55485 */   // Label 883: @55485
     /*   55485 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55581), // Rule ID 52103 //
     /*   55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55546 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55548 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55555 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55579 */     GIR_RootConstrainSelectedInstOperands,
     /*   55580 */     // GIR_Coverage, 52103,
     /*   55580 */     GIR_EraseRootFromParent_Done,
     /*   55581 */   // Label 884: @55581
     /*   55581 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55670), // Rule ID 46708 //
     /*   55586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55620 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55629 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55668 */     GIR_RootConstrainSelectedInstOperands,
     /*   55669 */     // GIR_Coverage, 46708,
     /*   55669 */     GIR_EraseRootFromParent_Done,
     /*   55670 */   // Label 885: @55670
     /*   55670 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55759), // Rule ID 46709 //
     /*   55675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55709 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55718 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55757 */     GIR_RootConstrainSelectedInstOperands,
     /*   55758 */     // GIR_Coverage, 46709,
     /*   55758 */     GIR_EraseRootFromParent_Done,
     /*   55759 */   // Label 886: @55759
     /*   55759 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55848), // Rule ID 46472 //
     /*   55764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55798 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55807 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55846 */     GIR_RootConstrainSelectedInstOperands,
     /*   55847 */     // GIR_Coverage, 46472,
     /*   55847 */     GIR_EraseRootFromParent_Done,
     /*   55848 */   // Label 887: @55848
     /*   55848 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55937), // Rule ID 46473 //
     /*   55853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55887 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55896 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55935 */     GIR_RootConstrainSelectedInstOperands,
     /*   55936 */     // GIR_Coverage, 46473,
     /*   55936 */     GIR_EraseRootFromParent_Done,
     /*   55937 */   // Label 888: @55937
     /*   55937 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(56026), // Rule ID 46588 //
     /*   55942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55976 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55985 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56024 */     GIR_RootConstrainSelectedInstOperands,
     /*   56025 */     // GIR_Coverage, 46588,
     /*   56025 */     GIR_EraseRootFromParent_Done,
     /*   56026 */   // Label 889: @56026
     /*   56026 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56115), // Rule ID 46589 //
     /*   56031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56046 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56065 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56074 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56113 */     GIR_RootConstrainSelectedInstOperands,
     /*   56114 */     // GIR_Coverage, 46589,
     /*   56114 */     GIR_EraseRootFromParent_Done,
     /*   56115 */   // Label 890: @56115
     /*   56115 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56183), // Rule ID 70488 //
     /*   56120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56157 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56181 */     GIR_RootConstrainSelectedInstOperands,
     /*   56182 */     // GIR_Coverage, 70488,
     /*   56182 */     GIR_EraseRootFromParent_Done,
     /*   56183 */   // Label 891: @56183
     /*   56183 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56251), // Rule ID 70489 //
     /*   56188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56225 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56249 */     GIR_RootConstrainSelectedInstOperands,
     /*   56250 */     // GIR_Coverage, 70489,
     /*   56250 */     GIR_EraseRootFromParent_Done,
     /*   56251 */   // Label 892: @56251
     /*   56251 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56306), // Rule ID 69400 //
     /*   56256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56284 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56304 */     GIR_RootConstrainSelectedInstOperands,
     /*   56305 */     // GIR_Coverage, 69400,
     /*   56305 */     GIR_EraseRootFromParent_Done,
     /*   56306 */   // Label 893: @56306
     /*   56306 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56361), // Rule ID 69401 //
     /*   56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56339 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56359 */     GIR_RootConstrainSelectedInstOperands,
     /*   56360 */     // GIR_Coverage, 69401,
     /*   56360 */     GIR_EraseRootFromParent_Done,
     /*   56361 */   // Label 894: @56361
     /*   56361 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56416), // Rule ID 69220 //
     /*   56366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56394 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56414 */     GIR_RootConstrainSelectedInstOperands,
     /*   56415 */     // GIR_Coverage, 69220,
     /*   56415 */     GIR_EraseRootFromParent_Done,
     /*   56416 */   // Label 895: @56416
     /*   56416 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56471), // Rule ID 69221 //
     /*   56421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56449 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56469 */     GIR_RootConstrainSelectedInstOperands,
     /*   56470 */     // GIR_Coverage, 69221,
     /*   56470 */     GIR_EraseRootFromParent_Done,
     /*   56471 */   // Label 896: @56471
     /*   56471 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56526), // Rule ID 69310 //
     /*   56476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56504 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56524 */     GIR_RootConstrainSelectedInstOperands,
     /*   56525 */     // GIR_Coverage, 69310,
     /*   56525 */     GIR_EraseRootFromParent_Done,
     /*   56526 */   // Label 897: @56526
     /*   56526 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56581), // Rule ID 69311 //
     /*   56531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56559 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56579 */     GIR_RootConstrainSelectedInstOperands,
     /*   56580 */     // GIR_Coverage, 69311,
     /*   56580 */     GIR_EraseRootFromParent_Done,
     /*   56581 */   // Label 898: @56581
     /*   56581 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56649), // Rule ID 51922 //
     /*   56586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56623 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56647 */     GIR_RootConstrainSelectedInstOperands,
     /*   56648 */     // GIR_Coverage, 51922,
     /*   56648 */     GIR_EraseRootFromParent_Done,
     /*   56649 */   // Label 899: @56649
     /*   56649 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56717), // Rule ID 51923 //
     /*   56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56691 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56715 */     GIR_RootConstrainSelectedInstOperands,
     /*   56716 */     // GIR_Coverage, 51923,
     /*   56716 */     GIR_EraseRootFromParent_Done,
     /*   56717 */   // Label 900: @56717
     /*   56717 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56772), // Rule ID 46768 //
     /*   56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56750 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56770 */     GIR_RootConstrainSelectedInstOperands,
     /*   56771 */     // GIR_Coverage, 46768,
     /*   56771 */     GIR_EraseRootFromParent_Done,
     /*   56772 */   // Label 901: @56772
     /*   56772 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56827), // Rule ID 46769 //
     /*   56777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56805 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56825 */     GIR_RootConstrainSelectedInstOperands,
     /*   56826 */     // GIR_Coverage, 46769,
     /*   56826 */     GIR_EraseRootFromParent_Done,
     /*   56827 */   // Label 902: @56827
     /*   56827 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56882), // Rule ID 46528 //
     /*   56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56860 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56880 */     GIR_RootConstrainSelectedInstOperands,
     /*   56881 */     // GIR_Coverage, 46528,
     /*   56881 */     GIR_EraseRootFromParent_Done,
     /*   56882 */   // Label 903: @56882
     /*   56882 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56937), // Rule ID 46529 //
     /*   56887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56915 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56935 */     GIR_RootConstrainSelectedInstOperands,
     /*   56936 */     // GIR_Coverage, 46529,
     /*   56936 */     GIR_EraseRootFromParent_Done,
     /*   56937 */   // Label 904: @56937
     /*   56937 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56992), // Rule ID 46648 //
     /*   56942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56970 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56990 */     GIR_RootConstrainSelectedInstOperands,
     /*   56991 */     // GIR_Coverage, 46648,
     /*   56991 */     GIR_EraseRootFromParent_Done,
     /*   56992 */   // Label 905: @56992
     /*   56992 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57047), // Rule ID 46649 //
     /*   56997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57025 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57045 */     GIR_RootConstrainSelectedInstOperands,
     /*   57046 */     // GIR_Coverage, 46649,
     /*   57046 */     GIR_EraseRootFromParent_Done,
     /*   57047 */   // Label 906: @57047
     /*   57047 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57100), // Rule ID 46154 //
     /*   57052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57063 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57098 */     GIR_RootConstrainSelectedInstOperands,
     /*   57099 */     // GIR_Coverage, 46154,
     /*   57099 */     GIR_EraseRootFromParent_Done,
     /*   57100 */   // Label 907: @57100
     /*   57100 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57153), // Rule ID 46155 //
     /*   57105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57116 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57151 */     GIR_RootConstrainSelectedInstOperands,
     /*   57152 */     // GIR_Coverage, 46155,
     /*   57152 */     GIR_EraseRootFromParent_Done,
     /*   57153 */   // Label 908: @57153
     /*   57153 */   GIM_Reject,
     /*   57154 */ // Label 868: @57154
     /*   57154 */ GIM_Reject,
     /*   57155 */ // Label 147: @57155
     /*   57155 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57549),
     /*   57160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57170 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57238), // Rule ID 70432 //
     /*   57175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57212 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57236 */     GIR_RootConstrainSelectedInstOperands,
     /*   57237 */     // GIR_Coverage, 70432,
     /*   57237 */     GIR_EraseRootFromParent_Done,
     /*   57238 */   // Label 910: @57238
     /*   57238 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57306), // Rule ID 70433 //
     /*   57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57280 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57304 */     GIR_RootConstrainSelectedInstOperands,
     /*   57305 */     // GIR_Coverage, 70433,
     /*   57305 */     GIR_EraseRootFromParent_Done,
     /*   57306 */   // Label 911: @57306
     /*   57306 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57374), // Rule ID 51894 //
     /*   57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57348 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57372 */     GIR_RootConstrainSelectedInstOperands,
     /*   57373 */     // GIR_Coverage, 51894,
     /*   57373 */     GIR_EraseRootFromParent_Done,
     /*   57374 */   // Label 912: @57374
     /*   57374 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57442), // Rule ID 51895 //
     /*   57379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57416 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57440 */     GIR_RootConstrainSelectedInstOperands,
     /*   57441 */     // GIR_Coverage, 51895,
     /*   57441 */     GIR_EraseRootFromParent_Done,
     /*   57442 */   // Label 913: @57442
     /*   57442 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57495), // Rule ID 46126 //
     /*   57447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57458 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57493 */     GIR_RootConstrainSelectedInstOperands,
     /*   57494 */     // GIR_Coverage, 46126,
     /*   57494 */     GIR_EraseRootFromParent_Done,
     /*   57495 */   // Label 914: @57495
     /*   57495 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57548), // Rule ID 46127 //
     /*   57500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57511 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57546 */     GIR_RootConstrainSelectedInstOperands,
     /*   57547 */     // GIR_Coverage, 46127,
     /*   57547 */     GIR_EraseRootFromParent_Done,
     /*   57548 */   // Label 915: @57548
     /*   57548 */   GIM_Reject,
     /*   57549 */ // Label 909: @57549
     /*   57549 */ GIM_Reject,
     /*   57550 */ // Label 148: @57550
     /*   57550 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(60674),
     /*   57555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57565 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57661), // Rule ID 70572 //
     /*   57570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57635 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57659 */     GIR_RootConstrainSelectedInstOperands,
     /*   57660 */     // GIR_Coverage, 70572,
     /*   57660 */     GIR_EraseRootFromParent_Done,
     /*   57661 */   // Label 917: @57661
     /*   57661 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57757), // Rule ID 70573 //
     /*   57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57731 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57755 */     GIR_RootConstrainSelectedInstOperands,
     /*   57756 */     // GIR_Coverage, 70573,
     /*   57756 */     GIR_EraseRootFromParent_Done,
     /*   57757 */   // Label 918: @57757
     /*   57757 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57853), // Rule ID 70828 //
     /*   57762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57827 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57851 */     GIR_RootConstrainSelectedInstOperands,
     /*   57852 */     // GIR_Coverage, 70828,
     /*   57852 */     GIR_EraseRootFromParent_Done,
     /*   57853 */   // Label 919: @57853
     /*   57853 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57949), // Rule ID 70829 //
     /*   57858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57923 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57947 */     GIR_RootConstrainSelectedInstOperands,
     /*   57948 */     // GIR_Coverage, 70829,
     /*   57948 */     GIR_EraseRootFromParent_Done,
     /*   57949 */   // Label 920: @57949
     /*   57949 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58045), // Rule ID 70830 //
     /*   57954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58019 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58043 */     GIR_RootConstrainSelectedInstOperands,
     /*   58044 */     // GIR_Coverage, 70830,
     /*   58044 */     GIR_EraseRootFromParent_Done,
     /*   58045 */   // Label 921: @58045
     /*   58045 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(58141), // Rule ID 70831 //
     /*   58050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58115 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58139 */     GIR_RootConstrainSelectedInstOperands,
     /*   58140 */     // GIR_Coverage, 70831,
     /*   58140 */     GIR_EraseRootFromParent_Done,
     /*   58141 */   // Label 922: @58141
     /*   58141 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58237), // Rule ID 70686 //
     /*   58146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58211 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58235 */     GIR_RootConstrainSelectedInstOperands,
     /*   58236 */     // GIR_Coverage, 70686,
     /*   58236 */     GIR_EraseRootFromParent_Done,
     /*   58237 */   // Label 923: @58237
     /*   58237 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58333), // Rule ID 70687 //
     /*   58242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58307 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58331 */     GIR_RootConstrainSelectedInstOperands,
     /*   58332 */     // GIR_Coverage, 70687,
     /*   58332 */     GIR_EraseRootFromParent_Done,
     /*   58333 */   // Label 924: @58333
     /*   58333 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58429), // Rule ID 52034 //
     /*   58338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58375 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58394 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58403 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58427 */     GIR_RootConstrainSelectedInstOperands,
     /*   58428 */     // GIR_Coverage, 52034,
     /*   58428 */     GIR_EraseRootFromParent_Done,
     /*   58429 */   // Label 925: @58429
     /*   58429 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58525), // Rule ID 52035 //
     /*   58434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58490 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58492 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58499 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58523 */     GIR_RootConstrainSelectedInstOperands,
     /*   58524 */     // GIR_Coverage, 52035,
     /*   58524 */     GIR_EraseRootFromParent_Done,
     /*   58525 */   // Label 926: @58525
     /*   58525 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58621), // Rule ID 52152 //
     /*   58530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58567 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58586 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58588 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58595 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58619 */     GIR_RootConstrainSelectedInstOperands,
     /*   58620 */     // GIR_Coverage, 52152,
     /*   58620 */     GIR_EraseRootFromParent_Done,
     /*   58621 */   // Label 927: @58621
     /*   58621 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58717), // Rule ID 52153 //
     /*   58626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58663 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58682 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58691 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58715 */     GIR_RootConstrainSelectedInstOperands,
     /*   58716 */     // GIR_Coverage, 52153,
     /*   58716 */     GIR_EraseRootFromParent_Done,
     /*   58717 */   // Label 928: @58717
     /*   58717 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58813), // Rule ID 70826 //
     /*   58722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58778 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58787 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58811 */     GIR_RootConstrainSelectedInstOperands,
     /*   58812 */     // GIR_Coverage, 70826,
     /*   58812 */     GIR_EraseRootFromParent_Done,
     /*   58813 */   // Label 929: @58813
     /*   58813 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58909), // Rule ID 70827 //
     /*   58818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58883 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58907 */     GIR_RootConstrainSelectedInstOperands,
     /*   58908 */     // GIR_Coverage, 70827,
     /*   58908 */     GIR_EraseRootFromParent_Done,
     /*   58909 */   // Label 930: @58909
     /*   58909 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(59005), // Rule ID 52092 //
     /*   58914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58979 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59003 */     GIR_RootConstrainSelectedInstOperands,
     /*   59004 */     // GIR_Coverage, 52092,
     /*   59004 */     GIR_EraseRootFromParent_Done,
     /*   59005 */   // Label 931: @59005
     /*   59005 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(59101), // Rule ID 52093 //
     /*   59010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59075 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59099 */     GIR_RootConstrainSelectedInstOperands,
     /*   59100 */     // GIR_Coverage, 52093,
     /*   59100 */     GIR_EraseRootFromParent_Done,
     /*   59101 */   // Label 932: @59101
     /*   59101 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59190), // Rule ID 46688 //
     /*   59106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59149 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59188 */     GIR_RootConstrainSelectedInstOperands,
     /*   59189 */     // GIR_Coverage, 46688,
     /*   59189 */     GIR_EraseRootFromParent_Done,
     /*   59190 */   // Label 933: @59190
     /*   59190 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59279), // Rule ID 46689 //
     /*   59195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59238 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59277 */     GIR_RootConstrainSelectedInstOperands,
     /*   59278 */     // GIR_Coverage, 46689,
     /*   59278 */     GIR_EraseRootFromParent_Done,
     /*   59279 */   // Label 934: @59279
     /*   59279 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59368), // Rule ID 46452 //
     /*   59284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59327 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59366 */     GIR_RootConstrainSelectedInstOperands,
     /*   59367 */     // GIR_Coverage, 46452,
     /*   59367 */     GIR_EraseRootFromParent_Done,
     /*   59368 */   // Label 935: @59368
     /*   59368 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59457), // Rule ID 46453 //
     /*   59373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59407 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59416 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59455 */     GIR_RootConstrainSelectedInstOperands,
     /*   59456 */     // GIR_Coverage, 46453,
     /*   59456 */     GIR_EraseRootFromParent_Done,
     /*   59457 */   // Label 936: @59457
     /*   59457 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59546), // Rule ID 46568 //
     /*   59462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59505 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59544 */     GIR_RootConstrainSelectedInstOperands,
     /*   59545 */     // GIR_Coverage, 46568,
     /*   59545 */     GIR_EraseRootFromParent_Done,
     /*   59546 */   // Label 937: @59546
     /*   59546 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59635), // Rule ID 46569 //
     /*   59551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59594 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59633 */     GIR_RootConstrainSelectedInstOperands,
     /*   59634 */     // GIR_Coverage, 46569,
     /*   59634 */     GIR_EraseRootFromParent_Done,
     /*   59635 */   // Label 938: @59635
     /*   59635 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59703), // Rule ID 70464 //
     /*   59640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59677 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59701 */     GIR_RootConstrainSelectedInstOperands,
     /*   59702 */     // GIR_Coverage, 70464,
     /*   59702 */     GIR_EraseRootFromParent_Done,
     /*   59703 */   // Label 939: @59703
     /*   59703 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59771), // Rule ID 70465 //
     /*   59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59745 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59769 */     GIR_RootConstrainSelectedInstOperands,
     /*   59770 */     // GIR_Coverage, 70465,
     /*   59770 */     GIR_EraseRootFromParent_Done,
     /*   59771 */   // Label 940: @59771
     /*   59771 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59826), // Rule ID 69380 //
     /*   59776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59804 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59824 */     GIR_RootConstrainSelectedInstOperands,
     /*   59825 */     // GIR_Coverage, 69380,
     /*   59825 */     GIR_EraseRootFromParent_Done,
     /*   59826 */   // Label 941: @59826
     /*   59826 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59881), // Rule ID 69381 //
     /*   59831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59859 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59879 */     GIR_RootConstrainSelectedInstOperands,
     /*   59880 */     // GIR_Coverage, 69381,
     /*   59880 */     GIR_EraseRootFromParent_Done,
     /*   59881 */   // Label 942: @59881
     /*   59881 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(59936), // Rule ID 69200 //
     /*   59886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59914 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59934 */     GIR_RootConstrainSelectedInstOperands,
     /*   59935 */     // GIR_Coverage, 69200,
     /*   59935 */     GIR_EraseRootFromParent_Done,
     /*   59936 */   // Label 943: @59936
     /*   59936 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(59991), // Rule ID 69201 //
     /*   59941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59969 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59989 */     GIR_RootConstrainSelectedInstOperands,
     /*   59990 */     // GIR_Coverage, 69201,
     /*   59990 */     GIR_EraseRootFromParent_Done,
     /*   59991 */   // Label 944: @59991
     /*   59991 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60046), // Rule ID 69290 //
     /*   59996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60024 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60044 */     GIR_RootConstrainSelectedInstOperands,
     /*   60045 */     // GIR_Coverage, 69290,
     /*   60045 */     GIR_EraseRootFromParent_Done,
     /*   60046 */   // Label 945: @60046
     /*   60046 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60101), // Rule ID 69291 //
     /*   60051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60079 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60099 */     GIR_RootConstrainSelectedInstOperands,
     /*   60100 */     // GIR_Coverage, 69291,
     /*   60100 */     GIR_EraseRootFromParent_Done,
     /*   60101 */   // Label 946: @60101
     /*   60101 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60169), // Rule ID 51910 //
     /*   60106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60143 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60167 */     GIR_RootConstrainSelectedInstOperands,
     /*   60168 */     // GIR_Coverage, 51910,
     /*   60168 */     GIR_EraseRootFromParent_Done,
     /*   60169 */   // Label 947: @60169
     /*   60169 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60237), // Rule ID 51911 //
     /*   60174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60211 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60235 */     GIR_RootConstrainSelectedInstOperands,
     /*   60236 */     // GIR_Coverage, 51911,
     /*   60236 */     GIR_EraseRootFromParent_Done,
     /*   60237 */   // Label 948: @60237
     /*   60237 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60292), // Rule ID 46748 //
     /*   60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60270 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60290 */     GIR_RootConstrainSelectedInstOperands,
     /*   60291 */     // GIR_Coverage, 46748,
     /*   60291 */     GIR_EraseRootFromParent_Done,
     /*   60292 */   // Label 949: @60292
     /*   60292 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60347), // Rule ID 46749 //
     /*   60297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60325 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60345 */     GIR_RootConstrainSelectedInstOperands,
     /*   60346 */     // GIR_Coverage, 46749,
     /*   60346 */     GIR_EraseRootFromParent_Done,
     /*   60347 */   // Label 950: @60347
     /*   60347 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60402), // Rule ID 46508 //
     /*   60352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60380 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60400 */     GIR_RootConstrainSelectedInstOperands,
     /*   60401 */     // GIR_Coverage, 46508,
     /*   60401 */     GIR_EraseRootFromParent_Done,
     /*   60402 */   // Label 951: @60402
     /*   60402 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60457), // Rule ID 46509 //
     /*   60407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60435 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60455 */     GIR_RootConstrainSelectedInstOperands,
     /*   60456 */     // GIR_Coverage, 46509,
     /*   60456 */     GIR_EraseRootFromParent_Done,
     /*   60457 */   // Label 952: @60457
     /*   60457 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60512), // Rule ID 46628 //
     /*   60462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60490 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60510 */     GIR_RootConstrainSelectedInstOperands,
     /*   60511 */     // GIR_Coverage, 46628,
     /*   60511 */     GIR_EraseRootFromParent_Done,
     /*   60512 */   // Label 953: @60512
     /*   60512 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60567), // Rule ID 46629 //
     /*   60517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60545 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60565 */     GIR_RootConstrainSelectedInstOperands,
     /*   60566 */     // GIR_Coverage, 46629,
     /*   60566 */     GIR_EraseRootFromParent_Done,
     /*   60567 */   // Label 954: @60567
     /*   60567 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60620), // Rule ID 46142 //
     /*   60572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60583 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   60583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60618 */     GIR_RootConstrainSelectedInstOperands,
     /*   60619 */     // GIR_Coverage, 46142,
     /*   60619 */     GIR_EraseRootFromParent_Done,
     /*   60620 */   // Label 955: @60620
     /*   60620 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60673), // Rule ID 46143 //
     /*   60625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60636 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   60636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60671 */     GIR_RootConstrainSelectedInstOperands,
     /*   60672 */     // GIR_Coverage, 46143,
     /*   60672 */     GIR_EraseRootFromParent_Done,
     /*   60673 */   // Label 956: @60673
     /*   60673 */   GIM_Reject,
     /*   60674 */ // Label 916: @60674
     /*   60674 */ GIM_Reject,
     /*   60675 */ // Label 149: @60675
     /*   60675 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(61069),
     /*   60680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60690 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60758), // Rule ID 70440 //
     /*   60695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60732 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60756 */     GIR_RootConstrainSelectedInstOperands,
     /*   60757 */     // GIR_Coverage, 70440,
     /*   60757 */     GIR_EraseRootFromParent_Done,
     /*   60758 */   // Label 958: @60758
     /*   60758 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60826), // Rule ID 70441 //
     /*   60763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60800 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60824 */     GIR_RootConstrainSelectedInstOperands,
     /*   60825 */     // GIR_Coverage, 70441,
     /*   60825 */     GIR_EraseRootFromParent_Done,
     /*   60826 */   // Label 959: @60826
     /*   60826 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(60894), // Rule ID 51898 //
     /*   60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60868 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60892 */     GIR_RootConstrainSelectedInstOperands,
     /*   60893 */     // GIR_Coverage, 51898,
     /*   60893 */     GIR_EraseRootFromParent_Done,
     /*   60894 */   // Label 960: @60894
     /*   60894 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(60962), // Rule ID 51899 //
     /*   60899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60936 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60960 */     GIR_RootConstrainSelectedInstOperands,
     /*   60961 */     // GIR_Coverage, 51899,
     /*   60961 */     GIR_EraseRootFromParent_Done,
     /*   60962 */   // Label 961: @60962
     /*   60962 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61015), // Rule ID 46130 //
     /*   60967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60978 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   60978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   60981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61013 */     GIR_RootConstrainSelectedInstOperands,
     /*   61014 */     // GIR_Coverage, 46130,
     /*   61014 */     GIR_EraseRootFromParent_Done,
     /*   61015 */   // Label 962: @61015
     /*   61015 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61068), // Rule ID 46131 //
     /*   61020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61031 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61066 */     GIR_RootConstrainSelectedInstOperands,
     /*   61067 */     // GIR_Coverage, 46131,
     /*   61067 */     GIR_EraseRootFromParent_Done,
     /*   61068 */   // Label 963: @61068
     /*   61068 */   GIM_Reject,
     /*   61069 */ // Label 957: @61069
     /*   61069 */ GIM_Reject,
     /*   61070 */ // Label 150: @61070
     /*   61070 */ GIM_Reject,
     /*   61071 */ // Label 1: @61071
     /*   61071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 988*/ GIMT_Encode4(80303),
     /*   61082 */ /*GILLT_s32*//*Label 964*/ GIMT_Encode4(61206),
     /*   61086 */ /*GILLT_s64*//*Label 965*/ GIMT_Encode4(61453), GIMT_Encode4(0),
     /*   61094 */ /*GILLT_nxv1s8*//*Label 966*/ GIMT_Encode4(61729),
     /*   61098 */ /*GILLT_nxv1s16*//*Label 967*/ GIMT_Encode4(61976),
     /*   61102 */ /*GILLT_nxv1s32*//*Label 968*/ GIMT_Encode4(63099),
     /*   61106 */ /*GILLT_nxv1s64*//*Label 969*/ GIMT_Encode4(64222), GIMT_Encode4(0),
     /*   61114 */ /*GILLT_nxv2s8*//*Label 970*/ GIMT_Encode4(65345),
     /*   61118 */ /*GILLT_nxv2s16*//*Label 971*/ GIMT_Encode4(65592),
     /*   61122 */ /*GILLT_nxv2s32*//*Label 972*/ GIMT_Encode4(66715),
     /*   61126 */ /*GILLT_nxv2s64*//*Label 973*/ GIMT_Encode4(67838), GIMT_Encode4(0),
     /*   61134 */ /*GILLT_nxv4s8*//*Label 974*/ GIMT_Encode4(68961),
     /*   61138 */ /*GILLT_nxv4s16*//*Label 975*/ GIMT_Encode4(69208),
     /*   61142 */ /*GILLT_nxv4s32*//*Label 976*/ GIMT_Encode4(70331),
     /*   61146 */ /*GILLT_nxv4s64*//*Label 977*/ GIMT_Encode4(71454), GIMT_Encode4(0),
     /*   61154 */ /*GILLT_nxv8s8*//*Label 978*/ GIMT_Encode4(72577),
     /*   61158 */ /*GILLT_nxv8s16*//*Label 979*/ GIMT_Encode4(72824),
     /*   61162 */ /*GILLT_nxv8s32*//*Label 980*/ GIMT_Encode4(73947),
     /*   61166 */ /*GILLT_nxv8s64*//*Label 981*/ GIMT_Encode4(75070), GIMT_Encode4(0),
     /*   61174 */ /*GILLT_nxv16s8*//*Label 982*/ GIMT_Encode4(76193),
     /*   61178 */ /*GILLT_nxv16s16*//*Label 983*/ GIMT_Encode4(76440),
     /*   61182 */ /*GILLT_nxv16s32*//*Label 984*/ GIMT_Encode4(77563), GIMT_Encode4(0),
     /*   61190 */ /*GILLT_nxv32s8*//*Label 985*/ GIMT_Encode4(78686),
     /*   61194 */ /*GILLT_nxv32s16*//*Label 986*/ GIMT_Encode4(78933), GIMT_Encode4(0),
     /*   61202 */ /*GILLT_nxv64s8*//*Label 987*/ GIMT_Encode4(80056),
     /*   61206 */ // Label 964: @61206
     /*   61206 */ GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(61452),
     /*   61211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61221 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(61296), // Rule ID 98 //
     /*   61226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61262 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61294 */     GIR_RootConstrainSelectedInstOperands,
     /*   61295 */     // GIR_Coverage, 98,
     /*   61295 */     GIR_EraseRootFromParent_Done,
     /*   61296 */   // Label 990: @61296
     /*   61296 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(61371), // Rule ID 99 //
     /*   61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61337 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61369 */     GIR_RootConstrainSelectedInstOperands,
     /*   61370 */     // GIR_Coverage, 99,
     /*   61370 */     GIR_EraseRootFromParent_Done,
     /*   61371 */   // Label 991: @61371
     /*   61371 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(61428), // Rule ID 62589 //
     /*   61376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61411 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61426 */     GIR_RootConstrainSelectedInstOperands,
     /*   61427 */     // GIR_Coverage, 62589,
     /*   61427 */     GIR_EraseRootFromParent_Done,
     /*   61428 */   // Label 992: @61428
     /*   61428 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(61451), // Rule ID 77 //
     /*   61433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61444 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61449 */     GIR_RootConstrainSelectedInstOperands,
     /*   61450 */     // GIR_Coverage, 77,
     /*   61450 */     GIR_Done,
     /*   61451 */   // Label 993: @61451
     /*   61451 */   GIM_Reject,
     /*   61452 */ // Label 989: @61452
     /*   61452 */ GIM_Reject,
     /*   61453 */ // Label 965: @61453
     /*   61453 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(61728),
     /*   61458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61464 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61543), // Rule ID 100 //
     /*   61469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61509 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   61528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   61541 */     GIR_RootConstrainSelectedInstOperands,
     /*   61542 */     // GIR_Coverage, 100,
     /*   61542 */     GIR_EraseRootFromParent_Done,
     /*   61543 */   // Label 995: @61543
     /*   61543 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61608), // Rule ID 62591 //
     /*   61548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   61551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10050),
     /*   61589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61591 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10050>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   61594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61606 */     GIR_RootConstrainSelectedInstOperands,
     /*   61607 */     // GIR_Coverage, 62591,
     /*   61607 */     GIR_EraseRootFromParent_Done,
     /*   61608 */   // Label 996: @61608
     /*   61608 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61669), // Rule ID 62588 //
     /*   61613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   61616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61652 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61667 */     GIR_RootConstrainSelectedInstOperands,
     /*   61668 */     // GIR_Coverage, 62588,
     /*   61668 */     GIR_EraseRootFromParent_Done,
     /*   61669 */   // Label 997: @61669
     /*   61669 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61700), // Rule ID 267 //
     /*   61674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10050),
     /*   61693 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10050>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   61698 */     GIR_RootConstrainSelectedInstOperands,
     /*   61699 */     // GIR_Coverage, 267,
     /*   61699 */     GIR_Done,
     /*   61700 */   // Label 998: @61700
     /*   61700 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61727), // Rule ID 76 //
     /*   61705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   61708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61720 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61725 */     GIR_RootConstrainSelectedInstOperands,
     /*   61726 */     // GIR_Coverage, 76,
     /*   61726 */     GIR_Done,
     /*   61727 */   // Label 999: @61727
     /*   61727 */   GIM_Reject,
     /*   61728 */ // Label 994: @61728
     /*   61728 */ GIM_Reject,
     /*   61729 */ // Label 966: @61729
     /*   61729 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61975),
     /*   61734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61748 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61812), // Rule ID 51938 //
     /*   61753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61786 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61810 */     GIR_RootConstrainSelectedInstOperands,
     /*   61811 */     // GIR_Coverage, 51938,
     /*   61811 */     GIR_EraseRootFromParent_Done,
     /*   61812 */   // Label 1001: @61812
     /*   61812 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61876), // Rule ID 51939 //
     /*   61817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61850 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61874 */     GIR_RootConstrainSelectedInstOperands,
     /*   61875 */     // GIR_Coverage, 51939,
     /*   61875 */     GIR_EraseRootFromParent_Done,
     /*   61876 */   // Label 1002: @61876
     /*   61876 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61925), // Rule ID 46212 //
     /*   61881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61888 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61923 */     GIR_RootConstrainSelectedInstOperands,
     /*   61924 */     // GIR_Coverage, 46212,
     /*   61924 */     GIR_EraseRootFromParent_Done,
     /*   61925 */   // Label 1003: @61925
     /*   61925 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61974), // Rule ID 46213 //
     /*   61930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61937 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61972 */     GIR_RootConstrainSelectedInstOperands,
     /*   61973 */     // GIR_Coverage, 46213,
     /*   61973 */     GIR_EraseRootFromParent_Done,
     /*   61974 */   // Label 1004: @61974
     /*   61974 */   GIM_Reject,
     /*   61975 */ // Label 1000: @61975
     /*   61975 */ GIM_Reject,
     /*   61976 */ // Label 967: @61976
     /*   61976 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(63098),
     /*   61981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   61984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   61987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61991 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62080), // Rule ID 47208 //
     /*   61996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62039 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62078 */     GIR_RootConstrainSelectedInstOperands,
     /*   62079 */     // GIR_Coverage, 47208,
     /*   62079 */     GIR_EraseRootFromParent_Done,
     /*   62080 */   // Label 1006: @62080
     /*   62080 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62169), // Rule ID 47209 //
     /*   62085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62128 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62167 */     GIR_RootConstrainSelectedInstOperands,
     /*   62168 */     // GIR_Coverage, 47209,
     /*   62168 */     GIR_EraseRootFromParent_Done,
     /*   62169 */   // Label 1007: @62169
     /*   62169 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62258), // Rule ID 46968 //
     /*   62174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62208 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62217 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62256 */     GIR_RootConstrainSelectedInstOperands,
     /*   62257 */     // GIR_Coverage, 46968,
     /*   62257 */     GIR_EraseRootFromParent_Done,
     /*   62258 */   // Label 1008: @62258
     /*   62258 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62347), // Rule ID 46969 //
     /*   62263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62306 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62345 */     GIR_RootConstrainSelectedInstOperands,
     /*   62346 */     // GIR_Coverage, 46969,
     /*   62346 */     GIR_EraseRootFromParent_Done,
     /*   62347 */   // Label 1009: @62347
     /*   62347 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62436), // Rule ID 47088 //
     /*   62352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62395 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62434 */     GIR_RootConstrainSelectedInstOperands,
     /*   62435 */     // GIR_Coverage, 47088,
     /*   62435 */     GIR_EraseRootFromParent_Done,
     /*   62436 */   // Label 1010: @62436
     /*   62436 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(62525), // Rule ID 47089 //
     /*   62441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62475 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62484 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62523 */     GIR_RootConstrainSelectedInstOperands,
     /*   62524 */     // GIR_Coverage, 47089,
     /*   62524 */     GIR_EraseRootFromParent_Done,
     /*   62525 */   // Label 1011: @62525
     /*   62525 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62593), // Rule ID 51950 //
     /*   62530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62567 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   62567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62591 */     GIR_RootConstrainSelectedInstOperands,
     /*   62592 */     // GIR_Coverage, 51950,
     /*   62592 */     GIR_EraseRootFromParent_Done,
     /*   62593 */   // Label 1012: @62593
     /*   62593 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62661), // Rule ID 51951 //
     /*   62598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62635 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   62635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62659 */     GIR_RootConstrainSelectedInstOperands,
     /*   62660 */     // GIR_Coverage, 51951,
     /*   62660 */     GIR_EraseRootFromParent_Done,
     /*   62661 */   // Label 1013: @62661
     /*   62661 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62716), // Rule ID 47268 //
     /*   62666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62694 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62714 */     GIR_RootConstrainSelectedInstOperands,
     /*   62715 */     // GIR_Coverage, 47268,
     /*   62715 */     GIR_EraseRootFromParent_Done,
     /*   62716 */   // Label 1014: @62716
     /*   62716 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62771), // Rule ID 47269 //
     /*   62721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62749 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62769 */     GIR_RootConstrainSelectedInstOperands,
     /*   62770 */     // GIR_Coverage, 47269,
     /*   62770 */     GIR_EraseRootFromParent_Done,
     /*   62771 */   // Label 1015: @62771
     /*   62771 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62826), // Rule ID 47028 //
     /*   62776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62804 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62824 */     GIR_RootConstrainSelectedInstOperands,
     /*   62825 */     // GIR_Coverage, 47028,
     /*   62825 */     GIR_EraseRootFromParent_Done,
     /*   62826 */   // Label 1016: @62826
     /*   62826 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62881), // Rule ID 47029 //
     /*   62831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62859 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62879 */     GIR_RootConstrainSelectedInstOperands,
     /*   62880 */     // GIR_Coverage, 47029,
     /*   62880 */     GIR_EraseRootFromParent_Done,
     /*   62881 */   // Label 1017: @62881
     /*   62881 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62936), // Rule ID 47148 //
     /*   62886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62914 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62934 */     GIR_RootConstrainSelectedInstOperands,
     /*   62935 */     // GIR_Coverage, 47148,
     /*   62935 */     GIR_EraseRootFromParent_Done,
     /*   62936 */   // Label 1018: @62936
     /*   62936 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62991), // Rule ID 47149 //
     /*   62941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62969 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62989 */     GIR_RootConstrainSelectedInstOperands,
     /*   62990 */     // GIR_Coverage, 47149,
     /*   62990 */     GIR_EraseRootFromParent_Done,
     /*   62991 */   // Label 1019: @62991
     /*   62991 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63044), // Rule ID 46224 //
     /*   62996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63007 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63042 */     GIR_RootConstrainSelectedInstOperands,
     /*   63043 */     // GIR_Coverage, 46224,
     /*   63043 */     GIR_EraseRootFromParent_Done,
     /*   63044 */   // Label 1020: @63044
     /*   63044 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63097), // Rule ID 46225 //
     /*   63049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63060 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63095 */     GIR_RootConstrainSelectedInstOperands,
     /*   63096 */     // GIR_Coverage, 46225,
     /*   63096 */     GIR_EraseRootFromParent_Done,
     /*   63097 */   // Label 1021: @63097
     /*   63097 */   GIM_Reject,
     /*   63098 */ // Label 1005: @63098
     /*   63098 */ GIM_Reject,
     /*   63099 */ // Label 968: @63099
     /*   63099 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(64221),
     /*   63104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63114 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63203), // Rule ID 47232 //
     /*   63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63162 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63201 */     GIR_RootConstrainSelectedInstOperands,
     /*   63202 */     // GIR_Coverage, 47232,
     /*   63202 */     GIR_EraseRootFromParent_Done,
     /*   63203 */   // Label 1023: @63203
     /*   63203 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63292), // Rule ID 47233 //
     /*   63208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63251 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63290 */     GIR_RootConstrainSelectedInstOperands,
     /*   63291 */     // GIR_Coverage, 47233,
     /*   63291 */     GIR_EraseRootFromParent_Done,
     /*   63292 */   // Label 1024: @63292
     /*   63292 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63381), // Rule ID 46992 //
     /*   63297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63340 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63379 */     GIR_RootConstrainSelectedInstOperands,
     /*   63380 */     // GIR_Coverage, 46992,
     /*   63380 */     GIR_EraseRootFromParent_Done,
     /*   63381 */   // Label 1025: @63381
     /*   63381 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63470), // Rule ID 46993 //
     /*   63386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63429 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63468 */     GIR_RootConstrainSelectedInstOperands,
     /*   63469 */     // GIR_Coverage, 46993,
     /*   63469 */     GIR_EraseRootFromParent_Done,
     /*   63470 */   // Label 1026: @63470
     /*   63470 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63559), // Rule ID 47112 //
     /*   63475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63518 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63557 */     GIR_RootConstrainSelectedInstOperands,
     /*   63558 */     // GIR_Coverage, 47112,
     /*   63558 */     GIR_EraseRootFromParent_Done,
     /*   63559 */   // Label 1027: @63559
     /*   63559 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(63648), // Rule ID 47113 //
     /*   63564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63607 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63646 */     GIR_RootConstrainSelectedInstOperands,
     /*   63647 */     // GIR_Coverage, 47113,
     /*   63647 */     GIR_EraseRootFromParent_Done,
     /*   63648 */   // Label 1028: @63648
     /*   63648 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63716), // Rule ID 51958 //
     /*   63653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63690 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   63690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63714 */     GIR_RootConstrainSelectedInstOperands,
     /*   63715 */     // GIR_Coverage, 51958,
     /*   63715 */     GIR_EraseRootFromParent_Done,
     /*   63716 */   // Label 1029: @63716
     /*   63716 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63784), // Rule ID 51959 //
     /*   63721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63758 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   63758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63782 */     GIR_RootConstrainSelectedInstOperands,
     /*   63783 */     // GIR_Coverage, 51959,
     /*   63783 */     GIR_EraseRootFromParent_Done,
     /*   63784 */   // Label 1030: @63784
     /*   63784 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63839), // Rule ID 47292 //
     /*   63789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63817 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63837 */     GIR_RootConstrainSelectedInstOperands,
     /*   63838 */     // GIR_Coverage, 47292,
     /*   63838 */     GIR_EraseRootFromParent_Done,
     /*   63839 */   // Label 1031: @63839
     /*   63839 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63894), // Rule ID 47293 //
     /*   63844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63872 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63892 */     GIR_RootConstrainSelectedInstOperands,
     /*   63893 */     // GIR_Coverage, 47293,
     /*   63893 */     GIR_EraseRootFromParent_Done,
     /*   63894 */   // Label 1032: @63894
     /*   63894 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(63949), // Rule ID 47052 //
     /*   63899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63927 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63947 */     GIR_RootConstrainSelectedInstOperands,
     /*   63948 */     // GIR_Coverage, 47052,
     /*   63948 */     GIR_EraseRootFromParent_Done,
     /*   63949 */   // Label 1033: @63949
     /*   63949 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64004), // Rule ID 47053 //
     /*   63954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63982 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64002 */     GIR_RootConstrainSelectedInstOperands,
     /*   64003 */     // GIR_Coverage, 47053,
     /*   64003 */     GIR_EraseRootFromParent_Done,
     /*   64004 */   // Label 1034: @64004
     /*   64004 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64059), // Rule ID 47172 //
     /*   64009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64037 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64057 */     GIR_RootConstrainSelectedInstOperands,
     /*   64058 */     // GIR_Coverage, 47172,
     /*   64058 */     GIR_EraseRootFromParent_Done,
     /*   64059 */   // Label 1035: @64059
     /*   64059 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64114), // Rule ID 47173 //
     /*   64064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64092 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64112 */     GIR_RootConstrainSelectedInstOperands,
     /*   64113 */     // GIR_Coverage, 47173,
     /*   64113 */     GIR_EraseRootFromParent_Done,
     /*   64114 */   // Label 1036: @64114
     /*   64114 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64167), // Rule ID 46232 //
     /*   64119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64130 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64165 */     GIR_RootConstrainSelectedInstOperands,
     /*   64166 */     // GIR_Coverage, 46232,
     /*   64166 */     GIR_EraseRootFromParent_Done,
     /*   64167 */   // Label 1037: @64167
     /*   64167 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64220), // Rule ID 46233 //
     /*   64172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64183 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64218 */     GIR_RootConstrainSelectedInstOperands,
     /*   64219 */     // GIR_Coverage, 46233,
     /*   64219 */     GIR_EraseRootFromParent_Done,
     /*   64220 */   // Label 1038: @64220
     /*   64220 */   GIM_Reject,
     /*   64221 */ // Label 1022: @64221
     /*   64221 */ GIM_Reject,
     /*   64222 */ // Label 969: @64222
     /*   64222 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(65344),
     /*   64227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64237 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64326), // Rule ID 47252 //
     /*   64242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64285 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64324 */     GIR_RootConstrainSelectedInstOperands,
     /*   64325 */     // GIR_Coverage, 47252,
     /*   64325 */     GIR_EraseRootFromParent_Done,
     /*   64326 */   // Label 1040: @64326
     /*   64326 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64415), // Rule ID 47253 //
     /*   64331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64374 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64413 */     GIR_RootConstrainSelectedInstOperands,
     /*   64414 */     // GIR_Coverage, 47253,
     /*   64414 */     GIR_EraseRootFromParent_Done,
     /*   64415 */   // Label 1041: @64415
     /*   64415 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64504), // Rule ID 47012 //
     /*   64420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64435 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64463 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64502 */     GIR_RootConstrainSelectedInstOperands,
     /*   64503 */     // GIR_Coverage, 47012,
     /*   64503 */     GIR_EraseRootFromParent_Done,
     /*   64504 */   // Label 1042: @64504
     /*   64504 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64593), // Rule ID 47013 //
     /*   64509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64552 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64591 */     GIR_RootConstrainSelectedInstOperands,
     /*   64592 */     // GIR_Coverage, 47013,
     /*   64592 */     GIR_EraseRootFromParent_Done,
     /*   64593 */   // Label 1043: @64593
     /*   64593 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64682), // Rule ID 47132 //
     /*   64598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64641 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64680 */     GIR_RootConstrainSelectedInstOperands,
     /*   64681 */     // GIR_Coverage, 47132,
     /*   64681 */     GIR_EraseRootFromParent_Done,
     /*   64682 */   // Label 1044: @64682
     /*   64682 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(64771), // Rule ID 47133 //
     /*   64687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64730 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64769 */     GIR_RootConstrainSelectedInstOperands,
     /*   64770 */     // GIR_Coverage, 47133,
     /*   64770 */     GIR_EraseRootFromParent_Done,
     /*   64771 */   // Label 1045: @64771
     /*   64771 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64839), // Rule ID 51974 //
     /*   64776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64799 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64813 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   64813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64837 */     GIR_RootConstrainSelectedInstOperands,
     /*   64838 */     // GIR_Coverage, 51974,
     /*   64838 */     GIR_EraseRootFromParent_Done,
     /*   64839 */   // Label 1046: @64839
     /*   64839 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64907), // Rule ID 51975 //
     /*   64844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64881 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   64881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64905 */     GIR_RootConstrainSelectedInstOperands,
     /*   64906 */     // GIR_Coverage, 51975,
     /*   64906 */     GIR_EraseRootFromParent_Done,
     /*   64907 */   // Label 1047: @64907
     /*   64907 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64962), // Rule ID 47312 //
     /*   64912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64940 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64960 */     GIR_RootConstrainSelectedInstOperands,
     /*   64961 */     // GIR_Coverage, 47312,
     /*   64961 */     GIR_EraseRootFromParent_Done,
     /*   64962 */   // Label 1048: @64962
     /*   64962 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65017), // Rule ID 47313 //
     /*   64967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64995 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65015 */     GIR_RootConstrainSelectedInstOperands,
     /*   65016 */     // GIR_Coverage, 47313,
     /*   65016 */     GIR_EraseRootFromParent_Done,
     /*   65017 */   // Label 1049: @65017
     /*   65017 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65072), // Rule ID 47072 //
     /*   65022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65050 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65070 */     GIR_RootConstrainSelectedInstOperands,
     /*   65071 */     // GIR_Coverage, 47072,
     /*   65071 */     GIR_EraseRootFromParent_Done,
     /*   65072 */   // Label 1050: @65072
     /*   65072 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65127), // Rule ID 47073 //
     /*   65077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65105 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65125 */     GIR_RootConstrainSelectedInstOperands,
     /*   65126 */     // GIR_Coverage, 47073,
     /*   65126 */     GIR_EraseRootFromParent_Done,
     /*   65127 */   // Label 1051: @65127
     /*   65127 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65182), // Rule ID 47192 //
     /*   65132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65160 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65180 */     GIR_RootConstrainSelectedInstOperands,
     /*   65181 */     // GIR_Coverage, 47192,
     /*   65181 */     GIR_EraseRootFromParent_Done,
     /*   65182 */   // Label 1052: @65182
     /*   65182 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65237), // Rule ID 47193 //
     /*   65187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65215 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65235 */     GIR_RootConstrainSelectedInstOperands,
     /*   65236 */     // GIR_Coverage, 47193,
     /*   65236 */     GIR_EraseRootFromParent_Done,
     /*   65237 */   // Label 1053: @65237
     /*   65237 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65290), // Rule ID 46248 //
     /*   65242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65253 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65288 */     GIR_RootConstrainSelectedInstOperands,
     /*   65289 */     // GIR_Coverage, 46248,
     /*   65289 */     GIR_EraseRootFromParent_Done,
     /*   65290 */   // Label 1054: @65290
     /*   65290 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65343), // Rule ID 46249 //
     /*   65295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65306 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65341 */     GIR_RootConstrainSelectedInstOperands,
     /*   65342 */     // GIR_Coverage, 46249,
     /*   65342 */     GIR_EraseRootFromParent_Done,
     /*   65343 */   // Label 1055: @65343
     /*   65343 */   GIM_Reject,
     /*   65344 */ // Label 1039: @65344
     /*   65344 */ GIM_Reject,
     /*   65345 */ // Label 970: @65345
     /*   65345 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65591),
     /*   65350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65364 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65428), // Rule ID 51942 //
     /*   65369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65402 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65426 */     GIR_RootConstrainSelectedInstOperands,
     /*   65427 */     // GIR_Coverage, 51942,
     /*   65427 */     GIR_EraseRootFromParent_Done,
     /*   65428 */   // Label 1057: @65428
     /*   65428 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65492), // Rule ID 51943 //
     /*   65433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65466 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65490 */     GIR_RootConstrainSelectedInstOperands,
     /*   65491 */     // GIR_Coverage, 51943,
     /*   65491 */     GIR_EraseRootFromParent_Done,
     /*   65492 */   // Label 1058: @65492
     /*   65492 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65541), // Rule ID 46216 //
     /*   65497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65504 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65539 */     GIR_RootConstrainSelectedInstOperands,
     /*   65540 */     // GIR_Coverage, 46216,
     /*   65540 */     GIR_EraseRootFromParent_Done,
     /*   65541 */   // Label 1059: @65541
     /*   65541 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65590), // Rule ID 46217 //
     /*   65546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65553 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65588 */     GIR_RootConstrainSelectedInstOperands,
     /*   65589 */     // GIR_Coverage, 46217,
     /*   65589 */     GIR_EraseRootFromParent_Done,
     /*   65590 */   // Label 1060: @65590
     /*   65590 */   GIM_Reject,
     /*   65591 */ // Label 1056: @65591
     /*   65591 */ GIM_Reject,
     /*   65592 */ // Label 971: @65592
     /*   65592 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(66714),
     /*   65597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   65600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   65603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65607 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(65696), // Rule ID 47212 //
     /*   65612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65646 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65655 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65694 */     GIR_RootConstrainSelectedInstOperands,
     /*   65695 */     // GIR_Coverage, 47212,
     /*   65695 */     GIR_EraseRootFromParent_Done,
     /*   65696 */   // Label 1062: @65696
     /*   65696 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65785), // Rule ID 47213 //
     /*   65701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65744 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65783 */     GIR_RootConstrainSelectedInstOperands,
     /*   65784 */     // GIR_Coverage, 47213,
     /*   65784 */     GIR_EraseRootFromParent_Done,
     /*   65785 */   // Label 1063: @65785
     /*   65785 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65874), // Rule ID 46972 //
     /*   65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65805 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65833 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65872 */     GIR_RootConstrainSelectedInstOperands,
     /*   65873 */     // GIR_Coverage, 46972,
     /*   65873 */     GIR_EraseRootFromParent_Done,
     /*   65874 */   // Label 1064: @65874
     /*   65874 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(65963), // Rule ID 46973 //
     /*   65879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65894 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65913 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65922 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65961 */     GIR_RootConstrainSelectedInstOperands,
     /*   65962 */     // GIR_Coverage, 46973,
     /*   65962 */     GIR_EraseRootFromParent_Done,
     /*   65963 */   // Label 1065: @65963
     /*   65963 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66052), // Rule ID 47092 //
     /*   65968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65983 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66011 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66050 */     GIR_RootConstrainSelectedInstOperands,
     /*   66051 */     // GIR_Coverage, 47092,
     /*   66051 */     GIR_EraseRootFromParent_Done,
     /*   66052 */   // Label 1066: @66052
     /*   66052 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(66141), // Rule ID 47093 //
     /*   66057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66091 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66100 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66139 */     GIR_RootConstrainSelectedInstOperands,
     /*   66140 */     // GIR_Coverage, 47093,
     /*   66140 */     GIR_EraseRootFromParent_Done,
     /*   66141 */   // Label 1067: @66141
     /*   66141 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66209), // Rule ID 51954 //
     /*   66146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66169 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66183 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66207 */     GIR_RootConstrainSelectedInstOperands,
     /*   66208 */     // GIR_Coverage, 51954,
     /*   66208 */     GIR_EraseRootFromParent_Done,
     /*   66209 */   // Label 1068: @66209
     /*   66209 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66277), // Rule ID 51955 //
     /*   66214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66251 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66275 */     GIR_RootConstrainSelectedInstOperands,
     /*   66276 */     // GIR_Coverage, 51955,
     /*   66276 */     GIR_EraseRootFromParent_Done,
     /*   66277 */   // Label 1069: @66277
     /*   66277 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66332), // Rule ID 47272 //
     /*   66282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66310 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66330 */     GIR_RootConstrainSelectedInstOperands,
     /*   66331 */     // GIR_Coverage, 47272,
     /*   66331 */     GIR_EraseRootFromParent_Done,
     /*   66332 */   // Label 1070: @66332
     /*   66332 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66387), // Rule ID 47273 //
     /*   66337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66365 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66385 */     GIR_RootConstrainSelectedInstOperands,
     /*   66386 */     // GIR_Coverage, 47273,
     /*   66386 */     GIR_EraseRootFromParent_Done,
     /*   66387 */   // Label 1071: @66387
     /*   66387 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66442), // Rule ID 47032 //
     /*   66392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66420 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66440 */     GIR_RootConstrainSelectedInstOperands,
     /*   66441 */     // GIR_Coverage, 47032,
     /*   66441 */     GIR_EraseRootFromParent_Done,
     /*   66442 */   // Label 1072: @66442
     /*   66442 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66497), // Rule ID 47033 //
     /*   66447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66475 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66495 */     GIR_RootConstrainSelectedInstOperands,
     /*   66496 */     // GIR_Coverage, 47033,
     /*   66496 */     GIR_EraseRootFromParent_Done,
     /*   66497 */   // Label 1073: @66497
     /*   66497 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66552), // Rule ID 47152 //
     /*   66502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66530 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66550 */     GIR_RootConstrainSelectedInstOperands,
     /*   66551 */     // GIR_Coverage, 47152,
     /*   66551 */     GIR_EraseRootFromParent_Done,
     /*   66552 */   // Label 1074: @66552
     /*   66552 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66607), // Rule ID 47153 //
     /*   66557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66576 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66585 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66605 */     GIR_RootConstrainSelectedInstOperands,
     /*   66606 */     // GIR_Coverage, 47153,
     /*   66606 */     GIR_EraseRootFromParent_Done,
     /*   66607 */   // Label 1075: @66607
     /*   66607 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66660), // Rule ID 46228 //
     /*   66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66623 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66658 */     GIR_RootConstrainSelectedInstOperands,
     /*   66659 */     // GIR_Coverage, 46228,
     /*   66659 */     GIR_EraseRootFromParent_Done,
     /*   66660 */   // Label 1076: @66660
     /*   66660 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66713), // Rule ID 46229 //
     /*   66665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66676 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66711 */     GIR_RootConstrainSelectedInstOperands,
     /*   66712 */     // GIR_Coverage, 46229,
     /*   66712 */     GIR_EraseRootFromParent_Done,
     /*   66713 */   // Label 1077: @66713
     /*   66713 */   GIM_Reject,
     /*   66714 */ // Label 1061: @66714
     /*   66714 */ GIM_Reject,
     /*   66715 */ // Label 972: @66715
     /*   66715 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(67837),
     /*   66720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   66723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   66726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66730 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66819), // Rule ID 47236 //
     /*   66735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66769 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66778 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66817 */     GIR_RootConstrainSelectedInstOperands,
     /*   66818 */     // GIR_Coverage, 47236,
     /*   66818 */     GIR_EraseRootFromParent_Done,
     /*   66819 */   // Label 1079: @66819
     /*   66819 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(66908), // Rule ID 47237 //
     /*   66824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66858 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66867 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66906 */     GIR_RootConstrainSelectedInstOperands,
     /*   66907 */     // GIR_Coverage, 47237,
     /*   66907 */     GIR_EraseRootFromParent_Done,
     /*   66908 */   // Label 1080: @66908
     /*   66908 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(66997), // Rule ID 46996 //
     /*   66913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66956 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   66973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66995 */     GIR_RootConstrainSelectedInstOperands,
     /*   66996 */     // GIR_Coverage, 46996,
     /*   66996 */     GIR_EraseRootFromParent_Done,
     /*   66997 */   // Label 1081: @66997
     /*   66997 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67086), // Rule ID 46997 //
     /*   67002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67036 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67045 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67084 */     GIR_RootConstrainSelectedInstOperands,
     /*   67085 */     // GIR_Coverage, 46997,
     /*   67085 */     GIR_EraseRootFromParent_Done,
     /*   67086 */   // Label 1082: @67086
     /*   67086 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67175), // Rule ID 47116 //
     /*   67091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67106 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67125 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67134 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67173 */     GIR_RootConstrainSelectedInstOperands,
     /*   67174 */     // GIR_Coverage, 47116,
     /*   67174 */     GIR_EraseRootFromParent_Done,
     /*   67175 */   // Label 1083: @67175
     /*   67175 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(67264), // Rule ID 47117 //
     /*   67180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67214 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67223 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67262 */     GIR_RootConstrainSelectedInstOperands,
     /*   67263 */     // GIR_Coverage, 47117,
     /*   67263 */     GIR_EraseRootFromParent_Done,
     /*   67264 */   // Label 1084: @67264
     /*   67264 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67332), // Rule ID 51970 //
     /*   67269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67306 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67330 */     GIR_RootConstrainSelectedInstOperands,
     /*   67331 */     // GIR_Coverage, 51970,
     /*   67331 */     GIR_EraseRootFromParent_Done,
     /*   67332 */   // Label 1085: @67332
     /*   67332 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67400), // Rule ID 51971 //
     /*   67337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67374 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67398 */     GIR_RootConstrainSelectedInstOperands,
     /*   67399 */     // GIR_Coverage, 51971,
     /*   67399 */     GIR_EraseRootFromParent_Done,
     /*   67400 */   // Label 1086: @67400
     /*   67400 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67455), // Rule ID 47296 //
     /*   67405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67433 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67453 */     GIR_RootConstrainSelectedInstOperands,
     /*   67454 */     // GIR_Coverage, 47296,
     /*   67454 */     GIR_EraseRootFromParent_Done,
     /*   67455 */   // Label 1087: @67455
     /*   67455 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67510), // Rule ID 47297 //
     /*   67460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67488 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67508 */     GIR_RootConstrainSelectedInstOperands,
     /*   67509 */     // GIR_Coverage, 47297,
     /*   67509 */     GIR_EraseRootFromParent_Done,
     /*   67510 */   // Label 1088: @67510
     /*   67510 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67565), // Rule ID 47056 //
     /*   67515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67543 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67563 */     GIR_RootConstrainSelectedInstOperands,
     /*   67564 */     // GIR_Coverage, 47056,
     /*   67564 */     GIR_EraseRootFromParent_Done,
     /*   67565 */   // Label 1089: @67565
     /*   67565 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67620), // Rule ID 47057 //
     /*   67570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67598 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67618 */     GIR_RootConstrainSelectedInstOperands,
     /*   67619 */     // GIR_Coverage, 47057,
     /*   67619 */     GIR_EraseRootFromParent_Done,
     /*   67620 */   // Label 1090: @67620
     /*   67620 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67675), // Rule ID 47176 //
     /*   67625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67644 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67653 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67673 */     GIR_RootConstrainSelectedInstOperands,
     /*   67674 */     // GIR_Coverage, 47176,
     /*   67674 */     GIR_EraseRootFromParent_Done,
     /*   67675 */   // Label 1091: @67675
     /*   67675 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67730), // Rule ID 47177 //
     /*   67680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67708 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67728 */     GIR_RootConstrainSelectedInstOperands,
     /*   67729 */     // GIR_Coverage, 47177,
     /*   67729 */     GIR_EraseRootFromParent_Done,
     /*   67730 */   // Label 1092: @67730
     /*   67730 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67783), // Rule ID 46244 //
     /*   67735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67746 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67781 */     GIR_RootConstrainSelectedInstOperands,
     /*   67782 */     // GIR_Coverage, 46244,
     /*   67782 */     GIR_EraseRootFromParent_Done,
     /*   67783 */   // Label 1093: @67783
     /*   67783 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67836), // Rule ID 46245 //
     /*   67788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67799 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67834 */     GIR_RootConstrainSelectedInstOperands,
     /*   67835 */     // GIR_Coverage, 46245,
     /*   67835 */     GIR_EraseRootFromParent_Done,
     /*   67836 */   // Label 1094: @67836
     /*   67836 */   GIM_Reject,
     /*   67837 */ // Label 1078: @67837
     /*   67837 */ GIM_Reject,
     /*   67838 */ // Label 973: @67838
     /*   67838 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68960),
     /*   67843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   67846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   67849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67853 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(67942), // Rule ID 47256 //
     /*   67858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67901 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   67918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67940 */     GIR_RootConstrainSelectedInstOperands,
     /*   67941 */     // GIR_Coverage, 47256,
     /*   67941 */     GIR_EraseRootFromParent_Done,
     /*   67942 */   // Label 1096: @67942
     /*   67942 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68031), // Rule ID 47257 //
     /*   67947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67990 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68029 */     GIR_RootConstrainSelectedInstOperands,
     /*   68030 */     // GIR_Coverage, 47257,
     /*   68030 */     GIR_EraseRootFromParent_Done,
     /*   68031 */   // Label 1097: @68031
     /*   68031 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68120), // Rule ID 47016 //
     /*   68036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68079 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68118 */     GIR_RootConstrainSelectedInstOperands,
     /*   68119 */     // GIR_Coverage, 47016,
     /*   68119 */     GIR_EraseRootFromParent_Done,
     /*   68120 */   // Label 1098: @68120
     /*   68120 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68209), // Rule ID 47017 //
     /*   68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68168 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68207 */     GIR_RootConstrainSelectedInstOperands,
     /*   68208 */     // GIR_Coverage, 47017,
     /*   68208 */     GIR_EraseRootFromParent_Done,
     /*   68209 */   // Label 1099: @68209
     /*   68209 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68298), // Rule ID 47136 //
     /*   68214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68257 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68296 */     GIR_RootConstrainSelectedInstOperands,
     /*   68297 */     // GIR_Coverage, 47136,
     /*   68297 */     GIR_EraseRootFromParent_Done,
     /*   68298 */   // Label 1100: @68298
     /*   68298 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(68387), // Rule ID 47137 //
     /*   68303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68346 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68385 */     GIR_RootConstrainSelectedInstOperands,
     /*   68386 */     // GIR_Coverage, 47137,
     /*   68386 */     GIR_EraseRootFromParent_Done,
     /*   68387 */   // Label 1101: @68387
     /*   68387 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68455), // Rule ID 52014 //
     /*   68392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68415 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68429 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68453 */     GIR_RootConstrainSelectedInstOperands,
     /*   68454 */     // GIR_Coverage, 52014,
     /*   68454 */     GIR_EraseRootFromParent_Done,
     /*   68455 */   // Label 1102: @68455
     /*   68455 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68523), // Rule ID 52015 //
     /*   68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68497 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68521 */     GIR_RootConstrainSelectedInstOperands,
     /*   68522 */     // GIR_Coverage, 52015,
     /*   68522 */     GIR_EraseRootFromParent_Done,
     /*   68523 */   // Label 1103: @68523
     /*   68523 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68578), // Rule ID 47316 //
     /*   68528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68556 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68576 */     GIR_RootConstrainSelectedInstOperands,
     /*   68577 */     // GIR_Coverage, 47316,
     /*   68577 */     GIR_EraseRootFromParent_Done,
     /*   68578 */   // Label 1104: @68578
     /*   68578 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68633), // Rule ID 47317 //
     /*   68583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68611 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68631 */     GIR_RootConstrainSelectedInstOperands,
     /*   68632 */     // GIR_Coverage, 47317,
     /*   68632 */     GIR_EraseRootFromParent_Done,
     /*   68633 */   // Label 1105: @68633
     /*   68633 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68688), // Rule ID 47076 //
     /*   68638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68666 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68686 */     GIR_RootConstrainSelectedInstOperands,
     /*   68687 */     // GIR_Coverage, 47076,
     /*   68687 */     GIR_EraseRootFromParent_Done,
     /*   68688 */   // Label 1106: @68688
     /*   68688 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68743), // Rule ID 47077 //
     /*   68693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68721 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68741 */     GIR_RootConstrainSelectedInstOperands,
     /*   68742 */     // GIR_Coverage, 47077,
     /*   68742 */     GIR_EraseRootFromParent_Done,
     /*   68743 */   // Label 1107: @68743
     /*   68743 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68798), // Rule ID 47196 //
     /*   68748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68776 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68796 */     GIR_RootConstrainSelectedInstOperands,
     /*   68797 */     // GIR_Coverage, 47196,
     /*   68797 */     GIR_EraseRootFromParent_Done,
     /*   68798 */   // Label 1108: @68798
     /*   68798 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68853), // Rule ID 47197 //
     /*   68803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68831 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68851 */     GIR_RootConstrainSelectedInstOperands,
     /*   68852 */     // GIR_Coverage, 47197,
     /*   68852 */     GIR_EraseRootFromParent_Done,
     /*   68853 */   // Label 1109: @68853
     /*   68853 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(68906), // Rule ID 46288 //
     /*   68858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68869 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   68869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68904 */     GIR_RootConstrainSelectedInstOperands,
     /*   68905 */     // GIR_Coverage, 46288,
     /*   68905 */     GIR_EraseRootFromParent_Done,
     /*   68906 */   // Label 1110: @68906
     /*   68906 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(68959), // Rule ID 46289 //
     /*   68911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68922 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   68922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68957 */     GIR_RootConstrainSelectedInstOperands,
     /*   68958 */     // GIR_Coverage, 46289,
     /*   68958 */     GIR_EraseRootFromParent_Done,
     /*   68959 */   // Label 1111: @68959
     /*   68959 */   GIM_Reject,
     /*   68960 */ // Label 1095: @68960
     /*   68960 */ GIM_Reject,
     /*   68961 */ // Label 974: @68961
     /*   68961 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69207),
     /*   68966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   68969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   68972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68980 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69044), // Rule ID 51946 //
     /*   68985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69018 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69042 */     GIR_RootConstrainSelectedInstOperands,
     /*   69043 */     // GIR_Coverage, 51946,
     /*   69043 */     GIR_EraseRootFromParent_Done,
     /*   69044 */   // Label 1113: @69044
     /*   69044 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69108), // Rule ID 51947 //
     /*   69049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69082 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69106 */     GIR_RootConstrainSelectedInstOperands,
     /*   69107 */     // GIR_Coverage, 51947,
     /*   69107 */     GIR_EraseRootFromParent_Done,
     /*   69108 */   // Label 1114: @69108
     /*   69108 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69157), // Rule ID 46220 //
     /*   69113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69120 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69155 */     GIR_RootConstrainSelectedInstOperands,
     /*   69156 */     // GIR_Coverage, 46220,
     /*   69156 */     GIR_EraseRootFromParent_Done,
     /*   69157 */   // Label 1115: @69157
     /*   69157 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69206), // Rule ID 46221 //
     /*   69162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69169 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69204 */     GIR_RootConstrainSelectedInstOperands,
     /*   69205 */     // GIR_Coverage, 46221,
     /*   69205 */     GIR_EraseRootFromParent_Done,
     /*   69206 */   // Label 1116: @69206
     /*   69206 */   GIM_Reject,
     /*   69207 */ // Label 1112: @69207
     /*   69207 */ GIM_Reject,
     /*   69208 */ // Label 975: @69208
     /*   69208 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70330),
     /*   69213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69223 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69312), // Rule ID 47216 //
     /*   69228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69271 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69310 */     GIR_RootConstrainSelectedInstOperands,
     /*   69311 */     // GIR_Coverage, 47216,
     /*   69311 */     GIR_EraseRootFromParent_Done,
     /*   69312 */   // Label 1118: @69312
     /*   69312 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69401), // Rule ID 47217 //
     /*   69317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69360 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69399 */     GIR_RootConstrainSelectedInstOperands,
     /*   69400 */     // GIR_Coverage, 47217,
     /*   69400 */     GIR_EraseRootFromParent_Done,
     /*   69401 */   // Label 1119: @69401
     /*   69401 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69490), // Rule ID 46976 //
     /*   69406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69449 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69488 */     GIR_RootConstrainSelectedInstOperands,
     /*   69489 */     // GIR_Coverage, 46976,
     /*   69489 */     GIR_EraseRootFromParent_Done,
     /*   69490 */   // Label 1120: @69490
     /*   69490 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69579), // Rule ID 46977 //
     /*   69495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69538 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69577 */     GIR_RootConstrainSelectedInstOperands,
     /*   69578 */     // GIR_Coverage, 46977,
     /*   69578 */     GIR_EraseRootFromParent_Done,
     /*   69579 */   // Label 1121: @69579
     /*   69579 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69668), // Rule ID 47096 //
     /*   69584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69627 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69666 */     GIR_RootConstrainSelectedInstOperands,
     /*   69667 */     // GIR_Coverage, 47096,
     /*   69667 */     GIR_EraseRootFromParent_Done,
     /*   69668 */   // Label 1122: @69668
     /*   69668 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(69757), // Rule ID 47097 //
     /*   69673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69716 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69755 */     GIR_RootConstrainSelectedInstOperands,
     /*   69756 */     // GIR_Coverage, 47097,
     /*   69756 */     GIR_EraseRootFromParent_Done,
     /*   69757 */   // Label 1123: @69757
     /*   69757 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69825), // Rule ID 51966 //
     /*   69762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69799 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   69799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69823 */     GIR_RootConstrainSelectedInstOperands,
     /*   69824 */     // GIR_Coverage, 51966,
     /*   69824 */     GIR_EraseRootFromParent_Done,
     /*   69825 */   // Label 1124: @69825
     /*   69825 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69893), // Rule ID 51967 //
     /*   69830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69867 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   69867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69891 */     GIR_RootConstrainSelectedInstOperands,
     /*   69892 */     // GIR_Coverage, 51967,
     /*   69892 */     GIR_EraseRootFromParent_Done,
     /*   69893 */   // Label 1125: @69893
     /*   69893 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69948), // Rule ID 47276 //
     /*   69898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69926 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69946 */     GIR_RootConstrainSelectedInstOperands,
     /*   69947 */     // GIR_Coverage, 47276,
     /*   69947 */     GIR_EraseRootFromParent_Done,
     /*   69948 */   // Label 1126: @69948
     /*   69948 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70003), // Rule ID 47277 //
     /*   69953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69981 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70001 */     GIR_RootConstrainSelectedInstOperands,
     /*   70002 */     // GIR_Coverage, 47277,
     /*   70002 */     GIR_EraseRootFromParent_Done,
     /*   70003 */   // Label 1127: @70003
     /*   70003 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70058), // Rule ID 47036 //
     /*   70008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70036 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70056 */     GIR_RootConstrainSelectedInstOperands,
     /*   70057 */     // GIR_Coverage, 47036,
     /*   70057 */     GIR_EraseRootFromParent_Done,
     /*   70058 */   // Label 1128: @70058
     /*   70058 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70113), // Rule ID 47037 //
     /*   70063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70091 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70111 */     GIR_RootConstrainSelectedInstOperands,
     /*   70112 */     // GIR_Coverage, 47037,
     /*   70112 */     GIR_EraseRootFromParent_Done,
     /*   70113 */   // Label 1129: @70113
     /*   70113 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70168), // Rule ID 47156 //
     /*   70118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70146 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70166 */     GIR_RootConstrainSelectedInstOperands,
     /*   70167 */     // GIR_Coverage, 47156,
     /*   70167 */     GIR_EraseRootFromParent_Done,
     /*   70168 */   // Label 1130: @70168
     /*   70168 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70223), // Rule ID 47157 //
     /*   70173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70201 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70221 */     GIR_RootConstrainSelectedInstOperands,
     /*   70222 */     // GIR_Coverage, 47157,
     /*   70222 */     GIR_EraseRootFromParent_Done,
     /*   70223 */   // Label 1131: @70223
     /*   70223 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70276), // Rule ID 46240 //
     /*   70228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70239 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70274 */     GIR_RootConstrainSelectedInstOperands,
     /*   70275 */     // GIR_Coverage, 46240,
     /*   70275 */     GIR_EraseRootFromParent_Done,
     /*   70276 */   // Label 1132: @70276
     /*   70276 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70329), // Rule ID 46241 //
     /*   70281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70292 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70327 */     GIR_RootConstrainSelectedInstOperands,
     /*   70328 */     // GIR_Coverage, 46241,
     /*   70328 */     GIR_EraseRootFromParent_Done,
     /*   70329 */   // Label 1133: @70329
     /*   70329 */   GIM_Reject,
     /*   70330 */ // Label 1117: @70330
     /*   70330 */ GIM_Reject,
     /*   70331 */ // Label 976: @70331
     /*   70331 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71453),
     /*   70336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70346 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70435), // Rule ID 47240 //
     /*   70351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70394 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70433 */     GIR_RootConstrainSelectedInstOperands,
     /*   70434 */     // GIR_Coverage, 47240,
     /*   70434 */     GIR_EraseRootFromParent_Done,
     /*   70435 */   // Label 1135: @70435
     /*   70435 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70524), // Rule ID 47241 //
     /*   70440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70483 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70522 */     GIR_RootConstrainSelectedInstOperands,
     /*   70523 */     // GIR_Coverage, 47241,
     /*   70523 */     GIR_EraseRootFromParent_Done,
     /*   70524 */   // Label 1136: @70524
     /*   70524 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70613), // Rule ID 47000 //
     /*   70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70572 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70611 */     GIR_RootConstrainSelectedInstOperands,
     /*   70612 */     // GIR_Coverage, 47000,
     /*   70612 */     GIR_EraseRootFromParent_Done,
     /*   70613 */   // Label 1137: @70613
     /*   70613 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70702), // Rule ID 47001 //
     /*   70618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70661 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70700 */     GIR_RootConstrainSelectedInstOperands,
     /*   70701 */     // GIR_Coverage, 47001,
     /*   70701 */     GIR_EraseRootFromParent_Done,
     /*   70702 */   // Label 1138: @70702
     /*   70702 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70791), // Rule ID 47120 //
     /*   70707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70750 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70789 */     GIR_RootConstrainSelectedInstOperands,
     /*   70790 */     // GIR_Coverage, 47120,
     /*   70790 */     GIR_EraseRootFromParent_Done,
     /*   70791 */   // Label 1139: @70791
     /*   70791 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70880), // Rule ID 47121 //
     /*   70796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70839 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70878 */     GIR_RootConstrainSelectedInstOperands,
     /*   70879 */     // GIR_Coverage, 47121,
     /*   70879 */     GIR_EraseRootFromParent_Done,
     /*   70880 */   // Label 1140: @70880
     /*   70880 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70948), // Rule ID 52002 //
     /*   70885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70922 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   70922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70946 */     GIR_RootConstrainSelectedInstOperands,
     /*   70947 */     // GIR_Coverage, 52002,
     /*   70947 */     GIR_EraseRootFromParent_Done,
     /*   70948 */   // Label 1141: @70948
     /*   70948 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71016), // Rule ID 52003 //
     /*   70953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70990 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   70990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71014 */     GIR_RootConstrainSelectedInstOperands,
     /*   71015 */     // GIR_Coverage, 52003,
     /*   71015 */     GIR_EraseRootFromParent_Done,
     /*   71016 */   // Label 1142: @71016
     /*   71016 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71071), // Rule ID 47300 //
     /*   71021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71049 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71069 */     GIR_RootConstrainSelectedInstOperands,
     /*   71070 */     // GIR_Coverage, 47300,
     /*   71070 */     GIR_EraseRootFromParent_Done,
     /*   71071 */   // Label 1143: @71071
     /*   71071 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71126), // Rule ID 47301 //
     /*   71076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71104 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71124 */     GIR_RootConstrainSelectedInstOperands,
     /*   71125 */     // GIR_Coverage, 47301,
     /*   71125 */     GIR_EraseRootFromParent_Done,
     /*   71126 */   // Label 1144: @71126
     /*   71126 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71181), // Rule ID 47060 //
     /*   71131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71159 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71179 */     GIR_RootConstrainSelectedInstOperands,
     /*   71180 */     // GIR_Coverage, 47060,
     /*   71180 */     GIR_EraseRootFromParent_Done,
     /*   71181 */   // Label 1145: @71181
     /*   71181 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71236), // Rule ID 47061 //
     /*   71186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71214 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71234 */     GIR_RootConstrainSelectedInstOperands,
     /*   71235 */     // GIR_Coverage, 47061,
     /*   71235 */     GIR_EraseRootFromParent_Done,
     /*   71236 */   // Label 1146: @71236
     /*   71236 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71291), // Rule ID 47180 //
     /*   71241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71269 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71289 */     GIR_RootConstrainSelectedInstOperands,
     /*   71290 */     // GIR_Coverage, 47180,
     /*   71290 */     GIR_EraseRootFromParent_Done,
     /*   71291 */   // Label 1147: @71291
     /*   71291 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71346), // Rule ID 47181 //
     /*   71296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71324 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71344 */     GIR_RootConstrainSelectedInstOperands,
     /*   71345 */     // GIR_Coverage, 47181,
     /*   71345 */     GIR_EraseRootFromParent_Done,
     /*   71346 */   // Label 1148: @71346
     /*   71346 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71399), // Rule ID 46276 //
     /*   71351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71362 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71397 */     GIR_RootConstrainSelectedInstOperands,
     /*   71398 */     // GIR_Coverage, 46276,
     /*   71398 */     GIR_EraseRootFromParent_Done,
     /*   71399 */   // Label 1149: @71399
     /*   71399 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71452), // Rule ID 46277 //
     /*   71404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71415 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71450 */     GIR_RootConstrainSelectedInstOperands,
     /*   71451 */     // GIR_Coverage, 46277,
     /*   71451 */     GIR_EraseRootFromParent_Done,
     /*   71452 */   // Label 1150: @71452
     /*   71452 */   GIM_Reject,
     /*   71453 */ // Label 1134: @71453
     /*   71453 */ GIM_Reject,
     /*   71454 */ // Label 977: @71454
     /*   71454 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(72576),
     /*   71459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71469 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71558), // Rule ID 47260 //
     /*   71474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71517 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71556 */     GIR_RootConstrainSelectedInstOperands,
     /*   71557 */     // GIR_Coverage, 47260,
     /*   71557 */     GIR_EraseRootFromParent_Done,
     /*   71558 */   // Label 1152: @71558
     /*   71558 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71647), // Rule ID 47261 //
     /*   71563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71597 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71606 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71645 */     GIR_RootConstrainSelectedInstOperands,
     /*   71646 */     // GIR_Coverage, 47261,
     /*   71646 */     GIR_EraseRootFromParent_Done,
     /*   71647 */   // Label 1153: @71647
     /*   71647 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71736), // Rule ID 47020 //
     /*   71652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71686 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71695 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71734 */     GIR_RootConstrainSelectedInstOperands,
     /*   71735 */     // GIR_Coverage, 47020,
     /*   71735 */     GIR_EraseRootFromParent_Done,
     /*   71736 */   // Label 1154: @71736
     /*   71736 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71825), // Rule ID 47021 //
     /*   71741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71784 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71823 */     GIR_RootConstrainSelectedInstOperands,
     /*   71824 */     // GIR_Coverage, 47021,
     /*   71824 */     GIR_EraseRootFromParent_Done,
     /*   71825 */   // Label 1155: @71825
     /*   71825 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71914), // Rule ID 47140 //
     /*   71830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71864 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71873 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71912 */     GIR_RootConstrainSelectedInstOperands,
     /*   71913 */     // GIR_Coverage, 47140,
     /*   71913 */     GIR_EraseRootFromParent_Done,
     /*   71914 */   // Label 1156: @71914
     /*   71914 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72003), // Rule ID 47141 //
     /*   71919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71953 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71962 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72001 */     GIR_RootConstrainSelectedInstOperands,
     /*   72002 */     // GIR_Coverage, 47141,
     /*   72002 */     GIR_EraseRootFromParent_Done,
     /*   72003 */   // Label 1157: @72003
     /*   72003 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72071), // Rule ID 52018 //
     /*   72008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72045 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72069 */     GIR_RootConstrainSelectedInstOperands,
     /*   72070 */     // GIR_Coverage, 52018,
     /*   72070 */     GIR_EraseRootFromParent_Done,
     /*   72071 */   // Label 1158: @72071
     /*   72071 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72139), // Rule ID 52019 //
     /*   72076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72113 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72137 */     GIR_RootConstrainSelectedInstOperands,
     /*   72138 */     // GIR_Coverage, 52019,
     /*   72138 */     GIR_EraseRootFromParent_Done,
     /*   72139 */   // Label 1159: @72139
     /*   72139 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72194), // Rule ID 47320 //
     /*   72144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72172 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72192 */     GIR_RootConstrainSelectedInstOperands,
     /*   72193 */     // GIR_Coverage, 47320,
     /*   72193 */     GIR_EraseRootFromParent_Done,
     /*   72194 */   // Label 1160: @72194
     /*   72194 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72249), // Rule ID 47321 //
     /*   72199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72227 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72247 */     GIR_RootConstrainSelectedInstOperands,
     /*   72248 */     // GIR_Coverage, 47321,
     /*   72248 */     GIR_EraseRootFromParent_Done,
     /*   72249 */   // Label 1161: @72249
     /*   72249 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72304), // Rule ID 47080 //
     /*   72254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72282 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72302 */     GIR_RootConstrainSelectedInstOperands,
     /*   72303 */     // GIR_Coverage, 47080,
     /*   72303 */     GIR_EraseRootFromParent_Done,
     /*   72304 */   // Label 1162: @72304
     /*   72304 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72359), // Rule ID 47081 //
     /*   72309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72337 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72357 */     GIR_RootConstrainSelectedInstOperands,
     /*   72358 */     // GIR_Coverage, 47081,
     /*   72358 */     GIR_EraseRootFromParent_Done,
     /*   72359 */   // Label 1163: @72359
     /*   72359 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72414), // Rule ID 47200 //
     /*   72364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72392 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72412 */     GIR_RootConstrainSelectedInstOperands,
     /*   72413 */     // GIR_Coverage, 47200,
     /*   72413 */     GIR_EraseRootFromParent_Done,
     /*   72414 */   // Label 1164: @72414
     /*   72414 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72469), // Rule ID 47201 //
     /*   72419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72447 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72467 */     GIR_RootConstrainSelectedInstOperands,
     /*   72468 */     // GIR_Coverage, 47201,
     /*   72468 */     GIR_EraseRootFromParent_Done,
     /*   72469 */   // Label 1165: @72469
     /*   72469 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72522), // Rule ID 46292 //
     /*   72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72485 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72520 */     GIR_RootConstrainSelectedInstOperands,
     /*   72521 */     // GIR_Coverage, 46292,
     /*   72521 */     GIR_EraseRootFromParent_Done,
     /*   72522 */   // Label 1166: @72522
     /*   72522 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72575), // Rule ID 46293 //
     /*   72527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72538 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72573 */     GIR_RootConstrainSelectedInstOperands,
     /*   72574 */     // GIR_Coverage, 46293,
     /*   72574 */     GIR_EraseRootFromParent_Done,
     /*   72575 */   // Label 1167: @72575
     /*   72575 */   GIM_Reject,
     /*   72576 */ // Label 1151: @72576
     /*   72576 */ GIM_Reject,
     /*   72577 */ // Label 978: @72577
     /*   72577 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72823),
     /*   72582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72596 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72660), // Rule ID 51962 //
     /*   72601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72634 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   72634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72658 */     GIR_RootConstrainSelectedInstOperands,
     /*   72659 */     // GIR_Coverage, 51962,
     /*   72659 */     GIR_EraseRootFromParent_Done,
     /*   72660 */   // Label 1169: @72660
     /*   72660 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72724), // Rule ID 51963 //
     /*   72665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72698 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   72698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72722 */     GIR_RootConstrainSelectedInstOperands,
     /*   72723 */     // GIR_Coverage, 51963,
     /*   72723 */     GIR_EraseRootFromParent_Done,
     /*   72724 */   // Label 1170: @72724
     /*   72724 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72773), // Rule ID 46236 //
     /*   72729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72736 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72771 */     GIR_RootConstrainSelectedInstOperands,
     /*   72772 */     // GIR_Coverage, 46236,
     /*   72772 */     GIR_EraseRootFromParent_Done,
     /*   72773 */   // Label 1171: @72773
     /*   72773 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72822), // Rule ID 46237 //
     /*   72778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72785 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72820 */     GIR_RootConstrainSelectedInstOperands,
     /*   72821 */     // GIR_Coverage, 46237,
     /*   72821 */     GIR_EraseRootFromParent_Done,
     /*   72822 */   // Label 1172: @72822
     /*   72822 */   GIM_Reject,
     /*   72823 */ // Label 1168: @72823
     /*   72823 */ GIM_Reject,
     /*   72824 */ // Label 979: @72824
     /*   72824 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73946),
     /*   72829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   72832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   72835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72839 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72928), // Rule ID 47220 //
     /*   72844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72887 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72926 */     GIR_RootConstrainSelectedInstOperands,
     /*   72927 */     // GIR_Coverage, 47220,
     /*   72927 */     GIR_EraseRootFromParent_Done,
     /*   72928 */   // Label 1174: @72928
     /*   72928 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73017), // Rule ID 47221 //
     /*   72933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72976 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73015 */     GIR_RootConstrainSelectedInstOperands,
     /*   73016 */     // GIR_Coverage, 47221,
     /*   73016 */     GIR_EraseRootFromParent_Done,
     /*   73017 */   // Label 1175: @73017
     /*   73017 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73106), // Rule ID 46980 //
     /*   73022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73065 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73104 */     GIR_RootConstrainSelectedInstOperands,
     /*   73105 */     // GIR_Coverage, 46980,
     /*   73105 */     GIR_EraseRootFromParent_Done,
     /*   73106 */   // Label 1176: @73106
     /*   73106 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73195), // Rule ID 46981 //
     /*   73111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73154 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73193 */     GIR_RootConstrainSelectedInstOperands,
     /*   73194 */     // GIR_Coverage, 46981,
     /*   73194 */     GIR_EraseRootFromParent_Done,
     /*   73195 */   // Label 1177: @73195
     /*   73195 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73284), // Rule ID 47100 //
     /*   73200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73243 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73282 */     GIR_RootConstrainSelectedInstOperands,
     /*   73283 */     // GIR_Coverage, 47100,
     /*   73283 */     GIR_EraseRootFromParent_Done,
     /*   73284 */   // Label 1178: @73284
     /*   73284 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73373), // Rule ID 47101 //
     /*   73289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73332 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73371 */     GIR_RootConstrainSelectedInstOperands,
     /*   73372 */     // GIR_Coverage, 47101,
     /*   73372 */     GIR_EraseRootFromParent_Done,
     /*   73373 */   // Label 1179: @73373
     /*   73373 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73441), // Rule ID 51990 //
     /*   73378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73415 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73439 */     GIR_RootConstrainSelectedInstOperands,
     /*   73440 */     // GIR_Coverage, 51990,
     /*   73440 */     GIR_EraseRootFromParent_Done,
     /*   73441 */   // Label 1180: @73441
     /*   73441 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73509), // Rule ID 51991 //
     /*   73446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73483 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73507 */     GIR_RootConstrainSelectedInstOperands,
     /*   73508 */     // GIR_Coverage, 51991,
     /*   73508 */     GIR_EraseRootFromParent_Done,
     /*   73509 */   // Label 1181: @73509
     /*   73509 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73564), // Rule ID 47280 //
     /*   73514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73542 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73562 */     GIR_RootConstrainSelectedInstOperands,
     /*   73563 */     // GIR_Coverage, 47280,
     /*   73563 */     GIR_EraseRootFromParent_Done,
     /*   73564 */   // Label 1182: @73564
     /*   73564 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73619), // Rule ID 47281 //
     /*   73569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73597 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73617 */     GIR_RootConstrainSelectedInstOperands,
     /*   73618 */     // GIR_Coverage, 47281,
     /*   73618 */     GIR_EraseRootFromParent_Done,
     /*   73619 */   // Label 1183: @73619
     /*   73619 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73674), // Rule ID 47040 //
     /*   73624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73652 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73672 */     GIR_RootConstrainSelectedInstOperands,
     /*   73673 */     // GIR_Coverage, 47040,
     /*   73673 */     GIR_EraseRootFromParent_Done,
     /*   73674 */   // Label 1184: @73674
     /*   73674 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73729), // Rule ID 47041 //
     /*   73679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73707 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73727 */     GIR_RootConstrainSelectedInstOperands,
     /*   73728 */     // GIR_Coverage, 47041,
     /*   73728 */     GIR_EraseRootFromParent_Done,
     /*   73729 */   // Label 1185: @73729
     /*   73729 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73784), // Rule ID 47160 //
     /*   73734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73762 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73782 */     GIR_RootConstrainSelectedInstOperands,
     /*   73783 */     // GIR_Coverage, 47160,
     /*   73783 */     GIR_EraseRootFromParent_Done,
     /*   73784 */   // Label 1186: @73784
     /*   73784 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73839), // Rule ID 47161 //
     /*   73789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73817 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73837 */     GIR_RootConstrainSelectedInstOperands,
     /*   73838 */     // GIR_Coverage, 47161,
     /*   73838 */     GIR_EraseRootFromParent_Done,
     /*   73839 */   // Label 1187: @73839
     /*   73839 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73892), // Rule ID 46264 //
     /*   73844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73855 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73890 */     GIR_RootConstrainSelectedInstOperands,
     /*   73891 */     // GIR_Coverage, 46264,
     /*   73891 */     GIR_EraseRootFromParent_Done,
     /*   73892 */   // Label 1188: @73892
     /*   73892 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73945), // Rule ID 46265 //
     /*   73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73908 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73943 */     GIR_RootConstrainSelectedInstOperands,
     /*   73944 */     // GIR_Coverage, 46265,
     /*   73944 */     GIR_EraseRootFromParent_Done,
     /*   73945 */   // Label 1189: @73945
     /*   73945 */   GIM_Reject,
     /*   73946 */ // Label 1173: @73946
     /*   73946 */ GIM_Reject,
     /*   73947 */ // Label 980: @73947
     /*   73947 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(75069),
     /*   73952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   73955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   73958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73962 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74051), // Rule ID 47244 //
     /*   73967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74001 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74010 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74049 */     GIR_RootConstrainSelectedInstOperands,
     /*   74050 */     // GIR_Coverage, 47244,
     /*   74050 */     GIR_EraseRootFromParent_Done,
     /*   74051 */   // Label 1191: @74051
     /*   74051 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74140), // Rule ID 47245 //
     /*   74056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74099 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74138 */     GIR_RootConstrainSelectedInstOperands,
     /*   74139 */     // GIR_Coverage, 47245,
     /*   74139 */     GIR_EraseRootFromParent_Done,
     /*   74140 */   // Label 1192: @74140
     /*   74140 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74229), // Rule ID 47004 //
     /*   74145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74188 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74227 */     GIR_RootConstrainSelectedInstOperands,
     /*   74228 */     // GIR_Coverage, 47004,
     /*   74228 */     GIR_EraseRootFromParent_Done,
     /*   74229 */   // Label 1193: @74229
     /*   74229 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74318), // Rule ID 47005 //
     /*   74234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74268 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74277 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74316 */     GIR_RootConstrainSelectedInstOperands,
     /*   74317 */     // GIR_Coverage, 47005,
     /*   74317 */     GIR_EraseRootFromParent_Done,
     /*   74318 */   // Label 1194: @74318
     /*   74318 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74407), // Rule ID 47124 //
     /*   74323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74366 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74405 */     GIR_RootConstrainSelectedInstOperands,
     /*   74406 */     // GIR_Coverage, 47124,
     /*   74406 */     GIR_EraseRootFromParent_Done,
     /*   74407 */   // Label 1195: @74407
     /*   74407 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74496), // Rule ID 47125 //
     /*   74412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74446 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74455 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74494 */     GIR_RootConstrainSelectedInstOperands,
     /*   74495 */     // GIR_Coverage, 47125,
     /*   74495 */     GIR_EraseRootFromParent_Done,
     /*   74496 */   // Label 1196: @74496
     /*   74496 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74564), // Rule ID 52006 //
     /*   74501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74538 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   74538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74562 */     GIR_RootConstrainSelectedInstOperands,
     /*   74563 */     // GIR_Coverage, 52006,
     /*   74563 */     GIR_EraseRootFromParent_Done,
     /*   74564 */   // Label 1197: @74564
     /*   74564 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74632), // Rule ID 52007 //
     /*   74569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74606 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   74606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74630 */     GIR_RootConstrainSelectedInstOperands,
     /*   74631 */     // GIR_Coverage, 52007,
     /*   74631 */     GIR_EraseRootFromParent_Done,
     /*   74632 */   // Label 1198: @74632
     /*   74632 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74687), // Rule ID 47304 //
     /*   74637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74665 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74685 */     GIR_RootConstrainSelectedInstOperands,
     /*   74686 */     // GIR_Coverage, 47304,
     /*   74686 */     GIR_EraseRootFromParent_Done,
     /*   74687 */   // Label 1199: @74687
     /*   74687 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74742), // Rule ID 47305 //
     /*   74692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74720 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74740 */     GIR_RootConstrainSelectedInstOperands,
     /*   74741 */     // GIR_Coverage, 47305,
     /*   74741 */     GIR_EraseRootFromParent_Done,
     /*   74742 */   // Label 1200: @74742
     /*   74742 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74797), // Rule ID 47064 //
     /*   74747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74775 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74795 */     GIR_RootConstrainSelectedInstOperands,
     /*   74796 */     // GIR_Coverage, 47064,
     /*   74796 */     GIR_EraseRootFromParent_Done,
     /*   74797 */   // Label 1201: @74797
     /*   74797 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74852), // Rule ID 47065 //
     /*   74802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74830 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74850 */     GIR_RootConstrainSelectedInstOperands,
     /*   74851 */     // GIR_Coverage, 47065,
     /*   74851 */     GIR_EraseRootFromParent_Done,
     /*   74852 */   // Label 1202: @74852
     /*   74852 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74907), // Rule ID 47184 //
     /*   74857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74885 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74905 */     GIR_RootConstrainSelectedInstOperands,
     /*   74906 */     // GIR_Coverage, 47184,
     /*   74906 */     GIR_EraseRootFromParent_Done,
     /*   74907 */   // Label 1203: @74907
     /*   74907 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74962), // Rule ID 47185 //
     /*   74912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74940 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74960 */     GIR_RootConstrainSelectedInstOperands,
     /*   74961 */     // GIR_Coverage, 47185,
     /*   74961 */     GIR_EraseRootFromParent_Done,
     /*   74962 */   // Label 1204: @74962
     /*   74962 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75015), // Rule ID 46280 //
     /*   74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74978 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   74978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   74995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75013 */     GIR_RootConstrainSelectedInstOperands,
     /*   75014 */     // GIR_Coverage, 46280,
     /*   75014 */     GIR_EraseRootFromParent_Done,
     /*   75015 */   // Label 1205: @75015
     /*   75015 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75068), // Rule ID 46281 //
     /*   75020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75031 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75066 */     GIR_RootConstrainSelectedInstOperands,
     /*   75067 */     // GIR_Coverage, 46281,
     /*   75067 */     GIR_EraseRootFromParent_Done,
     /*   75068 */   // Label 1206: @75068
     /*   75068 */   GIM_Reject,
     /*   75069 */ // Label 1190: @75069
     /*   75069 */ GIM_Reject,
     /*   75070 */ // Label 981: @75070
     /*   75070 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(76192),
     /*   75075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75085 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75174), // Rule ID 47264 //
     /*   75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75133 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75172 */     GIR_RootConstrainSelectedInstOperands,
     /*   75173 */     // GIR_Coverage, 47264,
     /*   75173 */     GIR_EraseRootFromParent_Done,
     /*   75174 */   // Label 1208: @75174
     /*   75174 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75263), // Rule ID 47265 //
     /*   75179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75213 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75222 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75261 */     GIR_RootConstrainSelectedInstOperands,
     /*   75262 */     // GIR_Coverage, 47265,
     /*   75262 */     GIR_EraseRootFromParent_Done,
     /*   75263 */   // Label 1209: @75263
     /*   75263 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75352), // Rule ID 47024 //
     /*   75268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75302 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75311 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75350 */     GIR_RootConstrainSelectedInstOperands,
     /*   75351 */     // GIR_Coverage, 47024,
     /*   75351 */     GIR_EraseRootFromParent_Done,
     /*   75352 */   // Label 1210: @75352
     /*   75352 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75441), // Rule ID 47025 //
     /*   75357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75391 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75400 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75439 */     GIR_RootConstrainSelectedInstOperands,
     /*   75440 */     // GIR_Coverage, 47025,
     /*   75440 */     GIR_EraseRootFromParent_Done,
     /*   75441 */   // Label 1211: @75441
     /*   75441 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75530), // Rule ID 47144 //
     /*   75446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75489 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75528 */     GIR_RootConstrainSelectedInstOperands,
     /*   75529 */     // GIR_Coverage, 47144,
     /*   75529 */     GIR_EraseRootFromParent_Done,
     /*   75530 */   // Label 1212: @75530
     /*   75530 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75619), // Rule ID 47145 //
     /*   75535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75569 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75578 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75617 */     GIR_RootConstrainSelectedInstOperands,
     /*   75618 */     // GIR_Coverage, 47145,
     /*   75618 */     GIR_EraseRootFromParent_Done,
     /*   75619 */   // Label 1213: @75619
     /*   75619 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75687), // Rule ID 52022 //
     /*   75624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   75627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75661 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   75661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75685 */     GIR_RootConstrainSelectedInstOperands,
     /*   75686 */     // GIR_Coverage, 52022,
     /*   75686 */     GIR_EraseRootFromParent_Done,
     /*   75687 */   // Label 1214: @75687
     /*   75687 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75755), // Rule ID 52023 //
     /*   75692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   75695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75729 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   75729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75753 */     GIR_RootConstrainSelectedInstOperands,
     /*   75754 */     // GIR_Coverage, 52023,
     /*   75754 */     GIR_EraseRootFromParent_Done,
     /*   75755 */   // Label 1215: @75755
     /*   75755 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75810), // Rule ID 47324 //
     /*   75760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75788 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75808 */     GIR_RootConstrainSelectedInstOperands,
     /*   75809 */     // GIR_Coverage, 47324,
     /*   75809 */     GIR_EraseRootFromParent_Done,
     /*   75810 */   // Label 1216: @75810
     /*   75810 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75865), // Rule ID 47325 //
     /*   75815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75843 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75863 */     GIR_RootConstrainSelectedInstOperands,
     /*   75864 */     // GIR_Coverage, 47325,
     /*   75864 */     GIR_EraseRootFromParent_Done,
     /*   75865 */   // Label 1217: @75865
     /*   75865 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75920), // Rule ID 47084 //
     /*   75870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75898 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75918 */     GIR_RootConstrainSelectedInstOperands,
     /*   75919 */     // GIR_Coverage, 47084,
     /*   75919 */     GIR_EraseRootFromParent_Done,
     /*   75920 */   // Label 1218: @75920
     /*   75920 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75975), // Rule ID 47085 //
     /*   75925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75953 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75973 */     GIR_RootConstrainSelectedInstOperands,
     /*   75974 */     // GIR_Coverage, 47085,
     /*   75974 */     GIR_EraseRootFromParent_Done,
     /*   75975 */   // Label 1219: @75975
     /*   75975 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76030), // Rule ID 47204 //
     /*   75980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76008 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76028 */     GIR_RootConstrainSelectedInstOperands,
     /*   76029 */     // GIR_Coverage, 47204,
     /*   76029 */     GIR_EraseRootFromParent_Done,
     /*   76030 */   // Label 1220: @76030
     /*   76030 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76085), // Rule ID 47205 //
     /*   76035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76063 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76083 */     GIR_RootConstrainSelectedInstOperands,
     /*   76084 */     // GIR_Coverage, 47205,
     /*   76084 */     GIR_EraseRootFromParent_Done,
     /*   76085 */   // Label 1221: @76085
     /*   76085 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76138), // Rule ID 46296 //
     /*   76090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76101 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76136 */     GIR_RootConstrainSelectedInstOperands,
     /*   76137 */     // GIR_Coverage, 46296,
     /*   76137 */     GIR_EraseRootFromParent_Done,
     /*   76138 */   // Label 1222: @76138
     /*   76138 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76191), // Rule ID 46297 //
     /*   76143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76154 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76189 */     GIR_RootConstrainSelectedInstOperands,
     /*   76190 */     // GIR_Coverage, 46297,
     /*   76190 */     GIR_EraseRootFromParent_Done,
     /*   76191 */   // Label 1223: @76191
     /*   76191 */   GIM_Reject,
     /*   76192 */ // Label 1207: @76192
     /*   76192 */ GIM_Reject,
     /*   76193 */ // Label 982: @76193
     /*   76193 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76439),
     /*   76198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76212 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76276), // Rule ID 51978 //
     /*   76217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76250 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76274 */     GIR_RootConstrainSelectedInstOperands,
     /*   76275 */     // GIR_Coverage, 51978,
     /*   76275 */     GIR_EraseRootFromParent_Done,
     /*   76276 */   // Label 1225: @76276
     /*   76276 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76340), // Rule ID 51979 //
     /*   76281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76314 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76338 */     GIR_RootConstrainSelectedInstOperands,
     /*   76339 */     // GIR_Coverage, 51979,
     /*   76339 */     GIR_EraseRootFromParent_Done,
     /*   76340 */   // Label 1226: @76340
     /*   76340 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76389), // Rule ID 46252 //
     /*   76345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76352 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76387 */     GIR_RootConstrainSelectedInstOperands,
     /*   76388 */     // GIR_Coverage, 46252,
     /*   76388 */     GIR_EraseRootFromParent_Done,
     /*   76389 */   // Label 1227: @76389
     /*   76389 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76438), // Rule ID 46253 //
     /*   76394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76401 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76436 */     GIR_RootConstrainSelectedInstOperands,
     /*   76437 */     // GIR_Coverage, 46253,
     /*   76437 */     GIR_EraseRootFromParent_Done,
     /*   76438 */   // Label 1228: @76438
     /*   76438 */   GIM_Reject,
     /*   76439 */ // Label 1224: @76439
     /*   76439 */ GIM_Reject,
     /*   76440 */ // Label 983: @76440
     /*   76440 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77562),
     /*   76445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76455 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76544), // Rule ID 47224 //
     /*   76460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76503 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76542 */     GIR_RootConstrainSelectedInstOperands,
     /*   76543 */     // GIR_Coverage, 47224,
     /*   76543 */     GIR_EraseRootFromParent_Done,
     /*   76544 */   // Label 1230: @76544
     /*   76544 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76633), // Rule ID 47225 //
     /*   76549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76592 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76631 */     GIR_RootConstrainSelectedInstOperands,
     /*   76632 */     // GIR_Coverage, 47225,
     /*   76632 */     GIR_EraseRootFromParent_Done,
     /*   76633 */   // Label 1231: @76633
     /*   76633 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76722), // Rule ID 46984 //
     /*   76638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76681 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76720 */     GIR_RootConstrainSelectedInstOperands,
     /*   76721 */     // GIR_Coverage, 46984,
     /*   76721 */     GIR_EraseRootFromParent_Done,
     /*   76722 */   // Label 1232: @76722
     /*   76722 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76811), // Rule ID 46985 //
     /*   76727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76770 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76809 */     GIR_RootConstrainSelectedInstOperands,
     /*   76810 */     // GIR_Coverage, 46985,
     /*   76810 */     GIR_EraseRootFromParent_Done,
     /*   76811 */   // Label 1233: @76811
     /*   76811 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76900), // Rule ID 47104 //
     /*   76816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76859 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76898 */     GIR_RootConstrainSelectedInstOperands,
     /*   76899 */     // GIR_Coverage, 47104,
     /*   76899 */     GIR_EraseRootFromParent_Done,
     /*   76900 */   // Label 1234: @76900
     /*   76900 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(76989), // Rule ID 47105 //
     /*   76905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76948 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76987 */     GIR_RootConstrainSelectedInstOperands,
     /*   76988 */     // GIR_Coverage, 47105,
     /*   76988 */     GIR_EraseRootFromParent_Done,
     /*   76989 */   // Label 1235: @76989
     /*   76989 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77057), // Rule ID 51994 //
     /*   76994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77031 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77055 */     GIR_RootConstrainSelectedInstOperands,
     /*   77056 */     // GIR_Coverage, 51994,
     /*   77056 */     GIR_EraseRootFromParent_Done,
     /*   77057 */   // Label 1236: @77057
     /*   77057 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77125), // Rule ID 51995 //
     /*   77062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77099 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77123 */     GIR_RootConstrainSelectedInstOperands,
     /*   77124 */     // GIR_Coverage, 51995,
     /*   77124 */     GIR_EraseRootFromParent_Done,
     /*   77125 */   // Label 1237: @77125
     /*   77125 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77180), // Rule ID 47284 //
     /*   77130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77158 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77178 */     GIR_RootConstrainSelectedInstOperands,
     /*   77179 */     // GIR_Coverage, 47284,
     /*   77179 */     GIR_EraseRootFromParent_Done,
     /*   77180 */   // Label 1238: @77180
     /*   77180 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77235), // Rule ID 47285 //
     /*   77185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77213 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77233 */     GIR_RootConstrainSelectedInstOperands,
     /*   77234 */     // GIR_Coverage, 47285,
     /*   77234 */     GIR_EraseRootFromParent_Done,
     /*   77235 */   // Label 1239: @77235
     /*   77235 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77290), // Rule ID 47044 //
     /*   77240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77268 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77288 */     GIR_RootConstrainSelectedInstOperands,
     /*   77289 */     // GIR_Coverage, 47044,
     /*   77289 */     GIR_EraseRootFromParent_Done,
     /*   77290 */   // Label 1240: @77290
     /*   77290 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77345), // Rule ID 47045 //
     /*   77295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77323 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77343 */     GIR_RootConstrainSelectedInstOperands,
     /*   77344 */     // GIR_Coverage, 47045,
     /*   77344 */     GIR_EraseRootFromParent_Done,
     /*   77345 */   // Label 1241: @77345
     /*   77345 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77400), // Rule ID 47164 //
     /*   77350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77378 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77398 */     GIR_RootConstrainSelectedInstOperands,
     /*   77399 */     // GIR_Coverage, 47164,
     /*   77399 */     GIR_EraseRootFromParent_Done,
     /*   77400 */   // Label 1242: @77400
     /*   77400 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77455), // Rule ID 47165 //
     /*   77405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77433 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77453 */     GIR_RootConstrainSelectedInstOperands,
     /*   77454 */     // GIR_Coverage, 47165,
     /*   77454 */     GIR_EraseRootFromParent_Done,
     /*   77455 */   // Label 1243: @77455
     /*   77455 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77508), // Rule ID 46268 //
     /*   77460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77471 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77506 */     GIR_RootConstrainSelectedInstOperands,
     /*   77507 */     // GIR_Coverage, 46268,
     /*   77507 */     GIR_EraseRootFromParent_Done,
     /*   77508 */   // Label 1244: @77508
     /*   77508 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77561), // Rule ID 46269 //
     /*   77513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77524 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77559 */     GIR_RootConstrainSelectedInstOperands,
     /*   77560 */     // GIR_Coverage, 46269,
     /*   77560 */     GIR_EraseRootFromParent_Done,
     /*   77561 */   // Label 1245: @77561
     /*   77561 */   GIM_Reject,
     /*   77562 */ // Label 1229: @77562
     /*   77562 */ GIM_Reject,
     /*   77563 */ // Label 984: @77563
     /*   77563 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(78685),
     /*   77568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   77571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   77574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   77578 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77667), // Rule ID 47248 //
     /*   77583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77626 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77665 */     GIR_RootConstrainSelectedInstOperands,
     /*   77666 */     // GIR_Coverage, 47248,
     /*   77666 */     GIR_EraseRootFromParent_Done,
     /*   77667 */   // Label 1247: @77667
     /*   77667 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77756), // Rule ID 47249 //
     /*   77672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77715 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77754 */     GIR_RootConstrainSelectedInstOperands,
     /*   77755 */     // GIR_Coverage, 47249,
     /*   77755 */     GIR_EraseRootFromParent_Done,
     /*   77756 */   // Label 1248: @77756
     /*   77756 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77845), // Rule ID 47008 //
     /*   77761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77804 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77843 */     GIR_RootConstrainSelectedInstOperands,
     /*   77844 */     // GIR_Coverage, 47008,
     /*   77844 */     GIR_EraseRootFromParent_Done,
     /*   77845 */   // Label 1249: @77845
     /*   77845 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77934), // Rule ID 47009 //
     /*   77850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77893 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77932 */     GIR_RootConstrainSelectedInstOperands,
     /*   77933 */     // GIR_Coverage, 47009,
     /*   77933 */     GIR_EraseRootFromParent_Done,
     /*   77934 */   // Label 1250: @77934
     /*   77934 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78023), // Rule ID 47128 //
     /*   77939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77982 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78021 */     GIR_RootConstrainSelectedInstOperands,
     /*   78022 */     // GIR_Coverage, 47128,
     /*   78022 */     GIR_EraseRootFromParent_Done,
     /*   78023 */   // Label 1251: @78023
     /*   78023 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(78112), // Rule ID 47129 //
     /*   78028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78062 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78071 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78110 */     GIR_RootConstrainSelectedInstOperands,
     /*   78111 */     // GIR_Coverage, 47129,
     /*   78111 */     GIR_EraseRootFromParent_Done,
     /*   78112 */   // Label 1252: @78112
     /*   78112 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78180), // Rule ID 52010 //
     /*   78117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78154 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78178 */     GIR_RootConstrainSelectedInstOperands,
     /*   78179 */     // GIR_Coverage, 52010,
     /*   78179 */     GIR_EraseRootFromParent_Done,
     /*   78180 */   // Label 1253: @78180
     /*   78180 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78248), // Rule ID 52011 //
     /*   78185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78222 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78246 */     GIR_RootConstrainSelectedInstOperands,
     /*   78247 */     // GIR_Coverage, 52011,
     /*   78247 */     GIR_EraseRootFromParent_Done,
     /*   78248 */   // Label 1254: @78248
     /*   78248 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78303), // Rule ID 47308 //
     /*   78253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78281 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78301 */     GIR_RootConstrainSelectedInstOperands,
     /*   78302 */     // GIR_Coverage, 47308,
     /*   78302 */     GIR_EraseRootFromParent_Done,
     /*   78303 */   // Label 1255: @78303
     /*   78303 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78358), // Rule ID 47309 //
     /*   78308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78336 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78356 */     GIR_RootConstrainSelectedInstOperands,
     /*   78357 */     // GIR_Coverage, 47309,
     /*   78357 */     GIR_EraseRootFromParent_Done,
     /*   78358 */   // Label 1256: @78358
     /*   78358 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78413), // Rule ID 47068 //
     /*   78363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78391 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78411 */     GIR_RootConstrainSelectedInstOperands,
     /*   78412 */     // GIR_Coverage, 47068,
     /*   78412 */     GIR_EraseRootFromParent_Done,
     /*   78413 */   // Label 1257: @78413
     /*   78413 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78468), // Rule ID 47069 //
     /*   78418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78446 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78466 */     GIR_RootConstrainSelectedInstOperands,
     /*   78467 */     // GIR_Coverage, 47069,
     /*   78467 */     GIR_EraseRootFromParent_Done,
     /*   78468 */   // Label 1258: @78468
     /*   78468 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78523), // Rule ID 47188 //
     /*   78473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78501 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78521 */     GIR_RootConstrainSelectedInstOperands,
     /*   78522 */     // GIR_Coverage, 47188,
     /*   78522 */     GIR_EraseRootFromParent_Done,
     /*   78523 */   // Label 1259: @78523
     /*   78523 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78578), // Rule ID 47189 //
     /*   78528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78556 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78576 */     GIR_RootConstrainSelectedInstOperands,
     /*   78577 */     // GIR_Coverage, 47189,
     /*   78577 */     GIR_EraseRootFromParent_Done,
     /*   78578 */   // Label 1260: @78578
     /*   78578 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78631), // Rule ID 46284 //
     /*   78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78594 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   78594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78629 */     GIR_RootConstrainSelectedInstOperands,
     /*   78630 */     // GIR_Coverage, 46284,
     /*   78630 */     GIR_EraseRootFromParent_Done,
     /*   78631 */   // Label 1261: @78631
     /*   78631 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78684), // Rule ID 46285 //
     /*   78636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78647 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   78647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78682 */     GIR_RootConstrainSelectedInstOperands,
     /*   78683 */     // GIR_Coverage, 46285,
     /*   78683 */     GIR_EraseRootFromParent_Done,
     /*   78684 */   // Label 1262: @78684
     /*   78684 */   GIM_Reject,
     /*   78685 */ // Label 1246: @78685
     /*   78685 */ GIM_Reject,
     /*   78686 */ // Label 985: @78686
     /*   78686 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78932),
     /*   78691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78705 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78769), // Rule ID 51982 //
     /*   78710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78743 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   78743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78767 */     GIR_RootConstrainSelectedInstOperands,
     /*   78768 */     // GIR_Coverage, 51982,
     /*   78768 */     GIR_EraseRootFromParent_Done,
     /*   78769 */   // Label 1264: @78769
     /*   78769 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78833), // Rule ID 51983 //
     /*   78774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78807 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   78807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78831 */     GIR_RootConstrainSelectedInstOperands,
     /*   78832 */     // GIR_Coverage, 51983,
     /*   78832 */     GIR_EraseRootFromParent_Done,
     /*   78833 */   // Label 1265: @78833
     /*   78833 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(78882), // Rule ID 46256 //
     /*   78838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78845 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78880 */     GIR_RootConstrainSelectedInstOperands,
     /*   78881 */     // GIR_Coverage, 46256,
     /*   78881 */     GIR_EraseRootFromParent_Done,
     /*   78882 */   // Label 1266: @78882
     /*   78882 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(78931), // Rule ID 46257 //
     /*   78887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78894 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78929 */     GIR_RootConstrainSelectedInstOperands,
     /*   78930 */     // GIR_Coverage, 46257,
     /*   78930 */     GIR_EraseRootFromParent_Done,
     /*   78931 */   // Label 1267: @78931
     /*   78931 */   GIM_Reject,
     /*   78932 */ // Label 1263: @78932
     /*   78932 */ GIM_Reject,
     /*   78933 */ // Label 986: @78933
     /*   78933 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(80055),
     /*   78938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   78941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   78944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78948 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79037), // Rule ID 47228 //
     /*   78953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78996 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   78999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79035 */     GIR_RootConstrainSelectedInstOperands,
     /*   79036 */     // GIR_Coverage, 47228,
     /*   79036 */     GIR_EraseRootFromParent_Done,
     /*   79037 */   // Label 1269: @79037
     /*   79037 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79126), // Rule ID 47229 //
     /*   79042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79085 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79124 */     GIR_RootConstrainSelectedInstOperands,
     /*   79125 */     // GIR_Coverage, 47229,
     /*   79125 */     GIR_EraseRootFromParent_Done,
     /*   79126 */   // Label 1270: @79126
     /*   79126 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79215), // Rule ID 46988 //
     /*   79131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79174 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79213 */     GIR_RootConstrainSelectedInstOperands,
     /*   79214 */     // GIR_Coverage, 46988,
     /*   79214 */     GIR_EraseRootFromParent_Done,
     /*   79215 */   // Label 1271: @79215
     /*   79215 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79304), // Rule ID 46989 //
     /*   79220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79263 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79302 */     GIR_RootConstrainSelectedInstOperands,
     /*   79303 */     // GIR_Coverage, 46989,
     /*   79303 */     GIR_EraseRootFromParent_Done,
     /*   79304 */   // Label 1272: @79304
     /*   79304 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79393), // Rule ID 47108 //
     /*   79309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79352 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79391 */     GIR_RootConstrainSelectedInstOperands,
     /*   79392 */     // GIR_Coverage, 47108,
     /*   79392 */     GIR_EraseRootFromParent_Done,
     /*   79393 */   // Label 1273: @79393
     /*   79393 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(79482), // Rule ID 47109 //
     /*   79398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79441 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79480 */     GIR_RootConstrainSelectedInstOperands,
     /*   79481 */     // GIR_Coverage, 47109,
     /*   79481 */     GIR_EraseRootFromParent_Done,
     /*   79482 */   // Label 1274: @79482
     /*   79482 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79550), // Rule ID 51998 //
     /*   79487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79524 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79548 */     GIR_RootConstrainSelectedInstOperands,
     /*   79549 */     // GIR_Coverage, 51998,
     /*   79549 */     GIR_EraseRootFromParent_Done,
     /*   79550 */   // Label 1275: @79550
     /*   79550 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79618), // Rule ID 51999 //
     /*   79555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79592 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79616 */     GIR_RootConstrainSelectedInstOperands,
     /*   79617 */     // GIR_Coverage, 51999,
     /*   79617 */     GIR_EraseRootFromParent_Done,
     /*   79618 */   // Label 1276: @79618
     /*   79618 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79673), // Rule ID 47288 //
     /*   79623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79651 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79671 */     GIR_RootConstrainSelectedInstOperands,
     /*   79672 */     // GIR_Coverage, 47288,
     /*   79672 */     GIR_EraseRootFromParent_Done,
     /*   79673 */   // Label 1277: @79673
     /*   79673 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79728), // Rule ID 47289 //
     /*   79678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79706 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79726 */     GIR_RootConstrainSelectedInstOperands,
     /*   79727 */     // GIR_Coverage, 47289,
     /*   79727 */     GIR_EraseRootFromParent_Done,
     /*   79728 */   // Label 1278: @79728
     /*   79728 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79783), // Rule ID 47048 //
     /*   79733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79761 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79781 */     GIR_RootConstrainSelectedInstOperands,
     /*   79782 */     // GIR_Coverage, 47048,
     /*   79782 */     GIR_EraseRootFromParent_Done,
     /*   79783 */   // Label 1279: @79783
     /*   79783 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79838), // Rule ID 47049 //
     /*   79788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79816 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79836 */     GIR_RootConstrainSelectedInstOperands,
     /*   79837 */     // GIR_Coverage, 47049,
     /*   79837 */     GIR_EraseRootFromParent_Done,
     /*   79838 */   // Label 1280: @79838
     /*   79838 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(79893), // Rule ID 47168 //
     /*   79843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79871 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79891 */     GIR_RootConstrainSelectedInstOperands,
     /*   79892 */     // GIR_Coverage, 47168,
     /*   79892 */     GIR_EraseRootFromParent_Done,
     /*   79893 */   // Label 1281: @79893
     /*   79893 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(79948), // Rule ID 47169 //
     /*   79898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79926 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79946 */     GIR_RootConstrainSelectedInstOperands,
     /*   79947 */     // GIR_Coverage, 47169,
     /*   79947 */     GIR_EraseRootFromParent_Done,
     /*   79948 */   // Label 1282: @79948
     /*   79948 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80001), // Rule ID 46272 //
     /*   79953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79964 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79999 */     GIR_RootConstrainSelectedInstOperands,
     /*   80000 */     // GIR_Coverage, 46272,
     /*   80000 */     GIR_EraseRootFromParent_Done,
     /*   80001 */   // Label 1283: @80001
     /*   80001 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80054), // Rule ID 46273 //
     /*   80006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80017 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80052 */     GIR_RootConstrainSelectedInstOperands,
     /*   80053 */     // GIR_Coverage, 46273,
     /*   80053 */     GIR_EraseRootFromParent_Done,
     /*   80054 */   // Label 1284: @80054
     /*   80054 */   GIM_Reject,
     /*   80055 */ // Label 1268: @80055
     /*   80055 */ GIM_Reject,
     /*   80056 */ // Label 987: @80056
     /*   80056 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80302),
     /*   80061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80075 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80139), // Rule ID 51986 //
     /*   80080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80113 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80137 */     GIR_RootConstrainSelectedInstOperands,
     /*   80138 */     // GIR_Coverage, 51986,
     /*   80138 */     GIR_EraseRootFromParent_Done,
     /*   80139 */   // Label 1286: @80139
     /*   80139 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80203), // Rule ID 51987 //
     /*   80144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80177 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80201 */     GIR_RootConstrainSelectedInstOperands,
     /*   80202 */     // GIR_Coverage, 51987,
     /*   80202 */     GIR_EraseRootFromParent_Done,
     /*   80203 */   // Label 1287: @80203
     /*   80203 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80252), // Rule ID 46260 //
     /*   80208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80215 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80250 */     GIR_RootConstrainSelectedInstOperands,
     /*   80251 */     // GIR_Coverage, 46260,
     /*   80251 */     GIR_EraseRootFromParent_Done,
     /*   80252 */   // Label 1288: @80252
     /*   80252 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80301), // Rule ID 46261 //
     /*   80257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80264 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80299 */     GIR_RootConstrainSelectedInstOperands,
     /*   80300 */     // GIR_Coverage, 46261,
     /*   80300 */     GIR_EraseRootFromParent_Done,
     /*   80301 */   // Label 1289: @80301
     /*   80301 */   GIM_Reject,
     /*   80302 */ // Label 1285: @80302
     /*   80302 */ GIM_Reject,
     /*   80303 */ // Label 988: @80303
     /*   80303 */ GIM_Reject,
     /*   80304 */ // Label 2: @80304
     /*   80304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1314*/ GIMT_Encode4(107357),
     /*   80315 */ /*GILLT_s32*//*Label 1290*/ GIMT_Encode4(80439),
     /*   80319 */ /*GILLT_s64*//*Label 1291*/ GIMT_Encode4(80473), GIMT_Encode4(0),
     /*   80327 */ /*GILLT_nxv1s8*//*Label 1292*/ GIMT_Encode4(80677),
     /*   80331 */ /*GILLT_nxv1s16*//*Label 1293*/ GIMT_Encode4(80792),
     /*   80335 */ /*GILLT_nxv1s32*//*Label 1294*/ GIMT_Encode4(82517),
     /*   80339 */ /*GILLT_nxv1s64*//*Label 1295*/ GIMT_Encode4(84242), GIMT_Encode4(0),
     /*   80347 */ /*GILLT_nxv2s8*//*Label 1296*/ GIMT_Encode4(85967),
     /*   80351 */ /*GILLT_nxv2s16*//*Label 1297*/ GIMT_Encode4(86082),
     /*   80355 */ /*GILLT_nxv2s32*//*Label 1298*/ GIMT_Encode4(87807),
     /*   80359 */ /*GILLT_nxv2s64*//*Label 1299*/ GIMT_Encode4(89532), GIMT_Encode4(0),
     /*   80367 */ /*GILLT_nxv4s8*//*Label 1300*/ GIMT_Encode4(91257),
     /*   80371 */ /*GILLT_nxv4s16*//*Label 1301*/ GIMT_Encode4(91372),
     /*   80375 */ /*GILLT_nxv4s32*//*Label 1302*/ GIMT_Encode4(93097),
     /*   80379 */ /*GILLT_nxv4s64*//*Label 1303*/ GIMT_Encode4(94822), GIMT_Encode4(0),
     /*   80387 */ /*GILLT_nxv8s8*//*Label 1304*/ GIMT_Encode4(96547),
     /*   80391 */ /*GILLT_nxv8s16*//*Label 1305*/ GIMT_Encode4(96662),
     /*   80395 */ /*GILLT_nxv8s32*//*Label 1306*/ GIMT_Encode4(98387),
     /*   80399 */ /*GILLT_nxv8s64*//*Label 1307*/ GIMT_Encode4(100112), GIMT_Encode4(0),
     /*   80407 */ /*GILLT_nxv16s8*//*Label 1308*/ GIMT_Encode4(101837),
     /*   80411 */ /*GILLT_nxv16s16*//*Label 1309*/ GIMT_Encode4(101952),
     /*   80415 */ /*GILLT_nxv16s32*//*Label 1310*/ GIMT_Encode4(103677), GIMT_Encode4(0),
     /*   80423 */ /*GILLT_nxv32s8*//*Label 1311*/ GIMT_Encode4(105402),
     /*   80427 */ /*GILLT_nxv32s16*//*Label 1312*/ GIMT_Encode4(105517), GIMT_Encode4(0),
     /*   80435 */ /*GILLT_nxv64s8*//*Label 1313*/ GIMT_Encode4(107242),
     /*   80439 */ // Label 1290: @80439
     /*   80439 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(80472), // Rule ID 290 //
     /*   80444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80465 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80470 */   GIR_RootConstrainSelectedInstOperands,
     /*   80471 */   // GIR_Coverage, 290,
     /*   80471 */   GIR_Done,
     /*   80472 */ // Label 1315: @80472
     /*   80472 */ GIM_Reject,
     /*   80473 */ // Label 1291: @80473
     /*   80473 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(80676),
     /*   80478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80484 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(80617), // Rule ID 312 //
     /*   80489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80517 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   80540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   80544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80549 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80562 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   80562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   80565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   80581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   80583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   80586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   80602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   80607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   80615 */     GIR_RootConstrainSelectedInstOperands,
     /*   80616 */     // GIR_Coverage, 312,
     /*   80616 */     GIR_EraseRootFromParent_Done,
     /*   80617 */   // Label 1317: @80617
     /*   80617 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(80648), // Rule ID 305 //
     /*   80622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   80625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10086),
     /*   80641 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10086>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   80646 */     GIR_RootConstrainSelectedInstOperands,
     /*   80647 */     // GIR_Coverage, 305,
     /*   80647 */     GIR_Done,
     /*   80648 */   // Label 1318: @80648
     /*   80648 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(80675), // Rule ID 289 //
     /*   80653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   80656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80668 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80673 */     GIR_RootConstrainSelectedInstOperands,
     /*   80674 */     // GIR_Coverage, 289,
     /*   80674 */     GIR_Done,
     /*   80675 */   // Label 1319: @80675
     /*   80675 */   GIM_Reject,
     /*   80676 */ // Label 1316: @80676
     /*   80676 */ GIM_Reject,
     /*   80677 */ // Label 1292: @80677
     /*   80677 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(80791),
     /*   80682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   80688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80700 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80745), // Rule ID 50848 //
     /*   80705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80708 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80743 */     GIR_RootConstrainSelectedInstOperands,
     /*   80744 */     // GIR_Coverage, 50848,
     /*   80744 */     GIR_EraseRootFromParent_Done,
     /*   80745 */   // Label 1321: @80745
     /*   80745 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(80790), // Rule ID 50849 //
     /*   80750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80753 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80788 */     GIR_RootConstrainSelectedInstOperands,
     /*   80789 */     // GIR_Coverage, 50849,
     /*   80789 */     GIR_EraseRootFromParent_Done,
     /*   80790 */   // Label 1322: @80790
     /*   80790 */   GIM_Reject,
     /*   80791 */ // Label 1320: @80791
     /*   80791 */ GIM_Reject,
     /*   80792 */ // Label 1293: @80792
     /*   80792 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82516),
     /*   80797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   80800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   80803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80807 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(80896), // Rule ID 51614 //
     /*   80812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80855 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80894 */     GIR_RootConstrainSelectedInstOperands,
     /*   80895 */     // GIR_Coverage, 51614,
     /*   80895 */     GIR_EraseRootFromParent_Done,
     /*   80896 */   // Label 1324: @80896
     /*   80896 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(80985), // Rule ID 51615 //
     /*   80901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80944 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80983 */     GIR_RootConstrainSelectedInstOperands,
     /*   80984 */     // GIR_Coverage, 51615,
     /*   80984 */     GIR_EraseRootFromParent_Done,
     /*   80985 */   // Label 1325: @80985
     /*   80985 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81074), // Rule ID 70292 //
     /*   80990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81033 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81072 */     GIR_RootConstrainSelectedInstOperands,
     /*   81073 */     // GIR_Coverage, 70292,
     /*   81073 */     GIR_EraseRootFromParent_Done,
     /*   81074 */   // Label 1326: @81074
     /*   81074 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81163), // Rule ID 70293 //
     /*   81079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81122 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81161 */     GIR_RootConstrainSelectedInstOperands,
     /*   81162 */     // GIR_Coverage, 70293,
     /*   81162 */     GIR_EraseRootFromParent_Done,
     /*   81163 */   // Label 1327: @81163
     /*   81163 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81252), // Rule ID 70172 //
     /*   81168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81211 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81250 */     GIR_RootConstrainSelectedInstOperands,
     /*   81251 */     // GIR_Coverage, 70172,
     /*   81251 */     GIR_EraseRootFromParent_Done,
     /*   81252 */   // Label 1328: @81252
     /*   81252 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(81341), // Rule ID 70173 //
     /*   81257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81300 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81339 */     GIR_RootConstrainSelectedInstOperands,
     /*   81340 */     // GIR_Coverage, 70173,
     /*   81340 */     GIR_EraseRootFromParent_Done,
     /*   81341 */   // Label 1329: @81341
     /*   81341 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81430), // Rule ID 51794 //
     /*   81346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81389 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81428 */     GIR_RootConstrainSelectedInstOperands,
     /*   81429 */     // GIR_Coverage, 51794,
     /*   81429 */     GIR_EraseRootFromParent_Done,
     /*   81430 */   // Label 1330: @81430
     /*   81430 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81519), // Rule ID 51795 //
     /*   81435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81478 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81517 */     GIR_RootConstrainSelectedInstOperands,
     /*   81518 */     // GIR_Coverage, 51795,
     /*   81518 */     GIR_EraseRootFromParent_Done,
     /*   81519 */   // Label 1331: @81519
     /*   81519 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81608), // Rule ID 51494 //
     /*   81524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81567 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81606 */     GIR_RootConstrainSelectedInstOperands,
     /*   81607 */     // GIR_Coverage, 51494,
     /*   81607 */     GIR_EraseRootFromParent_Done,
     /*   81608 */   // Label 1332: @81608
     /*   81608 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81697), // Rule ID 51495 //
     /*   81613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81656 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81695 */     GIR_RootConstrainSelectedInstOperands,
     /*   81696 */     // GIR_Coverage, 51495,
     /*   81696 */     GIR_EraseRootFromParent_Done,
     /*   81697 */   // Label 1333: @81697
     /*   81697 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81786), // Rule ID 51734 //
     /*   81702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81745 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81784 */     GIR_RootConstrainSelectedInstOperands,
     /*   81785 */     // GIR_Coverage, 51734,
     /*   81785 */     GIR_EraseRootFromParent_Done,
     /*   81786 */   // Label 1334: @81786
     /*   81786 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81875), // Rule ID 51735 //
     /*   81791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81834 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81873 */     GIR_RootConstrainSelectedInstOperands,
     /*   81874 */     // GIR_Coverage, 51735,
     /*   81874 */     GIR_EraseRootFromParent_Done,
     /*   81875 */   // Label 1335: @81875
     /*   81875 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81964), // Rule ID 51674 //
     /*   81880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81923 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81962 */     GIR_RootConstrainSelectedInstOperands,
     /*   81963 */     // GIR_Coverage, 51674,
     /*   81963 */     GIR_EraseRootFromParent_Done,
     /*   81964 */   // Label 1336: @81964
     /*   81964 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(82053), // Rule ID 51675 //
     /*   81969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82012 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82051 */     GIR_RootConstrainSelectedInstOperands,
     /*   82052 */     // GIR_Coverage, 51675,
     /*   82052 */     GIR_EraseRootFromParent_Done,
     /*   82053 */   // Label 1337: @82053
     /*   82053 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82142), // Rule ID 70232 //
     /*   82058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82101 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82140 */     GIR_RootConstrainSelectedInstOperands,
     /*   82141 */     // GIR_Coverage, 70232,
     /*   82141 */     GIR_EraseRootFromParent_Done,
     /*   82142 */   // Label 1338: @82142
     /*   82142 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82231), // Rule ID 70233 //
     /*   82147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82190 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82229 */     GIR_RootConstrainSelectedInstOperands,
     /*   82230 */     // GIR_Coverage, 70233,
     /*   82230 */     GIR_EraseRootFromParent_Done,
     /*   82231 */   // Label 1339: @82231
     /*   82231 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82320), // Rule ID 51554 //
     /*   82236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82279 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82318 */     GIR_RootConstrainSelectedInstOperands,
     /*   82319 */     // GIR_Coverage, 51554,
     /*   82319 */     GIR_EraseRootFromParent_Done,
     /*   82320 */   // Label 1340: @82320
     /*   82320 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82409), // Rule ID 51555 //
     /*   82325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82368 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82407 */     GIR_RootConstrainSelectedInstOperands,
     /*   82408 */     // GIR_Coverage, 51555,
     /*   82408 */     GIR_EraseRootFromParent_Done,
     /*   82409 */   // Label 1341: @82409
     /*   82409 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82462), // Rule ID 50860 //
     /*   82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82425 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82460 */     GIR_RootConstrainSelectedInstOperands,
     /*   82461 */     // GIR_Coverage, 50860,
     /*   82461 */     GIR_EraseRootFromParent_Done,
     /*   82462 */   // Label 1342: @82462
     /*   82462 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82515), // Rule ID 50861 //
     /*   82467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82478 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82513 */     GIR_RootConstrainSelectedInstOperands,
     /*   82514 */     // GIR_Coverage, 50861,
     /*   82514 */     GIR_EraseRootFromParent_Done,
     /*   82515 */   // Label 1343: @82515
     /*   82515 */   GIM_Reject,
     /*   82516 */ // Label 1323: @82516
     /*   82516 */ GIM_Reject,
     /*   82517 */ // Label 1294: @82517
     /*   82517 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84241),
     /*   82522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   82528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82532 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82621), // Rule ID 51638 //
     /*   82537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82580 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82619 */     GIR_RootConstrainSelectedInstOperands,
     /*   82620 */     // GIR_Coverage, 51638,
     /*   82620 */     GIR_EraseRootFromParent_Done,
     /*   82621 */   // Label 1345: @82621
     /*   82621 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82710), // Rule ID 51639 //
     /*   82626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82669 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82708 */     GIR_RootConstrainSelectedInstOperands,
     /*   82709 */     // GIR_Coverage, 51639,
     /*   82709 */     GIR_EraseRootFromParent_Done,
     /*   82710 */   // Label 1346: @82710
     /*   82710 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82799), // Rule ID 70316 //
     /*   82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82758 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82797 */     GIR_RootConstrainSelectedInstOperands,
     /*   82798 */     // GIR_Coverage, 70316,
     /*   82798 */     GIR_EraseRootFromParent_Done,
     /*   82799 */   // Label 1347: @82799
     /*   82799 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82888), // Rule ID 70317 //
     /*   82804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82847 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82886 */     GIR_RootConstrainSelectedInstOperands,
     /*   82887 */     // GIR_Coverage, 70317,
     /*   82887 */     GIR_EraseRootFromParent_Done,
     /*   82888 */   // Label 1348: @82888
     /*   82888 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82977), // Rule ID 70196 //
     /*   82893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82936 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82975 */     GIR_RootConstrainSelectedInstOperands,
     /*   82976 */     // GIR_Coverage, 70196,
     /*   82976 */     GIR_EraseRootFromParent_Done,
     /*   82977 */   // Label 1349: @82977
     /*   82977 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(83066), // Rule ID 70197 //
     /*   82982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83025 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83064 */     GIR_RootConstrainSelectedInstOperands,
     /*   83065 */     // GIR_Coverage, 70197,
     /*   83065 */     GIR_EraseRootFromParent_Done,
     /*   83066 */   // Label 1350: @83066
     /*   83066 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83155), // Rule ID 51818 //
     /*   83071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83114 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83153 */     GIR_RootConstrainSelectedInstOperands,
     /*   83154 */     // GIR_Coverage, 51818,
     /*   83154 */     GIR_EraseRootFromParent_Done,
     /*   83155 */   // Label 1351: @83155
     /*   83155 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83244), // Rule ID 51819 //
     /*   83160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83203 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83242 */     GIR_RootConstrainSelectedInstOperands,
     /*   83243 */     // GIR_Coverage, 51819,
     /*   83243 */     GIR_EraseRootFromParent_Done,
     /*   83244 */   // Label 1352: @83244
     /*   83244 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83333), // Rule ID 51518 //
     /*   83249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83292 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83331 */     GIR_RootConstrainSelectedInstOperands,
     /*   83332 */     // GIR_Coverage, 51518,
     /*   83332 */     GIR_EraseRootFromParent_Done,
     /*   83333 */   // Label 1353: @83333
     /*   83333 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83422), // Rule ID 51519 //
     /*   83338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83381 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83420 */     GIR_RootConstrainSelectedInstOperands,
     /*   83421 */     // GIR_Coverage, 51519,
     /*   83421 */     GIR_EraseRootFromParent_Done,
     /*   83422 */   // Label 1354: @83422
     /*   83422 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83511), // Rule ID 51758 //
     /*   83427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83470 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83509 */     GIR_RootConstrainSelectedInstOperands,
     /*   83510 */     // GIR_Coverage, 51758,
     /*   83510 */     GIR_EraseRootFromParent_Done,
     /*   83511 */   // Label 1355: @83511
     /*   83511 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83600), // Rule ID 51759 //
     /*   83516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83559 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83598 */     GIR_RootConstrainSelectedInstOperands,
     /*   83599 */     // GIR_Coverage, 51759,
     /*   83599 */     GIR_EraseRootFromParent_Done,
     /*   83600 */   // Label 1356: @83600
     /*   83600 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83689), // Rule ID 51698 //
     /*   83605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83648 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83687 */     GIR_RootConstrainSelectedInstOperands,
     /*   83688 */     // GIR_Coverage, 51698,
     /*   83688 */     GIR_EraseRootFromParent_Done,
     /*   83689 */   // Label 1357: @83689
     /*   83689 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83778), // Rule ID 51699 //
     /*   83694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83737 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83776 */     GIR_RootConstrainSelectedInstOperands,
     /*   83777 */     // GIR_Coverage, 51699,
     /*   83777 */     GIR_EraseRootFromParent_Done,
     /*   83778 */   // Label 1358: @83778
     /*   83778 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83867), // Rule ID 70256 //
     /*   83783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83826 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83865 */     GIR_RootConstrainSelectedInstOperands,
     /*   83866 */     // GIR_Coverage, 70256,
     /*   83866 */     GIR_EraseRootFromParent_Done,
     /*   83867 */   // Label 1359: @83867
     /*   83867 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83956), // Rule ID 70257 //
     /*   83872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83915 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83954 */     GIR_RootConstrainSelectedInstOperands,
     /*   83955 */     // GIR_Coverage, 70257,
     /*   83955 */     GIR_EraseRootFromParent_Done,
     /*   83956 */   // Label 1360: @83956
     /*   83956 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(84045), // Rule ID 51578 //
     /*   83961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84004 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84043 */     GIR_RootConstrainSelectedInstOperands,
     /*   84044 */     // GIR_Coverage, 51578,
     /*   84044 */     GIR_EraseRootFromParent_Done,
     /*   84045 */   // Label 1361: @84045
     /*   84045 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84134), // Rule ID 51579 //
     /*   84050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84093 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84132 */     GIR_RootConstrainSelectedInstOperands,
     /*   84133 */     // GIR_Coverage, 51579,
     /*   84133 */     GIR_EraseRootFromParent_Done,
     /*   84134 */   // Label 1362: @84134
     /*   84134 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84187), // Rule ID 50868 //
     /*   84139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84150 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84185 */     GIR_RootConstrainSelectedInstOperands,
     /*   84186 */     // GIR_Coverage, 50868,
     /*   84186 */     GIR_EraseRootFromParent_Done,
     /*   84187 */   // Label 1363: @84187
     /*   84187 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84240), // Rule ID 50869 //
     /*   84192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84203 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84238 */     GIR_RootConstrainSelectedInstOperands,
     /*   84239 */     // GIR_Coverage, 50869,
     /*   84239 */     GIR_EraseRootFromParent_Done,
     /*   84240 */   // Label 1364: @84240
     /*   84240 */   GIM_Reject,
     /*   84241 */ // Label 1344: @84241
     /*   84241 */ GIM_Reject,
     /*   84242 */ // Label 1295: @84242
     /*   84242 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(85966),
     /*   84247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84257 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84346), // Rule ID 51658 //
     /*   84262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84305 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84344 */     GIR_RootConstrainSelectedInstOperands,
     /*   84345 */     // GIR_Coverage, 51658,
     /*   84345 */     GIR_EraseRootFromParent_Done,
     /*   84346 */   // Label 1366: @84346
     /*   84346 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84435), // Rule ID 51659 //
     /*   84351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84394 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84433 */     GIR_RootConstrainSelectedInstOperands,
     /*   84434 */     // GIR_Coverage, 51659,
     /*   84434 */     GIR_EraseRootFromParent_Done,
     /*   84435 */   // Label 1367: @84435
     /*   84435 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84524), // Rule ID 70336 //
     /*   84440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84483 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84522 */     GIR_RootConstrainSelectedInstOperands,
     /*   84523 */     // GIR_Coverage, 70336,
     /*   84523 */     GIR_EraseRootFromParent_Done,
     /*   84524 */   // Label 1368: @84524
     /*   84524 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84613), // Rule ID 70337 //
     /*   84529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84572 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84611 */     GIR_RootConstrainSelectedInstOperands,
     /*   84612 */     // GIR_Coverage, 70337,
     /*   84612 */     GIR_EraseRootFromParent_Done,
     /*   84613 */   // Label 1369: @84613
     /*   84613 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84702), // Rule ID 70216 //
     /*   84618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84661 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84700 */     GIR_RootConstrainSelectedInstOperands,
     /*   84701 */     // GIR_Coverage, 70216,
     /*   84701 */     GIR_EraseRootFromParent_Done,
     /*   84702 */   // Label 1370: @84702
     /*   84702 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(84791), // Rule ID 70217 //
     /*   84707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84750 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84789 */     GIR_RootConstrainSelectedInstOperands,
     /*   84790 */     // GIR_Coverage, 70217,
     /*   84790 */     GIR_EraseRootFromParent_Done,
     /*   84791 */   // Label 1371: @84791
     /*   84791 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84880), // Rule ID 51838 //
     /*   84796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84839 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84878 */     GIR_RootConstrainSelectedInstOperands,
     /*   84879 */     // GIR_Coverage, 51838,
     /*   84879 */     GIR_EraseRootFromParent_Done,
     /*   84880 */   // Label 1372: @84880
     /*   84880 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84969), // Rule ID 51839 //
     /*   84885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84919 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84928 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84967 */     GIR_RootConstrainSelectedInstOperands,
     /*   84968 */     // GIR_Coverage, 51839,
     /*   84968 */     GIR_EraseRootFromParent_Done,
     /*   84969 */   // Label 1373: @84969
     /*   84969 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(85058), // Rule ID 51538 //
     /*   84974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85017 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85056 */     GIR_RootConstrainSelectedInstOperands,
     /*   85057 */     // GIR_Coverage, 51538,
     /*   85057 */     GIR_EraseRootFromParent_Done,
     /*   85058 */   // Label 1374: @85058
     /*   85058 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85147), // Rule ID 51539 //
     /*   85063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85097 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85106 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85145 */     GIR_RootConstrainSelectedInstOperands,
     /*   85146 */     // GIR_Coverage, 51539,
     /*   85146 */     GIR_EraseRootFromParent_Done,
     /*   85147 */   // Label 1375: @85147
     /*   85147 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85236), // Rule ID 51778 //
     /*   85152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85195 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85234 */     GIR_RootConstrainSelectedInstOperands,
     /*   85235 */     // GIR_Coverage, 51778,
     /*   85235 */     GIR_EraseRootFromParent_Done,
     /*   85236 */   // Label 1376: @85236
     /*   85236 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85325), // Rule ID 51779 //
     /*   85241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85284 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85323 */     GIR_RootConstrainSelectedInstOperands,
     /*   85324 */     // GIR_Coverage, 51779,
     /*   85324 */     GIR_EraseRootFromParent_Done,
     /*   85325 */   // Label 1377: @85325
     /*   85325 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85414), // Rule ID 51718 //
     /*   85330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85373 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85412 */     GIR_RootConstrainSelectedInstOperands,
     /*   85413 */     // GIR_Coverage, 51718,
     /*   85413 */     GIR_EraseRootFromParent_Done,
     /*   85414 */   // Label 1378: @85414
     /*   85414 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85503), // Rule ID 51719 //
     /*   85419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85462 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85501 */     GIR_RootConstrainSelectedInstOperands,
     /*   85502 */     // GIR_Coverage, 51719,
     /*   85502 */     GIR_EraseRootFromParent_Done,
     /*   85503 */   // Label 1379: @85503
     /*   85503 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85592), // Rule ID 70276 //
     /*   85508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85551 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85590 */     GIR_RootConstrainSelectedInstOperands,
     /*   85591 */     // GIR_Coverage, 70276,
     /*   85591 */     GIR_EraseRootFromParent_Done,
     /*   85592 */   // Label 1380: @85592
     /*   85592 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85681), // Rule ID 70277 //
     /*   85597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85640 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85679 */     GIR_RootConstrainSelectedInstOperands,
     /*   85680 */     // GIR_Coverage, 70277,
     /*   85680 */     GIR_EraseRootFromParent_Done,
     /*   85681 */   // Label 1381: @85681
     /*   85681 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85770), // Rule ID 51598 //
     /*   85686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85729 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85768 */     GIR_RootConstrainSelectedInstOperands,
     /*   85769 */     // GIR_Coverage, 51598,
     /*   85769 */     GIR_EraseRootFromParent_Done,
     /*   85770 */   // Label 1382: @85770
     /*   85770 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85859), // Rule ID 51599 //
     /*   85775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85818 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85857 */     GIR_RootConstrainSelectedInstOperands,
     /*   85858 */     // GIR_Coverage, 51599,
     /*   85858 */     GIR_EraseRootFromParent_Done,
     /*   85859 */   // Label 1383: @85859
     /*   85859 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85912), // Rule ID 50884 //
     /*   85864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   85867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85875 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   85875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85910 */     GIR_RootConstrainSelectedInstOperands,
     /*   85911 */     // GIR_Coverage, 50884,
     /*   85911 */     GIR_EraseRootFromParent_Done,
     /*   85912 */   // Label 1384: @85912
     /*   85912 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85965), // Rule ID 50885 //
     /*   85917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   85920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85928 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   85928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85963 */     GIR_RootConstrainSelectedInstOperands,
     /*   85964 */     // GIR_Coverage, 50885,
     /*   85964 */     GIR_EraseRootFromParent_Done,
     /*   85965 */   // Label 1385: @85965
     /*   85965 */   GIM_Reject,
     /*   85966 */ // Label 1365: @85966
     /*   85966 */ GIM_Reject,
     /*   85967 */ // Label 1296: @85967
     /*   85967 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86081),
     /*   85972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   85975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   85978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85990 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86035), // Rule ID 50852 //
     /*   85995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   85998 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   85998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86033 */     GIR_RootConstrainSelectedInstOperands,
     /*   86034 */     // GIR_Coverage, 50852,
     /*   86034 */     GIR_EraseRootFromParent_Done,
     /*   86035 */   // Label 1387: @86035
     /*   86035 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86080), // Rule ID 50853 //
     /*   86040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86043 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86078 */     GIR_RootConstrainSelectedInstOperands,
     /*   86079 */     // GIR_Coverage, 50853,
     /*   86079 */     GIR_EraseRootFromParent_Done,
     /*   86080 */   // Label 1388: @86080
     /*   86080 */   GIM_Reject,
     /*   86081 */ // Label 1386: @86081
     /*   86081 */ GIM_Reject,
     /*   86082 */ // Label 1297: @86082
     /*   86082 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(87806),
     /*   86087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86097 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86186), // Rule ID 51618 //
     /*   86102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86145 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86184 */     GIR_RootConstrainSelectedInstOperands,
     /*   86185 */     // GIR_Coverage, 51618,
     /*   86185 */     GIR_EraseRootFromParent_Done,
     /*   86186 */   // Label 1390: @86186
     /*   86186 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86275), // Rule ID 51619 //
     /*   86191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86234 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86273 */     GIR_RootConstrainSelectedInstOperands,
     /*   86274 */     // GIR_Coverage, 51619,
     /*   86274 */     GIR_EraseRootFromParent_Done,
     /*   86275 */   // Label 1391: @86275
     /*   86275 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86364), // Rule ID 70296 //
     /*   86280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86323 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86362 */     GIR_RootConstrainSelectedInstOperands,
     /*   86363 */     // GIR_Coverage, 70296,
     /*   86363 */     GIR_EraseRootFromParent_Done,
     /*   86364 */   // Label 1392: @86364
     /*   86364 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86453), // Rule ID 70297 //
     /*   86369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86412 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86451 */     GIR_RootConstrainSelectedInstOperands,
     /*   86452 */     // GIR_Coverage, 70297,
     /*   86452 */     GIR_EraseRootFromParent_Done,
     /*   86453 */   // Label 1393: @86453
     /*   86453 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86542), // Rule ID 70176 //
     /*   86458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86501 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86540 */     GIR_RootConstrainSelectedInstOperands,
     /*   86541 */     // GIR_Coverage, 70176,
     /*   86541 */     GIR_EraseRootFromParent_Done,
     /*   86542 */   // Label 1394: @86542
     /*   86542 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(86631), // Rule ID 70177 //
     /*   86547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86590 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86629 */     GIR_RootConstrainSelectedInstOperands,
     /*   86630 */     // GIR_Coverage, 70177,
     /*   86630 */     GIR_EraseRootFromParent_Done,
     /*   86631 */   // Label 1395: @86631
     /*   86631 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86720), // Rule ID 51798 //
     /*   86636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86679 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86718 */     GIR_RootConstrainSelectedInstOperands,
     /*   86719 */     // GIR_Coverage, 51798,
     /*   86719 */     GIR_EraseRootFromParent_Done,
     /*   86720 */   // Label 1396: @86720
     /*   86720 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86809), // Rule ID 51799 //
     /*   86725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86768 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86807 */     GIR_RootConstrainSelectedInstOperands,
     /*   86808 */     // GIR_Coverage, 51799,
     /*   86808 */     GIR_EraseRootFromParent_Done,
     /*   86809 */   // Label 1397: @86809
     /*   86809 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86898), // Rule ID 51498 //
     /*   86814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86857 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86896 */     GIR_RootConstrainSelectedInstOperands,
     /*   86897 */     // GIR_Coverage, 51498,
     /*   86897 */     GIR_EraseRootFromParent_Done,
     /*   86898 */   // Label 1398: @86898
     /*   86898 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86987), // Rule ID 51499 //
     /*   86903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86946 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86985 */     GIR_RootConstrainSelectedInstOperands,
     /*   86986 */     // GIR_Coverage, 51499,
     /*   86986 */     GIR_EraseRootFromParent_Done,
     /*   86987 */   // Label 1399: @86987
     /*   86987 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87076), // Rule ID 51738 //
     /*   86992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87035 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87074 */     GIR_RootConstrainSelectedInstOperands,
     /*   87075 */     // GIR_Coverage, 51738,
     /*   87075 */     GIR_EraseRootFromParent_Done,
     /*   87076 */   // Label 1400: @87076
     /*   87076 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87165), // Rule ID 51739 //
     /*   87081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87124 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87163 */     GIR_RootConstrainSelectedInstOperands,
     /*   87164 */     // GIR_Coverage, 51739,
     /*   87164 */     GIR_EraseRootFromParent_Done,
     /*   87165 */   // Label 1401: @87165
     /*   87165 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87254), // Rule ID 51678 //
     /*   87170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87185 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87204 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87213 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87252 */     GIR_RootConstrainSelectedInstOperands,
     /*   87253 */     // GIR_Coverage, 51678,
     /*   87253 */     GIR_EraseRootFromParent_Done,
     /*   87254 */   // Label 1402: @87254
     /*   87254 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87343), // Rule ID 51679 //
     /*   87259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87293 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87302 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87341 */     GIR_RootConstrainSelectedInstOperands,
     /*   87342 */     // GIR_Coverage, 51679,
     /*   87342 */     GIR_EraseRootFromParent_Done,
     /*   87343 */   // Label 1403: @87343
     /*   87343 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87432), // Rule ID 70236 //
     /*   87348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87391 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87430 */     GIR_RootConstrainSelectedInstOperands,
     /*   87431 */     // GIR_Coverage, 70236,
     /*   87431 */     GIR_EraseRootFromParent_Done,
     /*   87432 */   // Label 1404: @87432
     /*   87432 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87521), // Rule ID 70237 //
     /*   87437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87480 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87519 */     GIR_RootConstrainSelectedInstOperands,
     /*   87520 */     // GIR_Coverage, 70237,
     /*   87520 */     GIR_EraseRootFromParent_Done,
     /*   87521 */   // Label 1405: @87521
     /*   87521 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87610), // Rule ID 51558 //
     /*   87526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87569 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87608 */     GIR_RootConstrainSelectedInstOperands,
     /*   87609 */     // GIR_Coverage, 51558,
     /*   87609 */     GIR_EraseRootFromParent_Done,
     /*   87610 */   // Label 1406: @87610
     /*   87610 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87699), // Rule ID 51559 //
     /*   87615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87649 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87658 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87697 */     GIR_RootConstrainSelectedInstOperands,
     /*   87698 */     // GIR_Coverage, 51559,
     /*   87698 */     GIR_EraseRootFromParent_Done,
     /*   87699 */   // Label 1407: @87699
     /*   87699 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87752), // Rule ID 50864 //
     /*   87704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87715 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87750 */     GIR_RootConstrainSelectedInstOperands,
     /*   87751 */     // GIR_Coverage, 50864,
     /*   87751 */     GIR_EraseRootFromParent_Done,
     /*   87752 */   // Label 1408: @87752
     /*   87752 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87805), // Rule ID 50865 //
     /*   87757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87768 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87803 */     GIR_RootConstrainSelectedInstOperands,
     /*   87804 */     // GIR_Coverage, 50865,
     /*   87804 */     GIR_EraseRootFromParent_Done,
     /*   87805 */   // Label 1409: @87805
     /*   87805 */   GIM_Reject,
     /*   87806 */ // Label 1389: @87806
     /*   87806 */ GIM_Reject,
     /*   87807 */ // Label 1298: @87807
     /*   87807 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(89531),
     /*   87812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   87815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   87818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87822 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87911), // Rule ID 51642 //
     /*   87827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87870 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87909 */     GIR_RootConstrainSelectedInstOperands,
     /*   87910 */     // GIR_Coverage, 51642,
     /*   87910 */     GIR_EraseRootFromParent_Done,
     /*   87911 */   // Label 1411: @87911
     /*   87911 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88000), // Rule ID 51643 //
     /*   87916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87959 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87998 */     GIR_RootConstrainSelectedInstOperands,
     /*   87999 */     // GIR_Coverage, 51643,
     /*   87999 */     GIR_EraseRootFromParent_Done,
     /*   88000 */   // Label 1412: @88000
     /*   88000 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88089), // Rule ID 70320 //
     /*   88005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88048 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88087 */     GIR_RootConstrainSelectedInstOperands,
     /*   88088 */     // GIR_Coverage, 70320,
     /*   88088 */     GIR_EraseRootFromParent_Done,
     /*   88089 */   // Label 1413: @88089
     /*   88089 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88178), // Rule ID 70321 //
     /*   88094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88137 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88176 */     GIR_RootConstrainSelectedInstOperands,
     /*   88177 */     // GIR_Coverage, 70321,
     /*   88177 */     GIR_EraseRootFromParent_Done,
     /*   88178 */   // Label 1414: @88178
     /*   88178 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88267), // Rule ID 70200 //
     /*   88183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88226 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88265 */     GIR_RootConstrainSelectedInstOperands,
     /*   88266 */     // GIR_Coverage, 70200,
     /*   88266 */     GIR_EraseRootFromParent_Done,
     /*   88267 */   // Label 1415: @88267
     /*   88267 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(88356), // Rule ID 70201 //
     /*   88272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88315 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88354 */     GIR_RootConstrainSelectedInstOperands,
     /*   88355 */     // GIR_Coverage, 70201,
     /*   88355 */     GIR_EraseRootFromParent_Done,
     /*   88356 */   // Label 1416: @88356
     /*   88356 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88445), // Rule ID 51822 //
     /*   88361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88404 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88443 */     GIR_RootConstrainSelectedInstOperands,
     /*   88444 */     // GIR_Coverage, 51822,
     /*   88444 */     GIR_EraseRootFromParent_Done,
     /*   88445 */   // Label 1417: @88445
     /*   88445 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88534), // Rule ID 51823 //
     /*   88450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88493 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88532 */     GIR_RootConstrainSelectedInstOperands,
     /*   88533 */     // GIR_Coverage, 51823,
     /*   88533 */     GIR_EraseRootFromParent_Done,
     /*   88534 */   // Label 1418: @88534
     /*   88534 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88623), // Rule ID 51522 //
     /*   88539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88582 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88621 */     GIR_RootConstrainSelectedInstOperands,
     /*   88622 */     // GIR_Coverage, 51522,
     /*   88622 */     GIR_EraseRootFromParent_Done,
     /*   88623 */   // Label 1419: @88623
     /*   88623 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88712), // Rule ID 51523 //
     /*   88628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88671 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88710 */     GIR_RootConstrainSelectedInstOperands,
     /*   88711 */     // GIR_Coverage, 51523,
     /*   88711 */     GIR_EraseRootFromParent_Done,
     /*   88712 */   // Label 1420: @88712
     /*   88712 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88801), // Rule ID 51762 //
     /*   88717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88760 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88799 */     GIR_RootConstrainSelectedInstOperands,
     /*   88800 */     // GIR_Coverage, 51762,
     /*   88800 */     GIR_EraseRootFromParent_Done,
     /*   88801 */   // Label 1421: @88801
     /*   88801 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88890), // Rule ID 51763 //
     /*   88806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88849 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88888 */     GIR_RootConstrainSelectedInstOperands,
     /*   88889 */     // GIR_Coverage, 51763,
     /*   88889 */     GIR_EraseRootFromParent_Done,
     /*   88890 */   // Label 1422: @88890
     /*   88890 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88979), // Rule ID 51702 //
     /*   88895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88938 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88977 */     GIR_RootConstrainSelectedInstOperands,
     /*   88978 */     // GIR_Coverage, 51702,
     /*   88978 */     GIR_EraseRootFromParent_Done,
     /*   88979 */   // Label 1423: @88979
     /*   88979 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89068), // Rule ID 51703 //
     /*   88984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89027 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89066 */     GIR_RootConstrainSelectedInstOperands,
     /*   89067 */     // GIR_Coverage, 51703,
     /*   89067 */     GIR_EraseRootFromParent_Done,
     /*   89068 */   // Label 1424: @89068
     /*   89068 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89157), // Rule ID 70260 //
     /*   89073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89116 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89155 */     GIR_RootConstrainSelectedInstOperands,
     /*   89156 */     // GIR_Coverage, 70260,
     /*   89156 */     GIR_EraseRootFromParent_Done,
     /*   89157 */   // Label 1425: @89157
     /*   89157 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89246), // Rule ID 70261 //
     /*   89162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89205 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89244 */     GIR_RootConstrainSelectedInstOperands,
     /*   89245 */     // GIR_Coverage, 70261,
     /*   89245 */     GIR_EraseRootFromParent_Done,
     /*   89246 */   // Label 1426: @89246
     /*   89246 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89335), // Rule ID 51582 //
     /*   89251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89285 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89294 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89333 */     GIR_RootConstrainSelectedInstOperands,
     /*   89334 */     // GIR_Coverage, 51582,
     /*   89334 */     GIR_EraseRootFromParent_Done,
     /*   89335 */   // Label 1427: @89335
     /*   89335 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89424), // Rule ID 51583 //
     /*   89340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89383 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89422 */     GIR_RootConstrainSelectedInstOperands,
     /*   89423 */     // GIR_Coverage, 51583,
     /*   89423 */     GIR_EraseRootFromParent_Done,
     /*   89424 */   // Label 1428: @89424
     /*   89424 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89477), // Rule ID 50880 //
     /*   89429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89440 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89475 */     GIR_RootConstrainSelectedInstOperands,
     /*   89476 */     // GIR_Coverage, 50880,
     /*   89476 */     GIR_EraseRootFromParent_Done,
     /*   89477 */   // Label 1429: @89477
     /*   89477 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89530), // Rule ID 50881 //
     /*   89482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89493 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89528 */     GIR_RootConstrainSelectedInstOperands,
     /*   89529 */     // GIR_Coverage, 50881,
     /*   89529 */     GIR_EraseRootFromParent_Done,
     /*   89530 */   // Label 1430: @89530
     /*   89530 */   GIM_Reject,
     /*   89531 */ // Label 1410: @89531
     /*   89531 */ GIM_Reject,
     /*   89532 */ // Label 1299: @89532
     /*   89532 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91256),
     /*   89537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   89540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   89543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   89547 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89636), // Rule ID 51662 //
     /*   89552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89595 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89634 */     GIR_RootConstrainSelectedInstOperands,
     /*   89635 */     // GIR_Coverage, 51662,
     /*   89635 */     GIR_EraseRootFromParent_Done,
     /*   89636 */   // Label 1432: @89636
     /*   89636 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89725), // Rule ID 51663 //
     /*   89641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89684 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89723 */     GIR_RootConstrainSelectedInstOperands,
     /*   89724 */     // GIR_Coverage, 51663,
     /*   89724 */     GIR_EraseRootFromParent_Done,
     /*   89725 */   // Label 1433: @89725
     /*   89725 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89814), // Rule ID 70340 //
     /*   89730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89773 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89812 */     GIR_RootConstrainSelectedInstOperands,
     /*   89813 */     // GIR_Coverage, 70340,
     /*   89813 */     GIR_EraseRootFromParent_Done,
     /*   89814 */   // Label 1434: @89814
     /*   89814 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89903), // Rule ID 70341 //
     /*   89819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89853 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89862 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89901 */     GIR_RootConstrainSelectedInstOperands,
     /*   89902 */     // GIR_Coverage, 70341,
     /*   89902 */     GIR_EraseRootFromParent_Done,
     /*   89903 */   // Label 1435: @89903
     /*   89903 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(89992), // Rule ID 70220 //
     /*   89908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89951 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89990 */     GIR_RootConstrainSelectedInstOperands,
     /*   89991 */     // GIR_Coverage, 70220,
     /*   89991 */     GIR_EraseRootFromParent_Done,
     /*   89992 */   // Label 1436: @89992
     /*   89992 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90081), // Rule ID 70221 //
     /*   89997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90031 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90040 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90079 */     GIR_RootConstrainSelectedInstOperands,
     /*   90080 */     // GIR_Coverage, 70221,
     /*   90080 */     GIR_EraseRootFromParent_Done,
     /*   90081 */   // Label 1437: @90081
     /*   90081 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90170), // Rule ID 51842 //
     /*   90086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90120 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90129 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90168 */     GIR_RootConstrainSelectedInstOperands,
     /*   90169 */     // GIR_Coverage, 51842,
     /*   90169 */     GIR_EraseRootFromParent_Done,
     /*   90170 */   // Label 1438: @90170
     /*   90170 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90259), // Rule ID 51843 //
     /*   90175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90218 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90257 */     GIR_RootConstrainSelectedInstOperands,
     /*   90258 */     // GIR_Coverage, 51843,
     /*   90258 */     GIR_EraseRootFromParent_Done,
     /*   90259 */   // Label 1439: @90259
     /*   90259 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90348), // Rule ID 51542 //
     /*   90264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90279 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90307 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90346 */     GIR_RootConstrainSelectedInstOperands,
     /*   90347 */     // GIR_Coverage, 51542,
     /*   90347 */     GIR_EraseRootFromParent_Done,
     /*   90348 */   // Label 1440: @90348
     /*   90348 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90437), // Rule ID 51543 //
     /*   90353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90396 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90435 */     GIR_RootConstrainSelectedInstOperands,
     /*   90436 */     // GIR_Coverage, 51543,
     /*   90436 */     GIR_EraseRootFromParent_Done,
     /*   90437 */   // Label 1441: @90437
     /*   90437 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90526), // Rule ID 51782 //
     /*   90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90485 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90524 */     GIR_RootConstrainSelectedInstOperands,
     /*   90525 */     // GIR_Coverage, 51782,
     /*   90525 */     GIR_EraseRootFromParent_Done,
     /*   90526 */   // Label 1442: @90526
     /*   90526 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90615), // Rule ID 51783 //
     /*   90531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90574 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90613 */     GIR_RootConstrainSelectedInstOperands,
     /*   90614 */     // GIR_Coverage, 51783,
     /*   90614 */     GIR_EraseRootFromParent_Done,
     /*   90615 */   // Label 1443: @90615
     /*   90615 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90704), // Rule ID 51722 //
     /*   90620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90663 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90702 */     GIR_RootConstrainSelectedInstOperands,
     /*   90703 */     // GIR_Coverage, 51722,
     /*   90703 */     GIR_EraseRootFromParent_Done,
     /*   90704 */   // Label 1444: @90704
     /*   90704 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90793), // Rule ID 51723 //
     /*   90709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90752 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90791 */     GIR_RootConstrainSelectedInstOperands,
     /*   90792 */     // GIR_Coverage, 51723,
     /*   90792 */     GIR_EraseRootFromParent_Done,
     /*   90793 */   // Label 1445: @90793
     /*   90793 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90882), // Rule ID 70280 //
     /*   90798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90813 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90841 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90880 */     GIR_RootConstrainSelectedInstOperands,
     /*   90881 */     // GIR_Coverage, 70280,
     /*   90881 */     GIR_EraseRootFromParent_Done,
     /*   90882 */   // Label 1446: @90882
     /*   90882 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90971), // Rule ID 70281 //
     /*   90887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90930 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90969 */     GIR_RootConstrainSelectedInstOperands,
     /*   90970 */     // GIR_Coverage, 70281,
     /*   90970 */     GIR_EraseRootFromParent_Done,
     /*   90971 */   // Label 1447: @90971
     /*   90971 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91060), // Rule ID 51602 //
     /*   90976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90991 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91019 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91058 */     GIR_RootConstrainSelectedInstOperands,
     /*   91059 */     // GIR_Coverage, 51602,
     /*   91059 */     GIR_EraseRootFromParent_Done,
     /*   91060 */   // Label 1448: @91060
     /*   91060 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91149), // Rule ID 51603 //
     /*   91065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91108 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91147 */     GIR_RootConstrainSelectedInstOperands,
     /*   91148 */     // GIR_Coverage, 51603,
     /*   91148 */     GIR_EraseRootFromParent_Done,
     /*   91149 */   // Label 1449: @91149
     /*   91149 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91202), // Rule ID 50924 //
     /*   91154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91165 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91200 */     GIR_RootConstrainSelectedInstOperands,
     /*   91201 */     // GIR_Coverage, 50924,
     /*   91201 */     GIR_EraseRootFromParent_Done,
     /*   91202 */   // Label 1450: @91202
     /*   91202 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91255), // Rule ID 50925 //
     /*   91207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91218 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91253 */     GIR_RootConstrainSelectedInstOperands,
     /*   91254 */     // GIR_Coverage, 50925,
     /*   91254 */     GIR_EraseRootFromParent_Done,
     /*   91255 */   // Label 1451: @91255
     /*   91255 */   GIM_Reject,
     /*   91256 */ // Label 1431: @91256
     /*   91256 */ GIM_Reject,
     /*   91257 */ // Label 1300: @91257
     /*   91257 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91371),
     /*   91262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91280 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91325), // Rule ID 50856 //
     /*   91285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91288 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91323 */     GIR_RootConstrainSelectedInstOperands,
     /*   91324 */     // GIR_Coverage, 50856,
     /*   91324 */     GIR_EraseRootFromParent_Done,
     /*   91325 */   // Label 1453: @91325
     /*   91325 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91370), // Rule ID 50857 //
     /*   91330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91333 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91368 */     GIR_RootConstrainSelectedInstOperands,
     /*   91369 */     // GIR_Coverage, 50857,
     /*   91369 */     GIR_EraseRootFromParent_Done,
     /*   91370 */   // Label 1454: @91370
     /*   91370 */   GIM_Reject,
     /*   91371 */ // Label 1452: @91371
     /*   91371 */ GIM_Reject,
     /*   91372 */ // Label 1301: @91372
     /*   91372 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93096),
     /*   91377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91387 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91476), // Rule ID 51622 //
     /*   91392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91435 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91474 */     GIR_RootConstrainSelectedInstOperands,
     /*   91475 */     // GIR_Coverage, 51622,
     /*   91475 */     GIR_EraseRootFromParent_Done,
     /*   91476 */   // Label 1456: @91476
     /*   91476 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91565), // Rule ID 51623 //
     /*   91481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91515 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91524 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91563 */     GIR_RootConstrainSelectedInstOperands,
     /*   91564 */     // GIR_Coverage, 51623,
     /*   91564 */     GIR_EraseRootFromParent_Done,
     /*   91565 */   // Label 1457: @91565
     /*   91565 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91654), // Rule ID 70300 //
     /*   91570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91613 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91652 */     GIR_RootConstrainSelectedInstOperands,
     /*   91653 */     // GIR_Coverage, 70300,
     /*   91653 */     GIR_EraseRootFromParent_Done,
     /*   91654 */   // Label 1458: @91654
     /*   91654 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91743), // Rule ID 70301 //
     /*   91659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91693 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91702 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91741 */     GIR_RootConstrainSelectedInstOperands,
     /*   91742 */     // GIR_Coverage, 70301,
     /*   91742 */     GIR_EraseRootFromParent_Done,
     /*   91743 */   // Label 1459: @91743
     /*   91743 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91832), // Rule ID 70180 //
     /*   91748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91791 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91830 */     GIR_RootConstrainSelectedInstOperands,
     /*   91831 */     // GIR_Coverage, 70180,
     /*   91831 */     GIR_EraseRootFromParent_Done,
     /*   91832 */   // Label 1460: @91832
     /*   91832 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(91921), // Rule ID 70181 //
     /*   91837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91880 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91919 */     GIR_RootConstrainSelectedInstOperands,
     /*   91920 */     // GIR_Coverage, 70181,
     /*   91920 */     GIR_EraseRootFromParent_Done,
     /*   91921 */   // Label 1461: @91921
     /*   91921 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92010), // Rule ID 51802 //
     /*   91926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91969 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92008 */     GIR_RootConstrainSelectedInstOperands,
     /*   92009 */     // GIR_Coverage, 51802,
     /*   92009 */     GIR_EraseRootFromParent_Done,
     /*   92010 */   // Label 1462: @92010
     /*   92010 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92099), // Rule ID 51803 //
     /*   92015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92058 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92097 */     GIR_RootConstrainSelectedInstOperands,
     /*   92098 */     // GIR_Coverage, 51803,
     /*   92098 */     GIR_EraseRootFromParent_Done,
     /*   92099 */   // Label 1463: @92099
     /*   92099 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92188), // Rule ID 51502 //
     /*   92104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92147 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92186 */     GIR_RootConstrainSelectedInstOperands,
     /*   92187 */     // GIR_Coverage, 51502,
     /*   92187 */     GIR_EraseRootFromParent_Done,
     /*   92188 */   // Label 1464: @92188
     /*   92188 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92277), // Rule ID 51503 //
     /*   92193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92236 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92275 */     GIR_RootConstrainSelectedInstOperands,
     /*   92276 */     // GIR_Coverage, 51503,
     /*   92276 */     GIR_EraseRootFromParent_Done,
     /*   92277 */   // Label 1465: @92277
     /*   92277 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92366), // Rule ID 51742 //
     /*   92282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92325 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92364 */     GIR_RootConstrainSelectedInstOperands,
     /*   92365 */     // GIR_Coverage, 51742,
     /*   92365 */     GIR_EraseRootFromParent_Done,
     /*   92366 */   // Label 1466: @92366
     /*   92366 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92455), // Rule ID 51743 //
     /*   92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92414 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92453 */     GIR_RootConstrainSelectedInstOperands,
     /*   92454 */     // GIR_Coverage, 51743,
     /*   92454 */     GIR_EraseRootFromParent_Done,
     /*   92455 */   // Label 1467: @92455
     /*   92455 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92544), // Rule ID 51682 //
     /*   92460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92503 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92542 */     GIR_RootConstrainSelectedInstOperands,
     /*   92543 */     // GIR_Coverage, 51682,
     /*   92543 */     GIR_EraseRootFromParent_Done,
     /*   92544 */   // Label 1468: @92544
     /*   92544 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92633), // Rule ID 51683 //
     /*   92549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92592 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92631 */     GIR_RootConstrainSelectedInstOperands,
     /*   92632 */     // GIR_Coverage, 51683,
     /*   92632 */     GIR_EraseRootFromParent_Done,
     /*   92633 */   // Label 1469: @92633
     /*   92633 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92722), // Rule ID 70240 //
     /*   92638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92681 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92720 */     GIR_RootConstrainSelectedInstOperands,
     /*   92721 */     // GIR_Coverage, 70240,
     /*   92721 */     GIR_EraseRootFromParent_Done,
     /*   92722 */   // Label 1470: @92722
     /*   92722 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92811), // Rule ID 70241 //
     /*   92727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92770 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92809 */     GIR_RootConstrainSelectedInstOperands,
     /*   92810 */     // GIR_Coverage, 70241,
     /*   92810 */     GIR_EraseRootFromParent_Done,
     /*   92811 */   // Label 1471: @92811
     /*   92811 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92900), // Rule ID 51562 //
     /*   92816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92859 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92898 */     GIR_RootConstrainSelectedInstOperands,
     /*   92899 */     // GIR_Coverage, 51562,
     /*   92899 */     GIR_EraseRootFromParent_Done,
     /*   92900 */   // Label 1472: @92900
     /*   92900 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(92989), // Rule ID 51563 //
     /*   92905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92948 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92987 */     GIR_RootConstrainSelectedInstOperands,
     /*   92988 */     // GIR_Coverage, 51563,
     /*   92988 */     GIR_EraseRootFromParent_Done,
     /*   92989 */   // Label 1473: @92989
     /*   92989 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93042), // Rule ID 50876 //
     /*   92994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93005 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93040 */     GIR_RootConstrainSelectedInstOperands,
     /*   93041 */     // GIR_Coverage, 50876,
     /*   93041 */     GIR_EraseRootFromParent_Done,
     /*   93042 */   // Label 1474: @93042
     /*   93042 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93095), // Rule ID 50877 //
     /*   93047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93058 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93093 */     GIR_RootConstrainSelectedInstOperands,
     /*   93094 */     // GIR_Coverage, 50877,
     /*   93094 */     GIR_EraseRootFromParent_Done,
     /*   93095 */   // Label 1475: @93095
     /*   93095 */   GIM_Reject,
     /*   93096 */ // Label 1455: @93096
     /*   93096 */ GIM_Reject,
     /*   93097 */ // Label 1302: @93097
     /*   93097 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(94821),
     /*   93102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93112 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93201), // Rule ID 51646 //
     /*   93117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93151 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93160 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93199 */     GIR_RootConstrainSelectedInstOperands,
     /*   93200 */     // GIR_Coverage, 51646,
     /*   93200 */     GIR_EraseRootFromParent_Done,
     /*   93201 */   // Label 1477: @93201
     /*   93201 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93290), // Rule ID 51647 //
     /*   93206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93221 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93249 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93288 */     GIR_RootConstrainSelectedInstOperands,
     /*   93289 */     // GIR_Coverage, 51647,
     /*   93289 */     GIR_EraseRootFromParent_Done,
     /*   93290 */   // Label 1478: @93290
     /*   93290 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93379), // Rule ID 70324 //
     /*   93295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93338 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93377 */     GIR_RootConstrainSelectedInstOperands,
     /*   93378 */     // GIR_Coverage, 70324,
     /*   93378 */     GIR_EraseRootFromParent_Done,
     /*   93379 */   // Label 1479: @93379
     /*   93379 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93468), // Rule ID 70325 //
     /*   93384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93399 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93427 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93466 */     GIR_RootConstrainSelectedInstOperands,
     /*   93467 */     // GIR_Coverage, 70325,
     /*   93467 */     GIR_EraseRootFromParent_Done,
     /*   93468 */   // Label 1480: @93468
     /*   93468 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93557), // Rule ID 70204 //
     /*   93473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93516 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93555 */     GIR_RootConstrainSelectedInstOperands,
     /*   93556 */     // GIR_Coverage, 70204,
     /*   93556 */     GIR_EraseRootFromParent_Done,
     /*   93557 */   // Label 1481: @93557
     /*   93557 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(93646), // Rule ID 70205 //
     /*   93562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93605 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93644 */     GIR_RootConstrainSelectedInstOperands,
     /*   93645 */     // GIR_Coverage, 70205,
     /*   93645 */     GIR_EraseRootFromParent_Done,
     /*   93646 */   // Label 1482: @93646
     /*   93646 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93735), // Rule ID 51826 //
     /*   93651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93694 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93733 */     GIR_RootConstrainSelectedInstOperands,
     /*   93734 */     // GIR_Coverage, 51826,
     /*   93734 */     GIR_EraseRootFromParent_Done,
     /*   93735 */   // Label 1483: @93735
     /*   93735 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93824), // Rule ID 51827 //
     /*   93740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93783 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93822 */     GIR_RootConstrainSelectedInstOperands,
     /*   93823 */     // GIR_Coverage, 51827,
     /*   93823 */     GIR_EraseRootFromParent_Done,
     /*   93824 */   // Label 1484: @93824
     /*   93824 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93913), // Rule ID 51526 //
     /*   93829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93872 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93911 */     GIR_RootConstrainSelectedInstOperands,
     /*   93912 */     // GIR_Coverage, 51526,
     /*   93912 */     GIR_EraseRootFromParent_Done,
     /*   93913 */   // Label 1485: @93913
     /*   93913 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94002), // Rule ID 51527 //
     /*   93918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93961 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94000 */     GIR_RootConstrainSelectedInstOperands,
     /*   94001 */     // GIR_Coverage, 51527,
     /*   94001 */     GIR_EraseRootFromParent_Done,
     /*   94002 */   // Label 1486: @94002
     /*   94002 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94091), // Rule ID 51766 //
     /*   94007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94050 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94089 */     GIR_RootConstrainSelectedInstOperands,
     /*   94090 */     // GIR_Coverage, 51766,
     /*   94090 */     GIR_EraseRootFromParent_Done,
     /*   94091 */   // Label 1487: @94091
     /*   94091 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94180), // Rule ID 51767 //
     /*   94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94139 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94178 */     GIR_RootConstrainSelectedInstOperands,
     /*   94179 */     // GIR_Coverage, 51767,
     /*   94179 */     GIR_EraseRootFromParent_Done,
     /*   94180 */   // Label 1488: @94180
     /*   94180 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94269), // Rule ID 51706 //
     /*   94185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94200 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94219 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94228 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94267 */     GIR_RootConstrainSelectedInstOperands,
     /*   94268 */     // GIR_Coverage, 51706,
     /*   94268 */     GIR_EraseRootFromParent_Done,
     /*   94269 */   // Label 1489: @94269
     /*   94269 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94358), // Rule ID 51707 //
     /*   94274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94317 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94356 */     GIR_RootConstrainSelectedInstOperands,
     /*   94357 */     // GIR_Coverage, 51707,
     /*   94357 */     GIR_EraseRootFromParent_Done,
     /*   94358 */   // Label 1490: @94358
     /*   94358 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94447), // Rule ID 70264 //
     /*   94363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94406 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94445 */     GIR_RootConstrainSelectedInstOperands,
     /*   94446 */     // GIR_Coverage, 70264,
     /*   94446 */     GIR_EraseRootFromParent_Done,
     /*   94447 */   // Label 1491: @94447
     /*   94447 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94536), // Rule ID 70265 //
     /*   94452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94495 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94534 */     GIR_RootConstrainSelectedInstOperands,
     /*   94535 */     // GIR_Coverage, 70265,
     /*   94535 */     GIR_EraseRootFromParent_Done,
     /*   94536 */   // Label 1492: @94536
     /*   94536 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94625), // Rule ID 51586 //
     /*   94541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94584 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94623 */     GIR_RootConstrainSelectedInstOperands,
     /*   94624 */     // GIR_Coverage, 51586,
     /*   94624 */     GIR_EraseRootFromParent_Done,
     /*   94625 */   // Label 1493: @94625
     /*   94625 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94714), // Rule ID 51587 //
     /*   94630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94673 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94712 */     GIR_RootConstrainSelectedInstOperands,
     /*   94713 */     // GIR_Coverage, 51587,
     /*   94713 */     GIR_EraseRootFromParent_Done,
     /*   94714 */   // Label 1494: @94714
     /*   94714 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94767), // Rule ID 50912 //
     /*   94719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94730 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94765 */     GIR_RootConstrainSelectedInstOperands,
     /*   94766 */     // GIR_Coverage, 50912,
     /*   94766 */     GIR_EraseRootFromParent_Done,
     /*   94767 */   // Label 1495: @94767
     /*   94767 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94820), // Rule ID 50913 //
     /*   94772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94783 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94818 */     GIR_RootConstrainSelectedInstOperands,
     /*   94819 */     // GIR_Coverage, 50913,
     /*   94819 */     GIR_EraseRootFromParent_Done,
     /*   94820 */   // Label 1496: @94820
     /*   94820 */   GIM_Reject,
     /*   94821 */ // Label 1476: @94821
     /*   94821 */ GIM_Reject,
     /*   94822 */ // Label 1303: @94822
     /*   94822 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96546),
     /*   94827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   94830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   94833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   94837 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(94926), // Rule ID 51666 //
     /*   94842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   94845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94885 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94924 */     GIR_RootConstrainSelectedInstOperands,
     /*   94925 */     // GIR_Coverage, 51666,
     /*   94925 */     GIR_EraseRootFromParent_Done,
     /*   94926 */   // Label 1498: @94926
     /*   94926 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95015), // Rule ID 51667 //
     /*   94931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   94934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94974 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95013 */     GIR_RootConstrainSelectedInstOperands,
     /*   95014 */     // GIR_Coverage, 51667,
     /*   95014 */     GIR_EraseRootFromParent_Done,
     /*   95015 */   // Label 1499: @95015
     /*   95015 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95104), // Rule ID 70344 //
     /*   95020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95035 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95063 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95102 */     GIR_RootConstrainSelectedInstOperands,
     /*   95103 */     // GIR_Coverage, 70344,
     /*   95103 */     GIR_EraseRootFromParent_Done,
     /*   95104 */   // Label 1500: @95104
     /*   95104 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95193), // Rule ID 70345 //
     /*   95109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95124 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95152 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95191 */     GIR_RootConstrainSelectedInstOperands,
     /*   95192 */     // GIR_Coverage, 70345,
     /*   95192 */     GIR_EraseRootFromParent_Done,
     /*   95193 */   // Label 1501: @95193
     /*   95193 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95282), // Rule ID 70224 //
     /*   95198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95241 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95280 */     GIR_RootConstrainSelectedInstOperands,
     /*   95281 */     // GIR_Coverage, 70224,
     /*   95281 */     GIR_EraseRootFromParent_Done,
     /*   95282 */   // Label 1502: @95282
     /*   95282 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95371), // Rule ID 70225 //
     /*   95287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95330 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95369 */     GIR_RootConstrainSelectedInstOperands,
     /*   95370 */     // GIR_Coverage, 70225,
     /*   95370 */     GIR_EraseRootFromParent_Done,
     /*   95371 */   // Label 1503: @95371
     /*   95371 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95460), // Rule ID 51846 //
     /*   95376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95410 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95419 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95458 */     GIR_RootConstrainSelectedInstOperands,
     /*   95459 */     // GIR_Coverage, 51846,
     /*   95459 */     GIR_EraseRootFromParent_Done,
     /*   95460 */   // Label 1504: @95460
     /*   95460 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95549), // Rule ID 51847 //
     /*   95465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95499 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95508 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95547 */     GIR_RootConstrainSelectedInstOperands,
     /*   95548 */     // GIR_Coverage, 51847,
     /*   95548 */     GIR_EraseRootFromParent_Done,
     /*   95549 */   // Label 1505: @95549
     /*   95549 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95638), // Rule ID 51546 //
     /*   95554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95569 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95588 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95597 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95636 */     GIR_RootConstrainSelectedInstOperands,
     /*   95637 */     // GIR_Coverage, 51546,
     /*   95637 */     GIR_EraseRootFromParent_Done,
     /*   95638 */   // Label 1506: @95638
     /*   95638 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95727), // Rule ID 51547 //
     /*   95643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95677 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95686 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95725 */     GIR_RootConstrainSelectedInstOperands,
     /*   95726 */     // GIR_Coverage, 51547,
     /*   95726 */     GIR_EraseRootFromParent_Done,
     /*   95727 */   // Label 1507: @95727
     /*   95727 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95816), // Rule ID 51786 //
     /*   95732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95775 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95814 */     GIR_RootConstrainSelectedInstOperands,
     /*   95815 */     // GIR_Coverage, 51786,
     /*   95815 */     GIR_EraseRootFromParent_Done,
     /*   95816 */   // Label 1508: @95816
     /*   95816 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95905), // Rule ID 51787 //
     /*   95821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95864 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95903 */     GIR_RootConstrainSelectedInstOperands,
     /*   95904 */     // GIR_Coverage, 51787,
     /*   95904 */     GIR_EraseRootFromParent_Done,
     /*   95905 */   // Label 1509: @95905
     /*   95905 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(95994), // Rule ID 51726 //
     /*   95910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95953 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95992 */     GIR_RootConstrainSelectedInstOperands,
     /*   95993 */     // GIR_Coverage, 51726,
     /*   95993 */     GIR_EraseRootFromParent_Done,
     /*   95994 */   // Label 1510: @95994
     /*   95994 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96083), // Rule ID 51727 //
     /*   95999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96042 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96081 */     GIR_RootConstrainSelectedInstOperands,
     /*   96082 */     // GIR_Coverage, 51727,
     /*   96082 */     GIR_EraseRootFromParent_Done,
     /*   96083 */   // Label 1511: @96083
     /*   96083 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96172), // Rule ID 70284 //
     /*   96088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96103 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96131 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96170 */     GIR_RootConstrainSelectedInstOperands,
     /*   96171 */     // GIR_Coverage, 70284,
     /*   96171 */     GIR_EraseRootFromParent_Done,
     /*   96172 */   // Label 1512: @96172
     /*   96172 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96261), // Rule ID 70285 //
     /*   96177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96211 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96220 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96259 */     GIR_RootConstrainSelectedInstOperands,
     /*   96260 */     // GIR_Coverage, 70285,
     /*   96260 */     GIR_EraseRootFromParent_Done,
     /*   96261 */   // Label 1513: @96261
     /*   96261 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96350), // Rule ID 51606 //
     /*   96266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96281 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96300 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96309 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96348 */     GIR_RootConstrainSelectedInstOperands,
     /*   96349 */     // GIR_Coverage, 51606,
     /*   96349 */     GIR_EraseRootFromParent_Done,
     /*   96350 */   // Label 1514: @96350
     /*   96350 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96439), // Rule ID 51607 //
     /*   96355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96389 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96398 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96437 */     GIR_RootConstrainSelectedInstOperands,
     /*   96438 */     // GIR_Coverage, 51607,
     /*   96438 */     GIR_EraseRootFromParent_Done,
     /*   96439 */   // Label 1515: @96439
     /*   96439 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96492), // Rule ID 50928 //
     /*   96444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96455 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96490 */     GIR_RootConstrainSelectedInstOperands,
     /*   96491 */     // GIR_Coverage, 50928,
     /*   96491 */     GIR_EraseRootFromParent_Done,
     /*   96492 */   // Label 1516: @96492
     /*   96492 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96545), // Rule ID 50929 //
     /*   96497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96508 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96543 */     GIR_RootConstrainSelectedInstOperands,
     /*   96544 */     // GIR_Coverage, 50929,
     /*   96544 */     GIR_EraseRootFromParent_Done,
     /*   96545 */   // Label 1517: @96545
     /*   96545 */   GIM_Reject,
     /*   96546 */ // Label 1497: @96546
     /*   96546 */ GIM_Reject,
     /*   96547 */ // Label 1304: @96547
     /*   96547 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96661),
     /*   96552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   96558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96570 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96615), // Rule ID 50872 //
     /*   96575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96578 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96613 */     GIR_RootConstrainSelectedInstOperands,
     /*   96614 */     // GIR_Coverage, 50872,
     /*   96614 */     GIR_EraseRootFromParent_Done,
     /*   96615 */   // Label 1519: @96615
     /*   96615 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96660), // Rule ID 50873 //
     /*   96620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96623 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96658 */     GIR_RootConstrainSelectedInstOperands,
     /*   96659 */     // GIR_Coverage, 50873,
     /*   96659 */     GIR_EraseRootFromParent_Done,
     /*   96660 */   // Label 1520: @96660
     /*   96660 */   GIM_Reject,
     /*   96661 */ // Label 1518: @96661
     /*   96661 */ GIM_Reject,
     /*   96662 */ // Label 1305: @96662
     /*   96662 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98386),
     /*   96667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   96670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   96673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96677 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96766), // Rule ID 51626 //
     /*   96682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96725 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96764 */     GIR_RootConstrainSelectedInstOperands,
     /*   96765 */     // GIR_Coverage, 51626,
     /*   96765 */     GIR_EraseRootFromParent_Done,
     /*   96766 */   // Label 1522: @96766
     /*   96766 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(96855), // Rule ID 51627 //
     /*   96771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96814 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96853 */     GIR_RootConstrainSelectedInstOperands,
     /*   96854 */     // GIR_Coverage, 51627,
     /*   96854 */     GIR_EraseRootFromParent_Done,
     /*   96855 */   // Label 1523: @96855
     /*   96855 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(96944), // Rule ID 70304 //
     /*   96860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96903 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96942 */     GIR_RootConstrainSelectedInstOperands,
     /*   96943 */     // GIR_Coverage, 70304,
     /*   96943 */     GIR_EraseRootFromParent_Done,
     /*   96944 */   // Label 1524: @96944
     /*   96944 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97033), // Rule ID 70305 //
     /*   96949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96992 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97031 */     GIR_RootConstrainSelectedInstOperands,
     /*   97032 */     // GIR_Coverage, 70305,
     /*   97032 */     GIR_EraseRootFromParent_Done,
     /*   97033 */   // Label 1525: @97033
     /*   97033 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97122), // Rule ID 70184 //
     /*   97038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97081 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97120 */     GIR_RootConstrainSelectedInstOperands,
     /*   97121 */     // GIR_Coverage, 70184,
     /*   97121 */     GIR_EraseRootFromParent_Done,
     /*   97122 */   // Label 1526: @97122
     /*   97122 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97211), // Rule ID 70185 //
     /*   97127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97161 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97170 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97209 */     GIR_RootConstrainSelectedInstOperands,
     /*   97210 */     // GIR_Coverage, 70185,
     /*   97210 */     GIR_EraseRootFromParent_Done,
     /*   97211 */   // Label 1527: @97211
     /*   97211 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97300), // Rule ID 51806 //
     /*   97216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97250 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97259 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97298 */     GIR_RootConstrainSelectedInstOperands,
     /*   97299 */     // GIR_Coverage, 51806,
     /*   97299 */     GIR_EraseRootFromParent_Done,
     /*   97300 */   // Label 1528: @97300
     /*   97300 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97389), // Rule ID 51807 //
     /*   97305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97339 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97348 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97387 */     GIR_RootConstrainSelectedInstOperands,
     /*   97388 */     // GIR_Coverage, 51807,
     /*   97388 */     GIR_EraseRootFromParent_Done,
     /*   97389 */   // Label 1529: @97389
     /*   97389 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97478), // Rule ID 51506 //
     /*   97394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97437 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97476 */     GIR_RootConstrainSelectedInstOperands,
     /*   97477 */     // GIR_Coverage, 51506,
     /*   97477 */     GIR_EraseRootFromParent_Done,
     /*   97478 */   // Label 1530: @97478
     /*   97478 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97567), // Rule ID 51507 //
     /*   97483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97517 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97526 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97565 */     GIR_RootConstrainSelectedInstOperands,
     /*   97566 */     // GIR_Coverage, 51507,
     /*   97566 */     GIR_EraseRootFromParent_Done,
     /*   97567 */   // Label 1531: @97567
     /*   97567 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97656), // Rule ID 51746 //
     /*   97572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97615 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97654 */     GIR_RootConstrainSelectedInstOperands,
     /*   97655 */     // GIR_Coverage, 51746,
     /*   97655 */     GIR_EraseRootFromParent_Done,
     /*   97656 */   // Label 1532: @97656
     /*   97656 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97745), // Rule ID 51747 //
     /*   97661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97704 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97743 */     GIR_RootConstrainSelectedInstOperands,
     /*   97744 */     // GIR_Coverage, 51747,
     /*   97744 */     GIR_EraseRootFromParent_Done,
     /*   97745 */   // Label 1533: @97745
     /*   97745 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97834), // Rule ID 51686 //
     /*   97750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97793 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97832 */     GIR_RootConstrainSelectedInstOperands,
     /*   97833 */     // GIR_Coverage, 51686,
     /*   97833 */     GIR_EraseRootFromParent_Done,
     /*   97834 */   // Label 1534: @97834
     /*   97834 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97923), // Rule ID 51687 //
     /*   97839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97882 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97921 */     GIR_RootConstrainSelectedInstOperands,
     /*   97922 */     // GIR_Coverage, 51687,
     /*   97922 */     GIR_EraseRootFromParent_Done,
     /*   97923 */   // Label 1535: @97923
     /*   97923 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98012), // Rule ID 70244 //
     /*   97928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97971 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98010 */     GIR_RootConstrainSelectedInstOperands,
     /*   98011 */     // GIR_Coverage, 70244,
     /*   98011 */     GIR_EraseRootFromParent_Done,
     /*   98012 */   // Label 1536: @98012
     /*   98012 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98101), // Rule ID 70245 //
     /*   98017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98060 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98099 */     GIR_RootConstrainSelectedInstOperands,
     /*   98100 */     // GIR_Coverage, 70245,
     /*   98100 */     GIR_EraseRootFromParent_Done,
     /*   98101 */   // Label 1537: @98101
     /*   98101 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98190), // Rule ID 51566 //
     /*   98106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98149 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98188 */     GIR_RootConstrainSelectedInstOperands,
     /*   98189 */     // GIR_Coverage, 51566,
     /*   98189 */     GIR_EraseRootFromParent_Done,
     /*   98190 */   // Label 1538: @98190
     /*   98190 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98279), // Rule ID 51567 //
     /*   98195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98238 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98277 */     GIR_RootConstrainSelectedInstOperands,
     /*   98278 */     // GIR_Coverage, 51567,
     /*   98278 */     GIR_EraseRootFromParent_Done,
     /*   98279 */   // Label 1539: @98279
     /*   98279 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98332), // Rule ID 50900 //
     /*   98284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98295 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98330 */     GIR_RootConstrainSelectedInstOperands,
     /*   98331 */     // GIR_Coverage, 50900,
     /*   98331 */     GIR_EraseRootFromParent_Done,
     /*   98332 */   // Label 1540: @98332
     /*   98332 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98385), // Rule ID 50901 //
     /*   98337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98348 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98383 */     GIR_RootConstrainSelectedInstOperands,
     /*   98384 */     // GIR_Coverage, 50901,
     /*   98384 */     GIR_EraseRootFromParent_Done,
     /*   98385 */   // Label 1541: @98385
     /*   98385 */   GIM_Reject,
     /*   98386 */ // Label 1521: @98386
     /*   98386 */ GIM_Reject,
     /*   98387 */ // Label 1306: @98387
     /*   98387 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100111),
     /*   98392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98402 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98491), // Rule ID 51650 //
     /*   98407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98450 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98489 */     GIR_RootConstrainSelectedInstOperands,
     /*   98490 */     // GIR_Coverage, 51650,
     /*   98490 */     GIR_EraseRootFromParent_Done,
     /*   98491 */   // Label 1543: @98491
     /*   98491 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98580), // Rule ID 51651 //
     /*   98496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98539 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98578 */     GIR_RootConstrainSelectedInstOperands,
     /*   98579 */     // GIR_Coverage, 51651,
     /*   98579 */     GIR_EraseRootFromParent_Done,
     /*   98580 */   // Label 1544: @98580
     /*   98580 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98669), // Rule ID 70328 //
     /*   98585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98628 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98667 */     GIR_RootConstrainSelectedInstOperands,
     /*   98668 */     // GIR_Coverage, 70328,
     /*   98668 */     GIR_EraseRootFromParent_Done,
     /*   98669 */   // Label 1545: @98669
     /*   98669 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98758), // Rule ID 70329 //
     /*   98674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98717 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98756 */     GIR_RootConstrainSelectedInstOperands,
     /*   98757 */     // GIR_Coverage, 70329,
     /*   98757 */     GIR_EraseRootFromParent_Done,
     /*   98758 */   // Label 1546: @98758
     /*   98758 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98847), // Rule ID 70208 //
     /*   98763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98806 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98845 */     GIR_RootConstrainSelectedInstOperands,
     /*   98846 */     // GIR_Coverage, 70208,
     /*   98846 */     GIR_EraseRootFromParent_Done,
     /*   98847 */   // Label 1547: @98847
     /*   98847 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(98936), // Rule ID 70209 //
     /*   98852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98895 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98934 */     GIR_RootConstrainSelectedInstOperands,
     /*   98935 */     // GIR_Coverage, 70209,
     /*   98935 */     GIR_EraseRootFromParent_Done,
     /*   98936 */   // Label 1548: @98936
     /*   98936 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99025), // Rule ID 51830 //
     /*   98941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98984 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99023 */     GIR_RootConstrainSelectedInstOperands,
     /*   99024 */     // GIR_Coverage, 51830,
     /*   99024 */     GIR_EraseRootFromParent_Done,
     /*   99025 */   // Label 1549: @99025
     /*   99025 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99114), // Rule ID 51831 //
     /*   99030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99073 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99112 */     GIR_RootConstrainSelectedInstOperands,
     /*   99113 */     // GIR_Coverage, 51831,
     /*   99113 */     GIR_EraseRootFromParent_Done,
     /*   99114 */   // Label 1550: @99114
     /*   99114 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99203), // Rule ID 51530 //
     /*   99119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99162 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99201 */     GIR_RootConstrainSelectedInstOperands,
     /*   99202 */     // GIR_Coverage, 51530,
     /*   99202 */     GIR_EraseRootFromParent_Done,
     /*   99203 */   // Label 1551: @99203
     /*   99203 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99292), // Rule ID 51531 //
     /*   99208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99251 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99290 */     GIR_RootConstrainSelectedInstOperands,
     /*   99291 */     // GIR_Coverage, 51531,
     /*   99291 */     GIR_EraseRootFromParent_Done,
     /*   99292 */   // Label 1552: @99292
     /*   99292 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99381), // Rule ID 51770 //
     /*   99297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99340 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99379 */     GIR_RootConstrainSelectedInstOperands,
     /*   99380 */     // GIR_Coverage, 51770,
     /*   99380 */     GIR_EraseRootFromParent_Done,
     /*   99381 */   // Label 1553: @99381
     /*   99381 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99470), // Rule ID 51771 //
     /*   99386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99429 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99468 */     GIR_RootConstrainSelectedInstOperands,
     /*   99469 */     // GIR_Coverage, 51771,
     /*   99469 */     GIR_EraseRootFromParent_Done,
     /*   99470 */   // Label 1554: @99470
     /*   99470 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99559), // Rule ID 51710 //
     /*   99475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99518 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99557 */     GIR_RootConstrainSelectedInstOperands,
     /*   99558 */     // GIR_Coverage, 51710,
     /*   99558 */     GIR_EraseRootFromParent_Done,
     /*   99559 */   // Label 1555: @99559
     /*   99559 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99648), // Rule ID 51711 //
     /*   99564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99607 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99646 */     GIR_RootConstrainSelectedInstOperands,
     /*   99647 */     // GIR_Coverage, 51711,
     /*   99647 */     GIR_EraseRootFromParent_Done,
     /*   99648 */   // Label 1556: @99648
     /*   99648 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99737), // Rule ID 70268 //
     /*   99653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99696 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99735 */     GIR_RootConstrainSelectedInstOperands,
     /*   99736 */     // GIR_Coverage, 70268,
     /*   99736 */     GIR_EraseRootFromParent_Done,
     /*   99737 */   // Label 1557: @99737
     /*   99737 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99826), // Rule ID 70269 //
     /*   99742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99785 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99824 */     GIR_RootConstrainSelectedInstOperands,
     /*   99825 */     // GIR_Coverage, 70269,
     /*   99825 */     GIR_EraseRootFromParent_Done,
     /*   99826 */   // Label 1558: @99826
     /*   99826 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99915), // Rule ID 51590 //
     /*   99831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99874 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99913 */     GIR_RootConstrainSelectedInstOperands,
     /*   99914 */     // GIR_Coverage, 51590,
     /*   99914 */     GIR_EraseRootFromParent_Done,
     /*   99915 */   // Label 1559: @99915
     /*   99915 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(100004), // Rule ID 51591 //
     /*   99920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99963 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100002 */     GIR_RootConstrainSelectedInstOperands,
     /*  100003 */     // GIR_Coverage, 51591,
     /*  100003 */     GIR_EraseRootFromParent_Done,
     /*  100004 */   // Label 1560: @100004
     /*  100004 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100057), // Rule ID 50916 //
     /*  100009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100020 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100055 */     GIR_RootConstrainSelectedInstOperands,
     /*  100056 */     // GIR_Coverage, 50916,
     /*  100056 */     GIR_EraseRootFromParent_Done,
     /*  100057 */   // Label 1561: @100057
     /*  100057 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100110), // Rule ID 50917 //
     /*  100062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100073 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100108 */     GIR_RootConstrainSelectedInstOperands,
     /*  100109 */     // GIR_Coverage, 50917,
     /*  100109 */     GIR_EraseRootFromParent_Done,
     /*  100110 */   // Label 1562: @100110
     /*  100110 */   GIM_Reject,
     /*  100111 */ // Label 1542: @100111
     /*  100111 */ GIM_Reject,
     /*  100112 */ // Label 1307: @100112
     /*  100112 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101836),
     /*  100117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100127 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100216), // Rule ID 51670 //
     /*  100132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100175 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100214 */     GIR_RootConstrainSelectedInstOperands,
     /*  100215 */     // GIR_Coverage, 51670,
     /*  100215 */     GIR_EraseRootFromParent_Done,
     /*  100216 */   // Label 1564: @100216
     /*  100216 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100305), // Rule ID 51671 //
     /*  100221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100264 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100303 */     GIR_RootConstrainSelectedInstOperands,
     /*  100304 */     // GIR_Coverage, 51671,
     /*  100304 */     GIR_EraseRootFromParent_Done,
     /*  100305 */   // Label 1565: @100305
     /*  100305 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100394), // Rule ID 70348 //
     /*  100310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100353 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100392 */     GIR_RootConstrainSelectedInstOperands,
     /*  100393 */     // GIR_Coverage, 70348,
     /*  100393 */     GIR_EraseRootFromParent_Done,
     /*  100394 */   // Label 1566: @100394
     /*  100394 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100483), // Rule ID 70349 //
     /*  100399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100442 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100481 */     GIR_RootConstrainSelectedInstOperands,
     /*  100482 */     // GIR_Coverage, 70349,
     /*  100482 */     GIR_EraseRootFromParent_Done,
     /*  100483 */   // Label 1567: @100483
     /*  100483 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100572), // Rule ID 70228 //
     /*  100488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100531 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100570 */     GIR_RootConstrainSelectedInstOperands,
     /*  100571 */     // GIR_Coverage, 70228,
     /*  100571 */     GIR_EraseRootFromParent_Done,
     /*  100572 */   // Label 1568: @100572
     /*  100572 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(100661), // Rule ID 70229 //
     /*  100577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100620 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100659 */     GIR_RootConstrainSelectedInstOperands,
     /*  100660 */     // GIR_Coverage, 70229,
     /*  100660 */     GIR_EraseRootFromParent_Done,
     /*  100661 */   // Label 1569: @100661
     /*  100661 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100750), // Rule ID 51850 //
     /*  100666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100709 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100748 */     GIR_RootConstrainSelectedInstOperands,
     /*  100749 */     // GIR_Coverage, 51850,
     /*  100749 */     GIR_EraseRootFromParent_Done,
     /*  100750 */   // Label 1570: @100750
     /*  100750 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100839), // Rule ID 51851 //
     /*  100755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100798 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100837 */     GIR_RootConstrainSelectedInstOperands,
     /*  100838 */     // GIR_Coverage, 51851,
     /*  100838 */     GIR_EraseRootFromParent_Done,
     /*  100839 */   // Label 1571: @100839
     /*  100839 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100928), // Rule ID 51550 //
     /*  100844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100887 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100926 */     GIR_RootConstrainSelectedInstOperands,
     /*  100927 */     // GIR_Coverage, 51550,
     /*  100927 */     GIR_EraseRootFromParent_Done,
     /*  100928 */   // Label 1572: @100928
     /*  100928 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(101017), // Rule ID 51551 //
     /*  100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100976 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101015 */     GIR_RootConstrainSelectedInstOperands,
     /*  101016 */     // GIR_Coverage, 51551,
     /*  101016 */     GIR_EraseRootFromParent_Done,
     /*  101017 */   // Label 1573: @101017
     /*  101017 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101106), // Rule ID 51790 //
     /*  101022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101065 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101104 */     GIR_RootConstrainSelectedInstOperands,
     /*  101105 */     // GIR_Coverage, 51790,
     /*  101105 */     GIR_EraseRootFromParent_Done,
     /*  101106 */   // Label 1574: @101106
     /*  101106 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101195), // Rule ID 51791 //
     /*  101111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101154 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101193 */     GIR_RootConstrainSelectedInstOperands,
     /*  101194 */     // GIR_Coverage, 51791,
     /*  101194 */     GIR_EraseRootFromParent_Done,
     /*  101195 */   // Label 1575: @101195
     /*  101195 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101284), // Rule ID 51730 //
     /*  101200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101243 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101282 */     GIR_RootConstrainSelectedInstOperands,
     /*  101283 */     // GIR_Coverage, 51730,
     /*  101283 */     GIR_EraseRootFromParent_Done,
     /*  101284 */   // Label 1576: @101284
     /*  101284 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101373), // Rule ID 51731 //
     /*  101289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101332 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101371 */     GIR_RootConstrainSelectedInstOperands,
     /*  101372 */     // GIR_Coverage, 51731,
     /*  101372 */     GIR_EraseRootFromParent_Done,
     /*  101373 */   // Label 1577: @101373
     /*  101373 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101462), // Rule ID 70288 //
     /*  101378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101421 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101460 */     GIR_RootConstrainSelectedInstOperands,
     /*  101461 */     // GIR_Coverage, 70288,
     /*  101461 */     GIR_EraseRootFromParent_Done,
     /*  101462 */   // Label 1578: @101462
     /*  101462 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101551), // Rule ID 70289 //
     /*  101467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101501 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101510 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101549 */     GIR_RootConstrainSelectedInstOperands,
     /*  101550 */     // GIR_Coverage, 70289,
     /*  101550 */     GIR_EraseRootFromParent_Done,
     /*  101551 */   // Label 1579: @101551
     /*  101551 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101640), // Rule ID 51610 //
     /*  101556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101590 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101599 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101638 */     GIR_RootConstrainSelectedInstOperands,
     /*  101639 */     // GIR_Coverage, 51610,
     /*  101639 */     GIR_EraseRootFromParent_Done,
     /*  101640 */   // Label 1580: @101640
     /*  101640 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101729), // Rule ID 51611 //
     /*  101645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101688 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101727 */     GIR_RootConstrainSelectedInstOperands,
     /*  101728 */     // GIR_Coverage, 51611,
     /*  101728 */     GIR_EraseRootFromParent_Done,
     /*  101729 */   // Label 1581: @101729
     /*  101729 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101782), // Rule ID 50932 //
     /*  101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  101737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101745 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  101745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101780 */     GIR_RootConstrainSelectedInstOperands,
     /*  101781 */     // GIR_Coverage, 50932,
     /*  101781 */     GIR_EraseRootFromParent_Done,
     /*  101782 */   // Label 1582: @101782
     /*  101782 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101835), // Rule ID 50933 //
     /*  101787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  101790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101798 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  101798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101833 */     GIR_RootConstrainSelectedInstOperands,
     /*  101834 */     // GIR_Coverage, 50933,
     /*  101834 */     GIR_EraseRootFromParent_Done,
     /*  101835 */   // Label 1583: @101835
     /*  101835 */   GIM_Reject,
     /*  101836 */ // Label 1563: @101836
     /*  101836 */ GIM_Reject,
     /*  101837 */ // Label 1308: @101837
     /*  101837 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101951),
     /*  101842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  101848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101860 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(101905), // Rule ID 50888 //
     /*  101865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101868 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101903 */     GIR_RootConstrainSelectedInstOperands,
     /*  101904 */     // GIR_Coverage, 50888,
     /*  101904 */     GIR_EraseRootFromParent_Done,
     /*  101905 */   // Label 1585: @101905
     /*  101905 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(101950), // Rule ID 50889 //
     /*  101910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101913 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101948 */     GIR_RootConstrainSelectedInstOperands,
     /*  101949 */     // GIR_Coverage, 50889,
     /*  101949 */     GIR_EraseRootFromParent_Done,
     /*  101950 */   // Label 1586: @101950
     /*  101950 */   GIM_Reject,
     /*  101951 */ // Label 1584: @101951
     /*  101951 */ GIM_Reject,
     /*  101952 */ // Label 1309: @101952
     /*  101952 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103676),
     /*  101957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  101963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101967 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102056), // Rule ID 51630 //
     /*  101972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102015 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102054 */     GIR_RootConstrainSelectedInstOperands,
     /*  102055 */     // GIR_Coverage, 51630,
     /*  102055 */     GIR_EraseRootFromParent_Done,
     /*  102056 */   // Label 1588: @102056
     /*  102056 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102145), // Rule ID 51631 //
     /*  102061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102104 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102143 */     GIR_RootConstrainSelectedInstOperands,
     /*  102144 */     // GIR_Coverage, 51631,
     /*  102144 */     GIR_EraseRootFromParent_Done,
     /*  102145 */   // Label 1589: @102145
     /*  102145 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102234), // Rule ID 70308 //
     /*  102150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102193 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102232 */     GIR_RootConstrainSelectedInstOperands,
     /*  102233 */     // GIR_Coverage, 70308,
     /*  102233 */     GIR_EraseRootFromParent_Done,
     /*  102234 */   // Label 1590: @102234
     /*  102234 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102323), // Rule ID 70309 //
     /*  102239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102282 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102321 */     GIR_RootConstrainSelectedInstOperands,
     /*  102322 */     // GIR_Coverage, 70309,
     /*  102322 */     GIR_EraseRootFromParent_Done,
     /*  102323 */   // Label 1591: @102323
     /*  102323 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102412), // Rule ID 70188 //
     /*  102328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102371 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102410 */     GIR_RootConstrainSelectedInstOperands,
     /*  102411 */     // GIR_Coverage, 70188,
     /*  102411 */     GIR_EraseRootFromParent_Done,
     /*  102412 */   // Label 1592: @102412
     /*  102412 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(102501), // Rule ID 70189 //
     /*  102417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102460 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102499 */     GIR_RootConstrainSelectedInstOperands,
     /*  102500 */     // GIR_Coverage, 70189,
     /*  102500 */     GIR_EraseRootFromParent_Done,
     /*  102501 */   // Label 1593: @102501
     /*  102501 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102590), // Rule ID 51810 //
     /*  102506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102549 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102588 */     GIR_RootConstrainSelectedInstOperands,
     /*  102589 */     // GIR_Coverage, 51810,
     /*  102589 */     GIR_EraseRootFromParent_Done,
     /*  102590 */   // Label 1594: @102590
     /*  102590 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102679), // Rule ID 51811 //
     /*  102595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102638 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102677 */     GIR_RootConstrainSelectedInstOperands,
     /*  102678 */     // GIR_Coverage, 51811,
     /*  102678 */     GIR_EraseRootFromParent_Done,
     /*  102679 */   // Label 1595: @102679
     /*  102679 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102768), // Rule ID 51510 //
     /*  102684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102727 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102766 */     GIR_RootConstrainSelectedInstOperands,
     /*  102767 */     // GIR_Coverage, 51510,
     /*  102767 */     GIR_EraseRootFromParent_Done,
     /*  102768 */   // Label 1596: @102768
     /*  102768 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102857), // Rule ID 51511 //
     /*  102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102816 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102855 */     GIR_RootConstrainSelectedInstOperands,
     /*  102856 */     // GIR_Coverage, 51511,
     /*  102856 */     GIR_EraseRootFromParent_Done,
     /*  102857 */   // Label 1597: @102857
     /*  102857 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102946), // Rule ID 51750 //
     /*  102862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102905 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102944 */     GIR_RootConstrainSelectedInstOperands,
     /*  102945 */     // GIR_Coverage, 51750,
     /*  102945 */     GIR_EraseRootFromParent_Done,
     /*  102946 */   // Label 1598: @102946
     /*  102946 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(103035), // Rule ID 51751 //
     /*  102951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102994 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103033 */     GIR_RootConstrainSelectedInstOperands,
     /*  103034 */     // GIR_Coverage, 51751,
     /*  103034 */     GIR_EraseRootFromParent_Done,
     /*  103035 */   // Label 1599: @103035
     /*  103035 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103124), // Rule ID 51690 //
     /*  103040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103083 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103122 */     GIR_RootConstrainSelectedInstOperands,
     /*  103123 */     // GIR_Coverage, 51690,
     /*  103123 */     GIR_EraseRootFromParent_Done,
     /*  103124 */   // Label 1600: @103124
     /*  103124 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103213), // Rule ID 51691 //
     /*  103129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103144 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103172 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103211 */     GIR_RootConstrainSelectedInstOperands,
     /*  103212 */     // GIR_Coverage, 51691,
     /*  103212 */     GIR_EraseRootFromParent_Done,
     /*  103213 */   // Label 1601: @103213
     /*  103213 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103302), // Rule ID 70248 //
     /*  103218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103261 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103300 */     GIR_RootConstrainSelectedInstOperands,
     /*  103301 */     // GIR_Coverage, 70248,
     /*  103301 */     GIR_EraseRootFromParent_Done,
     /*  103302 */   // Label 1602: @103302
     /*  103302 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103391), // Rule ID 70249 //
     /*  103307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103341 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103350 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103389 */     GIR_RootConstrainSelectedInstOperands,
     /*  103390 */     // GIR_Coverage, 70249,
     /*  103390 */     GIR_EraseRootFromParent_Done,
     /*  103391 */   // Label 1603: @103391
     /*  103391 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103480), // Rule ID 51570 //
     /*  103396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103439 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103478 */     GIR_RootConstrainSelectedInstOperands,
     /*  103479 */     // GIR_Coverage, 51570,
     /*  103479 */     GIR_EraseRootFromParent_Done,
     /*  103480 */   // Label 1604: @103480
     /*  103480 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103569), // Rule ID 51571 //
     /*  103485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103528 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103567 */     GIR_RootConstrainSelectedInstOperands,
     /*  103568 */     // GIR_Coverage, 51571,
     /*  103568 */     GIR_EraseRootFromParent_Done,
     /*  103569 */   // Label 1605: @103569
     /*  103569 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103622), // Rule ID 50904 //
     /*  103574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103585 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103620 */     GIR_RootConstrainSelectedInstOperands,
     /*  103621 */     // GIR_Coverage, 50904,
     /*  103621 */     GIR_EraseRootFromParent_Done,
     /*  103622 */   // Label 1606: @103622
     /*  103622 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103675), // Rule ID 50905 //
     /*  103627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103638 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103673 */     GIR_RootConstrainSelectedInstOperands,
     /*  103674 */     // GIR_Coverage, 50905,
     /*  103674 */     GIR_EraseRootFromParent_Done,
     /*  103675 */   // Label 1607: @103675
     /*  103675 */   GIM_Reject,
     /*  103676 */ // Label 1587: @103676
     /*  103676 */ GIM_Reject,
     /*  103677 */ // Label 1310: @103677
     /*  103677 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105401),
     /*  103682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  103685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  103688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103692 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103781), // Rule ID 51654 //
     /*  103697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103731 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103740 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103779 */     GIR_RootConstrainSelectedInstOperands,
     /*  103780 */     // GIR_Coverage, 51654,
     /*  103780 */     GIR_EraseRootFromParent_Done,
     /*  103781 */   // Label 1609: @103781
     /*  103781 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103870), // Rule ID 51655 //
     /*  103786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103820 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103829 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103868 */     GIR_RootConstrainSelectedInstOperands,
     /*  103869 */     // GIR_Coverage, 51655,
     /*  103869 */     GIR_EraseRootFromParent_Done,
     /*  103870 */   // Label 1610: @103870
     /*  103870 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(103959), // Rule ID 70332 //
     /*  103875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103918 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  103935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103957 */     GIR_RootConstrainSelectedInstOperands,
     /*  103958 */     // GIR_Coverage, 70332,
     /*  103958 */     GIR_EraseRootFromParent_Done,
     /*  103959 */   // Label 1611: @103959
     /*  103959 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104048), // Rule ID 70333 //
     /*  103964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103998 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104007 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104046 */     GIR_RootConstrainSelectedInstOperands,
     /*  104047 */     // GIR_Coverage, 70333,
     /*  104047 */     GIR_EraseRootFromParent_Done,
     /*  104048 */   // Label 1612: @104048
     /*  104048 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104137), // Rule ID 70212 //
     /*  104053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104087 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104096 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104135 */     GIR_RootConstrainSelectedInstOperands,
     /*  104136 */     // GIR_Coverage, 70212,
     /*  104136 */     GIR_EraseRootFromParent_Done,
     /*  104137 */   // Label 1613: @104137
     /*  104137 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(104226), // Rule ID 70213 //
     /*  104142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104185 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104224 */     GIR_RootConstrainSelectedInstOperands,
     /*  104225 */     // GIR_Coverage, 70213,
     /*  104225 */     GIR_EraseRootFromParent_Done,
     /*  104226 */   // Label 1614: @104226
     /*  104226 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104315), // Rule ID 51834 //
     /*  104231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104274 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104313 */     GIR_RootConstrainSelectedInstOperands,
     /*  104314 */     // GIR_Coverage, 51834,
     /*  104314 */     GIR_EraseRootFromParent_Done,
     /*  104315 */   // Label 1615: @104315
     /*  104315 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104404), // Rule ID 51835 //
     /*  104320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104363 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104402 */     GIR_RootConstrainSelectedInstOperands,
     /*  104403 */     // GIR_Coverage, 51835,
     /*  104403 */     GIR_EraseRootFromParent_Done,
     /*  104404 */   // Label 1616: @104404
     /*  104404 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104493), // Rule ID 51534 //
     /*  104409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104452 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104491 */     GIR_RootConstrainSelectedInstOperands,
     /*  104492 */     // GIR_Coverage, 51534,
     /*  104492 */     GIR_EraseRootFromParent_Done,
     /*  104493 */   // Label 1617: @104493
     /*  104493 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104582), // Rule ID 51535 //
     /*  104498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104532 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104541 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104580 */     GIR_RootConstrainSelectedInstOperands,
     /*  104581 */     // GIR_Coverage, 51535,
     /*  104581 */     GIR_EraseRootFromParent_Done,
     /*  104582 */   // Label 1618: @104582
     /*  104582 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104671), // Rule ID 51774 //
     /*  104587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104621 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104630 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104669 */     GIR_RootConstrainSelectedInstOperands,
     /*  104670 */     // GIR_Coverage, 51774,
     /*  104670 */     GIR_EraseRootFromParent_Done,
     /*  104671 */   // Label 1619: @104671
     /*  104671 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104760), // Rule ID 51775 //
     /*  104676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104719 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104758 */     GIR_RootConstrainSelectedInstOperands,
     /*  104759 */     // GIR_Coverage, 51775,
     /*  104759 */     GIR_EraseRootFromParent_Done,
     /*  104760 */   // Label 1620: @104760
     /*  104760 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104849), // Rule ID 51714 //
     /*  104765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104799 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104808 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104847 */     GIR_RootConstrainSelectedInstOperands,
     /*  104848 */     // GIR_Coverage, 51714,
     /*  104848 */     GIR_EraseRootFromParent_Done,
     /*  104849 */   // Label 1621: @104849
     /*  104849 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104938), // Rule ID 51715 //
     /*  104854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104888 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104897 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104936 */     GIR_RootConstrainSelectedInstOperands,
     /*  104937 */     // GIR_Coverage, 51715,
     /*  104937 */     GIR_EraseRootFromParent_Done,
     /*  104938 */   // Label 1622: @104938
     /*  104938 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105027), // Rule ID 70272 //
     /*  104943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104986 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105025 */     GIR_RootConstrainSelectedInstOperands,
     /*  105026 */     // GIR_Coverage, 70272,
     /*  105026 */     GIR_EraseRootFromParent_Done,
     /*  105027 */   // Label 1623: @105027
     /*  105027 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105116), // Rule ID 70273 //
     /*  105032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105075 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105114 */     GIR_RootConstrainSelectedInstOperands,
     /*  105115 */     // GIR_Coverage, 70273,
     /*  105115 */     GIR_EraseRootFromParent_Done,
     /*  105116 */   // Label 1624: @105116
     /*  105116 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105205), // Rule ID 51594 //
     /*  105121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105164 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105203 */     GIR_RootConstrainSelectedInstOperands,
     /*  105204 */     // GIR_Coverage, 51594,
     /*  105204 */     GIR_EraseRootFromParent_Done,
     /*  105205 */   // Label 1625: @105205
     /*  105205 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105294), // Rule ID 51595 //
     /*  105210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105253 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105292 */     GIR_RootConstrainSelectedInstOperands,
     /*  105293 */     // GIR_Coverage, 51595,
     /*  105293 */     GIR_EraseRootFromParent_Done,
     /*  105294 */   // Label 1626: @105294
     /*  105294 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105347), // Rule ID 50920 //
     /*  105299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105310 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105345 */     GIR_RootConstrainSelectedInstOperands,
     /*  105346 */     // GIR_Coverage, 50920,
     /*  105346 */     GIR_EraseRootFromParent_Done,
     /*  105347 */   // Label 1627: @105347
     /*  105347 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105400), // Rule ID 50921 //
     /*  105352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105363 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105398 */     GIR_RootConstrainSelectedInstOperands,
     /*  105399 */     // GIR_Coverage, 50921,
     /*  105399 */     GIR_EraseRootFromParent_Done,
     /*  105400 */   // Label 1628: @105400
     /*  105400 */   GIM_Reject,
     /*  105401 */ // Label 1608: @105401
     /*  105401 */ GIM_Reject,
     /*  105402 */ // Label 1311: @105402
     /*  105402 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105516),
     /*  105407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105425 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105470), // Rule ID 50892 //
     /*  105430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105433 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105468 */     GIR_RootConstrainSelectedInstOperands,
     /*  105469 */     // GIR_Coverage, 50892,
     /*  105469 */     GIR_EraseRootFromParent_Done,
     /*  105470 */   // Label 1630: @105470
     /*  105470 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105515), // Rule ID 50893 //
     /*  105475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105478 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105513 */     GIR_RootConstrainSelectedInstOperands,
     /*  105514 */     // GIR_Coverage, 50893,
     /*  105514 */     GIR_EraseRootFromParent_Done,
     /*  105515 */   // Label 1631: @105515
     /*  105515 */   GIM_Reject,
     /*  105516 */ // Label 1629: @105516
     /*  105516 */ GIM_Reject,
     /*  105517 */ // Label 1312: @105517
     /*  105517 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(107241),
     /*  105522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105532 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105621), // Rule ID 51634 //
     /*  105537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105580 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105619 */     GIR_RootConstrainSelectedInstOperands,
     /*  105620 */     // GIR_Coverage, 51634,
     /*  105620 */     GIR_EraseRootFromParent_Done,
     /*  105621 */   // Label 1633: @105621
     /*  105621 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105710), // Rule ID 51635 //
     /*  105626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105669 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105708 */     GIR_RootConstrainSelectedInstOperands,
     /*  105709 */     // GIR_Coverage, 51635,
     /*  105709 */     GIR_EraseRootFromParent_Done,
     /*  105710 */   // Label 1634: @105710
     /*  105710 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105799), // Rule ID 70312 //
     /*  105715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105758 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105797 */     GIR_RootConstrainSelectedInstOperands,
     /*  105798 */     // GIR_Coverage, 70312,
     /*  105798 */     GIR_EraseRootFromParent_Done,
     /*  105799 */   // Label 1635: @105799
     /*  105799 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105888), // Rule ID 70313 //
     /*  105804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105847 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105886 */     GIR_RootConstrainSelectedInstOperands,
     /*  105887 */     // GIR_Coverage, 70313,
     /*  105887 */     GIR_EraseRootFromParent_Done,
     /*  105888 */   // Label 1636: @105888
     /*  105888 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105977), // Rule ID 70192 //
     /*  105893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105936 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105975 */     GIR_RootConstrainSelectedInstOperands,
     /*  105976 */     // GIR_Coverage, 70192,
     /*  105976 */     GIR_EraseRootFromParent_Done,
     /*  105977 */   // Label 1637: @105977
     /*  105977 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106066), // Rule ID 70193 //
     /*  105982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106025 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106064 */     GIR_RootConstrainSelectedInstOperands,
     /*  106065 */     // GIR_Coverage, 70193,
     /*  106065 */     GIR_EraseRootFromParent_Done,
     /*  106066 */   // Label 1638: @106066
     /*  106066 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106155), // Rule ID 51814 //
     /*  106071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106114 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106153 */     GIR_RootConstrainSelectedInstOperands,
     /*  106154 */     // GIR_Coverage, 51814,
     /*  106154 */     GIR_EraseRootFromParent_Done,
     /*  106155 */   // Label 1639: @106155
     /*  106155 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106244), // Rule ID 51815 //
     /*  106160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106203 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106242 */     GIR_RootConstrainSelectedInstOperands,
     /*  106243 */     // GIR_Coverage, 51815,
     /*  106243 */     GIR_EraseRootFromParent_Done,
     /*  106244 */   // Label 1640: @106244
     /*  106244 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106333), // Rule ID 51514 //
     /*  106249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106292 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106331 */     GIR_RootConstrainSelectedInstOperands,
     /*  106332 */     // GIR_Coverage, 51514,
     /*  106332 */     GIR_EraseRootFromParent_Done,
     /*  106333 */   // Label 1641: @106333
     /*  106333 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106422), // Rule ID 51515 //
     /*  106338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106381 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106420 */     GIR_RootConstrainSelectedInstOperands,
     /*  106421 */     // GIR_Coverage, 51515,
     /*  106421 */     GIR_EraseRootFromParent_Done,
     /*  106422 */   // Label 1642: @106422
     /*  106422 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106511), // Rule ID 51754 //
     /*  106427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106470 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106509 */     GIR_RootConstrainSelectedInstOperands,
     /*  106510 */     // GIR_Coverage, 51754,
     /*  106510 */     GIR_EraseRootFromParent_Done,
     /*  106511 */   // Label 1643: @106511
     /*  106511 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106600), // Rule ID 51755 //
     /*  106516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106559 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106598 */     GIR_RootConstrainSelectedInstOperands,
     /*  106599 */     // GIR_Coverage, 51755,
     /*  106599 */     GIR_EraseRootFromParent_Done,
     /*  106600 */   // Label 1644: @106600
     /*  106600 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106689), // Rule ID 51694 //
     /*  106605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106648 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106687 */     GIR_RootConstrainSelectedInstOperands,
     /*  106688 */     // GIR_Coverage, 51694,
     /*  106688 */     GIR_EraseRootFromParent_Done,
     /*  106689 */   // Label 1645: @106689
     /*  106689 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106778), // Rule ID 51695 //
     /*  106694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106737 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106776 */     GIR_RootConstrainSelectedInstOperands,
     /*  106777 */     // GIR_Coverage, 51695,
     /*  106777 */     GIR_EraseRootFromParent_Done,
     /*  106778 */   // Label 1646: @106778
     /*  106778 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106867), // Rule ID 70252 //
     /*  106783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106826 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106865 */     GIR_RootConstrainSelectedInstOperands,
     /*  106866 */     // GIR_Coverage, 70252,
     /*  106866 */     GIR_EraseRootFromParent_Done,
     /*  106867 */   // Label 1647: @106867
     /*  106867 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106956), // Rule ID 70253 //
     /*  106872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106915 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106954 */     GIR_RootConstrainSelectedInstOperands,
     /*  106955 */     // GIR_Coverage, 70253,
     /*  106955 */     GIR_EraseRootFromParent_Done,
     /*  106956 */   // Label 1648: @106956
     /*  106956 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107045), // Rule ID 51574 //
     /*  106961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107004 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107043 */     GIR_RootConstrainSelectedInstOperands,
     /*  107044 */     // GIR_Coverage, 51574,
     /*  107044 */     GIR_EraseRootFromParent_Done,
     /*  107045 */   // Label 1649: @107045
     /*  107045 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107134), // Rule ID 51575 //
     /*  107050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107093 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107132 */     GIR_RootConstrainSelectedInstOperands,
     /*  107133 */     // GIR_Coverage, 51575,
     /*  107133 */     GIR_EraseRootFromParent_Done,
     /*  107134 */   // Label 1650: @107134
     /*  107134 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107187), // Rule ID 50908 //
     /*  107139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107150 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107185 */     GIR_RootConstrainSelectedInstOperands,
     /*  107186 */     // GIR_Coverage, 50908,
     /*  107186 */     GIR_EraseRootFromParent_Done,
     /*  107187 */   // Label 1651: @107187
     /*  107187 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107240), // Rule ID 50909 //
     /*  107192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107203 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107238 */     GIR_RootConstrainSelectedInstOperands,
     /*  107239 */     // GIR_Coverage, 50909,
     /*  107239 */     GIR_EraseRootFromParent_Done,
     /*  107240 */   // Label 1652: @107240
     /*  107240 */   GIM_Reject,
     /*  107241 */ // Label 1632: @107241
     /*  107241 */ GIM_Reject,
     /*  107242 */ // Label 1313: @107242
     /*  107242 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107356),
     /*  107247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107265 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107310), // Rule ID 50896 //
     /*  107270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107273 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107308 */     GIR_RootConstrainSelectedInstOperands,
     /*  107309 */     // GIR_Coverage, 50896,
     /*  107309 */     GIR_EraseRootFromParent_Done,
     /*  107310 */   // Label 1654: @107310
     /*  107310 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107355), // Rule ID 50897 //
     /*  107315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107318 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107353 */     GIR_RootConstrainSelectedInstOperands,
     /*  107354 */     // GIR_Coverage, 50897,
     /*  107354 */     GIR_EraseRootFromParent_Done,
     /*  107355 */   // Label 1655: @107355
     /*  107355 */   GIM_Reject,
     /*  107356 */ // Label 1653: @107356
     /*  107356 */ GIM_Reject,
     /*  107357 */ // Label 1314: @107357
     /*  107357 */ GIM_Reject,
     /*  107358 */ // Label 3: @107358
     /*  107358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(110091),
     /*  107369 */ /*GILLT_s32*//*Label 1656*/ GIMT_Encode4(107493),
     /*  107373 */ /*GILLT_s64*//*Label 1657*/ GIMT_Encode4(107527), GIMT_Encode4(0),
     /*  107381 */ /*GILLT_nxv1s8*//*Label 1658*/ GIMT_Encode4(107561),
     /*  107385 */ /*GILLT_nxv1s16*//*Label 1659*/ GIMT_Encode4(107676),
     /*  107389 */ /*GILLT_nxv1s32*//*Label 1660*/ GIMT_Encode4(107791),
     /*  107393 */ /*GILLT_nxv1s64*//*Label 1661*/ GIMT_Encode4(107906), GIMT_Encode4(0),
     /*  107401 */ /*GILLT_nxv2s8*//*Label 1662*/ GIMT_Encode4(108021),
     /*  107405 */ /*GILLT_nxv2s16*//*Label 1663*/ GIMT_Encode4(108136),
     /*  107409 */ /*GILLT_nxv2s32*//*Label 1664*/ GIMT_Encode4(108251),
     /*  107413 */ /*GILLT_nxv2s64*//*Label 1665*/ GIMT_Encode4(108366), GIMT_Encode4(0),
     /*  107421 */ /*GILLT_nxv4s8*//*Label 1666*/ GIMT_Encode4(108481),
     /*  107425 */ /*GILLT_nxv4s16*//*Label 1667*/ GIMT_Encode4(108596),
     /*  107429 */ /*GILLT_nxv4s32*//*Label 1668*/ GIMT_Encode4(108711),
     /*  107433 */ /*GILLT_nxv4s64*//*Label 1669*/ GIMT_Encode4(108826), GIMT_Encode4(0),
     /*  107441 */ /*GILLT_nxv8s8*//*Label 1670*/ GIMT_Encode4(108941),
     /*  107445 */ /*GILLT_nxv8s16*//*Label 1671*/ GIMT_Encode4(109056),
     /*  107449 */ /*GILLT_nxv8s32*//*Label 1672*/ GIMT_Encode4(109171),
     /*  107453 */ /*GILLT_nxv8s64*//*Label 1673*/ GIMT_Encode4(109286), GIMT_Encode4(0),
     /*  107461 */ /*GILLT_nxv16s8*//*Label 1674*/ GIMT_Encode4(109401),
     /*  107465 */ /*GILLT_nxv16s16*//*Label 1675*/ GIMT_Encode4(109516),
     /*  107469 */ /*GILLT_nxv16s32*//*Label 1676*/ GIMT_Encode4(109631), GIMT_Encode4(0),
     /*  107477 */ /*GILLT_nxv32s8*//*Label 1677*/ GIMT_Encode4(109746),
     /*  107481 */ /*GILLT_nxv32s16*//*Label 1678*/ GIMT_Encode4(109861), GIMT_Encode4(0),
     /*  107489 */ /*GILLT_nxv64s8*//*Label 1679*/ GIMT_Encode4(109976),
     /*  107493 */ // Label 1656: @107493
     /*  107493 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107526), // Rule ID 298 //
     /*  107498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107519 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107524 */   GIR_RootConstrainSelectedInstOperands,
     /*  107525 */   // GIR_Coverage, 298,
     /*  107525 */   GIR_Done,
     /*  107526 */ // Label 1681: @107526
     /*  107526 */ GIM_Reject,
     /*  107527 */ // Label 1657: @107527
     /*  107527 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107560), // Rule ID 297 //
     /*  107532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  107535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  107538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  107541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107553 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107558 */   GIR_RootConstrainSelectedInstOperands,
     /*  107559 */   // GIR_Coverage, 297,
     /*  107559 */   GIR_Done,
     /*  107560 */ // Label 1682: @107560
     /*  107560 */ GIM_Reject,
     /*  107561 */ // Label 1658: @107561
     /*  107561 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107675),
     /*  107566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  107569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107584 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107629), // Rule ID 51200 //
     /*  107589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107592 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107627 */     GIR_RootConstrainSelectedInstOperands,
     /*  107628 */     // GIR_Coverage, 51200,
     /*  107628 */     GIR_EraseRootFromParent_Done,
     /*  107629 */   // Label 1684: @107629
     /*  107629 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107674), // Rule ID 51201 //
     /*  107634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107637 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107672 */     GIR_RootConstrainSelectedInstOperands,
     /*  107673 */     // GIR_Coverage, 51201,
     /*  107673 */     GIR_EraseRootFromParent_Done,
     /*  107674 */   // Label 1685: @107674
     /*  107674 */   GIM_Reject,
     /*  107675 */ // Label 1683: @107675
     /*  107675 */ GIM_Reject,
     /*  107676 */ // Label 1659: @107676
     /*  107676 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107790),
     /*  107681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  107684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  107687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107699 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107744), // Rule ID 51212 //
     /*  107704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107707 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107742 */     GIR_RootConstrainSelectedInstOperands,
     /*  107743 */     // GIR_Coverage, 51212,
     /*  107743 */     GIR_EraseRootFromParent_Done,
     /*  107744 */   // Label 1687: @107744
     /*  107744 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107789), // Rule ID 51213 //
     /*  107749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107752 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107787 */     GIR_RootConstrainSelectedInstOperands,
     /*  107788 */     // GIR_Coverage, 51213,
     /*  107788 */     GIR_EraseRootFromParent_Done,
     /*  107789 */   // Label 1688: @107789
     /*  107789 */   GIM_Reject,
     /*  107790 */ // Label 1686: @107790
     /*  107790 */ GIM_Reject,
     /*  107791 */ // Label 1660: @107791
     /*  107791 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107905),
     /*  107796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  107799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  107802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107814 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107859), // Rule ID 51220 //
     /*  107819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107822 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107857 */     GIR_RootConstrainSelectedInstOperands,
     /*  107858 */     // GIR_Coverage, 51220,
     /*  107858 */     GIR_EraseRootFromParent_Done,
     /*  107859 */   // Label 1690: @107859
     /*  107859 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107904), // Rule ID 51221 //
     /*  107864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107867 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107902 */     GIR_RootConstrainSelectedInstOperands,
     /*  107903 */     // GIR_Coverage, 51221,
     /*  107903 */     GIR_EraseRootFromParent_Done,
     /*  107904 */   // Label 1691: @107904
     /*  107904 */   GIM_Reject,
     /*  107905 */ // Label 1689: @107905
     /*  107905 */ GIM_Reject,
     /*  107906 */ // Label 1661: @107906
     /*  107906 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108020),
     /*  107911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  107914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  107917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107929 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107974), // Rule ID 51236 //
     /*  107934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107937 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107972 */     GIR_RootConstrainSelectedInstOperands,
     /*  107973 */     // GIR_Coverage, 51236,
     /*  107973 */     GIR_EraseRootFromParent_Done,
     /*  107974 */   // Label 1693: @107974
     /*  107974 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108019), // Rule ID 51237 //
     /*  107979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107982 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108017 */     GIR_RootConstrainSelectedInstOperands,
     /*  108018 */     // GIR_Coverage, 51237,
     /*  108018 */     GIR_EraseRootFromParent_Done,
     /*  108019 */   // Label 1694: @108019
     /*  108019 */   GIM_Reject,
     /*  108020 */ // Label 1692: @108020
     /*  108020 */ GIM_Reject,
     /*  108021 */ // Label 1662: @108021
     /*  108021 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108135),
     /*  108026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108044 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108089), // Rule ID 51204 //
     /*  108049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108052 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108087 */     GIR_RootConstrainSelectedInstOperands,
     /*  108088 */     // GIR_Coverage, 51204,
     /*  108088 */     GIR_EraseRootFromParent_Done,
     /*  108089 */   // Label 1696: @108089
     /*  108089 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108134), // Rule ID 51205 //
     /*  108094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108097 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108132 */     GIR_RootConstrainSelectedInstOperands,
     /*  108133 */     // GIR_Coverage, 51205,
     /*  108133 */     GIR_EraseRootFromParent_Done,
     /*  108134 */   // Label 1697: @108134
     /*  108134 */   GIM_Reject,
     /*  108135 */ // Label 1695: @108135
     /*  108135 */ GIM_Reject,
     /*  108136 */ // Label 1663: @108136
     /*  108136 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108250),
     /*  108141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108159 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108204), // Rule ID 51216 //
     /*  108164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108167 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108202 */     GIR_RootConstrainSelectedInstOperands,
     /*  108203 */     // GIR_Coverage, 51216,
     /*  108203 */     GIR_EraseRootFromParent_Done,
     /*  108204 */   // Label 1699: @108204
     /*  108204 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108249), // Rule ID 51217 //
     /*  108209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108212 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108247 */     GIR_RootConstrainSelectedInstOperands,
     /*  108248 */     // GIR_Coverage, 51217,
     /*  108248 */     GIR_EraseRootFromParent_Done,
     /*  108249 */   // Label 1700: @108249
     /*  108249 */   GIM_Reject,
     /*  108250 */ // Label 1698: @108250
     /*  108250 */ GIM_Reject,
     /*  108251 */ // Label 1664: @108251
     /*  108251 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108365),
     /*  108256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108274 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108319), // Rule ID 51232 //
     /*  108279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108282 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108317 */     GIR_RootConstrainSelectedInstOperands,
     /*  108318 */     // GIR_Coverage, 51232,
     /*  108318 */     GIR_EraseRootFromParent_Done,
     /*  108319 */   // Label 1702: @108319
     /*  108319 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108364), // Rule ID 51233 //
     /*  108324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108327 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108362 */     GIR_RootConstrainSelectedInstOperands,
     /*  108363 */     // GIR_Coverage, 51233,
     /*  108363 */     GIR_EraseRootFromParent_Done,
     /*  108364 */   // Label 1703: @108364
     /*  108364 */   GIM_Reject,
     /*  108365 */ // Label 1701: @108365
     /*  108365 */ GIM_Reject,
     /*  108366 */ // Label 1665: @108366
     /*  108366 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108480),
     /*  108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108389 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108434), // Rule ID 51276 //
     /*  108394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108397 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108432 */     GIR_RootConstrainSelectedInstOperands,
     /*  108433 */     // GIR_Coverage, 51276,
     /*  108433 */     GIR_EraseRootFromParent_Done,
     /*  108434 */   // Label 1705: @108434
     /*  108434 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108479), // Rule ID 51277 //
     /*  108439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108442 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108477 */     GIR_RootConstrainSelectedInstOperands,
     /*  108478 */     // GIR_Coverage, 51277,
     /*  108478 */     GIR_EraseRootFromParent_Done,
     /*  108479 */   // Label 1706: @108479
     /*  108479 */   GIM_Reject,
     /*  108480 */ // Label 1704: @108480
     /*  108480 */ GIM_Reject,
     /*  108481 */ // Label 1666: @108481
     /*  108481 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108595),
     /*  108486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108504 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108549), // Rule ID 51208 //
     /*  108509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108512 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108547 */     GIR_RootConstrainSelectedInstOperands,
     /*  108548 */     // GIR_Coverage, 51208,
     /*  108548 */     GIR_EraseRootFromParent_Done,
     /*  108549 */   // Label 1708: @108549
     /*  108549 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108594), // Rule ID 51209 //
     /*  108554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108557 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108592 */     GIR_RootConstrainSelectedInstOperands,
     /*  108593 */     // GIR_Coverage, 51209,
     /*  108593 */     GIR_EraseRootFromParent_Done,
     /*  108594 */   // Label 1709: @108594
     /*  108594 */   GIM_Reject,
     /*  108595 */ // Label 1707: @108595
     /*  108595 */ GIM_Reject,
     /*  108596 */ // Label 1667: @108596
     /*  108596 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108710),
     /*  108601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  108604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  108607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108619 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108664), // Rule ID 51228 //
     /*  108624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108627 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108662 */     GIR_RootConstrainSelectedInstOperands,
     /*  108663 */     // GIR_Coverage, 51228,
     /*  108663 */     GIR_EraseRootFromParent_Done,
     /*  108664 */   // Label 1711: @108664
     /*  108664 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108709), // Rule ID 51229 //
     /*  108669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108672 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108707 */     GIR_RootConstrainSelectedInstOperands,
     /*  108708 */     // GIR_Coverage, 51229,
     /*  108708 */     GIR_EraseRootFromParent_Done,
     /*  108709 */   // Label 1712: @108709
     /*  108709 */   GIM_Reject,
     /*  108710 */ // Label 1710: @108710
     /*  108710 */ GIM_Reject,
     /*  108711 */ // Label 1668: @108711
     /*  108711 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108825),
     /*  108716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  108719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108734 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108779), // Rule ID 51264 //
     /*  108739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108742 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108777 */     GIR_RootConstrainSelectedInstOperands,
     /*  108778 */     // GIR_Coverage, 51264,
     /*  108778 */     GIR_EraseRootFromParent_Done,
     /*  108779 */   // Label 1714: @108779
     /*  108779 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108824), // Rule ID 51265 //
     /*  108784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108787 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108822 */     GIR_RootConstrainSelectedInstOperands,
     /*  108823 */     // GIR_Coverage, 51265,
     /*  108823 */     GIR_EraseRootFromParent_Done,
     /*  108824 */   // Label 1715: @108824
     /*  108824 */   GIM_Reject,
     /*  108825 */ // Label 1713: @108825
     /*  108825 */ GIM_Reject,
     /*  108826 */ // Label 1669: @108826
     /*  108826 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108940),
     /*  108831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  108834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  108837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108849 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108894), // Rule ID 51280 //
     /*  108854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108857 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108892 */     GIR_RootConstrainSelectedInstOperands,
     /*  108893 */     // GIR_Coverage, 51280,
     /*  108893 */     GIR_EraseRootFromParent_Done,
     /*  108894 */   // Label 1717: @108894
     /*  108894 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108939), // Rule ID 51281 //
     /*  108899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108902 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108937 */     GIR_RootConstrainSelectedInstOperands,
     /*  108938 */     // GIR_Coverage, 51281,
     /*  108938 */     GIR_EraseRootFromParent_Done,
     /*  108939 */   // Label 1718: @108939
     /*  108939 */   GIM_Reject,
     /*  108940 */ // Label 1716: @108940
     /*  108940 */ GIM_Reject,
     /*  108941 */ // Label 1670: @108941
     /*  108941 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109055),
     /*  108946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  108949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  108952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108964 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109009), // Rule ID 51224 //
     /*  108969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108972 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  108975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  108989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109007 */     GIR_RootConstrainSelectedInstOperands,
     /*  109008 */     // GIR_Coverage, 51224,
     /*  109008 */     GIR_EraseRootFromParent_Done,
     /*  109009 */   // Label 1720: @109009
     /*  109009 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109054), // Rule ID 51225 //
     /*  109014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109017 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109052 */     GIR_RootConstrainSelectedInstOperands,
     /*  109053 */     // GIR_Coverage, 51225,
     /*  109053 */     GIR_EraseRootFromParent_Done,
     /*  109054 */   // Label 1721: @109054
     /*  109054 */   GIM_Reject,
     /*  109055 */ // Label 1719: @109055
     /*  109055 */ GIM_Reject,
     /*  109056 */ // Label 1671: @109056
     /*  109056 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109170),
     /*  109061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109079 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109124), // Rule ID 51252 //
     /*  109084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109087 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109122 */     GIR_RootConstrainSelectedInstOperands,
     /*  109123 */     // GIR_Coverage, 51252,
     /*  109123 */     GIR_EraseRootFromParent_Done,
     /*  109124 */   // Label 1723: @109124
     /*  109124 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109169), // Rule ID 51253 //
     /*  109129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109132 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109167 */     GIR_RootConstrainSelectedInstOperands,
     /*  109168 */     // GIR_Coverage, 51253,
     /*  109168 */     GIR_EraseRootFromParent_Done,
     /*  109169 */   // Label 1724: @109169
     /*  109169 */   GIM_Reject,
     /*  109170 */ // Label 1722: @109170
     /*  109170 */ GIM_Reject,
     /*  109171 */ // Label 1672: @109171
     /*  109171 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109285),
     /*  109176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109194 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109239), // Rule ID 51268 //
     /*  109199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109202 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109237 */     GIR_RootConstrainSelectedInstOperands,
     /*  109238 */     // GIR_Coverage, 51268,
     /*  109238 */     GIR_EraseRootFromParent_Done,
     /*  109239 */   // Label 1726: @109239
     /*  109239 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109284), // Rule ID 51269 //
     /*  109244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109247 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109282 */     GIR_RootConstrainSelectedInstOperands,
     /*  109283 */     // GIR_Coverage, 51269,
     /*  109283 */     GIR_EraseRootFromParent_Done,
     /*  109284 */   // Label 1727: @109284
     /*  109284 */   GIM_Reject,
     /*  109285 */ // Label 1725: @109285
     /*  109285 */ GIM_Reject,
     /*  109286 */ // Label 1673: @109286
     /*  109286 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109400),
     /*  109291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109309 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109354), // Rule ID 51284 //
     /*  109314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109317 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109352 */     GIR_RootConstrainSelectedInstOperands,
     /*  109353 */     // GIR_Coverage, 51284,
     /*  109353 */     GIR_EraseRootFromParent_Done,
     /*  109354 */   // Label 1729: @109354
     /*  109354 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109399), // Rule ID 51285 //
     /*  109359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109362 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109397 */     GIR_RootConstrainSelectedInstOperands,
     /*  109398 */     // GIR_Coverage, 51285,
     /*  109398 */     GIR_EraseRootFromParent_Done,
     /*  109399 */   // Label 1730: @109399
     /*  109399 */   GIM_Reject,
     /*  109400 */ // Label 1728: @109400
     /*  109400 */ GIM_Reject,
     /*  109401 */ // Label 1674: @109401
     /*  109401 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109515),
     /*  109406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109424 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109469), // Rule ID 51240 //
     /*  109429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109432 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109467 */     GIR_RootConstrainSelectedInstOperands,
     /*  109468 */     // GIR_Coverage, 51240,
     /*  109468 */     GIR_EraseRootFromParent_Done,
     /*  109469 */   // Label 1732: @109469
     /*  109469 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109514), // Rule ID 51241 //
     /*  109474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109477 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109512 */     GIR_RootConstrainSelectedInstOperands,
     /*  109513 */     // GIR_Coverage, 51241,
     /*  109513 */     GIR_EraseRootFromParent_Done,
     /*  109514 */   // Label 1733: @109514
     /*  109514 */   GIM_Reject,
     /*  109515 */ // Label 1731: @109515
     /*  109515 */ GIM_Reject,
     /*  109516 */ // Label 1675: @109516
     /*  109516 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109630),
     /*  109521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  109527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109539 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109584), // Rule ID 51256 //
     /*  109544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109547 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109582 */     GIR_RootConstrainSelectedInstOperands,
     /*  109583 */     // GIR_Coverage, 51256,
     /*  109583 */     GIR_EraseRootFromParent_Done,
     /*  109584 */   // Label 1735: @109584
     /*  109584 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109629), // Rule ID 51257 //
     /*  109589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109592 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109627 */     GIR_RootConstrainSelectedInstOperands,
     /*  109628 */     // GIR_Coverage, 51257,
     /*  109628 */     GIR_EraseRootFromParent_Done,
     /*  109629 */   // Label 1736: @109629
     /*  109629 */   GIM_Reject,
     /*  109630 */ // Label 1734: @109630
     /*  109630 */ GIM_Reject,
     /*  109631 */ // Label 1676: @109631
     /*  109631 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109745),
     /*  109636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  109639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  109642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109654 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109699), // Rule ID 51272 //
     /*  109659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109662 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109697 */     GIR_RootConstrainSelectedInstOperands,
     /*  109698 */     // GIR_Coverage, 51272,
     /*  109698 */     GIR_EraseRootFromParent_Done,
     /*  109699 */   // Label 1738: @109699
     /*  109699 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109744), // Rule ID 51273 //
     /*  109704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109707 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109742 */     GIR_RootConstrainSelectedInstOperands,
     /*  109743 */     // GIR_Coverage, 51273,
     /*  109743 */     GIR_EraseRootFromParent_Done,
     /*  109744 */   // Label 1739: @109744
     /*  109744 */   GIM_Reject,
     /*  109745 */ // Label 1737: @109745
     /*  109745 */ GIM_Reject,
     /*  109746 */ // Label 1677: @109746
     /*  109746 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109860),
     /*  109751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  109754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  109757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109769 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109814), // Rule ID 51244 //
     /*  109774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109777 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109812 */     GIR_RootConstrainSelectedInstOperands,
     /*  109813 */     // GIR_Coverage, 51244,
     /*  109813 */     GIR_EraseRootFromParent_Done,
     /*  109814 */   // Label 1741: @109814
     /*  109814 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109859), // Rule ID 51245 //
     /*  109819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109822 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109857 */     GIR_RootConstrainSelectedInstOperands,
     /*  109858 */     // GIR_Coverage, 51245,
     /*  109858 */     GIR_EraseRootFromParent_Done,
     /*  109859 */   // Label 1742: @109859
     /*  109859 */   GIM_Reject,
     /*  109860 */ // Label 1740: @109860
     /*  109860 */ GIM_Reject,
     /*  109861 */ // Label 1678: @109861
     /*  109861 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109975),
     /*  109866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  109869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  109872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109884 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109929), // Rule ID 51260 //
     /*  109889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109892 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109927 */     GIR_RootConstrainSelectedInstOperands,
     /*  109928 */     // GIR_Coverage, 51260,
     /*  109928 */     GIR_EraseRootFromParent_Done,
     /*  109929 */   // Label 1744: @109929
     /*  109929 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109974), // Rule ID 51261 //
     /*  109934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109937 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109972 */     GIR_RootConstrainSelectedInstOperands,
     /*  109973 */     // GIR_Coverage, 51261,
     /*  109973 */     GIR_EraseRootFromParent_Done,
     /*  109974 */   // Label 1745: @109974
     /*  109974 */   GIM_Reject,
     /*  109975 */ // Label 1743: @109975
     /*  109975 */ GIM_Reject,
     /*  109976 */ // Label 1679: @109976
     /*  109976 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110090),
     /*  109981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  109984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  109987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109999 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110044), // Rule ID 51248 //
     /*  110004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110007 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110042 */     GIR_RootConstrainSelectedInstOperands,
     /*  110043 */     // GIR_Coverage, 51248,
     /*  110043 */     GIR_EraseRootFromParent_Done,
     /*  110044 */   // Label 1747: @110044
     /*  110044 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110089), // Rule ID 51249 //
     /*  110049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110052 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110087 */     GIR_RootConstrainSelectedInstOperands,
     /*  110088 */     // GIR_Coverage, 51249,
     /*  110088 */     GIR_EraseRootFromParent_Done,
     /*  110089 */   // Label 1748: @110089
     /*  110089 */   GIM_Reject,
     /*  110090 */ // Label 1746: @110090
     /*  110090 */ GIM_Reject,
     /*  110091 */ // Label 1680: @110091
     /*  110091 */ GIM_Reject,
     /*  110092 */ // Label 4: @110092
     /*  110092 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(112825),
     /*  110103 */ /*GILLT_s32*//*Label 1749*/ GIMT_Encode4(110227),
     /*  110107 */ /*GILLT_s64*//*Label 1750*/ GIMT_Encode4(110261), GIMT_Encode4(0),
     /*  110115 */ /*GILLT_nxv1s8*//*Label 1751*/ GIMT_Encode4(110295),
     /*  110119 */ /*GILLT_nxv1s16*//*Label 1752*/ GIMT_Encode4(110410),
     /*  110123 */ /*GILLT_nxv1s32*//*Label 1753*/ GIMT_Encode4(110525),
     /*  110127 */ /*GILLT_nxv1s64*//*Label 1754*/ GIMT_Encode4(110640), GIMT_Encode4(0),
     /*  110135 */ /*GILLT_nxv2s8*//*Label 1755*/ GIMT_Encode4(110755),
     /*  110139 */ /*GILLT_nxv2s16*//*Label 1756*/ GIMT_Encode4(110870),
     /*  110143 */ /*GILLT_nxv2s32*//*Label 1757*/ GIMT_Encode4(110985),
     /*  110147 */ /*GILLT_nxv2s64*//*Label 1758*/ GIMT_Encode4(111100), GIMT_Encode4(0),
     /*  110155 */ /*GILLT_nxv4s8*//*Label 1759*/ GIMT_Encode4(111215),
     /*  110159 */ /*GILLT_nxv4s16*//*Label 1760*/ GIMT_Encode4(111330),
     /*  110163 */ /*GILLT_nxv4s32*//*Label 1761*/ GIMT_Encode4(111445),
     /*  110167 */ /*GILLT_nxv4s64*//*Label 1762*/ GIMT_Encode4(111560), GIMT_Encode4(0),
     /*  110175 */ /*GILLT_nxv8s8*//*Label 1763*/ GIMT_Encode4(111675),
     /*  110179 */ /*GILLT_nxv8s16*//*Label 1764*/ GIMT_Encode4(111790),
     /*  110183 */ /*GILLT_nxv8s32*//*Label 1765*/ GIMT_Encode4(111905),
     /*  110187 */ /*GILLT_nxv8s64*//*Label 1766*/ GIMT_Encode4(112020), GIMT_Encode4(0),
     /*  110195 */ /*GILLT_nxv16s8*//*Label 1767*/ GIMT_Encode4(112135),
     /*  110199 */ /*GILLT_nxv16s16*//*Label 1768*/ GIMT_Encode4(112250),
     /*  110203 */ /*GILLT_nxv16s32*//*Label 1769*/ GIMT_Encode4(112365), GIMT_Encode4(0),
     /*  110211 */ /*GILLT_nxv32s8*//*Label 1770*/ GIMT_Encode4(112480),
     /*  110215 */ /*GILLT_nxv32s16*//*Label 1771*/ GIMT_Encode4(112595), GIMT_Encode4(0),
     /*  110223 */ /*GILLT_nxv64s8*//*Label 1772*/ GIMT_Encode4(112710),
     /*  110227 */ // Label 1749: @110227
     /*  110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110260), // Rule ID 300 //
     /*  110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110253 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110258 */   GIR_RootConstrainSelectedInstOperands,
     /*  110259 */   // GIR_Coverage, 300,
     /*  110259 */   GIR_Done,
     /*  110260 */ // Label 1774: @110260
     /*  110260 */ GIM_Reject,
     /*  110261 */ // Label 1750: @110261
     /*  110261 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110294), // Rule ID 299 //
     /*  110266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110287 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110292 */   GIR_RootConstrainSelectedInstOperands,
     /*  110293 */   // GIR_Coverage, 299,
     /*  110293 */   GIR_Done,
     /*  110294 */ // Label 1775: @110294
     /*  110294 */ GIM_Reject,
     /*  110295 */ // Label 1751: @110295
     /*  110295 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110409),
     /*  110300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110318 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110363), // Rule ID 51112 //
     /*  110323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110326 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110361 */     GIR_RootConstrainSelectedInstOperands,
     /*  110362 */     // GIR_Coverage, 51112,
     /*  110362 */     GIR_EraseRootFromParent_Done,
     /*  110363 */   // Label 1777: @110363
     /*  110363 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110408), // Rule ID 51113 //
     /*  110368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110371 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110406 */     GIR_RootConstrainSelectedInstOperands,
     /*  110407 */     // GIR_Coverage, 51113,
     /*  110407 */     GIR_EraseRootFromParent_Done,
     /*  110408 */   // Label 1778: @110408
     /*  110408 */   GIM_Reject,
     /*  110409 */ // Label 1776: @110409
     /*  110409 */ GIM_Reject,
     /*  110410 */ // Label 1752: @110410
     /*  110410 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110524),
     /*  110415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110433 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110478), // Rule ID 51124 //
     /*  110438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110441 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110476 */     GIR_RootConstrainSelectedInstOperands,
     /*  110477 */     // GIR_Coverage, 51124,
     /*  110477 */     GIR_EraseRootFromParent_Done,
     /*  110478 */   // Label 1780: @110478
     /*  110478 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110523), // Rule ID 51125 //
     /*  110483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110486 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110521 */     GIR_RootConstrainSelectedInstOperands,
     /*  110522 */     // GIR_Coverage, 51125,
     /*  110522 */     GIR_EraseRootFromParent_Done,
     /*  110523 */   // Label 1781: @110523
     /*  110523 */   GIM_Reject,
     /*  110524 */ // Label 1779: @110524
     /*  110524 */ GIM_Reject,
     /*  110525 */ // Label 1753: @110525
     /*  110525 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110639),
     /*  110530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  110533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  110536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110548 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110593), // Rule ID 51132 //
     /*  110553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110556 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110591 */     GIR_RootConstrainSelectedInstOperands,
     /*  110592 */     // GIR_Coverage, 51132,
     /*  110592 */     GIR_EraseRootFromParent_Done,
     /*  110593 */   // Label 1783: @110593
     /*  110593 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110638), // Rule ID 51133 //
     /*  110598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110601 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110636 */     GIR_RootConstrainSelectedInstOperands,
     /*  110637 */     // GIR_Coverage, 51133,
     /*  110637 */     GIR_EraseRootFromParent_Done,
     /*  110638 */   // Label 1784: @110638
     /*  110638 */   GIM_Reject,
     /*  110639 */ // Label 1782: @110639
     /*  110639 */ GIM_Reject,
     /*  110640 */ // Label 1754: @110640
     /*  110640 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110754),
     /*  110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  110648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  110651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110663 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110708), // Rule ID 51148 //
     /*  110668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110671 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110706 */     GIR_RootConstrainSelectedInstOperands,
     /*  110707 */     // GIR_Coverage, 51148,
     /*  110707 */     GIR_EraseRootFromParent_Done,
     /*  110708 */   // Label 1786: @110708
     /*  110708 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110753), // Rule ID 51149 //
     /*  110713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110716 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110751 */     GIR_RootConstrainSelectedInstOperands,
     /*  110752 */     // GIR_Coverage, 51149,
     /*  110752 */     GIR_EraseRootFromParent_Done,
     /*  110753 */   // Label 1787: @110753
     /*  110753 */   GIM_Reject,
     /*  110754 */ // Label 1785: @110754
     /*  110754 */ GIM_Reject,
     /*  110755 */ // Label 1755: @110755
     /*  110755 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110869),
     /*  110760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  110763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  110766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110778 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110823), // Rule ID 51116 //
     /*  110783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110786 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110821 */     GIR_RootConstrainSelectedInstOperands,
     /*  110822 */     // GIR_Coverage, 51116,
     /*  110822 */     GIR_EraseRootFromParent_Done,
     /*  110823 */   // Label 1789: @110823
     /*  110823 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110868), // Rule ID 51117 //
     /*  110828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110831 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110866 */     GIR_RootConstrainSelectedInstOperands,
     /*  110867 */     // GIR_Coverage, 51117,
     /*  110867 */     GIR_EraseRootFromParent_Done,
     /*  110868 */   // Label 1790: @110868
     /*  110868 */   GIM_Reject,
     /*  110869 */ // Label 1788: @110869
     /*  110869 */ GIM_Reject,
     /*  110870 */ // Label 1756: @110870
     /*  110870 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110984),
     /*  110875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  110878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  110881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110893 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110938), // Rule ID 51128 //
     /*  110898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110901 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110936 */     GIR_RootConstrainSelectedInstOperands,
     /*  110937 */     // GIR_Coverage, 51128,
     /*  110937 */     GIR_EraseRootFromParent_Done,
     /*  110938 */   // Label 1792: @110938
     /*  110938 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110983), // Rule ID 51129 //
     /*  110943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110946 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110981 */     GIR_RootConstrainSelectedInstOperands,
     /*  110982 */     // GIR_Coverage, 51129,
     /*  110982 */     GIR_EraseRootFromParent_Done,
     /*  110983 */   // Label 1793: @110983
     /*  110983 */   GIM_Reject,
     /*  110984 */ // Label 1791: @110984
     /*  110984 */ GIM_Reject,
     /*  110985 */ // Label 1757: @110985
     /*  110985 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111099),
     /*  110990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  110993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  110996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111008 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111053), // Rule ID 51144 //
     /*  111013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111016 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111051 */     GIR_RootConstrainSelectedInstOperands,
     /*  111052 */     // GIR_Coverage, 51144,
     /*  111052 */     GIR_EraseRootFromParent_Done,
     /*  111053 */   // Label 1795: @111053
     /*  111053 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111098), // Rule ID 51145 //
     /*  111058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111061 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111096 */     GIR_RootConstrainSelectedInstOperands,
     /*  111097 */     // GIR_Coverage, 51145,
     /*  111097 */     GIR_EraseRootFromParent_Done,
     /*  111098 */   // Label 1796: @111098
     /*  111098 */   GIM_Reject,
     /*  111099 */ // Label 1794: @111099
     /*  111099 */ GIM_Reject,
     /*  111100 */ // Label 1758: @111100
     /*  111100 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111214),
     /*  111105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111123 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111168), // Rule ID 51188 //
     /*  111128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111131 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111166 */     GIR_RootConstrainSelectedInstOperands,
     /*  111167 */     // GIR_Coverage, 51188,
     /*  111167 */     GIR_EraseRootFromParent_Done,
     /*  111168 */   // Label 1798: @111168
     /*  111168 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111213), // Rule ID 51189 //
     /*  111173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111176 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111211 */     GIR_RootConstrainSelectedInstOperands,
     /*  111212 */     // GIR_Coverage, 51189,
     /*  111212 */     GIR_EraseRootFromParent_Done,
     /*  111213 */   // Label 1799: @111213
     /*  111213 */   GIM_Reject,
     /*  111214 */ // Label 1797: @111214
     /*  111214 */ GIM_Reject,
     /*  111215 */ // Label 1759: @111215
     /*  111215 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111329),
     /*  111220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111238 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111283), // Rule ID 51120 //
     /*  111243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111246 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111281 */     GIR_RootConstrainSelectedInstOperands,
     /*  111282 */     // GIR_Coverage, 51120,
     /*  111282 */     GIR_EraseRootFromParent_Done,
     /*  111283 */   // Label 1801: @111283
     /*  111283 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111328), // Rule ID 51121 //
     /*  111288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111291 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111326 */     GIR_RootConstrainSelectedInstOperands,
     /*  111327 */     // GIR_Coverage, 51121,
     /*  111327 */     GIR_EraseRootFromParent_Done,
     /*  111328 */   // Label 1802: @111328
     /*  111328 */   GIM_Reject,
     /*  111329 */ // Label 1800: @111329
     /*  111329 */ GIM_Reject,
     /*  111330 */ // Label 1760: @111330
     /*  111330 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111444),
     /*  111335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111353 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111398), // Rule ID 51140 //
     /*  111358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111361 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111396 */     GIR_RootConstrainSelectedInstOperands,
     /*  111397 */     // GIR_Coverage, 51140,
     /*  111397 */     GIR_EraseRootFromParent_Done,
     /*  111398 */   // Label 1804: @111398
     /*  111398 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111443), // Rule ID 51141 //
     /*  111403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111406 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111441 */     GIR_RootConstrainSelectedInstOperands,
     /*  111442 */     // GIR_Coverage, 51141,
     /*  111442 */     GIR_EraseRootFromParent_Done,
     /*  111443 */   // Label 1805: @111443
     /*  111443 */   GIM_Reject,
     /*  111444 */ // Label 1803: @111444
     /*  111444 */ GIM_Reject,
     /*  111445 */ // Label 1761: @111445
     /*  111445 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111559),
     /*  111450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111468 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111513), // Rule ID 51176 //
     /*  111473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111476 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111511 */     GIR_RootConstrainSelectedInstOperands,
     /*  111512 */     // GIR_Coverage, 51176,
     /*  111512 */     GIR_EraseRootFromParent_Done,
     /*  111513 */   // Label 1807: @111513
     /*  111513 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111558), // Rule ID 51177 //
     /*  111518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111521 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111556 */     GIR_RootConstrainSelectedInstOperands,
     /*  111557 */     // GIR_Coverage, 51177,
     /*  111557 */     GIR_EraseRootFromParent_Done,
     /*  111558 */   // Label 1808: @111558
     /*  111558 */   GIM_Reject,
     /*  111559 */ // Label 1806: @111559
     /*  111559 */ GIM_Reject,
     /*  111560 */ // Label 1762: @111560
     /*  111560 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111674),
     /*  111565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  111568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  111571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111583 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111628), // Rule ID 51192 //
     /*  111588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111591 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111626 */     GIR_RootConstrainSelectedInstOperands,
     /*  111627 */     // GIR_Coverage, 51192,
     /*  111627 */     GIR_EraseRootFromParent_Done,
     /*  111628 */   // Label 1810: @111628
     /*  111628 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111673), // Rule ID 51193 //
     /*  111633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111636 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111671 */     GIR_RootConstrainSelectedInstOperands,
     /*  111672 */     // GIR_Coverage, 51193,
     /*  111672 */     GIR_EraseRootFromParent_Done,
     /*  111673 */   // Label 1811: @111673
     /*  111673 */   GIM_Reject,
     /*  111674 */ // Label 1809: @111674
     /*  111674 */ GIM_Reject,
     /*  111675 */ // Label 1763: @111675
     /*  111675 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111789),
     /*  111680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  111683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111698 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111743), // Rule ID 51136 //
     /*  111703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111706 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111741 */     GIR_RootConstrainSelectedInstOperands,
     /*  111742 */     // GIR_Coverage, 51136,
     /*  111742 */     GIR_EraseRootFromParent_Done,
     /*  111743 */   // Label 1813: @111743
     /*  111743 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111788), // Rule ID 51137 //
     /*  111748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111751 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111786 */     GIR_RootConstrainSelectedInstOperands,
     /*  111787 */     // GIR_Coverage, 51137,
     /*  111787 */     GIR_EraseRootFromParent_Done,
     /*  111788 */   // Label 1814: @111788
     /*  111788 */   GIM_Reject,
     /*  111789 */ // Label 1812: @111789
     /*  111789 */ GIM_Reject,
     /*  111790 */ // Label 1764: @111790
     /*  111790 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111904),
     /*  111795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  111798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  111801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111813 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111858), // Rule ID 51164 //
     /*  111818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111821 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111856 */     GIR_RootConstrainSelectedInstOperands,
     /*  111857 */     // GIR_Coverage, 51164,
     /*  111857 */     GIR_EraseRootFromParent_Done,
     /*  111858 */   // Label 1816: @111858
     /*  111858 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111903), // Rule ID 51165 //
     /*  111863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111866 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111901 */     GIR_RootConstrainSelectedInstOperands,
     /*  111902 */     // GIR_Coverage, 51165,
     /*  111902 */     GIR_EraseRootFromParent_Done,
     /*  111903 */   // Label 1817: @111903
     /*  111903 */   GIM_Reject,
     /*  111904 */ // Label 1815: @111904
     /*  111904 */ GIM_Reject,
     /*  111905 */ // Label 1765: @111905
     /*  111905 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112019),
     /*  111910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  111913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  111916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111928 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111973), // Rule ID 51180 //
     /*  111933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111936 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111971 */     GIR_RootConstrainSelectedInstOperands,
     /*  111972 */     // GIR_Coverage, 51180,
     /*  111972 */     GIR_EraseRootFromParent_Done,
     /*  111973 */   // Label 1819: @111973
     /*  111973 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112018), // Rule ID 51181 //
     /*  111978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111981 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112016 */     GIR_RootConstrainSelectedInstOperands,
     /*  112017 */     // GIR_Coverage, 51181,
     /*  112017 */     GIR_EraseRootFromParent_Done,
     /*  112018 */   // Label 1820: @112018
     /*  112018 */   GIM_Reject,
     /*  112019 */ // Label 1818: @112019
     /*  112019 */ GIM_Reject,
     /*  112020 */ // Label 1766: @112020
     /*  112020 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112134),
     /*  112025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112043 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112088), // Rule ID 51196 //
     /*  112048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112051 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112086 */     GIR_RootConstrainSelectedInstOperands,
     /*  112087 */     // GIR_Coverage, 51196,
     /*  112087 */     GIR_EraseRootFromParent_Done,
     /*  112088 */   // Label 1822: @112088
     /*  112088 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112133), // Rule ID 51197 //
     /*  112093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112096 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112131 */     GIR_RootConstrainSelectedInstOperands,
     /*  112132 */     // GIR_Coverage, 51197,
     /*  112132 */     GIR_EraseRootFromParent_Done,
     /*  112133 */   // Label 1823: @112133
     /*  112133 */   GIM_Reject,
     /*  112134 */ // Label 1821: @112134
     /*  112134 */ GIM_Reject,
     /*  112135 */ // Label 1767: @112135
     /*  112135 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112249),
     /*  112140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112158 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112203), // Rule ID 51152 //
     /*  112163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112166 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112201 */     GIR_RootConstrainSelectedInstOperands,
     /*  112202 */     // GIR_Coverage, 51152,
     /*  112202 */     GIR_EraseRootFromParent_Done,
     /*  112203 */   // Label 1825: @112203
     /*  112203 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112248), // Rule ID 51153 //
     /*  112208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112211 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112246 */     GIR_RootConstrainSelectedInstOperands,
     /*  112247 */     // GIR_Coverage, 51153,
     /*  112247 */     GIR_EraseRootFromParent_Done,
     /*  112248 */   // Label 1826: @112248
     /*  112248 */   GIM_Reject,
     /*  112249 */ // Label 1824: @112249
     /*  112249 */ GIM_Reject,
     /*  112250 */ // Label 1768: @112250
     /*  112250 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112364),
     /*  112255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112273 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112318), // Rule ID 51168 //
     /*  112278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112281 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112316 */     GIR_RootConstrainSelectedInstOperands,
     /*  112317 */     // GIR_Coverage, 51168,
     /*  112317 */     GIR_EraseRootFromParent_Done,
     /*  112318 */   // Label 1828: @112318
     /*  112318 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112363), // Rule ID 51169 //
     /*  112323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112326 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112361 */     GIR_RootConstrainSelectedInstOperands,
     /*  112362 */     // GIR_Coverage, 51169,
     /*  112362 */     GIR_EraseRootFromParent_Done,
     /*  112363 */   // Label 1829: @112363
     /*  112363 */   GIM_Reject,
     /*  112364 */ // Label 1827: @112364
     /*  112364 */ GIM_Reject,
     /*  112365 */ // Label 1769: @112365
     /*  112365 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112479),
     /*  112370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112388 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112433), // Rule ID 51184 //
     /*  112393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112396 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112431 */     GIR_RootConstrainSelectedInstOperands,
     /*  112432 */     // GIR_Coverage, 51184,
     /*  112432 */     GIR_EraseRootFromParent_Done,
     /*  112433 */   // Label 1831: @112433
     /*  112433 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112478), // Rule ID 51185 //
     /*  112438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112441 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112476 */     GIR_RootConstrainSelectedInstOperands,
     /*  112477 */     // GIR_Coverage, 51185,
     /*  112477 */     GIR_EraseRootFromParent_Done,
     /*  112478 */   // Label 1832: @112478
     /*  112478 */   GIM_Reject,
     /*  112479 */ // Label 1830: @112479
     /*  112479 */ GIM_Reject,
     /*  112480 */ // Label 1770: @112480
     /*  112480 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112594),
     /*  112485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112503 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112548), // Rule ID 51156 //
     /*  112508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112511 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112546 */     GIR_RootConstrainSelectedInstOperands,
     /*  112547 */     // GIR_Coverage, 51156,
     /*  112547 */     GIR_EraseRootFromParent_Done,
     /*  112548 */   // Label 1834: @112548
     /*  112548 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112593), // Rule ID 51157 //
     /*  112553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112556 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112591 */     GIR_RootConstrainSelectedInstOperands,
     /*  112592 */     // GIR_Coverage, 51157,
     /*  112592 */     GIR_EraseRootFromParent_Done,
     /*  112593 */   // Label 1835: @112593
     /*  112593 */   GIM_Reject,
     /*  112594 */ // Label 1833: @112594
     /*  112594 */ GIM_Reject,
     /*  112595 */ // Label 1771: @112595
     /*  112595 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112709),
     /*  112600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  112603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  112606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112618 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112663), // Rule ID 51172 //
     /*  112623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112626 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112661 */     GIR_RootConstrainSelectedInstOperands,
     /*  112662 */     // GIR_Coverage, 51172,
     /*  112662 */     GIR_EraseRootFromParent_Done,
     /*  112663 */   // Label 1837: @112663
     /*  112663 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112708), // Rule ID 51173 //
     /*  112668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112671 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112706 */     GIR_RootConstrainSelectedInstOperands,
     /*  112707 */     // GIR_Coverage, 51173,
     /*  112707 */     GIR_EraseRootFromParent_Done,
     /*  112708 */   // Label 1838: @112708
     /*  112708 */   GIM_Reject,
     /*  112709 */ // Label 1836: @112709
     /*  112709 */ GIM_Reject,
     /*  112710 */ // Label 1772: @112710
     /*  112710 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112824),
     /*  112715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  112718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  112721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112733 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112778), // Rule ID 51160 //
     /*  112738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112741 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112776 */     GIR_RootConstrainSelectedInstOperands,
     /*  112777 */     // GIR_Coverage, 51160,
     /*  112777 */     GIR_EraseRootFromParent_Done,
     /*  112778 */   // Label 1840: @112778
     /*  112778 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112823), // Rule ID 51161 //
     /*  112783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112786 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112821 */     GIR_RootConstrainSelectedInstOperands,
     /*  112822 */     // GIR_Coverage, 51161,
     /*  112822 */     GIR_EraseRootFromParent_Done,
     /*  112823 */   // Label 1841: @112823
     /*  112823 */   GIM_Reject,
     /*  112824 */ // Label 1839: @112824
     /*  112824 */ GIM_Reject,
     /*  112825 */ // Label 1773: @112825
     /*  112825 */ GIM_Reject,
     /*  112826 */ // Label 5: @112826
     /*  112826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1866*/ GIMT_Encode4(115604),
     /*  112837 */ /*GILLT_s32*//*Label 1842*/ GIMT_Encode4(112961),
     /*  112841 */ /*GILLT_s64*//*Label 1843*/ GIMT_Encode4(112995), GIMT_Encode4(0),
     /*  112849 */ /*GILLT_nxv1s8*//*Label 1844*/ GIMT_Encode4(113074),
     /*  112853 */ /*GILLT_nxv1s16*//*Label 1845*/ GIMT_Encode4(113189),
     /*  112857 */ /*GILLT_nxv1s32*//*Label 1846*/ GIMT_Encode4(113304),
     /*  112861 */ /*GILLT_nxv1s64*//*Label 1847*/ GIMT_Encode4(113419), GIMT_Encode4(0),
     /*  112869 */ /*GILLT_nxv2s8*//*Label 1848*/ GIMT_Encode4(113534),
     /*  112873 */ /*GILLT_nxv2s16*//*Label 1849*/ GIMT_Encode4(113649),
     /*  112877 */ /*GILLT_nxv2s32*//*Label 1850*/ GIMT_Encode4(113764),
     /*  112881 */ /*GILLT_nxv2s64*//*Label 1851*/ GIMT_Encode4(113879), GIMT_Encode4(0),
     /*  112889 */ /*GILLT_nxv4s8*//*Label 1852*/ GIMT_Encode4(113994),
     /*  112893 */ /*GILLT_nxv4s16*//*Label 1853*/ GIMT_Encode4(114109),
     /*  112897 */ /*GILLT_nxv4s32*//*Label 1854*/ GIMT_Encode4(114224),
     /*  112901 */ /*GILLT_nxv4s64*//*Label 1855*/ GIMT_Encode4(114339), GIMT_Encode4(0),
     /*  112909 */ /*GILLT_nxv8s8*//*Label 1856*/ GIMT_Encode4(114454),
     /*  112913 */ /*GILLT_nxv8s16*//*Label 1857*/ GIMT_Encode4(114569),
     /*  112917 */ /*GILLT_nxv8s32*//*Label 1858*/ GIMT_Encode4(114684),
     /*  112921 */ /*GILLT_nxv8s64*//*Label 1859*/ GIMT_Encode4(114799), GIMT_Encode4(0),
     /*  112929 */ /*GILLT_nxv16s8*//*Label 1860*/ GIMT_Encode4(114914),
     /*  112933 */ /*GILLT_nxv16s16*//*Label 1861*/ GIMT_Encode4(115029),
     /*  112937 */ /*GILLT_nxv16s32*//*Label 1862*/ GIMT_Encode4(115144), GIMT_Encode4(0),
     /*  112945 */ /*GILLT_nxv32s8*//*Label 1863*/ GIMT_Encode4(115259),
     /*  112949 */ /*GILLT_nxv32s16*//*Label 1864*/ GIMT_Encode4(115374), GIMT_Encode4(0),
     /*  112957 */ /*GILLT_nxv64s8*//*Label 1865*/ GIMT_Encode4(115489),
     /*  112961 */ // Label 1842: @112961
     /*  112961 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(112994), // Rule ID 302 //
     /*  112966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  112969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  112972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  112975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112987 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  112987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  112992 */   GIR_RootConstrainSelectedInstOperands,
     /*  112993 */   // GIR_Coverage, 302,
     /*  112993 */   GIR_Done,
     /*  112994 */ // Label 1867: @112994
     /*  112994 */ GIM_Reject,
     /*  112995 */ // Label 1843: @112995
     /*  112995 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113073),
     /*  113000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113010 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113049), // Rule ID 311 //
     /*  113015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113032 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113047 */     GIR_RootConstrainSelectedInstOperands,
     /*  113048 */     // GIR_Coverage, 311,
     /*  113048 */     GIR_EraseRootFromParent_Done,
     /*  113049 */   // Label 1869: @113049
     /*  113049 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113072), // Rule ID 301 //
     /*  113054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113065 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113070 */     GIR_RootConstrainSelectedInstOperands,
     /*  113071 */     // GIR_Coverage, 301,
     /*  113071 */     GIR_Done,
     /*  113072 */   // Label 1870: @113072
     /*  113072 */   GIM_Reject,
     /*  113073 */ // Label 1868: @113073
     /*  113073 */ GIM_Reject,
     /*  113074 */ // Label 1844: @113074
     /*  113074 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113188),
     /*  113079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113097 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113142), // Rule ID 51376 //
     /*  113102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113105 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113140 */     GIR_RootConstrainSelectedInstOperands,
     /*  113141 */     // GIR_Coverage, 51376,
     /*  113141 */     GIR_EraseRootFromParent_Done,
     /*  113142 */   // Label 1872: @113142
     /*  113142 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113187), // Rule ID 51377 //
     /*  113147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113150 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113185 */     GIR_RootConstrainSelectedInstOperands,
     /*  113186 */     // GIR_Coverage, 51377,
     /*  113186 */     GIR_EraseRootFromParent_Done,
     /*  113187 */   // Label 1873: @113187
     /*  113187 */   GIM_Reject,
     /*  113188 */ // Label 1871: @113188
     /*  113188 */ GIM_Reject,
     /*  113189 */ // Label 1845: @113189
     /*  113189 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113303),
     /*  113194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113212 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113257), // Rule ID 51388 //
     /*  113217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113220 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113255 */     GIR_RootConstrainSelectedInstOperands,
     /*  113256 */     // GIR_Coverage, 51388,
     /*  113256 */     GIR_EraseRootFromParent_Done,
     /*  113257 */   // Label 1875: @113257
     /*  113257 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113302), // Rule ID 51389 //
     /*  113262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113265 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113300 */     GIR_RootConstrainSelectedInstOperands,
     /*  113301 */     // GIR_Coverage, 51389,
     /*  113301 */     GIR_EraseRootFromParent_Done,
     /*  113302 */   // Label 1876: @113302
     /*  113302 */   GIM_Reject,
     /*  113303 */ // Label 1874: @113303
     /*  113303 */ GIM_Reject,
     /*  113304 */ // Label 1846: @113304
     /*  113304 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113418),
     /*  113309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113327 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113372), // Rule ID 51396 //
     /*  113332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113335 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113370 */     GIR_RootConstrainSelectedInstOperands,
     /*  113371 */     // GIR_Coverage, 51396,
     /*  113371 */     GIR_EraseRootFromParent_Done,
     /*  113372 */   // Label 1878: @113372
     /*  113372 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113417), // Rule ID 51397 //
     /*  113377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113380 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113415 */     GIR_RootConstrainSelectedInstOperands,
     /*  113416 */     // GIR_Coverage, 51397,
     /*  113416 */     GIR_EraseRootFromParent_Done,
     /*  113417 */   // Label 1879: @113417
     /*  113417 */   GIM_Reject,
     /*  113418 */ // Label 1877: @113418
     /*  113418 */ GIM_Reject,
     /*  113419 */ // Label 1847: @113419
     /*  113419 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113533),
     /*  113424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113442 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113487), // Rule ID 51412 //
     /*  113447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113450 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113485 */     GIR_RootConstrainSelectedInstOperands,
     /*  113486 */     // GIR_Coverage, 51412,
     /*  113486 */     GIR_EraseRootFromParent_Done,
     /*  113487 */   // Label 1881: @113487
     /*  113487 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113532), // Rule ID 51413 //
     /*  113492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113495 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113530 */     GIR_RootConstrainSelectedInstOperands,
     /*  113531 */     // GIR_Coverage, 51413,
     /*  113531 */     GIR_EraseRootFromParent_Done,
     /*  113532 */   // Label 1882: @113532
     /*  113532 */   GIM_Reject,
     /*  113533 */ // Label 1880: @113533
     /*  113533 */ GIM_Reject,
     /*  113534 */ // Label 1848: @113534
     /*  113534 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113648),
     /*  113539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  113542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  113545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113557 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113602), // Rule ID 51380 //
     /*  113562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113565 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113600 */     GIR_RootConstrainSelectedInstOperands,
     /*  113601 */     // GIR_Coverage, 51380,
     /*  113601 */     GIR_EraseRootFromParent_Done,
     /*  113602 */   // Label 1884: @113602
     /*  113602 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113647), // Rule ID 51381 //
     /*  113607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113610 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113645 */     GIR_RootConstrainSelectedInstOperands,
     /*  113646 */     // GIR_Coverage, 51381,
     /*  113646 */     GIR_EraseRootFromParent_Done,
     /*  113647 */   // Label 1885: @113647
     /*  113647 */   GIM_Reject,
     /*  113648 */ // Label 1883: @113648
     /*  113648 */ GIM_Reject,
     /*  113649 */ // Label 1849: @113649
     /*  113649 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113763),
     /*  113654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  113657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  113660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113672 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113717), // Rule ID 51392 //
     /*  113677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113680 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113715 */     GIR_RootConstrainSelectedInstOperands,
     /*  113716 */     // GIR_Coverage, 51392,
     /*  113716 */     GIR_EraseRootFromParent_Done,
     /*  113717 */   // Label 1887: @113717
     /*  113717 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113762), // Rule ID 51393 //
     /*  113722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113725 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113760 */     GIR_RootConstrainSelectedInstOperands,
     /*  113761 */     // GIR_Coverage, 51393,
     /*  113761 */     GIR_EraseRootFromParent_Done,
     /*  113762 */   // Label 1888: @113762
     /*  113762 */   GIM_Reject,
     /*  113763 */ // Label 1886: @113763
     /*  113763 */ GIM_Reject,
     /*  113764 */ // Label 1850: @113764
     /*  113764 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113878),
     /*  113769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  113772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  113775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113787 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113832), // Rule ID 51408 //
     /*  113792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113795 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113830 */     GIR_RootConstrainSelectedInstOperands,
     /*  113831 */     // GIR_Coverage, 51408,
     /*  113831 */     GIR_EraseRootFromParent_Done,
     /*  113832 */   // Label 1890: @113832
     /*  113832 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(113877), // Rule ID 51409 //
     /*  113837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113840 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113875 */     GIR_RootConstrainSelectedInstOperands,
     /*  113876 */     // GIR_Coverage, 51409,
     /*  113876 */     GIR_EraseRootFromParent_Done,
     /*  113877 */   // Label 1891: @113877
     /*  113877 */   GIM_Reject,
     /*  113878 */ // Label 1889: @113878
     /*  113878 */ GIM_Reject,
     /*  113879 */ // Label 1851: @113879
     /*  113879 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(113993),
     /*  113884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  113887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  113890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113902 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(113947), // Rule ID 51452 //
     /*  113907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113910 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113945 */     GIR_RootConstrainSelectedInstOperands,
     /*  113946 */     // GIR_Coverage, 51452,
     /*  113946 */     GIR_EraseRootFromParent_Done,
     /*  113947 */   // Label 1893: @113947
     /*  113947 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(113992), // Rule ID 51453 //
     /*  113952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113955 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113990 */     GIR_RootConstrainSelectedInstOperands,
     /*  113991 */     // GIR_Coverage, 51453,
     /*  113991 */     GIR_EraseRootFromParent_Done,
     /*  113992 */   // Label 1894: @113992
     /*  113992 */   GIM_Reject,
     /*  113993 */ // Label 1892: @113993
     /*  113993 */ GIM_Reject,
     /*  113994 */ // Label 1852: @113994
     /*  113994 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114108),
     /*  113999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114017 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114062), // Rule ID 51384 //
     /*  114022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114025 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114060 */     GIR_RootConstrainSelectedInstOperands,
     /*  114061 */     // GIR_Coverage, 51384,
     /*  114061 */     GIR_EraseRootFromParent_Done,
     /*  114062 */   // Label 1896: @114062
     /*  114062 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114107), // Rule ID 51385 //
     /*  114067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114070 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114105 */     GIR_RootConstrainSelectedInstOperands,
     /*  114106 */     // GIR_Coverage, 51385,
     /*  114106 */     GIR_EraseRootFromParent_Done,
     /*  114107 */   // Label 1897: @114107
     /*  114107 */   GIM_Reject,
     /*  114108 */ // Label 1895: @114108
     /*  114108 */ GIM_Reject,
     /*  114109 */ // Label 1853: @114109
     /*  114109 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114223),
     /*  114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114132 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114177), // Rule ID 51404 //
     /*  114137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114140 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114175 */     GIR_RootConstrainSelectedInstOperands,
     /*  114176 */     // GIR_Coverage, 51404,
     /*  114176 */     GIR_EraseRootFromParent_Done,
     /*  114177 */   // Label 1899: @114177
     /*  114177 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114222), // Rule ID 51405 //
     /*  114182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114185 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114220 */     GIR_RootConstrainSelectedInstOperands,
     /*  114221 */     // GIR_Coverage, 51405,
     /*  114221 */     GIR_EraseRootFromParent_Done,
     /*  114222 */   // Label 1900: @114222
     /*  114222 */   GIM_Reject,
     /*  114223 */ // Label 1898: @114223
     /*  114223 */ GIM_Reject,
     /*  114224 */ // Label 1854: @114224
     /*  114224 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114338),
     /*  114229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114247 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114292), // Rule ID 51440 //
     /*  114252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114255 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114290 */     GIR_RootConstrainSelectedInstOperands,
     /*  114291 */     // GIR_Coverage, 51440,
     /*  114291 */     GIR_EraseRootFromParent_Done,
     /*  114292 */   // Label 1902: @114292
     /*  114292 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114337), // Rule ID 51441 //
     /*  114297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114300 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114335 */     GIR_RootConstrainSelectedInstOperands,
     /*  114336 */     // GIR_Coverage, 51441,
     /*  114336 */     GIR_EraseRootFromParent_Done,
     /*  114337 */   // Label 1903: @114337
     /*  114337 */   GIM_Reject,
     /*  114338 */ // Label 1901: @114338
     /*  114338 */ GIM_Reject,
     /*  114339 */ // Label 1855: @114339
     /*  114339 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114453),
     /*  114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114362 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114407), // Rule ID 51456 //
     /*  114367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114370 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114405 */     GIR_RootConstrainSelectedInstOperands,
     /*  114406 */     // GIR_Coverage, 51456,
     /*  114406 */     GIR_EraseRootFromParent_Done,
     /*  114407 */   // Label 1905: @114407
     /*  114407 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114452), // Rule ID 51457 //
     /*  114412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114415 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114450 */     GIR_RootConstrainSelectedInstOperands,
     /*  114451 */     // GIR_Coverage, 51457,
     /*  114451 */     GIR_EraseRootFromParent_Done,
     /*  114452 */   // Label 1906: @114452
     /*  114452 */   GIM_Reject,
     /*  114453 */ // Label 1904: @114453
     /*  114453 */ GIM_Reject,
     /*  114454 */ // Label 1856: @114454
     /*  114454 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114568),
     /*  114459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114477 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114522), // Rule ID 51400 //
     /*  114482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114485 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114520 */     GIR_RootConstrainSelectedInstOperands,
     /*  114521 */     // GIR_Coverage, 51400,
     /*  114521 */     GIR_EraseRootFromParent_Done,
     /*  114522 */   // Label 1908: @114522
     /*  114522 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114567), // Rule ID 51401 //
     /*  114527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114530 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114565 */     GIR_RootConstrainSelectedInstOperands,
     /*  114566 */     // GIR_Coverage, 51401,
     /*  114566 */     GIR_EraseRootFromParent_Done,
     /*  114567 */   // Label 1909: @114567
     /*  114567 */   GIM_Reject,
     /*  114568 */ // Label 1907: @114568
     /*  114568 */ GIM_Reject,
     /*  114569 */ // Label 1857: @114569
     /*  114569 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114683),
     /*  114574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  114577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  114580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114592 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114637), // Rule ID 51428 //
     /*  114597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114600 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114635 */     GIR_RootConstrainSelectedInstOperands,
     /*  114636 */     // GIR_Coverage, 51428,
     /*  114636 */     GIR_EraseRootFromParent_Done,
     /*  114637 */   // Label 1911: @114637
     /*  114637 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114682), // Rule ID 51429 //
     /*  114642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114645 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114680 */     GIR_RootConstrainSelectedInstOperands,
     /*  114681 */     // GIR_Coverage, 51429,
     /*  114681 */     GIR_EraseRootFromParent_Done,
     /*  114682 */   // Label 1912: @114682
     /*  114682 */   GIM_Reject,
     /*  114683 */ // Label 1910: @114683
     /*  114683 */ GIM_Reject,
     /*  114684 */ // Label 1858: @114684
     /*  114684 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114798),
     /*  114689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  114692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  114695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114707 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114752), // Rule ID 51444 //
     /*  114712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114715 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114750 */     GIR_RootConstrainSelectedInstOperands,
     /*  114751 */     // GIR_Coverage, 51444,
     /*  114751 */     GIR_EraseRootFromParent_Done,
     /*  114752 */   // Label 1914: @114752
     /*  114752 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(114797), // Rule ID 51445 //
     /*  114757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114760 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114795 */     GIR_RootConstrainSelectedInstOperands,
     /*  114796 */     // GIR_Coverage, 51445,
     /*  114796 */     GIR_EraseRootFromParent_Done,
     /*  114797 */   // Label 1915: @114797
     /*  114797 */   GIM_Reject,
     /*  114798 */ // Label 1913: @114798
     /*  114798 */ GIM_Reject,
     /*  114799 */ // Label 1859: @114799
     /*  114799 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(114913),
     /*  114804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  114807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  114810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114822 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(114867), // Rule ID 51460 //
     /*  114827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114830 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114865 */     GIR_RootConstrainSelectedInstOperands,
     /*  114866 */     // GIR_Coverage, 51460,
     /*  114866 */     GIR_EraseRootFromParent_Done,
     /*  114867 */   // Label 1917: @114867
     /*  114867 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(114912), // Rule ID 51461 //
     /*  114872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114875 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114910 */     GIR_RootConstrainSelectedInstOperands,
     /*  114911 */     // GIR_Coverage, 51461,
     /*  114911 */     GIR_EraseRootFromParent_Done,
     /*  114912 */   // Label 1918: @114912
     /*  114912 */   GIM_Reject,
     /*  114913 */ // Label 1916: @114913
     /*  114913 */ GIM_Reject,
     /*  114914 */ // Label 1860: @114914
     /*  114914 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115028),
     /*  114919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  114922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  114925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114937 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(114982), // Rule ID 51416 //
     /*  114942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114945 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  114962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114980 */     GIR_RootConstrainSelectedInstOperands,
     /*  114981 */     // GIR_Coverage, 51416,
     /*  114981 */     GIR_EraseRootFromParent_Done,
     /*  114982 */   // Label 1920: @114982
     /*  114982 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115027), // Rule ID 51417 //
     /*  114987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114990 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115025 */     GIR_RootConstrainSelectedInstOperands,
     /*  115026 */     // GIR_Coverage, 51417,
     /*  115026 */     GIR_EraseRootFromParent_Done,
     /*  115027 */   // Label 1921: @115027
     /*  115027 */   GIM_Reject,
     /*  115028 */ // Label 1919: @115028
     /*  115028 */ GIM_Reject,
     /*  115029 */ // Label 1861: @115029
     /*  115029 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115143),
     /*  115034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115052 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115097), // Rule ID 51432 //
     /*  115057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115060 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115095 */     GIR_RootConstrainSelectedInstOperands,
     /*  115096 */     // GIR_Coverage, 51432,
     /*  115096 */     GIR_EraseRootFromParent_Done,
     /*  115097 */   // Label 1923: @115097
     /*  115097 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115142), // Rule ID 51433 //
     /*  115102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115105 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115140 */     GIR_RootConstrainSelectedInstOperands,
     /*  115141 */     // GIR_Coverage, 51433,
     /*  115141 */     GIR_EraseRootFromParent_Done,
     /*  115142 */   // Label 1924: @115142
     /*  115142 */   GIM_Reject,
     /*  115143 */ // Label 1922: @115143
     /*  115143 */ GIM_Reject,
     /*  115144 */ // Label 1862: @115144
     /*  115144 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115258),
     /*  115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115167 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115212), // Rule ID 51448 //
     /*  115172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115175 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115210 */     GIR_RootConstrainSelectedInstOperands,
     /*  115211 */     // GIR_Coverage, 51448,
     /*  115211 */     GIR_EraseRootFromParent_Done,
     /*  115212 */   // Label 1926: @115212
     /*  115212 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115257), // Rule ID 51449 //
     /*  115217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115220 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115255 */     GIR_RootConstrainSelectedInstOperands,
     /*  115256 */     // GIR_Coverage, 51449,
     /*  115256 */     GIR_EraseRootFromParent_Done,
     /*  115257 */   // Label 1927: @115257
     /*  115257 */   GIM_Reject,
     /*  115258 */ // Label 1925: @115258
     /*  115258 */ GIM_Reject,
     /*  115259 */ // Label 1863: @115259
     /*  115259 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115373),
     /*  115264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115282 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115327), // Rule ID 51420 //
     /*  115287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115290 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115325 */     GIR_RootConstrainSelectedInstOperands,
     /*  115326 */     // GIR_Coverage, 51420,
     /*  115326 */     GIR_EraseRootFromParent_Done,
     /*  115327 */   // Label 1929: @115327
     /*  115327 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115372), // Rule ID 51421 //
     /*  115332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115335 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115370 */     GIR_RootConstrainSelectedInstOperands,
     /*  115371 */     // GIR_Coverage, 51421,
     /*  115371 */     GIR_EraseRootFromParent_Done,
     /*  115372 */   // Label 1930: @115372
     /*  115372 */   GIM_Reject,
     /*  115373 */ // Label 1928: @115373
     /*  115373 */ GIM_Reject,
     /*  115374 */ // Label 1864: @115374
     /*  115374 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115488),
     /*  115379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115397 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115442), // Rule ID 51436 //
     /*  115402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115405 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115440 */     GIR_RootConstrainSelectedInstOperands,
     /*  115441 */     // GIR_Coverage, 51436,
     /*  115441 */     GIR_EraseRootFromParent_Done,
     /*  115442 */   // Label 1932: @115442
     /*  115442 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115487), // Rule ID 51437 //
     /*  115447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115450 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115485 */     GIR_RootConstrainSelectedInstOperands,
     /*  115486 */     // GIR_Coverage, 51437,
     /*  115486 */     GIR_EraseRootFromParent_Done,
     /*  115487 */   // Label 1933: @115487
     /*  115487 */   GIM_Reject,
     /*  115488 */ // Label 1931: @115488
     /*  115488 */ GIM_Reject,
     /*  115489 */ // Label 1865: @115489
     /*  115489 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115603),
     /*  115494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115512 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115557), // Rule ID 51424 //
     /*  115517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115520 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115555 */     GIR_RootConstrainSelectedInstOperands,
     /*  115556 */     // GIR_Coverage, 51424,
     /*  115556 */     GIR_EraseRootFromParent_Done,
     /*  115557 */   // Label 1935: @115557
     /*  115557 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115602), // Rule ID 51425 //
     /*  115562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115565 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115600 */     GIR_RootConstrainSelectedInstOperands,
     /*  115601 */     // GIR_Coverage, 51425,
     /*  115601 */     GIR_EraseRootFromParent_Done,
     /*  115602 */   // Label 1936: @115602
     /*  115602 */   GIM_Reject,
     /*  115603 */ // Label 1934: @115603
     /*  115603 */ GIM_Reject,
     /*  115604 */ // Label 1866: @115604
     /*  115604 */ GIM_Reject,
     /*  115605 */ // Label 6: @115605
     /*  115605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(118338),
     /*  115616 */ /*GILLT_s32*//*Label 1937*/ GIMT_Encode4(115740),
     /*  115620 */ /*GILLT_s64*//*Label 1938*/ GIMT_Encode4(115774), GIMT_Encode4(0),
     /*  115628 */ /*GILLT_nxv1s8*//*Label 1939*/ GIMT_Encode4(115808),
     /*  115632 */ /*GILLT_nxv1s16*//*Label 1940*/ GIMT_Encode4(115923),
     /*  115636 */ /*GILLT_nxv1s32*//*Label 1941*/ GIMT_Encode4(116038),
     /*  115640 */ /*GILLT_nxv1s64*//*Label 1942*/ GIMT_Encode4(116153), GIMT_Encode4(0),
     /*  115648 */ /*GILLT_nxv2s8*//*Label 1943*/ GIMT_Encode4(116268),
     /*  115652 */ /*GILLT_nxv2s16*//*Label 1944*/ GIMT_Encode4(116383),
     /*  115656 */ /*GILLT_nxv2s32*//*Label 1945*/ GIMT_Encode4(116498),
     /*  115660 */ /*GILLT_nxv2s64*//*Label 1946*/ GIMT_Encode4(116613), GIMT_Encode4(0),
     /*  115668 */ /*GILLT_nxv4s8*//*Label 1947*/ GIMT_Encode4(116728),
     /*  115672 */ /*GILLT_nxv4s16*//*Label 1948*/ GIMT_Encode4(116843),
     /*  115676 */ /*GILLT_nxv4s32*//*Label 1949*/ GIMT_Encode4(116958),
     /*  115680 */ /*GILLT_nxv4s64*//*Label 1950*/ GIMT_Encode4(117073), GIMT_Encode4(0),
     /*  115688 */ /*GILLT_nxv8s8*//*Label 1951*/ GIMT_Encode4(117188),
     /*  115692 */ /*GILLT_nxv8s16*//*Label 1952*/ GIMT_Encode4(117303),
     /*  115696 */ /*GILLT_nxv8s32*//*Label 1953*/ GIMT_Encode4(117418),
     /*  115700 */ /*GILLT_nxv8s64*//*Label 1954*/ GIMT_Encode4(117533), GIMT_Encode4(0),
     /*  115708 */ /*GILLT_nxv16s8*//*Label 1955*/ GIMT_Encode4(117648),
     /*  115712 */ /*GILLT_nxv16s16*//*Label 1956*/ GIMT_Encode4(117763),
     /*  115716 */ /*GILLT_nxv16s32*//*Label 1957*/ GIMT_Encode4(117878), GIMT_Encode4(0),
     /*  115724 */ /*GILLT_nxv32s8*//*Label 1958*/ GIMT_Encode4(117993),
     /*  115728 */ /*GILLT_nxv32s16*//*Label 1959*/ GIMT_Encode4(118108), GIMT_Encode4(0),
     /*  115736 */ /*GILLT_nxv64s8*//*Label 1960*/ GIMT_Encode4(118223),
     /*  115740 */ // Label 1937: @115740
     /*  115740 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(115773), // Rule ID 304 //
     /*  115745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  115748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  115751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  115754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115766 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115771 */   GIR_RootConstrainSelectedInstOperands,
     /*  115772 */   // GIR_Coverage, 304,
     /*  115772 */   GIR_Done,
     /*  115773 */ // Label 1962: @115773
     /*  115773 */ GIM_Reject,
     /*  115774 */ // Label 1938: @115774
     /*  115774 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(115807), // Rule ID 303 //
     /*  115779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  115782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  115785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  115788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115800 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115805 */   GIR_RootConstrainSelectedInstOperands,
     /*  115806 */   // GIR_Coverage, 303,
     /*  115806 */   GIR_Done,
     /*  115807 */ // Label 1963: @115807
     /*  115807 */ GIM_Reject,
     /*  115808 */ // Label 1939: @115808
     /*  115808 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(115922),
     /*  115813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  115816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115831 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(115876), // Rule ID 51288 //
     /*  115836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115839 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115874 */     GIR_RootConstrainSelectedInstOperands,
     /*  115875 */     // GIR_Coverage, 51288,
     /*  115875 */     GIR_EraseRootFromParent_Done,
     /*  115876 */   // Label 1965: @115876
     /*  115876 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(115921), // Rule ID 51289 //
     /*  115881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115884 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115919 */     GIR_RootConstrainSelectedInstOperands,
     /*  115920 */     // GIR_Coverage, 51289,
     /*  115920 */     GIR_EraseRootFromParent_Done,
     /*  115921 */   // Label 1966: @115921
     /*  115921 */   GIM_Reject,
     /*  115922 */ // Label 1964: @115922
     /*  115922 */ GIM_Reject,
     /*  115923 */ // Label 1940: @115923
     /*  115923 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116037),
     /*  115928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  115931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  115934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115946 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(115991), // Rule ID 51300 //
     /*  115951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115954 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  115957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  115971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115989 */     GIR_RootConstrainSelectedInstOperands,
     /*  115990 */     // GIR_Coverage, 51300,
     /*  115990 */     GIR_EraseRootFromParent_Done,
     /*  115991 */   // Label 1968: @115991
     /*  115991 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116036), // Rule ID 51301 //
     /*  115996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115999 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116034 */     GIR_RootConstrainSelectedInstOperands,
     /*  116035 */     // GIR_Coverage, 51301,
     /*  116035 */     GIR_EraseRootFromParent_Done,
     /*  116036 */   // Label 1969: @116036
     /*  116036 */   GIM_Reject,
     /*  116037 */ // Label 1967: @116037
     /*  116037 */ GIM_Reject,
     /*  116038 */ // Label 1941: @116038
     /*  116038 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116152),
     /*  116043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116061 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116106), // Rule ID 51308 //
     /*  116066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116069 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116104 */     GIR_RootConstrainSelectedInstOperands,
     /*  116105 */     // GIR_Coverage, 51308,
     /*  116105 */     GIR_EraseRootFromParent_Done,
     /*  116106 */   // Label 1971: @116106
     /*  116106 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116151), // Rule ID 51309 //
     /*  116111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116114 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116149 */     GIR_RootConstrainSelectedInstOperands,
     /*  116150 */     // GIR_Coverage, 51309,
     /*  116150 */     GIR_EraseRootFromParent_Done,
     /*  116151 */   // Label 1972: @116151
     /*  116151 */   GIM_Reject,
     /*  116152 */ // Label 1970: @116152
     /*  116152 */ GIM_Reject,
     /*  116153 */ // Label 1942: @116153
     /*  116153 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116267),
     /*  116158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116176 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116221), // Rule ID 51324 //
     /*  116181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116184 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116219 */     GIR_RootConstrainSelectedInstOperands,
     /*  116220 */     // GIR_Coverage, 51324,
     /*  116220 */     GIR_EraseRootFromParent_Done,
     /*  116221 */   // Label 1974: @116221
     /*  116221 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116266), // Rule ID 51325 //
     /*  116226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116229 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116264 */     GIR_RootConstrainSelectedInstOperands,
     /*  116265 */     // GIR_Coverage, 51325,
     /*  116265 */     GIR_EraseRootFromParent_Done,
     /*  116266 */   // Label 1975: @116266
     /*  116266 */   GIM_Reject,
     /*  116267 */ // Label 1973: @116267
     /*  116267 */ GIM_Reject,
     /*  116268 */ // Label 1943: @116268
     /*  116268 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116382),
     /*  116273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116291 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116336), // Rule ID 51292 //
     /*  116296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116299 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116334 */     GIR_RootConstrainSelectedInstOperands,
     /*  116335 */     // GIR_Coverage, 51292,
     /*  116335 */     GIR_EraseRootFromParent_Done,
     /*  116336 */   // Label 1977: @116336
     /*  116336 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116381), // Rule ID 51293 //
     /*  116341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116344 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116379 */     GIR_RootConstrainSelectedInstOperands,
     /*  116380 */     // GIR_Coverage, 51293,
     /*  116380 */     GIR_EraseRootFromParent_Done,
     /*  116381 */   // Label 1978: @116381
     /*  116381 */   GIM_Reject,
     /*  116382 */ // Label 1976: @116382
     /*  116382 */ GIM_Reject,
     /*  116383 */ // Label 1944: @116383
     /*  116383 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116497),
     /*  116388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116406 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116451), // Rule ID 51304 //
     /*  116411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116414 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116449 */     GIR_RootConstrainSelectedInstOperands,
     /*  116450 */     // GIR_Coverage, 51304,
     /*  116450 */     GIR_EraseRootFromParent_Done,
     /*  116451 */   // Label 1980: @116451
     /*  116451 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116496), // Rule ID 51305 //
     /*  116456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116459 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116494 */     GIR_RootConstrainSelectedInstOperands,
     /*  116495 */     // GIR_Coverage, 51305,
     /*  116495 */     GIR_EraseRootFromParent_Done,
     /*  116496 */   // Label 1981: @116496
     /*  116496 */   GIM_Reject,
     /*  116497 */ // Label 1979: @116497
     /*  116497 */ GIM_Reject,
     /*  116498 */ // Label 1945: @116498
     /*  116498 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116612),
     /*  116503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116521 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116566), // Rule ID 51320 //
     /*  116526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116529 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116564 */     GIR_RootConstrainSelectedInstOperands,
     /*  116565 */     // GIR_Coverage, 51320,
     /*  116565 */     GIR_EraseRootFromParent_Done,
     /*  116566 */   // Label 1983: @116566
     /*  116566 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116611), // Rule ID 51321 //
     /*  116571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116574 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116609 */     GIR_RootConstrainSelectedInstOperands,
     /*  116610 */     // GIR_Coverage, 51321,
     /*  116610 */     GIR_EraseRootFromParent_Done,
     /*  116611 */   // Label 1984: @116611
     /*  116611 */   GIM_Reject,
     /*  116612 */ // Label 1982: @116612
     /*  116612 */ GIM_Reject,
     /*  116613 */ // Label 1946: @116613
     /*  116613 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116727),
     /*  116618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  116621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  116624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116636 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116681), // Rule ID 51364 //
     /*  116641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116644 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116679 */     GIR_RootConstrainSelectedInstOperands,
     /*  116680 */     // GIR_Coverage, 51364,
     /*  116680 */     GIR_EraseRootFromParent_Done,
     /*  116681 */   // Label 1986: @116681
     /*  116681 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116726), // Rule ID 51365 //
     /*  116686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116689 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116724 */     GIR_RootConstrainSelectedInstOperands,
     /*  116725 */     // GIR_Coverage, 51365,
     /*  116725 */     GIR_EraseRootFromParent_Done,
     /*  116726 */   // Label 1987: @116726
     /*  116726 */   GIM_Reject,
     /*  116727 */ // Label 1985: @116727
     /*  116727 */ GIM_Reject,
     /*  116728 */ // Label 1947: @116728
     /*  116728 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116842),
     /*  116733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  116736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  116739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116751 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116796), // Rule ID 51296 //
     /*  116756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116759 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116794 */     GIR_RootConstrainSelectedInstOperands,
     /*  116795 */     // GIR_Coverage, 51296,
     /*  116795 */     GIR_EraseRootFromParent_Done,
     /*  116796 */   // Label 1989: @116796
     /*  116796 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(116841), // Rule ID 51297 //
     /*  116801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116804 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116839 */     GIR_RootConstrainSelectedInstOperands,
     /*  116840 */     // GIR_Coverage, 51297,
     /*  116840 */     GIR_EraseRootFromParent_Done,
     /*  116841 */   // Label 1990: @116841
     /*  116841 */   GIM_Reject,
     /*  116842 */ // Label 1988: @116842
     /*  116842 */ GIM_Reject,
     /*  116843 */ // Label 1948: @116843
     /*  116843 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(116957),
     /*  116848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  116851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  116854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116866 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(116911), // Rule ID 51316 //
     /*  116871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116874 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116909 */     GIR_RootConstrainSelectedInstOperands,
     /*  116910 */     // GIR_Coverage, 51316,
     /*  116910 */     GIR_EraseRootFromParent_Done,
     /*  116911 */   // Label 1992: @116911
     /*  116911 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(116956), // Rule ID 51317 //
     /*  116916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116919 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116954 */     GIR_RootConstrainSelectedInstOperands,
     /*  116955 */     // GIR_Coverage, 51317,
     /*  116955 */     GIR_EraseRootFromParent_Done,
     /*  116956 */   // Label 1993: @116956
     /*  116956 */   GIM_Reject,
     /*  116957 */ // Label 1991: @116957
     /*  116957 */ GIM_Reject,
     /*  116958 */ // Label 1949: @116958
     /*  116958 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117072),
     /*  116963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  116966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  116969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116981 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117026), // Rule ID 51352 //
     /*  116986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116989 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  116992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117024 */     GIR_RootConstrainSelectedInstOperands,
     /*  117025 */     // GIR_Coverage, 51352,
     /*  117025 */     GIR_EraseRootFromParent_Done,
     /*  117026 */   // Label 1995: @117026
     /*  117026 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117071), // Rule ID 51353 //
     /*  117031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117034 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117069 */     GIR_RootConstrainSelectedInstOperands,
     /*  117070 */     // GIR_Coverage, 51353,
     /*  117070 */     GIR_EraseRootFromParent_Done,
     /*  117071 */   // Label 1996: @117071
     /*  117071 */   GIM_Reject,
     /*  117072 */ // Label 1994: @117072
     /*  117072 */ GIM_Reject,
     /*  117073 */ // Label 1950: @117073
     /*  117073 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117187),
     /*  117078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117096 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117141), // Rule ID 51368 //
     /*  117101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117104 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117139 */     GIR_RootConstrainSelectedInstOperands,
     /*  117140 */     // GIR_Coverage, 51368,
     /*  117140 */     GIR_EraseRootFromParent_Done,
     /*  117141 */   // Label 1998: @117141
     /*  117141 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117186), // Rule ID 51369 //
     /*  117146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117149 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117184 */     GIR_RootConstrainSelectedInstOperands,
     /*  117185 */     // GIR_Coverage, 51369,
     /*  117185 */     GIR_EraseRootFromParent_Done,
     /*  117186 */   // Label 1999: @117186
     /*  117186 */   GIM_Reject,
     /*  117187 */ // Label 1997: @117187
     /*  117187 */ GIM_Reject,
     /*  117188 */ // Label 1951: @117188
     /*  117188 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117302),
     /*  117193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117211 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117256), // Rule ID 51312 //
     /*  117216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117219 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117254 */     GIR_RootConstrainSelectedInstOperands,
     /*  117255 */     // GIR_Coverage, 51312,
     /*  117255 */     GIR_EraseRootFromParent_Done,
     /*  117256 */   // Label 2001: @117256
     /*  117256 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117301), // Rule ID 51313 //
     /*  117261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117264 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117299 */     GIR_RootConstrainSelectedInstOperands,
     /*  117300 */     // GIR_Coverage, 51313,
     /*  117300 */     GIR_EraseRootFromParent_Done,
     /*  117301 */   // Label 2002: @117301
     /*  117301 */   GIM_Reject,
     /*  117302 */ // Label 2000: @117302
     /*  117302 */ GIM_Reject,
     /*  117303 */ // Label 1952: @117303
     /*  117303 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117417),
     /*  117308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117326 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117371), // Rule ID 51340 //
     /*  117331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117334 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117369 */     GIR_RootConstrainSelectedInstOperands,
     /*  117370 */     // GIR_Coverage, 51340,
     /*  117370 */     GIR_EraseRootFromParent_Done,
     /*  117371 */   // Label 2004: @117371
     /*  117371 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117416), // Rule ID 51341 //
     /*  117376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117379 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117414 */     GIR_RootConstrainSelectedInstOperands,
     /*  117415 */     // GIR_Coverage, 51341,
     /*  117415 */     GIR_EraseRootFromParent_Done,
     /*  117416 */   // Label 2005: @117416
     /*  117416 */   GIM_Reject,
     /*  117417 */ // Label 2003: @117417
     /*  117417 */ GIM_Reject,
     /*  117418 */ // Label 1953: @117418
     /*  117418 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117532),
     /*  117423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117441 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117486), // Rule ID 51356 //
     /*  117446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117449 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117484 */     GIR_RootConstrainSelectedInstOperands,
     /*  117485 */     // GIR_Coverage, 51356,
     /*  117485 */     GIR_EraseRootFromParent_Done,
     /*  117486 */   // Label 2007: @117486
     /*  117486 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117531), // Rule ID 51357 //
     /*  117491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117494 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117529 */     GIR_RootConstrainSelectedInstOperands,
     /*  117530 */     // GIR_Coverage, 51357,
     /*  117530 */     GIR_EraseRootFromParent_Done,
     /*  117531 */   // Label 2008: @117531
     /*  117531 */   GIM_Reject,
     /*  117532 */ // Label 2006: @117532
     /*  117532 */ GIM_Reject,
     /*  117533 */ // Label 1954: @117533
     /*  117533 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117647),
     /*  117538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  117541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  117544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117556 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117601), // Rule ID 51372 //
     /*  117561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117564 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117599 */     GIR_RootConstrainSelectedInstOperands,
     /*  117600 */     // GIR_Coverage, 51372,
     /*  117600 */     GIR_EraseRootFromParent_Done,
     /*  117601 */   // Label 2010: @117601
     /*  117601 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117646), // Rule ID 51373 //
     /*  117606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117609 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117644 */     GIR_RootConstrainSelectedInstOperands,
     /*  117645 */     // GIR_Coverage, 51373,
     /*  117645 */     GIR_EraseRootFromParent_Done,
     /*  117646 */   // Label 2011: @117646
     /*  117646 */   GIM_Reject,
     /*  117647 */ // Label 2009: @117647
     /*  117647 */ GIM_Reject,
     /*  117648 */ // Label 1955: @117648
     /*  117648 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(117762),
     /*  117653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  117656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  117659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117671 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117716), // Rule ID 51328 //
     /*  117676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117679 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117714 */     GIR_RootConstrainSelectedInstOperands,
     /*  117715 */     // GIR_Coverage, 51328,
     /*  117715 */     GIR_EraseRootFromParent_Done,
     /*  117716 */   // Label 2013: @117716
     /*  117716 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117761), // Rule ID 51329 //
     /*  117721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117724 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117759 */     GIR_RootConstrainSelectedInstOperands,
     /*  117760 */     // GIR_Coverage, 51329,
     /*  117760 */     GIR_EraseRootFromParent_Done,
     /*  117761 */   // Label 2014: @117761
     /*  117761 */   GIM_Reject,
     /*  117762 */ // Label 2012: @117762
     /*  117762 */ GIM_Reject,
     /*  117763 */ // Label 1956: @117763
     /*  117763 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(117877),
     /*  117768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  117771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  117774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117786 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117831), // Rule ID 51344 //
     /*  117791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117794 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117829 */     GIR_RootConstrainSelectedInstOperands,
     /*  117830 */     // GIR_Coverage, 51344,
     /*  117830 */     GIR_EraseRootFromParent_Done,
     /*  117831 */   // Label 2016: @117831
     /*  117831 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117876), // Rule ID 51345 //
     /*  117836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117839 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117874 */     GIR_RootConstrainSelectedInstOperands,
     /*  117875 */     // GIR_Coverage, 51345,
     /*  117875 */     GIR_EraseRootFromParent_Done,
     /*  117876 */   // Label 2017: @117876
     /*  117876 */   GIM_Reject,
     /*  117877 */ // Label 2015: @117877
     /*  117877 */ GIM_Reject,
     /*  117878 */ // Label 1957: @117878
     /*  117878 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117992),
     /*  117883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  117886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  117889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117901 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117946), // Rule ID 51360 //
     /*  117906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117909 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117944 */     GIR_RootConstrainSelectedInstOperands,
     /*  117945 */     // GIR_Coverage, 51360,
     /*  117945 */     GIR_EraseRootFromParent_Done,
     /*  117946 */   // Label 2019: @117946
     /*  117946 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117991), // Rule ID 51361 //
     /*  117951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117954 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117989 */     GIR_RootConstrainSelectedInstOperands,
     /*  117990 */     // GIR_Coverage, 51361,
     /*  117990 */     GIR_EraseRootFromParent_Done,
     /*  117991 */   // Label 2020: @117991
     /*  117991 */   GIM_Reject,
     /*  117992 */ // Label 2018: @117992
     /*  117992 */ GIM_Reject,
     /*  117993 */ // Label 1958: @117993
     /*  117993 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118107),
     /*  117998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118016 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118061), // Rule ID 51332 //
     /*  118021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118024 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118059 */     GIR_RootConstrainSelectedInstOperands,
     /*  118060 */     // GIR_Coverage, 51332,
     /*  118060 */     GIR_EraseRootFromParent_Done,
     /*  118061 */   // Label 2022: @118061
     /*  118061 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118106), // Rule ID 51333 //
     /*  118066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118069 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118104 */     GIR_RootConstrainSelectedInstOperands,
     /*  118105 */     // GIR_Coverage, 51333,
     /*  118105 */     GIR_EraseRootFromParent_Done,
     /*  118106 */   // Label 2023: @118106
     /*  118106 */   GIM_Reject,
     /*  118107 */ // Label 2021: @118107
     /*  118107 */ GIM_Reject,
     /*  118108 */ // Label 1959: @118108
     /*  118108 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118222),
     /*  118113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118131 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118176), // Rule ID 51348 //
     /*  118136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118139 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118174 */     GIR_RootConstrainSelectedInstOperands,
     /*  118175 */     // GIR_Coverage, 51348,
     /*  118175 */     GIR_EraseRootFromParent_Done,
     /*  118176 */   // Label 2025: @118176
     /*  118176 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118221), // Rule ID 51349 //
     /*  118181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118184 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118219 */     GIR_RootConstrainSelectedInstOperands,
     /*  118220 */     // GIR_Coverage, 51349,
     /*  118220 */     GIR_EraseRootFromParent_Done,
     /*  118221 */   // Label 2026: @118221
     /*  118221 */   GIM_Reject,
     /*  118222 */ // Label 2024: @118222
     /*  118222 */ GIM_Reject,
     /*  118223 */ // Label 1960: @118223
     /*  118223 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118337),
     /*  118228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118246 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118291), // Rule ID 51336 //
     /*  118251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118254 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118289 */     GIR_RootConstrainSelectedInstOperands,
     /*  118290 */     // GIR_Coverage, 51336,
     /*  118290 */     GIR_EraseRootFromParent_Done,
     /*  118291 */   // Label 2028: @118291
     /*  118291 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118336), // Rule ID 51337 //
     /*  118296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118299 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118334 */     GIR_RootConstrainSelectedInstOperands,
     /*  118335 */     // GIR_Coverage, 51337,
     /*  118335 */     GIR_EraseRootFromParent_Done,
     /*  118336 */   // Label 2029: @118336
     /*  118336 */   GIM_Reject,
     /*  118337 */ // Label 2027: @118337
     /*  118337 */ GIM_Reject,
     /*  118338 */ // Label 1961: @118338
     /*  118338 */ GIM_Reject,
     /*  118339 */ // Label 7: @118339
     /*  118339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2061*/ GIMT_Encode4(127820),
     /*  118350 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(118474),
     /*  118354 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(119692),
     /*  118358 */ /*GILLT_nxv1s1*//*Label 2032*/ GIMT_Encode4(121013),
     /*  118362 */ /*GILLT_nxv1s8*//*Label 2033*/ GIMT_Encode4(121624),
     /*  118366 */ /*GILLT_nxv1s16*//*Label 2034*/ GIMT_Encode4(121739),
     /*  118370 */ /*GILLT_nxv1s32*//*Label 2035*/ GIMT_Encode4(121854),
     /*  118374 */ /*GILLT_nxv1s64*//*Label 2036*/ GIMT_Encode4(121969),
     /*  118378 */ /*GILLT_nxv2s1*//*Label 2037*/ GIMT_Encode4(122084),
     /*  118382 */ /*GILLT_nxv2s8*//*Label 2038*/ GIMT_Encode4(122695),
     /*  118386 */ /*GILLT_nxv2s16*//*Label 2039*/ GIMT_Encode4(122810),
     /*  118390 */ /*GILLT_nxv2s32*//*Label 2040*/ GIMT_Encode4(122925),
     /*  118394 */ /*GILLT_nxv2s64*//*Label 2041*/ GIMT_Encode4(123040),
     /*  118398 */ /*GILLT_nxv4s1*//*Label 2042*/ GIMT_Encode4(123155),
     /*  118402 */ /*GILLT_nxv4s8*//*Label 2043*/ GIMT_Encode4(123766),
     /*  118406 */ /*GILLT_nxv4s16*//*Label 2044*/ GIMT_Encode4(123881),
     /*  118410 */ /*GILLT_nxv4s32*//*Label 2045*/ GIMT_Encode4(123996),
     /*  118414 */ /*GILLT_nxv4s64*//*Label 2046*/ GIMT_Encode4(124111),
     /*  118418 */ /*GILLT_nxv8s1*//*Label 2047*/ GIMT_Encode4(124226),
     /*  118422 */ /*GILLT_nxv8s8*//*Label 2048*/ GIMT_Encode4(124837),
     /*  118426 */ /*GILLT_nxv8s16*//*Label 2049*/ GIMT_Encode4(124952),
     /*  118430 */ /*GILLT_nxv8s32*//*Label 2050*/ GIMT_Encode4(125067),
     /*  118434 */ /*GILLT_nxv8s64*//*Label 2051*/ GIMT_Encode4(125182),
     /*  118438 */ /*GILLT_nxv16s1*//*Label 2052*/ GIMT_Encode4(125297),
     /*  118442 */ /*GILLT_nxv16s8*//*Label 2053*/ GIMT_Encode4(125908),
     /*  118446 */ /*GILLT_nxv16s16*//*Label 2054*/ GIMT_Encode4(126023),
     /*  118450 */ /*GILLT_nxv16s32*//*Label 2055*/ GIMT_Encode4(126138),
     /*  118454 */ /*GILLT_nxv32s1*//*Label 2056*/ GIMT_Encode4(126253),
     /*  118458 */ /*GILLT_nxv32s8*//*Label 2057*/ GIMT_Encode4(126864),
     /*  118462 */ /*GILLT_nxv32s16*//*Label 2058*/ GIMT_Encode4(126979),
     /*  118466 */ /*GILLT_nxv64s1*//*Label 2059*/ GIMT_Encode4(127094),
     /*  118470 */ /*GILLT_nxv64s8*//*Label 2060*/ GIMT_Encode4(127705),
     /*  118474 */ // Label 2030: @118474
     /*  118474 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119691),
     /*  118479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118485 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(118574), // Rule ID 65237 //
     /*  118490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118538 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118558 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118572 */     GIR_RootConstrainSelectedInstOperands,
     /*  118573 */     // GIR_Coverage, 65237,
     /*  118573 */     GIR_EraseRootFromParent_Done,
     /*  118574 */   // Label 2063: @118574
     /*  118574 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(118663), // Rule ID 2536 //
     /*  118579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118623 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118627 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118647 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118661 */     GIR_RootConstrainSelectedInstOperands,
     /*  118662 */     // GIR_Coverage, 2536,
     /*  118662 */     GIR_EraseRootFromParent_Done,
     /*  118663 */   // Label 2064: @118663
     /*  118663 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(118742), // Rule ID 2463 //
     /*  118668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118707 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118728 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118740 */     GIR_RootConstrainSelectedInstOperands,
     /*  118741 */     // GIR_Coverage, 2463,
     /*  118741 */     GIR_EraseRootFromParent_Done,
     /*  118742 */   // Label 2065: @118742
     /*  118742 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(118821), // Rule ID 65225 //
     /*  118747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118807 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118819 */     GIR_RootConstrainSelectedInstOperands,
     /*  118820 */     // GIR_Coverage, 65225,
     /*  118820 */     GIR_EraseRootFromParent_Done,
     /*  118821 */   // Label 2066: @118821
     /*  118821 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(118886), // Rule ID 2483 //
     /*  118826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118866 */     // MIs[2] Operand 1
     /*  118866 */     // No operand predicates
     /*  118866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118872 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  118875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118884 */     GIR_RootConstrainSelectedInstOperands,
     /*  118885 */     // GIR_Coverage, 2483,
     /*  118885 */     GIR_EraseRootFromParent_Done,
     /*  118886 */   // Label 2067: @118886
     /*  118886 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(118951), // Rule ID 62565 //
     /*  118891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  118894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118931 */     // MIs[2] Operand 1
     /*  118931 */     // No operand predicates
     /*  118931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118937 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  118940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118949 */     GIR_RootConstrainSelectedInstOperands,
     /*  118950 */     // GIR_Coverage, 62565,
     /*  118950 */     GIR_EraseRootFromParent_Done,
     /*  118951 */   // Label 2068: @118951
     /*  118951 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119013), // Rule ID 2471 //
     /*  118956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  118990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118997 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119011 */     GIR_RootConstrainSelectedInstOperands,
     /*  119012 */     // GIR_Coverage, 2471,
     /*  119012 */     GIR_EraseRootFromParent_Done,
     /*  119013 */   // Label 2069: @119013
     /*  119013 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119069), // Rule ID 2465 //
     /*  119018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119056 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119067 */     GIR_RootConstrainSelectedInstOperands,
     /*  119068 */     // GIR_Coverage, 2465,
     /*  119068 */     GIR_EraseRootFromParent_Done,
     /*  119069 */   // Label 2070: @119069
     /*  119069 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119125), // Rule ID 65211 //
     /*  119074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119112 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119123 */     GIR_RootConstrainSelectedInstOperands,
     /*  119124 */     // GIR_Coverage, 65211,
     /*  119124 */     GIR_EraseRootFromParent_Done,
     /*  119125 */   // Label 2071: @119125
     /*  119125 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119181), // Rule ID 65227 //
     /*  119130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119157 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119168 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119179 */     GIR_RootConstrainSelectedInstOperands,
     /*  119180 */     // GIR_Coverage, 65227,
     /*  119180 */     GIR_EraseRootFromParent_Done,
     /*  119181 */   // Label 2072: @119181
     /*  119181 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119237), // Rule ID 2439 //
     /*  119186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119224 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119235 */     GIR_RootConstrainSelectedInstOperands,
     /*  119236 */     // GIR_Coverage, 2439,
     /*  119236 */     GIR_EraseRootFromParent_Done,
     /*  119237 */   // Label 2073: @119237
     /*  119237 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119273), // Rule ID 64466 //
     /*  119242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119253 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119264 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119271 */     GIR_RootConstrainSelectedInstOperands,
     /*  119272 */     // GIR_Coverage, 64466,
     /*  119272 */     GIR_EraseRootFromParent_Done,
     /*  119273 */   // Label 2074: @119273
     /*  119273 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119309), // Rule ID 64468 //
     /*  119278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119289 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119300 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119307 */     GIR_RootConstrainSelectedInstOperands,
     /*  119308 */     // GIR_Coverage, 64468,
     /*  119308 */     GIR_EraseRootFromParent_Done,
     /*  119309 */   // Label 2075: @119309
     /*  119309 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119345), // Rule ID 2547 //
     /*  119314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119325 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119336 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119343 */     GIR_RootConstrainSelectedInstOperands,
     /*  119344 */     // GIR_Coverage, 2547,
     /*  119344 */     GIR_EraseRootFromParent_Done,
     /*  119345 */   // Label 2076: @119345
     /*  119345 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119381), // Rule ID 2548 //
     /*  119350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119361 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119372 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119379 */     GIR_RootConstrainSelectedInstOperands,
     /*  119380 */     // GIR_Coverage, 2548,
     /*  119380 */     GIR_EraseRootFromParent_Done,
     /*  119381 */   // Label 2077: @119381
     /*  119381 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119423), // Rule ID 2550 //
     /*  119386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119397 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119408 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119421 */     GIR_RootConstrainSelectedInstOperands,
     /*  119422 */     // GIR_Coverage, 2550,
     /*  119422 */     GIR_EraseRootFromParent_Done,
     /*  119423 */   // Label 2078: @119423
     /*  119423 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119465), // Rule ID 2551 //
     /*  119428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119439 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119450 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119463 */     GIR_RootConstrainSelectedInstOperands,
     /*  119464 */     // GIR_Coverage, 2551,
     /*  119464 */     GIR_EraseRootFromParent_Done,
     /*  119465 */   // Label 2079: @119465
     /*  119465 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119507), // Rule ID 85 //
     /*  119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  119493 */     // MIs[1] Operand 1
     /*  119493 */     // No operand predicates
     /*  119493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119495 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  119495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  119498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119505 */     GIR_RootConstrainSelectedInstOperands,
     /*  119506 */     // GIR_Coverage, 85,
     /*  119506 */     GIR_EraseRootFromParent_Done,
     /*  119507 */   // Label 2080: @119507
     /*  119507 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119579), // Rule ID 103 //
     /*  119512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119531 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  119535 */     // MIs[1] Operand 1
     /*  119535 */     // No operand predicates
     /*  119535 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9944),
     /*  119539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119541 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9944>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  119541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  119544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  119548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  119557 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  119562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  119567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119572 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  119577 */     GIR_RootConstrainSelectedInstOperands,
     /*  119578 */     // GIR_Coverage, 103,
     /*  119578 */     GIR_EraseRootFromParent_Done,
     /*  119579 */   // Label 2081: @119579
     /*  119579 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119621), // Rule ID 64519 //
     /*  119584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  119587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  119607 */     // MIs[1] Operand 1
     /*  119607 */     // No operand predicates
     /*  119607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119609 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  119609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  119612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  119614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119619 */     GIR_RootConstrainSelectedInstOperands,
     /*  119620 */     // GIR_Coverage, 64519,
     /*  119620 */     GIR_EraseRootFromParent_Done,
     /*  119621 */   // Label 2082: @119621
     /*  119621 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119663), // Rule ID 64523 //
     /*  119626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  119629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  119649 */     // MIs[1] Operand 1
     /*  119649 */     // No operand predicates
     /*  119649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119651 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  119651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  119654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119661 */     GIR_RootConstrainSelectedInstOperands,
     /*  119662 */     // GIR_Coverage, 64523,
     /*  119662 */     GIR_EraseRootFromParent_Done,
     /*  119663 */   // Label 2083: @119663
     /*  119663 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119690), // Rule ID 83 //
     /*  119668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119683 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  119688 */     GIR_RootConstrainSelectedInstOperands,
     /*  119689 */     // GIR_Coverage, 83,
     /*  119689 */     GIR_Done,
     /*  119690 */   // Label 2084: @119690
     /*  119690 */   GIM_Reject,
     /*  119691 */ // Label 2062: @119691
     /*  119691 */ GIM_Reject,
     /*  119692 */ // Label 2031: @119692
     /*  119692 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121012),
     /*  119697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  119700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  119703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119707 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119792), // Rule ID 65236 //
     /*  119712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  119715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119756 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119776 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119790 */     GIR_RootConstrainSelectedInstOperands,
     /*  119791 */     // GIR_Coverage, 65236,
     /*  119791 */     GIR_EraseRootFromParent_Done,
     /*  119792 */   // Label 2086: @119792
     /*  119792 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(119877), // Rule ID 2535 //
     /*  119797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  119800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  119808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  119841 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  119861 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  119864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  119871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  119875 */     GIR_RootConstrainSelectedInstOperands,
     /*  119876 */     // GIR_Coverage, 2535,
     /*  119876 */     GIR_EraseRootFromParent_Done,
     /*  119877 */   // Label 2087: @119877
     /*  119877 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(119952), // Rule ID 2462 //
     /*  119882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  119885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  119921 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  119938 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119950 */     GIR_RootConstrainSelectedInstOperands,
     /*  119951 */     // GIR_Coverage, 2462,
     /*  119951 */     GIR_EraseRootFromParent_Done,
     /*  119952 */   // Label 2088: @119952
     /*  119952 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(120027), // Rule ID 65224 //
     /*  119957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  119960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  119976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  119980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  119988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  119996 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120013 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120025 */     GIR_RootConstrainSelectedInstOperands,
     /*  120026 */     // GIR_Coverage, 65224,
     /*  120026 */     GIR_EraseRootFromParent_Done,
     /*  120027 */   // Label 2089: @120027
     /*  120027 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(120088), // Rule ID 2482 //
     /*  120032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120068 */     // MIs[2] Operand 1
     /*  120068 */     // No operand predicates
     /*  120068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120074 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  120077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120086 */     GIR_RootConstrainSelectedInstOperands,
     /*  120087 */     // GIR_Coverage, 2482,
     /*  120087 */     GIR_EraseRootFromParent_Done,
     /*  120088 */   // Label 2090: @120088
     /*  120088 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(120149), // Rule ID 62564 //
     /*  120093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  120096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120129 */     // MIs[2] Operand 1
     /*  120129 */     // No operand predicates
     /*  120129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120135 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  120138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120147 */     GIR_RootConstrainSelectedInstOperands,
     /*  120148 */     // GIR_Coverage, 62564,
     /*  120148 */     GIR_EraseRootFromParent_Done,
     /*  120149 */   // Label 2091: @120149
     /*  120149 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(120207), // Rule ID 2470 //
     /*  120154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120191 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  120194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120205 */     GIR_RootConstrainSelectedInstOperands,
     /*  120206 */     // GIR_Coverage, 2470,
     /*  120206 */     GIR_EraseRootFromParent_Done,
     /*  120207 */   // Label 2092: @120207
     /*  120207 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120259), // Rule ID 2464 //
     /*  120212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120246 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120257 */     GIR_RootConstrainSelectedInstOperands,
     /*  120258 */     // GIR_Coverage, 2464,
     /*  120258 */     GIR_EraseRootFromParent_Done,
     /*  120259 */   // Label 2093: @120259
     /*  120259 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120311), // Rule ID 65210 //
     /*  120264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120298 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120309 */     GIR_RootConstrainSelectedInstOperands,
     /*  120310 */     // GIR_Coverage, 65210,
     /*  120310 */     GIR_EraseRootFromParent_Done,
     /*  120311 */   // Label 2094: @120311
     /*  120311 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120363), // Rule ID 65226 //
     /*  120316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120350 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120361 */     GIR_RootConstrainSelectedInstOperands,
     /*  120362 */     // GIR_Coverage, 65226,
     /*  120362 */     GIR_EraseRootFromParent_Done,
     /*  120363 */   // Label 2095: @120363
     /*  120363 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120415), // Rule ID 2438 //
     /*  120368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120402 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120413 */     GIR_RootConstrainSelectedInstOperands,
     /*  120414 */     // GIR_Coverage, 2438,
     /*  120414 */     GIR_EraseRootFromParent_Done,
     /*  120415 */   // Label 2096: @120415
     /*  120415 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(120447), // Rule ID 64465 //
     /*  120420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120427 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120438 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  120441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120445 */     GIR_RootConstrainSelectedInstOperands,
     /*  120446 */     // GIR_Coverage, 64465,
     /*  120446 */     GIR_EraseRootFromParent_Done,
     /*  120447 */   // Label 2097: @120447
     /*  120447 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120479), // Rule ID 64467 //
     /*  120452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120459 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120470 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  120473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120477 */     GIR_RootConstrainSelectedInstOperands,
     /*  120478 */     // GIR_Coverage, 64467,
     /*  120478 */     GIR_EraseRootFromParent_Done,
     /*  120479 */   // Label 2098: @120479
     /*  120479 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120536), // Rule ID 252 //
     /*  120484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  120487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120491 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120502 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  120502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  120518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  120521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  120534 */     GIR_RootConstrainSelectedInstOperands,
     /*  120535 */     // GIR_Coverage, 252,
     /*  120535 */     GIR_EraseRootFromParent_Done,
     /*  120536 */   // Label 2099: @120536
     /*  120536 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120568), // Rule ID 2549 //
     /*  120541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  120544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120548 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120559 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  120559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  120562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120566 */     GIR_RootConstrainSelectedInstOperands,
     /*  120567 */     // GIR_Coverage, 2549,
     /*  120567 */     GIR_EraseRootFromParent_Done,
     /*  120568 */   // Label 2100: @120568
     /*  120568 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120606), // Rule ID 2552 //
     /*  120573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  120576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120591 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  120594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120604 */     GIR_RootConstrainSelectedInstOperands,
     /*  120605 */     // GIR_Coverage, 2552,
     /*  120605 */     GIR_EraseRootFromParent_Done,
     /*  120606 */   // Label 2101: @120606
     /*  120606 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120644), // Rule ID 2593 //
     /*  120611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  120614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120618 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120629 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  120632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120642 */     GIR_RootConstrainSelectedInstOperands,
     /*  120643 */     // GIR_Coverage, 2593,
     /*  120643 */     GIR_EraseRootFromParent_Done,
     /*  120644 */   // Label 2102: @120644
     /*  120644 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(120682), // Rule ID 64977 //
     /*  120649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  120652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120656 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120667 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  120667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  120670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  120674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  120680 */     GIR_RootConstrainSelectedInstOperands,
     /*  120681 */     // GIR_Coverage, 64977,
     /*  120681 */     GIR_EraseRootFromParent_Done,
     /*  120682 */   // Label 2103: @120682
     /*  120682 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120720), // Rule ID 84 //
     /*  120687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  120706 */     // MIs[1] Operand 1
     /*  120706 */     // No operand predicates
     /*  120706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120708 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  120708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  120711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120718 */     GIR_RootConstrainSelectedInstOperands,
     /*  120719 */     // GIR_Coverage, 84,
     /*  120719 */     GIR_EraseRootFromParent_Done,
     /*  120720 */   // Label 2104: @120720
     /*  120720 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120788), // Rule ID 101 //
     /*  120725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  120744 */     // MIs[1] Operand 1
     /*  120744 */     // No operand predicates
     /*  120744 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9942),
     /*  120748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120750 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9942>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120766 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120781 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120786 */     GIR_RootConstrainSelectedInstOperands,
     /*  120787 */     // GIR_Coverage, 101,
     /*  120787 */     GIR_EraseRootFromParent_Done,
     /*  120788 */   // Label 2105: @120788
     /*  120788 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120856), // Rule ID 102 //
     /*  120793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120808 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120812 */     // MIs[1] Operand 1
     /*  120812 */     // No operand predicates
     /*  120812 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9944),
     /*  120816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120818 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9944>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120834 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120854 */     GIR_RootConstrainSelectedInstOperands,
     /*  120855 */     // GIR_Coverage, 102,
     /*  120855 */     GIR_EraseRootFromParent_Done,
     /*  120856 */   // Label 2106: @120856
     /*  120856 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120924), // Rule ID 254 //
     /*  120861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  120864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  120880 */     // MIs[1] Operand 1
     /*  120880 */     // No operand predicates
     /*  120880 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10032),
     /*  120884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120886 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10032>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  120886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  120893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120902 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120917 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120922 */     GIR_RootConstrainSelectedInstOperands,
     /*  120923 */     // GIR_Coverage, 254,
     /*  120923 */     GIR_EraseRootFromParent_Done,
     /*  120924 */   // Label 2107: @120924
     /*  120924 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(120988), // Rule ID 2612 //
     /*  120929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  120932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120944 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  120948 */     // MIs[1] Operand 1
     /*  120948 */     // No operand predicates
     /*  120948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120950 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  120950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  120966 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  120976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120981 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  120986 */     GIR_RootConstrainSelectedInstOperands,
     /*  120987 */     // GIR_Coverage, 2612,
     /*  120987 */     GIR_EraseRootFromParent_Done,
     /*  120988 */   // Label 2108: @120988
     /*  120988 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(121011), // Rule ID 82 //
     /*  120993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  120996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121004 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121009 */     GIR_RootConstrainSelectedInstOperands,
     /*  121010 */     // GIR_Coverage, 82,
     /*  121010 */     GIR_Done,
     /*  121011 */   // Label 2109: @121011
     /*  121011 */   GIM_Reject,
     /*  121012 */ // Label 2085: @121012
     /*  121012 */ GIM_Reject,
     /*  121013 */ // Label 2032: @121013
     /*  121013 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(121623),
     /*  121018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121028 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121094), // Rule ID 71434 //
     /*  121033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121075 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121092 */     GIR_RootConstrainSelectedInstOperands,
     /*  121093 */     // GIR_Coverage, 71434,
     /*  121093 */     GIR_EraseRootFromParent_Done,
     /*  121094 */   // Label 2111: @121094
     /*  121094 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121160), // Rule ID 71435 //
     /*  121099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121141 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121158 */     GIR_RootConstrainSelectedInstOperands,
     /*  121159 */     // GIR_Coverage, 71435,
     /*  121159 */     GIR_EraseRootFromParent_Done,
     /*  121160 */   // Label 2112: @121160
     /*  121160 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121226), // Rule ID 71432 //
     /*  121165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121207 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121224 */     GIR_RootConstrainSelectedInstOperands,
     /*  121225 */     // GIR_Coverage, 71432,
     /*  121225 */     GIR_EraseRootFromParent_Done,
     /*  121226 */   // Label 2113: @121226
     /*  121226 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121292), // Rule ID 71433 //
     /*  121231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121273 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121290 */     GIR_RootConstrainSelectedInstOperands,
     /*  121291 */     // GIR_Coverage, 71433,
     /*  121291 */     GIR_EraseRootFromParent_Done,
     /*  121292 */   // Label 2114: @121292
     /*  121292 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121358), // Rule ID 71430 //
     /*  121297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121339 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121356 */     GIR_RootConstrainSelectedInstOperands,
     /*  121357 */     // GIR_Coverage, 71430,
     /*  121357 */     GIR_EraseRootFromParent_Done,
     /*  121358 */   // Label 2115: @121358
     /*  121358 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121424), // Rule ID 71431 //
     /*  121363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121405 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121422 */     GIR_RootConstrainSelectedInstOperands,
     /*  121423 */     // GIR_Coverage, 71431,
     /*  121423 */     GIR_EraseRootFromParent_Done,
     /*  121424 */   // Label 2116: @121424
     /*  121424 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121490), // Rule ID 53164 //
     /*  121429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121471 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121488 */     GIR_RootConstrainSelectedInstOperands,
     /*  121489 */     // GIR_Coverage, 53164,
     /*  121489 */     GIR_EraseRootFromParent_Done,
     /*  121490 */   // Label 2117: @121490
     /*  121490 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121556), // Rule ID 53165 //
     /*  121495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121537 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121554 */     GIR_RootConstrainSelectedInstOperands,
     /*  121555 */     // GIR_Coverage, 53165,
     /*  121555 */     GIR_EraseRootFromParent_Done,
     /*  121556 */   // Label 2118: @121556
     /*  121556 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121589), // Rule ID 53152 //
     /*  121561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121572 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  121575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121587 */     GIR_RootConstrainSelectedInstOperands,
     /*  121588 */     // GIR_Coverage, 53152,
     /*  121588 */     GIR_EraseRootFromParent_Done,
     /*  121589 */   // Label 2119: @121589
     /*  121589 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121622), // Rule ID 53153 //
     /*  121594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121605 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  121608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121620 */     GIR_RootConstrainSelectedInstOperands,
     /*  121621 */     // GIR_Coverage, 53153,
     /*  121621 */     GIR_EraseRootFromParent_Done,
     /*  121622 */   // Label 2120: @121622
     /*  121622 */   GIM_Reject,
     /*  121623 */ // Label 2110: @121623
     /*  121623 */ GIM_Reject,
     /*  121624 */ // Label 2033: @121624
     /*  121624 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121738),
     /*  121629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  121632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  121635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121647 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(121692), // Rule ID 47644 //
     /*  121652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121655 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  121655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  121658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  121672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121690 */     GIR_RootConstrainSelectedInstOperands,
     /*  121691 */     // GIR_Coverage, 47644,
     /*  121691 */     GIR_EraseRootFromParent_Done,
     /*  121692 */   // Label 2122: @121692
     /*  121692 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121737), // Rule ID 47645 //
     /*  121697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121700 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  121700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  121703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  121717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121735 */     GIR_RootConstrainSelectedInstOperands,
     /*  121736 */     // GIR_Coverage, 47645,
     /*  121736 */     GIR_EraseRootFromParent_Done,
     /*  121737 */   // Label 2123: @121737
     /*  121737 */   GIM_Reject,
     /*  121738 */ // Label 2121: @121738
     /*  121738 */ GIM_Reject,
     /*  121739 */ // Label 2034: @121739
     /*  121739 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121853),
     /*  121744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  121747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  121750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121762 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121807), // Rule ID 47656 //
     /*  121767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121770 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  121770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  121773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  121787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121805 */     GIR_RootConstrainSelectedInstOperands,
     /*  121806 */     // GIR_Coverage, 47656,
     /*  121806 */     GIR_EraseRootFromParent_Done,
     /*  121807 */   // Label 2125: @121807
     /*  121807 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121852), // Rule ID 47657 //
     /*  121812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121815 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  121815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  121818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  121832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121850 */     GIR_RootConstrainSelectedInstOperands,
     /*  121851 */     // GIR_Coverage, 47657,
     /*  121851 */     GIR_EraseRootFromParent_Done,
     /*  121852 */   // Label 2126: @121852
     /*  121852 */   GIM_Reject,
     /*  121853 */ // Label 2124: @121853
     /*  121853 */ GIM_Reject,
     /*  121854 */ // Label 2035: @121854
     /*  121854 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121968),
     /*  121859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  121862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  121865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121877 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(121922), // Rule ID 47664 //
     /*  121882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121885 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  121885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  121888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  121902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  121917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121920 */     GIR_RootConstrainSelectedInstOperands,
     /*  121921 */     // GIR_Coverage, 47664,
     /*  121921 */     GIR_EraseRootFromParent_Done,
     /*  121922 */   // Label 2128: @121922
     /*  121922 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(121967), // Rule ID 47665 //
     /*  121927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121930 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  121930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  121933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  121947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  121962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121965 */     GIR_RootConstrainSelectedInstOperands,
     /*  121966 */     // GIR_Coverage, 47665,
     /*  121966 */     GIR_EraseRootFromParent_Done,
     /*  121967 */   // Label 2129: @121967
     /*  121967 */   GIM_Reject,
     /*  121968 */ // Label 2127: @121968
     /*  121968 */ GIM_Reject,
     /*  121969 */ // Label 2036: @121969
     /*  121969 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122083),
     /*  121974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  121977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  121980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121992 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122037), // Rule ID 47680 //
     /*  121997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122000 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122035 */     GIR_RootConstrainSelectedInstOperands,
     /*  122036 */     // GIR_Coverage, 47680,
     /*  122036 */     GIR_EraseRootFromParent_Done,
     /*  122037 */   // Label 2131: @122037
     /*  122037 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122082), // Rule ID 47681 //
     /*  122042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122045 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122080 */     GIR_RootConstrainSelectedInstOperands,
     /*  122081 */     // GIR_Coverage, 47681,
     /*  122081 */     GIR_EraseRootFromParent_Done,
     /*  122082 */   // Label 2132: @122082
     /*  122082 */   GIM_Reject,
     /*  122083 */ // Label 2130: @122083
     /*  122083 */ GIM_Reject,
     /*  122084 */ // Label 2037: @122084
     /*  122084 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122694),
     /*  122089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122099 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122165), // Rule ID 71462 //
     /*  122104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122146 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122163 */     GIR_RootConstrainSelectedInstOperands,
     /*  122164 */     // GIR_Coverage, 71462,
     /*  122164 */     GIR_EraseRootFromParent_Done,
     /*  122165 */   // Label 2134: @122165
     /*  122165 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122231), // Rule ID 71463 //
     /*  122170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122212 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122229 */     GIR_RootConstrainSelectedInstOperands,
     /*  122230 */     // GIR_Coverage, 71463,
     /*  122230 */     GIR_EraseRootFromParent_Done,
     /*  122231 */   // Label 2135: @122231
     /*  122231 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122297), // Rule ID 71460 //
     /*  122236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122278 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122295 */     GIR_RootConstrainSelectedInstOperands,
     /*  122296 */     // GIR_Coverage, 71460,
     /*  122296 */     GIR_EraseRootFromParent_Done,
     /*  122297 */   // Label 2136: @122297
     /*  122297 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122363), // Rule ID 71461 //
     /*  122302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122344 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122361 */     GIR_RootConstrainSelectedInstOperands,
     /*  122362 */     // GIR_Coverage, 71461,
     /*  122362 */     GIR_EraseRootFromParent_Done,
     /*  122363 */   // Label 2137: @122363
     /*  122363 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122429), // Rule ID 71458 //
     /*  122368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122410 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122427 */     GIR_RootConstrainSelectedInstOperands,
     /*  122428 */     // GIR_Coverage, 71458,
     /*  122428 */     GIR_EraseRootFromParent_Done,
     /*  122429 */   // Label 2138: @122429
     /*  122429 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122495), // Rule ID 71459 //
     /*  122434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122476 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122493 */     GIR_RootConstrainSelectedInstOperands,
     /*  122494 */     // GIR_Coverage, 71459,
     /*  122494 */     GIR_EraseRootFromParent_Done,
     /*  122495 */   // Label 2139: @122495
     /*  122495 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122561), // Rule ID 53182 //
     /*  122500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122542 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122559 */     GIR_RootConstrainSelectedInstOperands,
     /*  122560 */     // GIR_Coverage, 53182,
     /*  122560 */     GIR_EraseRootFromParent_Done,
     /*  122561 */   // Label 2140: @122561
     /*  122561 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122627), // Rule ID 53183 //
     /*  122566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122608 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122625 */     GIR_RootConstrainSelectedInstOperands,
     /*  122626 */     // GIR_Coverage, 53183,
     /*  122626 */     GIR_EraseRootFromParent_Done,
     /*  122627 */   // Label 2141: @122627
     /*  122627 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122660), // Rule ID 53170 //
     /*  122632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122643 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  122646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122658 */     GIR_RootConstrainSelectedInstOperands,
     /*  122659 */     // GIR_Coverage, 53170,
     /*  122659 */     GIR_EraseRootFromParent_Done,
     /*  122660 */   // Label 2142: @122660
     /*  122660 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122693), // Rule ID 53171 //
     /*  122665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122676 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  122679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122691 */     GIR_RootConstrainSelectedInstOperands,
     /*  122692 */     // GIR_Coverage, 53171,
     /*  122692 */     GIR_EraseRootFromParent_Done,
     /*  122693 */   // Label 2143: @122693
     /*  122693 */   GIM_Reject,
     /*  122694 */ // Label 2133: @122694
     /*  122694 */ GIM_Reject,
     /*  122695 */ // Label 2038: @122695
     /*  122695 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122809),
     /*  122700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  122703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  122706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122718 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(122763), // Rule ID 47648 //
     /*  122723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122726 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  122729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122761 */     GIR_RootConstrainSelectedInstOperands,
     /*  122762 */     // GIR_Coverage, 47648,
     /*  122762 */     GIR_EraseRootFromParent_Done,
     /*  122763 */   // Label 2145: @122763
     /*  122763 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122808), // Rule ID 47649 //
     /*  122768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122771 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  122774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122806 */     GIR_RootConstrainSelectedInstOperands,
     /*  122807 */     // GIR_Coverage, 47649,
     /*  122807 */     GIR_EraseRootFromParent_Done,
     /*  122808 */   // Label 2146: @122808
     /*  122808 */   GIM_Reject,
     /*  122809 */ // Label 2144: @122809
     /*  122809 */ GIM_Reject,
     /*  122810 */ // Label 2039: @122810
     /*  122810 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122924),
     /*  122815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  122818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  122821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122833 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(122878), // Rule ID 47660 //
     /*  122838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122841 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  122844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122876 */     GIR_RootConstrainSelectedInstOperands,
     /*  122877 */     // GIR_Coverage, 47660,
     /*  122877 */     GIR_EraseRootFromParent_Done,
     /*  122878 */   // Label 2148: @122878
     /*  122878 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122923), // Rule ID 47661 //
     /*  122883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122886 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  122889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122921 */     GIR_RootConstrainSelectedInstOperands,
     /*  122922 */     // GIR_Coverage, 47661,
     /*  122922 */     GIR_EraseRootFromParent_Done,
     /*  122923 */   // Label 2149: @122923
     /*  122923 */   GIM_Reject,
     /*  122924 */ // Label 2147: @122924
     /*  122924 */ GIM_Reject,
     /*  122925 */ // Label 2040: @122925
     /*  122925 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(123039),
     /*  122930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  122933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  122936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122948 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(122993), // Rule ID 47676 //
     /*  122953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122956 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  122959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122991 */     GIR_RootConstrainSelectedInstOperands,
     /*  122992 */     // GIR_Coverage, 47676,
     /*  122992 */     GIR_EraseRootFromParent_Done,
     /*  122993 */   // Label 2151: @122993
     /*  122993 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123038), // Rule ID 47677 //
     /*  122998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123001 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123036 */     GIR_RootConstrainSelectedInstOperands,
     /*  123037 */     // GIR_Coverage, 47677,
     /*  123037 */     GIR_EraseRootFromParent_Done,
     /*  123038 */   // Label 2152: @123038
     /*  123038 */   GIM_Reject,
     /*  123039 */ // Label 2150: @123039
     /*  123039 */ GIM_Reject,
     /*  123040 */ // Label 2041: @123040
     /*  123040 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123154),
     /*  123045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  123051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123063 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123108), // Rule ID 47720 //
     /*  123068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  123071 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  123071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123106 */     GIR_RootConstrainSelectedInstOperands,
     /*  123107 */     // GIR_Coverage, 47720,
     /*  123107 */     GIR_EraseRootFromParent_Done,
     /*  123108 */   // Label 2154: @123108
     /*  123108 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123153), // Rule ID 47721 //
     /*  123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  123116 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  123116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123151 */     GIR_RootConstrainSelectedInstOperands,
     /*  123152 */     // GIR_Coverage, 47721,
     /*  123152 */     GIR_EraseRootFromParent_Done,
     /*  123153 */   // Label 2155: @123153
     /*  123153 */   GIM_Reject,
     /*  123154 */ // Label 2153: @123154
     /*  123154 */ GIM_Reject,
     /*  123155 */ // Label 2042: @123155
     /*  123155 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123765),
     /*  123160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123170 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123236), // Rule ID 71490 //
     /*  123175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123217 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123234 */     GIR_RootConstrainSelectedInstOperands,
     /*  123235 */     // GIR_Coverage, 71490,
     /*  123235 */     GIR_EraseRootFromParent_Done,
     /*  123236 */   // Label 2157: @123236
     /*  123236 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123302), // Rule ID 71491 //
     /*  123241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123283 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123300 */     GIR_RootConstrainSelectedInstOperands,
     /*  123301 */     // GIR_Coverage, 71491,
     /*  123301 */     GIR_EraseRootFromParent_Done,
     /*  123302 */   // Label 2158: @123302
     /*  123302 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123368), // Rule ID 71488 //
     /*  123307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123349 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123366 */     GIR_RootConstrainSelectedInstOperands,
     /*  123367 */     // GIR_Coverage, 71488,
     /*  123367 */     GIR_EraseRootFromParent_Done,
     /*  123368 */   // Label 2159: @123368
     /*  123368 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123434), // Rule ID 71489 //
     /*  123373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123415 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123432 */     GIR_RootConstrainSelectedInstOperands,
     /*  123433 */     // GIR_Coverage, 71489,
     /*  123433 */     GIR_EraseRootFromParent_Done,
     /*  123434 */   // Label 2160: @123434
     /*  123434 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123500), // Rule ID 71486 //
     /*  123439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123481 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123498 */     GIR_RootConstrainSelectedInstOperands,
     /*  123499 */     // GIR_Coverage, 71486,
     /*  123499 */     GIR_EraseRootFromParent_Done,
     /*  123500 */   // Label 2161: @123500
     /*  123500 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123566), // Rule ID 71487 //
     /*  123505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123547 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123564 */     GIR_RootConstrainSelectedInstOperands,
     /*  123565 */     // GIR_Coverage, 71487,
     /*  123565 */     GIR_EraseRootFromParent_Done,
     /*  123566 */   // Label 2162: @123566
     /*  123566 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123632), // Rule ID 53200 //
     /*  123571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123613 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123630 */     GIR_RootConstrainSelectedInstOperands,
     /*  123631 */     // GIR_Coverage, 53200,
     /*  123631 */     GIR_EraseRootFromParent_Done,
     /*  123632 */   // Label 2163: @123632
     /*  123632 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123698), // Rule ID 53201 //
     /*  123637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123679 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123696 */     GIR_RootConstrainSelectedInstOperands,
     /*  123697 */     // GIR_Coverage, 53201,
     /*  123697 */     GIR_EraseRootFromParent_Done,
     /*  123698 */   // Label 2164: @123698
     /*  123698 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123731), // Rule ID 53188 //
     /*  123703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123714 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  123717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123729 */     GIR_RootConstrainSelectedInstOperands,
     /*  123730 */     // GIR_Coverage, 53188,
     /*  123730 */     GIR_EraseRootFromParent_Done,
     /*  123731 */   // Label 2165: @123731
     /*  123731 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123764), // Rule ID 53189 //
     /*  123736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123747 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  123750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123762 */     GIR_RootConstrainSelectedInstOperands,
     /*  123763 */     // GIR_Coverage, 53189,
     /*  123763 */     GIR_EraseRootFromParent_Done,
     /*  123764 */   // Label 2166: @123764
     /*  123764 */   GIM_Reject,
     /*  123765 */ // Label 2156: @123765
     /*  123765 */ GIM_Reject,
     /*  123766 */ // Label 2043: @123766
     /*  123766 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123880),
     /*  123771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  123774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  123777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123789 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(123834), // Rule ID 47652 //
     /*  123794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123797 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  123800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123832 */     GIR_RootConstrainSelectedInstOperands,
     /*  123833 */     // GIR_Coverage, 47652,
     /*  123833 */     GIR_EraseRootFromParent_Done,
     /*  123834 */   // Label 2168: @123834
     /*  123834 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123879), // Rule ID 47653 //
     /*  123839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123842 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  123845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123877 */     GIR_RootConstrainSelectedInstOperands,
     /*  123878 */     // GIR_Coverage, 47653,
     /*  123878 */     GIR_EraseRootFromParent_Done,
     /*  123879 */   // Label 2169: @123879
     /*  123879 */   GIM_Reject,
     /*  123880 */ // Label 2167: @123880
     /*  123880 */ GIM_Reject,
     /*  123881 */ // Label 2044: @123881
     /*  123881 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123995),
     /*  123886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  123889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  123892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123904 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(123949), // Rule ID 47672 //
     /*  123909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123912 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  123915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123947 */     GIR_RootConstrainSelectedInstOperands,
     /*  123948 */     // GIR_Coverage, 47672,
     /*  123948 */     GIR_EraseRootFromParent_Done,
     /*  123949 */   // Label 2171: @123949
     /*  123949 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(123994), // Rule ID 47673 //
     /*  123954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123957 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  123960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123992 */     GIR_RootConstrainSelectedInstOperands,
     /*  123993 */     // GIR_Coverage, 47673,
     /*  123993 */     GIR_EraseRootFromParent_Done,
     /*  123994 */   // Label 2172: @123994
     /*  123994 */   GIM_Reject,
     /*  123995 */ // Label 2170: @123995
     /*  123995 */ GIM_Reject,
     /*  123996 */ // Label 2045: @123996
     /*  123996 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124110),
     /*  124001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124019 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124064), // Rule ID 47708 //
     /*  124024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124027 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124062 */     GIR_RootConstrainSelectedInstOperands,
     /*  124063 */     // GIR_Coverage, 47708,
     /*  124063 */     GIR_EraseRootFromParent_Done,
     /*  124064 */   // Label 2174: @124064
     /*  124064 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124109), // Rule ID 47709 //
     /*  124069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124072 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  124072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124107 */     GIR_RootConstrainSelectedInstOperands,
     /*  124108 */     // GIR_Coverage, 47709,
     /*  124108 */     GIR_EraseRootFromParent_Done,
     /*  124109 */   // Label 2175: @124109
     /*  124109 */   GIM_Reject,
     /*  124110 */ // Label 2173: @124110
     /*  124110 */ GIM_Reject,
     /*  124111 */ // Label 2046: @124111
     /*  124111 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124225),
     /*  124116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  124119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  124122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124134 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124179), // Rule ID 47724 //
     /*  124139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124142 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124177 */     GIR_RootConstrainSelectedInstOperands,
     /*  124178 */     // GIR_Coverage, 47724,
     /*  124178 */     GIR_EraseRootFromParent_Done,
     /*  124179 */   // Label 2177: @124179
     /*  124179 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124224), // Rule ID 47725 //
     /*  124184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124187 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124222 */     GIR_RootConstrainSelectedInstOperands,
     /*  124223 */     // GIR_Coverage, 47725,
     /*  124223 */     GIR_EraseRootFromParent_Done,
     /*  124224 */   // Label 2178: @124224
     /*  124224 */   GIM_Reject,
     /*  124225 */ // Label 2176: @124225
     /*  124225 */ GIM_Reject,
     /*  124226 */ // Label 2047: @124226
     /*  124226 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124836),
     /*  124231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124241 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124307), // Rule ID 71518 //
     /*  124246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124288 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124305 */     GIR_RootConstrainSelectedInstOperands,
     /*  124306 */     // GIR_Coverage, 71518,
     /*  124306 */     GIR_EraseRootFromParent_Done,
     /*  124307 */   // Label 2180: @124307
     /*  124307 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124373), // Rule ID 71519 //
     /*  124312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124354 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124371 */     GIR_RootConstrainSelectedInstOperands,
     /*  124372 */     // GIR_Coverage, 71519,
     /*  124372 */     GIR_EraseRootFromParent_Done,
     /*  124373 */   // Label 2181: @124373
     /*  124373 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124439), // Rule ID 71516 //
     /*  124378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124420 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124437 */     GIR_RootConstrainSelectedInstOperands,
     /*  124438 */     // GIR_Coverage, 71516,
     /*  124438 */     GIR_EraseRootFromParent_Done,
     /*  124439 */   // Label 2182: @124439
     /*  124439 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124505), // Rule ID 71517 //
     /*  124444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124486 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124503 */     GIR_RootConstrainSelectedInstOperands,
     /*  124504 */     // GIR_Coverage, 71517,
     /*  124504 */     GIR_EraseRootFromParent_Done,
     /*  124505 */   // Label 2183: @124505
     /*  124505 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124571), // Rule ID 71514 //
     /*  124510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124552 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124569 */     GIR_RootConstrainSelectedInstOperands,
     /*  124570 */     // GIR_Coverage, 71514,
     /*  124570 */     GIR_EraseRootFromParent_Done,
     /*  124571 */   // Label 2184: @124571
     /*  124571 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124637), // Rule ID 71515 //
     /*  124576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124618 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124635 */     GIR_RootConstrainSelectedInstOperands,
     /*  124636 */     // GIR_Coverage, 71515,
     /*  124636 */     GIR_EraseRootFromParent_Done,
     /*  124637 */   // Label 2185: @124637
     /*  124637 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124703), // Rule ID 53218 //
     /*  124642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124684 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124701 */     GIR_RootConstrainSelectedInstOperands,
     /*  124702 */     // GIR_Coverage, 53218,
     /*  124702 */     GIR_EraseRootFromParent_Done,
     /*  124703 */   // Label 2186: @124703
     /*  124703 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124769), // Rule ID 53219 //
     /*  124708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124750 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124767 */     GIR_RootConstrainSelectedInstOperands,
     /*  124768 */     // GIR_Coverage, 53219,
     /*  124768 */     GIR_EraseRootFromParent_Done,
     /*  124769 */   // Label 2187: @124769
     /*  124769 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124802), // Rule ID 53206 //
     /*  124774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124785 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  124788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124800 */     GIR_RootConstrainSelectedInstOperands,
     /*  124801 */     // GIR_Coverage, 53206,
     /*  124801 */     GIR_EraseRootFromParent_Done,
     /*  124802 */   // Label 2188: @124802
     /*  124802 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124835), // Rule ID 53207 //
     /*  124807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124818 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  124821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124833 */     GIR_RootConstrainSelectedInstOperands,
     /*  124834 */     // GIR_Coverage, 53207,
     /*  124834 */     GIR_EraseRootFromParent_Done,
     /*  124835 */   // Label 2189: @124835
     /*  124835 */   GIM_Reject,
     /*  124836 */ // Label 2179: @124836
     /*  124836 */ GIM_Reject,
     /*  124837 */ // Label 2048: @124837
     /*  124837 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124951),
     /*  124842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  124845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  124848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124860 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(124905), // Rule ID 47668 //
     /*  124865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124868 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  124871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124903 */     GIR_RootConstrainSelectedInstOperands,
     /*  124904 */     // GIR_Coverage, 47668,
     /*  124904 */     GIR_EraseRootFromParent_Done,
     /*  124905 */   // Label 2191: @124905
     /*  124905 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(124950), // Rule ID 47669 //
     /*  124910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124913 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  124916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124948 */     GIR_RootConstrainSelectedInstOperands,
     /*  124949 */     // GIR_Coverage, 47669,
     /*  124949 */     GIR_EraseRootFromParent_Done,
     /*  124950 */   // Label 2192: @124950
     /*  124950 */   GIM_Reject,
     /*  124951 */ // Label 2190: @124951
     /*  124951 */ GIM_Reject,
     /*  124952 */ // Label 2049: @124952
     /*  124952 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125066),
     /*  124957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  124960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  124963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124975 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(125020), // Rule ID 47696 //
     /*  124980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124983 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  124986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125018 */     GIR_RootConstrainSelectedInstOperands,
     /*  125019 */     // GIR_Coverage, 47696,
     /*  125019 */     GIR_EraseRootFromParent_Done,
     /*  125020 */   // Label 2194: @125020
     /*  125020 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(125065), // Rule ID 47697 //
     /*  125025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125028 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125063 */     GIR_RootConstrainSelectedInstOperands,
     /*  125064 */     // GIR_Coverage, 47697,
     /*  125064 */     GIR_EraseRootFromParent_Done,
     /*  125065 */   // Label 2195: @125065
     /*  125065 */   GIM_Reject,
     /*  125066 */ // Label 2193: @125066
     /*  125066 */ GIM_Reject,
     /*  125067 */ // Label 2050: @125067
     /*  125067 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125181),
     /*  125072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  125075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  125078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125090 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125135), // Rule ID 47712 //
     /*  125095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125098 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  125098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125133 */     GIR_RootConstrainSelectedInstOperands,
     /*  125134 */     // GIR_Coverage, 47712,
     /*  125134 */     GIR_EraseRootFromParent_Done,
     /*  125135 */   // Label 2197: @125135
     /*  125135 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125180), // Rule ID 47713 //
     /*  125140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125143 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125178 */     GIR_RootConstrainSelectedInstOperands,
     /*  125179 */     // GIR_Coverage, 47713,
     /*  125179 */     GIR_EraseRootFromParent_Done,
     /*  125180 */   // Label 2198: @125180
     /*  125180 */   GIM_Reject,
     /*  125181 */ // Label 2196: @125181
     /*  125181 */ GIM_Reject,
     /*  125182 */ // Label 2051: @125182
     /*  125182 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125296),
     /*  125187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  125190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125205 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125250), // Rule ID 47728 //
     /*  125210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125213 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125248 */     GIR_RootConstrainSelectedInstOperands,
     /*  125249 */     // GIR_Coverage, 47728,
     /*  125249 */     GIR_EraseRootFromParent_Done,
     /*  125250 */   // Label 2200: @125250
     /*  125250 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125295), // Rule ID 47729 //
     /*  125255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125258 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125293 */     GIR_RootConstrainSelectedInstOperands,
     /*  125294 */     // GIR_Coverage, 47729,
     /*  125294 */     GIR_EraseRootFromParent_Done,
     /*  125295 */   // Label 2201: @125295
     /*  125295 */   GIM_Reject,
     /*  125296 */ // Label 2199: @125296
     /*  125296 */ GIM_Reject,
     /*  125297 */ // Label 2052: @125297
     /*  125297 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125907),
     /*  125302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125312 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125378), // Rule ID 71546 //
     /*  125317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125359 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125376 */     GIR_RootConstrainSelectedInstOperands,
     /*  125377 */     // GIR_Coverage, 71546,
     /*  125377 */     GIR_EraseRootFromParent_Done,
     /*  125378 */   // Label 2203: @125378
     /*  125378 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125444), // Rule ID 71547 //
     /*  125383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125425 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125442 */     GIR_RootConstrainSelectedInstOperands,
     /*  125443 */     // GIR_Coverage, 71547,
     /*  125443 */     GIR_EraseRootFromParent_Done,
     /*  125444 */   // Label 2204: @125444
     /*  125444 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125510), // Rule ID 71544 //
     /*  125449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125491 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125508 */     GIR_RootConstrainSelectedInstOperands,
     /*  125509 */     // GIR_Coverage, 71544,
     /*  125509 */     GIR_EraseRootFromParent_Done,
     /*  125510 */   // Label 2205: @125510
     /*  125510 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125576), // Rule ID 71545 //
     /*  125515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125557 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125574 */     GIR_RootConstrainSelectedInstOperands,
     /*  125575 */     // GIR_Coverage, 71545,
     /*  125575 */     GIR_EraseRootFromParent_Done,
     /*  125576 */   // Label 2206: @125576
     /*  125576 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125642), // Rule ID 71542 //
     /*  125581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125623 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125640 */     GIR_RootConstrainSelectedInstOperands,
     /*  125641 */     // GIR_Coverage, 71542,
     /*  125641 */     GIR_EraseRootFromParent_Done,
     /*  125642 */   // Label 2207: @125642
     /*  125642 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125708), // Rule ID 71543 //
     /*  125647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125689 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125706 */     GIR_RootConstrainSelectedInstOperands,
     /*  125707 */     // GIR_Coverage, 71543,
     /*  125707 */     GIR_EraseRootFromParent_Done,
     /*  125708 */   // Label 2208: @125708
     /*  125708 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125774), // Rule ID 53236 //
     /*  125713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125755 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125772 */     GIR_RootConstrainSelectedInstOperands,
     /*  125773 */     // GIR_Coverage, 53236,
     /*  125773 */     GIR_EraseRootFromParent_Done,
     /*  125774 */   // Label 2209: @125774
     /*  125774 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125840), // Rule ID 53237 //
     /*  125779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125821 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125838 */     GIR_RootConstrainSelectedInstOperands,
     /*  125839 */     // GIR_Coverage, 53237,
     /*  125839 */     GIR_EraseRootFromParent_Done,
     /*  125840 */   // Label 2210: @125840
     /*  125840 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(125873), // Rule ID 53224 //
     /*  125845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125856 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  125859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125871 */     GIR_RootConstrainSelectedInstOperands,
     /*  125872 */     // GIR_Coverage, 53224,
     /*  125872 */     GIR_EraseRootFromParent_Done,
     /*  125873 */   // Label 2211: @125873
     /*  125873 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125906), // Rule ID 53225 //
     /*  125878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125889 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  125892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125904 */     GIR_RootConstrainSelectedInstOperands,
     /*  125905 */     // GIR_Coverage, 53225,
     /*  125905 */     GIR_EraseRootFromParent_Done,
     /*  125906 */   // Label 2212: @125906
     /*  125906 */   GIM_Reject,
     /*  125907 */ // Label 2202: @125907
     /*  125907 */ GIM_Reject,
     /*  125908 */ // Label 2053: @125908
     /*  125908 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126022),
     /*  125913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  125916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  125919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125931 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(125976), // Rule ID 47684 //
     /*  125936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125939 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  125942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125974 */     GIR_RootConstrainSelectedInstOperands,
     /*  125975 */     // GIR_Coverage, 47684,
     /*  125975 */     GIR_EraseRootFromParent_Done,
     /*  125976 */   // Label 2214: @125976
     /*  125976 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126021), // Rule ID 47685 //
     /*  125981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125984 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  125987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126019 */     GIR_RootConstrainSelectedInstOperands,
     /*  126020 */     // GIR_Coverage, 47685,
     /*  126020 */     GIR_EraseRootFromParent_Done,
     /*  126021 */   // Label 2215: @126021
     /*  126021 */   GIM_Reject,
     /*  126022 */ // Label 2213: @126022
     /*  126022 */ GIM_Reject,
     /*  126023 */ // Label 2054: @126023
     /*  126023 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126137),
     /*  126028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126046 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126091), // Rule ID 47700 //
     /*  126051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126054 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  126054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126089 */     GIR_RootConstrainSelectedInstOperands,
     /*  126090 */     // GIR_Coverage, 47700,
     /*  126090 */     GIR_EraseRootFromParent_Done,
     /*  126091 */   // Label 2217: @126091
     /*  126091 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126136), // Rule ID 47701 //
     /*  126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126099 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  126099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126134 */     GIR_RootConstrainSelectedInstOperands,
     /*  126135 */     // GIR_Coverage, 47701,
     /*  126135 */     GIR_EraseRootFromParent_Done,
     /*  126136 */   // Label 2218: @126136
     /*  126136 */   GIM_Reject,
     /*  126137 */ // Label 2216: @126137
     /*  126137 */ GIM_Reject,
     /*  126138 */ // Label 2055: @126138
     /*  126138 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126252),
     /*  126143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  126146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  126149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126161 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126206), // Rule ID 47716 //
     /*  126166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126169 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126204 */     GIR_RootConstrainSelectedInstOperands,
     /*  126205 */     // GIR_Coverage, 47716,
     /*  126205 */     GIR_EraseRootFromParent_Done,
     /*  126206 */   // Label 2220: @126206
     /*  126206 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126251), // Rule ID 47717 //
     /*  126211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126214 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126249 */     GIR_RootConstrainSelectedInstOperands,
     /*  126250 */     // GIR_Coverage, 47717,
     /*  126250 */     GIR_EraseRootFromParent_Done,
     /*  126251 */   // Label 2221: @126251
     /*  126251 */   GIM_Reject,
     /*  126252 */ // Label 2219: @126252
     /*  126252 */ GIM_Reject,
     /*  126253 */ // Label 2056: @126253
     /*  126253 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126863),
     /*  126258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126268 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126334), // Rule ID 71574 //
     /*  126273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126315 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126332 */     GIR_RootConstrainSelectedInstOperands,
     /*  126333 */     // GIR_Coverage, 71574,
     /*  126333 */     GIR_EraseRootFromParent_Done,
     /*  126334 */   // Label 2223: @126334
     /*  126334 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126400), // Rule ID 71575 //
     /*  126339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126381 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126398 */     GIR_RootConstrainSelectedInstOperands,
     /*  126399 */     // GIR_Coverage, 71575,
     /*  126399 */     GIR_EraseRootFromParent_Done,
     /*  126400 */   // Label 2224: @126400
     /*  126400 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126466), // Rule ID 71572 //
     /*  126405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126447 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126464 */     GIR_RootConstrainSelectedInstOperands,
     /*  126465 */     // GIR_Coverage, 71572,
     /*  126465 */     GIR_EraseRootFromParent_Done,
     /*  126466 */   // Label 2225: @126466
     /*  126466 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126532), // Rule ID 71573 //
     /*  126471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126513 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126530 */     GIR_RootConstrainSelectedInstOperands,
     /*  126531 */     // GIR_Coverage, 71573,
     /*  126531 */     GIR_EraseRootFromParent_Done,
     /*  126532 */   // Label 2226: @126532
     /*  126532 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126598), // Rule ID 71570 //
     /*  126537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126579 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126596 */     GIR_RootConstrainSelectedInstOperands,
     /*  126597 */     // GIR_Coverage, 71570,
     /*  126597 */     GIR_EraseRootFromParent_Done,
     /*  126598 */   // Label 2227: @126598
     /*  126598 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126664), // Rule ID 71571 //
     /*  126603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126645 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126662 */     GIR_RootConstrainSelectedInstOperands,
     /*  126663 */     // GIR_Coverage, 71571,
     /*  126663 */     GIR_EraseRootFromParent_Done,
     /*  126664 */   // Label 2228: @126664
     /*  126664 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126730), // Rule ID 53254 //
     /*  126669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126711 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126728 */     GIR_RootConstrainSelectedInstOperands,
     /*  126729 */     // GIR_Coverage, 53254,
     /*  126729 */     GIR_EraseRootFromParent_Done,
     /*  126730 */   // Label 2229: @126730
     /*  126730 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126796), // Rule ID 53255 //
     /*  126735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126777 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126794 */     GIR_RootConstrainSelectedInstOperands,
     /*  126795 */     // GIR_Coverage, 53255,
     /*  126795 */     GIR_EraseRootFromParent_Done,
     /*  126796 */   // Label 2230: @126796
     /*  126796 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126829), // Rule ID 53242 //
     /*  126801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126812 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  126815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126827 */     GIR_RootConstrainSelectedInstOperands,
     /*  126828 */     // GIR_Coverage, 53242,
     /*  126828 */     GIR_EraseRootFromParent_Done,
     /*  126829 */   // Label 2231: @126829
     /*  126829 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126862), // Rule ID 53243 //
     /*  126834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126845 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  126848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126860 */     GIR_RootConstrainSelectedInstOperands,
     /*  126861 */     // GIR_Coverage, 53243,
     /*  126861 */     GIR_EraseRootFromParent_Done,
     /*  126862 */   // Label 2232: @126862
     /*  126862 */   GIM_Reject,
     /*  126863 */ // Label 2222: @126863
     /*  126863 */ GIM_Reject,
     /*  126864 */ // Label 2057: @126864
     /*  126864 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126978),
     /*  126869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  126872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  126875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126887 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(126932), // Rule ID 47688 //
     /*  126892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126895 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  126898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126930 */     GIR_RootConstrainSelectedInstOperands,
     /*  126931 */     // GIR_Coverage, 47688,
     /*  126931 */     GIR_EraseRootFromParent_Done,
     /*  126932 */   // Label 2234: @126932
     /*  126932 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(126977), // Rule ID 47689 //
     /*  126937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126940 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  126943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126975 */     GIR_RootConstrainSelectedInstOperands,
     /*  126976 */     // GIR_Coverage, 47689,
     /*  126976 */     GIR_EraseRootFromParent_Done,
     /*  126977 */   // Label 2235: @126977
     /*  126977 */   GIM_Reject,
     /*  126978 */ // Label 2233: @126978
     /*  126978 */ GIM_Reject,
     /*  126979 */ // Label 2058: @126979
     /*  126979 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127093),
     /*  126984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  126987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  126990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127002 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127047), // Rule ID 47704 //
     /*  127007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127010 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127045 */     GIR_RootConstrainSelectedInstOperands,
     /*  127046 */     // GIR_Coverage, 47704,
     /*  127046 */     GIR_EraseRootFromParent_Done,
     /*  127047 */   // Label 2237: @127047
     /*  127047 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127092), // Rule ID 47705 //
     /*  127052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127055 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127090 */     GIR_RootConstrainSelectedInstOperands,
     /*  127091 */     // GIR_Coverage, 47705,
     /*  127091 */     GIR_EraseRootFromParent_Done,
     /*  127092 */   // Label 2238: @127092
     /*  127092 */   GIM_Reject,
     /*  127093 */ // Label 2236: @127093
     /*  127093 */ GIM_Reject,
     /*  127094 */ // Label 2059: @127094
     /*  127094 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127704),
     /*  127099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127109 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127175), // Rule ID 71602 //
     /*  127114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127156 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127173 */     GIR_RootConstrainSelectedInstOperands,
     /*  127174 */     // GIR_Coverage, 71602,
     /*  127174 */     GIR_EraseRootFromParent_Done,
     /*  127175 */   // Label 2240: @127175
     /*  127175 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127241), // Rule ID 71603 //
     /*  127180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127222 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127239 */     GIR_RootConstrainSelectedInstOperands,
     /*  127240 */     // GIR_Coverage, 71603,
     /*  127240 */     GIR_EraseRootFromParent_Done,
     /*  127241 */   // Label 2241: @127241
     /*  127241 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127307), // Rule ID 71600 //
     /*  127246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127288 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127305 */     GIR_RootConstrainSelectedInstOperands,
     /*  127306 */     // GIR_Coverage, 71600,
     /*  127306 */     GIR_EraseRootFromParent_Done,
     /*  127307 */   // Label 2242: @127307
     /*  127307 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127373), // Rule ID 71601 //
     /*  127312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127354 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127371 */     GIR_RootConstrainSelectedInstOperands,
     /*  127372 */     // GIR_Coverage, 71601,
     /*  127372 */     GIR_EraseRootFromParent_Done,
     /*  127373 */   // Label 2243: @127373
     /*  127373 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127439), // Rule ID 71598 //
     /*  127378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127420 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127437 */     GIR_RootConstrainSelectedInstOperands,
     /*  127438 */     // GIR_Coverage, 71598,
     /*  127438 */     GIR_EraseRootFromParent_Done,
     /*  127439 */   // Label 2244: @127439
     /*  127439 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127505), // Rule ID 71599 //
     /*  127444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127486 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127503 */     GIR_RootConstrainSelectedInstOperands,
     /*  127504 */     // GIR_Coverage, 71599,
     /*  127504 */     GIR_EraseRootFromParent_Done,
     /*  127505 */   // Label 2245: @127505
     /*  127505 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127571), // Rule ID 53272 //
     /*  127510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127552 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127569 */     GIR_RootConstrainSelectedInstOperands,
     /*  127570 */     // GIR_Coverage, 53272,
     /*  127570 */     GIR_EraseRootFromParent_Done,
     /*  127571 */   // Label 2246: @127571
     /*  127571 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127637), // Rule ID 53273 //
     /*  127576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127618 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127635 */     GIR_RootConstrainSelectedInstOperands,
     /*  127636 */     // GIR_Coverage, 53273,
     /*  127636 */     GIR_EraseRootFromParent_Done,
     /*  127637 */   // Label 2247: @127637
     /*  127637 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127670), // Rule ID 53260 //
     /*  127642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127653 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  127656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127668 */     GIR_RootConstrainSelectedInstOperands,
     /*  127669 */     // GIR_Coverage, 53260,
     /*  127669 */     GIR_EraseRootFromParent_Done,
     /*  127670 */   // Label 2248: @127670
     /*  127670 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127703), // Rule ID 53261 //
     /*  127675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127686 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  127689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127701 */     GIR_RootConstrainSelectedInstOperands,
     /*  127702 */     // GIR_Coverage, 53261,
     /*  127702 */     GIR_EraseRootFromParent_Done,
     /*  127703 */   // Label 2249: @127703
     /*  127703 */   GIM_Reject,
     /*  127704 */ // Label 2239: @127704
     /*  127704 */ GIM_Reject,
     /*  127705 */ // Label 2060: @127705
     /*  127705 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127819),
     /*  127710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  127713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  127716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127728 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(127773), // Rule ID 47692 //
     /*  127733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127736 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  127739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127771 */     GIR_RootConstrainSelectedInstOperands,
     /*  127772 */     // GIR_Coverage, 47692,
     /*  127772 */     GIR_EraseRootFromParent_Done,
     /*  127773 */   // Label 2251: @127773
     /*  127773 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127818), // Rule ID 47693 //
     /*  127778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127781 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  127784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127816 */     GIR_RootConstrainSelectedInstOperands,
     /*  127817 */     // GIR_Coverage, 47693,
     /*  127817 */     GIR_EraseRootFromParent_Done,
     /*  127818 */   // Label 2252: @127818
     /*  127818 */   GIM_Reject,
     /*  127819 */ // Label 2250: @127819
     /*  127819 */ GIM_Reject,
     /*  127820 */ // Label 2061: @127820
     /*  127820 */ GIM_Reject,
     /*  127821 */ // Label 8: @127821
     /*  127821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2284*/ GIMT_Encode4(140441),
     /*  127832 */ /*GILLT_s32*//*Label 2253*/ GIMT_Encode4(127956),
     /*  127836 */ /*GILLT_s64*//*Label 2254*/ GIMT_Encode4(130686),
     /*  127840 */ /*GILLT_nxv1s1*//*Label 2255*/ GIMT_Encode4(133634),
     /*  127844 */ /*GILLT_nxv1s8*//*Label 2256*/ GIMT_Encode4(134245),
     /*  127848 */ /*GILLT_nxv1s16*//*Label 2257*/ GIMT_Encode4(134360),
     /*  127852 */ /*GILLT_nxv1s32*//*Label 2258*/ GIMT_Encode4(134475),
     /*  127856 */ /*GILLT_nxv1s64*//*Label 2259*/ GIMT_Encode4(134590),
     /*  127860 */ /*GILLT_nxv2s1*//*Label 2260*/ GIMT_Encode4(134705),
     /*  127864 */ /*GILLT_nxv2s8*//*Label 2261*/ GIMT_Encode4(135316),
     /*  127868 */ /*GILLT_nxv2s16*//*Label 2262*/ GIMT_Encode4(135431),
     /*  127872 */ /*GILLT_nxv2s32*//*Label 2263*/ GIMT_Encode4(135546),
     /*  127876 */ /*GILLT_nxv2s64*//*Label 2264*/ GIMT_Encode4(135661),
     /*  127880 */ /*GILLT_nxv4s1*//*Label 2265*/ GIMT_Encode4(135776),
     /*  127884 */ /*GILLT_nxv4s8*//*Label 2266*/ GIMT_Encode4(136387),
     /*  127888 */ /*GILLT_nxv4s16*//*Label 2267*/ GIMT_Encode4(136502),
     /*  127892 */ /*GILLT_nxv4s32*//*Label 2268*/ GIMT_Encode4(136617),
     /*  127896 */ /*GILLT_nxv4s64*//*Label 2269*/ GIMT_Encode4(136732),
     /*  127900 */ /*GILLT_nxv8s1*//*Label 2270*/ GIMT_Encode4(136847),
     /*  127904 */ /*GILLT_nxv8s8*//*Label 2271*/ GIMT_Encode4(137458),
     /*  127908 */ /*GILLT_nxv8s16*//*Label 2272*/ GIMT_Encode4(137573),
     /*  127912 */ /*GILLT_nxv8s32*//*Label 2273*/ GIMT_Encode4(137688),
     /*  127916 */ /*GILLT_nxv8s64*//*Label 2274*/ GIMT_Encode4(137803),
     /*  127920 */ /*GILLT_nxv16s1*//*Label 2275*/ GIMT_Encode4(137918),
     /*  127924 */ /*GILLT_nxv16s8*//*Label 2276*/ GIMT_Encode4(138529),
     /*  127928 */ /*GILLT_nxv16s16*//*Label 2277*/ GIMT_Encode4(138644),
     /*  127932 */ /*GILLT_nxv16s32*//*Label 2278*/ GIMT_Encode4(138759),
     /*  127936 */ /*GILLT_nxv32s1*//*Label 2279*/ GIMT_Encode4(138874),
     /*  127940 */ /*GILLT_nxv32s8*//*Label 2280*/ GIMT_Encode4(139485),
     /*  127944 */ /*GILLT_nxv32s16*//*Label 2281*/ GIMT_Encode4(139600),
     /*  127948 */ /*GILLT_nxv64s1*//*Label 2282*/ GIMT_Encode4(139715),
     /*  127952 */ /*GILLT_nxv64s8*//*Label 2283*/ GIMT_Encode4(140326),
     /*  127956 */ // Label 2253: @127956
     /*  127956 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(130685),
     /*  127961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  127964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  127967 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(128162), // Rule ID 65254 //
     /*  127972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  127975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  127991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  127995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128011 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128023 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128043 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128047 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128051 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128055 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128059 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128063 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128067 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128071 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128087 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128094 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128101 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128160 */     GIR_RootConstrainSelectedInstOperands,
     /*  128161 */     // GIR_Coverage, 65254,
     /*  128161 */     GIR_EraseRootFromParent_Done,
     /*  128162 */   // Label 2286: @128162
     /*  128162 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(128357), // Rule ID 65256 //
     /*  128167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128222 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128234 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128242 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128246 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128250 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128254 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128258 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128262 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128266 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128282 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128289 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128296 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128355 */     GIR_RootConstrainSelectedInstOperands,
     /*  128356 */     // GIR_Coverage, 65256,
     /*  128356 */     GIR_EraseRootFromParent_Done,
     /*  128357 */   // Label 2287: @128357
     /*  128357 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(128552), // Rule ID 65250 //
     /*  128362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128429 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128433 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128437 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128441 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128445 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128449 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128453 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128457 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128461 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128477 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128484 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128491 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  128532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  128537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128550 */     GIR_RootConstrainSelectedInstOperands,
     /*  128551 */     // GIR_Coverage, 65250,
     /*  128551 */     GIR_EraseRootFromParent_Done,
     /*  128552 */   // Label 2288: @128552
     /*  128552 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(128747), // Rule ID 65252 //
     /*  128557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128624 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128632 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128636 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128640 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128644 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128648 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128652 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128656 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128672 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128679 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128686 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  128727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  128732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128745 */     GIR_RootConstrainSelectedInstOperands,
     /*  128746 */     // GIR_Coverage, 65252,
     /*  128746 */     GIR_EraseRootFromParent_Done,
     /*  128747 */   // Label 2289: @128747
     /*  128747 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(128942), // Rule ID 65244 //
     /*  128752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  128795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  128799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128807 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128811 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  128815 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  128819 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128823 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128827 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128831 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  128835 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128839 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128843 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128847 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  128851 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128860 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128867 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128874 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128881 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  128898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  128903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  128922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  128927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128940 */     GIR_RootConstrainSelectedInstOperands,
     /*  128941 */     // GIR_Coverage, 65244,
     /*  128941 */     GIR_EraseRootFromParent_Done,
     /*  128942 */   // Label 2290: @128942
     /*  128942 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(129137), // Rule ID 65248 //
     /*  128947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128986 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  128990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  128994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129006 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129014 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129018 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129038 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129042 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129046 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129055 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129062 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129069 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129076 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129076 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129079 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129083 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129135 */     GIR_RootConstrainSelectedInstOperands,
     /*  129136 */     // GIR_Coverage, 65248,
     /*  129136 */     GIR_EraseRootFromParent_Done,
     /*  129137 */   // Label 2291: @129137
     /*  129137 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(129332), // Rule ID 2543 //
     /*  129142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129201 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129205 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129209 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129213 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129217 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129221 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129225 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129229 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129233 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129237 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129241 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129250 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129257 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129264 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129271 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129330 */     GIR_RootConstrainSelectedInstOperands,
     /*  129331 */     // GIR_Coverage, 2543,
     /*  129331 */     GIR_EraseRootFromParent_Done,
     /*  129332 */   // Label 2292: @129332
     /*  129332 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(129527), // Rule ID 65246 //
     /*  129337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129376 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129396 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129412 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129416 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129420 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129424 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129428 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129432 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129436 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129445 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129452 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129459 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129466 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129525 */     GIR_RootConstrainSelectedInstOperands,
     /*  129526 */     // GIR_Coverage, 65246,
     /*  129526 */     GIR_EraseRootFromParent_Done,
     /*  129527 */   // Label 2293: @129527
     /*  129527 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(129632), // Rule ID 2538 //
     /*  129532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129555 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  129559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  129563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129575 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129595 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  129595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  129612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  129617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  129622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  129630 */     GIR_RootConstrainSelectedInstOperands,
     /*  129631 */     // GIR_Coverage, 2538,
     /*  129631 */     GIR_EraseRootFromParent_Done,
     /*  129632 */   // Label 2294: @129632
     /*  129632 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129737), // Rule ID 65239 //
     /*  129637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  129664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  129668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129680 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129700 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  129700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  129722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  129727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  129735 */     GIR_RootConstrainSelectedInstOperands,
     /*  129736 */     // GIR_Coverage, 65239,
     /*  129736 */     GIR_EraseRootFromParent_Done,
     /*  129737 */   // Label 2295: @129737
     /*  129737 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(129826), // Rule ID 65233 //
     /*  129742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  129757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129790 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  129801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129810 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  129824 */     GIR_RootConstrainSelectedInstOperands,
     /*  129825 */     // GIR_Coverage, 65233,
     /*  129825 */     GIR_EraseRootFromParent_Done,
     /*  129826 */   // Label 2296: @129826
     /*  129826 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(129915), // Rule ID 2532 //
     /*  129831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  129846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129875 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129879 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  129890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129899 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  129913 */     GIR_RootConstrainSelectedInstOperands,
     /*  129914 */     // GIR_Coverage, 2532,
     /*  129914 */     GIR_EraseRootFromParent_Done,
     /*  129915 */   // Label 2297: @129915
     /*  129915 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(129980), // Rule ID 65235 //
     /*  129920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  129947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129963 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  129963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  129978 */     GIR_RootConstrainSelectedInstOperands,
     /*  129979 */     // GIR_Coverage, 65235,
     /*  129979 */     GIR_EraseRootFromParent_Done,
     /*  129980 */   // Label 2298: @129980
     /*  129980 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130045), // Rule ID 2534 //
     /*  129985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  129988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130028 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130043 */     GIR_RootConstrainSelectedInstOperands,
     /*  130044 */     // GIR_Coverage, 2534,
     /*  130044 */     GIR_EraseRootFromParent_Done,
     /*  130045 */   // Label 2299: @130045
     /*  130045 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130111), // Rule ID 65241 //
     /*  130050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11275),
     /*  130086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130095 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11275>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130109 */     GIR_RootConstrainSelectedInstOperands,
     /*  130110 */     // GIR_Coverage, 65241,
     /*  130110 */     GIR_EraseRootFromParent_Done,
     /*  130111 */   // Label 2300: @130111
     /*  130111 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(130177), // Rule ID 2540 //
     /*  130116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11275),
     /*  130152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130161 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11275>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130175 */     GIR_RootConstrainSelectedInstOperands,
     /*  130176 */     // GIR_Coverage, 2540,
     /*  130176 */     GIR_EraseRootFromParent_Done,
     /*  130177 */   // Label 2301: @130177
     /*  130177 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130239), // Rule ID 2541 //
     /*  130182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130223 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130237 */     GIR_RootConstrainSelectedInstOperands,
     /*  130238 */     // GIR_Coverage, 2541,
     /*  130238 */     GIR_EraseRootFromParent_Done,
     /*  130239 */   // Label 2302: @130239
     /*  130239 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130301), // Rule ID 65242 //
     /*  130244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130285 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130299 */     GIR_RootConstrainSelectedInstOperands,
     /*  130300 */     // GIR_Coverage, 65242,
     /*  130300 */     GIR_EraseRootFromParent_Done,
     /*  130301 */   // Label 2303: @130301
     /*  130301 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130360), // Rule ID 2467 //
     /*  130306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130346 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130358 */     GIR_RootConstrainSelectedInstOperands,
     /*  130359 */     // GIR_Coverage, 2467,
     /*  130359 */     GIR_EraseRootFromParent_Done,
     /*  130360 */   // Label 2304: @130360
     /*  130360 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130419), // Rule ID 65229 //
     /*  130365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130392 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130405 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130417 */     GIR_RootConstrainSelectedInstOperands,
     /*  130418 */     // GIR_Coverage, 65229,
     /*  130418 */     GIR_EraseRootFromParent_Done,
     /*  130419 */   // Label 2305: @130419
     /*  130419 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130475), // Rule ID 65213 //
     /*  130424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130452 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130462 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130473 */     GIR_RootConstrainSelectedInstOperands,
     /*  130474 */     // GIR_Coverage, 65213,
     /*  130474 */     GIR_EraseRootFromParent_Done,
     /*  130475 */   // Label 2306: @130475
     /*  130475 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130531), // Rule ID 2441 //
     /*  130480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130518 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130529 */     GIR_RootConstrainSelectedInstOperands,
     /*  130530 */     // GIR_Coverage, 2441,
     /*  130530 */     GIR_EraseRootFromParent_Done,
     /*  130531 */   // Label 2307: @130531
     /*  130531 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130573), // Rule ID 81 //
     /*  130536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  130539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  130559 */     // MIs[1] Operand 1
     /*  130559 */     // No operand predicates
     /*  130559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130561 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  130561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  130564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130571 */     GIR_RootConstrainSelectedInstOperands,
     /*  130572 */     // GIR_Coverage, 81,
     /*  130572 */     GIR_EraseRootFromParent_Done,
     /*  130573 */   // Label 2308: @130573
     /*  130573 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130615), // Rule ID 64520 //
     /*  130578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  130581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  130601 */     // MIs[1] Operand 1
     /*  130601 */     // No operand predicates
     /*  130601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130603 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  130603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  130606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  130608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130613 */     GIR_RootConstrainSelectedInstOperands,
     /*  130614 */     // GIR_Coverage, 64520,
     /*  130614 */     GIR_EraseRootFromParent_Done,
     /*  130615 */   // Label 2309: @130615
     /*  130615 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130657), // Rule ID 64524 //
     /*  130620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  130623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  130631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  130639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  130643 */     // MIs[1] Operand 1
     /*  130643 */     // No operand predicates
     /*  130643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130645 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  130645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  130648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  130655 */     GIR_RootConstrainSelectedInstOperands,
     /*  130656 */     // GIR_Coverage, 64524,
     /*  130656 */     GIR_EraseRootFromParent_Done,
     /*  130657 */   // Label 2310: @130657
     /*  130657 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130684), // Rule ID 79 //
     /*  130662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  130665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130677 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  130682 */     GIR_RootConstrainSelectedInstOperands,
     /*  130683 */     // GIR_Coverage, 79,
     /*  130683 */     GIR_Done,
     /*  130684 */   // Label 2311: @130684
     /*  130684 */   GIM_Reject,
     /*  130685 */ // Label 2285: @130685
     /*  130685 */ GIM_Reject,
     /*  130686 */ // Label 2254: @130686
     /*  130686 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(133633),
     /*  130691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  130694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  130697 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130892), // Rule ID 65253 //
     /*  130702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  130705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  130721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  130725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  130741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  130749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  130757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  130761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  130765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130769 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  130773 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  130777 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  130781 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  130785 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130789 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  130793 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  130797 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  130801 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130817 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  130824 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  130831 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  130831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  130834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  130848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  130853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  130855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  130858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  130872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  130877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130890 */     GIR_RootConstrainSelectedInstOperands,
     /*  130891 */     // GIR_Coverage, 65253,
     /*  130891 */     GIR_EraseRootFromParent_Done,
     /*  130892 */   // Label 2313: @130892
     /*  130892 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131087), // Rule ID 65255 //
     /*  130897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  130900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  130916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  130920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  130936 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  130944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  130948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  130952 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  130956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  130960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130964 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  130968 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  130972 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  130976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  130980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130984 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  130988 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  130992 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  130996 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  130998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131012 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131019 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131026 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131085 */     GIR_RootConstrainSelectedInstOperands,
     /*  131086 */     // GIR_Coverage, 65255,
     /*  131086 */     GIR_EraseRootFromParent_Done,
     /*  131087 */   // Label 2314: @131087
     /*  131087 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131282), // Rule ID 65249 //
     /*  131092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131151 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131155 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131159 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131163 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131167 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131171 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131175 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131179 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131183 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131187 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131191 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131207 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131214 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131221 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131280 */     GIR_RootConstrainSelectedInstOperands,
     /*  131281 */     // GIR_Coverage, 65249,
     /*  131281 */     GIR_EraseRootFromParent_Done,
     /*  131282 */   // Label 2315: @131282
     /*  131282 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131477), // Rule ID 65251 //
     /*  131287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131326 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131354 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131362 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131374 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131378 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131382 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131386 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131402 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131409 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131416 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131475 */     GIR_RootConstrainSelectedInstOperands,
     /*  131476 */     // GIR_Coverage, 65251,
     /*  131476 */     GIR_EraseRootFromParent_Done,
     /*  131477 */   // Label 2316: @131477
     /*  131477 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131672), // Rule ID 65243 //
     /*  131482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  131525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131541 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  131545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131553 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131561 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  131565 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131569 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131573 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131577 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131581 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131590 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131597 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131604 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131611 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  131628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  131633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  131652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  131657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131670 */     GIR_RootConstrainSelectedInstOperands,
     /*  131671 */     // GIR_Coverage, 65243,
     /*  131671 */     GIR_EraseRootFromParent_Done,
     /*  131672 */   // Label 2317: @131672
     /*  131672 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131867), // Rule ID 65247 //
     /*  131677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  131720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131736 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  131740 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131744 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131748 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131752 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  131760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131764 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131768 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131772 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131776 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131785 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131792 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131799 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131806 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131806 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131809 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131813 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  131823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  131828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  131847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  131852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131865 */     GIR_RootConstrainSelectedInstOperands,
     /*  131866 */     // GIR_Coverage, 65247,
     /*  131866 */     GIR_EraseRootFromParent_Done,
     /*  131867 */   // Label 2318: @131867
     /*  131867 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(132062), // Rule ID 2542 //
     /*  131872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131911 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  131915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  131919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131923 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131927 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131931 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  131935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  131939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  131955 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131959 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131963 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131967 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  131971 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131980 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131987 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131994 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132001 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132060 */     GIR_RootConstrainSelectedInstOperands,
     /*  132061 */     // GIR_Coverage, 2542,
     /*  132061 */     GIR_EraseRootFromParent_Done,
     /*  132062 */   // Label 2319: @132062
     /*  132062 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(132257), // Rule ID 65245 //
     /*  132067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132106 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132126 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132138 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132154 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132158 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132162 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132166 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132175 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132182 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132189 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132196 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132255 */     GIR_RootConstrainSelectedInstOperands,
     /*  132256 */     // GIR_Coverage, 65245,
     /*  132256 */     GIR_EraseRootFromParent_Done,
     /*  132257 */   // Label 2320: @132257
     /*  132257 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132362), // Rule ID 2537 //
     /*  132262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  132289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132305 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132325 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132360 */     GIR_RootConstrainSelectedInstOperands,
     /*  132361 */     // GIR_Coverage, 2537,
     /*  132361 */     GIR_EraseRootFromParent_Done,
     /*  132362 */   // Label 2321: @132362
     /*  132362 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132467), // Rule ID 65238 //
     /*  132367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132390 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  132394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132430 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132465 */     GIR_RootConstrainSelectedInstOperands,
     /*  132466 */     // GIR_Coverage, 65238,
     /*  132466 */     GIR_EraseRootFromParent_Done,
     /*  132467 */   // Label 2322: @132467
     /*  132467 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132556), // Rule ID 65232 //
     /*  132472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132520 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  132531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132540 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132554 */     GIR_RootConstrainSelectedInstOperands,
     /*  132555 */     // GIR_Coverage, 65232,
     /*  132555 */     GIR_EraseRootFromParent_Done,
     /*  132556 */   // Label 2323: @132556
     /*  132556 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132645), // Rule ID 2531 //
     /*  132561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132609 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  132620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132629 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132643 */     GIR_RootConstrainSelectedInstOperands,
     /*  132644 */     // GIR_Coverage, 2531,
     /*  132644 */     GIR_EraseRootFromParent_Done,
     /*  132645 */   // Label 2324: @132645
     /*  132645 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132710), // Rule ID 65234 //
     /*  132650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132693 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132708 */     GIR_RootConstrainSelectedInstOperands,
     /*  132709 */     // GIR_Coverage, 65234,
     /*  132709 */     GIR_EraseRootFromParent_Done,
     /*  132710 */   // Label 2325: @132710
     /*  132710 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132775), // Rule ID 2533 //
     /*  132715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132758 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132773 */     GIR_RootConstrainSelectedInstOperands,
     /*  132774 */     // GIR_Coverage, 2533,
     /*  132774 */     GIR_EraseRootFromParent_Done,
     /*  132775 */   // Label 2326: @132775
     /*  132775 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132860), // Rule ID 65259 //
     /*  132780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  132783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  132795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132824 */     // MIs[1] Operand 2
     /*  132824 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  132835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  132844 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  132847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132858 */     GIR_RootConstrainSelectedInstOperands,
     /*  132859 */     // GIR_Coverage, 65259,
     /*  132859 */     GIR_EraseRootFromParent_Done,
     /*  132860 */   // Label 2327: @132860
     /*  132860 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132945), // Rule ID 2546 //
     /*  132865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  132868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  132880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132905 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132909 */     // MIs[1] Operand 2
     /*  132909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  132920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  132929 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  132932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  132943 */     GIR_RootConstrainSelectedInstOperands,
     /*  132944 */     // GIR_Coverage, 2546,
     /*  132944 */     GIR_EraseRootFromParent_Done,
     /*  132945 */   // Label 2328: @132945
     /*  132945 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(133011), // Rule ID 65240 //
     /*  132950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132978 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  132982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11275),
     /*  132986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  132988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132995 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11275>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  132995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133009 */     GIR_RootConstrainSelectedInstOperands,
     /*  133010 */     // GIR_Coverage, 65240,
     /*  133010 */     GIR_EraseRootFromParent_Done,
     /*  133011 */   // Label 2329: @133011
     /*  133011 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(133077), // Rule ID 65258 //
     /*  133016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10059),
     /*  133052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133061 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10059>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133075 */     GIR_RootConstrainSelectedInstOperands,
     /*  133076 */     // GIR_Coverage, 65258,
     /*  133076 */     GIR_EraseRootFromParent_Done,
     /*  133077 */   // Label 2330: @133077
     /*  133077 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133143), // Rule ID 2539 //
     /*  133082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11275),
     /*  133118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133127 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11275>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133141 */     GIR_RootConstrainSelectedInstOperands,
     /*  133142 */     // GIR_Coverage, 2539,
     /*  133142 */     GIR_EraseRootFromParent_Done,
     /*  133143 */   // Label 2331: @133143
     /*  133143 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133209), // Rule ID 2545 //
     /*  133148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133176 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10059),
     /*  133184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133193 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10059>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133207 */     GIR_RootConstrainSelectedInstOperands,
     /*  133208 */     // GIR_Coverage, 2545,
     /*  133208 */     GIR_EraseRootFromParent_Done,
     /*  133209 */   // Label 2332: @133209
     /*  133209 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133271), // Rule ID 2544 //
     /*  133214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133255 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133269 */     GIR_RootConstrainSelectedInstOperands,
     /*  133270 */     // GIR_Coverage, 2544,
     /*  133270 */     GIR_EraseRootFromParent_Done,
     /*  133271 */   // Label 2333: @133271
     /*  133271 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133333), // Rule ID 65257 //
     /*  133276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133317 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133331 */     GIR_RootConstrainSelectedInstOperands,
     /*  133332 */     // GIR_Coverage, 65257,
     /*  133332 */     GIR_EraseRootFromParent_Done,
     /*  133333 */   // Label 2334: @133333
     /*  133333 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133392), // Rule ID 2466 //
     /*  133338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133378 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133390 */     GIR_RootConstrainSelectedInstOperands,
     /*  133391 */     // GIR_Coverage, 2466,
     /*  133391 */     GIR_EraseRootFromParent_Done,
     /*  133392 */   // Label 2335: @133392
     /*  133392 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133451), // Rule ID 65228 //
     /*  133397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133437 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133449 */     GIR_RootConstrainSelectedInstOperands,
     /*  133450 */     // GIR_Coverage, 65228,
     /*  133450 */     GIR_EraseRootFromParent_Done,
     /*  133451 */   // Label 2336: @133451
     /*  133451 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133507), // Rule ID 65212 //
     /*  133456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133494 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133505 */     GIR_RootConstrainSelectedInstOperands,
     /*  133506 */     // GIR_Coverage, 65212,
     /*  133506 */     GIR_EraseRootFromParent_Done,
     /*  133507 */   // Label 2337: @133507
     /*  133507 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133563), // Rule ID 2440 //
     /*  133512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133544 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133550 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133561 */     GIR_RootConstrainSelectedInstOperands,
     /*  133562 */     // GIR_Coverage, 2440,
     /*  133562 */     GIR_EraseRootFromParent_Done,
     /*  133563 */   // Label 2338: @133563
     /*  133563 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133605), // Rule ID 80 //
     /*  133568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  133571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  133587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  133591 */     // MIs[1] Operand 1
     /*  133591 */     // No operand predicates
     /*  133591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133593 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  133593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  133596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  133603 */     GIR_RootConstrainSelectedInstOperands,
     /*  133604 */     // GIR_Coverage, 80,
     /*  133604 */     GIR_EraseRootFromParent_Done,
     /*  133605 */   // Label 2339: @133605
     /*  133605 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133632), // Rule ID 78 //
     /*  133610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  133613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133625 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  133630 */     GIR_RootConstrainSelectedInstOperands,
     /*  133631 */     // GIR_Coverage, 78,
     /*  133631 */     GIR_Done,
     /*  133632 */   // Label 2340: @133632
     /*  133632 */   GIM_Reject,
     /*  133633 */ // Label 2312: @133633
     /*  133633 */ GIM_Reject,
     /*  133634 */ // Label 2255: @133634
     /*  133634 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(134244),
     /*  133639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133649 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133715), // Rule ID 71440 //
     /*  133654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133696 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133713 */     GIR_RootConstrainSelectedInstOperands,
     /*  133714 */     // GIR_Coverage, 71440,
     /*  133714 */     GIR_EraseRootFromParent_Done,
     /*  133715 */   // Label 2342: @133715
     /*  133715 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133781), // Rule ID 71441 //
     /*  133720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133762 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133779 */     GIR_RootConstrainSelectedInstOperands,
     /*  133780 */     // GIR_Coverage, 71441,
     /*  133780 */     GIR_EraseRootFromParent_Done,
     /*  133781 */   // Label 2343: @133781
     /*  133781 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133847), // Rule ID 71438 //
     /*  133786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133828 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133845 */     GIR_RootConstrainSelectedInstOperands,
     /*  133846 */     // GIR_Coverage, 71438,
     /*  133846 */     GIR_EraseRootFromParent_Done,
     /*  133847 */   // Label 2344: @133847
     /*  133847 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133913), // Rule ID 71439 //
     /*  133852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133894 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133911 */     GIR_RootConstrainSelectedInstOperands,
     /*  133912 */     // GIR_Coverage, 71439,
     /*  133912 */     GIR_EraseRootFromParent_Done,
     /*  133913 */   // Label 2345: @133913
     /*  133913 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133979), // Rule ID 71436 //
     /*  133918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  133937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  133941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133960 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  133963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133977 */     GIR_RootConstrainSelectedInstOperands,
     /*  133978 */     // GIR_Coverage, 71436,
     /*  133978 */     GIR_EraseRootFromParent_Done,
     /*  133979 */   // Label 2346: @133979
     /*  133979 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134045), // Rule ID 71437 //
     /*  133984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134026 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134043 */     GIR_RootConstrainSelectedInstOperands,
     /*  134044 */     // GIR_Coverage, 71437,
     /*  134044 */     GIR_EraseRootFromParent_Done,
     /*  134045 */   // Label 2347: @134045
     /*  134045 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134111), // Rule ID 53166 //
     /*  134050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134092 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134109 */     GIR_RootConstrainSelectedInstOperands,
     /*  134110 */     // GIR_Coverage, 53166,
     /*  134110 */     GIR_EraseRootFromParent_Done,
     /*  134111 */   // Label 2348: @134111
     /*  134111 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134177), // Rule ID 53167 //
     /*  134116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134158 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134175 */     GIR_RootConstrainSelectedInstOperands,
     /*  134176 */     // GIR_Coverage, 53167,
     /*  134176 */     GIR_EraseRootFromParent_Done,
     /*  134177 */   // Label 2349: @134177
     /*  134177 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134210), // Rule ID 53154 //
     /*  134182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134193 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134208 */     GIR_RootConstrainSelectedInstOperands,
     /*  134209 */     // GIR_Coverage, 53154,
     /*  134209 */     GIR_EraseRootFromParent_Done,
     /*  134210 */   // Label 2350: @134210
     /*  134210 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134243), // Rule ID 53155 //
     /*  134215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134226 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134241 */     GIR_RootConstrainSelectedInstOperands,
     /*  134242 */     // GIR_Coverage, 53155,
     /*  134242 */     GIR_EraseRootFromParent_Done,
     /*  134243 */   // Label 2351: @134243
     /*  134243 */   GIM_Reject,
     /*  134244 */ // Label 2341: @134244
     /*  134244 */ GIM_Reject,
     /*  134245 */ // Label 2256: @134245
     /*  134245 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134359),
     /*  134250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  134253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  134256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134268 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134313), // Rule ID 47776 //
     /*  134273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134276 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  134276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134311 */     GIR_RootConstrainSelectedInstOperands,
     /*  134312 */     // GIR_Coverage, 47776,
     /*  134312 */     GIR_EraseRootFromParent_Done,
     /*  134313 */   // Label 2353: @134313
     /*  134313 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134358), // Rule ID 47777 //
     /*  134318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134321 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  134321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134356 */     GIR_RootConstrainSelectedInstOperands,
     /*  134357 */     // GIR_Coverage, 47777,
     /*  134357 */     GIR_EraseRootFromParent_Done,
     /*  134358 */   // Label 2354: @134358
     /*  134358 */   GIM_Reject,
     /*  134359 */ // Label 2352: @134359
     /*  134359 */ GIM_Reject,
     /*  134360 */ // Label 2257: @134360
     /*  134360 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134474),
     /*  134365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  134368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  134371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134383 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134428), // Rule ID 47788 //
     /*  134388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134391 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  134391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134426 */     GIR_RootConstrainSelectedInstOperands,
     /*  134427 */     // GIR_Coverage, 47788,
     /*  134427 */     GIR_EraseRootFromParent_Done,
     /*  134428 */   // Label 2356: @134428
     /*  134428 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134473), // Rule ID 47789 //
     /*  134433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134436 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  134436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134471 */     GIR_RootConstrainSelectedInstOperands,
     /*  134472 */     // GIR_Coverage, 47789,
     /*  134472 */     GIR_EraseRootFromParent_Done,
     /*  134473 */   // Label 2357: @134473
     /*  134473 */   GIM_Reject,
     /*  134474 */ // Label 2355: @134474
     /*  134474 */ GIM_Reject,
     /*  134475 */ // Label 2258: @134475
     /*  134475 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134589),
     /*  134480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  134483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  134486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134498 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134543), // Rule ID 47796 //
     /*  134503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134506 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  134506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  134523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134541 */     GIR_RootConstrainSelectedInstOperands,
     /*  134542 */     // GIR_Coverage, 47796,
     /*  134542 */     GIR_EraseRootFromParent_Done,
     /*  134543 */   // Label 2359: @134543
     /*  134543 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134588), // Rule ID 47797 //
     /*  134548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134551 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  134551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  134568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134586 */     GIR_RootConstrainSelectedInstOperands,
     /*  134587 */     // GIR_Coverage, 47797,
     /*  134587 */     GIR_EraseRootFromParent_Done,
     /*  134588 */   // Label 2360: @134588
     /*  134588 */   GIM_Reject,
     /*  134589 */ // Label 2358: @134589
     /*  134589 */ GIM_Reject,
     /*  134590 */ // Label 2259: @134590
     /*  134590 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134704),
     /*  134595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  134598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  134601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134613 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134658), // Rule ID 47812 //
     /*  134618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  134621 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  134621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  134624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  134638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134656 */     GIR_RootConstrainSelectedInstOperands,
     /*  134657 */     // GIR_Coverage, 47812,
     /*  134657 */     GIR_EraseRootFromParent_Done,
     /*  134658 */   // Label 2362: @134658
     /*  134658 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134703), // Rule ID 47813 //
     /*  134663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  134666 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  134666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  134669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  134683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  134698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134701 */     GIR_RootConstrainSelectedInstOperands,
     /*  134702 */     // GIR_Coverage, 47813,
     /*  134702 */     GIR_EraseRootFromParent_Done,
     /*  134703 */   // Label 2363: @134703
     /*  134703 */   GIM_Reject,
     /*  134704 */ // Label 2361: @134704
     /*  134704 */ GIM_Reject,
     /*  134705 */ // Label 2260: @134705
     /*  134705 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135315),
     /*  134710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134720 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134786), // Rule ID 71468 //
     /*  134725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134767 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134784 */     GIR_RootConstrainSelectedInstOperands,
     /*  134785 */     // GIR_Coverage, 71468,
     /*  134785 */     GIR_EraseRootFromParent_Done,
     /*  134786 */   // Label 2365: @134786
     /*  134786 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(134852), // Rule ID 71469 //
     /*  134791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134833 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134850 */     GIR_RootConstrainSelectedInstOperands,
     /*  134851 */     // GIR_Coverage, 71469,
     /*  134851 */     GIR_EraseRootFromParent_Done,
     /*  134852 */   // Label 2366: @134852
     /*  134852 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(134918), // Rule ID 71466 //
     /*  134857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134899 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134916 */     GIR_RootConstrainSelectedInstOperands,
     /*  134917 */     // GIR_Coverage, 71466,
     /*  134917 */     GIR_EraseRootFromParent_Done,
     /*  134918 */   // Label 2367: @134918
     /*  134918 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(134984), // Rule ID 71467 //
     /*  134923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  134938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  134942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134965 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  134968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134982 */     GIR_RootConstrainSelectedInstOperands,
     /*  134983 */     // GIR_Coverage, 71467,
     /*  134983 */     GIR_EraseRootFromParent_Done,
     /*  134984 */   // Label 2368: @134984
     /*  134984 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135050), // Rule ID 71464 //
     /*  134989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135031 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135048 */     GIR_RootConstrainSelectedInstOperands,
     /*  135049 */     // GIR_Coverage, 71464,
     /*  135049 */     GIR_EraseRootFromParent_Done,
     /*  135050 */   // Label 2369: @135050
     /*  135050 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135116), // Rule ID 71465 //
     /*  135055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135097 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135114 */     GIR_RootConstrainSelectedInstOperands,
     /*  135115 */     // GIR_Coverage, 71465,
     /*  135115 */     GIR_EraseRootFromParent_Done,
     /*  135116 */   // Label 2370: @135116
     /*  135116 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135182), // Rule ID 53184 //
     /*  135121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135163 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135180 */     GIR_RootConstrainSelectedInstOperands,
     /*  135181 */     // GIR_Coverage, 53184,
     /*  135181 */     GIR_EraseRootFromParent_Done,
     /*  135182 */   // Label 2371: @135182
     /*  135182 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135248), // Rule ID 53185 //
     /*  135187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135229 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135246 */     GIR_RootConstrainSelectedInstOperands,
     /*  135247 */     // GIR_Coverage, 53185,
     /*  135247 */     GIR_EraseRootFromParent_Done,
     /*  135248 */   // Label 2372: @135248
     /*  135248 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135281), // Rule ID 53172 //
     /*  135253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135264 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135279 */     GIR_RootConstrainSelectedInstOperands,
     /*  135280 */     // GIR_Coverage, 53172,
     /*  135280 */     GIR_EraseRootFromParent_Done,
     /*  135281 */   // Label 2373: @135281
     /*  135281 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135314), // Rule ID 53173 //
     /*  135286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135297 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135312 */     GIR_RootConstrainSelectedInstOperands,
     /*  135313 */     // GIR_Coverage, 53173,
     /*  135313 */     GIR_EraseRootFromParent_Done,
     /*  135314 */   // Label 2374: @135314
     /*  135314 */   GIM_Reject,
     /*  135315 */ // Label 2364: @135315
     /*  135315 */ GIM_Reject,
     /*  135316 */ // Label 2261: @135316
     /*  135316 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135430),
     /*  135321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  135324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135339 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135384), // Rule ID 47780 //
     /*  135344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135347 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135382 */     GIR_RootConstrainSelectedInstOperands,
     /*  135383 */     // GIR_Coverage, 47780,
     /*  135383 */     GIR_EraseRootFromParent_Done,
     /*  135384 */   // Label 2376: @135384
     /*  135384 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135429), // Rule ID 47781 //
     /*  135389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135392 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135427 */     GIR_RootConstrainSelectedInstOperands,
     /*  135428 */     // GIR_Coverage, 47781,
     /*  135428 */     GIR_EraseRootFromParent_Done,
     /*  135429 */   // Label 2377: @135429
     /*  135429 */   GIM_Reject,
     /*  135430 */ // Label 2375: @135430
     /*  135430 */ GIM_Reject,
     /*  135431 */ // Label 2262: @135431
     /*  135431 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135545),
     /*  135436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  135439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135454 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135499), // Rule ID 47792 //
     /*  135459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135462 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135497 */     GIR_RootConstrainSelectedInstOperands,
     /*  135498 */     // GIR_Coverage, 47792,
     /*  135498 */     GIR_EraseRootFromParent_Done,
     /*  135499 */   // Label 2379: @135499
     /*  135499 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135544), // Rule ID 47793 //
     /*  135504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135507 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135542 */     GIR_RootConstrainSelectedInstOperands,
     /*  135543 */     // GIR_Coverage, 47793,
     /*  135543 */     GIR_EraseRootFromParent_Done,
     /*  135544 */   // Label 2380: @135544
     /*  135544 */   GIM_Reject,
     /*  135545 */ // Label 2378: @135545
     /*  135545 */ GIM_Reject,
     /*  135546 */ // Label 2263: @135546
     /*  135546 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135660),
     /*  135551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  135554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  135557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135569 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(135614), // Rule ID 47808 //
     /*  135574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135577 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  135577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  135580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135612 */     GIR_RootConstrainSelectedInstOperands,
     /*  135613 */     // GIR_Coverage, 47808,
     /*  135613 */     GIR_EraseRootFromParent_Done,
     /*  135614 */   // Label 2382: @135614
     /*  135614 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135659), // Rule ID 47809 //
     /*  135619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135622 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  135625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135657 */     GIR_RootConstrainSelectedInstOperands,
     /*  135658 */     // GIR_Coverage, 47809,
     /*  135658 */     GIR_EraseRootFromParent_Done,
     /*  135659 */   // Label 2383: @135659
     /*  135659 */   GIM_Reject,
     /*  135660 */ // Label 2381: @135660
     /*  135660 */ GIM_Reject,
     /*  135661 */ // Label 2264: @135661
     /*  135661 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135775),
     /*  135666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  135669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  135672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  135684 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135729), // Rule ID 47852 //
     /*  135689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135692 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  135695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  135709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135727 */     GIR_RootConstrainSelectedInstOperands,
     /*  135728 */     // GIR_Coverage, 47852,
     /*  135728 */     GIR_EraseRootFromParent_Done,
     /*  135729 */   // Label 2385: @135729
     /*  135729 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135774), // Rule ID 47853 //
     /*  135734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135737 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  135740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  135754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135772 */     GIR_RootConstrainSelectedInstOperands,
     /*  135773 */     // GIR_Coverage, 47853,
     /*  135773 */     GIR_EraseRootFromParent_Done,
     /*  135774 */   // Label 2386: @135774
     /*  135774 */   GIM_Reject,
     /*  135775 */ // Label 2384: @135775
     /*  135775 */ GIM_Reject,
     /*  135776 */ // Label 2265: @135776
     /*  135776 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136386),
     /*  135781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135791 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(135857), // Rule ID 71496 //
     /*  135796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135838 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135855 */     GIR_RootConstrainSelectedInstOperands,
     /*  135856 */     // GIR_Coverage, 71496,
     /*  135856 */     GIR_EraseRootFromParent_Done,
     /*  135857 */   // Label 2388: @135857
     /*  135857 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(135923), // Rule ID 71497 //
     /*  135862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135904 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135921 */     GIR_RootConstrainSelectedInstOperands,
     /*  135922 */     // GIR_Coverage, 71497,
     /*  135922 */     GIR_EraseRootFromParent_Done,
     /*  135923 */   // Label 2389: @135923
     /*  135923 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(135989), // Rule ID 71494 //
     /*  135928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  135943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  135947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135970 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  135973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135987 */     GIR_RootConstrainSelectedInstOperands,
     /*  135988 */     // GIR_Coverage, 71494,
     /*  135988 */     GIR_EraseRootFromParent_Done,
     /*  135989 */   // Label 2390: @135989
     /*  135989 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(136055), // Rule ID 71495 //
     /*  135994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136036 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136053 */     GIR_RootConstrainSelectedInstOperands,
     /*  136054 */     // GIR_Coverage, 71495,
     /*  136054 */     GIR_EraseRootFromParent_Done,
     /*  136055 */   // Label 2391: @136055
     /*  136055 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136121), // Rule ID 71492 //
     /*  136060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136102 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136119 */     GIR_RootConstrainSelectedInstOperands,
     /*  136120 */     // GIR_Coverage, 71492,
     /*  136120 */     GIR_EraseRootFromParent_Done,
     /*  136121 */   // Label 2392: @136121
     /*  136121 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136187), // Rule ID 71493 //
     /*  136126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136168 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136185 */     GIR_RootConstrainSelectedInstOperands,
     /*  136186 */     // GIR_Coverage, 71493,
     /*  136186 */     GIR_EraseRootFromParent_Done,
     /*  136187 */   // Label 2393: @136187
     /*  136187 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136253), // Rule ID 53202 //
     /*  136192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136234 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136251 */     GIR_RootConstrainSelectedInstOperands,
     /*  136252 */     // GIR_Coverage, 53202,
     /*  136252 */     GIR_EraseRootFromParent_Done,
     /*  136253 */   // Label 2394: @136253
     /*  136253 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136319), // Rule ID 53203 //
     /*  136258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136300 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136317 */     GIR_RootConstrainSelectedInstOperands,
     /*  136318 */     // GIR_Coverage, 53203,
     /*  136318 */     GIR_EraseRootFromParent_Done,
     /*  136319 */   // Label 2395: @136319
     /*  136319 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136352), // Rule ID 53190 //
     /*  136324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136335 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136350 */     GIR_RootConstrainSelectedInstOperands,
     /*  136351 */     // GIR_Coverage, 53190,
     /*  136351 */     GIR_EraseRootFromParent_Done,
     /*  136352 */   // Label 2396: @136352
     /*  136352 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136385), // Rule ID 53191 //
     /*  136357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136368 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136383 */     GIR_RootConstrainSelectedInstOperands,
     /*  136384 */     // GIR_Coverage, 53191,
     /*  136384 */     GIR_EraseRootFromParent_Done,
     /*  136385 */   // Label 2397: @136385
     /*  136385 */   GIM_Reject,
     /*  136386 */ // Label 2387: @136386
     /*  136386 */ GIM_Reject,
     /*  136387 */ // Label 2266: @136387
     /*  136387 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136501),
     /*  136392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  136395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  136398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136410 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136455), // Rule ID 47784 //
     /*  136415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136418 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136453 */     GIR_RootConstrainSelectedInstOperands,
     /*  136454 */     // GIR_Coverage, 47784,
     /*  136454 */     GIR_EraseRootFromParent_Done,
     /*  136455 */   // Label 2399: @136455
     /*  136455 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136500), // Rule ID 47785 //
     /*  136460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136463 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136498 */     GIR_RootConstrainSelectedInstOperands,
     /*  136499 */     // GIR_Coverage, 47785,
     /*  136499 */     GIR_EraseRootFromParent_Done,
     /*  136500 */   // Label 2400: @136500
     /*  136500 */   GIM_Reject,
     /*  136501 */ // Label 2398: @136501
     /*  136501 */ GIM_Reject,
     /*  136502 */ // Label 2267: @136502
     /*  136502 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136616),
     /*  136507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  136510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  136513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136525 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136570), // Rule ID 47804 //
     /*  136530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136533 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  136533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  136536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136568 */     GIR_RootConstrainSelectedInstOperands,
     /*  136569 */     // GIR_Coverage, 47804,
     /*  136569 */     GIR_EraseRootFromParent_Done,
     /*  136570 */   // Label 2402: @136570
     /*  136570 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136615), // Rule ID 47805 //
     /*  136575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136578 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  136578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  136581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136613 */     GIR_RootConstrainSelectedInstOperands,
     /*  136614 */     // GIR_Coverage, 47805,
     /*  136614 */     GIR_EraseRootFromParent_Done,
     /*  136615 */   // Label 2403: @136615
     /*  136615 */   GIM_Reject,
     /*  136616 */ // Label 2401: @136616
     /*  136616 */ GIM_Reject,
     /*  136617 */ // Label 2268: @136617
     /*  136617 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136731),
     /*  136622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  136625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  136628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136640 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(136685), // Rule ID 47840 //
     /*  136645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136648 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  136651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136683 */     GIR_RootConstrainSelectedInstOperands,
     /*  136684 */     // GIR_Coverage, 47840,
     /*  136684 */     GIR_EraseRootFromParent_Done,
     /*  136685 */   // Label 2405: @136685
     /*  136685 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136730), // Rule ID 47841 //
     /*  136690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136693 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  136696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136728 */     GIR_RootConstrainSelectedInstOperands,
     /*  136729 */     // GIR_Coverage, 47841,
     /*  136729 */     GIR_EraseRootFromParent_Done,
     /*  136730 */   // Label 2406: @136730
     /*  136730 */   GIM_Reject,
     /*  136731 */ // Label 2404: @136731
     /*  136731 */ GIM_Reject,
     /*  136732 */ // Label 2269: @136732
     /*  136732 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136846),
     /*  136737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  136740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  136743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  136755 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136800), // Rule ID 47856 //
     /*  136760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136763 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  136766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  136780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136798 */     GIR_RootConstrainSelectedInstOperands,
     /*  136799 */     // GIR_Coverage, 47856,
     /*  136799 */     GIR_EraseRootFromParent_Done,
     /*  136800 */   // Label 2408: @136800
     /*  136800 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(136845), // Rule ID 47857 //
     /*  136805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136808 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  136811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  136825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136843 */     GIR_RootConstrainSelectedInstOperands,
     /*  136844 */     // GIR_Coverage, 47857,
     /*  136844 */     GIR_EraseRootFromParent_Done,
     /*  136845 */   // Label 2409: @136845
     /*  136845 */   GIM_Reject,
     /*  136846 */ // Label 2407: @136846
     /*  136846 */ GIM_Reject,
     /*  136847 */ // Label 2270: @136847
     /*  136847 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(137457),
     /*  136852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136862 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(136928), // Rule ID 71524 //
     /*  136867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136909 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  136912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136926 */     GIR_RootConstrainSelectedInstOperands,
     /*  136927 */     // GIR_Coverage, 71524,
     /*  136927 */     GIR_EraseRootFromParent_Done,
     /*  136928 */   // Label 2411: @136928
     /*  136928 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(136994), // Rule ID 71525 //
     /*  136933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  136948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  136952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136975 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  136978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136992 */     GIR_RootConstrainSelectedInstOperands,
     /*  136993 */     // GIR_Coverage, 71525,
     /*  136993 */     GIR_EraseRootFromParent_Done,
     /*  136994 */   // Label 2412: @136994
     /*  136994 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137060), // Rule ID 71522 //
     /*  136999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137041 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137058 */     GIR_RootConstrainSelectedInstOperands,
     /*  137059 */     // GIR_Coverage, 71522,
     /*  137059 */     GIR_EraseRootFromParent_Done,
     /*  137060 */   // Label 2413: @137060
     /*  137060 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137126), // Rule ID 71523 //
     /*  137065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137107 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137124 */     GIR_RootConstrainSelectedInstOperands,
     /*  137125 */     // GIR_Coverage, 71523,
     /*  137125 */     GIR_EraseRootFromParent_Done,
     /*  137126 */   // Label 2414: @137126
     /*  137126 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137192), // Rule ID 71520 //
     /*  137131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137173 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137190 */     GIR_RootConstrainSelectedInstOperands,
     /*  137191 */     // GIR_Coverage, 71520,
     /*  137191 */     GIR_EraseRootFromParent_Done,
     /*  137192 */   // Label 2415: @137192
     /*  137192 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137258), // Rule ID 71521 //
     /*  137197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137239 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137256 */     GIR_RootConstrainSelectedInstOperands,
     /*  137257 */     // GIR_Coverage, 71521,
     /*  137257 */     GIR_EraseRootFromParent_Done,
     /*  137258 */   // Label 2416: @137258
     /*  137258 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137324), // Rule ID 53220 //
     /*  137263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137305 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137322 */     GIR_RootConstrainSelectedInstOperands,
     /*  137323 */     // GIR_Coverage, 53220,
     /*  137323 */     GIR_EraseRootFromParent_Done,
     /*  137324 */   // Label 2417: @137324
     /*  137324 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137390), // Rule ID 53221 //
     /*  137329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137371 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137388 */     GIR_RootConstrainSelectedInstOperands,
     /*  137389 */     // GIR_Coverage, 53221,
     /*  137389 */     GIR_EraseRootFromParent_Done,
     /*  137390 */   // Label 2418: @137390
     /*  137390 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137423), // Rule ID 53208 //
     /*  137395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137406 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137421 */     GIR_RootConstrainSelectedInstOperands,
     /*  137422 */     // GIR_Coverage, 53208,
     /*  137422 */     GIR_EraseRootFromParent_Done,
     /*  137423 */   // Label 2419: @137423
     /*  137423 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137456), // Rule ID 53209 //
     /*  137428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137439 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137454 */     GIR_RootConstrainSelectedInstOperands,
     /*  137455 */     // GIR_Coverage, 53209,
     /*  137455 */     GIR_EraseRootFromParent_Done,
     /*  137456 */   // Label 2420: @137456
     /*  137456 */   GIM_Reject,
     /*  137457 */ // Label 2410: @137457
     /*  137457 */ GIM_Reject,
     /*  137458 */ // Label 2271: @137458
     /*  137458 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137572),
     /*  137463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  137466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  137469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137481 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137526), // Rule ID 47800 //
     /*  137486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137489 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137524 */     GIR_RootConstrainSelectedInstOperands,
     /*  137525 */     // GIR_Coverage, 47800,
     /*  137525 */     GIR_EraseRootFromParent_Done,
     /*  137526 */   // Label 2422: @137526
     /*  137526 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137571), // Rule ID 47801 //
     /*  137531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137534 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  137534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137569 */     GIR_RootConstrainSelectedInstOperands,
     /*  137570 */     // GIR_Coverage, 47801,
     /*  137570 */     GIR_EraseRootFromParent_Done,
     /*  137571 */   // Label 2423: @137571
     /*  137571 */   GIM_Reject,
     /*  137572 */ // Label 2421: @137572
     /*  137572 */ GIM_Reject,
     /*  137573 */ // Label 2272: @137573
     /*  137573 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137687),
     /*  137578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  137581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  137584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137596 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137641), // Rule ID 47828 //
     /*  137601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137604 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  137607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137639 */     GIR_RootConstrainSelectedInstOperands,
     /*  137640 */     // GIR_Coverage, 47828,
     /*  137640 */     GIR_EraseRootFromParent_Done,
     /*  137641 */   // Label 2425: @137641
     /*  137641 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137686), // Rule ID 47829 //
     /*  137646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137649 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  137652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137684 */     GIR_RootConstrainSelectedInstOperands,
     /*  137685 */     // GIR_Coverage, 47829,
     /*  137685 */     GIR_EraseRootFromParent_Done,
     /*  137686 */   // Label 2426: @137686
     /*  137686 */   GIM_Reject,
     /*  137687 */ // Label 2424: @137687
     /*  137687 */ GIM_Reject,
     /*  137688 */ // Label 2273: @137688
     /*  137688 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137802),
     /*  137693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  137696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  137699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137711 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(137756), // Rule ID 47844 //
     /*  137716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137719 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  137722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137754 */     GIR_RootConstrainSelectedInstOperands,
     /*  137755 */     // GIR_Coverage, 47844,
     /*  137755 */     GIR_EraseRootFromParent_Done,
     /*  137756 */   // Label 2428: @137756
     /*  137756 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137801), // Rule ID 47845 //
     /*  137761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137764 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  137767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137799 */     GIR_RootConstrainSelectedInstOperands,
     /*  137800 */     // GIR_Coverage, 47845,
     /*  137800 */     GIR_EraseRootFromParent_Done,
     /*  137801 */   // Label 2429: @137801
     /*  137801 */   GIM_Reject,
     /*  137802 */ // Label 2427: @137802
     /*  137802 */ GIM_Reject,
     /*  137803 */ // Label 2274: @137803
     /*  137803 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137917),
     /*  137808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  137811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  137814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  137826 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(137871), // Rule ID 47860 //
     /*  137831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137834 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  137837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  137851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137869 */     GIR_RootConstrainSelectedInstOperands,
     /*  137870 */     // GIR_Coverage, 47860,
     /*  137870 */     GIR_EraseRootFromParent_Done,
     /*  137871 */   // Label 2431: @137871
     /*  137871 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(137916), // Rule ID 47861 //
     /*  137876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137879 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  137882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  137896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137914 */     GIR_RootConstrainSelectedInstOperands,
     /*  137915 */     // GIR_Coverage, 47861,
     /*  137915 */     GIR_EraseRootFromParent_Done,
     /*  137916 */   // Label 2432: @137916
     /*  137916 */   GIM_Reject,
     /*  137917 */ // Label 2430: @137917
     /*  137917 */ GIM_Reject,
     /*  137918 */ // Label 2275: @137918
     /*  137918 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138528),
     /*  137923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  137926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  137929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137933 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(137999), // Rule ID 71552 //
     /*  137938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  137953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  137957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137980 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  137983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137997 */     GIR_RootConstrainSelectedInstOperands,
     /*  137998 */     // GIR_Coverage, 71552,
     /*  137998 */     GIR_EraseRootFromParent_Done,
     /*  137999 */   // Label 2434: @137999
     /*  137999 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138065), // Rule ID 71553 //
     /*  138004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138046 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138063 */     GIR_RootConstrainSelectedInstOperands,
     /*  138064 */     // GIR_Coverage, 71553,
     /*  138064 */     GIR_EraseRootFromParent_Done,
     /*  138065 */   // Label 2435: @138065
     /*  138065 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138131), // Rule ID 71550 //
     /*  138070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138112 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138129 */     GIR_RootConstrainSelectedInstOperands,
     /*  138130 */     // GIR_Coverage, 71550,
     /*  138130 */     GIR_EraseRootFromParent_Done,
     /*  138131 */   // Label 2436: @138131
     /*  138131 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138197), // Rule ID 71551 //
     /*  138136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138178 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138195 */     GIR_RootConstrainSelectedInstOperands,
     /*  138196 */     // GIR_Coverage, 71551,
     /*  138196 */     GIR_EraseRootFromParent_Done,
     /*  138197 */   // Label 2437: @138197
     /*  138197 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138263), // Rule ID 71548 //
     /*  138202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138244 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138261 */     GIR_RootConstrainSelectedInstOperands,
     /*  138262 */     // GIR_Coverage, 71548,
     /*  138262 */     GIR_EraseRootFromParent_Done,
     /*  138263 */   // Label 2438: @138263
     /*  138263 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138329), // Rule ID 71549 //
     /*  138268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138310 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138327 */     GIR_RootConstrainSelectedInstOperands,
     /*  138328 */     // GIR_Coverage, 71549,
     /*  138328 */     GIR_EraseRootFromParent_Done,
     /*  138329 */   // Label 2439: @138329
     /*  138329 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138395), // Rule ID 53238 //
     /*  138334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138376 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138393 */     GIR_RootConstrainSelectedInstOperands,
     /*  138394 */     // GIR_Coverage, 53238,
     /*  138394 */     GIR_EraseRootFromParent_Done,
     /*  138395 */   // Label 2440: @138395
     /*  138395 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138461), // Rule ID 53239 //
     /*  138400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138442 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138459 */     GIR_RootConstrainSelectedInstOperands,
     /*  138460 */     // GIR_Coverage, 53239,
     /*  138460 */     GIR_EraseRootFromParent_Done,
     /*  138461 */   // Label 2441: @138461
     /*  138461 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138494), // Rule ID 53226 //
     /*  138466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138477 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138492 */     GIR_RootConstrainSelectedInstOperands,
     /*  138493 */     // GIR_Coverage, 53226,
     /*  138493 */     GIR_EraseRootFromParent_Done,
     /*  138494 */   // Label 2442: @138494
     /*  138494 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138527), // Rule ID 53227 //
     /*  138499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138510 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138525 */     GIR_RootConstrainSelectedInstOperands,
     /*  138526 */     // GIR_Coverage, 53227,
     /*  138526 */     GIR_EraseRootFromParent_Done,
     /*  138527 */   // Label 2443: @138527
     /*  138527 */   GIM_Reject,
     /*  138528 */ // Label 2433: @138528
     /*  138528 */ GIM_Reject,
     /*  138529 */ // Label 2276: @138529
     /*  138529 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138643),
     /*  138534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  138537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  138540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138552 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(138597), // Rule ID 47816 //
     /*  138557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138560 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  138560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  138563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138595 */     GIR_RootConstrainSelectedInstOperands,
     /*  138596 */     // GIR_Coverage, 47816,
     /*  138596 */     GIR_EraseRootFromParent_Done,
     /*  138597 */   // Label 2445: @138597
     /*  138597 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138642), // Rule ID 47817 //
     /*  138602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138605 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  138608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138640 */     GIR_RootConstrainSelectedInstOperands,
     /*  138641 */     // GIR_Coverage, 47817,
     /*  138641 */     GIR_EraseRootFromParent_Done,
     /*  138642 */   // Label 2446: @138642
     /*  138642 */   GIM_Reject,
     /*  138643 */ // Label 2444: @138643
     /*  138643 */ GIM_Reject,
     /*  138644 */ // Label 2277: @138644
     /*  138644 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138758),
     /*  138649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  138652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  138655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138667 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138712), // Rule ID 47832 //
     /*  138672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138675 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  138678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138710 */     GIR_RootConstrainSelectedInstOperands,
     /*  138711 */     // GIR_Coverage, 47832,
     /*  138711 */     GIR_EraseRootFromParent_Done,
     /*  138712 */   // Label 2448: @138712
     /*  138712 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138757), // Rule ID 47833 //
     /*  138717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138720 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  138723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138755 */     GIR_RootConstrainSelectedInstOperands,
     /*  138756 */     // GIR_Coverage, 47833,
     /*  138756 */     GIR_EraseRootFromParent_Done,
     /*  138757 */   // Label 2449: @138757
     /*  138757 */   GIM_Reject,
     /*  138758 */ // Label 2447: @138758
     /*  138758 */ GIM_Reject,
     /*  138759 */ // Label 2278: @138759
     /*  138759 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138873),
     /*  138764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  138767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  138770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138782 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(138827), // Rule ID 47848 //
     /*  138787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138790 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  138793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138825 */     GIR_RootConstrainSelectedInstOperands,
     /*  138826 */     // GIR_Coverage, 47848,
     /*  138826 */     GIR_EraseRootFromParent_Done,
     /*  138827 */   // Label 2451: @138827
     /*  138827 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138872), // Rule ID 47849 //
     /*  138832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138835 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  138838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138870 */     GIR_RootConstrainSelectedInstOperands,
     /*  138871 */     // GIR_Coverage, 47849,
     /*  138871 */     GIR_EraseRootFromParent_Done,
     /*  138872 */   // Label 2452: @138872
     /*  138872 */   GIM_Reject,
     /*  138873 */ // Label 2450: @138873
     /*  138873 */ GIM_Reject,
     /*  138874 */ // Label 2279: @138874
     /*  138874 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(139484),
     /*  138879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138889 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(138955), // Rule ID 71580 //
     /*  138894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138936 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  138939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138953 */     GIR_RootConstrainSelectedInstOperands,
     /*  138954 */     // GIR_Coverage, 71580,
     /*  138954 */     GIR_EraseRootFromParent_Done,
     /*  138955 */   // Label 2454: @138955
     /*  138955 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139021), // Rule ID 71581 //
     /*  138960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  138975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  138979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139002 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139019 */     GIR_RootConstrainSelectedInstOperands,
     /*  139020 */     // GIR_Coverage, 71581,
     /*  139020 */     GIR_EraseRootFromParent_Done,
     /*  139021 */   // Label 2455: @139021
     /*  139021 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139087), // Rule ID 71578 //
     /*  139026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139068 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139085 */     GIR_RootConstrainSelectedInstOperands,
     /*  139086 */     // GIR_Coverage, 71578,
     /*  139086 */     GIR_EraseRootFromParent_Done,
     /*  139087 */   // Label 2456: @139087
     /*  139087 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139153), // Rule ID 71579 //
     /*  139092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139134 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139151 */     GIR_RootConstrainSelectedInstOperands,
     /*  139152 */     // GIR_Coverage, 71579,
     /*  139152 */     GIR_EraseRootFromParent_Done,
     /*  139153 */   // Label 2457: @139153
     /*  139153 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139219), // Rule ID 71576 //
     /*  139158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139200 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139217 */     GIR_RootConstrainSelectedInstOperands,
     /*  139218 */     // GIR_Coverage, 71576,
     /*  139218 */     GIR_EraseRootFromParent_Done,
     /*  139219 */   // Label 2458: @139219
     /*  139219 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139285), // Rule ID 71577 //
     /*  139224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139266 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139283 */     GIR_RootConstrainSelectedInstOperands,
     /*  139284 */     // GIR_Coverage, 71577,
     /*  139284 */     GIR_EraseRootFromParent_Done,
     /*  139285 */   // Label 2459: @139285
     /*  139285 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139351), // Rule ID 53256 //
     /*  139290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139332 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139349 */     GIR_RootConstrainSelectedInstOperands,
     /*  139350 */     // GIR_Coverage, 53256,
     /*  139350 */     GIR_EraseRootFromParent_Done,
     /*  139351 */   // Label 2460: @139351
     /*  139351 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139417), // Rule ID 53257 //
     /*  139356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139398 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139415 */     GIR_RootConstrainSelectedInstOperands,
     /*  139416 */     // GIR_Coverage, 53257,
     /*  139416 */     GIR_EraseRootFromParent_Done,
     /*  139417 */   // Label 2461: @139417
     /*  139417 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139450), // Rule ID 53244 //
     /*  139422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139433 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139448 */     GIR_RootConstrainSelectedInstOperands,
     /*  139449 */     // GIR_Coverage, 53244,
     /*  139449 */     GIR_EraseRootFromParent_Done,
     /*  139450 */   // Label 2462: @139450
     /*  139450 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139483), // Rule ID 53245 //
     /*  139455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139466 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139481 */     GIR_RootConstrainSelectedInstOperands,
     /*  139482 */     // GIR_Coverage, 53245,
     /*  139482 */     GIR_EraseRootFromParent_Done,
     /*  139483 */   // Label 2463: @139483
     /*  139483 */   GIM_Reject,
     /*  139484 */ // Label 2453: @139484
     /*  139484 */ GIM_Reject,
     /*  139485 */ // Label 2280: @139485
     /*  139485 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139599),
     /*  139490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  139493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  139496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139508 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139553), // Rule ID 47820 //
     /*  139513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139516 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  139519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139551 */     GIR_RootConstrainSelectedInstOperands,
     /*  139552 */     // GIR_Coverage, 47820,
     /*  139552 */     GIR_EraseRootFromParent_Done,
     /*  139553 */   // Label 2465: @139553
     /*  139553 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139598), // Rule ID 47821 //
     /*  139558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139561 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  139564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139596 */     GIR_RootConstrainSelectedInstOperands,
     /*  139597 */     // GIR_Coverage, 47821,
     /*  139597 */     GIR_EraseRootFromParent_Done,
     /*  139598 */   // Label 2466: @139598
     /*  139598 */   GIM_Reject,
     /*  139599 */ // Label 2464: @139599
     /*  139599 */ GIM_Reject,
     /*  139600 */ // Label 2281: @139600
     /*  139600 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139714),
     /*  139605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  139608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  139611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139623 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139668), // Rule ID 47836 //
     /*  139628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139631 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  139634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139666 */     GIR_RootConstrainSelectedInstOperands,
     /*  139667 */     // GIR_Coverage, 47836,
     /*  139667 */     GIR_EraseRootFromParent_Done,
     /*  139668 */   // Label 2468: @139668
     /*  139668 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139713), // Rule ID 47837 //
     /*  139673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139676 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  139679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139711 */     GIR_RootConstrainSelectedInstOperands,
     /*  139712 */     // GIR_Coverage, 47837,
     /*  139712 */     GIR_EraseRootFromParent_Done,
     /*  139713 */   // Label 2469: @139713
     /*  139713 */   GIM_Reject,
     /*  139714 */ // Label 2467: @139714
     /*  139714 */ GIM_Reject,
     /*  139715 */ // Label 2282: @139715
     /*  139715 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(140325),
     /*  139720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139730 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(139796), // Rule ID 71608 //
     /*  139735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139777 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139794 */     GIR_RootConstrainSelectedInstOperands,
     /*  139795 */     // GIR_Coverage, 71608,
     /*  139795 */     GIR_EraseRootFromParent_Done,
     /*  139796 */   // Label 2471: @139796
     /*  139796 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139862), // Rule ID 71609 //
     /*  139801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139843 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139860 */     GIR_RootConstrainSelectedInstOperands,
     /*  139861 */     // GIR_Coverage, 71609,
     /*  139861 */     GIR_EraseRootFromParent_Done,
     /*  139862 */   // Label 2472: @139862
     /*  139862 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139928), // Rule ID 71606 //
     /*  139867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139909 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139926 */     GIR_RootConstrainSelectedInstOperands,
     /*  139927 */     // GIR_Coverage, 71606,
     /*  139927 */     GIR_EraseRootFromParent_Done,
     /*  139928 */   // Label 2473: @139928
     /*  139928 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(139994), // Rule ID 71607 //
     /*  139933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  139948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  139952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139975 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  139978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139992 */     GIR_RootConstrainSelectedInstOperands,
     /*  139993 */     // GIR_Coverage, 71607,
     /*  139993 */     GIR_EraseRootFromParent_Done,
     /*  139994 */   // Label 2474: @139994
     /*  139994 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(140060), // Rule ID 71604 //
     /*  139999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140041 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140058 */     GIR_RootConstrainSelectedInstOperands,
     /*  140059 */     // GIR_Coverage, 71604,
     /*  140059 */     GIR_EraseRootFromParent_Done,
     /*  140060 */   // Label 2475: @140060
     /*  140060 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140126), // Rule ID 71605 //
     /*  140065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140107 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140124 */     GIR_RootConstrainSelectedInstOperands,
     /*  140125 */     // GIR_Coverage, 71605,
     /*  140125 */     GIR_EraseRootFromParent_Done,
     /*  140126 */   // Label 2476: @140126
     /*  140126 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140192), // Rule ID 53274 //
     /*  140131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140173 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140190 */     GIR_RootConstrainSelectedInstOperands,
     /*  140191 */     // GIR_Coverage, 53274,
     /*  140191 */     GIR_EraseRootFromParent_Done,
     /*  140192 */   // Label 2477: @140192
     /*  140192 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140258), // Rule ID 53275 //
     /*  140197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140239 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140256 */     GIR_RootConstrainSelectedInstOperands,
     /*  140257 */     // GIR_Coverage, 53275,
     /*  140257 */     GIR_EraseRootFromParent_Done,
     /*  140258 */   // Label 2478: @140258
     /*  140258 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140291), // Rule ID 53262 //
     /*  140263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140274 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140289 */     GIR_RootConstrainSelectedInstOperands,
     /*  140290 */     // GIR_Coverage, 53262,
     /*  140290 */     GIR_EraseRootFromParent_Done,
     /*  140291 */   // Label 2479: @140291
     /*  140291 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140324), // Rule ID 53263 //
     /*  140296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140307 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140322 */     GIR_RootConstrainSelectedInstOperands,
     /*  140323 */     // GIR_Coverage, 53263,
     /*  140323 */     GIR_EraseRootFromParent_Done,
     /*  140324 */   // Label 2480: @140324
     /*  140324 */   GIM_Reject,
     /*  140325 */ // Label 2470: @140325
     /*  140325 */ GIM_Reject,
     /*  140326 */ // Label 2283: @140326
     /*  140326 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140440),
     /*  140331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  140334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140349 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140394), // Rule ID 47824 //
     /*  140354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140357 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140392 */     GIR_RootConstrainSelectedInstOperands,
     /*  140393 */     // GIR_Coverage, 47824,
     /*  140393 */     GIR_EraseRootFromParent_Done,
     /*  140394 */   // Label 2482: @140394
     /*  140394 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140439), // Rule ID 47825 //
     /*  140399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140402 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140437 */     GIR_RootConstrainSelectedInstOperands,
     /*  140438 */     // GIR_Coverage, 47825,
     /*  140438 */     GIR_EraseRootFromParent_Done,
     /*  140439 */   // Label 2483: @140439
     /*  140439 */   GIM_Reject,
     /*  140440 */ // Label 2481: @140440
     /*  140440 */ GIM_Reject,
     /*  140441 */ // Label 2284: @140441
     /*  140441 */ GIM_Reject,
     /*  140442 */ // Label 9: @140442
     /*  140442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2515*/ GIMT_Encode4(155348),
     /*  140453 */ /*GILLT_s32*//*Label 2484*/ GIMT_Encode4(140577),
     /*  140457 */ /*GILLT_s64*//*Label 2485*/ GIMT_Encode4(141115),
     /*  140461 */ /*GILLT_nxv1s1*//*Label 2486*/ GIMT_Encode4(141541),
     /*  140465 */ /*GILLT_nxv1s8*//*Label 2487*/ GIMT_Encode4(143152),
     /*  140469 */ /*GILLT_nxv1s16*//*Label 2488*/ GIMT_Encode4(143267),
     /*  140473 */ /*GILLT_nxv1s32*//*Label 2489*/ GIMT_Encode4(143382),
     /*  140477 */ /*GILLT_nxv1s64*//*Label 2490*/ GIMT_Encode4(143497),
     /*  140481 */ /*GILLT_nxv2s1*//*Label 2491*/ GIMT_Encode4(143612),
     /*  140485 */ /*GILLT_nxv2s8*//*Label 2492*/ GIMT_Encode4(145223),
     /*  140489 */ /*GILLT_nxv2s16*//*Label 2493*/ GIMT_Encode4(145338),
     /*  140493 */ /*GILLT_nxv2s32*//*Label 2494*/ GIMT_Encode4(145453),
     /*  140497 */ /*GILLT_nxv2s64*//*Label 2495*/ GIMT_Encode4(145568),
     /*  140501 */ /*GILLT_nxv4s1*//*Label 2496*/ GIMT_Encode4(145683),
     /*  140505 */ /*GILLT_nxv4s8*//*Label 2497*/ GIMT_Encode4(147294),
     /*  140509 */ /*GILLT_nxv4s16*//*Label 2498*/ GIMT_Encode4(147409),
     /*  140513 */ /*GILLT_nxv4s32*//*Label 2499*/ GIMT_Encode4(147524),
     /*  140517 */ /*GILLT_nxv4s64*//*Label 2500*/ GIMT_Encode4(147639),
     /*  140521 */ /*GILLT_nxv8s1*//*Label 2501*/ GIMT_Encode4(147754),
     /*  140525 */ /*GILLT_nxv8s8*//*Label 2502*/ GIMT_Encode4(149365),
     /*  140529 */ /*GILLT_nxv8s16*//*Label 2503*/ GIMT_Encode4(149480),
     /*  140533 */ /*GILLT_nxv8s32*//*Label 2504*/ GIMT_Encode4(149595),
     /*  140537 */ /*GILLT_nxv8s64*//*Label 2505*/ GIMT_Encode4(149710),
     /*  140541 */ /*GILLT_nxv16s1*//*Label 2506*/ GIMT_Encode4(149825),
     /*  140545 */ /*GILLT_nxv16s8*//*Label 2507*/ GIMT_Encode4(151436),
     /*  140549 */ /*GILLT_nxv16s16*//*Label 2508*/ GIMT_Encode4(151551),
     /*  140553 */ /*GILLT_nxv16s32*//*Label 2509*/ GIMT_Encode4(151666),
     /*  140557 */ /*GILLT_nxv32s1*//*Label 2510*/ GIMT_Encode4(151781),
     /*  140561 */ /*GILLT_nxv32s8*//*Label 2511*/ GIMT_Encode4(153392),
     /*  140565 */ /*GILLT_nxv32s16*//*Label 2512*/ GIMT_Encode4(153507),
     /*  140569 */ /*GILLT_nxv64s1*//*Label 2513*/ GIMT_Encode4(153622),
     /*  140573 */ /*GILLT_nxv64s8*//*Label 2514*/ GIMT_Encode4(155233),
     /*  140577 */ // Label 2484: @140577
     /*  140577 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(141114),
     /*  140582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  140585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  140588 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(140671), // Rule ID 2475 //
     /*  140593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140616 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  140620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  140624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140633 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  140633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  140636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  140640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140645 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  140651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  140661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140669 */     GIR_RootConstrainSelectedInstOperands,
     /*  140670 */     // GIR_Coverage, 2475,
     /*  140670 */     GIR_EraseRootFromParent_Done,
     /*  140671 */   // Label 2517: @140671
     /*  140671 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(140730), // Rule ID 2469 //
     /*  140676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140699 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  140703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140716 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  140719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140728 */     GIR_RootConstrainSelectedInstOperands,
     /*  140729 */     // GIR_Coverage, 2469,
     /*  140729 */     GIR_EraseRootFromParent_Done,
     /*  140730 */   // Label 2518: @140730
     /*  140730 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(140789), // Rule ID 65231 //
     /*  140735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  140738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  140754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140762 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  140766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  140775 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  140778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  140787 */     GIR_RootConstrainSelectedInstOperands,
     /*  140788 */     // GIR_Coverage, 65231,
     /*  140788 */     GIR_EraseRootFromParent_Done,
     /*  140789 */   // Label 2519: @140789
     /*  140789 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(140845), // Rule ID 65217 //
     /*  140794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  140826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140843 */     GIR_RootConstrainSelectedInstOperands,
     /*  140844 */     // GIR_Coverage, 65217,
     /*  140844 */     GIR_EraseRootFromParent_Done,
     /*  140845 */   // Label 2520: @140845
     /*  140845 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(140904), // Rule ID 65215 //
     /*  140850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  140887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140889 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140902 */     GIR_RootConstrainSelectedInstOperands,
     /*  140903 */     // GIR_Coverage, 65215,
     /*  140903 */     GIR_EraseRootFromParent_Done,
     /*  140904 */   // Label 2521: @140904
     /*  140904 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(140960), // Rule ID 2443 //
     /*  140909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  140912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  140936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  140945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140947 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  140947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  140950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140958 */     GIR_RootConstrainSelectedInstOperands,
     /*  140959 */     // GIR_Coverage, 2443,
     /*  140959 */     GIR_EraseRootFromParent_Done,
     /*  140960 */   // Label 2522: @140960
     /*  140960 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(141002), // Rule ID 89 //
     /*  140965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  140968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  140976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  140984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  140988 */     // MIs[1] Operand 1
     /*  140988 */     // No operand predicates
     /*  140988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140990 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  140990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  140993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141000 */     GIR_RootConstrainSelectedInstOperands,
     /*  141001 */     // GIR_Coverage, 89,
     /*  141001 */     GIR_EraseRootFromParent_Done,
     /*  141002 */   // Label 2523: @141002
     /*  141002 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(141044), // Rule ID 64521 //
     /*  141007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141030 */     // MIs[1] Operand 1
     /*  141030 */     // No operand predicates
     /*  141030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141032 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141042 */     GIR_RootConstrainSelectedInstOperands,
     /*  141043 */     // GIR_Coverage, 64521,
     /*  141043 */     GIR_EraseRootFromParent_Done,
     /*  141044 */   // Label 2524: @141044
     /*  141044 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(141086), // Rule ID 64525 //
     /*  141049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  141072 */     // MIs[1] Operand 1
     /*  141072 */     // No operand predicates
     /*  141072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141074 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  141074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  141077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141084 */     GIR_RootConstrainSelectedInstOperands,
     /*  141085 */     // GIR_Coverage, 64525,
     /*  141085 */     GIR_EraseRootFromParent_Done,
     /*  141086 */   // Label 2525: @141086
     /*  141086 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(141113), // Rule ID 87 //
     /*  141091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141106 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141111 */     GIR_RootConstrainSelectedInstOperands,
     /*  141112 */     // GIR_Coverage, 87,
     /*  141112 */     GIR_Done,
     /*  141113 */   // Label 2526: @141113
     /*  141113 */   GIM_Reject,
     /*  141114 */ // Label 2516: @141114
     /*  141114 */ GIM_Reject,
     /*  141115 */ // Label 2485: @141115
     /*  141115 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(141540),
     /*  141120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  141123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  141126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141130 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(141209), // Rule ID 2474 //
     /*  141135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141154 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141171 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  141171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  141174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141183 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141207 */     GIR_RootConstrainSelectedInstOperands,
     /*  141208 */     // GIR_Coverage, 2474,
     /*  141208 */     GIR_EraseRootFromParent_Done,
     /*  141209 */   // Label 2528: @141209
     /*  141209 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(141264), // Rule ID 2468 //
     /*  141214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141250 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141262 */     GIR_RootConstrainSelectedInstOperands,
     /*  141263 */     // GIR_Coverage, 2468,
     /*  141263 */     GIR_EraseRootFromParent_Done,
     /*  141264 */   // Label 2529: @141264
     /*  141264 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(141319), // Rule ID 65230 //
     /*  141269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141305 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141317 */     GIR_RootConstrainSelectedInstOperands,
     /*  141318 */     // GIR_Coverage, 65230,
     /*  141318 */     GIR_EraseRootFromParent_Done,
     /*  141319 */   // Label 2530: @141319
     /*  141319 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(141371), // Rule ID 65216 //
     /*  141324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141348 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141358 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141369 */     GIR_RootConstrainSelectedInstOperands,
     /*  141370 */     // GIR_Coverage, 65216,
     /*  141370 */     GIR_EraseRootFromParent_Done,
     /*  141371 */   // Label 2531: @141371
     /*  141371 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(141426), // Rule ID 65214 //
     /*  141376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141411 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141424 */     GIR_RootConstrainSelectedInstOperands,
     /*  141425 */     // GIR_Coverage, 65214,
     /*  141425 */     GIR_EraseRootFromParent_Done,
     /*  141426 */   // Label 2532: @141426
     /*  141426 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(141478), // Rule ID 2442 //
     /*  141431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141465 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141476 */     GIR_RootConstrainSelectedInstOperands,
     /*  141477 */     // GIR_Coverage, 2442,
     /*  141477 */     GIR_EraseRootFromParent_Done,
     /*  141478 */   // Label 2533: @141478
     /*  141478 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(141516), // Rule ID 88 //
     /*  141483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141502 */     // MIs[1] Operand 1
     /*  141502 */     // No operand predicates
     /*  141502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141504 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  141504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141514 */     GIR_RootConstrainSelectedInstOperands,
     /*  141515 */     // GIR_Coverage, 88,
     /*  141515 */     GIR_EraseRootFromParent_Done,
     /*  141516 */   // Label 2534: @141516
     /*  141516 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141539), // Rule ID 86 //
     /*  141521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141532 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141537 */     GIR_RootConstrainSelectedInstOperands,
     /*  141538 */     // GIR_Coverage, 86,
     /*  141538 */     GIR_Done,
     /*  141539 */   // Label 2535: @141539
     /*  141539 */   GIM_Reject,
     /*  141540 */ // Label 2527: @141540
     /*  141540 */ GIM_Reject,
     /*  141541 */ // Label 2486: @141541
     /*  141541 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143151),
     /*  141546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141556 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141625), // Rule ID 53158 //
     /*  141561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141604 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  141607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141623 */     GIR_RootConstrainSelectedInstOperands,
     /*  141624 */     // GIR_Coverage, 53158,
     /*  141624 */     GIR_EraseRootFromParent_Done,
     /*  141625 */   // Label 2537: @141625
     /*  141625 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141694), // Rule ID 53159 //
     /*  141630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141673 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  141676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141692 */     GIR_RootConstrainSelectedInstOperands,
     /*  141693 */     // GIR_Coverage, 53159,
     /*  141693 */     GIR_EraseRootFromParent_Done,
     /*  141694 */   // Label 2538: @141694
     /*  141694 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(141763), // Rule ID 53160 //
     /*  141699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141742 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  141745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141761 */     GIR_RootConstrainSelectedInstOperands,
     /*  141762 */     // GIR_Coverage, 53160,
     /*  141762 */     GIR_EraseRootFromParent_Done,
     /*  141763 */   // Label 2539: @141763
     /*  141763 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141832), // Rule ID 53161 //
     /*  141768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141811 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  141814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141830 */     GIR_RootConstrainSelectedInstOperands,
     /*  141831 */     // GIR_Coverage, 53161,
     /*  141831 */     GIR_EraseRootFromParent_Done,
     /*  141832 */   // Label 2540: @141832
     /*  141832 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141898), // Rule ID 71422 //
     /*  141837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141879 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  141882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141896 */     GIR_RootConstrainSelectedInstOperands,
     /*  141897 */     // GIR_Coverage, 71422,
     /*  141897 */     GIR_EraseRootFromParent_Done,
     /*  141898 */   // Label 2541: @141898
     /*  141898 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141964), // Rule ID 71423 //
     /*  141903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141945 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  141948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141962 */     GIR_RootConstrainSelectedInstOperands,
     /*  141963 */     // GIR_Coverage, 71423,
     /*  141963 */     GIR_EraseRootFromParent_Done,
     /*  141964 */   // Label 2542: @141964
     /*  141964 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(142030), // Rule ID 71420 //
     /*  141969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  141984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  141988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142011 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142028 */     GIR_RootConstrainSelectedInstOperands,
     /*  142029 */     // GIR_Coverage, 71420,
     /*  142029 */     GIR_EraseRootFromParent_Done,
     /*  142030 */   // Label 2543: @142030
     /*  142030 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(142096), // Rule ID 71421 //
     /*  142035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142077 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142094 */     GIR_RootConstrainSelectedInstOperands,
     /*  142095 */     // GIR_Coverage, 71421,
     /*  142095 */     GIR_EraseRootFromParent_Done,
     /*  142096 */   // Label 2544: @142096
     /*  142096 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(142165), // Rule ID 53162 //
     /*  142101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142144 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142163 */     GIR_RootConstrainSelectedInstOperands,
     /*  142164 */     // GIR_Coverage, 53162,
     /*  142164 */     GIR_EraseRootFromParent_Done,
     /*  142165 */   // Label 2545: @142165
     /*  142165 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(142234), // Rule ID 53163 //
     /*  142170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142213 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142232 */     GIR_RootConstrainSelectedInstOperands,
     /*  142233 */     // GIR_Coverage, 53163,
     /*  142233 */     GIR_EraseRootFromParent_Done,
     /*  142234 */   // Label 2546: @142234
     /*  142234 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142303), // Rule ID 71416 //
     /*  142239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142282 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142301 */     GIR_RootConstrainSelectedInstOperands,
     /*  142302 */     // GIR_Coverage, 71416,
     /*  142302 */     GIR_EraseRootFromParent_Done,
     /*  142303 */   // Label 2547: @142303
     /*  142303 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(142372), // Rule ID 71417 //
     /*  142308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142351 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142370 */     GIR_RootConstrainSelectedInstOperands,
     /*  142371 */     // GIR_Coverage, 71417,
     /*  142371 */     GIR_EraseRootFromParent_Done,
     /*  142372 */   // Label 2548: @142372
     /*  142372 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142441), // Rule ID 71418 //
     /*  142377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142420 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142439 */     GIR_RootConstrainSelectedInstOperands,
     /*  142440 */     // GIR_Coverage, 71418,
     /*  142440 */     GIR_EraseRootFromParent_Done,
     /*  142441 */   // Label 2549: @142441
     /*  142441 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142510), // Rule ID 71419 //
     /*  142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142489 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142508 */     GIR_RootConstrainSelectedInstOperands,
     /*  142509 */     // GIR_Coverage, 71419,
     /*  142509 */     GIR_EraseRootFromParent_Done,
     /*  142510 */   // Label 2550: @142510
     /*  142510 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142579), // Rule ID 71424 //
     /*  142515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142558 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142577 */     GIR_RootConstrainSelectedInstOperands,
     /*  142578 */     // GIR_Coverage, 71424,
     /*  142578 */     GIR_EraseRootFromParent_Done,
     /*  142579 */   // Label 2551: @142579
     /*  142579 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142648), // Rule ID 71425 //
     /*  142584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142627 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142646 */     GIR_RootConstrainSelectedInstOperands,
     /*  142647 */     // GIR_Coverage, 71425,
     /*  142647 */     GIR_EraseRootFromParent_Done,
     /*  142648 */   // Label 2552: @142648
     /*  142648 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142714), // Rule ID 71428 //
     /*  142653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142695 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142712 */     GIR_RootConstrainSelectedInstOperands,
     /*  142713 */     // GIR_Coverage, 71428,
     /*  142713 */     GIR_EraseRootFromParent_Done,
     /*  142714 */   // Label 2553: @142714
     /*  142714 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(142780), // Rule ID 71429 //
     /*  142719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142761 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142778 */     GIR_RootConstrainSelectedInstOperands,
     /*  142779 */     // GIR_Coverage, 71429,
     /*  142779 */     GIR_EraseRootFromParent_Done,
     /*  142780 */   // Label 2554: @142780
     /*  142780 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142846), // Rule ID 71426 //
     /*  142785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142827 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142844 */     GIR_RootConstrainSelectedInstOperands,
     /*  142845 */     // GIR_Coverage, 71426,
     /*  142845 */     GIR_EraseRootFromParent_Done,
     /*  142846 */   // Label 2555: @142846
     /*  142846 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142912), // Rule ID 71427 //
     /*  142851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142893 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142910 */     GIR_RootConstrainSelectedInstOperands,
     /*  142911 */     // GIR_Coverage, 71427,
     /*  142911 */     GIR_EraseRootFromParent_Done,
     /*  142912 */   // Label 2556: @142912
     /*  142912 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142955), // Rule ID 71442 //
     /*  142917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142938 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142953 */     GIR_RootConstrainSelectedInstOperands,
     /*  142954 */     // GIR_Coverage, 71442,
     /*  142954 */     GIR_EraseRootFromParent_Done,
     /*  142955 */   // Label 2557: @142955
     /*  142955 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142998), // Rule ID 71443 //
     /*  142960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142981 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142996 */     GIR_RootConstrainSelectedInstOperands,
     /*  142997 */     // GIR_Coverage, 71443,
     /*  142997 */     GIR_EraseRootFromParent_Done,
     /*  142998 */   // Label 2558: @142998
     /*  142998 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(143041), // Rule ID 53168 //
     /*  143003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143024 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143039 */     GIR_RootConstrainSelectedInstOperands,
     /*  143040 */     // GIR_Coverage, 53168,
     /*  143040 */     GIR_EraseRootFromParent_Done,
     /*  143041 */   // Label 2559: @143041
     /*  143041 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(143084), // Rule ID 53169 //
     /*  143046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143067 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143082 */     GIR_RootConstrainSelectedInstOperands,
     /*  143083 */     // GIR_Coverage, 53169,
     /*  143083 */     GIR_EraseRootFromParent_Done,
     /*  143084 */   // Label 2560: @143084
     /*  143084 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(143117), // Rule ID 53156 //
     /*  143089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143100 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143115 */     GIR_RootConstrainSelectedInstOperands,
     /*  143116 */     // GIR_Coverage, 53156,
     /*  143116 */     GIR_EraseRootFromParent_Done,
     /*  143117 */   // Label 2561: @143117
     /*  143117 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(143150), // Rule ID 53157 //
     /*  143122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143133 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143148 */     GIR_RootConstrainSelectedInstOperands,
     /*  143149 */     // GIR_Coverage, 53157,
     /*  143149 */     GIR_EraseRootFromParent_Done,
     /*  143150 */   // Label 2562: @143150
     /*  143150 */   GIM_Reject,
     /*  143151 */ // Label 2536: @143151
     /*  143151 */ GIM_Reject,
     /*  143152 */ // Label 2487: @143152
     /*  143152 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143266),
     /*  143157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  143160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  143163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143175 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143220), // Rule ID 47908 //
     /*  143180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143183 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  143183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143218 */     GIR_RootConstrainSelectedInstOperands,
     /*  143219 */     // GIR_Coverage, 47908,
     /*  143219 */     GIR_EraseRootFromParent_Done,
     /*  143220 */   // Label 2564: @143220
     /*  143220 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143265), // Rule ID 47909 //
     /*  143225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143228 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  143228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143263 */     GIR_RootConstrainSelectedInstOperands,
     /*  143264 */     // GIR_Coverage, 47909,
     /*  143264 */     GIR_EraseRootFromParent_Done,
     /*  143265 */   // Label 2565: @143265
     /*  143265 */   GIM_Reject,
     /*  143266 */ // Label 2563: @143266
     /*  143266 */ GIM_Reject,
     /*  143267 */ // Label 2488: @143267
     /*  143267 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143381),
     /*  143272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  143275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  143278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143290 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143335), // Rule ID 47920 //
     /*  143295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143298 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  143298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143333 */     GIR_RootConstrainSelectedInstOperands,
     /*  143334 */     // GIR_Coverage, 47920,
     /*  143334 */     GIR_EraseRootFromParent_Done,
     /*  143335 */   // Label 2567: @143335
     /*  143335 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143380), // Rule ID 47921 //
     /*  143340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143343 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  143343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143378 */     GIR_RootConstrainSelectedInstOperands,
     /*  143379 */     // GIR_Coverage, 47921,
     /*  143379 */     GIR_EraseRootFromParent_Done,
     /*  143380 */   // Label 2568: @143380
     /*  143380 */   GIM_Reject,
     /*  143381 */ // Label 2566: @143381
     /*  143381 */ GIM_Reject,
     /*  143382 */ // Label 2489: @143382
     /*  143382 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143496),
     /*  143387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  143390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  143393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143405 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143450), // Rule ID 47928 //
     /*  143410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143413 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  143413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143448 */     GIR_RootConstrainSelectedInstOperands,
     /*  143449 */     // GIR_Coverage, 47928,
     /*  143449 */     GIR_EraseRootFromParent_Done,
     /*  143450 */   // Label 2570: @143450
     /*  143450 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143495), // Rule ID 47929 //
     /*  143455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143458 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  143458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143493 */     GIR_RootConstrainSelectedInstOperands,
     /*  143494 */     // GIR_Coverage, 47929,
     /*  143494 */     GIR_EraseRootFromParent_Done,
     /*  143495 */   // Label 2571: @143495
     /*  143495 */   GIM_Reject,
     /*  143496 */ // Label 2569: @143496
     /*  143496 */ GIM_Reject,
     /*  143497 */ // Label 2490: @143497
     /*  143497 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143611),
     /*  143502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  143505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  143508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143520 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143565), // Rule ID 47944 //
     /*  143525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  143528 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  143528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  143531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143563 */     GIR_RootConstrainSelectedInstOperands,
     /*  143564 */     // GIR_Coverage, 47944,
     /*  143564 */     GIR_EraseRootFromParent_Done,
     /*  143565 */   // Label 2573: @143565
     /*  143565 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143610), // Rule ID 47945 //
     /*  143570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  143573 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  143573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  143576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143608 */     GIR_RootConstrainSelectedInstOperands,
     /*  143609 */     // GIR_Coverage, 47945,
     /*  143609 */     GIR_EraseRootFromParent_Done,
     /*  143610 */   // Label 2574: @143610
     /*  143610 */   GIM_Reject,
     /*  143611 */ // Label 2572: @143611
     /*  143611 */ GIM_Reject,
     /*  143612 */ // Label 2491: @143612
     /*  143612 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(145222),
     /*  143617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143627 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143696), // Rule ID 53176 //
     /*  143632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143675 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  143678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143694 */     GIR_RootConstrainSelectedInstOperands,
     /*  143695 */     // GIR_Coverage, 53176,
     /*  143695 */     GIR_EraseRootFromParent_Done,
     /*  143696 */   // Label 2576: @143696
     /*  143696 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143765), // Rule ID 53177 //
     /*  143701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143744 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  143747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143763 */     GIR_RootConstrainSelectedInstOperands,
     /*  143764 */     // GIR_Coverage, 53177,
     /*  143764 */     GIR_EraseRootFromParent_Done,
     /*  143765 */   // Label 2577: @143765
     /*  143765 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(143834), // Rule ID 53178 //
     /*  143770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143813 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  143816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143832 */     GIR_RootConstrainSelectedInstOperands,
     /*  143833 */     // GIR_Coverage, 53178,
     /*  143833 */     GIR_EraseRootFromParent_Done,
     /*  143834 */   // Label 2578: @143834
     /*  143834 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(143903), // Rule ID 53179 //
     /*  143839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143882 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  143885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143901 */     GIR_RootConstrainSelectedInstOperands,
     /*  143902 */     // GIR_Coverage, 53179,
     /*  143902 */     GIR_EraseRootFromParent_Done,
     /*  143903 */   // Label 2579: @143903
     /*  143903 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(143969), // Rule ID 71450 //
     /*  143908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143950 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  143953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143967 */     GIR_RootConstrainSelectedInstOperands,
     /*  143968 */     // GIR_Coverage, 71450,
     /*  143968 */     GIR_EraseRootFromParent_Done,
     /*  143969 */   // Label 2580: @143969
     /*  143969 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(144035), // Rule ID 71451 //
     /*  143974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  143989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  143993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144016 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144033 */     GIR_RootConstrainSelectedInstOperands,
     /*  144034 */     // GIR_Coverage, 71451,
     /*  144034 */     GIR_EraseRootFromParent_Done,
     /*  144035 */   // Label 2581: @144035
     /*  144035 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(144101), // Rule ID 71448 //
     /*  144040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144082 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144099 */     GIR_RootConstrainSelectedInstOperands,
     /*  144100 */     // GIR_Coverage, 71448,
     /*  144100 */     GIR_EraseRootFromParent_Done,
     /*  144101 */   // Label 2582: @144101
     /*  144101 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(144167), // Rule ID 71449 //
     /*  144106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144148 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144165 */     GIR_RootConstrainSelectedInstOperands,
     /*  144166 */     // GIR_Coverage, 71449,
     /*  144166 */     GIR_EraseRootFromParent_Done,
     /*  144167 */   // Label 2583: @144167
     /*  144167 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144236), // Rule ID 53180 //
     /*  144172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144215 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144234 */     GIR_RootConstrainSelectedInstOperands,
     /*  144235 */     // GIR_Coverage, 53180,
     /*  144235 */     GIR_EraseRootFromParent_Done,
     /*  144236 */   // Label 2584: @144236
     /*  144236 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144305), // Rule ID 53181 //
     /*  144241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144284 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144303 */     GIR_RootConstrainSelectedInstOperands,
     /*  144304 */     // GIR_Coverage, 53181,
     /*  144304 */     GIR_EraseRootFromParent_Done,
     /*  144305 */   // Label 2585: @144305
     /*  144305 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144374), // Rule ID 71444 //
     /*  144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144353 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144372 */     GIR_RootConstrainSelectedInstOperands,
     /*  144373 */     // GIR_Coverage, 71444,
     /*  144373 */     GIR_EraseRootFromParent_Done,
     /*  144374 */   // Label 2586: @144374
     /*  144374 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(144443), // Rule ID 71445 //
     /*  144379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144422 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144441 */     GIR_RootConstrainSelectedInstOperands,
     /*  144442 */     // GIR_Coverage, 71445,
     /*  144442 */     GIR_EraseRootFromParent_Done,
     /*  144443 */   // Label 2587: @144443
     /*  144443 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144512), // Rule ID 71446 //
     /*  144448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144491 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144510 */     GIR_RootConstrainSelectedInstOperands,
     /*  144511 */     // GIR_Coverage, 71446,
     /*  144511 */     GIR_EraseRootFromParent_Done,
     /*  144512 */   // Label 2588: @144512
     /*  144512 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144581), // Rule ID 71447 //
     /*  144517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144560 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144579 */     GIR_RootConstrainSelectedInstOperands,
     /*  144580 */     // GIR_Coverage, 71447,
     /*  144580 */     GIR_EraseRootFromParent_Done,
     /*  144581 */   // Label 2589: @144581
     /*  144581 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144650), // Rule ID 71452 //
     /*  144586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144629 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144648 */     GIR_RootConstrainSelectedInstOperands,
     /*  144649 */     // GIR_Coverage, 71452,
     /*  144649 */     GIR_EraseRootFromParent_Done,
     /*  144650 */   // Label 2590: @144650
     /*  144650 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144719), // Rule ID 71453 //
     /*  144655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144698 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144717 */     GIR_RootConstrainSelectedInstOperands,
     /*  144718 */     // GIR_Coverage, 71453,
     /*  144718 */     GIR_EraseRootFromParent_Done,
     /*  144719 */   // Label 2591: @144719
     /*  144719 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144785), // Rule ID 71456 //
     /*  144724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144766 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144783 */     GIR_RootConstrainSelectedInstOperands,
     /*  144784 */     // GIR_Coverage, 71456,
     /*  144784 */     GIR_EraseRootFromParent_Done,
     /*  144785 */   // Label 2592: @144785
     /*  144785 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(144851), // Rule ID 71457 //
     /*  144790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144832 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144849 */     GIR_RootConstrainSelectedInstOperands,
     /*  144850 */     // GIR_Coverage, 71457,
     /*  144850 */     GIR_EraseRootFromParent_Done,
     /*  144851 */   // Label 2593: @144851
     /*  144851 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144917), // Rule ID 71454 //
     /*  144856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144898 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144915 */     GIR_RootConstrainSelectedInstOperands,
     /*  144916 */     // GIR_Coverage, 71454,
     /*  144916 */     GIR_EraseRootFromParent_Done,
     /*  144917 */   // Label 2594: @144917
     /*  144917 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144983), // Rule ID 71455 //
     /*  144922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144964 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144981 */     GIR_RootConstrainSelectedInstOperands,
     /*  144982 */     // GIR_Coverage, 71455,
     /*  144982 */     GIR_EraseRootFromParent_Done,
     /*  144983 */   // Label 2595: @144983
     /*  144983 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(145026), // Rule ID 71470 //
     /*  144988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145009 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145024 */     GIR_RootConstrainSelectedInstOperands,
     /*  145025 */     // GIR_Coverage, 71470,
     /*  145025 */     GIR_EraseRootFromParent_Done,
     /*  145026 */   // Label 2596: @145026
     /*  145026 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(145069), // Rule ID 71471 //
     /*  145031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145052 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145067 */     GIR_RootConstrainSelectedInstOperands,
     /*  145068 */     // GIR_Coverage, 71471,
     /*  145068 */     GIR_EraseRootFromParent_Done,
     /*  145069 */   // Label 2597: @145069
     /*  145069 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(145112), // Rule ID 53186 //
     /*  145074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145095 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145110 */     GIR_RootConstrainSelectedInstOperands,
     /*  145111 */     // GIR_Coverage, 53186,
     /*  145111 */     GIR_EraseRootFromParent_Done,
     /*  145112 */   // Label 2598: @145112
     /*  145112 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(145155), // Rule ID 53187 //
     /*  145117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145138 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145153 */     GIR_RootConstrainSelectedInstOperands,
     /*  145154 */     // GIR_Coverage, 53187,
     /*  145154 */     GIR_EraseRootFromParent_Done,
     /*  145155 */   // Label 2599: @145155
     /*  145155 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(145188), // Rule ID 53174 //
     /*  145160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145171 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145186 */     GIR_RootConstrainSelectedInstOperands,
     /*  145187 */     // GIR_Coverage, 53174,
     /*  145187 */     GIR_EraseRootFromParent_Done,
     /*  145188 */   // Label 2600: @145188
     /*  145188 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145221), // Rule ID 53175 //
     /*  145193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145204 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145219 */     GIR_RootConstrainSelectedInstOperands,
     /*  145220 */     // GIR_Coverage, 53175,
     /*  145220 */     GIR_EraseRootFromParent_Done,
     /*  145221 */   // Label 2601: @145221
     /*  145221 */   GIM_Reject,
     /*  145222 */ // Label 2575: @145222
     /*  145222 */ GIM_Reject,
     /*  145223 */ // Label 2492: @145223
     /*  145223 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145337),
     /*  145228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  145231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  145234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145246 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145291), // Rule ID 47912 //
     /*  145251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145254 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  145254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145289 */     GIR_RootConstrainSelectedInstOperands,
     /*  145290 */     // GIR_Coverage, 47912,
     /*  145290 */     GIR_EraseRootFromParent_Done,
     /*  145291 */   // Label 2603: @145291
     /*  145291 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145336), // Rule ID 47913 //
     /*  145296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145299 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  145299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145334 */     GIR_RootConstrainSelectedInstOperands,
     /*  145335 */     // GIR_Coverage, 47913,
     /*  145335 */     GIR_EraseRootFromParent_Done,
     /*  145336 */   // Label 2604: @145336
     /*  145336 */   GIM_Reject,
     /*  145337 */ // Label 2602: @145337
     /*  145337 */ GIM_Reject,
     /*  145338 */ // Label 2493: @145338
     /*  145338 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145452),
     /*  145343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  145346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  145349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145361 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145406), // Rule ID 47924 //
     /*  145366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145369 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  145369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145404 */     GIR_RootConstrainSelectedInstOperands,
     /*  145405 */     // GIR_Coverage, 47924,
     /*  145405 */     GIR_EraseRootFromParent_Done,
     /*  145406 */   // Label 2606: @145406
     /*  145406 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145451), // Rule ID 47925 //
     /*  145411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145414 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  145414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145449 */     GIR_RootConstrainSelectedInstOperands,
     /*  145450 */     // GIR_Coverage, 47925,
     /*  145450 */     GIR_EraseRootFromParent_Done,
     /*  145451 */   // Label 2607: @145451
     /*  145451 */   GIM_Reject,
     /*  145452 */ // Label 2605: @145452
     /*  145452 */ GIM_Reject,
     /*  145453 */ // Label 2494: @145453
     /*  145453 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145567),
     /*  145458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  145461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  145464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145476 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145521), // Rule ID 47940 //
     /*  145481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145484 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  145484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145519 */     GIR_RootConstrainSelectedInstOperands,
     /*  145520 */     // GIR_Coverage, 47940,
     /*  145520 */     GIR_EraseRootFromParent_Done,
     /*  145521 */   // Label 2609: @145521
     /*  145521 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145566), // Rule ID 47941 //
     /*  145526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145529 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  145529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145564 */     GIR_RootConstrainSelectedInstOperands,
     /*  145565 */     // GIR_Coverage, 47941,
     /*  145565 */     GIR_EraseRootFromParent_Done,
     /*  145566 */   // Label 2610: @145566
     /*  145566 */   GIM_Reject,
     /*  145567 */ // Label 2608: @145567
     /*  145567 */ GIM_Reject,
     /*  145568 */ // Label 2495: @145568
     /*  145568 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145682),
     /*  145573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  145576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  145579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145591 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145636), // Rule ID 47984 //
     /*  145596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  145599 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  145599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  145602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145634 */     GIR_RootConstrainSelectedInstOperands,
     /*  145635 */     // GIR_Coverage, 47984,
     /*  145635 */     GIR_EraseRootFromParent_Done,
     /*  145636 */   // Label 2612: @145636
     /*  145636 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145681), // Rule ID 47985 //
     /*  145641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  145644 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  145644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  145647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145679 */     GIR_RootConstrainSelectedInstOperands,
     /*  145680 */     // GIR_Coverage, 47985,
     /*  145680 */     GIR_EraseRootFromParent_Done,
     /*  145681 */   // Label 2613: @145681
     /*  145681 */   GIM_Reject,
     /*  145682 */ // Label 2611: @145682
     /*  145682 */ GIM_Reject,
     /*  145683 */ // Label 2496: @145683
     /*  145683 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147293),
     /*  145688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145698 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(145767), // Rule ID 53194 //
     /*  145703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145746 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  145749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145765 */     GIR_RootConstrainSelectedInstOperands,
     /*  145766 */     // GIR_Coverage, 53194,
     /*  145766 */     GIR_EraseRootFromParent_Done,
     /*  145767 */   // Label 2615: @145767
     /*  145767 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(145836), // Rule ID 53195 //
     /*  145772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145815 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  145818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145834 */     GIR_RootConstrainSelectedInstOperands,
     /*  145835 */     // GIR_Coverage, 53195,
     /*  145835 */     GIR_EraseRootFromParent_Done,
     /*  145836 */   // Label 2616: @145836
     /*  145836 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(145905), // Rule ID 53196 //
     /*  145841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145884 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  145887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145903 */     GIR_RootConstrainSelectedInstOperands,
     /*  145904 */     // GIR_Coverage, 53196,
     /*  145904 */     GIR_EraseRootFromParent_Done,
     /*  145905 */   // Label 2617: @145905
     /*  145905 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(145974), // Rule ID 53197 //
     /*  145910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145953 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  145956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145972 */     GIR_RootConstrainSelectedInstOperands,
     /*  145973 */     // GIR_Coverage, 53197,
     /*  145973 */     GIR_EraseRootFromParent_Done,
     /*  145974 */   // Label 2618: @145974
     /*  145974 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(146040), // Rule ID 71478 //
     /*  145979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  145994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  145998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146021 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146038 */     GIR_RootConstrainSelectedInstOperands,
     /*  146039 */     // GIR_Coverage, 71478,
     /*  146039 */     GIR_EraseRootFromParent_Done,
     /*  146040 */   // Label 2619: @146040
     /*  146040 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146106), // Rule ID 71479 //
     /*  146045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146087 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146104 */     GIR_RootConstrainSelectedInstOperands,
     /*  146105 */     // GIR_Coverage, 71479,
     /*  146105 */     GIR_EraseRootFromParent_Done,
     /*  146106 */   // Label 2620: @146106
     /*  146106 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(146172), // Rule ID 71476 //
     /*  146111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146153 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146170 */     GIR_RootConstrainSelectedInstOperands,
     /*  146171 */     // GIR_Coverage, 71476,
     /*  146171 */     GIR_EraseRootFromParent_Done,
     /*  146172 */   // Label 2621: @146172
     /*  146172 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146238), // Rule ID 71477 //
     /*  146177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146219 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146236 */     GIR_RootConstrainSelectedInstOperands,
     /*  146237 */     // GIR_Coverage, 71477,
     /*  146237 */     GIR_EraseRootFromParent_Done,
     /*  146238 */   // Label 2622: @146238
     /*  146238 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146307), // Rule ID 53198 //
     /*  146243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146286 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146305 */     GIR_RootConstrainSelectedInstOperands,
     /*  146306 */     // GIR_Coverage, 53198,
     /*  146306 */     GIR_EraseRootFromParent_Done,
     /*  146307 */   // Label 2623: @146307
     /*  146307 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146376), // Rule ID 53199 //
     /*  146312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146355 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146374 */     GIR_RootConstrainSelectedInstOperands,
     /*  146375 */     // GIR_Coverage, 53199,
     /*  146375 */     GIR_EraseRootFromParent_Done,
     /*  146376 */   // Label 2624: @146376
     /*  146376 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146445), // Rule ID 71472 //
     /*  146381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146424 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146443 */     GIR_RootConstrainSelectedInstOperands,
     /*  146444 */     // GIR_Coverage, 71472,
     /*  146444 */     GIR_EraseRootFromParent_Done,
     /*  146445 */   // Label 2625: @146445
     /*  146445 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(146514), // Rule ID 71473 //
     /*  146450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146493 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146512 */     GIR_RootConstrainSelectedInstOperands,
     /*  146513 */     // GIR_Coverage, 71473,
     /*  146513 */     GIR_EraseRootFromParent_Done,
     /*  146514 */   // Label 2626: @146514
     /*  146514 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146583), // Rule ID 71474 //
     /*  146519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146562 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146581 */     GIR_RootConstrainSelectedInstOperands,
     /*  146582 */     // GIR_Coverage, 71474,
     /*  146582 */     GIR_EraseRootFromParent_Done,
     /*  146583 */   // Label 2627: @146583
     /*  146583 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146652), // Rule ID 71475 //
     /*  146588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146631 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146650 */     GIR_RootConstrainSelectedInstOperands,
     /*  146651 */     // GIR_Coverage, 71475,
     /*  146651 */     GIR_EraseRootFromParent_Done,
     /*  146652 */   // Label 2628: @146652
     /*  146652 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146721), // Rule ID 71480 //
     /*  146657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146700 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146719 */     GIR_RootConstrainSelectedInstOperands,
     /*  146720 */     // GIR_Coverage, 71480,
     /*  146720 */     GIR_EraseRootFromParent_Done,
     /*  146721 */   // Label 2629: @146721
     /*  146721 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146790), // Rule ID 71481 //
     /*  146726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146769 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146788 */     GIR_RootConstrainSelectedInstOperands,
     /*  146789 */     // GIR_Coverage, 71481,
     /*  146789 */     GIR_EraseRootFromParent_Done,
     /*  146790 */   // Label 2630: @146790
     /*  146790 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146856), // Rule ID 71484 //
     /*  146795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146837 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146854 */     GIR_RootConstrainSelectedInstOperands,
     /*  146855 */     // GIR_Coverage, 71484,
     /*  146855 */     GIR_EraseRootFromParent_Done,
     /*  146856 */   // Label 2631: @146856
     /*  146856 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(146922), // Rule ID 71485 //
     /*  146861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146903 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146920 */     GIR_RootConstrainSelectedInstOperands,
     /*  146921 */     // GIR_Coverage, 71485,
     /*  146921 */     GIR_EraseRootFromParent_Done,
     /*  146922 */   // Label 2632: @146922
     /*  146922 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146988), // Rule ID 71482 //
     /*  146927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146969 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146986 */     GIR_RootConstrainSelectedInstOperands,
     /*  146987 */     // GIR_Coverage, 71482,
     /*  146987 */     GIR_EraseRootFromParent_Done,
     /*  146988 */   // Label 2633: @146988
     /*  146988 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(147054), // Rule ID 71483 //
     /*  146993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147035 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147052 */     GIR_RootConstrainSelectedInstOperands,
     /*  147053 */     // GIR_Coverage, 71483,
     /*  147053 */     GIR_EraseRootFromParent_Done,
     /*  147054 */   // Label 2634: @147054
     /*  147054 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(147097), // Rule ID 71498 //
     /*  147059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147080 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147095 */     GIR_RootConstrainSelectedInstOperands,
     /*  147096 */     // GIR_Coverage, 71498,
     /*  147096 */     GIR_EraseRootFromParent_Done,
     /*  147097 */   // Label 2635: @147097
     /*  147097 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(147140), // Rule ID 71499 //
     /*  147102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147123 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147138 */     GIR_RootConstrainSelectedInstOperands,
     /*  147139 */     // GIR_Coverage, 71499,
     /*  147139 */     GIR_EraseRootFromParent_Done,
     /*  147140 */   // Label 2636: @147140
     /*  147140 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(147183), // Rule ID 53204 //
     /*  147145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147166 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147181 */     GIR_RootConstrainSelectedInstOperands,
     /*  147182 */     // GIR_Coverage, 53204,
     /*  147182 */     GIR_EraseRootFromParent_Done,
     /*  147183 */   // Label 2637: @147183
     /*  147183 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(147226), // Rule ID 53205 //
     /*  147188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147209 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147224 */     GIR_RootConstrainSelectedInstOperands,
     /*  147225 */     // GIR_Coverage, 53205,
     /*  147225 */     GIR_EraseRootFromParent_Done,
     /*  147226 */   // Label 2638: @147226
     /*  147226 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147259), // Rule ID 53192 //
     /*  147231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147242 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147257 */     GIR_RootConstrainSelectedInstOperands,
     /*  147258 */     // GIR_Coverage, 53192,
     /*  147258 */     GIR_EraseRootFromParent_Done,
     /*  147259 */   // Label 2639: @147259
     /*  147259 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147292), // Rule ID 53193 //
     /*  147264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147275 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147290 */     GIR_RootConstrainSelectedInstOperands,
     /*  147291 */     // GIR_Coverage, 53193,
     /*  147291 */     GIR_EraseRootFromParent_Done,
     /*  147292 */   // Label 2640: @147292
     /*  147292 */   GIM_Reject,
     /*  147293 */ // Label 2614: @147293
     /*  147293 */ GIM_Reject,
     /*  147294 */ // Label 2497: @147294
     /*  147294 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147408),
     /*  147299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  147302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  147305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147317 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147362), // Rule ID 47916 //
     /*  147322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147325 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  147325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147360 */     GIR_RootConstrainSelectedInstOperands,
     /*  147361 */     // GIR_Coverage, 47916,
     /*  147361 */     GIR_EraseRootFromParent_Done,
     /*  147362 */   // Label 2642: @147362
     /*  147362 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147407), // Rule ID 47917 //
     /*  147367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147370 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  147370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147405 */     GIR_RootConstrainSelectedInstOperands,
     /*  147406 */     // GIR_Coverage, 47917,
     /*  147406 */     GIR_EraseRootFromParent_Done,
     /*  147407 */   // Label 2643: @147407
     /*  147407 */   GIM_Reject,
     /*  147408 */ // Label 2641: @147408
     /*  147408 */ GIM_Reject,
     /*  147409 */ // Label 2498: @147409
     /*  147409 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147523),
     /*  147414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  147417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  147420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147432 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147477), // Rule ID 47936 //
     /*  147437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147440 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  147440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147475 */     GIR_RootConstrainSelectedInstOperands,
     /*  147476 */     // GIR_Coverage, 47936,
     /*  147476 */     GIR_EraseRootFromParent_Done,
     /*  147477 */   // Label 2645: @147477
     /*  147477 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147522), // Rule ID 47937 //
     /*  147482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147485 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  147485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147520 */     GIR_RootConstrainSelectedInstOperands,
     /*  147521 */     // GIR_Coverage, 47937,
     /*  147521 */     GIR_EraseRootFromParent_Done,
     /*  147522 */   // Label 2646: @147522
     /*  147522 */   GIM_Reject,
     /*  147523 */ // Label 2644: @147523
     /*  147523 */ GIM_Reject,
     /*  147524 */ // Label 2499: @147524
     /*  147524 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147638),
     /*  147529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  147532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  147535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147547 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147592), // Rule ID 47972 //
     /*  147552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147555 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  147555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  147558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147590 */     GIR_RootConstrainSelectedInstOperands,
     /*  147591 */     // GIR_Coverage, 47972,
     /*  147591 */     GIR_EraseRootFromParent_Done,
     /*  147592 */   // Label 2648: @147592
     /*  147592 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147637), // Rule ID 47973 //
     /*  147597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147600 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  147600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  147603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147635 */     GIR_RootConstrainSelectedInstOperands,
     /*  147636 */     // GIR_Coverage, 47973,
     /*  147636 */     GIR_EraseRootFromParent_Done,
     /*  147637 */   // Label 2649: @147637
     /*  147637 */   GIM_Reject,
     /*  147638 */ // Label 2647: @147638
     /*  147638 */ GIM_Reject,
     /*  147639 */ // Label 2500: @147639
     /*  147639 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147753),
     /*  147644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  147647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  147650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147662 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147707), // Rule ID 47988 //
     /*  147667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  147670 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  147670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  147673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147705 */     GIR_RootConstrainSelectedInstOperands,
     /*  147706 */     // GIR_Coverage, 47988,
     /*  147706 */     GIR_EraseRootFromParent_Done,
     /*  147707 */   // Label 2651: @147707
     /*  147707 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(147752), // Rule ID 47989 //
     /*  147712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  147715 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  147715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  147718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  147747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147750 */     GIR_RootConstrainSelectedInstOperands,
     /*  147751 */     // GIR_Coverage, 47989,
     /*  147751 */     GIR_EraseRootFromParent_Done,
     /*  147752 */   // Label 2652: @147752
     /*  147752 */   GIM_Reject,
     /*  147753 */ // Label 2650: @147753
     /*  147753 */ GIM_Reject,
     /*  147754 */ // Label 2501: @147754
     /*  147754 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(149364),
     /*  147759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147769 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(147838), // Rule ID 53212 //
     /*  147774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147817 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  147820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147836 */     GIR_RootConstrainSelectedInstOperands,
     /*  147837 */     // GIR_Coverage, 53212,
     /*  147837 */     GIR_EraseRootFromParent_Done,
     /*  147838 */   // Label 2654: @147838
     /*  147838 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(147907), // Rule ID 53213 //
     /*  147843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147886 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  147889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147905 */     GIR_RootConstrainSelectedInstOperands,
     /*  147906 */     // GIR_Coverage, 53213,
     /*  147906 */     GIR_EraseRootFromParent_Done,
     /*  147907 */   // Label 2655: @147907
     /*  147907 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(147976), // Rule ID 53214 //
     /*  147912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  147931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147955 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  147958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147974 */     GIR_RootConstrainSelectedInstOperands,
     /*  147975 */     // GIR_Coverage, 53214,
     /*  147975 */     GIR_EraseRootFromParent_Done,
     /*  147976 */   // Label 2656: @147976
     /*  147976 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(148045), // Rule ID 53215 //
     /*  147981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  147996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148024 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148043 */     GIR_RootConstrainSelectedInstOperands,
     /*  148044 */     // GIR_Coverage, 53215,
     /*  148044 */     GIR_EraseRootFromParent_Done,
     /*  148045 */   // Label 2657: @148045
     /*  148045 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(148111), // Rule ID 71506 //
     /*  148050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148092 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148109 */     GIR_RootConstrainSelectedInstOperands,
     /*  148110 */     // GIR_Coverage, 71506,
     /*  148110 */     GIR_EraseRootFromParent_Done,
     /*  148111 */   // Label 2658: @148111
     /*  148111 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148177), // Rule ID 71507 //
     /*  148116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148158 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148175 */     GIR_RootConstrainSelectedInstOperands,
     /*  148176 */     // GIR_Coverage, 71507,
     /*  148176 */     GIR_EraseRootFromParent_Done,
     /*  148177 */   // Label 2659: @148177
     /*  148177 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148243), // Rule ID 71504 //
     /*  148182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148224 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148241 */     GIR_RootConstrainSelectedInstOperands,
     /*  148242 */     // GIR_Coverage, 71504,
     /*  148242 */     GIR_EraseRootFromParent_Done,
     /*  148243 */   // Label 2660: @148243
     /*  148243 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148309), // Rule ID 71505 //
     /*  148248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148290 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148307 */     GIR_RootConstrainSelectedInstOperands,
     /*  148308 */     // GIR_Coverage, 71505,
     /*  148308 */     GIR_EraseRootFromParent_Done,
     /*  148309 */   // Label 2661: @148309
     /*  148309 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148378), // Rule ID 53216 //
     /*  148314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148357 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148376 */     GIR_RootConstrainSelectedInstOperands,
     /*  148377 */     // GIR_Coverage, 53216,
     /*  148377 */     GIR_EraseRootFromParent_Done,
     /*  148378 */   // Label 2662: @148378
     /*  148378 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148447), // Rule ID 53217 //
     /*  148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148426 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148445 */     GIR_RootConstrainSelectedInstOperands,
     /*  148446 */     // GIR_Coverage, 53217,
     /*  148446 */     GIR_EraseRootFromParent_Done,
     /*  148447 */   // Label 2663: @148447
     /*  148447 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148516), // Rule ID 71500 //
     /*  148452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148495 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148514 */     GIR_RootConstrainSelectedInstOperands,
     /*  148515 */     // GIR_Coverage, 71500,
     /*  148515 */     GIR_EraseRootFromParent_Done,
     /*  148516 */   // Label 2664: @148516
     /*  148516 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(148585), // Rule ID 71501 //
     /*  148521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148564 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148583 */     GIR_RootConstrainSelectedInstOperands,
     /*  148584 */     // GIR_Coverage, 71501,
     /*  148584 */     GIR_EraseRootFromParent_Done,
     /*  148585 */   // Label 2665: @148585
     /*  148585 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148654), // Rule ID 71502 //
     /*  148590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148633 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148652 */     GIR_RootConstrainSelectedInstOperands,
     /*  148653 */     // GIR_Coverage, 71502,
     /*  148653 */     GIR_EraseRootFromParent_Done,
     /*  148654 */   // Label 2666: @148654
     /*  148654 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148723), // Rule ID 71503 //
     /*  148659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148702 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148721 */     GIR_RootConstrainSelectedInstOperands,
     /*  148722 */     // GIR_Coverage, 71503,
     /*  148722 */     GIR_EraseRootFromParent_Done,
     /*  148723 */   // Label 2667: @148723
     /*  148723 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148792), // Rule ID 71508 //
     /*  148728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148771 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148790 */     GIR_RootConstrainSelectedInstOperands,
     /*  148791 */     // GIR_Coverage, 71508,
     /*  148791 */     GIR_EraseRootFromParent_Done,
     /*  148792 */   // Label 2668: @148792
     /*  148792 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148861), // Rule ID 71509 //
     /*  148797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148840 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148859 */     GIR_RootConstrainSelectedInstOperands,
     /*  148860 */     // GIR_Coverage, 71509,
     /*  148860 */     GIR_EraseRootFromParent_Done,
     /*  148861 */   // Label 2669: @148861
     /*  148861 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148927), // Rule ID 71512 //
     /*  148866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148908 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148925 */     GIR_RootConstrainSelectedInstOperands,
     /*  148926 */     // GIR_Coverage, 71512,
     /*  148926 */     GIR_EraseRootFromParent_Done,
     /*  148927 */   // Label 2670: @148927
     /*  148927 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(148993), // Rule ID 71513 //
     /*  148932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148974 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148991 */     GIR_RootConstrainSelectedInstOperands,
     /*  148992 */     // GIR_Coverage, 71513,
     /*  148992 */     GIR_EraseRootFromParent_Done,
     /*  148993 */   // Label 2671: @148993
     /*  148993 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(149059), // Rule ID 71510 //
     /*  148998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149040 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149057 */     GIR_RootConstrainSelectedInstOperands,
     /*  149058 */     // GIR_Coverage, 71510,
     /*  149058 */     GIR_EraseRootFromParent_Done,
     /*  149059 */   // Label 2672: @149059
     /*  149059 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(149125), // Rule ID 71511 //
     /*  149064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149106 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149123 */     GIR_RootConstrainSelectedInstOperands,
     /*  149124 */     // GIR_Coverage, 71511,
     /*  149124 */     GIR_EraseRootFromParent_Done,
     /*  149125 */   // Label 2673: @149125
     /*  149125 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(149168), // Rule ID 71526 //
     /*  149130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149151 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149166 */     GIR_RootConstrainSelectedInstOperands,
     /*  149167 */     // GIR_Coverage, 71526,
     /*  149167 */     GIR_EraseRootFromParent_Done,
     /*  149168 */   // Label 2674: @149168
     /*  149168 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(149211), // Rule ID 71527 //
     /*  149173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149194 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149209 */     GIR_RootConstrainSelectedInstOperands,
     /*  149210 */     // GIR_Coverage, 71527,
     /*  149210 */     GIR_EraseRootFromParent_Done,
     /*  149211 */   // Label 2675: @149211
     /*  149211 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(149254), // Rule ID 53222 //
     /*  149216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149237 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149252 */     GIR_RootConstrainSelectedInstOperands,
     /*  149253 */     // GIR_Coverage, 53222,
     /*  149253 */     GIR_EraseRootFromParent_Done,
     /*  149254 */   // Label 2676: @149254
     /*  149254 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149297), // Rule ID 53223 //
     /*  149259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149280 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149295 */     GIR_RootConstrainSelectedInstOperands,
     /*  149296 */     // GIR_Coverage, 53223,
     /*  149296 */     GIR_EraseRootFromParent_Done,
     /*  149297 */   // Label 2677: @149297
     /*  149297 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149330), // Rule ID 53210 //
     /*  149302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149313 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149328 */     GIR_RootConstrainSelectedInstOperands,
     /*  149329 */     // GIR_Coverage, 53210,
     /*  149329 */     GIR_EraseRootFromParent_Done,
     /*  149330 */   // Label 2678: @149330
     /*  149330 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149363), // Rule ID 53211 //
     /*  149335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149346 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149361 */     GIR_RootConstrainSelectedInstOperands,
     /*  149362 */     // GIR_Coverage, 53211,
     /*  149362 */     GIR_EraseRootFromParent_Done,
     /*  149363 */   // Label 2679: @149363
     /*  149363 */   GIM_Reject,
     /*  149364 */ // Label 2653: @149364
     /*  149364 */ GIM_Reject,
     /*  149365 */ // Label 2502: @149365
     /*  149365 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149479),
     /*  149370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  149373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  149376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149388 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149433), // Rule ID 47932 //
     /*  149393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149396 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  149396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149431 */     GIR_RootConstrainSelectedInstOperands,
     /*  149432 */     // GIR_Coverage, 47932,
     /*  149432 */     GIR_EraseRootFromParent_Done,
     /*  149433 */   // Label 2681: @149433
     /*  149433 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149478), // Rule ID 47933 //
     /*  149438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149441 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  149441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149476 */     GIR_RootConstrainSelectedInstOperands,
     /*  149477 */     // GIR_Coverage, 47933,
     /*  149477 */     GIR_EraseRootFromParent_Done,
     /*  149478 */   // Label 2682: @149478
     /*  149478 */   GIM_Reject,
     /*  149479 */ // Label 2680: @149479
     /*  149479 */ GIM_Reject,
     /*  149480 */ // Label 2503: @149480
     /*  149480 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149594),
     /*  149485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  149488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  149491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149503 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149548), // Rule ID 47960 //
     /*  149508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149511 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  149511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  149514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  149528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149546 */     GIR_RootConstrainSelectedInstOperands,
     /*  149547 */     // GIR_Coverage, 47960,
     /*  149547 */     GIR_EraseRootFromParent_Done,
     /*  149548 */   // Label 2684: @149548
     /*  149548 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149593), // Rule ID 47961 //
     /*  149553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149556 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  149556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  149559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  149573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149591 */     GIR_RootConstrainSelectedInstOperands,
     /*  149592 */     // GIR_Coverage, 47961,
     /*  149592 */     GIR_EraseRootFromParent_Done,
     /*  149593 */   // Label 2685: @149593
     /*  149593 */   GIM_Reject,
     /*  149594 */ // Label 2683: @149594
     /*  149594 */ GIM_Reject,
     /*  149595 */ // Label 2504: @149595
     /*  149595 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149709),
     /*  149600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  149603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  149606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149618 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149663), // Rule ID 47976 //
     /*  149623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149626 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  149626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  149629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  149658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149661 */     GIR_RootConstrainSelectedInstOperands,
     /*  149662 */     // GIR_Coverage, 47976,
     /*  149662 */     GIR_EraseRootFromParent_Done,
     /*  149663 */   // Label 2687: @149663
     /*  149663 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149708), // Rule ID 47977 //
     /*  149668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149671 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  149671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  149674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  149703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149706 */     GIR_RootConstrainSelectedInstOperands,
     /*  149707 */     // GIR_Coverage, 47977,
     /*  149707 */     GIR_EraseRootFromParent_Done,
     /*  149708 */   // Label 2688: @149708
     /*  149708 */   GIM_Reject,
     /*  149709 */ // Label 2686: @149709
     /*  149709 */ GIM_Reject,
     /*  149710 */ // Label 2505: @149710
     /*  149710 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149824),
     /*  149715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  149718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  149721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149733 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(149778), // Rule ID 47992 //
     /*  149738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  149741 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  149741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  149744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149776 */     GIR_RootConstrainSelectedInstOperands,
     /*  149777 */     // GIR_Coverage, 47992,
     /*  149777 */     GIR_EraseRootFromParent_Done,
     /*  149778 */   // Label 2690: @149778
     /*  149778 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(149823), // Rule ID 47993 //
     /*  149783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  149786 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  149786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  149789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  149818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149821 */     GIR_RootConstrainSelectedInstOperands,
     /*  149822 */     // GIR_Coverage, 47993,
     /*  149822 */     GIR_EraseRootFromParent_Done,
     /*  149823 */   // Label 2691: @149823
     /*  149823 */   GIM_Reject,
     /*  149824 */ // Label 2689: @149824
     /*  149824 */ GIM_Reject,
     /*  149825 */ // Label 2506: @149825
     /*  149825 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151435),
     /*  149830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149840 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(149909), // Rule ID 53230 //
     /*  149845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149888 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  149891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149907 */     GIR_RootConstrainSelectedInstOperands,
     /*  149908 */     // GIR_Coverage, 53230,
     /*  149908 */     GIR_EraseRootFromParent_Done,
     /*  149909 */   // Label 2693: @149909
     /*  149909 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(149978), // Rule ID 53231 //
     /*  149914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  149933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149957 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  149960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149976 */     GIR_RootConstrainSelectedInstOperands,
     /*  149977 */     // GIR_Coverage, 53231,
     /*  149977 */     GIR_EraseRootFromParent_Done,
     /*  149978 */   // Label 2694: @149978
     /*  149978 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150047), // Rule ID 53232 //
     /*  149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  149998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150026 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150045 */     GIR_RootConstrainSelectedInstOperands,
     /*  150046 */     // GIR_Coverage, 53232,
     /*  150046 */     GIR_EraseRootFromParent_Done,
     /*  150047 */   // Label 2695: @150047
     /*  150047 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150116), // Rule ID 53233 //
     /*  150052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150095 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150114 */     GIR_RootConstrainSelectedInstOperands,
     /*  150115 */     // GIR_Coverage, 53233,
     /*  150115 */     GIR_EraseRootFromParent_Done,
     /*  150116 */   // Label 2696: @150116
     /*  150116 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150182), // Rule ID 71534 //
     /*  150121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150163 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150180 */     GIR_RootConstrainSelectedInstOperands,
     /*  150181 */     // GIR_Coverage, 71534,
     /*  150181 */     GIR_EraseRootFromParent_Done,
     /*  150182 */   // Label 2697: @150182
     /*  150182 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150248), // Rule ID 71535 //
     /*  150187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150229 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150246 */     GIR_RootConstrainSelectedInstOperands,
     /*  150247 */     // GIR_Coverage, 71535,
     /*  150247 */     GIR_EraseRootFromParent_Done,
     /*  150248 */   // Label 2698: @150248
     /*  150248 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150314), // Rule ID 71532 //
     /*  150253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150295 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150312 */     GIR_RootConstrainSelectedInstOperands,
     /*  150313 */     // GIR_Coverage, 71532,
     /*  150313 */     GIR_EraseRootFromParent_Done,
     /*  150314 */   // Label 2699: @150314
     /*  150314 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150380), // Rule ID 71533 //
     /*  150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150361 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150378 */     GIR_RootConstrainSelectedInstOperands,
     /*  150379 */     // GIR_Coverage, 71533,
     /*  150379 */     GIR_EraseRootFromParent_Done,
     /*  150380 */   // Label 2700: @150380
     /*  150380 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150449), // Rule ID 53234 //
     /*  150385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150428 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150447 */     GIR_RootConstrainSelectedInstOperands,
     /*  150448 */     // GIR_Coverage, 53234,
     /*  150448 */     GIR_EraseRootFromParent_Done,
     /*  150449 */   // Label 2701: @150449
     /*  150449 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150518), // Rule ID 53235 //
     /*  150454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150497 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150516 */     GIR_RootConstrainSelectedInstOperands,
     /*  150517 */     // GIR_Coverage, 53235,
     /*  150517 */     GIR_EraseRootFromParent_Done,
     /*  150518 */   // Label 2702: @150518
     /*  150518 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150587), // Rule ID 71528 //
     /*  150523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150566 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150585 */     GIR_RootConstrainSelectedInstOperands,
     /*  150586 */     // GIR_Coverage, 71528,
     /*  150586 */     GIR_EraseRootFromParent_Done,
     /*  150587 */   // Label 2703: @150587
     /*  150587 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(150656), // Rule ID 71529 //
     /*  150592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150635 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150654 */     GIR_RootConstrainSelectedInstOperands,
     /*  150655 */     // GIR_Coverage, 71529,
     /*  150655 */     GIR_EraseRootFromParent_Done,
     /*  150656 */   // Label 2704: @150656
     /*  150656 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150725), // Rule ID 71530 //
     /*  150661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150704 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150723 */     GIR_RootConstrainSelectedInstOperands,
     /*  150724 */     // GIR_Coverage, 71530,
     /*  150724 */     GIR_EraseRootFromParent_Done,
     /*  150725 */   // Label 2705: @150725
     /*  150725 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150794), // Rule ID 71531 //
     /*  150730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150773 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150792 */     GIR_RootConstrainSelectedInstOperands,
     /*  150793 */     // GIR_Coverage, 71531,
     /*  150793 */     GIR_EraseRootFromParent_Done,
     /*  150794 */   // Label 2706: @150794
     /*  150794 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150863), // Rule ID 71536 //
     /*  150799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150842 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150861 */     GIR_RootConstrainSelectedInstOperands,
     /*  150862 */     // GIR_Coverage, 71536,
     /*  150862 */     GIR_EraseRootFromParent_Done,
     /*  150863 */   // Label 2707: @150863
     /*  150863 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150932), // Rule ID 71537 //
     /*  150868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150911 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150930 */     GIR_RootConstrainSelectedInstOperands,
     /*  150931 */     // GIR_Coverage, 71537,
     /*  150931 */     GIR_EraseRootFromParent_Done,
     /*  150932 */   // Label 2708: @150932
     /*  150932 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150998), // Rule ID 71540 //
     /*  150937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150979 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150996 */     GIR_RootConstrainSelectedInstOperands,
     /*  150997 */     // GIR_Coverage, 71540,
     /*  150997 */     GIR_EraseRootFromParent_Done,
     /*  150998 */   // Label 2709: @150998
     /*  150998 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151064), // Rule ID 71541 //
     /*  151003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151045 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151062 */     GIR_RootConstrainSelectedInstOperands,
     /*  151063 */     // GIR_Coverage, 71541,
     /*  151063 */     GIR_EraseRootFromParent_Done,
     /*  151064 */   // Label 2710: @151064
     /*  151064 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151130), // Rule ID 71538 //
     /*  151069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151111 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151128 */     GIR_RootConstrainSelectedInstOperands,
     /*  151129 */     // GIR_Coverage, 71538,
     /*  151129 */     GIR_EraseRootFromParent_Done,
     /*  151130 */   // Label 2711: @151130
     /*  151130 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(151196), // Rule ID 71539 //
     /*  151135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151177 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151194 */     GIR_RootConstrainSelectedInstOperands,
     /*  151195 */     // GIR_Coverage, 71539,
     /*  151195 */     GIR_EraseRootFromParent_Done,
     /*  151196 */   // Label 2712: @151196
     /*  151196 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(151239), // Rule ID 71554 //
     /*  151201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151222 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151237 */     GIR_RootConstrainSelectedInstOperands,
     /*  151238 */     // GIR_Coverage, 71554,
     /*  151238 */     GIR_EraseRootFromParent_Done,
     /*  151239 */   // Label 2713: @151239
     /*  151239 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(151282), // Rule ID 71555 //
     /*  151244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151265 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151280 */     GIR_RootConstrainSelectedInstOperands,
     /*  151281 */     // GIR_Coverage, 71555,
     /*  151281 */     GIR_EraseRootFromParent_Done,
     /*  151282 */   // Label 2714: @151282
     /*  151282 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151325), // Rule ID 53240 //
     /*  151287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151308 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151323 */     GIR_RootConstrainSelectedInstOperands,
     /*  151324 */     // GIR_Coverage, 53240,
     /*  151324 */     GIR_EraseRootFromParent_Done,
     /*  151325 */   // Label 2715: @151325
     /*  151325 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151368), // Rule ID 53241 //
     /*  151330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151351 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151366 */     GIR_RootConstrainSelectedInstOperands,
     /*  151367 */     // GIR_Coverage, 53241,
     /*  151367 */     GIR_EraseRootFromParent_Done,
     /*  151368 */   // Label 2716: @151368
     /*  151368 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151401), // Rule ID 53228 //
     /*  151373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151384 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151399 */     GIR_RootConstrainSelectedInstOperands,
     /*  151400 */     // GIR_Coverage, 53228,
     /*  151400 */     GIR_EraseRootFromParent_Done,
     /*  151401 */   // Label 2717: @151401
     /*  151401 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151434), // Rule ID 53229 //
     /*  151406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151417 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151432 */     GIR_RootConstrainSelectedInstOperands,
     /*  151433 */     // GIR_Coverage, 53229,
     /*  151433 */     GIR_EraseRootFromParent_Done,
     /*  151434 */   // Label 2718: @151434
     /*  151434 */   GIM_Reject,
     /*  151435 */ // Label 2692: @151435
     /*  151435 */ GIM_Reject,
     /*  151436 */ // Label 2507: @151436
     /*  151436 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151550),
     /*  151441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  151444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  151447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151459 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151504), // Rule ID 47948 //
     /*  151464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151467 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  151467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151502 */     GIR_RootConstrainSelectedInstOperands,
     /*  151503 */     // GIR_Coverage, 47948,
     /*  151503 */     GIR_EraseRootFromParent_Done,
     /*  151504 */   // Label 2720: @151504
     /*  151504 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151549), // Rule ID 47949 //
     /*  151509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151512 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  151512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151547 */     GIR_RootConstrainSelectedInstOperands,
     /*  151548 */     // GIR_Coverage, 47949,
     /*  151548 */     GIR_EraseRootFromParent_Done,
     /*  151549 */   // Label 2721: @151549
     /*  151549 */   GIM_Reject,
     /*  151550 */ // Label 2719: @151550
     /*  151550 */ GIM_Reject,
     /*  151551 */ // Label 2508: @151551
     /*  151551 */ GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151665),
     /*  151556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  151559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  151562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  151574 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151619), // Rule ID 47964 //
     /*  151579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151582 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  151582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  151585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  151599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  151614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151617 */     GIR_RootConstrainSelectedInstOperands,
     /*  151618 */     // GIR_Coverage, 47964,
     /*  151618 */     GIR_EraseRootFromParent_Done,
     /*  151619 */   // Label 2723: @151619
     /*  151619 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151664), // Rule ID 47965 //
     /*  151624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151627 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  151627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  151630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  151644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  151659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151662 */     GIR_RootConstrainSelectedInstOperands,
     /*  151663 */     // GIR_Coverage, 47965,
     /*  151663 */     GIR_EraseRootFromParent_Done,
     /*  151664 */   // Label 2724: @151664
     /*  151664 */   GIM_Reject,
     /*  151665 */ // Label 2722: @151665
     /*  151665 */ GIM_Reject,
     /*  151666 */ // Label 2509: @151666
     /*  151666 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151780),
     /*  151671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  151674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  151677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151689 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151734), // Rule ID 47980 //
     /*  151694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151697 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  151697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  151700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151732 */     GIR_RootConstrainSelectedInstOperands,
     /*  151733 */     // GIR_Coverage, 47980,
     /*  151733 */     GIR_EraseRootFromParent_Done,
     /*  151734 */   // Label 2726: @151734
     /*  151734 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151779), // Rule ID 47981 //
     /*  151739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151742 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  151742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  151745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  151774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151777 */     GIR_RootConstrainSelectedInstOperands,
     /*  151778 */     // GIR_Coverage, 47981,
     /*  151778 */     GIR_EraseRootFromParent_Done,
     /*  151779 */   // Label 2727: @151779
     /*  151779 */   GIM_Reject,
     /*  151780 */ // Label 2725: @151780
     /*  151780 */ GIM_Reject,
     /*  151781 */ // Label 2510: @151781
     /*  151781 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153391),
     /*  151786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151796 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(151865), // Rule ID 53248 //
     /*  151801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151844 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  151847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151863 */     GIR_RootConstrainSelectedInstOperands,
     /*  151864 */     // GIR_Coverage, 53248,
     /*  151864 */     GIR_EraseRootFromParent_Done,
     /*  151865 */   // Label 2729: @151865
     /*  151865 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(151934), // Rule ID 53249 //
     /*  151870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151913 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  151916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151932 */     GIR_RootConstrainSelectedInstOperands,
     /*  151933 */     // GIR_Coverage, 53249,
     /*  151933 */     GIR_EraseRootFromParent_Done,
     /*  151934 */   // Label 2730: @151934
     /*  151934 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152003), // Rule ID 53250 //
     /*  151939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  151954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  151958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151982 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  151985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  151995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152001 */     GIR_RootConstrainSelectedInstOperands,
     /*  152002 */     // GIR_Coverage, 53250,
     /*  152002 */     GIR_EraseRootFromParent_Done,
     /*  152003 */   // Label 2731: @152003
     /*  152003 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152072), // Rule ID 53251 //
     /*  152008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152051 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152070 */     GIR_RootConstrainSelectedInstOperands,
     /*  152071 */     // GIR_Coverage, 53251,
     /*  152071 */     GIR_EraseRootFromParent_Done,
     /*  152072 */   // Label 2732: @152072
     /*  152072 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152138), // Rule ID 71562 //
     /*  152077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152119 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152136 */     GIR_RootConstrainSelectedInstOperands,
     /*  152137 */     // GIR_Coverage, 71562,
     /*  152137 */     GIR_EraseRootFromParent_Done,
     /*  152138 */   // Label 2733: @152138
     /*  152138 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152204), // Rule ID 71563 //
     /*  152143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152185 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152202 */     GIR_RootConstrainSelectedInstOperands,
     /*  152203 */     // GIR_Coverage, 71563,
     /*  152203 */     GIR_EraseRootFromParent_Done,
     /*  152204 */   // Label 2734: @152204
     /*  152204 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152270), // Rule ID 71560 //
     /*  152209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152251 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152268 */     GIR_RootConstrainSelectedInstOperands,
     /*  152269 */     // GIR_Coverage, 71560,
     /*  152269 */     GIR_EraseRootFromParent_Done,
     /*  152270 */   // Label 2735: @152270
     /*  152270 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152336), // Rule ID 71561 //
     /*  152275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152317 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152334 */     GIR_RootConstrainSelectedInstOperands,
     /*  152335 */     // GIR_Coverage, 71561,
     /*  152335 */     GIR_EraseRootFromParent_Done,
     /*  152336 */   // Label 2736: @152336
     /*  152336 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152405), // Rule ID 53252 //
     /*  152341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152384 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152403 */     GIR_RootConstrainSelectedInstOperands,
     /*  152404 */     // GIR_Coverage, 53252,
     /*  152404 */     GIR_EraseRootFromParent_Done,
     /*  152405 */   // Label 2737: @152405
     /*  152405 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152474), // Rule ID 53253 //
     /*  152410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152453 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152472 */     GIR_RootConstrainSelectedInstOperands,
     /*  152473 */     // GIR_Coverage, 53253,
     /*  152473 */     GIR_EraseRootFromParent_Done,
     /*  152474 */   // Label 2738: @152474
     /*  152474 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152543), // Rule ID 71556 //
     /*  152479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152522 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152541 */     GIR_RootConstrainSelectedInstOperands,
     /*  152542 */     // GIR_Coverage, 71556,
     /*  152542 */     GIR_EraseRootFromParent_Done,
     /*  152543 */   // Label 2739: @152543
     /*  152543 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(152612), // Rule ID 71557 //
     /*  152548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152591 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152610 */     GIR_RootConstrainSelectedInstOperands,
     /*  152611 */     // GIR_Coverage, 71557,
     /*  152611 */     GIR_EraseRootFromParent_Done,
     /*  152612 */   // Label 2740: @152612
     /*  152612 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152681), // Rule ID 71558 //
     /*  152617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152660 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152679 */     GIR_RootConstrainSelectedInstOperands,
     /*  152680 */     // GIR_Coverage, 71558,
     /*  152680 */     GIR_EraseRootFromParent_Done,
     /*  152681 */   // Label 2741: @152681
     /*  152681 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152750), // Rule ID 71559 //
     /*  152686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152729 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152748 */     GIR_RootConstrainSelectedInstOperands,
     /*  152749 */     // GIR_Coverage, 71559,
     /*  152749 */     GIR_EraseRootFromParent_Done,
     /*  152750 */   // Label 2742: @152750
     /*  152750 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152819), // Rule ID 71564 //
     /*  152755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152798 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152817 */     GIR_RootConstrainSelectedInstOperands,
     /*  152818 */     // GIR_Coverage, 71564,
     /*  152818 */     GIR_EraseRootFromParent_Done,
     /*  152819 */   // Label 2743: @152819
     /*  152819 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152888), // Rule ID 71565 //
     /*  152824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  152839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152867 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  152876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  152880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152886 */     GIR_RootConstrainSelectedInstOperands,
     /*  152887 */     // GIR_Coverage, 71565,
     /*  152887 */     GIR_EraseRootFromParent_Done,
     /*  152888 */   // Label 2744: @152888
     /*  152888 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152954), // Rule ID 71568 //
     /*  152893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152935 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  152946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152952 */     GIR_RootConstrainSelectedInstOperands,
     /*  152953 */     // GIR_Coverage, 71568,
     /*  152953 */     GIR_EraseRootFromParent_Done,
     /*  152954 */   // Label 2745: @152954
     /*  152954 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153020), // Rule ID 71569 //
     /*  152959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  152970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153001 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153018 */     GIR_RootConstrainSelectedInstOperands,
     /*  153019 */     // GIR_Coverage, 71569,
     /*  153019 */     GIR_EraseRootFromParent_Done,
     /*  153020 */   // Label 2746: @153020
     /*  153020 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153086), // Rule ID 71566 //
     /*  153025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153067 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153084 */     GIR_RootConstrainSelectedInstOperands,
     /*  153085 */     // GIR_Coverage, 71566,
     /*  153085 */     GIR_EraseRootFromParent_Done,
     /*  153086 */   // Label 2747: @153086
     /*  153086 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(153152), // Rule ID 71567 //
     /*  153091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153133 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153150 */     GIR_RootConstrainSelectedInstOperands,
     /*  153151 */     // GIR_Coverage, 71567,
     /*  153151 */     GIR_EraseRootFromParent_Done,
     /*  153152 */   // Label 2748: @153152
     /*  153152 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(153195), // Rule ID 71582 //
     /*  153157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153178 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153193 */     GIR_RootConstrainSelectedInstOperands,
     /*  153194 */     // GIR_Coverage, 71582,
     /*  153194 */     GIR_EraseRootFromParent_Done,
     /*  153195 */   // Label 2749: @153195
     /*  153195 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(153238), // Rule ID 71583 //
     /*  153200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153221 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153236 */     GIR_RootConstrainSelectedInstOperands,
     /*  153237 */     // GIR_Coverage, 71583,
     /*  153237 */     GIR_EraseRootFromParent_Done,
     /*  153238 */   // Label 2750: @153238
     /*  153238 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153281), // Rule ID 53258 //
     /*  153243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153264 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153279 */     GIR_RootConstrainSelectedInstOperands,
     /*  153280 */     // GIR_Coverage, 53258,
     /*  153280 */     GIR_EraseRootFromParent_Done,
     /*  153281 */   // Label 2751: @153281
     /*  153281 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153324), // Rule ID 53259 //
     /*  153286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153307 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153322 */     GIR_RootConstrainSelectedInstOperands,
     /*  153323 */     // GIR_Coverage, 53259,
     /*  153323 */     GIR_EraseRootFromParent_Done,
     /*  153324 */   // Label 2752: @153324
     /*  153324 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153357), // Rule ID 53246 //
     /*  153329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153340 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153355 */     GIR_RootConstrainSelectedInstOperands,
     /*  153356 */     // GIR_Coverage, 53246,
     /*  153356 */     GIR_EraseRootFromParent_Done,
     /*  153357 */   // Label 2753: @153357
     /*  153357 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153390), // Rule ID 53247 //
     /*  153362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153373 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153388 */     GIR_RootConstrainSelectedInstOperands,
     /*  153389 */     // GIR_Coverage, 53247,
     /*  153389 */     GIR_EraseRootFromParent_Done,
     /*  153390 */   // Label 2754: @153390
     /*  153390 */   GIM_Reject,
     /*  153391 */ // Label 2728: @153391
     /*  153391 */ GIM_Reject,
     /*  153392 */ // Label 2511: @153392
     /*  153392 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153506),
     /*  153397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  153400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  153403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153415 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153460), // Rule ID 47952 //
     /*  153420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153423 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  153423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153458 */     GIR_RootConstrainSelectedInstOperands,
     /*  153459 */     // GIR_Coverage, 47952,
     /*  153459 */     GIR_EraseRootFromParent_Done,
     /*  153460 */   // Label 2756: @153460
     /*  153460 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153505), // Rule ID 47953 //
     /*  153465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153468 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  153468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153503 */     GIR_RootConstrainSelectedInstOperands,
     /*  153504 */     // GIR_Coverage, 47953,
     /*  153504 */     GIR_EraseRootFromParent_Done,
     /*  153505 */   // Label 2757: @153505
     /*  153505 */   GIM_Reject,
     /*  153506 */ // Label 2755: @153506
     /*  153506 */ GIM_Reject,
     /*  153507 */ // Label 2512: @153507
     /*  153507 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153621),
     /*  153512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  153515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  153518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153530 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153575), // Rule ID 47968 //
     /*  153535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153538 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  153538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  153541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  153555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153573 */     GIR_RootConstrainSelectedInstOperands,
     /*  153574 */     // GIR_Coverage, 47968,
     /*  153574 */     GIR_EraseRootFromParent_Done,
     /*  153575 */   // Label 2759: @153575
     /*  153575 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153620), // Rule ID 47969 //
     /*  153580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153583 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  153583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  153586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  153600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  153615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153618 */     GIR_RootConstrainSelectedInstOperands,
     /*  153619 */     // GIR_Coverage, 47969,
     /*  153619 */     GIR_EraseRootFromParent_Done,
     /*  153620 */   // Label 2760: @153620
     /*  153620 */   GIM_Reject,
     /*  153621 */ // Label 2758: @153621
     /*  153621 */ GIM_Reject,
     /*  153622 */ // Label 2513: @153622
     /*  153622 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(155232),
     /*  153627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153637 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153706), // Rule ID 53266 //
     /*  153642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153685 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  153688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153704 */     GIR_RootConstrainSelectedInstOperands,
     /*  153705 */     // GIR_Coverage, 53266,
     /*  153705 */     GIR_EraseRootFromParent_Done,
     /*  153706 */   // Label 2762: @153706
     /*  153706 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153775), // Rule ID 53267 //
     /*  153711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153754 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  153757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153773 */     GIR_RootConstrainSelectedInstOperands,
     /*  153774 */     // GIR_Coverage, 53267,
     /*  153774 */     GIR_EraseRootFromParent_Done,
     /*  153775 */   // Label 2763: @153775
     /*  153775 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153844), // Rule ID 53268 //
     /*  153780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153823 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  153826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153842 */     GIR_RootConstrainSelectedInstOperands,
     /*  153843 */     // GIR_Coverage, 53268,
     /*  153843 */     GIR_EraseRootFromParent_Done,
     /*  153844 */   // Label 2764: @153844
     /*  153844 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(153913), // Rule ID 53269 //
     /*  153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153892 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  153895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  153905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153911 */     GIR_RootConstrainSelectedInstOperands,
     /*  153912 */     // GIR_Coverage, 53269,
     /*  153912 */     GIR_EraseRootFromParent_Done,
     /*  153913 */   // Label 2765: @153913
     /*  153913 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(153979), // Rule ID 71590 //
     /*  153918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  153937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153960 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  153963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153977 */     GIR_RootConstrainSelectedInstOperands,
     /*  153978 */     // GIR_Coverage, 71590,
     /*  153978 */     GIR_EraseRootFromParent_Done,
     /*  153979 */   // Label 2766: @153979
     /*  153979 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154045), // Rule ID 71591 //
     /*  153984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  153999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154026 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154043 */     GIR_RootConstrainSelectedInstOperands,
     /*  154044 */     // GIR_Coverage, 71591,
     /*  154044 */     GIR_EraseRootFromParent_Done,
     /*  154045 */   // Label 2767: @154045
     /*  154045 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154111), // Rule ID 71588 //
     /*  154050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154092 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154109 */     GIR_RootConstrainSelectedInstOperands,
     /*  154110 */     // GIR_Coverage, 71588,
     /*  154110 */     GIR_EraseRootFromParent_Done,
     /*  154111 */   // Label 2768: @154111
     /*  154111 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154177), // Rule ID 71589 //
     /*  154116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154158 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154175 */     GIR_RootConstrainSelectedInstOperands,
     /*  154176 */     // GIR_Coverage, 71589,
     /*  154176 */     GIR_EraseRootFromParent_Done,
     /*  154177 */   // Label 2769: @154177
     /*  154177 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154246), // Rule ID 53270 //
     /*  154182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154225 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154244 */     GIR_RootConstrainSelectedInstOperands,
     /*  154245 */     // GIR_Coverage, 53270,
     /*  154245 */     GIR_EraseRootFromParent_Done,
     /*  154246 */   // Label 2770: @154246
     /*  154246 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154315), // Rule ID 53271 //
     /*  154251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154294 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154313 */     GIR_RootConstrainSelectedInstOperands,
     /*  154314 */     // GIR_Coverage, 53271,
     /*  154314 */     GIR_EraseRootFromParent_Done,
     /*  154315 */   // Label 2771: @154315
     /*  154315 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154384), // Rule ID 71584 //
     /*  154320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154363 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154382 */     GIR_RootConstrainSelectedInstOperands,
     /*  154383 */     // GIR_Coverage, 71584,
     /*  154383 */     GIR_EraseRootFromParent_Done,
     /*  154384 */   // Label 2772: @154384
     /*  154384 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(154453), // Rule ID 71585 //
     /*  154389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154432 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154451 */     GIR_RootConstrainSelectedInstOperands,
     /*  154452 */     // GIR_Coverage, 71585,
     /*  154452 */     GIR_EraseRootFromParent_Done,
     /*  154453 */   // Label 2773: @154453
     /*  154453 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154522), // Rule ID 71586 //
     /*  154458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154501 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154520 */     GIR_RootConstrainSelectedInstOperands,
     /*  154521 */     // GIR_Coverage, 71586,
     /*  154521 */     GIR_EraseRootFromParent_Done,
     /*  154522 */   // Label 2774: @154522
     /*  154522 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154591), // Rule ID 71587 //
     /*  154527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154570 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154589 */     GIR_RootConstrainSelectedInstOperands,
     /*  154590 */     // GIR_Coverage, 71587,
     /*  154590 */     GIR_EraseRootFromParent_Done,
     /*  154591 */   // Label 2775: @154591
     /*  154591 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154660), // Rule ID 71592 //
     /*  154596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154639 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154658 */     GIR_RootConstrainSelectedInstOperands,
     /*  154659 */     // GIR_Coverage, 71592,
     /*  154659 */     GIR_EraseRootFromParent_Done,
     /*  154660 */   // Label 2776: @154660
     /*  154660 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154729), // Rule ID 71593 //
     /*  154665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154708 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154727 */     GIR_RootConstrainSelectedInstOperands,
     /*  154728 */     // GIR_Coverage, 71593,
     /*  154728 */     GIR_EraseRootFromParent_Done,
     /*  154729 */   // Label 2777: @154729
     /*  154729 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154795), // Rule ID 71596 //
     /*  154734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154776 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154793 */     GIR_RootConstrainSelectedInstOperands,
     /*  154794 */     // GIR_Coverage, 71596,
     /*  154794 */     GIR_EraseRootFromParent_Done,
     /*  154795 */   // Label 2778: @154795
     /*  154795 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154861), // Rule ID 71597 //
     /*  154800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154842 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154859 */     GIR_RootConstrainSelectedInstOperands,
     /*  154860 */     // GIR_Coverage, 71597,
     /*  154860 */     GIR_EraseRootFromParent_Done,
     /*  154861 */   // Label 2779: @154861
     /*  154861 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154927), // Rule ID 71594 //
     /*  154866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154908 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154925 */     GIR_RootConstrainSelectedInstOperands,
     /*  154926 */     // GIR_Coverage, 71594,
     /*  154926 */     GIR_EraseRootFromParent_Done,
     /*  154927 */   // Label 2780: @154927
     /*  154927 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154993), // Rule ID 71595 //
     /*  154932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  154943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154974 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  154985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154991 */     GIR_RootConstrainSelectedInstOperands,
     /*  154992 */     // GIR_Coverage, 71595,
     /*  154992 */     GIR_EraseRootFromParent_Done,
     /*  154993 */   // Label 2781: @154993
     /*  154993 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155036), // Rule ID 71610 //
     /*  154998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155019 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155034 */     GIR_RootConstrainSelectedInstOperands,
     /*  155035 */     // GIR_Coverage, 71610,
     /*  155035 */     GIR_EraseRootFromParent_Done,
     /*  155036 */   // Label 2782: @155036
     /*  155036 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155079), // Rule ID 71611 //
     /*  155041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155062 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155077 */     GIR_RootConstrainSelectedInstOperands,
     /*  155078 */     // GIR_Coverage, 71611,
     /*  155078 */     GIR_EraseRootFromParent_Done,
     /*  155079 */   // Label 2783: @155079
     /*  155079 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155122), // Rule ID 53276 //
     /*  155084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155105 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155120 */     GIR_RootConstrainSelectedInstOperands,
     /*  155121 */     // GIR_Coverage, 53276,
     /*  155121 */     GIR_EraseRootFromParent_Done,
     /*  155122 */   // Label 2784: @155122
     /*  155122 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155165), // Rule ID 53277 //
     /*  155127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155148 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155163 */     GIR_RootConstrainSelectedInstOperands,
     /*  155164 */     // GIR_Coverage, 53277,
     /*  155164 */     GIR_EraseRootFromParent_Done,
     /*  155165 */   // Label 2785: @155165
     /*  155165 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155198), // Rule ID 53264 //
     /*  155170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155181 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155196 */     GIR_RootConstrainSelectedInstOperands,
     /*  155197 */     // GIR_Coverage, 53264,
     /*  155197 */     GIR_EraseRootFromParent_Done,
     /*  155198 */   // Label 2786: @155198
     /*  155198 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155231), // Rule ID 53265 //
     /*  155203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155214 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155229 */     GIR_RootConstrainSelectedInstOperands,
     /*  155230 */     // GIR_Coverage, 53265,
     /*  155230 */     GIR_EraseRootFromParent_Done,
     /*  155231 */   // Label 2787: @155231
     /*  155231 */   GIM_Reject,
     /*  155232 */ // Label 2761: @155232
     /*  155232 */ GIM_Reject,
     /*  155233 */ // Label 2514: @155233
     /*  155233 */ GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155347),
     /*  155238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  155241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  155244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155256 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155301), // Rule ID 47956 //
     /*  155261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155264 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  155264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155299 */     GIR_RootConstrainSelectedInstOperands,
     /*  155300 */     // GIR_Coverage, 47956,
     /*  155300 */     GIR_EraseRootFromParent_Done,
     /*  155301 */   // Label 2789: @155301
     /*  155301 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155346), // Rule ID 47957 //
     /*  155306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155309 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  155309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155344 */     GIR_RootConstrainSelectedInstOperands,
     /*  155345 */     // GIR_Coverage, 47957,
     /*  155345 */     GIR_EraseRootFromParent_Done,
     /*  155346 */   // Label 2790: @155346
     /*  155346 */   GIM_Reject,
     /*  155347 */ // Label 2788: @155347
     /*  155347 */ GIM_Reject,
     /*  155348 */ // Label 2515: @155348
     /*  155348 */ GIM_Reject,
     /*  155349 */ // Label 10: @155349
     /*  155349 */ GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155409),
     /*  155354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  155358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155362 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155385), // Rule ID 110 //
     /*  155367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  155370 */     // MIs[0] Operand 1
     /*  155370 */     // No operand predicates
     /*  155370 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  155370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155375 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155383 */     GIR_RootConstrainSelectedInstOperands,
     /*  155384 */     // GIR_Coverage, 110,
     /*  155384 */     GIR_EraseRootFromParent_Done,
     /*  155385 */   // Label 2792: @155385
     /*  155385 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155408), // Rule ID 111 //
     /*  155390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155393 */     // MIs[0] Operand 1
     /*  155393 */     // No operand predicates
     /*  155393 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  155393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155398 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155406 */     GIR_RootConstrainSelectedInstOperands,
     /*  155407 */     // GIR_Coverage, 111,
     /*  155407 */     GIR_EraseRootFromParent_Done,
     /*  155408 */   // Label 2793: @155408
     /*  155408 */   GIM_Reject,
     /*  155409 */ // Label 2791: @155409
     /*  155409 */ GIM_Reject,
     /*  155410 */ // Label 11: @155410
     /*  155410 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155470),
     /*  155415 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155418 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  155421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  155427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155439 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155454), // Rule ID 50 //
     /*  155444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155447 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155452 */     GIR_RootConstrainSelectedInstOperands,
     /*  155453 */     // GIR_Coverage, 50,
     /*  155453 */     GIR_Done,
     /*  155454 */   // Label 2795: @155454
     /*  155454 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155469), // Rule ID 51 //
     /*  155459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155462 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155467 */     GIR_RootConstrainSelectedInstOperands,
     /*  155468 */     // GIR_Coverage, 51,
     /*  155468 */     GIR_Done,
     /*  155469 */   // Label 2796: @155469
     /*  155469 */   GIM_Reject,
     /*  155470 */ // Label 2794: @155470
     /*  155470 */ GIM_Reject,
     /*  155471 */ // Label 12: @155471
     /*  155471 */ GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155561),
     /*  155476 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155479 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  155482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  155488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155500 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155515), // Rule ID 48 //
     /*  155505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155508 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  155513 */     GIR_RootConstrainSelectedInstOperands,
     /*  155514 */     // GIR_Coverage, 48,
     /*  155514 */     GIR_Done,
     /*  155515 */   // Label 2798: @155515
     /*  155515 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155530), // Rule ID 49 //
     /*  155520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155523 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  155528 */     GIR_RootConstrainSelectedInstOperands,
     /*  155529 */     // GIR_Coverage, 49,
     /*  155529 */     GIR_Done,
     /*  155530 */   // Label 2799: @155530
     /*  155530 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155545), // Rule ID 2396 //
     /*  155535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  155538 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  155538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  155543 */     GIR_RootConstrainSelectedInstOperands,
     /*  155544 */     // GIR_Coverage, 2396,
     /*  155544 */     GIR_Done,
     /*  155545 */   // Label 2800: @155545
     /*  155545 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(155560), // Rule ID 2397 //
     /*  155550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  155553 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  155553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  155558 */     GIR_RootConstrainSelectedInstOperands,
     /*  155559 */     // GIR_Coverage, 2397,
     /*  155559 */     GIR_Done,
     /*  155560 */   // Label 2801: @155560
     /*  155560 */   GIM_Reject,
     /*  155561 */ // Label 2797: @155561
     /*  155561 */ GIM_Reject,
     /*  155562 */ // Label 13: @155562
     /*  155562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2804*/ GIMT_Encode4(155928),
     /*  155573 */ /*GILLT_s32*//*Label 2802*/ GIMT_Encode4(155581),
     /*  155577 */ /*GILLT_s64*//*Label 2803*/ GIMT_Encode4(155818),
     /*  155581 */ // Label 2802: @155581
     /*  155581 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155817),
     /*  155586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155589 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155612), // Rule ID 1435 //
     /*  155594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  155597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155605 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  155605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  155610 */     GIR_RootConstrainSelectedInstOperands,
     /*  155611 */     // GIR_Coverage, 1435,
     /*  155611 */     GIR_Done,
     /*  155612 */   // Label 2806: @155612
     /*  155612 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155635), // Rule ID 1436 //
     /*  155617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  155620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155628 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  155628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  155633 */     GIR_RootConstrainSelectedInstOperands,
     /*  155634 */     // GIR_Coverage, 1436,
     /*  155634 */     GIR_Done,
     /*  155635 */   // Label 2807: @155635
     /*  155635 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155658), // Rule ID 1437 //
     /*  155640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  155643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155651 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  155651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  155656 */     GIR_RootConstrainSelectedInstOperands,
     /*  155657 */     // GIR_Coverage, 1437,
     /*  155657 */     GIR_Done,
     /*  155658 */   // Label 2808: @155658
     /*  155658 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155681), // Rule ID 1438 //
     /*  155663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  155666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  155674 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  155674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  155679 */     GIR_RootConstrainSelectedInstOperands,
     /*  155680 */     // GIR_Coverage, 1438,
     /*  155680 */     GIR_Done,
     /*  155681 */   // Label 2809: @155681
     /*  155681 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155719), // Rule ID 1439 //
     /*  155686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  155689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  155697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155702 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  155708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155718 */     // GIR_Coverage, 1439,
     /*  155718 */     GIR_EraseRootFromParent_Done,
     /*  155719 */   // Label 2810: @155719
     /*  155719 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155757), // Rule ID 1440 //
     /*  155724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  155727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155735 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  155735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155740 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  155746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155756 */     // GIR_Coverage, 1440,
     /*  155756 */     GIR_EraseRootFromParent_Done,
     /*  155757 */   // Label 2811: @155757
     /*  155757 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155816), // Rule ID 1441 //
     /*  155762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  155765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155773 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  155773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  155776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  155790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  155792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  155800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  155815 */     // GIR_Coverage, 1441,
     /*  155815 */     GIR_EraseRootFromParent_Done,
     /*  155816 */   // Label 2812: @155816
     /*  155816 */   GIM_Reject,
     /*  155817 */ // Label 2805: @155817
     /*  155817 */ GIM_Reject,
     /*  155818 */ // Label 2803: @155818
     /*  155818 */ GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155927),
     /*  155823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  155826 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(155849), // Rule ID 1892 //
     /*  155831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  155834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155842 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  155842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  155847 */     GIR_RootConstrainSelectedInstOperands,
     /*  155848 */     // GIR_Coverage, 1892,
     /*  155848 */     GIR_Done,
     /*  155849 */   // Label 2814: @155849
     /*  155849 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155872), // Rule ID 1893 //
     /*  155854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  155857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155865 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  155865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  155870 */     GIR_RootConstrainSelectedInstOperands,
     /*  155871 */     // GIR_Coverage, 1893,
     /*  155871 */     GIR_Done,
     /*  155872 */   // Label 2815: @155872
     /*  155872 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(155899), // Rule ID 1920 //
     /*  155877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  155880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155888 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  155888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155898 */     // GIR_Coverage, 1920,
     /*  155898 */     GIR_Done,
     /*  155899 */   // Label 2816: @155899
     /*  155899 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(155926), // Rule ID 1921 //
     /*  155904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  155907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155915 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  155915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  155920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155925 */     // GIR_Coverage, 1921,
     /*  155925 */     GIR_Done,
     /*  155926 */   // Label 2817: @155926
     /*  155926 */   GIM_Reject,
     /*  155927 */ // Label 2813: @155927
     /*  155927 */ GIM_Reject,
     /*  155928 */ // Label 2804: @155928
     /*  155928 */ GIM_Reject,
     /*  155929 */ // Label 14: @155929
     /*  155929 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2821*/ GIMT_Encode4(156126),
     /*  155940 */ /*GILLT_s16*//*Label 2818*/ GIMT_Encode4(155952),
     /*  155944 */ /*GILLT_s32*//*Label 2819*/ GIMT_Encode4(156010),
     /*  155948 */ /*GILLT_s64*//*Label 2820*/ GIMT_Encode4(156068),
     /*  155952 */ // Label 2818: @155952
     /*  155952 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(156009),
     /*  155957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  155960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  155964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  155968 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(155988), // Rule ID 2428 //
     /*  155973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  155976 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  155976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  155979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  155986 */     GIR_RootConstrainSelectedInstOperands,
     /*  155987 */     // GIR_Coverage, 2428,
     /*  155987 */     GIR_EraseRootFromParent_Done,
     /*  155988 */   // Label 2823: @155988
     /*  155988 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156008), // Rule ID 2429 //
     /*  155993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  155996 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  155996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  155999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156006 */     GIR_RootConstrainSelectedInstOperands,
     /*  156007 */     // GIR_Coverage, 2429,
     /*  156007 */     GIR_EraseRootFromParent_Done,
     /*  156008 */   // Label 2824: @156008
     /*  156008 */   GIM_Reject,
     /*  156009 */ // Label 2822: @156009
     /*  156009 */ GIM_Reject,
     /*  156010 */ // Label 2819: @156010
     /*  156010 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156067),
     /*  156015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156026 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156046), // Rule ID 2346 //
     /*  156031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156034 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156044 */     GIR_RootConstrainSelectedInstOperands,
     /*  156045 */     // GIR_Coverage, 2346,
     /*  156045 */     GIR_EraseRootFromParent_Done,
     /*  156046 */   // Label 2826: @156046
     /*  156046 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156066), // Rule ID 2347 //
     /*  156051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156054 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  156054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156064 */     GIR_RootConstrainSelectedInstOperands,
     /*  156065 */     // GIR_Coverage, 2347,
     /*  156065 */     GIR_EraseRootFromParent_Done,
     /*  156066 */   // Label 2827: @156066
     /*  156066 */   GIM_Reject,
     /*  156067 */ // Label 2825: @156067
     /*  156067 */ GIM_Reject,
     /*  156068 */ // Label 2820: @156068
     /*  156068 */ GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156125),
     /*  156073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156084 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156104), // Rule ID 2386 //
     /*  156089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156092 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  156092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156102 */     GIR_RootConstrainSelectedInstOperands,
     /*  156103 */     // GIR_Coverage, 2386,
     /*  156103 */     GIR_EraseRootFromParent_Done,
     /*  156104 */   // Label 2829: @156104
     /*  156104 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156124), // Rule ID 2387 //
     /*  156109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156112 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  156112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156122 */     GIR_RootConstrainSelectedInstOperands,
     /*  156123 */     // GIR_Coverage, 2387,
     /*  156123 */     GIR_EraseRootFromParent_Done,
     /*  156124 */   // Label 2830: @156124
     /*  156124 */   GIM_Reject,
     /*  156125 */ // Label 2828: @156125
     /*  156125 */ GIM_Reject,
     /*  156126 */ // Label 2821: @156126
     /*  156126 */ GIM_Reject,
     /*  156127 */ // Label 15: @156127
     /*  156127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2834*/ GIMT_Encode4(156324),
     /*  156138 */ /*GILLT_s16*//*Label 2831*/ GIMT_Encode4(156150),
     /*  156142 */ /*GILLT_s32*//*Label 2832*/ GIMT_Encode4(156208),
     /*  156146 */ /*GILLT_s64*//*Label 2833*/ GIMT_Encode4(156266),
     /*  156150 */ // Label 2831: @156150
     /*  156150 */ GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156207),
     /*  156155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156166 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156186), // Rule ID 2412 //
     /*  156171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156174 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  156174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156184 */     GIR_RootConstrainSelectedInstOperands,
     /*  156185 */     // GIR_Coverage, 2412,
     /*  156185 */     GIR_EraseRootFromParent_Done,
     /*  156186 */   // Label 2836: @156186
     /*  156186 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156206), // Rule ID 2413 //
     /*  156191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156194 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  156194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156204 */     GIR_RootConstrainSelectedInstOperands,
     /*  156205 */     // GIR_Coverage, 2413,
     /*  156205 */     GIR_EraseRootFromParent_Done,
     /*  156206 */   // Label 2837: @156206
     /*  156206 */   GIM_Reject,
     /*  156207 */ // Label 2835: @156207
     /*  156207 */ GIM_Reject,
     /*  156208 */ // Label 2832: @156208
     /*  156208 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156265),
     /*  156213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156224 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156244), // Rule ID 2330 //
     /*  156229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156232 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  156232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156242 */     GIR_RootConstrainSelectedInstOperands,
     /*  156243 */     // GIR_Coverage, 2330,
     /*  156243 */     GIR_EraseRootFromParent_Done,
     /*  156244 */   // Label 2839: @156244
     /*  156244 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156264), // Rule ID 2331 //
     /*  156249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156252 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  156252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156262 */     GIR_RootConstrainSelectedInstOperands,
     /*  156263 */     // GIR_Coverage, 2331,
     /*  156263 */     GIR_EraseRootFromParent_Done,
     /*  156264 */   // Label 2840: @156264
     /*  156264 */   GIM_Reject,
     /*  156265 */ // Label 2838: @156265
     /*  156265 */ GIM_Reject,
     /*  156266 */ // Label 2833: @156266
     /*  156266 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156323),
     /*  156271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156282 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156302), // Rule ID 2370 //
     /*  156287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156290 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  156290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156300 */     GIR_RootConstrainSelectedInstOperands,
     /*  156301 */     // GIR_Coverage, 2370,
     /*  156301 */     GIR_EraseRootFromParent_Done,
     /*  156302 */   // Label 2842: @156302
     /*  156302 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(156322), // Rule ID 2371 //
     /*  156307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156310 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  156310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156320 */     GIR_RootConstrainSelectedInstOperands,
     /*  156321 */     // GIR_Coverage, 2371,
     /*  156321 */     GIR_EraseRootFromParent_Done,
     /*  156322 */   // Label 2843: @156322
     /*  156322 */   GIM_Reject,
     /*  156323 */ // Label 2841: @156323
     /*  156323 */ GIM_Reject,
     /*  156324 */ // Label 2834: @156324
     /*  156324 */ GIM_Reject,
     /*  156325 */ // Label 16: @156325
     /*  156325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2846*/ GIMT_Encode4(156904),
     /*  156336 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(156344),
     /*  156340 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(156717),
     /*  156344 */ // Label 2844: @156344
     /*  156344 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(156375), // Rule ID 1454 //
     /*  156349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156363 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156373 */   GIR_RootConstrainSelectedInstOperands,
     /*  156374 */   // GIR_Coverage, 1454,
     /*  156374 */   GIR_EraseRootFromParent_Done,
     /*  156375 */ // Label 2847: @156375
     /*  156375 */ GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(156406), // Rule ID 1455 //
     /*  156380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156394 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156399 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156404 */   GIR_RootConstrainSelectedInstOperands,
     /*  156405 */   // GIR_Coverage, 1455,
     /*  156405 */   GIR_EraseRootFromParent_Done,
     /*  156406 */ // Label 2848: @156406
     /*  156406 */ GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(156437), // Rule ID 1480 //
     /*  156411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156425 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156430 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156435 */   GIR_RootConstrainSelectedInstOperands,
     /*  156436 */   // GIR_Coverage, 1480,
     /*  156436 */   GIR_EraseRootFromParent_Done,
     /*  156437 */ // Label 2849: @156437
     /*  156437 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(156468), // Rule ID 1481 //
     /*  156442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156456 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156461 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156466 */   GIR_RootConstrainSelectedInstOperands,
     /*  156467 */   // GIR_Coverage, 1481,
     /*  156467 */   GIR_EraseRootFromParent_Done,
     /*  156468 */ // Label 2850: @156468
     /*  156468 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(156499), // Rule ID 1852 //
     /*  156473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  156476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156487 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156497 */   GIR_RootConstrainSelectedInstOperands,
     /*  156498 */   // GIR_Coverage, 1852,
     /*  156498 */   GIR_EraseRootFromParent_Done,
     /*  156499 */ // Label 2851: @156499
     /*  156499 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(156530), // Rule ID 1853 //
     /*  156504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  156507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156518 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  156518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156528 */   GIR_RootConstrainSelectedInstOperands,
     /*  156529 */   // GIR_Coverage, 1853,
     /*  156529 */   GIR_EraseRootFromParent_Done,
     /*  156530 */ // Label 2852: @156530
     /*  156530 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(156561), // Rule ID 1878 //
     /*  156535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  156538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  156549 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  156552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156559 */   GIR_RootConstrainSelectedInstOperands,
     /*  156560 */   // GIR_Coverage, 1878,
     /*  156560 */   GIR_EraseRootFromParent_Done,
     /*  156561 */ // Label 2853: @156561
     /*  156561 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(156592), // Rule ID 1879 //
     /*  156566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  156569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  156580 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  156580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  156583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156590 */   GIR_RootConstrainSelectedInstOperands,
     /*  156591 */   // GIR_Coverage, 1879,
     /*  156591 */   GIR_EraseRootFromParent_Done,
     /*  156592 */ // Label 2854: @156592
     /*  156592 */ GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(156623), // Rule ID 2194 //
     /*  156597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  156600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156611 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  156614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156621 */   GIR_RootConstrainSelectedInstOperands,
     /*  156622 */   // GIR_Coverage, 2194,
     /*  156622 */   GIR_EraseRootFromParent_Done,
     /*  156623 */ // Label 2855: @156623
     /*  156623 */ GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(156654), // Rule ID 2195 //
     /*  156628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  156631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156642 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  156642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  156645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156652 */   GIR_RootConstrainSelectedInstOperands,
     /*  156653 */   // GIR_Coverage, 2195,
     /*  156653 */   GIR_EraseRootFromParent_Done,
     /*  156654 */ // Label 2856: @156654
     /*  156654 */ GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(156685), // Rule ID 2220 //
     /*  156659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  156662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156673 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  156676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156683 */   GIR_RootConstrainSelectedInstOperands,
     /*  156684 */   // GIR_Coverage, 2220,
     /*  156684 */   GIR_EraseRootFromParent_Done,
     /*  156685 */ // Label 2857: @156685
     /*  156685 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(156716), // Rule ID 2221 //
     /*  156690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  156693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156704 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  156704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  156707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156714 */   GIR_RootConstrainSelectedInstOperands,
     /*  156715 */   // GIR_Coverage, 2221,
     /*  156715 */   GIR_EraseRootFromParent_Done,
     /*  156716 */ // Label 2858: @156716
     /*  156716 */ GIM_Reject,
     /*  156717 */ // Label 2845: @156717
     /*  156717 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(156748), // Rule ID 1507 //
     /*  156722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  156725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156736 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  156739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156746 */   GIR_RootConstrainSelectedInstOperands,
     /*  156747 */   // GIR_Coverage, 1507,
     /*  156747 */   GIR_EraseRootFromParent_Done,
     /*  156748 */ // Label 2859: @156748
     /*  156748 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(156779), // Rule ID 1535 //
     /*  156753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  156756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156767 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  156770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156772 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156777 */   GIR_RootConstrainSelectedInstOperands,
     /*  156778 */   // GIR_Coverage, 1535,
     /*  156778 */   GIR_EraseRootFromParent_Done,
     /*  156779 */ // Label 2860: @156779
     /*  156779 */ GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(156810), // Rule ID 1909 //
     /*  156784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156798 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  156801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156808 */   GIR_RootConstrainSelectedInstOperands,
     /*  156809 */   // GIR_Coverage, 1909,
     /*  156809 */   GIR_EraseRootFromParent_Done,
     /*  156810 */ // Label 2861: @156810
     /*  156810 */ GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(156841), // Rule ID 1937 //
     /*  156815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156829 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  156832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156834 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156839 */   GIR_RootConstrainSelectedInstOperands,
     /*  156840 */   // GIR_Coverage, 1937,
     /*  156840 */   GIR_EraseRootFromParent_Done,
     /*  156841 */ // Label 2862: @156841
     /*  156841 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(156872), // Rule ID 2245 //
     /*  156846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  156849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156860 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  156863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156870 */   GIR_RootConstrainSelectedInstOperands,
     /*  156871 */   // GIR_Coverage, 2245,
     /*  156871 */   GIR_EraseRootFromParent_Done,
     /*  156872 */ // Label 2863: @156872
     /*  156872 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(156903), // Rule ID 2271 //
     /*  156877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  156880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156891 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  156894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156896 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156901 */   GIR_RootConstrainSelectedInstOperands,
     /*  156902 */   // GIR_Coverage, 2271,
     /*  156902 */   GIR_EraseRootFromParent_Done,
     /*  156903 */ // Label 2864: @156903
     /*  156903 */ GIM_Reject,
     /*  156904 */ // Label 2846: @156904
     /*  156904 */ GIM_Reject,
     /*  156905 */ // Label 17: @156905
     /*  156905 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157114),
     /*  156910 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  156913 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(157113),
     /*  156924 */   /*GILLT_s16*//*Label 2866*/ GIMT_Encode4(156936),
     /*  156928 */   /*GILLT_s32*//*Label 2867*/ GIMT_Encode4(156995),
     /*  156932 */   /*GILLT_s64*//*Label 2868*/ GIMT_Encode4(157054),
     /*  156936 */   // Label 2866: @156936
     /*  156936 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(156994),
     /*  156941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156945 */     GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(156969), // Rule ID 2247 //
     /*  156950 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  156953 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156957 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156957 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  156960 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156962 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156964 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156967 */       GIR_RootConstrainSelectedInstOperands,
     /*  156968 */       // GIR_Coverage, 2247,
     /*  156968 */       GIR_EraseRootFromParent_Done,
     /*  156969 */     // Label 2871: @156969
     /*  156969 */     GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(156993), // Rule ID 2273 //
     /*  156974 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  156977 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  156981 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  156981 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  156984 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156986 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156988 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156991 */       GIR_RootConstrainSelectedInstOperands,
     /*  156992 */       // GIR_Coverage, 2273,
     /*  156992 */       GIR_EraseRootFromParent_Done,
     /*  156993 */     // Label 2872: @156993
     /*  156993 */     GIM_Reject,
     /*  156994 */   // Label 2870: @156994
     /*  156994 */   GIM_Reject,
     /*  156995 */   // Label 2867: @156995
     /*  156995 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157053),
     /*  157000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157004 */     GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157028), // Rule ID 1509 //
     /*  157009 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157016 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157016 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157019 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157021 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157023 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157026 */       GIR_RootConstrainSelectedInstOperands,
     /*  157027 */       // GIR_Coverage, 1509,
     /*  157027 */       GIR_EraseRootFromParent_Done,
     /*  157028 */     // Label 2874: @157028
     /*  157028 */     GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157052), // Rule ID 1537 //
     /*  157033 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157040 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157045 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157047 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157050 */       GIR_RootConstrainSelectedInstOperands,
     /*  157051 */       // GIR_Coverage, 1537,
     /*  157051 */       GIR_EraseRootFromParent_Done,
     /*  157052 */     // Label 2875: @157052
     /*  157052 */     GIM_Reject,
     /*  157053 */   // Label 2873: @157053
     /*  157053 */   GIM_Reject,
     /*  157054 */   // Label 2868: @157054
     /*  157054 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157112),
     /*  157059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157063 */     GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157087), // Rule ID 1911 //
     /*  157068 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157075 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157075 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157078 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157080 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157082 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157085 */       GIR_RootConstrainSelectedInstOperands,
     /*  157086 */       // GIR_Coverage, 1911,
     /*  157086 */       GIR_EraseRootFromParent_Done,
     /*  157087 */     // Label 2877: @157087
     /*  157087 */     GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157111), // Rule ID 1939 //
     /*  157092 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157095 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157099 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157104 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157106 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157109 */       GIR_RootConstrainSelectedInstOperands,
     /*  157110 */       // GIR_Coverage, 1939,
     /*  157110 */       GIR_EraseRootFromParent_Done,
     /*  157111 */     // Label 2878: @157111
     /*  157111 */     GIM_Reject,
     /*  157112 */   // Label 2876: @157112
     /*  157112 */   GIM_Reject,
     /*  157113 */   // Label 2869: @157113
     /*  157113 */   GIM_Reject,
     /*  157114 */ // Label 2865: @157114
     /*  157114 */ GIM_Reject,
     /*  157115 */ // Label 18: @157115
     /*  157115 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2882*/ GIMT_Encode4(157312),
     /*  157126 */ /*GILLT_s16*//*Label 2879*/ GIMT_Encode4(157138),
     /*  157130 */ /*GILLT_s32*//*Label 2880*/ GIMT_Encode4(157196),
     /*  157134 */ /*GILLT_s64*//*Label 2881*/ GIMT_Encode4(157254),
     /*  157138 */ // Label 2879: @157138
     /*  157138 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(157195),
     /*  157143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157154 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(157174), // Rule ID 2416 //
     /*  157159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157162 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  157162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157172 */     GIR_RootConstrainSelectedInstOperands,
     /*  157173 */     // GIR_Coverage, 2416,
     /*  157173 */     GIR_EraseRootFromParent_Done,
     /*  157174 */   // Label 2884: @157174
     /*  157174 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(157194), // Rule ID 2417 //
     /*  157179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157182 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157192 */     GIR_RootConstrainSelectedInstOperands,
     /*  157193 */     // GIR_Coverage, 2417,
     /*  157193 */     GIR_EraseRootFromParent_Done,
     /*  157194 */   // Label 2885: @157194
     /*  157194 */   GIM_Reject,
     /*  157195 */ // Label 2883: @157195
     /*  157195 */ GIM_Reject,
     /*  157196 */ // Label 2880: @157196
     /*  157196 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(157253),
     /*  157201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157212 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(157232), // Rule ID 2334 //
     /*  157217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157220 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  157220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157230 */     GIR_RootConstrainSelectedInstOperands,
     /*  157231 */     // GIR_Coverage, 2334,
     /*  157231 */     GIR_EraseRootFromParent_Done,
     /*  157232 */   // Label 2887: @157232
     /*  157232 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157252), // Rule ID 2335 //
     /*  157237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157240 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  157240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157250 */     GIR_RootConstrainSelectedInstOperands,
     /*  157251 */     // GIR_Coverage, 2335,
     /*  157251 */     GIR_EraseRootFromParent_Done,
     /*  157252 */   // Label 2888: @157252
     /*  157252 */   GIM_Reject,
     /*  157253 */ // Label 2886: @157253
     /*  157253 */ GIM_Reject,
     /*  157254 */ // Label 2881: @157254
     /*  157254 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157311),
     /*  157259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157270 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157290), // Rule ID 2374 //
     /*  157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157278 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  157278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157288 */     GIR_RootConstrainSelectedInstOperands,
     /*  157289 */     // GIR_Coverage, 2374,
     /*  157289 */     GIR_EraseRootFromParent_Done,
     /*  157290 */   // Label 2890: @157290
     /*  157290 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(157310), // Rule ID 2375 //
     /*  157295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157298 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  157298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157308 */     GIR_RootConstrainSelectedInstOperands,
     /*  157309 */     // GIR_Coverage, 2375,
     /*  157309 */     GIR_EraseRootFromParent_Done,
     /*  157310 */   // Label 2891: @157310
     /*  157310 */   GIM_Reject,
     /*  157311 */ // Label 2889: @157311
     /*  157311 */ GIM_Reject,
     /*  157312 */ // Label 2882: @157312
     /*  157312 */ GIM_Reject,
     /*  157313 */ // Label 19: @157313
     /*  157313 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(157351), // Rule ID 281 //
     /*  157318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157321 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157328 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  157328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157333 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  157343 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157349 */   GIR_RootConstrainSelectedInstOperands,
     /*  157350 */   // GIR_Coverage, 281,
     /*  157350 */   GIR_EraseRootFromParent_Done,
     /*  157351 */ // Label 2892: @157351
     /*  157351 */ GIM_Reject,
     /*  157352 */ // Label 20: @157352
     /*  157352 */ GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(157390), // Rule ID 282 //
     /*  157357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157367 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  157367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157372 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  157382 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157388 */   GIR_RootConstrainSelectedInstOperands,
     /*  157389 */   // GIR_Coverage, 282,
     /*  157389 */   GIR_EraseRootFromParent_Done,
     /*  157390 */ // Label 2893: @157390
     /*  157390 */ GIM_Reject,
     /*  157391 */ // Label 21: @157391
     /*  157391 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2928*/ GIMT_Encode4(167672),
     /*  157402 */ /*GILLT_p0s32*//*Label 2894*/ GIMT_Encode4(157538),
     /*  157406 */ /*GILLT_p0s64*//*Label 2895*/ GIMT_Encode4(157632),
     /*  157410 */ /*GILLT_s16*//*Label 2896*/ GIMT_Encode4(157726),
     /*  157414 */ /*GILLT_s32*//*Label 2897*/ GIMT_Encode4(158381),
     /*  157418 */ /*GILLT_s64*//*Label 2898*/ GIMT_Encode4(161140),
     /*  157422 */ /*GILLT_nxv1s1*//*Label 2899*/ GIMT_Encode4(162366),
     /*  157426 */ /*GILLT_nxv1s8*//*Label 2900*/ GIMT_Encode4(162486),
     /*  157430 */ /*GILLT_nxv1s16*//*Label 2901*/ GIMT_Encode4(162614),
     /*  157434 */ /*GILLT_nxv1s32*//*Label 2902*/ GIMT_Encode4(162852),
     /*  157438 */ /*GILLT_nxv1s64*//*Label 2903*/ GIMT_Encode4(163090),
     /*  157442 */ /*GILLT_nxv2s1*//*Label 2904*/ GIMT_Encode4(163328),
     /*  157446 */ /*GILLT_nxv2s8*//*Label 2905*/ GIMT_Encode4(163448),
     /*  157450 */ /*GILLT_nxv2s16*//*Label 2906*/ GIMT_Encode4(163576),
     /*  157454 */ /*GILLT_nxv2s32*//*Label 2907*/ GIMT_Encode4(163814),
     /*  157458 */ /*GILLT_nxv2s64*//*Label 2908*/ GIMT_Encode4(164052),
     /*  157462 */ /*GILLT_nxv4s1*//*Label 2909*/ GIMT_Encode4(164290),
     /*  157466 */ /*GILLT_nxv4s8*//*Label 2910*/ GIMT_Encode4(164410),
     /*  157470 */ /*GILLT_nxv4s16*//*Label 2911*/ GIMT_Encode4(164538),
     /*  157474 */ /*GILLT_nxv4s32*//*Label 2912*/ GIMT_Encode4(164776),
     /*  157478 */ /*GILLT_nxv4s64*//*Label 2913*/ GIMT_Encode4(165014),
     /*  157482 */ /*GILLT_nxv8s1*//*Label 2914*/ GIMT_Encode4(165252),
     /*  157486 */ /*GILLT_nxv8s8*//*Label 2915*/ GIMT_Encode4(165372),
     /*  157490 */ /*GILLT_nxv8s16*//*Label 2916*/ GIMT_Encode4(165500),
     /*  157494 */ /*GILLT_nxv8s32*//*Label 2917*/ GIMT_Encode4(165738),
     /*  157498 */ /*GILLT_nxv8s64*//*Label 2918*/ GIMT_Encode4(165976),
     /*  157502 */ /*GILLT_nxv16s1*//*Label 2919*/ GIMT_Encode4(166214),
     /*  157506 */ /*GILLT_nxv16s8*//*Label 2920*/ GIMT_Encode4(166334),
     /*  157510 */ /*GILLT_nxv16s16*//*Label 2921*/ GIMT_Encode4(166462),
     /*  157514 */ /*GILLT_nxv16s32*//*Label 2922*/ GIMT_Encode4(166700),
     /*  157518 */ /*GILLT_nxv32s1*//*Label 2923*/ GIMT_Encode4(166938),
     /*  157522 */ /*GILLT_nxv32s8*//*Label 2924*/ GIMT_Encode4(167058),
     /*  157526 */ /*GILLT_nxv32s16*//*Label 2925*/ GIMT_Encode4(167186),
     /*  157530 */ /*GILLT_nxv64s1*//*Label 2926*/ GIMT_Encode4(167424),
     /*  157534 */ /*GILLT_nxv64s8*//*Label 2927*/ GIMT_Encode4(167544),
     /*  157538 */ // Label 2894: @157538
     /*  157538 */ GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(157631),
     /*  157543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157558 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(157594), // Rule ID 65092 //
     /*  157563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  157566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157573 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157592 */     GIR_RootConstrainSelectedInstOperands,
     /*  157593 */     // GIR_Coverage, 65092,
     /*  157593 */     GIR_EraseRootFromParent_Done,
     /*  157594 */   // Label 2930: @157594
     /*  157594 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(157630), // Rule ID 65096 //
     /*  157599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  157602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157609 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157628 */     GIR_RootConstrainSelectedInstOperands,
     /*  157629 */     // GIR_Coverage, 65096,
     /*  157629 */     GIR_EraseRootFromParent_Done,
     /*  157630 */   // Label 2931: @157630
     /*  157630 */   GIM_Reject,
     /*  157631 */ // Label 2929: @157631
     /*  157631 */ GIM_Reject,
     /*  157632 */ // Label 2895: @157632
     /*  157632 */ GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(157725),
     /*  157637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157652 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(157688), // Rule ID 65091 //
     /*  157657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  157660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157667 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157686 */     GIR_RootConstrainSelectedInstOperands,
     /*  157687 */     // GIR_Coverage, 65091,
     /*  157687 */     GIR_EraseRootFromParent_Done,
     /*  157688 */   // Label 2933: @157688
     /*  157688 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(157724), // Rule ID 65095 //
     /*  157693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157703 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157722 */     GIR_RootConstrainSelectedInstOperands,
     /*  157723 */     // GIR_Coverage, 65095,
     /*  157723 */     GIR_EraseRootFromParent_Done,
     /*  157724 */   // Label 2934: @157724
     /*  157724 */   GIM_Reject,
     /*  157725 */ // Label 2932: @157725
     /*  157725 */ GIM_Reject,
     /*  157726 */ // Label 2896: @157726
     /*  157726 */ GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(157777), // Rule ID 2142 //
     /*  157731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  157734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157749 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157756 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  157759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157775 */   GIR_RootConstrainSelectedInstOperands,
     /*  157776 */   // GIR_Coverage, 2142,
     /*  157776 */   GIR_EraseRootFromParent_Done,
     /*  157777 */ // Label 2935: @157777
     /*  157777 */ GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(157828), // Rule ID 2143 //
     /*  157782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  157785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157788 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157807 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  157810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157826 */   GIR_RootConstrainSelectedInstOperands,
     /*  157827 */   // GIR_Coverage, 2143,
     /*  157827 */   GIR_EraseRootFromParent_Done,
     /*  157828 */ // Label 2936: @157828
     /*  157828 */ GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(157879), // Rule ID 2148 //
     /*  157833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  157836 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157858 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  157861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157877 */   GIR_RootConstrainSelectedInstOperands,
     /*  157878 */   // GIR_Coverage, 2148,
     /*  157878 */   GIR_EraseRootFromParent_Done,
     /*  157879 */ // Label 2937: @157879
     /*  157879 */ GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(157930), // Rule ID 2149 //
     /*  157884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  157887 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157890 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157909 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  157912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157928 */   GIR_RootConstrainSelectedInstOperands,
     /*  157929 */   // GIR_Coverage, 2149,
     /*  157929 */   GIR_EraseRootFromParent_Done,
     /*  157930 */ // Label 2938: @157930
     /*  157930 */ GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(157981), // Rule ID 65099 //
     /*  157935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  157938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157960 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  157963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157979 */   GIR_RootConstrainSelectedInstOperands,
     /*  157980 */   // GIR_Coverage, 65099,
     /*  157980 */   GIR_EraseRootFromParent_Done,
     /*  157981 */ // Label 2939: @157981
     /*  157981 */ GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(158032), // Rule ID 65100 //
     /*  157986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  157989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158011 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158030 */   GIR_RootConstrainSelectedInstOperands,
     /*  158031 */   // GIR_Coverage, 65100,
     /*  158031 */   GIR_EraseRootFromParent_Done,
     /*  158032 */ // Label 2940: @158032
     /*  158032 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(158090), // Rule ID 65103 //
     /*  158037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158043 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158069 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158088 */   GIR_RootConstrainSelectedInstOperands,
     /*  158089 */   // GIR_Coverage, 65103,
     /*  158089 */   GIR_EraseRootFromParent_Done,
     /*  158090 */ // Label 2941: @158090
     /*  158090 */ GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(158148), // Rule ID 65104 //
     /*  158095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158127 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158146 */   GIR_RootConstrainSelectedInstOperands,
     /*  158147 */   // GIR_Coverage, 65104,
     /*  158147 */   GIR_EraseRootFromParent_Done,
     /*  158148 */ // Label 2942: @158148
     /*  158148 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(158206), // Rule ID 65107 //
     /*  158153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158185 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158200 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158204 */   GIR_RootConstrainSelectedInstOperands,
     /*  158205 */   // GIR_Coverage, 65107,
     /*  158205 */   GIR_EraseRootFromParent_Done,
     /*  158206 */ // Label 2943: @158206
     /*  158206 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(158264), // Rule ID 65108 //
     /*  158211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158217 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158232 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158236 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158243 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158262 */   GIR_RootConstrainSelectedInstOperands,
     /*  158263 */   // GIR_Coverage, 65108,
     /*  158263 */   GIR_EraseRootFromParent_Done,
     /*  158264 */ // Label 2944: @158264
     /*  158264 */ GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(158322), // Rule ID 65109 //
     /*  158269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158301 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158320 */   GIR_RootConstrainSelectedInstOperands,
     /*  158321 */   // GIR_Coverage, 65109,
     /*  158321 */   GIR_EraseRootFromParent_Done,
     /*  158322 */ // Label 2945: @158322
     /*  158322 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(158380), // Rule ID 65110 //
     /*  158327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158359 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158378 */   GIR_RootConstrainSelectedInstOperands,
     /*  158379 */   // GIR_Coverage, 65110,
     /*  158379 */   GIR_EraseRootFromParent_Done,
     /*  158380 */ // Label 2946: @158380
     /*  158380 */ GIM_Reject,
     /*  158381 */ // Label 2897: @158381
     /*  158381 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158492), // Rule ID 74115 //
     /*  158386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158407 */   // MIs[0] Operand 1
     /*  158407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158435 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158439 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158443 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158448 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158452 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158456 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158460 */   // MIs[3] Operand 1
     /*  158460 */   // No operand predicates
     /*  158460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158465 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158467 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  158470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158472 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158476 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158480 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158490 */   GIR_RootConstrainSelectedInstOperands,
     /*  158491 */   // GIR_Coverage, 74115,
     /*  158491 */   GIR_EraseRootFromParent_Done,
     /*  158492 */ // Label 2947: @158492
     /*  158492 */ GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158603), // Rule ID 74116 //
     /*  158497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158503 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158518 */   // MIs[0] Operand 1
     /*  158518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158534 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158546 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158550 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158554 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158559 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158563 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158567 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158571 */   // MIs[3] Operand 1
     /*  158571 */   // No operand predicates
     /*  158571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158576 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158578 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  158578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  158581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158591 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158601 */   GIR_RootConstrainSelectedInstOperands,
     /*  158602 */   // GIR_Coverage, 74116,
     /*  158602 */   GIR_EraseRootFromParent_Done,
     /*  158603 */ // Label 2948: @158603
     /*  158603 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158714), // Rule ID 74119 //
     /*  158608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158614 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158629 */   // MIs[0] Operand 1
     /*  158629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158649 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158653 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158657 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158661 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158665 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158670 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158674 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158678 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158682 */   // MIs[3] Operand 1
     /*  158682 */   // No operand predicates
     /*  158682 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158687 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158689 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  158692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158694 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158698 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158712 */   GIR_RootConstrainSelectedInstOperands,
     /*  158713 */   // GIR_Coverage, 74119,
     /*  158713 */   GIR_EraseRootFromParent_Done,
     /*  158714 */ // Label 2949: @158714
     /*  158714 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158825), // Rule ID 74120 //
     /*  158719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158740 */   // MIs[0] Operand 1
     /*  158740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158768 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158772 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158776 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158781 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158785 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158789 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158793 */   // MIs[3] Operand 1
     /*  158793 */   // No operand predicates
     /*  158793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158798 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158800 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  158800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  158803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158805 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158809 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158813 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158823 */   GIR_RootConstrainSelectedInstOperands,
     /*  158824 */   // GIR_Coverage, 74120,
     /*  158824 */   GIR_EraseRootFromParent_Done,
     /*  158825 */ // Label 2950: @158825
     /*  158825 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158929), // Rule ID 74121 //
     /*  158830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  158833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158844 */   // MIs[0] Operand 1
     /*  158844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158864 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158868 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158872 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158876 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  158880 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158885 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158889 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158893 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  158897 */   // MIs[3] Operand 1
     /*  158897 */   // No operand predicates
     /*  158897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158902 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  158904 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  158904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  158907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  158913 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  158917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  158920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  158927 */   GIR_RootConstrainSelectedInstOperands,
     /*  158928 */   // GIR_Coverage, 74121,
     /*  158928 */   GIR_EraseRootFromParent_Done,
     /*  158929 */ // Label 2951: @158929
     /*  158929 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(159033), // Rule ID 74122 //
     /*  158934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  158937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158948 */   // MIs[0] Operand 1
     /*  158948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  158956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  158960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  158964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  158968 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  158972 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  158976 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  158980 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  158984 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  158989 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  158993 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  158997 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159001 */   // MIs[3] Operand 1
     /*  159001 */   // No operand predicates
     /*  159001 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159006 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159008 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159013 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  159017 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159021 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159031 */   GIR_RootConstrainSelectedInstOperands,
     /*  159032 */   // GIR_Coverage, 74122,
     /*  159032 */   GIR_EraseRootFromParent_Done,
     /*  159033 */ // Label 2952: @159033
     /*  159033 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(159144), // Rule ID 64548 //
     /*  159038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159044 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159059 */   // MIs[0] Operand 1
     /*  159059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159079 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159084 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159088 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159092 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159096 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159100 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159105 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159109 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159113 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159117 */   // MIs[3] Operand 1
     /*  159117 */   // No operand predicates
     /*  159117 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159119 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  159122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159132 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159142 */   GIR_RootConstrainSelectedInstOperands,
     /*  159143 */   // GIR_Coverage, 64548,
     /*  159143 */   GIR_EraseRootFromParent_Done,
     /*  159144 */ // Label 2953: @159144
     /*  159144 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(159255), // Rule ID 64549 //
     /*  159149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159170 */   // MIs[0] Operand 1
     /*  159170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159190 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159195 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159199 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159203 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159207 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159211 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159216 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159220 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159224 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159228 */   // MIs[3] Operand 1
     /*  159228 */   // No operand predicates
     /*  159228 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159230 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  159233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159235 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159239 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159243 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159253 */   GIR_RootConstrainSelectedInstOperands,
     /*  159254 */   // GIR_Coverage, 64549,
     /*  159254 */   GIR_EraseRootFromParent_Done,
     /*  159255 */ // Label 2954: @159255
     /*  159255 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(159366), // Rule ID 64552 //
     /*  159260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159266 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159281 */   // MIs[0] Operand 1
     /*  159281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159306 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159310 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159314 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159318 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159322 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159327 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159331 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159335 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159339 */   // MIs[3] Operand 1
     /*  159339 */   // No operand predicates
     /*  159339 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159341 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  159344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159346 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159350 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159364 */   GIR_RootConstrainSelectedInstOperands,
     /*  159365 */   // GIR_Coverage, 64552,
     /*  159365 */   GIR_EraseRootFromParent_Done,
     /*  159366 */ // Label 2955: @159366
     /*  159366 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(159477), // Rule ID 64553 //
     /*  159371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159374 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159377 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159392 */   // MIs[0] Operand 1
     /*  159392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159408 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159412 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159417 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159421 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159425 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159429 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159433 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159438 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159442 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159446 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159450 */   // MIs[3] Operand 1
     /*  159450 */   // No operand predicates
     /*  159450 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159452 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  159455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159457 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159461 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159465 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159475 */   GIR_RootConstrainSelectedInstOperands,
     /*  159476 */   // GIR_Coverage, 64553,
     /*  159476 */   GIR_EraseRootFromParent_Done,
     /*  159477 */ // Label 2956: @159477
     /*  159477 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(159581), // Rule ID 64554 //
     /*  159482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  159485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159488 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159496 */   // MIs[0] Operand 1
     /*  159496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159500 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159508 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159512 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159521 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159525 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159529 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159533 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  159537 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159542 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159546 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159550 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159554 */   // MIs[3] Operand 1
     /*  159554 */   // No operand predicates
     /*  159554 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159556 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  159556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159561 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159565 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159569 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159579 */   GIR_RootConstrainSelectedInstOperands,
     /*  159580 */   // GIR_Coverage, 64554,
     /*  159580 */   GIR_EraseRootFromParent_Done,
     /*  159581 */ // Label 2957: @159581
     /*  159581 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(159685), // Rule ID 64555 //
     /*  159586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  159589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159600 */   // MIs[0] Operand 1
     /*  159600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  159608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  159612 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  159616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  159620 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159625 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  159629 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  159633 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  159637 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  159641 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  159646 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  159650 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  159654 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  159658 */   // MIs[3] Operand 1
     /*  159658 */   // No operand predicates
     /*  159658 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  159660 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  159660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  159663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  159669 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  159673 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  159676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  159683 */   GIR_RootConstrainSelectedInstOperands,
     /*  159684 */   // GIR_Coverage, 64555,
     /*  159684 */   GIR_EraseRootFromParent_Done,
     /*  159685 */ // Label 2958: @159685
     /*  159685 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(159743), // Rule ID 227 //
     /*  159690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159696 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159722 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159741 */   GIR_RootConstrainSelectedInstOperands,
     /*  159742 */   // GIR_Coverage, 227,
     /*  159742 */   GIR_EraseRootFromParent_Done,
     /*  159743 */ // Label 2959: @159743
     /*  159743 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(159801), // Rule ID 231 //
     /*  159748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159780 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159799 */   GIR_RootConstrainSelectedInstOperands,
     /*  159800 */   // GIR_Coverage, 231,
     /*  159800 */   GIR_EraseRootFromParent_Done,
     /*  159801 */ // Label 2960: @159801
     /*  159801 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159852), // Rule ID 232 //
     /*  159806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  159809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159831 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159850 */   GIR_RootConstrainSelectedInstOperands,
     /*  159851 */   // GIR_Coverage, 232,
     /*  159851 */   GIR_EraseRootFromParent_Done,
     /*  159852 */ // Label 2961: @159852
     /*  159852 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159903), // Rule ID 233 //
     /*  159857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159860 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159863 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159882 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159901 */   GIR_RootConstrainSelectedInstOperands,
     /*  159902 */   // GIR_Coverage, 233,
     /*  159902 */   GIR_EraseRootFromParent_Done,
     /*  159903 */ // Label 2962: @159903
     /*  159903 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159964), // Rule ID 314 //
     /*  159908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159914 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159925 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159943 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10095>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159962 */   GIR_RootConstrainSelectedInstOperands,
     /*  159963 */   // GIR_Coverage, 314,
     /*  159963 */   GIR_EraseRootFromParent_Done,
     /*  159964 */ // Label 2963: @159964
     /*  159964 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(160025), // Rule ID 318 //
     /*  159969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159972 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159975 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159979 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159986 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160004 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10097>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160023 */   GIR_RootConstrainSelectedInstOperands,
     /*  160024 */   // GIR_Coverage, 318,
     /*  160024 */   GIR_EraseRootFromParent_Done,
     /*  160025 */ // Label 2964: @160025
     /*  160025 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(160086), // Rule ID 332 //
     /*  160030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  160033 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160047 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160065 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10109>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160084 */   GIR_RootConstrainSelectedInstOperands,
     /*  160085 */   // GIR_Coverage, 332,
     /*  160085 */   GIR_EraseRootFromParent_Done,
     /*  160086 */ // Label 2965: @160086
     /*  160086 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(160147), // Rule ID 334 //
     /*  160091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160097 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160108 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160119 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160126 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10111>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160145 */   GIR_RootConstrainSelectedInstOperands,
     /*  160146 */   // GIR_Coverage, 334,
     /*  160146 */   GIR_EraseRootFromParent_Done,
     /*  160147 */ // Label 2966: @160147
     /*  160147 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(160198), // Rule ID 1425 //
     /*  160152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  160155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  160166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160177 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  160180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160196 */   GIR_RootConstrainSelectedInstOperands,
     /*  160197 */   // GIR_Coverage, 1425,
     /*  160197 */   GIR_EraseRootFromParent_Done,
     /*  160198 */ // Label 2967: @160198
     /*  160198 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(160249), // Rule ID 1426 //
     /*  160203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  160206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  160217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160228 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  160231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160247 */   GIR_RootConstrainSelectedInstOperands,
     /*  160248 */   // GIR_Coverage, 1426,
     /*  160248 */   GIR_EraseRootFromParent_Done,
     /*  160249 */ // Label 2968: @160249
     /*  160249 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(160300), // Rule ID 1431 //
     /*  160254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  160257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  160268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160279 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  160282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160298 */   GIR_RootConstrainSelectedInstOperands,
     /*  160299 */   // GIR_Coverage, 1431,
     /*  160299 */   GIR_EraseRootFromParent_Done,
     /*  160300 */ // Label 2969: @160300
     /*  160300 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(160351), // Rule ID 1432 //
     /*  160305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  160308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  160319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160330 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  160333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160349 */   GIR_RootConstrainSelectedInstOperands,
     /*  160350 */   // GIR_Coverage, 1432,
     /*  160350 */   GIR_EraseRootFromParent_Done,
     /*  160351 */ // Label 2970: @160351
     /*  160351 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(160409), // Rule ID 65115 //
     /*  160356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160359 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160388 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160407 */   GIR_RootConstrainSelectedInstOperands,
     /*  160408 */   // GIR_Coverage, 65115,
     /*  160408 */   GIR_EraseRootFromParent_Done,
     /*  160409 */ // Label 2971: @160409
     /*  160409 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(160467), // Rule ID 65116 //
     /*  160414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  160417 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160446 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160465 */   GIR_RootConstrainSelectedInstOperands,
     /*  160466 */   // GIR_Coverage, 65116,
     /*  160466 */   GIR_EraseRootFromParent_Done,
     /*  160467 */ // Label 2972: @160467
     /*  160467 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(160525), // Rule ID 65119 //
     /*  160472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160478 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160504 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160523 */   GIR_RootConstrainSelectedInstOperands,
     /*  160524 */   // GIR_Coverage, 65119,
     /*  160524 */   GIR_EraseRootFromParent_Done,
     /*  160525 */ // Label 2973: @160525
     /*  160525 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(160583), // Rule ID 65120 //
     /*  160530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160536 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160540 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160555 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160562 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160581 */   GIR_RootConstrainSelectedInstOperands,
     /*  160582 */   // GIR_Coverage, 65120,
     /*  160582 */   GIR_EraseRootFromParent_Done,
     /*  160583 */ // Label 2974: @160583
     /*  160583 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(160641), // Rule ID 65121 //
     /*  160588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160594 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160620 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160639 */   GIR_RootConstrainSelectedInstOperands,
     /*  160640 */   // GIR_Coverage, 65121,
     /*  160640 */   GIR_EraseRootFromParent_Done,
     /*  160641 */ // Label 2975: @160641
     /*  160641 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(160699), // Rule ID 65122 //
     /*  160646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  160649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160652 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160678 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160697 */   GIR_RootConstrainSelectedInstOperands,
     /*  160698 */   // GIR_Coverage, 65122,
     /*  160698 */   GIR_EraseRootFromParent_Done,
     /*  160699 */ // Label 2976: @160699
     /*  160699 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(160743), // Rule ID 1090 //
     /*  160704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160707 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160710 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160714 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160728 */   // MIs[0] rs1
     /*  160728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160736 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10599>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160741 */   GIR_RootConstrainSelectedInstOperands,
     /*  160742 */   // GIR_Coverage, 1090,
     /*  160742 */   GIR_Done,
     /*  160743 */ // Label 2977: @160743
     /*  160743 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(160787), // Rule ID 1094 //
     /*  160748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160772 */   // MIs[0] rs1
     /*  160772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160780 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10601>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  160785 */   GIR_RootConstrainSelectedInstOperands,
     /*  160786 */   // GIR_Coverage, 1094,
     /*  160786 */   GIR_Done,
     /*  160787 */ // Label 2978: @160787
     /*  160787 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160831), // Rule ID 1098 //
     /*  160792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160795 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160798 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160802 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160816 */   // MIs[0] rs1
     /*  160816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160824 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10603>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160829 */   GIR_RootConstrainSelectedInstOperands,
     /*  160830 */   // GIR_Coverage, 1098,
     /*  160830 */   GIR_Done,
     /*  160831 */ // Label 2979: @160831
     /*  160831 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160875), // Rule ID 1102 //
     /*  160836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160839 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160853 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160860 */   // MIs[0] rs1
     /*  160860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160868 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10605>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160873 */   GIR_RootConstrainSelectedInstOperands,
     /*  160874 */   // GIR_Coverage, 1102,
     /*  160874 */   GIR_Done,
     /*  160875 */ // Label 2980: @160875
     /*  160875 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160919), // Rule ID 1118 //
     /*  160880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160890 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160904 */   // MIs[0] rs1
     /*  160904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160912 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160917 */   GIR_RootConstrainSelectedInstOperands,
     /*  160918 */   // GIR_Coverage, 1118,
     /*  160918 */   GIR_Done,
     /*  160919 */ // Label 2981: @160919
     /*  160919 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160963), // Rule ID 1120 //
     /*  160924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160934 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160948 */   // MIs[0] rs1
     /*  160948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160956 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160961 */   GIR_RootConstrainSelectedInstOperands,
     /*  160962 */   // GIR_Coverage, 1120,
     /*  160962 */   GIR_Done,
     /*  160963 */ // Label 2982: @160963
     /*  160963 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161007), // Rule ID 1122 //
     /*  160968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160992 */   // MIs[0] rs1
     /*  160992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161000 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10623>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161000 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161005 */   GIR_RootConstrainSelectedInstOperands,
     /*  161006 */   // GIR_Coverage, 1122,
     /*  161006 */   GIR_Done,
     /*  161007 */ // Label 2983: @161007
     /*  161007 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161051), // Rule ID 1126 //
     /*  161012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161015 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161018 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161036 */   // MIs[0] rs1
     /*  161036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161044 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10625>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161049 */   GIR_RootConstrainSelectedInstOperands,
     /*  161050 */   // GIR_Coverage, 1126,
     /*  161050 */   GIR_Done,
     /*  161051 */ // Label 2984: @161051
     /*  161051 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161095), // Rule ID 1130 //
     /*  161056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161080 */   // MIs[0] rs1
     /*  161080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161088 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10627>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161093 */   GIR_RootConstrainSelectedInstOperands,
     /*  161094 */   // GIR_Coverage, 1130,
     /*  161094 */   GIR_Done,
     /*  161095 */ // Label 2985: @161095
     /*  161095 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161139), // Rule ID 1132 //
     /*  161100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  161103 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161117 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161124 */   // MIs[0] rs1
     /*  161124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161132 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10629>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  161132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161137 */   GIR_RootConstrainSelectedInstOperands,
     /*  161138 */   // GIR_Coverage, 1132,
     /*  161138 */   GIR_Done,
     /*  161139 */ // Label 2986: @161139
     /*  161139 */ GIM_Reject,
     /*  161140 */ // Label 2898: @161140
     /*  161140 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161198), // Rule ID 226 //
     /*  161145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  161148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161151 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161177 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  161180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161196 */   GIR_RootConstrainSelectedInstOperands,
     /*  161197 */   // GIR_Coverage, 226,
     /*  161197 */   GIR_EraseRootFromParent_Done,
     /*  161198 */ // Label 2987: @161198
     /*  161198 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161256), // Rule ID 230 //
     /*  161203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  161206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161209 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161235 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161254 */   GIR_RootConstrainSelectedInstOperands,
     /*  161255 */   // GIR_Coverage, 230,
     /*  161255 */   GIR_EraseRootFromParent_Done,
     /*  161256 */ // Label 2988: @161256
     /*  161256 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(161314), // Rule ID 276 //
     /*  161261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  161264 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161267 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161293 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161312 */   GIR_RootConstrainSelectedInstOperands,
     /*  161313 */   // GIR_Coverage, 276,
     /*  161313 */   GIR_EraseRootFromParent_Done,
     /*  161314 */ // Label 2989: @161314
     /*  161314 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(161365), // Rule ID 278 //
     /*  161319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  161322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161344 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161363 */   GIR_RootConstrainSelectedInstOperands,
     /*  161364 */   // GIR_Coverage, 278,
     /*  161364 */   GIR_EraseRootFromParent_Done,
     /*  161365 */ // Label 2990: @161365
     /*  161365 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(161426), // Rule ID 313 //
     /*  161370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161387 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161394 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161405 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10095>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  161408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161424 */   GIR_RootConstrainSelectedInstOperands,
     /*  161425 */   // GIR_Coverage, 313,
     /*  161425 */   GIR_EraseRootFromParent_Done,
     /*  161426 */ // Label 2991: @161426
     /*  161426 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(161487), // Rule ID 317 //
     /*  161431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  161434 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161437 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161448 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161466 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10097>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  161469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161485 */   GIR_RootConstrainSelectedInstOperands,
     /*  161486 */   // GIR_Coverage, 317,
     /*  161486 */   GIR_EraseRootFromParent_Done,
     /*  161487 */ // Label 2992: @161487
     /*  161487 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(161548), // Rule ID 331 //
     /*  161492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  161495 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161502 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161509 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161527 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10109>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161546 */   GIR_RootConstrainSelectedInstOperands,
     /*  161547 */   // GIR_Coverage, 331,
     /*  161547 */   GIR_EraseRootFromParent_Done,
     /*  161548 */ // Label 2993: @161548
     /*  161548 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(161609), // Rule ID 333 //
     /*  161553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161556 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161559 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161570 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161588 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10111>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  161591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161607 */   GIR_RootConstrainSelectedInstOperands,
     /*  161608 */   // GIR_Coverage, 333,
     /*  161608 */   GIR_EraseRootFromParent_Done,
     /*  161609 */ // Label 2994: @161609
     /*  161609 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(161670), // Rule ID 339 //
     /*  161614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  161617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161620 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161631 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161649 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10115>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161668 */   GIR_RootConstrainSelectedInstOperands,
     /*  161669 */   // GIR_Coverage, 339,
     /*  161669 */   GIR_EraseRootFromParent_Done,
     /*  161670 */ // Label 2995: @161670
     /*  161670 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(161721), // Rule ID 1823 //
     /*  161675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  161678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161700 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161719 */   GIR_RootConstrainSelectedInstOperands,
     /*  161720 */   // GIR_Coverage, 1823,
     /*  161720 */   GIR_EraseRootFromParent_Done,
     /*  161721 */ // Label 2996: @161721
     /*  161721 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(161772), // Rule ID 1824 //
     /*  161726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  161729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  161740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161751 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  161754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161770 */   GIR_RootConstrainSelectedInstOperands,
     /*  161771 */   // GIR_Coverage, 1824,
     /*  161771 */   GIR_EraseRootFromParent_Done,
     /*  161772 */ // Label 2997: @161772
     /*  161772 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(161823), // Rule ID 1828 //
     /*  161777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  161780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161802 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  161805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161821 */   GIR_RootConstrainSelectedInstOperands,
     /*  161822 */   // GIR_Coverage, 1828,
     /*  161822 */   GIR_EraseRootFromParent_Done,
     /*  161823 */ // Label 2998: @161823
     /*  161823 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161874), // Rule ID 1836 //
     /*  161828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161853 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161872 */   GIR_RootConstrainSelectedInstOperands,
     /*  161873 */   // GIR_Coverage, 1836,
     /*  161873 */   GIR_EraseRootFromParent_Done,
     /*  161874 */ // Label 2999: @161874
     /*  161874 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161925), // Rule ID 1837 //
     /*  161879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161904 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161923 */   GIR_RootConstrainSelectedInstOperands,
     /*  161924 */   // GIR_Coverage, 1837,
     /*  161924 */   GIR_EraseRootFromParent_Done,
     /*  161925 */ // Label 3000: @161925
     /*  161925 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161969), // Rule ID 1089 //
     /*  161930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161933 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161954 */   // MIs[0] rs1
     /*  161954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161962 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10599>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161967 */   GIR_RootConstrainSelectedInstOperands,
     /*  161968 */   // GIR_Coverage, 1089,
     /*  161968 */   GIR_Done,
     /*  161969 */ // Label 3001: @161969
     /*  161969 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162013), // Rule ID 1093 //
     /*  161974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161980 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161998 */   // MIs[0] rs1
     /*  161998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162006 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10601>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  162011 */   GIR_RootConstrainSelectedInstOperands,
     /*  162012 */   // GIR_Coverage, 1093,
     /*  162012 */   GIR_Done,
     /*  162013 */ // Label 3002: @162013
     /*  162013 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162057), // Rule ID 1097 //
     /*  162018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  162021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162024 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  162035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162042 */   // MIs[0] rs1
     /*  162042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162050 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10603>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  162055 */   GIR_RootConstrainSelectedInstOperands,
     /*  162056 */   // GIR_Coverage, 1097,
     /*  162056 */   GIR_Done,
     /*  162057 */ // Label 3003: @162057
     /*  162057 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162101), // Rule ID 1101 //
     /*  162062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  162065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162068 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  162079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162086 */   // MIs[0] rs1
     /*  162086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162094 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10605>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  162099 */   GIR_RootConstrainSelectedInstOperands,
     /*  162100 */   // GIR_Coverage, 1101,
     /*  162100 */   GIR_Done,
     /*  162101 */ // Label 3004: @162101
     /*  162101 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162145), // Rule ID 1117 //
     /*  162106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  162109 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162130 */   // MIs[0] rs1
     /*  162130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162138 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10619>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162143 */   GIR_RootConstrainSelectedInstOperands,
     /*  162144 */   // GIR_Coverage, 1117,
     /*  162144 */   GIR_Done,
     /*  162145 */ // Label 3005: @162145
     /*  162145 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162189), // Rule ID 1119 //
     /*  162150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  162153 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162174 */   // MIs[0] rs1
     /*  162174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162182 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10621>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162187 */   GIR_RootConstrainSelectedInstOperands,
     /*  162188 */   // GIR_Coverage, 1119,
     /*  162188 */   GIR_Done,
     /*  162189 */ // Label 3006: @162189
     /*  162189 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162233), // Rule ID 1121 //
     /*  162194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162197 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162218 */   // MIs[0] rs1
     /*  162218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162226 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10623>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162231 */   GIR_RootConstrainSelectedInstOperands,
     /*  162232 */   // GIR_Coverage, 1121,
     /*  162232 */   GIR_Done,
     /*  162233 */ // Label 3007: @162233
     /*  162233 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162277), // Rule ID 1125 //
     /*  162238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  162255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162262 */   // MIs[0] rs1
     /*  162262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162270 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10625>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  162275 */   GIR_RootConstrainSelectedInstOperands,
     /*  162276 */   // GIR_Coverage, 1125,
     /*  162276 */   GIR_Done,
     /*  162277 */ // Label 3008: @162277
     /*  162277 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162321), // Rule ID 1129 //
     /*  162282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  162299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  162302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162306 */   // MIs[0] rs1
     /*  162306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162314 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10627>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162319 */   GIR_RootConstrainSelectedInstOperands,
     /*  162320 */   // GIR_Coverage, 1129,
     /*  162320 */   GIR_Done,
     /*  162321 */ // Label 3009: @162321
     /*  162321 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162365), // Rule ID 1131 //
     /*  162326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  162329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  162332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  162343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  162346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162350 */   // MIs[0] rs1
     /*  162350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162358 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10629>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  162358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  162363 */   GIR_RootConstrainSelectedInstOperands,
     /*  162364 */   // GIR_Coverage, 1131,
     /*  162364 */   GIR_Done,
     /*  162365 */ // Label 3010: @162365
     /*  162365 */ GIM_Reject,
     /*  162366 */ // Label 2899: @162366
     /*  162366 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162485),
     /*  162371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162390 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162437), // Rule ID 45734 //
     /*  162395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162398 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162435 */     GIR_RootConstrainSelectedInstOperands,
     /*  162436 */     // GIR_Coverage, 45734,
     /*  162436 */     GIR_EraseRootFromParent_Done,
     /*  162437 */   // Label 3012: @162437
     /*  162437 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162484), // Rule ID 45735 //
     /*  162442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162445 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  162448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  162462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162482 */     GIR_RootConstrainSelectedInstOperands,
     /*  162483 */     // GIR_Coverage, 45735,
     /*  162483 */     GIR_EraseRootFromParent_Done,
     /*  162484 */   // Label 3013: @162484
     /*  162484 */   GIM_Reject,
     /*  162485 */ // Label 3011: @162485
     /*  162485 */ GIM_Reject,
     /*  162486 */ // Label 2900: @162486
     /*  162486 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162613),
     /*  162491 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162502 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162557), // Rule ID 45730 //
     /*  162507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162510 */     // MIs[0] rs1
     /*  162510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162518 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162555 */     GIR_RootConstrainSelectedInstOperands,
     /*  162556 */     // GIR_Coverage, 45730,
     /*  162556 */     GIR_EraseRootFromParent_Done,
     /*  162557 */   // Label 3015: @162557
     /*  162557 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162612), // Rule ID 45731 //
     /*  162562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162565 */     // MIs[0] rs1
     /*  162565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162573 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  162576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  162590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162610 */     GIR_RootConstrainSelectedInstOperands,
     /*  162611 */     // GIR_Coverage, 45731,
     /*  162611 */     GIR_EraseRootFromParent_Done,
     /*  162612 */   // Label 3016: @162612
     /*  162612 */   GIM_Reject,
     /*  162613 */ // Label 3014: @162613
     /*  162613 */ GIM_Reject,
     /*  162614 */ // Label 2901: @162614
     /*  162614 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162851),
     /*  162619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162630 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(162685), // Rule ID 45926 //
     /*  162635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162638 */     // MIs[0] rs1
     /*  162638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162646 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162683 */     GIR_RootConstrainSelectedInstOperands,
     /*  162684 */     // GIR_Coverage, 45926,
     /*  162684 */     GIR_EraseRootFromParent_Done,
     /*  162685 */   // Label 3018: @162685
     /*  162685 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(162740), // Rule ID 45927 //
     /*  162690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162693 */     // MIs[0] rs1
     /*  162693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162701 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162738 */     GIR_RootConstrainSelectedInstOperands,
     /*  162739 */     // GIR_Coverage, 45927,
     /*  162739 */     GIR_EraseRootFromParent_Done,
     /*  162740 */   // Label 3019: @162740
     /*  162740 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(162795), // Rule ID 46002 //
     /*  162745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162748 */     // MIs[0] rs1
     /*  162748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162756 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162793 */     GIR_RootConstrainSelectedInstOperands,
     /*  162794 */     // GIR_Coverage, 46002,
     /*  162794 */     GIR_EraseRootFromParent_Done,
     /*  162795 */   // Label 3020: @162795
     /*  162795 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162850), // Rule ID 46003 //
     /*  162800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162803 */     // MIs[0] rs1
     /*  162803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162811 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  162814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162848 */     GIR_RootConstrainSelectedInstOperands,
     /*  162849 */     // GIR_Coverage, 46003,
     /*  162849 */     GIR_EraseRootFromParent_Done,
     /*  162850 */   // Label 3021: @162850
     /*  162850 */   GIM_Reject,
     /*  162851 */ // Label 3017: @162851
     /*  162851 */ GIM_Reject,
     /*  162852 */ // Label 2902: @162852
     /*  162852 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163089),
     /*  162857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162868 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162923), // Rule ID 45934 //
     /*  162873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162876 */     // MIs[0] rs1
     /*  162876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162884 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162921 */     GIR_RootConstrainSelectedInstOperands,
     /*  162922 */     // GIR_Coverage, 45934,
     /*  162922 */     GIR_EraseRootFromParent_Done,
     /*  162923 */   // Label 3023: @162923
     /*  162923 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162978), // Rule ID 45935 //
     /*  162928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162931 */     // MIs[0] rs1
     /*  162931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162939 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162976 */     GIR_RootConstrainSelectedInstOperands,
     /*  162977 */     // GIR_Coverage, 45935,
     /*  162977 */     GIR_EraseRootFromParent_Done,
     /*  162978 */   // Label 3024: @162978
     /*  162978 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163033), // Rule ID 46010 //
     /*  162983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162986 */     // MIs[0] rs1
     /*  162986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162994 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  163011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163031 */     GIR_RootConstrainSelectedInstOperands,
     /*  163032 */     // GIR_Coverage, 46010,
     /*  163032 */     GIR_EraseRootFromParent_Done,
     /*  163033 */   // Label 3025: @163033
     /*  163033 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163088), // Rule ID 46011 //
     /*  163038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163041 */     // MIs[0] rs1
     /*  163041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163049 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  163052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  163066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163086 */     GIR_RootConstrainSelectedInstOperands,
     /*  163087 */     // GIR_Coverage, 46011,
     /*  163087 */     GIR_EraseRootFromParent_Done,
     /*  163088 */   // Label 3026: @163088
     /*  163088 */   GIM_Reject,
     /*  163089 */ // Label 3022: @163089
     /*  163089 */ GIM_Reject,
     /*  163090 */ // Label 2903: @163090
     /*  163090 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163327),
     /*  163095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163106 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163161), // Rule ID 45950 //
     /*  163111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163114 */     // MIs[0] rs1
     /*  163114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163122 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163159 */     GIR_RootConstrainSelectedInstOperands,
     /*  163160 */     // GIR_Coverage, 45950,
     /*  163160 */     GIR_EraseRootFromParent_Done,
     /*  163161 */   // Label 3028: @163161
     /*  163161 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163216), // Rule ID 45951 //
     /*  163166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163169 */     // MIs[0] rs1
     /*  163169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163177 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163214 */     GIR_RootConstrainSelectedInstOperands,
     /*  163215 */     // GIR_Coverage, 45951,
     /*  163215 */     GIR_EraseRootFromParent_Done,
     /*  163216 */   // Label 3029: @163216
     /*  163216 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163271), // Rule ID 46022 //
     /*  163221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163224 */     // MIs[0] rs1
     /*  163224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163232 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163269 */     GIR_RootConstrainSelectedInstOperands,
     /*  163270 */     // GIR_Coverage, 46022,
     /*  163270 */     GIR_EraseRootFromParent_Done,
     /*  163271 */   // Label 3030: @163271
     /*  163271 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163326), // Rule ID 46023 //
     /*  163276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163279 */     // MIs[0] rs1
     /*  163279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163287 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  163290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  163304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163324 */     GIR_RootConstrainSelectedInstOperands,
     /*  163325 */     // GIR_Coverage, 46023,
     /*  163325 */     GIR_EraseRootFromParent_Done,
     /*  163326 */   // Label 3031: @163326
     /*  163326 */   GIM_Reject,
     /*  163327 */ // Label 3027: @163327
     /*  163327 */ GIM_Reject,
     /*  163328 */ // Label 2904: @163328
     /*  163328 */ GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163447),
     /*  163333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163352 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163399), // Rule ID 46062 //
     /*  163357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163360 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163397 */     GIR_RootConstrainSelectedInstOperands,
     /*  163398 */     // GIR_Coverage, 46062,
     /*  163398 */     GIR_EraseRootFromParent_Done,
     /*  163399 */   // Label 3033: @163399
     /*  163399 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163446), // Rule ID 46063 //
     /*  163404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163407 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  163410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  163424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163444 */     GIR_RootConstrainSelectedInstOperands,
     /*  163445 */     // GIR_Coverage, 46063,
     /*  163445 */     GIR_EraseRootFromParent_Done,
     /*  163446 */   // Label 3034: @163446
     /*  163446 */   GIM_Reject,
     /*  163447 */ // Label 3032: @163447
     /*  163447 */ GIM_Reject,
     /*  163448 */ // Label 2905: @163448
     /*  163448 */ GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163575),
     /*  163453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163464 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163519), // Rule ID 45918 //
     /*  163469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163472 */     // MIs[0] rs1
     /*  163472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163480 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163517 */     GIR_RootConstrainSelectedInstOperands,
     /*  163518 */     // GIR_Coverage, 45918,
     /*  163518 */     GIR_EraseRootFromParent_Done,
     /*  163519 */   // Label 3036: @163519
     /*  163519 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163574), // Rule ID 45919 //
     /*  163524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163527 */     // MIs[0] rs1
     /*  163527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163535 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  163538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  163552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163572 */     GIR_RootConstrainSelectedInstOperands,
     /*  163573 */     // GIR_Coverage, 45919,
     /*  163573 */     GIR_EraseRootFromParent_Done,
     /*  163574 */   // Label 3037: @163574
     /*  163574 */   GIM_Reject,
     /*  163575 */ // Label 3035: @163575
     /*  163575 */ GIM_Reject,
     /*  163576 */ // Label 2906: @163576
     /*  163576 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163813),
     /*  163581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163592 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163647), // Rule ID 45930 //
     /*  163597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163600 */     // MIs[0] rs1
     /*  163600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163608 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163645 */     GIR_RootConstrainSelectedInstOperands,
     /*  163646 */     // GIR_Coverage, 45930,
     /*  163646 */     GIR_EraseRootFromParent_Done,
     /*  163647 */   // Label 3039: @163647
     /*  163647 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163702), // Rule ID 45931 //
     /*  163652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163655 */     // MIs[0] rs1
     /*  163655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163663 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163700 */     GIR_RootConstrainSelectedInstOperands,
     /*  163701 */     // GIR_Coverage, 45931,
     /*  163701 */     GIR_EraseRootFromParent_Done,
     /*  163702 */   // Label 3040: @163702
     /*  163702 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163757), // Rule ID 46006 //
     /*  163707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163710 */     // MIs[0] rs1
     /*  163710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163718 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163755 */     GIR_RootConstrainSelectedInstOperands,
     /*  163756 */     // GIR_Coverage, 46006,
     /*  163756 */     GIR_EraseRootFromParent_Done,
     /*  163757 */   // Label 3041: @163757
     /*  163757 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163812), // Rule ID 46007 //
     /*  163762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163765 */     // MIs[0] rs1
     /*  163765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163773 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  163776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  163790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163810 */     GIR_RootConstrainSelectedInstOperands,
     /*  163811 */     // GIR_Coverage, 46007,
     /*  163811 */     GIR_EraseRootFromParent_Done,
     /*  163812 */   // Label 3042: @163812
     /*  163812 */   GIM_Reject,
     /*  163813 */ // Label 3038: @163813
     /*  163813 */ GIM_Reject,
     /*  163814 */ // Label 2907: @163814
     /*  163814 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(164051),
     /*  163819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163830 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163885), // Rule ID 45946 //
     /*  163835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163838 */     // MIs[0] rs1
     /*  163838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163846 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163883 */     GIR_RootConstrainSelectedInstOperands,
     /*  163884 */     // GIR_Coverage, 45946,
     /*  163884 */     GIR_EraseRootFromParent_Done,
     /*  163885 */   // Label 3044: @163885
     /*  163885 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163940), // Rule ID 45947 //
     /*  163890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163893 */     // MIs[0] rs1
     /*  163893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163901 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163938 */     GIR_RootConstrainSelectedInstOperands,
     /*  163939 */     // GIR_Coverage, 45947,
     /*  163939 */     GIR_EraseRootFromParent_Done,
     /*  163940 */   // Label 3045: @163940
     /*  163940 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163995), // Rule ID 46018 //
     /*  163945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163948 */     // MIs[0] rs1
     /*  163948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163956 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163993 */     GIR_RootConstrainSelectedInstOperands,
     /*  163994 */     // GIR_Coverage, 46018,
     /*  163994 */     GIR_EraseRootFromParent_Done,
     /*  163995 */   // Label 3046: @163995
     /*  163995 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164050), // Rule ID 46019 //
     /*  164000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164003 */     // MIs[0] rs1
     /*  164003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164011 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  164014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  164028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164048 */     GIR_RootConstrainSelectedInstOperands,
     /*  164049 */     // GIR_Coverage, 46019,
     /*  164049 */     GIR_EraseRootFromParent_Done,
     /*  164050 */   // Label 3047: @164050
     /*  164050 */   GIM_Reject,
     /*  164051 */ // Label 3043: @164051
     /*  164051 */ GIM_Reject,
     /*  164052 */ // Label 2908: @164052
     /*  164052 */ GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164289),
     /*  164057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164068 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164123), // Rule ID 45990 //
     /*  164073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164076 */     // MIs[0] rs1
     /*  164076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164084 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164121 */     GIR_RootConstrainSelectedInstOperands,
     /*  164122 */     // GIR_Coverage, 45990,
     /*  164122 */     GIR_EraseRootFromParent_Done,
     /*  164123 */   // Label 3049: @164123
     /*  164123 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164178), // Rule ID 45991 //
     /*  164128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164131 */     // MIs[0] rs1
     /*  164131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164139 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164176 */     GIR_RootConstrainSelectedInstOperands,
     /*  164177 */     // GIR_Coverage, 45991,
     /*  164177 */     GIR_EraseRootFromParent_Done,
     /*  164178 */   // Label 3050: @164178
     /*  164178 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164233), // Rule ID 46050 //
     /*  164183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164186 */     // MIs[0] rs1
     /*  164186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164194 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164231 */     GIR_RootConstrainSelectedInstOperands,
     /*  164232 */     // GIR_Coverage, 46050,
     /*  164232 */     GIR_EraseRootFromParent_Done,
     /*  164233 */   // Label 3051: @164233
     /*  164233 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164288), // Rule ID 46051 //
     /*  164238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164241 */     // MIs[0] rs1
     /*  164241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164249 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  164252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  164266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164286 */     GIR_RootConstrainSelectedInstOperands,
     /*  164287 */     // GIR_Coverage, 46051,
     /*  164287 */     GIR_EraseRootFromParent_Done,
     /*  164288 */   // Label 3052: @164288
     /*  164288 */   GIM_Reject,
     /*  164289 */ // Label 3048: @164289
     /*  164289 */ GIM_Reject,
     /*  164290 */ // Label 2909: @164290
     /*  164290 */ GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164409),
     /*  164295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164314 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164361), // Rule ID 46066 //
     /*  164319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164322 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164359 */     GIR_RootConstrainSelectedInstOperands,
     /*  164360 */     // GIR_Coverage, 46066,
     /*  164360 */     GIR_EraseRootFromParent_Done,
     /*  164361 */   // Label 3054: @164361
     /*  164361 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164408), // Rule ID 46067 //
     /*  164366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164369 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  164372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  164386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164406 */     GIR_RootConstrainSelectedInstOperands,
     /*  164407 */     // GIR_Coverage, 46067,
     /*  164407 */     GIR_EraseRootFromParent_Done,
     /*  164408 */   // Label 3055: @164408
     /*  164408 */   GIM_Reject,
     /*  164409 */ // Label 3053: @164409
     /*  164409 */ GIM_Reject,
     /*  164410 */ // Label 2910: @164410
     /*  164410 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164537),
     /*  164415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164426 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164481), // Rule ID 45922 //
     /*  164431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164434 */     // MIs[0] rs1
     /*  164434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164442 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164479 */     GIR_RootConstrainSelectedInstOperands,
     /*  164480 */     // GIR_Coverage, 45922,
     /*  164480 */     GIR_EraseRootFromParent_Done,
     /*  164481 */   // Label 3057: @164481
     /*  164481 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164536), // Rule ID 45923 //
     /*  164486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164489 */     // MIs[0] rs1
     /*  164489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164497 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  164500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  164514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164534 */     GIR_RootConstrainSelectedInstOperands,
     /*  164535 */     // GIR_Coverage, 45923,
     /*  164535 */     GIR_EraseRootFromParent_Done,
     /*  164536 */   // Label 3058: @164536
     /*  164536 */   GIM_Reject,
     /*  164537 */ // Label 3056: @164537
     /*  164537 */ GIM_Reject,
     /*  164538 */ // Label 2911: @164538
     /*  164538 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164775),
     /*  164543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164554 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164609), // Rule ID 45942 //
     /*  164559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164562 */     // MIs[0] rs1
     /*  164562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164570 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164607 */     GIR_RootConstrainSelectedInstOperands,
     /*  164608 */     // GIR_Coverage, 45942,
     /*  164608 */     GIR_EraseRootFromParent_Done,
     /*  164609 */   // Label 3060: @164609
     /*  164609 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164664), // Rule ID 45943 //
     /*  164614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164617 */     // MIs[0] rs1
     /*  164617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164625 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164662 */     GIR_RootConstrainSelectedInstOperands,
     /*  164663 */     // GIR_Coverage, 45943,
     /*  164663 */     GIR_EraseRootFromParent_Done,
     /*  164664 */   // Label 3061: @164664
     /*  164664 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164719), // Rule ID 46014 //
     /*  164669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164672 */     // MIs[0] rs1
     /*  164672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164680 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164717 */     GIR_RootConstrainSelectedInstOperands,
     /*  164718 */     // GIR_Coverage, 46014,
     /*  164718 */     GIR_EraseRootFromParent_Done,
     /*  164719 */   // Label 3062: @164719
     /*  164719 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164774), // Rule ID 46015 //
     /*  164724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164727 */     // MIs[0] rs1
     /*  164727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164735 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  164738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  164752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164772 */     GIR_RootConstrainSelectedInstOperands,
     /*  164773 */     // GIR_Coverage, 46015,
     /*  164773 */     GIR_EraseRootFromParent_Done,
     /*  164774 */   // Label 3063: @164774
     /*  164774 */   GIM_Reject,
     /*  164775 */ // Label 3059: @164775
     /*  164775 */ GIM_Reject,
     /*  164776 */ // Label 2912: @164776
     /*  164776 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165013),
     /*  164781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164792 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164847), // Rule ID 45978 //
     /*  164797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164800 */     // MIs[0] rs1
     /*  164800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164808 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164845 */     GIR_RootConstrainSelectedInstOperands,
     /*  164846 */     // GIR_Coverage, 45978,
     /*  164846 */     GIR_EraseRootFromParent_Done,
     /*  164847 */   // Label 3065: @164847
     /*  164847 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164902), // Rule ID 45979 //
     /*  164852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164855 */     // MIs[0] rs1
     /*  164855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164863 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164900 */     GIR_RootConstrainSelectedInstOperands,
     /*  164901 */     // GIR_Coverage, 45979,
     /*  164901 */     GIR_EraseRootFromParent_Done,
     /*  164902 */   // Label 3066: @164902
     /*  164902 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164957), // Rule ID 46038 //
     /*  164907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164910 */     // MIs[0] rs1
     /*  164910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164918 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164955 */     GIR_RootConstrainSelectedInstOperands,
     /*  164956 */     // GIR_Coverage, 46038,
     /*  164956 */     GIR_EraseRootFromParent_Done,
     /*  164957 */   // Label 3067: @164957
     /*  164957 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165012), // Rule ID 46039 //
     /*  164962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164965 */     // MIs[0] rs1
     /*  164965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164973 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165010 */     GIR_RootConstrainSelectedInstOperands,
     /*  165011 */     // GIR_Coverage, 46039,
     /*  165011 */     GIR_EraseRootFromParent_Done,
     /*  165012 */   // Label 3068: @165012
     /*  165012 */   GIM_Reject,
     /*  165013 */ // Label 3064: @165013
     /*  165013 */ GIM_Reject,
     /*  165014 */ // Label 2913: @165014
     /*  165014 */ GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165251),
     /*  165019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165030 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(165085), // Rule ID 45994 //
     /*  165035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165038 */     // MIs[0] rs1
     /*  165038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165046 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165083 */     GIR_RootConstrainSelectedInstOperands,
     /*  165084 */     // GIR_Coverage, 45994,
     /*  165084 */     GIR_EraseRootFromParent_Done,
     /*  165085 */   // Label 3070: @165085
     /*  165085 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(165140), // Rule ID 45995 //
     /*  165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165093 */     // MIs[0] rs1
     /*  165093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165101 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165138 */     GIR_RootConstrainSelectedInstOperands,
     /*  165139 */     // GIR_Coverage, 45995,
     /*  165139 */     GIR_EraseRootFromParent_Done,
     /*  165140 */   // Label 3071: @165140
     /*  165140 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165195), // Rule ID 46054 //
     /*  165145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165148 */     // MIs[0] rs1
     /*  165148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165156 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165193 */     GIR_RootConstrainSelectedInstOperands,
     /*  165194 */     // GIR_Coverage, 46054,
     /*  165194 */     GIR_EraseRootFromParent_Done,
     /*  165195 */   // Label 3072: @165195
     /*  165195 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165250), // Rule ID 46055 //
     /*  165200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165203 */     // MIs[0] rs1
     /*  165203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165211 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  165214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  165228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165248 */     GIR_RootConstrainSelectedInstOperands,
     /*  165249 */     // GIR_Coverage, 46055,
     /*  165249 */     GIR_EraseRootFromParent_Done,
     /*  165250 */   // Label 3073: @165250
     /*  165250 */   GIM_Reject,
     /*  165251 */ // Label 3069: @165251
     /*  165251 */ GIM_Reject,
     /*  165252 */ // Label 2914: @165252
     /*  165252 */ GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165371),
     /*  165257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165276 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165323), // Rule ID 46070 //
     /*  165281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165284 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  165287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  165301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165321 */     GIR_RootConstrainSelectedInstOperands,
     /*  165322 */     // GIR_Coverage, 46070,
     /*  165322 */     GIR_EraseRootFromParent_Done,
     /*  165323 */   // Label 3075: @165323
     /*  165323 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165370), // Rule ID 46071 //
     /*  165328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165331 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  165334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  165348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165368 */     GIR_RootConstrainSelectedInstOperands,
     /*  165369 */     // GIR_Coverage, 46071,
     /*  165369 */     GIR_EraseRootFromParent_Done,
     /*  165370 */   // Label 3076: @165370
     /*  165370 */   GIM_Reject,
     /*  165371 */ // Label 3074: @165371
     /*  165371 */ GIM_Reject,
     /*  165372 */ // Label 2915: @165372
     /*  165372 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165499),
     /*  165377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165388 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165443), // Rule ID 45938 //
     /*  165393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165396 */     // MIs[0] rs1
     /*  165396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165404 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165441 */     GIR_RootConstrainSelectedInstOperands,
     /*  165442 */     // GIR_Coverage, 45938,
     /*  165442 */     GIR_EraseRootFromParent_Done,
     /*  165443 */   // Label 3078: @165443
     /*  165443 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165498), // Rule ID 45939 //
     /*  165448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165451 */     // MIs[0] rs1
     /*  165451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165459 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  165462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  165476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165496 */     GIR_RootConstrainSelectedInstOperands,
     /*  165497 */     // GIR_Coverage, 45939,
     /*  165497 */     GIR_EraseRootFromParent_Done,
     /*  165498 */   // Label 3079: @165498
     /*  165498 */   GIM_Reject,
     /*  165499 */ // Label 3077: @165499
     /*  165499 */ GIM_Reject,
     /*  165500 */ // Label 2916: @165500
     /*  165500 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165737),
     /*  165505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165516 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165571), // Rule ID 45966 //
     /*  165521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165524 */     // MIs[0] rs1
     /*  165524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165532 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165569 */     GIR_RootConstrainSelectedInstOperands,
     /*  165570 */     // GIR_Coverage, 45966,
     /*  165570 */     GIR_EraseRootFromParent_Done,
     /*  165571 */   // Label 3081: @165571
     /*  165571 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165626), // Rule ID 45967 //
     /*  165576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165579 */     // MIs[0] rs1
     /*  165579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165587 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165624 */     GIR_RootConstrainSelectedInstOperands,
     /*  165625 */     // GIR_Coverage, 45967,
     /*  165625 */     GIR_EraseRootFromParent_Done,
     /*  165626 */   // Label 3082: @165626
     /*  165626 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165681), // Rule ID 46026 //
     /*  165631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165634 */     // MIs[0] rs1
     /*  165634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165642 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165679 */     GIR_RootConstrainSelectedInstOperands,
     /*  165680 */     // GIR_Coverage, 46026,
     /*  165680 */     GIR_EraseRootFromParent_Done,
     /*  165681 */   // Label 3083: @165681
     /*  165681 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165736), // Rule ID 46027 //
     /*  165686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165689 */     // MIs[0] rs1
     /*  165689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165697 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  165700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  165714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165734 */     GIR_RootConstrainSelectedInstOperands,
     /*  165735 */     // GIR_Coverage, 46027,
     /*  165735 */     GIR_EraseRootFromParent_Done,
     /*  165736 */   // Label 3084: @165736
     /*  165736 */   GIM_Reject,
     /*  165737 */ // Label 3080: @165737
     /*  165737 */ GIM_Reject,
     /*  165738 */ // Label 2917: @165738
     /*  165738 */ GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165975),
     /*  165743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165754 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165809), // Rule ID 45982 //
     /*  165759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165762 */     // MIs[0] rs1
     /*  165762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165770 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165807 */     GIR_RootConstrainSelectedInstOperands,
     /*  165808 */     // GIR_Coverage, 45982,
     /*  165808 */     GIR_EraseRootFromParent_Done,
     /*  165809 */   // Label 3086: @165809
     /*  165809 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165864), // Rule ID 45983 //
     /*  165814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165817 */     // MIs[0] rs1
     /*  165817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165825 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165862 */     GIR_RootConstrainSelectedInstOperands,
     /*  165863 */     // GIR_Coverage, 45983,
     /*  165863 */     GIR_EraseRootFromParent_Done,
     /*  165864 */   // Label 3087: @165864
     /*  165864 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165919), // Rule ID 46042 //
     /*  165869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165872 */     // MIs[0] rs1
     /*  165872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165880 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165917 */     GIR_RootConstrainSelectedInstOperands,
     /*  165918 */     // GIR_Coverage, 46042,
     /*  165918 */     GIR_EraseRootFromParent_Done,
     /*  165919 */   // Label 3088: @165919
     /*  165919 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165974), // Rule ID 46043 //
     /*  165924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165927 */     // MIs[0] rs1
     /*  165927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165935 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165972 */     GIR_RootConstrainSelectedInstOperands,
     /*  165973 */     // GIR_Coverage, 46043,
     /*  165973 */     GIR_EraseRootFromParent_Done,
     /*  165974 */   // Label 3089: @165974
     /*  165974 */   GIM_Reject,
     /*  165975 */ // Label 3085: @165975
     /*  165975 */ GIM_Reject,
     /*  165976 */ // Label 2918: @165976
     /*  165976 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166213),
     /*  165981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165992 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166047), // Rule ID 45998 //
     /*  165997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  166000 */     // MIs[0] rs1
     /*  166000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166008 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  166008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166045 */     GIR_RootConstrainSelectedInstOperands,
     /*  166046 */     // GIR_Coverage, 45998,
     /*  166046 */     GIR_EraseRootFromParent_Done,
     /*  166047 */   // Label 3091: @166047
     /*  166047 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166102), // Rule ID 45999 //
     /*  166052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  166055 */     // MIs[0] rs1
     /*  166055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166063 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  166063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166100 */     GIR_RootConstrainSelectedInstOperands,
     /*  166101 */     // GIR_Coverage, 45999,
     /*  166101 */     GIR_EraseRootFromParent_Done,
     /*  166102 */   // Label 3092: @166102
     /*  166102 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166157), // Rule ID 46058 //
     /*  166107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  166110 */     // MIs[0] rs1
     /*  166110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166118 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  166118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166155 */     GIR_RootConstrainSelectedInstOperands,
     /*  166156 */     // GIR_Coverage, 46058,
     /*  166156 */     GIR_EraseRootFromParent_Done,
     /*  166157 */   // Label 3093: @166157
     /*  166157 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166212), // Rule ID 46059 //
     /*  166162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  166165 */     // MIs[0] rs1
     /*  166165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166173 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  166173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  166176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  166190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  166203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166210 */     GIR_RootConstrainSelectedInstOperands,
     /*  166211 */     // GIR_Coverage, 46059,
     /*  166211 */     GIR_EraseRootFromParent_Done,
     /*  166212 */   // Label 3094: @166212
     /*  166212 */   GIM_Reject,
     /*  166213 */ // Label 3090: @166213
     /*  166213 */ GIM_Reject,
     /*  166214 */ // Label 2919: @166214
     /*  166214 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166333),
     /*  166219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166238 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166285), // Rule ID 46074 //
     /*  166243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166246 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  166249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  166263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166283 */     GIR_RootConstrainSelectedInstOperands,
     /*  166284 */     // GIR_Coverage, 46074,
     /*  166284 */     GIR_EraseRootFromParent_Done,
     /*  166285 */   // Label 3096: @166285
     /*  166285 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166332), // Rule ID 46075 //
     /*  166290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166293 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  166296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  166310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166330 */     GIR_RootConstrainSelectedInstOperands,
     /*  166331 */     // GIR_Coverage, 46075,
     /*  166331 */     GIR_EraseRootFromParent_Done,
     /*  166332 */   // Label 3097: @166332
     /*  166332 */   GIM_Reject,
     /*  166333 */ // Label 3095: @166333
     /*  166333 */ GIM_Reject,
     /*  166334 */ // Label 2920: @166334
     /*  166334 */ GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(166461),
     /*  166339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  166350 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(166405), // Rule ID 45954 //
     /*  166355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166358 */     // MIs[0] rs1
     /*  166358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166366 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166403 */     GIR_RootConstrainSelectedInstOperands,
     /*  166404 */     // GIR_Coverage, 45954,
     /*  166404 */     GIR_EraseRootFromParent_Done,
     /*  166405 */   // Label 3099: @166405
     /*  166405 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166460), // Rule ID 45955 //
     /*  166410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166413 */     // MIs[0] rs1
     /*  166413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166421 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  166424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  166438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166458 */     GIR_RootConstrainSelectedInstOperands,
     /*  166459 */     // GIR_Coverage, 45955,
     /*  166459 */     GIR_EraseRootFromParent_Done,
     /*  166460 */   // Label 3100: @166460
     /*  166460 */   GIM_Reject,
     /*  166461 */ // Label 3098: @166461
     /*  166461 */ GIM_Reject,
     /*  166462 */ // Label 2921: @166462
     /*  166462 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166699),
     /*  166467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166478 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166533), // Rule ID 45970 //
     /*  166483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166486 */     // MIs[0] rs1
     /*  166486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166494 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166531 */     GIR_RootConstrainSelectedInstOperands,
     /*  166532 */     // GIR_Coverage, 45970,
     /*  166532 */     GIR_EraseRootFromParent_Done,
     /*  166533 */   // Label 3102: @166533
     /*  166533 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166588), // Rule ID 45971 //
     /*  166538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166541 */     // MIs[0] rs1
     /*  166541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166549 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166586 */     GIR_RootConstrainSelectedInstOperands,
     /*  166587 */     // GIR_Coverage, 45971,
     /*  166587 */     GIR_EraseRootFromParent_Done,
     /*  166588 */   // Label 3103: @166588
     /*  166588 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166643), // Rule ID 46030 //
     /*  166593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166596 */     // MIs[0] rs1
     /*  166596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166604 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166641 */     GIR_RootConstrainSelectedInstOperands,
     /*  166642 */     // GIR_Coverage, 46030,
     /*  166642 */     GIR_EraseRootFromParent_Done,
     /*  166643 */   // Label 3104: @166643
     /*  166643 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166698), // Rule ID 46031 //
     /*  166648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166651 */     // MIs[0] rs1
     /*  166651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166659 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  166662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166696 */     GIR_RootConstrainSelectedInstOperands,
     /*  166697 */     // GIR_Coverage, 46031,
     /*  166697 */     GIR_EraseRootFromParent_Done,
     /*  166698 */   // Label 3105: @166698
     /*  166698 */   GIM_Reject,
     /*  166699 */ // Label 3101: @166699
     /*  166699 */ GIM_Reject,
     /*  166700 */ // Label 2922: @166700
     /*  166700 */ GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166937),
     /*  166705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166708 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166716 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166771), // Rule ID 45986 //
     /*  166721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166724 */     // MIs[0] rs1
     /*  166724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166732 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166769 */     GIR_RootConstrainSelectedInstOperands,
     /*  166770 */     // GIR_Coverage, 45986,
     /*  166770 */     GIR_EraseRootFromParent_Done,
     /*  166771 */   // Label 3107: @166771
     /*  166771 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166826), // Rule ID 45987 //
     /*  166776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166779 */     // MIs[0] rs1
     /*  166779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166787 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166824 */     GIR_RootConstrainSelectedInstOperands,
     /*  166825 */     // GIR_Coverage, 45987,
     /*  166825 */     GIR_EraseRootFromParent_Done,
     /*  166826 */   // Label 3108: @166826
     /*  166826 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166881), // Rule ID 46046 //
     /*  166831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166834 */     // MIs[0] rs1
     /*  166834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166842 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166879 */     GIR_RootConstrainSelectedInstOperands,
     /*  166880 */     // GIR_Coverage, 46046,
     /*  166880 */     GIR_EraseRootFromParent_Done,
     /*  166881 */   // Label 3109: @166881
     /*  166881 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166936), // Rule ID 46047 //
     /*  166886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166889 */     // MIs[0] rs1
     /*  166889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166897 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166934 */     GIR_RootConstrainSelectedInstOperands,
     /*  166935 */     // GIR_Coverage, 46047,
     /*  166935 */     GIR_EraseRootFromParent_Done,
     /*  166936 */   // Label 3110: @166936
     /*  166936 */   GIM_Reject,
     /*  166937 */ // Label 3106: @166937
     /*  166937 */ GIM_Reject,
     /*  166938 */ // Label 2923: @166938
     /*  166938 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167057),
     /*  166943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166962 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167009), // Rule ID 46078 //
     /*  166967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166970 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167007 */     GIR_RootConstrainSelectedInstOperands,
     /*  167008 */     // GIR_Coverage, 46078,
     /*  167008 */     GIR_EraseRootFromParent_Done,
     /*  167009 */   // Label 3112: @167009
     /*  167009 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167056), // Rule ID 46079 //
     /*  167014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167017 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  167020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  167034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167054 */     GIR_RootConstrainSelectedInstOperands,
     /*  167055 */     // GIR_Coverage, 46079,
     /*  167055 */     GIR_EraseRootFromParent_Done,
     /*  167056 */   // Label 3113: @167056
     /*  167056 */   GIM_Reject,
     /*  167057 */ // Label 3111: @167057
     /*  167057 */ GIM_Reject,
     /*  167058 */ // Label 2924: @167058
     /*  167058 */ GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167185),
     /*  167063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  167074 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167129), // Rule ID 45958 //
     /*  167079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167082 */     // MIs[0] rs1
     /*  167082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167090 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  167093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  167107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167127 */     GIR_RootConstrainSelectedInstOperands,
     /*  167128 */     // GIR_Coverage, 45958,
     /*  167128 */     GIR_EraseRootFromParent_Done,
     /*  167129 */   // Label 3115: @167129
     /*  167129 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167184), // Rule ID 45959 //
     /*  167134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167137 */     // MIs[0] rs1
     /*  167137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167145 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  167148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  167162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167182 */     GIR_RootConstrainSelectedInstOperands,
     /*  167183 */     // GIR_Coverage, 45959,
     /*  167183 */     GIR_EraseRootFromParent_Done,
     /*  167184 */   // Label 3116: @167184
     /*  167184 */   GIM_Reject,
     /*  167185 */ // Label 3114: @167185
     /*  167185 */ GIM_Reject,
     /*  167186 */ // Label 2925: @167186
     /*  167186 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167423),
     /*  167191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167194 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167202 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167257), // Rule ID 45974 //
     /*  167207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167210 */     // MIs[0] rs1
     /*  167210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167218 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  167218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167255 */     GIR_RootConstrainSelectedInstOperands,
     /*  167256 */     // GIR_Coverage, 45974,
     /*  167256 */     GIR_EraseRootFromParent_Done,
     /*  167257 */   // Label 3118: @167257
     /*  167257 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167312), // Rule ID 45975 //
     /*  167262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167265 */     // MIs[0] rs1
     /*  167265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167273 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167310 */     GIR_RootConstrainSelectedInstOperands,
     /*  167311 */     // GIR_Coverage, 45975,
     /*  167311 */     GIR_EraseRootFromParent_Done,
     /*  167312 */   // Label 3119: @167312
     /*  167312 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167367), // Rule ID 46034 //
     /*  167317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  167320 */     // MIs[0] rs1
     /*  167320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167328 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  167328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167365 */     GIR_RootConstrainSelectedInstOperands,
     /*  167366 */     // GIR_Coverage, 46034,
     /*  167366 */     GIR_EraseRootFromParent_Done,
     /*  167367 */   // Label 3120: @167367
     /*  167367 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167422), // Rule ID 46035 //
     /*  167372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  167375 */     // MIs[0] rs1
     /*  167375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167383 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  167383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  167386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  167400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  167413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167420 */     GIR_RootConstrainSelectedInstOperands,
     /*  167421 */     // GIR_Coverage, 46035,
     /*  167421 */     GIR_EraseRootFromParent_Done,
     /*  167422 */   // Label 3121: @167422
     /*  167422 */   GIM_Reject,
     /*  167423 */ // Label 3117: @167423
     /*  167423 */ GIM_Reject,
     /*  167424 */ // Label 2926: @167424
     /*  167424 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167543),
     /*  167429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  167440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167448 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167495), // Rule ID 46082 //
     /*  167453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167456 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  167456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167493 */     GIR_RootConstrainSelectedInstOperands,
     /*  167494 */     // GIR_Coverage, 46082,
     /*  167494 */     GIR_EraseRootFromParent_Done,
     /*  167495 */   // Label 3123: @167495
     /*  167495 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167542), // Rule ID 46083 //
     /*  167500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167503 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  167503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  167506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  167520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  167533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167540 */     GIR_RootConstrainSelectedInstOperands,
     /*  167541 */     // GIR_Coverage, 46083,
     /*  167541 */     GIR_EraseRootFromParent_Done,
     /*  167542 */   // Label 3124: @167542
     /*  167542 */   GIM_Reject,
     /*  167543 */ // Label 3122: @167543
     /*  167543 */ GIM_Reject,
     /*  167544 */ // Label 2927: @167544
     /*  167544 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(167671),
     /*  167549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  167560 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(167615), // Rule ID 45962 //
     /*  167565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  167568 */     // MIs[0] rs1
     /*  167568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167576 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  167576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167613 */     GIR_RootConstrainSelectedInstOperands,
     /*  167614 */     // GIR_Coverage, 45962,
     /*  167614 */     GIR_EraseRootFromParent_Done,
     /*  167615 */   // Label 3126: @167615
     /*  167615 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167670), // Rule ID 45963 //
     /*  167620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  167623 */     // MIs[0] rs1
     /*  167623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167631 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  167631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  167634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  167638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  167643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  167645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  167648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  167653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  167655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  167658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  167664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167668 */     GIR_RootConstrainSelectedInstOperands,
     /*  167669 */     // GIR_Coverage, 45963,
     /*  167669 */     GIR_EraseRootFromParent_Done,
     /*  167670 */   // Label 3127: @167670
     /*  167670 */   GIM_Reject,
     /*  167671 */ // Label 3125: @167671
     /*  167671 */ GIM_Reject,
     /*  167672 */ // Label 2928: @167672
     /*  167672 */ GIM_Reject,
     /*  167673 */ // Label 22: @167673
     /*  167673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3130*/ GIMT_Encode4(169642),
     /*  167684 */ /*GILLT_s32*//*Label 3128*/ GIMT_Encode4(167692),
     /*  167688 */ /*GILLT_s64*//*Label 3129*/ GIMT_Encode4(169068),
     /*  167692 */ // Label 3128: @167692
     /*  167692 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167799), // Rule ID 74113 //
     /*  167697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  167700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167703 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167714 */   // MIs[0] Operand 1
     /*  167714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167726 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167730 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167734 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167738 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167742 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167746 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  167750 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167755 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167759 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167763 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167767 */   // MIs[3] Operand 1
     /*  167767 */   // No operand predicates
     /*  167767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167772 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167774 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  167774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  167777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167779 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  167787 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  167790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  167797 */   GIR_RootConstrainSelectedInstOperands,
     /*  167798 */   // GIR_Coverage, 74113,
     /*  167798 */   GIR_EraseRootFromParent_Done,
     /*  167799 */ // Label 3131: @167799
     /*  167799 */ GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167906), // Rule ID 74114 //
     /*  167804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  167807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167821 */   // MIs[0] Operand 1
     /*  167821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167833 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167841 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167845 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167849 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167853 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  167857 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167862 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167866 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167870 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167874 */   // MIs[3] Operand 1
     /*  167874 */   // No operand predicates
     /*  167874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167879 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167881 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  167881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  167884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  167894 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  167897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  167904 */   GIR_RootConstrainSelectedInstOperands,
     /*  167905 */   // GIR_Coverage, 74114,
     /*  167905 */   GIR_EraseRootFromParent_Done,
     /*  167906 */ // Label 3132: @167906
     /*  167906 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168013), // Rule ID 74117 //
     /*  167911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  167914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167928 */   // MIs[0] Operand 1
     /*  167928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167944 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167948 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167956 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167960 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  167964 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167969 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167973 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167977 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167981 */   // MIs[3] Operand 1
     /*  167981 */   // No operand predicates
     /*  167981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167986 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167988 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  167988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  167991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168001 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168011 */   GIR_RootConstrainSelectedInstOperands,
     /*  168012 */   // GIR_Coverage, 74117,
     /*  168012 */   GIR_EraseRootFromParent_Done,
     /*  168013 */ // Label 3133: @168013
     /*  168013 */ GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168120), // Rule ID 74118 //
     /*  168018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168035 */   // MIs[0] Operand 1
     /*  168035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168051 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168055 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168059 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168063 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168067 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168071 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168076 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168080 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168084 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168088 */   // MIs[3] Operand 1
     /*  168088 */   // No operand predicates
     /*  168088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168093 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168095 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168100 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168104 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168108 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168118 */   GIR_RootConstrainSelectedInstOperands,
     /*  168119 */   // GIR_Coverage, 74118,
     /*  168119 */   GIR_EraseRootFromParent_Done,
     /*  168120 */ // Label 3134: @168120
     /*  168120 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168227), // Rule ID 64546 //
     /*  168125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168128 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168142 */   // MIs[0] Operand 1
     /*  168142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168167 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168171 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168175 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168179 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168183 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168188 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168192 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168196 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168200 */   // MIs[3] Operand 1
     /*  168200 */   // No operand predicates
     /*  168200 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168202 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  168205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168211 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168215 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168225 */   GIR_RootConstrainSelectedInstOperands,
     /*  168226 */   // GIR_Coverage, 64546,
     /*  168226 */   GIR_EraseRootFromParent_Done,
     /*  168227 */ // Label 3135: @168227
     /*  168227 */ GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168334), // Rule ID 64547 //
     /*  168232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168249 */   // MIs[0] Operand 1
     /*  168249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168274 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168278 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168282 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168286 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168290 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168295 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168299 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168303 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168307 */   // MIs[3] Operand 1
     /*  168307 */   // No operand predicates
     /*  168307 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168309 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  168312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168322 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168332 */   GIR_RootConstrainSelectedInstOperands,
     /*  168333 */   // GIR_Coverage, 64547,
     /*  168333 */   GIR_EraseRootFromParent_Done,
     /*  168334 */ // Label 3136: @168334
     /*  168334 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168441), // Rule ID 64550 //
     /*  168339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168356 */   // MIs[0] Operand 1
     /*  168356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168368 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168372 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168381 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168385 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168389 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168393 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168397 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168402 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168406 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168410 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168414 */   // MIs[3] Operand 1
     /*  168414 */   // No operand predicates
     /*  168414 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168416 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168421 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168439 */   GIR_RootConstrainSelectedInstOperands,
     /*  168440 */   // GIR_Coverage, 64550,
     /*  168440 */   GIR_EraseRootFromParent_Done,
     /*  168441 */ // Label 3137: @168441
     /*  168441 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168548), // Rule ID 64551 //
     /*  168446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168463 */   // MIs[0] Operand 1
     /*  168463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168488 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168492 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168496 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168500 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168504 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168509 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168513 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168517 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168521 */   // MIs[3] Operand 1
     /*  168521 */   // No operand predicates
     /*  168521 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168523 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  168526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168528 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168532 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168536 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168546 */   GIR_RootConstrainSelectedInstOperands,
     /*  168547 */   // GIR_Coverage, 64551,
     /*  168547 */   GIR_EraseRootFromParent_Done,
     /*  168548 */ // Label 3138: @168548
     /*  168548 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168602), // Rule ID 225 //
     /*  168553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168581 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168600 */   GIR_RootConstrainSelectedInstOperands,
     /*  168601 */   // GIR_Coverage, 225,
     /*  168601 */   GIR_EraseRootFromParent_Done,
     /*  168602 */ // Label 3139: @168602
     /*  168602 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168656), // Rule ID 229 //
     /*  168607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168635 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168654 */   GIR_RootConstrainSelectedInstOperands,
     /*  168655 */   // GIR_Coverage, 229,
     /*  168655 */   GIR_EraseRootFromParent_Done,
     /*  168656 */ // Label 3140: @168656
     /*  168656 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168713), // Rule ID 316 //
     /*  168661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168692 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10095>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  168695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168711 */   GIR_RootConstrainSelectedInstOperands,
     /*  168712 */   // GIR_Coverage, 316,
     /*  168712 */   GIR_EraseRootFromParent_Done,
     /*  168713 */ // Label 3141: @168713
     /*  168713 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168770), // Rule ID 320 //
     /*  168718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168731 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168749 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10097>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  168752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168768 */   GIR_RootConstrainSelectedInstOperands,
     /*  168769 */   // GIR_Coverage, 320,
     /*  168769 */   GIR_EraseRootFromParent_Done,
     /*  168770 */ // Label 3142: @168770
     /*  168770 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168827), // Rule ID 336 //
     /*  168775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168806 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10111>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  168809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168825 */   GIR_RootConstrainSelectedInstOperands,
     /*  168826 */   // GIR_Coverage, 336,
     /*  168826 */   GIR_EraseRootFromParent_Done,
     /*  168827 */ // Label 3143: @168827
     /*  168827 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168867), // Rule ID 1092 //
     /*  168832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168852 */   // MIs[0] rs1
     /*  168852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168860 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10599>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168865 */   GIR_RootConstrainSelectedInstOperands,
     /*  168866 */   // GIR_Coverage, 1092,
     /*  168866 */   GIR_Done,
     /*  168867 */ // Label 3144: @168867
     /*  168867 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168907), // Rule ID 1096 //
     /*  168872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168875 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168878 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168892 */   // MIs[0] rs1
     /*  168892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168900 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10601>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  168905 */   GIR_RootConstrainSelectedInstOperands,
     /*  168906 */   // GIR_Coverage, 1096,
     /*  168906 */   GIR_Done,
     /*  168907 */ // Label 3145: @168907
     /*  168907 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168947), // Rule ID 1100 //
     /*  168912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168932 */   // MIs[0] rs1
     /*  168932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168940 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10603>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168945 */   GIR_RootConstrainSelectedInstOperands,
     /*  168946 */   // GIR_Coverage, 1100,
     /*  168946 */   GIR_Done,
     /*  168947 */ // Label 3146: @168947
     /*  168947 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168987), // Rule ID 1104 //
     /*  168952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  168955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  168968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168972 */   // MIs[0] rs1
     /*  168972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168980 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10605>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  168980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  168985 */   GIR_RootConstrainSelectedInstOperands,
     /*  168986 */   // GIR_Coverage, 1104,
     /*  168986 */   GIR_Done,
     /*  168987 */ // Label 3147: @168987
     /*  168987 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(169027), // Rule ID 1124 //
     /*  168992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  168995 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169012 */   // MIs[0] rs1
     /*  169012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169020 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10623>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  169020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169025 */   GIR_RootConstrainSelectedInstOperands,
     /*  169026 */   // GIR_Coverage, 1124,
     /*  169026 */   GIR_Done,
     /*  169027 */ // Label 3148: @169027
     /*  169027 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(169067), // Rule ID 1128 //
     /*  169032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  169035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169052 */   // MIs[0] rs1
     /*  169052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169060 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10625>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  169060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169065 */   GIR_RootConstrainSelectedInstOperands,
     /*  169066 */   // GIR_Coverage, 1128,
     /*  169066 */   GIR_Done,
     /*  169067 */ // Label 3149: @169067
     /*  169067 */ GIM_Reject,
     /*  169068 */ // Label 3129: @169068
     /*  169068 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(169122), // Rule ID 224 //
     /*  169073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169101 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  169104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169120 */   GIR_RootConstrainSelectedInstOperands,
     /*  169121 */   // GIR_Coverage, 224,
     /*  169121 */   GIR_EraseRootFromParent_Done,
     /*  169122 */ // Label 3150: @169122
     /*  169122 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(169176), // Rule ID 228 //
     /*  169127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169155 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  169158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169174 */   GIR_RootConstrainSelectedInstOperands,
     /*  169175 */   // GIR_Coverage, 228,
     /*  169175 */   GIR_EraseRootFromParent_Done,
     /*  169176 */ // Label 3151: @169176
     /*  169176 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(169230), // Rule ID 275 //
     /*  169181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169184 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169202 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169209 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  169212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169228 */   GIR_RootConstrainSelectedInstOperands,
     /*  169229 */   // GIR_Coverage, 275,
     /*  169229 */   GIR_EraseRootFromParent_Done,
     /*  169230 */ // Label 3152: @169230
     /*  169230 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(169287), // Rule ID 315 //
     /*  169235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169238 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169248 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169266 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10095>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  169269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169285 */   GIR_RootConstrainSelectedInstOperands,
     /*  169286 */   // GIR_Coverage, 315,
     /*  169286 */   GIR_EraseRootFromParent_Done,
     /*  169287 */ // Label 3153: @169287
     /*  169287 */ GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(169344), // Rule ID 319 //
     /*  169292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169305 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169323 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10097>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  169326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169342 */   GIR_RootConstrainSelectedInstOperands,
     /*  169343 */   // GIR_Coverage, 319,
     /*  169343 */   GIR_EraseRootFromParent_Done,
     /*  169344 */ // Label 3154: @169344
     /*  169344 */ GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(169401), // Rule ID 335 //
     /*  169349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169352 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169362 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169380 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10111>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  169383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169399 */   GIR_RootConstrainSelectedInstOperands,
     /*  169400 */   // GIR_Coverage, 335,
     /*  169400 */   GIR_EraseRootFromParent_Done,
     /*  169401 */ // Label 3155: @169401
     /*  169401 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169441), // Rule ID 1091 //
     /*  169406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169426 */   // MIs[0] rs1
     /*  169426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169434 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10599>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  169439 */   GIR_RootConstrainSelectedInstOperands,
     /*  169440 */   // GIR_Coverage, 1091,
     /*  169440 */   GIR_Done,
     /*  169441 */ // Label 3156: @169441
     /*  169441 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169481), // Rule ID 1095 //
     /*  169446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169466 */   // MIs[0] rs1
     /*  169466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169474 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10601>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  169479 */   GIR_RootConstrainSelectedInstOperands,
     /*  169480 */   // GIR_Coverage, 1095,
     /*  169480 */   GIR_Done,
     /*  169481 */ // Label 3157: @169481
     /*  169481 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169521), // Rule ID 1099 //
     /*  169486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169506 */   // MIs[0] rs1
     /*  169506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169514 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10603>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  169519 */   GIR_RootConstrainSelectedInstOperands,
     /*  169520 */   // GIR_Coverage, 1099,
     /*  169520 */   GIR_Done,
     /*  169521 */ // Label 3158: @169521
     /*  169521 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169561), // Rule ID 1103 //
     /*  169526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  169529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169532 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169546 */   // MIs[0] rs1
     /*  169546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169554 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10605>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  169559 */   GIR_RootConstrainSelectedInstOperands,
     /*  169560 */   // GIR_Coverage, 1103,
     /*  169560 */   GIR_Done,
     /*  169561 */ // Label 3159: @169561
     /*  169561 */ GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169601), // Rule ID 1123 //
     /*  169566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  169569 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169572 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  169582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169586 */   // MIs[0] rs1
     /*  169586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169594 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10623>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169599 */   GIR_RootConstrainSelectedInstOperands,
     /*  169600 */   // GIR_Coverage, 1123,
     /*  169600 */   GIR_Done,
     /*  169601 */ // Label 3160: @169601
     /*  169601 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169641), // Rule ID 1127 //
     /*  169606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  169609 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  169622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169626 */   // MIs[0] rs1
     /*  169626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  169630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169634 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10625>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  169634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  169639 */   GIR_RootConstrainSelectedInstOperands,
     /*  169640 */   // GIR_Coverage, 1127,
     /*  169640 */   GIR_Done,
     /*  169641 */ // Label 3161: @169641
     /*  169641 */ GIM_Reject,
     /*  169642 */ // Label 3130: @169642
     /*  169642 */ GIM_Reject,
     /*  169643 */ // Label 23: @169643
     /*  169643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3164*/ GIMT_Encode4(171132),
     /*  169654 */ /*GILLT_s32*//*Label 3162*/ GIMT_Encode4(169662),
     /*  169658 */ /*GILLT_s64*//*Label 3163*/ GIMT_Encode4(170798),
     /*  169662 */ // Label 3162: @169662
     /*  169662 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169769), // Rule ID 74123 //
     /*  169667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  169670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169684 */   // MIs[0] Operand 1
     /*  169684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169704 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169708 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169712 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169716 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  169720 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169725 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169729 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169733 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169737 */   // MIs[3] Operand 1
     /*  169737 */   // No operand predicates
     /*  169737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169742 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169744 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  169744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  169747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169757 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169767 */   GIR_RootConstrainSelectedInstOperands,
     /*  169768 */   // GIR_Coverage, 74123,
     /*  169768 */   GIR_EraseRootFromParent_Done,
     /*  169769 */ // Label 3165: @169769
     /*  169769 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169876), // Rule ID 74124 //
     /*  169774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  169777 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169791 */   // MIs[0] Operand 1
     /*  169791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169803 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169807 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169811 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169815 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169819 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169823 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  169827 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169832 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169836 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169840 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169844 */   // MIs[3] Operand 1
     /*  169844 */   // No operand predicates
     /*  169844 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169849 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169851 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  169851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  169854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169856 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169860 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169864 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169874 */   GIR_RootConstrainSelectedInstOperands,
     /*  169875 */   // GIR_Coverage, 74124,
     /*  169875 */   GIR_EraseRootFromParent_Done,
     /*  169876 */ // Label 3166: @169876
     /*  169876 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169983), // Rule ID 74125 //
     /*  169881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  169884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169898 */   // MIs[0] Operand 1
     /*  169898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169918 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  169922 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169926 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169930 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  169934 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169939 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169943 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169947 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169951 */   // MIs[3] Operand 1
     /*  169951 */   // No operand predicates
     /*  169951 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169956 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169958 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  169958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  169961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  169963 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  169967 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169981 */   GIR_RootConstrainSelectedInstOperands,
     /*  169982 */   // GIR_Coverage, 74125,
     /*  169982 */   GIR_EraseRootFromParent_Done,
     /*  169983 */ // Label 3167: @169983
     /*  169983 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(170090), // Rule ID 74126 //
     /*  169988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  169991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170005 */   // MIs[0] Operand 1
     /*  170005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170025 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  170029 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170033 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170037 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170041 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170046 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170050 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170054 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170058 */   // MIs[3] Operand 1
     /*  170058 */   // No operand predicates
     /*  170058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170063 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170065 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170070 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  170074 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170078 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170088 */   GIR_RootConstrainSelectedInstOperands,
     /*  170089 */   // GIR_Coverage, 74126,
     /*  170089 */   GIR_EraseRootFromParent_Done,
     /*  170090 */ // Label 3168: @170090
     /*  170090 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(170197), // Rule ID 64556 //
     /*  170095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  170098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170112 */   // MIs[0] Operand 1
     /*  170112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170124 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170137 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170141 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170145 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170149 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  170153 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170158 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170162 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170166 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170170 */   // MIs[3] Operand 1
     /*  170170 */   // No operand predicates
     /*  170170 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170172 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  170172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  170175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170181 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170185 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170195 */   GIR_RootConstrainSelectedInstOperands,
     /*  170196 */   // GIR_Coverage, 64556,
     /*  170196 */   GIR_EraseRootFromParent_Done,
     /*  170197 */ // Label 3169: @170197
     /*  170197 */ GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(170304), // Rule ID 64557 //
     /*  170202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  170205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170208 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170219 */   // MIs[0] Operand 1
     /*  170219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170252 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170256 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170260 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170265 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170269 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170273 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170277 */   // MIs[3] Operand 1
     /*  170277 */   // No operand predicates
     /*  170277 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170279 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  170282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170284 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170292 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170302 */   GIR_RootConstrainSelectedInstOperands,
     /*  170303 */   // GIR_Coverage, 64557,
     /*  170303 */   GIR_EraseRootFromParent_Done,
     /*  170304 */ // Label 3170: @170304
     /*  170304 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(170411), // Rule ID 64558 //
     /*  170309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  170312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170326 */   // MIs[0] Operand 1
     /*  170326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170359 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170363 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  170367 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170372 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170376 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170380 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170384 */   // MIs[3] Operand 1
     /*  170384 */   // No operand predicates
     /*  170384 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170386 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  170386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170409 */   GIR_RootConstrainSelectedInstOperands,
     /*  170410 */   // GIR_Coverage, 64558,
     /*  170410 */   GIR_EraseRootFromParent_Done,
     /*  170411 */ // Label 3171: @170411
     /*  170411 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(170518), // Rule ID 64559 //
     /*  170416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  170419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170433 */   // MIs[0] Operand 1
     /*  170433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  170441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  170445 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  170449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  170453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170458 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  170462 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  170466 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  170470 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  170474 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  170479 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  170483 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  170487 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  170491 */   // MIs[3] Operand 1
     /*  170491 */   // No operand predicates
     /*  170491 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  170493 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  170493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  170496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170498 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  170502 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  170506 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  170509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  170516 */   GIR_RootConstrainSelectedInstOperands,
     /*  170517 */   // GIR_Coverage, 64559,
     /*  170517 */   GIR_EraseRootFromParent_Done,
     /*  170518 */ // Label 3172: @170518
     /*  170518 */ GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(170572), // Rule ID 235 //
     /*  170523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170551 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170566 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170570 */   GIR_RootConstrainSelectedInstOperands,
     /*  170571 */   // GIR_Coverage, 235,
     /*  170571 */   GIR_EraseRootFromParent_Done,
     /*  170572 */ // Label 3173: @170572
     /*  170572 */ GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(170626), // Rule ID 237 //
     /*  170577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170583 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170605 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170624 */   GIR_RootConstrainSelectedInstOperands,
     /*  170625 */   // GIR_Coverage, 237,
     /*  170625 */   GIR_EraseRootFromParent_Done,
     /*  170626 */ // Label 3174: @170626
     /*  170626 */ GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(170683), // Rule ID 322 //
     /*  170631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170634 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170644 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170662 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10099>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170681 */   GIR_RootConstrainSelectedInstOperands,
     /*  170682 */   // GIR_Coverage, 322,
     /*  170682 */   GIR_EraseRootFromParent_Done,
     /*  170683 */ // Label 3175: @170683
     /*  170683 */ GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(170740), // Rule ID 324 //
     /*  170688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  170691 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170701 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170719 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10101>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170738 */   GIR_RootConstrainSelectedInstOperands,
     /*  170739 */   // GIR_Coverage, 324,
     /*  170739 */   GIR_EraseRootFromParent_Done,
     /*  170740 */ // Label 3176: @170740
     /*  170740 */ GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(170797), // Rule ID 338 //
     /*  170745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  170748 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170751 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170758 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170776 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10113>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  170779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170795 */   GIR_RootConstrainSelectedInstOperands,
     /*  170796 */   // GIR_Coverage, 338,
     /*  170796 */   GIR_EraseRootFromParent_Done,
     /*  170797 */ // Label 3177: @170797
     /*  170797 */ GIM_Reject,
     /*  170798 */ // Label 3163: @170798
     /*  170798 */ GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170852), // Rule ID 234 //
     /*  170803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170831 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170850 */   GIR_RootConstrainSelectedInstOperands,
     /*  170851 */   // GIR_Coverage, 234,
     /*  170851 */   GIR_EraseRootFromParent_Done,
     /*  170852 */ // Label 3178: @170852
     /*  170852 */ GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170906), // Rule ID 236 //
     /*  170857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170860 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170885 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  170888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170904 */   GIR_RootConstrainSelectedInstOperands,
     /*  170905 */   // GIR_Coverage, 236,
     /*  170905 */   GIR_EraseRootFromParent_Done,
     /*  170906 */ // Label 3179: @170906
     /*  170906 */ GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170960), // Rule ID 277 //
     /*  170911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170939 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  170942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  170944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170958 */   GIR_RootConstrainSelectedInstOperands,
     /*  170959 */   // GIR_Coverage, 277,
     /*  170959 */   GIR_EraseRootFromParent_Done,
     /*  170960 */ // Label 3180: @170960
     /*  170960 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(171017), // Rule ID 321 //
     /*  170965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170968 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170971 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170978 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  170981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170989 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170996 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10099>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  170999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171015 */   GIR_RootConstrainSelectedInstOperands,
     /*  171016 */   // GIR_Coverage, 321,
     /*  171016 */   GIR_EraseRootFromParent_Done,
     /*  171017 */ // Label 3181: @171017
     /*  171017 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(171074), // Rule ID 323 //
     /*  171022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171025 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171035 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  171038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171053 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10101>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  171056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171072 */   GIR_RootConstrainSelectedInstOperands,
     /*  171073 */   // GIR_Coverage, 323,
     /*  171073 */   GIR_EraseRootFromParent_Done,
     /*  171074 */ // Label 3182: @171074
     /*  171074 */ GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(171131), // Rule ID 337 //
     /*  171079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171092 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  171095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171110 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10113>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  171113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  171115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171129 */   GIR_RootConstrainSelectedInstOperands,
     /*  171130 */   // GIR_Coverage, 337,
     /*  171130 */   GIR_EraseRootFromParent_Done,
     /*  171131 */ // Label 3183: @171131
     /*  171131 */ GIM_Reject,
     /*  171132 */ // Label 3164: @171132
     /*  171132 */ GIM_Reject,
     /*  171133 */ // Label 24: @171133
     /*  171133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3218*/ GIMT_Encode4(179336),
     /*  171144 */ /*GILLT_p0s32*//*Label 3184*/ GIMT_Encode4(171280),
     /*  171148 */ /*GILLT_p0s64*//*Label 3185*/ GIMT_Encode4(171374),
     /*  171152 */ /*GILLT_s16*//*Label 3186*/ GIMT_Encode4(171468),
     /*  171156 */ /*GILLT_s32*//*Label 3187*/ GIMT_Encode4(172107),
     /*  171160 */ /*GILLT_s64*//*Label 3188*/ GIMT_Encode4(174713),
     /*  171164 */ /*GILLT_nxv1s1*//*Label 3189*/ GIMT_Encode4(175790),
     /*  171168 */ /*GILLT_nxv1s8*//*Label 3190*/ GIMT_Encode4(175870),
     /*  171172 */ /*GILLT_nxv1s16*//*Label 3191*/ GIMT_Encode4(175958),
     /*  171176 */ /*GILLT_nxv1s32*//*Label 3192*/ GIMT_Encode4(176116),
     /*  171180 */ /*GILLT_nxv1s64*//*Label 3193*/ GIMT_Encode4(176274),
     /*  171184 */ /*GILLT_nxv2s1*//*Label 3194*/ GIMT_Encode4(176432),
     /*  171188 */ /*GILLT_nxv2s8*//*Label 3195*/ GIMT_Encode4(176512),
     /*  171192 */ /*GILLT_nxv2s16*//*Label 3196*/ GIMT_Encode4(176600),
     /*  171196 */ /*GILLT_nxv2s32*//*Label 3197*/ GIMT_Encode4(176758),
     /*  171200 */ /*GILLT_nxv2s64*//*Label 3198*/ GIMT_Encode4(176916),
     /*  171204 */ /*GILLT_nxv4s1*//*Label 3199*/ GIMT_Encode4(177074),
     /*  171208 */ /*GILLT_nxv4s8*//*Label 3200*/ GIMT_Encode4(177154),
     /*  171212 */ /*GILLT_nxv4s16*//*Label 3201*/ GIMT_Encode4(177242),
     /*  171216 */ /*GILLT_nxv4s32*//*Label 3202*/ GIMT_Encode4(177400),
     /*  171220 */ /*GILLT_nxv4s64*//*Label 3203*/ GIMT_Encode4(177558),
     /*  171224 */ /*GILLT_nxv8s1*//*Label 3204*/ GIMT_Encode4(177716),
     /*  171228 */ /*GILLT_nxv8s8*//*Label 3205*/ GIMT_Encode4(177796),
     /*  171232 */ /*GILLT_nxv8s16*//*Label 3206*/ GIMT_Encode4(177884),
     /*  171236 */ /*GILLT_nxv8s32*//*Label 3207*/ GIMT_Encode4(178042),
     /*  171240 */ /*GILLT_nxv8s64*//*Label 3208*/ GIMT_Encode4(178200),
     /*  171244 */ /*GILLT_nxv16s1*//*Label 3209*/ GIMT_Encode4(178358),
     /*  171248 */ /*GILLT_nxv16s8*//*Label 3210*/ GIMT_Encode4(178438),
     /*  171252 */ /*GILLT_nxv16s16*//*Label 3211*/ GIMT_Encode4(178526),
     /*  171256 */ /*GILLT_nxv16s32*//*Label 3212*/ GIMT_Encode4(178684),
     /*  171260 */ /*GILLT_nxv32s1*//*Label 3213*/ GIMT_Encode4(178842),
     /*  171264 */ /*GILLT_nxv32s8*//*Label 3214*/ GIMT_Encode4(178922),
     /*  171268 */ /*GILLT_nxv32s16*//*Label 3215*/ GIMT_Encode4(179010),
     /*  171272 */ /*GILLT_nxv64s1*//*Label 3216*/ GIMT_Encode4(179168),
     /*  171276 */ /*GILLT_nxv64s8*//*Label 3217*/ GIMT_Encode4(179248),
     /*  171280 */ // Label 3184: @171280
     /*  171280 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171373),
     /*  171285 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171288 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171300 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171336), // Rule ID 65094 //
     /*  171305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  171308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171315 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171334 */     GIR_RootConstrainSelectedInstOperands,
     /*  171335 */     // GIR_Coverage, 65094,
     /*  171335 */     GIR_EraseRootFromParent_Done,
     /*  171336 */   // Label 3220: @171336
     /*  171336 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171372), // Rule ID 65098 //
     /*  171341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  171344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171351 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171354 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171370 */     GIR_RootConstrainSelectedInstOperands,
     /*  171371 */     // GIR_Coverage, 65098,
     /*  171371 */     GIR_EraseRootFromParent_Done,
     /*  171372 */   // Label 3221: @171372
     /*  171372 */   GIM_Reject,
     /*  171373 */ // Label 3219: @171373
     /*  171373 */ GIM_Reject,
     /*  171374 */ // Label 3185: @171374
     /*  171374 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171467),
     /*  171379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171394 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171430), // Rule ID 65093 //
     /*  171399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  171402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171409 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171412 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171428 */     GIR_RootConstrainSelectedInstOperands,
     /*  171429 */     // GIR_Coverage, 65093,
     /*  171429 */     GIR_EraseRootFromParent_Done,
     /*  171430 */   // Label 3223: @171430
     /*  171430 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171466), // Rule ID 65097 //
     /*  171435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171445 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171448 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171464 */     GIR_RootConstrainSelectedInstOperands,
     /*  171465 */     // GIR_Coverage, 65097,
     /*  171465 */     GIR_EraseRootFromParent_Done,
     /*  171466 */   // Label 3224: @171466
     /*  171466 */   GIM_Reject,
     /*  171467 */ // Label 3222: @171467
     /*  171467 */ GIM_Reject,
     /*  171468 */ // Label 3186: @171468
     /*  171468 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171522), // Rule ID 65111 //
     /*  171473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171476 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171479 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171501 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171504 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171520 */   GIR_RootConstrainSelectedInstOperands,
     /*  171521 */   // GIR_Coverage, 65111,
     /*  171521 */   GIR_EraseRootFromParent_Done,
     /*  171522 */ // Label 3225: @171522
     /*  171522 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171576), // Rule ID 65112 //
     /*  171527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  171530 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171555 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171558 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171574 */   GIR_RootConstrainSelectedInstOperands,
     /*  171575 */   // GIR_Coverage, 65112,
     /*  171575 */   GIR_EraseRootFromParent_Done,
     /*  171576 */ // Label 3226: @171576
     /*  171576 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171630), // Rule ID 65113 //
     /*  171581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  171584 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171587 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171609 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171612 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171628 */   GIR_RootConstrainSelectedInstOperands,
     /*  171629 */   // GIR_Coverage, 65113,
     /*  171629 */   GIR_EraseRootFromParent_Done,
     /*  171630 */ // Label 3227: @171630
     /*  171630 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171684), // Rule ID 65114 //
     /*  171635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  171638 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171641 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171663 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171666 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171682 */   GIR_RootConstrainSelectedInstOperands,
     /*  171683 */   // GIR_Coverage, 65114,
     /*  171683 */   GIR_EraseRootFromParent_Done,
     /*  171684 */ // Label 3228: @171684
     /*  171684 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171735), // Rule ID 2144 //
     /*  171689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  171692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171695 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  171703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171714 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  171717 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171733 */   GIR_RootConstrainSelectedInstOperands,
     /*  171734 */   // GIR_Coverage, 2144,
     /*  171734 */   GIR_EraseRootFromParent_Done,
     /*  171735 */ // Label 3229: @171735
     /*  171735 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171786), // Rule ID 2145 //
     /*  171740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  171743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  171754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171765 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  171768 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171784 */   GIR_RootConstrainSelectedInstOperands,
     /*  171785 */   // GIR_Coverage, 2145,
     /*  171785 */   GIR_EraseRootFromParent_Done,
     /*  171786 */ // Label 3230: @171786
     /*  171786 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171837), // Rule ID 2150 //
     /*  171791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  171794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  171805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171816 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  171819 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171835 */   GIR_RootConstrainSelectedInstOperands,
     /*  171836 */   // GIR_Coverage, 2150,
     /*  171836 */   GIR_EraseRootFromParent_Done,
     /*  171837 */ // Label 3231: @171837
     /*  171837 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(171888), // Rule ID 2151 //
     /*  171842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  171845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  171856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171867 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  171870 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171886 */   GIR_RootConstrainSelectedInstOperands,
     /*  171887 */   // GIR_Coverage, 2151,
     /*  171887 */   GIR_EraseRootFromParent_Done,
     /*  171888 */ // Label 3232: @171888
     /*  171888 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171939), // Rule ID 65101 //
     /*  171893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171918 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171921 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171937 */   GIR_RootConstrainSelectedInstOperands,
     /*  171938 */   // GIR_Coverage, 65101,
     /*  171938 */   GIR_EraseRootFromParent_Done,
     /*  171939 */ // Label 3233: @171939
     /*  171939 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171990), // Rule ID 65102 //
     /*  171944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  171947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171969 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171972 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171988 */   GIR_RootConstrainSelectedInstOperands,
     /*  171989 */   // GIR_Coverage, 65102,
     /*  171989 */   GIR_EraseRootFromParent_Done,
     /*  171990 */ // Label 3234: @171990
     /*  171990 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172048), // Rule ID 65105 //
     /*  171995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172001 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172027 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  172027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  172030 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172046 */   GIR_RootConstrainSelectedInstOperands,
     /*  172047 */   // GIR_Coverage, 65105,
     /*  172047 */   GIR_EraseRootFromParent_Done,
     /*  172048 */ // Label 3235: @172048
     /*  172048 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172106), // Rule ID 65106 //
     /*  172053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  172056 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172059 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  172085 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  172085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  172088 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  172095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  172100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172104 */   GIR_RootConstrainSelectedInstOperands,
     /*  172105 */   // GIR_Coverage, 65106,
     /*  172105 */   GIR_EraseRootFromParent_Done,
     /*  172106 */ // Label 3236: @172106
     /*  172106 */ GIM_Reject,
     /*  172107 */ // Label 3187: @172107
     /*  172107 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172218), // Rule ID 74127 //
     /*  172112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172133 */   // MIs[0] Operand 1
     /*  172133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172149 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172153 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172157 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172161 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172165 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172169 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172174 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172178 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172182 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172186 */   // MIs[3] Operand 1
     /*  172186 */   // No operand predicates
     /*  172186 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172191 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172193 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172196 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172216 */   GIR_RootConstrainSelectedInstOperands,
     /*  172217 */   // GIR_Coverage, 74127,
     /*  172217 */   GIR_EraseRootFromParent_Done,
     /*  172218 */ // Label 3237: @172218
     /*  172218 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172329), // Rule ID 74128 //
     /*  172223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172229 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172244 */   // MIs[0] Operand 1
     /*  172244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172264 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172268 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172272 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172276 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172280 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172285 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172289 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172293 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172297 */   // MIs[3] Operand 1
     /*  172297 */   // No operand predicates
     /*  172297 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172302 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172304 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172307 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172313 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172317 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172327 */   GIR_RootConstrainSelectedInstOperands,
     /*  172328 */   // GIR_Coverage, 74128,
     /*  172328 */   GIR_EraseRootFromParent_Done,
     /*  172329 */ // Label 3238: @172329
     /*  172329 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172440), // Rule ID 74129 //
     /*  172334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172340 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172355 */   // MIs[0] Operand 1
     /*  172355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172375 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172379 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172383 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172387 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172391 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172396 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172400 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172404 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172408 */   // MIs[3] Operand 1
     /*  172408 */   // No operand predicates
     /*  172408 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172413 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172415 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  172418 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172420 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172424 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172428 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172438 */   GIR_RootConstrainSelectedInstOperands,
     /*  172439 */   // GIR_Coverage, 74129,
     /*  172439 */   GIR_EraseRootFromParent_Done,
     /*  172440 */ // Label 3239: @172440
     /*  172440 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172551), // Rule ID 74130 //
     /*  172445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  172462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172466 */   // MIs[0] Operand 1
     /*  172466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172478 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172486 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172490 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172494 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172498 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172502 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172507 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172511 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172515 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172519 */   // MIs[3] Operand 1
     /*  172519 */   // No operand predicates
     /*  172519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172524 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172526 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  172529 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172531 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172535 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172539 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172549 */   GIR_RootConstrainSelectedInstOperands,
     /*  172550 */   // GIR_Coverage, 74130,
     /*  172550 */   GIR_EraseRootFromParent_Done,
     /*  172551 */ // Label 3240: @172551
     /*  172551 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172655), // Rule ID 74131 //
     /*  172556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172570 */   // MIs[0] Operand 1
     /*  172570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172582 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172586 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172590 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172594 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172598 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172602 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172606 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172611 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172615 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172619 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172623 */   // MIs[3] Operand 1
     /*  172623 */   // No operand predicates
     /*  172623 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172628 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172630 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  172633 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172635 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172639 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172643 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172653 */   GIR_RootConstrainSelectedInstOperands,
     /*  172654 */   // GIR_Coverage, 74131,
     /*  172654 */   GIR_EraseRootFromParent_Done,
     /*  172655 */ // Label 3241: @172655
     /*  172655 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(172759), // Rule ID 74132 //
     /*  172660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172674 */   // MIs[0] Operand 1
     /*  172674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172686 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172694 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  172698 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172702 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172706 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172710 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172715 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172719 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172723 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172727 */   // MIs[3] Operand 1
     /*  172727 */   // No operand predicates
     /*  172727 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172732 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172734 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  172737 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  172743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172747 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172757 */   GIR_RootConstrainSelectedInstOperands,
     /*  172758 */   // GIR_Coverage, 74132,
     /*  172758 */   GIR_EraseRootFromParent_Done,
     /*  172759 */ // Label 3242: @172759
     /*  172759 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(172870), // Rule ID 64560 //
     /*  172764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172767 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172770 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172785 */   // MIs[0] Operand 1
     /*  172785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172810 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  172814 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172818 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172822 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  172826 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172831 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172835 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172839 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172843 */   // MIs[3] Operand 1
     /*  172843 */   // No operand predicates
     /*  172843 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172845 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  172845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172848 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  172854 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172858 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172868 */   GIR_RootConstrainSelectedInstOperands,
     /*  172869 */   // GIR_Coverage, 64560,
     /*  172869 */   GIR_EraseRootFromParent_Done,
     /*  172870 */ // Label 3243: @172870
     /*  172870 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(172981), // Rule ID 64561 //
     /*  172875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  172878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172881 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172885 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  172892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172896 */   // MIs[0] Operand 1
     /*  172896 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  172904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  172908 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  172912 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  172916 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172921 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  172925 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  172929 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  172933 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  172937 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  172942 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  172946 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  172950 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  172954 */   // MIs[3] Operand 1
     /*  172954 */   // No operand predicates
     /*  172954 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  172956 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  172956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  172959 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  172961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  172965 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  172969 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  172972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  172979 */   GIR_RootConstrainSelectedInstOperands,
     /*  172980 */   // GIR_Coverage, 64561,
     /*  172980 */   GIR_EraseRootFromParent_Done,
     /*  172981 */ // Label 3244: @172981
     /*  172981 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173092), // Rule ID 64562 //
     /*  172986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  172989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172992 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173007 */   // MIs[0] Operand 1
     /*  173007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173032 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173036 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173040 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173044 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  173048 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173053 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173057 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173061 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173065 */   // MIs[3] Operand 1
     /*  173065 */   // No operand predicates
     /*  173065 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173067 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  173067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  173070 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173090 */   GIR_RootConstrainSelectedInstOperands,
     /*  173091 */   // GIR_Coverage, 64562,
     /*  173091 */   GIR_EraseRootFromParent_Done,
     /*  173092 */ // Label 3245: @173092
     /*  173092 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173203), // Rule ID 64563 //
     /*  173097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  173100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173103 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173118 */   // MIs[0] Operand 1
     /*  173118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173143 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173147 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173151 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173155 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  173159 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173164 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173168 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173172 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173176 */   // MIs[3] Operand 1
     /*  173176 */   // No operand predicates
     /*  173176 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173178 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  173178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  173181 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173191 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173201 */   GIR_RootConstrainSelectedInstOperands,
     /*  173202 */   // GIR_Coverage, 64563,
     /*  173202 */   GIR_EraseRootFromParent_Done,
     /*  173203 */ // Label 3246: @173203
     /*  173203 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173307), // Rule ID 64564 //
     /*  173208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  173211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173222 */   // MIs[0] Operand 1
     /*  173222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173247 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173251 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173255 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173259 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  173263 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173268 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173272 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173276 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173280 */   // MIs[3] Operand 1
     /*  173280 */   // No operand predicates
     /*  173280 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173282 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  173282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  173285 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173291 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173295 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173305 */   GIR_RootConstrainSelectedInstOperands,
     /*  173306 */   // GIR_Coverage, 64564,
     /*  173306 */   GIR_EraseRootFromParent_Done,
     /*  173307 */ // Label 3247: @173307
     /*  173307 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173411), // Rule ID 64565 //
     /*  173312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  173315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173326 */   // MIs[0] Operand 1
     /*  173326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  173334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  173338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  173342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  173346 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  173355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  173359 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  173363 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  173367 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  173372 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  173376 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  173380 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  173384 */   // MIs[3] Operand 1
     /*  173384 */   // No operand predicates
     /*  173384 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  173386 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  173386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  173389 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  173391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  173395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  173399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  173402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  173409 */   GIR_RootConstrainSelectedInstOperands,
     /*  173410 */   // GIR_Coverage, 64565,
     /*  173410 */   GIR_EraseRootFromParent_Done,
     /*  173411 */ // Label 3248: @173411
     /*  173411 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173468), // Rule ID 326 //
     /*  173416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173419 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  173429 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173447 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10103>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  173450 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173466 */   GIR_RootConstrainSelectedInstOperands,
     /*  173467 */   // GIR_Coverage, 326,
     /*  173467 */   GIR_EraseRootFromParent_Done,
     /*  173468 */ // Label 3249: @173468
     /*  173468 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173525), // Rule ID 328 //
     /*  173473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173476 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173479 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173486 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173504 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10105>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  173507 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173523 */   GIR_RootConstrainSelectedInstOperands,
     /*  173524 */   // GIR_Coverage, 328,
     /*  173524 */   GIR_EraseRootFromParent_Done,
     /*  173525 */ // Label 3250: @173525
     /*  173525 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173582), // Rule ID 330 //
     /*  173530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  173533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  173546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173561 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10107>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173564 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173580 */   GIR_RootConstrainSelectedInstOperands,
     /*  173581 */   // GIR_Coverage, 330,
     /*  173581 */   GIR_EraseRootFromParent_Done,
     /*  173582 */ // Label 3251: @173582
     /*  173582 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173636), // Rule ID 65117 //
     /*  173587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  173590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173615 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173618 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173634 */   GIR_RootConstrainSelectedInstOperands,
     /*  173635 */   // GIR_Coverage, 65117,
     /*  173635 */   GIR_EraseRootFromParent_Done,
     /*  173636 */ // Label 3252: @173636
     /*  173636 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(173690), // Rule ID 65118 //
     /*  173641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  173644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  173647 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  173654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173669 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173672 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173688 */   GIR_RootConstrainSelectedInstOperands,
     /*  173689 */   // GIR_Coverage, 65118,
     /*  173689 */   GIR_EraseRootFromParent_Done,
     /*  173690 */ // Label 3253: @173690
     /*  173690 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(173748), // Rule ID 239 //
     /*  173695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173701 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  173712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173727 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  173730 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173746 */   GIR_RootConstrainSelectedInstOperands,
     /*  173747 */   // GIR_Coverage, 239,
     /*  173747 */   GIR_EraseRootFromParent_Done,
     /*  173748 */ // Label 3254: @173748
     /*  173748 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(173806), // Rule ID 241 //
     /*  173753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173756 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173759 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173763 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  173770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173785 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  173788 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173804 */   GIR_RootConstrainSelectedInstOperands,
     /*  173805 */   // GIR_Coverage, 241,
     /*  173805 */   GIR_EraseRootFromParent_Done,
     /*  173806 */ // Label 3255: @173806
     /*  173806 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(173857), // Rule ID 242 //
     /*  173811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  173814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173836 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173839 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173855 */   GIR_RootConstrainSelectedInstOperands,
     /*  173856 */   // GIR_Coverage, 242,
     /*  173856 */   GIR_EraseRootFromParent_Done,
     /*  173857 */ // Label 3256: @173857
     /*  173857 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(173908), // Rule ID 243 //
     /*  173862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  173865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173887 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  173890 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173906 */   GIR_RootConstrainSelectedInstOperands,
     /*  173907 */   // GIR_Coverage, 243,
     /*  173907 */   GIR_EraseRootFromParent_Done,
     /*  173908 */ // Label 3257: @173908
     /*  173908 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(173959), // Rule ID 1427 //
     /*  173913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  173916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  173927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173938 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  173938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  173941 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  173953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173957 */   GIR_RootConstrainSelectedInstOperands,
     /*  173958 */   // GIR_Coverage, 1427,
     /*  173958 */   GIR_EraseRootFromParent_Done,
     /*  173959 */ // Label 3258: @173959
     /*  173959 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174010), // Rule ID 1428 //
     /*  173964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  173967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  173978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  173989 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  173989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  173992 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  173999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174008 */   GIR_RootConstrainSelectedInstOperands,
     /*  174009 */   // GIR_Coverage, 1428,
     /*  174009 */   GIR_EraseRootFromParent_Done,
     /*  174010 */ // Label 3259: @174010
     /*  174010 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174061), // Rule ID 1433 //
     /*  174015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  174018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  174029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174040 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  174043 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174059 */   GIR_RootConstrainSelectedInstOperands,
     /*  174060 */   // GIR_Coverage, 1433,
     /*  174060 */   GIR_EraseRootFromParent_Done,
     /*  174061 */ // Label 3260: @174061
     /*  174061 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(174112), // Rule ID 1434 //
     /*  174066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  174069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  174080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174084 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174091 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  174094 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174110 */   GIR_RootConstrainSelectedInstOperands,
     /*  174111 */   // GIR_Coverage, 1434,
     /*  174111 */   GIR_EraseRootFromParent_Done,
     /*  174112 */ // Label 3261: @174112
     /*  174112 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(174170), // Rule ID 65123 //
     /*  174117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  174120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174123 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174127 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174142 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174149 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174152 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174168 */   GIR_RootConstrainSelectedInstOperands,
     /*  174169 */   // GIR_Coverage, 65123,
     /*  174169 */   GIR_EraseRootFromParent_Done,
     /*  174170 */ // Label 3262: @174170
     /*  174170 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(174228), // Rule ID 65124 //
     /*  174175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  174178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174181 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174207 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174210 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174226 */   GIR_RootConstrainSelectedInstOperands,
     /*  174227 */   // GIR_Coverage, 65124,
     /*  174227 */   GIR_EraseRootFromParent_Done,
     /*  174228 */ // Label 3263: @174228
     /*  174228 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(174286), // Rule ID 65125 //
     /*  174233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  174236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174239 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174265 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174268 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174284 */   GIR_RootConstrainSelectedInstOperands,
     /*  174285 */   // GIR_Coverage, 65125,
     /*  174285 */   GIR_EraseRootFromParent_Done,
     /*  174286 */ // Label 3264: @174286
     /*  174286 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(174344), // Rule ID 65126 //
     /*  174291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  174294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174297 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174323 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  174323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174326 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174342 */   GIR_RootConstrainSelectedInstOperands,
     /*  174343 */   // GIR_Coverage, 65126,
     /*  174343 */   GIR_EraseRootFromParent_Done,
     /*  174344 */ // Label 3265: @174344
     /*  174344 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(174390), // Rule ID 1106 //
     /*  174349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174352 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174369 */   // MIs[0] rs1
     /*  174369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174377 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10607>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  174380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174382 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174388 */   GIR_RootConstrainSelectedInstOperands,
     /*  174389 */   // GIR_Coverage, 1106,
     /*  174389 */   GIR_EraseRootFromParent_Done,
     /*  174390 */ // Label 3266: @174390
     /*  174390 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(174436), // Rule ID 1108 //
     /*  174395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174415 */   // MIs[0] rs1
     /*  174415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174423 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10609>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  174426 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174428 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174434 */   GIR_RootConstrainSelectedInstOperands,
     /*  174435 */   // GIR_Coverage, 1108,
     /*  174435 */   GIR_EraseRootFromParent_Done,
     /*  174436 */ // Label 3267: @174436
     /*  174436 */ GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(174482), // Rule ID 1110 //
     /*  174441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174444 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174447 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174461 */   // MIs[0] rs1
     /*  174461 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174469 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10611>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  174472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174474 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174480 */   GIR_RootConstrainSelectedInstOperands,
     /*  174481 */   // GIR_Coverage, 1110,
     /*  174481 */   GIR_EraseRootFromParent_Done,
     /*  174482 */ // Label 3268: @174482
     /*  174482 */ GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(174528), // Rule ID 1112 //
     /*  174487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174507 */   // MIs[0] rs1
     /*  174507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174515 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10613>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  174518 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174520 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174526 */   GIR_RootConstrainSelectedInstOperands,
     /*  174527 */   // GIR_Coverage, 1112,
     /*  174527 */   GIR_EraseRootFromParent_Done,
     /*  174528 */ // Label 3269: @174528
     /*  174528 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(174574), // Rule ID 1114 //
     /*  174533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174536 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174553 */   // MIs[0] rs1
     /*  174553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174561 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10615>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  174564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174566 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174568 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174572 */   GIR_RootConstrainSelectedInstOperands,
     /*  174573 */   // GIR_Coverage, 1114,
     /*  174573 */   GIR_EraseRootFromParent_Done,
     /*  174574 */ // Label 3270: @174574
     /*  174574 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(174620), // Rule ID 1116 //
     /*  174579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  174582 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174599 */   // MIs[0] rs1
     /*  174599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174607 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10617>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  174610 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174612 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174618 */   GIR_RootConstrainSelectedInstOperands,
     /*  174619 */   // GIR_Coverage, 1116,
     /*  174619 */   GIR_EraseRootFromParent_Done,
     /*  174620 */ // Label 3271: @174620
     /*  174620 */ GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(174666), // Rule ID 1134 //
     /*  174625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  174628 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174631 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174645 */   // MIs[0] rs1
     /*  174645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174653 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10631>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  174656 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174658 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174664 */   GIR_RootConstrainSelectedInstOperands,
     /*  174665 */   // GIR_Coverage, 1134,
     /*  174665 */   GIR_EraseRootFromParent_Done,
     /*  174666 */ // Label 3272: @174666
     /*  174666 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(174712), // Rule ID 1136 //
     /*  174671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  174674 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  174687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174691 */   // MIs[0] rs1
     /*  174691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174699 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10633>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  174699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  174702 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174704 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174710 */   GIR_RootConstrainSelectedInstOperands,
     /*  174711 */   // GIR_Coverage, 1136,
     /*  174711 */   GIR_EraseRootFromParent_Done,
     /*  174712 */ // Label 3273: @174712
     /*  174712 */ GIM_Reject,
     /*  174713 */ // Label 3188: @174713
     /*  174713 */ GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(174770), // Rule ID 325 //
     /*  174718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174721 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174724 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174731 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174749 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10103>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174752 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174768 */   GIR_RootConstrainSelectedInstOperands,
     /*  174769 */   // GIR_Coverage, 325,
     /*  174769 */   GIR_EraseRootFromParent_Done,
     /*  174770 */ // Label 3274: @174770
     /*  174770 */ GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(174827), // Rule ID 327 //
     /*  174775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  174788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174806 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10105>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  174809 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174825 */   GIR_RootConstrainSelectedInstOperands,
     /*  174826 */   // GIR_Coverage, 327,
     /*  174826 */   GIR_EraseRootFromParent_Done,
     /*  174827 */ // Label 3275: @174827
     /*  174827 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(174884), // Rule ID 329 //
     /*  174832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  174835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  174845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174863 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10107>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  174866 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174882 */   GIR_RootConstrainSelectedInstOperands,
     /*  174883 */   // GIR_Coverage, 329,
     /*  174883 */   GIR_EraseRootFromParent_Done,
     /*  174884 */ // Label 3276: @174884
     /*  174884 */ GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(174941), // Rule ID 340 //
     /*  174889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  174892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  174895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  174902 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  174905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174920 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10117>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  174923 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174939 */   GIR_RootConstrainSelectedInstOperands,
     /*  174940 */   // GIR_Coverage, 340,
     /*  174940 */   GIR_EraseRootFromParent_Done,
     /*  174941 */ // Label 3277: @174941
     /*  174941 */ GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(174999), // Rule ID 238 //
     /*  174946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  174949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174952 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174956 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  174963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  174978 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  174978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  174981 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  174988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  174993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174997 */   GIR_RootConstrainSelectedInstOperands,
     /*  174998 */   // GIR_Coverage, 238,
     /*  174998 */   GIR_EraseRootFromParent_Done,
     /*  174999 */ // Label 3278: @174999
     /*  174999 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(175057), // Rule ID 240 //
     /*  175004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  175007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175036 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  175039 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175055 */   GIR_RootConstrainSelectedInstOperands,
     /*  175056 */   // GIR_Coverage, 240,
     /*  175056 */   GIR_EraseRootFromParent_Done,
     /*  175057 */ // Label 3279: @175057
     /*  175057 */ GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(175115), // Rule ID 279 //
     /*  175062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  175065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175068 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175094 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  175097 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175113 */   GIR_RootConstrainSelectedInstOperands,
     /*  175114 */   // GIR_Coverage, 279,
     /*  175114 */   GIR_EraseRootFromParent_Done,
     /*  175115 */ // Label 3280: @175115
     /*  175115 */ GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(175166), // Rule ID 280 //
     /*  175120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  175123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175145 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  175148 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175164 */   GIR_RootConstrainSelectedInstOperands,
     /*  175165 */   // GIR_Coverage, 280,
     /*  175165 */   GIR_EraseRootFromParent_Done,
     /*  175166 */ // Label 3281: @175166
     /*  175166 */ GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(175217), // Rule ID 1825 //
     /*  175171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  175174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  175185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175196 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  175199 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175215 */   GIR_RootConstrainSelectedInstOperands,
     /*  175216 */   // GIR_Coverage, 1825,
     /*  175216 */   GIR_EraseRootFromParent_Done,
     /*  175217 */ // Label 3282: @175217
     /*  175217 */ GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(175268), // Rule ID 1826 //
     /*  175222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  175225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  175236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175247 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  175247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  175250 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175266 */   GIR_RootConstrainSelectedInstOperands,
     /*  175267 */   // GIR_Coverage, 1826,
     /*  175267 */   GIR_EraseRootFromParent_Done,
     /*  175268 */ // Label 3283: @175268
     /*  175268 */ GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(175319), // Rule ID 1829 //
     /*  175273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  175276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175279 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175298 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  175301 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175317 */   GIR_RootConstrainSelectedInstOperands,
     /*  175318 */   // GIR_Coverage, 1829,
     /*  175318 */   GIR_EraseRootFromParent_Done,
     /*  175319 */ // Label 3284: @175319
     /*  175319 */ GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(175370), // Rule ID 1838 //
     /*  175324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  175327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  175338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175349 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  175349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  175352 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175368 */   GIR_RootConstrainSelectedInstOperands,
     /*  175369 */   // GIR_Coverage, 1838,
     /*  175369 */   GIR_EraseRootFromParent_Done,
     /*  175370 */ // Label 3285: @175370
     /*  175370 */ GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(175421), // Rule ID 1839 //
     /*  175375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  175378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  175389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  175400 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  175400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  175403 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  175410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  175415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175419 */   GIR_RootConstrainSelectedInstOperands,
     /*  175420 */   // GIR_Coverage, 1839,
     /*  175420 */   GIR_EraseRootFromParent_Done,
     /*  175421 */ // Label 3286: @175421
     /*  175421 */ GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(175467), // Rule ID 1105 //
     /*  175426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175429 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175446 */   // MIs[0] rs1
     /*  175446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175454 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10607>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  175457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175459 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175465 */   GIR_RootConstrainSelectedInstOperands,
     /*  175466 */   // GIR_Coverage, 1105,
     /*  175466 */   GIR_EraseRootFromParent_Done,
     /*  175467 */ // Label 3287: @175467
     /*  175467 */ GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(175513), // Rule ID 1107 //
     /*  175472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175475 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175478 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175492 */   // MIs[0] rs1
     /*  175492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175500 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10609>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  175503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175505 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175511 */   GIR_RootConstrainSelectedInstOperands,
     /*  175512 */   // GIR_Coverage, 1107,
     /*  175512 */   GIR_EraseRootFromParent_Done,
     /*  175513 */ // Label 3288: @175513
     /*  175513 */ GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(175559), // Rule ID 1109 //
     /*  175518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175521 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175538 */   // MIs[0] rs1
     /*  175538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175546 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10611>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  175549 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175551 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175557 */   GIR_RootConstrainSelectedInstOperands,
     /*  175558 */   // GIR_Coverage, 1109,
     /*  175558 */   GIR_EraseRootFromParent_Done,
     /*  175559 */ // Label 3289: @175559
     /*  175559 */ GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(175605), // Rule ID 1111 //
     /*  175564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  175577 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175584 */   // MIs[0] rs1
     /*  175584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175592 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10613>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  175595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175597 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175603 */   GIR_RootConstrainSelectedInstOperands,
     /*  175604 */   // GIR_Coverage, 1111,
     /*  175604 */   GIR_EraseRootFromParent_Done,
     /*  175605 */ // Label 3290: @175605
     /*  175605 */ GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(175651), // Rule ID 1113 //
     /*  175610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175630 */   // MIs[0] rs1
     /*  175630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175638 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10615>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  175641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175643 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175649 */   GIR_RootConstrainSelectedInstOperands,
     /*  175650 */   // GIR_Coverage, 1113,
     /*  175650 */   GIR_EraseRootFromParent_Done,
     /*  175651 */ // Label 3291: @175651
     /*  175651 */ GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(175697), // Rule ID 1115 //
     /*  175656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  175659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175676 */   // MIs[0] rs1
     /*  175676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175684 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10617>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  175687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175689 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175695 */   GIR_RootConstrainSelectedInstOperands,
     /*  175696 */   // GIR_Coverage, 1115,
     /*  175696 */   GIR_EraseRootFromParent_Done,
     /*  175697 */ // Label 3292: @175697
     /*  175697 */ GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(175743), // Rule ID 1133 //
     /*  175702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  175705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  175715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175722 */   // MIs[0] rs1
     /*  175722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175730 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10631>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  175733 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175735 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175741 */   GIR_RootConstrainSelectedInstOperands,
     /*  175742 */   // GIR_Coverage, 1133,
     /*  175742 */   GIR_EraseRootFromParent_Done,
     /*  175743 */ // Label 3293: @175743
     /*  175743 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(175789), // Rule ID 1135 //
     /*  175748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  175751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  175754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  175761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175768 */   // MIs[0] rs1
     /*  175768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175776 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10633>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  175776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  175779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175781 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175787 */   GIR_RootConstrainSelectedInstOperands,
     /*  175788 */   // GIR_Coverage, 1135,
     /*  175788 */   GIR_EraseRootFromParent_Done,
     /*  175789 */ // Label 3294: @175789
     /*  175789 */ GIM_Reject,
     /*  175790 */ // Label 3189: @175790
     /*  175790 */ GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(175869),
     /*  175795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175814 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(175841), // Rule ID 45736 //
     /*  175819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175822 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  175825 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175839 */     GIR_RootConstrainSelectedInstOperands,
     /*  175840 */     // GIR_Coverage, 45736,
     /*  175840 */     GIR_EraseRootFromParent_Done,
     /*  175841 */   // Label 3296: @175841
     /*  175841 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(175868), // Rule ID 45737 //
     /*  175846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175849 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  175852 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175866 */     GIR_RootConstrainSelectedInstOperands,
     /*  175867 */     // GIR_Coverage, 45737,
     /*  175867 */     GIR_EraseRootFromParent_Done,
     /*  175868 */   // Label 3297: @175868
     /*  175868 */   GIM_Reject,
     /*  175869 */ // Label 3295: @175869
     /*  175869 */ GIM_Reject,
     /*  175870 */ // Label 3190: @175870
     /*  175870 */ GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(175957),
     /*  175875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175886 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(175921), // Rule ID 45732 //
     /*  175891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175894 */     // MIs[0] rs1
     /*  175894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175902 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  175905 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175919 */     GIR_RootConstrainSelectedInstOperands,
     /*  175920 */     // GIR_Coverage, 45732,
     /*  175920 */     GIR_EraseRootFromParent_Done,
     /*  175921 */   // Label 3299: @175921
     /*  175921 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(175956), // Rule ID 45733 //
     /*  175926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175929 */     // MIs[0] rs1
     /*  175929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175937 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  175940 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175954 */     GIR_RootConstrainSelectedInstOperands,
     /*  175955 */     // GIR_Coverage, 45733,
     /*  175955 */     GIR_EraseRootFromParent_Done,
     /*  175956 */   // Label 3300: @175956
     /*  175956 */   GIM_Reject,
     /*  175957 */ // Label 3298: @175957
     /*  175957 */ GIM_Reject,
     /*  175958 */ // Label 3191: @175958
     /*  175958 */ GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(176115),
     /*  175963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175974 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(176009), // Rule ID 45928 //
     /*  175979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175982 */     // MIs[0] rs1
     /*  175982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175990 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  175993 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176007 */     GIR_RootConstrainSelectedInstOperands,
     /*  176008 */     // GIR_Coverage, 45928,
     /*  176008 */     GIR_EraseRootFromParent_Done,
     /*  176009 */   // Label 3302: @176009
     /*  176009 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(176044), // Rule ID 45929 //
     /*  176014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176017 */     // MIs[0] rs1
     /*  176017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176025 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176028 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176042 */     GIR_RootConstrainSelectedInstOperands,
     /*  176043 */     // GIR_Coverage, 45929,
     /*  176043 */     GIR_EraseRootFromParent_Done,
     /*  176044 */   // Label 3303: @176044
     /*  176044 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(176079), // Rule ID 46004 //
     /*  176049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  176052 */     // MIs[0] rs1
     /*  176052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176060 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176063 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176077 */     GIR_RootConstrainSelectedInstOperands,
     /*  176078 */     // GIR_Coverage, 46004,
     /*  176078 */     GIR_EraseRootFromParent_Done,
     /*  176079 */   // Label 3304: @176079
     /*  176079 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(176114), // Rule ID 46005 //
     /*  176084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  176087 */     // MIs[0] rs1
     /*  176087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176095 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  176098 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176112 */     GIR_RootConstrainSelectedInstOperands,
     /*  176113 */     // GIR_Coverage, 46005,
     /*  176113 */     GIR_EraseRootFromParent_Done,
     /*  176114 */   // Label 3305: @176114
     /*  176114 */   GIM_Reject,
     /*  176115 */ // Label 3301: @176115
     /*  176115 */ GIM_Reject,
     /*  176116 */ // Label 3192: @176116
     /*  176116 */ GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(176273),
     /*  176121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176132 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(176167), // Rule ID 45936 //
     /*  176137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176140 */     // MIs[0] rs1
     /*  176140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176148 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176151 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176165 */     GIR_RootConstrainSelectedInstOperands,
     /*  176166 */     // GIR_Coverage, 45936,
     /*  176166 */     GIR_EraseRootFromParent_Done,
     /*  176167 */   // Label 3307: @176167
     /*  176167 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(176202), // Rule ID 45937 //
     /*  176172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176175 */     // MIs[0] rs1
     /*  176175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176183 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176186 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176200 */     GIR_RootConstrainSelectedInstOperands,
     /*  176201 */     // GIR_Coverage, 45937,
     /*  176201 */     GIR_EraseRootFromParent_Done,
     /*  176202 */   // Label 3308: @176202
     /*  176202 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(176237), // Rule ID 46012 //
     /*  176207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  176210 */     // MIs[0] rs1
     /*  176210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176218 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176235 */     GIR_RootConstrainSelectedInstOperands,
     /*  176236 */     // GIR_Coverage, 46012,
     /*  176236 */     GIR_EraseRootFromParent_Done,
     /*  176237 */   // Label 3309: @176237
     /*  176237 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(176272), // Rule ID 46013 //
     /*  176242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  176245 */     // MIs[0] rs1
     /*  176245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176253 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  176256 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176270 */     GIR_RootConstrainSelectedInstOperands,
     /*  176271 */     // GIR_Coverage, 46013,
     /*  176271 */     GIR_EraseRootFromParent_Done,
     /*  176272 */   // Label 3310: @176272
     /*  176272 */   GIM_Reject,
     /*  176273 */ // Label 3306: @176273
     /*  176273 */ GIM_Reject,
     /*  176274 */ // Label 3193: @176274
     /*  176274 */ GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(176431),
     /*  176279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176290 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(176325), // Rule ID 45952 //
     /*  176295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  176298 */     // MIs[0] rs1
     /*  176298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176306 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176309 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176323 */     GIR_RootConstrainSelectedInstOperands,
     /*  176324 */     // GIR_Coverage, 45952,
     /*  176324 */     GIR_EraseRootFromParent_Done,
     /*  176325 */   // Label 3312: @176325
     /*  176325 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(176360), // Rule ID 45953 //
     /*  176330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  176333 */     // MIs[0] rs1
     /*  176333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176341 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176344 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176358 */     GIR_RootConstrainSelectedInstOperands,
     /*  176359 */     // GIR_Coverage, 45953,
     /*  176359 */     GIR_EraseRootFromParent_Done,
     /*  176360 */   // Label 3313: @176360
     /*  176360 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(176395), // Rule ID 46024 //
     /*  176365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  176368 */     // MIs[0] rs1
     /*  176368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176376 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176379 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176393 */     GIR_RootConstrainSelectedInstOperands,
     /*  176394 */     // GIR_Coverage, 46024,
     /*  176394 */     GIR_EraseRootFromParent_Done,
     /*  176395 */   // Label 3314: @176395
     /*  176395 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(176430), // Rule ID 46025 //
     /*  176400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  176403 */     // MIs[0] rs1
     /*  176403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176411 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  176414 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176428 */     GIR_RootConstrainSelectedInstOperands,
     /*  176429 */     // GIR_Coverage, 46025,
     /*  176429 */     GIR_EraseRootFromParent_Done,
     /*  176430 */   // Label 3315: @176430
     /*  176430 */   GIM_Reject,
     /*  176431 */ // Label 3311: @176431
     /*  176431 */ GIM_Reject,
     /*  176432 */ // Label 3194: @176432
     /*  176432 */ GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(176511),
     /*  176437 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176440 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  176452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176456 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(176483), // Rule ID 46064 //
     /*  176461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176464 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  176464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  176467 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  176477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176481 */     GIR_RootConstrainSelectedInstOperands,
     /*  176482 */     // GIR_Coverage, 46064,
     /*  176482 */     GIR_EraseRootFromParent_Done,
     /*  176483 */   // Label 3317: @176483
     /*  176483 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(176510), // Rule ID 46065 //
     /*  176488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176491 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  176491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  176494 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  176504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176508 */     GIR_RootConstrainSelectedInstOperands,
     /*  176509 */     // GIR_Coverage, 46065,
     /*  176509 */     GIR_EraseRootFromParent_Done,
     /*  176510 */   // Label 3318: @176510
     /*  176510 */   GIM_Reject,
     /*  176511 */ // Label 3316: @176511
     /*  176511 */ GIM_Reject,
     /*  176512 */ // Label 3195: @176512
     /*  176512 */ GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(176599),
     /*  176517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176528 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(176563), // Rule ID 45920 //
     /*  176533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176536 */     // MIs[0] rs1
     /*  176536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176544 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  176544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  176547 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176561 */     GIR_RootConstrainSelectedInstOperands,
     /*  176562 */     // GIR_Coverage, 45920,
     /*  176562 */     GIR_EraseRootFromParent_Done,
     /*  176563 */   // Label 3320: @176563
     /*  176563 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(176598), // Rule ID 45921 //
     /*  176568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176571 */     // MIs[0] rs1
     /*  176571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176579 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  176579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  176582 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  176592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176596 */     GIR_RootConstrainSelectedInstOperands,
     /*  176597 */     // GIR_Coverage, 45921,
     /*  176597 */     GIR_EraseRootFromParent_Done,
     /*  176598 */   // Label 3321: @176598
     /*  176598 */   GIM_Reject,
     /*  176599 */ // Label 3319: @176599
     /*  176599 */ GIM_Reject,
     /*  176600 */ // Label 3196: @176600
     /*  176600 */ GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(176757),
     /*  176605 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176608 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176616 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(176651), // Rule ID 45932 //
     /*  176621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176624 */     // MIs[0] rs1
     /*  176624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176632 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176635 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176649 */     GIR_RootConstrainSelectedInstOperands,
     /*  176650 */     // GIR_Coverage, 45932,
     /*  176650 */     GIR_EraseRootFromParent_Done,
     /*  176651 */   // Label 3323: @176651
     /*  176651 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(176686), // Rule ID 45933 //
     /*  176656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176659 */     // MIs[0] rs1
     /*  176659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176667 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176670 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176684 */     GIR_RootConstrainSelectedInstOperands,
     /*  176685 */     // GIR_Coverage, 45933,
     /*  176685 */     GIR_EraseRootFromParent_Done,
     /*  176686 */   // Label 3324: @176686
     /*  176686 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(176721), // Rule ID 46008 //
     /*  176691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  176694 */     // MIs[0] rs1
     /*  176694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176702 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  176702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176705 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176719 */     GIR_RootConstrainSelectedInstOperands,
     /*  176720 */     // GIR_Coverage, 46008,
     /*  176720 */     GIR_EraseRootFromParent_Done,
     /*  176721 */   // Label 3325: @176721
     /*  176721 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(176756), // Rule ID 46009 //
     /*  176726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  176729 */     // MIs[0] rs1
     /*  176729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176737 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  176737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  176740 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  176750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176754 */     GIR_RootConstrainSelectedInstOperands,
     /*  176755 */     // GIR_Coverage, 46009,
     /*  176755 */     GIR_EraseRootFromParent_Done,
     /*  176756 */   // Label 3326: @176756
     /*  176756 */   GIM_Reject,
     /*  176757 */ // Label 3322: @176757
     /*  176757 */ GIM_Reject,
     /*  176758 */ // Label 3197: @176758
     /*  176758 */ GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(176915),
     /*  176763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  176774 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(176809), // Rule ID 45948 //
     /*  176779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  176782 */     // MIs[0] rs1
     /*  176782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176790 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176793 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176807 */     GIR_RootConstrainSelectedInstOperands,
     /*  176808 */     // GIR_Coverage, 45948,
     /*  176808 */     GIR_EraseRootFromParent_Done,
     /*  176809 */   // Label 3328: @176809
     /*  176809 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(176844), // Rule ID 45949 //
     /*  176814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  176817 */     // MIs[0] rs1
     /*  176817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176825 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176828 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176842 */     GIR_RootConstrainSelectedInstOperands,
     /*  176843 */     // GIR_Coverage, 45949,
     /*  176843 */     GIR_EraseRootFromParent_Done,
     /*  176844 */   // Label 3329: @176844
     /*  176844 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(176879), // Rule ID 46020 //
     /*  176849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  176852 */     // MIs[0] rs1
     /*  176852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176860 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  176860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176863 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176877 */     GIR_RootConstrainSelectedInstOperands,
     /*  176878 */     // GIR_Coverage, 46020,
     /*  176878 */     GIR_EraseRootFromParent_Done,
     /*  176879 */   // Label 3330: @176879
     /*  176879 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(176914), // Rule ID 46021 //
     /*  176884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  176887 */     // MIs[0] rs1
     /*  176887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176895 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  176895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  176898 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  176908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176912 */     GIR_RootConstrainSelectedInstOperands,
     /*  176913 */     // GIR_Coverage, 46021,
     /*  176913 */     GIR_EraseRootFromParent_Done,
     /*  176914 */   // Label 3331: @176914
     /*  176914 */   GIM_Reject,
     /*  176915 */ // Label 3327: @176915
     /*  176915 */ GIM_Reject,
     /*  176916 */ // Label 3198: @176916
     /*  176916 */ GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(177073),
     /*  176921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  176924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  176928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  176932 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(176967), // Rule ID 45992 //
     /*  176937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  176940 */     // MIs[0] rs1
     /*  176940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  176944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176948 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  176948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  176951 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176965 */     GIR_RootConstrainSelectedInstOperands,
     /*  176966 */     // GIR_Coverage, 45992,
     /*  176966 */     GIR_EraseRootFromParent_Done,
     /*  176967 */   // Label 3333: @176967
     /*  176967 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(177002), // Rule ID 45993 //
     /*  176972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  176975 */     // MIs[0] rs1
     /*  176975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176983 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  176983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  176986 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  176988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  176990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  176993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  176996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177000 */     GIR_RootConstrainSelectedInstOperands,
     /*  177001 */     // GIR_Coverage, 45993,
     /*  177001 */     GIR_EraseRootFromParent_Done,
     /*  177002 */   // Label 3334: @177002
     /*  177002 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(177037), // Rule ID 46052 //
     /*  177007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  177010 */     // MIs[0] rs1
     /*  177010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177018 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  177021 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177035 */     GIR_RootConstrainSelectedInstOperands,
     /*  177036 */     // GIR_Coverage, 46052,
     /*  177036 */     GIR_EraseRootFromParent_Done,
     /*  177037 */   // Label 3335: @177037
     /*  177037 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(177072), // Rule ID 46053 //
     /*  177042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  177045 */     // MIs[0] rs1
     /*  177045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177053 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  177056 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177070 */     GIR_RootConstrainSelectedInstOperands,
     /*  177071 */     // GIR_Coverage, 46053,
     /*  177071 */     GIR_EraseRootFromParent_Done,
     /*  177072 */   // Label 3336: @177072
     /*  177072 */   GIM_Reject,
     /*  177073 */ // Label 3332: @177073
     /*  177073 */ GIM_Reject,
     /*  177074 */ // Label 3199: @177074
     /*  177074 */ GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(177153),
     /*  177079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177098 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(177125), // Rule ID 46068 //
     /*  177103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177106 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  177106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  177109 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177123 */     GIR_RootConstrainSelectedInstOperands,
     /*  177124 */     // GIR_Coverage, 46068,
     /*  177124 */     GIR_EraseRootFromParent_Done,
     /*  177125 */   // Label 3338: @177125
     /*  177125 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(177152), // Rule ID 46069 //
     /*  177130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177133 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  177133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  177136 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177150 */     GIR_RootConstrainSelectedInstOperands,
     /*  177151 */     // GIR_Coverage, 46069,
     /*  177151 */     GIR_EraseRootFromParent_Done,
     /*  177152 */   // Label 3339: @177152
     /*  177152 */   GIM_Reject,
     /*  177153 */ // Label 3337: @177153
     /*  177153 */ GIM_Reject,
     /*  177154 */ // Label 3200: @177154
     /*  177154 */ GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(177241),
     /*  177159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177162 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177170 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(177205), // Rule ID 45924 //
     /*  177175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177178 */     // MIs[0] rs1
     /*  177178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177186 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  177186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  177189 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177203 */     GIR_RootConstrainSelectedInstOperands,
     /*  177204 */     // GIR_Coverage, 45924,
     /*  177204 */     GIR_EraseRootFromParent_Done,
     /*  177205 */   // Label 3341: @177205
     /*  177205 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(177240), // Rule ID 45925 //
     /*  177210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177213 */     // MIs[0] rs1
     /*  177213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177221 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  177221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  177224 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177238 */     GIR_RootConstrainSelectedInstOperands,
     /*  177239 */     // GIR_Coverage, 45925,
     /*  177239 */     GIR_EraseRootFromParent_Done,
     /*  177240 */   // Label 3342: @177240
     /*  177240 */   GIM_Reject,
     /*  177241 */ // Label 3340: @177241
     /*  177241 */ GIM_Reject,
     /*  177242 */ // Label 3201: @177242
     /*  177242 */ GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(177399),
     /*  177247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177258 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(177293), // Rule ID 45944 //
     /*  177263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177266 */     // MIs[0] rs1
     /*  177266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177274 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177277 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177291 */     GIR_RootConstrainSelectedInstOperands,
     /*  177292 */     // GIR_Coverage, 45944,
     /*  177292 */     GIR_EraseRootFromParent_Done,
     /*  177293 */   // Label 3344: @177293
     /*  177293 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(177328), // Rule ID 45945 //
     /*  177298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177301 */     // MIs[0] rs1
     /*  177301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177309 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177312 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177326 */     GIR_RootConstrainSelectedInstOperands,
     /*  177327 */     // GIR_Coverage, 45945,
     /*  177327 */     GIR_EraseRootFromParent_Done,
     /*  177328 */   // Label 3345: @177328
     /*  177328 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(177363), // Rule ID 46016 //
     /*  177333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  177336 */     // MIs[0] rs1
     /*  177336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177344 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177347 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177361 */     GIR_RootConstrainSelectedInstOperands,
     /*  177362 */     // GIR_Coverage, 46016,
     /*  177362 */     GIR_EraseRootFromParent_Done,
     /*  177363 */   // Label 3346: @177363
     /*  177363 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(177398), // Rule ID 46017 //
     /*  177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  177371 */     // MIs[0] rs1
     /*  177371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177379 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  177382 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177396 */     GIR_RootConstrainSelectedInstOperands,
     /*  177397 */     // GIR_Coverage, 46017,
     /*  177397 */     GIR_EraseRootFromParent_Done,
     /*  177398 */   // Label 3347: @177398
     /*  177398 */   GIM_Reject,
     /*  177399 */ // Label 3343: @177399
     /*  177399 */ GIM_Reject,
     /*  177400 */ // Label 3202: @177400
     /*  177400 */ GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(177557),
     /*  177405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177416 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(177451), // Rule ID 45980 //
     /*  177421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177424 */     // MIs[0] rs1
     /*  177424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177432 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  177432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177435 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177449 */     GIR_RootConstrainSelectedInstOperands,
     /*  177450 */     // GIR_Coverage, 45980,
     /*  177450 */     GIR_EraseRootFromParent_Done,
     /*  177451 */   // Label 3349: @177451
     /*  177451 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(177486), // Rule ID 45981 //
     /*  177456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177459 */     // MIs[0] rs1
     /*  177459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177467 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  177467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177470 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177484 */     GIR_RootConstrainSelectedInstOperands,
     /*  177485 */     // GIR_Coverage, 45981,
     /*  177485 */     GIR_EraseRootFromParent_Done,
     /*  177486 */   // Label 3350: @177486
     /*  177486 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(177521), // Rule ID 46040 //
     /*  177491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  177494 */     // MIs[0] rs1
     /*  177494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177502 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  177502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177505 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177519 */     GIR_RootConstrainSelectedInstOperands,
     /*  177520 */     // GIR_Coverage, 46040,
     /*  177520 */     GIR_EraseRootFromParent_Done,
     /*  177521 */   // Label 3351: @177521
     /*  177521 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(177556), // Rule ID 46041 //
     /*  177526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  177529 */     // MIs[0] rs1
     /*  177529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177537 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  177537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  177540 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177554 */     GIR_RootConstrainSelectedInstOperands,
     /*  177555 */     // GIR_Coverage, 46041,
     /*  177555 */     GIR_EraseRootFromParent_Done,
     /*  177556 */   // Label 3352: @177556
     /*  177556 */   GIM_Reject,
     /*  177557 */ // Label 3348: @177557
     /*  177557 */ GIM_Reject,
     /*  177558 */ // Label 3203: @177558
     /*  177558 */ GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(177715),
     /*  177563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177566 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  177574 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(177609), // Rule ID 45996 //
     /*  177579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  177582 */     // MIs[0] rs1
     /*  177582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177590 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177593 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177607 */     GIR_RootConstrainSelectedInstOperands,
     /*  177608 */     // GIR_Coverage, 45996,
     /*  177608 */     GIR_EraseRootFromParent_Done,
     /*  177609 */   // Label 3354: @177609
     /*  177609 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(177644), // Rule ID 45997 //
     /*  177614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  177617 */     // MIs[0] rs1
     /*  177617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177625 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177628 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177642 */     GIR_RootConstrainSelectedInstOperands,
     /*  177643 */     // GIR_Coverage, 45997,
     /*  177643 */     GIR_EraseRootFromParent_Done,
     /*  177644 */   // Label 3355: @177644
     /*  177644 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(177679), // Rule ID 46056 //
     /*  177649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  177652 */     // MIs[0] rs1
     /*  177652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177660 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  177660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177663 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177677 */     GIR_RootConstrainSelectedInstOperands,
     /*  177678 */     // GIR_Coverage, 46056,
     /*  177678 */     GIR_EraseRootFromParent_Done,
     /*  177679 */   // Label 3356: @177679
     /*  177679 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(177714), // Rule ID 46057 //
     /*  177684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  177687 */     // MIs[0] rs1
     /*  177687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177695 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  177695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  177698 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177712 */     GIR_RootConstrainSelectedInstOperands,
     /*  177713 */     // GIR_Coverage, 46057,
     /*  177713 */     GIR_EraseRootFromParent_Done,
     /*  177714 */   // Label 3357: @177714
     /*  177714 */   GIM_Reject,
     /*  177715 */ // Label 3353: @177715
     /*  177715 */ GIM_Reject,
     /*  177716 */ // Label 3204: @177716
     /*  177716 */ GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(177795),
     /*  177721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177740 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(177767), // Rule ID 46072 //
     /*  177745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177748 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  177748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  177751 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177765 */     GIR_RootConstrainSelectedInstOperands,
     /*  177766 */     // GIR_Coverage, 46072,
     /*  177766 */     GIR_EraseRootFromParent_Done,
     /*  177767 */   // Label 3359: @177767
     /*  177767 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(177794), // Rule ID 46073 //
     /*  177772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177775 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  177775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  177778 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  177788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177792 */     GIR_RootConstrainSelectedInstOperands,
     /*  177793 */     // GIR_Coverage, 46073,
     /*  177793 */     GIR_EraseRootFromParent_Done,
     /*  177794 */   // Label 3360: @177794
     /*  177794 */   GIM_Reject,
     /*  177795 */ // Label 3358: @177795
     /*  177795 */ GIM_Reject,
     /*  177796 */ // Label 3205: @177796
     /*  177796 */ GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(177883),
     /*  177801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  177812 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(177847), // Rule ID 45940 //
     /*  177817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177820 */     // MIs[0] rs1
     /*  177820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177828 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  177828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  177831 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177845 */     GIR_RootConstrainSelectedInstOperands,
     /*  177846 */     // GIR_Coverage, 45940,
     /*  177846 */     GIR_EraseRootFromParent_Done,
     /*  177847 */   // Label 3362: @177847
     /*  177847 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(177882), // Rule ID 45941 //
     /*  177852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177855 */     // MIs[0] rs1
     /*  177855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177863 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  177863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  177866 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  177876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177880 */     GIR_RootConstrainSelectedInstOperands,
     /*  177881 */     // GIR_Coverage, 45941,
     /*  177881 */     GIR_EraseRootFromParent_Done,
     /*  177882 */   // Label 3363: @177882
     /*  177882 */   GIM_Reject,
     /*  177883 */ // Label 3361: @177883
     /*  177883 */ GIM_Reject,
     /*  177884 */ // Label 3206: @177884
     /*  177884 */ GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(178041),
     /*  177889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  177892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  177896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  177900 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(177935), // Rule ID 45968 //
     /*  177905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  177908 */     // MIs[0] rs1
     /*  177908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177916 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177919 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177933 */     GIR_RootConstrainSelectedInstOperands,
     /*  177934 */     // GIR_Coverage, 45968,
     /*  177934 */     GIR_EraseRootFromParent_Done,
     /*  177935 */   // Label 3365: @177935
     /*  177935 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(177970), // Rule ID 45969 //
     /*  177940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  177943 */     // MIs[0] rs1
     /*  177943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177951 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  177951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177954 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177968 */     GIR_RootConstrainSelectedInstOperands,
     /*  177969 */     // GIR_Coverage, 45969,
     /*  177969 */     GIR_EraseRootFromParent_Done,
     /*  177970 */   // Label 3366: @177970
     /*  177970 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(178005), // Rule ID 46028 //
     /*  177975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  177978 */     // MIs[0] rs1
     /*  177978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177986 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  177986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  177989 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  177991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  177993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  177996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178003 */     GIR_RootConstrainSelectedInstOperands,
     /*  178004 */     // GIR_Coverage, 46028,
     /*  178004 */     GIR_EraseRootFromParent_Done,
     /*  178005 */   // Label 3367: @178005
     /*  178005 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(178040), // Rule ID 46029 //
     /*  178010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  178013 */     // MIs[0] rs1
     /*  178013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178021 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  178024 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178038 */     GIR_RootConstrainSelectedInstOperands,
     /*  178039 */     // GIR_Coverage, 46029,
     /*  178039 */     GIR_EraseRootFromParent_Done,
     /*  178040 */   // Label 3368: @178040
     /*  178040 */   GIM_Reject,
     /*  178041 */ // Label 3364: @178041
     /*  178041 */ GIM_Reject,
     /*  178042 */ // Label 3207: @178042
     /*  178042 */ GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(178199),
     /*  178047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178050 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178058 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(178093), // Rule ID 45984 //
     /*  178063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178066 */     // MIs[0] rs1
     /*  178066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178074 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178077 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178091 */     GIR_RootConstrainSelectedInstOperands,
     /*  178092 */     // GIR_Coverage, 45984,
     /*  178092 */     GIR_EraseRootFromParent_Done,
     /*  178093 */   // Label 3370: @178093
     /*  178093 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(178128), // Rule ID 45985 //
     /*  178098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178101 */     // MIs[0] rs1
     /*  178101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178109 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178112 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178126 */     GIR_RootConstrainSelectedInstOperands,
     /*  178127 */     // GIR_Coverage, 45985,
     /*  178127 */     GIR_EraseRootFromParent_Done,
     /*  178128 */   // Label 3371: @178128
     /*  178128 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(178163), // Rule ID 46044 //
     /*  178133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  178136 */     // MIs[0] rs1
     /*  178136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178147 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178161 */     GIR_RootConstrainSelectedInstOperands,
     /*  178162 */     // GIR_Coverage, 46044,
     /*  178162 */     GIR_EraseRootFromParent_Done,
     /*  178163 */   // Label 3372: @178163
     /*  178163 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(178198), // Rule ID 46045 //
     /*  178168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  178171 */     // MIs[0] rs1
     /*  178171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178179 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  178182 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178196 */     GIR_RootConstrainSelectedInstOperands,
     /*  178197 */     // GIR_Coverage, 46045,
     /*  178197 */     GIR_EraseRootFromParent_Done,
     /*  178198 */   // Label 3373: @178198
     /*  178198 */   GIM_Reject,
     /*  178199 */ // Label 3369: @178199
     /*  178199 */ GIM_Reject,
     /*  178200 */ // Label 3208: @178200
     /*  178200 */ GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(178357),
     /*  178205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178216 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(178251), // Rule ID 46000 //
     /*  178221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  178224 */     // MIs[0] rs1
     /*  178224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178232 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  178232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178235 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178249 */     GIR_RootConstrainSelectedInstOperands,
     /*  178250 */     // GIR_Coverage, 46000,
     /*  178250 */     GIR_EraseRootFromParent_Done,
     /*  178251 */   // Label 3375: @178251
     /*  178251 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(178286), // Rule ID 46001 //
     /*  178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  178259 */     // MIs[0] rs1
     /*  178259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178267 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  178267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178270 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178284 */     GIR_RootConstrainSelectedInstOperands,
     /*  178285 */     // GIR_Coverage, 46001,
     /*  178285 */     GIR_EraseRootFromParent_Done,
     /*  178286 */   // Label 3376: @178286
     /*  178286 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(178321), // Rule ID 46060 //
     /*  178291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  178294 */     // MIs[0] rs1
     /*  178294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178302 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  178302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178305 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178319 */     GIR_RootConstrainSelectedInstOperands,
     /*  178320 */     // GIR_Coverage, 46060,
     /*  178320 */     GIR_EraseRootFromParent_Done,
     /*  178321 */   // Label 3377: @178321
     /*  178321 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(178356), // Rule ID 46061 //
     /*  178326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  178329 */     // MIs[0] rs1
     /*  178329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178337 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  178337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  178340 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178354 */     GIR_RootConstrainSelectedInstOperands,
     /*  178355 */     // GIR_Coverage, 46061,
     /*  178355 */     GIR_EraseRootFromParent_Done,
     /*  178356 */   // Label 3378: @178356
     /*  178356 */   GIM_Reject,
     /*  178357 */ // Label 3374: @178357
     /*  178357 */ GIM_Reject,
     /*  178358 */ // Label 3209: @178358
     /*  178358 */ GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(178437),
     /*  178363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178382 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(178409), // Rule ID 46076 //
     /*  178387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178390 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  178390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  178393 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178407 */     GIR_RootConstrainSelectedInstOperands,
     /*  178408 */     // GIR_Coverage, 46076,
     /*  178408 */     GIR_EraseRootFromParent_Done,
     /*  178409 */   // Label 3380: @178409
     /*  178409 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(178436), // Rule ID 46077 //
     /*  178414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178417 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  178417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  178420 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178434 */     GIR_RootConstrainSelectedInstOperands,
     /*  178435 */     // GIR_Coverage, 46077,
     /*  178435 */     GIR_EraseRootFromParent_Done,
     /*  178436 */   // Label 3381: @178436
     /*  178436 */   GIM_Reject,
     /*  178437 */ // Label 3379: @178437
     /*  178437 */ GIM_Reject,
     /*  178438 */ // Label 3210: @178438
     /*  178438 */ GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(178525),
     /*  178443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  178454 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(178489), // Rule ID 45956 //
     /*  178459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178462 */     // MIs[0] rs1
     /*  178462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178470 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  178470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  178473 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178487 */     GIR_RootConstrainSelectedInstOperands,
     /*  178488 */     // GIR_Coverage, 45956,
     /*  178488 */     GIR_EraseRootFromParent_Done,
     /*  178489 */   // Label 3383: @178489
     /*  178489 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(178524), // Rule ID 45957 //
     /*  178494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178497 */     // MIs[0] rs1
     /*  178497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178505 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  178505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  178508 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178522 */     GIR_RootConstrainSelectedInstOperands,
     /*  178523 */     // GIR_Coverage, 45957,
     /*  178523 */     GIR_EraseRootFromParent_Done,
     /*  178524 */   // Label 3384: @178524
     /*  178524 */   GIM_Reject,
     /*  178525 */ // Label 3382: @178525
     /*  178525 */ GIM_Reject,
     /*  178526 */ // Label 3211: @178526
     /*  178526 */ GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(178683),
     /*  178531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178542 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(178577), // Rule ID 45972 //
     /*  178547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178550 */     // MIs[0] rs1
     /*  178550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178558 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  178558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178561 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178575 */     GIR_RootConstrainSelectedInstOperands,
     /*  178576 */     // GIR_Coverage, 45972,
     /*  178576 */     GIR_EraseRootFromParent_Done,
     /*  178577 */   // Label 3386: @178577
     /*  178577 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(178612), // Rule ID 45973 //
     /*  178582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178585 */     // MIs[0] rs1
     /*  178585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178593 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178596 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178610 */     GIR_RootConstrainSelectedInstOperands,
     /*  178611 */     // GIR_Coverage, 45973,
     /*  178611 */     GIR_EraseRootFromParent_Done,
     /*  178612 */   // Label 3387: @178612
     /*  178612 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(178647), // Rule ID 46032 //
     /*  178617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  178620 */     // MIs[0] rs1
     /*  178620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178628 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  178628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178631 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178645 */     GIR_RootConstrainSelectedInstOperands,
     /*  178646 */     // GIR_Coverage, 46032,
     /*  178646 */     GIR_EraseRootFromParent_Done,
     /*  178647 */   // Label 3388: @178647
     /*  178647 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(178682), // Rule ID 46033 //
     /*  178652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  178655 */     // MIs[0] rs1
     /*  178655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178663 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  178663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  178666 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  178676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178680 */     GIR_RootConstrainSelectedInstOperands,
     /*  178681 */     // GIR_Coverage, 46033,
     /*  178681 */     GIR_EraseRootFromParent_Done,
     /*  178682 */   // Label 3389: @178682
     /*  178682 */   GIM_Reject,
     /*  178683 */ // Label 3385: @178683
     /*  178683 */ GIM_Reject,
     /*  178684 */ // Label 3212: @178684
     /*  178684 */ GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(178841),
     /*  178689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  178700 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(178735), // Rule ID 45988 //
     /*  178705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178708 */     // MIs[0] rs1
     /*  178708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178716 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178719 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178733 */     GIR_RootConstrainSelectedInstOperands,
     /*  178734 */     // GIR_Coverage, 45988,
     /*  178734 */     GIR_EraseRootFromParent_Done,
     /*  178735 */   // Label 3391: @178735
     /*  178735 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(178770), // Rule ID 45989 //
     /*  178740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178743 */     // MIs[0] rs1
     /*  178743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178751 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178754 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178768 */     GIR_RootConstrainSelectedInstOperands,
     /*  178769 */     // GIR_Coverage, 45989,
     /*  178769 */     GIR_EraseRootFromParent_Done,
     /*  178770 */   // Label 3392: @178770
     /*  178770 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(178805), // Rule ID 46048 //
     /*  178775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  178778 */     // MIs[0] rs1
     /*  178778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178786 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  178786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178789 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178803 */     GIR_RootConstrainSelectedInstOperands,
     /*  178804 */     // GIR_Coverage, 46048,
     /*  178804 */     GIR_EraseRootFromParent_Done,
     /*  178805 */   // Label 3393: @178805
     /*  178805 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(178840), // Rule ID 46049 //
     /*  178810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  178813 */     // MIs[0] rs1
     /*  178813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178821 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  178821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  178824 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178838 */     GIR_RootConstrainSelectedInstOperands,
     /*  178839 */     // GIR_Coverage, 46049,
     /*  178839 */     GIR_EraseRootFromParent_Done,
     /*  178840 */   // Label 3394: @178840
     /*  178840 */   GIM_Reject,
     /*  178841 */ // Label 3390: @178841
     /*  178841 */ GIM_Reject,
     /*  178842 */ // Label 3213: @178842
     /*  178842 */ GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(178921),
     /*  178847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  178858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178866 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(178893), // Rule ID 46080 //
     /*  178871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178874 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  178874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  178877 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178891 */     GIR_RootConstrainSelectedInstOperands,
     /*  178892 */     // GIR_Coverage, 46080,
     /*  178892 */     GIR_EraseRootFromParent_Done,
     /*  178893 */   // Label 3396: @178893
     /*  178893 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(178920), // Rule ID 46081 //
     /*  178898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178901 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  178901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  178904 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  178914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178918 */     GIR_RootConstrainSelectedInstOperands,
     /*  178919 */     // GIR_Coverage, 46081,
     /*  178919 */     GIR_EraseRootFromParent_Done,
     /*  178920 */   // Label 3397: @178920
     /*  178920 */   GIM_Reject,
     /*  178921 */ // Label 3395: @178921
     /*  178921 */ GIM_Reject,
     /*  178922 */ // Label 3214: @178922
     /*  178922 */ GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(179009),
     /*  178927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  178930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  178934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  178938 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(178973), // Rule ID 45960 //
     /*  178943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  178946 */     // MIs[0] rs1
     /*  178946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178954 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  178954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  178957 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  178967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178971 */     GIR_RootConstrainSelectedInstOperands,
     /*  178972 */     // GIR_Coverage, 45960,
     /*  178972 */     GIR_EraseRootFromParent_Done,
     /*  178973 */   // Label 3399: @178973
     /*  178973 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(179008), // Rule ID 45961 //
     /*  178978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  178981 */     // MIs[0] rs1
     /*  178981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  178985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178989 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  178994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  178996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  178999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179006 */     GIR_RootConstrainSelectedInstOperands,
     /*  179007 */     // GIR_Coverage, 45961,
     /*  179007 */     GIR_EraseRootFromParent_Done,
     /*  179008 */   // Label 3400: @179008
     /*  179008 */   GIM_Reject,
     /*  179009 */ // Label 3398: @179009
     /*  179009 */ GIM_Reject,
     /*  179010 */ // Label 3215: @179010
     /*  179010 */ GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(179167),
     /*  179015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179026 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(179061), // Rule ID 45976 //
     /*  179031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179034 */     // MIs[0] rs1
     /*  179034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179042 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  179042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179045 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179059 */     GIR_RootConstrainSelectedInstOperands,
     /*  179060 */     // GIR_Coverage, 45976,
     /*  179060 */     GIR_EraseRootFromParent_Done,
     /*  179061 */   // Label 3402: @179061
     /*  179061 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(179096), // Rule ID 45977 //
     /*  179066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179069 */     // MIs[0] rs1
     /*  179069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179077 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  179077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179080 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179094 */     GIR_RootConstrainSelectedInstOperands,
     /*  179095 */     // GIR_Coverage, 45977,
     /*  179095 */     GIR_EraseRootFromParent_Done,
     /*  179096 */   // Label 3403: @179096
     /*  179096 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(179131), // Rule ID 46036 //
     /*  179101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  179104 */     // MIs[0] rs1
     /*  179104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179112 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  179112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179115 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179129 */     GIR_RootConstrainSelectedInstOperands,
     /*  179130 */     // GIR_Coverage, 46036,
     /*  179130 */     GIR_EraseRootFromParent_Done,
     /*  179131 */   // Label 3404: @179131
     /*  179131 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(179166), // Rule ID 46037 //
     /*  179136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  179139 */     // MIs[0] rs1
     /*  179139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179147 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  179147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  179150 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179164 */     GIR_RootConstrainSelectedInstOperands,
     /*  179165 */     // GIR_Coverage, 46037,
     /*  179165 */     GIR_EraseRootFromParent_Done,
     /*  179166 */   // Label 3405: @179166
     /*  179166 */   GIM_Reject,
     /*  179167 */ // Label 3401: @179167
     /*  179167 */ GIM_Reject,
     /*  179168 */ // Label 3216: @179168
     /*  179168 */ GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(179247),
     /*  179173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  179184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179192 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(179219), // Rule ID 46084 //
     /*  179197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179200 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  179200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  179203 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  179213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179217 */     GIR_RootConstrainSelectedInstOperands,
     /*  179218 */     // GIR_Coverage, 46084,
     /*  179218 */     GIR_EraseRootFromParent_Done,
     /*  179219 */   // Label 3407: @179219
     /*  179219 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(179246), // Rule ID 46085 //
     /*  179224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179227 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  179227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  179230 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  179240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179244 */     GIR_RootConstrainSelectedInstOperands,
     /*  179245 */     // GIR_Coverage, 46085,
     /*  179245 */     GIR_EraseRootFromParent_Done,
     /*  179246 */   // Label 3408: @179246
     /*  179246 */   GIM_Reject,
     /*  179247 */ // Label 3406: @179247
     /*  179247 */ GIM_Reject,
     /*  179248 */ // Label 3217: @179248
     /*  179248 */ GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(179335),
     /*  179253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  179256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  179260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  179264 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(179299), // Rule ID 45964 //
     /*  179269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  179272 */     // MIs[0] rs1
     /*  179272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179280 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  179280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  179283 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179297 */     GIR_RootConstrainSelectedInstOperands,
     /*  179298 */     // GIR_Coverage, 45964,
     /*  179298 */     GIR_EraseRootFromParent_Done,
     /*  179299 */   // Label 3410: @179299
     /*  179299 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(179334), // Rule ID 45965 //
     /*  179304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  179307 */     // MIs[0] rs1
     /*  179307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179315 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  179315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  179318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  179320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  179322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  179325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  179328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179332 */     GIR_RootConstrainSelectedInstOperands,
     /*  179333 */     // GIR_Coverage, 45965,
     /*  179333 */     GIR_EraseRootFromParent_Done,
     /*  179334 */   // Label 3411: @179334
     /*  179334 */   GIM_Reject,
     /*  179335 */ // Label 3409: @179335
     /*  179335 */ GIM_Reject,
     /*  179336 */ // Label 3218: @179336
     /*  179336 */ GIM_Reject,
     /*  179337 */ // Label 25: @179337
     /*  179337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3414*/ GIMT_Encode4(184222),
     /*  179348 */ /*GILLT_s32*//*Label 3412*/ GIMT_Encode4(179356),
     /*  179352 */ /*GILLT_s64*//*Label 3413*/ GIMT_Encode4(181349),
     /*  179356 */ // Label 3412: @179356
     /*  179356 */ GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(181348),
     /*  179361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  179364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  179367 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(179433), // Rule ID 643 //
     /*  179372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179375 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179382 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179389 */     // MIs[0] addr
     /*  179389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179405 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  179405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179413 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179418 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179420 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179422 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  179427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179431 */     GIR_RootConstrainSelectedInstOperands,
     /*  179432 */     // GIR_Coverage, 643,
     /*  179432 */     GIR_EraseRootFromParent_Done,
     /*  179433 */   // Label 3416: @179433
     /*  179433 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(179499), // Rule ID 645 //
     /*  179438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179455 */     // MIs[0] addr
     /*  179455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179471 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  179471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179479 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179484 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179486 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179488 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  179493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179497 */     GIR_RootConstrainSelectedInstOperands,
     /*  179498 */     // GIR_Coverage, 645,
     /*  179498 */     GIR_EraseRootFromParent_Done,
     /*  179499 */   // Label 3417: @179499
     /*  179499 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(179565), // Rule ID 647 //
     /*  179504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179521 */     // MIs[0] addr
     /*  179521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179537 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  179537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179545 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179550 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179552 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179554 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  179559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179563 */     GIR_RootConstrainSelectedInstOperands,
     /*  179564 */     // GIR_Coverage, 647,
     /*  179564 */     GIR_EraseRootFromParent_Done,
     /*  179565 */   // Label 3418: @179565
     /*  179565 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(179631), // Rule ID 649 //
     /*  179570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179587 */     // MIs[0] addr
     /*  179587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179603 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  179603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179611 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179616 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179618 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179620 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  179625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179629 */     GIR_RootConstrainSelectedInstOperands,
     /*  179630 */     // GIR_Coverage, 649,
     /*  179630 */     GIR_EraseRootFromParent_Done,
     /*  179631 */   // Label 3419: @179631
     /*  179631 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(179697), // Rule ID 651 //
     /*  179636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  179639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179653 */     // MIs[0] addr
     /*  179653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  179657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179669 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  179669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  179672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  179675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  179677 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  179682 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179684 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179686 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  179691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179695 */     GIR_RootConstrainSelectedInstOperands,
     /*  179696 */     // GIR_Coverage, 651,
     /*  179696 */     GIR_EraseRootFromParent_Done,
     /*  179697 */   // Label 3420: @179697
     /*  179697 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(179752), // Rule ID 660 //
     /*  179702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179719 */     // MIs[0] addr
     /*  179719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179735 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  179738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179740 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179742 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179744 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179750 */     GIR_RootConstrainSelectedInstOperands,
     /*  179751 */     // GIR_Coverage, 660,
     /*  179751 */     GIR_EraseRootFromParent_Done,
     /*  179752 */   // Label 3421: @179752
     /*  179752 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(179807), // Rule ID 662 //
     /*  179757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179774 */     // MIs[0] addr
     /*  179774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179790 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  179793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179795 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179797 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179799 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179805 */     GIR_RootConstrainSelectedInstOperands,
     /*  179806 */     // GIR_Coverage, 662,
     /*  179806 */     GIR_EraseRootFromParent_Done,
     /*  179807 */   // Label 3422: @179807
     /*  179807 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(179862), // Rule ID 664 //
     /*  179812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179829 */     // MIs[0] addr
     /*  179829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179845 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  179848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179850 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179852 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179854 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179860 */     GIR_RootConstrainSelectedInstOperands,
     /*  179861 */     // GIR_Coverage, 664,
     /*  179861 */     GIR_EraseRootFromParent_Done,
     /*  179862 */   // Label 3423: @179862
     /*  179862 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(179917), // Rule ID 666 //
     /*  179867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179884 */     // MIs[0] addr
     /*  179884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179900 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  179903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179905 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179907 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179909 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179915 */     GIR_RootConstrainSelectedInstOperands,
     /*  179916 */     // GIR_Coverage, 666,
     /*  179916 */     GIR_EraseRootFromParent_Done,
     /*  179917 */   // Label 3424: @179917
     /*  179917 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(179972), // Rule ID 668 //
     /*  179922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  179925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179939 */     // MIs[0] addr
     /*  179939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179955 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  179955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  179958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179960 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179962 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179964 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179970 */     GIR_RootConstrainSelectedInstOperands,
     /*  179971 */     // GIR_Coverage, 668,
     /*  179971 */     GIR_EraseRootFromParent_Done,
     /*  179972 */   // Label 3425: @179972
     /*  179972 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(180027), // Rule ID 670 //
     /*  179977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  179980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179994 */     // MIs[0] addr
     /*  179994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180010 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180015 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180017 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180019 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180025 */     GIR_RootConstrainSelectedInstOperands,
     /*  180026 */     // GIR_Coverage, 670,
     /*  180026 */     GIR_EraseRootFromParent_Done,
     /*  180027 */   // Label 3426: @180027
     /*  180027 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(180082), // Rule ID 672 //
     /*  180032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180049 */     // MIs[0] addr
     /*  180049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180065 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180070 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180072 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180074 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180080 */     GIR_RootConstrainSelectedInstOperands,
     /*  180081 */     // GIR_Coverage, 672,
     /*  180081 */     GIR_EraseRootFromParent_Done,
     /*  180082 */   // Label 3427: @180082
     /*  180082 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(180137), // Rule ID 674 //
     /*  180087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180104 */     // MIs[0] addr
     /*  180104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180120 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180125 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180127 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180129 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180135 */     GIR_RootConstrainSelectedInstOperands,
     /*  180136 */     // GIR_Coverage, 674,
     /*  180136 */     GIR_EraseRootFromParent_Done,
     /*  180137 */   // Label 3428: @180137
     /*  180137 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(180192), // Rule ID 676 //
     /*  180142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180159 */     // MIs[0] addr
     /*  180159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180175 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180180 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180182 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180184 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180190 */     GIR_RootConstrainSelectedInstOperands,
     /*  180191 */     // GIR_Coverage, 676,
     /*  180191 */     GIR_EraseRootFromParent_Done,
     /*  180192 */   // Label 3429: @180192
     /*  180192 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(180247), // Rule ID 678 //
     /*  180197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180214 */     // MIs[0] addr
     /*  180214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180230 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  180233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180235 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180237 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180239 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180245 */     GIR_RootConstrainSelectedInstOperands,
     /*  180246 */     // GIR_Coverage, 678,
     /*  180246 */     GIR_EraseRootFromParent_Done,
     /*  180247 */   // Label 3430: @180247
     /*  180247 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(180302), // Rule ID 1050 //
     /*  180252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180269 */     // MIs[0] addr
     /*  180269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180285 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180292 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180294 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180300 */     GIR_RootConstrainSelectedInstOperands,
     /*  180301 */     // GIR_Coverage, 1050,
     /*  180301 */     GIR_EraseRootFromParent_Done,
     /*  180302 */   // Label 3431: @180302
     /*  180302 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(180357), // Rule ID 1052 //
     /*  180307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180324 */     // MIs[0] addr
     /*  180324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180340 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  180343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180345 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180347 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180349 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180355 */     GIR_RootConstrainSelectedInstOperands,
     /*  180356 */     // GIR_Coverage, 1052,
     /*  180356 */     GIR_EraseRootFromParent_Done,
     /*  180357 */   // Label 3432: @180357
     /*  180357 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(180412), // Rule ID 1054 //
     /*  180362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180379 */     // MIs[0] addr
     /*  180379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180395 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  180398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180400 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180402 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180404 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180410 */     GIR_RootConstrainSelectedInstOperands,
     /*  180411 */     // GIR_Coverage, 1054,
     /*  180411 */     GIR_EraseRootFromParent_Done,
     /*  180412 */   // Label 3433: @180412
     /*  180412 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(180467), // Rule ID 1056 //
     /*  180417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180434 */     // MIs[0] addr
     /*  180434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180450 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180455 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180457 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180459 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180465 */     GIR_RootConstrainSelectedInstOperands,
     /*  180466 */     // GIR_Coverage, 1056,
     /*  180466 */     GIR_EraseRootFromParent_Done,
     /*  180467 */   // Label 3434: @180467
     /*  180467 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(180522), // Rule ID 1058 //
     /*  180472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180489 */     // MIs[0] addr
     /*  180489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180505 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  180508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180510 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180512 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180514 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180520 */     GIR_RootConstrainSelectedInstOperands,
     /*  180521 */     // GIR_Coverage, 1058,
     /*  180521 */     GIR_EraseRootFromParent_Done,
     /*  180522 */   // Label 3435: @180522
     /*  180522 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(180577), // Rule ID 1060 //
     /*  180527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180537 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180544 */     // MIs[0] addr
     /*  180544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180560 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180565 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180567 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180569 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180575 */     GIR_RootConstrainSelectedInstOperands,
     /*  180576 */     // GIR_Coverage, 1060,
     /*  180576 */     GIR_EraseRootFromParent_Done,
     /*  180577 */   // Label 3436: @180577
     /*  180577 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(180632), // Rule ID 1062 //
     /*  180582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180599 */     // MIs[0] addr
     /*  180599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180615 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180620 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180622 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180624 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180630 */     GIR_RootConstrainSelectedInstOperands,
     /*  180631 */     // GIR_Coverage, 1062,
     /*  180631 */     GIR_EraseRootFromParent_Done,
     /*  180632 */   // Label 3437: @180632
     /*  180632 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(180687), // Rule ID 1064 //
     /*  180637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180654 */     // MIs[0] addr
     /*  180654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180670 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180675 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180677 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180679 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180685 */     GIR_RootConstrainSelectedInstOperands,
     /*  180686 */     // GIR_Coverage, 1064,
     /*  180686 */     GIR_EraseRootFromParent_Done,
     /*  180687 */   // Label 3438: @180687
     /*  180687 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(180742), // Rule ID 1066 //
     /*  180692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180709 */     // MIs[0] addr
     /*  180709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180725 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180730 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180732 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180734 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180740 */     GIR_RootConstrainSelectedInstOperands,
     /*  180741 */     // GIR_Coverage, 1066,
     /*  180741 */     GIR_EraseRootFromParent_Done,
     /*  180742 */   // Label 3439: @180742
     /*  180742 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(180797), // Rule ID 1068 //
     /*  180747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  180750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180764 */     // MIs[0] addr
     /*  180764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180780 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  180783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180785 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180787 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180789 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180795 */     GIR_RootConstrainSelectedInstOperands,
     /*  180796 */     // GIR_Coverage, 1068,
     /*  180796 */     GIR_EraseRootFromParent_Done,
     /*  180797 */   // Label 3440: @180797
     /*  180797 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(180852), // Rule ID 1070 //
     /*  180802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180819 */     // MIs[0] addr
     /*  180819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180835 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180840 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180842 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180844 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180850 */     GIR_RootConstrainSelectedInstOperands,
     /*  180851 */     // GIR_Coverage, 1070,
     /*  180851 */     GIR_EraseRootFromParent_Done,
     /*  180852 */   // Label 3441: @180852
     /*  180852 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(180907), // Rule ID 1072 //
     /*  180857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180874 */     // MIs[0] addr
     /*  180874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180890 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  180893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180895 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180897 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180899 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180905 */     GIR_RootConstrainSelectedInstOperands,
     /*  180906 */     // GIR_Coverage, 1072,
     /*  180906 */     GIR_EraseRootFromParent_Done,
     /*  180907 */   // Label 3442: @180907
     /*  180907 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(180962), // Rule ID 1074 //
     /*  180912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180929 */     // MIs[0] addr
     /*  180929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180945 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  180945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  180948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180950 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180952 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180954 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180960 */     GIR_RootConstrainSelectedInstOperands,
     /*  180961 */     // GIR_Coverage, 1074,
     /*  180961 */     GIR_EraseRootFromParent_Done,
     /*  180962 */   // Label 3443: @180962
     /*  180962 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(181017), // Rule ID 1076 //
     /*  180967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  180970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180984 */     // MIs[0] addr
     /*  180984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181000 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  181003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181005 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181007 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181009 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181015 */     GIR_RootConstrainSelectedInstOperands,
     /*  181016 */     // GIR_Coverage, 1076,
     /*  181016 */     GIR_EraseRootFromParent_Done,
     /*  181017 */   // Label 3444: @181017
     /*  181017 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(181072), // Rule ID 1078 //
     /*  181022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  181025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181039 */     // MIs[0] addr
     /*  181039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181055 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  181058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181060 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181062 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181064 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181070 */     GIR_RootConstrainSelectedInstOperands,
     /*  181071 */     // GIR_Coverage, 1078,
     /*  181071 */     GIR_EraseRootFromParent_Done,
     /*  181072 */   // Label 3445: @181072
     /*  181072 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(181127), // Rule ID 1080 //
     /*  181077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181094 */     // MIs[0] addr
     /*  181094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181110 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181115 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181117 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181119 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181125 */     GIR_RootConstrainSelectedInstOperands,
     /*  181126 */     // GIR_Coverage, 1080,
     /*  181126 */     GIR_EraseRootFromParent_Done,
     /*  181127 */   // Label 3446: @181127
     /*  181127 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(181182), // Rule ID 1082 //
     /*  181132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181135 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181149 */     // MIs[0] addr
     /*  181149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181165 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181170 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181172 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181174 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181180 */     GIR_RootConstrainSelectedInstOperands,
     /*  181181 */     // GIR_Coverage, 1082,
     /*  181181 */     GIR_EraseRootFromParent_Done,
     /*  181182 */   // Label 3447: @181182
     /*  181182 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(181237), // Rule ID 1084 //
     /*  181187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181204 */     // MIs[0] addr
     /*  181204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181220 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181225 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181227 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181229 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181235 */     GIR_RootConstrainSelectedInstOperands,
     /*  181236 */     // GIR_Coverage, 1084,
     /*  181236 */     GIR_EraseRootFromParent_Done,
     /*  181237 */   // Label 3448: @181237
     /*  181237 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(181292), // Rule ID 1086 //
     /*  181242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181259 */     // MIs[0] addr
     /*  181259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181275 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181280 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181282 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181284 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181290 */     GIR_RootConstrainSelectedInstOperands,
     /*  181291 */     // GIR_Coverage, 1086,
     /*  181291 */     GIR_EraseRootFromParent_Done,
     /*  181292 */   // Label 3449: @181292
     /*  181292 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(181347), // Rule ID 1088 //
     /*  181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  181300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181314 */     // MIs[0] addr
     /*  181314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181330 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  181330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  181333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  181335 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181337 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181339 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181345 */     GIR_RootConstrainSelectedInstOperands,
     /*  181346 */     // GIR_Coverage, 1088,
     /*  181346 */     GIR_EraseRootFromParent_Done,
     /*  181347 */   // Label 3450: @181347
     /*  181347 */   GIM_Reject,
     /*  181348 */ // Label 3415: @181348
     /*  181348 */ GIM_Reject,
     /*  181349 */ // Label 3413: @181349
     /*  181349 */ GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(184221),
     /*  181354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  181357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  181360 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(181426), // Rule ID 642 //
     /*  181365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181382 */     // MIs[0] addr
     /*  181382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181398 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  181398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181406 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181411 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181413 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181415 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  181420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181424 */     GIR_RootConstrainSelectedInstOperands,
     /*  181425 */     // GIR_Coverage, 642,
     /*  181425 */     GIR_EraseRootFromParent_Done,
     /*  181426 */   // Label 3452: @181426
     /*  181426 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(181492), // Rule ID 644 //
     /*  181431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181448 */     // MIs[0] addr
     /*  181448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181464 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  181464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181472 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181477 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181479 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181481 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181490 */     GIR_RootConstrainSelectedInstOperands,
     /*  181491 */     // GIR_Coverage, 644,
     /*  181491 */     GIR_EraseRootFromParent_Done,
     /*  181492 */   // Label 3453: @181492
     /*  181492 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(181558), // Rule ID 646 //
     /*  181497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181500 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181514 */     // MIs[0] addr
     /*  181514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181530 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  181530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181538 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181543 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181545 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181547 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181556 */     GIR_RootConstrainSelectedInstOperands,
     /*  181557 */     // GIR_Coverage, 646,
     /*  181557 */     GIR_EraseRootFromParent_Done,
     /*  181558 */   // Label 3454: @181558
     /*  181558 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(181624), // Rule ID 648 //
     /*  181563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181580 */     // MIs[0] addr
     /*  181580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181596 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  181596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181604 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181609 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181611 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181613 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  181618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181622 */     GIR_RootConstrainSelectedInstOperands,
     /*  181623 */     // GIR_Coverage, 648,
     /*  181623 */     GIR_EraseRootFromParent_Done,
     /*  181624 */   // Label 3455: @181624
     /*  181624 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(181690), // Rule ID 650 //
     /*  181629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  181632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181646 */     // MIs[0] addr
     /*  181646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181662 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  181662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  181668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181670 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181675 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181677 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181679 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  181684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181688 */     GIR_RootConstrainSelectedInstOperands,
     /*  181689 */     // GIR_Coverage, 650,
     /*  181689 */     GIR_EraseRootFromParent_Done,
     /*  181690 */   // Label 3456: @181690
     /*  181690 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(181756), // Rule ID 652 //
     /*  181695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181712 */     // MIs[0] addr
     /*  181712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181728 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  181728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181736 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181741 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181743 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181745 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  181750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181754 */     GIR_RootConstrainSelectedInstOperands,
     /*  181755 */     // GIR_Coverage, 652,
     /*  181755 */     GIR_EraseRootFromParent_Done,
     /*  181756 */   // Label 3457: @181756
     /*  181756 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(181822), // Rule ID 653 //
     /*  181761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181778 */     // MIs[0] addr
     /*  181778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181794 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  181794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181802 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181807 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181809 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181811 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  181816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181820 */     GIR_RootConstrainSelectedInstOperands,
     /*  181821 */     // GIR_Coverage, 653,
     /*  181821 */     GIR_EraseRootFromParent_Done,
     /*  181822 */   // Label 3458: @181822
     /*  181822 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(181888), // Rule ID 654 //
     /*  181827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181844 */     // MIs[0] addr
     /*  181844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181860 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  181860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181868 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181873 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181875 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181877 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  181882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181886 */     GIR_RootConstrainSelectedInstOperands,
     /*  181887 */     // GIR_Coverage, 654,
     /*  181887 */     GIR_EraseRootFromParent_Done,
     /*  181888 */   // Label 3459: @181888
     /*  181888 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(181954), // Rule ID 655 //
     /*  181893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181910 */     // MIs[0] addr
     /*  181910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181926 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  181926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  181934 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  181939 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  181941 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  181943 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  181945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  181948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  181952 */     GIR_RootConstrainSelectedInstOperands,
     /*  181953 */     // GIR_Coverage, 655,
     /*  181953 */     GIR_EraseRootFromParent_Done,
     /*  181954 */   // Label 3460: @181954
     /*  181954 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(182020), // Rule ID 656 //
     /*  181959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  181962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181976 */     // MIs[0] addr
     /*  181976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  181980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181992 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  181992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  181995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  181998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  182000 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  182005 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182007 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182009 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  182014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182018 */     GIR_RootConstrainSelectedInstOperands,
     /*  182019 */     // GIR_Coverage, 656,
     /*  182019 */     GIR_EraseRootFromParent_Done,
     /*  182020 */   // Label 3461: @182020
     /*  182020 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(182075), // Rule ID 659 //
     /*  182025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182035 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182042 */     // MIs[0] addr
     /*  182042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182058 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182063 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182065 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182067 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182073 */     GIR_RootConstrainSelectedInstOperands,
     /*  182074 */     // GIR_Coverage, 659,
     /*  182074 */     GIR_EraseRootFromParent_Done,
     /*  182075 */   // Label 3462: @182075
     /*  182075 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(182130), // Rule ID 661 //
     /*  182080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182097 */     // MIs[0] addr
     /*  182097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182113 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  182116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182118 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182120 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182122 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182128 */     GIR_RootConstrainSelectedInstOperands,
     /*  182129 */     // GIR_Coverage, 661,
     /*  182129 */     GIR_EraseRootFromParent_Done,
     /*  182130 */   // Label 3463: @182130
     /*  182130 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(182185), // Rule ID 663 //
     /*  182135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182152 */     // MIs[0] addr
     /*  182152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182168 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  182171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182173 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182175 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182177 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182183 */     GIR_RootConstrainSelectedInstOperands,
     /*  182184 */     // GIR_Coverage, 663,
     /*  182184 */     GIR_EraseRootFromParent_Done,
     /*  182185 */   // Label 3464: @182185
     /*  182185 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(182240), // Rule ID 665 //
     /*  182190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182207 */     // MIs[0] addr
     /*  182207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182223 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  182226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182228 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182230 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182232 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182238 */     GIR_RootConstrainSelectedInstOperands,
     /*  182239 */     // GIR_Coverage, 665,
     /*  182239 */     GIR_EraseRootFromParent_Done,
     /*  182240 */   // Label 3465: @182240
     /*  182240 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(182295), // Rule ID 667 //
     /*  182245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  182248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182262 */     // MIs[0] addr
     /*  182262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182278 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  182281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182283 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182285 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182287 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182293 */     GIR_RootConstrainSelectedInstOperands,
     /*  182294 */     // GIR_Coverage, 667,
     /*  182294 */     GIR_EraseRootFromParent_Done,
     /*  182295 */   // Label 3466: @182295
     /*  182295 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(182350), // Rule ID 669 //
     /*  182300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182317 */     // MIs[0] addr
     /*  182317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182333 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182338 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182340 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182342 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182348 */     GIR_RootConstrainSelectedInstOperands,
     /*  182349 */     // GIR_Coverage, 669,
     /*  182349 */     GIR_EraseRootFromParent_Done,
     /*  182350 */   // Label 3467: @182350
     /*  182350 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(182405), // Rule ID 671 //
     /*  182355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182358 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182372 */     // MIs[0] addr
     /*  182372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182388 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182393 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182395 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182397 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182403 */     GIR_RootConstrainSelectedInstOperands,
     /*  182404 */     // GIR_Coverage, 671,
     /*  182404 */     GIR_EraseRootFromParent_Done,
     /*  182405 */   // Label 3468: @182405
     /*  182405 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(182460), // Rule ID 673 //
     /*  182410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182427 */     // MIs[0] addr
     /*  182427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182443 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182448 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182450 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182452 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182458 */     GIR_RootConstrainSelectedInstOperands,
     /*  182459 */     // GIR_Coverage, 673,
     /*  182459 */     GIR_EraseRootFromParent_Done,
     /*  182460 */   // Label 3469: @182460
     /*  182460 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(182515), // Rule ID 675 //
     /*  182465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182482 */     // MIs[0] addr
     /*  182482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182498 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182503 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182505 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182507 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182513 */     GIR_RootConstrainSelectedInstOperands,
     /*  182514 */     // GIR_Coverage, 675,
     /*  182514 */     GIR_EraseRootFromParent_Done,
     /*  182515 */   // Label 3470: @182515
     /*  182515 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(182570), // Rule ID 677 //
     /*  182520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  182523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182537 */     // MIs[0] addr
     /*  182537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182553 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  182556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182558 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182560 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182562 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182568 */     GIR_RootConstrainSelectedInstOperands,
     /*  182569 */     // GIR_Coverage, 677,
     /*  182569 */     GIR_EraseRootFromParent_Done,
     /*  182570 */   // Label 3471: @182570
     /*  182570 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(182625), // Rule ID 679 //
     /*  182575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182592 */     // MIs[0] addr
     /*  182592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182608 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182613 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182615 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182617 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182623 */     GIR_RootConstrainSelectedInstOperands,
     /*  182624 */     // GIR_Coverage, 679,
     /*  182624 */     GIR_EraseRootFromParent_Done,
     /*  182625 */   // Label 3472: @182625
     /*  182625 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(182680), // Rule ID 680 //
     /*  182630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182647 */     // MIs[0] addr
     /*  182647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182663 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  182666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182668 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182670 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182672 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182678 */     GIR_RootConstrainSelectedInstOperands,
     /*  182679 */     // GIR_Coverage, 680,
     /*  182679 */     GIR_EraseRootFromParent_Done,
     /*  182680 */   // Label 3473: @182680
     /*  182680 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(182735), // Rule ID 681 //
     /*  182685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182702 */     // MIs[0] addr
     /*  182702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182718 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  182721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182723 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182725 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182727 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182733 */     GIR_RootConstrainSelectedInstOperands,
     /*  182734 */     // GIR_Coverage, 681,
     /*  182734 */     GIR_EraseRootFromParent_Done,
     /*  182735 */   // Label 3474: @182735
     /*  182735 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(182790), // Rule ID 682 //
     /*  182740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182757 */     // MIs[0] addr
     /*  182757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182773 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  182776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182778 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182780 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182782 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182788 */     GIR_RootConstrainSelectedInstOperands,
     /*  182789 */     // GIR_Coverage, 682,
     /*  182789 */     GIR_EraseRootFromParent_Done,
     /*  182790 */   // Label 3475: @182790
     /*  182790 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(182845), // Rule ID 683 //
     /*  182795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182812 */     // MIs[0] addr
     /*  182812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182828 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  182831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182833 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182835 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182837 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182843 */     GIR_RootConstrainSelectedInstOperands,
     /*  182844 */     // GIR_Coverage, 683,
     /*  182844 */     GIR_EraseRootFromParent_Done,
     /*  182845 */   // Label 3476: @182845
     /*  182845 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(182900), // Rule ID 684 //
     /*  182850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182867 */     // MIs[0] addr
     /*  182867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182883 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182888 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182890 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182892 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182898 */     GIR_RootConstrainSelectedInstOperands,
     /*  182899 */     // GIR_Coverage, 684,
     /*  182899 */     GIR_EraseRootFromParent_Done,
     /*  182900 */   // Label 3477: @182900
     /*  182900 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(182955), // Rule ID 685 //
     /*  182905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182922 */     // MIs[0] addr
     /*  182922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182938 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182943 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  182945 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  182947 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  182949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  182953 */     GIR_RootConstrainSelectedInstOperands,
     /*  182954 */     // GIR_Coverage, 685,
     /*  182954 */     GIR_EraseRootFromParent_Done,
     /*  182955 */   // Label 3478: @182955
     /*  182955 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(183010), // Rule ID 686 //
     /*  182960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  182963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182977 */     // MIs[0] addr
     /*  182977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182993 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  182998 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183000 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183002 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183008 */     GIR_RootConstrainSelectedInstOperands,
     /*  183009 */     // GIR_Coverage, 686,
     /*  183009 */     GIR_EraseRootFromParent_Done,
     /*  183010 */   // Label 3479: @183010
     /*  183010 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(183065), // Rule ID 687 //
     /*  183015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  183018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  183025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183032 */     // MIs[0] addr
     /*  183032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183048 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  183051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183053 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183055 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183057 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183063 */     GIR_RootConstrainSelectedInstOperands,
     /*  183064 */     // GIR_Coverage, 687,
     /*  183064 */     GIR_EraseRootFromParent_Done,
     /*  183065 */   // Label 3480: @183065
     /*  183065 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(183120), // Rule ID 688 //
     /*  183070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  183073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  183080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183087 */     // MIs[0] addr
     /*  183087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183103 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  183106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183108 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183110 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183112 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183118 */     GIR_RootConstrainSelectedInstOperands,
     /*  183119 */     // GIR_Coverage, 688,
     /*  183119 */     GIR_EraseRootFromParent_Done,
     /*  183120 */   // Label 3481: @183120
     /*  183120 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(183175), // Rule ID 1049 //
     /*  183125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183128 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183135 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183142 */     // MIs[0] addr
     /*  183142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183158 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183163 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183165 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183167 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183173 */     GIR_RootConstrainSelectedInstOperands,
     /*  183174 */     // GIR_Coverage, 1049,
     /*  183174 */     GIR_EraseRootFromParent_Done,
     /*  183175 */   // Label 3482: @183175
     /*  183175 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(183230), // Rule ID 1051 //
     /*  183180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183183 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183197 */     // MIs[0] addr
     /*  183197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183213 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  183216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183218 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183220 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183222 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183228 */     GIR_RootConstrainSelectedInstOperands,
     /*  183229 */     // GIR_Coverage, 1051,
     /*  183229 */     GIR_EraseRootFromParent_Done,
     /*  183230 */   // Label 3483: @183230
     /*  183230 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(183285), // Rule ID 1053 //
     /*  183235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183252 */     // MIs[0] addr
     /*  183252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183268 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  183271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183273 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183275 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183277 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183283 */     GIR_RootConstrainSelectedInstOperands,
     /*  183284 */     // GIR_Coverage, 1053,
     /*  183284 */     GIR_EraseRootFromParent_Done,
     /*  183285 */   // Label 3484: @183285
     /*  183285 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(183340), // Rule ID 1055 //
     /*  183290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183307 */     // MIs[0] addr
     /*  183307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183323 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  183326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183328 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183330 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183332 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183338 */     GIR_RootConstrainSelectedInstOperands,
     /*  183339 */     // GIR_Coverage, 1055,
     /*  183339 */     GIR_EraseRootFromParent_Done,
     /*  183340 */   // Label 3485: @183340
     /*  183340 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(183395), // Rule ID 1057 //
     /*  183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183362 */     // MIs[0] addr
     /*  183362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183378 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  183381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183383 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183385 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183387 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183393 */     GIR_RootConstrainSelectedInstOperands,
     /*  183394 */     // GIR_Coverage, 1057,
     /*  183394 */     GIR_EraseRootFromParent_Done,
     /*  183395 */   // Label 3486: @183395
     /*  183395 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(183450), // Rule ID 1059 //
     /*  183400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183417 */     // MIs[0] addr
     /*  183417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183433 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183438 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183440 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183442 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183448 */     GIR_RootConstrainSelectedInstOperands,
     /*  183449 */     // GIR_Coverage, 1059,
     /*  183449 */     GIR_EraseRootFromParent_Done,
     /*  183450 */   // Label 3487: @183450
     /*  183450 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(183505), // Rule ID 1061 //
     /*  183455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183472 */     // MIs[0] addr
     /*  183472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183488 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183493 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183495 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183497 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183503 */     GIR_RootConstrainSelectedInstOperands,
     /*  183504 */     // GIR_Coverage, 1061,
     /*  183504 */     GIR_EraseRootFromParent_Done,
     /*  183505 */   // Label 3488: @183505
     /*  183505 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(183560), // Rule ID 1063 //
     /*  183510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183527 */     // MIs[0] addr
     /*  183527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183543 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183548 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183550 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183552 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183558 */     GIR_RootConstrainSelectedInstOperands,
     /*  183559 */     // GIR_Coverage, 1063,
     /*  183559 */     GIR_EraseRootFromParent_Done,
     /*  183560 */   // Label 3489: @183560
     /*  183560 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(183615), // Rule ID 1065 //
     /*  183565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183582 */     // MIs[0] addr
     /*  183582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183598 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183603 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183605 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183607 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183613 */     GIR_RootConstrainSelectedInstOperands,
     /*  183614 */     // GIR_Coverage, 1065,
     /*  183614 */     GIR_EraseRootFromParent_Done,
     /*  183615 */   // Label 3490: @183615
     /*  183615 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(183670), // Rule ID 1067 //
     /*  183620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183637 */     // MIs[0] addr
     /*  183637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183653 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  183656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183658 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183660 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183662 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183668 */     GIR_RootConstrainSelectedInstOperands,
     /*  183669 */     // GIR_Coverage, 1067,
     /*  183669 */     GIR_EraseRootFromParent_Done,
     /*  183670 */   // Label 3491: @183670
     /*  183670 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(183725), // Rule ID 1069 //
     /*  183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183678 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183685 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183692 */     // MIs[0] addr
     /*  183692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183708 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  183711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183713 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183715 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183717 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183723 */     GIR_RootConstrainSelectedInstOperands,
     /*  183724 */     // GIR_Coverage, 1069,
     /*  183724 */     GIR_EraseRootFromParent_Done,
     /*  183725 */   // Label 3492: @183725
     /*  183725 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(183780), // Rule ID 1071 //
     /*  183730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183747 */     // MIs[0] addr
     /*  183747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183763 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  183766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183768 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183770 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183772 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183778 */     GIR_RootConstrainSelectedInstOperands,
     /*  183779 */     // GIR_Coverage, 1071,
     /*  183779 */     GIR_EraseRootFromParent_Done,
     /*  183780 */   // Label 3493: @183780
     /*  183780 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(183835), // Rule ID 1073 //
     /*  183785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183802 */     // MIs[0] addr
     /*  183802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183818 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  183821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183823 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183825 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183827 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183833 */     GIR_RootConstrainSelectedInstOperands,
     /*  183834 */     // GIR_Coverage, 1073,
     /*  183834 */     GIR_EraseRootFromParent_Done,
     /*  183835 */   // Label 3494: @183835
     /*  183835 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(183890), // Rule ID 1075 //
     /*  183840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183857 */     // MIs[0] addr
     /*  183857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183873 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  183876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183878 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183880 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183882 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183888 */     GIR_RootConstrainSelectedInstOperands,
     /*  183889 */     // GIR_Coverage, 1075,
     /*  183889 */     GIR_EraseRootFromParent_Done,
     /*  183890 */   // Label 3495: @183890
     /*  183890 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(183945), // Rule ID 1077 //
     /*  183895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  183898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183912 */     // MIs[0] addr
     /*  183912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183928 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  183931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183933 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183935 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183937 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183943 */     GIR_RootConstrainSelectedInstOperands,
     /*  183944 */     // GIR_Coverage, 1077,
     /*  183944 */     GIR_EraseRootFromParent_Done,
     /*  183945 */   // Label 3496: @183945
     /*  183945 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(184000), // Rule ID 1079 //
     /*  183950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  183953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183967 */     // MIs[0] addr
     /*  183967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183983 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  183983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  183986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  183988 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  183990 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  183992 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  183994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  183998 */     GIR_RootConstrainSelectedInstOperands,
     /*  183999 */     // GIR_Coverage, 1079,
     /*  183999 */     GIR_EraseRootFromParent_Done,
     /*  184000 */   // Label 3497: @184000
     /*  184000 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(184055), // Rule ID 1081 //
     /*  184005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184022 */     // MIs[0] addr
     /*  184022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184038 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184043 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184045 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184047 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184053 */     GIR_RootConstrainSelectedInstOperands,
     /*  184054 */     // GIR_Coverage, 1081,
     /*  184054 */     GIR_EraseRootFromParent_Done,
     /*  184055 */   // Label 3498: @184055
     /*  184055 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(184110), // Rule ID 1083 //
     /*  184060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184077 */     // MIs[0] addr
     /*  184077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184093 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184098 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184100 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184102 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184108 */     GIR_RootConstrainSelectedInstOperands,
     /*  184109 */     // GIR_Coverage, 1083,
     /*  184109 */     GIR_EraseRootFromParent_Done,
     /*  184110 */   // Label 3499: @184110
     /*  184110 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(184165), // Rule ID 1085 //
     /*  184115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184132 */     // MIs[0] addr
     /*  184132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184148 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184153 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184155 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184157 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184163 */     GIR_RootConstrainSelectedInstOperands,
     /*  184164 */     // GIR_Coverage, 1085,
     /*  184164 */     GIR_EraseRootFromParent_Done,
     /*  184165 */   // Label 3500: @184165
     /*  184165 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(184220), // Rule ID 1087 //
     /*  184170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  184173 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184187 */     // MIs[0] addr
     /*  184187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184203 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  184203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  184206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  184208 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  184210 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  184212 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  184214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  184218 */     GIR_RootConstrainSelectedInstOperands,
     /*  184219 */     // GIR_Coverage, 1087,
     /*  184219 */     GIR_EraseRootFromParent_Done,
     /*  184220 */   // Label 3501: @184220
     /*  184220 */   GIM_Reject,
     /*  184221 */ // Label 3451: @184221
     /*  184221 */ GIM_Reject,
     /*  184222 */ // Label 3414: @184222
     /*  184222 */ GIM_Reject,
     /*  184223 */ // Label 26: @184223
     /*  184223 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3504*/ GIMT_Encode4(187132),
     /*  184234 */ /*GILLT_s32*//*Label 3502*/ GIMT_Encode4(184242),
     /*  184238 */ /*GILLT_s64*//*Label 3503*/ GIMT_Encode4(185482),
     /*  184242 */ // Label 3502: @184242
     /*  184242 */ GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(185481),
     /*  184247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  184250 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(184291), // Rule ID 342 //
     /*  184255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184258 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184272 */     // MIs[0] rs1
     /*  184272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184284 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184289 */     GIR_RootConstrainSelectedInstOperands,
     /*  184290 */     // GIR_Coverage, 342,
     /*  184290 */     GIR_Done,
     /*  184291 */   // Label 3506: @184291
     /*  184291 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(184332), // Rule ID 344 //
     /*  184296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184313 */     // MIs[0] rs1
     /*  184313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184325 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  184330 */     GIR_RootConstrainSelectedInstOperands,
     /*  184331 */     // GIR_Coverage, 344,
     /*  184331 */     GIR_Done,
     /*  184332 */   // Label 3507: @184332
     /*  184332 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(184373), // Rule ID 346 //
     /*  184337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184354 */     // MIs[0] rs1
     /*  184354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184366 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  184371 */     GIR_RootConstrainSelectedInstOperands,
     /*  184372 */     // GIR_Coverage, 346,
     /*  184372 */     GIR_Done,
     /*  184373 */   // Label 3508: @184373
     /*  184373 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(184414), // Rule ID 348 //
     /*  184378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184381 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184395 */     // MIs[0] rs1
     /*  184395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184407 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  184412 */     GIR_RootConstrainSelectedInstOperands,
     /*  184413 */     // GIR_Coverage, 348,
     /*  184413 */     GIR_Done,
     /*  184414 */   // Label 3509: @184414
     /*  184414 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(184455), // Rule ID 350 //
     /*  184419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  184422 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184429 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184436 */     // MIs[0] rs1
     /*  184436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184448 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  184453 */     GIR_RootConstrainSelectedInstOperands,
     /*  184454 */     // GIR_Coverage, 350,
     /*  184454 */     GIR_Done,
     /*  184455 */   // Label 3510: @184455
     /*  184455 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(184496), // Rule ID 352 //
     /*  184460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184463 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184477 */     // MIs[0] rs1
     /*  184477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184489 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184494 */     GIR_RootConstrainSelectedInstOperands,
     /*  184495 */     // GIR_Coverage, 352,
     /*  184495 */     GIR_Done,
     /*  184496 */   // Label 3511: @184496
     /*  184496 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(184537), // Rule ID 354 //
     /*  184501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184504 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184518 */     // MIs[0] rs1
     /*  184518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184530 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184535 */     GIR_RootConstrainSelectedInstOperands,
     /*  184536 */     // GIR_Coverage, 354,
     /*  184536 */     GIR_Done,
     /*  184537 */   // Label 3512: @184537
     /*  184537 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(184578), // Rule ID 356 //
     /*  184542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184559 */     // MIs[0] rs1
     /*  184559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184571 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184576 */     GIR_RootConstrainSelectedInstOperands,
     /*  184577 */     // GIR_Coverage, 356,
     /*  184577 */     GIR_Done,
     /*  184578 */   // Label 3513: @184578
     /*  184578 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(184619), // Rule ID 358 //
     /*  184583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184600 */     // MIs[0] rs1
     /*  184600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184612 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184617 */     GIR_RootConstrainSelectedInstOperands,
     /*  184618 */     // GIR_Coverage, 358,
     /*  184618 */     GIR_Done,
     /*  184619 */   // Label 3514: @184619
     /*  184619 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(184660), // Rule ID 360 //
     /*  184624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  184627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184641 */     // MIs[0] rs1
     /*  184641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184653 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  184658 */     GIR_RootConstrainSelectedInstOperands,
     /*  184659 */     // GIR_Coverage, 360,
     /*  184659 */     GIR_Done,
     /*  184660 */   // Label 3515: @184660
     /*  184660 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(184701), // Rule ID 690 //
     /*  184665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184682 */     // MIs[0] rs1
     /*  184682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184694 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184699 */     GIR_RootConstrainSelectedInstOperands,
     /*  184700 */     // GIR_Coverage, 690,
     /*  184700 */     GIR_Done,
     /*  184701 */   // Label 3516: @184701
     /*  184701 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(184742), // Rule ID 692 //
     /*  184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184723 */     // MIs[0] rs1
     /*  184723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184735 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  184740 */     GIR_RootConstrainSelectedInstOperands,
     /*  184741 */     // GIR_Coverage, 692,
     /*  184741 */     GIR_Done,
     /*  184742 */   // Label 3517: @184742
     /*  184742 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(184783), // Rule ID 694 //
     /*  184747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184764 */     // MIs[0] rs1
     /*  184764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184776 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  184781 */     GIR_RootConstrainSelectedInstOperands,
     /*  184782 */     // GIR_Coverage, 694,
     /*  184782 */     GIR_Done,
     /*  184783 */   // Label 3518: @184783
     /*  184783 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(184824), // Rule ID 696 //
     /*  184788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184805 */     // MIs[0] rs1
     /*  184805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184817 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  184822 */     GIR_RootConstrainSelectedInstOperands,
     /*  184823 */     // GIR_Coverage, 696,
     /*  184823 */     GIR_Done,
     /*  184824 */   // Label 3519: @184824
     /*  184824 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(184865), // Rule ID 698 //
     /*  184829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184846 */     // MIs[0] rs1
     /*  184846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184858 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  184863 */     GIR_RootConstrainSelectedInstOperands,
     /*  184864 */     // GIR_Coverage, 698,
     /*  184864 */     GIR_Done,
     /*  184865 */   // Label 3520: @184865
     /*  184865 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(184906), // Rule ID 700 //
     /*  184870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184873 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184880 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184887 */     // MIs[0] rs1
     /*  184887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184899 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184904 */     GIR_RootConstrainSelectedInstOperands,
     /*  184905 */     // GIR_Coverage, 700,
     /*  184905 */     GIR_Done,
     /*  184906 */   // Label 3521: @184906
     /*  184906 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(184947), // Rule ID 702 //
     /*  184911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184914 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184921 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184928 */     // MIs[0] rs1
     /*  184928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184940 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184945 */     GIR_RootConstrainSelectedInstOperands,
     /*  184946 */     // GIR_Coverage, 702,
     /*  184946 */     GIR_Done,
     /*  184947 */   // Label 3522: @184947
     /*  184947 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(184988), // Rule ID 704 //
     /*  184952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184969 */     // MIs[0] rs1
     /*  184969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184981 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  184986 */     GIR_RootConstrainSelectedInstOperands,
     /*  184987 */     // GIR_Coverage, 704,
     /*  184987 */     GIR_Done,
     /*  184988 */   // Label 3523: @184988
     /*  184988 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(185029), // Rule ID 706 //
     /*  184993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185010 */     // MIs[0] rs1
     /*  185010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185022 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  185027 */     GIR_RootConstrainSelectedInstOperands,
     /*  185028 */     // GIR_Coverage, 706,
     /*  185028 */     GIR_Done,
     /*  185029 */   // Label 3524: @185029
     /*  185029 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(185070), // Rule ID 708 //
     /*  185034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185051 */     // MIs[0] rs1
     /*  185051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185063 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  185068 */     GIR_RootConstrainSelectedInstOperands,
     /*  185069 */     // GIR_Coverage, 708,
     /*  185069 */     GIR_Done,
     /*  185070 */   // Label 3525: @185070
     /*  185070 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(185111), // Rule ID 870 //
     /*  185075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185092 */     // MIs[0] rs1
     /*  185092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185104 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185109 */     GIR_RootConstrainSelectedInstOperands,
     /*  185110 */     // GIR_Coverage, 870,
     /*  185110 */     GIR_Done,
     /*  185111 */   // Label 3526: @185111
     /*  185111 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(185152), // Rule ID 872 //
     /*  185116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185133 */     // MIs[0] rs1
     /*  185133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185145 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  185150 */     GIR_RootConstrainSelectedInstOperands,
     /*  185151 */     // GIR_Coverage, 872,
     /*  185151 */     GIR_Done,
     /*  185152 */   // Label 3527: @185152
     /*  185152 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(185193), // Rule ID 874 //
     /*  185157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185174 */     // MIs[0] rs1
     /*  185174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185186 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  185191 */     GIR_RootConstrainSelectedInstOperands,
     /*  185192 */     // GIR_Coverage, 874,
     /*  185192 */     GIR_Done,
     /*  185193 */   // Label 3528: @185193
     /*  185193 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(185234), // Rule ID 876 //
     /*  185198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185215 */     // MIs[0] rs1
     /*  185215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185227 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  185232 */     GIR_RootConstrainSelectedInstOperands,
     /*  185233 */     // GIR_Coverage, 876,
     /*  185233 */     GIR_Done,
     /*  185234 */   // Label 3529: @185234
     /*  185234 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(185275), // Rule ID 878 //
     /*  185239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  185242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185256 */     // MIs[0] rs1
     /*  185256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185268 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  185273 */     GIR_RootConstrainSelectedInstOperands,
     /*  185274 */     // GIR_Coverage, 878,
     /*  185274 */     GIR_Done,
     /*  185275 */   // Label 3530: @185275
     /*  185275 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(185316), // Rule ID 880 //
     /*  185280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185283 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185297 */     // MIs[0] rs1
     /*  185297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185309 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185314 */     GIR_RootConstrainSelectedInstOperands,
     /*  185315 */     // GIR_Coverage, 880,
     /*  185315 */     GIR_Done,
     /*  185316 */   // Label 3531: @185316
     /*  185316 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(185357), // Rule ID 882 //
     /*  185321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185338 */     // MIs[0] rs1
     /*  185338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185350 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185355 */     GIR_RootConstrainSelectedInstOperands,
     /*  185356 */     // GIR_Coverage, 882,
     /*  185356 */     GIR_Done,
     /*  185357 */   // Label 3532: @185357
     /*  185357 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(185398), // Rule ID 884 //
     /*  185362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185379 */     // MIs[0] rs1
     /*  185379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185391 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185396 */     GIR_RootConstrainSelectedInstOperands,
     /*  185397 */     // GIR_Coverage, 884,
     /*  185397 */     GIR_Done,
     /*  185398 */   // Label 3533: @185398
     /*  185398 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(185439), // Rule ID 886 //
     /*  185403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185420 */     // MIs[0] rs1
     /*  185420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185432 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185437 */     GIR_RootConstrainSelectedInstOperands,
     /*  185438 */     // GIR_Coverage, 886,
     /*  185438 */     GIR_Done,
     /*  185439 */   // Label 3534: @185439
     /*  185439 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(185480), // Rule ID 888 //
     /*  185444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  185447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185461 */     // MIs[0] rs1
     /*  185461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185473 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  185478 */     GIR_RootConstrainSelectedInstOperands,
     /*  185479 */     // GIR_Coverage, 888,
     /*  185479 */     GIR_Done,
     /*  185480 */   // Label 3535: @185480
     /*  185480 */   GIM_Reject,
     /*  185481 */ // Label 3505: @185481
     /*  185481 */ GIM_Reject,
     /*  185482 */ // Label 3503: @185482
     /*  185482 */ GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(187131),
     /*  185487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  185490 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(185531), // Rule ID 341 //
     /*  185495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185512 */     // MIs[0] rs1
     /*  185512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185524 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185529 */     GIR_RootConstrainSelectedInstOperands,
     /*  185530 */     // GIR_Coverage, 341,
     /*  185530 */     GIR_Done,
     /*  185531 */   // Label 3537: @185531
     /*  185531 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(185572), // Rule ID 343 //
     /*  185536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185553 */     // MIs[0] rs1
     /*  185553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185565 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  185570 */     GIR_RootConstrainSelectedInstOperands,
     /*  185571 */     // GIR_Coverage, 343,
     /*  185571 */     GIR_Done,
     /*  185572 */   // Label 3538: @185572
     /*  185572 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(185613), // Rule ID 345 //
     /*  185577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185594 */     // MIs[0] rs1
     /*  185594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185606 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  185611 */     GIR_RootConstrainSelectedInstOperands,
     /*  185612 */     // GIR_Coverage, 345,
     /*  185612 */     GIR_Done,
     /*  185613 */   // Label 3539: @185613
     /*  185613 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(185654), // Rule ID 347 //
     /*  185618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185621 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185628 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185635 */     // MIs[0] rs1
     /*  185635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185647 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  185652 */     GIR_RootConstrainSelectedInstOperands,
     /*  185653 */     // GIR_Coverage, 347,
     /*  185653 */     GIR_Done,
     /*  185654 */   // Label 3540: @185654
     /*  185654 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(185695), // Rule ID 349 //
     /*  185659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  185662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185676 */     // MIs[0] rs1
     /*  185676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185688 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  185693 */     GIR_RootConstrainSelectedInstOperands,
     /*  185694 */     // GIR_Coverage, 349,
     /*  185694 */     GIR_Done,
     /*  185695 */   // Label 3541: @185695
     /*  185695 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(185736), // Rule ID 351 //
     /*  185700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185717 */     // MIs[0] rs1
     /*  185717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185729 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185734 */     GIR_RootConstrainSelectedInstOperands,
     /*  185735 */     // GIR_Coverage, 351,
     /*  185735 */     GIR_Done,
     /*  185736 */   // Label 3542: @185736
     /*  185736 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(185777), // Rule ID 353 //
     /*  185741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185758 */     // MIs[0] rs1
     /*  185758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185770 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185775 */     GIR_RootConstrainSelectedInstOperands,
     /*  185776 */     // GIR_Coverage, 353,
     /*  185776 */     GIR_Done,
     /*  185777 */   // Label 3543: @185777
     /*  185777 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(185818), // Rule ID 355 //
     /*  185782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185785 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185799 */     // MIs[0] rs1
     /*  185799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185811 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185816 */     GIR_RootConstrainSelectedInstOperands,
     /*  185817 */     // GIR_Coverage, 355,
     /*  185817 */     GIR_Done,
     /*  185818 */   // Label 3544: @185818
     /*  185818 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(185859), // Rule ID 357 //
     /*  185823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185833 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185840 */     // MIs[0] rs1
     /*  185840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185852 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185857 */     GIR_RootConstrainSelectedInstOperands,
     /*  185858 */     // GIR_Coverage, 357,
     /*  185858 */     GIR_Done,
     /*  185859 */   // Label 3545: @185859
     /*  185859 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(185900), // Rule ID 359 //
     /*  185864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  185867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185881 */     // MIs[0] rs1
     /*  185881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185893 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  185898 */     GIR_RootConstrainSelectedInstOperands,
     /*  185899 */     // GIR_Coverage, 359,
     /*  185899 */     GIR_Done,
     /*  185900 */   // Label 3546: @185900
     /*  185900 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(185941), // Rule ID 521 //
     /*  185905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185922 */     // MIs[0] rs1
     /*  185922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185934 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  185939 */     GIR_RootConstrainSelectedInstOperands,
     /*  185940 */     // GIR_Coverage, 521,
     /*  185940 */     GIR_Done,
     /*  185941 */   // Label 3547: @185941
     /*  185941 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(185982), // Rule ID 522 //
     /*  185946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185963 */     // MIs[0] rs1
     /*  185963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185975 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  185980 */     GIR_RootConstrainSelectedInstOperands,
     /*  185981 */     // GIR_Coverage, 522,
     /*  185981 */     GIR_Done,
     /*  185982 */   // Label 3548: @185982
     /*  185982 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(186023), // Rule ID 523 //
     /*  185987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186004 */     // MIs[0] rs1
     /*  186004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186016 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  186021 */     GIR_RootConstrainSelectedInstOperands,
     /*  186022 */     // GIR_Coverage, 523,
     /*  186022 */     GIR_Done,
     /*  186023 */   // Label 3549: @186023
     /*  186023 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(186064), // Rule ID 524 //
     /*  186028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  186031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186045 */     // MIs[0] rs1
     /*  186045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186057 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  186062 */     GIR_RootConstrainSelectedInstOperands,
     /*  186063 */     // GIR_Coverage, 524,
     /*  186063 */     GIR_Done,
     /*  186064 */   // Label 3550: @186064
     /*  186064 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(186105), // Rule ID 525 //
     /*  186069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  186072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186086 */     // MIs[0] rs1
     /*  186086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186098 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  186103 */     GIR_RootConstrainSelectedInstOperands,
     /*  186104 */     // GIR_Coverage, 525,
     /*  186104 */     GIR_Done,
     /*  186105 */   // Label 3551: @186105
     /*  186105 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(186146), // Rule ID 526 //
     /*  186110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186127 */     // MIs[0] rs1
     /*  186127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186139 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186144 */     GIR_RootConstrainSelectedInstOperands,
     /*  186145 */     // GIR_Coverage, 526,
     /*  186145 */     GIR_Done,
     /*  186146 */   // Label 3552: @186146
     /*  186146 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(186187), // Rule ID 527 //
     /*  186151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186154 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186161 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186168 */     // MIs[0] rs1
     /*  186168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186180 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186185 */     GIR_RootConstrainSelectedInstOperands,
     /*  186186 */     // GIR_Coverage, 527,
     /*  186186 */     GIR_Done,
     /*  186187 */   // Label 3553: @186187
     /*  186187 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(186228), // Rule ID 528 //
     /*  186192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186195 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186202 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186209 */     // MIs[0] rs1
     /*  186209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186221 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186226 */     GIR_RootConstrainSelectedInstOperands,
     /*  186227 */     // GIR_Coverage, 528,
     /*  186227 */     GIR_Done,
     /*  186228 */   // Label 3554: @186228
     /*  186228 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(186269), // Rule ID 529 //
     /*  186233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186250 */     // MIs[0] rs1
     /*  186250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186262 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186267 */     GIR_RootConstrainSelectedInstOperands,
     /*  186268 */     // GIR_Coverage, 529,
     /*  186268 */     GIR_Done,
     /*  186269 */   // Label 3555: @186269
     /*  186269 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(186310), // Rule ID 530 //
     /*  186274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  186277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  186284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186291 */     // MIs[0] rs1
     /*  186291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186303 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  186308 */     GIR_RootConstrainSelectedInstOperands,
     /*  186309 */     // GIR_Coverage, 530,
     /*  186309 */     GIR_Done,
     /*  186310 */   // Label 3556: @186310
     /*  186310 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(186351), // Rule ID 689 //
     /*  186315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186332 */     // MIs[0] rs1
     /*  186332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186344 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186349 */     GIR_RootConstrainSelectedInstOperands,
     /*  186350 */     // GIR_Coverage, 689,
     /*  186350 */     GIR_Done,
     /*  186351 */   // Label 3557: @186351
     /*  186351 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(186392), // Rule ID 691 //
     /*  186356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186373 */     // MIs[0] rs1
     /*  186373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186385 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  186390 */     GIR_RootConstrainSelectedInstOperands,
     /*  186391 */     // GIR_Coverage, 691,
     /*  186391 */     GIR_Done,
     /*  186392 */   // Label 3558: @186392
     /*  186392 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(186433), // Rule ID 693 //
     /*  186397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186414 */     // MIs[0] rs1
     /*  186414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186426 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  186431 */     GIR_RootConstrainSelectedInstOperands,
     /*  186432 */     // GIR_Coverage, 693,
     /*  186432 */     GIR_Done,
     /*  186433 */   // Label 3559: @186433
     /*  186433 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(186474), // Rule ID 695 //
     /*  186438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186455 */     // MIs[0] rs1
     /*  186455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186467 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  186472 */     GIR_RootConstrainSelectedInstOperands,
     /*  186473 */     // GIR_Coverage, 695,
     /*  186473 */     GIR_Done,
     /*  186474 */   // Label 3560: @186474
     /*  186474 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(186515), // Rule ID 697 //
     /*  186479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186496 */     // MIs[0] rs1
     /*  186496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186508 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  186513 */     GIR_RootConstrainSelectedInstOperands,
     /*  186514 */     // GIR_Coverage, 697,
     /*  186514 */     GIR_Done,
     /*  186515 */   // Label 3561: @186515
     /*  186515 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(186556), // Rule ID 699 //
     /*  186520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186537 */     // MIs[0] rs1
     /*  186537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186549 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186554 */     GIR_RootConstrainSelectedInstOperands,
     /*  186555 */     // GIR_Coverage, 699,
     /*  186555 */     GIR_Done,
     /*  186556 */   // Label 3562: @186556
     /*  186556 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(186597), // Rule ID 701 //
     /*  186561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186578 */     // MIs[0] rs1
     /*  186578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186590 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186595 */     GIR_RootConstrainSelectedInstOperands,
     /*  186596 */     // GIR_Coverage, 701,
     /*  186596 */     GIR_Done,
     /*  186597 */   // Label 3563: @186597
     /*  186597 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(186638), // Rule ID 703 //
     /*  186602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186619 */     // MIs[0] rs1
     /*  186619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186631 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186636 */     GIR_RootConstrainSelectedInstOperands,
     /*  186637 */     // GIR_Coverage, 703,
     /*  186637 */     GIR_Done,
     /*  186638 */   // Label 3564: @186638
     /*  186638 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(186679), // Rule ID 705 //
     /*  186643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186660 */     // MIs[0] rs1
     /*  186660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186672 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186677 */     GIR_RootConstrainSelectedInstOperands,
     /*  186678 */     // GIR_Coverage, 705,
     /*  186678 */     GIR_Done,
     /*  186679 */   // Label 3565: @186679
     /*  186679 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(186720), // Rule ID 707 //
     /*  186684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186701 */     // MIs[0] rs1
     /*  186701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186713 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  186718 */     GIR_RootConstrainSelectedInstOperands,
     /*  186719 */     // GIR_Coverage, 707,
     /*  186719 */     GIR_Done,
     /*  186720 */   // Label 3566: @186720
     /*  186720 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(186761), // Rule ID 869 //
     /*  186725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186742 */     // MIs[0] rs1
     /*  186742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186754 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  186759 */     GIR_RootConstrainSelectedInstOperands,
     /*  186760 */     // GIR_Coverage, 869,
     /*  186760 */     GIR_Done,
     /*  186761 */   // Label 3567: @186761
     /*  186761 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(186802), // Rule ID 871 //
     /*  186766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186783 */     // MIs[0] rs1
     /*  186783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186795 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  186800 */     GIR_RootConstrainSelectedInstOperands,
     /*  186801 */     // GIR_Coverage, 871,
     /*  186801 */     GIR_Done,
     /*  186802 */   // Label 3568: @186802
     /*  186802 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(186843), // Rule ID 873 //
     /*  186807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186824 */     // MIs[0] rs1
     /*  186824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186836 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  186841 */     GIR_RootConstrainSelectedInstOperands,
     /*  186842 */     // GIR_Coverage, 873,
     /*  186842 */     GIR_Done,
     /*  186843 */   // Label 3569: @186843
     /*  186843 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(186884), // Rule ID 875 //
     /*  186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186865 */     // MIs[0] rs1
     /*  186865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186877 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  186882 */     GIR_RootConstrainSelectedInstOperands,
     /*  186883 */     // GIR_Coverage, 875,
     /*  186883 */     GIR_Done,
     /*  186884 */   // Label 3570: @186884
     /*  186884 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(186925), // Rule ID 877 //
     /*  186889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  186892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186906 */     // MIs[0] rs1
     /*  186906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186918 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  186923 */     GIR_RootConstrainSelectedInstOperands,
     /*  186924 */     // GIR_Coverage, 877,
     /*  186924 */     GIR_Done,
     /*  186925 */   // Label 3571: @186925
     /*  186925 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(186966), // Rule ID 879 //
     /*  186930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186947 */     // MIs[0] rs1
     /*  186947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186959 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  186964 */     GIR_RootConstrainSelectedInstOperands,
     /*  186965 */     // GIR_Coverage, 879,
     /*  186965 */     GIR_Done,
     /*  186966 */   // Label 3572: @186966
     /*  186966 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(187007), // Rule ID 881 //
     /*  186971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186988 */     // MIs[0] rs1
     /*  186988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187000 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187005 */     GIR_RootConstrainSelectedInstOperands,
     /*  187006 */     // GIR_Coverage, 881,
     /*  187006 */     GIR_Done,
     /*  187007 */   // Label 3573: @187007
     /*  187007 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(187048), // Rule ID 883 //
     /*  187012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187029 */     // MIs[0] rs1
     /*  187029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187041 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187046 */     GIR_RootConstrainSelectedInstOperands,
     /*  187047 */     // GIR_Coverage, 883,
     /*  187047 */     GIR_Done,
     /*  187048 */   // Label 3574: @187048
     /*  187048 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(187089), // Rule ID 885 //
     /*  187053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187070 */     // MIs[0] rs1
     /*  187070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187082 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187087 */     GIR_RootConstrainSelectedInstOperands,
     /*  187088 */     // GIR_Coverage, 885,
     /*  187088 */     GIR_Done,
     /*  187089 */   // Label 3575: @187089
     /*  187089 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(187130), // Rule ID 887 //
     /*  187094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187111 */     // MIs[0] rs1
     /*  187111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187123 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  187128 */     GIR_RootConstrainSelectedInstOperands,
     /*  187129 */     // GIR_Coverage, 887,
     /*  187129 */     GIR_Done,
     /*  187130 */   // Label 3576: @187130
     /*  187130 */   GIM_Reject,
     /*  187131 */ // Label 3536: @187131
     /*  187131 */ GIM_Reject,
     /*  187132 */ // Label 3504: @187132
     /*  187132 */ GIM_Reject,
     /*  187133 */ // Label 27: @187133
     /*  187133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3579*/ GIMT_Encode4(190042),
     /*  187144 */ /*GILLT_s32*//*Label 3577*/ GIMT_Encode4(187152),
     /*  187148 */ /*GILLT_s64*//*Label 3578*/ GIMT_Encode4(188392),
     /*  187152 */ // Label 3577: @187152
     /*  187152 */ GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(188391),
     /*  187157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  187160 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(187201), // Rule ID 362 //
     /*  187165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187168 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187182 */     // MIs[0] rs1
     /*  187182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187194 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187199 */     GIR_RootConstrainSelectedInstOperands,
     /*  187200 */     // GIR_Coverage, 362,
     /*  187200 */     GIR_Done,
     /*  187201 */   // Label 3581: @187201
     /*  187201 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(187242), // Rule ID 364 //
     /*  187206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187209 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187223 */     // MIs[0] rs1
     /*  187223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187235 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  187240 */     GIR_RootConstrainSelectedInstOperands,
     /*  187241 */     // GIR_Coverage, 364,
     /*  187241 */     GIR_Done,
     /*  187242 */   // Label 3582: @187242
     /*  187242 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(187283), // Rule ID 366 //
     /*  187247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187264 */     // MIs[0] rs1
     /*  187264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187276 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  187281 */     GIR_RootConstrainSelectedInstOperands,
     /*  187282 */     // GIR_Coverage, 366,
     /*  187282 */     GIR_Done,
     /*  187283 */   // Label 3583: @187283
     /*  187283 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(187324), // Rule ID 368 //
     /*  187288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187305 */     // MIs[0] rs1
     /*  187305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187317 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  187322 */     GIR_RootConstrainSelectedInstOperands,
     /*  187323 */     // GIR_Coverage, 368,
     /*  187323 */     GIR_Done,
     /*  187324 */   // Label 3584: @187324
     /*  187324 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(187365), // Rule ID 370 //
     /*  187329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  187332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187346 */     // MIs[0] rs1
     /*  187346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187358 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  187363 */     GIR_RootConstrainSelectedInstOperands,
     /*  187364 */     // GIR_Coverage, 370,
     /*  187364 */     GIR_Done,
     /*  187365 */   // Label 3585: @187365
     /*  187365 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(187406), // Rule ID 372 //
     /*  187370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187373 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187387 */     // MIs[0] rs1
     /*  187387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187399 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187404 */     GIR_RootConstrainSelectedInstOperands,
     /*  187405 */     // GIR_Coverage, 372,
     /*  187405 */     GIR_Done,
     /*  187406 */   // Label 3586: @187406
     /*  187406 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(187447), // Rule ID 374 //
     /*  187411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187414 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187428 */     // MIs[0] rs1
     /*  187428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187440 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187445 */     GIR_RootConstrainSelectedInstOperands,
     /*  187446 */     // GIR_Coverage, 374,
     /*  187446 */     GIR_Done,
     /*  187447 */   // Label 3587: @187447
     /*  187447 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(187488), // Rule ID 376 //
     /*  187452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187455 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187469 */     // MIs[0] rs1
     /*  187469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187481 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187486 */     GIR_RootConstrainSelectedInstOperands,
     /*  187487 */     // GIR_Coverage, 376,
     /*  187487 */     GIR_Done,
     /*  187488 */   // Label 3588: @187488
     /*  187488 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(187529), // Rule ID 378 //
     /*  187493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187510 */     // MIs[0] rs1
     /*  187510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187522 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187527 */     GIR_RootConstrainSelectedInstOperands,
     /*  187528 */     // GIR_Coverage, 378,
     /*  187528 */     GIR_Done,
     /*  187529 */   // Label 3589: @187529
     /*  187529 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(187570), // Rule ID 380 //
     /*  187534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  187537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187551 */     // MIs[0] rs1
     /*  187551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187563 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  187568 */     GIR_RootConstrainSelectedInstOperands,
     /*  187569 */     // GIR_Coverage, 380,
     /*  187569 */     GIR_Done,
     /*  187570 */   // Label 3590: @187570
     /*  187570 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(187611), // Rule ID 710 //
     /*  187575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187592 */     // MIs[0] rs1
     /*  187592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187604 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187609 */     GIR_RootConstrainSelectedInstOperands,
     /*  187610 */     // GIR_Coverage, 710,
     /*  187610 */     GIR_Done,
     /*  187611 */   // Label 3591: @187611
     /*  187611 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(187652), // Rule ID 712 //
     /*  187616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187633 */     // MIs[0] rs1
     /*  187633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187645 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  187650 */     GIR_RootConstrainSelectedInstOperands,
     /*  187651 */     // GIR_Coverage, 712,
     /*  187651 */     GIR_Done,
     /*  187652 */   // Label 3592: @187652
     /*  187652 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(187693), // Rule ID 714 //
     /*  187657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187674 */     // MIs[0] rs1
     /*  187674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187686 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  187691 */     GIR_RootConstrainSelectedInstOperands,
     /*  187692 */     // GIR_Coverage, 714,
     /*  187692 */     GIR_Done,
     /*  187693 */   // Label 3593: @187693
     /*  187693 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(187734), // Rule ID 716 //
     /*  187698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187715 */     // MIs[0] rs1
     /*  187715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187727 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  187732 */     GIR_RootConstrainSelectedInstOperands,
     /*  187733 */     // GIR_Coverage, 716,
     /*  187733 */     GIR_Done,
     /*  187734 */   // Label 3594: @187734
     /*  187734 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(187775), // Rule ID 718 //
     /*  187739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187756 */     // MIs[0] rs1
     /*  187756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187768 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  187773 */     GIR_RootConstrainSelectedInstOperands,
     /*  187774 */     // GIR_Coverage, 718,
     /*  187774 */     GIR_Done,
     /*  187775 */   // Label 3595: @187775
     /*  187775 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(187816), // Rule ID 720 //
     /*  187780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187783 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187790 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187797 */     // MIs[0] rs1
     /*  187797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187809 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187814 */     GIR_RootConstrainSelectedInstOperands,
     /*  187815 */     // GIR_Coverage, 720,
     /*  187815 */     GIR_Done,
     /*  187816 */   // Label 3596: @187816
     /*  187816 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(187857), // Rule ID 722 //
     /*  187821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187824 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187838 */     // MIs[0] rs1
     /*  187838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187850 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187855 */     GIR_RootConstrainSelectedInstOperands,
     /*  187856 */     // GIR_Coverage, 722,
     /*  187856 */     GIR_Done,
     /*  187857 */   // Label 3597: @187857
     /*  187857 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(187898), // Rule ID 724 //
     /*  187862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187879 */     // MIs[0] rs1
     /*  187879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187891 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187896 */     GIR_RootConstrainSelectedInstOperands,
     /*  187897 */     // GIR_Coverage, 724,
     /*  187897 */     GIR_Done,
     /*  187898 */   // Label 3598: @187898
     /*  187898 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(187939), // Rule ID 726 //
     /*  187903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187920 */     // MIs[0] rs1
     /*  187920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187932 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187937 */     GIR_RootConstrainSelectedInstOperands,
     /*  187938 */     // GIR_Coverage, 726,
     /*  187938 */     GIR_Done,
     /*  187939 */   // Label 3599: @187939
     /*  187939 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(187980), // Rule ID 728 //
     /*  187944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187961 */     // MIs[0] rs1
     /*  187961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187973 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  187978 */     GIR_RootConstrainSelectedInstOperands,
     /*  187979 */     // GIR_Coverage, 728,
     /*  187979 */     GIR_Done,
     /*  187980 */   // Label 3600: @187980
     /*  187980 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(188021), // Rule ID 890 //
     /*  187985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188002 */     // MIs[0] rs1
     /*  188002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188014 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188019 */     GIR_RootConstrainSelectedInstOperands,
     /*  188020 */     // GIR_Coverage, 890,
     /*  188020 */     GIR_Done,
     /*  188021 */   // Label 3601: @188021
     /*  188021 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(188062), // Rule ID 892 //
     /*  188026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188043 */     // MIs[0] rs1
     /*  188043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188055 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  188060 */     GIR_RootConstrainSelectedInstOperands,
     /*  188061 */     // GIR_Coverage, 892,
     /*  188061 */     GIR_Done,
     /*  188062 */   // Label 3602: @188062
     /*  188062 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(188103), // Rule ID 894 //
     /*  188067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188084 */     // MIs[0] rs1
     /*  188084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188096 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  188101 */     GIR_RootConstrainSelectedInstOperands,
     /*  188102 */     // GIR_Coverage, 894,
     /*  188102 */     GIR_Done,
     /*  188103 */   // Label 3603: @188103
     /*  188103 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(188144), // Rule ID 896 //
     /*  188108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188125 */     // MIs[0] rs1
     /*  188125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188137 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  188142 */     GIR_RootConstrainSelectedInstOperands,
     /*  188143 */     // GIR_Coverage, 896,
     /*  188143 */     GIR_Done,
     /*  188144 */   // Label 3604: @188144
     /*  188144 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(188185), // Rule ID 898 //
     /*  188149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  188152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188166 */     // MIs[0] rs1
     /*  188166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188178 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  188183 */     GIR_RootConstrainSelectedInstOperands,
     /*  188184 */     // GIR_Coverage, 898,
     /*  188184 */     GIR_Done,
     /*  188185 */   // Label 3605: @188185
     /*  188185 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(188226), // Rule ID 900 //
     /*  188190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188207 */     // MIs[0] rs1
     /*  188207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188219 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188224 */     GIR_RootConstrainSelectedInstOperands,
     /*  188225 */     // GIR_Coverage, 900,
     /*  188225 */     GIR_Done,
     /*  188226 */   // Label 3606: @188226
     /*  188226 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(188267), // Rule ID 902 //
     /*  188231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188248 */     // MIs[0] rs1
     /*  188248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188260 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188265 */     GIR_RootConstrainSelectedInstOperands,
     /*  188266 */     // GIR_Coverage, 902,
     /*  188266 */     GIR_Done,
     /*  188267 */   // Label 3607: @188267
     /*  188267 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(188308), // Rule ID 904 //
     /*  188272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188275 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188289 */     // MIs[0] rs1
     /*  188289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188301 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188306 */     GIR_RootConstrainSelectedInstOperands,
     /*  188307 */     // GIR_Coverage, 904,
     /*  188307 */     GIR_Done,
     /*  188308 */   // Label 3608: @188308
     /*  188308 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(188349), // Rule ID 906 //
     /*  188313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188330 */     // MIs[0] rs1
     /*  188330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188342 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188347 */     GIR_RootConstrainSelectedInstOperands,
     /*  188348 */     // GIR_Coverage, 906,
     /*  188348 */     GIR_Done,
     /*  188349 */   // Label 3609: @188349
     /*  188349 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(188390), // Rule ID 908 //
     /*  188354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  188357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188371 */     // MIs[0] rs1
     /*  188371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  188375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188383 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  188383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  188388 */     GIR_RootConstrainSelectedInstOperands,
     /*  188389 */     // GIR_Coverage, 908,
     /*  188389 */     GIR_Done,
     /*  188390 */   // Label 3610: @188390
     /*  188390 */   GIM_Reject,
     /*  188391 */ // Label 3580: @188391
     /*  188391 */ GIM_Reject,
     /*  188392 */ // Label 3578: @188392
     /*  188392 */ GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(190041),
     /*  188397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  188400 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(188441), // Rule ID 361 //
     /*  188405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188422 */     // MIs[0] rs1
     /*  188422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188434 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188439 */     GIR_RootConstrainSelectedInstOperands,
     /*  188440 */     // GIR_Coverage, 361,
     /*  188440 */     GIR_Done,
     /*  188441 */   // Label 3612: @188441
     /*  188441 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(188482), // Rule ID 363 //
     /*  188446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188463 */     // MIs[0] rs1
     /*  188463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188475 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  188480 */     GIR_RootConstrainSelectedInstOperands,
     /*  188481 */     // GIR_Coverage, 363,
     /*  188481 */     GIR_Done,
     /*  188482 */   // Label 3613: @188482
     /*  188482 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(188523), // Rule ID 365 //
     /*  188487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188504 */     // MIs[0] rs1
     /*  188504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188516 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  188521 */     GIR_RootConstrainSelectedInstOperands,
     /*  188522 */     // GIR_Coverage, 365,
     /*  188522 */     GIR_Done,
     /*  188523 */   // Label 3614: @188523
     /*  188523 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(188564), // Rule ID 367 //
     /*  188528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188545 */     // MIs[0] rs1
     /*  188545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188557 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  188562 */     GIR_RootConstrainSelectedInstOperands,
     /*  188563 */     // GIR_Coverage, 367,
     /*  188563 */     GIR_Done,
     /*  188564 */   // Label 3615: @188564
     /*  188564 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(188605), // Rule ID 369 //
     /*  188569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  188572 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188579 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188586 */     // MIs[0] rs1
     /*  188586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188598 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  188603 */     GIR_RootConstrainSelectedInstOperands,
     /*  188604 */     // GIR_Coverage, 369,
     /*  188604 */     GIR_Done,
     /*  188605 */   // Label 3616: @188605
     /*  188605 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(188646), // Rule ID 371 //
     /*  188610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188627 */     // MIs[0] rs1
     /*  188627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188639 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188644 */     GIR_RootConstrainSelectedInstOperands,
     /*  188645 */     // GIR_Coverage, 371,
     /*  188645 */     GIR_Done,
     /*  188646 */   // Label 3617: @188646
     /*  188646 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(188687), // Rule ID 373 //
     /*  188651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188668 */     // MIs[0] rs1
     /*  188668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188680 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188685 */     GIR_RootConstrainSelectedInstOperands,
     /*  188686 */     // GIR_Coverage, 373,
     /*  188686 */     GIR_Done,
     /*  188687 */   // Label 3618: @188687
     /*  188687 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(188728), // Rule ID 375 //
     /*  188692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188709 */     // MIs[0] rs1
     /*  188709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188721 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188726 */     GIR_RootConstrainSelectedInstOperands,
     /*  188727 */     // GIR_Coverage, 375,
     /*  188727 */     GIR_Done,
     /*  188728 */   // Label 3619: @188728
     /*  188728 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(188769), // Rule ID 377 //
     /*  188733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188750 */     // MIs[0] rs1
     /*  188750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188762 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188767 */     GIR_RootConstrainSelectedInstOperands,
     /*  188768 */     // GIR_Coverage, 377,
     /*  188768 */     GIR_Done,
     /*  188769 */   // Label 3620: @188769
     /*  188769 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(188810), // Rule ID 379 //
     /*  188774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  188777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188791 */     // MIs[0] rs1
     /*  188791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188803 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  188808 */     GIR_RootConstrainSelectedInstOperands,
     /*  188809 */     // GIR_Coverage, 379,
     /*  188809 */     GIR_Done,
     /*  188810 */   // Label 3621: @188810
     /*  188810 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(188851), // Rule ID 531 //
     /*  188815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188832 */     // MIs[0] rs1
     /*  188832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188844 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  188849 */     GIR_RootConstrainSelectedInstOperands,
     /*  188850 */     // GIR_Coverage, 531,
     /*  188850 */     GIR_Done,
     /*  188851 */   // Label 3622: @188851
     /*  188851 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(188892), // Rule ID 532 //
     /*  188856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188873 */     // MIs[0] rs1
     /*  188873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188885 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  188890 */     GIR_RootConstrainSelectedInstOperands,
     /*  188891 */     // GIR_Coverage, 532,
     /*  188891 */     GIR_Done,
     /*  188892 */   // Label 3623: @188892
     /*  188892 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(188933), // Rule ID 533 //
     /*  188897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188914 */     // MIs[0] rs1
     /*  188914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188926 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  188931 */     GIR_RootConstrainSelectedInstOperands,
     /*  188932 */     // GIR_Coverage, 533,
     /*  188932 */     GIR_Done,
     /*  188933 */   // Label 3624: @188933
     /*  188933 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(188974), // Rule ID 534 //
     /*  188938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188955 */     // MIs[0] rs1
     /*  188955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188967 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  188972 */     GIR_RootConstrainSelectedInstOperands,
     /*  188973 */     // GIR_Coverage, 534,
     /*  188973 */     GIR_Done,
     /*  188974 */   // Label 3625: @188974
     /*  188974 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(189015), // Rule ID 535 //
     /*  188979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188996 */     // MIs[0] rs1
     /*  188996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189008 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  189013 */     GIR_RootConstrainSelectedInstOperands,
     /*  189014 */     // GIR_Coverage, 535,
     /*  189014 */     GIR_Done,
     /*  189015 */   // Label 3626: @189015
     /*  189015 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(189056), // Rule ID 536 //
     /*  189020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189037 */     // MIs[0] rs1
     /*  189037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189049 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189054 */     GIR_RootConstrainSelectedInstOperands,
     /*  189055 */     // GIR_Coverage, 536,
     /*  189055 */     GIR_Done,
     /*  189056 */   // Label 3627: @189056
     /*  189056 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(189097), // Rule ID 537 //
     /*  189061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189078 */     // MIs[0] rs1
     /*  189078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189090 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189095 */     GIR_RootConstrainSelectedInstOperands,
     /*  189096 */     // GIR_Coverage, 537,
     /*  189096 */     GIR_Done,
     /*  189097 */   // Label 3628: @189097
     /*  189097 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(189138), // Rule ID 538 //
     /*  189102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189119 */     // MIs[0] rs1
     /*  189119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189131 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189136 */     GIR_RootConstrainSelectedInstOperands,
     /*  189137 */     // GIR_Coverage, 538,
     /*  189137 */     GIR_Done,
     /*  189138 */   // Label 3629: @189138
     /*  189138 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(189179), // Rule ID 539 //
     /*  189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189160 */     // MIs[0] rs1
     /*  189160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189172 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189177 */     GIR_RootConstrainSelectedInstOperands,
     /*  189178 */     // GIR_Coverage, 539,
     /*  189178 */     GIR_Done,
     /*  189179 */   // Label 3630: @189179
     /*  189179 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(189220), // Rule ID 540 //
     /*  189184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  189187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189201 */     // MIs[0] rs1
     /*  189201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189213 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  189218 */     GIR_RootConstrainSelectedInstOperands,
     /*  189219 */     // GIR_Coverage, 540,
     /*  189219 */     GIR_Done,
     /*  189220 */   // Label 3631: @189220
     /*  189220 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(189261), // Rule ID 709 //
     /*  189225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189242 */     // MIs[0] rs1
     /*  189242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189254 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189259 */     GIR_RootConstrainSelectedInstOperands,
     /*  189260 */     // GIR_Coverage, 709,
     /*  189260 */     GIR_Done,
     /*  189261 */   // Label 3632: @189261
     /*  189261 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(189302), // Rule ID 711 //
     /*  189266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189283 */     // MIs[0] rs1
     /*  189283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189295 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  189300 */     GIR_RootConstrainSelectedInstOperands,
     /*  189301 */     // GIR_Coverage, 711,
     /*  189301 */     GIR_Done,
     /*  189302 */   // Label 3633: @189302
     /*  189302 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(189343), // Rule ID 713 //
     /*  189307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189324 */     // MIs[0] rs1
     /*  189324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189336 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  189341 */     GIR_RootConstrainSelectedInstOperands,
     /*  189342 */     // GIR_Coverage, 713,
     /*  189342 */     GIR_Done,
     /*  189343 */   // Label 3634: @189343
     /*  189343 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(189384), // Rule ID 715 //
     /*  189348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189365 */     // MIs[0] rs1
     /*  189365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189377 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  189382 */     GIR_RootConstrainSelectedInstOperands,
     /*  189383 */     // GIR_Coverage, 715,
     /*  189383 */     GIR_Done,
     /*  189384 */   // Label 3635: @189384
     /*  189384 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(189425), // Rule ID 717 //
     /*  189389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189406 */     // MIs[0] rs1
     /*  189406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189418 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  189423 */     GIR_RootConstrainSelectedInstOperands,
     /*  189424 */     // GIR_Coverage, 717,
     /*  189424 */     GIR_Done,
     /*  189425 */   // Label 3636: @189425
     /*  189425 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(189466), // Rule ID 719 //
     /*  189430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189447 */     // MIs[0] rs1
     /*  189447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189459 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189464 */     GIR_RootConstrainSelectedInstOperands,
     /*  189465 */     // GIR_Coverage, 719,
     /*  189465 */     GIR_Done,
     /*  189466 */   // Label 3637: @189466
     /*  189466 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(189507), // Rule ID 721 //
     /*  189471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189488 */     // MIs[0] rs1
     /*  189488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189500 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189505 */     GIR_RootConstrainSelectedInstOperands,
     /*  189506 */     // GIR_Coverage, 721,
     /*  189506 */     GIR_Done,
     /*  189507 */   // Label 3638: @189507
     /*  189507 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(189548), // Rule ID 723 //
     /*  189512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189529 */     // MIs[0] rs1
     /*  189529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189541 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189546 */     GIR_RootConstrainSelectedInstOperands,
     /*  189547 */     // GIR_Coverage, 723,
     /*  189547 */     GIR_Done,
     /*  189548 */   // Label 3639: @189548
     /*  189548 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(189589), // Rule ID 725 //
     /*  189553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189570 */     // MIs[0] rs1
     /*  189570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189582 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189587 */     GIR_RootConstrainSelectedInstOperands,
     /*  189588 */     // GIR_Coverage, 725,
     /*  189588 */     GIR_Done,
     /*  189589 */   // Label 3640: @189589
     /*  189589 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(189630), // Rule ID 727 //
     /*  189594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189611 */     // MIs[0] rs1
     /*  189611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189623 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  189628 */     GIR_RootConstrainSelectedInstOperands,
     /*  189629 */     // GIR_Coverage, 727,
     /*  189629 */     GIR_Done,
     /*  189630 */   // Label 3641: @189630
     /*  189630 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(189671), // Rule ID 889 //
     /*  189635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189652 */     // MIs[0] rs1
     /*  189652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189664 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189669 */     GIR_RootConstrainSelectedInstOperands,
     /*  189670 */     // GIR_Coverage, 889,
     /*  189670 */     GIR_Done,
     /*  189671 */   // Label 3642: @189671
     /*  189671 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(189712), // Rule ID 891 //
     /*  189676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189693 */     // MIs[0] rs1
     /*  189693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189705 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  189710 */     GIR_RootConstrainSelectedInstOperands,
     /*  189711 */     // GIR_Coverage, 891,
     /*  189711 */     GIR_Done,
     /*  189712 */   // Label 3643: @189712
     /*  189712 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(189753), // Rule ID 893 //
     /*  189717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189734 */     // MIs[0] rs1
     /*  189734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189746 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  189751 */     GIR_RootConstrainSelectedInstOperands,
     /*  189752 */     // GIR_Coverage, 893,
     /*  189752 */     GIR_Done,
     /*  189753 */   // Label 3644: @189753
     /*  189753 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(189794), // Rule ID 895 //
     /*  189758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189775 */     // MIs[0] rs1
     /*  189775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189787 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  189792 */     GIR_RootConstrainSelectedInstOperands,
     /*  189793 */     // GIR_Coverage, 895,
     /*  189793 */     GIR_Done,
     /*  189794 */   // Label 3645: @189794
     /*  189794 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(189835), // Rule ID 897 //
     /*  189799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  189802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189816 */     // MIs[0] rs1
     /*  189816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189828 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  189833 */     GIR_RootConstrainSelectedInstOperands,
     /*  189834 */     // GIR_Coverage, 897,
     /*  189834 */     GIR_Done,
     /*  189835 */   // Label 3646: @189835
     /*  189835 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(189876), // Rule ID 899 //
     /*  189840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189857 */     // MIs[0] rs1
     /*  189857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189869 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189874 */     GIR_RootConstrainSelectedInstOperands,
     /*  189875 */     // GIR_Coverage, 899,
     /*  189875 */     GIR_Done,
     /*  189876 */   // Label 3647: @189876
     /*  189876 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(189917), // Rule ID 901 //
     /*  189881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189898 */     // MIs[0] rs1
     /*  189898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189910 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189915 */     GIR_RootConstrainSelectedInstOperands,
     /*  189916 */     // GIR_Coverage, 901,
     /*  189916 */     GIR_Done,
     /*  189917 */   // Label 3648: @189917
     /*  189917 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(189958), // Rule ID 903 //
     /*  189922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189939 */     // MIs[0] rs1
     /*  189939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189951 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189956 */     GIR_RootConstrainSelectedInstOperands,
     /*  189957 */     // GIR_Coverage, 903,
     /*  189957 */     GIR_Done,
     /*  189958 */   // Label 3649: @189958
     /*  189958 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(189999), // Rule ID 905 //
     /*  189963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189980 */     // MIs[0] rs1
     /*  189980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189992 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  189997 */     GIR_RootConstrainSelectedInstOperands,
     /*  189998 */     // GIR_Coverage, 905,
     /*  189998 */     GIR_Done,
     /*  189999 */   // Label 3650: @189999
     /*  189999 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(190040), // Rule ID 907 //
     /*  190004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  190007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190021 */     // MIs[0] rs1
     /*  190021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190033 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  190038 */     GIR_RootConstrainSelectedInstOperands,
     /*  190039 */     // GIR_Coverage, 907,
     /*  190039 */     GIR_Done,
     /*  190040 */   // Label 3651: @190040
     /*  190040 */   GIM_Reject,
     /*  190041 */ // Label 3611: @190041
     /*  190041 */ GIM_Reject,
     /*  190042 */ // Label 3579: @190042
     /*  190042 */ GIM_Reject,
     /*  190043 */ // Label 28: @190043
     /*  190043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3654*/ GIMT_Encode4(192952),
     /*  190054 */ /*GILLT_s32*//*Label 3652*/ GIMT_Encode4(190062),
     /*  190058 */ /*GILLT_s64*//*Label 3653*/ GIMT_Encode4(191302),
     /*  190062 */ // Label 3652: @190062
     /*  190062 */ GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(191301),
     /*  190067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190070 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(190111), // Rule ID 382 //
     /*  190075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190078 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190085 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190092 */     // MIs[0] rs1
     /*  190092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190104 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190109 */     GIR_RootConstrainSelectedInstOperands,
     /*  190110 */     // GIR_Coverage, 382,
     /*  190110 */     GIR_Done,
     /*  190111 */   // Label 3656: @190111
     /*  190111 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(190152), // Rule ID 384 //
     /*  190116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190133 */     // MIs[0] rs1
     /*  190133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190145 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  190150 */     GIR_RootConstrainSelectedInstOperands,
     /*  190151 */     // GIR_Coverage, 384,
     /*  190151 */     GIR_Done,
     /*  190152 */   // Label 3657: @190152
     /*  190152 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(190193), // Rule ID 386 //
     /*  190157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190174 */     // MIs[0] rs1
     /*  190174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190186 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  190191 */     GIR_RootConstrainSelectedInstOperands,
     /*  190192 */     // GIR_Coverage, 386,
     /*  190192 */     GIR_Done,
     /*  190193 */   // Label 3658: @190193
     /*  190193 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(190234), // Rule ID 388 //
     /*  190198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190215 */     // MIs[0] rs1
     /*  190215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190227 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  190232 */     GIR_RootConstrainSelectedInstOperands,
     /*  190233 */     // GIR_Coverage, 388,
     /*  190233 */     GIR_Done,
     /*  190234 */   // Label 3659: @190234
     /*  190234 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(190275), // Rule ID 390 //
     /*  190239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190256 */     // MIs[0] rs1
     /*  190256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190268 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  190273 */     GIR_RootConstrainSelectedInstOperands,
     /*  190274 */     // GIR_Coverage, 390,
     /*  190274 */     GIR_Done,
     /*  190275 */   // Label 3660: @190275
     /*  190275 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(190316), // Rule ID 392 //
     /*  190280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190283 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190297 */     // MIs[0] rs1
     /*  190297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190309 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190314 */     GIR_RootConstrainSelectedInstOperands,
     /*  190315 */     // GIR_Coverage, 392,
     /*  190315 */     GIR_Done,
     /*  190316 */   // Label 3661: @190316
     /*  190316 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(190357), // Rule ID 394 //
     /*  190321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190338 */     // MIs[0] rs1
     /*  190338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190350 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190355 */     GIR_RootConstrainSelectedInstOperands,
     /*  190356 */     // GIR_Coverage, 394,
     /*  190356 */     GIR_Done,
     /*  190357 */   // Label 3662: @190357
     /*  190357 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(190398), // Rule ID 396 //
     /*  190362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190379 */     // MIs[0] rs1
     /*  190379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190391 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190396 */     GIR_RootConstrainSelectedInstOperands,
     /*  190397 */     // GIR_Coverage, 396,
     /*  190397 */     GIR_Done,
     /*  190398 */   // Label 3663: @190398
     /*  190398 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(190439), // Rule ID 398 //
     /*  190403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190420 */     // MIs[0] rs1
     /*  190420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190432 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190437 */     GIR_RootConstrainSelectedInstOperands,
     /*  190438 */     // GIR_Coverage, 398,
     /*  190438 */     GIR_Done,
     /*  190439 */   // Label 3664: @190439
     /*  190439 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(190480), // Rule ID 400 //
     /*  190444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190461 */     // MIs[0] rs1
     /*  190461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190473 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  190478 */     GIR_RootConstrainSelectedInstOperands,
     /*  190479 */     // GIR_Coverage, 400,
     /*  190479 */     GIR_Done,
     /*  190480 */   // Label 3665: @190480
     /*  190480 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(190521), // Rule ID 730 //
     /*  190485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190502 */     // MIs[0] rs1
     /*  190502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190514 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190519 */     GIR_RootConstrainSelectedInstOperands,
     /*  190520 */     // GIR_Coverage, 730,
     /*  190520 */     GIR_Done,
     /*  190521 */   // Label 3666: @190521
     /*  190521 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(190562), // Rule ID 732 //
     /*  190526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190543 */     // MIs[0] rs1
     /*  190543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190555 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  190560 */     GIR_RootConstrainSelectedInstOperands,
     /*  190561 */     // GIR_Coverage, 732,
     /*  190561 */     GIR_Done,
     /*  190562 */   // Label 3667: @190562
     /*  190562 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(190603), // Rule ID 734 //
     /*  190567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190584 */     // MIs[0] rs1
     /*  190584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190596 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  190601 */     GIR_RootConstrainSelectedInstOperands,
     /*  190602 */     // GIR_Coverage, 734,
     /*  190602 */     GIR_Done,
     /*  190603 */   // Label 3668: @190603
     /*  190603 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(190644), // Rule ID 736 //
     /*  190608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190625 */     // MIs[0] rs1
     /*  190625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190637 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  190642 */     GIR_RootConstrainSelectedInstOperands,
     /*  190643 */     // GIR_Coverage, 736,
     /*  190643 */     GIR_Done,
     /*  190644 */   // Label 3669: @190644
     /*  190644 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(190685), // Rule ID 738 //
     /*  190649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190666 */     // MIs[0] rs1
     /*  190666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190678 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  190683 */     GIR_RootConstrainSelectedInstOperands,
     /*  190684 */     // GIR_Coverage, 738,
     /*  190684 */     GIR_Done,
     /*  190685 */   // Label 3670: @190685
     /*  190685 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(190726), // Rule ID 740 //
     /*  190690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190707 */     // MIs[0] rs1
     /*  190707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190719 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190724 */     GIR_RootConstrainSelectedInstOperands,
     /*  190725 */     // GIR_Coverage, 740,
     /*  190725 */     GIR_Done,
     /*  190726 */   // Label 3671: @190726
     /*  190726 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(190767), // Rule ID 742 //
     /*  190731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190748 */     // MIs[0] rs1
     /*  190748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190760 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190765 */     GIR_RootConstrainSelectedInstOperands,
     /*  190766 */     // GIR_Coverage, 742,
     /*  190766 */     GIR_Done,
     /*  190767 */   // Label 3672: @190767
     /*  190767 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(190808), // Rule ID 744 //
     /*  190772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190782 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190789 */     // MIs[0] rs1
     /*  190789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190801 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190806 */     GIR_RootConstrainSelectedInstOperands,
     /*  190807 */     // GIR_Coverage, 744,
     /*  190807 */     GIR_Done,
     /*  190808 */   // Label 3673: @190808
     /*  190808 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(190849), // Rule ID 746 //
     /*  190813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190816 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190823 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190830 */     // MIs[0] rs1
     /*  190830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190842 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190847 */     GIR_RootConstrainSelectedInstOperands,
     /*  190848 */     // GIR_Coverage, 746,
     /*  190848 */     GIR_Done,
     /*  190849 */   // Label 3674: @190849
     /*  190849 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(190890), // Rule ID 748 //
     /*  190854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190871 */     // MIs[0] rs1
     /*  190871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190883 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  190888 */     GIR_RootConstrainSelectedInstOperands,
     /*  190889 */     // GIR_Coverage, 748,
     /*  190889 */     GIR_Done,
     /*  190890 */   // Label 3675: @190890
     /*  190890 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(190931), // Rule ID 910 //
     /*  190895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190912 */     // MIs[0] rs1
     /*  190912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190924 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  190929 */     GIR_RootConstrainSelectedInstOperands,
     /*  190930 */     // GIR_Coverage, 910,
     /*  190930 */     GIR_Done,
     /*  190931 */   // Label 3676: @190931
     /*  190931 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(190972), // Rule ID 912 //
     /*  190936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190953 */     // MIs[0] rs1
     /*  190953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190965 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  190970 */     GIR_RootConstrainSelectedInstOperands,
     /*  190971 */     // GIR_Coverage, 912,
     /*  190971 */     GIR_Done,
     /*  190972 */   // Label 3677: @190972
     /*  190972 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(191013), // Rule ID 914 //
     /*  190977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190994 */     // MIs[0] rs1
     /*  190994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191006 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  191011 */     GIR_RootConstrainSelectedInstOperands,
     /*  191012 */     // GIR_Coverage, 914,
     /*  191012 */     GIR_Done,
     /*  191013 */   // Label 3678: @191013
     /*  191013 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(191054), // Rule ID 916 //
     /*  191018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191035 */     // MIs[0] rs1
     /*  191035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191047 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  191052 */     GIR_RootConstrainSelectedInstOperands,
     /*  191053 */     // GIR_Coverage, 916,
     /*  191053 */     GIR_Done,
     /*  191054 */   // Label 3679: @191054
     /*  191054 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(191095), // Rule ID 918 //
     /*  191059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191076 */     // MIs[0] rs1
     /*  191076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191088 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  191093 */     GIR_RootConstrainSelectedInstOperands,
     /*  191094 */     // GIR_Coverage, 918,
     /*  191094 */     GIR_Done,
     /*  191095 */   // Label 3680: @191095
     /*  191095 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(191136), // Rule ID 920 //
     /*  191100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191117 */     // MIs[0] rs1
     /*  191117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191129 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191134 */     GIR_RootConstrainSelectedInstOperands,
     /*  191135 */     // GIR_Coverage, 920,
     /*  191135 */     GIR_Done,
     /*  191136 */   // Label 3681: @191136
     /*  191136 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(191177), // Rule ID 922 //
     /*  191141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191158 */     // MIs[0] rs1
     /*  191158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191170 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191175 */     GIR_RootConstrainSelectedInstOperands,
     /*  191176 */     // GIR_Coverage, 922,
     /*  191176 */     GIR_Done,
     /*  191177 */   // Label 3682: @191177
     /*  191177 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(191218), // Rule ID 924 //
     /*  191182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191199 */     // MIs[0] rs1
     /*  191199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191211 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191216 */     GIR_RootConstrainSelectedInstOperands,
     /*  191217 */     // GIR_Coverage, 924,
     /*  191217 */     GIR_Done,
     /*  191218 */   // Label 3683: @191218
     /*  191218 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(191259), // Rule ID 926 //
     /*  191223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191240 */     // MIs[0] rs1
     /*  191240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191252 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191257 */     GIR_RootConstrainSelectedInstOperands,
     /*  191258 */     // GIR_Coverage, 926,
     /*  191258 */     GIR_Done,
     /*  191259 */   // Label 3684: @191259
     /*  191259 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(191300), // Rule ID 928 //
     /*  191264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191281 */     // MIs[0] rs1
     /*  191281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191293 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  191298 */     GIR_RootConstrainSelectedInstOperands,
     /*  191299 */     // GIR_Coverage, 928,
     /*  191299 */     GIR_Done,
     /*  191300 */   // Label 3685: @191300
     /*  191300 */   GIM_Reject,
     /*  191301 */ // Label 3655: @191301
     /*  191301 */ GIM_Reject,
     /*  191302 */ // Label 3653: @191302
     /*  191302 */ GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(192951),
     /*  191307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191310 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(191351), // Rule ID 381 //
     /*  191315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191332 */     // MIs[0] rs1
     /*  191332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191344 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191349 */     GIR_RootConstrainSelectedInstOperands,
     /*  191350 */     // GIR_Coverage, 381,
     /*  191350 */     GIR_Done,
     /*  191351 */   // Label 3687: @191351
     /*  191351 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(191392), // Rule ID 383 //
     /*  191356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191359 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191373 */     // MIs[0] rs1
     /*  191373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191385 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  191390 */     GIR_RootConstrainSelectedInstOperands,
     /*  191391 */     // GIR_Coverage, 383,
     /*  191391 */     GIR_Done,
     /*  191392 */   // Label 3688: @191392
     /*  191392 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(191433), // Rule ID 385 //
     /*  191397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191414 */     // MIs[0] rs1
     /*  191414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191426 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  191431 */     GIR_RootConstrainSelectedInstOperands,
     /*  191432 */     // GIR_Coverage, 385,
     /*  191432 */     GIR_Done,
     /*  191433 */   // Label 3689: @191433
     /*  191433 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(191474), // Rule ID 387 //
     /*  191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191455 */     // MIs[0] rs1
     /*  191455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191467 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  191472 */     GIR_RootConstrainSelectedInstOperands,
     /*  191473 */     // GIR_Coverage, 387,
     /*  191473 */     GIR_Done,
     /*  191474 */   // Label 3690: @191474
     /*  191474 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(191515), // Rule ID 389 //
     /*  191479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191482 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191496 */     // MIs[0] rs1
     /*  191496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191508 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  191513 */     GIR_RootConstrainSelectedInstOperands,
     /*  191514 */     // GIR_Coverage, 389,
     /*  191514 */     GIR_Done,
     /*  191515 */   // Label 3691: @191515
     /*  191515 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(191556), // Rule ID 391 //
     /*  191520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191523 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191530 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191537 */     // MIs[0] rs1
     /*  191537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191549 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191554 */     GIR_RootConstrainSelectedInstOperands,
     /*  191555 */     // GIR_Coverage, 391,
     /*  191555 */     GIR_Done,
     /*  191556 */   // Label 3692: @191556
     /*  191556 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(191597), // Rule ID 393 //
     /*  191561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191578 */     // MIs[0] rs1
     /*  191578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191590 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191595 */     GIR_RootConstrainSelectedInstOperands,
     /*  191596 */     // GIR_Coverage, 393,
     /*  191596 */     GIR_Done,
     /*  191597 */   // Label 3693: @191597
     /*  191597 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(191638), // Rule ID 395 //
     /*  191602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191619 */     // MIs[0] rs1
     /*  191619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191631 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191636 */     GIR_RootConstrainSelectedInstOperands,
     /*  191637 */     // GIR_Coverage, 395,
     /*  191637 */     GIR_Done,
     /*  191638 */   // Label 3694: @191638
     /*  191638 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(191679), // Rule ID 397 //
     /*  191643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191660 */     // MIs[0] rs1
     /*  191660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191672 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191677 */     GIR_RootConstrainSelectedInstOperands,
     /*  191678 */     // GIR_Coverage, 397,
     /*  191678 */     GIR_Done,
     /*  191679 */   // Label 3695: @191679
     /*  191679 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(191720), // Rule ID 399 //
     /*  191684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191701 */     // MIs[0] rs1
     /*  191701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191713 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  191718 */     GIR_RootConstrainSelectedInstOperands,
     /*  191719 */     // GIR_Coverage, 399,
     /*  191719 */     GIR_Done,
     /*  191720 */   // Label 3696: @191720
     /*  191720 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(191761), // Rule ID 541 //
     /*  191725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191742 */     // MIs[0] rs1
     /*  191742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191754 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  191759 */     GIR_RootConstrainSelectedInstOperands,
     /*  191760 */     // GIR_Coverage, 541,
     /*  191760 */     GIR_Done,
     /*  191761 */   // Label 3697: @191761
     /*  191761 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(191802), // Rule ID 542 //
     /*  191766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191783 */     // MIs[0] rs1
     /*  191783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191795 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  191800 */     GIR_RootConstrainSelectedInstOperands,
     /*  191801 */     // GIR_Coverage, 542,
     /*  191801 */     GIR_Done,
     /*  191802 */   // Label 3698: @191802
     /*  191802 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(191843), // Rule ID 543 //
     /*  191807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191824 */     // MIs[0] rs1
     /*  191824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191836 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  191841 */     GIR_RootConstrainSelectedInstOperands,
     /*  191842 */     // GIR_Coverage, 543,
     /*  191842 */     GIR_Done,
     /*  191843 */   // Label 3699: @191843
     /*  191843 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(191884), // Rule ID 544 //
     /*  191848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191865 */     // MIs[0] rs1
     /*  191865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191877 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  191882 */     GIR_RootConstrainSelectedInstOperands,
     /*  191883 */     // GIR_Coverage, 544,
     /*  191883 */     GIR_Done,
     /*  191884 */   // Label 3700: @191884
     /*  191884 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(191925), // Rule ID 545 //
     /*  191889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191906 */     // MIs[0] rs1
     /*  191906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191918 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  191923 */     GIR_RootConstrainSelectedInstOperands,
     /*  191924 */     // GIR_Coverage, 545,
     /*  191924 */     GIR_Done,
     /*  191925 */   // Label 3701: @191925
     /*  191925 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(191966), // Rule ID 546 //
     /*  191930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191947 */     // MIs[0] rs1
     /*  191947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191959 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  191964 */     GIR_RootConstrainSelectedInstOperands,
     /*  191965 */     // GIR_Coverage, 546,
     /*  191965 */     GIR_Done,
     /*  191966 */   // Label 3702: @191966
     /*  191966 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(192007), // Rule ID 547 //
     /*  191971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191988 */     // MIs[0] rs1
     /*  191988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192000 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192005 */     GIR_RootConstrainSelectedInstOperands,
     /*  192006 */     // GIR_Coverage, 547,
     /*  192006 */     GIR_Done,
     /*  192007 */   // Label 3703: @192007
     /*  192007 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(192048), // Rule ID 548 //
     /*  192012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192029 */     // MIs[0] rs1
     /*  192029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192041 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192046 */     GIR_RootConstrainSelectedInstOperands,
     /*  192047 */     // GIR_Coverage, 548,
     /*  192047 */     GIR_Done,
     /*  192048 */   // Label 3704: @192048
     /*  192048 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(192089), // Rule ID 549 //
     /*  192053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192070 */     // MIs[0] rs1
     /*  192070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192082 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192087 */     GIR_RootConstrainSelectedInstOperands,
     /*  192088 */     // GIR_Coverage, 549,
     /*  192088 */     GIR_Done,
     /*  192089 */   // Label 3705: @192089
     /*  192089 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(192130), // Rule ID 550 //
     /*  192094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192111 */     // MIs[0] rs1
     /*  192111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192123 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  192128 */     GIR_RootConstrainSelectedInstOperands,
     /*  192129 */     // GIR_Coverage, 550,
     /*  192129 */     GIR_Done,
     /*  192130 */   // Label 3706: @192130
     /*  192130 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(192171), // Rule ID 729 //
     /*  192135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192152 */     // MIs[0] rs1
     /*  192152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192164 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192169 */     GIR_RootConstrainSelectedInstOperands,
     /*  192170 */     // GIR_Coverage, 729,
     /*  192170 */     GIR_Done,
     /*  192171 */   // Label 3707: @192171
     /*  192171 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(192212), // Rule ID 731 //
     /*  192176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192193 */     // MIs[0] rs1
     /*  192193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192205 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  192210 */     GIR_RootConstrainSelectedInstOperands,
     /*  192211 */     // GIR_Coverage, 731,
     /*  192211 */     GIR_Done,
     /*  192212 */   // Label 3708: @192212
     /*  192212 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(192253), // Rule ID 733 //
     /*  192217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192234 */     // MIs[0] rs1
     /*  192234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192246 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  192251 */     GIR_RootConstrainSelectedInstOperands,
     /*  192252 */     // GIR_Coverage, 733,
     /*  192252 */     GIR_Done,
     /*  192253 */   // Label 3709: @192253
     /*  192253 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(192294), // Rule ID 735 //
     /*  192258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192275 */     // MIs[0] rs1
     /*  192275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192287 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  192292 */     GIR_RootConstrainSelectedInstOperands,
     /*  192293 */     // GIR_Coverage, 735,
     /*  192293 */     GIR_Done,
     /*  192294 */   // Label 3710: @192294
     /*  192294 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(192335), // Rule ID 737 //
     /*  192299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192316 */     // MIs[0] rs1
     /*  192316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192328 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  192333 */     GIR_RootConstrainSelectedInstOperands,
     /*  192334 */     // GIR_Coverage, 737,
     /*  192334 */     GIR_Done,
     /*  192335 */   // Label 3711: @192335
     /*  192335 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(192376), // Rule ID 739 //
     /*  192340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192357 */     // MIs[0] rs1
     /*  192357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192369 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192374 */     GIR_RootConstrainSelectedInstOperands,
     /*  192375 */     // GIR_Coverage, 739,
     /*  192375 */     GIR_Done,
     /*  192376 */   // Label 3712: @192376
     /*  192376 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(192417), // Rule ID 741 //
     /*  192381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192398 */     // MIs[0] rs1
     /*  192398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192410 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192415 */     GIR_RootConstrainSelectedInstOperands,
     /*  192416 */     // GIR_Coverage, 741,
     /*  192416 */     GIR_Done,
     /*  192417 */   // Label 3713: @192417
     /*  192417 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(192458), // Rule ID 743 //
     /*  192422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192439 */     // MIs[0] rs1
     /*  192439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192451 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192456 */     GIR_RootConstrainSelectedInstOperands,
     /*  192457 */     // GIR_Coverage, 743,
     /*  192457 */     GIR_Done,
     /*  192458 */   // Label 3714: @192458
     /*  192458 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(192499), // Rule ID 745 //
     /*  192463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192480 */     // MIs[0] rs1
     /*  192480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192492 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192497 */     GIR_RootConstrainSelectedInstOperands,
     /*  192498 */     // GIR_Coverage, 745,
     /*  192498 */     GIR_Done,
     /*  192499 */   // Label 3715: @192499
     /*  192499 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(192540), // Rule ID 747 //
     /*  192504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192521 */     // MIs[0] rs1
     /*  192521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192533 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  192538 */     GIR_RootConstrainSelectedInstOperands,
     /*  192539 */     // GIR_Coverage, 747,
     /*  192539 */     GIR_Done,
     /*  192540 */   // Label 3716: @192540
     /*  192540 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(192581), // Rule ID 909 //
     /*  192545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192562 */     // MIs[0] rs1
     /*  192562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192574 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192579 */     GIR_RootConstrainSelectedInstOperands,
     /*  192580 */     // GIR_Coverage, 909,
     /*  192580 */     GIR_Done,
     /*  192581 */   // Label 3717: @192581
     /*  192581 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(192622), // Rule ID 911 //
     /*  192586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192603 */     // MIs[0] rs1
     /*  192603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192615 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  192620 */     GIR_RootConstrainSelectedInstOperands,
     /*  192621 */     // GIR_Coverage, 911,
     /*  192621 */     GIR_Done,
     /*  192622 */   // Label 3718: @192622
     /*  192622 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(192663), // Rule ID 913 //
     /*  192627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192644 */     // MIs[0] rs1
     /*  192644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192656 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  192661 */     GIR_RootConstrainSelectedInstOperands,
     /*  192662 */     // GIR_Coverage, 913,
     /*  192662 */     GIR_Done,
     /*  192663 */   // Label 3719: @192663
     /*  192663 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(192704), // Rule ID 915 //
     /*  192668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192685 */     // MIs[0] rs1
     /*  192685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192697 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  192702 */     GIR_RootConstrainSelectedInstOperands,
     /*  192703 */     // GIR_Coverage, 915,
     /*  192703 */     GIR_Done,
     /*  192704 */   // Label 3720: @192704
     /*  192704 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(192745), // Rule ID 917 //
     /*  192709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192726 */     // MIs[0] rs1
     /*  192726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192738 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  192743 */     GIR_RootConstrainSelectedInstOperands,
     /*  192744 */     // GIR_Coverage, 917,
     /*  192744 */     GIR_Done,
     /*  192745 */   // Label 3721: @192745
     /*  192745 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(192786), // Rule ID 919 //
     /*  192750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192767 */     // MIs[0] rs1
     /*  192767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192779 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192784 */     GIR_RootConstrainSelectedInstOperands,
     /*  192785 */     // GIR_Coverage, 919,
     /*  192785 */     GIR_Done,
     /*  192786 */   // Label 3722: @192786
     /*  192786 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(192827), // Rule ID 921 //
     /*  192791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192808 */     // MIs[0] rs1
     /*  192808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192820 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192825 */     GIR_RootConstrainSelectedInstOperands,
     /*  192826 */     // GIR_Coverage, 921,
     /*  192826 */     GIR_Done,
     /*  192827 */   // Label 3723: @192827
     /*  192827 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(192868), // Rule ID 923 //
     /*  192832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192849 */     // MIs[0] rs1
     /*  192849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192861 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192866 */     GIR_RootConstrainSelectedInstOperands,
     /*  192867 */     // GIR_Coverage, 923,
     /*  192867 */     GIR_Done,
     /*  192868 */   // Label 3724: @192868
     /*  192868 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(192909), // Rule ID 925 //
     /*  192873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192890 */     // MIs[0] rs1
     /*  192890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192902 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192907 */     GIR_RootConstrainSelectedInstOperands,
     /*  192908 */     // GIR_Coverage, 925,
     /*  192908 */     GIR_Done,
     /*  192909 */   // Label 3725: @192909
     /*  192909 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(192950), // Rule ID 927 //
     /*  192914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192931 */     // MIs[0] rs1
     /*  192931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192943 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  192948 */     GIR_RootConstrainSelectedInstOperands,
     /*  192949 */     // GIR_Coverage, 927,
     /*  192949 */     GIR_Done,
     /*  192950 */   // Label 3726: @192950
     /*  192950 */   GIM_Reject,
     /*  192951 */ // Label 3686: @192951
     /*  192951 */ GIM_Reject,
     /*  192952 */ // Label 3654: @192952
     /*  192952 */ GIM_Reject,
     /*  192953 */ // Label 29: @192953
     /*  192953 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3729*/ GIMT_Encode4(193864),
     /*  192964 */ /*GILLT_s32*//*Label 3727*/ GIMT_Encode4(192972),
     /*  192968 */ /*GILLT_s64*//*Label 3728*/ GIMT_Encode4(193254),
     /*  192972 */ // Label 3727: @192972
     /*  192972 */ GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(193253),
     /*  192977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  192980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192987 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(193040), // Rule ID 612 //
     /*  192992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  192995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193002 */     // MIs[0] addr
     /*  193002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193014 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  193014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193022 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193027 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193029 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193038 */     GIR_RootConstrainSelectedInstOperands,
     /*  193039 */     // GIR_Coverage, 612,
     /*  193039 */     GIR_EraseRootFromParent_Done,
     /*  193040 */   // Label 3731: @193040
     /*  193040 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(193093), // Rule ID 614 //
     /*  193045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193055 */     // MIs[0] addr
     /*  193055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193067 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  193067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193075 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193080 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193082 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193091 */     GIR_RootConstrainSelectedInstOperands,
     /*  193092 */     // GIR_Coverage, 614,
     /*  193092 */     GIR_EraseRootFromParent_Done,
     /*  193093 */   // Label 3732: @193093
     /*  193093 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(193146), // Rule ID 616 //
     /*  193098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193101 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193108 */     // MIs[0] addr
     /*  193108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193120 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  193120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193128 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193133 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193135 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193144 */     GIR_RootConstrainSelectedInstOperands,
     /*  193145 */     // GIR_Coverage, 616,
     /*  193145 */     GIR_EraseRootFromParent_Done,
     /*  193146 */   // Label 3733: @193146
     /*  193146 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(193199), // Rule ID 618 //
     /*  193151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193161 */     // MIs[0] addr
     /*  193161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193173 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  193173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193181 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193186 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193188 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193197 */     GIR_RootConstrainSelectedInstOperands,
     /*  193198 */     // GIR_Coverage, 618,
     /*  193198 */     GIR_EraseRootFromParent_Done,
     /*  193199 */   // Label 3734: @193199
     /*  193199 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(193252), // Rule ID 620 //
     /*  193204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  193207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193214 */     // MIs[0] addr
     /*  193214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193226 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  193226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193234 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193239 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193241 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193250 */     GIR_RootConstrainSelectedInstOperands,
     /*  193251 */     // GIR_Coverage, 620,
     /*  193251 */     GIR_EraseRootFromParent_Done,
     /*  193252 */   // Label 3735: @193252
     /*  193252 */   GIM_Reject,
     /*  193253 */ // Label 3730: @193253
     /*  193253 */ GIM_Reject,
     /*  193254 */ // Label 3728: @193254
     /*  193254 */ GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(193863),
     /*  193259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  193262 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(193322), // Rule ID 611 //
     /*  193267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193284 */     // MIs[0] addr
     /*  193284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193296 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  193296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193304 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193309 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193311 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193320 */     GIR_RootConstrainSelectedInstOperands,
     /*  193321 */     // GIR_Coverage, 611,
     /*  193321 */     GIR_EraseRootFromParent_Done,
     /*  193322 */   // Label 3737: @193322
     /*  193322 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(193382), // Rule ID 613 //
     /*  193327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193344 */     // MIs[0] addr
     /*  193344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193356 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  193356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193364 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193369 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193371 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193380 */     GIR_RootConstrainSelectedInstOperands,
     /*  193381 */     // GIR_Coverage, 613,
     /*  193381 */     GIR_EraseRootFromParent_Done,
     /*  193382 */   // Label 3738: @193382
     /*  193382 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(193442), // Rule ID 615 //
     /*  193387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193404 */     // MIs[0] addr
     /*  193404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193416 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  193416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193424 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193429 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193431 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193440 */     GIR_RootConstrainSelectedInstOperands,
     /*  193441 */     // GIR_Coverage, 615,
     /*  193441 */     GIR_EraseRootFromParent_Done,
     /*  193442 */   // Label 3739: @193442
     /*  193442 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(193502), // Rule ID 617 //
     /*  193447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193464 */     // MIs[0] addr
     /*  193464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193476 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  193476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193484 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193489 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193491 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193500 */     GIR_RootConstrainSelectedInstOperands,
     /*  193501 */     // GIR_Coverage, 617,
     /*  193501 */     GIR_EraseRootFromParent_Done,
     /*  193502 */   // Label 3740: @193502
     /*  193502 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(193562), // Rule ID 619 //
     /*  193507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  193510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193524 */     // MIs[0] addr
     /*  193524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193536 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  193536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  193542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193544 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193549 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193551 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193560 */     GIR_RootConstrainSelectedInstOperands,
     /*  193561 */     // GIR_Coverage, 619,
     /*  193561 */     GIR_EraseRootFromParent_Done,
     /*  193562 */   // Label 3741: @193562
     /*  193562 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(193622), // Rule ID 629 //
     /*  193567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193584 */     // MIs[0] addr
     /*  193584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193596 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  193596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193604 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193609 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193611 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  193616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193620 */     GIR_RootConstrainSelectedInstOperands,
     /*  193621 */     // GIR_Coverage, 629,
     /*  193621 */     GIR_EraseRootFromParent_Done,
     /*  193622 */   // Label 3742: @193622
     /*  193622 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(193682), // Rule ID 630 //
     /*  193627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193644 */     // MIs[0] addr
     /*  193644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193656 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  193656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193664 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193669 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193671 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  193676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193680 */     GIR_RootConstrainSelectedInstOperands,
     /*  193681 */     // GIR_Coverage, 630,
     /*  193681 */     GIR_EraseRootFromParent_Done,
     /*  193682 */   // Label 3743: @193682
     /*  193682 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(193742), // Rule ID 631 //
     /*  193687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193704 */     // MIs[0] addr
     /*  193704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193716 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  193716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193724 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193729 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193731 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  193736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193740 */     GIR_RootConstrainSelectedInstOperands,
     /*  193741 */     // GIR_Coverage, 631,
     /*  193741 */     GIR_EraseRootFromParent_Done,
     /*  193742 */   // Label 3744: @193742
     /*  193742 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(193802), // Rule ID 632 //
     /*  193747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193764 */     // MIs[0] addr
     /*  193764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193776 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  193776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193784 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193789 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193791 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  193796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193800 */     GIR_RootConstrainSelectedInstOperands,
     /*  193801 */     // GIR_Coverage, 632,
     /*  193801 */     GIR_EraseRootFromParent_Done,
     /*  193802 */   // Label 3745: @193802
     /*  193802 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(193862), // Rule ID 633 //
     /*  193807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  193810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  193817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193824 */     // MIs[0] addr
     /*  193824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  193828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193836 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  193836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  193839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  193842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  193844 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  193849 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  193851 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  193853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  193856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  193860 */     GIR_RootConstrainSelectedInstOperands,
     /*  193861 */     // GIR_Coverage, 633,
     /*  193861 */     GIR_EraseRootFromParent_Done,
     /*  193862 */   // Label 3746: @193862
     /*  193862 */   GIM_Reject,
     /*  193863 */ // Label 3736: @193863
     /*  193863 */ GIM_Reject,
     /*  193864 */ // Label 3729: @193864
     /*  193864 */ GIM_Reject,
     /*  193865 */ // Label 30: @193865
     /*  193865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3749*/ GIMT_Encode4(196774),
     /*  193876 */ /*GILLT_s32*//*Label 3747*/ GIMT_Encode4(193884),
     /*  193880 */ /*GILLT_s64*//*Label 3748*/ GIMT_Encode4(195124),
     /*  193884 */ // Label 3747: @193884
     /*  193884 */ GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(195123),
     /*  193889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  193892 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(193933), // Rule ID 402 //
     /*  193897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193914 */     // MIs[0] rs1
     /*  193914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193926 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  193931 */     GIR_RootConstrainSelectedInstOperands,
     /*  193932 */     // GIR_Coverage, 402,
     /*  193932 */     GIR_Done,
     /*  193933 */   // Label 3751: @193933
     /*  193933 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(193974), // Rule ID 404 //
     /*  193938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193955 */     // MIs[0] rs1
     /*  193955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193967 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  193972 */     GIR_RootConstrainSelectedInstOperands,
     /*  193973 */     // GIR_Coverage, 404,
     /*  193973 */     GIR_Done,
     /*  193974 */   // Label 3752: @193974
     /*  193974 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(194015), // Rule ID 406 //
     /*  193979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193996 */     // MIs[0] rs1
     /*  193996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194008 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  194013 */     GIR_RootConstrainSelectedInstOperands,
     /*  194014 */     // GIR_Coverage, 406,
     /*  194014 */     GIR_Done,
     /*  194015 */   // Label 3753: @194015
     /*  194015 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(194056), // Rule ID 408 //
     /*  194020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  194023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194037 */     // MIs[0] rs1
     /*  194037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194049 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  194054 */     GIR_RootConstrainSelectedInstOperands,
     /*  194055 */     // GIR_Coverage, 408,
     /*  194055 */     GIR_Done,
     /*  194056 */   // Label 3754: @194056
     /*  194056 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(194097), // Rule ID 410 //
     /*  194061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  194064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194078 */     // MIs[0] rs1
     /*  194078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194090 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  194095 */     GIR_RootConstrainSelectedInstOperands,
     /*  194096 */     // GIR_Coverage, 410,
     /*  194096 */     GIR_Done,
     /*  194097 */   // Label 3755: @194097
     /*  194097 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(194138), // Rule ID 412 //
     /*  194102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194119 */     // MIs[0] rs1
     /*  194119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194131 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194136 */     GIR_RootConstrainSelectedInstOperands,
     /*  194137 */     // GIR_Coverage, 412,
     /*  194137 */     GIR_Done,
     /*  194138 */   // Label 3756: @194138
     /*  194138 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(194179), // Rule ID 414 //
     /*  194143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194160 */     // MIs[0] rs1
     /*  194160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194172 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194177 */     GIR_RootConstrainSelectedInstOperands,
     /*  194178 */     // GIR_Coverage, 414,
     /*  194178 */     GIR_Done,
     /*  194179 */   // Label 3757: @194179
     /*  194179 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(194220), // Rule ID 416 //
     /*  194184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194201 */     // MIs[0] rs1
     /*  194201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194213 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194218 */     GIR_RootConstrainSelectedInstOperands,
     /*  194219 */     // GIR_Coverage, 416,
     /*  194219 */     GIR_Done,
     /*  194220 */   // Label 3758: @194220
     /*  194220 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(194261), // Rule ID 418 //
     /*  194225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194242 */     // MIs[0] rs1
     /*  194242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194254 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194259 */     GIR_RootConstrainSelectedInstOperands,
     /*  194260 */     // GIR_Coverage, 418,
     /*  194260 */     GIR_Done,
     /*  194261 */   // Label 3759: @194261
     /*  194261 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(194302), // Rule ID 420 //
     /*  194266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  194269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194283 */     // MIs[0] rs1
     /*  194283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194295 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  194300 */     GIR_RootConstrainSelectedInstOperands,
     /*  194301 */     // GIR_Coverage, 420,
     /*  194301 */     GIR_Done,
     /*  194302 */   // Label 3760: @194302
     /*  194302 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(194343), // Rule ID 750 //
     /*  194307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194324 */     // MIs[0] rs1
     /*  194324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194336 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194341 */     GIR_RootConstrainSelectedInstOperands,
     /*  194342 */     // GIR_Coverage, 750,
     /*  194342 */     GIR_Done,
     /*  194343 */   // Label 3761: @194343
     /*  194343 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(194384), // Rule ID 752 //
     /*  194348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194365 */     // MIs[0] rs1
     /*  194365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194377 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  194382 */     GIR_RootConstrainSelectedInstOperands,
     /*  194383 */     // GIR_Coverage, 752,
     /*  194383 */     GIR_Done,
     /*  194384 */   // Label 3762: @194384
     /*  194384 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(194425), // Rule ID 754 //
     /*  194389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194406 */     // MIs[0] rs1
     /*  194406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194418 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  194423 */     GIR_RootConstrainSelectedInstOperands,
     /*  194424 */     // GIR_Coverage, 754,
     /*  194424 */     GIR_Done,
     /*  194425 */   // Label 3763: @194425
     /*  194425 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(194466), // Rule ID 756 //
     /*  194430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194447 */     // MIs[0] rs1
     /*  194447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194459 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  194464 */     GIR_RootConstrainSelectedInstOperands,
     /*  194465 */     // GIR_Coverage, 756,
     /*  194465 */     GIR_Done,
     /*  194466 */   // Label 3764: @194466
     /*  194466 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(194507), // Rule ID 758 //
     /*  194471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194488 */     // MIs[0] rs1
     /*  194488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194500 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  194505 */     GIR_RootConstrainSelectedInstOperands,
     /*  194506 */     // GIR_Coverage, 758,
     /*  194506 */     GIR_Done,
     /*  194507 */   // Label 3765: @194507
     /*  194507 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(194548), // Rule ID 760 //
     /*  194512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194529 */     // MIs[0] rs1
     /*  194529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194541 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194546 */     GIR_RootConstrainSelectedInstOperands,
     /*  194547 */     // GIR_Coverage, 760,
     /*  194547 */     GIR_Done,
     /*  194548 */   // Label 3766: @194548
     /*  194548 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(194589), // Rule ID 762 //
     /*  194553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194570 */     // MIs[0] rs1
     /*  194570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194582 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194587 */     GIR_RootConstrainSelectedInstOperands,
     /*  194588 */     // GIR_Coverage, 762,
     /*  194588 */     GIR_Done,
     /*  194589 */   // Label 3767: @194589
     /*  194589 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(194630), // Rule ID 764 //
     /*  194594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194611 */     // MIs[0] rs1
     /*  194611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194623 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194628 */     GIR_RootConstrainSelectedInstOperands,
     /*  194629 */     // GIR_Coverage, 764,
     /*  194629 */     GIR_Done,
     /*  194630 */   // Label 3768: @194630
     /*  194630 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(194671), // Rule ID 766 //
     /*  194635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194652 */     // MIs[0] rs1
     /*  194652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194664 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194669 */     GIR_RootConstrainSelectedInstOperands,
     /*  194670 */     // GIR_Coverage, 766,
     /*  194670 */     GIR_Done,
     /*  194671 */   // Label 3769: @194671
     /*  194671 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(194712), // Rule ID 768 //
     /*  194676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194693 */     // MIs[0] rs1
     /*  194693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194705 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  194710 */     GIR_RootConstrainSelectedInstOperands,
     /*  194711 */     // GIR_Coverage, 768,
     /*  194711 */     GIR_Done,
     /*  194712 */   // Label 3770: @194712
     /*  194712 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(194753), // Rule ID 930 //
     /*  194717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194734 */     // MIs[0] rs1
     /*  194734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194746 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194751 */     GIR_RootConstrainSelectedInstOperands,
     /*  194752 */     // GIR_Coverage, 930,
     /*  194752 */     GIR_Done,
     /*  194753 */   // Label 3771: @194753
     /*  194753 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(194794), // Rule ID 932 //
     /*  194758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194775 */     // MIs[0] rs1
     /*  194775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194787 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  194792 */     GIR_RootConstrainSelectedInstOperands,
     /*  194793 */     // GIR_Coverage, 932,
     /*  194793 */     GIR_Done,
     /*  194794 */   // Label 3772: @194794
     /*  194794 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(194835), // Rule ID 934 //
     /*  194799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194816 */     // MIs[0] rs1
     /*  194816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194828 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  194833 */     GIR_RootConstrainSelectedInstOperands,
     /*  194834 */     // GIR_Coverage, 934,
     /*  194834 */     GIR_Done,
     /*  194835 */   // Label 3773: @194835
     /*  194835 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(194876), // Rule ID 936 //
     /*  194840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194857 */     // MIs[0] rs1
     /*  194857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194869 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  194874 */     GIR_RootConstrainSelectedInstOperands,
     /*  194875 */     // GIR_Coverage, 936,
     /*  194875 */     GIR_Done,
     /*  194876 */   // Label 3774: @194876
     /*  194876 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(194917), // Rule ID 938 //
     /*  194881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  194884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194898 */     // MIs[0] rs1
     /*  194898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194910 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  194915 */     GIR_RootConstrainSelectedInstOperands,
     /*  194916 */     // GIR_Coverage, 938,
     /*  194916 */     GIR_Done,
     /*  194917 */   // Label 3775: @194917
     /*  194917 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(194958), // Rule ID 940 //
     /*  194922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194939 */     // MIs[0] rs1
     /*  194939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194951 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194956 */     GIR_RootConstrainSelectedInstOperands,
     /*  194957 */     // GIR_Coverage, 940,
     /*  194957 */     GIR_Done,
     /*  194958 */   // Label 3776: @194958
     /*  194958 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(194999), // Rule ID 942 //
     /*  194963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194980 */     // MIs[0] rs1
     /*  194980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194992 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  194997 */     GIR_RootConstrainSelectedInstOperands,
     /*  194998 */     // GIR_Coverage, 942,
     /*  194998 */     GIR_Done,
     /*  194999 */   // Label 3777: @194999
     /*  194999 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(195040), // Rule ID 944 //
     /*  195004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195021 */     // MIs[0] rs1
     /*  195021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195033 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195038 */     GIR_RootConstrainSelectedInstOperands,
     /*  195039 */     // GIR_Coverage, 944,
     /*  195039 */     GIR_Done,
     /*  195040 */   // Label 3778: @195040
     /*  195040 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(195081), // Rule ID 946 //
     /*  195045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195062 */     // MIs[0] rs1
     /*  195062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195074 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195079 */     GIR_RootConstrainSelectedInstOperands,
     /*  195080 */     // GIR_Coverage, 946,
     /*  195080 */     GIR_Done,
     /*  195081 */   // Label 3779: @195081
     /*  195081 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(195122), // Rule ID 948 //
     /*  195086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195103 */     // MIs[0] rs1
     /*  195103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195115 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  195120 */     GIR_RootConstrainSelectedInstOperands,
     /*  195121 */     // GIR_Coverage, 948,
     /*  195121 */     GIR_Done,
     /*  195122 */   // Label 3780: @195122
     /*  195122 */   GIM_Reject,
     /*  195123 */ // Label 3750: @195123
     /*  195123 */ GIM_Reject,
     /*  195124 */ // Label 3748: @195124
     /*  195124 */ GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(196773),
     /*  195129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  195132 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(195173), // Rule ID 401 //
     /*  195137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195154 */     // MIs[0] rs1
     /*  195154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195166 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195171 */     GIR_RootConstrainSelectedInstOperands,
     /*  195172 */     // GIR_Coverage, 401,
     /*  195172 */     GIR_Done,
     /*  195173 */   // Label 3782: @195173
     /*  195173 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(195214), // Rule ID 403 //
     /*  195178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195195 */     // MIs[0] rs1
     /*  195195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195207 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  195212 */     GIR_RootConstrainSelectedInstOperands,
     /*  195213 */     // GIR_Coverage, 403,
     /*  195213 */     GIR_Done,
     /*  195214 */   // Label 3783: @195214
     /*  195214 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(195255), // Rule ID 405 //
     /*  195219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195236 */     // MIs[0] rs1
     /*  195236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195248 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  195253 */     GIR_RootConstrainSelectedInstOperands,
     /*  195254 */     // GIR_Coverage, 405,
     /*  195254 */     GIR_Done,
     /*  195255 */   // Label 3784: @195255
     /*  195255 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(195296), // Rule ID 407 //
     /*  195260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195263 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195270 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195277 */     // MIs[0] rs1
     /*  195277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195289 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  195294 */     GIR_RootConstrainSelectedInstOperands,
     /*  195295 */     // GIR_Coverage, 407,
     /*  195295 */     GIR_Done,
     /*  195296 */   // Label 3785: @195296
     /*  195296 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(195337), // Rule ID 409 //
     /*  195301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  195304 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195318 */     // MIs[0] rs1
     /*  195318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195330 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  195335 */     GIR_RootConstrainSelectedInstOperands,
     /*  195336 */     // GIR_Coverage, 409,
     /*  195336 */     GIR_Done,
     /*  195337 */   // Label 3786: @195337
     /*  195337 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(195378), // Rule ID 411 //
     /*  195342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195352 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195359 */     // MIs[0] rs1
     /*  195359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195371 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195376 */     GIR_RootConstrainSelectedInstOperands,
     /*  195377 */     // GIR_Coverage, 411,
     /*  195377 */     GIR_Done,
     /*  195378 */   // Label 3787: @195378
     /*  195378 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(195419), // Rule ID 413 //
     /*  195383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195400 */     // MIs[0] rs1
     /*  195400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195412 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195417 */     GIR_RootConstrainSelectedInstOperands,
     /*  195418 */     // GIR_Coverage, 413,
     /*  195418 */     GIR_Done,
     /*  195419 */   // Label 3788: @195419
     /*  195419 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(195460), // Rule ID 415 //
     /*  195424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195441 */     // MIs[0] rs1
     /*  195441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195453 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195458 */     GIR_RootConstrainSelectedInstOperands,
     /*  195459 */     // GIR_Coverage, 415,
     /*  195459 */     GIR_Done,
     /*  195460 */   // Label 3789: @195460
     /*  195460 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(195501), // Rule ID 417 //
     /*  195465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195482 */     // MIs[0] rs1
     /*  195482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195494 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195499 */     GIR_RootConstrainSelectedInstOperands,
     /*  195500 */     // GIR_Coverage, 417,
     /*  195500 */     GIR_Done,
     /*  195501 */   // Label 3790: @195501
     /*  195501 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(195542), // Rule ID 419 //
     /*  195506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  195509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195523 */     // MIs[0] rs1
     /*  195523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195535 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  195540 */     GIR_RootConstrainSelectedInstOperands,
     /*  195541 */     // GIR_Coverage, 419,
     /*  195541 */     GIR_Done,
     /*  195542 */   // Label 3791: @195542
     /*  195542 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(195583), // Rule ID 551 //
     /*  195547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195564 */     // MIs[0] rs1
     /*  195564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195576 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195581 */     GIR_RootConstrainSelectedInstOperands,
     /*  195582 */     // GIR_Coverage, 551,
     /*  195582 */     GIR_Done,
     /*  195583 */   // Label 3792: @195583
     /*  195583 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(195624), // Rule ID 552 //
     /*  195588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195605 */     // MIs[0] rs1
     /*  195605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195617 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  195622 */     GIR_RootConstrainSelectedInstOperands,
     /*  195623 */     // GIR_Coverage, 552,
     /*  195623 */     GIR_Done,
     /*  195624 */   // Label 3793: @195624
     /*  195624 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(195665), // Rule ID 553 //
     /*  195629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195646 */     // MIs[0] rs1
     /*  195646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195658 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  195663 */     GIR_RootConstrainSelectedInstOperands,
     /*  195664 */     // GIR_Coverage, 553,
     /*  195664 */     GIR_Done,
     /*  195665 */   // Label 3794: @195665
     /*  195665 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(195706), // Rule ID 554 //
     /*  195670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195687 */     // MIs[0] rs1
     /*  195687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195699 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  195704 */     GIR_RootConstrainSelectedInstOperands,
     /*  195705 */     // GIR_Coverage, 554,
     /*  195705 */     GIR_Done,
     /*  195706 */   // Label 3795: @195706
     /*  195706 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(195747), // Rule ID 555 //
     /*  195711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  195714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195728 */     // MIs[0] rs1
     /*  195728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195740 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  195745 */     GIR_RootConstrainSelectedInstOperands,
     /*  195746 */     // GIR_Coverage, 555,
     /*  195746 */     GIR_Done,
     /*  195747 */   // Label 3796: @195747
     /*  195747 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(195788), // Rule ID 556 //
     /*  195752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195769 */     // MIs[0] rs1
     /*  195769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195781 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195786 */     GIR_RootConstrainSelectedInstOperands,
     /*  195787 */     // GIR_Coverage, 556,
     /*  195787 */     GIR_Done,
     /*  195788 */   // Label 3797: @195788
     /*  195788 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(195829), // Rule ID 557 //
     /*  195793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195810 */     // MIs[0] rs1
     /*  195810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195822 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195827 */     GIR_RootConstrainSelectedInstOperands,
     /*  195828 */     // GIR_Coverage, 557,
     /*  195828 */     GIR_Done,
     /*  195829 */   // Label 3798: @195829
     /*  195829 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(195870), // Rule ID 558 //
     /*  195834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195851 */     // MIs[0] rs1
     /*  195851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195863 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195868 */     GIR_RootConstrainSelectedInstOperands,
     /*  195869 */     // GIR_Coverage, 558,
     /*  195869 */     GIR_Done,
     /*  195870 */   // Label 3799: @195870
     /*  195870 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(195911), // Rule ID 559 //
     /*  195875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195892 */     // MIs[0] rs1
     /*  195892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195904 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195909 */     GIR_RootConstrainSelectedInstOperands,
     /*  195910 */     // GIR_Coverage, 559,
     /*  195910 */     GIR_Done,
     /*  195911 */   // Label 3800: @195911
     /*  195911 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(195952), // Rule ID 560 //
     /*  195916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  195919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  195926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195933 */     // MIs[0] rs1
     /*  195933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195945 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  195950 */     GIR_RootConstrainSelectedInstOperands,
     /*  195951 */     // GIR_Coverage, 560,
     /*  195951 */     GIR_Done,
     /*  195952 */   // Label 3801: @195952
     /*  195952 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(195993), // Rule ID 749 //
     /*  195957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195974 */     // MIs[0] rs1
     /*  195974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195986 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  195991 */     GIR_RootConstrainSelectedInstOperands,
     /*  195992 */     // GIR_Coverage, 749,
     /*  195992 */     GIR_Done,
     /*  195993 */   // Label 3802: @195993
     /*  195993 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(196034), // Rule ID 751 //
     /*  195998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196015 */     // MIs[0] rs1
     /*  196015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196027 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  196032 */     GIR_RootConstrainSelectedInstOperands,
     /*  196033 */     // GIR_Coverage, 751,
     /*  196033 */     GIR_Done,
     /*  196034 */   // Label 3803: @196034
     /*  196034 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(196075), // Rule ID 753 //
     /*  196039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196056 */     // MIs[0] rs1
     /*  196056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196068 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  196073 */     GIR_RootConstrainSelectedInstOperands,
     /*  196074 */     // GIR_Coverage, 753,
     /*  196074 */     GIR_Done,
     /*  196075 */   // Label 3804: @196075
     /*  196075 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(196116), // Rule ID 755 //
     /*  196080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196097 */     // MIs[0] rs1
     /*  196097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196109 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  196114 */     GIR_RootConstrainSelectedInstOperands,
     /*  196115 */     // GIR_Coverage, 755,
     /*  196115 */     GIR_Done,
     /*  196116 */   // Label 3805: @196116
     /*  196116 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(196157), // Rule ID 757 //
     /*  196121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196124 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196138 */     // MIs[0] rs1
     /*  196138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196150 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  196155 */     GIR_RootConstrainSelectedInstOperands,
     /*  196156 */     // GIR_Coverage, 757,
     /*  196156 */     GIR_Done,
     /*  196157 */   // Label 3806: @196157
     /*  196157 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(196198), // Rule ID 759 //
     /*  196162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196179 */     // MIs[0] rs1
     /*  196179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196191 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196196 */     GIR_RootConstrainSelectedInstOperands,
     /*  196197 */     // GIR_Coverage, 759,
     /*  196197 */     GIR_Done,
     /*  196198 */   // Label 3807: @196198
     /*  196198 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(196239), // Rule ID 761 //
     /*  196203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196220 */     // MIs[0] rs1
     /*  196220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196232 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196237 */     GIR_RootConstrainSelectedInstOperands,
     /*  196238 */     // GIR_Coverage, 761,
     /*  196238 */     GIR_Done,
     /*  196239 */   // Label 3808: @196239
     /*  196239 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(196280), // Rule ID 763 //
     /*  196244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196247 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196261 */     // MIs[0] rs1
     /*  196261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196273 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196278 */     GIR_RootConstrainSelectedInstOperands,
     /*  196279 */     // GIR_Coverage, 763,
     /*  196279 */     GIR_Done,
     /*  196280 */   // Label 3809: @196280
     /*  196280 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(196321), // Rule ID 765 //
     /*  196285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196302 */     // MIs[0] rs1
     /*  196302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196314 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196319 */     GIR_RootConstrainSelectedInstOperands,
     /*  196320 */     // GIR_Coverage, 765,
     /*  196320 */     GIR_Done,
     /*  196321 */   // Label 3810: @196321
     /*  196321 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(196362), // Rule ID 767 //
     /*  196326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196343 */     // MIs[0] rs1
     /*  196343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196355 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  196360 */     GIR_RootConstrainSelectedInstOperands,
     /*  196361 */     // GIR_Coverage, 767,
     /*  196361 */     GIR_Done,
     /*  196362 */   // Label 3811: @196362
     /*  196362 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(196403), // Rule ID 929 //
     /*  196367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196384 */     // MIs[0] rs1
     /*  196384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196396 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196401 */     GIR_RootConstrainSelectedInstOperands,
     /*  196402 */     // GIR_Coverage, 929,
     /*  196402 */     GIR_Done,
     /*  196403 */   // Label 3812: @196403
     /*  196403 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(196444), // Rule ID 931 //
     /*  196408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196425 */     // MIs[0] rs1
     /*  196425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196437 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  196442 */     GIR_RootConstrainSelectedInstOperands,
     /*  196443 */     // GIR_Coverage, 931,
     /*  196443 */     GIR_Done,
     /*  196444 */   // Label 3813: @196444
     /*  196444 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(196485), // Rule ID 933 //
     /*  196449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196466 */     // MIs[0] rs1
     /*  196466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196478 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  196483 */     GIR_RootConstrainSelectedInstOperands,
     /*  196484 */     // GIR_Coverage, 933,
     /*  196484 */     GIR_Done,
     /*  196485 */   // Label 3814: @196485
     /*  196485 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(196526), // Rule ID 935 //
     /*  196490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196507 */     // MIs[0] rs1
     /*  196507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196519 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  196524 */     GIR_RootConstrainSelectedInstOperands,
     /*  196525 */     // GIR_Coverage, 935,
     /*  196525 */     GIR_Done,
     /*  196526 */   // Label 3815: @196526
     /*  196526 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(196567), // Rule ID 937 //
     /*  196531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  196534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196548 */     // MIs[0] rs1
     /*  196548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196560 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  196565 */     GIR_RootConstrainSelectedInstOperands,
     /*  196566 */     // GIR_Coverage, 937,
     /*  196566 */     GIR_Done,
     /*  196567 */   // Label 3816: @196567
     /*  196567 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(196608), // Rule ID 939 //
     /*  196572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196589 */     // MIs[0] rs1
     /*  196589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196601 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196606 */     GIR_RootConstrainSelectedInstOperands,
     /*  196607 */     // GIR_Coverage, 939,
     /*  196607 */     GIR_Done,
     /*  196608 */   // Label 3817: @196608
     /*  196608 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(196649), // Rule ID 941 //
     /*  196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196630 */     // MIs[0] rs1
     /*  196630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196642 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196647 */     GIR_RootConstrainSelectedInstOperands,
     /*  196648 */     // GIR_Coverage, 941,
     /*  196648 */     GIR_Done,
     /*  196649 */   // Label 3818: @196649
     /*  196649 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(196690), // Rule ID 943 //
     /*  196654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196671 */     // MIs[0] rs1
     /*  196671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196683 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196688 */     GIR_RootConstrainSelectedInstOperands,
     /*  196689 */     // GIR_Coverage, 943,
     /*  196689 */     GIR_Done,
     /*  196690 */   // Label 3819: @196690
     /*  196690 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(196731), // Rule ID 945 //
     /*  196695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196712 */     // MIs[0] rs1
     /*  196712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196724 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196729 */     GIR_RootConstrainSelectedInstOperands,
     /*  196730 */     // GIR_Coverage, 945,
     /*  196730 */     GIR_Done,
     /*  196731 */   // Label 3820: @196731
     /*  196731 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(196772), // Rule ID 947 //
     /*  196736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  196739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196753 */     // MIs[0] rs1
     /*  196753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196765 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  196770 */     GIR_RootConstrainSelectedInstOperands,
     /*  196771 */     // GIR_Coverage, 947,
     /*  196771 */     GIR_Done,
     /*  196772 */   // Label 3821: @196772
     /*  196772 */   GIM_Reject,
     /*  196773 */ // Label 3781: @196773
     /*  196773 */ GIM_Reject,
     /*  196774 */ // Label 3749: @196774
     /*  196774 */ GIM_Reject,
     /*  196775 */ // Label 31: @196775
     /*  196775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3824*/ GIMT_Encode4(199684),
     /*  196786 */ /*GILLT_s32*//*Label 3822*/ GIMT_Encode4(196794),
     /*  196790 */ /*GILLT_s64*//*Label 3823*/ GIMT_Encode4(198034),
     /*  196794 */ // Label 3822: @196794
     /*  196794 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(198033),
     /*  196799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  196802 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(196843), // Rule ID 422 //
     /*  196807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196824 */     // MIs[0] rs1
     /*  196824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196836 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  196841 */     GIR_RootConstrainSelectedInstOperands,
     /*  196842 */     // GIR_Coverage, 422,
     /*  196842 */     GIR_Done,
     /*  196843 */   // Label 3826: @196843
     /*  196843 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(196884), // Rule ID 424 //
     /*  196848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196865 */     // MIs[0] rs1
     /*  196865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196877 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  196882 */     GIR_RootConstrainSelectedInstOperands,
     /*  196883 */     // GIR_Coverage, 424,
     /*  196883 */     GIR_Done,
     /*  196884 */   // Label 3827: @196884
     /*  196884 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(196925), // Rule ID 426 //
     /*  196889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196906 */     // MIs[0] rs1
     /*  196906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196918 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  196923 */     GIR_RootConstrainSelectedInstOperands,
     /*  196924 */     // GIR_Coverage, 426,
     /*  196924 */     GIR_Done,
     /*  196925 */   // Label 3828: @196925
     /*  196925 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(196966), // Rule ID 428 //
     /*  196930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196947 */     // MIs[0] rs1
     /*  196947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196959 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  196964 */     GIR_RootConstrainSelectedInstOperands,
     /*  196965 */     // GIR_Coverage, 428,
     /*  196965 */     GIR_Done,
     /*  196966 */   // Label 3829: @196966
     /*  196966 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(197007), // Rule ID 430 //
     /*  196971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196988 */     // MIs[0] rs1
     /*  196988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197000 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  197005 */     GIR_RootConstrainSelectedInstOperands,
     /*  197006 */     // GIR_Coverage, 430,
     /*  197006 */     GIR_Done,
     /*  197007 */   // Label 3830: @197007
     /*  197007 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(197048), // Rule ID 432 //
     /*  197012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197029 */     // MIs[0] rs1
     /*  197029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197041 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197046 */     GIR_RootConstrainSelectedInstOperands,
     /*  197047 */     // GIR_Coverage, 432,
     /*  197047 */     GIR_Done,
     /*  197048 */   // Label 3831: @197048
     /*  197048 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(197089), // Rule ID 434 //
     /*  197053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197070 */     // MIs[0] rs1
     /*  197070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197082 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197087 */     GIR_RootConstrainSelectedInstOperands,
     /*  197088 */     // GIR_Coverage, 434,
     /*  197088 */     GIR_Done,
     /*  197089 */   // Label 3832: @197089
     /*  197089 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(197130), // Rule ID 436 //
     /*  197094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197111 */     // MIs[0] rs1
     /*  197111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197123 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197128 */     GIR_RootConstrainSelectedInstOperands,
     /*  197129 */     // GIR_Coverage, 436,
     /*  197129 */     GIR_Done,
     /*  197130 */   // Label 3833: @197130
     /*  197130 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(197171), // Rule ID 438 //
     /*  197135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197152 */     // MIs[0] rs1
     /*  197152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197164 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197169 */     GIR_RootConstrainSelectedInstOperands,
     /*  197170 */     // GIR_Coverage, 438,
     /*  197170 */     GIR_Done,
     /*  197171 */   // Label 3834: @197171
     /*  197171 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(197212), // Rule ID 440 //
     /*  197176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  197179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197193 */     // MIs[0] rs1
     /*  197193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197205 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  197210 */     GIR_RootConstrainSelectedInstOperands,
     /*  197211 */     // GIR_Coverage, 440,
     /*  197211 */     GIR_Done,
     /*  197212 */   // Label 3835: @197212
     /*  197212 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(197253), // Rule ID 770 //
     /*  197217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197234 */     // MIs[0] rs1
     /*  197234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197246 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197251 */     GIR_RootConstrainSelectedInstOperands,
     /*  197252 */     // GIR_Coverage, 770,
     /*  197252 */     GIR_Done,
     /*  197253 */   // Label 3836: @197253
     /*  197253 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(197294), // Rule ID 772 //
     /*  197258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197275 */     // MIs[0] rs1
     /*  197275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197287 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  197292 */     GIR_RootConstrainSelectedInstOperands,
     /*  197293 */     // GIR_Coverage, 772,
     /*  197293 */     GIR_Done,
     /*  197294 */   // Label 3837: @197294
     /*  197294 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(197335), // Rule ID 774 //
     /*  197299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197316 */     // MIs[0] rs1
     /*  197316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197328 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  197333 */     GIR_RootConstrainSelectedInstOperands,
     /*  197334 */     // GIR_Coverage, 774,
     /*  197334 */     GIR_Done,
     /*  197335 */   // Label 3838: @197335
     /*  197335 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(197376), // Rule ID 776 //
     /*  197340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197357 */     // MIs[0] rs1
     /*  197357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197369 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  197374 */     GIR_RootConstrainSelectedInstOperands,
     /*  197375 */     // GIR_Coverage, 776,
     /*  197375 */     GIR_Done,
     /*  197376 */   // Label 3839: @197376
     /*  197376 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(197417), // Rule ID 778 //
     /*  197381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197398 */     // MIs[0] rs1
     /*  197398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197410 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  197415 */     GIR_RootConstrainSelectedInstOperands,
     /*  197416 */     // GIR_Coverage, 778,
     /*  197416 */     GIR_Done,
     /*  197417 */   // Label 3840: @197417
     /*  197417 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(197458), // Rule ID 780 //
     /*  197422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197439 */     // MIs[0] rs1
     /*  197439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197451 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197456 */     GIR_RootConstrainSelectedInstOperands,
     /*  197457 */     // GIR_Coverage, 780,
     /*  197457 */     GIR_Done,
     /*  197458 */   // Label 3841: @197458
     /*  197458 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(197499), // Rule ID 782 //
     /*  197463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197480 */     // MIs[0] rs1
     /*  197480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197492 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197497 */     GIR_RootConstrainSelectedInstOperands,
     /*  197498 */     // GIR_Coverage, 782,
     /*  197498 */     GIR_Done,
     /*  197499 */   // Label 3842: @197499
     /*  197499 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(197540), // Rule ID 784 //
     /*  197504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197521 */     // MIs[0] rs1
     /*  197521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197533 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197538 */     GIR_RootConstrainSelectedInstOperands,
     /*  197539 */     // GIR_Coverage, 784,
     /*  197539 */     GIR_Done,
     /*  197540 */   // Label 3843: @197540
     /*  197540 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(197581), // Rule ID 786 //
     /*  197545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197562 */     // MIs[0] rs1
     /*  197562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197574 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197579 */     GIR_RootConstrainSelectedInstOperands,
     /*  197580 */     // GIR_Coverage, 786,
     /*  197580 */     GIR_Done,
     /*  197581 */   // Label 3844: @197581
     /*  197581 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(197622), // Rule ID 788 //
     /*  197586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197603 */     // MIs[0] rs1
     /*  197603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197615 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  197620 */     GIR_RootConstrainSelectedInstOperands,
     /*  197621 */     // GIR_Coverage, 788,
     /*  197621 */     GIR_Done,
     /*  197622 */   // Label 3845: @197622
     /*  197622 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(197663), // Rule ID 950 //
     /*  197627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197644 */     // MIs[0] rs1
     /*  197644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197656 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197661 */     GIR_RootConstrainSelectedInstOperands,
     /*  197662 */     // GIR_Coverage, 950,
     /*  197662 */     GIR_Done,
     /*  197663 */   // Label 3846: @197663
     /*  197663 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(197704), // Rule ID 952 //
     /*  197668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197685 */     // MIs[0] rs1
     /*  197685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197697 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  197702 */     GIR_RootConstrainSelectedInstOperands,
     /*  197703 */     // GIR_Coverage, 952,
     /*  197703 */     GIR_Done,
     /*  197704 */   // Label 3847: @197704
     /*  197704 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(197745), // Rule ID 954 //
     /*  197709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197726 */     // MIs[0] rs1
     /*  197726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197738 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  197743 */     GIR_RootConstrainSelectedInstOperands,
     /*  197744 */     // GIR_Coverage, 954,
     /*  197744 */     GIR_Done,
     /*  197745 */   // Label 3848: @197745
     /*  197745 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(197786), // Rule ID 956 //
     /*  197750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197767 */     // MIs[0] rs1
     /*  197767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197779 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  197784 */     GIR_RootConstrainSelectedInstOperands,
     /*  197785 */     // GIR_Coverage, 956,
     /*  197785 */     GIR_Done,
     /*  197786 */   // Label 3849: @197786
     /*  197786 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(197827), // Rule ID 958 //
     /*  197791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  197794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197808 */     // MIs[0] rs1
     /*  197808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197820 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  197825 */     GIR_RootConstrainSelectedInstOperands,
     /*  197826 */     // GIR_Coverage, 958,
     /*  197826 */     GIR_Done,
     /*  197827 */   // Label 3850: @197827
     /*  197827 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(197868), // Rule ID 960 //
     /*  197832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197849 */     // MIs[0] rs1
     /*  197849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197861 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197866 */     GIR_RootConstrainSelectedInstOperands,
     /*  197867 */     // GIR_Coverage, 960,
     /*  197867 */     GIR_Done,
     /*  197868 */   // Label 3851: @197868
     /*  197868 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(197909), // Rule ID 962 //
     /*  197873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197890 */     // MIs[0] rs1
     /*  197890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197902 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197907 */     GIR_RootConstrainSelectedInstOperands,
     /*  197908 */     // GIR_Coverage, 962,
     /*  197908 */     GIR_Done,
     /*  197909 */   // Label 3852: @197909
     /*  197909 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(197950), // Rule ID 964 //
     /*  197914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197931 */     // MIs[0] rs1
     /*  197931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197943 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197948 */     GIR_RootConstrainSelectedInstOperands,
     /*  197949 */     // GIR_Coverage, 964,
     /*  197949 */     GIR_Done,
     /*  197950 */   // Label 3853: @197950
     /*  197950 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(197991), // Rule ID 966 //
     /*  197955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197972 */     // MIs[0] rs1
     /*  197972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197984 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  197989 */     GIR_RootConstrainSelectedInstOperands,
     /*  197990 */     // GIR_Coverage, 966,
     /*  197990 */     GIR_Done,
     /*  197991 */   // Label 3854: @197991
     /*  197991 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(198032), // Rule ID 968 //
     /*  197996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198013 */     // MIs[0] rs1
     /*  198013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198025 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  198030 */     GIR_RootConstrainSelectedInstOperands,
     /*  198031 */     // GIR_Coverage, 968,
     /*  198031 */     GIR_Done,
     /*  198032 */   // Label 3855: @198032
     /*  198032 */   GIM_Reject,
     /*  198033 */ // Label 3825: @198033
     /*  198033 */ GIM_Reject,
     /*  198034 */ // Label 3823: @198034
     /*  198034 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(199683),
     /*  198039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  198042 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(198083), // Rule ID 421 //
     /*  198047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198064 */     // MIs[0] rs1
     /*  198064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198076 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198081 */     GIR_RootConstrainSelectedInstOperands,
     /*  198082 */     // GIR_Coverage, 421,
     /*  198082 */     GIR_Done,
     /*  198083 */   // Label 3857: @198083
     /*  198083 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(198124), // Rule ID 423 //
     /*  198088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198105 */     // MIs[0] rs1
     /*  198105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198117 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  198122 */     GIR_RootConstrainSelectedInstOperands,
     /*  198123 */     // GIR_Coverage, 423,
     /*  198123 */     GIR_Done,
     /*  198124 */   // Label 3858: @198124
     /*  198124 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(198165), // Rule ID 425 //
     /*  198129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198146 */     // MIs[0] rs1
     /*  198146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198158 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  198163 */     GIR_RootConstrainSelectedInstOperands,
     /*  198164 */     // GIR_Coverage, 425,
     /*  198164 */     GIR_Done,
     /*  198165 */   // Label 3859: @198165
     /*  198165 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(198206), // Rule ID 427 //
     /*  198170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198173 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198187 */     // MIs[0] rs1
     /*  198187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198199 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  198204 */     GIR_RootConstrainSelectedInstOperands,
     /*  198205 */     // GIR_Coverage, 427,
     /*  198205 */     GIR_Done,
     /*  198206 */   // Label 3860: @198206
     /*  198206 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(198247), // Rule ID 429 //
     /*  198211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  198214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198228 */     // MIs[0] rs1
     /*  198228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198240 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  198245 */     GIR_RootConstrainSelectedInstOperands,
     /*  198246 */     // GIR_Coverage, 429,
     /*  198246 */     GIR_Done,
     /*  198247 */   // Label 3861: @198247
     /*  198247 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(198288), // Rule ID 431 //
     /*  198252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198255 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198262 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198269 */     // MIs[0] rs1
     /*  198269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198281 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198286 */     GIR_RootConstrainSelectedInstOperands,
     /*  198287 */     // GIR_Coverage, 431,
     /*  198287 */     GIR_Done,
     /*  198288 */   // Label 3862: @198288
     /*  198288 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(198329), // Rule ID 433 //
     /*  198293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198310 */     // MIs[0] rs1
     /*  198310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198322 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198327 */     GIR_RootConstrainSelectedInstOperands,
     /*  198328 */     // GIR_Coverage, 433,
     /*  198328 */     GIR_Done,
     /*  198329 */   // Label 3863: @198329
     /*  198329 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(198370), // Rule ID 435 //
     /*  198334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198351 */     // MIs[0] rs1
     /*  198351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198363 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198368 */     GIR_RootConstrainSelectedInstOperands,
     /*  198369 */     // GIR_Coverage, 435,
     /*  198369 */     GIR_Done,
     /*  198370 */   // Label 3864: @198370
     /*  198370 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(198411), // Rule ID 437 //
     /*  198375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198392 */     // MIs[0] rs1
     /*  198392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198404 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198409 */     GIR_RootConstrainSelectedInstOperands,
     /*  198410 */     // GIR_Coverage, 437,
     /*  198410 */     GIR_Done,
     /*  198411 */   // Label 3865: @198411
     /*  198411 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(198452), // Rule ID 439 //
     /*  198416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  198419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198433 */     // MIs[0] rs1
     /*  198433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198445 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  198450 */     GIR_RootConstrainSelectedInstOperands,
     /*  198451 */     // GIR_Coverage, 439,
     /*  198451 */     GIR_Done,
     /*  198452 */   // Label 3866: @198452
     /*  198452 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(198493), // Rule ID 561 //
     /*  198457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198474 */     // MIs[0] rs1
     /*  198474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198486 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198491 */     GIR_RootConstrainSelectedInstOperands,
     /*  198492 */     // GIR_Coverage, 561,
     /*  198492 */     GIR_Done,
     /*  198493 */   // Label 3867: @198493
     /*  198493 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(198534), // Rule ID 562 //
     /*  198498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198515 */     // MIs[0] rs1
     /*  198515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198527 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  198532 */     GIR_RootConstrainSelectedInstOperands,
     /*  198533 */     // GIR_Coverage, 562,
     /*  198533 */     GIR_Done,
     /*  198534 */   // Label 3868: @198534
     /*  198534 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(198575), // Rule ID 563 //
     /*  198539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198556 */     // MIs[0] rs1
     /*  198556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198568 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  198573 */     GIR_RootConstrainSelectedInstOperands,
     /*  198574 */     // GIR_Coverage, 563,
     /*  198574 */     GIR_Done,
     /*  198575 */   // Label 3869: @198575
     /*  198575 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(198616), // Rule ID 564 //
     /*  198580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198597 */     // MIs[0] rs1
     /*  198597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198609 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  198614 */     GIR_RootConstrainSelectedInstOperands,
     /*  198615 */     // GIR_Coverage, 564,
     /*  198615 */     GIR_Done,
     /*  198616 */   // Label 3870: @198616
     /*  198616 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(198657), // Rule ID 565 //
     /*  198621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  198624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198638 */     // MIs[0] rs1
     /*  198638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198650 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  198655 */     GIR_RootConstrainSelectedInstOperands,
     /*  198656 */     // GIR_Coverage, 565,
     /*  198656 */     GIR_Done,
     /*  198657 */   // Label 3871: @198657
     /*  198657 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(198698), // Rule ID 566 //
     /*  198662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198679 */     // MIs[0] rs1
     /*  198679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198691 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198696 */     GIR_RootConstrainSelectedInstOperands,
     /*  198697 */     // GIR_Coverage, 566,
     /*  198697 */     GIR_Done,
     /*  198698 */   // Label 3872: @198698
     /*  198698 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(198739), // Rule ID 567 //
     /*  198703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198720 */     // MIs[0] rs1
     /*  198720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198732 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198737 */     GIR_RootConstrainSelectedInstOperands,
     /*  198738 */     // GIR_Coverage, 567,
     /*  198738 */     GIR_Done,
     /*  198739 */   // Label 3873: @198739
     /*  198739 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(198780), // Rule ID 568 //
     /*  198744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198761 */     // MIs[0] rs1
     /*  198761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198773 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198778 */     GIR_RootConstrainSelectedInstOperands,
     /*  198779 */     // GIR_Coverage, 568,
     /*  198779 */     GIR_Done,
     /*  198780 */   // Label 3874: @198780
     /*  198780 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(198821), // Rule ID 569 //
     /*  198785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198802 */     // MIs[0] rs1
     /*  198802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198814 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198819 */     GIR_RootConstrainSelectedInstOperands,
     /*  198820 */     // GIR_Coverage, 569,
     /*  198820 */     GIR_Done,
     /*  198821 */   // Label 3875: @198821
     /*  198821 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(198862), // Rule ID 570 //
     /*  198826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  198829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  198836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198843 */     // MIs[0] rs1
     /*  198843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198855 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  198860 */     GIR_RootConstrainSelectedInstOperands,
     /*  198861 */     // GIR_Coverage, 570,
     /*  198861 */     GIR_Done,
     /*  198862 */   // Label 3876: @198862
     /*  198862 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(198903), // Rule ID 769 //
     /*  198867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198884 */     // MIs[0] rs1
     /*  198884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198896 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  198901 */     GIR_RootConstrainSelectedInstOperands,
     /*  198902 */     // GIR_Coverage, 769,
     /*  198902 */     GIR_Done,
     /*  198903 */   // Label 3877: @198903
     /*  198903 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(198944), // Rule ID 771 //
     /*  198908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198925 */     // MIs[0] rs1
     /*  198925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198937 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  198942 */     GIR_RootConstrainSelectedInstOperands,
     /*  198943 */     // GIR_Coverage, 771,
     /*  198943 */     GIR_Done,
     /*  198944 */   // Label 3878: @198944
     /*  198944 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(198985), // Rule ID 773 //
     /*  198949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198966 */     // MIs[0] rs1
     /*  198966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198978 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  198983 */     GIR_RootConstrainSelectedInstOperands,
     /*  198984 */     // GIR_Coverage, 773,
     /*  198984 */     GIR_Done,
     /*  198985 */   // Label 3879: @198985
     /*  198985 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(199026), // Rule ID 775 //
     /*  198990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199007 */     // MIs[0] rs1
     /*  199007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199019 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  199024 */     GIR_RootConstrainSelectedInstOperands,
     /*  199025 */     // GIR_Coverage, 775,
     /*  199025 */     GIR_Done,
     /*  199026 */   // Label 3880: @199026
     /*  199026 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(199067), // Rule ID 777 //
     /*  199031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199048 */     // MIs[0] rs1
     /*  199048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199060 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  199065 */     GIR_RootConstrainSelectedInstOperands,
     /*  199066 */     // GIR_Coverage, 777,
     /*  199066 */     GIR_Done,
     /*  199067 */   // Label 3881: @199067
     /*  199067 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(199108), // Rule ID 779 //
     /*  199072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199089 */     // MIs[0] rs1
     /*  199089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199101 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199106 */     GIR_RootConstrainSelectedInstOperands,
     /*  199107 */     // GIR_Coverage, 779,
     /*  199107 */     GIR_Done,
     /*  199108 */   // Label 3882: @199108
     /*  199108 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(199149), // Rule ID 781 //
     /*  199113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199130 */     // MIs[0] rs1
     /*  199130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199142 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199147 */     GIR_RootConstrainSelectedInstOperands,
     /*  199148 */     // GIR_Coverage, 781,
     /*  199148 */     GIR_Done,
     /*  199149 */   // Label 3883: @199149
     /*  199149 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(199190), // Rule ID 783 //
     /*  199154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199171 */     // MIs[0] rs1
     /*  199171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199183 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199188 */     GIR_RootConstrainSelectedInstOperands,
     /*  199189 */     // GIR_Coverage, 783,
     /*  199189 */     GIR_Done,
     /*  199190 */   // Label 3884: @199190
     /*  199190 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(199231), // Rule ID 785 //
     /*  199195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199212 */     // MIs[0] rs1
     /*  199212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199224 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199229 */     GIR_RootConstrainSelectedInstOperands,
     /*  199230 */     // GIR_Coverage, 785,
     /*  199230 */     GIR_Done,
     /*  199231 */   // Label 3885: @199231
     /*  199231 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(199272), // Rule ID 787 //
     /*  199236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199253 */     // MIs[0] rs1
     /*  199253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199265 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  199270 */     GIR_RootConstrainSelectedInstOperands,
     /*  199271 */     // GIR_Coverage, 787,
     /*  199271 */     GIR_Done,
     /*  199272 */   // Label 3886: @199272
     /*  199272 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(199313), // Rule ID 949 //
     /*  199277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199294 */     // MIs[0] rs1
     /*  199294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199306 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199311 */     GIR_RootConstrainSelectedInstOperands,
     /*  199312 */     // GIR_Coverage, 949,
     /*  199312 */     GIR_Done,
     /*  199313 */   // Label 3887: @199313
     /*  199313 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(199354), // Rule ID 951 //
     /*  199318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199335 */     // MIs[0] rs1
     /*  199335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199347 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  199352 */     GIR_RootConstrainSelectedInstOperands,
     /*  199353 */     // GIR_Coverage, 951,
     /*  199353 */     GIR_Done,
     /*  199354 */   // Label 3888: @199354
     /*  199354 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(199395), // Rule ID 953 //
     /*  199359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199376 */     // MIs[0] rs1
     /*  199376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199388 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  199393 */     GIR_RootConstrainSelectedInstOperands,
     /*  199394 */     // GIR_Coverage, 953,
     /*  199394 */     GIR_Done,
     /*  199395 */   // Label 3889: @199395
     /*  199395 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(199436), // Rule ID 955 //
     /*  199400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199417 */     // MIs[0] rs1
     /*  199417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199429 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  199434 */     GIR_RootConstrainSelectedInstOperands,
     /*  199435 */     // GIR_Coverage, 955,
     /*  199435 */     GIR_Done,
     /*  199436 */   // Label 3890: @199436
     /*  199436 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(199477), // Rule ID 957 //
     /*  199441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  199444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199458 */     // MIs[0] rs1
     /*  199458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199470 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  199475 */     GIR_RootConstrainSelectedInstOperands,
     /*  199476 */     // GIR_Coverage, 957,
     /*  199476 */     GIR_Done,
     /*  199477 */   // Label 3891: @199477
     /*  199477 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(199518), // Rule ID 959 //
     /*  199482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199499 */     // MIs[0] rs1
     /*  199499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199511 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199516 */     GIR_RootConstrainSelectedInstOperands,
     /*  199517 */     // GIR_Coverage, 959,
     /*  199517 */     GIR_Done,
     /*  199518 */   // Label 3892: @199518
     /*  199518 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(199559), // Rule ID 961 //
     /*  199523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199540 */     // MIs[0] rs1
     /*  199540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199552 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199557 */     GIR_RootConstrainSelectedInstOperands,
     /*  199558 */     // GIR_Coverage, 961,
     /*  199558 */     GIR_Done,
     /*  199559 */   // Label 3893: @199559
     /*  199559 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(199600), // Rule ID 963 //
     /*  199564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199581 */     // MIs[0] rs1
     /*  199581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199593 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199598 */     GIR_RootConstrainSelectedInstOperands,
     /*  199599 */     // GIR_Coverage, 963,
     /*  199599 */     GIR_Done,
     /*  199600 */   // Label 3894: @199600
     /*  199600 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(199641), // Rule ID 965 //
     /*  199605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199622 */     // MIs[0] rs1
     /*  199622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199634 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199639 */     GIR_RootConstrainSelectedInstOperands,
     /*  199640 */     // GIR_Coverage, 965,
     /*  199640 */     GIR_Done,
     /*  199641 */   // Label 3895: @199641
     /*  199641 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(199682), // Rule ID 967 //
     /*  199646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  199649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199663 */     // MIs[0] rs1
     /*  199663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199675 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  199680 */     GIR_RootConstrainSelectedInstOperands,
     /*  199681 */     // GIR_Coverage, 967,
     /*  199681 */     GIR_Done,
     /*  199682 */   // Label 3896: @199682
     /*  199682 */   GIM_Reject,
     /*  199683 */ // Label 3856: @199683
     /*  199683 */ GIM_Reject,
     /*  199684 */ // Label 3824: @199684
     /*  199684 */ GIM_Reject,
     /*  199685 */ // Label 32: @199685
     /*  199685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3899*/ GIMT_Encode4(202594),
     /*  199696 */ /*GILLT_s32*//*Label 3897*/ GIMT_Encode4(199704),
     /*  199700 */ /*GILLT_s64*//*Label 3898*/ GIMT_Encode4(200944),
     /*  199704 */ // Label 3897: @199704
     /*  199704 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(200943),
     /*  199709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  199712 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(199753), // Rule ID 442 //
     /*  199717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199734 */     // MIs[0] rs1
     /*  199734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199746 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199751 */     GIR_RootConstrainSelectedInstOperands,
     /*  199752 */     // GIR_Coverage, 442,
     /*  199752 */     GIR_Done,
     /*  199753 */   // Label 3901: @199753
     /*  199753 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(199794), // Rule ID 444 //
     /*  199758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199775 */     // MIs[0] rs1
     /*  199775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199787 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  199792 */     GIR_RootConstrainSelectedInstOperands,
     /*  199793 */     // GIR_Coverage, 444,
     /*  199793 */     GIR_Done,
     /*  199794 */   // Label 3902: @199794
     /*  199794 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(199835), // Rule ID 446 //
     /*  199799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199816 */     // MIs[0] rs1
     /*  199816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199828 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  199833 */     GIR_RootConstrainSelectedInstOperands,
     /*  199834 */     // GIR_Coverage, 446,
     /*  199834 */     GIR_Done,
     /*  199835 */   // Label 3903: @199835
     /*  199835 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(199876), // Rule ID 448 //
     /*  199840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199857 */     // MIs[0] rs1
     /*  199857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199869 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  199874 */     GIR_RootConstrainSelectedInstOperands,
     /*  199875 */     // GIR_Coverage, 448,
     /*  199875 */     GIR_Done,
     /*  199876 */   // Label 3904: @199876
     /*  199876 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(199917), // Rule ID 450 //
     /*  199881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  199884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199898 */     // MIs[0] rs1
     /*  199898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199910 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  199915 */     GIR_RootConstrainSelectedInstOperands,
     /*  199916 */     // GIR_Coverage, 450,
     /*  199916 */     GIR_Done,
     /*  199917 */   // Label 3905: @199917
     /*  199917 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(199958), // Rule ID 452 //
     /*  199922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199939 */     // MIs[0] rs1
     /*  199939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199951 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199956 */     GIR_RootConstrainSelectedInstOperands,
     /*  199957 */     // GIR_Coverage, 452,
     /*  199957 */     GIR_Done,
     /*  199958 */   // Label 3906: @199958
     /*  199958 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(199999), // Rule ID 454 //
     /*  199963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199980 */     // MIs[0] rs1
     /*  199980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199992 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  199997 */     GIR_RootConstrainSelectedInstOperands,
     /*  199998 */     // GIR_Coverage, 454,
     /*  199998 */     GIR_Done,
     /*  199999 */   // Label 3907: @199999
     /*  199999 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(200040), // Rule ID 456 //
     /*  200004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200021 */     // MIs[0] rs1
     /*  200021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200033 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200038 */     GIR_RootConstrainSelectedInstOperands,
     /*  200039 */     // GIR_Coverage, 456,
     /*  200039 */     GIR_Done,
     /*  200040 */   // Label 3908: @200040
     /*  200040 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(200081), // Rule ID 458 //
     /*  200045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200062 */     // MIs[0] rs1
     /*  200062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200074 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200079 */     GIR_RootConstrainSelectedInstOperands,
     /*  200080 */     // GIR_Coverage, 458,
     /*  200080 */     GIR_Done,
     /*  200081 */   // Label 3909: @200081
     /*  200081 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(200122), // Rule ID 460 //
     /*  200086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  200089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200103 */     // MIs[0] rs1
     /*  200103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200115 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200120 */     GIR_RootConstrainSelectedInstOperands,
     /*  200121 */     // GIR_Coverage, 460,
     /*  200121 */     GIR_Done,
     /*  200122 */   // Label 3910: @200122
     /*  200122 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(200163), // Rule ID 790 //
     /*  200127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200144 */     // MIs[0] rs1
     /*  200144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200156 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200161 */     GIR_RootConstrainSelectedInstOperands,
     /*  200162 */     // GIR_Coverage, 790,
     /*  200162 */     GIR_Done,
     /*  200163 */   // Label 3911: @200163
     /*  200163 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(200204), // Rule ID 792 //
     /*  200168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200185 */     // MIs[0] rs1
     /*  200185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200197 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  200202 */     GIR_RootConstrainSelectedInstOperands,
     /*  200203 */     // GIR_Coverage, 792,
     /*  200203 */     GIR_Done,
     /*  200204 */   // Label 3912: @200204
     /*  200204 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(200245), // Rule ID 794 //
     /*  200209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200226 */     // MIs[0] rs1
     /*  200226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200238 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  200243 */     GIR_RootConstrainSelectedInstOperands,
     /*  200244 */     // GIR_Coverage, 794,
     /*  200244 */     GIR_Done,
     /*  200245 */   // Label 3913: @200245
     /*  200245 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(200286), // Rule ID 796 //
     /*  200250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200267 */     // MIs[0] rs1
     /*  200267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200279 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  200284 */     GIR_RootConstrainSelectedInstOperands,
     /*  200285 */     // GIR_Coverage, 796,
     /*  200285 */     GIR_Done,
     /*  200286 */   // Label 3914: @200286
     /*  200286 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(200327), // Rule ID 798 //
     /*  200291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200308 */     // MIs[0] rs1
     /*  200308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200320 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  200325 */     GIR_RootConstrainSelectedInstOperands,
     /*  200326 */     // GIR_Coverage, 798,
     /*  200326 */     GIR_Done,
     /*  200327 */   // Label 3915: @200327
     /*  200327 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(200368), // Rule ID 800 //
     /*  200332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200349 */     // MIs[0] rs1
     /*  200349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200361 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200366 */     GIR_RootConstrainSelectedInstOperands,
     /*  200367 */     // GIR_Coverage, 800,
     /*  200367 */     GIR_Done,
     /*  200368 */   // Label 3916: @200368
     /*  200368 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(200409), // Rule ID 802 //
     /*  200373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200390 */     // MIs[0] rs1
     /*  200390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200402 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200407 */     GIR_RootConstrainSelectedInstOperands,
     /*  200408 */     // GIR_Coverage, 802,
     /*  200408 */     GIR_Done,
     /*  200409 */   // Label 3917: @200409
     /*  200409 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(200450), // Rule ID 804 //
     /*  200414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200431 */     // MIs[0] rs1
     /*  200431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200443 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200448 */     GIR_RootConstrainSelectedInstOperands,
     /*  200449 */     // GIR_Coverage, 804,
     /*  200449 */     GIR_Done,
     /*  200450 */   // Label 3918: @200450
     /*  200450 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(200491), // Rule ID 806 //
     /*  200455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200472 */     // MIs[0] rs1
     /*  200472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200484 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200489 */     GIR_RootConstrainSelectedInstOperands,
     /*  200490 */     // GIR_Coverage, 806,
     /*  200490 */     GIR_Done,
     /*  200491 */   // Label 3919: @200491
     /*  200491 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(200532), // Rule ID 808 //
     /*  200496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200513 */     // MIs[0] rs1
     /*  200513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200525 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  200530 */     GIR_RootConstrainSelectedInstOperands,
     /*  200531 */     // GIR_Coverage, 808,
     /*  200531 */     GIR_Done,
     /*  200532 */   // Label 3920: @200532
     /*  200532 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(200573), // Rule ID 970 //
     /*  200537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200554 */     // MIs[0] rs1
     /*  200554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200566 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200571 */     GIR_RootConstrainSelectedInstOperands,
     /*  200572 */     // GIR_Coverage, 970,
     /*  200572 */     GIR_Done,
     /*  200573 */   // Label 3921: @200573
     /*  200573 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(200614), // Rule ID 972 //
     /*  200578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200595 */     // MIs[0] rs1
     /*  200595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200607 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  200612 */     GIR_RootConstrainSelectedInstOperands,
     /*  200613 */     // GIR_Coverage, 972,
     /*  200613 */     GIR_Done,
     /*  200614 */   // Label 3922: @200614
     /*  200614 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(200655), // Rule ID 974 //
     /*  200619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200636 */     // MIs[0] rs1
     /*  200636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200648 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  200653 */     GIR_RootConstrainSelectedInstOperands,
     /*  200654 */     // GIR_Coverage, 974,
     /*  200654 */     GIR_Done,
     /*  200655 */   // Label 3923: @200655
     /*  200655 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(200696), // Rule ID 976 //
     /*  200660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200677 */     // MIs[0] rs1
     /*  200677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200689 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  200694 */     GIR_RootConstrainSelectedInstOperands,
     /*  200695 */     // GIR_Coverage, 976,
     /*  200695 */     GIR_Done,
     /*  200696 */   // Label 3924: @200696
     /*  200696 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(200737), // Rule ID 978 //
     /*  200701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  200704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200718 */     // MIs[0] rs1
     /*  200718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200730 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  200735 */     GIR_RootConstrainSelectedInstOperands,
     /*  200736 */     // GIR_Coverage, 978,
     /*  200736 */     GIR_Done,
     /*  200737 */   // Label 3925: @200737
     /*  200737 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(200778), // Rule ID 980 //
     /*  200742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200759 */     // MIs[0] rs1
     /*  200759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200771 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200776 */     GIR_RootConstrainSelectedInstOperands,
     /*  200777 */     // GIR_Coverage, 980,
     /*  200777 */     GIR_Done,
     /*  200778 */   // Label 3926: @200778
     /*  200778 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(200819), // Rule ID 982 //
     /*  200783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200800 */     // MIs[0] rs1
     /*  200800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200812 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200817 */     GIR_RootConstrainSelectedInstOperands,
     /*  200818 */     // GIR_Coverage, 982,
     /*  200818 */     GIR_Done,
     /*  200819 */   // Label 3927: @200819
     /*  200819 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(200860), // Rule ID 984 //
     /*  200824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200841 */     // MIs[0] rs1
     /*  200841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200853 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200858 */     GIR_RootConstrainSelectedInstOperands,
     /*  200859 */     // GIR_Coverage, 984,
     /*  200859 */     GIR_Done,
     /*  200860 */   // Label 3928: @200860
     /*  200860 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(200901), // Rule ID 986 //
     /*  200865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200882 */     // MIs[0] rs1
     /*  200882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200894 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200899 */     GIR_RootConstrainSelectedInstOperands,
     /*  200900 */     // GIR_Coverage, 986,
     /*  200900 */     GIR_Done,
     /*  200901 */   // Label 3929: @200901
     /*  200901 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(200942), // Rule ID 988 //
     /*  200906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  200909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200923 */     // MIs[0] rs1
     /*  200923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  200927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200935 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  200940 */     GIR_RootConstrainSelectedInstOperands,
     /*  200941 */     // GIR_Coverage, 988,
     /*  200941 */     GIR_Done,
     /*  200942 */   // Label 3930: @200942
     /*  200942 */   GIM_Reject,
     /*  200943 */ // Label 3900: @200943
     /*  200943 */ GIM_Reject,
     /*  200944 */ // Label 3898: @200944
     /*  200944 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(202593),
     /*  200949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200952 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(200993), // Rule ID 441 //
     /*  200957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200974 */     // MIs[0] rs1
     /*  200974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200986 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  200991 */     GIR_RootConstrainSelectedInstOperands,
     /*  200992 */     // GIR_Coverage, 441,
     /*  200992 */     GIR_Done,
     /*  200993 */   // Label 3932: @200993
     /*  200993 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(201034), // Rule ID 443 //
     /*  200998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201015 */     // MIs[0] rs1
     /*  201015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201027 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  201032 */     GIR_RootConstrainSelectedInstOperands,
     /*  201033 */     // GIR_Coverage, 443,
     /*  201033 */     GIR_Done,
     /*  201034 */   // Label 3933: @201034
     /*  201034 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(201075), // Rule ID 445 //
     /*  201039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201056 */     // MIs[0] rs1
     /*  201056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201068 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  201073 */     GIR_RootConstrainSelectedInstOperands,
     /*  201074 */     // GIR_Coverage, 445,
     /*  201074 */     GIR_Done,
     /*  201075 */   // Label 3934: @201075
     /*  201075 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(201116), // Rule ID 447 //
     /*  201080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201097 */     // MIs[0] rs1
     /*  201097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201109 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  201114 */     GIR_RootConstrainSelectedInstOperands,
     /*  201115 */     // GIR_Coverage, 447,
     /*  201115 */     GIR_Done,
     /*  201116 */   // Label 3935: @201116
     /*  201116 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(201157), // Rule ID 449 //
     /*  201121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  201124 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201138 */     // MIs[0] rs1
     /*  201138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201150 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  201155 */     GIR_RootConstrainSelectedInstOperands,
     /*  201156 */     // GIR_Coverage, 449,
     /*  201156 */     GIR_Done,
     /*  201157 */   // Label 3936: @201157
     /*  201157 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(201198), // Rule ID 451 //
     /*  201162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201165 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201179 */     // MIs[0] rs1
     /*  201179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201191 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201196 */     GIR_RootConstrainSelectedInstOperands,
     /*  201197 */     // GIR_Coverage, 451,
     /*  201197 */     GIR_Done,
     /*  201198 */   // Label 3937: @201198
     /*  201198 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(201239), // Rule ID 453 //
     /*  201203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201220 */     // MIs[0] rs1
     /*  201220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201232 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201237 */     GIR_RootConstrainSelectedInstOperands,
     /*  201238 */     // GIR_Coverage, 453,
     /*  201238 */     GIR_Done,
     /*  201239 */   // Label 3938: @201239
     /*  201239 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(201280), // Rule ID 455 //
     /*  201244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201247 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201261 */     // MIs[0] rs1
     /*  201261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201273 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201278 */     GIR_RootConstrainSelectedInstOperands,
     /*  201279 */     // GIR_Coverage, 455,
     /*  201279 */     GIR_Done,
     /*  201280 */   // Label 3939: @201280
     /*  201280 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(201321), // Rule ID 457 //
     /*  201285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201302 */     // MIs[0] rs1
     /*  201302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201314 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201319 */     GIR_RootConstrainSelectedInstOperands,
     /*  201320 */     // GIR_Coverage, 457,
     /*  201320 */     GIR_Done,
     /*  201321 */   // Label 3940: @201321
     /*  201321 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(201362), // Rule ID 459 //
     /*  201326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  201329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201343 */     // MIs[0] rs1
     /*  201343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201355 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  201360 */     GIR_RootConstrainSelectedInstOperands,
     /*  201361 */     // GIR_Coverage, 459,
     /*  201361 */     GIR_Done,
     /*  201362 */   // Label 3941: @201362
     /*  201362 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(201403), // Rule ID 571 //
     /*  201367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201384 */     // MIs[0] rs1
     /*  201384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201396 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201401 */     GIR_RootConstrainSelectedInstOperands,
     /*  201402 */     // GIR_Coverage, 571,
     /*  201402 */     GIR_Done,
     /*  201403 */   // Label 3942: @201403
     /*  201403 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(201444), // Rule ID 572 //
     /*  201408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201425 */     // MIs[0] rs1
     /*  201425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201437 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  201442 */     GIR_RootConstrainSelectedInstOperands,
     /*  201443 */     // GIR_Coverage, 572,
     /*  201443 */     GIR_Done,
     /*  201444 */   // Label 3943: @201444
     /*  201444 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(201485), // Rule ID 573 //
     /*  201449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201466 */     // MIs[0] rs1
     /*  201466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201478 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  201483 */     GIR_RootConstrainSelectedInstOperands,
     /*  201484 */     // GIR_Coverage, 573,
     /*  201484 */     GIR_Done,
     /*  201485 */   // Label 3944: @201485
     /*  201485 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(201526), // Rule ID 574 //
     /*  201490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201507 */     // MIs[0] rs1
     /*  201507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201519 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  201524 */     GIR_RootConstrainSelectedInstOperands,
     /*  201525 */     // GIR_Coverage, 574,
     /*  201525 */     GIR_Done,
     /*  201526 */   // Label 3945: @201526
     /*  201526 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(201567), // Rule ID 575 //
     /*  201531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  201534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201548 */     // MIs[0] rs1
     /*  201548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201560 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  201565 */     GIR_RootConstrainSelectedInstOperands,
     /*  201566 */     // GIR_Coverage, 575,
     /*  201566 */     GIR_Done,
     /*  201567 */   // Label 3946: @201567
     /*  201567 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(201608), // Rule ID 576 //
     /*  201572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201589 */     // MIs[0] rs1
     /*  201589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201601 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201606 */     GIR_RootConstrainSelectedInstOperands,
     /*  201607 */     // GIR_Coverage, 576,
     /*  201607 */     GIR_Done,
     /*  201608 */   // Label 3947: @201608
     /*  201608 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(201649), // Rule ID 577 //
     /*  201613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201630 */     // MIs[0] rs1
     /*  201630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201642 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201647 */     GIR_RootConstrainSelectedInstOperands,
     /*  201648 */     // GIR_Coverage, 577,
     /*  201648 */     GIR_Done,
     /*  201649 */   // Label 3948: @201649
     /*  201649 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(201690), // Rule ID 578 //
     /*  201654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201671 */     // MIs[0] rs1
     /*  201671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201683 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201688 */     GIR_RootConstrainSelectedInstOperands,
     /*  201689 */     // GIR_Coverage, 578,
     /*  201689 */     GIR_Done,
     /*  201690 */   // Label 3949: @201690
     /*  201690 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(201731), // Rule ID 579 //
     /*  201695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201712 */     // MIs[0] rs1
     /*  201712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201724 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201729 */     GIR_RootConstrainSelectedInstOperands,
     /*  201730 */     // GIR_Coverage, 579,
     /*  201730 */     GIR_Done,
     /*  201731 */   // Label 3950: @201731
     /*  201731 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(201772), // Rule ID 580 //
     /*  201736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  201739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  201746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201753 */     // MIs[0] rs1
     /*  201753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201765 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  201770 */     GIR_RootConstrainSelectedInstOperands,
     /*  201771 */     // GIR_Coverage, 580,
     /*  201771 */     GIR_Done,
     /*  201772 */   // Label 3951: @201772
     /*  201772 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(201813), // Rule ID 789 //
     /*  201777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201794 */     // MIs[0] rs1
     /*  201794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201806 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  201811 */     GIR_RootConstrainSelectedInstOperands,
     /*  201812 */     // GIR_Coverage, 789,
     /*  201812 */     GIR_Done,
     /*  201813 */   // Label 3952: @201813
     /*  201813 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(201854), // Rule ID 791 //
     /*  201818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201835 */     // MIs[0] rs1
     /*  201835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201847 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  201852 */     GIR_RootConstrainSelectedInstOperands,
     /*  201853 */     // GIR_Coverage, 791,
     /*  201853 */     GIR_Done,
     /*  201854 */   // Label 3953: @201854
     /*  201854 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(201895), // Rule ID 793 //
     /*  201859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201876 */     // MIs[0] rs1
     /*  201876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201888 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  201893 */     GIR_RootConstrainSelectedInstOperands,
     /*  201894 */     // GIR_Coverage, 793,
     /*  201894 */     GIR_Done,
     /*  201895 */   // Label 3954: @201895
     /*  201895 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(201936), // Rule ID 795 //
     /*  201900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201917 */     // MIs[0] rs1
     /*  201917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201929 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  201934 */     GIR_RootConstrainSelectedInstOperands,
     /*  201935 */     // GIR_Coverage, 795,
     /*  201935 */     GIR_Done,
     /*  201936 */   // Label 3955: @201936
     /*  201936 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(201977), // Rule ID 797 //
     /*  201941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201958 */     // MIs[0] rs1
     /*  201958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201970 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  201975 */     GIR_RootConstrainSelectedInstOperands,
     /*  201976 */     // GIR_Coverage, 797,
     /*  201976 */     GIR_Done,
     /*  201977 */   // Label 3956: @201977
     /*  201977 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(202018), // Rule ID 799 //
     /*  201982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201999 */     // MIs[0] rs1
     /*  201999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202011 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202016 */     GIR_RootConstrainSelectedInstOperands,
     /*  202017 */     // GIR_Coverage, 799,
     /*  202017 */     GIR_Done,
     /*  202018 */   // Label 3957: @202018
     /*  202018 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(202059), // Rule ID 801 //
     /*  202023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202040 */     // MIs[0] rs1
     /*  202040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202052 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202057 */     GIR_RootConstrainSelectedInstOperands,
     /*  202058 */     // GIR_Coverage, 801,
     /*  202058 */     GIR_Done,
     /*  202059 */   // Label 3958: @202059
     /*  202059 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(202100), // Rule ID 803 //
     /*  202064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202081 */     // MIs[0] rs1
     /*  202081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202093 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202098 */     GIR_RootConstrainSelectedInstOperands,
     /*  202099 */     // GIR_Coverage, 803,
     /*  202099 */     GIR_Done,
     /*  202100 */   // Label 3959: @202100
     /*  202100 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(202141), // Rule ID 805 //
     /*  202105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202122 */     // MIs[0] rs1
     /*  202122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202134 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202139 */     GIR_RootConstrainSelectedInstOperands,
     /*  202140 */     // GIR_Coverage, 805,
     /*  202140 */     GIR_Done,
     /*  202141 */   // Label 3960: @202141
     /*  202141 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(202182), // Rule ID 807 //
     /*  202146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202163 */     // MIs[0] rs1
     /*  202163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202175 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  202180 */     GIR_RootConstrainSelectedInstOperands,
     /*  202181 */     // GIR_Coverage, 807,
     /*  202181 */     GIR_Done,
     /*  202182 */   // Label 3961: @202182
     /*  202182 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(202223), // Rule ID 969 //
     /*  202187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202204 */     // MIs[0] rs1
     /*  202204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202216 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202221 */     GIR_RootConstrainSelectedInstOperands,
     /*  202222 */     // GIR_Coverage, 969,
     /*  202222 */     GIR_Done,
     /*  202223 */   // Label 3962: @202223
     /*  202223 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(202264), // Rule ID 971 //
     /*  202228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202245 */     // MIs[0] rs1
     /*  202245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202257 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  202262 */     GIR_RootConstrainSelectedInstOperands,
     /*  202263 */     // GIR_Coverage, 971,
     /*  202263 */     GIR_Done,
     /*  202264 */   // Label 3963: @202264
     /*  202264 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(202305), // Rule ID 973 //
     /*  202269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202286 */     // MIs[0] rs1
     /*  202286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202298 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  202303 */     GIR_RootConstrainSelectedInstOperands,
     /*  202304 */     // GIR_Coverage, 973,
     /*  202304 */     GIR_Done,
     /*  202305 */   // Label 3964: @202305
     /*  202305 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(202346), // Rule ID 975 //
     /*  202310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202327 */     // MIs[0] rs1
     /*  202327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202339 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  202344 */     GIR_RootConstrainSelectedInstOperands,
     /*  202345 */     // GIR_Coverage, 975,
     /*  202345 */     GIR_Done,
     /*  202346 */   // Label 3965: @202346
     /*  202346 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(202387), // Rule ID 977 //
     /*  202351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  202354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202368 */     // MIs[0] rs1
     /*  202368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202380 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  202385 */     GIR_RootConstrainSelectedInstOperands,
     /*  202386 */     // GIR_Coverage, 977,
     /*  202386 */     GIR_Done,
     /*  202387 */   // Label 3966: @202387
     /*  202387 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(202428), // Rule ID 979 //
     /*  202392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202409 */     // MIs[0] rs1
     /*  202409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202421 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202426 */     GIR_RootConstrainSelectedInstOperands,
     /*  202427 */     // GIR_Coverage, 979,
     /*  202427 */     GIR_Done,
     /*  202428 */   // Label 3967: @202428
     /*  202428 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(202469), // Rule ID 981 //
     /*  202433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202450 */     // MIs[0] rs1
     /*  202450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202462 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202467 */     GIR_RootConstrainSelectedInstOperands,
     /*  202468 */     // GIR_Coverage, 981,
     /*  202468 */     GIR_Done,
     /*  202469 */   // Label 3968: @202469
     /*  202469 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(202510), // Rule ID 983 //
     /*  202474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202491 */     // MIs[0] rs1
     /*  202491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202503 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202508 */     GIR_RootConstrainSelectedInstOperands,
     /*  202509 */     // GIR_Coverage, 983,
     /*  202509 */     GIR_Done,
     /*  202510 */   // Label 3969: @202510
     /*  202510 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(202551), // Rule ID 985 //
     /*  202515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202532 */     // MIs[0] rs1
     /*  202532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202544 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202549 */     GIR_RootConstrainSelectedInstOperands,
     /*  202550 */     // GIR_Coverage, 985,
     /*  202550 */     GIR_Done,
     /*  202551 */   // Label 3970: @202551
     /*  202551 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(202592), // Rule ID 987 //
     /*  202556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  202559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202573 */     // MIs[0] rs1
     /*  202573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202585 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  202590 */     GIR_RootConstrainSelectedInstOperands,
     /*  202591 */     // GIR_Coverage, 987,
     /*  202591 */     GIR_Done,
     /*  202592 */   // Label 3971: @202592
     /*  202592 */   GIM_Reject,
     /*  202593 */ // Label 3931: @202593
     /*  202593 */ GIM_Reject,
     /*  202594 */ // Label 3899: @202594
     /*  202594 */ GIM_Reject,
     /*  202595 */ // Label 33: @202595
     /*  202595 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3974*/ GIMT_Encode4(205504),
     /*  202606 */ /*GILLT_s32*//*Label 3972*/ GIMT_Encode4(202614),
     /*  202610 */ /*GILLT_s64*//*Label 3973*/ GIMT_Encode4(203854),
     /*  202614 */ // Label 3972: @202614
     /*  202614 */ GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(203853),
     /*  202619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  202622 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(202663), // Rule ID 462 //
     /*  202627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202644 */     // MIs[0] rs1
     /*  202644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202656 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202661 */     GIR_RootConstrainSelectedInstOperands,
     /*  202662 */     // GIR_Coverage, 462,
     /*  202662 */     GIR_Done,
     /*  202663 */   // Label 3976: @202663
     /*  202663 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(202704), // Rule ID 464 //
     /*  202668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202685 */     // MIs[0] rs1
     /*  202685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202697 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  202702 */     GIR_RootConstrainSelectedInstOperands,
     /*  202703 */     // GIR_Coverage, 464,
     /*  202703 */     GIR_Done,
     /*  202704 */   // Label 3977: @202704
     /*  202704 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(202745), // Rule ID 466 //
     /*  202709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202726 */     // MIs[0] rs1
     /*  202726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202738 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  202743 */     GIR_RootConstrainSelectedInstOperands,
     /*  202744 */     // GIR_Coverage, 466,
     /*  202744 */     GIR_Done,
     /*  202745 */   // Label 3978: @202745
     /*  202745 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(202786), // Rule ID 468 //
     /*  202750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202767 */     // MIs[0] rs1
     /*  202767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202779 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  202784 */     GIR_RootConstrainSelectedInstOperands,
     /*  202785 */     // GIR_Coverage, 468,
     /*  202785 */     GIR_Done,
     /*  202786 */   // Label 3979: @202786
     /*  202786 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(202827), // Rule ID 470 //
     /*  202791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  202794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202808 */     // MIs[0] rs1
     /*  202808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202820 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  202825 */     GIR_RootConstrainSelectedInstOperands,
     /*  202826 */     // GIR_Coverage, 470,
     /*  202826 */     GIR_Done,
     /*  202827 */   // Label 3980: @202827
     /*  202827 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(202868), // Rule ID 472 //
     /*  202832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202849 */     // MIs[0] rs1
     /*  202849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202861 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202866 */     GIR_RootConstrainSelectedInstOperands,
     /*  202867 */     // GIR_Coverage, 472,
     /*  202867 */     GIR_Done,
     /*  202868 */   // Label 3981: @202868
     /*  202868 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(202909), // Rule ID 474 //
     /*  202873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202890 */     // MIs[0] rs1
     /*  202890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202902 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202907 */     GIR_RootConstrainSelectedInstOperands,
     /*  202908 */     // GIR_Coverage, 474,
     /*  202908 */     GIR_Done,
     /*  202909 */   // Label 3982: @202909
     /*  202909 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(202950), // Rule ID 476 //
     /*  202914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202931 */     // MIs[0] rs1
     /*  202931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202943 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202948 */     GIR_RootConstrainSelectedInstOperands,
     /*  202949 */     // GIR_Coverage, 476,
     /*  202949 */     GIR_Done,
     /*  202950 */   // Label 3983: @202950
     /*  202950 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(202991), // Rule ID 478 //
     /*  202955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202972 */     // MIs[0] rs1
     /*  202972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202984 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  202989 */     GIR_RootConstrainSelectedInstOperands,
     /*  202990 */     // GIR_Coverage, 478,
     /*  202990 */     GIR_Done,
     /*  202991 */   // Label 3984: @202991
     /*  202991 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(203032), // Rule ID 480 //
     /*  202996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203013 */     // MIs[0] rs1
     /*  203013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203025 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  203030 */     GIR_RootConstrainSelectedInstOperands,
     /*  203031 */     // GIR_Coverage, 480,
     /*  203031 */     GIR_Done,
     /*  203032 */   // Label 3985: @203032
     /*  203032 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(203073), // Rule ID 810 //
     /*  203037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203054 */     // MIs[0] rs1
     /*  203054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203066 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203071 */     GIR_RootConstrainSelectedInstOperands,
     /*  203072 */     // GIR_Coverage, 810,
     /*  203072 */     GIR_Done,
     /*  203073 */   // Label 3986: @203073
     /*  203073 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(203114), // Rule ID 812 //
     /*  203078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203095 */     // MIs[0] rs1
     /*  203095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203107 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  203112 */     GIR_RootConstrainSelectedInstOperands,
     /*  203113 */     // GIR_Coverage, 812,
     /*  203113 */     GIR_Done,
     /*  203114 */   // Label 3987: @203114
     /*  203114 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(203155), // Rule ID 814 //
     /*  203119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203136 */     // MIs[0] rs1
     /*  203136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203148 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  203153 */     GIR_RootConstrainSelectedInstOperands,
     /*  203154 */     // GIR_Coverage, 814,
     /*  203154 */     GIR_Done,
     /*  203155 */   // Label 3988: @203155
     /*  203155 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(203196), // Rule ID 816 //
     /*  203160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203177 */     // MIs[0] rs1
     /*  203177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203189 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  203194 */     GIR_RootConstrainSelectedInstOperands,
     /*  203195 */     // GIR_Coverage, 816,
     /*  203195 */     GIR_Done,
     /*  203196 */   // Label 3989: @203196
     /*  203196 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(203237), // Rule ID 818 //
     /*  203201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203218 */     // MIs[0] rs1
     /*  203218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203230 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  203235 */     GIR_RootConstrainSelectedInstOperands,
     /*  203236 */     // GIR_Coverage, 818,
     /*  203236 */     GIR_Done,
     /*  203237 */   // Label 3990: @203237
     /*  203237 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(203278), // Rule ID 820 //
     /*  203242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203259 */     // MIs[0] rs1
     /*  203259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203271 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203276 */     GIR_RootConstrainSelectedInstOperands,
     /*  203277 */     // GIR_Coverage, 820,
     /*  203277 */     GIR_Done,
     /*  203278 */   // Label 3991: @203278
     /*  203278 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(203319), // Rule ID 822 //
     /*  203283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203300 */     // MIs[0] rs1
     /*  203300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203312 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203317 */     GIR_RootConstrainSelectedInstOperands,
     /*  203318 */     // GIR_Coverage, 822,
     /*  203318 */     GIR_Done,
     /*  203319 */   // Label 3992: @203319
     /*  203319 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(203360), // Rule ID 824 //
     /*  203324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203341 */     // MIs[0] rs1
     /*  203341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203353 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203358 */     GIR_RootConstrainSelectedInstOperands,
     /*  203359 */     // GIR_Coverage, 824,
     /*  203359 */     GIR_Done,
     /*  203360 */   // Label 3993: @203360
     /*  203360 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(203401), // Rule ID 826 //
     /*  203365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203382 */     // MIs[0] rs1
     /*  203382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203394 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203399 */     GIR_RootConstrainSelectedInstOperands,
     /*  203400 */     // GIR_Coverage, 826,
     /*  203400 */     GIR_Done,
     /*  203401 */   // Label 3994: @203401
     /*  203401 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(203442), // Rule ID 828 //
     /*  203406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203423 */     // MIs[0] rs1
     /*  203423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203435 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  203440 */     GIR_RootConstrainSelectedInstOperands,
     /*  203441 */     // GIR_Coverage, 828,
     /*  203441 */     GIR_Done,
     /*  203442 */   // Label 3995: @203442
     /*  203442 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(203483), // Rule ID 990 //
     /*  203447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203464 */     // MIs[0] rs1
     /*  203464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203476 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203481 */     GIR_RootConstrainSelectedInstOperands,
     /*  203482 */     // GIR_Coverage, 990,
     /*  203482 */     GIR_Done,
     /*  203483 */   // Label 3996: @203483
     /*  203483 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(203524), // Rule ID 992 //
     /*  203488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203505 */     // MIs[0] rs1
     /*  203505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203517 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  203522 */     GIR_RootConstrainSelectedInstOperands,
     /*  203523 */     // GIR_Coverage, 992,
     /*  203523 */     GIR_Done,
     /*  203524 */   // Label 3997: @203524
     /*  203524 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(203565), // Rule ID 994 //
     /*  203529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203546 */     // MIs[0] rs1
     /*  203546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203558 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  203563 */     GIR_RootConstrainSelectedInstOperands,
     /*  203564 */     // GIR_Coverage, 994,
     /*  203564 */     GIR_Done,
     /*  203565 */   // Label 3998: @203565
     /*  203565 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(203606), // Rule ID 996 //
     /*  203570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203587 */     // MIs[0] rs1
     /*  203587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203599 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  203604 */     GIR_RootConstrainSelectedInstOperands,
     /*  203605 */     // GIR_Coverage, 996,
     /*  203605 */     GIR_Done,
     /*  203606 */   // Label 3999: @203606
     /*  203606 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(203647), // Rule ID 998 //
     /*  203611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  203614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203628 */     // MIs[0] rs1
     /*  203628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203640 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  203645 */     GIR_RootConstrainSelectedInstOperands,
     /*  203646 */     // GIR_Coverage, 998,
     /*  203646 */     GIR_Done,
     /*  203647 */   // Label 4000: @203647
     /*  203647 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(203688), // Rule ID 1000 //
     /*  203652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203669 */     // MIs[0] rs1
     /*  203669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203681 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203686 */     GIR_RootConstrainSelectedInstOperands,
     /*  203687 */     // GIR_Coverage, 1000,
     /*  203687 */     GIR_Done,
     /*  203688 */   // Label 4001: @203688
     /*  203688 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(203729), // Rule ID 1002 //
     /*  203693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203710 */     // MIs[0] rs1
     /*  203710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203722 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203727 */     GIR_RootConstrainSelectedInstOperands,
     /*  203728 */     // GIR_Coverage, 1002,
     /*  203728 */     GIR_Done,
     /*  203729 */   // Label 4002: @203729
     /*  203729 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(203770), // Rule ID 1004 //
     /*  203734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203751 */     // MIs[0] rs1
     /*  203751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203763 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203768 */     GIR_RootConstrainSelectedInstOperands,
     /*  203769 */     // GIR_Coverage, 1004,
     /*  203769 */     GIR_Done,
     /*  203770 */   // Label 4003: @203770
     /*  203770 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(203811), // Rule ID 1006 //
     /*  203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203792 */     // MIs[0] rs1
     /*  203792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203804 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203809 */     GIR_RootConstrainSelectedInstOperands,
     /*  203810 */     // GIR_Coverage, 1006,
     /*  203810 */     GIR_Done,
     /*  203811 */   // Label 4004: @203811
     /*  203811 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(203852), // Rule ID 1008 //
     /*  203816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  203819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203833 */     // MIs[0] rs1
     /*  203833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  203837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203845 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  203845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  203850 */     GIR_RootConstrainSelectedInstOperands,
     /*  203851 */     // GIR_Coverage, 1008,
     /*  203851 */     GIR_Done,
     /*  203852 */   // Label 4005: @203852
     /*  203852 */   GIM_Reject,
     /*  203853 */ // Label 3975: @203853
     /*  203853 */ GIM_Reject,
     /*  203854 */ // Label 3973: @203854
     /*  203854 */ GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(205503),
     /*  203859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  203862 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(203903), // Rule ID 461 //
     /*  203867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203884 */     // MIs[0] rs1
     /*  203884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203896 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  203901 */     GIR_RootConstrainSelectedInstOperands,
     /*  203902 */     // GIR_Coverage, 461,
     /*  203902 */     GIR_Done,
     /*  203903 */   // Label 4007: @203903
     /*  203903 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(203944), // Rule ID 463 //
     /*  203908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203925 */     // MIs[0] rs1
     /*  203925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203937 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  203942 */     GIR_RootConstrainSelectedInstOperands,
     /*  203943 */     // GIR_Coverage, 463,
     /*  203943 */     GIR_Done,
     /*  203944 */   // Label 4008: @203944
     /*  203944 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(203985), // Rule ID 465 //
     /*  203949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203966 */     // MIs[0] rs1
     /*  203966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203978 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  203983 */     GIR_RootConstrainSelectedInstOperands,
     /*  203984 */     // GIR_Coverage, 465,
     /*  203984 */     GIR_Done,
     /*  203985 */   // Label 4009: @203985
     /*  203985 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(204026), // Rule ID 467 //
     /*  203990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204007 */     // MIs[0] rs1
     /*  204007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204019 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  204024 */     GIR_RootConstrainSelectedInstOperands,
     /*  204025 */     // GIR_Coverage, 467,
     /*  204025 */     GIR_Done,
     /*  204026 */   // Label 4010: @204026
     /*  204026 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(204067), // Rule ID 469 //
     /*  204031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  204034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204048 */     // MIs[0] rs1
     /*  204048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204060 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  204065 */     GIR_RootConstrainSelectedInstOperands,
     /*  204066 */     // GIR_Coverage, 469,
     /*  204066 */     GIR_Done,
     /*  204067 */   // Label 4011: @204067
     /*  204067 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(204108), // Rule ID 471 //
     /*  204072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204089 */     // MIs[0] rs1
     /*  204089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204101 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204106 */     GIR_RootConstrainSelectedInstOperands,
     /*  204107 */     // GIR_Coverage, 471,
     /*  204107 */     GIR_Done,
     /*  204108 */   // Label 4012: @204108
     /*  204108 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(204149), // Rule ID 473 //
     /*  204113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204130 */     // MIs[0] rs1
     /*  204130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204142 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204147 */     GIR_RootConstrainSelectedInstOperands,
     /*  204148 */     // GIR_Coverage, 473,
     /*  204148 */     GIR_Done,
     /*  204149 */   // Label 4013: @204149
     /*  204149 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(204190), // Rule ID 475 //
     /*  204154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204171 */     // MIs[0] rs1
     /*  204171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204183 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204188 */     GIR_RootConstrainSelectedInstOperands,
     /*  204189 */     // GIR_Coverage, 475,
     /*  204189 */     GIR_Done,
     /*  204190 */   // Label 4014: @204190
     /*  204190 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(204231), // Rule ID 477 //
     /*  204195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204212 */     // MIs[0] rs1
     /*  204212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204224 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204229 */     GIR_RootConstrainSelectedInstOperands,
     /*  204230 */     // GIR_Coverage, 477,
     /*  204230 */     GIR_Done,
     /*  204231 */   // Label 4015: @204231
     /*  204231 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(204272), // Rule ID 479 //
     /*  204236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  204239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204253 */     // MIs[0] rs1
     /*  204253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204265 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  204270 */     GIR_RootConstrainSelectedInstOperands,
     /*  204271 */     // GIR_Coverage, 479,
     /*  204271 */     GIR_Done,
     /*  204272 */   // Label 4016: @204272
     /*  204272 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(204313), // Rule ID 581 //
     /*  204277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204294 */     // MIs[0] rs1
     /*  204294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204306 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204311 */     GIR_RootConstrainSelectedInstOperands,
     /*  204312 */     // GIR_Coverage, 581,
     /*  204312 */     GIR_Done,
     /*  204313 */   // Label 4017: @204313
     /*  204313 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(204354), // Rule ID 582 //
     /*  204318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204335 */     // MIs[0] rs1
     /*  204335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204347 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  204352 */     GIR_RootConstrainSelectedInstOperands,
     /*  204353 */     // GIR_Coverage, 582,
     /*  204353 */     GIR_Done,
     /*  204354 */   // Label 4018: @204354
     /*  204354 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(204395), // Rule ID 583 //
     /*  204359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204376 */     // MIs[0] rs1
     /*  204376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204388 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  204393 */     GIR_RootConstrainSelectedInstOperands,
     /*  204394 */     // GIR_Coverage, 583,
     /*  204394 */     GIR_Done,
     /*  204395 */   // Label 4019: @204395
     /*  204395 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(204436), // Rule ID 584 //
     /*  204400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204417 */     // MIs[0] rs1
     /*  204417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204429 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  204434 */     GIR_RootConstrainSelectedInstOperands,
     /*  204435 */     // GIR_Coverage, 584,
     /*  204435 */     GIR_Done,
     /*  204436 */   // Label 4020: @204436
     /*  204436 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(204477), // Rule ID 585 //
     /*  204441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  204444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204458 */     // MIs[0] rs1
     /*  204458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204470 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  204475 */     GIR_RootConstrainSelectedInstOperands,
     /*  204476 */     // GIR_Coverage, 585,
     /*  204476 */     GIR_Done,
     /*  204477 */   // Label 4021: @204477
     /*  204477 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(204518), // Rule ID 586 //
     /*  204482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204499 */     // MIs[0] rs1
     /*  204499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204511 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204516 */     GIR_RootConstrainSelectedInstOperands,
     /*  204517 */     // GIR_Coverage, 586,
     /*  204517 */     GIR_Done,
     /*  204518 */   // Label 4022: @204518
     /*  204518 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(204559), // Rule ID 587 //
     /*  204523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204540 */     // MIs[0] rs1
     /*  204540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204552 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204557 */     GIR_RootConstrainSelectedInstOperands,
     /*  204558 */     // GIR_Coverage, 587,
     /*  204558 */     GIR_Done,
     /*  204559 */   // Label 4023: @204559
     /*  204559 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(204600), // Rule ID 588 //
     /*  204564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204581 */     // MIs[0] rs1
     /*  204581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204593 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204598 */     GIR_RootConstrainSelectedInstOperands,
     /*  204599 */     // GIR_Coverage, 588,
     /*  204599 */     GIR_Done,
     /*  204600 */   // Label 4024: @204600
     /*  204600 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(204641), // Rule ID 589 //
     /*  204605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204622 */     // MIs[0] rs1
     /*  204622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204634 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204639 */     GIR_RootConstrainSelectedInstOperands,
     /*  204640 */     // GIR_Coverage, 589,
     /*  204640 */     GIR_Done,
     /*  204641 */   // Label 4025: @204641
     /*  204641 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(204682), // Rule ID 590 //
     /*  204646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  204649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  204656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204663 */     // MIs[0] rs1
     /*  204663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204675 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  204680 */     GIR_RootConstrainSelectedInstOperands,
     /*  204681 */     // GIR_Coverage, 590,
     /*  204681 */     GIR_Done,
     /*  204682 */   // Label 4026: @204682
     /*  204682 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(204723), // Rule ID 809 //
     /*  204687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204704 */     // MIs[0] rs1
     /*  204704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204716 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204721 */     GIR_RootConstrainSelectedInstOperands,
     /*  204722 */     // GIR_Coverage, 809,
     /*  204722 */     GIR_Done,
     /*  204723 */   // Label 4027: @204723
     /*  204723 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(204764), // Rule ID 811 //
     /*  204728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204745 */     // MIs[0] rs1
     /*  204745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204757 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  204762 */     GIR_RootConstrainSelectedInstOperands,
     /*  204763 */     // GIR_Coverage, 811,
     /*  204763 */     GIR_Done,
     /*  204764 */   // Label 4028: @204764
     /*  204764 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(204805), // Rule ID 813 //
     /*  204769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204786 */     // MIs[0] rs1
     /*  204786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204798 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  204803 */     GIR_RootConstrainSelectedInstOperands,
     /*  204804 */     // GIR_Coverage, 813,
     /*  204804 */     GIR_Done,
     /*  204805 */   // Label 4029: @204805
     /*  204805 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(204846), // Rule ID 815 //
     /*  204810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204827 */     // MIs[0] rs1
     /*  204827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204839 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  204844 */     GIR_RootConstrainSelectedInstOperands,
     /*  204845 */     // GIR_Coverage, 815,
     /*  204845 */     GIR_Done,
     /*  204846 */   // Label 4030: @204846
     /*  204846 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(204887), // Rule ID 817 //
     /*  204851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204868 */     // MIs[0] rs1
     /*  204868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204880 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  204885 */     GIR_RootConstrainSelectedInstOperands,
     /*  204886 */     // GIR_Coverage, 817,
     /*  204886 */     GIR_Done,
     /*  204887 */   // Label 4031: @204887
     /*  204887 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(204928), // Rule ID 819 //
     /*  204892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204909 */     // MIs[0] rs1
     /*  204909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204921 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204926 */     GIR_RootConstrainSelectedInstOperands,
     /*  204927 */     // GIR_Coverage, 819,
     /*  204927 */     GIR_Done,
     /*  204928 */   // Label 4032: @204928
     /*  204928 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(204969), // Rule ID 821 //
     /*  204933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204950 */     // MIs[0] rs1
     /*  204950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204962 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  204967 */     GIR_RootConstrainSelectedInstOperands,
     /*  204968 */     // GIR_Coverage, 821,
     /*  204968 */     GIR_Done,
     /*  204969 */   // Label 4033: @204969
     /*  204969 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(205010), // Rule ID 823 //
     /*  204974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204991 */     // MIs[0] rs1
     /*  204991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205003 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205008 */     GIR_RootConstrainSelectedInstOperands,
     /*  205009 */     // GIR_Coverage, 823,
     /*  205009 */     GIR_Done,
     /*  205010 */   // Label 4034: @205010
     /*  205010 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(205051), // Rule ID 825 //
     /*  205015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205032 */     // MIs[0] rs1
     /*  205032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205044 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205049 */     GIR_RootConstrainSelectedInstOperands,
     /*  205050 */     // GIR_Coverage, 825,
     /*  205050 */     GIR_Done,
     /*  205051 */   // Label 4035: @205051
     /*  205051 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(205092), // Rule ID 827 //
     /*  205056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205073 */     // MIs[0] rs1
     /*  205073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205085 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  205090 */     GIR_RootConstrainSelectedInstOperands,
     /*  205091 */     // GIR_Coverage, 827,
     /*  205091 */     GIR_Done,
     /*  205092 */   // Label 4036: @205092
     /*  205092 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(205133), // Rule ID 989 //
     /*  205097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205114 */     // MIs[0] rs1
     /*  205114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205126 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205131 */     GIR_RootConstrainSelectedInstOperands,
     /*  205132 */     // GIR_Coverage, 989,
     /*  205132 */     GIR_Done,
     /*  205133 */   // Label 4037: @205133
     /*  205133 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(205174), // Rule ID 991 //
     /*  205138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205155 */     // MIs[0] rs1
     /*  205155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205167 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  205172 */     GIR_RootConstrainSelectedInstOperands,
     /*  205173 */     // GIR_Coverage, 991,
     /*  205173 */     GIR_Done,
     /*  205174 */   // Label 4038: @205174
     /*  205174 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(205215), // Rule ID 993 //
     /*  205179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205196 */     // MIs[0] rs1
     /*  205196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205208 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  205213 */     GIR_RootConstrainSelectedInstOperands,
     /*  205214 */     // GIR_Coverage, 993,
     /*  205214 */     GIR_Done,
     /*  205215 */   // Label 4039: @205215
     /*  205215 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(205256), // Rule ID 995 //
     /*  205220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205237 */     // MIs[0] rs1
     /*  205237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205249 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  205254 */     GIR_RootConstrainSelectedInstOperands,
     /*  205255 */     // GIR_Coverage, 995,
     /*  205255 */     GIR_Done,
     /*  205256 */   // Label 4040: @205256
     /*  205256 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(205297), // Rule ID 997 //
     /*  205261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  205264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205278 */     // MIs[0] rs1
     /*  205278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205290 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  205295 */     GIR_RootConstrainSelectedInstOperands,
     /*  205296 */     // GIR_Coverage, 997,
     /*  205296 */     GIR_Done,
     /*  205297 */   // Label 4041: @205297
     /*  205297 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(205338), // Rule ID 999 //
     /*  205302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205319 */     // MIs[0] rs1
     /*  205319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205331 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205336 */     GIR_RootConstrainSelectedInstOperands,
     /*  205337 */     // GIR_Coverage, 999,
     /*  205337 */     GIR_Done,
     /*  205338 */   // Label 4042: @205338
     /*  205338 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(205379), // Rule ID 1001 //
     /*  205343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205360 */     // MIs[0] rs1
     /*  205360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205372 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205377 */     GIR_RootConstrainSelectedInstOperands,
     /*  205378 */     // GIR_Coverage, 1001,
     /*  205378 */     GIR_Done,
     /*  205379 */   // Label 4043: @205379
     /*  205379 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(205420), // Rule ID 1003 //
     /*  205384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205401 */     // MIs[0] rs1
     /*  205401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205413 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205418 */     GIR_RootConstrainSelectedInstOperands,
     /*  205419 */     // GIR_Coverage, 1003,
     /*  205419 */     GIR_Done,
     /*  205420 */   // Label 4044: @205420
     /*  205420 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(205461), // Rule ID 1005 //
     /*  205425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205442 */     // MIs[0] rs1
     /*  205442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205454 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205459 */     GIR_RootConstrainSelectedInstOperands,
     /*  205460 */     // GIR_Coverage, 1005,
     /*  205460 */     GIR_Done,
     /*  205461 */   // Label 4045: @205461
     /*  205461 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(205502), // Rule ID 1007 //
     /*  205466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  205469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205483 */     // MIs[0] rs1
     /*  205483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205495 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  205500 */     GIR_RootConstrainSelectedInstOperands,
     /*  205501 */     // GIR_Coverage, 1007,
     /*  205501 */     GIR_Done,
     /*  205502 */   // Label 4046: @205502
     /*  205502 */   GIM_Reject,
     /*  205503 */ // Label 4006: @205503
     /*  205503 */ GIM_Reject,
     /*  205504 */ // Label 3974: @205504
     /*  205504 */ GIM_Reject,
     /*  205505 */ // Label 34: @205505
     /*  205505 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4049*/ GIMT_Encode4(208414),
     /*  205516 */ /*GILLT_s32*//*Label 4047*/ GIMT_Encode4(205524),
     /*  205520 */ /*GILLT_s64*//*Label 4048*/ GIMT_Encode4(206764),
     /*  205524 */ // Label 4047: @205524
     /*  205524 */ GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(206763),
     /*  205529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  205532 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(205573), // Rule ID 482 //
     /*  205537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205554 */     // MIs[0] rs1
     /*  205554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205566 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205571 */     GIR_RootConstrainSelectedInstOperands,
     /*  205572 */     // GIR_Coverage, 482,
     /*  205572 */     GIR_Done,
     /*  205573 */   // Label 4051: @205573
     /*  205573 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(205614), // Rule ID 484 //
     /*  205578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205595 */     // MIs[0] rs1
     /*  205595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205607 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  205612 */     GIR_RootConstrainSelectedInstOperands,
     /*  205613 */     // GIR_Coverage, 484,
     /*  205613 */     GIR_Done,
     /*  205614 */   // Label 4052: @205614
     /*  205614 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(205655), // Rule ID 486 //
     /*  205619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205636 */     // MIs[0] rs1
     /*  205636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205648 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  205653 */     GIR_RootConstrainSelectedInstOperands,
     /*  205654 */     // GIR_Coverage, 486,
     /*  205654 */     GIR_Done,
     /*  205655 */   // Label 4053: @205655
     /*  205655 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205696), // Rule ID 488 //
     /*  205660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205677 */     // MIs[0] rs1
     /*  205677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205689 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  205694 */     GIR_RootConstrainSelectedInstOperands,
     /*  205695 */     // GIR_Coverage, 488,
     /*  205695 */     GIR_Done,
     /*  205696 */   // Label 4054: @205696
     /*  205696 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205737), // Rule ID 490 //
     /*  205701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  205704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205718 */     // MIs[0] rs1
     /*  205718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205730 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  205735 */     GIR_RootConstrainSelectedInstOperands,
     /*  205736 */     // GIR_Coverage, 490,
     /*  205736 */     GIR_Done,
     /*  205737 */   // Label 4055: @205737
     /*  205737 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205778), // Rule ID 492 //
     /*  205742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205759 */     // MIs[0] rs1
     /*  205759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205771 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205776 */     GIR_RootConstrainSelectedInstOperands,
     /*  205777 */     // GIR_Coverage, 492,
     /*  205777 */     GIR_Done,
     /*  205778 */   // Label 4056: @205778
     /*  205778 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205819), // Rule ID 494 //
     /*  205783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205800 */     // MIs[0] rs1
     /*  205800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205812 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205817 */     GIR_RootConstrainSelectedInstOperands,
     /*  205818 */     // GIR_Coverage, 494,
     /*  205818 */     GIR_Done,
     /*  205819 */   // Label 4057: @205819
     /*  205819 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205860), // Rule ID 496 //
     /*  205824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205841 */     // MIs[0] rs1
     /*  205841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205853 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205858 */     GIR_RootConstrainSelectedInstOperands,
     /*  205859 */     // GIR_Coverage, 496,
     /*  205859 */     GIR_Done,
     /*  205860 */   // Label 4058: @205860
     /*  205860 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205901), // Rule ID 498 //
     /*  205865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205882 */     // MIs[0] rs1
     /*  205882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205894 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205899 */     GIR_RootConstrainSelectedInstOperands,
     /*  205900 */     // GIR_Coverage, 498,
     /*  205900 */     GIR_Done,
     /*  205901 */   // Label 4059: @205901
     /*  205901 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205942), // Rule ID 500 //
     /*  205906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  205909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205923 */     // MIs[0] rs1
     /*  205923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205935 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  205940 */     GIR_RootConstrainSelectedInstOperands,
     /*  205941 */     // GIR_Coverage, 500,
     /*  205941 */     GIR_Done,
     /*  205942 */   // Label 4060: @205942
     /*  205942 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205983), // Rule ID 830 //
     /*  205947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205964 */     // MIs[0] rs1
     /*  205964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205976 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  205981 */     GIR_RootConstrainSelectedInstOperands,
     /*  205982 */     // GIR_Coverage, 830,
     /*  205982 */     GIR_Done,
     /*  205983 */   // Label 4061: @205983
     /*  205983 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(206024), // Rule ID 832 //
     /*  205988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206005 */     // MIs[0] rs1
     /*  206005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206017 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  206022 */     GIR_RootConstrainSelectedInstOperands,
     /*  206023 */     // GIR_Coverage, 832,
     /*  206023 */     GIR_Done,
     /*  206024 */   // Label 4062: @206024
     /*  206024 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(206065), // Rule ID 834 //
     /*  206029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206046 */     // MIs[0] rs1
     /*  206046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206058 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  206063 */     GIR_RootConstrainSelectedInstOperands,
     /*  206064 */     // GIR_Coverage, 834,
     /*  206064 */     GIR_Done,
     /*  206065 */   // Label 4063: @206065
     /*  206065 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(206106), // Rule ID 836 //
     /*  206070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206087 */     // MIs[0] rs1
     /*  206087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206099 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  206104 */     GIR_RootConstrainSelectedInstOperands,
     /*  206105 */     // GIR_Coverage, 836,
     /*  206105 */     GIR_Done,
     /*  206106 */   // Label 4064: @206106
     /*  206106 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(206147), // Rule ID 838 //
     /*  206111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206128 */     // MIs[0] rs1
     /*  206128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206140 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  206145 */     GIR_RootConstrainSelectedInstOperands,
     /*  206146 */     // GIR_Coverage, 838,
     /*  206146 */     GIR_Done,
     /*  206147 */   // Label 4065: @206147
     /*  206147 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(206188), // Rule ID 840 //
     /*  206152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206169 */     // MIs[0] rs1
     /*  206169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206181 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206186 */     GIR_RootConstrainSelectedInstOperands,
     /*  206187 */     // GIR_Coverage, 840,
     /*  206187 */     GIR_Done,
     /*  206188 */   // Label 4066: @206188
     /*  206188 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(206229), // Rule ID 842 //
     /*  206193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206210 */     // MIs[0] rs1
     /*  206210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206222 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206227 */     GIR_RootConstrainSelectedInstOperands,
     /*  206228 */     // GIR_Coverage, 842,
     /*  206228 */     GIR_Done,
     /*  206229 */   // Label 4067: @206229
     /*  206229 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(206270), // Rule ID 844 //
     /*  206234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206251 */     // MIs[0] rs1
     /*  206251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206263 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206268 */     GIR_RootConstrainSelectedInstOperands,
     /*  206269 */     // GIR_Coverage, 844,
     /*  206269 */     GIR_Done,
     /*  206270 */   // Label 4068: @206270
     /*  206270 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(206311), // Rule ID 846 //
     /*  206275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206292 */     // MIs[0] rs1
     /*  206292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206304 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206309 */     GIR_RootConstrainSelectedInstOperands,
     /*  206310 */     // GIR_Coverage, 846,
     /*  206310 */     GIR_Done,
     /*  206311 */   // Label 4069: @206311
     /*  206311 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(206352), // Rule ID 848 //
     /*  206316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206333 */     // MIs[0] rs1
     /*  206333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206345 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  206350 */     GIR_RootConstrainSelectedInstOperands,
     /*  206351 */     // GIR_Coverage, 848,
     /*  206351 */     GIR_Done,
     /*  206352 */   // Label 4070: @206352
     /*  206352 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(206393), // Rule ID 1010 //
     /*  206357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206374 */     // MIs[0] rs1
     /*  206374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206386 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206391 */     GIR_RootConstrainSelectedInstOperands,
     /*  206392 */     // GIR_Coverage, 1010,
     /*  206392 */     GIR_Done,
     /*  206393 */   // Label 4071: @206393
     /*  206393 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206434), // Rule ID 1012 //
     /*  206398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206415 */     // MIs[0] rs1
     /*  206415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206427 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  206432 */     GIR_RootConstrainSelectedInstOperands,
     /*  206433 */     // GIR_Coverage, 1012,
     /*  206433 */     GIR_Done,
     /*  206434 */   // Label 4072: @206434
     /*  206434 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206475), // Rule ID 1014 //
     /*  206439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206456 */     // MIs[0] rs1
     /*  206456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206468 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  206473 */     GIR_RootConstrainSelectedInstOperands,
     /*  206474 */     // GIR_Coverage, 1014,
     /*  206474 */     GIR_Done,
     /*  206475 */   // Label 4073: @206475
     /*  206475 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206516), // Rule ID 1016 //
     /*  206480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206497 */     // MIs[0] rs1
     /*  206497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206509 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  206514 */     GIR_RootConstrainSelectedInstOperands,
     /*  206515 */     // GIR_Coverage, 1016,
     /*  206515 */     GIR_Done,
     /*  206516 */   // Label 4074: @206516
     /*  206516 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206557), // Rule ID 1018 //
     /*  206521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  206524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206538 */     // MIs[0] rs1
     /*  206538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206550 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  206555 */     GIR_RootConstrainSelectedInstOperands,
     /*  206556 */     // GIR_Coverage, 1018,
     /*  206556 */     GIR_Done,
     /*  206557 */   // Label 4075: @206557
     /*  206557 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206598), // Rule ID 1020 //
     /*  206562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206579 */     // MIs[0] rs1
     /*  206579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206591 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206596 */     GIR_RootConstrainSelectedInstOperands,
     /*  206597 */     // GIR_Coverage, 1020,
     /*  206597 */     GIR_Done,
     /*  206598 */   // Label 4076: @206598
     /*  206598 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206639), // Rule ID 1022 //
     /*  206603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206620 */     // MIs[0] rs1
     /*  206620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206632 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206637 */     GIR_RootConstrainSelectedInstOperands,
     /*  206638 */     // GIR_Coverage, 1022,
     /*  206638 */     GIR_Done,
     /*  206639 */   // Label 4077: @206639
     /*  206639 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206680), // Rule ID 1024 //
     /*  206644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206661 */     // MIs[0] rs1
     /*  206661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206673 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206678 */     GIR_RootConstrainSelectedInstOperands,
     /*  206679 */     // GIR_Coverage, 1024,
     /*  206679 */     GIR_Done,
     /*  206680 */   // Label 4078: @206680
     /*  206680 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206721), // Rule ID 1026 //
     /*  206685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206702 */     // MIs[0] rs1
     /*  206702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206714 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206719 */     GIR_RootConstrainSelectedInstOperands,
     /*  206720 */     // GIR_Coverage, 1026,
     /*  206720 */     GIR_Done,
     /*  206721 */   // Label 4079: @206721
     /*  206721 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206762), // Rule ID 1028 //
     /*  206726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  206729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206743 */     // MIs[0] rs1
     /*  206743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  206747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206755 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  206755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  206760 */     GIR_RootConstrainSelectedInstOperands,
     /*  206761 */     // GIR_Coverage, 1028,
     /*  206761 */     GIR_Done,
     /*  206762 */   // Label 4080: @206762
     /*  206762 */   GIM_Reject,
     /*  206763 */ // Label 4050: @206763
     /*  206763 */ GIM_Reject,
     /*  206764 */ // Label 4048: @206764
     /*  206764 */ GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(208413),
     /*  206769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  206772 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206813), // Rule ID 481 //
     /*  206777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206794 */     // MIs[0] rs1
     /*  206794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206806 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  206811 */     GIR_RootConstrainSelectedInstOperands,
     /*  206812 */     // GIR_Coverage, 481,
     /*  206812 */     GIR_Done,
     /*  206813 */   // Label 4082: @206813
     /*  206813 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206854), // Rule ID 483 //
     /*  206818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206835 */     // MIs[0] rs1
     /*  206835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206847 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  206852 */     GIR_RootConstrainSelectedInstOperands,
     /*  206853 */     // GIR_Coverage, 483,
     /*  206853 */     GIR_Done,
     /*  206854 */   // Label 4083: @206854
     /*  206854 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206895), // Rule ID 485 //
     /*  206859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206876 */     // MIs[0] rs1
     /*  206876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206888 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  206893 */     GIR_RootConstrainSelectedInstOperands,
     /*  206894 */     // GIR_Coverage, 485,
     /*  206894 */     GIR_Done,
     /*  206895 */   // Label 4084: @206895
     /*  206895 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206936), // Rule ID 487 //
     /*  206900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206917 */     // MIs[0] rs1
     /*  206917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206929 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  206934 */     GIR_RootConstrainSelectedInstOperands,
     /*  206935 */     // GIR_Coverage, 487,
     /*  206935 */     GIR_Done,
     /*  206936 */   // Label 4085: @206936
     /*  206936 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206977), // Rule ID 489 //
     /*  206941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206958 */     // MIs[0] rs1
     /*  206958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206970 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  206975 */     GIR_RootConstrainSelectedInstOperands,
     /*  206976 */     // GIR_Coverage, 489,
     /*  206976 */     GIR_Done,
     /*  206977 */   // Label 4086: @206977
     /*  206977 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207018), // Rule ID 491 //
     /*  206982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206999 */     // MIs[0] rs1
     /*  206999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207011 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207016 */     GIR_RootConstrainSelectedInstOperands,
     /*  207017 */     // GIR_Coverage, 491,
     /*  207017 */     GIR_Done,
     /*  207018 */   // Label 4087: @207018
     /*  207018 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207059), // Rule ID 493 //
     /*  207023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207040 */     // MIs[0] rs1
     /*  207040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207052 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207057 */     GIR_RootConstrainSelectedInstOperands,
     /*  207058 */     // GIR_Coverage, 493,
     /*  207058 */     GIR_Done,
     /*  207059 */   // Label 4088: @207059
     /*  207059 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207100), // Rule ID 495 //
     /*  207064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207081 */     // MIs[0] rs1
     /*  207081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207093 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207098 */     GIR_RootConstrainSelectedInstOperands,
     /*  207099 */     // GIR_Coverage, 495,
     /*  207099 */     GIR_Done,
     /*  207100 */   // Label 4089: @207100
     /*  207100 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207141), // Rule ID 497 //
     /*  207105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207122 */     // MIs[0] rs1
     /*  207122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207134 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207139 */     GIR_RootConstrainSelectedInstOperands,
     /*  207140 */     // GIR_Coverage, 497,
     /*  207140 */     GIR_Done,
     /*  207141 */   // Label 4090: @207141
     /*  207141 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207182), // Rule ID 499 //
     /*  207146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  207149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  207156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207163 */     // MIs[0] rs1
     /*  207163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207175 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  207180 */     GIR_RootConstrainSelectedInstOperands,
     /*  207181 */     // GIR_Coverage, 499,
     /*  207181 */     GIR_Done,
     /*  207182 */   // Label 4091: @207182
     /*  207182 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207223), // Rule ID 591 //
     /*  207187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207204 */     // MIs[0] rs1
     /*  207204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207216 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207221 */     GIR_RootConstrainSelectedInstOperands,
     /*  207222 */     // GIR_Coverage, 591,
     /*  207222 */     GIR_Done,
     /*  207223 */   // Label 4092: @207223
     /*  207223 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207264), // Rule ID 592 //
     /*  207228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207245 */     // MIs[0] rs1
     /*  207245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207257 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  207262 */     GIR_RootConstrainSelectedInstOperands,
     /*  207263 */     // GIR_Coverage, 592,
     /*  207263 */     GIR_Done,
     /*  207264 */   // Label 4093: @207264
     /*  207264 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207305), // Rule ID 593 //
     /*  207269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207286 */     // MIs[0] rs1
     /*  207286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207298 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  207303 */     GIR_RootConstrainSelectedInstOperands,
     /*  207304 */     // GIR_Coverage, 593,
     /*  207304 */     GIR_Done,
     /*  207305 */   // Label 4094: @207305
     /*  207305 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207346), // Rule ID 594 //
     /*  207310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207327 */     // MIs[0] rs1
     /*  207327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207339 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  207344 */     GIR_RootConstrainSelectedInstOperands,
     /*  207345 */     // GIR_Coverage, 594,
     /*  207345 */     GIR_Done,
     /*  207346 */   // Label 4095: @207346
     /*  207346 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207387), // Rule ID 595 //
     /*  207351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  207354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207368 */     // MIs[0] rs1
     /*  207368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207380 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  207385 */     GIR_RootConstrainSelectedInstOperands,
     /*  207386 */     // GIR_Coverage, 595,
     /*  207386 */     GIR_Done,
     /*  207387 */   // Label 4096: @207387
     /*  207387 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207428), // Rule ID 596 //
     /*  207392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207409 */     // MIs[0] rs1
     /*  207409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207421 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207426 */     GIR_RootConstrainSelectedInstOperands,
     /*  207427 */     // GIR_Coverage, 596,
     /*  207427 */     GIR_Done,
     /*  207428 */   // Label 4097: @207428
     /*  207428 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207469), // Rule ID 597 //
     /*  207433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207450 */     // MIs[0] rs1
     /*  207450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207462 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207467 */     GIR_RootConstrainSelectedInstOperands,
     /*  207468 */     // GIR_Coverage, 597,
     /*  207468 */     GIR_Done,
     /*  207469 */   // Label 4098: @207469
     /*  207469 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207510), // Rule ID 598 //
     /*  207474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207491 */     // MIs[0] rs1
     /*  207491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207503 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207508 */     GIR_RootConstrainSelectedInstOperands,
     /*  207509 */     // GIR_Coverage, 598,
     /*  207509 */     GIR_Done,
     /*  207510 */   // Label 4099: @207510
     /*  207510 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207551), // Rule ID 599 //
     /*  207515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207532 */     // MIs[0] rs1
     /*  207532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207544 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207549 */     GIR_RootConstrainSelectedInstOperands,
     /*  207550 */     // GIR_Coverage, 599,
     /*  207550 */     GIR_Done,
     /*  207551 */   // Label 4100: @207551
     /*  207551 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207592), // Rule ID 600 //
     /*  207556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  207559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  207566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207573 */     // MIs[0] rs1
     /*  207573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207585 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  207590 */     GIR_RootConstrainSelectedInstOperands,
     /*  207591 */     // GIR_Coverage, 600,
     /*  207591 */     GIR_Done,
     /*  207592 */   // Label 4101: @207592
     /*  207592 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207633), // Rule ID 829 //
     /*  207597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207614 */     // MIs[0] rs1
     /*  207614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207626 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207631 */     GIR_RootConstrainSelectedInstOperands,
     /*  207632 */     // GIR_Coverage, 829,
     /*  207632 */     GIR_Done,
     /*  207633 */   // Label 4102: @207633
     /*  207633 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207674), // Rule ID 831 //
     /*  207638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207655 */     // MIs[0] rs1
     /*  207655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207667 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  207672 */     GIR_RootConstrainSelectedInstOperands,
     /*  207673 */     // GIR_Coverage, 831,
     /*  207673 */     GIR_Done,
     /*  207674 */   // Label 4103: @207674
     /*  207674 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207715), // Rule ID 833 //
     /*  207679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207696 */     // MIs[0] rs1
     /*  207696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207708 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  207713 */     GIR_RootConstrainSelectedInstOperands,
     /*  207714 */     // GIR_Coverage, 833,
     /*  207714 */     GIR_Done,
     /*  207715 */   // Label 4104: @207715
     /*  207715 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207756), // Rule ID 835 //
     /*  207720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207737 */     // MIs[0] rs1
     /*  207737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207749 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  207754 */     GIR_RootConstrainSelectedInstOperands,
     /*  207755 */     // GIR_Coverage, 835,
     /*  207755 */     GIR_Done,
     /*  207756 */   // Label 4105: @207756
     /*  207756 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207797), // Rule ID 837 //
     /*  207761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207778 */     // MIs[0] rs1
     /*  207778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207790 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  207795 */     GIR_RootConstrainSelectedInstOperands,
     /*  207796 */     // GIR_Coverage, 837,
     /*  207796 */     GIR_Done,
     /*  207797 */   // Label 4106: @207797
     /*  207797 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207838), // Rule ID 839 //
     /*  207802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207819 */     // MIs[0] rs1
     /*  207819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207831 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207836 */     GIR_RootConstrainSelectedInstOperands,
     /*  207837 */     // GIR_Coverage, 839,
     /*  207837 */     GIR_Done,
     /*  207838 */   // Label 4107: @207838
     /*  207838 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207879), // Rule ID 841 //
     /*  207843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207860 */     // MIs[0] rs1
     /*  207860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207872 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207877 */     GIR_RootConstrainSelectedInstOperands,
     /*  207878 */     // GIR_Coverage, 841,
     /*  207878 */     GIR_Done,
     /*  207879 */   // Label 4108: @207879
     /*  207879 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(207920), // Rule ID 843 //
     /*  207884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207901 */     // MIs[0] rs1
     /*  207901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207913 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207918 */     GIR_RootConstrainSelectedInstOperands,
     /*  207919 */     // GIR_Coverage, 843,
     /*  207919 */     GIR_Done,
     /*  207920 */   // Label 4109: @207920
     /*  207920 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(207961), // Rule ID 845 //
     /*  207925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207942 */     // MIs[0] rs1
     /*  207942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207954 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  207959 */     GIR_RootConstrainSelectedInstOperands,
     /*  207960 */     // GIR_Coverage, 845,
     /*  207960 */     GIR_Done,
     /*  207961 */   // Label 4110: @207961
     /*  207961 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208002), // Rule ID 847 //
     /*  207966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207983 */     // MIs[0] rs1
     /*  207983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207995 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  208000 */     GIR_RootConstrainSelectedInstOperands,
     /*  208001 */     // GIR_Coverage, 847,
     /*  208001 */     GIR_Done,
     /*  208002 */   // Label 4111: @208002
     /*  208002 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208043), // Rule ID 1009 //
     /*  208007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208024 */     // MIs[0] rs1
     /*  208024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208036 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208041 */     GIR_RootConstrainSelectedInstOperands,
     /*  208042 */     // GIR_Coverage, 1009,
     /*  208042 */     GIR_Done,
     /*  208043 */   // Label 4112: @208043
     /*  208043 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208084), // Rule ID 1011 //
     /*  208048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208065 */     // MIs[0] rs1
     /*  208065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208077 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  208082 */     GIR_RootConstrainSelectedInstOperands,
     /*  208083 */     // GIR_Coverage, 1011,
     /*  208083 */     GIR_Done,
     /*  208084 */   // Label 4113: @208084
     /*  208084 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208125), // Rule ID 1013 //
     /*  208089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208106 */     // MIs[0] rs1
     /*  208106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208118 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  208123 */     GIR_RootConstrainSelectedInstOperands,
     /*  208124 */     // GIR_Coverage, 1013,
     /*  208124 */     GIR_Done,
     /*  208125 */   // Label 4114: @208125
     /*  208125 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208166), // Rule ID 1015 //
     /*  208130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208147 */     // MIs[0] rs1
     /*  208147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208159 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  208164 */     GIR_RootConstrainSelectedInstOperands,
     /*  208165 */     // GIR_Coverage, 1015,
     /*  208165 */     GIR_Done,
     /*  208166 */   // Label 4115: @208166
     /*  208166 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208207), // Rule ID 1017 //
     /*  208171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  208174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208188 */     // MIs[0] rs1
     /*  208188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208200 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  208205 */     GIR_RootConstrainSelectedInstOperands,
     /*  208206 */     // GIR_Coverage, 1017,
     /*  208206 */     GIR_Done,
     /*  208207 */   // Label 4116: @208207
     /*  208207 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208248), // Rule ID 1019 //
     /*  208212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208229 */     // MIs[0] rs1
     /*  208229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208241 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208246 */     GIR_RootConstrainSelectedInstOperands,
     /*  208247 */     // GIR_Coverage, 1019,
     /*  208247 */     GIR_Done,
     /*  208248 */   // Label 4117: @208248
     /*  208248 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208289), // Rule ID 1021 //
     /*  208253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208270 */     // MIs[0] rs1
     /*  208270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208282 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208287 */     GIR_RootConstrainSelectedInstOperands,
     /*  208288 */     // GIR_Coverage, 1021,
     /*  208288 */     GIR_Done,
     /*  208289 */   // Label 4118: @208289
     /*  208289 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208330), // Rule ID 1023 //
     /*  208294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208311 */     // MIs[0] rs1
     /*  208311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208323 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208328 */     GIR_RootConstrainSelectedInstOperands,
     /*  208329 */     // GIR_Coverage, 1023,
     /*  208329 */     GIR_Done,
     /*  208330 */   // Label 4119: @208330
     /*  208330 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208371), // Rule ID 1025 //
     /*  208335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208352 */     // MIs[0] rs1
     /*  208352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208364 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208369 */     GIR_RootConstrainSelectedInstOperands,
     /*  208370 */     // GIR_Coverage, 1025,
     /*  208370 */     GIR_Done,
     /*  208371 */   // Label 4120: @208371
     /*  208371 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208412), // Rule ID 1027 //
     /*  208376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  208379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  208386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208393 */     // MIs[0] rs1
     /*  208393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  208397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208405 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  208405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  208410 */     GIR_RootConstrainSelectedInstOperands,
     /*  208411 */     // GIR_Coverage, 1027,
     /*  208411 */     GIR_Done,
     /*  208412 */   // Label 4121: @208412
     /*  208412 */   GIM_Reject,
     /*  208413 */ // Label 4081: @208413
     /*  208413 */ GIM_Reject,
     /*  208414 */ // Label 4049: @208414
     /*  208414 */ GIM_Reject,
     /*  208415 */ // Label 35: @208415
     /*  208415 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4124*/ GIMT_Encode4(211324),
     /*  208426 */ /*GILLT_s32*//*Label 4122*/ GIMT_Encode4(208434),
     /*  208430 */ /*GILLT_s64*//*Label 4123*/ GIMT_Encode4(209674),
     /*  208434 */ // Label 4122: @208434
     /*  208434 */ GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209673),
     /*  208439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208442 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208483), // Rule ID 502 //
     /*  208447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208464 */     // MIs[0] rs1
     /*  208464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208476 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208481 */     GIR_RootConstrainSelectedInstOperands,
     /*  208482 */     // GIR_Coverage, 502,
     /*  208482 */     GIR_Done,
     /*  208483 */   // Label 4126: @208483
     /*  208483 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208524), // Rule ID 504 //
     /*  208488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208505 */     // MIs[0] rs1
     /*  208505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208517 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  208522 */     GIR_RootConstrainSelectedInstOperands,
     /*  208523 */     // GIR_Coverage, 504,
     /*  208523 */     GIR_Done,
     /*  208524 */   // Label 4127: @208524
     /*  208524 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208565), // Rule ID 506 //
     /*  208529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208546 */     // MIs[0] rs1
     /*  208546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208558 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  208563 */     GIR_RootConstrainSelectedInstOperands,
     /*  208564 */     // GIR_Coverage, 506,
     /*  208564 */     GIR_Done,
     /*  208565 */   // Label 4128: @208565
     /*  208565 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208606), // Rule ID 508 //
     /*  208570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208587 */     // MIs[0] rs1
     /*  208587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208599 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  208604 */     GIR_RootConstrainSelectedInstOperands,
     /*  208605 */     // GIR_Coverage, 508,
     /*  208605 */     GIR_Done,
     /*  208606 */   // Label 4129: @208606
     /*  208606 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(208647), // Rule ID 510 //
     /*  208611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  208614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208628 */     // MIs[0] rs1
     /*  208628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208640 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  208645 */     GIR_RootConstrainSelectedInstOperands,
     /*  208646 */     // GIR_Coverage, 510,
     /*  208646 */     GIR_Done,
     /*  208647 */   // Label 4130: @208647
     /*  208647 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(208688), // Rule ID 512 //
     /*  208652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208669 */     // MIs[0] rs1
     /*  208669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208681 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208686 */     GIR_RootConstrainSelectedInstOperands,
     /*  208687 */     // GIR_Coverage, 512,
     /*  208687 */     GIR_Done,
     /*  208688 */   // Label 4131: @208688
     /*  208688 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(208729), // Rule ID 514 //
     /*  208693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208710 */     // MIs[0] rs1
     /*  208710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208722 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208727 */     GIR_RootConstrainSelectedInstOperands,
     /*  208728 */     // GIR_Coverage, 514,
     /*  208728 */     GIR_Done,
     /*  208729 */   // Label 4132: @208729
     /*  208729 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(208770), // Rule ID 516 //
     /*  208734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208751 */     // MIs[0] rs1
     /*  208751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208763 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208768 */     GIR_RootConstrainSelectedInstOperands,
     /*  208769 */     // GIR_Coverage, 516,
     /*  208769 */     GIR_Done,
     /*  208770 */   // Label 4133: @208770
     /*  208770 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(208811), // Rule ID 518 //
     /*  208775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208792 */     // MIs[0] rs1
     /*  208792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208804 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208809 */     GIR_RootConstrainSelectedInstOperands,
     /*  208810 */     // GIR_Coverage, 518,
     /*  208810 */     GIR_Done,
     /*  208811 */   // Label 4134: @208811
     /*  208811 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(208852), // Rule ID 520 //
     /*  208816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  208819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  208826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  208829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208833 */     // MIs[0] rs1
     /*  208833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208845 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  208850 */     GIR_RootConstrainSelectedInstOperands,
     /*  208851 */     // GIR_Coverage, 520,
     /*  208851 */     GIR_Done,
     /*  208852 */   // Label 4135: @208852
     /*  208852 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(208893), // Rule ID 850 //
     /*  208857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  208870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208874 */     // MIs[0] rs1
     /*  208874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208886 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  208891 */     GIR_RootConstrainSelectedInstOperands,
     /*  208892 */     // GIR_Coverage, 850,
     /*  208892 */     GIR_Done,
     /*  208893 */   // Label 4136: @208893
     /*  208893 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(208934), // Rule ID 852 //
     /*  208898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  208911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208915 */     // MIs[0] rs1
     /*  208915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208927 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  208932 */     GIR_RootConstrainSelectedInstOperands,
     /*  208933 */     // GIR_Coverage, 852,
     /*  208933 */     GIR_Done,
     /*  208934 */   // Label 4137: @208934
     /*  208934 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(208975), // Rule ID 854 //
     /*  208939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  208952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208956 */     // MIs[0] rs1
     /*  208956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  208960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208968 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  208968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  208973 */     GIR_RootConstrainSelectedInstOperands,
     /*  208974 */     // GIR_Coverage, 854,
     /*  208974 */     GIR_Done,
     /*  208975 */   // Label 4138: @208975
     /*  208975 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209016), // Rule ID 856 //
     /*  208980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  208983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  208990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  208993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208997 */     // MIs[0] rs1
     /*  208997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209009 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  209014 */     GIR_RootConstrainSelectedInstOperands,
     /*  209015 */     // GIR_Coverage, 856,
     /*  209015 */     GIR_Done,
     /*  209016 */   // Label 4139: @209016
     /*  209016 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209057), // Rule ID 858 //
     /*  209021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209038 */     // MIs[0] rs1
     /*  209038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209050 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  209055 */     GIR_RootConstrainSelectedInstOperands,
     /*  209056 */     // GIR_Coverage, 858,
     /*  209056 */     GIR_Done,
     /*  209057 */   // Label 4140: @209057
     /*  209057 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209098), // Rule ID 860 //
     /*  209062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209079 */     // MIs[0] rs1
     /*  209079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209091 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209096 */     GIR_RootConstrainSelectedInstOperands,
     /*  209097 */     // GIR_Coverage, 860,
     /*  209097 */     GIR_Done,
     /*  209098 */   // Label 4141: @209098
     /*  209098 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209139), // Rule ID 862 //
     /*  209103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209120 */     // MIs[0] rs1
     /*  209120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209132 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209137 */     GIR_RootConstrainSelectedInstOperands,
     /*  209138 */     // GIR_Coverage, 862,
     /*  209138 */     GIR_Done,
     /*  209139 */   // Label 4142: @209139
     /*  209139 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(209180), // Rule ID 864 //
     /*  209144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209161 */     // MIs[0] rs1
     /*  209161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209173 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209178 */     GIR_RootConstrainSelectedInstOperands,
     /*  209179 */     // GIR_Coverage, 864,
     /*  209179 */     GIR_Done,
     /*  209180 */   // Label 4143: @209180
     /*  209180 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(209221), // Rule ID 866 //
     /*  209185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209202 */     // MIs[0] rs1
     /*  209202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209214 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209219 */     GIR_RootConstrainSelectedInstOperands,
     /*  209220 */     // GIR_Coverage, 866,
     /*  209220 */     GIR_Done,
     /*  209221 */   // Label 4144: @209221
     /*  209221 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(209262), // Rule ID 868 //
     /*  209226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  209236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209243 */     // MIs[0] rs1
     /*  209243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209255 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  209260 */     GIR_RootConstrainSelectedInstOperands,
     /*  209261 */     // GIR_Coverage, 868,
     /*  209261 */     GIR_Done,
     /*  209262 */   // Label 4145: @209262
     /*  209262 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(209303), // Rule ID 1030 //
     /*  209267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209284 */     // MIs[0] rs1
     /*  209284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209296 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209301 */     GIR_RootConstrainSelectedInstOperands,
     /*  209302 */     // GIR_Coverage, 1030,
     /*  209302 */     GIR_Done,
     /*  209303 */   // Label 4146: @209303
     /*  209303 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(209344), // Rule ID 1032 //
     /*  209308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209325 */     // MIs[0] rs1
     /*  209325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209337 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  209342 */     GIR_RootConstrainSelectedInstOperands,
     /*  209343 */     // GIR_Coverage, 1032,
     /*  209343 */     GIR_Done,
     /*  209344 */   // Label 4147: @209344
     /*  209344 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(209385), // Rule ID 1034 //
     /*  209349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209366 */     // MIs[0] rs1
     /*  209366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209378 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  209383 */     GIR_RootConstrainSelectedInstOperands,
     /*  209384 */     // GIR_Coverage, 1034,
     /*  209384 */     GIR_Done,
     /*  209385 */   // Label 4148: @209385
     /*  209385 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(209426), // Rule ID 1036 //
     /*  209390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209407 */     // MIs[0] rs1
     /*  209407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209419 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  209424 */     GIR_RootConstrainSelectedInstOperands,
     /*  209425 */     // GIR_Coverage, 1036,
     /*  209425 */     GIR_Done,
     /*  209426 */   // Label 4149: @209426
     /*  209426 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(209467), // Rule ID 1038 //
     /*  209431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  209434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209448 */     // MIs[0] rs1
     /*  209448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209460 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  209465 */     GIR_RootConstrainSelectedInstOperands,
     /*  209466 */     // GIR_Coverage, 1038,
     /*  209466 */     GIR_Done,
     /*  209467 */   // Label 4150: @209467
     /*  209467 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(209508), // Rule ID 1040 //
     /*  209472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209489 */     // MIs[0] rs1
     /*  209489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209501 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209506 */     GIR_RootConstrainSelectedInstOperands,
     /*  209507 */     // GIR_Coverage, 1040,
     /*  209507 */     GIR_Done,
     /*  209508 */   // Label 4151: @209508
     /*  209508 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(209549), // Rule ID 1042 //
     /*  209513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209530 */     // MIs[0] rs1
     /*  209530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209542 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209547 */     GIR_RootConstrainSelectedInstOperands,
     /*  209548 */     // GIR_Coverage, 1042,
     /*  209548 */     GIR_Done,
     /*  209549 */   // Label 4152: @209549
     /*  209549 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(209590), // Rule ID 1044 //
     /*  209554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209571 */     // MIs[0] rs1
     /*  209571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209583 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209588 */     GIR_RootConstrainSelectedInstOperands,
     /*  209589 */     // GIR_Coverage, 1044,
     /*  209589 */     GIR_Done,
     /*  209590 */   // Label 4153: @209590
     /*  209590 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(209631), // Rule ID 1046 //
     /*  209595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209612 */     // MIs[0] rs1
     /*  209612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209624 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209629 */     GIR_RootConstrainSelectedInstOperands,
     /*  209630 */     // GIR_Coverage, 1046,
     /*  209630 */     GIR_Done,
     /*  209631 */   // Label 4154: @209631
     /*  209631 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(209672), // Rule ID 1048 //
     /*  209636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  209639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  209646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209653 */     // MIs[0] rs1
     /*  209653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  209657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209665 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  209665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  209670 */     GIR_RootConstrainSelectedInstOperands,
     /*  209671 */     // GIR_Coverage, 1048,
     /*  209671 */     GIR_Done,
     /*  209672 */   // Label 4155: @209672
     /*  209672 */   GIM_Reject,
     /*  209673 */ // Label 4125: @209673
     /*  209673 */ GIM_Reject,
     /*  209674 */ // Label 4123: @209674
     /*  209674 */ GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(211323),
     /*  209679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209682 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(209723), // Rule ID 501 //
     /*  209687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209704 */     // MIs[0] rs1
     /*  209704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209716 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209721 */     GIR_RootConstrainSelectedInstOperands,
     /*  209722 */     // GIR_Coverage, 501,
     /*  209722 */     GIR_Done,
     /*  209723 */   // Label 4157: @209723
     /*  209723 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(209764), // Rule ID 503 //
     /*  209728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209745 */     // MIs[0] rs1
     /*  209745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209757 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  209762 */     GIR_RootConstrainSelectedInstOperands,
     /*  209763 */     // GIR_Coverage, 503,
     /*  209763 */     GIR_Done,
     /*  209764 */   // Label 4158: @209764
     /*  209764 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(209805), // Rule ID 505 //
     /*  209769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209786 */     // MIs[0] rs1
     /*  209786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209798 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  209803 */     GIR_RootConstrainSelectedInstOperands,
     /*  209804 */     // GIR_Coverage, 505,
     /*  209804 */     GIR_Done,
     /*  209805 */   // Label 4159: @209805
     /*  209805 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(209846), // Rule ID 507 //
     /*  209810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  209823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209827 */     // MIs[0] rs1
     /*  209827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209839 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  209844 */     GIR_RootConstrainSelectedInstOperands,
     /*  209845 */     // GIR_Coverage, 507,
     /*  209845 */     GIR_Done,
     /*  209846 */   // Label 4160: @209846
     /*  209846 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(209887), // Rule ID 509 //
     /*  209851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  209854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  209864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209868 */     // MIs[0] rs1
     /*  209868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209880 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  209885 */     GIR_RootConstrainSelectedInstOperands,
     /*  209886 */     // GIR_Coverage, 509,
     /*  209886 */     GIR_Done,
     /*  209887 */   // Label 4161: @209887
     /*  209887 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(209928), // Rule ID 511 //
     /*  209892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  209905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209909 */     // MIs[0] rs1
     /*  209909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209921 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209926 */     GIR_RootConstrainSelectedInstOperands,
     /*  209927 */     // GIR_Coverage, 511,
     /*  209927 */     GIR_Done,
     /*  209928 */   // Label 4162: @209928
     /*  209928 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(209969), // Rule ID 513 //
     /*  209933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  209946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209950 */     // MIs[0] rs1
     /*  209950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209962 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  209962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  209967 */     GIR_RootConstrainSelectedInstOperands,
     /*  209968 */     // GIR_Coverage, 513,
     /*  209968 */     GIR_Done,
     /*  209969 */   // Label 4163: @209969
     /*  209969 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(210010), // Rule ID 515 //
     /*  209974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  209977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  209984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  209987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209991 */     // MIs[0] rs1
     /*  209991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  209995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210003 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210008 */     GIR_RootConstrainSelectedInstOperands,
     /*  210009 */     // GIR_Coverage, 515,
     /*  210009 */     GIR_Done,
     /*  210010 */   // Label 4164: @210010
     /*  210010 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(210051), // Rule ID 517 //
     /*  210015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  210018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  210025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210032 */     // MIs[0] rs1
     /*  210032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210044 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210049 */     GIR_RootConstrainSelectedInstOperands,
     /*  210050 */     // GIR_Coverage, 517,
     /*  210050 */     GIR_Done,
     /*  210051 */   // Label 4165: @210051
     /*  210051 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(210092), // Rule ID 519 //
     /*  210056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  210059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  210066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210073 */     // MIs[0] rs1
     /*  210073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210085 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  210090 */     GIR_RootConstrainSelectedInstOperands,
     /*  210091 */     // GIR_Coverage, 519,
     /*  210091 */     GIR_Done,
     /*  210092 */   // Label 4166: @210092
     /*  210092 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(210133), // Rule ID 601 //
     /*  210097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210114 */     // MIs[0] rs1
     /*  210114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210126 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210131 */     GIR_RootConstrainSelectedInstOperands,
     /*  210132 */     // GIR_Coverage, 601,
     /*  210132 */     GIR_Done,
     /*  210133 */   // Label 4167: @210133
     /*  210133 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(210174), // Rule ID 602 //
     /*  210138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210155 */     // MIs[0] rs1
     /*  210155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210167 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  210172 */     GIR_RootConstrainSelectedInstOperands,
     /*  210173 */     // GIR_Coverage, 602,
     /*  210173 */     GIR_Done,
     /*  210174 */   // Label 4168: @210174
     /*  210174 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(210215), // Rule ID 603 //
     /*  210179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210196 */     // MIs[0] rs1
     /*  210196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210208 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  210213 */     GIR_RootConstrainSelectedInstOperands,
     /*  210214 */     // GIR_Coverage, 603,
     /*  210214 */     GIR_Done,
     /*  210215 */   // Label 4169: @210215
     /*  210215 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(210256), // Rule ID 604 //
     /*  210220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210237 */     // MIs[0] rs1
     /*  210237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210249 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  210254 */     GIR_RootConstrainSelectedInstOperands,
     /*  210255 */     // GIR_Coverage, 604,
     /*  210255 */     GIR_Done,
     /*  210256 */   // Label 4170: @210256
     /*  210256 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(210297), // Rule ID 605 //
     /*  210261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  210264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210278 */     // MIs[0] rs1
     /*  210278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210290 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  210295 */     GIR_RootConstrainSelectedInstOperands,
     /*  210296 */     // GIR_Coverage, 605,
     /*  210296 */     GIR_Done,
     /*  210297 */   // Label 4171: @210297
     /*  210297 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(210338), // Rule ID 606 //
     /*  210302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210319 */     // MIs[0] rs1
     /*  210319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210331 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210336 */     GIR_RootConstrainSelectedInstOperands,
     /*  210337 */     // GIR_Coverage, 606,
     /*  210337 */     GIR_Done,
     /*  210338 */   // Label 4172: @210338
     /*  210338 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(210379), // Rule ID 607 //
     /*  210343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210360 */     // MIs[0] rs1
     /*  210360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210372 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210377 */     GIR_RootConstrainSelectedInstOperands,
     /*  210378 */     // GIR_Coverage, 607,
     /*  210378 */     GIR_Done,
     /*  210379 */   // Label 4173: @210379
     /*  210379 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(210420), // Rule ID 608 //
     /*  210384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210401 */     // MIs[0] rs1
     /*  210401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210413 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210418 */     GIR_RootConstrainSelectedInstOperands,
     /*  210419 */     // GIR_Coverage, 608,
     /*  210419 */     GIR_Done,
     /*  210420 */   // Label 4174: @210420
     /*  210420 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(210461), // Rule ID 609 //
     /*  210425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210442 */     // MIs[0] rs1
     /*  210442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210454 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210459 */     GIR_RootConstrainSelectedInstOperands,
     /*  210460 */     // GIR_Coverage, 609,
     /*  210460 */     GIR_Done,
     /*  210461 */   // Label 4175: @210461
     /*  210461 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(210502), // Rule ID 610 //
     /*  210466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  210469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  210476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210483 */     // MIs[0] rs1
     /*  210483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210495 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  210500 */     GIR_RootConstrainSelectedInstOperands,
     /*  210501 */     // GIR_Coverage, 610,
     /*  210501 */     GIR_Done,
     /*  210502 */   // Label 4176: @210502
     /*  210502 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(210543), // Rule ID 849 //
     /*  210507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210524 */     // MIs[0] rs1
     /*  210524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210536 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210541 */     GIR_RootConstrainSelectedInstOperands,
     /*  210542 */     // GIR_Coverage, 849,
     /*  210542 */     GIR_Done,
     /*  210543 */   // Label 4177: @210543
     /*  210543 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(210584), // Rule ID 851 //
     /*  210548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210565 */     // MIs[0] rs1
     /*  210565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210577 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  210582 */     GIR_RootConstrainSelectedInstOperands,
     /*  210583 */     // GIR_Coverage, 851,
     /*  210583 */     GIR_Done,
     /*  210584 */   // Label 4178: @210584
     /*  210584 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(210625), // Rule ID 853 //
     /*  210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210606 */     // MIs[0] rs1
     /*  210606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210618 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  210623 */     GIR_RootConstrainSelectedInstOperands,
     /*  210624 */     // GIR_Coverage, 853,
     /*  210624 */     GIR_Done,
     /*  210625 */   // Label 4179: @210625
     /*  210625 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(210666), // Rule ID 855 //
     /*  210630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210647 */     // MIs[0] rs1
     /*  210647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210659 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  210664 */     GIR_RootConstrainSelectedInstOperands,
     /*  210665 */     // GIR_Coverage, 855,
     /*  210665 */     GIR_Done,
     /*  210666 */   // Label 4180: @210666
     /*  210666 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(210707), // Rule ID 857 //
     /*  210671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210688 */     // MIs[0] rs1
     /*  210688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210700 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  210705 */     GIR_RootConstrainSelectedInstOperands,
     /*  210706 */     // GIR_Coverage, 857,
     /*  210706 */     GIR_Done,
     /*  210707 */   // Label 4181: @210707
     /*  210707 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(210748), // Rule ID 859 //
     /*  210712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210729 */     // MIs[0] rs1
     /*  210729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210741 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210746 */     GIR_RootConstrainSelectedInstOperands,
     /*  210747 */     // GIR_Coverage, 859,
     /*  210747 */     GIR_Done,
     /*  210748 */   // Label 4182: @210748
     /*  210748 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(210789), // Rule ID 861 //
     /*  210753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210770 */     // MIs[0] rs1
     /*  210770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210782 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210787 */     GIR_RootConstrainSelectedInstOperands,
     /*  210788 */     // GIR_Coverage, 861,
     /*  210788 */     GIR_Done,
     /*  210789 */   // Label 4183: @210789
     /*  210789 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(210830), // Rule ID 863 //
     /*  210794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  210807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210811 */     // MIs[0] rs1
     /*  210811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210823 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210828 */     GIR_RootConstrainSelectedInstOperands,
     /*  210829 */     // GIR_Coverage, 863,
     /*  210829 */     GIR_Done,
     /*  210830 */   // Label 4184: @210830
     /*  210830 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(210871), // Rule ID 865 //
     /*  210835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  210848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210852 */     // MIs[0] rs1
     /*  210852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210864 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210869 */     GIR_RootConstrainSelectedInstOperands,
     /*  210870 */     // GIR_Coverage, 865,
     /*  210870 */     GIR_Done,
     /*  210871 */   // Label 4185: @210871
     /*  210871 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(210912), // Rule ID 867 //
     /*  210876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  210879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  210886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  210889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210893 */     // MIs[0] rs1
     /*  210893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210905 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  210910 */     GIR_RootConstrainSelectedInstOperands,
     /*  210911 */     // GIR_Coverage, 867,
     /*  210911 */     GIR_Done,
     /*  210912 */   // Label 4186: @210912
     /*  210912 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(210953), // Rule ID 1029 //
     /*  210917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  210927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210934 */     // MIs[0] rs1
     /*  210934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210946 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  210951 */     GIR_RootConstrainSelectedInstOperands,
     /*  210952 */     // GIR_Coverage, 1029,
     /*  210952 */     GIR_Done,
     /*  210953 */   // Label 4187: @210953
     /*  210953 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(210994), // Rule ID 1031 //
     /*  210958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  210961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  210968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  210971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210975 */     // MIs[0] rs1
     /*  210975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  210979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210987 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  210987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  210992 */     GIR_RootConstrainSelectedInstOperands,
     /*  210993 */     // GIR_Coverage, 1031,
     /*  210993 */     GIR_Done,
     /*  210994 */   // Label 4188: @210994
     /*  210994 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(211035), // Rule ID 1033 //
     /*  210999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  211012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211016 */     // MIs[0] rs1
     /*  211016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211028 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  211033 */     GIR_RootConstrainSelectedInstOperands,
     /*  211034 */     // GIR_Coverage, 1033,
     /*  211034 */     GIR_Done,
     /*  211035 */   // Label 4189: @211035
     /*  211035 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(211076), // Rule ID 1035 //
     /*  211040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  211053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211057 */     // MIs[0] rs1
     /*  211057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211069 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  211074 */     GIR_RootConstrainSelectedInstOperands,
     /*  211075 */     // GIR_Coverage, 1035,
     /*  211075 */     GIR_Done,
     /*  211076 */   // Label 4190: @211076
     /*  211076 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(211117), // Rule ID 1037 //
     /*  211081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  211084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  211094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211098 */     // MIs[0] rs1
     /*  211098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211110 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  211115 */     GIR_RootConstrainSelectedInstOperands,
     /*  211116 */     // GIR_Coverage, 1037,
     /*  211116 */     GIR_Done,
     /*  211117 */   // Label 4191: @211117
     /*  211117 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(211158), // Rule ID 1039 //
     /*  211122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  211135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211139 */     // MIs[0] rs1
     /*  211139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211151 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211156 */     GIR_RootConstrainSelectedInstOperands,
     /*  211157 */     // GIR_Coverage, 1039,
     /*  211157 */     GIR_Done,
     /*  211158 */   // Label 4192: @211158
     /*  211158 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(211199), // Rule ID 1041 //
     /*  211163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  211176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211180 */     // MIs[0] rs1
     /*  211180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211192 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211197 */     GIR_RootConstrainSelectedInstOperands,
     /*  211198 */     // GIR_Coverage, 1041,
     /*  211198 */     GIR_Done,
     /*  211199 */   // Label 4193: @211199
     /*  211199 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(211240), // Rule ID 1043 //
     /*  211204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  211217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211221 */     // MIs[0] rs1
     /*  211221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211233 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211238 */     GIR_RootConstrainSelectedInstOperands,
     /*  211239 */     // GIR_Coverage, 1043,
     /*  211239 */     GIR_Done,
     /*  211240 */   // Label 4194: @211240
     /*  211240 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(211281), // Rule ID 1045 //
     /*  211245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  211258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211262 */     // MIs[0] rs1
     /*  211262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211274 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211279 */     GIR_RootConstrainSelectedInstOperands,
     /*  211280 */     // GIR_Coverage, 1045,
     /*  211280 */     GIR_Done,
     /*  211281 */   // Label 4195: @211281
     /*  211281 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(211322), // Rule ID 1047 //
     /*  211286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  211289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  211296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  211299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211303 */     // MIs[0] rs1
     /*  211303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  211307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  211315 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  211315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  211320 */     GIR_RootConstrainSelectedInstOperands,
     /*  211321 */     // GIR_Coverage, 1047,
     /*  211321 */     GIR_Done,
     /*  211322 */   // Label 4196: @211322
     /*  211322 */   GIM_Reject,
     /*  211323 */ // Label 4156: @211323
     /*  211323 */ GIM_Reject,
     /*  211324 */ // Label 4124: @211324
     /*  211324 */ GIM_Reject,
     /*  211325 */ // Label 36: @211325
     /*  211325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4199*/ GIMT_Encode4(211542),
     /*  211336 */ /*GILLT_s32*//*Label 4197*/ GIMT_Encode4(211344),
     /*  211340 */ /*GILLT_s64*//*Label 4198*/ GIMT_Encode4(211443),
     /*  211344 */ // Label 4197: @211344
     /*  211344 */ GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(211370), // Rule ID 245 //
     /*  211349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211352 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  211356 */   // MIs[0] Operand 1
     /*  211356 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211359 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  211359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  211365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211368 */   GIR_RootConstrainSelectedInstOperands,
     /*  211369 */   // GIR_Coverage, 245,
     /*  211369 */   GIR_EraseRootFromParent_Done,
     /*  211370 */ // Label 4200: @211370
     /*  211370 */ GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(211396), // Rule ID 247 //
     /*  211375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211378 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  211382 */   // MIs[0] Operand 1
     /*  211382 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211385 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  211385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  211394 */   GIR_RootConstrainSelectedInstOperands,
     /*  211395 */   // GIR_Coverage, 247,
     /*  211395 */   GIR_EraseRootFromParent_Done,
     /*  211396 */ // Label 4201: @211396
     /*  211396 */ GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(211416), // Rule ID 249 //
     /*  211401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211404 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  211408 */   // MIs[0] Operand 1
     /*  211408 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211411 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  211411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  211414 */   GIR_RootConstrainSelectedInstOperands,
     /*  211415 */   // GIR_Coverage, 249,
     /*  211415 */   GIR_EraseRootFromParent_Done,
     /*  211416 */ // Label 4202: @211416
     /*  211416 */ GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(211442), // Rule ID 251 //
     /*  211421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211424 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  211428 */   // MIs[0] Operand 1
     /*  211428 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211431 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  211431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211440 */   GIR_RootConstrainSelectedInstOperands,
     /*  211441 */   // GIR_Coverage, 251,
     /*  211441 */   GIR_EraseRootFromParent_Done,
     /*  211442 */ // Label 4203: @211442
     /*  211442 */ GIM_Reject,
     /*  211443 */ // Label 4198: @211443
     /*  211443 */ GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(211469), // Rule ID 244 //
     /*  211448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211451 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  211455 */   // MIs[0] Operand 1
     /*  211455 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211458 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  211458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  211464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211467 */   GIR_RootConstrainSelectedInstOperands,
     /*  211468 */   // GIR_Coverage, 244,
     /*  211468 */   GIR_EraseRootFromParent_Done,
     /*  211469 */ // Label 4204: @211469
     /*  211469 */ GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(211495), // Rule ID 246 //
     /*  211474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211477 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  211481 */   // MIs[0] Operand 1
     /*  211481 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211484 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  211484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  211493 */   GIR_RootConstrainSelectedInstOperands,
     /*  211494 */   // GIR_Coverage, 246,
     /*  211494 */   GIR_EraseRootFromParent_Done,
     /*  211495 */ // Label 4205: @211495
     /*  211495 */ GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(211515), // Rule ID 248 //
     /*  211500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211503 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  211507 */   // MIs[0] Operand 1
     /*  211507 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211510 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  211510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  211513 */   GIR_RootConstrainSelectedInstOperands,
     /*  211514 */   // GIR_Coverage, 248,
     /*  211514 */   GIR_EraseRootFromParent_Done,
     /*  211515 */ // Label 4206: @211515
     /*  211515 */ GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(211541), // Rule ID 250 //
     /*  211520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211523 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  211527 */   // MIs[0] Operand 1
     /*  211527 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  211530 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  211530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  211533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  211539 */   GIR_RootConstrainSelectedInstOperands,
     /*  211540 */   // GIR_Coverage, 250,
     /*  211540 */   GIR_EraseRootFromParent_Done,
     /*  211541 */ // Label 4207: @211541
     /*  211541 */ GIM_Reject,
     /*  211542 */ // Label 4199: @211542
     /*  211542 */ GIM_Reject,
     /*  211543 */ // Label 37: @211543
     /*  211543 */ GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213028),
     /*  211548 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  211551 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(211596), // Rule ID 2706 //
     /*  211556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211581 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  211584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211594 */     GIR_RootConstrainSelectedInstOperands,
     /*  211595 */     // GIR_Coverage, 2706,
     /*  211595 */     GIR_EraseRootFromParent_Done,
     /*  211596 */   // Label 4209: @211596
     /*  211596 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(211641), // Rule ID 2707 //
     /*  211601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  211629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211639 */     GIR_RootConstrainSelectedInstOperands,
     /*  211640 */     // GIR_Coverage, 2707,
     /*  211640 */     GIR_EraseRootFromParent_Done,
     /*  211641 */   // Label 4210: @211641
     /*  211641 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(211686), // Rule ID 23256 //
     /*  211646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211671 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  211674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211684 */     GIR_RootConstrainSelectedInstOperands,
     /*  211685 */     // GIR_Coverage, 23256,
     /*  211685 */     GIR_EraseRootFromParent_Done,
     /*  211686 */   // Label 4211: @211686
     /*  211686 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(211731), // Rule ID 23257 //
     /*  211691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211716 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  211719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211729 */     GIR_RootConstrainSelectedInstOperands,
     /*  211730 */     // GIR_Coverage, 23257,
     /*  211730 */     GIR_EraseRootFromParent_Done,
     /*  211731 */   // Label 4212: @211731
     /*  211731 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(211776), // Rule ID 23258 //
     /*  211736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211761 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  211764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211774 */     GIR_RootConstrainSelectedInstOperands,
     /*  211775 */     // GIR_Coverage, 23258,
     /*  211775 */     GIR_EraseRootFromParent_Done,
     /*  211776 */   // Label 4213: @211776
     /*  211776 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(211821), // Rule ID 23259 //
     /*  211781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  211809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211819 */     GIR_RootConstrainSelectedInstOperands,
     /*  211820 */     // GIR_Coverage, 23259,
     /*  211820 */     GIR_EraseRootFromParent_Done,
     /*  211821 */   // Label 4214: @211821
     /*  211821 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(211866), // Rule ID 23260 //
     /*  211826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  211854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211864 */     GIR_RootConstrainSelectedInstOperands,
     /*  211865 */     // GIR_Coverage, 23260,
     /*  211865 */     GIR_EraseRootFromParent_Done,
     /*  211866 */   // Label 4215: @211866
     /*  211866 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(211911), // Rule ID 23261 //
     /*  211871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  211899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211909 */     GIR_RootConstrainSelectedInstOperands,
     /*  211910 */     // GIR_Coverage, 23261,
     /*  211910 */     GIR_EraseRootFromParent_Done,
     /*  211911 */   // Label 4216: @211911
     /*  211911 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(211956), // Rule ID 23262 //
     /*  211916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  211930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  211944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211954 */     GIR_RootConstrainSelectedInstOperands,
     /*  211955 */     // GIR_Coverage, 23262,
     /*  211955 */     GIR_EraseRootFromParent_Done,
     /*  211956 */   // Label 4217: @211956
     /*  211956 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(212001), // Rule ID 23263 //
     /*  211961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  211969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  211975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  211989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211999 */     GIR_RootConstrainSelectedInstOperands,
     /*  212000 */     // GIR_Coverage, 23263,
     /*  212000 */     GIR_EraseRootFromParent_Done,
     /*  212001 */   // Label 4218: @212001
     /*  212001 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(212046), // Rule ID 23264 //
     /*  212006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212031 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  212034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212044 */     GIR_RootConstrainSelectedInstOperands,
     /*  212045 */     // GIR_Coverage, 23264,
     /*  212045 */     GIR_EraseRootFromParent_Done,
     /*  212046 */   // Label 4219: @212046
     /*  212046 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(212091), // Rule ID 23265 //
     /*  212051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212076 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  212079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212089 */     GIR_RootConstrainSelectedInstOperands,
     /*  212090 */     // GIR_Coverage, 23265,
     /*  212090 */     GIR_EraseRootFromParent_Done,
     /*  212091 */   // Label 4220: @212091
     /*  212091 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(212136), // Rule ID 23266 //
     /*  212096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212121 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  212124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212134 */     GIR_RootConstrainSelectedInstOperands,
     /*  212135 */     // GIR_Coverage, 23266,
     /*  212135 */     GIR_EraseRootFromParent_Done,
     /*  212136 */   // Label 4221: @212136
     /*  212136 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(212181), // Rule ID 23267 //
     /*  212141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  212149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212166 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11357:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  212169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212179 */     GIR_RootConstrainSelectedInstOperands,
     /*  212180 */     // GIR_Coverage, 23267,
     /*  212180 */     GIR_EraseRootFromParent_Done,
     /*  212181 */   // Label 4222: @212181
     /*  212181 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(212226), // Rule ID 23268 //
     /*  212186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  212214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212224 */     GIR_RootConstrainSelectedInstOperands,
     /*  212225 */     // GIR_Coverage, 23268,
     /*  212225 */     GIR_EraseRootFromParent_Done,
     /*  212226 */   // Label 4223: @212226
     /*  212226 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(212271), // Rule ID 23269 //
     /*  212231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  212259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212269 */     GIR_RootConstrainSelectedInstOperands,
     /*  212270 */     // GIR_Coverage, 23269,
     /*  212270 */     GIR_EraseRootFromParent_Done,
     /*  212271 */   // Label 4224: @212271
     /*  212271 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(212316), // Rule ID 23270 //
     /*  212276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212301 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  212304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212314 */     GIR_RootConstrainSelectedInstOperands,
     /*  212315 */     // GIR_Coverage, 23270,
     /*  212315 */     GIR_EraseRootFromParent_Done,
     /*  212316 */   // Label 4225: @212316
     /*  212316 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(212361), // Rule ID 23271 //
     /*  212321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  212349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212359 */     GIR_RootConstrainSelectedInstOperands,
     /*  212360 */     // GIR_Coverage, 23271,
     /*  212360 */     GIR_EraseRootFromParent_Done,
     /*  212361 */   // Label 4226: @212361
     /*  212361 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(212406), // Rule ID 23272 //
     /*  212366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212391 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  212394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212404 */     GIR_RootConstrainSelectedInstOperands,
     /*  212405 */     // GIR_Coverage, 23272,
     /*  212405 */     GIR_EraseRootFromParent_Done,
     /*  212406 */   // Label 4227: @212406
     /*  212406 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(212451), // Rule ID 23273 //
     /*  212411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  212439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212449 */     GIR_RootConstrainSelectedInstOperands,
     /*  212450 */     // GIR_Coverage, 23273,
     /*  212450 */     GIR_EraseRootFromParent_Done,
     /*  212451 */   // Label 4228: @212451
     /*  212451 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(212496), // Rule ID 23274 //
     /*  212456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  212484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212494 */     GIR_RootConstrainSelectedInstOperands,
     /*  212495 */     // GIR_Coverage, 23274,
     /*  212495 */     GIR_EraseRootFromParent_Done,
     /*  212496 */   // Label 4229: @212496
     /*  212496 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(212541), // Rule ID 23275 //
     /*  212501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  212529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212539 */     GIR_RootConstrainSelectedInstOperands,
     /*  212540 */     // GIR_Coverage, 23275,
     /*  212540 */     GIR_EraseRootFromParent_Done,
     /*  212541 */   // Label 4230: @212541
     /*  212541 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(212586), // Rule ID 23276 //
     /*  212546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212571 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  212574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212584 */     GIR_RootConstrainSelectedInstOperands,
     /*  212585 */     // GIR_Coverage, 23276,
     /*  212585 */     GIR_EraseRootFromParent_Done,
     /*  212586 */   // Label 4231: @212586
     /*  212586 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(212631), // Rule ID 23277 //
     /*  212591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  212619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212629 */     GIR_RootConstrainSelectedInstOperands,
     /*  212630 */     // GIR_Coverage, 23277,
     /*  212630 */     GIR_EraseRootFromParent_Done,
     /*  212631 */   // Label 4232: @212631
     /*  212631 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(212676), // Rule ID 23278 //
     /*  212636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212661 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  212664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212674 */     GIR_RootConstrainSelectedInstOperands,
     /*  212675 */     // GIR_Coverage, 23278,
     /*  212675 */     GIR_EraseRootFromParent_Done,
     /*  212676 */   // Label 4233: @212676
     /*  212676 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(212721), // Rule ID 23279 //
     /*  212681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  212709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212719 */     GIR_RootConstrainSelectedInstOperands,
     /*  212720 */     // GIR_Coverage, 23279,
     /*  212720 */     GIR_EraseRootFromParent_Done,
     /*  212721 */   // Label 4234: @212721
     /*  212721 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(212766), // Rule ID 23280 //
     /*  212726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212751 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  212754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212764 */     GIR_RootConstrainSelectedInstOperands,
     /*  212765 */     // GIR_Coverage, 23280,
     /*  212765 */     GIR_EraseRootFromParent_Done,
     /*  212766 */   // Label 4235: @212766
     /*  212766 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(212811), // Rule ID 23281 //
     /*  212771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  212779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  212785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212796 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  212799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212809 */     GIR_RootConstrainSelectedInstOperands,
     /*  212810 */     // GIR_Coverage, 23281,
     /*  212810 */     GIR_EraseRootFromParent_Done,
     /*  212811 */   // Label 4236: @212811
     /*  212811 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(212847), // Rule ID 2643 //
     /*  212816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  212819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  212824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212838 */     // (intrinsic_wo_chain:{ *:[i64] } 10916:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  212841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212845 */     GIR_RootConstrainSelectedInstOperands,
     /*  212846 */     // GIR_Coverage, 2643,
     /*  212846 */     GIR_EraseRootFromParent_Done,
     /*  212847 */   // Label 4237: @212847
     /*  212847 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(212883), // Rule ID 2664 //
     /*  212852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  212860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212874 */     // (intrinsic_wo_chain:{ *:[i64] } 11052:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  212877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212881 */     GIR_RootConstrainSelectedInstOperands,
     /*  212882 */     // GIR_Coverage, 2664,
     /*  212882 */     GIR_EraseRootFromParent_Done,
     /*  212883 */   // Label 4238: @212883
     /*  212883 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(212919), // Rule ID 2665 //
     /*  212888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  212896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212910 */     // (intrinsic_wo_chain:{ *:[i64] } 11055:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  212913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212917 */     GIR_RootConstrainSelectedInstOperands,
     /*  212918 */     // GIR_Coverage, 2665,
     /*  212918 */     GIR_EraseRootFromParent_Done,
     /*  212919 */   // Label 4239: @212919
     /*  212919 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(212955), // Rule ID 2666 //
     /*  212924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  212932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212946 */     // (intrinsic_wo_chain:{ *:[i64] } 11058:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  212949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212953 */     GIR_RootConstrainSelectedInstOperands,
     /*  212954 */     // GIR_Coverage, 2666,
     /*  212954 */     GIR_EraseRootFromParent_Done,
     /*  212955 */   // Label 4240: @212955
     /*  212955 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(212991), // Rule ID 2667 //
     /*  212960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  212963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  212968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  212971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  212974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  212982 */     // (intrinsic_wo_chain:{ *:[i64] } 11060:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  212982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  212985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  212989 */     GIR_RootConstrainSelectedInstOperands,
     /*  212990 */     // GIR_Coverage, 2667,
     /*  212990 */     GIR_EraseRootFromParent_Done,
     /*  212991 */   // Label 4241: @212991
     /*  212991 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(213027), // Rule ID 64434 //
     /*  212996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  212999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  213004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  213010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213018 */     // (intrinsic_wo_chain:{ *:[i32] } 10936:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  213018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  213021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213025 */     GIR_RootConstrainSelectedInstOperands,
     /*  213026 */     // GIR_Coverage, 64434,
     /*  213026 */     GIR_EraseRootFromParent_Done,
     /*  213027 */   // Label 4242: @213027
     /*  213027 */   GIM_Reject,
     /*  213028 */ // Label 4208: @213028
     /*  213028 */ GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(220316),
     /*  213033 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  213036 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(213090), // Rule ID 2676 //
     /*  213041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213073 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  213076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213088 */     GIR_RootConstrainSelectedInstOperands,
     /*  213089 */     // GIR_Coverage, 2676,
     /*  213089 */     GIR_EraseRootFromParent_Done,
     /*  213090 */   // Label 4244: @213090
     /*  213090 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(213144), // Rule ID 2677 //
     /*  213095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213127 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  213130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213142 */     GIR_RootConstrainSelectedInstOperands,
     /*  213143 */     // GIR_Coverage, 2677,
     /*  213143 */     GIR_EraseRootFromParent_Done,
     /*  213144 */   // Label 4245: @213144
     /*  213144 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(213198), // Rule ID 2682 //
     /*  213149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  213157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  213160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213181 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  213184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213196 */     GIR_RootConstrainSelectedInstOperands,
     /*  213197 */     // GIR_Coverage, 2682,
     /*  213197 */     GIR_EraseRootFromParent_Done,
     /*  213198 */   // Label 4246: @213198
     /*  213198 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(213252), // Rule ID 2683 //
     /*  213203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  213211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  213214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  213217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  213238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213250 */     GIR_RootConstrainSelectedInstOperands,
     /*  213251 */     // GIR_Coverage, 2683,
     /*  213251 */     GIR_EraseRootFromParent_Done,
     /*  213252 */   // Label 4247: @213252
     /*  213252 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(213309), // Rule ID 2702 //
     /*  213257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  213268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  213271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213289 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  213292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213307 */     GIR_RootConstrainSelectedInstOperands,
     /*  213308 */     // GIR_Coverage, 2702,
     /*  213308 */     GIR_EraseRootFromParent_Done,
     /*  213309 */   // Label 4248: @213309
     /*  213309 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(213366), // Rule ID 2703 //
     /*  213314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  213325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  213328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  213349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213364 */     GIR_RootConstrainSelectedInstOperands,
     /*  213365 */     // GIR_Coverage, 2703,
     /*  213365 */     GIR_EraseRootFromParent_Done,
     /*  213366 */   // Label 4249: @213366
     /*  213366 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(213420), // Rule ID 23282 //
     /*  213371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  213385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213403 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  213406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213418 */     GIR_RootConstrainSelectedInstOperands,
     /*  213419 */     // GIR_Coverage, 23282,
     /*  213419 */     GIR_EraseRootFromParent_Done,
     /*  213420 */   // Label 4250: @213420
     /*  213420 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(213474), // Rule ID 23283 //
     /*  213425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  213439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213457 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  213460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213472 */     GIR_RootConstrainSelectedInstOperands,
     /*  213473 */     // GIR_Coverage, 23283,
     /*  213473 */     GIR_EraseRootFromParent_Done,
     /*  213474 */   // Label 4251: @213474
     /*  213474 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(213528), // Rule ID 23286 //
     /*  213479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213511 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  213514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213526 */     GIR_RootConstrainSelectedInstOperands,
     /*  213527 */     // GIR_Coverage, 23286,
     /*  213527 */     GIR_EraseRootFromParent_Done,
     /*  213528 */   // Label 4252: @213528
     /*  213528 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(213582), // Rule ID 23287 //
     /*  213533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  213547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213565 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  213568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213580 */     GIR_RootConstrainSelectedInstOperands,
     /*  213581 */     // GIR_Coverage, 23287,
     /*  213581 */     GIR_EraseRootFromParent_Done,
     /*  213582 */   // Label 4253: @213582
     /*  213582 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(213636), // Rule ID 23290 //
     /*  213587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213619 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  213622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213634 */     GIR_RootConstrainSelectedInstOperands,
     /*  213635 */     // GIR_Coverage, 23290,
     /*  213635 */     GIR_EraseRootFromParent_Done,
     /*  213636 */   // Label 4254: @213636
     /*  213636 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(213690), // Rule ID 23291 //
     /*  213641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  213655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213673 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  213676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213688 */     GIR_RootConstrainSelectedInstOperands,
     /*  213689 */     // GIR_Coverage, 23291,
     /*  213689 */     GIR_EraseRootFromParent_Done,
     /*  213690 */   // Label 4255: @213690
     /*  213690 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(213744), // Rule ID 23294 //
     /*  213695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213727 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  213730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213742 */     GIR_RootConstrainSelectedInstOperands,
     /*  213743 */     // GIR_Coverage, 23294,
     /*  213743 */     GIR_EraseRootFromParent_Done,
     /*  213744 */   // Label 4256: @213744
     /*  213744 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(213798), // Rule ID 23295 //
     /*  213749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  213763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213781 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  213784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213796 */     GIR_RootConstrainSelectedInstOperands,
     /*  213797 */     // GIR_Coverage, 23295,
     /*  213797 */     GIR_EraseRootFromParent_Done,
     /*  213798 */   // Label 4257: @213798
     /*  213798 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(213852), // Rule ID 23298 //
     /*  213803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213835 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  213838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213850 */     GIR_RootConstrainSelectedInstOperands,
     /*  213851 */     // GIR_Coverage, 23298,
     /*  213851 */     GIR_EraseRootFromParent_Done,
     /*  213852 */   // Label 4258: @213852
     /*  213852 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(213906), // Rule ID 23299 //
     /*  213857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  213871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213889 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  213892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213904 */     GIR_RootConstrainSelectedInstOperands,
     /*  213905 */     // GIR_Coverage, 23299,
     /*  213905 */     GIR_EraseRootFromParent_Done,
     /*  213906 */   // Label 4259: @213906
     /*  213906 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(213960), // Rule ID 23302 //
     /*  213911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  213914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  213922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213943 */     // (intrinsic_wo_chain:{ *:[i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  213946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  213950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213958 */     GIR_RootConstrainSelectedInstOperands,
     /*  213959 */     // GIR_Coverage, 23302,
     /*  213959 */     GIR_EraseRootFromParent_Done,
     /*  213960 */   // Label 4260: @213960
     /*  213960 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(214014), // Rule ID 23303 //
     /*  213965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  213973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  213976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  213986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213997 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  214000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214012 */     GIR_RootConstrainSelectedInstOperands,
     /*  214013 */     // GIR_Coverage, 23303,
     /*  214013 */     GIR_EraseRootFromParent_Done,
     /*  214014 */   // Label 4261: @214014
     /*  214014 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(214068), // Rule ID 23306 //
     /*  214019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  214033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214051 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  214054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214066 */     GIR_RootConstrainSelectedInstOperands,
     /*  214067 */     // GIR_Coverage, 23306,
     /*  214067 */     GIR_EraseRootFromParent_Done,
     /*  214068 */   // Label 4262: @214068
     /*  214068 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(214122), // Rule ID 23307 //
     /*  214073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  214087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214105 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  214108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214120 */     GIR_RootConstrainSelectedInstOperands,
     /*  214121 */     // GIR_Coverage, 23307,
     /*  214121 */     GIR_EraseRootFromParent_Done,
     /*  214122 */   // Label 4263: @214122
     /*  214122 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(214176), // Rule ID 23310 //
     /*  214127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214159 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  214162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214174 */     GIR_RootConstrainSelectedInstOperands,
     /*  214175 */     // GIR_Coverage, 23310,
     /*  214175 */     GIR_EraseRootFromParent_Done,
     /*  214176 */   // Label 4264: @214176
     /*  214176 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(214230), // Rule ID 23311 //
     /*  214181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214213 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  214216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214228 */     GIR_RootConstrainSelectedInstOperands,
     /*  214229 */     // GIR_Coverage, 23311,
     /*  214229 */     GIR_EraseRootFromParent_Done,
     /*  214230 */   // Label 4265: @214230
     /*  214230 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(214284), // Rule ID 23314 //
     /*  214235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214267 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  214270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214282 */     GIR_RootConstrainSelectedInstOperands,
     /*  214283 */     // GIR_Coverage, 23314,
     /*  214283 */     GIR_EraseRootFromParent_Done,
     /*  214284 */   // Label 4266: @214284
     /*  214284 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(214338), // Rule ID 23315 //
     /*  214289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214321 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  214324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214336 */     GIR_RootConstrainSelectedInstOperands,
     /*  214337 */     // GIR_Coverage, 23315,
     /*  214337 */     GIR_EraseRootFromParent_Done,
     /*  214338 */   // Label 4267: @214338
     /*  214338 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(214392), // Rule ID 23318 //
     /*  214343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  214357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214375 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  214378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214390 */     GIR_RootConstrainSelectedInstOperands,
     /*  214391 */     // GIR_Coverage, 23318,
     /*  214391 */     GIR_EraseRootFromParent_Done,
     /*  214392 */   // Label 4268: @214392
     /*  214392 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(214446), // Rule ID 23319 //
     /*  214397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  214411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214429 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  214432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214444 */     GIR_RootConstrainSelectedInstOperands,
     /*  214445 */     // GIR_Coverage, 23319,
     /*  214445 */     GIR_EraseRootFromParent_Done,
     /*  214446 */   // Label 4269: @214446
     /*  214446 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(214500), // Rule ID 23322 //
     /*  214451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  214465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214483 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  214486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214498 */     GIR_RootConstrainSelectedInstOperands,
     /*  214499 */     // GIR_Coverage, 23322,
     /*  214499 */     GIR_EraseRootFromParent_Done,
     /*  214500 */   // Label 4270: @214500
     /*  214500 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(214554), // Rule ID 23323 //
     /*  214505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  214519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214537 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  214540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214552 */     GIR_RootConstrainSelectedInstOperands,
     /*  214553 */     // GIR_Coverage, 23323,
     /*  214553 */     GIR_EraseRootFromParent_Done,
     /*  214554 */   // Label 4271: @214554
     /*  214554 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(214608), // Rule ID 23326 //
     /*  214559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  214573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214591 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214606 */     GIR_RootConstrainSelectedInstOperands,
     /*  214607 */     // GIR_Coverage, 23326,
     /*  214607 */     GIR_EraseRootFromParent_Done,
     /*  214608 */   // Label 4272: @214608
     /*  214608 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(214662), // Rule ID 23327 //
     /*  214613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  214627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214645 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  214648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214660 */     GIR_RootConstrainSelectedInstOperands,
     /*  214661 */     // GIR_Coverage, 23327,
     /*  214661 */     GIR_EraseRootFromParent_Done,
     /*  214662 */   // Label 4273: @214662
     /*  214662 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(214716), // Rule ID 23330 //
     /*  214667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  214681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214699 */     // (intrinsic_wo_chain:{ *:[i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  214702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214714 */     GIR_RootConstrainSelectedInstOperands,
     /*  214715 */     // GIR_Coverage, 23330,
     /*  214715 */     GIR_EraseRootFromParent_Done,
     /*  214716 */   // Label 4274: @214716
     /*  214716 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(214770), // Rule ID 23331 //
     /*  214721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  214729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  214732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  214735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214753 */     // (intrinsic_wo_chain:{ *:[i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  214756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  214760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214768 */     GIR_RootConstrainSelectedInstOperands,
     /*  214769 */     // GIR_Coverage, 23331,
     /*  214769 */     GIR_EraseRootFromParent_Done,
     /*  214770 */   // Label 4275: @214770
     /*  214770 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(214824), // Rule ID 23334 //
     /*  214775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  214786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  214810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214822 */     GIR_RootConstrainSelectedInstOperands,
     /*  214823 */     // GIR_Coverage, 23334,
     /*  214823 */     GIR_EraseRootFromParent_Done,
     /*  214824 */   // Label 4276: @214824
     /*  214824 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(214878), // Rule ID 23335 //
     /*  214829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  214840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  214843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  214864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214876 */     GIR_RootConstrainSelectedInstOperands,
     /*  214877 */     // GIR_Coverage, 23335,
     /*  214877 */     GIR_EraseRootFromParent_Done,
     /*  214878 */   // Label 4277: @214878
     /*  214878 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(214932), // Rule ID 23338 //
     /*  214883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  214894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214915 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  214915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  214918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214930 */     GIR_RootConstrainSelectedInstOperands,
     /*  214931 */     // GIR_Coverage, 23338,
     /*  214931 */     GIR_EraseRootFromParent_Done,
     /*  214932 */   // Label 4278: @214932
     /*  214932 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(214986), // Rule ID 23339 //
     /*  214937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  214940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  214948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  214951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  214969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  214972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  214976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214984 */     GIR_RootConstrainSelectedInstOperands,
     /*  214985 */     // GIR_Coverage, 23339,
     /*  214985 */     GIR_EraseRootFromParent_Done,
     /*  214986 */   // Label 4279: @214986
     /*  214986 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(215040), // Rule ID 23342 //
     /*  214991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  214994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  214999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215023 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  215026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215038 */     GIR_RootConstrainSelectedInstOperands,
     /*  215039 */     // GIR_Coverage, 23342,
     /*  215039 */     GIR_EraseRootFromParent_Done,
     /*  215040 */   // Label 4280: @215040
     /*  215040 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(215094), // Rule ID 23343 //
     /*  215045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  215080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215092 */     GIR_RootConstrainSelectedInstOperands,
     /*  215093 */     // GIR_Coverage, 23343,
     /*  215093 */     GIR_EraseRootFromParent_Done,
     /*  215094 */   // Label 4281: @215094
     /*  215094 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(215148), // Rule ID 23346 //
     /*  215099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215131 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  215134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215146 */     GIR_RootConstrainSelectedInstOperands,
     /*  215147 */     // GIR_Coverage, 23346,
     /*  215147 */     GIR_EraseRootFromParent_Done,
     /*  215148 */   // Label 4282: @215148
     /*  215148 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(215202), // Rule ID 23347 //
     /*  215153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215185 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  215188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215200 */     GIR_RootConstrainSelectedInstOperands,
     /*  215201 */     // GIR_Coverage, 23347,
     /*  215201 */     GIR_EraseRootFromParent_Done,
     /*  215202 */   // Label 4283: @215202
     /*  215202 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(215256), // Rule ID 23350 //
     /*  215207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215239 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  215242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215254 */     GIR_RootConstrainSelectedInstOperands,
     /*  215255 */     // GIR_Coverage, 23350,
     /*  215255 */     GIR_EraseRootFromParent_Done,
     /*  215256 */   // Label 4284: @215256
     /*  215256 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(215310), // Rule ID 23351 //
     /*  215261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215293 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  215296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215308 */     GIR_RootConstrainSelectedInstOperands,
     /*  215309 */     // GIR_Coverage, 23351,
     /*  215309 */     GIR_EraseRootFromParent_Done,
     /*  215310 */   // Label 4285: @215310
     /*  215310 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(215364), // Rule ID 23354 //
     /*  215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  215326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  215329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215347 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  215350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215362 */     GIR_RootConstrainSelectedInstOperands,
     /*  215363 */     // GIR_Coverage, 23354,
     /*  215363 */     GIR_EraseRootFromParent_Done,
     /*  215364 */   // Label 4286: @215364
     /*  215364 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(215418), // Rule ID 23355 //
     /*  215369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  215377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  215380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  215383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215401 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  215404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215416 */     GIR_RootConstrainSelectedInstOperands,
     /*  215417 */     // GIR_Coverage, 23355,
     /*  215417 */     GIR_EraseRootFromParent_Done,
     /*  215418 */   // Label 4287: @215418
     /*  215418 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(215472), // Rule ID 23358 //
     /*  215423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  215434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  215437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  215458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215470 */     GIR_RootConstrainSelectedInstOperands,
     /*  215471 */     // GIR_Coverage, 23358,
     /*  215471 */     GIR_EraseRootFromParent_Done,
     /*  215472 */   // Label 4288: @215472
     /*  215472 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(215526), // Rule ID 23359 //
     /*  215477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  215488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  215491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215509 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  215512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215524 */     GIR_RootConstrainSelectedInstOperands,
     /*  215525 */     // GIR_Coverage, 23359,
     /*  215525 */     GIR_EraseRootFromParent_Done,
     /*  215526 */   // Label 4289: @215526
     /*  215526 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(215580), // Rule ID 23362 //
     /*  215531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  215542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  215545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215563 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  215566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215578 */     GIR_RootConstrainSelectedInstOperands,
     /*  215579 */     // GIR_Coverage, 23362,
     /*  215579 */     GIR_EraseRootFromParent_Done,
     /*  215580 */   // Label 4290: @215580
     /*  215580 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(215634), // Rule ID 23363 //
     /*  215585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  215596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  215599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215632 */     GIR_RootConstrainSelectedInstOperands,
     /*  215633 */     // GIR_Coverage, 23363,
     /*  215633 */     GIR_EraseRootFromParent_Done,
     /*  215634 */   // Label 4291: @215634
     /*  215634 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(215688), // Rule ID 23366 //
     /*  215639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  215650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  215653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215671 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  215674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215686 */     GIR_RootConstrainSelectedInstOperands,
     /*  215687 */     // GIR_Coverage, 23366,
     /*  215687 */     GIR_EraseRootFromParent_Done,
     /*  215688 */   // Label 4292: @215688
     /*  215688 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(215742), // Rule ID 23367 //
     /*  215693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  215704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  215707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  215728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215740 */     GIR_RootConstrainSelectedInstOperands,
     /*  215741 */     // GIR_Coverage, 23367,
     /*  215741 */     GIR_EraseRootFromParent_Done,
     /*  215742 */   // Label 4293: @215742
     /*  215742 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(215796), // Rule ID 23370 //
     /*  215747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  215782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215794 */     GIR_RootConstrainSelectedInstOperands,
     /*  215795 */     // GIR_Coverage, 23370,
     /*  215795 */     GIR_EraseRootFromParent_Done,
     /*  215796 */   // Label 4294: @215796
     /*  215796 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(215850), // Rule ID 23371 //
     /*  215801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  215812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  215815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  215836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215848 */     GIR_RootConstrainSelectedInstOperands,
     /*  215849 */     // GIR_Coverage, 23371,
     /*  215849 */     GIR_EraseRootFromParent_Done,
     /*  215850 */   // Label 4295: @215850
     /*  215850 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(215904), // Rule ID 23374 //
     /*  215855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215887 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  215890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215902 */     GIR_RootConstrainSelectedInstOperands,
     /*  215903 */     // GIR_Coverage, 23374,
     /*  215903 */     GIR_EraseRootFromParent_Done,
     /*  215904 */   // Label 4296: @215904
     /*  215904 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(215958), // Rule ID 23375 //
     /*  215909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  215912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  215920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  215923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  215941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  215944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  215948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215956 */     GIR_RootConstrainSelectedInstOperands,
     /*  215957 */     // GIR_Coverage, 23375,
     /*  215957 */     GIR_EraseRootFromParent_Done,
     /*  215958 */   // Label 4297: @215958
     /*  215958 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(216012), // Rule ID 23378 //
     /*  215963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  215966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  215971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  215974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  215977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  215988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215995 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  215995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  215998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216010 */     GIR_RootConstrainSelectedInstOperands,
     /*  216011 */     // GIR_Coverage, 23378,
     /*  216011 */     GIR_EraseRootFromParent_Done,
     /*  216012 */   // Label 4298: @216012
     /*  216012 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(216066), // Rule ID 23379 //
     /*  216017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216049 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  216052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216064 */     GIR_RootConstrainSelectedInstOperands,
     /*  216065 */     // GIR_Coverage, 23379,
     /*  216065 */     GIR_EraseRootFromParent_Done,
     /*  216066 */   // Label 4299: @216066
     /*  216066 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(216120), // Rule ID 23382 //
     /*  216071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216103 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  216106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216118 */     GIR_RootConstrainSelectedInstOperands,
     /*  216119 */     // GIR_Coverage, 23382,
     /*  216119 */     GIR_EraseRootFromParent_Done,
     /*  216120 */   // Label 4300: @216120
     /*  216120 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(216174), // Rule ID 23383 //
     /*  216125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  216133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216157 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  216160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216172 */     GIR_RootConstrainSelectedInstOperands,
     /*  216173 */     // GIR_Coverage, 23383,
     /*  216173 */     GIR_EraseRootFromParent_Done,
     /*  216174 */   // Label 4301: @216174
     /*  216174 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(216228), // Rule ID 23386 //
     /*  216179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  216193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  216214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216226 */     GIR_RootConstrainSelectedInstOperands,
     /*  216227 */     // GIR_Coverage, 23386,
     /*  216227 */     GIR_EraseRootFromParent_Done,
     /*  216228 */   // Label 4302: @216228
     /*  216228 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(216282), // Rule ID 23387 //
     /*  216233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  216247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  216268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216280 */     GIR_RootConstrainSelectedInstOperands,
     /*  216281 */     // GIR_Coverage, 23387,
     /*  216281 */     GIR_EraseRootFromParent_Done,
     /*  216282 */   // Label 4303: @216282
     /*  216282 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(216336), // Rule ID 23390 //
     /*  216287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  216301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  216322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216334 */     GIR_RootConstrainSelectedInstOperands,
     /*  216335 */     // GIR_Coverage, 23390,
     /*  216335 */     GIR_EraseRootFromParent_Done,
     /*  216336 */   // Label 4304: @216336
     /*  216336 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(216390), // Rule ID 23391 //
     /*  216341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  216355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216373 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  216376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216388 */     GIR_RootConstrainSelectedInstOperands,
     /*  216389 */     // GIR_Coverage, 23391,
     /*  216389 */     GIR_EraseRootFromParent_Done,
     /*  216390 */   // Label 4305: @216390
     /*  216390 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(216444), // Rule ID 23394 //
     /*  216395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  216409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216427 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  216430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216442 */     GIR_RootConstrainSelectedInstOperands,
     /*  216443 */     // GIR_Coverage, 23394,
     /*  216443 */     GIR_EraseRootFromParent_Done,
     /*  216444 */   // Label 4306: @216444
     /*  216444 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(216498), // Rule ID 23395 //
     /*  216449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  216463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216481 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  216484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216496 */     GIR_RootConstrainSelectedInstOperands,
     /*  216497 */     // GIR_Coverage, 23395,
     /*  216497 */     GIR_EraseRootFromParent_Done,
     /*  216498 */   // Label 4307: @216498
     /*  216498 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(216552), // Rule ID 23398 //
     /*  216503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  216517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216535 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  216538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216550 */     GIR_RootConstrainSelectedInstOperands,
     /*  216551 */     // GIR_Coverage, 23398,
     /*  216551 */     GIR_EraseRootFromParent_Done,
     /*  216552 */   // Label 4308: @216552
     /*  216552 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(216606), // Rule ID 23399 //
     /*  216557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  216571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  216592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216604 */     GIR_RootConstrainSelectedInstOperands,
     /*  216605 */     // GIR_Coverage, 23399,
     /*  216605 */     GIR_EraseRootFromParent_Done,
     /*  216606 */   // Label 4309: @216606
     /*  216606 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(216660), // Rule ID 23402 //
     /*  216611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  216622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  216625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  216646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216658 */     GIR_RootConstrainSelectedInstOperands,
     /*  216659 */     // GIR_Coverage, 23402,
     /*  216659 */     GIR_EraseRootFromParent_Done,
     /*  216660 */   // Label 4310: @216660
     /*  216660 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(216714), // Rule ID 23403 //
     /*  216665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  216676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  216679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  216700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216712 */     GIR_RootConstrainSelectedInstOperands,
     /*  216713 */     // GIR_Coverage, 23403,
     /*  216713 */     GIR_EraseRootFromParent_Done,
     /*  216714 */   // Label 4311: @216714
     /*  216714 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(216768), // Rule ID 23406 //
     /*  216719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216751 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  216754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216766 */     GIR_RootConstrainSelectedInstOperands,
     /*  216767 */     // GIR_Coverage, 23406,
     /*  216767 */     GIR_EraseRootFromParent_Done,
     /*  216768 */   // Label 4312: @216768
     /*  216768 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(216822), // Rule ID 23407 //
     /*  216773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  216784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  216787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  216808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216820 */     GIR_RootConstrainSelectedInstOperands,
     /*  216821 */     // GIR_Coverage, 23407,
     /*  216821 */     GIR_EraseRootFromParent_Done,
     /*  216822 */   // Label 4313: @216822
     /*  216822 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(216876), // Rule ID 23410 //
     /*  216827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  216830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216859 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  216859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  216862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216874 */     GIR_RootConstrainSelectedInstOperands,
     /*  216875 */     // GIR_Coverage, 23410,
     /*  216875 */     GIR_EraseRootFromParent_Done,
     /*  216876 */   // Label 4314: @216876
     /*  216876 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(216930), // Rule ID 23411 //
     /*  216881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  216884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  216889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  216892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  216895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216913 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11406:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  216913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  216916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  216920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216928 */     GIR_RootConstrainSelectedInstOperands,
     /*  216929 */     // GIR_Coverage, 23411,
     /*  216929 */     GIR_EraseRootFromParent_Done,
     /*  216930 */   // Label 4315: @216930
     /*  216930 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(216987), // Rule ID 23498 //
     /*  216935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  216943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  216946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216967 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  216967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  216970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  216974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  216985 */     GIR_RootConstrainSelectedInstOperands,
     /*  216986 */     // GIR_Coverage, 23498,
     /*  216986 */     GIR_EraseRootFromParent_Done,
     /*  216987 */   // Label 4316: @216987
     /*  216987 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(217044), // Rule ID 23499 //
     /*  216992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  217003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  217006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217042 */     GIR_RootConstrainSelectedInstOperands,
     /*  217043 */     // GIR_Coverage, 23499,
     /*  217043 */     GIR_EraseRootFromParent_Done,
     /*  217044 */   // Label 4317: @217044
     /*  217044 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(217101), // Rule ID 23502 //
     /*  217049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  217060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217081 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217099 */     GIR_RootConstrainSelectedInstOperands,
     /*  217100 */     // GIR_Coverage, 23502,
     /*  217100 */     GIR_EraseRootFromParent_Done,
     /*  217101 */   // Label 4318: @217101
     /*  217101 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(217158), // Rule ID 23503 //
     /*  217106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  217117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  217120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217156 */     GIR_RootConstrainSelectedInstOperands,
     /*  217157 */     // GIR_Coverage, 23503,
     /*  217157 */     GIR_EraseRootFromParent_Done,
     /*  217158 */   // Label 4319: @217158
     /*  217158 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(217215), // Rule ID 23506 //
     /*  217163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  217174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217195 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217213 */     GIR_RootConstrainSelectedInstOperands,
     /*  217214 */     // GIR_Coverage, 23506,
     /*  217214 */     GIR_EraseRootFromParent_Done,
     /*  217215 */   // Label 4320: @217215
     /*  217215 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(217272), // Rule ID 23507 //
     /*  217220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  217231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  217255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217270 */     GIR_RootConstrainSelectedInstOperands,
     /*  217271 */     // GIR_Coverage, 23507,
     /*  217271 */     GIR_EraseRootFromParent_Done,
     /*  217272 */   // Label 4321: @217272
     /*  217272 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(217329), // Rule ID 23510 //
     /*  217277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217309 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217327 */     GIR_RootConstrainSelectedInstOperands,
     /*  217328 */     // GIR_Coverage, 23510,
     /*  217328 */     GIR_EraseRootFromParent_Done,
     /*  217329 */   // Label 4322: @217329
     /*  217329 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(217386), // Rule ID 23511 //
     /*  217334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  217345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217384 */     GIR_RootConstrainSelectedInstOperands,
     /*  217385 */     // GIR_Coverage, 23511,
     /*  217385 */     GIR_EraseRootFromParent_Done,
     /*  217386 */   // Label 4323: @217386
     /*  217386 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(217443), // Rule ID 23514 //
     /*  217391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217423 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217441 */     GIR_RootConstrainSelectedInstOperands,
     /*  217442 */     // GIR_Coverage, 23514,
     /*  217442 */     GIR_EraseRootFromParent_Done,
     /*  217443 */   // Label 4324: @217443
     /*  217443 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(217500), // Rule ID 23515 //
     /*  217448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  217459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  217483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217498 */     GIR_RootConstrainSelectedInstOperands,
     /*  217499 */     // GIR_Coverage, 23515,
     /*  217499 */     GIR_EraseRootFromParent_Done,
     /*  217500 */   // Label 4325: @217500
     /*  217500 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(217557), // Rule ID 23518 //
     /*  217505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  217516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217537 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217555 */     GIR_RootConstrainSelectedInstOperands,
     /*  217556 */     // GIR_Coverage, 23518,
     /*  217556 */     GIR_EraseRootFromParent_Done,
     /*  217557 */   // Label 4326: @217557
     /*  217557 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(217614), // Rule ID 23519 //
     /*  217562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  217573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11260:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  217594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217612 */     GIR_RootConstrainSelectedInstOperands,
     /*  217613 */     // GIR_Coverage, 23519,
     /*  217613 */     GIR_EraseRootFromParent_Done,
     /*  217614 */   // Label 4327: @217614
     /*  217614 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(217671), // Rule ID 23522 //
     /*  217619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217651 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  217651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217669 */     GIR_RootConstrainSelectedInstOperands,
     /*  217670 */     // GIR_Coverage, 23522,
     /*  217670 */     GIR_EraseRootFromParent_Done,
     /*  217671 */   // Label 4328: @217671
     /*  217671 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(217728), // Rule ID 23523 //
     /*  217676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  217687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  217708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217726 */     GIR_RootConstrainSelectedInstOperands,
     /*  217727 */     // GIR_Coverage, 23523,
     /*  217727 */     GIR_EraseRootFromParent_Done,
     /*  217728 */   // Label 4329: @217728
     /*  217728 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(217785), // Rule ID 23526 //
     /*  217733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  217765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217783 */     GIR_RootConstrainSelectedInstOperands,
     /*  217784 */     // GIR_Coverage, 23526,
     /*  217784 */     GIR_EraseRootFromParent_Done,
     /*  217785 */   // Label 4330: @217785
     /*  217785 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(217842), // Rule ID 23527 //
     /*  217790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  217801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  217822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217840 */     GIR_RootConstrainSelectedInstOperands,
     /*  217841 */     // GIR_Coverage, 23527,
     /*  217841 */     GIR_EraseRootFromParent_Done,
     /*  217842 */   // Label 4331: @217842
     /*  217842 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(217899), // Rule ID 23530 //
     /*  217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  217850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217879 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  217879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217897 */     GIR_RootConstrainSelectedInstOperands,
     /*  217898 */     // GIR_Coverage, 23530,
     /*  217898 */     GIR_EraseRootFromParent_Done,
     /*  217899 */   // Label 4332: @217899
     /*  217899 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(217956), // Rule ID 23531 //
     /*  217904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  217907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  217915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  217936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  217939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  217943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  217954 */     GIR_RootConstrainSelectedInstOperands,
     /*  217955 */     // GIR_Coverage, 23531,
     /*  217955 */     GIR_EraseRootFromParent_Done,
     /*  217956 */   // Label 4333: @217956
     /*  217956 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(218013), // Rule ID 23534 //
     /*  217961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  217969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  217972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  217993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  217996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218011 */     GIR_RootConstrainSelectedInstOperands,
     /*  218012 */     // GIR_Coverage, 23534,
     /*  218012 */     GIR_EraseRootFromParent_Done,
     /*  218013 */   // Label 4334: @218013
     /*  218013 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(218070), // Rule ID 23535 //
     /*  218018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  218029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218068 */     GIR_RootConstrainSelectedInstOperands,
     /*  218069 */     // GIR_Coverage, 23535,
     /*  218069 */     GIR_EraseRootFromParent_Done,
     /*  218070 */   // Label 4335: @218070
     /*  218070 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(218127), // Rule ID 23538 //
     /*  218075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  218086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218107 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  218107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218125 */     GIR_RootConstrainSelectedInstOperands,
     /*  218126 */     // GIR_Coverage, 23538,
     /*  218126 */     GIR_EraseRootFromParent_Done,
     /*  218127 */   // Label 4336: @218127
     /*  218127 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(218184), // Rule ID 23539 //
     /*  218132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  218143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218182 */     GIR_RootConstrainSelectedInstOperands,
     /*  218183 */     // GIR_Coverage, 23539,
     /*  218183 */     GIR_EraseRootFromParent_Done,
     /*  218184 */   // Label 4337: @218184
     /*  218184 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(218241), // Rule ID 23542 //
     /*  218189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  218200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218221 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  218221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218239 */     GIR_RootConstrainSelectedInstOperands,
     /*  218240 */     // GIR_Coverage, 23542,
     /*  218240 */     GIR_EraseRootFromParent_Done,
     /*  218241 */   // Label 4338: @218241
     /*  218241 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(218298), // Rule ID 23543 //
     /*  218246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  218257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218278 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  218278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218296 */     GIR_RootConstrainSelectedInstOperands,
     /*  218297 */     // GIR_Coverage, 23543,
     /*  218297 */     GIR_EraseRootFromParent_Done,
     /*  218298 */   // Label 4339: @218298
     /*  218298 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(218355), // Rule ID 23546 //
     /*  218303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  218314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218335 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218353 */     GIR_RootConstrainSelectedInstOperands,
     /*  218354 */     // GIR_Coverage, 23546,
     /*  218354 */     GIR_EraseRootFromParent_Done,
     /*  218355 */   // Label 4340: @218355
     /*  218355 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(218412), // Rule ID 23547 //
     /*  218360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  218371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218410 */     GIR_RootConstrainSelectedInstOperands,
     /*  218411 */     // GIR_Coverage, 23547,
     /*  218411 */     GIR_EraseRootFromParent_Done,
     /*  218412 */   // Label 4341: @218412
     /*  218412 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(218469), // Rule ID 23550 //
     /*  218417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  218428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218467 */     GIR_RootConstrainSelectedInstOperands,
     /*  218468 */     // GIR_Coverage, 23550,
     /*  218468 */     GIR_EraseRootFromParent_Done,
     /*  218469 */   // Label 4342: @218469
     /*  218469 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(218526), // Rule ID 23551 //
     /*  218474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  218485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218524 */     GIR_RootConstrainSelectedInstOperands,
     /*  218525 */     // GIR_Coverage, 23551,
     /*  218525 */     GIR_EraseRootFromParent_Done,
     /*  218526 */   // Label 4343: @218526
     /*  218526 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(218583), // Rule ID 23554 //
     /*  218531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  218542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218563 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  218563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218581 */     GIR_RootConstrainSelectedInstOperands,
     /*  218582 */     // GIR_Coverage, 23554,
     /*  218582 */     GIR_EraseRootFromParent_Done,
     /*  218583 */   // Label 4344: @218583
     /*  218583 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(218640), // Rule ID 23555 //
     /*  218588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  218599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  218620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218638 */     GIR_RootConstrainSelectedInstOperands,
     /*  218639 */     // GIR_Coverage, 23555,
     /*  218639 */     GIR_EraseRootFromParent_Done,
     /*  218640 */   // Label 4345: @218640
     /*  218640 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(218697), // Rule ID 23558 //
     /*  218645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218695 */     GIR_RootConstrainSelectedInstOperands,
     /*  218696 */     // GIR_Coverage, 23558,
     /*  218696 */     GIR_EraseRootFromParent_Done,
     /*  218697 */   // Label 4346: @218697
     /*  218697 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(218754), // Rule ID 23559 //
     /*  218702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  218713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218752 */     GIR_RootConstrainSelectedInstOperands,
     /*  218753 */     // GIR_Coverage, 23559,
     /*  218753 */     GIR_EraseRootFromParent_Done,
     /*  218754 */   // Label 4347: @218754
     /*  218754 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(218811), // Rule ID 23562 //
     /*  218759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218809 */     GIR_RootConstrainSelectedInstOperands,
     /*  218810 */     // GIR_Coverage, 23562,
     /*  218810 */     GIR_EraseRootFromParent_Done,
     /*  218811 */   // Label 4348: @218811
     /*  218811 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(218868), // Rule ID 23563 //
     /*  218816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  218827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  218851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218866 */     GIR_RootConstrainSelectedInstOperands,
     /*  218867 */     // GIR_Coverage, 23563,
     /*  218867 */     GIR_EraseRootFromParent_Done,
     /*  218868 */   // Label 4349: @218868
     /*  218868 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(218925), // Rule ID 23566 //
     /*  218873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  218905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218923 */     GIR_RootConstrainSelectedInstOperands,
     /*  218924 */     // GIR_Coverage, 23566,
     /*  218924 */     GIR_EraseRootFromParent_Done,
     /*  218925 */   // Label 4350: @218925
     /*  218925 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(218982), // Rule ID 23567 //
     /*  218930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  218941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  218962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  218965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  218969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  218980 */     GIR_RootConstrainSelectedInstOperands,
     /*  218981 */     // GIR_Coverage, 23567,
     /*  218981 */     GIR_EraseRootFromParent_Done,
     /*  218982 */   // Label 4351: @218982
     /*  218982 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(219039), // Rule ID 23570 //
     /*  218987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  218995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  218998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  219022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219037 */     GIR_RootConstrainSelectedInstOperands,
     /*  219038 */     // GIR_Coverage, 23570,
     /*  219038 */     GIR_EraseRootFromParent_Done,
     /*  219039 */   // Label 4352: @219039
     /*  219039 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(219096), // Rule ID 23571 //
     /*  219044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  219055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11260:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  219079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219094 */     GIR_RootConstrainSelectedInstOperands,
     /*  219095 */     // GIR_Coverage, 23571,
     /*  219095 */     GIR_EraseRootFromParent_Done,
     /*  219096 */   // Label 4353: @219096
     /*  219096 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(219153), // Rule ID 23574 //
     /*  219101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  219112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  219136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219151 */     GIR_RootConstrainSelectedInstOperands,
     /*  219152 */     // GIR_Coverage, 23574,
     /*  219152 */     GIR_EraseRootFromParent_Done,
     /*  219153 */   // Label 4354: @219153
     /*  219153 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(219210), // Rule ID 23575 //
     /*  219158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  219169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11260:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  219193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219208 */     GIR_RootConstrainSelectedInstOperands,
     /*  219209 */     // GIR_Coverage, 23575,
     /*  219209 */     GIR_EraseRootFromParent_Done,
     /*  219210 */   // Label 4355: @219210
     /*  219210 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(219267), // Rule ID 23578 //
     /*  219215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  219226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  219247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  219250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219265 */     GIR_RootConstrainSelectedInstOperands,
     /*  219266 */     // GIR_Coverage, 23578,
     /*  219266 */     GIR_EraseRootFromParent_Done,
     /*  219267 */   // Label 4356: @219267
     /*  219267 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(219324), // Rule ID 23579 //
     /*  219272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  219280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  219283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219304 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11260:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  219304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  219307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  219311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  219322 */     GIR_RootConstrainSelectedInstOperands,
     /*  219323 */     // GIR_Coverage, 23579,
     /*  219323 */     GIR_EraseRootFromParent_Done,
     /*  219324 */   // Label 4357: @219324
     /*  219324 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(219370), // Rule ID 2645 //
     /*  219329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  219332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  219337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219351 */     // MIs[0] rnum
     /*  219351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  219354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  219359 */     // (intrinsic_wo_chain:{ *:[i64] } 10917:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  219359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  219362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  219368 */     GIR_RootConstrainSelectedInstOperands,
     /*  219369 */     // GIR_Coverage, 2645,
     /*  219369 */     GIR_EraseRootFromParent_Done,
     /*  219370 */   // Label 4358: @219370
     /*  219370 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(219415), // Rule ID 64442 //
     /*  219375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  219378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  219383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219404 */     // (intrinsic_wo_chain:{ *:[i32] } 10927:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  219407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219413 */     GIR_RootConstrainSelectedInstOperands,
     /*  219414 */     // GIR_Coverage, 64442,
     /*  219414 */     GIR_EraseRootFromParent_Done,
     /*  219415 */   // Label 4359: @219415
     /*  219415 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219460), // Rule ID 64469 //
     /*  219420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  219423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  219428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219449 */     // (intrinsic_wo_chain:{ *:[i32] } 10928:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  219452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219458 */     GIR_RootConstrainSelectedInstOperands,
     /*  219459 */     // GIR_Coverage, 64469,
     /*  219459 */     GIR_EraseRootFromParent_Done,
     /*  219460 */   // Label 4360: @219460
     /*  219460 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219505), // Rule ID 2635 //
     /*  219465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  219468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  219473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219494 */     // (intrinsic_wo_chain:{ *:[i64] } 11618:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  219497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219503 */     GIR_RootConstrainSelectedInstOperands,
     /*  219504 */     // GIR_Coverage, 2635,
     /*  219504 */     GIR_EraseRootFromParent_Done,
     /*  219505 */   // Label 4361: @219505
     /*  219505 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219550), // Rule ID 2636 //
     /*  219510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  219513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  219518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219539 */     // (intrinsic_wo_chain:{ *:[i32] } 11618:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  219542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219548 */     GIR_RootConstrainSelectedInstOperands,
     /*  219549 */     // GIR_Coverage, 2636,
     /*  219549 */     GIR_EraseRootFromParent_Done,
     /*  219550 */   // Label 4362: @219550
     /*  219550 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219595), // Rule ID 2637 //
     /*  219555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  219558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  219563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219584 */     // (intrinsic_wo_chain:{ *:[i64] } 11619:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  219587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219593 */     GIR_RootConstrainSelectedInstOperands,
     /*  219594 */     // GIR_Coverage, 2637,
     /*  219594 */     GIR_EraseRootFromParent_Done,
     /*  219595 */   // Label 4363: @219595
     /*  219595 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219640), // Rule ID 2638 //
     /*  219600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  219603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  219608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219629 */     // (intrinsic_wo_chain:{ *:[i32] } 11619:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  219632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219638 */     GIR_RootConstrainSelectedInstOperands,
     /*  219639 */     // GIR_Coverage, 2638,
     /*  219639 */     GIR_EraseRootFromParent_Done,
     /*  219640 */   // Label 4364: @219640
     /*  219640 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219685), // Rule ID 2641 //
     /*  219645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  219648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  219653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219674 */     // (intrinsic_wo_chain:{ *:[i64] } 10912:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  219677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219683 */     GIR_RootConstrainSelectedInstOperands,
     /*  219684 */     // GIR_Coverage, 2641,
     /*  219684 */     GIR_EraseRootFromParent_Done,
     /*  219685 */   // Label 4365: @219685
     /*  219685 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219730), // Rule ID 2642 //
     /*  219690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  219693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  219698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219719 */     // (intrinsic_wo_chain:{ *:[i64] } 10913:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  219722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219728 */     GIR_RootConstrainSelectedInstOperands,
     /*  219729 */     // GIR_Coverage, 2642,
     /*  219729 */     GIR_EraseRootFromParent_Done,
     /*  219730 */   // Label 4366: @219730
     /*  219730 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219775), // Rule ID 2644 //
     /*  219735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  219738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  219743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219764 */     // (intrinsic_wo_chain:{ *:[i64] } 10918:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  219767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219773 */     GIR_RootConstrainSelectedInstOperands,
     /*  219774 */     // GIR_Coverage, 2644,
     /*  219774 */     GIR_EraseRootFromParent_Done,
     /*  219775 */   // Label 4367: @219775
     /*  219775 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(219820), // Rule ID 2648 //
     /*  219780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  219783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  219788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219809 */     // (intrinsic_wo_chain:{ *:[i64] } 10914:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  219812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219818 */     GIR_RootConstrainSelectedInstOperands,
     /*  219819 */     // GIR_Coverage, 2648,
     /*  219819 */     GIR_EraseRootFromParent_Done,
     /*  219820 */   // Label 4368: @219820
     /*  219820 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(219865), // Rule ID 2649 //
     /*  219825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  219828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  219833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  219836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  219839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219854 */     // (intrinsic_wo_chain:{ *:[i64] } 10915:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  219854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  219857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219863 */     GIR_RootConstrainSelectedInstOperands,
     /*  219864 */     // GIR_Coverage, 2649,
     /*  219864 */     GIR_EraseRootFromParent_Done,
     /*  219865 */   // Label 4369: @219865
     /*  219865 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(219910), // Rule ID 2658 //
     /*  219870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  219878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219899 */     // (intrinsic_wo_chain:{ *:[i32] } 11054:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  219902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219908 */     GIR_RootConstrainSelectedInstOperands,
     /*  219909 */     // GIR_Coverage, 2658,
     /*  219909 */     GIR_EraseRootFromParent_Done,
     /*  219910 */   // Label 4370: @219910
     /*  219910 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(219955), // Rule ID 2659 //
     /*  219915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  219923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219944 */     // (intrinsic_wo_chain:{ *:[i32] } 11053:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  219947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219953 */     GIR_RootConstrainSelectedInstOperands,
     /*  219954 */     // GIR_Coverage, 2659,
     /*  219954 */     GIR_EraseRootFromParent_Done,
     /*  219955 */   // Label 4371: @219955
     /*  219955 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(220000), // Rule ID 2660 //
     /*  219960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  219963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  219968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  219971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  219974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  219989 */     // (intrinsic_wo_chain:{ *:[i32] } 11057:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  219989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  219992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  219998 */     GIR_RootConstrainSelectedInstOperands,
     /*  219999 */     // GIR_Coverage, 2660,
     /*  219999 */     GIR_EraseRootFromParent_Done,
     /*  220000 */   // Label 4372: @220000
     /*  220000 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(220045), // Rule ID 2661 //
     /*  220005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  220013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220034 */     // (intrinsic_wo_chain:{ *:[i32] } 11056:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  220037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220043 */     GIR_RootConstrainSelectedInstOperands,
     /*  220044 */     // GIR_Coverage, 2661,
     /*  220044 */     GIR_EraseRootFromParent_Done,
     /*  220045 */   // Label 4373: @220045
     /*  220045 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220090), // Rule ID 2662 //
     /*  220050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  220058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220079 */     // (intrinsic_wo_chain:{ *:[i32] } 11059:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  220082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220088 */     GIR_RootConstrainSelectedInstOperands,
     /*  220089 */     // GIR_Coverage, 2662,
     /*  220089 */     GIR_EraseRootFromParent_Done,
     /*  220090 */   // Label 4374: @220090
     /*  220090 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220135), // Rule ID 2663 //
     /*  220095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  220098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  220103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220124 */     // (intrinsic_wo_chain:{ *:[i32] } 11061:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  220127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220133 */     GIR_RootConstrainSelectedInstOperands,
     /*  220134 */     // GIR_Coverage, 2663,
     /*  220134 */     GIR_EraseRootFromParent_Done,
     /*  220135 */   // Label 4375: @220135
     /*  220135 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220180), // Rule ID 64419 //
     /*  220140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  220148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220169 */     // (intrinsic_wo_chain:{ *:[i32] } 10937:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  220172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220178 */     GIR_RootConstrainSelectedInstOperands,
     /*  220179 */     // GIR_Coverage, 64419,
     /*  220179 */     GIR_EraseRootFromParent_Done,
     /*  220180 */   // Label 4376: @220180
     /*  220180 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220225), // Rule ID 64421 //
     /*  220185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  220193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220214 */     // (intrinsic_wo_chain:{ *:[i32] } 10938:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  220217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220223 */     GIR_RootConstrainSelectedInstOperands,
     /*  220224 */     // GIR_Coverage, 64421,
     /*  220224 */     GIR_EraseRootFromParent_Done,
     /*  220225 */   // Label 4377: @220225
     /*  220225 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220270), // Rule ID 64423 //
     /*  220230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  220238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220259 */     // (intrinsic_wo_chain:{ *:[i32] } 10933:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  220262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220268 */     GIR_RootConstrainSelectedInstOperands,
     /*  220269 */     // GIR_Coverage, 64423,
     /*  220269 */     GIR_EraseRootFromParent_Done,
     /*  220270 */   // Label 4378: @220270
     /*  220270 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220315), // Rule ID 64425 //
     /*  220275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  220278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  220283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  220286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  220289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  220304 */     // (intrinsic_wo_chain:{ *:[i32] } 10935:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  220304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  220307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  220313 */     GIR_RootConstrainSelectedInstOperands,
     /*  220314 */     // GIR_Coverage, 64425,
     /*  220314 */     GIR_EraseRootFromParent_Done,
     /*  220315 */   // Label 4379: @220315
     /*  220315 */   GIM_Reject,
     /*  220316 */ // Label 4243: @220316
     /*  220316 */ GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(391221),
     /*  220321 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  220324 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220398), // Rule ID 5456 //
     /*  220329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220369 */     // MIs[1] Operand 1
     /*  220369 */     // No operand predicates
     /*  220369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  220381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220396 */     GIR_RootConstrainSelectedInstOperands,
     /*  220397 */     // GIR_Coverage, 5456,
     /*  220397 */     GIR_EraseRootFromParent_Done,
     /*  220398 */   // Label 4381: @220398
     /*  220398 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220472), // Rule ID 5457 //
     /*  220403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  220417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220443 */     // MIs[1] Operand 1
     /*  220443 */     // No operand predicates
     /*  220443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  220455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220470 */     GIR_RootConstrainSelectedInstOperands,
     /*  220471 */     // GIR_Coverage, 5457,
     /*  220471 */     GIR_EraseRootFromParent_Done,
     /*  220472 */   // Label 4382: @220472
     /*  220472 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220546), // Rule ID 5458 //
     /*  220477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220517 */     // MIs[1] Operand 1
     /*  220517 */     // No operand predicates
     /*  220517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220544 */     GIR_RootConstrainSelectedInstOperands,
     /*  220545 */     // GIR_Coverage, 5458,
     /*  220545 */     GIR_EraseRootFromParent_Done,
     /*  220546 */   // Label 4383: @220546
     /*  220546 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220620), // Rule ID 5459 //
     /*  220551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  220565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220591 */     // MIs[1] Operand 1
     /*  220591 */     // No operand predicates
     /*  220591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220618 */     GIR_RootConstrainSelectedInstOperands,
     /*  220619 */     // GIR_Coverage, 5459,
     /*  220619 */     GIR_EraseRootFromParent_Done,
     /*  220620 */   // Label 4384: @220620
     /*  220620 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220694), // Rule ID 5460 //
     /*  220625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220665 */     // MIs[1] Operand 1
     /*  220665 */     // No operand predicates
     /*  220665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220692 */     GIR_RootConstrainSelectedInstOperands,
     /*  220693 */     // GIR_Coverage, 5460,
     /*  220693 */     GIR_EraseRootFromParent_Done,
     /*  220694 */   // Label 4385: @220694
     /*  220694 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220768), // Rule ID 5461 //
     /*  220699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220739 */     // MIs[1] Operand 1
     /*  220739 */     // No operand predicates
     /*  220739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220766 */     GIR_RootConstrainSelectedInstOperands,
     /*  220767 */     // GIR_Coverage, 5461,
     /*  220767 */     GIR_EraseRootFromParent_Done,
     /*  220768 */   // Label 4386: @220768
     /*  220768 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(220842), // Rule ID 5462 //
     /*  220773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220813 */     // MIs[1] Operand 1
     /*  220813 */     // No operand predicates
     /*  220813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220822 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220840 */     GIR_RootConstrainSelectedInstOperands,
     /*  220841 */     // GIR_Coverage, 5462,
     /*  220841 */     GIR_EraseRootFromParent_Done,
     /*  220842 */   // Label 4387: @220842
     /*  220842 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(220916), // Rule ID 5463 //
     /*  220847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220887 */     // MIs[1] Operand 1
     /*  220887 */     // No operand predicates
     /*  220887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  220899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220914 */     GIR_RootConstrainSelectedInstOperands,
     /*  220915 */     // GIR_Coverage, 5463,
     /*  220915 */     GIR_EraseRootFromParent_Done,
     /*  220916 */   // Label 4388: @220916
     /*  220916 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(220990), // Rule ID 5464 //
     /*  220921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  220929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220961 */     // MIs[1] Operand 1
     /*  220961 */     // No operand predicates
     /*  220961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  220973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220988 */     GIR_RootConstrainSelectedInstOperands,
     /*  220989 */     // GIR_Coverage, 5464,
     /*  220989 */     GIR_EraseRootFromParent_Done,
     /*  220990 */   // Label 4389: @220990
     /*  220990 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(221064), // Rule ID 5465 //
     /*  220995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  221009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221035 */     // MIs[1] Operand 1
     /*  221035 */     // No operand predicates
     /*  221035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221062 */     GIR_RootConstrainSelectedInstOperands,
     /*  221063 */     // GIR_Coverage, 5465,
     /*  221063 */     GIR_EraseRootFromParent_Done,
     /*  221064 */   // Label 4390: @221064
     /*  221064 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(221138), // Rule ID 5466 //
     /*  221069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221109 */     // MIs[1] Operand 1
     /*  221109 */     // No operand predicates
     /*  221109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221136 */     GIR_RootConstrainSelectedInstOperands,
     /*  221137 */     // GIR_Coverage, 5466,
     /*  221137 */     GIR_EraseRootFromParent_Done,
     /*  221138 */   // Label 4391: @221138
     /*  221138 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221212), // Rule ID 5467 //
     /*  221143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  221157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221183 */     // MIs[1] Operand 1
     /*  221183 */     // No operand predicates
     /*  221183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  221195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221210 */     GIR_RootConstrainSelectedInstOperands,
     /*  221211 */     // GIR_Coverage, 5467,
     /*  221211 */     GIR_EraseRootFromParent_Done,
     /*  221212 */   // Label 4392: @221212
     /*  221212 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221286), // Rule ID 5468 //
     /*  221217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221257 */     // MIs[1] Operand 1
     /*  221257 */     // No operand predicates
     /*  221257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221284 */     GIR_RootConstrainSelectedInstOperands,
     /*  221285 */     // GIR_Coverage, 5468,
     /*  221285 */     GIR_EraseRootFromParent_Done,
     /*  221286 */   // Label 4393: @221286
     /*  221286 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221360), // Rule ID 5469 //
     /*  221291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  221305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221331 */     // MIs[1] Operand 1
     /*  221331 */     // No operand predicates
     /*  221331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221358 */     GIR_RootConstrainSelectedInstOperands,
     /*  221359 */     // GIR_Coverage, 5469,
     /*  221359 */     GIR_EraseRootFromParent_Done,
     /*  221360 */   // Label 4394: @221360
     /*  221360 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221434), // Rule ID 5470 //
     /*  221365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221405 */     // MIs[1] Operand 1
     /*  221405 */     // No operand predicates
     /*  221405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221432 */     GIR_RootConstrainSelectedInstOperands,
     /*  221433 */     // GIR_Coverage, 5470,
     /*  221433 */     GIR_EraseRootFromParent_Done,
     /*  221434 */   // Label 4395: @221434
     /*  221434 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(221508), // Rule ID 5471 //
     /*  221439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  221453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221479 */     // MIs[1] Operand 1
     /*  221479 */     // No operand predicates
     /*  221479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221506 */     GIR_RootConstrainSelectedInstOperands,
     /*  221507 */     // GIR_Coverage, 5471,
     /*  221507 */     GIR_EraseRootFromParent_Done,
     /*  221508 */   // Label 4396: @221508
     /*  221508 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221582), // Rule ID 5472 //
     /*  221513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221553 */     // MIs[1] Operand 1
     /*  221553 */     // No operand predicates
     /*  221553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221580 */     GIR_RootConstrainSelectedInstOperands,
     /*  221581 */     // GIR_Coverage, 5472,
     /*  221581 */     GIR_EraseRootFromParent_Done,
     /*  221582 */   // Label 4397: @221582
     /*  221582 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221656), // Rule ID 5473 //
     /*  221587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221627 */     // MIs[1] Operand 1
     /*  221627 */     // No operand predicates
     /*  221627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221654 */     GIR_RootConstrainSelectedInstOperands,
     /*  221655 */     // GIR_Coverage, 5473,
     /*  221655 */     GIR_EraseRootFromParent_Done,
     /*  221656 */   // Label 4398: @221656
     /*  221656 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221730), // Rule ID 5474 //
     /*  221661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221701 */     // MIs[1] Operand 1
     /*  221701 */     // No operand predicates
     /*  221701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221728 */     GIR_RootConstrainSelectedInstOperands,
     /*  221729 */     // GIR_Coverage, 5474,
     /*  221729 */     GIR_EraseRootFromParent_Done,
     /*  221730 */   // Label 4399: @221730
     /*  221730 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221804), // Rule ID 5475 //
     /*  221735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221775 */     // MIs[1] Operand 1
     /*  221775 */     // No operand predicates
     /*  221775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  221787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221802 */     GIR_RootConstrainSelectedInstOperands,
     /*  221803 */     // GIR_Coverage, 5475,
     /*  221803 */     GIR_EraseRootFromParent_Done,
     /*  221804 */   // Label 4400: @221804
     /*  221804 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(221878), // Rule ID 5476 //
     /*  221809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221849 */     // MIs[1] Operand 1
     /*  221849 */     // No operand predicates
     /*  221849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221858 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  221861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221876 */     GIR_RootConstrainSelectedInstOperands,
     /*  221877 */     // GIR_Coverage, 5476,
     /*  221877 */     GIR_EraseRootFromParent_Done,
     /*  221878 */   // Label 4401: @221878
     /*  221878 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(221952), // Rule ID 5477 //
     /*  221883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221923 */     // MIs[1] Operand 1
     /*  221923 */     // No operand predicates
     /*  221923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  221935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221950 */     GIR_RootConstrainSelectedInstOperands,
     /*  221951 */     // GIR_Coverage, 5477,
     /*  221951 */     GIR_EraseRootFromParent_Done,
     /*  221952 */   // Label 4402: @221952
     /*  221952 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222026), // Rule ID 5478 //
     /*  221957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  221965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221997 */     // MIs[1] Operand 1
     /*  221997 */     // No operand predicates
     /*  221997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222024 */     GIR_RootConstrainSelectedInstOperands,
     /*  222025 */     // GIR_Coverage, 5478,
     /*  222025 */     GIR_EraseRootFromParent_Done,
     /*  222026 */   // Label 4403: @222026
     /*  222026 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222100), // Rule ID 5479 //
     /*  222031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  222045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222071 */     // MIs[1] Operand 1
     /*  222071 */     // No operand predicates
     /*  222071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222098 */     GIR_RootConstrainSelectedInstOperands,
     /*  222099 */     // GIR_Coverage, 5479,
     /*  222099 */     GIR_EraseRootFromParent_Done,
     /*  222100 */   // Label 4404: @222100
     /*  222100 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222174), // Rule ID 5480 //
     /*  222105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222145 */     // MIs[1] Operand 1
     /*  222145 */     // No operand predicates
     /*  222145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222154 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222172 */     GIR_RootConstrainSelectedInstOperands,
     /*  222173 */     // GIR_Coverage, 5480,
     /*  222173 */     GIR_EraseRootFromParent_Done,
     /*  222174 */   // Label 4405: @222174
     /*  222174 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222248), // Rule ID 5481 //
     /*  222179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  222190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  222193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222219 */     // MIs[1] Operand 1
     /*  222219 */     // No operand predicates
     /*  222219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222228 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222246 */     GIR_RootConstrainSelectedInstOperands,
     /*  222247 */     // GIR_Coverage, 5481,
     /*  222247 */     GIR_EraseRootFromParent_Done,
     /*  222248 */   // Label 4406: @222248
     /*  222248 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222322), // Rule ID 5482 //
     /*  222253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222293 */     // MIs[1] Operand 1
     /*  222293 */     // No operand predicates
     /*  222293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222320 */     GIR_RootConstrainSelectedInstOperands,
     /*  222321 */     // GIR_Coverage, 5482,
     /*  222321 */     GIR_EraseRootFromParent_Done,
     /*  222322 */   // Label 4407: @222322
     /*  222322 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222396), // Rule ID 5483 //
     /*  222327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  222341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222367 */     // MIs[1] Operand 1
     /*  222367 */     // No operand predicates
     /*  222367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222394 */     GIR_RootConstrainSelectedInstOperands,
     /*  222395 */     // GIR_Coverage, 5483,
     /*  222395 */     GIR_EraseRootFromParent_Done,
     /*  222396 */   // Label 4408: @222396
     /*  222396 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(222470), // Rule ID 5484 //
     /*  222401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222441 */     // MIs[1] Operand 1
     /*  222441 */     // No operand predicates
     /*  222441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222468 */     GIR_RootConstrainSelectedInstOperands,
     /*  222469 */     // GIR_Coverage, 5484,
     /*  222469 */     GIR_EraseRootFromParent_Done,
     /*  222470 */   // Label 4409: @222470
     /*  222470 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(222544), // Rule ID 5485 //
     /*  222475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  222489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222515 */     // MIs[1] Operand 1
     /*  222515 */     // No operand predicates
     /*  222515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222542 */     GIR_RootConstrainSelectedInstOperands,
     /*  222543 */     // GIR_Coverage, 5485,
     /*  222543 */     GIR_EraseRootFromParent_Done,
     /*  222544 */   // Label 4410: @222544
     /*  222544 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(222618), // Rule ID 5486 //
     /*  222549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222589 */     // MIs[1] Operand 1
     /*  222589 */     // No operand predicates
     /*  222589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222616 */     GIR_RootConstrainSelectedInstOperands,
     /*  222617 */     // GIR_Coverage, 5486,
     /*  222617 */     GIR_EraseRootFromParent_Done,
     /*  222618 */   // Label 4411: @222618
     /*  222618 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(222692), // Rule ID 5487 //
     /*  222623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222663 */     // MIs[1] Operand 1
     /*  222663 */     // No operand predicates
     /*  222663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  222675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222690 */     GIR_RootConstrainSelectedInstOperands,
     /*  222691 */     // GIR_Coverage, 5487,
     /*  222691 */     GIR_EraseRootFromParent_Done,
     /*  222692 */   // Label 4412: @222692
     /*  222692 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(222766), // Rule ID 5488 //
     /*  222697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222737 */     // MIs[1] Operand 1
     /*  222737 */     // No operand predicates
     /*  222737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222746 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222764 */     GIR_RootConstrainSelectedInstOperands,
     /*  222765 */     // GIR_Coverage, 5488,
     /*  222765 */     GIR_EraseRootFromParent_Done,
     /*  222766 */   // Label 4413: @222766
     /*  222766 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(222840), // Rule ID 5489 //
     /*  222771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222811 */     // MIs[1] Operand 1
     /*  222811 */     // No operand predicates
     /*  222811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222820 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  222823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222838 */     GIR_RootConstrainSelectedInstOperands,
     /*  222839 */     // GIR_Coverage, 5489,
     /*  222839 */     GIR_EraseRootFromParent_Done,
     /*  222840 */   // Label 4414: @222840
     /*  222840 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(222914), // Rule ID 5490 //
     /*  222845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222885 */     // MIs[1] Operand 1
     /*  222885 */     // No operand predicates
     /*  222885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222912 */     GIR_RootConstrainSelectedInstOperands,
     /*  222913 */     // GIR_Coverage, 5490,
     /*  222913 */     GIR_EraseRootFromParent_Done,
     /*  222914 */   // Label 4415: @222914
     /*  222914 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(222988), // Rule ID 5491 //
     /*  222919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  222927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222959 */     // MIs[1] Operand 1
     /*  222959 */     // No operand predicates
     /*  222959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  222971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222986 */     GIR_RootConstrainSelectedInstOperands,
     /*  222987 */     // GIR_Coverage, 5491,
     /*  222987 */     GIR_EraseRootFromParent_Done,
     /*  222988 */   // Label 4416: @222988
     /*  222988 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223062), // Rule ID 5492 //
     /*  222993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  223007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223033 */     // MIs[1] Operand 1
     /*  223033 */     // No operand predicates
     /*  223033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223060 */     GIR_RootConstrainSelectedInstOperands,
     /*  223061 */     // GIR_Coverage, 5492,
     /*  223061 */     GIR_EraseRootFromParent_Done,
     /*  223062 */   // Label 4417: @223062
     /*  223062 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223136), // Rule ID 5493 //
     /*  223067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  223081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223107 */     // MIs[1] Operand 1
     /*  223107 */     // No operand predicates
     /*  223107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223134 */     GIR_RootConstrainSelectedInstOperands,
     /*  223135 */     // GIR_Coverage, 5493,
     /*  223135 */     GIR_EraseRootFromParent_Done,
     /*  223136 */   // Label 4418: @223136
     /*  223136 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223210), // Rule ID 5494 //
     /*  223141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223181 */     // MIs[1] Operand 1
     /*  223181 */     // No operand predicates
     /*  223181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  223193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223208 */     GIR_RootConstrainSelectedInstOperands,
     /*  223209 */     // GIR_Coverage, 5494,
     /*  223209 */     GIR_EraseRootFromParent_Done,
     /*  223210 */   // Label 4419: @223210
     /*  223210 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223284), // Rule ID 5495 //
     /*  223215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  223229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223255 */     // MIs[1] Operand 1
     /*  223255 */     // No operand predicates
     /*  223255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  223267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223282 */     GIR_RootConstrainSelectedInstOperands,
     /*  223283 */     // GIR_Coverage, 5495,
     /*  223283 */     GIR_EraseRootFromParent_Done,
     /*  223284 */   // Label 4420: @223284
     /*  223284 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223358), // Rule ID 5496 //
     /*  223289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223329 */     // MIs[1] Operand 1
     /*  223329 */     // No operand predicates
     /*  223329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  223341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223356 */     GIR_RootConstrainSelectedInstOperands,
     /*  223357 */     // GIR_Coverage, 5496,
     /*  223357 */     GIR_EraseRootFromParent_Done,
     /*  223358 */   // Label 4421: @223358
     /*  223358 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223432), // Rule ID 5497 //
     /*  223363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  223377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  223391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223403 */     // MIs[1] Operand 1
     /*  223403 */     // No operand predicates
     /*  223403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  223415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223430 */     GIR_RootConstrainSelectedInstOperands,
     /*  223431 */     // GIR_Coverage, 5497,
     /*  223431 */     GIR_EraseRootFromParent_Done,
     /*  223432 */   // Label 4422: @223432
     /*  223432 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223506), // Rule ID 5498 //
     /*  223437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223477 */     // MIs[1] Operand 1
     /*  223477 */     // No operand predicates
     /*  223477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223504 */     GIR_RootConstrainSelectedInstOperands,
     /*  223505 */     // GIR_Coverage, 5498,
     /*  223505 */     GIR_EraseRootFromParent_Done,
     /*  223506 */   // Label 4423: @223506
     /*  223506 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223580), // Rule ID 5499 //
     /*  223511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  223519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  223525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  223539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223551 */     // MIs[1] Operand 1
     /*  223551 */     // No operand predicates
     /*  223551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  223563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223578 */     GIR_RootConstrainSelectedInstOperands,
     /*  223579 */     // GIR_Coverage, 5499,
     /*  223579 */     GIR_EraseRootFromParent_Done,
     /*  223580 */   // Label 4424: @223580
     /*  223580 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223654), // Rule ID 7968 //
     /*  223585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223625 */     // MIs[1] Operand 1
     /*  223625 */     // No operand predicates
     /*  223625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  223637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223652 */     GIR_RootConstrainSelectedInstOperands,
     /*  223653 */     // GIR_Coverage, 7968,
     /*  223653 */     GIR_EraseRootFromParent_Done,
     /*  223654 */   // Label 4425: @223654
     /*  223654 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223728), // Rule ID 7969 //
     /*  223659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223699 */     // MIs[1] Operand 1
     /*  223699 */     // No operand predicates
     /*  223699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  223711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223726 */     GIR_RootConstrainSelectedInstOperands,
     /*  223727 */     // GIR_Coverage, 7969,
     /*  223727 */     GIR_EraseRootFromParent_Done,
     /*  223728 */   // Label 4426: @223728
     /*  223728 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223802), // Rule ID 7972 //
     /*  223733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223773 */     // MIs[1] Operand 1
     /*  223773 */     // No operand predicates
     /*  223773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  223785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223800 */     GIR_RootConstrainSelectedInstOperands,
     /*  223801 */     // GIR_Coverage, 7972,
     /*  223801 */     GIR_EraseRootFromParent_Done,
     /*  223802 */   // Label 4427: @223802
     /*  223802 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223876), // Rule ID 7973 //
     /*  223807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223847 */     // MIs[1] Operand 1
     /*  223847 */     // No operand predicates
     /*  223847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  223859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223874 */     GIR_RootConstrainSelectedInstOperands,
     /*  223875 */     // GIR_Coverage, 7973,
     /*  223875 */     GIR_EraseRootFromParent_Done,
     /*  223876 */   // Label 4428: @223876
     /*  223876 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(223950), // Rule ID 7976 //
     /*  223881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223921 */     // MIs[1] Operand 1
     /*  223921 */     // No operand predicates
     /*  223921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  223933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223948 */     GIR_RootConstrainSelectedInstOperands,
     /*  223949 */     // GIR_Coverage, 7976,
     /*  223949 */     GIR_EraseRootFromParent_Done,
     /*  223950 */   // Label 4429: @223950
     /*  223950 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224024), // Rule ID 7977 //
     /*  223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223995 */     // MIs[1] Operand 1
     /*  223995 */     // No operand predicates
     /*  223995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224022 */     GIR_RootConstrainSelectedInstOperands,
     /*  224023 */     // GIR_Coverage, 7977,
     /*  224023 */     GIR_EraseRootFromParent_Done,
     /*  224024 */   // Label 4430: @224024
     /*  224024 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224098), // Rule ID 7980 //
     /*  224029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224069 */     // MIs[1] Operand 1
     /*  224069 */     // No operand predicates
     /*  224069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  224081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224096 */     GIR_RootConstrainSelectedInstOperands,
     /*  224097 */     // GIR_Coverage, 7980,
     /*  224097 */     GIR_EraseRootFromParent_Done,
     /*  224098 */   // Label 4431: @224098
     /*  224098 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224172), // Rule ID 7981 //
     /*  224103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  224117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224143 */     // MIs[1] Operand 1
     /*  224143 */     // No operand predicates
     /*  224143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  224155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224170 */     GIR_RootConstrainSelectedInstOperands,
     /*  224171 */     // GIR_Coverage, 7981,
     /*  224171 */     GIR_EraseRootFromParent_Done,
     /*  224172 */   // Label 4432: @224172
     /*  224172 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224246), // Rule ID 7984 //
     /*  224177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224217 */     // MIs[1] Operand 1
     /*  224217 */     // No operand predicates
     /*  224217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224244 */     GIR_RootConstrainSelectedInstOperands,
     /*  224245 */     // GIR_Coverage, 7984,
     /*  224245 */     GIR_EraseRootFromParent_Done,
     /*  224246 */   // Label 4433: @224246
     /*  224246 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224320), // Rule ID 7985 //
     /*  224251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  224265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224291 */     // MIs[1] Operand 1
     /*  224291 */     // No operand predicates
     /*  224291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224318 */     GIR_RootConstrainSelectedInstOperands,
     /*  224319 */     // GIR_Coverage, 7985,
     /*  224319 */     GIR_EraseRootFromParent_Done,
     /*  224320 */   // Label 4434: @224320
     /*  224320 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224394), // Rule ID 7988 //
     /*  224325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224365 */     // MIs[1] Operand 1
     /*  224365 */     // No operand predicates
     /*  224365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224392 */     GIR_RootConstrainSelectedInstOperands,
     /*  224393 */     // GIR_Coverage, 7988,
     /*  224393 */     GIR_EraseRootFromParent_Done,
     /*  224394 */   // Label 4435: @224394
     /*  224394 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224468), // Rule ID 7989 //
     /*  224399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  224413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224439 */     // MIs[1] Operand 1
     /*  224439 */     // No operand predicates
     /*  224439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  224451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224466 */     GIR_RootConstrainSelectedInstOperands,
     /*  224467 */     // GIR_Coverage, 7989,
     /*  224467 */     GIR_EraseRootFromParent_Done,
     /*  224468 */   // Label 4436: @224468
     /*  224468 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224542), // Rule ID 7992 //
     /*  224473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224513 */     // MIs[1] Operand 1
     /*  224513 */     // No operand predicates
     /*  224513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224522 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224540 */     GIR_RootConstrainSelectedInstOperands,
     /*  224541 */     // GIR_Coverage, 7992,
     /*  224541 */     GIR_EraseRootFromParent_Done,
     /*  224542 */   // Label 4437: @224542
     /*  224542 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224616), // Rule ID 7993 //
     /*  224547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  224561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224587 */     // MIs[1] Operand 1
     /*  224587 */     // No operand predicates
     /*  224587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224614 */     GIR_RootConstrainSelectedInstOperands,
     /*  224615 */     // GIR_Coverage, 7993,
     /*  224615 */     GIR_EraseRootFromParent_Done,
     /*  224616 */   // Label 4438: @224616
     /*  224616 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224690), // Rule ID 7996 //
     /*  224621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224661 */     // MIs[1] Operand 1
     /*  224661 */     // No operand predicates
     /*  224661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224688 */     GIR_RootConstrainSelectedInstOperands,
     /*  224689 */     // GIR_Coverage, 7996,
     /*  224689 */     GIR_EraseRootFromParent_Done,
     /*  224690 */   // Label 4439: @224690
     /*  224690 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224764), // Rule ID 7997 //
     /*  224695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224735 */     // MIs[1] Operand 1
     /*  224735 */     // No operand predicates
     /*  224735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224762 */     GIR_RootConstrainSelectedInstOperands,
     /*  224763 */     // GIR_Coverage, 7997,
     /*  224763 */     GIR_EraseRootFromParent_Done,
     /*  224764 */   // Label 4440: @224764
     /*  224764 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224838), // Rule ID 8000 //
     /*  224769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224809 */     // MIs[1] Operand 1
     /*  224809 */     // No operand predicates
     /*  224809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224818 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224836 */     GIR_RootConstrainSelectedInstOperands,
     /*  224837 */     // GIR_Coverage, 8000,
     /*  224837 */     GIR_EraseRootFromParent_Done,
     /*  224838 */   // Label 4441: @224838
     /*  224838 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224912), // Rule ID 8001 //
     /*  224843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224883 */     // MIs[1] Operand 1
     /*  224883 */     // No operand predicates
     /*  224883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224910 */     GIR_RootConstrainSelectedInstOperands,
     /*  224911 */     // GIR_Coverage, 8001,
     /*  224911 */     GIR_EraseRootFromParent_Done,
     /*  224912 */   // Label 4442: @224912
     /*  224912 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224986), // Rule ID 8004 //
     /*  224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224957 */     // MIs[1] Operand 1
     /*  224957 */     // No operand predicates
     /*  224957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224966 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  224969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224984 */     GIR_RootConstrainSelectedInstOperands,
     /*  224985 */     // GIR_Coverage, 8004,
     /*  224985 */     GIR_EraseRootFromParent_Done,
     /*  224986 */   // Label 4443: @224986
     /*  224986 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(225060), // Rule ID 8005 //
     /*  224991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  224999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  225005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225031 */     // MIs[1] Operand 1
     /*  225031 */     // No operand predicates
     /*  225031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  225043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225058 */     GIR_RootConstrainSelectedInstOperands,
     /*  225059 */     // GIR_Coverage, 8005,
     /*  225059 */     GIR_EraseRootFromParent_Done,
     /*  225060 */   // Label 4444: @225060
     /*  225060 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(225134), // Rule ID 8008 //
     /*  225065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225105 */     // MIs[1] Operand 1
     /*  225105 */     // No operand predicates
     /*  225105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225132 */     GIR_RootConstrainSelectedInstOperands,
     /*  225133 */     // GIR_Coverage, 8008,
     /*  225133 */     GIR_EraseRootFromParent_Done,
     /*  225134 */   // Label 4445: @225134
     /*  225134 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(225208), // Rule ID 8009 //
     /*  225139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  225153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225179 */     // MIs[1] Operand 1
     /*  225179 */     // No operand predicates
     /*  225179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225206 */     GIR_RootConstrainSelectedInstOperands,
     /*  225207 */     // GIR_Coverage, 8009,
     /*  225207 */     GIR_EraseRootFromParent_Done,
     /*  225208 */   // Label 4446: @225208
     /*  225208 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(225282), // Rule ID 8012 //
     /*  225213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225253 */     // MIs[1] Operand 1
     /*  225253 */     // No operand predicates
     /*  225253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225262 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225280 */     GIR_RootConstrainSelectedInstOperands,
     /*  225281 */     // GIR_Coverage, 8012,
     /*  225281 */     GIR_EraseRootFromParent_Done,
     /*  225282 */   // Label 4447: @225282
     /*  225282 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(225356), // Rule ID 8013 //
     /*  225287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  225301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225327 */     // MIs[1] Operand 1
     /*  225327 */     // No operand predicates
     /*  225327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225336 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225354 */     GIR_RootConstrainSelectedInstOperands,
     /*  225355 */     // GIR_Coverage, 8013,
     /*  225355 */     GIR_EraseRootFromParent_Done,
     /*  225356 */   // Label 4448: @225356
     /*  225356 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225430), // Rule ID 8016 //
     /*  225361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225401 */     // MIs[1] Operand 1
     /*  225401 */     // No operand predicates
     /*  225401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225410 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225428 */     GIR_RootConstrainSelectedInstOperands,
     /*  225429 */     // GIR_Coverage, 8016,
     /*  225429 */     GIR_EraseRootFromParent_Done,
     /*  225430 */   // Label 4449: @225430
     /*  225430 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225504), // Rule ID 8017 //
     /*  225435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  225446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  225449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225475 */     // MIs[1] Operand 1
     /*  225475 */     // No operand predicates
     /*  225475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225484 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225502 */     GIR_RootConstrainSelectedInstOperands,
     /*  225503 */     // GIR_Coverage, 8017,
     /*  225503 */     GIR_EraseRootFromParent_Done,
     /*  225504 */   // Label 4450: @225504
     /*  225504 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225578), // Rule ID 8020 //
     /*  225509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225549 */     // MIs[1] Operand 1
     /*  225549 */     // No operand predicates
     /*  225549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225576 */     GIR_RootConstrainSelectedInstOperands,
     /*  225577 */     // GIR_Coverage, 8020,
     /*  225577 */     GIR_EraseRootFromParent_Done,
     /*  225578 */   // Label 4451: @225578
     /*  225578 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225652), // Rule ID 8021 //
     /*  225583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225623 */     // MIs[1] Operand 1
     /*  225623 */     // No operand predicates
     /*  225623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  225635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225650 */     GIR_RootConstrainSelectedInstOperands,
     /*  225651 */     // GIR_Coverage, 8021,
     /*  225651 */     GIR_EraseRootFromParent_Done,
     /*  225652 */   // Label 4452: @225652
     /*  225652 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225726), // Rule ID 8024 //
     /*  225657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225697 */     // MIs[1] Operand 1
     /*  225697 */     // No operand predicates
     /*  225697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225724 */     GIR_RootConstrainSelectedInstOperands,
     /*  225725 */     // GIR_Coverage, 8024,
     /*  225725 */     GIR_EraseRootFromParent_Done,
     /*  225726 */   // Label 4453: @225726
     /*  225726 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225800), // Rule ID 8025 //
     /*  225731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225771 */     // MIs[1] Operand 1
     /*  225771 */     // No operand predicates
     /*  225771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  225783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225798 */     GIR_RootConstrainSelectedInstOperands,
     /*  225799 */     // GIR_Coverage, 8025,
     /*  225799 */     GIR_EraseRootFromParent_Done,
     /*  225800 */   // Label 4454: @225800
     /*  225800 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225874), // Rule ID 8028 //
     /*  225805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225845 */     // MIs[1] Operand 1
     /*  225845 */     // No operand predicates
     /*  225845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225872 */     GIR_RootConstrainSelectedInstOperands,
     /*  225873 */     // GIR_Coverage, 8028,
     /*  225873 */     GIR_EraseRootFromParent_Done,
     /*  225874 */   // Label 4455: @225874
     /*  225874 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225948), // Rule ID 8029 //
     /*  225879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225919 */     // MIs[1] Operand 1
     /*  225919 */     // No operand predicates
     /*  225919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  225931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225946 */     GIR_RootConstrainSelectedInstOperands,
     /*  225947 */     // GIR_Coverage, 8029,
     /*  225947 */     GIR_EraseRootFromParent_Done,
     /*  225948 */   // Label 4456: @225948
     /*  225948 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(226022), // Rule ID 8032 //
     /*  225953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  225961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225993 */     // MIs[1] Operand 1
     /*  225993 */     // No operand predicates
     /*  225993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226020 */     GIR_RootConstrainSelectedInstOperands,
     /*  226021 */     // GIR_Coverage, 8032,
     /*  226021 */     GIR_EraseRootFromParent_Done,
     /*  226022 */   // Label 4457: @226022
     /*  226022 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(226096), // Rule ID 8033 //
     /*  226027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  226041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226067 */     // MIs[1] Operand 1
     /*  226067 */     // No operand predicates
     /*  226067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226094 */     GIR_RootConstrainSelectedInstOperands,
     /*  226095 */     // GIR_Coverage, 8033,
     /*  226095 */     GIR_EraseRootFromParent_Done,
     /*  226096 */   // Label 4458: @226096
     /*  226096 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(226170), // Rule ID 8036 //
     /*  226101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226141 */     // MIs[1] Operand 1
     /*  226141 */     // No operand predicates
     /*  226141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226150 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226168 */     GIR_RootConstrainSelectedInstOperands,
     /*  226169 */     // GIR_Coverage, 8036,
     /*  226169 */     GIR_EraseRootFromParent_Done,
     /*  226170 */   // Label 4459: @226170
     /*  226170 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(226244), // Rule ID 8037 //
     /*  226175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  226189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226215 */     // MIs[1] Operand 1
     /*  226215 */     // No operand predicates
     /*  226215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226242 */     GIR_RootConstrainSelectedInstOperands,
     /*  226243 */     // GIR_Coverage, 8037,
     /*  226243 */     GIR_EraseRootFromParent_Done,
     /*  226244 */   // Label 4460: @226244
     /*  226244 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(226318), // Rule ID 8040 //
     /*  226249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226289 */     // MIs[1] Operand 1
     /*  226289 */     // No operand predicates
     /*  226289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226316 */     GIR_RootConstrainSelectedInstOperands,
     /*  226317 */     // GIR_Coverage, 8040,
     /*  226317 */     GIR_EraseRootFromParent_Done,
     /*  226318 */   // Label 4461: @226318
     /*  226318 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(226392), // Rule ID 8041 //
     /*  226323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  226334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  226337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226363 */     // MIs[1] Operand 1
     /*  226363 */     // No operand predicates
     /*  226363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226390 */     GIR_RootConstrainSelectedInstOperands,
     /*  226391 */     // GIR_Coverage, 8041,
     /*  226391 */     GIR_EraseRootFromParent_Done,
     /*  226392 */   // Label 4462: @226392
     /*  226392 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(226466), // Rule ID 8044 //
     /*  226397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226437 */     // MIs[1] Operand 1
     /*  226437 */     // No operand predicates
     /*  226437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226464 */     GIR_RootConstrainSelectedInstOperands,
     /*  226465 */     // GIR_Coverage, 8044,
     /*  226465 */     GIR_EraseRootFromParent_Done,
     /*  226466 */   // Label 4463: @226466
     /*  226466 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(226540), // Rule ID 8045 //
     /*  226471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  226485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  226499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226511 */     // MIs[1] Operand 1
     /*  226511 */     // No operand predicates
     /*  226511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  226523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226538 */     GIR_RootConstrainSelectedInstOperands,
     /*  226539 */     // GIR_Coverage, 8045,
     /*  226539 */     GIR_EraseRootFromParent_Done,
     /*  226540 */   // Label 4464: @226540
     /*  226540 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(226614), // Rule ID 8048 //
     /*  226545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226585 */     // MIs[1] Operand 1
     /*  226585 */     // No operand predicates
     /*  226585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226612 */     GIR_RootConstrainSelectedInstOperands,
     /*  226613 */     // GIR_Coverage, 8048,
     /*  226613 */     GIR_EraseRootFromParent_Done,
     /*  226614 */   // Label 4465: @226614
     /*  226614 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(226688), // Rule ID 8049 //
     /*  226619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226659 */     // MIs[1] Operand 1
     /*  226659 */     // No operand predicates
     /*  226659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  226671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226686 */     GIR_RootConstrainSelectedInstOperands,
     /*  226687 */     // GIR_Coverage, 8049,
     /*  226687 */     GIR_EraseRootFromParent_Done,
     /*  226688 */   // Label 4466: @226688
     /*  226688 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(226762), // Rule ID 8052 //
     /*  226693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226733 */     // MIs[1] Operand 1
     /*  226733 */     // No operand predicates
     /*  226733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226760 */     GIR_RootConstrainSelectedInstOperands,
     /*  226761 */     // GIR_Coverage, 8052,
     /*  226761 */     GIR_EraseRootFromParent_Done,
     /*  226762 */   // Label 4467: @226762
     /*  226762 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(226836), // Rule ID 8053 //
     /*  226767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  226775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226807 */     // MIs[1] Operand 1
     /*  226807 */     // No operand predicates
     /*  226807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  226819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226834 */     GIR_RootConstrainSelectedInstOperands,
     /*  226835 */     // GIR_Coverage, 8053,
     /*  226835 */     GIR_EraseRootFromParent_Done,
     /*  226836 */   // Label 4468: @226836
     /*  226836 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(226910), // Rule ID 8232 //
     /*  226841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226881 */     // MIs[1] Operand 1
     /*  226881 */     // No operand predicates
     /*  226881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  226893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226908 */     GIR_RootConstrainSelectedInstOperands,
     /*  226909 */     // GIR_Coverage, 8232,
     /*  226909 */     GIR_EraseRootFromParent_Done,
     /*  226910 */   // Label 4469: @226910
     /*  226910 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(226984), // Rule ID 8233 //
     /*  226915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226955 */     // MIs[1] Operand 1
     /*  226955 */     // No operand predicates
     /*  226955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  226967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226982 */     GIR_RootConstrainSelectedInstOperands,
     /*  226983 */     // GIR_Coverage, 8233,
     /*  226983 */     GIR_EraseRootFromParent_Done,
     /*  226984 */   // Label 4470: @226984
     /*  226984 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(227058), // Rule ID 8236 //
     /*  226989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  227003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227029 */     // MIs[1] Operand 1
     /*  227029 */     // No operand predicates
     /*  227029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227056 */     GIR_RootConstrainSelectedInstOperands,
     /*  227057 */     // GIR_Coverage, 8236,
     /*  227057 */     GIR_EraseRootFromParent_Done,
     /*  227058 */   // Label 4471: @227058
     /*  227058 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(227132), // Rule ID 8237 //
     /*  227063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  227077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227103 */     // MIs[1] Operand 1
     /*  227103 */     // No operand predicates
     /*  227103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227130 */     GIR_RootConstrainSelectedInstOperands,
     /*  227131 */     // GIR_Coverage, 8237,
     /*  227131 */     GIR_EraseRootFromParent_Done,
     /*  227132 */   // Label 4472: @227132
     /*  227132 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(227206), // Rule ID 8240 //
     /*  227137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227177 */     // MIs[1] Operand 1
     /*  227177 */     // No operand predicates
     /*  227177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227204 */     GIR_RootConstrainSelectedInstOperands,
     /*  227205 */     // GIR_Coverage, 8240,
     /*  227205 */     GIR_EraseRootFromParent_Done,
     /*  227206 */   // Label 4473: @227206
     /*  227206 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(227280), // Rule ID 8241 //
     /*  227211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  227225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227251 */     // MIs[1] Operand 1
     /*  227251 */     // No operand predicates
     /*  227251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227278 */     GIR_RootConstrainSelectedInstOperands,
     /*  227279 */     // GIR_Coverage, 8241,
     /*  227279 */     GIR_EraseRootFromParent_Done,
     /*  227280 */   // Label 4474: @227280
     /*  227280 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(227354), // Rule ID 8244 //
     /*  227285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227325 */     // MIs[1] Operand 1
     /*  227325 */     // No operand predicates
     /*  227325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227334 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227352 */     GIR_RootConstrainSelectedInstOperands,
     /*  227353 */     // GIR_Coverage, 8244,
     /*  227353 */     GIR_EraseRootFromParent_Done,
     /*  227354 */   // Label 4475: @227354
     /*  227354 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(227428), // Rule ID 8245 //
     /*  227359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  227373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227399 */     // MIs[1] Operand 1
     /*  227399 */     // No operand predicates
     /*  227399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  227411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227426 */     GIR_RootConstrainSelectedInstOperands,
     /*  227427 */     // GIR_Coverage, 8245,
     /*  227427 */     GIR_EraseRootFromParent_Done,
     /*  227428 */   // Label 4476: @227428
     /*  227428 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(227502), // Rule ID 8248 //
     /*  227433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227473 */     // MIs[1] Operand 1
     /*  227473 */     // No operand predicates
     /*  227473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227500 */     GIR_RootConstrainSelectedInstOperands,
     /*  227501 */     // GIR_Coverage, 8248,
     /*  227501 */     GIR_EraseRootFromParent_Done,
     /*  227502 */   // Label 4477: @227502
     /*  227502 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(227576), // Rule ID 8249 //
     /*  227507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  227521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227547 */     // MIs[1] Operand 1
     /*  227547 */     // No operand predicates
     /*  227547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227574 */     GIR_RootConstrainSelectedInstOperands,
     /*  227575 */     // GIR_Coverage, 8249,
     /*  227575 */     GIR_EraseRootFromParent_Done,
     /*  227576 */   // Label 4478: @227576
     /*  227576 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(227650), // Rule ID 8252 //
     /*  227581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227621 */     // MIs[1] Operand 1
     /*  227621 */     // No operand predicates
     /*  227621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227648 */     GIR_RootConstrainSelectedInstOperands,
     /*  227649 */     // GIR_Coverage, 8252,
     /*  227649 */     GIR_EraseRootFromParent_Done,
     /*  227650 */   // Label 4479: @227650
     /*  227650 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(227724), // Rule ID 8253 //
     /*  227655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227695 */     // MIs[1] Operand 1
     /*  227695 */     // No operand predicates
     /*  227695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  227707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227722 */     GIR_RootConstrainSelectedInstOperands,
     /*  227723 */     // GIR_Coverage, 8253,
     /*  227723 */     GIR_EraseRootFromParent_Done,
     /*  227724 */   // Label 4480: @227724
     /*  227724 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(227798), // Rule ID 8256 //
     /*  227729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227769 */     // MIs[1] Operand 1
     /*  227769 */     // No operand predicates
     /*  227769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227796 */     GIR_RootConstrainSelectedInstOperands,
     /*  227797 */     // GIR_Coverage, 8256,
     /*  227797 */     GIR_EraseRootFromParent_Done,
     /*  227798 */   // Label 4481: @227798
     /*  227798 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(227872), // Rule ID 8257 //
     /*  227803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227843 */     // MIs[1] Operand 1
     /*  227843 */     // No operand predicates
     /*  227843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227870 */     GIR_RootConstrainSelectedInstOperands,
     /*  227871 */     // GIR_Coverage, 8257,
     /*  227871 */     GIR_EraseRootFromParent_Done,
     /*  227872 */   // Label 4482: @227872
     /*  227872 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(227946), // Rule ID 8260 //
     /*  227877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227917 */     // MIs[1] Operand 1
     /*  227917 */     // No operand predicates
     /*  227917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  227929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227944 */     GIR_RootConstrainSelectedInstOperands,
     /*  227945 */     // GIR_Coverage, 8260,
     /*  227945 */     GIR_EraseRootFromParent_Done,
     /*  227946 */   // Label 4483: @227946
     /*  227946 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(228020), // Rule ID 8261 //
     /*  227951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  227959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227991 */     // MIs[1] Operand 1
     /*  227991 */     // No operand predicates
     /*  227991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228018 */     GIR_RootConstrainSelectedInstOperands,
     /*  228019 */     // GIR_Coverage, 8261,
     /*  228019 */     GIR_EraseRootFromParent_Done,
     /*  228020 */   // Label 4484: @228020
     /*  228020 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(228094), // Rule ID 8264 //
     /*  228025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228065 */     // MIs[1] Operand 1
     /*  228065 */     // No operand predicates
     /*  228065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228092 */     GIR_RootConstrainSelectedInstOperands,
     /*  228093 */     // GIR_Coverage, 8264,
     /*  228093 */     GIR_EraseRootFromParent_Done,
     /*  228094 */   // Label 4485: @228094
     /*  228094 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(228168), // Rule ID 8265 //
     /*  228099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  228113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228139 */     // MIs[1] Operand 1
     /*  228139 */     // No operand predicates
     /*  228139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228166 */     GIR_RootConstrainSelectedInstOperands,
     /*  228167 */     // GIR_Coverage, 8265,
     /*  228167 */     GIR_EraseRootFromParent_Done,
     /*  228168 */   // Label 4486: @228168
     /*  228168 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(228242), // Rule ID 8268 //
     /*  228173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228213 */     // MIs[1] Operand 1
     /*  228213 */     // No operand predicates
     /*  228213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228240 */     GIR_RootConstrainSelectedInstOperands,
     /*  228241 */     // GIR_Coverage, 8268,
     /*  228241 */     GIR_EraseRootFromParent_Done,
     /*  228242 */   // Label 4487: @228242
     /*  228242 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(228316), // Rule ID 8269 //
     /*  228247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  228258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  228261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228287 */     // MIs[1] Operand 1
     /*  228287 */     // No operand predicates
     /*  228287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228296 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  228299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228314 */     GIR_RootConstrainSelectedInstOperands,
     /*  228315 */     // GIR_Coverage, 8269,
     /*  228315 */     GIR_EraseRootFromParent_Done,
     /*  228316 */   // Label 4488: @228316
     /*  228316 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(228390), // Rule ID 8272 //
     /*  228321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228361 */     // MIs[1] Operand 1
     /*  228361 */     // No operand predicates
     /*  228361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228388 */     GIR_RootConstrainSelectedInstOperands,
     /*  228389 */     // GIR_Coverage, 8272,
     /*  228389 */     GIR_EraseRootFromParent_Done,
     /*  228390 */   // Label 4489: @228390
     /*  228390 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(228464), // Rule ID 8273 //
     /*  228395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  228409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228435 */     // MIs[1] Operand 1
     /*  228435 */     // No operand predicates
     /*  228435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228462 */     GIR_RootConstrainSelectedInstOperands,
     /*  228463 */     // GIR_Coverage, 8273,
     /*  228463 */     GIR_EraseRootFromParent_Done,
     /*  228464 */   // Label 4490: @228464
     /*  228464 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(228538), // Rule ID 8276 //
     /*  228469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228509 */     // MIs[1] Operand 1
     /*  228509 */     // No operand predicates
     /*  228509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228536 */     GIR_RootConstrainSelectedInstOperands,
     /*  228537 */     // GIR_Coverage, 8276,
     /*  228537 */     GIR_EraseRootFromParent_Done,
     /*  228538 */   // Label 4491: @228538
     /*  228538 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(228612), // Rule ID 8277 //
     /*  228543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  228557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228583 */     // MIs[1] Operand 1
     /*  228583 */     // No operand predicates
     /*  228583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228592 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228610 */     GIR_RootConstrainSelectedInstOperands,
     /*  228611 */     // GIR_Coverage, 8277,
     /*  228611 */     GIR_EraseRootFromParent_Done,
     /*  228612 */   // Label 4492: @228612
     /*  228612 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(228686), // Rule ID 8280 //
     /*  228617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228657 */     // MIs[1] Operand 1
     /*  228657 */     // No operand predicates
     /*  228657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228666 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  228669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228684 */     GIR_RootConstrainSelectedInstOperands,
     /*  228685 */     // GIR_Coverage, 8280,
     /*  228685 */     GIR_EraseRootFromParent_Done,
     /*  228686 */   // Label 4493: @228686
     /*  228686 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(228760), // Rule ID 8281 //
     /*  228691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228731 */     // MIs[1] Operand 1
     /*  228731 */     // No operand predicates
     /*  228731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228740 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  228743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228758 */     GIR_RootConstrainSelectedInstOperands,
     /*  228759 */     // GIR_Coverage, 8281,
     /*  228759 */     GIR_EraseRootFromParent_Done,
     /*  228760 */   // Label 4494: @228760
     /*  228760 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(228834), // Rule ID 8284 //
     /*  228765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228805 */     // MIs[1] Operand 1
     /*  228805 */     // No operand predicates
     /*  228805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228814 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228832 */     GIR_RootConstrainSelectedInstOperands,
     /*  228833 */     // GIR_Coverage, 8284,
     /*  228833 */     GIR_EraseRootFromParent_Done,
     /*  228834 */   // Label 4495: @228834
     /*  228834 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(228908), // Rule ID 8285 //
     /*  228839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228879 */     // MIs[1] Operand 1
     /*  228879 */     // No operand predicates
     /*  228879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  228891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228906 */     GIR_RootConstrainSelectedInstOperands,
     /*  228907 */     // GIR_Coverage, 8285,
     /*  228907 */     GIR_EraseRootFromParent_Done,
     /*  228908 */   // Label 4496: @228908
     /*  228908 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(228982), // Rule ID 8288 //
     /*  228913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228953 */     // MIs[1] Operand 1
     /*  228953 */     // No operand predicates
     /*  228953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228962 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  228965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228980 */     GIR_RootConstrainSelectedInstOperands,
     /*  228981 */     // GIR_Coverage, 8288,
     /*  228981 */     GIR_EraseRootFromParent_Done,
     /*  228982 */   // Label 4497: @228982
     /*  228982 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(229056), // Rule ID 8289 //
     /*  228987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  228995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  229001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229027 */     // MIs[1] Operand 1
     /*  229027 */     // No operand predicates
     /*  229027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229036 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229054 */     GIR_RootConstrainSelectedInstOperands,
     /*  229055 */     // GIR_Coverage, 8289,
     /*  229055 */     GIR_EraseRootFromParent_Done,
     /*  229056 */   // Label 4498: @229056
     /*  229056 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(229130), // Rule ID 8292 //
     /*  229061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229101 */     // MIs[1] Operand 1
     /*  229101 */     // No operand predicates
     /*  229101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229128 */     GIR_RootConstrainSelectedInstOperands,
     /*  229129 */     // GIR_Coverage, 8292,
     /*  229129 */     GIR_EraseRootFromParent_Done,
     /*  229130 */   // Label 4499: @229130
     /*  229130 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(229204), // Rule ID 8293 //
     /*  229135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  229146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  229149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229175 */     // MIs[1] Operand 1
     /*  229175 */     // No operand predicates
     /*  229175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229202 */     GIR_RootConstrainSelectedInstOperands,
     /*  229203 */     // GIR_Coverage, 8293,
     /*  229203 */     GIR_EraseRootFromParent_Done,
     /*  229204 */   // Label 4500: @229204
     /*  229204 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(229278), // Rule ID 8296 //
     /*  229209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229249 */     // MIs[1] Operand 1
     /*  229249 */     // No operand predicates
     /*  229249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229276 */     GIR_RootConstrainSelectedInstOperands,
     /*  229277 */     // GIR_Coverage, 8296,
     /*  229277 */     GIR_EraseRootFromParent_Done,
     /*  229278 */   // Label 4501: @229278
     /*  229278 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(229352), // Rule ID 8297 //
     /*  229283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  229297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229323 */     // MIs[1] Operand 1
     /*  229323 */     // No operand predicates
     /*  229323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229350 */     GIR_RootConstrainSelectedInstOperands,
     /*  229351 */     // GIR_Coverage, 8297,
     /*  229351 */     GIR_EraseRootFromParent_Done,
     /*  229352 */   // Label 4502: @229352
     /*  229352 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(229426), // Rule ID 8300 //
     /*  229357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229397 */     // MIs[1] Operand 1
     /*  229397 */     // No operand predicates
     /*  229397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229424 */     GIR_RootConstrainSelectedInstOperands,
     /*  229425 */     // GIR_Coverage, 8300,
     /*  229425 */     GIR_EraseRootFromParent_Done,
     /*  229426 */   // Label 4503: @229426
     /*  229426 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(229500), // Rule ID 8301 //
     /*  229431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  229445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229471 */     // MIs[1] Operand 1
     /*  229471 */     // No operand predicates
     /*  229471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229498 */     GIR_RootConstrainSelectedInstOperands,
     /*  229499 */     // GIR_Coverage, 8301,
     /*  229499 */     GIR_EraseRootFromParent_Done,
     /*  229500 */   // Label 4504: @229500
     /*  229500 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(229574), // Rule ID 8304 //
     /*  229505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229545 */     // MIs[1] Operand 1
     /*  229545 */     // No operand predicates
     /*  229545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229572 */     GIR_RootConstrainSelectedInstOperands,
     /*  229573 */     // GIR_Coverage, 8304,
     /*  229573 */     GIR_EraseRootFromParent_Done,
     /*  229574 */   // Label 4505: @229574
     /*  229574 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(229648), // Rule ID 8305 //
     /*  229579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229619 */     // MIs[1] Operand 1
     /*  229619 */     // No operand predicates
     /*  229619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  229631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229646 */     GIR_RootConstrainSelectedInstOperands,
     /*  229647 */     // GIR_Coverage, 8305,
     /*  229647 */     GIR_EraseRootFromParent_Done,
     /*  229648 */   // Label 4506: @229648
     /*  229648 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(229722), // Rule ID 8308 //
     /*  229653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229693 */     // MIs[1] Operand 1
     /*  229693 */     // No operand predicates
     /*  229693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229720 */     GIR_RootConstrainSelectedInstOperands,
     /*  229721 */     // GIR_Coverage, 8308,
     /*  229721 */     GIR_EraseRootFromParent_Done,
     /*  229722 */   // Label 4507: @229722
     /*  229722 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(229796), // Rule ID 8309 //
     /*  229727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229767 */     // MIs[1] Operand 1
     /*  229767 */     // No operand predicates
     /*  229767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  229779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229794 */     GIR_RootConstrainSelectedInstOperands,
     /*  229795 */     // GIR_Coverage, 8309,
     /*  229795 */     GIR_EraseRootFromParent_Done,
     /*  229796 */   // Label 4508: @229796
     /*  229796 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(229870), // Rule ID 8312 //
     /*  229801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229841 */     // MIs[1] Operand 1
     /*  229841 */     // No operand predicates
     /*  229841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229868 */     GIR_RootConstrainSelectedInstOperands,
     /*  229869 */     // GIR_Coverage, 8312,
     /*  229869 */     GIR_EraseRootFromParent_Done,
     /*  229870 */   // Label 4509: @229870
     /*  229870 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(229944), // Rule ID 8313 //
     /*  229875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229915 */     // MIs[1] Operand 1
     /*  229915 */     // No operand predicates
     /*  229915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  229927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229942 */     GIR_RootConstrainSelectedInstOperands,
     /*  229943 */     // GIR_Coverage, 8313,
     /*  229943 */     GIR_EraseRootFromParent_Done,
     /*  229944 */   // Label 4510: @229944
     /*  229944 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(230018), // Rule ID 8316 //
     /*  229949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  229957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229989 */     // MIs[1] Operand 1
     /*  229989 */     // No operand predicates
     /*  229989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  230001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230016 */     GIR_RootConstrainSelectedInstOperands,
     /*  230017 */     // GIR_Coverage, 8316,
     /*  230017 */     GIR_EraseRootFromParent_Done,
     /*  230018 */   // Label 4511: @230018
     /*  230018 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(230092), // Rule ID 8317 //
     /*  230023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  230026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  230031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  230037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230063 */     // MIs[1] Operand 1
     /*  230063 */     // No operand predicates
     /*  230063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  230075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230090 */     GIR_RootConstrainSelectedInstOperands,
     /*  230091 */     // GIR_Coverage, 8317,
     /*  230091 */     GIR_EraseRootFromParent_Done,
     /*  230092 */   // Label 4512: @230092
     /*  230092 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(230166), // Rule ID 8848 //
     /*  230097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230137 */     // MIs[1] Operand 1
     /*  230137 */     // No operand predicates
     /*  230137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  230149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230164 */     GIR_RootConstrainSelectedInstOperands,
     /*  230165 */     // GIR_Coverage, 8848,
     /*  230165 */     GIR_EraseRootFromParent_Done,
     /*  230166 */   // Label 4513: @230166
     /*  230166 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(230240), // Rule ID 8849 //
     /*  230171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  230185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230211 */     // MIs[1] Operand 1
     /*  230211 */     // No operand predicates
     /*  230211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  230223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230238 */     GIR_RootConstrainSelectedInstOperands,
     /*  230239 */     // GIR_Coverage, 8849,
     /*  230239 */     GIR_EraseRootFromParent_Done,
     /*  230240 */   // Label 4514: @230240
     /*  230240 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(230314), // Rule ID 8852 //
     /*  230245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230285 */     // MIs[1] Operand 1
     /*  230285 */     // No operand predicates
     /*  230285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230294 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230312 */     GIR_RootConstrainSelectedInstOperands,
     /*  230313 */     // GIR_Coverage, 8852,
     /*  230313 */     GIR_EraseRootFromParent_Done,
     /*  230314 */   // Label 4515: @230314
     /*  230314 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(230388), // Rule ID 8853 //
     /*  230319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  230333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230359 */     // MIs[1] Operand 1
     /*  230359 */     // No operand predicates
     /*  230359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230386 */     GIR_RootConstrainSelectedInstOperands,
     /*  230387 */     // GIR_Coverage, 8853,
     /*  230387 */     GIR_EraseRootFromParent_Done,
     /*  230388 */   // Label 4516: @230388
     /*  230388 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(230462), // Rule ID 8856 //
     /*  230393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230433 */     // MIs[1] Operand 1
     /*  230433 */     // No operand predicates
     /*  230433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230460 */     GIR_RootConstrainSelectedInstOperands,
     /*  230461 */     // GIR_Coverage, 8856,
     /*  230461 */     GIR_EraseRootFromParent_Done,
     /*  230462 */   // Label 4517: @230462
     /*  230462 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(230536), // Rule ID 8857 //
     /*  230467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  230481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230507 */     // MIs[1] Operand 1
     /*  230507 */     // No operand predicates
     /*  230507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230534 */     GIR_RootConstrainSelectedInstOperands,
     /*  230535 */     // GIR_Coverage, 8857,
     /*  230535 */     GIR_EraseRootFromParent_Done,
     /*  230536 */   // Label 4518: @230536
     /*  230536 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(230610), // Rule ID 8860 //
     /*  230541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230581 */     // MIs[1] Operand 1
     /*  230581 */     // No operand predicates
     /*  230581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230608 */     GIR_RootConstrainSelectedInstOperands,
     /*  230609 */     // GIR_Coverage, 8860,
     /*  230609 */     GIR_EraseRootFromParent_Done,
     /*  230610 */   // Label 4519: @230610
     /*  230610 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(230684), // Rule ID 8861 //
     /*  230615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230655 */     // MIs[1] Operand 1
     /*  230655 */     // No operand predicates
     /*  230655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  230667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230682 */     GIR_RootConstrainSelectedInstOperands,
     /*  230683 */     // GIR_Coverage, 8861,
     /*  230683 */     GIR_EraseRootFromParent_Done,
     /*  230684 */   // Label 4520: @230684
     /*  230684 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(230758), // Rule ID 8864 //
     /*  230689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230729 */     // MIs[1] Operand 1
     /*  230729 */     // No operand predicates
     /*  230729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230756 */     GIR_RootConstrainSelectedInstOperands,
     /*  230757 */     // GIR_Coverage, 8864,
     /*  230757 */     GIR_EraseRootFromParent_Done,
     /*  230758 */   // Label 4521: @230758
     /*  230758 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(230832), // Rule ID 8865 //
     /*  230763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230803 */     // MIs[1] Operand 1
     /*  230803 */     // No operand predicates
     /*  230803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230830 */     GIR_RootConstrainSelectedInstOperands,
     /*  230831 */     // GIR_Coverage, 8865,
     /*  230831 */     GIR_EraseRootFromParent_Done,
     /*  230832 */   // Label 4522: @230832
     /*  230832 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(230906), // Rule ID 8868 //
     /*  230837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230877 */     // MIs[1] Operand 1
     /*  230877 */     // No operand predicates
     /*  230877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230904 */     GIR_RootConstrainSelectedInstOperands,
     /*  230905 */     // GIR_Coverage, 8868,
     /*  230905 */     GIR_EraseRootFromParent_Done,
     /*  230906 */   // Label 4523: @230906
     /*  230906 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(230980), // Rule ID 8869 //
     /*  230911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230951 */     // MIs[1] Operand 1
     /*  230951 */     // No operand predicates
     /*  230951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  230963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230978 */     GIR_RootConstrainSelectedInstOperands,
     /*  230979 */     // GIR_Coverage, 8869,
     /*  230979 */     GIR_EraseRootFromParent_Done,
     /*  230980 */   // Label 4524: @230980
     /*  230980 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(231054), // Rule ID 8872 //
     /*  230985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  230993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231025 */     // MIs[1] Operand 1
     /*  231025 */     // No operand predicates
     /*  231025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231034 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231052 */     GIR_RootConstrainSelectedInstOperands,
     /*  231053 */     // GIR_Coverage, 8872,
     /*  231053 */     GIR_EraseRootFromParent_Done,
     /*  231054 */   // Label 4525: @231054
     /*  231054 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(231128), // Rule ID 8873 //
     /*  231059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  231073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231099 */     // MIs[1] Operand 1
     /*  231099 */     // No operand predicates
     /*  231099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231126 */     GIR_RootConstrainSelectedInstOperands,
     /*  231127 */     // GIR_Coverage, 8873,
     /*  231127 */     GIR_EraseRootFromParent_Done,
     /*  231128 */   // Label 4526: @231128
     /*  231128 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(231202), // Rule ID 8876 //
     /*  231133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231173 */     // MIs[1] Operand 1
     /*  231173 */     // No operand predicates
     /*  231173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231200 */     GIR_RootConstrainSelectedInstOperands,
     /*  231201 */     // GIR_Coverage, 8876,
     /*  231201 */     GIR_EraseRootFromParent_Done,
     /*  231202 */   // Label 4527: @231202
     /*  231202 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(231276), // Rule ID 8877 //
     /*  231207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  231221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231247 */     // MIs[1] Operand 1
     /*  231247 */     // No operand predicates
     /*  231247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231274 */     GIR_RootConstrainSelectedInstOperands,
     /*  231275 */     // GIR_Coverage, 8877,
     /*  231275 */     GIR_EraseRootFromParent_Done,
     /*  231276 */   // Label 4528: @231276
     /*  231276 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(231350), // Rule ID 8880 //
     /*  231281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231321 */     // MIs[1] Operand 1
     /*  231321 */     // No operand predicates
     /*  231321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231348 */     GIR_RootConstrainSelectedInstOperands,
     /*  231349 */     // GIR_Coverage, 8880,
     /*  231349 */     GIR_EraseRootFromParent_Done,
     /*  231350 */   // Label 4529: @231350
     /*  231350 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(231424), // Rule ID 8881 //
     /*  231355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  231369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231395 */     // MIs[1] Operand 1
     /*  231395 */     // No operand predicates
     /*  231395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231422 */     GIR_RootConstrainSelectedInstOperands,
     /*  231423 */     // GIR_Coverage, 8881,
     /*  231423 */     GIR_EraseRootFromParent_Done,
     /*  231424 */   // Label 4530: @231424
     /*  231424 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(231498), // Rule ID 8884 //
     /*  231429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231469 */     // MIs[1] Operand 1
     /*  231469 */     // No operand predicates
     /*  231469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231496 */     GIR_RootConstrainSelectedInstOperands,
     /*  231497 */     // GIR_Coverage, 8884,
     /*  231497 */     GIR_EraseRootFromParent_Done,
     /*  231498 */   // Label 4531: @231498
     /*  231498 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(231572), // Rule ID 8885 //
     /*  231503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  231506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  231514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  231517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231543 */     // MIs[1] Operand 1
     /*  231543 */     // No operand predicates
     /*  231543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  231555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231570 */     GIR_RootConstrainSelectedInstOperands,
     /*  231571 */     // GIR_Coverage, 8885,
     /*  231571 */     GIR_EraseRootFromParent_Done,
     /*  231572 */   // Label 4532: @231572
     /*  231572 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(231646), // Rule ID 8888 //
     /*  231577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231617 */     // MIs[1] Operand 1
     /*  231617 */     // No operand predicates
     /*  231617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  231629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231644 */     GIR_RootConstrainSelectedInstOperands,
     /*  231645 */     // GIR_Coverage, 8888,
     /*  231645 */     GIR_EraseRootFromParent_Done,
     /*  231646 */   // Label 4533: @231646
     /*  231646 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(231720), // Rule ID 8889 //
     /*  231651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231691 */     // MIs[1] Operand 1
     /*  231691 */     // No operand predicates
     /*  231691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  231703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231718 */     GIR_RootConstrainSelectedInstOperands,
     /*  231719 */     // GIR_Coverage, 8889,
     /*  231719 */     GIR_EraseRootFromParent_Done,
     /*  231720 */   // Label 4534: @231720
     /*  231720 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(231794), // Rule ID 8892 //
     /*  231725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231765 */     // MIs[1] Operand 1
     /*  231765 */     // No operand predicates
     /*  231765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231774 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  231777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231792 */     GIR_RootConstrainSelectedInstOperands,
     /*  231793 */     // GIR_Coverage, 8892,
     /*  231793 */     GIR_EraseRootFromParent_Done,
     /*  231794 */   // Label 4535: @231794
     /*  231794 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(231868), // Rule ID 8893 //
     /*  231799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231839 */     // MIs[1] Operand 1
     /*  231839 */     // No operand predicates
     /*  231839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231848 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  231851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231866 */     GIR_RootConstrainSelectedInstOperands,
     /*  231867 */     // GIR_Coverage, 8893,
     /*  231867 */     GIR_EraseRootFromParent_Done,
     /*  231868 */   // Label 4536: @231868
     /*  231868 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(231942), // Rule ID 8896 //
     /*  231873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231913 */     // MIs[1] Operand 1
     /*  231913 */     // No operand predicates
     /*  231913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231922 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  231925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231940 */     GIR_RootConstrainSelectedInstOperands,
     /*  231941 */     // GIR_Coverage, 8896,
     /*  231941 */     GIR_EraseRootFromParent_Done,
     /*  231942 */   // Label 4537: @231942
     /*  231942 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(232016), // Rule ID 8897 //
     /*  231947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  231955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231987 */     // MIs[1] Operand 1
     /*  231987 */     // No operand predicates
     /*  231987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231996 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  231999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232014 */     GIR_RootConstrainSelectedInstOperands,
     /*  232015 */     // GIR_Coverage, 8897,
     /*  232015 */     GIR_EraseRootFromParent_Done,
     /*  232016 */   // Label 4538: @232016
     /*  232016 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(232090), // Rule ID 8900 //
     /*  232021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232061 */     // MIs[1] Operand 1
     /*  232061 */     // No operand predicates
     /*  232061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232088 */     GIR_RootConstrainSelectedInstOperands,
     /*  232089 */     // GIR_Coverage, 8900,
     /*  232089 */     GIR_EraseRootFromParent_Done,
     /*  232090 */   // Label 4539: @232090
     /*  232090 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(232164), // Rule ID 8901 //
     /*  232095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  232109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232135 */     // MIs[1] Operand 1
     /*  232135 */     // No operand predicates
     /*  232135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232162 */     GIR_RootConstrainSelectedInstOperands,
     /*  232163 */     // GIR_Coverage, 8901,
     /*  232163 */     GIR_EraseRootFromParent_Done,
     /*  232164 */   // Label 4540: @232164
     /*  232164 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(232238), // Rule ID 8904 //
     /*  232169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232209 */     // MIs[1] Operand 1
     /*  232209 */     // No operand predicates
     /*  232209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232236 */     GIR_RootConstrainSelectedInstOperands,
     /*  232237 */     // GIR_Coverage, 8904,
     /*  232237 */     GIR_EraseRootFromParent_Done,
     /*  232238 */   // Label 4541: @232238
     /*  232238 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(232312), // Rule ID 8905 //
     /*  232243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  232257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232283 */     // MIs[1] Operand 1
     /*  232283 */     // No operand predicates
     /*  232283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232310 */     GIR_RootConstrainSelectedInstOperands,
     /*  232311 */     // GIR_Coverage, 8905,
     /*  232311 */     GIR_EraseRootFromParent_Done,
     /*  232312 */   // Label 4542: @232312
     /*  232312 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(232386), // Rule ID 8908 //
     /*  232317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232357 */     // MIs[1] Operand 1
     /*  232357 */     // No operand predicates
     /*  232357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232366 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232384 */     GIR_RootConstrainSelectedInstOperands,
     /*  232385 */     // GIR_Coverage, 8908,
     /*  232385 */     GIR_EraseRootFromParent_Done,
     /*  232386 */   // Label 4543: @232386
     /*  232386 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(232460), // Rule ID 8909 //
     /*  232391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  232402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  232405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232431 */     // MIs[1] Operand 1
     /*  232431 */     // No operand predicates
     /*  232431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232440 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232458 */     GIR_RootConstrainSelectedInstOperands,
     /*  232459 */     // GIR_Coverage, 8909,
     /*  232459 */     GIR_EraseRootFromParent_Done,
     /*  232460 */   // Label 4544: @232460
     /*  232460 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(232534), // Rule ID 8912 //
     /*  232465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232505 */     // MIs[1] Operand 1
     /*  232505 */     // No operand predicates
     /*  232505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232514 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232532 */     GIR_RootConstrainSelectedInstOperands,
     /*  232533 */     // GIR_Coverage, 8912,
     /*  232533 */     GIR_EraseRootFromParent_Done,
     /*  232534 */   // Label 4545: @232534
     /*  232534 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(232608), // Rule ID 8913 //
     /*  232539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  232553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232579 */     // MIs[1] Operand 1
     /*  232579 */     // No operand predicates
     /*  232579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232606 */     GIR_RootConstrainSelectedInstOperands,
     /*  232607 */     // GIR_Coverage, 8913,
     /*  232607 */     GIR_EraseRootFromParent_Done,
     /*  232608 */   // Label 4546: @232608
     /*  232608 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(232682), // Rule ID 8916 //
     /*  232613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232653 */     // MIs[1] Operand 1
     /*  232653 */     // No operand predicates
     /*  232653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232680 */     GIR_RootConstrainSelectedInstOperands,
     /*  232681 */     // GIR_Coverage, 8916,
     /*  232681 */     GIR_EraseRootFromParent_Done,
     /*  232682 */   // Label 4547: @232682
     /*  232682 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(232756), // Rule ID 8917 //
     /*  232687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232727 */     // MIs[1] Operand 1
     /*  232727 */     // No operand predicates
     /*  232727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  232739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232754 */     GIR_RootConstrainSelectedInstOperands,
     /*  232755 */     // GIR_Coverage, 8917,
     /*  232755 */     GIR_EraseRootFromParent_Done,
     /*  232756 */   // Label 4548: @232756
     /*  232756 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(232830), // Rule ID 8920 //
     /*  232761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232801 */     // MIs[1] Operand 1
     /*  232801 */     // No operand predicates
     /*  232801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232810 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232828 */     GIR_RootConstrainSelectedInstOperands,
     /*  232829 */     // GIR_Coverage, 8920,
     /*  232829 */     GIR_EraseRootFromParent_Done,
     /*  232830 */   // Label 4549: @232830
     /*  232830 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(232904), // Rule ID 8921 //
     /*  232835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232875 */     // MIs[1] Operand 1
     /*  232875 */     // No operand predicates
     /*  232875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  232887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232902 */     GIR_RootConstrainSelectedInstOperands,
     /*  232903 */     // GIR_Coverage, 8921,
     /*  232903 */     GIR_EraseRootFromParent_Done,
     /*  232904 */   // Label 4550: @232904
     /*  232904 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(232978), // Rule ID 8924 //
     /*  232909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232949 */     // MIs[1] Operand 1
     /*  232949 */     // No operand predicates
     /*  232949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232958 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  232961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232976 */     GIR_RootConstrainSelectedInstOperands,
     /*  232977 */     // GIR_Coverage, 8924,
     /*  232977 */     GIR_EraseRootFromParent_Done,
     /*  232978 */   // Label 4551: @232978
     /*  232978 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(233052), // Rule ID 8925 //
     /*  232983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  232991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233023 */     // MIs[1] Operand 1
     /*  233023 */     // No operand predicates
     /*  233023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  233035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233050 */     GIR_RootConstrainSelectedInstOperands,
     /*  233051 */     // GIR_Coverage, 8925,
     /*  233051 */     GIR_EraseRootFromParent_Done,
     /*  233052 */   // Label 4552: @233052
     /*  233052 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(233126), // Rule ID 8928 //
     /*  233057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233097 */     // MIs[1] Operand 1
     /*  233097 */     // No operand predicates
     /*  233097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  233109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233124 */     GIR_RootConstrainSelectedInstOperands,
     /*  233125 */     // GIR_Coverage, 8928,
     /*  233125 */     GIR_EraseRootFromParent_Done,
     /*  233126 */   // Label 4553: @233126
     /*  233126 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(233200), // Rule ID 8929 //
     /*  233131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  233145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233171 */     // MIs[1] Operand 1
     /*  233171 */     // No operand predicates
     /*  233171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  233183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233198 */     GIR_RootConstrainSelectedInstOperands,
     /*  233199 */     // GIR_Coverage, 8929,
     /*  233199 */     GIR_EraseRootFromParent_Done,
     /*  233200 */   // Label 4554: @233200
     /*  233200 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(233274), // Rule ID 8932 //
     /*  233205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233245 */     // MIs[1] Operand 1
     /*  233245 */     // No operand predicates
     /*  233245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233254 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  233257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233272 */     GIR_RootConstrainSelectedInstOperands,
     /*  233273 */     // GIR_Coverage, 8932,
     /*  233273 */     GIR_EraseRootFromParent_Done,
     /*  233274 */   // Label 4555: @233274
     /*  233274 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(233348), // Rule ID 8933 //
     /*  233279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  233287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  233293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  233307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233319 */     // MIs[1] Operand 1
     /*  233319 */     // No operand predicates
     /*  233319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  233331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233346 */     GIR_RootConstrainSelectedInstOperands,
     /*  233347 */     // GIR_Coverage, 8933,
     /*  233347 */     GIR_EraseRootFromParent_Done,
     /*  233348 */   // Label 4556: @233348
     /*  233348 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(233422), // Rule ID 9112 //
     /*  233353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233393 */     // MIs[1] Operand 1
     /*  233393 */     // No operand predicates
     /*  233393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  233405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233420 */     GIR_RootConstrainSelectedInstOperands,
     /*  233421 */     // GIR_Coverage, 9112,
     /*  233421 */     GIR_EraseRootFromParent_Done,
     /*  233422 */   // Label 4557: @233422
     /*  233422 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(233496), // Rule ID 9113 //
     /*  233427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  233441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233467 */     // MIs[1] Operand 1
     /*  233467 */     // No operand predicates
     /*  233467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  233479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233494 */     GIR_RootConstrainSelectedInstOperands,
     /*  233495 */     // GIR_Coverage, 9113,
     /*  233495 */     GIR_EraseRootFromParent_Done,
     /*  233496 */   // Label 4558: @233496
     /*  233496 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(233570), // Rule ID 9116 //
     /*  233501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233541 */     // MIs[1] Operand 1
     /*  233541 */     // No operand predicates
     /*  233541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233568 */     GIR_RootConstrainSelectedInstOperands,
     /*  233569 */     // GIR_Coverage, 9116,
     /*  233569 */     GIR_EraseRootFromParent_Done,
     /*  233570 */   // Label 4559: @233570
     /*  233570 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(233644), // Rule ID 9117 //
     /*  233575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233615 */     // MIs[1] Operand 1
     /*  233615 */     // No operand predicates
     /*  233615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233642 */     GIR_RootConstrainSelectedInstOperands,
     /*  233643 */     // GIR_Coverage, 9117,
     /*  233643 */     GIR_EraseRootFromParent_Done,
     /*  233644 */   // Label 4560: @233644
     /*  233644 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(233718), // Rule ID 9120 //
     /*  233649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233689 */     // MIs[1] Operand 1
     /*  233689 */     // No operand predicates
     /*  233689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233716 */     GIR_RootConstrainSelectedInstOperands,
     /*  233717 */     // GIR_Coverage, 9120,
     /*  233717 */     GIR_EraseRootFromParent_Done,
     /*  233718 */   // Label 4561: @233718
     /*  233718 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(233792), // Rule ID 9121 //
     /*  233723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233763 */     // MIs[1] Operand 1
     /*  233763 */     // No operand predicates
     /*  233763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233790 */     GIR_RootConstrainSelectedInstOperands,
     /*  233791 */     // GIR_Coverage, 9121,
     /*  233791 */     GIR_EraseRootFromParent_Done,
     /*  233792 */   // Label 4562: @233792
     /*  233792 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(233866), // Rule ID 9124 //
     /*  233797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233837 */     // MIs[1] Operand 1
     /*  233837 */     // No operand predicates
     /*  233837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233864 */     GIR_RootConstrainSelectedInstOperands,
     /*  233865 */     // GIR_Coverage, 9124,
     /*  233865 */     GIR_EraseRootFromParent_Done,
     /*  233866 */   // Label 4563: @233866
     /*  233866 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(233940), // Rule ID 9125 //
     /*  233871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233911 */     // MIs[1] Operand 1
     /*  233911 */     // No operand predicates
     /*  233911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  233923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233938 */     GIR_RootConstrainSelectedInstOperands,
     /*  233939 */     // GIR_Coverage, 9125,
     /*  233939 */     GIR_EraseRootFromParent_Done,
     /*  233940 */   // Label 4564: @233940
     /*  233940 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(234014), // Rule ID 9128 //
     /*  233945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  233953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233985 */     // MIs[1] Operand 1
     /*  233985 */     // No operand predicates
     /*  233985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  233997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234012 */     GIR_RootConstrainSelectedInstOperands,
     /*  234013 */     // GIR_Coverage, 9128,
     /*  234013 */     GIR_EraseRootFromParent_Done,
     /*  234014 */   // Label 4565: @234014
     /*  234014 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(234088), // Rule ID 9129 //
     /*  234019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  234033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234059 */     // MIs[1] Operand 1
     /*  234059 */     // No operand predicates
     /*  234059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234086 */     GIR_RootConstrainSelectedInstOperands,
     /*  234087 */     // GIR_Coverage, 9129,
     /*  234087 */     GIR_EraseRootFromParent_Done,
     /*  234088 */   // Label 4566: @234088
     /*  234088 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(234162), // Rule ID 9132 //
     /*  234093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234133 */     // MIs[1] Operand 1
     /*  234133 */     // No operand predicates
     /*  234133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234142 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234160 */     GIR_RootConstrainSelectedInstOperands,
     /*  234161 */     // GIR_Coverage, 9132,
     /*  234161 */     GIR_EraseRootFromParent_Done,
     /*  234162 */   // Label 4567: @234162
     /*  234162 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(234236), // Rule ID 9133 //
     /*  234167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  234181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234207 */     // MIs[1] Operand 1
     /*  234207 */     // No operand predicates
     /*  234207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234216 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  234219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234234 */     GIR_RootConstrainSelectedInstOperands,
     /*  234235 */     // GIR_Coverage, 9133,
     /*  234235 */     GIR_EraseRootFromParent_Done,
     /*  234236 */   // Label 4568: @234236
     /*  234236 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(234310), // Rule ID 9136 //
     /*  234241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234281 */     // MIs[1] Operand 1
     /*  234281 */     // No operand predicates
     /*  234281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234308 */     GIR_RootConstrainSelectedInstOperands,
     /*  234309 */     // GIR_Coverage, 9136,
     /*  234309 */     GIR_EraseRootFromParent_Done,
     /*  234310 */   // Label 4569: @234310
     /*  234310 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(234384), // Rule ID 9137 //
     /*  234315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  234329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234355 */     // MIs[1] Operand 1
     /*  234355 */     // No operand predicates
     /*  234355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234382 */     GIR_RootConstrainSelectedInstOperands,
     /*  234383 */     // GIR_Coverage, 9137,
     /*  234383 */     GIR_EraseRootFromParent_Done,
     /*  234384 */   // Label 4570: @234384
     /*  234384 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(234458), // Rule ID 9140 //
     /*  234389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234429 */     // MIs[1] Operand 1
     /*  234429 */     // No operand predicates
     /*  234429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234456 */     GIR_RootConstrainSelectedInstOperands,
     /*  234457 */     // GIR_Coverage, 9140,
     /*  234457 */     GIR_EraseRootFromParent_Done,
     /*  234458 */   // Label 4571: @234458
     /*  234458 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(234532), // Rule ID 9141 //
     /*  234463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  234477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234503 */     // MIs[1] Operand 1
     /*  234503 */     // No operand predicates
     /*  234503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234530 */     GIR_RootConstrainSelectedInstOperands,
     /*  234531 */     // GIR_Coverage, 9141,
     /*  234531 */     GIR_EraseRootFromParent_Done,
     /*  234532 */   // Label 4572: @234532
     /*  234532 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(234606), // Rule ID 9144 //
     /*  234537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234577 */     // MIs[1] Operand 1
     /*  234577 */     // No operand predicates
     /*  234577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234586 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234604 */     GIR_RootConstrainSelectedInstOperands,
     /*  234605 */     // GIR_Coverage, 9144,
     /*  234605 */     GIR_EraseRootFromParent_Done,
     /*  234606 */   // Label 4573: @234606
     /*  234606 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(234680), // Rule ID 9145 //
     /*  234611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234651 */     // MIs[1] Operand 1
     /*  234651 */     // No operand predicates
     /*  234651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234678 */     GIR_RootConstrainSelectedInstOperands,
     /*  234679 */     // GIR_Coverage, 9145,
     /*  234679 */     GIR_EraseRootFromParent_Done,
     /*  234680 */   // Label 4574: @234680
     /*  234680 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(234754), // Rule ID 9148 //
     /*  234685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234725 */     // MIs[1] Operand 1
     /*  234725 */     // No operand predicates
     /*  234725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234752 */     GIR_RootConstrainSelectedInstOperands,
     /*  234753 */     // GIR_Coverage, 9148,
     /*  234753 */     GIR_EraseRootFromParent_Done,
     /*  234754 */   // Label 4575: @234754
     /*  234754 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(234828), // Rule ID 9149 //
     /*  234759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234799 */     // MIs[1] Operand 1
     /*  234799 */     // No operand predicates
     /*  234799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  234811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234826 */     GIR_RootConstrainSelectedInstOperands,
     /*  234827 */     // GIR_Coverage, 9149,
     /*  234827 */     GIR_EraseRootFromParent_Done,
     /*  234828 */   // Label 4576: @234828
     /*  234828 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(234902), // Rule ID 9152 //
     /*  234833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234873 */     // MIs[1] Operand 1
     /*  234873 */     // No operand predicates
     /*  234873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  234885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234900 */     GIR_RootConstrainSelectedInstOperands,
     /*  234901 */     // GIR_Coverage, 9152,
     /*  234901 */     GIR_EraseRootFromParent_Done,
     /*  234902 */   // Label 4577: @234902
     /*  234902 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(234976), // Rule ID 9153 //
     /*  234907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234947 */     // MIs[1] Operand 1
     /*  234947 */     // No operand predicates
     /*  234947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  234959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234974 */     GIR_RootConstrainSelectedInstOperands,
     /*  234975 */     // GIR_Coverage, 9153,
     /*  234975 */     GIR_EraseRootFromParent_Done,
     /*  234976 */   // Label 4578: @234976
     /*  234976 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(235050), // Rule ID 9156 //
     /*  234981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  234989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235021 */     // MIs[1] Operand 1
     /*  235021 */     // No operand predicates
     /*  235021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235030 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235048 */     GIR_RootConstrainSelectedInstOperands,
     /*  235049 */     // GIR_Coverage, 9156,
     /*  235049 */     GIR_EraseRootFromParent_Done,
     /*  235050 */   // Label 4579: @235050
     /*  235050 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(235124), // Rule ID 9157 //
     /*  235055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  235069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235095 */     // MIs[1] Operand 1
     /*  235095 */     // No operand predicates
     /*  235095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235104 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235122 */     GIR_RootConstrainSelectedInstOperands,
     /*  235123 */     // GIR_Coverage, 9157,
     /*  235123 */     GIR_EraseRootFromParent_Done,
     /*  235124 */   // Label 4580: @235124
     /*  235124 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(235198), // Rule ID 9160 //
     /*  235129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235169 */     // MIs[1] Operand 1
     /*  235169 */     // No operand predicates
     /*  235169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235178 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235196 */     GIR_RootConstrainSelectedInstOperands,
     /*  235197 */     // GIR_Coverage, 9160,
     /*  235197 */     GIR_EraseRootFromParent_Done,
     /*  235198 */   // Label 4581: @235198
     /*  235198 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(235272), // Rule ID 9161 //
     /*  235203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  235214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  235217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235243 */     // MIs[1] Operand 1
     /*  235243 */     // No operand predicates
     /*  235243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235252 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235270 */     GIR_RootConstrainSelectedInstOperands,
     /*  235271 */     // GIR_Coverage, 9161,
     /*  235271 */     GIR_EraseRootFromParent_Done,
     /*  235272 */   // Label 4582: @235272
     /*  235272 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(235346), // Rule ID 9164 //
     /*  235277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235317 */     // MIs[1] Operand 1
     /*  235317 */     // No operand predicates
     /*  235317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235326 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235344 */     GIR_RootConstrainSelectedInstOperands,
     /*  235345 */     // GIR_Coverage, 9164,
     /*  235345 */     GIR_EraseRootFromParent_Done,
     /*  235346 */   // Label 4583: @235346
     /*  235346 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(235420), // Rule ID 9165 //
     /*  235351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  235365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235391 */     // MIs[1] Operand 1
     /*  235391 */     // No operand predicates
     /*  235391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235418 */     GIR_RootConstrainSelectedInstOperands,
     /*  235419 */     // GIR_Coverage, 9165,
     /*  235419 */     GIR_EraseRootFromParent_Done,
     /*  235420 */   // Label 4584: @235420
     /*  235420 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(235494), // Rule ID 9168 //
     /*  235425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235465 */     // MIs[1] Operand 1
     /*  235465 */     // No operand predicates
     /*  235465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235492 */     GIR_RootConstrainSelectedInstOperands,
     /*  235493 */     // GIR_Coverage, 9168,
     /*  235493 */     GIR_EraseRootFromParent_Done,
     /*  235494 */   // Label 4585: @235494
     /*  235494 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(235568), // Rule ID 9169 //
     /*  235499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  235513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235539 */     // MIs[1] Operand 1
     /*  235539 */     // No operand predicates
     /*  235539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235566 */     GIR_RootConstrainSelectedInstOperands,
     /*  235567 */     // GIR_Coverage, 9169,
     /*  235567 */     GIR_EraseRootFromParent_Done,
     /*  235568 */   // Label 4586: @235568
     /*  235568 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(235642), // Rule ID 9172 //
     /*  235573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235613 */     // MIs[1] Operand 1
     /*  235613 */     // No operand predicates
     /*  235613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235640 */     GIR_RootConstrainSelectedInstOperands,
     /*  235641 */     // GIR_Coverage, 9172,
     /*  235641 */     GIR_EraseRootFromParent_Done,
     /*  235642 */   // Label 4587: @235642
     /*  235642 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(235716), // Rule ID 9173 //
     /*  235647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235687 */     // MIs[1] Operand 1
     /*  235687 */     // No operand predicates
     /*  235687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  235699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235714 */     GIR_RootConstrainSelectedInstOperands,
     /*  235715 */     // GIR_Coverage, 9173,
     /*  235715 */     GIR_EraseRootFromParent_Done,
     /*  235716 */   // Label 4588: @235716
     /*  235716 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(235790), // Rule ID 9176 //
     /*  235721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235761 */     // MIs[1] Operand 1
     /*  235761 */     // No operand predicates
     /*  235761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235788 */     GIR_RootConstrainSelectedInstOperands,
     /*  235789 */     // GIR_Coverage, 9176,
     /*  235789 */     GIR_EraseRootFromParent_Done,
     /*  235790 */   // Label 4589: @235790
     /*  235790 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(235864), // Rule ID 9177 //
     /*  235795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235835 */     // MIs[1] Operand 1
     /*  235835 */     // No operand predicates
     /*  235835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  235847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235862 */     GIR_RootConstrainSelectedInstOperands,
     /*  235863 */     // GIR_Coverage, 9177,
     /*  235863 */     GIR_EraseRootFromParent_Done,
     /*  235864 */   // Label 4590: @235864
     /*  235864 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(235938), // Rule ID 9180 //
     /*  235869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235909 */     // MIs[1] Operand 1
     /*  235909 */     // No operand predicates
     /*  235909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235936 */     GIR_RootConstrainSelectedInstOperands,
     /*  235937 */     // GIR_Coverage, 9180,
     /*  235937 */     GIR_EraseRootFromParent_Done,
     /*  235938 */   // Label 4591: @235938
     /*  235938 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(236012), // Rule ID 9181 //
     /*  235943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  235951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235983 */     // MIs[1] Operand 1
     /*  235983 */     // No operand predicates
     /*  235983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  235995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236010 */     GIR_RootConstrainSelectedInstOperands,
     /*  236011 */     // GIR_Coverage, 9181,
     /*  236011 */     GIR_EraseRootFromParent_Done,
     /*  236012 */   // Label 4592: @236012
     /*  236012 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(236086), // Rule ID 9184 //
     /*  236017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  236031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236057 */     // MIs[1] Operand 1
     /*  236057 */     // No operand predicates
     /*  236057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236066 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236084 */     GIR_RootConstrainSelectedInstOperands,
     /*  236085 */     // GIR_Coverage, 9184,
     /*  236085 */     GIR_EraseRootFromParent_Done,
     /*  236086 */   // Label 4593: @236086
     /*  236086 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(236160), // Rule ID 9185 //
     /*  236091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  236102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  236105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236131 */     // MIs[1] Operand 1
     /*  236131 */     // No operand predicates
     /*  236131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236158 */     GIR_RootConstrainSelectedInstOperands,
     /*  236159 */     // GIR_Coverage, 9185,
     /*  236159 */     GIR_EraseRootFromParent_Done,
     /*  236160 */   // Label 4594: @236160
     /*  236160 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(236234), // Rule ID 9188 //
     /*  236165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236205 */     // MIs[1] Operand 1
     /*  236205 */     // No operand predicates
     /*  236205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  236217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236232 */     GIR_RootConstrainSelectedInstOperands,
     /*  236233 */     // GIR_Coverage, 9188,
     /*  236233 */     GIR_EraseRootFromParent_Done,
     /*  236234 */   // Label 4595: @236234
     /*  236234 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(236308), // Rule ID 9189 //
     /*  236239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  236253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  236267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236279 */     // MIs[1] Operand 1
     /*  236279 */     // No operand predicates
     /*  236279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  236291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236306 */     GIR_RootConstrainSelectedInstOperands,
     /*  236307 */     // GIR_Coverage, 9189,
     /*  236307 */     GIR_EraseRootFromParent_Done,
     /*  236308 */   // Label 4596: @236308
     /*  236308 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(236382), // Rule ID 9192 //
     /*  236313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236353 */     // MIs[1] Operand 1
     /*  236353 */     // No operand predicates
     /*  236353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  236365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236380 */     GIR_RootConstrainSelectedInstOperands,
     /*  236381 */     // GIR_Coverage, 9192,
     /*  236381 */     GIR_EraseRootFromParent_Done,
     /*  236382 */   // Label 4597: @236382
     /*  236382 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(236456), // Rule ID 9193 //
     /*  236387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  236401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  236415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236427 */     // MIs[1] Operand 1
     /*  236427 */     // No operand predicates
     /*  236427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  236439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236454 */     GIR_RootConstrainSelectedInstOperands,
     /*  236455 */     // GIR_Coverage, 9193,
     /*  236455 */     GIR_EraseRootFromParent_Done,
     /*  236456 */   // Label 4598: @236456
     /*  236456 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(236530), // Rule ID 9196 //
     /*  236461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236501 */     // MIs[1] Operand 1
     /*  236501 */     // No operand predicates
     /*  236501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236528 */     GIR_RootConstrainSelectedInstOperands,
     /*  236529 */     // GIR_Coverage, 9196,
     /*  236529 */     GIR_EraseRootFromParent_Done,
     /*  236530 */   // Label 4599: @236530
     /*  236530 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(236604), // Rule ID 9197 //
     /*  236535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  236543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  236549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  236563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236575 */     // MIs[1] Operand 1
     /*  236575 */     // No operand predicates
     /*  236575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  236587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236602 */     GIR_RootConstrainSelectedInstOperands,
     /*  236603 */     // GIR_Coverage, 9197,
     /*  236603 */     GIR_EraseRootFromParent_Done,
     /*  236604 */   // Label 4600: @236604
     /*  236604 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(236678), // Rule ID 9288 //
     /*  236609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236649 */     // MIs[1] Operand 1
     /*  236649 */     // No operand predicates
     /*  236649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  236661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236676 */     GIR_RootConstrainSelectedInstOperands,
     /*  236677 */     // GIR_Coverage, 9288,
     /*  236677 */     GIR_EraseRootFromParent_Done,
     /*  236678 */   // Label 4601: @236678
     /*  236678 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(236752), // Rule ID 9289 //
     /*  236683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236723 */     // MIs[1] Operand 1
     /*  236723 */     // No operand predicates
     /*  236723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  236735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236750 */     GIR_RootConstrainSelectedInstOperands,
     /*  236751 */     // GIR_Coverage, 9289,
     /*  236751 */     GIR_EraseRootFromParent_Done,
     /*  236752 */   // Label 4602: @236752
     /*  236752 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(236826), // Rule ID 9292 //
     /*  236757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236797 */     // MIs[1] Operand 1
     /*  236797 */     // No operand predicates
     /*  236797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236806 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  236809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236824 */     GIR_RootConstrainSelectedInstOperands,
     /*  236825 */     // GIR_Coverage, 9292,
     /*  236825 */     GIR_EraseRootFromParent_Done,
     /*  236826 */   // Label 4603: @236826
     /*  236826 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(236900), // Rule ID 9293 //
     /*  236831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236871 */     // MIs[1] Operand 1
     /*  236871 */     // No operand predicates
     /*  236871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  236883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236898 */     GIR_RootConstrainSelectedInstOperands,
     /*  236899 */     // GIR_Coverage, 9293,
     /*  236899 */     GIR_EraseRootFromParent_Done,
     /*  236900 */   // Label 4604: @236900
     /*  236900 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(236974), // Rule ID 9296 //
     /*  236905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236945 */     // MIs[1] Operand 1
     /*  236945 */     // No operand predicates
     /*  236945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  236957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236972 */     GIR_RootConstrainSelectedInstOperands,
     /*  236973 */     // GIR_Coverage, 9296,
     /*  236973 */     GIR_EraseRootFromParent_Done,
     /*  236974 */   // Label 4605: @236974
     /*  236974 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(237048), // Rule ID 9297 //
     /*  236979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  236987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237019 */     // MIs[1] Operand 1
     /*  237019 */     // No operand predicates
     /*  237019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237046 */     GIR_RootConstrainSelectedInstOperands,
     /*  237047 */     // GIR_Coverage, 9297,
     /*  237047 */     GIR_EraseRootFromParent_Done,
     /*  237048 */   // Label 4606: @237048
     /*  237048 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(237122), // Rule ID 9300 //
     /*  237053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237093 */     // MIs[1] Operand 1
     /*  237093 */     // No operand predicates
     /*  237093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  237105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237120 */     GIR_RootConstrainSelectedInstOperands,
     /*  237121 */     // GIR_Coverage, 9300,
     /*  237121 */     GIR_EraseRootFromParent_Done,
     /*  237122 */   // Label 4607: @237122
     /*  237122 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(237196), // Rule ID 9301 //
     /*  237127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  237141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237167 */     // MIs[1] Operand 1
     /*  237167 */     // No operand predicates
     /*  237167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  237179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237194 */     GIR_RootConstrainSelectedInstOperands,
     /*  237195 */     // GIR_Coverage, 9301,
     /*  237195 */     GIR_EraseRootFromParent_Done,
     /*  237196 */   // Label 4608: @237196
     /*  237196 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(237270), // Rule ID 9304 //
     /*  237201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237241 */     // MIs[1] Operand 1
     /*  237241 */     // No operand predicates
     /*  237241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237268 */     GIR_RootConstrainSelectedInstOperands,
     /*  237269 */     // GIR_Coverage, 9304,
     /*  237269 */     GIR_EraseRootFromParent_Done,
     /*  237270 */   // Label 4609: @237270
     /*  237270 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(237344), // Rule ID 9305 //
     /*  237275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  237289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237315 */     // MIs[1] Operand 1
     /*  237315 */     // No operand predicates
     /*  237315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237324 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237342 */     GIR_RootConstrainSelectedInstOperands,
     /*  237343 */     // GIR_Coverage, 9305,
     /*  237343 */     GIR_EraseRootFromParent_Done,
     /*  237344 */   // Label 4610: @237344
     /*  237344 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(237418), // Rule ID 9308 //
     /*  237349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237389 */     // MIs[1] Operand 1
     /*  237389 */     // No operand predicates
     /*  237389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237416 */     GIR_RootConstrainSelectedInstOperands,
     /*  237417 */     // GIR_Coverage, 9308,
     /*  237417 */     GIR_EraseRootFromParent_Done,
     /*  237418 */   // Label 4611: @237418
     /*  237418 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(237492), // Rule ID 9309 //
     /*  237423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  237437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237463 */     // MIs[1] Operand 1
     /*  237463 */     // No operand predicates
     /*  237463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  237475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237490 */     GIR_RootConstrainSelectedInstOperands,
     /*  237491 */     // GIR_Coverage, 9309,
     /*  237491 */     GIR_EraseRootFromParent_Done,
     /*  237492 */   // Label 4612: @237492
     /*  237492 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(237566), // Rule ID 9312 //
     /*  237497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237537 */     // MIs[1] Operand 1
     /*  237537 */     // No operand predicates
     /*  237537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237546 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237564 */     GIR_RootConstrainSelectedInstOperands,
     /*  237565 */     // GIR_Coverage, 9312,
     /*  237565 */     GIR_EraseRootFromParent_Done,
     /*  237566 */   // Label 4613: @237566
     /*  237566 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(237640), // Rule ID 9313 //
     /*  237571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  237585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237611 */     // MIs[1] Operand 1
     /*  237611 */     // No operand predicates
     /*  237611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237638 */     GIR_RootConstrainSelectedInstOperands,
     /*  237639 */     // GIR_Coverage, 9313,
     /*  237639 */     GIR_EraseRootFromParent_Done,
     /*  237640 */   // Label 4614: @237640
     /*  237640 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(237714), // Rule ID 9316 //
     /*  237645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237685 */     // MIs[1] Operand 1
     /*  237685 */     // No operand predicates
     /*  237685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237694 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237712 */     GIR_RootConstrainSelectedInstOperands,
     /*  237713 */     // GIR_Coverage, 9316,
     /*  237713 */     GIR_EraseRootFromParent_Done,
     /*  237714 */   // Label 4615: @237714
     /*  237714 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(237788), // Rule ID 9317 //
     /*  237719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237759 */     // MIs[1] Operand 1
     /*  237759 */     // No operand predicates
     /*  237759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237786 */     GIR_RootConstrainSelectedInstOperands,
     /*  237787 */     // GIR_Coverage, 9317,
     /*  237787 */     GIR_EraseRootFromParent_Done,
     /*  237788 */   // Label 4616: @237788
     /*  237788 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(237862), // Rule ID 9320 //
     /*  237793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237833 */     // MIs[1] Operand 1
     /*  237833 */     // No operand predicates
     /*  237833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237860 */     GIR_RootConstrainSelectedInstOperands,
     /*  237861 */     // GIR_Coverage, 9320,
     /*  237861 */     GIR_EraseRootFromParent_Done,
     /*  237862 */   // Label 4617: @237862
     /*  237862 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(237936), // Rule ID 9321 //
     /*  237867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237907 */     // MIs[1] Operand 1
     /*  237907 */     // No operand predicates
     /*  237907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237934 */     GIR_RootConstrainSelectedInstOperands,
     /*  237935 */     // GIR_Coverage, 9321,
     /*  237935 */     GIR_EraseRootFromParent_Done,
     /*  237936 */   // Label 4618: @237936
     /*  237936 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(238010), // Rule ID 9324 //
     /*  237941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  237949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237981 */     // MIs[1] Operand 1
     /*  237981 */     // No operand predicates
     /*  237981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  237993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238008 */     GIR_RootConstrainSelectedInstOperands,
     /*  238009 */     // GIR_Coverage, 9324,
     /*  238009 */     GIR_EraseRootFromParent_Done,
     /*  238010 */   // Label 4619: @238010
     /*  238010 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(238084), // Rule ID 9325 //
     /*  238015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  238026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  238029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238055 */     // MIs[1] Operand 1
     /*  238055 */     // No operand predicates
     /*  238055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  238067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238082 */     GIR_RootConstrainSelectedInstOperands,
     /*  238083 */     // GIR_Coverage, 9325,
     /*  238083 */     GIR_EraseRootFromParent_Done,
     /*  238084 */   // Label 4620: @238084
     /*  238084 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(238158), // Rule ID 9328 //
     /*  238089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238129 */     // MIs[1] Operand 1
     /*  238129 */     // No operand predicates
     /*  238129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238156 */     GIR_RootConstrainSelectedInstOperands,
     /*  238157 */     // GIR_Coverage, 9328,
     /*  238157 */     GIR_EraseRootFromParent_Done,
     /*  238158 */   // Label 4621: @238158
     /*  238158 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(238232), // Rule ID 9329 //
     /*  238163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  238177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238203 */     // MIs[1] Operand 1
     /*  238203 */     // No operand predicates
     /*  238203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238230 */     GIR_RootConstrainSelectedInstOperands,
     /*  238231 */     // GIR_Coverage, 9329,
     /*  238231 */     GIR_EraseRootFromParent_Done,
     /*  238232 */   // Label 4622: @238232
     /*  238232 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(238306), // Rule ID 9332 //
     /*  238237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238277 */     // MIs[1] Operand 1
     /*  238277 */     // No operand predicates
     /*  238277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238286 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238304 */     GIR_RootConstrainSelectedInstOperands,
     /*  238305 */     // GIR_Coverage, 9332,
     /*  238305 */     GIR_EraseRootFromParent_Done,
     /*  238306 */   // Label 4623: @238306
     /*  238306 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(238380), // Rule ID 9333 //
     /*  238311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  238325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238351 */     // MIs[1] Operand 1
     /*  238351 */     // No operand predicates
     /*  238351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238378 */     GIR_RootConstrainSelectedInstOperands,
     /*  238379 */     // GIR_Coverage, 9333,
     /*  238379 */     GIR_EraseRootFromParent_Done,
     /*  238380 */   // Label 4624: @238380
     /*  238380 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(238454), // Rule ID 9336 //
     /*  238385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238425 */     // MIs[1] Operand 1
     /*  238425 */     // No operand predicates
     /*  238425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238434 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  238434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238452 */     GIR_RootConstrainSelectedInstOperands,
     /*  238453 */     // GIR_Coverage, 9336,
     /*  238453 */     GIR_EraseRootFromParent_Done,
     /*  238454 */   // Label 4625: @238454
     /*  238454 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(238528), // Rule ID 9337 //
     /*  238459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  238470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  238473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238499 */     // MIs[1] Operand 1
     /*  238499 */     // No operand predicates
     /*  238499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238508 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  238508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  238526 */     GIR_RootConstrainSelectedInstOperands,
     /*  238527 */     // GIR_Coverage, 9337,
     /*  238527 */     GIR_EraseRootFromParent_Done,
     /*  238528 */   // Label 4626: @238528
     /*  238528 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(238602), // Rule ID 9340 //
     /*  238533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238573 */     // MIs[1] Operand 1
     /*  238573 */     // No operand predicates
     /*  238573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238600 */     GIR_RootConstrainSelectedInstOperands,
     /*  238601 */     // GIR_Coverage, 9340,
     /*  238601 */     GIR_EraseRootFromParent_Done,
     /*  238602 */   // Label 4627: @238602
     /*  238602 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(238676), // Rule ID 9341 //
     /*  238607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238647 */     // MIs[1] Operand 1
     /*  238647 */     // No operand predicates
     /*  238647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  238659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238674 */     GIR_RootConstrainSelectedInstOperands,
     /*  238675 */     // GIR_Coverage, 9341,
     /*  238675 */     GIR_EraseRootFromParent_Done,
     /*  238676 */   // Label 4628: @238676
     /*  238676 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(238750), // Rule ID 9344 //
     /*  238681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238721 */     // MIs[1] Operand 1
     /*  238721 */     // No operand predicates
     /*  238721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238748 */     GIR_RootConstrainSelectedInstOperands,
     /*  238749 */     // GIR_Coverage, 9344,
     /*  238749 */     GIR_EraseRootFromParent_Done,
     /*  238750 */   // Label 4629: @238750
     /*  238750 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(238824), // Rule ID 9345 //
     /*  238755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238795 */     // MIs[1] Operand 1
     /*  238795 */     // No operand predicates
     /*  238795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  238807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238822 */     GIR_RootConstrainSelectedInstOperands,
     /*  238823 */     // GIR_Coverage, 9345,
     /*  238823 */     GIR_EraseRootFromParent_Done,
     /*  238824 */   // Label 4630: @238824
     /*  238824 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(238898), // Rule ID 9348 //
     /*  238829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238869 */     // MIs[1] Operand 1
     /*  238869 */     // No operand predicates
     /*  238869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238878 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238896 */     GIR_RootConstrainSelectedInstOperands,
     /*  238897 */     // GIR_Coverage, 9348,
     /*  238897 */     GIR_EraseRootFromParent_Done,
     /*  238898 */   // Label 4631: @238898
     /*  238898 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(238972), // Rule ID 9349 //
     /*  238903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238943 */     // MIs[1] Operand 1
     /*  238943 */     // No operand predicates
     /*  238943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  238955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238970 */     GIR_RootConstrainSelectedInstOperands,
     /*  238971 */     // GIR_Coverage, 9349,
     /*  238971 */     GIR_EraseRootFromParent_Done,
     /*  238972 */   // Label 4632: @238972
     /*  238972 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(239046), // Rule ID 9352 //
     /*  238977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  238985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239017 */     // MIs[1] Operand 1
     /*  239017 */     // No operand predicates
     /*  239017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239044 */     GIR_RootConstrainSelectedInstOperands,
     /*  239045 */     // GIR_Coverage, 9352,
     /*  239045 */     GIR_EraseRootFromParent_Done,
     /*  239046 */   // Label 4633: @239046
     /*  239046 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(239120), // Rule ID 9353 //
     /*  239051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  239065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239091 */     // MIs[1] Operand 1
     /*  239091 */     // No operand predicates
     /*  239091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239118 */     GIR_RootConstrainSelectedInstOperands,
     /*  239119 */     // GIR_Coverage, 9353,
     /*  239119 */     GIR_EraseRootFromParent_Done,
     /*  239120 */   // Label 4634: @239120
     /*  239120 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(239194), // Rule ID 9356 //
     /*  239125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239165 */     // MIs[1] Operand 1
     /*  239165 */     // No operand predicates
     /*  239165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239192 */     GIR_RootConstrainSelectedInstOperands,
     /*  239193 */     // GIR_Coverage, 9356,
     /*  239193 */     GIR_EraseRootFromParent_Done,
     /*  239194 */   // Label 4635: @239194
     /*  239194 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(239268), // Rule ID 9357 //
     /*  239199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  239213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239239 */     // MIs[1] Operand 1
     /*  239239 */     // No operand predicates
     /*  239239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239266 */     GIR_RootConstrainSelectedInstOperands,
     /*  239267 */     // GIR_Coverage, 9357,
     /*  239267 */     GIR_EraseRootFromParent_Done,
     /*  239268 */   // Label 4636: @239268
     /*  239268 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(239342), // Rule ID 9360 //
     /*  239273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239313 */     // MIs[1] Operand 1
     /*  239313 */     // No operand predicates
     /*  239313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  239322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239340 */     GIR_RootConstrainSelectedInstOperands,
     /*  239341 */     // GIR_Coverage, 9360,
     /*  239341 */     GIR_EraseRootFromParent_Done,
     /*  239342 */   // Label 4637: @239342
     /*  239342 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(239416), // Rule ID 9361 //
     /*  239347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  239358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  239361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239387 */     // MIs[1] Operand 1
     /*  239387 */     // No operand predicates
     /*  239387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  239396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  239414 */     GIR_RootConstrainSelectedInstOperands,
     /*  239415 */     // GIR_Coverage, 9361,
     /*  239415 */     GIR_EraseRootFromParent_Done,
     /*  239416 */   // Label 4638: @239416
     /*  239416 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(239490), // Rule ID 9364 //
     /*  239421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239461 */     // MIs[1] Operand 1
     /*  239461 */     // No operand predicates
     /*  239461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239488 */     GIR_RootConstrainSelectedInstOperands,
     /*  239489 */     // GIR_Coverage, 9364,
     /*  239489 */     GIR_EraseRootFromParent_Done,
     /*  239490 */   // Label 4639: @239490
     /*  239490 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(239564), // Rule ID 9365 //
     /*  239495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  239506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  239509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  239523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239535 */     // MIs[1] Operand 1
     /*  239535 */     // No operand predicates
     /*  239535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  239547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239562 */     GIR_RootConstrainSelectedInstOperands,
     /*  239563 */     // GIR_Coverage, 9365,
     /*  239563 */     GIR_EraseRootFromParent_Done,
     /*  239564 */   // Label 4640: @239564
     /*  239564 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(239638), // Rule ID 9368 //
     /*  239569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239609 */     // MIs[1] Operand 1
     /*  239609 */     // No operand predicates
     /*  239609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239636 */     GIR_RootConstrainSelectedInstOperands,
     /*  239637 */     // GIR_Coverage, 9368,
     /*  239637 */     GIR_EraseRootFromParent_Done,
     /*  239638 */   // Label 4641: @239638
     /*  239638 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(239712), // Rule ID 9369 //
     /*  239643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239683 */     // MIs[1] Operand 1
     /*  239683 */     // No operand predicates
     /*  239683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  239695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239710 */     GIR_RootConstrainSelectedInstOperands,
     /*  239711 */     // GIR_Coverage, 9369,
     /*  239711 */     GIR_EraseRootFromParent_Done,
     /*  239712 */   // Label 4642: @239712
     /*  239712 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(239786), // Rule ID 9372 //
     /*  239717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239757 */     // MIs[1] Operand 1
     /*  239757 */     // No operand predicates
     /*  239757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239784 */     GIR_RootConstrainSelectedInstOperands,
     /*  239785 */     // GIR_Coverage, 9372,
     /*  239785 */     GIR_EraseRootFromParent_Done,
     /*  239786 */   // Label 4643: @239786
     /*  239786 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(239860), // Rule ID 9373 //
     /*  239791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239831 */     // MIs[1] Operand 1
     /*  239831 */     // No operand predicates
     /*  239831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  239843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239858 */     GIR_RootConstrainSelectedInstOperands,
     /*  239859 */     // GIR_Coverage, 9373,
     /*  239859 */     GIR_EraseRootFromParent_Done,
     /*  239860 */   // Label 4644: @239860
     /*  239860 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(239934), // Rule ID 9464 //
     /*  239865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239905 */     // MIs[1] Operand 1
     /*  239905 */     // No operand predicates
     /*  239905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239914 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  239917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239932 */     GIR_RootConstrainSelectedInstOperands,
     /*  239933 */     // GIR_Coverage, 9464,
     /*  239933 */     GIR_EraseRootFromParent_Done,
     /*  239934 */   // Label 4645: @239934
     /*  239934 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(240008), // Rule ID 9465 //
     /*  239939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239979 */     // MIs[1] Operand 1
     /*  239979 */     // No operand predicates
     /*  239979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  239991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240006 */     GIR_RootConstrainSelectedInstOperands,
     /*  240007 */     // GIR_Coverage, 9465,
     /*  240007 */     GIR_EraseRootFromParent_Done,
     /*  240008 */   // Label 4646: @240008
     /*  240008 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(240082), // Rule ID 9468 //
     /*  240013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  240027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240053 */     // MIs[1] Operand 1
     /*  240053 */     // No operand predicates
     /*  240053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240080 */     GIR_RootConstrainSelectedInstOperands,
     /*  240081 */     // GIR_Coverage, 9468,
     /*  240081 */     GIR_EraseRootFromParent_Done,
     /*  240082 */   // Label 4647: @240082
     /*  240082 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(240156), // Rule ID 9469 //
     /*  240087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  240101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240127 */     // MIs[1] Operand 1
     /*  240127 */     // No operand predicates
     /*  240127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240154 */     GIR_RootConstrainSelectedInstOperands,
     /*  240155 */     // GIR_Coverage, 9469,
     /*  240155 */     GIR_EraseRootFromParent_Done,
     /*  240156 */   // Label 4648: @240156
     /*  240156 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(240230), // Rule ID 9472 //
     /*  240161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  240175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240201 */     // MIs[1] Operand 1
     /*  240201 */     // No operand predicates
     /*  240201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240228 */     GIR_RootConstrainSelectedInstOperands,
     /*  240229 */     // GIR_Coverage, 9472,
     /*  240229 */     GIR_EraseRootFromParent_Done,
     /*  240230 */   // Label 4649: @240230
     /*  240230 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(240304), // Rule ID 9473 //
     /*  240235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  240249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240275 */     // MIs[1] Operand 1
     /*  240275 */     // No operand predicates
     /*  240275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240302 */     GIR_RootConstrainSelectedInstOperands,
     /*  240303 */     // GIR_Coverage, 9473,
     /*  240303 */     GIR_EraseRootFromParent_Done,
     /*  240304 */   // Label 4650: @240304
     /*  240304 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(240378), // Rule ID 9476 //
     /*  240309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240349 */     // MIs[1] Operand 1
     /*  240349 */     // No operand predicates
     /*  240349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240376 */     GIR_RootConstrainSelectedInstOperands,
     /*  240377 */     // GIR_Coverage, 9476,
     /*  240377 */     GIR_EraseRootFromParent_Done,
     /*  240378 */   // Label 4651: @240378
     /*  240378 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(240452), // Rule ID 9477 //
     /*  240383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240423 */     // MIs[1] Operand 1
     /*  240423 */     // No operand predicates
     /*  240423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  240435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240450 */     GIR_RootConstrainSelectedInstOperands,
     /*  240451 */     // GIR_Coverage, 9477,
     /*  240451 */     GIR_EraseRootFromParent_Done,
     /*  240452 */   // Label 4652: @240452
     /*  240452 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(240526), // Rule ID 9480 //
     /*  240457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240497 */     // MIs[1] Operand 1
     /*  240497 */     // No operand predicates
     /*  240497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240524 */     GIR_RootConstrainSelectedInstOperands,
     /*  240525 */     // GIR_Coverage, 9480,
     /*  240525 */     GIR_EraseRootFromParent_Done,
     /*  240526 */   // Label 4653: @240526
     /*  240526 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(240600), // Rule ID 9481 //
     /*  240531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  240542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240571 */     // MIs[1] Operand 1
     /*  240571 */     // No operand predicates
     /*  240571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  240580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240598 */     GIR_RootConstrainSelectedInstOperands,
     /*  240599 */     // GIR_Coverage, 9481,
     /*  240599 */     GIR_EraseRootFromParent_Done,
     /*  240600 */   // Label 4654: @240600
     /*  240600 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(240674), // Rule ID 9484 //
     /*  240605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240645 */     // MIs[1] Operand 1
     /*  240645 */     // No operand predicates
     /*  240645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  240654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240672 */     GIR_RootConstrainSelectedInstOperands,
     /*  240673 */     // GIR_Coverage, 9484,
     /*  240673 */     GIR_EraseRootFromParent_Done,
     /*  240674 */   // Label 4655: @240674
     /*  240674 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(240748), // Rule ID 9485 //
     /*  240679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240719 */     // MIs[1] Operand 1
     /*  240719 */     // No operand predicates
     /*  240719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  240728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  240731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240746 */     GIR_RootConstrainSelectedInstOperands,
     /*  240747 */     // GIR_Coverage, 9485,
     /*  240747 */     GIR_EraseRootFromParent_Done,
     /*  240748 */   // Label 4656: @240748
     /*  240748 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(240822), // Rule ID 9488 //
     /*  240753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  240767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240793 */     // MIs[1] Operand 1
     /*  240793 */     // No operand predicates
     /*  240793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240820 */     GIR_RootConstrainSelectedInstOperands,
     /*  240821 */     // GIR_Coverage, 9488,
     /*  240821 */     GIR_EraseRootFromParent_Done,
     /*  240822 */   // Label 4657: @240822
     /*  240822 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(240896), // Rule ID 9489 //
     /*  240827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  240838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  240841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240867 */     // MIs[1] Operand 1
     /*  240867 */     // No operand predicates
     /*  240867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240894 */     GIR_RootConstrainSelectedInstOperands,
     /*  240895 */     // GIR_Coverage, 9489,
     /*  240895 */     GIR_EraseRootFromParent_Done,
     /*  240896 */   // Label 4658: @240896
     /*  240896 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(240970), // Rule ID 9492 //
     /*  240901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  240918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  240933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  240937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  240941 */     // MIs[1] Operand 1
     /*  240941 */     // No operand predicates
     /*  240941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  240943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  240950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  240953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  240960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240968 */     GIR_RootConstrainSelectedInstOperands,
     /*  240969 */     // GIR_Coverage, 9492,
     /*  240969 */     GIR_EraseRootFromParent_Done,
     /*  240970 */   // Label 4659: @240970
     /*  240970 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(241044), // Rule ID 9493 //
     /*  240975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  240983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  240986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  240992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241015 */     // MIs[1] Operand 1
     /*  241015 */     // No operand predicates
     /*  241015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241042 */     GIR_RootConstrainSelectedInstOperands,
     /*  241043 */     // GIR_Coverage, 9493,
     /*  241043 */     GIR_EraseRootFromParent_Done,
     /*  241044 */   // Label 4660: @241044
     /*  241044 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(241118), // Rule ID 9496 //
     /*  241049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241089 */     // MIs[1] Operand 1
     /*  241089 */     // No operand predicates
     /*  241089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  241098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241116 */     GIR_RootConstrainSelectedInstOperands,
     /*  241117 */     // GIR_Coverage, 9496,
     /*  241117 */     GIR_EraseRootFromParent_Done,
     /*  241118 */   // Label 4661: @241118
     /*  241118 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(241192), // Rule ID 9497 //
     /*  241123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  241134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241163 */     // MIs[1] Operand 1
     /*  241163 */     // No operand predicates
     /*  241163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  241172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241190 */     GIR_RootConstrainSelectedInstOperands,
     /*  241191 */     // GIR_Coverage, 9497,
     /*  241191 */     GIR_EraseRootFromParent_Done,
     /*  241192 */   // Label 4662: @241192
     /*  241192 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(241266), // Rule ID 9500 //
     /*  241197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  241200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241237 */     // MIs[1] Operand 1
     /*  241237 */     // No operand predicates
     /*  241237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  241246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241264 */     GIR_RootConstrainSelectedInstOperands,
     /*  241265 */     // GIR_Coverage, 9500,
     /*  241265 */     GIR_EraseRootFromParent_Done,
     /*  241266 */   // Label 4663: @241266
     /*  241266 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(241340), // Rule ID 9501 //
     /*  241271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  241274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  241282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241311 */     // MIs[1] Operand 1
     /*  241311 */     // No operand predicates
     /*  241311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  241320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  241323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241338 */     GIR_RootConstrainSelectedInstOperands,
     /*  241339 */     // GIR_Coverage, 9501,
     /*  241339 */     GIR_EraseRootFromParent_Done,
     /*  241340 */   // Label 4664: @241340
     /*  241340 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(241414), // Rule ID 9504 //
     /*  241345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  241359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241385 */     // MIs[1] Operand 1
     /*  241385 */     // No operand predicates
     /*  241385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241394 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241412 */     GIR_RootConstrainSelectedInstOperands,
     /*  241413 */     // GIR_Coverage, 9504,
     /*  241413 */     GIR_EraseRootFromParent_Done,
     /*  241414 */   // Label 4665: @241414
     /*  241414 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(241488), // Rule ID 9505 //
     /*  241419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  241433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241459 */     // MIs[1] Operand 1
     /*  241459 */     // No operand predicates
     /*  241459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241486 */     GIR_RootConstrainSelectedInstOperands,
     /*  241487 */     // GIR_Coverage, 9505,
     /*  241487 */     GIR_EraseRootFromParent_Done,
     /*  241488 */   // Label 4666: @241488
     /*  241488 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(241562), // Rule ID 9508 //
     /*  241493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  241504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  241507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241533 */     // MIs[1] Operand 1
     /*  241533 */     // No operand predicates
     /*  241533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241542 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241560 */     GIR_RootConstrainSelectedInstOperands,
     /*  241561 */     // GIR_Coverage, 9508,
     /*  241561 */     GIR_EraseRootFromParent_Done,
     /*  241562 */   // Label 4667: @241562
     /*  241562 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(241636), // Rule ID 9509 //
     /*  241567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  241578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  241581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241607 */     // MIs[1] Operand 1
     /*  241607 */     // No operand predicates
     /*  241607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241616 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241634 */     GIR_RootConstrainSelectedInstOperands,
     /*  241635 */     // GIR_Coverage, 9509,
     /*  241635 */     GIR_EraseRootFromParent_Done,
     /*  241636 */   // Label 4668: @241636
     /*  241636 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(241710), // Rule ID 9512 //
     /*  241641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  241652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  241655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241681 */     // MIs[1] Operand 1
     /*  241681 */     // No operand predicates
     /*  241681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241690 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  241690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  241693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241708 */     GIR_RootConstrainSelectedInstOperands,
     /*  241709 */     // GIR_Coverage, 9512,
     /*  241709 */     GIR_EraseRootFromParent_Done,
     /*  241710 */   // Label 4669: @241710
     /*  241710 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(241784), // Rule ID 9513 //
     /*  241715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  241726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  241729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241755 */     // MIs[1] Operand 1
     /*  241755 */     // No operand predicates
     /*  241755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241764 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  241764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  241767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  241782 */     GIR_RootConstrainSelectedInstOperands,
     /*  241783 */     // GIR_Coverage, 9513,
     /*  241783 */     GIR_EraseRootFromParent_Done,
     /*  241784 */   // Label 4670: @241784
     /*  241784 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(241858), // Rule ID 9516 //
     /*  241789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241829 */     // MIs[1] Operand 1
     /*  241829 */     // No operand predicates
     /*  241829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241856 */     GIR_RootConstrainSelectedInstOperands,
     /*  241857 */     // GIR_Coverage, 9516,
     /*  241857 */     GIR_EraseRootFromParent_Done,
     /*  241858 */   // Label 4671: @241858
     /*  241858 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(241932), // Rule ID 9517 //
     /*  241863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  241874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  241877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  241880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241903 */     // MIs[1] Operand 1
     /*  241903 */     // No operand predicates
     /*  241903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  241912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  241915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241930 */     GIR_RootConstrainSelectedInstOperands,
     /*  241931 */     // GIR_Coverage, 9517,
     /*  241931 */     GIR_EraseRootFromParent_Done,
     /*  241932 */   // Label 4672: @241932
     /*  241932 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(242006), // Rule ID 9520 //
     /*  241937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  241945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  241948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  241951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  241954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  241969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  241973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  241977 */     // MIs[1] Operand 1
     /*  241977 */     // No operand predicates
     /*  241977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  241979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  241986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  241989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  241993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  241996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242004 */     GIR_RootConstrainSelectedInstOperands,
     /*  242005 */     // GIR_Coverage, 9520,
     /*  242005 */     GIR_EraseRootFromParent_Done,
     /*  242006 */   // Label 4673: @242006
     /*  242006 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(242080), // Rule ID 9521 //
     /*  242011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  242025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242051 */     // MIs[1] Operand 1
     /*  242051 */     // No operand predicates
     /*  242051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242078 */     GIR_RootConstrainSelectedInstOperands,
     /*  242079 */     // GIR_Coverage, 9521,
     /*  242079 */     GIR_EraseRootFromParent_Done,
     /*  242080 */   // Label 4674: @242080
     /*  242080 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(242154), // Rule ID 9524 //
     /*  242085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242125 */     // MIs[1] Operand 1
     /*  242125 */     // No operand predicates
     /*  242125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242134 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  242134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242152 */     GIR_RootConstrainSelectedInstOperands,
     /*  242153 */     // GIR_Coverage, 9524,
     /*  242153 */     GIR_EraseRootFromParent_Done,
     /*  242154 */   // Label 4675: @242154
     /*  242154 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(242228), // Rule ID 9525 //
     /*  242159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  242170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  242173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242199 */     // MIs[1] Operand 1
     /*  242199 */     // No operand predicates
     /*  242199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242208 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  242208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  242226 */     GIR_RootConstrainSelectedInstOperands,
     /*  242227 */     // GIR_Coverage, 9525,
     /*  242227 */     GIR_EraseRootFromParent_Done,
     /*  242228 */   // Label 4676: @242228
     /*  242228 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(242302), // Rule ID 9528 //
     /*  242233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242273 */     // MIs[1] Operand 1
     /*  242273 */     // No operand predicates
     /*  242273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242300 */     GIR_RootConstrainSelectedInstOperands,
     /*  242301 */     // GIR_Coverage, 9528,
     /*  242301 */     GIR_EraseRootFromParent_Done,
     /*  242302 */   // Label 4677: @242302
     /*  242302 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(242376), // Rule ID 9529 //
     /*  242307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242347 */     // MIs[1] Operand 1
     /*  242347 */     // No operand predicates
     /*  242347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242374 */     GIR_RootConstrainSelectedInstOperands,
     /*  242375 */     // GIR_Coverage, 9529,
     /*  242375 */     GIR_EraseRootFromParent_Done,
     /*  242376 */   // Label 4678: @242376
     /*  242376 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(242450), // Rule ID 9532 //
     /*  242381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242421 */     // MIs[1] Operand 1
     /*  242421 */     // No operand predicates
     /*  242421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242448 */     GIR_RootConstrainSelectedInstOperands,
     /*  242449 */     // GIR_Coverage, 9532,
     /*  242449 */     GIR_EraseRootFromParent_Done,
     /*  242450 */   // Label 4679: @242450
     /*  242450 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(242524), // Rule ID 9533 //
     /*  242455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242495 */     // MIs[1] Operand 1
     /*  242495 */     // No operand predicates
     /*  242495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242522 */     GIR_RootConstrainSelectedInstOperands,
     /*  242523 */     // GIR_Coverage, 9533,
     /*  242523 */     GIR_EraseRootFromParent_Done,
     /*  242524 */   // Label 4680: @242524
     /*  242524 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(242598), // Rule ID 9536 //
     /*  242529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242569 */     // MIs[1] Operand 1
     /*  242569 */     // No operand predicates
     /*  242569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  242578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242596 */     GIR_RootConstrainSelectedInstOperands,
     /*  242597 */     // GIR_Coverage, 9536,
     /*  242597 */     GIR_EraseRootFromParent_Done,
     /*  242598 */   // Label 4681: @242598
     /*  242598 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(242672), // Rule ID 9537 //
     /*  242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242643 */     // MIs[1] Operand 1
     /*  242643 */     // No operand predicates
     /*  242643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  242652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  242655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242670 */     GIR_RootConstrainSelectedInstOperands,
     /*  242671 */     // GIR_Coverage, 9537,
     /*  242671 */     GIR_EraseRootFromParent_Done,
     /*  242672 */   // Label 4682: @242672
     /*  242672 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(242746), // Rule ID 9540 //
     /*  242677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242717 */     // MIs[1] Operand 1
     /*  242717 */     // No operand predicates
     /*  242717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  242726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242744 */     GIR_RootConstrainSelectedInstOperands,
     /*  242745 */     // GIR_Coverage, 9540,
     /*  242745 */     GIR_EraseRootFromParent_Done,
     /*  242746 */   // Label 4683: @242746
     /*  242746 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(242820), // Rule ID 9541 //
     /*  242751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  242754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  242762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242791 */     // MIs[1] Operand 1
     /*  242791 */     // No operand predicates
     /*  242791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  242800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  242803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242818 */     GIR_RootConstrainSelectedInstOperands,
     /*  242819 */     // GIR_Coverage, 9541,
     /*  242819 */     GIR_EraseRootFromParent_Done,
     /*  242820 */   // Label 4684: @242820
     /*  242820 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(242894), // Rule ID 9544 //
     /*  242825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242865 */     // MIs[1] Operand 1
     /*  242865 */     // No operand predicates
     /*  242865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  242874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242892 */     GIR_RootConstrainSelectedInstOperands,
     /*  242893 */     // GIR_Coverage, 9544,
     /*  242893 */     GIR_EraseRootFromParent_Done,
     /*  242894 */   // Label 4685: @242894
     /*  242894 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(242968), // Rule ID 9545 //
     /*  242899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  242902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  242910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  242916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  242931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  242935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  242939 */     // MIs[1] Operand 1
     /*  242939 */     // No operand predicates
     /*  242939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  242941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  242948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  242951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  242955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  242958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242966 */     GIR_RootConstrainSelectedInstOperands,
     /*  242967 */     // GIR_Coverage, 9545,
     /*  242967 */     GIR_EraseRootFromParent_Done,
     /*  242968 */   // Label 4686: @242968
     /*  242968 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(243042), // Rule ID 9548 //
     /*  242973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  242976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  242981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  242984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  242990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  243005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  243009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  243013 */     // MIs[1] Operand 1
     /*  243013 */     // No operand predicates
     /*  243013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  243015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  243022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  243025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  243032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243040 */     GIR_RootConstrainSelectedInstOperands,
     /*  243041 */     // GIR_Coverage, 9548,
     /*  243041 */     GIR_EraseRootFromParent_Done,
     /*  243042 */   // Label 4687: @243042
     /*  243042 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(243116), // Rule ID 9549 //
     /*  243047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  243050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  243055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  243058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  243064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  243079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  243083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  243087 */     // MIs[1] Operand 1
     /*  243087 */     // No operand predicates
     /*  243087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  243089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  243096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  243099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  243106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243114 */     GIR_RootConstrainSelectedInstOperands,
     /*  243115 */     // GIR_Coverage, 9549,
     /*  243115 */     GIR_EraseRootFromParent_Done,
     /*  243116 */   // Label 4688: @243116
     /*  243116 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(243172), // Rule ID 64439 //
     /*  243121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  243124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  243129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  243132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  243135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243143 */     // MIs[0] pts
     /*  243143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  243146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  243151 */     // MIs[0] radix
     /*  243151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  243154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  243159 */     // (intrinsic_wo_chain:{ *:[i32] } 10934:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  243159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  243162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243166 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  243168 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  243170 */     GIR_RootConstrainSelectedInstOperands,
     /*  243171 */     // GIR_Coverage, 64439,
     /*  243171 */     GIR_EraseRootFromParent_Done,
     /*  243172 */   // Label 4689: @243172
     /*  243172 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(243235), // Rule ID 2678 //
     /*  243177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  243180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  243185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  243188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  243191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  243209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243216 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  243216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  243219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243223 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  243225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243233 */     GIR_RootConstrainSelectedInstOperands,
     /*  243234 */     // GIR_Coverage, 2678,
     /*  243234 */     GIR_EraseRootFromParent_Done,
     /*  243235 */   // Label 4690: @243235
     /*  243235 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(243298), // Rule ID 2679 //
     /*  243240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  243243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  243248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  243251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  243254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  243264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  243272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243279 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  243279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  243282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243286 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  243288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243296 */     GIR_RootConstrainSelectedInstOperands,
     /*  243297 */     // GIR_Coverage, 2679,
     /*  243297 */     GIR_EraseRootFromParent_Done,
     /*  243298 */   // Label 4691: @243298
     /*  243298 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(243364), // Rule ID 2686 //
     /*  243303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  243311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  243314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  243342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  243345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243362 */     GIR_RootConstrainSelectedInstOperands,
     /*  243363 */     // GIR_Coverage, 2686,
     /*  243363 */     GIR_EraseRootFromParent_Done,
     /*  243364 */   // Label 4692: @243364
     /*  243364 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(243430), // Rule ID 2687 //
     /*  243369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  243377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  243380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  243386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  243408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  243411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243428 */     GIR_RootConstrainSelectedInstOperands,
     /*  243429 */     // GIR_Coverage, 2687,
     /*  243429 */     GIR_EraseRootFromParent_Done,
     /*  243430 */   // Label 4693: @243430
     /*  243430 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(243496), // Rule ID 2690 //
     /*  243435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  243477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243494 */     GIR_RootConstrainSelectedInstOperands,
     /*  243495 */     // GIR_Coverage, 2690,
     /*  243495 */     GIR_EraseRootFromParent_Done,
     /*  243496 */   // Label 4694: @243496
     /*  243496 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(243562), // Rule ID 2691 //
     /*  243501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  243543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243560 */     GIR_RootConstrainSelectedInstOperands,
     /*  243561 */     // GIR_Coverage, 2691,
     /*  243561 */     GIR_EraseRootFromParent_Done,
     /*  243562 */   // Label 4695: @243562
     /*  243562 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(243628), // Rule ID 2694 //
     /*  243567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  243570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  243575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  243609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243626 */     GIR_RootConstrainSelectedInstOperands,
     /*  243627 */     // GIR_Coverage, 2694,
     /*  243627 */     GIR_EraseRootFromParent_Done,
     /*  243628 */   // Label 4696: @243628
     /*  243628 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(243694), // Rule ID 2695 //
     /*  243633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  243636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  243641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243672 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  243675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243692 */     GIR_RootConstrainSelectedInstOperands,
     /*  243693 */     // GIR_Coverage, 2695,
     /*  243693 */     GIR_EraseRootFromParent_Done,
     /*  243694 */   // Label 4697: @243694
     /*  243694 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(243757), // Rule ID 2708 //
     /*  243699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  243707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  243741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243755 */     GIR_RootConstrainSelectedInstOperands,
     /*  243756 */     // GIR_Coverage, 2708,
     /*  243756 */     GIR_EraseRootFromParent_Done,
     /*  243757 */   // Label 4698: @243757
     /*  243757 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(243820), // Rule ID 2709 //
     /*  243762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  243770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243801 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  243801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  243804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243818 */     GIR_RootConstrainSelectedInstOperands,
     /*  243819 */     // GIR_Coverage, 2709,
     /*  243819 */     GIR_EraseRootFromParent_Done,
     /*  243820 */   // Label 4699: @243820
     /*  243820 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(243883), // Rule ID 2720 //
     /*  243825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  243833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  243867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243881 */     GIR_RootConstrainSelectedInstOperands,
     /*  243882 */     // GIR_Coverage, 2720,
     /*  243882 */     GIR_EraseRootFromParent_Done,
     /*  243883 */   // Label 4700: @243883
     /*  243883 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(243946), // Rule ID 2721 //
     /*  243888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  243896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  243927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  243930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  243934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  243936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  243944 */     GIR_RootConstrainSelectedInstOperands,
     /*  243945 */     // GIR_Coverage, 2721,
     /*  243945 */     GIR_EraseRootFromParent_Done,
     /*  243946 */   // Label 4701: @243946
     /*  243946 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(244009), // Rule ID 2728 //
     /*  243951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  243959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  243962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  243965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  243990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  243993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  243997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  244007 */     GIR_RootConstrainSelectedInstOperands,
     /*  244008 */     // GIR_Coverage, 2728,
     /*  244008 */     GIR_EraseRootFromParent_Done,
     /*  244009 */   // Label 4702: @244009
     /*  244009 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(244072), // Rule ID 2729 //
     /*  244014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  244022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  244028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244053 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  244053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  244056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  244070 */     GIR_RootConstrainSelectedInstOperands,
     /*  244071 */     // GIR_Coverage, 2729,
     /*  244071 */     GIR_EraseRootFromParent_Done,
     /*  244072 */   // Label 4703: @244072
     /*  244072 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(244138), // Rule ID 2730 //
     /*  244077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  244080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  244119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244136 */     GIR_RootConstrainSelectedInstOperands,
     /*  244137 */     // GIR_Coverage, 2730,
     /*  244137 */     GIR_EraseRootFromParent_Done,
     /*  244138 */   // Label 4704: @244138
     /*  244138 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(244204), // Rule ID 2731 //
     /*  244143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  244146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  244151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  244185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244202 */     GIR_RootConstrainSelectedInstOperands,
     /*  244203 */     // GIR_Coverage, 2731,
     /*  244203 */     GIR_EraseRootFromParent_Done,
     /*  244204 */   // Label 4705: @244204
     /*  244204 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(244267), // Rule ID 2742 //
     /*  244209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  244217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  244223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  244226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  244248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  244251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244265 */     GIR_RootConstrainSelectedInstOperands,
     /*  244266 */     // GIR_Coverage, 2742,
     /*  244266 */     GIR_EraseRootFromParent_Done,
     /*  244267 */   // Label 4706: @244267
     /*  244267 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(244330), // Rule ID 2743 //
     /*  244272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  244280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  244283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  244286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  244289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244311 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  244311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  244314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  244318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244328 */     GIR_RootConstrainSelectedInstOperands,
     /*  244329 */     // GIR_Coverage, 2743,
     /*  244329 */     GIR_EraseRootFromParent_Done,
     /*  244330 */   // Label 4707: @244330
     /*  244330 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(244396), // Rule ID 4890 //
     /*  244335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  244377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244394 */     GIR_RootConstrainSelectedInstOperands,
     /*  244395 */     // GIR_Coverage, 4890,
     /*  244395 */     GIR_EraseRootFromParent_Done,
     /*  244396 */   // Label 4708: @244396
     /*  244396 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(244462), // Rule ID 4891 //
     /*  244401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  244443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244460 */     GIR_RootConstrainSelectedInstOperands,
     /*  244461 */     // GIR_Coverage, 4891,
     /*  244461 */     GIR_EraseRootFromParent_Done,
     /*  244462 */   // Label 4709: @244462
     /*  244462 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(244528), // Rule ID 4894 //
     /*  244467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  244509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244526 */     GIR_RootConstrainSelectedInstOperands,
     /*  244527 */     // GIR_Coverage, 4894,
     /*  244527 */     GIR_EraseRootFromParent_Done,
     /*  244528 */   // Label 4710: @244528
     /*  244528 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(244594), // Rule ID 4895 //
     /*  244533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11616:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  244575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244592 */     GIR_RootConstrainSelectedInstOperands,
     /*  244593 */     // GIR_Coverage, 4895,
     /*  244593 */     GIR_EraseRootFromParent_Done,
     /*  244594 */   // Label 4711: @244594
     /*  244594 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(244660), // Rule ID 4898 //
     /*  244599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  244641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244658 */     GIR_RootConstrainSelectedInstOperands,
     /*  244659 */     // GIR_Coverage, 4898,
     /*  244659 */     GIR_EraseRootFromParent_Done,
     /*  244660 */   // Label 4712: @244660
     /*  244660 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(244726), // Rule ID 4899 //
     /*  244665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  244707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244724 */     GIR_RootConstrainSelectedInstOperands,
     /*  244725 */     // GIR_Coverage, 4899,
     /*  244725 */     GIR_EraseRootFromParent_Done,
     /*  244726 */   // Label 4713: @244726
     /*  244726 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(244792), // Rule ID 4902 //
     /*  244731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  244773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244790 */     GIR_RootConstrainSelectedInstOperands,
     /*  244791 */     // GIR_Coverage, 4902,
     /*  244791 */     GIR_EraseRootFromParent_Done,
     /*  244792 */   // Label 4714: @244792
     /*  244792 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(244858), // Rule ID 4903 //
     /*  244797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  244839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244856 */     GIR_RootConstrainSelectedInstOperands,
     /*  244857 */     // GIR_Coverage, 4903,
     /*  244857 */     GIR_EraseRootFromParent_Done,
     /*  244858 */   // Label 4715: @244858
     /*  244858 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(244924), // Rule ID 4906 //
     /*  244863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  244905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244922 */     GIR_RootConstrainSelectedInstOperands,
     /*  244923 */     // GIR_Coverage, 4906,
     /*  244923 */     GIR_EraseRootFromParent_Done,
     /*  244924 */   // Label 4716: @244924
     /*  244924 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(244990), // Rule ID 4907 //
     /*  244929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  244937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  244971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244988 */     GIR_RootConstrainSelectedInstOperands,
     /*  244989 */     // GIR_Coverage, 4907,
     /*  244989 */     GIR_EraseRootFromParent_Done,
     /*  244990 */   // Label 4717: @244990
     /*  244990 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(245056), // Rule ID 4910 //
     /*  244995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  245037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245054 */     GIR_RootConstrainSelectedInstOperands,
     /*  245055 */     // GIR_Coverage, 4910,
     /*  245055 */     GIR_EraseRootFromParent_Done,
     /*  245056 */   // Label 4718: @245056
     /*  245056 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(245122), // Rule ID 4911 //
     /*  245061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  245078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  245103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245120 */     GIR_RootConstrainSelectedInstOperands,
     /*  245121 */     // GIR_Coverage, 4911,
     /*  245121 */     GIR_EraseRootFromParent_Done,
     /*  245122 */   // Label 4719: @245122
     /*  245122 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(245188), // Rule ID 4914 //
     /*  245127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245186 */     GIR_RootConstrainSelectedInstOperands,
     /*  245187 */     // GIR_Coverage, 4914,
     /*  245187 */     GIR_EraseRootFromParent_Done,
     /*  245188 */   // Label 4720: @245188
     /*  245188 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(245254), // Rule ID 4915 //
     /*  245193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245252 */     GIR_RootConstrainSelectedInstOperands,
     /*  245253 */     // GIR_Coverage, 4915,
     /*  245253 */     GIR_EraseRootFromParent_Done,
     /*  245254 */   // Label 4721: @245254
     /*  245254 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(245320), // Rule ID 4918 //
     /*  245259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245318 */     GIR_RootConstrainSelectedInstOperands,
     /*  245319 */     // GIR_Coverage, 4918,
     /*  245319 */     GIR_EraseRootFromParent_Done,
     /*  245320 */   // Label 4722: @245320
     /*  245320 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(245386), // Rule ID 4919 //
     /*  245325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245384 */     GIR_RootConstrainSelectedInstOperands,
     /*  245385 */     // GIR_Coverage, 4919,
     /*  245385 */     GIR_EraseRootFromParent_Done,
     /*  245386 */   // Label 4723: @245386
     /*  245386 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(245452), // Rule ID 4922 //
     /*  245391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245450 */     GIR_RootConstrainSelectedInstOperands,
     /*  245451 */     // GIR_Coverage, 4922,
     /*  245451 */     GIR_EraseRootFromParent_Done,
     /*  245452 */   // Label 4724: @245452
     /*  245452 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(245518), // Rule ID 4923 //
     /*  245457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245516 */     GIR_RootConstrainSelectedInstOperands,
     /*  245517 */     // GIR_Coverage, 4923,
     /*  245517 */     GIR_EraseRootFromParent_Done,
     /*  245518 */   // Label 4725: @245518
     /*  245518 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(245584), // Rule ID 4926 //
     /*  245523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  245565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245582 */     GIR_RootConstrainSelectedInstOperands,
     /*  245583 */     // GIR_Coverage, 4926,
     /*  245583 */     GIR_EraseRootFromParent_Done,
     /*  245584 */   // Label 4726: @245584
     /*  245584 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(245650), // Rule ID 4927 //
     /*  245589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  245631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245648 */     GIR_RootConstrainSelectedInstOperands,
     /*  245649 */     // GIR_Coverage, 4927,
     /*  245649 */     GIR_EraseRootFromParent_Done,
     /*  245650 */   // Label 4727: @245650
     /*  245650 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(245716), // Rule ID 4930 //
     /*  245655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245714 */     GIR_RootConstrainSelectedInstOperands,
     /*  245715 */     // GIR_Coverage, 4930,
     /*  245715 */     GIR_EraseRootFromParent_Done,
     /*  245716 */   // Label 4728: @245716
     /*  245716 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(245782), // Rule ID 4931 //
     /*  245721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  245763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245780 */     GIR_RootConstrainSelectedInstOperands,
     /*  245781 */     // GIR_Coverage, 4931,
     /*  245781 */     GIR_EraseRootFromParent_Done,
     /*  245782 */   // Label 4729: @245782
     /*  245782 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(245848), // Rule ID 4934 //
     /*  245787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245846 */     GIR_RootConstrainSelectedInstOperands,
     /*  245847 */     // GIR_Coverage, 4934,
     /*  245847 */     GIR_EraseRootFromParent_Done,
     /*  245848 */   // Label 4730: @245848
     /*  245848 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(245914), // Rule ID 4935 //
     /*  245853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  245895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245912 */     GIR_RootConstrainSelectedInstOperands,
     /*  245913 */     // GIR_Coverage, 4935,
     /*  245913 */     GIR_EraseRootFromParent_Done,
     /*  245914 */   // Label 4731: @245914
     /*  245914 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(245980), // Rule ID 4938 //
     /*  245919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  245961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245978 */     GIR_RootConstrainSelectedInstOperands,
     /*  245979 */     // GIR_Coverage, 4938,
     /*  245979 */     GIR_EraseRootFromParent_Done,
     /*  245980 */   // Label 4732: @245980
     /*  245980 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246046), // Rule ID 4939 //
     /*  245985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  245993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  246002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  246027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246044 */     GIR_RootConstrainSelectedInstOperands,
     /*  246045 */     // GIR_Coverage, 4939,
     /*  246045 */     GIR_EraseRootFromParent_Done,
     /*  246046 */   // Label 4733: @246046
     /*  246046 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246112), // Rule ID 4942 //
     /*  246051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  246093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246110 */     GIR_RootConstrainSelectedInstOperands,
     /*  246111 */     // GIR_Coverage, 4942,
     /*  246111 */     GIR_EraseRootFromParent_Done,
     /*  246112 */   // Label 4734: @246112
     /*  246112 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246178), // Rule ID 4943 //
     /*  246117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  246134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  246159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246176 */     GIR_RootConstrainSelectedInstOperands,
     /*  246177 */     // GIR_Coverage, 4943,
     /*  246177 */     GIR_EraseRootFromParent_Done,
     /*  246178 */   // Label 4735: @246178
     /*  246178 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246244), // Rule ID 4946 //
     /*  246183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  246225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246242 */     GIR_RootConstrainSelectedInstOperands,
     /*  246243 */     // GIR_Coverage, 4946,
     /*  246243 */     GIR_EraseRootFromParent_Done,
     /*  246244 */   // Label 4736: @246244
     /*  246244 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246310), // Rule ID 4947 //
     /*  246249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  246291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246308 */     GIR_RootConstrainSelectedInstOperands,
     /*  246309 */     // GIR_Coverage, 4947,
     /*  246309 */     GIR_EraseRootFromParent_Done,
     /*  246310 */   // Label 4737: @246310
     /*  246310 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246376), // Rule ID 4950 //
     /*  246315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246374 */     GIR_RootConstrainSelectedInstOperands,
     /*  246375 */     // GIR_Coverage, 4950,
     /*  246375 */     GIR_EraseRootFromParent_Done,
     /*  246376 */   // Label 4738: @246376
     /*  246376 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246442), // Rule ID 4951 //
     /*  246381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11616:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246440 */     GIR_RootConstrainSelectedInstOperands,
     /*  246441 */     // GIR_Coverage, 4951,
     /*  246441 */     GIR_EraseRootFromParent_Done,
     /*  246442 */   // Label 4739: @246442
     /*  246442 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246508), // Rule ID 4954 //
     /*  246447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  246489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246506 */     GIR_RootConstrainSelectedInstOperands,
     /*  246507 */     // GIR_Coverage, 4954,
     /*  246507 */     GIR_EraseRootFromParent_Done,
     /*  246508 */   // Label 4740: @246508
     /*  246508 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246574), // Rule ID 4955 //
     /*  246513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  246555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246572 */     GIR_RootConstrainSelectedInstOperands,
     /*  246573 */     // GIR_Coverage, 4955,
     /*  246573 */     GIR_EraseRootFromParent_Done,
     /*  246574 */   // Label 4741: @246574
     /*  246574 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246640), // Rule ID 4958 //
     /*  246579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  246621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246638 */     GIR_RootConstrainSelectedInstOperands,
     /*  246639 */     // GIR_Coverage, 4958,
     /*  246639 */     GIR_EraseRootFromParent_Done,
     /*  246640 */   // Label 4742: @246640
     /*  246640 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246706), // Rule ID 4959 //
     /*  246645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246684 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  246687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246704 */     GIR_RootConstrainSelectedInstOperands,
     /*  246705 */     // GIR_Coverage, 4959,
     /*  246705 */     GIR_EraseRootFromParent_Done,
     /*  246706 */   // Label 4743: @246706
     /*  246706 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(246772), // Rule ID 4962 //
     /*  246711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  246753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246770 */     GIR_RootConstrainSelectedInstOperands,
     /*  246771 */     // GIR_Coverage, 4962,
     /*  246771 */     GIR_EraseRootFromParent_Done,
     /*  246772 */   // Label 4744: @246772
     /*  246772 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(246838), // Rule ID 4963 //
     /*  246777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  246819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246836 */     GIR_RootConstrainSelectedInstOperands,
     /*  246837 */     // GIR_Coverage, 4963,
     /*  246837 */     GIR_EraseRootFromParent_Done,
     /*  246838 */   // Label 4745: @246838
     /*  246838 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(246904), // Rule ID 4966 //
     /*  246843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246902 */     GIR_RootConstrainSelectedInstOperands,
     /*  246903 */     // GIR_Coverage, 4966,
     /*  246903 */     GIR_EraseRootFromParent_Done,
     /*  246904 */   // Label 4746: @246904
     /*  246904 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(246970), // Rule ID 4967 //
     /*  246909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  246951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246968 */     GIR_RootConstrainSelectedInstOperands,
     /*  246969 */     // GIR_Coverage, 4967,
     /*  246969 */     GIR_EraseRootFromParent_Done,
     /*  246970 */   // Label 4747: @246970
     /*  246970 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247036), // Rule ID 4970 //
     /*  246975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  246983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  247017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247034 */     GIR_RootConstrainSelectedInstOperands,
     /*  247035 */     // GIR_Coverage, 4970,
     /*  247035 */     GIR_EraseRootFromParent_Done,
     /*  247036 */   // Label 4748: @247036
     /*  247036 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247102), // Rule ID 4971 //
     /*  247041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  247083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247100 */     GIR_RootConstrainSelectedInstOperands,
     /*  247101 */     // GIR_Coverage, 4971,
     /*  247101 */     GIR_EraseRootFromParent_Done,
     /*  247102 */   // Label 4749: @247102
     /*  247102 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247168), // Rule ID 4974 //
     /*  247107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  247149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247166 */     GIR_RootConstrainSelectedInstOperands,
     /*  247167 */     // GIR_Coverage, 4974,
     /*  247167 */     GIR_EraseRootFromParent_Done,
     /*  247168 */   // Label 4750: @247168
     /*  247168 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247234), // Rule ID 4975 //
     /*  247173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  247215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247232 */     GIR_RootConstrainSelectedInstOperands,
     /*  247233 */     // GIR_Coverage, 4975,
     /*  247233 */     GIR_EraseRootFromParent_Done,
     /*  247234 */   // Label 4751: @247234
     /*  247234 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247300), // Rule ID 4978 //
     /*  247239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  247281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247298 */     GIR_RootConstrainSelectedInstOperands,
     /*  247299 */     // GIR_Coverage, 4978,
     /*  247299 */     GIR_EraseRootFromParent_Done,
     /*  247300 */   // Label 4752: @247300
     /*  247300 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247366), // Rule ID 4979 //
     /*  247305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  247347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247364 */     GIR_RootConstrainSelectedInstOperands,
     /*  247365 */     // GIR_Coverage, 4979,
     /*  247365 */     GIR_EraseRootFromParent_Done,
     /*  247366 */   // Label 4753: @247366
     /*  247366 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247432), // Rule ID 4982 //
     /*  247371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  247413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247430 */     GIR_RootConstrainSelectedInstOperands,
     /*  247431 */     // GIR_Coverage, 4982,
     /*  247431 */     GIR_EraseRootFromParent_Done,
     /*  247432 */   // Label 4754: @247432
     /*  247432 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247498), // Rule ID 4983 //
     /*  247437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11616:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  247479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247496 */     GIR_RootConstrainSelectedInstOperands,
     /*  247497 */     // GIR_Coverage, 4983,
     /*  247497 */     GIR_EraseRootFromParent_Done,
     /*  247498 */   // Label 4755: @247498
     /*  247498 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247564), // Rule ID 4986 //
     /*  247503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  247545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247562 */     GIR_RootConstrainSelectedInstOperands,
     /*  247563 */     // GIR_Coverage, 4986,
     /*  247563 */     GIR_EraseRootFromParent_Done,
     /*  247564 */   // Label 4756: @247564
     /*  247564 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247630), // Rule ID 4987 //
     /*  247569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11616:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  247611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247628 */     GIR_RootConstrainSelectedInstOperands,
     /*  247629 */     // GIR_Coverage, 4987,
     /*  247629 */     GIR_EraseRootFromParent_Done,
     /*  247630 */   // Label 4757: @247630
     /*  247630 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247696), // Rule ID 4990 //
     /*  247635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  247677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247694 */     GIR_RootConstrainSelectedInstOperands,
     /*  247695 */     // GIR_Coverage, 4990,
     /*  247695 */     GIR_EraseRootFromParent_Done,
     /*  247696 */   // Label 4758: @247696
     /*  247696 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247762), // Rule ID 4991 //
     /*  247701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11616:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  247743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247760 */     GIR_RootConstrainSelectedInstOperands,
     /*  247761 */     // GIR_Coverage, 4991,
     /*  247761 */     GIR_EraseRootFromParent_Done,
     /*  247762 */   // Label 4759: @247762
     /*  247762 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247828), // Rule ID 4994 //
     /*  247767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  247809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247826 */     GIR_RootConstrainSelectedInstOperands,
     /*  247827 */     // GIR_Coverage, 4994,
     /*  247827 */     GIR_EraseRootFromParent_Done,
     /*  247828 */   // Label 4760: @247828
     /*  247828 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247894), // Rule ID 4995 //
     /*  247833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  247841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11616:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  247875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247892 */     GIR_RootConstrainSelectedInstOperands,
     /*  247893 */     // GIR_Coverage, 4995,
     /*  247893 */     GIR_EraseRootFromParent_Done,
     /*  247894 */   // Label 4761: @247894
     /*  247894 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247960), // Rule ID 4998 //
     /*  247899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  247938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  247941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247958 */     GIR_RootConstrainSelectedInstOperands,
     /*  247959 */     // GIR_Coverage, 4998,
     /*  247959 */     GIR_EraseRootFromParent_Done,
     /*  247960 */   // Label 4762: @247960
     /*  247960 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(248026), // Rule ID 4999 //
     /*  247965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  247976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  248007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248024 */     GIR_RootConstrainSelectedInstOperands,
     /*  248025 */     // GIR_Coverage, 4999,
     /*  248025 */     GIR_EraseRootFromParent_Done,
     /*  248026 */   // Label 4763: @248026
     /*  248026 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(248092), // Rule ID 5002 //
     /*  248031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  248042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248090 */     GIR_RootConstrainSelectedInstOperands,
     /*  248091 */     // GIR_Coverage, 5002,
     /*  248091 */     GIR_EraseRootFromParent_Done,
     /*  248092 */   // Label 4764: @248092
     /*  248092 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(248158), // Rule ID 5003 //
     /*  248097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  248108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  248114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248156 */     GIR_RootConstrainSelectedInstOperands,
     /*  248157 */     // GIR_Coverage, 5003,
     /*  248157 */     GIR_EraseRootFromParent_Done,
     /*  248158 */   // Label 4765: @248158
     /*  248158 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248224), // Rule ID 5006 //
     /*  248163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  248174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248222 */     GIR_RootConstrainSelectedInstOperands,
     /*  248223 */     // GIR_Coverage, 5006,
     /*  248223 */     GIR_EraseRootFromParent_Done,
     /*  248224 */   // Label 4766: @248224
     /*  248224 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248290), // Rule ID 5007 //
     /*  248229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  248240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  248246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248288 */     GIR_RootConstrainSelectedInstOperands,
     /*  248289 */     // GIR_Coverage, 5007,
     /*  248289 */     GIR_EraseRootFromParent_Done,
     /*  248290 */   // Label 4767: @248290
     /*  248290 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248356), // Rule ID 5010 //
     /*  248295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248354 */     GIR_RootConstrainSelectedInstOperands,
     /*  248355 */     // GIR_Coverage, 5010,
     /*  248355 */     GIR_EraseRootFromParent_Done,
     /*  248356 */   // Label 4768: @248356
     /*  248356 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248422), // Rule ID 5011 //
     /*  248361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  248372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248420 */     GIR_RootConstrainSelectedInstOperands,
     /*  248421 */     // GIR_Coverage, 5011,
     /*  248421 */     GIR_EraseRootFromParent_Done,
     /*  248422 */   // Label 4769: @248422
     /*  248422 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248488), // Rule ID 5014 //
     /*  248427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  248469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248486 */     GIR_RootConstrainSelectedInstOperands,
     /*  248487 */     // GIR_Coverage, 5014,
     /*  248487 */     GIR_EraseRootFromParent_Done,
     /*  248488 */   // Label 4770: @248488
     /*  248488 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248554), // Rule ID 5015 //
     /*  248493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  248504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  248535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248552 */     GIR_RootConstrainSelectedInstOperands,
     /*  248553 */     // GIR_Coverage, 5015,
     /*  248553 */     GIR_EraseRootFromParent_Done,
     /*  248554 */   // Label 4771: @248554
     /*  248554 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248620), // Rule ID 5018 //
     /*  248559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  248598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  248601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248618 */     GIR_RootConstrainSelectedInstOperands,
     /*  248619 */     // GIR_Coverage, 5018,
     /*  248619 */     GIR_EraseRootFromParent_Done,
     /*  248620 */   // Label 4772: @248620
     /*  248620 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248686), // Rule ID 5019 //
     /*  248625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  248636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  248639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248664 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  248664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  248667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248684 */     GIR_RootConstrainSelectedInstOperands,
     /*  248685 */     // GIR_Coverage, 5019,
     /*  248685 */     GIR_EraseRootFromParent_Done,
     /*  248686 */   // Label 4773: @248686
     /*  248686 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248752), // Rule ID 5022 //
     /*  248691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  248702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248750 */     GIR_RootConstrainSelectedInstOperands,
     /*  248751 */     // GIR_Coverage, 5022,
     /*  248751 */     GIR_EraseRootFromParent_Done,
     /*  248752 */   // Label 4774: @248752
     /*  248752 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248818), // Rule ID 5023 //
     /*  248757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  248768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  248799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248816 */     GIR_RootConstrainSelectedInstOperands,
     /*  248817 */     // GIR_Coverage, 5023,
     /*  248817 */     GIR_EraseRootFromParent_Done,
     /*  248818 */   // Label 4775: @248818
     /*  248818 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248884), // Rule ID 5026 //
     /*  248823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  248834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248882 */     GIR_RootConstrainSelectedInstOperands,
     /*  248883 */     // GIR_Coverage, 5026,
     /*  248883 */     GIR_EraseRootFromParent_Done,
     /*  248884 */   // Label 4776: @248884
     /*  248884 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248950), // Rule ID 5027 //
     /*  248889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  248900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  248928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  248931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  248935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  248948 */     GIR_RootConstrainSelectedInstOperands,
     /*  248949 */     // GIR_Coverage, 5027,
     /*  248949 */     GIR_EraseRootFromParent_Done,
     /*  248950 */   // Label 4777: @248950
     /*  248950 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(249016), // Rule ID 5030 //
     /*  248955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  248963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  248966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  248969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  248994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  248997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249014 */     GIR_RootConstrainSelectedInstOperands,
     /*  249015 */     // GIR_Coverage, 5030,
     /*  249015 */     GIR_EraseRootFromParent_Done,
     /*  249016 */   // Label 4778: @249016
     /*  249016 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(249082), // Rule ID 5031 //
     /*  249021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  249032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  249038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249080 */     GIR_RootConstrainSelectedInstOperands,
     /*  249081 */     // GIR_Coverage, 5031,
     /*  249081 */     GIR_EraseRootFromParent_Done,
     /*  249082 */   // Label 4779: @249082
     /*  249082 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(249148), // Rule ID 5034 //
     /*  249087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249146 */     GIR_RootConstrainSelectedInstOperands,
     /*  249147 */     // GIR_Coverage, 5034,
     /*  249147 */     GIR_EraseRootFromParent_Done,
     /*  249148 */   // Label 4780: @249148
     /*  249148 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(249214), // Rule ID 5035 //
     /*  249153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  249164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249212 */     GIR_RootConstrainSelectedInstOperands,
     /*  249213 */     // GIR_Coverage, 5035,
     /*  249213 */     GIR_EraseRootFromParent_Done,
     /*  249214 */   // Label 4781: @249214
     /*  249214 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(249280), // Rule ID 5038 //
     /*  249219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249278 */     GIR_RootConstrainSelectedInstOperands,
     /*  249279 */     // GIR_Coverage, 5038,
     /*  249279 */     GIR_EraseRootFromParent_Done,
     /*  249280 */   // Label 4782: @249280
     /*  249280 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(249346), // Rule ID 5039 //
     /*  249285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  249296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249324 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249344 */     GIR_RootConstrainSelectedInstOperands,
     /*  249345 */     // GIR_Coverage, 5039,
     /*  249345 */     GIR_EraseRootFromParent_Done,
     /*  249346 */   // Label 4783: @249346
     /*  249346 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(249412), // Rule ID 5042 //
     /*  249351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  249393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249410 */     GIR_RootConstrainSelectedInstOperands,
     /*  249411 */     // GIR_Coverage, 5042,
     /*  249411 */     GIR_EraseRootFromParent_Done,
     /*  249412 */   // Label 4784: @249412
     /*  249412 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(249478), // Rule ID 5043 //
     /*  249417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  249428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  249431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  249434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  249459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249476 */     GIR_RootConstrainSelectedInstOperands,
     /*  249477 */     // GIR_Coverage, 5043,
     /*  249477 */     GIR_EraseRootFromParent_Done,
     /*  249478 */   // Label 4785: @249478
     /*  249478 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(249544), // Rule ID 5046 //
     /*  249483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  249494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249542 */     GIR_RootConstrainSelectedInstOperands,
     /*  249543 */     // GIR_Coverage, 5046,
     /*  249543 */     GIR_EraseRootFromParent_Done,
     /*  249544 */   // Label 4786: @249544
     /*  249544 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(249610), // Rule ID 5047 //
     /*  249549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  249560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  249566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  249591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249608 */     GIR_RootConstrainSelectedInstOperands,
     /*  249609 */     // GIR_Coverage, 5047,
     /*  249609 */     GIR_EraseRootFromParent_Done,
     /*  249610 */   // Label 4787: @249610
     /*  249610 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249676), // Rule ID 5050 //
     /*  249615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  249626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249654 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249674 */     GIR_RootConstrainSelectedInstOperands,
     /*  249675 */     // GIR_Coverage, 5050,
     /*  249675 */     GIR_EraseRootFromParent_Done,
     /*  249676 */   // Label 4788: @249676
     /*  249676 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249742), // Rule ID 5051 //
     /*  249681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  249692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  249723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249740 */     GIR_RootConstrainSelectedInstOperands,
     /*  249741 */     // GIR_Coverage, 5051,
     /*  249741 */     GIR_EraseRootFromParent_Done,
     /*  249742 */   // Label 4789: @249742
     /*  249742 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249808), // Rule ID 5054 //
     /*  249747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  249750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  249786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249806 */     GIR_RootConstrainSelectedInstOperands,
     /*  249807 */     // GIR_Coverage, 5054,
     /*  249807 */     GIR_EraseRootFromParent_Done,
     /*  249808 */   // Label 4790: @249808
     /*  249808 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249874), // Rule ID 5055 //
     /*  249813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  249816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  249824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  249852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  249855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249872 */     GIR_RootConstrainSelectedInstOperands,
     /*  249873 */     // GIR_Coverage, 5055,
     /*  249873 */     GIR_EraseRootFromParent_Done,
     /*  249874 */   // Label 4791: @249874
     /*  249874 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249940), // Rule ID 5058 //
     /*  249879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  249896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  249918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  249921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  249938 */     GIR_RootConstrainSelectedInstOperands,
     /*  249939 */     // GIR_Coverage, 5058,
     /*  249939 */     GIR_EraseRootFromParent_Done,
     /*  249940 */   // Label 4792: @249940
     /*  249940 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(250006), // Rule ID 5059 //
     /*  249945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  249953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  249956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  249959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  249962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249984 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  249984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  249987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  249991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250004 */     GIR_RootConstrainSelectedInstOperands,
     /*  250005 */     // GIR_Coverage, 5059,
     /*  250005 */     GIR_EraseRootFromParent_Done,
     /*  250006 */   // Label 4793: @250006
     /*  250006 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(250072), // Rule ID 5062 //
     /*  250011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  250028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250070 */     GIR_RootConstrainSelectedInstOperands,
     /*  250071 */     // GIR_Coverage, 5062,
     /*  250071 */     GIR_EraseRootFromParent_Done,
     /*  250072 */   // Label 4794: @250072
     /*  250072 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(250138), // Rule ID 5063 //
     /*  250077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  250088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  250094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250136 */     GIR_RootConstrainSelectedInstOperands,
     /*  250137 */     // GIR_Coverage, 5063,
     /*  250137 */     GIR_EraseRootFromParent_Done,
     /*  250138 */   // Label 4795: @250138
     /*  250138 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(250204), // Rule ID 5066 //
     /*  250143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  250160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250202 */     GIR_RootConstrainSelectedInstOperands,
     /*  250203 */     // GIR_Coverage, 5066,
     /*  250203 */     GIR_EraseRootFromParent_Done,
     /*  250204 */   // Label 4796: @250204
     /*  250204 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(250270), // Rule ID 5067 //
     /*  250209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  250220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  250223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  250226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250268 */     GIR_RootConstrainSelectedInstOperands,
     /*  250269 */     // GIR_Coverage, 5067,
     /*  250269 */     GIR_EraseRootFromParent_Done,
     /*  250270 */   // Label 4797: @250270
     /*  250270 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(250336), // Rule ID 5070 //
     /*  250275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  250292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250334 */     GIR_RootConstrainSelectedInstOperands,
     /*  250335 */     // GIR_Coverage, 5070,
     /*  250335 */     GIR_EraseRootFromParent_Done,
     /*  250336 */   // Label 4798: @250336
     /*  250336 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(250402), // Rule ID 5071 //
     /*  250341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  250352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  250355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  250358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250380 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250400 */     GIR_RootConstrainSelectedInstOperands,
     /*  250401 */     // GIR_Coverage, 5071,
     /*  250401 */     GIR_EraseRootFromParent_Done,
     /*  250402 */   // Label 4799: @250402
     /*  250402 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(250468), // Rule ID 5074 //
     /*  250407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  250424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  250446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250466 */     GIR_RootConstrainSelectedInstOperands,
     /*  250467 */     // GIR_Coverage, 5074,
     /*  250467 */     GIR_EraseRootFromParent_Done,
     /*  250468 */   // Label 4800: @250468
     /*  250468 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(250534), // Rule ID 5075 //
     /*  250473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  250484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  250487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  250490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  250512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250532 */     GIR_RootConstrainSelectedInstOperands,
     /*  250533 */     // GIR_Coverage, 5075,
     /*  250533 */     GIR_EraseRootFromParent_Done,
     /*  250534 */   // Label 4801: @250534
     /*  250534 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(250600), // Rule ID 5078 //
     /*  250539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  250550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  250553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250578 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250598 */     GIR_RootConstrainSelectedInstOperands,
     /*  250599 */     // GIR_Coverage, 5078,
     /*  250599 */     GIR_EraseRootFromParent_Done,
     /*  250600 */   // Label 4802: @250600
     /*  250600 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(250666), // Rule ID 5079 //
     /*  250605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  250616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  250619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  250622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  250647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250664 */     GIR_RootConstrainSelectedInstOperands,
     /*  250665 */     // GIR_Coverage, 5079,
     /*  250665 */     GIR_EraseRootFromParent_Done,
     /*  250666 */   // Label 4803: @250666
     /*  250666 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(250732), // Rule ID 5082 //
     /*  250671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  250682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250730 */     GIR_RootConstrainSelectedInstOperands,
     /*  250731 */     // GIR_Coverage, 5082,
     /*  250731 */     GIR_EraseRootFromParent_Done,
     /*  250732 */   // Label 4804: @250732
     /*  250732 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(250798), // Rule ID 5083 //
     /*  250737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  250748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  250754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  250779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250796 */     GIR_RootConstrainSelectedInstOperands,
     /*  250797 */     // GIR_Coverage, 5083,
     /*  250797 */     GIR_EraseRootFromParent_Done,
     /*  250798 */   // Label 4805: @250798
     /*  250798 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(250864), // Rule ID 5086 //
     /*  250803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250842 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250862 */     GIR_RootConstrainSelectedInstOperands,
     /*  250863 */     // GIR_Coverage, 5086,
     /*  250863 */     GIR_EraseRootFromParent_Done,
     /*  250864 */   // Label 4806: @250864
     /*  250864 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(250930), // Rule ID 5087 //
     /*  250869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  250872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  250880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  250886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  250908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  250911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250928 */     GIR_RootConstrainSelectedInstOperands,
     /*  250929 */     // GIR_Coverage, 5087,
     /*  250929 */     GIR_EraseRootFromParent_Done,
     /*  250930 */   // Label 4807: @250930
     /*  250930 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(250996), // Rule ID 5090 //
     /*  250935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  250938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  250943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  250946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  250952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  250974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  250977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  250981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  250994 */     GIR_RootConstrainSelectedInstOperands,
     /*  250995 */     // GIR_Coverage, 5090,
     /*  250995 */     GIR_EraseRootFromParent_Done,
     /*  250996 */   // Label 4808: @250996
     /*  250996 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(251062), // Rule ID 5091 //
     /*  251001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  251018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  251043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251060 */     GIR_RootConstrainSelectedInstOperands,
     /*  251061 */     // GIR_Coverage, 5091,
     /*  251061 */     GIR_EraseRootFromParent_Done,
     /*  251062 */   // Label 4809: @251062
     /*  251062 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(251128), // Rule ID 5094 //
     /*  251067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  251109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251126 */     GIR_RootConstrainSelectedInstOperands,
     /*  251127 */     // GIR_Coverage, 5094,
     /*  251127 */     GIR_EraseRootFromParent_Done,
     /*  251128 */   // Label 4810: @251128
     /*  251128 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(251194), // Rule ID 5095 //
     /*  251133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  251144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  251150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  251175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251192 */     GIR_RootConstrainSelectedInstOperands,
     /*  251193 */     // GIR_Coverage, 5095,
     /*  251193 */     GIR_EraseRootFromParent_Done,
     /*  251194 */   // Label 4811: @251194
     /*  251194 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(251260), // Rule ID 5098 //
     /*  251199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  251241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251258 */     GIR_RootConstrainSelectedInstOperands,
     /*  251259 */     // GIR_Coverage, 5098,
     /*  251259 */     GIR_EraseRootFromParent_Done,
     /*  251260 */   // Label 4812: @251260
     /*  251260 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(251326), // Rule ID 5099 //
     /*  251265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  251276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  251279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  251307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251324 */     GIR_RootConstrainSelectedInstOperands,
     /*  251325 */     // GIR_Coverage, 5099,
     /*  251325 */     GIR_EraseRootFromParent_Done,
     /*  251326 */   // Label 4813: @251326
     /*  251326 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(251392), // Rule ID 5102 //
     /*  251331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  251373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251390 */     GIR_RootConstrainSelectedInstOperands,
     /*  251391 */     // GIR_Coverage, 5102,
     /*  251391 */     GIR_EraseRootFromParent_Done,
     /*  251392 */   // Label 4814: @251392
     /*  251392 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(251458), // Rule ID 5103 //
     /*  251397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  251408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  251411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  251439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251456 */     GIR_RootConstrainSelectedInstOperands,
     /*  251457 */     // GIR_Coverage, 5103,
     /*  251457 */     GIR_EraseRootFromParent_Done,
     /*  251458 */   // Label 4815: @251458
     /*  251458 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(251524), // Rule ID 5106 //
     /*  251463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  251466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  251480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  251502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  251505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251522 */     GIR_RootConstrainSelectedInstOperands,
     /*  251523 */     // GIR_Coverage, 5106,
     /*  251523 */     GIR_EraseRootFromParent_Done,
     /*  251524 */   // Label 4816: @251524
     /*  251524 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(251590), // Rule ID 5107 //
     /*  251529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  251532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  251537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  251540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  251543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  251546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  251568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  251571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  251575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  251588 */     GIR_RootConstrainSelectedInstOperands,
     /*  251589 */     // GIR_Coverage, 5107,
     /*  251589 */     GIR_EraseRootFromParent_Done,
     /*  251590 */   // Label 4817: @251590
     /*  251590 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(251653), // Rule ID 5370 //
     /*  251595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251651 */     GIR_RootConstrainSelectedInstOperands,
     /*  251652 */     // GIR_Coverage, 5370,
     /*  251652 */     GIR_EraseRootFromParent_Done,
     /*  251653 */   // Label 4818: @251653
     /*  251653 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(251716), // Rule ID 5371 //
     /*  251658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  251672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  251675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251714 */     GIR_RootConstrainSelectedInstOperands,
     /*  251715 */     // GIR_Coverage, 5371,
     /*  251715 */     GIR_EraseRootFromParent_Done,
     /*  251716 */   // Label 4819: @251716
     /*  251716 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(251779), // Rule ID 5372 //
     /*  251721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  251763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251777 */     GIR_RootConstrainSelectedInstOperands,
     /*  251778 */     // GIR_Coverage, 5372,
     /*  251778 */     GIR_EraseRootFromParent_Done,
     /*  251779 */   // Label 4820: @251779
     /*  251779 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(251842), // Rule ID 5373 //
     /*  251784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  251798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  251801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  251826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251840 */     GIR_RootConstrainSelectedInstOperands,
     /*  251841 */     // GIR_Coverage, 5373,
     /*  251841 */     GIR_EraseRootFromParent_Done,
     /*  251842 */   // Label 4821: @251842
     /*  251842 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(251905), // Rule ID 5374 //
     /*  251847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  251864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251903 */     GIR_RootConstrainSelectedInstOperands,
     /*  251904 */     // GIR_Coverage, 5374,
     /*  251904 */     GIR_EraseRootFromParent_Done,
     /*  251905 */   // Label 4822: @251905
     /*  251905 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(251968), // Rule ID 5375 //
     /*  251910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  251924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  251927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251949 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  251952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251966 */     GIR_RootConstrainSelectedInstOperands,
     /*  251967 */     // GIR_Coverage, 5375,
     /*  251967 */     GIR_EraseRootFromParent_Done,
     /*  251968 */   // Label 4823: @251968
     /*  251968 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(252031), // Rule ID 5376 //
     /*  251973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  251987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  251990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252029 */     GIR_RootConstrainSelectedInstOperands,
     /*  252030 */     // GIR_Coverage, 5376,
     /*  252030 */     GIR_EraseRootFromParent_Done,
     /*  252031 */   // Label 4824: @252031
     /*  252031 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(252094), // Rule ID 5377 //
     /*  252036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  252050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  252053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252075 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252092 */     GIR_RootConstrainSelectedInstOperands,
     /*  252093 */     // GIR_Coverage, 5377,
     /*  252093 */     GIR_EraseRootFromParent_Done,
     /*  252094 */   // Label 4825: @252094
     /*  252094 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(252157), // Rule ID 5378 //
     /*  252099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  252116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252155 */     GIR_RootConstrainSelectedInstOperands,
     /*  252156 */     // GIR_Coverage, 5378,
     /*  252156 */     GIR_EraseRootFromParent_Done,
     /*  252157 */   // Label 4826: @252157
     /*  252157 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(252220), // Rule ID 5379 //
     /*  252162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  252176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  252179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252201 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  252204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252218 */     GIR_RootConstrainSelectedInstOperands,
     /*  252219 */     // GIR_Coverage, 5379,
     /*  252219 */     GIR_EraseRootFromParent_Done,
     /*  252220 */   // Label 4827: @252220
     /*  252220 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(252283), // Rule ID 5380 //
     /*  252225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  252239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  252242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252281 */     GIR_RootConstrainSelectedInstOperands,
     /*  252282 */     // GIR_Coverage, 5380,
     /*  252282 */     GIR_EraseRootFromParent_Done,
     /*  252283 */   // Label 4828: @252283
     /*  252283 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(252346), // Rule ID 5381 //
     /*  252288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  252302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  252305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252344 */     GIR_RootConstrainSelectedInstOperands,
     /*  252345 */     // GIR_Coverage, 5381,
     /*  252345 */     GIR_EraseRootFromParent_Done,
     /*  252346 */   // Label 4829: @252346
     /*  252346 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(252409), // Rule ID 5382 //
     /*  252351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  252365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252407 */     GIR_RootConstrainSelectedInstOperands,
     /*  252408 */     // GIR_Coverage, 5382,
     /*  252408 */     GIR_EraseRootFromParent_Done,
     /*  252409 */   // Label 4830: @252409
     /*  252409 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(252472), // Rule ID 5383 //
     /*  252414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  252428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  252431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252470 */     GIR_RootConstrainSelectedInstOperands,
     /*  252471 */     // GIR_Coverage, 5383,
     /*  252471 */     GIR_EraseRootFromParent_Done,
     /*  252472 */   // Label 4831: @252472
     /*  252472 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(252535), // Rule ID 5384 //
     /*  252477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  252494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252533 */     GIR_RootConstrainSelectedInstOperands,
     /*  252534 */     // GIR_Coverage, 5384,
     /*  252534 */     GIR_EraseRootFromParent_Done,
     /*  252535 */   // Label 4832: @252535
     /*  252535 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(252598), // Rule ID 5385 //
     /*  252540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  252554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  252557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252596 */     GIR_RootConstrainSelectedInstOperands,
     /*  252597 */     // GIR_Coverage, 5385,
     /*  252597 */     GIR_EraseRootFromParent_Done,
     /*  252598 */   // Label 4833: @252598
     /*  252598 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(252661), // Rule ID 5386 //
     /*  252603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  252620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252659 */     GIR_RootConstrainSelectedInstOperands,
     /*  252660 */     // GIR_Coverage, 5386,
     /*  252660 */     GIR_EraseRootFromParent_Done,
     /*  252661 */   // Label 4834: @252661
     /*  252661 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(252724), // Rule ID 5387 //
     /*  252666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  252680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  252683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  252708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252722 */     GIR_RootConstrainSelectedInstOperands,
     /*  252723 */     // GIR_Coverage, 5387,
     /*  252723 */     GIR_EraseRootFromParent_Done,
     /*  252724 */   // Label 4835: @252724
     /*  252724 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(252787), // Rule ID 5388 //
     /*  252729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  252771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252785 */     GIR_RootConstrainSelectedInstOperands,
     /*  252786 */     // GIR_Coverage, 5388,
     /*  252786 */     GIR_EraseRootFromParent_Done,
     /*  252787 */   // Label 4836: @252787
     /*  252787 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(252850), // Rule ID 5389 //
     /*  252792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  252806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  252809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252831 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  252834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252848 */     GIR_RootConstrainSelectedInstOperands,
     /*  252849 */     // GIR_Coverage, 5389,
     /*  252849 */     GIR_EraseRootFromParent_Done,
     /*  252850 */   // Label 4837: @252850
     /*  252850 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(252913), // Rule ID 5390 //
     /*  252855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252894 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  252897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252911 */     GIR_RootConstrainSelectedInstOperands,
     /*  252912 */     // GIR_Coverage, 5390,
     /*  252912 */     GIR_EraseRootFromParent_Done,
     /*  252913 */   // Label 4838: @252913
     /*  252913 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(252976), // Rule ID 5391 //
     /*  252918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  252932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  252935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252957 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  252960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252974 */     GIR_RootConstrainSelectedInstOperands,
     /*  252975 */     // GIR_Coverage, 5391,
     /*  252975 */     GIR_EraseRootFromParent_Done,
     /*  252976 */   // Label 4839: @252976
     /*  252976 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(253039), // Rule ID 5392 //
     /*  252981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  252992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  252995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  252998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253020 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253037 */     GIR_RootConstrainSelectedInstOperands,
     /*  253038 */     // GIR_Coverage, 5392,
     /*  253038 */     GIR_EraseRootFromParent_Done,
     /*  253039 */   // Label 4840: @253039
     /*  253039 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(253102), // Rule ID 5393 //
     /*  253044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  253055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  253058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  253061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253083 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253100 */     GIR_RootConstrainSelectedInstOperands,
     /*  253101 */     // GIR_Coverage, 5393,
     /*  253101 */     GIR_EraseRootFromParent_Done,
     /*  253102 */   // Label 4841: @253102
     /*  253102 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(253165), // Rule ID 5394 //
     /*  253107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  253121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  253124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253146 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253163 */     GIR_RootConstrainSelectedInstOperands,
     /*  253164 */     // GIR_Coverage, 5394,
     /*  253164 */     GIR_EraseRootFromParent_Done,
     /*  253165 */   // Label 4842: @253165
     /*  253165 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(253228), // Rule ID 5395 //
     /*  253170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  253184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  253187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253209 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253226 */     GIR_RootConstrainSelectedInstOperands,
     /*  253227 */     // GIR_Coverage, 5395,
     /*  253227 */     GIR_EraseRootFromParent_Done,
     /*  253228 */   // Label 4843: @253228
     /*  253228 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(253291), // Rule ID 5396 //
     /*  253233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  253247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  253250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253289 */     GIR_RootConstrainSelectedInstOperands,
     /*  253290 */     // GIR_Coverage, 5396,
     /*  253290 */     GIR_EraseRootFromParent_Done,
     /*  253291 */   // Label 4844: @253291
     /*  253291 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(253354), // Rule ID 5397 //
     /*  253296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  253310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  253313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253335 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253352 */     GIR_RootConstrainSelectedInstOperands,
     /*  253353 */     // GIR_Coverage, 5397,
     /*  253353 */     GIR_EraseRootFromParent_Done,
     /*  253354 */   // Label 4845: @253354
     /*  253354 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(253417), // Rule ID 5398 //
     /*  253359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  253370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  253373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  253376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253398 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253415 */     GIR_RootConstrainSelectedInstOperands,
     /*  253416 */     // GIR_Coverage, 5398,
     /*  253416 */     GIR_EraseRootFromParent_Done,
     /*  253417 */   // Label 4846: @253417
     /*  253417 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(253480), // Rule ID 5399 //
     /*  253422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  253433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  253436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  253439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253461 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253478 */     GIR_RootConstrainSelectedInstOperands,
     /*  253479 */     // GIR_Coverage, 5399,
     /*  253479 */     GIR_EraseRootFromParent_Done,
     /*  253480 */   // Label 4847: @253480
     /*  253480 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(253543), // Rule ID 5400 //
     /*  253485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  253499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253541 */     GIR_RootConstrainSelectedInstOperands,
     /*  253542 */     // GIR_Coverage, 5400,
     /*  253542 */     GIR_EraseRootFromParent_Done,
     /*  253543 */   // Label 4848: @253543
     /*  253543 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(253606), // Rule ID 5401 //
     /*  253548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  253562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  253565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253587 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253604 */     GIR_RootConstrainSelectedInstOperands,
     /*  253605 */     // GIR_Coverage, 5401,
     /*  253605 */     GIR_EraseRootFromParent_Done,
     /*  253606 */   // Label 4849: @253606
     /*  253606 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(253669), // Rule ID 5402 //
     /*  253611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253667 */     GIR_RootConstrainSelectedInstOperands,
     /*  253668 */     // GIR_Coverage, 5402,
     /*  253668 */     GIR_EraseRootFromParent_Done,
     /*  253669 */   // Label 4850: @253669
     /*  253669 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(253732), // Rule ID 5403 //
     /*  253674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  253688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  253691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253713 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  253716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253730 */     GIR_RootConstrainSelectedInstOperands,
     /*  253731 */     // GIR_Coverage, 5403,
     /*  253731 */     GIR_EraseRootFromParent_Done,
     /*  253732 */   // Label 4851: @253732
     /*  253732 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(253795), // Rule ID 5404 //
     /*  253737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  253754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253776 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253793 */     GIR_RootConstrainSelectedInstOperands,
     /*  253794 */     // GIR_Coverage, 5404,
     /*  253794 */     GIR_EraseRootFromParent_Done,
     /*  253795 */   // Label 4852: @253795
     /*  253795 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(253858), // Rule ID 5405 //
     /*  253800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  253814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  253817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253839 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  253842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253856 */     GIR_RootConstrainSelectedInstOperands,
     /*  253857 */     // GIR_Coverage, 5405,
     /*  253857 */     GIR_EraseRootFromParent_Done,
     /*  253858 */   // Label 4853: @253858
     /*  253858 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(253921), // Rule ID 5406 //
     /*  253863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  253880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253919 */     GIR_RootConstrainSelectedInstOperands,
     /*  253920 */     // GIR_Coverage, 5406,
     /*  253920 */     GIR_EraseRootFromParent_Done,
     /*  253921 */   // Label 4854: @253921
     /*  253921 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(253984), // Rule ID 5407 //
     /*  253926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  253940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  253943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253965 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  253968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253982 */     GIR_RootConstrainSelectedInstOperands,
     /*  253983 */     // GIR_Coverage, 5407,
     /*  253983 */     GIR_EraseRootFromParent_Done,
     /*  253984 */   // Label 4855: @253984
     /*  253984 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(254047), // Rule ID 5408 //
     /*  253989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  254003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  254006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  254031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254045 */     GIR_RootConstrainSelectedInstOperands,
     /*  254046 */     // GIR_Coverage, 5408,
     /*  254046 */     GIR_EraseRootFromParent_Done,
     /*  254047 */   // Label 4856: @254047
     /*  254047 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(254110), // Rule ID 5409 //
     /*  254052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  254066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  254069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254091 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  254094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254108 */     GIR_RootConstrainSelectedInstOperands,
     /*  254109 */     // GIR_Coverage, 5409,
     /*  254109 */     GIR_EraseRootFromParent_Done,
     /*  254110 */   // Label 4857: @254110
     /*  254110 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(254173), // Rule ID 5410 //
     /*  254115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  254129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  254132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  254157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254171 */     GIR_RootConstrainSelectedInstOperands,
     /*  254172 */     // GIR_Coverage, 5410,
     /*  254172 */     GIR_EraseRootFromParent_Done,
     /*  254173 */   // Label 4858: @254173
     /*  254173 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(254236), // Rule ID 5411 //
     /*  254178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  254192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  254195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  254220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254234 */     GIR_RootConstrainSelectedInstOperands,
     /*  254235 */     // GIR_Coverage, 5411,
     /*  254235 */     GIR_EraseRootFromParent_Done,
     /*  254236 */   // Label 4859: @254236
     /*  254236 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(254299), // Rule ID 5412 //
     /*  254241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  254255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  254283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254297 */     GIR_RootConstrainSelectedInstOperands,
     /*  254298 */     // GIR_Coverage, 5412,
     /*  254298 */     GIR_EraseRootFromParent_Done,
     /*  254299 */   // Label 4860: @254299
     /*  254299 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(254362), // Rule ID 5413 //
     /*  254304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  254318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  254346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254360 */     GIR_RootConstrainSelectedInstOperands,
     /*  254361 */     // GIR_Coverage, 5413,
     /*  254361 */     GIR_EraseRootFromParent_Done,
     /*  254362 */   // Label 4861: @254362
     /*  254362 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(254425), // Rule ID 5414 //
     /*  254367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  254381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254423 */     GIR_RootConstrainSelectedInstOperands,
     /*  254424 */     // GIR_Coverage, 5414,
     /*  254424 */     GIR_EraseRootFromParent_Done,
     /*  254425 */   // Label 4862: @254425
     /*  254425 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(254488), // Rule ID 5415 //
     /*  254430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  254444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254486 */     GIR_RootConstrainSelectedInstOperands,
     /*  254487 */     // GIR_Coverage, 5415,
     /*  254487 */     GIR_EraseRootFromParent_Done,
     /*  254488 */   // Label 4863: @254488
     /*  254488 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(254551), // Rule ID 5416 //
     /*  254493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  254507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254549 */     GIR_RootConstrainSelectedInstOperands,
     /*  254550 */     // GIR_Coverage, 5416,
     /*  254550 */     GIR_EraseRootFromParent_Done,
     /*  254551 */   // Label 4864: @254551
     /*  254551 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(254614), // Rule ID 5417 //
     /*  254556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  254570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254595 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254612 */     GIR_RootConstrainSelectedInstOperands,
     /*  254613 */     // GIR_Coverage, 5417,
     /*  254613 */     GIR_EraseRootFromParent_Done,
     /*  254614 */   // Label 4865: @254614
     /*  254614 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(254677), // Rule ID 5418 //
     /*  254619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254675 */     GIR_RootConstrainSelectedInstOperands,
     /*  254676 */     // GIR_Coverage, 5418,
     /*  254676 */     GIR_EraseRootFromParent_Done,
     /*  254677 */   // Label 4866: @254677
     /*  254677 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(254740), // Rule ID 5419 //
     /*  254682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  254696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254721 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  254724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254738 */     GIR_RootConstrainSelectedInstOperands,
     /*  254739 */     // GIR_Coverage, 5419,
     /*  254739 */     GIR_EraseRootFromParent_Done,
     /*  254740 */   // Label 4867: @254740
     /*  254740 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(254803), // Rule ID 5420 //
     /*  254745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254801 */     GIR_RootConstrainSelectedInstOperands,
     /*  254802 */     // GIR_Coverage, 5420,
     /*  254802 */     GIR_EraseRootFromParent_Done,
     /*  254803 */   // Label 4868: @254803
     /*  254803 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(254866), // Rule ID 5421 //
     /*  254808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  254822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254847 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254864 */     GIR_RootConstrainSelectedInstOperands,
     /*  254865 */     // GIR_Coverage, 5421,
     /*  254865 */     GIR_EraseRootFromParent_Done,
     /*  254866 */   // Label 4869: @254866
     /*  254866 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(254929), // Rule ID 5422 //
     /*  254871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  254888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254927 */     GIR_RootConstrainSelectedInstOperands,
     /*  254928 */     // GIR_Coverage, 5422,
     /*  254928 */     GIR_EraseRootFromParent_Done,
     /*  254929 */   // Label 4870: @254929
     /*  254929 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(254992), // Rule ID 5423 //
     /*  254934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  254942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  254948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  254951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  254966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254973 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  254976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254990 */     GIR_RootConstrainSelectedInstOperands,
     /*  254991 */     // GIR_Coverage, 5423,
     /*  254991 */     GIR_EraseRootFromParent_Done,
     /*  254992 */   // Label 4871: @254992
     /*  254992 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(255055), // Rule ID 5424 //
     /*  254997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  255011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255053 */     GIR_RootConstrainSelectedInstOperands,
     /*  255054 */     // GIR_Coverage, 5424,
     /*  255054 */     GIR_EraseRootFromParent_Done,
     /*  255055 */   // Label 4872: @255055
     /*  255055 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(255118), // Rule ID 5425 //
     /*  255060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  255074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255116 */     GIR_RootConstrainSelectedInstOperands,
     /*  255117 */     // GIR_Coverage, 5425,
     /*  255117 */     GIR_EraseRootFromParent_Done,
     /*  255118 */   // Label 4873: @255118
     /*  255118 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(255181), // Rule ID 5426 //
     /*  255123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  255137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255179 */     GIR_RootConstrainSelectedInstOperands,
     /*  255180 */     // GIR_Coverage, 5426,
     /*  255180 */     GIR_EraseRootFromParent_Done,
     /*  255181 */   // Label 4874: @255181
     /*  255181 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(255244), // Rule ID 5427 //
     /*  255186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  255200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255242 */     GIR_RootConstrainSelectedInstOperands,
     /*  255243 */     // GIR_Coverage, 5427,
     /*  255243 */     GIR_EraseRootFromParent_Done,
     /*  255244 */   // Label 4875: @255244
     /*  255244 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(255307), // Rule ID 5428 //
     /*  255249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255305 */     GIR_RootConstrainSelectedInstOperands,
     /*  255306 */     // GIR_Coverage, 5428,
     /*  255306 */     GIR_EraseRootFromParent_Done,
     /*  255307 */   // Label 4876: @255307
     /*  255307 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(255370), // Rule ID 5429 //
     /*  255312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  255326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255368 */     GIR_RootConstrainSelectedInstOperands,
     /*  255369 */     // GIR_Coverage, 5429,
     /*  255369 */     GIR_EraseRootFromParent_Done,
     /*  255370 */   // Label 4877: @255370
     /*  255370 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(255433), // Rule ID 5430 //
     /*  255375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255414 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255431 */     GIR_RootConstrainSelectedInstOperands,
     /*  255432 */     // GIR_Coverage, 5430,
     /*  255432 */     GIR_EraseRootFromParent_Done,
     /*  255433 */   // Label 4878: @255433
     /*  255433 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(255496), // Rule ID 5431 //
     /*  255438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  255452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255477 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  255480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255494 */     GIR_RootConstrainSelectedInstOperands,
     /*  255495 */     // GIR_Coverage, 5431,
     /*  255495 */     GIR_EraseRootFromParent_Done,
     /*  255496 */   // Label 4879: @255496
     /*  255496 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(255559), // Rule ID 5432 //
     /*  255501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  255515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255557 */     GIR_RootConstrainSelectedInstOperands,
     /*  255558 */     // GIR_Coverage, 5432,
     /*  255558 */     GIR_EraseRootFromParent_Done,
     /*  255559 */   // Label 4880: @255559
     /*  255559 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(255622), // Rule ID 5433 //
     /*  255564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  255578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255603 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255620 */     GIR_RootConstrainSelectedInstOperands,
     /*  255621 */     // GIR_Coverage, 5433,
     /*  255621 */     GIR_EraseRootFromParent_Done,
     /*  255622 */   // Label 4881: @255622
     /*  255622 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(255685), // Rule ID 5434 //
     /*  255627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255666 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  255669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255683 */     GIR_RootConstrainSelectedInstOperands,
     /*  255684 */     // GIR_Coverage, 5434,
     /*  255684 */     GIR_EraseRootFromParent_Done,
     /*  255685 */   // Label 4882: @255685
     /*  255685 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(255748), // Rule ID 5435 //
     /*  255690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  255704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255729 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  255732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255746 */     GIR_RootConstrainSelectedInstOperands,
     /*  255747 */     // GIR_Coverage, 5435,
     /*  255747 */     GIR_EraseRootFromParent_Done,
     /*  255748 */   // Label 4883: @255748
     /*  255748 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(255811), // Rule ID 5436 //
     /*  255753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255792 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  255795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255809 */     GIR_RootConstrainSelectedInstOperands,
     /*  255810 */     // GIR_Coverage, 5436,
     /*  255810 */     GIR_EraseRootFromParent_Done,
     /*  255811 */   // Label 4884: @255811
     /*  255811 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(255874), // Rule ID 5437 //
     /*  255816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  255827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  255830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255855 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  255858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255872 */     GIR_RootConstrainSelectedInstOperands,
     /*  255873 */     // GIR_Coverage, 5437,
     /*  255873 */     GIR_EraseRootFromParent_Done,
     /*  255874 */   // Label 4885: @255874
     /*  255874 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(255937), // Rule ID 5438 //
     /*  255879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255935 */     GIR_RootConstrainSelectedInstOperands,
     /*  255936 */     // GIR_Coverage, 5438,
     /*  255936 */     GIR_EraseRootFromParent_Done,
     /*  255937 */   // Label 4886: @255937
     /*  255937 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(256000), // Rule ID 5439 //
     /*  255942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  255950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  255956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255981 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  255984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255998 */     GIR_RootConstrainSelectedInstOperands,
     /*  255999 */     // GIR_Coverage, 5439,
     /*  255999 */     GIR_EraseRootFromParent_Done,
     /*  256000 */   // Label 4887: @256000
     /*  256000 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(256063), // Rule ID 5440 //
     /*  256005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  256019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256061 */     GIR_RootConstrainSelectedInstOperands,
     /*  256062 */     // GIR_Coverage, 5440,
     /*  256062 */     GIR_EraseRootFromParent_Done,
     /*  256063 */   // Label 4888: @256063
     /*  256063 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(256126), // Rule ID 5441 //
     /*  256068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  256082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256124 */     GIR_RootConstrainSelectedInstOperands,
     /*  256125 */     // GIR_Coverage, 5441,
     /*  256125 */     GIR_EraseRootFromParent_Done,
     /*  256126 */   // Label 4889: @256126
     /*  256126 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(256189), // Rule ID 5442 //
     /*  256131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  256145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256170 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256187 */     GIR_RootConstrainSelectedInstOperands,
     /*  256188 */     // GIR_Coverage, 5442,
     /*  256188 */     GIR_EraseRootFromParent_Done,
     /*  256189 */   // Label 4890: @256189
     /*  256189 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(256252), // Rule ID 5443 //
     /*  256194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  256208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256233 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256250 */     GIR_RootConstrainSelectedInstOperands,
     /*  256251 */     // GIR_Coverage, 5443,
     /*  256251 */     GIR_EraseRootFromParent_Done,
     /*  256252 */   // Label 4891: @256252
     /*  256252 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(256315), // Rule ID 5444 //
     /*  256257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  256271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256313 */     GIR_RootConstrainSelectedInstOperands,
     /*  256314 */     // GIR_Coverage, 5444,
     /*  256314 */     GIR_EraseRootFromParent_Done,
     /*  256315 */   // Label 4892: @256315
     /*  256315 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(256378), // Rule ID 5445 //
     /*  256320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  256334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256376 */     GIR_RootConstrainSelectedInstOperands,
     /*  256377 */     // GIR_Coverage, 5445,
     /*  256377 */     GIR_EraseRootFromParent_Done,
     /*  256378 */   // Label 4893: @256378
     /*  256378 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(256441), // Rule ID 5446 //
     /*  256383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  256397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256439 */     GIR_RootConstrainSelectedInstOperands,
     /*  256440 */     // GIR_Coverage, 5446,
     /*  256440 */     GIR_EraseRootFromParent_Done,
     /*  256441 */   // Label 4894: @256441
     /*  256441 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(256504), // Rule ID 5447 //
     /*  256446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  256460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256485 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256502 */     GIR_RootConstrainSelectedInstOperands,
     /*  256503 */     // GIR_Coverage, 5447,
     /*  256503 */     GIR_EraseRootFromParent_Done,
     /*  256504 */   // Label 4895: @256504
     /*  256504 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(256567), // Rule ID 5448 //
     /*  256509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256565 */     GIR_RootConstrainSelectedInstOperands,
     /*  256566 */     // GIR_Coverage, 5448,
     /*  256566 */     GIR_EraseRootFromParent_Done,
     /*  256567 */   // Label 4896: @256567
     /*  256567 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(256630), // Rule ID 5449 //
     /*  256572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  256586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256611 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256628 */     GIR_RootConstrainSelectedInstOperands,
     /*  256629 */     // GIR_Coverage, 5449,
     /*  256629 */     GIR_EraseRootFromParent_Done,
     /*  256630 */   // Label 4897: @256630
     /*  256630 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(256693), // Rule ID 5450 //
     /*  256635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256691 */     GIR_RootConstrainSelectedInstOperands,
     /*  256692 */     // GIR_Coverage, 5450,
     /*  256692 */     GIR_EraseRootFromParent_Done,
     /*  256693 */   // Label 4898: @256693
     /*  256693 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(256756), // Rule ID 5451 //
     /*  256698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  256712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  256740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256754 */     GIR_RootConstrainSelectedInstOperands,
     /*  256755 */     // GIR_Coverage, 5451,
     /*  256755 */     GIR_EraseRootFromParent_Done,
     /*  256756 */   // Label 4899: @256756
     /*  256756 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(256819), // Rule ID 5452 //
     /*  256761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256817 */     GIR_RootConstrainSelectedInstOperands,
     /*  256818 */     // GIR_Coverage, 5452,
     /*  256818 */     GIR_EraseRootFromParent_Done,
     /*  256819 */   // Label 4900: @256819
     /*  256819 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(256882), // Rule ID 5453 //
     /*  256824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  256838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  256866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256880 */     GIR_RootConstrainSelectedInstOperands,
     /*  256881 */     // GIR_Coverage, 5453,
     /*  256881 */     GIR_EraseRootFromParent_Done,
     /*  256882 */   // Label 4901: @256882
     /*  256882 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(256945), // Rule ID 5454 //
     /*  256887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256943 */     GIR_RootConstrainSelectedInstOperands,
     /*  256944 */     // GIR_Coverage, 5454,
     /*  256944 */     GIR_EraseRootFromParent_Done,
     /*  256945 */   // Label 4902: @256945
     /*  256945 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(257008), // Rule ID 5455 //
     /*  256950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  256958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  256964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  256992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257006 */     GIR_RootConstrainSelectedInstOperands,
     /*  257007 */     // GIR_Coverage, 5455,
     /*  257007 */     GIR_EraseRootFromParent_Done,
     /*  257008 */   // Label 4903: @257008
     /*  257008 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(257071), // Rule ID 5676 //
     /*  257013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  257027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  257030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  257055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257069 */     GIR_RootConstrainSelectedInstOperands,
     /*  257070 */     // GIR_Coverage, 5676,
     /*  257070 */     GIR_EraseRootFromParent_Done,
     /*  257071 */   // Label 4904: @257071
     /*  257071 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(257134), // Rule ID 5677 //
     /*  257076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  257090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  257093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  257118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257132 */     GIR_RootConstrainSelectedInstOperands,
     /*  257133 */     // GIR_Coverage, 5677,
     /*  257133 */     GIR_EraseRootFromParent_Done,
     /*  257134 */   // Label 4905: @257134
     /*  257134 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(257197), // Rule ID 5678 //
     /*  257139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  257153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  257156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257195 */     GIR_RootConstrainSelectedInstOperands,
     /*  257196 */     // GIR_Coverage, 5678,
     /*  257196 */     GIR_EraseRootFromParent_Done,
     /*  257197 */   // Label 4906: @257197
     /*  257197 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(257260), // Rule ID 5679 //
     /*  257202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  257216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  257219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257258 */     GIR_RootConstrainSelectedInstOperands,
     /*  257259 */     // GIR_Coverage, 5679,
     /*  257259 */     GIR_EraseRootFromParent_Done,
     /*  257260 */   // Label 4907: @257260
     /*  257260 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(257323), // Rule ID 5680 //
     /*  257265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  257279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  257282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257321 */     GIR_RootConstrainSelectedInstOperands,
     /*  257322 */     // GIR_Coverage, 5680,
     /*  257322 */     GIR_EraseRootFromParent_Done,
     /*  257323 */   // Label 4908: @257323
     /*  257323 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(257386), // Rule ID 5681 //
     /*  257328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  257342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  257345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257367 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257384 */     GIR_RootConstrainSelectedInstOperands,
     /*  257385 */     // GIR_Coverage, 5681,
     /*  257385 */     GIR_EraseRootFromParent_Done,
     /*  257386 */   // Label 4909: @257386
     /*  257386 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(257449), // Rule ID 5682 //
     /*  257391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  257408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257447 */     GIR_RootConstrainSelectedInstOperands,
     /*  257448 */     // GIR_Coverage, 5682,
     /*  257448 */     GIR_EraseRootFromParent_Done,
     /*  257449 */   // Label 4910: @257449
     /*  257449 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(257512), // Rule ID 5683 //
     /*  257454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  257468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  257471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257493 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  257496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257510 */     GIR_RootConstrainSelectedInstOperands,
     /*  257511 */     // GIR_Coverage, 5683,
     /*  257511 */     GIR_EraseRootFromParent_Done,
     /*  257512 */   // Label 4911: @257512
     /*  257512 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(257575), // Rule ID 5684 //
     /*  257517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  257534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257573 */     GIR_RootConstrainSelectedInstOperands,
     /*  257574 */     // GIR_Coverage, 5684,
     /*  257574 */     GIR_EraseRootFromParent_Done,
     /*  257575 */   // Label 4912: @257575
     /*  257575 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(257638), // Rule ID 5685 //
     /*  257580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  257594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  257597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257619 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257636 */     GIR_RootConstrainSelectedInstOperands,
     /*  257637 */     // GIR_Coverage, 5685,
     /*  257637 */     GIR_EraseRootFromParent_Done,
     /*  257638 */   // Label 4913: @257638
     /*  257638 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(257701), // Rule ID 5686 //
     /*  257643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257699 */     GIR_RootConstrainSelectedInstOperands,
     /*  257700 */     // GIR_Coverage, 5686,
     /*  257700 */     GIR_EraseRootFromParent_Done,
     /*  257701 */   // Label 4914: @257701
     /*  257701 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(257764), // Rule ID 5687 //
     /*  257706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  257720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  257723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257745 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  257748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257762 */     GIR_RootConstrainSelectedInstOperands,
     /*  257763 */     // GIR_Coverage, 5687,
     /*  257763 */     GIR_EraseRootFromParent_Done,
     /*  257764 */   // Label 4915: @257764
     /*  257764 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(257827), // Rule ID 5688 //
     /*  257769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  257786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257825 */     GIR_RootConstrainSelectedInstOperands,
     /*  257826 */     // GIR_Coverage, 5688,
     /*  257826 */     GIR_EraseRootFromParent_Done,
     /*  257827 */   // Label 4916: @257827
     /*  257827 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(257890), // Rule ID 5689 //
     /*  257832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  257846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  257849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257888 */     GIR_RootConstrainSelectedInstOperands,
     /*  257889 */     // GIR_Coverage, 5689,
     /*  257889 */     GIR_EraseRootFromParent_Done,
     /*  257890 */   // Label 4917: @257890
     /*  257890 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(257953), // Rule ID 5690 //
     /*  257895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  257912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257934 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  257937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257951 */     GIR_RootConstrainSelectedInstOperands,
     /*  257952 */     // GIR_Coverage, 5690,
     /*  257952 */     GIR_EraseRootFromParent_Done,
     /*  257953 */   // Label 4918: @257953
     /*  257953 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(258016), // Rule ID 5691 //
     /*  257958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  257972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  257975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257997 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258014 */     GIR_RootConstrainSelectedInstOperands,
     /*  258015 */     // GIR_Coverage, 5691,
     /*  258015 */     GIR_EraseRootFromParent_Done,
     /*  258016 */   // Label 4919: @258016
     /*  258016 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(258079), // Rule ID 5692 //
     /*  258021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  258038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258077 */     GIR_RootConstrainSelectedInstOperands,
     /*  258078 */     // GIR_Coverage, 5692,
     /*  258078 */     GIR_EraseRootFromParent_Done,
     /*  258079 */   // Label 4920: @258079
     /*  258079 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(258142), // Rule ID 5693 //
     /*  258084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  258098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  258101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258123 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258140 */     GIR_RootConstrainSelectedInstOperands,
     /*  258141 */     // GIR_Coverage, 5693,
     /*  258141 */     GIR_EraseRootFromParent_Done,
     /*  258142 */   // Label 4921: @258142
     /*  258142 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(258205), // Rule ID 5694 //
     /*  258147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  258161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258203 */     GIR_RootConstrainSelectedInstOperands,
     /*  258204 */     // GIR_Coverage, 5694,
     /*  258204 */     GIR_EraseRootFromParent_Done,
     /*  258205 */   // Label 4922: @258205
     /*  258205 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(258268), // Rule ID 5695 //
     /*  258210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  258224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  258227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258249 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  258252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258266 */     GIR_RootConstrainSelectedInstOperands,
     /*  258267 */     // GIR_Coverage, 5695,
     /*  258267 */     GIR_EraseRootFromParent_Done,
     /*  258268 */   // Label 4923: @258268
     /*  258268 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(258331), // Rule ID 5696 //
     /*  258273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  258287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  258290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258329 */     GIR_RootConstrainSelectedInstOperands,
     /*  258330 */     // GIR_Coverage, 5696,
     /*  258330 */     GIR_EraseRootFromParent_Done,
     /*  258331 */   // Label 4924: @258331
     /*  258331 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(258394), // Rule ID 5697 //
     /*  258336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  258350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  258353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258375 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258392 */     GIR_RootConstrainSelectedInstOperands,
     /*  258393 */     // GIR_Coverage, 5697,
     /*  258393 */     GIR_EraseRootFromParent_Done,
     /*  258394 */   // Label 4925: @258394
     /*  258394 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(258457), // Rule ID 5698 //
     /*  258399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  258413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  258416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258438 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258455 */     GIR_RootConstrainSelectedInstOperands,
     /*  258456 */     // GIR_Coverage, 5698,
     /*  258456 */     GIR_EraseRootFromParent_Done,
     /*  258457 */   // Label 4926: @258457
     /*  258457 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(258520), // Rule ID 5699 //
     /*  258462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  258476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  258479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258501 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258518 */     GIR_RootConstrainSelectedInstOperands,
     /*  258519 */     // GIR_Coverage, 5699,
     /*  258519 */     GIR_EraseRootFromParent_Done,
     /*  258520 */   // Label 4927: @258520
     /*  258520 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(258583), // Rule ID 5700 //
     /*  258525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  258536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  258539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  258542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258564 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258581 */     GIR_RootConstrainSelectedInstOperands,
     /*  258582 */     // GIR_Coverage, 5700,
     /*  258582 */     GIR_EraseRootFromParent_Done,
     /*  258583 */   // Label 4928: @258583
     /*  258583 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(258646), // Rule ID 5701 //
     /*  258588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  258599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  258602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  258605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258627 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258644 */     GIR_RootConstrainSelectedInstOperands,
     /*  258645 */     // GIR_Coverage, 5701,
     /*  258645 */     GIR_EraseRootFromParent_Done,
     /*  258646 */   // Label 4929: @258646
     /*  258646 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(258709), // Rule ID 5702 //
     /*  258651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  258668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258707 */     GIR_RootConstrainSelectedInstOperands,
     /*  258708 */     // GIR_Coverage, 5702,
     /*  258708 */     GIR_EraseRootFromParent_Done,
     /*  258709 */   // Label 4930: @258709
     /*  258709 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(258772), // Rule ID 5703 //
     /*  258714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  258728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  258731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  258756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258770 */     GIR_RootConstrainSelectedInstOperands,
     /*  258771 */     // GIR_Coverage, 5703,
     /*  258771 */     GIR_EraseRootFromParent_Done,
     /*  258772 */   // Label 4931: @258772
     /*  258772 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(258835), // Rule ID 5704 //
     /*  258777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  258794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258833 */     GIR_RootConstrainSelectedInstOperands,
     /*  258834 */     // GIR_Coverage, 5704,
     /*  258834 */     GIR_EraseRootFromParent_Done,
     /*  258835 */   // Label 4932: @258835
     /*  258835 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(258898), // Rule ID 5705 //
     /*  258840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  258854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  258857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  258882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258896 */     GIR_RootConstrainSelectedInstOperands,
     /*  258897 */     // GIR_Coverage, 5705,
     /*  258897 */     GIR_EraseRootFromParent_Done,
     /*  258898 */   // Label 4933: @258898
     /*  258898 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(258961), // Rule ID 5706 //
     /*  258903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  258920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258942 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  258945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258959 */     GIR_RootConstrainSelectedInstOperands,
     /*  258960 */     // GIR_Coverage, 5706,
     /*  258960 */     GIR_EraseRootFromParent_Done,
     /*  258961 */   // Label 4934: @258961
     /*  258961 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(259024), // Rule ID 5707 //
     /*  258966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  258977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  258980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  258983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259005 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259022 */     GIR_RootConstrainSelectedInstOperands,
     /*  259023 */     // GIR_Coverage, 5707,
     /*  259023 */     GIR_EraseRootFromParent_Done,
     /*  259024 */   // Label 4935: @259024
     /*  259024 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(259087), // Rule ID 5708 //
     /*  259029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  259043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259068 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259085 */     GIR_RootConstrainSelectedInstOperands,
     /*  259086 */     // GIR_Coverage, 5708,
     /*  259086 */     GIR_EraseRootFromParent_Done,
     /*  259087 */   // Label 4936: @259087
     /*  259087 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(259150), // Rule ID 5709 //
     /*  259092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  259106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  259109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259148 */     GIR_RootConstrainSelectedInstOperands,
     /*  259149 */     // GIR_Coverage, 5709,
     /*  259149 */     GIR_EraseRootFromParent_Done,
     /*  259150 */   // Label 4937: @259150
     /*  259150 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(259213), // Rule ID 5710 //
     /*  259155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  259169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259211 */     GIR_RootConstrainSelectedInstOperands,
     /*  259212 */     // GIR_Coverage, 5710,
     /*  259212 */     GIR_EraseRootFromParent_Done,
     /*  259213 */   // Label 4938: @259213
     /*  259213 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(259276), // Rule ID 5711 //
     /*  259218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  259232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  259235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259257 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259274 */     GIR_RootConstrainSelectedInstOperands,
     /*  259275 */     // GIR_Coverage, 5711,
     /*  259275 */     GIR_EraseRootFromParent_Done,
     /*  259276 */   // Label 4939: @259276
     /*  259276 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(259339), // Rule ID 5712 //
     /*  259281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  259295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  259298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259337 */     GIR_RootConstrainSelectedInstOperands,
     /*  259338 */     // GIR_Coverage, 5712,
     /*  259338 */     GIR_EraseRootFromParent_Done,
     /*  259339 */   // Label 4940: @259339
     /*  259339 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(259402), // Rule ID 5713 //
     /*  259344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  259358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  259361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259383 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259400 */     GIR_RootConstrainSelectedInstOperands,
     /*  259401 */     // GIR_Coverage, 5713,
     /*  259401 */     GIR_EraseRootFromParent_Done,
     /*  259402 */   // Label 4941: @259402
     /*  259402 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(259465), // Rule ID 5714 //
     /*  259407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  259421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  259424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259463 */     GIR_RootConstrainSelectedInstOperands,
     /*  259464 */     // GIR_Coverage, 5714,
     /*  259464 */     GIR_EraseRootFromParent_Done,
     /*  259465 */   // Label 4942: @259465
     /*  259465 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(259528), // Rule ID 5715 //
     /*  259470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  259484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  259487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  259512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259526 */     GIR_RootConstrainSelectedInstOperands,
     /*  259527 */     // GIR_Coverage, 5715,
     /*  259527 */     GIR_EraseRootFromParent_Done,
     /*  259528 */   // Label 4943: @259528
     /*  259528 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(259591), // Rule ID 5716 //
     /*  259533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  259550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259589 */     GIR_RootConstrainSelectedInstOperands,
     /*  259590 */     // GIR_Coverage, 5716,
     /*  259590 */     GIR_EraseRootFromParent_Done,
     /*  259591 */   // Label 4944: @259591
     /*  259591 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(259654), // Rule ID 5717 //
     /*  259596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  259610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  259613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259635 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  259638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259652 */     GIR_RootConstrainSelectedInstOperands,
     /*  259653 */     // GIR_Coverage, 5717,
     /*  259653 */     GIR_EraseRootFromParent_Done,
     /*  259654 */   // Label 4945: @259654
     /*  259654 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(259717), // Rule ID 5718 //
     /*  259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259715 */     GIR_RootConstrainSelectedInstOperands,
     /*  259716 */     // GIR_Coverage, 5718,
     /*  259716 */     GIR_EraseRootFromParent_Done,
     /*  259717 */   // Label 4946: @259717
     /*  259717 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(259780), // Rule ID 5719 //
     /*  259722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  259736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  259739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  259764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259778 */     GIR_RootConstrainSelectedInstOperands,
     /*  259779 */     // GIR_Coverage, 5719,
     /*  259779 */     GIR_EraseRootFromParent_Done,
     /*  259780 */   // Label 4947: @259780
     /*  259780 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(259843), // Rule ID 5720 //
     /*  259785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  259799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  259827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259841 */     GIR_RootConstrainSelectedInstOperands,
     /*  259842 */     // GIR_Coverage, 5720,
     /*  259842 */     GIR_EraseRootFromParent_Done,
     /*  259843 */   // Label 4948: @259843
     /*  259843 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(259906), // Rule ID 5721 //
     /*  259848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  259862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259887 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  259890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259904 */     GIR_RootConstrainSelectedInstOperands,
     /*  259905 */     // GIR_Coverage, 5721,
     /*  259905 */     GIR_EraseRootFromParent_Done,
     /*  259906 */   // Label 4949: @259906
     /*  259906 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(259969), // Rule ID 5722 //
     /*  259911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  259928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  259943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  259953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259967 */     GIR_RootConstrainSelectedInstOperands,
     /*  259968 */     // GIR_Coverage, 5722,
     /*  259968 */     GIR_EraseRootFromParent_Done,
     /*  259969 */   // Label 4950: @259969
     /*  259969 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(260032), // Rule ID 5723 //
     /*  259974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  259982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  259988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  259991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260030 */     GIR_RootConstrainSelectedInstOperands,
     /*  260031 */     // GIR_Coverage, 5723,
     /*  260031 */     GIR_EraseRootFromParent_Done,
     /*  260032 */   // Label 4951: @260032
     /*  260032 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(260095), // Rule ID 5724 //
     /*  260037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  260051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260093 */     GIR_RootConstrainSelectedInstOperands,
     /*  260094 */     // GIR_Coverage, 5724,
     /*  260094 */     GIR_EraseRootFromParent_Done,
     /*  260095 */   // Label 4952: @260095
     /*  260095 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(260158), // Rule ID 5725 //
     /*  260100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  260114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260139 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260156 */     GIR_RootConstrainSelectedInstOperands,
     /*  260157 */     // GIR_Coverage, 5725,
     /*  260157 */     GIR_EraseRootFromParent_Done,
     /*  260158 */   // Label 4953: @260158
     /*  260158 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(260221), // Rule ID 5726 //
     /*  260163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260219 */     GIR_RootConstrainSelectedInstOperands,
     /*  260220 */     // GIR_Coverage, 5726,
     /*  260220 */     GIR_EraseRootFromParent_Done,
     /*  260221 */   // Label 4954: @260221
     /*  260221 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(260284), // Rule ID 5727 //
     /*  260226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  260240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  260268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260282 */     GIR_RootConstrainSelectedInstOperands,
     /*  260283 */     // GIR_Coverage, 5727,
     /*  260283 */     GIR_EraseRootFromParent_Done,
     /*  260284 */   // Label 4955: @260284
     /*  260284 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(260347), // Rule ID 5728 //
     /*  260289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260345 */     GIR_RootConstrainSelectedInstOperands,
     /*  260346 */     // GIR_Coverage, 5728,
     /*  260346 */     GIR_EraseRootFromParent_Done,
     /*  260347 */   // Label 4956: @260347
     /*  260347 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(260410), // Rule ID 5729 //
     /*  260352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  260366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260408 */     GIR_RootConstrainSelectedInstOperands,
     /*  260409 */     // GIR_Coverage, 5729,
     /*  260409 */     GIR_EraseRootFromParent_Done,
     /*  260410 */   // Label 4957: @260410
     /*  260410 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(260473), // Rule ID 5730 //
     /*  260415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260471 */     GIR_RootConstrainSelectedInstOperands,
     /*  260472 */     // GIR_Coverage, 5730,
     /*  260472 */     GIR_EraseRootFromParent_Done,
     /*  260473 */   // Label 4958: @260473
     /*  260473 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(260536), // Rule ID 5731 //
     /*  260478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  260492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  260520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260534 */     GIR_RootConstrainSelectedInstOperands,
     /*  260535 */     // GIR_Coverage, 5731,
     /*  260535 */     GIR_EraseRootFromParent_Done,
     /*  260536 */   // Label 4959: @260536
     /*  260536 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(260599), // Rule ID 5732 //
     /*  260541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  260555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260597 */     GIR_RootConstrainSelectedInstOperands,
     /*  260598 */     // GIR_Coverage, 5732,
     /*  260598 */     GIR_EraseRootFromParent_Done,
     /*  260599 */   // Label 4960: @260599
     /*  260599 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(260662), // Rule ID 5733 //
     /*  260604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  260618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260660 */     GIR_RootConstrainSelectedInstOperands,
     /*  260661 */     // GIR_Coverage, 5733,
     /*  260661 */     GIR_EraseRootFromParent_Done,
     /*  260662 */   // Label 4961: @260662
     /*  260662 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(260725), // Rule ID 5734 //
     /*  260667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260723 */     GIR_RootConstrainSelectedInstOperands,
     /*  260724 */     // GIR_Coverage, 5734,
     /*  260724 */     GIR_EraseRootFromParent_Done,
     /*  260725 */   // Label 4962: @260725
     /*  260725 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(260788), // Rule ID 5735 //
     /*  260730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  260744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260769 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260786 */     GIR_RootConstrainSelectedInstOperands,
     /*  260787 */     // GIR_Coverage, 5735,
     /*  260787 */     GIR_EraseRootFromParent_Done,
     /*  260788 */   // Label 4963: @260788
     /*  260788 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(260851), // Rule ID 5736 //
     /*  260793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260849 */     GIR_RootConstrainSelectedInstOperands,
     /*  260850 */     // GIR_Coverage, 5736,
     /*  260850 */     GIR_EraseRootFromParent_Done,
     /*  260851 */   // Label 4964: @260851
     /*  260851 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(260914), // Rule ID 5737 //
     /*  260856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  260870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260895 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260912 */     GIR_RootConstrainSelectedInstOperands,
     /*  260913 */     // GIR_Coverage, 5737,
     /*  260913 */     GIR_EraseRootFromParent_Done,
     /*  260914 */   // Label 4965: @260914
     /*  260914 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(260977), // Rule ID 5738 //
     /*  260919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  260961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260975 */     GIR_RootConstrainSelectedInstOperands,
     /*  260976 */     // GIR_Coverage, 5738,
     /*  260976 */     GIR_EraseRootFromParent_Done,
     /*  260977 */   // Label 4966: @260977
     /*  260977 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(261040), // Rule ID 5739 //
     /*  260982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  260990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  260996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261021 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  261024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261038 */     GIR_RootConstrainSelectedInstOperands,
     /*  261039 */     // GIR_Coverage, 5739,
     /*  261039 */     GIR_EraseRootFromParent_Done,
     /*  261040 */   // Label 4967: @261040
     /*  261040 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(261103), // Rule ID 5740 //
     /*  261045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  261059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261101 */     GIR_RootConstrainSelectedInstOperands,
     /*  261102 */     // GIR_Coverage, 5740,
     /*  261102 */     GIR_EraseRootFromParent_Done,
     /*  261103 */   // Label 4968: @261103
     /*  261103 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(261166), // Rule ID 5741 //
     /*  261108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  261122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261164 */     GIR_RootConstrainSelectedInstOperands,
     /*  261165 */     // GIR_Coverage, 5741,
     /*  261165 */     GIR_EraseRootFromParent_Done,
     /*  261166 */   // Label 4969: @261166
     /*  261166 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(261229), // Rule ID 5742 //
     /*  261171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  261185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261227 */     GIR_RootConstrainSelectedInstOperands,
     /*  261228 */     // GIR_Coverage, 5742,
     /*  261228 */     GIR_EraseRootFromParent_Done,
     /*  261229 */   // Label 4970: @261229
     /*  261229 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(261292), // Rule ID 5743 //
     /*  261234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  261248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261273 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261290 */     GIR_RootConstrainSelectedInstOperands,
     /*  261291 */     // GIR_Coverage, 5743,
     /*  261291 */     GIR_EraseRootFromParent_Done,
     /*  261292 */   // Label 4971: @261292
     /*  261292 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(261355), // Rule ID 5744 //
     /*  261297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  261308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  261311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261336 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261353 */     GIR_RootConstrainSelectedInstOperands,
     /*  261354 */     // GIR_Coverage, 5744,
     /*  261354 */     GIR_EraseRootFromParent_Done,
     /*  261355 */   // Label 4972: @261355
     /*  261355 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(261418), // Rule ID 5745 //
     /*  261360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  261371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  261374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261399 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261416 */     GIR_RootConstrainSelectedInstOperands,
     /*  261417 */     // GIR_Coverage, 5745,
     /*  261417 */     GIR_EraseRootFromParent_Done,
     /*  261418 */   // Label 4973: @261418
     /*  261418 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(261481), // Rule ID 5746 //
     /*  261423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261479 */     GIR_RootConstrainSelectedInstOperands,
     /*  261480 */     // GIR_Coverage, 5746,
     /*  261480 */     GIR_EraseRootFromParent_Done,
     /*  261481 */   // Label 4974: @261481
     /*  261481 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(261544), // Rule ID 5747 //
     /*  261486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  261500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261542 */     GIR_RootConstrainSelectedInstOperands,
     /*  261543 */     // GIR_Coverage, 5747,
     /*  261543 */     GIR_EraseRootFromParent_Done,
     /*  261544 */   // Label 4975: @261544
     /*  261544 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(261607), // Rule ID 5748 //
     /*  261549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261605 */     GIR_RootConstrainSelectedInstOperands,
     /*  261606 */     // GIR_Coverage, 5748,
     /*  261606 */     GIR_EraseRootFromParent_Done,
     /*  261607 */   // Label 4976: @261607
     /*  261607 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(261670), // Rule ID 5749 //
     /*  261612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  261623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  261626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261668 */     GIR_RootConstrainSelectedInstOperands,
     /*  261669 */     // GIR_Coverage, 5749,
     /*  261669 */     GIR_EraseRootFromParent_Done,
     /*  261670 */   // Label 4977: @261670
     /*  261670 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(261733), // Rule ID 5750 //
     /*  261675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261714 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261731 */     GIR_RootConstrainSelectedInstOperands,
     /*  261732 */     // GIR_Coverage, 5750,
     /*  261732 */     GIR_EraseRootFromParent_Done,
     /*  261733 */   // Label 4978: @261733
     /*  261733 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(261796), // Rule ID 5751 //
     /*  261738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  261749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  261752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261777 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  261780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261794 */     GIR_RootConstrainSelectedInstOperands,
     /*  261795 */     // GIR_Coverage, 5751,
     /*  261795 */     GIR_EraseRootFromParent_Done,
     /*  261796 */   // Label 4979: @261796
     /*  261796 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(261859), // Rule ID 5752 //
     /*  261801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261857 */     GIR_RootConstrainSelectedInstOperands,
     /*  261858 */     // GIR_Coverage, 5752,
     /*  261858 */     GIR_EraseRootFromParent_Done,
     /*  261859 */   // Label 4980: @261859
     /*  261859 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(261922), // Rule ID 5753 //
     /*  261864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  261878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  261906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261920 */     GIR_RootConstrainSelectedInstOperands,
     /*  261921 */     // GIR_Coverage, 5753,
     /*  261921 */     GIR_EraseRootFromParent_Done,
     /*  261922 */   // Label 4981: @261922
     /*  261922 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(261985), // Rule ID 5754 //
     /*  261927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  261941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  261969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261983 */     GIR_RootConstrainSelectedInstOperands,
     /*  261984 */     // GIR_Coverage, 5754,
     /*  261984 */     GIR_EraseRootFromParent_Done,
     /*  261985 */   // Label 4982: @261985
     /*  261985 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(262048), // Rule ID 5755 //
     /*  261990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  261998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  262004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262046 */     GIR_RootConstrainSelectedInstOperands,
     /*  262047 */     // GIR_Coverage, 5755,
     /*  262047 */     GIR_EraseRootFromParent_Done,
     /*  262048 */   // Label 4983: @262048
     /*  262048 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(262111), // Rule ID 5756 //
     /*  262053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  262067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262109 */     GIR_RootConstrainSelectedInstOperands,
     /*  262110 */     // GIR_Coverage, 5756,
     /*  262110 */     GIR_EraseRootFromParent_Done,
     /*  262111 */   // Label 4984: @262111
     /*  262111 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(262174), // Rule ID 5757 //
     /*  262116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  262130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262172 */     GIR_RootConstrainSelectedInstOperands,
     /*  262173 */     // GIR_Coverage, 5757,
     /*  262173 */     GIR_EraseRootFromParent_Done,
     /*  262174 */   // Label 4985: @262174
     /*  262174 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(262237), // Rule ID 5758 //
     /*  262179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  262193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  262221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262235 */     GIR_RootConstrainSelectedInstOperands,
     /*  262236 */     // GIR_Coverage, 5758,
     /*  262236 */     GIR_EraseRootFromParent_Done,
     /*  262237 */   // Label 4986: @262237
     /*  262237 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(262300), // Rule ID 5759 //
     /*  262242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  262256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  262284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262298 */     GIR_RootConstrainSelectedInstOperands,
     /*  262299 */     // GIR_Coverage, 5759,
     /*  262299 */     GIR_EraseRootFromParent_Done,
     /*  262300 */   // Label 4987: @262300
     /*  262300 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(262363), // Rule ID 5760 //
     /*  262305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  262319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262361 */     GIR_RootConstrainSelectedInstOperands,
     /*  262362 */     // GIR_Coverage, 5760,
     /*  262362 */     GIR_EraseRootFromParent_Done,
     /*  262363 */   // Label 4988: @262363
     /*  262363 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(262426), // Rule ID 5761 //
     /*  262368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  262382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  262410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262424 */     GIR_RootConstrainSelectedInstOperands,
     /*  262425 */     // GIR_Coverage, 5761,
     /*  262425 */     GIR_EraseRootFromParent_Done,
     /*  262426 */   // Label 4989: @262426
     /*  262426 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(262489), // Rule ID 5762 //
     /*  262431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  262445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262487 */     GIR_RootConstrainSelectedInstOperands,
     /*  262488 */     // GIR_Coverage, 5762,
     /*  262488 */     GIR_EraseRootFromParent_Done,
     /*  262489 */   // Label 4990: @262489
     /*  262489 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(262552), // Rule ID 5763 //
     /*  262494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  262502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  262508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262533 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  262536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262550 */     GIR_RootConstrainSelectedInstOperands,
     /*  262551 */     // GIR_Coverage, 5763,
     /*  262551 */     GIR_EraseRootFromParent_Done,
     /*  262552 */   // Label 4991: @262552
     /*  262552 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(262615), // Rule ID 7796 //
     /*  262557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  262574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262613 */     GIR_RootConstrainSelectedInstOperands,
     /*  262614 */     // GIR_Coverage, 7796,
     /*  262614 */     GIR_EraseRootFromParent_Done,
     /*  262615 */   // Label 4992: @262615
     /*  262615 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(262678), // Rule ID 7797 //
     /*  262620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  262634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  262637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262676 */     GIR_RootConstrainSelectedInstOperands,
     /*  262677 */     // GIR_Coverage, 7797,
     /*  262677 */     GIR_EraseRootFromParent_Done,
     /*  262678 */   // Label 4993: @262678
     /*  262678 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(262741), // Rule ID 7800 //
     /*  262683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  262700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262739 */     GIR_RootConstrainSelectedInstOperands,
     /*  262740 */     // GIR_Coverage, 7800,
     /*  262740 */     GIR_EraseRootFromParent_Done,
     /*  262741 */   // Label 4994: @262741
     /*  262741 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(262804), // Rule ID 7801 //
     /*  262746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  262760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  262763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262802 */     GIR_RootConstrainSelectedInstOperands,
     /*  262803 */     // GIR_Coverage, 7801,
     /*  262803 */     GIR_EraseRootFromParent_Done,
     /*  262804 */   // Label 4995: @262804
     /*  262804 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(262867), // Rule ID 7804 //
     /*  262809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  262826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262865 */     GIR_RootConstrainSelectedInstOperands,
     /*  262866 */     // GIR_Coverage, 7804,
     /*  262866 */     GIR_EraseRootFromParent_Done,
     /*  262867 */   // Label 4996: @262867
     /*  262867 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(262930), // Rule ID 7805 //
     /*  262872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  262886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  262889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262911 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  262914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262928 */     GIR_RootConstrainSelectedInstOperands,
     /*  262929 */     // GIR_Coverage, 7805,
     /*  262929 */     GIR_EraseRootFromParent_Done,
     /*  262930 */   // Label 4997: @262930
     /*  262930 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(262993), // Rule ID 7808 //
     /*  262935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  262949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  262952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  262977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262991 */     GIR_RootConstrainSelectedInstOperands,
     /*  262992 */     // GIR_Coverage, 7808,
     /*  262992 */     GIR_EraseRootFromParent_Done,
     /*  262993 */   // Label 4998: @262993
     /*  262993 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(263056), // Rule ID 7809 //
     /*  262998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  263012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  263015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263037 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263054 */     GIR_RootConstrainSelectedInstOperands,
     /*  263055 */     // GIR_Coverage, 7809,
     /*  263055 */     GIR_EraseRootFromParent_Done,
     /*  263056 */   // Label 4999: @263056
     /*  263056 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(263119), // Rule ID 7812 //
     /*  263061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  263075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  263078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263117 */     GIR_RootConstrainSelectedInstOperands,
     /*  263118 */     // GIR_Coverage, 7812,
     /*  263118 */     GIR_EraseRootFromParent_Done,
     /*  263119 */   // Label 5000: @263119
     /*  263119 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(263182), // Rule ID 7813 //
     /*  263124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  263138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  263141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263163 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  263166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263180 */     GIR_RootConstrainSelectedInstOperands,
     /*  263181 */     // GIR_Coverage, 7813,
     /*  263181 */     GIR_EraseRootFromParent_Done,
     /*  263182 */   // Label 5001: @263182
     /*  263182 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(263245), // Rule ID 7816 //
     /*  263187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  263201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  263204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263243 */     GIR_RootConstrainSelectedInstOperands,
     /*  263244 */     // GIR_Coverage, 7816,
     /*  263244 */     GIR_EraseRootFromParent_Done,
     /*  263245 */   // Label 5002: @263245
     /*  263245 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(263308), // Rule ID 7817 //
     /*  263250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  263264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  263267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263289 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263306 */     GIR_RootConstrainSelectedInstOperands,
     /*  263307 */     // GIR_Coverage, 7817,
     /*  263307 */     GIR_EraseRootFromParent_Done,
     /*  263308 */   // Label 5003: @263308
     /*  263308 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(263371), // Rule ID 7820 //
     /*  263313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  263327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  263330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263369 */     GIR_RootConstrainSelectedInstOperands,
     /*  263370 */     // GIR_Coverage, 7820,
     /*  263370 */     GIR_EraseRootFromParent_Done,
     /*  263371 */   // Label 5004: @263371
     /*  263371 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(263434), // Rule ID 7821 //
     /*  263376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  263390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  263393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263432 */     GIR_RootConstrainSelectedInstOperands,
     /*  263433 */     // GIR_Coverage, 7821,
     /*  263433 */     GIR_EraseRootFromParent_Done,
     /*  263434 */   // Label 5005: @263434
     /*  263434 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(263497), // Rule ID 7824 //
     /*  263439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  263453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  263456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263495 */     GIR_RootConstrainSelectedInstOperands,
     /*  263496 */     // GIR_Coverage, 7824,
     /*  263496 */     GIR_EraseRootFromParent_Done,
     /*  263497 */   // Label 5006: @263497
     /*  263497 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(263560), // Rule ID 7825 //
     /*  263502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  263516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  263519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263541 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263558 */     GIR_RootConstrainSelectedInstOperands,
     /*  263559 */     // GIR_Coverage, 7825,
     /*  263559 */     GIR_EraseRootFromParent_Done,
     /*  263560 */   // Label 5007: @263560
     /*  263560 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(263623), // Rule ID 7828 //
     /*  263565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  263582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263621 */     GIR_RootConstrainSelectedInstOperands,
     /*  263622 */     // GIR_Coverage, 7828,
     /*  263622 */     GIR_EraseRootFromParent_Done,
     /*  263623 */   // Label 5008: @263623
     /*  263623 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(263686), // Rule ID 7829 //
     /*  263628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  263642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  263645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263667 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  263670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263684 */     GIR_RootConstrainSelectedInstOperands,
     /*  263685 */     // GIR_Coverage, 7829,
     /*  263685 */     GIR_EraseRootFromParent_Done,
     /*  263686 */   // Label 5009: @263686
     /*  263686 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(263749), // Rule ID 7832 //
     /*  263691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  263708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  263733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263747 */     GIR_RootConstrainSelectedInstOperands,
     /*  263748 */     // GIR_Coverage, 7832,
     /*  263748 */     GIR_EraseRootFromParent_Done,
     /*  263749 */   // Label 5010: @263749
     /*  263749 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(263812), // Rule ID 7833 //
     /*  263754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  263768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  263771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263793 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  263796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263810 */     GIR_RootConstrainSelectedInstOperands,
     /*  263811 */     // GIR_Coverage, 7833,
     /*  263811 */     GIR_EraseRootFromParent_Done,
     /*  263812 */   // Label 5011: @263812
     /*  263812 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(263875), // Rule ID 7836 //
     /*  263817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  263834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263856 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  263859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263873 */     GIR_RootConstrainSelectedInstOperands,
     /*  263874 */     // GIR_Coverage, 7836,
     /*  263874 */     GIR_EraseRootFromParent_Done,
     /*  263875 */   // Label 5012: @263875
     /*  263875 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(263938), // Rule ID 7837 //
     /*  263880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  263894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  263897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263919 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  263922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263936 */     GIR_RootConstrainSelectedInstOperands,
     /*  263937 */     // GIR_Coverage, 7837,
     /*  263937 */     GIR_EraseRootFromParent_Done,
     /*  263938 */   // Label 5013: @263938
     /*  263938 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(264001), // Rule ID 7840 //
     /*  263943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  263954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  263957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  263960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263982 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  263985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263999 */     GIR_RootConstrainSelectedInstOperands,
     /*  264000 */     // GIR_Coverage, 7840,
     /*  264000 */     GIR_EraseRootFromParent_Done,
     /*  264001 */   // Label 5014: @264001
     /*  264001 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(264064), // Rule ID 7841 //
     /*  264006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  264017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  264020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  264023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264045 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264062 */     GIR_RootConstrainSelectedInstOperands,
     /*  264063 */     // GIR_Coverage, 7841,
     /*  264063 */     GIR_EraseRootFromParent_Done,
     /*  264064 */   // Label 5015: @264064
     /*  264064 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(264127), // Rule ID 7844 //
     /*  264069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  264083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  264086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264125 */     GIR_RootConstrainSelectedInstOperands,
     /*  264126 */     // GIR_Coverage, 7844,
     /*  264126 */     GIR_EraseRootFromParent_Done,
     /*  264127 */   // Label 5016: @264127
     /*  264127 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(264190), // Rule ID 7845 //
     /*  264132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  264146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  264149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264171 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264188 */     GIR_RootConstrainSelectedInstOperands,
     /*  264189 */     // GIR_Coverage, 7845,
     /*  264189 */     GIR_EraseRootFromParent_Done,
     /*  264190 */   // Label 5017: @264190
     /*  264190 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(264253), // Rule ID 7848 //
     /*  264195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  264209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  264212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264251 */     GIR_RootConstrainSelectedInstOperands,
     /*  264252 */     // GIR_Coverage, 7848,
     /*  264252 */     GIR_EraseRootFromParent_Done,
     /*  264253 */   // Label 5018: @264253
     /*  264253 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(264316), // Rule ID 7849 //
     /*  264258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  264272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  264275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264297 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264314 */     GIR_RootConstrainSelectedInstOperands,
     /*  264315 */     // GIR_Coverage, 7849,
     /*  264315 */     GIR_EraseRootFromParent_Done,
     /*  264316 */   // Label 5019: @264316
     /*  264316 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(264379), // Rule ID 7852 //
     /*  264321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  264335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  264338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264377 */     GIR_RootConstrainSelectedInstOperands,
     /*  264378 */     // GIR_Coverage, 7852,
     /*  264378 */     GIR_EraseRootFromParent_Done,
     /*  264379 */   // Label 5020: @264379
     /*  264379 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(264442), // Rule ID 7853 //
     /*  264384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  264395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  264398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  264401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264423 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264440 */     GIR_RootConstrainSelectedInstOperands,
     /*  264441 */     // GIR_Coverage, 7853,
     /*  264441 */     GIR_EraseRootFromParent_Done,
     /*  264442 */   // Label 5021: @264442
     /*  264442 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(264505), // Rule ID 7856 //
     /*  264447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  264461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  264464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264486 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264503 */     GIR_RootConstrainSelectedInstOperands,
     /*  264504 */     // GIR_Coverage, 7856,
     /*  264504 */     GIR_EraseRootFromParent_Done,
     /*  264505 */   // Label 5022: @264505
     /*  264505 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(264568), // Rule ID 7857 //
     /*  264510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  264524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  264527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264549 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264566 */     GIR_RootConstrainSelectedInstOperands,
     /*  264567 */     // GIR_Coverage, 7857,
     /*  264567 */     GIR_EraseRootFromParent_Done,
     /*  264568 */   // Label 5023: @264568
     /*  264568 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(264631), // Rule ID 7860 //
     /*  264573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  264590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264612 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264629 */     GIR_RootConstrainSelectedInstOperands,
     /*  264630 */     // GIR_Coverage, 7860,
     /*  264630 */     GIR_EraseRootFromParent_Done,
     /*  264631 */   // Label 5024: @264631
     /*  264631 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(264694), // Rule ID 7861 //
     /*  264636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  264650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  264653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264692 */     GIR_RootConstrainSelectedInstOperands,
     /*  264693 */     // GIR_Coverage, 7861,
     /*  264693 */     GIR_EraseRootFromParent_Done,
     /*  264694 */   // Label 5025: @264694
     /*  264694 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(264757), // Rule ID 7864 //
     /*  264699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  264716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264738 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264755 */     GIR_RootConstrainSelectedInstOperands,
     /*  264756 */     // GIR_Coverage, 7864,
     /*  264756 */     GIR_EraseRootFromParent_Done,
     /*  264757 */   // Label 5026: @264757
     /*  264757 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(264820), // Rule ID 7865 //
     /*  264762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  264776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  264779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264801 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  264804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264818 */     GIR_RootConstrainSelectedInstOperands,
     /*  264819 */     // GIR_Coverage, 7865,
     /*  264819 */     GIR_EraseRootFromParent_Done,
     /*  264820 */   // Label 5027: @264820
     /*  264820 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(264883), // Rule ID 7868 //
     /*  264825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  264842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264881 */     GIR_RootConstrainSelectedInstOperands,
     /*  264882 */     // GIR_Coverage, 7868,
     /*  264882 */     GIR_EraseRootFromParent_Done,
     /*  264883 */   // Label 5028: @264883
     /*  264883 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(264946), // Rule ID 7869 //
     /*  264888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  264902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  264905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  264930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264944 */     GIR_RootConstrainSelectedInstOperands,
     /*  264945 */     // GIR_Coverage, 7869,
     /*  264945 */     GIR_EraseRootFromParent_Done,
     /*  264946 */   // Label 5029: @264946
     /*  264946 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(265009), // Rule ID 7872 //
     /*  264951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  264965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  264968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  264983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  264993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265007 */     GIR_RootConstrainSelectedInstOperands,
     /*  265008 */     // GIR_Coverage, 7872,
     /*  265008 */     GIR_EraseRootFromParent_Done,
     /*  265009 */   // Label 5030: @265009
     /*  265009 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(265072), // Rule ID 7873 //
     /*  265014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  265028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  265031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265053 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  265056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265070 */     GIR_RootConstrainSelectedInstOperands,
     /*  265071 */     // GIR_Coverage, 7873,
     /*  265071 */     GIR_EraseRootFromParent_Done,
     /*  265072 */   // Label 5031: @265072
     /*  265072 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(265135), // Rule ID 7876 //
     /*  265077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  265091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  265094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  265119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265133 */     GIR_RootConstrainSelectedInstOperands,
     /*  265134 */     // GIR_Coverage, 7876,
     /*  265134 */     GIR_EraseRootFromParent_Done,
     /*  265135 */   // Label 5032: @265135
     /*  265135 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(265198), // Rule ID 7877 //
     /*  265140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  265154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  265157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  265182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265196 */     GIR_RootConstrainSelectedInstOperands,
     /*  265197 */     // GIR_Coverage, 7877,
     /*  265197 */     GIR_EraseRootFromParent_Done,
     /*  265198 */   // Label 5033: @265198
     /*  265198 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(265261), // Rule ID 7880 //
     /*  265203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  265217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  265245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265259 */     GIR_RootConstrainSelectedInstOperands,
     /*  265260 */     // GIR_Coverage, 7880,
     /*  265260 */     GIR_EraseRootFromParent_Done,
     /*  265261 */   // Label 5034: @265261
     /*  265261 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(265324), // Rule ID 7881 //
     /*  265266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  265280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  265308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265322 */     GIR_RootConstrainSelectedInstOperands,
     /*  265323 */     // GIR_Coverage, 7881,
     /*  265323 */     GIR_EraseRootFromParent_Done,
     /*  265324 */   // Label 5035: @265324
     /*  265324 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(265387), // Rule ID 7884 //
     /*  265329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  265343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265385 */     GIR_RootConstrainSelectedInstOperands,
     /*  265386 */     // GIR_Coverage, 7884,
     /*  265386 */     GIR_EraseRootFromParent_Done,
     /*  265387 */   // Label 5036: @265387
     /*  265387 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(265450), // Rule ID 7885 //
     /*  265392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  265406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265431 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265448 */     GIR_RootConstrainSelectedInstOperands,
     /*  265449 */     // GIR_Coverage, 7885,
     /*  265449 */     GIR_EraseRootFromParent_Done,
     /*  265450 */   // Label 5037: @265450
     /*  265450 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(265513), // Rule ID 7888 //
     /*  265455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  265469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265511 */     GIR_RootConstrainSelectedInstOperands,
     /*  265512 */     // GIR_Coverage, 7888,
     /*  265512 */     GIR_EraseRootFromParent_Done,
     /*  265513 */   // Label 5038: @265513
     /*  265513 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(265576), // Rule ID 7889 //
     /*  265518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  265532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265557 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265574 */     GIR_RootConstrainSelectedInstOperands,
     /*  265575 */     // GIR_Coverage, 7889,
     /*  265575 */     GIR_EraseRootFromParent_Done,
     /*  265576 */   // Label 5039: @265576
     /*  265576 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(265639), // Rule ID 7892 //
     /*  265581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265637 */     GIR_RootConstrainSelectedInstOperands,
     /*  265638 */     // GIR_Coverage, 7892,
     /*  265638 */     GIR_EraseRootFromParent_Done,
     /*  265639 */   // Label 5040: @265639
     /*  265639 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(265702), // Rule ID 7893 //
     /*  265644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  265658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  265686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265700 */     GIR_RootConstrainSelectedInstOperands,
     /*  265701 */     // GIR_Coverage, 7893,
     /*  265701 */     GIR_EraseRootFromParent_Done,
     /*  265702 */   // Label 5041: @265702
     /*  265702 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(265765), // Rule ID 7896 //
     /*  265707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265763 */     GIR_RootConstrainSelectedInstOperands,
     /*  265764 */     // GIR_Coverage, 7896,
     /*  265764 */     GIR_EraseRootFromParent_Done,
     /*  265765 */   // Label 5042: @265765
     /*  265765 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(265828), // Rule ID 7897 //
     /*  265770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  265784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265809 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265826 */     GIR_RootConstrainSelectedInstOperands,
     /*  265827 */     // GIR_Coverage, 7897,
     /*  265827 */     GIR_EraseRootFromParent_Done,
     /*  265828 */   // Label 5043: @265828
     /*  265828 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(265891), // Rule ID 7900 //
     /*  265833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265889 */     GIR_RootConstrainSelectedInstOperands,
     /*  265890 */     // GIR_Coverage, 7900,
     /*  265890 */     GIR_EraseRootFromParent_Done,
     /*  265891 */   // Label 5044: @265891
     /*  265891 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(265954), // Rule ID 7901 //
     /*  265896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  265910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  265913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  265938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265952 */     GIR_RootConstrainSelectedInstOperands,
     /*  265953 */     // GIR_Coverage, 7901,
     /*  265953 */     GIR_EraseRootFromParent_Done,
     /*  265954 */   // Label 5045: @265954
     /*  265954 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(266017), // Rule ID 7904 //
     /*  265959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  265967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  265973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  265976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  265991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266015 */     GIR_RootConstrainSelectedInstOperands,
     /*  266016 */     // GIR_Coverage, 7904,
     /*  266016 */     GIR_EraseRootFromParent_Done,
     /*  266017 */   // Label 5046: @266017
     /*  266017 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(266080), // Rule ID 7905 //
     /*  266022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  266036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266061 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266078 */     GIR_RootConstrainSelectedInstOperands,
     /*  266079 */     // GIR_Coverage, 7905,
     /*  266079 */     GIR_EraseRootFromParent_Done,
     /*  266080 */   // Label 5047: @266080
     /*  266080 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(266143), // Rule ID 7908 //
     /*  266085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  266099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266141 */     GIR_RootConstrainSelectedInstOperands,
     /*  266142 */     // GIR_Coverage, 7908,
     /*  266142 */     GIR_EraseRootFromParent_Done,
     /*  266143 */   // Label 5048: @266143
     /*  266143 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(266206), // Rule ID 7909 //
     /*  266148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  266162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266187 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266204 */     GIR_RootConstrainSelectedInstOperands,
     /*  266205 */     // GIR_Coverage, 7909,
     /*  266205 */     GIR_EraseRootFromParent_Done,
     /*  266206 */   // Label 5049: @266206
     /*  266206 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(266269), // Rule ID 7912 //
     /*  266211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  266225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266250 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266267 */     GIR_RootConstrainSelectedInstOperands,
     /*  266268 */     // GIR_Coverage, 7912,
     /*  266268 */     GIR_EraseRootFromParent_Done,
     /*  266269 */   // Label 5050: @266269
     /*  266269 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(266332), // Rule ID 7913 //
     /*  266274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  266288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266313 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266330 */     GIR_RootConstrainSelectedInstOperands,
     /*  266331 */     // GIR_Coverage, 7913,
     /*  266331 */     GIR_EraseRootFromParent_Done,
     /*  266332 */   // Label 5051: @266332
     /*  266332 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(266395), // Rule ID 7916 //
     /*  266337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  266351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266393 */     GIR_RootConstrainSelectedInstOperands,
     /*  266394 */     // GIR_Coverage, 7916,
     /*  266394 */     GIR_EraseRootFromParent_Done,
     /*  266395 */   // Label 5052: @266395
     /*  266395 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(266458), // Rule ID 7917 //
     /*  266400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  266414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266439 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  266442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266456 */     GIR_RootConstrainSelectedInstOperands,
     /*  266457 */     // GIR_Coverage, 7917,
     /*  266457 */     GIR_EraseRootFromParent_Done,
     /*  266458 */   // Label 5053: @266458
     /*  266458 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(266521), // Rule ID 7920 //
     /*  266463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  266477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266519 */     GIR_RootConstrainSelectedInstOperands,
     /*  266520 */     // GIR_Coverage, 7920,
     /*  266520 */     GIR_EraseRootFromParent_Done,
     /*  266521 */   // Label 5054: @266521
     /*  266521 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(266584), // Rule ID 7921 //
     /*  266526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  266540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266582 */     GIR_RootConstrainSelectedInstOperands,
     /*  266583 */     // GIR_Coverage, 7921,
     /*  266583 */     GIR_EraseRootFromParent_Done,
     /*  266584 */   // Label 5055: @266584
     /*  266584 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(266647), // Rule ID 7924 //
     /*  266589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  266631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266645 */     GIR_RootConstrainSelectedInstOperands,
     /*  266646 */     // GIR_Coverage, 7924,
     /*  266646 */     GIR_EraseRootFromParent_Done,
     /*  266647 */   // Label 5056: @266647
     /*  266647 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(266710), // Rule ID 7925 //
     /*  266652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  266666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  266694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266708 */     GIR_RootConstrainSelectedInstOperands,
     /*  266709 */     // GIR_Coverage, 7925,
     /*  266709 */     GIR_EraseRootFromParent_Done,
     /*  266710 */   // Label 5057: @266710
     /*  266710 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(266773), // Rule ID 7928 //
     /*  266715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266754 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  266757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266771 */     GIR_RootConstrainSelectedInstOperands,
     /*  266772 */     // GIR_Coverage, 7928,
     /*  266772 */     GIR_EraseRootFromParent_Done,
     /*  266773 */   // Label 5058: @266773
     /*  266773 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(266836), // Rule ID 7929 //
     /*  266778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  266789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  266792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266817 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  266820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266834 */     GIR_RootConstrainSelectedInstOperands,
     /*  266835 */     // GIR_Coverage, 7929,
     /*  266835 */     GIR_EraseRootFromParent_Done,
     /*  266836 */   // Label 5059: @266836
     /*  266836 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(266899), // Rule ID 7932 //
     /*  266841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266897 */     GIR_RootConstrainSelectedInstOperands,
     /*  266898 */     // GIR_Coverage, 7932,
     /*  266898 */     GIR_EraseRootFromParent_Done,
     /*  266899 */   // Label 5060: @266899
     /*  266899 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(266962), // Rule ID 7933 //
     /*  266904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  266918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  266946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266960 */     GIR_RootConstrainSelectedInstOperands,
     /*  266961 */     // GIR_Coverage, 7933,
     /*  266961 */     GIR_EraseRootFromParent_Done,
     /*  266962 */   // Label 5061: @266962
     /*  266962 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(267025), // Rule ID 7936 //
     /*  266967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  266975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  266981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267023 */     GIR_RootConstrainSelectedInstOperands,
     /*  267024 */     // GIR_Coverage, 7936,
     /*  267024 */     GIR_EraseRootFromParent_Done,
     /*  267025 */   // Label 5062: @267025
     /*  267025 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(267088), // Rule ID 7937 //
     /*  267030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  267044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267069 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267086 */     GIR_RootConstrainSelectedInstOperands,
     /*  267087 */     // GIR_Coverage, 7937,
     /*  267087 */     GIR_EraseRootFromParent_Done,
     /*  267088 */   // Label 5063: @267088
     /*  267088 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(267151), // Rule ID 7940 //
     /*  267093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  267107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267132 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267149 */     GIR_RootConstrainSelectedInstOperands,
     /*  267150 */     // GIR_Coverage, 7940,
     /*  267150 */     GIR_EraseRootFromParent_Done,
     /*  267151 */   // Label 5064: @267151
     /*  267151 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(267214), // Rule ID 7941 //
     /*  267156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  267170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267195 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267212 */     GIR_RootConstrainSelectedInstOperands,
     /*  267213 */     // GIR_Coverage, 7941,
     /*  267213 */     GIR_EraseRootFromParent_Done,
     /*  267214 */   // Label 5065: @267214
     /*  267214 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(267277), // Rule ID 7944 //
     /*  267219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  267233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267275 */     GIR_RootConstrainSelectedInstOperands,
     /*  267276 */     // GIR_Coverage, 7944,
     /*  267276 */     GIR_EraseRootFromParent_Done,
     /*  267277 */   // Label 5066: @267277
     /*  267277 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(267340), // Rule ID 7945 //
     /*  267282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  267296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267338 */     GIR_RootConstrainSelectedInstOperands,
     /*  267339 */     // GIR_Coverage, 7945,
     /*  267339 */     GIR_EraseRootFromParent_Done,
     /*  267340 */   // Label 5067: @267340
     /*  267340 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(267403), // Rule ID 7948 //
     /*  267345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  267359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267401 */     GIR_RootConstrainSelectedInstOperands,
     /*  267402 */     // GIR_Coverage, 7948,
     /*  267402 */     GIR_EraseRootFromParent_Done,
     /*  267403 */   // Label 5068: @267403
     /*  267403 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(267466), // Rule ID 7949 //
     /*  267408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  267422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267464 */     GIR_RootConstrainSelectedInstOperands,
     /*  267465 */     // GIR_Coverage, 7949,
     /*  267465 */     GIR_EraseRootFromParent_Done,
     /*  267466 */   // Label 5069: @267466
     /*  267466 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(267529), // Rule ID 7952 //
     /*  267471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  267485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267527 */     GIR_RootConstrainSelectedInstOperands,
     /*  267528 */     // GIR_Coverage, 7952,
     /*  267528 */     GIR_EraseRootFromParent_Done,
     /*  267529 */   // Label 5070: @267529
     /*  267529 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(267592), // Rule ID 7953 //
     /*  267534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  267548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267573 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267590 */     GIR_RootConstrainSelectedInstOperands,
     /*  267591 */     // GIR_Coverage, 7953,
     /*  267591 */     GIR_EraseRootFromParent_Done,
     /*  267592 */   // Label 5071: @267592
     /*  267592 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(267655), // Rule ID 7956 //
     /*  267597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267653 */     GIR_RootConstrainSelectedInstOperands,
     /*  267654 */     // GIR_Coverage, 7956,
     /*  267654 */     GIR_EraseRootFromParent_Done,
     /*  267655 */   // Label 5072: @267655
     /*  267655 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(267718), // Rule ID 7957 //
     /*  267660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  267674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  267702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267716 */     GIR_RootConstrainSelectedInstOperands,
     /*  267717 */     // GIR_Coverage, 7957,
     /*  267717 */     GIR_EraseRootFromParent_Done,
     /*  267718 */   // Label 5073: @267718
     /*  267718 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(267781), // Rule ID 7960 //
     /*  267723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267779 */     GIR_RootConstrainSelectedInstOperands,
     /*  267780 */     // GIR_Coverage, 7960,
     /*  267780 */     GIR_EraseRootFromParent_Done,
     /*  267781 */   // Label 5074: @267781
     /*  267781 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(267844), // Rule ID 7961 //
     /*  267786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  267800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267825 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  267828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267842 */     GIR_RootConstrainSelectedInstOperands,
     /*  267843 */     // GIR_Coverage, 7961,
     /*  267843 */     GIR_EraseRootFromParent_Done,
     /*  267844 */   // Label 5075: @267844
     /*  267844 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(267907), // Rule ID 7964 //
     /*  267849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267905 */     GIR_RootConstrainSelectedInstOperands,
     /*  267906 */     // GIR_Coverage, 7964,
     /*  267906 */     GIR_EraseRootFromParent_Done,
     /*  267907 */   // Label 5076: @267907
     /*  267907 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(267970), // Rule ID 7965 //
     /*  267912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  267926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267951 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  267954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267968 */     GIR_RootConstrainSelectedInstOperands,
     /*  267969 */     // GIR_Coverage, 7965,
     /*  267969 */     GIR_EraseRootFromParent_Done,
     /*  267970 */   // Label 5077: @267970
     /*  267970 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(268033), // Rule ID 8056 //
     /*  267975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  267989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  267992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  268017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268031 */     GIR_RootConstrainSelectedInstOperands,
     /*  268032 */     // GIR_Coverage, 8056,
     /*  268032 */     GIR_EraseRootFromParent_Done,
     /*  268033 */   // Label 5078: @268033
     /*  268033 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(268096), // Rule ID 8057 //
     /*  268038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  268052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  268055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  268080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268094 */     GIR_RootConstrainSelectedInstOperands,
     /*  268095 */     // GIR_Coverage, 8057,
     /*  268095 */     GIR_EraseRootFromParent_Done,
     /*  268096 */   // Label 5079: @268096
     /*  268096 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(268159), // Rule ID 8060 //
     /*  268101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  268115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  268118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268157 */     GIR_RootConstrainSelectedInstOperands,
     /*  268158 */     // GIR_Coverage, 8060,
     /*  268158 */     GIR_EraseRootFromParent_Done,
     /*  268159 */   // Label 5080: @268159
     /*  268159 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(268222), // Rule ID 8061 //
     /*  268164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  268178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  268181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268220 */     GIR_RootConstrainSelectedInstOperands,
     /*  268221 */     // GIR_Coverage, 8061,
     /*  268221 */     GIR_EraseRootFromParent_Done,
     /*  268222 */   // Label 5081: @268222
     /*  268222 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(268285), // Rule ID 8064 //
     /*  268227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  268241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  268244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268283 */     GIR_RootConstrainSelectedInstOperands,
     /*  268284 */     // GIR_Coverage, 8064,
     /*  268284 */     GIR_EraseRootFromParent_Done,
     /*  268285 */   // Label 5082: @268285
     /*  268285 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(268348), // Rule ID 8065 //
     /*  268290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  268304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  268307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268329 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268346 */     GIR_RootConstrainSelectedInstOperands,
     /*  268347 */     // GIR_Coverage, 8065,
     /*  268347 */     GIR_EraseRootFromParent_Done,
     /*  268348 */   // Label 5083: @268348
     /*  268348 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(268411), // Rule ID 8068 //
     /*  268353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  268367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  268370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268409 */     GIR_RootConstrainSelectedInstOperands,
     /*  268410 */     // GIR_Coverage, 8068,
     /*  268410 */     GIR_EraseRootFromParent_Done,
     /*  268411 */   // Label 5084: @268411
     /*  268411 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(268474), // Rule ID 8069 //
     /*  268416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  268430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  268433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  268458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268472 */     GIR_RootConstrainSelectedInstOperands,
     /*  268473 */     // GIR_Coverage, 8069,
     /*  268473 */     GIR_EraseRootFromParent_Done,
     /*  268474 */   // Label 5085: @268474
     /*  268474 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(268537), // Rule ID 8072 //
     /*  268479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  268493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  268496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268535 */     GIR_RootConstrainSelectedInstOperands,
     /*  268536 */     // GIR_Coverage, 8072,
     /*  268536 */     GIR_EraseRootFromParent_Done,
     /*  268537 */   // Label 5086: @268537
     /*  268537 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(268600), // Rule ID 8073 //
     /*  268542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  268556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  268559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268581 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268598 */     GIR_RootConstrainSelectedInstOperands,
     /*  268599 */     // GIR_Coverage, 8073,
     /*  268599 */     GIR_EraseRootFromParent_Done,
     /*  268600 */   // Label 5087: @268600
     /*  268600 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(268663), // Rule ID 8076 //
     /*  268605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  268622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268661 */     GIR_RootConstrainSelectedInstOperands,
     /*  268662 */     // GIR_Coverage, 8076,
     /*  268662 */     GIR_EraseRootFromParent_Done,
     /*  268663 */   // Label 5088: @268663
     /*  268663 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(268726), // Rule ID 8077 //
     /*  268668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  268682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  268685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268707 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  268710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268724 */     GIR_RootConstrainSelectedInstOperands,
     /*  268725 */     // GIR_Coverage, 8077,
     /*  268725 */     GIR_EraseRootFromParent_Done,
     /*  268726 */   // Label 5089: @268726
     /*  268726 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(268789), // Rule ID 8080 //
     /*  268731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  268748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268787 */     GIR_RootConstrainSelectedInstOperands,
     /*  268788 */     // GIR_Coverage, 8080,
     /*  268788 */     GIR_EraseRootFromParent_Done,
     /*  268789 */   // Label 5090: @268789
     /*  268789 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(268852), // Rule ID 8081 //
     /*  268794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  268808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  268811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268850 */     GIR_RootConstrainSelectedInstOperands,
     /*  268851 */     // GIR_Coverage, 8081,
     /*  268851 */     GIR_EraseRootFromParent_Done,
     /*  268852 */   // Label 5091: @268852
     /*  268852 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(268915), // Rule ID 8084 //
     /*  268857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  268874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268913 */     GIR_RootConstrainSelectedInstOperands,
     /*  268914 */     // GIR_Coverage, 8084,
     /*  268914 */     GIR_EraseRootFromParent_Done,
     /*  268915 */   // Label 5092: @268915
     /*  268915 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(268978), // Rule ID 8085 //
     /*  268920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  268934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  268937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  268962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268976 */     GIR_RootConstrainSelectedInstOperands,
     /*  268977 */     // GIR_Coverage, 8085,
     /*  268977 */     GIR_EraseRootFromParent_Done,
     /*  268978 */   // Label 5093: @268978
     /*  268978 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(269041), // Rule ID 8088 //
     /*  268983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  268997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  269000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269039 */     GIR_RootConstrainSelectedInstOperands,
     /*  269040 */     // GIR_Coverage, 8088,
     /*  269040 */     GIR_EraseRootFromParent_Done,
     /*  269041 */   // Label 5094: @269041
     /*  269041 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(269104), // Rule ID 8089 //
     /*  269046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  269060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  269063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269085 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269102 */     GIR_RootConstrainSelectedInstOperands,
     /*  269103 */     // GIR_Coverage, 8089,
     /*  269103 */     GIR_EraseRootFromParent_Done,
     /*  269104 */   // Label 5095: @269104
     /*  269104 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(269167), // Rule ID 8092 //
     /*  269109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  269123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  269126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269165 */     GIR_RootConstrainSelectedInstOperands,
     /*  269166 */     // GIR_Coverage, 8092,
     /*  269166 */     GIR_EraseRootFromParent_Done,
     /*  269167 */   // Label 5096: @269167
     /*  269167 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(269230), // Rule ID 8093 //
     /*  269172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  269186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  269189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269211 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  269214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269228 */     GIR_RootConstrainSelectedInstOperands,
     /*  269229 */     // GIR_Coverage, 8093,
     /*  269229 */     GIR_EraseRootFromParent_Done,
     /*  269230 */   // Label 5097: @269230
     /*  269230 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(269293), // Rule ID 8096 //
     /*  269235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  269249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  269252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269291 */     GIR_RootConstrainSelectedInstOperands,
     /*  269292 */     // GIR_Coverage, 8096,
     /*  269292 */     GIR_EraseRootFromParent_Done,
     /*  269293 */   // Label 5098: @269293
     /*  269293 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(269356), // Rule ID 8097 //
     /*  269298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  269312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  269315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269354 */     GIR_RootConstrainSelectedInstOperands,
     /*  269355 */     // GIR_Coverage, 8097,
     /*  269355 */     GIR_EraseRootFromParent_Done,
     /*  269356 */   // Label 5099: @269356
     /*  269356 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(269419), // Rule ID 8100 //
     /*  269361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  269375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  269378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269417 */     GIR_RootConstrainSelectedInstOperands,
     /*  269418 */     // GIR_Coverage, 8100,
     /*  269418 */     GIR_EraseRootFromParent_Done,
     /*  269419 */   // Label 5100: @269419
     /*  269419 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(269482), // Rule ID 8101 //
     /*  269424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  269438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  269441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269463 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269480 */     GIR_RootConstrainSelectedInstOperands,
     /*  269481 */     // GIR_Coverage, 8101,
     /*  269481 */     GIR_EraseRootFromParent_Done,
     /*  269482 */   // Label 5101: @269482
     /*  269482 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(269545), // Rule ID 8104 //
     /*  269487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  269498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  269501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  269504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269526 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269543 */     GIR_RootConstrainSelectedInstOperands,
     /*  269544 */     // GIR_Coverage, 8104,
     /*  269544 */     GIR_EraseRootFromParent_Done,
     /*  269545 */   // Label 5102: @269545
     /*  269545 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(269608), // Rule ID 8105 //
     /*  269550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  269561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  269564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  269567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269589 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269606 */     GIR_RootConstrainSelectedInstOperands,
     /*  269607 */     // GIR_Coverage, 8105,
     /*  269607 */     GIR_EraseRootFromParent_Done,
     /*  269608 */   // Label 5103: @269608
     /*  269608 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(269671), // Rule ID 8108 //
     /*  269613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  269630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269669 */     GIR_RootConstrainSelectedInstOperands,
     /*  269670 */     // GIR_Coverage, 8108,
     /*  269670 */     GIR_EraseRootFromParent_Done,
     /*  269671 */   // Label 5104: @269671
     /*  269671 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(269734), // Rule ID 8109 //
     /*  269676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  269690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  269693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269715 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  269718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269732 */     GIR_RootConstrainSelectedInstOperands,
     /*  269733 */     // GIR_Coverage, 8109,
     /*  269733 */     GIR_EraseRootFromParent_Done,
     /*  269734 */   // Label 5105: @269734
     /*  269734 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(269797), // Rule ID 8112 //
     /*  269739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  269756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269795 */     GIR_RootConstrainSelectedInstOperands,
     /*  269796 */     // GIR_Coverage, 8112,
     /*  269796 */     GIR_EraseRootFromParent_Done,
     /*  269797 */   // Label 5106: @269797
     /*  269797 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(269860), // Rule ID 8113 //
     /*  269802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  269816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  269819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269841 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  269844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269858 */     GIR_RootConstrainSelectedInstOperands,
     /*  269859 */     // GIR_Coverage, 8113,
     /*  269859 */     GIR_EraseRootFromParent_Done,
     /*  269860 */   // Label 5107: @269860
     /*  269860 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(269923), // Rule ID 8116 //
     /*  269865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  269882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269904 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269921 */     GIR_RootConstrainSelectedInstOperands,
     /*  269922 */     // GIR_Coverage, 8116,
     /*  269922 */     GIR_EraseRootFromParent_Done,
     /*  269923 */   // Label 5108: @269923
     /*  269923 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(269986), // Rule ID 8117 //
     /*  269928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  269939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  269942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  269945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269967 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  269970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269984 */     GIR_RootConstrainSelectedInstOperands,
     /*  269985 */     // GIR_Coverage, 8117,
     /*  269985 */     GIR_EraseRootFromParent_Done,
     /*  269986 */   // Label 5109: @269986
     /*  269986 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(270049), // Rule ID 8120 //
     /*  269991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  270005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  270008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270047 */     GIR_RootConstrainSelectedInstOperands,
     /*  270048 */     // GIR_Coverage, 8120,
     /*  270048 */     GIR_EraseRootFromParent_Done,
     /*  270049 */   // Label 5110: @270049
     /*  270049 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(270112), // Rule ID 8121 //
     /*  270054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  270068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  270071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270093 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270110 */     GIR_RootConstrainSelectedInstOperands,
     /*  270111 */     // GIR_Coverage, 8121,
     /*  270111 */     GIR_EraseRootFromParent_Done,
     /*  270112 */   // Label 5111: @270112
     /*  270112 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(270175), // Rule ID 8124 //
     /*  270117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  270131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  270134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270173 */     GIR_RootConstrainSelectedInstOperands,
     /*  270174 */     // GIR_Coverage, 8124,
     /*  270174 */     GIR_EraseRootFromParent_Done,
     /*  270175 */   // Label 5112: @270175
     /*  270175 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(270238), // Rule ID 8125 //
     /*  270180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  270194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  270197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270236 */     GIR_RootConstrainSelectedInstOperands,
     /*  270237 */     // GIR_Coverage, 8125,
     /*  270237 */     GIR_EraseRootFromParent_Done,
     /*  270238 */   // Label 5113: @270238
     /*  270238 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(270301), // Rule ID 8128 //
     /*  270243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  270257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  270260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270299 */     GIR_RootConstrainSelectedInstOperands,
     /*  270300 */     // GIR_Coverage, 8128,
     /*  270300 */     GIR_EraseRootFromParent_Done,
     /*  270301 */   // Label 5114: @270301
     /*  270301 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(270364), // Rule ID 8129 //
     /*  270306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  270320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  270323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270345 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270362 */     GIR_RootConstrainSelectedInstOperands,
     /*  270363 */     // GIR_Coverage, 8129,
     /*  270363 */     GIR_EraseRootFromParent_Done,
     /*  270364 */   // Label 5115: @270364
     /*  270364 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(270427), // Rule ID 8132 //
     /*  270369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  270383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  270386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270425 */     GIR_RootConstrainSelectedInstOperands,
     /*  270426 */     // GIR_Coverage, 8132,
     /*  270426 */     GIR_EraseRootFromParent_Done,
     /*  270427 */   // Label 5116: @270427
     /*  270427 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(270490), // Rule ID 8133 //
     /*  270432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  270446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  270449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270471 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  270474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270488 */     GIR_RootConstrainSelectedInstOperands,
     /*  270489 */     // GIR_Coverage, 8133,
     /*  270489 */     GIR_EraseRootFromParent_Done,
     /*  270490 */   // Label 5117: @270490
     /*  270490 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(270553), // Rule ID 8136 //
     /*  270495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  270509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  270512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270551 */     GIR_RootConstrainSelectedInstOperands,
     /*  270552 */     // GIR_Coverage, 8136,
     /*  270552 */     GIR_EraseRootFromParent_Done,
     /*  270553 */   // Label 5118: @270553
     /*  270553 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(270616), // Rule ID 8137 //
     /*  270558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  270572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  270575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  270600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270614 */     GIR_RootConstrainSelectedInstOperands,
     /*  270615 */     // GIR_Coverage, 8137,
     /*  270615 */     GIR_EraseRootFromParent_Done,
     /*  270616 */   // Label 5119: @270616
     /*  270616 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(270679), // Rule ID 8140 //
     /*  270621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  270638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270677 */     GIR_RootConstrainSelectedInstOperands,
     /*  270678 */     // GIR_Coverage, 8140,
     /*  270678 */     GIR_EraseRootFromParent_Done,
     /*  270679 */   // Label 5120: @270679
     /*  270679 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(270742), // Rule ID 8141 //
     /*  270684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  270698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  270701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  270726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270740 */     GIR_RootConstrainSelectedInstOperands,
     /*  270741 */     // GIR_Coverage, 8141,
     /*  270741 */     GIR_EraseRootFromParent_Done,
     /*  270742 */   // Label 5121: @270742
     /*  270742 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(270805), // Rule ID 8144 //
     /*  270747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  270789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270803 */     GIR_RootConstrainSelectedInstOperands,
     /*  270804 */     // GIR_Coverage, 8144,
     /*  270804 */     GIR_EraseRootFromParent_Done,
     /*  270805 */   // Label 5122: @270805
     /*  270805 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(270868), // Rule ID 8145 //
     /*  270810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  270824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270849 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  270852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270866 */     GIR_RootConstrainSelectedInstOperands,
     /*  270867 */     // GIR_Coverage, 8145,
     /*  270867 */     GIR_EraseRootFromParent_Done,
     /*  270868 */   // Label 5123: @270868
     /*  270868 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(270931), // Rule ID 8148 //
     /*  270873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  270890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  270915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270929 */     GIR_RootConstrainSelectedInstOperands,
     /*  270930 */     // GIR_Coverage, 8148,
     /*  270930 */     GIR_EraseRootFromParent_Done,
     /*  270931 */   // Label 5124: @270931
     /*  270931 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(270994), // Rule ID 8149 //
     /*  270936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  270944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  270950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  270953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  270968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  270978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270992 */     GIR_RootConstrainSelectedInstOperands,
     /*  270993 */     // GIR_Coverage, 8149,
     /*  270993 */     GIR_EraseRootFromParent_Done,
     /*  270994 */   // Label 5125: @270994
     /*  270994 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(271057), // Rule ID 8152 //
     /*  270999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  271013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271055 */     GIR_RootConstrainSelectedInstOperands,
     /*  271056 */     // GIR_Coverage, 8152,
     /*  271056 */     GIR_EraseRootFromParent_Done,
     /*  271057 */   // Label 5126: @271057
     /*  271057 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(271120), // Rule ID 8153 //
     /*  271062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  271076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271118 */     GIR_RootConstrainSelectedInstOperands,
     /*  271119 */     // GIR_Coverage, 8153,
     /*  271119 */     GIR_EraseRootFromParent_Done,
     /*  271120 */   // Label 5127: @271120
     /*  271120 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(271183), // Rule ID 8156 //
     /*  271125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  271139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  271167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271181 */     GIR_RootConstrainSelectedInstOperands,
     /*  271182 */     // GIR_Coverage, 8156,
     /*  271182 */     GIR_EraseRootFromParent_Done,
     /*  271183 */   // Label 5128: @271183
     /*  271183 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(271246), // Rule ID 8157 //
     /*  271188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  271202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  271230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271244 */     GIR_RootConstrainSelectedInstOperands,
     /*  271245 */     // GIR_Coverage, 8157,
     /*  271245 */     GIR_EraseRootFromParent_Done,
     /*  271246 */   // Label 5129: @271246
     /*  271246 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(271309), // Rule ID 8160 //
     /*  271251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  271265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271307 */     GIR_RootConstrainSelectedInstOperands,
     /*  271308 */     // GIR_Coverage, 8160,
     /*  271308 */     GIR_EraseRootFromParent_Done,
     /*  271309 */   // Label 5130: @271309
     /*  271309 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(271372), // Rule ID 8161 //
     /*  271314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  271328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271353 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271370 */     GIR_RootConstrainSelectedInstOperands,
     /*  271371 */     // GIR_Coverage, 8161,
     /*  271371 */     GIR_EraseRootFromParent_Done,
     /*  271372 */   // Label 5131: @271372
     /*  271372 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(271435), // Rule ID 8164 //
     /*  271377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  271391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271433 */     GIR_RootConstrainSelectedInstOperands,
     /*  271434 */     // GIR_Coverage, 8164,
     /*  271434 */     GIR_EraseRootFromParent_Done,
     /*  271435 */   // Label 5132: @271435
     /*  271435 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(271498), // Rule ID 8165 //
     /*  271440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  271454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  271482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271496 */     GIR_RootConstrainSelectedInstOperands,
     /*  271497 */     // GIR_Coverage, 8165,
     /*  271497 */     GIR_EraseRootFromParent_Done,
     /*  271498 */   // Label 5133: @271498
     /*  271498 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(271561), // Rule ID 8168 //
     /*  271503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271559 */     GIR_RootConstrainSelectedInstOperands,
     /*  271560 */     // GIR_Coverage, 8168,
     /*  271560 */     GIR_EraseRootFromParent_Done,
     /*  271561 */   // Label 5134: @271561
     /*  271561 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(271624), // Rule ID 8169 //
     /*  271566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  271580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271622 */     GIR_RootConstrainSelectedInstOperands,
     /*  271623 */     // GIR_Coverage, 8169,
     /*  271623 */     GIR_EraseRootFromParent_Done,
     /*  271624 */   // Label 5135: @271624
     /*  271624 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(271687), // Rule ID 8172 //
     /*  271629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271685 */     GIR_RootConstrainSelectedInstOperands,
     /*  271686 */     // GIR_Coverage, 8172,
     /*  271686 */     GIR_EraseRootFromParent_Done,
     /*  271687 */   // Label 5136: @271687
     /*  271687 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(271750), // Rule ID 8173 //
     /*  271692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  271706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271748 */     GIR_RootConstrainSelectedInstOperands,
     /*  271749 */     // GIR_Coverage, 8173,
     /*  271749 */     GIR_EraseRootFromParent_Done,
     /*  271750 */   // Label 5137: @271750
     /*  271750 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(271813), // Rule ID 8176 //
     /*  271755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271811 */     GIR_RootConstrainSelectedInstOperands,
     /*  271812 */     // GIR_Coverage, 8176,
     /*  271812 */     GIR_EraseRootFromParent_Done,
     /*  271813 */   // Label 5138: @271813
     /*  271813 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(271876), // Rule ID 8177 //
     /*  271818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  271832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271857 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271874 */     GIR_RootConstrainSelectedInstOperands,
     /*  271875 */     // GIR_Coverage, 8177,
     /*  271875 */     GIR_EraseRootFromParent_Done,
     /*  271876 */   // Label 5139: @271876
     /*  271876 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(271939), // Rule ID 8180 //
     /*  271881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271937 */     GIR_RootConstrainSelectedInstOperands,
     /*  271938 */     // GIR_Coverage, 8180,
     /*  271938 */     GIR_EraseRootFromParent_Done,
     /*  271939 */   // Label 5140: @271939
     /*  271939 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(272002), // Rule ID 8181 //
     /*  271944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  271952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  271958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  271961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  271986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272000 */     GIR_RootConstrainSelectedInstOperands,
     /*  272001 */     // GIR_Coverage, 8181,
     /*  272001 */     GIR_EraseRootFromParent_Done,
     /*  272002 */   // Label 5141: @272002
     /*  272002 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(272065), // Rule ID 8184 //
     /*  272007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  272021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272046 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272063 */     GIR_RootConstrainSelectedInstOperands,
     /*  272064 */     // GIR_Coverage, 8184,
     /*  272064 */     GIR_EraseRootFromParent_Done,
     /*  272065 */   // Label 5142: @272065
     /*  272065 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(272128), // Rule ID 8185 //
     /*  272070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  272084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272126 */     GIR_RootConstrainSelectedInstOperands,
     /*  272127 */     // GIR_Coverage, 8185,
     /*  272127 */     GIR_EraseRootFromParent_Done,
     /*  272128 */   // Label 5143: @272128
     /*  272128 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(272191), // Rule ID 8188 //
     /*  272133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  272147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272172 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272189 */     GIR_RootConstrainSelectedInstOperands,
     /*  272190 */     // GIR_Coverage, 8188,
     /*  272190 */     GIR_EraseRootFromParent_Done,
     /*  272191 */   // Label 5144: @272191
     /*  272191 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(272254), // Rule ID 8189 //
     /*  272196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  272210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272235 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272252 */     GIR_RootConstrainSelectedInstOperands,
     /*  272253 */     // GIR_Coverage, 8189,
     /*  272253 */     GIR_EraseRootFromParent_Done,
     /*  272254 */   // Label 5145: @272254
     /*  272254 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(272317), // Rule ID 8192 //
     /*  272259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  272270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  272273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272298 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272315 */     GIR_RootConstrainSelectedInstOperands,
     /*  272316 */     // GIR_Coverage, 8192,
     /*  272316 */     GIR_EraseRootFromParent_Done,
     /*  272317 */   // Label 5146: @272317
     /*  272317 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(272380), // Rule ID 8193 //
     /*  272322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  272333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  272336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272361 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272378 */     GIR_RootConstrainSelectedInstOperands,
     /*  272379 */     // GIR_Coverage, 8193,
     /*  272379 */     GIR_EraseRootFromParent_Done,
     /*  272380 */   // Label 5147: @272380
     /*  272380 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(272443), // Rule ID 8196 //
     /*  272385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272441 */     GIR_RootConstrainSelectedInstOperands,
     /*  272442 */     // GIR_Coverage, 8196,
     /*  272442 */     GIR_EraseRootFromParent_Done,
     /*  272443 */   // Label 5148: @272443
     /*  272443 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(272506), // Rule ID 8197 //
     /*  272448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  272462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272487 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272504 */     GIR_RootConstrainSelectedInstOperands,
     /*  272505 */     // GIR_Coverage, 8197,
     /*  272505 */     GIR_EraseRootFromParent_Done,
     /*  272506 */   // Label 5149: @272506
     /*  272506 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(272569), // Rule ID 8200 //
     /*  272511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272567 */     GIR_RootConstrainSelectedInstOperands,
     /*  272568 */     // GIR_Coverage, 8200,
     /*  272568 */     GIR_EraseRootFromParent_Done,
     /*  272569 */   // Label 5150: @272569
     /*  272569 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(272632), // Rule ID 8201 //
     /*  272574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  272588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272613 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272630 */     GIR_RootConstrainSelectedInstOperands,
     /*  272631 */     // GIR_Coverage, 8201,
     /*  272631 */     GIR_EraseRootFromParent_Done,
     /*  272632 */   // Label 5151: @272632
     /*  272632 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(272695), // Rule ID 8204 //
     /*  272637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272676 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272693 */     GIR_RootConstrainSelectedInstOperands,
     /*  272694 */     // GIR_Coverage, 8204,
     /*  272694 */     GIR_EraseRootFromParent_Done,
     /*  272695 */   // Label 5152: @272695
     /*  272695 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(272758), // Rule ID 8205 //
     /*  272700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  272711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  272714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272739 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  272742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272756 */     GIR_RootConstrainSelectedInstOperands,
     /*  272757 */     // GIR_Coverage, 8205,
     /*  272757 */     GIR_EraseRootFromParent_Done,
     /*  272758 */   // Label 5153: @272758
     /*  272758 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(272821), // Rule ID 8208 //
     /*  272763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272819 */     GIR_RootConstrainSelectedInstOperands,
     /*  272820 */     // GIR_Coverage, 8208,
     /*  272820 */     GIR_EraseRootFromParent_Done,
     /*  272821 */   // Label 5154: @272821
     /*  272821 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(272884), // Rule ID 8209 //
     /*  272826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  272840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272865 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  272868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272882 */     GIR_RootConstrainSelectedInstOperands,
     /*  272883 */     // GIR_Coverage, 8209,
     /*  272883 */     GIR_EraseRootFromParent_Done,
     /*  272884 */   // Label 5155: @272884
     /*  272884 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(272947), // Rule ID 8212 //
     /*  272889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272928 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272945 */     GIR_RootConstrainSelectedInstOperands,
     /*  272946 */     // GIR_Coverage, 8212,
     /*  272946 */     GIR_EraseRootFromParent_Done,
     /*  272947 */   // Label 5156: @272947
     /*  272947 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(273010), // Rule ID 8213 //
     /*  272952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  272960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  272966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272991 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  272994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273008 */     GIR_RootConstrainSelectedInstOperands,
     /*  273009 */     // GIR_Coverage, 8213,
     /*  273009 */     GIR_EraseRootFromParent_Done,
     /*  273010 */   // Label 5157: @273010
     /*  273010 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(273073), // Rule ID 8216 //
     /*  273015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  273029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273054 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273071 */     GIR_RootConstrainSelectedInstOperands,
     /*  273072 */     // GIR_Coverage, 8216,
     /*  273072 */     GIR_EraseRootFromParent_Done,
     /*  273073 */   // Label 5158: @273073
     /*  273073 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(273136), // Rule ID 8217 //
     /*  273078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  273092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273117 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273134 */     GIR_RootConstrainSelectedInstOperands,
     /*  273135 */     // GIR_Coverage, 8217,
     /*  273135 */     GIR_EraseRootFromParent_Done,
     /*  273136 */   // Label 5159: @273136
     /*  273136 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(273199), // Rule ID 8220 //
     /*  273141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  273155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  273183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273197 */     GIR_RootConstrainSelectedInstOperands,
     /*  273198 */     // GIR_Coverage, 8220,
     /*  273198 */     GIR_EraseRootFromParent_Done,
     /*  273199 */   // Label 5160: @273199
     /*  273199 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(273262), // Rule ID 8221 //
     /*  273204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  273218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273243 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  273246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273260 */     GIR_RootConstrainSelectedInstOperands,
     /*  273261 */     // GIR_Coverage, 8221,
     /*  273261 */     GIR_EraseRootFromParent_Done,
     /*  273262 */   // Label 5161: @273262
     /*  273262 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(273325), // Rule ID 8224 //
     /*  273267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  273281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  273309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273323 */     GIR_RootConstrainSelectedInstOperands,
     /*  273324 */     // GIR_Coverage, 8224,
     /*  273324 */     GIR_EraseRootFromParent_Done,
     /*  273325 */   // Label 5162: @273325
     /*  273325 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(273388), // Rule ID 8225 //
     /*  273330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  273344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  273372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273386 */     GIR_RootConstrainSelectedInstOperands,
     /*  273387 */     // GIR_Coverage, 8225,
     /*  273387 */     GIR_EraseRootFromParent_Done,
     /*  273388 */   // Label 5163: @273388
     /*  273388 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(273451), // Rule ID 8228 //
     /*  273393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273449 */     GIR_RootConstrainSelectedInstOperands,
     /*  273450 */     // GIR_Coverage, 8228,
     /*  273450 */     GIR_EraseRootFromParent_Done,
     /*  273451 */   // Label 5164: @273451
     /*  273451 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(273514), // Rule ID 8229 //
     /*  273456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  273464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  273470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  273498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273512 */     GIR_RootConstrainSelectedInstOperands,
     /*  273513 */     // GIR_Coverage, 8229,
     /*  273513 */     GIR_EraseRootFromParent_Done,
     /*  273514 */   // Label 5165: @273514
     /*  273514 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(273577), // Rule ID 8320 //
     /*  273519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  273561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273575 */     GIR_RootConstrainSelectedInstOperands,
     /*  273576 */     // GIR_Coverage, 8320,
     /*  273576 */     GIR_EraseRootFromParent_Done,
     /*  273577 */   // Label 5166: @273577
     /*  273577 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(273640), // Rule ID 8321 //
     /*  273582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  273596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  273599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273621 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  273624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273638 */     GIR_RootConstrainSelectedInstOperands,
     /*  273639 */     // GIR_Coverage, 8321,
     /*  273639 */     GIR_EraseRootFromParent_Done,
     /*  273640 */   // Label 5167: @273640
     /*  273640 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(273703), // Rule ID 8324 //
     /*  273645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273701 */     GIR_RootConstrainSelectedInstOperands,
     /*  273702 */     // GIR_Coverage, 8324,
     /*  273702 */     GIR_EraseRootFromParent_Done,
     /*  273703 */   // Label 5168: @273703
     /*  273703 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(273766), // Rule ID 8325 //
     /*  273708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  273722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  273725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273764 */     GIR_RootConstrainSelectedInstOperands,
     /*  273765 */     // GIR_Coverage, 8325,
     /*  273765 */     GIR_EraseRootFromParent_Done,
     /*  273766 */   // Label 5169: @273766
     /*  273766 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(273829), // Rule ID 8328 //
     /*  273771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  273813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273827 */     GIR_RootConstrainSelectedInstOperands,
     /*  273828 */     // GIR_Coverage, 8328,
     /*  273828 */     GIR_EraseRootFromParent_Done,
     /*  273829 */   // Label 5170: @273829
     /*  273829 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(273892), // Rule ID 8329 //
     /*  273834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  273848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  273851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273873 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  273876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273890 */     GIR_RootConstrainSelectedInstOperands,
     /*  273891 */     // GIR_Coverage, 8329,
     /*  273891 */     GIR_EraseRootFromParent_Done,
     /*  273892 */   // Label 5171: @273892
     /*  273892 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(273955), // Rule ID 8332 //
     /*  273897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  273939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273953 */     GIR_RootConstrainSelectedInstOperands,
     /*  273954 */     // GIR_Coverage, 8332,
     /*  273954 */     GIR_EraseRootFromParent_Done,
     /*  273955 */   // Label 5172: @273955
     /*  273955 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(274018), // Rule ID 8333 //
     /*  273960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  273974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  273977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  274002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274016 */     GIR_RootConstrainSelectedInstOperands,
     /*  274017 */     // GIR_Coverage, 8333,
     /*  274017 */     GIR_EraseRootFromParent_Done,
     /*  274018 */   // Label 5173: @274018
     /*  274018 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(274081), // Rule ID 8336 //
     /*  274023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  274037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  274040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274079 */     GIR_RootConstrainSelectedInstOperands,
     /*  274080 */     // GIR_Coverage, 8336,
     /*  274080 */     GIR_EraseRootFromParent_Done,
     /*  274081 */   // Label 5174: @274081
     /*  274081 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(274144), // Rule ID 8337 //
     /*  274086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  274100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  274103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274142 */     GIR_RootConstrainSelectedInstOperands,
     /*  274143 */     // GIR_Coverage, 8337,
     /*  274143 */     GIR_EraseRootFromParent_Done,
     /*  274144 */   // Label 5175: @274144
     /*  274144 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(274207), // Rule ID 8340 //
     /*  274149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  274163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  274166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274205 */     GIR_RootConstrainSelectedInstOperands,
     /*  274206 */     // GIR_Coverage, 8340,
     /*  274206 */     GIR_EraseRootFromParent_Done,
     /*  274207 */   // Label 5176: @274207
     /*  274207 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(274270), // Rule ID 8341 //
     /*  274212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  274226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  274229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274251 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  274254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274268 */     GIR_RootConstrainSelectedInstOperands,
     /*  274269 */     // GIR_Coverage, 8341,
     /*  274269 */     GIR_EraseRootFromParent_Done,
     /*  274270 */   // Label 5177: @274270
     /*  274270 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(274333), // Rule ID 8344 //
     /*  274275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274314 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274331 */     GIR_RootConstrainSelectedInstOperands,
     /*  274332 */     // GIR_Coverage, 8344,
     /*  274332 */     GIR_EraseRootFromParent_Done,
     /*  274333 */   // Label 5178: @274333
     /*  274333 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(274396), // Rule ID 8345 //
     /*  274338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  274352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  274355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274377 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274394 */     GIR_RootConstrainSelectedInstOperands,
     /*  274395 */     // GIR_Coverage, 8345,
     /*  274395 */     GIR_EraseRootFromParent_Done,
     /*  274396 */   // Label 5179: @274396
     /*  274396 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(274459), // Rule ID 8348 //
     /*  274401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274457 */     GIR_RootConstrainSelectedInstOperands,
     /*  274458 */     // GIR_Coverage, 8348,
     /*  274458 */     GIR_EraseRootFromParent_Done,
     /*  274459 */   // Label 5180: @274459
     /*  274459 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(274522), // Rule ID 8349 //
     /*  274464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  274478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  274481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274503 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274520 */     GIR_RootConstrainSelectedInstOperands,
     /*  274521 */     // GIR_Coverage, 8349,
     /*  274521 */     GIR_EraseRootFromParent_Done,
     /*  274522 */   // Label 5181: @274522
     /*  274522 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(274585), // Rule ID 8352 //
     /*  274527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274583 */     GIR_RootConstrainSelectedInstOperands,
     /*  274584 */     // GIR_Coverage, 8352,
     /*  274584 */     GIR_EraseRootFromParent_Done,
     /*  274585 */   // Label 5182: @274585
     /*  274585 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(274648), // Rule ID 8353 //
     /*  274590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  274604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  274607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274629 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274646 */     GIR_RootConstrainSelectedInstOperands,
     /*  274647 */     // GIR_Coverage, 8353,
     /*  274647 */     GIR_EraseRootFromParent_Done,
     /*  274648 */   // Label 5183: @274648
     /*  274648 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(274711), // Rule ID 8356 //
     /*  274653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274692 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274709 */     GIR_RootConstrainSelectedInstOperands,
     /*  274710 */     // GIR_Coverage, 8356,
     /*  274710 */     GIR_EraseRootFromParent_Done,
     /*  274711 */   // Label 5184: @274711
     /*  274711 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(274774), // Rule ID 8357 //
     /*  274716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  274730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  274733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274755 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  274758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274772 */     GIR_RootConstrainSelectedInstOperands,
     /*  274773 */     // GIR_Coverage, 8357,
     /*  274773 */     GIR_EraseRootFromParent_Done,
     /*  274774 */   // Label 5185: @274774
     /*  274774 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(274837), // Rule ID 8360 //
     /*  274779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274818 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  274821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274835 */     GIR_RootConstrainSelectedInstOperands,
     /*  274836 */     // GIR_Coverage, 8360,
     /*  274836 */     GIR_EraseRootFromParent_Done,
     /*  274837 */   // Label 5186: @274837
     /*  274837 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(274900), // Rule ID 8361 //
     /*  274842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  274856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  274859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274881 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  274884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274898 */     GIR_RootConstrainSelectedInstOperands,
     /*  274899 */     // GIR_Coverage, 8361,
     /*  274899 */     GIR_EraseRootFromParent_Done,
     /*  274900 */   // Label 5187: @274900
     /*  274900 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(274963), // Rule ID 8364 //
     /*  274905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274944 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  274947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274961 */     GIR_RootConstrainSelectedInstOperands,
     /*  274962 */     // GIR_Coverage, 8364,
     /*  274962 */     GIR_EraseRootFromParent_Done,
     /*  274963 */   // Label 5188: @274963
     /*  274963 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(275026), // Rule ID 8365 //
     /*  274968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  274982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  274985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275007 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275024 */     GIR_RootConstrainSelectedInstOperands,
     /*  275025 */     // GIR_Coverage, 8365,
     /*  275025 */     GIR_EraseRootFromParent_Done,
     /*  275026 */   // Label 5189: @275026
     /*  275026 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(275089), // Rule ID 8368 //
     /*  275031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  275042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  275045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  275048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275070 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275087 */     GIR_RootConstrainSelectedInstOperands,
     /*  275088 */     // GIR_Coverage, 8368,
     /*  275088 */     GIR_EraseRootFromParent_Done,
     /*  275089 */   // Label 5190: @275089
     /*  275089 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(275152), // Rule ID 8369 //
     /*  275094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  275105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  275108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  275111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275133 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275150 */     GIR_RootConstrainSelectedInstOperands,
     /*  275151 */     // GIR_Coverage, 8369,
     /*  275151 */     GIR_EraseRootFromParent_Done,
     /*  275152 */   // Label 5191: @275152
     /*  275152 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(275215), // Rule ID 8372 //
     /*  275157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  275171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  275174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275213 */     GIR_RootConstrainSelectedInstOperands,
     /*  275214 */     // GIR_Coverage, 8372,
     /*  275214 */     GIR_EraseRootFromParent_Done,
     /*  275215 */   // Label 5192: @275215
     /*  275215 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(275278), // Rule ID 8373 //
     /*  275220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  275234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  275237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275259 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275276 */     GIR_RootConstrainSelectedInstOperands,
     /*  275277 */     // GIR_Coverage, 8373,
     /*  275277 */     GIR_EraseRootFromParent_Done,
     /*  275278 */   // Label 5193: @275278
     /*  275278 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(275341), // Rule ID 8376 //
     /*  275283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275339 */     GIR_RootConstrainSelectedInstOperands,
     /*  275340 */     // GIR_Coverage, 8376,
     /*  275340 */     GIR_EraseRootFromParent_Done,
     /*  275341 */   // Label 5194: @275341
     /*  275341 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(275404), // Rule ID 8377 //
     /*  275346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  275360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  275363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275385 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275402 */     GIR_RootConstrainSelectedInstOperands,
     /*  275403 */     // GIR_Coverage, 8377,
     /*  275403 */     GIR_EraseRootFromParent_Done,
     /*  275404 */   // Label 5195: @275404
     /*  275404 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(275467), // Rule ID 8380 //
     /*  275409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  275420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275448 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275465 */     GIR_RootConstrainSelectedInstOperands,
     /*  275466 */     // GIR_Coverage, 8380,
     /*  275466 */     GIR_EraseRootFromParent_Done,
     /*  275467 */   // Label 5196: @275467
     /*  275467 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(275530), // Rule ID 8381 //
     /*  275472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  275483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  275486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  275489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275511 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275528 */     GIR_RootConstrainSelectedInstOperands,
     /*  275529 */     // GIR_Coverage, 8381,
     /*  275529 */     GIR_EraseRootFromParent_Done,
     /*  275530 */   // Label 5197: @275530
     /*  275530 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(275593), // Rule ID 8384 //
     /*  275535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275591 */     GIR_RootConstrainSelectedInstOperands,
     /*  275592 */     // GIR_Coverage, 8384,
     /*  275592 */     GIR_EraseRootFromParent_Done,
     /*  275593 */   // Label 5198: @275593
     /*  275593 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(275656), // Rule ID 8385 //
     /*  275598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  275612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  275615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275637 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275654 */     GIR_RootConstrainSelectedInstOperands,
     /*  275655 */     // GIR_Coverage, 8385,
     /*  275655 */     GIR_EraseRootFromParent_Done,
     /*  275656 */   // Label 5199: @275656
     /*  275656 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(275719), // Rule ID 8388 //
     /*  275661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275717 */     GIR_RootConstrainSelectedInstOperands,
     /*  275718 */     // GIR_Coverage, 8388,
     /*  275718 */     GIR_EraseRootFromParent_Done,
     /*  275719 */   // Label 5200: @275719
     /*  275719 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(275782), // Rule ID 8389 //
     /*  275724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  275738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  275741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275763 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  275766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275780 */     GIR_RootConstrainSelectedInstOperands,
     /*  275781 */     // GIR_Coverage, 8389,
     /*  275781 */     GIR_EraseRootFromParent_Done,
     /*  275782 */   // Label 5201: @275782
     /*  275782 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(275845), // Rule ID 8392 //
     /*  275787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275826 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275843 */     GIR_RootConstrainSelectedInstOperands,
     /*  275844 */     // GIR_Coverage, 8392,
     /*  275844 */     GIR_EraseRootFromParent_Done,
     /*  275845 */   // Label 5202: @275845
     /*  275845 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(275908), // Rule ID 8393 //
     /*  275850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  275864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  275867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275889 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  275892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275906 */     GIR_RootConstrainSelectedInstOperands,
     /*  275907 */     // GIR_Coverage, 8393,
     /*  275907 */     GIR_EraseRootFromParent_Done,
     /*  275908 */   // Label 5203: @275908
     /*  275908 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(275971), // Rule ID 8396 //
     /*  275913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  275955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275969 */     GIR_RootConstrainSelectedInstOperands,
     /*  275970 */     // GIR_Coverage, 8396,
     /*  275970 */     GIR_EraseRootFromParent_Done,
     /*  275971 */   // Label 5204: @275971
     /*  275971 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(276034), // Rule ID 8397 //
     /*  275976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  275990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  275993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  276018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276032 */     GIR_RootConstrainSelectedInstOperands,
     /*  276033 */     // GIR_Coverage, 8397,
     /*  276033 */     GIR_EraseRootFromParent_Done,
     /*  276034 */   // Label 5205: @276034
     /*  276034 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(276097), // Rule ID 8400 //
     /*  276039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  276053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  276056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  276081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276095 */     GIR_RootConstrainSelectedInstOperands,
     /*  276096 */     // GIR_Coverage, 8400,
     /*  276096 */     GIR_EraseRootFromParent_Done,
     /*  276097 */   // Label 5206: @276097
     /*  276097 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(276160), // Rule ID 8401 //
     /*  276102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  276116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  276119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276141 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  276144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276158 */     GIR_RootConstrainSelectedInstOperands,
     /*  276159 */     // GIR_Coverage, 8401,
     /*  276159 */     GIR_EraseRootFromParent_Done,
     /*  276160 */   // Label 5207: @276160
     /*  276160 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(276223), // Rule ID 8404 //
     /*  276165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  276179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  276182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  276207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276221 */     GIR_RootConstrainSelectedInstOperands,
     /*  276222 */     // GIR_Coverage, 8404,
     /*  276222 */     GIR_EraseRootFromParent_Done,
     /*  276223 */   // Label 5208: @276223
     /*  276223 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(276286), // Rule ID 8405 //
     /*  276228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  276242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  276245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276267 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  276270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276284 */     GIR_RootConstrainSelectedInstOperands,
     /*  276285 */     // GIR_Coverage, 8405,
     /*  276285 */     GIR_EraseRootFromParent_Done,
     /*  276286 */   // Label 5209: @276286
     /*  276286 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(276349), // Rule ID 8408 //
     /*  276291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  276333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276347 */     GIR_RootConstrainSelectedInstOperands,
     /*  276348 */     // GIR_Coverage, 8408,
     /*  276348 */     GIR_EraseRootFromParent_Done,
     /*  276349 */   // Label 5210: @276349
     /*  276349 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(276412), // Rule ID 8409 //
     /*  276354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  276368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  276396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276410 */     GIR_RootConstrainSelectedInstOperands,
     /*  276411 */     // GIR_Coverage, 8409,
     /*  276411 */     GIR_EraseRootFromParent_Done,
     /*  276412 */   // Label 5211: @276412
     /*  276412 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(276475), // Rule ID 8412 //
     /*  276417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276473 */     GIR_RootConstrainSelectedInstOperands,
     /*  276474 */     // GIR_Coverage, 8412,
     /*  276474 */     GIR_EraseRootFromParent_Done,
     /*  276475 */   // Label 5212: @276475
     /*  276475 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(276538), // Rule ID 8413 //
     /*  276480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  276494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276519 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276536 */     GIR_RootConstrainSelectedInstOperands,
     /*  276537 */     // GIR_Coverage, 8413,
     /*  276537 */     GIR_EraseRootFromParent_Done,
     /*  276538 */   // Label 5213: @276538
     /*  276538 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(276601), // Rule ID 8416 //
     /*  276543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276582 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276599 */     GIR_RootConstrainSelectedInstOperands,
     /*  276600 */     // GIR_Coverage, 8416,
     /*  276600 */     GIR_EraseRootFromParent_Done,
     /*  276601 */   // Label 5214: @276601
     /*  276601 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(276664), // Rule ID 8417 //
     /*  276606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  276620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276645 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276662 */     GIR_RootConstrainSelectedInstOperands,
     /*  276663 */     // GIR_Coverage, 8417,
     /*  276663 */     GIR_EraseRootFromParent_Done,
     /*  276664 */   // Label 5215: @276664
     /*  276664 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(276727), // Rule ID 8420 //
     /*  276669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276725 */     GIR_RootConstrainSelectedInstOperands,
     /*  276726 */     // GIR_Coverage, 8420,
     /*  276726 */     GIR_EraseRootFromParent_Done,
     /*  276727 */   // Label 5216: @276727
     /*  276727 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(276790), // Rule ID 8421 //
     /*  276732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  276746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  276774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276788 */     GIR_RootConstrainSelectedInstOperands,
     /*  276789 */     // GIR_Coverage, 8421,
     /*  276789 */     GIR_EraseRootFromParent_Done,
     /*  276790 */   // Label 5217: @276790
     /*  276790 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(276853), // Rule ID 8424 //
     /*  276795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276851 */     GIR_RootConstrainSelectedInstOperands,
     /*  276852 */     // GIR_Coverage, 8424,
     /*  276852 */     GIR_EraseRootFromParent_Done,
     /*  276853 */   // Label 5218: @276853
     /*  276853 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(276916), // Rule ID 8425 //
     /*  276858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  276872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  276875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276897 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276914 */     GIR_RootConstrainSelectedInstOperands,
     /*  276915 */     // GIR_Coverage, 8425,
     /*  276915 */     GIR_EraseRootFromParent_Done,
     /*  276916 */   // Label 5219: @276916
     /*  276916 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(276979), // Rule ID 8428 //
     /*  276921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  276938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  276953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  276963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276977 */     GIR_RootConstrainSelectedInstOperands,
     /*  276978 */     // GIR_Coverage, 8428,
     /*  276978 */     GIR_EraseRootFromParent_Done,
     /*  276979 */   // Label 5220: @276979
     /*  276979 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(277042), // Rule ID 8429 //
     /*  276984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  276992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  276998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  277026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277040 */     GIR_RootConstrainSelectedInstOperands,
     /*  277041 */     // GIR_Coverage, 8429,
     /*  277041 */     GIR_EraseRootFromParent_Done,
     /*  277042 */   // Label 5221: @277042
     /*  277042 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(277105), // Rule ID 8432 //
     /*  277047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  277061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277103 */     GIR_RootConstrainSelectedInstOperands,
     /*  277104 */     // GIR_Coverage, 8432,
     /*  277104 */     GIR_EraseRootFromParent_Done,
     /*  277105 */   // Label 5222: @277105
     /*  277105 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(277168), // Rule ID 8433 //
     /*  277110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  277124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277149 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277166 */     GIR_RootConstrainSelectedInstOperands,
     /*  277167 */     // GIR_Coverage, 8433,
     /*  277167 */     GIR_EraseRootFromParent_Done,
     /*  277168 */   // Label 5223: @277168
     /*  277168 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(277231), // Rule ID 8436 //
     /*  277173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277229 */     GIR_RootConstrainSelectedInstOperands,
     /*  277230 */     // GIR_Coverage, 8436,
     /*  277230 */     GIR_EraseRootFromParent_Done,
     /*  277231 */   // Label 5224: @277231
     /*  277231 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(277294), // Rule ID 8437 //
     /*  277236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  277250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277292 */     GIR_RootConstrainSelectedInstOperands,
     /*  277293 */     // GIR_Coverage, 8437,
     /*  277293 */     GIR_EraseRootFromParent_Done,
     /*  277294 */   // Label 5225: @277294
     /*  277294 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(277357), // Rule ID 8440 //
     /*  277299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277355 */     GIR_RootConstrainSelectedInstOperands,
     /*  277356 */     // GIR_Coverage, 8440,
     /*  277356 */     GIR_EraseRootFromParent_Done,
     /*  277357 */   // Label 5226: @277357
     /*  277357 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(277420), // Rule ID 8441 //
     /*  277362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  277376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277401 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277418 */     GIR_RootConstrainSelectedInstOperands,
     /*  277419 */     // GIR_Coverage, 8441,
     /*  277419 */     GIR_EraseRootFromParent_Done,
     /*  277420 */   // Label 5227: @277420
     /*  277420 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(277483), // Rule ID 8444 //
     /*  277425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277481 */     GIR_RootConstrainSelectedInstOperands,
     /*  277482 */     // GIR_Coverage, 8444,
     /*  277482 */     GIR_EraseRootFromParent_Done,
     /*  277483 */   // Label 5228: @277483
     /*  277483 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(277546), // Rule ID 8445 //
     /*  277488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  277502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277527 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  277530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277544 */     GIR_RootConstrainSelectedInstOperands,
     /*  277545 */     // GIR_Coverage, 8445,
     /*  277545 */     GIR_EraseRootFromParent_Done,
     /*  277546 */   // Label 5229: @277546
     /*  277546 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(277609), // Rule ID 8448 //
     /*  277551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277590 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277607 */     GIR_RootConstrainSelectedInstOperands,
     /*  277608 */     // GIR_Coverage, 8448,
     /*  277608 */     GIR_EraseRootFromParent_Done,
     /*  277609 */   // Label 5230: @277609
     /*  277609 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(277672), // Rule ID 8449 //
     /*  277614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  277628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277653 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277670 */     GIR_RootConstrainSelectedInstOperands,
     /*  277671 */     // GIR_Coverage, 8449,
     /*  277671 */     GIR_EraseRootFromParent_Done,
     /*  277672 */   // Label 5231: @277672
     /*  277672 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(277735), // Rule ID 8452 //
     /*  277677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277716 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  277719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277733 */     GIR_RootConstrainSelectedInstOperands,
     /*  277734 */     // GIR_Coverage, 8452,
     /*  277734 */     GIR_EraseRootFromParent_Done,
     /*  277735 */   // Label 5232: @277735
     /*  277735 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(277798), // Rule ID 8453 //
     /*  277740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  277754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277779 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  277782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277796 */     GIR_RootConstrainSelectedInstOperands,
     /*  277797 */     // GIR_Coverage, 8453,
     /*  277797 */     GIR_EraseRootFromParent_Done,
     /*  277798 */   // Label 5233: @277798
     /*  277798 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(277861), // Rule ID 8456 //
     /*  277803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277842 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  277845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277859 */     GIR_RootConstrainSelectedInstOperands,
     /*  277860 */     // GIR_Coverage, 8456,
     /*  277860 */     GIR_EraseRootFromParent_Done,
     /*  277861 */   // Label 5234: @277861
     /*  277861 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(277924), // Rule ID 8457 //
     /*  277866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  277877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  277880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277905 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  277908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277922 */     GIR_RootConstrainSelectedInstOperands,
     /*  277923 */     // GIR_Coverage, 8457,
     /*  277923 */     GIR_EraseRootFromParent_Done,
     /*  277924 */   // Label 5235: @277924
     /*  277924 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(277987), // Rule ID 8460 //
     /*  277929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  277937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  277943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  277971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277985 */     GIR_RootConstrainSelectedInstOperands,
     /*  277986 */     // GIR_Coverage, 8460,
     /*  277986 */     GIR_EraseRootFromParent_Done,
     /*  277987 */   // Label 5236: @277987
     /*  277987 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(278050), // Rule ID 8461 //
     /*  277992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  278006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278031 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278048 */     GIR_RootConstrainSelectedInstOperands,
     /*  278049 */     // GIR_Coverage, 8461,
     /*  278049 */     GIR_EraseRootFromParent_Done,
     /*  278050 */   // Label 5237: @278050
     /*  278050 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(278113), // Rule ID 8464 //
     /*  278055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  278069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278094 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278111 */     GIR_RootConstrainSelectedInstOperands,
     /*  278112 */     // GIR_Coverage, 8464,
     /*  278112 */     GIR_EraseRootFromParent_Done,
     /*  278113 */   // Label 5238: @278113
     /*  278113 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(278176), // Rule ID 8465 //
     /*  278118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  278132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278157 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278174 */     GIR_RootConstrainSelectedInstOperands,
     /*  278175 */     // GIR_Coverage, 8465,
     /*  278175 */     GIR_EraseRootFromParent_Done,
     /*  278176 */   // Label 5239: @278176
     /*  278176 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(278239), // Rule ID 8468 //
     /*  278181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278220 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278237 */     GIR_RootConstrainSelectedInstOperands,
     /*  278238 */     // GIR_Coverage, 8468,
     /*  278238 */     GIR_EraseRootFromParent_Done,
     /*  278239 */   // Label 5240: @278239
     /*  278239 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(278302), // Rule ID 8469 //
     /*  278244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  278258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278283 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278300 */     GIR_RootConstrainSelectedInstOperands,
     /*  278301 */     // GIR_Coverage, 8469,
     /*  278301 */     GIR_EraseRootFromParent_Done,
     /*  278302 */   // Label 5241: @278302
     /*  278302 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(278365), // Rule ID 8472 //
     /*  278307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278363 */     GIR_RootConstrainSelectedInstOperands,
     /*  278364 */     // GIR_Coverage, 8472,
     /*  278364 */     GIR_EraseRootFromParent_Done,
     /*  278365 */   // Label 5242: @278365
     /*  278365 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(278428), // Rule ID 8473 //
     /*  278370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  278384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278409 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278426 */     GIR_RootConstrainSelectedInstOperands,
     /*  278427 */     // GIR_Coverage, 8473,
     /*  278427 */     GIR_EraseRootFromParent_Done,
     /*  278428 */   // Label 5243: @278428
     /*  278428 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(278491), // Rule ID 8476 //
     /*  278433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278489 */     GIR_RootConstrainSelectedInstOperands,
     /*  278490 */     // GIR_Coverage, 8476,
     /*  278490 */     GIR_EraseRootFromParent_Done,
     /*  278491 */   // Label 5244: @278491
     /*  278491 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(278554), // Rule ID 8477 //
     /*  278496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  278510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278535 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278552 */     GIR_RootConstrainSelectedInstOperands,
     /*  278553 */     // GIR_Coverage, 8477,
     /*  278553 */     GIR_EraseRootFromParent_Done,
     /*  278554 */   // Label 5245: @278554
     /*  278554 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(278617), // Rule ID 8480 //
     /*  278559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278598 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278615 */     GIR_RootConstrainSelectedInstOperands,
     /*  278616 */     // GIR_Coverage, 8480,
     /*  278616 */     GIR_EraseRootFromParent_Done,
     /*  278617 */   // Label 5246: @278617
     /*  278617 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(278680), // Rule ID 8481 //
     /*  278622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  278636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278661 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278678 */     GIR_RootConstrainSelectedInstOperands,
     /*  278679 */     // GIR_Coverage, 8481,
     /*  278679 */     GIR_EraseRootFromParent_Done,
     /*  278680 */   // Label 5247: @278680
     /*  278680 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(278743), // Rule ID 8484 //
     /*  278685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278741 */     GIR_RootConstrainSelectedInstOperands,
     /*  278742 */     // GIR_Coverage, 8484,
     /*  278742 */     GIR_EraseRootFromParent_Done,
     /*  278743 */   // Label 5248: @278743
     /*  278743 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(278806), // Rule ID 8485 //
     /*  278748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  278762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278787 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  278790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278804 */     GIR_RootConstrainSelectedInstOperands,
     /*  278805 */     // GIR_Coverage, 8485,
     /*  278805 */     GIR_EraseRootFromParent_Done,
     /*  278806 */   // Label 5249: @278806
     /*  278806 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(278869), // Rule ID 8488 //
     /*  278811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278867 */     GIR_RootConstrainSelectedInstOperands,
     /*  278868 */     // GIR_Coverage, 8488,
     /*  278868 */     GIR_EraseRootFromParent_Done,
     /*  278869 */   // Label 5250: @278869
     /*  278869 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(278932), // Rule ID 8489 //
     /*  278874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  278888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278913 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  278916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278930 */     GIR_RootConstrainSelectedInstOperands,
     /*  278931 */     // GIR_Coverage, 8489,
     /*  278931 */     GIR_EraseRootFromParent_Done,
     /*  278932 */   // Label 5251: @278932
     /*  278932 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(278995), // Rule ID 8492 //
     /*  278937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  278945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  278951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  278965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  278979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278993 */     GIR_RootConstrainSelectedInstOperands,
     /*  278994 */     // GIR_Coverage, 8492,
     /*  278994 */     GIR_EraseRootFromParent_Done,
     /*  278995 */   // Label 5252: @278995
     /*  278995 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(279058), // Rule ID 8493 //
     /*  279000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  279008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  279014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279039 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  279042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279056 */     GIR_RootConstrainSelectedInstOperands,
     /*  279057 */     // GIR_Coverage, 8493,
     /*  279057 */     GIR_EraseRootFromParent_Done,
     /*  279058 */   // Label 5253: @279058
     /*  279058 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(279121), // Rule ID 8496 //
     /*  279063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  279105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279119 */     GIR_RootConstrainSelectedInstOperands,
     /*  279120 */     // GIR_Coverage, 8496,
     /*  279120 */     GIR_EraseRootFromParent_Done,
     /*  279121 */   // Label 5254: @279121
     /*  279121 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(279184), // Rule ID 8497 //
     /*  279126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  279140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  279143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  279168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279182 */     GIR_RootConstrainSelectedInstOperands,
     /*  279183 */     // GIR_Coverage, 8497,
     /*  279183 */     GIR_EraseRootFromParent_Done,
     /*  279184 */   // Label 5255: @279184
     /*  279184 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(279247), // Rule ID 8500 //
     /*  279189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279245 */     GIR_RootConstrainSelectedInstOperands,
     /*  279246 */     // GIR_Coverage, 8500,
     /*  279246 */     GIR_EraseRootFromParent_Done,
     /*  279247 */   // Label 5256: @279247
     /*  279247 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(279310), // Rule ID 8501 //
     /*  279252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  279266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  279269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279291 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279308 */     GIR_RootConstrainSelectedInstOperands,
     /*  279309 */     // GIR_Coverage, 8501,
     /*  279309 */     GIR_EraseRootFromParent_Done,
     /*  279310 */   // Label 5257: @279310
     /*  279310 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(279373), // Rule ID 8504 //
     /*  279315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279371 */     GIR_RootConstrainSelectedInstOperands,
     /*  279372 */     // GIR_Coverage, 8504,
     /*  279372 */     GIR_EraseRootFromParent_Done,
     /*  279373 */   // Label 5258: @279373
     /*  279373 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(279436), // Rule ID 8505 //
     /*  279378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  279392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  279395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279434 */     GIR_RootConstrainSelectedInstOperands,
     /*  279435 */     // GIR_Coverage, 8505,
     /*  279435 */     GIR_EraseRootFromParent_Done,
     /*  279436 */   // Label 5259: @279436
     /*  279436 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(279499), // Rule ID 8508 //
     /*  279441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279497 */     GIR_RootConstrainSelectedInstOperands,
     /*  279498 */     // GIR_Coverage, 8508,
     /*  279498 */     GIR_EraseRootFromParent_Done,
     /*  279499 */   // Label 5260: @279499
     /*  279499 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(279562), // Rule ID 8509 //
     /*  279504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  279518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  279521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  279546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279560 */     GIR_RootConstrainSelectedInstOperands,
     /*  279561 */     // GIR_Coverage, 8509,
     /*  279561 */     GIR_EraseRootFromParent_Done,
     /*  279562 */   // Label 5261: @279562
     /*  279562 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(279625), // Rule ID 8512 //
     /*  279567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279623 */     GIR_RootConstrainSelectedInstOperands,
     /*  279624 */     // GIR_Coverage, 8512,
     /*  279624 */     GIR_EraseRootFromParent_Done,
     /*  279625 */   // Label 5262: @279625
     /*  279625 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(279688), // Rule ID 8513 //
     /*  279630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  279644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  279647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279669 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279686 */     GIR_RootConstrainSelectedInstOperands,
     /*  279687 */     // GIR_Coverage, 8513,
     /*  279687 */     GIR_EraseRootFromParent_Done,
     /*  279688 */   // Label 5263: @279688
     /*  279688 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(279751), // Rule ID 8516 //
     /*  279693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279732 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279749 */     GIR_RootConstrainSelectedInstOperands,
     /*  279750 */     // GIR_Coverage, 8516,
     /*  279750 */     GIR_EraseRootFromParent_Done,
     /*  279751 */   // Label 5264: @279751
     /*  279751 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(279814), // Rule ID 8517 //
     /*  279756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  279770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  279773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279795 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  279798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279812 */     GIR_RootConstrainSelectedInstOperands,
     /*  279813 */     // GIR_Coverage, 8517,
     /*  279813 */     GIR_EraseRootFromParent_Done,
     /*  279814 */   // Label 5265: @279814
     /*  279814 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(279877), // Rule ID 8520 //
     /*  279819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279858 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279875 */     GIR_RootConstrainSelectedInstOperands,
     /*  279876 */     // GIR_Coverage, 8520,
     /*  279876 */     GIR_EraseRootFromParent_Done,
     /*  279877 */   // Label 5266: @279877
     /*  279877 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(279940), // Rule ID 8521 //
     /*  279882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  279896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  279899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279921 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279938 */     GIR_RootConstrainSelectedInstOperands,
     /*  279939 */     // GIR_Coverage, 8521,
     /*  279939 */     GIR_EraseRootFromParent_Done,
     /*  279940 */   // Label 5267: @279940
     /*  279940 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(280003), // Rule ID 8524 //
     /*  279945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  279959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  279962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  279987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280001 */     GIR_RootConstrainSelectedInstOperands,
     /*  280002 */     // GIR_Coverage, 8524,
     /*  280002 */     GIR_EraseRootFromParent_Done,
     /*  280003 */   // Label 5268: @280003
     /*  280003 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(280066), // Rule ID 8525 //
     /*  280008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  280022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  280025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280064 */     GIR_RootConstrainSelectedInstOperands,
     /*  280065 */     // GIR_Coverage, 8525,
     /*  280065 */     GIR_EraseRootFromParent_Done,
     /*  280066 */   // Label 5269: @280066
     /*  280066 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(280129), // Rule ID 8528 //
     /*  280071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280110 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280127 */     GIR_RootConstrainSelectedInstOperands,
     /*  280128 */     // GIR_Coverage, 8528,
     /*  280128 */     GIR_EraseRootFromParent_Done,
     /*  280129 */   // Label 5270: @280129
     /*  280129 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(280192), // Rule ID 8529 //
     /*  280134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  280148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  280151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280173 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280190 */     GIR_RootConstrainSelectedInstOperands,
     /*  280191 */     // GIR_Coverage, 8529,
     /*  280191 */     GIR_EraseRootFromParent_Done,
     /*  280192 */   // Label 5271: @280192
     /*  280192 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(280255), // Rule ID 8532 //
     /*  280197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280236 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280253 */     GIR_RootConstrainSelectedInstOperands,
     /*  280254 */     // GIR_Coverage, 8532,
     /*  280254 */     GIR_EraseRootFromParent_Done,
     /*  280255 */   // Label 5272: @280255
     /*  280255 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(280318), // Rule ID 8533 //
     /*  280260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  280274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  280277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280299 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  280302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280316 */     GIR_RootConstrainSelectedInstOperands,
     /*  280317 */     // GIR_Coverage, 8533,
     /*  280317 */     GIR_EraseRootFromParent_Done,
     /*  280318 */   // Label 5273: @280318
     /*  280318 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(280381), // Rule ID 8536 //
     /*  280323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280379 */     GIR_RootConstrainSelectedInstOperands,
     /*  280380 */     // GIR_Coverage, 8536,
     /*  280380 */     GIR_EraseRootFromParent_Done,
     /*  280381 */   // Label 5274: @280381
     /*  280381 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(280444), // Rule ID 8537 //
     /*  280386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  280400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  280403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280425 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280442 */     GIR_RootConstrainSelectedInstOperands,
     /*  280443 */     // GIR_Coverage, 8537,
     /*  280443 */     GIR_EraseRootFromParent_Done,
     /*  280444 */   // Label 5275: @280444
     /*  280444 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(280507), // Rule ID 8540 //
     /*  280449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280505 */     GIR_RootConstrainSelectedInstOperands,
     /*  280506 */     // GIR_Coverage, 8540,
     /*  280506 */     GIR_EraseRootFromParent_Done,
     /*  280507 */   // Label 5276: @280507
     /*  280507 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(280570), // Rule ID 8541 //
     /*  280512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  280526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  280529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280551 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280568 */     GIR_RootConstrainSelectedInstOperands,
     /*  280569 */     // GIR_Coverage, 8541,
     /*  280569 */     GIR_EraseRootFromParent_Done,
     /*  280570 */   // Label 5277: @280570
     /*  280570 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(280633), // Rule ID 8544 //
     /*  280575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280614 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280631 */     GIR_RootConstrainSelectedInstOperands,
     /*  280632 */     // GIR_Coverage, 8544,
     /*  280632 */     GIR_EraseRootFromParent_Done,
     /*  280633 */   // Label 5278: @280633
     /*  280633 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(280696), // Rule ID 8545 //
     /*  280638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  280649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  280652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  280655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280677 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280694 */     GIR_RootConstrainSelectedInstOperands,
     /*  280695 */     // GIR_Coverage, 8545,
     /*  280695 */     GIR_EraseRootFromParent_Done,
     /*  280696 */   // Label 5279: @280696
     /*  280696 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(280759), // Rule ID 8548 //
     /*  280701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280757 */     GIR_RootConstrainSelectedInstOperands,
     /*  280758 */     // GIR_Coverage, 8548,
     /*  280758 */     GIR_EraseRootFromParent_Done,
     /*  280759 */   // Label 5280: @280759
     /*  280759 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(280822), // Rule ID 8549 //
     /*  280764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  280778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  280781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280803 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  280806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280820 */     GIR_RootConstrainSelectedInstOperands,
     /*  280821 */     // GIR_Coverage, 8549,
     /*  280821 */     GIR_EraseRootFromParent_Done,
     /*  280822 */   // Label 5281: @280822
     /*  280822 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(280885), // Rule ID 8552 //
     /*  280827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280883 */     GIR_RootConstrainSelectedInstOperands,
     /*  280884 */     // GIR_Coverage, 8552,
     /*  280884 */     GIR_EraseRootFromParent_Done,
     /*  280885 */   // Label 5282: @280885
     /*  280885 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(280948), // Rule ID 8553 //
     /*  280890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  280904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  280907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280929 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  280932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280946 */     GIR_RootConstrainSelectedInstOperands,
     /*  280947 */     // GIR_Coverage, 8553,
     /*  280947 */     GIR_EraseRootFromParent_Done,
     /*  280948 */   // Label 5283: @280948
     /*  280948 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(281011), // Rule ID 8556 //
     /*  280953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  280964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  280967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  280970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280992 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  280995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281009 */     GIR_RootConstrainSelectedInstOperands,
     /*  281010 */     // GIR_Coverage, 8556,
     /*  281010 */     GIR_EraseRootFromParent_Done,
     /*  281011 */   // Label 5284: @281011
     /*  281011 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(281074), // Rule ID 8557 //
     /*  281016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  281027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  281030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  281033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281055 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281072 */     GIR_RootConstrainSelectedInstOperands,
     /*  281073 */     // GIR_Coverage, 8557,
     /*  281073 */     GIR_EraseRootFromParent_Done,
     /*  281074 */   // Label 5285: @281074
     /*  281074 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(281137), // Rule ID 8560 //
     /*  281079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281135 */     GIR_RootConstrainSelectedInstOperands,
     /*  281136 */     // GIR_Coverage, 8560,
     /*  281136 */     GIR_EraseRootFromParent_Done,
     /*  281137 */   // Label 5286: @281137
     /*  281137 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(281200), // Rule ID 8561 //
     /*  281142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  281156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  281159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281181 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281198 */     GIR_RootConstrainSelectedInstOperands,
     /*  281199 */     // GIR_Coverage, 8561,
     /*  281199 */     GIR_EraseRootFromParent_Done,
     /*  281200 */   // Label 5287: @281200
     /*  281200 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(281263), // Rule ID 8564 //
     /*  281205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281261 */     GIR_RootConstrainSelectedInstOperands,
     /*  281262 */     // GIR_Coverage, 8564,
     /*  281262 */     GIR_EraseRootFromParent_Done,
     /*  281263 */   // Label 5288: @281263
     /*  281263 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(281326), // Rule ID 8565 //
     /*  281268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  281282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  281285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281324 */     GIR_RootConstrainSelectedInstOperands,
     /*  281325 */     // GIR_Coverage, 8565,
     /*  281325 */     GIR_EraseRootFromParent_Done,
     /*  281326 */   // Label 5289: @281326
     /*  281326 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(281389), // Rule ID 8568 //
     /*  281331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281387 */     GIR_RootConstrainSelectedInstOperands,
     /*  281388 */     // GIR_Coverage, 8568,
     /*  281388 */     GIR_EraseRootFromParent_Done,
     /*  281389 */   // Label 5290: @281389
     /*  281389 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(281452), // Rule ID 8569 //
     /*  281394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  281408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  281411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281433 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281450 */     GIR_RootConstrainSelectedInstOperands,
     /*  281451 */     // GIR_Coverage, 8569,
     /*  281451 */     GIR_EraseRootFromParent_Done,
     /*  281452 */   // Label 5291: @281452
     /*  281452 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(281515), // Rule ID 8572 //
     /*  281457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281513 */     GIR_RootConstrainSelectedInstOperands,
     /*  281514 */     // GIR_Coverage, 8572,
     /*  281514 */     GIR_EraseRootFromParent_Done,
     /*  281515 */   // Label 5292: @281515
     /*  281515 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(281578), // Rule ID 8573 //
     /*  281520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  281534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  281537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281559 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  281562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281576 */     GIR_RootConstrainSelectedInstOperands,
     /*  281577 */     // GIR_Coverage, 8573,
     /*  281577 */     GIR_EraseRootFromParent_Done,
     /*  281578 */   // Label 5293: @281578
     /*  281578 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(281641), // Rule ID 8576 //
     /*  281583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281639 */     GIR_RootConstrainSelectedInstOperands,
     /*  281640 */     // GIR_Coverage, 8576,
     /*  281640 */     GIR_EraseRootFromParent_Done,
     /*  281641 */   // Label 5294: @281641
     /*  281641 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(281704), // Rule ID 8577 //
     /*  281646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  281660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  281663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281685 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  281688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281702 */     GIR_RootConstrainSelectedInstOperands,
     /*  281703 */     // GIR_Coverage, 8577,
     /*  281703 */     GIR_EraseRootFromParent_Done,
     /*  281704 */   // Label 5295: @281704
     /*  281704 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(281767), // Rule ID 8580 //
     /*  281709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281748 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281765 */     GIR_RootConstrainSelectedInstOperands,
     /*  281766 */     // GIR_Coverage, 8580,
     /*  281766 */     GIR_EraseRootFromParent_Done,
     /*  281767 */   // Label 5296: @281767
     /*  281767 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(281830), // Rule ID 8581 //
     /*  281772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  281786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  281789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281811 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  281814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281828 */     GIR_RootConstrainSelectedInstOperands,
     /*  281829 */     // GIR_Coverage, 8581,
     /*  281829 */     GIR_EraseRootFromParent_Done,
     /*  281830 */   // Label 5297: @281830
     /*  281830 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(281893), // Rule ID 8584 //
     /*  281835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  281877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281891 */     GIR_RootConstrainSelectedInstOperands,
     /*  281892 */     // GIR_Coverage, 8584,
     /*  281892 */     GIR_EraseRootFromParent_Done,
     /*  281893 */   // Label 5298: @281893
     /*  281893 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(281956), // Rule ID 8585 //
     /*  281898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  281912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  281915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281937 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  281940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281954 */     GIR_RootConstrainSelectedInstOperands,
     /*  281955 */     // GIR_Coverage, 8585,
     /*  281955 */     GIR_EraseRootFromParent_Done,
     /*  281956 */   // Label 5299: @281956
     /*  281956 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(282019), // Rule ID 8588 //
     /*  281961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  281969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  281975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  281978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  281993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282017 */     GIR_RootConstrainSelectedInstOperands,
     /*  282018 */     // GIR_Coverage, 8588,
     /*  282018 */     GIR_EraseRootFromParent_Done,
     /*  282019 */   // Label 5300: @282019
     /*  282019 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(282082), // Rule ID 8589 //
     /*  282024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  282038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282063 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282080 */     GIR_RootConstrainSelectedInstOperands,
     /*  282081 */     // GIR_Coverage, 8589,
     /*  282081 */     GIR_EraseRootFromParent_Done,
     /*  282082 */   // Label 5301: @282082
     /*  282082 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(282145), // Rule ID 8592 //
     /*  282087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282143 */     GIR_RootConstrainSelectedInstOperands,
     /*  282144 */     // GIR_Coverage, 8592,
     /*  282144 */     GIR_EraseRootFromParent_Done,
     /*  282145 */   // Label 5302: @282145
     /*  282145 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(282208), // Rule ID 8593 //
     /*  282150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  282164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282189 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282206 */     GIR_RootConstrainSelectedInstOperands,
     /*  282207 */     // GIR_Coverage, 8593,
     /*  282207 */     GIR_EraseRootFromParent_Done,
     /*  282208 */   // Label 5303: @282208
     /*  282208 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(282271), // Rule ID 8596 //
     /*  282213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282269 */     GIR_RootConstrainSelectedInstOperands,
     /*  282270 */     // GIR_Coverage, 8596,
     /*  282270 */     GIR_EraseRootFromParent_Done,
     /*  282271 */   // Label 5304: @282271
     /*  282271 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(282334), // Rule ID 8597 //
     /*  282276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  282290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  282318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282332 */     GIR_RootConstrainSelectedInstOperands,
     /*  282333 */     // GIR_Coverage, 8597,
     /*  282333 */     GIR_EraseRootFromParent_Done,
     /*  282334 */   // Label 5305: @282334
     /*  282334 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(282397), // Rule ID 8600 //
     /*  282339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282395 */     GIR_RootConstrainSelectedInstOperands,
     /*  282396 */     // GIR_Coverage, 8600,
     /*  282396 */     GIR_EraseRootFromParent_Done,
     /*  282397 */   // Label 5306: @282397
     /*  282397 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(282460), // Rule ID 8601 //
     /*  282402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  282416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282441 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282458 */     GIR_RootConstrainSelectedInstOperands,
     /*  282459 */     // GIR_Coverage, 8601,
     /*  282459 */     GIR_EraseRootFromParent_Done,
     /*  282460 */   // Label 5307: @282460
     /*  282460 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(282523), // Rule ID 8604 //
     /*  282465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282521 */     GIR_RootConstrainSelectedInstOperands,
     /*  282522 */     // GIR_Coverage, 8604,
     /*  282522 */     GIR_EraseRootFromParent_Done,
     /*  282523 */   // Label 5308: @282523
     /*  282523 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(282586), // Rule ID 8605 //
     /*  282528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  282542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282567 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  282570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282584 */     GIR_RootConstrainSelectedInstOperands,
     /*  282585 */     // GIR_Coverage, 8605,
     /*  282585 */     GIR_EraseRootFromParent_Done,
     /*  282586 */   // Label 5309: @282586
     /*  282586 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(282649), // Rule ID 8608 //
     /*  282591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282647 */     GIR_RootConstrainSelectedInstOperands,
     /*  282648 */     // GIR_Coverage, 8608,
     /*  282648 */     GIR_EraseRootFromParent_Done,
     /*  282649 */   // Label 5310: @282649
     /*  282649 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(282712), // Rule ID 8609 //
     /*  282654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  282668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282693 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282710 */     GIR_RootConstrainSelectedInstOperands,
     /*  282711 */     // GIR_Coverage, 8609,
     /*  282711 */     GIR_EraseRootFromParent_Done,
     /*  282712 */   // Label 5311: @282712
     /*  282712 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(282775), // Rule ID 8612 //
     /*  282717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282773 */     GIR_RootConstrainSelectedInstOperands,
     /*  282774 */     // GIR_Coverage, 8612,
     /*  282774 */     GIR_EraseRootFromParent_Done,
     /*  282775 */   // Label 5312: @282775
     /*  282775 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(282838), // Rule ID 8613 //
     /*  282780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  282794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282836 */     GIR_RootConstrainSelectedInstOperands,
     /*  282837 */     // GIR_Coverage, 8613,
     /*  282837 */     GIR_EraseRootFromParent_Done,
     /*  282838 */   // Label 5313: @282838
     /*  282838 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(282901), // Rule ID 8616 //
     /*  282843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282899 */     GIR_RootConstrainSelectedInstOperands,
     /*  282900 */     // GIR_Coverage, 8616,
     /*  282900 */     GIR_EraseRootFromParent_Done,
     /*  282901 */   // Label 5314: @282901
     /*  282901 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(282964), // Rule ID 8617 //
     /*  282906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  282920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  282923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  282938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  282948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282962 */     GIR_RootConstrainSelectedInstOperands,
     /*  282963 */     // GIR_Coverage, 8617,
     /*  282963 */     GIR_EraseRootFromParent_Done,
     /*  282964 */   // Label 5315: @282964
     /*  282964 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(283027), // Rule ID 8620 //
     /*  282969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  282977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  282980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  282983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  282986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  283011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283025 */     GIR_RootConstrainSelectedInstOperands,
     /*  283026 */     // GIR_Coverage, 8620,
     /*  283026 */     GIR_EraseRootFromParent_Done,
     /*  283027 */   // Label 5316: @283027
     /*  283027 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(283090), // Rule ID 8621 //
     /*  283032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  283046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283071 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  283074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283088 */     GIR_RootConstrainSelectedInstOperands,
     /*  283089 */     // GIR_Coverage, 8621,
     /*  283089 */     GIR_EraseRootFromParent_Done,
     /*  283090 */   // Label 5317: @283090
     /*  283090 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(283153), // Rule ID 8624 //
     /*  283095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283134 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283151 */     GIR_RootConstrainSelectedInstOperands,
     /*  283152 */     // GIR_Coverage, 8624,
     /*  283152 */     GIR_EraseRootFromParent_Done,
     /*  283153 */   // Label 5318: @283153
     /*  283153 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(283216), // Rule ID 8625 //
     /*  283158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  283172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283197 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283214 */     GIR_RootConstrainSelectedInstOperands,
     /*  283215 */     // GIR_Coverage, 8625,
     /*  283215 */     GIR_EraseRootFromParent_Done,
     /*  283216 */   // Label 5319: @283216
     /*  283216 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(283279), // Rule ID 8628 //
     /*  283221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283277 */     GIR_RootConstrainSelectedInstOperands,
     /*  283278 */     // GIR_Coverage, 8628,
     /*  283278 */     GIR_EraseRootFromParent_Done,
     /*  283279 */   // Label 5320: @283279
     /*  283279 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(283342), // Rule ID 8629 //
     /*  283284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  283298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283323 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283340 */     GIR_RootConstrainSelectedInstOperands,
     /*  283341 */     // GIR_Coverage, 8629,
     /*  283341 */     GIR_EraseRootFromParent_Done,
     /*  283342 */   // Label 5321: @283342
     /*  283342 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(283405), // Rule ID 8632 //
     /*  283347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  283358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283386 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283403 */     GIR_RootConstrainSelectedInstOperands,
     /*  283404 */     // GIR_Coverage, 8632,
     /*  283404 */     GIR_EraseRootFromParent_Done,
     /*  283405 */   // Label 5322: @283405
     /*  283405 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(283468), // Rule ID 8633 //
     /*  283410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  283421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  283424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283449 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283466 */     GIR_RootConstrainSelectedInstOperands,
     /*  283467 */     // GIR_Coverage, 8633,
     /*  283467 */     GIR_EraseRootFromParent_Done,
     /*  283468 */   // Label 5323: @283468
     /*  283468 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(283531), // Rule ID 8636 //
     /*  283473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283529 */     GIR_RootConstrainSelectedInstOperands,
     /*  283530 */     // GIR_Coverage, 8636,
     /*  283530 */     GIR_EraseRootFromParent_Done,
     /*  283531 */   // Label 5324: @283531
     /*  283531 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(283594), // Rule ID 8637 //
     /*  283536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  283550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283592 */     GIR_RootConstrainSelectedInstOperands,
     /*  283593 */     // GIR_Coverage, 8637,
     /*  283593 */     GIR_EraseRootFromParent_Done,
     /*  283594 */   // Label 5325: @283594
     /*  283594 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(283657), // Rule ID 8640 //
     /*  283599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283655 */     GIR_RootConstrainSelectedInstOperands,
     /*  283656 */     // GIR_Coverage, 8640,
     /*  283656 */     GIR_EraseRootFromParent_Done,
     /*  283657 */   // Label 5326: @283657
     /*  283657 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(283720), // Rule ID 8641 //
     /*  283662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  283676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283701 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  283704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283718 */     GIR_RootConstrainSelectedInstOperands,
     /*  283719 */     // GIR_Coverage, 8641,
     /*  283719 */     GIR_EraseRootFromParent_Done,
     /*  283720 */   // Label 5327: @283720
     /*  283720 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(283783), // Rule ID 8644 //
     /*  283725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283764 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283781 */     GIR_RootConstrainSelectedInstOperands,
     /*  283782 */     // GIR_Coverage, 8644,
     /*  283782 */     GIR_EraseRootFromParent_Done,
     /*  283783 */   // Label 5328: @283783
     /*  283783 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(283846), // Rule ID 8645 //
     /*  283788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  283799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  283802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283827 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  283830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283844 */     GIR_RootConstrainSelectedInstOperands,
     /*  283845 */     // GIR_Coverage, 8645,
     /*  283845 */     GIR_EraseRootFromParent_Done,
     /*  283846 */   // Label 5329: @283846
     /*  283846 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(283909), // Rule ID 8648 //
     /*  283851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283907 */     GIR_RootConstrainSelectedInstOperands,
     /*  283908 */     // GIR_Coverage, 8648,
     /*  283908 */     GIR_EraseRootFromParent_Done,
     /*  283909 */   // Label 5330: @283909
     /*  283909 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(283972), // Rule ID 8649 //
     /*  283914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  283928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283953 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  283956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283970 */     GIR_RootConstrainSelectedInstOperands,
     /*  283971 */     // GIR_Coverage, 8649,
     /*  283971 */     GIR_EraseRootFromParent_Done,
     /*  283972 */   // Label 5331: @283972
     /*  283972 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(284035), // Rule ID 8652 //
     /*  283977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  283985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  283991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284016 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284033 */     GIR_RootConstrainSelectedInstOperands,
     /*  284034 */     // GIR_Coverage, 8652,
     /*  284034 */     GIR_EraseRootFromParent_Done,
     /*  284035 */   // Label 5332: @284035
     /*  284035 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(284098), // Rule ID 8653 //
     /*  284040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  284054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284079 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284096 */     GIR_RootConstrainSelectedInstOperands,
     /*  284097 */     // GIR_Coverage, 8653,
     /*  284097 */     GIR_EraseRootFromParent_Done,
     /*  284098 */   // Label 5333: @284098
     /*  284098 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(284161), // Rule ID 8656 //
     /*  284103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284159 */     GIR_RootConstrainSelectedInstOperands,
     /*  284160 */     // GIR_Coverage, 8656,
     /*  284160 */     GIR_EraseRootFromParent_Done,
     /*  284161 */   // Label 5334: @284161
     /*  284161 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(284224), // Rule ID 8657 //
     /*  284166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  284180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284205 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284222 */     GIR_RootConstrainSelectedInstOperands,
     /*  284223 */     // GIR_Coverage, 8657,
     /*  284223 */     GIR_EraseRootFromParent_Done,
     /*  284224 */   // Label 5335: @284224
     /*  284224 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(284287), // Rule ID 8660 //
     /*  284229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  284271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284285 */     GIR_RootConstrainSelectedInstOperands,
     /*  284286 */     // GIR_Coverage, 8660,
     /*  284286 */     GIR_EraseRootFromParent_Done,
     /*  284287 */   // Label 5336: @284287
     /*  284287 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(284350), // Rule ID 8661 //
     /*  284292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  284306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284331 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  284334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284348 */     GIR_RootConstrainSelectedInstOperands,
     /*  284349 */     // GIR_Coverage, 8661,
     /*  284349 */     GIR_EraseRootFromParent_Done,
     /*  284350 */   // Label 5337: @284350
     /*  284350 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(284413), // Rule ID 8664 //
     /*  284355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284411 */     GIR_RootConstrainSelectedInstOperands,
     /*  284412 */     // GIR_Coverage, 8664,
     /*  284412 */     GIR_EraseRootFromParent_Done,
     /*  284413 */   // Label 5338: @284413
     /*  284413 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(284476), // Rule ID 8665 //
     /*  284418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  284432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284457 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  284460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284474 */     GIR_RootConstrainSelectedInstOperands,
     /*  284475 */     // GIR_Coverage, 8665,
     /*  284475 */     GIR_EraseRootFromParent_Done,
     /*  284476 */   // Label 5339: @284476
     /*  284476 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(284539), // Rule ID 8668 //
     /*  284481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284537 */     GIR_RootConstrainSelectedInstOperands,
     /*  284538 */     // GIR_Coverage, 8668,
     /*  284538 */     GIR_EraseRootFromParent_Done,
     /*  284539 */   // Label 5340: @284539
     /*  284539 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(284602), // Rule ID 8669 //
     /*  284544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  284552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  284558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284583 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  284586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284600 */     GIR_RootConstrainSelectedInstOperands,
     /*  284601 */     // GIR_Coverage, 8669,
     /*  284601 */     GIR_EraseRootFromParent_Done,
     /*  284602 */   // Label 5341: @284602
     /*  284602 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(284665), // Rule ID 8672 //
     /*  284607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  284649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284663 */     GIR_RootConstrainSelectedInstOperands,
     /*  284664 */     // GIR_Coverage, 8672,
     /*  284664 */     GIR_EraseRootFromParent_Done,
     /*  284665 */   // Label 5342: @284665
     /*  284665 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(284728), // Rule ID 8673 //
     /*  284670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  284684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  284687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284709 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  284712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284726 */     GIR_RootConstrainSelectedInstOperands,
     /*  284727 */     // GIR_Coverage, 8673,
     /*  284727 */     GIR_EraseRootFromParent_Done,
     /*  284728 */   // Label 5343: @284728
     /*  284728 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(284791), // Rule ID 8676 //
     /*  284733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  284750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  284775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284789 */     GIR_RootConstrainSelectedInstOperands,
     /*  284790 */     // GIR_Coverage, 8676,
     /*  284790 */     GIR_EraseRootFromParent_Done,
     /*  284791 */   // Label 5344: @284791
     /*  284791 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(284854), // Rule ID 8677 //
     /*  284796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  284810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  284813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284835 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  284838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284852 */     GIR_RootConstrainSelectedInstOperands,
     /*  284853 */     // GIR_Coverage, 8677,
     /*  284853 */     GIR_EraseRootFromParent_Done,
     /*  284854 */   // Label 5345: @284854
     /*  284854 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(284917), // Rule ID 8680 //
     /*  284859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  284876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  284901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284915 */     GIR_RootConstrainSelectedInstOperands,
     /*  284916 */     // GIR_Coverage, 8680,
     /*  284916 */     GIR_EraseRootFromParent_Done,
     /*  284917 */   // Label 5346: @284917
     /*  284917 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(284980), // Rule ID 8681 //
     /*  284922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  284936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  284939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284961 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  284964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284978 */     GIR_RootConstrainSelectedInstOperands,
     /*  284979 */     // GIR_Coverage, 8681,
     /*  284979 */     GIR_EraseRootFromParent_Done,
     /*  284980 */   // Label 5347: @284980
     /*  284980 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(285043), // Rule ID 8684 //
     /*  284985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  284999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  285027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285041 */     GIR_RootConstrainSelectedInstOperands,
     /*  285042 */     // GIR_Coverage, 8684,
     /*  285042 */     GIR_EraseRootFromParent_Done,
     /*  285043 */   // Label 5348: @285043
     /*  285043 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(285106), // Rule ID 8685 //
     /*  285048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  285062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  285065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  285090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285104 */     GIR_RootConstrainSelectedInstOperands,
     /*  285105 */     // GIR_Coverage, 8685,
     /*  285105 */     GIR_EraseRootFromParent_Done,
     /*  285106 */   // Label 5349: @285106
     /*  285106 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(285169), // Rule ID 8688 //
     /*  285111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285167 */     GIR_RootConstrainSelectedInstOperands,
     /*  285168 */     // GIR_Coverage, 8688,
     /*  285168 */     GIR_EraseRootFromParent_Done,
     /*  285169 */   // Label 5350: @285169
     /*  285169 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(285232), // Rule ID 8689 //
     /*  285174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  285188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  285191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285213 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285230 */     GIR_RootConstrainSelectedInstOperands,
     /*  285231 */     // GIR_Coverage, 8689,
     /*  285231 */     GIR_EraseRootFromParent_Done,
     /*  285232 */   // Label 5351: @285232
     /*  285232 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(285295), // Rule ID 8692 //
     /*  285237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285293 */     GIR_RootConstrainSelectedInstOperands,
     /*  285294 */     // GIR_Coverage, 8692,
     /*  285294 */     GIR_EraseRootFromParent_Done,
     /*  285295 */   // Label 5352: @285295
     /*  285295 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(285358), // Rule ID 8693 //
     /*  285300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  285314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  285317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285339 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  285342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285356 */     GIR_RootConstrainSelectedInstOperands,
     /*  285357 */     // GIR_Coverage, 8693,
     /*  285357 */     GIR_EraseRootFromParent_Done,
     /*  285358 */   // Label 5353: @285358
     /*  285358 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(285421), // Rule ID 8696 //
     /*  285363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285402 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285419 */     GIR_RootConstrainSelectedInstOperands,
     /*  285420 */     // GIR_Coverage, 8696,
     /*  285420 */     GIR_EraseRootFromParent_Done,
     /*  285421 */   // Label 5354: @285421
     /*  285421 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(285484), // Rule ID 8697 //
     /*  285426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  285440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  285443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285465 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285482 */     GIR_RootConstrainSelectedInstOperands,
     /*  285483 */     // GIR_Coverage, 8697,
     /*  285483 */     GIR_EraseRootFromParent_Done,
     /*  285484 */   // Label 5355: @285484
     /*  285484 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(285547), // Rule ID 8700 //
     /*  285489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285545 */     GIR_RootConstrainSelectedInstOperands,
     /*  285546 */     // GIR_Coverage, 8700,
     /*  285546 */     GIR_EraseRootFromParent_Done,
     /*  285547 */   // Label 5356: @285547
     /*  285547 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(285610), // Rule ID 8701 //
     /*  285552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  285566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  285569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285608 */     GIR_RootConstrainSelectedInstOperands,
     /*  285609 */     // GIR_Coverage, 8701,
     /*  285609 */     GIR_EraseRootFromParent_Done,
     /*  285610 */   // Label 5357: @285610
     /*  285610 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(285673), // Rule ID 8704 //
     /*  285615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285654 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285671 */     GIR_RootConstrainSelectedInstOperands,
     /*  285672 */     // GIR_Coverage, 8704,
     /*  285672 */     GIR_EraseRootFromParent_Done,
     /*  285673 */   // Label 5358: @285673
     /*  285673 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(285736), // Rule ID 8705 //
     /*  285678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  285692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  285695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285717 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285734 */     GIR_RootConstrainSelectedInstOperands,
     /*  285735 */     // GIR_Coverage, 8705,
     /*  285735 */     GIR_EraseRootFromParent_Done,
     /*  285736 */   // Label 5359: @285736
     /*  285736 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(285799), // Rule ID 8708 //
     /*  285741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  285758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285797 */     GIR_RootConstrainSelectedInstOperands,
     /*  285798 */     // GIR_Coverage, 8708,
     /*  285798 */     GIR_EraseRootFromParent_Done,
     /*  285799 */   // Label 5360: @285799
     /*  285799 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(285862), // Rule ID 8709 //
     /*  285804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  285818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  285821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285843 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  285846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285860 */     GIR_RootConstrainSelectedInstOperands,
     /*  285861 */     // GIR_Coverage, 8709,
     /*  285861 */     GIR_EraseRootFromParent_Done,
     /*  285862 */   // Label 5361: @285862
     /*  285862 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(285925), // Rule ID 8712 //
     /*  285867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  285884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  285909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285923 */     GIR_RootConstrainSelectedInstOperands,
     /*  285924 */     // GIR_Coverage, 8712,
     /*  285924 */     GIR_EraseRootFromParent_Done,
     /*  285925 */   // Label 5362: @285925
     /*  285925 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(285988), // Rule ID 8713 //
     /*  285930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  285944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  285947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  285972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285986 */     GIR_RootConstrainSelectedInstOperands,
     /*  285987 */     // GIR_Coverage, 8713,
     /*  285987 */     GIR_EraseRootFromParent_Done,
     /*  285988 */   // Label 5363: @285988
     /*  285988 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(286051), // Rule ID 8716 //
     /*  285993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286049 */     GIR_RootConstrainSelectedInstOperands,
     /*  286050 */     // GIR_Coverage, 8716,
     /*  286050 */     GIR_EraseRootFromParent_Done,
     /*  286051 */   // Label 5364: @286051
     /*  286051 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(286114), // Rule ID 8717 //
     /*  286056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  286070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  286073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286095 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286112 */     GIR_RootConstrainSelectedInstOperands,
     /*  286113 */     // GIR_Coverage, 8717,
     /*  286113 */     GIR_EraseRootFromParent_Done,
     /*  286114 */   // Label 5365: @286114
     /*  286114 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(286177), // Rule ID 8720 //
     /*  286119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  286130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286158 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286175 */     GIR_RootConstrainSelectedInstOperands,
     /*  286176 */     // GIR_Coverage, 8720,
     /*  286176 */     GIR_EraseRootFromParent_Done,
     /*  286177 */   // Label 5366: @286177
     /*  286177 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(286240), // Rule ID 8721 //
     /*  286182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  286193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  286196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  286199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286221 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286238 */     GIR_RootConstrainSelectedInstOperands,
     /*  286239 */     // GIR_Coverage, 8721,
     /*  286239 */     GIR_EraseRootFromParent_Done,
     /*  286240 */   // Label 5367: @286240
     /*  286240 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(286303), // Rule ID 8724 //
     /*  286245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286301 */     GIR_RootConstrainSelectedInstOperands,
     /*  286302 */     // GIR_Coverage, 8724,
     /*  286302 */     GIR_EraseRootFromParent_Done,
     /*  286303 */   // Label 5368: @286303
     /*  286303 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(286366), // Rule ID 8725 //
     /*  286308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  286322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  286325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286364 */     GIR_RootConstrainSelectedInstOperands,
     /*  286365 */     // GIR_Coverage, 8725,
     /*  286365 */     GIR_EraseRootFromParent_Done,
     /*  286366 */   // Label 5369: @286366
     /*  286366 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(286429), // Rule ID 8728 //
     /*  286371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286427 */     GIR_RootConstrainSelectedInstOperands,
     /*  286428 */     // GIR_Coverage, 8728,
     /*  286428 */     GIR_EraseRootFromParent_Done,
     /*  286429 */   // Label 5370: @286429
     /*  286429 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(286492), // Rule ID 8729 //
     /*  286434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  286448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  286451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286490 */     GIR_RootConstrainSelectedInstOperands,
     /*  286491 */     // GIR_Coverage, 8729,
     /*  286491 */     GIR_EraseRootFromParent_Done,
     /*  286492 */   // Label 5371: @286492
     /*  286492 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(286555), // Rule ID 8732 //
     /*  286497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286536 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286553 */     GIR_RootConstrainSelectedInstOperands,
     /*  286554 */     // GIR_Coverage, 8732,
     /*  286554 */     GIR_EraseRootFromParent_Done,
     /*  286555 */   // Label 5372: @286555
     /*  286555 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(286618), // Rule ID 8733 //
     /*  286560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  286571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  286574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  286577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286599 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286616 */     GIR_RootConstrainSelectedInstOperands,
     /*  286617 */     // GIR_Coverage, 8733,
     /*  286617 */     GIR_EraseRootFromParent_Done,
     /*  286618 */   // Label 5373: @286618
     /*  286618 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(286681), // Rule ID 8736 //
     /*  286623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  286640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286679 */     GIR_RootConstrainSelectedInstOperands,
     /*  286680 */     // GIR_Coverage, 8736,
     /*  286680 */     GIR_EraseRootFromParent_Done,
     /*  286681 */   // Label 5374: @286681
     /*  286681 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(286744), // Rule ID 8737 //
     /*  286686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  286700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  286703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286725 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  286728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286742 */     GIR_RootConstrainSelectedInstOperands,
     /*  286743 */     // GIR_Coverage, 8737,
     /*  286743 */     GIR_EraseRootFromParent_Done,
     /*  286744 */   // Label 5375: @286744
     /*  286744 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(286807), // Rule ID 8740 //
     /*  286749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  286766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286805 */     GIR_RootConstrainSelectedInstOperands,
     /*  286806 */     // GIR_Coverage, 8740,
     /*  286806 */     GIR_EraseRootFromParent_Done,
     /*  286807 */   // Label 5376: @286807
     /*  286807 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(286870), // Rule ID 8741 //
     /*  286812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  286826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  286829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286851 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  286854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286868 */     GIR_RootConstrainSelectedInstOperands,
     /*  286869 */     // GIR_Coverage, 8741,
     /*  286869 */     GIR_EraseRootFromParent_Done,
     /*  286870 */   // Label 5377: @286870
     /*  286870 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(286933), // Rule ID 8744 //
     /*  286875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  286892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286914 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286931 */     GIR_RootConstrainSelectedInstOperands,
     /*  286932 */     // GIR_Coverage, 8744,
     /*  286932 */     GIR_EraseRootFromParent_Done,
     /*  286933 */   // Label 5378: @286933
     /*  286933 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(286996), // Rule ID 8745 //
     /*  286938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  286949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  286952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  286955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286977 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  286980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286994 */     GIR_RootConstrainSelectedInstOperands,
     /*  286995 */     // GIR_Coverage, 8745,
     /*  286995 */     GIR_EraseRootFromParent_Done,
     /*  286996 */   // Label 5379: @286996
     /*  286996 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(287059), // Rule ID 8748 //
     /*  287001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  287043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287057 */     GIR_RootConstrainSelectedInstOperands,
     /*  287058 */     // GIR_Coverage, 8748,
     /*  287058 */     GIR_EraseRootFromParent_Done,
     /*  287059 */   // Label 5380: @287059
     /*  287059 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(287122), // Rule ID 8749 //
     /*  287064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  287078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  287081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287103 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  287106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287120 */     GIR_RootConstrainSelectedInstOperands,
     /*  287121 */     // GIR_Coverage, 8749,
     /*  287121 */     GIR_EraseRootFromParent_Done,
     /*  287122 */   // Label 5381: @287122
     /*  287122 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(287185), // Rule ID 8752 //
     /*  287127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287166 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  287169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287183 */     GIR_RootConstrainSelectedInstOperands,
     /*  287184 */     // GIR_Coverage, 8752,
     /*  287184 */     GIR_EraseRootFromParent_Done,
     /*  287185 */   // Label 5382: @287185
     /*  287185 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(287248), // Rule ID 8753 //
     /*  287190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  287204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  287207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287229 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  287232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287246 */     GIR_RootConstrainSelectedInstOperands,
     /*  287247 */     // GIR_Coverage, 8753,
     /*  287247 */     GIR_EraseRootFromParent_Done,
     /*  287248 */   // Label 5383: @287248
     /*  287248 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(287311), // Rule ID 8756 //
     /*  287253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  287295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287309 */     GIR_RootConstrainSelectedInstOperands,
     /*  287310 */     // GIR_Coverage, 8756,
     /*  287310 */     GIR_EraseRootFromParent_Done,
     /*  287311 */   // Label 5384: @287311
     /*  287311 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(287374), // Rule ID 8757 //
     /*  287316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  287330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  287333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287355 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  287358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287372 */     GIR_RootConstrainSelectedInstOperands,
     /*  287373 */     // GIR_Coverage, 8757,
     /*  287373 */     GIR_EraseRootFromParent_Done,
     /*  287374 */   // Label 5385: @287374
     /*  287374 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(287437), // Rule ID 8760 //
     /*  287379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  287421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287435 */     GIR_RootConstrainSelectedInstOperands,
     /*  287436 */     // GIR_Coverage, 8760,
     /*  287436 */     GIR_EraseRootFromParent_Done,
     /*  287437 */   // Label 5386: @287437
     /*  287437 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(287500), // Rule ID 8761 //
     /*  287442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  287456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287481 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  287484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287498 */     GIR_RootConstrainSelectedInstOperands,
     /*  287499 */     // GIR_Coverage, 8761,
     /*  287499 */     GIR_EraseRootFromParent_Done,
     /*  287500 */   // Label 5387: @287500
     /*  287500 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(287563), // Rule ID 8764 //
     /*  287505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287561 */     GIR_RootConstrainSelectedInstOperands,
     /*  287562 */     // GIR_Coverage, 8764,
     /*  287562 */     GIR_EraseRootFromParent_Done,
     /*  287563 */   // Label 5388: @287563
     /*  287563 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(287626), // Rule ID 8765 //
     /*  287568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  287582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287624 */     GIR_RootConstrainSelectedInstOperands,
     /*  287625 */     // GIR_Coverage, 8765,
     /*  287625 */     GIR_EraseRootFromParent_Done,
     /*  287626 */   // Label 5389: @287626
     /*  287626 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(287689), // Rule ID 8768 //
     /*  287631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287687 */     GIR_RootConstrainSelectedInstOperands,
     /*  287688 */     // GIR_Coverage, 8768,
     /*  287688 */     GIR_EraseRootFromParent_Done,
     /*  287689 */   // Label 5390: @287689
     /*  287689 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(287752), // Rule ID 8769 //
     /*  287694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  287708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287733 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287750 */     GIR_RootConstrainSelectedInstOperands,
     /*  287751 */     // GIR_Coverage, 8769,
     /*  287751 */     GIR_EraseRootFromParent_Done,
     /*  287752 */   // Label 5391: @287752
     /*  287752 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(287815), // Rule ID 8772 //
     /*  287757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287813 */     GIR_RootConstrainSelectedInstOperands,
     /*  287814 */     // GIR_Coverage, 8772,
     /*  287814 */     GIR_EraseRootFromParent_Done,
     /*  287815 */   // Label 5392: @287815
     /*  287815 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(287878), // Rule ID 8773 //
     /*  287820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  287834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  287862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287876 */     GIR_RootConstrainSelectedInstOperands,
     /*  287877 */     // GIR_Coverage, 8773,
     /*  287877 */     GIR_EraseRootFromParent_Done,
     /*  287878 */   // Label 5393: @287878
     /*  287878 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(287941), // Rule ID 8776 //
     /*  287883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  287900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287939 */     GIR_RootConstrainSelectedInstOperands,
     /*  287940 */     // GIR_Coverage, 8776,
     /*  287940 */     GIR_EraseRootFromParent_Done,
     /*  287941 */   // Label 5394: @287941
     /*  287941 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(288004), // Rule ID 8777 //
     /*  287946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  287954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  287960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  287963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  287978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287985 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  287988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288002 */     GIR_RootConstrainSelectedInstOperands,
     /*  288003 */     // GIR_Coverage, 8777,
     /*  288003 */     GIR_EraseRootFromParent_Done,
     /*  288004 */   // Label 5395: @288004
     /*  288004 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(288067), // Rule ID 8780 //
     /*  288009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  288051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288065 */     GIR_RootConstrainSelectedInstOperands,
     /*  288066 */     // GIR_Coverage, 8780,
     /*  288066 */     GIR_EraseRootFromParent_Done,
     /*  288067 */   // Label 5396: @288067
     /*  288067 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(288130), // Rule ID 8781 //
     /*  288072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  288086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  288114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288128 */     GIR_RootConstrainSelectedInstOperands,
     /*  288129 */     // GIR_Coverage, 8781,
     /*  288129 */     GIR_EraseRootFromParent_Done,
     /*  288130 */   // Label 5397: @288130
     /*  288130 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(288193), // Rule ID 8784 //
     /*  288135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288191 */     GIR_RootConstrainSelectedInstOperands,
     /*  288192 */     // GIR_Coverage, 8784,
     /*  288192 */     GIR_EraseRootFromParent_Done,
     /*  288193 */   // Label 5398: @288193
     /*  288193 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(288256), // Rule ID 8785 //
     /*  288198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  288212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288237 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288254 */     GIR_RootConstrainSelectedInstOperands,
     /*  288255 */     // GIR_Coverage, 8785,
     /*  288255 */     GIR_EraseRootFromParent_Done,
     /*  288256 */   // Label 5399: @288256
     /*  288256 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(288319), // Rule ID 8788 //
     /*  288261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288317 */     GIR_RootConstrainSelectedInstOperands,
     /*  288318 */     // GIR_Coverage, 8788,
     /*  288318 */     GIR_EraseRootFromParent_Done,
     /*  288319 */   // Label 5400: @288319
     /*  288319 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(288382), // Rule ID 8789 //
     /*  288324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  288338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288380 */     GIR_RootConstrainSelectedInstOperands,
     /*  288381 */     // GIR_Coverage, 8789,
     /*  288381 */     GIR_EraseRootFromParent_Done,
     /*  288382 */   // Label 5401: @288382
     /*  288382 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(288445), // Rule ID 8792 //
     /*  288387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288426 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288443 */     GIR_RootConstrainSelectedInstOperands,
     /*  288444 */     // GIR_Coverage, 8792,
     /*  288444 */     GIR_EraseRootFromParent_Done,
     /*  288445 */   // Label 5402: @288445
     /*  288445 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(288508), // Rule ID 8793 //
     /*  288450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  288464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288489 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288506 */     GIR_RootConstrainSelectedInstOperands,
     /*  288507 */     // GIR_Coverage, 8793,
     /*  288507 */     GIR_EraseRootFromParent_Done,
     /*  288508 */   // Label 5403: @288508
     /*  288508 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(288571), // Rule ID 8796 //
     /*  288513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288569 */     GIR_RootConstrainSelectedInstOperands,
     /*  288570 */     // GIR_Coverage, 8796,
     /*  288570 */     GIR_EraseRootFromParent_Done,
     /*  288571 */   // Label 5404: @288571
     /*  288571 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(288634), // Rule ID 8797 //
     /*  288576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  288590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288615 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  288618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288632 */     GIR_RootConstrainSelectedInstOperands,
     /*  288633 */     // GIR_Coverage, 8797,
     /*  288633 */     GIR_EraseRootFromParent_Done,
     /*  288634 */   // Label 5405: @288634
     /*  288634 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(288697), // Rule ID 8800 //
     /*  288639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  288681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288695 */     GIR_RootConstrainSelectedInstOperands,
     /*  288696 */     // GIR_Coverage, 8800,
     /*  288696 */     GIR_EraseRootFromParent_Done,
     /*  288697 */   // Label 5406: @288697
     /*  288697 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(288760), // Rule ID 8801 //
     /*  288702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  288716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288741 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  288744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288758 */     GIR_RootConstrainSelectedInstOperands,
     /*  288759 */     // GIR_Coverage, 8801,
     /*  288759 */     GIR_EraseRootFromParent_Done,
     /*  288760 */   // Label 5407: @288760
     /*  288760 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(288823), // Rule ID 8804 //
     /*  288765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288804 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  288807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288821 */     GIR_RootConstrainSelectedInstOperands,
     /*  288822 */     // GIR_Coverage, 8804,
     /*  288822 */     GIR_EraseRootFromParent_Done,
     /*  288823 */   // Label 5408: @288823
     /*  288823 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(288886), // Rule ID 8805 //
     /*  288828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  288842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288867 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  288870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288884 */     GIR_RootConstrainSelectedInstOperands,
     /*  288885 */     // GIR_Coverage, 8805,
     /*  288885 */     GIR_EraseRootFromParent_Done,
     /*  288886 */   // Label 5409: @288886
     /*  288886 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(288949), // Rule ID 8808 //
     /*  288891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288930 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  288933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288947 */     GIR_RootConstrainSelectedInstOperands,
     /*  288948 */     // GIR_Coverage, 8808,
     /*  288948 */     GIR_EraseRootFromParent_Done,
     /*  288949 */   // Label 5410: @288949
     /*  288949 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(289012), // Rule ID 8809 //
     /*  288954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  288962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  288965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  288968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288993 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  288996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289010 */     GIR_RootConstrainSelectedInstOperands,
     /*  289011 */     // GIR_Coverage, 8809,
     /*  289011 */     GIR_EraseRootFromParent_Done,
     /*  289012 */   // Label 5411: @289012
     /*  289012 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(289075), // Rule ID 8812 //
     /*  289017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289073 */     GIR_RootConstrainSelectedInstOperands,
     /*  289074 */     // GIR_Coverage, 8812,
     /*  289074 */     GIR_EraseRootFromParent_Done,
     /*  289075 */   // Label 5412: @289075
     /*  289075 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(289138), // Rule ID 8813 //
     /*  289080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  289094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289136 */     GIR_RootConstrainSelectedInstOperands,
     /*  289137 */     // GIR_Coverage, 8813,
     /*  289137 */     GIR_EraseRootFromParent_Done,
     /*  289138 */   // Label 5413: @289138
     /*  289138 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(289201), // Rule ID 8816 //
     /*  289143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289199 */     GIR_RootConstrainSelectedInstOperands,
     /*  289200 */     // GIR_Coverage, 8816,
     /*  289200 */     GIR_EraseRootFromParent_Done,
     /*  289201 */   // Label 5414: @289201
     /*  289201 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(289264), // Rule ID 8817 //
     /*  289206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  289220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289245 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289262 */     GIR_RootConstrainSelectedInstOperands,
     /*  289263 */     // GIR_Coverage, 8817,
     /*  289263 */     GIR_EraseRootFromParent_Done,
     /*  289264 */   // Label 5415: @289264
     /*  289264 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(289327), // Rule ID 8820 //
     /*  289269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  289280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289308 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289325 */     GIR_RootConstrainSelectedInstOperands,
     /*  289326 */     // GIR_Coverage, 8820,
     /*  289326 */     GIR_EraseRootFromParent_Done,
     /*  289327 */   // Label 5416: @289327
     /*  289327 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(289390), // Rule ID 8821 //
     /*  289332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  289343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  289346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289371 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289388 */     GIR_RootConstrainSelectedInstOperands,
     /*  289389 */     // GIR_Coverage, 8821,
     /*  289389 */     GIR_EraseRootFromParent_Done,
     /*  289390 */   // Label 5417: @289390
     /*  289390 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(289453), // Rule ID 8824 //
     /*  289395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289451 */     GIR_RootConstrainSelectedInstOperands,
     /*  289452 */     // GIR_Coverage, 8824,
     /*  289452 */     GIR_EraseRootFromParent_Done,
     /*  289453 */   // Label 5418: @289453
     /*  289453 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(289516), // Rule ID 8825 //
     /*  289458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  289472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289497 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289514 */     GIR_RootConstrainSelectedInstOperands,
     /*  289515 */     // GIR_Coverage, 8825,
     /*  289515 */     GIR_EraseRootFromParent_Done,
     /*  289516 */   // Label 5419: @289516
     /*  289516 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(289579), // Rule ID 8828 //
     /*  289521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289577 */     GIR_RootConstrainSelectedInstOperands,
     /*  289578 */     // GIR_Coverage, 8828,
     /*  289578 */     GIR_EraseRootFromParent_Done,
     /*  289579 */   // Label 5420: @289579
     /*  289579 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(289642), // Rule ID 8829 //
     /*  289584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  289598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289623 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289640 */     GIR_RootConstrainSelectedInstOperands,
     /*  289641 */     // GIR_Coverage, 8829,
     /*  289641 */     GIR_EraseRootFromParent_Done,
     /*  289642 */   // Label 5421: @289642
     /*  289642 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(289705), // Rule ID 8832 //
     /*  289647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289703 */     GIR_RootConstrainSelectedInstOperands,
     /*  289704 */     // GIR_Coverage, 8832,
     /*  289704 */     GIR_EraseRootFromParent_Done,
     /*  289705 */   // Label 5422: @289705
     /*  289705 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(289768), // Rule ID 8833 //
     /*  289710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  289724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  289752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289766 */     GIR_RootConstrainSelectedInstOperands,
     /*  289767 */     // GIR_Coverage, 8833,
     /*  289767 */     GIR_EraseRootFromParent_Done,
     /*  289768 */   // Label 5423: @289768
     /*  289768 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(289831), // Rule ID 8836 //
     /*  289773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289829 */     GIR_RootConstrainSelectedInstOperands,
     /*  289830 */     // GIR_Coverage, 8836,
     /*  289830 */     GIR_EraseRootFromParent_Done,
     /*  289831 */   // Label 5424: @289831
     /*  289831 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(289894), // Rule ID 8837 //
     /*  289836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  289850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  289878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289892 */     GIR_RootConstrainSelectedInstOperands,
     /*  289893 */     // GIR_Coverage, 8837,
     /*  289893 */     GIR_EraseRootFromParent_Done,
     /*  289894 */   // Label 5425: @289894
     /*  289894 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(289957), // Rule ID 8840 //
     /*  289899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289938 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  289941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289955 */     GIR_RootConstrainSelectedInstOperands,
     /*  289956 */     // GIR_Coverage, 8840,
     /*  289956 */     GIR_EraseRootFromParent_Done,
     /*  289957 */   // Label 5426: @289957
     /*  289957 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(290020), // Rule ID 8841 //
     /*  289962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  289970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  289976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290001 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  290004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290018 */     GIR_RootConstrainSelectedInstOperands,
     /*  290019 */     // GIR_Coverage, 8841,
     /*  290019 */     GIR_EraseRootFromParent_Done,
     /*  290020 */   // Label 5427: @290020
     /*  290020 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(290083), // Rule ID 8844 //
     /*  290025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  290033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  290067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290081 */     GIR_RootConstrainSelectedInstOperands,
     /*  290082 */     // GIR_Coverage, 8844,
     /*  290082 */     GIR_EraseRootFromParent_Done,
     /*  290083 */   // Label 5428: @290083
     /*  290083 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(290146), // Rule ID 8845 //
     /*  290088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  290096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  290102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290127 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  290130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290144 */     GIR_RootConstrainSelectedInstOperands,
     /*  290145 */     // GIR_Coverage, 8845,
     /*  290145 */     GIR_EraseRootFromParent_Done,
     /*  290146 */   // Label 5429: @290146
     /*  290146 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(290209), // Rule ID 8936 //
     /*  290151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  290165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  290168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  290193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290207 */     GIR_RootConstrainSelectedInstOperands,
     /*  290208 */     // GIR_Coverage, 8936,
     /*  290208 */     GIR_EraseRootFromParent_Done,
     /*  290209 */   // Label 5430: @290209
     /*  290209 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(290272), // Rule ID 8937 //
     /*  290214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  290228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  290231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290253 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  290256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290270 */     GIR_RootConstrainSelectedInstOperands,
     /*  290271 */     // GIR_Coverage, 8937,
     /*  290271 */     GIR_EraseRootFromParent_Done,
     /*  290272 */   // Label 5431: @290272
     /*  290272 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(290335), // Rule ID 8940 //
     /*  290277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  290291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  290294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290333 */     GIR_RootConstrainSelectedInstOperands,
     /*  290334 */     // GIR_Coverage, 8940,
     /*  290334 */     GIR_EraseRootFromParent_Done,
     /*  290335 */   // Label 5432: @290335
     /*  290335 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(290398), // Rule ID 8941 //
     /*  290340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  290354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  290357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290396 */     GIR_RootConstrainSelectedInstOperands,
     /*  290397 */     // GIR_Coverage, 8941,
     /*  290397 */     GIR_EraseRootFromParent_Done,
     /*  290398 */   // Label 5433: @290398
     /*  290398 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(290461), // Rule ID 8944 //
     /*  290403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  290417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  290420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290459 */     GIR_RootConstrainSelectedInstOperands,
     /*  290460 */     // GIR_Coverage, 8944,
     /*  290460 */     GIR_EraseRootFromParent_Done,
     /*  290461 */   // Label 5434: @290461
     /*  290461 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(290524), // Rule ID 8945 //
     /*  290466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  290480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  290483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290505 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290522 */     GIR_RootConstrainSelectedInstOperands,
     /*  290523 */     // GIR_Coverage, 8945,
     /*  290523 */     GIR_EraseRootFromParent_Done,
     /*  290524 */   // Label 5435: @290524
     /*  290524 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(290587), // Rule ID 8948 //
     /*  290529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  290546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290585 */     GIR_RootConstrainSelectedInstOperands,
     /*  290586 */     // GIR_Coverage, 8948,
     /*  290586 */     GIR_EraseRootFromParent_Done,
     /*  290587 */   // Label 5436: @290587
     /*  290587 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(290650), // Rule ID 8949 //
     /*  290592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  290606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  290609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290631 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  290634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290648 */     GIR_RootConstrainSelectedInstOperands,
     /*  290649 */     // GIR_Coverage, 8949,
     /*  290649 */     GIR_EraseRootFromParent_Done,
     /*  290650 */   // Label 5437: @290650
     /*  290650 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(290713), // Rule ID 8952 //
     /*  290655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  290672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290711 */     GIR_RootConstrainSelectedInstOperands,
     /*  290712 */     // GIR_Coverage, 8952,
     /*  290712 */     GIR_EraseRootFromParent_Done,
     /*  290713 */   // Label 5438: @290713
     /*  290713 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(290776), // Rule ID 8953 //
     /*  290718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  290732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  290735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290757 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290774 */     GIR_RootConstrainSelectedInstOperands,
     /*  290775 */     // GIR_Coverage, 8953,
     /*  290775 */     GIR_EraseRootFromParent_Done,
     /*  290776 */   // Label 5439: @290776
     /*  290776 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(290839), // Rule ID 8956 //
     /*  290781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  290798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290837 */     GIR_RootConstrainSelectedInstOperands,
     /*  290838 */     // GIR_Coverage, 8956,
     /*  290838 */     GIR_EraseRootFromParent_Done,
     /*  290839 */   // Label 5440: @290839
     /*  290839 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(290902), // Rule ID 8957 //
     /*  290844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  290858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  290861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290883 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  290886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290900 */     GIR_RootConstrainSelectedInstOperands,
     /*  290901 */     // GIR_Coverage, 8957,
     /*  290901 */     GIR_EraseRootFromParent_Done,
     /*  290902 */   // Label 5441: @290902
     /*  290902 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(290965), // Rule ID 8960 //
     /*  290907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  290924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  290949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290963 */     GIR_RootConstrainSelectedInstOperands,
     /*  290964 */     // GIR_Coverage, 8960,
     /*  290964 */     GIR_EraseRootFromParent_Done,
     /*  290965 */   // Label 5442: @290965
     /*  290965 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(291028), // Rule ID 8961 //
     /*  290970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  290984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  290987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291009 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291026 */     GIR_RootConstrainSelectedInstOperands,
     /*  291027 */     // GIR_Coverage, 8961,
     /*  291027 */     GIR_EraseRootFromParent_Done,
     /*  291028 */   // Label 5443: @291028
     /*  291028 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(291091), // Rule ID 8964 //
     /*  291033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  291047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  291050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291089 */     GIR_RootConstrainSelectedInstOperands,
     /*  291090 */     // GIR_Coverage, 8964,
     /*  291090 */     GIR_EraseRootFromParent_Done,
     /*  291091 */   // Label 5444: @291091
     /*  291091 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(291154), // Rule ID 8965 //
     /*  291096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  291110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  291113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291152 */     GIR_RootConstrainSelectedInstOperands,
     /*  291153 */     // GIR_Coverage, 8965,
     /*  291153 */     GIR_EraseRootFromParent_Done,
     /*  291154 */   // Label 5445: @291154
     /*  291154 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(291217), // Rule ID 8968 //
     /*  291159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  291173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  291176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291198 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291215 */     GIR_RootConstrainSelectedInstOperands,
     /*  291216 */     // GIR_Coverage, 8968,
     /*  291216 */     GIR_EraseRootFromParent_Done,
     /*  291217 */   // Label 5446: @291217
     /*  291217 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(291280), // Rule ID 8969 //
     /*  291222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  291236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  291239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291261 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291278 */     GIR_RootConstrainSelectedInstOperands,
     /*  291279 */     // GIR_Coverage, 8969,
     /*  291279 */     GIR_EraseRootFromParent_Done,
     /*  291280 */   // Label 5447: @291280
     /*  291280 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(291343), // Rule ID 8972 //
     /*  291285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  291299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  291302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291341 */     GIR_RootConstrainSelectedInstOperands,
     /*  291342 */     // GIR_Coverage, 8972,
     /*  291342 */     GIR_EraseRootFromParent_Done,
     /*  291343 */   // Label 5448: @291343
     /*  291343 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(291406), // Rule ID 8973 //
     /*  291348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  291362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  291365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291387 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  291390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291404 */     GIR_RootConstrainSelectedInstOperands,
     /*  291405 */     // GIR_Coverage, 8973,
     /*  291405 */     GIR_EraseRootFromParent_Done,
     /*  291406 */   // Label 5449: @291406
     /*  291406 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(291469), // Rule ID 8976 //
     /*  291411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  291425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  291428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291467 */     GIR_RootConstrainSelectedInstOperands,
     /*  291468 */     // GIR_Coverage, 8976,
     /*  291468 */     GIR_EraseRootFromParent_Done,
     /*  291469 */   // Label 5450: @291469
     /*  291469 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(291532), // Rule ID 8977 //
     /*  291474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  291488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  291491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291530 */     GIR_RootConstrainSelectedInstOperands,
     /*  291531 */     // GIR_Coverage, 8977,
     /*  291531 */     GIR_EraseRootFromParent_Done,
     /*  291532 */   // Label 5451: @291532
     /*  291532 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(291595), // Rule ID 8980 //
     /*  291537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  291554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291593 */     GIR_RootConstrainSelectedInstOperands,
     /*  291594 */     // GIR_Coverage, 8980,
     /*  291594 */     GIR_EraseRootFromParent_Done,
     /*  291595 */   // Label 5452: @291595
     /*  291595 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(291658), // Rule ID 8981 //
     /*  291600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  291614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  291617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291639 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291656 */     GIR_RootConstrainSelectedInstOperands,
     /*  291657 */     // GIR_Coverage, 8981,
     /*  291657 */     GIR_EraseRootFromParent_Done,
     /*  291658 */   // Label 5453: @291658
     /*  291658 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(291721), // Rule ID 8984 //
     /*  291663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  291680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291702 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  291705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291719 */     GIR_RootConstrainSelectedInstOperands,
     /*  291720 */     // GIR_Coverage, 8984,
     /*  291720 */     GIR_EraseRootFromParent_Done,
     /*  291721 */   // Label 5454: @291721
     /*  291721 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(291784), // Rule ID 8985 //
     /*  291726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  291737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  291740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  291743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291765 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  291768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291782 */     GIR_RootConstrainSelectedInstOperands,
     /*  291783 */     // GIR_Coverage, 8985,
     /*  291783 */     GIR_EraseRootFromParent_Done,
     /*  291784 */   // Label 5455: @291784
     /*  291784 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(291847), // Rule ID 8988 //
     /*  291789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  291806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291845 */     GIR_RootConstrainSelectedInstOperands,
     /*  291846 */     // GIR_Coverage, 8988,
     /*  291846 */     GIR_EraseRootFromParent_Done,
     /*  291847 */   // Label 5456: @291847
     /*  291847 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(291910), // Rule ID 8989 //
     /*  291852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  291866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  291869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291891 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  291894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291908 */     GIR_RootConstrainSelectedInstOperands,
     /*  291909 */     // GIR_Coverage, 8989,
     /*  291909 */     GIR_EraseRootFromParent_Done,
     /*  291910 */   // Label 5457: @291910
     /*  291910 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(291973), // Rule ID 8992 //
     /*  291915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  291932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291954 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  291957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291971 */     GIR_RootConstrainSelectedInstOperands,
     /*  291972 */     // GIR_Coverage, 8992,
     /*  291972 */     GIR_EraseRootFromParent_Done,
     /*  291973 */   // Label 5458: @291973
     /*  291973 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(292036), // Rule ID 8993 //
     /*  291978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  291992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  291995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292034 */     GIR_RootConstrainSelectedInstOperands,
     /*  292035 */     // GIR_Coverage, 8993,
     /*  292035 */     GIR_EraseRootFromParent_Done,
     /*  292036 */   // Label 5459: @292036
     /*  292036 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(292099), // Rule ID 8996 //
     /*  292041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  292055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  292058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292097 */     GIR_RootConstrainSelectedInstOperands,
     /*  292098 */     // GIR_Coverage, 8996,
     /*  292098 */     GIR_EraseRootFromParent_Done,
     /*  292099 */   // Label 5460: @292099
     /*  292099 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(292162), // Rule ID 8997 //
     /*  292104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  292118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  292121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292143 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292160 */     GIR_RootConstrainSelectedInstOperands,
     /*  292161 */     // GIR_Coverage, 8997,
     /*  292161 */     GIR_EraseRootFromParent_Done,
     /*  292162 */   // Label 5461: @292162
     /*  292162 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(292225), // Rule ID 9000 //
     /*  292167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  292181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  292184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292223 */     GIR_RootConstrainSelectedInstOperands,
     /*  292224 */     // GIR_Coverage, 9000,
     /*  292224 */     GIR_EraseRootFromParent_Done,
     /*  292225 */   // Label 5462: @292225
     /*  292225 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(292288), // Rule ID 9001 //
     /*  292230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  292244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  292247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292269 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292286 */     GIR_RootConstrainSelectedInstOperands,
     /*  292287 */     // GIR_Coverage, 9001,
     /*  292287 */     GIR_EraseRootFromParent_Done,
     /*  292288 */   // Label 5463: @292288
     /*  292288 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(292351), // Rule ID 9004 //
     /*  292293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  292307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  292310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292349 */     GIR_RootConstrainSelectedInstOperands,
     /*  292350 */     // GIR_Coverage, 9004,
     /*  292350 */     GIR_EraseRootFromParent_Done,
     /*  292351 */   // Label 5464: @292351
     /*  292351 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(292414), // Rule ID 9005 //
     /*  292356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  292370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  292373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292412 */     GIR_RootConstrainSelectedInstOperands,
     /*  292413 */     // GIR_Coverage, 9005,
     /*  292413 */     GIR_EraseRootFromParent_Done,
     /*  292414 */   // Label 5465: @292414
     /*  292414 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(292477), // Rule ID 9008 //
     /*  292419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  292433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  292436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292475 */     GIR_RootConstrainSelectedInstOperands,
     /*  292476 */     // GIR_Coverage, 9008,
     /*  292476 */     GIR_EraseRootFromParent_Done,
     /*  292477 */   // Label 5466: @292477
     /*  292477 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(292540), // Rule ID 9009 //
     /*  292482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  292496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  292499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292521 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292538 */     GIR_RootConstrainSelectedInstOperands,
     /*  292539 */     // GIR_Coverage, 9009,
     /*  292539 */     GIR_EraseRootFromParent_Done,
     /*  292540 */   // Label 5467: @292540
     /*  292540 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(292603), // Rule ID 9012 //
     /*  292545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  292562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292601 */     GIR_RootConstrainSelectedInstOperands,
     /*  292602 */     // GIR_Coverage, 9012,
     /*  292602 */     GIR_EraseRootFromParent_Done,
     /*  292603 */   // Label 5468: @292603
     /*  292603 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(292666), // Rule ID 9013 //
     /*  292608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  292622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  292625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  292650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292664 */     GIR_RootConstrainSelectedInstOperands,
     /*  292665 */     // GIR_Coverage, 9013,
     /*  292665 */     GIR_EraseRootFromParent_Done,
     /*  292666 */   // Label 5469: @292666
     /*  292666 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(292729), // Rule ID 9016 //
     /*  292671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  292688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292727 */     GIR_RootConstrainSelectedInstOperands,
     /*  292728 */     // GIR_Coverage, 9016,
     /*  292728 */     GIR_EraseRootFromParent_Done,
     /*  292729 */   // Label 5470: @292729
     /*  292729 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(292792), // Rule ID 9017 //
     /*  292734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  292748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  292751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292773 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  292776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292790 */     GIR_RootConstrainSelectedInstOperands,
     /*  292791 */     // GIR_Coverage, 9017,
     /*  292791 */     GIR_EraseRootFromParent_Done,
     /*  292792 */   // Label 5471: @292792
     /*  292792 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(292855), // Rule ID 9020 //
     /*  292797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  292814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292836 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292853 */     GIR_RootConstrainSelectedInstOperands,
     /*  292854 */     // GIR_Coverage, 9020,
     /*  292854 */     GIR_EraseRootFromParent_Done,
     /*  292855 */   // Label 5472: @292855
     /*  292855 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(292918), // Rule ID 9021 //
     /*  292860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  292874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  292877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  292902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292916 */     GIR_RootConstrainSelectedInstOperands,
     /*  292917 */     // GIR_Coverage, 9021,
     /*  292917 */     GIR_EraseRootFromParent_Done,
     /*  292918 */   // Label 5473: @292918
     /*  292918 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(292981), // Rule ID 9024 //
     /*  292923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  292937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  292965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292979 */     GIR_RootConstrainSelectedInstOperands,
     /*  292980 */     // GIR_Coverage, 9024,
     /*  292980 */     GIR_EraseRootFromParent_Done,
     /*  292981 */   // Label 5474: @292981
     /*  292981 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(293044), // Rule ID 9025 //
     /*  292986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  292994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  293000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293025 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  293028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293042 */     GIR_RootConstrainSelectedInstOperands,
     /*  293043 */     // GIR_Coverage, 9025,
     /*  293043 */     GIR_EraseRootFromParent_Done,
     /*  293044 */   // Label 5475: @293044
     /*  293044 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(293107), // Rule ID 9028 //
     /*  293049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  293063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293105 */     GIR_RootConstrainSelectedInstOperands,
     /*  293106 */     // GIR_Coverage, 9028,
     /*  293106 */     GIR_EraseRootFromParent_Done,
     /*  293107 */   // Label 5476: @293107
     /*  293107 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(293170), // Rule ID 9029 //
     /*  293112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  293126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293168 */     GIR_RootConstrainSelectedInstOperands,
     /*  293169 */     // GIR_Coverage, 9029,
     /*  293169 */     GIR_EraseRootFromParent_Done,
     /*  293170 */   // Label 5477: @293170
     /*  293170 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(293233), // Rule ID 9032 //
     /*  293175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  293189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293231 */     GIR_RootConstrainSelectedInstOperands,
     /*  293232 */     // GIR_Coverage, 9032,
     /*  293232 */     GIR_EraseRootFromParent_Done,
     /*  293233 */   // Label 5478: @293233
     /*  293233 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(293296), // Rule ID 9033 //
     /*  293238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  293252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293277 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293294 */     GIR_RootConstrainSelectedInstOperands,
     /*  293295 */     // GIR_Coverage, 9033,
     /*  293295 */     GIR_EraseRootFromParent_Done,
     /*  293296 */   // Label 5479: @293296
     /*  293296 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(293359), // Rule ID 9036 //
     /*  293301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  293315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293357 */     GIR_RootConstrainSelectedInstOperands,
     /*  293358 */     // GIR_Coverage, 9036,
     /*  293358 */     GIR_EraseRootFromParent_Done,
     /*  293359 */   // Label 5480: @293359
     /*  293359 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(293422), // Rule ID 9037 //
     /*  293364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  293378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  293406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293420 */     GIR_RootConstrainSelectedInstOperands,
     /*  293421 */     // GIR_Coverage, 9037,
     /*  293421 */     GIR_EraseRootFromParent_Done,
     /*  293422 */   // Label 5481: @293422
     /*  293422 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(293485), // Rule ID 9040 //
     /*  293427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  293441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293483 */     GIR_RootConstrainSelectedInstOperands,
     /*  293484 */     // GIR_Coverage, 9040,
     /*  293484 */     GIR_EraseRootFromParent_Done,
     /*  293485 */   // Label 5482: @293485
     /*  293485 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(293548), // Rule ID 9041 //
     /*  293490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  293504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293529 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293546 */     GIR_RootConstrainSelectedInstOperands,
     /*  293547 */     // GIR_Coverage, 9041,
     /*  293547 */     GIR_EraseRootFromParent_Done,
     /*  293548 */   // Label 5483: @293548
     /*  293548 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(293611), // Rule ID 9044 //
     /*  293553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293609 */     GIR_RootConstrainSelectedInstOperands,
     /*  293610 */     // GIR_Coverage, 9044,
     /*  293610 */     GIR_EraseRootFromParent_Done,
     /*  293611 */   // Label 5484: @293611
     /*  293611 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(293674), // Rule ID 9045 //
     /*  293616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  293630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293655 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  293658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293672 */     GIR_RootConstrainSelectedInstOperands,
     /*  293673 */     // GIR_Coverage, 9045,
     /*  293673 */     GIR_EraseRootFromParent_Done,
     /*  293674 */   // Label 5485: @293674
     /*  293674 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(293737), // Rule ID 9048 //
     /*  293679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293735 */     GIR_RootConstrainSelectedInstOperands,
     /*  293736 */     // GIR_Coverage, 9048,
     /*  293736 */     GIR_EraseRootFromParent_Done,
     /*  293737 */   // Label 5486: @293737
     /*  293737 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(293800), // Rule ID 9049 //
     /*  293742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  293756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293781 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293798 */     GIR_RootConstrainSelectedInstOperands,
     /*  293799 */     // GIR_Coverage, 9049,
     /*  293799 */     GIR_EraseRootFromParent_Done,
     /*  293800 */   // Label 5487: @293800
     /*  293800 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(293863), // Rule ID 9052 //
     /*  293805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293861 */     GIR_RootConstrainSelectedInstOperands,
     /*  293862 */     // GIR_Coverage, 9052,
     /*  293862 */     GIR_EraseRootFromParent_Done,
     /*  293863 */   // Label 5488: @293863
     /*  293863 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(293926), // Rule ID 9053 //
     /*  293868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  293882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293924 */     GIR_RootConstrainSelectedInstOperands,
     /*  293925 */     // GIR_Coverage, 9053,
     /*  293925 */     GIR_EraseRootFromParent_Done,
     /*  293926 */   // Label 5489: @293926
     /*  293926 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(293989), // Rule ID 9056 //
     /*  293931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  293939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  293945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  293973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293987 */     GIR_RootConstrainSelectedInstOperands,
     /*  293988 */     // GIR_Coverage, 9056,
     /*  293988 */     GIR_EraseRootFromParent_Done,
     /*  293989 */   // Label 5490: @293989
     /*  293989 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(294052), // Rule ID 9057 //
     /*  293994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  294008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294033 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294050 */     GIR_RootConstrainSelectedInstOperands,
     /*  294051 */     // GIR_Coverage, 9057,
     /*  294051 */     GIR_EraseRootFromParent_Done,
     /*  294052 */   // Label 5491: @294052
     /*  294052 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(294115), // Rule ID 9060 //
     /*  294057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  294071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294113 */     GIR_RootConstrainSelectedInstOperands,
     /*  294114 */     // GIR_Coverage, 9060,
     /*  294114 */     GIR_EraseRootFromParent_Done,
     /*  294115 */   // Label 5492: @294115
     /*  294115 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(294178), // Rule ID 9061 //
     /*  294120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  294134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294159 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  294162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294176 */     GIR_RootConstrainSelectedInstOperands,
     /*  294177 */     // GIR_Coverage, 9061,
     /*  294177 */     GIR_EraseRootFromParent_Done,
     /*  294178 */   // Label 5493: @294178
     /*  294178 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(294241), // Rule ID 9064 //
     /*  294183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  294197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294239 */     GIR_RootConstrainSelectedInstOperands,
     /*  294240 */     // GIR_Coverage, 9064,
     /*  294240 */     GIR_EraseRootFromParent_Done,
     /*  294241 */   // Label 5494: @294241
     /*  294241 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(294304), // Rule ID 9065 //
     /*  294246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  294260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294285 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294302 */     GIR_RootConstrainSelectedInstOperands,
     /*  294303 */     // GIR_Coverage, 9065,
     /*  294303 */     GIR_EraseRootFromParent_Done,
     /*  294304 */   // Label 5495: @294304
     /*  294304 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(294367), // Rule ID 9068 //
     /*  294309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  294323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294348 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294365 */     GIR_RootConstrainSelectedInstOperands,
     /*  294366 */     // GIR_Coverage, 9068,
     /*  294366 */     GIR_EraseRootFromParent_Done,
     /*  294367 */   // Label 5496: @294367
     /*  294367 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(294430), // Rule ID 9069 //
     /*  294372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  294386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294411 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294428 */     GIR_RootConstrainSelectedInstOperands,
     /*  294429 */     // GIR_Coverage, 9069,
     /*  294429 */     GIR_EraseRootFromParent_Done,
     /*  294430 */   // Label 5497: @294430
     /*  294430 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(294493), // Rule ID 9072 //
     /*  294435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  294446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  294449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294474 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294491 */     GIR_RootConstrainSelectedInstOperands,
     /*  294492 */     // GIR_Coverage, 9072,
     /*  294492 */     GIR_EraseRootFromParent_Done,
     /*  294493 */   // Label 5498: @294493
     /*  294493 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(294556), // Rule ID 9073 //
     /*  294498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  294509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  294512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294537 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294554 */     GIR_RootConstrainSelectedInstOperands,
     /*  294555 */     // GIR_Coverage, 9073,
     /*  294555 */     GIR_EraseRootFromParent_Done,
     /*  294556 */   // Label 5499: @294556
     /*  294556 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(294619), // Rule ID 9076 //
     /*  294561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294617 */     GIR_RootConstrainSelectedInstOperands,
     /*  294618 */     // GIR_Coverage, 9076,
     /*  294618 */     GIR_EraseRootFromParent_Done,
     /*  294619 */   // Label 5500: @294619
     /*  294619 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(294682), // Rule ID 9077 //
     /*  294624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  294638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294663 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294680 */     GIR_RootConstrainSelectedInstOperands,
     /*  294681 */     // GIR_Coverage, 9077,
     /*  294681 */     GIR_EraseRootFromParent_Done,
     /*  294682 */   // Label 5501: @294682
     /*  294682 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(294745), // Rule ID 9080 //
     /*  294687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294726 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294743 */     GIR_RootConstrainSelectedInstOperands,
     /*  294744 */     // GIR_Coverage, 9080,
     /*  294744 */     GIR_EraseRootFromParent_Done,
     /*  294745 */   // Label 5502: @294745
     /*  294745 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(294808), // Rule ID 9081 //
     /*  294750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  294764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294789 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  294792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294806 */     GIR_RootConstrainSelectedInstOperands,
     /*  294807 */     // GIR_Coverage, 9081,
     /*  294807 */     GIR_EraseRootFromParent_Done,
     /*  294808 */   // Label 5503: @294808
     /*  294808 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(294871), // Rule ID 9084 //
     /*  294813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294852 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294869 */     GIR_RootConstrainSelectedInstOperands,
     /*  294870 */     // GIR_Coverage, 9084,
     /*  294870 */     GIR_EraseRootFromParent_Done,
     /*  294871 */   // Label 5504: @294871
     /*  294871 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(294934), // Rule ID 9085 //
     /*  294876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  294887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  294890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294915 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  294918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294932 */     GIR_RootConstrainSelectedInstOperands,
     /*  294933 */     // GIR_Coverage, 9085,
     /*  294933 */     GIR_EraseRootFromParent_Done,
     /*  294934 */   // Label 5505: @294934
     /*  294934 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(294997), // Rule ID 9088 //
     /*  294939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  294947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  294953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  294981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294995 */     GIR_RootConstrainSelectedInstOperands,
     /*  294996 */     // GIR_Coverage, 9088,
     /*  294996 */     GIR_EraseRootFromParent_Done,
     /*  294997 */   // Label 5506: @294997
     /*  294997 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(295060), // Rule ID 9089 //
     /*  295002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  295016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295041 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295058 */     GIR_RootConstrainSelectedInstOperands,
     /*  295059 */     // GIR_Coverage, 9089,
     /*  295059 */     GIR_EraseRootFromParent_Done,
     /*  295060 */   // Label 5507: @295060
     /*  295060 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(295123), // Rule ID 9092 //
     /*  295065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  295079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295121 */     GIR_RootConstrainSelectedInstOperands,
     /*  295122 */     // GIR_Coverage, 9092,
     /*  295122 */     GIR_EraseRootFromParent_Done,
     /*  295123 */   // Label 5508: @295123
     /*  295123 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(295186), // Rule ID 9093 //
     /*  295128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  295142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295167 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295184 */     GIR_RootConstrainSelectedInstOperands,
     /*  295185 */     // GIR_Coverage, 9093,
     /*  295185 */     GIR_EraseRootFromParent_Done,
     /*  295186 */   // Label 5509: @295186
     /*  295186 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(295249), // Rule ID 9096 //
     /*  295191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  295205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295230 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295247 */     GIR_RootConstrainSelectedInstOperands,
     /*  295248 */     // GIR_Coverage, 9096,
     /*  295248 */     GIR_EraseRootFromParent_Done,
     /*  295249 */   // Label 5510: @295249
     /*  295249 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(295312), // Rule ID 9097 //
     /*  295254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  295268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295310 */     GIR_RootConstrainSelectedInstOperands,
     /*  295311 */     // GIR_Coverage, 9097,
     /*  295311 */     GIR_EraseRootFromParent_Done,
     /*  295312 */   // Label 5511: @295312
     /*  295312 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(295375), // Rule ID 9100 //
     /*  295317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  295331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295373 */     GIR_RootConstrainSelectedInstOperands,
     /*  295374 */     // GIR_Coverage, 9100,
     /*  295374 */     GIR_EraseRootFromParent_Done,
     /*  295375 */   // Label 5512: @295375
     /*  295375 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(295438), // Rule ID 9101 //
     /*  295380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  295394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  295422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295436 */     GIR_RootConstrainSelectedInstOperands,
     /*  295437 */     // GIR_Coverage, 9101,
     /*  295437 */     GIR_EraseRootFromParent_Done,
     /*  295438 */   // Label 5513: @295438
     /*  295438 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(295501), // Rule ID 9104 //
     /*  295443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  295457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295499 */     GIR_RootConstrainSelectedInstOperands,
     /*  295500 */     // GIR_Coverage, 9104,
     /*  295500 */     GIR_EraseRootFromParent_Done,
     /*  295501 */   // Label 5514: @295501
     /*  295501 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(295564), // Rule ID 9105 //
     /*  295506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  295520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295545 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  295548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295562 */     GIR_RootConstrainSelectedInstOperands,
     /*  295563 */     // GIR_Coverage, 9105,
     /*  295563 */     GIR_EraseRootFromParent_Done,
     /*  295564 */   // Label 5515: @295564
     /*  295564 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(295627), // Rule ID 9108 //
     /*  295569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295625 */     GIR_RootConstrainSelectedInstOperands,
     /*  295626 */     // GIR_Coverage, 9108,
     /*  295626 */     GIR_EraseRootFromParent_Done,
     /*  295627 */   // Label 5516: @295627
     /*  295627 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(295690), // Rule ID 9109 //
     /*  295632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  295640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  295646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  295674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295688 */     GIR_RootConstrainSelectedInstOperands,
     /*  295689 */     // GIR_Coverage, 9109,
     /*  295689 */     GIR_EraseRootFromParent_Done,
     /*  295690 */   // Label 5517: @295690
     /*  295690 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(295753), // Rule ID 9200 //
     /*  295695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  295737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295751 */     GIR_RootConstrainSelectedInstOperands,
     /*  295752 */     // GIR_Coverage, 9200,
     /*  295752 */     GIR_EraseRootFromParent_Done,
     /*  295753 */   // Label 5518: @295753
     /*  295753 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(295816), // Rule ID 9201 //
     /*  295758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  295772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295797 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  295800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295814 */     GIR_RootConstrainSelectedInstOperands,
     /*  295815 */     // GIR_Coverage, 9201,
     /*  295815 */     GIR_EraseRootFromParent_Done,
     /*  295816 */   // Label 5519: @295816
     /*  295816 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(295879), // Rule ID 9204 //
     /*  295821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  295863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295877 */     GIR_RootConstrainSelectedInstOperands,
     /*  295878 */     // GIR_Coverage, 9204,
     /*  295878 */     GIR_EraseRootFromParent_Done,
     /*  295879 */   // Label 5520: @295879
     /*  295879 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(295942), // Rule ID 9205 //
     /*  295884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  295898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  295926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295940 */     GIR_RootConstrainSelectedInstOperands,
     /*  295941 */     // GIR_Coverage, 9205,
     /*  295941 */     GIR_EraseRootFromParent_Done,
     /*  295942 */   // Label 5521: @295942
     /*  295942 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(296005), // Rule ID 9208 //
     /*  295947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  295955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  295961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295986 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  295989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296003 */     GIR_RootConstrainSelectedInstOperands,
     /*  296004 */     // GIR_Coverage, 9208,
     /*  296004 */     GIR_EraseRootFromParent_Done,
     /*  296005 */   // Label 5522: @296005
     /*  296005 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(296068), // Rule ID 9209 //
     /*  296010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  296024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296049 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296066 */     GIR_RootConstrainSelectedInstOperands,
     /*  296067 */     // GIR_Coverage, 9209,
     /*  296067 */     GIR_EraseRootFromParent_Done,
     /*  296068 */   // Label 5523: @296068
     /*  296068 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(296131), // Rule ID 9212 //
     /*  296073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  296087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  296115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296129 */     GIR_RootConstrainSelectedInstOperands,
     /*  296130 */     // GIR_Coverage, 9212,
     /*  296130 */     GIR_EraseRootFromParent_Done,
     /*  296131 */   // Label 5524: @296131
     /*  296131 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(296194), // Rule ID 9213 //
     /*  296136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  296150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296175 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  296178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296192 */     GIR_RootConstrainSelectedInstOperands,
     /*  296193 */     // GIR_Coverage, 9213,
     /*  296193 */     GIR_EraseRootFromParent_Done,
     /*  296194 */   // Label 5525: @296194
     /*  296194 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(296257), // Rule ID 9216 //
     /*  296199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  296213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296255 */     GIR_RootConstrainSelectedInstOperands,
     /*  296256 */     // GIR_Coverage, 9216,
     /*  296256 */     GIR_EraseRootFromParent_Done,
     /*  296257 */   // Label 5526: @296257
     /*  296257 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(296320), // Rule ID 9217 //
     /*  296262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  296276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296301 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296318 */     GIR_RootConstrainSelectedInstOperands,
     /*  296319 */     // GIR_Coverage, 9217,
     /*  296319 */     GIR_EraseRootFromParent_Done,
     /*  296320 */   // Label 5527: @296320
     /*  296320 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(296383), // Rule ID 9220 //
     /*  296325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  296339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296381 */     GIR_RootConstrainSelectedInstOperands,
     /*  296382 */     // GIR_Coverage, 9220,
     /*  296382 */     GIR_EraseRootFromParent_Done,
     /*  296383 */   // Label 5528: @296383
     /*  296383 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(296446), // Rule ID 9221 //
     /*  296388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  296402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296427 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  296430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296444 */     GIR_RootConstrainSelectedInstOperands,
     /*  296445 */     // GIR_Coverage, 9221,
     /*  296445 */     GIR_EraseRootFromParent_Done,
     /*  296446 */   // Label 5529: @296446
     /*  296446 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(296509), // Rule ID 9224 //
     /*  296451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  296465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296507 */     GIR_RootConstrainSelectedInstOperands,
     /*  296508 */     // GIR_Coverage, 9224,
     /*  296508 */     GIR_EraseRootFromParent_Done,
     /*  296509 */   // Label 5530: @296509
     /*  296509 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(296572), // Rule ID 9225 //
     /*  296514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  296528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296570 */     GIR_RootConstrainSelectedInstOperands,
     /*  296571 */     // GIR_Coverage, 9225,
     /*  296571 */     GIR_EraseRootFromParent_Done,
     /*  296572 */   // Label 5531: @296572
     /*  296572 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(296635), // Rule ID 9228 //
     /*  296577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296633 */     GIR_RootConstrainSelectedInstOperands,
     /*  296634 */     // GIR_Coverage, 9228,
     /*  296634 */     GIR_EraseRootFromParent_Done,
     /*  296635 */   // Label 5532: @296635
     /*  296635 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(296698), // Rule ID 9229 //
     /*  296640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  296654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296679 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296696 */     GIR_RootConstrainSelectedInstOperands,
     /*  296697 */     // GIR_Coverage, 9229,
     /*  296697 */     GIR_EraseRootFromParent_Done,
     /*  296698 */   // Label 5533: @296698
     /*  296698 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(296761), // Rule ID 9232 //
     /*  296703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296759 */     GIR_RootConstrainSelectedInstOperands,
     /*  296760 */     // GIR_Coverage, 9232,
     /*  296760 */     GIR_EraseRootFromParent_Done,
     /*  296761 */   // Label 5534: @296761
     /*  296761 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(296824), // Rule ID 9233 //
     /*  296766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  296780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296805 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296822 */     GIR_RootConstrainSelectedInstOperands,
     /*  296823 */     // GIR_Coverage, 9233,
     /*  296823 */     GIR_EraseRootFromParent_Done,
     /*  296824 */   // Label 5535: @296824
     /*  296824 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(296887), // Rule ID 9236 //
     /*  296829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296885 */     GIR_RootConstrainSelectedInstOperands,
     /*  296886 */     // GIR_Coverage, 9236,
     /*  296886 */     GIR_EraseRootFromParent_Done,
     /*  296887 */   // Label 5536: @296887
     /*  296887 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(296950), // Rule ID 9237 //
     /*  296892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  296903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  296906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296931 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  296934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296948 */     GIR_RootConstrainSelectedInstOperands,
     /*  296949 */     // GIR_Coverage, 9237,
     /*  296949 */     GIR_EraseRootFromParent_Done,
     /*  296950 */   // Label 5537: @296950
     /*  296950 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(297013), // Rule ID 9240 //
     /*  296955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  296969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  296997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297011 */     GIR_RootConstrainSelectedInstOperands,
     /*  297012 */     // GIR_Coverage, 9240,
     /*  297012 */     GIR_EraseRootFromParent_Done,
     /*  297013 */   // Label 5538: @297013
     /*  297013 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(297076), // Rule ID 9241 //
     /*  297018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  297032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297057 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297074 */     GIR_RootConstrainSelectedInstOperands,
     /*  297075 */     // GIR_Coverage, 9241,
     /*  297075 */     GIR_EraseRootFromParent_Done,
     /*  297076 */   // Label 5539: @297076
     /*  297076 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(297139), // Rule ID 9244 //
     /*  297081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  297095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297120 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297137 */     GIR_RootConstrainSelectedInstOperands,
     /*  297138 */     // GIR_Coverage, 9244,
     /*  297138 */     GIR_EraseRootFromParent_Done,
     /*  297139 */   // Label 5540: @297139
     /*  297139 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(297202), // Rule ID 9245 //
     /*  297144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  297158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297183 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297200 */     GIR_RootConstrainSelectedInstOperands,
     /*  297201 */     // GIR_Coverage, 9245,
     /*  297201 */     GIR_EraseRootFromParent_Done,
     /*  297202 */   // Label 5541: @297202
     /*  297202 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(297265), // Rule ID 9248 //
     /*  297207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  297218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  297221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297246 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297263 */     GIR_RootConstrainSelectedInstOperands,
     /*  297264 */     // GIR_Coverage, 9248,
     /*  297264 */     GIR_EraseRootFromParent_Done,
     /*  297265 */   // Label 5542: @297265
     /*  297265 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(297328), // Rule ID 9249 //
     /*  297270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  297281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  297284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297309 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297326 */     GIR_RootConstrainSelectedInstOperands,
     /*  297327 */     // GIR_Coverage, 9249,
     /*  297327 */     GIR_EraseRootFromParent_Done,
     /*  297328 */   // Label 5543: @297328
     /*  297328 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(297391), // Rule ID 9252 //
     /*  297333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  297347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297389 */     GIR_RootConstrainSelectedInstOperands,
     /*  297390 */     // GIR_Coverage, 9252,
     /*  297390 */     GIR_EraseRootFromParent_Done,
     /*  297391 */   // Label 5544: @297391
     /*  297391 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(297454), // Rule ID 9253 //
     /*  297396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  297410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297435 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297452 */     GIR_RootConstrainSelectedInstOperands,
     /*  297453 */     // GIR_Coverage, 9253,
     /*  297453 */     GIR_EraseRootFromParent_Done,
     /*  297454 */   // Label 5545: @297454
     /*  297454 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(297517), // Rule ID 9256 //
     /*  297459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  297473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297498 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297515 */     GIR_RootConstrainSelectedInstOperands,
     /*  297516 */     // GIR_Coverage, 9256,
     /*  297516 */     GIR_EraseRootFromParent_Done,
     /*  297517 */   // Label 5546: @297517
     /*  297517 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(297580), // Rule ID 9257 //
     /*  297522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  297536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297561 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297578 */     GIR_RootConstrainSelectedInstOperands,
     /*  297579 */     // GIR_Coverage, 9257,
     /*  297579 */     GIR_EraseRootFromParent_Done,
     /*  297580 */   // Label 5547: @297580
     /*  297580 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(297643), // Rule ID 9260 //
     /*  297585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297641 */     GIR_RootConstrainSelectedInstOperands,
     /*  297642 */     // GIR_Coverage, 9260,
     /*  297642 */     GIR_EraseRootFromParent_Done,
     /*  297643 */   // Label 5548: @297643
     /*  297643 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(297706), // Rule ID 9261 //
     /*  297648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  297659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  297662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297687 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  297690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297704 */     GIR_RootConstrainSelectedInstOperands,
     /*  297705 */     // GIR_Coverage, 9261,
     /*  297705 */     GIR_EraseRootFromParent_Done,
     /*  297706 */   // Label 5549: @297706
     /*  297706 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(297769), // Rule ID 9264 //
     /*  297711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297767 */     GIR_RootConstrainSelectedInstOperands,
     /*  297768 */     // GIR_Coverage, 9264,
     /*  297768 */     GIR_EraseRootFromParent_Done,
     /*  297769 */   // Label 5550: @297769
     /*  297769 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(297832), // Rule ID 9265 //
     /*  297774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  297788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297813 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  297816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297830 */     GIR_RootConstrainSelectedInstOperands,
     /*  297831 */     // GIR_Coverage, 9265,
     /*  297831 */     GIR_EraseRootFromParent_Done,
     /*  297832 */   // Label 5551: @297832
     /*  297832 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(297895), // Rule ID 9268 //
     /*  297837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297893 */     GIR_RootConstrainSelectedInstOperands,
     /*  297894 */     // GIR_Coverage, 9268,
     /*  297894 */     GIR_EraseRootFromParent_Done,
     /*  297895 */   // Label 5552: @297895
     /*  297895 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(297958), // Rule ID 9269 //
     /*  297900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  297914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297939 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  297942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297956 */     GIR_RootConstrainSelectedInstOperands,
     /*  297957 */     // GIR_Coverage, 9269,
     /*  297957 */     GIR_EraseRootFromParent_Done,
     /*  297958 */   // Label 5553: @297958
     /*  297958 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(298021), // Rule ID 9272 //
     /*  297963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  297974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  297977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298019 */     GIR_RootConstrainSelectedInstOperands,
     /*  298020 */     // GIR_Coverage, 9272,
     /*  298020 */     GIR_EraseRootFromParent_Done,
     /*  298021 */   // Label 5554: @298021
     /*  298021 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(298084), // Rule ID 9273 //
     /*  298026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  298040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298065 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298082 */     GIR_RootConstrainSelectedInstOperands,
     /*  298083 */     // GIR_Coverage, 9273,
     /*  298083 */     GIR_EraseRootFromParent_Done,
     /*  298084 */   // Label 5555: @298084
     /*  298084 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(298147), // Rule ID 9276 //
     /*  298089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  298103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  298131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298145 */     GIR_RootConstrainSelectedInstOperands,
     /*  298146 */     // GIR_Coverage, 9276,
     /*  298146 */     GIR_EraseRootFromParent_Done,
     /*  298147 */   // Label 5556: @298147
     /*  298147 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(298210), // Rule ID 9277 //
     /*  298152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  298166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  298194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298208 */     GIR_RootConstrainSelectedInstOperands,
     /*  298209 */     // GIR_Coverage, 9277,
     /*  298209 */     GIR_EraseRootFromParent_Done,
     /*  298210 */   // Label 5557: @298210
     /*  298210 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(298273), // Rule ID 9280 //
     /*  298215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  298229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  298257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298271 */     GIR_RootConstrainSelectedInstOperands,
     /*  298272 */     // GIR_Coverage, 9280,
     /*  298272 */     GIR_EraseRootFromParent_Done,
     /*  298273 */   // Label 5558: @298273
     /*  298273 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(298336), // Rule ID 9281 //
     /*  298278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  298292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298317 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  298320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298334 */     GIR_RootConstrainSelectedInstOperands,
     /*  298335 */     // GIR_Coverage, 9281,
     /*  298335 */     GIR_EraseRootFromParent_Done,
     /*  298336 */   // Label 5559: @298336
     /*  298336 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(298399), // Rule ID 9284 //
     /*  298341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  298355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298397 */     GIR_RootConstrainSelectedInstOperands,
     /*  298398 */     // GIR_Coverage, 9284,
     /*  298398 */     GIR_EraseRootFromParent_Done,
     /*  298399 */   // Label 5560: @298399
     /*  298399 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(298462), // Rule ID 9285 //
     /*  298404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  298418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  298446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298460 */     GIR_RootConstrainSelectedInstOperands,
     /*  298461 */     // GIR_Coverage, 9285,
     /*  298461 */     GIR_EraseRootFromParent_Done,
     /*  298462 */   // Label 5561: @298462
     /*  298462 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(298525), // Rule ID 9376 //
     /*  298467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  298481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298506 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  298509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298523 */     GIR_RootConstrainSelectedInstOperands,
     /*  298524 */     // GIR_Coverage, 9376,
     /*  298524 */     GIR_EraseRootFromParent_Done,
     /*  298525 */   // Label 5562: @298525
     /*  298525 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(298588), // Rule ID 9377 //
     /*  298530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  298544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298569 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  298572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298586 */     GIR_RootConstrainSelectedInstOperands,
     /*  298587 */     // GIR_Coverage, 9377,
     /*  298587 */     GIR_EraseRootFromParent_Done,
     /*  298588 */   // Label 5563: @298588
     /*  298588 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(298651), // Rule ID 9380 //
     /*  298593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  298607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298649 */     GIR_RootConstrainSelectedInstOperands,
     /*  298650 */     // GIR_Coverage, 9380,
     /*  298650 */     GIR_EraseRootFromParent_Done,
     /*  298651 */   // Label 5564: @298651
     /*  298651 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(298714), // Rule ID 9381 //
     /*  298656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  298670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298712 */     GIR_RootConstrainSelectedInstOperands,
     /*  298713 */     // GIR_Coverage, 9381,
     /*  298713 */     GIR_EraseRootFromParent_Done,
     /*  298714 */   // Label 5565: @298714
     /*  298714 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(298777), // Rule ID 9384 //
     /*  298719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298758 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  298761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298775 */     GIR_RootConstrainSelectedInstOperands,
     /*  298776 */     // GIR_Coverage, 9384,
     /*  298776 */     GIR_EraseRootFromParent_Done,
     /*  298777 */   // Label 5566: @298777
     /*  298777 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(298840), // Rule ID 9385 //
     /*  298782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  298796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298821 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  298824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298838 */     GIR_RootConstrainSelectedInstOperands,
     /*  298839 */     // GIR_Coverage, 9385,
     /*  298839 */     GIR_EraseRootFromParent_Done,
     /*  298840 */   // Label 5567: @298840
     /*  298840 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(298903), // Rule ID 9388 //
     /*  298845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298901 */     GIR_RootConstrainSelectedInstOperands,
     /*  298902 */     // GIR_Coverage, 9388,
     /*  298902 */     GIR_EraseRootFromParent_Done,
     /*  298903 */   // Label 5568: @298903
     /*  298903 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(298966), // Rule ID 9389 //
     /*  298908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  298922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  298925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  298940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298947 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  298950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  298954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  298956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298964 */     GIR_RootConstrainSelectedInstOperands,
     /*  298965 */     // GIR_Coverage, 9389,
     /*  298965 */     GIR_EraseRootFromParent_Done,
     /*  298966 */   // Label 5569: @298966
     /*  298966 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(299029), // Rule ID 9392 //
     /*  298971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  298979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  298985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  298988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299027 */     GIR_RootConstrainSelectedInstOperands,
     /*  299028 */     // GIR_Coverage, 9392,
     /*  299028 */     GIR_EraseRootFromParent_Done,
     /*  299029 */   // Label 5570: @299029
     /*  299029 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(299092), // Rule ID 9393 //
     /*  299034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  299048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299073 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299090 */     GIR_RootConstrainSelectedInstOperands,
     /*  299091 */     // GIR_Coverage, 9393,
     /*  299091 */     GIR_EraseRootFromParent_Done,
     /*  299092 */   // Label 5571: @299092
     /*  299092 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(299155), // Rule ID 9396 //
     /*  299097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  299111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299153 */     GIR_RootConstrainSelectedInstOperands,
     /*  299154 */     // GIR_Coverage, 9396,
     /*  299154 */     GIR_EraseRootFromParent_Done,
     /*  299155 */   // Label 5572: @299155
     /*  299155 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(299218), // Rule ID 9397 //
     /*  299160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  299174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  299202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299216 */     GIR_RootConstrainSelectedInstOperands,
     /*  299217 */     // GIR_Coverage, 9397,
     /*  299217 */     GIR_EraseRootFromParent_Done,
     /*  299218 */   // Label 5573: @299218
     /*  299218 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(299281), // Rule ID 9400 //
     /*  299223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  299237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299279 */     GIR_RootConstrainSelectedInstOperands,
     /*  299280 */     // GIR_Coverage, 9400,
     /*  299280 */     GIR_EraseRootFromParent_Done,
     /*  299281 */   // Label 5574: @299281
     /*  299281 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(299344), // Rule ID 9401 //
     /*  299286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  299300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299342 */     GIR_RootConstrainSelectedInstOperands,
     /*  299343 */     // GIR_Coverage, 9401,
     /*  299343 */     GIR_EraseRootFromParent_Done,
     /*  299344 */   // Label 5575: @299344
     /*  299344 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(299407), // Rule ID 9404 //
     /*  299349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  299363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299405 */     GIR_RootConstrainSelectedInstOperands,
     /*  299406 */     // GIR_Coverage, 9404,
     /*  299406 */     GIR_EraseRootFromParent_Done,
     /*  299407 */   // Label 5576: @299407
     /*  299407 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(299470), // Rule ID 9405 //
     /*  299412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  299426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299451 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299468 */     GIR_RootConstrainSelectedInstOperands,
     /*  299469 */     // GIR_Coverage, 9405,
     /*  299469 */     GIR_EraseRootFromParent_Done,
     /*  299470 */   // Label 5577: @299470
     /*  299470 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(299533), // Rule ID 9408 //
     /*  299475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  299489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299531 */     GIR_RootConstrainSelectedInstOperands,
     /*  299532 */     // GIR_Coverage, 9408,
     /*  299532 */     GIR_EraseRootFromParent_Done,
     /*  299533 */   // Label 5578: @299533
     /*  299533 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(299596), // Rule ID 9409 //
     /*  299538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  299552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299577 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299594 */     GIR_RootConstrainSelectedInstOperands,
     /*  299595 */     // GIR_Coverage, 9409,
     /*  299595 */     GIR_EraseRootFromParent_Done,
     /*  299596 */   // Label 5579: @299596
     /*  299596 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(299659), // Rule ID 9412 //
     /*  299601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  299615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299657 */     GIR_RootConstrainSelectedInstOperands,
     /*  299658 */     // GIR_Coverage, 9412,
     /*  299658 */     GIR_EraseRootFromParent_Done,
     /*  299659 */   // Label 5580: @299659
     /*  299659 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(299722), // Rule ID 9413 //
     /*  299664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  299678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299703 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  299706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299720 */     GIR_RootConstrainSelectedInstOperands,
     /*  299721 */     // GIR_Coverage, 9413,
     /*  299721 */     GIR_EraseRootFromParent_Done,
     /*  299722 */   // Label 5581: @299722
     /*  299722 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(299785), // Rule ID 9416 //
     /*  299727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  299769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299783 */     GIR_RootConstrainSelectedInstOperands,
     /*  299784 */     // GIR_Coverage, 9416,
     /*  299784 */     GIR_EraseRootFromParent_Done,
     /*  299785 */   // Label 5582: @299785
     /*  299785 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(299848), // Rule ID 9417 //
     /*  299790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  299804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299829 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  299832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299846 */     GIR_RootConstrainSelectedInstOperands,
     /*  299847 */     // GIR_Coverage, 9417,
     /*  299847 */     GIR_EraseRootFromParent_Done,
     /*  299848 */   // Label 5583: @299848
     /*  299848 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(299911), // Rule ID 9420 //
     /*  299853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299892 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  299895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299909 */     GIR_RootConstrainSelectedInstOperands,
     /*  299910 */     // GIR_Coverage, 9420,
     /*  299910 */     GIR_EraseRootFromParent_Done,
     /*  299911 */   // Label 5584: @299911
     /*  299911 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(299974), // Rule ID 9421 //
     /*  299916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  299930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  299933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  299948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299955 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  299958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  299962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  299964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299972 */     GIR_RootConstrainSelectedInstOperands,
     /*  299973 */     // GIR_Coverage, 9421,
     /*  299973 */     GIR_EraseRootFromParent_Done,
     /*  299974 */   // Label 5585: @299974
     /*  299974 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(300037), // Rule ID 9424 //
     /*  299979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  299990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  299993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  299996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300018 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300035 */     GIR_RootConstrainSelectedInstOperands,
     /*  300036 */     // GIR_Coverage, 9424,
     /*  300036 */     GIR_EraseRootFromParent_Done,
     /*  300037 */   // Label 5586: @300037
     /*  300037 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(300100), // Rule ID 9425 //
     /*  300042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  300053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  300056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300081 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300098 */     GIR_RootConstrainSelectedInstOperands,
     /*  300099 */     // GIR_Coverage, 9425,
     /*  300099 */     GIR_EraseRootFromParent_Done,
     /*  300100 */   // Label 5587: @300100
     /*  300100 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(300163), // Rule ID 9428 //
     /*  300105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  300119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300161 */     GIR_RootConstrainSelectedInstOperands,
     /*  300162 */     // GIR_Coverage, 9428,
     /*  300162 */     GIR_EraseRootFromParent_Done,
     /*  300163 */   // Label 5588: @300163
     /*  300163 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(300226), // Rule ID 9429 //
     /*  300168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  300182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300224 */     GIR_RootConstrainSelectedInstOperands,
     /*  300225 */     // GIR_Coverage, 9429,
     /*  300225 */     GIR_EraseRootFromParent_Done,
     /*  300226 */   // Label 5589: @300226
     /*  300226 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(300289), // Rule ID 9432 //
     /*  300231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  300245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300270 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300287 */     GIR_RootConstrainSelectedInstOperands,
     /*  300288 */     // GIR_Coverage, 9432,
     /*  300288 */     GIR_EraseRootFromParent_Done,
     /*  300289 */   // Label 5590: @300289
     /*  300289 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(300352), // Rule ID 9433 //
     /*  300294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  300308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300333 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300350 */     GIR_RootConstrainSelectedInstOperands,
     /*  300351 */     // GIR_Coverage, 9433,
     /*  300351 */     GIR_EraseRootFromParent_Done,
     /*  300352 */   // Label 5591: @300352
     /*  300352 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(300415), // Rule ID 9436 //
     /*  300357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  300371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300396 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300413 */     GIR_RootConstrainSelectedInstOperands,
     /*  300414 */     // GIR_Coverage, 9436,
     /*  300414 */     GIR_EraseRootFromParent_Done,
     /*  300415 */   // Label 5592: @300415
     /*  300415 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(300478), // Rule ID 9437 //
     /*  300420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  300434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300459 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300476 */     GIR_RootConstrainSelectedInstOperands,
     /*  300477 */     // GIR_Coverage, 9437,
     /*  300477 */     GIR_EraseRootFromParent_Done,
     /*  300478 */   // Label 5593: @300478
     /*  300478 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(300541), // Rule ID 9440 //
     /*  300483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  300497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300539 */     GIR_RootConstrainSelectedInstOperands,
     /*  300540 */     // GIR_Coverage, 9440,
     /*  300540 */     GIR_EraseRootFromParent_Done,
     /*  300541 */   // Label 5594: @300541
     /*  300541 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(300604), // Rule ID 9441 //
     /*  300546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  300560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300585 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300602 */     GIR_RootConstrainSelectedInstOperands,
     /*  300603 */     // GIR_Coverage, 9441,
     /*  300603 */     GIR_EraseRootFromParent_Done,
     /*  300604 */   // Label 5595: @300604
     /*  300604 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(300667), // Rule ID 9444 //
     /*  300609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  300623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300648 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300665 */     GIR_RootConstrainSelectedInstOperands,
     /*  300666 */     // GIR_Coverage, 9444,
     /*  300666 */     GIR_EraseRootFromParent_Done,
     /*  300667 */   // Label 5596: @300667
     /*  300667 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(300730), // Rule ID 9445 //
     /*  300672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  300686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300711 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  300714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300728 */     GIR_RootConstrainSelectedInstOperands,
     /*  300729 */     // GIR_Coverage, 9445,
     /*  300729 */     GIR_EraseRootFromParent_Done,
     /*  300730 */   // Label 5597: @300730
     /*  300730 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(300793), // Rule ID 9448 //
     /*  300735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300774 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300791 */     GIR_RootConstrainSelectedInstOperands,
     /*  300792 */     // GIR_Coverage, 9448,
     /*  300792 */     GIR_EraseRootFromParent_Done,
     /*  300793 */   // Label 5598: @300793
     /*  300793 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(300856), // Rule ID 9449 //
     /*  300798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  300812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300837 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  300840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300854 */     GIR_RootConstrainSelectedInstOperands,
     /*  300855 */     // GIR_Coverage, 9449,
     /*  300855 */     GIR_EraseRootFromParent_Done,
     /*  300856 */   // Label 5599: @300856
     /*  300856 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(300919), // Rule ID 9452 //
     /*  300861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  300878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300917 */     GIR_RootConstrainSelectedInstOperands,
     /*  300918 */     // GIR_Coverage, 9452,
     /*  300918 */     GIR_EraseRootFromParent_Done,
     /*  300919 */   // Label 5600: @300919
     /*  300919 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(300982), // Rule ID 9453 //
     /*  300924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  300938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  300941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  300956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  300966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  300970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  300972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300980 */     GIR_RootConstrainSelectedInstOperands,
     /*  300981 */     // GIR_Coverage, 9453,
     /*  300981 */     GIR_EraseRootFromParent_Done,
     /*  300982 */   // Label 5601: @300982
     /*  300982 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(301045), // Rule ID 9456 //
     /*  300987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  301001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  301004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  301029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301043 */     GIR_RootConstrainSelectedInstOperands,
     /*  301044 */     // GIR_Coverage, 9456,
     /*  301044 */     GIR_EraseRootFromParent_Done,
     /*  301045 */   // Label 5602: @301045
     /*  301045 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(301108), // Rule ID 9457 //
     /*  301050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  301064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  301067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301089 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  301092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301106 */     GIR_RootConstrainSelectedInstOperands,
     /*  301107 */     // GIR_Coverage, 9457,
     /*  301107 */     GIR_EraseRootFromParent_Done,
     /*  301108 */   // Label 5603: @301108
     /*  301108 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(301171), // Rule ID 9460 //
     /*  301113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  301127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  301130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  301155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301169 */     GIR_RootConstrainSelectedInstOperands,
     /*  301170 */     // GIR_Coverage, 9460,
     /*  301170 */     GIR_EraseRootFromParent_Done,
     /*  301171 */   // Label 5604: @301171
     /*  301171 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(301234), // Rule ID 9461 //
     /*  301176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  301190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  301193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  301208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301215 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  301218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  301222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  301224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301232 */     GIR_RootConstrainSelectedInstOperands,
     /*  301233 */     // GIR_Coverage, 9461,
     /*  301233 */     GIR_EraseRootFromParent_Done,
     /*  301234 */   // Label 5605: @301234
     /*  301234 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(301297), // Rule ID 9552 //
     /*  301239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  301253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  301256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301295 */     GIR_RootConstrainSelectedInstOperands,
     /*  301296 */     // GIR_Coverage, 9552,
     /*  301296 */     GIR_EraseRootFromParent_Done,
     /*  301297 */   // Label 5606: @301297
     /*  301297 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(301360), // Rule ID 9553 //
     /*  301302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  301316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  301319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301341 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301358 */     GIR_RootConstrainSelectedInstOperands,
     /*  301359 */     // GIR_Coverage, 9553,
     /*  301359 */     GIR_EraseRootFromParent_Done,
     /*  301360 */   // Label 5607: @301360
     /*  301360 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(301423), // Rule ID 9556 //
     /*  301365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  301379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  301382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301421 */     GIR_RootConstrainSelectedInstOperands,
     /*  301422 */     // GIR_Coverage, 9556,
     /*  301422 */     GIR_EraseRootFromParent_Done,
     /*  301423 */   // Label 5608: @301423
     /*  301423 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(301486), // Rule ID 9557 //
     /*  301428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  301442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  301445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301467 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301484 */     GIR_RootConstrainSelectedInstOperands,
     /*  301485 */     // GIR_Coverage, 9557,
     /*  301485 */     GIR_EraseRootFromParent_Done,
     /*  301486 */   // Label 5609: @301486
     /*  301486 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(301549), // Rule ID 9560 //
     /*  301491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  301505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  301508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301530 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301547 */     GIR_RootConstrainSelectedInstOperands,
     /*  301548 */     // GIR_Coverage, 9560,
     /*  301548 */     GIR_EraseRootFromParent_Done,
     /*  301549 */   // Label 5610: @301549
     /*  301549 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(301612), // Rule ID 9561 //
     /*  301554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  301568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  301571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301593 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  301596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301610 */     GIR_RootConstrainSelectedInstOperands,
     /*  301611 */     // GIR_Coverage, 9561,
     /*  301611 */     GIR_EraseRootFromParent_Done,
     /*  301612 */   // Label 5611: @301612
     /*  301612 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(301675), // Rule ID 9564 //
     /*  301617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301673 */     GIR_RootConstrainSelectedInstOperands,
     /*  301674 */     // GIR_Coverage, 9564,
     /*  301674 */     GIR_EraseRootFromParent_Done,
     /*  301675 */   // Label 5612: @301675
     /*  301675 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(301738), // Rule ID 9565 //
     /*  301680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  301694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  301697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301719 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301736 */     GIR_RootConstrainSelectedInstOperands,
     /*  301737 */     // GIR_Coverage, 9565,
     /*  301737 */     GIR_EraseRootFromParent_Done,
     /*  301738 */   // Label 5613: @301738
     /*  301738 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(301801), // Rule ID 9568 //
     /*  301743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301799 */     GIR_RootConstrainSelectedInstOperands,
     /*  301800 */     // GIR_Coverage, 9568,
     /*  301800 */     GIR_EraseRootFromParent_Done,
     /*  301801 */   // Label 5614: @301801
     /*  301801 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(301864), // Rule ID 9569 //
     /*  301806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  301820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  301823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301845 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  301848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301862 */     GIR_RootConstrainSelectedInstOperands,
     /*  301863 */     // GIR_Coverage, 9569,
     /*  301863 */     GIR_EraseRootFromParent_Done,
     /*  301864 */   // Label 5615: @301864
     /*  301864 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(301927), // Rule ID 9572 //
     /*  301869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  301911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301925 */     GIR_RootConstrainSelectedInstOperands,
     /*  301926 */     // GIR_Coverage, 9572,
     /*  301926 */     GIR_EraseRootFromParent_Done,
     /*  301927 */   // Label 5616: @301927
     /*  301927 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(301990), // Rule ID 9573 //
     /*  301932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  301940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  301946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  301949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301971 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  301974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301988 */     GIR_RootConstrainSelectedInstOperands,
     /*  301989 */     // GIR_Coverage, 9573,
     /*  301989 */     GIR_EraseRootFromParent_Done,
     /*  301990 */   // Label 5617: @301990
     /*  301990 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(302053), // Rule ID 9576 //
     /*  301995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  302009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  302012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302051 */     GIR_RootConstrainSelectedInstOperands,
     /*  302052 */     // GIR_Coverage, 9576,
     /*  302052 */     GIR_EraseRootFromParent_Done,
     /*  302053 */   // Label 5618: @302053
     /*  302053 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(302116), // Rule ID 9577 //
     /*  302058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  302072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  302075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302097 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302114 */     GIR_RootConstrainSelectedInstOperands,
     /*  302115 */     // GIR_Coverage, 9577,
     /*  302115 */     GIR_EraseRootFromParent_Done,
     /*  302116 */   // Label 5619: @302116
     /*  302116 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(302179), // Rule ID 9580 //
     /*  302121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  302135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  302138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302177 */     GIR_RootConstrainSelectedInstOperands,
     /*  302178 */     // GIR_Coverage, 9580,
     /*  302178 */     GIR_EraseRootFromParent_Done,
     /*  302179 */   // Label 5620: @302179
     /*  302179 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(302242), // Rule ID 9581 //
     /*  302184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  302198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  302201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302223 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302240 */     GIR_RootConstrainSelectedInstOperands,
     /*  302241 */     // GIR_Coverage, 9581,
     /*  302241 */     GIR_EraseRootFromParent_Done,
     /*  302242 */   // Label 5621: @302242
     /*  302242 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(302305), // Rule ID 9584 //
     /*  302247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  302261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  302264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302303 */     GIR_RootConstrainSelectedInstOperands,
     /*  302304 */     // GIR_Coverage, 9584,
     /*  302304 */     GIR_EraseRootFromParent_Done,
     /*  302305 */   // Label 5622: @302305
     /*  302305 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(302368), // Rule ID 9585 //
     /*  302310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  302324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  302327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302349 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  302352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302366 */     GIR_RootConstrainSelectedInstOperands,
     /*  302367 */     // GIR_Coverage, 9585,
     /*  302367 */     GIR_EraseRootFromParent_Done,
     /*  302368 */   // Label 5623: @302368
     /*  302368 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(302431), // Rule ID 9588 //
     /*  302373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  302387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  302390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302412 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302429 */     GIR_RootConstrainSelectedInstOperands,
     /*  302430 */     // GIR_Coverage, 9588,
     /*  302430 */     GIR_EraseRootFromParent_Done,
     /*  302431 */   // Label 5624: @302431
     /*  302431 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(302494), // Rule ID 9589 //
     /*  302436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  302450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  302453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302475 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302492 */     GIR_RootConstrainSelectedInstOperands,
     /*  302493 */     // GIR_Coverage, 9589,
     /*  302493 */     GIR_EraseRootFromParent_Done,
     /*  302494 */   // Label 5625: @302494
     /*  302494 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(302557), // Rule ID 9592 //
     /*  302499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  302513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  302516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302538 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302555 */     GIR_RootConstrainSelectedInstOperands,
     /*  302556 */     // GIR_Coverage, 9592,
     /*  302556 */     GIR_EraseRootFromParent_Done,
     /*  302557 */   // Label 5626: @302557
     /*  302557 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(302620), // Rule ID 9593 //
     /*  302562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  302576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  302579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302601 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302618 */     GIR_RootConstrainSelectedInstOperands,
     /*  302619 */     // GIR_Coverage, 9593,
     /*  302619 */     GIR_EraseRootFromParent_Done,
     /*  302620 */   // Label 5627: @302620
     /*  302620 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(302683), // Rule ID 9596 //
     /*  302625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302664 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  302667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302681 */     GIR_RootConstrainSelectedInstOperands,
     /*  302682 */     // GIR_Coverage, 9596,
     /*  302682 */     GIR_EraseRootFromParent_Done,
     /*  302683 */   // Label 5628: @302683
     /*  302683 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(302746), // Rule ID 9597 //
     /*  302688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  302699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  302702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  302705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302727 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  302730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302744 */     GIR_RootConstrainSelectedInstOperands,
     /*  302745 */     // GIR_Coverage, 9597,
     /*  302745 */     GIR_EraseRootFromParent_Done,
     /*  302746 */   // Label 5629: @302746
     /*  302746 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(302809), // Rule ID 9600 //
     /*  302751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302807 */     GIR_RootConstrainSelectedInstOperands,
     /*  302808 */     // GIR_Coverage, 9600,
     /*  302808 */     GIR_EraseRootFromParent_Done,
     /*  302809 */   // Label 5630: @302809
     /*  302809 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(302872), // Rule ID 9601 //
     /*  302814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  302828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  302831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302853 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  302856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302870 */     GIR_RootConstrainSelectedInstOperands,
     /*  302871 */     // GIR_Coverage, 9601,
     /*  302871 */     GIR_EraseRootFromParent_Done,
     /*  302872 */   // Label 5631: @302872
     /*  302872 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(302935), // Rule ID 9604 //
     /*  302877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302933 */     GIR_RootConstrainSelectedInstOperands,
     /*  302934 */     // GIR_Coverage, 9604,
     /*  302934 */     GIR_EraseRootFromParent_Done,
     /*  302935 */   // Label 5632: @302935
     /*  302935 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(302998), // Rule ID 9605 //
     /*  302940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  302948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  302954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  302957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302979 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  302982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302996 */     GIR_RootConstrainSelectedInstOperands,
     /*  302997 */     // GIR_Coverage, 9605,
     /*  302997 */     GIR_EraseRootFromParent_Done,
     /*  302998 */   // Label 5633: @302998
     /*  302998 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(303061), // Rule ID 9608 //
     /*  303003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  303017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  303020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303059 */     GIR_RootConstrainSelectedInstOperands,
     /*  303060 */     // GIR_Coverage, 9608,
     /*  303060 */     GIR_EraseRootFromParent_Done,
     /*  303061 */   // Label 5634: @303061
     /*  303061 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(303124), // Rule ID 9609 //
     /*  303066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  303080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  303083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303105 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303122 */     GIR_RootConstrainSelectedInstOperands,
     /*  303123 */     // GIR_Coverage, 9609,
     /*  303123 */     GIR_EraseRootFromParent_Done,
     /*  303124 */   // Label 5635: @303124
     /*  303124 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(303187), // Rule ID 9612 //
     /*  303129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  303143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  303146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303185 */     GIR_RootConstrainSelectedInstOperands,
     /*  303186 */     // GIR_Coverage, 9612,
     /*  303186 */     GIR_EraseRootFromParent_Done,
     /*  303187 */   // Label 5636: @303187
     /*  303187 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(303250), // Rule ID 9613 //
     /*  303192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  303206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  303209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303231 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303248 */     GIR_RootConstrainSelectedInstOperands,
     /*  303249 */     // GIR_Coverage, 9613,
     /*  303249 */     GIR_EraseRootFromParent_Done,
     /*  303250 */   // Label 5637: @303250
     /*  303250 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(303313), // Rule ID 9616 //
     /*  303255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  303269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  303272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303294 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303311 */     GIR_RootConstrainSelectedInstOperands,
     /*  303312 */     // GIR_Coverage, 9616,
     /*  303312 */     GIR_EraseRootFromParent_Done,
     /*  303313 */   // Label 5638: @303313
     /*  303313 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(303376), // Rule ID 9617 //
     /*  303318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  303332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  303335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303374 */     GIR_RootConstrainSelectedInstOperands,
     /*  303375 */     // GIR_Coverage, 9617,
     /*  303375 */     GIR_EraseRootFromParent_Done,
     /*  303376 */   // Label 5639: @303376
     /*  303376 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(303439), // Rule ID 9620 //
     /*  303381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  303395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  303398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303437 */     GIR_RootConstrainSelectedInstOperands,
     /*  303438 */     // GIR_Coverage, 9620,
     /*  303438 */     GIR_EraseRootFromParent_Done,
     /*  303439 */   // Label 5640: @303439
     /*  303439 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(303502), // Rule ID 9621 //
     /*  303444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  303458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  303461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303483 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303500 */     GIR_RootConstrainSelectedInstOperands,
     /*  303501 */     // GIR_Coverage, 9621,
     /*  303501 */     GIR_EraseRootFromParent_Done,
     /*  303502 */   // Label 5641: @303502
     /*  303502 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(303565), // Rule ID 9624 //
     /*  303507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  303521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  303524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303563 */     GIR_RootConstrainSelectedInstOperands,
     /*  303564 */     // GIR_Coverage, 9624,
     /*  303564 */     GIR_EraseRootFromParent_Done,
     /*  303565 */   // Label 5642: @303565
     /*  303565 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(303628), // Rule ID 9625 //
     /*  303570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  303584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  303587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303609 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  303612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303626 */     GIR_RootConstrainSelectedInstOperands,
     /*  303627 */     // GIR_Coverage, 9625,
     /*  303627 */     GIR_EraseRootFromParent_Done,
     /*  303628 */   // Label 5643: @303628
     /*  303628 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(303691), // Rule ID 9628 //
     /*  303633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303689 */     GIR_RootConstrainSelectedInstOperands,
     /*  303690 */     // GIR_Coverage, 9628,
     /*  303690 */     GIR_EraseRootFromParent_Done,
     /*  303691 */   // Label 5644: @303691
     /*  303691 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(303754), // Rule ID 9629 //
     /*  303696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  303710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  303713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303735 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  303738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303752 */     GIR_RootConstrainSelectedInstOperands,
     /*  303753 */     // GIR_Coverage, 9629,
     /*  303753 */     GIR_EraseRootFromParent_Done,
     /*  303754 */   // Label 5645: @303754
     /*  303754 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(303817), // Rule ID 9632 //
     /*  303759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303815 */     GIR_RootConstrainSelectedInstOperands,
     /*  303816 */     // GIR_Coverage, 9632,
     /*  303816 */     GIR_EraseRootFromParent_Done,
     /*  303817 */   // Label 5646: @303817
     /*  303817 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(303880), // Rule ID 9633 //
     /*  303822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  303830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  303836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  303839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303861 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  303864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303878 */     GIR_RootConstrainSelectedInstOperands,
     /*  303879 */     // GIR_Coverage, 9633,
     /*  303879 */     GIR_EraseRootFromParent_Done,
     /*  303880 */   // Label 5647: @303880
     /*  303880 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(303943), // Rule ID 9636 //
     /*  303885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  303927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303941 */     GIR_RootConstrainSelectedInstOperands,
     /*  303942 */     // GIR_Coverage, 9636,
     /*  303942 */     GIR_EraseRootFromParent_Done,
     /*  303943 */   // Label 5648: @303943
     /*  303943 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(304006), // Rule ID 9637 //
     /*  303948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  303956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  303962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  303965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  303990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304004 */     GIR_RootConstrainSelectedInstOperands,
     /*  304005 */     // GIR_Coverage, 9637,
     /*  304005 */     GIR_EraseRootFromParent_Done,
     /*  304006 */   // Label 5649: @304006
     /*  304006 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(304069), // Rule ID 9640 //
     /*  304011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  304025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  304028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304067 */     GIR_RootConstrainSelectedInstOperands,
     /*  304068 */     // GIR_Coverage, 9640,
     /*  304068 */     GIR_EraseRootFromParent_Done,
     /*  304069 */   // Label 5650: @304069
     /*  304069 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(304132), // Rule ID 9641 //
     /*  304074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  304088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  304091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304113 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304130 */     GIR_RootConstrainSelectedInstOperands,
     /*  304131 */     // GIR_Coverage, 9641,
     /*  304131 */     GIR_EraseRootFromParent_Done,
     /*  304132 */   // Label 5651: @304132
     /*  304132 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(304195), // Rule ID 9644 //
     /*  304137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  304151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  304154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304193 */     GIR_RootConstrainSelectedInstOperands,
     /*  304194 */     // GIR_Coverage, 9644,
     /*  304194 */     GIR_EraseRootFromParent_Done,
     /*  304195 */   // Label 5652: @304195
     /*  304195 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(304258), // Rule ID 9645 //
     /*  304200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  304214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  304217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304239 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304256 */     GIR_RootConstrainSelectedInstOperands,
     /*  304257 */     // GIR_Coverage, 9645,
     /*  304257 */     GIR_EraseRootFromParent_Done,
     /*  304258 */   // Label 5653: @304258
     /*  304258 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(304321), // Rule ID 9648 //
     /*  304263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  304277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  304280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304319 */     GIR_RootConstrainSelectedInstOperands,
     /*  304320 */     // GIR_Coverage, 9648,
     /*  304320 */     GIR_EraseRootFromParent_Done,
     /*  304321 */   // Label 5654: @304321
     /*  304321 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(304384), // Rule ID 9649 //
     /*  304326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  304340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  304343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304365 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  304368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304382 */     GIR_RootConstrainSelectedInstOperands,
     /*  304383 */     // GIR_Coverage, 9649,
     /*  304383 */     GIR_EraseRootFromParent_Done,
     /*  304384 */   // Label 5655: @304384
     /*  304384 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(304447), // Rule ID 9652 //
     /*  304389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  304403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  304406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304445 */     GIR_RootConstrainSelectedInstOperands,
     /*  304446 */     // GIR_Coverage, 9652,
     /*  304446 */     GIR_EraseRootFromParent_Done,
     /*  304447 */   // Label 5656: @304447
     /*  304447 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(304510), // Rule ID 9653 //
     /*  304452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  304466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  304469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304491 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304508 */     GIR_RootConstrainSelectedInstOperands,
     /*  304509 */     // GIR_Coverage, 9653,
     /*  304509 */     GIR_EraseRootFromParent_Done,
     /*  304510 */   // Label 5657: @304510
     /*  304510 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(304573), // Rule ID 9656 //
     /*  304515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  304529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  304532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304571 */     GIR_RootConstrainSelectedInstOperands,
     /*  304572 */     // GIR_Coverage, 9656,
     /*  304572 */     GIR_EraseRootFromParent_Done,
     /*  304573 */   // Label 5658: @304573
     /*  304573 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(304636), // Rule ID 9657 //
     /*  304578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  304592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  304595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304617 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  304620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304634 */     GIR_RootConstrainSelectedInstOperands,
     /*  304635 */     // GIR_Coverage, 9657,
     /*  304635 */     GIR_EraseRootFromParent_Done,
     /*  304636 */   // Label 5659: @304636
     /*  304636 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(304699), // Rule ID 9660 //
     /*  304641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304697 */     GIR_RootConstrainSelectedInstOperands,
     /*  304698 */     // GIR_Coverage, 9660,
     /*  304698 */     GIR_EraseRootFromParent_Done,
     /*  304699 */   // Label 5660: @304699
     /*  304699 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(304762), // Rule ID 9661 //
     /*  304704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  304718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  304721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304743 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304760 */     GIR_RootConstrainSelectedInstOperands,
     /*  304761 */     // GIR_Coverage, 9661,
     /*  304761 */     GIR_EraseRootFromParent_Done,
     /*  304762 */   // Label 5661: @304762
     /*  304762 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(304825), // Rule ID 9664 //
     /*  304767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304823 */     GIR_RootConstrainSelectedInstOperands,
     /*  304824 */     // GIR_Coverage, 9664,
     /*  304824 */     GIR_EraseRootFromParent_Done,
     /*  304825 */   // Label 5662: @304825
     /*  304825 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(304888), // Rule ID 9665 //
     /*  304830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  304844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  304847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304869 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304886 */     GIR_RootConstrainSelectedInstOperands,
     /*  304887 */     // GIR_Coverage, 9665,
     /*  304887 */     GIR_EraseRootFromParent_Done,
     /*  304888 */   // Label 5663: @304888
     /*  304888 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(304951), // Rule ID 9668 //
     /*  304893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304949 */     GIR_RootConstrainSelectedInstOperands,
     /*  304950 */     // GIR_Coverage, 9668,
     /*  304950 */     GIR_EraseRootFromParent_Done,
     /*  304951 */   // Label 5664: @304951
     /*  304951 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(305014), // Rule ID 9669 //
     /*  304956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  304964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  304970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  304973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  304998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305012 */     GIR_RootConstrainSelectedInstOperands,
     /*  305013 */     // GIR_Coverage, 9669,
     /*  305013 */     GIR_EraseRootFromParent_Done,
     /*  305014 */   // Label 5665: @305014
     /*  305014 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(305077), // Rule ID 9672 //
     /*  305019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  305033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  305036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  305061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305075 */     GIR_RootConstrainSelectedInstOperands,
     /*  305076 */     // GIR_Coverage, 9672,
     /*  305076 */     GIR_EraseRootFromParent_Done,
     /*  305077 */   // Label 5666: @305077
     /*  305077 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(305140), // Rule ID 9673 //
     /*  305082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  305096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  305099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305121 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  305124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305138 */     GIR_RootConstrainSelectedInstOperands,
     /*  305139 */     // GIR_Coverage, 9673,
     /*  305139 */     GIR_EraseRootFromParent_Done,
     /*  305140 */   // Label 5667: @305140
     /*  305140 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(305203), // Rule ID 9676 //
     /*  305145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  305159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  305162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305201 */     GIR_RootConstrainSelectedInstOperands,
     /*  305202 */     // GIR_Coverage, 9676,
     /*  305202 */     GIR_EraseRootFromParent_Done,
     /*  305203 */   // Label 5668: @305203
     /*  305203 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(305266), // Rule ID 9677 //
     /*  305208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  305222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  305225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305264 */     GIR_RootConstrainSelectedInstOperands,
     /*  305265 */     // GIR_Coverage, 9677,
     /*  305265 */     GIR_EraseRootFromParent_Done,
     /*  305266 */   // Label 5669: @305266
     /*  305266 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(305329), // Rule ID 9680 //
     /*  305271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  305285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  305288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305310 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305327 */     GIR_RootConstrainSelectedInstOperands,
     /*  305328 */     // GIR_Coverage, 9680,
     /*  305328 */     GIR_EraseRootFromParent_Done,
     /*  305329 */   // Label 5670: @305329
     /*  305329 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(305392), // Rule ID 9681 //
     /*  305334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  305348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  305351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305373 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305390 */     GIR_RootConstrainSelectedInstOperands,
     /*  305391 */     // GIR_Coverage, 9681,
     /*  305391 */     GIR_EraseRootFromParent_Done,
     /*  305392 */   // Label 5671: @305392
     /*  305392 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(305455), // Rule ID 9684 //
     /*  305397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  305408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  305411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  305414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305436 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305453 */     GIR_RootConstrainSelectedInstOperands,
     /*  305454 */     // GIR_Coverage, 9684,
     /*  305454 */     GIR_EraseRootFromParent_Done,
     /*  305455 */   // Label 5672: @305455
     /*  305455 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(305518), // Rule ID 9685 //
     /*  305460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  305471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  305474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  305477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305499 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305516 */     GIR_RootConstrainSelectedInstOperands,
     /*  305517 */     // GIR_Coverage, 9685,
     /*  305517 */     GIR_EraseRootFromParent_Done,
     /*  305518 */   // Label 5673: @305518
     /*  305518 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(305581), // Rule ID 9688 //
     /*  305523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  305537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  305540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305579 */     GIR_RootConstrainSelectedInstOperands,
     /*  305580 */     // GIR_Coverage, 9688,
     /*  305580 */     GIR_EraseRootFromParent_Done,
     /*  305581 */   // Label 5674: @305581
     /*  305581 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(305644), // Rule ID 9689 //
     /*  305586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  305600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  305603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305625 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305642 */     GIR_RootConstrainSelectedInstOperands,
     /*  305643 */     // GIR_Coverage, 9689,
     /*  305643 */     GIR_EraseRootFromParent_Done,
     /*  305644 */   // Label 5675: @305644
     /*  305644 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(305707), // Rule ID 9692 //
     /*  305649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305705 */     GIR_RootConstrainSelectedInstOperands,
     /*  305706 */     // GIR_Coverage, 9692,
     /*  305706 */     GIR_EraseRootFromParent_Done,
     /*  305707 */   // Label 5676: @305707
     /*  305707 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(305770), // Rule ID 9693 //
     /*  305712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  305726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  305729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305751 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  305754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305768 */     GIR_RootConstrainSelectedInstOperands,
     /*  305769 */     // GIR_Coverage, 9693,
     /*  305769 */     GIR_EraseRootFromParent_Done,
     /*  305770 */   // Label 5677: @305770
     /*  305770 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(305833), // Rule ID 9696 //
     /*  305775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305814 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305831 */     GIR_RootConstrainSelectedInstOperands,
     /*  305832 */     // GIR_Coverage, 9696,
     /*  305832 */     GIR_EraseRootFromParent_Done,
     /*  305833 */   // Label 5678: @305833
     /*  305833 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(305896), // Rule ID 9697 //
     /*  305838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  305849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  305852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  305855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305877 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  305880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305894 */     GIR_RootConstrainSelectedInstOperands,
     /*  305895 */     // GIR_Coverage, 9697,
     /*  305895 */     GIR_EraseRootFromParent_Done,
     /*  305896 */   // Label 5679: @305896
     /*  305896 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(305959), // Rule ID 9700 //
     /*  305901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  305943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305957 */     GIR_RootConstrainSelectedInstOperands,
     /*  305958 */     // GIR_Coverage, 9700,
     /*  305958 */     GIR_EraseRootFromParent_Done,
     /*  305959 */   // Label 5680: @305959
     /*  305959 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(306022), // Rule ID 9701 //
     /*  305964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  305972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  305978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  305981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306003 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306020 */     GIR_RootConstrainSelectedInstOperands,
     /*  306021 */     // GIR_Coverage, 9701,
     /*  306021 */     GIR_EraseRootFromParent_Done,
     /*  306022 */   // Label 5681: @306022
     /*  306022 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(306085), // Rule ID 9704 //
     /*  306027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  306041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  306044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306066 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306083 */     GIR_RootConstrainSelectedInstOperands,
     /*  306084 */     // GIR_Coverage, 9704,
     /*  306084 */     GIR_EraseRootFromParent_Done,
     /*  306085 */   // Label 5682: @306085
     /*  306085 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(306148), // Rule ID 9705 //
     /*  306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  306104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  306107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306129 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306146 */     GIR_RootConstrainSelectedInstOperands,
     /*  306147 */     // GIR_Coverage, 9705,
     /*  306147 */     GIR_EraseRootFromParent_Done,
     /*  306148 */   // Label 5683: @306148
     /*  306148 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(306211), // Rule ID 9708 //
     /*  306153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  306167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  306170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306209 */     GIR_RootConstrainSelectedInstOperands,
     /*  306210 */     // GIR_Coverage, 9708,
     /*  306210 */     GIR_EraseRootFromParent_Done,
     /*  306211 */   // Label 5684: @306211
     /*  306211 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(306274), // Rule ID 9709 //
     /*  306216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  306230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  306233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306272 */     GIR_RootConstrainSelectedInstOperands,
     /*  306273 */     // GIR_Coverage, 9709,
     /*  306273 */     GIR_EraseRootFromParent_Done,
     /*  306274 */   // Label 5685: @306274
     /*  306274 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(306337), // Rule ID 9712 //
     /*  306279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  306293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  306296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306335 */     GIR_RootConstrainSelectedInstOperands,
     /*  306336 */     // GIR_Coverage, 9712,
     /*  306336 */     GIR_EraseRootFromParent_Done,
     /*  306337 */   // Label 5686: @306337
     /*  306337 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(306400), // Rule ID 9713 //
     /*  306342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  306356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  306359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306381 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  306384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306398 */     GIR_RootConstrainSelectedInstOperands,
     /*  306399 */     // GIR_Coverage, 9713,
     /*  306399 */     GIR_EraseRootFromParent_Done,
     /*  306400 */   // Label 5687: @306400
     /*  306400 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(306463), // Rule ID 9716 //
     /*  306405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  306419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  306422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306461 */     GIR_RootConstrainSelectedInstOperands,
     /*  306462 */     // GIR_Coverage, 9716,
     /*  306462 */     GIR_EraseRootFromParent_Done,
     /*  306463 */   // Label 5688: @306463
     /*  306463 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(306526), // Rule ID 9717 //
     /*  306468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  306482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  306485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306507 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  306510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306524 */     GIR_RootConstrainSelectedInstOperands,
     /*  306525 */     // GIR_Coverage, 9717,
     /*  306525 */     GIR_EraseRootFromParent_Done,
     /*  306526 */   // Label 5689: @306526
     /*  306526 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(306589), // Rule ID 9720 //
     /*  306531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306587 */     GIR_RootConstrainSelectedInstOperands,
     /*  306588 */     // GIR_Coverage, 9720,
     /*  306588 */     GIR_EraseRootFromParent_Done,
     /*  306589 */   // Label 5690: @306589
     /*  306589 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(306652), // Rule ID 9721 //
     /*  306594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  306602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  306608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  306611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306633 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  306636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306650 */     GIR_RootConstrainSelectedInstOperands,
     /*  306651 */     // GIR_Coverage, 9721,
     /*  306651 */     GIR_EraseRootFromParent_Done,
     /*  306652 */   // Label 5691: @306652
     /*  306652 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(306715), // Rule ID 9724 //
     /*  306657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  306699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306713 */     GIR_RootConstrainSelectedInstOperands,
     /*  306714 */     // GIR_Coverage, 9724,
     /*  306714 */     GIR_EraseRootFromParent_Done,
     /*  306715 */   // Label 5692: @306715
     /*  306715 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(306778), // Rule ID 9725 //
     /*  306720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  306734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  306737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  306762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306776 */     GIR_RootConstrainSelectedInstOperands,
     /*  306777 */     // GIR_Coverage, 9725,
     /*  306777 */     GIR_EraseRootFromParent_Done,
     /*  306778 */   // Label 5693: @306778
     /*  306778 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(306841), // Rule ID 9728 //
     /*  306783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  306825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306839 */     GIR_RootConstrainSelectedInstOperands,
     /*  306840 */     // GIR_Coverage, 9728,
     /*  306840 */     GIR_EraseRootFromParent_Done,
     /*  306841 */   // Label 5694: @306841
     /*  306841 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(306904), // Rule ID 9729 //
     /*  306846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  306860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  306863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306885 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  306888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306902 */     GIR_RootConstrainSelectedInstOperands,
     /*  306903 */     // GIR_Coverage, 9729,
     /*  306903 */     GIR_EraseRootFromParent_Done,
     /*  306904 */   // Label 5695: @306904
     /*  306904 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(306967), // Rule ID 9732 //
     /*  306909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  306951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306965 */     GIR_RootConstrainSelectedInstOperands,
     /*  306966 */     // GIR_Coverage, 9732,
     /*  306966 */     GIR_EraseRootFromParent_Done,
     /*  306967 */   // Label 5696: @306967
     /*  306967 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(307030), // Rule ID 9733 //
     /*  306972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  306980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  306986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  306989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307028 */     GIR_RootConstrainSelectedInstOperands,
     /*  307029 */     // GIR_Coverage, 9733,
     /*  307029 */     GIR_EraseRootFromParent_Done,
     /*  307030 */   // Label 5697: @307030
     /*  307030 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(307093), // Rule ID 9736 //
     /*  307035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  307049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  307052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307074 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  307077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307091 */     GIR_RootConstrainSelectedInstOperands,
     /*  307092 */     // GIR_Coverage, 9736,
     /*  307092 */     GIR_EraseRootFromParent_Done,
     /*  307093 */   // Label 5698: @307093
     /*  307093 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(307156), // Rule ID 9737 //
     /*  307098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  307112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  307115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307137 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  307140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307154 */     GIR_RootConstrainSelectedInstOperands,
     /*  307155 */     // GIR_Coverage, 9737,
     /*  307155 */     GIR_EraseRootFromParent_Done,
     /*  307156 */   // Label 5699: @307156
     /*  307156 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(307219), // Rule ID 9740 //
     /*  307161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  307175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  307178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307217 */     GIR_RootConstrainSelectedInstOperands,
     /*  307218 */     // GIR_Coverage, 9740,
     /*  307218 */     GIR_EraseRootFromParent_Done,
     /*  307219 */   // Label 5700: @307219
     /*  307219 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(307282), // Rule ID 9741 //
     /*  307224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  307238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  307241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307263 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307280 */     GIR_RootConstrainSelectedInstOperands,
     /*  307281 */     // GIR_Coverage, 9741,
     /*  307281 */     GIR_EraseRootFromParent_Done,
     /*  307282 */   // Label 5701: @307282
     /*  307282 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(307345), // Rule ID 9744 //
     /*  307287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  307301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  307304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307326 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307343 */     GIR_RootConstrainSelectedInstOperands,
     /*  307344 */     // GIR_Coverage, 9744,
     /*  307344 */     GIR_EraseRootFromParent_Done,
     /*  307345 */   // Label 5702: @307345
     /*  307345 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(307408), // Rule ID 9745 //
     /*  307350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  307364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  307367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307389 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  307392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307406 */     GIR_RootConstrainSelectedInstOperands,
     /*  307407 */     // GIR_Coverage, 9745,
     /*  307407 */     GIR_EraseRootFromParent_Done,
     /*  307408 */   // Label 5703: @307408
     /*  307408 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(307471), // Rule ID 9748 //
     /*  307413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  307427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  307430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307469 */     GIR_RootConstrainSelectedInstOperands,
     /*  307470 */     // GIR_Coverage, 9748,
     /*  307470 */     GIR_EraseRootFromParent_Done,
     /*  307471 */   // Label 5704: @307471
     /*  307471 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(307534), // Rule ID 9749 //
     /*  307476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  307490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  307493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307532 */     GIR_RootConstrainSelectedInstOperands,
     /*  307533 */     // GIR_Coverage, 9749,
     /*  307533 */     GIR_EraseRootFromParent_Done,
     /*  307534 */   // Label 5705: @307534
     /*  307534 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(307597), // Rule ID 9752 //
     /*  307539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307595 */     GIR_RootConstrainSelectedInstOperands,
     /*  307596 */     // GIR_Coverage, 9752,
     /*  307596 */     GIR_EraseRootFromParent_Done,
     /*  307597 */   // Label 5706: @307597
     /*  307597 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(307660), // Rule ID 9753 //
     /*  307602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  307616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  307619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307641 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307658 */     GIR_RootConstrainSelectedInstOperands,
     /*  307659 */     // GIR_Coverage, 9753,
     /*  307659 */     GIR_EraseRootFromParent_Done,
     /*  307660 */   // Label 5707: @307660
     /*  307660 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(307723), // Rule ID 9756 //
     /*  307665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307721 */     GIR_RootConstrainSelectedInstOperands,
     /*  307722 */     // GIR_Coverage, 9756,
     /*  307722 */     GIR_EraseRootFromParent_Done,
     /*  307723 */   // Label 5708: @307723
     /*  307723 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(307786), // Rule ID 9757 //
     /*  307728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  307742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  307745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307767 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307784 */     GIR_RootConstrainSelectedInstOperands,
     /*  307785 */     // GIR_Coverage, 9757,
     /*  307785 */     GIR_EraseRootFromParent_Done,
     /*  307786 */   // Label 5709: @307786
     /*  307786 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(307849), // Rule ID 9760 //
     /*  307791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307847 */     GIR_RootConstrainSelectedInstOperands,
     /*  307848 */     // GIR_Coverage, 9760,
     /*  307848 */     GIR_EraseRootFromParent_Done,
     /*  307849 */   // Label 5710: @307849
     /*  307849 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(307912), // Rule ID 9761 //
     /*  307854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  307865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  307868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  307871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307893 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  307896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307910 */     GIR_RootConstrainSelectedInstOperands,
     /*  307911 */     // GIR_Coverage, 9761,
     /*  307911 */     GIR_EraseRootFromParent_Done,
     /*  307912 */   // Label 5711: @307912
     /*  307912 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(307975), // Rule ID 9764 //
     /*  307917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  307959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307973 */     GIR_RootConstrainSelectedInstOperands,
     /*  307974 */     // GIR_Coverage, 9764,
     /*  307974 */     GIR_EraseRootFromParent_Done,
     /*  307975 */   // Label 5712: @307975
     /*  307975 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(308038), // Rule ID 9765 //
     /*  307980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  307988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  307994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  307997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308019 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308036 */     GIR_RootConstrainSelectedInstOperands,
     /*  308037 */     // GIR_Coverage, 9765,
     /*  308037 */     GIR_EraseRootFromParent_Done,
     /*  308038 */   // Label 5713: @308038
     /*  308038 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(308101), // Rule ID 9768 //
     /*  308043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  308057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  308060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308082 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  308082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308099 */     GIR_RootConstrainSelectedInstOperands,
     /*  308100 */     // GIR_Coverage, 9768,
     /*  308100 */     GIR_EraseRootFromParent_Done,
     /*  308101 */   // Label 5714: @308101
     /*  308101 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(308164), // Rule ID 9769 //
     /*  308106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  308120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  308123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308145 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308162 */     GIR_RootConstrainSelectedInstOperands,
     /*  308163 */     // GIR_Coverage, 9769,
     /*  308163 */     GIR_EraseRootFromParent_Done,
     /*  308164 */   // Label 5715: @308164
     /*  308164 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(308227), // Rule ID 9772 //
     /*  308169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  308180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  308183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  308186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308208 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  308208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308225 */     GIR_RootConstrainSelectedInstOperands,
     /*  308226 */     // GIR_Coverage, 9772,
     /*  308226 */     GIR_EraseRootFromParent_Done,
     /*  308227 */   // Label 5716: @308227
     /*  308227 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(308290), // Rule ID 9773 //
     /*  308232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  308243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  308246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  308249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308271 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  308271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308288 */     GIR_RootConstrainSelectedInstOperands,
     /*  308289 */     // GIR_Coverage, 9773,
     /*  308289 */     GIR_EraseRootFromParent_Done,
     /*  308290 */   // Label 5717: @308290
     /*  308290 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(308353), // Rule ID 9776 //
     /*  308295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  308309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  308312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308334 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308351 */     GIR_RootConstrainSelectedInstOperands,
     /*  308352 */     // GIR_Coverage, 9776,
     /*  308352 */     GIR_EraseRootFromParent_Done,
     /*  308353 */   // Label 5718: @308353
     /*  308353 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(308416), // Rule ID 9777 //
     /*  308358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  308372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  308375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308414 */     GIR_RootConstrainSelectedInstOperands,
     /*  308415 */     // GIR_Coverage, 9777,
     /*  308415 */     GIR_EraseRootFromParent_Done,
     /*  308416 */   // Label 5719: @308416
     /*  308416 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(308479), // Rule ID 9780 //
     /*  308421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  308435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  308438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308477 */     GIR_RootConstrainSelectedInstOperands,
     /*  308478 */     // GIR_Coverage, 9780,
     /*  308478 */     GIR_EraseRootFromParent_Done,
     /*  308479 */   // Label 5720: @308479
     /*  308479 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(308542), // Rule ID 9781 //
     /*  308484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  308498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  308501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308523 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308540 */     GIR_RootConstrainSelectedInstOperands,
     /*  308541 */     // GIR_Coverage, 9781,
     /*  308541 */     GIR_EraseRootFromParent_Done,
     /*  308542 */   // Label 5721: @308542
     /*  308542 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(308605), // Rule ID 9784 //
     /*  308547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308586 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  308586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308603 */     GIR_RootConstrainSelectedInstOperands,
     /*  308604 */     // GIR_Coverage, 9784,
     /*  308604 */     GIR_EraseRootFromParent_Done,
     /*  308605 */   // Label 5722: @308605
     /*  308605 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(308668), // Rule ID 9785 //
     /*  308610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  308621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  308624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  308627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308649 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  308649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308666 */     GIR_RootConstrainSelectedInstOperands,
     /*  308667 */     // GIR_Coverage, 9785,
     /*  308667 */     GIR_EraseRootFromParent_Done,
     /*  308668 */   // Label 5723: @308668
     /*  308668 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(308731), // Rule ID 9788 //
     /*  308673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308729 */     GIR_RootConstrainSelectedInstOperands,
     /*  308730 */     // GIR_Coverage, 9788,
     /*  308730 */     GIR_EraseRootFromParent_Done,
     /*  308731 */   // Label 5724: @308731
     /*  308731 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(308794), // Rule ID 9789 //
     /*  308736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  308750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  308753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  308778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308792 */     GIR_RootConstrainSelectedInstOperands,
     /*  308793 */     // GIR_Coverage, 9789,
     /*  308793 */     GIR_EraseRootFromParent_Done,
     /*  308794 */   // Label 5725: @308794
     /*  308794 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(308857), // Rule ID 9792 //
     /*  308799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308855 */     GIR_RootConstrainSelectedInstOperands,
     /*  308856 */     // GIR_Coverage, 9792,
     /*  308856 */     GIR_EraseRootFromParent_Done,
     /*  308857 */   // Label 5726: @308857
     /*  308857 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(308920), // Rule ID 9793 //
     /*  308862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  308876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  308879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308901 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  308901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  308904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308918 */     GIR_RootConstrainSelectedInstOperands,
     /*  308919 */     // GIR_Coverage, 9793,
     /*  308919 */     GIR_EraseRootFromParent_Done,
     /*  308920 */   // Label 5727: @308920
     /*  308920 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(308983), // Rule ID 9796 //
     /*  308925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  308939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  308942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  308964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  308967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308981 */     GIR_RootConstrainSelectedInstOperands,
     /*  308982 */     // GIR_Coverage, 9796,
     /*  308982 */     GIR_EraseRootFromParent_Done,
     /*  308983 */   // Label 5728: @308983
     /*  308983 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(309046), // Rule ID 9797 //
     /*  308988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  308996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  308999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  309002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  309005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  309027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309044 */     GIR_RootConstrainSelectedInstOperands,
     /*  309045 */     // GIR_Coverage, 9797,
     /*  309045 */     GIR_EraseRootFromParent_Done,
     /*  309046 */   // Label 5729: @309046
     /*  309046 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(309109), // Rule ID 9800 //
     /*  309051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  309065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  309068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  309093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309107 */     GIR_RootConstrainSelectedInstOperands,
     /*  309108 */     // GIR_Coverage, 9800,
     /*  309108 */     GIR_EraseRootFromParent_Done,
     /*  309109 */   // Label 5730: @309109
     /*  309109 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(309172), // Rule ID 9801 //
     /*  309114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  309128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  309131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309153 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  309156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309170 */     GIR_RootConstrainSelectedInstOperands,
     /*  309171 */     // GIR_Coverage, 9801,
     /*  309171 */     GIR_EraseRootFromParent_Done,
     /*  309172 */   // Label 5731: @309172
     /*  309172 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(309235), // Rule ID 9804 //
     /*  309177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  309191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  309194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  309219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309233 */     GIR_RootConstrainSelectedInstOperands,
     /*  309234 */     // GIR_Coverage, 9804,
     /*  309234 */     GIR_EraseRootFromParent_Done,
     /*  309235 */   // Label 5732: @309235
     /*  309235 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(309298), // Rule ID 9805 //
     /*  309240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  309254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  309257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309279 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  309282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309296 */     GIR_RootConstrainSelectedInstOperands,
     /*  309297 */     // GIR_Coverage, 9805,
     /*  309297 */     GIR_EraseRootFromParent_Done,
     /*  309298 */   // Label 5733: @309298
     /*  309298 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(309361), // Rule ID 9808 //
     /*  309303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  309314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  309317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  309320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  309342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309359 */     GIR_RootConstrainSelectedInstOperands,
     /*  309360 */     // GIR_Coverage, 9808,
     /*  309360 */     GIR_EraseRootFromParent_Done,
     /*  309361 */   // Label 5734: @309361
     /*  309361 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(309424), // Rule ID 9809 //
     /*  309366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  309374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  309377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  309380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  309383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309405 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  309405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  309408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309422 */     GIR_RootConstrainSelectedInstOperands,
     /*  309423 */     // GIR_Coverage, 9809,
     /*  309423 */     GIR_EraseRootFromParent_Done,
     /*  309424 */   // Label 5735: @309424
     /*  309424 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(309487), // Rule ID 9812 //
     /*  309429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  309443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  309446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  309471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309485 */     GIR_RootConstrainSelectedInstOperands,
     /*  309486 */     // GIR_Coverage, 9812,
     /*  309486 */     GIR_EraseRootFromParent_Done,
     /*  309487 */   // Label 5736: @309487
     /*  309487 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(309550), // Rule ID 9813 //
     /*  309492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  309506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  309509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  309534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309548 */     GIR_RootConstrainSelectedInstOperands,
     /*  309549 */     // GIR_Coverage, 9813,
     /*  309549 */     GIR_EraseRootFromParent_Done,
     /*  309550 */   // Label 5737: @309550
     /*  309550 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(309613), // Rule ID 9816 //
     /*  309555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309611 */     GIR_RootConstrainSelectedInstOperands,
     /*  309612 */     // GIR_Coverage, 9816,
     /*  309612 */     GIR_EraseRootFromParent_Done,
     /*  309613 */   // Label 5738: @309613
     /*  309613 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(309676), // Rule ID 9817 //
     /*  309618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  309632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  309635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309674 */     GIR_RootConstrainSelectedInstOperands,
     /*  309675 */     // GIR_Coverage, 9817,
     /*  309675 */     GIR_EraseRootFromParent_Done,
     /*  309676 */   // Label 5739: @309676
     /*  309676 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(309739), // Rule ID 9820 //
     /*  309681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  309720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309737 */     GIR_RootConstrainSelectedInstOperands,
     /*  309738 */     // GIR_Coverage, 9820,
     /*  309738 */     GIR_EraseRootFromParent_Done,
     /*  309739 */   // Label 5740: @309739
     /*  309739 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(309802), // Rule ID 9821 //
     /*  309744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  309755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  309758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  309761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  309783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309800 */     GIR_RootConstrainSelectedInstOperands,
     /*  309801 */     // GIR_Coverage, 9821,
     /*  309801 */     GIR_EraseRootFromParent_Done,
     /*  309802 */   // Label 5741: @309802
     /*  309802 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(309865), // Rule ID 9824 //
     /*  309807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  309846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309863 */     GIR_RootConstrainSelectedInstOperands,
     /*  309864 */     // GIR_Coverage, 9824,
     /*  309864 */     GIR_EraseRootFromParent_Done,
     /*  309865 */   // Label 5742: @309865
     /*  309865 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(309928), // Rule ID 9825 //
     /*  309870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  309881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  309884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  309887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309909 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  309909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  309912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309926 */     GIR_RootConstrainSelectedInstOperands,
     /*  309927 */     // GIR_Coverage, 9825,
     /*  309927 */     GIR_EraseRootFromParent_Done,
     /*  309928 */   // Label 5743: @309928
     /*  309928 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(309991), // Rule ID 9828 //
     /*  309933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  309941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  309944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  309947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  309950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  309972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  309975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  309981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309989 */     GIR_RootConstrainSelectedInstOperands,
     /*  309990 */     // GIR_Coverage, 9828,
     /*  309990 */     GIR_EraseRootFromParent_Done,
     /*  309991 */   // Label 5744: @309991
     /*  309991 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(310054), // Rule ID 9829 //
     /*  309996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  310010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  310035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310052 */     GIR_RootConstrainSelectedInstOperands,
     /*  310053 */     // GIR_Coverage, 9829,
     /*  310053 */     GIR_EraseRootFromParent_Done,
     /*  310054 */   // Label 5745: @310054
     /*  310054 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(310117), // Rule ID 9832 //
     /*  310059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  310076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  310098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310115 */     GIR_RootConstrainSelectedInstOperands,
     /*  310116 */     // GIR_Coverage, 9832,
     /*  310116 */     GIR_EraseRootFromParent_Done,
     /*  310117 */   // Label 5746: @310117
     /*  310117 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(310180), // Rule ID 9833 //
     /*  310122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  310136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  310139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310161 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  310161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  310164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310178 */     GIR_RootConstrainSelectedInstOperands,
     /*  310179 */     // GIR_Coverage, 9833,
     /*  310179 */     GIR_EraseRootFromParent_Done,
     /*  310180 */   // Label 5747: @310180
     /*  310180 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(310243), // Rule ID 9836 //
     /*  310185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  310196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  310199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  310202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310241 */     GIR_RootConstrainSelectedInstOperands,
     /*  310242 */     // GIR_Coverage, 9836,
     /*  310242 */     GIR_EraseRootFromParent_Done,
     /*  310243 */   // Label 5748: @310243
     /*  310243 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(310306), // Rule ID 9837 //
     /*  310248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  310259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  310262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  310265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310287 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310304 */     GIR_RootConstrainSelectedInstOperands,
     /*  310305 */     // GIR_Coverage, 9837,
     /*  310305 */     GIR_EraseRootFromParent_Done,
     /*  310306 */   // Label 5749: @310306
     /*  310306 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(310369), // Rule ID 9840 //
     /*  310311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  310322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  310325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  310328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  310350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310367 */     GIR_RootConstrainSelectedInstOperands,
     /*  310368 */     // GIR_Coverage, 9840,
     /*  310368 */     GIR_EraseRootFromParent_Done,
     /*  310369 */   // Label 5750: @310369
     /*  310369 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(310432), // Rule ID 9841 //
     /*  310374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  310385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  310388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  310391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310413 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  310413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310430 */     GIR_RootConstrainSelectedInstOperands,
     /*  310431 */     // GIR_Coverage, 9841,
     /*  310431 */     GIR_EraseRootFromParent_Done,
     /*  310432 */   // Label 5751: @310432
     /*  310432 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(310495), // Rule ID 9844 //
     /*  310437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  310454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  310476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310493 */     GIR_RootConstrainSelectedInstOperands,
     /*  310494 */     // GIR_Coverage, 9844,
     /*  310494 */     GIR_EraseRootFromParent_Done,
     /*  310495 */   // Label 5752: @310495
     /*  310495 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(310558), // Rule ID 9845 //
     /*  310500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  310511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  310514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  310517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  310539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310556 */     GIR_RootConstrainSelectedInstOperands,
     /*  310557 */     // GIR_Coverage, 9845,
     /*  310557 */     GIR_EraseRootFromParent_Done,
     /*  310558 */   // Label 5753: @310558
     /*  310558 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(310621), // Rule ID 9848 //
     /*  310563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  310602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310619 */     GIR_RootConstrainSelectedInstOperands,
     /*  310620 */     // GIR_Coverage, 9848,
     /*  310620 */     GIR_EraseRootFromParent_Done,
     /*  310621 */   // Label 5754: @310621
     /*  310621 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(310684), // Rule ID 9849 //
     /*  310626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  310637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  310640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  310643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  310665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  310668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310682 */     GIR_RootConstrainSelectedInstOperands,
     /*  310683 */     // GIR_Coverage, 9849,
     /*  310683 */     GIR_EraseRootFromParent_Done,
     /*  310684 */   // Label 5755: @310684
     /*  310684 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(310747), // Rule ID 9852 //
     /*  310689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  310700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310728 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  310731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310745 */     GIR_RootConstrainSelectedInstOperands,
     /*  310746 */     // GIR_Coverage, 9852,
     /*  310746 */     GIR_EraseRootFromParent_Done,
     /*  310747 */   // Label 5756: @310747
     /*  310747 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(310810), // Rule ID 9853 //
     /*  310752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  310763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  310766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  310769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  310794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310808 */     GIR_RootConstrainSelectedInstOperands,
     /*  310809 */     // GIR_Coverage, 9853,
     /*  310809 */     GIR_EraseRootFromParent_Done,
     /*  310810 */   // Label 5757: @310810
     /*  310810 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(310873), // Rule ID 9856 //
     /*  310815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  310826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  310857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310871 */     GIR_RootConstrainSelectedInstOperands,
     /*  310872 */     // GIR_Coverage, 9856,
     /*  310872 */     GIR_EraseRootFromParent_Done,
     /*  310873 */   // Label 5758: @310873
     /*  310873 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(310936), // Rule ID 9857 //
     /*  310878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  310889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  310892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  310895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310917 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  310917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  310920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310934 */     GIR_RootConstrainSelectedInstOperands,
     /*  310935 */     // GIR_Coverage, 9857,
     /*  310935 */     GIR_EraseRootFromParent_Done,
     /*  310936 */   // Label 5759: @310936
     /*  310936 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(310999), // Rule ID 9860 //
     /*  310941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  310949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  310952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310980 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  310980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  310983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  310989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310997 */     GIR_RootConstrainSelectedInstOperands,
     /*  310998 */     // GIR_Coverage, 9860,
     /*  310998 */     GIR_EraseRootFromParent_Done,
     /*  310999 */   // Label 5760: @310999
     /*  310999 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(311062), // Rule ID 9861 //
     /*  311004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  311015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  311018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  311021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311043 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  311043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  311060 */     GIR_RootConstrainSelectedInstOperands,
     /*  311061 */     // GIR_Coverage, 9861,
     /*  311061 */     GIR_EraseRootFromParent_Done,
     /*  311062 */   // Label 5761: @311062
     /*  311062 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(311125), // Rule ID 9864 //
     /*  311067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311123 */     GIR_RootConstrainSelectedInstOperands,
     /*  311124 */     // GIR_Coverage, 9864,
     /*  311124 */     GIR_EraseRootFromParent_Done,
     /*  311125 */   // Label 5762: @311125
     /*  311125 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(311188), // Rule ID 9865 //
     /*  311130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311186 */     GIR_RootConstrainSelectedInstOperands,
     /*  311187 */     // GIR_Coverage, 9865,
     /*  311187 */     GIR_EraseRootFromParent_Done,
     /*  311188 */   // Label 5763: @311188
     /*  311188 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(311251), // Rule ID 9868 //
     /*  311193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311232 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311249 */     GIR_RootConstrainSelectedInstOperands,
     /*  311250 */     // GIR_Coverage, 9868,
     /*  311250 */     GIR_EraseRootFromParent_Done,
     /*  311251 */   // Label 5764: @311251
     /*  311251 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(311314), // Rule ID 9869 //
     /*  311256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311295 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311312 */     GIR_RootConstrainSelectedInstOperands,
     /*  311313 */     // GIR_Coverage, 9869,
     /*  311313 */     GIR_EraseRootFromParent_Done,
     /*  311314 */   // Label 5765: @311314
     /*  311314 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(311377), // Rule ID 9872 //
     /*  311319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  311330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311358 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  311358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311375 */     GIR_RootConstrainSelectedInstOperands,
     /*  311376 */     // GIR_Coverage, 9872,
     /*  311376 */     GIR_EraseRootFromParent_Done,
     /*  311377 */   // Label 5766: @311377
     /*  311377 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(311440), // Rule ID 9873 //
     /*  311382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  311393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311421 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  311421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311438 */     GIR_RootConstrainSelectedInstOperands,
     /*  311439 */     // GIR_Coverage, 9873,
     /*  311439 */     GIR_EraseRootFromParent_Done,
     /*  311440 */   // Label 5767: @311440
     /*  311440 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(311503), // Rule ID 9876 //
     /*  311445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311501 */     GIR_RootConstrainSelectedInstOperands,
     /*  311502 */     // GIR_Coverage, 9876,
     /*  311502 */     GIR_EraseRootFromParent_Done,
     /*  311503 */   // Label 5768: @311503
     /*  311503 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(311566), // Rule ID 9877 //
     /*  311508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311547 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311564 */     GIR_RootConstrainSelectedInstOperands,
     /*  311565 */     // GIR_Coverage, 9877,
     /*  311565 */     GIR_EraseRootFromParent_Done,
     /*  311566 */   // Label 5769: @311566
     /*  311566 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(311629), // Rule ID 9880 //
     /*  311571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311627 */     GIR_RootConstrainSelectedInstOperands,
     /*  311628 */     // GIR_Coverage, 9880,
     /*  311628 */     GIR_EraseRootFromParent_Done,
     /*  311629 */   // Label 5770: @311629
     /*  311629 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(311692), // Rule ID 9881 //
     /*  311634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  311645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  311648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  311651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311690 */     GIR_RootConstrainSelectedInstOperands,
     /*  311691 */     // GIR_Coverage, 9881,
     /*  311691 */     GIR_EraseRootFromParent_Done,
     /*  311692 */   // Label 5771: @311692
     /*  311692 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(311755), // Rule ID 9884 //
     /*  311697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  311700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  311736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311753 */     GIR_RootConstrainSelectedInstOperands,
     /*  311754 */     // GIR_Coverage, 9884,
     /*  311754 */     GIR_EraseRootFromParent_Done,
     /*  311755 */   // Label 5772: @311755
     /*  311755 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(311818), // Rule ID 9885 //
     /*  311760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  311763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  311771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  311774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  311777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311799 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  311799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  311802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311816 */     GIR_RootConstrainSelectedInstOperands,
     /*  311817 */     // GIR_Coverage, 9885,
     /*  311817 */     GIR_EraseRootFromParent_Done,
     /*  311818 */   // Label 5773: @311818
     /*  311818 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(311881), // Rule ID 9888 //
     /*  311823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  311834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  311862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311879 */     GIR_RootConstrainSelectedInstOperands,
     /*  311880 */     // GIR_Coverage, 9888,
     /*  311880 */     GIR_EraseRootFromParent_Done,
     /*  311881 */   // Label 5774: @311881
     /*  311881 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(311944), // Rule ID 9889 //
     /*  311886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  311897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  311900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  311903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311925 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  311925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  311928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311942 */     GIR_RootConstrainSelectedInstOperands,
     /*  311943 */     // GIR_Coverage, 9889,
     /*  311943 */     GIR_EraseRootFromParent_Done,
     /*  311944 */   // Label 5775: @311944
     /*  311944 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(312007), // Rule ID 9892 //
     /*  311949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  311957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  311960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  311988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  311991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  311997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312005 */     GIR_RootConstrainSelectedInstOperands,
     /*  312006 */     // GIR_Coverage, 9892,
     /*  312006 */     GIR_EraseRootFromParent_Done,
     /*  312007 */   // Label 5776: @312007
     /*  312007 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(312070), // Rule ID 9893 //
     /*  312012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  312015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  312023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  312026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  312029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312051 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  312051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  312054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312068 */     GIR_RootConstrainSelectedInstOperands,
     /*  312069 */     // GIR_Coverage, 9893,
     /*  312069 */     GIR_EraseRootFromParent_Done,
     /*  312070 */   // Label 5777: @312070
     /*  312070 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(312133), // Rule ID 9896 //
     /*  312075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  312078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  312086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  312114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  312117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312131 */     GIR_RootConstrainSelectedInstOperands,
     /*  312132 */     // GIR_Coverage, 9896,
     /*  312132 */     GIR_EraseRootFromParent_Done,
     /*  312133 */   // Label 5778: @312133
     /*  312133 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(312196), // Rule ID 9897 //
     /*  312138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  312141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  312146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  312149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  312177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  312180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  312186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312194 */     GIR_RootConstrainSelectedInstOperands,
     /*  312195 */     // GIR_Coverage, 9897,
     /*  312195 */     GIR_EraseRootFromParent_Done,
     /*  312196 */   // Label 5779: @312196
     /*  312196 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(312262), // Rule ID 13972 //
     /*  312201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  312212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  312215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  312218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312240 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  312243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312260 */     GIR_RootConstrainSelectedInstOperands,
     /*  312261 */     // GIR_Coverage, 13972,
     /*  312261 */     GIR_EraseRootFromParent_Done,
     /*  312262 */   // Label 5780: @312262
     /*  312262 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(312328), // Rule ID 13973 //
     /*  312267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  312278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  312281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  312284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  312309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312326 */     GIR_RootConstrainSelectedInstOperands,
     /*  312327 */     // GIR_Coverage, 13973,
     /*  312327 */     GIR_EraseRootFromParent_Done,
     /*  312328 */   // Label 5781: @312328
     /*  312328 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(312394), // Rule ID 13974 //
     /*  312333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  312344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  312347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  312350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312392 */     GIR_RootConstrainSelectedInstOperands,
     /*  312393 */     // GIR_Coverage, 13974,
     /*  312393 */     GIR_EraseRootFromParent_Done,
     /*  312394 */   // Label 5782: @312394
     /*  312394 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(312460), // Rule ID 13975 //
     /*  312399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  312410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  312413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  312416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312438 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312458 */     GIR_RootConstrainSelectedInstOperands,
     /*  312459 */     // GIR_Coverage, 13975,
     /*  312459 */     GIR_EraseRootFromParent_Done,
     /*  312460 */   // Label 5783: @312460
     /*  312460 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(312526), // Rule ID 13976 //
     /*  312465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  312476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  312479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  312482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  312504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312524 */     GIR_RootConstrainSelectedInstOperands,
     /*  312525 */     // GIR_Coverage, 13976,
     /*  312525 */     GIR_EraseRootFromParent_Done,
     /*  312526 */   // Label 5784: @312526
     /*  312526 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(312592), // Rule ID 13977 //
     /*  312531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  312542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  312545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  312548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  312570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  312587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312590 */     GIR_RootConstrainSelectedInstOperands,
     /*  312591 */     // GIR_Coverage, 13977,
     /*  312591 */     GIR_EraseRootFromParent_Done,
     /*  312592 */   // Label 5785: @312592
     /*  312592 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(312658), // Rule ID 13978 //
     /*  312597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  312608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  312611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312656 */     GIR_RootConstrainSelectedInstOperands,
     /*  312657 */     // GIR_Coverage, 13978,
     /*  312657 */     GIR_EraseRootFromParent_Done,
     /*  312658 */   // Label 5786: @312658
     /*  312658 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(312724), // Rule ID 13979 //
     /*  312663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  312674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  312677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  312680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  312705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312722 */     GIR_RootConstrainSelectedInstOperands,
     /*  312723 */     // GIR_Coverage, 13979,
     /*  312723 */     GIR_EraseRootFromParent_Done,
     /*  312724 */   // Label 5787: @312724
     /*  312724 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(312790), // Rule ID 13980 //
     /*  312729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312788 */     GIR_RootConstrainSelectedInstOperands,
     /*  312789 */     // GIR_Coverage, 13980,
     /*  312789 */     GIR_EraseRootFromParent_Done,
     /*  312790 */   // Label 5788: @312790
     /*  312790 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(312856), // Rule ID 13981 //
     /*  312795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312854 */     GIR_RootConstrainSelectedInstOperands,
     /*  312855 */     // GIR_Coverage, 13981,
     /*  312855 */     GIR_EraseRootFromParent_Done,
     /*  312856 */   // Label 5789: @312856
     /*  312856 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(312922), // Rule ID 13982 //
     /*  312861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312920 */     GIR_RootConstrainSelectedInstOperands,
     /*  312921 */     // GIR_Coverage, 13982,
     /*  312921 */     GIR_EraseRootFromParent_Done,
     /*  312922 */   // Label 5790: @312922
     /*  312922 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(312988), // Rule ID 13983 //
     /*  312927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  312930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  312969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312986 */     GIR_RootConstrainSelectedInstOperands,
     /*  312987 */     // GIR_Coverage, 13983,
     /*  312987 */     GIR_EraseRootFromParent_Done,
     /*  312988 */   // Label 5791: @312988
     /*  312988 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(313054), // Rule ID 13984 //
     /*  312993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  312996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  313004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  313007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  313010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313052 */     GIR_RootConstrainSelectedInstOperands,
     /*  313053 */     // GIR_Coverage, 13984,
     /*  313053 */     GIR_EraseRootFromParent_Done,
     /*  313054 */   // Label 5792: @313054
     /*  313054 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(313120), // Rule ID 13985 //
     /*  313059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  313070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  313073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  313076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313098 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313118 */     GIR_RootConstrainSelectedInstOperands,
     /*  313119 */     // GIR_Coverage, 13985,
     /*  313119 */     GIR_EraseRootFromParent_Done,
     /*  313120 */   // Label 5793: @313120
     /*  313120 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(313186), // Rule ID 13986 //
     /*  313125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313184 */     GIR_RootConstrainSelectedInstOperands,
     /*  313185 */     // GIR_Coverage, 13986,
     /*  313185 */     GIR_EraseRootFromParent_Done,
     /*  313186 */   // Label 5794: @313186
     /*  313186 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(313252), // Rule ID 13987 //
     /*  313191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313250 */     GIR_RootConstrainSelectedInstOperands,
     /*  313251 */     // GIR_Coverage, 13987,
     /*  313251 */     GIR_EraseRootFromParent_Done,
     /*  313252 */   // Label 5795: @313252
     /*  313252 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(313318), // Rule ID 13988 //
     /*  313257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313316 */     GIR_RootConstrainSelectedInstOperands,
     /*  313317 */     // GIR_Coverage, 13988,
     /*  313317 */     GIR_EraseRootFromParent_Done,
     /*  313318 */   // Label 5796: @313318
     /*  313318 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(313384), // Rule ID 13989 //
     /*  313323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313382 */     GIR_RootConstrainSelectedInstOperands,
     /*  313383 */     // GIR_Coverage, 13989,
     /*  313383 */     GIR_EraseRootFromParent_Done,
     /*  313384 */   // Label 5797: @313384
     /*  313384 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(313450), // Rule ID 13990 //
     /*  313389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  313392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313428 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313448 */     GIR_RootConstrainSelectedInstOperands,
     /*  313449 */     // GIR_Coverage, 13990,
     /*  313449 */     GIR_EraseRootFromParent_Done,
     /*  313450 */   // Label 5798: @313450
     /*  313450 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(313516), // Rule ID 13991 //
     /*  313455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  313458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  313497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313514 */     GIR_RootConstrainSelectedInstOperands,
     /*  313515 */     // GIR_Coverage, 13991,
     /*  313515 */     GIR_EraseRootFromParent_Done,
     /*  313516 */   // Label 5799: @313516
     /*  313516 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(313582), // Rule ID 13992 //
     /*  313521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  313532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  313535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  313538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313580 */     GIR_RootConstrainSelectedInstOperands,
     /*  313581 */     // GIR_Coverage, 13992,
     /*  313581 */     GIR_EraseRootFromParent_Done,
     /*  313582 */   // Label 5800: @313582
     /*  313582 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(313648), // Rule ID 13993 //
     /*  313587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  313598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  313601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  313604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313646 */     GIR_RootConstrainSelectedInstOperands,
     /*  313647 */     // GIR_Coverage, 13993,
     /*  313647 */     GIR_EraseRootFromParent_Done,
     /*  313648 */   // Label 5801: @313648
     /*  313648 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(313714), // Rule ID 13994 //
     /*  313653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  313664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  313667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  313670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313692 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313712 */     GIR_RootConstrainSelectedInstOperands,
     /*  313713 */     // GIR_Coverage, 13994,
     /*  313713 */     GIR_EraseRootFromParent_Done,
     /*  313714 */   // Label 5802: @313714
     /*  313714 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(313780), // Rule ID 13995 //
     /*  313719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  313730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  313733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  313736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313758 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313778 */     GIR_RootConstrainSelectedInstOperands,
     /*  313779 */     // GIR_Coverage, 13995,
     /*  313779 */     GIR_EraseRootFromParent_Done,
     /*  313780 */   // Label 5803: @313780
     /*  313780 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(313846), // Rule ID 13996 //
     /*  313785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  313796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  313799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  313802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  313824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313844 */     GIR_RootConstrainSelectedInstOperands,
     /*  313845 */     // GIR_Coverage, 13996,
     /*  313845 */     GIR_EraseRootFromParent_Done,
     /*  313846 */   // Label 5804: @313846
     /*  313846 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(313912), // Rule ID 13997 //
     /*  313851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  313862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  313865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  313868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313890 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  313890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  313907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313910 */     GIR_RootConstrainSelectedInstOperands,
     /*  313911 */     // GIR_Coverage, 13997,
     /*  313911 */     GIR_EraseRootFromParent_Done,
     /*  313912 */   // Label 5805: @313912
     /*  313912 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(313978), // Rule ID 13998 //
     /*  313917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  313920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  313959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313976 */     GIR_RootConstrainSelectedInstOperands,
     /*  313977 */     // GIR_Coverage, 13998,
     /*  313977 */     GIR_EraseRootFromParent_Done,
     /*  313978 */   // Label 5806: @313978
     /*  313978 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(314044), // Rule ID 13999 //
     /*  313983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  313986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  314000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314042 */     GIR_RootConstrainSelectedInstOperands,
     /*  314043 */     // GIR_Coverage, 13999,
     /*  314043 */     GIR_EraseRootFromParent_Done,
     /*  314044 */   // Label 5807: @314044
     /*  314044 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(314110), // Rule ID 14000 //
     /*  314049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314088 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314108 */     GIR_RootConstrainSelectedInstOperands,
     /*  314109 */     // GIR_Coverage, 14000,
     /*  314109 */     GIR_EraseRootFromParent_Done,
     /*  314110 */   // Label 5808: @314110
     /*  314110 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(314176), // Rule ID 14001 //
     /*  314115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314174 */     GIR_RootConstrainSelectedInstOperands,
     /*  314175 */     // GIR_Coverage, 14001,
     /*  314175 */     GIR_EraseRootFromParent_Done,
     /*  314176 */   // Label 5809: @314176
     /*  314176 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(314242), // Rule ID 14002 //
     /*  314181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314240 */     GIR_RootConstrainSelectedInstOperands,
     /*  314241 */     // GIR_Coverage, 14002,
     /*  314241 */     GIR_EraseRootFromParent_Done,
     /*  314242 */   // Label 5810: @314242
     /*  314242 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(314308), // Rule ID 14003 //
     /*  314247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314306 */     GIR_RootConstrainSelectedInstOperands,
     /*  314307 */     // GIR_Coverage, 14003,
     /*  314307 */     GIR_EraseRootFromParent_Done,
     /*  314308 */   // Label 5811: @314308
     /*  314308 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(314374), // Rule ID 14004 //
     /*  314313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314372 */     GIR_RootConstrainSelectedInstOperands,
     /*  314373 */     // GIR_Coverage, 14004,
     /*  314373 */     GIR_EraseRootFromParent_Done,
     /*  314374 */   // Label 5812: @314374
     /*  314374 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(314440), // Rule ID 14005 //
     /*  314379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314438 */     GIR_RootConstrainSelectedInstOperands,
     /*  314439 */     // GIR_Coverage, 14005,
     /*  314439 */     GIR_EraseRootFromParent_Done,
     /*  314440 */   // Label 5813: @314440
     /*  314440 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(314506), // Rule ID 14006 //
     /*  314445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314504 */     GIR_RootConstrainSelectedInstOperands,
     /*  314505 */     // GIR_Coverage, 14006,
     /*  314505 */     GIR_EraseRootFromParent_Done,
     /*  314506 */   // Label 5814: @314506
     /*  314506 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(314572), // Rule ID 14007 //
     /*  314511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314570 */     GIR_RootConstrainSelectedInstOperands,
     /*  314571 */     // GIR_Coverage, 14007,
     /*  314571 */     GIR_EraseRootFromParent_Done,
     /*  314572 */   // Label 5815: @314572
     /*  314572 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(314638), // Rule ID 14008 //
     /*  314577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  314580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314636 */     GIR_RootConstrainSelectedInstOperands,
     /*  314637 */     // GIR_Coverage, 14008,
     /*  314637 */     GIR_EraseRootFromParent_Done,
     /*  314638 */   // Label 5816: @314638
     /*  314638 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(314704), // Rule ID 14009 //
     /*  314643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  314646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  314685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314702 */     GIR_RootConstrainSelectedInstOperands,
     /*  314703 */     // GIR_Coverage, 14009,
     /*  314703 */     GIR_EraseRootFromParent_Done,
     /*  314704 */   // Label 5817: @314704
     /*  314704 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(314770), // Rule ID 14010 //
     /*  314709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314768 */     GIR_RootConstrainSelectedInstOperands,
     /*  314769 */     // GIR_Coverage, 14010,
     /*  314769 */     GIR_EraseRootFromParent_Done,
     /*  314770 */   // Label 5818: @314770
     /*  314770 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(314836), // Rule ID 14011 //
     /*  314775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  314778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  314817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314834 */     GIR_RootConstrainSelectedInstOperands,
     /*  314835 */     // GIR_Coverage, 14011,
     /*  314835 */     GIR_EraseRootFromParent_Done,
     /*  314836 */   // Label 5819: @314836
     /*  314836 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(314902), // Rule ID 14012 //
     /*  314841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314900 */     GIR_RootConstrainSelectedInstOperands,
     /*  314901 */     // GIR_Coverage, 14012,
     /*  314901 */     GIR_EraseRootFromParent_Done,
     /*  314902 */   // Label 5820: @314902
     /*  314902 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(314968), // Rule ID 14013 //
     /*  314907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  314910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  314949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  314955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314966 */     GIR_RootConstrainSelectedInstOperands,
     /*  314967 */     // GIR_Coverage, 14013,
     /*  314967 */     GIR_EraseRootFromParent_Done,
     /*  314968 */   // Label 5821: @314968
     /*  314968 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(315034), // Rule ID 14014 //
     /*  314973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  314976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  314981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  315015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315032 */     GIR_RootConstrainSelectedInstOperands,
     /*  315033 */     // GIR_Coverage, 14014,
     /*  315033 */     GIR_EraseRootFromParent_Done,
     /*  315034 */   // Label 5822: @315034
     /*  315034 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(315100), // Rule ID 14015 //
     /*  315039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  315042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  315081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315098 */     GIR_RootConstrainSelectedInstOperands,
     /*  315099 */     // GIR_Coverage, 14015,
     /*  315099 */     GIR_EraseRootFromParent_Done,
     /*  315100 */   // Label 5823: @315100
     /*  315100 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(315166), // Rule ID 14016 //
     /*  315105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  315116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315144 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  315147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315164 */     GIR_RootConstrainSelectedInstOperands,
     /*  315165 */     // GIR_Coverage, 14016,
     /*  315165 */     GIR_EraseRootFromParent_Done,
     /*  315166 */   // Label 5824: @315166
     /*  315166 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(315232), // Rule ID 14017 //
     /*  315171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  315182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  315213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315230 */     GIR_RootConstrainSelectedInstOperands,
     /*  315231 */     // GIR_Coverage, 14017,
     /*  315231 */     GIR_EraseRootFromParent_Done,
     /*  315232 */   // Label 5825: @315232
     /*  315232 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(315298), // Rule ID 14018 //
     /*  315237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  315248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315276 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315296 */     GIR_RootConstrainSelectedInstOperands,
     /*  315297 */     // GIR_Coverage, 14018,
     /*  315297 */     GIR_EraseRootFromParent_Done,
     /*  315298 */   // Label 5826: @315298
     /*  315298 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(315364), // Rule ID 14019 //
     /*  315303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  315314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315342 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315362 */     GIR_RootConstrainSelectedInstOperands,
     /*  315363 */     // GIR_Coverage, 14019,
     /*  315363 */     GIR_EraseRootFromParent_Done,
     /*  315364 */   // Label 5827: @315364
     /*  315364 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(315430), // Rule ID 14020 //
     /*  315369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315408 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315428 */     GIR_RootConstrainSelectedInstOperands,
     /*  315429 */     // GIR_Coverage, 14020,
     /*  315429 */     GIR_EraseRootFromParent_Done,
     /*  315430 */   // Label 5828: @315430
     /*  315430 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(315496), // Rule ID 14021 //
     /*  315435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  315446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315474 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  315477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315494 */     GIR_RootConstrainSelectedInstOperands,
     /*  315495 */     // GIR_Coverage, 14021,
     /*  315495 */     GIR_EraseRootFromParent_Done,
     /*  315496 */   // Label 5829: @315496
     /*  315496 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(315562), // Rule ID 14022 //
     /*  315501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  315512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315560 */     GIR_RootConstrainSelectedInstOperands,
     /*  315561 */     // GIR_Coverage, 14022,
     /*  315561 */     GIR_EraseRootFromParent_Done,
     /*  315562 */   // Label 5830: @315562
     /*  315562 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(315628), // Rule ID 14023 //
     /*  315567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  315578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315606 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  315606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315626 */     GIR_RootConstrainSelectedInstOperands,
     /*  315627 */     // GIR_Coverage, 14023,
     /*  315627 */     GIR_EraseRootFromParent_Done,
     /*  315628 */   // Label 5831: @315628
     /*  315628 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(315694), // Rule ID 14024 //
     /*  315633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315672 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  315672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315692 */     GIR_RootConstrainSelectedInstOperands,
     /*  315693 */     // GIR_Coverage, 14024,
     /*  315693 */     GIR_EraseRootFromParent_Done,
     /*  315694 */   // Label 5832: @315694
     /*  315694 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(315760), // Rule ID 14025 //
     /*  315699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  315710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315738 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  315738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315758 */     GIR_RootConstrainSelectedInstOperands,
     /*  315759 */     // GIR_Coverage, 14025,
     /*  315759 */     GIR_EraseRootFromParent_Done,
     /*  315760 */   // Label 5833: @315760
     /*  315760 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(315826), // Rule ID 14026 //
     /*  315765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  315776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  315804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315824 */     GIR_RootConstrainSelectedInstOperands,
     /*  315825 */     // GIR_Coverage, 14026,
     /*  315825 */     GIR_EraseRootFromParent_Done,
     /*  315826 */   // Label 5834: @315826
     /*  315826 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(315892), // Rule ID 14027 //
     /*  315831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  315842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  315873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315890 */     GIR_RootConstrainSelectedInstOperands,
     /*  315891 */     // GIR_Coverage, 14027,
     /*  315891 */     GIR_EraseRootFromParent_Done,
     /*  315892 */   // Label 5835: @315892
     /*  315892 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(315958), // Rule ID 14028 //
     /*  315897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  315900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  315908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315936 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  315936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  315939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  315945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315956 */     GIR_RootConstrainSelectedInstOperands,
     /*  315957 */     // GIR_Coverage, 14028,
     /*  315957 */     GIR_EraseRootFromParent_Done,
     /*  315958 */   // Label 5836: @315958
     /*  315958 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(316024), // Rule ID 14029 //
     /*  315963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  315966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  315971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  315974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316002 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316022 */     GIR_RootConstrainSelectedInstOperands,
     /*  316023 */     // GIR_Coverage, 14029,
     /*  316023 */     GIR_EraseRootFromParent_Done,
     /*  316024 */   // Label 5837: @316024
     /*  316024 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(316090), // Rule ID 14030 //
     /*  316029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  316032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  316040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316068 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316088 */     GIR_RootConstrainSelectedInstOperands,
     /*  316089 */     // GIR_Coverage, 14030,
     /*  316089 */     GIR_EraseRootFromParent_Done,
     /*  316090 */   // Label 5838: @316090
     /*  316090 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(316156), // Rule ID 14031 //
     /*  316095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  316098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  316106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316134 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316154 */     GIR_RootConstrainSelectedInstOperands,
     /*  316155 */     // GIR_Coverage, 14031,
     /*  316155 */     GIR_EraseRootFromParent_Done,
     /*  316156 */   // Label 5839: @316156
     /*  316156 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(316222), // Rule ID 14032 //
     /*  316161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  316164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  316172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  316200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316220 */     GIR_RootConstrainSelectedInstOperands,
     /*  316221 */     // GIR_Coverage, 14032,
     /*  316221 */     GIR_EraseRootFromParent_Done,
     /*  316222 */   // Label 5840: @316222
     /*  316222 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(316288), // Rule ID 14033 //
     /*  316227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  316230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  316238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316266 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  316266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316286 */     GIR_RootConstrainSelectedInstOperands,
     /*  316287 */     // GIR_Coverage, 14033,
     /*  316287 */     GIR_EraseRootFromParent_Done,
     /*  316288 */   // Label 5841: @316288
     /*  316288 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(316354), // Rule ID 14034 //
     /*  316293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  316304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316352 */     GIR_RootConstrainSelectedInstOperands,
     /*  316353 */     // GIR_Coverage, 14034,
     /*  316353 */     GIR_EraseRootFromParent_Done,
     /*  316354 */   // Label 5842: @316354
     /*  316354 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(316420), // Rule ID 14035 //
     /*  316359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  316370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316398 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316418 */     GIR_RootConstrainSelectedInstOperands,
     /*  316419 */     // GIR_Coverage, 14035,
     /*  316419 */     GIR_EraseRootFromParent_Done,
     /*  316420 */   // Label 5843: @316420
     /*  316420 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(316486), // Rule ID 14036 //
     /*  316425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  316436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316484 */     GIR_RootConstrainSelectedInstOperands,
     /*  316485 */     // GIR_Coverage, 14036,
     /*  316485 */     GIR_EraseRootFromParent_Done,
     /*  316486 */   // Label 5844: @316486
     /*  316486 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(316552), // Rule ID 14037 //
     /*  316491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  316502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316550 */     GIR_RootConstrainSelectedInstOperands,
     /*  316551 */     // GIR_Coverage, 14037,
     /*  316551 */     GIR_EraseRootFromParent_Done,
     /*  316552 */   // Label 5845: @316552
     /*  316552 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(316618), // Rule ID 14038 //
     /*  316557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  316568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316596 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  316596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316616 */     GIR_RootConstrainSelectedInstOperands,
     /*  316617 */     // GIR_Coverage, 14038,
     /*  316617 */     GIR_EraseRootFromParent_Done,
     /*  316618 */   // Label 5846: @316618
     /*  316618 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(316684), // Rule ID 14039 //
     /*  316623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  316634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316662 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  316662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316682 */     GIR_RootConstrainSelectedInstOperands,
     /*  316683 */     // GIR_Coverage, 14039,
     /*  316683 */     GIR_EraseRootFromParent_Done,
     /*  316684 */   // Label 5847: @316684
     /*  316684 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(316750), // Rule ID 14040 //
     /*  316689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  316700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316728 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316748 */     GIR_RootConstrainSelectedInstOperands,
     /*  316749 */     // GIR_Coverage, 14040,
     /*  316749 */     GIR_EraseRootFromParent_Done,
     /*  316750 */   // Label 5848: @316750
     /*  316750 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(316816), // Rule ID 14041 //
     /*  316755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  316766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316794 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  316794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  316797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316814 */     GIR_RootConstrainSelectedInstOperands,
     /*  316815 */     // GIR_Coverage, 14041,
     /*  316815 */     GIR_EraseRootFromParent_Done,
     /*  316816 */   // Label 5849: @316816
     /*  316816 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(316882), // Rule ID 14042 //
     /*  316821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  316832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316860 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316880 */     GIR_RootConstrainSelectedInstOperands,
     /*  316881 */     // GIR_Coverage, 14042,
     /*  316881 */     GIR_EraseRootFromParent_Done,
     /*  316882 */   // Label 5850: @316882
     /*  316882 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(316948), // Rule ID 14043 //
     /*  316887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  316898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316926 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  316926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  316929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  316935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  316946 */     GIR_RootConstrainSelectedInstOperands,
     /*  316947 */     // GIR_Coverage, 14043,
     /*  316947 */     GIR_EraseRootFromParent_Done,
     /*  316948 */   // Label 5851: @316948
     /*  316948 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(317014), // Rule ID 14044 //
     /*  316953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  316961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  316964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316992 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  316992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  316995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  316999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  317001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317012 */     GIR_RootConstrainSelectedInstOperands,
     /*  317013 */     // GIR_Coverage, 14044,
     /*  317013 */     GIR_EraseRootFromParent_Done,
     /*  317014 */   // Label 5852: @317014
     /*  317014 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(317080), // Rule ID 14045 //
     /*  317019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  317027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  317030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  317033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  317036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317058 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  317058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  317061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  317067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317078 */     GIR_RootConstrainSelectedInstOperands,
     /*  317079 */     // GIR_Coverage, 14045,
     /*  317079 */     GIR_EraseRootFromParent_Done,
     /*  317080 */   // Label 5853: @317080
     /*  317080 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(317146), // Rule ID 19048 //
     /*  317085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  317096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  317102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317124 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  317127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317144 */     GIR_RootConstrainSelectedInstOperands,
     /*  317145 */     // GIR_Coverage, 19048,
     /*  317145 */     GIR_EraseRootFromParent_Done,
     /*  317146 */   // Label 5854: @317146
     /*  317146 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(317212), // Rule ID 19049 //
     /*  317151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  317162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  317168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317190 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  317193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317210 */     GIR_RootConstrainSelectedInstOperands,
     /*  317211 */     // GIR_Coverage, 19049,
     /*  317211 */     GIR_EraseRootFromParent_Done,
     /*  317212 */   // Label 5855: @317212
     /*  317212 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(317278), // Rule ID 19052 //
     /*  317217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  317234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  317259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317276 */     GIR_RootConstrainSelectedInstOperands,
     /*  317277 */     // GIR_Coverage, 19052,
     /*  317277 */     GIR_EraseRootFromParent_Done,
     /*  317278 */   // Label 5856: @317278
     /*  317278 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(317344), // Rule ID 19053 //
     /*  317283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  317294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  317300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  317325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317342 */     GIR_RootConstrainSelectedInstOperands,
     /*  317343 */     // GIR_Coverage, 19053,
     /*  317343 */     GIR_EraseRootFromParent_Done,
     /*  317344 */   // Label 5857: @317344
     /*  317344 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(317410), // Rule ID 19056 //
     /*  317349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  317366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317388 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  317391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317408 */     GIR_RootConstrainSelectedInstOperands,
     /*  317409 */     // GIR_Coverage, 19056,
     /*  317409 */     GIR_EraseRootFromParent_Done,
     /*  317410 */   // Label 5858: @317410
     /*  317410 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(317476), // Rule ID 19057 //
     /*  317415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  317426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  317432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  317457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317474 */     GIR_RootConstrainSelectedInstOperands,
     /*  317475 */     // GIR_Coverage, 19057,
     /*  317475 */     GIR_EraseRootFromParent_Done,
     /*  317476 */   // Label 5859: @317476
     /*  317476 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(317542), // Rule ID 19060 //
     /*  317481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  317498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317520 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  317520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  317523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317540 */     GIR_RootConstrainSelectedInstOperands,
     /*  317541 */     // GIR_Coverage, 19060,
     /*  317541 */     GIR_EraseRootFromParent_Done,
     /*  317542 */   // Label 5860: @317542
     /*  317542 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(317608), // Rule ID 19061 //
     /*  317547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  317558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  317564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317586 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  317586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  317589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317606 */     GIR_RootConstrainSelectedInstOperands,
     /*  317607 */     // GIR_Coverage, 19061,
     /*  317607 */     GIR_EraseRootFromParent_Done,
     /*  317608 */   // Label 5861: @317608
     /*  317608 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(317674), // Rule ID 19064 //
     /*  317613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  317624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  317652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  317655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317672 */     GIR_RootConstrainSelectedInstOperands,
     /*  317673 */     // GIR_Coverage, 19064,
     /*  317673 */     GIR_EraseRootFromParent_Done,
     /*  317674 */   // Label 5862: @317674
     /*  317674 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(317740), // Rule ID 19065 //
     /*  317679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  317690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  317696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317718 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  317718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  317721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317738 */     GIR_RootConstrainSelectedInstOperands,
     /*  317739 */     // GIR_Coverage, 19065,
     /*  317739 */     GIR_EraseRootFromParent_Done,
     /*  317740 */   // Label 5863: @317740
     /*  317740 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(317806), // Rule ID 19068 //
     /*  317745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  317762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317784 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  317787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317804 */     GIR_RootConstrainSelectedInstOperands,
     /*  317805 */     // GIR_Coverage, 19068,
     /*  317805 */     GIR_EraseRootFromParent_Done,
     /*  317806 */   // Label 5864: @317806
     /*  317806 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(317872), // Rule ID 19069 //
     /*  317811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  317822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  317828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  317853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317870 */     GIR_RootConstrainSelectedInstOperands,
     /*  317871 */     // GIR_Coverage, 19069,
     /*  317871 */     GIR_EraseRootFromParent_Done,
     /*  317872 */   // Label 5865: @317872
     /*  317872 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(317938), // Rule ID 19072 //
     /*  317877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  317894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  317916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  317919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  317936 */     GIR_RootConstrainSelectedInstOperands,
     /*  317937 */     // GIR_Coverage, 19072,
     /*  317937 */     GIR_EraseRootFromParent_Done,
     /*  317938 */   // Label 5866: @317938
     /*  317938 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(318004), // Rule ID 19073 //
     /*  317943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  317951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  317954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  317960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317982 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  317982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  317985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  317989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318002 */     GIR_RootConstrainSelectedInstOperands,
     /*  318003 */     // GIR_Coverage, 19073,
     /*  318003 */     GIR_EraseRootFromParent_Done,
     /*  318004 */   // Label 5867: @318004
     /*  318004 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(318070), // Rule ID 19076 //
     /*  318009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  318020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  318026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318048 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  318048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  318051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318068 */     GIR_RootConstrainSelectedInstOperands,
     /*  318069 */     // GIR_Coverage, 19076,
     /*  318069 */     GIR_EraseRootFromParent_Done,
     /*  318070 */   // Label 5868: @318070
     /*  318070 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(318136), // Rule ID 19077 //
     /*  318075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  318086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  318092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318114 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  318114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  318117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318134 */     GIR_RootConstrainSelectedInstOperands,
     /*  318135 */     // GIR_Coverage, 19077,
     /*  318135 */     GIR_EraseRootFromParent_Done,
     /*  318136 */   // Label 5869: @318136
     /*  318136 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(318202), // Rule ID 19080 //
     /*  318141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  318152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  318158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318180 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  318183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318200 */     GIR_RootConstrainSelectedInstOperands,
     /*  318201 */     // GIR_Coverage, 19080,
     /*  318201 */     GIR_EraseRootFromParent_Done,
     /*  318202 */   // Label 5870: @318202
     /*  318202 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(318268), // Rule ID 19081 //
     /*  318207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  318218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  318224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  318249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318266 */     GIR_RootConstrainSelectedInstOperands,
     /*  318267 */     // GIR_Coverage, 19081,
     /*  318267 */     GIR_EraseRootFromParent_Done,
     /*  318268 */   // Label 5871: @318268
     /*  318268 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(318334), // Rule ID 19084 //
     /*  318273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  318284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  318290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318312 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  318315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318332 */     GIR_RootConstrainSelectedInstOperands,
     /*  318333 */     // GIR_Coverage, 19084,
     /*  318333 */     GIR_EraseRootFromParent_Done,
     /*  318334 */   // Label 5872: @318334
     /*  318334 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(318400), // Rule ID 19085 //
     /*  318339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  318350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  318356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318378 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  318381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318398 */     GIR_RootConstrainSelectedInstOperands,
     /*  318399 */     // GIR_Coverage, 19085,
     /*  318399 */     GIR_EraseRootFromParent_Done,
     /*  318400 */   // Label 5873: @318400
     /*  318400 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(318466), // Rule ID 19088 //
     /*  318405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  318416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  318422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  318444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  318447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318464 */     GIR_RootConstrainSelectedInstOperands,
     /*  318465 */     // GIR_Coverage, 19088,
     /*  318465 */     GIR_EraseRootFromParent_Done,
     /*  318466 */   // Label 5874: @318466
     /*  318466 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(318532), // Rule ID 19089 //
     /*  318471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  318482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  318488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318510 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  318510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  318513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318530 */     GIR_RootConstrainSelectedInstOperands,
     /*  318531 */     // GIR_Coverage, 19089,
     /*  318531 */     GIR_EraseRootFromParent_Done,
     /*  318532 */   // Label 5875: @318532
     /*  318532 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(318598), // Rule ID 19092 //
     /*  318537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  318548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  318554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318576 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  318579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318596 */     GIR_RootConstrainSelectedInstOperands,
     /*  318597 */     // GIR_Coverage, 19092,
     /*  318597 */     GIR_EraseRootFromParent_Done,
     /*  318598 */   // Label 5876: @318598
     /*  318598 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(318664), // Rule ID 19093 //
     /*  318603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  318614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  318620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  318645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318662 */     GIR_RootConstrainSelectedInstOperands,
     /*  318663 */     // GIR_Coverage, 19093,
     /*  318663 */     GIR_EraseRootFromParent_Done,
     /*  318664 */   // Label 5877: @318664
     /*  318664 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(318730), // Rule ID 19096 //
     /*  318669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  318680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  318686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318708 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  318711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318728 */     GIR_RootConstrainSelectedInstOperands,
     /*  318729 */     // GIR_Coverage, 19096,
     /*  318729 */     GIR_EraseRootFromParent_Done,
     /*  318730 */   // Label 5878: @318730
     /*  318730 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(318796), // Rule ID 19097 //
     /*  318735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  318746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  318752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318774 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  318777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318794 */     GIR_RootConstrainSelectedInstOperands,
     /*  318795 */     // GIR_Coverage, 19097,
     /*  318795 */     GIR_EraseRootFromParent_Done,
     /*  318796 */   // Label 5879: @318796
     /*  318796 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(318862), // Rule ID 19100 //
     /*  318801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  318812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  318818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  318840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  318843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318860 */     GIR_RootConstrainSelectedInstOperands,
     /*  318861 */     // GIR_Coverage, 19100,
     /*  318861 */     GIR_EraseRootFromParent_Done,
     /*  318862 */   // Label 5880: @318862
     /*  318862 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(318928), // Rule ID 19101 //
     /*  318867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  318875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  318878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  318884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318906 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  318906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  318909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  318913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  318926 */     GIR_RootConstrainSelectedInstOperands,
     /*  318927 */     // GIR_Coverage, 19101,
     /*  318927 */     GIR_EraseRootFromParent_Done,
     /*  318928 */   // Label 5881: @318928
     /*  318928 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(318991), // Rule ID 19764 //
     /*  318933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318972 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  318975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318989 */     GIR_RootConstrainSelectedInstOperands,
     /*  318990 */     // GIR_Coverage, 19764,
     /*  318990 */     GIR_EraseRootFromParent_Done,
     /*  318991 */   // Label 5882: @318991
     /*  318991 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(319054), // Rule ID 19765 //
     /*  318996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  319010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  319013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319035 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  319038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319052 */     GIR_RootConstrainSelectedInstOperands,
     /*  319053 */     // GIR_Coverage, 19765,
     /*  319053 */     GIR_EraseRootFromParent_Done,
     /*  319054 */   // Label 5883: @319054
     /*  319054 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(319117), // Rule ID 19768 //
     /*  319059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319115 */     GIR_RootConstrainSelectedInstOperands,
     /*  319116 */     // GIR_Coverage, 19768,
     /*  319116 */     GIR_EraseRootFromParent_Done,
     /*  319117 */   // Label 5884: @319117
     /*  319117 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(319180), // Rule ID 19769 //
     /*  319122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319161 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319178 */     GIR_RootConstrainSelectedInstOperands,
     /*  319179 */     // GIR_Coverage, 19769,
     /*  319179 */     GIR_EraseRootFromParent_Done,
     /*  319180 */   // Label 5885: @319180
     /*  319180 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(319243), // Rule ID 19772 //
     /*  319185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319241 */     GIR_RootConstrainSelectedInstOperands,
     /*  319242 */     // GIR_Coverage, 19772,
     /*  319242 */     GIR_EraseRootFromParent_Done,
     /*  319243 */   // Label 5886: @319243
     /*  319243 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(319306), // Rule ID 19773 //
     /*  319248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319287 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  319290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319304 */     GIR_RootConstrainSelectedInstOperands,
     /*  319305 */     // GIR_Coverage, 19773,
     /*  319305 */     GIR_EraseRootFromParent_Done,
     /*  319306 */   // Label 5887: @319306
     /*  319306 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(319369), // Rule ID 19776 //
     /*  319311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319350 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319367 */     GIR_RootConstrainSelectedInstOperands,
     /*  319368 */     // GIR_Coverage, 19776,
     /*  319368 */     GIR_EraseRootFromParent_Done,
     /*  319369 */   // Label 5888: @319369
     /*  319369 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(319432), // Rule ID 19777 //
     /*  319374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319413 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319430 */     GIR_RootConstrainSelectedInstOperands,
     /*  319431 */     // GIR_Coverage, 19777,
     /*  319431 */     GIR_EraseRootFromParent_Done,
     /*  319432 */   // Label 5889: @319432
     /*  319432 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(319495), // Rule ID 19780 //
     /*  319437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319493 */     GIR_RootConstrainSelectedInstOperands,
     /*  319494 */     // GIR_Coverage, 19780,
     /*  319494 */     GIR_EraseRootFromParent_Done,
     /*  319495 */   // Label 5890: @319495
     /*  319495 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(319558), // Rule ID 19781 //
     /*  319500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319556 */     GIR_RootConstrainSelectedInstOperands,
     /*  319557 */     // GIR_Coverage, 19781,
     /*  319557 */     GIR_EraseRootFromParent_Done,
     /*  319558 */   // Label 5891: @319558
     /*  319558 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(319621), // Rule ID 19784 //
     /*  319563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319602 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319619 */     GIR_RootConstrainSelectedInstOperands,
     /*  319620 */     // GIR_Coverage, 19784,
     /*  319620 */     GIR_EraseRootFromParent_Done,
     /*  319621 */   // Label 5892: @319621
     /*  319621 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(319684), // Rule ID 19785 //
     /*  319626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  319668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319682 */     GIR_RootConstrainSelectedInstOperands,
     /*  319683 */     // GIR_Coverage, 19785,
     /*  319683 */     GIR_EraseRootFromParent_Done,
     /*  319684 */   // Label 5893: @319684
     /*  319684 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(319747), // Rule ID 19788 //
     /*  319689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  319731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319745 */     GIR_RootConstrainSelectedInstOperands,
     /*  319746 */     // GIR_Coverage, 19788,
     /*  319746 */     GIR_EraseRootFromParent_Done,
     /*  319747 */   // Label 5894: @319747
     /*  319747 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(319810), // Rule ID 19789 //
     /*  319752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  319794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319808 */     GIR_RootConstrainSelectedInstOperands,
     /*  319809 */     // GIR_Coverage, 19789,
     /*  319809 */     GIR_EraseRootFromParent_Done,
     /*  319810 */   // Label 5895: @319810
     /*  319810 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(319873), // Rule ID 19792 //
     /*  319815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  319857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319871 */     GIR_RootConstrainSelectedInstOperands,
     /*  319872 */     // GIR_Coverage, 19792,
     /*  319872 */     GIR_EraseRootFromParent_Done,
     /*  319873 */   // Label 5896: @319873
     /*  319873 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(319936), // Rule ID 19793 //
     /*  319878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  319920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319934 */     GIR_RootConstrainSelectedInstOperands,
     /*  319935 */     // GIR_Coverage, 19793,
     /*  319935 */     GIR_EraseRootFromParent_Done,
     /*  319936 */   // Label 5897: @319936
     /*  319936 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(319999), // Rule ID 19796 //
     /*  319941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  319949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319980 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  319983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319997 */     GIR_RootConstrainSelectedInstOperands,
     /*  319998 */     // GIR_Coverage, 19796,
     /*  319998 */     GIR_EraseRootFromParent_Done,
     /*  319999 */   // Label 5898: @319999
     /*  319999 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(320062), // Rule ID 19797 //
     /*  320004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  320015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  320018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  320021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320043 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320060 */     GIR_RootConstrainSelectedInstOperands,
     /*  320061 */     // GIR_Coverage, 19797,
     /*  320061 */     GIR_EraseRootFromParent_Done,
     /*  320062 */   // Label 5899: @320062
     /*  320062 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(320125), // Rule ID 19800 //
     /*  320067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320123 */     GIR_RootConstrainSelectedInstOperands,
     /*  320124 */     // GIR_Coverage, 19800,
     /*  320124 */     GIR_EraseRootFromParent_Done,
     /*  320125 */   // Label 5900: @320125
     /*  320125 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(320188), // Rule ID 19801 //
     /*  320130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320186 */     GIR_RootConstrainSelectedInstOperands,
     /*  320187 */     // GIR_Coverage, 19801,
     /*  320187 */     GIR_EraseRootFromParent_Done,
     /*  320188 */   // Label 5901: @320188
     /*  320188 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(320251), // Rule ID 19804 //
     /*  320193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320249 */     GIR_RootConstrainSelectedInstOperands,
     /*  320250 */     // GIR_Coverage, 19804,
     /*  320250 */     GIR_EraseRootFromParent_Done,
     /*  320251 */   // Label 5902: @320251
     /*  320251 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(320314), // Rule ID 19805 //
     /*  320256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320295 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320312 */     GIR_RootConstrainSelectedInstOperands,
     /*  320313 */     // GIR_Coverage, 19805,
     /*  320313 */     GIR_EraseRootFromParent_Done,
     /*  320314 */   // Label 5903: @320314
     /*  320314 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(320377), // Rule ID 19808 //
     /*  320319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320358 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320375 */     GIR_RootConstrainSelectedInstOperands,
     /*  320376 */     // GIR_Coverage, 19808,
     /*  320376 */     GIR_EraseRootFromParent_Done,
     /*  320377 */   // Label 5904: @320377
     /*  320377 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(320440), // Rule ID 19809 //
     /*  320382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320438 */     GIR_RootConstrainSelectedInstOperands,
     /*  320439 */     // GIR_Coverage, 19809,
     /*  320439 */     GIR_EraseRootFromParent_Done,
     /*  320440 */   // Label 5905: @320440
     /*  320440 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(320503), // Rule ID 19812 //
     /*  320445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320501 */     GIR_RootConstrainSelectedInstOperands,
     /*  320502 */     // GIR_Coverage, 19812,
     /*  320502 */     GIR_EraseRootFromParent_Done,
     /*  320503 */   // Label 5906: @320503
     /*  320503 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(320566), // Rule ID 19813 //
     /*  320508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  320550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320564 */     GIR_RootConstrainSelectedInstOperands,
     /*  320565 */     // GIR_Coverage, 19813,
     /*  320565 */     GIR_EraseRootFromParent_Done,
     /*  320566 */   // Label 5907: @320566
     /*  320566 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(320629), // Rule ID 19816 //
     /*  320571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320627 */     GIR_RootConstrainSelectedInstOperands,
     /*  320628 */     // GIR_Coverage, 19816,
     /*  320628 */     GIR_EraseRootFromParent_Done,
     /*  320629 */   // Label 5908: @320629
     /*  320629 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(320692), // Rule ID 19817 //
     /*  320634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320673 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  320676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320690 */     GIR_RootConstrainSelectedInstOperands,
     /*  320691 */     // GIR_Coverage, 19817,
     /*  320691 */     GIR_EraseRootFromParent_Done,
     /*  320692 */   // Label 5909: @320692
     /*  320692 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(320755), // Rule ID 19820 //
     /*  320697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320753 */     GIR_RootConstrainSelectedInstOperands,
     /*  320754 */     // GIR_Coverage, 19820,
     /*  320754 */     GIR_EraseRootFromParent_Done,
     /*  320755 */   // Label 5910: @320755
     /*  320755 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(320818), // Rule ID 19821 //
     /*  320760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  320802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320816 */     GIR_RootConstrainSelectedInstOperands,
     /*  320817 */     // GIR_Coverage, 19821,
     /*  320817 */     GIR_EraseRootFromParent_Done,
     /*  320818 */   // Label 5911: @320818
     /*  320818 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(320881), // Rule ID 19824 //
     /*  320823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  320865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320879 */     GIR_RootConstrainSelectedInstOperands,
     /*  320880 */     // GIR_Coverage, 19824,
     /*  320880 */     GIR_EraseRootFromParent_Done,
     /*  320881 */   // Label 5912: @320881
     /*  320881 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(320944), // Rule ID 19825 //
     /*  320886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  320928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320942 */     GIR_RootConstrainSelectedInstOperands,
     /*  320943 */     // GIR_Coverage, 19825,
     /*  320943 */     GIR_EraseRootFromParent_Done,
     /*  320944 */   // Label 5913: @320944
     /*  320944 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(321007), // Rule ID 19828 //
     /*  320949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  320957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  320991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321005 */     GIR_RootConstrainSelectedInstOperands,
     /*  321006 */     // GIR_Coverage, 19828,
     /*  321006 */     GIR_EraseRootFromParent_Done,
     /*  321007 */   // Label 5914: @321007
     /*  321007 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(321070), // Rule ID 19829 //
     /*  321012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  321026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  321054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321068 */     GIR_RootConstrainSelectedInstOperands,
     /*  321069 */     // GIR_Coverage, 19829,
     /*  321069 */     GIR_EraseRootFromParent_Done,
     /*  321070 */   // Label 5915: @321070
     /*  321070 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(321133), // Rule ID 19832 //
     /*  321075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  321117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321131 */     GIR_RootConstrainSelectedInstOperands,
     /*  321132 */     // GIR_Coverage, 19832,
     /*  321132 */     GIR_EraseRootFromParent_Done,
     /*  321133 */   // Label 5916: @321133
     /*  321133 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(321196), // Rule ID 19833 //
     /*  321138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  321180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321194 */     GIR_RootConstrainSelectedInstOperands,
     /*  321195 */     // GIR_Coverage, 19833,
     /*  321195 */     GIR_EraseRootFromParent_Done,
     /*  321196 */   // Label 5917: @321196
     /*  321196 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(321259), // Rule ID 19836 //
     /*  321201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  321243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321257 */     GIR_RootConstrainSelectedInstOperands,
     /*  321258 */     // GIR_Coverage, 19836,
     /*  321258 */     GIR_EraseRootFromParent_Done,
     /*  321259 */   // Label 5918: @321259
     /*  321259 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(321322), // Rule ID 19837 //
     /*  321264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321303 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  321306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321320 */     GIR_RootConstrainSelectedInstOperands,
     /*  321321 */     // GIR_Coverage, 19837,
     /*  321321 */     GIR_EraseRootFromParent_Done,
     /*  321322 */   // Label 5919: @321322
     /*  321322 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(321385), // Rule ID 19840 //
     /*  321327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  321369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321383 */     GIR_RootConstrainSelectedInstOperands,
     /*  321384 */     // GIR_Coverage, 19840,
     /*  321384 */     GIR_EraseRootFromParent_Done,
     /*  321385 */   // Label 5920: @321385
     /*  321385 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(321448), // Rule ID 19841 //
     /*  321390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321429 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  321432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321446 */     GIR_RootConstrainSelectedInstOperands,
     /*  321447 */     // GIR_Coverage, 19841,
     /*  321447 */     GIR_EraseRootFromParent_Done,
     /*  321448 */   // Label 5921: @321448
     /*  321448 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(321511), // Rule ID 19844 //
     /*  321453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  321495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321509 */     GIR_RootConstrainSelectedInstOperands,
     /*  321510 */     // GIR_Coverage, 19844,
     /*  321510 */     GIR_EraseRootFromParent_Done,
     /*  321511 */   // Label 5922: @321511
     /*  321511 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(321574), // Rule ID 19845 //
     /*  321516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321555 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  321558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321572 */     GIR_RootConstrainSelectedInstOperands,
     /*  321573 */     // GIR_Coverage, 19845,
     /*  321573 */     GIR_EraseRootFromParent_Done,
     /*  321574 */   // Label 5923: @321574
     /*  321574 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(321637), // Rule ID 19848 //
     /*  321579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  321621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321635 */     GIR_RootConstrainSelectedInstOperands,
     /*  321636 */     // GIR_Coverage, 19848,
     /*  321636 */     GIR_EraseRootFromParent_Done,
     /*  321637 */   // Label 5924: @321637
     /*  321637 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(321700), // Rule ID 19849 //
     /*  321642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  321684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321698 */     GIR_RootConstrainSelectedInstOperands,
     /*  321699 */     // GIR_Coverage, 19849,
     /*  321699 */     GIR_EraseRootFromParent_Done,
     /*  321700 */   // Label 5925: @321700
     /*  321700 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(321763), // Rule ID 19852 //
     /*  321705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  321747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321761 */     GIR_RootConstrainSelectedInstOperands,
     /*  321762 */     // GIR_Coverage, 19852,
     /*  321762 */     GIR_EraseRootFromParent_Done,
     /*  321763 */   // Label 5926: @321763
     /*  321763 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(321826), // Rule ID 19853 //
     /*  321768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  321810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321824 */     GIR_RootConstrainSelectedInstOperands,
     /*  321825 */     // GIR_Coverage, 19853,
     /*  321825 */     GIR_EraseRootFromParent_Done,
     /*  321826 */   // Label 5927: @321826
     /*  321826 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(321889), // Rule ID 19856 //
     /*  321831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  321873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321887 */     GIR_RootConstrainSelectedInstOperands,
     /*  321888 */     // GIR_Coverage, 19856,
     /*  321888 */     GIR_EraseRootFromParent_Done,
     /*  321889 */   // Label 5928: @321889
     /*  321889 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(321952), // Rule ID 19857 //
     /*  321894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321933 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  321936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321950 */     GIR_RootConstrainSelectedInstOperands,
     /*  321951 */     // GIR_Coverage, 19857,
     /*  321951 */     GIR_EraseRootFromParent_Done,
     /*  321952 */   // Label 5929: @321952
     /*  321952 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(322015), // Rule ID 19860 //
     /*  321957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  321965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  321999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322013 */     GIR_RootConstrainSelectedInstOperands,
     /*  322014 */     // GIR_Coverage, 19860,
     /*  322014 */     GIR_EraseRootFromParent_Done,
     /*  322015 */   // Label 5930: @322015
     /*  322015 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(322078), // Rule ID 19861 //
     /*  322020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  322034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  322062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322076 */     GIR_RootConstrainSelectedInstOperands,
     /*  322077 */     // GIR_Coverage, 19861,
     /*  322077 */     GIR_EraseRootFromParent_Done,
     /*  322078 */   // Label 5931: @322078
     /*  322078 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(322141), // Rule ID 19864 //
     /*  322083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  322125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322139 */     GIR_RootConstrainSelectedInstOperands,
     /*  322140 */     // GIR_Coverage, 19864,
     /*  322140 */     GIR_EraseRootFromParent_Done,
     /*  322141 */   // Label 5932: @322141
     /*  322141 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(322204), // Rule ID 19865 //
     /*  322146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  322188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322202 */     GIR_RootConstrainSelectedInstOperands,
     /*  322203 */     // GIR_Coverage, 19865,
     /*  322203 */     GIR_EraseRootFromParent_Done,
     /*  322204 */   // Label 5933: @322204
     /*  322204 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(322267), // Rule ID 19868 //
     /*  322209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322248 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  322251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322265 */     GIR_RootConstrainSelectedInstOperands,
     /*  322266 */     // GIR_Coverage, 19868,
     /*  322266 */     GIR_EraseRootFromParent_Done,
     /*  322267 */   // Label 5934: @322267
     /*  322267 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(322330), // Rule ID 19869 //
     /*  322272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  322314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322328 */     GIR_RootConstrainSelectedInstOperands,
     /*  322329 */     // GIR_Coverage, 19869,
     /*  322329 */     GIR_EraseRootFromParent_Done,
     /*  322330 */   // Label 5935: @322330
     /*  322330 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(322393), // Rule ID 19872 //
     /*  322335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  322377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322391 */     GIR_RootConstrainSelectedInstOperands,
     /*  322392 */     // GIR_Coverage, 19872,
     /*  322392 */     GIR_EraseRootFromParent_Done,
     /*  322393 */   // Label 5936: @322393
     /*  322393 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(322456), // Rule ID 19873 //
     /*  322398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  322440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322454 */     GIR_RootConstrainSelectedInstOperands,
     /*  322455 */     // GIR_Coverage, 19873,
     /*  322455 */     GIR_EraseRootFromParent_Done,
     /*  322456 */   // Label 5937: @322456
     /*  322456 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(322519), // Rule ID 19876 //
     /*  322461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  322503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322517 */     GIR_RootConstrainSelectedInstOperands,
     /*  322518 */     // GIR_Coverage, 19876,
     /*  322518 */     GIR_EraseRootFromParent_Done,
     /*  322519 */   // Label 5938: @322519
     /*  322519 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(322582), // Rule ID 19877 //
     /*  322524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  322566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322580 */     GIR_RootConstrainSelectedInstOperands,
     /*  322581 */     // GIR_Coverage, 19877,
     /*  322581 */     GIR_EraseRootFromParent_Done,
     /*  322582 */   // Label 5939: @322582
     /*  322582 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(322645), // Rule ID 19880 //
     /*  322587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  322629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322643 */     GIR_RootConstrainSelectedInstOperands,
     /*  322644 */     // GIR_Coverage, 19880,
     /*  322644 */     GIR_EraseRootFromParent_Done,
     /*  322645 */   // Label 5940: @322645
     /*  322645 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(322708), // Rule ID 19881 //
     /*  322650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  322658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322689 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  322692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322706 */     GIR_RootConstrainSelectedInstOperands,
     /*  322707 */     // GIR_Coverage, 19881,
     /*  322707 */     GIR_EraseRootFromParent_Done,
     /*  322708 */   // Label 5941: @322708
     /*  322708 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(322771), // Rule ID 19884 //
     /*  322713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  322755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322769 */     GIR_RootConstrainSelectedInstOperands,
     /*  322770 */     // GIR_Coverage, 19884,
     /*  322770 */     GIR_EraseRootFromParent_Done,
     /*  322771 */   // Label 5942: @322771
     /*  322771 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(322834), // Rule ID 19885 //
     /*  322776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322815 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  322818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322832 */     GIR_RootConstrainSelectedInstOperands,
     /*  322833 */     // GIR_Coverage, 19885,
     /*  322833 */     GIR_EraseRootFromParent_Done,
     /*  322834 */   // Label 5943: @322834
     /*  322834 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(322897), // Rule ID 19888 //
     /*  322839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322878 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  322881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322895 */     GIR_RootConstrainSelectedInstOperands,
     /*  322896 */     // GIR_Coverage, 19888,
     /*  322896 */     GIR_EraseRootFromParent_Done,
     /*  322897 */   // Label 5944: @322897
     /*  322897 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(322960), // Rule ID 19889 //
     /*  322902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322941 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  322944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322958 */     GIR_RootConstrainSelectedInstOperands,
     /*  322959 */     // GIR_Coverage, 19889,
     /*  322959 */     GIR_EraseRootFromParent_Done,
     /*  322960 */   // Label 5945: @322960
     /*  322960 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(323023), // Rule ID 19892 //
     /*  322965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  323007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323021 */     GIR_RootConstrainSelectedInstOperands,
     /*  323022 */     // GIR_Coverage, 19892,
     /*  323022 */     GIR_EraseRootFromParent_Done,
     /*  323023 */   // Label 5946: @323023
     /*  323023 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(323086), // Rule ID 19893 //
     /*  323028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  323042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  323045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  323070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323084 */     GIR_RootConstrainSelectedInstOperands,
     /*  323085 */     // GIR_Coverage, 19893,
     /*  323085 */     GIR_EraseRootFromParent_Done,
     /*  323086 */   // Label 5947: @323086
     /*  323086 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(323149), // Rule ID 19896 //
     /*  323091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323147 */     GIR_RootConstrainSelectedInstOperands,
     /*  323148 */     // GIR_Coverage, 19896,
     /*  323148 */     GIR_EraseRootFromParent_Done,
     /*  323149 */   // Label 5948: @323149
     /*  323149 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(323212), // Rule ID 19897 //
     /*  323154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323210 */     GIR_RootConstrainSelectedInstOperands,
     /*  323211 */     // GIR_Coverage, 19897,
     /*  323211 */     GIR_EraseRootFromParent_Done,
     /*  323212 */   // Label 5949: @323212
     /*  323212 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(323275), // Rule ID 19900 //
     /*  323217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323273 */     GIR_RootConstrainSelectedInstOperands,
     /*  323274 */     // GIR_Coverage, 19900,
     /*  323274 */     GIR_EraseRootFromParent_Done,
     /*  323275 */   // Label 5950: @323275
     /*  323275 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(323338), // Rule ID 19901 //
     /*  323280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323336 */     GIR_RootConstrainSelectedInstOperands,
     /*  323337 */     // GIR_Coverage, 19901,
     /*  323337 */     GIR_EraseRootFromParent_Done,
     /*  323338 */   // Label 5951: @323338
     /*  323338 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(323401), // Rule ID 19904 //
     /*  323343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323399 */     GIR_RootConstrainSelectedInstOperands,
     /*  323400 */     // GIR_Coverage, 19904,
     /*  323400 */     GIR_EraseRootFromParent_Done,
     /*  323401 */   // Label 5952: @323401
     /*  323401 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(323464), // Rule ID 19905 //
     /*  323406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  323448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323462 */     GIR_RootConstrainSelectedInstOperands,
     /*  323463 */     // GIR_Coverage, 19905,
     /*  323463 */     GIR_EraseRootFromParent_Done,
     /*  323464 */   // Label 5953: @323464
     /*  323464 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(323527), // Rule ID 19908 //
     /*  323469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323525 */     GIR_RootConstrainSelectedInstOperands,
     /*  323526 */     // GIR_Coverage, 19908,
     /*  323526 */     GIR_EraseRootFromParent_Done,
     /*  323527 */   // Label 5954: @323527
     /*  323527 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(323590), // Rule ID 19909 //
     /*  323532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323588 */     GIR_RootConstrainSelectedInstOperands,
     /*  323589 */     // GIR_Coverage, 19909,
     /*  323589 */     GIR_EraseRootFromParent_Done,
     /*  323590 */   // Label 5955: @323590
     /*  323590 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(323653), // Rule ID 19912 //
     /*  323595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  323637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323651 */     GIR_RootConstrainSelectedInstOperands,
     /*  323652 */     // GIR_Coverage, 19912,
     /*  323652 */     GIR_EraseRootFromParent_Done,
     /*  323653 */   // Label 5956: @323653
     /*  323653 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(323716), // Rule ID 19913 //
     /*  323658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  323700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323714 */     GIR_RootConstrainSelectedInstOperands,
     /*  323715 */     // GIR_Coverage, 19913,
     /*  323715 */     GIR_EraseRootFromParent_Done,
     /*  323716 */   // Label 5957: @323716
     /*  323716 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(323779), // Rule ID 19916 //
     /*  323721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323760 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  323763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323777 */     GIR_RootConstrainSelectedInstOperands,
     /*  323778 */     // GIR_Coverage, 19916,
     /*  323778 */     GIR_EraseRootFromParent_Done,
     /*  323779 */   // Label 5958: @323779
     /*  323779 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(323842), // Rule ID 19917 //
     /*  323784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323823 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  323826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323840 */     GIR_RootConstrainSelectedInstOperands,
     /*  323841 */     // GIR_Coverage, 19917,
     /*  323841 */     GIR_EraseRootFromParent_Done,
     /*  323842 */   // Label 5959: @323842
     /*  323842 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(323905), // Rule ID 19920 //
     /*  323847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323903 */     GIR_RootConstrainSelectedInstOperands,
     /*  323904 */     // GIR_Coverage, 19920,
     /*  323904 */     GIR_EraseRootFromParent_Done,
     /*  323905 */   // Label 5960: @323905
     /*  323905 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(323968), // Rule ID 19921 //
     /*  323910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  323952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323966 */     GIR_RootConstrainSelectedInstOperands,
     /*  323967 */     // GIR_Coverage, 19921,
     /*  323967 */     GIR_EraseRootFromParent_Done,
     /*  323968 */   // Label 5961: @323968
     /*  323968 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(324031), // Rule ID 19924 //
     /*  323973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  323981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324029 */     GIR_RootConstrainSelectedInstOperands,
     /*  324030 */     // GIR_Coverage, 19924,
     /*  324030 */     GIR_EraseRootFromParent_Done,
     /*  324031 */   // Label 5962: @324031
     /*  324031 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(324094), // Rule ID 19925 //
     /*  324036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  324050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  324053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324075 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324092 */     GIR_RootConstrainSelectedInstOperands,
     /*  324093 */     // GIR_Coverage, 19925,
     /*  324093 */     GIR_EraseRootFromParent_Done,
     /*  324094 */   // Label 5963: @324094
     /*  324094 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(324157), // Rule ID 19928 //
     /*  324099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324155 */     GIR_RootConstrainSelectedInstOperands,
     /*  324156 */     // GIR_Coverage, 19928,
     /*  324156 */     GIR_EraseRootFromParent_Done,
     /*  324157 */   // Label 5964: @324157
     /*  324157 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(324220), // Rule ID 19929 //
     /*  324162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324201 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324218 */     GIR_RootConstrainSelectedInstOperands,
     /*  324219 */     // GIR_Coverage, 19929,
     /*  324219 */     GIR_EraseRootFromParent_Done,
     /*  324220 */   // Label 5965: @324220
     /*  324220 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(324283), // Rule ID 19932 //
     /*  324225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  324267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324281 */     GIR_RootConstrainSelectedInstOperands,
     /*  324282 */     // GIR_Coverage, 19932,
     /*  324282 */     GIR_EraseRootFromParent_Done,
     /*  324283 */   // Label 5966: @324283
     /*  324283 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(324346), // Rule ID 19933 //
     /*  324288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324327 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  324330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324344 */     GIR_RootConstrainSelectedInstOperands,
     /*  324345 */     // GIR_Coverage, 19933,
     /*  324345 */     GIR_EraseRootFromParent_Done,
     /*  324346 */   // Label 5967: @324346
     /*  324346 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(324409), // Rule ID 19936 //
     /*  324351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324390 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324407 */     GIR_RootConstrainSelectedInstOperands,
     /*  324408 */     // GIR_Coverage, 19936,
     /*  324408 */     GIR_EraseRootFromParent_Done,
     /*  324409 */   // Label 5968: @324409
     /*  324409 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(324472), // Rule ID 19937 //
     /*  324414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324453 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  324456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324470 */     GIR_RootConstrainSelectedInstOperands,
     /*  324471 */     // GIR_Coverage, 19937,
     /*  324471 */     GIR_EraseRootFromParent_Done,
     /*  324472 */   // Label 5969: @324472
     /*  324472 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(324535), // Rule ID 19940 //
     /*  324477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324516 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324533 */     GIR_RootConstrainSelectedInstOperands,
     /*  324534 */     // GIR_Coverage, 19940,
     /*  324534 */     GIR_EraseRootFromParent_Done,
     /*  324535 */   // Label 5970: @324535
     /*  324535 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(324598), // Rule ID 19941 //
     /*  324540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324579 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  324582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324596 */     GIR_RootConstrainSelectedInstOperands,
     /*  324597 */     // GIR_Coverage, 19941,
     /*  324597 */     GIR_EraseRootFromParent_Done,
     /*  324598 */   // Label 5971: @324598
     /*  324598 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(324661), // Rule ID 19944 //
     /*  324603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  324645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324659 */     GIR_RootConstrainSelectedInstOperands,
     /*  324660 */     // GIR_Coverage, 19944,
     /*  324660 */     GIR_EraseRootFromParent_Done,
     /*  324661 */   // Label 5972: @324661
     /*  324661 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(324724), // Rule ID 19945 //
     /*  324666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324705 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  324708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324722 */     GIR_RootConstrainSelectedInstOperands,
     /*  324723 */     // GIR_Coverage, 19945,
     /*  324723 */     GIR_EraseRootFromParent_Done,
     /*  324724 */   // Label 5973: @324724
     /*  324724 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(324787), // Rule ID 19948 //
     /*  324729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  324771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324785 */     GIR_RootConstrainSelectedInstOperands,
     /*  324786 */     // GIR_Coverage, 19948,
     /*  324786 */     GIR_EraseRootFromParent_Done,
     /*  324787 */   // Label 5974: @324787
     /*  324787 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(324850), // Rule ID 19949 //
     /*  324792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324831 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  324834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324848 */     GIR_RootConstrainSelectedInstOperands,
     /*  324849 */     // GIR_Coverage, 19949,
     /*  324849 */     GIR_EraseRootFromParent_Done,
     /*  324850 */   // Label 5975: @324850
     /*  324850 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(324913), // Rule ID 19952 //
     /*  324855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  324897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324911 */     GIR_RootConstrainSelectedInstOperands,
     /*  324912 */     // GIR_Coverage, 19952,
     /*  324912 */     GIR_EraseRootFromParent_Done,
     /*  324913 */   // Label 5976: @324913
     /*  324913 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(324976), // Rule ID 19953 //
     /*  324918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324957 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  324960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324974 */     GIR_RootConstrainSelectedInstOperands,
     /*  324975 */     // GIR_Coverage, 19953,
     /*  324975 */     GIR_EraseRootFromParent_Done,
     /*  324976 */   // Label 5977: @324976
     /*  324976 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(325039), // Rule ID 19956 //
     /*  324981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  324989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  325023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325037 */     GIR_RootConstrainSelectedInstOperands,
     /*  325038 */     // GIR_Coverage, 19956,
     /*  325038 */     GIR_EraseRootFromParent_Done,
     /*  325039 */   // Label 5978: @325039
     /*  325039 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(325102), // Rule ID 19957 //
     /*  325044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  325058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325083 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  325086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325100 */     GIR_RootConstrainSelectedInstOperands,
     /*  325101 */     // GIR_Coverage, 19957,
     /*  325101 */     GIR_EraseRootFromParent_Done,
     /*  325102 */   // Label 5979: @325102
     /*  325102 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(325165), // Rule ID 19960 //
     /*  325107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  325149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325163 */     GIR_RootConstrainSelectedInstOperands,
     /*  325164 */     // GIR_Coverage, 19960,
     /*  325164 */     GIR_EraseRootFromParent_Done,
     /*  325165 */   // Label 5980: @325165
     /*  325165 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(325228), // Rule ID 19961 //
     /*  325170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  325212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325226 */     GIR_RootConstrainSelectedInstOperands,
     /*  325227 */     // GIR_Coverage, 19961,
     /*  325227 */     GIR_EraseRootFromParent_Done,
     /*  325228 */   // Label 5981: @325228
     /*  325228 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(325291), // Rule ID 19964 //
     /*  325233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  325275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325289 */     GIR_RootConstrainSelectedInstOperands,
     /*  325290 */     // GIR_Coverage, 19964,
     /*  325290 */     GIR_EraseRootFromParent_Done,
     /*  325291 */   // Label 5982: @325291
     /*  325291 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(325354), // Rule ID 19965 //
     /*  325296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325335 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  325338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325352 */     GIR_RootConstrainSelectedInstOperands,
     /*  325353 */     // GIR_Coverage, 19965,
     /*  325353 */     GIR_EraseRootFromParent_Done,
     /*  325354 */   // Label 5983: @325354
     /*  325354 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(325417), // Rule ID 19968 //
     /*  325359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  325401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325415 */     GIR_RootConstrainSelectedInstOperands,
     /*  325416 */     // GIR_Coverage, 19968,
     /*  325416 */     GIR_EraseRootFromParent_Done,
     /*  325417 */   // Label 5984: @325417
     /*  325417 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(325480), // Rule ID 19969 //
     /*  325422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325461 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  325464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325478 */     GIR_RootConstrainSelectedInstOperands,
     /*  325479 */     // GIR_Coverage, 19969,
     /*  325479 */     GIR_EraseRootFromParent_Done,
     /*  325480 */   // Label 5985: @325480
     /*  325480 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(325543), // Rule ID 19972 //
     /*  325485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  325527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325541 */     GIR_RootConstrainSelectedInstOperands,
     /*  325542 */     // GIR_Coverage, 19972,
     /*  325542 */     GIR_EraseRootFromParent_Done,
     /*  325543 */   // Label 5986: @325543
     /*  325543 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(325606), // Rule ID 19973 //
     /*  325548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  325590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325604 */     GIR_RootConstrainSelectedInstOperands,
     /*  325605 */     // GIR_Coverage, 19973,
     /*  325605 */     GIR_EraseRootFromParent_Done,
     /*  325606 */   // Label 5987: @325606
     /*  325606 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(325669), // Rule ID 19976 //
     /*  325611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325650 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  325653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325667 */     GIR_RootConstrainSelectedInstOperands,
     /*  325668 */     // GIR_Coverage, 19976,
     /*  325668 */     GIR_EraseRootFromParent_Done,
     /*  325669 */   // Label 5988: @325669
     /*  325669 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(325732), // Rule ID 19977 //
     /*  325674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325713 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  325716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325730 */     GIR_RootConstrainSelectedInstOperands,
     /*  325731 */     // GIR_Coverage, 19977,
     /*  325731 */     GIR_EraseRootFromParent_Done,
     /*  325732 */   // Label 5989: @325732
     /*  325732 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(325795), // Rule ID 19980 //
     /*  325737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  325779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325793 */     GIR_RootConstrainSelectedInstOperands,
     /*  325794 */     // GIR_Coverage, 19980,
     /*  325794 */     GIR_EraseRootFromParent_Done,
     /*  325795 */   // Label 5990: @325795
     /*  325795 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(325858), // Rule ID 19981 //
     /*  325800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  325842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325856 */     GIR_RootConstrainSelectedInstOperands,
     /*  325857 */     // GIR_Coverage, 19981,
     /*  325857 */     GIR_EraseRootFromParent_Done,
     /*  325858 */   // Label 5991: @325858
     /*  325858 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(325921), // Rule ID 19984 //
     /*  325863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  325905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325919 */     GIR_RootConstrainSelectedInstOperands,
     /*  325920 */     // GIR_Coverage, 19984,
     /*  325920 */     GIR_EraseRootFromParent_Done,
     /*  325921 */   // Label 5992: @325921
     /*  325921 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(325984), // Rule ID 19985 //
     /*  325926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  325968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325982 */     GIR_RootConstrainSelectedInstOperands,
     /*  325983 */     // GIR_Coverage, 19985,
     /*  325983 */     GIR_EraseRootFromParent_Done,
     /*  325984 */   // Label 5993: @325984
     /*  325984 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(326047), // Rule ID 19988 //
     /*  325989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  325997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326028 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  326031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326045 */     GIR_RootConstrainSelectedInstOperands,
     /*  326046 */     // GIR_Coverage, 19988,
     /*  326046 */     GIR_EraseRootFromParent_Done,
     /*  326047 */   // Label 5994: @326047
     /*  326047 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(326110), // Rule ID 19989 //
     /*  326052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326091 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  326094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326108 */     GIR_RootConstrainSelectedInstOperands,
     /*  326109 */     // GIR_Coverage, 19989,
     /*  326109 */     GIR_EraseRootFromParent_Done,
     /*  326110 */   // Label 5995: @326110
     /*  326110 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(326173), // Rule ID 19992 //
     /*  326115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  326157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326171 */     GIR_RootConstrainSelectedInstOperands,
     /*  326172 */     // GIR_Coverage, 19992,
     /*  326172 */     GIR_EraseRootFromParent_Done,
     /*  326173 */   // Label 5996: @326173
     /*  326173 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(326236), // Rule ID 19993 //
     /*  326178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326217 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  326220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326234 */     GIR_RootConstrainSelectedInstOperands,
     /*  326235 */     // GIR_Coverage, 19993,
     /*  326235 */     GIR_EraseRootFromParent_Done,
     /*  326236 */   // Label 5997: @326236
     /*  326236 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(326299), // Rule ID 19996 //
     /*  326241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  326283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326297 */     GIR_RootConstrainSelectedInstOperands,
     /*  326298 */     // GIR_Coverage, 19996,
     /*  326298 */     GIR_EraseRootFromParent_Done,
     /*  326299 */   // Label 5998: @326299
     /*  326299 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(326362), // Rule ID 19997 //
     /*  326304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326343 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  326346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326360 */     GIR_RootConstrainSelectedInstOperands,
     /*  326361 */     // GIR_Coverage, 19997,
     /*  326361 */     GIR_EraseRootFromParent_Done,
     /*  326362 */   // Label 5999: @326362
     /*  326362 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(326425), // Rule ID 20000 //
     /*  326367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326406 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  326409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326423 */     GIR_RootConstrainSelectedInstOperands,
     /*  326424 */     // GIR_Coverage, 20000,
     /*  326424 */     GIR_EraseRootFromParent_Done,
     /*  326425 */   // Label 6000: @326425
     /*  326425 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(326488), // Rule ID 20001 //
     /*  326430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  326438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326469 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  326472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326486 */     GIR_RootConstrainSelectedInstOperands,
     /*  326487 */     // GIR_Coverage, 20001,
     /*  326487 */     GIR_EraseRootFromParent_Done,
     /*  326488 */   // Label 6001: @326488
     /*  326488 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(326551), // Rule ID 20004 //
     /*  326493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  326535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326549 */     GIR_RootConstrainSelectedInstOperands,
     /*  326550 */     // GIR_Coverage, 20004,
     /*  326550 */     GIR_EraseRootFromParent_Done,
     /*  326551 */   // Label 6002: @326551
     /*  326551 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(326614), // Rule ID 20005 //
     /*  326556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  326598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326612 */     GIR_RootConstrainSelectedInstOperands,
     /*  326613 */     // GIR_Coverage, 20005,
     /*  326613 */     GIR_EraseRootFromParent_Done,
     /*  326614 */   // Label 6003: @326614
     /*  326614 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(326677), // Rule ID 20008 //
     /*  326619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326675 */     GIR_RootConstrainSelectedInstOperands,
     /*  326676 */     // GIR_Coverage, 20008,
     /*  326676 */     GIR_EraseRootFromParent_Done,
     /*  326677 */   // Label 6004: @326677
     /*  326677 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(326740), // Rule ID 20009 //
     /*  326682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326738 */     GIR_RootConstrainSelectedInstOperands,
     /*  326739 */     // GIR_Coverage, 20009,
     /*  326739 */     GIR_EraseRootFromParent_Done,
     /*  326740 */   // Label 6005: @326740
     /*  326740 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(326803), // Rule ID 20012 //
     /*  326745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326801 */     GIR_RootConstrainSelectedInstOperands,
     /*  326802 */     // GIR_Coverage, 20012,
     /*  326802 */     GIR_EraseRootFromParent_Done,
     /*  326803 */   // Label 6006: @326803
     /*  326803 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(326866), // Rule ID 20013 //
     /*  326808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326847 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  326850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326864 */     GIR_RootConstrainSelectedInstOperands,
     /*  326865 */     // GIR_Coverage, 20013,
     /*  326865 */     GIR_EraseRootFromParent_Done,
     /*  326866 */   // Label 6007: @326866
     /*  326866 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(326929), // Rule ID 20016 //
     /*  326871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326910 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  326913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326927 */     GIR_RootConstrainSelectedInstOperands,
     /*  326928 */     // GIR_Coverage, 20016,
     /*  326928 */     GIR_EraseRootFromParent_Done,
     /*  326929 */   // Label 6008: @326929
     /*  326929 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(326992), // Rule ID 20017 //
     /*  326934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326973 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  326976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326990 */     GIR_RootConstrainSelectedInstOperands,
     /*  326991 */     // GIR_Coverage, 20017,
     /*  326991 */     GIR_EraseRootFromParent_Done,
     /*  326992 */   // Label 6009: @326992
     /*  326992 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(327055), // Rule ID 20020 //
     /*  326997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327053 */     GIR_RootConstrainSelectedInstOperands,
     /*  327054 */     // GIR_Coverage, 20020,
     /*  327054 */     GIR_EraseRootFromParent_Done,
     /*  327055 */   // Label 6010: @327055
     /*  327055 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(327118), // Rule ID 20021 //
     /*  327060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327099 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327116 */     GIR_RootConstrainSelectedInstOperands,
     /*  327117 */     // GIR_Coverage, 20021,
     /*  327117 */     GIR_EraseRootFromParent_Done,
     /*  327118 */   // Label 6011: @327118
     /*  327118 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(327181), // Rule ID 20024 //
     /*  327123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327179 */     GIR_RootConstrainSelectedInstOperands,
     /*  327180 */     // GIR_Coverage, 20024,
     /*  327180 */     GIR_EraseRootFromParent_Done,
     /*  327181 */   // Label 6012: @327181
     /*  327181 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(327244), // Rule ID 20025 //
     /*  327186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327225 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  327228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327242 */     GIR_RootConstrainSelectedInstOperands,
     /*  327243 */     // GIR_Coverage, 20025,
     /*  327243 */     GIR_EraseRootFromParent_Done,
     /*  327244 */   // Label 6013: @327244
     /*  327244 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(327307), // Rule ID 20028 //
     /*  327249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327305 */     GIR_RootConstrainSelectedInstOperands,
     /*  327306 */     // GIR_Coverage, 20028,
     /*  327306 */     GIR_EraseRootFromParent_Done,
     /*  327307 */   // Label 6014: @327307
     /*  327307 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(327370), // Rule ID 20029 //
     /*  327312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327351 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327368 */     GIR_RootConstrainSelectedInstOperands,
     /*  327369 */     // GIR_Coverage, 20029,
     /*  327369 */     GIR_EraseRootFromParent_Done,
     /*  327370 */   // Label 6015: @327370
     /*  327370 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(327433), // Rule ID 20032 //
     /*  327375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327431 */     GIR_RootConstrainSelectedInstOperands,
     /*  327432 */     // GIR_Coverage, 20032,
     /*  327432 */     GIR_EraseRootFromParent_Done,
     /*  327433 */   // Label 6016: @327433
     /*  327433 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(327496), // Rule ID 20033 //
     /*  327438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327494 */     GIR_RootConstrainSelectedInstOperands,
     /*  327495 */     // GIR_Coverage, 20033,
     /*  327495 */     GIR_EraseRootFromParent_Done,
     /*  327496 */   // Label 6017: @327496
     /*  327496 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(327559), // Rule ID 20036 //
     /*  327501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327557 */     GIR_RootConstrainSelectedInstOperands,
     /*  327558 */     // GIR_Coverage, 20036,
     /*  327558 */     GIR_EraseRootFromParent_Done,
     /*  327559 */   // Label 6018: @327559
     /*  327559 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(327622), // Rule ID 20037 //
     /*  327564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327603 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327620 */     GIR_RootConstrainSelectedInstOperands,
     /*  327621 */     // GIR_Coverage, 20037,
     /*  327621 */     GIR_EraseRootFromParent_Done,
     /*  327622 */   // Label 6019: @327622
     /*  327622 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(327685), // Rule ID 20040 //
     /*  327627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327683 */     GIR_RootConstrainSelectedInstOperands,
     /*  327684 */     // GIR_Coverage, 20040,
     /*  327684 */     GIR_EraseRootFromParent_Done,
     /*  327685 */   // Label 6020: @327685
     /*  327685 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(327748), // Rule ID 20041 //
     /*  327690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327729 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  327732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327746 */     GIR_RootConstrainSelectedInstOperands,
     /*  327747 */     // GIR_Coverage, 20041,
     /*  327747 */     GIR_EraseRootFromParent_Done,
     /*  327748 */   // Label 6021: @327748
     /*  327748 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(327811), // Rule ID 20044 //
     /*  327753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327809 */     GIR_RootConstrainSelectedInstOperands,
     /*  327810 */     // GIR_Coverage, 20044,
     /*  327810 */     GIR_EraseRootFromParent_Done,
     /*  327811 */   // Label 6022: @327811
     /*  327811 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(327874), // Rule ID 20045 //
     /*  327816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  327858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327872 */     GIR_RootConstrainSelectedInstOperands,
     /*  327873 */     // GIR_Coverage, 20045,
     /*  327873 */     GIR_EraseRootFromParent_Done,
     /*  327874 */   // Label 6023: @327874
     /*  327874 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(327937), // Rule ID 20048 //
     /*  327879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327935 */     GIR_RootConstrainSelectedInstOperands,
     /*  327936 */     // GIR_Coverage, 20048,
     /*  327936 */     GIR_EraseRootFromParent_Done,
     /*  327937 */   // Label 6024: @327937
     /*  327937 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(328000), // Rule ID 20049 //
     /*  327942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  327950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  327984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327998 */     GIR_RootConstrainSelectedInstOperands,
     /*  327999 */     // GIR_Coverage, 20049,
     /*  327999 */     GIR_EraseRootFromParent_Done,
     /*  328000 */   // Label 6025: @328000
     /*  328000 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(328063), // Rule ID 20052 //
     /*  328005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  328047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328061 */     GIR_RootConstrainSelectedInstOperands,
     /*  328062 */     // GIR_Coverage, 20052,
     /*  328062 */     GIR_EraseRootFromParent_Done,
     /*  328063 */   // Label 6026: @328063
     /*  328063 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(328126), // Rule ID 20053 //
     /*  328068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  328110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328124 */     GIR_RootConstrainSelectedInstOperands,
     /*  328125 */     // GIR_Coverage, 20053,
     /*  328125 */     GIR_EraseRootFromParent_Done,
     /*  328126 */   // Label 6027: @328126
     /*  328126 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(328189), // Rule ID 20056 //
     /*  328131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  328173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328187 */     GIR_RootConstrainSelectedInstOperands,
     /*  328188 */     // GIR_Coverage, 20056,
     /*  328188 */     GIR_EraseRootFromParent_Done,
     /*  328189 */   // Label 6028: @328189
     /*  328189 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(328252), // Rule ID 20057 //
     /*  328194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328233 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  328236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328250 */     GIR_RootConstrainSelectedInstOperands,
     /*  328251 */     // GIR_Coverage, 20057,
     /*  328251 */     GIR_EraseRootFromParent_Done,
     /*  328252 */   // Label 6029: @328252
     /*  328252 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(328315), // Rule ID 20060 //
     /*  328257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  328299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328313 */     GIR_RootConstrainSelectedInstOperands,
     /*  328314 */     // GIR_Coverage, 20060,
     /*  328314 */     GIR_EraseRootFromParent_Done,
     /*  328315 */   // Label 6030: @328315
     /*  328315 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(328378), // Rule ID 20061 //
     /*  328320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  328362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328376 */     GIR_RootConstrainSelectedInstOperands,
     /*  328377 */     // GIR_Coverage, 20061,
     /*  328377 */     GIR_EraseRootFromParent_Done,
     /*  328378 */   // Label 6031: @328378
     /*  328378 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(328441), // Rule ID 20064 //
     /*  328383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328422 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  328425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328439 */     GIR_RootConstrainSelectedInstOperands,
     /*  328440 */     // GIR_Coverage, 20064,
     /*  328440 */     GIR_EraseRootFromParent_Done,
     /*  328441 */   // Label 6032: @328441
     /*  328441 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(328504), // Rule ID 20065 //
     /*  328446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328485 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  328488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328502 */     GIR_RootConstrainSelectedInstOperands,
     /*  328503 */     // GIR_Coverage, 20065,
     /*  328503 */     GIR_EraseRootFromParent_Done,
     /*  328504 */   // Label 6033: @328504
     /*  328504 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(328567), // Rule ID 20068 //
     /*  328509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  328551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328565 */     GIR_RootConstrainSelectedInstOperands,
     /*  328566 */     // GIR_Coverage, 20068,
     /*  328566 */     GIR_EraseRootFromParent_Done,
     /*  328567 */   // Label 6034: @328567
     /*  328567 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(328630), // Rule ID 20069 //
     /*  328572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  328614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328628 */     GIR_RootConstrainSelectedInstOperands,
     /*  328629 */     // GIR_Coverage, 20069,
     /*  328629 */     GIR_EraseRootFromParent_Done,
     /*  328630 */   // Label 6035: @328630
     /*  328630 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(328693), // Rule ID 20072 //
     /*  328635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  328677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328691 */     GIR_RootConstrainSelectedInstOperands,
     /*  328692 */     // GIR_Coverage, 20072,
     /*  328692 */     GIR_EraseRootFromParent_Done,
     /*  328693 */   // Label 6036: @328693
     /*  328693 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(328756), // Rule ID 20073 //
     /*  328698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  328740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328754 */     GIR_RootConstrainSelectedInstOperands,
     /*  328755 */     // GIR_Coverage, 20073,
     /*  328755 */     GIR_EraseRootFromParent_Done,
     /*  328756 */   // Label 6037: @328756
     /*  328756 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(328819), // Rule ID 20076 //
     /*  328761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  328803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328817 */     GIR_RootConstrainSelectedInstOperands,
     /*  328818 */     // GIR_Coverage, 20076,
     /*  328818 */     GIR_EraseRootFromParent_Done,
     /*  328819 */   // Label 6038: @328819
     /*  328819 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(328882), // Rule ID 20077 //
     /*  328824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328863 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  328866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328880 */     GIR_RootConstrainSelectedInstOperands,
     /*  328881 */     // GIR_Coverage, 20077,
     /*  328881 */     GIR_EraseRootFromParent_Done,
     /*  328882 */   // Label 6039: @328882
     /*  328882 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(328945), // Rule ID 20080 //
     /*  328887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  328929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328943 */     GIR_RootConstrainSelectedInstOperands,
     /*  328944 */     // GIR_Coverage, 20080,
     /*  328944 */     GIR_EraseRootFromParent_Done,
     /*  328945 */   // Label 6040: @328945
     /*  328945 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(329008), // Rule ID 20081 //
     /*  328950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  328958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  328992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329006 */     GIR_RootConstrainSelectedInstOperands,
     /*  329007 */     // GIR_Coverage, 20081,
     /*  329007 */     GIR_EraseRootFromParent_Done,
     /*  329008 */   // Label 6041: @329008
     /*  329008 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(329071), // Rule ID 20084 //
     /*  329013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  329055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329069 */     GIR_RootConstrainSelectedInstOperands,
     /*  329070 */     // GIR_Coverage, 20084,
     /*  329070 */     GIR_EraseRootFromParent_Done,
     /*  329071 */   // Label 6042: @329071
     /*  329071 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(329134), // Rule ID 20085 //
     /*  329076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329115 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  329118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329132 */     GIR_RootConstrainSelectedInstOperands,
     /*  329133 */     // GIR_Coverage, 20085,
     /*  329133 */     GIR_EraseRootFromParent_Done,
     /*  329134 */   // Label 6043: @329134
     /*  329134 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(329197), // Rule ID 20088 //
     /*  329139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  329181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329195 */     GIR_RootConstrainSelectedInstOperands,
     /*  329196 */     // GIR_Coverage, 20088,
     /*  329196 */     GIR_EraseRootFromParent_Done,
     /*  329197 */   // Label 6044: @329197
     /*  329197 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(329260), // Rule ID 20089 //
     /*  329202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329241 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  329244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329258 */     GIR_RootConstrainSelectedInstOperands,
     /*  329259 */     // GIR_Coverage, 20089,
     /*  329259 */     GIR_EraseRootFromParent_Done,
     /*  329260 */   // Label 6045: @329260
     /*  329260 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(329323), // Rule ID 20092 //
     /*  329265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329304 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  329307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329321 */     GIR_RootConstrainSelectedInstOperands,
     /*  329322 */     // GIR_Coverage, 20092,
     /*  329322 */     GIR_EraseRootFromParent_Done,
     /*  329323 */   // Label 6046: @329323
     /*  329323 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(329386), // Rule ID 20093 //
     /*  329328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329367 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  329370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329384 */     GIR_RootConstrainSelectedInstOperands,
     /*  329385 */     // GIR_Coverage, 20093,
     /*  329385 */     GIR_EraseRootFromParent_Done,
     /*  329386 */   // Label 6047: @329386
     /*  329386 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(329449), // Rule ID 20096 //
     /*  329391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329430 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  329433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329447 */     GIR_RootConstrainSelectedInstOperands,
     /*  329448 */     // GIR_Coverage, 20096,
     /*  329448 */     GIR_EraseRootFromParent_Done,
     /*  329449 */   // Label 6048: @329449
     /*  329449 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(329512), // Rule ID 20097 //
     /*  329454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329493 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  329496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329510 */     GIR_RootConstrainSelectedInstOperands,
     /*  329511 */     // GIR_Coverage, 20097,
     /*  329511 */     GIR_EraseRootFromParent_Done,
     /*  329512 */   // Label 6049: @329512
     /*  329512 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(329575), // Rule ID 20100 //
     /*  329517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  329559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329573 */     GIR_RootConstrainSelectedInstOperands,
     /*  329574 */     // GIR_Coverage, 20100,
     /*  329574 */     GIR_EraseRootFromParent_Done,
     /*  329575 */   // Label 6050: @329575
     /*  329575 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(329638), // Rule ID 20101 //
     /*  329580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  329622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329636 */     GIR_RootConstrainSelectedInstOperands,
     /*  329637 */     // GIR_Coverage, 20101,
     /*  329637 */     GIR_EraseRootFromParent_Done,
     /*  329638 */   // Label 6051: @329638
     /*  329638 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(329701), // Rule ID 20104 //
     /*  329643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  329685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329699 */     GIR_RootConstrainSelectedInstOperands,
     /*  329700 */     // GIR_Coverage, 20104,
     /*  329700 */     GIR_EraseRootFromParent_Done,
     /*  329701 */   // Label 6052: @329701
     /*  329701 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(329764), // Rule ID 20105 //
     /*  329706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  329748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329762 */     GIR_RootConstrainSelectedInstOperands,
     /*  329763 */     // GIR_Coverage, 20105,
     /*  329763 */     GIR_EraseRootFromParent_Done,
     /*  329764 */   // Label 6053: @329764
     /*  329764 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(329827), // Rule ID 20108 //
     /*  329769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  329811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329825 */     GIR_RootConstrainSelectedInstOperands,
     /*  329826 */     // GIR_Coverage, 20108,
     /*  329826 */     GIR_EraseRootFromParent_Done,
     /*  329827 */   // Label 6054: @329827
     /*  329827 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(329890), // Rule ID 20109 //
     /*  329832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329871 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  329874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329888 */     GIR_RootConstrainSelectedInstOperands,
     /*  329889 */     // GIR_Coverage, 20109,
     /*  329889 */     GIR_EraseRootFromParent_Done,
     /*  329890 */   // Label 6055: @329890
     /*  329890 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(329953), // Rule ID 20112 //
     /*  329895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  329937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329951 */     GIR_RootConstrainSelectedInstOperands,
     /*  329952 */     // GIR_Coverage, 20112,
     /*  329952 */     GIR_EraseRootFromParent_Done,
     /*  329953 */   // Label 6056: @329953
     /*  329953 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(330016), // Rule ID 20113 //
     /*  329958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  329966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329997 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  330000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330014 */     GIR_RootConstrainSelectedInstOperands,
     /*  330015 */     // GIR_Coverage, 20113,
     /*  330015 */     GIR_EraseRootFromParent_Done,
     /*  330016 */   // Label 6057: @330016
     /*  330016 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(330079), // Rule ID 20116 //
     /*  330021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  330063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330077 */     GIR_RootConstrainSelectedInstOperands,
     /*  330078 */     // GIR_Coverage, 20116,
     /*  330078 */     GIR_EraseRootFromParent_Done,
     /*  330079 */   // Label 6058: @330079
     /*  330079 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(330142), // Rule ID 20117 //
     /*  330084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  330126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330140 */     GIR_RootConstrainSelectedInstOperands,
     /*  330141 */     // GIR_Coverage, 20117,
     /*  330141 */     GIR_EraseRootFromParent_Done,
     /*  330142 */   // Label 6059: @330142
     /*  330142 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(330205), // Rule ID 20120 //
     /*  330147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  330189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330203 */     GIR_RootConstrainSelectedInstOperands,
     /*  330204 */     // GIR_Coverage, 20120,
     /*  330204 */     GIR_EraseRootFromParent_Done,
     /*  330205 */   // Label 6060: @330205
     /*  330205 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(330268), // Rule ID 20121 //
     /*  330210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  330218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330249 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  330252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330266 */     GIR_RootConstrainSelectedInstOperands,
     /*  330267 */     // GIR_Coverage, 20121,
     /*  330267 */     GIR_EraseRootFromParent_Done,
     /*  330268 */   // Label 6061: @330268
     /*  330268 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(330331), // Rule ID 20124 //
     /*  330273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  330290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  330315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330329 */     GIR_RootConstrainSelectedInstOperands,
     /*  330330 */     // GIR_Coverage, 20124,
     /*  330330 */     GIR_EraseRootFromParent_Done,
     /*  330331 */   // Label 6062: @330331
     /*  330331 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(330394), // Rule ID 20125 //
     /*  330336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  330353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330375 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  330378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330392 */     GIR_RootConstrainSelectedInstOperands,
     /*  330393 */     // GIR_Coverage, 20125,
     /*  330393 */     GIR_EraseRootFromParent_Done,
     /*  330394 */   // Label 6063: @330394
     /*  330394 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(330457), // Rule ID 20128 //
     /*  330399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  330416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330438 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330455 */     GIR_RootConstrainSelectedInstOperands,
     /*  330456 */     // GIR_Coverage, 20128,
     /*  330456 */     GIR_EraseRootFromParent_Done,
     /*  330457 */   // Label 6064: @330457
     /*  330457 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(330520), // Rule ID 20129 //
     /*  330462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  330479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330501 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330518 */     GIR_RootConstrainSelectedInstOperands,
     /*  330519 */     // GIR_Coverage, 20129,
     /*  330519 */     GIR_EraseRootFromParent_Done,
     /*  330520 */   // Label 6065: @330520
     /*  330520 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(330583), // Rule ID 20132 //
     /*  330525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330581 */     GIR_RootConstrainSelectedInstOperands,
     /*  330582 */     // GIR_Coverage, 20132,
     /*  330582 */     GIR_EraseRootFromParent_Done,
     /*  330583 */   // Label 6066: @330583
     /*  330583 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(330646), // Rule ID 20133 //
     /*  330588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  330605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330627 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  330630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330644 */     GIR_RootConstrainSelectedInstOperands,
     /*  330645 */     // GIR_Coverage, 20133,
     /*  330645 */     GIR_EraseRootFromParent_Done,
     /*  330646 */   // Label 6067: @330646
     /*  330646 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(330709), // Rule ID 20136 //
     /*  330651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  330668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330707 */     GIR_RootConstrainSelectedInstOperands,
     /*  330708 */     // GIR_Coverage, 20136,
     /*  330708 */     GIR_EraseRootFromParent_Done,
     /*  330709 */   // Label 6068: @330709
     /*  330709 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(330772), // Rule ID 20137 //
     /*  330714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  330731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330770 */     GIR_RootConstrainSelectedInstOperands,
     /*  330771 */     // GIR_Coverage, 20137,
     /*  330771 */     GIR_EraseRootFromParent_Done,
     /*  330772 */   // Label 6069: @330772
     /*  330772 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(330835), // Rule ID 20140 //
     /*  330777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330833 */     GIR_RootConstrainSelectedInstOperands,
     /*  330834 */     // GIR_Coverage, 20140,
     /*  330834 */     GIR_EraseRootFromParent_Done,
     /*  330835 */   // Label 6070: @330835
     /*  330835 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(330898), // Rule ID 20141 //
     /*  330840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  330857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330879 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330896 */     GIR_RootConstrainSelectedInstOperands,
     /*  330897 */     // GIR_Coverage, 20141,
     /*  330897 */     GIR_EraseRootFromParent_Done,
     /*  330898 */   // Label 6071: @330898
     /*  330898 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(330961), // Rule ID 20144 //
     /*  330903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  330920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  330945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330959 */     GIR_RootConstrainSelectedInstOperands,
     /*  330960 */     // GIR_Coverage, 20144,
     /*  330960 */     GIR_EraseRootFromParent_Done,
     /*  330961 */   // Label 6072: @330961
     /*  330961 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(331024), // Rule ID 20145 //
     /*  330966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  330983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  331008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331022 */     GIR_RootConstrainSelectedInstOperands,
     /*  331023 */     // GIR_Coverage, 20145,
     /*  331023 */     GIR_EraseRootFromParent_Done,
     /*  331024 */   // Label 6073: @331024
     /*  331024 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(331087), // Rule ID 20148 //
     /*  331029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  331046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331085 */     GIR_RootConstrainSelectedInstOperands,
     /*  331086 */     // GIR_Coverage, 20148,
     /*  331086 */     GIR_EraseRootFromParent_Done,
     /*  331087 */   // Label 6074: @331087
     /*  331087 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(331150), // Rule ID 20149 //
     /*  331092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  331109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331131 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331148 */     GIR_RootConstrainSelectedInstOperands,
     /*  331149 */     // GIR_Coverage, 20149,
     /*  331149 */     GIR_EraseRootFromParent_Done,
     /*  331150 */   // Label 6075: @331150
     /*  331150 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(331213), // Rule ID 20152 //
     /*  331155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  331172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331211 */     GIR_RootConstrainSelectedInstOperands,
     /*  331212 */     // GIR_Coverage, 20152,
     /*  331212 */     GIR_EraseRootFromParent_Done,
     /*  331213 */   // Label 6076: @331213
     /*  331213 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(331276), // Rule ID 20153 //
     /*  331218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  331235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331257 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331274 */     GIR_RootConstrainSelectedInstOperands,
     /*  331275 */     // GIR_Coverage, 20153,
     /*  331275 */     GIR_EraseRootFromParent_Done,
     /*  331276 */   // Label 6077: @331276
     /*  331276 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(331339), // Rule ID 20156 //
     /*  331281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  331298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331320 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331337 */     GIR_RootConstrainSelectedInstOperands,
     /*  331338 */     // GIR_Coverage, 20156,
     /*  331338 */     GIR_EraseRootFromParent_Done,
     /*  331339 */   // Label 6078: @331339
     /*  331339 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(331402), // Rule ID 20157 //
     /*  331344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  331361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331383 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331400 */     GIR_RootConstrainSelectedInstOperands,
     /*  331401 */     // GIR_Coverage, 20157,
     /*  331401 */     GIR_EraseRootFromParent_Done,
     /*  331402 */   // Label 6079: @331402
     /*  331402 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(331465), // Rule ID 20160 //
     /*  331407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331446 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331463 */     GIR_RootConstrainSelectedInstOperands,
     /*  331464 */     // GIR_Coverage, 20160,
     /*  331464 */     GIR_EraseRootFromParent_Done,
     /*  331465 */   // Label 6080: @331465
     /*  331465 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(331528), // Rule ID 20161 //
     /*  331470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  331487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331509 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331526 */     GIR_RootConstrainSelectedInstOperands,
     /*  331527 */     // GIR_Coverage, 20161,
     /*  331527 */     GIR_EraseRootFromParent_Done,
     /*  331528 */   // Label 6081: @331528
     /*  331528 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(331591), // Rule ID 20164 //
     /*  331533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331589 */     GIR_RootConstrainSelectedInstOperands,
     /*  331590 */     // GIR_Coverage, 20164,
     /*  331590 */     GIR_EraseRootFromParent_Done,
     /*  331591 */   // Label 6082: @331591
     /*  331591 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(331654), // Rule ID 20165 //
     /*  331596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  331613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331635 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331652 */     GIR_RootConstrainSelectedInstOperands,
     /*  331653 */     // GIR_Coverage, 20165,
     /*  331653 */     GIR_EraseRootFromParent_Done,
     /*  331654 */   // Label 6083: @331654
     /*  331654 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(331717), // Rule ID 20168 //
     /*  331659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331698 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331715 */     GIR_RootConstrainSelectedInstOperands,
     /*  331716 */     // GIR_Coverage, 20168,
     /*  331716 */     GIR_EraseRootFromParent_Done,
     /*  331717 */   // Label 6084: @331717
     /*  331717 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(331780), // Rule ID 20169 //
     /*  331722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  331739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331761 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  331764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331778 */     GIR_RootConstrainSelectedInstOperands,
     /*  331779 */     // GIR_Coverage, 20169,
     /*  331779 */     GIR_EraseRootFromParent_Done,
     /*  331780 */   // Label 6085: @331780
     /*  331780 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(331843), // Rule ID 20172 //
     /*  331785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  331802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331841 */     GIR_RootConstrainSelectedInstOperands,
     /*  331842 */     // GIR_Coverage, 20172,
     /*  331842 */     GIR_EraseRootFromParent_Done,
     /*  331843 */   // Label 6086: @331843
     /*  331843 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(331906), // Rule ID 20173 //
     /*  331848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  331865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331887 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  331890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331904 */     GIR_RootConstrainSelectedInstOperands,
     /*  331905 */     // GIR_Coverage, 20173,
     /*  331905 */     GIR_EraseRootFromParent_Done,
     /*  331906 */   // Label 6087: @331906
     /*  331906 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(331969), // Rule ID 20176 //
     /*  331911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  331928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  331953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331967 */     GIR_RootConstrainSelectedInstOperands,
     /*  331968 */     // GIR_Coverage, 20176,
     /*  331968 */     GIR_EraseRootFromParent_Done,
     /*  331969 */   // Label 6088: @331969
     /*  331969 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(332032), // Rule ID 20177 //
     /*  331974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  331982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  331991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332013 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  332016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332030 */     GIR_RootConstrainSelectedInstOperands,
     /*  332031 */     // GIR_Coverage, 20177,
     /*  332031 */     GIR_EraseRootFromParent_Done,
     /*  332032 */   // Label 6089: @332032
     /*  332032 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(332095), // Rule ID 20180 //
     /*  332037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  332054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  332079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332093 */     GIR_RootConstrainSelectedInstOperands,
     /*  332094 */     // GIR_Coverage, 20180,
     /*  332094 */     GIR_EraseRootFromParent_Done,
     /*  332095 */   // Label 6090: @332095
     /*  332095 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(332158), // Rule ID 20181 //
     /*  332100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  332117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  332142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332156 */     GIR_RootConstrainSelectedInstOperands,
     /*  332157 */     // GIR_Coverage, 20181,
     /*  332157 */     GIR_EraseRootFromParent_Done,
     /*  332158 */   // Label 6091: @332158
     /*  332158 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(332221), // Rule ID 20184 //
     /*  332163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  332205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332219 */     GIR_RootConstrainSelectedInstOperands,
     /*  332220 */     // GIR_Coverage, 20184,
     /*  332220 */     GIR_EraseRootFromParent_Done,
     /*  332221 */   // Label 6092: @332221
     /*  332221 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(332284), // Rule ID 20185 //
     /*  332226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  332268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332282 */     GIR_RootConstrainSelectedInstOperands,
     /*  332283 */     // GIR_Coverage, 20185,
     /*  332283 */     GIR_EraseRootFromParent_Done,
     /*  332284 */   // Label 6093: @332284
     /*  332284 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(332347), // Rule ID 20188 //
     /*  332289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  332331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332345 */     GIR_RootConstrainSelectedInstOperands,
     /*  332346 */     // GIR_Coverage, 20188,
     /*  332346 */     GIR_EraseRootFromParent_Done,
     /*  332347 */   // Label 6094: @332347
     /*  332347 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(332410), // Rule ID 20189 //
     /*  332352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332391 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  332394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332408 */     GIR_RootConstrainSelectedInstOperands,
     /*  332409 */     // GIR_Coverage, 20189,
     /*  332409 */     GIR_EraseRootFromParent_Done,
     /*  332410 */   // Label 6095: @332410
     /*  332410 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(332473), // Rule ID 20192 //
     /*  332415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  332457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332471 */     GIR_RootConstrainSelectedInstOperands,
     /*  332472 */     // GIR_Coverage, 20192,
     /*  332472 */     GIR_EraseRootFromParent_Done,
     /*  332473 */   // Label 6096: @332473
     /*  332473 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(332536), // Rule ID 20193 //
     /*  332478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  332520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332534 */     GIR_RootConstrainSelectedInstOperands,
     /*  332535 */     // GIR_Coverage, 20193,
     /*  332535 */     GIR_EraseRootFromParent_Done,
     /*  332536 */   // Label 6097: @332536
     /*  332536 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(332599), // Rule ID 20196 //
     /*  332541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  332583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332597 */     GIR_RootConstrainSelectedInstOperands,
     /*  332598 */     // GIR_Coverage, 20196,
     /*  332598 */     GIR_EraseRootFromParent_Done,
     /*  332599 */   // Label 6098: @332599
     /*  332599 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(332662), // Rule ID 20197 //
     /*  332604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332643 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  332646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332660 */     GIR_RootConstrainSelectedInstOperands,
     /*  332661 */     // GIR_Coverage, 20197,
     /*  332661 */     GIR_EraseRootFromParent_Done,
     /*  332662 */   // Label 6099: @332662
     /*  332662 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(332725), // Rule ID 20200 //
     /*  332667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  332709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332723 */     GIR_RootConstrainSelectedInstOperands,
     /*  332724 */     // GIR_Coverage, 20200,
     /*  332724 */     GIR_EraseRootFromParent_Done,
     /*  332725 */   // Label 6100: @332725
     /*  332725 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(332788), // Rule ID 20201 //
     /*  332730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332769 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  332772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332786 */     GIR_RootConstrainSelectedInstOperands,
     /*  332787 */     // GIR_Coverage, 20201,
     /*  332787 */     GIR_EraseRootFromParent_Done,
     /*  332788 */   // Label 6101: @332788
     /*  332788 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(332851), // Rule ID 20204 //
     /*  332793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  332835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332849 */     GIR_RootConstrainSelectedInstOperands,
     /*  332850 */     // GIR_Coverage, 20204,
     /*  332850 */     GIR_EraseRootFromParent_Done,
     /*  332851 */   // Label 6102: @332851
     /*  332851 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(332914), // Rule ID 20205 //
     /*  332856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332895 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  332898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332912 */     GIR_RootConstrainSelectedInstOperands,
     /*  332913 */     // GIR_Coverage, 20205,
     /*  332913 */     GIR_EraseRootFromParent_Done,
     /*  332914 */   // Label 6103: @332914
     /*  332914 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(332977), // Rule ID 20208 //
     /*  332919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  332961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332975 */     GIR_RootConstrainSelectedInstOperands,
     /*  332976 */     // GIR_Coverage, 20208,
     /*  332976 */     GIR_EraseRootFromParent_Done,
     /*  332977 */   // Label 6104: @332977
     /*  332977 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(333040), // Rule ID 20209 //
     /*  332982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  332990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333021 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  333024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333038 */     GIR_RootConstrainSelectedInstOperands,
     /*  333039 */     // GIR_Coverage, 20209,
     /*  333039 */     GIR_EraseRootFromParent_Done,
     /*  333040 */   // Label 6105: @333040
     /*  333040 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(333103), // Rule ID 20212 //
     /*  333045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  333087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333101 */     GIR_RootConstrainSelectedInstOperands,
     /*  333102 */     // GIR_Coverage, 20212,
     /*  333102 */     GIR_EraseRootFromParent_Done,
     /*  333103 */   // Label 6106: @333103
     /*  333103 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(333166), // Rule ID 20213 //
     /*  333108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333147 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  333150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333164 */     GIR_RootConstrainSelectedInstOperands,
     /*  333165 */     // GIR_Coverage, 20213,
     /*  333165 */     GIR_EraseRootFromParent_Done,
     /*  333166 */   // Label 6107: @333166
     /*  333166 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(333229), // Rule ID 20216 //
     /*  333171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333210 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  333213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333227 */     GIR_RootConstrainSelectedInstOperands,
     /*  333228 */     // GIR_Coverage, 20216,
     /*  333228 */     GIR_EraseRootFromParent_Done,
     /*  333229 */   // Label 6108: @333229
     /*  333229 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(333292), // Rule ID 20217 //
     /*  333234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333273 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  333276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333290 */     GIR_RootConstrainSelectedInstOperands,
     /*  333291 */     // GIR_Coverage, 20217,
     /*  333291 */     GIR_EraseRootFromParent_Done,
     /*  333292 */   // Label 6109: @333292
     /*  333292 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(333355), // Rule ID 20220 //
     /*  333297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  333339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333353 */     GIR_RootConstrainSelectedInstOperands,
     /*  333354 */     // GIR_Coverage, 20220,
     /*  333354 */     GIR_EraseRootFromParent_Done,
     /*  333355 */   // Label 6110: @333355
     /*  333355 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(333418), // Rule ID 20221 //
     /*  333360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333399 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  333402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333416 */     GIR_RootConstrainSelectedInstOperands,
     /*  333417 */     // GIR_Coverage, 20221,
     /*  333417 */     GIR_EraseRootFromParent_Done,
     /*  333418 */   // Label 6111: @333418
     /*  333418 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(333481), // Rule ID 20224 //
     /*  333423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  333465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333479 */     GIR_RootConstrainSelectedInstOperands,
     /*  333480 */     // GIR_Coverage, 20224,
     /*  333480 */     GIR_EraseRootFromParent_Done,
     /*  333481 */   // Label 6112: @333481
     /*  333481 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(333544), // Rule ID 20225 //
     /*  333486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  333528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333542 */     GIR_RootConstrainSelectedInstOperands,
     /*  333543 */     // GIR_Coverage, 20225,
     /*  333543 */     GIR_EraseRootFromParent_Done,
     /*  333544 */   // Label 6113: @333544
     /*  333544 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(333607), // Rule ID 20228 //
     /*  333549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  333591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333605 */     GIR_RootConstrainSelectedInstOperands,
     /*  333606 */     // GIR_Coverage, 20228,
     /*  333606 */     GIR_EraseRootFromParent_Done,
     /*  333607 */   // Label 6114: @333607
     /*  333607 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(333670), // Rule ID 20229 //
     /*  333612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  333654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333668 */     GIR_RootConstrainSelectedInstOperands,
     /*  333669 */     // GIR_Coverage, 20229,
     /*  333669 */     GIR_EraseRootFromParent_Done,
     /*  333670 */   // Label 6115: @333670
     /*  333670 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(333733), // Rule ID 20232 //
     /*  333675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  333717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333731 */     GIR_RootConstrainSelectedInstOperands,
     /*  333732 */     // GIR_Coverage, 20232,
     /*  333732 */     GIR_EraseRootFromParent_Done,
     /*  333733 */   // Label 6116: @333733
     /*  333733 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(333796), // Rule ID 20233 //
     /*  333738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  333780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333794 */     GIR_RootConstrainSelectedInstOperands,
     /*  333795 */     // GIR_Coverage, 20233,
     /*  333795 */     GIR_EraseRootFromParent_Done,
     /*  333796 */   // Label 6117: @333796
     /*  333796 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(333859), // Rule ID 20236 //
     /*  333801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  333843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333857 */     GIR_RootConstrainSelectedInstOperands,
     /*  333858 */     // GIR_Coverage, 20236,
     /*  333858 */     GIR_EraseRootFromParent_Done,
     /*  333859 */   // Label 6118: @333859
     /*  333859 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(333922), // Rule ID 20237 //
     /*  333864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333903 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  333906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333920 */     GIR_RootConstrainSelectedInstOperands,
     /*  333921 */     // GIR_Coverage, 20237,
     /*  333921 */     GIR_EraseRootFromParent_Done,
     /*  333922 */   // Label 6119: @333922
     /*  333922 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(333985), // Rule ID 20240 //
     /*  333927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  333969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333983 */     GIR_RootConstrainSelectedInstOperands,
     /*  333984 */     // GIR_Coverage, 20240,
     /*  333984 */     GIR_EraseRootFromParent_Done,
     /*  333985 */   // Label 6120: @333985
     /*  333985 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(334048), // Rule ID 20241 //
     /*  333990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  333998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  334004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334029 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  334032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334046 */     GIR_RootConstrainSelectedInstOperands,
     /*  334047 */     // GIR_Coverage, 20241,
     /*  334047 */     GIR_EraseRootFromParent_Done,
     /*  334048 */   // Label 6121: @334048
     /*  334048 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(334111), // Rule ID 20244 //
     /*  334053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  334095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334109 */     GIR_RootConstrainSelectedInstOperands,
     /*  334110 */     // GIR_Coverage, 20244,
     /*  334110 */     GIR_EraseRootFromParent_Done,
     /*  334111 */   // Label 6122: @334111
     /*  334111 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(334174), // Rule ID 20245 //
     /*  334116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  334158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334172 */     GIR_RootConstrainSelectedInstOperands,
     /*  334173 */     // GIR_Coverage, 20245,
     /*  334173 */     GIR_EraseRootFromParent_Done,
     /*  334174 */   // Label 6123: @334174
     /*  334174 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(334237), // Rule ID 20248 //
     /*  334179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  334221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334235 */     GIR_RootConstrainSelectedInstOperands,
     /*  334236 */     // GIR_Coverage, 20248,
     /*  334236 */     GIR_EraseRootFromParent_Done,
     /*  334237 */   // Label 6124: @334237
     /*  334237 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(334300), // Rule ID 20249 //
     /*  334242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  334284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334298 */     GIR_RootConstrainSelectedInstOperands,
     /*  334299 */     // GIR_Coverage, 20249,
     /*  334299 */     GIR_EraseRootFromParent_Done,
     /*  334300 */   // Label 6125: @334300
     /*  334300 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(334363), // Rule ID 20252 //
     /*  334305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  334347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334361 */     GIR_RootConstrainSelectedInstOperands,
     /*  334362 */     // GIR_Coverage, 20252,
     /*  334362 */     GIR_EraseRootFromParent_Done,
     /*  334363 */   // Label 6126: @334363
     /*  334363 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(334426), // Rule ID 20253 //
     /*  334368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  334410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334424 */     GIR_RootConstrainSelectedInstOperands,
     /*  334425 */     // GIR_Coverage, 20253,
     /*  334425 */     GIR_EraseRootFromParent_Done,
     /*  334426 */   // Label 6127: @334426
     /*  334426 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(334489), // Rule ID 20256 //
     /*  334431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  334473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334487 */     GIR_RootConstrainSelectedInstOperands,
     /*  334488 */     // GIR_Coverage, 20256,
     /*  334488 */     GIR_EraseRootFromParent_Done,
     /*  334489 */   // Label 6128: @334489
     /*  334489 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(334552), // Rule ID 20257 //
     /*  334494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  334536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334550 */     GIR_RootConstrainSelectedInstOperands,
     /*  334551 */     // GIR_Coverage, 20257,
     /*  334551 */     GIR_EraseRootFromParent_Done,
     /*  334552 */   // Label 6129: @334552
     /*  334552 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(334615), // Rule ID 20260 //
     /*  334557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  334599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334613 */     GIR_RootConstrainSelectedInstOperands,
     /*  334614 */     // GIR_Coverage, 20260,
     /*  334614 */     GIR_EraseRootFromParent_Done,
     /*  334615 */   // Label 6130: @334615
     /*  334615 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(334678), // Rule ID 20261 //
     /*  334620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  334637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  334652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334659 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  334662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334676 */     GIR_RootConstrainSelectedInstOperands,
     /*  334677 */     // GIR_Coverage, 20261,
     /*  334677 */     GIR_EraseRootFromParent_Done,
     /*  334678 */   // Label 6131: @334678
     /*  334678 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(334741), // Rule ID 20264 //
     /*  334683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  334725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334739 */     GIR_RootConstrainSelectedInstOperands,
     /*  334740 */     // GIR_Coverage, 20264,
     /*  334740 */     GIR_EraseRootFromParent_Done,
     /*  334741 */   // Label 6132: @334741
     /*  334741 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(334804), // Rule ID 20265 //
     /*  334746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  334763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  334778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  334788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334802 */     GIR_RootConstrainSelectedInstOperands,
     /*  334803 */     // GIR_Coverage, 20265,
     /*  334803 */     GIR_EraseRootFromParent_Done,
     /*  334804 */   // Label 6133: @334804
     /*  334804 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(334867), // Rule ID 20268 //
     /*  334809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  334851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334865 */     GIR_RootConstrainSelectedInstOperands,
     /*  334866 */     // GIR_Coverage, 20268,
     /*  334866 */     GIR_EraseRootFromParent_Done,
     /*  334867 */   // Label 6134: @334867
     /*  334867 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(334930), // Rule ID 20269 //
     /*  334872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334911 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  334914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334928 */     GIR_RootConstrainSelectedInstOperands,
     /*  334929 */     // GIR_Coverage, 20269,
     /*  334929 */     GIR_EraseRootFromParent_Done,
     /*  334930 */   // Label 6135: @334930
     /*  334930 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(334993), // Rule ID 20272 //
     /*  334935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  334952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  334967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  334977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  334981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  334983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334991 */     GIR_RootConstrainSelectedInstOperands,
     /*  334992 */     // GIR_Coverage, 20272,
     /*  334992 */     GIR_EraseRootFromParent_Done,
     /*  334993 */   // Label 6136: @334993
     /*  334993 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(335056), // Rule ID 20273 //
     /*  334998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  335012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  335040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335054 */     GIR_RootConstrainSelectedInstOperands,
     /*  335055 */     // GIR_Coverage, 20273,
     /*  335055 */     GIR_EraseRootFromParent_Done,
     /*  335056 */   // Label 6137: @335056
     /*  335056 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(335119), // Rule ID 20276 //
     /*  335061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335100 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  335103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335117 */     GIR_RootConstrainSelectedInstOperands,
     /*  335118 */     // GIR_Coverage, 20276,
     /*  335118 */     GIR_EraseRootFromParent_Done,
     /*  335119 */   // Label 6138: @335119
     /*  335119 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(335182), // Rule ID 20277 //
     /*  335124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  335166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335180 */     GIR_RootConstrainSelectedInstOperands,
     /*  335181 */     // GIR_Coverage, 20277,
     /*  335181 */     GIR_EraseRootFromParent_Done,
     /*  335182 */   // Label 6139: @335182
     /*  335182 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(335245), // Rule ID 20280 //
     /*  335187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  335229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335243 */     GIR_RootConstrainSelectedInstOperands,
     /*  335244 */     // GIR_Coverage, 20280,
     /*  335244 */     GIR_EraseRootFromParent_Done,
     /*  335245 */   // Label 6140: @335245
     /*  335245 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(335308), // Rule ID 20281 //
     /*  335250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335289 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  335292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335306 */     GIR_RootConstrainSelectedInstOperands,
     /*  335307 */     // GIR_Coverage, 20281,
     /*  335307 */     GIR_EraseRootFromParent_Done,
     /*  335308 */   // Label 6141: @335308
     /*  335308 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(335371), // Rule ID 20284 //
     /*  335313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  335355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335369 */     GIR_RootConstrainSelectedInstOperands,
     /*  335370 */     // GIR_Coverage, 20284,
     /*  335370 */     GIR_EraseRootFromParent_Done,
     /*  335371 */   // Label 6142: @335371
     /*  335371 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(335434), // Rule ID 20285 //
     /*  335376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  335418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335432 */     GIR_RootConstrainSelectedInstOperands,
     /*  335433 */     // GIR_Coverage, 20285,
     /*  335433 */     GIR_EraseRootFromParent_Done,
     /*  335434 */   // Label 6143: @335434
     /*  335434 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(335497), // Rule ID 20288 //
     /*  335439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  335481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335495 */     GIR_RootConstrainSelectedInstOperands,
     /*  335496 */     // GIR_Coverage, 20288,
     /*  335496 */     GIR_EraseRootFromParent_Done,
     /*  335497 */   // Label 6144: @335497
     /*  335497 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(335560), // Rule ID 20289 //
     /*  335502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  335519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  335534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  335544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335558 */     GIR_RootConstrainSelectedInstOperands,
     /*  335559 */     // GIR_Coverage, 20289,
     /*  335559 */     GIR_EraseRootFromParent_Done,
     /*  335560 */   // Label 6145: @335560
     /*  335560 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(335623), // Rule ID 20292 //
     /*  335565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  335607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335621 */     GIR_RootConstrainSelectedInstOperands,
     /*  335622 */     // GIR_Coverage, 20292,
     /*  335622 */     GIR_EraseRootFromParent_Done,
     /*  335623 */   // Label 6146: @335623
     /*  335623 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(335686), // Rule ID 20293 //
     /*  335628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  335670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335684 */     GIR_RootConstrainSelectedInstOperands,
     /*  335685 */     // GIR_Coverage, 20293,
     /*  335685 */     GIR_EraseRootFromParent_Done,
     /*  335686 */   // Label 6147: @335686
     /*  335686 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(335749), // Rule ID 20296 //
     /*  335691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  335733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335747 */     GIR_RootConstrainSelectedInstOperands,
     /*  335748 */     // GIR_Coverage, 20296,
     /*  335748 */     GIR_EraseRootFromParent_Done,
     /*  335749 */   // Label 6148: @335749
     /*  335749 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(335812), // Rule ID 20297 //
     /*  335754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  335796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335810 */     GIR_RootConstrainSelectedInstOperands,
     /*  335811 */     // GIR_Coverage, 20297,
     /*  335811 */     GIR_EraseRootFromParent_Done,
     /*  335812 */   // Label 6149: @335812
     /*  335812 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(335875), // Rule ID 20300 //
     /*  335817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  335859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335873 */     GIR_RootConstrainSelectedInstOperands,
     /*  335874 */     // GIR_Coverage, 20300,
     /*  335874 */     GIR_EraseRootFromParent_Done,
     /*  335875 */   // Label 6150: @335875
     /*  335875 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(335938), // Rule ID 20301 //
     /*  335880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  335897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  335912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  335922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335936 */     GIR_RootConstrainSelectedInstOperands,
     /*  335937 */     // GIR_Coverage, 20301,
     /*  335937 */     GIR_EraseRootFromParent_Done,
     /*  335938 */   // Label 6151: @335938
     /*  335938 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(336001), // Rule ID 20304 //
     /*  335943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  335960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  335975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  335985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  335989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  335991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335999 */     GIR_RootConstrainSelectedInstOperands,
     /*  336000 */     // GIR_Coverage, 20304,
     /*  336000 */     GIR_EraseRootFromParent_Done,
     /*  336001 */   // Label 6152: @336001
     /*  336001 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(336064), // Rule ID 20305 //
     /*  336006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  336020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336045 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  336048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336062 */     GIR_RootConstrainSelectedInstOperands,
     /*  336063 */     // GIR_Coverage, 20305,
     /*  336063 */     GIR_EraseRootFromParent_Done,
     /*  336064 */   // Label 6153: @336064
     /*  336064 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(336127), // Rule ID 20308 //
     /*  336069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  336111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336125 */     GIR_RootConstrainSelectedInstOperands,
     /*  336126 */     // GIR_Coverage, 20308,
     /*  336126 */     GIR_EraseRootFromParent_Done,
     /*  336127 */   // Label 6154: @336127
     /*  336127 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(336190), // Rule ID 20309 //
     /*  336132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  336174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336188 */     GIR_RootConstrainSelectedInstOperands,
     /*  336189 */     // GIR_Coverage, 20309,
     /*  336189 */     GIR_EraseRootFromParent_Done,
     /*  336190 */   // Label 6155: @336190
     /*  336190 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(336253), // Rule ID 20312 //
     /*  336195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  336237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336251 */     GIR_RootConstrainSelectedInstOperands,
     /*  336252 */     // GIR_Coverage, 20312,
     /*  336252 */     GIR_EraseRootFromParent_Done,
     /*  336253 */   // Label 6156: @336253
     /*  336253 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(336316), // Rule ID 20313 //
     /*  336258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  336300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336314 */     GIR_RootConstrainSelectedInstOperands,
     /*  336315 */     // GIR_Coverage, 20313,
     /*  336315 */     GIR_EraseRootFromParent_Done,
     /*  336316 */   // Label 6157: @336316
     /*  336316 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(336379), // Rule ID 20316 //
     /*  336321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  336363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336377 */     GIR_RootConstrainSelectedInstOperands,
     /*  336378 */     // GIR_Coverage, 20316,
     /*  336378 */     GIR_EraseRootFromParent_Done,
     /*  336379 */   // Label 6158: @336379
     /*  336379 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(336442), // Rule ID 20317 //
     /*  336384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  336426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336440 */     GIR_RootConstrainSelectedInstOperands,
     /*  336441 */     // GIR_Coverage, 20317,
     /*  336441 */     GIR_EraseRootFromParent_Done,
     /*  336442 */   // Label 6159: @336442
     /*  336442 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(336505), // Rule ID 20320 //
     /*  336447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  336489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336503 */     GIR_RootConstrainSelectedInstOperands,
     /*  336504 */     // GIR_Coverage, 20320,
     /*  336504 */     GIR_EraseRootFromParent_Done,
     /*  336505 */   // Label 6160: @336505
     /*  336505 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(336568), // Rule ID 20321 //
     /*  336510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  336527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  336542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  336552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336566 */     GIR_RootConstrainSelectedInstOperands,
     /*  336567 */     // GIR_Coverage, 20321,
     /*  336567 */     GIR_EraseRootFromParent_Done,
     /*  336568 */   // Label 6161: @336568
     /*  336568 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(336631), // Rule ID 20324 //
     /*  336573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  336590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  336605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  336615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336629 */     GIR_RootConstrainSelectedInstOperands,
     /*  336630 */     // GIR_Coverage, 20324,
     /*  336630 */     GIR_EraseRootFromParent_Done,
     /*  336631 */   // Label 6162: @336631
     /*  336631 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(336694), // Rule ID 20325 //
     /*  336636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  336653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  336668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  336678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336692 */     GIR_RootConstrainSelectedInstOperands,
     /*  336693 */     // GIR_Coverage, 20325,
     /*  336693 */     GIR_EraseRootFromParent_Done,
     /*  336694 */   // Label 6163: @336694
     /*  336694 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(336757), // Rule ID 20328 //
     /*  336699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  336741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336755 */     GIR_RootConstrainSelectedInstOperands,
     /*  336756 */     // GIR_Coverage, 20328,
     /*  336756 */     GIR_EraseRootFromParent_Done,
     /*  336757 */   // Label 6164: @336757
     /*  336757 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(336820), // Rule ID 20329 //
     /*  336762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  336804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336818 */     GIR_RootConstrainSelectedInstOperands,
     /*  336819 */     // GIR_Coverage, 20329,
     /*  336819 */     GIR_EraseRootFromParent_Done,
     /*  336820 */   // Label 6165: @336820
     /*  336820 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(336883), // Rule ID 20332 //
     /*  336825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  336867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336881 */     GIR_RootConstrainSelectedInstOperands,
     /*  336882 */     // GIR_Coverage, 20332,
     /*  336882 */     GIR_EraseRootFromParent_Done,
     /*  336883 */   // Label 6166: @336883
     /*  336883 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(336946), // Rule ID 20333 //
     /*  336888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  336930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336944 */     GIR_RootConstrainSelectedInstOperands,
     /*  336945 */     // GIR_Coverage, 20333,
     /*  336945 */     GIR_EraseRootFromParent_Done,
     /*  336946 */   // Label 6167: @336946
     /*  336946 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(337009), // Rule ID 20336 //
     /*  336951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  336968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  336983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  336993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  336997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  336999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337007 */     GIR_RootConstrainSelectedInstOperands,
     /*  337008 */     // GIR_Coverage, 20336,
     /*  337008 */     GIR_EraseRootFromParent_Done,
     /*  337009 */   // Label 6168: @337009
     /*  337009 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(337072), // Rule ID 20337 //
     /*  337014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  337025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  337028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  337031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  337046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337053 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  337056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337070 */     GIR_RootConstrainSelectedInstOperands,
     /*  337071 */     // GIR_Coverage, 20337,
     /*  337071 */     GIR_EraseRootFromParent_Done,
     /*  337072 */   // Label 6169: @337072
     /*  337072 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(337135), // Rule ID 20340 //
     /*  337077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  337119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337133 */     GIR_RootConstrainSelectedInstOperands,
     /*  337134 */     // GIR_Coverage, 20340,
     /*  337134 */     GIR_EraseRootFromParent_Done,
     /*  337135 */   // Label 6170: @337135
     /*  337135 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(337198), // Rule ID 20341 //
     /*  337140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  337182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337196 */     GIR_RootConstrainSelectedInstOperands,
     /*  337197 */     // GIR_Coverage, 20341,
     /*  337197 */     GIR_EraseRootFromParent_Done,
     /*  337198 */   // Label 6171: @337198
     /*  337198 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(337261), // Rule ID 20344 //
     /*  337203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  337245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337259 */     GIR_RootConstrainSelectedInstOperands,
     /*  337260 */     // GIR_Coverage, 20344,
     /*  337260 */     GIR_EraseRootFromParent_Done,
     /*  337261 */   // Label 6172: @337261
     /*  337261 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(337324), // Rule ID 20345 //
     /*  337266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  337308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337322 */     GIR_RootConstrainSelectedInstOperands,
     /*  337323 */     // GIR_Coverage, 20345,
     /*  337323 */     GIR_EraseRootFromParent_Done,
     /*  337324 */   // Label 6173: @337324
     /*  337324 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(337387), // Rule ID 20348 //
     /*  337329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  337371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337385 */     GIR_RootConstrainSelectedInstOperands,
     /*  337386 */     // GIR_Coverage, 20348,
     /*  337386 */     GIR_EraseRootFromParent_Done,
     /*  337387 */   // Label 6174: @337387
     /*  337387 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(337450), // Rule ID 20349 //
     /*  337392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  337409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  337424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337431 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  337434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337448 */     GIR_RootConstrainSelectedInstOperands,
     /*  337449 */     // GIR_Coverage, 20349,
     /*  337449 */     GIR_EraseRootFromParent_Done,
     /*  337450 */   // Label 6175: @337450
     /*  337450 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(337513), // Rule ID 20352 //
     /*  337455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  337497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337511 */     GIR_RootConstrainSelectedInstOperands,
     /*  337512 */     // GIR_Coverage, 20352,
     /*  337512 */     GIR_EraseRootFromParent_Done,
     /*  337513 */   // Label 6176: @337513
     /*  337513 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(337576), // Rule ID 20353 //
     /*  337518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  337560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337574 */     GIR_RootConstrainSelectedInstOperands,
     /*  337575 */     // GIR_Coverage, 20353,
     /*  337575 */     GIR_EraseRootFromParent_Done,
     /*  337576 */   // Label 6177: @337576
     /*  337576 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(337639), // Rule ID 20356 //
     /*  337581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  337623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337637 */     GIR_RootConstrainSelectedInstOperands,
     /*  337638 */     // GIR_Coverage, 20356,
     /*  337638 */     GIR_EraseRootFromParent_Done,
     /*  337639 */   // Label 6178: @337639
     /*  337639 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(337702), // Rule ID 20357 //
     /*  337644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  337686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337700 */     GIR_RootConstrainSelectedInstOperands,
     /*  337701 */     // GIR_Coverage, 20357,
     /*  337701 */     GIR_EraseRootFromParent_Done,
     /*  337702 */   // Label 6179: @337702
     /*  337702 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(337765), // Rule ID 20360 //
     /*  337707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  337749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337763 */     GIR_RootConstrainSelectedInstOperands,
     /*  337764 */     // GIR_Coverage, 20360,
     /*  337764 */     GIR_EraseRootFromParent_Done,
     /*  337765 */   // Label 6180: @337765
     /*  337765 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(337828), // Rule ID 20361 //
     /*  337770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  337787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  337802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337809 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  337812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  337816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337826 */     GIR_RootConstrainSelectedInstOperands,
     /*  337827 */     // GIR_Coverage, 20361,
     /*  337827 */     GIR_EraseRootFromParent_Done,
     /*  337828 */   // Label 6181: @337828
     /*  337828 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(337891), // Rule ID 20364 //
     /*  337833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  337847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  337850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  337875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337889 */     GIR_RootConstrainSelectedInstOperands,
     /*  337890 */     // GIR_Coverage, 20364,
     /*  337890 */     GIR_EraseRootFromParent_Done,
     /*  337891 */   // Label 6182: @337891
     /*  337891 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(337954), // Rule ID 20365 //
     /*  337896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  337899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  337907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  337910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  337913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  337935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  337938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337952 */     GIR_RootConstrainSelectedInstOperands,
     /*  337953 */     // GIR_Coverage, 20365,
     /*  337953 */     GIR_EraseRootFromParent_Done,
     /*  337954 */   // Label 6183: @337954
     /*  337954 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(338017), // Rule ID 20368 //
     /*  337959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  337962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  337967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  337998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338015 */     GIR_RootConstrainSelectedInstOperands,
     /*  338016 */     // GIR_Coverage, 20368,
     /*  338016 */     GIR_EraseRootFromParent_Done,
     /*  338017 */   // Label 6184: @338017
     /*  338017 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(338080), // Rule ID 20369 //
     /*  338022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  338036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  338039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338061 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338078 */     GIR_RootConstrainSelectedInstOperands,
     /*  338079 */     // GIR_Coverage, 20369,
     /*  338079 */     GIR_EraseRootFromParent_Done,
     /*  338080 */   // Label 6185: @338080
     /*  338080 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(338143), // Rule ID 20372 //
     /*  338085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  338124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338141 */     GIR_RootConstrainSelectedInstOperands,
     /*  338142 */     // GIR_Coverage, 20372,
     /*  338142 */     GIR_EraseRootFromParent_Done,
     /*  338143 */   // Label 6186: @338143
     /*  338143 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(338206), // Rule ID 20373 //
     /*  338148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  338151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  338162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  338165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338187 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  338187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  338190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338204 */     GIR_RootConstrainSelectedInstOperands,
     /*  338205 */     // GIR_Coverage, 20373,
     /*  338205 */     GIR_EraseRootFromParent_Done,
     /*  338206 */   // Label 6187: @338206
     /*  338206 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(338269), // Rule ID 20376 //
     /*  338211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338267 */     GIR_RootConstrainSelectedInstOperands,
     /*  338268 */     // GIR_Coverage, 20376,
     /*  338268 */     GIR_EraseRootFromParent_Done,
     /*  338269 */   // Label 6188: @338269
     /*  338269 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(338332), // Rule ID 20377 //
     /*  338274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338313 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338330 */     GIR_RootConstrainSelectedInstOperands,
     /*  338331 */     // GIR_Coverage, 20377,
     /*  338331 */     GIR_EraseRootFromParent_Done,
     /*  338332 */   // Label 6189: @338332
     /*  338332 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(338395), // Rule ID 20380 //
     /*  338337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  338376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338393 */     GIR_RootConstrainSelectedInstOperands,
     /*  338394 */     // GIR_Coverage, 20380,
     /*  338394 */     GIR_EraseRootFromParent_Done,
     /*  338395 */   // Label 6190: @338395
     /*  338395 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(338458), // Rule ID 20381 //
     /*  338400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  338403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  338411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  338439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338456 */     GIR_RootConstrainSelectedInstOperands,
     /*  338457 */     // GIR_Coverage, 20381,
     /*  338457 */     GIR_EraseRootFromParent_Done,
     /*  338458 */   // Label 6191: @338458
     /*  338458 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(338521), // Rule ID 20384 //
     /*  338463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  338466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338502 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  338502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338519 */     GIR_RootConstrainSelectedInstOperands,
     /*  338520 */     // GIR_Coverage, 20384,
     /*  338520 */     GIR_EraseRootFromParent_Done,
     /*  338521 */   // Label 6192: @338521
     /*  338521 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(338584), // Rule ID 20385 //
     /*  338526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  338529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  338537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338565 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  338565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  338568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338582 */     GIR_RootConstrainSelectedInstOperands,
     /*  338583 */     // GIR_Coverage, 20385,
     /*  338583 */     GIR_EraseRootFromParent_Done,
     /*  338584 */   // Label 6193: @338584
     /*  338584 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(338647), // Rule ID 20388 //
     /*  338589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  338631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338645 */     GIR_RootConstrainSelectedInstOperands,
     /*  338646 */     // GIR_Coverage, 20388,
     /*  338646 */     GIR_EraseRootFromParent_Done,
     /*  338647 */   // Label 6194: @338647
     /*  338647 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(338710), // Rule ID 20389 //
     /*  338652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  338663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  338694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338708 */     GIR_RootConstrainSelectedInstOperands,
     /*  338709 */     // GIR_Coverage, 20389,
     /*  338709 */     GIR_EraseRootFromParent_Done,
     /*  338710 */   // Label 6195: @338710
     /*  338710 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(338773), // Rule ID 20392 //
     /*  338715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  338726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  338757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338771 */     GIR_RootConstrainSelectedInstOperands,
     /*  338772 */     // GIR_Coverage, 20392,
     /*  338772 */     GIR_EraseRootFromParent_Done,
     /*  338773 */   // Label 6196: @338773
     /*  338773 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(338836), // Rule ID 20393 //
     /*  338778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  338789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  338820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338834 */     GIR_RootConstrainSelectedInstOperands,
     /*  338835 */     // GIR_Coverage, 20393,
     /*  338835 */     GIR_EraseRootFromParent_Done,
     /*  338836 */   // Label 6197: @338836
     /*  338836 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(338899), // Rule ID 20396 //
     /*  338841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  338844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  338852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  338880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  338883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338897 */     GIR_RootConstrainSelectedInstOperands,
     /*  338898 */     // GIR_Coverage, 20396,
     /*  338898 */     GIR_EraseRootFromParent_Done,
     /*  338899 */   // Label 6198: @338899
     /*  338899 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(338962), // Rule ID 20397 //
     /*  338904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  338907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  338915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338943 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  338943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  338946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  338950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  338952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338960 */     GIR_RootConstrainSelectedInstOperands,
     /*  338961 */     // GIR_Coverage, 20397,
     /*  338961 */     GIR_EraseRootFromParent_Done,
     /*  338962 */   // Label 6199: @338962
     /*  338962 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(339025), // Rule ID 20400 //
     /*  338967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  338970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  338975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  338978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339023 */     GIR_RootConstrainSelectedInstOperands,
     /*  339024 */     // GIR_Coverage, 20400,
     /*  339024 */     GIR_EraseRootFromParent_Done,
     /*  339025 */   // Label 6200: @339025
     /*  339025 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(339088), // Rule ID 20401 //
     /*  339030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  339044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  339047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339069 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339086 */     GIR_RootConstrainSelectedInstOperands,
     /*  339087 */     // GIR_Coverage, 20401,
     /*  339087 */     GIR_EraseRootFromParent_Done,
     /*  339088 */   // Label 6201: @339088
     /*  339088 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(339151), // Rule ID 20404 //
     /*  339093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339149 */     GIR_RootConstrainSelectedInstOperands,
     /*  339150 */     // GIR_Coverage, 20404,
     /*  339150 */     GIR_EraseRootFromParent_Done,
     /*  339151 */   // Label 6202: @339151
     /*  339151 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(339214), // Rule ID 20405 //
     /*  339156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339212 */     GIR_RootConstrainSelectedInstOperands,
     /*  339213 */     // GIR_Coverage, 20405,
     /*  339213 */     GIR_EraseRootFromParent_Done,
     /*  339214 */   // Label 6203: @339214
     /*  339214 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(339277), // Rule ID 20408 //
     /*  339219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  339230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339258 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  339258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339275 */     GIR_RootConstrainSelectedInstOperands,
     /*  339276 */     // GIR_Coverage, 20408,
     /*  339276 */     GIR_EraseRootFromParent_Done,
     /*  339277 */   // Label 6204: @339277
     /*  339277 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(339340), // Rule ID 20409 //
     /*  339282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  339285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  339293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339321 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  339321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339338 */     GIR_RootConstrainSelectedInstOperands,
     /*  339339 */     // GIR_Coverage, 20409,
     /*  339339 */     GIR_EraseRootFromParent_Done,
     /*  339340 */   // Label 6205: @339340
     /*  339340 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(339403), // Rule ID 20412 //
     /*  339345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339401 */     GIR_RootConstrainSelectedInstOperands,
     /*  339402 */     // GIR_Coverage, 20412,
     /*  339402 */     GIR_EraseRootFromParent_Done,
     /*  339403 */   // Label 6206: @339403
     /*  339403 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(339466), // Rule ID 20413 //
     /*  339408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  339450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339464 */     GIR_RootConstrainSelectedInstOperands,
     /*  339465 */     // GIR_Coverage, 20413,
     /*  339465 */     GIR_EraseRootFromParent_Done,
     /*  339466 */   // Label 6207: @339466
     /*  339466 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(339529), // Rule ID 20416 //
     /*  339471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339527 */     GIR_RootConstrainSelectedInstOperands,
     /*  339528 */     // GIR_Coverage, 20416,
     /*  339528 */     GIR_EraseRootFromParent_Done,
     /*  339529 */   // Label 6208: @339529
     /*  339529 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(339592), // Rule ID 20417 //
     /*  339534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  339545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339573 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  339576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339590 */     GIR_RootConstrainSelectedInstOperands,
     /*  339591 */     // GIR_Coverage, 20417,
     /*  339591 */     GIR_EraseRootFromParent_Done,
     /*  339592 */   // Label 6209: @339592
     /*  339592 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(339655), // Rule ID 20420 //
     /*  339597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  339600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  339636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339653 */     GIR_RootConstrainSelectedInstOperands,
     /*  339654 */     // GIR_Coverage, 20420,
     /*  339654 */     GIR_EraseRootFromParent_Done,
     /*  339655 */   // Label 6210: @339655
     /*  339655 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(339718), // Rule ID 20421 //
     /*  339660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  339663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  339668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  339671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339699 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  339699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  339702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339716 */     GIR_RootConstrainSelectedInstOperands,
     /*  339717 */     // GIR_Coverage, 20421,
     /*  339717 */     GIR_EraseRootFromParent_Done,
     /*  339718 */   // Label 6211: @339718
     /*  339718 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(339781), // Rule ID 20424 //
     /*  339723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  339726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  339762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  339765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339779 */     GIR_RootConstrainSelectedInstOperands,
     /*  339780 */     // GIR_Coverage, 20424,
     /*  339780 */     GIR_EraseRootFromParent_Done,
     /*  339781 */   // Label 6212: @339781
     /*  339781 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(339844), // Rule ID 20425 //
     /*  339786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  339789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339825 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  339825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  339828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339842 */     GIR_RootConstrainSelectedInstOperands,
     /*  339843 */     // GIR_Coverage, 20425,
     /*  339843 */     GIR_EraseRootFromParent_Done,
     /*  339844 */   // Label 6213: @339844
     /*  339844 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(339907), // Rule ID 20428 //
     /*  339849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  339852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  339888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  339891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339905 */     GIR_RootConstrainSelectedInstOperands,
     /*  339906 */     // GIR_Coverage, 20428,
     /*  339906 */     GIR_EraseRootFromParent_Done,
     /*  339907 */   // Label 6214: @339907
     /*  339907 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(339970), // Rule ID 20429 //
     /*  339912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  339915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  339923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339951 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  339951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  339954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  339958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  339960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339968 */     GIR_RootConstrainSelectedInstOperands,
     /*  339969 */     // GIR_Coverage, 20429,
     /*  339969 */     GIR_EraseRootFromParent_Done,
     /*  339970 */   // Label 6215: @339970
     /*  339970 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(340033), // Rule ID 20432 //
     /*  339975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  339978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  339983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  339986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  340017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340031 */     GIR_RootConstrainSelectedInstOperands,
     /*  340032 */     // GIR_Coverage, 20432,
     /*  340032 */     GIR_EraseRootFromParent_Done,
     /*  340033 */   // Label 6216: @340033
     /*  340033 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(340096), // Rule ID 20433 //
     /*  340038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  340052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  340055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340077 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  340080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340094 */     GIR_RootConstrainSelectedInstOperands,
     /*  340095 */     // GIR_Coverage, 20433,
     /*  340095 */     GIR_EraseRootFromParent_Done,
     /*  340096 */   // Label 6217: @340096
     /*  340096 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(340159), // Rule ID 20436 //
     /*  340101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340157 */     GIR_RootConstrainSelectedInstOperands,
     /*  340158 */     // GIR_Coverage, 20436,
     /*  340158 */     GIR_EraseRootFromParent_Done,
     /*  340159 */   // Label 6218: @340159
     /*  340159 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(340222), // Rule ID 20437 //
     /*  340164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340220 */     GIR_RootConstrainSelectedInstOperands,
     /*  340221 */     // GIR_Coverage, 20437,
     /*  340221 */     GIR_EraseRootFromParent_Done,
     /*  340222 */   // Label 6219: @340222
     /*  340222 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(340285), // Rule ID 20440 //
     /*  340227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  340238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340283 */     GIR_RootConstrainSelectedInstOperands,
     /*  340284 */     // GIR_Coverage, 20440,
     /*  340284 */     GIR_EraseRootFromParent_Done,
     /*  340285 */   // Label 6220: @340285
     /*  340285 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(340348), // Rule ID 20441 //
     /*  340290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  340301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340346 */     GIR_RootConstrainSelectedInstOperands,
     /*  340347 */     // GIR_Coverage, 20441,
     /*  340347 */     GIR_EraseRootFromParent_Done,
     /*  340348 */   // Label 6221: @340348
     /*  340348 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(340411), // Rule ID 20444 //
     /*  340353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  340356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  340392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340409 */     GIR_RootConstrainSelectedInstOperands,
     /*  340410 */     // GIR_Coverage, 20444,
     /*  340410 */     GIR_EraseRootFromParent_Done,
     /*  340411 */   // Label 6222: @340411
     /*  340411 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(340474), // Rule ID 20445 //
     /*  340416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  340419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  340427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  340455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  340458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340472 */     GIR_RootConstrainSelectedInstOperands,
     /*  340473 */     // GIR_Coverage, 20445,
     /*  340473 */     GIR_EraseRootFromParent_Done,
     /*  340474 */   // Label 6223: @340474
     /*  340474 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(340537), // Rule ID 20448 //
     /*  340479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340535 */     GIR_RootConstrainSelectedInstOperands,
     /*  340536 */     // GIR_Coverage, 20448,
     /*  340536 */     GIR_EraseRootFromParent_Done,
     /*  340537 */   // Label 6224: @340537
     /*  340537 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(340600), // Rule ID 20449 //
     /*  340542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340581 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340598 */     GIR_RootConstrainSelectedInstOperands,
     /*  340599 */     // GIR_Coverage, 20449,
     /*  340599 */     GIR_EraseRootFromParent_Done,
     /*  340600 */   // Label 6225: @340600
     /*  340600 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(340663), // Rule ID 20452 //
     /*  340605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  340616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340644 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  340647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340661 */     GIR_RootConstrainSelectedInstOperands,
     /*  340662 */     // GIR_Coverage, 20452,
     /*  340662 */     GIR_EraseRootFromParent_Done,
     /*  340663 */   // Label 6226: @340663
     /*  340663 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(340726), // Rule ID 20453 //
     /*  340668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  340679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340707 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  340710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340724 */     GIR_RootConstrainSelectedInstOperands,
     /*  340725 */     // GIR_Coverage, 20453,
     /*  340725 */     GIR_EraseRootFromParent_Done,
     /*  340726 */   // Label 6227: @340726
     /*  340726 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(340789), // Rule ID 20456 //
     /*  340731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  340734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  340742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340770 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  340770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  340773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340787 */     GIR_RootConstrainSelectedInstOperands,
     /*  340788 */     // GIR_Coverage, 20456,
     /*  340788 */     GIR_EraseRootFromParent_Done,
     /*  340789 */   // Label 6228: @340789
     /*  340789 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(340852), // Rule ID 20457 //
     /*  340794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  340797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  340805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340833 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  340833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  340836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340850 */     GIR_RootConstrainSelectedInstOperands,
     /*  340851 */     // GIR_Coverage, 20457,
     /*  340851 */     GIR_EraseRootFromParent_Done,
     /*  340852 */   // Label 6229: @340852
     /*  340852 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(340915), // Rule ID 20460 //
     /*  340857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  340896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340913 */     GIR_RootConstrainSelectedInstOperands,
     /*  340914 */     // GIR_Coverage, 20460,
     /*  340914 */     GIR_EraseRootFromParent_Done,
     /*  340915 */   // Label 6230: @340915
     /*  340915 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(340978), // Rule ID 20461 //
     /*  340920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  340923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  340931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340959 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  340959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  340962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  340966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  340968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340976 */     GIR_RootConstrainSelectedInstOperands,
     /*  340977 */     // GIR_Coverage, 20461,
     /*  340977 */     GIR_EraseRootFromParent_Done,
     /*  340978 */   // Label 6231: @340978
     /*  340978 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(341041), // Rule ID 20464 //
     /*  340983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  340986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  340991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  340994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  341022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341039 */     GIR_RootConstrainSelectedInstOperands,
     /*  341040 */     // GIR_Coverage, 20464,
     /*  341040 */     GIR_EraseRootFromParent_Done,
     /*  341041 */   // Label 6232: @341041
     /*  341041 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(341104), // Rule ID 20465 //
     /*  341046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  341049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  341085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341102 */     GIR_RootConstrainSelectedInstOperands,
     /*  341103 */     // GIR_Coverage, 20465,
     /*  341103 */     GIR_EraseRootFromParent_Done,
     /*  341104 */   // Label 6233: @341104
     /*  341104 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(341167), // Rule ID 20468 //
     /*  341109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  341112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  341120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341148 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  341148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341165 */     GIR_RootConstrainSelectedInstOperands,
     /*  341166 */     // GIR_Coverage, 20468,
     /*  341166 */     GIR_EraseRootFromParent_Done,
     /*  341167 */   // Label 6234: @341167
     /*  341167 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(341230), // Rule ID 20469 //
     /*  341172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  341175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  341183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341211 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  341211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341228 */     GIR_RootConstrainSelectedInstOperands,
     /*  341229 */     // GIR_Coverage, 20469,
     /*  341229 */     GIR_EraseRootFromParent_Done,
     /*  341230 */   // Label 6235: @341230
     /*  341230 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(341293), // Rule ID 20472 //
     /*  341235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  341246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  341277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341291 */     GIR_RootConstrainSelectedInstOperands,
     /*  341292 */     // GIR_Coverage, 20472,
     /*  341292 */     GIR_EraseRootFromParent_Done,
     /*  341293 */   // Label 6236: @341293
     /*  341293 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(341356), // Rule ID 20473 //
     /*  341298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  341309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341337 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  341340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341354 */     GIR_RootConstrainSelectedInstOperands,
     /*  341355 */     // GIR_Coverage, 20473,
     /*  341355 */     GIR_EraseRootFromParent_Done,
     /*  341356 */   // Label 6237: @341356
     /*  341356 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(341419), // Rule ID 20476 //
     /*  341361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  341372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341417 */     GIR_RootConstrainSelectedInstOperands,
     /*  341418 */     // GIR_Coverage, 20476,
     /*  341418 */     GIR_EraseRootFromParent_Done,
     /*  341419 */   // Label 6238: @341419
     /*  341419 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(341482), // Rule ID 20477 //
     /*  341424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  341435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341463 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  341466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341480 */     GIR_RootConstrainSelectedInstOperands,
     /*  341481 */     // GIR_Coverage, 20477,
     /*  341481 */     GIR_EraseRootFromParent_Done,
     /*  341482 */   // Label 6239: @341482
     /*  341482 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(341545), // Rule ID 20480 //
     /*  341487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  341490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  341526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341543 */     GIR_RootConstrainSelectedInstOperands,
     /*  341544 */     // GIR_Coverage, 20480,
     /*  341544 */     GIR_EraseRootFromParent_Done,
     /*  341545 */   // Label 6240: @341545
     /*  341545 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(341608), // Rule ID 20481 //
     /*  341550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  341553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  341558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  341561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341589 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  341589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  341592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  341596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  341598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341606 */     GIR_RootConstrainSelectedInstOperands,
     /*  341607 */     // GIR_Coverage, 20481,
     /*  341607 */     GIR_EraseRootFromParent_Done,
     /*  341608 */   // Label 6241: @341608
     /*  341608 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(341674), // Rule ID 20484 //
     /*  341613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341672 */     GIR_RootConstrainSelectedInstOperands,
     /*  341673 */     // GIR_Coverage, 20484,
     /*  341673 */     GIR_EraseRootFromParent_Done,
     /*  341674 */   // Label 6242: @341674
     /*  341674 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(341740), // Rule ID 20485 //
     /*  341679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341738 */     GIR_RootConstrainSelectedInstOperands,
     /*  341739 */     // GIR_Coverage, 20485,
     /*  341739 */     GIR_EraseRootFromParent_Done,
     /*  341740 */   // Label 6243: @341740
     /*  341740 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(341806), // Rule ID 20488 //
     /*  341745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341804 */     GIR_RootConstrainSelectedInstOperands,
     /*  341805 */     // GIR_Coverage, 20488,
     /*  341805 */     GIR_EraseRootFromParent_Done,
     /*  341806 */   // Label 6244: @341806
     /*  341806 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(341872), // Rule ID 20489 //
     /*  341811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  341853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341870 */     GIR_RootConstrainSelectedInstOperands,
     /*  341871 */     // GIR_Coverage, 20489,
     /*  341871 */     GIR_EraseRootFromParent_Done,
     /*  341872 */   // Label 6245: @341872
     /*  341872 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(341938), // Rule ID 20492 //
     /*  341877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  341919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341936 */     GIR_RootConstrainSelectedInstOperands,
     /*  341937 */     // GIR_Coverage, 20492,
     /*  341937 */     GIR_EraseRootFromParent_Done,
     /*  341938 */   // Label 6246: @341938
     /*  341938 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(342004), // Rule ID 20493 //
     /*  341943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  341951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  341985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342002 */     GIR_RootConstrainSelectedInstOperands,
     /*  342003 */     // GIR_Coverage, 20493,
     /*  342003 */     GIR_EraseRootFromParent_Done,
     /*  342004 */   // Label 6247: @342004
     /*  342004 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(342070), // Rule ID 20496 //
     /*  342009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342068 */     GIR_RootConstrainSelectedInstOperands,
     /*  342069 */     // GIR_Coverage, 20496,
     /*  342069 */     GIR_EraseRootFromParent_Done,
     /*  342070 */   // Label 6248: @342070
     /*  342070 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(342136), // Rule ID 20497 //
     /*  342075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342134 */     GIR_RootConstrainSelectedInstOperands,
     /*  342135 */     // GIR_Coverage, 20497,
     /*  342135 */     GIR_EraseRootFromParent_Done,
     /*  342136 */   // Label 6249: @342136
     /*  342136 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(342202), // Rule ID 20500 //
     /*  342141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342200 */     GIR_RootConstrainSelectedInstOperands,
     /*  342201 */     // GIR_Coverage, 20500,
     /*  342201 */     GIR_EraseRootFromParent_Done,
     /*  342202 */   // Label 6250: @342202
     /*  342202 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(342268), // Rule ID 20501 //
     /*  342207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  342249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342266 */     GIR_RootConstrainSelectedInstOperands,
     /*  342267 */     // GIR_Coverage, 20501,
     /*  342267 */     GIR_EraseRootFromParent_Done,
     /*  342268 */   // Label 6251: @342268
     /*  342268 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(342334), // Rule ID 20504 //
     /*  342273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342332 */     GIR_RootConstrainSelectedInstOperands,
     /*  342333 */     // GIR_Coverage, 20504,
     /*  342333 */     GIR_EraseRootFromParent_Done,
     /*  342334 */   // Label 6252: @342334
     /*  342334 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(342400), // Rule ID 20505 //
     /*  342339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342398 */     GIR_RootConstrainSelectedInstOperands,
     /*  342399 */     // GIR_Coverage, 20505,
     /*  342399 */     GIR_EraseRootFromParent_Done,
     /*  342400 */   // Label 6253: @342400
     /*  342400 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(342466), // Rule ID 20508 //
     /*  342405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342464 */     GIR_RootConstrainSelectedInstOperands,
     /*  342465 */     // GIR_Coverage, 20508,
     /*  342465 */     GIR_EraseRootFromParent_Done,
     /*  342466 */   // Label 6254: @342466
     /*  342466 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(342532), // Rule ID 20509 //
     /*  342471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342510 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342530 */     GIR_RootConstrainSelectedInstOperands,
     /*  342531 */     // GIR_Coverage, 20509,
     /*  342531 */     GIR_EraseRootFromParent_Done,
     /*  342532 */   // Label 6255: @342532
     /*  342532 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(342598), // Rule ID 20512 //
     /*  342537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342596 */     GIR_RootConstrainSelectedInstOperands,
     /*  342597 */     // GIR_Coverage, 20512,
     /*  342597 */     GIR_EraseRootFromParent_Done,
     /*  342598 */   // Label 6256: @342598
     /*  342598 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(342664), // Rule ID 20513 //
     /*  342603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342662 */     GIR_RootConstrainSelectedInstOperands,
     /*  342663 */     // GIR_Coverage, 20513,
     /*  342663 */     GIR_EraseRootFromParent_Done,
     /*  342664 */   // Label 6257: @342664
     /*  342664 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(342730), // Rule ID 20516 //
     /*  342669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342728 */     GIR_RootConstrainSelectedInstOperands,
     /*  342729 */     // GIR_Coverage, 20516,
     /*  342729 */     GIR_EraseRootFromParent_Done,
     /*  342730 */   // Label 6258: @342730
     /*  342730 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(342796), // Rule ID 20517 //
     /*  342735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  342777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342794 */     GIR_RootConstrainSelectedInstOperands,
     /*  342795 */     // GIR_Coverage, 20517,
     /*  342795 */     GIR_EraseRootFromParent_Done,
     /*  342796 */   // Label 6259: @342796
     /*  342796 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(342862), // Rule ID 20520 //
     /*  342801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342860 */     GIR_RootConstrainSelectedInstOperands,
     /*  342861 */     // GIR_Coverage, 20520,
     /*  342861 */     GIR_EraseRootFromParent_Done,
     /*  342862 */   // Label 6260: @342862
     /*  342862 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(342928), // Rule ID 20521 //
     /*  342867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342906 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  342909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342926 */     GIR_RootConstrainSelectedInstOperands,
     /*  342927 */     // GIR_Coverage, 20521,
     /*  342927 */     GIR_EraseRootFromParent_Done,
     /*  342928 */   // Label 6261: @342928
     /*  342928 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(342994), // Rule ID 20524 //
     /*  342933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  342941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  342975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342992 */     GIR_RootConstrainSelectedInstOperands,
     /*  342993 */     // GIR_Coverage, 20524,
     /*  342993 */     GIR_EraseRootFromParent_Done,
     /*  342994 */   // Label 6262: @342994
     /*  342994 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(343060), // Rule ID 20525 //
     /*  342999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343058 */     GIR_RootConstrainSelectedInstOperands,
     /*  343059 */     // GIR_Coverage, 20525,
     /*  343059 */     GIR_EraseRootFromParent_Done,
     /*  343060 */   // Label 6263: @343060
     /*  343060 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(343126), // Rule ID 20528 //
     /*  343065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  343107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343124 */     GIR_RootConstrainSelectedInstOperands,
     /*  343125 */     // GIR_Coverage, 20528,
     /*  343125 */     GIR_EraseRootFromParent_Done,
     /*  343126 */   // Label 6264: @343126
     /*  343126 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(343192), // Rule ID 20529 //
     /*  343131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  343173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343190 */     GIR_RootConstrainSelectedInstOperands,
     /*  343191 */     // GIR_Coverage, 20529,
     /*  343191 */     GIR_EraseRootFromParent_Done,
     /*  343192 */   // Label 6265: @343192
     /*  343192 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(343258), // Rule ID 20532 //
     /*  343197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  343239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343256 */     GIR_RootConstrainSelectedInstOperands,
     /*  343257 */     // GIR_Coverage, 20532,
     /*  343257 */     GIR_EraseRootFromParent_Done,
     /*  343258 */   // Label 6266: @343258
     /*  343258 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(343324), // Rule ID 20533 //
     /*  343263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  343305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343322 */     GIR_RootConstrainSelectedInstOperands,
     /*  343323 */     // GIR_Coverage, 20533,
     /*  343323 */     GIR_EraseRootFromParent_Done,
     /*  343324 */   // Label 6267: @343324
     /*  343324 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(343390), // Rule ID 20536 //
     /*  343329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343388 */     GIR_RootConstrainSelectedInstOperands,
     /*  343389 */     // GIR_Coverage, 20536,
     /*  343389 */     GIR_EraseRootFromParent_Done,
     /*  343390 */   // Label 6268: @343390
     /*  343390 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(343456), // Rule ID 20537 //
     /*  343395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  343403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  343437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343454 */     GIR_RootConstrainSelectedInstOperands,
     /*  343455 */     // GIR_Coverage, 20537,
     /*  343455 */     GIR_EraseRootFromParent_Done,
     /*  343456 */   // Label 6269: @343456
     /*  343456 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(343522), // Rule ID 20862 //
     /*  343461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  343503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343520 */     GIR_RootConstrainSelectedInstOperands,
     /*  343521 */     // GIR_Coverage, 20862,
     /*  343521 */     GIR_EraseRootFromParent_Done,
     /*  343522 */   // Label 6270: @343522
     /*  343522 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(343588), // Rule ID 20863 //
     /*  343527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  343538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  343541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  343569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343586 */     GIR_RootConstrainSelectedInstOperands,
     /*  343587 */     // GIR_Coverage, 20863,
     /*  343587 */     GIR_EraseRootFromParent_Done,
     /*  343588 */   // Label 6271: @343588
     /*  343588 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(343654), // Rule ID 20866 //
     /*  343593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  343604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  343607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343652 */     GIR_RootConstrainSelectedInstOperands,
     /*  343653 */     // GIR_Coverage, 20866,
     /*  343653 */     GIR_EraseRootFromParent_Done,
     /*  343654 */   // Label 6272: @343654
     /*  343654 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(343720), // Rule ID 20867 //
     /*  343659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  343670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  343673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343718 */     GIR_RootConstrainSelectedInstOperands,
     /*  343719 */     // GIR_Coverage, 20867,
     /*  343719 */     GIR_EraseRootFromParent_Done,
     /*  343720 */   // Label 6273: @343720
     /*  343720 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(343786), // Rule ID 20870 //
     /*  343725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343764 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343784 */     GIR_RootConstrainSelectedInstOperands,
     /*  343785 */     // GIR_Coverage, 20870,
     /*  343785 */     GIR_EraseRootFromParent_Done,
     /*  343786 */   // Label 6274: @343786
     /*  343786 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(343852), // Rule ID 20871 //
     /*  343791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  343833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343850 */     GIR_RootConstrainSelectedInstOperands,
     /*  343851 */     // GIR_Coverage, 20871,
     /*  343851 */     GIR_EraseRootFromParent_Done,
     /*  343852 */   // Label 6275: @343852
     /*  343852 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(343918), // Rule ID 20874 //
     /*  343857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  343868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  343871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  343899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343916 */     GIR_RootConstrainSelectedInstOperands,
     /*  343917 */     // GIR_Coverage, 20874,
     /*  343917 */     GIR_EraseRootFromParent_Done,
     /*  343918 */   // Label 6276: @343918
     /*  343918 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(343984), // Rule ID 20875 //
     /*  343923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  343934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  343937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  343965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343982 */     GIR_RootConstrainSelectedInstOperands,
     /*  343983 */     // GIR_Coverage, 20875,
     /*  343983 */     GIR_EraseRootFromParent_Done,
     /*  343984 */   // Label 6277: @343984
     /*  343984 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(344050), // Rule ID 20878 //
     /*  343989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  343997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344048 */     GIR_RootConstrainSelectedInstOperands,
     /*  344049 */     // GIR_Coverage, 20878,
     /*  344049 */     GIR_EraseRootFromParent_Done,
     /*  344050 */   // Label 6278: @344050
     /*  344050 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(344116), // Rule ID 20879 //
     /*  344055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344094 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344114 */     GIR_RootConstrainSelectedInstOperands,
     /*  344115 */     // GIR_Coverage, 20879,
     /*  344115 */     GIR_EraseRootFromParent_Done,
     /*  344116 */   // Label 6279: @344116
     /*  344116 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(344182), // Rule ID 20882 //
     /*  344121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  344124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  344160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344180 */     GIR_RootConstrainSelectedInstOperands,
     /*  344181 */     // GIR_Coverage, 20882,
     /*  344181 */     GIR_EraseRootFromParent_Done,
     /*  344182 */   // Label 6280: @344182
     /*  344182 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(344248), // Rule ID 20883 //
     /*  344187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  344190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  344204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  344226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  344229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  344243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344246 */     GIR_RootConstrainSelectedInstOperands,
     /*  344247 */     // GIR_Coverage, 20883,
     /*  344247 */     GIR_EraseRootFromParent_Done,
     /*  344248 */   // Label 6281: @344248
     /*  344248 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(344314), // Rule ID 20886 //
     /*  344253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  344264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  344267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344312 */     GIR_RootConstrainSelectedInstOperands,
     /*  344313 */     // GIR_Coverage, 20886,
     /*  344313 */     GIR_EraseRootFromParent_Done,
     /*  344314 */   // Label 6282: @344314
     /*  344314 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(344380), // Rule ID 20887 //
     /*  344319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  344330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  344333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344378 */     GIR_RootConstrainSelectedInstOperands,
     /*  344379 */     // GIR_Coverage, 20887,
     /*  344379 */     GIR_EraseRootFromParent_Done,
     /*  344380 */   // Label 6283: @344380
     /*  344380 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(344446), // Rule ID 20890 //
     /*  344385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  344396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  344399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344444 */     GIR_RootConstrainSelectedInstOperands,
     /*  344445 */     // GIR_Coverage, 20890,
     /*  344445 */     GIR_EraseRootFromParent_Done,
     /*  344446 */   // Label 6284: @344446
     /*  344446 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(344512), // Rule ID 20891 //
     /*  344451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  344462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  344465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344510 */     GIR_RootConstrainSelectedInstOperands,
     /*  344511 */     // GIR_Coverage, 20891,
     /*  344511 */     GIR_EraseRootFromParent_Done,
     /*  344512 */   // Label 6285: @344512
     /*  344512 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(344578), // Rule ID 20894 //
     /*  344517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  344528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  344531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  344534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344576 */     GIR_RootConstrainSelectedInstOperands,
     /*  344577 */     // GIR_Coverage, 20894,
     /*  344577 */     GIR_EraseRootFromParent_Done,
     /*  344578 */   // Label 6286: @344578
     /*  344578 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(344644), // Rule ID 20895 //
     /*  344583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  344594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  344597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  344600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344642 */     GIR_RootConstrainSelectedInstOperands,
     /*  344643 */     // GIR_Coverage, 20895,
     /*  344643 */     GIR_EraseRootFromParent_Done,
     /*  344644 */   // Label 6287: @344644
     /*  344644 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(344710), // Rule ID 20898 //
     /*  344649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344708 */     GIR_RootConstrainSelectedInstOperands,
     /*  344709 */     // GIR_Coverage, 20898,
     /*  344709 */     GIR_EraseRootFromParent_Done,
     /*  344710 */   // Label 6288: @344710
     /*  344710 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(344776), // Rule ID 20899 //
     /*  344715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  344757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344774 */     GIR_RootConstrainSelectedInstOperands,
     /*  344775 */     // GIR_Coverage, 20899,
     /*  344775 */     GIR_EraseRootFromParent_Done,
     /*  344776 */   // Label 6289: @344776
     /*  344776 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(344842), // Rule ID 20902 //
     /*  344781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344840 */     GIR_RootConstrainSelectedInstOperands,
     /*  344841 */     // GIR_Coverage, 20902,
     /*  344841 */     GIR_EraseRootFromParent_Done,
     /*  344842 */   // Label 6290: @344842
     /*  344842 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(344908), // Rule ID 20903 //
     /*  344847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  344889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344906 */     GIR_RootConstrainSelectedInstOperands,
     /*  344907 */     // GIR_Coverage, 20903,
     /*  344907 */     GIR_EraseRootFromParent_Done,
     /*  344908 */   // Label 6291: @344908
     /*  344908 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(344974), // Rule ID 20906 //
     /*  344913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  344916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  344930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  344955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344972 */     GIR_RootConstrainSelectedInstOperands,
     /*  344973 */     // GIR_Coverage, 20906,
     /*  344973 */     GIR_EraseRootFromParent_Done,
     /*  344974 */   // Label 6292: @344974
     /*  344974 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(345040), // Rule ID 20907 //
     /*  344979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  344982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  344987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  344996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345038 */     GIR_RootConstrainSelectedInstOperands,
     /*  345039 */     // GIR_Coverage, 20907,
     /*  345039 */     GIR_EraseRootFromParent_Done,
     /*  345040 */   // Label 6293: @345040
     /*  345040 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(345106), // Rule ID 20910 //
     /*  345045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  345062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345084 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  345087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345104 */     GIR_RootConstrainSelectedInstOperands,
     /*  345105 */     // GIR_Coverage, 20910,
     /*  345105 */     GIR_EraseRootFromParent_Done,
     /*  345106 */   // Label 6294: @345106
     /*  345106 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(345172), // Rule ID 20911 //
     /*  345111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  345128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  345153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345170 */     GIR_RootConstrainSelectedInstOperands,
     /*  345171 */     // GIR_Coverage, 20911,
     /*  345171 */     GIR_EraseRootFromParent_Done,
     /*  345172 */   // Label 6295: @345172
     /*  345172 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(345238), // Rule ID 20914 //
     /*  345177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  345194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  345219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345236 */     GIR_RootConstrainSelectedInstOperands,
     /*  345237 */     // GIR_Coverage, 20914,
     /*  345237 */     GIR_EraseRootFromParent_Done,
     /*  345238 */   // Label 6296: @345238
     /*  345238 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(345304), // Rule ID 20915 //
     /*  345243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  345260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  345285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345302 */     GIR_RootConstrainSelectedInstOperands,
     /*  345303 */     // GIR_Coverage, 20915,
     /*  345303 */     GIR_EraseRootFromParent_Done,
     /*  345304 */   // Label 6297: @345304
     /*  345304 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(345370), // Rule ID 20918 //
     /*  345309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  345312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  345326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  345348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345368 */     GIR_RootConstrainSelectedInstOperands,
     /*  345369 */     // GIR_Coverage, 20918,
     /*  345369 */     GIR_EraseRootFromParent_Done,
     /*  345370 */   // Label 6298: @345370
     /*  345370 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(345436), // Rule ID 20919 //
     /*  345375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  345378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  345383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  345392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  345414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  345417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  345431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345434 */     GIR_RootConstrainSelectedInstOperands,
     /*  345435 */     // GIR_Coverage, 20919,
     /*  345435 */     GIR_EraseRootFromParent_Done,
     /*  345436 */   // Label 6299: @345436
     /*  345436 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(345502), // Rule ID 20922 //
     /*  345441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  345483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345500 */     GIR_RootConstrainSelectedInstOperands,
     /*  345501 */     // GIR_Coverage, 20922,
     /*  345501 */     GIR_EraseRootFromParent_Done,
     /*  345502 */   // Label 6300: @345502
     /*  345502 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(345568), // Rule ID 20923 //
     /*  345507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  345524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  345549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345566 */     GIR_RootConstrainSelectedInstOperands,
     /*  345567 */     // GIR_Coverage, 20923,
     /*  345567 */     GIR_EraseRootFromParent_Done,
     /*  345568 */   // Label 6301: @345568
     /*  345568 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(345634), // Rule ID 20926 //
     /*  345573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345632 */     GIR_RootConstrainSelectedInstOperands,
     /*  345633 */     // GIR_Coverage, 20926,
     /*  345633 */     GIR_EraseRootFromParent_Done,
     /*  345634 */   // Label 6302: @345634
     /*  345634 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(345700), // Rule ID 20927 //
     /*  345639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  345656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345698 */     GIR_RootConstrainSelectedInstOperands,
     /*  345699 */     // GIR_Coverage, 20927,
     /*  345699 */     GIR_EraseRootFromParent_Done,
     /*  345700 */   // Label 6303: @345700
     /*  345700 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(345766), // Rule ID 20930 //
     /*  345705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  345708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345764 */     GIR_RootConstrainSelectedInstOperands,
     /*  345765 */     // GIR_Coverage, 20930,
     /*  345765 */     GIR_EraseRootFromParent_Done,
     /*  345766 */   // Label 6304: @345766
     /*  345766 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(345832), // Rule ID 20931 //
     /*  345771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  345774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  345782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  345785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  345813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345830 */     GIR_RootConstrainSelectedInstOperands,
     /*  345831 */     // GIR_Coverage, 20931,
     /*  345831 */     GIR_EraseRootFromParent_Done,
     /*  345832 */   // Label 6305: @345832
     /*  345832 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(345898), // Rule ID 20934 //
     /*  345837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  345879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345896 */     GIR_RootConstrainSelectedInstOperands,
     /*  345897 */     // GIR_Coverage, 20934,
     /*  345897 */     GIR_EraseRootFromParent_Done,
     /*  345898 */   // Label 6306: @345898
     /*  345898 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(345964), // Rule ID 20935 //
     /*  345903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  345945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345962 */     GIR_RootConstrainSelectedInstOperands,
     /*  345963 */     // GIR_Coverage, 20935,
     /*  345963 */     GIR_EraseRootFromParent_Done,
     /*  345964 */   // Label 6307: @345964
     /*  345964 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(346030), // Rule ID 20938 //
     /*  345969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  345972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  345977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  345980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  345983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346028 */     GIR_RootConstrainSelectedInstOperands,
     /*  346029 */     // GIR_Coverage, 20938,
     /*  346029 */     GIR_EraseRootFromParent_Done,
     /*  346030 */   // Label 6308: @346030
     /*  346030 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(346096), // Rule ID 20939 //
     /*  346035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  346052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346094 */     GIR_RootConstrainSelectedInstOperands,
     /*  346095 */     // GIR_Coverage, 20939,
     /*  346095 */     GIR_EraseRootFromParent_Done,
     /*  346096 */   // Label 6309: @346096
     /*  346096 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(346162), // Rule ID 20942 //
     /*  346101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  346104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  346118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  346140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346160 */     GIR_RootConstrainSelectedInstOperands,
     /*  346161 */     // GIR_Coverage, 20942,
     /*  346161 */     GIR_EraseRootFromParent_Done,
     /*  346162 */   // Label 6310: @346162
     /*  346162 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(346228), // Rule ID 20943 //
     /*  346167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  346170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  346184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  346206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  346209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  346223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346226 */     GIR_RootConstrainSelectedInstOperands,
     /*  346227 */     // GIR_Coverage, 20943,
     /*  346227 */     GIR_EraseRootFromParent_Done,
     /*  346228 */   // Label 6311: @346228
     /*  346228 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(346294), // Rule ID 20946 //
     /*  346233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346292 */     GIR_RootConstrainSelectedInstOperands,
     /*  346293 */     // GIR_Coverage, 20946,
     /*  346293 */     GIR_EraseRootFromParent_Done,
     /*  346294 */   // Label 6312: @346294
     /*  346294 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(346360), // Rule ID 20947 //
     /*  346299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346358 */     GIR_RootConstrainSelectedInstOperands,
     /*  346359 */     // GIR_Coverage, 20947,
     /*  346359 */     GIR_EraseRootFromParent_Done,
     /*  346360 */   // Label 6313: @346360
     /*  346360 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(346426), // Rule ID 20950 //
     /*  346365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346424 */     GIR_RootConstrainSelectedInstOperands,
     /*  346425 */     // GIR_Coverage, 20950,
     /*  346425 */     GIR_EraseRootFromParent_Done,
     /*  346426 */   // Label 6314: @346426
     /*  346426 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(346492), // Rule ID 20951 //
     /*  346431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346490 */     GIR_RootConstrainSelectedInstOperands,
     /*  346491 */     // GIR_Coverage, 20951,
     /*  346491 */     GIR_EraseRootFromParent_Done,
     /*  346492 */   // Label 6315: @346492
     /*  346492 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(346558), // Rule ID 20954 //
     /*  346497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  346514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346556 */     GIR_RootConstrainSelectedInstOperands,
     /*  346557 */     // GIR_Coverage, 20954,
     /*  346557 */     GIR_EraseRootFromParent_Done,
     /*  346558 */   // Label 6316: @346558
     /*  346558 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(346624), // Rule ID 20955 //
     /*  346563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  346580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346622 */     GIR_RootConstrainSelectedInstOperands,
     /*  346623 */     // GIR_Coverage, 20955,
     /*  346623 */     GIR_EraseRootFromParent_Done,
     /*  346624 */   // Label 6317: @346624
     /*  346624 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(346690), // Rule ID 20958 //
     /*  346629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346688 */     GIR_RootConstrainSelectedInstOperands,
     /*  346689 */     // GIR_Coverage, 20958,
     /*  346689 */     GIR_EraseRootFromParent_Done,
     /*  346690 */   // Label 6318: @346690
     /*  346690 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(346756), // Rule ID 20959 //
     /*  346695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  346712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  346737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346754 */     GIR_RootConstrainSelectedInstOperands,
     /*  346755 */     // GIR_Coverage, 20959,
     /*  346755 */     GIR_EraseRootFromParent_Done,
     /*  346756 */   // Label 6319: @346756
     /*  346756 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(346822), // Rule ID 20962 //
     /*  346761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346820 */     GIR_RootConstrainSelectedInstOperands,
     /*  346821 */     // GIR_Coverage, 20962,
     /*  346821 */     GIR_EraseRootFromParent_Done,
     /*  346822 */   // Label 6320: @346822
     /*  346822 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(346888), // Rule ID 20963 //
     /*  346827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  346844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  346869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346886 */     GIR_RootConstrainSelectedInstOperands,
     /*  346887 */     // GIR_Coverage, 20963,
     /*  346887 */     GIR_EraseRootFromParent_Done,
     /*  346888 */   // Label 6321: @346888
     /*  346888 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(346954), // Rule ID 20966 //
     /*  346893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  346935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346952 */     GIR_RootConstrainSelectedInstOperands,
     /*  346953 */     // GIR_Coverage, 20966,
     /*  346953 */     GIR_EraseRootFromParent_Done,
     /*  346954 */   // Label 6322: @346954
     /*  346954 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(347020), // Rule ID 20967 //
     /*  346959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  346967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  346976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  346998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347018 */     GIR_RootConstrainSelectedInstOperands,
     /*  347019 */     // GIR_Coverage, 20967,
     /*  347019 */     GIR_EraseRootFromParent_Done,
     /*  347020 */   // Label 6323: @347020
     /*  347020 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(347086), // Rule ID 20970 //
     /*  347025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  347042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  347067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347084 */     GIR_RootConstrainSelectedInstOperands,
     /*  347085 */     // GIR_Coverage, 20970,
     /*  347085 */     GIR_EraseRootFromParent_Done,
     /*  347086 */   // Label 6324: @347086
     /*  347086 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(347152), // Rule ID 20971 //
     /*  347091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  347108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  347133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347150 */     GIR_RootConstrainSelectedInstOperands,
     /*  347151 */     // GIR_Coverage, 20971,
     /*  347151 */     GIR_EraseRootFromParent_Done,
     /*  347152 */   // Label 6325: @347152
     /*  347152 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(347218), // Rule ID 20974 //
     /*  347157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  347174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  347199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347216 */     GIR_RootConstrainSelectedInstOperands,
     /*  347217 */     // GIR_Coverage, 20974,
     /*  347217 */     GIR_EraseRootFromParent_Done,
     /*  347218 */   // Label 6326: @347218
     /*  347218 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(347284), // Rule ID 20975 //
     /*  347223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  347240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  347265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347282 */     GIR_RootConstrainSelectedInstOperands,
     /*  347283 */     // GIR_Coverage, 20975,
     /*  347283 */     GIR_EraseRootFromParent_Done,
     /*  347284 */   // Label 6327: @347284
     /*  347284 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(347350), // Rule ID 20978 //
     /*  347289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  347292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  347306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  347328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347348 */     GIR_RootConstrainSelectedInstOperands,
     /*  347349 */     // GIR_Coverage, 20978,
     /*  347349 */     GIR_EraseRootFromParent_Done,
     /*  347350 */   // Label 6328: @347350
     /*  347350 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(347416), // Rule ID 20979 //
     /*  347355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  347358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  347363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  347372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  347394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  347397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  347411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347414 */     GIR_RootConstrainSelectedInstOperands,
     /*  347415 */     // GIR_Coverage, 20979,
     /*  347415 */     GIR_EraseRootFromParent_Done,
     /*  347416 */   // Label 6329: @347416
     /*  347416 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(347482), // Rule ID 21246 //
     /*  347421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  347463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347480 */     GIR_RootConstrainSelectedInstOperands,
     /*  347481 */     // GIR_Coverage, 21246,
     /*  347481 */     GIR_EraseRootFromParent_Done,
     /*  347482 */   // Label 6330: @347482
     /*  347482 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(347548), // Rule ID 21247 //
     /*  347487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  347498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  347501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  347504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  347529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347546 */     GIR_RootConstrainSelectedInstOperands,
     /*  347547 */     // GIR_Coverage, 21247,
     /*  347547 */     GIR_EraseRootFromParent_Done,
     /*  347548 */   // Label 6331: @347548
     /*  347548 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(347614), // Rule ID 21250 //
     /*  347553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  347595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347612 */     GIR_RootConstrainSelectedInstOperands,
     /*  347613 */     // GIR_Coverage, 21250,
     /*  347613 */     GIR_EraseRootFromParent_Done,
     /*  347614 */   // Label 6332: @347614
     /*  347614 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(347680), // Rule ID 21251 //
     /*  347619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  347630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  347633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  347636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  347661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347678 */     GIR_RootConstrainSelectedInstOperands,
     /*  347679 */     // GIR_Coverage, 21251,
     /*  347679 */     GIR_EraseRootFromParent_Done,
     /*  347680 */   // Label 6333: @347680
     /*  347680 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(347746), // Rule ID 21254 //
     /*  347685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  347727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347744 */     GIR_RootConstrainSelectedInstOperands,
     /*  347745 */     // GIR_Coverage, 21254,
     /*  347745 */     GIR_EraseRootFromParent_Done,
     /*  347746 */   // Label 6334: @347746
     /*  347746 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(347812), // Rule ID 21255 //
     /*  347751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  347793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347810 */     GIR_RootConstrainSelectedInstOperands,
     /*  347811 */     // GIR_Coverage, 21255,
     /*  347811 */     GIR_EraseRootFromParent_Done,
     /*  347812 */   // Label 6335: @347812
     /*  347812 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(347878), // Rule ID 21258 //
     /*  347817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  347859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347876 */     GIR_RootConstrainSelectedInstOperands,
     /*  347877 */     // GIR_Coverage, 21258,
     /*  347877 */     GIR_EraseRootFromParent_Done,
     /*  347878 */   // Label 6336: @347878
     /*  347878 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(347944), // Rule ID 21259 //
     /*  347883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  347925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347942 */     GIR_RootConstrainSelectedInstOperands,
     /*  347943 */     // GIR_Coverage, 21259,
     /*  347943 */     GIR_EraseRootFromParent_Done,
     /*  347944 */   // Label 6337: @347944
     /*  347944 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(348010), // Rule ID 21262 //
     /*  347949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  347957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  347991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348008 */     GIR_RootConstrainSelectedInstOperands,
     /*  348009 */     // GIR_Coverage, 21262,
     /*  348009 */     GIR_EraseRootFromParent_Done,
     /*  348010 */   // Label 6338: @348010
     /*  348010 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(348076), // Rule ID 21263 //
     /*  348015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  348026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  348029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  348032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348074 */     GIR_RootConstrainSelectedInstOperands,
     /*  348075 */     // GIR_Coverage, 21263,
     /*  348075 */     GIR_EraseRootFromParent_Done,
     /*  348076 */   // Label 6339: @348076
     /*  348076 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(348142), // Rule ID 21266 //
     /*  348081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  348123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348140 */     GIR_RootConstrainSelectedInstOperands,
     /*  348141 */     // GIR_Coverage, 21266,
     /*  348141 */     GIR_EraseRootFromParent_Done,
     /*  348142 */   // Label 6340: @348142
     /*  348142 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(348208), // Rule ID 21267 //
     /*  348147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  348189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348206 */     GIR_RootConstrainSelectedInstOperands,
     /*  348207 */     // GIR_Coverage, 21267,
     /*  348207 */     GIR_EraseRootFromParent_Done,
     /*  348208 */   // Label 6341: @348208
     /*  348208 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(348274), // Rule ID 21270 //
     /*  348213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  348255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348272 */     GIR_RootConstrainSelectedInstOperands,
     /*  348273 */     // GIR_Coverage, 21270,
     /*  348273 */     GIR_EraseRootFromParent_Done,
     /*  348274 */   // Label 6342: @348274
     /*  348274 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(348340), // Rule ID 21271 //
     /*  348279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  348290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  348293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  348296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  348321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348338 */     GIR_RootConstrainSelectedInstOperands,
     /*  348339 */     // GIR_Coverage, 21271,
     /*  348339 */     GIR_EraseRootFromParent_Done,
     /*  348340 */   // Label 6343: @348340
     /*  348340 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(348406), // Rule ID 21274 //
     /*  348345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  348387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348404 */     GIR_RootConstrainSelectedInstOperands,
     /*  348405 */     // GIR_Coverage, 21274,
     /*  348405 */     GIR_EraseRootFromParent_Done,
     /*  348406 */   // Label 6344: @348406
     /*  348406 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(348472), // Rule ID 21275 //
     /*  348411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  348422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  348425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  348428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  348453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348470 */     GIR_RootConstrainSelectedInstOperands,
     /*  348471 */     // GIR_Coverage, 21275,
     /*  348471 */     GIR_EraseRootFromParent_Done,
     /*  348472 */   // Label 6345: @348472
     /*  348472 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(348538), // Rule ID 21278 //
     /*  348477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  348480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348536 */     GIR_RootConstrainSelectedInstOperands,
     /*  348537 */     // GIR_Coverage, 21278,
     /*  348537 */     GIR_EraseRootFromParent_Done,
     /*  348538 */   // Label 6346: @348538
     /*  348538 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(348604), // Rule ID 21279 //
     /*  348543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  348546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  348551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  348554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  348557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  348560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  348585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348602 */     GIR_RootConstrainSelectedInstOperands,
     /*  348603 */     // GIR_Coverage, 21279,
     /*  348603 */     GIR_EraseRootFromParent_Done,
     /*  348604 */   // Label 6347: @348604
     /*  348604 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(348670), // Rule ID 21282 //
     /*  348609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  348651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348668 */     GIR_RootConstrainSelectedInstOperands,
     /*  348669 */     // GIR_Coverage, 21282,
     /*  348669 */     GIR_EraseRootFromParent_Done,
     /*  348670 */   // Label 6348: @348670
     /*  348670 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(348736), // Rule ID 21283 //
     /*  348675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  348717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348734 */     GIR_RootConstrainSelectedInstOperands,
     /*  348735 */     // GIR_Coverage, 21283,
     /*  348735 */     GIR_EraseRootFromParent_Done,
     /*  348736 */   // Label 6349: @348736
     /*  348736 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(348802), // Rule ID 21286 //
     /*  348741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  348783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348800 */     GIR_RootConstrainSelectedInstOperands,
     /*  348801 */     // GIR_Coverage, 21286,
     /*  348801 */     GIR_EraseRootFromParent_Done,
     /*  348802 */   // Label 6350: @348802
     /*  348802 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(348868), // Rule ID 21287 //
     /*  348807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  348849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348866 */     GIR_RootConstrainSelectedInstOperands,
     /*  348867 */     // GIR_Coverage, 21287,
     /*  348867 */     GIR_EraseRootFromParent_Done,
     /*  348868 */   // Label 6351: @348868
     /*  348868 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(348934), // Rule ID 21290 //
     /*  348873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  348915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348932 */     GIR_RootConstrainSelectedInstOperands,
     /*  348933 */     // GIR_Coverage, 21290,
     /*  348933 */     GIR_EraseRootFromParent_Done,
     /*  348934 */   // Label 6352: @348934
     /*  348934 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(349000), // Rule ID 21291 //
     /*  348939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  348947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  348981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348998 */     GIR_RootConstrainSelectedInstOperands,
     /*  348999 */     // GIR_Coverage, 21291,
     /*  348999 */     GIR_EraseRootFromParent_Done,
     /*  349000 */   // Label 6353: @349000
     /*  349000 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(349066), // Rule ID 21294 //
     /*  349005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349064 */     GIR_RootConstrainSelectedInstOperands,
     /*  349065 */     // GIR_Coverage, 21294,
     /*  349065 */     GIR_EraseRootFromParent_Done,
     /*  349066 */   // Label 6354: @349066
     /*  349066 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(349132), // Rule ID 21295 //
     /*  349071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349130 */     GIR_RootConstrainSelectedInstOperands,
     /*  349131 */     // GIR_Coverage, 21295,
     /*  349131 */     GIR_EraseRootFromParent_Done,
     /*  349132 */   // Label 6355: @349132
     /*  349132 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(349198), // Rule ID 21298 //
     /*  349137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349196 */     GIR_RootConstrainSelectedInstOperands,
     /*  349197 */     // GIR_Coverage, 21298,
     /*  349197 */     GIR_EraseRootFromParent_Done,
     /*  349198 */   // Label 6356: @349198
     /*  349198 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(349264), // Rule ID 21299 //
     /*  349203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349262 */     GIR_RootConstrainSelectedInstOperands,
     /*  349263 */     // GIR_Coverage, 21299,
     /*  349263 */     GIR_EraseRootFromParent_Done,
     /*  349264 */   // Label 6357: @349264
     /*  349264 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(349330), // Rule ID 21302 //
     /*  349269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  349311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349328 */     GIR_RootConstrainSelectedInstOperands,
     /*  349329 */     // GIR_Coverage, 21302,
     /*  349329 */     GIR_EraseRootFromParent_Done,
     /*  349330 */   // Label 6358: @349330
     /*  349330 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(349396), // Rule ID 21303 //
     /*  349335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  349377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349394 */     GIR_RootConstrainSelectedInstOperands,
     /*  349395 */     // GIR_Coverage, 21303,
     /*  349395 */     GIR_EraseRootFromParent_Done,
     /*  349396 */   // Label 6359: @349396
     /*  349396 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(349462), // Rule ID 21306 //
     /*  349401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  349443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349460 */     GIR_RootConstrainSelectedInstOperands,
     /*  349461 */     // GIR_Coverage, 21306,
     /*  349461 */     GIR_EraseRootFromParent_Done,
     /*  349462 */   // Label 6360: @349462
     /*  349462 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(349528), // Rule ID 21307 //
     /*  349467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  349509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349526 */     GIR_RootConstrainSelectedInstOperands,
     /*  349527 */     // GIR_Coverage, 21307,
     /*  349527 */     GIR_EraseRootFromParent_Done,
     /*  349528 */   // Label 6361: @349528
     /*  349528 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(349594), // Rule ID 21310 //
     /*  349533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349592 */     GIR_RootConstrainSelectedInstOperands,
     /*  349593 */     // GIR_Coverage, 21310,
     /*  349593 */     GIR_EraseRootFromParent_Done,
     /*  349594 */   // Label 6362: @349594
     /*  349594 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(349660), // Rule ID 21311 //
     /*  349599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  349641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349658 */     GIR_RootConstrainSelectedInstOperands,
     /*  349659 */     // GIR_Coverage, 21311,
     /*  349659 */     GIR_EraseRootFromParent_Done,
     /*  349660 */   // Label 6363: @349660
     /*  349660 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(349726), // Rule ID 21314 //
     /*  349665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  349668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349724 */     GIR_RootConstrainSelectedInstOperands,
     /*  349725 */     // GIR_Coverage, 21314,
     /*  349725 */     GIR_EraseRootFromParent_Done,
     /*  349726 */   // Label 6364: @349726
     /*  349726 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(349792), // Rule ID 21315 //
     /*  349731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  349734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  349739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11228:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  349773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349790 */     GIR_RootConstrainSelectedInstOperands,
     /*  349791 */     // GIR_Coverage, 21315,
     /*  349791 */     GIR_EraseRootFromParent_Done,
     /*  349792 */   // Label 6365: @349792
     /*  349792 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(349858), // Rule ID 21318 //
     /*  349797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  349808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  349811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  349814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  349839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349856 */     GIR_RootConstrainSelectedInstOperands,
     /*  349857 */     // GIR_Coverage, 21318,
     /*  349857 */     GIR_EraseRootFromParent_Done,
     /*  349858 */   // Label 6366: @349858
     /*  349858 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(349924), // Rule ID 21319 //
     /*  349863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  349874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  349877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  349880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  349902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  349905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349922 */     GIR_RootConstrainSelectedInstOperands,
     /*  349923 */     // GIR_Coverage, 21319,
     /*  349923 */     GIR_EraseRootFromParent_Done,
     /*  349924 */   // Label 6367: @349924
     /*  349924 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(349990), // Rule ID 21322 //
     /*  349929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  349932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  349937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  349940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  349943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  349946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349968 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  349968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  349971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  349985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349988 */     GIR_RootConstrainSelectedInstOperands,
     /*  349989 */     // GIR_Coverage, 21322,
     /*  349989 */     GIR_EraseRootFromParent_Done,
     /*  349990 */   // Label 6368: @349990
     /*  349990 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(350056), // Rule ID 21323 //
     /*  349995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  349998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  350006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  350009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  350012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350034 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  350037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350054 */     GIR_RootConstrainSelectedInstOperands,
     /*  350055 */     // GIR_Coverage, 21323,
     /*  350055 */     GIR_EraseRootFromParent_Done,
     /*  350056 */   // Label 6369: @350056
     /*  350056 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(350122), // Rule ID 21326 //
     /*  350061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  350072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  350075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  350078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350100 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  350103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350120 */     GIR_RootConstrainSelectedInstOperands,
     /*  350121 */     // GIR_Coverage, 21326,
     /*  350121 */     GIR_EraseRootFromParent_Done,
     /*  350122 */   // Label 6370: @350122
     /*  350122 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(350188), // Rule ID 21327 //
     /*  350127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  350138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  350141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  350144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350166 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  350169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350186 */     GIR_RootConstrainSelectedInstOperands,
     /*  350187 */     // GIR_Coverage, 21327,
     /*  350187 */     GIR_EraseRootFromParent_Done,
     /*  350188 */   // Label 6371: @350188
     /*  350188 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(350254), // Rule ID 21330 //
     /*  350193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  350204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  350207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  350210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  350235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350252 */     GIR_RootConstrainSelectedInstOperands,
     /*  350253 */     // GIR_Coverage, 21330,
     /*  350253 */     GIR_EraseRootFromParent_Done,
     /*  350254 */   // Label 6372: @350254
     /*  350254 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(350320), // Rule ID 21331 //
     /*  350259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  350270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  350273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  350276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350298 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  350301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350318 */     GIR_RootConstrainSelectedInstOperands,
     /*  350319 */     // GIR_Coverage, 21331,
     /*  350319 */     GIR_EraseRootFromParent_Done,
     /*  350320 */   // Label 6373: @350320
     /*  350320 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(350386), // Rule ID 21334 //
     /*  350325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  350336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  350339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  350342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  350367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350384 */     GIR_RootConstrainSelectedInstOperands,
     /*  350385 */     // GIR_Coverage, 21334,
     /*  350385 */     GIR_EraseRootFromParent_Done,
     /*  350386 */   // Label 6374: @350386
     /*  350386 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(350452), // Rule ID 21335 //
     /*  350391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  350402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  350405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  350408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350430 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  350433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350450 */     GIR_RootConstrainSelectedInstOperands,
     /*  350451 */     // GIR_Coverage, 21335,
     /*  350451 */     GIR_EraseRootFromParent_Done,
     /*  350452 */   // Label 6375: @350452
     /*  350452 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(350518), // Rule ID 21338 //
     /*  350457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  350468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  350471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  350474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350496 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  350499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350516 */     GIR_RootConstrainSelectedInstOperands,
     /*  350517 */     // GIR_Coverage, 21338,
     /*  350517 */     GIR_EraseRootFromParent_Done,
     /*  350518 */   // Label 6376: @350518
     /*  350518 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(350584), // Rule ID 21339 //
     /*  350523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  350534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  350537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  350540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350562 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  350565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350582 */     GIR_RootConstrainSelectedInstOperands,
     /*  350583 */     // GIR_Coverage, 21339,
     /*  350583 */     GIR_EraseRootFromParent_Done,
     /*  350584 */   // Label 6377: @350584
     /*  350584 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(350650), // Rule ID 21342 //
     /*  350589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350628 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  350631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350648 */     GIR_RootConstrainSelectedInstOperands,
     /*  350649 */     // GIR_Coverage, 21342,
     /*  350649 */     GIR_EraseRootFromParent_Done,
     /*  350650 */   // Label 6378: @350650
     /*  350650 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(350716), // Rule ID 21343 //
     /*  350655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  350666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  350669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350694 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  350697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350714 */     GIR_RootConstrainSelectedInstOperands,
     /*  350715 */     // GIR_Coverage, 21343,
     /*  350715 */     GIR_EraseRootFromParent_Done,
     /*  350716 */   // Label 6379: @350716
     /*  350716 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(350782), // Rule ID 21346 //
     /*  350721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  350763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350780 */     GIR_RootConstrainSelectedInstOperands,
     /*  350781 */     // GIR_Coverage, 21346,
     /*  350781 */     GIR_EraseRootFromParent_Done,
     /*  350782 */   // Label 6380: @350782
     /*  350782 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(350848), // Rule ID 21347 //
     /*  350787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350826 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  350829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350846 */     GIR_RootConstrainSelectedInstOperands,
     /*  350847 */     // GIR_Coverage, 21347,
     /*  350847 */     GIR_EraseRootFromParent_Done,
     /*  350848 */   // Label 6381: @350848
     /*  350848 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(350914), // Rule ID 21350 //
     /*  350853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350892 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  350895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350912 */     GIR_RootConstrainSelectedInstOperands,
     /*  350913 */     // GIR_Coverage, 21350,
     /*  350913 */     GIR_EraseRootFromParent_Done,
     /*  350914 */   // Label 6382: @350914
     /*  350914 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(350980), // Rule ID 21351 //
     /*  350919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  350922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350958 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  350961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350978 */     GIR_RootConstrainSelectedInstOperands,
     /*  350979 */     // GIR_Coverage, 21351,
     /*  350979 */     GIR_EraseRootFromParent_Done,
     /*  350980 */   // Label 6383: @350980
     /*  350980 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(351046), // Rule ID 21354 //
     /*  350985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  350988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  350993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  351027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351044 */     GIR_RootConstrainSelectedInstOperands,
     /*  351045 */     // GIR_Coverage, 21354,
     /*  351045 */     GIR_EraseRootFromParent_Done,
     /*  351046 */   // Label 6384: @351046
     /*  351046 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(351112), // Rule ID 21355 //
     /*  351051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  351062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  351065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  351093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351110 */     GIR_RootConstrainSelectedInstOperands,
     /*  351111 */     // GIR_Coverage, 21355,
     /*  351111 */     GIR_EraseRootFromParent_Done,
     /*  351112 */   // Label 6385: @351112
     /*  351112 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(351178), // Rule ID 21358 //
     /*  351117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  351128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  351131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351156 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  351159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351176 */     GIR_RootConstrainSelectedInstOperands,
     /*  351177 */     // GIR_Coverage, 21358,
     /*  351177 */     GIR_EraseRootFromParent_Done,
     /*  351178 */   // Label 6386: @351178
     /*  351178 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(351244), // Rule ID 21359 //
     /*  351183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  351194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  351197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  351225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351242 */     GIR_RootConstrainSelectedInstOperands,
     /*  351243 */     // GIR_Coverage, 21359,
     /*  351243 */     GIR_EraseRootFromParent_Done,
     /*  351244 */   // Label 6387: @351244
     /*  351244 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(351310), // Rule ID 21362 //
     /*  351249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  351291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351308 */     GIR_RootConstrainSelectedInstOperands,
     /*  351309 */     // GIR_Coverage, 21362,
     /*  351309 */     GIR_EraseRootFromParent_Done,
     /*  351310 */   // Label 6388: @351310
     /*  351310 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(351376), // Rule ID 21363 //
     /*  351315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  351326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  351329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  351357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351374 */     GIR_RootConstrainSelectedInstOperands,
     /*  351375 */     // GIR_Coverage, 21363,
     /*  351375 */     GIR_EraseRootFromParent_Done,
     /*  351376 */   // Label 6389: @351376
     /*  351376 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(351442), // Rule ID 21366 //
     /*  351381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351420 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  351423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351440 */     GIR_RootConstrainSelectedInstOperands,
     /*  351441 */     // GIR_Coverage, 21366,
     /*  351441 */     GIR_EraseRootFromParent_Done,
     /*  351442 */   // Label 6390: @351442
     /*  351442 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(351508), // Rule ID 21367 //
     /*  351447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  351458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  351461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  351489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351506 */     GIR_RootConstrainSelectedInstOperands,
     /*  351507 */     // GIR_Coverage, 21367,
     /*  351507 */     GIR_EraseRootFromParent_Done,
     /*  351508 */   // Label 6391: @351508
     /*  351508 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(351574), // Rule ID 21370 //
     /*  351513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  351555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351572 */     GIR_RootConstrainSelectedInstOperands,
     /*  351573 */     // GIR_Coverage, 21370,
     /*  351573 */     GIR_EraseRootFromParent_Done,
     /*  351574 */   // Label 6392: @351574
     /*  351574 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(351640), // Rule ID 21371 //
     /*  351579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  351590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  351593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  351621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351638 */     GIR_RootConstrainSelectedInstOperands,
     /*  351639 */     // GIR_Coverage, 21371,
     /*  351639 */     GIR_EraseRootFromParent_Done,
     /*  351640 */   // Label 6393: @351640
     /*  351640 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(351706), // Rule ID 21374 //
     /*  351645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  351648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  351687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351704 */     GIR_RootConstrainSelectedInstOperands,
     /*  351705 */     // GIR_Coverage, 21374,
     /*  351705 */     GIR_EraseRootFromParent_Done,
     /*  351706 */   // Label 6394: @351706
     /*  351706 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(351772), // Rule ID 21375 //
     /*  351711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  351714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  351719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  351753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351770 */     GIR_RootConstrainSelectedInstOperands,
     /*  351771 */     // GIR_Coverage, 21375,
     /*  351771 */     GIR_EraseRootFromParent_Done,
     /*  351772 */   // Label 6395: @351772
     /*  351772 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(351838), // Rule ID 21378 //
     /*  351777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  351794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  351819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351836 */     GIR_RootConstrainSelectedInstOperands,
     /*  351837 */     // GIR_Coverage, 21378,
     /*  351837 */     GIR_EraseRootFromParent_Done,
     /*  351838 */   // Label 6396: @351838
     /*  351838 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(351904), // Rule ID 21379 //
     /*  351843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  351860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  351885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351902 */     GIR_RootConstrainSelectedInstOperands,
     /*  351903 */     // GIR_Coverage, 21379,
     /*  351903 */     GIR_EraseRootFromParent_Done,
     /*  351904 */   // Label 6397: @351904
     /*  351904 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(351970), // Rule ID 21382 //
     /*  351909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351948 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  351951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351968 */     GIR_RootConstrainSelectedInstOperands,
     /*  351969 */     // GIR_Coverage, 21382,
     /*  351969 */     GIR_EraseRootFromParent_Done,
     /*  351970 */   // Label 6398: @351970
     /*  351970 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(352036), // Rule ID 21383 //
     /*  351975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  351983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  351992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  352017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352034 */     GIR_RootConstrainSelectedInstOperands,
     /*  352035 */     // GIR_Coverage, 21383,
     /*  352035 */     GIR_EraseRootFromParent_Done,
     /*  352036 */   // Label 6399: @352036
     /*  352036 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(352102), // Rule ID 21386 //
     /*  352041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  352058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  352083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352100 */     GIR_RootConstrainSelectedInstOperands,
     /*  352101 */     // GIR_Coverage, 21386,
     /*  352101 */     GIR_EraseRootFromParent_Done,
     /*  352102 */   // Label 6400: @352102
     /*  352102 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(352168), // Rule ID 21387 //
     /*  352107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  352124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352146 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  352149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352166 */     GIR_RootConstrainSelectedInstOperands,
     /*  352167 */     // GIR_Coverage, 21387,
     /*  352167 */     GIR_EraseRootFromParent_Done,
     /*  352168 */   // Label 6401: @352168
     /*  352168 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(352234), // Rule ID 21390 //
     /*  352173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  352190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  352215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352232 */     GIR_RootConstrainSelectedInstOperands,
     /*  352233 */     // GIR_Coverage, 21390,
     /*  352233 */     GIR_EraseRootFromParent_Done,
     /*  352234 */   // Label 6402: @352234
     /*  352234 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(352300), // Rule ID 21391 //
     /*  352239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  352256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  352281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352298 */     GIR_RootConstrainSelectedInstOperands,
     /*  352299 */     // GIR_Coverage, 21391,
     /*  352299 */     GIR_EraseRootFromParent_Done,
     /*  352300 */   // Label 6403: @352300
     /*  352300 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(352366), // Rule ID 21394 //
     /*  352305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352344 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  352347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352364 */     GIR_RootConstrainSelectedInstOperands,
     /*  352365 */     // GIR_Coverage, 21394,
     /*  352365 */     GIR_EraseRootFromParent_Done,
     /*  352366 */   // Label 6404: @352366
     /*  352366 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(352432), // Rule ID 21395 //
     /*  352371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  352388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352410 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  352413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352430 */     GIR_RootConstrainSelectedInstOperands,
     /*  352431 */     // GIR_Coverage, 21395,
     /*  352431 */     GIR_EraseRootFromParent_Done,
     /*  352432 */   // Label 6405: @352432
     /*  352432 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(352498), // Rule ID 21398 //
     /*  352437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  352448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  352451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  352479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352496 */     GIR_RootConstrainSelectedInstOperands,
     /*  352497 */     // GIR_Coverage, 21398,
     /*  352497 */     GIR_EraseRootFromParent_Done,
     /*  352498 */   // Label 6406: @352498
     /*  352498 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(352564), // Rule ID 21399 //
     /*  352503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  352514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  352517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  352520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352542 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  352545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352562 */     GIR_RootConstrainSelectedInstOperands,
     /*  352563 */     // GIR_Coverage, 21399,
     /*  352563 */     GIR_EraseRootFromParent_Done,
     /*  352564 */   // Label 6407: @352564
     /*  352564 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(352630), // Rule ID 21402 //
     /*  352569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  352611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352628 */     GIR_RootConstrainSelectedInstOperands,
     /*  352629 */     // GIR_Coverage, 21402,
     /*  352629 */     GIR_EraseRootFromParent_Done,
     /*  352630 */   // Label 6408: @352630
     /*  352630 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(352696), // Rule ID 21403 //
     /*  352635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352674 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  352677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352694 */     GIR_RootConstrainSelectedInstOperands,
     /*  352695 */     // GIR_Coverage, 21403,
     /*  352695 */     GIR_EraseRootFromParent_Done,
     /*  352696 */   // Label 6409: @352696
     /*  352696 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(352762), // Rule ID 21406 //
     /*  352701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352740 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  352743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352760 */     GIR_RootConstrainSelectedInstOperands,
     /*  352761 */     // GIR_Coverage, 21406,
     /*  352761 */     GIR_EraseRootFromParent_Done,
     /*  352762 */   // Label 6410: @352762
     /*  352762 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(352828), // Rule ID 21407 //
     /*  352767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352806 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  352809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352826 */     GIR_RootConstrainSelectedInstOperands,
     /*  352827 */     // GIR_Coverage, 21407,
     /*  352827 */     GIR_EraseRootFromParent_Done,
     /*  352828 */   // Label 6411: @352828
     /*  352828 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(352894), // Rule ID 21410 //
     /*  352833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  352875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352892 */     GIR_RootConstrainSelectedInstOperands,
     /*  352893 */     // GIR_Coverage, 21410,
     /*  352893 */     GIR_EraseRootFromParent_Done,
     /*  352894 */   // Label 6412: @352894
     /*  352894 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(352960), // Rule ID 21411 //
     /*  352899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  352941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352958 */     GIR_RootConstrainSelectedInstOperands,
     /*  352959 */     // GIR_Coverage, 21411,
     /*  352959 */     GIR_EraseRootFromParent_Done,
     /*  352960 */   // Label 6413: @352960
     /*  352960 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(353026), // Rule ID 21414 //
     /*  352965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  352973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  352982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  353007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353024 */     GIR_RootConstrainSelectedInstOperands,
     /*  353025 */     // GIR_Coverage, 21414,
     /*  353025 */     GIR_EraseRootFromParent_Done,
     /*  353026 */   // Label 6414: @353026
     /*  353026 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(353092), // Rule ID 21415 //
     /*  353031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  353073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353090 */     GIR_RootConstrainSelectedInstOperands,
     /*  353091 */     // GIR_Coverage, 21415,
     /*  353091 */     GIR_EraseRootFromParent_Done,
     /*  353092 */   // Label 6415: @353092
     /*  353092 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(353158), // Rule ID 21418 //
     /*  353097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  353108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  353111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353136 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  353139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353156 */     GIR_RootConstrainSelectedInstOperands,
     /*  353157 */     // GIR_Coverage, 21418,
     /*  353157 */     GIR_EraseRootFromParent_Done,
     /*  353158 */   // Label 6416: @353158
     /*  353158 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(353224), // Rule ID 21419 //
     /*  353163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  353174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  353177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  353205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353222 */     GIR_RootConstrainSelectedInstOperands,
     /*  353223 */     // GIR_Coverage, 21419,
     /*  353223 */     GIR_EraseRootFromParent_Done,
     /*  353224 */   // Label 6417: @353224
     /*  353224 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(353290), // Rule ID 21422 //
     /*  353229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  353240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  353243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353268 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  353271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353288 */     GIR_RootConstrainSelectedInstOperands,
     /*  353289 */     // GIR_Coverage, 21422,
     /*  353289 */     GIR_EraseRootFromParent_Done,
     /*  353290 */   // Label 6418: @353290
     /*  353290 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(353356), // Rule ID 21423 //
     /*  353295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  353306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  353309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353334 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  353337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353354 */     GIR_RootConstrainSelectedInstOperands,
     /*  353355 */     // GIR_Coverage, 21423,
     /*  353355 */     GIR_EraseRootFromParent_Done,
     /*  353356 */   // Label 6419: @353356
     /*  353356 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(353422), // Rule ID 21426 //
     /*  353361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  353372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  353375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353400 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  353403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353420 */     GIR_RootConstrainSelectedInstOperands,
     /*  353421 */     // GIR_Coverage, 21426,
     /*  353421 */     GIR_EraseRootFromParent_Done,
     /*  353422 */   // Label 6420: @353422
     /*  353422 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(353488), // Rule ID 21427 //
     /*  353427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  353438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  353441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353466 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  353469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353486 */     GIR_RootConstrainSelectedInstOperands,
     /*  353487 */     // GIR_Coverage, 21427,
     /*  353487 */     GIR_EraseRootFromParent_Done,
     /*  353488 */   // Label 6421: @353488
     /*  353488 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(353554), // Rule ID 21430 //
     /*  353493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  353504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  353507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  353535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353552 */     GIR_RootConstrainSelectedInstOperands,
     /*  353553 */     // GIR_Coverage, 21430,
     /*  353553 */     GIR_EraseRootFromParent_Done,
     /*  353554 */   // Label 6422: @353554
     /*  353554 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(353620), // Rule ID 21431 //
     /*  353559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  353570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  353573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353598 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  353601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353618 */     GIR_RootConstrainSelectedInstOperands,
     /*  353619 */     // GIR_Coverage, 21431,
     /*  353619 */     GIR_EraseRootFromParent_Done,
     /*  353620 */   // Label 6423: @353620
     /*  353620 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(353686), // Rule ID 21434 //
     /*  353625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  353628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  353636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  353639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  353664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  353667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353684 */     GIR_RootConstrainSelectedInstOperands,
     /*  353685 */     // GIR_Coverage, 21434,
     /*  353685 */     GIR_EraseRootFromParent_Done,
     /*  353686 */   // Label 6424: @353686
     /*  353686 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(353752), // Rule ID 21435 //
     /*  353691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  353699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  353702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  353705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353730 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  353733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353750 */     GIR_RootConstrainSelectedInstOperands,
     /*  353751 */     // GIR_Coverage, 21435,
     /*  353751 */     GIR_EraseRootFromParent_Done,
     /*  353752 */   // Label 6425: @353752
     /*  353752 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(353818), // Rule ID 21438 //
     /*  353757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  353760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  353799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353816 */     GIR_RootConstrainSelectedInstOperands,
     /*  353817 */     // GIR_Coverage, 21438,
     /*  353817 */     GIR_EraseRootFromParent_Done,
     /*  353818 */   // Label 6426: @353818
     /*  353818 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(353884), // Rule ID 21439 //
     /*  353823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  353826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  353834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  353837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  353865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353882 */     GIR_RootConstrainSelectedInstOperands,
     /*  353883 */     // GIR_Coverage, 21439,
     /*  353883 */     GIR_EraseRootFromParent_Done,
     /*  353884 */   // Label 6427: @353884
     /*  353884 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(353950), // Rule ID 21442 //
     /*  353889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  353892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353928 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  353931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353948 */     GIR_RootConstrainSelectedInstOperands,
     /*  353949 */     // GIR_Coverage, 21442,
     /*  353949 */     GIR_EraseRootFromParent_Done,
     /*  353950 */   // Label 6428: @353950
     /*  353950 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(354016), // Rule ID 21443 //
     /*  353955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  353958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  353963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  353966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  353969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353994 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  353997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354014 */     GIR_RootConstrainSelectedInstOperands,
     /*  354015 */     // GIR_Coverage, 21443,
     /*  354015 */     GIR_EraseRootFromParent_Done,
     /*  354016 */   // Label 6429: @354016
     /*  354016 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(354082), // Rule ID 21446 //
     /*  354021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  354038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  354063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354080 */     GIR_RootConstrainSelectedInstOperands,
     /*  354081 */     // GIR_Coverage, 21446,
     /*  354081 */     GIR_EraseRootFromParent_Done,
     /*  354082 */   // Label 6430: @354082
     /*  354082 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(354148), // Rule ID 21447 //
     /*  354087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  354104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354126 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  354129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354146 */     GIR_RootConstrainSelectedInstOperands,
     /*  354147 */     // GIR_Coverage, 21447,
     /*  354147 */     GIR_EraseRootFromParent_Done,
     /*  354148 */   // Label 6431: @354148
     /*  354148 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(354214), // Rule ID 21450 //
     /*  354153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  354195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354212 */     GIR_RootConstrainSelectedInstOperands,
     /*  354213 */     // GIR_Coverage, 21450,
     /*  354213 */     GIR_EraseRootFromParent_Done,
     /*  354214 */   // Label 6432: @354214
     /*  354214 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(354280), // Rule ID 21451 //
     /*  354219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  354236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  354261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354278 */     GIR_RootConstrainSelectedInstOperands,
     /*  354279 */     // GIR_Coverage, 21451,
     /*  354279 */     GIR_EraseRootFromParent_Done,
     /*  354280 */   // Label 6433: @354280
     /*  354280 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(354346), // Rule ID 21454 //
     /*  354285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  354288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354324 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  354327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354344 */     GIR_RootConstrainSelectedInstOperands,
     /*  354345 */     // GIR_Coverage, 21454,
     /*  354345 */     GIR_EraseRootFromParent_Done,
     /*  354346 */   // Label 6434: @354346
     /*  354346 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(354412), // Rule ID 21455 //
     /*  354351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  354354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  354362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  354365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  354368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  354393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354410 */     GIR_RootConstrainSelectedInstOperands,
     /*  354411 */     // GIR_Coverage, 21455,
     /*  354411 */     GIR_EraseRootFromParent_Done,
     /*  354412 */   // Label 6435: @354412
     /*  354412 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(354478), // Rule ID 21458 //
     /*  354417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  354428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  354431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  354459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354476 */     GIR_RootConstrainSelectedInstOperands,
     /*  354477 */     // GIR_Coverage, 21458,
     /*  354477 */     GIR_EraseRootFromParent_Done,
     /*  354478 */   // Label 6436: @354478
     /*  354478 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(354544), // Rule ID 21459 //
     /*  354483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  354494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  354497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354522 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  354525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354542 */     GIR_RootConstrainSelectedInstOperands,
     /*  354543 */     // GIR_Coverage, 21459,
     /*  354543 */     GIR_EraseRootFromParent_Done,
     /*  354544 */   // Label 6437: @354544
     /*  354544 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(354610), // Rule ID 21462 //
     /*  354549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354588 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  354591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354608 */     GIR_RootConstrainSelectedInstOperands,
     /*  354609 */     // GIR_Coverage, 21462,
     /*  354609 */     GIR_EraseRootFromParent_Done,
     /*  354610 */   // Label 6438: @354610
     /*  354610 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(354676), // Rule ID 21463 //
     /*  354615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  354626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  354629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354654 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  354657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354674 */     GIR_RootConstrainSelectedInstOperands,
     /*  354675 */     // GIR_Coverage, 21463,
     /*  354675 */     GIR_EraseRootFromParent_Done,
     /*  354676 */   // Label 6439: @354676
     /*  354676 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(354742), // Rule ID 21466 //
     /*  354681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  354723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354740 */     GIR_RootConstrainSelectedInstOperands,
     /*  354741 */     // GIR_Coverage, 21466,
     /*  354741 */     GIR_EraseRootFromParent_Done,
     /*  354742 */   // Label 6440: @354742
     /*  354742 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(354808), // Rule ID 21467 //
     /*  354747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  354758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  354761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354786 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  354789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354806 */     GIR_RootConstrainSelectedInstOperands,
     /*  354807 */     // GIR_Coverage, 21467,
     /*  354807 */     GIR_EraseRootFromParent_Done,
     /*  354808 */   // Label 6441: @354808
     /*  354808 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(354874), // Rule ID 21470 //
     /*  354813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  354816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354852 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  354855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354872 */     GIR_RootConstrainSelectedInstOperands,
     /*  354873 */     // GIR_Coverage, 21470,
     /*  354873 */     GIR_EraseRootFromParent_Done,
     /*  354874 */   // Label 6442: @354874
     /*  354874 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(354940), // Rule ID 21471 //
     /*  354879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  354882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  354887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  354890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  354893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354918 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  354921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354938 */     GIR_RootConstrainSelectedInstOperands,
     /*  354939 */     // GIR_Coverage, 21471,
     /*  354939 */     GIR_EraseRootFromParent_Done,
     /*  354940 */   // Label 6443: @354940
     /*  354940 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(355006), // Rule ID 21714 //
     /*  354945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  354948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  354953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  354956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  354959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  354962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  354984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  354987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355004 */     GIR_RootConstrainSelectedInstOperands,
     /*  355005 */     // GIR_Coverage, 21714,
     /*  355005 */     GIR_EraseRootFromParent_Done,
     /*  355006 */   // Label 6444: @355006
     /*  355006 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(355072), // Rule ID 21715 //
     /*  355011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  355022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  355025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  355028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  355053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355070 */     GIR_RootConstrainSelectedInstOperands,
     /*  355071 */     // GIR_Coverage, 21715,
     /*  355071 */     GIR_EraseRootFromParent_Done,
     /*  355072 */   // Label 6445: @355072
     /*  355072 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(355138), // Rule ID 21718 //
     /*  355077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  355088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  355091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355136 */     GIR_RootConstrainSelectedInstOperands,
     /*  355137 */     // GIR_Coverage, 21718,
     /*  355137 */     GIR_EraseRootFromParent_Done,
     /*  355138 */   // Label 6446: @355138
     /*  355138 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(355204), // Rule ID 21719 //
     /*  355143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  355154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  355157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  355160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355202 */     GIR_RootConstrainSelectedInstOperands,
     /*  355203 */     // GIR_Coverage, 21719,
     /*  355203 */     GIR_EraseRootFromParent_Done,
     /*  355204 */   // Label 6447: @355204
     /*  355204 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(355270), // Rule ID 21722 //
     /*  355209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  355226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355268 */     GIR_RootConstrainSelectedInstOperands,
     /*  355269 */     // GIR_Coverage, 21722,
     /*  355269 */     GIR_EraseRootFromParent_Done,
     /*  355270 */   // Label 6448: @355270
     /*  355270 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(355336), // Rule ID 21723 //
     /*  355275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  355286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  355289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  355292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355334 */     GIR_RootConstrainSelectedInstOperands,
     /*  355335 */     // GIR_Coverage, 21723,
     /*  355335 */     GIR_EraseRootFromParent_Done,
     /*  355336 */   // Label 6449: @355336
     /*  355336 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(355402), // Rule ID 21726 //
     /*  355341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  355358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  355383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355400 */     GIR_RootConstrainSelectedInstOperands,
     /*  355401 */     // GIR_Coverage, 21726,
     /*  355401 */     GIR_EraseRootFromParent_Done,
     /*  355402 */   // Label 6450: @355402
     /*  355402 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(355468), // Rule ID 21727 //
     /*  355407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  355418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  355421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  355424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  355449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355466 */     GIR_RootConstrainSelectedInstOperands,
     /*  355467 */     // GIR_Coverage, 21727,
     /*  355467 */     GIR_EraseRootFromParent_Done,
     /*  355468 */   // Label 6451: @355468
     /*  355468 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(355534), // Rule ID 21730 //
     /*  355473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  355484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  355487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  355490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  355515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355532 */     GIR_RootConstrainSelectedInstOperands,
     /*  355533 */     // GIR_Coverage, 21730,
     /*  355533 */     GIR_EraseRootFromParent_Done,
     /*  355534 */   // Label 6452: @355534
     /*  355534 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(355600), // Rule ID 21731 //
     /*  355539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  355550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  355553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  355556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  355581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355598 */     GIR_RootConstrainSelectedInstOperands,
     /*  355599 */     // GIR_Coverage, 21731,
     /*  355599 */     GIR_EraseRootFromParent_Done,
     /*  355600 */   // Label 6453: @355600
     /*  355600 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(355666), // Rule ID 21734 //
     /*  355605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  355608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  355616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  355619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  355622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  355644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  355647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355664 */     GIR_RootConstrainSelectedInstOperands,
     /*  355665 */     // GIR_Coverage, 21734,
     /*  355665 */     GIR_EraseRootFromParent_Done,
     /*  355666 */   // Label 6454: @355666
     /*  355666 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(355732), // Rule ID 21735 //
     /*  355671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  355674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  355682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  355685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  355688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  355710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  355713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  355727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355730 */     GIR_RootConstrainSelectedInstOperands,
     /*  355731 */     // GIR_Coverage, 21735,
     /*  355731 */     GIR_EraseRootFromParent_Done,
     /*  355732 */   // Label 6455: @355732
     /*  355732 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(355798), // Rule ID 21738 //
     /*  355737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  355740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355796 */     GIR_RootConstrainSelectedInstOperands,
     /*  355797 */     // GIR_Coverage, 21738,
     /*  355797 */     GIR_EraseRootFromParent_Done,
     /*  355798 */   // Label 6456: @355798
     /*  355798 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(355864), // Rule ID 21739 //
     /*  355803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  355806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  355845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355862 */     GIR_RootConstrainSelectedInstOperands,
     /*  355863 */     // GIR_Coverage, 21739,
     /*  355863 */     GIR_EraseRootFromParent_Done,
     /*  355864 */   // Label 6457: @355864
     /*  355864 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(355930), // Rule ID 21742 //
     /*  355869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  355872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355908 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355928 */     GIR_RootConstrainSelectedInstOperands,
     /*  355929 */     // GIR_Coverage, 21742,
     /*  355929 */     GIR_EraseRootFromParent_Done,
     /*  355930 */   // Label 6458: @355930
     /*  355930 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(355996), // Rule ID 21743 //
     /*  355935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  355938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  355943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  355977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355994 */     GIR_RootConstrainSelectedInstOperands,
     /*  355995 */     // GIR_Coverage, 21743,
     /*  355995 */     GIR_EraseRootFromParent_Done,
     /*  355996 */   // Label 6459: @355996
     /*  355996 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(356062), // Rule ID 21746 //
     /*  356001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  356012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  356015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  356018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356060 */     GIR_RootConstrainSelectedInstOperands,
     /*  356061 */     // GIR_Coverage, 21746,
     /*  356061 */     GIR_EraseRootFromParent_Done,
     /*  356062 */   // Label 6460: @356062
     /*  356062 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(356128), // Rule ID 21747 //
     /*  356067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  356078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  356081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  356084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356126 */     GIR_RootConstrainSelectedInstOperands,
     /*  356127 */     // GIR_Coverage, 21747,
     /*  356127 */     GIR_EraseRootFromParent_Done,
     /*  356128 */   // Label 6461: @356128
     /*  356128 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(356194), // Rule ID 21750 //
     /*  356133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356192 */     GIR_RootConstrainSelectedInstOperands,
     /*  356193 */     // GIR_Coverage, 21750,
     /*  356193 */     GIR_EraseRootFromParent_Done,
     /*  356194 */   // Label 6462: @356194
     /*  356194 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(356260), // Rule ID 21751 //
     /*  356199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  356210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  356213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  356216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356258 */     GIR_RootConstrainSelectedInstOperands,
     /*  356259 */     // GIR_Coverage, 21751,
     /*  356259 */     GIR_EraseRootFromParent_Done,
     /*  356260 */   // Label 6463: @356260
     /*  356260 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(356326), // Rule ID 21754 //
     /*  356265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  356268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  356304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356324 */     GIR_RootConstrainSelectedInstOperands,
     /*  356325 */     // GIR_Coverage, 21754,
     /*  356325 */     GIR_EraseRootFromParent_Done,
     /*  356326 */   // Label 6464: @356326
     /*  356326 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(356392), // Rule ID 21755 //
     /*  356331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  356334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  356342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  356345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  356348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  356370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  356387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356390 */     GIR_RootConstrainSelectedInstOperands,
     /*  356391 */     // GIR_Coverage, 21755,
     /*  356391 */     GIR_EraseRootFromParent_Done,
     /*  356392 */   // Label 6465: @356392
     /*  356392 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(356458), // Rule ID 21758 //
     /*  356397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356436 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  356439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356456 */     GIR_RootConstrainSelectedInstOperands,
     /*  356457 */     // GIR_Coverage, 21758,
     /*  356457 */     GIR_EraseRootFromParent_Done,
     /*  356458 */   // Label 6466: @356458
     /*  356458 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(356524), // Rule ID 21759 //
     /*  356463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  356474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  356477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  356480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  356505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356522 */     GIR_RootConstrainSelectedInstOperands,
     /*  356523 */     // GIR_Coverage, 21759,
     /*  356523 */     GIR_EraseRootFromParent_Done,
     /*  356524 */   // Label 6467: @356524
     /*  356524 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(356590), // Rule ID 21762 //
     /*  356529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356588 */     GIR_RootConstrainSelectedInstOperands,
     /*  356589 */     // GIR_Coverage, 21762,
     /*  356589 */     GIR_EraseRootFromParent_Done,
     /*  356590 */   // Label 6468: @356590
     /*  356590 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(356656), // Rule ID 21763 //
     /*  356595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  356606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  356609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  356612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356634 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  356637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356654 */     GIR_RootConstrainSelectedInstOperands,
     /*  356655 */     // GIR_Coverage, 21763,
     /*  356655 */     GIR_EraseRootFromParent_Done,
     /*  356656 */   // Label 6469: @356656
     /*  356656 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(356722), // Rule ID 21766 //
     /*  356661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356720 */     GIR_RootConstrainSelectedInstOperands,
     /*  356721 */     // GIR_Coverage, 21766,
     /*  356721 */     GIR_EraseRootFromParent_Done,
     /*  356722 */   // Label 6470: @356722
     /*  356722 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(356788), // Rule ID 21767 //
     /*  356727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  356769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356786 */     GIR_RootConstrainSelectedInstOperands,
     /*  356787 */     // GIR_Coverage, 21767,
     /*  356787 */     GIR_EraseRootFromParent_Done,
     /*  356788 */   // Label 6471: @356788
     /*  356788 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(356854), // Rule ID 21770 //
     /*  356793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  356796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356852 */     GIR_RootConstrainSelectedInstOperands,
     /*  356853 */     // GIR_Coverage, 21770,
     /*  356853 */     GIR_EraseRootFromParent_Done,
     /*  356854 */   // Label 6472: @356854
     /*  356854 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(356920), // Rule ID 21771 //
     /*  356859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  356862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  356867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  356901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356918 */     GIR_RootConstrainSelectedInstOperands,
     /*  356919 */     // GIR_Coverage, 21771,
     /*  356919 */     GIR_EraseRootFromParent_Done,
     /*  356920 */   // Label 6473: @356920
     /*  356920 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(356986), // Rule ID 21774 //
     /*  356925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  356928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  356933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  356936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  356939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  356942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  356964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  356967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  356981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356984 */     GIR_RootConstrainSelectedInstOperands,
     /*  356985 */     // GIR_Coverage, 21774,
     /*  356985 */     GIR_EraseRootFromParent_Done,
     /*  356986 */   // Label 6474: @356986
     /*  356986 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(357052), // Rule ID 21775 //
     /*  356991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  356994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  356999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  357002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  357005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  357008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  357033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357050 */     GIR_RootConstrainSelectedInstOperands,
     /*  357051 */     // GIR_Coverage, 21775,
     /*  357051 */     GIR_EraseRootFromParent_Done,
     /*  357052 */   // Label 6475: @357052
     /*  357052 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(357118), // Rule ID 21778 //
     /*  357057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  357068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  357071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  357074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357116 */     GIR_RootConstrainSelectedInstOperands,
     /*  357117 */     // GIR_Coverage, 21778,
     /*  357117 */     GIR_EraseRootFromParent_Done,
     /*  357118 */   // Label 6476: @357118
     /*  357118 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(357184), // Rule ID 21779 //
     /*  357123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  357134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  357137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  357140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357182 */     GIR_RootConstrainSelectedInstOperands,
     /*  357183 */     // GIR_Coverage, 21779,
     /*  357183 */     GIR_EraseRootFromParent_Done,
     /*  357184 */   // Label 6477: @357184
     /*  357184 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(357250), // Rule ID 21782 //
     /*  357189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  357200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  357203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  357206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357248 */     GIR_RootConstrainSelectedInstOperands,
     /*  357249 */     // GIR_Coverage, 21782,
     /*  357249 */     GIR_EraseRootFromParent_Done,
     /*  357250 */   // Label 6478: @357250
     /*  357250 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(357316), // Rule ID 21783 //
     /*  357255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  357266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  357269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  357272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357314 */     GIR_RootConstrainSelectedInstOperands,
     /*  357315 */     // GIR_Coverage, 21783,
     /*  357315 */     GIR_EraseRootFromParent_Done,
     /*  357316 */   // Label 6479: @357316
     /*  357316 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(357382), // Rule ID 21786 //
     /*  357321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  357332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  357335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  357338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  357363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357380 */     GIR_RootConstrainSelectedInstOperands,
     /*  357381 */     // GIR_Coverage, 21786,
     /*  357381 */     GIR_EraseRootFromParent_Done,
     /*  357382 */   // Label 6480: @357382
     /*  357382 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(357448), // Rule ID 21787 //
     /*  357387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  357398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  357401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  357404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11170:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  357429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357446 */     GIR_RootConstrainSelectedInstOperands,
     /*  357447 */     // GIR_Coverage, 21787,
     /*  357447 */     GIR_EraseRootFromParent_Done,
     /*  357448 */   // Label 6481: @357448
     /*  357448 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(357514), // Rule ID 21790 //
     /*  357453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  357464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  357467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  357495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357512 */     GIR_RootConstrainSelectedInstOperands,
     /*  357513 */     // GIR_Coverage, 21790,
     /*  357513 */     GIR_EraseRootFromParent_Done,
     /*  357514 */   // Label 6482: @357514
     /*  357514 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(357580), // Rule ID 21791 //
     /*  357519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  357530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  357533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  357536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  357547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  357561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357578 */     GIR_RootConstrainSelectedInstOperands,
     /*  357579 */     // GIR_Coverage, 21791,
     /*  357579 */     GIR_EraseRootFromParent_Done,
     /*  357580 */   // Label 6483: @357580
     /*  357580 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(357646), // Rule ID 21794 //
     /*  357585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  357588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  357596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  357599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  357624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  357627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357644 */     GIR_RootConstrainSelectedInstOperands,
     /*  357645 */     // GIR_Coverage, 21794,
     /*  357645 */     GIR_EraseRootFromParent_Done,
     /*  357646 */   // Label 6484: @357646
     /*  357646 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(357712), // Rule ID 21795 //
     /*  357651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  357654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  357662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  357665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  357668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  357679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  357683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357690 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  357690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  357693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  357707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357710 */     GIR_RootConstrainSelectedInstOperands,
     /*  357711 */     // GIR_Coverage, 21795,
     /*  357711 */     GIR_EraseRootFromParent_Done,
     /*  357712 */   // Label 6485: @357712
     /*  357712 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(357778), // Rule ID 21798 //
     /*  357717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  357728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  357731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  357734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357756 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357776 */     GIR_RootConstrainSelectedInstOperands,
     /*  357777 */     // GIR_Coverage, 21798,
     /*  357777 */     GIR_EraseRootFromParent_Done,
     /*  357778 */   // Label 6486: @357778
     /*  357778 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(357844), // Rule ID 21799 //
     /*  357783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  357786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  357794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  357797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  357800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  357825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357842 */     GIR_RootConstrainSelectedInstOperands,
     /*  357843 */     // GIR_Coverage, 21799,
     /*  357843 */     GIR_EraseRootFromParent_Done,
     /*  357844 */   // Label 6487: @357844
     /*  357844 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(357910), // Rule ID 21802 //
     /*  357849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  357860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  357863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  357866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  357888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357908 */     GIR_RootConstrainSelectedInstOperands,
     /*  357909 */     // GIR_Coverage, 21802,
     /*  357909 */     GIR_EraseRootFromParent_Done,
     /*  357910 */   // Label 6488: @357910
     /*  357910 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(357976), // Rule ID 21803 //
     /*  357915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  357918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  357926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  357929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  357932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  357954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  357957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  357961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  357971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357974 */     GIR_RootConstrainSelectedInstOperands,
     /*  357975 */     // GIR_Coverage, 21803,
     /*  357975 */     GIR_EraseRootFromParent_Done,
     /*  357976 */   // Label 6489: @357976
     /*  357976 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(358042), // Rule ID 21806 //
     /*  357981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  357984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  357989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  357992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  357995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  357998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358040 */     GIR_RootConstrainSelectedInstOperands,
     /*  358041 */     // GIR_Coverage, 21806,
     /*  358041 */     GIR_EraseRootFromParent_Done,
     /*  358042 */   // Label 6490: @358042
     /*  358042 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(358108), // Rule ID 21807 //
     /*  358047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  358058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  358061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  358064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11170:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358106 */     GIR_RootConstrainSelectedInstOperands,
     /*  358107 */     // GIR_Coverage, 21807,
     /*  358107 */     GIR_EraseRootFromParent_Done,
     /*  358108 */   // Label 6491: @358108
     /*  358108 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(358174), // Rule ID 21810 //
     /*  358113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  358116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  358124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  358127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  358130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358172 */     GIR_RootConstrainSelectedInstOperands,
     /*  358173 */     // GIR_Coverage, 21810,
     /*  358173 */     GIR_EraseRootFromParent_Done,
     /*  358174 */   // Label 6492: @358174
     /*  358174 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(358240), // Rule ID 21811 //
     /*  358179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  358190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  358193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  358196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358238 */     GIR_RootConstrainSelectedInstOperands,
     /*  358239 */     // GIR_Coverage, 21811,
     /*  358239 */     GIR_EraseRootFromParent_Done,
     /*  358240 */   // Label 6493: @358240
     /*  358240 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(358306), // Rule ID 21814 //
     /*  358245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  358248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  358256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  358259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  358262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358304 */     GIR_RootConstrainSelectedInstOperands,
     /*  358305 */     // GIR_Coverage, 21814,
     /*  358305 */     GIR_EraseRootFromParent_Done,
     /*  358306 */   // Label 6494: @358306
     /*  358306 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(358372), // Rule ID 21815 //
     /*  358311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  358314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  358322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  358325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  358328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  358350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358370 */     GIR_RootConstrainSelectedInstOperands,
     /*  358371 */     // GIR_Coverage, 21815,
     /*  358371 */     GIR_EraseRootFromParent_Done,
     /*  358372 */   // Label 6495: @358372
     /*  358372 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(358438), // Rule ID 21818 //
     /*  358377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  358388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  358391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  358394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  358419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358436 */     GIR_RootConstrainSelectedInstOperands,
     /*  358437 */     // GIR_Coverage, 21818,
     /*  358437 */     GIR_EraseRootFromParent_Done,
     /*  358438 */   // Label 6496: @358438
     /*  358438 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(358504), // Rule ID 21819 //
     /*  358443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  358454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  358457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  358460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  358485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358502 */     GIR_RootConstrainSelectedInstOperands,
     /*  358503 */     // GIR_Coverage, 21819,
     /*  358503 */     GIR_EraseRootFromParent_Done,
     /*  358504 */   // Label 6497: @358504
     /*  358504 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(358570), // Rule ID 21822 //
     /*  358509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  358520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  358523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  358526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358568 */     GIR_RootConstrainSelectedInstOperands,
     /*  358569 */     // GIR_Coverage, 21822,
     /*  358569 */     GIR_EraseRootFromParent_Done,
     /*  358570 */   // Label 6498: @358570
     /*  358570 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(358636), // Rule ID 21823 //
     /*  358575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  358586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  358589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  358592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11170:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  358617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358634 */     GIR_RootConstrainSelectedInstOperands,
     /*  358635 */     // GIR_Coverage, 21823,
     /*  358635 */     GIR_EraseRootFromParent_Done,
     /*  358636 */   // Label 6499: @358636
     /*  358636 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(358702), // Rule ID 21826 //
     /*  358641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  358652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  358655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358700 */     GIR_RootConstrainSelectedInstOperands,
     /*  358701 */     // GIR_Coverage, 21826,
     /*  358701 */     GIR_EraseRootFromParent_Done,
     /*  358702 */   // Label 6500: @358702
     /*  358702 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(358768), // Rule ID 21827 //
     /*  358707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  358718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  358721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  358724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  358735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  358749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358766 */     GIR_RootConstrainSelectedInstOperands,
     /*  358767 */     // GIR_Coverage, 21827,
     /*  358767 */     GIR_EraseRootFromParent_Done,
     /*  358768 */   // Label 6501: @358768
     /*  358768 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(358834), // Rule ID 21830 //
     /*  358773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  358776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  358784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  358787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  358812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358832 */     GIR_RootConstrainSelectedInstOperands,
     /*  358833 */     // GIR_Coverage, 21830,
     /*  358833 */     GIR_EraseRootFromParent_Done,
     /*  358834 */   // Label 6502: @358834
     /*  358834 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(358900), // Rule ID 21831 //
     /*  358839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  358842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  358847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  358850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  358853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  358856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  358867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  358871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  358878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  358881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  358895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358898 */     GIR_RootConstrainSelectedInstOperands,
     /*  358899 */     // GIR_Coverage, 21831,
     /*  358899 */     GIR_EraseRootFromParent_Done,
     /*  358900 */   // Label 6503: @358900
     /*  358900 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(358966), // Rule ID 21942 //
     /*  358905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  358908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  358913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  358916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  358919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  358922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358944 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  358944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  358947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  358951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  358961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358964 */     GIR_RootConstrainSelectedInstOperands,
     /*  358965 */     // GIR_Coverage, 21942,
     /*  358965 */     GIR_EraseRootFromParent_Done,
     /*  358966 */   // Label 6504: @358966
     /*  358966 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(359032), // Rule ID 21943 //
     /*  358971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  358974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  358979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  358982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  358985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  358988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359010 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  359013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359030 */     GIR_RootConstrainSelectedInstOperands,
     /*  359031 */     // GIR_Coverage, 21943,
     /*  359031 */     GIR_EraseRootFromParent_Done,
     /*  359032 */   // Label 6505: @359032
     /*  359032 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(359098), // Rule ID 21946 //
     /*  359037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359076 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  359079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359096 */     GIR_RootConstrainSelectedInstOperands,
     /*  359097 */     // GIR_Coverage, 21946,
     /*  359097 */     GIR_EraseRootFromParent_Done,
     /*  359098 */   // Label 6506: @359098
     /*  359098 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(359164), // Rule ID 21947 //
     /*  359103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  359114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  359117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  359120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359142 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  359145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359162 */     GIR_RootConstrainSelectedInstOperands,
     /*  359163 */     // GIR_Coverage, 21947,
     /*  359163 */     GIR_EraseRootFromParent_Done,
     /*  359164 */   // Label 6507: @359164
     /*  359164 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(359230), // Rule ID 21950 //
     /*  359169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  359186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359208 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  359211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359228 */     GIR_RootConstrainSelectedInstOperands,
     /*  359229 */     // GIR_Coverage, 21950,
     /*  359229 */     GIR_EraseRootFromParent_Done,
     /*  359230 */   // Label 6508: @359230
     /*  359230 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(359296), // Rule ID 21951 //
     /*  359235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  359246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  359249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  359252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359274 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  359277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359294 */     GIR_RootConstrainSelectedInstOperands,
     /*  359295 */     // GIR_Coverage, 21951,
     /*  359295 */     GIR_EraseRootFromParent_Done,
     /*  359296 */   // Label 6509: @359296
     /*  359296 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(359362), // Rule ID 21954 //
     /*  359301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  359312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  359315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  359318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359340 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  359343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359360 */     GIR_RootConstrainSelectedInstOperands,
     /*  359361 */     // GIR_Coverage, 21954,
     /*  359361 */     GIR_EraseRootFromParent_Done,
     /*  359362 */   // Label 6510: @359362
     /*  359362 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(359428), // Rule ID 21955 //
     /*  359367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  359378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  359381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  359384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  359409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359426 */     GIR_RootConstrainSelectedInstOperands,
     /*  359427 */     // GIR_Coverage, 21955,
     /*  359427 */     GIR_EraseRootFromParent_Done,
     /*  359428 */   // Label 6511: @359428
     /*  359428 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(359494), // Rule ID 21958 //
     /*  359433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  359436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  359444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  359447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  359450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359472 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  359472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  359475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359492 */     GIR_RootConstrainSelectedInstOperands,
     /*  359493 */     // GIR_Coverage, 21958,
     /*  359493 */     GIR_EraseRootFromParent_Done,
     /*  359494 */   // Label 6512: @359494
     /*  359494 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(359560), // Rule ID 21959 //
     /*  359499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  359502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  359510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  359513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  359516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  359538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  359541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  359555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359558 */     GIR_RootConstrainSelectedInstOperands,
     /*  359559 */     // GIR_Coverage, 21959,
     /*  359559 */     GIR_EraseRootFromParent_Done,
     /*  359560 */   // Label 6513: @359560
     /*  359560 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(359626), // Rule ID 21962 //
     /*  359565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  359582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  359607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359624 */     GIR_RootConstrainSelectedInstOperands,
     /*  359625 */     // GIR_Coverage, 21962,
     /*  359625 */     GIR_EraseRootFromParent_Done,
     /*  359626 */   // Label 6514: @359626
     /*  359626 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(359692), // Rule ID 21963 //
     /*  359631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  359642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  359645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  359648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359670 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  359673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359690 */     GIR_RootConstrainSelectedInstOperands,
     /*  359691 */     // GIR_Coverage, 21963,
     /*  359691 */     GIR_EraseRootFromParent_Done,
     /*  359692 */   // Label 6515: @359692
     /*  359692 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(359758), // Rule ID 21966 //
     /*  359697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  359714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  359739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359756 */     GIR_RootConstrainSelectedInstOperands,
     /*  359757 */     // GIR_Coverage, 21966,
     /*  359757 */     GIR_EraseRootFromParent_Done,
     /*  359758 */   // Label 6516: @359758
     /*  359758 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(359824), // Rule ID 21967 //
     /*  359763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  359774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  359777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  359780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  359805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359822 */     GIR_RootConstrainSelectedInstOperands,
     /*  359823 */     // GIR_Coverage, 21967,
     /*  359823 */     GIR_EraseRootFromParent_Done,
     /*  359824 */   // Label 6517: @359824
     /*  359824 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(359890), // Rule ID 21970 //
     /*  359829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  359840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  359843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  359846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  359868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  359871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359888 */     GIR_RootConstrainSelectedInstOperands,
     /*  359889 */     // GIR_Coverage, 21970,
     /*  359889 */     GIR_EraseRootFromParent_Done,
     /*  359890 */   // Label 6518: @359890
     /*  359890 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(359956), // Rule ID 21971 //
     /*  359895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  359898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  359906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  359909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  359912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  359923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  359934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  359937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  359941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  359951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359954 */     GIR_RootConstrainSelectedInstOperands,
     /*  359955 */     // GIR_Coverage, 21971,
     /*  359955 */     GIR_EraseRootFromParent_Done,
     /*  359956 */   // Label 6519: @359956
     /*  359956 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(360022), // Rule ID 21974 //
     /*  359961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  359964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  359969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  359972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  359975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  359978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  359989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  359993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360000 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  360000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  360003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  360017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360020 */     GIR_RootConstrainSelectedInstOperands,
     /*  360021 */     // GIR_Coverage, 21974,
     /*  360021 */     GIR_EraseRootFromParent_Done,
     /*  360022 */   // Label 6520: @360022
     /*  360022 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(360088), // Rule ID 21975 //
     /*  360027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  360030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  360035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  360038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  360041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  360044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  360055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  360059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  360066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  360069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  360073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  360083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360086 */     GIR_RootConstrainSelectedInstOperands,
     /*  360087 */     // GIR_Coverage, 21975,
     /*  360087 */     GIR_EraseRootFromParent_Done,
     /*  360088 */   // Label 6521: @360088
     /*  360088 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(360151), // Rule ID 23146 //
     /*  360093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  360135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360149 */     GIR_RootConstrainSelectedInstOperands,
     /*  360150 */     // GIR_Coverage, 23146,
     /*  360150 */     GIR_EraseRootFromParent_Done,
     /*  360151 */   // Label 6522: @360151
     /*  360151 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(360214), // Rule ID 23147 //
     /*  360156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360195 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  360198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360212 */     GIR_RootConstrainSelectedInstOperands,
     /*  360213 */     // GIR_Coverage, 23147,
     /*  360213 */     GIR_EraseRootFromParent_Done,
     /*  360214 */   // Label 6523: @360214
     /*  360214 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(360277), // Rule ID 23148 //
     /*  360219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  360261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360275 */     GIR_RootConstrainSelectedInstOperands,
     /*  360276 */     // GIR_Coverage, 23148,
     /*  360276 */     GIR_EraseRootFromParent_Done,
     /*  360277 */   // Label 6524: @360277
     /*  360277 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(360340), // Rule ID 23149 //
     /*  360282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  360324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360338 */     GIR_RootConstrainSelectedInstOperands,
     /*  360339 */     // GIR_Coverage, 23149,
     /*  360339 */     GIR_EraseRootFromParent_Done,
     /*  360340 */   // Label 6525: @360340
     /*  360340 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(360403), // Rule ID 23150 //
     /*  360345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  360387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360401 */     GIR_RootConstrainSelectedInstOperands,
     /*  360402 */     // GIR_Coverage, 23150,
     /*  360402 */     GIR_EraseRootFromParent_Done,
     /*  360403 */   // Label 6526: @360403
     /*  360403 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(360466), // Rule ID 23151 //
     /*  360408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  360450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360464 */     GIR_RootConstrainSelectedInstOperands,
     /*  360465 */     // GIR_Coverage, 23151,
     /*  360465 */     GIR_EraseRootFromParent_Done,
     /*  360466 */   // Label 6527: @360466
     /*  360466 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(360529), // Rule ID 23152 //
     /*  360471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  360513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360527 */     GIR_RootConstrainSelectedInstOperands,
     /*  360528 */     // GIR_Coverage, 23152,
     /*  360528 */     GIR_EraseRootFromParent_Done,
     /*  360529 */   // Label 6528: @360529
     /*  360529 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(360592), // Rule ID 23153 //
     /*  360534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360573 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  360576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360590 */     GIR_RootConstrainSelectedInstOperands,
     /*  360591 */     // GIR_Coverage, 23153,
     /*  360591 */     GIR_EraseRootFromParent_Done,
     /*  360592 */   // Label 6529: @360592
     /*  360592 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(360655), // Rule ID 23154 //
     /*  360597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  360639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360653 */     GIR_RootConstrainSelectedInstOperands,
     /*  360654 */     // GIR_Coverage, 23154,
     /*  360654 */     GIR_EraseRootFromParent_Done,
     /*  360655 */   // Label 6530: @360655
     /*  360655 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(360718), // Rule ID 23155 //
     /*  360660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360699 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  360702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360716 */     GIR_RootConstrainSelectedInstOperands,
     /*  360717 */     // GIR_Coverage, 23155,
     /*  360717 */     GIR_EraseRootFromParent_Done,
     /*  360718 */   // Label 6531: @360718
     /*  360718 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(360781), // Rule ID 23156 //
     /*  360723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360762 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  360765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360779 */     GIR_RootConstrainSelectedInstOperands,
     /*  360780 */     // GIR_Coverage, 23156,
     /*  360780 */     GIR_EraseRootFromParent_Done,
     /*  360781 */   // Label 6532: @360781
     /*  360781 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(360844), // Rule ID 23157 //
     /*  360786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  360794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360825 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  360828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360842 */     GIR_RootConstrainSelectedInstOperands,
     /*  360843 */     // GIR_Coverage, 23157,
     /*  360843 */     GIR_EraseRootFromParent_Done,
     /*  360844 */   // Label 6533: @360844
     /*  360844 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(360907), // Rule ID 23158 //
     /*  360849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360888 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  360891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360905 */     GIR_RootConstrainSelectedInstOperands,
     /*  360906 */     // GIR_Coverage, 23158,
     /*  360906 */     GIR_EraseRootFromParent_Done,
     /*  360907 */   // Label 6534: @360907
     /*  360907 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(360970), // Rule ID 23159 //
     /*  360912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360951 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  360954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360968 */     GIR_RootConstrainSelectedInstOperands,
     /*  360969 */     // GIR_Coverage, 23159,
     /*  360969 */     GIR_EraseRootFromParent_Done,
     /*  360970 */   // Label 6535: @360970
     /*  360970 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(361033), // Rule ID 23160 //
     /*  360975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  360983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361014 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  361017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361031 */     GIR_RootConstrainSelectedInstOperands,
     /*  361032 */     // GIR_Coverage, 23160,
     /*  361032 */     GIR_EraseRootFromParent_Done,
     /*  361033 */   // Label 6536: @361033
     /*  361033 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(361096), // Rule ID 23161 //
     /*  361038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361077 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  361080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361094 */     GIR_RootConstrainSelectedInstOperands,
     /*  361095 */     // GIR_Coverage, 23161,
     /*  361095 */     GIR_EraseRootFromParent_Done,
     /*  361096 */   // Label 6537: @361096
     /*  361096 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(361159), // Rule ID 23162 //
     /*  361101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  361143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361157 */     GIR_RootConstrainSelectedInstOperands,
     /*  361158 */     // GIR_Coverage, 23162,
     /*  361158 */     GIR_EraseRootFromParent_Done,
     /*  361159 */   // Label 6538: @361159
     /*  361159 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(361222), // Rule ID 23163 //
     /*  361164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  361206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361220 */     GIR_RootConstrainSelectedInstOperands,
     /*  361221 */     // GIR_Coverage, 23163,
     /*  361221 */     GIR_EraseRootFromParent_Done,
     /*  361222 */   // Label 6539: @361222
     /*  361222 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(361285), // Rule ID 23164 //
     /*  361227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  361269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361283 */     GIR_RootConstrainSelectedInstOperands,
     /*  361284 */     // GIR_Coverage, 23164,
     /*  361284 */     GIR_EraseRootFromParent_Done,
     /*  361285 */   // Label 6540: @361285
     /*  361285 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(361348), // Rule ID 23165 //
     /*  361290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361329 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  361332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361346 */     GIR_RootConstrainSelectedInstOperands,
     /*  361347 */     // GIR_Coverage, 23165,
     /*  361347 */     GIR_EraseRootFromParent_Done,
     /*  361348 */   // Label 6541: @361348
     /*  361348 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(361411), // Rule ID 23166 //
     /*  361353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  361395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361409 */     GIR_RootConstrainSelectedInstOperands,
     /*  361410 */     // GIR_Coverage, 23166,
     /*  361410 */     GIR_EraseRootFromParent_Done,
     /*  361411 */   // Label 6542: @361411
     /*  361411 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(361474), // Rule ID 23167 //
     /*  361416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361455 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  361458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361472 */     GIR_RootConstrainSelectedInstOperands,
     /*  361473 */     // GIR_Coverage, 23167,
     /*  361473 */     GIR_EraseRootFromParent_Done,
     /*  361474 */   // Label 6543: @361474
     /*  361474 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(361537), // Rule ID 23168 //
     /*  361479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  361521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361535 */     GIR_RootConstrainSelectedInstOperands,
     /*  361536 */     // GIR_Coverage, 23168,
     /*  361536 */     GIR_EraseRootFromParent_Done,
     /*  361537 */   // Label 6544: @361537
     /*  361537 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(361600), // Rule ID 23169 //
     /*  361542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361581 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  361584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361598 */     GIR_RootConstrainSelectedInstOperands,
     /*  361599 */     // GIR_Coverage, 23169,
     /*  361599 */     GIR_EraseRootFromParent_Done,
     /*  361600 */   // Label 6545: @361600
     /*  361600 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(361663), // Rule ID 23170 //
     /*  361605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361644 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  361647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361661 */     GIR_RootConstrainSelectedInstOperands,
     /*  361662 */     // GIR_Coverage, 23170,
     /*  361662 */     GIR_EraseRootFromParent_Done,
     /*  361663 */   // Label 6546: @361663
     /*  361663 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(361726), // Rule ID 23171 //
     /*  361668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  361676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361707 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  361710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361724 */     GIR_RootConstrainSelectedInstOperands,
     /*  361725 */     // GIR_Coverage, 23171,
     /*  361725 */     GIR_EraseRootFromParent_Done,
     /*  361726 */   // Label 6547: @361726
     /*  361726 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(361789), // Rule ID 23172 //
     /*  361731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361770 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  361773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361787 */     GIR_RootConstrainSelectedInstOperands,
     /*  361788 */     // GIR_Coverage, 23172,
     /*  361788 */     GIR_EraseRootFromParent_Done,
     /*  361789 */   // Label 6548: @361789
     /*  361789 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(361852), // Rule ID 23173 //
     /*  361794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361833 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  361836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361850 */     GIR_RootConstrainSelectedInstOperands,
     /*  361851 */     // GIR_Coverage, 23173,
     /*  361851 */     GIR_EraseRootFromParent_Done,
     /*  361852 */   // Label 6549: @361852
     /*  361852 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(361915), // Rule ID 23174 //
     /*  361857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  361899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361913 */     GIR_RootConstrainSelectedInstOperands,
     /*  361914 */     // GIR_Coverage, 23174,
     /*  361914 */     GIR_EraseRootFromParent_Done,
     /*  361915 */   // Label 6550: @361915
     /*  361915 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(361978), // Rule ID 23175 //
     /*  361920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361959 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  361962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361976 */     GIR_RootConstrainSelectedInstOperands,
     /*  361977 */     // GIR_Coverage, 23175,
     /*  361977 */     GIR_EraseRootFromParent_Done,
     /*  361978 */   // Label 6551: @361978
     /*  361978 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(362041), // Rule ID 23176 //
     /*  361983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  361991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  362025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362039 */     GIR_RootConstrainSelectedInstOperands,
     /*  362040 */     // GIR_Coverage, 23176,
     /*  362040 */     GIR_EraseRootFromParent_Done,
     /*  362041 */   // Label 6552: @362041
     /*  362041 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(362104), // Rule ID 23177 //
     /*  362046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362085 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  362088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362102 */     GIR_RootConstrainSelectedInstOperands,
     /*  362103 */     // GIR_Coverage, 23177,
     /*  362103 */     GIR_EraseRootFromParent_Done,
     /*  362104 */   // Label 6553: @362104
     /*  362104 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(362167), // Rule ID 23178 //
     /*  362109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  362151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362165 */     GIR_RootConstrainSelectedInstOperands,
     /*  362166 */     // GIR_Coverage, 23178,
     /*  362166 */     GIR_EraseRootFromParent_Done,
     /*  362167 */   // Label 6554: @362167
     /*  362167 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(362230), // Rule ID 23179 //
     /*  362172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362211 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  362214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362228 */     GIR_RootConstrainSelectedInstOperands,
     /*  362229 */     // GIR_Coverage, 23179,
     /*  362229 */     GIR_EraseRootFromParent_Done,
     /*  362230 */   // Label 6555: @362230
     /*  362230 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(362293), // Rule ID 23180 //
     /*  362235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  362277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362291 */     GIR_RootConstrainSelectedInstOperands,
     /*  362292 */     // GIR_Coverage, 23180,
     /*  362292 */     GIR_EraseRootFromParent_Done,
     /*  362293 */   // Label 6556: @362293
     /*  362293 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(362356), // Rule ID 23181 //
     /*  362298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  362340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362354 */     GIR_RootConstrainSelectedInstOperands,
     /*  362355 */     // GIR_Coverage, 23181,
     /*  362355 */     GIR_EraseRootFromParent_Done,
     /*  362356 */   // Label 6557: @362356
     /*  362356 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(362419), // Rule ID 23182 //
     /*  362361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  362403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362417 */     GIR_RootConstrainSelectedInstOperands,
     /*  362418 */     // GIR_Coverage, 23182,
     /*  362418 */     GIR_EraseRootFromParent_Done,
     /*  362419 */   // Label 6558: @362419
     /*  362419 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(362482), // Rule ID 23183 //
     /*  362424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362463 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  362466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362480 */     GIR_RootConstrainSelectedInstOperands,
     /*  362481 */     // GIR_Coverage, 23183,
     /*  362481 */     GIR_EraseRootFromParent_Done,
     /*  362482 */   // Label 6559: @362482
     /*  362482 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(362545), // Rule ID 23184 //
     /*  362487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362526 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  362529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362543 */     GIR_RootConstrainSelectedInstOperands,
     /*  362544 */     // GIR_Coverage, 23184,
     /*  362544 */     GIR_EraseRootFromParent_Done,
     /*  362545 */   // Label 6560: @362545
     /*  362545 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(362608), // Rule ID 23185 //
     /*  362550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  362558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362589 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  362592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362606 */     GIR_RootConstrainSelectedInstOperands,
     /*  362607 */     // GIR_Coverage, 23185,
     /*  362607 */     GIR_EraseRootFromParent_Done,
     /*  362608 */   // Label 6561: @362608
     /*  362608 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(362671), // Rule ID 23186 //
     /*  362613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  362655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362669 */     GIR_RootConstrainSelectedInstOperands,
     /*  362670 */     // GIR_Coverage, 23186,
     /*  362670 */     GIR_EraseRootFromParent_Done,
     /*  362671 */   // Label 6562: @362671
     /*  362671 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(362734), // Rule ID 23187 //
     /*  362676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362715 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  362718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362732 */     GIR_RootConstrainSelectedInstOperands,
     /*  362733 */     // GIR_Coverage, 23187,
     /*  362733 */     GIR_EraseRootFromParent_Done,
     /*  362734 */   // Label 6563: @362734
     /*  362734 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(362797), // Rule ID 23188 //
     /*  362739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  362781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362795 */     GIR_RootConstrainSelectedInstOperands,
     /*  362796 */     // GIR_Coverage, 23188,
     /*  362796 */     GIR_EraseRootFromParent_Done,
     /*  362797 */   // Label 6564: @362797
     /*  362797 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(362860), // Rule ID 23189 //
     /*  362802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362841 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  362844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362858 */     GIR_RootConstrainSelectedInstOperands,
     /*  362859 */     // GIR_Coverage, 23189,
     /*  362859 */     GIR_EraseRootFromParent_Done,
     /*  362860 */   // Label 6565: @362860
     /*  362860 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(362923), // Rule ID 23190 //
     /*  362865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  362907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362921 */     GIR_RootConstrainSelectedInstOperands,
     /*  362922 */     // GIR_Coverage, 23190,
     /*  362922 */     GIR_EraseRootFromParent_Done,
     /*  362923 */   // Label 6566: @362923
     /*  362923 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(362986), // Rule ID 23191 //
     /*  362928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  362970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362984 */     GIR_RootConstrainSelectedInstOperands,
     /*  362985 */     // GIR_Coverage, 23191,
     /*  362985 */     GIR_EraseRootFromParent_Done,
     /*  362986 */   // Label 6567: @362986
     /*  362986 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(363049), // Rule ID 23192 //
     /*  362991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  362999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363030 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  363033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363047 */     GIR_RootConstrainSelectedInstOperands,
     /*  363048 */     // GIR_Coverage, 23192,
     /*  363048 */     GIR_EraseRootFromParent_Done,
     /*  363049 */   // Label 6568: @363049
     /*  363049 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(363112), // Rule ID 23193 //
     /*  363054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363093 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  363096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363110 */     GIR_RootConstrainSelectedInstOperands,
     /*  363111 */     // GIR_Coverage, 23193,
     /*  363111 */     GIR_EraseRootFromParent_Done,
     /*  363112 */   // Label 6569: @363112
     /*  363112 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(363175), // Rule ID 23194 //
     /*  363117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  363159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363173 */     GIR_RootConstrainSelectedInstOperands,
     /*  363174 */     // GIR_Coverage, 23194,
     /*  363174 */     GIR_EraseRootFromParent_Done,
     /*  363175 */   // Label 6570: @363175
     /*  363175 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(363238), // Rule ID 23195 //
     /*  363180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  363191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363219 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  363222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363236 */     GIR_RootConstrainSelectedInstOperands,
     /*  363237 */     // GIR_Coverage, 23195,
     /*  363237 */     GIR_EraseRootFromParent_Done,
     /*  363238 */   // Label 6571: @363238
     /*  363238 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(363301), // Rule ID 23196 //
     /*  363243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363282 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  363285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363299 */     GIR_RootConstrainSelectedInstOperands,
     /*  363300 */     // GIR_Coverage, 23196,
     /*  363300 */     GIR_EraseRootFromParent_Done,
     /*  363301 */   // Label 6572: @363301
     /*  363301 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(363364), // Rule ID 23197 //
     /*  363306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363345 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  363348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363362 */     GIR_RootConstrainSelectedInstOperands,
     /*  363363 */     // GIR_Coverage, 23197,
     /*  363363 */     GIR_EraseRootFromParent_Done,
     /*  363364 */   // Label 6573: @363364
     /*  363364 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(363427), // Rule ID 23198 //
     /*  363369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363408 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  363411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363425 */     GIR_RootConstrainSelectedInstOperands,
     /*  363426 */     // GIR_Coverage, 23198,
     /*  363426 */     GIR_EraseRootFromParent_Done,
     /*  363427 */   // Label 6574: @363427
     /*  363427 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(363490), // Rule ID 23199 //
     /*  363432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  363440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363471 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  363474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363488 */     GIR_RootConstrainSelectedInstOperands,
     /*  363489 */     // GIR_Coverage, 23199,
     /*  363489 */     GIR_EraseRootFromParent_Done,
     /*  363490 */   // Label 6575: @363490
     /*  363490 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(363553), // Rule ID 23200 //
     /*  363495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  363506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  363537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363551 */     GIR_RootConstrainSelectedInstOperands,
     /*  363552 */     // GIR_Coverage, 23200,
     /*  363552 */     GIR_EraseRootFromParent_Done,
     /*  363553 */   // Label 6576: @363553
     /*  363553 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(363616), // Rule ID 23201 //
     /*  363558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  363569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363597 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  363600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363614 */     GIR_RootConstrainSelectedInstOperands,
     /*  363615 */     // GIR_Coverage, 23201,
     /*  363615 */     GIR_EraseRootFromParent_Done,
     /*  363616 */   // Label 6577: @363616
     /*  363616 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(363679), // Rule ID 23202 //
     /*  363621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  363632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  363663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363677 */     GIR_RootConstrainSelectedInstOperands,
     /*  363678 */     // GIR_Coverage, 23202,
     /*  363678 */     GIR_EraseRootFromParent_Done,
     /*  363679 */   // Label 6578: @363679
     /*  363679 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(363742), // Rule ID 23203 //
     /*  363684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  363695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  363726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363740 */     GIR_RootConstrainSelectedInstOperands,
     /*  363741 */     // GIR_Coverage, 23203,
     /*  363741 */     GIR_EraseRootFromParent_Done,
     /*  363742 */   // Label 6579: @363742
     /*  363742 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(363805), // Rule ID 23204 //
     /*  363747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363786 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  363789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363803 */     GIR_RootConstrainSelectedInstOperands,
     /*  363804 */     // GIR_Coverage, 23204,
     /*  363804 */     GIR_EraseRootFromParent_Done,
     /*  363805 */   // Label 6580: @363805
     /*  363805 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(363868), // Rule ID 23205 //
     /*  363810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  363821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363849 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  363852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363866 */     GIR_RootConstrainSelectedInstOperands,
     /*  363867 */     // GIR_Coverage, 23205,
     /*  363867 */     GIR_EraseRootFromParent_Done,
     /*  363868 */   // Label 6581: @363868
     /*  363868 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(363931), // Rule ID 23206 //
     /*  363873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  363915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363929 */     GIR_RootConstrainSelectedInstOperands,
     /*  363930 */     // GIR_Coverage, 23206,
     /*  363930 */     GIR_EraseRootFromParent_Done,
     /*  363931 */   // Label 6582: @363931
     /*  363931 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(363994), // Rule ID 23207 //
     /*  363936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  363944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  363947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363975 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  363978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363992 */     GIR_RootConstrainSelectedInstOperands,
     /*  363993 */     // GIR_Coverage, 23207,
     /*  363993 */     GIR_EraseRootFromParent_Done,
     /*  363994 */   // Label 6583: @363994
     /*  363994 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(364057), // Rule ID 23208 //
     /*  363999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  364041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364055 */     GIR_RootConstrainSelectedInstOperands,
     /*  364056 */     // GIR_Coverage, 23208,
     /*  364056 */     GIR_EraseRootFromParent_Done,
     /*  364057 */   // Label 6584: @364057
     /*  364057 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(364120), // Rule ID 23209 //
     /*  364062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364101 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  364104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364118 */     GIR_RootConstrainSelectedInstOperands,
     /*  364119 */     // GIR_Coverage, 23209,
     /*  364119 */     GIR_EraseRootFromParent_Done,
     /*  364120 */   // Label 6585: @364120
     /*  364120 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(364183), // Rule ID 23210 //
     /*  364125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  364136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364164 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  364167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364181 */     GIR_RootConstrainSelectedInstOperands,
     /*  364182 */     // GIR_Coverage, 23210,
     /*  364182 */     GIR_EraseRootFromParent_Done,
     /*  364183 */   // Label 6586: @364183
     /*  364183 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(364246), // Rule ID 23211 //
     /*  364188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  364199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364227 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  364230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364244 */     GIR_RootConstrainSelectedInstOperands,
     /*  364245 */     // GIR_Coverage, 23211,
     /*  364245 */     GIR_EraseRootFromParent_Done,
     /*  364246 */   // Label 6587: @364246
     /*  364246 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(364309), // Rule ID 23212 //
     /*  364251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  364262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364290 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  364293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364307 */     GIR_RootConstrainSelectedInstOperands,
     /*  364308 */     // GIR_Coverage, 23212,
     /*  364308 */     GIR_EraseRootFromParent_Done,
     /*  364309 */   // Label 6588: @364309
     /*  364309 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(364372), // Rule ID 23213 //
     /*  364314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  364322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  364325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364353 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11377:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  364356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364370 */     GIR_RootConstrainSelectedInstOperands,
     /*  364371 */     // GIR_Coverage, 23213,
     /*  364371 */     GIR_EraseRootFromParent_Done,
     /*  364372 */   // Label 6589: @364372
     /*  364372 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(364435), // Rule ID 23214 //
     /*  364377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  364388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  364419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364433 */     GIR_RootConstrainSelectedInstOperands,
     /*  364434 */     // GIR_Coverage, 23214,
     /*  364434 */     GIR_EraseRootFromParent_Done,
     /*  364435 */   // Label 6590: @364435
     /*  364435 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(364498), // Rule ID 23215 //
     /*  364440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  364451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364479 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  364482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364496 */     GIR_RootConstrainSelectedInstOperands,
     /*  364497 */     // GIR_Coverage, 23215,
     /*  364497 */     GIR_EraseRootFromParent_Done,
     /*  364498 */   // Label 6591: @364498
     /*  364498 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(364561), // Rule ID 23216 //
     /*  364503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  364514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  364545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364559 */     GIR_RootConstrainSelectedInstOperands,
     /*  364560 */     // GIR_Coverage, 23216,
     /*  364560 */     GIR_EraseRootFromParent_Done,
     /*  364561 */   // Label 6592: @364561
     /*  364561 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(364624), // Rule ID 23217 //
     /*  364566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  364577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  364608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364622 */     GIR_RootConstrainSelectedInstOperands,
     /*  364623 */     // GIR_Coverage, 23217,
     /*  364623 */     GIR_EraseRootFromParent_Done,
     /*  364624 */   // Label 6593: @364624
     /*  364624 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(364687), // Rule ID 23218 //
     /*  364629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  364640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  364671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364685 */     GIR_RootConstrainSelectedInstOperands,
     /*  364686 */     // GIR_Coverage, 23218,
     /*  364686 */     GIR_EraseRootFromParent_Done,
     /*  364687 */   // Label 6594: @364687
     /*  364687 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(364750), // Rule ID 23219 //
     /*  364692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  364703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  364734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364748 */     GIR_RootConstrainSelectedInstOperands,
     /*  364749 */     // GIR_Coverage, 23219,
     /*  364749 */     GIR_EraseRootFromParent_Done,
     /*  364750 */   // Label 6595: @364750
     /*  364750 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(364813), // Rule ID 23220 //
     /*  364755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  364766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  364797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364811 */     GIR_RootConstrainSelectedInstOperands,
     /*  364812 */     // GIR_Coverage, 23220,
     /*  364812 */     GIR_EraseRootFromParent_Done,
     /*  364813 */   // Label 6596: @364813
     /*  364813 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(364876), // Rule ID 23221 //
     /*  364818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  364829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  364860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364874 */     GIR_RootConstrainSelectedInstOperands,
     /*  364875 */     // GIR_Coverage, 23221,
     /*  364875 */     GIR_EraseRootFromParent_Done,
     /*  364876 */   // Label 6597: @364876
     /*  364876 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(364939), // Rule ID 23222 //
     /*  364881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  364923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364937 */     GIR_RootConstrainSelectedInstOperands,
     /*  364938 */     // GIR_Coverage, 23222,
     /*  364938 */     GIR_EraseRootFromParent_Done,
     /*  364939 */   // Label 6598: @364939
     /*  364939 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(365002), // Rule ID 23223 //
     /*  364944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  364952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  364955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  364986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365000 */     GIR_RootConstrainSelectedInstOperands,
     /*  365001 */     // GIR_Coverage, 23223,
     /*  365001 */     GIR_EraseRootFromParent_Done,
     /*  365002 */   // Label 6599: @365002
     /*  365002 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(365065), // Rule ID 23224 //
     /*  365007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  365049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365063 */     GIR_RootConstrainSelectedInstOperands,
     /*  365064 */     // GIR_Coverage, 23224,
     /*  365064 */     GIR_EraseRootFromParent_Done,
     /*  365065 */   // Label 6600: @365065
     /*  365065 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(365128), // Rule ID 23225 //
     /*  365070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365109 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  365112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365126 */     GIR_RootConstrainSelectedInstOperands,
     /*  365127 */     // GIR_Coverage, 23225,
     /*  365127 */     GIR_EraseRootFromParent_Done,
     /*  365128 */   // Label 6601: @365128
     /*  365128 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(365191), // Rule ID 23226 //
     /*  365133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  365144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365172 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  365175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365189 */     GIR_RootConstrainSelectedInstOperands,
     /*  365190 */     // GIR_Coverage, 23226,
     /*  365190 */     GIR_EraseRootFromParent_Done,
     /*  365191 */   // Label 6602: @365191
     /*  365191 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(365254), // Rule ID 23227 //
     /*  365196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  365204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  365207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  365210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365235 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  365238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365252 */     GIR_RootConstrainSelectedInstOperands,
     /*  365253 */     // GIR_Coverage, 23227,
     /*  365253 */     GIR_EraseRootFromParent_Done,
     /*  365254 */   // Label 6603: @365254
     /*  365254 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(365317), // Rule ID 23228 //
     /*  365259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  365270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  365273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  365301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365315 */     GIR_RootConstrainSelectedInstOperands,
     /*  365316 */     // GIR_Coverage, 23228,
     /*  365316 */     GIR_EraseRootFromParent_Done,
     /*  365317 */   // Label 6604: @365317
     /*  365317 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(365380), // Rule ID 23229 //
     /*  365322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  365333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  365336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365361 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  365364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365378 */     GIR_RootConstrainSelectedInstOperands,
     /*  365379 */     // GIR_Coverage, 23229,
     /*  365379 */     GIR_EraseRootFromParent_Done,
     /*  365380 */   // Label 6605: @365380
     /*  365380 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(365443), // Rule ID 23230 //
     /*  365385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  365396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  365399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  365427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365441 */     GIR_RootConstrainSelectedInstOperands,
     /*  365442 */     // GIR_Coverage, 23230,
     /*  365442 */     GIR_EraseRootFromParent_Done,
     /*  365443 */   // Label 6606: @365443
     /*  365443 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(365506), // Rule ID 23231 //
     /*  365448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  365459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  365462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  365490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365504 */     GIR_RootConstrainSelectedInstOperands,
     /*  365505 */     // GIR_Coverage, 23231,
     /*  365505 */     GIR_EraseRootFromParent_Done,
     /*  365506 */   // Label 6607: @365506
     /*  365506 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(365569), // Rule ID 23232 //
     /*  365511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  365522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  365525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  365553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365567 */     GIR_RootConstrainSelectedInstOperands,
     /*  365568 */     // GIR_Coverage, 23232,
     /*  365568 */     GIR_EraseRootFromParent_Done,
     /*  365569 */   // Label 6608: @365569
     /*  365569 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(365632), // Rule ID 23233 //
     /*  365574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  365585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  365588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365613 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  365616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365630 */     GIR_RootConstrainSelectedInstOperands,
     /*  365631 */     // GIR_Coverage, 23233,
     /*  365631 */     GIR_EraseRootFromParent_Done,
     /*  365632 */   // Label 6609: @365632
     /*  365632 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(365695), // Rule ID 23234 //
     /*  365637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  365648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  365651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  365679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365693 */     GIR_RootConstrainSelectedInstOperands,
     /*  365694 */     // GIR_Coverage, 23234,
     /*  365694 */     GIR_EraseRootFromParent_Done,
     /*  365695 */   // Label 6610: @365695
     /*  365695 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(365758), // Rule ID 23235 //
     /*  365700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  365711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  365714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  365742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365756 */     GIR_RootConstrainSelectedInstOperands,
     /*  365757 */     // GIR_Coverage, 23235,
     /*  365757 */     GIR_EraseRootFromParent_Done,
     /*  365758 */   // Label 6611: @365758
     /*  365758 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(365821), // Rule ID 23236 //
     /*  365763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  365774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  365777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  365805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365819 */     GIR_RootConstrainSelectedInstOperands,
     /*  365820 */     // GIR_Coverage, 23236,
     /*  365820 */     GIR_EraseRootFromParent_Done,
     /*  365821 */   // Label 6612: @365821
     /*  365821 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(365884), // Rule ID 23237 //
     /*  365826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  365837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  365840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  365868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365882 */     GIR_RootConstrainSelectedInstOperands,
     /*  365883 */     // GIR_Coverage, 23237,
     /*  365883 */     GIR_EraseRootFromParent_Done,
     /*  365884 */   // Label 6613: @365884
     /*  365884 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(365947), // Rule ID 23238 //
     /*  365889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  365928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  365931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365945 */     GIR_RootConstrainSelectedInstOperands,
     /*  365946 */     // GIR_Coverage, 23238,
     /*  365946 */     GIR_EraseRootFromParent_Done,
     /*  365947 */   // Label 6614: @365947
     /*  365947 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(366010), // Rule ID 23239 //
     /*  365952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  365960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  365963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  365966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365991 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  365991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  365994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  365998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366008 */     GIR_RootConstrainSelectedInstOperands,
     /*  366009 */     // GIR_Coverage, 23239,
     /*  366009 */     GIR_EraseRootFromParent_Done,
     /*  366010 */   // Label 6615: @366010
     /*  366010 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(366073), // Rule ID 23240 //
     /*  366015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  366023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366054 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  366057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366071 */     GIR_RootConstrainSelectedInstOperands,
     /*  366072 */     // GIR_Coverage, 23240,
     /*  366072 */     GIR_EraseRootFromParent_Done,
     /*  366073 */   // Label 6616: @366073
     /*  366073 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(366136), // Rule ID 23241 //
     /*  366078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  366086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366117 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  366120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366134 */     GIR_RootConstrainSelectedInstOperands,
     /*  366135 */     // GIR_Coverage, 23241,
     /*  366135 */     GIR_EraseRootFromParent_Done,
     /*  366136 */   // Label 6617: @366136
     /*  366136 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(366199), // Rule ID 23242 //
     /*  366141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  366152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  366155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  366183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366197 */     GIR_RootConstrainSelectedInstOperands,
     /*  366198 */     // GIR_Coverage, 23242,
     /*  366198 */     GIR_EraseRootFromParent_Done,
     /*  366199 */   // Label 6618: @366199
     /*  366199 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(366262), // Rule ID 23243 //
     /*  366204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  366215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  366218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  366221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  366246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366260 */     GIR_RootConstrainSelectedInstOperands,
     /*  366261 */     // GIR_Coverage, 23243,
     /*  366261 */     GIR_EraseRootFromParent_Done,
     /*  366262 */   // Label 6619: @366262
     /*  366262 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(366325), // Rule ID 23244 //
     /*  366267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  366278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  366281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  366309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366323 */     GIR_RootConstrainSelectedInstOperands,
     /*  366324 */     // GIR_Coverage, 23244,
     /*  366324 */     GIR_EraseRootFromParent_Done,
     /*  366325 */   // Label 6620: @366325
     /*  366325 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(366388), // Rule ID 23245 //
     /*  366330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  366341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  366344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  366372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366386 */     GIR_RootConstrainSelectedInstOperands,
     /*  366387 */     // GIR_Coverage, 23245,
     /*  366387 */     GIR_EraseRootFromParent_Done,
     /*  366388 */   // Label 6621: @366388
     /*  366388 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(366451), // Rule ID 23246 //
     /*  366393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  366404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  366407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366432 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  366435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366449 */     GIR_RootConstrainSelectedInstOperands,
     /*  366450 */     // GIR_Coverage, 23246,
     /*  366450 */     GIR_EraseRootFromParent_Done,
     /*  366451 */   // Label 6622: @366451
     /*  366451 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(366514), // Rule ID 23247 //
     /*  366456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  366467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  366470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  366498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366512 */     GIR_RootConstrainSelectedInstOperands,
     /*  366513 */     // GIR_Coverage, 23247,
     /*  366513 */     GIR_EraseRootFromParent_Done,
     /*  366514 */   // Label 6623: @366514
     /*  366514 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(366577), // Rule ID 23248 //
     /*  366519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  366530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  366533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  366561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366575 */     GIR_RootConstrainSelectedInstOperands,
     /*  366576 */     // GIR_Coverage, 23248,
     /*  366576 */     GIR_EraseRootFromParent_Done,
     /*  366577 */   // Label 6624: @366577
     /*  366577 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(366640), // Rule ID 23249 //
     /*  366582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  366593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  366596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366621 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  366624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366638 */     GIR_RootConstrainSelectedInstOperands,
     /*  366639 */     // GIR_Coverage, 23249,
     /*  366639 */     GIR_EraseRootFromParent_Done,
     /*  366640 */   // Label 6625: @366640
     /*  366640 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(366703), // Rule ID 23250 //
     /*  366645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  366656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  366659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  366687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366701 */     GIR_RootConstrainSelectedInstOperands,
     /*  366702 */     // GIR_Coverage, 23250,
     /*  366702 */     GIR_EraseRootFromParent_Done,
     /*  366703 */   // Label 6626: @366703
     /*  366703 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(366766), // Rule ID 23251 //
     /*  366708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  366719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  366722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366747 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  366750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366764 */     GIR_RootConstrainSelectedInstOperands,
     /*  366765 */     // GIR_Coverage, 23251,
     /*  366765 */     GIR_EraseRootFromParent_Done,
     /*  366766 */   // Label 6627: @366766
     /*  366766 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(366829), // Rule ID 23252 //
     /*  366771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  366782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  366785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366810 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  366813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366827 */     GIR_RootConstrainSelectedInstOperands,
     /*  366828 */     // GIR_Coverage, 23252,
     /*  366828 */     GIR_EraseRootFromParent_Done,
     /*  366829 */   // Label 6628: @366829
     /*  366829 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(366892), // Rule ID 23253 //
     /*  366834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  366845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  366848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366873 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  366876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366890 */     GIR_RootConstrainSelectedInstOperands,
     /*  366891 */     // GIR_Coverage, 23253,
     /*  366891 */     GIR_EraseRootFromParent_Done,
     /*  366892 */   // Label 6629: @366892
     /*  366892 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(366955), // Rule ID 23254 //
     /*  366897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366936 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  366936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  366939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  366943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366953 */     GIR_RootConstrainSelectedInstOperands,
     /*  366954 */     // GIR_Coverage, 23254,
     /*  366954 */     GIR_EraseRootFromParent_Done,
     /*  366955 */   // Label 6630: @366955
     /*  366955 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(367018), // Rule ID 23255 //
     /*  366960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  366968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  366971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  366974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366999 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  366999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  367002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367016 */     GIR_RootConstrainSelectedInstOperands,
     /*  367017 */     // GIR_Coverage, 23255,
     /*  367017 */     GIR_EraseRootFromParent_Done,
     /*  367018 */   // Label 6631: @367018
     /*  367018 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(367081), // Rule ID 23284 //
     /*  367023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367062 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  367065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367079 */     GIR_RootConstrainSelectedInstOperands,
     /*  367080 */     // GIR_Coverage, 23284,
     /*  367080 */     GIR_EraseRootFromParent_Done,
     /*  367081 */   // Label 6632: @367081
     /*  367081 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(367144), // Rule ID 23285 //
     /*  367086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367125 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  367128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367132 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367142 */     GIR_RootConstrainSelectedInstOperands,
     /*  367143 */     // GIR_Coverage, 23285,
     /*  367143 */     GIR_EraseRootFromParent_Done,
     /*  367144 */   // Label 6633: @367144
     /*  367144 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(367207), // Rule ID 23288 //
     /*  367149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  367163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367188 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  367191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367195 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367205 */     GIR_RootConstrainSelectedInstOperands,
     /*  367206 */     // GIR_Coverage, 23288,
     /*  367206 */     GIR_EraseRootFromParent_Done,
     /*  367207 */   // Label 6634: @367207
     /*  367207 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(367270), // Rule ID 23289 //
     /*  367212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  367226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367251 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  367254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367258 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367268 */     GIR_RootConstrainSelectedInstOperands,
     /*  367269 */     // GIR_Coverage, 23289,
     /*  367269 */     GIR_EraseRootFromParent_Done,
     /*  367270 */   // Label 6635: @367270
     /*  367270 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(367333), // Rule ID 23292 //
     /*  367275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  367289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367314 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  367317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367321 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367331 */     GIR_RootConstrainSelectedInstOperands,
     /*  367332 */     // GIR_Coverage, 23292,
     /*  367332 */     GIR_EraseRootFromParent_Done,
     /*  367333 */   // Label 6636: @367333
     /*  367333 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(367396), // Rule ID 23293 //
     /*  367338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  367352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367377 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  367380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367384 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367394 */     GIR_RootConstrainSelectedInstOperands,
     /*  367395 */     // GIR_Coverage, 23293,
     /*  367395 */     GIR_EraseRootFromParent_Done,
     /*  367396 */   // Label 6637: @367396
     /*  367396 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(367459), // Rule ID 23296 //
     /*  367401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  367415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367440 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  367443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367447 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367457 */     GIR_RootConstrainSelectedInstOperands,
     /*  367458 */     // GIR_Coverage, 23296,
     /*  367458 */     GIR_EraseRootFromParent_Done,
     /*  367459 */   // Label 6638: @367459
     /*  367459 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(367522), // Rule ID 23297 //
     /*  367464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  367478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367503 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  367506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367510 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367520 */     GIR_RootConstrainSelectedInstOperands,
     /*  367521 */     // GIR_Coverage, 23297,
     /*  367521 */     GIR_EraseRootFromParent_Done,
     /*  367522 */   // Label 6639: @367522
     /*  367522 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(367585), // Rule ID 23300 //
     /*  367527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  367541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367566 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  367569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367573 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367583 */     GIR_RootConstrainSelectedInstOperands,
     /*  367584 */     // GIR_Coverage, 23300,
     /*  367584 */     GIR_EraseRootFromParent_Done,
     /*  367585 */   // Label 6640: @367585
     /*  367585 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(367648), // Rule ID 23301 //
     /*  367590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  367604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  367607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367629 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  367632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367636 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367646 */     GIR_RootConstrainSelectedInstOperands,
     /*  367647 */     // GIR_Coverage, 23301,
     /*  367647 */     GIR_EraseRootFromParent_Done,
     /*  367648 */   // Label 6641: @367648
     /*  367648 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(367711), // Rule ID 23304 //
     /*  367653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  367667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  367670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367692 */     // (intrinsic_wo_chain:{ *:[i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  367695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367699 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367709 */     GIR_RootConstrainSelectedInstOperands,
     /*  367710 */     // GIR_Coverage, 23304,
     /*  367710 */     GIR_EraseRootFromParent_Done,
     /*  367711 */   // Label 6642: @367711
     /*  367711 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(367774), // Rule ID 23305 //
     /*  367716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  367724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  367730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  367733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367755 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  367758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367762 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367772 */     GIR_RootConstrainSelectedInstOperands,
     /*  367773 */     // GIR_Coverage, 23305,
     /*  367773 */     GIR_EraseRootFromParent_Done,
     /*  367774 */   // Label 6643: @367774
     /*  367774 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(367837), // Rule ID 23308 //
     /*  367779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  367793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  367796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367818 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  367821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367825 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367835 */     GIR_RootConstrainSelectedInstOperands,
     /*  367836 */     // GIR_Coverage, 23308,
     /*  367836 */     GIR_EraseRootFromParent_Done,
     /*  367837 */   // Label 6644: @367837
     /*  367837 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(367900), // Rule ID 23309 //
     /*  367842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  367856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  367859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367881 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  367881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  367884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367888 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367898 */     GIR_RootConstrainSelectedInstOperands,
     /*  367899 */     // GIR_Coverage, 23309,
     /*  367899 */     GIR_EraseRootFromParent_Done,
     /*  367900 */   // Label 6645: @367900
     /*  367900 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(367963), // Rule ID 23312 //
     /*  367905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  367908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  367916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  367937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367944 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  367944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  367947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  367951 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  367953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367961 */     GIR_RootConstrainSelectedInstOperands,
     /*  367962 */     // GIR_Coverage, 23312,
     /*  367962 */     GIR_EraseRootFromParent_Done,
     /*  367963 */   // Label 6646: @367963
     /*  367963 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(368026), // Rule ID 23313 //
     /*  367968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  367971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  367976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  367979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  367982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  367992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368007 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  368010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368014 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368024 */     GIR_RootConstrainSelectedInstOperands,
     /*  368025 */     // GIR_Coverage, 23313,
     /*  368025 */     GIR_EraseRootFromParent_Done,
     /*  368026 */   // Label 6647: @368026
     /*  368026 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(368089), // Rule ID 23316 //
     /*  368031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  368045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368070 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  368073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368087 */     GIR_RootConstrainSelectedInstOperands,
     /*  368088 */     // GIR_Coverage, 23316,
     /*  368088 */     GIR_EraseRootFromParent_Done,
     /*  368089 */   // Label 6648: @368089
     /*  368089 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(368152), // Rule ID 23317 //
     /*  368094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  368108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368133 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  368136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368150 */     GIR_RootConstrainSelectedInstOperands,
     /*  368151 */     // GIR_Coverage, 23317,
     /*  368151 */     GIR_EraseRootFromParent_Done,
     /*  368152 */   // Label 6649: @368152
     /*  368152 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(368215), // Rule ID 23320 //
     /*  368157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  368171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368196 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  368199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368203 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368213 */     GIR_RootConstrainSelectedInstOperands,
     /*  368214 */     // GIR_Coverage, 23320,
     /*  368214 */     GIR_EraseRootFromParent_Done,
     /*  368215 */   // Label 6650: @368215
     /*  368215 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(368278), // Rule ID 23321 //
     /*  368220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  368234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  368237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368259 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  368262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368266 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368276 */     GIR_RootConstrainSelectedInstOperands,
     /*  368277 */     // GIR_Coverage, 23321,
     /*  368277 */     GIR_EraseRootFromParent_Done,
     /*  368278 */   // Label 6651: @368278
     /*  368278 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(368341), // Rule ID 23324 //
     /*  368283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  368297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  368300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368322 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  368325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368329 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368339 */     GIR_RootConstrainSelectedInstOperands,
     /*  368340 */     // GIR_Coverage, 23324,
     /*  368340 */     GIR_EraseRootFromParent_Done,
     /*  368341 */   // Label 6652: @368341
     /*  368341 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(368404), // Rule ID 23325 //
     /*  368346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  368360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  368363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368385 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  368388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368392 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368402 */     GIR_RootConstrainSelectedInstOperands,
     /*  368403 */     // GIR_Coverage, 23325,
     /*  368403 */     GIR_EraseRootFromParent_Done,
     /*  368404 */   // Label 6653: @368404
     /*  368404 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(368467), // Rule ID 23328 //
     /*  368409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  368423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  368426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368448 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  368451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368455 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368465 */     GIR_RootConstrainSelectedInstOperands,
     /*  368466 */     // GIR_Coverage, 23328,
     /*  368466 */     GIR_EraseRootFromParent_Done,
     /*  368467 */   // Label 6654: @368467
     /*  368467 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(368530), // Rule ID 23329 //
     /*  368472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  368486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  368489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368511 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  368514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368518 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368528 */     GIR_RootConstrainSelectedInstOperands,
     /*  368529 */     // GIR_Coverage, 23329,
     /*  368529 */     GIR_EraseRootFromParent_Done,
     /*  368530 */   // Label 6655: @368530
     /*  368530 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(368593), // Rule ID 23332 //
     /*  368535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  368538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  368546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  368549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  368552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368574 */     // (intrinsic_wo_chain:{ *:[i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  368574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  368577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368581 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368591 */     GIR_RootConstrainSelectedInstOperands,
     /*  368592 */     // GIR_Coverage, 23332,
     /*  368592 */     GIR_EraseRootFromParent_Done,
     /*  368593 */   // Label 6656: @368593
     /*  368593 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(368656), // Rule ID 23333 //
     /*  368598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  368601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  368606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  368609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  368612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  368615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  368622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  368630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368637 */     // (intrinsic_wo_chain:{ *:[i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  368637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  368640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  368644 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  368646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368654 */     GIR_RootConstrainSelectedInstOperands,
     /*  368655 */     // GIR_Coverage, 23333,
     /*  368655 */     GIR_EraseRootFromParent_Done,
     /*  368656 */   // Label 6657: @368656
     /*  368656 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(368722), // Rule ID 23414 //
     /*  368661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  368678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368720 */     GIR_RootConstrainSelectedInstOperands,
     /*  368721 */     // GIR_Coverage, 23414,
     /*  368721 */     GIR_EraseRootFromParent_Done,
     /*  368722 */   // Label 6658: @368722
     /*  368722 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(368788), // Rule ID 23415 //
     /*  368727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  368738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  368741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  368744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368766 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368786 */     GIR_RootConstrainSelectedInstOperands,
     /*  368787 */     // GIR_Coverage, 23415,
     /*  368787 */     GIR_EraseRootFromParent_Done,
     /*  368788 */   // Label 6659: @368788
     /*  368788 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(368854), // Rule ID 23418 //
     /*  368793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  368835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368852 */     GIR_RootConstrainSelectedInstOperands,
     /*  368853 */     // GIR_Coverage, 23418,
     /*  368853 */     GIR_EraseRootFromParent_Done,
     /*  368854 */   // Label 6660: @368854
     /*  368854 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(368920), // Rule ID 23419 //
     /*  368859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  368870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  368873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  368876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368898 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  368901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368918 */     GIR_RootConstrainSelectedInstOperands,
     /*  368919 */     // GIR_Coverage, 23419,
     /*  368919 */     GIR_EraseRootFromParent_Done,
     /*  368920 */   // Label 6661: @368920
     /*  368920 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(368986), // Rule ID 23422 //
     /*  368925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  368928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  368942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  368967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368984 */     GIR_RootConstrainSelectedInstOperands,
     /*  368985 */     // GIR_Coverage, 23422,
     /*  368985 */     GIR_EraseRootFromParent_Done,
     /*  368986 */   // Label 6662: @368986
     /*  368986 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(369052), // Rule ID 23423 //
     /*  368991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  368994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  368999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  369002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  369005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  369033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369050 */     GIR_RootConstrainSelectedInstOperands,
     /*  369051 */     // GIR_Coverage, 23423,
     /*  369051 */     GIR_EraseRootFromParent_Done,
     /*  369052 */   // Label 6663: @369052
     /*  369052 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(369118), // Rule ID 23426 //
     /*  369057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369116 */     GIR_RootConstrainSelectedInstOperands,
     /*  369117 */     // GIR_Coverage, 23426,
     /*  369117 */     GIR_EraseRootFromParent_Done,
     /*  369118 */   // Label 6664: @369118
     /*  369118 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(369184), // Rule ID 23427 //
     /*  369123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  369134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  369137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369162 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369182 */     GIR_RootConstrainSelectedInstOperands,
     /*  369183 */     // GIR_Coverage, 23427,
     /*  369183 */     GIR_EraseRootFromParent_Done,
     /*  369184 */   // Label 6665: @369184
     /*  369184 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(369250), // Rule ID 23430 //
     /*  369189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  369200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  369203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369248 */     GIR_RootConstrainSelectedInstOperands,
     /*  369249 */     // GIR_Coverage, 23430,
     /*  369249 */     GIR_EraseRootFromParent_Done,
     /*  369250 */   // Label 6666: @369250
     /*  369250 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(369316), // Rule ID 23431 //
     /*  369255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  369266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  369269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  369297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369314 */     GIR_RootConstrainSelectedInstOperands,
     /*  369315 */     // GIR_Coverage, 23431,
     /*  369315 */     GIR_EraseRootFromParent_Done,
     /*  369316 */   // Label 6667: @369316
     /*  369316 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(369382), // Rule ID 23434 //
     /*  369321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  369338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369380 */     GIR_RootConstrainSelectedInstOperands,
     /*  369381 */     // GIR_Coverage, 23434,
     /*  369381 */     GIR_EraseRootFromParent_Done,
     /*  369382 */   // Label 6668: @369382
     /*  369382 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(369448), // Rule ID 23435 //
     /*  369387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  369398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  369401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  369404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11262:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369446 */     GIR_RootConstrainSelectedInstOperands,
     /*  369447 */     // GIR_Coverage, 23435,
     /*  369447 */     GIR_EraseRootFromParent_Done,
     /*  369448 */   // Label 6669: @369448
     /*  369448 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(369514), // Rule ID 23438 //
     /*  369453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  369470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369512 */     GIR_RootConstrainSelectedInstOperands,
     /*  369513 */     // GIR_Coverage, 23438,
     /*  369513 */     GIR_EraseRootFromParent_Done,
     /*  369514 */   // Label 6670: @369514
     /*  369514 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(369580), // Rule ID 23439 //
     /*  369519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  369530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  369533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  369536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369578 */     GIR_RootConstrainSelectedInstOperands,
     /*  369579 */     // GIR_Coverage, 23439,
     /*  369579 */     GIR_EraseRootFromParent_Done,
     /*  369580 */   // Label 6671: @369580
     /*  369580 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(369646), // Rule ID 23442 //
     /*  369585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369644 */     GIR_RootConstrainSelectedInstOperands,
     /*  369645 */     // GIR_Coverage, 23442,
     /*  369645 */     GIR_EraseRootFromParent_Done,
     /*  369646 */   // Label 6672: @369646
     /*  369646 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(369712), // Rule ID 23443 //
     /*  369651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  369662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  369665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  369668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369710 */     GIR_RootConstrainSelectedInstOperands,
     /*  369711 */     // GIR_Coverage, 23443,
     /*  369711 */     GIR_EraseRootFromParent_Done,
     /*  369712 */   // Label 6673: @369712
     /*  369712 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(369778), // Rule ID 23446 //
     /*  369717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  369720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369776 */     GIR_RootConstrainSelectedInstOperands,
     /*  369777 */     // GIR_Coverage, 23446,
     /*  369777 */     GIR_EraseRootFromParent_Done,
     /*  369778 */   // Label 6674: @369778
     /*  369778 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(369844), // Rule ID 23447 //
     /*  369783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  369786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  369794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  369797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  369800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  369825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369842 */     GIR_RootConstrainSelectedInstOperands,
     /*  369843 */     // GIR_Coverage, 23447,
     /*  369843 */     GIR_EraseRootFromParent_Done,
     /*  369844 */   // Label 6675: @369844
     /*  369844 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(369910), // Rule ID 23450 //
     /*  369849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  369866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369888 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  369891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369908 */     GIR_RootConstrainSelectedInstOperands,
     /*  369909 */     // GIR_Coverage, 23450,
     /*  369909 */     GIR_EraseRootFromParent_Done,
     /*  369910 */   // Label 6676: @369910
     /*  369910 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(369976), // Rule ID 23451 //
     /*  369915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  369918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  369926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  369929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  369932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  369947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  369957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369974 */     GIR_RootConstrainSelectedInstOperands,
     /*  369975 */     // GIR_Coverage, 23451,
     /*  369975 */     GIR_EraseRootFromParent_Done,
     /*  369976 */   // Label 6677: @369976
     /*  369976 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(370042), // Rule ID 23454 //
     /*  369981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  369984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  369989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  369998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370040 */     GIR_RootConstrainSelectedInstOperands,
     /*  370041 */     // GIR_Coverage, 23454,
     /*  370041 */     GIR_EraseRootFromParent_Done,
     /*  370042 */   // Label 6678: @370042
     /*  370042 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(370108), // Rule ID 23455 //
     /*  370047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  370058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  370061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370106 */     GIR_RootConstrainSelectedInstOperands,
     /*  370107 */     // GIR_Coverage, 23455,
     /*  370107 */     GIR_EraseRootFromParent_Done,
     /*  370108 */   // Label 6679: @370108
     /*  370108 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(370174), // Rule ID 23458 //
     /*  370113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  370124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  370127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  370130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370172 */     GIR_RootConstrainSelectedInstOperands,
     /*  370173 */     // GIR_Coverage, 23458,
     /*  370173 */     GIR_EraseRootFromParent_Done,
     /*  370174 */   // Label 6680: @370174
     /*  370174 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(370240), // Rule ID 23459 //
     /*  370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  370190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  370193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  370196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370238 */     GIR_RootConstrainSelectedInstOperands,
     /*  370239 */     // GIR_Coverage, 23459,
     /*  370239 */     GIR_EraseRootFromParent_Done,
     /*  370240 */   // Label 6681: @370240
     /*  370240 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(370306), // Rule ID 23462 //
     /*  370245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370304 */     GIR_RootConstrainSelectedInstOperands,
     /*  370305 */     // GIR_Coverage, 23462,
     /*  370305 */     GIR_EraseRootFromParent_Done,
     /*  370306 */   // Label 6682: @370306
     /*  370306 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(370372), // Rule ID 23463 //
     /*  370311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  370322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  370325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370370 */     GIR_RootConstrainSelectedInstOperands,
     /*  370371 */     // GIR_Coverage, 23463,
     /*  370371 */     GIR_EraseRootFromParent_Done,
     /*  370372 */   // Label 6683: @370372
     /*  370372 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(370438), // Rule ID 23466 //
     /*  370377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370436 */     GIR_RootConstrainSelectedInstOperands,
     /*  370437 */     // GIR_Coverage, 23466,
     /*  370437 */     GIR_EraseRootFromParent_Done,
     /*  370438 */   // Label 6684: @370438
     /*  370438 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(370504), // Rule ID 23467 //
     /*  370443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  370454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  370457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370502 */     GIR_RootConstrainSelectedInstOperands,
     /*  370503 */     // GIR_Coverage, 23467,
     /*  370503 */     GIR_EraseRootFromParent_Done,
     /*  370504 */   // Label 6685: @370504
     /*  370504 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(370570), // Rule ID 23470 //
     /*  370509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370568 */     GIR_RootConstrainSelectedInstOperands,
     /*  370569 */     // GIR_Coverage, 23470,
     /*  370569 */     GIR_EraseRootFromParent_Done,
     /*  370570 */   // Label 6686: @370570
     /*  370570 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(370636), // Rule ID 23471 //
     /*  370575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  370586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  370589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  370592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370634 */     GIR_RootConstrainSelectedInstOperands,
     /*  370635 */     // GIR_Coverage, 23471,
     /*  370635 */     GIR_EraseRootFromParent_Done,
     /*  370636 */   // Label 6687: @370636
     /*  370636 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(370702), // Rule ID 23474 //
     /*  370641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  370658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370700 */     GIR_RootConstrainSelectedInstOperands,
     /*  370701 */     // GIR_Coverage, 23474,
     /*  370701 */     GIR_EraseRootFromParent_Done,
     /*  370702 */   // Label 6688: @370702
     /*  370702 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(370768), // Rule ID 23475 //
     /*  370707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  370718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  370721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  370724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  370749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370766 */     GIR_RootConstrainSelectedInstOperands,
     /*  370767 */     // GIR_Coverage, 23475,
     /*  370767 */     GIR_EraseRootFromParent_Done,
     /*  370768 */   // Label 6689: @370768
     /*  370768 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(370834), // Rule ID 23478 //
     /*  370773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370832 */     GIR_RootConstrainSelectedInstOperands,
     /*  370833 */     // GIR_Coverage, 23478,
     /*  370833 */     GIR_EraseRootFromParent_Done,
     /*  370834 */   // Label 6690: @370834
     /*  370834 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(370900), // Rule ID 23479 //
     /*  370839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  370850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  370853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  370856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  370881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370898 */     GIR_RootConstrainSelectedInstOperands,
     /*  370899 */     // GIR_Coverage, 23479,
     /*  370899 */     GIR_EraseRootFromParent_Done,
     /*  370900 */   // Label 6691: @370900
     /*  370900 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(370966), // Rule ID 23482 //
     /*  370905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  370908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  370947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370964 */     GIR_RootConstrainSelectedInstOperands,
     /*  370965 */     // GIR_Coverage, 23482,
     /*  370965 */     GIR_EraseRootFromParent_Done,
     /*  370966 */   // Label 6692: @370966
     /*  370966 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(371032), // Rule ID 23483 //
     /*  370971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  370974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  370979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  370988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371030 */     GIR_RootConstrainSelectedInstOperands,
     /*  371031 */     // GIR_Coverage, 23483,
     /*  371031 */     GIR_EraseRootFromParent_Done,
     /*  371032 */   // Label 6693: @371032
     /*  371032 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(371098), // Rule ID 23486 //
     /*  371037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  371048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  371051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  371054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  371079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371096 */     GIR_RootConstrainSelectedInstOperands,
     /*  371097 */     // GIR_Coverage, 23486,
     /*  371097 */     GIR_EraseRootFromParent_Done,
     /*  371098 */   // Label 6694: @371098
     /*  371098 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(371164), // Rule ID 23487 //
     /*  371103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  371114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  371117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  371120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  371145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371162 */     GIR_RootConstrainSelectedInstOperands,
     /*  371163 */     // GIR_Coverage, 23487,
     /*  371163 */     GIR_EraseRootFromParent_Done,
     /*  371164 */   // Label 6695: @371164
     /*  371164 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(371230), // Rule ID 23490 //
     /*  371169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  371180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  371183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  371186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  371211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371228 */     GIR_RootConstrainSelectedInstOperands,
     /*  371229 */     // GIR_Coverage, 23490,
     /*  371229 */     GIR_EraseRootFromParent_Done,
     /*  371230 */   // Label 6696: @371230
     /*  371230 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(371296), // Rule ID 23491 //
     /*  371235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  371246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  371249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  371252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371274 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  371277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371294 */     GIR_RootConstrainSelectedInstOperands,
     /*  371295 */     // GIR_Coverage, 23491,
     /*  371295 */     GIR_EraseRootFromParent_Done,
     /*  371296 */   // Label 6697: @371296
     /*  371296 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(371362), // Rule ID 23494 //
     /*  371301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  371304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  371312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  371315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  371318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371360 */     GIR_RootConstrainSelectedInstOperands,
     /*  371361 */     // GIR_Coverage, 23494,
     /*  371361 */     GIR_EraseRootFromParent_Done,
     /*  371362 */   // Label 6698: @371362
     /*  371362 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(371428), // Rule ID 23495 //
     /*  371367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  371370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  371375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  371378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  371381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  371384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  371409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371426 */     GIR_RootConstrainSelectedInstOperands,
     /*  371427 */     // GIR_Coverage, 23495,
     /*  371427 */     GIR_EraseRootFromParent_Done,
     /*  371428 */   // Label 6699: @371428
     /*  371428 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(371494), // Rule ID 60610 //
     /*  371433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  371475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371492 */     GIR_RootConstrainSelectedInstOperands,
     /*  371493 */     // GIR_Coverage, 60610,
     /*  371493 */     GIR_EraseRootFromParent_Done,
     /*  371494 */   // Label 6700: @371494
     /*  371494 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(371560), // Rule ID 60611 //
     /*  371499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  371510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  371513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  371516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  371541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371558 */     GIR_RootConstrainSelectedInstOperands,
     /*  371559 */     // GIR_Coverage, 60611,
     /*  371559 */     GIR_EraseRootFromParent_Done,
     /*  371560 */   // Label 6701: @371560
     /*  371560 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(371626), // Rule ID 60614 //
     /*  371565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371624 */     GIR_RootConstrainSelectedInstOperands,
     /*  371625 */     // GIR_Coverage, 60614,
     /*  371625 */     GIR_EraseRootFromParent_Done,
     /*  371626 */   // Label 6702: @371626
     /*  371626 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(371692), // Rule ID 60615 //
     /*  371631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  371642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  371645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  371648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371690 */     GIR_RootConstrainSelectedInstOperands,
     /*  371691 */     // GIR_Coverage, 60615,
     /*  371691 */     GIR_EraseRootFromParent_Done,
     /*  371692 */   // Label 6703: @371692
     /*  371692 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(371758), // Rule ID 60618 //
     /*  371697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  371739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371756 */     GIR_RootConstrainSelectedInstOperands,
     /*  371757 */     // GIR_Coverage, 60618,
     /*  371757 */     GIR_EraseRootFromParent_Done,
     /*  371758 */   // Label 6704: @371758
     /*  371758 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(371824), // Rule ID 60619 //
     /*  371763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  371774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  371777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  371780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  371805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371822 */     GIR_RootConstrainSelectedInstOperands,
     /*  371823 */     // GIR_Coverage, 60619,
     /*  371823 */     GIR_EraseRootFromParent_Done,
     /*  371824 */   // Label 6705: @371824
     /*  371824 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(371890), // Rule ID 60622 //
     /*  371829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371888 */     GIR_RootConstrainSelectedInstOperands,
     /*  371889 */     // GIR_Coverage, 60622,
     /*  371889 */     GIR_EraseRootFromParent_Done,
     /*  371890 */   // Label 6706: @371890
     /*  371890 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(371956), // Rule ID 60623 //
     /*  371895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  371906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  371909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  371912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371934 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  371937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371954 */     GIR_RootConstrainSelectedInstOperands,
     /*  371955 */     // GIR_Coverage, 60623,
     /*  371955 */     GIR_EraseRootFromParent_Done,
     /*  371956 */   // Label 6707: @371956
     /*  371956 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(372022), // Rule ID 60626 //
     /*  371961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  371969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372020 */     GIR_RootConstrainSelectedInstOperands,
     /*  372021 */     // GIR_Coverage, 60626,
     /*  372021 */     GIR_EraseRootFromParent_Done,
     /*  372022 */   // Label 6708: @372022
     /*  372022 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(372088), // Rule ID 60627 //
     /*  372027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  372038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  372041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  372044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372086 */     GIR_RootConstrainSelectedInstOperands,
     /*  372087 */     // GIR_Coverage, 60627,
     /*  372087 */     GIR_EraseRootFromParent_Done,
     /*  372088 */   // Label 6709: @372088
     /*  372088 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(372154), // Rule ID 60630 //
     /*  372093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372152 */     GIR_RootConstrainSelectedInstOperands,
     /*  372153 */     // GIR_Coverage, 60630,
     /*  372153 */     GIR_EraseRootFromParent_Done,
     /*  372154 */   // Label 6710: @372154
     /*  372154 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(372220), // Rule ID 60631 //
     /*  372159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  372170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  372173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  372176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  372201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372218 */     GIR_RootConstrainSelectedInstOperands,
     /*  372219 */     // GIR_Coverage, 60631,
     /*  372219 */     GIR_EraseRootFromParent_Done,
     /*  372220 */   // Label 6711: @372220
     /*  372220 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(372286), // Rule ID 60634 //
     /*  372225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372284 */     GIR_RootConstrainSelectedInstOperands,
     /*  372285 */     // GIR_Coverage, 60634,
     /*  372285 */     GIR_EraseRootFromParent_Done,
     /*  372286 */   // Label 6712: @372286
     /*  372286 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(372352), // Rule ID 60635 //
     /*  372291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  372302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  372305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  372308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372330 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372350 */     GIR_RootConstrainSelectedInstOperands,
     /*  372351 */     // GIR_Coverage, 60635,
     /*  372351 */     GIR_EraseRootFromParent_Done,
     /*  372352 */   // Label 6713: @372352
     /*  372352 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(372418), // Rule ID 60638 //
     /*  372357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372416 */     GIR_RootConstrainSelectedInstOperands,
     /*  372417 */     // GIR_Coverage, 60638,
     /*  372417 */     GIR_EraseRootFromParent_Done,
     /*  372418 */   // Label 6714: @372418
     /*  372418 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(372484), // Rule ID 60639 //
     /*  372423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  372434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  372437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  372440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372482 */     GIR_RootConstrainSelectedInstOperands,
     /*  372483 */     // GIR_Coverage, 60639,
     /*  372483 */     GIR_EraseRootFromParent_Done,
     /*  372484 */   // Label 6715: @372484
     /*  372484 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(372550), // Rule ID 60642 //
     /*  372489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372548 */     GIR_RootConstrainSelectedInstOperands,
     /*  372549 */     // GIR_Coverage, 60642,
     /*  372549 */     GIR_EraseRootFromParent_Done,
     /*  372550 */   // Label 6716: @372550
     /*  372550 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(372616), // Rule ID 60643 //
     /*  372555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  372566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  372569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  372572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372614 */     GIR_RootConstrainSelectedInstOperands,
     /*  372615 */     // GIR_Coverage, 60643,
     /*  372615 */     GIR_EraseRootFromParent_Done,
     /*  372616 */   // Label 6717: @372616
     /*  372616 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(372682), // Rule ID 60646 //
     /*  372621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372680 */     GIR_RootConstrainSelectedInstOperands,
     /*  372681 */     // GIR_Coverage, 60646,
     /*  372681 */     GIR_EraseRootFromParent_Done,
     /*  372682 */   // Label 6718: @372682
     /*  372682 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(372748), // Rule ID 60647 //
     /*  372687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  372698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  372701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  372704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  372729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372746 */     GIR_RootConstrainSelectedInstOperands,
     /*  372747 */     // GIR_Coverage, 60647,
     /*  372747 */     GIR_EraseRootFromParent_Done,
     /*  372748 */   // Label 6719: @372748
     /*  372748 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(372814), // Rule ID 60650 //
     /*  372753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  372795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372812 */     GIR_RootConstrainSelectedInstOperands,
     /*  372813 */     // GIR_Coverage, 60650,
     /*  372813 */     GIR_EraseRootFromParent_Done,
     /*  372814 */   // Label 6720: @372814
     /*  372814 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(372880), // Rule ID 60651 //
     /*  372819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  372830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  372833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  372836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  372861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372878 */     GIR_RootConstrainSelectedInstOperands,
     /*  372879 */     // GIR_Coverage, 60651,
     /*  372879 */     GIR_EraseRootFromParent_Done,
     /*  372880 */   // Label 6721: @372880
     /*  372880 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(372946), // Rule ID 60654 //
     /*  372885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372924 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  372927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372944 */     GIR_RootConstrainSelectedInstOperands,
     /*  372945 */     // GIR_Coverage, 60654,
     /*  372945 */     GIR_EraseRootFromParent_Done,
     /*  372946 */   // Label 6722: @372946
     /*  372946 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(373012), // Rule ID 60655 //
     /*  372951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  372959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  372993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373010 */     GIR_RootConstrainSelectedInstOperands,
     /*  373011 */     // GIR_Coverage, 60655,
     /*  373011 */     GIR_EraseRootFromParent_Done,
     /*  373012 */   // Label 6723: @373012
     /*  373012 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(373078), // Rule ID 60658 //
     /*  373017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373056 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373076 */     GIR_RootConstrainSelectedInstOperands,
     /*  373077 */     // GIR_Coverage, 60658,
     /*  373077 */     GIR_EraseRootFromParent_Done,
     /*  373078 */   // Label 6724: @373078
     /*  373078 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(373144), // Rule ID 60659 //
     /*  373083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  373094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  373097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  373100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373142 */     GIR_RootConstrainSelectedInstOperands,
     /*  373143 */     // GIR_Coverage, 60659,
     /*  373143 */     GIR_EraseRootFromParent_Done,
     /*  373144 */   // Label 6725: @373144
     /*  373144 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(373210), // Rule ID 60662 //
     /*  373149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373208 */     GIR_RootConstrainSelectedInstOperands,
     /*  373209 */     // GIR_Coverage, 60662,
     /*  373209 */     GIR_EraseRootFromParent_Done,
     /*  373210 */   // Label 6726: @373210
     /*  373210 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(373276), // Rule ID 60663 //
     /*  373215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  373226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  373229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  373232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373274 */     GIR_RootConstrainSelectedInstOperands,
     /*  373275 */     // GIR_Coverage, 60663,
     /*  373275 */     GIR_EraseRootFromParent_Done,
     /*  373276 */   // Label 6727: @373276
     /*  373276 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(373342), // Rule ID 60666 //
     /*  373281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373340 */     GIR_RootConstrainSelectedInstOperands,
     /*  373341 */     // GIR_Coverage, 60666,
     /*  373341 */     GIR_EraseRootFromParent_Done,
     /*  373342 */   // Label 6728: @373342
     /*  373342 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(373408), // Rule ID 60667 //
     /*  373347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  373358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  373361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  373364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373406 */     GIR_RootConstrainSelectedInstOperands,
     /*  373407 */     // GIR_Coverage, 60667,
     /*  373407 */     GIR_EraseRootFromParent_Done,
     /*  373408 */   // Label 6729: @373408
     /*  373408 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(373474), // Rule ID 60670 //
     /*  373413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373472 */     GIR_RootConstrainSelectedInstOperands,
     /*  373473 */     // GIR_Coverage, 60670,
     /*  373473 */     GIR_EraseRootFromParent_Done,
     /*  373474 */   // Label 6730: @373474
     /*  373474 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(373540), // Rule ID 60671 //
     /*  373479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  373490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  373493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  373496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373538 */     GIR_RootConstrainSelectedInstOperands,
     /*  373539 */     // GIR_Coverage, 60671,
     /*  373539 */     GIR_EraseRootFromParent_Done,
     /*  373540 */   // Label 6731: @373540
     /*  373540 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(373606), // Rule ID 60674 //
     /*  373545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373604 */     GIR_RootConstrainSelectedInstOperands,
     /*  373605 */     // GIR_Coverage, 60674,
     /*  373605 */     GIR_EraseRootFromParent_Done,
     /*  373606 */   // Label 6732: @373606
     /*  373606 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(373672), // Rule ID 60675 //
     /*  373611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  373622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  373625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  373628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373670 */     GIR_RootConstrainSelectedInstOperands,
     /*  373671 */     // GIR_Coverage, 60675,
     /*  373671 */     GIR_EraseRootFromParent_Done,
     /*  373672 */   // Label 6733: @373672
     /*  373672 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(373738), // Rule ID 60678 //
     /*  373677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373736 */     GIR_RootConstrainSelectedInstOperands,
     /*  373737 */     // GIR_Coverage, 60678,
     /*  373737 */     GIR_EraseRootFromParent_Done,
     /*  373738 */   // Label 6734: @373738
     /*  373738 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(373804), // Rule ID 60679 //
     /*  373743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  373754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  373757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  373760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  373785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373802 */     GIR_RootConstrainSelectedInstOperands,
     /*  373803 */     // GIR_Coverage, 60679,
     /*  373803 */     GIR_EraseRootFromParent_Done,
     /*  373804 */   // Label 6735: @373804
     /*  373804 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(373870), // Rule ID 60682 //
     /*  373809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373868 */     GIR_RootConstrainSelectedInstOperands,
     /*  373869 */     // GIR_Coverage, 60682,
     /*  373869 */     GIR_EraseRootFromParent_Done,
     /*  373870 */   // Label 6736: @373870
     /*  373870 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(373936), // Rule ID 60683 //
     /*  373875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  373886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  373889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  373892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  373917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373934 */     GIR_RootConstrainSelectedInstOperands,
     /*  373935 */     // GIR_Coverage, 60683,
     /*  373935 */     GIR_EraseRootFromParent_Done,
     /*  373936 */   // Label 6737: @373936
     /*  373936 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(374002), // Rule ID 60686 //
     /*  373941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  373949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  373983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374000 */     GIR_RootConstrainSelectedInstOperands,
     /*  374001 */     // GIR_Coverage, 60686,
     /*  374001 */     GIR_EraseRootFromParent_Done,
     /*  374002 */   // Label 6738: @374002
     /*  374002 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(374068), // Rule ID 60687 //
     /*  374007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  374018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  374021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  374024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  374049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374066 */     GIR_RootConstrainSelectedInstOperands,
     /*  374067 */     // GIR_Coverage, 60687,
     /*  374067 */     GIR_EraseRootFromParent_Done,
     /*  374068 */   // Label 6739: @374068
     /*  374068 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(374134), // Rule ID 60690 //
     /*  374073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  374115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374132 */     GIR_RootConstrainSelectedInstOperands,
     /*  374133 */     // GIR_Coverage, 60690,
     /*  374133 */     GIR_EraseRootFromParent_Done,
     /*  374134 */   // Label 6740: @374134
     /*  374134 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(374200), // Rule ID 60691 //
     /*  374139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  374150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  374153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  374156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  374181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374198 */     GIR_RootConstrainSelectedInstOperands,
     /*  374199 */     // GIR_Coverage, 60691,
     /*  374199 */     GIR_EraseRootFromParent_Done,
     /*  374200 */   // Label 6741: @374200
     /*  374200 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(374266), // Rule ID 60694 //
     /*  374205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  374216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  374219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  374222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  374247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374264 */     GIR_RootConstrainSelectedInstOperands,
     /*  374265 */     // GIR_Coverage, 60694,
     /*  374265 */     GIR_EraseRootFromParent_Done,
     /*  374266 */   // Label 6742: @374266
     /*  374266 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(374332), // Rule ID 60695 //
     /*  374271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  374279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  374282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  374285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  374288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  374313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374330 */     GIR_RootConstrainSelectedInstOperands,
     /*  374331 */     // GIR_Coverage, 60695,
     /*  374331 */     GIR_EraseRootFromParent_Done,
     /*  374332 */   // Label 6743: @374332
     /*  374332 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(374398), // Rule ID 60698 //
     /*  374337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  374348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  374351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  374354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  374379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374396 */     GIR_RootConstrainSelectedInstOperands,
     /*  374397 */     // GIR_Coverage, 60698,
     /*  374397 */     GIR_EraseRootFromParent_Done,
     /*  374398 */   // Label 6744: @374398
     /*  374398 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(374464), // Rule ID 60699 //
     /*  374403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  374414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  374417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  374420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  374445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374462 */     GIR_RootConstrainSelectedInstOperands,
     /*  374463 */     // GIR_Coverage, 60699,
     /*  374463 */     GIR_EraseRootFromParent_Done,
     /*  374464 */   // Label 6745: @374464
     /*  374464 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(374530), // Rule ID 60702 //
     /*  374469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374528 */     GIR_RootConstrainSelectedInstOperands,
     /*  374529 */     // GIR_Coverage, 60702,
     /*  374529 */     GIR_EraseRootFromParent_Done,
     /*  374530 */   // Label 6746: @374530
     /*  374530 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(374596), // Rule ID 60703 //
     /*  374535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  374546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  374549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  374552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374574 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374594 */     GIR_RootConstrainSelectedInstOperands,
     /*  374595 */     // GIR_Coverage, 60703,
     /*  374595 */     GIR_EraseRootFromParent_Done,
     /*  374596 */   // Label 6747: @374596
     /*  374596 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(374662), // Rule ID 60706 //
     /*  374601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374660 */     GIR_RootConstrainSelectedInstOperands,
     /*  374661 */     // GIR_Coverage, 60706,
     /*  374661 */     GIR_EraseRootFromParent_Done,
     /*  374662 */   // Label 6748: @374662
     /*  374662 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(374728), // Rule ID 60707 //
     /*  374667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  374678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  374681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  374684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374726 */     GIR_RootConstrainSelectedInstOperands,
     /*  374727 */     // GIR_Coverage, 60707,
     /*  374727 */     GIR_EraseRootFromParent_Done,
     /*  374728 */   // Label 6749: @374728
     /*  374728 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(374794), // Rule ID 60710 //
     /*  374733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374772 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374792 */     GIR_RootConstrainSelectedInstOperands,
     /*  374793 */     // GIR_Coverage, 60710,
     /*  374793 */     GIR_EraseRootFromParent_Done,
     /*  374794 */   // Label 6750: @374794
     /*  374794 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(374860), // Rule ID 60711 //
     /*  374799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  374810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  374813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  374816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  374841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374858 */     GIR_RootConstrainSelectedInstOperands,
     /*  374859 */     // GIR_Coverage, 60711,
     /*  374859 */     GIR_EraseRootFromParent_Done,
     /*  374860 */   // Label 6751: @374860
     /*  374860 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(374926), // Rule ID 60714 //
     /*  374865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374924 */     GIR_RootConstrainSelectedInstOperands,
     /*  374925 */     // GIR_Coverage, 60714,
     /*  374925 */     GIR_EraseRootFromParent_Done,
     /*  374926 */   // Label 6752: @374926
     /*  374926 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(374992), // Rule ID 60715 //
     /*  374931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  374939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  374973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374990 */     GIR_RootConstrainSelectedInstOperands,
     /*  374991 */     // GIR_Coverage, 60715,
     /*  374991 */     GIR_EraseRootFromParent_Done,
     /*  374992 */   // Label 6753: @374992
     /*  374992 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(375058), // Rule ID 60718 //
     /*  374997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  375008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  375011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  375014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  375039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375056 */     GIR_RootConstrainSelectedInstOperands,
     /*  375057 */     // GIR_Coverage, 60718,
     /*  375057 */     GIR_EraseRootFromParent_Done,
     /*  375058 */   // Label 6754: @375058
     /*  375058 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(375124), // Rule ID 60719 //
     /*  375063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  375074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  375077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  375080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  375105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375122 */     GIR_RootConstrainSelectedInstOperands,
     /*  375123 */     // GIR_Coverage, 60719,
     /*  375123 */     GIR_EraseRootFromParent_Done,
     /*  375124 */   // Label 6755: @375124
     /*  375124 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(375190), // Rule ID 60722 //
     /*  375129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  375140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  375143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  375146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375188 */     GIR_RootConstrainSelectedInstOperands,
     /*  375189 */     // GIR_Coverage, 60722,
     /*  375189 */     GIR_EraseRootFromParent_Done,
     /*  375190 */   // Label 6756: @375190
     /*  375190 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(375256), // Rule ID 60723 //
     /*  375195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  375206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  375209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  375212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375254 */     GIR_RootConstrainSelectedInstOperands,
     /*  375255 */     // GIR_Coverage, 60723,
     /*  375255 */     GIR_EraseRootFromParent_Done,
     /*  375256 */   // Label 6757: @375256
     /*  375256 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(375322), // Rule ID 60726 //
     /*  375261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  375272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  375275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  375278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375320 */     GIR_RootConstrainSelectedInstOperands,
     /*  375321 */     // GIR_Coverage, 60726,
     /*  375321 */     GIR_EraseRootFromParent_Done,
     /*  375322 */   // Label 6758: @375322
     /*  375322 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(375388), // Rule ID 60727 //
     /*  375327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  375338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  375341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  375344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375386 */     GIR_RootConstrainSelectedInstOperands,
     /*  375387 */     // GIR_Coverage, 60727,
     /*  375387 */     GIR_EraseRootFromParent_Done,
     /*  375388 */   // Label 6759: @375388
     /*  375388 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(375454), // Rule ID 60730 //
     /*  375393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  375404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  375407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375452 */     GIR_RootConstrainSelectedInstOperands,
     /*  375453 */     // GIR_Coverage, 60730,
     /*  375453 */     GIR_EraseRootFromParent_Done,
     /*  375454 */   // Label 6760: @375454
     /*  375454 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(375520), // Rule ID 60731 //
     /*  375459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  375470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  375473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  375476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375518 */     GIR_RootConstrainSelectedInstOperands,
     /*  375519 */     // GIR_Coverage, 60731,
     /*  375519 */     GIR_EraseRootFromParent_Done,
     /*  375520 */   // Label 6761: @375520
     /*  375520 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(375586), // Rule ID 60734 //
     /*  375525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375584 */     GIR_RootConstrainSelectedInstOperands,
     /*  375585 */     // GIR_Coverage, 60734,
     /*  375585 */     GIR_EraseRootFromParent_Done,
     /*  375586 */   // Label 6762: @375586
     /*  375586 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(375652), // Rule ID 60735 //
     /*  375591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  375602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  375605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  375608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  375633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375650 */     GIR_RootConstrainSelectedInstOperands,
     /*  375651 */     // GIR_Coverage, 60735,
     /*  375651 */     GIR_EraseRootFromParent_Done,
     /*  375652 */   // Label 6763: @375652
     /*  375652 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(375718), // Rule ID 60738 //
     /*  375657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  375699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375716 */     GIR_RootConstrainSelectedInstOperands,
     /*  375717 */     // GIR_Coverage, 60738,
     /*  375717 */     GIR_EraseRootFromParent_Done,
     /*  375718 */   // Label 6764: @375718
     /*  375718 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(375784), // Rule ID 60739 //
     /*  375723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  375734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  375737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  375740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375762 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  375765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375782 */     GIR_RootConstrainSelectedInstOperands,
     /*  375783 */     // GIR_Coverage, 60739,
     /*  375783 */     GIR_EraseRootFromParent_Done,
     /*  375784 */   // Label 6765: @375784
     /*  375784 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(375850), // Rule ID 60742 //
     /*  375789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  375831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375848 */     GIR_RootConstrainSelectedInstOperands,
     /*  375849 */     // GIR_Coverage, 60742,
     /*  375849 */     GIR_EraseRootFromParent_Done,
     /*  375850 */   // Label 6766: @375850
     /*  375850 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(375916), // Rule ID 60743 //
     /*  375855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  375866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  375869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  375872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  375897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375914 */     GIR_RootConstrainSelectedInstOperands,
     /*  375915 */     // GIR_Coverage, 60743,
     /*  375915 */     GIR_EraseRootFromParent_Done,
     /*  375916 */   // Label 6767: @375916
     /*  375916 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(375982), // Rule ID 60746 //
     /*  375921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  375963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375980 */     GIR_RootConstrainSelectedInstOperands,
     /*  375981 */     // GIR_Coverage, 60746,
     /*  375981 */     GIR_EraseRootFromParent_Done,
     /*  375982 */   // Label 6768: @375982
     /*  375982 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(376048), // Rule ID 60747 //
     /*  375987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  375995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  376001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  376004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376046 */     GIR_RootConstrainSelectedInstOperands,
     /*  376047 */     // GIR_Coverage, 60747,
     /*  376047 */     GIR_EraseRootFromParent_Done,
     /*  376048 */   // Label 6769: @376048
     /*  376048 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(376114), // Rule ID 60750 //
     /*  376053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  376064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  376067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  376070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376112 */     GIR_RootConstrainSelectedInstOperands,
     /*  376113 */     // GIR_Coverage, 60750,
     /*  376113 */     GIR_EraseRootFromParent_Done,
     /*  376114 */   // Label 6770: @376114
     /*  376114 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(376180), // Rule ID 60751 //
     /*  376119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  376130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  376133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  376136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376178 */     GIR_RootConstrainSelectedInstOperands,
     /*  376179 */     // GIR_Coverage, 60751,
     /*  376179 */     GIR_EraseRootFromParent_Done,
     /*  376180 */   // Label 6771: @376180
     /*  376180 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(376246), // Rule ID 60754 //
     /*  376185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  376196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  376199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  376202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376244 */     GIR_RootConstrainSelectedInstOperands,
     /*  376245 */     // GIR_Coverage, 60754,
     /*  376245 */     GIR_EraseRootFromParent_Done,
     /*  376246 */   // Label 6772: @376246
     /*  376246 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(376312), // Rule ID 60755 //
     /*  376251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  376262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  376265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  376268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376310 */     GIR_RootConstrainSelectedInstOperands,
     /*  376311 */     // GIR_Coverage, 60755,
     /*  376311 */     GIR_EraseRootFromParent_Done,
     /*  376312 */   // Label 6773: @376312
     /*  376312 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(376378), // Rule ID 60758 //
     /*  376317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  376328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  376331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  376334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376376 */     GIR_RootConstrainSelectedInstOperands,
     /*  376377 */     // GIR_Coverage, 60758,
     /*  376377 */     GIR_EraseRootFromParent_Done,
     /*  376378 */   // Label 6774: @376378
     /*  376378 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(376444), // Rule ID 60759 //
     /*  376383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  376394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  376397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  376400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376442 */     GIR_RootConstrainSelectedInstOperands,
     /*  376443 */     // GIR_Coverage, 60759,
     /*  376443 */     GIR_EraseRootFromParent_Done,
     /*  376444 */   // Label 6775: @376444
     /*  376444 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(376510), // Rule ID 60762 //
     /*  376449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376508 */     GIR_RootConstrainSelectedInstOperands,
     /*  376509 */     // GIR_Coverage, 60762,
     /*  376509 */     GIR_EraseRootFromParent_Done,
     /*  376510 */   // Label 6776: @376510
     /*  376510 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(376576), // Rule ID 60763 //
     /*  376515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  376526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  376529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  376532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376574 */     GIR_RootConstrainSelectedInstOperands,
     /*  376575 */     // GIR_Coverage, 60763,
     /*  376575 */     GIR_EraseRootFromParent_Done,
     /*  376576 */   // Label 6777: @376576
     /*  376576 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(376642), // Rule ID 60766 //
     /*  376581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376620 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376640 */     GIR_RootConstrainSelectedInstOperands,
     /*  376641 */     // GIR_Coverage, 60766,
     /*  376641 */     GIR_EraseRootFromParent_Done,
     /*  376642 */   // Label 6778: @376642
     /*  376642 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(376708), // Rule ID 60767 //
     /*  376647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  376658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  376661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  376664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  376689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376706 */     GIR_RootConstrainSelectedInstOperands,
     /*  376707 */     // GIR_Coverage, 60767,
     /*  376707 */     GIR_EraseRootFromParent_Done,
     /*  376708 */   // Label 6779: @376708
     /*  376708 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(376774), // Rule ID 60770 //
     /*  376713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376772 */     GIR_RootConstrainSelectedInstOperands,
     /*  376773 */     // GIR_Coverage, 60770,
     /*  376773 */     GIR_EraseRootFromParent_Done,
     /*  376774 */   // Label 6780: @376774
     /*  376774 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(376840), // Rule ID 60771 //
     /*  376779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  376790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  376793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  376796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  376821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376838 */     GIR_RootConstrainSelectedInstOperands,
     /*  376839 */     // GIR_Coverage, 60771,
     /*  376839 */     GIR_EraseRootFromParent_Done,
     /*  376840 */   // Label 6781: @376840
     /*  376840 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(376906), // Rule ID 60774 //
     /*  376845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376904 */     GIR_RootConstrainSelectedInstOperands,
     /*  376905 */     // GIR_Coverage, 60774,
     /*  376905 */     GIR_EraseRootFromParent_Done,
     /*  376906 */   // Label 6782: @376906
     /*  376906 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(376972), // Rule ID 60775 //
     /*  376911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  376922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  376925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  376928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  376953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376970 */     GIR_RootConstrainSelectedInstOperands,
     /*  376971 */     // GIR_Coverage, 60775,
     /*  376971 */     GIR_EraseRootFromParent_Done,
     /*  376972 */   // Label 6783: @376972
     /*  376972 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(377038), // Rule ID 60778 //
     /*  376977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  376985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  377019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377036 */     GIR_RootConstrainSelectedInstOperands,
     /*  377037 */     // GIR_Coverage, 60778,
     /*  377037 */     GIR_EraseRootFromParent_Done,
     /*  377038 */   // Label 6784: @377038
     /*  377038 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(377104), // Rule ID 60779 //
     /*  377043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  377054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  377057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  377060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  377085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377102 */     GIR_RootConstrainSelectedInstOperands,
     /*  377103 */     // GIR_Coverage, 60779,
     /*  377103 */     GIR_EraseRootFromParent_Done,
     /*  377104 */   // Label 6785: @377104
     /*  377104 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(377170), // Rule ID 60782 //
     /*  377109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  377120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  377123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  377126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  377151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377168 */     GIR_RootConstrainSelectedInstOperands,
     /*  377169 */     // GIR_Coverage, 60782,
     /*  377169 */     GIR_EraseRootFromParent_Done,
     /*  377170 */   // Label 6786: @377170
     /*  377170 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(377236), // Rule ID 60783 //
     /*  377175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  377183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  377186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  377189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  377192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  377217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377234 */     GIR_RootConstrainSelectedInstOperands,
     /*  377235 */     // GIR_Coverage, 60783,
     /*  377235 */     GIR_EraseRootFromParent_Done,
     /*  377236 */   // Label 6787: @377236
     /*  377236 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(377302), // Rule ID 60786 //
     /*  377241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  377252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  377255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  377258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377300 */     GIR_RootConstrainSelectedInstOperands,
     /*  377301 */     // GIR_Coverage, 60786,
     /*  377301 */     GIR_EraseRootFromParent_Done,
     /*  377302 */   // Label 6788: @377302
     /*  377302 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(377368), // Rule ID 60787 //
     /*  377307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  377318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  377321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  377324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  377349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377366 */     GIR_RootConstrainSelectedInstOperands,
     /*  377367 */     // GIR_Coverage, 60787,
     /*  377367 */     GIR_EraseRootFromParent_Done,
     /*  377368 */   // Label 6789: @377368
     /*  377368 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(377434), // Rule ID 60790 //
     /*  377373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  377384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  377387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  377390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377432 */     GIR_RootConstrainSelectedInstOperands,
     /*  377433 */     // GIR_Coverage, 60790,
     /*  377433 */     GIR_EraseRootFromParent_Done,
     /*  377434 */   // Label 6790: @377434
     /*  377434 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(377500), // Rule ID 60791 //
     /*  377439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  377450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  377453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  377456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377478 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377498 */     GIR_RootConstrainSelectedInstOperands,
     /*  377499 */     // GIR_Coverage, 60791,
     /*  377499 */     GIR_EraseRootFromParent_Done,
     /*  377500 */   // Label 6791: @377500
     /*  377500 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(377566), // Rule ID 60794 //
     /*  377505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377564 */     GIR_RootConstrainSelectedInstOperands,
     /*  377565 */     // GIR_Coverage, 60794,
     /*  377565 */     GIR_EraseRootFromParent_Done,
     /*  377566 */   // Label 6792: @377566
     /*  377566 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(377632), // Rule ID 60795 //
     /*  377571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  377582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  377585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  377588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377630 */     GIR_RootConstrainSelectedInstOperands,
     /*  377631 */     // GIR_Coverage, 60795,
     /*  377631 */     GIR_EraseRootFromParent_Done,
     /*  377632 */   // Label 6793: @377632
     /*  377632 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(377698), // Rule ID 60798 //
     /*  377637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377696 */     GIR_RootConstrainSelectedInstOperands,
     /*  377697 */     // GIR_Coverage, 60798,
     /*  377697 */     GIR_EraseRootFromParent_Done,
     /*  377698 */   // Label 6794: @377698
     /*  377698 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(377764), // Rule ID 60799 //
     /*  377703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  377714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  377717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  377720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  377745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377762 */     GIR_RootConstrainSelectedInstOperands,
     /*  377763 */     // GIR_Coverage, 60799,
     /*  377763 */     GIR_EraseRootFromParent_Done,
     /*  377764 */   // Label 6795: @377764
     /*  377764 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(377830), // Rule ID 60802 //
     /*  377769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377808 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377828 */     GIR_RootConstrainSelectedInstOperands,
     /*  377829 */     // GIR_Coverage, 60802,
     /*  377829 */     GIR_EraseRootFromParent_Done,
     /*  377830 */   // Label 6796: @377830
     /*  377830 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(377896), // Rule ID 60803 //
     /*  377835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  377846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  377849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  377852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377894 */     GIR_RootConstrainSelectedInstOperands,
     /*  377895 */     // GIR_Coverage, 60803,
     /*  377895 */     GIR_EraseRootFromParent_Done,
     /*  377896 */   // Label 6797: @377896
     /*  377896 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(377962), // Rule ID 60806 //
     /*  377901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  377943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377960 */     GIR_RootConstrainSelectedInstOperands,
     /*  377961 */     // GIR_Coverage, 60806,
     /*  377961 */     GIR_EraseRootFromParent_Done,
     /*  377962 */   // Label 6798: @377962
     /*  377962 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(378028), // Rule ID 60807 //
     /*  377967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  377975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  378009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378026 */     GIR_RootConstrainSelectedInstOperands,
     /*  378027 */     // GIR_Coverage, 60807,
     /*  378027 */     GIR_EraseRootFromParent_Done,
     /*  378028 */   // Label 6799: @378028
     /*  378028 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(378094), // Rule ID 60810 //
     /*  378033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  378044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  378047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  378050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378092 */     GIR_RootConstrainSelectedInstOperands,
     /*  378093 */     // GIR_Coverage, 60810,
     /*  378093 */     GIR_EraseRootFromParent_Done,
     /*  378094 */   // Label 6800: @378094
     /*  378094 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(378160), // Rule ID 60811 //
     /*  378099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  378110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  378113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  378116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11118:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378158 */     GIR_RootConstrainSelectedInstOperands,
     /*  378159 */     // GIR_Coverage, 60811,
     /*  378159 */     GIR_EraseRootFromParent_Done,
     /*  378160 */   // Label 6801: @378160
     /*  378160 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(378226), // Rule ID 60814 //
     /*  378165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  378176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  378179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  378182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378224 */     GIR_RootConstrainSelectedInstOperands,
     /*  378225 */     // GIR_Coverage, 60814,
     /*  378225 */     GIR_EraseRootFromParent_Done,
     /*  378226 */   // Label 6802: @378226
     /*  378226 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(378292), // Rule ID 60815 //
     /*  378231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  378242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  378245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  378248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378290 */     GIR_RootConstrainSelectedInstOperands,
     /*  378291 */     // GIR_Coverage, 60815,
     /*  378291 */     GIR_EraseRootFromParent_Done,
     /*  378292 */   // Label 6803: @378292
     /*  378292 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(378358), // Rule ID 60818 //
     /*  378297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  378308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  378311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  378314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378356 */     GIR_RootConstrainSelectedInstOperands,
     /*  378357 */     // GIR_Coverage, 60818,
     /*  378357 */     GIR_EraseRootFromParent_Done,
     /*  378358 */   // Label 6804: @378358
     /*  378358 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(378424), // Rule ID 60819 //
     /*  378363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  378374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  378377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  378380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378422 */     GIR_RootConstrainSelectedInstOperands,
     /*  378423 */     // GIR_Coverage, 60819,
     /*  378423 */     GIR_EraseRootFromParent_Done,
     /*  378424 */   // Label 6805: @378424
     /*  378424 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(378490), // Rule ID 60822 //
     /*  378429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378488 */     GIR_RootConstrainSelectedInstOperands,
     /*  378489 */     // GIR_Coverage, 60822,
     /*  378489 */     GIR_EraseRootFromParent_Done,
     /*  378490 */   // Label 6806: @378490
     /*  378490 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(378556), // Rule ID 60823 //
     /*  378495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  378506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  378509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  378512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  378537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378554 */     GIR_RootConstrainSelectedInstOperands,
     /*  378555 */     // GIR_Coverage, 60823,
     /*  378555 */     GIR_EraseRootFromParent_Done,
     /*  378556 */   // Label 6807: @378556
     /*  378556 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(378622), // Rule ID 60826 //
     /*  378561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378620 */     GIR_RootConstrainSelectedInstOperands,
     /*  378621 */     // GIR_Coverage, 60826,
     /*  378621 */     GIR_EraseRootFromParent_Done,
     /*  378622 */   // Label 6808: @378622
     /*  378622 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(378688), // Rule ID 60827 //
     /*  378627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  378638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  378641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  378644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378686 */     GIR_RootConstrainSelectedInstOperands,
     /*  378687 */     // GIR_Coverage, 60827,
     /*  378687 */     GIR_EraseRootFromParent_Done,
     /*  378688 */   // Label 6809: @378688
     /*  378688 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(378754), // Rule ID 60830 //
     /*  378693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378732 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  378735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378752 */     GIR_RootConstrainSelectedInstOperands,
     /*  378753 */     // GIR_Coverage, 60830,
     /*  378753 */     GIR_EraseRootFromParent_Done,
     /*  378754 */   // Label 6810: @378754
     /*  378754 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(378820), // Rule ID 60831 //
     /*  378759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  378770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  378773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  378776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  378801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378818 */     GIR_RootConstrainSelectedInstOperands,
     /*  378819 */     // GIR_Coverage, 60831,
     /*  378819 */     GIR_EraseRootFromParent_Done,
     /*  378820 */   // Label 6811: @378820
     /*  378820 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(378886), // Rule ID 60834 //
     /*  378825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378864 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  378867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378884 */     GIR_RootConstrainSelectedInstOperands,
     /*  378885 */     // GIR_Coverage, 60834,
     /*  378885 */     GIR_EraseRootFromParent_Done,
     /*  378886 */   // Label 6812: @378886
     /*  378886 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(378952), // Rule ID 60835 //
     /*  378891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  378902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  378905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  378908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  378933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378950 */     GIR_RootConstrainSelectedInstOperands,
     /*  378951 */     // GIR_Coverage, 60835,
     /*  378951 */     GIR_EraseRootFromParent_Done,
     /*  378952 */   // Label 6813: @378952
     /*  378952 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(379018), // Rule ID 60838 //
     /*  378957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  378965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  378999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379016 */     GIR_RootConstrainSelectedInstOperands,
     /*  379017 */     // GIR_Coverage, 60838,
     /*  379017 */     GIR_EraseRootFromParent_Done,
     /*  379018 */   // Label 6814: @379018
     /*  379018 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(379084), // Rule ID 60839 //
     /*  379023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  379034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  379037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  379040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379082 */     GIR_RootConstrainSelectedInstOperands,
     /*  379083 */     // GIR_Coverage, 60839,
     /*  379083 */     GIR_EraseRootFromParent_Done,
     /*  379084 */   // Label 6815: @379084
     /*  379084 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(379150), // Rule ID 60842 //
     /*  379089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  379100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  379103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  379106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379148 */     GIR_RootConstrainSelectedInstOperands,
     /*  379149 */     // GIR_Coverage, 60842,
     /*  379149 */     GIR_EraseRootFromParent_Done,
     /*  379150 */   // Label 6816: @379150
     /*  379150 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(379216), // Rule ID 60843 //
     /*  379155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  379166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  379169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  379172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379214 */     GIR_RootConstrainSelectedInstOperands,
     /*  379215 */     // GIR_Coverage, 60843,
     /*  379215 */     GIR_EraseRootFromParent_Done,
     /*  379216 */   // Label 6817: @379216
     /*  379216 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(379282), // Rule ID 60846 //
     /*  379221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  379232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  379235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  379238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379280 */     GIR_RootConstrainSelectedInstOperands,
     /*  379281 */     // GIR_Coverage, 60846,
     /*  379281 */     GIR_EraseRootFromParent_Done,
     /*  379282 */   // Label 6818: @379282
     /*  379282 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(379348), // Rule ID 60847 //
     /*  379287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  379298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  379301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  379304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379346 */     GIR_RootConstrainSelectedInstOperands,
     /*  379347 */     // GIR_Coverage, 60847,
     /*  379347 */     GIR_EraseRootFromParent_Done,
     /*  379348 */   // Label 6819: @379348
     /*  379348 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(379414), // Rule ID 60850 //
     /*  379353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  379364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  379367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  379370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379412 */     GIR_RootConstrainSelectedInstOperands,
     /*  379413 */     // GIR_Coverage, 60850,
     /*  379413 */     GIR_EraseRootFromParent_Done,
     /*  379414 */   // Label 6820: @379414
     /*  379414 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(379480), // Rule ID 60851 //
     /*  379419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  379430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  379433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  379436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379478 */     GIR_RootConstrainSelectedInstOperands,
     /*  379479 */     // GIR_Coverage, 60851,
     /*  379479 */     GIR_EraseRootFromParent_Done,
     /*  379480 */   // Label 6821: @379480
     /*  379480 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(379546), // Rule ID 60854 //
     /*  379485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379544 */     GIR_RootConstrainSelectedInstOperands,
     /*  379545 */     // GIR_Coverage, 60854,
     /*  379545 */     GIR_EraseRootFromParent_Done,
     /*  379546 */   // Label 6822: @379546
     /*  379546 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(379612), // Rule ID 60855 //
     /*  379551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  379562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  379565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  379568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379610 */     GIR_RootConstrainSelectedInstOperands,
     /*  379611 */     // GIR_Coverage, 60855,
     /*  379611 */     GIR_EraseRootFromParent_Done,
     /*  379612 */   // Label 6823: @379612
     /*  379612 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(379678), // Rule ID 60858 //
     /*  379617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379676 */     GIR_RootConstrainSelectedInstOperands,
     /*  379677 */     // GIR_Coverage, 60858,
     /*  379677 */     GIR_EraseRootFromParent_Done,
     /*  379678 */   // Label 6824: @379678
     /*  379678 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(379744), // Rule ID 60859 //
     /*  379683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  379694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  379697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  379700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  379725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379742 */     GIR_RootConstrainSelectedInstOperands,
     /*  379743 */     // GIR_Coverage, 60859,
     /*  379743 */     GIR_EraseRootFromParent_Done,
     /*  379744 */   // Label 6825: @379744
     /*  379744 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(379810), // Rule ID 60862 //
     /*  379749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379808 */     GIR_RootConstrainSelectedInstOperands,
     /*  379809 */     // GIR_Coverage, 60862,
     /*  379809 */     GIR_EraseRootFromParent_Done,
     /*  379810 */   // Label 6826: @379810
     /*  379810 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(379876), // Rule ID 60863 //
     /*  379815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  379826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  379829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  379832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  379847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  379857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379874 */     GIR_RootConstrainSelectedInstOperands,
     /*  379875 */     // GIR_Coverage, 60863,
     /*  379875 */     GIR_EraseRootFromParent_Done,
     /*  379876 */   // Label 6827: @379876
     /*  379876 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(379942), // Rule ID 60866 //
     /*  379881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379920 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379940 */     GIR_RootConstrainSelectedInstOperands,
     /*  379941 */     // GIR_Coverage, 60866,
     /*  379941 */     GIR_EraseRootFromParent_Done,
     /*  379942 */   // Label 6828: @379942
     /*  379942 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(380008), // Rule ID 60867 //
     /*  379947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  379955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  379989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380006 */     GIR_RootConstrainSelectedInstOperands,
     /*  380007 */     // GIR_Coverage, 60867,
     /*  380007 */     GIR_EraseRootFromParent_Done,
     /*  380008 */   // Label 6829: @380008
     /*  380008 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(380074), // Rule ID 60870 //
     /*  380013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  380021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  380024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  380027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  380030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  380055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380072 */     GIR_RootConstrainSelectedInstOperands,
     /*  380073 */     // GIR_Coverage, 60870,
     /*  380073 */     GIR_EraseRootFromParent_Done,
     /*  380074 */   // Label 6830: @380074
     /*  380074 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(380140), // Rule ID 60871 //
     /*  380079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  380087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  380090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  380093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  380096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  380121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380138 */     GIR_RootConstrainSelectedInstOperands,
     /*  380139 */     // GIR_Coverage, 60871,
     /*  380139 */     GIR_EraseRootFromParent_Done,
     /*  380140 */   // Label 6831: @380140
     /*  380140 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(380206), // Rule ID 60874 //
     /*  380145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  380156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  380159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  380162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380184 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  380187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380204 */     GIR_RootConstrainSelectedInstOperands,
     /*  380205 */     // GIR_Coverage, 60874,
     /*  380205 */     GIR_EraseRootFromParent_Done,
     /*  380206 */   // Label 6832: @380206
     /*  380206 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(380272), // Rule ID 60875 //
     /*  380211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  380222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  380225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  380228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  380253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380270 */     GIR_RootConstrainSelectedInstOperands,
     /*  380271 */     // GIR_Coverage, 60875,
     /*  380271 */     GIR_EraseRootFromParent_Done,
     /*  380272 */   // Label 6833: @380272
     /*  380272 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(380338), // Rule ID 60878 //
     /*  380277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  380288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  380291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  380294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380336 */     GIR_RootConstrainSelectedInstOperands,
     /*  380337 */     // GIR_Coverage, 60878,
     /*  380337 */     GIR_EraseRootFromParent_Done,
     /*  380338 */   // Label 6834: @380338
     /*  380338 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(380404), // Rule ID 60879 //
     /*  380343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  380354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  380357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  380360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380402 */     GIR_RootConstrainSelectedInstOperands,
     /*  380403 */     // GIR_Coverage, 60879,
     /*  380403 */     GIR_EraseRootFromParent_Done,
     /*  380404 */   // Label 6835: @380404
     /*  380404 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(380470), // Rule ID 60882 //
     /*  380409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380468 */     GIR_RootConstrainSelectedInstOperands,
     /*  380469 */     // GIR_Coverage, 60882,
     /*  380469 */     GIR_EraseRootFromParent_Done,
     /*  380470 */   // Label 6836: @380470
     /*  380470 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(380536), // Rule ID 60883 //
     /*  380475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  380486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  380489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  380492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380514 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380534 */     GIR_RootConstrainSelectedInstOperands,
     /*  380535 */     // GIR_Coverage, 60883,
     /*  380535 */     GIR_EraseRootFromParent_Done,
     /*  380536 */   // Label 6837: @380536
     /*  380536 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(380602), // Rule ID 60886 //
     /*  380541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380600 */     GIR_RootConstrainSelectedInstOperands,
     /*  380601 */     // GIR_Coverage, 60886,
     /*  380601 */     GIR_EraseRootFromParent_Done,
     /*  380602 */   // Label 6838: @380602
     /*  380602 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(380668), // Rule ID 60887 //
     /*  380607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  380618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  380621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  380624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  380649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380666 */     GIR_RootConstrainSelectedInstOperands,
     /*  380667 */     // GIR_Coverage, 60887,
     /*  380667 */     GIR_EraseRootFromParent_Done,
     /*  380668 */   // Label 6839: @380668
     /*  380668 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(380734), // Rule ID 60890 //
     /*  380673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380732 */     GIR_RootConstrainSelectedInstOperands,
     /*  380733 */     // GIR_Coverage, 60890,
     /*  380733 */     GIR_EraseRootFromParent_Done,
     /*  380734 */   // Label 6840: @380734
     /*  380734 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(380800), // Rule ID 60891 //
     /*  380739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  380750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  380753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  380756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380778 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380798 */     GIR_RootConstrainSelectedInstOperands,
     /*  380799 */     // GIR_Coverage, 60891,
     /*  380799 */     GIR_EraseRootFromParent_Done,
     /*  380800 */   // Label 6841: @380800
     /*  380800 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(380866), // Rule ID 60894 //
     /*  380805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380864 */     GIR_RootConstrainSelectedInstOperands,
     /*  380865 */     // GIR_Coverage, 60894,
     /*  380865 */     GIR_EraseRootFromParent_Done,
     /*  380866 */   // Label 6842: @380866
     /*  380866 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(380932), // Rule ID 60895 //
     /*  380871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  380874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  380882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  380885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  380888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  380913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380930 */     GIR_RootConstrainSelectedInstOperands,
     /*  380931 */     // GIR_Coverage, 60895,
     /*  380931 */     GIR_EraseRootFromParent_Done,
     /*  380932 */   // Label 6843: @380932
     /*  380932 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(380998), // Rule ID 60898 //
     /*  380937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  380940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  380945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  380979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380996 */     GIR_RootConstrainSelectedInstOperands,
     /*  380997 */     // GIR_Coverage, 60898,
     /*  380997 */     GIR_EraseRootFromParent_Done,
     /*  380998 */   // Label 6844: @380998
     /*  380998 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(381064), // Rule ID 60899 //
     /*  381003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  381014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  381017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  381020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11116:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381062 */     GIR_RootConstrainSelectedInstOperands,
     /*  381063 */     // GIR_Coverage, 60899,
     /*  381063 */     GIR_EraseRootFromParent_Done,
     /*  381064 */   // Label 6845: @381064
     /*  381064 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(381130), // Rule ID 60902 //
     /*  381069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  381080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  381083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  381086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381128 */     GIR_RootConstrainSelectedInstOperands,
     /*  381129 */     // GIR_Coverage, 60902,
     /*  381129 */     GIR_EraseRootFromParent_Done,
     /*  381130 */   // Label 6846: @381130
     /*  381130 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(381196), // Rule ID 60903 //
     /*  381135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  381146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  381149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  381152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381194 */     GIR_RootConstrainSelectedInstOperands,
     /*  381195 */     // GIR_Coverage, 60903,
     /*  381195 */     GIR_EraseRootFromParent_Done,
     /*  381196 */   // Label 6847: @381196
     /*  381196 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(381262), // Rule ID 60906 //
     /*  381201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  381212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  381215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  381218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381260 */     GIR_RootConstrainSelectedInstOperands,
     /*  381261 */     // GIR_Coverage, 60906,
     /*  381261 */     GIR_EraseRootFromParent_Done,
     /*  381262 */   // Label 6848: @381262
     /*  381262 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(381328), // Rule ID 60907 //
     /*  381267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  381278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  381281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  381284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381326 */     GIR_RootConstrainSelectedInstOperands,
     /*  381327 */     // GIR_Coverage, 60907,
     /*  381327 */     GIR_EraseRootFromParent_Done,
     /*  381328 */   // Label 6849: @381328
     /*  381328 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(381394), // Rule ID 60910 //
     /*  381333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  381344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  381347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  381350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381392 */     GIR_RootConstrainSelectedInstOperands,
     /*  381393 */     // GIR_Coverage, 60910,
     /*  381393 */     GIR_EraseRootFromParent_Done,
     /*  381394 */   // Label 6850: @381394
     /*  381394 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(381460), // Rule ID 60911 //
     /*  381399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  381410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  381413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  381416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  381441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381458 */     GIR_RootConstrainSelectedInstOperands,
     /*  381459 */     // GIR_Coverage, 60911,
     /*  381459 */     GIR_EraseRootFromParent_Done,
     /*  381460 */   // Label 6851: @381460
     /*  381460 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(381526), // Rule ID 60914 //
     /*  381465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381524 */     GIR_RootConstrainSelectedInstOperands,
     /*  381525 */     // GIR_Coverage, 60914,
     /*  381525 */     GIR_EraseRootFromParent_Done,
     /*  381526 */   // Label 6852: @381526
     /*  381526 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(381592), // Rule ID 60915 //
     /*  381531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  381542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  381545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  381548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381590 */     GIR_RootConstrainSelectedInstOperands,
     /*  381591 */     // GIR_Coverage, 60915,
     /*  381591 */     GIR_EraseRootFromParent_Done,
     /*  381592 */   // Label 6853: @381592
     /*  381592 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(381658), // Rule ID 60918 //
     /*  381597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  381639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381656 */     GIR_RootConstrainSelectedInstOperands,
     /*  381657 */     // GIR_Coverage, 60918,
     /*  381657 */     GIR_EraseRootFromParent_Done,
     /*  381658 */   // Label 6854: @381658
     /*  381658 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(381724), // Rule ID 60919 //
     /*  381663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  381674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  381677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  381680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  381705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381722 */     GIR_RootConstrainSelectedInstOperands,
     /*  381723 */     // GIR_Coverage, 60919,
     /*  381723 */     GIR_EraseRootFromParent_Done,
     /*  381724 */   // Label 6855: @381724
     /*  381724 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(381790), // Rule ID 60922 //
     /*  381729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381768 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  381771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381788 */     GIR_RootConstrainSelectedInstOperands,
     /*  381789 */     // GIR_Coverage, 60922,
     /*  381789 */     GIR_EraseRootFromParent_Done,
     /*  381790 */   // Label 6856: @381790
     /*  381790 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(381856), // Rule ID 60923 //
     /*  381795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  381806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  381809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  381812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  381837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381854 */     GIR_RootConstrainSelectedInstOperands,
     /*  381855 */     // GIR_Coverage, 60923,
     /*  381855 */     GIR_EraseRootFromParent_Done,
     /*  381856 */   // Label 6857: @381856
     /*  381856 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(381922), // Rule ID 60926 //
     /*  381861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381920 */     GIR_RootConstrainSelectedInstOperands,
     /*  381921 */     // GIR_Coverage, 60926,
     /*  381921 */     GIR_EraseRootFromParent_Done,
     /*  381922 */   // Label 6858: @381922
     /*  381922 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(381988), // Rule ID 60927 //
     /*  381927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  381930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  381935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  381938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  381969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381986 */     GIR_RootConstrainSelectedInstOperands,
     /*  381987 */     // GIR_Coverage, 60927,
     /*  381987 */     GIR_EraseRootFromParent_Done,
     /*  381988 */   // Label 6859: @381988
     /*  381988 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(382054), // Rule ID 60930 //
     /*  381993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  381996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  382004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  382007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  382010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382052 */     GIR_RootConstrainSelectedInstOperands,
     /*  382053 */     // GIR_Coverage, 60930,
     /*  382053 */     GIR_EraseRootFromParent_Done,
     /*  382054 */   // Label 6860: @382054
     /*  382054 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(382120), // Rule ID 60931 //
     /*  382059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  382070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  382073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  382076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382098 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382118 */     GIR_RootConstrainSelectedInstOperands,
     /*  382119 */     // GIR_Coverage, 60931,
     /*  382119 */     GIR_EraseRootFromParent_Done,
     /*  382120 */   // Label 6861: @382120
     /*  382120 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(382186), // Rule ID 60934 //
     /*  382125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  382136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  382139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  382142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382184 */     GIR_RootConstrainSelectedInstOperands,
     /*  382185 */     // GIR_Coverage, 60934,
     /*  382185 */     GIR_EraseRootFromParent_Done,
     /*  382186 */   // Label 6862: @382186
     /*  382186 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(382252), // Rule ID 60935 //
     /*  382191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  382202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  382205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  382208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382250 */     GIR_RootConstrainSelectedInstOperands,
     /*  382251 */     // GIR_Coverage, 60935,
     /*  382251 */     GIR_EraseRootFromParent_Done,
     /*  382252 */   // Label 6863: @382252
     /*  382252 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(382318), // Rule ID 60938 //
     /*  382257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  382268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  382271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  382274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382316 */     GIR_RootConstrainSelectedInstOperands,
     /*  382317 */     // GIR_Coverage, 60938,
     /*  382317 */     GIR_EraseRootFromParent_Done,
     /*  382318 */   // Label 6864: @382318
     /*  382318 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(382384), // Rule ID 60939 //
     /*  382323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  382334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  382337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  382340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382382 */     GIR_RootConstrainSelectedInstOperands,
     /*  382383 */     // GIR_Coverage, 60939,
     /*  382383 */     GIR_EraseRootFromParent_Done,
     /*  382384 */   // Label 6865: @382384
     /*  382384 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(382450), // Rule ID 60942 //
     /*  382389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382448 */     GIR_RootConstrainSelectedInstOperands,
     /*  382449 */     // GIR_Coverage, 60942,
     /*  382449 */     GIR_EraseRootFromParent_Done,
     /*  382450 */   // Label 6866: @382450
     /*  382450 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(382516), // Rule ID 60943 //
     /*  382455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  382466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  382469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  382472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382514 */     GIR_RootConstrainSelectedInstOperands,
     /*  382515 */     // GIR_Coverage, 60943,
     /*  382515 */     GIR_EraseRootFromParent_Done,
     /*  382516 */   // Label 6867: @382516
     /*  382516 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(382582), // Rule ID 60946 //
     /*  382521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382580 */     GIR_RootConstrainSelectedInstOperands,
     /*  382581 */     // GIR_Coverage, 60946,
     /*  382581 */     GIR_EraseRootFromParent_Done,
     /*  382582 */   // Label 6868: @382582
     /*  382582 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(382648), // Rule ID 60947 //
     /*  382587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  382598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  382601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  382604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382646 */     GIR_RootConstrainSelectedInstOperands,
     /*  382647 */     // GIR_Coverage, 60947,
     /*  382647 */     GIR_EraseRootFromParent_Done,
     /*  382648 */   // Label 6869: @382648
     /*  382648 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(382714), // Rule ID 60950 //
     /*  382653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382712 */     GIR_RootConstrainSelectedInstOperands,
     /*  382713 */     // GIR_Coverage, 60950,
     /*  382713 */     GIR_EraseRootFromParent_Done,
     /*  382714 */   // Label 6870: @382714
     /*  382714 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(382780), // Rule ID 60951 //
     /*  382719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  382730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  382733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  382736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  382761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382778 */     GIR_RootConstrainSelectedInstOperands,
     /*  382779 */     // GIR_Coverage, 60951,
     /*  382779 */     GIR_EraseRootFromParent_Done,
     /*  382780 */   // Label 6871: @382780
     /*  382780 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(382846), // Rule ID 60954 //
     /*  382785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382824 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382844 */     GIR_RootConstrainSelectedInstOperands,
     /*  382845 */     // GIR_Coverage, 60954,
     /*  382845 */     GIR_EraseRootFromParent_Done,
     /*  382846 */   // Label 6872: @382846
     /*  382846 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(382912), // Rule ID 60955 //
     /*  382851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  382862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  382865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  382868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  382883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  382893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382910 */     GIR_RootConstrainSelectedInstOperands,
     /*  382911 */     // GIR_Coverage, 60955,
     /*  382911 */     GIR_EraseRootFromParent_Done,
     /*  382912 */   // Label 6873: @382912
     /*  382912 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(382978), // Rule ID 60958 //
     /*  382917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  382920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  382959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382976 */     GIR_RootConstrainSelectedInstOperands,
     /*  382977 */     // GIR_Coverage, 60958,
     /*  382977 */     GIR_EraseRootFromParent_Done,
     /*  382978 */   // Label 6874: @382978
     /*  382978 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(383044), // Rule ID 60959 //
     /*  382983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  382986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  382991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  383000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  383025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383042 */     GIR_RootConstrainSelectedInstOperands,
     /*  383043 */     // GIR_Coverage, 60959,
     /*  383043 */     GIR_EraseRootFromParent_Done,
     /*  383044 */   // Label 6875: @383044
     /*  383044 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(383110), // Rule ID 61382 //
     /*  383049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  383060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  383063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  383066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383088 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  383091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383108 */     GIR_RootConstrainSelectedInstOperands,
     /*  383109 */     // GIR_Coverage, 61382,
     /*  383109 */     GIR_EraseRootFromParent_Done,
     /*  383110 */   // Label 6876: @383110
     /*  383110 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(383176), // Rule ID 61383 //
     /*  383115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  383126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  383129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  383132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  383157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383174 */     GIR_RootConstrainSelectedInstOperands,
     /*  383175 */     // GIR_Coverage, 61383,
     /*  383175 */     GIR_EraseRootFromParent_Done,
     /*  383176 */   // Label 6877: @383176
     /*  383176 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(383242), // Rule ID 61386 //
     /*  383181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  383192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  383195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  383198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383240 */     GIR_RootConstrainSelectedInstOperands,
     /*  383241 */     // GIR_Coverage, 61386,
     /*  383241 */     GIR_EraseRootFromParent_Done,
     /*  383242 */   // Label 6878: @383242
     /*  383242 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(383308), // Rule ID 61387 //
     /*  383247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  383258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  383261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  383264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383306 */     GIR_RootConstrainSelectedInstOperands,
     /*  383307 */     // GIR_Coverage, 61387,
     /*  383307 */     GIR_EraseRootFromParent_Done,
     /*  383308 */   // Label 6879: @383308
     /*  383308 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(383374), // Rule ID 61390 //
     /*  383313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  383324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  383327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  383330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383372 */     GIR_RootConstrainSelectedInstOperands,
     /*  383373 */     // GIR_Coverage, 61390,
     /*  383373 */     GIR_EraseRootFromParent_Done,
     /*  383374 */   // Label 6880: @383374
     /*  383374 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(383440), // Rule ID 61391 //
     /*  383379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  383390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  383393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  383396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383438 */     GIR_RootConstrainSelectedInstOperands,
     /*  383439 */     // GIR_Coverage, 61391,
     /*  383439 */     GIR_EraseRootFromParent_Done,
     /*  383440 */   // Label 6881: @383440
     /*  383440 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(383506), // Rule ID 61394 //
     /*  383445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383504 */     GIR_RootConstrainSelectedInstOperands,
     /*  383505 */     // GIR_Coverage, 61394,
     /*  383505 */     GIR_EraseRootFromParent_Done,
     /*  383506 */   // Label 6882: @383506
     /*  383506 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(383572), // Rule ID 61395 //
     /*  383511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  383522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  383525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  383528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  383553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383570 */     GIR_RootConstrainSelectedInstOperands,
     /*  383571 */     // GIR_Coverage, 61395,
     /*  383571 */     GIR_EraseRootFromParent_Done,
     /*  383572 */   // Label 6883: @383572
     /*  383572 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(383638), // Rule ID 61398 //
     /*  383577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383636 */     GIR_RootConstrainSelectedInstOperands,
     /*  383637 */     // GIR_Coverage, 61398,
     /*  383637 */     GIR_EraseRootFromParent_Done,
     /*  383638 */   // Label 6884: @383638
     /*  383638 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(383704), // Rule ID 61399 //
     /*  383643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  383654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  383657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  383660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383682 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383702 */     GIR_RootConstrainSelectedInstOperands,
     /*  383703 */     // GIR_Coverage, 61399,
     /*  383703 */     GIR_EraseRootFromParent_Done,
     /*  383704 */   // Label 6885: @383704
     /*  383704 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(383770), // Rule ID 61402 //
     /*  383709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383768 */     GIR_RootConstrainSelectedInstOperands,
     /*  383769 */     // GIR_Coverage, 61402,
     /*  383769 */     GIR_EraseRootFromParent_Done,
     /*  383770 */   // Label 6886: @383770
     /*  383770 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(383836), // Rule ID 61403 //
     /*  383775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  383786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  383789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  383792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  383817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383834 */     GIR_RootConstrainSelectedInstOperands,
     /*  383835 */     // GIR_Coverage, 61403,
     /*  383835 */     GIR_EraseRootFromParent_Done,
     /*  383836 */   // Label 6887: @383836
     /*  383836 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(383902), // Rule ID 61406 //
     /*  383841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  383883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383900 */     GIR_RootConstrainSelectedInstOperands,
     /*  383901 */     // GIR_Coverage, 61406,
     /*  383901 */     GIR_EraseRootFromParent_Done,
     /*  383902 */   // Label 6888: @383902
     /*  383902 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(383968), // Rule ID 61407 //
     /*  383907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  383918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  383921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  383924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  383949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383966 */     GIR_RootConstrainSelectedInstOperands,
     /*  383967 */     // GIR_Coverage, 61407,
     /*  383967 */     GIR_EraseRootFromParent_Done,
     /*  383968 */   // Label 6889: @383968
     /*  383968 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(384034), // Rule ID 61410 //
     /*  383973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  383981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384032 */     GIR_RootConstrainSelectedInstOperands,
     /*  384033 */     // GIR_Coverage, 61410,
     /*  384033 */     GIR_EraseRootFromParent_Done,
     /*  384034 */   // Label 6890: @384034
     /*  384034 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(384100), // Rule ID 61411 //
     /*  384039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  384050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  384053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  384056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384098 */     GIR_RootConstrainSelectedInstOperands,
     /*  384099 */     // GIR_Coverage, 61411,
     /*  384099 */     GIR_EraseRootFromParent_Done,
     /*  384100 */   // Label 6891: @384100
     /*  384100 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(384166), // Rule ID 61414 //
     /*  384105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  384116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  384119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  384122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384164 */     GIR_RootConstrainSelectedInstOperands,
     /*  384165 */     // GIR_Coverage, 61414,
     /*  384165 */     GIR_EraseRootFromParent_Done,
     /*  384166 */   // Label 6892: @384166
     /*  384166 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(384232), // Rule ID 61415 //
     /*  384171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  384182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  384185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  384188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384210 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384230 */     GIR_RootConstrainSelectedInstOperands,
     /*  384231 */     // GIR_Coverage, 61415,
     /*  384231 */     GIR_EraseRootFromParent_Done,
     /*  384232 */   // Label 6893: @384232
     /*  384232 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(384298), // Rule ID 61418 //
     /*  384237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  384248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  384251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  384254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384296 */     GIR_RootConstrainSelectedInstOperands,
     /*  384297 */     // GIR_Coverage, 61418,
     /*  384297 */     GIR_EraseRootFromParent_Done,
     /*  384298 */   // Label 6894: @384298
     /*  384298 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(384364), // Rule ID 61419 //
     /*  384303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  384314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  384317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  384320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  384335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  384345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384362 */     GIR_RootConstrainSelectedInstOperands,
     /*  384363 */     // GIR_Coverage, 61419,
     /*  384363 */     GIR_EraseRootFromParent_Done,
     /*  384364 */   // Label 6895: @384364
     /*  384364 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(384430), // Rule ID 61422 //
     /*  384369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  384380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  384383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  384386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384428 */     GIR_RootConstrainSelectedInstOperands,
     /*  384429 */     // GIR_Coverage, 61422,
     /*  384429 */     GIR_EraseRootFromParent_Done,
     /*  384430 */   // Label 6896: @384430
     /*  384430 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(384496), // Rule ID 61423 //
     /*  384435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  384446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  384449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  384452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384494 */     GIR_RootConstrainSelectedInstOperands,
     /*  384495 */     // GIR_Coverage, 61423,
     /*  384495 */     GIR_EraseRootFromParent_Done,
     /*  384496 */   // Label 6897: @384496
     /*  384496 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(384562), // Rule ID 61426 //
     /*  384501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384560 */     GIR_RootConstrainSelectedInstOperands,
     /*  384561 */     // GIR_Coverage, 61426,
     /*  384561 */     GIR_EraseRootFromParent_Done,
     /*  384562 */   // Label 6898: @384562
     /*  384562 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(384628), // Rule ID 61427 //
     /*  384567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  384578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  384581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  384584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384606 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384626 */     GIR_RootConstrainSelectedInstOperands,
     /*  384627 */     // GIR_Coverage, 61427,
     /*  384627 */     GIR_EraseRootFromParent_Done,
     /*  384628 */   // Label 6899: @384628
     /*  384628 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(384694), // Rule ID 61430 //
     /*  384633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  384672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  384675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384692 */     GIR_RootConstrainSelectedInstOperands,
     /*  384693 */     // GIR_Coverage, 61430,
     /*  384693 */     GIR_EraseRootFromParent_Done,
     /*  384694 */   // Label 6900: @384694
     /*  384694 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(384760), // Rule ID 61431 //
     /*  384699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  384710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  384713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  384716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  384738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  384741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  384755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384758 */     GIR_RootConstrainSelectedInstOperands,
     /*  384759 */     // GIR_Coverage, 61431,
     /*  384759 */     GIR_EraseRootFromParent_Done,
     /*  384760 */   // Label 6901: @384760
     /*  384760 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(384826), // Rule ID 61434 //
     /*  384765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384824 */     GIR_RootConstrainSelectedInstOperands,
     /*  384825 */     // GIR_Coverage, 61434,
     /*  384825 */     GIR_EraseRootFromParent_Done,
     /*  384826 */   // Label 6902: @384826
     /*  384826 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(384892), // Rule ID 61435 //
     /*  384831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  384842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  384845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  384848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  384873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384890 */     GIR_RootConstrainSelectedInstOperands,
     /*  384891 */     // GIR_Coverage, 61435,
     /*  384891 */     GIR_EraseRootFromParent_Done,
     /*  384892 */   // Label 6903: @384892
     /*  384892 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(384958), // Rule ID 61438 //
     /*  384897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  384939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384956 */     GIR_RootConstrainSelectedInstOperands,
     /*  384957 */     // GIR_Coverage, 61438,
     /*  384957 */     GIR_EraseRootFromParent_Done,
     /*  384958 */   // Label 6904: @384958
     /*  384958 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(385024), // Rule ID 61439 //
     /*  384963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  384971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385022 */     GIR_RootConstrainSelectedInstOperands,
     /*  385023 */     // GIR_Coverage, 61439,
     /*  385023 */     GIR_EraseRootFromParent_Done,
     /*  385024 */   // Label 6905: @385024
     /*  385024 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(385090), // Rule ID 61442 //
     /*  385029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  385068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385088 */     GIR_RootConstrainSelectedInstOperands,
     /*  385089 */     // GIR_Coverage, 61442,
     /*  385089 */     GIR_EraseRootFromParent_Done,
     /*  385090 */   // Label 6906: @385090
     /*  385090 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(385156), // Rule ID 61443 //
     /*  385095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  385106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  385109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  385112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  385134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  385151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385154 */     GIR_RootConstrainSelectedInstOperands,
     /*  385155 */     // GIR_Coverage, 61443,
     /*  385155 */     GIR_EraseRootFromParent_Done,
     /*  385156 */   // Label 6907: @385156
     /*  385156 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(385222), // Rule ID 61446 //
     /*  385161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  385172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  385175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  385178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385220 */     GIR_RootConstrainSelectedInstOperands,
     /*  385221 */     // GIR_Coverage, 61446,
     /*  385221 */     GIR_EraseRootFromParent_Done,
     /*  385222 */   // Label 6908: @385222
     /*  385222 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(385288), // Rule ID 61447 //
     /*  385227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  385238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  385241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  385244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385286 */     GIR_RootConstrainSelectedInstOperands,
     /*  385287 */     // GIR_Coverage, 61447,
     /*  385287 */     GIR_EraseRootFromParent_Done,
     /*  385288 */   // Label 6909: @385288
     /*  385288 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(385354), // Rule ID 61450 //
     /*  385293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  385304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  385307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  385310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385352 */     GIR_RootConstrainSelectedInstOperands,
     /*  385353 */     // GIR_Coverage, 61450,
     /*  385353 */     GIR_EraseRootFromParent_Done,
     /*  385354 */   // Label 6910: @385354
     /*  385354 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(385420), // Rule ID 61451 //
     /*  385359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  385370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  385373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  385376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385418 */     GIR_RootConstrainSelectedInstOperands,
     /*  385419 */     // GIR_Coverage, 61451,
     /*  385419 */     GIR_EraseRootFromParent_Done,
     /*  385420 */   // Label 6911: @385420
     /*  385420 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(385486), // Rule ID 61454 //
     /*  385425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  385464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385484 */     GIR_RootConstrainSelectedInstOperands,
     /*  385485 */     // GIR_Coverage, 61454,
     /*  385485 */     GIR_EraseRootFromParent_Done,
     /*  385486 */   // Label 6912: @385486
     /*  385486 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(385552), // Rule ID 61455 //
     /*  385491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  385502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  385505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  385508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  385530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  385547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385550 */     GIR_RootConstrainSelectedInstOperands,
     /*  385551 */     // GIR_Coverage, 61455,
     /*  385551 */     GIR_EraseRootFromParent_Done,
     /*  385552 */   // Label 6913: @385552
     /*  385552 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(385618), // Rule ID 61458 //
     /*  385557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385616 */     GIR_RootConstrainSelectedInstOperands,
     /*  385617 */     // GIR_Coverage, 61458,
     /*  385617 */     GIR_EraseRootFromParent_Done,
     /*  385618 */   // Label 6914: @385618
     /*  385618 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(385684), // Rule ID 61459 //
     /*  385623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  385634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  385637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  385640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  385655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  385665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385682 */     GIR_RootConstrainSelectedInstOperands,
     /*  385683 */     // GIR_Coverage, 61459,
     /*  385683 */     GIR_EraseRootFromParent_Done,
     /*  385684 */   // Label 6915: @385684
     /*  385684 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(385750), // Rule ID 61462 //
     /*  385689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385748 */     GIR_RootConstrainSelectedInstOperands,
     /*  385749 */     // GIR_Coverage, 61462,
     /*  385749 */     GIR_EraseRootFromParent_Done,
     /*  385750 */   // Label 6916: @385750
     /*  385750 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(385816), // Rule ID 61463 //
     /*  385755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  385766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  385769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  385772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  385787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  385797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385814 */     GIR_RootConstrainSelectedInstOperands,
     /*  385815 */     // GIR_Coverage, 61463,
     /*  385815 */     GIR_EraseRootFromParent_Done,
     /*  385816 */   // Label 6917: @385816
     /*  385816 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(385882), // Rule ID 61466 //
     /*  385821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  385860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385880 */     GIR_RootConstrainSelectedInstOperands,
     /*  385881 */     // GIR_Coverage, 61466,
     /*  385881 */     GIR_EraseRootFromParent_Done,
     /*  385882 */   // Label 6918: @385882
     /*  385882 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(385948), // Rule ID 61467 //
     /*  385887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  385890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  385895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  385898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  385901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  385904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  385919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  385926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  385929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385946 */     GIR_RootConstrainSelectedInstOperands,
     /*  385947 */     // GIR_Coverage, 61467,
     /*  385947 */     GIR_EraseRootFromParent_Done,
     /*  385948 */   // Label 6919: @385948
     /*  385948 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(386014), // Rule ID 61470 //
     /*  385953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  385956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  385961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  385964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  385967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  385970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  385973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  385985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  385992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  385992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  385995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  385999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386012 */     GIR_RootConstrainSelectedInstOperands,
     /*  386013 */     // GIR_Coverage, 61470,
     /*  386013 */     GIR_EraseRootFromParent_Done,
     /*  386014 */   // Label 6920: @386014
     /*  386014 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(386080), // Rule ID 61471 //
     /*  386019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  386030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  386033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  386036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  386061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386078 */     GIR_RootConstrainSelectedInstOperands,
     /*  386079 */     // GIR_Coverage, 61471,
     /*  386079 */     GIR_EraseRootFromParent_Done,
     /*  386080 */   // Label 6921: @386080
     /*  386080 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(386146), // Rule ID 61474 //
     /*  386085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  386096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  386099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  386102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386124 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386144 */     GIR_RootConstrainSelectedInstOperands,
     /*  386145 */     // GIR_Coverage, 61474,
     /*  386145 */     GIR_EraseRootFromParent_Done,
     /*  386146 */   // Label 6922: @386146
     /*  386146 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(386212), // Rule ID 61475 //
     /*  386151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  386162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  386165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  386168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386210 */     GIR_RootConstrainSelectedInstOperands,
     /*  386211 */     // GIR_Coverage, 61475,
     /*  386211 */     GIR_EraseRootFromParent_Done,
     /*  386212 */   // Label 6923: @386212
     /*  386212 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(386278), // Rule ID 61478 //
     /*  386217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  386228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  386231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  386234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386276 */     GIR_RootConstrainSelectedInstOperands,
     /*  386277 */     // GIR_Coverage, 61478,
     /*  386277 */     GIR_EraseRootFromParent_Done,
     /*  386278 */   // Label 6924: @386278
     /*  386278 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(386344), // Rule ID 61479 //
     /*  386283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  386294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  386297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  386300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386342 */     GIR_RootConstrainSelectedInstOperands,
     /*  386343 */     // GIR_Coverage, 61479,
     /*  386343 */     GIR_EraseRootFromParent_Done,
     /*  386344 */   // Label 6925: @386344
     /*  386344 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(386410), // Rule ID 61482 //
     /*  386349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  386360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  386363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386408 */     GIR_RootConstrainSelectedInstOperands,
     /*  386409 */     // GIR_Coverage, 61482,
     /*  386409 */     GIR_EraseRootFromParent_Done,
     /*  386410 */   // Label 6926: @386410
     /*  386410 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(386476), // Rule ID 61483 //
     /*  386415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  386426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  386429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  386432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  386457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386474 */     GIR_RootConstrainSelectedInstOperands,
     /*  386475 */     // GIR_Coverage, 61483,
     /*  386475 */     GIR_EraseRootFromParent_Done,
     /*  386476 */   // Label 6927: @386476
     /*  386476 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(386542), // Rule ID 61486 //
     /*  386481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  386492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  386495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386540 */     GIR_RootConstrainSelectedInstOperands,
     /*  386541 */     // GIR_Coverage, 61486,
     /*  386541 */     GIR_EraseRootFromParent_Done,
     /*  386542 */   // Label 6928: @386542
     /*  386542 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(386608), // Rule ID 61487 //
     /*  386547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  386558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  386561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  386564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386606 */     GIR_RootConstrainSelectedInstOperands,
     /*  386607 */     // GIR_Coverage, 61487,
     /*  386607 */     GIR_EraseRootFromParent_Done,
     /*  386608 */   // Label 6929: @386608
     /*  386608 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(386674), // Rule ID 61490 //
     /*  386613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  386630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  386652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  386669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386672 */     GIR_RootConstrainSelectedInstOperands,
     /*  386673 */     // GIR_Coverage, 61490,
     /*  386673 */     GIR_EraseRootFromParent_Done,
     /*  386674 */   // Label 6930: @386674
     /*  386674 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(386740), // Rule ID 61491 //
     /*  386679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  386690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  386693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  386696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  386718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  386721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  386735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386738 */     GIR_RootConstrainSelectedInstOperands,
     /*  386739 */     // GIR_Coverage, 61491,
     /*  386739 */     GIR_EraseRootFromParent_Done,
     /*  386740 */   // Label 6931: @386740
     /*  386740 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(386806), // Rule ID 61494 //
     /*  386745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  386756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  386759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  386762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  386784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386804 */     GIR_RootConstrainSelectedInstOperands,
     /*  386805 */     // GIR_Coverage, 61494,
     /*  386805 */     GIR_EraseRootFromParent_Done,
     /*  386806 */   // Label 6932: @386806
     /*  386806 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(386872), // Rule ID 61495 //
     /*  386811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  386822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  386825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  386828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  386850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386870 */     GIR_RootConstrainSelectedInstOperands,
     /*  386871 */     // GIR_Coverage, 61495,
     /*  386871 */     GIR_EraseRootFromParent_Done,
     /*  386872 */   // Label 6933: @386872
     /*  386872 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(386938), // Rule ID 61498 //
     /*  386877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  386880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  386888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  386891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  386897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  386916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  386936 */     GIR_RootConstrainSelectedInstOperands,
     /*  386937 */     // GIR_Coverage, 61498,
     /*  386937 */     GIR_EraseRootFromParent_Done,
     /*  386938 */   // Label 6934: @386938
     /*  386938 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(387004), // Rule ID 61499 //
     /*  386943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  386946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  386951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  386954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  386957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  386960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  386982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  386985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  386989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  386999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387002 */     GIR_RootConstrainSelectedInstOperands,
     /*  387003 */     // GIR_Coverage, 61499,
     /*  387003 */     GIR_EraseRootFromParent_Done,
     /*  387004 */   // Label 6935: @387004
     /*  387004 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(387070), // Rule ID 61502 //
     /*  387009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  387020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  387023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  387048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387068 */     GIR_RootConstrainSelectedInstOperands,
     /*  387069 */     // GIR_Coverage, 61502,
     /*  387069 */     GIR_EraseRootFromParent_Done,
     /*  387070 */   // Label 6936: @387070
     /*  387070 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(387136), // Rule ID 61503 //
     /*  387075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  387086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  387089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  387092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  387114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387134 */     GIR_RootConstrainSelectedInstOperands,
     /*  387135 */     // GIR_Coverage, 61503,
     /*  387135 */     GIR_EraseRootFromParent_Done,
     /*  387136 */   // Label 6937: @387136
     /*  387136 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(387202), // Rule ID 61506 //
     /*  387141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  387158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  387180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  387197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387200 */     GIR_RootConstrainSelectedInstOperands,
     /*  387201 */     // GIR_Coverage, 61506,
     /*  387201 */     GIR_EraseRootFromParent_Done,
     /*  387202 */   // Label 6938: @387202
     /*  387202 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(387268), // Rule ID 61507 //
     /*  387207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  387218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  387221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  387224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  387246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  387249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  387263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387266 */     GIR_RootConstrainSelectedInstOperands,
     /*  387267 */     // GIR_Coverage, 61507,
     /*  387267 */     GIR_EraseRootFromParent_Done,
     /*  387268 */   // Label 6939: @387268
     /*  387268 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(387334), // Rule ID 61510 //
     /*  387273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  387284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  387287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  387290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387332 */     GIR_RootConstrainSelectedInstOperands,
     /*  387333 */     // GIR_Coverage, 61510,
     /*  387333 */     GIR_EraseRootFromParent_Done,
     /*  387334 */   // Label 6940: @387334
     /*  387334 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(387400), // Rule ID 61511 //
     /*  387339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  387350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  387353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  387356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387378 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387398 */     GIR_RootConstrainSelectedInstOperands,
     /*  387399 */     // GIR_Coverage, 61511,
     /*  387399 */     GIR_EraseRootFromParent_Done,
     /*  387400 */   // Label 6941: @387400
     /*  387400 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(387466), // Rule ID 61514 //
     /*  387405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  387416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  387419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  387422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387464 */     GIR_RootConstrainSelectedInstOperands,
     /*  387465 */     // GIR_Coverage, 61514,
     /*  387465 */     GIR_EraseRootFromParent_Done,
     /*  387466 */   // Label 6942: @387466
     /*  387466 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(387532), // Rule ID 61515 //
     /*  387471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  387482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  387485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  387488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387530 */     GIR_RootConstrainSelectedInstOperands,
     /*  387531 */     // GIR_Coverage, 61515,
     /*  387531 */     GIR_EraseRootFromParent_Done,
     /*  387532 */   // Label 6943: @387532
     /*  387532 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(387598), // Rule ID 61518 //
     /*  387537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  387548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  387551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  387554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  387576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387596 */     GIR_RootConstrainSelectedInstOperands,
     /*  387597 */     // GIR_Coverage, 61518,
     /*  387597 */     GIR_EraseRootFromParent_Done,
     /*  387598 */   // Label 6944: @387598
     /*  387598 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(387664), // Rule ID 61519 //
     /*  387603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  387614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  387617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  387620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  387642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387662 */     GIR_RootConstrainSelectedInstOperands,
     /*  387663 */     // GIR_Coverage, 61519,
     /*  387663 */     GIR_EraseRootFromParent_Done,
     /*  387664 */   // Label 6945: @387664
     /*  387664 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(387730), // Rule ID 61522 //
     /*  387669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  387680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  387683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  387686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387728 */     GIR_RootConstrainSelectedInstOperands,
     /*  387729 */     // GIR_Coverage, 61522,
     /*  387729 */     GIR_EraseRootFromParent_Done,
     /*  387730 */   // Label 6946: @387730
     /*  387730 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(387796), // Rule ID 61523 //
     /*  387735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  387746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  387749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  387752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  387767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  387777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387794 */     GIR_RootConstrainSelectedInstOperands,
     /*  387795 */     // GIR_Coverage, 61523,
     /*  387795 */     GIR_EraseRootFromParent_Done,
     /*  387796 */   // Label 6947: @387796
     /*  387796 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(387862), // Rule ID 61526 //
     /*  387801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  387812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  387815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387860 */     GIR_RootConstrainSelectedInstOperands,
     /*  387861 */     // GIR_Coverage, 61526,
     /*  387861 */     GIR_EraseRootFromParent_Done,
     /*  387862 */   // Label 6948: @387862
     /*  387862 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(387928), // Rule ID 61527 //
     /*  387867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  387870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  387878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  387881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  387884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  387899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  387906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  387909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387926 */     GIR_RootConstrainSelectedInstOperands,
     /*  387927 */     // GIR_Coverage, 61527,
     /*  387927 */     GIR_EraseRootFromParent_Done,
     /*  387928 */   // Label 6949: @387928
     /*  387928 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(387994), // Rule ID 61530 //
     /*  387933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  387936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  387941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  387944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  387947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  387950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  387953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  387965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  387972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  387975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  387979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  387992 */     GIR_RootConstrainSelectedInstOperands,
     /*  387993 */     // GIR_Coverage, 61530,
     /*  387993 */     GIR_EraseRootFromParent_Done,
     /*  387994 */   // Label 6950: @387994
     /*  387994 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(388060), // Rule ID 61531 //
     /*  387999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  388010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  388013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  388016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  388038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388058 */     GIR_RootConstrainSelectedInstOperands,
     /*  388059 */     // GIR_Coverage, 61531,
     /*  388059 */     GIR_EraseRootFromParent_Done,
     /*  388060 */   // Label 6951: @388060
     /*  388060 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(388126), // Rule ID 61534 //
     /*  388065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  388076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  388079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  388082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388124 */     GIR_RootConstrainSelectedInstOperands,
     /*  388125 */     // GIR_Coverage, 61534,
     /*  388125 */     GIR_EraseRootFromParent_Done,
     /*  388126 */   // Label 6952: @388126
     /*  388126 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(388192), // Rule ID 61535 //
     /*  388131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  388142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  388145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  388148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388190 */     GIR_RootConstrainSelectedInstOperands,
     /*  388191 */     // GIR_Coverage, 61535,
     /*  388191 */     GIR_EraseRootFromParent_Done,
     /*  388192 */   // Label 6953: @388192
     /*  388192 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(388258), // Rule ID 61538 //
     /*  388197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  388208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  388211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  388214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388256 */     GIR_RootConstrainSelectedInstOperands,
     /*  388257 */     // GIR_Coverage, 61538,
     /*  388257 */     GIR_EraseRootFromParent_Done,
     /*  388258 */   // Label 6954: @388258
     /*  388258 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(388324), // Rule ID 61539 //
     /*  388263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  388274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  388277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  388280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388322 */     GIR_RootConstrainSelectedInstOperands,
     /*  388323 */     // GIR_Coverage, 61539,
     /*  388323 */     GIR_EraseRootFromParent_Done,
     /*  388324 */   // Label 6955: @388324
     /*  388324 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(388390), // Rule ID 61542 //
     /*  388329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  388340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  388343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  388346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  388368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388388 */     GIR_RootConstrainSelectedInstOperands,
     /*  388389 */     // GIR_Coverage, 61542,
     /*  388389 */     GIR_EraseRootFromParent_Done,
     /*  388390 */   // Label 6956: @388390
     /*  388390 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(388456), // Rule ID 61543 //
     /*  388395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  388406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  388409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  388412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  388434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388454 */     GIR_RootConstrainSelectedInstOperands,
     /*  388455 */     // GIR_Coverage, 61543,
     /*  388455 */     GIR_EraseRootFromParent_Done,
     /*  388456 */   // Label 6957: @388456
     /*  388456 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(388522), // Rule ID 61546 //
     /*  388461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  388472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  388475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  388478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388520 */     GIR_RootConstrainSelectedInstOperands,
     /*  388521 */     // GIR_Coverage, 61546,
     /*  388521 */     GIR_EraseRootFromParent_Done,
     /*  388522 */   // Label 6958: @388522
     /*  388522 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(388588), // Rule ID 61547 //
     /*  388527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  388538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  388541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  388544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  388569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388586 */     GIR_RootConstrainSelectedInstOperands,
     /*  388587 */     // GIR_Coverage, 61547,
     /*  388587 */     GIR_EraseRootFromParent_Done,
     /*  388588 */   // Label 6959: @388588
     /*  388588 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(388654), // Rule ID 61550 //
     /*  388593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  388604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  388607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  388610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388652 */     GIR_RootConstrainSelectedInstOperands,
     /*  388653 */     // GIR_Coverage, 61550,
     /*  388653 */     GIR_EraseRootFromParent_Done,
     /*  388654 */   // Label 6960: @388654
     /*  388654 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(388720), // Rule ID 61551 //
     /*  388659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  388670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  388673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  388676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  388701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388718 */     GIR_RootConstrainSelectedInstOperands,
     /*  388719 */     // GIR_Coverage, 61551,
     /*  388719 */     GIR_EraseRootFromParent_Done,
     /*  388720 */   // Label 6961: @388720
     /*  388720 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(388786), // Rule ID 61554 //
     /*  388725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  388728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  388736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  388739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  388742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  388745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  388764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388784 */     GIR_RootConstrainSelectedInstOperands,
     /*  388785 */     // GIR_Coverage, 61554,
     /*  388785 */     GIR_EraseRootFromParent_Done,
     /*  388786 */   // Label 6962: @388786
     /*  388786 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(388852), // Rule ID 61555 //
     /*  388791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  388794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  388799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  388802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  388805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  388808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  388830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  388833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  388837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  388850 */     GIR_RootConstrainSelectedInstOperands,
     /*  388851 */     // GIR_Coverage, 61555,
     /*  388851 */     GIR_EraseRootFromParent_Done,
     /*  388852 */   // Label 6963: @388852
     /*  388852 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(388917), // Rule ID 64446 //
     /*  388857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  388865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  388871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  388874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  388901 */     // MIs[1] Operand 1
     /*  388901 */     // No operand predicates
     /*  388901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388903 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  388903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  388906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  388910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  388915 */     GIR_RootConstrainSelectedInstOperands,
     /*  388916 */     // GIR_Coverage, 64446,
     /*  388916 */     GIR_EraseRootFromParent_Done,
     /*  388917 */   // Label 6964: @388917
     /*  388917 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(388982), // Rule ID 64473 //
     /*  388922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  388930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  388936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  388939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  388942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  388954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  388958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  388962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  388966 */     // MIs[1] Operand 1
     /*  388966 */     // No operand predicates
     /*  388966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  388968 */     // (intrinsic_wo_chain:{ *:[i32] } 10925:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  388968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  388971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  388975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  388977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  388980 */     GIR_RootConstrainSelectedInstOperands,
     /*  388981 */     // GIR_Coverage, 64473,
     /*  388981 */     GIR_EraseRootFromParent_Done,
     /*  388982 */   // Label 6965: @388982
     /*  388982 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(389047), // Rule ID 64476 //
     /*  388987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  388990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  388995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  388998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389031 */     // MIs[1] Operand 1
     /*  389031 */     // No operand predicates
     /*  389031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389033 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  389036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389045 */     GIR_RootConstrainSelectedInstOperands,
     /*  389046 */     // GIR_Coverage, 64476,
     /*  389046 */     GIR_EraseRootFromParent_Done,
     /*  389047 */   // Label 6966: @389047
     /*  389047 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(389112), // Rule ID 64479 //
     /*  389052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  389060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389096 */     // MIs[1] Operand 1
     /*  389096 */     // No operand predicates
     /*  389096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389098 */     // (intrinsic_wo_chain:{ *:[i32] } 10926:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  389101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389110 */     GIR_RootConstrainSelectedInstOperands,
     /*  389111 */     // GIR_Coverage, 64479,
     /*  389111 */     GIR_EraseRootFromParent_Done,
     /*  389112 */   // Label 6967: @389112
     /*  389112 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(389177), // Rule ID 64482 //
     /*  389117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  389125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389161 */     // MIs[1] Operand 1
     /*  389161 */     // No operand predicates
     /*  389161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389163 */     // (intrinsic_wo_chain:{ *:[i32] } 10929:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  389166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389175 */     GIR_RootConstrainSelectedInstOperands,
     /*  389176 */     // GIR_Coverage, 64482,
     /*  389176 */     GIR_EraseRootFromParent_Done,
     /*  389177 */   // Label 6968: @389177
     /*  389177 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(389242), // Rule ID 64485 //
     /*  389182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  389190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389226 */     // MIs[1] Operand 1
     /*  389226 */     // No operand predicates
     /*  389226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389228 */     // (intrinsic_wo_chain:{ *:[i32] } 10931:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  389231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389240 */     GIR_RootConstrainSelectedInstOperands,
     /*  389241 */     // GIR_Coverage, 64485,
     /*  389241 */     GIR_EraseRootFromParent_Done,
     /*  389242 */   // Label 6969: @389242
     /*  389242 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(389307), // Rule ID 64488 //
     /*  389247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  389255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389291 */     // MIs[1] Operand 1
     /*  389291 */     // No operand predicates
     /*  389291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389293 */     // (intrinsic_wo_chain:{ *:[i32] } 10930:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  389296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389305 */     GIR_RootConstrainSelectedInstOperands,
     /*  389306 */     // GIR_Coverage, 64488,
     /*  389306 */     GIR_EraseRootFromParent_Done,
     /*  389307 */   // Label 6970: @389307
     /*  389307 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(389372), // Rule ID 64491 //
     /*  389312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  389315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  389320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  389332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  389348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  389352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  389356 */     // MIs[1] Operand 1
     /*  389356 */     // No operand predicates
     /*  389356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  389358 */     // (intrinsic_wo_chain:{ *:[i32] } 10932:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  389358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  389361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  389370 */     GIR_RootConstrainSelectedInstOperands,
     /*  389371 */     // GIR_Coverage, 64491,
     /*  389371 */     GIR_EraseRootFromParent_Done,
     /*  389372 */   // Label 6971: @389372
     /*  389372 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(389427), // Rule ID 2639 //
     /*  389377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  389380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  389385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389406 */     // MIs[0] imm
     /*  389406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389414 */     // (intrinsic_wo_chain:{ *:[i32] } 10908:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  389417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389423 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389425 */     GIR_RootConstrainSelectedInstOperands,
     /*  389426 */     // GIR_Coverage, 2639,
     /*  389426 */     GIR_EraseRootFromParent_Done,
     /*  389427 */   // Label 6972: @389427
     /*  389427 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(389482), // Rule ID 2640 //
     /*  389432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  389435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  389440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389461 */     // MIs[0] imm
     /*  389461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389469 */     // (intrinsic_wo_chain:{ *:[i32] } 10909:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  389472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389478 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389480 */     GIR_RootConstrainSelectedInstOperands,
     /*  389481 */     // GIR_Coverage, 2640,
     /*  389481 */     GIR_EraseRootFromParent_Done,
     /*  389482 */   // Label 6973: @389482
     /*  389482 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(389537), // Rule ID 2646 //
     /*  389487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  389490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  389495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389516 */     // MIs[0] imm
     /*  389516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389524 */     // (intrinsic_wo_chain:{ *:[i32] } 10910:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  389527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389533 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389535 */     GIR_RootConstrainSelectedInstOperands,
     /*  389536 */     // GIR_Coverage, 2646,
     /*  389536 */     GIR_EraseRootFromParent_Done,
     /*  389537 */   // Label 6974: @389537
     /*  389537 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(389592), // Rule ID 2647 //
     /*  389542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  389545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  389550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389571 */     // MIs[0] imm
     /*  389571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  389579 */     // (intrinsic_wo_chain:{ *:[i32] } 10911:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  389579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  389582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389588 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  389590 */     GIR_RootConstrainSelectedInstOperands,
     /*  389591 */     // GIR_Coverage, 2647,
     /*  389591 */     GIR_EraseRootFromParent_Done,
     /*  389592 */   // Label 6975: @389592
     /*  389592 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(389647), // Rule ID 64502 //
     /*  389597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  389605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389626 */     // MIs[0] imm5
     /*  389626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389634 */     // (intrinsic_wo_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  389637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389643 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389645 */     GIR_RootConstrainSelectedInstOperands,
     /*  389646 */     // GIR_Coverage, 64502,
     /*  389646 */     GIR_EraseRootFromParent_Done,
     /*  389647 */   // Label 6976: @389647
     /*  389647 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(389702), // Rule ID 64503 //
     /*  389652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  389660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389681 */     // MIs[0] imm5
     /*  389681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389689 */     // (intrinsic_wo_chain:{ *:[i32] } 10952:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  389692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389698 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389700 */     GIR_RootConstrainSelectedInstOperands,
     /*  389701 */     // GIR_Coverage, 64503,
     /*  389701 */     GIR_EraseRootFromParent_Done,
     /*  389702 */   // Label 6977: @389702
     /*  389702 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(389757), // Rule ID 64504 //
     /*  389707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  389715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389736 */     // MIs[0] imm5
     /*  389736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389744 */     // (intrinsic_wo_chain:{ *:[i32] } 10954:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  389747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389753 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389755 */     GIR_RootConstrainSelectedInstOperands,
     /*  389756 */     // GIR_Coverage, 64504,
     /*  389756 */     GIR_EraseRootFromParent_Done,
     /*  389757 */   // Label 6978: @389757
     /*  389757 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(389812), // Rule ID 64505 //
     /*  389762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  389770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389791 */     // MIs[0] imm5
     /*  389791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389799 */     // (intrinsic_wo_chain:{ *:[i32] } 10950:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  389802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389808 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389810 */     GIR_RootConstrainSelectedInstOperands,
     /*  389811 */     // GIR_Coverage, 64505,
     /*  389811 */     GIR_EraseRootFromParent_Done,
     /*  389812 */   // Label 6979: @389812
     /*  389812 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(389867), // Rule ID 64506 //
     /*  389817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  389825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389846 */     // MIs[0] imm5
     /*  389846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389854 */     // (intrinsic_wo_chain:{ *:[i32] } 10957:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  389857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389863 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389865 */     GIR_RootConstrainSelectedInstOperands,
     /*  389866 */     // GIR_Coverage, 64506,
     /*  389866 */     GIR_EraseRootFromParent_Done,
     /*  389867 */   // Label 6980: @389867
     /*  389867 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(389922), // Rule ID 64507 //
     /*  389872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  389880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389901 */     // MIs[0] imm5
     /*  389901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389909 */     // (intrinsic_wo_chain:{ *:[i32] } 10953:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  389912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389918 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389920 */     GIR_RootConstrainSelectedInstOperands,
     /*  389921 */     // GIR_Coverage, 64507,
     /*  389921 */     GIR_EraseRootFromParent_Done,
     /*  389922 */   // Label 6981: @389922
     /*  389922 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(389977), // Rule ID 64508 //
     /*  389927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  389935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  389956 */     // MIs[0] imm5
     /*  389956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  389964 */     // (intrinsic_wo_chain:{ *:[i32] } 10955:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  389964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  389967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  389971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  389973 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  389975 */     GIR_RootConstrainSelectedInstOperands,
     /*  389976 */     // GIR_Coverage, 64508,
     /*  389976 */     GIR_EraseRootFromParent_Done,
     /*  389977 */   // Label 6982: @389977
     /*  389977 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(390032), // Rule ID 64509 //
     /*  389982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  389985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  389990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  389993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  389996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  389999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390011 */     // MIs[0] imm5
     /*  390011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  390019 */     // (intrinsic_wo_chain:{ *:[i32] } 10951:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  390019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  390022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390028 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  390030 */     GIR_RootConstrainSelectedInstOperands,
     /*  390031 */     // GIR_Coverage, 64509,
     /*  390031 */     GIR_EraseRootFromParent_Done,
     /*  390032 */   // Label 6983: @390032
     /*  390032 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(390086), // Rule ID 64444 //
     /*  390037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  390045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390073 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  390076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390084 */     GIR_RootConstrainSelectedInstOperands,
     /*  390085 */     // GIR_Coverage, 64444,
     /*  390085 */     GIR_EraseRootFromParent_Done,
     /*  390086 */   // Label 6984: @390086
     /*  390086 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(390140), // Rule ID 64445 //
     /*  390091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  390099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390127 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  390130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390138 */     GIR_RootConstrainSelectedInstOperands,
     /*  390139 */     // GIR_Coverage, 64445,
     /*  390139 */     GIR_EraseRootFromParent_Done,
     /*  390140 */   // Label 6985: @390140
     /*  390140 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(390194), // Rule ID 64471 //
     /*  390145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  390153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390181 */     // (intrinsic_wo_chain:{ *:[i32] } 10925:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  390184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390192 */     GIR_RootConstrainSelectedInstOperands,
     /*  390193 */     // GIR_Coverage, 64471,
     /*  390193 */     GIR_EraseRootFromParent_Done,
     /*  390194 */   // Label 6986: @390194
     /*  390194 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(390248), // Rule ID 64472 //
     /*  390199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  390207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390235 */     // (intrinsic_wo_chain:{ *:[i32] } 10925:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  390238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390246 */     GIR_RootConstrainSelectedInstOperands,
     /*  390247 */     // GIR_Coverage, 64472,
     /*  390247 */     GIR_EraseRootFromParent_Done,
     /*  390248 */   // Label 6987: @390248
     /*  390248 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(390302), // Rule ID 64474 //
     /*  390253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  390261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390289 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  390292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390300 */     GIR_RootConstrainSelectedInstOperands,
     /*  390301 */     // GIR_Coverage, 64474,
     /*  390301 */     GIR_EraseRootFromParent_Done,
     /*  390302 */   // Label 6988: @390302
     /*  390302 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(390356), // Rule ID 64475 //
     /*  390307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  390315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390343 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  390346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390354 */     GIR_RootConstrainSelectedInstOperands,
     /*  390355 */     // GIR_Coverage, 64475,
     /*  390355 */     GIR_EraseRootFromParent_Done,
     /*  390356 */   // Label 6989: @390356
     /*  390356 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(390410), // Rule ID 64477 //
     /*  390361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  390369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390397 */     // (intrinsic_wo_chain:{ *:[i32] } 10926:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  390400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390408 */     GIR_RootConstrainSelectedInstOperands,
     /*  390409 */     // GIR_Coverage, 64477,
     /*  390409 */     GIR_EraseRootFromParent_Done,
     /*  390410 */   // Label 6990: @390410
     /*  390410 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(390464), // Rule ID 64478 //
     /*  390415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  390423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390451 */     // (intrinsic_wo_chain:{ *:[i32] } 10926:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  390454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390462 */     GIR_RootConstrainSelectedInstOperands,
     /*  390463 */     // GIR_Coverage, 64478,
     /*  390463 */     GIR_EraseRootFromParent_Done,
     /*  390464 */   // Label 6991: @390464
     /*  390464 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(390518), // Rule ID 64480 //
     /*  390469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  390477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390505 */     // (intrinsic_wo_chain:{ *:[i32] } 10929:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  390508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390516 */     GIR_RootConstrainSelectedInstOperands,
     /*  390517 */     // GIR_Coverage, 64480,
     /*  390517 */     GIR_EraseRootFromParent_Done,
     /*  390518 */   // Label 6992: @390518
     /*  390518 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(390572), // Rule ID 64481 //
     /*  390523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  390531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390559 */     // (intrinsic_wo_chain:{ *:[i32] } 10929:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  390562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390570 */     GIR_RootConstrainSelectedInstOperands,
     /*  390571 */     // GIR_Coverage, 64481,
     /*  390571 */     GIR_EraseRootFromParent_Done,
     /*  390572 */   // Label 6993: @390572
     /*  390572 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(390626), // Rule ID 64483 //
     /*  390577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  390585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390613 */     // (intrinsic_wo_chain:{ *:[i32] } 10931:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  390616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390624 */     GIR_RootConstrainSelectedInstOperands,
     /*  390625 */     // GIR_Coverage, 64483,
     /*  390625 */     GIR_EraseRootFromParent_Done,
     /*  390626 */   // Label 6994: @390626
     /*  390626 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(390680), // Rule ID 64484 //
     /*  390631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  390639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390667 */     // (intrinsic_wo_chain:{ *:[i32] } 10931:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  390670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390678 */     GIR_RootConstrainSelectedInstOperands,
     /*  390679 */     // GIR_Coverage, 64484,
     /*  390679 */     GIR_EraseRootFromParent_Done,
     /*  390680 */   // Label 6995: @390680
     /*  390680 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(390734), // Rule ID 64486 //
     /*  390685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  390693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390721 */     // (intrinsic_wo_chain:{ *:[i32] } 10930:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  390724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390732 */     GIR_RootConstrainSelectedInstOperands,
     /*  390733 */     // GIR_Coverage, 64486,
     /*  390733 */     GIR_EraseRootFromParent_Done,
     /*  390734 */   // Label 6996: @390734
     /*  390734 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(390788), // Rule ID 64487 //
     /*  390739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  390747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390775 */     // (intrinsic_wo_chain:{ *:[i32] } 10930:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  390778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390786 */     GIR_RootConstrainSelectedInstOperands,
     /*  390787 */     // GIR_Coverage, 64487,
     /*  390787 */     GIR_EraseRootFromParent_Done,
     /*  390788 */   // Label 6997: @390788
     /*  390788 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(390842), // Rule ID 64489 //
     /*  390793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  390796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  390801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390829 */     // (intrinsic_wo_chain:{ *:[i32] } 10932:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  390832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390840 */     GIR_RootConstrainSelectedInstOperands,
     /*  390841 */     // GIR_Coverage, 64489,
     /*  390841 */     GIR_EraseRootFromParent_Done,
     /*  390842 */   // Label 6998: @390842
     /*  390842 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(390896), // Rule ID 64490 //
     /*  390847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  390850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  390855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390883 */     // (intrinsic_wo_chain:{ *:[i32] } 10932:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  390883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  390886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  390894 */     GIR_RootConstrainSelectedInstOperands,
     /*  390895 */     // GIR_Coverage, 64490,
     /*  390895 */     GIR_EraseRootFromParent_Done,
     /*  390896 */   // Label 6999: @390896
     /*  390896 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(390950), // Rule ID 64427 //
     /*  390901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  390904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  390909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390937 */     // (intrinsic_wo_chain:{ *:[i32] } 10939:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  390937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  390940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  390944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  390946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  390948 */     GIR_RootConstrainSelectedInstOperands,
     /*  390949 */     // GIR_Coverage, 64427,
     /*  390949 */     GIR_EraseRootFromParent_Done,
     /*  390950 */   // Label 7000: @390950
     /*  390950 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(391004), // Rule ID 64428 //
     /*  390955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  390958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  390963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  390966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  390969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  390972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390991 */     // (intrinsic_wo_chain:{ *:[i32] } 10939:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  390991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  390994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  390996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  390998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391002 */     GIR_RootConstrainSelectedInstOperands,
     /*  391003 */     // GIR_Coverage, 64428,
     /*  391003 */     GIR_EraseRootFromParent_Done,
     /*  391004 */   // Label 7001: @391004
     /*  391004 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(391058), // Rule ID 64498 //
     /*  391009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  391012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  391017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391045 */     // (intrinsic_wo_chain:{ *:[i32] } 10940:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  391048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391056 */     GIR_RootConstrainSelectedInstOperands,
     /*  391057 */     // GIR_Coverage, 64498,
     /*  391057 */     GIR_EraseRootFromParent_Done,
     /*  391058 */   // Label 7002: @391058
     /*  391058 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(391112), // Rule ID 64499 //
     /*  391063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  391066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  391071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391099 */     // (intrinsic_wo_chain:{ *:[i32] } 10940:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  391102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391110 */     GIR_RootConstrainSelectedInstOperands,
     /*  391111 */     // GIR_Coverage, 64499,
     /*  391111 */     GIR_EraseRootFromParent_Done,
     /*  391112 */   // Label 7003: @391112
     /*  391112 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(391166), // Rule ID 64500 //
     /*  391117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  391120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  391125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391153 */     // (intrinsic_wo_chain:{ *:[i32] } 10949:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  391156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391164 */     GIR_RootConstrainSelectedInstOperands,
     /*  391165 */     // GIR_Coverage, 64500,
     /*  391165 */     GIR_EraseRootFromParent_Done,
     /*  391166 */   // Label 7004: @391166
     /*  391166 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(391220), // Rule ID 64501 //
     /*  391171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  391174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  391179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  391182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  391185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  391188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391207 */     // (intrinsic_wo_chain:{ *:[i32] } 10949:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  391207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  391210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  391212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  391214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  391216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  391218 */     GIR_RootConstrainSelectedInstOperands,
     /*  391219 */     // GIR_Coverage, 64501,
     /*  391219 */     GIR_EraseRootFromParent_Done,
     /*  391220 */   // Label 7005: @391220
     /*  391220 */   GIM_Reject,
     /*  391221 */ // Label 4380: @391221
     /*  391221 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(909998),
     /*  391226 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  391229 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(391304), // Rule ID 62831 //
     /*  391234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391252 */     // MIs[0] op1
     /*  391252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391260 */     // MIs[0] op2
     /*  391260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391268 */     // MIs[0] op3
     /*  391268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391283 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  391286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391302 */     GIR_RootConstrainSelectedInstOperands,
     /*  391303 */     // GIR_Coverage, 62831,
     /*  391303 */     GIR_EraseRootFromParent_Done,
     /*  391304 */   // Label 7007: @391304
     /*  391304 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(391379), // Rule ID 62832 //
     /*  391309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  391320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391327 */     // MIs[0] op1
     /*  391327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391335 */     // MIs[0] op2
     /*  391335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391343 */     // MIs[0] op3
     /*  391343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  391361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391377 */     GIR_RootConstrainSelectedInstOperands,
     /*  391378 */     // GIR_Coverage, 62832,
     /*  391378 */     GIR_EraseRootFromParent_Done,
     /*  391379 */   // Label 7008: @391379
     /*  391379 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(391454), // Rule ID 62863 //
     /*  391384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391402 */     // MIs[0] op1
     /*  391402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391410 */     // MIs[0] op2
     /*  391410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391418 */     // MIs[0] op3
     /*  391418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391433 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391452 */     GIR_RootConstrainSelectedInstOperands,
     /*  391453 */     // GIR_Coverage, 62863,
     /*  391453 */     GIR_EraseRootFromParent_Done,
     /*  391454 */   // Label 7009: @391454
     /*  391454 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(391529), // Rule ID 62864 //
     /*  391459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  391470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391477 */     // MIs[0] op1
     /*  391477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391485 */     // MIs[0] op2
     /*  391485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391493 */     // MIs[0] op3
     /*  391493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391527 */     GIR_RootConstrainSelectedInstOperands,
     /*  391528 */     // GIR_Coverage, 62864,
     /*  391528 */     GIR_EraseRootFromParent_Done,
     /*  391529 */   // Label 7010: @391529
     /*  391529 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(391604), // Rule ID 62907 //
     /*  391534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391552 */     // MIs[0] op1
     /*  391552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391560 */     // MIs[0] op2
     /*  391560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391568 */     // MIs[0] op3
     /*  391568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391602 */     GIR_RootConstrainSelectedInstOperands,
     /*  391603 */     // GIR_Coverage, 62907,
     /*  391603 */     GIR_EraseRootFromParent_Done,
     /*  391604 */   // Label 7011: @391604
     /*  391604 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(391679), // Rule ID 62908 //
     /*  391609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391627 */     // MIs[0] op1
     /*  391627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391635 */     // MIs[0] op2
     /*  391635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391643 */     // MIs[0] op3
     /*  391643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391663 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391665 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391667 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391677 */     GIR_RootConstrainSelectedInstOperands,
     /*  391678 */     // GIR_Coverage, 62908,
     /*  391678 */     GIR_EraseRootFromParent_Done,
     /*  391679 */   // Label 7012: @391679
     /*  391679 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(391754), // Rule ID 62951 //
     /*  391684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391702 */     // MIs[0] op1
     /*  391702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391710 */     // MIs[0] op2
     /*  391710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391718 */     // MIs[0] op3
     /*  391718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391733 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391738 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391740 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391742 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391752 */     GIR_RootConstrainSelectedInstOperands,
     /*  391753 */     // GIR_Coverage, 62951,
     /*  391753 */     GIR_EraseRootFromParent_Done,
     /*  391754 */   // Label 7013: @391754
     /*  391754 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(391829), // Rule ID 62952 //
     /*  391759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391777 */     // MIs[0] op1
     /*  391777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391785 */     // MIs[0] op2
     /*  391785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391793 */     // MIs[0] op3
     /*  391793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  391811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391813 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391815 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391817 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391827 */     GIR_RootConstrainSelectedInstOperands,
     /*  391828 */     // GIR_Coverage, 62952,
     /*  391828 */     GIR_EraseRootFromParent_Done,
     /*  391829 */   // Label 7014: @391829
     /*  391829 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(391904), // Rule ID 63007 //
     /*  391834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391852 */     // MIs[0] op1
     /*  391852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391860 */     // MIs[0] op2
     /*  391860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391868 */     // MIs[0] op3
     /*  391868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391883 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391902 */     GIR_RootConstrainSelectedInstOperands,
     /*  391903 */     // GIR_Coverage, 63007,
     /*  391903 */     GIR_EraseRootFromParent_Done,
     /*  391904 */   // Label 7015: @391904
     /*  391904 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(391979), // Rule ID 63008 //
     /*  391909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391927 */     // MIs[0] op1
     /*  391927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391935 */     // MIs[0] op2
     /*  391935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391943 */     // MIs[0] op3
     /*  391943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  391946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  391951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  391961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391963 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391965 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391967 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391977 */     GIR_RootConstrainSelectedInstOperands,
     /*  391978 */     // GIR_Coverage, 63008,
     /*  391978 */     GIR_EraseRootFromParent_Done,
     /*  391979 */   // Label 7016: @391979
     /*  391979 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(392054), // Rule ID 63063 //
     /*  391984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  391992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392002 */     // MIs[0] op1
     /*  392002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392010 */     // MIs[0] op2
     /*  392010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392018 */     // MIs[0] op3
     /*  392018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392033 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  392036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392052 */     GIR_RootConstrainSelectedInstOperands,
     /*  392053 */     // GIR_Coverage, 63063,
     /*  392053 */     GIR_EraseRootFromParent_Done,
     /*  392054 */   // Label 7017: @392054
     /*  392054 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(392129), // Rule ID 63064 //
     /*  392059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  392070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392077 */     // MIs[0] op1
     /*  392077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392085 */     // MIs[0] op2
     /*  392085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392093 */     // MIs[0] op3
     /*  392093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  392111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392113 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392115 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392117 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392127 */     GIR_RootConstrainSelectedInstOperands,
     /*  392128 */     // GIR_Coverage, 63064,
     /*  392128 */     GIR_EraseRootFromParent_Done,
     /*  392129 */   // Label 7018: @392129
     /*  392129 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(392204), // Rule ID 63119 //
     /*  392134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392152 */     // MIs[0] op1
     /*  392152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392160 */     // MIs[0] op2
     /*  392160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392168 */     // MIs[0] op3
     /*  392168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392188 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392190 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392192 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392202 */     GIR_RootConstrainSelectedInstOperands,
     /*  392203 */     // GIR_Coverage, 63119,
     /*  392203 */     GIR_EraseRootFromParent_Done,
     /*  392204 */   // Label 7019: @392204
     /*  392204 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(392279), // Rule ID 63120 //
     /*  392209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  392220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392227 */     // MIs[0] op1
     /*  392227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392235 */     // MIs[0] op2
     /*  392235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392243 */     // MIs[0] op3
     /*  392243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392263 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392265 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392267 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392277 */     GIR_RootConstrainSelectedInstOperands,
     /*  392278 */     // GIR_Coverage, 63120,
     /*  392278 */     GIR_EraseRootFromParent_Done,
     /*  392279 */   // Label 7020: @392279
     /*  392279 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(392354), // Rule ID 63163 //
     /*  392284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392302 */     // MIs[0] op1
     /*  392302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392310 */     // MIs[0] op2
     /*  392310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392318 */     // MIs[0] op3
     /*  392318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392338 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392340 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392342 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392352 */     GIR_RootConstrainSelectedInstOperands,
     /*  392353 */     // GIR_Coverage, 63163,
     /*  392353 */     GIR_EraseRootFromParent_Done,
     /*  392354 */   // Label 7021: @392354
     /*  392354 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(392429), // Rule ID 63164 //
     /*  392359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  392370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392377 */     // MIs[0] op1
     /*  392377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392385 */     // MIs[0] op2
     /*  392385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392393 */     // MIs[0] op3
     /*  392393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392413 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392415 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392417 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392427 */     GIR_RootConstrainSelectedInstOperands,
     /*  392428 */     // GIR_Coverage, 63164,
     /*  392428 */     GIR_EraseRootFromParent_Done,
     /*  392429 */   // Label 7022: @392429
     /*  392429 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(392504), // Rule ID 63219 //
     /*  392434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392452 */     // MIs[0] op1
     /*  392452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392460 */     // MIs[0] op2
     /*  392460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392468 */     // MIs[0] op3
     /*  392468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392483 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392502 */     GIR_RootConstrainSelectedInstOperands,
     /*  392503 */     // GIR_Coverage, 63219,
     /*  392503 */     GIR_EraseRootFromParent_Done,
     /*  392504 */   // Label 7023: @392504
     /*  392504 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(392579), // Rule ID 63220 //
     /*  392509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  392520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392527 */     // MIs[0] op1
     /*  392527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392535 */     // MIs[0] op2
     /*  392535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392543 */     // MIs[0] op3
     /*  392543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392563 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392565 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392567 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392577 */     GIR_RootConstrainSelectedInstOperands,
     /*  392578 */     // GIR_Coverage, 63220,
     /*  392578 */     GIR_EraseRootFromParent_Done,
     /*  392579 */   // Label 7024: @392579
     /*  392579 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(392654), // Rule ID 63275 //
     /*  392584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392602 */     // MIs[0] op1
     /*  392602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392610 */     // MIs[0] op2
     /*  392610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392618 */     // MIs[0] op3
     /*  392618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392633 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392652 */     GIR_RootConstrainSelectedInstOperands,
     /*  392653 */     // GIR_Coverage, 63275,
     /*  392653 */     GIR_EraseRootFromParent_Done,
     /*  392654 */   // Label 7025: @392654
     /*  392654 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(392729), // Rule ID 63276 //
     /*  392659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392677 */     // MIs[0] op1
     /*  392677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392685 */     // MIs[0] op2
     /*  392685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392693 */     // MIs[0] op3
     /*  392693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  392711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392713 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392715 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392717 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392727 */     GIR_RootConstrainSelectedInstOperands,
     /*  392728 */     // GIR_Coverage, 63276,
     /*  392728 */     GIR_EraseRootFromParent_Done,
     /*  392729 */   // Label 7026: @392729
     /*  392729 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(392804), // Rule ID 63331 //
     /*  392734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392752 */     // MIs[0] op1
     /*  392752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392760 */     // MIs[0] op2
     /*  392760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392768 */     // MIs[0] op3
     /*  392768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392783 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  392786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392802 */     GIR_RootConstrainSelectedInstOperands,
     /*  392803 */     // GIR_Coverage, 63331,
     /*  392803 */     GIR_EraseRootFromParent_Done,
     /*  392804 */   // Label 7027: @392804
     /*  392804 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(392879), // Rule ID 63332 //
     /*  392809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392827 */     // MIs[0] op1
     /*  392827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392835 */     // MIs[0] op2
     /*  392835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392843 */     // MIs[0] op3
     /*  392843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  392861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392877 */     GIR_RootConstrainSelectedInstOperands,
     /*  392878 */     // GIR_Coverage, 63332,
     /*  392878 */     GIR_EraseRootFromParent_Done,
     /*  392879 */   // Label 7028: @392879
     /*  392879 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(392954), // Rule ID 63375 //
     /*  392884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392902 */     // MIs[0] op1
     /*  392902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392910 */     // MIs[0] op2
     /*  392910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392918 */     // MIs[0] op3
     /*  392918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  392926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392933 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  392936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392952 */     GIR_RootConstrainSelectedInstOperands,
     /*  392953 */     // GIR_Coverage, 63375,
     /*  392953 */     GIR_EraseRootFromParent_Done,
     /*  392954 */   // Label 7029: @392954
     /*  392954 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(393029), // Rule ID 63376 //
     /*  392959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  392967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392977 */     // MIs[0] op1
     /*  392977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392985 */     // MIs[0] op2
     /*  392985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392993 */     // MIs[0] op3
     /*  392993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  392996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393013 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393015 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393017 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393027 */     GIR_RootConstrainSelectedInstOperands,
     /*  393028 */     // GIR_Coverage, 63376,
     /*  393028 */     GIR_EraseRootFromParent_Done,
     /*  393029 */   // Label 7030: @393029
     /*  393029 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(393104), // Rule ID 63419 //
     /*  393034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393052 */     // MIs[0] op1
     /*  393052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393060 */     // MIs[0] op2
     /*  393060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393068 */     // MIs[0] op3
     /*  393068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393083 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393102 */     GIR_RootConstrainSelectedInstOperands,
     /*  393103 */     // GIR_Coverage, 63419,
     /*  393103 */     GIR_EraseRootFromParent_Done,
     /*  393104 */   // Label 7031: @393104
     /*  393104 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(393179), // Rule ID 63420 //
     /*  393109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  393120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393127 */     // MIs[0] op1
     /*  393127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393135 */     // MIs[0] op2
     /*  393135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393143 */     // MIs[0] op3
     /*  393143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393163 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393165 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393167 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393177 */     GIR_RootConstrainSelectedInstOperands,
     /*  393178 */     // GIR_Coverage, 63420,
     /*  393178 */     GIR_EraseRootFromParent_Done,
     /*  393179 */   // Label 7032: @393179
     /*  393179 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(393254), // Rule ID 63463 //
     /*  393184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393202 */     // MIs[0] op1
     /*  393202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393210 */     // MIs[0] op2
     /*  393210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393218 */     // MIs[0] op3
     /*  393218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393238 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393240 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393242 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393252 */     GIR_RootConstrainSelectedInstOperands,
     /*  393253 */     // GIR_Coverage, 63463,
     /*  393253 */     GIR_EraseRootFromParent_Done,
     /*  393254 */   // Label 7033: @393254
     /*  393254 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(393329), // Rule ID 63464 //
     /*  393259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  393270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393277 */     // MIs[0] op1
     /*  393277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393285 */     // MIs[0] op2
     /*  393285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393293 */     // MIs[0] op3
     /*  393293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393313 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393315 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393317 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393327 */     GIR_RootConstrainSelectedInstOperands,
     /*  393328 */     // GIR_Coverage, 63464,
     /*  393328 */     GIR_EraseRootFromParent_Done,
     /*  393329 */   // Label 7034: @393329
     /*  393329 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(393404), // Rule ID 63519 //
     /*  393334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393352 */     // MIs[0] op1
     /*  393352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393360 */     // MIs[0] op2
     /*  393360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393368 */     // MIs[0] op3
     /*  393368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393383 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393388 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393390 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393392 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393402 */     GIR_RootConstrainSelectedInstOperands,
     /*  393403 */     // GIR_Coverage, 63519,
     /*  393403 */     GIR_EraseRootFromParent_Done,
     /*  393404 */   // Label 7035: @393404
     /*  393404 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(393479), // Rule ID 63520 //
     /*  393409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  393420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393427 */     // MIs[0] op1
     /*  393427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393435 */     // MIs[0] op2
     /*  393435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393443 */     // MIs[0] op3
     /*  393443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393463 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393465 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393467 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393477 */     GIR_RootConstrainSelectedInstOperands,
     /*  393478 */     // GIR_Coverage, 63520,
     /*  393478 */     GIR_EraseRootFromParent_Done,
     /*  393479 */   // Label 7036: @393479
     /*  393479 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(393554), // Rule ID 63575 //
     /*  393484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393502 */     // MIs[0] op1
     /*  393502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393510 */     // MIs[0] op2
     /*  393510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393518 */     // MIs[0] op3
     /*  393518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393533 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393552 */     GIR_RootConstrainSelectedInstOperands,
     /*  393553 */     // GIR_Coverage, 63575,
     /*  393553 */     GIR_EraseRootFromParent_Done,
     /*  393554 */   // Label 7037: @393554
     /*  393554 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(393629), // Rule ID 63576 //
     /*  393559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  393570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393577 */     // MIs[0] op1
     /*  393577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393585 */     // MIs[0] op2
     /*  393585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393593 */     // MIs[0] op3
     /*  393593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393613 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393615 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393617 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393627 */     GIR_RootConstrainSelectedInstOperands,
     /*  393628 */     // GIR_Coverage, 63576,
     /*  393628 */     GIR_EraseRootFromParent_Done,
     /*  393629 */   // Label 7038: @393629
     /*  393629 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(393704), // Rule ID 63631 //
     /*  393634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393652 */     // MIs[0] op1
     /*  393652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393660 */     // MIs[0] op2
     /*  393660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393668 */     // MIs[0] op3
     /*  393668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393702 */     GIR_RootConstrainSelectedInstOperands,
     /*  393703 */     // GIR_Coverage, 63631,
     /*  393703 */     GIR_EraseRootFromParent_Done,
     /*  393704 */   // Label 7039: @393704
     /*  393704 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(393779), // Rule ID 63632 //
     /*  393709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393727 */     // MIs[0] op1
     /*  393727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393735 */     // MIs[0] op2
     /*  393735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393743 */     // MIs[0] op3
     /*  393743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  393761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393763 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393765 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393767 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393777 */     GIR_RootConstrainSelectedInstOperands,
     /*  393778 */     // GIR_Coverage, 63632,
     /*  393778 */     GIR_EraseRootFromParent_Done,
     /*  393779 */   // Label 7040: @393779
     /*  393779 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(393854), // Rule ID 63687 //
     /*  393784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393802 */     // MIs[0] op1
     /*  393802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393810 */     // MIs[0] op2
     /*  393810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393818 */     // MIs[0] op3
     /*  393818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393852 */     GIR_RootConstrainSelectedInstOperands,
     /*  393853 */     // GIR_Coverage, 63687,
     /*  393853 */     GIR_EraseRootFromParent_Done,
     /*  393854 */   // Label 7041: @393854
     /*  393854 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(393929), // Rule ID 63688 //
     /*  393859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393877 */     // MIs[0] op1
     /*  393877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393885 */     // MIs[0] op2
     /*  393885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393893 */     // MIs[0] op3
     /*  393893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  393911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393913 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393915 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393917 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393927 */     GIR_RootConstrainSelectedInstOperands,
     /*  393928 */     // GIR_Coverage, 63688,
     /*  393928 */     GIR_EraseRootFromParent_Done,
     /*  393929 */   // Label 7042: @393929
     /*  393929 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(394004), // Rule ID 63743 //
     /*  393934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  393942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393952 */     // MIs[0] op1
     /*  393952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393960 */     // MIs[0] op2
     /*  393960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393968 */     // MIs[0] op3
     /*  393968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393983 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  393986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394002 */     GIR_RootConstrainSelectedInstOperands,
     /*  394003 */     // GIR_Coverage, 63743,
     /*  394003 */     GIR_EraseRootFromParent_Done,
     /*  394004 */   // Label 7043: @394004
     /*  394004 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(394079), // Rule ID 63744 //
     /*  394009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  394020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394027 */     // MIs[0] op1
     /*  394027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394035 */     // MIs[0] op2
     /*  394035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394043 */     // MIs[0] op3
     /*  394043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394077 */     GIR_RootConstrainSelectedInstOperands,
     /*  394078 */     // GIR_Coverage, 63744,
     /*  394078 */     GIR_EraseRootFromParent_Done,
     /*  394079 */   // Label 7044: @394079
     /*  394079 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(394154), // Rule ID 63799 //
     /*  394084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394102 */     // MIs[0] op1
     /*  394102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394110 */     // MIs[0] op2
     /*  394110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394118 */     // MIs[0] op3
     /*  394118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  394136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394152 */     GIR_RootConstrainSelectedInstOperands,
     /*  394153 */     // GIR_Coverage, 63799,
     /*  394153 */     GIR_EraseRootFromParent_Done,
     /*  394154 */   // Label 7045: @394154
     /*  394154 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(394229), // Rule ID 63800 //
     /*  394159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  394170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394177 */     // MIs[0] op1
     /*  394177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394185 */     // MIs[0] op2
     /*  394185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394193 */     // MIs[0] op3
     /*  394193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  394211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394227 */     GIR_RootConstrainSelectedInstOperands,
     /*  394228 */     // GIR_Coverage, 63800,
     /*  394228 */     GIR_EraseRootFromParent_Done,
     /*  394229 */   // Label 7046: @394229
     /*  394229 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(394304), // Rule ID 63855 //
     /*  394234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394252 */     // MIs[0] op1
     /*  394252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394260 */     // MIs[0] op2
     /*  394260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394268 */     // MIs[0] op3
     /*  394268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394283 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  394286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394302 */     GIR_RootConstrainSelectedInstOperands,
     /*  394303 */     // GIR_Coverage, 63855,
     /*  394303 */     GIR_EraseRootFromParent_Done,
     /*  394304 */   // Label 7047: @394304
     /*  394304 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(394379), // Rule ID 63856 //
     /*  394309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  394320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  394327 */     // MIs[0] op1
     /*  394327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394335 */     // MIs[0] op2
     /*  394335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394343 */     // MIs[0] op3
     /*  394343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  394361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394377 */     GIR_RootConstrainSelectedInstOperands,
     /*  394378 */     // GIR_Coverage, 63856,
     /*  394378 */     GIR_EraseRootFromParent_Done,
     /*  394379 */   // Label 7048: @394379
     /*  394379 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(394454), // Rule ID 63911 //
     /*  394384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394402 */     // MIs[0] op1
     /*  394402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394410 */     // MIs[0] op2
     /*  394410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394418 */     // MIs[0] op3
     /*  394418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394433 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394452 */     GIR_RootConstrainSelectedInstOperands,
     /*  394453 */     // GIR_Coverage, 63911,
     /*  394453 */     GIR_EraseRootFromParent_Done,
     /*  394454 */   // Label 7049: @394454
     /*  394454 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(394529), // Rule ID 63912 //
     /*  394459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  394467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  394470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  394477 */     // MIs[0] op1
     /*  394477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394485 */     // MIs[0] op2
     /*  394485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394493 */     // MIs[0] op3
     /*  394493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  394511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394527 */     GIR_RootConstrainSelectedInstOperands,
     /*  394528 */     // GIR_Coverage, 63912,
     /*  394528 */     GIR_EraseRootFromParent_Done,
     /*  394529 */   // Label 7050: @394529
     /*  394529 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(394603), // Rule ID 62813 //
     /*  394534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394555 */     // MIs[0] op1
     /*  394555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394563 */     // MIs[0] op2
     /*  394563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394582 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  394585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394587 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394589 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394591 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394601 */     GIR_RootConstrainSelectedInstOperands,
     /*  394602 */     // GIR_Coverage, 62813,
     /*  394602 */     GIR_EraseRootFromParent_Done,
     /*  394603 */   // Label 7051: @394603
     /*  394603 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(394677), // Rule ID 62814 //
     /*  394608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394629 */     // MIs[0] op1
     /*  394629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394637 */     // MIs[0] op2
     /*  394637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394656 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  394659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394675 */     GIR_RootConstrainSelectedInstOperands,
     /*  394676 */     // GIR_Coverage, 62814,
     /*  394676 */     GIR_EraseRootFromParent_Done,
     /*  394677 */   // Label 7052: @394677
     /*  394677 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(394751), // Rule ID 62859 //
     /*  394682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394703 */     // MIs[0] op1
     /*  394703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394711 */     // MIs[0] op2
     /*  394711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  394733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394749 */     GIR_RootConstrainSelectedInstOperands,
     /*  394750 */     // GIR_Coverage, 62859,
     /*  394750 */     GIR_EraseRootFromParent_Done,
     /*  394751 */   // Label 7053: @394751
     /*  394751 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(394825), // Rule ID 62860 //
     /*  394756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394777 */     // MIs[0] op1
     /*  394777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394785 */     // MIs[0] op2
     /*  394785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  394807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394809 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394811 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394813 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394823 */     GIR_RootConstrainSelectedInstOperands,
     /*  394824 */     // GIR_Coverage, 62860,
     /*  394824 */     GIR_EraseRootFromParent_Done,
     /*  394825 */   // Label 7054: @394825
     /*  394825 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(394899), // Rule ID 62903 //
     /*  394830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394851 */     // MIs[0] op1
     /*  394851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394859 */     // MIs[0] op2
     /*  394859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  394881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394897 */     GIR_RootConstrainSelectedInstOperands,
     /*  394898 */     // GIR_Coverage, 62903,
     /*  394898 */     GIR_EraseRootFromParent_Done,
     /*  394899 */   // Label 7055: @394899
     /*  394899 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(394973), // Rule ID 62904 //
     /*  394904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  394918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394925 */     // MIs[0] op1
     /*  394925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394933 */     // MIs[0] op2
     /*  394933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  394936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  394941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  394945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  394955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394957 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394959 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394961 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394971 */     GIR_RootConstrainSelectedInstOperands,
     /*  394972 */     // GIR_Coverage, 62904,
     /*  394972 */     GIR_EraseRootFromParent_Done,
     /*  394973 */   // Label 7056: @394973
     /*  394973 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(395047), // Rule ID 62947 //
     /*  394978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  394986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  394992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394999 */     // MIs[0] op1
     /*  394999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395007 */     // MIs[0] op2
     /*  395007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  395029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395045 */     GIR_RootConstrainSelectedInstOperands,
     /*  395046 */     // GIR_Coverage, 62947,
     /*  395046 */     GIR_EraseRootFromParent_Done,
     /*  395047 */   // Label 7057: @395047
     /*  395047 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(395121), // Rule ID 62948 //
     /*  395052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  395063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395073 */     // MIs[0] op1
     /*  395073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395081 */     // MIs[0] op2
     /*  395081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  395103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395105 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395107 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395109 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395119 */     GIR_RootConstrainSelectedInstOperands,
     /*  395120 */     // GIR_Coverage, 62948,
     /*  395120 */     GIR_EraseRootFromParent_Done,
     /*  395121 */   // Label 7058: @395121
     /*  395121 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(395195), // Rule ID 63003 //
     /*  395126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395147 */     // MIs[0] op1
     /*  395147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395155 */     // MIs[0] op2
     /*  395155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395179 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395181 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395183 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395193 */     GIR_RootConstrainSelectedInstOperands,
     /*  395194 */     // GIR_Coverage, 63003,
     /*  395194 */     GIR_EraseRootFromParent_Done,
     /*  395195 */   // Label 7059: @395195
     /*  395195 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(395269), // Rule ID 63004 //
     /*  395200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  395211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395221 */     // MIs[0] op1
     /*  395221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395229 */     // MIs[0] op2
     /*  395229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395253 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395255 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395257 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395267 */     GIR_RootConstrainSelectedInstOperands,
     /*  395268 */     // GIR_Coverage, 63004,
     /*  395268 */     GIR_EraseRootFromParent_Done,
     /*  395269 */   // Label 7060: @395269
     /*  395269 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(395343), // Rule ID 63059 //
     /*  395274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395295 */     // MIs[0] op1
     /*  395295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395303 */     // MIs[0] op2
     /*  395303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395327 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395329 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395331 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395341 */     GIR_RootConstrainSelectedInstOperands,
     /*  395342 */     // GIR_Coverage, 63059,
     /*  395342 */     GIR_EraseRootFromParent_Done,
     /*  395343 */   // Label 7061: @395343
     /*  395343 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(395417), // Rule ID 63060 //
     /*  395348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  395359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395369 */     // MIs[0] op1
     /*  395369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395377 */     // MIs[0] op2
     /*  395377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  395399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395401 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395403 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395405 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395415 */     GIR_RootConstrainSelectedInstOperands,
     /*  395416 */     // GIR_Coverage, 63060,
     /*  395416 */     GIR_EraseRootFromParent_Done,
     /*  395417 */   // Label 7062: @395417
     /*  395417 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(395491), // Rule ID 63115 //
     /*  395422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395443 */     // MIs[0] op1
     /*  395443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395451 */     // MIs[0] op2
     /*  395451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395475 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395477 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395479 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395489 */     GIR_RootConstrainSelectedInstOperands,
     /*  395490 */     // GIR_Coverage, 63115,
     /*  395490 */     GIR_EraseRootFromParent_Done,
     /*  395491 */   // Label 7063: @395491
     /*  395491 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(395565), // Rule ID 63116 //
     /*  395496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  395507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395517 */     // MIs[0] op1
     /*  395517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395525 */     // MIs[0] op2
     /*  395525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395563 */     GIR_RootConstrainSelectedInstOperands,
     /*  395564 */     // GIR_Coverage, 63116,
     /*  395564 */     GIR_EraseRootFromParent_Done,
     /*  395565 */   // Label 7064: @395565
     /*  395565 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(395639), // Rule ID 63159 //
     /*  395570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395591 */     // MIs[0] op1
     /*  395591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395599 */     // MIs[0] op2
     /*  395599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395623 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395625 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395627 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395637 */     GIR_RootConstrainSelectedInstOperands,
     /*  395638 */     // GIR_Coverage, 63159,
     /*  395638 */     GIR_EraseRootFromParent_Done,
     /*  395639 */   // Label 7065: @395639
     /*  395639 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(395713), // Rule ID 63160 //
     /*  395644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395665 */     // MIs[0] op1
     /*  395665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395673 */     // MIs[0] op2
     /*  395673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395697 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395699 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395701 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395711 */     GIR_RootConstrainSelectedInstOperands,
     /*  395712 */     // GIR_Coverage, 63160,
     /*  395712 */     GIR_EraseRootFromParent_Done,
     /*  395713 */   // Label 7066: @395713
     /*  395713 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(395787), // Rule ID 63215 //
     /*  395718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395739 */     // MIs[0] op1
     /*  395739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395747 */     // MIs[0] op2
     /*  395747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395771 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395773 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395775 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395785 */     GIR_RootConstrainSelectedInstOperands,
     /*  395786 */     // GIR_Coverage, 63215,
     /*  395786 */     GIR_EraseRootFromParent_Done,
     /*  395787 */   // Label 7067: @395787
     /*  395787 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(395861), // Rule ID 63216 //
     /*  395792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395813 */     // MIs[0] op1
     /*  395813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395821 */     // MIs[0] op2
     /*  395821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395845 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395847 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395849 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395859 */     GIR_RootConstrainSelectedInstOperands,
     /*  395860 */     // GIR_Coverage, 63216,
     /*  395860 */     GIR_EraseRootFromParent_Done,
     /*  395861 */   // Label 7068: @395861
     /*  395861 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(395935), // Rule ID 63271 //
     /*  395866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  395880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395887 */     // MIs[0] op1
     /*  395887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395895 */     // MIs[0] op2
     /*  395895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395919 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395921 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395923 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395933 */     GIR_RootConstrainSelectedInstOperands,
     /*  395934 */     // GIR_Coverage, 63271,
     /*  395934 */     GIR_EraseRootFromParent_Done,
     /*  395935 */   // Label 7069: @395935
     /*  395935 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(396009), // Rule ID 63272 //
     /*  395940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  395948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  395954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395961 */     // MIs[0] op1
     /*  395961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395969 */     // MIs[0] op2
     /*  395969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  395972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  395977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  395981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  395991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396007 */     GIR_RootConstrainSelectedInstOperands,
     /*  396008 */     // GIR_Coverage, 63272,
     /*  396008 */     GIR_EraseRootFromParent_Done,
     /*  396009 */   // Label 7070: @396009
     /*  396009 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(396083), // Rule ID 63327 //
     /*  396014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  396025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396035 */     // MIs[0] op1
     /*  396035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396043 */     // MIs[0] op2
     /*  396043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396081 */     GIR_RootConstrainSelectedInstOperands,
     /*  396082 */     // GIR_Coverage, 63327,
     /*  396082 */     GIR_EraseRootFromParent_Done,
     /*  396083 */   // Label 7071: @396083
     /*  396083 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(396157), // Rule ID 63328 //
     /*  396088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  396099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396109 */     // MIs[0] op1
     /*  396109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396117 */     // MIs[0] op2
     /*  396117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396141 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396143 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396145 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396155 */     GIR_RootConstrainSelectedInstOperands,
     /*  396156 */     // GIR_Coverage, 63328,
     /*  396156 */     GIR_EraseRootFromParent_Done,
     /*  396157 */   // Label 7072: @396157
     /*  396157 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(396231), // Rule ID 63371 //
     /*  396162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396183 */     // MIs[0] op1
     /*  396183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396191 */     // MIs[0] op2
     /*  396191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396210 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396229 */     GIR_RootConstrainSelectedInstOperands,
     /*  396230 */     // GIR_Coverage, 63371,
     /*  396230 */     GIR_EraseRootFromParent_Done,
     /*  396231 */   // Label 7073: @396231
     /*  396231 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(396305), // Rule ID 63372 //
     /*  396236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  396247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396257 */     // MIs[0] op1
     /*  396257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396265 */     // MIs[0] op2
     /*  396265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396289 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396291 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396293 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396303 */     GIR_RootConstrainSelectedInstOperands,
     /*  396304 */     // GIR_Coverage, 63372,
     /*  396304 */     GIR_EraseRootFromParent_Done,
     /*  396305 */   // Label 7074: @396305
     /*  396305 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(396379), // Rule ID 63415 //
     /*  396310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396331 */     // MIs[0] op1
     /*  396331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396339 */     // MIs[0] op2
     /*  396339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  396358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396377 */     GIR_RootConstrainSelectedInstOperands,
     /*  396378 */     // GIR_Coverage, 63415,
     /*  396378 */     GIR_EraseRootFromParent_Done,
     /*  396379 */   // Label 7075: @396379
     /*  396379 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(396453), // Rule ID 63416 //
     /*  396384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  396395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396405 */     // MIs[0] op1
     /*  396405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396413 */     // MIs[0] op2
     /*  396413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  396432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396437 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396439 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396441 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396451 */     GIR_RootConstrainSelectedInstOperands,
     /*  396452 */     // GIR_Coverage, 63416,
     /*  396452 */     GIR_EraseRootFromParent_Done,
     /*  396453 */   // Label 7076: @396453
     /*  396453 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(396527), // Rule ID 63459 //
     /*  396458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396479 */     // MIs[0] op1
     /*  396479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396487 */     // MIs[0] op2
     /*  396487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396525 */     GIR_RootConstrainSelectedInstOperands,
     /*  396526 */     // GIR_Coverage, 63459,
     /*  396526 */     GIR_EraseRootFromParent_Done,
     /*  396527 */   // Label 7077: @396527
     /*  396527 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(396601), // Rule ID 63460 //
     /*  396532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  396543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396553 */     // MIs[0] op1
     /*  396553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396561 */     // MIs[0] op2
     /*  396561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396585 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396587 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396589 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396599 */     GIR_RootConstrainSelectedInstOperands,
     /*  396600 */     // GIR_Coverage, 63460,
     /*  396600 */     GIR_EraseRootFromParent_Done,
     /*  396601 */   // Label 7078: @396601
     /*  396601 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(396675), // Rule ID 63515 //
     /*  396606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396627 */     // MIs[0] op1
     /*  396627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396635 */     // MIs[0] op2
     /*  396635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396673 */     GIR_RootConstrainSelectedInstOperands,
     /*  396674 */     // GIR_Coverage, 63515,
     /*  396674 */     GIR_EraseRootFromParent_Done,
     /*  396675 */   // Label 7079: @396675
     /*  396675 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(396749), // Rule ID 63516 //
     /*  396680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396701 */     // MIs[0] op1
     /*  396701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396709 */     // MIs[0] op2
     /*  396709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  396731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396733 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396735 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396737 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396747 */     GIR_RootConstrainSelectedInstOperands,
     /*  396748 */     // GIR_Coverage, 63516,
     /*  396748 */     GIR_EraseRootFromParent_Done,
     /*  396749 */   // Label 7080: @396749
     /*  396749 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(396823), // Rule ID 63571 //
     /*  396754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396775 */     // MIs[0] op1
     /*  396775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396783 */     // MIs[0] op2
     /*  396783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396821 */     GIR_RootConstrainSelectedInstOperands,
     /*  396822 */     // GIR_Coverage, 63571,
     /*  396822 */     GIR_EraseRootFromParent_Done,
     /*  396823 */   // Label 7081: @396823
     /*  396823 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(396897), // Rule ID 63572 //
     /*  396828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396849 */     // MIs[0] op1
     /*  396849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396857 */     // MIs[0] op2
     /*  396857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  396879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396895 */     GIR_RootConstrainSelectedInstOperands,
     /*  396896 */     // GIR_Coverage, 63572,
     /*  396896 */     GIR_EraseRootFromParent_Done,
     /*  396897 */   // Label 7082: @396897
     /*  396897 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(396971), // Rule ID 63627 //
     /*  396902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396923 */     // MIs[0] op1
     /*  396923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396931 */     // MIs[0] op2
     /*  396931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  396934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  396939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  396943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  396953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396955 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396957 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396959 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396969 */     GIR_RootConstrainSelectedInstOperands,
     /*  396970 */     // GIR_Coverage, 63627,
     /*  396970 */     GIR_EraseRootFromParent_Done,
     /*  396971 */   // Label 7083: @396971
     /*  396971 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(397045), // Rule ID 63628 //
     /*  396976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  396984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396997 */     // MIs[0] op1
     /*  396997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397005 */     // MIs[0] op2
     /*  397005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397029 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397031 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397033 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397043 */     GIR_RootConstrainSelectedInstOperands,
     /*  397044 */     // GIR_Coverage, 63628,
     /*  397044 */     GIR_EraseRootFromParent_Done,
     /*  397045 */   // Label 7084: @397045
     /*  397045 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(397119), // Rule ID 63683 //
     /*  397050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397071 */     // MIs[0] op1
     /*  397071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397079 */     // MIs[0] op2
     /*  397079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397103 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397105 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397107 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397117 */     GIR_RootConstrainSelectedInstOperands,
     /*  397118 */     // GIR_Coverage, 63683,
     /*  397118 */     GIR_EraseRootFromParent_Done,
     /*  397119 */   // Label 7085: @397119
     /*  397119 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(397193), // Rule ID 63684 //
     /*  397124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  397135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397145 */     // MIs[0] op1
     /*  397145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397153 */     // MIs[0] op2
     /*  397153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397191 */     GIR_RootConstrainSelectedInstOperands,
     /*  397192 */     // GIR_Coverage, 63684,
     /*  397192 */     GIR_EraseRootFromParent_Done,
     /*  397193 */   // Label 7086: @397193
     /*  397193 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(397267), // Rule ID 63739 //
     /*  397198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397219 */     // MIs[0] op1
     /*  397219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397227 */     // MIs[0] op2
     /*  397227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  397246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397251 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397253 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397255 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397265 */     GIR_RootConstrainSelectedInstOperands,
     /*  397266 */     // GIR_Coverage, 63739,
     /*  397266 */     GIR_EraseRootFromParent_Done,
     /*  397267 */   // Label 7087: @397267
     /*  397267 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(397341), // Rule ID 63740 //
     /*  397272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  397283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397293 */     // MIs[0] op1
     /*  397293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397301 */     // MIs[0] op2
     /*  397301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  397320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397325 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397327 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397329 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397339 */     GIR_RootConstrainSelectedInstOperands,
     /*  397340 */     // GIR_Coverage, 63740,
     /*  397340 */     GIR_EraseRootFromParent_Done,
     /*  397341 */   // Label 7088: @397341
     /*  397341 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(397415), // Rule ID 63795 //
     /*  397346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397367 */     // MIs[0] op1
     /*  397367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397375 */     // MIs[0] op2
     /*  397375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397413 */     GIR_RootConstrainSelectedInstOperands,
     /*  397414 */     // GIR_Coverage, 63795,
     /*  397414 */     GIR_EraseRootFromParent_Done,
     /*  397415 */   // Label 7089: @397415
     /*  397415 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(397489), // Rule ID 63796 //
     /*  397420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  397431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  397441 */     // MIs[0] op1
     /*  397441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397449 */     // MIs[0] op2
     /*  397449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  397471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397473 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397475 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397477 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397487 */     GIR_RootConstrainSelectedInstOperands,
     /*  397488 */     // GIR_Coverage, 63796,
     /*  397488 */     GIR_EraseRootFromParent_Done,
     /*  397489 */   // Label 7090: @397489
     /*  397489 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(397563), // Rule ID 63851 //
     /*  397494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397515 */     // MIs[0] op1
     /*  397515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397523 */     // MIs[0] op2
     /*  397523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397547 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397549 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397551 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397561 */     GIR_RootConstrainSelectedInstOperands,
     /*  397562 */     // GIR_Coverage, 63851,
     /*  397562 */     GIR_EraseRootFromParent_Done,
     /*  397563 */   // Label 7091: @397563
     /*  397563 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(397637), // Rule ID 63852 //
     /*  397568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  397579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397589 */     // MIs[0] op1
     /*  397589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397597 */     // MIs[0] op2
     /*  397597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  397619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397621 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397623 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397625 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397635 */     GIR_RootConstrainSelectedInstOperands,
     /*  397636 */     // GIR_Coverage, 63852,
     /*  397636 */     GIR_EraseRootFromParent_Done,
     /*  397637 */   // Label 7092: @397637
     /*  397637 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(397711), // Rule ID 63907 //
     /*  397642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397663 */     // MIs[0] op1
     /*  397663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397671 */     // MIs[0] op2
     /*  397671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397709 */     GIR_RootConstrainSelectedInstOperands,
     /*  397710 */     // GIR_Coverage, 63907,
     /*  397710 */     GIR_EraseRootFromParent_Done,
     /*  397711 */   // Label 7093: @397711
     /*  397711 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(397785), // Rule ID 63908 //
     /*  397716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  397724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397737 */     // MIs[0] op1
     /*  397737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397745 */     // MIs[0] op2
     /*  397745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  397748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  397753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  397757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397764 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11020:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  397767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397769 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397771 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397773 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397783 */     GIR_RootConstrainSelectedInstOperands,
     /*  397784 */     // GIR_Coverage, 63908,
     /*  397784 */     GIR_EraseRootFromParent_Done,
     /*  397785 */   // Label 7094: @397785
     /*  397785 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(397859), // Rule ID 62837 //
     /*  397790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397811 */     // MIs[0] op1
     /*  397811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397823 */     // MIs[0] op3
     /*  397823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397838 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  397838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  397841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397843 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397845 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397847 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397857 */     GIR_RootConstrainSelectedInstOperands,
     /*  397858 */     // GIR_Coverage, 62837,
     /*  397858 */     GIR_EraseRootFromParent_Done,
     /*  397859 */   // Label 7095: @397859
     /*  397859 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(397933), // Rule ID 62838 //
     /*  397864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397885 */     // MIs[0] op1
     /*  397885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397888 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397897 */     // MIs[0] op3
     /*  397897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397912 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  397912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  397915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397917 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397919 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397921 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397931 */     GIR_RootConstrainSelectedInstOperands,
     /*  397932 */     // GIR_Coverage, 62838,
     /*  397932 */     GIR_EraseRootFromParent_Done,
     /*  397933 */   // Label 7096: @397933
     /*  397933 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(398007), // Rule ID 62875 //
     /*  397938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397959 */     // MIs[0] op1
     /*  397959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397971 */     // MIs[0] op3
     /*  397971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  397986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  397989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397991 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397993 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397995 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398005 */     GIR_RootConstrainSelectedInstOperands,
     /*  398006 */     // GIR_Coverage, 62875,
     /*  398006 */     GIR_EraseRootFromParent_Done,
     /*  398007 */   // Label 7097: @398007
     /*  398007 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(398081), // Rule ID 62876 //
     /*  398012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  398023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  398026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398033 */     // MIs[0] op1
     /*  398033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398045 */     // MIs[0] op3
     /*  398045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398065 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398067 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398069 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398079 */     GIR_RootConstrainSelectedInstOperands,
     /*  398080 */     // GIR_Coverage, 62876,
     /*  398080 */     GIR_EraseRootFromParent_Done,
     /*  398081 */   // Label 7098: @398081
     /*  398081 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(398155), // Rule ID 62919 //
     /*  398086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398107 */     // MIs[0] op1
     /*  398107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398119 */     // MIs[0] op3
     /*  398119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  398134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398139 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398141 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398143 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398153 */     GIR_RootConstrainSelectedInstOperands,
     /*  398154 */     // GIR_Coverage, 62919,
     /*  398154 */     GIR_EraseRootFromParent_Done,
     /*  398155 */   // Label 7099: @398155
     /*  398155 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(398229), // Rule ID 62920 //
     /*  398160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  398171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  398174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398181 */     // MIs[0] op1
     /*  398181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398193 */     // MIs[0] op3
     /*  398193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398227 */     GIR_RootConstrainSelectedInstOperands,
     /*  398228 */     // GIR_Coverage, 62920,
     /*  398228 */     GIR_EraseRootFromParent_Done,
     /*  398229 */   // Label 7100: @398229
     /*  398229 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(398303), // Rule ID 62963 //
     /*  398234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398255 */     // MIs[0] op1
     /*  398255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398267 */     // MIs[0] op3
     /*  398267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398287 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398289 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398291 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398301 */     GIR_RootConstrainSelectedInstOperands,
     /*  398302 */     // GIR_Coverage, 62963,
     /*  398302 */     GIR_EraseRootFromParent_Done,
     /*  398303 */   // Label 7101: @398303
     /*  398303 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(398377), // Rule ID 62964 //
     /*  398308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  398319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  398322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398329 */     // MIs[0] op1
     /*  398329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398341 */     // MIs[0] op3
     /*  398341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  398359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398375 */     GIR_RootConstrainSelectedInstOperands,
     /*  398376 */     // GIR_Coverage, 62964,
     /*  398376 */     GIR_EraseRootFromParent_Done,
     /*  398377 */   // Label 7102: @398377
     /*  398377 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(398451), // Rule ID 63019 //
     /*  398382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398403 */     // MIs[0] op1
     /*  398403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398415 */     // MIs[0] op3
     /*  398415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398430 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398449 */     GIR_RootConstrainSelectedInstOperands,
     /*  398450 */     // GIR_Coverage, 63019,
     /*  398450 */     GIR_EraseRootFromParent_Done,
     /*  398451 */   // Label 7103: @398451
     /*  398451 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(398525), // Rule ID 63020 //
     /*  398456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  398467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  398470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398477 */     // MIs[0] op1
     /*  398477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398489 */     // MIs[0] op3
     /*  398489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398509 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398511 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398513 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398523 */     GIR_RootConstrainSelectedInstOperands,
     /*  398524 */     // GIR_Coverage, 63020,
     /*  398524 */     GIR_EraseRootFromParent_Done,
     /*  398525 */   // Label 7104: @398525
     /*  398525 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(398599), // Rule ID 63075 //
     /*  398530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398551 */     // MIs[0] op1
     /*  398551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398563 */     // MIs[0] op3
     /*  398563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  398578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398583 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398585 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398587 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398597 */     GIR_RootConstrainSelectedInstOperands,
     /*  398598 */     // GIR_Coverage, 63075,
     /*  398598 */     GIR_EraseRootFromParent_Done,
     /*  398599 */   // Label 7105: @398599
     /*  398599 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(398673), // Rule ID 63076 //
     /*  398604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398625 */     // MIs[0] op1
     /*  398625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398637 */     // MIs[0] op3
     /*  398637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  398652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  398655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398657 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398659 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398661 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398671 */     GIR_RootConstrainSelectedInstOperands,
     /*  398672 */     // GIR_Coverage, 63076,
     /*  398672 */     GIR_EraseRootFromParent_Done,
     /*  398673 */   // Label 7106: @398673
     /*  398673 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(398747), // Rule ID 63131 //
     /*  398678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398699 */     // MIs[0] op1
     /*  398699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398711 */     // MIs[0] op3
     /*  398711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  398726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398745 */     GIR_RootConstrainSelectedInstOperands,
     /*  398746 */     // GIR_Coverage, 63131,
     /*  398746 */     GIR_EraseRootFromParent_Done,
     /*  398747 */   // Label 7107: @398747
     /*  398747 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(398821), // Rule ID 63132 //
     /*  398752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398773 */     // MIs[0] op1
     /*  398773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398785 */     // MIs[0] op3
     /*  398785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  398800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398819 */     GIR_RootConstrainSelectedInstOperands,
     /*  398820 */     // GIR_Coverage, 63132,
     /*  398820 */     GIR_EraseRootFromParent_Done,
     /*  398821 */   // Label 7108: @398821
     /*  398821 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(398895), // Rule ID 63175 //
     /*  398826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398847 */     // MIs[0] op1
     /*  398847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398859 */     // MIs[0] op3
     /*  398859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  398874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398879 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398881 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398883 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398893 */     GIR_RootConstrainSelectedInstOperands,
     /*  398894 */     // GIR_Coverage, 63175,
     /*  398894 */     GIR_EraseRootFromParent_Done,
     /*  398895 */   // Label 7109: @398895
     /*  398895 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(398969), // Rule ID 63176 //
     /*  398900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  398903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398921 */     // MIs[0] op1
     /*  398921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  398929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398933 */     // MIs[0] op3
     /*  398933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  398936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  398941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  398948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  398951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  398955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  398957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  398959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398967 */     GIR_RootConstrainSelectedInstOperands,
     /*  398968 */     // GIR_Coverage, 63176,
     /*  398968 */     GIR_EraseRootFromParent_Done,
     /*  398969 */   // Label 7110: @398969
     /*  398969 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(399043), // Rule ID 63231 //
     /*  398974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  398977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  398982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398995 */     // MIs[0] op1
     /*  398995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  398998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399007 */     // MIs[0] op3
     /*  399007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  399022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399027 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399029 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399031 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399041 */     GIR_RootConstrainSelectedInstOperands,
     /*  399042 */     // GIR_Coverage, 63231,
     /*  399042 */     GIR_EraseRootFromParent_Done,
     /*  399043 */   // Label 7111: @399043
     /*  399043 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(399117), // Rule ID 63232 //
     /*  399048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  399059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  399062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399069 */     // MIs[0] op1
     /*  399069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399081 */     // MIs[0] op3
     /*  399081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  399096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399101 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399103 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399105 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399115 */     GIR_RootConstrainSelectedInstOperands,
     /*  399116 */     // GIR_Coverage, 63232,
     /*  399116 */     GIR_EraseRootFromParent_Done,
     /*  399117 */   // Label 7112: @399117
     /*  399117 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(399191), // Rule ID 63287 //
     /*  399122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399143 */     // MIs[0] op1
     /*  399143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399155 */     // MIs[0] op3
     /*  399155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  399170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399175 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399177 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399179 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399189 */     GIR_RootConstrainSelectedInstOperands,
     /*  399190 */     // GIR_Coverage, 63287,
     /*  399190 */     GIR_EraseRootFromParent_Done,
     /*  399191 */   // Label 7113: @399191
     /*  399191 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(399265), // Rule ID 63288 //
     /*  399196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  399207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  399210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399217 */     // MIs[0] op1
     /*  399217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  399229 */     // MIs[0] op3
     /*  399229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  399244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  399247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399249 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399251 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399253 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399263 */     GIR_RootConstrainSelectedInstOperands,
     /*  399264 */     // GIR_Coverage, 63288,
     /*  399264 */     GIR_EraseRootFromParent_Done,
     /*  399265 */   // Label 7114: @399265
     /*  399265 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(399339), // Rule ID 63343 //
     /*  399270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399291 */     // MIs[0] op1
     /*  399291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399303 */     // MIs[0] op3
     /*  399303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399337 */     GIR_RootConstrainSelectedInstOperands,
     /*  399338 */     // GIR_Coverage, 63343,
     /*  399338 */     GIR_EraseRootFromParent_Done,
     /*  399339 */   // Label 7115: @399339
     /*  399339 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(399413), // Rule ID 63344 //
     /*  399344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  399355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  399358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399365 */     // MIs[0] op1
     /*  399365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399377 */     // MIs[0] op3
     /*  399377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399397 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399399 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399401 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399411 */     GIR_RootConstrainSelectedInstOperands,
     /*  399412 */     // GIR_Coverage, 63344,
     /*  399412 */     GIR_EraseRootFromParent_Done,
     /*  399413 */   // Label 7116: @399413
     /*  399413 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(399487), // Rule ID 63387 //
     /*  399418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399439 */     // MIs[0] op1
     /*  399439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399451 */     // MIs[0] op3
     /*  399451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399466 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399471 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399473 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399475 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399485 */     GIR_RootConstrainSelectedInstOperands,
     /*  399486 */     // GIR_Coverage, 63387,
     /*  399486 */     GIR_EraseRootFromParent_Done,
     /*  399487 */   // Label 7117: @399487
     /*  399487 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(399561), // Rule ID 63388 //
     /*  399492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  399503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  399506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399513 */     // MIs[0] op1
     /*  399513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399525 */     // MIs[0] op3
     /*  399525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399545 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399547 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399549 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399559 */     GIR_RootConstrainSelectedInstOperands,
     /*  399560 */     // GIR_Coverage, 63388,
     /*  399560 */     GIR_EraseRootFromParent_Done,
     /*  399561 */   // Label 7118: @399561
     /*  399561 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(399635), // Rule ID 63431 //
     /*  399566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399587 */     // MIs[0] op1
     /*  399587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399599 */     // MIs[0] op3
     /*  399599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399614 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  399614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  399617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399619 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399621 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399623 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399633 */     GIR_RootConstrainSelectedInstOperands,
     /*  399634 */     // GIR_Coverage, 63431,
     /*  399634 */     GIR_EraseRootFromParent_Done,
     /*  399635 */   // Label 7119: @399635
     /*  399635 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(399709), // Rule ID 63432 //
     /*  399640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399661 */     // MIs[0] op1
     /*  399661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399673 */     // MIs[0] op3
     /*  399673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399688 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  399688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  399691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399693 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399695 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399697 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399707 */     GIR_RootConstrainSelectedInstOperands,
     /*  399708 */     // GIR_Coverage, 63432,
     /*  399708 */     GIR_EraseRootFromParent_Done,
     /*  399709 */   // Label 7120: @399709
     /*  399709 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(399783), // Rule ID 63475 //
     /*  399714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399735 */     // MIs[0] op1
     /*  399735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399747 */     // MIs[0] op3
     /*  399747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  399762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399767 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399769 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399771 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399781 */     GIR_RootConstrainSelectedInstOperands,
     /*  399782 */     // GIR_Coverage, 63475,
     /*  399782 */     GIR_EraseRootFromParent_Done,
     /*  399783 */   // Label 7121: @399783
     /*  399783 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(399857), // Rule ID 63476 //
     /*  399788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399809 */     // MIs[0] op1
     /*  399809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399821 */     // MIs[0] op3
     /*  399821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  399836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  399839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399855 */     GIR_RootConstrainSelectedInstOperands,
     /*  399856 */     // GIR_Coverage, 63476,
     /*  399856 */     GIR_EraseRootFromParent_Done,
     /*  399857 */   // Label 7122: @399857
     /*  399857 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(399931), // Rule ID 63531 //
     /*  399862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  399865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399883 */     // MIs[0] op1
     /*  399883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399895 */     // MIs[0] op3
     /*  399895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  399910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399915 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399917 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399919 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399929 */     GIR_RootConstrainSelectedInstOperands,
     /*  399930 */     // GIR_Coverage, 63531,
     /*  399930 */     GIR_EraseRootFromParent_Done,
     /*  399931 */   // Label 7123: @399931
     /*  399931 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(400005), // Rule ID 63532 //
     /*  399936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  399939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  399944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399957 */     // MIs[0] op1
     /*  399957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  399960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  399965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399969 */     // MIs[0] op3
     /*  399969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  399972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  399977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  399984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  399987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399989 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  399991 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  399993 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  399995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400003 */     GIR_RootConstrainSelectedInstOperands,
     /*  400004 */     // GIR_Coverage, 63532,
     /*  400004 */     GIR_EraseRootFromParent_Done,
     /*  400005 */   // Label 7124: @400005
     /*  400005 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(400079), // Rule ID 63587 //
     /*  400010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400031 */     // MIs[0] op1
     /*  400031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400043 */     // MIs[0] op3
     /*  400043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  400058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400077 */     GIR_RootConstrainSelectedInstOperands,
     /*  400078 */     // GIR_Coverage, 63587,
     /*  400078 */     GIR_EraseRootFromParent_Done,
     /*  400079 */   // Label 7125: @400079
     /*  400079 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(400153), // Rule ID 63588 //
     /*  400084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  400095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  400098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400105 */     // MIs[0] op1
     /*  400105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400117 */     // MIs[0] op3
     /*  400117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  400132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400137 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400139 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400141 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400151 */     GIR_RootConstrainSelectedInstOperands,
     /*  400152 */     // GIR_Coverage, 63588,
     /*  400152 */     GIR_EraseRootFromParent_Done,
     /*  400153 */   // Label 7126: @400153
     /*  400153 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(400227), // Rule ID 63643 //
     /*  400158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400179 */     // MIs[0] op1
     /*  400179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400191 */     // MIs[0] op3
     /*  400191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400211 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400213 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400215 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400225 */     GIR_RootConstrainSelectedInstOperands,
     /*  400226 */     // GIR_Coverage, 63643,
     /*  400226 */     GIR_EraseRootFromParent_Done,
     /*  400227 */   // Label 7127: @400227
     /*  400227 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(400301), // Rule ID 63644 //
     /*  400232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  400243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  400246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400253 */     // MIs[0] op1
     /*  400253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400265 */     // MIs[0] op3
     /*  400265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400299 */     GIR_RootConstrainSelectedInstOperands,
     /*  400300 */     // GIR_Coverage, 63644,
     /*  400300 */     GIR_EraseRootFromParent_Done,
     /*  400301 */   // Label 7128: @400301
     /*  400301 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(400375), // Rule ID 63699 //
     /*  400306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400327 */     // MIs[0] op1
     /*  400327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400339 */     // MIs[0] op3
     /*  400339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400359 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400361 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400363 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400373 */     GIR_RootConstrainSelectedInstOperands,
     /*  400374 */     // GIR_Coverage, 63699,
     /*  400374 */     GIR_EraseRootFromParent_Done,
     /*  400375 */   // Label 7129: @400375
     /*  400375 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(400449), // Rule ID 63700 //
     /*  400380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  400391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  400394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400401 */     // MIs[0] op1
     /*  400401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400413 */     // MIs[0] op3
     /*  400413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400433 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400435 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400437 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400447 */     GIR_RootConstrainSelectedInstOperands,
     /*  400448 */     // GIR_Coverage, 63700,
     /*  400448 */     GIR_EraseRootFromParent_Done,
     /*  400449 */   // Label 7130: @400449
     /*  400449 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(400523), // Rule ID 63755 //
     /*  400454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400475 */     // MIs[0] op1
     /*  400475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400487 */     // MIs[0] op3
     /*  400487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  400502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400507 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400509 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400511 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400521 */     GIR_RootConstrainSelectedInstOperands,
     /*  400522 */     // GIR_Coverage, 63755,
     /*  400522 */     GIR_EraseRootFromParent_Done,
     /*  400523 */   // Label 7131: @400523
     /*  400523 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(400597), // Rule ID 63756 //
     /*  400528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  400539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  400542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400549 */     // MIs[0] op1
     /*  400549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400561 */     // MIs[0] op3
     /*  400561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  400576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400595 */     GIR_RootConstrainSelectedInstOperands,
     /*  400596 */     // GIR_Coverage, 63756,
     /*  400596 */     GIR_EraseRootFromParent_Done,
     /*  400597 */   // Label 7132: @400597
     /*  400597 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(400671), // Rule ID 63811 //
     /*  400602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400623 */     // MIs[0] op1
     /*  400623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400635 */     // MIs[0] op3
     /*  400635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400655 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400657 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400659 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400669 */     GIR_RootConstrainSelectedInstOperands,
     /*  400670 */     // GIR_Coverage, 63811,
     /*  400670 */     GIR_EraseRootFromParent_Done,
     /*  400671 */   // Label 7133: @400671
     /*  400671 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(400745), // Rule ID 63812 //
     /*  400676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400697 */     // MIs[0] op1
     /*  400697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400709 */     // MIs[0] op3
     /*  400709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  400724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  400727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400729 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400731 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400733 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400743 */     GIR_RootConstrainSelectedInstOperands,
     /*  400744 */     // GIR_Coverage, 63812,
     /*  400744 */     GIR_EraseRootFromParent_Done,
     /*  400745 */   // Label 7134: @400745
     /*  400745 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(400819), // Rule ID 63867 //
     /*  400750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400771 */     // MIs[0] op1
     /*  400771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400783 */     // MIs[0] op3
     /*  400783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400798 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400803 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400805 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400807 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400817 */     GIR_RootConstrainSelectedInstOperands,
     /*  400818 */     // GIR_Coverage, 63867,
     /*  400818 */     GIR_EraseRootFromParent_Done,
     /*  400819 */   // Label 7135: @400819
     /*  400819 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(400893), // Rule ID 63868 //
     /*  400824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400845 */     // MIs[0] op1
     /*  400845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400857 */     // MIs[0] op3
     /*  400857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  400872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  400875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400877 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400879 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400881 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400891 */     GIR_RootConstrainSelectedInstOperands,
     /*  400892 */     // GIR_Coverage, 63868,
     /*  400892 */     GIR_EraseRootFromParent_Done,
     /*  400893 */   // Label 7136: @400893
     /*  400893 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(400967), // Rule ID 63923 //
     /*  400898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  400901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400919 */     // MIs[0] op1
     /*  400919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  400927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400931 */     // MIs[0] op3
     /*  400931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  400934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  400939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  400946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  400949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  400953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  400955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  400957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400965 */     GIR_RootConstrainSelectedInstOperands,
     /*  400966 */     // GIR_Coverage, 63923,
     /*  400966 */     GIR_EraseRootFromParent_Done,
     /*  400967 */   // Label 7137: @400967
     /*  400967 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(401041), // Rule ID 63924 //
     /*  400972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  400975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  400980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400993 */     // MIs[0] op1
     /*  400993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  400996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  401001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401005 */     // MIs[0] op3
     /*  401005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  401008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  401013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  401020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  401023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401025 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  401027 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  401029 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  401031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401039 */     GIR_RootConstrainSelectedInstOperands,
     /*  401040 */     // GIR_Coverage, 63924,
     /*  401040 */     GIR_EraseRootFromParent_Done,
     /*  401041 */   // Label 7138: @401041
     /*  401041 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(401116), // Rule ID 7348 //
     /*  401046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  401063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  401095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401114 */     GIR_RootConstrainSelectedInstOperands,
     /*  401115 */     // GIR_Coverage, 7348,
     /*  401115 */     GIR_EraseRootFromParent_Done,
     /*  401116 */   // Label 7139: @401116
     /*  401116 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(401191), // Rule ID 7349 //
     /*  401121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  401132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  401135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  401138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  401170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401189 */     GIR_RootConstrainSelectedInstOperands,
     /*  401190 */     // GIR_Coverage, 7349,
     /*  401190 */     GIR_EraseRootFromParent_Done,
     /*  401191 */   // Label 7140: @401191
     /*  401191 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(401266), // Rule ID 7352 //
     /*  401196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  401213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401264 */     GIR_RootConstrainSelectedInstOperands,
     /*  401265 */     // GIR_Coverage, 7352,
     /*  401265 */     GIR_EraseRootFromParent_Done,
     /*  401266 */   // Label 7141: @401266
     /*  401266 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(401341), // Rule ID 7353 //
     /*  401271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  401282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  401285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  401288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401317 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401339 */     GIR_RootConstrainSelectedInstOperands,
     /*  401340 */     // GIR_Coverage, 7353,
     /*  401340 */     GIR_EraseRootFromParent_Done,
     /*  401341 */   // Label 7142: @401341
     /*  401341 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(401416), // Rule ID 7356 //
     /*  401346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  401363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401414 */     GIR_RootConstrainSelectedInstOperands,
     /*  401415 */     // GIR_Coverage, 7356,
     /*  401415 */     GIR_EraseRootFromParent_Done,
     /*  401416 */   // Label 7143: @401416
     /*  401416 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(401491), // Rule ID 7357 //
     /*  401421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  401432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  401435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  401438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401467 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  401467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  401486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401489 */     GIR_RootConstrainSelectedInstOperands,
     /*  401490 */     // GIR_Coverage, 7357,
     /*  401490 */     GIR_EraseRootFromParent_Done,
     /*  401491 */   // Label 7144: @401491
     /*  401491 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(401566), // Rule ID 7360 //
     /*  401496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401564 */     GIR_RootConstrainSelectedInstOperands,
     /*  401565 */     // GIR_Coverage, 7360,
     /*  401565 */     GIR_EraseRootFromParent_Done,
     /*  401566 */   // Label 7145: @401566
     /*  401566 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(401641), // Rule ID 7361 //
     /*  401571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  401582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  401585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  401588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401617 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  401620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401639 */     GIR_RootConstrainSelectedInstOperands,
     /*  401640 */     // GIR_Coverage, 7361,
     /*  401640 */     GIR_EraseRootFromParent_Done,
     /*  401641 */   // Label 7146: @401641
     /*  401641 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(401716), // Rule ID 7364 //
     /*  401646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401692 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401714 */     GIR_RootConstrainSelectedInstOperands,
     /*  401715 */     // GIR_Coverage, 7364,
     /*  401715 */     GIR_EraseRootFromParent_Done,
     /*  401716 */   // Label 7147: @401716
     /*  401716 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(401791), // Rule ID 7365 //
     /*  401721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  401732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  401735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  401738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401767 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401789 */     GIR_RootConstrainSelectedInstOperands,
     /*  401790 */     // GIR_Coverage, 7365,
     /*  401790 */     GIR_EraseRootFromParent_Done,
     /*  401791 */   // Label 7148: @401791
     /*  401791 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(401866), // Rule ID 7368 //
     /*  401796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401864 */     GIR_RootConstrainSelectedInstOperands,
     /*  401865 */     // GIR_Coverage, 7368,
     /*  401865 */     GIR_EraseRootFromParent_Done,
     /*  401866 */   // Label 7149: @401866
     /*  401866 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(401941), // Rule ID 7369 //
     /*  401871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  401874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  401882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  401885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  401888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  401891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401917 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  401920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  401928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401939 */     GIR_RootConstrainSelectedInstOperands,
     /*  401940 */     // GIR_Coverage, 7369,
     /*  401940 */     GIR_EraseRootFromParent_Done,
     /*  401941 */   // Label 7150: @401941
     /*  401941 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(402016), // Rule ID 7372 //
     /*  401946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  401949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  401954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  401957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  401960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  401963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  401966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  401985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  401992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  401995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402014 */     GIR_RootConstrainSelectedInstOperands,
     /*  402015 */     // GIR_Coverage, 7372,
     /*  402015 */     GIR_EraseRootFromParent_Done,
     /*  402016 */   // Label 7151: @402016
     /*  402016 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(402091), // Rule ID 7373 //
     /*  402021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  402032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  402035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  402038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402067 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402089 */     GIR_RootConstrainSelectedInstOperands,
     /*  402090 */     // GIR_Coverage, 7373,
     /*  402090 */     GIR_EraseRootFromParent_Done,
     /*  402091 */   // Label 7152: @402091
     /*  402091 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(402166), // Rule ID 7376 //
     /*  402096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402164 */     GIR_RootConstrainSelectedInstOperands,
     /*  402165 */     // GIR_Coverage, 7376,
     /*  402165 */     GIR_EraseRootFromParent_Done,
     /*  402166 */   // Label 7153: @402166
     /*  402166 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(402241), // Rule ID 7377 //
     /*  402171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402239 */     GIR_RootConstrainSelectedInstOperands,
     /*  402240 */     // GIR_Coverage, 7377,
     /*  402240 */     GIR_EraseRootFromParent_Done,
     /*  402241 */   // Label 7154: @402241
     /*  402241 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(402316), // Rule ID 7380 //
     /*  402246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  402263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402314 */     GIR_RootConstrainSelectedInstOperands,
     /*  402315 */     // GIR_Coverage, 7380,
     /*  402315 */     GIR_EraseRootFromParent_Done,
     /*  402316 */   // Label 7155: @402316
     /*  402316 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(402391), // Rule ID 7381 //
     /*  402321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  402338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402367 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402389 */     GIR_RootConstrainSelectedInstOperands,
     /*  402390 */     // GIR_Coverage, 7381,
     /*  402390 */     GIR_EraseRootFromParent_Done,
     /*  402391 */   // Label 7156: @402391
     /*  402391 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(402466), // Rule ID 7384 //
     /*  402396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  402399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  402413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402464 */     GIR_RootConstrainSelectedInstOperands,
     /*  402465 */     // GIR_Coverage, 7384,
     /*  402465 */     GIR_EraseRootFromParent_Done,
     /*  402466 */   // Label 7157: @402466
     /*  402466 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(402541), // Rule ID 7385 //
     /*  402471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  402474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  402482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  402485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  402488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  402520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402539 */     GIR_RootConstrainSelectedInstOperands,
     /*  402540 */     // GIR_Coverage, 7385,
     /*  402540 */     GIR_EraseRootFromParent_Done,
     /*  402541 */   // Label 7158: @402541
     /*  402541 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(402616), // Rule ID 7388 //
     /*  402546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  402563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  402595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402614 */     GIR_RootConstrainSelectedInstOperands,
     /*  402615 */     // GIR_Coverage, 7388,
     /*  402615 */     GIR_EraseRootFromParent_Done,
     /*  402616 */   // Label 7159: @402616
     /*  402616 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(402691), // Rule ID 7389 //
     /*  402621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  402632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  402635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  402638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402667 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  402670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402689 */     GIR_RootConstrainSelectedInstOperands,
     /*  402690 */     // GIR_Coverage, 7389,
     /*  402690 */     GIR_EraseRootFromParent_Done,
     /*  402691 */   // Label 7160: @402691
     /*  402691 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(402766), // Rule ID 7392 //
     /*  402696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  402713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402742 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  402745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402764 */     GIR_RootConstrainSelectedInstOperands,
     /*  402765 */     // GIR_Coverage, 7392,
     /*  402765 */     GIR_EraseRootFromParent_Done,
     /*  402766 */   // Label 7161: @402766
     /*  402766 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(402841), // Rule ID 7393 //
     /*  402771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  402782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  402785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  402788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402817 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  402820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402839 */     GIR_RootConstrainSelectedInstOperands,
     /*  402840 */     // GIR_Coverage, 7393,
     /*  402840 */     GIR_EraseRootFromParent_Done,
     /*  402841 */   // Label 7162: @402841
     /*  402841 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(402916), // Rule ID 7396 //
     /*  402846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  402863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  402866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402892 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  402892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  402895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402914 */     GIR_RootConstrainSelectedInstOperands,
     /*  402915 */     // GIR_Coverage, 7396,
     /*  402915 */     GIR_EraseRootFromParent_Done,
     /*  402916 */   // Label 7163: @402916
     /*  402916 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(402991), // Rule ID 7397 //
     /*  402921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  402924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  402929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  402932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  402935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  402938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  402941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  402960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402967 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  402967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  402970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  402978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  402986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402989 */     GIR_RootConstrainSelectedInstOperands,
     /*  402990 */     // GIR_Coverage, 7397,
     /*  402990 */     GIR_EraseRootFromParent_Done,
     /*  402991 */   // Label 7164: @402991
     /*  402991 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(403066), // Rule ID 7400 //
     /*  402996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  402999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403064 */     GIR_RootConstrainSelectedInstOperands,
     /*  403065 */     // GIR_Coverage, 7400,
     /*  403065 */     GIR_EraseRootFromParent_Done,
     /*  403066 */   // Label 7165: @403066
     /*  403066 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(403141), // Rule ID 7401 //
     /*  403071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403139 */     GIR_RootConstrainSelectedInstOperands,
     /*  403140 */     // GIR_Coverage, 7401,
     /*  403140 */     GIR_EraseRootFromParent_Done,
     /*  403141 */   // Label 7166: @403141
     /*  403141 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(403216), // Rule ID 7404 //
     /*  403146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403214 */     GIR_RootConstrainSelectedInstOperands,
     /*  403215 */     // GIR_Coverage, 7404,
     /*  403215 */     GIR_EraseRootFromParent_Done,
     /*  403216 */   // Label 7167: @403216
     /*  403216 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(403291), // Rule ID 7405 //
     /*  403221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403289 */     GIR_RootConstrainSelectedInstOperands,
     /*  403290 */     // GIR_Coverage, 7405,
     /*  403290 */     GIR_EraseRootFromParent_Done,
     /*  403291 */   // Label 7168: @403291
     /*  403291 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(403366), // Rule ID 7408 //
     /*  403296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403364 */     GIR_RootConstrainSelectedInstOperands,
     /*  403365 */     // GIR_Coverage, 7408,
     /*  403365 */     GIR_EraseRootFromParent_Done,
     /*  403366 */   // Label 7169: @403366
     /*  403366 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(403441), // Rule ID 7409 //
     /*  403371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403417 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403439 */     GIR_RootConstrainSelectedInstOperands,
     /*  403440 */     // GIR_Coverage, 7409,
     /*  403440 */     GIR_EraseRootFromParent_Done,
     /*  403441 */   // Label 7170: @403441
     /*  403441 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(403516), // Rule ID 7412 //
     /*  403446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403514 */     GIR_RootConstrainSelectedInstOperands,
     /*  403515 */     // GIR_Coverage, 7412,
     /*  403515 */     GIR_EraseRootFromParent_Done,
     /*  403516 */   // Label 7171: @403516
     /*  403516 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(403591), // Rule ID 7413 //
     /*  403521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403589 */     GIR_RootConstrainSelectedInstOperands,
     /*  403590 */     // GIR_Coverage, 7413,
     /*  403590 */     GIR_EraseRootFromParent_Done,
     /*  403591 */   // Label 7172: @403591
     /*  403591 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(403666), // Rule ID 7416 //
     /*  403596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403664 */     GIR_RootConstrainSelectedInstOperands,
     /*  403665 */     // GIR_Coverage, 7416,
     /*  403665 */     GIR_EraseRootFromParent_Done,
     /*  403666 */   // Label 7173: @403666
     /*  403666 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(403741), // Rule ID 7417 //
     /*  403671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  403720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403739 */     GIR_RootConstrainSelectedInstOperands,
     /*  403740 */     // GIR_Coverage, 7417,
     /*  403740 */     GIR_EraseRootFromParent_Done,
     /*  403741 */   // Label 7174: @403741
     /*  403741 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(403816), // Rule ID 7420 //
     /*  403746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  403749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  403763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403814 */     GIR_RootConstrainSelectedInstOperands,
     /*  403815 */     // GIR_Coverage, 7420,
     /*  403815 */     GIR_EraseRootFromParent_Done,
     /*  403816 */   // Label 7175: @403816
     /*  403816 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(403891), // Rule ID 7421 //
     /*  403821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  403824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  403832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  403835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  403838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403867 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  403870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403889 */     GIR_RootConstrainSelectedInstOperands,
     /*  403890 */     // GIR_Coverage, 7421,
     /*  403890 */     GIR_EraseRootFromParent_Done,
     /*  403891 */   // Label 7176: @403891
     /*  403891 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(403966), // Rule ID 7424 //
     /*  403896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  403899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  403913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  403916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  403935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  403945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  403953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403964 */     GIR_RootConstrainSelectedInstOperands,
     /*  403965 */     // GIR_Coverage, 7424,
     /*  403965 */     GIR_EraseRootFromParent_Done,
     /*  403966 */   // Label 7177: @403966
     /*  403966 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(404041), // Rule ID 7425 //
     /*  403971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  403974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  403979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  403982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  403985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  403988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  403991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  404020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404039 */     GIR_RootConstrainSelectedInstOperands,
     /*  404040 */     // GIR_Coverage, 7425,
     /*  404040 */     GIR_EraseRootFromParent_Done,
     /*  404041 */   // Label 7178: @404041
     /*  404041 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(404116), // Rule ID 7428 //
     /*  404046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  404049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  404095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404114 */     GIR_RootConstrainSelectedInstOperands,
     /*  404115 */     // GIR_Coverage, 7428,
     /*  404115 */     GIR_EraseRootFromParent_Done,
     /*  404116 */   // Label 7179: @404116
     /*  404116 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(404191), // Rule ID 7429 //
     /*  404121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404167 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  404170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404189 */     GIR_RootConstrainSelectedInstOperands,
     /*  404190 */     // GIR_Coverage, 7429,
     /*  404190 */     GIR_EraseRootFromParent_Done,
     /*  404191 */   // Label 7180: @404191
     /*  404191 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(404266), // Rule ID 7432 //
     /*  404196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  404199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  404216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  404245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404264 */     GIR_RootConstrainSelectedInstOperands,
     /*  404265 */     // GIR_Coverage, 7432,
     /*  404265 */     GIR_EraseRootFromParent_Done,
     /*  404266 */   // Label 7181: @404266
     /*  404266 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(404341), // Rule ID 7433 //
     /*  404271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  404274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  404279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  404291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  404310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404317 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  404320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  404328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404339 */     GIR_RootConstrainSelectedInstOperands,
     /*  404340 */     // GIR_Coverage, 7433,
     /*  404340 */     GIR_EraseRootFromParent_Done,
     /*  404341 */   // Label 7182: @404341
     /*  404341 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(404418), // Rule ID 2738 //
     /*  404346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  404357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  404360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404378 */     // MIs[0] Operand 4
     /*  404378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  404399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404416 */     GIR_RootConstrainSelectedInstOperands,
     /*  404417 */     // GIR_Coverage, 2738,
     /*  404417 */     GIR_EraseRootFromParent_Done,
     /*  404418 */   // Label 7183: @404418
     /*  404418 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(404495), // Rule ID 2739 //
     /*  404423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  404434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  404437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404455 */     // MIs[0] Operand 4
     /*  404455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404473 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  404476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404493 */     GIR_RootConstrainSelectedInstOperands,
     /*  404494 */     // GIR_Coverage, 2739,
     /*  404494 */     GIR_EraseRootFromParent_Done,
     /*  404495 */   // Label 7184: @404495
     /*  404495 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(404572), // Rule ID 20630 //
     /*  404500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  404511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  404514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404532 */     // MIs[0] Operand 4
     /*  404532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404570 */     GIR_RootConstrainSelectedInstOperands,
     /*  404571 */     // GIR_Coverage, 20630,
     /*  404571 */     GIR_EraseRootFromParent_Done,
     /*  404572 */   // Label 7185: @404572
     /*  404572 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(404649), // Rule ID 20631 //
     /*  404577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  404588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  404591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404609 */     // MIs[0] Operand 4
     /*  404609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404647 */     GIR_RootConstrainSelectedInstOperands,
     /*  404648 */     // GIR_Coverage, 20631,
     /*  404648 */     GIR_EraseRootFromParent_Done,
     /*  404649 */   // Label 7186: @404649
     /*  404649 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(404726), // Rule ID 20634 //
     /*  404654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404686 */     // MIs[0] Operand 4
     /*  404686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404724 */     GIR_RootConstrainSelectedInstOperands,
     /*  404725 */     // GIR_Coverage, 20634,
     /*  404725 */     GIR_EraseRootFromParent_Done,
     /*  404726 */   // Label 7187: @404726
     /*  404726 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(404803), // Rule ID 20635 //
     /*  404731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  404748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404763 */     // MIs[0] Operand 4
     /*  404763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  404784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404801 */     GIR_RootConstrainSelectedInstOperands,
     /*  404802 */     // GIR_Coverage, 20635,
     /*  404802 */     GIR_EraseRootFromParent_Done,
     /*  404803 */   // Label 7188: @404803
     /*  404803 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(404880), // Rule ID 20638 //
     /*  404808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  404819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  404822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  404825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404840 */     // MIs[0] Operand 4
     /*  404840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  404861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404878 */     GIR_RootConstrainSelectedInstOperands,
     /*  404879 */     // GIR_Coverage, 20638,
     /*  404879 */     GIR_EraseRootFromParent_Done,
     /*  404880 */   // Label 7189: @404880
     /*  404880 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(404957), // Rule ID 20639 //
     /*  404885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  404896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  404899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  404902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404917 */     // MIs[0] Operand 4
     /*  404917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404935 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  404938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404955 */     GIR_RootConstrainSelectedInstOperands,
     /*  404956 */     // GIR_Coverage, 20639,
     /*  404956 */     GIR_EraseRootFromParent_Done,
     /*  404957 */   // Label 7190: @404957
     /*  404957 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(405034), // Rule ID 20642 //
     /*  404962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  404970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  404979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404994 */     // MIs[0] Operand 4
     /*  404994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405032 */     GIR_RootConstrainSelectedInstOperands,
     /*  405033 */     // GIR_Coverage, 20642,
     /*  405033 */     GIR_EraseRootFromParent_Done,
     /*  405034 */   // Label 7191: @405034
     /*  405034 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(405111), // Rule ID 20643 //
     /*  405039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405071 */     // MIs[0] Operand 4
     /*  405071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405109 */     GIR_RootConstrainSelectedInstOperands,
     /*  405110 */     // GIR_Coverage, 20643,
     /*  405110 */     GIR_EraseRootFromParent_Done,
     /*  405111 */   // Label 7192: @405111
     /*  405111 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(405188), // Rule ID 20646 //
     /*  405116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  405119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  405133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405148 */     // MIs[0] Operand 4
     /*  405148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405186 */     GIR_RootConstrainSelectedInstOperands,
     /*  405187 */     // GIR_Coverage, 20646,
     /*  405187 */     GIR_EraseRootFromParent_Done,
     /*  405188 */   // Label 7193: @405188
     /*  405188 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(405265), // Rule ID 20647 //
     /*  405193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  405210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405225 */     // MIs[0] Operand 4
     /*  405225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  405246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405263 */     GIR_RootConstrainSelectedInstOperands,
     /*  405264 */     // GIR_Coverage, 20647,
     /*  405264 */     GIR_EraseRootFromParent_Done,
     /*  405265 */   // Label 7194: @405265
     /*  405265 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(405342), // Rule ID 20650 //
     /*  405270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  405281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  405284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405302 */     // MIs[0] Operand 4
     /*  405302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405340 */     GIR_RootConstrainSelectedInstOperands,
     /*  405341 */     // GIR_Coverage, 20650,
     /*  405341 */     GIR_EraseRootFromParent_Done,
     /*  405342 */   // Label 7195: @405342
     /*  405342 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(405419), // Rule ID 20651 //
     /*  405347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  405358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  405361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405379 */     // MIs[0] Operand 4
     /*  405379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405417 */     GIR_RootConstrainSelectedInstOperands,
     /*  405418 */     // GIR_Coverage, 20651,
     /*  405418 */     GIR_EraseRootFromParent_Done,
     /*  405419 */   // Label 7196: @405419
     /*  405419 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(405496), // Rule ID 20654 //
     /*  405424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  405435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  405438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405456 */     // MIs[0] Operand 4
     /*  405456 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405494 */     GIR_RootConstrainSelectedInstOperands,
     /*  405495 */     // GIR_Coverage, 20654,
     /*  405495 */     GIR_EraseRootFromParent_Done,
     /*  405496 */   // Label 7197: @405496
     /*  405496 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(405573), // Rule ID 20655 //
     /*  405501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  405512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  405515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405533 */     // MIs[0] Operand 4
     /*  405533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405551 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405571 */     GIR_RootConstrainSelectedInstOperands,
     /*  405572 */     // GIR_Coverage, 20655,
     /*  405572 */     GIR_EraseRootFromParent_Done,
     /*  405573 */   // Label 7198: @405573
     /*  405573 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(405650), // Rule ID 20658 //
     /*  405578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  405589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  405592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  405595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405610 */     // MIs[0] Operand 4
     /*  405610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405628 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  405631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405648 */     GIR_RootConstrainSelectedInstOperands,
     /*  405649 */     // GIR_Coverage, 20658,
     /*  405649 */     GIR_EraseRootFromParent_Done,
     /*  405650 */   // Label 7199: @405650
     /*  405650 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(405727), // Rule ID 20659 //
     /*  405655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  405666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  405669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  405672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405687 */     // MIs[0] Operand 4
     /*  405687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405705 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  405708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405725 */     GIR_RootConstrainSelectedInstOperands,
     /*  405726 */     // GIR_Coverage, 20659,
     /*  405726 */     GIR_EraseRootFromParent_Done,
     /*  405727 */   // Label 7200: @405727
     /*  405727 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(405804), // Rule ID 20662 //
     /*  405732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  405735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405764 */     // MIs[0] Operand 4
     /*  405764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405802 */     GIR_RootConstrainSelectedInstOperands,
     /*  405803 */     // GIR_Coverage, 20662,
     /*  405803 */     GIR_EraseRootFromParent_Done,
     /*  405804 */   // Label 7201: @405804
     /*  405804 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(405881), // Rule ID 20663 //
     /*  405809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405841 */     // MIs[0] Operand 4
     /*  405841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  405862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405879 */     GIR_RootConstrainSelectedInstOperands,
     /*  405880 */     // GIR_Coverage, 20663,
     /*  405880 */     GIR_EraseRootFromParent_Done,
     /*  405881 */   // Label 7202: @405881
     /*  405881 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(405958), // Rule ID 20666 //
     /*  405886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  405889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405918 */     // MIs[0] Operand 4
     /*  405918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  405939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405956 */     GIR_RootConstrainSelectedInstOperands,
     /*  405957 */     // GIR_Coverage, 20666,
     /*  405957 */     GIR_EraseRootFromParent_Done,
     /*  405958 */   // Label 7203: @405958
     /*  405958 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(406035), // Rule ID 20667 //
     /*  405963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  405966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  405971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405995 */     // MIs[0] Operand 4
     /*  405995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406013 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406033 */     GIR_RootConstrainSelectedInstOperands,
     /*  406034 */     // GIR_Coverage, 20667,
     /*  406034 */     GIR_EraseRootFromParent_Done,
     /*  406035 */   // Label 7204: @406035
     /*  406035 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(406112), // Rule ID 20670 //
     /*  406040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  406043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  406057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406072 */     // MIs[0] Operand 4
     /*  406072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406090 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406110 */     GIR_RootConstrainSelectedInstOperands,
     /*  406111 */     // GIR_Coverage, 20670,
     /*  406111 */     GIR_EraseRootFromParent_Done,
     /*  406112 */   // Label 7205: @406112
     /*  406112 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(406189), // Rule ID 20671 //
     /*  406117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  406120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  406134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406149 */     // MIs[0] Operand 4
     /*  406149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406167 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406187 */     GIR_RootConstrainSelectedInstOperands,
     /*  406188 */     // GIR_Coverage, 20671,
     /*  406188 */     GIR_EraseRootFromParent_Done,
     /*  406189 */   // Label 7206: @406189
     /*  406189 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(406266), // Rule ID 20674 //
     /*  406194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  406211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406226 */     // MIs[0] Operand 4
     /*  406226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  406247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406264 */     GIR_RootConstrainSelectedInstOperands,
     /*  406265 */     // GIR_Coverage, 20674,
     /*  406265 */     GIR_EraseRootFromParent_Done,
     /*  406266 */   // Label 7207: @406266
     /*  406266 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(406343), // Rule ID 20675 //
     /*  406271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  406288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406303 */     // MIs[0] Operand 4
     /*  406303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  406324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406341 */     GIR_RootConstrainSelectedInstOperands,
     /*  406342 */     // GIR_Coverage, 20675,
     /*  406342 */     GIR_EraseRootFromParent_Done,
     /*  406343 */   // Label 7208: @406343
     /*  406343 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(406420), // Rule ID 20678 //
     /*  406348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  406365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406380 */     // MIs[0] Operand 4
     /*  406380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406398 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406418 */     GIR_RootConstrainSelectedInstOperands,
     /*  406419 */     // GIR_Coverage, 20678,
     /*  406419 */     GIR_EraseRootFromParent_Done,
     /*  406420 */   // Label 7209: @406420
     /*  406420 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(406497), // Rule ID 20679 //
     /*  406425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  406442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406457 */     // MIs[0] Operand 4
     /*  406457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406475 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  406478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406495 */     GIR_RootConstrainSelectedInstOperands,
     /*  406496 */     // GIR_Coverage, 20679,
     /*  406496 */     GIR_EraseRootFromParent_Done,
     /*  406497 */   // Label 7210: @406497
     /*  406497 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(406574), // Rule ID 20682 //
     /*  406502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  406505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  406519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406534 */     // MIs[0] Operand 4
     /*  406534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  406552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406572 */     GIR_RootConstrainSelectedInstOperands,
     /*  406573 */     // GIR_Coverage, 20682,
     /*  406573 */     GIR_EraseRootFromParent_Done,
     /*  406574 */   // Label 7211: @406574
     /*  406574 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(406651), // Rule ID 20683 //
     /*  406579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  406582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  406587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  406596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406611 */     // MIs[0] Operand 4
     /*  406611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406629 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  406629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  406632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  406646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406649 */     GIR_RootConstrainSelectedInstOperands,
     /*  406650 */     // GIR_Coverage, 20683,
     /*  406650 */     GIR_EraseRootFromParent_Done,
     /*  406651 */   // Label 7212: @406651
     /*  406651 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(406728), // Rule ID 20686 //
     /*  406656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  406667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  406670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406688 */     // MIs[0] Operand 4
     /*  406688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  406709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406726 */     GIR_RootConstrainSelectedInstOperands,
     /*  406727 */     // GIR_Coverage, 20686,
     /*  406727 */     GIR_EraseRootFromParent_Done,
     /*  406728 */   // Label 7213: @406728
     /*  406728 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(406805), // Rule ID 20687 //
     /*  406733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  406744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  406747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406765 */     // MIs[0] Operand 4
     /*  406765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  406786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406803 */     GIR_RootConstrainSelectedInstOperands,
     /*  406804 */     // GIR_Coverage, 20687,
     /*  406804 */     GIR_EraseRootFromParent_Done,
     /*  406805 */   // Label 7214: @406805
     /*  406805 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(406882), // Rule ID 20690 //
     /*  406810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  406821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  406824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406842 */     // MIs[0] Operand 4
     /*  406842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  406863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406880 */     GIR_RootConstrainSelectedInstOperands,
     /*  406881 */     // GIR_Coverage, 20690,
     /*  406881 */     GIR_EraseRootFromParent_Done,
     /*  406882 */   // Label 7215: @406882
     /*  406882 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(406959), // Rule ID 20691 //
     /*  406887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  406898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  406901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406919 */     // MIs[0] Operand 4
     /*  406919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  406940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406957 */     GIR_RootConstrainSelectedInstOperands,
     /*  406958 */     // GIR_Coverage, 20691,
     /*  406958 */     GIR_EraseRootFromParent_Done,
     /*  406959 */   // Label 7216: @406959
     /*  406959 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(407036), // Rule ID 20694 //
     /*  406964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  406967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  406972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406996 */     // MIs[0] Operand 4
     /*  406996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  407017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407034 */     GIR_RootConstrainSelectedInstOperands,
     /*  407035 */     // GIR_Coverage, 20694,
     /*  407035 */     GIR_EraseRootFromParent_Done,
     /*  407036 */   // Label 7217: @407036
     /*  407036 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(407113), // Rule ID 20695 //
     /*  407041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  407044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  407052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  407055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407073 */     // MIs[0] Operand 4
     /*  407073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  407094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407111 */     GIR_RootConstrainSelectedInstOperands,
     /*  407112 */     // GIR_Coverage, 20695,
     /*  407112 */     GIR_EraseRootFromParent_Done,
     /*  407113 */   // Label 7218: @407113
     /*  407113 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(407190), // Rule ID 20698 //
     /*  407118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  407129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  407132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407150 */     // MIs[0] Operand 4
     /*  407150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407188 */     GIR_RootConstrainSelectedInstOperands,
     /*  407189 */     // GIR_Coverage, 20698,
     /*  407189 */     GIR_EraseRootFromParent_Done,
     /*  407190 */   // Label 7219: @407190
     /*  407190 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(407267), // Rule ID 20699 //
     /*  407195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  407206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  407209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407227 */     // MIs[0] Operand 4
     /*  407227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407245 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407265 */     GIR_RootConstrainSelectedInstOperands,
     /*  407266 */     // GIR_Coverage, 20699,
     /*  407266 */     GIR_EraseRootFromParent_Done,
     /*  407267 */   // Label 7220: @407267
     /*  407267 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(407344), // Rule ID 20702 //
     /*  407272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  407275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407304 */     // MIs[0] Operand 4
     /*  407304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407342 */     GIR_RootConstrainSelectedInstOperands,
     /*  407343 */     // GIR_Coverage, 20702,
     /*  407343 */     GIR_EraseRootFromParent_Done,
     /*  407344 */   // Label 7221: @407344
     /*  407344 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(407421), // Rule ID 20703 //
     /*  407349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  407352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  407360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  407363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407381 */     // MIs[0] Operand 4
     /*  407381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407419 */     GIR_RootConstrainSelectedInstOperands,
     /*  407420 */     // GIR_Coverage, 20703,
     /*  407420 */     GIR_EraseRootFromParent_Done,
     /*  407421 */   // Label 7222: @407421
     /*  407421 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(407498), // Rule ID 20706 //
     /*  407426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  407429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  407443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407458 */     // MIs[0] Operand 4
     /*  407458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  407476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  407493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407496 */     GIR_RootConstrainSelectedInstOperands,
     /*  407497 */     // GIR_Coverage, 20706,
     /*  407497 */     GIR_EraseRootFromParent_Done,
     /*  407498 */   // Label 7223: @407498
     /*  407498 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(407575), // Rule ID 20707 //
     /*  407503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  407506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  407520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407535 */     // MIs[0] Operand 4
     /*  407535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407553 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  407553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  407556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  407570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407573 */     GIR_RootConstrainSelectedInstOperands,
     /*  407574 */     // GIR_Coverage, 20707,
     /*  407574 */     GIR_EraseRootFromParent_Done,
     /*  407575 */   // Label 7224: @407575
     /*  407575 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(407652), // Rule ID 20710 //
     /*  407580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  407591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  407594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407612 */     // MIs[0] Operand 4
     /*  407612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  407633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407650 */     GIR_RootConstrainSelectedInstOperands,
     /*  407651 */     // GIR_Coverage, 20710,
     /*  407651 */     GIR_EraseRootFromParent_Done,
     /*  407652 */   // Label 7225: @407652
     /*  407652 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(407729), // Rule ID 20711 //
     /*  407657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  407668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  407671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407689 */     // MIs[0] Operand 4
     /*  407689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  407710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407727 */     GIR_RootConstrainSelectedInstOperands,
     /*  407728 */     // GIR_Coverage, 20711,
     /*  407728 */     GIR_EraseRootFromParent_Done,
     /*  407729 */   // Label 7226: @407729
     /*  407729 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(407806), // Rule ID 20714 //
     /*  407734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  407745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  407748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407766 */     // MIs[0] Operand 4
     /*  407766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  407787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407804 */     GIR_RootConstrainSelectedInstOperands,
     /*  407805 */     // GIR_Coverage, 20714,
     /*  407805 */     GIR_EraseRootFromParent_Done,
     /*  407806 */   // Label 7227: @407806
     /*  407806 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(407883), // Rule ID 20715 //
     /*  407811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  407822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  407825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407843 */     // MIs[0] Operand 4
     /*  407843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407861 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  407864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407881 */     GIR_RootConstrainSelectedInstOperands,
     /*  407882 */     // GIR_Coverage, 20715,
     /*  407882 */     GIR_EraseRootFromParent_Done,
     /*  407883 */   // Label 7228: @407883
     /*  407883 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(407960), // Rule ID 20718 //
     /*  407888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  407899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  407902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  407905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407920 */     // MIs[0] Operand 4
     /*  407920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407938 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  407941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407958 */     GIR_RootConstrainSelectedInstOperands,
     /*  407959 */     // GIR_Coverage, 20718,
     /*  407959 */     GIR_EraseRootFromParent_Done,
     /*  407960 */   // Label 7229: @407960
     /*  407960 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(408037), // Rule ID 20719 //
     /*  407965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  407973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  407976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  407979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  407982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407997 */     // MIs[0] Operand 4
     /*  407997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408035 */     GIR_RootConstrainSelectedInstOperands,
     /*  408036 */     // GIR_Coverage, 20719,
     /*  408036 */     GIR_EraseRootFromParent_Done,
     /*  408037 */   // Label 7230: @408037
     /*  408037 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(408114), // Rule ID 20722 //
     /*  408042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408074 */     // MIs[0] Operand 4
     /*  408074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408112 */     GIR_RootConstrainSelectedInstOperands,
     /*  408113 */     // GIR_Coverage, 20722,
     /*  408113 */     GIR_EraseRootFromParent_Done,
     /*  408114 */   // Label 7231: @408114
     /*  408114 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(408191), // Rule ID 20723 //
     /*  408119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  408130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  408133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408151 */     // MIs[0] Operand 4
     /*  408151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408189 */     GIR_RootConstrainSelectedInstOperands,
     /*  408190 */     // GIR_Coverage, 20723,
     /*  408190 */     GIR_EraseRootFromParent_Done,
     /*  408191 */   // Label 7232: @408191
     /*  408191 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(408268), // Rule ID 20726 //
     /*  408196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  408207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  408210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408228 */     // MIs[0] Operand 4
     /*  408228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408266 */     GIR_RootConstrainSelectedInstOperands,
     /*  408267 */     // GIR_Coverage, 20726,
     /*  408267 */     GIR_EraseRootFromParent_Done,
     /*  408268 */   // Label 7233: @408268
     /*  408268 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(408345), // Rule ID 20727 //
     /*  408273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  408284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  408287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408305 */     // MIs[0] Operand 4
     /*  408305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408323 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408343 */     GIR_RootConstrainSelectedInstOperands,
     /*  408344 */     // GIR_Coverage, 20727,
     /*  408344 */     GIR_EraseRootFromParent_Done,
     /*  408345 */   // Label 7234: @408345
     /*  408345 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(408422), // Rule ID 20730 //
     /*  408350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408382 */     // MIs[0] Operand 4
     /*  408382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  408400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408420 */     GIR_RootConstrainSelectedInstOperands,
     /*  408421 */     // GIR_Coverage, 20730,
     /*  408421 */     GIR_EraseRootFromParent_Done,
     /*  408422 */   // Label 7235: @408422
     /*  408422 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(408499), // Rule ID 20731 //
     /*  408427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  408438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  408441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408459 */     // MIs[0] Operand 4
     /*  408459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  408477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  408494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408497 */     GIR_RootConstrainSelectedInstOperands,
     /*  408498 */     // GIR_Coverage, 20731,
     /*  408498 */     GIR_EraseRootFromParent_Done,
     /*  408499 */   // Label 7236: @408499
     /*  408499 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(408576), // Rule ID 20734 //
     /*  408504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  408515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  408518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  408521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408536 */     // MIs[0] Operand 4
     /*  408536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408574 */     GIR_RootConstrainSelectedInstOperands,
     /*  408575 */     // GIR_Coverage, 20734,
     /*  408575 */     GIR_EraseRootFromParent_Done,
     /*  408576 */   // Label 7237: @408576
     /*  408576 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(408653), // Rule ID 20735 //
     /*  408581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  408592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  408595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  408598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408613 */     // MIs[0] Operand 4
     /*  408613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  408634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408651 */     GIR_RootConstrainSelectedInstOperands,
     /*  408652 */     // GIR_Coverage, 20735,
     /*  408652 */     GIR_EraseRootFromParent_Done,
     /*  408653 */   // Label 7238: @408653
     /*  408653 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(408730), // Rule ID 20738 //
     /*  408658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  408675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408690 */     // MIs[0] Operand 4
     /*  408690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408728 */     GIR_RootConstrainSelectedInstOperands,
     /*  408729 */     // GIR_Coverage, 20738,
     /*  408729 */     GIR_EraseRootFromParent_Done,
     /*  408730 */   // Label 7239: @408730
     /*  408730 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(408807), // Rule ID 20739 //
     /*  408735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  408746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  408749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  408752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408767 */     // MIs[0] Operand 4
     /*  408767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  408788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408805 */     GIR_RootConstrainSelectedInstOperands,
     /*  408806 */     // GIR_Coverage, 20739,
     /*  408806 */     GIR_EraseRootFromParent_Done,
     /*  408807 */   // Label 7240: @408807
     /*  408807 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(408884), // Rule ID 20742 //
     /*  408812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  408815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  408829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408844 */     // MIs[0] Operand 4
     /*  408844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  408862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408882 */     GIR_RootConstrainSelectedInstOperands,
     /*  408883 */     // GIR_Coverage, 20742,
     /*  408883 */     GIR_EraseRootFromParent_Done,
     /*  408884 */   // Label 7241: @408884
     /*  408884 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(408961), // Rule ID 20743 //
     /*  408889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  408892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  408897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  408900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  408903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  408906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408921 */     // MIs[0] Operand 4
     /*  408921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  408939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  408942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  408956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408959 */     GIR_RootConstrainSelectedInstOperands,
     /*  408960 */     // GIR_Coverage, 20743,
     /*  408960 */     GIR_EraseRootFromParent_Done,
     /*  408961 */   // Label 7242: @408961
     /*  408961 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(409038), // Rule ID 21102 //
     /*  408966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  408974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  408977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  408980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  408983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408998 */     // MIs[0] Operand 4
     /*  408998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  409019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409036 */     GIR_RootConstrainSelectedInstOperands,
     /*  409037 */     // GIR_Coverage, 21102,
     /*  409037 */     GIR_EraseRootFromParent_Done,
     /*  409038 */   // Label 7243: @409038
     /*  409038 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(409115), // Rule ID 21103 //
     /*  409043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  409060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409075 */     // MIs[0] Operand 4
     /*  409075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  409096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409113 */     GIR_RootConstrainSelectedInstOperands,
     /*  409114 */     // GIR_Coverage, 21103,
     /*  409114 */     GIR_EraseRootFromParent_Done,
     /*  409115 */   // Label 7244: @409115
     /*  409115 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(409192), // Rule ID 21106 //
     /*  409120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409152 */     // MIs[0] Operand 4
     /*  409152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409190 */     GIR_RootConstrainSelectedInstOperands,
     /*  409191 */     // GIR_Coverage, 21106,
     /*  409191 */     GIR_EraseRootFromParent_Done,
     /*  409192 */   // Label 7245: @409192
     /*  409192 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(409269), // Rule ID 21107 //
     /*  409197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409229 */     // MIs[0] Operand 4
     /*  409229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409267 */     GIR_RootConstrainSelectedInstOperands,
     /*  409268 */     // GIR_Coverage, 21107,
     /*  409268 */     GIR_EraseRootFromParent_Done,
     /*  409269 */   // Label 7246: @409269
     /*  409269 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(409346), // Rule ID 21110 //
     /*  409274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  409291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409306 */     // MIs[0] Operand 4
     /*  409306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409344 */     GIR_RootConstrainSelectedInstOperands,
     /*  409345 */     // GIR_Coverage, 21110,
     /*  409345 */     GIR_EraseRootFromParent_Done,
     /*  409346 */   // Label 7247: @409346
     /*  409346 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(409423), // Rule ID 21111 //
     /*  409351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  409368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409383 */     // MIs[0] Operand 4
     /*  409383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409421 */     GIR_RootConstrainSelectedInstOperands,
     /*  409422 */     // GIR_Coverage, 21111,
     /*  409422 */     GIR_EraseRootFromParent_Done,
     /*  409423 */   // Label 7248: @409423
     /*  409423 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(409500), // Rule ID 21114 //
     /*  409428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  409445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409460 */     // MIs[0] Operand 4
     /*  409460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  409481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409498 */     GIR_RootConstrainSelectedInstOperands,
     /*  409499 */     // GIR_Coverage, 21114,
     /*  409499 */     GIR_EraseRootFromParent_Done,
     /*  409500 */   // Label 7249: @409500
     /*  409500 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(409577), // Rule ID 21115 //
     /*  409505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  409522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409537 */     // MIs[0] Operand 4
     /*  409537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  409558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409575 */     GIR_RootConstrainSelectedInstOperands,
     /*  409576 */     // GIR_Coverage, 21115,
     /*  409576 */     GIR_EraseRootFromParent_Done,
     /*  409577 */   // Label 7250: @409577
     /*  409577 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(409654), // Rule ID 21118 //
     /*  409582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409614 */     // MIs[0] Operand 4
     /*  409614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  409635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409652 */     GIR_RootConstrainSelectedInstOperands,
     /*  409653 */     // GIR_Coverage, 21118,
     /*  409653 */     GIR_EraseRootFromParent_Done,
     /*  409654 */   // Label 7251: @409654
     /*  409654 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(409731), // Rule ID 21119 //
     /*  409659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  409670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  409673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  409676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409691 */     // MIs[0] Operand 4
     /*  409691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  409712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409729 */     GIR_RootConstrainSelectedInstOperands,
     /*  409730 */     // GIR_Coverage, 21119,
     /*  409730 */     GIR_EraseRootFromParent_Done,
     /*  409731 */   // Label 7252: @409731
     /*  409731 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(409808), // Rule ID 21122 //
     /*  409736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  409739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  409747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  409750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409768 */     // MIs[0] Operand 4
     /*  409768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409806 */     GIR_RootConstrainSelectedInstOperands,
     /*  409807 */     // GIR_Coverage, 21122,
     /*  409807 */     GIR_EraseRootFromParent_Done,
     /*  409808 */   // Label 7253: @409808
     /*  409808 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(409885), // Rule ID 21123 //
     /*  409813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  409816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  409824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  409827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  409830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409845 */     // MIs[0] Operand 4
     /*  409845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  409866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409883 */     GIR_RootConstrainSelectedInstOperands,
     /*  409884 */     // GIR_Coverage, 21123,
     /*  409884 */     GIR_EraseRootFromParent_Done,
     /*  409885 */   // Label 7254: @409885
     /*  409885 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(409962), // Rule ID 21126 //
     /*  409890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  409893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  409901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  409904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409922 */     // MIs[0] Operand 4
     /*  409922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  409943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409960 */     GIR_RootConstrainSelectedInstOperands,
     /*  409961 */     // GIR_Coverage, 21126,
     /*  409961 */     GIR_EraseRootFromParent_Done,
     /*  409962 */   // Label 7255: @409962
     /*  409962 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(410039), // Rule ID 21127 //
     /*  409967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  409970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  409975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  409978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  409981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409999 */     // MIs[0] Operand 4
     /*  409999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  410020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410037 */     GIR_RootConstrainSelectedInstOperands,
     /*  410038 */     // GIR_Coverage, 21127,
     /*  410038 */     GIR_EraseRootFromParent_Done,
     /*  410039 */   // Label 7256: @410039
     /*  410039 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(410116), // Rule ID 21130 //
     /*  410044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  410047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  410055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  410058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410076 */     // MIs[0] Operand 4
     /*  410076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  410097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410114 */     GIR_RootConstrainSelectedInstOperands,
     /*  410115 */     // GIR_Coverage, 21130,
     /*  410115 */     GIR_EraseRootFromParent_Done,
     /*  410116 */   // Label 7257: @410116
     /*  410116 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(410193), // Rule ID 21131 //
     /*  410121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  410124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  410132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  410135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410153 */     // MIs[0] Operand 4
     /*  410153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  410174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410191 */     GIR_RootConstrainSelectedInstOperands,
     /*  410192 */     // GIR_Coverage, 21131,
     /*  410192 */     GIR_EraseRootFromParent_Done,
     /*  410193 */   // Label 7258: @410193
     /*  410193 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(410270), // Rule ID 21134 //
     /*  410198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  410201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  410209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  410212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410230 */     // MIs[0] Operand 4
     /*  410230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  410251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410268 */     GIR_RootConstrainSelectedInstOperands,
     /*  410269 */     // GIR_Coverage, 21134,
     /*  410269 */     GIR_EraseRootFromParent_Done,
     /*  410270 */   // Label 7259: @410270
     /*  410270 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(410347), // Rule ID 21135 //
     /*  410275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  410278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  410283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  410286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  410289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  410292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410307 */     // MIs[0] Operand 4
     /*  410307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410325 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  410328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410345 */     GIR_RootConstrainSelectedInstOperands,
     /*  410346 */     // GIR_Coverage, 21135,
     /*  410346 */     GIR_EraseRootFromParent_Done,
     /*  410347 */   // Label 7260: @410347
     /*  410347 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(410424), // Rule ID 21138 //
     /*  410352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410384 */     // MIs[0] Operand 4
     /*  410384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  410405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410422 */     GIR_RootConstrainSelectedInstOperands,
     /*  410423 */     // GIR_Coverage, 21138,
     /*  410423 */     GIR_EraseRootFromParent_Done,
     /*  410424 */   // Label 7261: @410424
     /*  410424 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(410501), // Rule ID 21139 //
     /*  410429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  410440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  410443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410461 */     // MIs[0] Operand 4
     /*  410461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410479 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  410482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410499 */     GIR_RootConstrainSelectedInstOperands,
     /*  410500 */     // GIR_Coverage, 21139,
     /*  410500 */     GIR_EraseRootFromParent_Done,
     /*  410501 */   // Label 7262: @410501
     /*  410501 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(410578), // Rule ID 21142 //
     /*  410506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410538 */     // MIs[0] Operand 4
     /*  410538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410556 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  410559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410576 */     GIR_RootConstrainSelectedInstOperands,
     /*  410577 */     // GIR_Coverage, 21142,
     /*  410577 */     GIR_EraseRootFromParent_Done,
     /*  410578 */   // Label 7263: @410578
     /*  410578 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(410655), // Rule ID 21143 //
     /*  410583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  410594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  410597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410615 */     // MIs[0] Operand 4
     /*  410615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  410636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410653 */     GIR_RootConstrainSelectedInstOperands,
     /*  410654 */     // GIR_Coverage, 21143,
     /*  410654 */     GIR_EraseRootFromParent_Done,
     /*  410655 */   // Label 7264: @410655
     /*  410655 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(410732), // Rule ID 21146 //
     /*  410660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410692 */     // MIs[0] Operand 4
     /*  410692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  410713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410730 */     GIR_RootConstrainSelectedInstOperands,
     /*  410731 */     // GIR_Coverage, 21146,
     /*  410731 */     GIR_EraseRootFromParent_Done,
     /*  410732 */   // Label 7265: @410732
     /*  410732 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(410809), // Rule ID 21147 //
     /*  410737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  410748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  410751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410769 */     // MIs[0] Operand 4
     /*  410769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  410790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410807 */     GIR_RootConstrainSelectedInstOperands,
     /*  410808 */     // GIR_Coverage, 21147,
     /*  410808 */     GIR_EraseRootFromParent_Done,
     /*  410809 */   // Label 7266: @410809
     /*  410809 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(410886), // Rule ID 21150 //
     /*  410814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410846 */     // MIs[0] Operand 4
     /*  410846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  410867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410884 */     GIR_RootConstrainSelectedInstOperands,
     /*  410885 */     // GIR_Coverage, 21150,
     /*  410885 */     GIR_EraseRootFromParent_Done,
     /*  410886 */   // Label 7267: @410886
     /*  410886 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(410963), // Rule ID 21151 //
     /*  410891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410923 */     // MIs[0] Operand 4
     /*  410923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  410944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410961 */     GIR_RootConstrainSelectedInstOperands,
     /*  410962 */     // GIR_Coverage, 21151,
     /*  410962 */     GIR_EraseRootFromParent_Done,
     /*  410963 */   // Label 7268: @410963
     /*  410963 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(411040), // Rule ID 21154 //
     /*  410968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  410976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  410979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  410982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411000 */     // MIs[0] Operand 4
     /*  411000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411038 */     GIR_RootConstrainSelectedInstOperands,
     /*  411039 */     // GIR_Coverage, 21154,
     /*  411039 */     GIR_EraseRootFromParent_Done,
     /*  411040 */   // Label 7269: @411040
     /*  411040 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(411117), // Rule ID 21155 //
     /*  411045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  411056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  411059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  411062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411077 */     // MIs[0] Operand 4
     /*  411077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411095 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411115 */     GIR_RootConstrainSelectedInstOperands,
     /*  411116 */     // GIR_Coverage, 21155,
     /*  411116 */     GIR_EraseRootFromParent_Done,
     /*  411117 */   // Label 7270: @411117
     /*  411117 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(411194), // Rule ID 21158 //
     /*  411122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  411133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  411136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411154 */     // MIs[0] Operand 4
     /*  411154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411172 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  411175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411192 */     GIR_RootConstrainSelectedInstOperands,
     /*  411193 */     // GIR_Coverage, 21158,
     /*  411193 */     GIR_EraseRootFromParent_Done,
     /*  411194 */   // Label 7271: @411194
     /*  411194 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(411271), // Rule ID 21159 //
     /*  411199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  411210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  411213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411231 */     // MIs[0] Operand 4
     /*  411231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  411252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411269 */     GIR_RootConstrainSelectedInstOperands,
     /*  411270 */     // GIR_Coverage, 21159,
     /*  411270 */     GIR_EraseRootFromParent_Done,
     /*  411271 */   // Label 7272: @411271
     /*  411271 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(411348), // Rule ID 21162 //
     /*  411276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  411287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  411290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411308 */     // MIs[0] Operand 4
     /*  411308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  411329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411346 */     GIR_RootConstrainSelectedInstOperands,
     /*  411347 */     // GIR_Coverage, 21162,
     /*  411347 */     GIR_EraseRootFromParent_Done,
     /*  411348 */   // Label 7273: @411348
     /*  411348 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(411425), // Rule ID 21163 //
     /*  411353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  411364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  411367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411385 */     // MIs[0] Operand 4
     /*  411385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  411406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411423 */     GIR_RootConstrainSelectedInstOperands,
     /*  411424 */     // GIR_Coverage, 21163,
     /*  411424 */     GIR_EraseRootFromParent_Done,
     /*  411425 */   // Label 7274: @411425
     /*  411425 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(411502), // Rule ID 21166 //
     /*  411430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  411441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  411444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411462 */     // MIs[0] Operand 4
     /*  411462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  411483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411500 */     GIR_RootConstrainSelectedInstOperands,
     /*  411501 */     // GIR_Coverage, 21166,
     /*  411501 */     GIR_EraseRootFromParent_Done,
     /*  411502 */   // Label 7275: @411502
     /*  411502 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(411579), // Rule ID 21167 //
     /*  411507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  411518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  411521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411539 */     // MIs[0] Operand 4
     /*  411539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  411560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411577 */     GIR_RootConstrainSelectedInstOperands,
     /*  411578 */     // GIR_Coverage, 21167,
     /*  411578 */     GIR_EraseRootFromParent_Done,
     /*  411579 */   // Label 7276: @411579
     /*  411579 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(411656), // Rule ID 21170 //
     /*  411584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  411587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  411595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  411598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411616 */     // MIs[0] Operand 4
     /*  411616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411654 */     GIR_RootConstrainSelectedInstOperands,
     /*  411655 */     // GIR_Coverage, 21170,
     /*  411655 */     GIR_EraseRootFromParent_Done,
     /*  411656 */   // Label 7277: @411656
     /*  411656 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(411733), // Rule ID 21171 //
     /*  411661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  411664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  411669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  411672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  411675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411693 */     // MIs[0] Operand 4
     /*  411693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  411714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411731 */     GIR_RootConstrainSelectedInstOperands,
     /*  411732 */     // GIR_Coverage, 21171,
     /*  411732 */     GIR_EraseRootFromParent_Done,
     /*  411733 */   // Label 7278: @411733
     /*  411733 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(411810), // Rule ID 21474 //
     /*  411738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  411749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  411752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  411755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411770 */     // MIs[0] Operand 4
     /*  411770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  411791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411808 */     GIR_RootConstrainSelectedInstOperands,
     /*  411809 */     // GIR_Coverage, 21474,
     /*  411809 */     GIR_EraseRootFromParent_Done,
     /*  411810 */   // Label 7279: @411810
     /*  411810 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(411887), // Rule ID 21475 //
     /*  411815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  411826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  411829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  411832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411847 */     // MIs[0] Operand 4
     /*  411847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411865 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  411868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411885 */     GIR_RootConstrainSelectedInstOperands,
     /*  411886 */     // GIR_Coverage, 21475,
     /*  411886 */     GIR_EraseRootFromParent_Done,
     /*  411887 */   // Label 7280: @411887
     /*  411887 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(411964), // Rule ID 21478 //
     /*  411892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  411895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  411903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  411906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  411909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411924 */     // MIs[0] Operand 4
     /*  411924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  411945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411962 */     GIR_RootConstrainSelectedInstOperands,
     /*  411963 */     // GIR_Coverage, 21478,
     /*  411963 */     GIR_EraseRootFromParent_Done,
     /*  411964 */   // Label 7281: @411964
     /*  411964 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(412041), // Rule ID 21479 //
     /*  411969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  411977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  411980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  411983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  411986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412001 */     // MIs[0] Operand 4
     /*  412001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412019 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412039 */     GIR_RootConstrainSelectedInstOperands,
     /*  412040 */     // GIR_Coverage, 21479,
     /*  412040 */     GIR_EraseRootFromParent_Done,
     /*  412041 */   // Label 7282: @412041
     /*  412041 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(412118), // Rule ID 21482 //
     /*  412046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  412060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  412063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412078 */     // MIs[0] Operand 4
     /*  412078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412116 */     GIR_RootConstrainSelectedInstOperands,
     /*  412117 */     // GIR_Coverage, 21482,
     /*  412117 */     GIR_EraseRootFromParent_Done,
     /*  412118 */   // Label 7283: @412118
     /*  412118 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(412195), // Rule ID 21483 //
     /*  412123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  412137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  412140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412155 */     // MIs[0] Operand 4
     /*  412155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412173 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412193 */     GIR_RootConstrainSelectedInstOperands,
     /*  412194 */     // GIR_Coverage, 21483,
     /*  412194 */     GIR_EraseRootFromParent_Done,
     /*  412195 */   // Label 7284: @412195
     /*  412195 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(412272), // Rule ID 21486 //
     /*  412200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  412211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  412214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  412217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412232 */     // MIs[0] Operand 4
     /*  412232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  412253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412270 */     GIR_RootConstrainSelectedInstOperands,
     /*  412271 */     // GIR_Coverage, 21486,
     /*  412271 */     GIR_EraseRootFromParent_Done,
     /*  412272 */   // Label 7285: @412272
     /*  412272 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(412349), // Rule ID 21487 //
     /*  412277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  412288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  412291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  412294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412309 */     // MIs[0] Operand 4
     /*  412309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  412330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412347 */     GIR_RootConstrainSelectedInstOperands,
     /*  412348 */     // GIR_Coverage, 21487,
     /*  412348 */     GIR_EraseRootFromParent_Done,
     /*  412349 */   // Label 7286: @412349
     /*  412349 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(412426), // Rule ID 21490 //
     /*  412354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  412365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  412368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  412371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412386 */     // MIs[0] Operand 4
     /*  412386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  412407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412424 */     GIR_RootConstrainSelectedInstOperands,
     /*  412425 */     // GIR_Coverage, 21490,
     /*  412425 */     GIR_EraseRootFromParent_Done,
     /*  412426 */   // Label 7287: @412426
     /*  412426 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(412503), // Rule ID 21491 //
     /*  412431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  412442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  412445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  412448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412463 */     // MIs[0] Operand 4
     /*  412463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  412484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412501 */     GIR_RootConstrainSelectedInstOperands,
     /*  412502 */     // GIR_Coverage, 21491,
     /*  412502 */     GIR_EraseRootFromParent_Done,
     /*  412503 */   // Label 7288: @412503
     /*  412503 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(412580), // Rule ID 21494 //
     /*  412508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  412511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  412519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  412522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  412525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412540 */     // MIs[0] Operand 4
     /*  412540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  412558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  412561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412578 */     GIR_RootConstrainSelectedInstOperands,
     /*  412579 */     // GIR_Coverage, 21494,
     /*  412579 */     GIR_EraseRootFromParent_Done,
     /*  412580 */   // Label 7289: @412580
     /*  412580 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(412657), // Rule ID 21495 //
     /*  412585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  412588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  412596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  412599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  412602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412617 */     // MIs[0] Operand 4
     /*  412617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412635 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  412635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  412638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412655 */     GIR_RootConstrainSelectedInstOperands,
     /*  412656 */     // GIR_Coverage, 21495,
     /*  412656 */     GIR_EraseRootFromParent_Done,
     /*  412657 */   // Label 7290: @412657
     /*  412657 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(412734), // Rule ID 21498 //
     /*  412662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  412676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412694 */     // MIs[0] Operand 4
     /*  412694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412732 */     GIR_RootConstrainSelectedInstOperands,
     /*  412733 */     // GIR_Coverage, 21498,
     /*  412733 */     GIR_EraseRootFromParent_Done,
     /*  412734 */   // Label 7291: @412734
     /*  412734 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(412811), // Rule ID 21499 //
     /*  412739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  412753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  412756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412771 */     // MIs[0] Operand 4
     /*  412771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  412792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412809 */     GIR_RootConstrainSelectedInstOperands,
     /*  412810 */     // GIR_Coverage, 21499,
     /*  412810 */     GIR_EraseRootFromParent_Done,
     /*  412811 */   // Label 7292: @412811
     /*  412811 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(412888), // Rule ID 21502 //
     /*  412816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  412827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  412830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412848 */     // MIs[0] Operand 4
     /*  412848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  412866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412886 */     GIR_RootConstrainSelectedInstOperands,
     /*  412887 */     // GIR_Coverage, 21502,
     /*  412887 */     GIR_EraseRootFromParent_Done,
     /*  412888 */   // Label 7293: @412888
     /*  412888 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(412965), // Rule ID 21503 //
     /*  412893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  412896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  412904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  412907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  412910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412925 */     // MIs[0] Operand 4
     /*  412925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412943 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  412943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  412946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412963 */     GIR_RootConstrainSelectedInstOperands,
     /*  412964 */     // GIR_Coverage, 21503,
     /*  412964 */     GIR_EraseRootFromParent_Done,
     /*  412965 */   // Label 7294: @412965
     /*  412965 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(413042), // Rule ID 21506 //
     /*  412970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  412973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  412978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  412981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  412984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  412987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413002 */     // MIs[0] Operand 4
     /*  413002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413040 */     GIR_RootConstrainSelectedInstOperands,
     /*  413041 */     // GIR_Coverage, 21506,
     /*  413041 */     GIR_EraseRootFromParent_Done,
     /*  413042 */   // Label 7295: @413042
     /*  413042 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(413119), // Rule ID 21507 //
     /*  413047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  413058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  413061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  413064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413079 */     // MIs[0] Operand 4
     /*  413079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413097 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413117 */     GIR_RootConstrainSelectedInstOperands,
     /*  413118 */     // GIR_Coverage, 21507,
     /*  413118 */     GIR_EraseRootFromParent_Done,
     /*  413119 */   // Label 7296: @413119
     /*  413119 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(413196), // Rule ID 21510 //
     /*  413124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  413127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  413135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  413138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413156 */     // MIs[0] Operand 4
     /*  413156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413194 */     GIR_RootConstrainSelectedInstOperands,
     /*  413195 */     // GIR_Coverage, 21510,
     /*  413195 */     GIR_EraseRootFromParent_Done,
     /*  413196 */   // Label 7297: @413196
     /*  413196 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(413273), // Rule ID 21511 //
     /*  413201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  413212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  413215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  413218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413233 */     // MIs[0] Operand 4
     /*  413233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413251 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413271 */     GIR_RootConstrainSelectedInstOperands,
     /*  413272 */     // GIR_Coverage, 21511,
     /*  413272 */     GIR_EraseRootFromParent_Done,
     /*  413273 */   // Label 7298: @413273
     /*  413273 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(413350), // Rule ID 21514 //
     /*  413278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  413281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  413289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  413292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413310 */     // MIs[0] Operand 4
     /*  413310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  413328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413348 */     GIR_RootConstrainSelectedInstOperands,
     /*  413349 */     // GIR_Coverage, 21514,
     /*  413349 */     GIR_EraseRootFromParent_Done,
     /*  413350 */   // Label 7299: @413350
     /*  413350 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(413427), // Rule ID 21515 //
     /*  413355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  413358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  413366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  413369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  413372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413387 */     // MIs[0] Operand 4
     /*  413387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413405 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  413405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413425 */     GIR_RootConstrainSelectedInstOperands,
     /*  413426 */     // GIR_Coverage, 21515,
     /*  413426 */     GIR_EraseRootFromParent_Done,
     /*  413427 */   // Label 7300: @413427
     /*  413427 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(413504), // Rule ID 21518 //
     /*  413432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  413449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413464 */     // MIs[0] Operand 4
     /*  413464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  413485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413502 */     GIR_RootConstrainSelectedInstOperands,
     /*  413503 */     // GIR_Coverage, 21518,
     /*  413503 */     GIR_EraseRootFromParent_Done,
     /*  413504 */   // Label 7301: @413504
     /*  413504 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(413581), // Rule ID 21519 //
     /*  413509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  413523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  413526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413541 */     // MIs[0] Operand 4
     /*  413541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413559 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  413562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413579 */     GIR_RootConstrainSelectedInstOperands,
     /*  413580 */     // GIR_Coverage, 21519,
     /*  413580 */     GIR_EraseRootFromParent_Done,
     /*  413581 */   // Label 7302: @413581
     /*  413581 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(413658), // Rule ID 21522 //
     /*  413586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  413603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413618 */     // MIs[0] Operand 4
     /*  413618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413656 */     GIR_RootConstrainSelectedInstOperands,
     /*  413657 */     // GIR_Coverage, 21522,
     /*  413657 */     GIR_EraseRootFromParent_Done,
     /*  413658 */   // Label 7303: @413658
     /*  413658 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(413735), // Rule ID 21523 //
     /*  413663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  413674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  413677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  413680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413695 */     // MIs[0] Operand 4
     /*  413695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413713 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  413716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413733 */     GIR_RootConstrainSelectedInstOperands,
     /*  413734 */     // GIR_Coverage, 21523,
     /*  413734 */     GIR_EraseRootFromParent_Done,
     /*  413735 */   // Label 7304: @413735
     /*  413735 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(413812), // Rule ID 21526 //
     /*  413740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  413757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413772 */     // MIs[0] Operand 4
     /*  413772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413810 */     GIR_RootConstrainSelectedInstOperands,
     /*  413811 */     // GIR_Coverage, 21526,
     /*  413811 */     GIR_EraseRootFromParent_Done,
     /*  413812 */   // Label 7305: @413812
     /*  413812 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(413889), // Rule ID 21527 //
     /*  413817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  413828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  413831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  413834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  413845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413849 */     // MIs[0] Operand 4
     /*  413849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  413867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  413870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413887 */     GIR_RootConstrainSelectedInstOperands,
     /*  413888 */     // GIR_Coverage, 21527,
     /*  413888 */     GIR_EraseRootFromParent_Done,
     /*  413889 */   // Label 7306: @413889
     /*  413889 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(413966), // Rule ID 21530 //
     /*  413894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  413897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  413911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  413926 */     // MIs[0] Operand 4
     /*  413926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  413937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  413944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  413947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  413951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  413953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  413964 */     GIR_RootConstrainSelectedInstOperands,
     /*  413965 */     // GIR_Coverage, 21530,
     /*  413965 */     GIR_EraseRootFromParent_Done,
     /*  413966 */   // Label 7307: @413966
     /*  413966 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(414043), // Rule ID 21531 //
     /*  413971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  413974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  413979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  413982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  413985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  413988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  413999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414003 */     // MIs[0] Operand 4
     /*  414003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  414021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  414024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414041 */     GIR_RootConstrainSelectedInstOperands,
     /*  414042 */     // GIR_Coverage, 21531,
     /*  414042 */     GIR_EraseRootFromParent_Done,
     /*  414043 */   // Label 7308: @414043
     /*  414043 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(414120), // Rule ID 21534 //
     /*  414048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  414059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  414062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414080 */     // MIs[0] Operand 4
     /*  414080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  414101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414118 */     GIR_RootConstrainSelectedInstOperands,
     /*  414119 */     // GIR_Coverage, 21534,
     /*  414119 */     GIR_EraseRootFromParent_Done,
     /*  414120 */   // Label 7309: @414120
     /*  414120 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(414197), // Rule ID 21535 //
     /*  414125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  414136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  414139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  414142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414157 */     // MIs[0] Operand 4
     /*  414157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414175 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  414178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414195 */     GIR_RootConstrainSelectedInstOperands,
     /*  414196 */     // GIR_Coverage, 21535,
     /*  414196 */     GIR_EraseRootFromParent_Done,
     /*  414197 */   // Label 7310: @414197
     /*  414197 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(414274), // Rule ID 21538 //
     /*  414202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  414213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  414216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414234 */     // MIs[0] Operand 4
     /*  414234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  414255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414272 */     GIR_RootConstrainSelectedInstOperands,
     /*  414273 */     // GIR_Coverage, 21538,
     /*  414273 */     GIR_EraseRootFromParent_Done,
     /*  414274 */   // Label 7311: @414274
     /*  414274 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(414351), // Rule ID 21539 //
     /*  414279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  414290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  414293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414311 */     // MIs[0] Operand 4
     /*  414311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414329 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  414332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414349 */     GIR_RootConstrainSelectedInstOperands,
     /*  414350 */     // GIR_Coverage, 21539,
     /*  414350 */     GIR_EraseRootFromParent_Done,
     /*  414351 */   // Label 7312: @414351
     /*  414351 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(414428), // Rule ID 21542 //
     /*  414356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  414367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  414370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414388 */     // MIs[0] Operand 4
     /*  414388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414406 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  414409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414426 */     GIR_RootConstrainSelectedInstOperands,
     /*  414427 */     // GIR_Coverage, 21542,
     /*  414427 */     GIR_EraseRootFromParent_Done,
     /*  414428 */   // Label 7313: @414428
     /*  414428 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(414505), // Rule ID 21543 //
     /*  414433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  414444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  414447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414465 */     // MIs[0] Operand 4
     /*  414465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414483 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  414486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414503 */     GIR_RootConstrainSelectedInstOperands,
     /*  414504 */     // GIR_Coverage, 21543,
     /*  414504 */     GIR_EraseRootFromParent_Done,
     /*  414505 */   // Label 7314: @414505
     /*  414505 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(414582), // Rule ID 21546 //
     /*  414510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  414524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  414527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414542 */     // MIs[0] Operand 4
     /*  414542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  414563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414580 */     GIR_RootConstrainSelectedInstOperands,
     /*  414581 */     // GIR_Coverage, 21546,
     /*  414581 */     GIR_EraseRootFromParent_Done,
     /*  414582 */   // Label 7315: @414582
     /*  414582 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(414659), // Rule ID 21547 //
     /*  414587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  414601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  414604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414619 */     // MIs[0] Operand 4
     /*  414619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414637 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  414640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414657 */     GIR_RootConstrainSelectedInstOperands,
     /*  414658 */     // GIR_Coverage, 21547,
     /*  414658 */     GIR_EraseRootFromParent_Done,
     /*  414659 */   // Label 7316: @414659
     /*  414659 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(414736), // Rule ID 21550 //
     /*  414664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  414675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  414678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  414681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414696 */     // MIs[0] Operand 4
     /*  414696 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414714 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  414717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414734 */     GIR_RootConstrainSelectedInstOperands,
     /*  414735 */     // GIR_Coverage, 21550,
     /*  414735 */     GIR_EraseRootFromParent_Done,
     /*  414736 */   // Label 7317: @414736
     /*  414736 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(414813), // Rule ID 21551 //
     /*  414741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  414752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  414755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  414758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  414769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414773 */     // MIs[0] Operand 4
     /*  414773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  414794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414811 */     GIR_RootConstrainSelectedInstOperands,
     /*  414812 */     // GIR_Coverage, 21551,
     /*  414812 */     GIR_EraseRootFromParent_Done,
     /*  414813 */   // Label 7318: @414813
     /*  414813 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(414890), // Rule ID 21554 //
     /*  414818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  414821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  414829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  414832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  414835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414850 */     // MIs[0] Operand 4
     /*  414850 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  414868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  414871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414888 */     GIR_RootConstrainSelectedInstOperands,
     /*  414889 */     // GIR_Coverage, 21554,
     /*  414889 */     GIR_EraseRootFromParent_Done,
     /*  414890 */   // Label 7319: @414890
     /*  414890 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(414967), // Rule ID 21555 //
     /*  414895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  414898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  414906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  414909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  414912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  414923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  414927 */     // MIs[0] Operand 4
     /*  414927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  414938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414945 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  414945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  414948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  414952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  414954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  414965 */     GIR_RootConstrainSelectedInstOperands,
     /*  414966 */     // GIR_Coverage, 21555,
     /*  414966 */     GIR_EraseRootFromParent_Done,
     /*  414967 */   // Label 7320: @414967
     /*  414967 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(415044), // Rule ID 21558 //
     /*  414972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  414975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  414980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  414983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  414986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415004 */     // MIs[0] Operand 4
     /*  415004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  415025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415042 */     GIR_RootConstrainSelectedInstOperands,
     /*  415043 */     // GIR_Coverage, 21558,
     /*  415043 */     GIR_EraseRootFromParent_Done,
     /*  415044 */   // Label 7321: @415044
     /*  415044 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(415121), // Rule ID 21559 //
     /*  415049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  415060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  415063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  415066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415081 */     // MIs[0] Operand 4
     /*  415081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415099 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  415102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415119 */     GIR_RootConstrainSelectedInstOperands,
     /*  415120 */     // GIR_Coverage, 21559,
     /*  415120 */     GIR_EraseRootFromParent_Done,
     /*  415121 */   // Label 7322: @415121
     /*  415121 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(415198), // Rule ID 21562 //
     /*  415126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  415137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  415140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415158 */     // MIs[0] Operand 4
     /*  415158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415196 */     GIR_RootConstrainSelectedInstOperands,
     /*  415197 */     // GIR_Coverage, 21562,
     /*  415197 */     GIR_EraseRootFromParent_Done,
     /*  415198 */   // Label 7323: @415198
     /*  415198 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(415275), // Rule ID 21563 //
     /*  415203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  415214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  415217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415235 */     // MIs[0] Operand 4
     /*  415235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415253 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415273 */     GIR_RootConstrainSelectedInstOperands,
     /*  415274 */     // GIR_Coverage, 21563,
     /*  415274 */     GIR_EraseRootFromParent_Done,
     /*  415275 */   // Label 7324: @415275
     /*  415275 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(415352), // Rule ID 21566 //
     /*  415280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  415294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415312 */     // MIs[0] Operand 4
     /*  415312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415350 */     GIR_RootConstrainSelectedInstOperands,
     /*  415351 */     // GIR_Coverage, 21566,
     /*  415351 */     GIR_EraseRootFromParent_Done,
     /*  415352 */   // Label 7325: @415352
     /*  415352 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(415429), // Rule ID 21567 //
     /*  415357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  415371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  415374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415389 */     // MIs[0] Operand 4
     /*  415389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415427 */     GIR_RootConstrainSelectedInstOperands,
     /*  415428 */     // GIR_Coverage, 21567,
     /*  415428 */     GIR_EraseRootFromParent_Done,
     /*  415429 */   // Label 7326: @415429
     /*  415429 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(415506), // Rule ID 21570 //
     /*  415434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  415445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  415448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415466 */     // MIs[0] Operand 4
     /*  415466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  415487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415504 */     GIR_RootConstrainSelectedInstOperands,
     /*  415505 */     // GIR_Coverage, 21570,
     /*  415505 */     GIR_EraseRootFromParent_Done,
     /*  415506 */   // Label 7327: @415506
     /*  415506 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(415583), // Rule ID 21571 //
     /*  415511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  415522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  415525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  415528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415543 */     // MIs[0] Operand 4
     /*  415543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  415564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415581 */     GIR_RootConstrainSelectedInstOperands,
     /*  415582 */     // GIR_Coverage, 21571,
     /*  415582 */     GIR_EraseRootFromParent_Done,
     /*  415583 */   // Label 7328: @415583
     /*  415583 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(415660), // Rule ID 21574 //
     /*  415588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  415591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  415599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  415602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  415605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415620 */     // MIs[0] Operand 4
     /*  415620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  415638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  415641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415658 */     GIR_RootConstrainSelectedInstOperands,
     /*  415659 */     // GIR_Coverage, 21574,
     /*  415659 */     GIR_EraseRootFromParent_Done,
     /*  415660 */   // Label 7329: @415660
     /*  415660 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(415737), // Rule ID 21575 //
     /*  415665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  415668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  415676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  415679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  415682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  415693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  415697 */     // MIs[0] Operand 4
     /*  415697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415715 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  415715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  415718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415735 */     GIR_RootConstrainSelectedInstOperands,
     /*  415736 */     // GIR_Coverage, 21575,
     /*  415736 */     GIR_EraseRootFromParent_Done,
     /*  415737 */   // Label 7330: @415737
     /*  415737 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(415814), // Rule ID 21578 //
     /*  415742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  415745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415774 */     // MIs[0] Operand 4
     /*  415774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  415792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415812 */     GIR_RootConstrainSelectedInstOperands,
     /*  415813 */     // GIR_Coverage, 21578,
     /*  415813 */     GIR_EraseRootFromParent_Done,
     /*  415814 */   // Label 7331: @415814
     /*  415814 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(415891), // Rule ID 21579 //
     /*  415819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  415822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  415830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  415833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415851 */     // MIs[0] Operand 4
     /*  415851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  415869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  415872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415889 */     GIR_RootConstrainSelectedInstOperands,
     /*  415890 */     // GIR_Coverage, 21579,
     /*  415890 */     GIR_EraseRootFromParent_Done,
     /*  415891 */   // Label 7332: @415891
     /*  415891 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(415968), // Rule ID 21582 //
     /*  415896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  415899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  415913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415928 */     // MIs[0] Operand 4
     /*  415928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  415939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  415946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  415949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  415953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  415955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  415966 */     GIR_RootConstrainSelectedInstOperands,
     /*  415967 */     // GIR_Coverage, 21582,
     /*  415967 */     GIR_EraseRootFromParent_Done,
     /*  415968 */   // Label 7333: @415968
     /*  415968 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(416045), // Rule ID 21583 //
     /*  415973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  415976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  415981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  415987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  415990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416005 */     // MIs[0] Operand 4
     /*  416005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  416026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416043 */     GIR_RootConstrainSelectedInstOperands,
     /*  416044 */     // GIR_Coverage, 21583,
     /*  416044 */     GIR_EraseRootFromParent_Done,
     /*  416045 */   // Label 7334: @416045
     /*  416045 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(416122), // Rule ID 21586 //
     /*  416050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  416053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  416061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  416064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  416067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416082 */     // MIs[0] Operand 4
     /*  416082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  416100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  416103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416120 */     GIR_RootConstrainSelectedInstOperands,
     /*  416121 */     // GIR_Coverage, 21586,
     /*  416121 */     GIR_EraseRootFromParent_Done,
     /*  416122 */   // Label 7335: @416122
     /*  416122 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(416199), // Rule ID 21587 //
     /*  416127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  416130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  416138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  416141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  416144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416159 */     // MIs[0] Operand 4
     /*  416159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  416180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416197 */     GIR_RootConstrainSelectedInstOperands,
     /*  416198 */     // GIR_Coverage, 21587,
     /*  416198 */     GIR_EraseRootFromParent_Done,
     /*  416199 */   // Label 7336: @416199
     /*  416199 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(416276), // Rule ID 21590 //
     /*  416204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  416207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  416221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416236 */     // MIs[0] Operand 4
     /*  416236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  416254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  416257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416274 */     GIR_RootConstrainSelectedInstOperands,
     /*  416275 */     // GIR_Coverage, 21590,
     /*  416275 */     GIR_EraseRootFromParent_Done,
     /*  416276 */   // Label 7337: @416276
     /*  416276 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(416353), // Rule ID 21591 //
     /*  416281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  416284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  416289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  416292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  416295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  416298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416313 */     // MIs[0] Operand 4
     /*  416313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  416324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416331 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  416331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  416334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  416338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  416340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  416348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  416351 */     GIR_RootConstrainSelectedInstOperands,
     /*  416352 */     // GIR_Coverage, 21591,
     /*  416352 */     GIR_EraseRootFromParent_Done,
     /*  416353 */   // Label 7338: @416353
     /*  416353 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(416426), // Rule ID 62819 //
     /*  416358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416382 */     // MIs[0] op1
     /*  416382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416405 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  416408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416410 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416412 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416414 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416424 */     GIR_RootConstrainSelectedInstOperands,
     /*  416425 */     // GIR_Coverage, 62819,
     /*  416425 */     GIR_EraseRootFromParent_Done,
     /*  416426 */   // Label 7339: @416426
     /*  416426 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(416499), // Rule ID 62820 //
     /*  416431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416455 */     // MIs[0] op1
     /*  416455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  416481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416483 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416485 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416487 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416497 */     GIR_RootConstrainSelectedInstOperands,
     /*  416498 */     // GIR_Coverage, 62820,
     /*  416498 */     GIR_EraseRootFromParent_Done,
     /*  416499 */   // Label 7340: @416499
     /*  416499 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(416572), // Rule ID 62843 //
     /*  416504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  416521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416528 */     // MIs[0] op1
     /*  416528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416551 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  416554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416570 */     GIR_RootConstrainSelectedInstOperands,
     /*  416571 */     // GIR_Coverage, 62843,
     /*  416571 */     GIR_EraseRootFromParent_Done,
     /*  416572 */   // Label 7341: @416572
     /*  416572 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(416645), // Rule ID 62844 //
     /*  416577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  416588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  416591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  416594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416601 */     // MIs[0] op1
     /*  416601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  416627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416629 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416631 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416633 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416643 */     GIR_RootConstrainSelectedInstOperands,
     /*  416644 */     // GIR_Coverage, 62844,
     /*  416644 */     GIR_EraseRootFromParent_Done,
     /*  416645 */   // Label 7342: @416645
     /*  416645 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(416718), // Rule ID 62869 //
     /*  416650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416674 */     // MIs[0] op1
     /*  416674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  416700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416716 */     GIR_RootConstrainSelectedInstOperands,
     /*  416717 */     // GIR_Coverage, 62869,
     /*  416717 */     GIR_EraseRootFromParent_Done,
     /*  416718 */   // Label 7343: @416718
     /*  416718 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(416791), // Rule ID 62870 //
     /*  416723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416747 */     // MIs[0] op1
     /*  416747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416770 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  416773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416775 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416777 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416779 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416789 */     GIR_RootConstrainSelectedInstOperands,
     /*  416790 */     // GIR_Coverage, 62870,
     /*  416790 */     GIR_EraseRootFromParent_Done,
     /*  416791 */   // Label 7344: @416791
     /*  416791 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(416864), // Rule ID 62881 //
     /*  416796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  416813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416820 */     // MIs[0] op1
     /*  416820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  416846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416848 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416850 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416852 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416862 */     GIR_RootConstrainSelectedInstOperands,
     /*  416863 */     // GIR_Coverage, 62881,
     /*  416863 */     GIR_EraseRootFromParent_Done,
     /*  416864 */   // Label 7345: @416864
     /*  416864 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(416937), // Rule ID 62882 //
     /*  416869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  416880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  416883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  416886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416893 */     // MIs[0] op1
     /*  416893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  416919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416921 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416923 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416925 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416935 */     GIR_RootConstrainSelectedInstOperands,
     /*  416936 */     // GIR_Coverage, 62882,
     /*  416936 */     GIR_EraseRootFromParent_Done,
     /*  416937 */   // Label 7346: @416937
     /*  416937 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(417010), // Rule ID 62913 //
     /*  416942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  416953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  416956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416966 */     // MIs[0] op1
     /*  416966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416989 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  416992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417008 */     GIR_RootConstrainSelectedInstOperands,
     /*  417009 */     // GIR_Coverage, 62913,
     /*  417009 */     GIR_EraseRootFromParent_Done,
     /*  417010 */   // Label 7347: @417010
     /*  417010 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(417083), // Rule ID 62914 //
     /*  417015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417039 */     // MIs[0] op1
     /*  417039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417062 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417081 */     GIR_RootConstrainSelectedInstOperands,
     /*  417082 */     // GIR_Coverage, 62914,
     /*  417082 */     GIR_EraseRootFromParent_Done,
     /*  417083 */   // Label 7348: @417083
     /*  417083 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(417156), // Rule ID 62925 //
     /*  417088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  417105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417112 */     // MIs[0] op1
     /*  417112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417135 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417140 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417142 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417144 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417154 */     GIR_RootConstrainSelectedInstOperands,
     /*  417155 */     // GIR_Coverage, 62925,
     /*  417155 */     GIR_EraseRootFromParent_Done,
     /*  417156 */   // Label 7349: @417156
     /*  417156 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(417229), // Rule ID 62926 //
     /*  417161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  417172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  417175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  417178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417185 */     // MIs[0] op1
     /*  417185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417227 */     GIR_RootConstrainSelectedInstOperands,
     /*  417228 */     // GIR_Coverage, 62926,
     /*  417228 */     GIR_EraseRootFromParent_Done,
     /*  417229 */   // Label 7350: @417229
     /*  417229 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(417302), // Rule ID 62957 //
     /*  417234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417258 */     // MIs[0] op1
     /*  417258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  417284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417300 */     GIR_RootConstrainSelectedInstOperands,
     /*  417301 */     // GIR_Coverage, 62957,
     /*  417301 */     GIR_EraseRootFromParent_Done,
     /*  417302 */   // Label 7351: @417302
     /*  417302 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(417375), // Rule ID 62958 //
     /*  417307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417331 */     // MIs[0] op1
     /*  417331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  417357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417359 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417361 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417363 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417373 */     GIR_RootConstrainSelectedInstOperands,
     /*  417374 */     // GIR_Coverage, 62958,
     /*  417374 */     GIR_EraseRootFromParent_Done,
     /*  417375 */   // Label 7352: @417375
     /*  417375 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(417448), // Rule ID 62969 //
     /*  417380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  417397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417404 */     // MIs[0] op1
     /*  417404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417427 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  417430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417446 */     GIR_RootConstrainSelectedInstOperands,
     /*  417447 */     // GIR_Coverage, 62969,
     /*  417447 */     GIR_EraseRootFromParent_Done,
     /*  417448 */   // Label 7353: @417448
     /*  417448 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(417521), // Rule ID 62970 //
     /*  417453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  417470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417477 */     // MIs[0] op1
     /*  417477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  417503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417505 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417507 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417509 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417519 */     GIR_RootConstrainSelectedInstOperands,
     /*  417520 */     // GIR_Coverage, 62970,
     /*  417520 */     GIR_EraseRootFromParent_Done,
     /*  417521 */   // Label 7354: @417521
     /*  417521 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(417594), // Rule ID 62993 //
     /*  417526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417550 */     // MIs[0] op1
     /*  417550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417573 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  417576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417592 */     GIR_RootConstrainSelectedInstOperands,
     /*  417593 */     // GIR_Coverage, 62993,
     /*  417593 */     GIR_EraseRootFromParent_Done,
     /*  417594 */   // Label 7355: @417594
     /*  417594 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(417667), // Rule ID 62994 //
     /*  417599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  417610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  417613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417623 */     // MIs[0] op1
     /*  417623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  417649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417651 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417653 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417655 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417665 */     GIR_RootConstrainSelectedInstOperands,
     /*  417666 */     // GIR_Coverage, 62994,
     /*  417666 */     GIR_EraseRootFromParent_Done,
     /*  417667 */   // Label 7356: @417667
     /*  417667 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(417740), // Rule ID 63013 //
     /*  417672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417696 */     // MIs[0] op1
     /*  417696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417719 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417738 */     GIR_RootConstrainSelectedInstOperands,
     /*  417739 */     // GIR_Coverage, 63013,
     /*  417739 */     GIR_EraseRootFromParent_Done,
     /*  417740 */   // Label 7357: @417740
     /*  417740 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(417813), // Rule ID 63014 //
     /*  417745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417769 */     // MIs[0] op1
     /*  417769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  417795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417797 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417799 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417801 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417811 */     GIR_RootConstrainSelectedInstOperands,
     /*  417812 */     // GIR_Coverage, 63014,
     /*  417812 */     GIR_EraseRootFromParent_Done,
     /*  417813 */   // Label 7358: @417813
     /*  417813 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(417886), // Rule ID 63025 //
     /*  417818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  417835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417842 */     // MIs[0] op1
     /*  417842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417865 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417884 */     GIR_RootConstrainSelectedInstOperands,
     /*  417885 */     // GIR_Coverage, 63025,
     /*  417885 */     GIR_EraseRootFromParent_Done,
     /*  417886 */   // Label 7359: @417886
     /*  417886 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(417959), // Rule ID 63026 //
     /*  417891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  417908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417915 */     // MIs[0] op1
     /*  417915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  417941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417943 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417945 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417947 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417957 */     GIR_RootConstrainSelectedInstOperands,
     /*  417958 */     // GIR_Coverage, 63026,
     /*  417958 */     GIR_EraseRootFromParent_Done,
     /*  417959 */   // Label 7360: @417959
     /*  417959 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(418032), // Rule ID 63049 //
     /*  417964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  417975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  417978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  417988 */     // MIs[0] op1
     /*  417988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  418014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418016 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418018 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418020 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418030 */     GIR_RootConstrainSelectedInstOperands,
     /*  418031 */     // GIR_Coverage, 63049,
     /*  418031 */     GIR_EraseRootFromParent_Done,
     /*  418032 */   // Label 7361: @418032
     /*  418032 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(418105), // Rule ID 63050 //
     /*  418037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  418048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  418051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418061 */     // MIs[0] op1
     /*  418061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  418087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418089 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418091 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418093 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418103 */     GIR_RootConstrainSelectedInstOperands,
     /*  418104 */     // GIR_Coverage, 63050,
     /*  418104 */     GIR_EraseRootFromParent_Done,
     /*  418105 */   // Label 7362: @418105
     /*  418105 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(418178), // Rule ID 63069 //
     /*  418110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418134 */     // MIs[0] op1
     /*  418134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418157 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  418160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418176 */     GIR_RootConstrainSelectedInstOperands,
     /*  418177 */     // GIR_Coverage, 63069,
     /*  418177 */     GIR_EraseRootFromParent_Done,
     /*  418178 */   // Label 7363: @418178
     /*  418178 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(418251), // Rule ID 63070 //
     /*  418183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418207 */     // MIs[0] op1
     /*  418207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418230 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  418233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418249 */     GIR_RootConstrainSelectedInstOperands,
     /*  418250 */     // GIR_Coverage, 63070,
     /*  418250 */     GIR_EraseRootFromParent_Done,
     /*  418251 */   // Label 7364: @418251
     /*  418251 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(418324), // Rule ID 63081 //
     /*  418256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  418273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418280 */     // MIs[0] op1
     /*  418280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418303 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  418306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418322 */     GIR_RootConstrainSelectedInstOperands,
     /*  418323 */     // GIR_Coverage, 63081,
     /*  418323 */     GIR_EraseRootFromParent_Done,
     /*  418324 */   // Label 7365: @418324
     /*  418324 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(418397), // Rule ID 63082 //
     /*  418329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  418346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418353 */     // MIs[0] op1
     /*  418353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  418379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418395 */     GIR_RootConstrainSelectedInstOperands,
     /*  418396 */     // GIR_Coverage, 63082,
     /*  418396 */     GIR_EraseRootFromParent_Done,
     /*  418397 */   // Label 7366: @418397
     /*  418397 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(418470), // Rule ID 63105 //
     /*  418402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418426 */     // MIs[0] op1
     /*  418426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  418452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418468 */     GIR_RootConstrainSelectedInstOperands,
     /*  418469 */     // GIR_Coverage, 63105,
     /*  418469 */     GIR_EraseRootFromParent_Done,
     /*  418470 */   // Label 7367: @418470
     /*  418470 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(418543), // Rule ID 63106 //
     /*  418475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  418486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  418489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418499 */     // MIs[0] op1
     /*  418499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  418525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418541 */     GIR_RootConstrainSelectedInstOperands,
     /*  418542 */     // GIR_Coverage, 63106,
     /*  418542 */     GIR_EraseRootFromParent_Done,
     /*  418543 */   // Label 7368: @418543
     /*  418543 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(418616), // Rule ID 63125 //
     /*  418548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418572 */     // MIs[0] op1
     /*  418572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  418595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418614 */     GIR_RootConstrainSelectedInstOperands,
     /*  418615 */     // GIR_Coverage, 63125,
     /*  418615 */     GIR_EraseRootFromParent_Done,
     /*  418616 */   // Label 7369: @418616
     /*  418616 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(418689), // Rule ID 63126 //
     /*  418621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418645 */     // MIs[0] op1
     /*  418645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  418668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418673 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418675 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418677 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418687 */     GIR_RootConstrainSelectedInstOperands,
     /*  418688 */     // GIR_Coverage, 63126,
     /*  418688 */     GIR_EraseRootFromParent_Done,
     /*  418689 */   // Label 7370: @418689
     /*  418689 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(418762), // Rule ID 63137 //
     /*  418694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  418711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418718 */     // MIs[0] op1
     /*  418718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418741 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  418741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  418744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418746 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418748 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418750 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418760 */     GIR_RootConstrainSelectedInstOperands,
     /*  418761 */     // GIR_Coverage, 63137,
     /*  418761 */     GIR_EraseRootFromParent_Done,
     /*  418762 */   // Label 7371: @418762
     /*  418762 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(418835), // Rule ID 63138 //
     /*  418767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  418778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  418781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  418784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418791 */     // MIs[0] op1
     /*  418791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  418814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  418817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418819 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418821 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418823 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  418833 */     GIR_RootConstrainSelectedInstOperands,
     /*  418834 */     // GIR_Coverage, 63138,
     /*  418834 */     GIR_EraseRootFromParent_Done,
     /*  418835 */   // Label 7372: @418835
     /*  418835 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(418908), // Rule ID 63169 //
     /*  418840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  418854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418864 */     // MIs[0] op1
     /*  418864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418887 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418892 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418894 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418896 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418906 */     GIR_RootConstrainSelectedInstOperands,
     /*  418907 */     // GIR_Coverage, 63169,
     /*  418907 */     GIR_EraseRootFromParent_Done,
     /*  418908 */   // Label 7373: @418908
     /*  418908 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(418981), // Rule ID 63170 //
     /*  418913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  418927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418937 */     // MIs[0] op1
     /*  418937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  418949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  418963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418965 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418967 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418969 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418979 */     GIR_RootConstrainSelectedInstOperands,
     /*  418980 */     // GIR_Coverage, 63170,
     /*  418980 */     GIR_EraseRootFromParent_Done,
     /*  418981 */   // Label 7374: @418981
     /*  418981 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(419054), // Rule ID 63181 //
     /*  418986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  418997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  419003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419010 */     // MIs[0] op1
     /*  419010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  419033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419052 */     GIR_RootConstrainSelectedInstOperands,
     /*  419053 */     // GIR_Coverage, 63181,
     /*  419053 */     GIR_EraseRootFromParent_Done,
     /*  419054 */   // Label 7375: @419054
     /*  419054 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(419127), // Rule ID 63182 //
     /*  419059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  419076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419083 */     // MIs[0] op1
     /*  419083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  419106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419111 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419113 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419115 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419125 */     GIR_RootConstrainSelectedInstOperands,
     /*  419126 */     // GIR_Coverage, 63182,
     /*  419126 */     GIR_EraseRootFromParent_Done,
     /*  419127 */   // Label 7376: @419127
     /*  419127 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(419200), // Rule ID 63205 //
     /*  419132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  419149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419156 */     // MIs[0] op1
     /*  419156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  419172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419179 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  419179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  419182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419198 */     GIR_RootConstrainSelectedInstOperands,
     /*  419199 */     // GIR_Coverage, 63205,
     /*  419199 */     GIR_EraseRootFromParent_Done,
     /*  419200 */   // Label 7377: @419200
     /*  419200 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(419273), // Rule ID 63206 //
     /*  419205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  419216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  419219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  419222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419229 */     // MIs[0] op1
     /*  419229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  419245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  419252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  419255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419257 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419259 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419261 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  419271 */     GIR_RootConstrainSelectedInstOperands,
     /*  419272 */     // GIR_Coverage, 63206,
     /*  419272 */     GIR_EraseRootFromParent_Done,
     /*  419273 */   // Label 7378: @419273
     /*  419273 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(419346), // Rule ID 63225 //
     /*  419278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419302 */     // MIs[0] op1
     /*  419302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419325 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419344 */     GIR_RootConstrainSelectedInstOperands,
     /*  419345 */     // GIR_Coverage, 63225,
     /*  419345 */     GIR_EraseRootFromParent_Done,
     /*  419346 */   // Label 7379: @419346
     /*  419346 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(419419), // Rule ID 63226 //
     /*  419351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419375 */     // MIs[0] op1
     /*  419375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419417 */     GIR_RootConstrainSelectedInstOperands,
     /*  419418 */     // GIR_Coverage, 63226,
     /*  419418 */     GIR_EraseRootFromParent_Done,
     /*  419419 */   // Label 7380: @419419
     /*  419419 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(419492), // Rule ID 63237 //
     /*  419424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  419441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419448 */     // MIs[0] op1
     /*  419448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419490 */     GIR_RootConstrainSelectedInstOperands,
     /*  419491 */     // GIR_Coverage, 63237,
     /*  419491 */     GIR_EraseRootFromParent_Done,
     /*  419492 */   // Label 7381: @419492
     /*  419492 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(419565), // Rule ID 63238 //
     /*  419497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  419514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419521 */     // MIs[0] op1
     /*  419521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419563 */     GIR_RootConstrainSelectedInstOperands,
     /*  419564 */     // GIR_Coverage, 63238,
     /*  419564 */     GIR_EraseRootFromParent_Done,
     /*  419565 */   // Label 7382: @419565
     /*  419565 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(419638), // Rule ID 63261 //
     /*  419570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419594 */     // MIs[0] op1
     /*  419594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419617 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  419620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419622 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419624 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419626 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419636 */     GIR_RootConstrainSelectedInstOperands,
     /*  419637 */     // GIR_Coverage, 63261,
     /*  419637 */     GIR_EraseRootFromParent_Done,
     /*  419638 */   // Label 7383: @419638
     /*  419638 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(419711), // Rule ID 63262 //
     /*  419643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  419654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  419657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419667 */     // MIs[0] op1
     /*  419667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  419693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419709 */     GIR_RootConstrainSelectedInstOperands,
     /*  419710 */     // GIR_Coverage, 63262,
     /*  419710 */     GIR_EraseRootFromParent_Done,
     /*  419711 */   // Label 7384: @419711
     /*  419711 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(419784), // Rule ID 63281 //
     /*  419716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419740 */     // MIs[0] op1
     /*  419740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419763 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419782 */     GIR_RootConstrainSelectedInstOperands,
     /*  419783 */     // GIR_Coverage, 63281,
     /*  419783 */     GIR_EraseRootFromParent_Done,
     /*  419784 */   // Label 7385: @419784
     /*  419784 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(419857), // Rule ID 63282 //
     /*  419789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419813 */     // MIs[0] op1
     /*  419813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  419839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419841 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419843 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419845 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419855 */     GIR_RootConstrainSelectedInstOperands,
     /*  419856 */     // GIR_Coverage, 63282,
     /*  419856 */     GIR_EraseRootFromParent_Done,
     /*  419857 */   // Label 7386: @419857
     /*  419857 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(419930), // Rule ID 63293 //
     /*  419862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  419879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419886 */     // MIs[0] op1
     /*  419886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419928 */     GIR_RootConstrainSelectedInstOperands,
     /*  419929 */     // GIR_Coverage, 63293,
     /*  419929 */     GIR_EraseRootFromParent_Done,
     /*  419930 */   // Label 7387: @419930
     /*  419930 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(420003), // Rule ID 63294 //
     /*  419935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  419946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  419949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  419952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419959 */     // MIs[0] op1
     /*  419959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  419975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419982 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  419985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419987 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419989 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419991 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420001 */     GIR_RootConstrainSelectedInstOperands,
     /*  420002 */     // GIR_Coverage, 63294,
     /*  420002 */     GIR_EraseRootFromParent_Done,
     /*  420003 */   // Label 7388: @420003
     /*  420003 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(420076), // Rule ID 63317 //
     /*  420008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420032 */     // MIs[0] op1
     /*  420032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420055 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  420058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420074 */     GIR_RootConstrainSelectedInstOperands,
     /*  420075 */     // GIR_Coverage, 63317,
     /*  420075 */     GIR_EraseRootFromParent_Done,
     /*  420076 */   // Label 7389: @420076
     /*  420076 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(420149), // Rule ID 63318 //
     /*  420081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  420092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  420095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420105 */     // MIs[0] op1
     /*  420105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  420131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420133 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420135 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420137 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420147 */     GIR_RootConstrainSelectedInstOperands,
     /*  420148 */     // GIR_Coverage, 63318,
     /*  420148 */     GIR_EraseRootFromParent_Done,
     /*  420149 */   // Label 7390: @420149
     /*  420149 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(420222), // Rule ID 63337 //
     /*  420154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420178 */     // MIs[0] op1
     /*  420178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  420204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420220 */     GIR_RootConstrainSelectedInstOperands,
     /*  420221 */     // GIR_Coverage, 63337,
     /*  420221 */     GIR_EraseRootFromParent_Done,
     /*  420222 */   // Label 7391: @420222
     /*  420222 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(420295), // Rule ID 63338 //
     /*  420227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420251 */     // MIs[0] op1
     /*  420251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  420277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420279 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420281 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420283 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420293 */     GIR_RootConstrainSelectedInstOperands,
     /*  420294 */     // GIR_Coverage, 63338,
     /*  420294 */     GIR_EraseRootFromParent_Done,
     /*  420295 */   // Label 7392: @420295
     /*  420295 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(420368), // Rule ID 63349 //
     /*  420300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  420317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420324 */     // MIs[0] op1
     /*  420324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420352 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420354 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420356 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420366 */     GIR_RootConstrainSelectedInstOperands,
     /*  420367 */     // GIR_Coverage, 63349,
     /*  420367 */     GIR_EraseRootFromParent_Done,
     /*  420368 */   // Label 7393: @420368
     /*  420368 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(420441), // Rule ID 63350 //
     /*  420373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  420384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  420387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  420390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420397 */     // MIs[0] op1
     /*  420397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420425 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420427 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420429 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420439 */     GIR_RootConstrainSelectedInstOperands,
     /*  420440 */     // GIR_Coverage, 63350,
     /*  420440 */     GIR_EraseRootFromParent_Done,
     /*  420441 */   // Label 7394: @420441
     /*  420441 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(420514), // Rule ID 63381 //
     /*  420446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420470 */     // MIs[0] op1
     /*  420470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420493 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420512 */     GIR_RootConstrainSelectedInstOperands,
     /*  420513 */     // GIR_Coverage, 63381,
     /*  420513 */     GIR_EraseRootFromParent_Done,
     /*  420514 */   // Label 7395: @420514
     /*  420514 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(420587), // Rule ID 63382 //
     /*  420519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420543 */     // MIs[0] op1
     /*  420543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420566 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420571 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420573 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420575 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420585 */     GIR_RootConstrainSelectedInstOperands,
     /*  420586 */     // GIR_Coverage, 63382,
     /*  420586 */     GIR_EraseRootFromParent_Done,
     /*  420587 */   // Label 7396: @420587
     /*  420587 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(420660), // Rule ID 63393 //
     /*  420592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  420609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420616 */     // MIs[0] op1
     /*  420616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420639 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420658 */     GIR_RootConstrainSelectedInstOperands,
     /*  420659 */     // GIR_Coverage, 63393,
     /*  420659 */     GIR_EraseRootFromParent_Done,
     /*  420660 */   // Label 7397: @420660
     /*  420660 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(420733), // Rule ID 63394 //
     /*  420665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  420676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  420679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  420682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420689 */     // MIs[0] op1
     /*  420689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420712 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420731 */     GIR_RootConstrainSelectedInstOperands,
     /*  420732 */     // GIR_Coverage, 63394,
     /*  420732 */     GIR_EraseRootFromParent_Done,
     /*  420733 */   // Label 7398: @420733
     /*  420733 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(420806), // Rule ID 63425 //
     /*  420738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420762 */     // MIs[0] op1
     /*  420762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420785 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420804 */     GIR_RootConstrainSelectedInstOperands,
     /*  420805 */     // GIR_Coverage, 63425,
     /*  420805 */     GIR_EraseRootFromParent_Done,
     /*  420806 */   // Label 7399: @420806
     /*  420806 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(420879), // Rule ID 63426 //
     /*  420811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420835 */     // MIs[0] op1
     /*  420835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420877 */     GIR_RootConstrainSelectedInstOperands,
     /*  420878 */     // GIR_Coverage, 63426,
     /*  420878 */     GIR_EraseRootFromParent_Done,
     /*  420879 */   // Label 7400: @420879
     /*  420879 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(420952), // Rule ID 63437 //
     /*  420884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  420901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420908 */     // MIs[0] op1
     /*  420908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420931 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420950 */     GIR_RootConstrainSelectedInstOperands,
     /*  420951 */     // GIR_Coverage, 63437,
     /*  420951 */     GIR_EraseRootFromParent_Done,
     /*  420952 */   // Label 7401: @420952
     /*  420952 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(421025), // Rule ID 63438 //
     /*  420957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  420968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  420971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  420974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420981 */     // MIs[0] op1
     /*  420981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421004 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  421007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421023 */     GIR_RootConstrainSelectedInstOperands,
     /*  421024 */     // GIR_Coverage, 63438,
     /*  421024 */     GIR_EraseRootFromParent_Done,
     /*  421025 */   // Label 7402: @421025
     /*  421025 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(421098), // Rule ID 63469 //
     /*  421030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421054 */     // MIs[0] op1
     /*  421054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  421080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421082 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421084 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421086 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421096 */     GIR_RootConstrainSelectedInstOperands,
     /*  421097 */     // GIR_Coverage, 63469,
     /*  421097 */     GIR_EraseRootFromParent_Done,
     /*  421098 */   // Label 7403: @421098
     /*  421098 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(421171), // Rule ID 63470 //
     /*  421103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421127 */     // MIs[0] op1
     /*  421127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  421153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421155 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421157 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421159 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421169 */     GIR_RootConstrainSelectedInstOperands,
     /*  421170 */     // GIR_Coverage, 63470,
     /*  421170 */     GIR_EraseRootFromParent_Done,
     /*  421171 */   // Label 7404: @421171
     /*  421171 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(421244), // Rule ID 63481 //
     /*  421176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  421193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421200 */     // MIs[0] op1
     /*  421200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  421226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421242 */     GIR_RootConstrainSelectedInstOperands,
     /*  421243 */     // GIR_Coverage, 63481,
     /*  421243 */     GIR_EraseRootFromParent_Done,
     /*  421244 */   // Label 7405: @421244
     /*  421244 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(421317), // Rule ID 63482 //
     /*  421249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  421266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421273 */     // MIs[0] op1
     /*  421273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  421299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421301 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421303 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421305 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421315 */     GIR_RootConstrainSelectedInstOperands,
     /*  421316 */     // GIR_Coverage, 63482,
     /*  421316 */     GIR_EraseRootFromParent_Done,
     /*  421317 */   // Label 7406: @421317
     /*  421317 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(421390), // Rule ID 63505 //
     /*  421322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421346 */     // MIs[0] op1
     /*  421346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  421372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421388 */     GIR_RootConstrainSelectedInstOperands,
     /*  421389 */     // GIR_Coverage, 63505,
     /*  421389 */     GIR_EraseRootFromParent_Done,
     /*  421390 */   // Label 7407: @421390
     /*  421390 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(421463), // Rule ID 63506 //
     /*  421395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  421406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  421409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421419 */     // MIs[0] op1
     /*  421419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  421431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  421445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421447 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421449 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421451 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421461 */     GIR_RootConstrainSelectedInstOperands,
     /*  421462 */     // GIR_Coverage, 63506,
     /*  421462 */     GIR_EraseRootFromParent_Done,
     /*  421463 */   // Label 7408: @421463
     /*  421463 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(421536), // Rule ID 63525 //
     /*  421468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421492 */     // MIs[0] op1
     /*  421492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421515 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  421518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421534 */     GIR_RootConstrainSelectedInstOperands,
     /*  421535 */     // GIR_Coverage, 63525,
     /*  421535 */     GIR_EraseRootFromParent_Done,
     /*  421536 */   // Label 7409: @421536
     /*  421536 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(421609), // Rule ID 63526 //
     /*  421541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421565 */     // MIs[0] op1
     /*  421565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  421591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421607 */     GIR_RootConstrainSelectedInstOperands,
     /*  421608 */     // GIR_Coverage, 63526,
     /*  421608 */     GIR_EraseRootFromParent_Done,
     /*  421609 */   // Label 7410: @421609
     /*  421609 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(421682), // Rule ID 63537 //
     /*  421614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  421631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421638 */     // MIs[0] op1
     /*  421638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421661 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  421664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421680 */     GIR_RootConstrainSelectedInstOperands,
     /*  421681 */     // GIR_Coverage, 63537,
     /*  421681 */     GIR_EraseRootFromParent_Done,
     /*  421682 */   // Label 7411: @421682
     /*  421682 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(421755), // Rule ID 63538 //
     /*  421687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  421695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  421704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421711 */     // MIs[0] op1
     /*  421711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  421737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421739 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421741 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421743 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421753 */     GIR_RootConstrainSelectedInstOperands,
     /*  421754 */     // GIR_Coverage, 63538,
     /*  421754 */     GIR_EraseRootFromParent_Done,
     /*  421755 */   // Label 7412: @421755
     /*  421755 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(421828), // Rule ID 63561 //
     /*  421760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421784 */     // MIs[0] op1
     /*  421784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421807 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  421810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421812 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421814 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421816 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421826 */     GIR_RootConstrainSelectedInstOperands,
     /*  421827 */     // GIR_Coverage, 63561,
     /*  421827 */     GIR_EraseRootFromParent_Done,
     /*  421828 */   // Label 7413: @421828
     /*  421828 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(421901), // Rule ID 63562 //
     /*  421833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  421844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  421847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  421850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421857 */     // MIs[0] op1
     /*  421857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  421869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  421873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421880 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  421883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421899 */     GIR_RootConstrainSelectedInstOperands,
     /*  421900 */     // GIR_Coverage, 63562,
     /*  421900 */     GIR_EraseRootFromParent_Done,
     /*  421901 */   // Label 7414: @421901
     /*  421901 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(421974), // Rule ID 63581 //
     /*  421906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  421909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421930 */     // MIs[0] op1
     /*  421930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  421938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  421946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  421956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421972 */     GIR_RootConstrainSelectedInstOperands,
     /*  421973 */     // GIR_Coverage, 63581,
     /*  421973 */     GIR_EraseRootFromParent_Done,
     /*  421974 */   // Label 7415: @421974
     /*  421974 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(422047), // Rule ID 63582 //
     /*  421979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  421987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  421990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  421993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  421996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422003 */     // MIs[0] op1
     /*  422003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422026 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  422029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422045 */     GIR_RootConstrainSelectedInstOperands,
     /*  422046 */     // GIR_Coverage, 63582,
     /*  422046 */     GIR_EraseRootFromParent_Done,
     /*  422047 */   // Label 7416: @422047
     /*  422047 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(422120), // Rule ID 63593 //
     /*  422052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  422069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422076 */     // MIs[0] op1
     /*  422076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  422102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422118 */     GIR_RootConstrainSelectedInstOperands,
     /*  422119 */     // GIR_Coverage, 63593,
     /*  422119 */     GIR_EraseRootFromParent_Done,
     /*  422120 */   // Label 7417: @422120
     /*  422120 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(422193), // Rule ID 63594 //
     /*  422125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  422142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422149 */     // MIs[0] op1
     /*  422149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  422175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422177 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422179 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422181 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422191 */     GIR_RootConstrainSelectedInstOperands,
     /*  422192 */     // GIR_Coverage, 63594,
     /*  422192 */     GIR_EraseRootFromParent_Done,
     /*  422193 */   // Label 7418: @422193
     /*  422193 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(422266), // Rule ID 63617 //
     /*  422198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  422215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422222 */     // MIs[0] op1
     /*  422222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  422238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  422248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422264 */     GIR_RootConstrainSelectedInstOperands,
     /*  422265 */     // GIR_Coverage, 63617,
     /*  422265 */     GIR_EraseRootFromParent_Done,
     /*  422266 */   // Label 7419: @422266
     /*  422266 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(422339), // Rule ID 63618 //
     /*  422271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  422282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  422285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  422288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422295 */     // MIs[0] op1
     /*  422295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  422311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  422321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422323 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422325 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422327 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422337 */     GIR_RootConstrainSelectedInstOperands,
     /*  422338 */     // GIR_Coverage, 63618,
     /*  422338 */     GIR_EraseRootFromParent_Done,
     /*  422339 */   // Label 7420: @422339
     /*  422339 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(422412), // Rule ID 63637 //
     /*  422344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  422361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422368 */     // MIs[0] op1
     /*  422368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  422394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422410 */     GIR_RootConstrainSelectedInstOperands,
     /*  422411 */     // GIR_Coverage, 63637,
     /*  422411 */     GIR_EraseRootFromParent_Done,
     /*  422412 */   // Label 7421: @422412
     /*  422412 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(422485), // Rule ID 63638 //
     /*  422417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422441 */     // MIs[0] op1
     /*  422441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  422467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422469 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422471 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422473 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422483 */     GIR_RootConstrainSelectedInstOperands,
     /*  422484 */     // GIR_Coverage, 63638,
     /*  422484 */     GIR_EraseRootFromParent_Done,
     /*  422485 */   // Label 7422: @422485
     /*  422485 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(422558), // Rule ID 63649 //
     /*  422490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  422507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422514 */     // MIs[0] op1
     /*  422514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  422540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422542 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422544 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422546 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422556 */     GIR_RootConstrainSelectedInstOperands,
     /*  422557 */     // GIR_Coverage, 63649,
     /*  422557 */     GIR_EraseRootFromParent_Done,
     /*  422558 */   // Label 7423: @422558
     /*  422558 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(422631), // Rule ID 63650 //
     /*  422563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  422580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422587 */     // MIs[0] op1
     /*  422587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  422613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422615 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422617 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422619 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422629 */     GIR_RootConstrainSelectedInstOperands,
     /*  422630 */     // GIR_Coverage, 63650,
     /*  422630 */     GIR_EraseRootFromParent_Done,
     /*  422631 */   // Label 7424: @422631
     /*  422631 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(422704), // Rule ID 63673 //
     /*  422636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422660 */     // MIs[0] op1
     /*  422660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  422676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  422686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422688 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422690 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422692 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422702 */     GIR_RootConstrainSelectedInstOperands,
     /*  422703 */     // GIR_Coverage, 63673,
     /*  422703 */     GIR_EraseRootFromParent_Done,
     /*  422704 */   // Label 7425: @422704
     /*  422704 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(422777), // Rule ID 63674 //
     /*  422709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  422717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  422720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  422723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422733 */     // MIs[0] op1
     /*  422733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  422741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  422749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  422759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422775 */     GIR_RootConstrainSelectedInstOperands,
     /*  422776 */     // GIR_Coverage, 63674,
     /*  422776 */     GIR_EraseRootFromParent_Done,
     /*  422777 */   // Label 7426: @422777
     /*  422777 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(422850), // Rule ID 63693 //
     /*  422782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  422799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422806 */     // MIs[0] op1
     /*  422806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  422832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422848 */     GIR_RootConstrainSelectedInstOperands,
     /*  422849 */     // GIR_Coverage, 63693,
     /*  422849 */     GIR_EraseRootFromParent_Done,
     /*  422850 */   // Label 7427: @422850
     /*  422850 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(422923), // Rule ID 63694 //
     /*  422855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  422858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  422863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  422872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422879 */     // MIs[0] op1
     /*  422879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  422895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  422905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422907 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422909 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422911 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422921 */     GIR_RootConstrainSelectedInstOperands,
     /*  422922 */     // GIR_Coverage, 63694,
     /*  422922 */     GIR_EraseRootFromParent_Done,
     /*  422923 */   // Label 7428: @422923
     /*  422923 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(422996), // Rule ID 63705 //
     /*  422928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  422931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  422936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  422939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  422942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  422945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422952 */     // MIs[0] op1
     /*  422952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  422955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  422960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  422978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  422982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  422984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  422986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422994 */     GIR_RootConstrainSelectedInstOperands,
     /*  422995 */     // GIR_Coverage, 63705,
     /*  422995 */     GIR_EraseRootFromParent_Done,
     /*  422996 */   // Label 7429: @422996
     /*  422996 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(423069), // Rule ID 63706 //
     /*  423001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  423018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423025 */     // MIs[0] op1
     /*  423025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  423051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423067 */     GIR_RootConstrainSelectedInstOperands,
     /*  423068 */     // GIR_Coverage, 63706,
     /*  423068 */     GIR_EraseRootFromParent_Done,
     /*  423069 */   // Label 7430: @423069
     /*  423069 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(423142), // Rule ID 63729 //
     /*  423074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423098 */     // MIs[0] op1
     /*  423098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  423124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423140 */     GIR_RootConstrainSelectedInstOperands,
     /*  423141 */     // GIR_Coverage, 63729,
     /*  423141 */     GIR_EraseRootFromParent_Done,
     /*  423142 */   // Label 7431: @423142
     /*  423142 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(423215), // Rule ID 63730 //
     /*  423147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  423158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  423161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423171 */     // MIs[0] op1
     /*  423171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  423197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423199 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423201 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423203 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423213 */     GIR_RootConstrainSelectedInstOperands,
     /*  423214 */     // GIR_Coverage, 63730,
     /*  423214 */     GIR_EraseRootFromParent_Done,
     /*  423215 */   // Label 7432: @423215
     /*  423215 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(423288), // Rule ID 63749 //
     /*  423220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423244 */     // MIs[0] op1
     /*  423244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423267 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  423270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423286 */     GIR_RootConstrainSelectedInstOperands,
     /*  423287 */     // GIR_Coverage, 63749,
     /*  423287 */     GIR_EraseRootFromParent_Done,
     /*  423288 */   // Label 7433: @423288
     /*  423288 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(423361), // Rule ID 63750 //
     /*  423293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423317 */     // MIs[0] op1
     /*  423317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  423343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423359 */     GIR_RootConstrainSelectedInstOperands,
     /*  423360 */     // GIR_Coverage, 63750,
     /*  423360 */     GIR_EraseRootFromParent_Done,
     /*  423361 */   // Label 7434: @423361
     /*  423361 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(423434), // Rule ID 63761 //
     /*  423366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  423383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423390 */     // MIs[0] op1
     /*  423390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  423416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423418 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423420 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423422 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423432 */     GIR_RootConstrainSelectedInstOperands,
     /*  423433 */     // GIR_Coverage, 63761,
     /*  423433 */     GIR_EraseRootFromParent_Done,
     /*  423434 */   // Label 7435: @423434
     /*  423434 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(423507), // Rule ID 63762 //
     /*  423439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  423456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423463 */     // MIs[0] op1
     /*  423463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  423489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423491 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423493 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423495 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423505 */     GIR_RootConstrainSelectedInstOperands,
     /*  423506 */     // GIR_Coverage, 63762,
     /*  423506 */     GIR_EraseRootFromParent_Done,
     /*  423507 */   // Label 7436: @423507
     /*  423507 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(423580), // Rule ID 63785 //
     /*  423512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423536 */     // MIs[0] op1
     /*  423536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  423562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423564 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423566 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423568 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423578 */     GIR_RootConstrainSelectedInstOperands,
     /*  423579 */     // GIR_Coverage, 63785,
     /*  423579 */     GIR_EraseRootFromParent_Done,
     /*  423580 */   // Label 7437: @423580
     /*  423580 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(423653), // Rule ID 63786 //
     /*  423585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  423596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  423599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423609 */     // MIs[0] op1
     /*  423609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  423625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  423635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423637 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423639 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423641 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423651 */     GIR_RootConstrainSelectedInstOperands,
     /*  423652 */     // GIR_Coverage, 63786,
     /*  423652 */     GIR_EraseRootFromParent_Done,
     /*  423653 */   // Label 7438: @423653
     /*  423653 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(423726), // Rule ID 63805 //
     /*  423658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423682 */     // MIs[0] op1
     /*  423682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  423708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423724 */     GIR_RootConstrainSelectedInstOperands,
     /*  423725 */     // GIR_Coverage, 63805,
     /*  423725 */     GIR_EraseRootFromParent_Done,
     /*  423726 */   // Label 7439: @423726
     /*  423726 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(423799), // Rule ID 63806 //
     /*  423731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  423739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  423748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423755 */     // MIs[0] op1
     /*  423755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  423771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  423781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423783 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423785 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423787 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423797 */     GIR_RootConstrainSelectedInstOperands,
     /*  423798 */     // GIR_Coverage, 63806,
     /*  423798 */     GIR_EraseRootFromParent_Done,
     /*  423799 */   // Label 7440: @423799
     /*  423799 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(423872), // Rule ID 63817 //
     /*  423804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  423821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423828 */     // MIs[0] op1
     /*  423828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  423854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423870 */     GIR_RootConstrainSelectedInstOperands,
     /*  423871 */     // GIR_Coverage, 63817,
     /*  423871 */     GIR_EraseRootFromParent_Done,
     /*  423872 */   // Label 7441: @423872
     /*  423872 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(423945), // Rule ID 63818 //
     /*  423877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  423880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  423885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  423894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423901 */     // MIs[0] op1
     /*  423901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  423909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  423927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423929 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  423931 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  423933 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  423935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423943 */     GIR_RootConstrainSelectedInstOperands,
     /*  423944 */     // GIR_Coverage, 63818,
     /*  423944 */     GIR_EraseRootFromParent_Done,
     /*  423945 */   // Label 7442: @423945
     /*  423945 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(424018), // Rule ID 63841 //
     /*  423950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  423953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  423958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  423961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  423964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  423967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423974 */     // MIs[0] op1
     /*  423974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  423977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  423982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  423990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  424000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424016 */     GIR_RootConstrainSelectedInstOperands,
     /*  424017 */     // GIR_Coverage, 63841,
     /*  424017 */     GIR_EraseRootFromParent_Done,
     /*  424018 */   // Label 7443: @424018
     /*  424018 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(424091), // Rule ID 63842 //
     /*  424023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  424034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  424037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424047 */     // MIs[0] op1
     /*  424047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  424073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424075 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424077 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424079 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424089 */     GIR_RootConstrainSelectedInstOperands,
     /*  424090 */     // GIR_Coverage, 63842,
     /*  424090 */     GIR_EraseRootFromParent_Done,
     /*  424091 */   // Label 7444: @424091
     /*  424091 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(424164), // Rule ID 63861 //
     /*  424096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424120 */     // MIs[0] op1
     /*  424120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  424146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424148 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424150 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424152 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424162 */     GIR_RootConstrainSelectedInstOperands,
     /*  424163 */     // GIR_Coverage, 63861,
     /*  424163 */     GIR_EraseRootFromParent_Done,
     /*  424164 */   // Label 7445: @424164
     /*  424164 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(424237), // Rule ID 63862 //
     /*  424169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  424186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424193 */     // MIs[0] op1
     /*  424193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  424219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424235 */     GIR_RootConstrainSelectedInstOperands,
     /*  424236 */     // GIR_Coverage, 63862,
     /*  424236 */     GIR_EraseRootFromParent_Done,
     /*  424237 */   // Label 7446: @424237
     /*  424237 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(424310), // Rule ID 63873 //
     /*  424242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  424259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424266 */     // MIs[0] op1
     /*  424266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424289 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  424292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424308 */     GIR_RootConstrainSelectedInstOperands,
     /*  424309 */     // GIR_Coverage, 63873,
     /*  424309 */     GIR_EraseRootFromParent_Done,
     /*  424310 */   // Label 7447: @424310
     /*  424310 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(424383), // Rule ID 63874 //
     /*  424315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  424332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424339 */     // MIs[0] op1
     /*  424339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  424365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424381 */     GIR_RootConstrainSelectedInstOperands,
     /*  424382 */     // GIR_Coverage, 63874,
     /*  424382 */     GIR_EraseRootFromParent_Done,
     /*  424383 */   // Label 7448: @424383
     /*  424383 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(424456), // Rule ID 63897 //
     /*  424388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424412 */     // MIs[0] op1
     /*  424412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424435 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  424438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424454 */     GIR_RootConstrainSelectedInstOperands,
     /*  424455 */     // GIR_Coverage, 63897,
     /*  424455 */     GIR_EraseRootFromParent_Done,
     /*  424456 */   // Label 7449: @424456
     /*  424456 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(424529), // Rule ID 63898 //
     /*  424461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  424472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  424475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424485 */     // MIs[0] op1
     /*  424485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424508 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  424511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424513 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424515 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424517 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424527 */     GIR_RootConstrainSelectedInstOperands,
     /*  424528 */     // GIR_Coverage, 63898,
     /*  424528 */     GIR_EraseRootFromParent_Done,
     /*  424529 */   // Label 7450: @424529
     /*  424529 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(424602), // Rule ID 63917 //
     /*  424534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424558 */     // MIs[0] op1
     /*  424558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424581 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  424584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424600 */     GIR_RootConstrainSelectedInstOperands,
     /*  424601 */     // GIR_Coverage, 63917,
     /*  424601 */     GIR_EraseRootFromParent_Done,
     /*  424602 */   // Label 7451: @424602
     /*  424602 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(424675), // Rule ID 63918 //
     /*  424607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  424615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  424624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424631 */     // MIs[0] op1
     /*  424631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  424647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  424657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424659 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424661 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424663 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424673 */     GIR_RootConstrainSelectedInstOperands,
     /*  424674 */     // GIR_Coverage, 63918,
     /*  424674 */     GIR_EraseRootFromParent_Done,
     /*  424675 */   // Label 7452: @424675
     /*  424675 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(424748), // Rule ID 63929 //
     /*  424680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  424697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424704 */     // MIs[0] op1
     /*  424704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424727 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  424730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424746 */     GIR_RootConstrainSelectedInstOperands,
     /*  424747 */     // GIR_Coverage, 63929,
     /*  424747 */     GIR_EraseRootFromParent_Done,
     /*  424748 */   // Label 7453: @424748
     /*  424748 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(424821), // Rule ID 63930 //
     /*  424753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  424761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  424770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424777 */     // MIs[0] op1
     /*  424777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  424785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  424803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424805 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424807 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424809 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424819 */     GIR_RootConstrainSelectedInstOperands,
     /*  424820 */     // GIR_Coverage, 63930,
     /*  424820 */     GIR_EraseRootFromParent_Done,
     /*  424821 */   // Label 7454: @424821
     /*  424821 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(424894), // Rule ID 63953 //
     /*  424826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  424829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424850 */     // MIs[0] op1
     /*  424850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424873 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  424876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424892 */     GIR_RootConstrainSelectedInstOperands,
     /*  424893 */     // GIR_Coverage, 63953,
     /*  424893 */     GIR_EraseRootFromParent_Done,
     /*  424894 */   // Label 7455: @424894
     /*  424894 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(424967), // Rule ID 63954 //
     /*  424899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  424902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  424907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  424910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  424913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  424916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424923 */     // MIs[0] op1
     /*  424923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  424926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  424931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  424939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  424949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424951 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  424953 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  424955 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  424957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424965 */     GIR_RootConstrainSelectedInstOperands,
     /*  424966 */     // GIR_Coverage, 63954,
     /*  424966 */     GIR_EraseRootFromParent_Done,
     /*  424967 */   // Label 7456: @424967
     /*  424967 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(425050), // Rule ID 5326 //
     /*  424972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  424983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  424986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  424992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425015 */     // MIs[1] Operand 1
     /*  425015 */     // No operand predicates
     /*  425015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  425031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425048 */     GIR_RootConstrainSelectedInstOperands,
     /*  425049 */     // GIR_Coverage, 5326,
     /*  425049 */     GIR_EraseRootFromParent_Done,
     /*  425050 */   // Label 7457: @425050
     /*  425050 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(425133), // Rule ID 5327 //
     /*  425055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  425069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425098 */     // MIs[1] Operand 1
     /*  425098 */     // No operand predicates
     /*  425098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425111 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  425114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425131 */     GIR_RootConstrainSelectedInstOperands,
     /*  425132 */     // GIR_Coverage, 5327,
     /*  425132 */     GIR_EraseRootFromParent_Done,
     /*  425133 */   // Label 7458: @425133
     /*  425133 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(425216), // Rule ID 5328 //
     /*  425138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  425152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425181 */     // MIs[1] Operand 1
     /*  425181 */     // No operand predicates
     /*  425181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425214 */     GIR_RootConstrainSelectedInstOperands,
     /*  425215 */     // GIR_Coverage, 5328,
     /*  425215 */     GIR_EraseRootFromParent_Done,
     /*  425216 */   // Label 7459: @425216
     /*  425216 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(425299), // Rule ID 5329 //
     /*  425221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  425235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425264 */     // MIs[1] Operand 1
     /*  425264 */     // No operand predicates
     /*  425264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425277 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425297 */     GIR_RootConstrainSelectedInstOperands,
     /*  425298 */     // GIR_Coverage, 5329,
     /*  425298 */     GIR_EraseRootFromParent_Done,
     /*  425299 */   // Label 7460: @425299
     /*  425299 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(425382), // Rule ID 5330 //
     /*  425304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  425318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425347 */     // MIs[1] Operand 1
     /*  425347 */     // No operand predicates
     /*  425347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  425360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425380 */     GIR_RootConstrainSelectedInstOperands,
     /*  425381 */     // GIR_Coverage, 5330,
     /*  425381 */     GIR_EraseRootFromParent_Done,
     /*  425382 */   // Label 7461: @425382
     /*  425382 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(425465), // Rule ID 5331 //
     /*  425387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  425398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  425401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  425407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425430 */     // MIs[1] Operand 1
     /*  425430 */     // No operand predicates
     /*  425430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425443 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  425443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425463 */     GIR_RootConstrainSelectedInstOperands,
     /*  425464 */     // GIR_Coverage, 5331,
     /*  425464 */     GIR_EraseRootFromParent_Done,
     /*  425465 */   // Label 7462: @425465
     /*  425465 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(425548), // Rule ID 5332 //
     /*  425470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  425484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425513 */     // MIs[1] Operand 1
     /*  425513 */     // No operand predicates
     /*  425513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  425526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425546 */     GIR_RootConstrainSelectedInstOperands,
     /*  425547 */     // GIR_Coverage, 5332,
     /*  425547 */     GIR_EraseRootFromParent_Done,
     /*  425548 */   // Label 7463: @425548
     /*  425548 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(425631), // Rule ID 5333 //
     /*  425553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  425567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425596 */     // MIs[1] Operand 1
     /*  425596 */     // No operand predicates
     /*  425596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425609 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  425609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  425612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425629 */     GIR_RootConstrainSelectedInstOperands,
     /*  425630 */     // GIR_Coverage, 5333,
     /*  425630 */     GIR_EraseRootFromParent_Done,
     /*  425631 */   // Label 7464: @425631
     /*  425631 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(425714), // Rule ID 5334 //
     /*  425636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  425650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425679 */     // MIs[1] Operand 1
     /*  425679 */     // No operand predicates
     /*  425679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  425692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425712 */     GIR_RootConstrainSelectedInstOperands,
     /*  425713 */     // GIR_Coverage, 5334,
     /*  425713 */     GIR_EraseRootFromParent_Done,
     /*  425714 */   // Label 7465: @425714
     /*  425714 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(425797), // Rule ID 5335 //
     /*  425719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  425730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  425733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  425739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425762 */     // MIs[1] Operand 1
     /*  425762 */     // No operand predicates
     /*  425762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  425775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  425795 */     GIR_RootConstrainSelectedInstOperands,
     /*  425796 */     // GIR_Coverage, 5335,
     /*  425796 */     GIR_EraseRootFromParent_Done,
     /*  425797 */   // Label 7466: @425797
     /*  425797 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(425880), // Rule ID 5336 //
     /*  425802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425845 */     // MIs[1] Operand 1
     /*  425845 */     // No operand predicates
     /*  425845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  425858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425878 */     GIR_RootConstrainSelectedInstOperands,
     /*  425879 */     // GIR_Coverage, 5336,
     /*  425879 */     GIR_EraseRootFromParent_Done,
     /*  425880 */   // Label 7467: @425880
     /*  425880 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(425963), // Rule ID 5337 //
     /*  425885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  425896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  425902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  425905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  425920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  425928 */     // MIs[1] Operand 1
     /*  425928 */     // No operand predicates
     /*  425928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  425932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425941 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  425941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  425944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  425948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  425951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  425953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425961 */     GIR_RootConstrainSelectedInstOperands,
     /*  425962 */     // GIR_Coverage, 5337,
     /*  425962 */     GIR_EraseRootFromParent_Done,
     /*  425963 */   // Label 7468: @425963
     /*  425963 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(426046), // Rule ID 5338 //
     /*  425968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  425976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  425979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  425982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  425985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  425988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426011 */     // MIs[1] Operand 1
     /*  426011 */     // No operand predicates
     /*  426011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426044 */     GIR_RootConstrainSelectedInstOperands,
     /*  426045 */     // GIR_Coverage, 5338,
     /*  426045 */     GIR_EraseRootFromParent_Done,
     /*  426046 */   // Label 7469: @426046
     /*  426046 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(426129), // Rule ID 5339 //
     /*  426051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  426062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  426065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  426071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426094 */     // MIs[1] Operand 1
     /*  426094 */     // No operand predicates
     /*  426094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426127 */     GIR_RootConstrainSelectedInstOperands,
     /*  426128 */     // GIR_Coverage, 5339,
     /*  426128 */     GIR_EraseRootFromParent_Done,
     /*  426129 */   // Label 7470: @426129
     /*  426129 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(426212), // Rule ID 5340 //
     /*  426134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  426145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  426154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426177 */     // MIs[1] Operand 1
     /*  426177 */     // No operand predicates
     /*  426177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  426190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426210 */     GIR_RootConstrainSelectedInstOperands,
     /*  426211 */     // GIR_Coverage, 5340,
     /*  426211 */     GIR_EraseRootFromParent_Done,
     /*  426212 */   // Label 7471: @426212
     /*  426212 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(426295), // Rule ID 5341 //
     /*  426217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  426228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  426231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  426237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426260 */     // MIs[1] Operand 1
     /*  426260 */     // No operand predicates
     /*  426260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426273 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  426273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426293 */     GIR_RootConstrainSelectedInstOperands,
     /*  426294 */     // GIR_Coverage, 5341,
     /*  426294 */     GIR_EraseRootFromParent_Done,
     /*  426295 */   // Label 7472: @426295
     /*  426295 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(426378), // Rule ID 5342 //
     /*  426300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  426311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  426320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426343 */     // MIs[1] Operand 1
     /*  426343 */     // No operand predicates
     /*  426343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  426356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426376 */     GIR_RootConstrainSelectedInstOperands,
     /*  426377 */     // GIR_Coverage, 5342,
     /*  426377 */     GIR_EraseRootFromParent_Done,
     /*  426378 */   // Label 7473: @426378
     /*  426378 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(426461), // Rule ID 5343 //
     /*  426383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  426394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  426397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  426403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426426 */     // MIs[1] Operand 1
     /*  426426 */     // No operand predicates
     /*  426426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426439 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  426439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426459 */     GIR_RootConstrainSelectedInstOperands,
     /*  426460 */     // GIR_Coverage, 5343,
     /*  426460 */     GIR_EraseRootFromParent_Done,
     /*  426461 */   // Label 7474: @426461
     /*  426461 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(426544), // Rule ID 5344 //
     /*  426466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  426469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  426477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  426486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426509 */     // MIs[1] Operand 1
     /*  426509 */     // No operand predicates
     /*  426509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  426522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426542 */     GIR_RootConstrainSelectedInstOperands,
     /*  426543 */     // GIR_Coverage, 5344,
     /*  426543 */     GIR_EraseRootFromParent_Done,
     /*  426544 */   // Label 7475: @426544
     /*  426544 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(426627), // Rule ID 5345 //
     /*  426549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  426552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  426560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  426563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  426569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426592 */     // MIs[1] Operand 1
     /*  426592 */     // No operand predicates
     /*  426592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  426605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  426608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  426625 */     GIR_RootConstrainSelectedInstOperands,
     /*  426626 */     // GIR_Coverage, 5345,
     /*  426626 */     GIR_EraseRootFromParent_Done,
     /*  426627 */   // Label 7476: @426627
     /*  426627 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(426710), // Rule ID 5346 //
     /*  426632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  426643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  426646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  426652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426675 */     // MIs[1] Operand 1
     /*  426675 */     // No operand predicates
     /*  426675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  426691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426708 */     GIR_RootConstrainSelectedInstOperands,
     /*  426709 */     // GIR_Coverage, 5346,
     /*  426709 */     GIR_EraseRootFromParent_Done,
     /*  426710 */   // Label 7477: @426710
     /*  426710 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(426793), // Rule ID 5347 //
     /*  426715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  426726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  426729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  426735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  426746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426758 */     // MIs[1] Operand 1
     /*  426758 */     // No operand predicates
     /*  426758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426771 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  426774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426791 */     GIR_RootConstrainSelectedInstOperands,
     /*  426792 */     // GIR_Coverage, 5347,
     /*  426792 */     GIR_EraseRootFromParent_Done,
     /*  426793 */   // Label 7478: @426793
     /*  426793 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(426876), // Rule ID 5348 //
     /*  426798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  426809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  426812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  426818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426841 */     // MIs[1] Operand 1
     /*  426841 */     // No operand predicates
     /*  426841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426854 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  426854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  426857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426874 */     GIR_RootConstrainSelectedInstOperands,
     /*  426875 */     // GIR_Coverage, 5348,
     /*  426875 */     GIR_EraseRootFromParent_Done,
     /*  426876 */   // Label 7479: @426876
     /*  426876 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(426959), // Rule ID 5349 //
     /*  426881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  426892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  426895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  426898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  426901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  426924 */     // MIs[1] Operand 1
     /*  426924 */     // No operand predicates
     /*  426924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  426928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426937 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  426937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  426940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  426944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  426947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  426949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426957 */     GIR_RootConstrainSelectedInstOperands,
     /*  426958 */     // GIR_Coverage, 5349,
     /*  426958 */     GIR_EraseRootFromParent_Done,
     /*  426959 */   // Label 7480: @426959
     /*  426959 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(427042), // Rule ID 5350 //
     /*  426964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  426972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  426975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  426978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  426981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  426984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  426999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427007 */     // MIs[1] Operand 1
     /*  427007 */     // No operand predicates
     /*  427007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427020 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  427020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427040 */     GIR_RootConstrainSelectedInstOperands,
     /*  427041 */     // GIR_Coverage, 5350,
     /*  427041 */     GIR_EraseRootFromParent_Done,
     /*  427042 */   // Label 7481: @427042
     /*  427042 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(427125), // Rule ID 5351 //
     /*  427047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  427058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  427061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  427067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427090 */     // MIs[1] Operand 1
     /*  427090 */     // No operand predicates
     /*  427090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427103 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  427103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427123 */     GIR_RootConstrainSelectedInstOperands,
     /*  427124 */     // GIR_Coverage, 5351,
     /*  427124 */     GIR_EraseRootFromParent_Done,
     /*  427125 */   // Label 7482: @427125
     /*  427125 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(427208), // Rule ID 5352 //
     /*  427130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427173 */     // MIs[1] Operand 1
     /*  427173 */     // No operand predicates
     /*  427173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427206 */     GIR_RootConstrainSelectedInstOperands,
     /*  427207 */     // GIR_Coverage, 5352,
     /*  427207 */     GIR_EraseRootFromParent_Done,
     /*  427208 */   // Label 7483: @427208
     /*  427208 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(427291), // Rule ID 5353 //
     /*  427213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  427227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427256 */     // MIs[1] Operand 1
     /*  427256 */     // No operand predicates
     /*  427256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427269 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427289 */     GIR_RootConstrainSelectedInstOperands,
     /*  427290 */     // GIR_Coverage, 5353,
     /*  427290 */     GIR_EraseRootFromParent_Done,
     /*  427291 */   // Label 7484: @427291
     /*  427291 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(427374), // Rule ID 5354 //
     /*  427296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427339 */     // MIs[1] Operand 1
     /*  427339 */     // No operand predicates
     /*  427339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427372 */     GIR_RootConstrainSelectedInstOperands,
     /*  427373 */     // GIR_Coverage, 5354,
     /*  427373 */     GIR_EraseRootFromParent_Done,
     /*  427374 */   // Label 7485: @427374
     /*  427374 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(427457), // Rule ID 5355 //
     /*  427379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  427393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427422 */     // MIs[1] Operand 1
     /*  427422 */     // No operand predicates
     /*  427422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427455 */     GIR_RootConstrainSelectedInstOperands,
     /*  427456 */     // GIR_Coverage, 5355,
     /*  427456 */     GIR_EraseRootFromParent_Done,
     /*  427457 */   // Label 7486: @427457
     /*  427457 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(427540), // Rule ID 5356 //
     /*  427462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  427473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  427482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427505 */     // MIs[1] Operand 1
     /*  427505 */     // No operand predicates
     /*  427505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  427518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427538 */     GIR_RootConstrainSelectedInstOperands,
     /*  427539 */     // GIR_Coverage, 5356,
     /*  427539 */     GIR_EraseRootFromParent_Done,
     /*  427540 */   // Label 7487: @427540
     /*  427540 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(427623), // Rule ID 5357 //
     /*  427545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  427556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  427559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  427565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427588 */     // MIs[1] Operand 1
     /*  427588 */     // No operand predicates
     /*  427588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427601 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  427601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  427604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427621 */     GIR_RootConstrainSelectedInstOperands,
     /*  427622 */     // GIR_Coverage, 5357,
     /*  427622 */     GIR_EraseRootFromParent_Done,
     /*  427623 */   // Label 7488: @427623
     /*  427623 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(427706), // Rule ID 5358 //
     /*  427628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  427639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  427648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427671 */     // MIs[1] Operand 1
     /*  427671 */     // No operand predicates
     /*  427671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  427684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427704 */     GIR_RootConstrainSelectedInstOperands,
     /*  427705 */     // GIR_Coverage, 5358,
     /*  427705 */     GIR_EraseRootFromParent_Done,
     /*  427706 */   // Label 7489: @427706
     /*  427706 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(427789), // Rule ID 5359 //
     /*  427711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  427722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  427725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  427731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427754 */     // MIs[1] Operand 1
     /*  427754 */     // No operand predicates
     /*  427754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427767 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  427767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  427770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427787 */     GIR_RootConstrainSelectedInstOperands,
     /*  427788 */     // GIR_Coverage, 5359,
     /*  427788 */     GIR_EraseRootFromParent_Done,
     /*  427789 */   // Label 7490: @427789
     /*  427789 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(427872), // Rule ID 5360 //
     /*  427794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427837 */     // MIs[1] Operand 1
     /*  427837 */     // No operand predicates
     /*  427837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427850 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  427850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427870 */     GIR_RootConstrainSelectedInstOperands,
     /*  427871 */     // GIR_Coverage, 5360,
     /*  427871 */     GIR_EraseRootFromParent_Done,
     /*  427872 */   // Label 7491: @427872
     /*  427872 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(427955), // Rule ID 5361 //
     /*  427877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  427888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  427891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  427894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  427897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  427920 */     // MIs[1] Operand 1
     /*  427920 */     // No operand predicates
     /*  427920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  427924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427933 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  427933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  427936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  427940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  427943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  427945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427953 */     GIR_RootConstrainSelectedInstOperands,
     /*  427954 */     // GIR_Coverage, 5361,
     /*  427954 */     GIR_EraseRootFromParent_Done,
     /*  427955 */   // Label 7492: @427955
     /*  427955 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(428038), // Rule ID 5362 //
     /*  427960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  427968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  427971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  427974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  427977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  427980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  427995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428003 */     // MIs[1] Operand 1
     /*  428003 */     // No operand predicates
     /*  428003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  428016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428036 */     GIR_RootConstrainSelectedInstOperands,
     /*  428037 */     // GIR_Coverage, 5362,
     /*  428037 */     GIR_EraseRootFromParent_Done,
     /*  428038 */   // Label 7493: @428038
     /*  428038 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(428121), // Rule ID 5363 //
     /*  428043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  428054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  428057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  428063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428086 */     // MIs[1] Operand 1
     /*  428086 */     // No operand predicates
     /*  428086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428099 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  428099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428119 */     GIR_RootConstrainSelectedInstOperands,
     /*  428120 */     // GIR_Coverage, 5363,
     /*  428120 */     GIR_EraseRootFromParent_Done,
     /*  428121 */   // Label 7494: @428121
     /*  428121 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(428204), // Rule ID 5364 //
     /*  428126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  428137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  428140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  428146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428169 */     // MIs[1] Operand 1
     /*  428169 */     // No operand predicates
     /*  428169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428182 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  428185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428202 */     GIR_RootConstrainSelectedInstOperands,
     /*  428203 */     // GIR_Coverage, 5364,
     /*  428203 */     GIR_EraseRootFromParent_Done,
     /*  428204 */   // Label 7495: @428204
     /*  428204 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(428287), // Rule ID 5365 //
     /*  428209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  428220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  428223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  428229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428252 */     // MIs[1] Operand 1
     /*  428252 */     // No operand predicates
     /*  428252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428265 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  428268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428285 */     GIR_RootConstrainSelectedInstOperands,
     /*  428286 */     // GIR_Coverage, 5365,
     /*  428286 */     GIR_EraseRootFromParent_Done,
     /*  428287 */   // Label 7496: @428287
     /*  428287 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(428370), // Rule ID 5366 //
     /*  428292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  428303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  428306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  428312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428335 */     // MIs[1] Operand 1
     /*  428335 */     // No operand predicates
     /*  428335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428348 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  428351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428368 */     GIR_RootConstrainSelectedInstOperands,
     /*  428369 */     // GIR_Coverage, 5366,
     /*  428369 */     GIR_EraseRootFromParent_Done,
     /*  428370 */   // Label 7497: @428370
     /*  428370 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(428453), // Rule ID 5367 //
     /*  428375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  428386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  428389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  428395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428418 */     // MIs[1] Operand 1
     /*  428418 */     // No operand predicates
     /*  428418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  428434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428451 */     GIR_RootConstrainSelectedInstOperands,
     /*  428452 */     // GIR_Coverage, 5367,
     /*  428452 */     GIR_EraseRootFromParent_Done,
     /*  428453 */   // Label 7498: @428453
     /*  428453 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(428536), // Rule ID 5368 //
     /*  428458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  428461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  428469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  428475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  428478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428501 */     // MIs[1] Operand 1
     /*  428501 */     // No operand predicates
     /*  428501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428514 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  428514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428534 */     GIR_RootConstrainSelectedInstOperands,
     /*  428535 */     // GIR_Coverage, 5368,
     /*  428535 */     GIR_EraseRootFromParent_Done,
     /*  428536 */   // Label 7499: @428536
     /*  428536 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(428619), // Rule ID 5369 //
     /*  428541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  428544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  428549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  428552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  428555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  428558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  428561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  428576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  428584 */     // MIs[1] Operand 1
     /*  428584 */     // No operand predicates
     /*  428584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  428588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428597 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  428597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  428600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  428604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  428607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  428609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428617 */     GIR_RootConstrainSelectedInstOperands,
     /*  428618 */     // GIR_Coverage, 5369,
     /*  428618 */     GIR_EraseRootFromParent_Done,
     /*  428619 */   // Label 7500: @428619
     /*  428619 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(428695), // Rule ID 60602 //
     /*  428624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428656 */     // MIs[0] rs2
     /*  428656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  428674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428693 */     GIR_RootConstrainSelectedInstOperands,
     /*  428694 */     // GIR_Coverage, 60602,
     /*  428694 */     GIR_EraseRootFromParent_Done,
     /*  428695 */   // Label 7501: @428695
     /*  428695 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(428771), // Rule ID 60603 //
     /*  428700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  428703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  428711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  428714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  428717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428732 */     // MIs[0] rs2
     /*  428732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428747 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  428750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428769 */     GIR_RootConstrainSelectedInstOperands,
     /*  428770 */     // GIR_Coverage, 60603,
     /*  428770 */     GIR_EraseRootFromParent_Done,
     /*  428771 */   // Label 7502: @428771
     /*  428771 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(428847), // Rule ID 62248 //
     /*  428776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428808 */     // MIs[0] rs2
     /*  428808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428823 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  428826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428845 */     GIR_RootConstrainSelectedInstOperands,
     /*  428846 */     // GIR_Coverage, 62248,
     /*  428846 */     GIR_EraseRootFromParent_Done,
     /*  428847 */   // Label 7503: @428847
     /*  428847 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(428923), // Rule ID 62249 //
     /*  428852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  428855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  428863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  428866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  428869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428884 */     // MIs[0] rs2
     /*  428884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  428902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428921 */     GIR_RootConstrainSelectedInstOperands,
     /*  428922 */     // GIR_Coverage, 62249,
     /*  428922 */     GIR_EraseRootFromParent_Done,
     /*  428923 */   // Label 7504: @428923
     /*  428923 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(428999), // Rule ID 62250 //
     /*  428928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  428931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  428936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  428939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  428942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  428945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428960 */     // MIs[0] rs2
     /*  428960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  428963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  428968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  428978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  428986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428997 */     GIR_RootConstrainSelectedInstOperands,
     /*  428998 */     // GIR_Coverage, 62250,
     /*  428998 */     GIR_EraseRootFromParent_Done,
     /*  428999 */   // Label 7505: @428999
     /*  428999 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(429075), // Rule ID 62251 //
     /*  429004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429036 */     // MIs[0] rs2
     /*  429036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  429054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429073 */     GIR_RootConstrainSelectedInstOperands,
     /*  429074 */     // GIR_Coverage, 62251,
     /*  429074 */     GIR_EraseRootFromParent_Done,
     /*  429075 */   // Label 7506: @429075
     /*  429075 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(429151), // Rule ID 62252 //
     /*  429080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  429083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429112 */     // MIs[0] rs2
     /*  429112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429127 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  429130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429149 */     GIR_RootConstrainSelectedInstOperands,
     /*  429150 */     // GIR_Coverage, 62252,
     /*  429150 */     GIR_EraseRootFromParent_Done,
     /*  429151 */   // Label 7507: @429151
     /*  429151 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(429227), // Rule ID 62253 //
     /*  429156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429188 */     // MIs[0] rs2
     /*  429188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  429206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429225 */     GIR_RootConstrainSelectedInstOperands,
     /*  429226 */     // GIR_Coverage, 62253,
     /*  429226 */     GIR_EraseRootFromParent_Done,
     /*  429227 */   // Label 7508: @429227
     /*  429227 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(429303), // Rule ID 62254 //
     /*  429232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  429235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429264 */     // MIs[0] rs2
     /*  429264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429279 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  429282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429301 */     GIR_RootConstrainSelectedInstOperands,
     /*  429302 */     // GIR_Coverage, 62254,
     /*  429302 */     GIR_EraseRootFromParent_Done,
     /*  429303 */   // Label 7509: @429303
     /*  429303 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(429379), // Rule ID 62255 //
     /*  429308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  429311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  429316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429340 */     // MIs[0] rs2
     /*  429340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429355 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  429358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429377 */     GIR_RootConstrainSelectedInstOperands,
     /*  429378 */     // GIR_Coverage, 62255,
     /*  429378 */     GIR_EraseRootFromParent_Done,
     /*  429379 */   // Label 7510: @429379
     /*  429379 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(429455), // Rule ID 62376 //
     /*  429384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  429395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  429398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  429401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429416 */     // MIs[0] rs2
     /*  429416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  429434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429453 */     GIR_RootConstrainSelectedInstOperands,
     /*  429454 */     // GIR_Coverage, 62376,
     /*  429454 */     GIR_EraseRootFromParent_Done,
     /*  429455 */   // Label 7511: @429455
     /*  429455 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(429531), // Rule ID 62377 //
     /*  429460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  429471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  429474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  429477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429492 */     // MIs[0] rs2
     /*  429492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429495 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429507 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  429510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429529 */     GIR_RootConstrainSelectedInstOperands,
     /*  429530 */     // GIR_Coverage, 62377,
     /*  429530 */     GIR_EraseRootFromParent_Done,
     /*  429531 */   // Label 7512: @429531
     /*  429531 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(429607), // Rule ID 62378 //
     /*  429536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  429547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  429550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  429553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429568 */     // MIs[0] rs2
     /*  429568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  429586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429605 */     GIR_RootConstrainSelectedInstOperands,
     /*  429606 */     // GIR_Coverage, 62378,
     /*  429606 */     GIR_EraseRootFromParent_Done,
     /*  429607 */   // Label 7513: @429607
     /*  429607 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(429683), // Rule ID 62379 //
     /*  429612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  429623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  429626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  429629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429644 */     // MIs[0] rs2
     /*  429644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  429662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429681 */     GIR_RootConstrainSelectedInstOperands,
     /*  429682 */     // GIR_Coverage, 62379,
     /*  429682 */     GIR_EraseRootFromParent_Done,
     /*  429683 */   // Label 7514: @429683
     /*  429683 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(429759), // Rule ID 62380 //
     /*  429688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429720 */     // MIs[0] rs2
     /*  429720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  429738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429757 */     GIR_RootConstrainSelectedInstOperands,
     /*  429758 */     // GIR_Coverage, 62380,
     /*  429758 */     GIR_EraseRootFromParent_Done,
     /*  429759 */   // Label 7515: @429759
     /*  429759 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(429835), // Rule ID 62381 //
     /*  429764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429796 */     // MIs[0] rs2
     /*  429796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11497:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  429814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429833 */     GIR_RootConstrainSelectedInstOperands,
     /*  429834 */     // GIR_Coverage, 62381,
     /*  429834 */     GIR_EraseRootFromParent_Done,
     /*  429835 */   // Label 7516: @429835
     /*  429835 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(429911), // Rule ID 62382 //
     /*  429840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429872 */     // MIs[0] rs2
     /*  429872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429887 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  429890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429909 */     GIR_RootConstrainSelectedInstOperands,
     /*  429910 */     // GIR_Coverage, 62382,
     /*  429910 */     GIR_EraseRootFromParent_Done,
     /*  429911 */   // Label 7517: @429911
     /*  429911 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(429987), // Rule ID 62383 //
     /*  429916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  429919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  429924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429948 */     // MIs[0] rs2
     /*  429948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  429951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  429956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11497:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  429966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  429974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429985 */     GIR_RootConstrainSelectedInstOperands,
     /*  429986 */     // GIR_Coverage, 62383,
     /*  429986 */     GIR_EraseRootFromParent_Done,
     /*  429987 */   // Label 7518: @429987
     /*  429987 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(430063), // Rule ID 62384 //
     /*  429992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  429995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  430000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430024 */     // MIs[0] rs2
     /*  430024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  430032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  430039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  430042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  430050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430061 */     GIR_RootConstrainSelectedInstOperands,
     /*  430062 */     // GIR_Coverage, 62384,
     /*  430062 */     GIR_EraseRootFromParent_Done,
     /*  430063 */   // Label 7519: @430063
     /*  430063 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(430139), // Rule ID 62385 //
     /*  430068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  430071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  430076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  430079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  430082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  430085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430100 */     // MIs[0] rs2
     /*  430100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  430103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  430108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430115 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11497:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  430118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  430126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430137 */     GIR_RootConstrainSelectedInstOperands,
     /*  430138 */     // GIR_Coverage, 62385,
     /*  430138 */     GIR_EraseRootFromParent_Done,
     /*  430139 */   // Label 7520: @430139
     /*  430139 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(430227), // Rule ID 2788 //
     /*  430144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430191 */     // MIs[1] Operand 1
     /*  430191 */     // No operand predicates
     /*  430191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430209 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430225 */     GIR_RootConstrainSelectedInstOperands,
     /*  430226 */     // GIR_Coverage, 2788,
     /*  430226 */     GIR_EraseRootFromParent_Done,
     /*  430227 */   // Label 7521: @430227
     /*  430227 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(430315), // Rule ID 2789 //
     /*  430232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430279 */     // MIs[1] Operand 1
     /*  430279 */     // No operand predicates
     /*  430279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430288 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430297 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430313 */     GIR_RootConstrainSelectedInstOperands,
     /*  430314 */     // GIR_Coverage, 2789,
     /*  430314 */     GIR_EraseRootFromParent_Done,
     /*  430315 */   // Label 7522: @430315
     /*  430315 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(430403), // Rule ID 2796 //
     /*  430320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430367 */     // MIs[1] Operand 1
     /*  430367 */     // No operand predicates
     /*  430367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430385 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430401 */     GIR_RootConstrainSelectedInstOperands,
     /*  430402 */     // GIR_Coverage, 2796,
     /*  430402 */     GIR_EraseRootFromParent_Done,
     /*  430403 */   // Label 7523: @430403
     /*  430403 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(430491), // Rule ID 2797 //
     /*  430408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430455 */     // MIs[1] Operand 1
     /*  430455 */     // No operand predicates
     /*  430455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430473 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430489 */     GIR_RootConstrainSelectedInstOperands,
     /*  430490 */     // GIR_Coverage, 2797,
     /*  430490 */     GIR_EraseRootFromParent_Done,
     /*  430491 */   // Label 7524: @430491
     /*  430491 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(430579), // Rule ID 2804 //
     /*  430496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430543 */     // MIs[1] Operand 1
     /*  430543 */     // No operand predicates
     /*  430543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430561 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430577 */     GIR_RootConstrainSelectedInstOperands,
     /*  430578 */     // GIR_Coverage, 2804,
     /*  430578 */     GIR_EraseRootFromParent_Done,
     /*  430579 */   // Label 7525: @430579
     /*  430579 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(430667), // Rule ID 2805 //
     /*  430584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430631 */     // MIs[1] Operand 1
     /*  430631 */     // No operand predicates
     /*  430631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430649 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430665 */     GIR_RootConstrainSelectedInstOperands,
     /*  430666 */     // GIR_Coverage, 2805,
     /*  430666 */     GIR_EraseRootFromParent_Done,
     /*  430667 */   // Label 7526: @430667
     /*  430667 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(430755), // Rule ID 2812 //
     /*  430672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430719 */     // MIs[1] Operand 1
     /*  430719 */     // No operand predicates
     /*  430719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430737 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430753 */     GIR_RootConstrainSelectedInstOperands,
     /*  430754 */     // GIR_Coverage, 2812,
     /*  430754 */     GIR_EraseRootFromParent_Done,
     /*  430755 */   // Label 7527: @430755
     /*  430755 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(430843), // Rule ID 2813 //
     /*  430760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430807 */     // MIs[1] Operand 1
     /*  430807 */     // No operand predicates
     /*  430807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430825 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430841 */     GIR_RootConstrainSelectedInstOperands,
     /*  430842 */     // GIR_Coverage, 2813,
     /*  430842 */     GIR_EraseRootFromParent_Done,
     /*  430843 */   // Label 7528: @430843
     /*  430843 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(430931), // Rule ID 2820 //
     /*  430848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430895 */     // MIs[1] Operand 1
     /*  430895 */     // No operand predicates
     /*  430895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430913 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430929 */     GIR_RootConstrainSelectedInstOperands,
     /*  430930 */     // GIR_Coverage, 2820,
     /*  430930 */     GIR_EraseRootFromParent_Done,
     /*  430931 */   // Label 7529: @430931
     /*  430931 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(431019), // Rule ID 2821 //
     /*  430936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430983 */     // MIs[1] Operand 1
     /*  430983 */     // No operand predicates
     /*  430983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431001 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431017 */     GIR_RootConstrainSelectedInstOperands,
     /*  431018 */     // GIR_Coverage, 2821,
     /*  431018 */     GIR_EraseRootFromParent_Done,
     /*  431019 */   // Label 7530: @431019
     /*  431019 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(431107), // Rule ID 2828 //
     /*  431024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431071 */     // MIs[1] Operand 1
     /*  431071 */     // No operand predicates
     /*  431071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431080 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431089 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431105 */     GIR_RootConstrainSelectedInstOperands,
     /*  431106 */     // GIR_Coverage, 2828,
     /*  431106 */     GIR_EraseRootFromParent_Done,
     /*  431107 */   // Label 7531: @431107
     /*  431107 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(431195), // Rule ID 2829 //
     /*  431112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431159 */     // MIs[1] Operand 1
     /*  431159 */     // No operand predicates
     /*  431159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431177 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431193 */     GIR_RootConstrainSelectedInstOperands,
     /*  431194 */     // GIR_Coverage, 2829,
     /*  431194 */     GIR_EraseRootFromParent_Done,
     /*  431195 */   // Label 7532: @431195
     /*  431195 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(431283), // Rule ID 2836 //
     /*  431200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431247 */     // MIs[1] Operand 1
     /*  431247 */     // No operand predicates
     /*  431247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431256 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431265 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431281 */     GIR_RootConstrainSelectedInstOperands,
     /*  431282 */     // GIR_Coverage, 2836,
     /*  431282 */     GIR_EraseRootFromParent_Done,
     /*  431283 */   // Label 7533: @431283
     /*  431283 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(431371), // Rule ID 2837 //
     /*  431288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431335 */     // MIs[1] Operand 1
     /*  431335 */     // No operand predicates
     /*  431335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431353 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431369 */     GIR_RootConstrainSelectedInstOperands,
     /*  431370 */     // GIR_Coverage, 2837,
     /*  431370 */     GIR_EraseRootFromParent_Done,
     /*  431371 */   // Label 7534: @431371
     /*  431371 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(431459), // Rule ID 2844 //
     /*  431376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431423 */     // MIs[1] Operand 1
     /*  431423 */     // No operand predicates
     /*  431423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431441 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431457 */     GIR_RootConstrainSelectedInstOperands,
     /*  431458 */     // GIR_Coverage, 2844,
     /*  431458 */     GIR_EraseRootFromParent_Done,
     /*  431459 */   // Label 7535: @431459
     /*  431459 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(431547), // Rule ID 2845 //
     /*  431464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431511 */     // MIs[1] Operand 1
     /*  431511 */     // No operand predicates
     /*  431511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431529 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431545 */     GIR_RootConstrainSelectedInstOperands,
     /*  431546 */     // GIR_Coverage, 2845,
     /*  431546 */     GIR_EraseRootFromParent_Done,
     /*  431547 */   // Label 7536: @431547
     /*  431547 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(431635), // Rule ID 2852 //
     /*  431552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431599 */     // MIs[1] Operand 1
     /*  431599 */     // No operand predicates
     /*  431599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431617 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431633 */     GIR_RootConstrainSelectedInstOperands,
     /*  431634 */     // GIR_Coverage, 2852,
     /*  431634 */     GIR_EraseRootFromParent_Done,
     /*  431635 */   // Label 7537: @431635
     /*  431635 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(431723), // Rule ID 2853 //
     /*  431640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431687 */     // MIs[1] Operand 1
     /*  431687 */     // No operand predicates
     /*  431687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431705 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431721 */     GIR_RootConstrainSelectedInstOperands,
     /*  431722 */     // GIR_Coverage, 2853,
     /*  431722 */     GIR_EraseRootFromParent_Done,
     /*  431723 */   // Label 7538: @431723
     /*  431723 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(431811), // Rule ID 2860 //
     /*  431728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  431731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431775 */     // MIs[1] Operand 1
     /*  431775 */     // No operand predicates
     /*  431775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431793 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431809 */     GIR_RootConstrainSelectedInstOperands,
     /*  431810 */     // GIR_Coverage, 2860,
     /*  431810 */     GIR_EraseRootFromParent_Done,
     /*  431811 */   // Label 7539: @431811
     /*  431811 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(431899), // Rule ID 2861 //
     /*  431816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  431819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431863 */     // MIs[1] Operand 1
     /*  431863 */     // No operand predicates
     /*  431863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431881 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431897 */     GIR_RootConstrainSelectedInstOperands,
     /*  431898 */     // GIR_Coverage, 2861,
     /*  431898 */     GIR_EraseRootFromParent_Done,
     /*  431899 */   // Label 7540: @431899
     /*  431899 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(431987), // Rule ID 2868 //
     /*  431904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  431912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  431951 */     // MIs[1] Operand 1
     /*  431951 */     // No operand predicates
     /*  431951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  431974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431985 */     GIR_RootConstrainSelectedInstOperands,
     /*  431986 */     // GIR_Coverage, 2868,
     /*  431986 */     GIR_EraseRootFromParent_Done,
     /*  431987 */   // Label 7541: @431987
     /*  431987 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(432075), // Rule ID 2869 //
     /*  431992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  432003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  432006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  432009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432039 */     // MIs[1] Operand 1
     /*  432039 */     // No operand predicates
     /*  432039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432057 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432073 */     GIR_RootConstrainSelectedInstOperands,
     /*  432074 */     // GIR_Coverage, 2869,
     /*  432074 */     GIR_EraseRootFromParent_Done,
     /*  432075 */   // Label 7542: @432075
     /*  432075 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(432163), // Rule ID 2876 //
     /*  432080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432127 */     // MIs[1] Operand 1
     /*  432127 */     // No operand predicates
     /*  432127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432161 */     GIR_RootConstrainSelectedInstOperands,
     /*  432162 */     // GIR_Coverage, 2876,
     /*  432162 */     GIR_EraseRootFromParent_Done,
     /*  432163 */   // Label 7543: @432163
     /*  432163 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(432251), // Rule ID 2877 //
     /*  432168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432215 */     // MIs[1] Operand 1
     /*  432215 */     // No operand predicates
     /*  432215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432233 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432249 */     GIR_RootConstrainSelectedInstOperands,
     /*  432250 */     // GIR_Coverage, 2877,
     /*  432250 */     GIR_EraseRootFromParent_Done,
     /*  432251 */   // Label 7544: @432251
     /*  432251 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(432339), // Rule ID 2884 //
     /*  432256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432303 */     // MIs[1] Operand 1
     /*  432303 */     // No operand predicates
     /*  432303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432321 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432337 */     GIR_RootConstrainSelectedInstOperands,
     /*  432338 */     // GIR_Coverage, 2884,
     /*  432338 */     GIR_EraseRootFromParent_Done,
     /*  432339 */   // Label 7545: @432339
     /*  432339 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(432427), // Rule ID 2885 //
     /*  432344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432391 */     // MIs[1] Operand 1
     /*  432391 */     // No operand predicates
     /*  432391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432409 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432425 */     GIR_RootConstrainSelectedInstOperands,
     /*  432426 */     // GIR_Coverage, 2885,
     /*  432426 */     GIR_EraseRootFromParent_Done,
     /*  432427 */   // Label 7546: @432427
     /*  432427 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(432515), // Rule ID 2892 //
     /*  432432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432479 */     // MIs[1] Operand 1
     /*  432479 */     // No operand predicates
     /*  432479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432497 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432513 */     GIR_RootConstrainSelectedInstOperands,
     /*  432514 */     // GIR_Coverage, 2892,
     /*  432514 */     GIR_EraseRootFromParent_Done,
     /*  432515 */   // Label 7547: @432515
     /*  432515 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(432603), // Rule ID 2893 //
     /*  432520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432567 */     // MIs[1] Operand 1
     /*  432567 */     // No operand predicates
     /*  432567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432585 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432601 */     GIR_RootConstrainSelectedInstOperands,
     /*  432602 */     // GIR_Coverage, 2893,
     /*  432602 */     GIR_EraseRootFromParent_Done,
     /*  432603 */   // Label 7548: @432603
     /*  432603 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(432691), // Rule ID 2900 //
     /*  432608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432655 */     // MIs[1] Operand 1
     /*  432655 */     // No operand predicates
     /*  432655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432673 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432689 */     GIR_RootConstrainSelectedInstOperands,
     /*  432690 */     // GIR_Coverage, 2900,
     /*  432690 */     GIR_EraseRootFromParent_Done,
     /*  432691 */   // Label 7549: @432691
     /*  432691 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(432779), // Rule ID 2901 //
     /*  432696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432743 */     // MIs[1] Operand 1
     /*  432743 */     // No operand predicates
     /*  432743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432761 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432777 */     GIR_RootConstrainSelectedInstOperands,
     /*  432778 */     // GIR_Coverage, 2901,
     /*  432778 */     GIR_EraseRootFromParent_Done,
     /*  432779 */   // Label 7550: @432779
     /*  432779 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(432867), // Rule ID 2908 //
     /*  432784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432831 */     // MIs[1] Operand 1
     /*  432831 */     // No operand predicates
     /*  432831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432840 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432865 */     GIR_RootConstrainSelectedInstOperands,
     /*  432866 */     // GIR_Coverage, 2908,
     /*  432866 */     GIR_EraseRootFromParent_Done,
     /*  432867 */   // Label 7551: @432867
     /*  432867 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(432955), // Rule ID 2909 //
     /*  432872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  432919 */     // MIs[1] Operand 1
     /*  432919 */     // No operand predicates
     /*  432919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432937 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432953 */     GIR_RootConstrainSelectedInstOperands,
     /*  432954 */     // GIR_Coverage, 2909,
     /*  432954 */     GIR_EraseRootFromParent_Done,
     /*  432955 */   // Label 7552: @432955
     /*  432955 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(433043), // Rule ID 2916 //
     /*  432960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  432968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433007 */     // MIs[1] Operand 1
     /*  433007 */     // No operand predicates
     /*  433007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433025 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433041 */     GIR_RootConstrainSelectedInstOperands,
     /*  433042 */     // GIR_Coverage, 2916,
     /*  433042 */     GIR_EraseRootFromParent_Done,
     /*  433043 */   // Label 7553: @433043
     /*  433043 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(433131), // Rule ID 2917 //
     /*  433048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433095 */     // MIs[1] Operand 1
     /*  433095 */     // No operand predicates
     /*  433095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433113 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433129 */     GIR_RootConstrainSelectedInstOperands,
     /*  433130 */     // GIR_Coverage, 2917,
     /*  433130 */     GIR_EraseRootFromParent_Done,
     /*  433131 */   // Label 7554: @433131
     /*  433131 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(433219), // Rule ID 2924 //
     /*  433136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433183 */     // MIs[1] Operand 1
     /*  433183 */     // No operand predicates
     /*  433183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433201 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433217 */     GIR_RootConstrainSelectedInstOperands,
     /*  433218 */     // GIR_Coverage, 2924,
     /*  433218 */     GIR_EraseRootFromParent_Done,
     /*  433219 */   // Label 7555: @433219
     /*  433219 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(433307), // Rule ID 2925 //
     /*  433224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433271 */     // MIs[1] Operand 1
     /*  433271 */     // No operand predicates
     /*  433271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433289 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433305 */     GIR_RootConstrainSelectedInstOperands,
     /*  433306 */     // GIR_Coverage, 2925,
     /*  433306 */     GIR_EraseRootFromParent_Done,
     /*  433307 */   // Label 7556: @433307
     /*  433307 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(433395), // Rule ID 2932 //
     /*  433312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433359 */     // MIs[1] Operand 1
     /*  433359 */     // No operand predicates
     /*  433359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433377 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433393 */     GIR_RootConstrainSelectedInstOperands,
     /*  433394 */     // GIR_Coverage, 2932,
     /*  433394 */     GIR_EraseRootFromParent_Done,
     /*  433395 */   // Label 7557: @433395
     /*  433395 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(433483), // Rule ID 2933 //
     /*  433400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433447 */     // MIs[1] Operand 1
     /*  433447 */     // No operand predicates
     /*  433447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433465 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433481 */     GIR_RootConstrainSelectedInstOperands,
     /*  433482 */     // GIR_Coverage, 2933,
     /*  433482 */     GIR_EraseRootFromParent_Done,
     /*  433483 */   // Label 7558: @433483
     /*  433483 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(433571), // Rule ID 2940 //
     /*  433488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433535 */     // MIs[1] Operand 1
     /*  433535 */     // No operand predicates
     /*  433535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433553 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433569 */     GIR_RootConstrainSelectedInstOperands,
     /*  433570 */     // GIR_Coverage, 2940,
     /*  433570 */     GIR_EraseRootFromParent_Done,
     /*  433571 */   // Label 7559: @433571
     /*  433571 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(433659), // Rule ID 2941 //
     /*  433576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433623 */     // MIs[1] Operand 1
     /*  433623 */     // No operand predicates
     /*  433623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433641 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433657 */     GIR_RootConstrainSelectedInstOperands,
     /*  433658 */     // GIR_Coverage, 2941,
     /*  433658 */     GIR_EraseRootFromParent_Done,
     /*  433659 */   // Label 7560: @433659
     /*  433659 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(433747), // Rule ID 2948 //
     /*  433664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433711 */     // MIs[1] Operand 1
     /*  433711 */     // No operand predicates
     /*  433711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433729 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433745 */     GIR_RootConstrainSelectedInstOperands,
     /*  433746 */     // GIR_Coverage, 2948,
     /*  433746 */     GIR_EraseRootFromParent_Done,
     /*  433747 */   // Label 7561: @433747
     /*  433747 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(433835), // Rule ID 2949 //
     /*  433752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433799 */     // MIs[1] Operand 1
     /*  433799 */     // No operand predicates
     /*  433799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433817 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433833 */     GIR_RootConstrainSelectedInstOperands,
     /*  433834 */     // GIR_Coverage, 2949,
     /*  433834 */     GIR_EraseRootFromParent_Done,
     /*  433835 */   // Label 7562: @433835
     /*  433835 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(433923), // Rule ID 2956 //
     /*  433840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433887 */     // MIs[1] Operand 1
     /*  433887 */     // No operand predicates
     /*  433887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433896 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433905 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433921 */     GIR_RootConstrainSelectedInstOperands,
     /*  433922 */     // GIR_Coverage, 2956,
     /*  433922 */     GIR_EraseRootFromParent_Done,
     /*  433923 */   // Label 7563: @433923
     /*  433923 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(434011), // Rule ID 2957 //
     /*  433928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  433936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  433975 */     // MIs[1] Operand 1
     /*  433975 */     // No operand predicates
     /*  433975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433993 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  433998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  434006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434009 */     GIR_RootConstrainSelectedInstOperands,
     /*  434010 */     // GIR_Coverage, 2957,
     /*  434010 */     GIR_EraseRootFromParent_Done,
     /*  434011 */   // Label 7564: @434011
     /*  434011 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(434097), // Rule ID 3140 //
     /*  434016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434063 */     // MIs[1] Operand 1
     /*  434063 */     // No operand predicates
     /*  434063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  434075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434095 */     GIR_RootConstrainSelectedInstOperands,
     /*  434096 */     // GIR_Coverage, 3140,
     /*  434096 */     GIR_EraseRootFromParent_Done,
     /*  434097 */   // Label 7565: @434097
     /*  434097 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(434183), // Rule ID 3141 //
     /*  434102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434149 */     // MIs[1] Operand 1
     /*  434149 */     // No operand predicates
     /*  434149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  434161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434181 */     GIR_RootConstrainSelectedInstOperands,
     /*  434182 */     // GIR_Coverage, 3141,
     /*  434182 */     GIR_EraseRootFromParent_Done,
     /*  434183 */   // Label 7566: @434183
     /*  434183 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(434269), // Rule ID 3144 //
     /*  434188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434235 */     // MIs[1] Operand 1
     /*  434235 */     // No operand predicates
     /*  434235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434244 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434267 */     GIR_RootConstrainSelectedInstOperands,
     /*  434268 */     // GIR_Coverage, 3144,
     /*  434268 */     GIR_EraseRootFromParent_Done,
     /*  434269 */   // Label 7567: @434269
     /*  434269 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(434355), // Rule ID 3145 //
     /*  434274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434321 */     // MIs[1] Operand 1
     /*  434321 */     // No operand predicates
     /*  434321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434353 */     GIR_RootConstrainSelectedInstOperands,
     /*  434354 */     // GIR_Coverage, 3145,
     /*  434354 */     GIR_EraseRootFromParent_Done,
     /*  434355 */   // Label 7568: @434355
     /*  434355 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(434441), // Rule ID 3148 //
     /*  434360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434407 */     // MIs[1] Operand 1
     /*  434407 */     // No operand predicates
     /*  434407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434439 */     GIR_RootConstrainSelectedInstOperands,
     /*  434440 */     // GIR_Coverage, 3148,
     /*  434440 */     GIR_EraseRootFromParent_Done,
     /*  434441 */   // Label 7569: @434441
     /*  434441 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(434527), // Rule ID 3149 //
     /*  434446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434493 */     // MIs[1] Operand 1
     /*  434493 */     // No operand predicates
     /*  434493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434502 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434525 */     GIR_RootConstrainSelectedInstOperands,
     /*  434526 */     // GIR_Coverage, 3149,
     /*  434526 */     GIR_EraseRootFromParent_Done,
     /*  434527 */   // Label 7570: @434527
     /*  434527 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(434613), // Rule ID 3152 //
     /*  434532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434579 */     // MIs[1] Operand 1
     /*  434579 */     // No operand predicates
     /*  434579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434611 */     GIR_RootConstrainSelectedInstOperands,
     /*  434612 */     // GIR_Coverage, 3152,
     /*  434612 */     GIR_EraseRootFromParent_Done,
     /*  434613 */   // Label 7571: @434613
     /*  434613 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(434699), // Rule ID 3153 //
     /*  434618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434665 */     // MIs[1] Operand 1
     /*  434665 */     // No operand predicates
     /*  434665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  434677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434697 */     GIR_RootConstrainSelectedInstOperands,
     /*  434698 */     // GIR_Coverage, 3153,
     /*  434698 */     GIR_EraseRootFromParent_Done,
     /*  434699 */   // Label 7572: @434699
     /*  434699 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(434785), // Rule ID 3156 //
     /*  434704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434751 */     // MIs[1] Operand 1
     /*  434751 */     // No operand predicates
     /*  434751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434783 */     GIR_RootConstrainSelectedInstOperands,
     /*  434784 */     // GIR_Coverage, 3156,
     /*  434784 */     GIR_EraseRootFromParent_Done,
     /*  434785 */   // Label 7573: @434785
     /*  434785 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(434871), // Rule ID 3157 //
     /*  434790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434837 */     // MIs[1] Operand 1
     /*  434837 */     // No operand predicates
     /*  434837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434869 */     GIR_RootConstrainSelectedInstOperands,
     /*  434870 */     // GIR_Coverage, 3157,
     /*  434870 */     GIR_EraseRootFromParent_Done,
     /*  434871 */   // Label 7574: @434871
     /*  434871 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(434957), // Rule ID 3160 //
     /*  434876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434923 */     // MIs[1] Operand 1
     /*  434923 */     // No operand predicates
     /*  434923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  434935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434955 */     GIR_RootConstrainSelectedInstOperands,
     /*  434956 */     // GIR_Coverage, 3160,
     /*  434956 */     GIR_EraseRootFromParent_Done,
     /*  434957 */   // Label 7575: @434957
     /*  434957 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(435043), // Rule ID 3161 //
     /*  434962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  434970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435009 */     // MIs[1] Operand 1
     /*  435009 */     // No operand predicates
     /*  435009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  435021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435041 */     GIR_RootConstrainSelectedInstOperands,
     /*  435042 */     // GIR_Coverage, 3161,
     /*  435042 */     GIR_EraseRootFromParent_Done,
     /*  435043 */   // Label 7576: @435043
     /*  435043 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(435129), // Rule ID 3164 //
     /*  435048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435095 */     // MIs[1] Operand 1
     /*  435095 */     // No operand predicates
     /*  435095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435104 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435127 */     GIR_RootConstrainSelectedInstOperands,
     /*  435128 */     // GIR_Coverage, 3164,
     /*  435128 */     GIR_EraseRootFromParent_Done,
     /*  435129 */   // Label 7577: @435129
     /*  435129 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(435215), // Rule ID 3165 //
     /*  435134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435181 */     // MIs[1] Operand 1
     /*  435181 */     // No operand predicates
     /*  435181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435213 */     GIR_RootConstrainSelectedInstOperands,
     /*  435214 */     // GIR_Coverage, 3165,
     /*  435214 */     GIR_EraseRootFromParent_Done,
     /*  435215 */   // Label 7578: @435215
     /*  435215 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(435301), // Rule ID 3168 //
     /*  435220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435267 */     // MIs[1] Operand 1
     /*  435267 */     // No operand predicates
     /*  435267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435299 */     GIR_RootConstrainSelectedInstOperands,
     /*  435300 */     // GIR_Coverage, 3168,
     /*  435300 */     GIR_EraseRootFromParent_Done,
     /*  435301 */   // Label 7579: @435301
     /*  435301 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(435387), // Rule ID 3169 //
     /*  435306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435353 */     // MIs[1] Operand 1
     /*  435353 */     // No operand predicates
     /*  435353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435385 */     GIR_RootConstrainSelectedInstOperands,
     /*  435386 */     // GIR_Coverage, 3169,
     /*  435386 */     GIR_EraseRootFromParent_Done,
     /*  435387 */   // Label 7580: @435387
     /*  435387 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(435473), // Rule ID 3172 //
     /*  435392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435439 */     // MIs[1] Operand 1
     /*  435439 */     // No operand predicates
     /*  435439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435471 */     GIR_RootConstrainSelectedInstOperands,
     /*  435472 */     // GIR_Coverage, 3172,
     /*  435472 */     GIR_EraseRootFromParent_Done,
     /*  435473 */   // Label 7581: @435473
     /*  435473 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(435559), // Rule ID 3173 //
     /*  435478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435525 */     // MIs[1] Operand 1
     /*  435525 */     // No operand predicates
     /*  435525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435557 */     GIR_RootConstrainSelectedInstOperands,
     /*  435558 */     // GIR_Coverage, 3173,
     /*  435558 */     GIR_EraseRootFromParent_Done,
     /*  435559 */   // Label 7582: @435559
     /*  435559 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(435645), // Rule ID 3176 //
     /*  435564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435611 */     // MIs[1] Operand 1
     /*  435611 */     // No operand predicates
     /*  435611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  435620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435643 */     GIR_RootConstrainSelectedInstOperands,
     /*  435644 */     // GIR_Coverage, 3176,
     /*  435644 */     GIR_EraseRootFromParent_Done,
     /*  435645 */   // Label 7583: @435645
     /*  435645 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(435731), // Rule ID 3177 //
     /*  435650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  435653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435697 */     // MIs[1] Operand 1
     /*  435697 */     // No operand predicates
     /*  435697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  435706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  435709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435729 */     GIR_RootConstrainSelectedInstOperands,
     /*  435730 */     // GIR_Coverage, 3177,
     /*  435730 */     GIR_EraseRootFromParent_Done,
     /*  435731 */   // Label 7584: @435731
     /*  435731 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(435817), // Rule ID 3180 //
     /*  435736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435783 */     // MIs[1] Operand 1
     /*  435783 */     // No operand predicates
     /*  435783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  435795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435815 */     GIR_RootConstrainSelectedInstOperands,
     /*  435816 */     // GIR_Coverage, 3180,
     /*  435816 */     GIR_EraseRootFromParent_Done,
     /*  435817 */   // Label 7585: @435817
     /*  435817 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(435903), // Rule ID 3181 //
     /*  435822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435869 */     // MIs[1] Operand 1
     /*  435869 */     // No operand predicates
     /*  435869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  435881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435901 */     GIR_RootConstrainSelectedInstOperands,
     /*  435902 */     // GIR_Coverage, 3181,
     /*  435902 */     GIR_EraseRootFromParent_Done,
     /*  435903 */   // Label 7586: @435903
     /*  435903 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(435989), // Rule ID 3184 //
     /*  435908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  435916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435955 */     // MIs[1] Operand 1
     /*  435955 */     // No operand predicates
     /*  435955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  435967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435987 */     GIR_RootConstrainSelectedInstOperands,
     /*  435988 */     // GIR_Coverage, 3184,
     /*  435988 */     GIR_EraseRootFromParent_Done,
     /*  435989 */   // Label 7587: @435989
     /*  435989 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(436075), // Rule ID 3185 //
     /*  435994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  436005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  436008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  436011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436041 */     // MIs[1] Operand 1
     /*  436041 */     // No operand predicates
     /*  436041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436050 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436073 */     GIR_RootConstrainSelectedInstOperands,
     /*  436074 */     // GIR_Coverage, 3185,
     /*  436074 */     GIR_EraseRootFromParent_Done,
     /*  436075 */   // Label 7588: @436075
     /*  436075 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(436161), // Rule ID 3188 //
     /*  436080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436127 */     // MIs[1] Operand 1
     /*  436127 */     // No operand predicates
     /*  436127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436159 */     GIR_RootConstrainSelectedInstOperands,
     /*  436160 */     // GIR_Coverage, 3188,
     /*  436160 */     GIR_EraseRootFromParent_Done,
     /*  436161 */   // Label 7589: @436161
     /*  436161 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(436247), // Rule ID 3189 //
     /*  436166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436213 */     // MIs[1] Operand 1
     /*  436213 */     // No operand predicates
     /*  436213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436222 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436245 */     GIR_RootConstrainSelectedInstOperands,
     /*  436246 */     // GIR_Coverage, 3189,
     /*  436246 */     GIR_EraseRootFromParent_Done,
     /*  436247 */   // Label 7590: @436247
     /*  436247 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(436333), // Rule ID 3192 //
     /*  436252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436299 */     // MIs[1] Operand 1
     /*  436299 */     // No operand predicates
     /*  436299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436331 */     GIR_RootConstrainSelectedInstOperands,
     /*  436332 */     // GIR_Coverage, 3192,
     /*  436332 */     GIR_EraseRootFromParent_Done,
     /*  436333 */   // Label 7591: @436333
     /*  436333 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(436419), // Rule ID 3193 //
     /*  436338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436385 */     // MIs[1] Operand 1
     /*  436385 */     // No operand predicates
     /*  436385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436417 */     GIR_RootConstrainSelectedInstOperands,
     /*  436418 */     // GIR_Coverage, 3193,
     /*  436418 */     GIR_EraseRootFromParent_Done,
     /*  436419 */   // Label 7592: @436419
     /*  436419 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(436505), // Rule ID 3196 //
     /*  436424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436471 */     // MIs[1] Operand 1
     /*  436471 */     // No operand predicates
     /*  436471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436503 */     GIR_RootConstrainSelectedInstOperands,
     /*  436504 */     // GIR_Coverage, 3196,
     /*  436504 */     GIR_EraseRootFromParent_Done,
     /*  436505 */   // Label 7593: @436505
     /*  436505 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(436591), // Rule ID 3197 //
     /*  436510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436557 */     // MIs[1] Operand 1
     /*  436557 */     // No operand predicates
     /*  436557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436589 */     GIR_RootConstrainSelectedInstOperands,
     /*  436590 */     // GIR_Coverage, 3197,
     /*  436590 */     GIR_EraseRootFromParent_Done,
     /*  436591 */   // Label 7594: @436591
     /*  436591 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(436677), // Rule ID 3200 //
     /*  436596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436643 */     // MIs[1] Operand 1
     /*  436643 */     // No operand predicates
     /*  436643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436675 */     GIR_RootConstrainSelectedInstOperands,
     /*  436676 */     // GIR_Coverage, 3200,
     /*  436676 */     GIR_EraseRootFromParent_Done,
     /*  436677 */   // Label 7595: @436677
     /*  436677 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(436763), // Rule ID 3201 //
     /*  436682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436729 */     // MIs[1] Operand 1
     /*  436729 */     // No operand predicates
     /*  436729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  436741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436761 */     GIR_RootConstrainSelectedInstOperands,
     /*  436762 */     // GIR_Coverage, 3201,
     /*  436762 */     GIR_EraseRootFromParent_Done,
     /*  436763 */   // Label 7596: @436763
     /*  436763 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(436849), // Rule ID 3204 //
     /*  436768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436815 */     // MIs[1] Operand 1
     /*  436815 */     // No operand predicates
     /*  436815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436847 */     GIR_RootConstrainSelectedInstOperands,
     /*  436848 */     // GIR_Coverage, 3204,
     /*  436848 */     GIR_EraseRootFromParent_Done,
     /*  436849 */   // Label 7597: @436849
     /*  436849 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(436935), // Rule ID 3205 //
     /*  436854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436901 */     // MIs[1] Operand 1
     /*  436901 */     // No operand predicates
     /*  436901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  436913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436933 */     GIR_RootConstrainSelectedInstOperands,
     /*  436934 */     // GIR_Coverage, 3205,
     /*  436934 */     GIR_EraseRootFromParent_Done,
     /*  436935 */   // Label 7598: @436935
     /*  436935 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(437021), // Rule ID 3208 //
     /*  436940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  436948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436987 */     // MIs[1] Operand 1
     /*  436987 */     // No operand predicates
     /*  436987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  436999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437019 */     GIR_RootConstrainSelectedInstOperands,
     /*  437020 */     // GIR_Coverage, 3208,
     /*  437020 */     GIR_EraseRootFromParent_Done,
     /*  437021 */   // Label 7599: @437021
     /*  437021 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(437107), // Rule ID 3209 //
     /*  437026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  437037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  437040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  437043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437073 */     // MIs[1] Operand 1
     /*  437073 */     // No operand predicates
     /*  437073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437105 */     GIR_RootConstrainSelectedInstOperands,
     /*  437106 */     // GIR_Coverage, 3209,
     /*  437106 */     GIR_EraseRootFromParent_Done,
     /*  437107 */   // Label 7600: @437107
     /*  437107 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(437193), // Rule ID 3212 //
     /*  437112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437159 */     // MIs[1] Operand 1
     /*  437159 */     // No operand predicates
     /*  437159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437191 */     GIR_RootConstrainSelectedInstOperands,
     /*  437192 */     // GIR_Coverage, 3212,
     /*  437192 */     GIR_EraseRootFromParent_Done,
     /*  437193 */   // Label 7601: @437193
     /*  437193 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(437279), // Rule ID 3213 //
     /*  437198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437245 */     // MIs[1] Operand 1
     /*  437245 */     // No operand predicates
     /*  437245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437277 */     GIR_RootConstrainSelectedInstOperands,
     /*  437278 */     // GIR_Coverage, 3213,
     /*  437278 */     GIR_EraseRootFromParent_Done,
     /*  437279 */   // Label 7602: @437279
     /*  437279 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(437365), // Rule ID 3216 //
     /*  437284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437331 */     // MIs[1] Operand 1
     /*  437331 */     // No operand predicates
     /*  437331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  437343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437363 */     GIR_RootConstrainSelectedInstOperands,
     /*  437364 */     // GIR_Coverage, 3216,
     /*  437364 */     GIR_EraseRootFromParent_Done,
     /*  437365 */   // Label 7603: @437365
     /*  437365 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(437451), // Rule ID 3217 //
     /*  437370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437417 */     // MIs[1] Operand 1
     /*  437417 */     // No operand predicates
     /*  437417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  437429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437449 */     GIR_RootConstrainSelectedInstOperands,
     /*  437450 */     // GIR_Coverage, 3217,
     /*  437450 */     GIR_EraseRootFromParent_Done,
     /*  437451 */   // Label 7604: @437451
     /*  437451 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(437537), // Rule ID 3220 //
     /*  437456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437503 */     // MIs[1] Operand 1
     /*  437503 */     // No operand predicates
     /*  437503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437535 */     GIR_RootConstrainSelectedInstOperands,
     /*  437536 */     // GIR_Coverage, 3220,
     /*  437536 */     GIR_EraseRootFromParent_Done,
     /*  437537 */   // Label 7605: @437537
     /*  437537 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(437623), // Rule ID 3221 //
     /*  437542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437589 */     // MIs[1] Operand 1
     /*  437589 */     // No operand predicates
     /*  437589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  437601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437621 */     GIR_RootConstrainSelectedInstOperands,
     /*  437622 */     // GIR_Coverage, 3221,
     /*  437622 */     GIR_EraseRootFromParent_Done,
     /*  437623 */   // Label 7606: @437623
     /*  437623 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(437709), // Rule ID 3224 //
     /*  437628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437675 */     // MIs[1] Operand 1
     /*  437675 */     // No operand predicates
     /*  437675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437707 */     GIR_RootConstrainSelectedInstOperands,
     /*  437708 */     // GIR_Coverage, 3224,
     /*  437708 */     GIR_EraseRootFromParent_Done,
     /*  437709 */   // Label 7607: @437709
     /*  437709 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(437795), // Rule ID 3225 //
     /*  437714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  437722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437761 */     // MIs[1] Operand 1
     /*  437761 */     // No operand predicates
     /*  437761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  437773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437793 */     GIR_RootConstrainSelectedInstOperands,
     /*  437794 */     // GIR_Coverage, 3225,
     /*  437794 */     GIR_EraseRootFromParent_Done,
     /*  437795 */   // Label 7608: @437795
     /*  437795 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(437881), // Rule ID 3492 //
     /*  437800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437847 */     // MIs[1] Operand 1
     /*  437847 */     // No operand predicates
     /*  437847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  437859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437879 */     GIR_RootConstrainSelectedInstOperands,
     /*  437880 */     // GIR_Coverage, 3492,
     /*  437880 */     GIR_EraseRootFromParent_Done,
     /*  437881 */   // Label 7609: @437881
     /*  437881 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(437967), // Rule ID 3493 //
     /*  437886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437933 */     // MIs[1] Operand 1
     /*  437933 */     // No operand predicates
     /*  437933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  437945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437965 */     GIR_RootConstrainSelectedInstOperands,
     /*  437966 */     // GIR_Coverage, 3493,
     /*  437966 */     GIR_EraseRootFromParent_Done,
     /*  437967 */   // Label 7610: @437967
     /*  437967 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(438053), // Rule ID 3496 //
     /*  437972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438019 */     // MIs[1] Operand 1
     /*  438019 */     // No operand predicates
     /*  438019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438028 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438051 */     GIR_RootConstrainSelectedInstOperands,
     /*  438052 */     // GIR_Coverage, 3496,
     /*  438052 */     GIR_EraseRootFromParent_Done,
     /*  438053 */   // Label 7611: @438053
     /*  438053 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(438139), // Rule ID 3497 //
     /*  438058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438105 */     // MIs[1] Operand 1
     /*  438105 */     // No operand predicates
     /*  438105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438137 */     GIR_RootConstrainSelectedInstOperands,
     /*  438138 */     // GIR_Coverage, 3497,
     /*  438138 */     GIR_EraseRootFromParent_Done,
     /*  438139 */   // Label 7612: @438139
     /*  438139 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(438225), // Rule ID 3500 //
     /*  438144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438191 */     // MIs[1] Operand 1
     /*  438191 */     // No operand predicates
     /*  438191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438223 */     GIR_RootConstrainSelectedInstOperands,
     /*  438224 */     // GIR_Coverage, 3500,
     /*  438224 */     GIR_EraseRootFromParent_Done,
     /*  438225 */   // Label 7613: @438225
     /*  438225 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(438311), // Rule ID 3501 //
     /*  438230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438277 */     // MIs[1] Operand 1
     /*  438277 */     // No operand predicates
     /*  438277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438309 */     GIR_RootConstrainSelectedInstOperands,
     /*  438310 */     // GIR_Coverage, 3501,
     /*  438310 */     GIR_EraseRootFromParent_Done,
     /*  438311 */   // Label 7614: @438311
     /*  438311 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(438397), // Rule ID 3504 //
     /*  438316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438363 */     // MIs[1] Operand 1
     /*  438363 */     // No operand predicates
     /*  438363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438395 */     GIR_RootConstrainSelectedInstOperands,
     /*  438396 */     // GIR_Coverage, 3504,
     /*  438396 */     GIR_EraseRootFromParent_Done,
     /*  438397 */   // Label 7615: @438397
     /*  438397 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(438483), // Rule ID 3505 //
     /*  438402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438449 */     // MIs[1] Operand 1
     /*  438449 */     // No operand predicates
     /*  438449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  438461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438481 */     GIR_RootConstrainSelectedInstOperands,
     /*  438482 */     // GIR_Coverage, 3505,
     /*  438482 */     GIR_EraseRootFromParent_Done,
     /*  438483 */   // Label 7616: @438483
     /*  438483 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(438569), // Rule ID 3508 //
     /*  438488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438535 */     // MIs[1] Operand 1
     /*  438535 */     // No operand predicates
     /*  438535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438567 */     GIR_RootConstrainSelectedInstOperands,
     /*  438568 */     // GIR_Coverage, 3508,
     /*  438568 */     GIR_EraseRootFromParent_Done,
     /*  438569 */   // Label 7617: @438569
     /*  438569 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(438655), // Rule ID 3509 //
     /*  438574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438621 */     // MIs[1] Operand 1
     /*  438621 */     // No operand predicates
     /*  438621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438653 */     GIR_RootConstrainSelectedInstOperands,
     /*  438654 */     // GIR_Coverage, 3509,
     /*  438654 */     GIR_EraseRootFromParent_Done,
     /*  438655 */   // Label 7618: @438655
     /*  438655 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(438741), // Rule ID 3512 //
     /*  438660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438707 */     // MIs[1] Operand 1
     /*  438707 */     // No operand predicates
     /*  438707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438739 */     GIR_RootConstrainSelectedInstOperands,
     /*  438740 */     // GIR_Coverage, 3512,
     /*  438740 */     GIR_EraseRootFromParent_Done,
     /*  438741 */   // Label 7619: @438741
     /*  438741 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(438827), // Rule ID 3513 //
     /*  438746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438793 */     // MIs[1] Operand 1
     /*  438793 */     // No operand predicates
     /*  438793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  438805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438825 */     GIR_RootConstrainSelectedInstOperands,
     /*  438826 */     // GIR_Coverage, 3513,
     /*  438826 */     GIR_EraseRootFromParent_Done,
     /*  438827 */   // Label 7620: @438827
     /*  438827 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(438913), // Rule ID 3516 //
     /*  438832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438879 */     // MIs[1] Operand 1
     /*  438879 */     // No operand predicates
     /*  438879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  438891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438911 */     GIR_RootConstrainSelectedInstOperands,
     /*  438912 */     // GIR_Coverage, 3516,
     /*  438912 */     GIR_EraseRootFromParent_Done,
     /*  438913 */   // Label 7621: @438913
     /*  438913 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(438999), // Rule ID 3517 //
     /*  438918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  438926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438965 */     // MIs[1] Operand 1
     /*  438965 */     // No operand predicates
     /*  438965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  438977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438997 */     GIR_RootConstrainSelectedInstOperands,
     /*  438998 */     // GIR_Coverage, 3517,
     /*  438998 */     GIR_EraseRootFromParent_Done,
     /*  438999 */   // Label 7622: @438999
     /*  438999 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(439085), // Rule ID 3520 //
     /*  439004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439051 */     // MIs[1] Operand 1
     /*  439051 */     // No operand predicates
     /*  439051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439083 */     GIR_RootConstrainSelectedInstOperands,
     /*  439084 */     // GIR_Coverage, 3520,
     /*  439084 */     GIR_EraseRootFromParent_Done,
     /*  439085 */   // Label 7623: @439085
     /*  439085 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(439171), // Rule ID 3521 //
     /*  439090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439137 */     // MIs[1] Operand 1
     /*  439137 */     // No operand predicates
     /*  439137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439169 */     GIR_RootConstrainSelectedInstOperands,
     /*  439170 */     // GIR_Coverage, 3521,
     /*  439170 */     GIR_EraseRootFromParent_Done,
     /*  439171 */   // Label 7624: @439171
     /*  439171 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(439257), // Rule ID 3524 //
     /*  439176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439223 */     // MIs[1] Operand 1
     /*  439223 */     // No operand predicates
     /*  439223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439255 */     GIR_RootConstrainSelectedInstOperands,
     /*  439256 */     // GIR_Coverage, 3524,
     /*  439256 */     GIR_EraseRootFromParent_Done,
     /*  439257 */   // Label 7625: @439257
     /*  439257 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(439343), // Rule ID 3525 //
     /*  439262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439309 */     // MIs[1] Operand 1
     /*  439309 */     // No operand predicates
     /*  439309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439341 */     GIR_RootConstrainSelectedInstOperands,
     /*  439342 */     // GIR_Coverage, 3525,
     /*  439342 */     GIR_EraseRootFromParent_Done,
     /*  439343 */   // Label 7626: @439343
     /*  439343 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(439429), // Rule ID 3528 //
     /*  439348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439395 */     // MIs[1] Operand 1
     /*  439395 */     // No operand predicates
     /*  439395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439427 */     GIR_RootConstrainSelectedInstOperands,
     /*  439428 */     // GIR_Coverage, 3528,
     /*  439428 */     GIR_EraseRootFromParent_Done,
     /*  439429 */   // Label 7627: @439429
     /*  439429 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(439515), // Rule ID 3529 //
     /*  439434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439481 */     // MIs[1] Operand 1
     /*  439481 */     // No operand predicates
     /*  439481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  439493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439513 */     GIR_RootConstrainSelectedInstOperands,
     /*  439514 */     // GIR_Coverage, 3529,
     /*  439514 */     GIR_EraseRootFromParent_Done,
     /*  439515 */   // Label 7628: @439515
     /*  439515 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(439601), // Rule ID 3532 //
     /*  439520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439567 */     // MIs[1] Operand 1
     /*  439567 */     // No operand predicates
     /*  439567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  439579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439599 */     GIR_RootConstrainSelectedInstOperands,
     /*  439600 */     // GIR_Coverage, 3532,
     /*  439600 */     GIR_EraseRootFromParent_Done,
     /*  439601 */   // Label 7629: @439601
     /*  439601 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(439687), // Rule ID 3533 //
     /*  439606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439653 */     // MIs[1] Operand 1
     /*  439653 */     // No operand predicates
     /*  439653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  439665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439685 */     GIR_RootConstrainSelectedInstOperands,
     /*  439686 */     // GIR_Coverage, 3533,
     /*  439686 */     GIR_EraseRootFromParent_Done,
     /*  439687 */   // Label 7630: @439687
     /*  439687 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(439773), // Rule ID 3536 //
     /*  439692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439739 */     // MIs[1] Operand 1
     /*  439739 */     // No operand predicates
     /*  439739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  439751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439771 */     GIR_RootConstrainSelectedInstOperands,
     /*  439772 */     // GIR_Coverage, 3536,
     /*  439772 */     GIR_EraseRootFromParent_Done,
     /*  439773 */   // Label 7631: @439773
     /*  439773 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(439859), // Rule ID 3537 //
     /*  439778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439825 */     // MIs[1] Operand 1
     /*  439825 */     // No operand predicates
     /*  439825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  439837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439857 */     GIR_RootConstrainSelectedInstOperands,
     /*  439858 */     // GIR_Coverage, 3537,
     /*  439858 */     GIR_EraseRootFromParent_Done,
     /*  439859 */   // Label 7632: @439859
     /*  439859 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(439945), // Rule ID 3540 //
     /*  439864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439911 */     // MIs[1] Operand 1
     /*  439911 */     // No operand predicates
     /*  439911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  439923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439943 */     GIR_RootConstrainSelectedInstOperands,
     /*  439944 */     // GIR_Coverage, 3540,
     /*  439944 */     GIR_EraseRootFromParent_Done,
     /*  439945 */   // Label 7633: @439945
     /*  439945 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(440031), // Rule ID 3541 //
     /*  439950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  439958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439997 */     // MIs[1] Operand 1
     /*  439997 */     // No operand predicates
     /*  439997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  440006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  440026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440029 */     GIR_RootConstrainSelectedInstOperands,
     /*  440030 */     // GIR_Coverage, 3541,
     /*  440030 */     GIR_EraseRootFromParent_Done,
     /*  440031 */   // Label 7634: @440031
     /*  440031 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(440117), // Rule ID 3544 //
     /*  440036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440083 */     // MIs[1] Operand 1
     /*  440083 */     // No operand predicates
     /*  440083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440115 */     GIR_RootConstrainSelectedInstOperands,
     /*  440116 */     // GIR_Coverage, 3544,
     /*  440116 */     GIR_EraseRootFromParent_Done,
     /*  440117 */   // Label 7635: @440117
     /*  440117 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(440203), // Rule ID 3545 //
     /*  440122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440169 */     // MIs[1] Operand 1
     /*  440169 */     // No operand predicates
     /*  440169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440201 */     GIR_RootConstrainSelectedInstOperands,
     /*  440202 */     // GIR_Coverage, 3545,
     /*  440202 */     GIR_EraseRootFromParent_Done,
     /*  440203 */   // Label 7636: @440203
     /*  440203 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(440289), // Rule ID 3548 //
     /*  440208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440255 */     // MIs[1] Operand 1
     /*  440255 */     // No operand predicates
     /*  440255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440287 */     GIR_RootConstrainSelectedInstOperands,
     /*  440288 */     // GIR_Coverage, 3548,
     /*  440288 */     GIR_EraseRootFromParent_Done,
     /*  440289 */   // Label 7637: @440289
     /*  440289 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(440375), // Rule ID 3549 //
     /*  440294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440341 */     // MIs[1] Operand 1
     /*  440341 */     // No operand predicates
     /*  440341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440373 */     GIR_RootConstrainSelectedInstOperands,
     /*  440374 */     // GIR_Coverage, 3549,
     /*  440374 */     GIR_EraseRootFromParent_Done,
     /*  440375 */   // Label 7638: @440375
     /*  440375 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(440461), // Rule ID 3552 //
     /*  440380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440427 */     // MIs[1] Operand 1
     /*  440427 */     // No operand predicates
     /*  440427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440459 */     GIR_RootConstrainSelectedInstOperands,
     /*  440460 */     // GIR_Coverage, 3552,
     /*  440460 */     GIR_EraseRootFromParent_Done,
     /*  440461 */   // Label 7639: @440461
     /*  440461 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(440547), // Rule ID 3553 //
     /*  440466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440513 */     // MIs[1] Operand 1
     /*  440513 */     // No operand predicates
     /*  440513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440545 */     GIR_RootConstrainSelectedInstOperands,
     /*  440546 */     // GIR_Coverage, 3553,
     /*  440546 */     GIR_EraseRootFromParent_Done,
     /*  440547 */   // Label 7640: @440547
     /*  440547 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(440633), // Rule ID 3556 //
     /*  440552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440599 */     // MIs[1] Operand 1
     /*  440599 */     // No operand predicates
     /*  440599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440631 */     GIR_RootConstrainSelectedInstOperands,
     /*  440632 */     // GIR_Coverage, 3556,
     /*  440632 */     GIR_EraseRootFromParent_Done,
     /*  440633 */   // Label 7641: @440633
     /*  440633 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(440719), // Rule ID 3557 //
     /*  440638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440685 */     // MIs[1] Operand 1
     /*  440685 */     // No operand predicates
     /*  440685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  440697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440717 */     GIR_RootConstrainSelectedInstOperands,
     /*  440718 */     // GIR_Coverage, 3557,
     /*  440718 */     GIR_EraseRootFromParent_Done,
     /*  440719 */   // Label 7642: @440719
     /*  440719 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(440805), // Rule ID 3560 //
     /*  440724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440771 */     // MIs[1] Operand 1
     /*  440771 */     // No operand predicates
     /*  440771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440803 */     GIR_RootConstrainSelectedInstOperands,
     /*  440804 */     // GIR_Coverage, 3560,
     /*  440804 */     GIR_EraseRootFromParent_Done,
     /*  440805 */   // Label 7643: @440805
     /*  440805 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(440891), // Rule ID 3561 //
     /*  440810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440857 */     // MIs[1] Operand 1
     /*  440857 */     // No operand predicates
     /*  440857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  440869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440889 */     GIR_RootConstrainSelectedInstOperands,
     /*  440890 */     // GIR_Coverage, 3561,
     /*  440890 */     GIR_EraseRootFromParent_Done,
     /*  440891 */   // Label 7644: @440891
     /*  440891 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(440977), // Rule ID 3564 //
     /*  440896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440943 */     // MIs[1] Operand 1
     /*  440943 */     // No operand predicates
     /*  440943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  440955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440975 */     GIR_RootConstrainSelectedInstOperands,
     /*  440976 */     // GIR_Coverage, 3564,
     /*  440976 */     GIR_EraseRootFromParent_Done,
     /*  440977 */   // Label 7645: @440977
     /*  440977 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(441063), // Rule ID 3565 //
     /*  440982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  440990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441029 */     // MIs[1] Operand 1
     /*  441029 */     // No operand predicates
     /*  441029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  441038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441061 */     GIR_RootConstrainSelectedInstOperands,
     /*  441062 */     // GIR_Coverage, 3565,
     /*  441062 */     GIR_EraseRootFromParent_Done,
     /*  441063 */   // Label 7646: @441063
     /*  441063 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(441149), // Rule ID 3568 //
     /*  441068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441115 */     // MIs[1] Operand 1
     /*  441115 */     // No operand predicates
     /*  441115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  441127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441147 */     GIR_RootConstrainSelectedInstOperands,
     /*  441148 */     // GIR_Coverage, 3568,
     /*  441148 */     GIR_EraseRootFromParent_Done,
     /*  441149 */   // Label 7647: @441149
     /*  441149 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(441235), // Rule ID 3569 //
     /*  441154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441201 */     // MIs[1] Operand 1
     /*  441201 */     // No operand predicates
     /*  441201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  441213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441233 */     GIR_RootConstrainSelectedInstOperands,
     /*  441234 */     // GIR_Coverage, 3569,
     /*  441234 */     GIR_EraseRootFromParent_Done,
     /*  441235 */   // Label 7648: @441235
     /*  441235 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(441321), // Rule ID 3572 //
     /*  441240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441287 */     // MIs[1] Operand 1
     /*  441287 */     // No operand predicates
     /*  441287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  441299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441319 */     GIR_RootConstrainSelectedInstOperands,
     /*  441320 */     // GIR_Coverage, 3572,
     /*  441320 */     GIR_EraseRootFromParent_Done,
     /*  441321 */   // Label 7649: @441321
     /*  441321 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(441407), // Rule ID 3573 //
     /*  441326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441373 */     // MIs[1] Operand 1
     /*  441373 */     // No operand predicates
     /*  441373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  441385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441405 */     GIR_RootConstrainSelectedInstOperands,
     /*  441406 */     // GIR_Coverage, 3573,
     /*  441406 */     GIR_EraseRootFromParent_Done,
     /*  441407 */   // Label 7650: @441407
     /*  441407 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(441493), // Rule ID 3576 //
     /*  441412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441459 */     // MIs[1] Operand 1
     /*  441459 */     // No operand predicates
     /*  441459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441491 */     GIR_RootConstrainSelectedInstOperands,
     /*  441492 */     // GIR_Coverage, 3576,
     /*  441492 */     GIR_EraseRootFromParent_Done,
     /*  441493 */   // Label 7651: @441493
     /*  441493 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(441579), // Rule ID 3577 //
     /*  441498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  441506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441545 */     // MIs[1] Operand 1
     /*  441545 */     // No operand predicates
     /*  441545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  441557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441577 */     GIR_RootConstrainSelectedInstOperands,
     /*  441578 */     // GIR_Coverage, 3577,
     /*  441578 */     GIR_EraseRootFromParent_Done,
     /*  441579 */   // Label 7652: @441579
     /*  441579 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(441665), // Rule ID 5940 //
     /*  441584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441631 */     // MIs[1] Operand 1
     /*  441631 */     // No operand predicates
     /*  441631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  441643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441663 */     GIR_RootConstrainSelectedInstOperands,
     /*  441664 */     // GIR_Coverage, 5940,
     /*  441664 */     GIR_EraseRootFromParent_Done,
     /*  441665 */   // Label 7653: @441665
     /*  441665 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(441751), // Rule ID 5941 //
     /*  441670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441717 */     // MIs[1] Operand 1
     /*  441717 */     // No operand predicates
     /*  441717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  441729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441749 */     GIR_RootConstrainSelectedInstOperands,
     /*  441750 */     // GIR_Coverage, 5941,
     /*  441750 */     GIR_EraseRootFromParent_Done,
     /*  441751 */   // Label 7654: @441751
     /*  441751 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(441837), // Rule ID 5944 //
     /*  441756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441803 */     // MIs[1] Operand 1
     /*  441803 */     // No operand predicates
     /*  441803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  441815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441835 */     GIR_RootConstrainSelectedInstOperands,
     /*  441836 */     // GIR_Coverage, 5944,
     /*  441836 */     GIR_EraseRootFromParent_Done,
     /*  441837 */   // Label 7655: @441837
     /*  441837 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(441923), // Rule ID 5945 //
     /*  441842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441889 */     // MIs[1] Operand 1
     /*  441889 */     // No operand predicates
     /*  441889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  441901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441921 */     GIR_RootConstrainSelectedInstOperands,
     /*  441922 */     // GIR_Coverage, 5945,
     /*  441922 */     GIR_EraseRootFromParent_Done,
     /*  441923 */   // Label 7656: @441923
     /*  441923 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(442009), // Rule ID 5948 //
     /*  441928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441975 */     // MIs[1] Operand 1
     /*  441975 */     // No operand predicates
     /*  441975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  441987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442007 */     GIR_RootConstrainSelectedInstOperands,
     /*  442008 */     // GIR_Coverage, 5948,
     /*  442008 */     GIR_EraseRootFromParent_Done,
     /*  442009 */   // Label 7657: @442009
     /*  442009 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(442095), // Rule ID 5949 //
     /*  442014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  442025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  442028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  442031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442061 */     // MIs[1] Operand 1
     /*  442061 */     // No operand predicates
     /*  442061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442093 */     GIR_RootConstrainSelectedInstOperands,
     /*  442094 */     // GIR_Coverage, 5949,
     /*  442094 */     GIR_EraseRootFromParent_Done,
     /*  442095 */   // Label 7658: @442095
     /*  442095 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(442181), // Rule ID 5952 //
     /*  442100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442147 */     // MIs[1] Operand 1
     /*  442147 */     // No operand predicates
     /*  442147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  442159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442179 */     GIR_RootConstrainSelectedInstOperands,
     /*  442180 */     // GIR_Coverage, 5952,
     /*  442180 */     GIR_EraseRootFromParent_Done,
     /*  442181 */   // Label 7659: @442181
     /*  442181 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(442267), // Rule ID 5953 //
     /*  442186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442233 */     // MIs[1] Operand 1
     /*  442233 */     // No operand predicates
     /*  442233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  442245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442265 */     GIR_RootConstrainSelectedInstOperands,
     /*  442266 */     // GIR_Coverage, 5953,
     /*  442266 */     GIR_EraseRootFromParent_Done,
     /*  442267 */   // Label 7660: @442267
     /*  442267 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(442353), // Rule ID 5956 //
     /*  442272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442319 */     // MIs[1] Operand 1
     /*  442319 */     // No operand predicates
     /*  442319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442351 */     GIR_RootConstrainSelectedInstOperands,
     /*  442352 */     // GIR_Coverage, 5956,
     /*  442352 */     GIR_EraseRootFromParent_Done,
     /*  442353 */   // Label 7661: @442353
     /*  442353 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(442439), // Rule ID 5957 //
     /*  442358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442405 */     // MIs[1] Operand 1
     /*  442405 */     // No operand predicates
     /*  442405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442437 */     GIR_RootConstrainSelectedInstOperands,
     /*  442438 */     // GIR_Coverage, 5957,
     /*  442438 */     GIR_EraseRootFromParent_Done,
     /*  442439 */   // Label 7662: @442439
     /*  442439 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(442525), // Rule ID 5960 //
     /*  442444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442491 */     // MIs[1] Operand 1
     /*  442491 */     // No operand predicates
     /*  442491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442523 */     GIR_RootConstrainSelectedInstOperands,
     /*  442524 */     // GIR_Coverage, 5960,
     /*  442524 */     GIR_EraseRootFromParent_Done,
     /*  442525 */   // Label 7663: @442525
     /*  442525 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(442611), // Rule ID 5961 //
     /*  442530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442577 */     // MIs[1] Operand 1
     /*  442577 */     // No operand predicates
     /*  442577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  442589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442609 */     GIR_RootConstrainSelectedInstOperands,
     /*  442610 */     // GIR_Coverage, 5961,
     /*  442610 */     GIR_EraseRootFromParent_Done,
     /*  442611 */   // Label 7664: @442611
     /*  442611 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(442697), // Rule ID 5964 //
     /*  442616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442663 */     // MIs[1] Operand 1
     /*  442663 */     // No operand predicates
     /*  442663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442695 */     GIR_RootConstrainSelectedInstOperands,
     /*  442696 */     // GIR_Coverage, 5964,
     /*  442696 */     GIR_EraseRootFromParent_Done,
     /*  442697 */   // Label 7665: @442697
     /*  442697 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(442783), // Rule ID 5965 //
     /*  442702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442749 */     // MIs[1] Operand 1
     /*  442749 */     // No operand predicates
     /*  442749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442781 */     GIR_RootConstrainSelectedInstOperands,
     /*  442782 */     // GIR_Coverage, 5965,
     /*  442782 */     GIR_EraseRootFromParent_Done,
     /*  442783 */   // Label 7666: @442783
     /*  442783 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(442869), // Rule ID 5968 //
     /*  442788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442835 */     // MIs[1] Operand 1
     /*  442835 */     // No operand predicates
     /*  442835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442867 */     GIR_RootConstrainSelectedInstOperands,
     /*  442868 */     // GIR_Coverage, 5968,
     /*  442868 */     GIR_EraseRootFromParent_Done,
     /*  442869 */   // Label 7667: @442869
     /*  442869 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(442955), // Rule ID 5969 //
     /*  442874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442921 */     // MIs[1] Operand 1
     /*  442921 */     // No operand predicates
     /*  442921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  442933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442953 */     GIR_RootConstrainSelectedInstOperands,
     /*  442954 */     // GIR_Coverage, 5969,
     /*  442954 */     GIR_EraseRootFromParent_Done,
     /*  442955 */   // Label 7668: @442955
     /*  442955 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(443041), // Rule ID 5972 //
     /*  442960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  442968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443007 */     // MIs[1] Operand 1
     /*  443007 */     // No operand predicates
     /*  443007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443039 */     GIR_RootConstrainSelectedInstOperands,
     /*  443040 */     // GIR_Coverage, 5972,
     /*  443040 */     GIR_EraseRootFromParent_Done,
     /*  443041 */   // Label 7669: @443041
     /*  443041 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(443127), // Rule ID 5973 //
     /*  443046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  443057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443093 */     // MIs[1] Operand 1
     /*  443093 */     // No operand predicates
     /*  443093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443125 */     GIR_RootConstrainSelectedInstOperands,
     /*  443126 */     // GIR_Coverage, 5973,
     /*  443126 */     GIR_EraseRootFromParent_Done,
     /*  443127 */   // Label 7670: @443127
     /*  443127 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(443213), // Rule ID 5976 //
     /*  443132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443179 */     // MIs[1] Operand 1
     /*  443179 */     // No operand predicates
     /*  443179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443211 */     GIR_RootConstrainSelectedInstOperands,
     /*  443212 */     // GIR_Coverage, 5976,
     /*  443212 */     GIR_EraseRootFromParent_Done,
     /*  443213 */   // Label 7671: @443213
     /*  443213 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(443299), // Rule ID 5977 //
     /*  443218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443265 */     // MIs[1] Operand 1
     /*  443265 */     // No operand predicates
     /*  443265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  443277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443297 */     GIR_RootConstrainSelectedInstOperands,
     /*  443298 */     // GIR_Coverage, 5977,
     /*  443298 */     GIR_EraseRootFromParent_Done,
     /*  443299 */   // Label 7672: @443299
     /*  443299 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(443385), // Rule ID 5980 //
     /*  443304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443351 */     // MIs[1] Operand 1
     /*  443351 */     // No operand predicates
     /*  443351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443383 */     GIR_RootConstrainSelectedInstOperands,
     /*  443384 */     // GIR_Coverage, 5980,
     /*  443384 */     GIR_EraseRootFromParent_Done,
     /*  443385 */   // Label 7673: @443385
     /*  443385 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(443471), // Rule ID 5981 //
     /*  443390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443437 */     // MIs[1] Operand 1
     /*  443437 */     // No operand predicates
     /*  443437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443469 */     GIR_RootConstrainSelectedInstOperands,
     /*  443470 */     // GIR_Coverage, 5981,
     /*  443470 */     GIR_EraseRootFromParent_Done,
     /*  443471 */   // Label 7674: @443471
     /*  443471 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(443557), // Rule ID 5984 //
     /*  443476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443523 */     // MIs[1] Operand 1
     /*  443523 */     // No operand predicates
     /*  443523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  443535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443555 */     GIR_RootConstrainSelectedInstOperands,
     /*  443556 */     // GIR_Coverage, 5984,
     /*  443556 */     GIR_EraseRootFromParent_Done,
     /*  443557 */   // Label 7675: @443557
     /*  443557 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(443643), // Rule ID 5985 //
     /*  443562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443609 */     // MIs[1] Operand 1
     /*  443609 */     // No operand predicates
     /*  443609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  443621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443641 */     GIR_RootConstrainSelectedInstOperands,
     /*  443642 */     // GIR_Coverage, 5985,
     /*  443642 */     GIR_EraseRootFromParent_Done,
     /*  443643 */   // Label 7676: @443643
     /*  443643 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(443729), // Rule ID 5988 //
     /*  443648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443695 */     // MIs[1] Operand 1
     /*  443695 */     // No operand predicates
     /*  443695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  443707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443727 */     GIR_RootConstrainSelectedInstOperands,
     /*  443728 */     // GIR_Coverage, 5988,
     /*  443728 */     GIR_EraseRootFromParent_Done,
     /*  443729 */   // Label 7677: @443729
     /*  443729 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(443815), // Rule ID 5989 //
     /*  443734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443781 */     // MIs[1] Operand 1
     /*  443781 */     // No operand predicates
     /*  443781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443790 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  443793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443813 */     GIR_RootConstrainSelectedInstOperands,
     /*  443814 */     // GIR_Coverage, 5989,
     /*  443814 */     GIR_EraseRootFromParent_Done,
     /*  443815 */   // Label 7678: @443815
     /*  443815 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(443901), // Rule ID 5992 //
     /*  443820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443867 */     // MIs[1] Operand 1
     /*  443867 */     // No operand predicates
     /*  443867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443899 */     GIR_RootConstrainSelectedInstOperands,
     /*  443900 */     // GIR_Coverage, 5992,
     /*  443900 */     GIR_EraseRootFromParent_Done,
     /*  443901 */   // Label 7679: @443901
     /*  443901 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(443987), // Rule ID 5993 //
     /*  443906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  443914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443953 */     // MIs[1] Operand 1
     /*  443953 */     // No operand predicates
     /*  443953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  443965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443985 */     GIR_RootConstrainSelectedInstOperands,
     /*  443986 */     // GIR_Coverage, 5993,
     /*  443986 */     GIR_EraseRootFromParent_Done,
     /*  443987 */   // Label 7680: @443987
     /*  443987 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(444073), // Rule ID 5996 //
     /*  443992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444039 */     // MIs[1] Operand 1
     /*  444039 */     // No operand predicates
     /*  444039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444071 */     GIR_RootConstrainSelectedInstOperands,
     /*  444072 */     // GIR_Coverage, 5996,
     /*  444072 */     GIR_EraseRootFromParent_Done,
     /*  444073 */   // Label 7681: @444073
     /*  444073 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(444159), // Rule ID 5997 //
     /*  444078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444125 */     // MIs[1] Operand 1
     /*  444125 */     // No operand predicates
     /*  444125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444157 */     GIR_RootConstrainSelectedInstOperands,
     /*  444158 */     // GIR_Coverage, 5997,
     /*  444158 */     GIR_EraseRootFromParent_Done,
     /*  444159 */   // Label 7682: @444159
     /*  444159 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(444245), // Rule ID 6000 //
     /*  444164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444211 */     // MIs[1] Operand 1
     /*  444211 */     // No operand predicates
     /*  444211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444243 */     GIR_RootConstrainSelectedInstOperands,
     /*  444244 */     // GIR_Coverage, 6000,
     /*  444244 */     GIR_EraseRootFromParent_Done,
     /*  444245 */   // Label 7683: @444245
     /*  444245 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(444331), // Rule ID 6001 //
     /*  444250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444297 */     // MIs[1] Operand 1
     /*  444297 */     // No operand predicates
     /*  444297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444329 */     GIR_RootConstrainSelectedInstOperands,
     /*  444330 */     // GIR_Coverage, 6001,
     /*  444330 */     GIR_EraseRootFromParent_Done,
     /*  444331 */   // Label 7684: @444331
     /*  444331 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(444417), // Rule ID 6004 //
     /*  444336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444383 */     // MIs[1] Operand 1
     /*  444383 */     // No operand predicates
     /*  444383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444415 */     GIR_RootConstrainSelectedInstOperands,
     /*  444416 */     // GIR_Coverage, 6004,
     /*  444416 */     GIR_EraseRootFromParent_Done,
     /*  444417 */   // Label 7685: @444417
     /*  444417 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(444503), // Rule ID 6005 //
     /*  444422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444469 */     // MIs[1] Operand 1
     /*  444469 */     // No operand predicates
     /*  444469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444501 */     GIR_RootConstrainSelectedInstOperands,
     /*  444502 */     // GIR_Coverage, 6005,
     /*  444502 */     GIR_EraseRootFromParent_Done,
     /*  444503 */   // Label 7686: @444503
     /*  444503 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(444589), // Rule ID 6008 //
     /*  444508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444555 */     // MIs[1] Operand 1
     /*  444555 */     // No operand predicates
     /*  444555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444587 */     GIR_RootConstrainSelectedInstOperands,
     /*  444588 */     // GIR_Coverage, 6008,
     /*  444588 */     GIR_EraseRootFromParent_Done,
     /*  444589 */   // Label 7687: @444589
     /*  444589 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(444675), // Rule ID 6009 //
     /*  444594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444641 */     // MIs[1] Operand 1
     /*  444641 */     // No operand predicates
     /*  444641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  444653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444673 */     GIR_RootConstrainSelectedInstOperands,
     /*  444674 */     // GIR_Coverage, 6009,
     /*  444674 */     GIR_EraseRootFromParent_Done,
     /*  444675 */   // Label 7688: @444675
     /*  444675 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(444761), // Rule ID 6012 //
     /*  444680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444727 */     // MIs[1] Operand 1
     /*  444727 */     // No operand predicates
     /*  444727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444759 */     GIR_RootConstrainSelectedInstOperands,
     /*  444760 */     // GIR_Coverage, 6012,
     /*  444760 */     GIR_EraseRootFromParent_Done,
     /*  444761 */   // Label 7689: @444761
     /*  444761 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(444847), // Rule ID 6013 //
     /*  444766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444813 */     // MIs[1] Operand 1
     /*  444813 */     // No operand predicates
     /*  444813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  444825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444845 */     GIR_RootConstrainSelectedInstOperands,
     /*  444846 */     // GIR_Coverage, 6013,
     /*  444846 */     GIR_EraseRootFromParent_Done,
     /*  444847 */   // Label 7690: @444847
     /*  444847 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(444933), // Rule ID 6016 //
     /*  444852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444899 */     // MIs[1] Operand 1
     /*  444899 */     // No operand predicates
     /*  444899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444931 */     GIR_RootConstrainSelectedInstOperands,
     /*  444932 */     // GIR_Coverage, 6016,
     /*  444932 */     GIR_EraseRootFromParent_Done,
     /*  444933 */   // Label 7691: @444933
     /*  444933 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(445019), // Rule ID 6017 //
     /*  444938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  444946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444985 */     // MIs[1] Operand 1
     /*  444985 */     // No operand predicates
     /*  444985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  444997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445017 */     GIR_RootConstrainSelectedInstOperands,
     /*  445018 */     // GIR_Coverage, 6017,
     /*  445018 */     GIR_EraseRootFromParent_Done,
     /*  445019 */   // Label 7692: @445019
     /*  445019 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(445105), // Rule ID 6020 //
     /*  445024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445071 */     // MIs[1] Operand 1
     /*  445071 */     // No operand predicates
     /*  445071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  445083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445103 */     GIR_RootConstrainSelectedInstOperands,
     /*  445104 */     // GIR_Coverage, 6020,
     /*  445104 */     GIR_EraseRootFromParent_Done,
     /*  445105 */   // Label 7693: @445105
     /*  445105 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(445191), // Rule ID 6021 //
     /*  445110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445157 */     // MIs[1] Operand 1
     /*  445157 */     // No operand predicates
     /*  445157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445166 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  445169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445189 */     GIR_RootConstrainSelectedInstOperands,
     /*  445190 */     // GIR_Coverage, 6021,
     /*  445190 */     GIR_EraseRootFromParent_Done,
     /*  445191 */   // Label 7694: @445191
     /*  445191 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(445277), // Rule ID 6024 //
     /*  445196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445243 */     // MIs[1] Operand 1
     /*  445243 */     // No operand predicates
     /*  445243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445252 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  445255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445275 */     GIR_RootConstrainSelectedInstOperands,
     /*  445276 */     // GIR_Coverage, 6024,
     /*  445276 */     GIR_EraseRootFromParent_Done,
     /*  445277 */   // Label 7695: @445277
     /*  445277 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(445363), // Rule ID 6025 //
     /*  445282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  445290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445329 */     // MIs[1] Operand 1
     /*  445329 */     // No operand predicates
     /*  445329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  445341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445361 */     GIR_RootConstrainSelectedInstOperands,
     /*  445362 */     // GIR_Coverage, 6025,
     /*  445362 */     GIR_EraseRootFromParent_Done,
     /*  445363 */   // Label 7696: @445363
     /*  445363 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(445449), // Rule ID 6204 //
     /*  445368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445415 */     // MIs[1] Operand 1
     /*  445415 */     // No operand predicates
     /*  445415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445424 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  445427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445447 */     GIR_RootConstrainSelectedInstOperands,
     /*  445448 */     // GIR_Coverage, 6204,
     /*  445448 */     GIR_EraseRootFromParent_Done,
     /*  445449 */   // Label 7697: @445449
     /*  445449 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(445535), // Rule ID 6205 //
     /*  445454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445501 */     // MIs[1] Operand 1
     /*  445501 */     // No operand predicates
     /*  445501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  445513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445533 */     GIR_RootConstrainSelectedInstOperands,
     /*  445534 */     // GIR_Coverage, 6205,
     /*  445534 */     GIR_EraseRootFromParent_Done,
     /*  445535 */   // Label 7698: @445535
     /*  445535 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(445621), // Rule ID 6208 //
     /*  445540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445587 */     // MIs[1] Operand 1
     /*  445587 */     // No operand predicates
     /*  445587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445619 */     GIR_RootConstrainSelectedInstOperands,
     /*  445620 */     // GIR_Coverage, 6208,
     /*  445620 */     GIR_EraseRootFromParent_Done,
     /*  445621 */   // Label 7699: @445621
     /*  445621 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(445707), // Rule ID 6209 //
     /*  445626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445673 */     // MIs[1] Operand 1
     /*  445673 */     // No operand predicates
     /*  445673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445705 */     GIR_RootConstrainSelectedInstOperands,
     /*  445706 */     // GIR_Coverage, 6209,
     /*  445706 */     GIR_EraseRootFromParent_Done,
     /*  445707 */   // Label 7700: @445707
     /*  445707 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(445793), // Rule ID 6212 //
     /*  445712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445759 */     // MIs[1] Operand 1
     /*  445759 */     // No operand predicates
     /*  445759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  445771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445791 */     GIR_RootConstrainSelectedInstOperands,
     /*  445792 */     // GIR_Coverage, 6212,
     /*  445792 */     GIR_EraseRootFromParent_Done,
     /*  445793 */   // Label 7701: @445793
     /*  445793 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(445879), // Rule ID 6213 //
     /*  445798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445845 */     // MIs[1] Operand 1
     /*  445845 */     // No operand predicates
     /*  445845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  445857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445877 */     GIR_RootConstrainSelectedInstOperands,
     /*  445878 */     // GIR_Coverage, 6213,
     /*  445878 */     GIR_EraseRootFromParent_Done,
     /*  445879 */   // Label 7702: @445879
     /*  445879 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(445965), // Rule ID 6216 //
     /*  445884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445931 */     // MIs[1] Operand 1
     /*  445931 */     // No operand predicates
     /*  445931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  445943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445963 */     GIR_RootConstrainSelectedInstOperands,
     /*  445964 */     // GIR_Coverage, 6216,
     /*  445964 */     GIR_EraseRootFromParent_Done,
     /*  445965 */   // Label 7703: @445965
     /*  445965 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(446051), // Rule ID 6217 //
     /*  445970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446017 */     // MIs[1] Operand 1
     /*  446017 */     // No operand predicates
     /*  446017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  446029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446049 */     GIR_RootConstrainSelectedInstOperands,
     /*  446050 */     // GIR_Coverage, 6217,
     /*  446050 */     GIR_EraseRootFromParent_Done,
     /*  446051 */   // Label 7704: @446051
     /*  446051 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(446137), // Rule ID 6220 //
     /*  446056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446103 */     // MIs[1] Operand 1
     /*  446103 */     // No operand predicates
     /*  446103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446135 */     GIR_RootConstrainSelectedInstOperands,
     /*  446136 */     // GIR_Coverage, 6220,
     /*  446136 */     GIR_EraseRootFromParent_Done,
     /*  446137 */   // Label 7705: @446137
     /*  446137 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(446223), // Rule ID 6221 //
     /*  446142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446189 */     // MIs[1] Operand 1
     /*  446189 */     // No operand predicates
     /*  446189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446221 */     GIR_RootConstrainSelectedInstOperands,
     /*  446222 */     // GIR_Coverage, 6221,
     /*  446222 */     GIR_EraseRootFromParent_Done,
     /*  446223 */   // Label 7706: @446223
     /*  446223 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(446309), // Rule ID 6224 //
     /*  446228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446275 */     // MIs[1] Operand 1
     /*  446275 */     // No operand predicates
     /*  446275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446307 */     GIR_RootConstrainSelectedInstOperands,
     /*  446308 */     // GIR_Coverage, 6224,
     /*  446308 */     GIR_EraseRootFromParent_Done,
     /*  446309 */   // Label 7707: @446309
     /*  446309 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(446395), // Rule ID 6225 //
     /*  446314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446361 */     // MIs[1] Operand 1
     /*  446361 */     // No operand predicates
     /*  446361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  446373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446393 */     GIR_RootConstrainSelectedInstOperands,
     /*  446394 */     // GIR_Coverage, 6225,
     /*  446394 */     GIR_EraseRootFromParent_Done,
     /*  446395 */   // Label 7708: @446395
     /*  446395 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(446481), // Rule ID 6228 //
     /*  446400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446447 */     // MIs[1] Operand 1
     /*  446447 */     // No operand predicates
     /*  446447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446479 */     GIR_RootConstrainSelectedInstOperands,
     /*  446480 */     // GIR_Coverage, 6228,
     /*  446480 */     GIR_EraseRootFromParent_Done,
     /*  446481 */   // Label 7709: @446481
     /*  446481 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(446567), // Rule ID 6229 //
     /*  446486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446533 */     // MIs[1] Operand 1
     /*  446533 */     // No operand predicates
     /*  446533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446565 */     GIR_RootConstrainSelectedInstOperands,
     /*  446566 */     // GIR_Coverage, 6229,
     /*  446566 */     GIR_EraseRootFromParent_Done,
     /*  446567 */   // Label 7710: @446567
     /*  446567 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(446653), // Rule ID 6232 //
     /*  446572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446619 */     // MIs[1] Operand 1
     /*  446619 */     // No operand predicates
     /*  446619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446651 */     GIR_RootConstrainSelectedInstOperands,
     /*  446652 */     // GIR_Coverage, 6232,
     /*  446652 */     GIR_EraseRootFromParent_Done,
     /*  446653 */   // Label 7711: @446653
     /*  446653 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(446739), // Rule ID 6233 //
     /*  446658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446705 */     // MIs[1] Operand 1
     /*  446705 */     // No operand predicates
     /*  446705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446737 */     GIR_RootConstrainSelectedInstOperands,
     /*  446738 */     // GIR_Coverage, 6233,
     /*  446738 */     GIR_EraseRootFromParent_Done,
     /*  446739 */   // Label 7712: @446739
     /*  446739 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(446825), // Rule ID 6236 //
     /*  446744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446791 */     // MIs[1] Operand 1
     /*  446791 */     // No operand predicates
     /*  446791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446823 */     GIR_RootConstrainSelectedInstOperands,
     /*  446824 */     // GIR_Coverage, 6236,
     /*  446824 */     GIR_EraseRootFromParent_Done,
     /*  446825 */   // Label 7713: @446825
     /*  446825 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(446911), // Rule ID 6237 //
     /*  446830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446877 */     // MIs[1] Operand 1
     /*  446877 */     // No operand predicates
     /*  446877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446909 */     GIR_RootConstrainSelectedInstOperands,
     /*  446910 */     // GIR_Coverage, 6237,
     /*  446910 */     GIR_EraseRootFromParent_Done,
     /*  446911 */   // Label 7714: @446911
     /*  446911 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(446997), // Rule ID 6240 //
     /*  446916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  446919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  446924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446963 */     // MIs[1] Operand 1
     /*  446963 */     // No operand predicates
     /*  446963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  446972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  446975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446995 */     GIR_RootConstrainSelectedInstOperands,
     /*  446996 */     // GIR_Coverage, 6240,
     /*  446996 */     GIR_EraseRootFromParent_Done,
     /*  446997 */   // Label 7715: @446997
     /*  446997 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(447083), // Rule ID 6241 //
     /*  447002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  447005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  447013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  447016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  447019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  447037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447049 */     // MIs[1] Operand 1
     /*  447049 */     // No operand predicates
     /*  447049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  447058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  447061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447081 */     GIR_RootConstrainSelectedInstOperands,
     /*  447082 */     // GIR_Coverage, 6241,
     /*  447082 */     GIR_EraseRootFromParent_Done,
     /*  447083 */   // Label 7716: @447083
     /*  447083 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(447169), // Rule ID 6244 //
     /*  447088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447135 */     // MIs[1] Operand 1
     /*  447135 */     // No operand predicates
     /*  447135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447167 */     GIR_RootConstrainSelectedInstOperands,
     /*  447168 */     // GIR_Coverage, 6244,
     /*  447168 */     GIR_EraseRootFromParent_Done,
     /*  447169 */   // Label 7717: @447169
     /*  447169 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(447255), // Rule ID 6245 //
     /*  447174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447221 */     // MIs[1] Operand 1
     /*  447221 */     // No operand predicates
     /*  447221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447253 */     GIR_RootConstrainSelectedInstOperands,
     /*  447254 */     // GIR_Coverage, 6245,
     /*  447254 */     GIR_EraseRootFromParent_Done,
     /*  447255 */   // Label 7718: @447255
     /*  447255 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(447341), // Rule ID 6248 //
     /*  447260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447307 */     // MIs[1] Operand 1
     /*  447307 */     // No operand predicates
     /*  447307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447339 */     GIR_RootConstrainSelectedInstOperands,
     /*  447340 */     // GIR_Coverage, 6248,
     /*  447340 */     GIR_EraseRootFromParent_Done,
     /*  447341 */   // Label 7719: @447341
     /*  447341 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(447427), // Rule ID 6249 //
     /*  447346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447393 */     // MIs[1] Operand 1
     /*  447393 */     // No operand predicates
     /*  447393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447425 */     GIR_RootConstrainSelectedInstOperands,
     /*  447426 */     // GIR_Coverage, 6249,
     /*  447426 */     GIR_EraseRootFromParent_Done,
     /*  447427 */   // Label 7720: @447427
     /*  447427 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(447513), // Rule ID 6252 //
     /*  447432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447479 */     // MIs[1] Operand 1
     /*  447479 */     // No operand predicates
     /*  447479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447488 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  447491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447511 */     GIR_RootConstrainSelectedInstOperands,
     /*  447512 */     // GIR_Coverage, 6252,
     /*  447512 */     GIR_EraseRootFromParent_Done,
     /*  447513 */   // Label 7721: @447513
     /*  447513 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(447599), // Rule ID 6253 //
     /*  447518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447565 */     // MIs[1] Operand 1
     /*  447565 */     // No operand predicates
     /*  447565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  447577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447597 */     GIR_RootConstrainSelectedInstOperands,
     /*  447598 */     // GIR_Coverage, 6253,
     /*  447598 */     GIR_EraseRootFromParent_Done,
     /*  447599 */   // Label 7722: @447599
     /*  447599 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(447685), // Rule ID 6256 //
     /*  447604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447651 */     // MIs[1] Operand 1
     /*  447651 */     // No operand predicates
     /*  447651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447683 */     GIR_RootConstrainSelectedInstOperands,
     /*  447684 */     // GIR_Coverage, 6256,
     /*  447684 */     GIR_EraseRootFromParent_Done,
     /*  447685 */   // Label 7723: @447685
     /*  447685 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(447771), // Rule ID 6257 //
     /*  447690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447737 */     // MIs[1] Operand 1
     /*  447737 */     // No operand predicates
     /*  447737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  447749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447769 */     GIR_RootConstrainSelectedInstOperands,
     /*  447770 */     // GIR_Coverage, 6257,
     /*  447770 */     GIR_EraseRootFromParent_Done,
     /*  447771 */   // Label 7724: @447771
     /*  447771 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(447857), // Rule ID 6260 //
     /*  447776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447823 */     // MIs[1] Operand 1
     /*  447823 */     // No operand predicates
     /*  447823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447855 */     GIR_RootConstrainSelectedInstOperands,
     /*  447856 */     // GIR_Coverage, 6260,
     /*  447856 */     GIR_EraseRootFromParent_Done,
     /*  447857 */   // Label 7725: @447857
     /*  447857 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(447943), // Rule ID 6261 //
     /*  447862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447909 */     // MIs[1] Operand 1
     /*  447909 */     // No operand predicates
     /*  447909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  447921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447941 */     GIR_RootConstrainSelectedInstOperands,
     /*  447942 */     // GIR_Coverage, 6261,
     /*  447942 */     GIR_EraseRootFromParent_Done,
     /*  447943 */   // Label 7726: @447943
     /*  447943 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(448029), // Rule ID 6264 //
     /*  447948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  447956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447995 */     // MIs[1] Operand 1
     /*  447995 */     // No operand predicates
     /*  447995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  448004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448027 */     GIR_RootConstrainSelectedInstOperands,
     /*  448028 */     // GIR_Coverage, 6264,
     /*  448028 */     GIR_EraseRootFromParent_Done,
     /*  448029 */   // Label 7727: @448029
     /*  448029 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(448115), // Rule ID 6265 //
     /*  448034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  448045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  448048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  448051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448081 */     // MIs[1] Operand 1
     /*  448081 */     // No operand predicates
     /*  448081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448113 */     GIR_RootConstrainSelectedInstOperands,
     /*  448114 */     // GIR_Coverage, 6265,
     /*  448114 */     GIR_EraseRootFromParent_Done,
     /*  448115 */   // Label 7728: @448115
     /*  448115 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(448201), // Rule ID 6268 //
     /*  448120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448167 */     // MIs[1] Operand 1
     /*  448167 */     // No operand predicates
     /*  448167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448199 */     GIR_RootConstrainSelectedInstOperands,
     /*  448200 */     // GIR_Coverage, 6268,
     /*  448200 */     GIR_EraseRootFromParent_Done,
     /*  448201 */   // Label 7729: @448201
     /*  448201 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(448287), // Rule ID 6269 //
     /*  448206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448253 */     // MIs[1] Operand 1
     /*  448253 */     // No operand predicates
     /*  448253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448285 */     GIR_RootConstrainSelectedInstOperands,
     /*  448286 */     // GIR_Coverage, 6269,
     /*  448286 */     GIR_EraseRootFromParent_Done,
     /*  448287 */   // Label 7730: @448287
     /*  448287 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(448373), // Rule ID 6272 //
     /*  448292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448339 */     // MIs[1] Operand 1
     /*  448339 */     // No operand predicates
     /*  448339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448371 */     GIR_RootConstrainSelectedInstOperands,
     /*  448372 */     // GIR_Coverage, 6272,
     /*  448372 */     GIR_EraseRootFromParent_Done,
     /*  448373 */   // Label 7731: @448373
     /*  448373 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(448459), // Rule ID 6273 //
     /*  448378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448425 */     // MIs[1] Operand 1
     /*  448425 */     // No operand predicates
     /*  448425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448457 */     GIR_RootConstrainSelectedInstOperands,
     /*  448458 */     // GIR_Coverage, 6273,
     /*  448458 */     GIR_EraseRootFromParent_Done,
     /*  448459 */   // Label 7732: @448459
     /*  448459 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(448545), // Rule ID 6276 //
     /*  448464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448511 */     // MIs[1] Operand 1
     /*  448511 */     // No operand predicates
     /*  448511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448543 */     GIR_RootConstrainSelectedInstOperands,
     /*  448544 */     // GIR_Coverage, 6276,
     /*  448544 */     GIR_EraseRootFromParent_Done,
     /*  448545 */   // Label 7733: @448545
     /*  448545 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(448631), // Rule ID 6277 //
     /*  448550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448597 */     // MIs[1] Operand 1
     /*  448597 */     // No operand predicates
     /*  448597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  448609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448629 */     GIR_RootConstrainSelectedInstOperands,
     /*  448630 */     // GIR_Coverage, 6277,
     /*  448630 */     GIR_EraseRootFromParent_Done,
     /*  448631 */   // Label 7734: @448631
     /*  448631 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(448717), // Rule ID 6280 //
     /*  448636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448683 */     // MIs[1] Operand 1
     /*  448683 */     // No operand predicates
     /*  448683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448715 */     GIR_RootConstrainSelectedInstOperands,
     /*  448716 */     // GIR_Coverage, 6280,
     /*  448716 */     GIR_EraseRootFromParent_Done,
     /*  448717 */   // Label 7735: @448717
     /*  448717 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(448803), // Rule ID 6281 //
     /*  448722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448769 */     // MIs[1] Operand 1
     /*  448769 */     // No operand predicates
     /*  448769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  448781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448801 */     GIR_RootConstrainSelectedInstOperands,
     /*  448802 */     // GIR_Coverage, 6281,
     /*  448802 */     GIR_EraseRootFromParent_Done,
     /*  448803 */   // Label 7736: @448803
     /*  448803 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(448889), // Rule ID 6284 //
     /*  448808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448855 */     // MIs[1] Operand 1
     /*  448855 */     // No operand predicates
     /*  448855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448887 */     GIR_RootConstrainSelectedInstOperands,
     /*  448888 */     // GIR_Coverage, 6284,
     /*  448888 */     GIR_EraseRootFromParent_Done,
     /*  448889 */   // Label 7737: @448889
     /*  448889 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(448975), // Rule ID 6285 //
     /*  448894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448941 */     // MIs[1] Operand 1
     /*  448941 */     // No operand predicates
     /*  448941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  448953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448973 */     GIR_RootConstrainSelectedInstOperands,
     /*  448974 */     // GIR_Coverage, 6285,
     /*  448974 */     GIR_EraseRootFromParent_Done,
     /*  448975 */   // Label 7738: @448975
     /*  448975 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(449061), // Rule ID 6288 //
     /*  448980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  448988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449027 */     // MIs[1] Operand 1
     /*  449027 */     // No operand predicates
     /*  449027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  449036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  449039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449059 */     GIR_RootConstrainSelectedInstOperands,
     /*  449060 */     // GIR_Coverage, 6288,
     /*  449060 */     GIR_EraseRootFromParent_Done,
     /*  449061 */   // Label 7739: @449061
     /*  449061 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(449147), // Rule ID 6289 //
     /*  449066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  449074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449113 */     // MIs[1] Operand 1
     /*  449113 */     // No operand predicates
     /*  449113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  449125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449145 */     GIR_RootConstrainSelectedInstOperands,
     /*  449146 */     // GIR_Coverage, 6289,
     /*  449146 */     GIR_EraseRootFromParent_Done,
     /*  449147 */   // Label 7740: @449147
     /*  449147 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(449233), // Rule ID 6468 //
     /*  449152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449199 */     // MIs[1] Operand 1
     /*  449199 */     // No operand predicates
     /*  449199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  449211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449231 */     GIR_RootConstrainSelectedInstOperands,
     /*  449232 */     // GIR_Coverage, 6468,
     /*  449232 */     GIR_EraseRootFromParent_Done,
     /*  449233 */   // Label 7741: @449233
     /*  449233 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(449319), // Rule ID 6469 //
     /*  449238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449285 */     // MIs[1] Operand 1
     /*  449285 */     // No operand predicates
     /*  449285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  449297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449317 */     GIR_RootConstrainSelectedInstOperands,
     /*  449318 */     // GIR_Coverage, 6469,
     /*  449318 */     GIR_EraseRootFromParent_Done,
     /*  449319 */   // Label 7742: @449319
     /*  449319 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(449405), // Rule ID 6472 //
     /*  449324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449371 */     // MIs[1] Operand 1
     /*  449371 */     // No operand predicates
     /*  449371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449403 */     GIR_RootConstrainSelectedInstOperands,
     /*  449404 */     // GIR_Coverage, 6472,
     /*  449404 */     GIR_EraseRootFromParent_Done,
     /*  449405 */   // Label 7743: @449405
     /*  449405 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(449491), // Rule ID 6473 //
     /*  449410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449457 */     // MIs[1] Operand 1
     /*  449457 */     // No operand predicates
     /*  449457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449489 */     GIR_RootConstrainSelectedInstOperands,
     /*  449490 */     // GIR_Coverage, 6473,
     /*  449490 */     GIR_EraseRootFromParent_Done,
     /*  449491 */   // Label 7744: @449491
     /*  449491 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(449577), // Rule ID 6476 //
     /*  449496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449543 */     // MIs[1] Operand 1
     /*  449543 */     // No operand predicates
     /*  449543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449575 */     GIR_RootConstrainSelectedInstOperands,
     /*  449576 */     // GIR_Coverage, 6476,
     /*  449576 */     GIR_EraseRootFromParent_Done,
     /*  449577 */   // Label 7745: @449577
     /*  449577 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(449663), // Rule ID 6477 //
     /*  449582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449629 */     // MIs[1] Operand 1
     /*  449629 */     // No operand predicates
     /*  449629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449661 */     GIR_RootConstrainSelectedInstOperands,
     /*  449662 */     // GIR_Coverage, 6477,
     /*  449662 */     GIR_EraseRootFromParent_Done,
     /*  449663 */   // Label 7746: @449663
     /*  449663 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(449749), // Rule ID 6480 //
     /*  449668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449715 */     // MIs[1] Operand 1
     /*  449715 */     // No operand predicates
     /*  449715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449747 */     GIR_RootConstrainSelectedInstOperands,
     /*  449748 */     // GIR_Coverage, 6480,
     /*  449748 */     GIR_EraseRootFromParent_Done,
     /*  449749 */   // Label 7747: @449749
     /*  449749 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(449835), // Rule ID 6481 //
     /*  449754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449801 */     // MIs[1] Operand 1
     /*  449801 */     // No operand predicates
     /*  449801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  449813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449833 */     GIR_RootConstrainSelectedInstOperands,
     /*  449834 */     // GIR_Coverage, 6481,
     /*  449834 */     GIR_EraseRootFromParent_Done,
     /*  449835 */   // Label 7748: @449835
     /*  449835 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(449921), // Rule ID 6484 //
     /*  449840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449887 */     // MIs[1] Operand 1
     /*  449887 */     // No operand predicates
     /*  449887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449919 */     GIR_RootConstrainSelectedInstOperands,
     /*  449920 */     // GIR_Coverage, 6484,
     /*  449920 */     GIR_EraseRootFromParent_Done,
     /*  449921 */   // Label 7749: @449921
     /*  449921 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(450007), // Rule ID 6485 //
     /*  449926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449973 */     // MIs[1] Operand 1
     /*  449973 */     // No operand predicates
     /*  449973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  449985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450005 */     GIR_RootConstrainSelectedInstOperands,
     /*  450006 */     // GIR_Coverage, 6485,
     /*  450006 */     GIR_EraseRootFromParent_Done,
     /*  450007 */   // Label 7750: @450007
     /*  450007 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(450093), // Rule ID 6488 //
     /*  450012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450059 */     // MIs[1] Operand 1
     /*  450059 */     // No operand predicates
     /*  450059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  450071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450091 */     GIR_RootConstrainSelectedInstOperands,
     /*  450092 */     // GIR_Coverage, 6488,
     /*  450092 */     GIR_EraseRootFromParent_Done,
     /*  450093 */   // Label 7751: @450093
     /*  450093 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(450179), // Rule ID 6489 //
     /*  450098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450145 */     // MIs[1] Operand 1
     /*  450145 */     // No operand predicates
     /*  450145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  450157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450177 */     GIR_RootConstrainSelectedInstOperands,
     /*  450178 */     // GIR_Coverage, 6489,
     /*  450178 */     GIR_EraseRootFromParent_Done,
     /*  450179 */   // Label 7752: @450179
     /*  450179 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(450265), // Rule ID 6492 //
     /*  450184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450231 */     // MIs[1] Operand 1
     /*  450231 */     // No operand predicates
     /*  450231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450263 */     GIR_RootConstrainSelectedInstOperands,
     /*  450264 */     // GIR_Coverage, 6492,
     /*  450264 */     GIR_EraseRootFromParent_Done,
     /*  450265 */   // Label 7753: @450265
     /*  450265 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(450351), // Rule ID 6493 //
     /*  450270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450317 */     // MIs[1] Operand 1
     /*  450317 */     // No operand predicates
     /*  450317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450349 */     GIR_RootConstrainSelectedInstOperands,
     /*  450350 */     // GIR_Coverage, 6493,
     /*  450350 */     GIR_EraseRootFromParent_Done,
     /*  450351 */   // Label 7754: @450351
     /*  450351 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(450437), // Rule ID 6496 //
     /*  450356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450403 */     // MIs[1] Operand 1
     /*  450403 */     // No operand predicates
     /*  450403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450435 */     GIR_RootConstrainSelectedInstOperands,
     /*  450436 */     // GIR_Coverage, 6496,
     /*  450436 */     GIR_EraseRootFromParent_Done,
     /*  450437 */   // Label 7755: @450437
     /*  450437 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(450523), // Rule ID 6497 //
     /*  450442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450489 */     // MIs[1] Operand 1
     /*  450489 */     // No operand predicates
     /*  450489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450521 */     GIR_RootConstrainSelectedInstOperands,
     /*  450522 */     // GIR_Coverage, 6497,
     /*  450522 */     GIR_EraseRootFromParent_Done,
     /*  450523 */   // Label 7756: @450523
     /*  450523 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(450609), // Rule ID 6500 //
     /*  450528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450575 */     // MIs[1] Operand 1
     /*  450575 */     // No operand predicates
     /*  450575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450607 */     GIR_RootConstrainSelectedInstOperands,
     /*  450608 */     // GIR_Coverage, 6500,
     /*  450608 */     GIR_EraseRootFromParent_Done,
     /*  450609 */   // Label 7757: @450609
     /*  450609 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(450695), // Rule ID 6501 //
     /*  450614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450661 */     // MIs[1] Operand 1
     /*  450661 */     // No operand predicates
     /*  450661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450693 */     GIR_RootConstrainSelectedInstOperands,
     /*  450694 */     // GIR_Coverage, 6501,
     /*  450694 */     GIR_EraseRootFromParent_Done,
     /*  450695 */   // Label 7758: @450695
     /*  450695 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(450781), // Rule ID 6504 //
     /*  450700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  450703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450747 */     // MIs[1] Operand 1
     /*  450747 */     // No operand predicates
     /*  450747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  450756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450779 */     GIR_RootConstrainSelectedInstOperands,
     /*  450780 */     // GIR_Coverage, 6504,
     /*  450780 */     GIR_EraseRootFromParent_Done,
     /*  450781 */   // Label 7759: @450781
     /*  450781 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(450867), // Rule ID 6505 //
     /*  450786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  450789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450833 */     // MIs[1] Operand 1
     /*  450833 */     // No operand predicates
     /*  450833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  450842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  450845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450865 */     GIR_RootConstrainSelectedInstOperands,
     /*  450866 */     // GIR_Coverage, 6505,
     /*  450866 */     GIR_EraseRootFromParent_Done,
     /*  450867 */   // Label 7760: @450867
     /*  450867 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(450953), // Rule ID 6508 //
     /*  450872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  450919 */     // MIs[1] Operand 1
     /*  450919 */     // No operand predicates
     /*  450919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  450931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450951 */     GIR_RootConstrainSelectedInstOperands,
     /*  450952 */     // GIR_Coverage, 6508,
     /*  450952 */     GIR_EraseRootFromParent_Done,
     /*  450953 */   // Label 7761: @450953
     /*  450953 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(451039), // Rule ID 6509 //
     /*  450958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  450966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451005 */     // MIs[1] Operand 1
     /*  451005 */     // No operand predicates
     /*  451005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451037 */     GIR_RootConstrainSelectedInstOperands,
     /*  451038 */     // GIR_Coverage, 6509,
     /*  451038 */     GIR_EraseRootFromParent_Done,
     /*  451039 */   // Label 7762: @451039
     /*  451039 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(451125), // Rule ID 6512 //
     /*  451044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451091 */     // MIs[1] Operand 1
     /*  451091 */     // No operand predicates
     /*  451091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451123 */     GIR_RootConstrainSelectedInstOperands,
     /*  451124 */     // GIR_Coverage, 6512,
     /*  451124 */     GIR_EraseRootFromParent_Done,
     /*  451125 */   // Label 7763: @451125
     /*  451125 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(451211), // Rule ID 6513 //
     /*  451130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451177 */     // MIs[1] Operand 1
     /*  451177 */     // No operand predicates
     /*  451177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451209 */     GIR_RootConstrainSelectedInstOperands,
     /*  451210 */     // GIR_Coverage, 6513,
     /*  451210 */     GIR_EraseRootFromParent_Done,
     /*  451211 */   // Label 7764: @451211
     /*  451211 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(451297), // Rule ID 6516 //
     /*  451216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451263 */     // MIs[1] Operand 1
     /*  451263 */     // No operand predicates
     /*  451263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451295 */     GIR_RootConstrainSelectedInstOperands,
     /*  451296 */     // GIR_Coverage, 6516,
     /*  451296 */     GIR_EraseRootFromParent_Done,
     /*  451297 */   // Label 7765: @451297
     /*  451297 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(451383), // Rule ID 6517 //
     /*  451302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451349 */     // MIs[1] Operand 1
     /*  451349 */     // No operand predicates
     /*  451349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451381 */     GIR_RootConstrainSelectedInstOperands,
     /*  451382 */     // GIR_Coverage, 6517,
     /*  451382 */     GIR_EraseRootFromParent_Done,
     /*  451383 */   // Label 7766: @451383
     /*  451383 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(451469), // Rule ID 6520 //
     /*  451388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451435 */     // MIs[1] Operand 1
     /*  451435 */     // No operand predicates
     /*  451435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451467 */     GIR_RootConstrainSelectedInstOperands,
     /*  451468 */     // GIR_Coverage, 6520,
     /*  451468 */     GIR_EraseRootFromParent_Done,
     /*  451469 */   // Label 7767: @451469
     /*  451469 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(451555), // Rule ID 6521 //
     /*  451474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451521 */     // MIs[1] Operand 1
     /*  451521 */     // No operand predicates
     /*  451521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451553 */     GIR_RootConstrainSelectedInstOperands,
     /*  451554 */     // GIR_Coverage, 6521,
     /*  451554 */     GIR_EraseRootFromParent_Done,
     /*  451555 */   // Label 7768: @451555
     /*  451555 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(451641), // Rule ID 6524 //
     /*  451560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451607 */     // MIs[1] Operand 1
     /*  451607 */     // No operand predicates
     /*  451607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451639 */     GIR_RootConstrainSelectedInstOperands,
     /*  451640 */     // GIR_Coverage, 6524,
     /*  451640 */     GIR_EraseRootFromParent_Done,
     /*  451641 */   // Label 7769: @451641
     /*  451641 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(451727), // Rule ID 6525 //
     /*  451646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451693 */     // MIs[1] Operand 1
     /*  451693 */     // No operand predicates
     /*  451693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  451705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451725 */     GIR_RootConstrainSelectedInstOperands,
     /*  451726 */     // GIR_Coverage, 6525,
     /*  451726 */     GIR_EraseRootFromParent_Done,
     /*  451727 */   // Label 7770: @451727
     /*  451727 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(451813), // Rule ID 6528 //
     /*  451732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451779 */     // MIs[1] Operand 1
     /*  451779 */     // No operand predicates
     /*  451779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451811 */     GIR_RootConstrainSelectedInstOperands,
     /*  451812 */     // GIR_Coverage, 6528,
     /*  451812 */     GIR_EraseRootFromParent_Done,
     /*  451813 */   // Label 7771: @451813
     /*  451813 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(451899), // Rule ID 6529 //
     /*  451818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451865 */     // MIs[1] Operand 1
     /*  451865 */     // No operand predicates
     /*  451865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  451877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451897 */     GIR_RootConstrainSelectedInstOperands,
     /*  451898 */     // GIR_Coverage, 6529,
     /*  451898 */     GIR_EraseRootFromParent_Done,
     /*  451899 */   // Label 7772: @451899
     /*  451899 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(451985), // Rule ID 6532 //
     /*  451904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  451951 */     // MIs[1] Operand 1
     /*  451951 */     // No operand predicates
     /*  451951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  451963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451983 */     GIR_RootConstrainSelectedInstOperands,
     /*  451984 */     // GIR_Coverage, 6532,
     /*  451984 */     GIR_EraseRootFromParent_Done,
     /*  451985 */   // Label 7773: @451985
     /*  451985 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(452071), // Rule ID 6533 //
     /*  451990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  451998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  452001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  452004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  452007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452037 */     // MIs[1] Operand 1
     /*  452037 */     // No operand predicates
     /*  452037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452069 */     GIR_RootConstrainSelectedInstOperands,
     /*  452070 */     // GIR_Coverage, 6533,
     /*  452070 */     GIR_EraseRootFromParent_Done,
     /*  452071 */   // Label 7774: @452071
     /*  452071 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(452157), // Rule ID 6536 //
     /*  452076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452123 */     // MIs[1] Operand 1
     /*  452123 */     // No operand predicates
     /*  452123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452155 */     GIR_RootConstrainSelectedInstOperands,
     /*  452156 */     // GIR_Coverage, 6536,
     /*  452156 */     GIR_EraseRootFromParent_Done,
     /*  452157 */   // Label 7775: @452157
     /*  452157 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(452243), // Rule ID 6537 //
     /*  452162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452209 */     // MIs[1] Operand 1
     /*  452209 */     // No operand predicates
     /*  452209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452241 */     GIR_RootConstrainSelectedInstOperands,
     /*  452242 */     // GIR_Coverage, 6537,
     /*  452242 */     GIR_EraseRootFromParent_Done,
     /*  452243 */   // Label 7776: @452243
     /*  452243 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(452329), // Rule ID 6540 //
     /*  452248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452295 */     // MIs[1] Operand 1
     /*  452295 */     // No operand predicates
     /*  452295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452327 */     GIR_RootConstrainSelectedInstOperands,
     /*  452328 */     // GIR_Coverage, 6540,
     /*  452328 */     GIR_EraseRootFromParent_Done,
     /*  452329 */   // Label 7777: @452329
     /*  452329 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(452415), // Rule ID 6541 //
     /*  452334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452381 */     // MIs[1] Operand 1
     /*  452381 */     // No operand predicates
     /*  452381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452413 */     GIR_RootConstrainSelectedInstOperands,
     /*  452414 */     // GIR_Coverage, 6541,
     /*  452414 */     GIR_EraseRootFromParent_Done,
     /*  452415 */   // Label 7778: @452415
     /*  452415 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(452501), // Rule ID 6544 //
     /*  452420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452467 */     // MIs[1] Operand 1
     /*  452467 */     // No operand predicates
     /*  452467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452499 */     GIR_RootConstrainSelectedInstOperands,
     /*  452500 */     // GIR_Coverage, 6544,
     /*  452500 */     GIR_EraseRootFromParent_Done,
     /*  452501 */   // Label 7779: @452501
     /*  452501 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(452587), // Rule ID 6545 //
     /*  452506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452553 */     // MIs[1] Operand 1
     /*  452553 */     // No operand predicates
     /*  452553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  452565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452585 */     GIR_RootConstrainSelectedInstOperands,
     /*  452586 */     // GIR_Coverage, 6545,
     /*  452586 */     GIR_EraseRootFromParent_Done,
     /*  452587 */   // Label 7780: @452587
     /*  452587 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(452673), // Rule ID 6548 //
     /*  452592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452639 */     // MIs[1] Operand 1
     /*  452639 */     // No operand predicates
     /*  452639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452671 */     GIR_RootConstrainSelectedInstOperands,
     /*  452672 */     // GIR_Coverage, 6548,
     /*  452672 */     GIR_EraseRootFromParent_Done,
     /*  452673 */   // Label 7781: @452673
     /*  452673 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(452759), // Rule ID 6549 //
     /*  452678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452725 */     // MIs[1] Operand 1
     /*  452725 */     // No operand predicates
     /*  452725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  452737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452757 */     GIR_RootConstrainSelectedInstOperands,
     /*  452758 */     // GIR_Coverage, 6549,
     /*  452758 */     GIR_EraseRootFromParent_Done,
     /*  452759 */   // Label 7782: @452759
     /*  452759 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(452845), // Rule ID 6552 //
     /*  452764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452811 */     // MIs[1] Operand 1
     /*  452811 */     // No operand predicates
     /*  452811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452843 */     GIR_RootConstrainSelectedInstOperands,
     /*  452844 */     // GIR_Coverage, 6552,
     /*  452844 */     GIR_EraseRootFromParent_Done,
     /*  452845 */   // Label 7783: @452845
     /*  452845 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(452931), // Rule ID 6553 //
     /*  452850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  452858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  452897 */     // MIs[1] Operand 1
     /*  452897 */     // No operand predicates
     /*  452897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  452909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452929 */     GIR_RootConstrainSelectedInstOperands,
     /*  452930 */     // GIR_Coverage, 6553,
     /*  452930 */     GIR_EraseRootFromParent_Done,
     /*  452931 */   // Label 7784: @452931
     /*  452931 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(453017), // Rule ID 6732 //
     /*  452936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452983 */     // MIs[1] Operand 1
     /*  452983 */     // No operand predicates
     /*  452983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  452995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453015 */     GIR_RootConstrainSelectedInstOperands,
     /*  453016 */     // GIR_Coverage, 6732,
     /*  453016 */     GIR_EraseRootFromParent_Done,
     /*  453017 */   // Label 7785: @453017
     /*  453017 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(453103), // Rule ID 6733 //
     /*  453022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  453033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  453036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  453039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453069 */     // MIs[1] Operand 1
     /*  453069 */     // No operand predicates
     /*  453069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  453081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453101 */     GIR_RootConstrainSelectedInstOperands,
     /*  453102 */     // GIR_Coverage, 6733,
     /*  453102 */     GIR_EraseRootFromParent_Done,
     /*  453103 */   // Label 7786: @453103
     /*  453103 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(453189), // Rule ID 6736 //
     /*  453108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453155 */     // MIs[1] Operand 1
     /*  453155 */     // No operand predicates
     /*  453155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453164 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453187 */     GIR_RootConstrainSelectedInstOperands,
     /*  453188 */     // GIR_Coverage, 6736,
     /*  453188 */     GIR_EraseRootFromParent_Done,
     /*  453189 */   // Label 7787: @453189
     /*  453189 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(453275), // Rule ID 6737 //
     /*  453194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453241 */     // MIs[1] Operand 1
     /*  453241 */     // No operand predicates
     /*  453241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453250 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453273 */     GIR_RootConstrainSelectedInstOperands,
     /*  453274 */     // GIR_Coverage, 6737,
     /*  453274 */     GIR_EraseRootFromParent_Done,
     /*  453275 */   // Label 7788: @453275
     /*  453275 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(453361), // Rule ID 6740 //
     /*  453280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453327 */     // MIs[1] Operand 1
     /*  453327 */     // No operand predicates
     /*  453327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453359 */     GIR_RootConstrainSelectedInstOperands,
     /*  453360 */     // GIR_Coverage, 6740,
     /*  453360 */     GIR_EraseRootFromParent_Done,
     /*  453361 */   // Label 7789: @453361
     /*  453361 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(453447), // Rule ID 6741 //
     /*  453366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453413 */     // MIs[1] Operand 1
     /*  453413 */     // No operand predicates
     /*  453413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453422 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453445 */     GIR_RootConstrainSelectedInstOperands,
     /*  453446 */     // GIR_Coverage, 6741,
     /*  453446 */     GIR_EraseRootFromParent_Done,
     /*  453447 */   // Label 7790: @453447
     /*  453447 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(453533), // Rule ID 6744 //
     /*  453452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453499 */     // MIs[1] Operand 1
     /*  453499 */     // No operand predicates
     /*  453499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453508 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453531 */     GIR_RootConstrainSelectedInstOperands,
     /*  453532 */     // GIR_Coverage, 6744,
     /*  453532 */     GIR_EraseRootFromParent_Done,
     /*  453533 */   // Label 7791: @453533
     /*  453533 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(453619), // Rule ID 6745 //
     /*  453538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453585 */     // MIs[1] Operand 1
     /*  453585 */     // No operand predicates
     /*  453585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  453597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453617 */     GIR_RootConstrainSelectedInstOperands,
     /*  453618 */     // GIR_Coverage, 6745,
     /*  453618 */     GIR_EraseRootFromParent_Done,
     /*  453619 */   // Label 7792: @453619
     /*  453619 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(453705), // Rule ID 6748 //
     /*  453624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453671 */     // MIs[1] Operand 1
     /*  453671 */     // No operand predicates
     /*  453671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453703 */     GIR_RootConstrainSelectedInstOperands,
     /*  453704 */     // GIR_Coverage, 6748,
     /*  453704 */     GIR_EraseRootFromParent_Done,
     /*  453705 */   // Label 7793: @453705
     /*  453705 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(453791), // Rule ID 6749 //
     /*  453710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453757 */     // MIs[1] Operand 1
     /*  453757 */     // No operand predicates
     /*  453757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453766 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453789 */     GIR_RootConstrainSelectedInstOperands,
     /*  453790 */     // GIR_Coverage, 6749,
     /*  453790 */     GIR_EraseRootFromParent_Done,
     /*  453791 */   // Label 7794: @453791
     /*  453791 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(453877), // Rule ID 6752 //
     /*  453796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453843 */     // MIs[1] Operand 1
     /*  453843 */     // No operand predicates
     /*  453843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453875 */     GIR_RootConstrainSelectedInstOperands,
     /*  453876 */     // GIR_Coverage, 6752,
     /*  453876 */     GIR_EraseRootFromParent_Done,
     /*  453877 */   // Label 7795: @453877
     /*  453877 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(453963), // Rule ID 6753 //
     /*  453882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453929 */     // MIs[1] Operand 1
     /*  453929 */     // No operand predicates
     /*  453929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  453941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453961 */     GIR_RootConstrainSelectedInstOperands,
     /*  453962 */     // GIR_Coverage, 6753,
     /*  453962 */     GIR_EraseRootFromParent_Done,
     /*  453963 */   // Label 7796: @453963
     /*  453963 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(454049), // Rule ID 6756 //
     /*  453968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  453976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454015 */     // MIs[1] Operand 1
     /*  454015 */     // No operand predicates
     /*  454015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454047 */     GIR_RootConstrainSelectedInstOperands,
     /*  454048 */     // GIR_Coverage, 6756,
     /*  454048 */     GIR_EraseRootFromParent_Done,
     /*  454049 */   // Label 7797: @454049
     /*  454049 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(454135), // Rule ID 6757 //
     /*  454054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454101 */     // MIs[1] Operand 1
     /*  454101 */     // No operand predicates
     /*  454101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454133 */     GIR_RootConstrainSelectedInstOperands,
     /*  454134 */     // GIR_Coverage, 6757,
     /*  454134 */     GIR_EraseRootFromParent_Done,
     /*  454135 */   // Label 7798: @454135
     /*  454135 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(454221), // Rule ID 6760 //
     /*  454140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454187 */     // MIs[1] Operand 1
     /*  454187 */     // No operand predicates
     /*  454187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454219 */     GIR_RootConstrainSelectedInstOperands,
     /*  454220 */     // GIR_Coverage, 6760,
     /*  454220 */     GIR_EraseRootFromParent_Done,
     /*  454221 */   // Label 7799: @454221
     /*  454221 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(454307), // Rule ID 6761 //
     /*  454226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454273 */     // MIs[1] Operand 1
     /*  454273 */     // No operand predicates
     /*  454273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454305 */     GIR_RootConstrainSelectedInstOperands,
     /*  454306 */     // GIR_Coverage, 6761,
     /*  454306 */     GIR_EraseRootFromParent_Done,
     /*  454307 */   // Label 7800: @454307
     /*  454307 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(454393), // Rule ID 6764 //
     /*  454312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454359 */     // MIs[1] Operand 1
     /*  454359 */     // No operand predicates
     /*  454359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454391 */     GIR_RootConstrainSelectedInstOperands,
     /*  454392 */     // GIR_Coverage, 6764,
     /*  454392 */     GIR_EraseRootFromParent_Done,
     /*  454393 */   // Label 7801: @454393
     /*  454393 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(454479), // Rule ID 6765 //
     /*  454398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454445 */     // MIs[1] Operand 1
     /*  454445 */     // No operand predicates
     /*  454445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454477 */     GIR_RootConstrainSelectedInstOperands,
     /*  454478 */     // GIR_Coverage, 6765,
     /*  454478 */     GIR_EraseRootFromParent_Done,
     /*  454479 */   // Label 7802: @454479
     /*  454479 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(454565), // Rule ID 6768 //
     /*  454484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454531 */     // MIs[1] Operand 1
     /*  454531 */     // No operand predicates
     /*  454531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454563 */     GIR_RootConstrainSelectedInstOperands,
     /*  454564 */     // GIR_Coverage, 6768,
     /*  454564 */     GIR_EraseRootFromParent_Done,
     /*  454565 */   // Label 7803: @454565
     /*  454565 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(454651), // Rule ID 6769 //
     /*  454570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454617 */     // MIs[1] Operand 1
     /*  454617 */     // No operand predicates
     /*  454617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  454629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454649 */     GIR_RootConstrainSelectedInstOperands,
     /*  454650 */     // GIR_Coverage, 6769,
     /*  454650 */     GIR_EraseRootFromParent_Done,
     /*  454651 */   // Label 7804: @454651
     /*  454651 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(454737), // Rule ID 6772 //
     /*  454656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454703 */     // MIs[1] Operand 1
     /*  454703 */     // No operand predicates
     /*  454703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  454715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454735 */     GIR_RootConstrainSelectedInstOperands,
     /*  454736 */     // GIR_Coverage, 6772,
     /*  454736 */     GIR_EraseRootFromParent_Done,
     /*  454737 */   // Label 7805: @454737
     /*  454737 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(454823), // Rule ID 6773 //
     /*  454742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454789 */     // MIs[1] Operand 1
     /*  454789 */     // No operand predicates
     /*  454789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454798 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  454801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454821 */     GIR_RootConstrainSelectedInstOperands,
     /*  454822 */     // GIR_Coverage, 6773,
     /*  454822 */     GIR_EraseRootFromParent_Done,
     /*  454823 */   // Label 7806: @454823
     /*  454823 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(454909), // Rule ID 6776 //
     /*  454828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454875 */     // MIs[1] Operand 1
     /*  454875 */     // No operand predicates
     /*  454875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454884 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  454887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454907 */     GIR_RootConstrainSelectedInstOperands,
     /*  454908 */     // GIR_Coverage, 6776,
     /*  454908 */     GIR_EraseRootFromParent_Done,
     /*  454909 */   // Label 7807: @454909
     /*  454909 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(454995), // Rule ID 6777 //
     /*  454914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  454922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454961 */     // MIs[1] Operand 1
     /*  454961 */     // No operand predicates
     /*  454961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  454973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454993 */     GIR_RootConstrainSelectedInstOperands,
     /*  454994 */     // GIR_Coverage, 6777,
     /*  454994 */     GIR_EraseRootFromParent_Done,
     /*  454995 */   // Label 7808: @454995
     /*  454995 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(455081), // Rule ID 6780 //
     /*  455000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455047 */     // MIs[1] Operand 1
     /*  455047 */     // No operand predicates
     /*  455047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455056 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  455056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455079 */     GIR_RootConstrainSelectedInstOperands,
     /*  455080 */     // GIR_Coverage, 6780,
     /*  455080 */     GIR_EraseRootFromParent_Done,
     /*  455081 */   // Label 7809: @455081
     /*  455081 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(455167), // Rule ID 6781 //
     /*  455086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455133 */     // MIs[1] Operand 1
     /*  455133 */     // No operand predicates
     /*  455133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455142 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455165 */     GIR_RootConstrainSelectedInstOperands,
     /*  455166 */     // GIR_Coverage, 6781,
     /*  455166 */     GIR_EraseRootFromParent_Done,
     /*  455167 */   // Label 7810: @455167
     /*  455167 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(455253), // Rule ID 6784 //
     /*  455172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455219 */     // MIs[1] Operand 1
     /*  455219 */     // No operand predicates
     /*  455219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455251 */     GIR_RootConstrainSelectedInstOperands,
     /*  455252 */     // GIR_Coverage, 6784,
     /*  455252 */     GIR_EraseRootFromParent_Done,
     /*  455253 */   // Label 7811: @455253
     /*  455253 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(455339), // Rule ID 6785 //
     /*  455258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455305 */     // MIs[1] Operand 1
     /*  455305 */     // No operand predicates
     /*  455305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455337 */     GIR_RootConstrainSelectedInstOperands,
     /*  455338 */     // GIR_Coverage, 6785,
     /*  455338 */     GIR_EraseRootFromParent_Done,
     /*  455339 */   // Label 7812: @455339
     /*  455339 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(455425), // Rule ID 6788 //
     /*  455344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455391 */     // MIs[1] Operand 1
     /*  455391 */     // No operand predicates
     /*  455391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455423 */     GIR_RootConstrainSelectedInstOperands,
     /*  455424 */     // GIR_Coverage, 6788,
     /*  455424 */     GIR_EraseRootFromParent_Done,
     /*  455425 */   // Label 7813: @455425
     /*  455425 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(455511), // Rule ID 6789 //
     /*  455430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455477 */     // MIs[1] Operand 1
     /*  455477 */     // No operand predicates
     /*  455477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455509 */     GIR_RootConstrainSelectedInstOperands,
     /*  455510 */     // GIR_Coverage, 6789,
     /*  455510 */     GIR_EraseRootFromParent_Done,
     /*  455511 */   // Label 7814: @455511
     /*  455511 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(455597), // Rule ID 6792 //
     /*  455516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455563 */     // MIs[1] Operand 1
     /*  455563 */     // No operand predicates
     /*  455563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455595 */     GIR_RootConstrainSelectedInstOperands,
     /*  455596 */     // GIR_Coverage, 6792,
     /*  455596 */     GIR_EraseRootFromParent_Done,
     /*  455597 */   // Label 7815: @455597
     /*  455597 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(455683), // Rule ID 6793 //
     /*  455602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455649 */     // MIs[1] Operand 1
     /*  455649 */     // No operand predicates
     /*  455649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  455661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455681 */     GIR_RootConstrainSelectedInstOperands,
     /*  455682 */     // GIR_Coverage, 6793,
     /*  455682 */     GIR_EraseRootFromParent_Done,
     /*  455683 */   // Label 7816: @455683
     /*  455683 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(455769), // Rule ID 6796 //
     /*  455688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455735 */     // MIs[1] Operand 1
     /*  455735 */     // No operand predicates
     /*  455735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455767 */     GIR_RootConstrainSelectedInstOperands,
     /*  455768 */     // GIR_Coverage, 6796,
     /*  455768 */     GIR_EraseRootFromParent_Done,
     /*  455769 */   // Label 7817: @455769
     /*  455769 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(455855), // Rule ID 6797 //
     /*  455774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455821 */     // MIs[1] Operand 1
     /*  455821 */     // No operand predicates
     /*  455821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  455833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455853 */     GIR_RootConstrainSelectedInstOperands,
     /*  455854 */     // GIR_Coverage, 6797,
     /*  455854 */     GIR_EraseRootFromParent_Done,
     /*  455855 */   // Label 7818: @455855
     /*  455855 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(455941), // Rule ID 6800 //
     /*  455860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455907 */     // MIs[1] Operand 1
     /*  455907 */     // No operand predicates
     /*  455907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  455919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455939 */     GIR_RootConstrainSelectedInstOperands,
     /*  455940 */     // GIR_Coverage, 6800,
     /*  455940 */     GIR_EraseRootFromParent_Done,
     /*  455941 */   // Label 7819: @455941
     /*  455941 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(456027), // Rule ID 6801 //
     /*  455946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  455954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455993 */     // MIs[1] Operand 1
     /*  455993 */     // No operand predicates
     /*  455993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456025 */     GIR_RootConstrainSelectedInstOperands,
     /*  456026 */     // GIR_Coverage, 6801,
     /*  456026 */     GIR_EraseRootFromParent_Done,
     /*  456027 */   // Label 7820: @456027
     /*  456027 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(456113), // Rule ID 6804 //
     /*  456032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456079 */     // MIs[1] Operand 1
     /*  456079 */     // No operand predicates
     /*  456079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456111 */     GIR_RootConstrainSelectedInstOperands,
     /*  456112 */     // GIR_Coverage, 6804,
     /*  456112 */     GIR_EraseRootFromParent_Done,
     /*  456113 */   // Label 7821: @456113
     /*  456113 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(456199), // Rule ID 6805 //
     /*  456118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456165 */     // MIs[1] Operand 1
     /*  456165 */     // No operand predicates
     /*  456165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456197 */     GIR_RootConstrainSelectedInstOperands,
     /*  456198 */     // GIR_Coverage, 6805,
     /*  456198 */     GIR_EraseRootFromParent_Done,
     /*  456199 */   // Label 7822: @456199
     /*  456199 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(456285), // Rule ID 6808 //
     /*  456204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456251 */     // MIs[1] Operand 1
     /*  456251 */     // No operand predicates
     /*  456251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  456263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456283 */     GIR_RootConstrainSelectedInstOperands,
     /*  456284 */     // GIR_Coverage, 6808,
     /*  456284 */     GIR_EraseRootFromParent_Done,
     /*  456285 */   // Label 7823: @456285
     /*  456285 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(456371), // Rule ID 6809 //
     /*  456290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456337 */     // MIs[1] Operand 1
     /*  456337 */     // No operand predicates
     /*  456337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  456349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456369 */     GIR_RootConstrainSelectedInstOperands,
     /*  456370 */     // GIR_Coverage, 6809,
     /*  456370 */     GIR_EraseRootFromParent_Done,
     /*  456371 */   // Label 7824: @456371
     /*  456371 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(456457), // Rule ID 6812 //
     /*  456376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456423 */     // MIs[1] Operand 1
     /*  456423 */     // No operand predicates
     /*  456423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456455 */     GIR_RootConstrainSelectedInstOperands,
     /*  456456 */     // GIR_Coverage, 6812,
     /*  456456 */     GIR_EraseRootFromParent_Done,
     /*  456457 */   // Label 7825: @456457
     /*  456457 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(456543), // Rule ID 6813 //
     /*  456462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456509 */     // MIs[1] Operand 1
     /*  456509 */     // No operand predicates
     /*  456509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  456521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456541 */     GIR_RootConstrainSelectedInstOperands,
     /*  456542 */     // GIR_Coverage, 6813,
     /*  456542 */     GIR_EraseRootFromParent_Done,
     /*  456543 */   // Label 7826: @456543
     /*  456543 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(456629), // Rule ID 6816 //
     /*  456548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456595 */     // MIs[1] Operand 1
     /*  456595 */     // No operand predicates
     /*  456595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456627 */     GIR_RootConstrainSelectedInstOperands,
     /*  456628 */     // GIR_Coverage, 6816,
     /*  456628 */     GIR_EraseRootFromParent_Done,
     /*  456629 */   // Label 7827: @456629
     /*  456629 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(456715), // Rule ID 6817 //
     /*  456634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  456642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456681 */     // MIs[1] Operand 1
     /*  456681 */     // No operand predicates
     /*  456681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  456693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456713 */     GIR_RootConstrainSelectedInstOperands,
     /*  456714 */     // GIR_Coverage, 6817,
     /*  456714 */     GIR_EraseRootFromParent_Done,
     /*  456715 */   // Label 7828: @456715
     /*  456715 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(456801), // Rule ID 6996 //
     /*  456720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456767 */     // MIs[1] Operand 1
     /*  456767 */     // No operand predicates
     /*  456767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  456779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456799 */     GIR_RootConstrainSelectedInstOperands,
     /*  456800 */     // GIR_Coverage, 6996,
     /*  456800 */     GIR_EraseRootFromParent_Done,
     /*  456801 */   // Label 7829: @456801
     /*  456801 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(456887), // Rule ID 6997 //
     /*  456806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456853 */     // MIs[1] Operand 1
     /*  456853 */     // No operand predicates
     /*  456853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456862 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  456865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456885 */     GIR_RootConstrainSelectedInstOperands,
     /*  456886 */     // GIR_Coverage, 6997,
     /*  456886 */     GIR_EraseRootFromParent_Done,
     /*  456887 */   // Label 7830: @456887
     /*  456887 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(456973), // Rule ID 7000 //
     /*  456892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456939 */     // MIs[1] Operand 1
     /*  456939 */     // No operand predicates
     /*  456939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  456951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456971 */     GIR_RootConstrainSelectedInstOperands,
     /*  456972 */     // GIR_Coverage, 7000,
     /*  456972 */     GIR_EraseRootFromParent_Done,
     /*  456973 */   // Label 7831: @456973
     /*  456973 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(457059), // Rule ID 7001 //
     /*  456978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457025 */     // MIs[1] Operand 1
     /*  457025 */     // No operand predicates
     /*  457025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457057 */     GIR_RootConstrainSelectedInstOperands,
     /*  457058 */     // GIR_Coverage, 7001,
     /*  457058 */     GIR_EraseRootFromParent_Done,
     /*  457059 */   // Label 7832: @457059
     /*  457059 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(457145), // Rule ID 7004 //
     /*  457064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457111 */     // MIs[1] Operand 1
     /*  457111 */     // No operand predicates
     /*  457111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457120 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457143 */     GIR_RootConstrainSelectedInstOperands,
     /*  457144 */     // GIR_Coverage, 7004,
     /*  457144 */     GIR_EraseRootFromParent_Done,
     /*  457145 */   // Label 7833: @457145
     /*  457145 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(457231), // Rule ID 7005 //
     /*  457150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457197 */     // MIs[1] Operand 1
     /*  457197 */     // No operand predicates
     /*  457197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457206 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457229 */     GIR_RootConstrainSelectedInstOperands,
     /*  457230 */     // GIR_Coverage, 7005,
     /*  457230 */     GIR_EraseRootFromParent_Done,
     /*  457231 */   // Label 7834: @457231
     /*  457231 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(457317), // Rule ID 7008 //
     /*  457236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457283 */     // MIs[1] Operand 1
     /*  457283 */     // No operand predicates
     /*  457283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457315 */     GIR_RootConstrainSelectedInstOperands,
     /*  457316 */     // GIR_Coverage, 7008,
     /*  457316 */     GIR_EraseRootFromParent_Done,
     /*  457317 */   // Label 7835: @457317
     /*  457317 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(457403), // Rule ID 7009 //
     /*  457322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457369 */     // MIs[1] Operand 1
     /*  457369 */     // No operand predicates
     /*  457369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  457381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457401 */     GIR_RootConstrainSelectedInstOperands,
     /*  457402 */     // GIR_Coverage, 7009,
     /*  457402 */     GIR_EraseRootFromParent_Done,
     /*  457403 */   // Label 7836: @457403
     /*  457403 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(457489), // Rule ID 7012 //
     /*  457408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457455 */     // MIs[1] Operand 1
     /*  457455 */     // No operand predicates
     /*  457455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457487 */     GIR_RootConstrainSelectedInstOperands,
     /*  457488 */     // GIR_Coverage, 7012,
     /*  457488 */     GIR_EraseRootFromParent_Done,
     /*  457489 */   // Label 7837: @457489
     /*  457489 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(457575), // Rule ID 7013 //
     /*  457494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457541 */     // MIs[1] Operand 1
     /*  457541 */     // No operand predicates
     /*  457541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457573 */     GIR_RootConstrainSelectedInstOperands,
     /*  457574 */     // GIR_Coverage, 7013,
     /*  457574 */     GIR_EraseRootFromParent_Done,
     /*  457575 */   // Label 7838: @457575
     /*  457575 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(457661), // Rule ID 7016 //
     /*  457580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457627 */     // MIs[1] Operand 1
     /*  457627 */     // No operand predicates
     /*  457627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457659 */     GIR_RootConstrainSelectedInstOperands,
     /*  457660 */     // GIR_Coverage, 7016,
     /*  457660 */     GIR_EraseRootFromParent_Done,
     /*  457661 */   // Label 7839: @457661
     /*  457661 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(457747), // Rule ID 7017 //
     /*  457666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457713 */     // MIs[1] Operand 1
     /*  457713 */     // No operand predicates
     /*  457713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  457725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457745 */     GIR_RootConstrainSelectedInstOperands,
     /*  457746 */     // GIR_Coverage, 7017,
     /*  457746 */     GIR_EraseRootFromParent_Done,
     /*  457747 */   // Label 7840: @457747
     /*  457747 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(457833), // Rule ID 7020 //
     /*  457752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457799 */     // MIs[1] Operand 1
     /*  457799 */     // No operand predicates
     /*  457799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457831 */     GIR_RootConstrainSelectedInstOperands,
     /*  457832 */     // GIR_Coverage, 7020,
     /*  457832 */     GIR_EraseRootFromParent_Done,
     /*  457833 */   // Label 7841: @457833
     /*  457833 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(457919), // Rule ID 7021 //
     /*  457838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457885 */     // MIs[1] Operand 1
     /*  457885 */     // No operand predicates
     /*  457885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457917 */     GIR_RootConstrainSelectedInstOperands,
     /*  457918 */     // GIR_Coverage, 7021,
     /*  457918 */     GIR_EraseRootFromParent_Done,
     /*  457919 */   // Label 7842: @457919
     /*  457919 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(458005), // Rule ID 7024 //
     /*  457924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  457932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457971 */     // MIs[1] Operand 1
     /*  457971 */     // No operand predicates
     /*  457971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  457983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458003 */     GIR_RootConstrainSelectedInstOperands,
     /*  458004 */     // GIR_Coverage, 7024,
     /*  458004 */     GIR_EraseRootFromParent_Done,
     /*  458005 */   // Label 7843: @458005
     /*  458005 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(458091), // Rule ID 7025 //
     /*  458010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  458021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  458024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  458027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458057 */     // MIs[1] Operand 1
     /*  458057 */     // No operand predicates
     /*  458057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458089 */     GIR_RootConstrainSelectedInstOperands,
     /*  458090 */     // GIR_Coverage, 7025,
     /*  458090 */     GIR_EraseRootFromParent_Done,
     /*  458091 */   // Label 7844: @458091
     /*  458091 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(458177), // Rule ID 7028 //
     /*  458096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458143 */     // MIs[1] Operand 1
     /*  458143 */     // No operand predicates
     /*  458143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458175 */     GIR_RootConstrainSelectedInstOperands,
     /*  458176 */     // GIR_Coverage, 7028,
     /*  458176 */     GIR_EraseRootFromParent_Done,
     /*  458177 */   // Label 7845: @458177
     /*  458177 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(458263), // Rule ID 7029 //
     /*  458182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458229 */     // MIs[1] Operand 1
     /*  458229 */     // No operand predicates
     /*  458229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458261 */     GIR_RootConstrainSelectedInstOperands,
     /*  458262 */     // GIR_Coverage, 7029,
     /*  458262 */     GIR_EraseRootFromParent_Done,
     /*  458263 */   // Label 7846: @458263
     /*  458263 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(458349), // Rule ID 7032 //
     /*  458268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458315 */     // MIs[1] Operand 1
     /*  458315 */     // No operand predicates
     /*  458315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458347 */     GIR_RootConstrainSelectedInstOperands,
     /*  458348 */     // GIR_Coverage, 7032,
     /*  458348 */     GIR_EraseRootFromParent_Done,
     /*  458349 */   // Label 7847: @458349
     /*  458349 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(458435), // Rule ID 7033 //
     /*  458354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458401 */     // MIs[1] Operand 1
     /*  458401 */     // No operand predicates
     /*  458401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  458413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458433 */     GIR_RootConstrainSelectedInstOperands,
     /*  458434 */     // GIR_Coverage, 7033,
     /*  458434 */     GIR_EraseRootFromParent_Done,
     /*  458435 */   // Label 7848: @458435
     /*  458435 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(458521), // Rule ID 7036 //
     /*  458440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458487 */     // MIs[1] Operand 1
     /*  458487 */     // No operand predicates
     /*  458487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  458499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458519 */     GIR_RootConstrainSelectedInstOperands,
     /*  458520 */     // GIR_Coverage, 7036,
     /*  458520 */     GIR_EraseRootFromParent_Done,
     /*  458521 */   // Label 7849: @458521
     /*  458521 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(458607), // Rule ID 7037 //
     /*  458526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458573 */     // MIs[1] Operand 1
     /*  458573 */     // No operand predicates
     /*  458573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  458585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458605 */     GIR_RootConstrainSelectedInstOperands,
     /*  458606 */     // GIR_Coverage, 7037,
     /*  458606 */     GIR_EraseRootFromParent_Done,
     /*  458607 */   // Label 7850: @458607
     /*  458607 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(458693), // Rule ID 7040 //
     /*  458612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458659 */     // MIs[1] Operand 1
     /*  458659 */     // No operand predicates
     /*  458659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  458671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458691 */     GIR_RootConstrainSelectedInstOperands,
     /*  458692 */     // GIR_Coverage, 7040,
     /*  458692 */     GIR_EraseRootFromParent_Done,
     /*  458693 */   // Label 7851: @458693
     /*  458693 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(458779), // Rule ID 7041 //
     /*  458698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458745 */     // MIs[1] Operand 1
     /*  458745 */     // No operand predicates
     /*  458745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458754 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  458757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458777 */     GIR_RootConstrainSelectedInstOperands,
     /*  458778 */     // GIR_Coverage, 7041,
     /*  458778 */     GIR_EraseRootFromParent_Done,
     /*  458779 */   // Label 7852: @458779
     /*  458779 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(458865), // Rule ID 7044 //
     /*  458784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458831 */     // MIs[1] Operand 1
     /*  458831 */     // No operand predicates
     /*  458831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458840 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  458843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458863 */     GIR_RootConstrainSelectedInstOperands,
     /*  458864 */     // GIR_Coverage, 7044,
     /*  458864 */     GIR_EraseRootFromParent_Done,
     /*  458865 */   // Label 7853: @458865
     /*  458865 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(458951), // Rule ID 7045 //
     /*  458870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458917 */     // MIs[1] Operand 1
     /*  458917 */     // No operand predicates
     /*  458917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  458929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458949 */     GIR_RootConstrainSelectedInstOperands,
     /*  458950 */     // GIR_Coverage, 7045,
     /*  458950 */     GIR_EraseRootFromParent_Done,
     /*  458951 */   // Label 7854: @458951
     /*  458951 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(459037), // Rule ID 7048 //
     /*  458956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  458964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459003 */     // MIs[1] Operand 1
     /*  459003 */     // No operand predicates
     /*  459003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459035 */     GIR_RootConstrainSelectedInstOperands,
     /*  459036 */     // GIR_Coverage, 7048,
     /*  459036 */     GIR_EraseRootFromParent_Done,
     /*  459037 */   // Label 7855: @459037
     /*  459037 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(459123), // Rule ID 7049 //
     /*  459042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  459053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  459056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  459059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459089 */     // MIs[1] Operand 1
     /*  459089 */     // No operand predicates
     /*  459089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459121 */     GIR_RootConstrainSelectedInstOperands,
     /*  459122 */     // GIR_Coverage, 7049,
     /*  459122 */     GIR_EraseRootFromParent_Done,
     /*  459123 */   // Label 7856: @459123
     /*  459123 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(459209), // Rule ID 7052 //
     /*  459128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459175 */     // MIs[1] Operand 1
     /*  459175 */     // No operand predicates
     /*  459175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459207 */     GIR_RootConstrainSelectedInstOperands,
     /*  459208 */     // GIR_Coverage, 7052,
     /*  459208 */     GIR_EraseRootFromParent_Done,
     /*  459209 */   // Label 7857: @459209
     /*  459209 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(459295), // Rule ID 7053 //
     /*  459214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459261 */     // MIs[1] Operand 1
     /*  459261 */     // No operand predicates
     /*  459261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459293 */     GIR_RootConstrainSelectedInstOperands,
     /*  459294 */     // GIR_Coverage, 7053,
     /*  459294 */     GIR_EraseRootFromParent_Done,
     /*  459295 */   // Label 7858: @459295
     /*  459295 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(459381), // Rule ID 7056 //
     /*  459300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459347 */     // MIs[1] Operand 1
     /*  459347 */     // No operand predicates
     /*  459347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459356 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459379 */     GIR_RootConstrainSelectedInstOperands,
     /*  459380 */     // GIR_Coverage, 7056,
     /*  459380 */     GIR_EraseRootFromParent_Done,
     /*  459381 */   // Label 7859: @459381
     /*  459381 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(459467), // Rule ID 7057 //
     /*  459386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459433 */     // MIs[1] Operand 1
     /*  459433 */     // No operand predicates
     /*  459433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459465 */     GIR_RootConstrainSelectedInstOperands,
     /*  459466 */     // GIR_Coverage, 7057,
     /*  459466 */     GIR_EraseRootFromParent_Done,
     /*  459467 */   // Label 7860: @459467
     /*  459467 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(459553), // Rule ID 7060 //
     /*  459472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459519 */     // MIs[1] Operand 1
     /*  459519 */     // No operand predicates
     /*  459519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459551 */     GIR_RootConstrainSelectedInstOperands,
     /*  459552 */     // GIR_Coverage, 7060,
     /*  459552 */     GIR_EraseRootFromParent_Done,
     /*  459553 */   // Label 7861: @459553
     /*  459553 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(459639), // Rule ID 7061 //
     /*  459558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459605 */     // MIs[1] Operand 1
     /*  459605 */     // No operand predicates
     /*  459605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  459617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459637 */     GIR_RootConstrainSelectedInstOperands,
     /*  459638 */     // GIR_Coverage, 7061,
     /*  459638 */     GIR_EraseRootFromParent_Done,
     /*  459639 */   // Label 7862: @459639
     /*  459639 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(459725), // Rule ID 7064 //
     /*  459644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459691 */     // MIs[1] Operand 1
     /*  459691 */     // No operand predicates
     /*  459691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459700 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459723 */     GIR_RootConstrainSelectedInstOperands,
     /*  459724 */     // GIR_Coverage, 7064,
     /*  459724 */     GIR_EraseRootFromParent_Done,
     /*  459725 */   // Label 7863: @459725
     /*  459725 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(459811), // Rule ID 7065 //
     /*  459730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459777 */     // MIs[1] Operand 1
     /*  459777 */     // No operand predicates
     /*  459777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  459789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459809 */     GIR_RootConstrainSelectedInstOperands,
     /*  459810 */     // GIR_Coverage, 7065,
     /*  459810 */     GIR_EraseRootFromParent_Done,
     /*  459811 */   // Label 7864: @459811
     /*  459811 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(459897), // Rule ID 7068 //
     /*  459816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459863 */     // MIs[1] Operand 1
     /*  459863 */     // No operand predicates
     /*  459863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459895 */     GIR_RootConstrainSelectedInstOperands,
     /*  459896 */     // GIR_Coverage, 7068,
     /*  459896 */     GIR_EraseRootFromParent_Done,
     /*  459897 */   // Label 7865: @459897
     /*  459897 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(459983), // Rule ID 7069 //
     /*  459902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459949 */     // MIs[1] Operand 1
     /*  459949 */     // No operand predicates
     /*  459949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  459961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459981 */     GIR_RootConstrainSelectedInstOperands,
     /*  459982 */     // GIR_Coverage, 7069,
     /*  459982 */     GIR_EraseRootFromParent_Done,
     /*  459983 */   // Label 7866: @459983
     /*  459983 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(460069), // Rule ID 7072 //
     /*  459988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  459996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460035 */     // MIs[1] Operand 1
     /*  460035 */     // No operand predicates
     /*  460035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  460047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460067 */     GIR_RootConstrainSelectedInstOperands,
     /*  460068 */     // GIR_Coverage, 7072,
     /*  460068 */     GIR_EraseRootFromParent_Done,
     /*  460069 */   // Label 7867: @460069
     /*  460069 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(460155), // Rule ID 7073 //
     /*  460074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460121 */     // MIs[1] Operand 1
     /*  460121 */     // No operand predicates
     /*  460121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  460133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460153 */     GIR_RootConstrainSelectedInstOperands,
     /*  460154 */     // GIR_Coverage, 7073,
     /*  460154 */     GIR_EraseRootFromParent_Done,
     /*  460155 */   // Label 7868: @460155
     /*  460155 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(460241), // Rule ID 7076 //
     /*  460160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460207 */     // MIs[1] Operand 1
     /*  460207 */     // No operand predicates
     /*  460207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  460219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460239 */     GIR_RootConstrainSelectedInstOperands,
     /*  460240 */     // GIR_Coverage, 7076,
     /*  460240 */     GIR_EraseRootFromParent_Done,
     /*  460241 */   // Label 7869: @460241
     /*  460241 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(460327), // Rule ID 7077 //
     /*  460246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460293 */     // MIs[1] Operand 1
     /*  460293 */     // No operand predicates
     /*  460293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  460305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460325 */     GIR_RootConstrainSelectedInstOperands,
     /*  460326 */     // GIR_Coverage, 7077,
     /*  460326 */     GIR_EraseRootFromParent_Done,
     /*  460327 */   // Label 7870: @460327
     /*  460327 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(460413), // Rule ID 7080 //
     /*  460332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460379 */     // MIs[1] Operand 1
     /*  460379 */     // No operand predicates
     /*  460379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460388 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  460391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460411 */     GIR_RootConstrainSelectedInstOperands,
     /*  460412 */     // GIR_Coverage, 7080,
     /*  460412 */     GIR_EraseRootFromParent_Done,
     /*  460413 */   // Label 7871: @460413
     /*  460413 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(460499), // Rule ID 7081 //
     /*  460418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  460426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460465 */     // MIs[1] Operand 1
     /*  460465 */     // No operand predicates
     /*  460465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  460477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460497 */     GIR_RootConstrainSelectedInstOperands,
     /*  460498 */     // GIR_Coverage, 7081,
     /*  460498 */     GIR_EraseRootFromParent_Done,
     /*  460499 */   // Label 7872: @460499
     /*  460499 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(460585), // Rule ID 7260 //
     /*  460504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  460521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460551 */     // MIs[1] Operand 1
     /*  460551 */     // No operand predicates
     /*  460551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460560 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  460563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460583 */     GIR_RootConstrainSelectedInstOperands,
     /*  460584 */     // GIR_Coverage, 7260,
     /*  460584 */     GIR_EraseRootFromParent_Done,
     /*  460585 */   // Label 7873: @460585
     /*  460585 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(460671), // Rule ID 7261 //
     /*  460590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  460607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460637 */     // MIs[1] Operand 1
     /*  460637 */     // No operand predicates
     /*  460637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460646 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  460649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460669 */     GIR_RootConstrainSelectedInstOperands,
     /*  460670 */     // GIR_Coverage, 7261,
     /*  460670 */     GIR_EraseRootFromParent_Done,
     /*  460671 */   // Label 7874: @460671
     /*  460671 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(460757), // Rule ID 7264 //
     /*  460676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  460693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460723 */     // MIs[1] Operand 1
     /*  460723 */     // No operand predicates
     /*  460723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460732 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  460735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460755 */     GIR_RootConstrainSelectedInstOperands,
     /*  460756 */     // GIR_Coverage, 7264,
     /*  460756 */     GIR_EraseRootFromParent_Done,
     /*  460757 */   // Label 7875: @460757
     /*  460757 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(460843), // Rule ID 7265 //
     /*  460762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  460779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460809 */     // MIs[1] Operand 1
     /*  460809 */     // No operand predicates
     /*  460809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460818 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  460821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460841 */     GIR_RootConstrainSelectedInstOperands,
     /*  460842 */     // GIR_Coverage, 7265,
     /*  460842 */     GIR_EraseRootFromParent_Done,
     /*  460843 */   // Label 7876: @460843
     /*  460843 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(460929), // Rule ID 7268 //
     /*  460848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  460865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460895 */     // MIs[1] Operand 1
     /*  460895 */     // No operand predicates
     /*  460895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  460907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460927 */     GIR_RootConstrainSelectedInstOperands,
     /*  460928 */     // GIR_Coverage, 7268,
     /*  460928 */     GIR_EraseRootFromParent_Done,
     /*  460929 */   // Label 7877: @460929
     /*  460929 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(461015), // Rule ID 7269 //
     /*  460934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  460951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460981 */     // MIs[1] Operand 1
     /*  460981 */     // No operand predicates
     /*  460981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  460993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461013 */     GIR_RootConstrainSelectedInstOperands,
     /*  461014 */     // GIR_Coverage, 7269,
     /*  461014 */     GIR_EraseRootFromParent_Done,
     /*  461015 */   // Label 7878: @461015
     /*  461015 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(461101), // Rule ID 7272 //
     /*  461020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461067 */     // MIs[1] Operand 1
     /*  461067 */     // No operand predicates
     /*  461067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  461079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461099 */     GIR_RootConstrainSelectedInstOperands,
     /*  461100 */     // GIR_Coverage, 7272,
     /*  461100 */     GIR_EraseRootFromParent_Done,
     /*  461101 */   // Label 7879: @461101
     /*  461101 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(461187), // Rule ID 7273 //
     /*  461106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  461123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461153 */     // MIs[1] Operand 1
     /*  461153 */     // No operand predicates
     /*  461153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  461165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461185 */     GIR_RootConstrainSelectedInstOperands,
     /*  461186 */     // GIR_Coverage, 7273,
     /*  461186 */     GIR_EraseRootFromParent_Done,
     /*  461187 */   // Label 7880: @461187
     /*  461187 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(461273), // Rule ID 7276 //
     /*  461192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461239 */     // MIs[1] Operand 1
     /*  461239 */     // No operand predicates
     /*  461239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461271 */     GIR_RootConstrainSelectedInstOperands,
     /*  461272 */     // GIR_Coverage, 7276,
     /*  461272 */     GIR_EraseRootFromParent_Done,
     /*  461273 */   // Label 7881: @461273
     /*  461273 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(461359), // Rule ID 7277 //
     /*  461278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  461295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461325 */     // MIs[1] Operand 1
     /*  461325 */     // No operand predicates
     /*  461325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461357 */     GIR_RootConstrainSelectedInstOperands,
     /*  461358 */     // GIR_Coverage, 7277,
     /*  461358 */     GIR_EraseRootFromParent_Done,
     /*  461359 */   // Label 7882: @461359
     /*  461359 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(461445), // Rule ID 7280 //
     /*  461364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461411 */     // MIs[1] Operand 1
     /*  461411 */     // No operand predicates
     /*  461411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461443 */     GIR_RootConstrainSelectedInstOperands,
     /*  461444 */     // GIR_Coverage, 7280,
     /*  461444 */     GIR_EraseRootFromParent_Done,
     /*  461445 */   // Label 7883: @461445
     /*  461445 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(461531), // Rule ID 7281 //
     /*  461450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461497 */     // MIs[1] Operand 1
     /*  461497 */     // No operand predicates
     /*  461497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  461509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461529 */     GIR_RootConstrainSelectedInstOperands,
     /*  461530 */     // GIR_Coverage, 7281,
     /*  461530 */     GIR_EraseRootFromParent_Done,
     /*  461531 */   // Label 7884: @461531
     /*  461531 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(461617), // Rule ID 7284 //
     /*  461536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  461553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461583 */     // MIs[1] Operand 1
     /*  461583 */     // No operand predicates
     /*  461583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461615 */     GIR_RootConstrainSelectedInstOperands,
     /*  461616 */     // GIR_Coverage, 7284,
     /*  461616 */     GIR_EraseRootFromParent_Done,
     /*  461617 */   // Label 7885: @461617
     /*  461617 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(461703), // Rule ID 7285 //
     /*  461622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  461639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461669 */     // MIs[1] Operand 1
     /*  461669 */     // No operand predicates
     /*  461669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461701 */     GIR_RootConstrainSelectedInstOperands,
     /*  461702 */     // GIR_Coverage, 7285,
     /*  461702 */     GIR_EraseRootFromParent_Done,
     /*  461703 */   // Label 7886: @461703
     /*  461703 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(461789), // Rule ID 7288 //
     /*  461708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461755 */     // MIs[1] Operand 1
     /*  461755 */     // No operand predicates
     /*  461755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461787 */     GIR_RootConstrainSelectedInstOperands,
     /*  461788 */     // GIR_Coverage, 7288,
     /*  461788 */     GIR_EraseRootFromParent_Done,
     /*  461789 */   // Label 7887: @461789
     /*  461789 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(461875), // Rule ID 7289 //
     /*  461794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  461811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461841 */     // MIs[1] Operand 1
     /*  461841 */     // No operand predicates
     /*  461841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461873 */     GIR_RootConstrainSelectedInstOperands,
     /*  461874 */     // GIR_Coverage, 7289,
     /*  461874 */     GIR_EraseRootFromParent_Done,
     /*  461875 */   // Label 7888: @461875
     /*  461875 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(461961), // Rule ID 7292 //
     /*  461880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  461891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  461894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461927 */     // MIs[1] Operand 1
     /*  461927 */     // No operand predicates
     /*  461927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  461939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461959 */     GIR_RootConstrainSelectedInstOperands,
     /*  461960 */     // GIR_Coverage, 7292,
     /*  461960 */     GIR_EraseRootFromParent_Done,
     /*  461961 */   // Label 7889: @461961
     /*  461961 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(462047), // Rule ID 7293 //
     /*  461966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  461974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  461977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  461980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462013 */     // MIs[1] Operand 1
     /*  462013 */     // No operand predicates
     /*  462013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462045 */     GIR_RootConstrainSelectedInstOperands,
     /*  462046 */     // GIR_Coverage, 7293,
     /*  462046 */     GIR_EraseRootFromParent_Done,
     /*  462047 */   // Label 7890: @462047
     /*  462047 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(462133), // Rule ID 7296 //
     /*  462052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  462055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  462063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  462066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462099 */     // MIs[1] Operand 1
     /*  462099 */     // No operand predicates
     /*  462099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  462108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462131 */     GIR_RootConstrainSelectedInstOperands,
     /*  462132 */     // GIR_Coverage, 7296,
     /*  462132 */     GIR_EraseRootFromParent_Done,
     /*  462133 */   // Label 7891: @462133
     /*  462133 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(462219), // Rule ID 7297 //
     /*  462138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  462141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  462149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  462152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462185 */     // MIs[1] Operand 1
     /*  462185 */     // No operand predicates
     /*  462185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  462194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  462197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  462214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462217 */     GIR_RootConstrainSelectedInstOperands,
     /*  462218 */     // GIR_Coverage, 7297,
     /*  462218 */     GIR_EraseRootFromParent_Done,
     /*  462219 */   // Label 7892: @462219
     /*  462219 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(462305), // Rule ID 7300 //
     /*  462224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  462235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  462238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  462241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462271 */     // MIs[1] Operand 1
     /*  462271 */     // No operand predicates
     /*  462271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462280 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462303 */     GIR_RootConstrainSelectedInstOperands,
     /*  462304 */     // GIR_Coverage, 7300,
     /*  462304 */     GIR_EraseRootFromParent_Done,
     /*  462305 */   // Label 7893: @462305
     /*  462305 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(462391), // Rule ID 7301 //
     /*  462310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  462321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  462324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  462327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462357 */     // MIs[1] Operand 1
     /*  462357 */     // No operand predicates
     /*  462357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462389 */     GIR_RootConstrainSelectedInstOperands,
     /*  462390 */     // GIR_Coverage, 7301,
     /*  462390 */     GIR_EraseRootFromParent_Done,
     /*  462391 */   // Label 7894: @462391
     /*  462391 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(462477), // Rule ID 7304 //
     /*  462396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  462407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  462410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  462413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462443 */     // MIs[1] Operand 1
     /*  462443 */     // No operand predicates
     /*  462443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462452 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462475 */     GIR_RootConstrainSelectedInstOperands,
     /*  462476 */     // GIR_Coverage, 7304,
     /*  462476 */     GIR_EraseRootFromParent_Done,
     /*  462477 */   // Label 7895: @462477
     /*  462477 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(462563), // Rule ID 7305 //
     /*  462482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  462493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  462496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  462499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462529 */     // MIs[1] Operand 1
     /*  462529 */     // No operand predicates
     /*  462529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462538 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462561 */     GIR_RootConstrainSelectedInstOperands,
     /*  462562 */     // GIR_Coverage, 7305,
     /*  462562 */     GIR_EraseRootFromParent_Done,
     /*  462563 */   // Label 7896: @462563
     /*  462563 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(462649), // Rule ID 7308 //
     /*  462568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  462579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  462582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  462585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462615 */     // MIs[1] Operand 1
     /*  462615 */     // No operand predicates
     /*  462615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462624 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  462627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462647 */     GIR_RootConstrainSelectedInstOperands,
     /*  462648 */     // GIR_Coverage, 7308,
     /*  462648 */     GIR_EraseRootFromParent_Done,
     /*  462649 */   // Label 7897: @462649
     /*  462649 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(462735), // Rule ID 7309 //
     /*  462654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  462665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  462668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  462671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462701 */     // MIs[1] Operand 1
     /*  462701 */     // No operand predicates
     /*  462701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462710 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  462713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462733 */     GIR_RootConstrainSelectedInstOperands,
     /*  462734 */     // GIR_Coverage, 7309,
     /*  462734 */     GIR_EraseRootFromParent_Done,
     /*  462735 */   // Label 7898: @462735
     /*  462735 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(462821), // Rule ID 7312 //
     /*  462740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  462757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462787 */     // MIs[1] Operand 1
     /*  462787 */     // No operand predicates
     /*  462787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462819 */     GIR_RootConstrainSelectedInstOperands,
     /*  462820 */     // GIR_Coverage, 7312,
     /*  462820 */     GIR_EraseRootFromParent_Done,
     /*  462821 */   // Label 7899: @462821
     /*  462821 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(462907), // Rule ID 7313 //
     /*  462826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  462843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462873 */     // MIs[1] Operand 1
     /*  462873 */     // No operand predicates
     /*  462873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  462885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462905 */     GIR_RootConstrainSelectedInstOperands,
     /*  462906 */     // GIR_Coverage, 7313,
     /*  462906 */     GIR_EraseRootFromParent_Done,
     /*  462907 */   // Label 7900: @462907
     /*  462907 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(462993), // Rule ID 7316 //
     /*  462912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  462920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  462929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462959 */     // MIs[1] Operand 1
     /*  462959 */     // No operand predicates
     /*  462959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  462971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462991 */     GIR_RootConstrainSelectedInstOperands,
     /*  462992 */     // GIR_Coverage, 7316,
     /*  462992 */     GIR_EraseRootFromParent_Done,
     /*  462993 */   // Label 7901: @462993
     /*  462993 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(463079), // Rule ID 7317 //
     /*  462998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  463009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  463012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463045 */     // MIs[1] Operand 1
     /*  463045 */     // No operand predicates
     /*  463045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463077 */     GIR_RootConstrainSelectedInstOperands,
     /*  463078 */     // GIR_Coverage, 7317,
     /*  463078 */     GIR_EraseRootFromParent_Done,
     /*  463079 */   // Label 7902: @463079
     /*  463079 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(463165), // Rule ID 7320 //
     /*  463084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  463095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  463098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463131 */     // MIs[1] Operand 1
     /*  463131 */     // No operand predicates
     /*  463131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463163 */     GIR_RootConstrainSelectedInstOperands,
     /*  463164 */     // GIR_Coverage, 7320,
     /*  463164 */     GIR_EraseRootFromParent_Done,
     /*  463165 */   // Label 7903: @463165
     /*  463165 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(463251), // Rule ID 7321 //
     /*  463170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  463181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  463184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463217 */     // MIs[1] Operand 1
     /*  463217 */     // No operand predicates
     /*  463217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463249 */     GIR_RootConstrainSelectedInstOperands,
     /*  463250 */     // GIR_Coverage, 7321,
     /*  463250 */     GIR_EraseRootFromParent_Done,
     /*  463251 */   // Label 7904: @463251
     /*  463251 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(463337), // Rule ID 7324 //
     /*  463256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463303 */     // MIs[1] Operand 1
     /*  463303 */     // No operand predicates
     /*  463303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463335 */     GIR_RootConstrainSelectedInstOperands,
     /*  463336 */     // GIR_Coverage, 7324,
     /*  463336 */     GIR_EraseRootFromParent_Done,
     /*  463337 */   // Label 7905: @463337
     /*  463337 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(463423), // Rule ID 7325 //
     /*  463342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  463353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  463356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463389 */     // MIs[1] Operand 1
     /*  463389 */     // No operand predicates
     /*  463389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463421 */     GIR_RootConstrainSelectedInstOperands,
     /*  463422 */     // GIR_Coverage, 7325,
     /*  463422 */     GIR_EraseRootFromParent_Done,
     /*  463423 */   // Label 7906: @463423
     /*  463423 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(463509), // Rule ID 7328 //
     /*  463428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  463445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463475 */     // MIs[1] Operand 1
     /*  463475 */     // No operand predicates
     /*  463475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463507 */     GIR_RootConstrainSelectedInstOperands,
     /*  463508 */     // GIR_Coverage, 7328,
     /*  463508 */     GIR_EraseRootFromParent_Done,
     /*  463509 */   // Label 7907: @463509
     /*  463509 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(463595), // Rule ID 7329 //
     /*  463514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  463525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  463528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  463531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463561 */     // MIs[1] Operand 1
     /*  463561 */     // No operand predicates
     /*  463561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  463573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463593 */     GIR_RootConstrainSelectedInstOperands,
     /*  463594 */     // GIR_Coverage, 7329,
     /*  463594 */     GIR_EraseRootFromParent_Done,
     /*  463595 */   // Label 7908: @463595
     /*  463595 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(463681), // Rule ID 7332 //
     /*  463600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  463611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  463614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  463617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463647 */     // MIs[1] Operand 1
     /*  463647 */     // No operand predicates
     /*  463647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  463656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463679 */     GIR_RootConstrainSelectedInstOperands,
     /*  463680 */     // GIR_Coverage, 7332,
     /*  463680 */     GIR_EraseRootFromParent_Done,
     /*  463681 */   // Label 7909: @463681
     /*  463681 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(463767), // Rule ID 7333 //
     /*  463686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  463697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  463700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  463703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463733 */     // MIs[1] Operand 1
     /*  463733 */     // No operand predicates
     /*  463733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463742 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  463742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  463745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463765 */     GIR_RootConstrainSelectedInstOperands,
     /*  463766 */     // GIR_Coverage, 7333,
     /*  463766 */     GIR_EraseRootFromParent_Done,
     /*  463767 */   // Label 7910: @463767
     /*  463767 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(463853), // Rule ID 7336 //
     /*  463772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  463775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  463783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  463786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463819 */     // MIs[1] Operand 1
     /*  463819 */     // No operand predicates
     /*  463819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  463828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463851 */     GIR_RootConstrainSelectedInstOperands,
     /*  463852 */     // GIR_Coverage, 7336,
     /*  463852 */     GIR_EraseRootFromParent_Done,
     /*  463853 */   // Label 7911: @463853
     /*  463853 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(463939), // Rule ID 7337 //
     /*  463858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  463861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  463869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  463872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  463875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463905 */     // MIs[1] Operand 1
     /*  463905 */     // No operand predicates
     /*  463905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  463914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  463917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  463934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463937 */     GIR_RootConstrainSelectedInstOperands,
     /*  463938 */     // GIR_Coverage, 7337,
     /*  463938 */     GIR_EraseRootFromParent_Done,
     /*  463939 */   // Label 7912: @463939
     /*  463939 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(464025), // Rule ID 7340 //
     /*  463944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  463947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  463952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  463955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  463958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  463961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463991 */     // MIs[1] Operand 1
     /*  463991 */     // No operand predicates
     /*  463991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  464000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  464003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464023 */     GIR_RootConstrainSelectedInstOperands,
     /*  464024 */     // GIR_Coverage, 7340,
     /*  464024 */     GIR_EraseRootFromParent_Done,
     /*  464025 */   // Label 7913: @464025
     /*  464025 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(464111), // Rule ID 7341 //
     /*  464030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  464033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  464041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  464044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  464047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464077 */     // MIs[1] Operand 1
     /*  464077 */     // No operand predicates
     /*  464077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  464086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  464089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464109 */     GIR_RootConstrainSelectedInstOperands,
     /*  464110 */     // GIR_Coverage, 7341,
     /*  464110 */     GIR_EraseRootFromParent_Done,
     /*  464111 */   // Label 7914: @464111
     /*  464111 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(464197), // Rule ID 7344 //
     /*  464116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  464119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  464127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  464130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  464133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464163 */     // MIs[1] Operand 1
     /*  464163 */     // No operand predicates
     /*  464163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  464172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  464175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464195 */     GIR_RootConstrainSelectedInstOperands,
     /*  464196 */     // GIR_Coverage, 7344,
     /*  464196 */     GIR_EraseRootFromParent_Done,
     /*  464197 */   // Label 7915: @464197
     /*  464197 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(464283), // Rule ID 7345 //
     /*  464202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  464205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  464210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  464213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  464216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  464219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464249 */     // MIs[1] Operand 1
     /*  464249 */     // No operand predicates
     /*  464249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  464258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  464261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  464278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464281 */     GIR_RootConstrainSelectedInstOperands,
     /*  464282 */     // GIR_Coverage, 7345,
     /*  464282 */     GIR_EraseRootFromParent_Done,
     /*  464283 */   // Label 7916: @464283
     /*  464283 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(464369), // Rule ID 7556 //
     /*  464288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  464299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  464302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  464305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464335 */     // MIs[1] Operand 1
     /*  464335 */     // No operand predicates
     /*  464335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464344 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  464347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464367 */     GIR_RootConstrainSelectedInstOperands,
     /*  464368 */     // GIR_Coverage, 7556,
     /*  464368 */     GIR_EraseRootFromParent_Done,
     /*  464369 */   // Label 7917: @464369
     /*  464369 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(464455), // Rule ID 7557 //
     /*  464374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  464385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  464388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  464391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464421 */     // MIs[1] Operand 1
     /*  464421 */     // No operand predicates
     /*  464421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  464433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464453 */     GIR_RootConstrainSelectedInstOperands,
     /*  464454 */     // GIR_Coverage, 7557,
     /*  464454 */     GIR_EraseRootFromParent_Done,
     /*  464455 */   // Label 7918: @464455
     /*  464455 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(464541), // Rule ID 7560 //
     /*  464460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  464471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  464474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  464477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464507 */     // MIs[1] Operand 1
     /*  464507 */     // No operand predicates
     /*  464507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464516 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  464519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464539 */     GIR_RootConstrainSelectedInstOperands,
     /*  464540 */     // GIR_Coverage, 7560,
     /*  464540 */     GIR_EraseRootFromParent_Done,
     /*  464541 */   // Label 7919: @464541
     /*  464541 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(464627), // Rule ID 7561 //
     /*  464546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  464557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  464560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  464563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464593 */     // MIs[1] Operand 1
     /*  464593 */     // No operand predicates
     /*  464593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  464605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464625 */     GIR_RootConstrainSelectedInstOperands,
     /*  464626 */     // GIR_Coverage, 7561,
     /*  464626 */     GIR_EraseRootFromParent_Done,
     /*  464627 */   // Label 7920: @464627
     /*  464627 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(464713), // Rule ID 7564 //
     /*  464632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  464643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  464646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  464649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464679 */     // MIs[1] Operand 1
     /*  464679 */     // No operand predicates
     /*  464679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  464691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464711 */     GIR_RootConstrainSelectedInstOperands,
     /*  464712 */     // GIR_Coverage, 7564,
     /*  464712 */     GIR_EraseRootFromParent_Done,
     /*  464713 */   // Label 7921: @464713
     /*  464713 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(464799), // Rule ID 7565 //
     /*  464718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  464729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  464732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  464735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464765 */     // MIs[1] Operand 1
     /*  464765 */     // No operand predicates
     /*  464765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  464777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464797 */     GIR_RootConstrainSelectedInstOperands,
     /*  464798 */     // GIR_Coverage, 7565,
     /*  464798 */     GIR_EraseRootFromParent_Done,
     /*  464799 */   // Label 7922: @464799
     /*  464799 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(464885), // Rule ID 7568 //
     /*  464804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464851 */     // MIs[1] Operand 1
     /*  464851 */     // No operand predicates
     /*  464851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  464860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  464863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464883 */     GIR_RootConstrainSelectedInstOperands,
     /*  464884 */     // GIR_Coverage, 7568,
     /*  464884 */     GIR_EraseRootFromParent_Done,
     /*  464885 */   // Label 7923: @464885
     /*  464885 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(464971), // Rule ID 7569 //
     /*  464890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  464901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  464904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  464907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464937 */     // MIs[1] Operand 1
     /*  464937 */     // No operand predicates
     /*  464937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  464949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464969 */     GIR_RootConstrainSelectedInstOperands,
     /*  464970 */     // GIR_Coverage, 7569,
     /*  464970 */     GIR_EraseRootFromParent_Done,
     /*  464971 */   // Label 7924: @464971
     /*  464971 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(465057), // Rule ID 7572 //
     /*  464976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  464984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  464987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  464990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  464993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465023 */     // MIs[1] Operand 1
     /*  465023 */     // No operand predicates
     /*  465023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465055 */     GIR_RootConstrainSelectedInstOperands,
     /*  465056 */     // GIR_Coverage, 7572,
     /*  465056 */     GIR_EraseRootFromParent_Done,
     /*  465057 */   // Label 7925: @465057
     /*  465057 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(465143), // Rule ID 7573 //
     /*  465062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  465073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  465076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  465079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465109 */     // MIs[1] Operand 1
     /*  465109 */     // No operand predicates
     /*  465109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465141 */     GIR_RootConstrainSelectedInstOperands,
     /*  465142 */     // GIR_Coverage, 7573,
     /*  465142 */     GIR_EraseRootFromParent_Done,
     /*  465143 */   // Label 7926: @465143
     /*  465143 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(465229), // Rule ID 7576 //
     /*  465148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  465159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  465162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  465165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465195 */     // MIs[1] Operand 1
     /*  465195 */     // No operand predicates
     /*  465195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  465207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465227 */     GIR_RootConstrainSelectedInstOperands,
     /*  465228 */     // GIR_Coverage, 7576,
     /*  465228 */     GIR_EraseRootFromParent_Done,
     /*  465229 */   // Label 7927: @465229
     /*  465229 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(465315), // Rule ID 7577 //
     /*  465234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  465245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  465248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  465251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465281 */     // MIs[1] Operand 1
     /*  465281 */     // No operand predicates
     /*  465281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  465293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465313 */     GIR_RootConstrainSelectedInstOperands,
     /*  465314 */     // GIR_Coverage, 7577,
     /*  465314 */     GIR_EraseRootFromParent_Done,
     /*  465315 */   // Label 7928: @465315
     /*  465315 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(465401), // Rule ID 7580 //
     /*  465320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  465337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465367 */     // MIs[1] Operand 1
     /*  465367 */     // No operand predicates
     /*  465367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  465379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465399 */     GIR_RootConstrainSelectedInstOperands,
     /*  465400 */     // GIR_Coverage, 7580,
     /*  465400 */     GIR_EraseRootFromParent_Done,
     /*  465401 */   // Label 7929: @465401
     /*  465401 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(465487), // Rule ID 7581 //
     /*  465406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  465423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465453 */     // MIs[1] Operand 1
     /*  465453 */     // No operand predicates
     /*  465453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  465465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465485 */     GIR_RootConstrainSelectedInstOperands,
     /*  465486 */     // GIR_Coverage, 7581,
     /*  465486 */     GIR_EraseRootFromParent_Done,
     /*  465487 */   // Label 7930: @465487
     /*  465487 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(465573), // Rule ID 7584 //
     /*  465492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  465509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465539 */     // MIs[1] Operand 1
     /*  465539 */     // No operand predicates
     /*  465539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  465551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465571 */     GIR_RootConstrainSelectedInstOperands,
     /*  465572 */     // GIR_Coverage, 7584,
     /*  465572 */     GIR_EraseRootFromParent_Done,
     /*  465573 */   // Label 7931: @465573
     /*  465573 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(465659), // Rule ID 7585 //
     /*  465578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  465595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465625 */     // MIs[1] Operand 1
     /*  465625 */     // No operand predicates
     /*  465625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  465637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465657 */     GIR_RootConstrainSelectedInstOperands,
     /*  465658 */     // GIR_Coverage, 7585,
     /*  465658 */     GIR_EraseRootFromParent_Done,
     /*  465659 */   // Label 7932: @465659
     /*  465659 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(465745), // Rule ID 7588 //
     /*  465664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  465675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  465678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  465681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465711 */     // MIs[1] Operand 1
     /*  465711 */     // No operand predicates
     /*  465711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  465723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465743 */     GIR_RootConstrainSelectedInstOperands,
     /*  465744 */     // GIR_Coverage, 7588,
     /*  465744 */     GIR_EraseRootFromParent_Done,
     /*  465745 */   // Label 7933: @465745
     /*  465745 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(465831), // Rule ID 7589 //
     /*  465750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  465761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  465764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  465767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465797 */     // MIs[1] Operand 1
     /*  465797 */     // No operand predicates
     /*  465797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  465809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465829 */     GIR_RootConstrainSelectedInstOperands,
     /*  465830 */     // GIR_Coverage, 7589,
     /*  465830 */     GIR_EraseRootFromParent_Done,
     /*  465831 */   // Label 7934: @465831
     /*  465831 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(465917), // Rule ID 7592 //
     /*  465836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465883 */     // MIs[1] Operand 1
     /*  465883 */     // No operand predicates
     /*  465883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465915 */     GIR_RootConstrainSelectedInstOperands,
     /*  465916 */     // GIR_Coverage, 7592,
     /*  465916 */     GIR_EraseRootFromParent_Done,
     /*  465917 */   // Label 7935: @465917
     /*  465917 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(466003), // Rule ID 7593 //
     /*  465922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  465930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  465933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  465936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  465939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465969 */     // MIs[1] Operand 1
     /*  465969 */     // No operand predicates
     /*  465969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  465981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466001 */     GIR_RootConstrainSelectedInstOperands,
     /*  466002 */     // GIR_Coverage, 7593,
     /*  466002 */     GIR_EraseRootFromParent_Done,
     /*  466003 */   // Label 7936: @466003
     /*  466003 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(466089), // Rule ID 7596 //
     /*  466008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  466019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  466022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  466025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466055 */     // MIs[1] Operand 1
     /*  466055 */     // No operand predicates
     /*  466055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466087 */     GIR_RootConstrainSelectedInstOperands,
     /*  466088 */     // GIR_Coverage, 7596,
     /*  466088 */     GIR_EraseRootFromParent_Done,
     /*  466089 */   // Label 7937: @466089
     /*  466089 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(466175), // Rule ID 7597 //
     /*  466094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  466105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  466108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  466111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466141 */     // MIs[1] Operand 1
     /*  466141 */     // No operand predicates
     /*  466141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466173 */     GIR_RootConstrainSelectedInstOperands,
     /*  466174 */     // GIR_Coverage, 7597,
     /*  466174 */     GIR_EraseRootFromParent_Done,
     /*  466175 */   // Label 7938: @466175
     /*  466175 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(466261), // Rule ID 7600 //
     /*  466180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466227 */     // MIs[1] Operand 1
     /*  466227 */     // No operand predicates
     /*  466227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  466239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466259 */     GIR_RootConstrainSelectedInstOperands,
     /*  466260 */     // GIR_Coverage, 7600,
     /*  466260 */     GIR_EraseRootFromParent_Done,
     /*  466261 */   // Label 7939: @466261
     /*  466261 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(466347), // Rule ID 7601 //
     /*  466266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466313 */     // MIs[1] Operand 1
     /*  466313 */     // No operand predicates
     /*  466313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  466325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466345 */     GIR_RootConstrainSelectedInstOperands,
     /*  466346 */     // GIR_Coverage, 7601,
     /*  466346 */     GIR_EraseRootFromParent_Done,
     /*  466347 */   // Label 7940: @466347
     /*  466347 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(466433), // Rule ID 7604 //
     /*  466352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  466369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466399 */     // MIs[1] Operand 1
     /*  466399 */     // No operand predicates
     /*  466399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  466411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466431 */     GIR_RootConstrainSelectedInstOperands,
     /*  466432 */     // GIR_Coverage, 7604,
     /*  466432 */     GIR_EraseRootFromParent_Done,
     /*  466433 */   // Label 7941: @466433
     /*  466433 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(466519), // Rule ID 7605 //
     /*  466438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  466455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466485 */     // MIs[1] Operand 1
     /*  466485 */     // No operand predicates
     /*  466485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  466497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466517 */     GIR_RootConstrainSelectedInstOperands,
     /*  466518 */     // GIR_Coverage, 7605,
     /*  466518 */     GIR_EraseRootFromParent_Done,
     /*  466519 */   // Label 7942: @466519
     /*  466519 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(466605), // Rule ID 7608 //
     /*  466524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  466535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  466538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  466541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466571 */     // MIs[1] Operand 1
     /*  466571 */     // No operand predicates
     /*  466571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  466583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466603 */     GIR_RootConstrainSelectedInstOperands,
     /*  466604 */     // GIR_Coverage, 7608,
     /*  466604 */     GIR_EraseRootFromParent_Done,
     /*  466605 */   // Label 7943: @466605
     /*  466605 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(466691), // Rule ID 7609 //
     /*  466610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  466621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  466624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  466627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466657 */     // MIs[1] Operand 1
     /*  466657 */     // No operand predicates
     /*  466657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  466669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466689 */     GIR_RootConstrainSelectedInstOperands,
     /*  466690 */     // GIR_Coverage, 7609,
     /*  466690 */     GIR_EraseRootFromParent_Done,
     /*  466691 */   // Label 7944: @466691
     /*  466691 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(466777), // Rule ID 7612 //
     /*  466696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  466699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  466707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  466710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466743 */     // MIs[1] Operand 1
     /*  466743 */     // No operand predicates
     /*  466743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466775 */     GIR_RootConstrainSelectedInstOperands,
     /*  466776 */     // GIR_Coverage, 7612,
     /*  466776 */     GIR_EraseRootFromParent_Done,
     /*  466777 */   // Label 7945: @466777
     /*  466777 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(466863), // Rule ID 7613 //
     /*  466782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  466785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  466790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  466793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  466796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  466799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  466813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  466817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466829 */     // MIs[1] Operand 1
     /*  466829 */     // No operand predicates
     /*  466829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466838 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  466841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466861 */     GIR_RootConstrainSelectedInstOperands,
     /*  466862 */     // GIR_Coverage, 7613,
     /*  466862 */     GIR_EraseRootFromParent_Done,
     /*  466863 */   // Label 7946: @466863
     /*  466863 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(466949), // Rule ID 7736 //
     /*  466868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  466876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  466915 */     // MIs[1] Operand 1
     /*  466915 */     // No operand predicates
     /*  466915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  466927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466947 */     GIR_RootConstrainSelectedInstOperands,
     /*  466948 */     // GIR_Coverage, 7736,
     /*  466948 */     GIR_EraseRootFromParent_Done,
     /*  466949 */   // Label 7947: @466949
     /*  466949 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(467035), // Rule ID 7737 //
     /*  466954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  466962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  466965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  466968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467001 */     // MIs[1] Operand 1
     /*  467001 */     // No operand predicates
     /*  467001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  467013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467033 */     GIR_RootConstrainSelectedInstOperands,
     /*  467034 */     // GIR_Coverage, 7737,
     /*  467034 */     GIR_EraseRootFromParent_Done,
     /*  467035 */   // Label 7948: @467035
     /*  467035 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(467121), // Rule ID 7740 //
     /*  467040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  467051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  467054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  467057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467087 */     // MIs[1] Operand 1
     /*  467087 */     // No operand predicates
     /*  467087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467119 */     GIR_RootConstrainSelectedInstOperands,
     /*  467120 */     // GIR_Coverage, 7740,
     /*  467120 */     GIR_EraseRootFromParent_Done,
     /*  467121 */   // Label 7949: @467121
     /*  467121 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(467207), // Rule ID 7741 //
     /*  467126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  467137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  467140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  467143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467173 */     // MIs[1] Operand 1
     /*  467173 */     // No operand predicates
     /*  467173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467205 */     GIR_RootConstrainSelectedInstOperands,
     /*  467206 */     // GIR_Coverage, 7741,
     /*  467206 */     GIR_EraseRootFromParent_Done,
     /*  467207 */   // Label 7950: @467207
     /*  467207 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(467293), // Rule ID 7744 //
     /*  467212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  467223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  467226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467259 */     // MIs[1] Operand 1
     /*  467259 */     // No operand predicates
     /*  467259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  467271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467291 */     GIR_RootConstrainSelectedInstOperands,
     /*  467292 */     // GIR_Coverage, 7744,
     /*  467292 */     GIR_EraseRootFromParent_Done,
     /*  467293 */   // Label 7951: @467293
     /*  467293 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(467379), // Rule ID 7745 //
     /*  467298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  467309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  467312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  467315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467345 */     // MIs[1] Operand 1
     /*  467345 */     // No operand predicates
     /*  467345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467354 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  467357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467377 */     GIR_RootConstrainSelectedInstOperands,
     /*  467378 */     // GIR_Coverage, 7745,
     /*  467378 */     GIR_EraseRootFromParent_Done,
     /*  467379 */   // Label 7952: @467379
     /*  467379 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(467465), // Rule ID 7748 //
     /*  467384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467431 */     // MIs[1] Operand 1
     /*  467431 */     // No operand predicates
     /*  467431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  467443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467463 */     GIR_RootConstrainSelectedInstOperands,
     /*  467464 */     // GIR_Coverage, 7748,
     /*  467464 */     GIR_EraseRootFromParent_Done,
     /*  467465 */   // Label 7953: @467465
     /*  467465 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(467551), // Rule ID 7749 //
     /*  467470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  467481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  467484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467517 */     // MIs[1] Operand 1
     /*  467517 */     // No operand predicates
     /*  467517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  467529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467549 */     GIR_RootConstrainSelectedInstOperands,
     /*  467550 */     // GIR_Coverage, 7749,
     /*  467550 */     GIR_EraseRootFromParent_Done,
     /*  467551 */   // Label 7954: @467551
     /*  467551 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(467637), // Rule ID 7752 //
     /*  467556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467603 */     // MIs[1] Operand 1
     /*  467603 */     // No operand predicates
     /*  467603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  467615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467635 */     GIR_RootConstrainSelectedInstOperands,
     /*  467636 */     // GIR_Coverage, 7752,
     /*  467636 */     GIR_EraseRootFromParent_Done,
     /*  467637 */   // Label 7955: @467637
     /*  467637 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(467723), // Rule ID 7753 //
     /*  467642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467689 */     // MIs[1] Operand 1
     /*  467689 */     // No operand predicates
     /*  467689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  467701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467721 */     GIR_RootConstrainSelectedInstOperands,
     /*  467722 */     // GIR_Coverage, 7753,
     /*  467722 */     GIR_EraseRootFromParent_Done,
     /*  467723 */   // Label 7956: @467723
     /*  467723 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(467809), // Rule ID 7756 //
     /*  467728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467775 */     // MIs[1] Operand 1
     /*  467775 */     // No operand predicates
     /*  467775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  467787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467807 */     GIR_RootConstrainSelectedInstOperands,
     /*  467808 */     // GIR_Coverage, 7756,
     /*  467808 */     GIR_EraseRootFromParent_Done,
     /*  467809 */   // Label 7957: @467809
     /*  467809 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(467895), // Rule ID 7757 //
     /*  467814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467861 */     // MIs[1] Operand 1
     /*  467861 */     // No operand predicates
     /*  467861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  467873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467893 */     GIR_RootConstrainSelectedInstOperands,
     /*  467894 */     // GIR_Coverage, 7757,
     /*  467894 */     GIR_EraseRootFromParent_Done,
     /*  467895 */   // Label 7958: @467895
     /*  467895 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(467981), // Rule ID 7760 //
     /*  467900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  467911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  467914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  467917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  467947 */     // MIs[1] Operand 1
     /*  467947 */     // No operand predicates
     /*  467947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  467959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467979 */     GIR_RootConstrainSelectedInstOperands,
     /*  467980 */     // GIR_Coverage, 7760,
     /*  467980 */     GIR_EraseRootFromParent_Done,
     /*  467981 */   // Label 7959: @467981
     /*  467981 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(468067), // Rule ID 7761 //
     /*  467986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  467994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  467997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  468000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  468003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468033 */     // MIs[1] Operand 1
     /*  468033 */     // No operand predicates
     /*  468033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  468045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468065 */     GIR_RootConstrainSelectedInstOperands,
     /*  468066 */     // GIR_Coverage, 7761,
     /*  468066 */     GIR_EraseRootFromParent_Done,
     /*  468067 */   // Label 7960: @468067
     /*  468067 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(468153), // Rule ID 7764 //
     /*  468072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  468083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  468086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  468089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468119 */     // MIs[1] Operand 1
     /*  468119 */     // No operand predicates
     /*  468119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468128 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468151 */     GIR_RootConstrainSelectedInstOperands,
     /*  468152 */     // GIR_Coverage, 7764,
     /*  468152 */     GIR_EraseRootFromParent_Done,
     /*  468153 */   // Label 7961: @468153
     /*  468153 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(468239), // Rule ID 7765 //
     /*  468158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  468169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  468172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  468175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468205 */     // MIs[1] Operand 1
     /*  468205 */     // No operand predicates
     /*  468205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468237 */     GIR_RootConstrainSelectedInstOperands,
     /*  468238 */     // GIR_Coverage, 7765,
     /*  468238 */     GIR_EraseRootFromParent_Done,
     /*  468239 */   // Label 7962: @468239
     /*  468239 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(468325), // Rule ID 7768 //
     /*  468244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  468255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  468258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468291 */     // MIs[1] Operand 1
     /*  468291 */     // No operand predicates
     /*  468291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468323 */     GIR_RootConstrainSelectedInstOperands,
     /*  468324 */     // GIR_Coverage, 7768,
     /*  468324 */     GIR_EraseRootFromParent_Done,
     /*  468325 */   // Label 7963: @468325
     /*  468325 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(468411), // Rule ID 7769 //
     /*  468330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  468341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  468344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468377 */     // MIs[1] Operand 1
     /*  468377 */     // No operand predicates
     /*  468377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468409 */     GIR_RootConstrainSelectedInstOperands,
     /*  468410 */     // GIR_Coverage, 7769,
     /*  468410 */     GIR_EraseRootFromParent_Done,
     /*  468411 */   // Label 7964: @468411
     /*  468411 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(468497), // Rule ID 7772 //
     /*  468416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468463 */     // MIs[1] Operand 1
     /*  468463 */     // No operand predicates
     /*  468463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  468475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468495 */     GIR_RootConstrainSelectedInstOperands,
     /*  468496 */     // GIR_Coverage, 7772,
     /*  468496 */     GIR_EraseRootFromParent_Done,
     /*  468497 */   // Label 7965: @468497
     /*  468497 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(468583), // Rule ID 7773 //
     /*  468502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468549 */     // MIs[1] Operand 1
     /*  468549 */     // No operand predicates
     /*  468549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468558 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  468561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468581 */     GIR_RootConstrainSelectedInstOperands,
     /*  468582 */     // GIR_Coverage, 7773,
     /*  468582 */     GIR_EraseRootFromParent_Done,
     /*  468583 */   // Label 7966: @468583
     /*  468583 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(468669), // Rule ID 7776 //
     /*  468588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468635 */     // MIs[1] Operand 1
     /*  468635 */     // No operand predicates
     /*  468635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  468647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468667 */     GIR_RootConstrainSelectedInstOperands,
     /*  468668 */     // GIR_Coverage, 7776,
     /*  468668 */     GIR_EraseRootFromParent_Done,
     /*  468669 */   // Label 7967: @468669
     /*  468669 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(468755), // Rule ID 7777 //
     /*  468674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468721 */     // MIs[1] Operand 1
     /*  468721 */     // No operand predicates
     /*  468721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468730 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  468733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468753 */     GIR_RootConstrainSelectedInstOperands,
     /*  468754 */     // GIR_Coverage, 7777,
     /*  468754 */     GIR_EraseRootFromParent_Done,
     /*  468755 */   // Label 7968: @468755
     /*  468755 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(468841), // Rule ID 7780 //
     /*  468760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  468763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  468771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  468774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  468777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468807 */     // MIs[1] Operand 1
     /*  468807 */     // No operand predicates
     /*  468807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468839 */     GIR_RootConstrainSelectedInstOperands,
     /*  468840 */     // GIR_Coverage, 7780,
     /*  468840 */     GIR_EraseRootFromParent_Done,
     /*  468841 */   // Label 7969: @468841
     /*  468841 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(468927), // Rule ID 7781 //
     /*  468846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  468849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  468857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  468860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  468863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468893 */     // MIs[1] Operand 1
     /*  468893 */     // No operand predicates
     /*  468893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  468905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468925 */     GIR_RootConstrainSelectedInstOperands,
     /*  468926 */     // GIR_Coverage, 7781,
     /*  468926 */     GIR_EraseRootFromParent_Done,
     /*  468927 */   // Label 7970: @468927
     /*  468927 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(469013), // Rule ID 7784 //
     /*  468932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  468935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  468940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  468943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  468946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  468963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  468979 */     // MIs[1] Operand 1
     /*  468979 */     // No operand predicates
     /*  468979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  468991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469011 */     GIR_RootConstrainSelectedInstOperands,
     /*  469012 */     // GIR_Coverage, 7784,
     /*  469012 */     GIR_EraseRootFromParent_Done,
     /*  469013 */   // Label 7971: @469013
     /*  469013 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(469099), // Rule ID 7785 //
     /*  469018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  469029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  469032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469065 */     // MIs[1] Operand 1
     /*  469065 */     // No operand predicates
     /*  469065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  469077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469097 */     GIR_RootConstrainSelectedInstOperands,
     /*  469098 */     // GIR_Coverage, 7785,
     /*  469098 */     GIR_EraseRootFromParent_Done,
     /*  469099 */   // Label 7972: @469099
     /*  469099 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(469185), // Rule ID 7788 //
     /*  469104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  469107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469151 */     // MIs[1] Operand 1
     /*  469151 */     // No operand predicates
     /*  469151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  469163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469183 */     GIR_RootConstrainSelectedInstOperands,
     /*  469184 */     // GIR_Coverage, 7788,
     /*  469184 */     GIR_EraseRootFromParent_Done,
     /*  469185 */   // Label 7973: @469185
     /*  469185 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(469271), // Rule ID 7789 //
     /*  469190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  469201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  469204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469237 */     // MIs[1] Operand 1
     /*  469237 */     // No operand predicates
     /*  469237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  469249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469269 */     GIR_RootConstrainSelectedInstOperands,
     /*  469270 */     // GIR_Coverage, 7789,
     /*  469270 */     GIR_EraseRootFromParent_Done,
     /*  469271 */   // Label 7974: @469271
     /*  469271 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(469357), // Rule ID 7792 //
     /*  469276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  469279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469323 */     // MIs[1] Operand 1
     /*  469323 */     // No operand predicates
     /*  469323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  469335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469355 */     GIR_RootConstrainSelectedInstOperands,
     /*  469356 */     // GIR_Coverage, 7792,
     /*  469356 */     GIR_EraseRootFromParent_Done,
     /*  469357 */   // Label 7975: @469357
     /*  469357 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(469443), // Rule ID 7793 //
     /*  469362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  469365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  469370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  469373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  469376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  469409 */     // MIs[1] Operand 1
     /*  469409 */     // No operand predicates
     /*  469409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  469418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  469421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469441 */     GIR_RootConstrainSelectedInstOperands,
     /*  469442 */     // GIR_Coverage, 7793,
     /*  469442 */     GIR_EraseRootFromParent_Done,
     /*  469443 */   // Label 7976: @469443
     /*  469443 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(469532), // Rule ID 14222 //
     /*  469448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469495 */     // MIs[1] Operand 1
     /*  469495 */     // No operand predicates
     /*  469495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  469507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469530 */     GIR_RootConstrainSelectedInstOperands,
     /*  469531 */     // GIR_Coverage, 14222,
     /*  469531 */     GIR_EraseRootFromParent_Done,
     /*  469532 */   // Label 7977: @469532
     /*  469532 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(469621), // Rule ID 14223 //
     /*  469537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469584 */     // MIs[1] Operand 1
     /*  469584 */     // No operand predicates
     /*  469584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469593 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  469596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469619 */     GIR_RootConstrainSelectedInstOperands,
     /*  469620 */     // GIR_Coverage, 14223,
     /*  469620 */     GIR_EraseRootFromParent_Done,
     /*  469621 */   // Label 7978: @469621
     /*  469621 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(469710), // Rule ID 14226 //
     /*  469626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469673 */     // MIs[1] Operand 1
     /*  469673 */     // No operand predicates
     /*  469673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  469685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469708 */     GIR_RootConstrainSelectedInstOperands,
     /*  469709 */     // GIR_Coverage, 14226,
     /*  469709 */     GIR_EraseRootFromParent_Done,
     /*  469710 */   // Label 7979: @469710
     /*  469710 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(469799), // Rule ID 14227 //
     /*  469715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469762 */     // MIs[1] Operand 1
     /*  469762 */     // No operand predicates
     /*  469762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469771 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  469774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469797 */     GIR_RootConstrainSelectedInstOperands,
     /*  469798 */     // GIR_Coverage, 14227,
     /*  469798 */     GIR_EraseRootFromParent_Done,
     /*  469799 */   // Label 7980: @469799
     /*  469799 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(469888), // Rule ID 14230 //
     /*  469804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469851 */     // MIs[1] Operand 1
     /*  469851 */     // No operand predicates
     /*  469851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  469863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469886 */     GIR_RootConstrainSelectedInstOperands,
     /*  469887 */     // GIR_Coverage, 14230,
     /*  469887 */     GIR_EraseRootFromParent_Done,
     /*  469888 */   // Label 7981: @469888
     /*  469888 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(469977), // Rule ID 14231 //
     /*  469893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469940 */     // MIs[1] Operand 1
     /*  469940 */     // No operand predicates
     /*  469940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469949 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  469952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469975 */     GIR_RootConstrainSelectedInstOperands,
     /*  469976 */     // GIR_Coverage, 14231,
     /*  469976 */     GIR_EraseRootFromParent_Done,
     /*  469977 */   // Label 7982: @469977
     /*  469977 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(470066), // Rule ID 14234 //
     /*  469982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470029 */     // MIs[1] Operand 1
     /*  470029 */     // No operand predicates
     /*  470029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  470041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470064 */     GIR_RootConstrainSelectedInstOperands,
     /*  470065 */     // GIR_Coverage, 14234,
     /*  470065 */     GIR_EraseRootFromParent_Done,
     /*  470066 */   // Label 7983: @470066
     /*  470066 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(470155), // Rule ID 14235 //
     /*  470071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470118 */     // MIs[1] Operand 1
     /*  470118 */     // No operand predicates
     /*  470118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470127 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  470130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470153 */     GIR_RootConstrainSelectedInstOperands,
     /*  470154 */     // GIR_Coverage, 14235,
     /*  470154 */     GIR_EraseRootFromParent_Done,
     /*  470155 */   // Label 7984: @470155
     /*  470155 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(470244), // Rule ID 14238 //
     /*  470160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470207 */     // MIs[1] Operand 1
     /*  470207 */     // No operand predicates
     /*  470207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470242 */     GIR_RootConstrainSelectedInstOperands,
     /*  470243 */     // GIR_Coverage, 14238,
     /*  470243 */     GIR_EraseRootFromParent_Done,
     /*  470244 */   // Label 7985: @470244
     /*  470244 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(470333), // Rule ID 14239 //
     /*  470249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470296 */     // MIs[1] Operand 1
     /*  470296 */     // No operand predicates
     /*  470296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470305 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470331 */     GIR_RootConstrainSelectedInstOperands,
     /*  470332 */     // GIR_Coverage, 14239,
     /*  470332 */     GIR_EraseRootFromParent_Done,
     /*  470333 */   // Label 7986: @470333
     /*  470333 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(470422), // Rule ID 14242 //
     /*  470338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470385 */     // MIs[1] Operand 1
     /*  470385 */     // No operand predicates
     /*  470385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470420 */     GIR_RootConstrainSelectedInstOperands,
     /*  470421 */     // GIR_Coverage, 14242,
     /*  470421 */     GIR_EraseRootFromParent_Done,
     /*  470422 */   // Label 7987: @470422
     /*  470422 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(470511), // Rule ID 14243 //
     /*  470427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470474 */     // MIs[1] Operand 1
     /*  470474 */     // No operand predicates
     /*  470474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470483 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  470486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470509 */     GIR_RootConstrainSelectedInstOperands,
     /*  470510 */     // GIR_Coverage, 14243,
     /*  470510 */     GIR_EraseRootFromParent_Done,
     /*  470511 */   // Label 7988: @470511
     /*  470511 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(470600), // Rule ID 14246 //
     /*  470516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470563 */     // MIs[1] Operand 1
     /*  470563 */     // No operand predicates
     /*  470563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470598 */     GIR_RootConstrainSelectedInstOperands,
     /*  470599 */     // GIR_Coverage, 14246,
     /*  470599 */     GIR_EraseRootFromParent_Done,
     /*  470600 */   // Label 7989: @470600
     /*  470600 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(470689), // Rule ID 14247 //
     /*  470605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470652 */     // MIs[1] Operand 1
     /*  470652 */     // No operand predicates
     /*  470652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470661 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470687 */     GIR_RootConstrainSelectedInstOperands,
     /*  470688 */     // GIR_Coverage, 14247,
     /*  470688 */     GIR_EraseRootFromParent_Done,
     /*  470689 */   // Label 7990: @470689
     /*  470689 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(470778), // Rule ID 14250 //
     /*  470694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470741 */     // MIs[1] Operand 1
     /*  470741 */     // No operand predicates
     /*  470741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470776 */     GIR_RootConstrainSelectedInstOperands,
     /*  470777 */     // GIR_Coverage, 14250,
     /*  470777 */     GIR_EraseRootFromParent_Done,
     /*  470778 */   // Label 7991: @470778
     /*  470778 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(470867), // Rule ID 14251 //
     /*  470783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470830 */     // MIs[1] Operand 1
     /*  470830 */     // No operand predicates
     /*  470830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470839 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470865 */     GIR_RootConstrainSelectedInstOperands,
     /*  470866 */     // GIR_Coverage, 14251,
     /*  470866 */     GIR_EraseRootFromParent_Done,
     /*  470867 */   // Label 7992: @470867
     /*  470867 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(470956), // Rule ID 14254 //
     /*  470872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470919 */     // MIs[1] Operand 1
     /*  470919 */     // No operand predicates
     /*  470919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  470931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470954 */     GIR_RootConstrainSelectedInstOperands,
     /*  470955 */     // GIR_Coverage, 14254,
     /*  470955 */     GIR_EraseRootFromParent_Done,
     /*  470956 */   // Label 7993: @470956
     /*  470956 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(471045), // Rule ID 14255 //
     /*  470961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  470969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471008 */     // MIs[1] Operand 1
     /*  471008 */     // No operand predicates
     /*  471008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471043 */     GIR_RootConstrainSelectedInstOperands,
     /*  471044 */     // GIR_Coverage, 14255,
     /*  471044 */     GIR_EraseRootFromParent_Done,
     /*  471045 */   // Label 7994: @471045
     /*  471045 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(471134), // Rule ID 14258 //
     /*  471050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471097 */     // MIs[1] Operand 1
     /*  471097 */     // No operand predicates
     /*  471097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471132 */     GIR_RootConstrainSelectedInstOperands,
     /*  471133 */     // GIR_Coverage, 14258,
     /*  471133 */     GIR_EraseRootFromParent_Done,
     /*  471134 */   // Label 7995: @471134
     /*  471134 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(471223), // Rule ID 14259 //
     /*  471139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471186 */     // MIs[1] Operand 1
     /*  471186 */     // No operand predicates
     /*  471186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471195 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  471198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471221 */     GIR_RootConstrainSelectedInstOperands,
     /*  471222 */     // GIR_Coverage, 14259,
     /*  471222 */     GIR_EraseRootFromParent_Done,
     /*  471223 */   // Label 7996: @471223
     /*  471223 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(471312), // Rule ID 14262 //
     /*  471228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471275 */     // MIs[1] Operand 1
     /*  471275 */     // No operand predicates
     /*  471275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471310 */     GIR_RootConstrainSelectedInstOperands,
     /*  471311 */     // GIR_Coverage, 14262,
     /*  471311 */     GIR_EraseRootFromParent_Done,
     /*  471312 */   // Label 7997: @471312
     /*  471312 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(471401), // Rule ID 14263 //
     /*  471317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471364 */     // MIs[1] Operand 1
     /*  471364 */     // No operand predicates
     /*  471364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471373 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471399 */     GIR_RootConstrainSelectedInstOperands,
     /*  471400 */     // GIR_Coverage, 14263,
     /*  471400 */     GIR_EraseRootFromParent_Done,
     /*  471401 */   // Label 7998: @471401
     /*  471401 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(471490), // Rule ID 14266 //
     /*  471406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471453 */     // MIs[1] Operand 1
     /*  471453 */     // No operand predicates
     /*  471453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471488 */     GIR_RootConstrainSelectedInstOperands,
     /*  471489 */     // GIR_Coverage, 14266,
     /*  471489 */     GIR_EraseRootFromParent_Done,
     /*  471490 */   // Label 7999: @471490
     /*  471490 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(471579), // Rule ID 14267 //
     /*  471495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471542 */     // MIs[1] Operand 1
     /*  471542 */     // No operand predicates
     /*  471542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471551 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471577 */     GIR_RootConstrainSelectedInstOperands,
     /*  471578 */     // GIR_Coverage, 14267,
     /*  471578 */     GIR_EraseRootFromParent_Done,
     /*  471579 */   // Label 8000: @471579
     /*  471579 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(471668), // Rule ID 14270 //
     /*  471584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471631 */     // MIs[1] Operand 1
     /*  471631 */     // No operand predicates
     /*  471631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  471643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471666 */     GIR_RootConstrainSelectedInstOperands,
     /*  471667 */     // GIR_Coverage, 14270,
     /*  471667 */     GIR_EraseRootFromParent_Done,
     /*  471668 */   // Label 8001: @471668
     /*  471668 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(471757), // Rule ID 14271 //
     /*  471673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471720 */     // MIs[1] Operand 1
     /*  471720 */     // No operand predicates
     /*  471720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471729 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  471732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471755 */     GIR_RootConstrainSelectedInstOperands,
     /*  471756 */     // GIR_Coverage, 14271,
     /*  471756 */     GIR_EraseRootFromParent_Done,
     /*  471757 */   // Label 8002: @471757
     /*  471757 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(471846), // Rule ID 14274 //
     /*  471762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471809 */     // MIs[1] Operand 1
     /*  471809 */     // No operand predicates
     /*  471809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471844 */     GIR_RootConstrainSelectedInstOperands,
     /*  471845 */     // GIR_Coverage, 14274,
     /*  471845 */     GIR_EraseRootFromParent_Done,
     /*  471846 */   // Label 8003: @471846
     /*  471846 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(471935), // Rule ID 14275 //
     /*  471851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471898 */     // MIs[1] Operand 1
     /*  471898 */     // No operand predicates
     /*  471898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  471910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471933 */     GIR_RootConstrainSelectedInstOperands,
     /*  471934 */     // GIR_Coverage, 14275,
     /*  471934 */     GIR_EraseRootFromParent_Done,
     /*  471935 */   // Label 8004: @471935
     /*  471935 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(472024), // Rule ID 14278 //
     /*  471940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  471948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471987 */     // MIs[1] Operand 1
     /*  471987 */     // No operand predicates
     /*  471987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  471999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472022 */     GIR_RootConstrainSelectedInstOperands,
     /*  472023 */     // GIR_Coverage, 14278,
     /*  472023 */     GIR_EraseRootFromParent_Done,
     /*  472024 */   // Label 8005: @472024
     /*  472024 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(472113), // Rule ID 14279 //
     /*  472029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472076 */     // MIs[1] Operand 1
     /*  472076 */     // No operand predicates
     /*  472076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472085 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472111 */     GIR_RootConstrainSelectedInstOperands,
     /*  472112 */     // GIR_Coverage, 14279,
     /*  472112 */     GIR_EraseRootFromParent_Done,
     /*  472113 */   // Label 8006: @472113
     /*  472113 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(472202), // Rule ID 14282 //
     /*  472118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472165 */     // MIs[1] Operand 1
     /*  472165 */     // No operand predicates
     /*  472165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472200 */     GIR_RootConstrainSelectedInstOperands,
     /*  472201 */     // GIR_Coverage, 14282,
     /*  472201 */     GIR_EraseRootFromParent_Done,
     /*  472202 */   // Label 8007: @472202
     /*  472202 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(472291), // Rule ID 14283 //
     /*  472207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472254 */     // MIs[1] Operand 1
     /*  472254 */     // No operand predicates
     /*  472254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472263 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472289 */     GIR_RootConstrainSelectedInstOperands,
     /*  472290 */     // GIR_Coverage, 14283,
     /*  472290 */     GIR_EraseRootFromParent_Done,
     /*  472291 */   // Label 8008: @472291
     /*  472291 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(472380), // Rule ID 14286 //
     /*  472296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472343 */     // MIs[1] Operand 1
     /*  472343 */     // No operand predicates
     /*  472343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472378 */     GIR_RootConstrainSelectedInstOperands,
     /*  472379 */     // GIR_Coverage, 14286,
     /*  472379 */     GIR_EraseRootFromParent_Done,
     /*  472380 */   // Label 8009: @472380
     /*  472380 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(472469), // Rule ID 14287 //
     /*  472385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472432 */     // MIs[1] Operand 1
     /*  472432 */     // No operand predicates
     /*  472432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472467 */     GIR_RootConstrainSelectedInstOperands,
     /*  472468 */     // GIR_Coverage, 14287,
     /*  472468 */     GIR_EraseRootFromParent_Done,
     /*  472469 */   // Label 8010: @472469
     /*  472469 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(472558), // Rule ID 14290 //
     /*  472474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472521 */     // MIs[1] Operand 1
     /*  472521 */     // No operand predicates
     /*  472521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472556 */     GIR_RootConstrainSelectedInstOperands,
     /*  472557 */     // GIR_Coverage, 14290,
     /*  472557 */     GIR_EraseRootFromParent_Done,
     /*  472558 */   // Label 8011: @472558
     /*  472558 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(472647), // Rule ID 14291 //
     /*  472563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472610 */     // MIs[1] Operand 1
     /*  472610 */     // No operand predicates
     /*  472610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  472622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472645 */     GIR_RootConstrainSelectedInstOperands,
     /*  472646 */     // GIR_Coverage, 14291,
     /*  472646 */     GIR_EraseRootFromParent_Done,
     /*  472647 */   // Label 8012: @472647
     /*  472647 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(472736), // Rule ID 14294 //
     /*  472652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472699 */     // MIs[1] Operand 1
     /*  472699 */     // No operand predicates
     /*  472699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472708 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472734 */     GIR_RootConstrainSelectedInstOperands,
     /*  472735 */     // GIR_Coverage, 14294,
     /*  472735 */     GIR_EraseRootFromParent_Done,
     /*  472736 */   // Label 8013: @472736
     /*  472736 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(472825), // Rule ID 14295 //
     /*  472741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472788 */     // MIs[1] Operand 1
     /*  472788 */     // No operand predicates
     /*  472788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472797 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  472800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472823 */     GIR_RootConstrainSelectedInstOperands,
     /*  472824 */     // GIR_Coverage, 14295,
     /*  472824 */     GIR_EraseRootFromParent_Done,
     /*  472825 */   // Label 8014: @472825
     /*  472825 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(472914), // Rule ID 14298 //
     /*  472830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472877 */     // MIs[1] Operand 1
     /*  472877 */     // No operand predicates
     /*  472877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472912 */     GIR_RootConstrainSelectedInstOperands,
     /*  472913 */     // GIR_Coverage, 14298,
     /*  472913 */     GIR_EraseRootFromParent_Done,
     /*  472914 */   // Label 8015: @472914
     /*  472914 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(473003), // Rule ID 14299 //
     /*  472919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  472927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472966 */     // MIs[1] Operand 1
     /*  472966 */     // No operand predicates
     /*  472966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  472978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473001 */     GIR_RootConstrainSelectedInstOperands,
     /*  473002 */     // GIR_Coverage, 14299,
     /*  473002 */     GIR_EraseRootFromParent_Done,
     /*  473003 */   // Label 8016: @473003
     /*  473003 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(473092), // Rule ID 14302 //
     /*  473008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473055 */     // MIs[1] Operand 1
     /*  473055 */     // No operand predicates
     /*  473055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  473067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473090 */     GIR_RootConstrainSelectedInstOperands,
     /*  473091 */     // GIR_Coverage, 14302,
     /*  473091 */     GIR_EraseRootFromParent_Done,
     /*  473092 */   // Label 8017: @473092
     /*  473092 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(473181), // Rule ID 14303 //
     /*  473097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473144 */     // MIs[1] Operand 1
     /*  473144 */     // No operand predicates
     /*  473144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  473156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473179 */     GIR_RootConstrainSelectedInstOperands,
     /*  473180 */     // GIR_Coverage, 14303,
     /*  473180 */     GIR_EraseRootFromParent_Done,
     /*  473181 */   // Label 8018: @473181
     /*  473181 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(473270), // Rule ID 14306 //
     /*  473186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473233 */     // MIs[1] Operand 1
     /*  473233 */     // No operand predicates
     /*  473233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473242 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  473245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473268 */     GIR_RootConstrainSelectedInstOperands,
     /*  473269 */     // GIR_Coverage, 14306,
     /*  473269 */     GIR_EraseRootFromParent_Done,
     /*  473270 */   // Label 8019: @473270
     /*  473270 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(473359), // Rule ID 14307 //
     /*  473275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  473283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473322 */     // MIs[1] Operand 1
     /*  473322 */     // No operand predicates
     /*  473322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  473334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473357 */     GIR_RootConstrainSelectedInstOperands,
     /*  473358 */     // GIR_Coverage, 14307,
     /*  473358 */     GIR_EraseRootFromParent_Done,
     /*  473359 */   // Label 8020: @473359
     /*  473359 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(473448), // Rule ID 14486 //
     /*  473364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473411 */     // MIs[1] Operand 1
     /*  473411 */     // No operand predicates
     /*  473411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  473423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473446 */     GIR_RootConstrainSelectedInstOperands,
     /*  473447 */     // GIR_Coverage, 14486,
     /*  473447 */     GIR_EraseRootFromParent_Done,
     /*  473448 */   // Label 8021: @473448
     /*  473448 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(473537), // Rule ID 14487 //
     /*  473453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473500 */     // MIs[1] Operand 1
     /*  473500 */     // No operand predicates
     /*  473500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473509 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  473512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473535 */     GIR_RootConstrainSelectedInstOperands,
     /*  473536 */     // GIR_Coverage, 14487,
     /*  473536 */     GIR_EraseRootFromParent_Done,
     /*  473537 */   // Label 8022: @473537
     /*  473537 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(473626), // Rule ID 14490 //
     /*  473542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473589 */     // MIs[1] Operand 1
     /*  473589 */     // No operand predicates
     /*  473589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473598 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473624 */     GIR_RootConstrainSelectedInstOperands,
     /*  473625 */     // GIR_Coverage, 14490,
     /*  473625 */     GIR_EraseRootFromParent_Done,
     /*  473626 */   // Label 8023: @473626
     /*  473626 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(473715), // Rule ID 14491 //
     /*  473631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473678 */     // MIs[1] Operand 1
     /*  473678 */     // No operand predicates
     /*  473678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473687 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473713 */     GIR_RootConstrainSelectedInstOperands,
     /*  473714 */     // GIR_Coverage, 14491,
     /*  473714 */     GIR_EraseRootFromParent_Done,
     /*  473715 */   // Label 8024: @473715
     /*  473715 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(473804), // Rule ID 14494 //
     /*  473720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473767 */     // MIs[1] Operand 1
     /*  473767 */     // No operand predicates
     /*  473767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  473779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473802 */     GIR_RootConstrainSelectedInstOperands,
     /*  473803 */     // GIR_Coverage, 14494,
     /*  473803 */     GIR_EraseRootFromParent_Done,
     /*  473804 */   // Label 8025: @473804
     /*  473804 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(473893), // Rule ID 14495 //
     /*  473809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473856 */     // MIs[1] Operand 1
     /*  473856 */     // No operand predicates
     /*  473856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473865 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  473868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473891 */     GIR_RootConstrainSelectedInstOperands,
     /*  473892 */     // GIR_Coverage, 14495,
     /*  473892 */     GIR_EraseRootFromParent_Done,
     /*  473893 */   // Label 8026: @473893
     /*  473893 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(473982), // Rule ID 14498 //
     /*  473898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473945 */     // MIs[1] Operand 1
     /*  473945 */     // No operand predicates
     /*  473945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  473957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473980 */     GIR_RootConstrainSelectedInstOperands,
     /*  473981 */     // GIR_Coverage, 14498,
     /*  473981 */     GIR_EraseRootFromParent_Done,
     /*  473982 */   // Label 8027: @473982
     /*  473982 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(474071), // Rule ID 14499 //
     /*  473987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474034 */     // MIs[1] Operand 1
     /*  474034 */     // No operand predicates
     /*  474034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  474046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474069 */     GIR_RootConstrainSelectedInstOperands,
     /*  474070 */     // GIR_Coverage, 14499,
     /*  474070 */     GIR_EraseRootFromParent_Done,
     /*  474071 */   // Label 8028: @474071
     /*  474071 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(474160), // Rule ID 14502 //
     /*  474076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474123 */     // MIs[1] Operand 1
     /*  474123 */     // No operand predicates
     /*  474123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474158 */     GIR_RootConstrainSelectedInstOperands,
     /*  474159 */     // GIR_Coverage, 14502,
     /*  474159 */     GIR_EraseRootFromParent_Done,
     /*  474160 */   // Label 8029: @474160
     /*  474160 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(474249), // Rule ID 14503 //
     /*  474165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474212 */     // MIs[1] Operand 1
     /*  474212 */     // No operand predicates
     /*  474212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474221 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474247 */     GIR_RootConstrainSelectedInstOperands,
     /*  474248 */     // GIR_Coverage, 14503,
     /*  474248 */     GIR_EraseRootFromParent_Done,
     /*  474249 */   // Label 8030: @474249
     /*  474249 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(474338), // Rule ID 14506 //
     /*  474254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474301 */     // MIs[1] Operand 1
     /*  474301 */     // No operand predicates
     /*  474301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474336 */     GIR_RootConstrainSelectedInstOperands,
     /*  474337 */     // GIR_Coverage, 14506,
     /*  474337 */     GIR_EraseRootFromParent_Done,
     /*  474338 */   // Label 8031: @474338
     /*  474338 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(474427), // Rule ID 14507 //
     /*  474343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474390 */     // MIs[1] Operand 1
     /*  474390 */     // No operand predicates
     /*  474390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  474402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474425 */     GIR_RootConstrainSelectedInstOperands,
     /*  474426 */     // GIR_Coverage, 14507,
     /*  474426 */     GIR_EraseRootFromParent_Done,
     /*  474427 */   // Label 8032: @474427
     /*  474427 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(474516), // Rule ID 14510 //
     /*  474432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474479 */     // MIs[1] Operand 1
     /*  474479 */     // No operand predicates
     /*  474479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474488 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474514 */     GIR_RootConstrainSelectedInstOperands,
     /*  474515 */     // GIR_Coverage, 14510,
     /*  474515 */     GIR_EraseRootFromParent_Done,
     /*  474516 */   // Label 8033: @474516
     /*  474516 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(474605), // Rule ID 14511 //
     /*  474521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474568 */     // MIs[1] Operand 1
     /*  474568 */     // No operand predicates
     /*  474568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474603 */     GIR_RootConstrainSelectedInstOperands,
     /*  474604 */     // GIR_Coverage, 14511,
     /*  474604 */     GIR_EraseRootFromParent_Done,
     /*  474605 */   // Label 8034: @474605
     /*  474605 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(474694), // Rule ID 14514 //
     /*  474610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474657 */     // MIs[1] Operand 1
     /*  474657 */     // No operand predicates
     /*  474657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474666 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474692 */     GIR_RootConstrainSelectedInstOperands,
     /*  474693 */     // GIR_Coverage, 14514,
     /*  474693 */     GIR_EraseRootFromParent_Done,
     /*  474694 */   // Label 8035: @474694
     /*  474694 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(474783), // Rule ID 14515 //
     /*  474699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474746 */     // MIs[1] Operand 1
     /*  474746 */     // No operand predicates
     /*  474746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474781 */     GIR_RootConstrainSelectedInstOperands,
     /*  474782 */     // GIR_Coverage, 14515,
     /*  474782 */     GIR_EraseRootFromParent_Done,
     /*  474783 */   // Label 8036: @474783
     /*  474783 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(474872), // Rule ID 14518 //
     /*  474788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474835 */     // MIs[1] Operand 1
     /*  474835 */     // No operand predicates
     /*  474835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474870 */     GIR_RootConstrainSelectedInstOperands,
     /*  474871 */     // GIR_Coverage, 14518,
     /*  474871 */     GIR_EraseRootFromParent_Done,
     /*  474872 */   // Label 8037: @474872
     /*  474872 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(474961), // Rule ID 14519 //
     /*  474877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  474924 */     // MIs[1] Operand 1
     /*  474924 */     // No operand predicates
     /*  474924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  474936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  474959 */     GIR_RootConstrainSelectedInstOperands,
     /*  474960 */     // GIR_Coverage, 14519,
     /*  474960 */     GIR_EraseRootFromParent_Done,
     /*  474961 */   // Label 8038: @474961
     /*  474961 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(475050), // Rule ID 14522 //
     /*  474966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  474969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  474974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  474977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  474980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  474983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475013 */     // MIs[1] Operand 1
     /*  475013 */     // No operand predicates
     /*  475013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  475025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475048 */     GIR_RootConstrainSelectedInstOperands,
     /*  475049 */     // GIR_Coverage, 14522,
     /*  475049 */     GIR_EraseRootFromParent_Done,
     /*  475050 */   // Label 8039: @475050
     /*  475050 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(475139), // Rule ID 14523 //
     /*  475055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475102 */     // MIs[1] Operand 1
     /*  475102 */     // No operand predicates
     /*  475102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475111 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  475114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475137 */     GIR_RootConstrainSelectedInstOperands,
     /*  475138 */     // GIR_Coverage, 14523,
     /*  475138 */     GIR_EraseRootFromParent_Done,
     /*  475139 */   // Label 8040: @475139
     /*  475139 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(475228), // Rule ID 14526 //
     /*  475144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475191 */     // MIs[1] Operand 1
     /*  475191 */     // No operand predicates
     /*  475191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475226 */     GIR_RootConstrainSelectedInstOperands,
     /*  475227 */     // GIR_Coverage, 14526,
     /*  475227 */     GIR_EraseRootFromParent_Done,
     /*  475228 */   // Label 8041: @475228
     /*  475228 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(475317), // Rule ID 14527 //
     /*  475233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475280 */     // MIs[1] Operand 1
     /*  475280 */     // No operand predicates
     /*  475280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475315 */     GIR_RootConstrainSelectedInstOperands,
     /*  475316 */     // GIR_Coverage, 14527,
     /*  475316 */     GIR_EraseRootFromParent_Done,
     /*  475317 */   // Label 8042: @475317
     /*  475317 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(475406), // Rule ID 14530 //
     /*  475322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475369 */     // MIs[1] Operand 1
     /*  475369 */     // No operand predicates
     /*  475369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475378 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475404 */     GIR_RootConstrainSelectedInstOperands,
     /*  475405 */     // GIR_Coverage, 14530,
     /*  475405 */     GIR_EraseRootFromParent_Done,
     /*  475406 */   // Label 8043: @475406
     /*  475406 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(475495), // Rule ID 14531 //
     /*  475411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475458 */     // MIs[1] Operand 1
     /*  475458 */     // No operand predicates
     /*  475458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475493 */     GIR_RootConstrainSelectedInstOperands,
     /*  475494 */     // GIR_Coverage, 14531,
     /*  475494 */     GIR_EraseRootFromParent_Done,
     /*  475495 */   // Label 8044: @475495
     /*  475495 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(475584), // Rule ID 14534 //
     /*  475500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475547 */     // MIs[1] Operand 1
     /*  475547 */     // No operand predicates
     /*  475547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  475559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475582 */     GIR_RootConstrainSelectedInstOperands,
     /*  475583 */     // GIR_Coverage, 14534,
     /*  475583 */     GIR_EraseRootFromParent_Done,
     /*  475584 */   // Label 8045: @475584
     /*  475584 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(475673), // Rule ID 14535 //
     /*  475589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475636 */     // MIs[1] Operand 1
     /*  475636 */     // No operand predicates
     /*  475636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  475648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475671 */     GIR_RootConstrainSelectedInstOperands,
     /*  475672 */     // GIR_Coverage, 14535,
     /*  475672 */     GIR_EraseRootFromParent_Done,
     /*  475673 */   // Label 8046: @475673
     /*  475673 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(475762), // Rule ID 14538 //
     /*  475678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475725 */     // MIs[1] Operand 1
     /*  475725 */     // No operand predicates
     /*  475725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475760 */     GIR_RootConstrainSelectedInstOperands,
     /*  475761 */     // GIR_Coverage, 14538,
     /*  475761 */     GIR_EraseRootFromParent_Done,
     /*  475762 */   // Label 8047: @475762
     /*  475762 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(475851), // Rule ID 14539 //
     /*  475767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475814 */     // MIs[1] Operand 1
     /*  475814 */     // No operand predicates
     /*  475814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  475826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475849 */     GIR_RootConstrainSelectedInstOperands,
     /*  475850 */     // GIR_Coverage, 14539,
     /*  475850 */     GIR_EraseRootFromParent_Done,
     /*  475851 */   // Label 8048: @475851
     /*  475851 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(475940), // Rule ID 14542 //
     /*  475856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475903 */     // MIs[1] Operand 1
     /*  475903 */     // No operand predicates
     /*  475903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  475915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  475938 */     GIR_RootConstrainSelectedInstOperands,
     /*  475939 */     // GIR_Coverage, 14542,
     /*  475939 */     GIR_EraseRootFromParent_Done,
     /*  475940 */   // Label 8049: @475940
     /*  475940 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(476029), // Rule ID 14543 //
     /*  475945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  475953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  475992 */     // MIs[1] Operand 1
     /*  475992 */     // No operand predicates
     /*  475992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476027 */     GIR_RootConstrainSelectedInstOperands,
     /*  476028 */     // GIR_Coverage, 14543,
     /*  476028 */     GIR_EraseRootFromParent_Done,
     /*  476029 */   // Label 8050: @476029
     /*  476029 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(476118), // Rule ID 14546 //
     /*  476034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476081 */     // MIs[1] Operand 1
     /*  476081 */     // No operand predicates
     /*  476081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476116 */     GIR_RootConstrainSelectedInstOperands,
     /*  476117 */     // GIR_Coverage, 14546,
     /*  476117 */     GIR_EraseRootFromParent_Done,
     /*  476118 */   // Label 8051: @476118
     /*  476118 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(476207), // Rule ID 14547 //
     /*  476123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476170 */     // MIs[1] Operand 1
     /*  476170 */     // No operand predicates
     /*  476170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476179 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476205 */     GIR_RootConstrainSelectedInstOperands,
     /*  476206 */     // GIR_Coverage, 14547,
     /*  476206 */     GIR_EraseRootFromParent_Done,
     /*  476207 */   // Label 8052: @476207
     /*  476207 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(476296), // Rule ID 14550 //
     /*  476212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476259 */     // MIs[1] Operand 1
     /*  476259 */     // No operand predicates
     /*  476259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476294 */     GIR_RootConstrainSelectedInstOperands,
     /*  476295 */     // GIR_Coverage, 14550,
     /*  476295 */     GIR_EraseRootFromParent_Done,
     /*  476296 */   // Label 8053: @476296
     /*  476296 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(476385), // Rule ID 14551 //
     /*  476301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476348 */     // MIs[1] Operand 1
     /*  476348 */     // No operand predicates
     /*  476348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476383 */     GIR_RootConstrainSelectedInstOperands,
     /*  476384 */     // GIR_Coverage, 14551,
     /*  476384 */     GIR_EraseRootFromParent_Done,
     /*  476385 */   // Label 8054: @476385
     /*  476385 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(476474), // Rule ID 14554 //
     /*  476390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476437 */     // MIs[1] Operand 1
     /*  476437 */     // No operand predicates
     /*  476437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476472 */     GIR_RootConstrainSelectedInstOperands,
     /*  476473 */     // GIR_Coverage, 14554,
     /*  476473 */     GIR_EraseRootFromParent_Done,
     /*  476474 */   // Label 8055: @476474
     /*  476474 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(476563), // Rule ID 14555 //
     /*  476479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476526 */     // MIs[1] Operand 1
     /*  476526 */     // No operand predicates
     /*  476526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476535 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476561 */     GIR_RootConstrainSelectedInstOperands,
     /*  476562 */     // GIR_Coverage, 14555,
     /*  476562 */     GIR_EraseRootFromParent_Done,
     /*  476563 */   // Label 8056: @476563
     /*  476563 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(476652), // Rule ID 14558 //
     /*  476568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476615 */     // MIs[1] Operand 1
     /*  476615 */     // No operand predicates
     /*  476615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476650 */     GIR_RootConstrainSelectedInstOperands,
     /*  476651 */     // GIR_Coverage, 14558,
     /*  476651 */     GIR_EraseRootFromParent_Done,
     /*  476652 */   // Label 8057: @476652
     /*  476652 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(476741), // Rule ID 14559 //
     /*  476657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476704 */     // MIs[1] Operand 1
     /*  476704 */     // No operand predicates
     /*  476704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476713 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  476716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476739 */     GIR_RootConstrainSelectedInstOperands,
     /*  476740 */     // GIR_Coverage, 14559,
     /*  476740 */     GIR_EraseRootFromParent_Done,
     /*  476741 */   // Label 8058: @476741
     /*  476741 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(476830), // Rule ID 14562 //
     /*  476746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476793 */     // MIs[1] Operand 1
     /*  476793 */     // No operand predicates
     /*  476793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476828 */     GIR_RootConstrainSelectedInstOperands,
     /*  476829 */     // GIR_Coverage, 14562,
     /*  476829 */     GIR_EraseRootFromParent_Done,
     /*  476830 */   // Label 8059: @476830
     /*  476830 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(476919), // Rule ID 14563 //
     /*  476835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476882 */     // MIs[1] Operand 1
     /*  476882 */     // No operand predicates
     /*  476882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  476894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  476917 */     GIR_RootConstrainSelectedInstOperands,
     /*  476918 */     // GIR_Coverage, 14563,
     /*  476918 */     GIR_EraseRootFromParent_Done,
     /*  476919 */   // Label 8060: @476919
     /*  476919 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(477008), // Rule ID 14566 //
     /*  476924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  476932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  476971 */     // MIs[1] Operand 1
     /*  476971 */     // No operand predicates
     /*  476971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  476983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477006 */     GIR_RootConstrainSelectedInstOperands,
     /*  477007 */     // GIR_Coverage, 14566,
     /*  477007 */     GIR_EraseRootFromParent_Done,
     /*  477008 */   // Label 8061: @477008
     /*  477008 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(477097), // Rule ID 14567 //
     /*  477013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477060 */     // MIs[1] Operand 1
     /*  477060 */     // No operand predicates
     /*  477060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477069 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  477072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477095 */     GIR_RootConstrainSelectedInstOperands,
     /*  477096 */     // GIR_Coverage, 14567,
     /*  477096 */     GIR_EraseRootFromParent_Done,
     /*  477097 */   // Label 8062: @477097
     /*  477097 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(477186), // Rule ID 14570 //
     /*  477102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477149 */     // MIs[1] Operand 1
     /*  477149 */     // No operand predicates
     /*  477149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  477161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477184 */     GIR_RootConstrainSelectedInstOperands,
     /*  477185 */     // GIR_Coverage, 14570,
     /*  477185 */     GIR_EraseRootFromParent_Done,
     /*  477186 */   // Label 8063: @477186
     /*  477186 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(477275), // Rule ID 14571 //
     /*  477191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  477199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  477238 */     // MIs[1] Operand 1
     /*  477238 */     // No operand predicates
     /*  477238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  477250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  477273 */     GIR_RootConstrainSelectedInstOperands,
     /*  477274 */     // GIR_Coverage, 14571,
     /*  477274 */     GIR_EraseRootFromParent_Done,
     /*  477275 */   // Label 8064: @477275
     /*  477275 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(477361), // Rule ID 24666 //
     /*  477280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  477291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  477294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  477297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477327 */     // MIs[1] Operand 1
     /*  477327 */     // No operand predicates
     /*  477327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  477339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477359 */     GIR_RootConstrainSelectedInstOperands,
     /*  477360 */     // GIR_Coverage, 24666,
     /*  477360 */     GIR_EraseRootFromParent_Done,
     /*  477361 */   // Label 8065: @477361
     /*  477361 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(477447), // Rule ID 24667 //
     /*  477366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  477377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  477380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  477383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477413 */     // MIs[1] Operand 1
     /*  477413 */     // No operand predicates
     /*  477413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  477425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477445 */     GIR_RootConstrainSelectedInstOperands,
     /*  477446 */     // GIR_Coverage, 24667,
     /*  477446 */     GIR_EraseRootFromParent_Done,
     /*  477447 */   // Label 8066: @477447
     /*  477447 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(477533), // Rule ID 24670 //
     /*  477452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  477463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  477466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  477469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477499 */     // MIs[1] Operand 1
     /*  477499 */     // No operand predicates
     /*  477499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477531 */     GIR_RootConstrainSelectedInstOperands,
     /*  477532 */     // GIR_Coverage, 24670,
     /*  477532 */     GIR_EraseRootFromParent_Done,
     /*  477533 */   // Label 8067: @477533
     /*  477533 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(477619), // Rule ID 24671 //
     /*  477538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  477549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  477552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  477555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477585 */     // MIs[1] Operand 1
     /*  477585 */     // No operand predicates
     /*  477585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477617 */     GIR_RootConstrainSelectedInstOperands,
     /*  477618 */     // GIR_Coverage, 24671,
     /*  477618 */     GIR_EraseRootFromParent_Done,
     /*  477619 */   // Label 8068: @477619
     /*  477619 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(477705), // Rule ID 24674 //
     /*  477624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  477635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  477638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477671 */     // MIs[1] Operand 1
     /*  477671 */     // No operand predicates
     /*  477671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477680 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  477680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477703 */     GIR_RootConstrainSelectedInstOperands,
     /*  477704 */     // GIR_Coverage, 24674,
     /*  477704 */     GIR_EraseRootFromParent_Done,
     /*  477705 */   // Label 8069: @477705
     /*  477705 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(477791), // Rule ID 24675 //
     /*  477710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  477721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  477724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  477727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477757 */     // MIs[1] Operand 1
     /*  477757 */     // No operand predicates
     /*  477757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  477766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  477786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477789 */     GIR_RootConstrainSelectedInstOperands,
     /*  477790 */     // GIR_Coverage, 24675,
     /*  477790 */     GIR_EraseRootFromParent_Done,
     /*  477791 */   // Label 8070: @477791
     /*  477791 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(477877), // Rule ID 24678 //
     /*  477796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477843 */     // MIs[1] Operand 1
     /*  477843 */     // No operand predicates
     /*  477843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477875 */     GIR_RootConstrainSelectedInstOperands,
     /*  477876 */     // GIR_Coverage, 24678,
     /*  477876 */     GIR_EraseRootFromParent_Done,
     /*  477877 */   // Label 8071: @477877
     /*  477877 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(477963), // Rule ID 24679 //
     /*  477882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  477885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477929 */     // MIs[1] Operand 1
     /*  477929 */     // No operand predicates
     /*  477929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477961 */     GIR_RootConstrainSelectedInstOperands,
     /*  477962 */     // GIR_Coverage, 24679,
     /*  477962 */     GIR_EraseRootFromParent_Done,
     /*  477963 */   // Label 8072: @477963
     /*  477963 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(478049), // Rule ID 24682 //
     /*  477968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  477971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478015 */     // MIs[1] Operand 1
     /*  478015 */     // No operand predicates
     /*  478015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478024 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478047 */     GIR_RootConstrainSelectedInstOperands,
     /*  478048 */     // GIR_Coverage, 24682,
     /*  478048 */     GIR_EraseRootFromParent_Done,
     /*  478049 */   // Label 8073: @478049
     /*  478049 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(478135), // Rule ID 24683 //
     /*  478054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  478065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  478068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  478071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478101 */     // MIs[1] Operand 1
     /*  478101 */     // No operand predicates
     /*  478101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478133 */     GIR_RootConstrainSelectedInstOperands,
     /*  478134 */     // GIR_Coverage, 24683,
     /*  478134 */     GIR_EraseRootFromParent_Done,
     /*  478135 */   // Label 8074: @478135
     /*  478135 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(478221), // Rule ID 24686 //
     /*  478140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478187 */     // MIs[1] Operand 1
     /*  478187 */     // No operand predicates
     /*  478187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478196 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478219 */     GIR_RootConstrainSelectedInstOperands,
     /*  478220 */     // GIR_Coverage, 24686,
     /*  478220 */     GIR_EraseRootFromParent_Done,
     /*  478221 */   // Label 8075: @478221
     /*  478221 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(478307), // Rule ID 24687 //
     /*  478226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  478237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  478240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  478243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478273 */     // MIs[1] Operand 1
     /*  478273 */     // No operand predicates
     /*  478273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478305 */     GIR_RootConstrainSelectedInstOperands,
     /*  478306 */     // GIR_Coverage, 24687,
     /*  478306 */     GIR_EraseRootFromParent_Done,
     /*  478307 */   // Label 8076: @478307
     /*  478307 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(478393), // Rule ID 24690 //
     /*  478312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  478323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  478326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  478329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478359 */     // MIs[1] Operand 1
     /*  478359 */     // No operand predicates
     /*  478359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  478368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  478388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478391 */     GIR_RootConstrainSelectedInstOperands,
     /*  478392 */     // GIR_Coverage, 24690,
     /*  478392 */     GIR_EraseRootFromParent_Done,
     /*  478393 */   // Label 8077: @478393
     /*  478393 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(478479), // Rule ID 24691 //
     /*  478398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  478409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  478412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  478415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478445 */     // MIs[1] Operand 1
     /*  478445 */     // No operand predicates
     /*  478445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  478454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  478474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478477 */     GIR_RootConstrainSelectedInstOperands,
     /*  478478 */     // GIR_Coverage, 24691,
     /*  478478 */     GIR_EraseRootFromParent_Done,
     /*  478479 */   // Label 8078: @478479
     /*  478479 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(478565), // Rule ID 24694 //
     /*  478484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478531 */     // MIs[1] Operand 1
     /*  478531 */     // No operand predicates
     /*  478531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478563 */     GIR_RootConstrainSelectedInstOperands,
     /*  478564 */     // GIR_Coverage, 24694,
     /*  478564 */     GIR_EraseRootFromParent_Done,
     /*  478565 */   // Label 8079: @478565
     /*  478565 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(478651), // Rule ID 24695 //
     /*  478570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478617 */     // MIs[1] Operand 1
     /*  478617 */     // No operand predicates
     /*  478617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478649 */     GIR_RootConstrainSelectedInstOperands,
     /*  478650 */     // GIR_Coverage, 24695,
     /*  478650 */     GIR_EraseRootFromParent_Done,
     /*  478651 */   // Label 8080: @478651
     /*  478651 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(478737), // Rule ID 24698 //
     /*  478656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  478659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478703 */     // MIs[1] Operand 1
     /*  478703 */     // No operand predicates
     /*  478703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478735 */     GIR_RootConstrainSelectedInstOperands,
     /*  478736 */     // GIR_Coverage, 24698,
     /*  478736 */     GIR_EraseRootFromParent_Done,
     /*  478737 */   // Label 8081: @478737
     /*  478737 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(478823), // Rule ID 24699 //
     /*  478742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  478745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478789 */     // MIs[1] Operand 1
     /*  478789 */     // No operand predicates
     /*  478789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478821 */     GIR_RootConstrainSelectedInstOperands,
     /*  478822 */     // GIR_Coverage, 24699,
     /*  478822 */     GIR_EraseRootFromParent_Done,
     /*  478823 */   // Label 8082: @478823
     /*  478823 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(478909), // Rule ID 24702 //
     /*  478828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  478831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478875 */     // MIs[1] Operand 1
     /*  478875 */     // No operand predicates
     /*  478875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478907 */     GIR_RootConstrainSelectedInstOperands,
     /*  478908 */     // GIR_Coverage, 24702,
     /*  478908 */     GIR_EraseRootFromParent_Done,
     /*  478909 */   // Label 8083: @478909
     /*  478909 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(478995), // Rule ID 24703 //
     /*  478914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  478917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478961 */     // MIs[1] Operand 1
     /*  478961 */     // No operand predicates
     /*  478961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478993 */     GIR_RootConstrainSelectedInstOperands,
     /*  478994 */     // GIR_Coverage, 24703,
     /*  478994 */     GIR_EraseRootFromParent_Done,
     /*  478995 */   // Label 8084: @478995
     /*  478995 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(479081), // Rule ID 24706 //
     /*  479000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  479011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  479014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479047 */     // MIs[1] Operand 1
     /*  479047 */     // No operand predicates
     /*  479047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479079 */     GIR_RootConstrainSelectedInstOperands,
     /*  479080 */     // GIR_Coverage, 24706,
     /*  479080 */     GIR_EraseRootFromParent_Done,
     /*  479081 */   // Label 8085: @479081
     /*  479081 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(479167), // Rule ID 24707 //
     /*  479086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  479097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  479100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479133 */     // MIs[1] Operand 1
     /*  479133 */     // No operand predicates
     /*  479133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479165 */     GIR_RootConstrainSelectedInstOperands,
     /*  479166 */     // GIR_Coverage, 24707,
     /*  479166 */     GIR_EraseRootFromParent_Done,
     /*  479167 */   // Label 8086: @479167
     /*  479167 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(479253), // Rule ID 24710 //
     /*  479172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  479183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  479186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479219 */     // MIs[1] Operand 1
     /*  479219 */     // No operand predicates
     /*  479219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479251 */     GIR_RootConstrainSelectedInstOperands,
     /*  479252 */     // GIR_Coverage, 24710,
     /*  479252 */     GIR_EraseRootFromParent_Done,
     /*  479253 */   // Label 8087: @479253
     /*  479253 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(479339), // Rule ID 24711 //
     /*  479258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  479269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  479272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  479275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479305 */     // MIs[1] Operand 1
     /*  479305 */     // No operand predicates
     /*  479305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479337 */     GIR_RootConstrainSelectedInstOperands,
     /*  479338 */     // GIR_Coverage, 24711,
     /*  479338 */     GIR_EraseRootFromParent_Done,
     /*  479339 */   // Label 8088: @479339
     /*  479339 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(479425), // Rule ID 24714 //
     /*  479344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  479355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  479358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  479361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479391 */     // MIs[1] Operand 1
     /*  479391 */     // No operand predicates
     /*  479391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479423 */     GIR_RootConstrainSelectedInstOperands,
     /*  479424 */     // GIR_Coverage, 24714,
     /*  479424 */     GIR_EraseRootFromParent_Done,
     /*  479425 */   // Label 8089: @479425
     /*  479425 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(479511), // Rule ID 24715 //
     /*  479430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  479441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  479444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  479447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479477 */     // MIs[1] Operand 1
     /*  479477 */     // No operand predicates
     /*  479477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479509 */     GIR_RootConstrainSelectedInstOperands,
     /*  479510 */     // GIR_Coverage, 24715,
     /*  479510 */     GIR_EraseRootFromParent_Done,
     /*  479511 */   // Label 8090: @479511
     /*  479511 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(479597), // Rule ID 24718 //
     /*  479516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  479533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479563 */     // MIs[1] Operand 1
     /*  479563 */     // No operand predicates
     /*  479563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479595 */     GIR_RootConstrainSelectedInstOperands,
     /*  479596 */     // GIR_Coverage, 24718,
     /*  479596 */     GIR_EraseRootFromParent_Done,
     /*  479597 */   // Label 8091: @479597
     /*  479597 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(479683), // Rule ID 24719 //
     /*  479602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  479619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479649 */     // MIs[1] Operand 1
     /*  479649 */     // No operand predicates
     /*  479649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479681 */     GIR_RootConstrainSelectedInstOperands,
     /*  479682 */     // GIR_Coverage, 24719,
     /*  479682 */     GIR_EraseRootFromParent_Done,
     /*  479683 */   // Label 8092: @479683
     /*  479683 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(479769), // Rule ID 24722 //
     /*  479688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479735 */     // MIs[1] Operand 1
     /*  479735 */     // No operand predicates
     /*  479735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479767 */     GIR_RootConstrainSelectedInstOperands,
     /*  479768 */     // GIR_Coverage, 24722,
     /*  479768 */     GIR_EraseRootFromParent_Done,
     /*  479769 */   // Label 8093: @479769
     /*  479769 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(479855), // Rule ID 24723 //
     /*  479774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479821 */     // MIs[1] Operand 1
     /*  479821 */     // No operand predicates
     /*  479821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479853 */     GIR_RootConstrainSelectedInstOperands,
     /*  479854 */     // GIR_Coverage, 24723,
     /*  479854 */     GIR_EraseRootFromParent_Done,
     /*  479855 */   // Label 8094: @479855
     /*  479855 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(479941), // Rule ID 24726 //
     /*  479860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  479863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479907 */     // MIs[1] Operand 1
     /*  479907 */     // No operand predicates
     /*  479907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479939 */     GIR_RootConstrainSelectedInstOperands,
     /*  479940 */     // GIR_Coverage, 24726,
     /*  479940 */     GIR_EraseRootFromParent_Done,
     /*  479941 */   // Label 8095: @479941
     /*  479941 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(480027), // Rule ID 24727 //
     /*  479946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  479949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479993 */     // MIs[1] Operand 1
     /*  479993 */     // No operand predicates
     /*  479993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480025 */     GIR_RootConstrainSelectedInstOperands,
     /*  480026 */     // GIR_Coverage, 24727,
     /*  480026 */     GIR_EraseRootFromParent_Done,
     /*  480027 */   // Label 8096: @480027
     /*  480027 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(480113), // Rule ID 24730 //
     /*  480032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  480049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480079 */     // MIs[1] Operand 1
     /*  480079 */     // No operand predicates
     /*  480079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480111 */     GIR_RootConstrainSelectedInstOperands,
     /*  480112 */     // GIR_Coverage, 24730,
     /*  480112 */     GIR_EraseRootFromParent_Done,
     /*  480113 */   // Label 8097: @480113
     /*  480113 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(480199), // Rule ID 24731 //
     /*  480118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  480135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480165 */     // MIs[1] Operand 1
     /*  480165 */     // No operand predicates
     /*  480165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480197 */     GIR_RootConstrainSelectedInstOperands,
     /*  480198 */     // GIR_Coverage, 24731,
     /*  480198 */     GIR_EraseRootFromParent_Done,
     /*  480199 */   // Label 8098: @480199
     /*  480199 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(480285), // Rule ID 24734 //
     /*  480204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  480221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480251 */     // MIs[1] Operand 1
     /*  480251 */     // No operand predicates
     /*  480251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480283 */     GIR_RootConstrainSelectedInstOperands,
     /*  480284 */     // GIR_Coverage, 24734,
     /*  480284 */     GIR_EraseRootFromParent_Done,
     /*  480285 */   // Label 8099: @480285
     /*  480285 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(480371), // Rule ID 24735 //
     /*  480290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  480307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480337 */     // MIs[1] Operand 1
     /*  480337 */     // No operand predicates
     /*  480337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480369 */     GIR_RootConstrainSelectedInstOperands,
     /*  480370 */     // GIR_Coverage, 24735,
     /*  480370 */     GIR_EraseRootFromParent_Done,
     /*  480371 */   // Label 8100: @480371
     /*  480371 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(480457), // Rule ID 24738 //
     /*  480376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  480379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  480393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480423 */     // MIs[1] Operand 1
     /*  480423 */     // No operand predicates
     /*  480423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  480432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480455 */     GIR_RootConstrainSelectedInstOperands,
     /*  480456 */     // GIR_Coverage, 24738,
     /*  480456 */     GIR_EraseRootFromParent_Done,
     /*  480457 */   // Label 8101: @480457
     /*  480457 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(480543), // Rule ID 24739 //
     /*  480462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  480465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  480473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  480476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  480479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480509 */     // MIs[1] Operand 1
     /*  480509 */     // No operand predicates
     /*  480509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  480518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  480538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480541 */     GIR_RootConstrainSelectedInstOperands,
     /*  480542 */     // GIR_Coverage, 24739,
     /*  480542 */     GIR_EraseRootFromParent_Done,
     /*  480543 */   // Label 8102: @480543
     /*  480543 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(480629), // Rule ID 24742 //
     /*  480548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  480565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480595 */     // MIs[1] Operand 1
     /*  480595 */     // No operand predicates
     /*  480595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480627 */     GIR_RootConstrainSelectedInstOperands,
     /*  480628 */     // GIR_Coverage, 24742,
     /*  480628 */     GIR_EraseRootFromParent_Done,
     /*  480629 */   // Label 8103: @480629
     /*  480629 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(480715), // Rule ID 24743 //
     /*  480634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  480645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  480648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  480651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480681 */     // MIs[1] Operand 1
     /*  480681 */     // No operand predicates
     /*  480681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  480693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480713 */     GIR_RootConstrainSelectedInstOperands,
     /*  480714 */     // GIR_Coverage, 24743,
     /*  480714 */     GIR_EraseRootFromParent_Done,
     /*  480715 */   // Label 8104: @480715
     /*  480715 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(480801), // Rule ID 24746 //
     /*  480720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480767 */     // MIs[1] Operand 1
     /*  480767 */     // No operand predicates
     /*  480767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480799 */     GIR_RootConstrainSelectedInstOperands,
     /*  480800 */     // GIR_Coverage, 24746,
     /*  480800 */     GIR_EraseRootFromParent_Done,
     /*  480801 */   // Label 8105: @480801
     /*  480801 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(480887), // Rule ID 24747 //
     /*  480806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  480817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  480820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  480823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480853 */     // MIs[1] Operand 1
     /*  480853 */     // No operand predicates
     /*  480853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  480862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  480865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480885 */     GIR_RootConstrainSelectedInstOperands,
     /*  480886 */     // GIR_Coverage, 24747,
     /*  480886 */     GIR_EraseRootFromParent_Done,
     /*  480887 */   // Label 8106: @480887
     /*  480887 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(480973), // Rule ID 24750 //
     /*  480892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  480895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480939 */     // MIs[1] Operand 1
     /*  480939 */     // No operand predicates
     /*  480939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  480948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  480951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  480968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480971 */     GIR_RootConstrainSelectedInstOperands,
     /*  480972 */     // GIR_Coverage, 24750,
     /*  480972 */     GIR_EraseRootFromParent_Done,
     /*  480973 */   // Label 8107: @480973
     /*  480973 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(481059), // Rule ID 24751 //
     /*  480978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  480981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  480986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  480989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  480992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  480995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481025 */     // MIs[1] Operand 1
     /*  481025 */     // No operand predicates
     /*  481025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  481034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  481037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481057 */     GIR_RootConstrainSelectedInstOperands,
     /*  481058 */     // GIR_Coverage, 24751,
     /*  481058 */     GIR_EraseRootFromParent_Done,
     /*  481059 */   // Label 8108: @481059
     /*  481059 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(481145), // Rule ID 24910 //
     /*  481064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481111 */     // MIs[1] Operand 1
     /*  481111 */     // No operand predicates
     /*  481111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  481123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481143 */     GIR_RootConstrainSelectedInstOperands,
     /*  481144 */     // GIR_Coverage, 24910,
     /*  481144 */     GIR_EraseRootFromParent_Done,
     /*  481145 */   // Label 8109: @481145
     /*  481145 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(481231), // Rule ID 24911 //
     /*  481150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  481161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  481164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481197 */     // MIs[1] Operand 1
     /*  481197 */     // No operand predicates
     /*  481197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481206 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  481209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481229 */     GIR_RootConstrainSelectedInstOperands,
     /*  481230 */     // GIR_Coverage, 24911,
     /*  481230 */     GIR_EraseRootFromParent_Done,
     /*  481231 */   // Label 8110: @481231
     /*  481231 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(481317), // Rule ID 24914 //
     /*  481236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481283 */     // MIs[1] Operand 1
     /*  481283 */     // No operand predicates
     /*  481283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481292 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481315 */     GIR_RootConstrainSelectedInstOperands,
     /*  481316 */     // GIR_Coverage, 24914,
     /*  481316 */     GIR_EraseRootFromParent_Done,
     /*  481317 */   // Label 8111: @481317
     /*  481317 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(481403), // Rule ID 24915 //
     /*  481322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481369 */     // MIs[1] Operand 1
     /*  481369 */     // No operand predicates
     /*  481369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481378 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481401 */     GIR_RootConstrainSelectedInstOperands,
     /*  481402 */     // GIR_Coverage, 24915,
     /*  481402 */     GIR_EraseRootFromParent_Done,
     /*  481403 */   // Label 8112: @481403
     /*  481403 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(481489), // Rule ID 24918 //
     /*  481408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  481411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  481425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481455 */     // MIs[1] Operand 1
     /*  481455 */     // No operand predicates
     /*  481455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  481464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481487 */     GIR_RootConstrainSelectedInstOperands,
     /*  481488 */     // GIR_Coverage, 24918,
     /*  481488 */     GIR_EraseRootFromParent_Done,
     /*  481489 */   // Label 8113: @481489
     /*  481489 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(481575), // Rule ID 24919 //
     /*  481494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  481497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  481511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481541 */     // MIs[1] Operand 1
     /*  481541 */     // No operand predicates
     /*  481541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  481550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  481553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  481570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481573 */     GIR_RootConstrainSelectedInstOperands,
     /*  481574 */     // GIR_Coverage, 24919,
     /*  481574 */     GIR_EraseRootFromParent_Done,
     /*  481575 */   // Label 8114: @481575
     /*  481575 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(481661), // Rule ID 24922 //
     /*  481580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481627 */     // MIs[1] Operand 1
     /*  481627 */     // No operand predicates
     /*  481627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481636 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  481639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481659 */     GIR_RootConstrainSelectedInstOperands,
     /*  481660 */     // GIR_Coverage, 24922,
     /*  481660 */     GIR_EraseRootFromParent_Done,
     /*  481661 */   // Label 8115: @481661
     /*  481661 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(481747), // Rule ID 24923 //
     /*  481666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481713 */     // MIs[1] Operand 1
     /*  481713 */     // No operand predicates
     /*  481713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  481725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481745 */     GIR_RootConstrainSelectedInstOperands,
     /*  481746 */     // GIR_Coverage, 24923,
     /*  481746 */     GIR_EraseRootFromParent_Done,
     /*  481747 */   // Label 8116: @481747
     /*  481747 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(481833), // Rule ID 24926 //
     /*  481752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481799 */     // MIs[1] Operand 1
     /*  481799 */     // No operand predicates
     /*  481799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  481811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481831 */     GIR_RootConstrainSelectedInstOperands,
     /*  481832 */     // GIR_Coverage, 24926,
     /*  481832 */     GIR_EraseRootFromParent_Done,
     /*  481833 */   // Label 8117: @481833
     /*  481833 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(481919), // Rule ID 24927 //
     /*  481838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  481841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481885 */     // MIs[1] Operand 1
     /*  481885 */     // No operand predicates
     /*  481885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481894 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  481897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481917 */     GIR_RootConstrainSelectedInstOperands,
     /*  481918 */     // GIR_Coverage, 24927,
     /*  481918 */     GIR_EraseRootFromParent_Done,
     /*  481919 */   // Label 8118: @481919
     /*  481919 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(482005), // Rule ID 24930 //
     /*  481924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  481927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  481932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  481941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481971 */     // MIs[1] Operand 1
     /*  481971 */     // No operand predicates
     /*  481971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481980 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  481983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482003 */     GIR_RootConstrainSelectedInstOperands,
     /*  482004 */     // GIR_Coverage, 24930,
     /*  482004 */     GIR_EraseRootFromParent_Done,
     /*  482005 */   // Label 8119: @482005
     /*  482005 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(482091), // Rule ID 24931 //
     /*  482010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  482013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  482021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  482024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  482027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482057 */     // MIs[1] Operand 1
     /*  482057 */     // No operand predicates
     /*  482057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482066 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482089 */     GIR_RootConstrainSelectedInstOperands,
     /*  482090 */     // GIR_Coverage, 24931,
     /*  482090 */     GIR_EraseRootFromParent_Done,
     /*  482091 */   // Label 8120: @482091
     /*  482091 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(482177), // Rule ID 24934 //
     /*  482096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  482113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482143 */     // MIs[1] Operand 1
     /*  482143 */     // No operand predicates
     /*  482143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  482155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482175 */     GIR_RootConstrainSelectedInstOperands,
     /*  482176 */     // GIR_Coverage, 24934,
     /*  482176 */     GIR_EraseRootFromParent_Done,
     /*  482177 */   // Label 8121: @482177
     /*  482177 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(482263), // Rule ID 24935 //
     /*  482182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  482193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  482196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  482199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482229 */     // MIs[1] Operand 1
     /*  482229 */     // No operand predicates
     /*  482229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  482241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482261 */     GIR_RootConstrainSelectedInstOperands,
     /*  482262 */     // GIR_Coverage, 24935,
     /*  482262 */     GIR_EraseRootFromParent_Done,
     /*  482263 */   // Label 8122: @482263
     /*  482263 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(482349), // Rule ID 24938 //
     /*  482268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  482285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482315 */     // MIs[1] Operand 1
     /*  482315 */     // No operand predicates
     /*  482315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  482327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482347 */     GIR_RootConstrainSelectedInstOperands,
     /*  482348 */     // GIR_Coverage, 24938,
     /*  482348 */     GIR_EraseRootFromParent_Done,
     /*  482349 */   // Label 8123: @482349
     /*  482349 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(482435), // Rule ID 24939 //
     /*  482354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  482371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482401 */     // MIs[1] Operand 1
     /*  482401 */     // No operand predicates
     /*  482401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  482413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482433 */     GIR_RootConstrainSelectedInstOperands,
     /*  482434 */     // GIR_Coverage, 24939,
     /*  482434 */     GIR_EraseRootFromParent_Done,
     /*  482435 */   // Label 8124: @482435
     /*  482435 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(482521), // Rule ID 24942 //
     /*  482440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  482443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  482457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482487 */     // MIs[1] Operand 1
     /*  482487 */     // No operand predicates
     /*  482487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482496 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  482496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482519 */     GIR_RootConstrainSelectedInstOperands,
     /*  482520 */     // GIR_Coverage, 24942,
     /*  482520 */     GIR_EraseRootFromParent_Done,
     /*  482521 */   // Label 8125: @482521
     /*  482521 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(482607), // Rule ID 24943 //
     /*  482526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  482529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  482543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482573 */     // MIs[1] Operand 1
     /*  482573 */     // No operand predicates
     /*  482573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  482582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  482585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  482602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482605 */     GIR_RootConstrainSelectedInstOperands,
     /*  482606 */     // GIR_Coverage, 24943,
     /*  482606 */     GIR_EraseRootFromParent_Done,
     /*  482607 */   // Label 8126: @482607
     /*  482607 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(482693), // Rule ID 24994 //
     /*  482612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482659 */     // MIs[1] Operand 1
     /*  482659 */     // No operand predicates
     /*  482659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482668 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  482671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482691 */     GIR_RootConstrainSelectedInstOperands,
     /*  482692 */     // GIR_Coverage, 24994,
     /*  482692 */     GIR_EraseRootFromParent_Done,
     /*  482693 */   // Label 8127: @482693
     /*  482693 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(482779), // Rule ID 24995 //
     /*  482698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  482701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482745 */     // MIs[1] Operand 1
     /*  482745 */     // No operand predicates
     /*  482745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  482757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482777 */     GIR_RootConstrainSelectedInstOperands,
     /*  482778 */     // GIR_Coverage, 24995,
     /*  482778 */     GIR_EraseRootFromParent_Done,
     /*  482779 */   // Label 8128: @482779
     /*  482779 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(482865), // Rule ID 24998 //
     /*  482784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482831 */     // MIs[1] Operand 1
     /*  482831 */     // No operand predicates
     /*  482831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482840 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  482843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482863 */     GIR_RootConstrainSelectedInstOperands,
     /*  482864 */     // GIR_Coverage, 24998,
     /*  482864 */     GIR_EraseRootFromParent_Done,
     /*  482865 */   // Label 8129: @482865
     /*  482865 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(482951), // Rule ID 24999 //
     /*  482870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  482873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482917 */     // MIs[1] Operand 1
     /*  482917 */     // No operand predicates
     /*  482917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482926 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  482929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482949 */     GIR_RootConstrainSelectedInstOperands,
     /*  482950 */     // GIR_Coverage, 24999,
     /*  482950 */     GIR_EraseRootFromParent_Done,
     /*  482951 */   // Label 8130: @482951
     /*  482951 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(483037), // Rule ID 25002 //
     /*  482956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  482959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  482964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  482967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  482970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  482973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483003 */     // MIs[1] Operand 1
     /*  483003 */     // No operand predicates
     /*  483003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483012 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  483015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483035 */     GIR_RootConstrainSelectedInstOperands,
     /*  483036 */     // GIR_Coverage, 25002,
     /*  483036 */     GIR_EraseRootFromParent_Done,
     /*  483037 */   // Label 8131: @483037
     /*  483037 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(483123), // Rule ID 25003 //
     /*  483042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483089 */     // MIs[1] Operand 1
     /*  483089 */     // No operand predicates
     /*  483089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483098 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  483101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483121 */     GIR_RootConstrainSelectedInstOperands,
     /*  483122 */     // GIR_Coverage, 25003,
     /*  483122 */     GIR_EraseRootFromParent_Done,
     /*  483123 */   // Label 8132: @483123
     /*  483123 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(483209), // Rule ID 25006 //
     /*  483128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  483139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  483142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  483145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483175 */     // MIs[1] Operand 1
     /*  483175 */     // No operand predicates
     /*  483175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483184 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  483187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483207 */     GIR_RootConstrainSelectedInstOperands,
     /*  483208 */     // GIR_Coverage, 25006,
     /*  483208 */     GIR_EraseRootFromParent_Done,
     /*  483209 */   // Label 8133: @483209
     /*  483209 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(483295), // Rule ID 25007 //
     /*  483214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  483225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  483228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  483231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483261 */     // MIs[1] Operand 1
     /*  483261 */     // No operand predicates
     /*  483261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483270 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  483273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483293 */     GIR_RootConstrainSelectedInstOperands,
     /*  483294 */     // GIR_Coverage, 25007,
     /*  483294 */     GIR_EraseRootFromParent_Done,
     /*  483295 */   // Label 8134: @483295
     /*  483295 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(483381), // Rule ID 25010 //
     /*  483300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  483311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  483314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  483317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483347 */     // MIs[1] Operand 1
     /*  483347 */     // No operand predicates
     /*  483347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  483359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483379 */     GIR_RootConstrainSelectedInstOperands,
     /*  483380 */     // GIR_Coverage, 25010,
     /*  483380 */     GIR_EraseRootFromParent_Done,
     /*  483381 */   // Label 8135: @483381
     /*  483381 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(483467), // Rule ID 25011 //
     /*  483386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  483397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  483400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  483403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483433 */     // MIs[1] Operand 1
     /*  483433 */     // No operand predicates
     /*  483433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483442 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  483445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483465 */     GIR_RootConstrainSelectedInstOperands,
     /*  483466 */     // GIR_Coverage, 25011,
     /*  483466 */     GIR_EraseRootFromParent_Done,
     /*  483467 */   // Label 8136: @483467
     /*  483467 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(483553), // Rule ID 25014 //
     /*  483472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  483475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  483483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  483486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  483489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483519 */     // MIs[1] Operand 1
     /*  483519 */     // No operand predicates
     /*  483519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  483531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483551 */     GIR_RootConstrainSelectedInstOperands,
     /*  483552 */     // GIR_Coverage, 25014,
     /*  483552 */     GIR_EraseRootFromParent_Done,
     /*  483553 */   // Label 8137: @483553
     /*  483553 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(483639), // Rule ID 25015 //
     /*  483558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  483561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  483566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  483569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  483572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  483575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483605 */     // MIs[1] Operand 1
     /*  483605 */     // No operand predicates
     /*  483605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483614 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  483617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483637 */     GIR_RootConstrainSelectedInstOperands,
     /*  483638 */     // GIR_Coverage, 25015,
     /*  483638 */     GIR_EraseRootFromParent_Done,
     /*  483639 */   // Label 8138: @483639
     /*  483639 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(483725), // Rule ID 61026 //
     /*  483644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483691 */     // MIs[1] Operand 1
     /*  483691 */     // No operand predicates
     /*  483691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  483703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483723 */     GIR_RootConstrainSelectedInstOperands,
     /*  483724 */     // GIR_Coverage, 61026,
     /*  483724 */     GIR_EraseRootFromParent_Done,
     /*  483725 */   // Label 8139: @483725
     /*  483725 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(483811), // Rule ID 61027 //
     /*  483730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  483733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  483741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  483744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  483747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483777 */     // MIs[1] Operand 1
     /*  483777 */     // No operand predicates
     /*  483777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  483789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483809 */     GIR_RootConstrainSelectedInstOperands,
     /*  483810 */     // GIR_Coverage, 61027,
     /*  483810 */     GIR_EraseRootFromParent_Done,
     /*  483811 */   // Label 8140: @483811
     /*  483811 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(483897), // Rule ID 61034 //
     /*  483816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483863 */     // MIs[1] Operand 1
     /*  483863 */     // No operand predicates
     /*  483863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  483875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483895 */     GIR_RootConstrainSelectedInstOperands,
     /*  483896 */     // GIR_Coverage, 61034,
     /*  483896 */     GIR_EraseRootFromParent_Done,
     /*  483897 */   // Label 8141: @483897
     /*  483897 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(483983), // Rule ID 61035 //
     /*  483902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  483905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  483919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  483949 */     // MIs[1] Operand 1
     /*  483949 */     // No operand predicates
     /*  483949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  483961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483981 */     GIR_RootConstrainSelectedInstOperands,
     /*  483982 */     // GIR_Coverage, 61035,
     /*  483982 */     GIR_EraseRootFromParent_Done,
     /*  483983 */   // Label 8142: @483983
     /*  483983 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(484069), // Rule ID 61042 //
     /*  483988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  483991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  483996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  484005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484035 */     // MIs[1] Operand 1
     /*  484035 */     // No operand predicates
     /*  484035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484067 */     GIR_RootConstrainSelectedInstOperands,
     /*  484068 */     // GIR_Coverage, 61042,
     /*  484068 */     GIR_EraseRootFromParent_Done,
     /*  484069 */   // Label 8143: @484069
     /*  484069 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(484155), // Rule ID 61043 //
     /*  484074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  484085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  484088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  484091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484121 */     // MIs[1] Operand 1
     /*  484121 */     // No operand predicates
     /*  484121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484153 */     GIR_RootConstrainSelectedInstOperands,
     /*  484154 */     // GIR_Coverage, 61043,
     /*  484154 */     GIR_EraseRootFromParent_Done,
     /*  484155 */   // Label 8144: @484155
     /*  484155 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(484241), // Rule ID 61050 //
     /*  484160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  484177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484207 */     // MIs[1] Operand 1
     /*  484207 */     // No operand predicates
     /*  484207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  484219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484239 */     GIR_RootConstrainSelectedInstOperands,
     /*  484240 */     // GIR_Coverage, 61050,
     /*  484240 */     GIR_EraseRootFromParent_Done,
     /*  484241 */   // Label 8145: @484241
     /*  484241 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(484327), // Rule ID 61051 //
     /*  484246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  484263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484293 */     // MIs[1] Operand 1
     /*  484293 */     // No operand predicates
     /*  484293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  484305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484325 */     GIR_RootConstrainSelectedInstOperands,
     /*  484326 */     // GIR_Coverage, 61051,
     /*  484326 */     GIR_EraseRootFromParent_Done,
     /*  484327 */   // Label 8146: @484327
     /*  484327 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(484413), // Rule ID 61058 //
     /*  484332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484379 */     // MIs[1] Operand 1
     /*  484379 */     // No operand predicates
     /*  484379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  484391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484411 */     GIR_RootConstrainSelectedInstOperands,
     /*  484412 */     // GIR_Coverage, 61058,
     /*  484412 */     GIR_EraseRootFromParent_Done,
     /*  484413 */   // Label 8147: @484413
     /*  484413 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(484499), // Rule ID 61059 //
     /*  484418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484465 */     // MIs[1] Operand 1
     /*  484465 */     // No operand predicates
     /*  484465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  484477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484497 */     GIR_RootConstrainSelectedInstOperands,
     /*  484498 */     // GIR_Coverage, 61059,
     /*  484498 */     GIR_EraseRootFromParent_Done,
     /*  484499 */   // Label 8148: @484499
     /*  484499 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(484585), // Rule ID 61066 //
     /*  484504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484551 */     // MIs[1] Operand 1
     /*  484551 */     // No operand predicates
     /*  484551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  484563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484583 */     GIR_RootConstrainSelectedInstOperands,
     /*  484584 */     // GIR_Coverage, 61066,
     /*  484584 */     GIR_EraseRootFromParent_Done,
     /*  484585 */   // Label 8149: @484585
     /*  484585 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(484671), // Rule ID 61067 //
     /*  484590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484637 */     // MIs[1] Operand 1
     /*  484637 */     // No operand predicates
     /*  484637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  484649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484669 */     GIR_RootConstrainSelectedInstOperands,
     /*  484670 */     // GIR_Coverage, 61067,
     /*  484670 */     GIR_EraseRootFromParent_Done,
     /*  484671 */   // Label 8150: @484671
     /*  484671 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(484757), // Rule ID 61074 //
     /*  484676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484723 */     // MIs[1] Operand 1
     /*  484723 */     // No operand predicates
     /*  484723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  484735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484755 */     GIR_RootConstrainSelectedInstOperands,
     /*  484756 */     // GIR_Coverage, 61074,
     /*  484756 */     GIR_EraseRootFromParent_Done,
     /*  484757 */   // Label 8151: @484757
     /*  484757 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(484843), // Rule ID 61075 //
     /*  484762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  484773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  484776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  484779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484809 */     // MIs[1] Operand 1
     /*  484809 */     // No operand predicates
     /*  484809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  484821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484841 */     GIR_RootConstrainSelectedInstOperands,
     /*  484842 */     // GIR_Coverage, 61075,
     /*  484842 */     GIR_EraseRootFromParent_Done,
     /*  484843 */   // Label 8152: @484843
     /*  484843 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(484929), // Rule ID 61082 //
     /*  484848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  484851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484895 */     // MIs[1] Operand 1
     /*  484895 */     // No operand predicates
     /*  484895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484927 */     GIR_RootConstrainSelectedInstOperands,
     /*  484928 */     // GIR_Coverage, 61082,
     /*  484928 */     GIR_EraseRootFromParent_Done,
     /*  484929 */   // Label 8153: @484929
     /*  484929 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(485015), // Rule ID 61083 //
     /*  484934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  484937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  484942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  484945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  484948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  484951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  484981 */     // MIs[1] Operand 1
     /*  484981 */     // No operand predicates
     /*  484981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  484993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485013 */     GIR_RootConstrainSelectedInstOperands,
     /*  485014 */     // GIR_Coverage, 61083,
     /*  485014 */     GIR_EraseRootFromParent_Done,
     /*  485015 */   // Label 8154: @485015
     /*  485015 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(485101), // Rule ID 61090 //
     /*  485020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  485037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485067 */     // MIs[1] Operand 1
     /*  485067 */     // No operand predicates
     /*  485067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485099 */     GIR_RootConstrainSelectedInstOperands,
     /*  485100 */     // GIR_Coverage, 61090,
     /*  485100 */     GIR_EraseRootFromParent_Done,
     /*  485101 */   // Label 8155: @485101
     /*  485101 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(485187), // Rule ID 61091 //
     /*  485106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  485123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485153 */     // MIs[1] Operand 1
     /*  485153 */     // No operand predicates
     /*  485153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485185 */     GIR_RootConstrainSelectedInstOperands,
     /*  485186 */     // GIR_Coverage, 61091,
     /*  485186 */     GIR_EraseRootFromParent_Done,
     /*  485187 */   // Label 8156: @485187
     /*  485187 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(485273), // Rule ID 61098 //
     /*  485192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485239 */     // MIs[1] Operand 1
     /*  485239 */     // No operand predicates
     /*  485239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485271 */     GIR_RootConstrainSelectedInstOperands,
     /*  485272 */     // GIR_Coverage, 61098,
     /*  485272 */     GIR_EraseRootFromParent_Done,
     /*  485273 */   // Label 8157: @485273
     /*  485273 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(485359), // Rule ID 61099 //
     /*  485278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  485295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485325 */     // MIs[1] Operand 1
     /*  485325 */     // No operand predicates
     /*  485325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485357 */     GIR_RootConstrainSelectedInstOperands,
     /*  485358 */     // GIR_Coverage, 61099,
     /*  485358 */     GIR_EraseRootFromParent_Done,
     /*  485359 */   // Label 8158: @485359
     /*  485359 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(485445), // Rule ID 61106 //
     /*  485364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485411 */     // MIs[1] Operand 1
     /*  485411 */     // No operand predicates
     /*  485411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  485423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485443 */     GIR_RootConstrainSelectedInstOperands,
     /*  485444 */     // GIR_Coverage, 61106,
     /*  485444 */     GIR_EraseRootFromParent_Done,
     /*  485445 */   // Label 8159: @485445
     /*  485445 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(485531), // Rule ID 61107 //
     /*  485450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  485467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485497 */     // MIs[1] Operand 1
     /*  485497 */     // No operand predicates
     /*  485497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  485509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485529 */     GIR_RootConstrainSelectedInstOperands,
     /*  485530 */     // GIR_Coverage, 61107,
     /*  485530 */     GIR_EraseRootFromParent_Done,
     /*  485531 */   // Label 8160: @485531
     /*  485531 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(485617), // Rule ID 61114 //
     /*  485536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485583 */     // MIs[1] Operand 1
     /*  485583 */     // No operand predicates
     /*  485583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485592 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  485595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485615 */     GIR_RootConstrainSelectedInstOperands,
     /*  485616 */     // GIR_Coverage, 61114,
     /*  485616 */     GIR_EraseRootFromParent_Done,
     /*  485617 */   // Label 8161: @485617
     /*  485617 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(485703), // Rule ID 61115 //
     /*  485622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  485633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  485636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  485639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485669 */     // MIs[1] Operand 1
     /*  485669 */     // No operand predicates
     /*  485669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  485681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485701 */     GIR_RootConstrainSelectedInstOperands,
     /*  485702 */     // GIR_Coverage, 61115,
     /*  485702 */     GIR_EraseRootFromParent_Done,
     /*  485703 */   // Label 8162: @485703
     /*  485703 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(485789), // Rule ID 61122 //
     /*  485708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485755 */     // MIs[1] Operand 1
     /*  485755 */     // No operand predicates
     /*  485755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485787 */     GIR_RootConstrainSelectedInstOperands,
     /*  485788 */     // GIR_Coverage, 61122,
     /*  485788 */     GIR_EraseRootFromParent_Done,
     /*  485789 */   // Label 8163: @485789
     /*  485789 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(485875), // Rule ID 61123 //
     /*  485794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  485811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485841 */     // MIs[1] Operand 1
     /*  485841 */     // No operand predicates
     /*  485841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  485853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485873 */     GIR_RootConstrainSelectedInstOperands,
     /*  485874 */     // GIR_Coverage, 61123,
     /*  485874 */     GIR_EraseRootFromParent_Done,
     /*  485875 */   // Label 8164: @485875
     /*  485875 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(485961), // Rule ID 61130 //
     /*  485880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  485883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  485927 */     // MIs[1] Operand 1
     /*  485927 */     // No operand predicates
     /*  485927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  485939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485959 */     GIR_RootConstrainSelectedInstOperands,
     /*  485960 */     // GIR_Coverage, 61130,
     /*  485960 */     GIR_EraseRootFromParent_Done,
     /*  485961 */   // Label 8165: @485961
     /*  485961 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(486047), // Rule ID 61131 //
     /*  485966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  485969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  485974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486013 */     // MIs[1] Operand 1
     /*  486013 */     // No operand predicates
     /*  486013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  486025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486045 */     GIR_RootConstrainSelectedInstOperands,
     /*  486046 */     // GIR_Coverage, 61131,
     /*  486046 */     GIR_EraseRootFromParent_Done,
     /*  486047 */   // Label 8166: @486047
     /*  486047 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(486133), // Rule ID 61138 //
     /*  486052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  486055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  486060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  486069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486099 */     // MIs[1] Operand 1
     /*  486099 */     // No operand predicates
     /*  486099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486108 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  486108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  486111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486131 */     GIR_RootConstrainSelectedInstOperands,
     /*  486132 */     // GIR_Coverage, 61138,
     /*  486132 */     GIR_EraseRootFromParent_Done,
     /*  486133 */   // Label 8167: @486133
     /*  486133 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(486219), // Rule ID 61139 //
     /*  486138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  486141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  486146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  486155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  486185 */     // MIs[1] Operand 1
     /*  486185 */     // No operand predicates
     /*  486185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  486194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  486197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  486214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486217 */     GIR_RootConstrainSelectedInstOperands,
     /*  486218 */     // GIR_Coverage, 61139,
     /*  486218 */     GIR_EraseRootFromParent_Done,
     /*  486219 */   // Label 8168: @486219
     /*  486219 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(486305), // Rule ID 61994 //
     /*  486224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  486235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  486238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  486241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486271 */     // MIs[1] Operand 1
     /*  486271 */     // No operand predicates
     /*  486271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486280 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  486283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486303 */     GIR_RootConstrainSelectedInstOperands,
     /*  486304 */     // GIR_Coverage, 61994,
     /*  486304 */     GIR_EraseRootFromParent_Done,
     /*  486305 */   // Label 8169: @486305
     /*  486305 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(486391), // Rule ID 61995 //
     /*  486310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  486321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  486324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  486327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486357 */     // MIs[1] Operand 1
     /*  486357 */     // No operand predicates
     /*  486357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  486369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486389 */     GIR_RootConstrainSelectedInstOperands,
     /*  486390 */     // GIR_Coverage, 61995,
     /*  486390 */     GIR_EraseRootFromParent_Done,
     /*  486391 */   // Label 8170: @486391
     /*  486391 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(486477), // Rule ID 61998 //
     /*  486396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  486407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  486410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  486413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486443 */     // MIs[1] Operand 1
     /*  486443 */     // No operand predicates
     /*  486443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486475 */     GIR_RootConstrainSelectedInstOperands,
     /*  486476 */     // GIR_Coverage, 61998,
     /*  486476 */     GIR_EraseRootFromParent_Done,
     /*  486477 */   // Label 8171: @486477
     /*  486477 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(486563), // Rule ID 61999 //
     /*  486482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  486493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  486496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  486499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486529 */     // MIs[1] Operand 1
     /*  486529 */     // No operand predicates
     /*  486529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486561 */     GIR_RootConstrainSelectedInstOperands,
     /*  486562 */     // GIR_Coverage, 61999,
     /*  486562 */     GIR_EraseRootFromParent_Done,
     /*  486563 */   // Label 8172: @486563
     /*  486563 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(486649), // Rule ID 62002 //
     /*  486568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  486579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  486582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486615 */     // MIs[1] Operand 1
     /*  486615 */     // No operand predicates
     /*  486615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  486624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486647 */     GIR_RootConstrainSelectedInstOperands,
     /*  486648 */     // GIR_Coverage, 62002,
     /*  486648 */     GIR_EraseRootFromParent_Done,
     /*  486649 */   // Label 8173: @486649
     /*  486649 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(486735), // Rule ID 62003 //
     /*  486654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  486665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  486668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  486671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486701 */     // MIs[1] Operand 1
     /*  486701 */     // No operand predicates
     /*  486701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  486710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486733 */     GIR_RootConstrainSelectedInstOperands,
     /*  486734 */     // GIR_Coverage, 62003,
     /*  486734 */     GIR_EraseRootFromParent_Done,
     /*  486735 */   // Label 8174: @486735
     /*  486735 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(486821), // Rule ID 62006 //
     /*  486740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486787 */     // MIs[1] Operand 1
     /*  486787 */     // No operand predicates
     /*  486787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486819 */     GIR_RootConstrainSelectedInstOperands,
     /*  486820 */     // GIR_Coverage, 62006,
     /*  486820 */     GIR_EraseRootFromParent_Done,
     /*  486821 */   // Label 8175: @486821
     /*  486821 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(486907), // Rule ID 62007 //
     /*  486826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486873 */     // MIs[1] Operand 1
     /*  486873 */     // No operand predicates
     /*  486873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  486882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  486885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486905 */     GIR_RootConstrainSelectedInstOperands,
     /*  486906 */     // GIR_Coverage, 62007,
     /*  486906 */     GIR_EraseRootFromParent_Done,
     /*  486907 */   // Label 8176: @486907
     /*  486907 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(486993), // Rule ID 62010 //
     /*  486912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  486915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486959 */     // MIs[1] Operand 1
     /*  486959 */     // No operand predicates
     /*  486959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  486968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  486971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486991 */     GIR_RootConstrainSelectedInstOperands,
     /*  486992 */     // GIR_Coverage, 62010,
     /*  486992 */     GIR_EraseRootFromParent_Done,
     /*  486993 */   // Label 8177: @486993
     /*  486993 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(487079), // Rule ID 62011 //
     /*  486998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  487009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  487012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  487015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487045 */     // MIs[1] Operand 1
     /*  487045 */     // No operand predicates
     /*  487045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487077 */     GIR_RootConstrainSelectedInstOperands,
     /*  487078 */     // GIR_Coverage, 62011,
     /*  487078 */     GIR_EraseRootFromParent_Done,
     /*  487079 */   // Label 8178: @487079
     /*  487079 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(487165), // Rule ID 62014 //
     /*  487084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487131 */     // MIs[1] Operand 1
     /*  487131 */     // No operand predicates
     /*  487131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487163 */     GIR_RootConstrainSelectedInstOperands,
     /*  487164 */     // GIR_Coverage, 62014,
     /*  487164 */     GIR_EraseRootFromParent_Done,
     /*  487165 */   // Label 8179: @487165
     /*  487165 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(487251), // Rule ID 62015 //
     /*  487170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487217 */     // MIs[1] Operand 1
     /*  487217 */     // No operand predicates
     /*  487217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  487229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487249 */     GIR_RootConstrainSelectedInstOperands,
     /*  487250 */     // GIR_Coverage, 62015,
     /*  487250 */     GIR_EraseRootFromParent_Done,
     /*  487251 */   // Label 8180: @487251
     /*  487251 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(487337), // Rule ID 62018 //
     /*  487256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  487267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  487270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  487273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487303 */     // MIs[1] Operand 1
     /*  487303 */     // No operand predicates
     /*  487303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  487312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487335 */     GIR_RootConstrainSelectedInstOperands,
     /*  487336 */     // GIR_Coverage, 62018,
     /*  487336 */     GIR_EraseRootFromParent_Done,
     /*  487337 */   // Label 8181: @487337
     /*  487337 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(487423), // Rule ID 62019 //
     /*  487342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  487353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  487356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  487359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487389 */     // MIs[1] Operand 1
     /*  487389 */     // No operand predicates
     /*  487389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  487398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487421 */     GIR_RootConstrainSelectedInstOperands,
     /*  487422 */     // GIR_Coverage, 62019,
     /*  487422 */     GIR_EraseRootFromParent_Done,
     /*  487423 */   // Label 8182: @487423
     /*  487423 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(487509), // Rule ID 62022 //
     /*  487428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487475 */     // MIs[1] Operand 1
     /*  487475 */     // No operand predicates
     /*  487475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  487484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487507 */     GIR_RootConstrainSelectedInstOperands,
     /*  487508 */     // GIR_Coverage, 62022,
     /*  487508 */     GIR_EraseRootFromParent_Done,
     /*  487509 */   // Label 8183: @487509
     /*  487509 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(487595), // Rule ID 62023 //
     /*  487514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  487525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  487528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  487531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487561 */     // MIs[1] Operand 1
     /*  487561 */     // No operand predicates
     /*  487561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487570 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  487570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487593 */     GIR_RootConstrainSelectedInstOperands,
     /*  487594 */     // GIR_Coverage, 62023,
     /*  487594 */     GIR_EraseRootFromParent_Done,
     /*  487595 */   // Label 8184: @487595
     /*  487595 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(487681), // Rule ID 62026 //
     /*  487600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487647 */     // MIs[1] Operand 1
     /*  487647 */     // No operand predicates
     /*  487647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  487656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487679 */     GIR_RootConstrainSelectedInstOperands,
     /*  487680 */     // GIR_Coverage, 62026,
     /*  487680 */     GIR_EraseRootFromParent_Done,
     /*  487681 */   // Label 8185: @487681
     /*  487681 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(487767), // Rule ID 62027 //
     /*  487686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487733 */     // MIs[1] Operand 1
     /*  487733 */     // No operand predicates
     /*  487733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  487742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487765 */     GIR_RootConstrainSelectedInstOperands,
     /*  487766 */     // GIR_Coverage, 62027,
     /*  487766 */     GIR_EraseRootFromParent_Done,
     /*  487767 */   // Label 8186: @487767
     /*  487767 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(487853), // Rule ID 62030 //
     /*  487772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487819 */     // MIs[1] Operand 1
     /*  487819 */     // No operand predicates
     /*  487819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  487828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  487848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487851 */     GIR_RootConstrainSelectedInstOperands,
     /*  487852 */     // GIR_Coverage, 62030,
     /*  487852 */     GIR_EraseRootFromParent_Done,
     /*  487853 */   // Label 8187: @487853
     /*  487853 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(487939), // Rule ID 62031 //
     /*  487858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  487861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  487878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487905 */     // MIs[1] Operand 1
     /*  487905 */     // No operand predicates
     /*  487905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  487914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  487917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  487921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  487926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  487934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  487937 */     GIR_RootConstrainSelectedInstOperands,
     /*  487938 */     // GIR_Coverage, 62031,
     /*  487938 */     GIR_EraseRootFromParent_Done,
     /*  487939 */   // Label 8188: @487939
     /*  487939 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(488025), // Rule ID 62034 //
     /*  487944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  487947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  487952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  487955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  487958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  487961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  487964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  487983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  487987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  487991 */     // MIs[1] Operand 1
     /*  487991 */     // No operand predicates
     /*  487991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488023 */     GIR_RootConstrainSelectedInstOperands,
     /*  488024 */     // GIR_Coverage, 62034,
     /*  488024 */     GIR_EraseRootFromParent_Done,
     /*  488025 */   // Label 8189: @488025
     /*  488025 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(488111), // Rule ID 62035 //
     /*  488030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  488041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  488044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  488047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488077 */     // MIs[1] Operand 1
     /*  488077 */     // No operand predicates
     /*  488077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488109 */     GIR_RootConstrainSelectedInstOperands,
     /*  488110 */     // GIR_Coverage, 62035,
     /*  488110 */     GIR_EraseRootFromParent_Done,
     /*  488111 */   // Label 8190: @488111
     /*  488111 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(488197), // Rule ID 62038 //
     /*  488116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  488127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  488130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488163 */     // MIs[1] Operand 1
     /*  488163 */     // No operand predicates
     /*  488163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488195 */     GIR_RootConstrainSelectedInstOperands,
     /*  488196 */     // GIR_Coverage, 62038,
     /*  488196 */     GIR_EraseRootFromParent_Done,
     /*  488197 */   // Label 8191: @488197
     /*  488197 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(488283), // Rule ID 62039 //
     /*  488202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  488213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  488216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  488219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488249 */     // MIs[1] Operand 1
     /*  488249 */     // No operand predicates
     /*  488249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488258 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488281 */     GIR_RootConstrainSelectedInstOperands,
     /*  488282 */     // GIR_Coverage, 62039,
     /*  488282 */     GIR_EraseRootFromParent_Done,
     /*  488283 */   // Label 8192: @488283
     /*  488283 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(488369), // Rule ID 62042 //
     /*  488288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  488299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  488302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  488305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488335 */     // MIs[1] Operand 1
     /*  488335 */     // No operand predicates
     /*  488335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  488344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488367 */     GIR_RootConstrainSelectedInstOperands,
     /*  488368 */     // GIR_Coverage, 62042,
     /*  488368 */     GIR_EraseRootFromParent_Done,
     /*  488369 */   // Label 8193: @488369
     /*  488369 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(488455), // Rule ID 62043 //
     /*  488374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  488385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  488388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  488391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488421 */     // MIs[1] Operand 1
     /*  488421 */     // No operand predicates
     /*  488421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488430 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  488430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488453 */     GIR_RootConstrainSelectedInstOperands,
     /*  488454 */     // GIR_Coverage, 62043,
     /*  488454 */     GIR_EraseRootFromParent_Done,
     /*  488455 */   // Label 8194: @488455
     /*  488455 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(488541), // Rule ID 62046 //
     /*  488460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488507 */     // MIs[1] Operand 1
     /*  488507 */     // No operand predicates
     /*  488507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488539 */     GIR_RootConstrainSelectedInstOperands,
     /*  488540 */     // GIR_Coverage, 62046,
     /*  488540 */     GIR_EraseRootFromParent_Done,
     /*  488541 */   // Label 8195: @488541
     /*  488541 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(488627), // Rule ID 62047 //
     /*  488546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488593 */     // MIs[1] Operand 1
     /*  488593 */     // No operand predicates
     /*  488593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  488605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488625 */     GIR_RootConstrainSelectedInstOperands,
     /*  488626 */     // GIR_Coverage, 62047,
     /*  488626 */     GIR_EraseRootFromParent_Done,
     /*  488627 */   // Label 8196: @488627
     /*  488627 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(488713), // Rule ID 62050 //
     /*  488632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488679 */     // MIs[1] Operand 1
     /*  488679 */     // No operand predicates
     /*  488679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488711 */     GIR_RootConstrainSelectedInstOperands,
     /*  488712 */     // GIR_Coverage, 62050,
     /*  488712 */     GIR_EraseRootFromParent_Done,
     /*  488713 */   // Label 8197: @488713
     /*  488713 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(488799), // Rule ID 62051 //
     /*  488718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488765 */     // MIs[1] Operand 1
     /*  488765 */     // No operand predicates
     /*  488765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  488777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488797 */     GIR_RootConstrainSelectedInstOperands,
     /*  488798 */     // GIR_Coverage, 62051,
     /*  488798 */     GIR_EraseRootFromParent_Done,
     /*  488799 */   // Label 8198: @488799
     /*  488799 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(488885), // Rule ID 62054 //
     /*  488804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488851 */     // MIs[1] Operand 1
     /*  488851 */     // No operand predicates
     /*  488851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  488860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488883 */     GIR_RootConstrainSelectedInstOperands,
     /*  488884 */     // GIR_Coverage, 62054,
     /*  488884 */     GIR_EraseRootFromParent_Done,
     /*  488885 */   // Label 8199: @488885
     /*  488885 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(488971), // Rule ID 62055 //
     /*  488890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  488893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  488910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  488929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  488933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  488937 */     // MIs[1] Operand 1
     /*  488937 */     // No operand predicates
     /*  488937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  488946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  488949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  488953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  488958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  488966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  488969 */     GIR_RootConstrainSelectedInstOperands,
     /*  488970 */     // GIR_Coverage, 62055,
     /*  488970 */     GIR_EraseRootFromParent_Done,
     /*  488971 */   // Label 8200: @488971
     /*  488971 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(489057), // Rule ID 62058 //
     /*  488976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  488979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  488984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  488987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  488990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  488993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  488996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489023 */     // MIs[1] Operand 1
     /*  489023 */     // No operand predicates
     /*  489023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489055 */     GIR_RootConstrainSelectedInstOperands,
     /*  489056 */     // GIR_Coverage, 62058,
     /*  489056 */     GIR_EraseRootFromParent_Done,
     /*  489057 */   // Label 8201: @489057
     /*  489057 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(489143), // Rule ID 62059 //
     /*  489062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489109 */     // MIs[1] Operand 1
     /*  489109 */     // No operand predicates
     /*  489109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489141 */     GIR_RootConstrainSelectedInstOperands,
     /*  489142 */     // GIR_Coverage, 62059,
     /*  489142 */     GIR_EraseRootFromParent_Done,
     /*  489143 */   // Label 8202: @489143
     /*  489143 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(489229), // Rule ID 62062 //
     /*  489148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489195 */     // MIs[1] Operand 1
     /*  489195 */     // No operand predicates
     /*  489195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489227 */     GIR_RootConstrainSelectedInstOperands,
     /*  489228 */     // GIR_Coverage, 62062,
     /*  489228 */     GIR_EraseRootFromParent_Done,
     /*  489229 */   // Label 8203: @489229
     /*  489229 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(489315), // Rule ID 62063 //
     /*  489234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489281 */     // MIs[1] Operand 1
     /*  489281 */     // No operand predicates
     /*  489281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489313 */     GIR_RootConstrainSelectedInstOperands,
     /*  489314 */     // GIR_Coverage, 62063,
     /*  489314 */     GIR_EraseRootFromParent_Done,
     /*  489315 */   // Label 8204: @489315
     /*  489315 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(489401), // Rule ID 62066 //
     /*  489320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489367 */     // MIs[1] Operand 1
     /*  489367 */     // No operand predicates
     /*  489367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  489376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489399 */     GIR_RootConstrainSelectedInstOperands,
     /*  489400 */     // GIR_Coverage, 62066,
     /*  489400 */     GIR_EraseRootFromParent_Done,
     /*  489401 */   // Label 8205: @489401
     /*  489401 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(489487), // Rule ID 62067 //
     /*  489406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489453 */     // MIs[1] Operand 1
     /*  489453 */     // No operand predicates
     /*  489453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  489462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489485 */     GIR_RootConstrainSelectedInstOperands,
     /*  489486 */     // GIR_Coverage, 62067,
     /*  489486 */     GIR_EraseRootFromParent_Done,
     /*  489487 */   // Label 8206: @489487
     /*  489487 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(489573), // Rule ID 62070 //
     /*  489492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  489509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489539 */     // MIs[1] Operand 1
     /*  489539 */     // No operand predicates
     /*  489539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489571 */     GIR_RootConstrainSelectedInstOperands,
     /*  489572 */     // GIR_Coverage, 62070,
     /*  489572 */     GIR_EraseRootFromParent_Done,
     /*  489573 */   // Label 8207: @489573
     /*  489573 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(489659), // Rule ID 62071 //
     /*  489578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  489595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489625 */     // MIs[1] Operand 1
     /*  489625 */     // No operand predicates
     /*  489625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  489637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489657 */     GIR_RootConstrainSelectedInstOperands,
     /*  489658 */     // GIR_Coverage, 62071,
     /*  489658 */     GIR_EraseRootFromParent_Done,
     /*  489659 */   // Label 8208: @489659
     /*  489659 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(489745), // Rule ID 62074 //
     /*  489664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  489675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  489678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  489681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489711 */     // MIs[1] Operand 1
     /*  489711 */     // No operand predicates
     /*  489711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489743 */     GIR_RootConstrainSelectedInstOperands,
     /*  489744 */     // GIR_Coverage, 62074,
     /*  489744 */     GIR_EraseRootFromParent_Done,
     /*  489745 */   // Label 8209: @489745
     /*  489745 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(489831), // Rule ID 62075 //
     /*  489750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  489761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  489764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  489767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489797 */     // MIs[1] Operand 1
     /*  489797 */     // No operand predicates
     /*  489797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  489809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489829 */     GIR_RootConstrainSelectedInstOperands,
     /*  489830 */     // GIR_Coverage, 62075,
     /*  489830 */     GIR_EraseRootFromParent_Done,
     /*  489831 */   // Label 8210: @489831
     /*  489831 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(489917), // Rule ID 62078 //
     /*  489836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  489839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  489847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  489850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  489853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  489856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489883 */     // MIs[1] Operand 1
     /*  489883 */     // No operand predicates
     /*  489883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  489892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  489915 */     GIR_RootConstrainSelectedInstOperands,
     /*  489916 */     // GIR_Coverage, 62078,
     /*  489916 */     GIR_EraseRootFromParent_Done,
     /*  489917 */   // Label 8211: @489917
     /*  489917 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(490003), // Rule ID 62079 //
     /*  489922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  489925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  489930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  489933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  489936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  489939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  489942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  489961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  489965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  489969 */     // MIs[1] Operand 1
     /*  489969 */     // No operand predicates
     /*  489969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489978 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  489978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  489981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  489985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  489990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  489998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  490001 */     GIR_RootConstrainSelectedInstOperands,
     /*  490002 */     // GIR_Coverage, 62079,
     /*  490002 */     GIR_EraseRootFromParent_Done,
     /*  490003 */   // Label 8212: @490003
     /*  490003 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(490082), // Rule ID 2744 //
     /*  490008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  490063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490080 */     GIR_RootConstrainSelectedInstOperands,
     /*  490081 */     // GIR_Coverage, 2744,
     /*  490081 */     GIR_EraseRootFromParent_Done,
     /*  490082 */   // Label 8213: @490082
     /*  490082 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(490161), // Rule ID 2745 //
     /*  490087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  490142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490159 */     GIR_RootConstrainSelectedInstOperands,
     /*  490160 */     // GIR_Coverage, 2745,
     /*  490160 */     GIR_EraseRootFromParent_Done,
     /*  490161 */   // Label 8214: @490161
     /*  490161 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(490240), // Rule ID 4060 //
     /*  490166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  490221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490238 */     GIR_RootConstrainSelectedInstOperands,
     /*  490239 */     // GIR_Coverage, 4060,
     /*  490239 */     GIR_EraseRootFromParent_Done,
     /*  490240 */   // Label 8215: @490240
     /*  490240 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(490319), // Rule ID 4061 //
     /*  490245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490297 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  490300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490317 */     GIR_RootConstrainSelectedInstOperands,
     /*  490318 */     // GIR_Coverage, 4061,
     /*  490318 */     GIR_EraseRootFromParent_Done,
     /*  490319 */   // Label 8216: @490319
     /*  490319 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(490398), // Rule ID 4070 //
     /*  490324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  490379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490396 */     GIR_RootConstrainSelectedInstOperands,
     /*  490397 */     // GIR_Coverage, 4070,
     /*  490397 */     GIR_EraseRootFromParent_Done,
     /*  490398 */   // Label 8217: @490398
     /*  490398 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(490477), // Rule ID 4071 //
     /*  490403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490455 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  490458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490475 */     GIR_RootConstrainSelectedInstOperands,
     /*  490476 */     // GIR_Coverage, 4071,
     /*  490476 */     GIR_EraseRootFromParent_Done,
     /*  490477 */   // Label 8218: @490477
     /*  490477 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(490556), // Rule ID 4080 //
     /*  490482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  490537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490554 */     GIR_RootConstrainSelectedInstOperands,
     /*  490555 */     // GIR_Coverage, 4080,
     /*  490555 */     GIR_EraseRootFromParent_Done,
     /*  490556 */   // Label 8219: @490556
     /*  490556 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(490635), // Rule ID 4081 //
     /*  490561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  490616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490633 */     GIR_RootConstrainSelectedInstOperands,
     /*  490634 */     // GIR_Coverage, 4081,
     /*  490634 */     GIR_EraseRootFromParent_Done,
     /*  490635 */   // Label 8220: @490635
     /*  490635 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(490714), // Rule ID 4090 //
     /*  490640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490692 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  490695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490712 */     GIR_RootConstrainSelectedInstOperands,
     /*  490713 */     // GIR_Coverage, 4090,
     /*  490713 */     GIR_EraseRootFromParent_Done,
     /*  490714 */   // Label 8221: @490714
     /*  490714 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(490793), // Rule ID 4091 //
     /*  490719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  490730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  490733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  490736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  490739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  490774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490791 */     GIR_RootConstrainSelectedInstOperands,
     /*  490792 */     // GIR_Coverage, 4091,
     /*  490792 */     GIR_EraseRootFromParent_Done,
     /*  490793 */   // Label 8222: @490793
     /*  490793 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(490872), // Rule ID 4100 //
     /*  490798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  490853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490870 */     GIR_RootConstrainSelectedInstOperands,
     /*  490871 */     // GIR_Coverage, 4100,
     /*  490871 */     GIR_EraseRootFromParent_Done,
     /*  490872 */   // Label 8223: @490872
     /*  490872 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(490951), // Rule ID 4101 //
     /*  490877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  490888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  490891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  490894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  490897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490929 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  490932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490949 */     GIR_RootConstrainSelectedInstOperands,
     /*  490950 */     // GIR_Coverage, 4101,
     /*  490950 */     GIR_EraseRootFromParent_Done,
     /*  490951 */   // Label 8224: @490951
     /*  490951 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(491030), // Rule ID 4110 //
     /*  490956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  490964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  490967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  490970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  490973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  490976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  491011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491028 */     GIR_RootConstrainSelectedInstOperands,
     /*  491029 */     // GIR_Coverage, 4110,
     /*  491029 */     GIR_EraseRootFromParent_Done,
     /*  491030 */   // Label 8225: @491030
     /*  491030 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(491109), // Rule ID 4111 //
     /*  491035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491087 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  491090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491107 */     GIR_RootConstrainSelectedInstOperands,
     /*  491108 */     // GIR_Coverage, 4111,
     /*  491108 */     GIR_EraseRootFromParent_Done,
     /*  491109 */   // Label 8226: @491109
     /*  491109 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(491188), // Rule ID 4120 //
     /*  491114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491186 */     GIR_RootConstrainSelectedInstOperands,
     /*  491187 */     // GIR_Coverage, 4120,
     /*  491187 */     GIR_EraseRootFromParent_Done,
     /*  491188 */   // Label 8227: @491188
     /*  491188 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(491267), // Rule ID 4121 //
     /*  491193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491265 */     GIR_RootConstrainSelectedInstOperands,
     /*  491266 */     // GIR_Coverage, 4121,
     /*  491266 */     GIR_EraseRootFromParent_Done,
     /*  491267 */   // Label 8228: @491267
     /*  491267 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(491346), // Rule ID 4130 //
     /*  491272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491344 */     GIR_RootConstrainSelectedInstOperands,
     /*  491345 */     // GIR_Coverage, 4130,
     /*  491345 */     GIR_EraseRootFromParent_Done,
     /*  491346 */   // Label 8229: @491346
     /*  491346 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(491425), // Rule ID 4131 //
     /*  491351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491423 */     GIR_RootConstrainSelectedInstOperands,
     /*  491424 */     // GIR_Coverage, 4131,
     /*  491424 */     GIR_EraseRootFromParent_Done,
     /*  491425 */   // Label 8230: @491425
     /*  491425 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(491504), // Rule ID 4140 //
     /*  491430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  491485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491502 */     GIR_RootConstrainSelectedInstOperands,
     /*  491503 */     // GIR_Coverage, 4140,
     /*  491503 */     GIR_EraseRootFromParent_Done,
     /*  491504 */   // Label 8231: @491504
     /*  491504 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(491583), // Rule ID 4141 //
     /*  491509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  491564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491581 */     GIR_RootConstrainSelectedInstOperands,
     /*  491582 */     // GIR_Coverage, 4141,
     /*  491582 */     GIR_EraseRootFromParent_Done,
     /*  491583 */   // Label 8232: @491583
     /*  491583 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(491662), // Rule ID 4150 //
     /*  491588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  491643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491660 */     GIR_RootConstrainSelectedInstOperands,
     /*  491661 */     // GIR_Coverage, 4150,
     /*  491661 */     GIR_EraseRootFromParent_Done,
     /*  491662 */   // Label 8233: @491662
     /*  491662 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(491741), // Rule ID 4151 //
     /*  491667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  491722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491739 */     GIR_RootConstrainSelectedInstOperands,
     /*  491740 */     // GIR_Coverage, 4151,
     /*  491740 */     GIR_EraseRootFromParent_Done,
     /*  491741 */   // Label 8234: @491741
     /*  491741 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(491820), // Rule ID 4160 //
     /*  491746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491818 */     GIR_RootConstrainSelectedInstOperands,
     /*  491819 */     // GIR_Coverage, 4160,
     /*  491819 */     GIR_EraseRootFromParent_Done,
     /*  491820 */   // Label 8235: @491820
     /*  491820 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(491899), // Rule ID 4161 //
     /*  491825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  491836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  491839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  491842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  491845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  491877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  491880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491897 */     GIR_RootConstrainSelectedInstOperands,
     /*  491898 */     // GIR_Coverage, 4161,
     /*  491898 */     GIR_EraseRootFromParent_Done,
     /*  491899 */   // Label 8236: @491899
     /*  491899 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(491978), // Rule ID 4170 //
     /*  491904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  491907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  491921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  491924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491956 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  491956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  491959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  491973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491976 */     GIR_RootConstrainSelectedInstOperands,
     /*  491977 */     // GIR_Coverage, 4170,
     /*  491977 */     GIR_EraseRootFromParent_Done,
     /*  491978 */   // Label 8237: @491978
     /*  491978 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(492057), // Rule ID 4171 //
     /*  491983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  491986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  491991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  491994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  491997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  492038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492055 */     GIR_RootConstrainSelectedInstOperands,
     /*  492056 */     // GIR_Coverage, 4171,
     /*  492056 */     GIR_EraseRootFromParent_Done,
     /*  492057 */   // Label 8238: @492057
     /*  492057 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(492136), // Rule ID 4180 //
     /*  492062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  492117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492134 */     GIR_RootConstrainSelectedInstOperands,
     /*  492135 */     // GIR_Coverage, 4180,
     /*  492135 */     GIR_EraseRootFromParent_Done,
     /*  492136 */   // Label 8239: @492136
     /*  492136 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(492215), // Rule ID 4181 //
     /*  492141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  492196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492213 */     GIR_RootConstrainSelectedInstOperands,
     /*  492214 */     // GIR_Coverage, 4181,
     /*  492214 */     GIR_EraseRootFromParent_Done,
     /*  492215 */   // Label 8240: @492215
     /*  492215 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(492294), // Rule ID 4190 //
     /*  492220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  492275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492292 */     GIR_RootConstrainSelectedInstOperands,
     /*  492293 */     // GIR_Coverage, 4190,
     /*  492293 */     GIR_EraseRootFromParent_Done,
     /*  492294 */   // Label 8241: @492294
     /*  492294 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(492373), // Rule ID 4191 //
     /*  492299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  492307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492351 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  492354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492371 */     GIR_RootConstrainSelectedInstOperands,
     /*  492372 */     // GIR_Coverage, 4191,
     /*  492372 */     GIR_EraseRootFromParent_Done,
     /*  492373 */   // Label 8242: @492373
     /*  492373 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(492452), // Rule ID 4260 //
     /*  492378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492430 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  492433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492450 */     GIR_RootConstrainSelectedInstOperands,
     /*  492451 */     // GIR_Coverage, 4260,
     /*  492451 */     GIR_EraseRootFromParent_Done,
     /*  492452 */   // Label 8243: @492452
     /*  492452 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(492531), // Rule ID 4261 //
     /*  492457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  492512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492529 */     GIR_RootConstrainSelectedInstOperands,
     /*  492530 */     // GIR_Coverage, 4261,
     /*  492530 */     GIR_EraseRootFromParent_Done,
     /*  492531 */   // Label 8244: @492531
     /*  492531 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(492610), // Rule ID 4270 //
     /*  492536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  492556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  492591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492608 */     GIR_RootConstrainSelectedInstOperands,
     /*  492609 */     // GIR_Coverage, 4270,
     /*  492609 */     GIR_EraseRootFromParent_Done,
     /*  492610 */   // Label 8245: @492610
     /*  492610 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(492689), // Rule ID 4271 //
     /*  492615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  492635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  492670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492687 */     GIR_RootConstrainSelectedInstOperands,
     /*  492688 */     // GIR_Coverage, 4271,
     /*  492688 */     GIR_EraseRootFromParent_Done,
     /*  492689 */   // Label 8246: @492689
     /*  492689 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(492768), // Rule ID 4280 //
     /*  492694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  492714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  492749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492766 */     GIR_RootConstrainSelectedInstOperands,
     /*  492767 */     // GIR_Coverage, 4280,
     /*  492767 */     GIR_EraseRootFromParent_Done,
     /*  492768 */   // Label 8247: @492768
     /*  492768 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(492847), // Rule ID 4281 //
     /*  492773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  492784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  492787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  492790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  492793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  492828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492845 */     GIR_RootConstrainSelectedInstOperands,
     /*  492846 */     // GIR_Coverage, 4281,
     /*  492846 */     GIR_EraseRootFromParent_Done,
     /*  492847 */   // Label 8248: @492847
     /*  492847 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(492926), // Rule ID 4290 //
     /*  492852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  492872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  492907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492924 */     GIR_RootConstrainSelectedInstOperands,
     /*  492925 */     // GIR_Coverage, 4290,
     /*  492925 */     GIR_EraseRootFromParent_Done,
     /*  492926 */   // Label 8249: @492926
     /*  492926 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(493005), // Rule ID 4291 //
     /*  492931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  492939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  492942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  492945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  492948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  492951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  492986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493003 */     GIR_RootConstrainSelectedInstOperands,
     /*  493004 */     // GIR_Coverage, 4291,
     /*  493004 */     GIR_EraseRootFromParent_Done,
     /*  493005 */   // Label 8250: @493005
     /*  493005 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(493084), // Rule ID 4300 //
     /*  493010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493082 */     GIR_RootConstrainSelectedInstOperands,
     /*  493083 */     // GIR_Coverage, 4300,
     /*  493083 */     GIR_EraseRootFromParent_Done,
     /*  493084 */   // Label 8251: @493084
     /*  493084 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(493163), // Rule ID 4301 //
     /*  493089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493161 */     GIR_RootConstrainSelectedInstOperands,
     /*  493162 */     // GIR_Coverage, 4301,
     /*  493162 */     GIR_EraseRootFromParent_Done,
     /*  493163 */   // Label 8252: @493163
     /*  493163 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(493242), // Rule ID 4310 //
     /*  493168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  493223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493240 */     GIR_RootConstrainSelectedInstOperands,
     /*  493241 */     // GIR_Coverage, 4310,
     /*  493241 */     GIR_EraseRootFromParent_Done,
     /*  493242 */   // Label 8253: @493242
     /*  493242 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(493321), // Rule ID 4311 //
     /*  493247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493299 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  493302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493319 */     GIR_RootConstrainSelectedInstOperands,
     /*  493320 */     // GIR_Coverage, 4311,
     /*  493320 */     GIR_EraseRootFromParent_Done,
     /*  493321 */   // Label 8254: @493321
     /*  493321 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(493400), // Rule ID 4320 //
     /*  493326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  493381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493398 */     GIR_RootConstrainSelectedInstOperands,
     /*  493399 */     // GIR_Coverage, 4320,
     /*  493399 */     GIR_EraseRootFromParent_Done,
     /*  493400 */   // Label 8255: @493400
     /*  493400 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(493479), // Rule ID 4321 //
     /*  493405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  493460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493477 */     GIR_RootConstrainSelectedInstOperands,
     /*  493478 */     // GIR_Coverage, 4321,
     /*  493478 */     GIR_EraseRootFromParent_Done,
     /*  493479 */   // Label 8256: @493479
     /*  493479 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(493558), // Rule ID 4330 //
     /*  493484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  493539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493556 */     GIR_RootConstrainSelectedInstOperands,
     /*  493557 */     // GIR_Coverage, 4330,
     /*  493557 */     GIR_EraseRootFromParent_Done,
     /*  493558 */   // Label 8257: @493558
     /*  493558 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(493637), // Rule ID 4331 //
     /*  493563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493615 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  493618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493635 */     GIR_RootConstrainSelectedInstOperands,
     /*  493636 */     // GIR_Coverage, 4331,
     /*  493636 */     GIR_EraseRootFromParent_Done,
     /*  493637 */   // Label 8258: @493637
     /*  493637 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(493716), // Rule ID 4340 //
     /*  493642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  493662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  493697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493714 */     GIR_RootConstrainSelectedInstOperands,
     /*  493715 */     // GIR_Coverage, 4340,
     /*  493715 */     GIR_EraseRootFromParent_Done,
     /*  493716 */   // Label 8259: @493716
     /*  493716 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(493795), // Rule ID 4341 //
     /*  493721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  493732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  493735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  493738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  493741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  493776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493793 */     GIR_RootConstrainSelectedInstOperands,
     /*  493794 */     // GIR_Coverage, 4341,
     /*  493794 */     GIR_EraseRootFromParent_Done,
     /*  493795 */   // Label 8260: @493795
     /*  493795 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(493874), // Rule ID 4350 //
     /*  493800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  493820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493872 */     GIR_RootConstrainSelectedInstOperands,
     /*  493873 */     // GIR_Coverage, 4350,
     /*  493873 */     GIR_EraseRootFromParent_Done,
     /*  493874 */   // Label 8261: @493874
     /*  493874 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(493953), // Rule ID 4351 //
     /*  493879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  493890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  493893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  493896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  493899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  493934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493951 */     GIR_RootConstrainSelectedInstOperands,
     /*  493952 */     // GIR_Coverage, 4351,
     /*  493952 */     GIR_EraseRootFromParent_Done,
     /*  493953 */   // Label 8262: @493953
     /*  493953 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(494032), // Rule ID 4360 //
     /*  493958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  493966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  493969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  493972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  493975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  493978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494030 */     GIR_RootConstrainSelectedInstOperands,
     /*  494031 */     // GIR_Coverage, 4360,
     /*  494031 */     GIR_EraseRootFromParent_Done,
     /*  494032 */   // Label 8263: @494032
     /*  494032 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(494111), // Rule ID 4361 //
     /*  494037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494089 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494109 */     GIR_RootConstrainSelectedInstOperands,
     /*  494110 */     // GIR_Coverage, 4361,
     /*  494110 */     GIR_EraseRootFromParent_Done,
     /*  494111 */   // Label 8264: @494111
     /*  494111 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(494190), // Rule ID 4370 //
     /*  494116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  494171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494188 */     GIR_RootConstrainSelectedInstOperands,
     /*  494189 */     // GIR_Coverage, 4370,
     /*  494189 */     GIR_EraseRootFromParent_Done,
     /*  494190 */   // Label 8265: @494190
     /*  494190 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(494269), // Rule ID 4371 //
     /*  494195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494247 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  494250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494267 */     GIR_RootConstrainSelectedInstOperands,
     /*  494268 */     // GIR_Coverage, 4371,
     /*  494268 */     GIR_EraseRootFromParent_Done,
     /*  494269 */   // Label 8266: @494269
     /*  494269 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(494348), // Rule ID 4380 //
     /*  494274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  494329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494346 */     GIR_RootConstrainSelectedInstOperands,
     /*  494347 */     // GIR_Coverage, 4380,
     /*  494347 */     GIR_EraseRootFromParent_Done,
     /*  494348 */   // Label 8267: @494348
     /*  494348 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(494427), // Rule ID 4381 //
     /*  494353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  494408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494425 */     GIR_RootConstrainSelectedInstOperands,
     /*  494426 */     // GIR_Coverage, 4381,
     /*  494426 */     GIR_EraseRootFromParent_Done,
     /*  494427 */   // Label 8268: @494427
     /*  494427 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(494506), // Rule ID 4390 //
     /*  494432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  494487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494504 */     GIR_RootConstrainSelectedInstOperands,
     /*  494505 */     // GIR_Coverage, 4390,
     /*  494505 */     GIR_EraseRootFromParent_Done,
     /*  494506 */   // Label 8269: @494506
     /*  494506 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(494585), // Rule ID 4391 //
     /*  494511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494563 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  494566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494583 */     GIR_RootConstrainSelectedInstOperands,
     /*  494584 */     // GIR_Coverage, 4391,
     /*  494584 */     GIR_EraseRootFromParent_Done,
     /*  494585 */   // Label 8270: @494585
     /*  494585 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(494664), // Rule ID 4400 //
     /*  494590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  494610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494662 */     GIR_RootConstrainSelectedInstOperands,
     /*  494663 */     // GIR_Coverage, 4400,
     /*  494663 */     GIR_EraseRootFromParent_Done,
     /*  494664 */   // Label 8271: @494664
     /*  494664 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(494743), // Rule ID 4401 //
     /*  494669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  494677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  494689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  494724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494741 */     GIR_RootConstrainSelectedInstOperands,
     /*  494742 */     // GIR_Coverage, 4401,
     /*  494742 */     GIR_EraseRootFromParent_Done,
     /*  494743 */   // Label 8272: @494743
     /*  494743 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(494822), // Rule ID 4470 //
     /*  494748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  494803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494820 */     GIR_RootConstrainSelectedInstOperands,
     /*  494821 */     // GIR_Coverage, 4470,
     /*  494821 */     GIR_EraseRootFromParent_Done,
     /*  494822 */   // Label 8273: @494822
     /*  494822 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(494901), // Rule ID 4471 //
     /*  494827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  494838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  494841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  494844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  494847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  494882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494899 */     GIR_RootConstrainSelectedInstOperands,
     /*  494900 */     // GIR_Coverage, 4471,
     /*  494900 */     GIR_EraseRootFromParent_Done,
     /*  494901 */   // Label 8274: @494901
     /*  494901 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(494980), // Rule ID 4480 //
     /*  494906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  494923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  494926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  494961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494978 */     GIR_RootConstrainSelectedInstOperands,
     /*  494979 */     // GIR_Coverage, 4480,
     /*  494979 */     GIR_EraseRootFromParent_Done,
     /*  494980 */   // Label 8275: @494980
     /*  494980 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(495059), // Rule ID 4481 //
     /*  494985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  494993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  494996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  494999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  495002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  495005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495037 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495057 */     GIR_RootConstrainSelectedInstOperands,
     /*  495058 */     // GIR_Coverage, 4481,
     /*  495058 */     GIR_EraseRootFromParent_Done,
     /*  495059 */   // Label 8276: @495059
     /*  495059 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(495138), // Rule ID 4490 //
     /*  495064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  495075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  495078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  495081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  495084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495136 */     GIR_RootConstrainSelectedInstOperands,
     /*  495137 */     // GIR_Coverage, 4490,
     /*  495137 */     GIR_EraseRootFromParent_Done,
     /*  495138 */   // Label 8277: @495138
     /*  495138 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(495217), // Rule ID 4491 //
     /*  495143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  495154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  495157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  495160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  495163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495215 */     GIR_RootConstrainSelectedInstOperands,
     /*  495216 */     // GIR_Coverage, 4491,
     /*  495216 */     GIR_EraseRootFromParent_Done,
     /*  495217 */   // Label 8278: @495217
     /*  495217 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(495296), // Rule ID 4500 //
     /*  495222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  495277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495294 */     GIR_RootConstrainSelectedInstOperands,
     /*  495295 */     // GIR_Coverage, 4500,
     /*  495295 */     GIR_EraseRootFromParent_Done,
     /*  495296 */   // Label 8279: @495296
     /*  495296 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(495375), // Rule ID 4501 //
     /*  495301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  495312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  495315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  495318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  495321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  495356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495373 */     GIR_RootConstrainSelectedInstOperands,
     /*  495374 */     // GIR_Coverage, 4501,
     /*  495374 */     GIR_EraseRootFromParent_Done,
     /*  495375 */   // Label 8280: @495375
     /*  495375 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(495454), // Rule ID 4510 //
     /*  495380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  495435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495452 */     GIR_RootConstrainSelectedInstOperands,
     /*  495453 */     // GIR_Coverage, 4510,
     /*  495453 */     GIR_EraseRootFromParent_Done,
     /*  495454 */   // Label 8281: @495454
     /*  495454 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(495533), // Rule ID 4511 //
     /*  495459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  495470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  495473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  495476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  495479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  495514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495531 */     GIR_RootConstrainSelectedInstOperands,
     /*  495532 */     // GIR_Coverage, 4511,
     /*  495532 */     GIR_EraseRootFromParent_Done,
     /*  495533 */   // Label 8282: @495533
     /*  495533 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(495612), // Rule ID 4520 //
     /*  495538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  495590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  495593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495610 */     GIR_RootConstrainSelectedInstOperands,
     /*  495611 */     // GIR_Coverage, 4520,
     /*  495611 */     GIR_EraseRootFromParent_Done,
     /*  495612 */   // Label 8283: @495612
     /*  495612 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(495691), // Rule ID 4521 //
     /*  495617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  495628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  495631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  495634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  495637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  495669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  495672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495689 */     GIR_RootConstrainSelectedInstOperands,
     /*  495690 */     // GIR_Coverage, 4521,
     /*  495690 */     GIR_EraseRootFromParent_Done,
     /*  495691 */   // Label 8284: @495691
     /*  495691 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(495770), // Rule ID 4530 //
     /*  495696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495768 */     GIR_RootConstrainSelectedInstOperands,
     /*  495769 */     // GIR_Coverage, 4530,
     /*  495769 */     GIR_EraseRootFromParent_Done,
     /*  495770 */   // Label 8285: @495770
     /*  495770 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(495849), // Rule ID 4531 //
     /*  495775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  495792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  495795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  495830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495847 */     GIR_RootConstrainSelectedInstOperands,
     /*  495848 */     // GIR_Coverage, 4531,
     /*  495848 */     GIR_EraseRootFromParent_Done,
     /*  495849 */   // Label 8286: @495849
     /*  495849 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(495928), // Rule ID 4540 //
     /*  495854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  495906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495926 */     GIR_RootConstrainSelectedInstOperands,
     /*  495927 */     // GIR_Coverage, 4540,
     /*  495927 */     GIR_EraseRootFromParent_Done,
     /*  495928 */   // Label 8287: @495928
     /*  495928 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(496007), // Rule ID 4541 //
     /*  495933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  495941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  495944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  495947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  495950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  495953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495985 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  495985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  495988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496005 */     GIR_RootConstrainSelectedInstOperands,
     /*  496006 */     // GIR_Coverage, 4541,
     /*  496006 */     GIR_EraseRootFromParent_Done,
     /*  496007 */   // Label 8288: @496007
     /*  496007 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(496086), // Rule ID 4550 //
     /*  496012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  496023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  496026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  496029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  496032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496084 */     GIR_RootConstrainSelectedInstOperands,
     /*  496085 */     // GIR_Coverage, 4550,
     /*  496085 */     GIR_EraseRootFromParent_Done,
     /*  496086 */   // Label 8289: @496086
     /*  496086 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(496165), // Rule ID 4551 //
     /*  496091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  496102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  496105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  496108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  496111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496163 */     GIR_RootConstrainSelectedInstOperands,
     /*  496164 */     // GIR_Coverage, 4551,
     /*  496164 */     GIR_EraseRootFromParent_Done,
     /*  496165 */   // Label 8290: @496165
     /*  496165 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(496244), // Rule ID 4560 //
     /*  496170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  496181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  496184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  496187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  496190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496242 */     GIR_RootConstrainSelectedInstOperands,
     /*  496243 */     // GIR_Coverage, 4560,
     /*  496243 */     GIR_EraseRootFromParent_Done,
     /*  496244 */   // Label 8291: @496244
     /*  496244 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(496323), // Rule ID 4561 //
     /*  496249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  496260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  496263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  496266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  496269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496301 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496321 */     GIR_RootConstrainSelectedInstOperands,
     /*  496322 */     // GIR_Coverage, 4561,
     /*  496322 */     GIR_EraseRootFromParent_Done,
     /*  496323 */   // Label 8292: @496323
     /*  496323 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(496402), // Rule ID 4570 //
     /*  496328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  496380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  496383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496400 */     GIR_RootConstrainSelectedInstOperands,
     /*  496401 */     // GIR_Coverage, 4570,
     /*  496401 */     GIR_EraseRootFromParent_Done,
     /*  496402 */   // Label 8293: @496402
     /*  496402 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(496481), // Rule ID 4571 //
     /*  496407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  496418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  496421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  496424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  496427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  496459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  496462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496479 */     GIR_RootConstrainSelectedInstOperands,
     /*  496480 */     // GIR_Coverage, 4571,
     /*  496480 */     GIR_EraseRootFromParent_Done,
     /*  496481 */   // Label 8294: @496481
     /*  496481 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(496560), // Rule ID 4580 //
     /*  496486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  496541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496558 */     GIR_RootConstrainSelectedInstOperands,
     /*  496559 */     // GIR_Coverage, 4580,
     /*  496559 */     GIR_EraseRootFromParent_Done,
     /*  496560 */   // Label 8295: @496560
     /*  496560 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(496639), // Rule ID 4581 //
     /*  496565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  496582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  496585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496617 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  496620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496637 */     GIR_RootConstrainSelectedInstOperands,
     /*  496638 */     // GIR_Coverage, 4581,
     /*  496638 */     GIR_EraseRootFromParent_Done,
     /*  496639 */   // Label 8296: @496639
     /*  496639 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(496718), // Rule ID 4590 //
     /*  496644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496716 */     GIR_RootConstrainSelectedInstOperands,
     /*  496717 */     // GIR_Coverage, 4590,
     /*  496717 */     GIR_EraseRootFromParent_Done,
     /*  496718 */   // Label 8297: @496718
     /*  496718 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(496797), // Rule ID 4591 //
     /*  496723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  496734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  496737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  496740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  496743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  496778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496795 */     GIR_RootConstrainSelectedInstOperands,
     /*  496796 */     // GIR_Coverage, 4591,
     /*  496796 */     GIR_EraseRootFromParent_Done,
     /*  496797 */   // Label 8298: @496797
     /*  496797 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(496876), // Rule ID 4600 //
     /*  496802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  496854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496874 */     GIR_RootConstrainSelectedInstOperands,
     /*  496875 */     // GIR_Coverage, 4600,
     /*  496875 */     GIR_EraseRootFromParent_Done,
     /*  496876 */   // Label 8299: @496876
     /*  496876 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(496955), // Rule ID 4601 //
     /*  496881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  496884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  496892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  496895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  496898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  496901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  496904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  496926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  496933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  496936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  496940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  496942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  496953 */     GIR_RootConstrainSelectedInstOperands,
     /*  496954 */     // GIR_Coverage, 4601,
     /*  496954 */     GIR_EraseRootFromParent_Done,
     /*  496955 */   // Label 8300: @496955
     /*  496955 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(497034), // Rule ID 4610 //
     /*  496960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  496963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  496968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  496971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  496974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  496977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  496980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  496983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  496991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  496995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  497012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  497015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497032 */     GIR_RootConstrainSelectedInstOperands,
     /*  497033 */     // GIR_Coverage, 4610,
     /*  497033 */     GIR_EraseRootFromParent_Done,
     /*  497034 */   // Label 8301: @497034
     /*  497034 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(497113), // Rule ID 4611 //
     /*  497039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  497042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  497047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  497050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  497053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  497056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  497059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  497091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  497094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497111 */     GIR_RootConstrainSelectedInstOperands,
     /*  497112 */     // GIR_Coverage, 4611,
     /*  497112 */     GIR_EraseRootFromParent_Done,
     /*  497113 */   // Label 8302: @497113
     /*  497113 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(497192), // Rule ID 4680 //
     /*  497118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  497129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  497132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  497135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  497138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  497173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497190 */     GIR_RootConstrainSelectedInstOperands,
     /*  497191 */     // GIR_Coverage, 4680,
     /*  497191 */     GIR_EraseRootFromParent_Done,
     /*  497192 */   // Label 8303: @497192
     /*  497192 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(497271), // Rule ID 4681 //
     /*  497197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  497208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  497211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  497214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  497217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  497252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497269 */     GIR_RootConstrainSelectedInstOperands,
     /*  497270 */     // GIR_Coverage, 4681,
     /*  497270 */     GIR_EraseRootFromParent_Done,
     /*  497271 */   // Label 8304: @497271
     /*  497271 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(497350), // Rule ID 4690 //
     /*  497276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  497287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  497290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  497296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  497331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497348 */     GIR_RootConstrainSelectedInstOperands,
     /*  497349 */     // GIR_Coverage, 4690,
     /*  497349 */     GIR_EraseRootFromParent_Done,
     /*  497350 */   // Label 8305: @497350
     /*  497350 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(497429), // Rule ID 4691 //
     /*  497355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  497366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  497369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  497372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  497375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497407 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  497410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497427 */     GIR_RootConstrainSelectedInstOperands,
     /*  497428 */     // GIR_Coverage, 4691,
     /*  497428 */     GIR_EraseRootFromParent_Done,
     /*  497429 */   // Label 8306: @497429
     /*  497429 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(497508), // Rule ID 4700 //
     /*  497434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  497454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  497489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497506 */     GIR_RootConstrainSelectedInstOperands,
     /*  497507 */     // GIR_Coverage, 4700,
     /*  497507 */     GIR_EraseRootFromParent_Done,
     /*  497508 */   // Label 8307: @497508
     /*  497508 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(497587), // Rule ID 4701 //
     /*  497513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  497524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  497527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  497530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  497533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497565 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  497568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497585 */     GIR_RootConstrainSelectedInstOperands,
     /*  497586 */     // GIR_Coverage, 4701,
     /*  497586 */     GIR_EraseRootFromParent_Done,
     /*  497587 */   // Label 8308: @497587
     /*  497587 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(497666), // Rule ID 4710 //
     /*  497592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  497612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  497647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497664 */     GIR_RootConstrainSelectedInstOperands,
     /*  497665 */     // GIR_Coverage, 4710,
     /*  497665 */     GIR_EraseRootFromParent_Done,
     /*  497666 */   // Label 8309: @497666
     /*  497666 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(497745), // Rule ID 4711 //
     /*  497671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  497688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  497691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  497714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  497726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497743 */     GIR_RootConstrainSelectedInstOperands,
     /*  497744 */     // GIR_Coverage, 4711,
     /*  497744 */     GIR_EraseRootFromParent_Done,
     /*  497745 */   // Label 8310: @497745
     /*  497745 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(497824), // Rule ID 4720 //
     /*  497750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  497770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  497805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497822 */     GIR_RootConstrainSelectedInstOperands,
     /*  497823 */     // GIR_Coverage, 4720,
     /*  497823 */     GIR_EraseRootFromParent_Done,
     /*  497824 */   // Label 8311: @497824
     /*  497824 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(497903), // Rule ID 4721 //
     /*  497829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  497846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  497849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  497852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497881 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  497881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  497884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497901 */     GIR_RootConstrainSelectedInstOperands,
     /*  497902 */     // GIR_Coverage, 4721,
     /*  497902 */     GIR_EraseRootFromParent_Done,
     /*  497903 */   // Label 8312: @497903
     /*  497903 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(497982), // Rule ID 4730 //
     /*  497908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  497925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  497928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  497931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  497939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  497943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  497953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  497960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  497963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  497967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  497969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  497980 */     GIR_RootConstrainSelectedInstOperands,
     /*  497981 */     // GIR_Coverage, 4730,
     /*  497981 */     GIR_EraseRootFromParent_Done,
     /*  497982 */   // Label 8313: @497982
     /*  497982 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(498061), // Rule ID 4731 //
     /*  497987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  497995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  498001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  498004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  498007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498039 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  498039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  498056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498059 */     GIR_RootConstrainSelectedInstOperands,
     /*  498060 */     // GIR_Coverage, 4731,
     /*  498060 */     GIR_EraseRootFromParent_Done,
     /*  498061 */   // Label 8314: @498061
     /*  498061 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(498140), // Rule ID 4740 //
     /*  498066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  498086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  498121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498138 */     GIR_RootConstrainSelectedInstOperands,
     /*  498139 */     // GIR_Coverage, 4740,
     /*  498139 */     GIR_EraseRootFromParent_Done,
     /*  498140 */   // Label 8315: @498140
     /*  498140 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(498219), // Rule ID 4741 //
     /*  498145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  498165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498197 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  498200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498217 */     GIR_RootConstrainSelectedInstOperands,
     /*  498218 */     // GIR_Coverage, 4741,
     /*  498218 */     GIR_EraseRootFromParent_Done,
     /*  498219 */   // Label 8316: @498219
     /*  498219 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(498298), // Rule ID 4750 //
     /*  498224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  498244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498296 */     GIR_RootConstrainSelectedInstOperands,
     /*  498297 */     // GIR_Coverage, 4750,
     /*  498297 */     GIR_EraseRootFromParent_Done,
     /*  498298 */   // Label 8317: @498298
     /*  498298 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(498377), // Rule ID 4751 //
     /*  498303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  498323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498375 */     GIR_RootConstrainSelectedInstOperands,
     /*  498376 */     // GIR_Coverage, 4751,
     /*  498376 */     GIR_EraseRootFromParent_Done,
     /*  498377 */   // Label 8318: @498377
     /*  498377 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(498456), // Rule ID 4760 //
     /*  498382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  498402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  498437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498454 */     GIR_RootConstrainSelectedInstOperands,
     /*  498455 */     // GIR_Coverage, 4760,
     /*  498455 */     GIR_EraseRootFromParent_Done,
     /*  498456 */   // Label 8319: @498456
     /*  498456 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(498535), // Rule ID 4761 //
     /*  498461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  498481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  498516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498533 */     GIR_RootConstrainSelectedInstOperands,
     /*  498534 */     // GIR_Coverage, 4761,
     /*  498534 */     GIR_EraseRootFromParent_Done,
     /*  498535 */   // Label 8320: @498535
     /*  498535 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(498614), // Rule ID 4770 //
     /*  498540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  498560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  498595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498612 */     GIR_RootConstrainSelectedInstOperands,
     /*  498613 */     // GIR_Coverage, 4770,
     /*  498613 */     GIR_EraseRootFromParent_Done,
     /*  498614 */   // Label 8321: @498614
     /*  498614 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(498693), // Rule ID 4771 //
     /*  498619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  498639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  498674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498691 */     GIR_RootConstrainSelectedInstOperands,
     /*  498692 */     // GIR_Coverage, 4771,
     /*  498692 */     GIR_EraseRootFromParent_Done,
     /*  498693 */   // Label 8322: @498693
     /*  498693 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(498772), // Rule ID 4780 //
     /*  498698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  498718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  498750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498770 */     GIR_RootConstrainSelectedInstOperands,
     /*  498771 */     // GIR_Coverage, 4780,
     /*  498771 */     GIR_EraseRootFromParent_Done,
     /*  498772 */   // Label 8323: @498772
     /*  498772 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(498851), // Rule ID 4781 //
     /*  498777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  498797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498829 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  498829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  498832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  498846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498849 */     GIR_RootConstrainSelectedInstOperands,
     /*  498850 */     // GIR_Coverage, 4781,
     /*  498850 */     GIR_EraseRootFromParent_Done,
     /*  498851 */   // Label 8324: @498851
     /*  498851 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(498930), // Rule ID 4790 //
     /*  498856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  498859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  498876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  498879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  498908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  498928 */     GIR_RootConstrainSelectedInstOperands,
     /*  498929 */     // GIR_Coverage, 4790,
     /*  498929 */     GIR_EraseRootFromParent_Done,
     /*  498930 */   // Label 8325: @498930
     /*  498930 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(499009), // Rule ID 4791 //
     /*  498935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  498938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  498943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  498946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  498949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  498952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  498955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  498958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  498966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  498970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  498980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498987 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  498987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  498990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  498994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  498996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499007 */     GIR_RootConstrainSelectedInstOperands,
     /*  499008 */     // GIR_Coverage, 4791,
     /*  499008 */     GIR_EraseRootFromParent_Done,
     /*  499009 */   // Label 8326: @499009
     /*  499009 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(499088), // Rule ID 4800 //
     /*  499014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  499025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  499028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  499031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  499034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  499069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499086 */     GIR_RootConstrainSelectedInstOperands,
     /*  499087 */     // GIR_Coverage, 4800,
     /*  499087 */     GIR_EraseRootFromParent_Done,
     /*  499088 */   // Label 8327: @499088
     /*  499088 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(499167), // Rule ID 4801 //
     /*  499093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  499104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  499107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  499110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  499113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  499148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499165 */     GIR_RootConstrainSelectedInstOperands,
     /*  499166 */     // GIR_Coverage, 4801,
     /*  499166 */     GIR_EraseRootFromParent_Done,
     /*  499167 */   // Label 8328: @499167
     /*  499167 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(499246), // Rule ID 4810 //
     /*  499172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  499183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  499186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  499189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  499192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  499227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499244 */     GIR_RootConstrainSelectedInstOperands,
     /*  499245 */     // GIR_Coverage, 4810,
     /*  499245 */     GIR_EraseRootFromParent_Done,
     /*  499246 */   // Label 8329: @499246
     /*  499246 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(499325), // Rule ID 4811 //
     /*  499251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  499262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  499265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  499268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  499271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499303 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  499306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499323 */     GIR_RootConstrainSelectedInstOperands,
     /*  499324 */     // GIR_Coverage, 4811,
     /*  499324 */     GIR_EraseRootFromParent_Done,
     /*  499325 */   // Label 8330: @499325
     /*  499325 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(499404), // Rule ID 4820 //
     /*  499330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  499333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  499347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  499350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  499353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  499382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  499385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499402 */     GIR_RootConstrainSelectedInstOperands,
     /*  499403 */     // GIR_Coverage, 4820,
     /*  499403 */     GIR_EraseRootFromParent_Done,
     /*  499404 */   // Label 8331: @499404
     /*  499404 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(499483), // Rule ID 4821 //
     /*  499409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  499412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  499417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  499420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  499423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  499426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  499429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  499432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  499440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  499444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  499454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  499461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  499464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  499468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  499470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  499481 */     GIR_RootConstrainSelectedInstOperands,
     /*  499482 */     // GIR_Coverage, 4821,
     /*  499482 */     GIR_EraseRootFromParent_Done,
     /*  499483 */   // Label 8332: @499483
     /*  499483 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(499551), // Rule ID 2704 //
     /*  499488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  499499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  499502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499520 */     // MIs[0] policy
     /*  499520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  499533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499537 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499549 */     GIR_RootConstrainSelectedInstOperands,
     /*  499550 */     // GIR_Coverage, 2704,
     /*  499550 */     GIR_EraseRootFromParent_Done,
     /*  499551 */   // Label 8333: @499551
     /*  499551 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(499619), // Rule ID 2705 //
     /*  499556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  499567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  499570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499588 */     // MIs[0] policy
     /*  499588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  499601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499605 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499617 */     GIR_RootConstrainSelectedInstOperands,
     /*  499618 */     // GIR_Coverage, 2705,
     /*  499618 */     GIR_EraseRootFromParent_Done,
     /*  499619 */   // Label 8334: @499619
     /*  499619 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(499687), // Rule ID 23500 //
     /*  499624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  499635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  499638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  499641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499656 */     // MIs[0] policy
     /*  499656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499673 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499685 */     GIR_RootConstrainSelectedInstOperands,
     /*  499686 */     // GIR_Coverage, 23500,
     /*  499686 */     GIR_EraseRootFromParent_Done,
     /*  499687 */   // Label 8335: @499687
     /*  499687 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(499755), // Rule ID 23501 //
     /*  499692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  499703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  499706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  499709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499724 */     // MIs[0] policy
     /*  499724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499741 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499753 */     GIR_RootConstrainSelectedInstOperands,
     /*  499754 */     // GIR_Coverage, 23501,
     /*  499754 */     GIR_EraseRootFromParent_Done,
     /*  499755 */   // Label 8336: @499755
     /*  499755 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(499823), // Rule ID 23504 //
     /*  499760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  499771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  499774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  499777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499792 */     // MIs[0] policy
     /*  499792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  499805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499809 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499821 */     GIR_RootConstrainSelectedInstOperands,
     /*  499822 */     // GIR_Coverage, 23504,
     /*  499822 */     GIR_EraseRootFromParent_Done,
     /*  499823 */   // Label 8337: @499823
     /*  499823 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(499891), // Rule ID 23505 //
     /*  499828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  499839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  499842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  499845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499860 */     // MIs[0] policy
     /*  499860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499870 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  499873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499877 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  499887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499889 */     GIR_RootConstrainSelectedInstOperands,
     /*  499890 */     // GIR_Coverage, 23505,
     /*  499890 */     GIR_EraseRootFromParent_Done,
     /*  499891 */   // Label 8338: @499891
     /*  499891 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(499959), // Rule ID 23508 //
     /*  499896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  499899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499928 */     // MIs[0] policy
     /*  499928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  499941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  499943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  499945 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  499947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  499955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499957 */     GIR_RootConstrainSelectedInstOperands,
     /*  499958 */     // GIR_Coverage, 23508,
     /*  499958 */     GIR_EraseRootFromParent_Done,
     /*  499959 */   // Label 8339: @499959
     /*  499959 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(500027), // Rule ID 23509 //
     /*  499964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  499967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  499972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  499975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  499978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  499981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  499988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  499996 */     // MIs[0] policy
     /*  499996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  500009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500013 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500025 */     GIR_RootConstrainSelectedInstOperands,
     /*  500026 */     // GIR_Coverage, 23509,
     /*  500026 */     GIR_EraseRootFromParent_Done,
     /*  500027 */   // Label 8340: @500027
     /*  500027 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(500095), // Rule ID 23512 //
     /*  500032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  500043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  500046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500064 */     // MIs[0] policy
     /*  500064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500081 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500093 */     GIR_RootConstrainSelectedInstOperands,
     /*  500094 */     // GIR_Coverage, 23512,
     /*  500094 */     GIR_EraseRootFromParent_Done,
     /*  500095 */   // Label 8341: @500095
     /*  500095 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(500163), // Rule ID 23513 //
     /*  500100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  500111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  500114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500132 */     // MIs[0] policy
     /*  500132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500149 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500161 */     GIR_RootConstrainSelectedInstOperands,
     /*  500162 */     // GIR_Coverage, 23513,
     /*  500162 */     GIR_EraseRootFromParent_Done,
     /*  500163 */   // Label 8342: @500163
     /*  500163 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(500231), // Rule ID 23516 //
     /*  500168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500200 */     // MIs[0] policy
     /*  500200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500217 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500229 */     GIR_RootConstrainSelectedInstOperands,
     /*  500230 */     // GIR_Coverage, 23516,
     /*  500230 */     GIR_EraseRootFromParent_Done,
     /*  500231 */   // Label 8343: @500231
     /*  500231 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(500299), // Rule ID 23517 //
     /*  500236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  500247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  500250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500268 */     // MIs[0] policy
     /*  500268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  500281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500285 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500297 */     GIR_RootConstrainSelectedInstOperands,
     /*  500298 */     // GIR_Coverage, 23517,
     /*  500298 */     GIR_EraseRootFromParent_Done,
     /*  500299 */   // Label 8344: @500299
     /*  500299 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(500367), // Rule ID 23520 //
     /*  500304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  500315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  500318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  500321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500336 */     // MIs[0] policy
     /*  500336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500353 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500365 */     GIR_RootConstrainSelectedInstOperands,
     /*  500366 */     // GIR_Coverage, 23520,
     /*  500366 */     GIR_EraseRootFromParent_Done,
     /*  500367 */   // Label 8345: @500367
     /*  500367 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(500435), // Rule ID 23521 //
     /*  500372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  500383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  500386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  500389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500404 */     // MIs[0] policy
     /*  500404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11261:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500421 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500433 */     GIR_RootConstrainSelectedInstOperands,
     /*  500434 */     // GIR_Coverage, 23521,
     /*  500434 */     GIR_EraseRootFromParent_Done,
     /*  500435 */   // Label 8346: @500435
     /*  500435 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(500503), // Rule ID 23524 //
     /*  500440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  500451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  500454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  500457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500472 */     // MIs[0] policy
     /*  500472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500489 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500501 */     GIR_RootConstrainSelectedInstOperands,
     /*  500502 */     // GIR_Coverage, 23524,
     /*  500502 */     GIR_EraseRootFromParent_Done,
     /*  500503 */   // Label 8347: @500503
     /*  500503 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(500571), // Rule ID 23525 //
     /*  500508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  500519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  500522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  500525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500540 */     // MIs[0] policy
     /*  500540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500557 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  500567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500569 */     GIR_RootConstrainSelectedInstOperands,
     /*  500570 */     // GIR_Coverage, 23525,
     /*  500570 */     GIR_EraseRootFromParent_Done,
     /*  500571 */   // Label 8348: @500571
     /*  500571 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(500639), // Rule ID 23528 //
     /*  500576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500608 */     // MIs[0] policy
     /*  500608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500625 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500637 */     GIR_RootConstrainSelectedInstOperands,
     /*  500638 */     // GIR_Coverage, 23528,
     /*  500638 */     GIR_EraseRootFromParent_Done,
     /*  500639 */   // Label 8349: @500639
     /*  500639 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(500707), // Rule ID 23529 //
     /*  500644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  500661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500676 */     // MIs[0] policy
     /*  500676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500686 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500693 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500705 */     GIR_RootConstrainSelectedInstOperands,
     /*  500706 */     // GIR_Coverage, 23529,
     /*  500706 */     GIR_EraseRootFromParent_Done,
     /*  500707 */   // Label 8350: @500707
     /*  500707 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(500775), // Rule ID 23532 //
     /*  500712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  500715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500744 */     // MIs[0] policy
     /*  500744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500761 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  500771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500773 */     GIR_RootConstrainSelectedInstOperands,
     /*  500774 */     // GIR_Coverage, 23532,
     /*  500774 */     GIR_EraseRootFromParent_Done,
     /*  500775 */   // Label 8351: @500775
     /*  500775 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(500843), // Rule ID 23533 //
     /*  500780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  500783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  500791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  500794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  500797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  500804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500812 */     // MIs[0] policy
     /*  500812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  500825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500829 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  500839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500841 */     GIR_RootConstrainSelectedInstOperands,
     /*  500842 */     // GIR_Coverage, 23533,
     /*  500842 */     GIR_EraseRootFromParent_Done,
     /*  500843 */   // Label 8352: @500843
     /*  500843 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(500911), // Rule ID 23536 //
     /*  500848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  500859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  500862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  500865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  500872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500880 */     // MIs[0] policy
     /*  500880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500890 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  500893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500897 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500909 */     GIR_RootConstrainSelectedInstOperands,
     /*  500910 */     // GIR_Coverage, 23536,
     /*  500910 */     GIR_EraseRootFromParent_Done,
     /*  500911 */   // Label 8353: @500911
     /*  500911 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(500979), // Rule ID 23537 //
     /*  500916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  500919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  500927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  500930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  500933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  500940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  500948 */     // MIs[0] policy
     /*  500948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  500961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  500963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  500965 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  500967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  500975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500977 */     GIR_RootConstrainSelectedInstOperands,
     /*  500978 */     // GIR_Coverage, 23537,
     /*  500978 */     GIR_EraseRootFromParent_Done,
     /*  500979 */   // Label 8354: @500979
     /*  500979 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(501047), // Rule ID 23540 //
     /*  500984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  500987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  500992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  500995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  500998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501016 */     // MIs[0] policy
     /*  501016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501033 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501045 */     GIR_RootConstrainSelectedInstOperands,
     /*  501046 */     // GIR_Coverage, 23540,
     /*  501046 */     GIR_EraseRootFromParent_Done,
     /*  501047 */   // Label 8355: @501047
     /*  501047 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(501115), // Rule ID 23541 //
     /*  501052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  501063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  501066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501084 */     // MIs[0] policy
     /*  501084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501101 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501113 */     GIR_RootConstrainSelectedInstOperands,
     /*  501114 */     // GIR_Coverage, 23541,
     /*  501114 */     GIR_EraseRootFromParent_Done,
     /*  501115 */   // Label 8356: @501115
     /*  501115 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(501183), // Rule ID 23544 //
     /*  501120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  501131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  501134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  501137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501152 */     // MIs[0] policy
     /*  501152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501169 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501181 */     GIR_RootConstrainSelectedInstOperands,
     /*  501182 */     // GIR_Coverage, 23544,
     /*  501182 */     GIR_EraseRootFromParent_Done,
     /*  501183 */   // Label 8357: @501183
     /*  501183 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(501251), // Rule ID 23545 //
     /*  501188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  501199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  501202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  501205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501220 */     // MIs[0] policy
     /*  501220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501237 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  501247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501249 */     GIR_RootConstrainSelectedInstOperands,
     /*  501250 */     // GIR_Coverage, 23545,
     /*  501250 */     GIR_EraseRootFromParent_Done,
     /*  501251 */   // Label 8358: @501251
     /*  501251 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(501319), // Rule ID 23548 //
     /*  501256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501288 */     // MIs[0] policy
     /*  501288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501305 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501317 */     GIR_RootConstrainSelectedInstOperands,
     /*  501318 */     // GIR_Coverage, 23548,
     /*  501318 */     GIR_EraseRootFromParent_Done,
     /*  501319 */   // Label 8359: @501319
     /*  501319 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(501387), // Rule ID 23549 //
     /*  501324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  501335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  501338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501356 */     // MIs[0] policy
     /*  501356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501373 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501385 */     GIR_RootConstrainSelectedInstOperands,
     /*  501386 */     // GIR_Coverage, 23549,
     /*  501386 */     GIR_EraseRootFromParent_Done,
     /*  501387 */   // Label 8360: @501387
     /*  501387 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(501455), // Rule ID 23552 //
     /*  501392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  501403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  501406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501424 */     // MIs[0] policy
     /*  501424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501441 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501453 */     GIR_RootConstrainSelectedInstOperands,
     /*  501454 */     // GIR_Coverage, 23552,
     /*  501454 */     GIR_EraseRootFromParent_Done,
     /*  501455 */   // Label 8361: @501455
     /*  501455 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(501523), // Rule ID 23553 //
     /*  501460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  501471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  501474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501492 */     // MIs[0] policy
     /*  501492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501509 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501521 */     GIR_RootConstrainSelectedInstOperands,
     /*  501522 */     // GIR_Coverage, 23553,
     /*  501522 */     GIR_EraseRootFromParent_Done,
     /*  501523 */   // Label 8362: @501523
     /*  501523 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(501591), // Rule ID 23556 //
     /*  501528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  501539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  501542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501560 */     // MIs[0] policy
     /*  501560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501577 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501589 */     GIR_RootConstrainSelectedInstOperands,
     /*  501590 */     // GIR_Coverage, 23556,
     /*  501590 */     GIR_EraseRootFromParent_Done,
     /*  501591 */   // Label 8363: @501591
     /*  501591 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(501659), // Rule ID 23557 //
     /*  501596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  501607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  501610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  501613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501628 */     // MIs[0] policy
     /*  501628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501645 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  501655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501657 */     GIR_RootConstrainSelectedInstOperands,
     /*  501658 */     // GIR_Coverage, 23557,
     /*  501658 */     GIR_EraseRootFromParent_Done,
     /*  501659 */   // Label 8364: @501659
     /*  501659 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(501727), // Rule ID 23560 //
     /*  501664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  501681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501696 */     // MIs[0] policy
     /*  501696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501713 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501725 */     GIR_RootConstrainSelectedInstOperands,
     /*  501726 */     // GIR_Coverage, 23560,
     /*  501726 */     GIR_EraseRootFromParent_Done,
     /*  501727 */   // Label 8365: @501727
     /*  501727 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(501795), // Rule ID 23561 //
     /*  501732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  501749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  501756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501764 */     // MIs[0] policy
     /*  501764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  501777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501781 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501793 */     GIR_RootConstrainSelectedInstOperands,
     /*  501794 */     // GIR_Coverage, 23561,
     /*  501794 */     GIR_EraseRootFromParent_Done,
     /*  501795 */   // Label 8366: @501795
     /*  501795 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(501863), // Rule ID 23564 //
     /*  501800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501832 */     // MIs[0] policy
     /*  501832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501849 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501861 */     GIR_RootConstrainSelectedInstOperands,
     /*  501862 */     // GIR_Coverage, 23564,
     /*  501862 */     GIR_EraseRootFromParent_Done,
     /*  501863 */   // Label 8367: @501863
     /*  501863 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(501931), // Rule ID 23565 //
     /*  501868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  501871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  501885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  501892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501900 */     // MIs[0] policy
     /*  501900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  501913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501917 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501929 */     GIR_RootConstrainSelectedInstOperands,
     /*  501930 */     // GIR_Coverage, 23565,
     /*  501930 */     GIR_EraseRootFromParent_Done,
     /*  501931 */   // Label 8368: @501931
     /*  501931 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(501999), // Rule ID 23568 //
     /*  501936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  501939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  501944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  501953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  501960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  501968 */     // MIs[0] policy
     /*  501968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  501981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  501983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  501985 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  501987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501997 */     GIR_RootConstrainSelectedInstOperands,
     /*  501998 */     // GIR_Coverage, 23568,
     /*  501998 */     GIR_EraseRootFromParent_Done,
     /*  501999 */   // Label 8369: @501999
     /*  501999 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(502067), // Rule ID 23569 //
     /*  502004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  502007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  502021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502036 */     // MIs[0] policy
     /*  502036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502053 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502065 */     GIR_RootConstrainSelectedInstOperands,
     /*  502066 */     // GIR_Coverage, 23569,
     /*  502066 */     GIR_EraseRootFromParent_Done,
     /*  502067 */   // Label 8370: @502067
     /*  502067 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(502135), // Rule ID 23572 //
     /*  502072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  502083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  502086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  502089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  502096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502104 */     // MIs[0] policy
     /*  502104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  502117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502121 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502133 */     GIR_RootConstrainSelectedInstOperands,
     /*  502134 */     // GIR_Coverage, 23572,
     /*  502134 */     GIR_EraseRootFromParent_Done,
     /*  502135 */   // Label 8371: @502135
     /*  502135 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(502203), // Rule ID 23573 //
     /*  502140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  502151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  502154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  502157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  502164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502172 */     // MIs[0] policy
     /*  502172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  502185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502189 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502199 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502201 */     GIR_RootConstrainSelectedInstOperands,
     /*  502202 */     // GIR_Coverage, 23573,
     /*  502202 */     GIR_EraseRootFromParent_Done,
     /*  502203 */   // Label 8372: @502203
     /*  502203 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(502271), // Rule ID 23576 //
     /*  502208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  502219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  502222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  502225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  502232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502240 */     // MIs[0] policy
     /*  502240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  502253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502257 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502267 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502269 */     GIR_RootConstrainSelectedInstOperands,
     /*  502270 */     // GIR_Coverage, 23576,
     /*  502270 */     GIR_EraseRootFromParent_Done,
     /*  502271 */   // Label 8373: @502271
     /*  502271 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(502339), // Rule ID 23577 //
     /*  502276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  502287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  502290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  502293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  502300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502308 */     // MIs[0] policy
     /*  502308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  502321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502325 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502335 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502337 */     GIR_RootConstrainSelectedInstOperands,
     /*  502338 */     // GIR_Coverage, 23577,
     /*  502338 */     GIR_EraseRootFromParent_Done,
     /*  502339 */   // Label 8374: @502339
     /*  502339 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(502407), // Rule ID 23580 //
     /*  502344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  502347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  502355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  502358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  502361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502376 */     // MIs[0] policy
     /*  502376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502393 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502403 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502405 */     GIR_RootConstrainSelectedInstOperands,
     /*  502406 */     // GIR_Coverage, 23580,
     /*  502406 */     GIR_EraseRootFromParent_Done,
     /*  502407 */   // Label 8375: @502407
     /*  502407 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(502475), // Rule ID 23581 //
     /*  502412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  502415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  502420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  502423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  502426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  502429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  502436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  502444 */     // MIs[0] policy
     /*  502444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  502457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  502459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  502461 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  502463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  502471 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502473 */     GIR_RootConstrainSelectedInstOperands,
     /*  502474 */     // GIR_Coverage, 23581,
     /*  502474 */     GIR_EraseRootFromParent_Done,
     /*  502475 */   // Label 8376: @502475
     /*  502475 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(502543), // Rule ID 60594 //
     /*  502480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502512 */     // MIs[0] policy
     /*  502512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  502525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502539 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502541 */     GIR_RootConstrainSelectedInstOperands,
     /*  502542 */     // GIR_Coverage, 60594,
     /*  502542 */     GIR_EraseRootFromParent_Done,
     /*  502543 */   // Label 8377: @502543
     /*  502543 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(502611), // Rule ID 60595 //
     /*  502548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502580 */     // MIs[0] policy
     /*  502580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  502593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502607 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502609 */     GIR_RootConstrainSelectedInstOperands,
     /*  502610 */     // GIR_Coverage, 60595,
     /*  502610 */     GIR_EraseRootFromParent_Done,
     /*  502611 */   // Label 8378: @502611
     /*  502611 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(502679), // Rule ID 60596 //
     /*  502616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502648 */     // MIs[0] policy
     /*  502648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  502661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502675 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502677 */     GIR_RootConstrainSelectedInstOperands,
     /*  502678 */     // GIR_Coverage, 60596,
     /*  502678 */     GIR_EraseRootFromParent_Done,
     /*  502679 */   // Label 8379: @502679
     /*  502679 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(502747), // Rule ID 60597 //
     /*  502684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  502692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502716 */     // MIs[0] policy
     /*  502716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  502729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502743 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502745 */     GIR_RootConstrainSelectedInstOperands,
     /*  502746 */     // GIR_Coverage, 60597,
     /*  502746 */     GIR_EraseRootFromParent_Done,
     /*  502747 */   // Label 8380: @502747
     /*  502747 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(502815), // Rule ID 62090 //
     /*  502752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502784 */     // MIs[0] policy
     /*  502784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  502797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502811 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502813 */     GIR_RootConstrainSelectedInstOperands,
     /*  502814 */     // GIR_Coverage, 62090,
     /*  502814 */     GIR_EraseRootFromParent_Done,
     /*  502815 */   // Label 8381: @502815
     /*  502815 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(502883), // Rule ID 62091 //
     /*  502820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502852 */     // MIs[0] policy
     /*  502852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502862 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  502865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502879 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502881 */     GIR_RootConstrainSelectedInstOperands,
     /*  502882 */     // GIR_Coverage, 62091,
     /*  502882 */     GIR_EraseRootFromParent_Done,
     /*  502883 */   // Label 8382: @502883
     /*  502883 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(502951), // Rule ID 62092 //
     /*  502888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  502891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502920 */     // MIs[0] policy
     /*  502920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  502933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502947 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502949 */     GIR_RootConstrainSelectedInstOperands,
     /*  502950 */     // GIR_Coverage, 62092,
     /*  502950 */     GIR_EraseRootFromParent_Done,
     /*  502951 */   // Label 8383: @502951
     /*  502951 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(503019), // Rule ID 62093 //
     /*  502956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  502959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  502964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502988 */     // MIs[0] policy
     /*  502988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11259:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  503001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503015 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503017 */     GIR_RootConstrainSelectedInstOperands,
     /*  503018 */     // GIR_Coverage, 62093,
     /*  503018 */     GIR_EraseRootFromParent_Done,
     /*  503019 */   // Label 8384: @503019
     /*  503019 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(503087), // Rule ID 62094 //
     /*  503024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  503027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503056 */     // MIs[0] policy
     /*  503056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  503069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503083 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503085 */     GIR_RootConstrainSelectedInstOperands,
     /*  503086 */     // GIR_Coverage, 62094,
     /*  503086 */     GIR_EraseRootFromParent_Done,
     /*  503087 */   // Label 8385: @503087
     /*  503087 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(503155), // Rule ID 62095 //
     /*  503092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  503095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503124 */     // MIs[0] policy
     /*  503124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11259:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  503137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503151 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503153 */     GIR_RootConstrainSelectedInstOperands,
     /*  503154 */     // GIR_Coverage, 62095,
     /*  503154 */     GIR_EraseRootFromParent_Done,
     /*  503155 */   // Label 8386: @503155
     /*  503155 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(503223), // Rule ID 62096 //
     /*  503160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  503163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503192 */     // MIs[0] policy
     /*  503192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  503205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503219 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503221 */     GIR_RootConstrainSelectedInstOperands,
     /*  503222 */     // GIR_Coverage, 62096,
     /*  503222 */     GIR_EraseRootFromParent_Done,
     /*  503223 */   // Label 8387: @503223
     /*  503223 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(503291), // Rule ID 62097 //
     /*  503228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  503231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  503236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503260 */     // MIs[0] policy
     /*  503260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503270 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11259:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  503273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503287 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503289 */     GIR_RootConstrainSelectedInstOperands,
     /*  503290 */     // GIR_Coverage, 62097,
     /*  503290 */     GIR_EraseRootFromParent_Done,
     /*  503291 */   // Label 8388: @503291
     /*  503291 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(503359), // Rule ID 62098 //
     /*  503296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503328 */     // MIs[0] policy
     /*  503328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  503341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503355 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503357 */     GIR_RootConstrainSelectedInstOperands,
     /*  503358 */     // GIR_Coverage, 62098,
     /*  503358 */     GIR_EraseRootFromParent_Done,
     /*  503359 */   // Label 8389: @503359
     /*  503359 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(503427), // Rule ID 62099 //
     /*  503364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503396 */     // MIs[0] policy
     /*  503396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  503409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503423 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503425 */     GIR_RootConstrainSelectedInstOperands,
     /*  503426 */     // GIR_Coverage, 62099,
     /*  503426 */     GIR_EraseRootFromParent_Done,
     /*  503427 */   // Label 8390: @503427
     /*  503427 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(503495), // Rule ID 62100 //
     /*  503432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503464 */     // MIs[0] policy
     /*  503464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  503477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503491 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503493 */     GIR_RootConstrainSelectedInstOperands,
     /*  503494 */     // GIR_Coverage, 62100,
     /*  503494 */     GIR_EraseRootFromParent_Done,
     /*  503495 */   // Label 8391: @503495
     /*  503495 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(503563), // Rule ID 62101 //
     /*  503500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503532 */     // MIs[0] policy
     /*  503532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  503545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503559 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503561 */     GIR_RootConstrainSelectedInstOperands,
     /*  503562 */     // GIR_Coverage, 62101,
     /*  503562 */     GIR_EraseRootFromParent_Done,
     /*  503563 */   // Label 8392: @503563
     /*  503563 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(503631), // Rule ID 62102 //
     /*  503568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503600 */     // MIs[0] policy
     /*  503600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  503613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503627 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503629 */     GIR_RootConstrainSelectedInstOperands,
     /*  503630 */     // GIR_Coverage, 62102,
     /*  503630 */     GIR_EraseRootFromParent_Done,
     /*  503631 */   // Label 8393: @503631
     /*  503631 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(503699), // Rule ID 62103 //
     /*  503636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503668 */     // MIs[0] policy
     /*  503668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  503681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503695 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503697 */     GIR_RootConstrainSelectedInstOperands,
     /*  503698 */     // GIR_Coverage, 62103,
     /*  503698 */     GIR_EraseRootFromParent_Done,
     /*  503699 */   // Label 8394: @503699
     /*  503699 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(503767), // Rule ID 62104 //
     /*  503704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503736 */     // MIs[0] policy
     /*  503736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  503749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503763 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503765 */     GIR_RootConstrainSelectedInstOperands,
     /*  503766 */     // GIR_Coverage, 62104,
     /*  503766 */     GIR_EraseRootFromParent_Done,
     /*  503767 */   // Label 8395: @503767
     /*  503767 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(503835), // Rule ID 62105 //
     /*  503772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503804 */     // MIs[0] policy
     /*  503804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  503817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503831 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503833 */     GIR_RootConstrainSelectedInstOperands,
     /*  503834 */     // GIR_Coverage, 62105,
     /*  503834 */     GIR_EraseRootFromParent_Done,
     /*  503835 */   // Label 8396: @503835
     /*  503835 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(503903), // Rule ID 62106 //
     /*  503840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503872 */     // MIs[0] policy
     /*  503872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  503885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503899 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503901 */     GIR_RootConstrainSelectedInstOperands,
     /*  503902 */     // GIR_Coverage, 62106,
     /*  503902 */     GIR_EraseRootFromParent_Done,
     /*  503903 */   // Label 8397: @503903
     /*  503903 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(503971), // Rule ID 62107 //
     /*  503908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  503916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  503925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503940 */     // MIs[0] policy
     /*  503940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  503953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503967 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503969 */     GIR_RootConstrainSelectedInstOperands,
     /*  503970 */     // GIR_Coverage, 62107,
     /*  503970 */     GIR_EraseRootFromParent_Done,
     /*  503971 */   // Label 8398: @503971
     /*  503971 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(504039), // Rule ID 62108 //
     /*  503976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  503984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  503987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  503990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504008 */     // MIs[0] policy
     /*  504008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  504021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504035 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504037 */     GIR_RootConstrainSelectedInstOperands,
     /*  504038 */     // GIR_Coverage, 62108,
     /*  504038 */     GIR_EraseRootFromParent_Done,
     /*  504039 */   // Label 8399: @504039
     /*  504039 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(504107), // Rule ID 62109 //
     /*  504044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504076 */     // MIs[0] policy
     /*  504076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  504089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504103 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504105 */     GIR_RootConstrainSelectedInstOperands,
     /*  504106 */     // GIR_Coverage, 62109,
     /*  504106 */     GIR_EraseRootFromParent_Done,
     /*  504107 */   // Label 8400: @504107
     /*  504107 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(504175), // Rule ID 62110 //
     /*  504112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504144 */     // MIs[0] policy
     /*  504144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  504157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504171 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504173 */     GIR_RootConstrainSelectedInstOperands,
     /*  504174 */     // GIR_Coverage, 62110,
     /*  504174 */     GIR_EraseRootFromParent_Done,
     /*  504175 */   // Label 8401: @504175
     /*  504175 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(504243), // Rule ID 62111 //
     /*  504180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504212 */     // MIs[0] policy
     /*  504212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  504225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504239 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504241 */     GIR_RootConstrainSelectedInstOperands,
     /*  504242 */     // GIR_Coverage, 62111,
     /*  504242 */     GIR_EraseRootFromParent_Done,
     /*  504243 */   // Label 8402: @504243
     /*  504243 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(504311), // Rule ID 62112 //
     /*  504248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504280 */     // MIs[0] policy
     /*  504280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  504293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504307 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504309 */     GIR_RootConstrainSelectedInstOperands,
     /*  504310 */     // GIR_Coverage, 62112,
     /*  504310 */     GIR_EraseRootFromParent_Done,
     /*  504311 */   // Label 8403: @504311
     /*  504311 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(504379), // Rule ID 62113 //
     /*  504316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504348 */     // MIs[0] policy
     /*  504348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  504361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504375 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504377 */     GIR_RootConstrainSelectedInstOperands,
     /*  504378 */     // GIR_Coverage, 62113,
     /*  504378 */     GIR_EraseRootFromParent_Done,
     /*  504379 */   // Label 8404: @504379
     /*  504379 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(504447), // Rule ID 62114 //
     /*  504384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504416 */     // MIs[0] policy
     /*  504416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  504429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504443 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504445 */     GIR_RootConstrainSelectedInstOperands,
     /*  504446 */     // GIR_Coverage, 62114,
     /*  504446 */     GIR_EraseRootFromParent_Done,
     /*  504447 */   // Label 8405: @504447
     /*  504447 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(504515), // Rule ID 62115 //
     /*  504452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504484 */     // MIs[0] policy
     /*  504484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  504497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504511 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504513 */     GIR_RootConstrainSelectedInstOperands,
     /*  504514 */     // GIR_Coverage, 62115,
     /*  504514 */     GIR_EraseRootFromParent_Done,
     /*  504515 */   // Label 8406: @504515
     /*  504515 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(504583), // Rule ID 62116 //
     /*  504520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504552 */     // MIs[0] policy
     /*  504552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  504565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504579 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504581 */     GIR_RootConstrainSelectedInstOperands,
     /*  504582 */     // GIR_Coverage, 62116,
     /*  504582 */     GIR_EraseRootFromParent_Done,
     /*  504583 */   // Label 8407: @504583
     /*  504583 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(504651), // Rule ID 62117 //
     /*  504588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504620 */     // MIs[0] policy
     /*  504620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  504633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504647 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504649 */     GIR_RootConstrainSelectedInstOperands,
     /*  504650 */     // GIR_Coverage, 62117,
     /*  504650 */     GIR_EraseRootFromParent_Done,
     /*  504651 */   // Label 8408: @504651
     /*  504651 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(504719), // Rule ID 62118 //
     /*  504656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504688 */     // MIs[0] policy
     /*  504688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  504701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504717 */     GIR_RootConstrainSelectedInstOperands,
     /*  504718 */     // GIR_Coverage, 62118,
     /*  504718 */     GIR_EraseRootFromParent_Done,
     /*  504719 */   // Label 8409: @504719
     /*  504719 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(504787), // Rule ID 62119 //
     /*  504724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504756 */     // MIs[0] policy
     /*  504756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  504769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504785 */     GIR_RootConstrainSelectedInstOperands,
     /*  504786 */     // GIR_Coverage, 62119,
     /*  504786 */     GIR_EraseRootFromParent_Done,
     /*  504787 */   // Label 8410: @504787
     /*  504787 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(504855), // Rule ID 62120 //
     /*  504792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504824 */     // MIs[0] policy
     /*  504824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  504837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504853 */     GIR_RootConstrainSelectedInstOperands,
     /*  504854 */     // GIR_Coverage, 62120,
     /*  504854 */     GIR_EraseRootFromParent_Done,
     /*  504855 */   // Label 8411: @504855
     /*  504855 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(504923), // Rule ID 62121 //
     /*  504860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504892 */     // MIs[0] policy
     /*  504892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  504905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504921 */     GIR_RootConstrainSelectedInstOperands,
     /*  504922 */     // GIR_Coverage, 62121,
     /*  504922 */     GIR_EraseRootFromParent_Done,
     /*  504923 */   // Label 8412: @504923
     /*  504923 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(504991), // Rule ID 62122 //
     /*  504928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  504936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504960 */     // MIs[0] policy
     /*  504960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  504973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504989 */     GIR_RootConstrainSelectedInstOperands,
     /*  504990 */     // GIR_Coverage, 62122,
     /*  504990 */     GIR_EraseRootFromParent_Done,
     /*  504991 */   // Label 8413: @504991
     /*  504991 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(505059), // Rule ID 62123 //
     /*  504996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505028 */     // MIs[0] policy
     /*  505028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  505041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505057 */     GIR_RootConstrainSelectedInstOperands,
     /*  505058 */     // GIR_Coverage, 62123,
     /*  505058 */     GIR_EraseRootFromParent_Done,
     /*  505059 */   // Label 8414: @505059
     /*  505059 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(505127), // Rule ID 62124 //
     /*  505064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505096 */     // MIs[0] policy
     /*  505096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  505109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505125 */     GIR_RootConstrainSelectedInstOperands,
     /*  505126 */     // GIR_Coverage, 62124,
     /*  505126 */     GIR_EraseRootFromParent_Done,
     /*  505127 */   // Label 8415: @505127
     /*  505127 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(505195), // Rule ID 62125 //
     /*  505132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505164 */     // MIs[0] policy
     /*  505164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  505177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505193 */     GIR_RootConstrainSelectedInstOperands,
     /*  505194 */     // GIR_Coverage, 62125,
     /*  505194 */     GIR_EraseRootFromParent_Done,
     /*  505195 */   // Label 8416: @505195
     /*  505195 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(505263), // Rule ID 62126 //
     /*  505200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505232 */     // MIs[0] policy
     /*  505232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  505245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505261 */     GIR_RootConstrainSelectedInstOperands,
     /*  505262 */     // GIR_Coverage, 62126,
     /*  505262 */     GIR_EraseRootFromParent_Done,
     /*  505263 */   // Label 8417: @505263
     /*  505263 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(505331), // Rule ID 62127 //
     /*  505268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505300 */     // MIs[0] policy
     /*  505300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  505313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505329 */     GIR_RootConstrainSelectedInstOperands,
     /*  505330 */     // GIR_Coverage, 62127,
     /*  505330 */     GIR_EraseRootFromParent_Done,
     /*  505331 */   // Label 8418: @505331
     /*  505331 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(505399), // Rule ID 62128 //
     /*  505336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505368 */     // MIs[0] policy
     /*  505368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  505381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505397 */     GIR_RootConstrainSelectedInstOperands,
     /*  505398 */     // GIR_Coverage, 62128,
     /*  505398 */     GIR_EraseRootFromParent_Done,
     /*  505399 */   // Label 8419: @505399
     /*  505399 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(505467), // Rule ID 62129 //
     /*  505404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505436 */     // MIs[0] policy
     /*  505436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  505449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505465 */     GIR_RootConstrainSelectedInstOperands,
     /*  505466 */     // GIR_Coverage, 62129,
     /*  505466 */     GIR_EraseRootFromParent_Done,
     /*  505467 */   // Label 8420: @505467
     /*  505467 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(505535), // Rule ID 62130 //
     /*  505472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505504 */     // MIs[0] policy
     /*  505504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  505517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505533 */     GIR_RootConstrainSelectedInstOperands,
     /*  505534 */     // GIR_Coverage, 62130,
     /*  505534 */     GIR_EraseRootFromParent_Done,
     /*  505535 */   // Label 8421: @505535
     /*  505535 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(505603), // Rule ID 62131 //
     /*  505540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505572 */     // MIs[0] policy
     /*  505572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  505585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505601 */     GIR_RootConstrainSelectedInstOperands,
     /*  505602 */     // GIR_Coverage, 62131,
     /*  505602 */     GIR_EraseRootFromParent_Done,
     /*  505603 */   // Label 8422: @505603
     /*  505603 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(505671), // Rule ID 62132 //
     /*  505608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505640 */     // MIs[0] policy
     /*  505640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  505653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505669 */     GIR_RootConstrainSelectedInstOperands,
     /*  505670 */     // GIR_Coverage, 62132,
     /*  505670 */     GIR_EraseRootFromParent_Done,
     /*  505671 */   // Label 8423: @505671
     /*  505671 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(505739), // Rule ID 62133 //
     /*  505676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  505684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505708 */     // MIs[0] policy
     /*  505708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  505721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505737 */     GIR_RootConstrainSelectedInstOperands,
     /*  505738 */     // GIR_Coverage, 62133,
     /*  505738 */     GIR_EraseRootFromParent_Done,
     /*  505739 */   // Label 8424: @505739
     /*  505739 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(505807), // Rule ID 62134 //
     /*  505744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505776 */     // MIs[0] policy
     /*  505776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  505789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505805 */     GIR_RootConstrainSelectedInstOperands,
     /*  505806 */     // GIR_Coverage, 62134,
     /*  505806 */     GIR_EraseRootFromParent_Done,
     /*  505807 */   // Label 8425: @505807
     /*  505807 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(505875), // Rule ID 62135 //
     /*  505812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505844 */     // MIs[0] policy
     /*  505844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  505857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505873 */     GIR_RootConstrainSelectedInstOperands,
     /*  505874 */     // GIR_Coverage, 62135,
     /*  505874 */     GIR_EraseRootFromParent_Done,
     /*  505875 */   // Label 8426: @505875
     /*  505875 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(505943), // Rule ID 62136 //
     /*  505880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505912 */     // MIs[0] policy
     /*  505912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  505925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505941 */     GIR_RootConstrainSelectedInstOperands,
     /*  505942 */     // GIR_Coverage, 62136,
     /*  505942 */     GIR_EraseRootFromParent_Done,
     /*  505943 */   // Label 8427: @505943
     /*  505943 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(506011), // Rule ID 62137 //
     /*  505948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  505956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505980 */     // MIs[0] policy
     /*  505980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  505993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506009 */     GIR_RootConstrainSelectedInstOperands,
     /*  506010 */     // GIR_Coverage, 62137,
     /*  506010 */     GIR_EraseRootFromParent_Done,
     /*  506011 */   // Label 8428: @506011
     /*  506011 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(506079), // Rule ID 62138 //
     /*  506016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506048 */     // MIs[0] policy
     /*  506048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  506061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506077 */     GIR_RootConstrainSelectedInstOperands,
     /*  506078 */     // GIR_Coverage, 62138,
     /*  506078 */     GIR_EraseRootFromParent_Done,
     /*  506079 */   // Label 8429: @506079
     /*  506079 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(506147), // Rule ID 62139 //
     /*  506084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506116 */     // MIs[0] policy
     /*  506116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  506129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506145 */     GIR_RootConstrainSelectedInstOperands,
     /*  506146 */     // GIR_Coverage, 62139,
     /*  506146 */     GIR_EraseRootFromParent_Done,
     /*  506147 */   // Label 8430: @506147
     /*  506147 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(506215), // Rule ID 62140 //
     /*  506152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506184 */     // MIs[0] policy
     /*  506184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  506197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506211 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506213 */     GIR_RootConstrainSelectedInstOperands,
     /*  506214 */     // GIR_Coverage, 62140,
     /*  506214 */     GIR_EraseRootFromParent_Done,
     /*  506215 */   // Label 8431: @506215
     /*  506215 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(506283), // Rule ID 62141 //
     /*  506220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506252 */     // MIs[0] policy
     /*  506252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  506265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506279 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506281 */     GIR_RootConstrainSelectedInstOperands,
     /*  506282 */     // GIR_Coverage, 62141,
     /*  506282 */     GIR_EraseRootFromParent_Done,
     /*  506283 */   // Label 8432: @506283
     /*  506283 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(506351), // Rule ID 62142 //
     /*  506288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  506305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506320 */     // MIs[0] policy
     /*  506320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  506333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506347 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506349 */     GIR_RootConstrainSelectedInstOperands,
     /*  506350 */     // GIR_Coverage, 62142,
     /*  506350 */     GIR_EraseRootFromParent_Done,
     /*  506351 */   // Label 8433: @506351
     /*  506351 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(506419), // Rule ID 62143 //
     /*  506356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  506364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  506373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506388 */     // MIs[0] policy
     /*  506388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  506401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506415 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506417 */     GIR_RootConstrainSelectedInstOperands,
     /*  506418 */     // GIR_Coverage, 62143,
     /*  506418 */     GIR_EraseRootFromParent_Done,
     /*  506419 */   // Label 8434: @506419
     /*  506419 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(506487), // Rule ID 62144 //
     /*  506424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506456 */     // MIs[0] policy
     /*  506456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  506469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506483 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506485 */     GIR_RootConstrainSelectedInstOperands,
     /*  506486 */     // GIR_Coverage, 62144,
     /*  506486 */     GIR_EraseRootFromParent_Done,
     /*  506487 */   // Label 8435: @506487
     /*  506487 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(506555), // Rule ID 62145 //
     /*  506492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506524 */     // MIs[0] policy
     /*  506524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  506537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506551 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506553 */     GIR_RootConstrainSelectedInstOperands,
     /*  506554 */     // GIR_Coverage, 62145,
     /*  506554 */     GIR_EraseRootFromParent_Done,
     /*  506555 */   // Label 8436: @506555
     /*  506555 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(506623), // Rule ID 62146 //
     /*  506560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506592 */     // MIs[0] policy
     /*  506592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  506605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506619 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506621 */     GIR_RootConstrainSelectedInstOperands,
     /*  506622 */     // GIR_Coverage, 62146,
     /*  506622 */     GIR_EraseRootFromParent_Done,
     /*  506623 */   // Label 8437: @506623
     /*  506623 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(506691), // Rule ID 62147 //
     /*  506628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506660 */     // MIs[0] policy
     /*  506660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  506673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506687 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506689 */     GIR_RootConstrainSelectedInstOperands,
     /*  506690 */     // GIR_Coverage, 62147,
     /*  506690 */     GIR_EraseRootFromParent_Done,
     /*  506691 */   // Label 8438: @506691
     /*  506691 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(506759), // Rule ID 62148 //
     /*  506696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506728 */     // MIs[0] policy
     /*  506728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  506741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506755 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506757 */     GIR_RootConstrainSelectedInstOperands,
     /*  506758 */     // GIR_Coverage, 62148,
     /*  506758 */     GIR_EraseRootFromParent_Done,
     /*  506759 */   // Label 8439: @506759
     /*  506759 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(506827), // Rule ID 62149 //
     /*  506764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506796 */     // MIs[0] policy
     /*  506796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  506809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506823 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506825 */     GIR_RootConstrainSelectedInstOperands,
     /*  506826 */     // GIR_Coverage, 62149,
     /*  506826 */     GIR_EraseRootFromParent_Done,
     /*  506827 */   // Label 8440: @506827
     /*  506827 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(506895), // Rule ID 62150 //
     /*  506832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506864 */     // MIs[0] policy
     /*  506864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  506877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506891 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506893 */     GIR_RootConstrainSelectedInstOperands,
     /*  506894 */     // GIR_Coverage, 62150,
     /*  506894 */     GIR_EraseRootFromParent_Done,
     /*  506895 */   // Label 8441: @506895
     /*  506895 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(506963), // Rule ID 62151 //
     /*  506900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506932 */     // MIs[0] policy
     /*  506932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  506945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506959 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506961 */     GIR_RootConstrainSelectedInstOperands,
     /*  506962 */     // GIR_Coverage, 62151,
     /*  506962 */     GIR_EraseRootFromParent_Done,
     /*  506963 */   // Label 8442: @506963
     /*  506963 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(507031), // Rule ID 62152 //
     /*  506968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  506976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507000 */     // MIs[0] policy
     /*  507000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  507013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507027 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507029 */     GIR_RootConstrainSelectedInstOperands,
     /*  507030 */     // GIR_Coverage, 62152,
     /*  507030 */     GIR_EraseRootFromParent_Done,
     /*  507031 */   // Label 8443: @507031
     /*  507031 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(507099), // Rule ID 62153 //
     /*  507036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507068 */     // MIs[0] policy
     /*  507068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  507081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507095 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507097 */     GIR_RootConstrainSelectedInstOperands,
     /*  507098 */     // GIR_Coverage, 62153,
     /*  507098 */     GIR_EraseRootFromParent_Done,
     /*  507099 */   // Label 8444: @507099
     /*  507099 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(507167), // Rule ID 62154 //
     /*  507104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507136 */     // MIs[0] policy
     /*  507136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  507149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507163 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507165 */     GIR_RootConstrainSelectedInstOperands,
     /*  507166 */     // GIR_Coverage, 62154,
     /*  507166 */     GIR_EraseRootFromParent_Done,
     /*  507167 */   // Label 8445: @507167
     /*  507167 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(507235), // Rule ID 62155 //
     /*  507172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507204 */     // MIs[0] policy
     /*  507204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  507217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507231 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507233 */     GIR_RootConstrainSelectedInstOperands,
     /*  507234 */     // GIR_Coverage, 62155,
     /*  507234 */     GIR_EraseRootFromParent_Done,
     /*  507235 */   // Label 8446: @507235
     /*  507235 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(507303), // Rule ID 62156 //
     /*  507240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507272 */     // MIs[0] policy
     /*  507272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  507285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507299 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507301 */     GIR_RootConstrainSelectedInstOperands,
     /*  507302 */     // GIR_Coverage, 62156,
     /*  507302 */     GIR_EraseRootFromParent_Done,
     /*  507303 */   // Label 8447: @507303
     /*  507303 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(507371), // Rule ID 62157 //
     /*  507308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507340 */     // MIs[0] policy
     /*  507340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  507353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507367 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507369 */     GIR_RootConstrainSelectedInstOperands,
     /*  507370 */     // GIR_Coverage, 62157,
     /*  507370 */     GIR_EraseRootFromParent_Done,
     /*  507371 */   // Label 8448: @507371
     /*  507371 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(507439), // Rule ID 62158 //
     /*  507376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507408 */     // MIs[0] policy
     /*  507408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  507421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507435 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507437 */     GIR_RootConstrainSelectedInstOperands,
     /*  507438 */     // GIR_Coverage, 62158,
     /*  507438 */     GIR_EraseRootFromParent_Done,
     /*  507439 */   // Label 8449: @507439
     /*  507439 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(507507), // Rule ID 62159 //
     /*  507444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507476 */     // MIs[0] policy
     /*  507476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  507489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507503 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507505 */     GIR_RootConstrainSelectedInstOperands,
     /*  507506 */     // GIR_Coverage, 62159,
     /*  507506 */     GIR_EraseRootFromParent_Done,
     /*  507507 */   // Label 8450: @507507
     /*  507507 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(507575), // Rule ID 62160 //
     /*  507512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507544 */     // MIs[0] policy
     /*  507544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  507557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507571 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507573 */     GIR_RootConstrainSelectedInstOperands,
     /*  507574 */     // GIR_Coverage, 62160,
     /*  507574 */     GIR_EraseRootFromParent_Done,
     /*  507575 */   // Label 8451: @507575
     /*  507575 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(507643), // Rule ID 62161 //
     /*  507580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507612 */     // MIs[0] policy
     /*  507612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507622 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  507625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507639 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507641 */     GIR_RootConstrainSelectedInstOperands,
     /*  507642 */     // GIR_Coverage, 62161,
     /*  507642 */     GIR_EraseRootFromParent_Done,
     /*  507643 */   // Label 8452: @507643
     /*  507643 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(507711), // Rule ID 62162 //
     /*  507648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507680 */     // MIs[0] policy
     /*  507680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  507693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507707 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507709 */     GIR_RootConstrainSelectedInstOperands,
     /*  507710 */     // GIR_Coverage, 62162,
     /*  507710 */     GIR_EraseRootFromParent_Done,
     /*  507711 */   // Label 8453: @507711
     /*  507711 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(507779), // Rule ID 62163 //
     /*  507716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507748 */     // MIs[0] policy
     /*  507748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  507761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507775 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507777 */     GIR_RootConstrainSelectedInstOperands,
     /*  507778 */     // GIR_Coverage, 62163,
     /*  507778 */     GIR_EraseRootFromParent_Done,
     /*  507779 */   // Label 8454: @507779
     /*  507779 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(507847), // Rule ID 62164 //
     /*  507784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507816 */     // MIs[0] policy
     /*  507816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  507829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507843 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507845 */     GIR_RootConstrainSelectedInstOperands,
     /*  507846 */     // GIR_Coverage, 62164,
     /*  507846 */     GIR_EraseRootFromParent_Done,
     /*  507847 */   // Label 8455: @507847
     /*  507847 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(507915), // Rule ID 62165 //
     /*  507852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507884 */     // MIs[0] policy
     /*  507884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507894 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  507897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507911 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507913 */     GIR_RootConstrainSelectedInstOperands,
     /*  507914 */     // GIR_Coverage, 62165,
     /*  507914 */     GIR_EraseRootFromParent_Done,
     /*  507915 */   // Label 8456: @507915
     /*  507915 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(507983), // Rule ID 62166 //
     /*  507920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507952 */     // MIs[0] policy
     /*  507952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  507965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507979 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507981 */     GIR_RootConstrainSelectedInstOperands,
     /*  507982 */     // GIR_Coverage, 62166,
     /*  507982 */     GIR_EraseRootFromParent_Done,
     /*  507983 */   // Label 8457: @507983
     /*  507983 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(508051), // Rule ID 62167 //
     /*  507988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  507996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508020 */     // MIs[0] policy
     /*  508020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  508033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508047 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508049 */     GIR_RootConstrainSelectedInstOperands,
     /*  508050 */     // GIR_Coverage, 62167,
     /*  508050 */     GIR_EraseRootFromParent_Done,
     /*  508051 */   // Label 8458: @508051
     /*  508051 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(508119), // Rule ID 62168 //
     /*  508056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508088 */     // MIs[0] policy
     /*  508088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  508101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508115 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508117 */     GIR_RootConstrainSelectedInstOperands,
     /*  508118 */     // GIR_Coverage, 62168,
     /*  508118 */     GIR_EraseRootFromParent_Done,
     /*  508119 */   // Label 8459: @508119
     /*  508119 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(508187), // Rule ID 62169 //
     /*  508124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508156 */     // MIs[0] policy
     /*  508156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  508169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508183 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508185 */     GIR_RootConstrainSelectedInstOperands,
     /*  508186 */     // GIR_Coverage, 62169,
     /*  508186 */     GIR_EraseRootFromParent_Done,
     /*  508187 */   // Label 8460: @508187
     /*  508187 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(508255), // Rule ID 62170 //
     /*  508192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508224 */     // MIs[0] policy
     /*  508224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  508237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508251 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508253 */     GIR_RootConstrainSelectedInstOperands,
     /*  508254 */     // GIR_Coverage, 62170,
     /*  508254 */     GIR_EraseRootFromParent_Done,
     /*  508255 */   // Label 8461: @508255
     /*  508255 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(508323), // Rule ID 62171 //
     /*  508260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  508268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508292 */     // MIs[0] policy
     /*  508292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  508305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508319 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508321 */     GIR_RootConstrainSelectedInstOperands,
     /*  508322 */     // GIR_Coverage, 62171,
     /*  508322 */     GIR_EraseRootFromParent_Done,
     /*  508323 */   // Label 8462: @508323
     /*  508323 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(508391), // Rule ID 62172 //
     /*  508328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508360 */     // MIs[0] policy
     /*  508360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  508373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508387 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508389 */     GIR_RootConstrainSelectedInstOperands,
     /*  508390 */     // GIR_Coverage, 62172,
     /*  508390 */     GIR_EraseRootFromParent_Done,
     /*  508391 */   // Label 8463: @508391
     /*  508391 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(508459), // Rule ID 62173 //
     /*  508396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  508407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  508410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508428 */     // MIs[0] policy
     /*  508428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  508441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508455 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508457 */     GIR_RootConstrainSelectedInstOperands,
     /*  508458 */     // GIR_Coverage, 62173,
     /*  508458 */     GIR_EraseRootFromParent_Done,
     /*  508459 */   // Label 8464: @508459
     /*  508459 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(508527), // Rule ID 62174 //
     /*  508464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508496 */     // MIs[0] policy
     /*  508496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  508509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508523 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508525 */     GIR_RootConstrainSelectedInstOperands,
     /*  508526 */     // GIR_Coverage, 62174,
     /*  508526 */     GIR_EraseRootFromParent_Done,
     /*  508527 */   // Label 8465: @508527
     /*  508527 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(508595), // Rule ID 62175 //
     /*  508532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508564 */     // MIs[0] policy
     /*  508564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  508577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508591 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508593 */     GIR_RootConstrainSelectedInstOperands,
     /*  508594 */     // GIR_Coverage, 62175,
     /*  508594 */     GIR_EraseRootFromParent_Done,
     /*  508595 */   // Label 8466: @508595
     /*  508595 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(508663), // Rule ID 62176 //
     /*  508600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508632 */     // MIs[0] policy
     /*  508632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  508645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508659 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508661 */     GIR_RootConstrainSelectedInstOperands,
     /*  508662 */     // GIR_Coverage, 62176,
     /*  508662 */     GIR_EraseRootFromParent_Done,
     /*  508663 */   // Label 8467: @508663
     /*  508663 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(508731), // Rule ID 62177 //
     /*  508668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508700 */     // MIs[0] policy
     /*  508700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  508713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508727 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508729 */     GIR_RootConstrainSelectedInstOperands,
     /*  508730 */     // GIR_Coverage, 62177,
     /*  508730 */     GIR_EraseRootFromParent_Done,
     /*  508731 */   // Label 8468: @508731
     /*  508731 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(508799), // Rule ID 62178 //
     /*  508736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508768 */     // MIs[0] policy
     /*  508768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  508781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508795 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508797 */     GIR_RootConstrainSelectedInstOperands,
     /*  508798 */     // GIR_Coverage, 62178,
     /*  508798 */     GIR_EraseRootFromParent_Done,
     /*  508799 */   // Label 8469: @508799
     /*  508799 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(508867), // Rule ID 62179 //
     /*  508804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508836 */     // MIs[0] policy
     /*  508836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  508849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508863 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508865 */     GIR_RootConstrainSelectedInstOperands,
     /*  508866 */     // GIR_Coverage, 62179,
     /*  508866 */     GIR_EraseRootFromParent_Done,
     /*  508867 */   // Label 8470: @508867
     /*  508867 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(508935), // Rule ID 62180 //
     /*  508872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508904 */     // MIs[0] policy
     /*  508904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  508917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508931 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508933 */     GIR_RootConstrainSelectedInstOperands,
     /*  508934 */     // GIR_Coverage, 62180,
     /*  508934 */     GIR_EraseRootFromParent_Done,
     /*  508935 */   // Label 8471: @508935
     /*  508935 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(509003), // Rule ID 62181 //
     /*  508940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  508948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  508957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508972 */     // MIs[0] policy
     /*  508972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  508985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508999 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509001 */     GIR_RootConstrainSelectedInstOperands,
     /*  509002 */     // GIR_Coverage, 62181,
     /*  509002 */     GIR_EraseRootFromParent_Done,
     /*  509003 */   // Label 8472: @509003
     /*  509003 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(509071), // Rule ID 62182 //
     /*  509008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509040 */     // MIs[0] policy
     /*  509040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  509053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509067 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509069 */     GIR_RootConstrainSelectedInstOperands,
     /*  509070 */     // GIR_Coverage, 62182,
     /*  509070 */     GIR_EraseRootFromParent_Done,
     /*  509071 */   // Label 8473: @509071
     /*  509071 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(509139), // Rule ID 62183 //
     /*  509076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509108 */     // MIs[0] policy
     /*  509108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  509121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509135 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509137 */     GIR_RootConstrainSelectedInstOperands,
     /*  509138 */     // GIR_Coverage, 62183,
     /*  509138 */     GIR_EraseRootFromParent_Done,
     /*  509139 */   // Label 8474: @509139
     /*  509139 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(509207), // Rule ID 62184 //
     /*  509144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509176 */     // MIs[0] policy
     /*  509176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  509189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509203 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509205 */     GIR_RootConstrainSelectedInstOperands,
     /*  509206 */     // GIR_Coverage, 62184,
     /*  509206 */     GIR_EraseRootFromParent_Done,
     /*  509207 */   // Label 8475: @509207
     /*  509207 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(509275), // Rule ID 62185 //
     /*  509212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509244 */     // MIs[0] policy
     /*  509244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509254 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  509257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509271 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509273 */     GIR_RootConstrainSelectedInstOperands,
     /*  509274 */     // GIR_Coverage, 62185,
     /*  509274 */     GIR_EraseRootFromParent_Done,
     /*  509275 */   // Label 8476: @509275
     /*  509275 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(509343), // Rule ID 62186 //
     /*  509280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509312 */     // MIs[0] policy
     /*  509312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  509325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509339 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509341 */     GIR_RootConstrainSelectedInstOperands,
     /*  509342 */     // GIR_Coverage, 62186,
     /*  509342 */     GIR_EraseRootFromParent_Done,
     /*  509343 */   // Label 8477: @509343
     /*  509343 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(509411), // Rule ID 62187 //
     /*  509348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509380 */     // MIs[0] policy
     /*  509380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  509393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509407 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509409 */     GIR_RootConstrainSelectedInstOperands,
     /*  509410 */     // GIR_Coverage, 62187,
     /*  509410 */     GIR_EraseRootFromParent_Done,
     /*  509411 */   // Label 8478: @509411
     /*  509411 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(509479), // Rule ID 62188 //
     /*  509416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509448 */     // MIs[0] policy
     /*  509448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  509461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509475 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509477 */     GIR_RootConstrainSelectedInstOperands,
     /*  509478 */     // GIR_Coverage, 62188,
     /*  509478 */     GIR_EraseRootFromParent_Done,
     /*  509479 */   // Label 8479: @509479
     /*  509479 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(509547), // Rule ID 62189 //
     /*  509484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509516 */     // MIs[0] policy
     /*  509516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  509529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509543 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509545 */     GIR_RootConstrainSelectedInstOperands,
     /*  509546 */     // GIR_Coverage, 62189,
     /*  509546 */     GIR_EraseRootFromParent_Done,
     /*  509547 */   // Label 8480: @509547
     /*  509547 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(509615), // Rule ID 62190 //
     /*  509552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509584 */     // MIs[0] policy
     /*  509584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  509597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509611 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509613 */     GIR_RootConstrainSelectedInstOperands,
     /*  509614 */     // GIR_Coverage, 62190,
     /*  509614 */     GIR_EraseRootFromParent_Done,
     /*  509615 */   // Label 8481: @509615
     /*  509615 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(509683), // Rule ID 62191 //
     /*  509620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509652 */     // MIs[0] policy
     /*  509652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  509665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509679 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509681 */     GIR_RootConstrainSelectedInstOperands,
     /*  509682 */     // GIR_Coverage, 62191,
     /*  509682 */     GIR_EraseRootFromParent_Done,
     /*  509683 */   // Label 8482: @509683
     /*  509683 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(509751), // Rule ID 62192 //
     /*  509688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509720 */     // MIs[0] policy
     /*  509720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  509733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509747 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509749 */     GIR_RootConstrainSelectedInstOperands,
     /*  509750 */     // GIR_Coverage, 62192,
     /*  509750 */     GIR_EraseRootFromParent_Done,
     /*  509751 */   // Label 8483: @509751
     /*  509751 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(509819), // Rule ID 62193 //
     /*  509756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509788 */     // MIs[0] policy
     /*  509788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  509801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509815 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509817 */     GIR_RootConstrainSelectedInstOperands,
     /*  509818 */     // GIR_Coverage, 62193,
     /*  509818 */     GIR_EraseRootFromParent_Done,
     /*  509819 */   // Label 8484: @509819
     /*  509819 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(509887), // Rule ID 62194 //
     /*  509824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509856 */     // MIs[0] policy
     /*  509856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  509869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509883 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509885 */     GIR_RootConstrainSelectedInstOperands,
     /*  509886 */     // GIR_Coverage, 62194,
     /*  509886 */     GIR_EraseRootFromParent_Done,
     /*  509887 */   // Label 8485: @509887
     /*  509887 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(509955), // Rule ID 62195 //
     /*  509892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509924 */     // MIs[0] policy
     /*  509924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  509937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509951 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509953 */     GIR_RootConstrainSelectedInstOperands,
     /*  509954 */     // GIR_Coverage, 62195,
     /*  509954 */     GIR_EraseRootFromParent_Done,
     /*  509955 */   // Label 8486: @509955
     /*  509955 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(510023), // Rule ID 62196 //
     /*  509960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  509968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509992 */     // MIs[0] policy
     /*  509992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  510005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510019 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510021 */     GIR_RootConstrainSelectedInstOperands,
     /*  510022 */     // GIR_Coverage, 62196,
     /*  510022 */     GIR_EraseRootFromParent_Done,
     /*  510023 */   // Label 8487: @510023
     /*  510023 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(510091), // Rule ID 62197 //
     /*  510028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510060 */     // MIs[0] policy
     /*  510060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  510073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510087 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510089 */     GIR_RootConstrainSelectedInstOperands,
     /*  510090 */     // GIR_Coverage, 62197,
     /*  510090 */     GIR_EraseRootFromParent_Done,
     /*  510091 */   // Label 8488: @510091
     /*  510091 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(510159), // Rule ID 62198 //
     /*  510096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510128 */     // MIs[0] policy
     /*  510128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  510141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510155 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510157 */     GIR_RootConstrainSelectedInstOperands,
     /*  510158 */     // GIR_Coverage, 62198,
     /*  510158 */     GIR_EraseRootFromParent_Done,
     /*  510159 */   // Label 8489: @510159
     /*  510159 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(510227), // Rule ID 62199 //
     /*  510164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510196 */     // MIs[0] policy
     /*  510196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  510209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510223 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510225 */     GIR_RootConstrainSelectedInstOperands,
     /*  510226 */     // GIR_Coverage, 62199,
     /*  510226 */     GIR_EraseRootFromParent_Done,
     /*  510227 */   // Label 8490: @510227
     /*  510227 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(510295), // Rule ID 62200 //
     /*  510232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510264 */     // MIs[0] policy
     /*  510264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  510277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510291 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510293 */     GIR_RootConstrainSelectedInstOperands,
     /*  510294 */     // GIR_Coverage, 62200,
     /*  510294 */     GIR_EraseRootFromParent_Done,
     /*  510295 */   // Label 8491: @510295
     /*  510295 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(510363), // Rule ID 62201 //
     /*  510300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510332 */     // MIs[0] policy
     /*  510332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  510345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510359 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510361 */     GIR_RootConstrainSelectedInstOperands,
     /*  510362 */     // GIR_Coverage, 62201,
     /*  510362 */     GIR_EraseRootFromParent_Done,
     /*  510363 */   // Label 8492: @510363
     /*  510363 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(510431), // Rule ID 62202 //
     /*  510368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510400 */     // MIs[0] policy
     /*  510400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  510413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510427 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510429 */     GIR_RootConstrainSelectedInstOperands,
     /*  510430 */     // GIR_Coverage, 62202,
     /*  510430 */     GIR_EraseRootFromParent_Done,
     /*  510431 */   // Label 8493: @510431
     /*  510431 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(510499), // Rule ID 62203 //
     /*  510436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510468 */     // MIs[0] policy
     /*  510468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  510481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510495 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510497 */     GIR_RootConstrainSelectedInstOperands,
     /*  510498 */     // GIR_Coverage, 62203,
     /*  510498 */     GIR_EraseRootFromParent_Done,
     /*  510499 */   // Label 8494: @510499
     /*  510499 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(510567), // Rule ID 62204 //
     /*  510504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510536 */     // MIs[0] policy
     /*  510536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  510549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510563 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510565 */     GIR_RootConstrainSelectedInstOperands,
     /*  510566 */     // GIR_Coverage, 62204,
     /*  510566 */     GIR_EraseRootFromParent_Done,
     /*  510567 */   // Label 8495: @510567
     /*  510567 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(510635), // Rule ID 62205 //
     /*  510572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510604 */     // MIs[0] policy
     /*  510604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  510617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510631 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510633 */     GIR_RootConstrainSelectedInstOperands,
     /*  510634 */     // GIR_Coverage, 62205,
     /*  510634 */     GIR_EraseRootFromParent_Done,
     /*  510635 */   // Label 8496: @510635
     /*  510635 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(510703), // Rule ID 62206 //
     /*  510640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510672 */     // MIs[0] policy
     /*  510672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  510685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510699 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510701 */     GIR_RootConstrainSelectedInstOperands,
     /*  510702 */     // GIR_Coverage, 62206,
     /*  510702 */     GIR_EraseRootFromParent_Done,
     /*  510703 */   // Label 8497: @510703
     /*  510703 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(510771), // Rule ID 62207 //
     /*  510708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510740 */     // MIs[0] policy
     /*  510740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  510753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510767 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510769 */     GIR_RootConstrainSelectedInstOperands,
     /*  510770 */     // GIR_Coverage, 62207,
     /*  510770 */     GIR_EraseRootFromParent_Done,
     /*  510771 */   // Label 8498: @510771
     /*  510771 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(510839), // Rule ID 62208 //
     /*  510776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510808 */     // MIs[0] policy
     /*  510808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  510821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510835 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510837 */     GIR_RootConstrainSelectedInstOperands,
     /*  510838 */     // GIR_Coverage, 62208,
     /*  510838 */     GIR_EraseRootFromParent_Done,
     /*  510839 */   // Label 8499: @510839
     /*  510839 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(510907), // Rule ID 62209 //
     /*  510844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  510852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510876 */     // MIs[0] policy
     /*  510876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  510889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510903 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510905 */     GIR_RootConstrainSelectedInstOperands,
     /*  510906 */     // GIR_Coverage, 62209,
     /*  510906 */     GIR_EraseRootFromParent_Done,
     /*  510907 */   // Label 8500: @510907
     /*  510907 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(510975), // Rule ID 62210 //
     /*  510912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  510920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510944 */     // MIs[0] policy
     /*  510944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  510957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510971 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510973 */     GIR_RootConstrainSelectedInstOperands,
     /*  510974 */     // GIR_Coverage, 62210,
     /*  510974 */     GIR_EraseRootFromParent_Done,
     /*  510975 */   // Label 8501: @510975
     /*  510975 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(511043), // Rule ID 62211 //
     /*  510980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  510988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  510991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  510994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511012 */     // MIs[0] policy
     /*  511012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  511025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511039 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511041 */     GIR_RootConstrainSelectedInstOperands,
     /*  511042 */     // GIR_Coverage, 62211,
     /*  511042 */     GIR_EraseRootFromParent_Done,
     /*  511043 */   // Label 8502: @511043
     /*  511043 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(511111), // Rule ID 62212 //
     /*  511048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511080 */     // MIs[0] policy
     /*  511080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  511093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511107 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511109 */     GIR_RootConstrainSelectedInstOperands,
     /*  511110 */     // GIR_Coverage, 62212,
     /*  511110 */     GIR_EraseRootFromParent_Done,
     /*  511111 */   // Label 8503: @511111
     /*  511111 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(511179), // Rule ID 62213 //
     /*  511116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511148 */     // MIs[0] policy
     /*  511148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  511161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511175 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511177 */     GIR_RootConstrainSelectedInstOperands,
     /*  511178 */     // GIR_Coverage, 62213,
     /*  511178 */     GIR_EraseRootFromParent_Done,
     /*  511179 */   // Label 8504: @511179
     /*  511179 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(511247), // Rule ID 62214 //
     /*  511184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511216 */     // MIs[0] policy
     /*  511216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  511229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511243 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511245 */     GIR_RootConstrainSelectedInstOperands,
     /*  511246 */     // GIR_Coverage, 62214,
     /*  511246 */     GIR_EraseRootFromParent_Done,
     /*  511247 */   // Label 8505: @511247
     /*  511247 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(511315), // Rule ID 62215 //
     /*  511252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511284 */     // MIs[0] policy
     /*  511284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  511297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511311 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511313 */     GIR_RootConstrainSelectedInstOperands,
     /*  511314 */     // GIR_Coverage, 62215,
     /*  511314 */     GIR_EraseRootFromParent_Done,
     /*  511315 */   // Label 8506: @511315
     /*  511315 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(511383), // Rule ID 62216 //
     /*  511320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511352 */     // MIs[0] policy
     /*  511352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  511365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511379 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511381 */     GIR_RootConstrainSelectedInstOperands,
     /*  511382 */     // GIR_Coverage, 62216,
     /*  511382 */     GIR_EraseRootFromParent_Done,
     /*  511383 */   // Label 8507: @511383
     /*  511383 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(511451), // Rule ID 62217 //
     /*  511388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511420 */     // MIs[0] policy
     /*  511420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  511433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511447 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511449 */     GIR_RootConstrainSelectedInstOperands,
     /*  511450 */     // GIR_Coverage, 62217,
     /*  511450 */     GIR_EraseRootFromParent_Done,
     /*  511451 */   // Label 8508: @511451
     /*  511451 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(511519), // Rule ID 62218 //
     /*  511456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511488 */     // MIs[0] policy
     /*  511488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  511501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511515 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511517 */     GIR_RootConstrainSelectedInstOperands,
     /*  511518 */     // GIR_Coverage, 62218,
     /*  511518 */     GIR_EraseRootFromParent_Done,
     /*  511519 */   // Label 8509: @511519
     /*  511519 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(511587), // Rule ID 62219 //
     /*  511524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  511532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511556 */     // MIs[0] policy
     /*  511556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  511569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511583 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511585 */     GIR_RootConstrainSelectedInstOperands,
     /*  511586 */     // GIR_Coverage, 62219,
     /*  511586 */     GIR_EraseRootFromParent_Done,
     /*  511587 */   // Label 8510: @511587
     /*  511587 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(511655), // Rule ID 62220 //
     /*  511592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511624 */     // MIs[0] policy
     /*  511624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  511637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511651 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511653 */     GIR_RootConstrainSelectedInstOperands,
     /*  511654 */     // GIR_Coverage, 62220,
     /*  511654 */     GIR_EraseRootFromParent_Done,
     /*  511655 */   // Label 8511: @511655
     /*  511655 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(511723), // Rule ID 62221 //
     /*  511660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511692 */     // MIs[0] policy
     /*  511692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  511705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511719 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511721 */     GIR_RootConstrainSelectedInstOperands,
     /*  511722 */     // GIR_Coverage, 62221,
     /*  511722 */     GIR_EraseRootFromParent_Done,
     /*  511723 */   // Label 8512: @511723
     /*  511723 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(511791), // Rule ID 62222 //
     /*  511728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511760 */     // MIs[0] policy
     /*  511760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  511773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511787 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511789 */     GIR_RootConstrainSelectedInstOperands,
     /*  511790 */     // GIR_Coverage, 62222,
     /*  511790 */     GIR_EraseRootFromParent_Done,
     /*  511791 */   // Label 8513: @511791
     /*  511791 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(511859), // Rule ID 62223 //
     /*  511796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511828 */     // MIs[0] policy
     /*  511828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  511841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511855 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511857 */     GIR_RootConstrainSelectedInstOperands,
     /*  511858 */     // GIR_Coverage, 62223,
     /*  511858 */     GIR_EraseRootFromParent_Done,
     /*  511859 */   // Label 8514: @511859
     /*  511859 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(511927), // Rule ID 62224 //
     /*  511864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511896 */     // MIs[0] policy
     /*  511896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  511909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511923 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511925 */     GIR_RootConstrainSelectedInstOperands,
     /*  511926 */     // GIR_Coverage, 62224,
     /*  511926 */     GIR_EraseRootFromParent_Done,
     /*  511927 */   // Label 8515: @511927
     /*  511927 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(511995), // Rule ID 62225 //
     /*  511932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  511940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511964 */     // MIs[0] policy
     /*  511964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  511977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511991 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511993 */     GIR_RootConstrainSelectedInstOperands,
     /*  511994 */     // GIR_Coverage, 62225,
     /*  511994 */     GIR_EraseRootFromParent_Done,
     /*  511995 */   // Label 8516: @511995
     /*  511995 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(512063), // Rule ID 62226 //
     /*  512000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512032 */     // MIs[0] policy
     /*  512032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  512045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512059 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512061 */     GIR_RootConstrainSelectedInstOperands,
     /*  512062 */     // GIR_Coverage, 62226,
     /*  512062 */     GIR_EraseRootFromParent_Done,
     /*  512063 */   // Label 8517: @512063
     /*  512063 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(512131), // Rule ID 62227 //
     /*  512068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512100 */     // MIs[0] policy
     /*  512100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  512113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512127 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512129 */     GIR_RootConstrainSelectedInstOperands,
     /*  512130 */     // GIR_Coverage, 62227,
     /*  512130 */     GIR_EraseRootFromParent_Done,
     /*  512131 */   // Label 8518: @512131
     /*  512131 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(512199), // Rule ID 62228 //
     /*  512136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512168 */     // MIs[0] policy
     /*  512168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  512181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512197 */     GIR_RootConstrainSelectedInstOperands,
     /*  512198 */     // GIR_Coverage, 62228,
     /*  512198 */     GIR_EraseRootFromParent_Done,
     /*  512199 */   // Label 8519: @512199
     /*  512199 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(512267), // Rule ID 62229 //
     /*  512204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512236 */     // MIs[0] policy
     /*  512236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  512249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512265 */     GIR_RootConstrainSelectedInstOperands,
     /*  512266 */     // GIR_Coverage, 62229,
     /*  512266 */     GIR_EraseRootFromParent_Done,
     /*  512267 */   // Label 8520: @512267
     /*  512267 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(512335), // Rule ID 62230 //
     /*  512272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512304 */     // MIs[0] policy
     /*  512304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  512317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512333 */     GIR_RootConstrainSelectedInstOperands,
     /*  512334 */     // GIR_Coverage, 62230,
     /*  512334 */     GIR_EraseRootFromParent_Done,
     /*  512335 */   // Label 8521: @512335
     /*  512335 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(512403), // Rule ID 62231 //
     /*  512340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512372 */     // MIs[0] policy
     /*  512372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  512385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512401 */     GIR_RootConstrainSelectedInstOperands,
     /*  512402 */     // GIR_Coverage, 62231,
     /*  512402 */     GIR_EraseRootFromParent_Done,
     /*  512403 */   // Label 8522: @512403
     /*  512403 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(512471), // Rule ID 62232 //
     /*  512408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512440 */     // MIs[0] policy
     /*  512440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  512453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512469 */     GIR_RootConstrainSelectedInstOperands,
     /*  512470 */     // GIR_Coverage, 62232,
     /*  512470 */     GIR_EraseRootFromParent_Done,
     /*  512471 */   // Label 8523: @512471
     /*  512471 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(512539), // Rule ID 62233 //
     /*  512476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512508 */     // MIs[0] policy
     /*  512508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  512521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512537 */     GIR_RootConstrainSelectedInstOperands,
     /*  512538 */     // GIR_Coverage, 62233,
     /*  512538 */     GIR_EraseRootFromParent_Done,
     /*  512539 */   // Label 8524: @512539
     /*  512539 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(512607), // Rule ID 62234 //
     /*  512544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512576 */     // MIs[0] policy
     /*  512576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  512589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512605 */     GIR_RootConstrainSelectedInstOperands,
     /*  512606 */     // GIR_Coverage, 62234,
     /*  512606 */     GIR_EraseRootFromParent_Done,
     /*  512607 */   // Label 8525: @512607
     /*  512607 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(512675), // Rule ID 62235 //
     /*  512612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512644 */     // MIs[0] policy
     /*  512644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  512657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512673 */     GIR_RootConstrainSelectedInstOperands,
     /*  512674 */     // GIR_Coverage, 62235,
     /*  512674 */     GIR_EraseRootFromParent_Done,
     /*  512675 */   // Label 8526: @512675
     /*  512675 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(512743), // Rule ID 62236 //
     /*  512680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512712 */     // MIs[0] policy
     /*  512712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512722 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  512725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512741 */     GIR_RootConstrainSelectedInstOperands,
     /*  512742 */     // GIR_Coverage, 62236,
     /*  512742 */     GIR_EraseRootFromParent_Done,
     /*  512743 */   // Label 8527: @512743
     /*  512743 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(512811), // Rule ID 62237 //
     /*  512748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512780 */     // MIs[0] policy
     /*  512780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  512793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512809 */     GIR_RootConstrainSelectedInstOperands,
     /*  512810 */     // GIR_Coverage, 62237,
     /*  512810 */     GIR_EraseRootFromParent_Done,
     /*  512811 */   // Label 8528: @512811
     /*  512811 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(512879), // Rule ID 62238 //
     /*  512816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512848 */     // MIs[0] policy
     /*  512848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  512861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512877 */     GIR_RootConstrainSelectedInstOperands,
     /*  512878 */     // GIR_Coverage, 62238,
     /*  512878 */     GIR_EraseRootFromParent_Done,
     /*  512879 */   // Label 8529: @512879
     /*  512879 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(512947), // Rule ID 62239 //
     /*  512884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  512887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512916 */     // MIs[0] policy
     /*  512916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  512929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512945 */     GIR_RootConstrainSelectedInstOperands,
     /*  512946 */     // GIR_Coverage, 62239,
     /*  512946 */     GIR_EraseRootFromParent_Done,
     /*  512947 */   // Label 8530: @512947
     /*  512947 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(513015), // Rule ID 62240 //
     /*  512952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  512955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  512960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512984 */     // MIs[0] policy
     /*  512984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  512997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513013 */     GIR_RootConstrainSelectedInstOperands,
     /*  513014 */     // GIR_Coverage, 62240,
     /*  513014 */     GIR_EraseRootFromParent_Done,
     /*  513015 */   // Label 8531: @513015
     /*  513015 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(513083), // Rule ID 62241 //
     /*  513020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513052 */     // MIs[0] policy
     /*  513052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  513065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513081 */     GIR_RootConstrainSelectedInstOperands,
     /*  513082 */     // GIR_Coverage, 62241,
     /*  513082 */     GIR_EraseRootFromParent_Done,
     /*  513083 */   // Label 8532: @513083
     /*  513083 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(513151), // Rule ID 62242 //
     /*  513088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513120 */     // MIs[0] policy
     /*  513120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  513133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513149 */     GIR_RootConstrainSelectedInstOperands,
     /*  513150 */     // GIR_Coverage, 62242,
     /*  513150 */     GIR_EraseRootFromParent_Done,
     /*  513151 */   // Label 8533: @513151
     /*  513151 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(513219), // Rule ID 62243 //
     /*  513156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513188 */     // MIs[0] policy
     /*  513188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  513201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513217 */     GIR_RootConstrainSelectedInstOperands,
     /*  513218 */     // GIR_Coverage, 62243,
     /*  513218 */     GIR_EraseRootFromParent_Done,
     /*  513219 */   // Label 8534: @513219
     /*  513219 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(513287), // Rule ID 62244 //
     /*  513224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513256 */     // MIs[0] policy
     /*  513256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  513269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513285 */     GIR_RootConstrainSelectedInstOperands,
     /*  513286 */     // GIR_Coverage, 62244,
     /*  513286 */     GIR_EraseRootFromParent_Done,
     /*  513287 */   // Label 8535: @513287
     /*  513287 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(513355), // Rule ID 62245 //
     /*  513292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513324 */     // MIs[0] policy
     /*  513324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  513337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513353 */     GIR_RootConstrainSelectedInstOperands,
     /*  513354 */     // GIR_Coverage, 62245,
     /*  513354 */     GIR_EraseRootFromParent_Done,
     /*  513355 */   // Label 8536: @513355
     /*  513355 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(513423), // Rule ID 62246 //
     /*  513360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513392 */     // MIs[0] policy
     /*  513392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  513405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513421 */     GIR_RootConstrainSelectedInstOperands,
     /*  513422 */     // GIR_Coverage, 62246,
     /*  513422 */     GIR_EraseRootFromParent_Done,
     /*  513423 */   // Label 8537: @513423
     /*  513423 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(513491), // Rule ID 62247 //
     /*  513428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  513436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513460 */     // MIs[0] policy
     /*  513460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  513473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513489 */     GIR_RootConstrainSelectedInstOperands,
     /*  513490 */     // GIR_Coverage, 62247,
     /*  513490 */     GIR_EraseRootFromParent_Done,
     /*  513491 */   // Label 8538: @513491
     /*  513491 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(513559), // Rule ID 62264 //
     /*  513496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  513507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  513510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513528 */     // MIs[0] policy
     /*  513528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  513541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513557 */     GIR_RootConstrainSelectedInstOperands,
     /*  513558 */     // GIR_Coverage, 62264,
     /*  513558 */     GIR_EraseRootFromParent_Done,
     /*  513559 */   // Label 8539: @513559
     /*  513559 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(513627), // Rule ID 62265 //
     /*  513564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  513575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  513578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513596 */     // MIs[0] policy
     /*  513596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  513609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513625 */     GIR_RootConstrainSelectedInstOperands,
     /*  513626 */     // GIR_Coverage, 62265,
     /*  513626 */     GIR_EraseRootFromParent_Done,
     /*  513627 */   // Label 8540: @513627
     /*  513627 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(513695), // Rule ID 62266 //
     /*  513632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513664 */     // MIs[0] policy
     /*  513664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  513677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513691 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513693 */     GIR_RootConstrainSelectedInstOperands,
     /*  513694 */     // GIR_Coverage, 62266,
     /*  513694 */     GIR_EraseRootFromParent_Done,
     /*  513695 */   // Label 8541: @513695
     /*  513695 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(513763), // Rule ID 62267 //
     /*  513700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513732 */     // MIs[0] policy
     /*  513732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  513745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513759 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513761 */     GIR_RootConstrainSelectedInstOperands,
     /*  513762 */     // GIR_Coverage, 62267,
     /*  513762 */     GIR_EraseRootFromParent_Done,
     /*  513763 */   // Label 8542: @513763
     /*  513763 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(513831), // Rule ID 62268 //
     /*  513768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513800 */     // MIs[0] policy
     /*  513800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  513813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513827 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513829 */     GIR_RootConstrainSelectedInstOperands,
     /*  513830 */     // GIR_Coverage, 62268,
     /*  513830 */     GIR_EraseRootFromParent_Done,
     /*  513831 */   // Label 8543: @513831
     /*  513831 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(513899), // Rule ID 62269 //
     /*  513836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  513847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  513850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513868 */     // MIs[0] policy
     /*  513868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  513881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513895 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513897 */     GIR_RootConstrainSelectedInstOperands,
     /*  513898 */     // GIR_Coverage, 62269,
     /*  513898 */     GIR_EraseRootFromParent_Done,
     /*  513899 */   // Label 8544: @513899
     /*  513899 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(513967), // Rule ID 62270 //
     /*  513904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  513907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513936 */     // MIs[0] policy
     /*  513936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  513949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513963 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513965 */     GIR_RootConstrainSelectedInstOperands,
     /*  513966 */     // GIR_Coverage, 62270,
     /*  513966 */     GIR_EraseRootFromParent_Done,
     /*  513967 */   // Label 8545: @513967
     /*  513967 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(514035), // Rule ID 62271 //
     /*  513972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  513975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  513980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  513983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  513986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514004 */     // MIs[0] policy
     /*  514004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  514017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514031 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514033 */     GIR_RootConstrainSelectedInstOperands,
     /*  514034 */     // GIR_Coverage, 62271,
     /*  514034 */     GIR_EraseRootFromParent_Done,
     /*  514035 */   // Label 8546: @514035
     /*  514035 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(514103), // Rule ID 62272 //
     /*  514040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514072 */     // MIs[0] policy
     /*  514072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  514085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514099 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514101 */     GIR_RootConstrainSelectedInstOperands,
     /*  514102 */     // GIR_Coverage, 62272,
     /*  514102 */     GIR_EraseRootFromParent_Done,
     /*  514103 */   // Label 8547: @514103
     /*  514103 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(514171), // Rule ID 62273 //
     /*  514108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514140 */     // MIs[0] policy
     /*  514140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  514153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514167 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514169 */     GIR_RootConstrainSelectedInstOperands,
     /*  514170 */     // GIR_Coverage, 62273,
     /*  514170 */     GIR_EraseRootFromParent_Done,
     /*  514171 */   // Label 8548: @514171
     /*  514171 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(514239), // Rule ID 62274 //
     /*  514176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514208 */     // MIs[0] policy
     /*  514208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  514221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514235 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514237 */     GIR_RootConstrainSelectedInstOperands,
     /*  514238 */     // GIR_Coverage, 62274,
     /*  514238 */     GIR_EraseRootFromParent_Done,
     /*  514239 */   // Label 8549: @514239
     /*  514239 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(514307), // Rule ID 62275 //
     /*  514244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  514255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  514258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514276 */     // MIs[0] policy
     /*  514276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  514289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514303 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514305 */     GIR_RootConstrainSelectedInstOperands,
     /*  514306 */     // GIR_Coverage, 62275,
     /*  514306 */     GIR_EraseRootFromParent_Done,
     /*  514307 */   // Label 8550: @514307
     /*  514307 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(514375), // Rule ID 62276 //
     /*  514312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514344 */     // MIs[0] policy
     /*  514344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  514357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514371 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514373 */     GIR_RootConstrainSelectedInstOperands,
     /*  514374 */     // GIR_Coverage, 62276,
     /*  514374 */     GIR_EraseRootFromParent_Done,
     /*  514375 */   // Label 8551: @514375
     /*  514375 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(514443), // Rule ID 62277 //
     /*  514380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514412 */     // MIs[0] policy
     /*  514412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  514425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514439 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514441 */     GIR_RootConstrainSelectedInstOperands,
     /*  514442 */     // GIR_Coverage, 62277,
     /*  514442 */     GIR_EraseRootFromParent_Done,
     /*  514443 */   // Label 8552: @514443
     /*  514443 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(514511), // Rule ID 62278 //
     /*  514448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514480 */     // MIs[0] policy
     /*  514480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  514493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514507 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514509 */     GIR_RootConstrainSelectedInstOperands,
     /*  514510 */     // GIR_Coverage, 62278,
     /*  514510 */     GIR_EraseRootFromParent_Done,
     /*  514511 */   // Label 8553: @514511
     /*  514511 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(514579), // Rule ID 62279 //
     /*  514516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514548 */     // MIs[0] policy
     /*  514548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  514561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514575 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514577 */     GIR_RootConstrainSelectedInstOperands,
     /*  514578 */     // GIR_Coverage, 62279,
     /*  514578 */     GIR_EraseRootFromParent_Done,
     /*  514579 */   // Label 8554: @514579
     /*  514579 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(514647), // Rule ID 62280 //
     /*  514584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514616 */     // MIs[0] policy
     /*  514616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  514629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514643 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514645 */     GIR_RootConstrainSelectedInstOperands,
     /*  514646 */     // GIR_Coverage, 62280,
     /*  514646 */     GIR_EraseRootFromParent_Done,
     /*  514647 */   // Label 8555: @514647
     /*  514647 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(514715), // Rule ID 62281 //
     /*  514652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  514669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514684 */     // MIs[0] policy
     /*  514684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  514697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514711 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514713 */     GIR_RootConstrainSelectedInstOperands,
     /*  514714 */     // GIR_Coverage, 62281,
     /*  514714 */     GIR_EraseRootFromParent_Done,
     /*  514715 */   // Label 8556: @514715
     /*  514715 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(514783), // Rule ID 62282 //
     /*  514720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514752 */     // MIs[0] policy
     /*  514752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  514765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514779 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514781 */     GIR_RootConstrainSelectedInstOperands,
     /*  514782 */     // GIR_Coverage, 62282,
     /*  514782 */     GIR_EraseRootFromParent_Done,
     /*  514783 */   // Label 8557: @514783
     /*  514783 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(514851), // Rule ID 62283 //
     /*  514788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  514799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  514802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514820 */     // MIs[0] policy
     /*  514820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  514833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514847 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514849 */     GIR_RootConstrainSelectedInstOperands,
     /*  514850 */     // GIR_Coverage, 62283,
     /*  514850 */     GIR_EraseRootFromParent_Done,
     /*  514851 */   // Label 8558: @514851
     /*  514851 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(514919), // Rule ID 62284 //
     /*  514856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514888 */     // MIs[0] policy
     /*  514888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  514901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514915 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514917 */     GIR_RootConstrainSelectedInstOperands,
     /*  514918 */     // GIR_Coverage, 62284,
     /*  514918 */     GIR_EraseRootFromParent_Done,
     /*  514919 */   // Label 8559: @514919
     /*  514919 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(514987), // Rule ID 62285 //
     /*  514924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  514927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  514932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514956 */     // MIs[0] policy
     /*  514956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  514969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514983 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514985 */     GIR_RootConstrainSelectedInstOperands,
     /*  514986 */     // GIR_Coverage, 62285,
     /*  514986 */     GIR_EraseRootFromParent_Done,
     /*  514987 */   // Label 8560: @514987
     /*  514987 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(515055), // Rule ID 62286 //
     /*  514992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  514995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515024 */     // MIs[0] policy
     /*  515024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  515037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515051 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515053 */     GIR_RootConstrainSelectedInstOperands,
     /*  515054 */     // GIR_Coverage, 62286,
     /*  515054 */     GIR_EraseRootFromParent_Done,
     /*  515055 */   // Label 8561: @515055
     /*  515055 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(515123), // Rule ID 62287 //
     /*  515060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515092 */     // MIs[0] policy
     /*  515092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  515105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515119 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515121 */     GIR_RootConstrainSelectedInstOperands,
     /*  515122 */     // GIR_Coverage, 62287,
     /*  515122 */     GIR_EraseRootFromParent_Done,
     /*  515123 */   // Label 8562: @515123
     /*  515123 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(515191), // Rule ID 62288 //
     /*  515128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  515131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515160 */     // MIs[0] policy
     /*  515160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  515173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515187 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515189 */     GIR_RootConstrainSelectedInstOperands,
     /*  515190 */     // GIR_Coverage, 62288,
     /*  515190 */     GIR_EraseRootFromParent_Done,
     /*  515191 */   // Label 8563: @515191
     /*  515191 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(515259), // Rule ID 62289 //
     /*  515196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515228 */     // MIs[0] policy
     /*  515228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  515241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515255 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515257 */     GIR_RootConstrainSelectedInstOperands,
     /*  515258 */     // GIR_Coverage, 62289,
     /*  515258 */     GIR_EraseRootFromParent_Done,
     /*  515259 */   // Label 8564: @515259
     /*  515259 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(515327), // Rule ID 62290 //
     /*  515264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  515267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515296 */     // MIs[0] policy
     /*  515296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515306 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  515309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515323 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515325 */     GIR_RootConstrainSelectedInstOperands,
     /*  515326 */     // GIR_Coverage, 62290,
     /*  515326 */     GIR_EraseRootFromParent_Done,
     /*  515327 */   // Label 8565: @515327
     /*  515327 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(515395), // Rule ID 62291 //
     /*  515332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  515335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  515340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515364 */     // MIs[0] policy
     /*  515364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  515377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515391 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515393 */     GIR_RootConstrainSelectedInstOperands,
     /*  515394 */     // GIR_Coverage, 62291,
     /*  515394 */     GIR_EraseRootFromParent_Done,
     /*  515395 */   // Label 8566: @515395
     /*  515395 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(515463), // Rule ID 62386 //
     /*  515400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515432 */     // MIs[0] policy
     /*  515432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515442 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  515445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515459 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515461 */     GIR_RootConstrainSelectedInstOperands,
     /*  515462 */     // GIR_Coverage, 62386,
     /*  515462 */     GIR_EraseRootFromParent_Done,
     /*  515463 */   // Label 8567: @515463
     /*  515463 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(515531), // Rule ID 62387 //
     /*  515468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  515479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  515482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  515485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515500 */     // MIs[0] policy
     /*  515500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  515513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515527 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515529 */     GIR_RootConstrainSelectedInstOperands,
     /*  515530 */     // GIR_Coverage, 62387,
     /*  515530 */     GIR_EraseRootFromParent_Done,
     /*  515531 */   // Label 8568: @515531
     /*  515531 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(515599), // Rule ID 62388 //
     /*  515536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515568 */     // MIs[0] policy
     /*  515568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  515581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515595 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515597 */     GIR_RootConstrainSelectedInstOperands,
     /*  515598 */     // GIR_Coverage, 62388,
     /*  515598 */     GIR_EraseRootFromParent_Done,
     /*  515599 */   // Label 8569: @515599
     /*  515599 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(515667), // Rule ID 62389 //
     /*  515604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  515615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  515618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  515621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515636 */     // MIs[0] policy
     /*  515636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  515649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515663 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515665 */     GIR_RootConstrainSelectedInstOperands,
     /*  515666 */     // GIR_Coverage, 62389,
     /*  515666 */     GIR_EraseRootFromParent_Done,
     /*  515667 */   // Label 8570: @515667
     /*  515667 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(515735), // Rule ID 62390 //
     /*  515672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515704 */     // MIs[0] policy
     /*  515704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  515717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515731 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515733 */     GIR_RootConstrainSelectedInstOperands,
     /*  515734 */     // GIR_Coverage, 62390,
     /*  515734 */     GIR_EraseRootFromParent_Done,
     /*  515735 */   // Label 8571: @515735
     /*  515735 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(515803), // Rule ID 62391 //
     /*  515740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515772 */     // MIs[0] policy
     /*  515772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11499:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  515785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515799 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515801 */     GIR_RootConstrainSelectedInstOperands,
     /*  515802 */     // GIR_Coverage, 62391,
     /*  515802 */     GIR_EraseRootFromParent_Done,
     /*  515803 */   // Label 8572: @515803
     /*  515803 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(515871), // Rule ID 62392 //
     /*  515808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515840 */     // MIs[0] policy
     /*  515840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  515853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515867 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515869 */     GIR_RootConstrainSelectedInstOperands,
     /*  515870 */     // GIR_Coverage, 62392,
     /*  515870 */     GIR_EraseRootFromParent_Done,
     /*  515871 */   // Label 8573: @515871
     /*  515871 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(515939), // Rule ID 62393 //
     /*  515876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  515879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  515896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515908 */     // MIs[0] policy
     /*  515908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11499:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  515918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  515921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515935 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  515937 */     GIR_RootConstrainSelectedInstOperands,
     /*  515938 */     // GIR_Coverage, 62393,
     /*  515938 */     GIR_EraseRootFromParent_Done,
     /*  515939 */   // Label 8574: @515939
     /*  515939 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(516007), // Rule ID 62394 //
     /*  515944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  515947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  515952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  515964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515976 */     // MIs[0] policy
     /*  515976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  515979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  515986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  515989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  515991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  515993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516003 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516005 */     GIR_RootConstrainSelectedInstOperands,
     /*  516006 */     // GIR_Coverage, 62394,
     /*  516006 */     GIR_EraseRootFromParent_Done,
     /*  516007 */   // Label 8575: @516007
     /*  516007 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(516075), // Rule ID 62395 //
     /*  516012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  516020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  516023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  516026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  516029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516044 */     // MIs[0] policy
     /*  516044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11499:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  516057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516071 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516073 */     GIR_RootConstrainSelectedInstOperands,
     /*  516074 */     // GIR_Coverage, 62395,
     /*  516074 */     GIR_EraseRootFromParent_Done,
     /*  516075 */   // Label 8576: @516075
     /*  516075 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(516143), // Rule ID 62396 //
     /*  516080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516112 */     // MIs[0] policy
     /*  516112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  516125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516139 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516141 */     GIR_RootConstrainSelectedInstOperands,
     /*  516142 */     // GIR_Coverage, 62396,
     /*  516142 */     GIR_EraseRootFromParent_Done,
     /*  516143 */   // Label 8577: @516143
     /*  516143 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(516211), // Rule ID 62397 //
     /*  516148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516180 */     // MIs[0] policy
     /*  516180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  516193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516207 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516209 */     GIR_RootConstrainSelectedInstOperands,
     /*  516210 */     // GIR_Coverage, 62397,
     /*  516210 */     GIR_EraseRootFromParent_Done,
     /*  516211 */   // Label 8578: @516211
     /*  516211 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(516279), // Rule ID 62398 //
     /*  516216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516248 */     // MIs[0] policy
     /*  516248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  516261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516275 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516277 */     GIR_RootConstrainSelectedInstOperands,
     /*  516278 */     // GIR_Coverage, 62398,
     /*  516278 */     GIR_EraseRootFromParent_Done,
     /*  516279 */   // Label 8579: @516279
     /*  516279 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(516347), // Rule ID 62399 //
     /*  516284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516316 */     // MIs[0] policy
     /*  516316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  516329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516343 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516345 */     GIR_RootConstrainSelectedInstOperands,
     /*  516346 */     // GIR_Coverage, 62399,
     /*  516346 */     GIR_EraseRootFromParent_Done,
     /*  516347 */   // Label 8580: @516347
     /*  516347 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(516415), // Rule ID 62400 //
     /*  516352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516384 */     // MIs[0] policy
     /*  516384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  516397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516411 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516413 */     GIR_RootConstrainSelectedInstOperands,
     /*  516414 */     // GIR_Coverage, 62400,
     /*  516414 */     GIR_EraseRootFromParent_Done,
     /*  516415 */   // Label 8581: @516415
     /*  516415 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(516483), // Rule ID 62401 //
     /*  516420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516452 */     // MIs[0] policy
     /*  516452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  516465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516479 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516481 */     GIR_RootConstrainSelectedInstOperands,
     /*  516482 */     // GIR_Coverage, 62401,
     /*  516482 */     GIR_EraseRootFromParent_Done,
     /*  516483 */   // Label 8582: @516483
     /*  516483 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(516551), // Rule ID 62402 //
     /*  516488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516520 */     // MIs[0] policy
     /*  516520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  516533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516549 */     GIR_RootConstrainSelectedInstOperands,
     /*  516550 */     // GIR_Coverage, 62402,
     /*  516550 */     GIR_EraseRootFromParent_Done,
     /*  516551 */   // Label 8583: @516551
     /*  516551 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(516619), // Rule ID 62403 //
     /*  516556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516588 */     // MIs[0] policy
     /*  516588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  516601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516617 */     GIR_RootConstrainSelectedInstOperands,
     /*  516618 */     // GIR_Coverage, 62403,
     /*  516618 */     GIR_EraseRootFromParent_Done,
     /*  516619 */   // Label 8584: @516619
     /*  516619 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(516687), // Rule ID 62404 //
     /*  516624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516656 */     // MIs[0] policy
     /*  516656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  516669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516685 */     GIR_RootConstrainSelectedInstOperands,
     /*  516686 */     // GIR_Coverage, 62404,
     /*  516686 */     GIR_EraseRootFromParent_Done,
     /*  516687 */   // Label 8585: @516687
     /*  516687 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(516755), // Rule ID 62405 //
     /*  516692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516724 */     // MIs[0] policy
     /*  516724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  516737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516753 */     GIR_RootConstrainSelectedInstOperands,
     /*  516754 */     // GIR_Coverage, 62405,
     /*  516754 */     GIR_EraseRootFromParent_Done,
     /*  516755 */   // Label 8586: @516755
     /*  516755 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(516823), // Rule ID 62406 //
     /*  516760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516792 */     // MIs[0] policy
     /*  516792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  516805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516821 */     GIR_RootConstrainSelectedInstOperands,
     /*  516822 */     // GIR_Coverage, 62406,
     /*  516822 */     GIR_EraseRootFromParent_Done,
     /*  516823 */   // Label 8587: @516823
     /*  516823 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(516891), // Rule ID 62407 //
     /*  516828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  516839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  516842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  516845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516860 */     // MIs[0] policy
     /*  516860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11498:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  516870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  516873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516889 */     GIR_RootConstrainSelectedInstOperands,
     /*  516890 */     // GIR_Coverage, 62407,
     /*  516890 */     GIR_EraseRootFromParent_Done,
     /*  516891 */   // Label 8588: @516891
     /*  516891 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(516959), // Rule ID 62408 //
     /*  516896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  516899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  516916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516928 */     // MIs[0] policy
     /*  516928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  516938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  516941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  516943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  516945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  516957 */     GIR_RootConstrainSelectedInstOperands,
     /*  516958 */     // GIR_Coverage, 62408,
     /*  516958 */     GIR_EraseRootFromParent_Done,
     /*  516959 */   // Label 8589: @516959
     /*  516959 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(517027), // Rule ID 62409 //
     /*  516964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  516967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  516972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  516975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  516978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  516984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516996 */     // MIs[0] policy
     /*  516996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  516999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  517009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517025 */     GIR_RootConstrainSelectedInstOperands,
     /*  517026 */     // GIR_Coverage, 62409,
     /*  517026 */     GIR_EraseRootFromParent_Done,
     /*  517027 */   // Label 8590: @517027
     /*  517027 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(517095), // Rule ID 62410 //
     /*  517032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517064 */     // MIs[0] policy
     /*  517064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  517077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517093 */     GIR_RootConstrainSelectedInstOperands,
     /*  517094 */     // GIR_Coverage, 62410,
     /*  517094 */     GIR_EraseRootFromParent_Done,
     /*  517095 */   // Label 8591: @517095
     /*  517095 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(517163), // Rule ID 62411 //
     /*  517100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517132 */     // MIs[0] policy
     /*  517132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  517145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517161 */     GIR_RootConstrainSelectedInstOperands,
     /*  517162 */     // GIR_Coverage, 62411,
     /*  517162 */     GIR_EraseRootFromParent_Done,
     /*  517163 */   // Label 8592: @517163
     /*  517163 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(517231), // Rule ID 62412 //
     /*  517168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517200 */     // MIs[0] policy
     /*  517200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517210 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  517213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517229 */     GIR_RootConstrainSelectedInstOperands,
     /*  517230 */     // GIR_Coverage, 62412,
     /*  517230 */     GIR_EraseRootFromParent_Done,
     /*  517231 */   // Label 8593: @517231
     /*  517231 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(517299), // Rule ID 62413 //
     /*  517236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517268 */     // MIs[0] policy
     /*  517268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  517281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517297 */     GIR_RootConstrainSelectedInstOperands,
     /*  517298 */     // GIR_Coverage, 62413,
     /*  517298 */     GIR_EraseRootFromParent_Done,
     /*  517299 */   // Label 8594: @517299
     /*  517299 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(517367), // Rule ID 62414 //
     /*  517304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517336 */     // MIs[0] policy
     /*  517336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  517349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517365 */     GIR_RootConstrainSelectedInstOperands,
     /*  517366 */     // GIR_Coverage, 62414,
     /*  517366 */     GIR_EraseRootFromParent_Done,
     /*  517367 */   // Label 8595: @517367
     /*  517367 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(517435), // Rule ID 62415 //
     /*  517372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517404 */     // MIs[0] policy
     /*  517404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11498:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  517417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517433 */     GIR_RootConstrainSelectedInstOperands,
     /*  517434 */     // GIR_Coverage, 62415,
     /*  517434 */     GIR_EraseRootFromParent_Done,
     /*  517435 */   // Label 8596: @517435
     /*  517435 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(517503), // Rule ID 62416 //
     /*  517440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517472 */     // MIs[0] policy
     /*  517472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  517485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517501 */     GIR_RootConstrainSelectedInstOperands,
     /*  517502 */     // GIR_Coverage, 62416,
     /*  517502 */     GIR_EraseRootFromParent_Done,
     /*  517503 */   // Label 8597: @517503
     /*  517503 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(517571), // Rule ID 62417 //
     /*  517508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  517525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517540 */     // MIs[0] policy
     /*  517540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517550 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  517553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517569 */     GIR_RootConstrainSelectedInstOperands,
     /*  517570 */     // GIR_Coverage, 62417,
     /*  517570 */     GIR_EraseRootFromParent_Done,
     /*  517571 */   // Label 8598: @517571
     /*  517571 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(517639), // Rule ID 62418 //
     /*  517576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517608 */     // MIs[0] policy
     /*  517608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  517621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517637 */     GIR_RootConstrainSelectedInstOperands,
     /*  517638 */     // GIR_Coverage, 62418,
     /*  517638 */     GIR_EraseRootFromParent_Done,
     /*  517639 */   // Label 8599: @517639
     /*  517639 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(517707), // Rule ID 62419 //
     /*  517644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517676 */     // MIs[0] policy
     /*  517676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  517689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517705 */     GIR_RootConstrainSelectedInstOperands,
     /*  517706 */     // GIR_Coverage, 62419,
     /*  517706 */     GIR_EraseRootFromParent_Done,
     /*  517707 */   // Label 8600: @517707
     /*  517707 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(517775), // Rule ID 62420 //
     /*  517712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517744 */     // MIs[0] policy
     /*  517744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  517757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517773 */     GIR_RootConstrainSelectedInstOperands,
     /*  517774 */     // GIR_Coverage, 62420,
     /*  517774 */     GIR_EraseRootFromParent_Done,
     /*  517775 */   // Label 8601: @517775
     /*  517775 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(517843), // Rule ID 62421 //
     /*  517780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517812 */     // MIs[0] policy
     /*  517812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  517825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517841 */     GIR_RootConstrainSelectedInstOperands,
     /*  517842 */     // GIR_Coverage, 62421,
     /*  517842 */     GIR_EraseRootFromParent_Done,
     /*  517843 */   // Label 8602: @517843
     /*  517843 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(517911), // Rule ID 62422 //
     /*  517848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  517851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  517868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517880 */     // MIs[0] policy
     /*  517880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  517890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  517893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517909 */     GIR_RootConstrainSelectedInstOperands,
     /*  517910 */     // GIR_Coverage, 62422,
     /*  517910 */     GIR_EraseRootFromParent_Done,
     /*  517911 */   // Label 8603: @517911
     /*  517911 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(517979), // Rule ID 62423 //
     /*  517916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  517919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  517924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  517936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517948 */     // MIs[0] policy
     /*  517948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  517951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11498:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  517958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  517961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  517963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  517965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  517977 */     GIR_RootConstrainSelectedInstOperands,
     /*  517978 */     // GIR_Coverage, 62423,
     /*  517978 */     GIR_EraseRootFromParent_Done,
     /*  517979 */   // Label 8604: @517979
     /*  517979 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(518050), // Rule ID 2698 //
     /*  517984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  517992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  517995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  517998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518016 */     // MIs[0] round
     /*  518016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518026 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  518029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518035 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518048 */     GIR_RootConstrainSelectedInstOperands,
     /*  518049 */     // GIR_Coverage, 2698,
     /*  518049 */     GIR_EraseRootFromParent_Done,
     /*  518050 */   // Label 8605: @518050
     /*  518050 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(518121), // Rule ID 2699 //
     /*  518055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518087 */     // MIs[0] round
     /*  518087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518097 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  518100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518106 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518119 */     GIR_RootConstrainSelectedInstOperands,
     /*  518120 */     // GIR_Coverage, 2699,
     /*  518120 */     GIR_EraseRootFromParent_Done,
     /*  518121 */   // Label 8606: @518121
     /*  518121 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(518192), // Rule ID 2734 //
     /*  518126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518158 */     // MIs[0] round
     /*  518158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518168 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  518171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518177 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518190 */     GIR_RootConstrainSelectedInstOperands,
     /*  518191 */     // GIR_Coverage, 2734,
     /*  518191 */     GIR_EraseRootFromParent_Done,
     /*  518192 */   // Label 8607: @518192
     /*  518192 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(518263), // Rule ID 2735 //
     /*  518197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  518208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  518211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  518214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518229 */     // MIs[0] round
     /*  518229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518239 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  518242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518248 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518261 */     GIR_RootConstrainSelectedInstOperands,
     /*  518262 */     // GIR_Coverage, 2735,
     /*  518262 */     GIR_EraseRootFromParent_Done,
     /*  518263 */   // Label 8608: @518263
     /*  518263 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(518334), // Rule ID 18992 //
     /*  518268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518300 */     // MIs[0] round
     /*  518300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518310 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  518313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518319 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518332 */     GIR_RootConstrainSelectedInstOperands,
     /*  518333 */     // GIR_Coverage, 18992,
     /*  518333 */     GIR_EraseRootFromParent_Done,
     /*  518334 */   // Label 8609: @518334
     /*  518334 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(518405), // Rule ID 18993 //
     /*  518339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518371 */     // MIs[0] round
     /*  518371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518381 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  518384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518390 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518403 */     GIR_RootConstrainSelectedInstOperands,
     /*  518404 */     // GIR_Coverage, 18993,
     /*  518404 */     GIR_EraseRootFromParent_Done,
     /*  518405 */   // Label 8610: @518405
     /*  518405 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(518476), // Rule ID 18996 //
     /*  518410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518442 */     // MIs[0] round
     /*  518442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  518455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518461 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518474 */     GIR_RootConstrainSelectedInstOperands,
     /*  518475 */     // GIR_Coverage, 18996,
     /*  518475 */     GIR_EraseRootFromParent_Done,
     /*  518476 */   // Label 8611: @518476
     /*  518476 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(518547), // Rule ID 18997 //
     /*  518481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518513 */     // MIs[0] round
     /*  518513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518523 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  518526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518532 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518545 */     GIR_RootConstrainSelectedInstOperands,
     /*  518546 */     // GIR_Coverage, 18997,
     /*  518546 */     GIR_EraseRootFromParent_Done,
     /*  518547 */   // Label 8612: @518547
     /*  518547 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(518618), // Rule ID 19000 //
     /*  518552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518584 */     // MIs[0] round
     /*  518584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518594 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  518597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518603 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518616 */     GIR_RootConstrainSelectedInstOperands,
     /*  518617 */     // GIR_Coverage, 19000,
     /*  518617 */     GIR_EraseRootFromParent_Done,
     /*  518618 */   // Label 8613: @518618
     /*  518618 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(518689), // Rule ID 19001 //
     /*  518623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  518626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518655 */     // MIs[0] round
     /*  518655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518665 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  518668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518674 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518687 */     GIR_RootConstrainSelectedInstOperands,
     /*  518688 */     // GIR_Coverage, 19001,
     /*  518688 */     GIR_EraseRootFromParent_Done,
     /*  518689 */   // Label 8614: @518689
     /*  518689 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(518760), // Rule ID 19004 //
     /*  518694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  518697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518726 */     // MIs[0] round
     /*  518726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  518739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518745 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518758 */     GIR_RootConstrainSelectedInstOperands,
     /*  518759 */     // GIR_Coverage, 19004,
     /*  518759 */     GIR_EraseRootFromParent_Done,
     /*  518760 */   // Label 8615: @518760
     /*  518760 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(518831), // Rule ID 19005 //
     /*  518765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518797 */     // MIs[0] round
     /*  518797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  518810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518816 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518829 */     GIR_RootConstrainSelectedInstOperands,
     /*  518830 */     // GIR_Coverage, 19005,
     /*  518830 */     GIR_EraseRootFromParent_Done,
     /*  518831 */   // Label 8616: @518831
     /*  518831 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(518902), // Rule ID 19008 //
     /*  518836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518868 */     // MIs[0] round
     /*  518868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518878 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  518881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518887 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518900 */     GIR_RootConstrainSelectedInstOperands,
     /*  518901 */     // GIR_Coverage, 19008,
     /*  518901 */     GIR_EraseRootFromParent_Done,
     /*  518902 */   // Label 8617: @518902
     /*  518902 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(518973), // Rule ID 19009 //
     /*  518907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518939 */     // MIs[0] round
     /*  518939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518949 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  518952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518958 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518971 */     GIR_RootConstrainSelectedInstOperands,
     /*  518972 */     // GIR_Coverage, 19009,
     /*  518972 */     GIR_EraseRootFromParent_Done,
     /*  518973 */   // Label 8618: @518973
     /*  518973 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(519044), // Rule ID 19012 //
     /*  518978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  518981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  518986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  518989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  518992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  518995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519010 */     // MIs[0] round
     /*  519010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519020 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  519023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519029 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519042 */     GIR_RootConstrainSelectedInstOperands,
     /*  519043 */     // GIR_Coverage, 19012,
     /*  519043 */     GIR_EraseRootFromParent_Done,
     /*  519044 */   // Label 8619: @519044
     /*  519044 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(519115), // Rule ID 19013 //
     /*  519049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519081 */     // MIs[0] round
     /*  519081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  519094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519100 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519113 */     GIR_RootConstrainSelectedInstOperands,
     /*  519114 */     // GIR_Coverage, 19013,
     /*  519114 */     GIR_EraseRootFromParent_Done,
     /*  519115 */   // Label 8620: @519115
     /*  519115 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(519186), // Rule ID 19016 //
     /*  519120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  519123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519152 */     // MIs[0] round
     /*  519152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519162 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  519165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519171 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519184 */     GIR_RootConstrainSelectedInstOperands,
     /*  519185 */     // GIR_Coverage, 19016,
     /*  519185 */     GIR_EraseRootFromParent_Done,
     /*  519186 */   // Label 8621: @519186
     /*  519186 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(519257), // Rule ID 19017 //
     /*  519191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519223 */     // MIs[0] round
     /*  519223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519233 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  519236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519242 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519255 */     GIR_RootConstrainSelectedInstOperands,
     /*  519256 */     // GIR_Coverage, 19017,
     /*  519256 */     GIR_EraseRootFromParent_Done,
     /*  519257 */   // Label 8622: @519257
     /*  519257 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(519328), // Rule ID 19020 //
     /*  519262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  519265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519294 */     // MIs[0] round
     /*  519294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519304 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  519307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519313 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519326 */     GIR_RootConstrainSelectedInstOperands,
     /*  519327 */     // GIR_Coverage, 19020,
     /*  519327 */     GIR_EraseRootFromParent_Done,
     /*  519328 */   // Label 8623: @519328
     /*  519328 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(519399), // Rule ID 19021 //
     /*  519333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  519336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519365 */     // MIs[0] round
     /*  519365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519375 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  519378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519384 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519397 */     GIR_RootConstrainSelectedInstOperands,
     /*  519398 */     // GIR_Coverage, 19021,
     /*  519398 */     GIR_EraseRootFromParent_Done,
     /*  519399 */   // Label 8624: @519399
     /*  519399 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(519470), // Rule ID 19024 //
     /*  519404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519436 */     // MIs[0] round
     /*  519436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  519449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519455 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519468 */     GIR_RootConstrainSelectedInstOperands,
     /*  519469 */     // GIR_Coverage, 19024,
     /*  519469 */     GIR_EraseRootFromParent_Done,
     /*  519470 */   // Label 8625: @519470
     /*  519470 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(519541), // Rule ID 19025 //
     /*  519475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519507 */     // MIs[0] round
     /*  519507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519517 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  519520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519526 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519539 */     GIR_RootConstrainSelectedInstOperands,
     /*  519540 */     // GIR_Coverage, 19025,
     /*  519540 */     GIR_EraseRootFromParent_Done,
     /*  519541 */   // Label 8626: @519541
     /*  519541 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(519612), // Rule ID 19028 //
     /*  519546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519578 */     // MIs[0] round
     /*  519578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  519591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519597 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519610 */     GIR_RootConstrainSelectedInstOperands,
     /*  519611 */     // GIR_Coverage, 19028,
     /*  519611 */     GIR_EraseRootFromParent_Done,
     /*  519612 */   // Label 8627: @519612
     /*  519612 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(519683), // Rule ID 19029 //
     /*  519617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519649 */     // MIs[0] round
     /*  519649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519659 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  519662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519668 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519681 */     GIR_RootConstrainSelectedInstOperands,
     /*  519682 */     // GIR_Coverage, 19029,
     /*  519682 */     GIR_EraseRootFromParent_Done,
     /*  519683 */   // Label 8628: @519683
     /*  519683 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(519754), // Rule ID 19032 //
     /*  519688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  519691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519720 */     // MIs[0] round
     /*  519720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  519733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519739 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519752 */     GIR_RootConstrainSelectedInstOperands,
     /*  519753 */     // GIR_Coverage, 19032,
     /*  519753 */     GIR_EraseRootFromParent_Done,
     /*  519754 */   // Label 8629: @519754
     /*  519754 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(519825), // Rule ID 19033 //
     /*  519759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  519762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519791 */     // MIs[0] round
     /*  519791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519801 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  519804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519810 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519823 */     GIR_RootConstrainSelectedInstOperands,
     /*  519824 */     // GIR_Coverage, 19033,
     /*  519824 */     GIR_EraseRootFromParent_Done,
     /*  519825 */   // Label 8630: @519825
     /*  519825 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(519896), // Rule ID 19036 //
     /*  519830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  519833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519862 */     // MIs[0] round
     /*  519862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  519875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519881 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519894 */     GIR_RootConstrainSelectedInstOperands,
     /*  519895 */     // GIR_Coverage, 19036,
     /*  519895 */     GIR_EraseRootFromParent_Done,
     /*  519896 */   // Label 8631: @519896
     /*  519896 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(519967), // Rule ID 19037 //
     /*  519901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  519904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519933 */     // MIs[0] round
     /*  519933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519943 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  519946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519952 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519965 */     GIR_RootConstrainSelectedInstOperands,
     /*  519966 */     // GIR_Coverage, 19037,
     /*  519966 */     GIR_EraseRootFromParent_Done,
     /*  519967 */   // Label 8632: @519967
     /*  519967 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(520038), // Rule ID 19040 //
     /*  519972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  519975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  519980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  519983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  519986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  519989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520004 */     // MIs[0] round
     /*  520004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  520017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520023 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520036 */     GIR_RootConstrainSelectedInstOperands,
     /*  520037 */     // GIR_Coverage, 19040,
     /*  520037 */     GIR_EraseRootFromParent_Done,
     /*  520038 */   // Label 8633: @520038
     /*  520038 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(520109), // Rule ID 19041 //
     /*  520043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  520046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520075 */     // MIs[0] round
     /*  520075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520085 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  520088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520094 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520107 */     GIR_RootConstrainSelectedInstOperands,
     /*  520108 */     // GIR_Coverage, 19041,
     /*  520108 */     GIR_EraseRootFromParent_Done,
     /*  520109 */   // Label 8634: @520109
     /*  520109 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(520180), // Rule ID 19044 //
     /*  520114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  520117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520146 */     // MIs[0] round
     /*  520146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  520159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520165 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520178 */     GIR_RootConstrainSelectedInstOperands,
     /*  520179 */     // GIR_Coverage, 19044,
     /*  520179 */     GIR_EraseRootFromParent_Done,
     /*  520180 */   // Label 8635: @520180
     /*  520180 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(520251), // Rule ID 19045 //
     /*  520185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  520188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  520193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520217 */     // MIs[0] round
     /*  520217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520227 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  520230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520236 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520249 */     GIR_RootConstrainSelectedInstOperands,
     /*  520250 */     // GIR_Coverage, 19045,
     /*  520250 */     GIR_EraseRootFromParent_Done,
     /*  520251 */   // Label 8636: @520251
     /*  520251 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(520322), // Rule ID 19104 //
     /*  520256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520288 */     // MIs[0] round
     /*  520288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520298 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  520301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520307 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520320 */     GIR_RootConstrainSelectedInstOperands,
     /*  520321 */     // GIR_Coverage, 19104,
     /*  520321 */     GIR_EraseRootFromParent_Done,
     /*  520322 */   // Label 8637: @520322
     /*  520322 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(520393), // Rule ID 19105 //
     /*  520327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520359 */     // MIs[0] round
     /*  520359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520369 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  520372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520378 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520391 */     GIR_RootConstrainSelectedInstOperands,
     /*  520392 */     // GIR_Coverage, 19105,
     /*  520392 */     GIR_EraseRootFromParent_Done,
     /*  520393 */   // Label 8638: @520393
     /*  520393 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(520464), // Rule ID 19108 //
     /*  520398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520430 */     // MIs[0] round
     /*  520430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520440 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  520443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520449 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520462 */     GIR_RootConstrainSelectedInstOperands,
     /*  520463 */     // GIR_Coverage, 19108,
     /*  520463 */     GIR_EraseRootFromParent_Done,
     /*  520464 */   // Label 8639: @520464
     /*  520464 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(520535), // Rule ID 19109 //
     /*  520469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520501 */     // MIs[0] round
     /*  520501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520511 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  520514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520520 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520533 */     GIR_RootConstrainSelectedInstOperands,
     /*  520534 */     // GIR_Coverage, 19109,
     /*  520534 */     GIR_EraseRootFromParent_Done,
     /*  520535 */   // Label 8640: @520535
     /*  520535 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(520606), // Rule ID 19112 //
     /*  520540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  520543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520572 */     // MIs[0] round
     /*  520572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  520585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520591 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520604 */     GIR_RootConstrainSelectedInstOperands,
     /*  520605 */     // GIR_Coverage, 19112,
     /*  520605 */     GIR_EraseRootFromParent_Done,
     /*  520606 */   // Label 8641: @520606
     /*  520606 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(520677), // Rule ID 19113 //
     /*  520611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  520614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520643 */     // MIs[0] round
     /*  520643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520653 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  520656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520662 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520675 */     GIR_RootConstrainSelectedInstOperands,
     /*  520676 */     // GIR_Coverage, 19113,
     /*  520676 */     GIR_EraseRootFromParent_Done,
     /*  520677 */   // Label 8642: @520677
     /*  520677 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(520748), // Rule ID 19116 //
     /*  520682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  520685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520714 */     // MIs[0] round
     /*  520714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  520727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520733 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520746 */     GIR_RootConstrainSelectedInstOperands,
     /*  520747 */     // GIR_Coverage, 19116,
     /*  520747 */     GIR_EraseRootFromParent_Done,
     /*  520748 */   // Label 8643: @520748
     /*  520748 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(520819), // Rule ID 19117 //
     /*  520753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  520756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520785 */     // MIs[0] round
     /*  520785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520795 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  520798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520804 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520817 */     GIR_RootConstrainSelectedInstOperands,
     /*  520818 */     // GIR_Coverage, 19117,
     /*  520818 */     GIR_EraseRootFromParent_Done,
     /*  520819 */   // Label 8644: @520819
     /*  520819 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(520890), // Rule ID 19120 //
     /*  520824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  520827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520856 */     // MIs[0] round
     /*  520856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  520869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520875 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520888 */     GIR_RootConstrainSelectedInstOperands,
     /*  520889 */     // GIR_Coverage, 19120,
     /*  520889 */     GIR_EraseRootFromParent_Done,
     /*  520890 */   // Label 8645: @520890
     /*  520890 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(520961), // Rule ID 19121 //
     /*  520895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  520898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520927 */     // MIs[0] round
     /*  520927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520937 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  520940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520946 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520959 */     GIR_RootConstrainSelectedInstOperands,
     /*  520960 */     // GIR_Coverage, 19121,
     /*  520960 */     GIR_EraseRootFromParent_Done,
     /*  520961 */   // Label 8646: @520961
     /*  520961 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(521032), // Rule ID 19124 //
     /*  520966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  520969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  520974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  520977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  520980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  520983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520998 */     // MIs[0] round
     /*  520998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  521011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521017 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521030 */     GIR_RootConstrainSelectedInstOperands,
     /*  521031 */     // GIR_Coverage, 19124,
     /*  521031 */     GIR_EraseRootFromParent_Done,
     /*  521032 */   // Label 8647: @521032
     /*  521032 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(521103), // Rule ID 19125 //
     /*  521037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  521040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521069 */     // MIs[0] round
     /*  521069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521079 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  521082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521088 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521101 */     GIR_RootConstrainSelectedInstOperands,
     /*  521102 */     // GIR_Coverage, 19125,
     /*  521102 */     GIR_EraseRootFromParent_Done,
     /*  521103 */   // Label 8648: @521103
     /*  521103 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(521174), // Rule ID 19128 //
     /*  521108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521140 */     // MIs[0] round
     /*  521140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521150 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  521153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521159 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521172 */     GIR_RootConstrainSelectedInstOperands,
     /*  521173 */     // GIR_Coverage, 19128,
     /*  521173 */     GIR_EraseRootFromParent_Done,
     /*  521174 */   // Label 8649: @521174
     /*  521174 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(521245), // Rule ID 19129 //
     /*  521179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521211 */     // MIs[0] round
     /*  521211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  521224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521230 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521243 */     GIR_RootConstrainSelectedInstOperands,
     /*  521244 */     // GIR_Coverage, 19129,
     /*  521244 */     GIR_EraseRootFromParent_Done,
     /*  521245 */   // Label 8650: @521245
     /*  521245 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(521316), // Rule ID 19132 //
     /*  521250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521282 */     // MIs[0] round
     /*  521282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521292 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  521295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521301 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521314 */     GIR_RootConstrainSelectedInstOperands,
     /*  521315 */     // GIR_Coverage, 19132,
     /*  521315 */     GIR_EraseRootFromParent_Done,
     /*  521316 */   // Label 8651: @521316
     /*  521316 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(521387), // Rule ID 19133 //
     /*  521321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521353 */     // MIs[0] round
     /*  521353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521363 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  521366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521372 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521385 */     GIR_RootConstrainSelectedInstOperands,
     /*  521386 */     // GIR_Coverage, 19133,
     /*  521386 */     GIR_EraseRootFromParent_Done,
     /*  521387 */   // Label 8652: @521387
     /*  521387 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(521458), // Rule ID 19136 //
     /*  521392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  521395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521424 */     // MIs[0] round
     /*  521424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  521437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521443 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521456 */     GIR_RootConstrainSelectedInstOperands,
     /*  521457 */     // GIR_Coverage, 19136,
     /*  521457 */     GIR_EraseRootFromParent_Done,
     /*  521458 */   // Label 8653: @521458
     /*  521458 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(521529), // Rule ID 19137 //
     /*  521463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  521466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521495 */     // MIs[0] round
     /*  521495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  521508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521514 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521527 */     GIR_RootConstrainSelectedInstOperands,
     /*  521528 */     // GIR_Coverage, 19137,
     /*  521528 */     GIR_EraseRootFromParent_Done,
     /*  521529 */   // Label 8654: @521529
     /*  521529 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(521600), // Rule ID 19140 //
     /*  521534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521566 */     // MIs[0] round
     /*  521566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  521579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521585 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521598 */     GIR_RootConstrainSelectedInstOperands,
     /*  521599 */     // GIR_Coverage, 19140,
     /*  521599 */     GIR_EraseRootFromParent_Done,
     /*  521600 */   // Label 8655: @521600
     /*  521600 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(521671), // Rule ID 19141 //
     /*  521605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521637 */     // MIs[0] round
     /*  521637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521647 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  521650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521656 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521669 */     GIR_RootConstrainSelectedInstOperands,
     /*  521670 */     // GIR_Coverage, 19141,
     /*  521670 */     GIR_EraseRootFromParent_Done,
     /*  521671 */   // Label 8656: @521671
     /*  521671 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(521742), // Rule ID 19144 //
     /*  521676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521708 */     // MIs[0] round
     /*  521708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  521721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521727 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521740 */     GIR_RootConstrainSelectedInstOperands,
     /*  521741 */     // GIR_Coverage, 19144,
     /*  521741 */     GIR_EraseRootFromParent_Done,
     /*  521742 */   // Label 8657: @521742
     /*  521742 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(521813), // Rule ID 19145 //
     /*  521747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521779 */     // MIs[0] round
     /*  521779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521789 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  521792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521798 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521811 */     GIR_RootConstrainSelectedInstOperands,
     /*  521812 */     // GIR_Coverage, 19145,
     /*  521812 */     GIR_EraseRootFromParent_Done,
     /*  521813 */   // Label 8658: @521813
     /*  521813 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(521884), // Rule ID 19148 //
     /*  521818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  521821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521850 */     // MIs[0] round
     /*  521850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521860 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  521863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521869 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521882 */     GIR_RootConstrainSelectedInstOperands,
     /*  521883 */     // GIR_Coverage, 19148,
     /*  521883 */     GIR_EraseRootFromParent_Done,
     /*  521884 */   // Label 8659: @521884
     /*  521884 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(521955), // Rule ID 19149 //
     /*  521889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  521892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521921 */     // MIs[0] round
     /*  521921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521931 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  521934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521940 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521953 */     GIR_RootConstrainSelectedInstOperands,
     /*  521954 */     // GIR_Coverage, 19149,
     /*  521954 */     GIR_EraseRootFromParent_Done,
     /*  521955 */   // Label 8660: @521955
     /*  521955 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(522026), // Rule ID 19152 //
     /*  521960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  521963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  521968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  521971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  521974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  521977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521992 */     // MIs[0] round
     /*  521992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522002 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  522005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522011 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522024 */     GIR_RootConstrainSelectedInstOperands,
     /*  522025 */     // GIR_Coverage, 19152,
     /*  522025 */     GIR_EraseRootFromParent_Done,
     /*  522026 */   // Label 8661: @522026
     /*  522026 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(522097), // Rule ID 19153 //
     /*  522031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522063 */     // MIs[0] round
     /*  522063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522073 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  522076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522082 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522095 */     GIR_RootConstrainSelectedInstOperands,
     /*  522096 */     // GIR_Coverage, 19153,
     /*  522096 */     GIR_EraseRootFromParent_Done,
     /*  522097 */   // Label 8662: @522097
     /*  522097 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(522168), // Rule ID 19156 //
     /*  522102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  522105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522134 */     // MIs[0] round
     /*  522134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  522147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522153 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522166 */     GIR_RootConstrainSelectedInstOperands,
     /*  522167 */     // GIR_Coverage, 19156,
     /*  522167 */     GIR_EraseRootFromParent_Done,
     /*  522168 */   // Label 8663: @522168
     /*  522168 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(522239), // Rule ID 19157 //
     /*  522173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522205 */     // MIs[0] round
     /*  522205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522215 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  522218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522224 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522237 */     GIR_RootConstrainSelectedInstOperands,
     /*  522238 */     // GIR_Coverage, 19157,
     /*  522238 */     GIR_EraseRootFromParent_Done,
     /*  522239 */   // Label 8664: @522239
     /*  522239 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(522310), // Rule ID 19160 //
     /*  522244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  522247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522276 */     // MIs[0] round
     /*  522276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522286 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  522289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522295 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522308 */     GIR_RootConstrainSelectedInstOperands,
     /*  522309 */     // GIR_Coverage, 19160,
     /*  522309 */     GIR_EraseRootFromParent_Done,
     /*  522310 */   // Label 8665: @522310
     /*  522310 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(522381), // Rule ID 19161 //
     /*  522315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  522318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  522323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522347 */     // MIs[0] round
     /*  522347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  522360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522366 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522379 */     GIR_RootConstrainSelectedInstOperands,
     /*  522380 */     // GIR_Coverage, 19161,
     /*  522380 */     GIR_EraseRootFromParent_Done,
     /*  522381 */   // Label 8666: @522381
     /*  522381 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(522452), // Rule ID 20746 //
     /*  522386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522418 */     // MIs[0] round
     /*  522418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522437 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522450 */     GIR_RootConstrainSelectedInstOperands,
     /*  522451 */     // GIR_Coverage, 20746,
     /*  522451 */     GIR_EraseRootFromParent_Done,
     /*  522452 */   // Label 8667: @522452
     /*  522452 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(522523), // Rule ID 20747 //
     /*  522457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522489 */     // MIs[0] round
     /*  522489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522508 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522521 */     GIR_RootConstrainSelectedInstOperands,
     /*  522522 */     // GIR_Coverage, 20747,
     /*  522522 */     GIR_EraseRootFromParent_Done,
     /*  522523 */   // Label 8668: @522523
     /*  522523 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(522594), // Rule ID 20750 //
     /*  522528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522560 */     // MIs[0] round
     /*  522560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522579 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522592 */     GIR_RootConstrainSelectedInstOperands,
     /*  522593 */     // GIR_Coverage, 20750,
     /*  522593 */     GIR_EraseRootFromParent_Done,
     /*  522594 */   // Label 8669: @522594
     /*  522594 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(522665), // Rule ID 20751 //
     /*  522599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522631 */     // MIs[0] round
     /*  522631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  522644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522650 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522663 */     GIR_RootConstrainSelectedInstOperands,
     /*  522664 */     // GIR_Coverage, 20751,
     /*  522664 */     GIR_EraseRootFromParent_Done,
     /*  522665 */   // Label 8670: @522665
     /*  522665 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(522736), // Rule ID 20754 //
     /*  522670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522702 */     // MIs[0] round
     /*  522702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522721 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522734 */     GIR_RootConstrainSelectedInstOperands,
     /*  522735 */     // GIR_Coverage, 20754,
     /*  522735 */     GIR_EraseRootFromParent_Done,
     /*  522736 */   // Label 8671: @522736
     /*  522736 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(522807), // Rule ID 20755 //
     /*  522741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522773 */     // MIs[0] round
     /*  522773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522792 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522805 */     GIR_RootConstrainSelectedInstOperands,
     /*  522806 */     // GIR_Coverage, 20755,
     /*  522806 */     GIR_EraseRootFromParent_Done,
     /*  522807 */   // Label 8672: @522807
     /*  522807 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(522878), // Rule ID 20758 //
     /*  522812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522844 */     // MIs[0] round
     /*  522844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522863 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522876 */     GIR_RootConstrainSelectedInstOperands,
     /*  522877 */     // GIR_Coverage, 20758,
     /*  522877 */     GIR_EraseRootFromParent_Done,
     /*  522878 */   // Label 8673: @522878
     /*  522878 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(522949), // Rule ID 20759 //
     /*  522883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522915 */     // MIs[0] round
     /*  522915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522934 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522947 */     GIR_RootConstrainSelectedInstOperands,
     /*  522948 */     // GIR_Coverage, 20759,
     /*  522948 */     GIR_EraseRootFromParent_Done,
     /*  522949 */   // Label 8674: @522949
     /*  522949 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(523020), // Rule ID 20762 //
     /*  522954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  522962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  522965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  522968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  522971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522986 */     // MIs[0] round
     /*  522986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  522999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523005 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523018 */     GIR_RootConstrainSelectedInstOperands,
     /*  523019 */     // GIR_Coverage, 20762,
     /*  523019 */     GIR_EraseRootFromParent_Done,
     /*  523020 */   // Label 8675: @523020
     /*  523020 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(523091), // Rule ID 20763 //
     /*  523025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523057 */     // MIs[0] round
     /*  523057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523067 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  523070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523076 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523089 */     GIR_RootConstrainSelectedInstOperands,
     /*  523090 */     // GIR_Coverage, 20763,
     /*  523090 */     GIR_EraseRootFromParent_Done,
     /*  523091 */   // Label 8676: @523091
     /*  523091 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(523162), // Rule ID 20766 //
     /*  523096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523128 */     // MIs[0] round
     /*  523128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523147 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523160 */     GIR_RootConstrainSelectedInstOperands,
     /*  523161 */     // GIR_Coverage, 20766,
     /*  523161 */     GIR_EraseRootFromParent_Done,
     /*  523162 */   // Label 8677: @523162
     /*  523162 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(523233), // Rule ID 20767 //
     /*  523167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523199 */     // MIs[0] round
     /*  523199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523218 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523231 */     GIR_RootConstrainSelectedInstOperands,
     /*  523232 */     // GIR_Coverage, 20767,
     /*  523232 */     GIR_EraseRootFromParent_Done,
     /*  523233 */   // Label 8678: @523233
     /*  523233 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(523304), // Rule ID 20770 //
     /*  523238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523270 */     // MIs[0] round
     /*  523270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523289 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523302 */     GIR_RootConstrainSelectedInstOperands,
     /*  523303 */     // GIR_Coverage, 20770,
     /*  523303 */     GIR_EraseRootFromParent_Done,
     /*  523304 */   // Label 8679: @523304
     /*  523304 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(523375), // Rule ID 20771 //
     /*  523309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523341 */     // MIs[0] round
     /*  523341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523351 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523360 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523373 */     GIR_RootConstrainSelectedInstOperands,
     /*  523374 */     // GIR_Coverage, 20771,
     /*  523374 */     GIR_EraseRootFromParent_Done,
     /*  523375 */   // Label 8680: @523375
     /*  523375 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(523446), // Rule ID 20774 //
     /*  523380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523412 */     // MIs[0] round
     /*  523412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523431 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523444 */     GIR_RootConstrainSelectedInstOperands,
     /*  523445 */     // GIR_Coverage, 20774,
     /*  523445 */     GIR_EraseRootFromParent_Done,
     /*  523446 */   // Label 8681: @523446
     /*  523446 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(523517), // Rule ID 20775 //
     /*  523451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523483 */     // MIs[0] round
     /*  523483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523493 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523502 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523515 */     GIR_RootConstrainSelectedInstOperands,
     /*  523516 */     // GIR_Coverage, 20775,
     /*  523516 */     GIR_EraseRootFromParent_Done,
     /*  523517 */   // Label 8682: @523517
     /*  523517 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(523588), // Rule ID 20778 //
     /*  523522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523554 */     // MIs[0] round
     /*  523554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523573 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523586 */     GIR_RootConstrainSelectedInstOperands,
     /*  523587 */     // GIR_Coverage, 20778,
     /*  523587 */     GIR_EraseRootFromParent_Done,
     /*  523588 */   // Label 8683: @523588
     /*  523588 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(523659), // Rule ID 20779 //
     /*  523593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523625 */     // MIs[0] round
     /*  523625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523635 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523644 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523657 */     GIR_RootConstrainSelectedInstOperands,
     /*  523658 */     // GIR_Coverage, 20779,
     /*  523658 */     GIR_EraseRootFromParent_Done,
     /*  523659 */   // Label 8684: @523659
     /*  523659 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(523730), // Rule ID 20782 //
     /*  523664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523696 */     // MIs[0] round
     /*  523696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523715 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523728 */     GIR_RootConstrainSelectedInstOperands,
     /*  523729 */     // GIR_Coverage, 20782,
     /*  523729 */     GIR_EraseRootFromParent_Done,
     /*  523730 */   // Label 8685: @523730
     /*  523730 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(523801), // Rule ID 20783 //
     /*  523735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523767 */     // MIs[0] round
     /*  523767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  523780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523786 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523799 */     GIR_RootConstrainSelectedInstOperands,
     /*  523800 */     // GIR_Coverage, 20783,
     /*  523800 */     GIR_EraseRootFromParent_Done,
     /*  523801 */   // Label 8686: @523801
     /*  523801 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(523872), // Rule ID 20786 //
     /*  523806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523838 */     // MIs[0] round
     /*  523838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523857 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523870 */     GIR_RootConstrainSelectedInstOperands,
     /*  523871 */     // GIR_Coverage, 20786,
     /*  523871 */     GIR_EraseRootFromParent_Done,
     /*  523872 */   // Label 8687: @523872
     /*  523872 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(523943), // Rule ID 20787 //
     /*  523877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523909 */     // MIs[0] round
     /*  523909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  523922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523928 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523941 */     GIR_RootConstrainSelectedInstOperands,
     /*  523942 */     // GIR_Coverage, 20787,
     /*  523942 */     GIR_EraseRootFromParent_Done,
     /*  523943 */   // Label 8688: @523943
     /*  523943 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(524014), // Rule ID 20790 //
     /*  523948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  523956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523980 */     // MIs[0] round
     /*  523980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  523993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523999 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524012 */     GIR_RootConstrainSelectedInstOperands,
     /*  524013 */     // GIR_Coverage, 20790,
     /*  524013 */     GIR_EraseRootFromParent_Done,
     /*  524014 */   // Label 8689: @524014
     /*  524014 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(524085), // Rule ID 20791 //
     /*  524019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524051 */     // MIs[0] round
     /*  524051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  524064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524070 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524083 */     GIR_RootConstrainSelectedInstOperands,
     /*  524084 */     // GIR_Coverage, 20791,
     /*  524084 */     GIR_EraseRootFromParent_Done,
     /*  524085 */   // Label 8690: @524085
     /*  524085 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(524156), // Rule ID 20794 //
     /*  524090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524122 */     // MIs[0] round
     /*  524122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  524135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524141 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524154 */     GIR_RootConstrainSelectedInstOperands,
     /*  524155 */     // GIR_Coverage, 20794,
     /*  524155 */     GIR_EraseRootFromParent_Done,
     /*  524156 */   // Label 8691: @524156
     /*  524156 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(524227), // Rule ID 20795 //
     /*  524161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524193 */     // MIs[0] round
     /*  524193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524203 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  524206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524212 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524225 */     GIR_RootConstrainSelectedInstOperands,
     /*  524226 */     // GIR_Coverage, 20795,
     /*  524226 */     GIR_EraseRootFromParent_Done,
     /*  524227 */   // Label 8692: @524227
     /*  524227 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(524298), // Rule ID 20798 //
     /*  524232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524264 */     // MIs[0] round
     /*  524264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  524277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524283 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524296 */     GIR_RootConstrainSelectedInstOperands,
     /*  524297 */     // GIR_Coverage, 20798,
     /*  524297 */     GIR_EraseRootFromParent_Done,
     /*  524298 */   // Label 8693: @524298
     /*  524298 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(524369), // Rule ID 20799 //
     /*  524303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  524311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524335 */     // MIs[0] round
     /*  524335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524345 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  524348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524354 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524367 */     GIR_RootConstrainSelectedInstOperands,
     /*  524368 */     // GIR_Coverage, 20799,
     /*  524368 */     GIR_EraseRootFromParent_Done,
     /*  524369 */   // Label 8694: @524369
     /*  524369 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(524440), // Rule ID 20802 //
     /*  524374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524406 */     // MIs[0] round
     /*  524406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  524419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524425 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524438 */     GIR_RootConstrainSelectedInstOperands,
     /*  524439 */     // GIR_Coverage, 20802,
     /*  524439 */     GIR_EraseRootFromParent_Done,
     /*  524440 */   // Label 8695: @524440
     /*  524440 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(524511), // Rule ID 20803 //
     /*  524445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524477 */     // MIs[0] round
     /*  524477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524487 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  524490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524496 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524509 */     GIR_RootConstrainSelectedInstOperands,
     /*  524510 */     // GIR_Coverage, 20803,
     /*  524510 */     GIR_EraseRootFromParent_Done,
     /*  524511 */   // Label 8696: @524511
     /*  524511 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(524582), // Rule ID 20806 //
     /*  524516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524548 */     // MIs[0] round
     /*  524548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524567 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524580 */     GIR_RootConstrainSelectedInstOperands,
     /*  524581 */     // GIR_Coverage, 20806,
     /*  524581 */     GIR_EraseRootFromParent_Done,
     /*  524582 */   // Label 8697: @524582
     /*  524582 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(524653), // Rule ID 20807 //
     /*  524587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524619 */     // MIs[0] round
     /*  524619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524629 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524638 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524651 */     GIR_RootConstrainSelectedInstOperands,
     /*  524652 */     // GIR_Coverage, 20807,
     /*  524652 */     GIR_EraseRootFromParent_Done,
     /*  524653 */   // Label 8698: @524653
     /*  524653 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(524724), // Rule ID 20810 //
     /*  524658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524690 */     // MIs[0] round
     /*  524690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524709 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524722 */     GIR_RootConstrainSelectedInstOperands,
     /*  524723 */     // GIR_Coverage, 20810,
     /*  524723 */     GIR_EraseRootFromParent_Done,
     /*  524724 */   // Label 8699: @524724
     /*  524724 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(524795), // Rule ID 20811 //
     /*  524729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524761 */     // MIs[0] round
     /*  524761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  524774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524780 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524793 */     GIR_RootConstrainSelectedInstOperands,
     /*  524794 */     // GIR_Coverage, 20811,
     /*  524794 */     GIR_EraseRootFromParent_Done,
     /*  524795 */   // Label 8700: @524795
     /*  524795 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(524866), // Rule ID 20814 //
     /*  524800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524832 */     // MIs[0] round
     /*  524832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524851 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524864 */     GIR_RootConstrainSelectedInstOperands,
     /*  524865 */     // GIR_Coverage, 20814,
     /*  524865 */     GIR_EraseRootFromParent_Done,
     /*  524866 */   // Label 8701: @524866
     /*  524866 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(524937), // Rule ID 20815 //
     /*  524871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524903 */     // MIs[0] round
     /*  524903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524913 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524922 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524935 */     GIR_RootConstrainSelectedInstOperands,
     /*  524936 */     // GIR_Coverage, 20815,
     /*  524936 */     GIR_EraseRootFromParent_Done,
     /*  524937 */   // Label 8702: @524937
     /*  524937 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(525008), // Rule ID 20818 //
     /*  524942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  524950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  524953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  524956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  524959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524974 */     // MIs[0] round
     /*  524974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  524987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524993 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525006 */     GIR_RootConstrainSelectedInstOperands,
     /*  525007 */     // GIR_Coverage, 20818,
     /*  525007 */     GIR_EraseRootFromParent_Done,
     /*  525008 */   // Label 8703: @525008
     /*  525008 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(525079), // Rule ID 20819 //
     /*  525013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525045 */     // MIs[0] round
     /*  525045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525064 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525077 */     GIR_RootConstrainSelectedInstOperands,
     /*  525078 */     // GIR_Coverage, 20819,
     /*  525078 */     GIR_EraseRootFromParent_Done,
     /*  525079 */   // Label 8704: @525079
     /*  525079 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(525150), // Rule ID 20822 //
     /*  525084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525116 */     // MIs[0] round
     /*  525116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525135 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525148 */     GIR_RootConstrainSelectedInstOperands,
     /*  525149 */     // GIR_Coverage, 20822,
     /*  525149 */     GIR_EraseRootFromParent_Done,
     /*  525150 */   // Label 8705: @525150
     /*  525150 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(525221), // Rule ID 20823 //
     /*  525155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525187 */     // MIs[0] round
     /*  525187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525197 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  525200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525206 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525219 */     GIR_RootConstrainSelectedInstOperands,
     /*  525220 */     // GIR_Coverage, 20823,
     /*  525220 */     GIR_EraseRootFromParent_Done,
     /*  525221 */   // Label 8706: @525221
     /*  525221 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(525292), // Rule ID 20826 //
     /*  525226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525258 */     // MIs[0] round
     /*  525258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525277 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525290 */     GIR_RootConstrainSelectedInstOperands,
     /*  525291 */     // GIR_Coverage, 20826,
     /*  525291 */     GIR_EraseRootFromParent_Done,
     /*  525292 */   // Label 8707: @525292
     /*  525292 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(525363), // Rule ID 20827 //
     /*  525297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525329 */     // MIs[0] round
     /*  525329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525348 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525361 */     GIR_RootConstrainSelectedInstOperands,
     /*  525362 */     // GIR_Coverage, 20827,
     /*  525362 */     GIR_EraseRootFromParent_Done,
     /*  525363 */   // Label 8708: @525363
     /*  525363 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(525434), // Rule ID 20830 //
     /*  525368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525400 */     // MIs[0] round
     /*  525400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525419 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525432 */     GIR_RootConstrainSelectedInstOperands,
     /*  525433 */     // GIR_Coverage, 20830,
     /*  525433 */     GIR_EraseRootFromParent_Done,
     /*  525434 */   // Label 8709: @525434
     /*  525434 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(525505), // Rule ID 20831 //
     /*  525439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525471 */     // MIs[0] round
     /*  525471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525490 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525503 */     GIR_RootConstrainSelectedInstOperands,
     /*  525504 */     // GIR_Coverage, 20831,
     /*  525504 */     GIR_EraseRootFromParent_Done,
     /*  525505 */   // Label 8710: @525505
     /*  525505 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(525576), // Rule ID 20834 //
     /*  525510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525542 */     // MIs[0] round
     /*  525542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525561 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525574 */     GIR_RootConstrainSelectedInstOperands,
     /*  525575 */     // GIR_Coverage, 20834,
     /*  525575 */     GIR_EraseRootFromParent_Done,
     /*  525576 */   // Label 8711: @525576
     /*  525576 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(525647), // Rule ID 20835 //
     /*  525581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525613 */     // MIs[0] round
     /*  525613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525632 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525645 */     GIR_RootConstrainSelectedInstOperands,
     /*  525646 */     // GIR_Coverage, 20835,
     /*  525646 */     GIR_EraseRootFromParent_Done,
     /*  525647 */   // Label 8712: @525647
     /*  525647 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(525718), // Rule ID 20838 //
     /*  525652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525684 */     // MIs[0] round
     /*  525684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525703 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525716 */     GIR_RootConstrainSelectedInstOperands,
     /*  525717 */     // GIR_Coverage, 20838,
     /*  525717 */     GIR_EraseRootFromParent_Done,
     /*  525718 */   // Label 8713: @525718
     /*  525718 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(525789), // Rule ID 20839 //
     /*  525723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525755 */     // MIs[0] round
     /*  525755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  525768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525774 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525787 */     GIR_RootConstrainSelectedInstOperands,
     /*  525788 */     // GIR_Coverage, 20839,
     /*  525788 */     GIR_EraseRootFromParent_Done,
     /*  525789 */   // Label 8714: @525789
     /*  525789 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(525860), // Rule ID 20842 //
     /*  525794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525826 */     // MIs[0] round
     /*  525826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525845 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525858 */     GIR_RootConstrainSelectedInstOperands,
     /*  525859 */     // GIR_Coverage, 20842,
     /*  525859 */     GIR_EraseRootFromParent_Done,
     /*  525860 */   // Label 8715: @525860
     /*  525860 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(525931), // Rule ID 20843 //
     /*  525865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525897 */     // MIs[0] round
     /*  525897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  525910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525916 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525929 */     GIR_RootConstrainSelectedInstOperands,
     /*  525930 */     // GIR_Coverage, 20843,
     /*  525930 */     GIR_EraseRootFromParent_Done,
     /*  525931 */   // Label 8716: @525931
     /*  525931 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(526002), // Rule ID 20846 //
     /*  525936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  525944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  525947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  525950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  525953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525968 */     // MIs[0] round
     /*  525968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  525981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525987 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526000 */     GIR_RootConstrainSelectedInstOperands,
     /*  526001 */     // GIR_Coverage, 20846,
     /*  526001 */     GIR_EraseRootFromParent_Done,
     /*  526002 */   // Label 8717: @526002
     /*  526002 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(526073), // Rule ID 20847 //
     /*  526007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526039 */     // MIs[0] round
     /*  526039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526049 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526058 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526071 */     GIR_RootConstrainSelectedInstOperands,
     /*  526072 */     // GIR_Coverage, 20847,
     /*  526072 */     GIR_EraseRootFromParent_Done,
     /*  526073 */   // Label 8718: @526073
     /*  526073 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(526144), // Rule ID 20850 //
     /*  526078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526110 */     // MIs[0] round
     /*  526110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  526123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526129 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526142 */     GIR_RootConstrainSelectedInstOperands,
     /*  526143 */     // GIR_Coverage, 20850,
     /*  526143 */     GIR_EraseRootFromParent_Done,
     /*  526144 */   // Label 8719: @526144
     /*  526144 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(526215), // Rule ID 20851 //
     /*  526149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526181 */     // MIs[0] round
     /*  526181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  526194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526200 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526213 */     GIR_RootConstrainSelectedInstOperands,
     /*  526214 */     // GIR_Coverage, 20851,
     /*  526214 */     GIR_EraseRootFromParent_Done,
     /*  526215 */   // Label 8720: @526215
     /*  526215 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(526286), // Rule ID 20854 //
     /*  526220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526252 */     // MIs[0] round
     /*  526252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526262 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  526265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526271 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526284 */     GIR_RootConstrainSelectedInstOperands,
     /*  526285 */     // GIR_Coverage, 20854,
     /*  526285 */     GIR_EraseRootFromParent_Done,
     /*  526286 */   // Label 8721: @526286
     /*  526286 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(526357), // Rule ID 20855 //
     /*  526291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526323 */     // MIs[0] round
     /*  526323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  526336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526342 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526355 */     GIR_RootConstrainSelectedInstOperands,
     /*  526356 */     // GIR_Coverage, 20855,
     /*  526356 */     GIR_EraseRootFromParent_Done,
     /*  526357 */   // Label 8722: @526357
     /*  526357 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(526428), // Rule ID 20858 //
     /*  526362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526394 */     // MIs[0] round
     /*  526394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526413 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526426 */     GIR_RootConstrainSelectedInstOperands,
     /*  526427 */     // GIR_Coverage, 20858,
     /*  526427 */     GIR_EraseRootFromParent_Done,
     /*  526428 */   // Label 8723: @526428
     /*  526428 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(526499), // Rule ID 20859 //
     /*  526433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  526441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526465 */     // MIs[0] round
     /*  526465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526475 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  526478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526484 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526497 */     GIR_RootConstrainSelectedInstOperands,
     /*  526498 */     // GIR_Coverage, 20859,
     /*  526498 */     GIR_EraseRootFromParent_Done,
     /*  526499 */   // Label 8724: @526499
     /*  526499 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(526570), // Rule ID 20982 //
     /*  526504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  526515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  526518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526536 */     // MIs[0] round
     /*  526536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526546 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  526549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526555 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526568 */     GIR_RootConstrainSelectedInstOperands,
     /*  526569 */     // GIR_Coverage, 20982,
     /*  526569 */     GIR_EraseRootFromParent_Done,
     /*  526570 */   // Label 8725: @526570
     /*  526570 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(526641), // Rule ID 20983 //
     /*  526575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  526586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  526589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526607 */     // MIs[0] round
     /*  526607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526617 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  526620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526626 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526639 */     GIR_RootConstrainSelectedInstOperands,
     /*  526640 */     // GIR_Coverage, 20983,
     /*  526640 */     GIR_EraseRootFromParent_Done,
     /*  526641 */   // Label 8726: @526641
     /*  526641 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(526712), // Rule ID 20986 //
     /*  526646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  526657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  526660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526678 */     // MIs[0] round
     /*  526678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526688 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  526691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526697 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526710 */     GIR_RootConstrainSelectedInstOperands,
     /*  526711 */     // GIR_Coverage, 20986,
     /*  526711 */     GIR_EraseRootFromParent_Done,
     /*  526712 */   // Label 8727: @526712
     /*  526712 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(526783), // Rule ID 20987 //
     /*  526717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  526728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  526731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526749 */     // MIs[0] round
     /*  526749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526759 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  526762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526768 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526781 */     GIR_RootConstrainSelectedInstOperands,
     /*  526782 */     // GIR_Coverage, 20987,
     /*  526782 */     GIR_EraseRootFromParent_Done,
     /*  526783 */   // Label 8728: @526783
     /*  526783 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(526854), // Rule ID 20990 //
     /*  526788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  526805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526820 */     // MIs[0] round
     /*  526820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526830 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  526833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526839 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526852 */     GIR_RootConstrainSelectedInstOperands,
     /*  526853 */     // GIR_Coverage, 20990,
     /*  526853 */     GIR_EraseRootFromParent_Done,
     /*  526854 */   // Label 8729: @526854
     /*  526854 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(526925), // Rule ID 20991 //
     /*  526859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  526876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526891 */     // MIs[0] round
     /*  526891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526901 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  526904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526910 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526923 */     GIR_RootConstrainSelectedInstOperands,
     /*  526924 */     // GIR_Coverage, 20991,
     /*  526924 */     GIR_EraseRootFromParent_Done,
     /*  526925 */   // Label 8730: @526925
     /*  526925 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(526996), // Rule ID 20994 //
     /*  526930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  526938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  526941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  526944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  526947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526962 */     // MIs[0] round
     /*  526962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526972 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  526975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526981 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526994 */     GIR_RootConstrainSelectedInstOperands,
     /*  526995 */     // GIR_Coverage, 20994,
     /*  526995 */     GIR_EraseRootFromParent_Done,
     /*  526996 */   // Label 8731: @526996
     /*  526996 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(527067), // Rule ID 20995 //
     /*  527001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  527012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  527015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527033 */     // MIs[0] round
     /*  527033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527043 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  527046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527052 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527065 */     GIR_RootConstrainSelectedInstOperands,
     /*  527066 */     // GIR_Coverage, 20995,
     /*  527066 */     GIR_EraseRootFromParent_Done,
     /*  527067 */   // Label 8732: @527067
     /*  527067 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(527138), // Rule ID 20998 //
     /*  527072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527104 */     // MIs[0] round
     /*  527104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  527117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527123 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527136 */     GIR_RootConstrainSelectedInstOperands,
     /*  527137 */     // GIR_Coverage, 20998,
     /*  527137 */     GIR_EraseRootFromParent_Done,
     /*  527138 */   // Label 8733: @527138
     /*  527138 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(527209), // Rule ID 20999 //
     /*  527143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527175 */     // MIs[0] round
     /*  527175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527185 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  527188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527194 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527207 */     GIR_RootConstrainSelectedInstOperands,
     /*  527208 */     // GIR_Coverage, 20999,
     /*  527208 */     GIR_EraseRootFromParent_Done,
     /*  527209 */   // Label 8734: @527209
     /*  527209 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(527280), // Rule ID 21002 //
     /*  527214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  527217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  527231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527246 */     // MIs[0] round
     /*  527246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  527256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  527259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527265 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527278 */     GIR_RootConstrainSelectedInstOperands,
     /*  527279 */     // GIR_Coverage, 21002,
     /*  527279 */     GIR_EraseRootFromParent_Done,
     /*  527280 */   // Label 8735: @527280
     /*  527280 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(527351), // Rule ID 21003 //
     /*  527285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  527288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  527302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527317 */     // MIs[0] round
     /*  527317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527327 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  527327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  527330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527336 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  527346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527349 */     GIR_RootConstrainSelectedInstOperands,
     /*  527350 */     // GIR_Coverage, 21003,
     /*  527350 */     GIR_EraseRootFromParent_Done,
     /*  527351 */   // Label 8736: @527351
     /*  527351 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(527422), // Rule ID 21006 //
     /*  527356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  527367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  527370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527388 */     // MIs[0] round
     /*  527388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527398 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  527401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527407 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527420 */     GIR_RootConstrainSelectedInstOperands,
     /*  527421 */     // GIR_Coverage, 21006,
     /*  527421 */     GIR_EraseRootFromParent_Done,
     /*  527422 */   // Label 8737: @527422
     /*  527422 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(527493), // Rule ID 21007 //
     /*  527427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  527438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  527441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527459 */     // MIs[0] round
     /*  527459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527469 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  527472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527478 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527491 */     GIR_RootConstrainSelectedInstOperands,
     /*  527492 */     // GIR_Coverage, 21007,
     /*  527492 */     GIR_EraseRootFromParent_Done,
     /*  527493 */   // Label 8738: @527493
     /*  527493 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(527564), // Rule ID 21010 //
     /*  527498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  527509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  527512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527530 */     // MIs[0] round
     /*  527530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  527543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527549 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527562 */     GIR_RootConstrainSelectedInstOperands,
     /*  527563 */     // GIR_Coverage, 21010,
     /*  527563 */     GIR_EraseRootFromParent_Done,
     /*  527564 */   // Label 8739: @527564
     /*  527564 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(527635), // Rule ID 21011 //
     /*  527569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  527580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  527583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527601 */     // MIs[0] round
     /*  527601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527611 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  527614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527620 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527633 */     GIR_RootConstrainSelectedInstOperands,
     /*  527634 */     // GIR_Coverage, 21011,
     /*  527634 */     GIR_EraseRootFromParent_Done,
     /*  527635 */   // Label 8740: @527635
     /*  527635 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(527706), // Rule ID 21014 //
     /*  527640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  527651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  527654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  527657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527672 */     // MIs[0] round
     /*  527672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527682 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  527685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527691 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527704 */     GIR_RootConstrainSelectedInstOperands,
     /*  527705 */     // GIR_Coverage, 21014,
     /*  527705 */     GIR_EraseRootFromParent_Done,
     /*  527706 */   // Label 8741: @527706
     /*  527706 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(527777), // Rule ID 21015 //
     /*  527711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  527722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  527725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  527728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527743 */     // MIs[0] round
     /*  527743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527753 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  527756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527762 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527775 */     GIR_RootConstrainSelectedInstOperands,
     /*  527776 */     // GIR_Coverage, 21015,
     /*  527776 */     GIR_EraseRootFromParent_Done,
     /*  527777 */   // Label 8742: @527777
     /*  527777 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(527848), // Rule ID 21018 //
     /*  527782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527814 */     // MIs[0] round
     /*  527814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  527827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527833 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527846 */     GIR_RootConstrainSelectedInstOperands,
     /*  527847 */     // GIR_Coverage, 21018,
     /*  527847 */     GIR_EraseRootFromParent_Done,
     /*  527848 */   // Label 8743: @527848
     /*  527848 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(527919), // Rule ID 21019 //
     /*  527853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527885 */     // MIs[0] round
     /*  527885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527895 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  527898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527904 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527917 */     GIR_RootConstrainSelectedInstOperands,
     /*  527918 */     // GIR_Coverage, 21019,
     /*  527918 */     GIR_EraseRootFromParent_Done,
     /*  527919 */   // Label 8744: @527919
     /*  527919 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(527990), // Rule ID 21022 //
     /*  527924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  527927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  527932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  527941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527956 */     // MIs[0] round
     /*  527956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527966 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  527969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527975 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527988 */     GIR_RootConstrainSelectedInstOperands,
     /*  527989 */     // GIR_Coverage, 21022,
     /*  527989 */     GIR_EraseRootFromParent_Done,
     /*  527990 */   // Label 8745: @527990
     /*  527990 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(528061), // Rule ID 21023 //
     /*  527995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  527998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528027 */     // MIs[0] round
     /*  528027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528037 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  528040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528046 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528059 */     GIR_RootConstrainSelectedInstOperands,
     /*  528060 */     // GIR_Coverage, 21023,
     /*  528060 */     GIR_EraseRootFromParent_Done,
     /*  528061 */   // Label 8746: @528061
     /*  528061 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(528132), // Rule ID 21026 //
     /*  528066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  528069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  528083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528098 */     // MIs[0] round
     /*  528098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528108 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  528111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528117 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528130 */     GIR_RootConstrainSelectedInstOperands,
     /*  528131 */     // GIR_Coverage, 21026,
     /*  528131 */     GIR_EraseRootFromParent_Done,
     /*  528132 */   // Label 8747: @528132
     /*  528132 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(528203), // Rule ID 21027 //
     /*  528137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  528140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  528154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528169 */     // MIs[0] round
     /*  528169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528179 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  528182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528188 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528201 */     GIR_RootConstrainSelectedInstOperands,
     /*  528202 */     // GIR_Coverage, 21027,
     /*  528202 */     GIR_EraseRootFromParent_Done,
     /*  528203 */   // Label 8748: @528203
     /*  528203 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(528274), // Rule ID 21030 //
     /*  528208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  528225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528240 */     // MIs[0] round
     /*  528240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  528253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528259 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528272 */     GIR_RootConstrainSelectedInstOperands,
     /*  528273 */     // GIR_Coverage, 21030,
     /*  528273 */     GIR_EraseRootFromParent_Done,
     /*  528274 */   // Label 8749: @528274
     /*  528274 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(528345), // Rule ID 21031 //
     /*  528279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  528296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528311 */     // MIs[0] round
     /*  528311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528321 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  528324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528330 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528343 */     GIR_RootConstrainSelectedInstOperands,
     /*  528344 */     // GIR_Coverage, 21031,
     /*  528344 */     GIR_EraseRootFromParent_Done,
     /*  528345 */   // Label 8750: @528345
     /*  528345 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(528416), // Rule ID 21034 //
     /*  528350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  528367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528382 */     // MIs[0] round
     /*  528382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528392 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  528395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528401 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528414 */     GIR_RootConstrainSelectedInstOperands,
     /*  528415 */     // GIR_Coverage, 21034,
     /*  528415 */     GIR_EraseRootFromParent_Done,
     /*  528416 */   // Label 8751: @528416
     /*  528416 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(528487), // Rule ID 21035 //
     /*  528421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  528438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528453 */     // MIs[0] round
     /*  528453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528463 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  528466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528472 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528485 */     GIR_RootConstrainSelectedInstOperands,
     /*  528486 */     // GIR_Coverage, 21035,
     /*  528486 */     GIR_EraseRootFromParent_Done,
     /*  528487 */   // Label 8752: @528487
     /*  528487 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(528558), // Rule ID 21038 //
     /*  528492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  528495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  528509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528524 */     // MIs[0] round
     /*  528524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528534 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  528534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  528537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528543 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528556 */     GIR_RootConstrainSelectedInstOperands,
     /*  528557 */     // GIR_Coverage, 21038,
     /*  528557 */     GIR_EraseRootFromParent_Done,
     /*  528558 */   // Label 8753: @528558
     /*  528558 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(528629), // Rule ID 21039 //
     /*  528563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  528566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  528571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  528580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528595 */     // MIs[0] round
     /*  528595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528605 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  528605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  528608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528614 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  528624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528627 */     GIR_RootConstrainSelectedInstOperands,
     /*  528628 */     // GIR_Coverage, 21039,
     /*  528628 */     GIR_EraseRootFromParent_Done,
     /*  528629 */   // Label 8754: @528629
     /*  528629 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(528700), // Rule ID 21042 //
     /*  528634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  528645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  528648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528666 */     // MIs[0] round
     /*  528666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528676 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  528679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528685 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528698 */     GIR_RootConstrainSelectedInstOperands,
     /*  528699 */     // GIR_Coverage, 21042,
     /*  528699 */     GIR_EraseRootFromParent_Done,
     /*  528700 */   // Label 8755: @528700
     /*  528700 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(528771), // Rule ID 21043 //
     /*  528705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  528716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  528719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528737 */     // MIs[0] round
     /*  528737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528747 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  528750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528756 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528769 */     GIR_RootConstrainSelectedInstOperands,
     /*  528770 */     // GIR_Coverage, 21043,
     /*  528770 */     GIR_EraseRootFromParent_Done,
     /*  528771 */   // Label 8756: @528771
     /*  528771 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(528842), // Rule ID 21046 //
     /*  528776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  528787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  528790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528808 */     // MIs[0] round
     /*  528808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528818 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  528821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528827 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528840 */     GIR_RootConstrainSelectedInstOperands,
     /*  528841 */     // GIR_Coverage, 21046,
     /*  528841 */     GIR_EraseRootFromParent_Done,
     /*  528842 */   // Label 8757: @528842
     /*  528842 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(528913), // Rule ID 21047 //
     /*  528847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  528858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  528861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528879 */     // MIs[0] round
     /*  528879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528889 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  528892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528898 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528911 */     GIR_RootConstrainSelectedInstOperands,
     /*  528912 */     // GIR_Coverage, 21047,
     /*  528912 */     GIR_EraseRootFromParent_Done,
     /*  528913 */   // Label 8758: @528913
     /*  528913 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(528984), // Rule ID 21050 //
     /*  528918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  528921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528950 */     // MIs[0] round
     /*  528950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528960 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  528963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528969 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528982 */     GIR_RootConstrainSelectedInstOperands,
     /*  528983 */     // GIR_Coverage, 21050,
     /*  528983 */     GIR_EraseRootFromParent_Done,
     /*  528984 */   // Label 8759: @528984
     /*  528984 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(529055), // Rule ID 21051 //
     /*  528989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  528992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  528997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  529000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  529003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529021 */     // MIs[0] round
     /*  529021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529031 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  529034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529040 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529053 */     GIR_RootConstrainSelectedInstOperands,
     /*  529054 */     // GIR_Coverage, 21051,
     /*  529054 */     GIR_EraseRootFromParent_Done,
     /*  529055 */   // Label 8760: @529055
     /*  529055 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(529126), // Rule ID 21054 //
     /*  529060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  529071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  529074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529092 */     // MIs[0] round
     /*  529092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  529105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529111 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529124 */     GIR_RootConstrainSelectedInstOperands,
     /*  529125 */     // GIR_Coverage, 21054,
     /*  529125 */     GIR_EraseRootFromParent_Done,
     /*  529126 */   // Label 8761: @529126
     /*  529126 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(529197), // Rule ID 21055 //
     /*  529131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  529142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  529145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529163 */     // MIs[0] round
     /*  529163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529173 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  529176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529182 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529195 */     GIR_RootConstrainSelectedInstOperands,
     /*  529196 */     // GIR_Coverage, 21055,
     /*  529196 */     GIR_EraseRootFromParent_Done,
     /*  529197 */   // Label 8762: @529197
     /*  529197 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(529268), // Rule ID 21058 //
     /*  529202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  529213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  529216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529234 */     // MIs[0] round
     /*  529234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  529247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529253 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529266 */     GIR_RootConstrainSelectedInstOperands,
     /*  529267 */     // GIR_Coverage, 21058,
     /*  529267 */     GIR_EraseRootFromParent_Done,
     /*  529268 */   // Label 8763: @529268
     /*  529268 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(529339), // Rule ID 21059 //
     /*  529273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  529276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  529284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  529287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529305 */     // MIs[0] round
     /*  529305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529315 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  529318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529324 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529337 */     GIR_RootConstrainSelectedInstOperands,
     /*  529338 */     // GIR_Coverage, 21059,
     /*  529338 */     GIR_EraseRootFromParent_Done,
     /*  529339 */   // Label 8764: @529339
     /*  529339 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(529410), // Rule ID 21062 //
     /*  529344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  529347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  529361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529376 */     // MIs[0] round
     /*  529376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529386 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  529386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  529389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529395 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  529405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529408 */     GIR_RootConstrainSelectedInstOperands,
     /*  529409 */     // GIR_Coverage, 21062,
     /*  529409 */     GIR_EraseRootFromParent_Done,
     /*  529410 */   // Label 8765: @529410
     /*  529410 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(529481), // Rule ID 21063 //
     /*  529415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  529418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  529426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  529429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  529432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529447 */     // MIs[0] round
     /*  529447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529457 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  529457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  529460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529466 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  529476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529479 */     GIR_RootConstrainSelectedInstOperands,
     /*  529480 */     // GIR_Coverage, 21063,
     /*  529480 */     GIR_EraseRootFromParent_Done,
     /*  529481 */   // Label 8766: @529481
     /*  529481 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(529552), // Rule ID 21066 //
     /*  529486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529518 */     // MIs[0] round
     /*  529518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529528 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  529531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529537 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529550 */     GIR_RootConstrainSelectedInstOperands,
     /*  529551 */     // GIR_Coverage, 21066,
     /*  529551 */     GIR_EraseRootFromParent_Done,
     /*  529552 */   // Label 8767: @529552
     /*  529552 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(529623), // Rule ID 21067 //
     /*  529557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  529568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  529571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529589 */     // MIs[0] round
     /*  529589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529599 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  529602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529608 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529621 */     GIR_RootConstrainSelectedInstOperands,
     /*  529622 */     // GIR_Coverage, 21067,
     /*  529622 */     GIR_EraseRootFromParent_Done,
     /*  529623 */   // Label 8768: @529623
     /*  529623 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(529694), // Rule ID 21070 //
     /*  529628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529660 */     // MIs[0] round
     /*  529660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529670 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  529673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529679 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529692 */     GIR_RootConstrainSelectedInstOperands,
     /*  529693 */     // GIR_Coverage, 21070,
     /*  529693 */     GIR_EraseRootFromParent_Done,
     /*  529694 */   // Label 8769: @529694
     /*  529694 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(529765), // Rule ID 21071 //
     /*  529699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  529710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  529713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529731 */     // MIs[0] round
     /*  529731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529741 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  529744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529750 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529763 */     GIR_RootConstrainSelectedInstOperands,
     /*  529764 */     // GIR_Coverage, 21071,
     /*  529764 */     GIR_EraseRootFromParent_Done,
     /*  529765 */   // Label 8770: @529765
     /*  529765 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(529836), // Rule ID 21074 //
     /*  529770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529802 */     // MIs[0] round
     /*  529802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529812 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  529815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529821 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529834 */     GIR_RootConstrainSelectedInstOperands,
     /*  529835 */     // GIR_Coverage, 21074,
     /*  529835 */     GIR_EraseRootFromParent_Done,
     /*  529836 */   // Label 8771: @529836
     /*  529836 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(529907), // Rule ID 21075 //
     /*  529841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  529852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  529855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529873 */     // MIs[0] round
     /*  529873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  529886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529892 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529905 */     GIR_RootConstrainSelectedInstOperands,
     /*  529906 */     // GIR_Coverage, 21075,
     /*  529906 */     GIR_EraseRootFromParent_Done,
     /*  529907 */   // Label 8772: @529907
     /*  529907 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(529978), // Rule ID 21078 //
     /*  529912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529944 */     // MIs[0] round
     /*  529944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  529957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529963 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529976 */     GIR_RootConstrainSelectedInstOperands,
     /*  529977 */     // GIR_Coverage, 21078,
     /*  529977 */     GIR_EraseRootFromParent_Done,
     /*  529978 */   // Label 8773: @529978
     /*  529978 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(530049), // Rule ID 21079 //
     /*  529983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  529986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  529991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  529994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  529997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530015 */     // MIs[0] round
     /*  530015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  530028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530034 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530047 */     GIR_RootConstrainSelectedInstOperands,
     /*  530048 */     // GIR_Coverage, 21079,
     /*  530048 */     GIR_EraseRootFromParent_Done,
     /*  530049 */   // Label 8774: @530049
     /*  530049 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(530120), // Rule ID 21082 //
     /*  530054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  530065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  530068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530086 */     // MIs[0] round
     /*  530086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  530099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530105 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530118 */     GIR_RootConstrainSelectedInstOperands,
     /*  530119 */     // GIR_Coverage, 21082,
     /*  530119 */     GIR_EraseRootFromParent_Done,
     /*  530120 */   // Label 8775: @530120
     /*  530120 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(530191), // Rule ID 21083 //
     /*  530125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  530136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  530139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530157 */     // MIs[0] round
     /*  530157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530167 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  530170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530176 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530189 */     GIR_RootConstrainSelectedInstOperands,
     /*  530190 */     // GIR_Coverage, 21083,
     /*  530190 */     GIR_EraseRootFromParent_Done,
     /*  530191 */   // Label 8776: @530191
     /*  530191 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(530262), // Rule ID 21086 //
     /*  530196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  530207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  530210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530228 */     // MIs[0] round
     /*  530228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  530241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530247 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530260 */     GIR_RootConstrainSelectedInstOperands,
     /*  530261 */     // GIR_Coverage, 21086,
     /*  530261 */     GIR_EraseRootFromParent_Done,
     /*  530262 */   // Label 8777: @530262
     /*  530262 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(530333), // Rule ID 21087 //
     /*  530267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  530278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  530281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530299 */     // MIs[0] round
     /*  530299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530309 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  530312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530318 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530331 */     GIR_RootConstrainSelectedInstOperands,
     /*  530332 */     // GIR_Coverage, 21087,
     /*  530332 */     GIR_EraseRootFromParent_Done,
     /*  530333 */   // Label 8778: @530333
     /*  530333 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(530404), // Rule ID 21090 //
     /*  530338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530370 */     // MIs[0] round
     /*  530370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530380 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  530383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530389 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530402 */     GIR_RootConstrainSelectedInstOperands,
     /*  530403 */     // GIR_Coverage, 21090,
     /*  530403 */     GIR_EraseRootFromParent_Done,
     /*  530404 */   // Label 8779: @530404
     /*  530404 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(530475), // Rule ID 21091 //
     /*  530409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  530420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  530423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530441 */     // MIs[0] round
     /*  530441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  530454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530460 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530473 */     GIR_RootConstrainSelectedInstOperands,
     /*  530474 */     // GIR_Coverage, 21091,
     /*  530474 */     GIR_EraseRootFromParent_Done,
     /*  530475 */   // Label 8780: @530475
     /*  530475 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(530546), // Rule ID 21094 //
     /*  530480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530512 */     // MIs[0] round
     /*  530512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530522 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  530525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530531 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530544 */     GIR_RootConstrainSelectedInstOperands,
     /*  530545 */     // GIR_Coverage, 21094,
     /*  530545 */     GIR_EraseRootFromParent_Done,
     /*  530546 */   // Label 8781: @530546
     /*  530546 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(530617), // Rule ID 21095 //
     /*  530551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  530562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  530565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530583 */     // MIs[0] round
     /*  530583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530593 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  530596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530602 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530615 */     GIR_RootConstrainSelectedInstOperands,
     /*  530616 */     // GIR_Coverage, 21095,
     /*  530616 */     GIR_EraseRootFromParent_Done,
     /*  530617 */   // Label 8782: @530617
     /*  530617 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(530688), // Rule ID 21098 //
     /*  530622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  530625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530654 */     // MIs[0] round
     /*  530654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  530664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  530667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530673 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530686 */     GIR_RootConstrainSelectedInstOperands,
     /*  530687 */     // GIR_Coverage, 21098,
     /*  530687 */     GIR_EraseRootFromParent_Done,
     /*  530688 */   // Label 8783: @530688
     /*  530688 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(530759), // Rule ID 21099 //
     /*  530693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  530696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  530701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  530704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  530707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530725 */     // MIs[0] round
     /*  530725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530735 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  530735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  530738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530744 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  530754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530757 */     GIR_RootConstrainSelectedInstOperands,
     /*  530758 */     // GIR_Coverage, 21099,
     /*  530758 */     GIR_EraseRootFromParent_Done,
     /*  530759 */   // Label 8784: @530759
     /*  530759 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(530830), // Rule ID 21174 //
     /*  530764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530796 */     // MIs[0] round
     /*  530796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  530809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530815 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530828 */     GIR_RootConstrainSelectedInstOperands,
     /*  530829 */     // GIR_Coverage, 21174,
     /*  530829 */     GIR_EraseRootFromParent_Done,
     /*  530830 */   // Label 8785: @530830
     /*  530830 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(530901), // Rule ID 21175 //
     /*  530835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  530852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530867 */     // MIs[0] round
     /*  530867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  530880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530886 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530899 */     GIR_RootConstrainSelectedInstOperands,
     /*  530900 */     // GIR_Coverage, 21175,
     /*  530900 */     GIR_EraseRootFromParent_Done,
     /*  530901 */   // Label 8786: @530901
     /*  530901 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(530972), // Rule ID 21178 //
     /*  530906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530938 */     // MIs[0] round
     /*  530938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  530951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530957 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530970 */     GIR_RootConstrainSelectedInstOperands,
     /*  530971 */     // GIR_Coverage, 21178,
     /*  530971 */     GIR_EraseRootFromParent_Done,
     /*  530972 */   // Label 8787: @530972
     /*  530972 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(531043), // Rule ID 21179 //
     /*  530977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  530985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  530994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531009 */     // MIs[0] round
     /*  531009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531028 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531041 */     GIR_RootConstrainSelectedInstOperands,
     /*  531042 */     // GIR_Coverage, 21179,
     /*  531042 */     GIR_EraseRootFromParent_Done,
     /*  531043 */   // Label 8788: @531043
     /*  531043 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(531114), // Rule ID 21182 //
     /*  531048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531080 */     // MIs[0] round
     /*  531080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531099 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531112 */     GIR_RootConstrainSelectedInstOperands,
     /*  531113 */     // GIR_Coverage, 21182,
     /*  531113 */     GIR_EraseRootFromParent_Done,
     /*  531114 */   // Label 8789: @531114
     /*  531114 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(531185), // Rule ID 21183 //
     /*  531119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531151 */     // MIs[0] round
     /*  531151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531170 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531183 */     GIR_RootConstrainSelectedInstOperands,
     /*  531184 */     // GIR_Coverage, 21183,
     /*  531184 */     GIR_EraseRootFromParent_Done,
     /*  531185 */   // Label 8790: @531185
     /*  531185 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(531256), // Rule ID 21186 //
     /*  531190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531222 */     // MIs[0] round
     /*  531222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531241 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531254 */     GIR_RootConstrainSelectedInstOperands,
     /*  531255 */     // GIR_Coverage, 21186,
     /*  531255 */     GIR_EraseRootFromParent_Done,
     /*  531256 */   // Label 8791: @531256
     /*  531256 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(531327), // Rule ID 21187 //
     /*  531261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531293 */     // MIs[0] round
     /*  531293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531303 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531312 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531325 */     GIR_RootConstrainSelectedInstOperands,
     /*  531326 */     // GIR_Coverage, 21187,
     /*  531326 */     GIR_EraseRootFromParent_Done,
     /*  531327 */   // Label 8792: @531327
     /*  531327 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(531398), // Rule ID 21190 //
     /*  531332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  531343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  531346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531364 */     // MIs[0] round
     /*  531364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531374 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531383 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531396 */     GIR_RootConstrainSelectedInstOperands,
     /*  531397 */     // GIR_Coverage, 21190,
     /*  531397 */     GIR_EraseRootFromParent_Done,
     /*  531398 */   // Label 8793: @531398
     /*  531398 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(531469), // Rule ID 21191 //
     /*  531403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  531414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  531417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531435 */     // MIs[0] round
     /*  531435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531445 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531454 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531467 */     GIR_RootConstrainSelectedInstOperands,
     /*  531468 */     // GIR_Coverage, 21191,
     /*  531468 */     GIR_EraseRootFromParent_Done,
     /*  531469 */   // Label 8794: @531469
     /*  531469 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(531540), // Rule ID 21194 //
     /*  531474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531506 */     // MIs[0] round
     /*  531506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531525 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531538 */     GIR_RootConstrainSelectedInstOperands,
     /*  531539 */     // GIR_Coverage, 21194,
     /*  531539 */     GIR_EraseRootFromParent_Done,
     /*  531540 */   // Label 8795: @531540
     /*  531540 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(531611), // Rule ID 21195 //
     /*  531545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  531556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  531559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531577 */     // MIs[0] round
     /*  531577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531587 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  531590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531596 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531609 */     GIR_RootConstrainSelectedInstOperands,
     /*  531610 */     // GIR_Coverage, 21195,
     /*  531610 */     GIR_EraseRootFromParent_Done,
     /*  531611 */   // Label 8796: @531611
     /*  531611 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(531682), // Rule ID 21198 //
     /*  531616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  531627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  531630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531648 */     // MIs[0] round
     /*  531648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531667 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531680 */     GIR_RootConstrainSelectedInstOperands,
     /*  531681 */     // GIR_Coverage, 21198,
     /*  531681 */     GIR_EraseRootFromParent_Done,
     /*  531682 */   // Label 8797: @531682
     /*  531682 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(531753), // Rule ID 21199 //
     /*  531687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  531698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  531701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  531704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531719 */     // MIs[0] round
     /*  531719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  531732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531738 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531751 */     GIR_RootConstrainSelectedInstOperands,
     /*  531752 */     // GIR_Coverage, 21199,
     /*  531752 */     GIR_EraseRootFromParent_Done,
     /*  531753 */   // Label 8798: @531753
     /*  531753 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(531824), // Rule ID 21202 //
     /*  531758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  531769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  531772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531790 */     // MIs[0] round
     /*  531790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531809 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531822 */     GIR_RootConstrainSelectedInstOperands,
     /*  531823 */     // GIR_Coverage, 21202,
     /*  531823 */     GIR_EraseRootFromParent_Done,
     /*  531824 */   // Label 8799: @531824
     /*  531824 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(531895), // Rule ID 21203 //
     /*  531829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  531840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  531843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  531846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531861 */     // MIs[0] round
     /*  531861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  531874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531880 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531893 */     GIR_RootConstrainSelectedInstOperands,
     /*  531894 */     // GIR_Coverage, 21203,
     /*  531894 */     GIR_EraseRootFromParent_Done,
     /*  531895 */   // Label 8800: @531895
     /*  531895 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(531966), // Rule ID 21206 //
     /*  531900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  531903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  531911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  531914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531932 */     // MIs[0] round
     /*  531932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  531945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531951 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531964 */     GIR_RootConstrainSelectedInstOperands,
     /*  531965 */     // GIR_Coverage, 21206,
     /*  531965 */     GIR_EraseRootFromParent_Done,
     /*  531966 */   // Label 8801: @531966
     /*  531966 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(532037), // Rule ID 21207 //
     /*  531971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  531974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  531979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  531982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  531985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  531988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532003 */     // MIs[0] round
     /*  532003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532013 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  532016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532022 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532035 */     GIR_RootConstrainSelectedInstOperands,
     /*  532036 */     // GIR_Coverage, 21207,
     /*  532036 */     GIR_EraseRootFromParent_Done,
     /*  532037 */   // Label 8802: @532037
     /*  532037 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(532108), // Rule ID 21210 //
     /*  532042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532074 */     // MIs[0] round
     /*  532074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  532087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532093 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532106 */     GIR_RootConstrainSelectedInstOperands,
     /*  532107 */     // GIR_Coverage, 21210,
     /*  532107 */     GIR_EraseRootFromParent_Done,
     /*  532108 */   // Label 8803: @532108
     /*  532108 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(532179), // Rule ID 21211 //
     /*  532113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  532130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532145 */     // MIs[0] round
     /*  532145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532155 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  532158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532164 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532177 */     GIR_RootConstrainSelectedInstOperands,
     /*  532178 */     // GIR_Coverage, 21211,
     /*  532178 */     GIR_EraseRootFromParent_Done,
     /*  532179 */   // Label 8804: @532179
     /*  532179 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(532250), // Rule ID 21214 //
     /*  532184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532216 */     // MIs[0] round
     /*  532216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532235 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532248 */     GIR_RootConstrainSelectedInstOperands,
     /*  532249 */     // GIR_Coverage, 21214,
     /*  532249 */     GIR_EraseRootFromParent_Done,
     /*  532250 */   // Label 8805: @532250
     /*  532250 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(532321), // Rule ID 21215 //
     /*  532255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  532272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532287 */     // MIs[0] round
     /*  532287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532297 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532306 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532319 */     GIR_RootConstrainSelectedInstOperands,
     /*  532320 */     // GIR_Coverage, 21215,
     /*  532320 */     GIR_EraseRootFromParent_Done,
     /*  532321 */   // Label 8806: @532321
     /*  532321 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(532392), // Rule ID 21218 //
     /*  532326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532358 */     // MIs[0] round
     /*  532358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532377 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532390 */     GIR_RootConstrainSelectedInstOperands,
     /*  532391 */     // GIR_Coverage, 21218,
     /*  532391 */     GIR_EraseRootFromParent_Done,
     /*  532392 */   // Label 8807: @532392
     /*  532392 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(532463), // Rule ID 21219 //
     /*  532397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  532414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532429 */     // MIs[0] round
     /*  532429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532448 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532461 */     GIR_RootConstrainSelectedInstOperands,
     /*  532462 */     // GIR_Coverage, 21219,
     /*  532462 */     GIR_EraseRootFromParent_Done,
     /*  532463 */   // Label 8808: @532463
     /*  532463 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(532534), // Rule ID 21222 //
     /*  532468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532500 */     // MIs[0] round
     /*  532500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  532513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532519 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532532 */     GIR_RootConstrainSelectedInstOperands,
     /*  532533 */     // GIR_Coverage, 21222,
     /*  532533 */     GIR_EraseRootFromParent_Done,
     /*  532534 */   // Label 8809: @532534
     /*  532534 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(532605), // Rule ID 21223 //
     /*  532539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  532550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  532553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532571 */     // MIs[0] round
     /*  532571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532581 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  532584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532590 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532603 */     GIR_RootConstrainSelectedInstOperands,
     /*  532604 */     // GIR_Coverage, 21223,
     /*  532604 */     GIR_EraseRootFromParent_Done,
     /*  532605 */   // Label 8810: @532605
     /*  532605 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(532676), // Rule ID 21226 //
     /*  532610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  532621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  532624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532642 */     // MIs[0] round
     /*  532642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  532655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532661 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532674 */     GIR_RootConstrainSelectedInstOperands,
     /*  532675 */     // GIR_Coverage, 21226,
     /*  532675 */     GIR_EraseRootFromParent_Done,
     /*  532676 */   // Label 8811: @532676
     /*  532676 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(532747), // Rule ID 21227 //
     /*  532681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  532692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  532695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532713 */     // MIs[0] round
     /*  532713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  532726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532732 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532745 */     GIR_RootConstrainSelectedInstOperands,
     /*  532746 */     // GIR_Coverage, 21227,
     /*  532746 */     GIR_EraseRootFromParent_Done,
     /*  532747 */   // Label 8812: @532747
     /*  532747 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(532818), // Rule ID 21230 //
     /*  532752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  532755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  532763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  532766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532784 */     // MIs[0] round
     /*  532784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532803 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532816 */     GIR_RootConstrainSelectedInstOperands,
     /*  532817 */     // GIR_Coverage, 21230,
     /*  532817 */     GIR_EraseRootFromParent_Done,
     /*  532818 */   // Label 8813: @532818
     /*  532818 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(532889), // Rule ID 21231 //
     /*  532823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  532826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  532834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  532837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532855 */     // MIs[0] round
     /*  532855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  532868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532874 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532887 */     GIR_RootConstrainSelectedInstOperands,
     /*  532888 */     // GIR_Coverage, 21231,
     /*  532888 */     GIR_EraseRootFromParent_Done,
     /*  532889 */   // Label 8814: @532889
     /*  532889 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(532960), // Rule ID 21234 //
     /*  532894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  532897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  532905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  532908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532926 */     // MIs[0] round
     /*  532926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  532939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532945 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532958 */     GIR_RootConstrainSelectedInstOperands,
     /*  532959 */     // GIR_Coverage, 21234,
     /*  532959 */     GIR_EraseRootFromParent_Done,
     /*  532960 */   // Label 8815: @532960
     /*  532960 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(533031), // Rule ID 21235 //
     /*  532965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  532968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  532973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  532976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  532979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532997 */     // MIs[0] round
     /*  532997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  533010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533016 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533029 */     GIR_RootConstrainSelectedInstOperands,
     /*  533030 */     // GIR_Coverage, 21235,
     /*  533030 */     GIR_EraseRootFromParent_Done,
     /*  533031 */   // Label 8816: @533031
     /*  533031 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(533102), // Rule ID 21238 //
     /*  533036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  533039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533068 */     // MIs[0] round
     /*  533068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  533081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533087 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533100 */     GIR_RootConstrainSelectedInstOperands,
     /*  533101 */     // GIR_Coverage, 21238,
     /*  533101 */     GIR_EraseRootFromParent_Done,
     /*  533102 */   // Label 8817: @533102
     /*  533102 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(533173), // Rule ID 21239 //
     /*  533107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  533110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  533118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  533121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533139 */     // MIs[0] round
     /*  533139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  533152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533158 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533171 */     GIR_RootConstrainSelectedInstOperands,
     /*  533172 */     // GIR_Coverage, 21239,
     /*  533172 */     GIR_EraseRootFromParent_Done,
     /*  533173 */   // Label 8818: @533173
     /*  533173 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(533244), // Rule ID 21242 //
     /*  533178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  533181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533210 */     // MIs[0] round
     /*  533210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  533223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533229 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533242 */     GIR_RootConstrainSelectedInstOperands,
     /*  533243 */     // GIR_Coverage, 21242,
     /*  533243 */     GIR_EraseRootFromParent_Done,
     /*  533244 */   // Label 8819: @533244
     /*  533244 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(533315), // Rule ID 21243 //
     /*  533249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  533252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  533257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  533260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  533263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533281 */     // MIs[0] round
     /*  533281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11232:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  533294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533300 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533313 */     GIR_RootConstrainSelectedInstOperands,
     /*  533314 */     // GIR_Coverage, 21243,
     /*  533314 */     GIR_EraseRootFromParent_Done,
     /*  533315 */   // Label 8820: @533315
     /*  533315 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(533386), // Rule ID 21594 //
     /*  533320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  533337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533352 */     // MIs[0] round
     /*  533352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  533365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533371 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533384 */     GIR_RootConstrainSelectedInstOperands,
     /*  533385 */     // GIR_Coverage, 21594,
     /*  533385 */     GIR_EraseRootFromParent_Done,
     /*  533386 */   // Label 8821: @533386
     /*  533386 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(533457), // Rule ID 21595 //
     /*  533391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  533402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  533405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  533408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533423 */     // MIs[0] round
     /*  533423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533433 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  533436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533442 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533455 */     GIR_RootConstrainSelectedInstOperands,
     /*  533456 */     // GIR_Coverage, 21595,
     /*  533456 */     GIR_EraseRootFromParent_Done,
     /*  533457 */   // Label 8822: @533457
     /*  533457 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(533528), // Rule ID 21598 //
     /*  533462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  533473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  533476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  533479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533494 */     // MIs[0] round
     /*  533494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533504 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  533507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533513 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533526 */     GIR_RootConstrainSelectedInstOperands,
     /*  533527 */     // GIR_Coverage, 21598,
     /*  533527 */     GIR_EraseRootFromParent_Done,
     /*  533528 */   // Label 8823: @533528
     /*  533528 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(533599), // Rule ID 21599 //
     /*  533533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  533544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  533547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  533550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533565 */     // MIs[0] round
     /*  533565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533575 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  533578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533584 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533597 */     GIR_RootConstrainSelectedInstOperands,
     /*  533598 */     // GIR_Coverage, 21599,
     /*  533598 */     GIR_EraseRootFromParent_Done,
     /*  533599 */   // Label 8824: @533599
     /*  533599 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(533670), // Rule ID 21602 //
     /*  533604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  533615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  533618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  533621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533636 */     // MIs[0] round
     /*  533636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  533649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533655 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533668 */     GIR_RootConstrainSelectedInstOperands,
     /*  533669 */     // GIR_Coverage, 21602,
     /*  533669 */     GIR_EraseRootFromParent_Done,
     /*  533670 */   // Label 8825: @533670
     /*  533670 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(533741), // Rule ID 21603 //
     /*  533675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  533686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  533689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  533692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533707 */     // MIs[0] round
     /*  533707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533717 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  533720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533726 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533739 */     GIR_RootConstrainSelectedInstOperands,
     /*  533740 */     // GIR_Coverage, 21603,
     /*  533740 */     GIR_EraseRootFromParent_Done,
     /*  533741 */   // Label 8826: @533741
     /*  533741 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(533812), // Rule ID 21606 //
     /*  533746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  533757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  533760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  533763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533778 */     // MIs[0] round
     /*  533778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  533791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533797 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533810 */     GIR_RootConstrainSelectedInstOperands,
     /*  533811 */     // GIR_Coverage, 21606,
     /*  533811 */     GIR_EraseRootFromParent_Done,
     /*  533812 */   // Label 8827: @533812
     /*  533812 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(533883), // Rule ID 21607 //
     /*  533817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  533828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  533831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  533834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533849 */     // MIs[0] round
     /*  533849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533859 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  533859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  533862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533868 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533881 */     GIR_RootConstrainSelectedInstOperands,
     /*  533882 */     // GIR_Coverage, 21607,
     /*  533882 */     GIR_EraseRootFromParent_Done,
     /*  533883 */   // Label 8828: @533883
     /*  533883 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(533954), // Rule ID 21610 //
     /*  533888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  533899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  533902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  533905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533920 */     // MIs[0] round
     /*  533920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533930 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  533930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  533933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533939 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  533949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533952 */     GIR_RootConstrainSelectedInstOperands,
     /*  533953 */     // GIR_Coverage, 21610,
     /*  533953 */     GIR_EraseRootFromParent_Done,
     /*  533954 */   // Label 8829: @533954
     /*  533954 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(534025), // Rule ID 21611 //
     /*  533959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  533967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  533970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  533973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  533976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533991 */     // MIs[0] round
     /*  533991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534001 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534010 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534023 */     GIR_RootConstrainSelectedInstOperands,
     /*  534024 */     // GIR_Coverage, 21611,
     /*  534024 */     GIR_EraseRootFromParent_Done,
     /*  534025 */   // Label 8830: @534025
     /*  534025 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(534096), // Rule ID 21614 //
     /*  534030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  534041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  534044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  534047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534062 */     // MIs[0] round
     /*  534062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534072 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  534072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534081 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534094 */     GIR_RootConstrainSelectedInstOperands,
     /*  534095 */     // GIR_Coverage, 21614,
     /*  534095 */     GIR_EraseRootFromParent_Done,
     /*  534096 */   // Label 8831: @534096
     /*  534096 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(534167), // Rule ID 21615 //
     /*  534101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  534112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  534115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  534118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534133 */     // MIs[0] round
     /*  534133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534143 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  534143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534152 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  534162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534165 */     GIR_RootConstrainSelectedInstOperands,
     /*  534166 */     // GIR_Coverage, 21615,
     /*  534166 */     GIR_EraseRootFromParent_Done,
     /*  534167 */   // Label 8832: @534167
     /*  534167 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(534238), // Rule ID 21618 //
     /*  534172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534204 */     // MIs[0] round
     /*  534204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  534217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534223 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534236 */     GIR_RootConstrainSelectedInstOperands,
     /*  534237 */     // GIR_Coverage, 21618,
     /*  534237 */     GIR_EraseRootFromParent_Done,
     /*  534238 */   // Label 8833: @534238
     /*  534238 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(534309), // Rule ID 21619 //
     /*  534243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534275 */     // MIs[0] round
     /*  534275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534285 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  534288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534294 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534307 */     GIR_RootConstrainSelectedInstOperands,
     /*  534308 */     // GIR_Coverage, 21619,
     /*  534308 */     GIR_EraseRootFromParent_Done,
     /*  534309 */   // Label 8834: @534309
     /*  534309 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(534380), // Rule ID 21622 //
     /*  534314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534346 */     // MIs[0] round
     /*  534346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534365 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534378 */     GIR_RootConstrainSelectedInstOperands,
     /*  534379 */     // GIR_Coverage, 21622,
     /*  534379 */     GIR_EraseRootFromParent_Done,
     /*  534380 */   // Label 8835: @534380
     /*  534380 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(534451), // Rule ID 21623 //
     /*  534385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534417 */     // MIs[0] round
     /*  534417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534436 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534449 */     GIR_RootConstrainSelectedInstOperands,
     /*  534450 */     // GIR_Coverage, 21623,
     /*  534450 */     GIR_EraseRootFromParent_Done,
     /*  534451 */   // Label 8836: @534451
     /*  534451 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(534522), // Rule ID 21626 //
     /*  534456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534488 */     // MIs[0] round
     /*  534488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  534501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534507 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534520 */     GIR_RootConstrainSelectedInstOperands,
     /*  534521 */     // GIR_Coverage, 21626,
     /*  534521 */     GIR_EraseRootFromParent_Done,
     /*  534522 */   // Label 8837: @534522
     /*  534522 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(534593), // Rule ID 21627 //
     /*  534527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534559 */     // MIs[0] round
     /*  534559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  534572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534578 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534591 */     GIR_RootConstrainSelectedInstOperands,
     /*  534592 */     // GIR_Coverage, 21627,
     /*  534592 */     GIR_EraseRootFromParent_Done,
     /*  534593 */   // Label 8838: @534593
     /*  534593 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(534664), // Rule ID 21630 //
     /*  534598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534630 */     // MIs[0] round
     /*  534630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534649 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534662 */     GIR_RootConstrainSelectedInstOperands,
     /*  534663 */     // GIR_Coverage, 21630,
     /*  534663 */     GIR_EraseRootFromParent_Done,
     /*  534664 */   // Label 8839: @534664
     /*  534664 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(534735), // Rule ID 21631 //
     /*  534669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534701 */     // MIs[0] round
     /*  534701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  534714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534720 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534733 */     GIR_RootConstrainSelectedInstOperands,
     /*  534734 */     // GIR_Coverage, 21631,
     /*  534734 */     GIR_EraseRootFromParent_Done,
     /*  534735 */   // Label 8840: @534735
     /*  534735 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(534806), // Rule ID 21634 //
     /*  534740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  534743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534772 */     // MIs[0] round
     /*  534772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534782 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534791 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534804 */     GIR_RootConstrainSelectedInstOperands,
     /*  534805 */     // GIR_Coverage, 21634,
     /*  534805 */     GIR_EraseRootFromParent_Done,
     /*  534806 */   // Label 8841: @534806
     /*  534806 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(534877), // Rule ID 21635 //
     /*  534811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  534814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534843 */     // MIs[0] round
     /*  534843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534853 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  534856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534862 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534875 */     GIR_RootConstrainSelectedInstOperands,
     /*  534876 */     // GIR_Coverage, 21635,
     /*  534876 */     GIR_EraseRootFromParent_Done,
     /*  534877 */   // Label 8842: @534877
     /*  534877 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(534948), // Rule ID 21638 //
     /*  534882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  534885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534914 */     // MIs[0] round
     /*  534914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534933 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534946 */     GIR_RootConstrainSelectedInstOperands,
     /*  534947 */     // GIR_Coverage, 21638,
     /*  534947 */     GIR_EraseRootFromParent_Done,
     /*  534948 */   // Label 8843: @534948
     /*  534948 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(535019), // Rule ID 21639 //
     /*  534953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  534956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  534961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534985 */     // MIs[0] round
     /*  534985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534995 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  534998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535004 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535017 */     GIR_RootConstrainSelectedInstOperands,
     /*  535018 */     // GIR_Coverage, 21639,
     /*  535018 */     GIR_EraseRootFromParent_Done,
     /*  535019 */   // Label 8844: @535019
     /*  535019 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(535090), // Rule ID 21642 //
     /*  535024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535056 */     // MIs[0] round
     /*  535056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  535069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535075 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535088 */     GIR_RootConstrainSelectedInstOperands,
     /*  535089 */     // GIR_Coverage, 21642,
     /*  535089 */     GIR_EraseRootFromParent_Done,
     /*  535090 */   // Label 8845: @535090
     /*  535090 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(535161), // Rule ID 21643 //
     /*  535095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535127 */     // MIs[0] round
     /*  535127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535137 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  535140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535146 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535159 */     GIR_RootConstrainSelectedInstOperands,
     /*  535160 */     // GIR_Coverage, 21643,
     /*  535160 */     GIR_EraseRootFromParent_Done,
     /*  535161 */   // Label 8846: @535161
     /*  535161 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(535232), // Rule ID 21646 //
     /*  535166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535198 */     // MIs[0] round
     /*  535198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  535211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535217 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535230 */     GIR_RootConstrainSelectedInstOperands,
     /*  535231 */     // GIR_Coverage, 21646,
     /*  535231 */     GIR_EraseRootFromParent_Done,
     /*  535232 */   // Label 8847: @535232
     /*  535232 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(535303), // Rule ID 21647 //
     /*  535237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535269 */     // MIs[0] round
     /*  535269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  535282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535288 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535301 */     GIR_RootConstrainSelectedInstOperands,
     /*  535302 */     // GIR_Coverage, 21647,
     /*  535302 */     GIR_EraseRootFromParent_Done,
     /*  535303 */   // Label 8848: @535303
     /*  535303 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(535374), // Rule ID 21650 //
     /*  535308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  535311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535340 */     // MIs[0] round
     /*  535340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  535353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535359 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535372 */     GIR_RootConstrainSelectedInstOperands,
     /*  535373 */     // GIR_Coverage, 21650,
     /*  535373 */     GIR_EraseRootFromParent_Done,
     /*  535374 */   // Label 8849: @535374
     /*  535374 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(535445), // Rule ID 21651 //
     /*  535379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  535382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  535387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535411 */     // MIs[0] round
     /*  535411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  535424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535430 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535443 */     GIR_RootConstrainSelectedInstOperands,
     /*  535444 */     // GIR_Coverage, 21651,
     /*  535444 */     GIR_EraseRootFromParent_Done,
     /*  535445 */   // Label 8850: @535445
     /*  535445 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(535516), // Rule ID 21654 //
     /*  535450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  535461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  535464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  535467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535482 */     // MIs[0] round
     /*  535482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  535495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535501 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535514 */     GIR_RootConstrainSelectedInstOperands,
     /*  535515 */     // GIR_Coverage, 21654,
     /*  535515 */     GIR_EraseRootFromParent_Done,
     /*  535516 */   // Label 8851: @535516
     /*  535516 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(535587), // Rule ID 21655 //
     /*  535521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  535532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  535535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  535538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535553 */     // MIs[0] round
     /*  535553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535563 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  535566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535572 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535585 */     GIR_RootConstrainSelectedInstOperands,
     /*  535586 */     // GIR_Coverage, 21655,
     /*  535586 */     GIR_EraseRootFromParent_Done,
     /*  535587 */   // Label 8852: @535587
     /*  535587 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(535658), // Rule ID 21658 //
     /*  535592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  535603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  535606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  535609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535624 */     // MIs[0] round
     /*  535624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  535637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535643 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535656 */     GIR_RootConstrainSelectedInstOperands,
     /*  535657 */     // GIR_Coverage, 21658,
     /*  535657 */     GIR_EraseRootFromParent_Done,
     /*  535658 */   // Label 8853: @535658
     /*  535658 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(535729), // Rule ID 21659 //
     /*  535663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  535674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  535677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  535680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535695 */     // MIs[0] round
     /*  535695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535705 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  535708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535714 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535727 */     GIR_RootConstrainSelectedInstOperands,
     /*  535728 */     // GIR_Coverage, 21659,
     /*  535728 */     GIR_EraseRootFromParent_Done,
     /*  535729 */   // Label 8854: @535729
     /*  535729 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(535800), // Rule ID 21662 //
     /*  535734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  535745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  535748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  535751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535766 */     // MIs[0] round
     /*  535766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  535779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535785 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535798 */     GIR_RootConstrainSelectedInstOperands,
     /*  535799 */     // GIR_Coverage, 21662,
     /*  535799 */     GIR_EraseRootFromParent_Done,
     /*  535800 */   // Label 8855: @535800
     /*  535800 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(535871), // Rule ID 21663 //
     /*  535805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  535816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  535819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  535822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535837 */     // MIs[0] round
     /*  535837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535847 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  535850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535856 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535869 */     GIR_RootConstrainSelectedInstOperands,
     /*  535870 */     // GIR_Coverage, 21663,
     /*  535870 */     GIR_EraseRootFromParent_Done,
     /*  535871 */   // Label 8856: @535871
     /*  535871 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(535942), // Rule ID 21666 //
     /*  535876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  535887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  535890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535908 */     // MIs[0] round
     /*  535908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  535918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  535921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535927 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  535937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535940 */     GIR_RootConstrainSelectedInstOperands,
     /*  535941 */     // GIR_Coverage, 21666,
     /*  535941 */     GIR_EraseRootFromParent_Done,
     /*  535942 */   // Label 8857: @535942
     /*  535942 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(536013), // Rule ID 21667 //
     /*  535947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  535955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  535958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  535961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  535964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535979 */     // MIs[0] round
     /*  535979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535989 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  535989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  535992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535998 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536011 */     GIR_RootConstrainSelectedInstOperands,
     /*  536012 */     // GIR_Coverage, 21667,
     /*  536012 */     GIR_EraseRootFromParent_Done,
     /*  536013 */   // Label 8858: @536013
     /*  536013 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(536084), // Rule ID 21670 //
     /*  536018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  536029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  536032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  536035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536050 */     // MIs[0] round
     /*  536050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  536060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536069 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536082 */     GIR_RootConstrainSelectedInstOperands,
     /*  536083 */     // GIR_Coverage, 21670,
     /*  536083 */     GIR_EraseRootFromParent_Done,
     /*  536084 */   // Label 8859: @536084
     /*  536084 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(536155), // Rule ID 21671 //
     /*  536089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  536100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  536103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  536106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536121 */     // MIs[0] round
     /*  536121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  536131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536140 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536153 */     GIR_RootConstrainSelectedInstOperands,
     /*  536154 */     // GIR_Coverage, 21671,
     /*  536154 */     GIR_EraseRootFromParent_Done,
     /*  536155 */   // Label 8860: @536155
     /*  536155 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(536226), // Rule ID 21674 //
     /*  536160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  536163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  536171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  536174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536192 */     // MIs[0] round
     /*  536192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  536202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536211 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536224 */     GIR_RootConstrainSelectedInstOperands,
     /*  536225 */     // GIR_Coverage, 21674,
     /*  536225 */     GIR_EraseRootFromParent_Done,
     /*  536226 */   // Label 8861: @536226
     /*  536226 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(536297), // Rule ID 21675 //
     /*  536231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  536234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  536242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  536245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  536248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536263 */     // MIs[0] round
     /*  536263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536273 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  536273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536282 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  536292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536295 */     GIR_RootConstrainSelectedInstOperands,
     /*  536296 */     // GIR_Coverage, 21675,
     /*  536296 */     GIR_EraseRootFromParent_Done,
     /*  536297 */   // Label 8862: @536297
     /*  536297 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(536368), // Rule ID 21678 //
     /*  536302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536334 */     // MIs[0] round
     /*  536334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  536347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536353 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536366 */     GIR_RootConstrainSelectedInstOperands,
     /*  536367 */     // GIR_Coverage, 21678,
     /*  536367 */     GIR_EraseRootFromParent_Done,
     /*  536368 */   // Label 8863: @536368
     /*  536368 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(536439), // Rule ID 21679 //
     /*  536373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536405 */     // MIs[0] round
     /*  536405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  536418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536424 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536437 */     GIR_RootConstrainSelectedInstOperands,
     /*  536438 */     // GIR_Coverage, 21679,
     /*  536438 */     GIR_EraseRootFromParent_Done,
     /*  536439 */   // Label 8864: @536439
     /*  536439 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(536510), // Rule ID 21682 //
     /*  536444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536476 */     // MIs[0] round
     /*  536476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  536489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536495 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536508 */     GIR_RootConstrainSelectedInstOperands,
     /*  536509 */     // GIR_Coverage, 21682,
     /*  536509 */     GIR_EraseRootFromParent_Done,
     /*  536510 */   // Label 8865: @536510
     /*  536510 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(536581), // Rule ID 21683 //
     /*  536515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536547 */     // MIs[0] round
     /*  536547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536557 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  536560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536566 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536579 */     GIR_RootConstrainSelectedInstOperands,
     /*  536580 */     // GIR_Coverage, 21683,
     /*  536580 */     GIR_EraseRootFromParent_Done,
     /*  536581 */   // Label 8866: @536581
     /*  536581 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(536652), // Rule ID 21686 //
     /*  536586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536618 */     // MIs[0] round
     /*  536618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  536631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536637 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536650 */     GIR_RootConstrainSelectedInstOperands,
     /*  536651 */     // GIR_Coverage, 21686,
     /*  536651 */     GIR_EraseRootFromParent_Done,
     /*  536652 */   // Label 8867: @536652
     /*  536652 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(536723), // Rule ID 21687 //
     /*  536657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536689 */     // MIs[0] round
     /*  536689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536699 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  536702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536708 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536721 */     GIR_RootConstrainSelectedInstOperands,
     /*  536722 */     // GIR_Coverage, 21687,
     /*  536722 */     GIR_EraseRootFromParent_Done,
     /*  536723 */   // Label 8868: @536723
     /*  536723 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(536794), // Rule ID 21690 //
     /*  536728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536760 */     // MIs[0] round
     /*  536760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536779 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536792 */     GIR_RootConstrainSelectedInstOperands,
     /*  536793 */     // GIR_Coverage, 21690,
     /*  536793 */     GIR_EraseRootFromParent_Done,
     /*  536794 */   // Label 8869: @536794
     /*  536794 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(536865), // Rule ID 21691 //
     /*  536799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536831 */     // MIs[0] round
     /*  536831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  536844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536850 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536863 */     GIR_RootConstrainSelectedInstOperands,
     /*  536864 */     // GIR_Coverage, 21691,
     /*  536864 */     GIR_EraseRootFromParent_Done,
     /*  536865 */   // Label 8870: @536865
     /*  536865 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(536936), // Rule ID 21694 //
     /*  536870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  536873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536902 */     // MIs[0] round
     /*  536902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536921 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536934 */     GIR_RootConstrainSelectedInstOperands,
     /*  536935 */     // GIR_Coverage, 21694,
     /*  536935 */     GIR_EraseRootFromParent_Done,
     /*  536936 */   // Label 8871: @536936
     /*  536936 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(537007), // Rule ID 21695 //
     /*  536941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  536944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  536949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536973 */     // MIs[0] round
     /*  536973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536983 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  536986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536992 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537005 */     GIR_RootConstrainSelectedInstOperands,
     /*  537006 */     // GIR_Coverage, 21695,
     /*  537006 */     GIR_EraseRootFromParent_Done,
     /*  537007 */   // Label 8872: @537007
     /*  537007 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(537078), // Rule ID 21698 //
     /*  537012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537044 */     // MIs[0] round
     /*  537044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  537057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537063 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537076 */     GIR_RootConstrainSelectedInstOperands,
     /*  537077 */     // GIR_Coverage, 21698,
     /*  537077 */     GIR_EraseRootFromParent_Done,
     /*  537078 */   // Label 8873: @537078
     /*  537078 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(537149), // Rule ID 21699 //
     /*  537083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537115 */     // MIs[0] round
     /*  537115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537125 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  537128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537134 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537147 */     GIR_RootConstrainSelectedInstOperands,
     /*  537148 */     // GIR_Coverage, 21699,
     /*  537148 */     GIR_EraseRootFromParent_Done,
     /*  537149 */   // Label 8874: @537149
     /*  537149 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(537220), // Rule ID 21702 //
     /*  537154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537186 */     // MIs[0] round
     /*  537186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  537199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537205 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537218 */     GIR_RootConstrainSelectedInstOperands,
     /*  537219 */     // GIR_Coverage, 21702,
     /*  537219 */     GIR_EraseRootFromParent_Done,
     /*  537220 */   // Label 8875: @537220
     /*  537220 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(537291), // Rule ID 21703 //
     /*  537225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537257 */     // MIs[0] round
     /*  537257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537267 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  537270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537276 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537289 */     GIR_RootConstrainSelectedInstOperands,
     /*  537290 */     // GIR_Coverage, 21703,
     /*  537290 */     GIR_EraseRootFromParent_Done,
     /*  537291 */   // Label 8876: @537291
     /*  537291 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(537362), // Rule ID 21706 //
     /*  537296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537328 */     // MIs[0] round
     /*  537328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  537341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537347 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537360 */     GIR_RootConstrainSelectedInstOperands,
     /*  537361 */     // GIR_Coverage, 21706,
     /*  537361 */     GIR_EraseRootFromParent_Done,
     /*  537362 */   // Label 8877: @537362
     /*  537362 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(537433), // Rule ID 21707 //
     /*  537367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537399 */     // MIs[0] round
     /*  537399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  537412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537418 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537431 */     GIR_RootConstrainSelectedInstOperands,
     /*  537432 */     // GIR_Coverage, 21707,
     /*  537432 */     GIR_EraseRootFromParent_Done,
     /*  537433 */   // Label 8878: @537433
     /*  537433 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(537504), // Rule ID 21710 //
     /*  537438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  537441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537470 */     // MIs[0] round
     /*  537470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  537483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537489 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537502 */     GIR_RootConstrainSelectedInstOperands,
     /*  537503 */     // GIR_Coverage, 21710,
     /*  537503 */     GIR_EraseRootFromParent_Done,
     /*  537504 */   // Label 8879: @537504
     /*  537504 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(537575), // Rule ID 21711 //
     /*  537509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  537512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  537517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537541 */     // MIs[0] round
     /*  537541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  537554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537560 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537573 */     GIR_RootConstrainSelectedInstOperands,
     /*  537574 */     // GIR_Coverage, 21711,
     /*  537574 */     GIR_EraseRootFromParent_Done,
     /*  537575 */   // Label 8880: @537575
     /*  537575 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(537646), // Rule ID 21834 //
     /*  537580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537612 */     // MIs[0] round
     /*  537612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537622 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  537625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537631 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537644 */     GIR_RootConstrainSelectedInstOperands,
     /*  537645 */     // GIR_Coverage, 21834,
     /*  537645 */     GIR_EraseRootFromParent_Done,
     /*  537646 */   // Label 8881: @537646
     /*  537646 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(537717), // Rule ID 21835 //
     /*  537651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  537668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537683 */     // MIs[0] round
     /*  537683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537693 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  537696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537702 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537715 */     GIR_RootConstrainSelectedInstOperands,
     /*  537716 */     // GIR_Coverage, 21835,
     /*  537716 */     GIR_EraseRootFromParent_Done,
     /*  537717 */   // Label 8882: @537717
     /*  537717 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(537788), // Rule ID 21838 //
     /*  537722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  537739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537754 */     // MIs[0] round
     /*  537754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  537767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537773 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537786 */     GIR_RootConstrainSelectedInstOperands,
     /*  537787 */     // GIR_Coverage, 21838,
     /*  537787 */     GIR_EraseRootFromParent_Done,
     /*  537788 */   // Label 8883: @537788
     /*  537788 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(537859), // Rule ID 21839 //
     /*  537793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  537810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537825 */     // MIs[0] round
     /*  537825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537835 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  537838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537844 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537857 */     GIR_RootConstrainSelectedInstOperands,
     /*  537858 */     // GIR_Coverage, 21839,
     /*  537858 */     GIR_EraseRootFromParent_Done,
     /*  537859 */   // Label 8884: @537859
     /*  537859 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(537930), // Rule ID 21842 //
     /*  537864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  537867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537896 */     // MIs[0] round
     /*  537896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537906 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  537909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537915 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537928 */     GIR_RootConstrainSelectedInstOperands,
     /*  537929 */     // GIR_Coverage, 21842,
     /*  537929 */     GIR_EraseRootFromParent_Done,
     /*  537930 */   // Label 8885: @537930
     /*  537930 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(538001), // Rule ID 21843 //
     /*  537935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  537938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  537943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  537952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537967 */     // MIs[0] round
     /*  537967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537977 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  537980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537986 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537999 */     GIR_RootConstrainSelectedInstOperands,
     /*  538000 */     // GIR_Coverage, 21843,
     /*  538000 */     GIR_EraseRootFromParent_Done,
     /*  538001 */   // Label 8886: @538001
     /*  538001 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(538072), // Rule ID 21846 //
     /*  538006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  538023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538038 */     // MIs[0] round
     /*  538038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538048 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  538051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538057 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538070 */     GIR_RootConstrainSelectedInstOperands,
     /*  538071 */     // GIR_Coverage, 21846,
     /*  538071 */     GIR_EraseRootFromParent_Done,
     /*  538072 */   // Label 8887: @538072
     /*  538072 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(538143), // Rule ID 21847 //
     /*  538077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  538094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538109 */     // MIs[0] round
     /*  538109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538119 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  538122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538128 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538141 */     GIR_RootConstrainSelectedInstOperands,
     /*  538142 */     // GIR_Coverage, 21847,
     /*  538142 */     GIR_EraseRootFromParent_Done,
     /*  538143 */   // Label 8888: @538143
     /*  538143 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(538214), // Rule ID 21850 //
     /*  538148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  538165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538180 */     // MIs[0] round
     /*  538180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  538193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538199 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538212 */     GIR_RootConstrainSelectedInstOperands,
     /*  538213 */     // GIR_Coverage, 21850,
     /*  538213 */     GIR_EraseRootFromParent_Done,
     /*  538214 */   // Label 8889: @538214
     /*  538214 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(538285), // Rule ID 21851 //
     /*  538219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  538236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538251 */     // MIs[0] round
     /*  538251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538261 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  538264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538270 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538283 */     GIR_RootConstrainSelectedInstOperands,
     /*  538284 */     // GIR_Coverage, 21851,
     /*  538284 */     GIR_EraseRootFromParent_Done,
     /*  538285 */   // Label 8890: @538285
     /*  538285 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(538356), // Rule ID 21854 //
     /*  538290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538322 */     // MIs[0] round
     /*  538322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538332 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  538335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538341 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538354 */     GIR_RootConstrainSelectedInstOperands,
     /*  538355 */     // GIR_Coverage, 21854,
     /*  538355 */     GIR_EraseRootFromParent_Done,
     /*  538356 */   // Label 8891: @538356
     /*  538356 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(538427), // Rule ID 21855 //
     /*  538361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  538378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538393 */     // MIs[0] round
     /*  538393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538403 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  538406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538412 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538425 */     GIR_RootConstrainSelectedInstOperands,
     /*  538426 */     // GIR_Coverage, 21855,
     /*  538426 */     GIR_EraseRootFromParent_Done,
     /*  538427 */   // Label 8892: @538427
     /*  538427 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(538498), // Rule ID 21858 //
     /*  538432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  538449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538464 */     // MIs[0] round
     /*  538464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538474 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  538477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538483 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538496 */     GIR_RootConstrainSelectedInstOperands,
     /*  538497 */     // GIR_Coverage, 21858,
     /*  538497 */     GIR_EraseRootFromParent_Done,
     /*  538498 */   // Label 8893: @538498
     /*  538498 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(538569), // Rule ID 21859 //
     /*  538503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  538520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538535 */     // MIs[0] round
     /*  538535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538545 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  538548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538554 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538567 */     GIR_RootConstrainSelectedInstOperands,
     /*  538568 */     // GIR_Coverage, 21859,
     /*  538568 */     GIR_EraseRootFromParent_Done,
     /*  538569 */   // Label 8894: @538569
     /*  538569 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(538640), // Rule ID 21862 //
     /*  538574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  538591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538606 */     // MIs[0] round
     /*  538606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  538619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538625 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538638 */     GIR_RootConstrainSelectedInstOperands,
     /*  538639 */     // GIR_Coverage, 21862,
     /*  538639 */     GIR_EraseRootFromParent_Done,
     /*  538640 */   // Label 8895: @538640
     /*  538640 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(538711), // Rule ID 21863 //
     /*  538645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  538662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538677 */     // MIs[0] round
     /*  538677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538687 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  538690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538696 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538709 */     GIR_RootConstrainSelectedInstOperands,
     /*  538710 */     // GIR_Coverage, 21863,
     /*  538710 */     GIR_EraseRootFromParent_Done,
     /*  538711 */   // Label 8896: @538711
     /*  538711 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(538782), // Rule ID 21866 //
     /*  538716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  538719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  538733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538748 */     // MIs[0] round
     /*  538748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538758 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  538761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538767 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538780 */     GIR_RootConstrainSelectedInstOperands,
     /*  538781 */     // GIR_Coverage, 21866,
     /*  538781 */     GIR_EraseRootFromParent_Done,
     /*  538782 */   // Label 8897: @538782
     /*  538782 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(538853), // Rule ID 21867 //
     /*  538787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  538790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  538795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  538804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538819 */     // MIs[0] round
     /*  538819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538829 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  538832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538838 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538851 */     GIR_RootConstrainSelectedInstOperands,
     /*  538852 */     // GIR_Coverage, 21867,
     /*  538852 */     GIR_EraseRootFromParent_Done,
     /*  538853 */   // Label 8898: @538853
     /*  538853 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(538924), // Rule ID 21870 //
     /*  538858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  538861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  538866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  538875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538890 */     // MIs[0] round
     /*  538890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538900 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  538903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538909 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538922 */     GIR_RootConstrainSelectedInstOperands,
     /*  538923 */     // GIR_Coverage, 21870,
     /*  538923 */     GIR_EraseRootFromParent_Done,
     /*  538924 */   // Label 8899: @538924
     /*  538924 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(538995), // Rule ID 21871 //
     /*  538929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  538932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  538937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  538940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  538943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  538946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538961 */     // MIs[0] round
     /*  538961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  538964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538971 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  538974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  538980 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  538982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538993 */     GIR_RootConstrainSelectedInstOperands,
     /*  538994 */     // GIR_Coverage, 21871,
     /*  538994 */     GIR_EraseRootFromParent_Done,
     /*  538995 */   // Label 8900: @538995
     /*  538995 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(539066), // Rule ID 21874 //
     /*  539000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  539017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539032 */     // MIs[0] round
     /*  539032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  539045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539051 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539064 */     GIR_RootConstrainSelectedInstOperands,
     /*  539065 */     // GIR_Coverage, 21874,
     /*  539065 */     GIR_EraseRootFromParent_Done,
     /*  539066 */   // Label 8901: @539066
     /*  539066 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(539137), // Rule ID 21875 //
     /*  539071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  539088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539103 */     // MIs[0] round
     /*  539103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539113 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  539116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539122 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539135 */     GIR_RootConstrainSelectedInstOperands,
     /*  539136 */     // GIR_Coverage, 21875,
     /*  539136 */     GIR_EraseRootFromParent_Done,
     /*  539137 */   // Label 8902: @539137
     /*  539137 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(539208), // Rule ID 21878 //
     /*  539142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539174 */     // MIs[0] round
     /*  539174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  539187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539193 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539206 */     GIR_RootConstrainSelectedInstOperands,
     /*  539207 */     // GIR_Coverage, 21878,
     /*  539207 */     GIR_EraseRootFromParent_Done,
     /*  539208 */   // Label 8903: @539208
     /*  539208 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(539279), // Rule ID 21879 //
     /*  539213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  539230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539245 */     // MIs[0] round
     /*  539245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539255 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  539258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539264 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539277 */     GIR_RootConstrainSelectedInstOperands,
     /*  539278 */     // GIR_Coverage, 21879,
     /*  539278 */     GIR_EraseRootFromParent_Done,
     /*  539279 */   // Label 8904: @539279
     /*  539279 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(539350), // Rule ID 21882 //
     /*  539284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539316 */     // MIs[0] round
     /*  539316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539326 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  539329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539335 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539348 */     GIR_RootConstrainSelectedInstOperands,
     /*  539349 */     // GIR_Coverage, 21882,
     /*  539349 */     GIR_EraseRootFromParent_Done,
     /*  539350 */   // Label 8905: @539350
     /*  539350 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(539421), // Rule ID 21883 //
     /*  539355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  539372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539387 */     // MIs[0] round
     /*  539387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539397 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  539400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539406 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539419 */     GIR_RootConstrainSelectedInstOperands,
     /*  539420 */     // GIR_Coverage, 21883,
     /*  539420 */     GIR_EraseRootFromParent_Done,
     /*  539421 */   // Label 8906: @539421
     /*  539421 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(539492), // Rule ID 21886 //
     /*  539426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  539429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539458 */     // MIs[0] round
     /*  539458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539468 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  539471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539477 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539490 */     GIR_RootConstrainSelectedInstOperands,
     /*  539491 */     // GIR_Coverage, 21886,
     /*  539491 */     GIR_EraseRootFromParent_Done,
     /*  539492 */   // Label 8907: @539492
     /*  539492 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(539563), // Rule ID 21887 //
     /*  539497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  539500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  539514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539529 */     // MIs[0] round
     /*  539529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539539 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  539542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539548 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539561 */     GIR_RootConstrainSelectedInstOperands,
     /*  539562 */     // GIR_Coverage, 21887,
     /*  539562 */     GIR_EraseRootFromParent_Done,
     /*  539563 */   // Label 8908: @539563
     /*  539563 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(539634), // Rule ID 21890 //
     /*  539568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  539579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  539582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  539585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539600 */     // MIs[0] round
     /*  539600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  539613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539619 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539632 */     GIR_RootConstrainSelectedInstOperands,
     /*  539633 */     // GIR_Coverage, 21890,
     /*  539633 */     GIR_EraseRootFromParent_Done,
     /*  539634 */   // Label 8909: @539634
     /*  539634 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(539705), // Rule ID 21891 //
     /*  539639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  539650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  539653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  539656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539671 */     // MIs[0] round
     /*  539671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539681 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  539684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539690 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539703 */     GIR_RootConstrainSelectedInstOperands,
     /*  539704 */     // GIR_Coverage, 21891,
     /*  539704 */     GIR_EraseRootFromParent_Done,
     /*  539705 */   // Label 8910: @539705
     /*  539705 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(539776), // Rule ID 21894 //
     /*  539710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  539727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539742 */     // MIs[0] round
     /*  539742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  539755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539761 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539774 */     GIR_RootConstrainSelectedInstOperands,
     /*  539775 */     // GIR_Coverage, 21894,
     /*  539775 */     GIR_EraseRootFromParent_Done,
     /*  539776 */   // Label 8911: @539776
     /*  539776 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(539847), // Rule ID 21895 //
     /*  539781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  539792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  539795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  539798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539813 */     // MIs[0] round
     /*  539813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539823 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  539826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539832 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539845 */     GIR_RootConstrainSelectedInstOperands,
     /*  539846 */     // GIR_Coverage, 21895,
     /*  539846 */     GIR_EraseRootFromParent_Done,
     /*  539847 */   // Label 8912: @539847
     /*  539847 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(539918), // Rule ID 21898 //
     /*  539852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  539869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539884 */     // MIs[0] round
     /*  539884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  539897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539903 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539916 */     GIR_RootConstrainSelectedInstOperands,
     /*  539917 */     // GIR_Coverage, 21898,
     /*  539917 */     GIR_EraseRootFromParent_Done,
     /*  539918 */   // Label 8913: @539918
     /*  539918 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(539989), // Rule ID 21899 //
     /*  539923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  539926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  539931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  539934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  539937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  539940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539955 */     // MIs[0] round
     /*  539955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  539958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539965 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  539968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  539974 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  539976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539987 */     GIR_RootConstrainSelectedInstOperands,
     /*  539988 */     // GIR_Coverage, 21899,
     /*  539988 */     GIR_EraseRootFromParent_Done,
     /*  539989 */   // Label 8914: @539989
     /*  539989 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(540060), // Rule ID 21902 //
     /*  539994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  539997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  540002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540026 */     // MIs[0] round
     /*  540026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  540039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540045 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540058 */     GIR_RootConstrainSelectedInstOperands,
     /*  540059 */     // GIR_Coverage, 21902,
     /*  540059 */     GIR_EraseRootFromParent_Done,
     /*  540060 */   // Label 8915: @540060
     /*  540060 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(540131), // Rule ID 21903 //
     /*  540065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  540068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  540073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540097 */     // MIs[0] round
     /*  540097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540107 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  540110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540116 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540129 */     GIR_RootConstrainSelectedInstOperands,
     /*  540130 */     // GIR_Coverage, 21903,
     /*  540130 */     GIR_EraseRootFromParent_Done,
     /*  540131 */   // Label 8916: @540131
     /*  540131 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(540202), // Rule ID 21906 //
     /*  540136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  540153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540168 */     // MIs[0] round
     /*  540168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540178 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  540181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540187 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540200 */     GIR_RootConstrainSelectedInstOperands,
     /*  540201 */     // GIR_Coverage, 21906,
     /*  540201 */     GIR_EraseRootFromParent_Done,
     /*  540202 */   // Label 8917: @540202
     /*  540202 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(540273), // Rule ID 21907 //
     /*  540207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  540224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540239 */     // MIs[0] round
     /*  540239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540249 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  540252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540258 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540271 */     GIR_RootConstrainSelectedInstOperands,
     /*  540272 */     // GIR_Coverage, 21907,
     /*  540272 */     GIR_EraseRootFromParent_Done,
     /*  540273 */   // Label 8918: @540273
     /*  540273 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(540344), // Rule ID 21910 //
     /*  540278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  540295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540310 */     // MIs[0] round
     /*  540310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  540323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540329 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540342 */     GIR_RootConstrainSelectedInstOperands,
     /*  540343 */     // GIR_Coverage, 21910,
     /*  540343 */     GIR_EraseRootFromParent_Done,
     /*  540344 */   // Label 8919: @540344
     /*  540344 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(540415), // Rule ID 21911 //
     /*  540349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  540366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540381 */     // MIs[0] round
     /*  540381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540391 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  540394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540400 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540413 */     GIR_RootConstrainSelectedInstOperands,
     /*  540414 */     // GIR_Coverage, 21911,
     /*  540414 */     GIR_EraseRootFromParent_Done,
     /*  540415 */   // Label 8920: @540415
     /*  540415 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(540486), // Rule ID 21914 //
     /*  540420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540452 */     // MIs[0] round
     /*  540452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  540465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540471 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540484 */     GIR_RootConstrainSelectedInstOperands,
     /*  540485 */     // GIR_Coverage, 21914,
     /*  540485 */     GIR_EraseRootFromParent_Done,
     /*  540486 */   // Label 8921: @540486
     /*  540486 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(540557), // Rule ID 21915 //
     /*  540491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  540508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540523 */     // MIs[0] round
     /*  540523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  540536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540542 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540555 */     GIR_RootConstrainSelectedInstOperands,
     /*  540556 */     // GIR_Coverage, 21915,
     /*  540556 */     GIR_EraseRootFromParent_Done,
     /*  540557 */   // Label 8922: @540557
     /*  540557 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(540628), // Rule ID 21918 //
     /*  540562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  540565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540594 */     // MIs[0] round
     /*  540594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  540607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540613 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540626 */     GIR_RootConstrainSelectedInstOperands,
     /*  540627 */     // GIR_Coverage, 21918,
     /*  540627 */     GIR_EraseRootFromParent_Done,
     /*  540628 */   // Label 8923: @540628
     /*  540628 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(540699), // Rule ID 21919 //
     /*  540633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  540636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  540650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540665 */     // MIs[0] round
     /*  540665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540675 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  540678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540684 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540697 */     GIR_RootConstrainSelectedInstOperands,
     /*  540698 */     // GIR_Coverage, 21919,
     /*  540698 */     GIR_EraseRootFromParent_Done,
     /*  540699 */   // Label 8924: @540699
     /*  540699 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(540770), // Rule ID 21922 //
     /*  540704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  540721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540736 */     // MIs[0] round
     /*  540736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540746 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  540749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540755 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540768 */     GIR_RootConstrainSelectedInstOperands,
     /*  540769 */     // GIR_Coverage, 21922,
     /*  540769 */     GIR_EraseRootFromParent_Done,
     /*  540770 */   // Label 8925: @540770
     /*  540770 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(540841), // Rule ID 21923 //
     /*  540775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  540778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  540786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  540789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  540792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540807 */     // MIs[0] round
     /*  540807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540817 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  540820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540826 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540839 */     GIR_RootConstrainSelectedInstOperands,
     /*  540840 */     // GIR_Coverage, 21923,
     /*  540840 */     GIR_EraseRootFromParent_Done,
     /*  540841 */   // Label 8926: @540841
     /*  540841 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(540912), // Rule ID 21926 //
     /*  540846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  540863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540878 */     // MIs[0] round
     /*  540878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540888 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  540891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540897 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540910 */     GIR_RootConstrainSelectedInstOperands,
     /*  540911 */     // GIR_Coverage, 21926,
     /*  540911 */     GIR_EraseRootFromParent_Done,
     /*  540912 */   // Label 8927: @540912
     /*  540912 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(540983), // Rule ID 21927 //
     /*  540917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  540920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  540928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  540931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  540934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540949 */     // MIs[0] round
     /*  540949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  540952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540959 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  540962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  540968 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  540970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540981 */     GIR_RootConstrainSelectedInstOperands,
     /*  540982 */     // GIR_Coverage, 21927,
     /*  540982 */     GIR_EraseRootFromParent_Done,
     /*  540983 */   // Label 8928: @540983
     /*  540983 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(541054), // Rule ID 21930 //
     /*  540988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  540991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  540996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  541005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541020 */     // MIs[0] round
     /*  541020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  541033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541039 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541052 */     GIR_RootConstrainSelectedInstOperands,
     /*  541053 */     // GIR_Coverage, 21930,
     /*  541053 */     GIR_EraseRootFromParent_Done,
     /*  541054 */   // Label 8929: @541054
     /*  541054 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(541125), // Rule ID 21931 //
     /*  541059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  541076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541091 */     // MIs[0] round
     /*  541091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541101 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  541104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541110 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541123 */     GIR_RootConstrainSelectedInstOperands,
     /*  541124 */     // GIR_Coverage, 21931,
     /*  541124 */     GIR_EraseRootFromParent_Done,
     /*  541125 */   // Label 8930: @541125
     /*  541125 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(541196), // Rule ID 21934 //
     /*  541130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  541133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  541147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541162 */     // MIs[0] round
     /*  541162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541172 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  541175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541181 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541194 */     GIR_RootConstrainSelectedInstOperands,
     /*  541195 */     // GIR_Coverage, 21934,
     /*  541195 */     GIR_EraseRootFromParent_Done,
     /*  541196 */   // Label 8931: @541196
     /*  541196 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(541267), // Rule ID 21935 //
     /*  541201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  541218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541233 */     // MIs[0] round
     /*  541233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  541246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541252 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541265 */     GIR_RootConstrainSelectedInstOperands,
     /*  541266 */     // GIR_Coverage, 21935,
     /*  541266 */     GIR_EraseRootFromParent_Done,
     /*  541267 */   // Label 8932: @541267
     /*  541267 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(541338), // Rule ID 21938 //
     /*  541272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  541275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  541289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541304 */     // MIs[0] round
     /*  541304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541314 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  541317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541323 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541336 */     GIR_RootConstrainSelectedInstOperands,
     /*  541337 */     // GIR_Coverage, 21938,
     /*  541337 */     GIR_EraseRootFromParent_Done,
     /*  541338 */   // Label 8933: @541338
     /*  541338 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(541409), // Rule ID 21939 //
     /*  541343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  541346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  541351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  541360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541375 */     // MIs[0] round
     /*  541375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  541378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541385 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  541388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  541394 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  541396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541407 */     GIR_RootConstrainSelectedInstOperands,
     /*  541408 */     // GIR_Coverage, 21939,
     /*  541408 */     GIR_EraseRootFromParent_Done,
     /*  541409 */   // Label 8934: @541409
     /*  541409 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(541480), // Rule ID 2748 //
     /*  541414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541442 */     // MIs[0] passthru
     /*  541442 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  541461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541478 */     GIR_RootConstrainSelectedInstOperands,
     /*  541479 */     // GIR_Coverage, 2748,
     /*  541479 */     GIR_EraseRootFromParent_Done,
     /*  541480 */   // Label 8935: @541480
     /*  541480 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(541551), // Rule ID 2749 //
     /*  541485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541513 */     // MIs[0] passthru
     /*  541513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  541532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541549 */     GIR_RootConstrainSelectedInstOperands,
     /*  541550 */     // GIR_Coverage, 2749,
     /*  541550 */     GIR_EraseRootFromParent_Done,
     /*  541551 */   // Label 8936: @541551
     /*  541551 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(541622), // Rule ID 4064 //
     /*  541556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541584 */     // MIs[0] passthru
     /*  541584 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541600 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  541603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541620 */     GIR_RootConstrainSelectedInstOperands,
     /*  541621 */     // GIR_Coverage, 4064,
     /*  541621 */     GIR_EraseRootFromParent_Done,
     /*  541622 */   // Label 8937: @541622
     /*  541622 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(541693), // Rule ID 4065 //
     /*  541627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541655 */     // MIs[0] passthru
     /*  541655 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  541674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541691 */     GIR_RootConstrainSelectedInstOperands,
     /*  541692 */     // GIR_Coverage, 4065,
     /*  541692 */     GIR_EraseRootFromParent_Done,
     /*  541693 */   // Label 8938: @541693
     /*  541693 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(541764), // Rule ID 4074 //
     /*  541698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541726 */     // MIs[0] passthru
     /*  541726 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  541745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541762 */     GIR_RootConstrainSelectedInstOperands,
     /*  541763 */     // GIR_Coverage, 4074,
     /*  541763 */     GIR_EraseRootFromParent_Done,
     /*  541764 */   // Label 8939: @541764
     /*  541764 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(541835), // Rule ID 4075 //
     /*  541769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541797 */     // MIs[0] passthru
     /*  541797 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  541816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541833 */     GIR_RootConstrainSelectedInstOperands,
     /*  541834 */     // GIR_Coverage, 4075,
     /*  541834 */     GIR_EraseRootFromParent_Done,
     /*  541835 */   // Label 8940: @541835
     /*  541835 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(541906), // Rule ID 4084 //
     /*  541840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541868 */     // MIs[0] passthru
     /*  541868 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  541887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541904 */     GIR_RootConstrainSelectedInstOperands,
     /*  541905 */     // GIR_Coverage, 4084,
     /*  541905 */     GIR_EraseRootFromParent_Done,
     /*  541906 */   // Label 8941: @541906
     /*  541906 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(541977), // Rule ID 4085 //
     /*  541911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541939 */     // MIs[0] passthru
     /*  541939 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  541958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541975 */     GIR_RootConstrainSelectedInstOperands,
     /*  541976 */     // GIR_Coverage, 4085,
     /*  541976 */     GIR_EraseRootFromParent_Done,
     /*  541977 */   // Label 8942: @541977
     /*  541977 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(542048), // Rule ID 4094 //
     /*  541982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  541990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  541999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542010 */     // MIs[0] passthru
     /*  542010 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542046 */     GIR_RootConstrainSelectedInstOperands,
     /*  542047 */     // GIR_Coverage, 4094,
     /*  542047 */     GIR_EraseRootFromParent_Done,
     /*  542048 */   // Label 8943: @542048
     /*  542048 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(542119), // Rule ID 4095 //
     /*  542053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542081 */     // MIs[0] passthru
     /*  542081 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542097 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542117 */     GIR_RootConstrainSelectedInstOperands,
     /*  542118 */     // GIR_Coverage, 4095,
     /*  542118 */     GIR_EraseRootFromParent_Done,
     /*  542119 */   // Label 8944: @542119
     /*  542119 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(542190), // Rule ID 4104 //
     /*  542124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542152 */     // MIs[0] passthru
     /*  542152 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542188 */     GIR_RootConstrainSelectedInstOperands,
     /*  542189 */     // GIR_Coverage, 4104,
     /*  542189 */     GIR_EraseRootFromParent_Done,
     /*  542190 */   // Label 8945: @542190
     /*  542190 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(542261), // Rule ID 4105 //
     /*  542195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542223 */     // MIs[0] passthru
     /*  542223 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542239 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542259 */     GIR_RootConstrainSelectedInstOperands,
     /*  542260 */     // GIR_Coverage, 4105,
     /*  542260 */     GIR_EraseRootFromParent_Done,
     /*  542261 */   // Label 8946: @542261
     /*  542261 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(542332), // Rule ID 4114 //
     /*  542266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542294 */     // MIs[0] passthru
     /*  542294 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  542313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542330 */     GIR_RootConstrainSelectedInstOperands,
     /*  542331 */     // GIR_Coverage, 4114,
     /*  542331 */     GIR_EraseRootFromParent_Done,
     /*  542332 */   // Label 8947: @542332
     /*  542332 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(542403), // Rule ID 4115 //
     /*  542337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542365 */     // MIs[0] passthru
     /*  542365 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542381 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  542384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542401 */     GIR_RootConstrainSelectedInstOperands,
     /*  542402 */     // GIR_Coverage, 4115,
     /*  542402 */     GIR_EraseRootFromParent_Done,
     /*  542403 */   // Label 8948: @542403
     /*  542403 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(542474), // Rule ID 4124 //
     /*  542408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542436 */     // MIs[0] passthru
     /*  542436 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  542455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542472 */     GIR_RootConstrainSelectedInstOperands,
     /*  542473 */     // GIR_Coverage, 4124,
     /*  542473 */     GIR_EraseRootFromParent_Done,
     /*  542474 */   // Label 8949: @542474
     /*  542474 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(542545), // Rule ID 4125 //
     /*  542479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542507 */     // MIs[0] passthru
     /*  542507 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  542526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542543 */     GIR_RootConstrainSelectedInstOperands,
     /*  542544 */     // GIR_Coverage, 4125,
     /*  542544 */     GIR_EraseRootFromParent_Done,
     /*  542545 */   // Label 8950: @542545
     /*  542545 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(542616), // Rule ID 4134 //
     /*  542550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542578 */     // MIs[0] passthru
     /*  542578 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  542597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542614 */     GIR_RootConstrainSelectedInstOperands,
     /*  542615 */     // GIR_Coverage, 4134,
     /*  542615 */     GIR_EraseRootFromParent_Done,
     /*  542616 */   // Label 8951: @542616
     /*  542616 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(542687), // Rule ID 4135 //
     /*  542621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542649 */     // MIs[0] passthru
     /*  542649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  542668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542685 */     GIR_RootConstrainSelectedInstOperands,
     /*  542686 */     // GIR_Coverage, 4135,
     /*  542686 */     GIR_EraseRootFromParent_Done,
     /*  542687 */   // Label 8952: @542687
     /*  542687 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(542758), // Rule ID 4144 //
     /*  542692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542720 */     // MIs[0] passthru
     /*  542720 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542756 */     GIR_RootConstrainSelectedInstOperands,
     /*  542757 */     // GIR_Coverage, 4144,
     /*  542757 */     GIR_EraseRootFromParent_Done,
     /*  542758 */   // Label 8953: @542758
     /*  542758 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(542829), // Rule ID 4145 //
     /*  542763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542791 */     // MIs[0] passthru
     /*  542791 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542807 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  542810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542827 */     GIR_RootConstrainSelectedInstOperands,
     /*  542828 */     // GIR_Coverage, 4145,
     /*  542828 */     GIR_EraseRootFromParent_Done,
     /*  542829 */   // Label 8954: @542829
     /*  542829 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(542900), // Rule ID 4154 //
     /*  542834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542862 */     // MIs[0] passthru
     /*  542862 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542898 */     GIR_RootConstrainSelectedInstOperands,
     /*  542899 */     // GIR_Coverage, 4154,
     /*  542899 */     GIR_EraseRootFromParent_Done,
     /*  542900 */   // Label 8955: @542900
     /*  542900 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(542971), // Rule ID 4155 //
     /*  542905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542933 */     // MIs[0] passthru
     /*  542933 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542949 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  542952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542969 */     GIR_RootConstrainSelectedInstOperands,
     /*  542970 */     // GIR_Coverage, 4155,
     /*  542970 */     GIR_EraseRootFromParent_Done,
     /*  542971 */   // Label 8956: @542971
     /*  542971 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(543042), // Rule ID 4164 //
     /*  542976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  542984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  542987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  542990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  542993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543004 */     // MIs[0] passthru
     /*  543004 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  543023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543040 */     GIR_RootConstrainSelectedInstOperands,
     /*  543041 */     // GIR_Coverage, 4164,
     /*  543041 */     GIR_EraseRootFromParent_Done,
     /*  543042 */   // Label 8957: @543042
     /*  543042 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(543113), // Rule ID 4165 //
     /*  543047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543075 */     // MIs[0] passthru
     /*  543075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  543094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543111 */     GIR_RootConstrainSelectedInstOperands,
     /*  543112 */     // GIR_Coverage, 4165,
     /*  543112 */     GIR_EraseRootFromParent_Done,
     /*  543113 */   // Label 8958: @543113
     /*  543113 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(543184), // Rule ID 4174 //
     /*  543118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543146 */     // MIs[0] passthru
     /*  543146 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  543165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543182 */     GIR_RootConstrainSelectedInstOperands,
     /*  543183 */     // GIR_Coverage, 4174,
     /*  543183 */     GIR_EraseRootFromParent_Done,
     /*  543184 */   // Label 8959: @543184
     /*  543184 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(543255), // Rule ID 4175 //
     /*  543189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543217 */     // MIs[0] passthru
     /*  543217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  543236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543253 */     GIR_RootConstrainSelectedInstOperands,
     /*  543254 */     // GIR_Coverage, 4175,
     /*  543254 */     GIR_EraseRootFromParent_Done,
     /*  543255 */   // Label 8960: @543255
     /*  543255 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(543326), // Rule ID 4184 //
     /*  543260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543288 */     // MIs[0] passthru
     /*  543288 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  543307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543324 */     GIR_RootConstrainSelectedInstOperands,
     /*  543325 */     // GIR_Coverage, 4184,
     /*  543325 */     GIR_EraseRootFromParent_Done,
     /*  543326 */   // Label 8961: @543326
     /*  543326 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(543397), // Rule ID 4185 //
     /*  543331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543359 */     // MIs[0] passthru
     /*  543359 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543375 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  543378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543395 */     GIR_RootConstrainSelectedInstOperands,
     /*  543396 */     // GIR_Coverage, 4185,
     /*  543396 */     GIR_EraseRootFromParent_Done,
     /*  543397 */   // Label 8962: @543397
     /*  543397 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(543468), // Rule ID 4194 //
     /*  543402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543430 */     // MIs[0] passthru
     /*  543430 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  543449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543466 */     GIR_RootConstrainSelectedInstOperands,
     /*  543467 */     // GIR_Coverage, 4194,
     /*  543467 */     GIR_EraseRootFromParent_Done,
     /*  543468 */   // Label 8963: @543468
     /*  543468 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(543539), // Rule ID 4195 //
     /*  543473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  543481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543501 */     // MIs[0] passthru
     /*  543501 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543517 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  543520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543537 */     GIR_RootConstrainSelectedInstOperands,
     /*  543538 */     // GIR_Coverage, 4195,
     /*  543538 */     GIR_EraseRootFromParent_Done,
     /*  543539 */   // Label 8964: @543539
     /*  543539 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(543610), // Rule ID 4264 //
     /*  543544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543572 */     // MIs[0] passthru
     /*  543572 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  543591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543608 */     GIR_RootConstrainSelectedInstOperands,
     /*  543609 */     // GIR_Coverage, 4264,
     /*  543609 */     GIR_EraseRootFromParent_Done,
     /*  543610 */   // Label 8965: @543610
     /*  543610 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(543681), // Rule ID 4265 //
     /*  543615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543643 */     // MIs[0] passthru
     /*  543643 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543659 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  543662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543679 */     GIR_RootConstrainSelectedInstOperands,
     /*  543680 */     // GIR_Coverage, 4265,
     /*  543680 */     GIR_EraseRootFromParent_Done,
     /*  543681 */   // Label 8966: @543681
     /*  543681 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(543752), // Rule ID 4274 //
     /*  543686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543714 */     // MIs[0] passthru
     /*  543714 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  543733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543750 */     GIR_RootConstrainSelectedInstOperands,
     /*  543751 */     // GIR_Coverage, 4274,
     /*  543751 */     GIR_EraseRootFromParent_Done,
     /*  543752 */   // Label 8967: @543752
     /*  543752 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(543823), // Rule ID 4275 //
     /*  543757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543785 */     // MIs[0] passthru
     /*  543785 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543801 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  543804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543821 */     GIR_RootConstrainSelectedInstOperands,
     /*  543822 */     // GIR_Coverage, 4275,
     /*  543822 */     GIR_EraseRootFromParent_Done,
     /*  543823 */   // Label 8968: @543823
     /*  543823 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(543894), // Rule ID 4284 //
     /*  543828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543856 */     // MIs[0] passthru
     /*  543856 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  543875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543892 */     GIR_RootConstrainSelectedInstOperands,
     /*  543893 */     // GIR_Coverage, 4284,
     /*  543893 */     GIR_EraseRootFromParent_Done,
     /*  543894 */   // Label 8969: @543894
     /*  543894 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(543965), // Rule ID 4285 //
     /*  543899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543927 */     // MIs[0] passthru
     /*  543927 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  543946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543963 */     GIR_RootConstrainSelectedInstOperands,
     /*  543964 */     // GIR_Coverage, 4285,
     /*  543964 */     GIR_EraseRootFromParent_Done,
     /*  543965 */   // Label 8970: @543965
     /*  543965 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(544036), // Rule ID 4294 //
     /*  543970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  543978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  543981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  543984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  543987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543998 */     // MIs[0] passthru
     /*  543998 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544034 */     GIR_RootConstrainSelectedInstOperands,
     /*  544035 */     // GIR_Coverage, 4294,
     /*  544035 */     GIR_EraseRootFromParent_Done,
     /*  544036 */   // Label 8971: @544036
     /*  544036 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(544107), // Rule ID 4295 //
     /*  544041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544069 */     // MIs[0] passthru
     /*  544069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544105 */     GIR_RootConstrainSelectedInstOperands,
     /*  544106 */     // GIR_Coverage, 4295,
     /*  544106 */     GIR_EraseRootFromParent_Done,
     /*  544107 */   // Label 8972: @544107
     /*  544107 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(544178), // Rule ID 4304 //
     /*  544112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544140 */     // MIs[0] passthru
     /*  544140 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544176 */     GIR_RootConstrainSelectedInstOperands,
     /*  544177 */     // GIR_Coverage, 4304,
     /*  544177 */     GIR_EraseRootFromParent_Done,
     /*  544178 */   // Label 8973: @544178
     /*  544178 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(544249), // Rule ID 4305 //
     /*  544183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544211 */     // MIs[0] passthru
     /*  544211 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544247 */     GIR_RootConstrainSelectedInstOperands,
     /*  544248 */     // GIR_Coverage, 4305,
     /*  544248 */     GIR_EraseRootFromParent_Done,
     /*  544249 */   // Label 8974: @544249
     /*  544249 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(544320), // Rule ID 4314 //
     /*  544254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544282 */     // MIs[0] passthru
     /*  544282 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544298 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  544301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544318 */     GIR_RootConstrainSelectedInstOperands,
     /*  544319 */     // GIR_Coverage, 4314,
     /*  544319 */     GIR_EraseRootFromParent_Done,
     /*  544320 */   // Label 8975: @544320
     /*  544320 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(544391), // Rule ID 4315 //
     /*  544325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544353 */     // MIs[0] passthru
     /*  544353 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544369 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  544372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544389 */     GIR_RootConstrainSelectedInstOperands,
     /*  544390 */     // GIR_Coverage, 4315,
     /*  544390 */     GIR_EraseRootFromParent_Done,
     /*  544391 */   // Label 8976: @544391
     /*  544391 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(544462), // Rule ID 4324 //
     /*  544396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544424 */     // MIs[0] passthru
     /*  544424 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  544443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544460 */     GIR_RootConstrainSelectedInstOperands,
     /*  544461 */     // GIR_Coverage, 4324,
     /*  544461 */     GIR_EraseRootFromParent_Done,
     /*  544462 */   // Label 8977: @544462
     /*  544462 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(544533), // Rule ID 4325 //
     /*  544467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544495 */     // MIs[0] passthru
     /*  544495 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  544514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544531 */     GIR_RootConstrainSelectedInstOperands,
     /*  544532 */     // GIR_Coverage, 4325,
     /*  544532 */     GIR_EraseRootFromParent_Done,
     /*  544533 */   // Label 8978: @544533
     /*  544533 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(544604), // Rule ID 4334 //
     /*  544538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544566 */     // MIs[0] passthru
     /*  544566 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  544585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544602 */     GIR_RootConstrainSelectedInstOperands,
     /*  544603 */     // GIR_Coverage, 4334,
     /*  544603 */     GIR_EraseRootFromParent_Done,
     /*  544604 */   // Label 8979: @544604
     /*  544604 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(544675), // Rule ID 4335 //
     /*  544609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544637 */     // MIs[0] passthru
     /*  544637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  544656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544673 */     GIR_RootConstrainSelectedInstOperands,
     /*  544674 */     // GIR_Coverage, 4335,
     /*  544674 */     GIR_EraseRootFromParent_Done,
     /*  544675 */   // Label 8980: @544675
     /*  544675 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(544746), // Rule ID 4344 //
     /*  544680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544708 */     // MIs[0] passthru
     /*  544708 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544744 */     GIR_RootConstrainSelectedInstOperands,
     /*  544745 */     // GIR_Coverage, 4344,
     /*  544745 */     GIR_EraseRootFromParent_Done,
     /*  544746 */   // Label 8981: @544746
     /*  544746 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(544817), // Rule ID 4345 //
     /*  544751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544779 */     // MIs[0] passthru
     /*  544779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  544798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544815 */     GIR_RootConstrainSelectedInstOperands,
     /*  544816 */     // GIR_Coverage, 4345,
     /*  544816 */     GIR_EraseRootFromParent_Done,
     /*  544817 */   // Label 8982: @544817
     /*  544817 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(544888), // Rule ID 4354 //
     /*  544822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544850 */     // MIs[0] passthru
     /*  544850 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544886 */     GIR_RootConstrainSelectedInstOperands,
     /*  544887 */     // GIR_Coverage, 4354,
     /*  544887 */     GIR_EraseRootFromParent_Done,
     /*  544888 */   // Label 8983: @544888
     /*  544888 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(544959), // Rule ID 4355 //
     /*  544893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544921 */     // MIs[0] passthru
     /*  544921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  544940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544957 */     GIR_RootConstrainSelectedInstOperands,
     /*  544958 */     // GIR_Coverage, 4355,
     /*  544958 */     GIR_EraseRootFromParent_Done,
     /*  544959 */   // Label 8984: @544959
     /*  544959 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(545030), // Rule ID 4364 //
     /*  544964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  544972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  544975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  544978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  544981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544992 */     // MIs[0] passthru
     /*  544992 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545028 */     GIR_RootConstrainSelectedInstOperands,
     /*  545029 */     // GIR_Coverage, 4364,
     /*  545029 */     GIR_EraseRootFromParent_Done,
     /*  545030 */   // Label 8985: @545030
     /*  545030 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(545101), // Rule ID 4365 //
     /*  545035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545063 */     // MIs[0] passthru
     /*  545063 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545079 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545099 */     GIR_RootConstrainSelectedInstOperands,
     /*  545100 */     // GIR_Coverage, 4365,
     /*  545100 */     GIR_EraseRootFromParent_Done,
     /*  545101 */   // Label 8986: @545101
     /*  545101 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(545172), // Rule ID 4374 //
     /*  545106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545134 */     // MIs[0] passthru
     /*  545134 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  545153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545170 */     GIR_RootConstrainSelectedInstOperands,
     /*  545171 */     // GIR_Coverage, 4374,
     /*  545171 */     GIR_EraseRootFromParent_Done,
     /*  545172 */   // Label 8987: @545172
     /*  545172 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(545243), // Rule ID 4375 //
     /*  545177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545205 */     // MIs[0] passthru
     /*  545205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  545224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545241 */     GIR_RootConstrainSelectedInstOperands,
     /*  545242 */     // GIR_Coverage, 4375,
     /*  545242 */     GIR_EraseRootFromParent_Done,
     /*  545243 */   // Label 8988: @545243
     /*  545243 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(545314), // Rule ID 4384 //
     /*  545248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545276 */     // MIs[0] passthru
     /*  545276 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  545295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545312 */     GIR_RootConstrainSelectedInstOperands,
     /*  545313 */     // GIR_Coverage, 4384,
     /*  545313 */     GIR_EraseRootFromParent_Done,
     /*  545314 */   // Label 8989: @545314
     /*  545314 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(545385), // Rule ID 4385 //
     /*  545319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545347 */     // MIs[0] passthru
     /*  545347 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  545366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545383 */     GIR_RootConstrainSelectedInstOperands,
     /*  545384 */     // GIR_Coverage, 4385,
     /*  545384 */     GIR_EraseRootFromParent_Done,
     /*  545385 */   // Label 8990: @545385
     /*  545385 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(545456), // Rule ID 4394 //
     /*  545390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545418 */     // MIs[0] passthru
     /*  545418 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  545437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545454 */     GIR_RootConstrainSelectedInstOperands,
     /*  545455 */     // GIR_Coverage, 4394,
     /*  545455 */     GIR_EraseRootFromParent_Done,
     /*  545456 */   // Label 8991: @545456
     /*  545456 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(545527), // Rule ID 4395 //
     /*  545461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545489 */     // MIs[0] passthru
     /*  545489 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  545508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545525 */     GIR_RootConstrainSelectedInstOperands,
     /*  545526 */     // GIR_Coverage, 4395,
     /*  545526 */     GIR_EraseRootFromParent_Done,
     /*  545527 */   // Label 8992: @545527
     /*  545527 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(545598), // Rule ID 4404 //
     /*  545532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545560 */     // MIs[0] passthru
     /*  545560 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545576 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545596 */     GIR_RootConstrainSelectedInstOperands,
     /*  545597 */     // GIR_Coverage, 4404,
     /*  545597 */     GIR_EraseRootFromParent_Done,
     /*  545598 */   // Label 8993: @545598
     /*  545598 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(545669), // Rule ID 4405 //
     /*  545603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  545611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545631 */     // MIs[0] passthru
     /*  545631 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545647 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  545650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545667 */     GIR_RootConstrainSelectedInstOperands,
     /*  545668 */     // GIR_Coverage, 4405,
     /*  545668 */     GIR_EraseRootFromParent_Done,
     /*  545669 */   // Label 8994: @545669
     /*  545669 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(545740), // Rule ID 4474 //
     /*  545674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  545685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  545688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545702 */     // MIs[0] passthru
     /*  545702 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  545721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545738 */     GIR_RootConstrainSelectedInstOperands,
     /*  545739 */     // GIR_Coverage, 4474,
     /*  545739 */     GIR_EraseRootFromParent_Done,
     /*  545740 */   // Label 8995: @545740
     /*  545740 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(545811), // Rule ID 4475 //
     /*  545745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  545756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  545759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545773 */     // MIs[0] passthru
     /*  545773 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545789 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  545792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545809 */     GIR_RootConstrainSelectedInstOperands,
     /*  545810 */     // GIR_Coverage, 4475,
     /*  545810 */     GIR_EraseRootFromParent_Done,
     /*  545811 */   // Label 8996: @545811
     /*  545811 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(545882), // Rule ID 4484 //
     /*  545816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  545827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  545830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  545833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545844 */     // MIs[0] passthru
     /*  545844 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  545863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545880 */     GIR_RootConstrainSelectedInstOperands,
     /*  545881 */     // GIR_Coverage, 4484,
     /*  545881 */     GIR_EraseRootFromParent_Done,
     /*  545882 */   // Label 8997: @545882
     /*  545882 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(545953), // Rule ID 4485 //
     /*  545887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  545898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  545901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  545904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545915 */     // MIs[0] passthru
     /*  545915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545931 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  545934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545951 */     GIR_RootConstrainSelectedInstOperands,
     /*  545952 */     // GIR_Coverage, 4485,
     /*  545952 */     GIR_EraseRootFromParent_Done,
     /*  545953 */   // Label 8998: @545953
     /*  545953 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(546024), // Rule ID 4494 //
     /*  545958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  545966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  545969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  545972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  545975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545986 */     // MIs[0] passthru
     /*  545986 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546022 */     GIR_RootConstrainSelectedInstOperands,
     /*  546023 */     // GIR_Coverage, 4494,
     /*  546023 */     GIR_EraseRootFromParent_Done,
     /*  546024 */   // Label 8999: @546024
     /*  546024 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(546095), // Rule ID 4495 //
     /*  546029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  546040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  546043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  546046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546057 */     // MIs[0] passthru
     /*  546057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546073 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546093 */     GIR_RootConstrainSelectedInstOperands,
     /*  546094 */     // GIR_Coverage, 4495,
     /*  546094 */     GIR_EraseRootFromParent_Done,
     /*  546095 */   // Label 9000: @546095
     /*  546095 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(546166), // Rule ID 4504 //
     /*  546100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  546111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  546114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546128 */     // MIs[0] passthru
     /*  546128 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546164 */     GIR_RootConstrainSelectedInstOperands,
     /*  546165 */     // GIR_Coverage, 4504,
     /*  546165 */     GIR_EraseRootFromParent_Done,
     /*  546166 */   // Label 9001: @546166
     /*  546166 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(546237), // Rule ID 4505 //
     /*  546171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  546182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  546185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546199 */     // MIs[0] passthru
     /*  546199 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546235 */     GIR_RootConstrainSelectedInstOperands,
     /*  546236 */     // GIR_Coverage, 4505,
     /*  546236 */     GIR_EraseRootFromParent_Done,
     /*  546237 */   // Label 9002: @546237
     /*  546237 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(546308), // Rule ID 4514 //
     /*  546242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  546253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  546256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  546259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546270 */     // MIs[0] passthru
     /*  546270 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546306 */     GIR_RootConstrainSelectedInstOperands,
     /*  546307 */     // GIR_Coverage, 4514,
     /*  546307 */     GIR_EraseRootFromParent_Done,
     /*  546308 */   // Label 9003: @546308
     /*  546308 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(546379), // Rule ID 4515 //
     /*  546313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  546324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  546327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  546330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546341 */     // MIs[0] passthru
     /*  546341 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546357 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546377 */     GIR_RootConstrainSelectedInstOperands,
     /*  546378 */     // GIR_Coverage, 4515,
     /*  546378 */     GIR_EraseRootFromParent_Done,
     /*  546379 */   // Label 9004: @546379
     /*  546379 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(546450), // Rule ID 4524 //
     /*  546384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  546395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  546398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  546401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546412 */     // MIs[0] passthru
     /*  546412 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546428 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  546431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546448 */     GIR_RootConstrainSelectedInstOperands,
     /*  546449 */     // GIR_Coverage, 4524,
     /*  546449 */     GIR_EraseRootFromParent_Done,
     /*  546450 */   // Label 9005: @546450
     /*  546450 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(546521), // Rule ID 4525 //
     /*  546455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  546466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  546469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  546472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546483 */     // MIs[0] passthru
     /*  546483 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  546502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546519 */     GIR_RootConstrainSelectedInstOperands,
     /*  546520 */     // GIR_Coverage, 4525,
     /*  546520 */     GIR_EraseRootFromParent_Done,
     /*  546521 */   // Label 9006: @546521
     /*  546521 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(546592), // Rule ID 4534 //
     /*  546526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  546537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  546540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  546543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546554 */     // MIs[0] passthru
     /*  546554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  546573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546590 */     GIR_RootConstrainSelectedInstOperands,
     /*  546591 */     // GIR_Coverage, 4534,
     /*  546591 */     GIR_EraseRootFromParent_Done,
     /*  546592 */   // Label 9007: @546592
     /*  546592 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(546663), // Rule ID 4535 //
     /*  546597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  546608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  546611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  546614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546625 */     // MIs[0] passthru
     /*  546625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  546644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546661 */     GIR_RootConstrainSelectedInstOperands,
     /*  546662 */     // GIR_Coverage, 4535,
     /*  546662 */     GIR_EraseRootFromParent_Done,
     /*  546663 */   // Label 9008: @546663
     /*  546663 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(546734), // Rule ID 4544 //
     /*  546668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  546679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  546682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  546685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546696 */     // MIs[0] passthru
     /*  546696 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546732 */     GIR_RootConstrainSelectedInstOperands,
     /*  546733 */     // GIR_Coverage, 4544,
     /*  546733 */     GIR_EraseRootFromParent_Done,
     /*  546734 */   // Label 9009: @546734
     /*  546734 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(546805), // Rule ID 4545 //
     /*  546739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  546750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  546753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  546756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546767 */     // MIs[0] passthru
     /*  546767 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  546786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546803 */     GIR_RootConstrainSelectedInstOperands,
     /*  546804 */     // GIR_Coverage, 4545,
     /*  546804 */     GIR_EraseRootFromParent_Done,
     /*  546805 */   // Label 9010: @546805
     /*  546805 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(546876), // Rule ID 4554 //
     /*  546810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  546827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546838 */     // MIs[0] passthru
     /*  546838 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546874 */     GIR_RootConstrainSelectedInstOperands,
     /*  546875 */     // GIR_Coverage, 4554,
     /*  546875 */     GIR_EraseRootFromParent_Done,
     /*  546876 */   // Label 9011: @546876
     /*  546876 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(546947), // Rule ID 4555 //
     /*  546881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  546892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  546895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  546898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546909 */     // MIs[0] passthru
     /*  546909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  546925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  546928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546945 */     GIR_RootConstrainSelectedInstOperands,
     /*  546946 */     // GIR_Coverage, 4555,
     /*  546946 */     GIR_EraseRootFromParent_Done,
     /*  546947 */   // Label 9012: @546947
     /*  546947 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(547018), // Rule ID 4564 //
     /*  546952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  546960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  546963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  546966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  546969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546980 */     // MIs[0] passthru
     /*  546980 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  546989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  546999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547016 */     GIR_RootConstrainSelectedInstOperands,
     /*  547017 */     // GIR_Coverage, 4564,
     /*  547017 */     GIR_EraseRootFromParent_Done,
     /*  547018 */   // Label 9013: @547018
     /*  547018 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(547089), // Rule ID 4565 //
     /*  547023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  547034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  547037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  547040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547051 */     // MIs[0] passthru
     /*  547051 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547087 */     GIR_RootConstrainSelectedInstOperands,
     /*  547088 */     // GIR_Coverage, 4565,
     /*  547088 */     GIR_EraseRootFromParent_Done,
     /*  547089 */   // Label 9014: @547089
     /*  547089 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(547160), // Rule ID 4574 //
     /*  547094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  547105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  547108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  547111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547122 */     // MIs[0] passthru
     /*  547122 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547138 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547158 */     GIR_RootConstrainSelectedInstOperands,
     /*  547159 */     // GIR_Coverage, 4574,
     /*  547159 */     GIR_EraseRootFromParent_Done,
     /*  547160 */   // Label 9015: @547160
     /*  547160 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(547231), // Rule ID 4575 //
     /*  547165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  547176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  547179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  547182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547193 */     // MIs[0] passthru
     /*  547193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547209 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547229 */     GIR_RootConstrainSelectedInstOperands,
     /*  547230 */     // GIR_Coverage, 4575,
     /*  547230 */     GIR_EraseRootFromParent_Done,
     /*  547231 */   // Label 9016: @547231
     /*  547231 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(547302), // Rule ID 4584 //
     /*  547236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547264 */     // MIs[0] passthru
     /*  547264 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  547283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547300 */     GIR_RootConstrainSelectedInstOperands,
     /*  547301 */     // GIR_Coverage, 4584,
     /*  547301 */     GIR_EraseRootFromParent_Done,
     /*  547302 */   // Label 9017: @547302
     /*  547302 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(547373), // Rule ID 4585 //
     /*  547307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547335 */     // MIs[0] passthru
     /*  547335 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  547354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547371 */     GIR_RootConstrainSelectedInstOperands,
     /*  547372 */     // GIR_Coverage, 4585,
     /*  547372 */     GIR_EraseRootFromParent_Done,
     /*  547373 */   // Label 9018: @547373
     /*  547373 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(547444), // Rule ID 4594 //
     /*  547378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  547389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  547392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547406 */     // MIs[0] passthru
     /*  547406 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  547425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547442 */     GIR_RootConstrainSelectedInstOperands,
     /*  547443 */     // GIR_Coverage, 4594,
     /*  547443 */     GIR_EraseRootFromParent_Done,
     /*  547444 */   // Label 9019: @547444
     /*  547444 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(547515), // Rule ID 4595 //
     /*  547449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  547460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  547463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547477 */     // MIs[0] passthru
     /*  547477 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  547496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547513 */     GIR_RootConstrainSelectedInstOperands,
     /*  547514 */     // GIR_Coverage, 4595,
     /*  547514 */     GIR_EraseRootFromParent_Done,
     /*  547515 */   // Label 9020: @547515
     /*  547515 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(547586), // Rule ID 4604 //
     /*  547520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  547531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  547534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  547537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547548 */     // MIs[0] passthru
     /*  547548 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547584 */     GIR_RootConstrainSelectedInstOperands,
     /*  547585 */     // GIR_Coverage, 4604,
     /*  547585 */     GIR_EraseRootFromParent_Done,
     /*  547586 */   // Label 9021: @547586
     /*  547586 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(547657), // Rule ID 4605 //
     /*  547591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  547602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  547605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  547608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547619 */     // MIs[0] passthru
     /*  547619 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547635 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  547638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547655 */     GIR_RootConstrainSelectedInstOperands,
     /*  547656 */     // GIR_Coverage, 4605,
     /*  547656 */     GIR_EraseRootFromParent_Done,
     /*  547657 */   // Label 9022: @547657
     /*  547657 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(547728), // Rule ID 4614 //
     /*  547662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  547665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  547673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  547676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  547679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547690 */     // MIs[0] passthru
     /*  547690 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547726 */     GIR_RootConstrainSelectedInstOperands,
     /*  547727 */     // GIR_Coverage, 4614,
     /*  547727 */     GIR_EraseRootFromParent_Done,
     /*  547728 */   // Label 9023: @547728
     /*  547728 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(547799), // Rule ID 4615 //
     /*  547733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  547736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  547741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  547744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  547747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  547750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  547761 */     // MIs[0] passthru
     /*  547761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  547770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  547780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547797 */     GIR_RootConstrainSelectedInstOperands,
     /*  547798 */     // GIR_Coverage, 4615,
     /*  547798 */     GIR_EraseRootFromParent_Done,
     /*  547799 */   // Label 9024: @547799
     /*  547799 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(547870), // Rule ID 4684 //
     /*  547804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547832 */     // MIs[0] passthru
     /*  547832 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547848 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  547851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547868 */     GIR_RootConstrainSelectedInstOperands,
     /*  547869 */     // GIR_Coverage, 4684,
     /*  547869 */     GIR_EraseRootFromParent_Done,
     /*  547870 */   // Label 9025: @547870
     /*  547870 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(547941), // Rule ID 4685 //
     /*  547875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547903 */     // MIs[0] passthru
     /*  547903 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547919 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  547922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547939 */     GIR_RootConstrainSelectedInstOperands,
     /*  547940 */     // GIR_Coverage, 4685,
     /*  547940 */     GIR_EraseRootFromParent_Done,
     /*  547941 */   // Label 9026: @547941
     /*  547941 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(548012), // Rule ID 4694 //
     /*  547946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  547954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547974 */     // MIs[0] passthru
     /*  547974 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  547979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  547993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  547999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548010 */     GIR_RootConstrainSelectedInstOperands,
     /*  548011 */     // GIR_Coverage, 4694,
     /*  548011 */     GIR_EraseRootFromParent_Done,
     /*  548012 */   // Label 9027: @548012
     /*  548012 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(548083), // Rule ID 4695 //
     /*  548017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  548028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  548031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  548034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548045 */     // MIs[0] passthru
     /*  548045 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548061 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548081 */     GIR_RootConstrainSelectedInstOperands,
     /*  548082 */     // GIR_Coverage, 4695,
     /*  548082 */     GIR_EraseRootFromParent_Done,
     /*  548083 */   // Label 9028: @548083
     /*  548083 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(548154), // Rule ID 4704 //
     /*  548088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  548105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548116 */     // MIs[0] passthru
     /*  548116 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548152 */     GIR_RootConstrainSelectedInstOperands,
     /*  548153 */     // GIR_Coverage, 4704,
     /*  548153 */     GIR_EraseRootFromParent_Done,
     /*  548154 */   // Label 9029: @548154
     /*  548154 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(548225), // Rule ID 4705 //
     /*  548159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  548176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548187 */     // MIs[0] passthru
     /*  548187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548203 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548223 */     GIR_RootConstrainSelectedInstOperands,
     /*  548224 */     // GIR_Coverage, 4705,
     /*  548224 */     GIR_EraseRootFromParent_Done,
     /*  548225 */   // Label 9030: @548225
     /*  548225 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(548296), // Rule ID 4714 //
     /*  548230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548258 */     // MIs[0] passthru
     /*  548258 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548274 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548294 */     GIR_RootConstrainSelectedInstOperands,
     /*  548295 */     // GIR_Coverage, 4714,
     /*  548295 */     GIR_EraseRootFromParent_Done,
     /*  548296 */   // Label 9031: @548296
     /*  548296 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(548367), // Rule ID 4715 //
     /*  548301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  548318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548329 */     // MIs[0] passthru
     /*  548329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548365 */     GIR_RootConstrainSelectedInstOperands,
     /*  548366 */     // GIR_Coverage, 4715,
     /*  548366 */     GIR_EraseRootFromParent_Done,
     /*  548367 */   // Label 9032: @548367
     /*  548367 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(548438), // Rule ID 4724 //
     /*  548372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548400 */     // MIs[0] passthru
     /*  548400 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  548419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548436 */     GIR_RootConstrainSelectedInstOperands,
     /*  548437 */     // GIR_Coverage, 4724,
     /*  548437 */     GIR_EraseRootFromParent_Done,
     /*  548438 */   // Label 9033: @548438
     /*  548438 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(548509), // Rule ID 4725 //
     /*  548443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548471 */     // MIs[0] passthru
     /*  548471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548487 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  548490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548507 */     GIR_RootConstrainSelectedInstOperands,
     /*  548508 */     // GIR_Coverage, 4725,
     /*  548508 */     GIR_EraseRootFromParent_Done,
     /*  548509 */   // Label 9034: @548509
     /*  548509 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(548580), // Rule ID 4734 //
     /*  548514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548542 */     // MIs[0] passthru
     /*  548542 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  548561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548578 */     GIR_RootConstrainSelectedInstOperands,
     /*  548579 */     // GIR_Coverage, 4734,
     /*  548579 */     GIR_EraseRootFromParent_Done,
     /*  548580 */   // Label 9035: @548580
     /*  548580 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(548651), // Rule ID 4735 //
     /*  548585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548613 */     // MIs[0] passthru
     /*  548613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548629 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  548632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548649 */     GIR_RootConstrainSelectedInstOperands,
     /*  548650 */     // GIR_Coverage, 4735,
     /*  548650 */     GIR_EraseRootFromParent_Done,
     /*  548651 */   // Label 9036: @548651
     /*  548651 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(548722), // Rule ID 4744 //
     /*  548656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  548673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548684 */     // MIs[0] passthru
     /*  548684 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548720 */     GIR_RootConstrainSelectedInstOperands,
     /*  548721 */     // GIR_Coverage, 4744,
     /*  548721 */     GIR_EraseRootFromParent_Done,
     /*  548722 */   // Label 9037: @548722
     /*  548722 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(548793), // Rule ID 4745 //
     /*  548727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  548738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  548741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  548744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548755 */     // MIs[0] passthru
     /*  548755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548771 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  548774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548791 */     GIR_RootConstrainSelectedInstOperands,
     /*  548792 */     // GIR_Coverage, 4745,
     /*  548792 */     GIR_EraseRootFromParent_Done,
     /*  548793 */   // Label 9038: @548793
     /*  548793 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(548864), // Rule ID 4754 //
     /*  548798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548826 */     // MIs[0] passthru
     /*  548826 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548862 */     GIR_RootConstrainSelectedInstOperands,
     /*  548863 */     // GIR_Coverage, 4754,
     /*  548863 */     GIR_EraseRootFromParent_Done,
     /*  548864 */   // Label 9039: @548864
     /*  548864 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(548935), // Rule ID 4755 //
     /*  548869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  548886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548897 */     // MIs[0] passthru
     /*  548897 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548913 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  548916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548933 */     GIR_RootConstrainSelectedInstOperands,
     /*  548934 */     // GIR_Coverage, 4755,
     /*  548934 */     GIR_EraseRootFromParent_Done,
     /*  548935 */   // Label 9040: @548935
     /*  548935 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(549006), // Rule ID 4764 //
     /*  548940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  548948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  548951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  548954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548968 */     // MIs[0] passthru
     /*  548968 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  548973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  548987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  548993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549004 */     GIR_RootConstrainSelectedInstOperands,
     /*  549005 */     // GIR_Coverage, 4764,
     /*  549005 */     GIR_EraseRootFromParent_Done,
     /*  549006 */   // Label 9041: @549006
     /*  549006 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(549077), // Rule ID 4765 //
     /*  549011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  549028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549039 */     // MIs[0] passthru
     /*  549039 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549075 */     GIR_RootConstrainSelectedInstOperands,
     /*  549076 */     // GIR_Coverage, 4765,
     /*  549076 */     GIR_EraseRootFromParent_Done,
     /*  549077 */   // Label 9042: @549077
     /*  549077 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(549148), // Rule ID 4774 //
     /*  549082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549110 */     // MIs[0] passthru
     /*  549110 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549146 */     GIR_RootConstrainSelectedInstOperands,
     /*  549147 */     // GIR_Coverage, 4774,
     /*  549147 */     GIR_EraseRootFromParent_Done,
     /*  549148 */   // Label 9043: @549148
     /*  549148 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(549219), // Rule ID 4775 //
     /*  549153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549181 */     // MIs[0] passthru
     /*  549181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549197 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549217 */     GIR_RootConstrainSelectedInstOperands,
     /*  549218 */     // GIR_Coverage, 4775,
     /*  549218 */     GIR_EraseRootFromParent_Done,
     /*  549219 */   // Label 9044: @549219
     /*  549219 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(549290), // Rule ID 4784 //
     /*  549224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549252 */     // MIs[0] passthru
     /*  549252 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549288 */     GIR_RootConstrainSelectedInstOperands,
     /*  549289 */     // GIR_Coverage, 4784,
     /*  549289 */     GIR_EraseRootFromParent_Done,
     /*  549290 */   // Label 9045: @549290
     /*  549290 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(549361), // Rule ID 4785 //
     /*  549295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549323 */     // MIs[0] passthru
     /*  549323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549359 */     GIR_RootConstrainSelectedInstOperands,
     /*  549360 */     // GIR_Coverage, 4785,
     /*  549360 */     GIR_EraseRootFromParent_Done,
     /*  549361 */   // Label 9046: @549361
     /*  549361 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(549432), // Rule ID 4794 //
     /*  549366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  549377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  549380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  549383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549394 */     // MIs[0] passthru
     /*  549394 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  549413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549430 */     GIR_RootConstrainSelectedInstOperands,
     /*  549431 */     // GIR_Coverage, 4794,
     /*  549431 */     GIR_EraseRootFromParent_Done,
     /*  549432 */   // Label 9047: @549432
     /*  549432 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(549503), // Rule ID 4795 //
     /*  549437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  549448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  549451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  549454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549465 */     // MIs[0] passthru
     /*  549465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  549484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549501 */     GIR_RootConstrainSelectedInstOperands,
     /*  549502 */     // GIR_Coverage, 4795,
     /*  549502 */     GIR_EraseRootFromParent_Done,
     /*  549503 */   // Label 9048: @549503
     /*  549503 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(549574), // Rule ID 4804 //
     /*  549508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  549525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549536 */     // MIs[0] passthru
     /*  549536 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549572 */     GIR_RootConstrainSelectedInstOperands,
     /*  549573 */     // GIR_Coverage, 4804,
     /*  549573 */     GIR_EraseRootFromParent_Done,
     /*  549574 */   // Label 9049: @549574
     /*  549574 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(549645), // Rule ID 4805 //
     /*  549579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  549596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549607 */     // MIs[0] passthru
     /*  549607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  549626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549643 */     GIR_RootConstrainSelectedInstOperands,
     /*  549644 */     // GIR_Coverage, 4805,
     /*  549644 */     GIR_EraseRootFromParent_Done,
     /*  549645 */   // Label 9050: @549645
     /*  549645 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(549716), // Rule ID 4814 //
     /*  549650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549678 */     // MIs[0] passthru
     /*  549678 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549694 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549714 */     GIR_RootConstrainSelectedInstOperands,
     /*  549715 */     // GIR_Coverage, 4814,
     /*  549715 */     GIR_EraseRootFromParent_Done,
     /*  549716 */   // Label 9051: @549716
     /*  549716 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(549787), // Rule ID 4815 //
     /*  549721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549749 */     // MIs[0] passthru
     /*  549749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549765 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  549768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549785 */     GIR_RootConstrainSelectedInstOperands,
     /*  549786 */     // GIR_Coverage, 4815,
     /*  549786 */     GIR_EraseRootFromParent_Done,
     /*  549787 */   // Label 9052: @549787
     /*  549787 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(549858), // Rule ID 4824 //
     /*  549792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  549795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549820 */     // MIs[0] passthru
     /*  549820 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549856 */     GIR_RootConstrainSelectedInstOperands,
     /*  549857 */     // GIR_Coverage, 4824,
     /*  549857 */     GIR_EraseRootFromParent_Done,
     /*  549858 */   // Label 9053: @549858
     /*  549858 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(549929), // Rule ID 4825 //
     /*  549863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  549866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  549871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549891 */     // MIs[0] passthru
     /*  549891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  549896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549907 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  549910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549927 */     GIR_RootConstrainSelectedInstOperands,
     /*  549928 */     // GIR_Coverage, 4825,
     /*  549928 */     GIR_EraseRootFromParent_Done,
     /*  549929 */   // Label 9054: @549929
     /*  549929 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(550001), // Rule ID 2680 //
     /*  549934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  549942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  549945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  549948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  549951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  549954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  549980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  549983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549999 */     GIR_RootConstrainSelectedInstOperands,
     /*  550000 */     // GIR_Coverage, 2680,
     /*  550000 */     GIR_EraseRootFromParent_Done,
     /*  550001 */   // Label 9055: @550001
     /*  550001 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(550073), // Rule ID 2681 //
     /*  550006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  550014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  550052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  550055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550071 */     GIR_RootConstrainSelectedInstOperands,
     /*  550072 */     // GIR_Coverage, 2681,
     /*  550072 */     GIR_EraseRootFromParent_Done,
     /*  550073 */   // Label 9056: @550073
     /*  550073 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(550148), // Rule ID 2684 //
     /*  550078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  550081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  550086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  550092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  550095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  550105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  550124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  550127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  550146 */     GIR_RootConstrainSelectedInstOperands,
     /*  550147 */     // GIR_Coverage, 2684,
     /*  550147 */     GIR_EraseRootFromParent_Done,
     /*  550148 */   // Label 9057: @550148
     /*  550148 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(550223), // Rule ID 2685 //
     /*  550153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  550156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  550161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  550167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  550170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  550180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550199 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  550199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  550202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  550221 */     GIR_RootConstrainSelectedInstOperands,
     /*  550222 */     // GIR_Coverage, 2685,
     /*  550222 */     GIR_EraseRootFromParent_Done,
     /*  550223 */   // Label 9058: @550223
     /*  550223 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(550298), // Rule ID 2712 //
     /*  550228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  550277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550296 */     GIR_RootConstrainSelectedInstOperands,
     /*  550297 */     // GIR_Coverage, 2712,
     /*  550297 */     GIR_EraseRootFromParent_Done,
     /*  550298 */   // Label 9059: @550298
     /*  550298 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(550373), // Rule ID 2713 //
     /*  550303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550349 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  550352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550371 */     GIR_RootConstrainSelectedInstOperands,
     /*  550372 */     // GIR_Coverage, 2713,
     /*  550372 */     GIR_EraseRootFromParent_Done,
     /*  550373 */   // Label 9060: @550373
     /*  550373 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(550445), // Rule ID 2726 //
     /*  550378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  550386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  550424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  550427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  550431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550443 */     GIR_RootConstrainSelectedInstOperands,
     /*  550444 */     // GIR_Coverage, 2726,
     /*  550444 */     GIR_EraseRootFromParent_Done,
     /*  550445 */   // Label 9061: @550445
     /*  550445 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(550517), // Rule ID 2727 //
     /*  550450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  550458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  550461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  550470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  550489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  550496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  550499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  550503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  550507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550515 */     GIR_RootConstrainSelectedInstOperands,
     /*  550516 */     // GIR_Coverage, 2727,
     /*  550516 */     GIR_EraseRootFromParent_Done,
     /*  550517 */   // Label 9062: @550517
     /*  550517 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(550592), // Rule ID 2746 //
     /*  550522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  550530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  550571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550590 */     GIR_RootConstrainSelectedInstOperands,
     /*  550591 */     // GIR_Coverage, 2746,
     /*  550591 */     GIR_EraseRootFromParent_Done,
     /*  550592 */   // Label 9063: @550592
     /*  550592 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(550667), // Rule ID 2747 //
     /*  550597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  550605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  550646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550665 */     GIR_RootConstrainSelectedInstOperands,
     /*  550666 */     // GIR_Coverage, 2747,
     /*  550666 */     GIR_EraseRootFromParent_Done,
     /*  550667 */   // Label 9064: @550667
     /*  550667 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(550742), // Rule ID 2772 //
     /*  550672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  550680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  550721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  550725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550740 */     GIR_RootConstrainSelectedInstOperands,
     /*  550741 */     // GIR_Coverage, 2772,
     /*  550741 */     GIR_EraseRootFromParent_Done,
     /*  550742 */   // Label 9065: @550742
     /*  550742 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(550817), // Rule ID 2773 //
     /*  550747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  550755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  550796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  550800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550815 */     GIR_RootConstrainSelectedInstOperands,
     /*  550816 */     // GIR_Coverage, 2773,
     /*  550816 */     GIR_EraseRootFromParent_Done,
     /*  550817 */   // Label 9066: @550817
     /*  550817 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(550892), // Rule ID 2784 //
     /*  550822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  550871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550890 */     GIR_RootConstrainSelectedInstOperands,
     /*  550891 */     // GIR_Coverage, 2784,
     /*  550891 */     GIR_EraseRootFromParent_Done,
     /*  550892 */   // Label 9067: @550892
     /*  550892 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(550967), // Rule ID 2785 //
     /*  550897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  550908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  550911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  550914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  550917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550943 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  550946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550965 */     GIR_RootConstrainSelectedInstOperands,
     /*  550966 */     // GIR_Coverage, 2785,
     /*  550966 */     GIR_EraseRootFromParent_Done,
     /*  550967 */   // Label 9068: @550967
     /*  550967 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(551042), // Rule ID 2792 //
     /*  550972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551040 */     GIR_RootConstrainSelectedInstOperands,
     /*  551041 */     // GIR_Coverage, 2792,
     /*  551041 */     GIR_EraseRootFromParent_Done,
     /*  551042 */   // Label 9069: @551042
     /*  551042 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(551117), // Rule ID 2793 //
     /*  551047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  551058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  551061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  551064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  551067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551115 */     GIR_RootConstrainSelectedInstOperands,
     /*  551116 */     // GIR_Coverage, 2793,
     /*  551116 */     GIR_EraseRootFromParent_Done,
     /*  551117 */   // Label 9070: @551117
     /*  551117 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(551192), // Rule ID 2800 //
     /*  551122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  551133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  551136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  551139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  551142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551190 */     GIR_RootConstrainSelectedInstOperands,
     /*  551191 */     // GIR_Coverage, 2800,
     /*  551191 */     GIR_EraseRootFromParent_Done,
     /*  551192 */   // Label 9071: @551192
     /*  551192 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(551267), // Rule ID 2801 //
     /*  551197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  551208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  551211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  551214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  551217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551265 */     GIR_RootConstrainSelectedInstOperands,
     /*  551266 */     // GIR_Coverage, 2801,
     /*  551266 */     GIR_EraseRootFromParent_Done,
     /*  551267 */   // Label 9072: @551267
     /*  551267 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(551342), // Rule ID 2808 //
     /*  551272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551340 */     GIR_RootConstrainSelectedInstOperands,
     /*  551341 */     // GIR_Coverage, 2808,
     /*  551341 */     GIR_EraseRootFromParent_Done,
     /*  551342 */   // Label 9073: @551342
     /*  551342 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(551417), // Rule ID 2809 //
     /*  551347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  551358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  551361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  551364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  551367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  551396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551415 */     GIR_RootConstrainSelectedInstOperands,
     /*  551416 */     // GIR_Coverage, 2809,
     /*  551416 */     GIR_EraseRootFromParent_Done,
     /*  551417 */   // Label 9074: @551417
     /*  551417 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(551492), // Rule ID 2816 //
     /*  551422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551490 */     GIR_RootConstrainSelectedInstOperands,
     /*  551491 */     // GIR_Coverage, 2816,
     /*  551491 */     GIR_EraseRootFromParent_Done,
     /*  551492 */   // Label 9075: @551492
     /*  551492 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(551567), // Rule ID 2817 //
     /*  551497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  551508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  551511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  551514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  551517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551543 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551565 */     GIR_RootConstrainSelectedInstOperands,
     /*  551566 */     // GIR_Coverage, 2817,
     /*  551566 */     GIR_EraseRootFromParent_Done,
     /*  551567 */   // Label 9076: @551567
     /*  551567 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(551642), // Rule ID 2824 //
     /*  551572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551618 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551640 */     GIR_RootConstrainSelectedInstOperands,
     /*  551641 */     // GIR_Coverage, 2824,
     /*  551641 */     GIR_EraseRootFromParent_Done,
     /*  551642 */   // Label 9077: @551642
     /*  551642 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(551717), // Rule ID 2825 //
     /*  551647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  551658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  551661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  551664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  551667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  551696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551715 */     GIR_RootConstrainSelectedInstOperands,
     /*  551716 */     // GIR_Coverage, 2825,
     /*  551716 */     GIR_EraseRootFromParent_Done,
     /*  551717 */   // Label 9078: @551717
     /*  551717 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(551792), // Rule ID 2832 //
     /*  551722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551768 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551790 */     GIR_RootConstrainSelectedInstOperands,
     /*  551791 */     // GIR_Coverage, 2832,
     /*  551791 */     GIR_EraseRootFromParent_Done,
     /*  551792 */   // Label 9079: @551792
     /*  551792 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(551867), // Rule ID 2833 //
     /*  551797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551843 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551865 */     GIR_RootConstrainSelectedInstOperands,
     /*  551866 */     // GIR_Coverage, 2833,
     /*  551866 */     GIR_EraseRootFromParent_Done,
     /*  551867 */   // Label 9080: @551867
     /*  551867 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(551942), // Rule ID 2840 //
     /*  551872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  551927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  551929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551940 */     GIR_RootConstrainSelectedInstOperands,
     /*  551941 */     // GIR_Coverage, 2840,
     /*  551941 */     GIR_EraseRootFromParent_Done,
     /*  551942 */   // Label 9081: @551942
     /*  551942 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(552017), // Rule ID 2841 //
     /*  551947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  551955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  551996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552015 */     GIR_RootConstrainSelectedInstOperands,
     /*  552016 */     // GIR_Coverage, 2841,
     /*  552016 */     GIR_EraseRootFromParent_Done,
     /*  552017 */   // Label 9082: @552017
     /*  552017 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(552092), // Rule ID 2848 //
     /*  552022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  552033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  552036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  552039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  552042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552090 */     GIR_RootConstrainSelectedInstOperands,
     /*  552091 */     // GIR_Coverage, 2848,
     /*  552091 */     GIR_EraseRootFromParent_Done,
     /*  552092 */   // Label 9083: @552092
     /*  552092 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(552167), // Rule ID 2849 //
     /*  552097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  552108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  552111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  552114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  552117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552165 */     GIR_RootConstrainSelectedInstOperands,
     /*  552166 */     // GIR_Coverage, 2849,
     /*  552166 */     GIR_EraseRootFromParent_Done,
     /*  552167 */   // Label 9084: @552167
     /*  552167 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(552242), // Rule ID 2856 //
     /*  552172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  552218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552240 */     GIR_RootConstrainSelectedInstOperands,
     /*  552241 */     // GIR_Coverage, 2856,
     /*  552241 */     GIR_EraseRootFromParent_Done,
     /*  552242 */   // Label 9085: @552242
     /*  552242 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(552317), // Rule ID 2857 //
     /*  552247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  552258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  552261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  552264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  552267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  552296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552315 */     GIR_RootConstrainSelectedInstOperands,
     /*  552316 */     // GIR_Coverage, 2857,
     /*  552316 */     GIR_EraseRootFromParent_Done,
     /*  552317 */   // Label 9086: @552317
     /*  552317 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(552392), // Rule ID 2864 //
     /*  552322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552390 */     GIR_RootConstrainSelectedInstOperands,
     /*  552391 */     // GIR_Coverage, 2864,
     /*  552391 */     GIR_EraseRootFromParent_Done,
     /*  552392 */   // Label 9087: @552392
     /*  552392 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(552467), // Rule ID 2865 //
     /*  552397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  552408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  552411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  552414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  552417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552465 */     GIR_RootConstrainSelectedInstOperands,
     /*  552466 */     // GIR_Coverage, 2865,
     /*  552466 */     GIR_EraseRootFromParent_Done,
     /*  552467 */   // Label 9088: @552467
     /*  552467 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(552542), // Rule ID 2872 //
     /*  552472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552540 */     GIR_RootConstrainSelectedInstOperands,
     /*  552541 */     // GIR_Coverage, 2872,
     /*  552541 */     GIR_EraseRootFromParent_Done,
     /*  552542 */   // Label 9089: @552542
     /*  552542 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(552617), // Rule ID 2873 //
     /*  552547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  552558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  552561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  552564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  552567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552615 */     GIR_RootConstrainSelectedInstOperands,
     /*  552616 */     // GIR_Coverage, 2873,
     /*  552616 */     GIR_EraseRootFromParent_Done,
     /*  552617 */   // Label 9090: @552617
     /*  552617 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(552692), // Rule ID 2880 //
     /*  552622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552668 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  552671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552690 */     GIR_RootConstrainSelectedInstOperands,
     /*  552691 */     // GIR_Coverage, 2880,
     /*  552691 */     GIR_EraseRootFromParent_Done,
     /*  552692 */   // Label 9091: @552692
     /*  552692 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(552767), // Rule ID 2881 //
     /*  552697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552743 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  552746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552765 */     GIR_RootConstrainSelectedInstOperands,
     /*  552766 */     // GIR_Coverage, 2881,
     /*  552766 */     GIR_EraseRootFromParent_Done,
     /*  552767 */   // Label 9092: @552767
     /*  552767 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(552842), // Rule ID 2888 //
     /*  552772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552840 */     GIR_RootConstrainSelectedInstOperands,
     /*  552841 */     // GIR_Coverage, 2888,
     /*  552841 */     GIR_EraseRootFromParent_Done,
     /*  552842 */   // Label 9093: @552842
     /*  552842 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(552917), // Rule ID 2889 //
     /*  552847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  552896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552915 */     GIR_RootConstrainSelectedInstOperands,
     /*  552916 */     // GIR_Coverage, 2889,
     /*  552916 */     GIR_EraseRootFromParent_Done,
     /*  552917 */   // Label 9094: @552917
     /*  552917 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(552992), // Rule ID 2896 //
     /*  552922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  552930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  552971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  552977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  552979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552990 */     GIR_RootConstrainSelectedInstOperands,
     /*  552991 */     // GIR_Coverage, 2896,
     /*  552991 */     GIR_EraseRootFromParent_Done,
     /*  552992 */   // Label 9095: @552992
     /*  552992 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(553067), // Rule ID 2897 //
     /*  552997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  553008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  553011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  553014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  553017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553065 */     GIR_RootConstrainSelectedInstOperands,
     /*  553066 */     // GIR_Coverage, 2897,
     /*  553066 */     GIR_EraseRootFromParent_Done,
     /*  553067 */   // Label 9096: @553067
     /*  553067 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(553142), // Rule ID 2904 //
     /*  553072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  553083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  553086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  553089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  553092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553140 */     GIR_RootConstrainSelectedInstOperands,
     /*  553141 */     // GIR_Coverage, 2904,
     /*  553141 */     GIR_EraseRootFromParent_Done,
     /*  553142 */   // Label 9097: @553142
     /*  553142 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(553217), // Rule ID 2905 //
     /*  553147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  553158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  553161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  553164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  553167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553215 */     GIR_RootConstrainSelectedInstOperands,
     /*  553216 */     // GIR_Coverage, 2905,
     /*  553216 */     GIR_EraseRootFromParent_Done,
     /*  553217 */   // Label 9098: @553217
     /*  553217 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(553292), // Rule ID 2912 //
     /*  553222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553290 */     GIR_RootConstrainSelectedInstOperands,
     /*  553291 */     // GIR_Coverage, 2912,
     /*  553291 */     GIR_EraseRootFromParent_Done,
     /*  553292 */   // Label 9099: @553292
     /*  553292 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(553367), // Rule ID 2913 //
     /*  553297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  553308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  553311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  553314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  553317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553365 */     GIR_RootConstrainSelectedInstOperands,
     /*  553366 */     // GIR_Coverage, 2913,
     /*  553366 */     GIR_EraseRootFromParent_Done,
     /*  553367 */   // Label 9100: @553367
     /*  553367 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(553442), // Rule ID 2920 //
     /*  553372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553440 */     GIR_RootConstrainSelectedInstOperands,
     /*  553441 */     // GIR_Coverage, 2920,
     /*  553441 */     GIR_EraseRootFromParent_Done,
     /*  553442 */   // Label 9101: @553442
     /*  553442 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(553517), // Rule ID 2921 //
     /*  553447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  553458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  553461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  553464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  553467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553515 */     GIR_RootConstrainSelectedInstOperands,
     /*  553516 */     // GIR_Coverage, 2921,
     /*  553516 */     GIR_EraseRootFromParent_Done,
     /*  553517 */   // Label 9102: @553517
     /*  553517 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(553592), // Rule ID 2928 //
     /*  553522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553590 */     GIR_RootConstrainSelectedInstOperands,
     /*  553591 */     // GIR_Coverage, 2928,
     /*  553591 */     GIR_EraseRootFromParent_Done,
     /*  553592 */   // Label 9103: @553592
     /*  553592 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(553667), // Rule ID 2929 //
     /*  553597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  553608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  553611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  553614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  553617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  553646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553665 */     GIR_RootConstrainSelectedInstOperands,
     /*  553666 */     // GIR_Coverage, 2929,
     /*  553666 */     GIR_EraseRootFromParent_Done,
     /*  553667 */   // Label 9104: @553667
     /*  553667 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(553742), // Rule ID 2936 //
     /*  553672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553740 */     GIR_RootConstrainSelectedInstOperands,
     /*  553741 */     // GIR_Coverage, 2936,
     /*  553741 */     GIR_EraseRootFromParent_Done,
     /*  553742 */   // Label 9105: @553742
     /*  553742 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(553817), // Rule ID 2937 //
     /*  553747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  553796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553815 */     GIR_RootConstrainSelectedInstOperands,
     /*  553816 */     // GIR_Coverage, 2937,
     /*  553816 */     GIR_EraseRootFromParent_Done,
     /*  553817 */   // Label 9106: @553817
     /*  553817 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(553892), // Rule ID 2944 //
     /*  553822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553890 */     GIR_RootConstrainSelectedInstOperands,
     /*  553891 */     // GIR_Coverage, 2944,
     /*  553891 */     GIR_EraseRootFromParent_Done,
     /*  553892 */   // Label 9107: @553892
     /*  553892 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(553967), // Rule ID 2945 //
     /*  553897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553943 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  553946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  553952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  553954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553965 */     GIR_RootConstrainSelectedInstOperands,
     /*  553966 */     // GIR_Coverage, 2945,
     /*  553966 */     GIR_EraseRootFromParent_Done,
     /*  553967 */   // Label 9108: @553967
     /*  553967 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(554042), // Rule ID 2952 //
     /*  553972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  553980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  554018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  554021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  554027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  554029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554040 */     GIR_RootConstrainSelectedInstOperands,
     /*  554041 */     // GIR_Coverage, 2952,
     /*  554041 */     GIR_EraseRootFromParent_Done,
     /*  554042 */   // Label 9109: @554042
     /*  554042 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(554117), // Rule ID 2953 //
     /*  554047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  554050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  554055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  554058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  554061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  554064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  554067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  554093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  554096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  554102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  554104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554115 */     GIR_RootConstrainSelectedInstOperands,
     /*  554116 */     // GIR_Coverage, 2953,
     /*  554116 */     GIR_EraseRootFromParent_Done,
     /*  554117 */   // Label 9110: @554117
     /*  554117 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(554192), // Rule ID 2968 //
     /*  554122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  554142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554190 */     GIR_RootConstrainSelectedInstOperands,
     /*  554191 */     // GIR_Coverage, 2968,
     /*  554191 */     GIR_EraseRootFromParent_Done,
     /*  554192 */   // Label 9111: @554192
     /*  554192 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(554267), // Rule ID 2969 //
     /*  554197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  554208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  554211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  554214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  554217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554265 */     GIR_RootConstrainSelectedInstOperands,
     /*  554266 */     // GIR_Coverage, 2969,
     /*  554266 */     GIR_EraseRootFromParent_Done,
     /*  554267 */   // Label 9112: @554267
     /*  554267 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(554342), // Rule ID 2972 //
     /*  554272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  554292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554340 */     GIR_RootConstrainSelectedInstOperands,
     /*  554341 */     // GIR_Coverage, 2972,
     /*  554341 */     GIR_EraseRootFromParent_Done,
     /*  554342 */   // Label 9113: @554342
     /*  554342 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(554417), // Rule ID 2973 //
     /*  554347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  554358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  554361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  554364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  554367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554393 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554415 */     GIR_RootConstrainSelectedInstOperands,
     /*  554416 */     // GIR_Coverage, 2973,
     /*  554416 */     GIR_EraseRootFromParent_Done,
     /*  554417 */   // Label 9114: @554417
     /*  554417 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(554492), // Rule ID 2976 //
     /*  554422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554468 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554490 */     GIR_RootConstrainSelectedInstOperands,
     /*  554491 */     // GIR_Coverage, 2976,
     /*  554491 */     GIR_EraseRootFromParent_Done,
     /*  554492 */   // Label 9115: @554492
     /*  554492 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(554567), // Rule ID 2977 //
     /*  554497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  554508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  554511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  554514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  554517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554543 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  554546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554565 */     GIR_RootConstrainSelectedInstOperands,
     /*  554566 */     // GIR_Coverage, 2977,
     /*  554566 */     GIR_EraseRootFromParent_Done,
     /*  554567 */   // Label 9116: @554567
     /*  554567 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(554642), // Rule ID 2980 //
     /*  554572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554640 */     GIR_RootConstrainSelectedInstOperands,
     /*  554641 */     // GIR_Coverage, 2980,
     /*  554641 */     GIR_EraseRootFromParent_Done,
     /*  554642 */   // Label 9117: @554642
     /*  554642 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(554717), // Rule ID 2981 //
     /*  554647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  554667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554693 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554715 */     GIR_RootConstrainSelectedInstOperands,
     /*  554716 */     // GIR_Coverage, 2981,
     /*  554716 */     GIR_EraseRootFromParent_Done,
     /*  554717 */   // Label 9118: @554717
     /*  554717 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(554792), // Rule ID 2984 //
     /*  554722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554790 */     GIR_RootConstrainSelectedInstOperands,
     /*  554791 */     // GIR_Coverage, 2984,
     /*  554791 */     GIR_EraseRootFromParent_Done,
     /*  554792 */   // Label 9119: @554792
     /*  554792 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(554867), // Rule ID 2985 //
     /*  554797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  554817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  554846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554865 */     GIR_RootConstrainSelectedInstOperands,
     /*  554866 */     // GIR_Coverage, 2985,
     /*  554866 */     GIR_EraseRootFromParent_Done,
     /*  554867 */   // Label 9120: @554867
     /*  554867 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(554942), // Rule ID 2988 //
     /*  554872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  554921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554940 */     GIR_RootConstrainSelectedInstOperands,
     /*  554941 */     // GIR_Coverage, 2988,
     /*  554941 */     GIR_EraseRootFromParent_Done,
     /*  554942 */   // Label 9121: @554942
     /*  554942 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(555017), // Rule ID 2989 //
     /*  554947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  554967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554993 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  554996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555015 */     GIR_RootConstrainSelectedInstOperands,
     /*  555016 */     // GIR_Coverage, 2989,
     /*  555016 */     GIR_EraseRootFromParent_Done,
     /*  555017 */   // Label 9122: @555017
     /*  555017 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(555092), // Rule ID 2992 //
     /*  555022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  555042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555090 */     GIR_RootConstrainSelectedInstOperands,
     /*  555091 */     // GIR_Coverage, 2992,
     /*  555091 */     GIR_EraseRootFromParent_Done,
     /*  555092 */   // Label 9123: @555092
     /*  555092 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(555167), // Rule ID 2993 //
     /*  555097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  555108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  555111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  555114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  555117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555165 */     GIR_RootConstrainSelectedInstOperands,
     /*  555166 */     // GIR_Coverage, 2993,
     /*  555166 */     GIR_EraseRootFromParent_Done,
     /*  555167 */   // Label 9124: @555167
     /*  555167 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(555242), // Rule ID 2996 //
     /*  555172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  555192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555240 */     GIR_RootConstrainSelectedInstOperands,
     /*  555241 */     // GIR_Coverage, 2996,
     /*  555241 */     GIR_EraseRootFromParent_Done,
     /*  555242 */   // Label 9125: @555242
     /*  555242 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(555317), // Rule ID 2997 //
     /*  555247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  555258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  555261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  555264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  555267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555315 */     GIR_RootConstrainSelectedInstOperands,
     /*  555316 */     // GIR_Coverage, 2997,
     /*  555316 */     GIR_EraseRootFromParent_Done,
     /*  555317 */   // Label 9126: @555317
     /*  555317 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(555392), // Rule ID 3000 //
     /*  555322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  555342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555368 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555390 */     GIR_RootConstrainSelectedInstOperands,
     /*  555391 */     // GIR_Coverage, 3000,
     /*  555391 */     GIR_EraseRootFromParent_Done,
     /*  555392 */   // Label 9127: @555392
     /*  555392 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(555467), // Rule ID 3001 //
     /*  555397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  555408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  555411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  555414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  555417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  555436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555443 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  555446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555465 */     GIR_RootConstrainSelectedInstOperands,
     /*  555466 */     // GIR_Coverage, 3001,
     /*  555466 */     GIR_EraseRootFromParent_Done,
     /*  555467 */   // Label 9128: @555467
     /*  555467 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(555542), // Rule ID 3004 //
     /*  555472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555540 */     GIR_RootConstrainSelectedInstOperands,
     /*  555541 */     // GIR_Coverage, 3004,
     /*  555541 */     GIR_EraseRootFromParent_Done,
     /*  555542 */   // Label 9129: @555542
     /*  555542 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(555617), // Rule ID 3005 //
     /*  555547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  555567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555615 */     GIR_RootConstrainSelectedInstOperands,
     /*  555616 */     // GIR_Coverage, 3005,
     /*  555616 */     GIR_EraseRootFromParent_Done,
     /*  555617 */   // Label 9130: @555617
     /*  555617 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(555692), // Rule ID 3008 //
     /*  555622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  555671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555690 */     GIR_RootConstrainSelectedInstOperands,
     /*  555691 */     // GIR_Coverage, 3008,
     /*  555691 */     GIR_EraseRootFromParent_Done,
     /*  555692 */   // Label 9131: @555692
     /*  555692 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(555767), // Rule ID 3009 //
     /*  555697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  555717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555743 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  555746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555765 */     GIR_RootConstrainSelectedInstOperands,
     /*  555766 */     // GIR_Coverage, 3009,
     /*  555766 */     GIR_EraseRootFromParent_Done,
     /*  555767 */   // Label 9132: @555767
     /*  555767 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(555842), // Rule ID 3012 //
     /*  555772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  555821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555840 */     GIR_RootConstrainSelectedInstOperands,
     /*  555841 */     // GIR_Coverage, 3012,
     /*  555841 */     GIR_EraseRootFromParent_Done,
     /*  555842 */   // Label 9133: @555842
     /*  555842 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(555917), // Rule ID 3013 //
     /*  555847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  555867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555893 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  555896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555915 */     GIR_RootConstrainSelectedInstOperands,
     /*  555916 */     // GIR_Coverage, 3013,
     /*  555916 */     GIR_EraseRootFromParent_Done,
     /*  555917 */   // Label 9134: @555917
     /*  555917 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(555992), // Rule ID 3016 //
     /*  555922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  555942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  555971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555990 */     GIR_RootConstrainSelectedInstOperands,
     /*  555991 */     // GIR_Coverage, 3016,
     /*  555991 */     GIR_EraseRootFromParent_Done,
     /*  555992 */   // Label 9135: @555992
     /*  555992 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(556067), // Rule ID 3017 //
     /*  555997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  556008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  556011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  556014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  556017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556065 */     GIR_RootConstrainSelectedInstOperands,
     /*  556066 */     // GIR_Coverage, 3017,
     /*  556066 */     GIR_EraseRootFromParent_Done,
     /*  556067 */   // Label 9136: @556067
     /*  556067 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(556142), // Rule ID 3020 //
     /*  556072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  556092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556140 */     GIR_RootConstrainSelectedInstOperands,
     /*  556141 */     // GIR_Coverage, 3020,
     /*  556141 */     GIR_EraseRootFromParent_Done,
     /*  556142 */   // Label 9137: @556142
     /*  556142 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(556217), // Rule ID 3021 //
     /*  556147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  556158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  556161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  556164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  556167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556215 */     GIR_RootConstrainSelectedInstOperands,
     /*  556216 */     // GIR_Coverage, 3021,
     /*  556216 */     GIR_EraseRootFromParent_Done,
     /*  556217 */   // Label 9138: @556217
     /*  556217 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(556292), // Rule ID 3024 //
     /*  556222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  556242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556290 */     GIR_RootConstrainSelectedInstOperands,
     /*  556291 */     // GIR_Coverage, 3024,
     /*  556291 */     GIR_EraseRootFromParent_Done,
     /*  556292 */   // Label 9139: @556292
     /*  556292 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(556367), // Rule ID 3025 //
     /*  556297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  556308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  556311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  556314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  556317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556365 */     GIR_RootConstrainSelectedInstOperands,
     /*  556366 */     // GIR_Coverage, 3025,
     /*  556366 */     GIR_EraseRootFromParent_Done,
     /*  556367 */   // Label 9140: @556367
     /*  556367 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(556442), // Rule ID 3028 //
     /*  556372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556440 */     GIR_RootConstrainSelectedInstOperands,
     /*  556441 */     // GIR_Coverage, 3028,
     /*  556441 */     GIR_EraseRootFromParent_Done,
     /*  556442 */   // Label 9141: @556442
     /*  556442 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(556517), // Rule ID 3029 //
     /*  556447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  556458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  556461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  556464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  556467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556515 */     GIR_RootConstrainSelectedInstOperands,
     /*  556516 */     // GIR_Coverage, 3029,
     /*  556516 */     GIR_EraseRootFromParent_Done,
     /*  556517 */   // Label 9142: @556517
     /*  556517 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(556592), // Rule ID 3032 //
     /*  556522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556590 */     GIR_RootConstrainSelectedInstOperands,
     /*  556591 */     // GIR_Coverage, 3032,
     /*  556591 */     GIR_EraseRootFromParent_Done,
     /*  556592 */   // Label 9143: @556592
     /*  556592 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(556667), // Rule ID 3033 //
     /*  556597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  556617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556643 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  556646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556665 */     GIR_RootConstrainSelectedInstOperands,
     /*  556666 */     // GIR_Coverage, 3033,
     /*  556666 */     GIR_EraseRootFromParent_Done,
     /*  556667 */   // Label 9144: @556667
     /*  556667 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(556742), // Rule ID 3036 //
     /*  556672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556740 */     GIR_RootConstrainSelectedInstOperands,
     /*  556741 */     // GIR_Coverage, 3036,
     /*  556741 */     GIR_EraseRootFromParent_Done,
     /*  556742 */   // Label 9145: @556742
     /*  556742 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(556817), // Rule ID 3037 //
     /*  556747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  556767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556793 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  556796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556815 */     GIR_RootConstrainSelectedInstOperands,
     /*  556816 */     // GIR_Coverage, 3037,
     /*  556816 */     GIR_EraseRootFromParent_Done,
     /*  556817 */   // Label 9146: @556817
     /*  556817 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(556892), // Rule ID 3040 //
     /*  556822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556890 */     GIR_RootConstrainSelectedInstOperands,
     /*  556891 */     // GIR_Coverage, 3040,
     /*  556891 */     GIR_EraseRootFromParent_Done,
     /*  556892 */   // Label 9147: @556892
     /*  556892 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(556967), // Rule ID 3041 //
     /*  556897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  556917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  556946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556965 */     GIR_RootConstrainSelectedInstOperands,
     /*  556966 */     // GIR_Coverage, 3041,
     /*  556966 */     GIR_EraseRootFromParent_Done,
     /*  556967 */   // Label 9148: @556967
     /*  556967 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(557042), // Rule ID 3044 //
     /*  556972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  556992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  557021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557040 */     GIR_RootConstrainSelectedInstOperands,
     /*  557041 */     // GIR_Coverage, 3044,
     /*  557041 */     GIR_EraseRootFromParent_Done,
     /*  557042 */   // Label 9149: @557042
     /*  557042 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(557117), // Rule ID 3045 //
     /*  557047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  557058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  557061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  557064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  557067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  557096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557115 */     GIR_RootConstrainSelectedInstOperands,
     /*  557116 */     // GIR_Coverage, 3045,
     /*  557116 */     GIR_EraseRootFromParent_Done,
     /*  557117 */   // Label 9150: @557117
     /*  557117 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(557192), // Rule ID 3048 //
     /*  557122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  557125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  557142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  557171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557190 */     GIR_RootConstrainSelectedInstOperands,
     /*  557191 */     // GIR_Coverage, 3048,
     /*  557191 */     GIR_EraseRootFromParent_Done,
     /*  557192 */   // Label 9151: @557192
     /*  557192 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(557267), // Rule ID 3049 //
     /*  557197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  557208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  557211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  557214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  557217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  557236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557243 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  557246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557265 */     GIR_RootConstrainSelectedInstOperands,
     /*  557266 */     // GIR_Coverage, 3049,
     /*  557266 */     GIR_EraseRootFromParent_Done,
     /*  557267 */   // Label 9152: @557267
     /*  557267 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(557342), // Rule ID 3052 //
     /*  557272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  557321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557340 */     GIR_RootConstrainSelectedInstOperands,
     /*  557341 */     // GIR_Coverage, 3052,
     /*  557341 */     GIR_EraseRootFromParent_Done,
     /*  557342 */   // Label 9153: @557342
     /*  557342 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(557417), // Rule ID 3053 //
     /*  557347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  557358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  557361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  557364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557393 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  557396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557415 */     GIR_RootConstrainSelectedInstOperands,
     /*  557416 */     // GIR_Coverage, 3053,
     /*  557416 */     GIR_EraseRootFromParent_Done,
     /*  557417 */   // Label 9154: @557417
     /*  557417 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(557492), // Rule ID 3056 //
     /*  557422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557490 */     GIR_RootConstrainSelectedInstOperands,
     /*  557491 */     // GIR_Coverage, 3056,
     /*  557491 */     GIR_EraseRootFromParent_Done,
     /*  557492 */   // Label 9155: @557492
     /*  557492 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(557567), // Rule ID 3057 //
     /*  557497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  557508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  557511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  557514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557543 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557565 */     GIR_RootConstrainSelectedInstOperands,
     /*  557566 */     // GIR_Coverage, 3057,
     /*  557566 */     GIR_EraseRootFromParent_Done,
     /*  557567 */   // Label 9156: @557567
     /*  557567 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(557642), // Rule ID 3060 //
     /*  557572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557640 */     GIR_RootConstrainSelectedInstOperands,
     /*  557641 */     // GIR_Coverage, 3060,
     /*  557641 */     GIR_EraseRootFromParent_Done,
     /*  557642 */   // Label 9157: @557642
     /*  557642 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(557717), // Rule ID 3061 //
     /*  557647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557693 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557715 */     GIR_RootConstrainSelectedInstOperands,
     /*  557716 */     // GIR_Coverage, 3061,
     /*  557716 */     GIR_EraseRootFromParent_Done,
     /*  557717 */   // Label 9158: @557717
     /*  557717 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(557792), // Rule ID 3064 //
     /*  557722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557790 */     GIR_RootConstrainSelectedInstOperands,
     /*  557791 */     // GIR_Coverage, 3064,
     /*  557791 */     GIR_EraseRootFromParent_Done,
     /*  557792 */   // Label 9159: @557792
     /*  557792 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(557867), // Rule ID 3065 //
     /*  557797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  557846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557865 */     GIR_RootConstrainSelectedInstOperands,
     /*  557866 */     // GIR_Coverage, 3065,
     /*  557866 */     GIR_EraseRootFromParent_Done,
     /*  557867 */   // Label 9160: @557867
     /*  557867 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(557942), // Rule ID 3068 //
     /*  557872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  557892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557940 */     GIR_RootConstrainSelectedInstOperands,
     /*  557941 */     // GIR_Coverage, 3068,
     /*  557941 */     GIR_EraseRootFromParent_Done,
     /*  557942 */   // Label 9161: @557942
     /*  557942 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(558017), // Rule ID 3069 //
     /*  557947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  557955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  557967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  557986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  557996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558015 */     GIR_RootConstrainSelectedInstOperands,
     /*  558016 */     // GIR_Coverage, 3069,
     /*  558016 */     GIR_EraseRootFromParent_Done,
     /*  558017 */   // Label 9162: @558017
     /*  558017 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(558092), // Rule ID 3072 //
     /*  558022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  558071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558090 */     GIR_RootConstrainSelectedInstOperands,
     /*  558091 */     // GIR_Coverage, 3072,
     /*  558091 */     GIR_EraseRootFromParent_Done,
     /*  558092 */   // Label 9163: @558092
     /*  558092 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(558167), // Rule ID 3073 //
     /*  558097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  558108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  558111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  558114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  558146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558165 */     GIR_RootConstrainSelectedInstOperands,
     /*  558166 */     // GIR_Coverage, 3073,
     /*  558166 */     GIR_EraseRootFromParent_Done,
     /*  558167 */   // Label 9164: @558167
     /*  558167 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(558242), // Rule ID 3076 //
     /*  558172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558240 */     GIR_RootConstrainSelectedInstOperands,
     /*  558241 */     // GIR_Coverage, 3076,
     /*  558241 */     GIR_EraseRootFromParent_Done,
     /*  558242 */   // Label 9165: @558242
     /*  558242 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(558317), // Rule ID 3077 //
     /*  558247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  558258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  558261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  558264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558293 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11082:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558315 */     GIR_RootConstrainSelectedInstOperands,
     /*  558316 */     // GIR_Coverage, 3077,
     /*  558316 */     GIR_EraseRootFromParent_Done,
     /*  558317 */   // Label 9166: @558317
     /*  558317 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(558392), // Rule ID 3080 //
     /*  558322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558390 */     GIR_RootConstrainSelectedInstOperands,
     /*  558391 */     // GIR_Coverage, 3080,
     /*  558391 */     GIR_EraseRootFromParent_Done,
     /*  558392 */   // Label 9167: @558392
     /*  558392 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(558467), // Rule ID 3081 //
     /*  558397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  558408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  558411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  558414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11082:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558465 */     GIR_RootConstrainSelectedInstOperands,
     /*  558466 */     // GIR_Coverage, 3081,
     /*  558466 */     GIR_EraseRootFromParent_Done,
     /*  558467 */   // Label 9168: @558467
     /*  558467 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(558542), // Rule ID 3084 //
     /*  558472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558540 */     GIR_RootConstrainSelectedInstOperands,
     /*  558541 */     // GIR_Coverage, 3084,
     /*  558541 */     GIR_EraseRootFromParent_Done,
     /*  558542 */   // Label 9169: @558542
     /*  558542 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(558617), // Rule ID 3085 //
     /*  558547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558615 */     GIR_RootConstrainSelectedInstOperands,
     /*  558616 */     // GIR_Coverage, 3085,
     /*  558616 */     GIR_EraseRootFromParent_Done,
     /*  558617 */   // Label 9170: @558617
     /*  558617 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(558692), // Rule ID 3088 //
     /*  558622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558690 */     GIR_RootConstrainSelectedInstOperands,
     /*  558691 */     // GIR_Coverage, 3088,
     /*  558691 */     GIR_EraseRootFromParent_Done,
     /*  558692 */   // Label 9171: @558692
     /*  558692 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(558767), // Rule ID 3089 //
     /*  558697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  558746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558765 */     GIR_RootConstrainSelectedInstOperands,
     /*  558766 */     // GIR_Coverage, 3089,
     /*  558766 */     GIR_EraseRootFromParent_Done,
     /*  558767 */   // Label 9172: @558767
     /*  558767 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(558842), // Rule ID 3092 //
     /*  558772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  558821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558840 */     GIR_RootConstrainSelectedInstOperands,
     /*  558841 */     // GIR_Coverage, 3092,
     /*  558841 */     GIR_EraseRootFromParent_Done,
     /*  558842 */   // Label 9173: @558842
     /*  558842 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(558917), // Rule ID 3093 //
     /*  558847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  558867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  558896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558915 */     GIR_RootConstrainSelectedInstOperands,
     /*  558916 */     // GIR_Coverage, 3093,
     /*  558916 */     GIR_EraseRootFromParent_Done,
     /*  558917 */   // Label 9174: @558917
     /*  558917 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(558992), // Rule ID 3096 //
     /*  558922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  558930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  558942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  558961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  558971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558990 */     GIR_RootConstrainSelectedInstOperands,
     /*  558991 */     // GIR_Coverage, 3096,
     /*  558991 */     GIR_EraseRootFromParent_Done,
     /*  558992 */   // Label 9175: @558992
     /*  558992 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(559067), // Rule ID 3097 //
     /*  558997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  559008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  559011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  559014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559043 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559065 */     GIR_RootConstrainSelectedInstOperands,
     /*  559066 */     // GIR_Coverage, 3097,
     /*  559066 */     GIR_EraseRootFromParent_Done,
     /*  559067 */   // Label 9176: @559067
     /*  559067 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(559142), // Rule ID 3100 //
     /*  559072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559118 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559140 */     GIR_RootConstrainSelectedInstOperands,
     /*  559141 */     // GIR_Coverage, 3100,
     /*  559141 */     GIR_EraseRootFromParent_Done,
     /*  559142 */   // Label 9177: @559142
     /*  559142 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(559217), // Rule ID 3101 //
     /*  559147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  559158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  559161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  559164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559193 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559215 */     GIR_RootConstrainSelectedInstOperands,
     /*  559216 */     // GIR_Coverage, 3101,
     /*  559216 */     GIR_EraseRootFromParent_Done,
     /*  559217 */   // Label 9178: @559217
     /*  559217 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(559292), // Rule ID 3104 //
     /*  559222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559290 */     GIR_RootConstrainSelectedInstOperands,
     /*  559291 */     // GIR_Coverage, 3104,
     /*  559291 */     GIR_EraseRootFromParent_Done,
     /*  559292 */   // Label 9179: @559292
     /*  559292 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(559367), // Rule ID 3105 //
     /*  559297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  559308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  559311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  559314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559365 */     GIR_RootConstrainSelectedInstOperands,
     /*  559366 */     // GIR_Coverage, 3105,
     /*  559366 */     GIR_EraseRootFromParent_Done,
     /*  559367 */   // Label 9180: @559367
     /*  559367 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(559442), // Rule ID 3108 //
     /*  559372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559440 */     GIR_RootConstrainSelectedInstOperands,
     /*  559441 */     // GIR_Coverage, 3108,
     /*  559441 */     GIR_EraseRootFromParent_Done,
     /*  559442 */   // Label 9181: @559442
     /*  559442 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(559517), // Rule ID 3109 //
     /*  559447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  559458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  559461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  559464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559493 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559515 */     GIR_RootConstrainSelectedInstOperands,
     /*  559516 */     // GIR_Coverage, 3109,
     /*  559516 */     GIR_EraseRootFromParent_Done,
     /*  559517 */   // Label 9182: @559517
     /*  559517 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(559592), // Rule ID 3112 //
     /*  559522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559590 */     GIR_RootConstrainSelectedInstOperands,
     /*  559591 */     // GIR_Coverage, 3112,
     /*  559591 */     GIR_EraseRootFromParent_Done,
     /*  559592 */   // Label 9183: @559592
     /*  559592 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(559667), // Rule ID 3113 //
     /*  559597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559643 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  559646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559665 */     GIR_RootConstrainSelectedInstOperands,
     /*  559666 */     // GIR_Coverage, 3113,
     /*  559666 */     GIR_EraseRootFromParent_Done,
     /*  559667 */   // Label 9184: @559667
     /*  559667 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(559742), // Rule ID 3116 //
     /*  559672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559740 */     GIR_RootConstrainSelectedInstOperands,
     /*  559741 */     // GIR_Coverage, 3116,
     /*  559741 */     GIR_EraseRootFromParent_Done,
     /*  559742 */   // Label 9185: @559742
     /*  559742 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(559817), // Rule ID 3117 //
     /*  559747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  559796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559815 */     GIR_RootConstrainSelectedInstOperands,
     /*  559816 */     // GIR_Coverage, 3117,
     /*  559816 */     GIR_EraseRootFromParent_Done,
     /*  559817 */   // Label 9186: @559817
     /*  559817 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(559892), // Rule ID 3120 //
     /*  559822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559890 */     GIR_RootConstrainSelectedInstOperands,
     /*  559891 */     // GIR_Coverage, 3120,
     /*  559891 */     GIR_EraseRootFromParent_Done,
     /*  559892 */   // Label 9187: @559892
     /*  559892 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(559967), // Rule ID 3121 //
     /*  559897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  559946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559965 */     GIR_RootConstrainSelectedInstOperands,
     /*  559966 */     // GIR_Coverage, 3121,
     /*  559966 */     GIR_EraseRootFromParent_Done,
     /*  559967 */   // Label 9188: @559967
     /*  559967 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(560042), // Rule ID 3124 //
     /*  559972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  559980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560040 */     GIR_RootConstrainSelectedInstOperands,
     /*  560041 */     // GIR_Coverage, 3124,
     /*  560041 */     GIR_EraseRootFromParent_Done,
     /*  560042 */   // Label 9189: @560042
     /*  560042 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(560117), // Rule ID 3125 //
     /*  560047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  560058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  560061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  560064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560115 */     GIR_RootConstrainSelectedInstOperands,
     /*  560116 */     // GIR_Coverage, 3125,
     /*  560116 */     GIR_EraseRootFromParent_Done,
     /*  560117 */   // Label 9190: @560117
     /*  560117 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(560192), // Rule ID 3128 //
     /*  560122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  560171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560190 */     GIR_RootConstrainSelectedInstOperands,
     /*  560191 */     // GIR_Coverage, 3128,
     /*  560191 */     GIR_EraseRootFromParent_Done,
     /*  560192 */   // Label 9191: @560192
     /*  560192 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(560267), // Rule ID 3129 //
     /*  560197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  560208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  560211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  560214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  560232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  560246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560265 */     GIR_RootConstrainSelectedInstOperands,
     /*  560266 */     // GIR_Coverage, 3129,
     /*  560266 */     GIR_EraseRootFromParent_Done,
     /*  560267 */   // Label 9192: @560267
     /*  560267 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(560342), // Rule ID 3132 //
     /*  560272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  560321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560340 */     GIR_RootConstrainSelectedInstOperands,
     /*  560341 */     // GIR_Coverage, 3132,
     /*  560341 */     GIR_EraseRootFromParent_Done,
     /*  560342 */   // Label 9193: @560342
     /*  560342 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(560417), // Rule ID 3133 //
     /*  560347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  560358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  560361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  560364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  560382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  560396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560415 */     GIR_RootConstrainSelectedInstOperands,
     /*  560416 */     // GIR_Coverage, 3133,
     /*  560416 */     GIR_EraseRootFromParent_Done,
     /*  560417 */   // Label 9194: @560417
     /*  560417 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(560492), // Rule ID 3136 //
     /*  560422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560490 */     GIR_RootConstrainSelectedInstOperands,
     /*  560491 */     // GIR_Coverage, 3136,
     /*  560491 */     GIR_EraseRootFromParent_Done,
     /*  560492 */   // Label 9195: @560492
     /*  560492 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(560567), // Rule ID 3137 //
     /*  560497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  560505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  560508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  560511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  560514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  560532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  560546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560565 */     GIR_RootConstrainSelectedInstOperands,
     /*  560566 */     // GIR_Coverage, 3137,
     /*  560566 */     GIR_EraseRootFromParent_Done,
     /*  560567 */   // Label 9196: @560567
     /*  560567 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(560642), // Rule ID 3228 //
     /*  560572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560618 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  560621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560640 */     GIR_RootConstrainSelectedInstOperands,
     /*  560641 */     // GIR_Coverage, 3228,
     /*  560641 */     GIR_EraseRootFromParent_Done,
     /*  560642 */   // Label 9197: @560642
     /*  560642 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(560717), // Rule ID 3229 //
     /*  560647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  560667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  560696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560715 */     GIR_RootConstrainSelectedInstOperands,
     /*  560716 */     // GIR_Coverage, 3229,
     /*  560716 */     GIR_EraseRootFromParent_Done,
     /*  560717 */   // Label 9198: @560717
     /*  560717 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(560792), // Rule ID 3232 //
     /*  560722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  560771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560790 */     GIR_RootConstrainSelectedInstOperands,
     /*  560791 */     // GIR_Coverage, 3232,
     /*  560791 */     GIR_EraseRootFromParent_Done,
     /*  560792 */   // Label 9199: @560792
     /*  560792 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(560867), // Rule ID 3233 //
     /*  560797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  560817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  560846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560865 */     GIR_RootConstrainSelectedInstOperands,
     /*  560866 */     // GIR_Coverage, 3233,
     /*  560866 */     GIR_EraseRootFromParent_Done,
     /*  560867 */   // Label 9200: @560867
     /*  560867 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(560942), // Rule ID 3236 //
     /*  560872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560918 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  560921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560940 */     GIR_RootConstrainSelectedInstOperands,
     /*  560941 */     // GIR_Coverage, 3236,
     /*  560941 */     GIR_EraseRootFromParent_Done,
     /*  560942 */   // Label 9201: @560942
     /*  560942 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(561017), // Rule ID 3237 //
     /*  560947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  560967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560993 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  560996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561015 */     GIR_RootConstrainSelectedInstOperands,
     /*  561016 */     // GIR_Coverage, 3237,
     /*  561016 */     GIR_EraseRootFromParent_Done,
     /*  561017 */   // Label 9202: @561017
     /*  561017 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(561092), // Rule ID 3240 //
     /*  561022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  561071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561090 */     GIR_RootConstrainSelectedInstOperands,
     /*  561091 */     // GIR_Coverage, 3240,
     /*  561091 */     GIR_EraseRootFromParent_Done,
     /*  561092 */   // Label 9203: @561092
     /*  561092 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(561167), // Rule ID 3241 //
     /*  561097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  561108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  561111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  561114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  561117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  561146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561165 */     GIR_RootConstrainSelectedInstOperands,
     /*  561166 */     // GIR_Coverage, 3241,
     /*  561166 */     GIR_EraseRootFromParent_Done,
     /*  561167 */   // Label 9204: @561167
     /*  561167 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(561242), // Rule ID 3244 //
     /*  561172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561240 */     GIR_RootConstrainSelectedInstOperands,
     /*  561241 */     // GIR_Coverage, 3244,
     /*  561241 */     GIR_EraseRootFromParent_Done,
     /*  561242 */   // Label 9205: @561242
     /*  561242 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(561317), // Rule ID 3245 //
     /*  561247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  561258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  561261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  561264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  561267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561293 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561315 */     GIR_RootConstrainSelectedInstOperands,
     /*  561316 */     // GIR_Coverage, 3245,
     /*  561316 */     GIR_EraseRootFromParent_Done,
     /*  561317 */   // Label 9206: @561317
     /*  561317 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(561392), // Rule ID 3248 //
     /*  561322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561390 */     GIR_RootConstrainSelectedInstOperands,
     /*  561391 */     // GIR_Coverage, 3248,
     /*  561391 */     GIR_EraseRootFromParent_Done,
     /*  561392 */   // Label 9207: @561392
     /*  561392 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(561467), // Rule ID 3249 //
     /*  561397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  561408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  561411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  561414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  561417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561443 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  561446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561465 */     GIR_RootConstrainSelectedInstOperands,
     /*  561466 */     // GIR_Coverage, 3249,
     /*  561466 */     GIR_EraseRootFromParent_Done,
     /*  561467 */   // Label 9208: @561467
     /*  561467 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(561542), // Rule ID 3252 //
     /*  561472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  561492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561540 */     GIR_RootConstrainSelectedInstOperands,
     /*  561541 */     // GIR_Coverage, 3252,
     /*  561541 */     GIR_EraseRootFromParent_Done,
     /*  561542 */   // Label 9209: @561542
     /*  561542 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(561617), // Rule ID 3253 //
     /*  561547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  561567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561615 */     GIR_RootConstrainSelectedInstOperands,
     /*  561616 */     // GIR_Coverage, 3253,
     /*  561616 */     GIR_EraseRootFromParent_Done,
     /*  561617 */   // Label 9210: @561617
     /*  561617 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(561692), // Rule ID 3256 //
     /*  561622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561690 */     GIR_RootConstrainSelectedInstOperands,
     /*  561691 */     // GIR_Coverage, 3256,
     /*  561691 */     GIR_EraseRootFromParent_Done,
     /*  561692 */   // Label 9211: @561692
     /*  561692 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(561767), // Rule ID 3257 //
     /*  561697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  561717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561765 */     GIR_RootConstrainSelectedInstOperands,
     /*  561766 */     // GIR_Coverage, 3257,
     /*  561766 */     GIR_EraseRootFromParent_Done,
     /*  561767 */   // Label 9212: @561767
     /*  561767 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(561842), // Rule ID 3260 //
     /*  561772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  561792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561840 */     GIR_RootConstrainSelectedInstOperands,
     /*  561841 */     // GIR_Coverage, 3260,
     /*  561841 */     GIR_EraseRootFromParent_Done,
     /*  561842 */   // Label 9213: @561842
     /*  561842 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(561917), // Rule ID 3261 //
     /*  561847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  561867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561915 */     GIR_RootConstrainSelectedInstOperands,
     /*  561916 */     // GIR_Coverage, 3261,
     /*  561916 */     GIR_EraseRootFromParent_Done,
     /*  561917 */   // Label 9214: @561917
     /*  561917 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(561992), // Rule ID 3264 //
     /*  561922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  561942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  561971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561990 */     GIR_RootConstrainSelectedInstOperands,
     /*  561991 */     // GIR_Coverage, 3264,
     /*  561991 */     GIR_EraseRootFromParent_Done,
     /*  561992 */   // Label 9215: @561992
     /*  561992 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(562067), // Rule ID 3265 //
     /*  561997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  562008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  562011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  562014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  562017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  562046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562065 */     GIR_RootConstrainSelectedInstOperands,
     /*  562066 */     // GIR_Coverage, 3265,
     /*  562066 */     GIR_EraseRootFromParent_Done,
     /*  562067 */   // Label 9216: @562067
     /*  562067 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(562142), // Rule ID 3268 //
     /*  562072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  562092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562140 */     GIR_RootConstrainSelectedInstOperands,
     /*  562141 */     // GIR_Coverage, 3268,
     /*  562141 */     GIR_EraseRootFromParent_Done,
     /*  562142 */   // Label 9217: @562142
     /*  562142 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(562217), // Rule ID 3269 //
     /*  562147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  562158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  562161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  562164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  562167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562215 */     GIR_RootConstrainSelectedInstOperands,
     /*  562216 */     // GIR_Coverage, 3269,
     /*  562216 */     GIR_EraseRootFromParent_Done,
     /*  562217 */   // Label 9218: @562217
     /*  562217 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(562292), // Rule ID 3272 //
     /*  562222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  562242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562268 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562290 */     GIR_RootConstrainSelectedInstOperands,
     /*  562291 */     // GIR_Coverage, 3272,
     /*  562291 */     GIR_EraseRootFromParent_Done,
     /*  562292 */   // Label 9219: @562292
     /*  562292 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(562367), // Rule ID 3273 //
     /*  562297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  562308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  562311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  562314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  562317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562343 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562365 */     GIR_RootConstrainSelectedInstOperands,
     /*  562366 */     // GIR_Coverage, 3273,
     /*  562366 */     GIR_EraseRootFromParent_Done,
     /*  562367 */   // Label 9220: @562367
     /*  562367 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(562442), // Rule ID 3276 //
     /*  562372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  562392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562440 */     GIR_RootConstrainSelectedInstOperands,
     /*  562441 */     // GIR_Coverage, 3276,
     /*  562441 */     GIR_EraseRootFromParent_Done,
     /*  562442 */   // Label 9221: @562442
     /*  562442 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(562517), // Rule ID 3277 //
     /*  562447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  562458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  562461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  562464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  562467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562493 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562515 */     GIR_RootConstrainSelectedInstOperands,
     /*  562516 */     // GIR_Coverage, 3277,
     /*  562516 */     GIR_EraseRootFromParent_Done,
     /*  562517 */   // Label 9222: @562517
     /*  562517 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(562592), // Rule ID 3280 //
     /*  562522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  562542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562590 */     GIR_RootConstrainSelectedInstOperands,
     /*  562591 */     // GIR_Coverage, 3280,
     /*  562591 */     GIR_EraseRootFromParent_Done,
     /*  562592 */   // Label 9223: @562592
     /*  562592 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(562667), // Rule ID 3281 //
     /*  562597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  562617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  562646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562665 */     GIR_RootConstrainSelectedInstOperands,
     /*  562666 */     // GIR_Coverage, 3281,
     /*  562666 */     GIR_EraseRootFromParent_Done,
     /*  562667 */   // Label 9224: @562667
     /*  562667 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(562742), // Rule ID 3284 //
     /*  562672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  562692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562740 */     GIR_RootConstrainSelectedInstOperands,
     /*  562741 */     // GIR_Coverage, 3284,
     /*  562741 */     GIR_EraseRootFromParent_Done,
     /*  562742 */   // Label 9225: @562742
     /*  562742 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(562817), // Rule ID 3285 //
     /*  562747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  562767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  562796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562815 */     GIR_RootConstrainSelectedInstOperands,
     /*  562816 */     // GIR_Coverage, 3285,
     /*  562816 */     GIR_EraseRootFromParent_Done,
     /*  562817 */   // Label 9226: @562817
     /*  562817 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(562892), // Rule ID 3288 //
     /*  562822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  562842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562890 */     GIR_RootConstrainSelectedInstOperands,
     /*  562891 */     // GIR_Coverage, 3288,
     /*  562891 */     GIR_EraseRootFromParent_Done,
     /*  562892 */   // Label 9227: @562892
     /*  562892 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(562967), // Rule ID 3289 //
     /*  562897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  562917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  562946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562965 */     GIR_RootConstrainSelectedInstOperands,
     /*  562966 */     // GIR_Coverage, 3289,
     /*  562966 */     GIR_EraseRootFromParent_Done,
     /*  562967 */   // Label 9228: @562967
     /*  562967 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(563042), // Rule ID 3292 //
     /*  562972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  562992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563040 */     GIR_RootConstrainSelectedInstOperands,
     /*  563041 */     // GIR_Coverage, 3292,
     /*  563041 */     GIR_EraseRootFromParent_Done,
     /*  563042 */   // Label 9229: @563042
     /*  563042 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(563117), // Rule ID 3293 //
     /*  563047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  563058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  563061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  563064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  563067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563115 */     GIR_RootConstrainSelectedInstOperands,
     /*  563116 */     // GIR_Coverage, 3293,
     /*  563116 */     GIR_EraseRootFromParent_Done,
     /*  563117 */   // Label 9230: @563117
     /*  563117 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(563192), // Rule ID 3296 //
     /*  563122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  563142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563190 */     GIR_RootConstrainSelectedInstOperands,
     /*  563191 */     // GIR_Coverage, 3296,
     /*  563191 */     GIR_EraseRootFromParent_Done,
     /*  563192 */   // Label 9231: @563192
     /*  563192 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(563267), // Rule ID 3297 //
     /*  563197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  563208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  563211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  563214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  563217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563243 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563265 */     GIR_RootConstrainSelectedInstOperands,
     /*  563266 */     // GIR_Coverage, 3297,
     /*  563266 */     GIR_EraseRootFromParent_Done,
     /*  563267 */   // Label 9232: @563267
     /*  563267 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(563342), // Rule ID 3300 //
     /*  563272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  563292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563340 */     GIR_RootConstrainSelectedInstOperands,
     /*  563341 */     // GIR_Coverage, 3300,
     /*  563341 */     GIR_EraseRootFromParent_Done,
     /*  563342 */   // Label 9233: @563342
     /*  563342 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(563417), // Rule ID 3301 //
     /*  563347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  563358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  563361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  563364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  563367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563393 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563415 */     GIR_RootConstrainSelectedInstOperands,
     /*  563416 */     // GIR_Coverage, 3301,
     /*  563416 */     GIR_EraseRootFromParent_Done,
     /*  563417 */   // Label 9234: @563417
     /*  563417 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(563492), // Rule ID 3304 //
     /*  563422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  563442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563490 */     GIR_RootConstrainSelectedInstOperands,
     /*  563491 */     // GIR_Coverage, 3304,
     /*  563491 */     GIR_EraseRootFromParent_Done,
     /*  563492 */   // Label 9235: @563492
     /*  563492 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(563567), // Rule ID 3305 //
     /*  563497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  563508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  563511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  563514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  563517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  563536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  563546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563565 */     GIR_RootConstrainSelectedInstOperands,
     /*  563566 */     // GIR_Coverage, 3305,
     /*  563566 */     GIR_EraseRootFromParent_Done,
     /*  563567 */   // Label 9236: @563567
     /*  563567 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(563642), // Rule ID 3308 //
     /*  563572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  563592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563618 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563640 */     GIR_RootConstrainSelectedInstOperands,
     /*  563641 */     // GIR_Coverage, 3308,
     /*  563641 */     GIR_EraseRootFromParent_Done,
     /*  563642 */   // Label 9237: @563642
     /*  563642 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(563717), // Rule ID 3309 //
     /*  563647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  563667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563693 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  563696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563715 */     GIR_RootConstrainSelectedInstOperands,
     /*  563716 */     // GIR_Coverage, 3309,
     /*  563716 */     GIR_EraseRootFromParent_Done,
     /*  563717 */   // Label 9238: @563717
     /*  563717 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(563792), // Rule ID 3312 //
     /*  563722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  563742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563790 */     GIR_RootConstrainSelectedInstOperands,
     /*  563791 */     // GIR_Coverage, 3312,
     /*  563791 */     GIR_EraseRootFromParent_Done,
     /*  563792 */   // Label 9239: @563792
     /*  563792 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(563867), // Rule ID 3313 //
     /*  563797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  563817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563843 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  563846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563865 */     GIR_RootConstrainSelectedInstOperands,
     /*  563866 */     // GIR_Coverage, 3313,
     /*  563866 */     GIR_EraseRootFromParent_Done,
     /*  563867 */   // Label 9240: @563867
     /*  563867 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(563942), // Rule ID 3316 //
     /*  563872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563918 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  563921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563940 */     GIR_RootConstrainSelectedInstOperands,
     /*  563941 */     // GIR_Coverage, 3316,
     /*  563941 */     GIR_EraseRootFromParent_Done,
     /*  563942 */   // Label 9241: @563942
     /*  563942 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(564017), // Rule ID 3317 //
     /*  563947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  563996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564015 */     GIR_RootConstrainSelectedInstOperands,
     /*  564016 */     // GIR_Coverage, 3317,
     /*  564016 */     GIR_EraseRootFromParent_Done,
     /*  564017 */   // Label 9242: @564017
     /*  564017 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(564092), // Rule ID 3320 //
     /*  564022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564068 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564090 */     GIR_RootConstrainSelectedInstOperands,
     /*  564091 */     // GIR_Coverage, 3320,
     /*  564091 */     GIR_EraseRootFromParent_Done,
     /*  564092 */   // Label 9243: @564092
     /*  564092 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(564167), // Rule ID 3321 //
     /*  564097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  564108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  564111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  564114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564143 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564165 */     GIR_RootConstrainSelectedInstOperands,
     /*  564166 */     // GIR_Coverage, 3321,
     /*  564166 */     GIR_EraseRootFromParent_Done,
     /*  564167 */   // Label 9244: @564167
     /*  564167 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(564242), // Rule ID 3324 //
     /*  564172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564240 */     GIR_RootConstrainSelectedInstOperands,
     /*  564241 */     // GIR_Coverage, 3324,
     /*  564241 */     GIR_EraseRootFromParent_Done,
     /*  564242 */   // Label 9245: @564242
     /*  564242 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(564317), // Rule ID 3325 //
     /*  564247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  564258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  564261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  564264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564315 */     GIR_RootConstrainSelectedInstOperands,
     /*  564316 */     // GIR_Coverage, 3325,
     /*  564316 */     GIR_EraseRootFromParent_Done,
     /*  564317 */   // Label 9246: @564317
     /*  564317 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(564392), // Rule ID 3328 //
     /*  564322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564390 */     GIR_RootConstrainSelectedInstOperands,
     /*  564391 */     // GIR_Coverage, 3328,
     /*  564391 */     GIR_EraseRootFromParent_Done,
     /*  564392 */   // Label 9247: @564392
     /*  564392 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(564467), // Rule ID 3329 //
     /*  564397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  564408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  564411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  564414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  564446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564465 */     GIR_RootConstrainSelectedInstOperands,
     /*  564466 */     // GIR_Coverage, 3329,
     /*  564466 */     GIR_EraseRootFromParent_Done,
     /*  564467 */   // Label 9248: @564467
     /*  564467 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(564542), // Rule ID 3332 //
     /*  564472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564540 */     GIR_RootConstrainSelectedInstOperands,
     /*  564541 */     // GIR_Coverage, 3332,
     /*  564541 */     GIR_EraseRootFromParent_Done,
     /*  564542 */   // Label 9249: @564542
     /*  564542 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(564617), // Rule ID 3333 //
     /*  564547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564615 */     GIR_RootConstrainSelectedInstOperands,
     /*  564616 */     // GIR_Coverage, 3333,
     /*  564616 */     GIR_EraseRootFromParent_Done,
     /*  564617 */   // Label 9250: @564617
     /*  564617 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(564692), // Rule ID 3336 //
     /*  564622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564690 */     GIR_RootConstrainSelectedInstOperands,
     /*  564691 */     // GIR_Coverage, 3336,
     /*  564691 */     GIR_EraseRootFromParent_Done,
     /*  564692 */   // Label 9251: @564692
     /*  564692 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(564767), // Rule ID 3337 //
     /*  564697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  564746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564765 */     GIR_RootConstrainSelectedInstOperands,
     /*  564766 */     // GIR_Coverage, 3337,
     /*  564766 */     GIR_EraseRootFromParent_Done,
     /*  564767 */   // Label 9252: @564767
     /*  564767 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(564842), // Rule ID 3340 //
     /*  564772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564840 */     GIR_RootConstrainSelectedInstOperands,
     /*  564841 */     // GIR_Coverage, 3340,
     /*  564841 */     GIR_EraseRootFromParent_Done,
     /*  564842 */   // Label 9253: @564842
     /*  564842 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(564917), // Rule ID 3341 //
     /*  564847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11560:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564915 */     GIR_RootConstrainSelectedInstOperands,
     /*  564916 */     // GIR_Coverage, 3341,
     /*  564916 */     GIR_EraseRootFromParent_Done,
     /*  564917 */   // Label 9254: @564917
     /*  564917 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(564992), // Rule ID 3344 //
     /*  564922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  564930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  564971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564990 */     GIR_RootConstrainSelectedInstOperands,
     /*  564991 */     // GIR_Coverage, 3344,
     /*  564991 */     GIR_EraseRootFromParent_Done,
     /*  564992 */   // Label 9255: @564992
     /*  564992 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(565067), // Rule ID 3345 //
     /*  564997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  565008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  565011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  565014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11560:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565065 */     GIR_RootConstrainSelectedInstOperands,
     /*  565066 */     // GIR_Coverage, 3345,
     /*  565066 */     GIR_EraseRootFromParent_Done,
     /*  565067 */   // Label 9256: @565067
     /*  565067 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(565142), // Rule ID 3348 //
     /*  565072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565140 */     GIR_RootConstrainSelectedInstOperands,
     /*  565141 */     // GIR_Coverage, 3348,
     /*  565141 */     GIR_EraseRootFromParent_Done,
     /*  565142 */   // Label 9257: @565142
     /*  565142 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(565217), // Rule ID 3349 //
     /*  565147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  565158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  565161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  565164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565193 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565215 */     GIR_RootConstrainSelectedInstOperands,
     /*  565216 */     // GIR_Coverage, 3349,
     /*  565216 */     GIR_EraseRootFromParent_Done,
     /*  565217 */   // Label 9258: @565217
     /*  565217 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(565292), // Rule ID 3352 //
     /*  565222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565290 */     GIR_RootConstrainSelectedInstOperands,
     /*  565291 */     // GIR_Coverage, 3352,
     /*  565291 */     GIR_EraseRootFromParent_Done,
     /*  565292 */   // Label 9259: @565292
     /*  565292 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(565367), // Rule ID 3353 //
     /*  565297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  565308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  565311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  565314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  565332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  565346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565365 */     GIR_RootConstrainSelectedInstOperands,
     /*  565366 */     // GIR_Coverage, 3353,
     /*  565366 */     GIR_EraseRootFromParent_Done,
     /*  565367 */   // Label 9260: @565367
     /*  565367 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(565442), // Rule ID 3356 //
     /*  565372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565418 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565440 */     GIR_RootConstrainSelectedInstOperands,
     /*  565441 */     // GIR_Coverage, 3356,
     /*  565441 */     GIR_EraseRootFromParent_Done,
     /*  565442 */   // Label 9261: @565442
     /*  565442 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(565517), // Rule ID 3357 //
     /*  565447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  565458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  565461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  565464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565515 */     GIR_RootConstrainSelectedInstOperands,
     /*  565516 */     // GIR_Coverage, 3357,
     /*  565516 */     GIR_EraseRootFromParent_Done,
     /*  565517 */   // Label 9262: @565517
     /*  565517 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(565592), // Rule ID 3360 //
     /*  565522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  565571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565590 */     GIR_RootConstrainSelectedInstOperands,
     /*  565591 */     // GIR_Coverage, 3360,
     /*  565591 */     GIR_EraseRootFromParent_Done,
     /*  565592 */   // Label 9263: @565592
     /*  565592 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(565667), // Rule ID 3361 //
     /*  565597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565643 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  565646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565665 */     GIR_RootConstrainSelectedInstOperands,
     /*  565666 */     // GIR_Coverage, 3361,
     /*  565666 */     GIR_EraseRootFromParent_Done,
     /*  565667 */   // Label 9264: @565667
     /*  565667 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(565742), // Rule ID 3364 //
     /*  565672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  565721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565740 */     GIR_RootConstrainSelectedInstOperands,
     /*  565741 */     // GIR_Coverage, 3364,
     /*  565741 */     GIR_EraseRootFromParent_Done,
     /*  565742 */   // Label 9265: @565742
     /*  565742 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(565817), // Rule ID 3365 //
     /*  565747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565793 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  565796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565815 */     GIR_RootConstrainSelectedInstOperands,
     /*  565816 */     // GIR_Coverage, 3365,
     /*  565816 */     GIR_EraseRootFromParent_Done,
     /*  565817 */   // Label 9266: @565817
     /*  565817 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(565892), // Rule ID 3368 //
     /*  565822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565890 */     GIR_RootConstrainSelectedInstOperands,
     /*  565891 */     // GIR_Coverage, 3368,
     /*  565891 */     GIR_EraseRootFromParent_Done,
     /*  565892 */   // Label 9267: @565892
     /*  565892 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(565967), // Rule ID 3369 //
     /*  565897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  565946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565965 */     GIR_RootConstrainSelectedInstOperands,
     /*  565966 */     // GIR_Coverage, 3369,
     /*  565966 */     GIR_EraseRootFromParent_Done,
     /*  565967 */   // Label 9268: @565967
     /*  565967 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(566042), // Rule ID 3372 //
     /*  565972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  565980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566040 */     GIR_RootConstrainSelectedInstOperands,
     /*  566041 */     // GIR_Coverage, 3372,
     /*  566041 */     GIR_EraseRootFromParent_Done,
     /*  566042 */   // Label 9269: @566042
     /*  566042 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(566117), // Rule ID 3373 //
     /*  566047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  566064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566093 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566115 */     GIR_RootConstrainSelectedInstOperands,
     /*  566116 */     // GIR_Coverage, 3373,
     /*  566116 */     GIR_EraseRootFromParent_Done,
     /*  566117 */   // Label 9270: @566117
     /*  566117 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(566192), // Rule ID 3376 //
     /*  566122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  566168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566190 */     GIR_RootConstrainSelectedInstOperands,
     /*  566191 */     // GIR_Coverage, 3376,
     /*  566191 */     GIR_EraseRootFromParent_Done,
     /*  566192 */   // Label 9271: @566192
     /*  566192 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(566267), // Rule ID 3377 //
     /*  566197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  566214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  566243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  566262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566265 */     GIR_RootConstrainSelectedInstOperands,
     /*  566266 */     // GIR_Coverage, 3377,
     /*  566266 */     GIR_EraseRootFromParent_Done,
     /*  566267 */   // Label 9272: @566267
     /*  566267 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(566342), // Rule ID 3380 //
     /*  566272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566340 */     GIR_RootConstrainSelectedInstOperands,
     /*  566341 */     // GIR_Coverage, 3380,
     /*  566341 */     GIR_EraseRootFromParent_Done,
     /*  566342 */   // Label 9273: @566342
     /*  566342 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(566417), // Rule ID 3381 //
     /*  566347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  566358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  566361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  566364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566415 */     GIR_RootConstrainSelectedInstOperands,
     /*  566416 */     // GIR_Coverage, 3381,
     /*  566416 */     GIR_EraseRootFromParent_Done,
     /*  566417 */   // Label 9274: @566417
     /*  566417 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(566492), // Rule ID 3384 //
     /*  566422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566490 */     GIR_RootConstrainSelectedInstOperands,
     /*  566491 */     // GIR_Coverage, 3384,
     /*  566491 */     GIR_EraseRootFromParent_Done,
     /*  566492 */   // Label 9275: @566492
     /*  566492 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(566567), // Rule ID 3385 //
     /*  566497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  566508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  566511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  566514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566565 */     GIR_RootConstrainSelectedInstOperands,
     /*  566566 */     // GIR_Coverage, 3385,
     /*  566566 */     GIR_EraseRootFromParent_Done,
     /*  566567 */   // Label 9276: @566567
     /*  566567 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(566642), // Rule ID 3388 //
     /*  566572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566640 */     GIR_RootConstrainSelectedInstOperands,
     /*  566641 */     // GIR_Coverage, 3388,
     /*  566641 */     GIR_EraseRootFromParent_Done,
     /*  566642 */   // Label 9277: @566642
     /*  566642 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(566717), // Rule ID 3389 //
     /*  566647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  566696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566715 */     GIR_RootConstrainSelectedInstOperands,
     /*  566716 */     // GIR_Coverage, 3389,
     /*  566716 */     GIR_EraseRootFromParent_Done,
     /*  566717 */   // Label 9278: @566717
     /*  566717 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(566792), // Rule ID 3392 //
     /*  566722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566790 */     GIR_RootConstrainSelectedInstOperands,
     /*  566791 */     // GIR_Coverage, 3392,
     /*  566791 */     GIR_EraseRootFromParent_Done,
     /*  566792 */   // Label 9279: @566792
     /*  566792 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(566867), // Rule ID 3393 //
     /*  566797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566843 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  566846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566865 */     GIR_RootConstrainSelectedInstOperands,
     /*  566866 */     // GIR_Coverage, 3393,
     /*  566866 */     GIR_EraseRootFromParent_Done,
     /*  566867 */   // Label 9280: @566867
     /*  566867 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(566942), // Rule ID 3396 //
     /*  566872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566940 */     GIR_RootConstrainSelectedInstOperands,
     /*  566941 */     // GIR_Coverage, 3396,
     /*  566941 */     GIR_EraseRootFromParent_Done,
     /*  566942 */   // Label 9281: @566942
     /*  566942 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(567017), // Rule ID 3397 //
     /*  566947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  566955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566993 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  566996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567015 */     GIR_RootConstrainSelectedInstOperands,
     /*  567016 */     // GIR_Coverage, 3397,
     /*  567016 */     GIR_EraseRootFromParent_Done,
     /*  567017 */   // Label 9282: @567017
     /*  567017 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(567092), // Rule ID 3400 //
     /*  567022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  567025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  567030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  567068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  567071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567090 */     GIR_RootConstrainSelectedInstOperands,
     /*  567091 */     // GIR_Coverage, 3400,
     /*  567091 */     GIR_EraseRootFromParent_Done,
     /*  567092 */   // Label 9283: @567092
     /*  567092 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(567167), // Rule ID 3401 //
     /*  567097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  567100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  567105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  567108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  567111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  567114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567143 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  567143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  567146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  567162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567165 */     GIR_RootConstrainSelectedInstOperands,
     /*  567166 */     // GIR_Coverage, 3401,
     /*  567166 */     GIR_EraseRootFromParent_Done,
     /*  567167 */   // Label 9284: @567167
     /*  567167 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(567242), // Rule ID 3404 //
     /*  567172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  567183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  567186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  567221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567240 */     GIR_RootConstrainSelectedInstOperands,
     /*  567241 */     // GIR_Coverage, 3404,
     /*  567241 */     GIR_EraseRootFromParent_Done,
     /*  567242 */   // Label 9285: @567242
     /*  567242 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(567317), // Rule ID 3405 //
     /*  567247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  567258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  567261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  567264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  567296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567315 */     GIR_RootConstrainSelectedInstOperands,
     /*  567316 */     // GIR_Coverage, 3405,
     /*  567316 */     GIR_EraseRootFromParent_Done,
     /*  567317 */   // Label 9286: @567317
     /*  567317 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(567392), // Rule ID 3408 //
     /*  567322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567390 */     GIR_RootConstrainSelectedInstOperands,
     /*  567391 */     // GIR_Coverage, 3408,
     /*  567391 */     GIR_EraseRootFromParent_Done,
     /*  567392 */   // Label 9287: @567392
     /*  567392 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(567467), // Rule ID 3409 //
     /*  567397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  567408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  567411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  567414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567443 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567465 */     GIR_RootConstrainSelectedInstOperands,
     /*  567466 */     // GIR_Coverage, 3409,
     /*  567466 */     GIR_EraseRootFromParent_Done,
     /*  567467 */   // Label 9288: @567467
     /*  567467 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(567542), // Rule ID 3412 //
     /*  567472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567540 */     GIR_RootConstrainSelectedInstOperands,
     /*  567541 */     // GIR_Coverage, 3412,
     /*  567541 */     GIR_EraseRootFromParent_Done,
     /*  567542 */   // Label 9289: @567542
     /*  567542 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(567617), // Rule ID 3413 //
     /*  567547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  567558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  567561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567593 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567615 */     GIR_RootConstrainSelectedInstOperands,
     /*  567616 */     // GIR_Coverage, 3413,
     /*  567616 */     GIR_EraseRootFromParent_Done,
     /*  567617 */   // Label 9290: @567617
     /*  567617 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(567692), // Rule ID 3416 //
     /*  567622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567668 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567690 */     GIR_RootConstrainSelectedInstOperands,
     /*  567691 */     // GIR_Coverage, 3416,
     /*  567691 */     GIR_EraseRootFromParent_Done,
     /*  567692 */   // Label 9291: @567692
     /*  567692 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(567767), // Rule ID 3417 //
     /*  567697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  567708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  567711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567743 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  567746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567765 */     GIR_RootConstrainSelectedInstOperands,
     /*  567766 */     // GIR_Coverage, 3417,
     /*  567766 */     GIR_EraseRootFromParent_Done,
     /*  567767 */   // Label 9292: @567767
     /*  567767 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(567842), // Rule ID 3420 //
     /*  567772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567840 */     GIR_RootConstrainSelectedInstOperands,
     /*  567841 */     // GIR_Coverage, 3420,
     /*  567841 */     GIR_EraseRootFromParent_Done,
     /*  567842 */   // Label 9293: @567842
     /*  567842 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(567917), // Rule ID 3421 //
     /*  567847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  567858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  567861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  567867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567893 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567915 */     GIR_RootConstrainSelectedInstOperands,
     /*  567916 */     // GIR_Coverage, 3421,
     /*  567916 */     GIR_EraseRootFromParent_Done,
     /*  567917 */   // Label 9294: @567917
     /*  567917 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(567992), // Rule ID 3424 //
     /*  567922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  567930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  567942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  567961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  567968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  567971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  567987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567990 */     GIR_RootConstrainSelectedInstOperands,
     /*  567991 */     // GIR_Coverage, 3424,
     /*  567991 */     GIR_EraseRootFromParent_Done,
     /*  567992 */   // Label 9295: @567992
     /*  567992 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(568067), // Rule ID 3425 //
     /*  567997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  568008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  568011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568043 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  568046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568065 */     GIR_RootConstrainSelectedInstOperands,
     /*  568066 */     // GIR_Coverage, 3425,
     /*  568066 */     GIR_EraseRootFromParent_Done,
     /*  568067 */   // Label 9296: @568067
     /*  568067 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(568142), // Rule ID 3428 //
     /*  568072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  568083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  568086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568140 */     GIR_RootConstrainSelectedInstOperands,
     /*  568141 */     // GIR_Coverage, 3428,
     /*  568141 */     GIR_EraseRootFromParent_Done,
     /*  568142 */   // Label 9297: @568142
     /*  568142 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(568217), // Rule ID 3429 //
     /*  568147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  568158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  568161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568215 */     GIR_RootConstrainSelectedInstOperands,
     /*  568216 */     // GIR_Coverage, 3429,
     /*  568216 */     GIR_EraseRootFromParent_Done,
     /*  568217 */   // Label 9298: @568217
     /*  568217 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(568292), // Rule ID 3432 //
     /*  568222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568290 */     GIR_RootConstrainSelectedInstOperands,
     /*  568291 */     // GIR_Coverage, 3432,
     /*  568291 */     GIR_EraseRootFromParent_Done,
     /*  568292 */   // Label 9299: @568292
     /*  568292 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(568367), // Rule ID 3433 //
     /*  568297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  568314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568365 */     GIR_RootConstrainSelectedInstOperands,
     /*  568366 */     // GIR_Coverage, 3433,
     /*  568366 */     GIR_EraseRootFromParent_Done,
     /*  568367 */   // Label 9300: @568367
     /*  568367 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(568442), // Rule ID 3436 //
     /*  568372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568440 */     GIR_RootConstrainSelectedInstOperands,
     /*  568441 */     // GIR_Coverage, 3436,
     /*  568441 */     GIR_EraseRootFromParent_Done,
     /*  568442 */   // Label 9301: @568442
     /*  568442 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(568517), // Rule ID 3437 //
     /*  568447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  568458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  568461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568515 */     GIR_RootConstrainSelectedInstOperands,
     /*  568516 */     // GIR_Coverage, 3437,
     /*  568516 */     GIR_EraseRootFromParent_Done,
     /*  568517 */   // Label 9302: @568517
     /*  568517 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(568592), // Rule ID 3440 //
     /*  568522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  568525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568568 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  568568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  568587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568590 */     GIR_RootConstrainSelectedInstOperands,
     /*  568591 */     // GIR_Coverage, 3440,
     /*  568591 */     GIR_EraseRootFromParent_Done,
     /*  568592 */   // Label 9303: @568592
     /*  568592 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(568667), // Rule ID 3441 //
     /*  568597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  568600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  568614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  568643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  568646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  568662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568665 */     GIR_RootConstrainSelectedInstOperands,
     /*  568666 */     // GIR_Coverage, 3441,
     /*  568666 */     GIR_EraseRootFromParent_Done,
     /*  568667 */   // Label 9304: @568667
     /*  568667 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(568742), // Rule ID 3444 //
     /*  568672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  568683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  568686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  568689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  568721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568740 */     GIR_RootConstrainSelectedInstOperands,
     /*  568741 */     // GIR_Coverage, 3444,
     /*  568741 */     GIR_EraseRootFromParent_Done,
     /*  568742 */   // Label 9305: @568742
     /*  568742 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(568817), // Rule ID 3445 //
     /*  568747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  568758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  568761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  568764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  568796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568815 */     GIR_RootConstrainSelectedInstOperands,
     /*  568816 */     // GIR_Coverage, 3445,
     /*  568816 */     GIR_EraseRootFromParent_Done,
     /*  568817 */   // Label 9306: @568817
     /*  568817 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(568892), // Rule ID 3448 //
     /*  568822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  568833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  568836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  568839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  568871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568890 */     GIR_RootConstrainSelectedInstOperands,
     /*  568891 */     // GIR_Coverage, 3448,
     /*  568891 */     GIR_EraseRootFromParent_Done,
     /*  568892 */   // Label 9307: @568892
     /*  568892 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(568967), // Rule ID 3449 //
     /*  568897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  568908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  568911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  568914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568943 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  568946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568965 */     GIR_RootConstrainSelectedInstOperands,
     /*  568966 */     // GIR_Coverage, 3449,
     /*  568966 */     GIR_EraseRootFromParent_Done,
     /*  568967 */   // Label 9308: @568967
     /*  568967 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(569042), // Rule ID 3452 //
     /*  568972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  568980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  568983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  568986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  568989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569040 */     GIR_RootConstrainSelectedInstOperands,
     /*  569041 */     // GIR_Coverage, 3452,
     /*  569041 */     GIR_EraseRootFromParent_Done,
     /*  569042 */   // Label 9309: @569042
     /*  569042 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(569117), // Rule ID 3453 //
     /*  569047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  569058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  569061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  569064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569093 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569115 */     GIR_RootConstrainSelectedInstOperands,
     /*  569116 */     // GIR_Coverage, 3453,
     /*  569116 */     GIR_EraseRootFromParent_Done,
     /*  569117 */   // Label 9310: @569117
     /*  569117 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(569192), // Rule ID 3456 //
     /*  569122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569190 */     GIR_RootConstrainSelectedInstOperands,
     /*  569191 */     // GIR_Coverage, 3456,
     /*  569191 */     GIR_EraseRootFromParent_Done,
     /*  569192 */   // Label 9311: @569192
     /*  569192 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(569267), // Rule ID 3457 //
     /*  569197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569265 */     GIR_RootConstrainSelectedInstOperands,
     /*  569266 */     // GIR_Coverage, 3457,
     /*  569266 */     GIR_EraseRootFromParent_Done,
     /*  569267 */   // Label 9312: @569267
     /*  569267 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(569342), // Rule ID 3460 //
     /*  569272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569340 */     GIR_RootConstrainSelectedInstOperands,
     /*  569341 */     // GIR_Coverage, 3460,
     /*  569341 */     GIR_EraseRootFromParent_Done,
     /*  569342 */   // Label 9313: @569342
     /*  569342 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(569417), // Rule ID 3461 //
     /*  569347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569393 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569415 */     GIR_RootConstrainSelectedInstOperands,
     /*  569416 */     // GIR_Coverage, 3461,
     /*  569416 */     GIR_EraseRootFromParent_Done,
     /*  569417 */   // Label 9314: @569417
     /*  569417 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(569492), // Rule ID 3464 //
     /*  569422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  569439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569490 */     GIR_RootConstrainSelectedInstOperands,
     /*  569491 */     // GIR_Coverage, 3464,
     /*  569491 */     GIR_EraseRootFromParent_Done,
     /*  569492 */   // Label 9315: @569492
     /*  569492 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(569567), // Rule ID 3465 //
     /*  569497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  569514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569543 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569565 */     GIR_RootConstrainSelectedInstOperands,
     /*  569566 */     // GIR_Coverage, 3465,
     /*  569566 */     GIR_EraseRootFromParent_Done,
     /*  569567 */   // Label 9316: @569567
     /*  569567 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(569642), // Rule ID 3468 //
     /*  569572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569640 */     GIR_RootConstrainSelectedInstOperands,
     /*  569641 */     // GIR_Coverage, 3468,
     /*  569641 */     GIR_EraseRootFromParent_Done,
     /*  569642 */   // Label 9317: @569642
     /*  569642 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(569717), // Rule ID 3469 //
     /*  569647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  569664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  569696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569715 */     GIR_RootConstrainSelectedInstOperands,
     /*  569716 */     // GIR_Coverage, 3469,
     /*  569716 */     GIR_EraseRootFromParent_Done,
     /*  569717 */   // Label 9318: @569717
     /*  569717 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(569792), // Rule ID 3472 //
     /*  569722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569790 */     GIR_RootConstrainSelectedInstOperands,
     /*  569791 */     // GIR_Coverage, 3472,
     /*  569791 */     GIR_EraseRootFromParent_Done,
     /*  569792 */   // Label 9319: @569792
     /*  569792 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(569867), // Rule ID 3473 //
     /*  569797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  569814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  569846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569865 */     GIR_RootConstrainSelectedInstOperands,
     /*  569866 */     // GIR_Coverage, 3473,
     /*  569866 */     GIR_EraseRootFromParent_Done,
     /*  569867 */   // Label 9320: @569867
     /*  569867 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(569942), // Rule ID 3476 //
     /*  569872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  569889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  569918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  569937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569940 */     GIR_RootConstrainSelectedInstOperands,
     /*  569941 */     // GIR_Coverage, 3476,
     /*  569941 */     GIR_EraseRootFromParent_Done,
     /*  569942 */   // Label 9321: @569942
     /*  569942 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(570017), // Rule ID 3477 //
     /*  569947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  569955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  569964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569993 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  569993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  569996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570015 */     GIR_RootConstrainSelectedInstOperands,
     /*  570016 */     // GIR_Coverage, 3477,
     /*  570016 */     GIR_EraseRootFromParent_Done,
     /*  570017 */   // Label 9322: @570017
     /*  570017 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(570092), // Rule ID 3480 //
     /*  570022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  570039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  570071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570090 */     GIR_RootConstrainSelectedInstOperands,
     /*  570091 */     // GIR_Coverage, 3480,
     /*  570091 */     GIR_EraseRootFromParent_Done,
     /*  570092 */   // Label 9323: @570092
     /*  570092 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(570167), // Rule ID 3481 //
     /*  570097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  570114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11468:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  570146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570165 */     GIR_RootConstrainSelectedInstOperands,
     /*  570166 */     // GIR_Coverage, 3481,
     /*  570166 */     GIR_EraseRootFromParent_Done,
     /*  570167 */   // Label 9324: @570167
     /*  570167 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(570242), // Rule ID 3484 //
     /*  570172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  570189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  570221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570240 */     GIR_RootConstrainSelectedInstOperands,
     /*  570241 */     // GIR_Coverage, 3484,
     /*  570241 */     GIR_EraseRootFromParent_Done,
     /*  570242 */   // Label 9325: @570242
     /*  570242 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(570317), // Rule ID 3485 //
     /*  570247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  570264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11468:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  570296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570315 */     GIR_RootConstrainSelectedInstOperands,
     /*  570316 */     // GIR_Coverage, 3485,
     /*  570316 */     GIR_EraseRootFromParent_Done,
     /*  570317 */   // Label 9326: @570317
     /*  570317 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(570392), // Rule ID 3488 //
     /*  570322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  570325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  570339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  570368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  570371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570390 */     GIR_RootConstrainSelectedInstOperands,
     /*  570391 */     // GIR_Coverage, 3488,
     /*  570391 */     GIR_EraseRootFromParent_Done,
     /*  570392 */   // Label 9327: @570392
     /*  570392 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(570467), // Rule ID 3489 //
     /*  570397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  570400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  570405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  570414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11468:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  570443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  570446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  570462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570465 */     GIR_RootConstrainSelectedInstOperands,
     /*  570466 */     // GIR_Coverage, 3489,
     /*  570466 */     GIR_EraseRootFromParent_Done,
     /*  570467 */   // Label 9328: @570467
     /*  570467 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(570542), // Rule ID 3580 //
     /*  570472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  570521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570540 */     GIR_RootConstrainSelectedInstOperands,
     /*  570541 */     // GIR_Coverage, 3580,
     /*  570541 */     GIR_EraseRootFromParent_Done,
     /*  570542 */   // Label 9329: @570542
     /*  570542 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(570617), // Rule ID 3581 //
     /*  570547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  570596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570615 */     GIR_RootConstrainSelectedInstOperands,
     /*  570616 */     // GIR_Coverage, 3581,
     /*  570616 */     GIR_EraseRootFromParent_Done,
     /*  570617 */   // Label 9330: @570617
     /*  570617 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(570692), // Rule ID 3584 //
     /*  570622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  570671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570690 */     GIR_RootConstrainSelectedInstOperands,
     /*  570691 */     // GIR_Coverage, 3584,
     /*  570691 */     GIR_EraseRootFromParent_Done,
     /*  570692 */   // Label 9331: @570692
     /*  570692 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(570767), // Rule ID 3585 //
     /*  570697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  570746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570765 */     GIR_RootConstrainSelectedInstOperands,
     /*  570766 */     // GIR_Coverage, 3585,
     /*  570766 */     GIR_EraseRootFromParent_Done,
     /*  570767 */   // Label 9332: @570767
     /*  570767 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(570842), // Rule ID 3588 //
     /*  570772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  570789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  570792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  570821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570840 */     GIR_RootConstrainSelectedInstOperands,
     /*  570841 */     // GIR_Coverage, 3588,
     /*  570841 */     GIR_EraseRootFromParent_Done,
     /*  570842 */   // Label 9333: @570842
     /*  570842 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(570917), // Rule ID 3589 //
     /*  570847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  570864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  570867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  570896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570915 */     GIR_RootConstrainSelectedInstOperands,
     /*  570916 */     // GIR_Coverage, 3589,
     /*  570916 */     GIR_EraseRootFromParent_Done,
     /*  570917 */   // Label 9334: @570917
     /*  570917 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(570992), // Rule ID 3592 //
     /*  570922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  570933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  570936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  570939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  570942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  570971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570990 */     GIR_RootConstrainSelectedInstOperands,
     /*  570991 */     // GIR_Coverage, 3592,
     /*  570991 */     GIR_EraseRootFromParent_Done,
     /*  570992 */   // Label 9335: @570992
     /*  570992 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(571067), // Rule ID 3593 //
     /*  570997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571065 */     GIR_RootConstrainSelectedInstOperands,
     /*  571066 */     // GIR_Coverage, 3593,
     /*  571066 */     GIR_EraseRootFromParent_Done,
     /*  571067 */   // Label 9336: @571067
     /*  571067 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(571142), // Rule ID 3596 //
     /*  571072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571140 */     GIR_RootConstrainSelectedInstOperands,
     /*  571141 */     // GIR_Coverage, 3596,
     /*  571141 */     GIR_EraseRootFromParent_Done,
     /*  571142 */   // Label 9337: @571142
     /*  571142 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(571217), // Rule ID 3597 //
     /*  571147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571215 */     GIR_RootConstrainSelectedInstOperands,
     /*  571216 */     // GIR_Coverage, 3597,
     /*  571216 */     GIR_EraseRootFromParent_Done,
     /*  571217 */   // Label 9338: @571217
     /*  571217 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(571292), // Rule ID 3600 //
     /*  571222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  571271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571290 */     GIR_RootConstrainSelectedInstOperands,
     /*  571291 */     // GIR_Coverage, 3600,
     /*  571291 */     GIR_EraseRootFromParent_Done,
     /*  571292 */   // Label 9339: @571292
     /*  571292 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(571367), // Rule ID 3601 //
     /*  571297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  571346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571365 */     GIR_RootConstrainSelectedInstOperands,
     /*  571366 */     // GIR_Coverage, 3601,
     /*  571366 */     GIR_EraseRootFromParent_Done,
     /*  571367 */   // Label 9340: @571367
     /*  571367 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(571442), // Rule ID 3604 //
     /*  571372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  571421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571440 */     GIR_RootConstrainSelectedInstOperands,
     /*  571441 */     // GIR_Coverage, 3604,
     /*  571441 */     GIR_EraseRootFromParent_Done,
     /*  571442 */   // Label 9341: @571442
     /*  571442 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(571517), // Rule ID 3605 //
     /*  571447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  571496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571515 */     GIR_RootConstrainSelectedInstOperands,
     /*  571516 */     // GIR_Coverage, 3605,
     /*  571516 */     GIR_EraseRootFromParent_Done,
     /*  571517 */   // Label 9342: @571517
     /*  571517 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(571592), // Rule ID 3608 //
     /*  571522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  571571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571590 */     GIR_RootConstrainSelectedInstOperands,
     /*  571591 */     // GIR_Coverage, 3608,
     /*  571591 */     GIR_EraseRootFromParent_Done,
     /*  571592 */   // Label 9343: @571592
     /*  571592 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(571667), // Rule ID 3609 //
     /*  571597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  571646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571665 */     GIR_RootConstrainSelectedInstOperands,
     /*  571666 */     // GIR_Coverage, 3609,
     /*  571666 */     GIR_EraseRootFromParent_Done,
     /*  571667 */   // Label 9344: @571667
     /*  571667 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(571742), // Rule ID 3612 //
     /*  571672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571740 */     GIR_RootConstrainSelectedInstOperands,
     /*  571741 */     // GIR_Coverage, 3612,
     /*  571741 */     GIR_EraseRootFromParent_Done,
     /*  571742 */   // Label 9345: @571742
     /*  571742 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(571817), // Rule ID 3613 //
     /*  571747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  571796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571815 */     GIR_RootConstrainSelectedInstOperands,
     /*  571816 */     // GIR_Coverage, 3613,
     /*  571816 */     GIR_EraseRootFromParent_Done,
     /*  571817 */   // Label 9346: @571817
     /*  571817 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(571892), // Rule ID 3616 //
     /*  571822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571890 */     GIR_RootConstrainSelectedInstOperands,
     /*  571891 */     // GIR_Coverage, 3616,
     /*  571891 */     GIR_EraseRootFromParent_Done,
     /*  571892 */   // Label 9347: @571892
     /*  571892 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(571967), // Rule ID 3617 //
     /*  571897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  571946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571965 */     GIR_RootConstrainSelectedInstOperands,
     /*  571966 */     // GIR_Coverage, 3617,
     /*  571966 */     GIR_EraseRootFromParent_Done,
     /*  571967 */   // Label 9348: @571967
     /*  571967 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(572042), // Rule ID 3620 //
     /*  571972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  571983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  571986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  571989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  571992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572040 */     GIR_RootConstrainSelectedInstOperands,
     /*  572041 */     // GIR_Coverage, 3620,
     /*  572041 */     GIR_EraseRootFromParent_Done,
     /*  572042 */   // Label 9349: @572042
     /*  572042 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(572117), // Rule ID 3621 //
     /*  572047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572115 */     GIR_RootConstrainSelectedInstOperands,
     /*  572116 */     // GIR_Coverage, 3621,
     /*  572116 */     GIR_EraseRootFromParent_Done,
     /*  572117 */   // Label 9350: @572117
     /*  572117 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(572192), // Rule ID 3624 //
     /*  572122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  572171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572190 */     GIR_RootConstrainSelectedInstOperands,
     /*  572191 */     // GIR_Coverage, 3624,
     /*  572191 */     GIR_EraseRootFromParent_Done,
     /*  572192 */   // Label 9351: @572192
     /*  572192 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(572267), // Rule ID 3625 //
     /*  572197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  572246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572265 */     GIR_RootConstrainSelectedInstOperands,
     /*  572266 */     // GIR_Coverage, 3625,
     /*  572266 */     GIR_EraseRootFromParent_Done,
     /*  572267 */   // Label 9352: @572267
     /*  572267 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(572342), // Rule ID 3628 //
     /*  572272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  572321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572340 */     GIR_RootConstrainSelectedInstOperands,
     /*  572341 */     // GIR_Coverage, 3628,
     /*  572341 */     GIR_EraseRootFromParent_Done,
     /*  572342 */   // Label 9353: @572342
     /*  572342 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(572417), // Rule ID 3629 //
     /*  572347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  572396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572415 */     GIR_RootConstrainSelectedInstOperands,
     /*  572416 */     // GIR_Coverage, 3629,
     /*  572416 */     GIR_EraseRootFromParent_Done,
     /*  572417 */   // Label 9354: @572417
     /*  572417 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(572492), // Rule ID 3632 //
     /*  572422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  572471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572490 */     GIR_RootConstrainSelectedInstOperands,
     /*  572491 */     // GIR_Coverage, 3632,
     /*  572491 */     GIR_EraseRootFromParent_Done,
     /*  572492 */   // Label 9355: @572492
     /*  572492 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(572567), // Rule ID 3633 //
     /*  572497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572543 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  572546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572565 */     GIR_RootConstrainSelectedInstOperands,
     /*  572566 */     // GIR_Coverage, 3633,
     /*  572566 */     GIR_EraseRootFromParent_Done,
     /*  572567 */   // Label 9356: @572567
     /*  572567 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(572642), // Rule ID 3636 //
     /*  572572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572640 */     GIR_RootConstrainSelectedInstOperands,
     /*  572641 */     // GIR_Coverage, 3636,
     /*  572641 */     GIR_EraseRootFromParent_Done,
     /*  572642 */   // Label 9357: @572642
     /*  572642 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(572717), // Rule ID 3637 //
     /*  572647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  572696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572715 */     GIR_RootConstrainSelectedInstOperands,
     /*  572716 */     // GIR_Coverage, 3637,
     /*  572716 */     GIR_EraseRootFromParent_Done,
     /*  572717 */   // Label 9358: @572717
     /*  572717 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(572792), // Rule ID 3640 //
     /*  572722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  572771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572790 */     GIR_RootConstrainSelectedInstOperands,
     /*  572791 */     // GIR_Coverage, 3640,
     /*  572791 */     GIR_EraseRootFromParent_Done,
     /*  572792 */   // Label 9359: @572792
     /*  572792 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(572867), // Rule ID 3641 //
     /*  572797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  572846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572865 */     GIR_RootConstrainSelectedInstOperands,
     /*  572866 */     // GIR_Coverage, 3641,
     /*  572866 */     GIR_EraseRootFromParent_Done,
     /*  572867 */   // Label 9360: @572867
     /*  572867 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(572942), // Rule ID 3644 //
     /*  572872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  572883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  572886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  572921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572940 */     GIR_RootConstrainSelectedInstOperands,
     /*  572941 */     // GIR_Coverage, 3644,
     /*  572941 */     GIR_EraseRootFromParent_Done,
     /*  572942 */   // Label 9361: @572942
     /*  572942 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(573017), // Rule ID 3645 //
     /*  572947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  572955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  572958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  572961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  572964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  572996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573015 */     GIR_RootConstrainSelectedInstOperands,
     /*  573016 */     // GIR_Coverage, 3645,
     /*  573016 */     GIR_EraseRootFromParent_Done,
     /*  573017 */   // Label 9362: @573017
     /*  573017 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(573092), // Rule ID 3648 //
     /*  573022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573090 */     GIR_RootConstrainSelectedInstOperands,
     /*  573091 */     // GIR_Coverage, 3648,
     /*  573091 */     GIR_EraseRootFromParent_Done,
     /*  573092 */   // Label 9363: @573092
     /*  573092 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(573167), // Rule ID 3649 //
     /*  573097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573165 */     GIR_RootConstrainSelectedInstOperands,
     /*  573166 */     // GIR_Coverage, 3649,
     /*  573166 */     GIR_EraseRootFromParent_Done,
     /*  573167 */   // Label 9364: @573167
     /*  573167 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(573242), // Rule ID 3652 //
     /*  573172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573240 */     GIR_RootConstrainSelectedInstOperands,
     /*  573241 */     // GIR_Coverage, 3652,
     /*  573241 */     GIR_EraseRootFromParent_Done,
     /*  573242 */   // Label 9365: @573242
     /*  573242 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(573317), // Rule ID 3653 //
     /*  573247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573315 */     GIR_RootConstrainSelectedInstOperands,
     /*  573316 */     // GIR_Coverage, 3653,
     /*  573316 */     GIR_EraseRootFromParent_Done,
     /*  573317 */   // Label 9366: @573317
     /*  573317 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(573392), // Rule ID 3656 //
     /*  573322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  573371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573390 */     GIR_RootConstrainSelectedInstOperands,
     /*  573391 */     // GIR_Coverage, 3656,
     /*  573391 */     GIR_EraseRootFromParent_Done,
     /*  573392 */   // Label 9367: @573392
     /*  573392 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(573467), // Rule ID 3657 //
     /*  573397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  573446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573465 */     GIR_RootConstrainSelectedInstOperands,
     /*  573466 */     // GIR_Coverage, 3657,
     /*  573466 */     GIR_EraseRootFromParent_Done,
     /*  573467 */   // Label 9368: @573467
     /*  573467 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(573542), // Rule ID 3660 //
     /*  573472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  573521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573540 */     GIR_RootConstrainSelectedInstOperands,
     /*  573541 */     // GIR_Coverage, 3660,
     /*  573541 */     GIR_EraseRootFromParent_Done,
     /*  573542 */   // Label 9369: @573542
     /*  573542 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(573617), // Rule ID 3661 //
     /*  573547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  573596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573615 */     GIR_RootConstrainSelectedInstOperands,
     /*  573616 */     // GIR_Coverage, 3661,
     /*  573616 */     GIR_EraseRootFromParent_Done,
     /*  573617 */   // Label 9370: @573617
     /*  573617 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(573692), // Rule ID 3664 //
     /*  573622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  573671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573690 */     GIR_RootConstrainSelectedInstOperands,
     /*  573691 */     // GIR_Coverage, 3664,
     /*  573691 */     GIR_EraseRootFromParent_Done,
     /*  573692 */   // Label 9371: @573692
     /*  573692 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(573767), // Rule ID 3665 //
     /*  573697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  573746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573765 */     GIR_RootConstrainSelectedInstOperands,
     /*  573766 */     // GIR_Coverage, 3665,
     /*  573766 */     GIR_EraseRootFromParent_Done,
     /*  573767 */   // Label 9372: @573767
     /*  573767 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(573842), // Rule ID 3668 //
     /*  573772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573840 */     GIR_RootConstrainSelectedInstOperands,
     /*  573841 */     // GIR_Coverage, 3668,
     /*  573841 */     GIR_EraseRootFromParent_Done,
     /*  573842 */   // Label 9373: @573842
     /*  573842 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(573917), // Rule ID 3669 //
     /*  573847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  573896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573915 */     GIR_RootConstrainSelectedInstOperands,
     /*  573916 */     // GIR_Coverage, 3669,
     /*  573916 */     GIR_EraseRootFromParent_Done,
     /*  573917 */   // Label 9374: @573917
     /*  573917 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(573992), // Rule ID 3672 //
     /*  573922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  573930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  573933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  573936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  573939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  573971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573990 */     GIR_RootConstrainSelectedInstOperands,
     /*  573991 */     // GIR_Coverage, 3672,
     /*  573991 */     GIR_EraseRootFromParent_Done,
     /*  573992 */   // Label 9375: @573992
     /*  573992 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(574067), // Rule ID 3673 //
     /*  573997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574065 */     GIR_RootConstrainSelectedInstOperands,
     /*  574066 */     // GIR_Coverage, 3673,
     /*  574066 */     GIR_EraseRootFromParent_Done,
     /*  574067 */   // Label 9376: @574067
     /*  574067 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(574142), // Rule ID 3676 //
     /*  574072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574140 */     GIR_RootConstrainSelectedInstOperands,
     /*  574141 */     // GIR_Coverage, 3676,
     /*  574141 */     GIR_EraseRootFromParent_Done,
     /*  574142 */   // Label 9377: @574142
     /*  574142 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(574217), // Rule ID 3677 //
     /*  574147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574215 */     GIR_RootConstrainSelectedInstOperands,
     /*  574216 */     // GIR_Coverage, 3677,
     /*  574216 */     GIR_EraseRootFromParent_Done,
     /*  574217 */   // Label 9378: @574217
     /*  574217 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(574292), // Rule ID 3680 //
     /*  574222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574290 */     GIR_RootConstrainSelectedInstOperands,
     /*  574291 */     // GIR_Coverage, 3680,
     /*  574291 */     GIR_EraseRootFromParent_Done,
     /*  574292 */   // Label 9379: @574292
     /*  574292 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(574367), // Rule ID 3681 //
     /*  574297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574365 */     GIR_RootConstrainSelectedInstOperands,
     /*  574366 */     // GIR_Coverage, 3681,
     /*  574366 */     GIR_EraseRootFromParent_Done,
     /*  574367 */   // Label 9380: @574367
     /*  574367 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(574442), // Rule ID 3684 //
     /*  574372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  574421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574440 */     GIR_RootConstrainSelectedInstOperands,
     /*  574441 */     // GIR_Coverage, 3684,
     /*  574441 */     GIR_EraseRootFromParent_Done,
     /*  574442 */   // Label 9381: @574442
     /*  574442 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(574517), // Rule ID 3685 //
     /*  574447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  574496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574515 */     GIR_RootConstrainSelectedInstOperands,
     /*  574516 */     // GIR_Coverage, 3685,
     /*  574516 */     GIR_EraseRootFromParent_Done,
     /*  574517 */   // Label 9382: @574517
     /*  574517 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(574592), // Rule ID 3688 //
     /*  574522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574590 */     GIR_RootConstrainSelectedInstOperands,
     /*  574591 */     // GIR_Coverage, 3688,
     /*  574591 */     GIR_EraseRootFromParent_Done,
     /*  574592 */   // Label 9383: @574592
     /*  574592 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(574667), // Rule ID 3689 //
     /*  574597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  574646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574665 */     GIR_RootConstrainSelectedInstOperands,
     /*  574666 */     // GIR_Coverage, 3689,
     /*  574666 */     GIR_EraseRootFromParent_Done,
     /*  574667 */   // Label 9384: @574667
     /*  574667 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(574742), // Rule ID 3692 //
     /*  574672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574740 */     GIR_RootConstrainSelectedInstOperands,
     /*  574741 */     // GIR_Coverage, 3692,
     /*  574741 */     GIR_EraseRootFromParent_Done,
     /*  574742 */   // Label 9385: @574742
     /*  574742 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(574817), // Rule ID 3693 //
     /*  574747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  574796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574815 */     GIR_RootConstrainSelectedInstOperands,
     /*  574816 */     // GIR_Coverage, 3693,
     /*  574816 */     GIR_EraseRootFromParent_Done,
     /*  574817 */   // Label 9386: @574817
     /*  574817 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(574892), // Rule ID 3696 //
     /*  574822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  574833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  574836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  574839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574890 */     GIR_RootConstrainSelectedInstOperands,
     /*  574891 */     // GIR_Coverage, 3696,
     /*  574891 */     GIR_EraseRootFromParent_Done,
     /*  574892 */   // Label 9387: @574892
     /*  574892 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(574967), // Rule ID 3697 //
     /*  574897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  574905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  574908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  574911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  574914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  574946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574965 */     GIR_RootConstrainSelectedInstOperands,
     /*  574966 */     // GIR_Coverage, 3697,
     /*  574966 */     GIR_EraseRootFromParent_Done,
     /*  574967 */   // Label 9388: @574967
     /*  574967 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(575042), // Rule ID 3700 //
     /*  574972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  574983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  574986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  574989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  574992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  575021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575040 */     GIR_RootConstrainSelectedInstOperands,
     /*  575041 */     // GIR_Coverage, 3700,
     /*  575041 */     GIR_EraseRootFromParent_Done,
     /*  575042 */   // Label 9389: @575042
     /*  575042 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(575117), // Rule ID 3701 //
     /*  575047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  575096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575115 */     GIR_RootConstrainSelectedInstOperands,
     /*  575116 */     // GIR_Coverage, 3701,
     /*  575116 */     GIR_EraseRootFromParent_Done,
     /*  575117 */   // Label 9390: @575117
     /*  575117 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(575192), // Rule ID 3704 //
     /*  575122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575190 */     GIR_RootConstrainSelectedInstOperands,
     /*  575191 */     // GIR_Coverage, 3704,
     /*  575191 */     GIR_EraseRootFromParent_Done,
     /*  575192 */   // Label 9391: @575192
     /*  575192 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(575267), // Rule ID 3705 //
     /*  575197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575265 */     GIR_RootConstrainSelectedInstOperands,
     /*  575266 */     // GIR_Coverage, 3705,
     /*  575266 */     GIR_EraseRootFromParent_Done,
     /*  575267 */   // Label 9392: @575267
     /*  575267 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(575342), // Rule ID 3708 //
     /*  575272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  575321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575340 */     GIR_RootConstrainSelectedInstOperands,
     /*  575341 */     // GIR_Coverage, 3708,
     /*  575341 */     GIR_EraseRootFromParent_Done,
     /*  575342 */   // Label 9393: @575342
     /*  575342 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(575417), // Rule ID 3709 //
     /*  575347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  575396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575415 */     GIR_RootConstrainSelectedInstOperands,
     /*  575416 */     // GIR_Coverage, 3709,
     /*  575416 */     GIR_EraseRootFromParent_Done,
     /*  575417 */   // Label 9394: @575417
     /*  575417 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(575492), // Rule ID 3712 //
     /*  575422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  575471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575490 */     GIR_RootConstrainSelectedInstOperands,
     /*  575491 */     // GIR_Coverage, 3712,
     /*  575491 */     GIR_EraseRootFromParent_Done,
     /*  575492 */   // Label 9395: @575492
     /*  575492 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(575567), // Rule ID 3713 //
     /*  575497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  575546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575565 */     GIR_RootConstrainSelectedInstOperands,
     /*  575566 */     // GIR_Coverage, 3713,
     /*  575566 */     GIR_EraseRootFromParent_Done,
     /*  575567 */   // Label 9396: @575567
     /*  575567 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(575642), // Rule ID 3716 //
     /*  575572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  575621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575640 */     GIR_RootConstrainSelectedInstOperands,
     /*  575641 */     // GIR_Coverage, 3716,
     /*  575641 */     GIR_EraseRootFromParent_Done,
     /*  575642 */   // Label 9397: @575642
     /*  575642 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(575717), // Rule ID 3717 //
     /*  575647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  575696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575715 */     GIR_RootConstrainSelectedInstOperands,
     /*  575716 */     // GIR_Coverage, 3717,
     /*  575716 */     GIR_EraseRootFromParent_Done,
     /*  575717 */   // Label 9398: @575717
     /*  575717 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(575792), // Rule ID 3720 //
     /*  575722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  575771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575790 */     GIR_RootConstrainSelectedInstOperands,
     /*  575791 */     // GIR_Coverage, 3720,
     /*  575791 */     GIR_EraseRootFromParent_Done,
     /*  575792 */   // Label 9399: @575792
     /*  575792 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(575867), // Rule ID 3721 //
     /*  575797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  575846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575865 */     GIR_RootConstrainSelectedInstOperands,
     /*  575866 */     // GIR_Coverage, 3721,
     /*  575866 */     GIR_EraseRootFromParent_Done,
     /*  575867 */   // Label 9400: @575867
     /*  575867 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(575942), // Rule ID 3724 //
     /*  575872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  575883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  575886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  575889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  575892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  575918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575940 */     GIR_RootConstrainSelectedInstOperands,
     /*  575941 */     // GIR_Coverage, 3724,
     /*  575941 */     GIR_EraseRootFromParent_Done,
     /*  575942 */   // Label 9401: @575942
     /*  575942 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(576017), // Rule ID 3725 //
     /*  575947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  575958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  575961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  575964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  575967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  575993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  575996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576015 */     GIR_RootConstrainSelectedInstOperands,
     /*  576016 */     // GIR_Coverage, 3725,
     /*  576016 */     GIR_EraseRootFromParent_Done,
     /*  576017 */   // Label 9402: @576017
     /*  576017 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(576092), // Rule ID 3728 //
     /*  576022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576090 */     GIR_RootConstrainSelectedInstOperands,
     /*  576091 */     // GIR_Coverage, 3728,
     /*  576091 */     GIR_EraseRootFromParent_Done,
     /*  576092 */   // Label 9403: @576092
     /*  576092 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(576167), // Rule ID 3729 //
     /*  576097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576165 */     GIR_RootConstrainSelectedInstOperands,
     /*  576166 */     // GIR_Coverage, 3729,
     /*  576166 */     GIR_EraseRootFromParent_Done,
     /*  576167 */   // Label 9404: @576167
     /*  576167 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(576242), // Rule ID 3732 //
     /*  576172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576240 */     GIR_RootConstrainSelectedInstOperands,
     /*  576241 */     // GIR_Coverage, 3732,
     /*  576241 */     GIR_EraseRootFromParent_Done,
     /*  576242 */   // Label 9405: @576242
     /*  576242 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(576317), // Rule ID 3733 //
     /*  576247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576315 */     GIR_RootConstrainSelectedInstOperands,
     /*  576316 */     // GIR_Coverage, 3733,
     /*  576316 */     GIR_EraseRootFromParent_Done,
     /*  576317 */   // Label 9406: @576317
     /*  576317 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(576392), // Rule ID 3736 //
     /*  576322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576390 */     GIR_RootConstrainSelectedInstOperands,
     /*  576391 */     // GIR_Coverage, 3736,
     /*  576391 */     GIR_EraseRootFromParent_Done,
     /*  576392 */   // Label 9407: @576392
     /*  576392 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(576467), // Rule ID 3737 //
     /*  576397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576465 */     GIR_RootConstrainSelectedInstOperands,
     /*  576466 */     // GIR_Coverage, 3737,
     /*  576466 */     GIR_EraseRootFromParent_Done,
     /*  576467 */   // Label 9408: @576467
     /*  576467 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(576542), // Rule ID 3740 //
     /*  576472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  576521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576540 */     GIR_RootConstrainSelectedInstOperands,
     /*  576541 */     // GIR_Coverage, 3740,
     /*  576541 */     GIR_EraseRootFromParent_Done,
     /*  576542 */   // Label 9409: @576542
     /*  576542 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(576617), // Rule ID 3741 //
     /*  576547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  576596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576615 */     GIR_RootConstrainSelectedInstOperands,
     /*  576616 */     // GIR_Coverage, 3741,
     /*  576616 */     GIR_EraseRootFromParent_Done,
     /*  576617 */   // Label 9410: @576617
     /*  576617 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(576692), // Rule ID 3744 //
     /*  576622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576690 */     GIR_RootConstrainSelectedInstOperands,
     /*  576691 */     // GIR_Coverage, 3744,
     /*  576691 */     GIR_EraseRootFromParent_Done,
     /*  576692 */   // Label 9411: @576692
     /*  576692 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(576767), // Rule ID 3745 //
     /*  576697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  576746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576765 */     GIR_RootConstrainSelectedInstOperands,
     /*  576766 */     // GIR_Coverage, 3745,
     /*  576766 */     GIR_EraseRootFromParent_Done,
     /*  576767 */   // Label 9412: @576767
     /*  576767 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(576842), // Rule ID 3748 //
     /*  576772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  576783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  576786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  576789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  576792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576840 */     GIR_RootConstrainSelectedInstOperands,
     /*  576841 */     // GIR_Coverage, 3748,
     /*  576841 */     GIR_EraseRootFromParent_Done,
     /*  576842 */   // Label 9413: @576842
     /*  576842 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(576917), // Rule ID 3749 //
     /*  576847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  576858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  576861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  576864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  576867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  576896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576915 */     GIR_RootConstrainSelectedInstOperands,
     /*  576916 */     // GIR_Coverage, 3749,
     /*  576916 */     GIR_EraseRootFromParent_Done,
     /*  576917 */   // Label 9414: @576917
     /*  576917 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(576992), // Rule ID 3752 //
     /*  576922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  576930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  576933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  576936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  576939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  576942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  576971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576990 */     GIR_RootConstrainSelectedInstOperands,
     /*  576991 */     // GIR_Coverage, 3752,
     /*  576991 */     GIR_EraseRootFromParent_Done,
     /*  576992 */   // Label 9415: @576992
     /*  576992 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(577067), // Rule ID 3753 //
     /*  576997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  577046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577065 */     GIR_RootConstrainSelectedInstOperands,
     /*  577066 */     // GIR_Coverage, 3753,
     /*  577066 */     GIR_EraseRootFromParent_Done,
     /*  577067 */   // Label 9416: @577067
     /*  577067 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(577142), // Rule ID 3756 //
     /*  577072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  577121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577140 */     GIR_RootConstrainSelectedInstOperands,
     /*  577141 */     // GIR_Coverage, 3756,
     /*  577141 */     GIR_EraseRootFromParent_Done,
     /*  577142 */   // Label 9417: @577142
     /*  577142 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(577217), // Rule ID 3757 //
     /*  577147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  577196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577215 */     GIR_RootConstrainSelectedInstOperands,
     /*  577216 */     // GIR_Coverage, 3757,
     /*  577216 */     GIR_EraseRootFromParent_Done,
     /*  577217 */   // Label 9418: @577217
     /*  577217 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(577292), // Rule ID 3760 //
     /*  577222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  577271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577290 */     GIR_RootConstrainSelectedInstOperands,
     /*  577291 */     // GIR_Coverage, 3760,
     /*  577291 */     GIR_EraseRootFromParent_Done,
     /*  577292 */   // Label 9419: @577292
     /*  577292 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(577367), // Rule ID 3761 //
     /*  577297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  577346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577365 */     GIR_RootConstrainSelectedInstOperands,
     /*  577366 */     // GIR_Coverage, 3761,
     /*  577366 */     GIR_EraseRootFromParent_Done,
     /*  577367 */   // Label 9420: @577367
     /*  577367 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(577442), // Rule ID 3764 //
     /*  577372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  577421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577440 */     GIR_RootConstrainSelectedInstOperands,
     /*  577441 */     // GIR_Coverage, 3764,
     /*  577441 */     GIR_EraseRootFromParent_Done,
     /*  577442 */   // Label 9421: @577442
     /*  577442 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(577517), // Rule ID 3765 //
     /*  577447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  577496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577515 */     GIR_RootConstrainSelectedInstOperands,
     /*  577516 */     // GIR_Coverage, 3765,
     /*  577516 */     GIR_EraseRootFromParent_Done,
     /*  577517 */   // Label 9422: @577517
     /*  577517 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(577592), // Rule ID 3768 //
     /*  577522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  577571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577590 */     GIR_RootConstrainSelectedInstOperands,
     /*  577591 */     // GIR_Coverage, 3768,
     /*  577591 */     GIR_EraseRootFromParent_Done,
     /*  577592 */   // Label 9423: @577592
     /*  577592 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(577667), // Rule ID 3769 //
     /*  577597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11610:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  577646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577665 */     GIR_RootConstrainSelectedInstOperands,
     /*  577666 */     // GIR_Coverage, 3769,
     /*  577666 */     GIR_EraseRootFromParent_Done,
     /*  577667 */   // Label 9424: @577667
     /*  577667 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(577742), // Rule ID 3772 //
     /*  577672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  577721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577740 */     GIR_RootConstrainSelectedInstOperands,
     /*  577741 */     // GIR_Coverage, 3772,
     /*  577741 */     GIR_EraseRootFromParent_Done,
     /*  577742 */   // Label 9425: @577742
     /*  577742 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(577817), // Rule ID 3773 //
     /*  577747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  577796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577815 */     GIR_RootConstrainSelectedInstOperands,
     /*  577816 */     // GIR_Coverage, 3773,
     /*  577816 */     GIR_EraseRootFromParent_Done,
     /*  577817 */   // Label 9426: @577817
     /*  577817 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(577892), // Rule ID 3776 //
     /*  577822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  577871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577890 */     GIR_RootConstrainSelectedInstOperands,
     /*  577891 */     // GIR_Coverage, 3776,
     /*  577891 */     GIR_EraseRootFromParent_Done,
     /*  577892 */   // Label 9427: @577892
     /*  577892 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(577967), // Rule ID 3777 //
     /*  577897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  577946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577965 */     GIR_RootConstrainSelectedInstOperands,
     /*  577966 */     // GIR_Coverage, 3777,
     /*  577966 */     GIR_EraseRootFromParent_Done,
     /*  577967 */   // Label 9428: @577967
     /*  577967 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(578042), // Rule ID 3780 //
     /*  577972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  577980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  577983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  577986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  577989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578040 */     GIR_RootConstrainSelectedInstOperands,
     /*  578041 */     // GIR_Coverage, 3780,
     /*  578041 */     GIR_EraseRootFromParent_Done,
     /*  578042 */   // Label 9429: @578042
     /*  578042 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(578117), // Rule ID 3781 //
     /*  578047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578115 */     GIR_RootConstrainSelectedInstOperands,
     /*  578116 */     // GIR_Coverage, 3781,
     /*  578116 */     GIR_EraseRootFromParent_Done,
     /*  578117 */   // Label 9430: @578117
     /*  578117 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(578192), // Rule ID 3784 //
     /*  578122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  578171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578190 */     GIR_RootConstrainSelectedInstOperands,
     /*  578191 */     // GIR_Coverage, 3784,
     /*  578191 */     GIR_EraseRootFromParent_Done,
     /*  578192 */   // Label 9431: @578192
     /*  578192 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(578267), // Rule ID 3785 //
     /*  578197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  578246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578265 */     GIR_RootConstrainSelectedInstOperands,
     /*  578266 */     // GIR_Coverage, 3785,
     /*  578266 */     GIR_EraseRootFromParent_Done,
     /*  578267 */   // Label 9432: @578267
     /*  578267 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(578342), // Rule ID 3788 //
     /*  578272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578340 */     GIR_RootConstrainSelectedInstOperands,
     /*  578341 */     // GIR_Coverage, 3788,
     /*  578341 */     GIR_EraseRootFromParent_Done,
     /*  578342 */   // Label 9433: @578342
     /*  578342 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(578417), // Rule ID 3789 //
     /*  578347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11610:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578415 */     GIR_RootConstrainSelectedInstOperands,
     /*  578416 */     // GIR_Coverage, 3789,
     /*  578416 */     GIR_EraseRootFromParent_Done,
     /*  578417 */   // Label 9434: @578417
     /*  578417 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(578492), // Rule ID 3792 //
     /*  578422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  578471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578490 */     GIR_RootConstrainSelectedInstOperands,
     /*  578491 */     // GIR_Coverage, 3792,
     /*  578491 */     GIR_EraseRootFromParent_Done,
     /*  578492 */   // Label 9435: @578492
     /*  578492 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(578567), // Rule ID 3793 //
     /*  578497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  578546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578565 */     GIR_RootConstrainSelectedInstOperands,
     /*  578566 */     // GIR_Coverage, 3793,
     /*  578566 */     GIR_EraseRootFromParent_Done,
     /*  578567 */   // Label 9436: @578567
     /*  578567 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(578642), // Rule ID 3796 //
     /*  578572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  578621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578640 */     GIR_RootConstrainSelectedInstOperands,
     /*  578641 */     // GIR_Coverage, 3796,
     /*  578641 */     GIR_EraseRootFromParent_Done,
     /*  578642 */   // Label 9437: @578642
     /*  578642 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(578717), // Rule ID 3797 //
     /*  578647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578693 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  578696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578715 */     GIR_RootConstrainSelectedInstOperands,
     /*  578716 */     // GIR_Coverage, 3797,
     /*  578716 */     GIR_EraseRootFromParent_Done,
     /*  578717 */   // Label 9438: @578717
     /*  578717 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(578792), // Rule ID 3800 //
     /*  578722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578790 */     GIR_RootConstrainSelectedInstOperands,
     /*  578791 */     // GIR_Coverage, 3800,
     /*  578791 */     GIR_EraseRootFromParent_Done,
     /*  578792 */   // Label 9439: @578792
     /*  578792 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(578867), // Rule ID 3801 //
     /*  578797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  578846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578865 */     GIR_RootConstrainSelectedInstOperands,
     /*  578866 */     // GIR_Coverage, 3801,
     /*  578866 */     GIR_EraseRootFromParent_Done,
     /*  578867 */   // Label 9440: @578867
     /*  578867 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(578942), // Rule ID 3804 //
     /*  578872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  578875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  578883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  578886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  578889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  578918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  578937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578940 */     GIR_RootConstrainSelectedInstOperands,
     /*  578941 */     // GIR_Coverage, 3804,
     /*  578941 */     GIR_EraseRootFromParent_Done,
     /*  578942 */   // Label 9441: @578942
     /*  578942 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(579017), // Rule ID 3805 //
     /*  578947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  578950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  578955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  578958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  578961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  578964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11610:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  578993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  578996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579015 */     GIR_RootConstrainSelectedInstOperands,
     /*  579016 */     // GIR_Coverage, 3805,
     /*  579016 */     GIR_EraseRootFromParent_Done,
     /*  579017 */   // Label 9442: @579017
     /*  579017 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(579092), // Rule ID 3808 //
     /*  579022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  579071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579090 */     GIR_RootConstrainSelectedInstOperands,
     /*  579091 */     // GIR_Coverage, 3808,
     /*  579091 */     GIR_EraseRootFromParent_Done,
     /*  579092 */   // Label 9443: @579092
     /*  579092 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(579167), // Rule ID 3809 //
     /*  579097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11610:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  579146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579165 */     GIR_RootConstrainSelectedInstOperands,
     /*  579166 */     // GIR_Coverage, 3809,
     /*  579166 */     GIR_EraseRootFromParent_Done,
     /*  579167 */   // Label 9444: @579167
     /*  579167 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(579242), // Rule ID 3812 //
     /*  579172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  579221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579240 */     GIR_RootConstrainSelectedInstOperands,
     /*  579241 */     // GIR_Coverage, 3812,
     /*  579241 */     GIR_EraseRootFromParent_Done,
     /*  579242 */   // Label 9445: @579242
     /*  579242 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(579317), // Rule ID 3813 //
     /*  579247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11610:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  579296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579315 */     GIR_RootConstrainSelectedInstOperands,
     /*  579316 */     // GIR_Coverage, 3813,
     /*  579316 */     GIR_EraseRootFromParent_Done,
     /*  579317 */   // Label 9446: @579317
     /*  579317 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(579392), // Rule ID 3816 //
     /*  579322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  579371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579390 */     GIR_RootConstrainSelectedInstOperands,
     /*  579391 */     // GIR_Coverage, 3816,
     /*  579391 */     GIR_EraseRootFromParent_Done,
     /*  579392 */   // Label 9447: @579392
     /*  579392 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(579467), // Rule ID 3817 //
     /*  579397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  579405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11610:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  579446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579465 */     GIR_RootConstrainSelectedInstOperands,
     /*  579466 */     // GIR_Coverage, 3817,
     /*  579466 */     GIR_EraseRootFromParent_Done,
     /*  579467 */   // Label 9448: @579467
     /*  579467 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(579542), // Rule ID 3820 //
     /*  579472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579518 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  579521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579540 */     GIR_RootConstrainSelectedInstOperands,
     /*  579541 */     // GIR_Coverage, 3820,
     /*  579541 */     GIR_EraseRootFromParent_Done,
     /*  579542 */   // Label 9449: @579542
     /*  579542 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(579617), // Rule ID 3821 //
     /*  579547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  579596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579615 */     GIR_RootConstrainSelectedInstOperands,
     /*  579616 */     // GIR_Coverage, 3821,
     /*  579616 */     GIR_EraseRootFromParent_Done,
     /*  579617 */   // Label 9450: @579617
     /*  579617 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(579692), // Rule ID 3824 //
     /*  579622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  579671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579690 */     GIR_RootConstrainSelectedInstOperands,
     /*  579691 */     // GIR_Coverage, 3824,
     /*  579691 */     GIR_EraseRootFromParent_Done,
     /*  579692 */   // Label 9451: @579692
     /*  579692 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(579767), // Rule ID 3825 //
     /*  579697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  579746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579765 */     GIR_RootConstrainSelectedInstOperands,
     /*  579766 */     // GIR_Coverage, 3825,
     /*  579766 */     GIR_EraseRootFromParent_Done,
     /*  579767 */   // Label 9452: @579767
     /*  579767 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(579842), // Rule ID 3828 //
     /*  579772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  579783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  579786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  579792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  579821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579840 */     GIR_RootConstrainSelectedInstOperands,
     /*  579841 */     // GIR_Coverage, 3828,
     /*  579841 */     GIR_EraseRootFromParent_Done,
     /*  579842 */   // Label 9453: @579842
     /*  579842 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(579917), // Rule ID 3829 //
     /*  579847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  579858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  579861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  579867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  579896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579915 */     GIR_RootConstrainSelectedInstOperands,
     /*  579916 */     // GIR_Coverage, 3829,
     /*  579916 */     GIR_EraseRootFromParent_Done,
     /*  579917 */   // Label 9454: @579917
     /*  579917 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(579992), // Rule ID 3832 //
     /*  579922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  579933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  579936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  579939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  579942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  579971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579990 */     GIR_RootConstrainSelectedInstOperands,
     /*  579991 */     // GIR_Coverage, 3832,
     /*  579991 */     GIR_EraseRootFromParent_Done,
     /*  579992 */   // Label 9455: @579992
     /*  579992 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(580067), // Rule ID 3833 //
     /*  579997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580065 */     GIR_RootConstrainSelectedInstOperands,
     /*  580066 */     // GIR_Coverage, 3833,
     /*  580066 */     GIR_EraseRootFromParent_Done,
     /*  580067 */   // Label 9456: @580067
     /*  580067 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(580142), // Rule ID 3836 //
     /*  580072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580140 */     GIR_RootConstrainSelectedInstOperands,
     /*  580141 */     // GIR_Coverage, 3836,
     /*  580141 */     GIR_EraseRootFromParent_Done,
     /*  580142 */   // Label 9457: @580142
     /*  580142 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(580217), // Rule ID 3837 //
     /*  580147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580193 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580215 */     GIR_RootConstrainSelectedInstOperands,
     /*  580216 */     // GIR_Coverage, 3837,
     /*  580216 */     GIR_EraseRootFromParent_Done,
     /*  580217 */   // Label 9458: @580217
     /*  580217 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(580292), // Rule ID 3840 //
     /*  580222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  580271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580290 */     GIR_RootConstrainSelectedInstOperands,
     /*  580291 */     // GIR_Coverage, 3840,
     /*  580291 */     GIR_EraseRootFromParent_Done,
     /*  580292 */   // Label 9459: @580292
     /*  580292 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(580367), // Rule ID 3841 //
     /*  580297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  580346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580365 */     GIR_RootConstrainSelectedInstOperands,
     /*  580366 */     // GIR_Coverage, 3841,
     /*  580366 */     GIR_EraseRootFromParent_Done,
     /*  580367 */   // Label 9460: @580367
     /*  580367 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(580442), // Rule ID 3844 //
     /*  580372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  580421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580440 */     GIR_RootConstrainSelectedInstOperands,
     /*  580441 */     // GIR_Coverage, 3844,
     /*  580441 */     GIR_EraseRootFromParent_Done,
     /*  580442 */   // Label 9461: @580442
     /*  580442 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(580517), // Rule ID 3845 //
     /*  580447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  580496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580515 */     GIR_RootConstrainSelectedInstOperands,
     /*  580516 */     // GIR_Coverage, 3845,
     /*  580516 */     GIR_EraseRootFromParent_Done,
     /*  580517 */   // Label 9462: @580517
     /*  580517 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(580592), // Rule ID 3848 //
     /*  580522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  580571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580590 */     GIR_RootConstrainSelectedInstOperands,
     /*  580591 */     // GIR_Coverage, 3848,
     /*  580591 */     GIR_EraseRootFromParent_Done,
     /*  580592 */   // Label 9463: @580592
     /*  580592 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(580667), // Rule ID 3849 //
     /*  580597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580643 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  580646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580665 */     GIR_RootConstrainSelectedInstOperands,
     /*  580666 */     // GIR_Coverage, 3849,
     /*  580666 */     GIR_EraseRootFromParent_Done,
     /*  580667 */   // Label 9464: @580667
     /*  580667 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(580742), // Rule ID 3852 //
     /*  580672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580740 */     GIR_RootConstrainSelectedInstOperands,
     /*  580741 */     // GIR_Coverage, 3852,
     /*  580741 */     GIR_EraseRootFromParent_Done,
     /*  580742 */   // Label 9465: @580742
     /*  580742 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(580817), // Rule ID 3853 //
     /*  580747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  580796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580815 */     GIR_RootConstrainSelectedInstOperands,
     /*  580816 */     // GIR_Coverage, 3853,
     /*  580816 */     GIR_EraseRootFromParent_Done,
     /*  580817 */   // Label 9466: @580817
     /*  580817 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(580892), // Rule ID 3856 //
     /*  580822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  580833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  580836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  580839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  580842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580890 */     GIR_RootConstrainSelectedInstOperands,
     /*  580891 */     // GIR_Coverage, 3856,
     /*  580891 */     GIR_EraseRootFromParent_Done,
     /*  580892 */   // Label 9467: @580892
     /*  580892 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(580967), // Rule ID 3857 //
     /*  580897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  580908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  580911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  580914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  580917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  580946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580965 */     GIR_RootConstrainSelectedInstOperands,
     /*  580966 */     // GIR_Coverage, 3857,
     /*  580966 */     GIR_EraseRootFromParent_Done,
     /*  580967 */   // Label 9468: @580967
     /*  580967 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(581042), // Rule ID 3860 //
     /*  580972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  580983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  580986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  580989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  580992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581040 */     GIR_RootConstrainSelectedInstOperands,
     /*  581041 */     // GIR_Coverage, 3860,
     /*  581041 */     GIR_EraseRootFromParent_Done,
     /*  581042 */   // Label 9469: @581042
     /*  581042 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(581117), // Rule ID 3861 //
     /*  581047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581115 */     GIR_RootConstrainSelectedInstOperands,
     /*  581116 */     // GIR_Coverage, 3861,
     /*  581116 */     GIR_EraseRootFromParent_Done,
     /*  581117 */   // Label 9470: @581117
     /*  581117 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(581192), // Rule ID 3864 //
     /*  581122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  581171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581190 */     GIR_RootConstrainSelectedInstOperands,
     /*  581191 */     // GIR_Coverage, 3864,
     /*  581191 */     GIR_EraseRootFromParent_Done,
     /*  581192 */   // Label 9471: @581192
     /*  581192 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(581267), // Rule ID 3865 //
     /*  581197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  581246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581265 */     GIR_RootConstrainSelectedInstOperands,
     /*  581266 */     // GIR_Coverage, 3865,
     /*  581266 */     GIR_EraseRootFromParent_Done,
     /*  581267 */   // Label 9472: @581267
     /*  581267 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(581342), // Rule ID 3868 //
     /*  581272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  581321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581340 */     GIR_RootConstrainSelectedInstOperands,
     /*  581341 */     // GIR_Coverage, 3868,
     /*  581341 */     GIR_EraseRootFromParent_Done,
     /*  581342 */   // Label 9473: @581342
     /*  581342 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(581417), // Rule ID 3869 //
     /*  581347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  581396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581415 */     GIR_RootConstrainSelectedInstOperands,
     /*  581416 */     // GIR_Coverage, 3869,
     /*  581416 */     GIR_EraseRootFromParent_Done,
     /*  581417 */   // Label 9474: @581417
     /*  581417 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(581492), // Rule ID 3872 //
     /*  581422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  581471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581490 */     GIR_RootConstrainSelectedInstOperands,
     /*  581491 */     // GIR_Coverage, 3872,
     /*  581491 */     GIR_EraseRootFromParent_Done,
     /*  581492 */   // Label 9475: @581492
     /*  581492 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(581567), // Rule ID 3873 //
     /*  581497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581543 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  581546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581565 */     GIR_RootConstrainSelectedInstOperands,
     /*  581566 */     // GIR_Coverage, 3873,
     /*  581566 */     GIR_EraseRootFromParent_Done,
     /*  581567 */   // Label 9476: @581567
     /*  581567 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(581642), // Rule ID 3876 //
     /*  581572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581640 */     GIR_RootConstrainSelectedInstOperands,
     /*  581641 */     // GIR_Coverage, 3876,
     /*  581641 */     GIR_EraseRootFromParent_Done,
     /*  581642 */   // Label 9477: @581642
     /*  581642 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(581717), // Rule ID 3877 //
     /*  581647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  581696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581715 */     GIR_RootConstrainSelectedInstOperands,
     /*  581716 */     // GIR_Coverage, 3877,
     /*  581716 */     GIR_EraseRootFromParent_Done,
     /*  581717 */   // Label 9478: @581717
     /*  581717 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(581792), // Rule ID 3880 //
     /*  581722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  581771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581790 */     GIR_RootConstrainSelectedInstOperands,
     /*  581791 */     // GIR_Coverage, 3880,
     /*  581791 */     GIR_EraseRootFromParent_Done,
     /*  581792 */   // Label 9479: @581792
     /*  581792 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(581867), // Rule ID 3881 //
     /*  581797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  581846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581865 */     GIR_RootConstrainSelectedInstOperands,
     /*  581866 */     // GIR_Coverage, 3881,
     /*  581866 */     GIR_EraseRootFromParent_Done,
     /*  581867 */   // Label 9480: @581867
     /*  581867 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(581942), // Rule ID 3884 //
     /*  581872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  581883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  581886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  581889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  581921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581940 */     GIR_RootConstrainSelectedInstOperands,
     /*  581941 */     // GIR_Coverage, 3884,
     /*  581941 */     GIR_EraseRootFromParent_Done,
     /*  581942 */   // Label 9481: @581942
     /*  581942 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(582017), // Rule ID 3885 //
     /*  581947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  581955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  581958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  581961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  581964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  581996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582015 */     GIR_RootConstrainSelectedInstOperands,
     /*  582016 */     // GIR_Coverage, 3885,
     /*  582016 */     GIR_EraseRootFromParent_Done,
     /*  582017 */   // Label 9482: @582017
     /*  582017 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(582092), // Rule ID 3888 //
     /*  582022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582090 */     GIR_RootConstrainSelectedInstOperands,
     /*  582091 */     // GIR_Coverage, 3888,
     /*  582091 */     GIR_EraseRootFromParent_Done,
     /*  582092 */   // Label 9483: @582092
     /*  582092 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(582167), // Rule ID 3889 //
     /*  582097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582165 */     GIR_RootConstrainSelectedInstOperands,
     /*  582166 */     // GIR_Coverage, 3889,
     /*  582166 */     GIR_EraseRootFromParent_Done,
     /*  582167 */   // Label 9484: @582167
     /*  582167 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(582242), // Rule ID 3892 //
     /*  582172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582240 */     GIR_RootConstrainSelectedInstOperands,
     /*  582241 */     // GIR_Coverage, 3892,
     /*  582241 */     GIR_EraseRootFromParent_Done,
     /*  582242 */   // Label 9485: @582242
     /*  582242 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(582317), // Rule ID 3893 //
     /*  582247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582315 */     GIR_RootConstrainSelectedInstOperands,
     /*  582316 */     // GIR_Coverage, 3893,
     /*  582316 */     GIR_EraseRootFromParent_Done,
     /*  582317 */   // Label 9486: @582317
     /*  582317 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(582392), // Rule ID 3896 //
     /*  582322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  582371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582390 */     GIR_RootConstrainSelectedInstOperands,
     /*  582391 */     // GIR_Coverage, 3896,
     /*  582391 */     GIR_EraseRootFromParent_Done,
     /*  582392 */   // Label 9487: @582392
     /*  582392 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(582467), // Rule ID 3897 //
     /*  582397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  582446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582465 */     GIR_RootConstrainSelectedInstOperands,
     /*  582466 */     // GIR_Coverage, 3897,
     /*  582466 */     GIR_EraseRootFromParent_Done,
     /*  582467 */   // Label 9488: @582467
     /*  582467 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(582542), // Rule ID 3900 //
     /*  582472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  582521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582540 */     GIR_RootConstrainSelectedInstOperands,
     /*  582541 */     // GIR_Coverage, 3900,
     /*  582541 */     GIR_EraseRootFromParent_Done,
     /*  582542 */   // Label 9489: @582542
     /*  582542 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(582617), // Rule ID 3901 //
     /*  582547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582593 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  582596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582615 */     GIR_RootConstrainSelectedInstOperands,
     /*  582616 */     // GIR_Coverage, 3901,
     /*  582616 */     GIR_EraseRootFromParent_Done,
     /*  582617 */   // Label 9490: @582617
     /*  582617 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(582692), // Rule ID 3904 //
     /*  582622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582668 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  582671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582690 */     GIR_RootConstrainSelectedInstOperands,
     /*  582691 */     // GIR_Coverage, 3904,
     /*  582691 */     GIR_EraseRootFromParent_Done,
     /*  582692 */   // Label 9491: @582692
     /*  582692 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(582767), // Rule ID 3905 //
     /*  582697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582743 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  582746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582765 */     GIR_RootConstrainSelectedInstOperands,
     /*  582766 */     // GIR_Coverage, 3905,
     /*  582766 */     GIR_EraseRootFromParent_Done,
     /*  582767 */   // Label 9492: @582767
     /*  582767 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(582842), // Rule ID 3908 //
     /*  582772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  582783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  582786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  582789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582840 */     GIR_RootConstrainSelectedInstOperands,
     /*  582841 */     // GIR_Coverage, 3908,
     /*  582841 */     GIR_EraseRootFromParent_Done,
     /*  582842 */   // Label 9493: @582842
     /*  582842 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(582917), // Rule ID 3909 //
     /*  582847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  582858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  582861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  582864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  582896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582915 */     GIR_RootConstrainSelectedInstOperands,
     /*  582916 */     // GIR_Coverage, 3909,
     /*  582916 */     GIR_EraseRootFromParent_Done,
     /*  582917 */   // Label 9494: @582917
     /*  582917 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(582992), // Rule ID 3912 //
     /*  582922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  582930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  582933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  582936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  582939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  582971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582990 */     GIR_RootConstrainSelectedInstOperands,
     /*  582991 */     // GIR_Coverage, 3912,
     /*  582991 */     GIR_EraseRootFromParent_Done,
     /*  582992 */   // Label 9495: @582992
     /*  582992 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(583067), // Rule ID 3913 //
     /*  582997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583065 */     GIR_RootConstrainSelectedInstOperands,
     /*  583066 */     // GIR_Coverage, 3913,
     /*  583066 */     GIR_EraseRootFromParent_Done,
     /*  583067 */   // Label 9496: @583067
     /*  583067 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(583142), // Rule ID 3916 //
     /*  583072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583140 */     GIR_RootConstrainSelectedInstOperands,
     /*  583141 */     // GIR_Coverage, 3916,
     /*  583141 */     GIR_EraseRootFromParent_Done,
     /*  583142 */   // Label 9497: @583142
     /*  583142 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(583217), // Rule ID 3917 //
     /*  583147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583193 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583215 */     GIR_RootConstrainSelectedInstOperands,
     /*  583216 */     // GIR_Coverage, 3917,
     /*  583216 */     GIR_EraseRootFromParent_Done,
     /*  583217 */   // Label 9498: @583217
     /*  583217 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(583292), // Rule ID 3920 //
     /*  583222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583290 */     GIR_RootConstrainSelectedInstOperands,
     /*  583291 */     // GIR_Coverage, 3920,
     /*  583291 */     GIR_EraseRootFromParent_Done,
     /*  583292 */   // Label 9499: @583292
     /*  583292 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(583367), // Rule ID 3921 //
     /*  583297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583343 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583365 */     GIR_RootConstrainSelectedInstOperands,
     /*  583366 */     // GIR_Coverage, 3921,
     /*  583366 */     GIR_EraseRootFromParent_Done,
     /*  583367 */   // Label 9500: @583367
     /*  583367 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(583442), // Rule ID 3924 //
     /*  583372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  583421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583440 */     GIR_RootConstrainSelectedInstOperands,
     /*  583441 */     // GIR_Coverage, 3924,
     /*  583441 */     GIR_EraseRootFromParent_Done,
     /*  583442 */   // Label 9501: @583442
     /*  583442 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(583517), // Rule ID 3925 //
     /*  583447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583493 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  583496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583515 */     GIR_RootConstrainSelectedInstOperands,
     /*  583516 */     // GIR_Coverage, 3925,
     /*  583516 */     GIR_EraseRootFromParent_Done,
     /*  583517 */   // Label 9502: @583517
     /*  583517 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(583592), // Rule ID 3928 //
     /*  583522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583590 */     GIR_RootConstrainSelectedInstOperands,
     /*  583591 */     // GIR_Coverage, 3928,
     /*  583591 */     GIR_EraseRootFromParent_Done,
     /*  583592 */   // Label 9503: @583592
     /*  583592 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(583667), // Rule ID 3929 //
     /*  583597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  583646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583665 */     GIR_RootConstrainSelectedInstOperands,
     /*  583666 */     // GIR_Coverage, 3929,
     /*  583666 */     GIR_EraseRootFromParent_Done,
     /*  583667 */   // Label 9504: @583667
     /*  583667 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(583742), // Rule ID 3932 //
     /*  583672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583718 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583740 */     GIR_RootConstrainSelectedInstOperands,
     /*  583741 */     // GIR_Coverage, 3932,
     /*  583741 */     GIR_EraseRootFromParent_Done,
     /*  583742 */   // Label 9505: @583742
     /*  583742 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(583817), // Rule ID 3933 //
     /*  583747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583793 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  583796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583815 */     GIR_RootConstrainSelectedInstOperands,
     /*  583816 */     // GIR_Coverage, 3933,
     /*  583816 */     GIR_EraseRootFromParent_Done,
     /*  583817 */   // Label 9506: @583817
     /*  583817 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(583892), // Rule ID 3936 //
     /*  583822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  583833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  583836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  583839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583890 */     GIR_RootConstrainSelectedInstOperands,
     /*  583891 */     // GIR_Coverage, 3936,
     /*  583891 */     GIR_EraseRootFromParent_Done,
     /*  583892 */   // Label 9507: @583892
     /*  583892 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(583967), // Rule ID 3937 //
     /*  583897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  583905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  583908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  583911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  583914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  583946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583965 */     GIR_RootConstrainSelectedInstOperands,
     /*  583966 */     // GIR_Coverage, 3937,
     /*  583966 */     GIR_EraseRootFromParent_Done,
     /*  583967 */   // Label 9508: @583967
     /*  583967 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(584042), // Rule ID 3940 //
     /*  583972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  583983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  583986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  583989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  583992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  584021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584040 */     GIR_RootConstrainSelectedInstOperands,
     /*  584041 */     // GIR_Coverage, 3940,
     /*  584041 */     GIR_EraseRootFromParent_Done,
     /*  584042 */   // Label 9509: @584042
     /*  584042 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(584117), // Rule ID 3941 //
     /*  584047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  584058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  584061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  584064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  584067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  584096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584115 */     GIR_RootConstrainSelectedInstOperands,
     /*  584116 */     // GIR_Coverage, 3941,
     /*  584116 */     GIR_EraseRootFromParent_Done,
     /*  584117 */   // Label 9510: @584117
     /*  584117 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(584192), // Rule ID 3944 //
     /*  584122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  584139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584190 */     GIR_RootConstrainSelectedInstOperands,
     /*  584191 */     // GIR_Coverage, 3944,
     /*  584191 */     GIR_EraseRootFromParent_Done,
     /*  584192 */   // Label 9511: @584192
     /*  584192 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(584267), // Rule ID 3945 //
     /*  584197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  584214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584265 */     GIR_RootConstrainSelectedInstOperands,
     /*  584266 */     // GIR_Coverage, 3945,
     /*  584266 */     GIR_EraseRootFromParent_Done,
     /*  584267 */   // Label 9512: @584267
     /*  584267 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(584342), // Rule ID 3948 //
     /*  584272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  584289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  584321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584340 */     GIR_RootConstrainSelectedInstOperands,
     /*  584341 */     // GIR_Coverage, 3948,
     /*  584341 */     GIR_EraseRootFromParent_Done,
     /*  584342 */   // Label 9513: @584342
     /*  584342 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(584417), // Rule ID 3949 //
     /*  584347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  584364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  584396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584415 */     GIR_RootConstrainSelectedInstOperands,
     /*  584416 */     // GIR_Coverage, 3949,
     /*  584416 */     GIR_EraseRootFromParent_Done,
     /*  584417 */   // Label 9514: @584417
     /*  584417 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(584492), // Rule ID 3952 //
     /*  584422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  584439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  584471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584490 */     GIR_RootConstrainSelectedInstOperands,
     /*  584491 */     // GIR_Coverage, 3952,
     /*  584491 */     GIR_EraseRootFromParent_Done,
     /*  584492 */   // Label 9515: @584492
     /*  584492 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(584567), // Rule ID 3953 //
     /*  584497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  584514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  584546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584565 */     GIR_RootConstrainSelectedInstOperands,
     /*  584566 */     // GIR_Coverage, 3953,
     /*  584566 */     GIR_EraseRootFromParent_Done,
     /*  584567 */   // Label 9516: @584567
     /*  584567 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(584642), // Rule ID 3956 //
     /*  584572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  584589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  584621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584640 */     GIR_RootConstrainSelectedInstOperands,
     /*  584641 */     // GIR_Coverage, 3956,
     /*  584641 */     GIR_EraseRootFromParent_Done,
     /*  584642 */   // Label 9517: @584642
     /*  584642 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(584717), // Rule ID 3957 //
     /*  584647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  584664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  584696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584715 */     GIR_RootConstrainSelectedInstOperands,
     /*  584716 */     // GIR_Coverage, 3957,
     /*  584716 */     GIR_EraseRootFromParent_Done,
     /*  584717 */   // Label 9518: @584717
     /*  584717 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(584792), // Rule ID 3960 //
     /*  584722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  584771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584790 */     GIR_RootConstrainSelectedInstOperands,
     /*  584791 */     // GIR_Coverage, 3960,
     /*  584791 */     GIR_EraseRootFromParent_Done,
     /*  584792 */   // Label 9519: @584792
     /*  584792 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(584867), // Rule ID 3961 //
     /*  584797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  584814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584843 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  584846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584865 */     GIR_RootConstrainSelectedInstOperands,
     /*  584866 */     // GIR_Coverage, 3961,
     /*  584866 */     GIR_EraseRootFromParent_Done,
     /*  584867 */   // Label 9520: @584867
     /*  584867 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(584942), // Rule ID 3964 //
     /*  584872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  584889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584940 */     GIR_RootConstrainSelectedInstOperands,
     /*  584941 */     // GIR_Coverage, 3964,
     /*  584941 */     GIR_EraseRootFromParent_Done,
     /*  584942 */   // Label 9521: @584942
     /*  584942 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(585017), // Rule ID 3965 //
     /*  584947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  584964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584993 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  584996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585015 */     GIR_RootConstrainSelectedInstOperands,
     /*  585016 */     // GIR_Coverage, 3965,
     /*  585016 */     GIR_EraseRootFromParent_Done,
     /*  585017 */   // Label 9522: @585017
     /*  585017 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(585092), // Rule ID 3968 //
     /*  585022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585090 */     GIR_RootConstrainSelectedInstOperands,
     /*  585091 */     // GIR_Coverage, 3968,
     /*  585091 */     GIR_EraseRootFromParent_Done,
     /*  585092 */   // Label 9523: @585092
     /*  585092 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(585167), // Rule ID 3969 //
     /*  585097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  585114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585143 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585165 */     GIR_RootConstrainSelectedInstOperands,
     /*  585166 */     // GIR_Coverage, 3969,
     /*  585166 */     GIR_EraseRootFromParent_Done,
     /*  585167 */   // Label 9524: @585167
     /*  585167 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(585242), // Rule ID 3972 //
     /*  585172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585240 */     GIR_RootConstrainSelectedInstOperands,
     /*  585241 */     // GIR_Coverage, 3972,
     /*  585241 */     GIR_EraseRootFromParent_Done,
     /*  585242 */   // Label 9525: @585242
     /*  585242 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(585317), // Rule ID 3973 //
     /*  585247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  585264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585315 */     GIR_RootConstrainSelectedInstOperands,
     /*  585316 */     // GIR_Coverage, 3973,
     /*  585316 */     GIR_EraseRootFromParent_Done,
     /*  585317 */   // Label 9526: @585317
     /*  585317 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(585392), // Rule ID 3976 //
     /*  585322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585390 */     GIR_RootConstrainSelectedInstOperands,
     /*  585391 */     // GIR_Coverage, 3976,
     /*  585391 */     GIR_EraseRootFromParent_Done,
     /*  585392 */   // Label 9527: @585392
     /*  585392 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(585467), // Rule ID 3977 //
     /*  585397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585443 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585465 */     GIR_RootConstrainSelectedInstOperands,
     /*  585466 */     // GIR_Coverage, 3977,
     /*  585466 */     GIR_EraseRootFromParent_Done,
     /*  585467 */   // Label 9528: @585467
     /*  585467 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(585542), // Rule ID 3980 //
     /*  585472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  585521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585540 */     GIR_RootConstrainSelectedInstOperands,
     /*  585541 */     // GIR_Coverage, 3980,
     /*  585541 */     GIR_EraseRootFromParent_Done,
     /*  585542 */   // Label 9529: @585542
     /*  585542 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(585617), // Rule ID 3981 //
     /*  585547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585593 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  585596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585615 */     GIR_RootConstrainSelectedInstOperands,
     /*  585616 */     // GIR_Coverage, 3981,
     /*  585616 */     GIR_EraseRootFromParent_Done,
     /*  585617 */   // Label 9530: @585617
     /*  585617 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(585692), // Rule ID 3984 //
     /*  585622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585690 */     GIR_RootConstrainSelectedInstOperands,
     /*  585691 */     // GIR_Coverage, 3984,
     /*  585691 */     GIR_EraseRootFromParent_Done,
     /*  585692 */   // Label 9531: @585692
     /*  585692 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(585767), // Rule ID 3985 //
     /*  585697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  585746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585765 */     GIR_RootConstrainSelectedInstOperands,
     /*  585766 */     // GIR_Coverage, 3985,
     /*  585766 */     GIR_EraseRootFromParent_Done,
     /*  585767 */   // Label 9532: @585767
     /*  585767 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(585842), // Rule ID 3988 //
     /*  585772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585840 */     GIR_RootConstrainSelectedInstOperands,
     /*  585841 */     // GIR_Coverage, 3988,
     /*  585841 */     GIR_EraseRootFromParent_Done,
     /*  585842 */   // Label 9533: @585842
     /*  585842 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(585917), // Rule ID 3989 //
     /*  585847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  585896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585915 */     GIR_RootConstrainSelectedInstOperands,
     /*  585916 */     // GIR_Coverage, 3989,
     /*  585916 */     GIR_EraseRootFromParent_Done,
     /*  585917 */   // Label 9534: @585917
     /*  585917 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(585992), // Rule ID 3992 //
     /*  585922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  585930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  585933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  585936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  585942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  585971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585990 */     GIR_RootConstrainSelectedInstOperands,
     /*  585991 */     // GIR_Coverage, 3992,
     /*  585991 */     GIR_EraseRootFromParent_Done,
     /*  585992 */   // Label 9535: @585992
     /*  585992 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(586067), // Rule ID 3993 //
     /*  585997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  586014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  586046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586065 */     GIR_RootConstrainSelectedInstOperands,
     /*  586066 */     // GIR_Coverage, 3993,
     /*  586066 */     GIR_EraseRootFromParent_Done,
     /*  586067 */   // Label 9536: @586067
     /*  586067 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(586142), // Rule ID 3996 //
     /*  586072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  586121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586140 */     GIR_RootConstrainSelectedInstOperands,
     /*  586141 */     // GIR_Coverage, 3996,
     /*  586141 */     GIR_EraseRootFromParent_Done,
     /*  586142 */   // Label 9537: @586142
     /*  586142 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(586217), // Rule ID 3997 //
     /*  586147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  586164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  586196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586215 */     GIR_RootConstrainSelectedInstOperands,
     /*  586216 */     // GIR_Coverage, 3997,
     /*  586216 */     GIR_EraseRootFromParent_Done,
     /*  586217 */   // Label 9538: @586217
     /*  586217 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(586292), // Rule ID 4000 //
     /*  586222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  586239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  586271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586290 */     GIR_RootConstrainSelectedInstOperands,
     /*  586291 */     // GIR_Coverage, 4000,
     /*  586291 */     GIR_EraseRootFromParent_Done,
     /*  586292 */   // Label 9539: @586292
     /*  586292 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(586367), // Rule ID 4001 //
     /*  586297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  586314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586343 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  586346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586365 */     GIR_RootConstrainSelectedInstOperands,
     /*  586366 */     // GIR_Coverage, 4001,
     /*  586366 */     GIR_EraseRootFromParent_Done,
     /*  586367 */   // Label 9540: @586367
     /*  586367 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(586442), // Rule ID 4004 //
     /*  586372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  586389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  586421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586440 */     GIR_RootConstrainSelectedInstOperands,
     /*  586441 */     // GIR_Coverage, 4004,
     /*  586441 */     GIR_EraseRootFromParent_Done,
     /*  586442 */   // Label 9541: @586442
     /*  586442 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(586517), // Rule ID 4005 //
     /*  586447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  586464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586493 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  586496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586515 */     GIR_RootConstrainSelectedInstOperands,
     /*  586516 */     // GIR_Coverage, 4005,
     /*  586516 */     GIR_EraseRootFromParent_Done,
     /*  586517 */   // Label 9542: @586517
     /*  586517 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(586592), // Rule ID 4008 //
     /*  586522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  586571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586590 */     GIR_RootConstrainSelectedInstOperands,
     /*  586591 */     // GIR_Coverage, 4008,
     /*  586591 */     GIR_EraseRootFromParent_Done,
     /*  586592 */   // Label 9543: @586592
     /*  586592 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(586667), // Rule ID 4009 //
     /*  586597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  586614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  586646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586665 */     GIR_RootConstrainSelectedInstOperands,
     /*  586666 */     // GIR_Coverage, 4009,
     /*  586666 */     GIR_EraseRootFromParent_Done,
     /*  586667 */   // Label 9544: @586667
     /*  586667 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(586742), // Rule ID 4012 //
     /*  586672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  586721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586740 */     GIR_RootConstrainSelectedInstOperands,
     /*  586741 */     // GIR_Coverage, 4012,
     /*  586741 */     GIR_EraseRootFromParent_Done,
     /*  586742 */   // Label 9545: @586742
     /*  586742 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(586817), // Rule ID 4013 //
     /*  586747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  586764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  586796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586815 */     GIR_RootConstrainSelectedInstOperands,
     /*  586816 */     // GIR_Coverage, 4013,
     /*  586816 */     GIR_EraseRootFromParent_Done,
     /*  586817 */   // Label 9546: @586817
     /*  586817 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(586892), // Rule ID 4016 //
     /*  586822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  586839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  586871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586890 */     GIR_RootConstrainSelectedInstOperands,
     /*  586891 */     // GIR_Coverage, 4016,
     /*  586891 */     GIR_EraseRootFromParent_Done,
     /*  586892 */   // Label 9547: @586892
     /*  586892 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(586967), // Rule ID 4017 //
     /*  586897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  586914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586943 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  586946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586965 */     GIR_RootConstrainSelectedInstOperands,
     /*  586966 */     // GIR_Coverage, 4017,
     /*  586966 */     GIR_EraseRootFromParent_Done,
     /*  586967 */   // Label 9548: @586967
     /*  586967 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(587042), // Rule ID 4020 //
     /*  586972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  586980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  586983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  586986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  586989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587040 */     GIR_RootConstrainSelectedInstOperands,
     /*  587041 */     // GIR_Coverage, 4020,
     /*  587041 */     GIR_EraseRootFromParent_Done,
     /*  587042 */   // Label 9549: @587042
     /*  587042 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(587117), // Rule ID 4021 //
     /*  587047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  587064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587093 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587115 */     GIR_RootConstrainSelectedInstOperands,
     /*  587116 */     // GIR_Coverage, 4021,
     /*  587116 */     GIR_EraseRootFromParent_Done,
     /*  587117 */   // Label 9550: @587117
     /*  587117 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(587192), // Rule ID 4024 //
     /*  587122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  587171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587190 */     GIR_RootConstrainSelectedInstOperands,
     /*  587191 */     // GIR_Coverage, 4024,
     /*  587191 */     GIR_EraseRootFromParent_Done,
     /*  587192 */   // Label 9551: @587192
     /*  587192 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(587267), // Rule ID 4025 //
     /*  587197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  587214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  587246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587265 */     GIR_RootConstrainSelectedInstOperands,
     /*  587266 */     // GIR_Coverage, 4025,
     /*  587266 */     GIR_EraseRootFromParent_Done,
     /*  587267 */   // Label 9552: @587267
     /*  587267 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(587342), // Rule ID 4028 //
     /*  587272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587340 */     GIR_RootConstrainSelectedInstOperands,
     /*  587341 */     // GIR_Coverage, 4028,
     /*  587341 */     GIR_EraseRootFromParent_Done,
     /*  587342 */   // Label 9553: @587342
     /*  587342 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(587417), // Rule ID 4029 //
     /*  587347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  587364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587415 */     GIR_RootConstrainSelectedInstOperands,
     /*  587416 */     // GIR_Coverage, 4029,
     /*  587416 */     GIR_EraseRootFromParent_Done,
     /*  587417 */   // Label 9554: @587417
     /*  587417 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(587492), // Rule ID 4032 //
     /*  587422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  587471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587490 */     GIR_RootConstrainSelectedInstOperands,
     /*  587491 */     // GIR_Coverage, 4032,
     /*  587491 */     GIR_EraseRootFromParent_Done,
     /*  587492 */   // Label 9555: @587492
     /*  587492 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(587567), // Rule ID 4033 //
     /*  587497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  587546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587565 */     GIR_RootConstrainSelectedInstOperands,
     /*  587566 */     // GIR_Coverage, 4033,
     /*  587566 */     GIR_EraseRootFromParent_Done,
     /*  587567 */   // Label 9556: @587567
     /*  587567 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(587642), // Rule ID 4036 //
     /*  587572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  587621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587640 */     GIR_RootConstrainSelectedInstOperands,
     /*  587641 */     // GIR_Coverage, 4036,
     /*  587641 */     GIR_EraseRootFromParent_Done,
     /*  587642 */   // Label 9557: @587642
     /*  587642 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(587717), // Rule ID 4037 //
     /*  587647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587693 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  587696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587715 */     GIR_RootConstrainSelectedInstOperands,
     /*  587716 */     // GIR_Coverage, 4037,
     /*  587716 */     GIR_EraseRootFromParent_Done,
     /*  587717 */   // Label 9558: @587717
     /*  587717 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(587792), // Rule ID 4040 //
     /*  587722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587790 */     GIR_RootConstrainSelectedInstOperands,
     /*  587791 */     // GIR_Coverage, 4040,
     /*  587791 */     GIR_EraseRootFromParent_Done,
     /*  587792 */   // Label 9559: @587792
     /*  587792 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(587867), // Rule ID 4041 //
     /*  587797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  587846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587865 */     GIR_RootConstrainSelectedInstOperands,
     /*  587866 */     // GIR_Coverage, 4041,
     /*  587866 */     GIR_EraseRootFromParent_Done,
     /*  587867 */   // Label 9560: @587867
     /*  587867 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(587942), // Rule ID 4044 //
     /*  587872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  587875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  587918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587940 */     GIR_RootConstrainSelectedInstOperands,
     /*  587941 */     // GIR_Coverage, 4044,
     /*  587941 */     GIR_EraseRootFromParent_Done,
     /*  587942 */   // Label 9561: @587942
     /*  587942 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(588017), // Rule ID 4045 //
     /*  587947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  587950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  587955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587993 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  587996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588015 */     GIR_RootConstrainSelectedInstOperands,
     /*  588016 */     // GIR_Coverage, 4045,
     /*  588016 */     GIR_EraseRootFromParent_Done,
     /*  588017 */   // Label 9562: @588017
     /*  588017 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(588092), // Rule ID 4048 //
     /*  588022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  588071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588090 */     GIR_RootConstrainSelectedInstOperands,
     /*  588091 */     // GIR_Coverage, 4048,
     /*  588091 */     GIR_EraseRootFromParent_Done,
     /*  588092 */   // Label 9563: @588092
     /*  588092 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(588167), // Rule ID 4049 //
     /*  588097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  588114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  588146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588165 */     GIR_RootConstrainSelectedInstOperands,
     /*  588166 */     // GIR_Coverage, 4049,
     /*  588166 */     GIR_EraseRootFromParent_Done,
     /*  588167 */   // Label 9564: @588167
     /*  588167 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(588242), // Rule ID 4052 //
     /*  588172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  588221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588240 */     GIR_RootConstrainSelectedInstOperands,
     /*  588241 */     // GIR_Coverage, 4052,
     /*  588241 */     GIR_EraseRootFromParent_Done,
     /*  588242 */   // Label 9565: @588242
     /*  588242 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(588317), // Rule ID 4053 //
     /*  588247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  588296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588315 */     GIR_RootConstrainSelectedInstOperands,
     /*  588316 */     // GIR_Coverage, 4053,
     /*  588316 */     GIR_EraseRootFromParent_Done,
     /*  588317 */   // Label 9566: @588317
     /*  588317 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(588392), // Rule ID 4056 //
     /*  588322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  588371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588390 */     GIR_RootConstrainSelectedInstOperands,
     /*  588391 */     // GIR_Coverage, 4056,
     /*  588391 */     GIR_EraseRootFromParent_Done,
     /*  588392 */   // Label 9567: @588392
     /*  588392 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(588467), // Rule ID 4057 //
     /*  588397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  588405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  588446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588465 */     GIR_RootConstrainSelectedInstOperands,
     /*  588466 */     // GIR_Coverage, 4057,
     /*  588466 */     GIR_EraseRootFromParent_Done,
     /*  588467 */   // Label 9568: @588467
     /*  588467 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(588542), // Rule ID 4062 //
     /*  588472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  588521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588540 */     GIR_RootConstrainSelectedInstOperands,
     /*  588541 */     // GIR_Coverage, 4062,
     /*  588541 */     GIR_EraseRootFromParent_Done,
     /*  588542 */   // Label 9569: @588542
     /*  588542 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(588617), // Rule ID 4063 //
     /*  588547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  588596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588615 */     GIR_RootConstrainSelectedInstOperands,
     /*  588616 */     // GIR_Coverage, 4063,
     /*  588616 */     GIR_EraseRootFromParent_Done,
     /*  588617 */   // Label 9570: @588617
     /*  588617 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(588692), // Rule ID 4072 //
     /*  588622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  588671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588690 */     GIR_RootConstrainSelectedInstOperands,
     /*  588691 */     // GIR_Coverage, 4072,
     /*  588691 */     GIR_EraseRootFromParent_Done,
     /*  588692 */   // Label 9571: @588692
     /*  588692 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(588767), // Rule ID 4073 //
     /*  588697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  588746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588765 */     GIR_RootConstrainSelectedInstOperands,
     /*  588766 */     // GIR_Coverage, 4073,
     /*  588766 */     GIR_EraseRootFromParent_Done,
     /*  588767 */   // Label 9572: @588767
     /*  588767 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(588842), // Rule ID 4082 //
     /*  588772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  588783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  588786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  588789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  588792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  588821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588840 */     GIR_RootConstrainSelectedInstOperands,
     /*  588841 */     // GIR_Coverage, 4082,
     /*  588841 */     GIR_EraseRootFromParent_Done,
     /*  588842 */   // Label 9573: @588842
     /*  588842 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(588917), // Rule ID 4083 //
     /*  588847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  588858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  588861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  588864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  588867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  588896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588915 */     GIR_RootConstrainSelectedInstOperands,
     /*  588916 */     // GIR_Coverage, 4083,
     /*  588916 */     GIR_EraseRootFromParent_Done,
     /*  588917 */   // Label 9574: @588917
     /*  588917 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(588992), // Rule ID 4092 //
     /*  588922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  588933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  588936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  588939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  588942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  588971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588990 */     GIR_RootConstrainSelectedInstOperands,
     /*  588991 */     // GIR_Coverage, 4092,
     /*  588991 */     GIR_EraseRootFromParent_Done,
     /*  588992 */   // Label 9575: @588992
     /*  588992 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(589067), // Rule ID 4093 //
     /*  588997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589065 */     GIR_RootConstrainSelectedInstOperands,
     /*  589066 */     // GIR_Coverage, 4093,
     /*  589066 */     GIR_EraseRootFromParent_Done,
     /*  589067 */   // Label 9576: @589067
     /*  589067 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(589142), // Rule ID 4102 //
     /*  589072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589140 */     GIR_RootConstrainSelectedInstOperands,
     /*  589141 */     // GIR_Coverage, 4102,
     /*  589141 */     GIR_EraseRootFromParent_Done,
     /*  589142 */   // Label 9577: @589142
     /*  589142 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(589217), // Rule ID 4103 //
     /*  589147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589215 */     GIR_RootConstrainSelectedInstOperands,
     /*  589216 */     // GIR_Coverage, 4103,
     /*  589216 */     GIR_EraseRootFromParent_Done,
     /*  589217 */   // Label 9578: @589217
     /*  589217 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(589292), // Rule ID 4112 //
     /*  589222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  589271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589290 */     GIR_RootConstrainSelectedInstOperands,
     /*  589291 */     // GIR_Coverage, 4112,
     /*  589291 */     GIR_EraseRootFromParent_Done,
     /*  589292 */   // Label 9579: @589292
     /*  589292 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(589367), // Rule ID 4113 //
     /*  589297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  589346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589365 */     GIR_RootConstrainSelectedInstOperands,
     /*  589366 */     // GIR_Coverage, 4113,
     /*  589366 */     GIR_EraseRootFromParent_Done,
     /*  589367 */   // Label 9580: @589367
     /*  589367 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(589442), // Rule ID 4122 //
     /*  589372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  589421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589440 */     GIR_RootConstrainSelectedInstOperands,
     /*  589441 */     // GIR_Coverage, 4122,
     /*  589441 */     GIR_EraseRootFromParent_Done,
     /*  589442 */   // Label 9581: @589442
     /*  589442 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(589517), // Rule ID 4123 //
     /*  589447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  589496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589515 */     GIR_RootConstrainSelectedInstOperands,
     /*  589516 */     // GIR_Coverage, 4123,
     /*  589516 */     GIR_EraseRootFromParent_Done,
     /*  589517 */   // Label 9582: @589517
     /*  589517 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(589592), // Rule ID 4132 //
     /*  589522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  589571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589590 */     GIR_RootConstrainSelectedInstOperands,
     /*  589591 */     // GIR_Coverage, 4132,
     /*  589591 */     GIR_EraseRootFromParent_Done,
     /*  589592 */   // Label 9583: @589592
     /*  589592 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(589667), // Rule ID 4133 //
     /*  589597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  589646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589665 */     GIR_RootConstrainSelectedInstOperands,
     /*  589666 */     // GIR_Coverage, 4133,
     /*  589666 */     GIR_EraseRootFromParent_Done,
     /*  589667 */   // Label 9584: @589667
     /*  589667 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(589742), // Rule ID 4142 //
     /*  589672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589740 */     GIR_RootConstrainSelectedInstOperands,
     /*  589741 */     // GIR_Coverage, 4142,
     /*  589741 */     GIR_EraseRootFromParent_Done,
     /*  589742 */   // Label 9585: @589742
     /*  589742 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(589817), // Rule ID 4143 //
     /*  589747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  589796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589815 */     GIR_RootConstrainSelectedInstOperands,
     /*  589816 */     // GIR_Coverage, 4143,
     /*  589816 */     GIR_EraseRootFromParent_Done,
     /*  589817 */   // Label 9586: @589817
     /*  589817 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(589892), // Rule ID 4152 //
     /*  589822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  589833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  589836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  589839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  589842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589890 */     GIR_RootConstrainSelectedInstOperands,
     /*  589891 */     // GIR_Coverage, 4152,
     /*  589891 */     GIR_EraseRootFromParent_Done,
     /*  589892 */   // Label 9587: @589892
     /*  589892 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(589967), // Rule ID 4153 //
     /*  589897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  589908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  589911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  589914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  589917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  589946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589965 */     GIR_RootConstrainSelectedInstOperands,
     /*  589966 */     // GIR_Coverage, 4153,
     /*  589966 */     GIR_EraseRootFromParent_Done,
     /*  589967 */   // Label 9588: @589967
     /*  589967 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(590042), // Rule ID 4162 //
     /*  589972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  589975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  589980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  589983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  589986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  589989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  589992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  590021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590040 */     GIR_RootConstrainSelectedInstOperands,
     /*  590041 */     // GIR_Coverage, 4162,
     /*  590041 */     GIR_EraseRootFromParent_Done,
     /*  590042 */   // Label 9589: @590042
     /*  590042 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(590117), // Rule ID 4163 //
     /*  590047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590093 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  590096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590115 */     GIR_RootConstrainSelectedInstOperands,
     /*  590116 */     // GIR_Coverage, 4163,
     /*  590116 */     GIR_EraseRootFromParent_Done,
     /*  590117 */   // Label 9590: @590117
     /*  590117 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(590192), // Rule ID 4172 //
     /*  590122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  590171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590190 */     GIR_RootConstrainSelectedInstOperands,
     /*  590191 */     // GIR_Coverage, 4172,
     /*  590191 */     GIR_EraseRootFromParent_Done,
     /*  590192 */   // Label 9591: @590192
     /*  590192 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(590267), // Rule ID 4173 //
     /*  590197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  590246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590265 */     GIR_RootConstrainSelectedInstOperands,
     /*  590266 */     // GIR_Coverage, 4173,
     /*  590266 */     GIR_EraseRootFromParent_Done,
     /*  590267 */   // Label 9592: @590267
     /*  590267 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(590342), // Rule ID 4182 //
     /*  590272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  590321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590340 */     GIR_RootConstrainSelectedInstOperands,
     /*  590341 */     // GIR_Coverage, 4182,
     /*  590341 */     GIR_EraseRootFromParent_Done,
     /*  590342 */   // Label 9593: @590342
     /*  590342 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(590417), // Rule ID 4183 //
     /*  590347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  590396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590415 */     GIR_RootConstrainSelectedInstOperands,
     /*  590416 */     // GIR_Coverage, 4183,
     /*  590416 */     GIR_EraseRootFromParent_Done,
     /*  590417 */   // Label 9594: @590417
     /*  590417 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(590492), // Rule ID 4192 //
     /*  590422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  590471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590490 */     GIR_RootConstrainSelectedInstOperands,
     /*  590491 */     // GIR_Coverage, 4192,
     /*  590491 */     GIR_EraseRootFromParent_Done,
     /*  590492 */   // Label 9595: @590492
     /*  590492 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(590567), // Rule ID 4193 //
     /*  590497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  590546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590565 */     GIR_RootConstrainSelectedInstOperands,
     /*  590566 */     // GIR_Coverage, 4193,
     /*  590566 */     GIR_EraseRootFromParent_Done,
     /*  590567 */   // Label 9596: @590567
     /*  590567 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(590642), // Rule ID 4200 //
     /*  590572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  590621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590640 */     GIR_RootConstrainSelectedInstOperands,
     /*  590641 */     // GIR_Coverage, 4200,
     /*  590641 */     GIR_EraseRootFromParent_Done,
     /*  590642 */   // Label 9597: @590642
     /*  590642 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(590717), // Rule ID 4201 //
     /*  590647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  590696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590715 */     GIR_RootConstrainSelectedInstOperands,
     /*  590716 */     // GIR_Coverage, 4201,
     /*  590716 */     GIR_EraseRootFromParent_Done,
     /*  590717 */   // Label 9598: @590717
     /*  590717 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(590792), // Rule ID 4204 //
     /*  590722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  590771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590790 */     GIR_RootConstrainSelectedInstOperands,
     /*  590791 */     // GIR_Coverage, 4204,
     /*  590791 */     GIR_EraseRootFromParent_Done,
     /*  590792 */   // Label 9599: @590792
     /*  590792 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(590867), // Rule ID 4205 //
     /*  590797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  590846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590865 */     GIR_RootConstrainSelectedInstOperands,
     /*  590866 */     // GIR_Coverage, 4205,
     /*  590866 */     GIR_EraseRootFromParent_Done,
     /*  590867 */   // Label 9600: @590867
     /*  590867 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(590942), // Rule ID 4208 //
     /*  590872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  590921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590940 */     GIR_RootConstrainSelectedInstOperands,
     /*  590941 */     // GIR_Coverage, 4208,
     /*  590941 */     GIR_EraseRootFromParent_Done,
     /*  590942 */   // Label 9601: @590942
     /*  590942 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(591017), // Rule ID 4209 //
     /*  590947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  590955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  590958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  590961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  590964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  590996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591015 */     GIR_RootConstrainSelectedInstOperands,
     /*  591016 */     // GIR_Coverage, 4209,
     /*  591016 */     GIR_EraseRootFromParent_Done,
     /*  591017 */   // Label 9602: @591017
     /*  591017 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(591092), // Rule ID 4212 //
     /*  591022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591090 */     GIR_RootConstrainSelectedInstOperands,
     /*  591091 */     // GIR_Coverage, 4212,
     /*  591091 */     GIR_EraseRootFromParent_Done,
     /*  591092 */   // Label 9603: @591092
     /*  591092 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(591167), // Rule ID 4213 //
     /*  591097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591165 */     GIR_RootConstrainSelectedInstOperands,
     /*  591166 */     // GIR_Coverage, 4213,
     /*  591166 */     GIR_EraseRootFromParent_Done,
     /*  591167 */   // Label 9604: @591167
     /*  591167 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(591242), // Rule ID 4216 //
     /*  591172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591240 */     GIR_RootConstrainSelectedInstOperands,
     /*  591241 */     // GIR_Coverage, 4216,
     /*  591241 */     GIR_EraseRootFromParent_Done,
     /*  591242 */   // Label 9605: @591242
     /*  591242 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(591317), // Rule ID 4217 //
     /*  591247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591315 */     GIR_RootConstrainSelectedInstOperands,
     /*  591316 */     // GIR_Coverage, 4217,
     /*  591316 */     GIR_EraseRootFromParent_Done,
     /*  591317 */   // Label 9606: @591317
     /*  591317 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(591392), // Rule ID 4220 //
     /*  591322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  591371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591390 */     GIR_RootConstrainSelectedInstOperands,
     /*  591391 */     // GIR_Coverage, 4220,
     /*  591391 */     GIR_EraseRootFromParent_Done,
     /*  591392 */   // Label 9607: @591392
     /*  591392 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(591467), // Rule ID 4221 //
     /*  591397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  591446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591465 */     GIR_RootConstrainSelectedInstOperands,
     /*  591466 */     // GIR_Coverage, 4221,
     /*  591466 */     GIR_EraseRootFromParent_Done,
     /*  591467 */   // Label 9608: @591467
     /*  591467 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(591542), // Rule ID 4224 //
     /*  591472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  591521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591540 */     GIR_RootConstrainSelectedInstOperands,
     /*  591541 */     // GIR_Coverage, 4224,
     /*  591541 */     GIR_EraseRootFromParent_Done,
     /*  591542 */   // Label 9609: @591542
     /*  591542 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(591617), // Rule ID 4225 //
     /*  591547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  591596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591615 */     GIR_RootConstrainSelectedInstOperands,
     /*  591616 */     // GIR_Coverage, 4225,
     /*  591616 */     GIR_EraseRootFromParent_Done,
     /*  591617 */   // Label 9610: @591617
     /*  591617 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(591692), // Rule ID 4228 //
     /*  591622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  591671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591690 */     GIR_RootConstrainSelectedInstOperands,
     /*  591691 */     // GIR_Coverage, 4228,
     /*  591691 */     GIR_EraseRootFromParent_Done,
     /*  591692 */   // Label 9611: @591692
     /*  591692 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(591767), // Rule ID 4229 //
     /*  591697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  591746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591765 */     GIR_RootConstrainSelectedInstOperands,
     /*  591766 */     // GIR_Coverage, 4229,
     /*  591766 */     GIR_EraseRootFromParent_Done,
     /*  591767 */   // Label 9612: @591767
     /*  591767 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(591842), // Rule ID 4232 //
     /*  591772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591840 */     GIR_RootConstrainSelectedInstOperands,
     /*  591841 */     // GIR_Coverage, 4232,
     /*  591841 */     GIR_EraseRootFromParent_Done,
     /*  591842 */   // Label 9613: @591842
     /*  591842 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(591917), // Rule ID 4233 //
     /*  591847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  591896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591915 */     GIR_RootConstrainSelectedInstOperands,
     /*  591916 */     // GIR_Coverage, 4233,
     /*  591916 */     GIR_EraseRootFromParent_Done,
     /*  591917 */   // Label 9614: @591917
     /*  591917 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(591992), // Rule ID 4236 //
     /*  591922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  591930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  591933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  591936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  591939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  591971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591990 */     GIR_RootConstrainSelectedInstOperands,
     /*  591991 */     // GIR_Coverage, 4236,
     /*  591991 */     GIR_EraseRootFromParent_Done,
     /*  591992 */   // Label 9615: @591992
     /*  591992 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(592067), // Rule ID 4237 //
     /*  591997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592065 */     GIR_RootConstrainSelectedInstOperands,
     /*  592066 */     // GIR_Coverage, 4237,
     /*  592066 */     GIR_EraseRootFromParent_Done,
     /*  592067 */   // Label 9616: @592067
     /*  592067 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(592142), // Rule ID 4240 //
     /*  592072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592140 */     GIR_RootConstrainSelectedInstOperands,
     /*  592141 */     // GIR_Coverage, 4240,
     /*  592141 */     GIR_EraseRootFromParent_Done,
     /*  592142 */   // Label 9617: @592142
     /*  592142 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(592217), // Rule ID 4241 //
     /*  592147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592215 */     GIR_RootConstrainSelectedInstOperands,
     /*  592216 */     // GIR_Coverage, 4241,
     /*  592216 */     GIR_EraseRootFromParent_Done,
     /*  592217 */   // Label 9618: @592217
     /*  592217 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(592292), // Rule ID 4244 //
     /*  592222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  592271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592290 */     GIR_RootConstrainSelectedInstOperands,
     /*  592291 */     // GIR_Coverage, 4244,
     /*  592291 */     GIR_EraseRootFromParent_Done,
     /*  592292 */   // Label 9619: @592292
     /*  592292 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(592367), // Rule ID 4245 //
     /*  592297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  592346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592365 */     GIR_RootConstrainSelectedInstOperands,
     /*  592366 */     // GIR_Coverage, 4245,
     /*  592366 */     GIR_EraseRootFromParent_Done,
     /*  592367 */   // Label 9620: @592367
     /*  592367 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(592442), // Rule ID 4248 //
     /*  592372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  592421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592440 */     GIR_RootConstrainSelectedInstOperands,
     /*  592441 */     // GIR_Coverage, 4248,
     /*  592441 */     GIR_EraseRootFromParent_Done,
     /*  592442 */   // Label 9621: @592442
     /*  592442 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(592517), // Rule ID 4249 //
     /*  592447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  592496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592515 */     GIR_RootConstrainSelectedInstOperands,
     /*  592516 */     // GIR_Coverage, 4249,
     /*  592516 */     GIR_EraseRootFromParent_Done,
     /*  592517 */   // Label 9622: @592517
     /*  592517 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(592592), // Rule ID 4252 //
     /*  592522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592590 */     GIR_RootConstrainSelectedInstOperands,
     /*  592591 */     // GIR_Coverage, 4252,
     /*  592591 */     GIR_EraseRootFromParent_Done,
     /*  592592 */   // Label 9623: @592592
     /*  592592 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(592667), // Rule ID 4253 //
     /*  592597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  592646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592665 */     GIR_RootConstrainSelectedInstOperands,
     /*  592666 */     // GIR_Coverage, 4253,
     /*  592666 */     GIR_EraseRootFromParent_Done,
     /*  592667 */   // Label 9624: @592667
     /*  592667 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(592742), // Rule ID 4256 //
     /*  592672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592740 */     GIR_RootConstrainSelectedInstOperands,
     /*  592741 */     // GIR_Coverage, 4256,
     /*  592741 */     GIR_EraseRootFromParent_Done,
     /*  592742 */   // Label 9625: @592742
     /*  592742 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(592817), // Rule ID 4257 //
     /*  592747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  592755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  592796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592815 */     GIR_RootConstrainSelectedInstOperands,
     /*  592816 */     // GIR_Coverage, 4257,
     /*  592816 */     GIR_EraseRootFromParent_Done,
     /*  592817 */   // Label 9626: @592817
     /*  592817 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(592892), // Rule ID 4262 //
     /*  592822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  592842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  592871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592890 */     GIR_RootConstrainSelectedInstOperands,
     /*  592891 */     // GIR_Coverage, 4262,
     /*  592891 */     GIR_EraseRootFromParent_Done,
     /*  592892 */   // Label 9627: @592892
     /*  592892 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(592967), // Rule ID 4263 //
     /*  592897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  592917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  592946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592965 */     GIR_RootConstrainSelectedInstOperands,
     /*  592966 */     // GIR_Coverage, 4263,
     /*  592966 */     GIR_EraseRootFromParent_Done,
     /*  592967 */   // Label 9628: @592967
     /*  592967 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(593042), // Rule ID 4272 //
     /*  592972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  592983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  592986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  592989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  592992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593040 */     GIR_RootConstrainSelectedInstOperands,
     /*  593041 */     // GIR_Coverage, 4272,
     /*  593041 */     GIR_EraseRootFromParent_Done,
     /*  593042 */   // Label 9629: @593042
     /*  593042 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(593117), // Rule ID 4273 //
     /*  593047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593115 */     GIR_RootConstrainSelectedInstOperands,
     /*  593116 */     // GIR_Coverage, 4273,
     /*  593116 */     GIR_EraseRootFromParent_Done,
     /*  593117 */   // Label 9630: @593117
     /*  593117 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(593192), // Rule ID 4282 //
     /*  593122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593190 */     GIR_RootConstrainSelectedInstOperands,
     /*  593191 */     // GIR_Coverage, 4282,
     /*  593191 */     GIR_EraseRootFromParent_Done,
     /*  593192 */   // Label 9631: @593192
     /*  593192 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(593267), // Rule ID 4283 //
     /*  593197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593265 */     GIR_RootConstrainSelectedInstOperands,
     /*  593266 */     // GIR_Coverage, 4283,
     /*  593266 */     GIR_EraseRootFromParent_Done,
     /*  593267 */   // Label 9632: @593267
     /*  593267 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(593342), // Rule ID 4292 //
     /*  593272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  593321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593340 */     GIR_RootConstrainSelectedInstOperands,
     /*  593341 */     // GIR_Coverage, 4292,
     /*  593341 */     GIR_EraseRootFromParent_Done,
     /*  593342 */   // Label 9633: @593342
     /*  593342 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(593417), // Rule ID 4293 //
     /*  593347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  593396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593415 */     GIR_RootConstrainSelectedInstOperands,
     /*  593416 */     // GIR_Coverage, 4293,
     /*  593416 */     GIR_EraseRootFromParent_Done,
     /*  593417 */   // Label 9634: @593417
     /*  593417 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(593492), // Rule ID 4302 //
     /*  593422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  593471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593490 */     GIR_RootConstrainSelectedInstOperands,
     /*  593491 */     // GIR_Coverage, 4302,
     /*  593491 */     GIR_EraseRootFromParent_Done,
     /*  593492 */   // Label 9635: @593492
     /*  593492 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(593567), // Rule ID 4303 //
     /*  593497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593543 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  593546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593565 */     GIR_RootConstrainSelectedInstOperands,
     /*  593566 */     // GIR_Coverage, 4303,
     /*  593566 */     GIR_EraseRootFromParent_Done,
     /*  593567 */   // Label 9636: @593567
     /*  593567 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(593642), // Rule ID 4312 //
     /*  593572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  593621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593640 */     GIR_RootConstrainSelectedInstOperands,
     /*  593641 */     // GIR_Coverage, 4312,
     /*  593641 */     GIR_EraseRootFromParent_Done,
     /*  593642 */   // Label 9637: @593642
     /*  593642 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(593717), // Rule ID 4313 //
     /*  593647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  593696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593715 */     GIR_RootConstrainSelectedInstOperands,
     /*  593716 */     // GIR_Coverage, 4313,
     /*  593716 */     GIR_EraseRootFromParent_Done,
     /*  593717 */   // Label 9638: @593717
     /*  593717 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(593792), // Rule ID 4322 //
     /*  593722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593790 */     GIR_RootConstrainSelectedInstOperands,
     /*  593791 */     // GIR_Coverage, 4322,
     /*  593791 */     GIR_EraseRootFromParent_Done,
     /*  593792 */   // Label 9639: @593792
     /*  593792 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(593867), // Rule ID 4323 //
     /*  593797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  593846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593865 */     GIR_RootConstrainSelectedInstOperands,
     /*  593866 */     // GIR_Coverage, 4323,
     /*  593866 */     GIR_EraseRootFromParent_Done,
     /*  593867 */   // Label 9640: @593867
     /*  593867 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(593942), // Rule ID 4332 //
     /*  593872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  593892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593940 */     GIR_RootConstrainSelectedInstOperands,
     /*  593941 */     // GIR_Coverage, 4332,
     /*  593941 */     GIR_EraseRootFromParent_Done,
     /*  593942 */   // Label 9641: @593942
     /*  593942 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(594017), // Rule ID 4333 //
     /*  593947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  593958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  593961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  593964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  593967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  593996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594015 */     GIR_RootConstrainSelectedInstOperands,
     /*  594016 */     // GIR_Coverage, 4333,
     /*  594016 */     GIR_EraseRootFromParent_Done,
     /*  594017 */   // Label 9642: @594017
     /*  594017 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(594092), // Rule ID 4342 //
     /*  594022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594090 */     GIR_RootConstrainSelectedInstOperands,
     /*  594091 */     // GIR_Coverage, 4342,
     /*  594091 */     GIR_EraseRootFromParent_Done,
     /*  594092 */   // Label 9643: @594092
     /*  594092 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(594167), // Rule ID 4343 //
     /*  594097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594165 */     GIR_RootConstrainSelectedInstOperands,
     /*  594166 */     // GIR_Coverage, 4343,
     /*  594166 */     GIR_EraseRootFromParent_Done,
     /*  594167 */   // Label 9644: @594167
     /*  594167 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(594242), // Rule ID 4352 //
     /*  594172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594240 */     GIR_RootConstrainSelectedInstOperands,
     /*  594241 */     // GIR_Coverage, 4352,
     /*  594241 */     GIR_EraseRootFromParent_Done,
     /*  594242 */   // Label 9645: @594242
     /*  594242 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(594317), // Rule ID 4353 //
     /*  594247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594315 */     GIR_RootConstrainSelectedInstOperands,
     /*  594316 */     // GIR_Coverage, 4353,
     /*  594316 */     GIR_EraseRootFromParent_Done,
     /*  594317 */   // Label 9646: @594317
     /*  594317 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(594392), // Rule ID 4362 //
     /*  594322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594390 */     GIR_RootConstrainSelectedInstOperands,
     /*  594391 */     // GIR_Coverage, 4362,
     /*  594391 */     GIR_EraseRootFromParent_Done,
     /*  594392 */   // Label 9647: @594392
     /*  594392 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(594467), // Rule ID 4363 //
     /*  594397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594465 */     GIR_RootConstrainSelectedInstOperands,
     /*  594466 */     // GIR_Coverage, 4363,
     /*  594466 */     GIR_EraseRootFromParent_Done,
     /*  594467 */   // Label 9648: @594467
     /*  594467 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(594542), // Rule ID 4372 //
     /*  594472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  594521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594540 */     GIR_RootConstrainSelectedInstOperands,
     /*  594541 */     // GIR_Coverage, 4372,
     /*  594541 */     GIR_EraseRootFromParent_Done,
     /*  594542 */   // Label 9649: @594542
     /*  594542 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(594617), // Rule ID 4373 //
     /*  594547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594593 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  594596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594615 */     GIR_RootConstrainSelectedInstOperands,
     /*  594616 */     // GIR_Coverage, 4373,
     /*  594616 */     GIR_EraseRootFromParent_Done,
     /*  594617 */   // Label 9650: @594617
     /*  594617 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(594692), // Rule ID 4382 //
     /*  594622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594690 */     GIR_RootConstrainSelectedInstOperands,
     /*  594691 */     // GIR_Coverage, 4382,
     /*  594691 */     GIR_EraseRootFromParent_Done,
     /*  594692 */   // Label 9651: @594692
     /*  594692 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(594767), // Rule ID 4383 //
     /*  594697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  594746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594765 */     GIR_RootConstrainSelectedInstOperands,
     /*  594766 */     // GIR_Coverage, 4383,
     /*  594766 */     GIR_EraseRootFromParent_Done,
     /*  594767 */   // Label 9652: @594767
     /*  594767 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(594842), // Rule ID 4392 //
     /*  594772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  594783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  594786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  594789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  594792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594840 */     GIR_RootConstrainSelectedInstOperands,
     /*  594841 */     // GIR_Coverage, 4392,
     /*  594841 */     GIR_EraseRootFromParent_Done,
     /*  594842 */   // Label 9653: @594842
     /*  594842 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(594917), // Rule ID 4393 //
     /*  594847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  594858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  594861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  594864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  594867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  594896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594915 */     GIR_RootConstrainSelectedInstOperands,
     /*  594916 */     // GIR_Coverage, 4393,
     /*  594916 */     GIR_EraseRootFromParent_Done,
     /*  594917 */   // Label 9654: @594917
     /*  594917 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(594992), // Rule ID 4402 //
     /*  594922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  594930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  594933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  594936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  594939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  594942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  594971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594990 */     GIR_RootConstrainSelectedInstOperands,
     /*  594991 */     // GIR_Coverage, 4402,
     /*  594991 */     GIR_EraseRootFromParent_Done,
     /*  594992 */   // Label 9655: @594992
     /*  594992 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(595067), // Rule ID 4403 //
     /*  594997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  595046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595065 */     GIR_RootConstrainSelectedInstOperands,
     /*  595066 */     // GIR_Coverage, 4403,
     /*  595066 */     GIR_EraseRootFromParent_Done,
     /*  595067 */   // Label 9656: @595067
     /*  595067 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(595142), // Rule ID 4410 //
     /*  595072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  595121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595140 */     GIR_RootConstrainSelectedInstOperands,
     /*  595141 */     // GIR_Coverage, 4410,
     /*  595141 */     GIR_EraseRootFromParent_Done,
     /*  595142 */   // Label 9657: @595142
     /*  595142 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(595217), // Rule ID 4411 //
     /*  595147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595193 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  595196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595215 */     GIR_RootConstrainSelectedInstOperands,
     /*  595216 */     // GIR_Coverage, 4411,
     /*  595216 */     GIR_EraseRootFromParent_Done,
     /*  595217 */   // Label 9658: @595217
     /*  595217 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(595292), // Rule ID 4414 //
     /*  595222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  595271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595290 */     GIR_RootConstrainSelectedInstOperands,
     /*  595291 */     // GIR_Coverage, 4414,
     /*  595291 */     GIR_EraseRootFromParent_Done,
     /*  595292 */   // Label 9659: @595292
     /*  595292 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(595367), // Rule ID 4415 //
     /*  595297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  595346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595365 */     GIR_RootConstrainSelectedInstOperands,
     /*  595366 */     // GIR_Coverage, 4415,
     /*  595366 */     GIR_EraseRootFromParent_Done,
     /*  595367 */   // Label 9660: @595367
     /*  595367 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(595442), // Rule ID 4418 //
     /*  595372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  595421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595440 */     GIR_RootConstrainSelectedInstOperands,
     /*  595441 */     // GIR_Coverage, 4418,
     /*  595441 */     GIR_EraseRootFromParent_Done,
     /*  595442 */   // Label 9661: @595442
     /*  595442 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(595517), // Rule ID 4419 //
     /*  595447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11612:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  595496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595515 */     GIR_RootConstrainSelectedInstOperands,
     /*  595516 */     // GIR_Coverage, 4419,
     /*  595516 */     GIR_EraseRootFromParent_Done,
     /*  595517 */   // Label 9662: @595517
     /*  595517 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(595592), // Rule ID 4422 //
     /*  595522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  595571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595590 */     GIR_RootConstrainSelectedInstOperands,
     /*  595591 */     // GIR_Coverage, 4422,
     /*  595591 */     GIR_EraseRootFromParent_Done,
     /*  595592 */   // Label 9663: @595592
     /*  595592 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(595667), // Rule ID 4423 //
     /*  595597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  595646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595665 */     GIR_RootConstrainSelectedInstOperands,
     /*  595666 */     // GIR_Coverage, 4423,
     /*  595666 */     GIR_EraseRootFromParent_Done,
     /*  595667 */   // Label 9664: @595667
     /*  595667 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(595742), // Rule ID 4426 //
     /*  595672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  595721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595740 */     GIR_RootConstrainSelectedInstOperands,
     /*  595741 */     // GIR_Coverage, 4426,
     /*  595741 */     GIR_EraseRootFromParent_Done,
     /*  595742 */   // Label 9665: @595742
     /*  595742 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(595817), // Rule ID 4427 //
     /*  595747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  595796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595815 */     GIR_RootConstrainSelectedInstOperands,
     /*  595816 */     // GIR_Coverage, 4427,
     /*  595816 */     GIR_EraseRootFromParent_Done,
     /*  595817 */   // Label 9666: @595817
     /*  595817 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(595892), // Rule ID 4430 //
     /*  595822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  595833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  595836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  595839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  595871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595890 */     GIR_RootConstrainSelectedInstOperands,
     /*  595891 */     // GIR_Coverage, 4430,
     /*  595891 */     GIR_EraseRootFromParent_Done,
     /*  595892 */   // Label 9667: @595892
     /*  595892 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(595967), // Rule ID 4431 //
     /*  595897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  595908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  595911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  595914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  595946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595965 */     GIR_RootConstrainSelectedInstOperands,
     /*  595966 */     // GIR_Coverage, 4431,
     /*  595966 */     GIR_EraseRootFromParent_Done,
     /*  595967 */   // Label 9668: @595967
     /*  595967 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(596042), // Rule ID 4434 //
     /*  595972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  595980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  595983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  595986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  595989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  596021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596040 */     GIR_RootConstrainSelectedInstOperands,
     /*  596041 */     // GIR_Coverage, 4434,
     /*  596041 */     GIR_EraseRootFromParent_Done,
     /*  596042 */   // Label 9669: @596042
     /*  596042 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(596117), // Rule ID 4435 //
     /*  596047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  596096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596115 */     GIR_RootConstrainSelectedInstOperands,
     /*  596116 */     // GIR_Coverage, 4435,
     /*  596116 */     GIR_EraseRootFromParent_Done,
     /*  596117 */   // Label 9670: @596117
     /*  596117 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(596192), // Rule ID 4438 //
     /*  596122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596190 */     GIR_RootConstrainSelectedInstOperands,
     /*  596191 */     // GIR_Coverage, 4438,
     /*  596191 */     GIR_EraseRootFromParent_Done,
     /*  596192 */   // Label 9671: @596192
     /*  596192 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(596267), // Rule ID 4439 //
     /*  596197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11612:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596265 */     GIR_RootConstrainSelectedInstOperands,
     /*  596266 */     // GIR_Coverage, 4439,
     /*  596266 */     GIR_EraseRootFromParent_Done,
     /*  596267 */   // Label 9672: @596267
     /*  596267 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(596342), // Rule ID 4442 //
     /*  596272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596340 */     GIR_RootConstrainSelectedInstOperands,
     /*  596341 */     // GIR_Coverage, 4442,
     /*  596341 */     GIR_EraseRootFromParent_Done,
     /*  596342 */   // Label 9673: @596342
     /*  596342 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(596417), // Rule ID 4443 //
     /*  596347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596415 */     GIR_RootConstrainSelectedInstOperands,
     /*  596416 */     // GIR_Coverage, 4443,
     /*  596416 */     GIR_EraseRootFromParent_Done,
     /*  596417 */   // Label 9674: @596417
     /*  596417 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(596492), // Rule ID 4446 //
     /*  596422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  596471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596490 */     GIR_RootConstrainSelectedInstOperands,
     /*  596491 */     // GIR_Coverage, 4446,
     /*  596491 */     GIR_EraseRootFromParent_Done,
     /*  596492 */   // Label 9675: @596492
     /*  596492 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(596567), // Rule ID 4447 //
     /*  596497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  596546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596565 */     GIR_RootConstrainSelectedInstOperands,
     /*  596566 */     // GIR_Coverage, 4447,
     /*  596566 */     GIR_EraseRootFromParent_Done,
     /*  596567 */   // Label 9676: @596567
     /*  596567 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(596642), // Rule ID 4450 //
     /*  596572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  596621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596640 */     GIR_RootConstrainSelectedInstOperands,
     /*  596641 */     // GIR_Coverage, 4450,
     /*  596641 */     GIR_EraseRootFromParent_Done,
     /*  596642 */   // Label 9677: @596642
     /*  596642 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(596717), // Rule ID 4451 //
     /*  596647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  596696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596715 */     GIR_RootConstrainSelectedInstOperands,
     /*  596716 */     // GIR_Coverage, 4451,
     /*  596716 */     GIR_EraseRootFromParent_Done,
     /*  596717 */   // Label 9678: @596717
     /*  596717 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(596792), // Rule ID 4454 //
     /*  596722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596790 */     GIR_RootConstrainSelectedInstOperands,
     /*  596791 */     // GIR_Coverage, 4454,
     /*  596791 */     GIR_EraseRootFromParent_Done,
     /*  596792 */   // Label 9679: @596792
     /*  596792 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(596867), // Rule ID 4455 //
     /*  596797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11612:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  596846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596865 */     GIR_RootConstrainSelectedInstOperands,
     /*  596866 */     // GIR_Coverage, 4455,
     /*  596866 */     GIR_EraseRootFromParent_Done,
     /*  596867 */   // Label 9680: @596867
     /*  596867 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(596942), // Rule ID 4458 //
     /*  596872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  596883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  596886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  596889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596940 */     GIR_RootConstrainSelectedInstOperands,
     /*  596941 */     // GIR_Coverage, 4458,
     /*  596941 */     GIR_EraseRootFromParent_Done,
     /*  596942 */   // Label 9681: @596942
     /*  596942 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(597017), // Rule ID 4459 //
     /*  596947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  596955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  596958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  596961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  596964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11612:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  596996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597015 */     GIR_RootConstrainSelectedInstOperands,
     /*  597016 */     // GIR_Coverage, 4459,
     /*  597016 */     GIR_EraseRootFromParent_Done,
     /*  597017 */   // Label 9682: @597017
     /*  597017 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(597092), // Rule ID 4462 //
     /*  597022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  597071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597090 */     GIR_RootConstrainSelectedInstOperands,
     /*  597091 */     // GIR_Coverage, 4462,
     /*  597091 */     GIR_EraseRootFromParent_Done,
     /*  597092 */   // Label 9683: @597092
     /*  597092 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(597167), // Rule ID 4463 //
     /*  597097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11612:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  597146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597165 */     GIR_RootConstrainSelectedInstOperands,
     /*  597166 */     // GIR_Coverage, 4463,
     /*  597166 */     GIR_EraseRootFromParent_Done,
     /*  597167 */   // Label 9684: @597167
     /*  597167 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(597242), // Rule ID 4466 //
     /*  597172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  597221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597240 */     GIR_RootConstrainSelectedInstOperands,
     /*  597241 */     // GIR_Coverage, 4466,
     /*  597241 */     GIR_EraseRootFromParent_Done,
     /*  597242 */   // Label 9685: @597242
     /*  597242 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(597317), // Rule ID 4467 //
     /*  597247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  597255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11612:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  597296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597315 */     GIR_RootConstrainSelectedInstOperands,
     /*  597316 */     // GIR_Coverage, 4467,
     /*  597316 */     GIR_EraseRootFromParent_Done,
     /*  597317 */   // Label 9686: @597317
     /*  597317 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(597392), // Rule ID 4472 //
     /*  597322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  597371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597390 */     GIR_RootConstrainSelectedInstOperands,
     /*  597391 */     // GIR_Coverage, 4472,
     /*  597391 */     GIR_EraseRootFromParent_Done,
     /*  597392 */   // Label 9687: @597392
     /*  597392 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(597467), // Rule ID 4473 //
     /*  597397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597443 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  597446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597465 */     GIR_RootConstrainSelectedInstOperands,
     /*  597466 */     // GIR_Coverage, 4473,
     /*  597466 */     GIR_EraseRootFromParent_Done,
     /*  597467 */   // Label 9688: @597467
     /*  597467 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(597542), // Rule ID 4482 //
     /*  597472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  597521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597540 */     GIR_RootConstrainSelectedInstOperands,
     /*  597541 */     // GIR_Coverage, 4482,
     /*  597541 */     GIR_EraseRootFromParent_Done,
     /*  597542 */   // Label 9689: @597542
     /*  597542 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(597617), // Rule ID 4483 //
     /*  597547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597593 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  597596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597615 */     GIR_RootConstrainSelectedInstOperands,
     /*  597616 */     // GIR_Coverage, 4483,
     /*  597616 */     GIR_EraseRootFromParent_Done,
     /*  597617 */   // Label 9690: @597617
     /*  597617 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(597692), // Rule ID 4492 //
     /*  597622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  597671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597690 */     GIR_RootConstrainSelectedInstOperands,
     /*  597691 */     // GIR_Coverage, 4492,
     /*  597691 */     GIR_EraseRootFromParent_Done,
     /*  597692 */   // Label 9691: @597692
     /*  597692 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(597767), // Rule ID 4493 //
     /*  597697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  597746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597765 */     GIR_RootConstrainSelectedInstOperands,
     /*  597766 */     // GIR_Coverage, 4493,
     /*  597766 */     GIR_EraseRootFromParent_Done,
     /*  597767 */   // Label 9692: @597767
     /*  597767 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(597842), // Rule ID 4502 //
     /*  597772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  597792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  597821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597840 */     GIR_RootConstrainSelectedInstOperands,
     /*  597841 */     // GIR_Coverage, 4502,
     /*  597841 */     GIR_EraseRootFromParent_Done,
     /*  597842 */   // Label 9693: @597842
     /*  597842 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(597917), // Rule ID 4503 //
     /*  597847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  597867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  597896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597915 */     GIR_RootConstrainSelectedInstOperands,
     /*  597916 */     // GIR_Coverage, 4503,
     /*  597916 */     GIR_EraseRootFromParent_Done,
     /*  597917 */   // Label 9694: @597917
     /*  597917 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(597992), // Rule ID 4512 //
     /*  597922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  597933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  597936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  597939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  597942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  597971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597990 */     GIR_RootConstrainSelectedInstOperands,
     /*  597991 */     // GIR_Coverage, 4512,
     /*  597991 */     GIR_EraseRootFromParent_Done,
     /*  597992 */   // Label 9695: @597992
     /*  597992 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(598067), // Rule ID 4513 //
     /*  597997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598043 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598065 */     GIR_RootConstrainSelectedInstOperands,
     /*  598066 */     // GIR_Coverage, 4513,
     /*  598066 */     GIR_EraseRootFromParent_Done,
     /*  598067 */   // Label 9696: @598067
     /*  598067 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(598142), // Rule ID 4522 //
     /*  598072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598118 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598140 */     GIR_RootConstrainSelectedInstOperands,
     /*  598141 */     // GIR_Coverage, 4522,
     /*  598141 */     GIR_EraseRootFromParent_Done,
     /*  598142 */   // Label 9697: @598142
     /*  598142 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(598217), // Rule ID 4523 //
     /*  598147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598215 */     GIR_RootConstrainSelectedInstOperands,
     /*  598216 */     // GIR_Coverage, 4523,
     /*  598216 */     GIR_EraseRootFromParent_Done,
     /*  598217 */   // Label 9698: @598217
     /*  598217 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(598292), // Rule ID 4532 //
     /*  598222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  598271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598290 */     GIR_RootConstrainSelectedInstOperands,
     /*  598291 */     // GIR_Coverage, 4532,
     /*  598291 */     GIR_EraseRootFromParent_Done,
     /*  598292 */   // Label 9699: @598292
     /*  598292 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(598367), // Rule ID 4533 //
     /*  598297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598343 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  598346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598365 */     GIR_RootConstrainSelectedInstOperands,
     /*  598366 */     // GIR_Coverage, 4533,
     /*  598366 */     GIR_EraseRootFromParent_Done,
     /*  598367 */   // Label 9700: @598367
     /*  598367 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(598442), // Rule ID 4542 //
     /*  598372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  598421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598440 */     GIR_RootConstrainSelectedInstOperands,
     /*  598441 */     // GIR_Coverage, 4542,
     /*  598441 */     GIR_EraseRootFromParent_Done,
     /*  598442 */   // Label 9701: @598442
     /*  598442 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(598517), // Rule ID 4543 //
     /*  598447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  598496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598515 */     GIR_RootConstrainSelectedInstOperands,
     /*  598516 */     // GIR_Coverage, 4543,
     /*  598516 */     GIR_EraseRootFromParent_Done,
     /*  598517 */   // Label 9702: @598517
     /*  598517 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(598592), // Rule ID 4552 //
     /*  598522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  598571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598590 */     GIR_RootConstrainSelectedInstOperands,
     /*  598591 */     // GIR_Coverage, 4552,
     /*  598591 */     GIR_EraseRootFromParent_Done,
     /*  598592 */   // Label 9703: @598592
     /*  598592 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(598667), // Rule ID 4553 //
     /*  598597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  598646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598665 */     GIR_RootConstrainSelectedInstOperands,
     /*  598666 */     // GIR_Coverage, 4553,
     /*  598666 */     GIR_EraseRootFromParent_Done,
     /*  598667 */   // Label 9704: @598667
     /*  598667 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(598742), // Rule ID 4562 //
     /*  598672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598740 */     GIR_RootConstrainSelectedInstOperands,
     /*  598741 */     // GIR_Coverage, 4562,
     /*  598741 */     GIR_EraseRootFromParent_Done,
     /*  598742 */   // Label 9705: @598742
     /*  598742 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(598817), // Rule ID 4563 //
     /*  598747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  598796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598815 */     GIR_RootConstrainSelectedInstOperands,
     /*  598816 */     // GIR_Coverage, 4563,
     /*  598816 */     GIR_EraseRootFromParent_Done,
     /*  598817 */   // Label 9706: @598817
     /*  598817 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(598892), // Rule ID 4572 //
     /*  598822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  598842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598890 */     GIR_RootConstrainSelectedInstOperands,
     /*  598891 */     // GIR_Coverage, 4572,
     /*  598891 */     GIR_EraseRootFromParent_Done,
     /*  598892 */   // Label 9707: @598892
     /*  598892 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(598967), // Rule ID 4573 //
     /*  598897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  598917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598943 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  598946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598965 */     GIR_RootConstrainSelectedInstOperands,
     /*  598966 */     // GIR_Coverage, 4573,
     /*  598966 */     GIR_EraseRootFromParent_Done,
     /*  598967 */   // Label 9708: @598967
     /*  598967 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(599042), // Rule ID 4582 //
     /*  598972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  598975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  598980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  598983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  598986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  598989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  598992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  599021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599040 */     GIR_RootConstrainSelectedInstOperands,
     /*  599041 */     // GIR_Coverage, 4582,
     /*  599041 */     GIR_EraseRootFromParent_Done,
     /*  599042 */   // Label 9709: @599042
     /*  599042 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(599117), // Rule ID 4583 //
     /*  599047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599093 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  599096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599115 */     GIR_RootConstrainSelectedInstOperands,
     /*  599116 */     // GIR_Coverage, 4583,
     /*  599116 */     GIR_EraseRootFromParent_Done,
     /*  599117 */   // Label 9710: @599117
     /*  599117 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(599192), // Rule ID 4592 //
     /*  599122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  599171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599190 */     GIR_RootConstrainSelectedInstOperands,
     /*  599191 */     // GIR_Coverage, 4592,
     /*  599191 */     GIR_EraseRootFromParent_Done,
     /*  599192 */   // Label 9711: @599192
     /*  599192 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(599267), // Rule ID 4593 //
     /*  599197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  599246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599265 */     GIR_RootConstrainSelectedInstOperands,
     /*  599266 */     // GIR_Coverage, 4593,
     /*  599266 */     GIR_EraseRootFromParent_Done,
     /*  599267 */   // Label 9712: @599267
     /*  599267 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(599342), // Rule ID 4602 //
     /*  599272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599318 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  599321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599340 */     GIR_RootConstrainSelectedInstOperands,
     /*  599341 */     // GIR_Coverage, 4602,
     /*  599341 */     GIR_EraseRootFromParent_Done,
     /*  599342 */   // Label 9713: @599342
     /*  599342 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(599417), // Rule ID 4603 //
     /*  599347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  599396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599415 */     GIR_RootConstrainSelectedInstOperands,
     /*  599416 */     // GIR_Coverage, 4603,
     /*  599416 */     GIR_EraseRootFromParent_Done,
     /*  599417 */   // Label 9714: @599417
     /*  599417 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(599492), // Rule ID 4612 //
     /*  599422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  599471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599490 */     GIR_RootConstrainSelectedInstOperands,
     /*  599491 */     // GIR_Coverage, 4612,
     /*  599491 */     GIR_EraseRootFromParent_Done,
     /*  599492 */   // Label 9715: @599492
     /*  599492 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(599567), // Rule ID 4613 //
     /*  599497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599543 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  599546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599565 */     GIR_RootConstrainSelectedInstOperands,
     /*  599566 */     // GIR_Coverage, 4613,
     /*  599566 */     GIR_EraseRootFromParent_Done,
     /*  599567 */   // Label 9716: @599567
     /*  599567 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(599642), // Rule ID 4620 //
     /*  599572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  599621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599640 */     GIR_RootConstrainSelectedInstOperands,
     /*  599641 */     // GIR_Coverage, 4620,
     /*  599641 */     GIR_EraseRootFromParent_Done,
     /*  599642 */   // Label 9717: @599642
     /*  599642 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(599717), // Rule ID 4621 //
     /*  599647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  599696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599715 */     GIR_RootConstrainSelectedInstOperands,
     /*  599716 */     // GIR_Coverage, 4621,
     /*  599716 */     GIR_EraseRootFromParent_Done,
     /*  599717 */   // Label 9718: @599717
     /*  599717 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(599792), // Rule ID 4624 //
     /*  599722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  599771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599790 */     GIR_RootConstrainSelectedInstOperands,
     /*  599791 */     // GIR_Coverage, 4624,
     /*  599791 */     GIR_EraseRootFromParent_Done,
     /*  599792 */   // Label 9719: @599792
     /*  599792 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(599867), // Rule ID 4625 //
     /*  599797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599843 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  599846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599865 */     GIR_RootConstrainSelectedInstOperands,
     /*  599866 */     // GIR_Coverage, 4625,
     /*  599866 */     GIR_EraseRootFromParent_Done,
     /*  599867 */   // Label 9720: @599867
     /*  599867 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(599942), // Rule ID 4628 //
     /*  599872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  599883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  599886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  599889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  599921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599940 */     GIR_RootConstrainSelectedInstOperands,
     /*  599941 */     // GIR_Coverage, 4628,
     /*  599941 */     GIR_EraseRootFromParent_Done,
     /*  599942 */   // Label 9721: @599942
     /*  599942 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(600017), // Rule ID 4629 //
     /*  599947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  599955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  599958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  599961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  599964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  599996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600015 */     GIR_RootConstrainSelectedInstOperands,
     /*  600016 */     // GIR_Coverage, 4629,
     /*  600016 */     GIR_EraseRootFromParent_Done,
     /*  600017 */   // Label 9722: @600017
     /*  600017 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(600092), // Rule ID 4632 //
     /*  600022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600090 */     GIR_RootConstrainSelectedInstOperands,
     /*  600091 */     // GIR_Coverage, 4632,
     /*  600091 */     GIR_EraseRootFromParent_Done,
     /*  600092 */   // Label 9723: @600092
     /*  600092 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(600167), // Rule ID 4633 //
     /*  600097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600165 */     GIR_RootConstrainSelectedInstOperands,
     /*  600166 */     // GIR_Coverage, 4633,
     /*  600166 */     GIR_EraseRootFromParent_Done,
     /*  600167 */   // Label 9724: @600167
     /*  600167 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(600242), // Rule ID 4636 //
     /*  600172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600240 */     GIR_RootConstrainSelectedInstOperands,
     /*  600241 */     // GIR_Coverage, 4636,
     /*  600241 */     GIR_EraseRootFromParent_Done,
     /*  600242 */   // Label 9725: @600242
     /*  600242 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(600317), // Rule ID 4637 //
     /*  600247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600315 */     GIR_RootConstrainSelectedInstOperands,
     /*  600316 */     // GIR_Coverage, 4637,
     /*  600316 */     GIR_EraseRootFromParent_Done,
     /*  600317 */   // Label 9726: @600317
     /*  600317 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(600392), // Rule ID 4640 //
     /*  600322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  600371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600390 */     GIR_RootConstrainSelectedInstOperands,
     /*  600391 */     // GIR_Coverage, 4640,
     /*  600391 */     GIR_EraseRootFromParent_Done,
     /*  600392 */   // Label 9727: @600392
     /*  600392 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(600467), // Rule ID 4641 //
     /*  600397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600443 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  600446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600465 */     GIR_RootConstrainSelectedInstOperands,
     /*  600466 */     // GIR_Coverage, 4641,
     /*  600466 */     GIR_EraseRootFromParent_Done,
     /*  600467 */   // Label 9728: @600467
     /*  600467 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(600542), // Rule ID 4644 //
     /*  600472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  600521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600540 */     GIR_RootConstrainSelectedInstOperands,
     /*  600541 */     // GIR_Coverage, 4644,
     /*  600541 */     GIR_EraseRootFromParent_Done,
     /*  600542 */   // Label 9729: @600542
     /*  600542 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(600617), // Rule ID 4645 //
     /*  600547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  600596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600615 */     GIR_RootConstrainSelectedInstOperands,
     /*  600616 */     // GIR_Coverage, 4645,
     /*  600616 */     GIR_EraseRootFromParent_Done,
     /*  600617 */   // Label 9730: @600617
     /*  600617 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(600692), // Rule ID 4648 //
     /*  600622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  600671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600690 */     GIR_RootConstrainSelectedInstOperands,
     /*  600691 */     // GIR_Coverage, 4648,
     /*  600691 */     GIR_EraseRootFromParent_Done,
     /*  600692 */   // Label 9731: @600692
     /*  600692 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(600767), // Rule ID 4649 //
     /*  600697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  600746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600765 */     GIR_RootConstrainSelectedInstOperands,
     /*  600766 */     // GIR_Coverage, 4649,
     /*  600766 */     GIR_EraseRootFromParent_Done,
     /*  600767 */   // Label 9732: @600767
     /*  600767 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(600842), // Rule ID 4652 //
     /*  600772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  600783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  600786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  600789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600840 */     GIR_RootConstrainSelectedInstOperands,
     /*  600841 */     // GIR_Coverage, 4652,
     /*  600841 */     GIR_EraseRootFromParent_Done,
     /*  600842 */   // Label 9733: @600842
     /*  600842 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(600917), // Rule ID 4653 //
     /*  600847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  600858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  600861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  600864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  600896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600915 */     GIR_RootConstrainSelectedInstOperands,
     /*  600916 */     // GIR_Coverage, 4653,
     /*  600916 */     GIR_EraseRootFromParent_Done,
     /*  600917 */   // Label 9734: @600917
     /*  600917 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(600992), // Rule ID 4656 //
     /*  600922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  600930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  600933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  600936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  600939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  600971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600990 */     GIR_RootConstrainSelectedInstOperands,
     /*  600991 */     // GIR_Coverage, 4656,
     /*  600991 */     GIR_EraseRootFromParent_Done,
     /*  600992 */   // Label 9735: @600992
     /*  600992 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(601067), // Rule ID 4657 //
     /*  600997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601065 */     GIR_RootConstrainSelectedInstOperands,
     /*  601066 */     // GIR_Coverage, 4657,
     /*  601066 */     GIR_EraseRootFromParent_Done,
     /*  601067 */   // Label 9736: @601067
     /*  601067 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(601142), // Rule ID 4660 //
     /*  601072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601140 */     GIR_RootConstrainSelectedInstOperands,
     /*  601141 */     // GIR_Coverage, 4660,
     /*  601141 */     GIR_EraseRootFromParent_Done,
     /*  601142 */   // Label 9737: @601142
     /*  601142 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(601217), // Rule ID 4661 //
     /*  601147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601193 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601215 */     GIR_RootConstrainSelectedInstOperands,
     /*  601216 */     // GIR_Coverage, 4661,
     /*  601216 */     GIR_EraseRootFromParent_Done,
     /*  601217 */   // Label 9738: @601217
     /*  601217 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(601292), // Rule ID 4664 //
     /*  601222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  601271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601290 */     GIR_RootConstrainSelectedInstOperands,
     /*  601291 */     // GIR_Coverage, 4664,
     /*  601291 */     GIR_EraseRootFromParent_Done,
     /*  601292 */   // Label 9739: @601292
     /*  601292 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(601367), // Rule ID 4665 //
     /*  601297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601343 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  601346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601365 */     GIR_RootConstrainSelectedInstOperands,
     /*  601366 */     // GIR_Coverage, 4665,
     /*  601366 */     GIR_EraseRootFromParent_Done,
     /*  601367 */   // Label 9740: @601367
     /*  601367 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(601442), // Rule ID 4668 //
     /*  601372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  601421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601440 */     GIR_RootConstrainSelectedInstOperands,
     /*  601441 */     // GIR_Coverage, 4668,
     /*  601441 */     GIR_EraseRootFromParent_Done,
     /*  601442 */   // Label 9741: @601442
     /*  601442 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(601517), // Rule ID 4669 //
     /*  601447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  601496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601515 */     GIR_RootConstrainSelectedInstOperands,
     /*  601516 */     // GIR_Coverage, 4669,
     /*  601516 */     GIR_EraseRootFromParent_Done,
     /*  601517 */   // Label 9742: @601517
     /*  601517 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(601592), // Rule ID 4672 //
     /*  601522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601590 */     GIR_RootConstrainSelectedInstOperands,
     /*  601591 */     // GIR_Coverage, 4672,
     /*  601591 */     GIR_EraseRootFromParent_Done,
     /*  601592 */   // Label 9743: @601592
     /*  601592 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(601667), // Rule ID 4673 //
     /*  601597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601643 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  601646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601665 */     GIR_RootConstrainSelectedInstOperands,
     /*  601666 */     // GIR_Coverage, 4673,
     /*  601666 */     GIR_EraseRootFromParent_Done,
     /*  601667 */   // Label 9744: @601667
     /*  601667 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(601742), // Rule ID 4676 //
     /*  601672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601740 */     GIR_RootConstrainSelectedInstOperands,
     /*  601741 */     // GIR_Coverage, 4676,
     /*  601741 */     GIR_EraseRootFromParent_Done,
     /*  601742 */   // Label 9745: @601742
     /*  601742 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(601817), // Rule ID 4677 //
     /*  601747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  601755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  601796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601815 */     GIR_RootConstrainSelectedInstOperands,
     /*  601816 */     // GIR_Coverage, 4677,
     /*  601816 */     GIR_EraseRootFromParent_Done,
     /*  601817 */   // Label 9746: @601817
     /*  601817 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(601892), // Rule ID 4682 //
     /*  601822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  601833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  601836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  601839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  601842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  601871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601890 */     GIR_RootConstrainSelectedInstOperands,
     /*  601891 */     // GIR_Coverage, 4682,
     /*  601891 */     GIR_EraseRootFromParent_Done,
     /*  601892 */   // Label 9747: @601892
     /*  601892 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(601967), // Rule ID 4683 //
     /*  601897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  601908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  601911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  601914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  601917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  601946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601965 */     GIR_RootConstrainSelectedInstOperands,
     /*  601966 */     // GIR_Coverage, 4683,
     /*  601966 */     GIR_EraseRootFromParent_Done,
     /*  601967 */   // Label 9748: @601967
     /*  601967 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(602042), // Rule ID 4692 //
     /*  601972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  601983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  601986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  601989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  601992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602040 */     GIR_RootConstrainSelectedInstOperands,
     /*  602041 */     // GIR_Coverage, 4692,
     /*  602041 */     GIR_EraseRootFromParent_Done,
     /*  602042 */   // Label 9749: @602042
     /*  602042 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(602117), // Rule ID 4693 //
     /*  602047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  602058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  602067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602115 */     GIR_RootConstrainSelectedInstOperands,
     /*  602116 */     // GIR_Coverage, 4693,
     /*  602116 */     GIR_EraseRootFromParent_Done,
     /*  602117 */   // Label 9750: @602117
     /*  602117 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(602192), // Rule ID 4702 //
     /*  602122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  602133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602190 */     GIR_RootConstrainSelectedInstOperands,
     /*  602191 */     // GIR_Coverage, 4702,
     /*  602191 */     GIR_EraseRootFromParent_Done,
     /*  602192 */   // Label 9751: @602192
     /*  602192 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(602267), // Rule ID 4703 //
     /*  602197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  602208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  602217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602243 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602265 */     GIR_RootConstrainSelectedInstOperands,
     /*  602266 */     // GIR_Coverage, 4703,
     /*  602266 */     GIR_EraseRootFromParent_Done,
     /*  602267 */   // Label 9752: @602267
     /*  602267 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(602342), // Rule ID 4712 //
     /*  602272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  602283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  602286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  602289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  602292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  602321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602340 */     GIR_RootConstrainSelectedInstOperands,
     /*  602341 */     // GIR_Coverage, 4712,
     /*  602341 */     GIR_EraseRootFromParent_Done,
     /*  602342 */   // Label 9753: @602342
     /*  602342 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(602417), // Rule ID 4713 //
     /*  602347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  602358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  602361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  602364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  602367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602393 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  602396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602415 */     GIR_RootConstrainSelectedInstOperands,
     /*  602416 */     // GIR_Coverage, 4713,
     /*  602416 */     GIR_EraseRootFromParent_Done,
     /*  602417 */   // Label 9754: @602417
     /*  602417 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(602492), // Rule ID 4722 //
     /*  602422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  602433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  602436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  602439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  602442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  602471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602490 */     GIR_RootConstrainSelectedInstOperands,
     /*  602491 */     // GIR_Coverage, 4722,
     /*  602491 */     GIR_EraseRootFromParent_Done,
     /*  602492 */   // Label 9755: @602492
     /*  602492 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(602567), // Rule ID 4723 //
     /*  602497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  602508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  602511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  602514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  602517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602543 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  602546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602565 */     GIR_RootConstrainSelectedInstOperands,
     /*  602566 */     // GIR_Coverage, 4723,
     /*  602566 */     GIR_EraseRootFromParent_Done,
     /*  602567 */   // Label 9756: @602567
     /*  602567 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(602642), // Rule ID 4732 //
     /*  602572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  602583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  602586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  602589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  602592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602618 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  602618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  602621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602640 */     GIR_RootConstrainSelectedInstOperands,
     /*  602641 */     // GIR_Coverage, 4732,
     /*  602641 */     GIR_EraseRootFromParent_Done,
     /*  602642 */   // Label 9757: @602642
     /*  602642 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(602717), // Rule ID 4733 //
     /*  602647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  602658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  602661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  602664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  602667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  602693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  602696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602715 */     GIR_RootConstrainSelectedInstOperands,
     /*  602716 */     // GIR_Coverage, 4733,
     /*  602716 */     GIR_EraseRootFromParent_Done,
     /*  602717 */   // Label 9758: @602717
     /*  602717 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(602792), // Rule ID 4742 //
     /*  602722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  602733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602790 */     GIR_RootConstrainSelectedInstOperands,
     /*  602791 */     // GIR_Coverage, 4742,
     /*  602791 */     GIR_EraseRootFromParent_Done,
     /*  602792 */   // Label 9759: @602792
     /*  602792 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(602867), // Rule ID 4743 //
     /*  602797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  602808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  602817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602843 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  602846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602865 */     GIR_RootConstrainSelectedInstOperands,
     /*  602866 */     // GIR_Coverage, 4743,
     /*  602866 */     GIR_EraseRootFromParent_Done,
     /*  602867 */   // Label 9760: @602867
     /*  602867 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(602942), // Rule ID 4752 //
     /*  602872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  602883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  602886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  602889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  602918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602940 */     GIR_RootConstrainSelectedInstOperands,
     /*  602941 */     // GIR_Coverage, 4752,
     /*  602941 */     GIR_EraseRootFromParent_Done,
     /*  602942 */   // Label 9761: @602942
     /*  602942 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(603017), // Rule ID 4753 //
     /*  602947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  602958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  602961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  602964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  602967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  602993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  602996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603015 */     GIR_RootConstrainSelectedInstOperands,
     /*  603016 */     // GIR_Coverage, 4753,
     /*  603016 */     GIR_EraseRootFromParent_Done,
     /*  603017 */   // Label 9762: @603017
     /*  603017 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(603092), // Rule ID 4762 //
     /*  603022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  603033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  603036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  603039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603090 */     GIR_RootConstrainSelectedInstOperands,
     /*  603091 */     // GIR_Coverage, 4762,
     /*  603091 */     GIR_EraseRootFromParent_Done,
     /*  603092 */   // Label 9763: @603092
     /*  603092 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(603167), // Rule ID 4763 //
     /*  603097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  603108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  603111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  603114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  603117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603165 */     GIR_RootConstrainSelectedInstOperands,
     /*  603166 */     // GIR_Coverage, 4763,
     /*  603166 */     GIR_EraseRootFromParent_Done,
     /*  603167 */   // Label 9764: @603167
     /*  603167 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(603242), // Rule ID 4772 //
     /*  603172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  603183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  603186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  603189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  603192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603240 */     GIR_RootConstrainSelectedInstOperands,
     /*  603241 */     // GIR_Coverage, 4772,
     /*  603241 */     GIR_EraseRootFromParent_Done,
     /*  603242 */   // Label 9765: @603242
     /*  603242 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(603317), // Rule ID 4773 //
     /*  603247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  603258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  603261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  603264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  603267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603315 */     GIR_RootConstrainSelectedInstOperands,
     /*  603316 */     // GIR_Coverage, 4773,
     /*  603316 */     GIR_EraseRootFromParent_Done,
     /*  603317 */   // Label 9766: @603317
     /*  603317 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(603392), // Rule ID 4782 //
     /*  603322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  603333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  603336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  603339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  603342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  603368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603390 */     GIR_RootConstrainSelectedInstOperands,
     /*  603391 */     // GIR_Coverage, 4782,
     /*  603391 */     GIR_EraseRootFromParent_Done,
     /*  603392 */   // Label 9767: @603392
     /*  603392 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(603467), // Rule ID 4783 //
     /*  603397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  603408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  603411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  603414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  603417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603443 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  603443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603465 */     GIR_RootConstrainSelectedInstOperands,
     /*  603466 */     // GIR_Coverage, 4783,
     /*  603466 */     GIR_EraseRootFromParent_Done,
     /*  603467 */   // Label 9768: @603467
     /*  603467 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(603542), // Rule ID 4792 //
     /*  603472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  603483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  603492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  603521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603540 */     GIR_RootConstrainSelectedInstOperands,
     /*  603541 */     // GIR_Coverage, 4792,
     /*  603541 */     GIR_EraseRootFromParent_Done,
     /*  603542 */   // Label 9769: @603542
     /*  603542 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(603617), // Rule ID 4793 //
     /*  603547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  603558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  603567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603593 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  603596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603615 */     GIR_RootConstrainSelectedInstOperands,
     /*  603616 */     // GIR_Coverage, 4793,
     /*  603616 */     GIR_EraseRootFromParent_Done,
     /*  603617 */   // Label 9770: @603617
     /*  603617 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(603692), // Rule ID 4802 //
     /*  603622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  603633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  603636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  603639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603690 */     GIR_RootConstrainSelectedInstOperands,
     /*  603691 */     // GIR_Coverage, 4802,
     /*  603691 */     GIR_EraseRootFromParent_Done,
     /*  603692 */   // Label 9771: @603692
     /*  603692 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(603767), // Rule ID 4803 //
     /*  603697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  603708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  603711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  603714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  603717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  603746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603765 */     GIR_RootConstrainSelectedInstOperands,
     /*  603766 */     // GIR_Coverage, 4803,
     /*  603766 */     GIR_EraseRootFromParent_Done,
     /*  603767 */   // Label 9772: @603767
     /*  603767 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(603842), // Rule ID 4812 //
     /*  603772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  603783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  603786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  603789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  603792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603818 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603840 */     GIR_RootConstrainSelectedInstOperands,
     /*  603841 */     // GIR_Coverage, 4812,
     /*  603841 */     GIR_EraseRootFromParent_Done,
     /*  603842 */   // Label 9773: @603842
     /*  603842 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(603917), // Rule ID 4813 //
     /*  603847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  603850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  603858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  603861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  603864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  603867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603893 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  603893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  603896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603915 */     GIR_RootConstrainSelectedInstOperands,
     /*  603916 */     // GIR_Coverage, 4813,
     /*  603916 */     GIR_EraseRootFromParent_Done,
     /*  603917 */   // Label 9774: @603917
     /*  603917 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(603992), // Rule ID 4822 //
     /*  603922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  603925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  603930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  603933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  603936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  603939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  603942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  603968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  603971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  603975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  603977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  603979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  603990 */     GIR_RootConstrainSelectedInstOperands,
     /*  603991 */     // GIR_Coverage, 4822,
     /*  603991 */     GIR_EraseRootFromParent_Done,
     /*  603992 */   // Label 9775: @603992
     /*  603992 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(604067), // Rule ID 4823 //
     /*  603997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  604000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  604008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  604011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  604014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  604017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  604043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  604046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604065 */     GIR_RootConstrainSelectedInstOperands,
     /*  604066 */     // GIR_Coverage, 4823,
     /*  604066 */     GIR_EraseRootFromParent_Done,
     /*  604067 */   // Label 9776: @604067
     /*  604067 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(604142), // Rule ID 4830 //
     /*  604072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  604083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  604086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  604089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  604121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604140 */     GIR_RootConstrainSelectedInstOperands,
     /*  604141 */     // GIR_Coverage, 4830,
     /*  604141 */     GIR_EraseRootFromParent_Done,
     /*  604142 */   // Label 9777: @604142
     /*  604142 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(604217), // Rule ID 4831 //
     /*  604147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  604158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  604161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  604164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604193 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  604196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604215 */     GIR_RootConstrainSelectedInstOperands,
     /*  604216 */     // GIR_Coverage, 4831,
     /*  604216 */     GIR_EraseRootFromParent_Done,
     /*  604217 */   // Label 9778: @604217
     /*  604217 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(604292), // Rule ID 4834 //
     /*  604222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  604233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  604236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  604239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  604271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604290 */     GIR_RootConstrainSelectedInstOperands,
     /*  604291 */     // GIR_Coverage, 4834,
     /*  604291 */     GIR_EraseRootFromParent_Done,
     /*  604292 */   // Label 9779: @604292
     /*  604292 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(604367), // Rule ID 4835 //
     /*  604297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  604308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  604311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  604314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604343 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  604346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604365 */     GIR_RootConstrainSelectedInstOperands,
     /*  604366 */     // GIR_Coverage, 4835,
     /*  604366 */     GIR_EraseRootFromParent_Done,
     /*  604367 */   // Label 9780: @604367
     /*  604367 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(604442), // Rule ID 4838 //
     /*  604372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  604383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  604386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  604389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  604421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604440 */     GIR_RootConstrainSelectedInstOperands,
     /*  604441 */     // GIR_Coverage, 4838,
     /*  604441 */     GIR_EraseRootFromParent_Done,
     /*  604442 */   // Label 9781: @604442
     /*  604442 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(604517), // Rule ID 4839 //
     /*  604447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  604458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  604461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  604464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  604496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604515 */     GIR_RootConstrainSelectedInstOperands,
     /*  604516 */     // GIR_Coverage, 4839,
     /*  604516 */     GIR_EraseRootFromParent_Done,
     /*  604517 */   // Label 9782: @604517
     /*  604517 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(604592), // Rule ID 4842 //
     /*  604522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  604571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604590 */     GIR_RootConstrainSelectedInstOperands,
     /*  604591 */     // GIR_Coverage, 4842,
     /*  604591 */     GIR_EraseRootFromParent_Done,
     /*  604592 */   // Label 9783: @604592
     /*  604592 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(604667), // Rule ID 4843 //
     /*  604597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  604608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  604646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604665 */     GIR_RootConstrainSelectedInstOperands,
     /*  604666 */     // GIR_Coverage, 4843,
     /*  604666 */     GIR_EraseRootFromParent_Done,
     /*  604667 */   // Label 9784: @604667
     /*  604667 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(604742), // Rule ID 4846 //
     /*  604672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  604721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604740 */     GIR_RootConstrainSelectedInstOperands,
     /*  604741 */     // GIR_Coverage, 4846,
     /*  604741 */     GIR_EraseRootFromParent_Done,
     /*  604742 */   // Label 9785: @604742
     /*  604742 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(604817), // Rule ID 4847 //
     /*  604747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  604758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604793 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  604796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604815 */     GIR_RootConstrainSelectedInstOperands,
     /*  604816 */     // GIR_Coverage, 4847,
     /*  604816 */     GIR_EraseRootFromParent_Done,
     /*  604817 */   // Label 9786: @604817
     /*  604817 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(604892), // Rule ID 4850 //
     /*  604822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  604868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  604871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604890 */     GIR_RootConstrainSelectedInstOperands,
     /*  604891 */     // GIR_Coverage, 4850,
     /*  604891 */     GIR_EraseRootFromParent_Done,
     /*  604892 */   // Label 9787: @604892
     /*  604892 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(604967), // Rule ID 4851 //
     /*  604897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  604908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  604917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  604936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  604943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  604946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  604950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  604952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  604954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  604965 */     GIR_RootConstrainSelectedInstOperands,
     /*  604966 */     // GIR_Coverage, 4851,
     /*  604966 */     GIR_EraseRootFromParent_Done,
     /*  604967 */   // Label 9788: @604967
     /*  604967 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(605042), // Rule ID 4854 //
     /*  604972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  604980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  604983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  604986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  604989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  604992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  605021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605040 */     GIR_RootConstrainSelectedInstOperands,
     /*  605041 */     // GIR_Coverage, 4854,
     /*  605041 */     GIR_EraseRootFromParent_Done,
     /*  605042 */   // Label 9789: @605042
     /*  605042 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(605117), // Rule ID 4855 //
     /*  605047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  605058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  605064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  605096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605115 */     GIR_RootConstrainSelectedInstOperands,
     /*  605116 */     // GIR_Coverage, 4855,
     /*  605116 */     GIR_EraseRootFromParent_Done,
     /*  605117 */   // Label 9790: @605117
     /*  605117 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(605192), // Rule ID 4858 //
     /*  605122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  605133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  605136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  605139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605190 */     GIR_RootConstrainSelectedInstOperands,
     /*  605191 */     // GIR_Coverage, 4858,
     /*  605191 */     GIR_EraseRootFromParent_Done,
     /*  605192 */   // Label 9791: @605192
     /*  605192 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(605267), // Rule ID 4859 //
     /*  605197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  605208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  605211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  605214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605243 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605265 */     GIR_RootConstrainSelectedInstOperands,
     /*  605266 */     // GIR_Coverage, 4859,
     /*  605266 */     GIR_EraseRootFromParent_Done,
     /*  605267 */   // Label 9792: @605267
     /*  605267 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(605342), // Rule ID 4862 //
     /*  605272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  605283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605340 */     GIR_RootConstrainSelectedInstOperands,
     /*  605341 */     // GIR_Coverage, 4862,
     /*  605341 */     GIR_EraseRootFromParent_Done,
     /*  605342 */   // Label 9793: @605342
     /*  605342 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(605417), // Rule ID 4863 //
     /*  605347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  605358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  605361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  605364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605415 */     GIR_RootConstrainSelectedInstOperands,
     /*  605416 */     // GIR_Coverage, 4863,
     /*  605416 */     GIR_EraseRootFromParent_Done,
     /*  605417 */   // Label 9794: @605417
     /*  605417 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(605492), // Rule ID 4866 //
     /*  605422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  605433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  605471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605490 */     GIR_RootConstrainSelectedInstOperands,
     /*  605491 */     // GIR_Coverage, 4866,
     /*  605491 */     GIR_EraseRootFromParent_Done,
     /*  605492 */   // Label 9795: @605492
     /*  605492 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(605567), // Rule ID 4867 //
     /*  605497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  605508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  605511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  605514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  605546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605565 */     GIR_RootConstrainSelectedInstOperands,
     /*  605566 */     // GIR_Coverage, 4867,
     /*  605566 */     GIR_EraseRootFromParent_Done,
     /*  605567 */   // Label 9796: @605567
     /*  605567 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(605642), // Rule ID 4870 //
     /*  605572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  605583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  605618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  605621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605640 */     GIR_RootConstrainSelectedInstOperands,
     /*  605641 */     // GIR_Coverage, 4870,
     /*  605641 */     GIR_EraseRootFromParent_Done,
     /*  605642 */   // Label 9797: @605642
     /*  605642 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(605717), // Rule ID 4871 //
     /*  605647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  605658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605693 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  605693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  605696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605715 */     GIR_RootConstrainSelectedInstOperands,
     /*  605716 */     // GIR_Coverage, 4871,
     /*  605716 */     GIR_EraseRootFromParent_Done,
     /*  605717 */   // Label 9798: @605717
     /*  605717 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(605792), // Rule ID 4874 //
     /*  605722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  605725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  605733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  605736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  605739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  605768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605790 */     GIR_RootConstrainSelectedInstOperands,
     /*  605791 */     // GIR_Coverage, 4874,
     /*  605791 */     GIR_EraseRootFromParent_Done,
     /*  605792 */   // Label 9799: @605792
     /*  605792 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(605867), // Rule ID 4875 //
     /*  605797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  605800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  605808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  605811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  605814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  605843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  605846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605865 */     GIR_RootConstrainSelectedInstOperands,
     /*  605866 */     // GIR_Coverage, 4875,
     /*  605866 */     GIR_EraseRootFromParent_Done,
     /*  605867 */   // Label 9800: @605867
     /*  605867 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(605942), // Rule ID 4878 //
     /*  605872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  605875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  605883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  605892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605918 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  605918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  605925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  605927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  605929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  605940 */     GIR_RootConstrainSelectedInstOperands,
     /*  605941 */     // GIR_Coverage, 4878,
     /*  605941 */     GIR_EraseRootFromParent_Done,
     /*  605942 */   // Label 9801: @605942
     /*  605942 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(606017), // Rule ID 4879 //
     /*  605947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  605950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  605955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  605958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  605967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  605993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  605996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606015 */     GIR_RootConstrainSelectedInstOperands,
     /*  606016 */     // GIR_Coverage, 4879,
     /*  606016 */     GIR_EraseRootFromParent_Done,
     /*  606017 */   // Label 9802: @606017
     /*  606017 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(606092), // Rule ID 4882 //
     /*  606022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  606025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  606033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  606036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  606039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  606068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  606071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606090 */     GIR_RootConstrainSelectedInstOperands,
     /*  606091 */     // GIR_Coverage, 4882,
     /*  606091 */     GIR_EraseRootFromParent_Done,
     /*  606092 */   // Label 9803: @606092
     /*  606092 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(606167), // Rule ID 4883 //
     /*  606097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  606100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  606108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  606111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  606114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606143 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  606143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  606146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606165 */     GIR_RootConstrainSelectedInstOperands,
     /*  606166 */     // GIR_Coverage, 4883,
     /*  606166 */     GIR_EraseRootFromParent_Done,
     /*  606167 */   // Label 9804: @606167
     /*  606167 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(606242), // Rule ID 4886 //
     /*  606172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  606175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  606183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  606186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  606189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  606192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606218 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  606218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  606221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606240 */     GIR_RootConstrainSelectedInstOperands,
     /*  606241 */     // GIR_Coverage, 4886,
     /*  606241 */     GIR_EraseRootFromParent_Done,
     /*  606242 */   // Label 9805: @606242
     /*  606242 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(606317), // Rule ID 4887 //
     /*  606247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  606250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  606255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  606258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  606261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  606264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  606267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  606293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  606296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  606300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  606302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  606304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  606315 */     GIR_RootConstrainSelectedInstOperands,
     /*  606316 */     // GIR_Coverage, 4887,
     /*  606316 */     GIR_EraseRootFromParent_Done,
     /*  606317 */   // Label 9806: @606317
     /*  606317 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(606389), // Rule ID 5240 //
     /*  606322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  606339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606387 */     GIR_RootConstrainSelectedInstOperands,
     /*  606388 */     // GIR_Coverage, 5240,
     /*  606388 */     GIR_EraseRootFromParent_Done,
     /*  606389 */   // Label 9807: @606389
     /*  606389 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(606461), // Rule ID 5241 //
     /*  606394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  606408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  606411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606459 */     GIR_RootConstrainSelectedInstOperands,
     /*  606460 */     // GIR_Coverage, 5241,
     /*  606460 */     GIR_EraseRootFromParent_Done,
     /*  606461 */   // Label 9808: @606461
     /*  606461 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(606533), // Rule ID 5242 //
     /*  606466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  606483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606531 */     GIR_RootConstrainSelectedInstOperands,
     /*  606532 */     // GIR_Coverage, 5242,
     /*  606532 */     GIR_EraseRootFromParent_Done,
     /*  606533 */   // Label 9809: @606533
     /*  606533 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(606605), // Rule ID 5243 //
     /*  606538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  606552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  606555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606603 */     GIR_RootConstrainSelectedInstOperands,
     /*  606604 */     // GIR_Coverage, 5243,
     /*  606604 */     GIR_EraseRootFromParent_Done,
     /*  606605 */   // Label 9810: @606605
     /*  606605 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(606677), // Rule ID 5244 //
     /*  606610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  606627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606675 */     GIR_RootConstrainSelectedInstOperands,
     /*  606676 */     // GIR_Coverage, 5244,
     /*  606676 */     GIR_EraseRootFromParent_Done,
     /*  606677 */   // Label 9811: @606677
     /*  606677 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(606749), // Rule ID 5245 //
     /*  606682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  606699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  606731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606747 */     GIR_RootConstrainSelectedInstOperands,
     /*  606748 */     // GIR_Coverage, 5245,
     /*  606748 */     GIR_EraseRootFromParent_Done,
     /*  606749 */   // Label 9812: @606749
     /*  606749 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(606821), // Rule ID 5246 //
     /*  606754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  606771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606819 */     GIR_RootConstrainSelectedInstOperands,
     /*  606820 */     // GIR_Coverage, 5246,
     /*  606820 */     GIR_EraseRootFromParent_Done,
     /*  606821 */   // Label 9813: @606821
     /*  606821 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(606893), // Rule ID 5247 //
     /*  606826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  606843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606891 */     GIR_RootConstrainSelectedInstOperands,
     /*  606892 */     // GIR_Coverage, 5247,
     /*  606892 */     GIR_EraseRootFromParent_Done,
     /*  606893 */   // Label 9814: @606893
     /*  606893 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(606965), // Rule ID 5248 //
     /*  606898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  606915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  606947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606963 */     GIR_RootConstrainSelectedInstOperands,
     /*  606964 */     // GIR_Coverage, 5248,
     /*  606964 */     GIR_EraseRootFromParent_Done,
     /*  606965 */   // Label 9815: @606965
     /*  606965 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(607037), // Rule ID 5249 //
     /*  606970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  606987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  607019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607035 */     GIR_RootConstrainSelectedInstOperands,
     /*  607036 */     // GIR_Coverage, 5249,
     /*  607036 */     GIR_EraseRootFromParent_Done,
     /*  607037 */   // Label 9816: @607037
     /*  607037 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(607109), // Rule ID 5250 //
     /*  607042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  607056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  607059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607107 */     GIR_RootConstrainSelectedInstOperands,
     /*  607108 */     // GIR_Coverage, 5250,
     /*  607108 */     GIR_EraseRootFromParent_Done,
     /*  607109 */   // Label 9817: @607109
     /*  607109 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(607181), // Rule ID 5251 //
     /*  607114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  607128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  607131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607179 */     GIR_RootConstrainSelectedInstOperands,
     /*  607180 */     // GIR_Coverage, 5251,
     /*  607180 */     GIR_EraseRootFromParent_Done,
     /*  607181 */   // Label 9818: @607181
     /*  607181 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(607253), // Rule ID 5252 //
     /*  607186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  607203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607251 */     GIR_RootConstrainSelectedInstOperands,
     /*  607252 */     // GIR_Coverage, 5252,
     /*  607252 */     GIR_EraseRootFromParent_Done,
     /*  607253 */   // Label 9819: @607253
     /*  607253 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(607325), // Rule ID 5253 //
     /*  607258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  607272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  607275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607323 */     GIR_RootConstrainSelectedInstOperands,
     /*  607324 */     // GIR_Coverage, 5253,
     /*  607324 */     GIR_EraseRootFromParent_Done,
     /*  607325 */   // Label 9820: @607325
     /*  607325 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(607397), // Rule ID 5254 //
     /*  607330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  607347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607395 */     GIR_RootConstrainSelectedInstOperands,
     /*  607396 */     // GIR_Coverage, 5254,
     /*  607396 */     GIR_EraseRootFromParent_Done,
     /*  607397 */   // Label 9821: @607397
     /*  607397 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(607469), // Rule ID 5255 //
     /*  607402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  607416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  607419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607467 */     GIR_RootConstrainSelectedInstOperands,
     /*  607468 */     // GIR_Coverage, 5255,
     /*  607468 */     GIR_EraseRootFromParent_Done,
     /*  607469 */   // Label 9822: @607469
     /*  607469 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(607541), // Rule ID 5256 //
     /*  607474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  607491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607539 */     GIR_RootConstrainSelectedInstOperands,
     /*  607540 */     // GIR_Coverage, 5256,
     /*  607540 */     GIR_EraseRootFromParent_Done,
     /*  607541 */   // Label 9823: @607541
     /*  607541 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(607613), // Rule ID 5257 //
     /*  607546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  607557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  607560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  607563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  607566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  607595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607611 */     GIR_RootConstrainSelectedInstOperands,
     /*  607612 */     // GIR_Coverage, 5257,
     /*  607612 */     GIR_EraseRootFromParent_Done,
     /*  607613 */   // Label 9824: @607613
     /*  607613 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(607685), // Rule ID 5258 //
     /*  607618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  607635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  607667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607683 */     GIR_RootConstrainSelectedInstOperands,
     /*  607684 */     // GIR_Coverage, 5258,
     /*  607684 */     GIR_EraseRootFromParent_Done,
     /*  607685 */   // Label 9825: @607685
     /*  607685 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(607757), // Rule ID 5259 //
     /*  607690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  607707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  607739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607755 */     GIR_RootConstrainSelectedInstOperands,
     /*  607756 */     // GIR_Coverage, 5259,
     /*  607756 */     GIR_EraseRootFromParent_Done,
     /*  607757 */   // Label 9826: @607757
     /*  607757 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(607829), // Rule ID 5260 //
     /*  607762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  607779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607808 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  607811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607827 */     GIR_RootConstrainSelectedInstOperands,
     /*  607828 */     // GIR_Coverage, 5260,
     /*  607828 */     GIR_EraseRootFromParent_Done,
     /*  607829 */   // Label 9827: @607829
     /*  607829 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(607901), // Rule ID 5261 //
     /*  607834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  607851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  607883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607899 */     GIR_RootConstrainSelectedInstOperands,
     /*  607900 */     // GIR_Coverage, 5261,
     /*  607900 */     GIR_EraseRootFromParent_Done,
     /*  607901 */   // Label 9828: @607901
     /*  607901 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(607973), // Rule ID 5262 //
     /*  607906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  607923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607952 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  607955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607971 */     GIR_RootConstrainSelectedInstOperands,
     /*  607972 */     // GIR_Coverage, 5262,
     /*  607972 */     GIR_EraseRootFromParent_Done,
     /*  607973 */   // Label 9829: @607973
     /*  607973 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(608045), // Rule ID 5263 //
     /*  607978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  607995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608024 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608043 */     GIR_RootConstrainSelectedInstOperands,
     /*  608044 */     // GIR_Coverage, 5263,
     /*  608044 */     GIR_EraseRootFromParent_Done,
     /*  608045 */   // Label 9830: @608045
     /*  608045 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(608117), // Rule ID 5264 //
     /*  608050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  608064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  608067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608115 */     GIR_RootConstrainSelectedInstOperands,
     /*  608116 */     // GIR_Coverage, 5264,
     /*  608116 */     GIR_EraseRootFromParent_Done,
     /*  608117 */   // Label 9831: @608117
     /*  608117 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(608189), // Rule ID 5265 //
     /*  608122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  608136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  608139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608187 */     GIR_RootConstrainSelectedInstOperands,
     /*  608188 */     // GIR_Coverage, 5265,
     /*  608188 */     GIR_EraseRootFromParent_Done,
     /*  608189 */   // Label 9832: @608189
     /*  608189 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(608261), // Rule ID 5266 //
     /*  608194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  608211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608259 */     GIR_RootConstrainSelectedInstOperands,
     /*  608260 */     // GIR_Coverage, 5266,
     /*  608260 */     GIR_EraseRootFromParent_Done,
     /*  608261 */   // Label 9833: @608261
     /*  608261 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(608333), // Rule ID 5267 //
     /*  608266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  608280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  608283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608331 */     GIR_RootConstrainSelectedInstOperands,
     /*  608332 */     // GIR_Coverage, 5267,
     /*  608332 */     GIR_EraseRootFromParent_Done,
     /*  608333 */   // Label 9834: @608333
     /*  608333 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(608405), // Rule ID 5268 //
     /*  608338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  608355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608403 */     GIR_RootConstrainSelectedInstOperands,
     /*  608404 */     // GIR_Coverage, 5268,
     /*  608404 */     GIR_EraseRootFromParent_Done,
     /*  608405 */   // Label 9835: @608405
     /*  608405 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(608477), // Rule ID 5269 //
     /*  608410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  608421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  608424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  608427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  608430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608456 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608475 */     GIR_RootConstrainSelectedInstOperands,
     /*  608476 */     // GIR_Coverage, 5269,
     /*  608476 */     GIR_EraseRootFromParent_Done,
     /*  608477 */   // Label 9836: @608477
     /*  608477 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(608549), // Rule ID 5270 //
     /*  608482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  608499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608547 */     GIR_RootConstrainSelectedInstOperands,
     /*  608548 */     // GIR_Coverage, 5270,
     /*  608548 */     GIR_EraseRootFromParent_Done,
     /*  608549 */   // Label 9837: @608549
     /*  608549 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(608621), // Rule ID 5271 //
     /*  608554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  608568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  608571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608619 */     GIR_RootConstrainSelectedInstOperands,
     /*  608620 */     // GIR_Coverage, 5271,
     /*  608620 */     GIR_EraseRootFromParent_Done,
     /*  608621 */   // Label 9838: @608621
     /*  608621 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(608693), // Rule ID 5272 //
     /*  608626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  608643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608691 */     GIR_RootConstrainSelectedInstOperands,
     /*  608692 */     // GIR_Coverage, 5272,
     /*  608692 */     GIR_EraseRootFromParent_Done,
     /*  608693 */   // Label 9839: @608693
     /*  608693 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(608765), // Rule ID 5273 //
     /*  608698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  608715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  608747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608763 */     GIR_RootConstrainSelectedInstOperands,
     /*  608764 */     // GIR_Coverage, 5273,
     /*  608764 */     GIR_EraseRootFromParent_Done,
     /*  608765 */   // Label 9840: @608765
     /*  608765 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(608837), // Rule ID 5274 //
     /*  608770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  608787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608835 */     GIR_RootConstrainSelectedInstOperands,
     /*  608836 */     // GIR_Coverage, 5274,
     /*  608836 */     GIR_EraseRootFromParent_Done,
     /*  608837 */   // Label 9841: @608837
     /*  608837 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(608909), // Rule ID 5275 //
     /*  608842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  608859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  608891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608907 */     GIR_RootConstrainSelectedInstOperands,
     /*  608908 */     // GIR_Coverage, 5275,
     /*  608908 */     GIR_EraseRootFromParent_Done,
     /*  608909 */   // Label 9842: @608909
     /*  608909 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(608981), // Rule ID 5276 //
     /*  608914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  608931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  608963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608979 */     GIR_RootConstrainSelectedInstOperands,
     /*  608980 */     // GIR_Coverage, 5276,
     /*  608980 */     GIR_EraseRootFromParent_Done,
     /*  608981 */   // Label 9843: @608981
     /*  608981 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(609053), // Rule ID 5277 //
     /*  608986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  609000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  609003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  609035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609051 */     GIR_RootConstrainSelectedInstOperands,
     /*  609052 */     // GIR_Coverage, 5277,
     /*  609052 */     GIR_EraseRootFromParent_Done,
     /*  609053 */   // Label 9844: @609053
     /*  609053 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(609125), // Rule ID 5278 //
     /*  609058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  609072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  609075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  609107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609123 */     GIR_RootConstrainSelectedInstOperands,
     /*  609124 */     // GIR_Coverage, 5278,
     /*  609124 */     GIR_EraseRootFromParent_Done,
     /*  609125 */   // Label 9845: @609125
     /*  609125 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(609197), // Rule ID 5279 //
     /*  609130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  609144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  609147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  609179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609195 */     GIR_RootConstrainSelectedInstOperands,
     /*  609196 */     // GIR_Coverage, 5279,
     /*  609196 */     GIR_EraseRootFromParent_Done,
     /*  609197 */   // Label 9846: @609197
     /*  609197 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(609269), // Rule ID 5280 //
     /*  609202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  609219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  609251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609267 */     GIR_RootConstrainSelectedInstOperands,
     /*  609268 */     // GIR_Coverage, 5280,
     /*  609268 */     GIR_EraseRootFromParent_Done,
     /*  609269 */   // Label 9847: @609269
     /*  609269 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(609341), // Rule ID 5281 //
     /*  609274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  609288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  609291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  609323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609339 */     GIR_RootConstrainSelectedInstOperands,
     /*  609340 */     // GIR_Coverage, 5281,
     /*  609340 */     GIR_EraseRootFromParent_Done,
     /*  609341 */   // Label 9848: @609341
     /*  609341 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(609413), // Rule ID 5282 //
     /*  609346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  609395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609411 */     GIR_RootConstrainSelectedInstOperands,
     /*  609412 */     // GIR_Coverage, 5282,
     /*  609412 */     GIR_EraseRootFromParent_Done,
     /*  609413 */   // Label 9849: @609413
     /*  609413 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(609485), // Rule ID 5283 //
     /*  609418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  609432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  609467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609483 */     GIR_RootConstrainSelectedInstOperands,
     /*  609484 */     // GIR_Coverage, 5283,
     /*  609484 */     GIR_EraseRootFromParent_Done,
     /*  609485 */   // Label 9850: @609485
     /*  609485 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(609557), // Rule ID 5284 //
     /*  609490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609555 */     GIR_RootConstrainSelectedInstOperands,
     /*  609556 */     // GIR_Coverage, 5284,
     /*  609556 */     GIR_EraseRootFromParent_Done,
     /*  609557 */   // Label 9851: @609557
     /*  609557 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(609629), // Rule ID 5285 //
     /*  609562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  609576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609627 */     GIR_RootConstrainSelectedInstOperands,
     /*  609628 */     // GIR_Coverage, 5285,
     /*  609628 */     GIR_EraseRootFromParent_Done,
     /*  609629 */   // Label 9852: @609629
     /*  609629 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(609701), // Rule ID 5286 //
     /*  609634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609699 */     GIR_RootConstrainSelectedInstOperands,
     /*  609700 */     // GIR_Coverage, 5286,
     /*  609700 */     GIR_EraseRootFromParent_Done,
     /*  609701 */   // Label 9853: @609701
     /*  609701 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(609773), // Rule ID 5287 //
     /*  609706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609771 */     GIR_RootConstrainSelectedInstOperands,
     /*  609772 */     // GIR_Coverage, 5287,
     /*  609772 */     GIR_EraseRootFromParent_Done,
     /*  609773 */   // Label 9854: @609773
     /*  609773 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(609845), // Rule ID 5288 //
     /*  609778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609843 */     GIR_RootConstrainSelectedInstOperands,
     /*  609844 */     // GIR_Coverage, 5288,
     /*  609844 */     GIR_EraseRootFromParent_Done,
     /*  609845 */   // Label 9855: @609845
     /*  609845 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(609917), // Rule ID 5289 //
     /*  609850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  609867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  609899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609915 */     GIR_RootConstrainSelectedInstOperands,
     /*  609916 */     // GIR_Coverage, 5289,
     /*  609916 */     GIR_EraseRootFromParent_Done,
     /*  609917 */   // Label 9856: @609917
     /*  609917 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(609989), // Rule ID 5290 //
     /*  609922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  609930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  609939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  609957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  609971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609987 */     GIR_RootConstrainSelectedInstOperands,
     /*  609988 */     // GIR_Coverage, 5290,
     /*  609988 */     GIR_EraseRootFromParent_Done,
     /*  609989 */   // Label 9857: @609989
     /*  609989 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(610061), // Rule ID 5291 //
     /*  609994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  610008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610059 */     GIR_RootConstrainSelectedInstOperands,
     /*  610060 */     // GIR_Coverage, 5291,
     /*  610060 */     GIR_EraseRootFromParent_Done,
     /*  610061 */   // Label 9858: @610061
     /*  610061 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(610133), // Rule ID 5292 //
     /*  610066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  610080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610131 */     GIR_RootConstrainSelectedInstOperands,
     /*  610132 */     // GIR_Coverage, 5292,
     /*  610132 */     GIR_EraseRootFromParent_Done,
     /*  610133 */   // Label 9859: @610133
     /*  610133 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(610205), // Rule ID 5293 //
     /*  610138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  610152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  610187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610203 */     GIR_RootConstrainSelectedInstOperands,
     /*  610204 */     // GIR_Coverage, 5293,
     /*  610204 */     GIR_EraseRootFromParent_Done,
     /*  610205 */   // Label 9860: @610205
     /*  610205 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(610277), // Rule ID 5294 //
     /*  610210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610275 */     GIR_RootConstrainSelectedInstOperands,
     /*  610276 */     // GIR_Coverage, 5294,
     /*  610276 */     GIR_EraseRootFromParent_Done,
     /*  610277 */   // Label 9861: @610277
     /*  610277 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(610349), // Rule ID 5295 //
     /*  610282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  610296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610347 */     GIR_RootConstrainSelectedInstOperands,
     /*  610348 */     // GIR_Coverage, 5295,
     /*  610348 */     GIR_EraseRootFromParent_Done,
     /*  610349 */   // Label 9862: @610349
     /*  610349 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(610421), // Rule ID 5296 //
     /*  610354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610419 */     GIR_RootConstrainSelectedInstOperands,
     /*  610420 */     // GIR_Coverage, 5296,
     /*  610420 */     GIR_EraseRootFromParent_Done,
     /*  610421 */   // Label 9863: @610421
     /*  610421 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(610493), // Rule ID 5297 //
     /*  610426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  610440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610491 */     GIR_RootConstrainSelectedInstOperands,
     /*  610492 */     // GIR_Coverage, 5297,
     /*  610492 */     GIR_EraseRootFromParent_Done,
     /*  610493 */   // Label 9864: @610493
     /*  610493 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(610565), // Rule ID 5298 //
     /*  610498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610563 */     GIR_RootConstrainSelectedInstOperands,
     /*  610564 */     // GIR_Coverage, 5298,
     /*  610564 */     GIR_EraseRootFromParent_Done,
     /*  610565 */   // Label 9865: @610565
     /*  610565 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(610637), // Rule ID 5299 //
     /*  610570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  610584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610635 */     GIR_RootConstrainSelectedInstOperands,
     /*  610636 */     // GIR_Coverage, 5299,
     /*  610636 */     GIR_EraseRootFromParent_Done,
     /*  610637 */   // Label 9866: @610637
     /*  610637 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(610709), // Rule ID 5300 //
     /*  610642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  610645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610707 */     GIR_RootConstrainSelectedInstOperands,
     /*  610708 */     // GIR_Coverage, 5300,
     /*  610708 */     GIR_EraseRootFromParent_Done,
     /*  610709 */   // Label 9867: @610709
     /*  610709 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(610781), // Rule ID 5301 //
     /*  610714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  610763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610779 */     GIR_RootConstrainSelectedInstOperands,
     /*  610780 */     // GIR_Coverage, 5301,
     /*  610780 */     GIR_EraseRootFromParent_Done,
     /*  610781 */   // Label 9868: @610781
     /*  610781 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(610853), // Rule ID 5302 //
     /*  610786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  610835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610851 */     GIR_RootConstrainSelectedInstOperands,
     /*  610852 */     // GIR_Coverage, 5302,
     /*  610852 */     GIR_EraseRootFromParent_Done,
     /*  610853 */   // Label 9869: @610853
     /*  610853 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(610925), // Rule ID 5303 //
     /*  610858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  610875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  610907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610923 */     GIR_RootConstrainSelectedInstOperands,
     /*  610924 */     // GIR_Coverage, 5303,
     /*  610924 */     GIR_EraseRootFromParent_Done,
     /*  610925 */   // Label 9870: @610925
     /*  610925 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(610997), // Rule ID 5304 //
     /*  610930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  610938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  610947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  610965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610976 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  610979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610995 */     GIR_RootConstrainSelectedInstOperands,
     /*  610996 */     // GIR_Coverage, 5304,
     /*  610996 */     GIR_EraseRootFromParent_Done,
     /*  610997 */   // Label 9871: @610997
     /*  610997 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(611069), // Rule ID 5305 //
     /*  611002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  611016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611067 */     GIR_RootConstrainSelectedInstOperands,
     /*  611068 */     // GIR_Coverage, 5305,
     /*  611068 */     GIR_EraseRootFromParent_Done,
     /*  611069 */   // Label 9872: @611069
     /*  611069 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(611141), // Rule ID 5306 //
     /*  611074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  611085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  611088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  611094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611120 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611139 */     GIR_RootConstrainSelectedInstOperands,
     /*  611140 */     // GIR_Coverage, 5306,
     /*  611140 */     GIR_EraseRootFromParent_Done,
     /*  611141 */   // Label 9873: @611141
     /*  611141 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(611213), // Rule ID 5307 //
     /*  611146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  611157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  611160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  611166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611192 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611211 */     GIR_RootConstrainSelectedInstOperands,
     /*  611212 */     // GIR_Coverage, 5307,
     /*  611212 */     GIR_EraseRootFromParent_Done,
     /*  611213 */   // Label 9874: @611213
     /*  611213 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(611285), // Rule ID 5308 //
     /*  611218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611283 */     GIR_RootConstrainSelectedInstOperands,
     /*  611284 */     // GIR_Coverage, 5308,
     /*  611284 */     GIR_EraseRootFromParent_Done,
     /*  611285 */   // Label 9875: @611285
     /*  611285 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(611357), // Rule ID 5309 //
     /*  611290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  611304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611355 */     GIR_RootConstrainSelectedInstOperands,
     /*  611356 */     // GIR_Coverage, 5309,
     /*  611356 */     GIR_EraseRootFromParent_Done,
     /*  611357 */   // Label 9876: @611357
     /*  611357 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(611429), // Rule ID 5310 //
     /*  611362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611427 */     GIR_RootConstrainSelectedInstOperands,
     /*  611428 */     // GIR_Coverage, 5310,
     /*  611428 */     GIR_EraseRootFromParent_Done,
     /*  611429 */   // Label 9877: @611429
     /*  611429 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(611501), // Rule ID 5311 //
     /*  611434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  611448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611499 */     GIR_RootConstrainSelectedInstOperands,
     /*  611500 */     // GIR_Coverage, 5311,
     /*  611500 */     GIR_EraseRootFromParent_Done,
     /*  611501 */   // Label 9878: @611501
     /*  611501 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(611573), // Rule ID 5312 //
     /*  611506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611571 */     GIR_RootConstrainSelectedInstOperands,
     /*  611572 */     // GIR_Coverage, 5312,
     /*  611572 */     GIR_EraseRootFromParent_Done,
     /*  611573 */   // Label 9879: @611573
     /*  611573 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(611645), // Rule ID 5313 //
     /*  611578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  611589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  611592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  611598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611643 */     GIR_RootConstrainSelectedInstOperands,
     /*  611644 */     // GIR_Coverage, 5313,
     /*  611644 */     GIR_EraseRootFromParent_Done,
     /*  611645 */   // Label 9880: @611645
     /*  611645 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(611717), // Rule ID 5314 //
     /*  611650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611715 */     GIR_RootConstrainSelectedInstOperands,
     /*  611716 */     // GIR_Coverage, 5314,
     /*  611716 */     GIR_EraseRootFromParent_Done,
     /*  611717 */   // Label 9881: @611717
     /*  611717 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(611789), // Rule ID 5315 //
     /*  611722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  611771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611787 */     GIR_RootConstrainSelectedInstOperands,
     /*  611788 */     // GIR_Coverage, 5315,
     /*  611788 */     GIR_EraseRootFromParent_Done,
     /*  611789 */   // Label 9882: @611789
     /*  611789 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(611861), // Rule ID 5316 //
     /*  611794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611859 */     GIR_RootConstrainSelectedInstOperands,
     /*  611860 */     // GIR_Coverage, 5316,
     /*  611860 */     GIR_EraseRootFromParent_Done,
     /*  611861 */   // Label 9883: @611861
     /*  611861 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(611933), // Rule ID 5317 //
     /*  611866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  611915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611931 */     GIR_RootConstrainSelectedInstOperands,
     /*  611932 */     // GIR_Coverage, 5317,
     /*  611932 */     GIR_EraseRootFromParent_Done,
     /*  611933 */   // Label 9884: @611933
     /*  611933 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(612005), // Rule ID 5318 //
     /*  611938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  611946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  611987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612003 */     GIR_RootConstrainSelectedInstOperands,
     /*  612004 */     // GIR_Coverage, 5318,
     /*  612004 */     GIR_EraseRootFromParent_Done,
     /*  612005 */   // Label 9885: @612005
     /*  612005 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(612077), // Rule ID 5319 //
     /*  612010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  612021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  612024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  612030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612075 */     GIR_RootConstrainSelectedInstOperands,
     /*  612076 */     // GIR_Coverage, 5319,
     /*  612076 */     GIR_EraseRootFromParent_Done,
     /*  612077 */   // Label 9886: @612077
     /*  612077 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(612149), // Rule ID 5320 //
     /*  612082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  612096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  612131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612147 */     GIR_RootConstrainSelectedInstOperands,
     /*  612148 */     // GIR_Coverage, 5320,
     /*  612148 */     GIR_EraseRootFromParent_Done,
     /*  612149 */   // Label 9887: @612149
     /*  612149 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(612221), // Rule ID 5321 //
     /*  612154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  612168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  612203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612219 */     GIR_RootConstrainSelectedInstOperands,
     /*  612220 */     // GIR_Coverage, 5321,
     /*  612220 */     GIR_EraseRootFromParent_Done,
     /*  612221 */   // Label 9888: @612221
     /*  612221 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(612293), // Rule ID 5322 //
     /*  612226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  612275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612291 */     GIR_RootConstrainSelectedInstOperands,
     /*  612292 */     // GIR_Coverage, 5322,
     /*  612292 */     GIR_EraseRootFromParent_Done,
     /*  612293 */   // Label 9889: @612293
     /*  612293 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(612365), // Rule ID 5323 //
     /*  612298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  612312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  612347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612363 */     GIR_RootConstrainSelectedInstOperands,
     /*  612364 */     // GIR_Coverage, 5323,
     /*  612364 */     GIR_EraseRootFromParent_Done,
     /*  612365 */   // Label 9890: @612365
     /*  612365 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(612437), // Rule ID 5324 //
     /*  612370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612435 */     GIR_RootConstrainSelectedInstOperands,
     /*  612436 */     // GIR_Coverage, 5324,
     /*  612436 */     GIR_EraseRootFromParent_Done,
     /*  612437 */   // Label 9891: @612437
     /*  612437 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(612509), // Rule ID 5325 //
     /*  612442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  612450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  612456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  612473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  612491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612507 */     GIR_RootConstrainSelectedInstOperands,
     /*  612508 */     // GIR_Coverage, 5325,
     /*  612508 */     GIR_EraseRootFromParent_Done,
     /*  612509 */   // Label 9892: @612509
     /*  612509 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(612581), // Rule ID 5588 //
     /*  612514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  612531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  612563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612579 */     GIR_RootConstrainSelectedInstOperands,
     /*  612580 */     // GIR_Coverage, 5588,
     /*  612580 */     GIR_EraseRootFromParent_Done,
     /*  612581 */   // Label 9893: @612581
     /*  612581 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(612653), // Rule ID 5589 //
     /*  612586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  612600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  612603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  612635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612651 */     GIR_RootConstrainSelectedInstOperands,
     /*  612652 */     // GIR_Coverage, 5589,
     /*  612652 */     GIR_EraseRootFromParent_Done,
     /*  612653 */   // Label 9894: @612653
     /*  612653 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(612725), // Rule ID 5590 //
     /*  612658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  612675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612723 */     GIR_RootConstrainSelectedInstOperands,
     /*  612724 */     // GIR_Coverage, 5590,
     /*  612724 */     GIR_EraseRootFromParent_Done,
     /*  612725 */   // Label 9895: @612725
     /*  612725 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(612797), // Rule ID 5591 //
     /*  612730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  612747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612795 */     GIR_RootConstrainSelectedInstOperands,
     /*  612796 */     // GIR_Coverage, 5591,
     /*  612796 */     GIR_EraseRootFromParent_Done,
     /*  612797 */   // Label 9896: @612797
     /*  612797 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(612869), // Rule ID 5592 //
     /*  612802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  612819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  612851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612867 */     GIR_RootConstrainSelectedInstOperands,
     /*  612868 */     // GIR_Coverage, 5592,
     /*  612868 */     GIR_EraseRootFromParent_Done,
     /*  612869 */   // Label 9897: @612869
     /*  612869 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(612941), // Rule ID 5593 //
     /*  612874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  612891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  612923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612939 */     GIR_RootConstrainSelectedInstOperands,
     /*  612940 */     // GIR_Coverage, 5593,
     /*  612940 */     GIR_EraseRootFromParent_Done,
     /*  612941 */   // Label 9898: @612941
     /*  612941 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(613013), // Rule ID 5594 //
     /*  612946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  612963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  612995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613011 */     GIR_RootConstrainSelectedInstOperands,
     /*  613012 */     // GIR_Coverage, 5594,
     /*  613012 */     GIR_EraseRootFromParent_Done,
     /*  613013 */   // Label 9899: @613013
     /*  613013 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(613085), // Rule ID 5595 //
     /*  613018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  613032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  613035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  613067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613083 */     GIR_RootConstrainSelectedInstOperands,
     /*  613084 */     // GIR_Coverage, 5595,
     /*  613084 */     GIR_EraseRootFromParent_Done,
     /*  613085 */   // Label 9900: @613085
     /*  613085 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(613157), // Rule ID 5596 //
     /*  613090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613155 */     GIR_RootConstrainSelectedInstOperands,
     /*  613156 */     // GIR_Coverage, 5596,
     /*  613156 */     GIR_EraseRootFromParent_Done,
     /*  613157 */   // Label 9901: @613157
     /*  613157 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(613229), // Rule ID 5597 //
     /*  613162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  613176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  613179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613227 */     GIR_RootConstrainSelectedInstOperands,
     /*  613228 */     // GIR_Coverage, 5597,
     /*  613228 */     GIR_EraseRootFromParent_Done,
     /*  613229 */   // Label 9902: @613229
     /*  613229 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(613301), // Rule ID 5598 //
     /*  613234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613299 */     GIR_RootConstrainSelectedInstOperands,
     /*  613300 */     // GIR_Coverage, 5598,
     /*  613300 */     GIR_EraseRootFromParent_Done,
     /*  613301 */   // Label 9903: @613301
     /*  613301 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(613373), // Rule ID 5599 //
     /*  613306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  613320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  613323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  613355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613371 */     GIR_RootConstrainSelectedInstOperands,
     /*  613372 */     // GIR_Coverage, 5599,
     /*  613372 */     GIR_EraseRootFromParent_Done,
     /*  613373 */   // Label 9904: @613373
     /*  613373 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(613445), // Rule ID 5600 //
     /*  613378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  613395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613443 */     GIR_RootConstrainSelectedInstOperands,
     /*  613444 */     // GIR_Coverage, 5600,
     /*  613444 */     GIR_EraseRootFromParent_Done,
     /*  613445 */   // Label 9905: @613445
     /*  613445 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(613517), // Rule ID 5601 //
     /*  613450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  613464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  613467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613515 */     GIR_RootConstrainSelectedInstOperands,
     /*  613516 */     // GIR_Coverage, 5601,
     /*  613516 */     GIR_EraseRootFromParent_Done,
     /*  613517 */   // Label 9906: @613517
     /*  613517 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(613589), // Rule ID 5602 //
     /*  613522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  613539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613587 */     GIR_RootConstrainSelectedInstOperands,
     /*  613588 */     // GIR_Coverage, 5602,
     /*  613588 */     GIR_EraseRootFromParent_Done,
     /*  613589 */   // Label 9907: @613589
     /*  613589 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(613661), // Rule ID 5603 //
     /*  613594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  613608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  613611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613659 */     GIR_RootConstrainSelectedInstOperands,
     /*  613660 */     // GIR_Coverage, 5603,
     /*  613660 */     GIR_EraseRootFromParent_Done,
     /*  613661 */   // Label 9908: @613661
     /*  613661 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(613733), // Rule ID 5604 //
     /*  613666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  613683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613731 */     GIR_RootConstrainSelectedInstOperands,
     /*  613732 */     // GIR_Coverage, 5604,
     /*  613732 */     GIR_EraseRootFromParent_Done,
     /*  613733 */   // Label 9909: @613733
     /*  613733 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(613805), // Rule ID 5605 //
     /*  613738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  613755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613803 */     GIR_RootConstrainSelectedInstOperands,
     /*  613804 */     // GIR_Coverage, 5605,
     /*  613804 */     GIR_EraseRootFromParent_Done,
     /*  613805 */   // Label 9910: @613805
     /*  613805 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(613877), // Rule ID 5606 //
     /*  613810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  613827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613875 */     GIR_RootConstrainSelectedInstOperands,
     /*  613876 */     // GIR_Coverage, 5606,
     /*  613876 */     GIR_EraseRootFromParent_Done,
     /*  613877 */   // Label 9911: @613877
     /*  613877 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(613949), // Rule ID 5607 //
     /*  613882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  613899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  613931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613947 */     GIR_RootConstrainSelectedInstOperands,
     /*  613948 */     // GIR_Coverage, 5607,
     /*  613948 */     GIR_EraseRootFromParent_Done,
     /*  613949 */   // Label 9912: @613949
     /*  613949 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(614021), // Rule ID 5608 //
     /*  613954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  613971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614019 */     GIR_RootConstrainSelectedInstOperands,
     /*  614020 */     // GIR_Coverage, 5608,
     /*  614020 */     GIR_EraseRootFromParent_Done,
     /*  614021 */   // Label 9913: @614021
     /*  614021 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(614093), // Rule ID 5609 //
     /*  614026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  614040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  614043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614091 */     GIR_RootConstrainSelectedInstOperands,
     /*  614092 */     // GIR_Coverage, 5609,
     /*  614092 */     GIR_EraseRootFromParent_Done,
     /*  614093 */   // Label 9914: @614093
     /*  614093 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(614165), // Rule ID 5610 //
     /*  614098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614144 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614163 */     GIR_RootConstrainSelectedInstOperands,
     /*  614164 */     // GIR_Coverage, 5610,
     /*  614164 */     GIR_EraseRootFromParent_Done,
     /*  614165 */   // Label 9915: @614165
     /*  614165 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(614237), // Rule ID 5611 //
     /*  614170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  614184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  614187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614216 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614235 */     GIR_RootConstrainSelectedInstOperands,
     /*  614236 */     // GIR_Coverage, 5611,
     /*  614236 */     GIR_EraseRootFromParent_Done,
     /*  614237 */   // Label 9916: @614237
     /*  614237 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(614309), // Rule ID 5612 //
     /*  614242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614288 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  614288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614307 */     GIR_RootConstrainSelectedInstOperands,
     /*  614308 */     // GIR_Coverage, 5612,
     /*  614308 */     GIR_EraseRootFromParent_Done,
     /*  614309 */   // Label 9917: @614309
     /*  614309 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(614381), // Rule ID 5613 //
     /*  614314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  614325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  614328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  614331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  614334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614360 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  614360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614379 */     GIR_RootConstrainSelectedInstOperands,
     /*  614380 */     // GIR_Coverage, 5613,
     /*  614380 */     GIR_EraseRootFromParent_Done,
     /*  614381 */   // Label 9918: @614381
     /*  614381 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(614453), // Rule ID 5614 //
     /*  614386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614451 */     GIR_RootConstrainSelectedInstOperands,
     /*  614452 */     // GIR_Coverage, 5614,
     /*  614452 */     GIR_EraseRootFromParent_Done,
     /*  614453 */   // Label 9919: @614453
     /*  614453 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(614525), // Rule ID 5615 //
     /*  614458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  614472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  614475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614523 */     GIR_RootConstrainSelectedInstOperands,
     /*  614524 */     // GIR_Coverage, 5615,
     /*  614524 */     GIR_EraseRootFromParent_Done,
     /*  614525 */   // Label 9920: @614525
     /*  614525 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(614597), // Rule ID 5616 //
     /*  614530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  614547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614595 */     GIR_RootConstrainSelectedInstOperands,
     /*  614596 */     // GIR_Coverage, 5616,
     /*  614596 */     GIR_EraseRootFromParent_Done,
     /*  614597 */   // Label 9921: @614597
     /*  614597 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(614669), // Rule ID 5617 //
     /*  614602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  614616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  614619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  614651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614667 */     GIR_RootConstrainSelectedInstOperands,
     /*  614668 */     // GIR_Coverage, 5617,
     /*  614668 */     GIR_EraseRootFromParent_Done,
     /*  614669 */   // Label 9922: @614669
     /*  614669 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(614741), // Rule ID 5618 //
     /*  614674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  614691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614739 */     GIR_RootConstrainSelectedInstOperands,
     /*  614740 */     // GIR_Coverage, 5618,
     /*  614740 */     GIR_EraseRootFromParent_Done,
     /*  614741 */   // Label 9923: @614741
     /*  614741 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(614813), // Rule ID 5619 //
     /*  614746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  614763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  614795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614811 */     GIR_RootConstrainSelectedInstOperands,
     /*  614812 */     // GIR_Coverage, 5619,
     /*  614812 */     GIR_EraseRootFromParent_Done,
     /*  614813 */   // Label 9924: @614813
     /*  614813 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(614885), // Rule ID 5620 //
     /*  614818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  614835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614883 */     GIR_RootConstrainSelectedInstOperands,
     /*  614884 */     // GIR_Coverage, 5620,
     /*  614884 */     GIR_EraseRootFromParent_Done,
     /*  614885 */   // Label 9925: @614885
     /*  614885 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(614957), // Rule ID 5621 //
     /*  614890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  614907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  614939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614955 */     GIR_RootConstrainSelectedInstOperands,
     /*  614956 */     // GIR_Coverage, 5621,
     /*  614956 */     GIR_EraseRootFromParent_Done,
     /*  614957 */   // Label 9926: @614957
     /*  614957 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(615029), // Rule ID 5622 //
     /*  614962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  614979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  615008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615027 */     GIR_RootConstrainSelectedInstOperands,
     /*  615028 */     // GIR_Coverage, 5622,
     /*  615028 */     GIR_EraseRootFromParent_Done,
     /*  615029 */   // Label 9927: @615029
     /*  615029 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(615101), // Rule ID 5623 //
     /*  615034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  615048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  615051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615099 */     GIR_RootConstrainSelectedInstOperands,
     /*  615100 */     // GIR_Coverage, 5623,
     /*  615100 */     GIR_EraseRootFromParent_Done,
     /*  615101 */   // Label 9928: @615101
     /*  615101 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(615173), // Rule ID 5624 //
     /*  615106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  615117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  615126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  615152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615171 */     GIR_RootConstrainSelectedInstOperands,
     /*  615172 */     // GIR_Coverage, 5624,
     /*  615172 */     GIR_EraseRootFromParent_Done,
     /*  615173 */   // Label 9929: @615173
     /*  615173 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(615245), // Rule ID 5625 //
     /*  615178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  615189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  615192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  615195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  615198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  615224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615243 */     GIR_RootConstrainSelectedInstOperands,
     /*  615244 */     // GIR_Coverage, 5625,
     /*  615244 */     GIR_EraseRootFromParent_Done,
     /*  615245 */   // Label 9930: @615245
     /*  615245 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(615317), // Rule ID 5626 //
     /*  615250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  615267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  615299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615315 */     GIR_RootConstrainSelectedInstOperands,
     /*  615316 */     // GIR_Coverage, 5626,
     /*  615316 */     GIR_EraseRootFromParent_Done,
     /*  615317 */   // Label 9931: @615317
     /*  615317 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(615389), // Rule ID 5627 //
     /*  615322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  615336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  615339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  615357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  615371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615387 */     GIR_RootConstrainSelectedInstOperands,
     /*  615388 */     // GIR_Coverage, 5627,
     /*  615388 */     GIR_EraseRootFromParent_Done,
     /*  615389 */   // Label 9932: @615389
     /*  615389 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(615461), // Rule ID 5628 //
     /*  615394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  615411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615459 */     GIR_RootConstrainSelectedInstOperands,
     /*  615460 */     // GIR_Coverage, 5628,
     /*  615460 */     GIR_EraseRootFromParent_Done,
     /*  615461 */   // Label 9933: @615461
     /*  615461 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(615533), // Rule ID 5629 //
     /*  615466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  615480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  615483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  615501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  615515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615531 */     GIR_RootConstrainSelectedInstOperands,
     /*  615532 */     // GIR_Coverage, 5629,
     /*  615532 */     GIR_EraseRootFromParent_Done,
     /*  615533 */   // Label 9934: @615533
     /*  615533 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(615605), // Rule ID 5630 //
     /*  615538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  615555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  615584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615603 */     GIR_RootConstrainSelectedInstOperands,
     /*  615604 */     // GIR_Coverage, 5630,
     /*  615604 */     GIR_EraseRootFromParent_Done,
     /*  615605 */   // Label 9935: @615605
     /*  615605 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(615677), // Rule ID 5631 //
     /*  615610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  615621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  615624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  615627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  615630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  615645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  615656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  615659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615675 */     GIR_RootConstrainSelectedInstOperands,
     /*  615676 */     // GIR_Coverage, 5631,
     /*  615676 */     GIR_EraseRootFromParent_Done,
     /*  615677 */   // Label 9936: @615677
     /*  615677 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(615749), // Rule ID 5632 //
     /*  615682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  615693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  615702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  615728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  615731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615747 */     GIR_RootConstrainSelectedInstOperands,
     /*  615748 */     // GIR_Coverage, 5632,
     /*  615748 */     GIR_EraseRootFromParent_Done,
     /*  615749 */   // Label 9937: @615749
     /*  615749 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(615821), // Rule ID 5633 //
     /*  615754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  615765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  615774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  615800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  615803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615819 */     GIR_RootConstrainSelectedInstOperands,
     /*  615820 */     // GIR_Coverage, 5633,
     /*  615820 */     GIR_EraseRootFromParent_Done,
     /*  615821 */   // Label 9938: @615821
     /*  615821 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(615893), // Rule ID 5634 //
     /*  615826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  615872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  615875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615891 */     GIR_RootConstrainSelectedInstOperands,
     /*  615892 */     // GIR_Coverage, 5634,
     /*  615892 */     GIR_EraseRootFromParent_Done,
     /*  615893 */   // Label 9939: @615893
     /*  615893 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(615965), // Rule ID 5635 //
     /*  615898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  615909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  615915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  615918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  615933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  615937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  615944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  615947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  615951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  615953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  615955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615963 */     GIR_RootConstrainSelectedInstOperands,
     /*  615964 */     // GIR_Coverage, 5635,
     /*  615964 */     GIR_EraseRootFromParent_Done,
     /*  615965 */   // Label 9940: @615965
     /*  615965 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(616037), // Rule ID 5636 //
     /*  615970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  615978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  615981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  615987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  615990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  616016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616035 */     GIR_RootConstrainSelectedInstOperands,
     /*  616036 */     // GIR_Coverage, 5636,
     /*  616036 */     GIR_EraseRootFromParent_Done,
     /*  616037 */   // Label 9941: @616037
     /*  616037 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(616109), // Rule ID 5637 //
     /*  616042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  616056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  616088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616107 */     GIR_RootConstrainSelectedInstOperands,
     /*  616108 */     // GIR_Coverage, 5637,
     /*  616108 */     GIR_EraseRootFromParent_Done,
     /*  616109 */   // Label 9942: @616109
     /*  616109 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(616181), // Rule ID 5638 //
     /*  616114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  616163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616179 */     GIR_RootConstrainSelectedInstOperands,
     /*  616180 */     // GIR_Coverage, 5638,
     /*  616180 */     GIR_EraseRootFromParent_Done,
     /*  616181 */   // Label 9943: @616181
     /*  616181 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(616253), // Rule ID 5639 //
     /*  616186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  616200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  616235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616251 */     GIR_RootConstrainSelectedInstOperands,
     /*  616252 */     // GIR_Coverage, 5639,
     /*  616252 */     GIR_EraseRootFromParent_Done,
     /*  616253 */   // Label 9944: @616253
     /*  616253 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(616325), // Rule ID 5640 //
     /*  616258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616323 */     GIR_RootConstrainSelectedInstOperands,
     /*  616324 */     // GIR_Coverage, 5640,
     /*  616324 */     GIR_EraseRootFromParent_Done,
     /*  616325 */   // Label 9945: @616325
     /*  616325 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(616397), // Rule ID 5641 //
     /*  616330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  616344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616395 */     GIR_RootConstrainSelectedInstOperands,
     /*  616396 */     // GIR_Coverage, 5641,
     /*  616396 */     GIR_EraseRootFromParent_Done,
     /*  616397 */   // Label 9946: @616397
     /*  616397 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(616469), // Rule ID 5642 //
     /*  616402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  616448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616467 */     GIR_RootConstrainSelectedInstOperands,
     /*  616468 */     // GIR_Coverage, 5642,
     /*  616468 */     GIR_EraseRootFromParent_Done,
     /*  616469 */   // Label 9947: @616469
     /*  616469 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(616541), // Rule ID 5643 //
     /*  616474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  616488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  616520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  616523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616539 */     GIR_RootConstrainSelectedInstOperands,
     /*  616540 */     // GIR_Coverage, 5643,
     /*  616540 */     GIR_EraseRootFromParent_Done,
     /*  616541 */   // Label 9948: @616541
     /*  616541 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(616613), // Rule ID 5644 //
     /*  616546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  616557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  616566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  616592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616611 */     GIR_RootConstrainSelectedInstOperands,
     /*  616612 */     // GIR_Coverage, 5644,
     /*  616612 */     GIR_EraseRootFromParent_Done,
     /*  616613 */   // Label 9949: @616613
     /*  616613 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(616685), // Rule ID 5645 //
     /*  616618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  616629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  616632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  616638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  616664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616683 */     GIR_RootConstrainSelectedInstOperands,
     /*  616684 */     // GIR_Coverage, 5645,
     /*  616684 */     GIR_EraseRootFromParent_Done,
     /*  616685 */   // Label 9950: @616685
     /*  616685 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(616757), // Rule ID 5646 //
     /*  616690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  616736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616755 */     GIR_RootConstrainSelectedInstOperands,
     /*  616756 */     // GIR_Coverage, 5646,
     /*  616756 */     GIR_EraseRootFromParent_Done,
     /*  616757 */   // Label 9951: @616757
     /*  616757 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(616829), // Rule ID 5647 //
     /*  616762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  616773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  616782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  616808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616827 */     GIR_RootConstrainSelectedInstOperands,
     /*  616828 */     // GIR_Coverage, 5647,
     /*  616828 */     GIR_EraseRootFromParent_Done,
     /*  616829 */   // Label 9952: @616829
     /*  616829 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(616901), // Rule ID 5648 //
     /*  616834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  616880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616899 */     GIR_RootConstrainSelectedInstOperands,
     /*  616900 */     // GIR_Coverage, 5648,
     /*  616900 */     GIR_EraseRootFromParent_Done,
     /*  616901 */   // Label 9953: @616901
     /*  616901 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(616973), // Rule ID 5649 //
     /*  616906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  616917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  616923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  616926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  616941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  616945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  616952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  616955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  616959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  616961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  616963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616971 */     GIR_RootConstrainSelectedInstOperands,
     /*  616972 */     // GIR_Coverage, 5649,
     /*  616972 */     GIR_EraseRootFromParent_Done,
     /*  616973 */   // Label 9954: @616973
     /*  616973 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(617045), // Rule ID 5650 //
     /*  616978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  616986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  616989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  616995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  616998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  617024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  617027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617043 */     GIR_RootConstrainSelectedInstOperands,
     /*  617044 */     // GIR_Coverage, 5650,
     /*  617044 */     GIR_EraseRootFromParent_Done,
     /*  617045 */   // Label 9955: @617045
     /*  617045 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(617117), // Rule ID 5651 //
     /*  617050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  617061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  617064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  617070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  617096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  617099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617115 */     GIR_RootConstrainSelectedInstOperands,
     /*  617116 */     // GIR_Coverage, 5651,
     /*  617116 */     GIR_EraseRootFromParent_Done,
     /*  617117 */   // Label 9956: @617117
     /*  617117 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(617189), // Rule ID 5652 //
     /*  617122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617187 */     GIR_RootConstrainSelectedInstOperands,
     /*  617188 */     // GIR_Coverage, 5652,
     /*  617188 */     GIR_EraseRootFromParent_Done,
     /*  617189 */   // Label 9957: @617189
     /*  617189 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(617261), // Rule ID 5653 //
     /*  617194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  617208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617259 */     GIR_RootConstrainSelectedInstOperands,
     /*  617260 */     // GIR_Coverage, 5653,
     /*  617260 */     GIR_EraseRootFromParent_Done,
     /*  617261 */   // Label 9958: @617261
     /*  617261 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(617333), // Rule ID 5654 //
     /*  617266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617312 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617331 */     GIR_RootConstrainSelectedInstOperands,
     /*  617332 */     // GIR_Coverage, 5654,
     /*  617332 */     GIR_EraseRootFromParent_Done,
     /*  617333 */   // Label 9959: @617333
     /*  617333 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(617405), // Rule ID 5655 //
     /*  617338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  617352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617403 */     GIR_RootConstrainSelectedInstOperands,
     /*  617404 */     // GIR_Coverage, 5655,
     /*  617404 */     GIR_EraseRootFromParent_Done,
     /*  617405 */   // Label 9960: @617405
     /*  617405 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(617477), // Rule ID 5656 //
     /*  617410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  617421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  617430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617456 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  617456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617475 */     GIR_RootConstrainSelectedInstOperands,
     /*  617476 */     // GIR_Coverage, 5656,
     /*  617476 */     GIR_EraseRootFromParent_Done,
     /*  617477 */   // Label 9961: @617477
     /*  617477 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(617549), // Rule ID 5657 //
     /*  617482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  617493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  617496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  617502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617528 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  617528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617547 */     GIR_RootConstrainSelectedInstOperands,
     /*  617548 */     // GIR_Coverage, 5657,
     /*  617548 */     GIR_EraseRootFromParent_Done,
     /*  617549 */   // Label 9962: @617549
     /*  617549 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(617621), // Rule ID 5658 //
     /*  617554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  617565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  617574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617600 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617619 */     GIR_RootConstrainSelectedInstOperands,
     /*  617620 */     // GIR_Coverage, 5658,
     /*  617620 */     GIR_EraseRootFromParent_Done,
     /*  617621 */   // Label 9963: @617621
     /*  617621 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(617693), // Rule ID 5659 //
     /*  617626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  617637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  617646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  617675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617691 */     GIR_RootConstrainSelectedInstOperands,
     /*  617692 */     // GIR_Coverage, 5659,
     /*  617692 */     GIR_EraseRootFromParent_Done,
     /*  617693 */   // Label 9964: @617693
     /*  617693 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(617765), // Rule ID 5660 //
     /*  617698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617763 */     GIR_RootConstrainSelectedInstOperands,
     /*  617764 */     // GIR_Coverage, 5660,
     /*  617764 */     GIR_EraseRootFromParent_Done,
     /*  617765 */   // Label 9965: @617765
     /*  617765 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(617837), // Rule ID 5661 //
     /*  617770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  617781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  617790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  617819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617835 */     GIR_RootConstrainSelectedInstOperands,
     /*  617836 */     // GIR_Coverage, 5661,
     /*  617836 */     GIR_EraseRootFromParent_Done,
     /*  617837 */   // Label 9966: @617837
     /*  617837 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(617909), // Rule ID 5662 //
     /*  617842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  617859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617888 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  617888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617907 */     GIR_RootConstrainSelectedInstOperands,
     /*  617908 */     // GIR_Coverage, 5662,
     /*  617908 */     GIR_EraseRootFromParent_Done,
     /*  617909 */   // Label 9967: @617909
     /*  617909 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(617981), // Rule ID 5663 //
     /*  617914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  617925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  617931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  617934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  617953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  617960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  617963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  617967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  617969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  617971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617979 */     GIR_RootConstrainSelectedInstOperands,
     /*  617980 */     // GIR_Coverage, 5663,
     /*  617980 */     GIR_EraseRootFromParent_Done,
     /*  617981 */   // Label 9968: @617981
     /*  617981 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(618053), // Rule ID 5664 //
     /*  617986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  617994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  617997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  618000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618032 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618051 */     GIR_RootConstrainSelectedInstOperands,
     /*  618052 */     // GIR_Coverage, 5664,
     /*  618052 */     GIR_EraseRootFromParent_Done,
     /*  618053 */   // Label 9969: @618053
     /*  618053 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(618125), // Rule ID 5665 //
     /*  618058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  618072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618123 */     GIR_RootConstrainSelectedInstOperands,
     /*  618124 */     // GIR_Coverage, 5665,
     /*  618124 */     GIR_EraseRootFromParent_Done,
     /*  618125 */   // Label 9970: @618125
     /*  618125 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(618197), // Rule ID 5666 //
     /*  618130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618195 */     GIR_RootConstrainSelectedInstOperands,
     /*  618196 */     // GIR_Coverage, 5666,
     /*  618196 */     GIR_EraseRootFromParent_Done,
     /*  618197 */   // Label 9971: @618197
     /*  618197 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(618269), // Rule ID 5667 //
     /*  618202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  618216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618267 */     GIR_RootConstrainSelectedInstOperands,
     /*  618268 */     // GIR_Coverage, 5667,
     /*  618268 */     GIR_EraseRootFromParent_Done,
     /*  618269 */   // Label 9972: @618269
     /*  618269 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(618341), // Rule ID 5668 //
     /*  618274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  618285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  618294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  618320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618339 */     GIR_RootConstrainSelectedInstOperands,
     /*  618340 */     // GIR_Coverage, 5668,
     /*  618340 */     GIR_EraseRootFromParent_Done,
     /*  618341 */   // Label 9973: @618341
     /*  618341 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(618413), // Rule ID 5669 //
     /*  618346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  618357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  618360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  618366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  618392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618411 */     GIR_RootConstrainSelectedInstOperands,
     /*  618412 */     // GIR_Coverage, 5669,
     /*  618412 */     GIR_EraseRootFromParent_Done,
     /*  618413 */   // Label 9974: @618413
     /*  618413 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(618485), // Rule ID 5670 //
     /*  618418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  618429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  618438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618483 */     GIR_RootConstrainSelectedInstOperands,
     /*  618484 */     // GIR_Coverage, 5670,
     /*  618484 */     GIR_EraseRootFromParent_Done,
     /*  618485 */   // Label 9975: @618485
     /*  618485 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(618557), // Rule ID 5671 //
     /*  618490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  618501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  618504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  618510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  618521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  618539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618555 */     GIR_RootConstrainSelectedInstOperands,
     /*  618556 */     // GIR_Coverage, 5671,
     /*  618556 */     GIR_EraseRootFromParent_Done,
     /*  618557 */   // Label 9976: @618557
     /*  618557 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(618629), // Rule ID 5672 //
     /*  618562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618627 */     GIR_RootConstrainSelectedInstOperands,
     /*  618628 */     // GIR_Coverage, 5672,
     /*  618628 */     GIR_EraseRootFromParent_Done,
     /*  618629 */   // Label 9977: @618629
     /*  618629 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(618701), // Rule ID 5673 //
     /*  618634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  618645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  618654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  618683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618699 */     GIR_RootConstrainSelectedInstOperands,
     /*  618700 */     // GIR_Coverage, 5673,
     /*  618700 */     GIR_EraseRootFromParent_Done,
     /*  618701 */   // Label 9978: @618701
     /*  618701 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(618773), // Rule ID 5674 //
     /*  618706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  618723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  618752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618771 */     GIR_RootConstrainSelectedInstOperands,
     /*  618772 */     // GIR_Coverage, 5674,
     /*  618772 */     GIR_EraseRootFromParent_Done,
     /*  618773 */   // Label 9979: @618773
     /*  618773 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(618845), // Rule ID 5675 //
     /*  618778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  618786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  618789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  618795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  618798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  618817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  618824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  618827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  618831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  618833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  618835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618843 */     GIR_RootConstrainSelectedInstOperands,
     /*  618844 */     // GIR_Coverage, 5675,
     /*  618844 */     GIR_EraseRootFromParent_Done,
     /*  618845 */   // Label 9980: @618845
     /*  618845 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(618920), // Rule ID 5764 //
     /*  618850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  618870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  618899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618918 */     GIR_RootConstrainSelectedInstOperands,
     /*  618919 */     // GIR_Coverage, 5764,
     /*  618919 */     GIR_EraseRootFromParent_Done,
     /*  618920 */   // Label 9981: @618920
     /*  618920 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(618995), // Rule ID 5765 //
     /*  618925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  618945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  618974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618993 */     GIR_RootConstrainSelectedInstOperands,
     /*  618994 */     // GIR_Coverage, 5765,
     /*  618994 */     GIR_EraseRootFromParent_Done,
     /*  618995 */   // Label 9982: @618995
     /*  618995 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(619070), // Rule ID 5768 //
     /*  619000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  619020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619068 */     GIR_RootConstrainSelectedInstOperands,
     /*  619069 */     // GIR_Coverage, 5768,
     /*  619069 */     GIR_EraseRootFromParent_Done,
     /*  619070 */   // Label 9983: @619070
     /*  619070 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(619145), // Rule ID 5769 //
     /*  619075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  619086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  619089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  619092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  619095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619143 */     GIR_RootConstrainSelectedInstOperands,
     /*  619144 */     // GIR_Coverage, 5769,
     /*  619144 */     GIR_EraseRootFromParent_Done,
     /*  619145 */   // Label 9984: @619145
     /*  619145 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(619220), // Rule ID 5772 //
     /*  619150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  619170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619218 */     GIR_RootConstrainSelectedInstOperands,
     /*  619219 */     // GIR_Coverage, 5772,
     /*  619219 */     GIR_EraseRootFromParent_Done,
     /*  619220 */   // Label 9985: @619220
     /*  619220 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(619295), // Rule ID 5773 //
     /*  619225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  619236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  619239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  619242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  619245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619293 */     GIR_RootConstrainSelectedInstOperands,
     /*  619294 */     // GIR_Coverage, 5773,
     /*  619294 */     GIR_EraseRootFromParent_Done,
     /*  619295 */   // Label 9986: @619295
     /*  619295 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(619370), // Rule ID 5776 //
     /*  619300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  619320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619368 */     GIR_RootConstrainSelectedInstOperands,
     /*  619369 */     // GIR_Coverage, 5776,
     /*  619369 */     GIR_EraseRootFromParent_Done,
     /*  619370 */   // Label 9987: @619370
     /*  619370 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(619445), // Rule ID 5777 //
     /*  619375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  619386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  619389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  619392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  619395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  619424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619443 */     GIR_RootConstrainSelectedInstOperands,
     /*  619444 */     // GIR_Coverage, 5777,
     /*  619444 */     GIR_EraseRootFromParent_Done,
     /*  619445 */   // Label 9988: @619445
     /*  619445 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(619520), // Rule ID 5780 //
     /*  619450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  619470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619518 */     GIR_RootConstrainSelectedInstOperands,
     /*  619519 */     // GIR_Coverage, 5780,
     /*  619519 */     GIR_EraseRootFromParent_Done,
     /*  619520 */   // Label 9989: @619520
     /*  619520 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(619595), // Rule ID 5781 //
     /*  619525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  619536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  619539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  619542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  619545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619593 */     GIR_RootConstrainSelectedInstOperands,
     /*  619594 */     // GIR_Coverage, 5781,
     /*  619594 */     GIR_EraseRootFromParent_Done,
     /*  619595 */   // Label 9990: @619595
     /*  619595 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(619670), // Rule ID 5784 //
     /*  619600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  619620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619668 */     GIR_RootConstrainSelectedInstOperands,
     /*  619669 */     // GIR_Coverage, 5784,
     /*  619669 */     GIR_EraseRootFromParent_Done,
     /*  619670 */   // Label 9991: @619670
     /*  619670 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(619745), // Rule ID 5785 //
     /*  619675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  619695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  619724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619743 */     GIR_RootConstrainSelectedInstOperands,
     /*  619744 */     // GIR_Coverage, 5785,
     /*  619744 */     GIR_EraseRootFromParent_Done,
     /*  619745 */   // Label 9992: @619745
     /*  619745 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(619820), // Rule ID 5788 //
     /*  619750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  619770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619818 */     GIR_RootConstrainSelectedInstOperands,
     /*  619819 */     // GIR_Coverage, 5788,
     /*  619819 */     GIR_EraseRootFromParent_Done,
     /*  619820 */   // Label 9993: @619820
     /*  619820 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(619895), // Rule ID 5789 //
     /*  619825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  619845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619893 */     GIR_RootConstrainSelectedInstOperands,
     /*  619894 */     // GIR_Coverage, 5789,
     /*  619894 */     GIR_EraseRootFromParent_Done,
     /*  619895 */   // Label 9994: @619895
     /*  619895 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(619970), // Rule ID 5792 //
     /*  619900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  619920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  619949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619968 */     GIR_RootConstrainSelectedInstOperands,
     /*  619969 */     // GIR_Coverage, 5792,
     /*  619969 */     GIR_EraseRootFromParent_Done,
     /*  619970 */   // Label 9995: @619970
     /*  619970 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(620045), // Rule ID 5793 //
     /*  619975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  619995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620043 */     GIR_RootConstrainSelectedInstOperands,
     /*  620044 */     // GIR_Coverage, 5793,
     /*  620044 */     GIR_EraseRootFromParent_Done,
     /*  620045 */   // Label 9996: @620045
     /*  620045 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(620120), // Rule ID 5796 //
     /*  620050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  620070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620118 */     GIR_RootConstrainSelectedInstOperands,
     /*  620119 */     // GIR_Coverage, 5796,
     /*  620119 */     GIR_EraseRootFromParent_Done,
     /*  620120 */   // Label 9997: @620120
     /*  620120 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(620195), // Rule ID 5797 //
     /*  620125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  620136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  620139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  620142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  620145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620193 */     GIR_RootConstrainSelectedInstOperands,
     /*  620194 */     // GIR_Coverage, 5797,
     /*  620194 */     GIR_EraseRootFromParent_Done,
     /*  620195 */   // Label 9998: @620195
     /*  620195 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(620270), // Rule ID 5800 //
     /*  620200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620268 */     GIR_RootConstrainSelectedInstOperands,
     /*  620269 */     // GIR_Coverage, 5800,
     /*  620269 */     GIR_EraseRootFromParent_Done,
     /*  620270 */   // Label 9999: @620270
     /*  620270 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(620345), // Rule ID 5801 //
     /*  620275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  620286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  620289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  620292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  620295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  620314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  620324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620343 */     GIR_RootConstrainSelectedInstOperands,
     /*  620344 */     // GIR_Coverage, 5801,
     /*  620344 */     GIR_EraseRootFromParent_Done,
     /*  620345 */   // Label 10000: @620345
     /*  620345 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(620420), // Rule ID 5804 //
     /*  620350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  620370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620418 */     GIR_RootConstrainSelectedInstOperands,
     /*  620419 */     // GIR_Coverage, 5804,
     /*  620419 */     GIR_EraseRootFromParent_Done,
     /*  620420 */   // Label 10001: @620420
     /*  620420 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(620495), // Rule ID 5805 //
     /*  620425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  620436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  620439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  620442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  620445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620493 */     GIR_RootConstrainSelectedInstOperands,
     /*  620494 */     // GIR_Coverage, 5805,
     /*  620494 */     GIR_EraseRootFromParent_Done,
     /*  620495 */   // Label 10002: @620495
     /*  620495 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(620570), // Rule ID 5808 //
     /*  620500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  620520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620568 */     GIR_RootConstrainSelectedInstOperands,
     /*  620569 */     // GIR_Coverage, 5808,
     /*  620569 */     GIR_EraseRootFromParent_Done,
     /*  620570 */   // Label 10003: @620570
     /*  620570 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(620645), // Rule ID 5809 //
     /*  620575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  620595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620643 */     GIR_RootConstrainSelectedInstOperands,
     /*  620644 */     // GIR_Coverage, 5809,
     /*  620644 */     GIR_EraseRootFromParent_Done,
     /*  620645 */   // Label 10004: @620645
     /*  620645 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(620720), // Rule ID 5812 //
     /*  620650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  620670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  620699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620718 */     GIR_RootConstrainSelectedInstOperands,
     /*  620719 */     // GIR_Coverage, 5812,
     /*  620719 */     GIR_EraseRootFromParent_Done,
     /*  620720 */   // Label 10005: @620720
     /*  620720 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(620795), // Rule ID 5813 //
     /*  620725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  620745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  620774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620793 */     GIR_RootConstrainSelectedInstOperands,
     /*  620794 */     // GIR_Coverage, 5813,
     /*  620794 */     GIR_EraseRootFromParent_Done,
     /*  620795 */   // Label 10006: @620795
     /*  620795 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(620870), // Rule ID 5816 //
     /*  620800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  620820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620868 */     GIR_RootConstrainSelectedInstOperands,
     /*  620869 */     // GIR_Coverage, 5816,
     /*  620869 */     GIR_EraseRootFromParent_Done,
     /*  620870 */   // Label 10007: @620870
     /*  620870 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(620945), // Rule ID 5817 //
     /*  620875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  620895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  620924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620943 */     GIR_RootConstrainSelectedInstOperands,
     /*  620944 */     // GIR_Coverage, 5817,
     /*  620944 */     GIR_EraseRootFromParent_Done,
     /*  620945 */   // Label 10008: @620945
     /*  620945 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(621020), // Rule ID 5820 //
     /*  620950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  620970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  620999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621018 */     GIR_RootConstrainSelectedInstOperands,
     /*  621019 */     // GIR_Coverage, 5820,
     /*  621019 */     GIR_EraseRootFromParent_Done,
     /*  621020 */   // Label 10009: @621020
     /*  621020 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(621095), // Rule ID 5821 //
     /*  621025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  621036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  621039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  621042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  621045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621093 */     GIR_RootConstrainSelectedInstOperands,
     /*  621094 */     // GIR_Coverage, 5821,
     /*  621094 */     GIR_EraseRootFromParent_Done,
     /*  621095 */   // Label 10010: @621095
     /*  621095 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(621170), // Rule ID 5824 //
     /*  621100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  621120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621168 */     GIR_RootConstrainSelectedInstOperands,
     /*  621169 */     // GIR_Coverage, 5824,
     /*  621169 */     GIR_EraseRootFromParent_Done,
     /*  621170 */   // Label 10011: @621170
     /*  621170 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(621245), // Rule ID 5825 //
     /*  621175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  621186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  621189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  621192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  621195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621243 */     GIR_RootConstrainSelectedInstOperands,
     /*  621244 */     // GIR_Coverage, 5825,
     /*  621244 */     GIR_EraseRootFromParent_Done,
     /*  621245 */   // Label 10012: @621245
     /*  621245 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(621320), // Rule ID 5828 //
     /*  621250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  621270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621318 */     GIR_RootConstrainSelectedInstOperands,
     /*  621319 */     // GIR_Coverage, 5828,
     /*  621319 */     GIR_EraseRootFromParent_Done,
     /*  621320 */   // Label 10013: @621320
     /*  621320 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(621395), // Rule ID 5829 //
     /*  621325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  621336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  621339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  621342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  621345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621393 */     GIR_RootConstrainSelectedInstOperands,
     /*  621394 */     // GIR_Coverage, 5829,
     /*  621394 */     GIR_EraseRootFromParent_Done,
     /*  621395 */   // Label 10014: @621395
     /*  621395 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(621470), // Rule ID 5832 //
     /*  621400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  621420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621468 */     GIR_RootConstrainSelectedInstOperands,
     /*  621469 */     // GIR_Coverage, 5832,
     /*  621469 */     GIR_EraseRootFromParent_Done,
     /*  621470 */   // Label 10015: @621470
     /*  621470 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(621545), // Rule ID 5833 //
     /*  621475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  621486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  621489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  621492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  621495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621543 */     GIR_RootConstrainSelectedInstOperands,
     /*  621544 */     // GIR_Coverage, 5833,
     /*  621544 */     GIR_EraseRootFromParent_Done,
     /*  621545 */   // Label 10016: @621545
     /*  621545 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(621620), // Rule ID 5836 //
     /*  621550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  621570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621618 */     GIR_RootConstrainSelectedInstOperands,
     /*  621619 */     // GIR_Coverage, 5836,
     /*  621619 */     GIR_EraseRootFromParent_Done,
     /*  621620 */   // Label 10017: @621620
     /*  621620 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(621695), // Rule ID 5837 //
     /*  621625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  621645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  621674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621693 */     GIR_RootConstrainSelectedInstOperands,
     /*  621694 */     // GIR_Coverage, 5837,
     /*  621694 */     GIR_EraseRootFromParent_Done,
     /*  621695 */   // Label 10018: @621695
     /*  621695 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(621770), // Rule ID 5840 //
     /*  621700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  621720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621768 */     GIR_RootConstrainSelectedInstOperands,
     /*  621769 */     // GIR_Coverage, 5840,
     /*  621769 */     GIR_EraseRootFromParent_Done,
     /*  621770 */   // Label 10019: @621770
     /*  621770 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(621845), // Rule ID 5841 //
     /*  621775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  621795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  621824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621843 */     GIR_RootConstrainSelectedInstOperands,
     /*  621844 */     // GIR_Coverage, 5841,
     /*  621844 */     GIR_EraseRootFromParent_Done,
     /*  621845 */   // Label 10020: @621845
     /*  621845 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(621920), // Rule ID 5844 //
     /*  621850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621918 */     GIR_RootConstrainSelectedInstOperands,
     /*  621919 */     // GIR_Coverage, 5844,
     /*  621919 */     GIR_EraseRootFromParent_Done,
     /*  621920 */   // Label 10021: @621920
     /*  621920 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(621995), // Rule ID 5845 //
     /*  621925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  621945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  621974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621993 */     GIR_RootConstrainSelectedInstOperands,
     /*  621994 */     // GIR_Coverage, 5845,
     /*  621994 */     GIR_EraseRootFromParent_Done,
     /*  621995 */   // Label 10022: @621995
     /*  621995 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(622070), // Rule ID 5848 //
     /*  622000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  622003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  622020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  622046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  622049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622068 */     GIR_RootConstrainSelectedInstOperands,
     /*  622069 */     // GIR_Coverage, 5848,
     /*  622069 */     GIR_EraseRootFromParent_Done,
     /*  622070 */   // Label 10023: @622070
     /*  622070 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(622145), // Rule ID 5849 //
     /*  622075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  622078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  622086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  622089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  622092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  622095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  622121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  622124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622143 */     GIR_RootConstrainSelectedInstOperands,
     /*  622144 */     // GIR_Coverage, 5849,
     /*  622144 */     GIR_EraseRootFromParent_Done,
     /*  622145 */   // Label 10024: @622145
     /*  622145 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(622220), // Rule ID 5852 //
     /*  622150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  622199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622218 */     GIR_RootConstrainSelectedInstOperands,
     /*  622219 */     // GIR_Coverage, 5852,
     /*  622219 */     GIR_EraseRootFromParent_Done,
     /*  622220 */   // Label 10025: @622220
     /*  622220 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(622295), // Rule ID 5853 //
     /*  622225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  622236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  622239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  622242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  622274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622293 */     GIR_RootConstrainSelectedInstOperands,
     /*  622294 */     // GIR_Coverage, 5853,
     /*  622294 */     GIR_EraseRootFromParent_Done,
     /*  622295 */   // Label 10026: @622295
     /*  622295 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(622370), // Rule ID 5856 //
     /*  622300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622368 */     GIR_RootConstrainSelectedInstOperands,
     /*  622369 */     // GIR_Coverage, 5856,
     /*  622369 */     GIR_EraseRootFromParent_Done,
     /*  622370 */   // Label 10027: @622370
     /*  622370 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(622445), // Rule ID 5857 //
     /*  622375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  622386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  622389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  622392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622443 */     GIR_RootConstrainSelectedInstOperands,
     /*  622444 */     // GIR_Coverage, 5857,
     /*  622444 */     GIR_EraseRootFromParent_Done,
     /*  622445 */   // Label 10028: @622445
     /*  622445 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(622520), // Rule ID 5860 //
     /*  622450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622518 */     GIR_RootConstrainSelectedInstOperands,
     /*  622519 */     // GIR_Coverage, 5860,
     /*  622519 */     GIR_EraseRootFromParent_Done,
     /*  622520 */   // Label 10029: @622520
     /*  622520 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(622595), // Rule ID 5861 //
     /*  622525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  622536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  622539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  622542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622593 */     GIR_RootConstrainSelectedInstOperands,
     /*  622594 */     // GIR_Coverage, 5861,
     /*  622594 */     GIR_EraseRootFromParent_Done,
     /*  622595 */   // Label 10030: @622595
     /*  622595 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(622670), // Rule ID 5864 //
     /*  622600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622668 */     GIR_RootConstrainSelectedInstOperands,
     /*  622669 */     // GIR_Coverage, 5864,
     /*  622669 */     GIR_EraseRootFromParent_Done,
     /*  622670 */   // Label 10031: @622670
     /*  622670 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(622745), // Rule ID 5865 //
     /*  622675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  622724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622743 */     GIR_RootConstrainSelectedInstOperands,
     /*  622744 */     // GIR_Coverage, 5865,
     /*  622744 */     GIR_EraseRootFromParent_Done,
     /*  622745 */   // Label 10032: @622745
     /*  622745 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(622820), // Rule ID 5868 //
     /*  622750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622818 */     GIR_RootConstrainSelectedInstOperands,
     /*  622819 */     // GIR_Coverage, 5868,
     /*  622819 */     GIR_EraseRootFromParent_Done,
     /*  622820 */   // Label 10033: @622820
     /*  622820 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(622895), // Rule ID 5869 //
     /*  622825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622893 */     GIR_RootConstrainSelectedInstOperands,
     /*  622894 */     // GIR_Coverage, 5869,
     /*  622894 */     GIR_EraseRootFromParent_Done,
     /*  622895 */   // Label 10034: @622895
     /*  622895 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(622970), // Rule ID 5872 //
     /*  622900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  622920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  622939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  622949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622968 */     GIR_RootConstrainSelectedInstOperands,
     /*  622969 */     // GIR_Coverage, 5872,
     /*  622969 */     GIR_EraseRootFromParent_Done,
     /*  622970 */   // Label 10035: @622970
     /*  622970 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(623045), // Rule ID 5873 //
     /*  622975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  622983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  622995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  623024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623043 */     GIR_RootConstrainSelectedInstOperands,
     /*  623044 */     // GIR_Coverage, 5873,
     /*  623044 */     GIR_EraseRootFromParent_Done,
     /*  623045 */   // Label 10036: @623045
     /*  623045 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(623120), // Rule ID 5876 //
     /*  623050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623118 */     GIR_RootConstrainSelectedInstOperands,
     /*  623119 */     // GIR_Coverage, 5876,
     /*  623119 */     GIR_EraseRootFromParent_Done,
     /*  623120 */   // Label 10037: @623120
     /*  623120 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(623195), // Rule ID 5877 //
     /*  623125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  623136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  623139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  623142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623193 */     GIR_RootConstrainSelectedInstOperands,
     /*  623194 */     // GIR_Coverage, 5877,
     /*  623194 */     GIR_EraseRootFromParent_Done,
     /*  623195 */   // Label 10038: @623195
     /*  623195 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(623270), // Rule ID 5880 //
     /*  623200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623268 */     GIR_RootConstrainSelectedInstOperands,
     /*  623269 */     // GIR_Coverage, 5880,
     /*  623269 */     GIR_EraseRootFromParent_Done,
     /*  623270 */   // Label 10039: @623270
     /*  623270 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(623345), // Rule ID 5881 //
     /*  623275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  623286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  623289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  623292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623343 */     GIR_RootConstrainSelectedInstOperands,
     /*  623344 */     // GIR_Coverage, 5881,
     /*  623344 */     GIR_EraseRootFromParent_Done,
     /*  623345 */   // Label 10040: @623345
     /*  623345 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(623420), // Rule ID 5884 //
     /*  623350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623418 */     GIR_RootConstrainSelectedInstOperands,
     /*  623419 */     // GIR_Coverage, 5884,
     /*  623419 */     GIR_EraseRootFromParent_Done,
     /*  623420 */   // Label 10041: @623420
     /*  623420 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(623495), // Rule ID 5885 //
     /*  623425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  623436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  623439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  623442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623493 */     GIR_RootConstrainSelectedInstOperands,
     /*  623494 */     // GIR_Coverage, 5885,
     /*  623494 */     GIR_EraseRootFromParent_Done,
     /*  623495 */   // Label 10042: @623495
     /*  623495 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(623570), // Rule ID 5888 //
     /*  623500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623568 */     GIR_RootConstrainSelectedInstOperands,
     /*  623569 */     // GIR_Coverage, 5888,
     /*  623569 */     GIR_EraseRootFromParent_Done,
     /*  623570 */   // Label 10043: @623570
     /*  623570 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(623645), // Rule ID 5889 //
     /*  623575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  623624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623643 */     GIR_RootConstrainSelectedInstOperands,
     /*  623644 */     // GIR_Coverage, 5889,
     /*  623644 */     GIR_EraseRootFromParent_Done,
     /*  623645 */   // Label 10044: @623645
     /*  623645 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(623720), // Rule ID 5892 //
     /*  623650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  623699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623718 */     GIR_RootConstrainSelectedInstOperands,
     /*  623719 */     // GIR_Coverage, 5892,
     /*  623719 */     GIR_EraseRootFromParent_Done,
     /*  623720 */   // Label 10045: @623720
     /*  623720 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(623795), // Rule ID 5893 //
     /*  623725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  623774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623793 */     GIR_RootConstrainSelectedInstOperands,
     /*  623794 */     // GIR_Coverage, 5893,
     /*  623794 */     GIR_EraseRootFromParent_Done,
     /*  623795 */   // Label 10046: @623795
     /*  623795 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(623870), // Rule ID 5896 //
     /*  623800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  623849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623868 */     GIR_RootConstrainSelectedInstOperands,
     /*  623869 */     // GIR_Coverage, 5896,
     /*  623869 */     GIR_EraseRootFromParent_Done,
     /*  623870 */   // Label 10047: @623870
     /*  623870 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(623945), // Rule ID 5897 //
     /*  623875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  623895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  623924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623943 */     GIR_RootConstrainSelectedInstOperands,
     /*  623944 */     // GIR_Coverage, 5897,
     /*  623944 */     GIR_EraseRootFromParent_Done,
     /*  623945 */   // Label 10048: @623945
     /*  623945 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(624020), // Rule ID 5900 //
     /*  623950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  623958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  623970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  623989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  623999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624018 */     GIR_RootConstrainSelectedInstOperands,
     /*  624019 */     // GIR_Coverage, 5900,
     /*  624019 */     GIR_EraseRootFromParent_Done,
     /*  624020 */   // Label 10049: @624020
     /*  624020 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(624095), // Rule ID 5901 //
     /*  624025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  624036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  624039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  624042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624093 */     GIR_RootConstrainSelectedInstOperands,
     /*  624094 */     // GIR_Coverage, 5901,
     /*  624094 */     GIR_EraseRootFromParent_Done,
     /*  624095 */   // Label 10050: @624095
     /*  624095 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(624170), // Rule ID 5904 //
     /*  624100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624168 */     GIR_RootConstrainSelectedInstOperands,
     /*  624169 */     // GIR_Coverage, 5904,
     /*  624169 */     GIR_EraseRootFromParent_Done,
     /*  624170 */   // Label 10051: @624170
     /*  624170 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(624245), // Rule ID 5905 //
     /*  624175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  624186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  624189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  624192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624243 */     GIR_RootConstrainSelectedInstOperands,
     /*  624244 */     // GIR_Coverage, 5905,
     /*  624244 */     GIR_EraseRootFromParent_Done,
     /*  624245 */   // Label 10052: @624245
     /*  624245 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(624320), // Rule ID 5908 //
     /*  624250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624318 */     GIR_RootConstrainSelectedInstOperands,
     /*  624319 */     // GIR_Coverage, 5908,
     /*  624319 */     GIR_EraseRootFromParent_Done,
     /*  624320 */   // Label 10053: @624320
     /*  624320 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(624395), // Rule ID 5909 //
     /*  624325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  624336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  624339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  624342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624393 */     GIR_RootConstrainSelectedInstOperands,
     /*  624394 */     // GIR_Coverage, 5909,
     /*  624394 */     GIR_EraseRootFromParent_Done,
     /*  624395 */   // Label 10054: @624395
     /*  624395 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(624470), // Rule ID 5912 //
     /*  624400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624468 */     GIR_RootConstrainSelectedInstOperands,
     /*  624469 */     // GIR_Coverage, 5912,
     /*  624469 */     GIR_EraseRootFromParent_Done,
     /*  624470 */   // Label 10055: @624470
     /*  624470 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(624545), // Rule ID 5913 //
     /*  624475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  624486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  624489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  624492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624543 */     GIR_RootConstrainSelectedInstOperands,
     /*  624544 */     // GIR_Coverage, 5913,
     /*  624544 */     GIR_EraseRootFromParent_Done,
     /*  624545 */   // Label 10056: @624545
     /*  624545 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(624620), // Rule ID 5916 //
     /*  624550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624618 */     GIR_RootConstrainSelectedInstOperands,
     /*  624619 */     // GIR_Coverage, 5916,
     /*  624619 */     GIR_EraseRootFromParent_Done,
     /*  624620 */   // Label 10057: @624620
     /*  624620 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(624695), // Rule ID 5917 //
     /*  624625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  624674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624693 */     GIR_RootConstrainSelectedInstOperands,
     /*  624694 */     // GIR_Coverage, 5917,
     /*  624694 */     GIR_EraseRootFromParent_Done,
     /*  624695 */   // Label 10058: @624695
     /*  624695 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(624770), // Rule ID 5920 //
     /*  624700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624768 */     GIR_RootConstrainSelectedInstOperands,
     /*  624769 */     // GIR_Coverage, 5920,
     /*  624769 */     GIR_EraseRootFromParent_Done,
     /*  624770 */   // Label 10059: @624770
     /*  624770 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(624845), // Rule ID 5921 //
     /*  624775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  624824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624843 */     GIR_RootConstrainSelectedInstOperands,
     /*  624844 */     // GIR_Coverage, 5921,
     /*  624844 */     GIR_EraseRootFromParent_Done,
     /*  624845 */   // Label 10060: @624845
     /*  624845 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(624920), // Rule ID 5924 //
     /*  624850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624918 */     GIR_RootConstrainSelectedInstOperands,
     /*  624919 */     // GIR_Coverage, 5924,
     /*  624919 */     GIR_EraseRootFromParent_Done,
     /*  624920 */   // Label 10061: @624920
     /*  624920 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(624995), // Rule ID 5925 //
     /*  624925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  624933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  624974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624993 */     GIR_RootConstrainSelectedInstOperands,
     /*  624994 */     // GIR_Coverage, 5925,
     /*  624994 */     GIR_EraseRootFromParent_Done,
     /*  624995 */   // Label 10062: @624995
     /*  624995 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(625070), // Rule ID 5928 //
     /*  625000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  625049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625068 */     GIR_RootConstrainSelectedInstOperands,
     /*  625069 */     // GIR_Coverage, 5928,
     /*  625069 */     GIR_EraseRootFromParent_Done,
     /*  625070 */   // Label 10063: @625070
     /*  625070 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(625145), // Rule ID 5929 //
     /*  625075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  625086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  625089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  625092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  625124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625143 */     GIR_RootConstrainSelectedInstOperands,
     /*  625144 */     // GIR_Coverage, 5929,
     /*  625144 */     GIR_EraseRootFromParent_Done,
     /*  625145 */   // Label 10064: @625145
     /*  625145 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(625220), // Rule ID 5932 //
     /*  625150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  625199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625218 */     GIR_RootConstrainSelectedInstOperands,
     /*  625219 */     // GIR_Coverage, 5932,
     /*  625219 */     GIR_EraseRootFromParent_Done,
     /*  625220 */   // Label 10065: @625220
     /*  625220 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(625295), // Rule ID 5933 //
     /*  625225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  625236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  625239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  625242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  625260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  625274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625293 */     GIR_RootConstrainSelectedInstOperands,
     /*  625294 */     // GIR_Coverage, 5933,
     /*  625294 */     GIR_EraseRootFromParent_Done,
     /*  625295 */   // Label 10066: @625295
     /*  625295 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(625370), // Rule ID 5936 //
     /*  625300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  625349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625368 */     GIR_RootConstrainSelectedInstOperands,
     /*  625369 */     // GIR_Coverage, 5936,
     /*  625369 */     GIR_EraseRootFromParent_Done,
     /*  625370 */   // Label 10067: @625370
     /*  625370 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(625445), // Rule ID 5937 //
     /*  625375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  625383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  625386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  625389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  625392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  625410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  625424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625443 */     GIR_RootConstrainSelectedInstOperands,
     /*  625444 */     // GIR_Coverage, 5937,
     /*  625444 */     GIR_EraseRootFromParent_Done,
     /*  625445 */   // Label 10068: @625445
     /*  625445 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(625520), // Rule ID 6028 //
     /*  625450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  625470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  625499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625518 */     GIR_RootConstrainSelectedInstOperands,
     /*  625519 */     // GIR_Coverage, 6028,
     /*  625519 */     GIR_EraseRootFromParent_Done,
     /*  625520 */   // Label 10069: @625520
     /*  625520 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(625595), // Rule ID 6029 //
     /*  625525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  625536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  625539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  625542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  625545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  625574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625593 */     GIR_RootConstrainSelectedInstOperands,
     /*  625594 */     // GIR_Coverage, 6029,
     /*  625594 */     GIR_EraseRootFromParent_Done,
     /*  625595 */   // Label 10070: @625595
     /*  625595 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(625670), // Rule ID 6032 //
     /*  625600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  625620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625668 */     GIR_RootConstrainSelectedInstOperands,
     /*  625669 */     // GIR_Coverage, 6032,
     /*  625669 */     GIR_EraseRootFromParent_Done,
     /*  625670 */   // Label 10071: @625670
     /*  625670 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(625745), // Rule ID 6033 //
     /*  625675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  625695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625743 */     GIR_RootConstrainSelectedInstOperands,
     /*  625744 */     // GIR_Coverage, 6033,
     /*  625744 */     GIR_EraseRootFromParent_Done,
     /*  625745 */   // Label 10072: @625745
     /*  625745 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(625820), // Rule ID 6036 //
     /*  625750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  625770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  625799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625818 */     GIR_RootConstrainSelectedInstOperands,
     /*  625819 */     // GIR_Coverage, 6036,
     /*  625819 */     GIR_EraseRootFromParent_Done,
     /*  625820 */   // Label 10073: @625820
     /*  625820 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(625895), // Rule ID 6037 //
     /*  625825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  625845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  625874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625893 */     GIR_RootConstrainSelectedInstOperands,
     /*  625894 */     // GIR_Coverage, 6037,
     /*  625894 */     GIR_EraseRootFromParent_Done,
     /*  625895 */   // Label 10074: @625895
     /*  625895 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(625970), // Rule ID 6040 //
     /*  625900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  625920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  625949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625968 */     GIR_RootConstrainSelectedInstOperands,
     /*  625969 */     // GIR_Coverage, 6040,
     /*  625969 */     GIR_EraseRootFromParent_Done,
     /*  625970 */   // Label 10075: @625970
     /*  625970 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(626045), // Rule ID 6041 //
     /*  625975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  625995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  626024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626043 */     GIR_RootConstrainSelectedInstOperands,
     /*  626044 */     // GIR_Coverage, 6041,
     /*  626044 */     GIR_EraseRootFromParent_Done,
     /*  626045 */   // Label 10076: @626045
     /*  626045 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(626120), // Rule ID 6044 //
     /*  626050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  626070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626118 */     GIR_RootConstrainSelectedInstOperands,
     /*  626119 */     // GIR_Coverage, 6044,
     /*  626119 */     GIR_EraseRootFromParent_Done,
     /*  626120 */   // Label 10077: @626120
     /*  626120 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(626195), // Rule ID 6045 //
     /*  626125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  626136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  626139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  626142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  626145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626193 */     GIR_RootConstrainSelectedInstOperands,
     /*  626194 */     // GIR_Coverage, 6045,
     /*  626194 */     GIR_EraseRootFromParent_Done,
     /*  626195 */   // Label 10078: @626195
     /*  626195 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(626270), // Rule ID 6048 //
     /*  626200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  626220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626268 */     GIR_RootConstrainSelectedInstOperands,
     /*  626269 */     // GIR_Coverage, 6048,
     /*  626269 */     GIR_EraseRootFromParent_Done,
     /*  626270 */   // Label 10079: @626270
     /*  626270 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(626345), // Rule ID 6049 //
     /*  626275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  626286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  626289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  626292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  626295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  626324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626343 */     GIR_RootConstrainSelectedInstOperands,
     /*  626344 */     // GIR_Coverage, 6049,
     /*  626344 */     GIR_EraseRootFromParent_Done,
     /*  626345 */   // Label 10080: @626345
     /*  626345 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(626420), // Rule ID 6052 //
     /*  626350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  626370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626418 */     GIR_RootConstrainSelectedInstOperands,
     /*  626419 */     // GIR_Coverage, 6052,
     /*  626419 */     GIR_EraseRootFromParent_Done,
     /*  626420 */   // Label 10081: @626420
     /*  626420 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(626495), // Rule ID 6053 //
     /*  626425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  626436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  626439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  626442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  626445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626493 */     GIR_RootConstrainSelectedInstOperands,
     /*  626494 */     // GIR_Coverage, 6053,
     /*  626494 */     GIR_EraseRootFromParent_Done,
     /*  626495 */   // Label 10082: @626495
     /*  626495 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(626570), // Rule ID 6056 //
     /*  626500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  626520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626568 */     GIR_RootConstrainSelectedInstOperands,
     /*  626569 */     // GIR_Coverage, 6056,
     /*  626569 */     GIR_EraseRootFromParent_Done,
     /*  626570 */   // Label 10083: @626570
     /*  626570 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(626645), // Rule ID 6057 //
     /*  626575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  626595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626643 */     GIR_RootConstrainSelectedInstOperands,
     /*  626644 */     // GIR_Coverage, 6057,
     /*  626644 */     GIR_EraseRootFromParent_Done,
     /*  626645 */   // Label 10084: @626645
     /*  626645 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(626720), // Rule ID 6060 //
     /*  626650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  626670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626718 */     GIR_RootConstrainSelectedInstOperands,
     /*  626719 */     // GIR_Coverage, 6060,
     /*  626719 */     GIR_EraseRootFromParent_Done,
     /*  626720 */   // Label 10085: @626720
     /*  626720 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(626795), // Rule ID 6061 //
     /*  626725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  626745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626793 */     GIR_RootConstrainSelectedInstOperands,
     /*  626794 */     // GIR_Coverage, 6061,
     /*  626794 */     GIR_EraseRootFromParent_Done,
     /*  626795 */   // Label 10086: @626795
     /*  626795 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(626870), // Rule ID 6064 //
     /*  626800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  626820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626868 */     GIR_RootConstrainSelectedInstOperands,
     /*  626869 */     // GIR_Coverage, 6064,
     /*  626869 */     GIR_EraseRootFromParent_Done,
     /*  626870 */   // Label 10087: @626870
     /*  626870 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(626945), // Rule ID 6065 //
     /*  626875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  626895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  626924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626943 */     GIR_RootConstrainSelectedInstOperands,
     /*  626944 */     // GIR_Coverage, 6065,
     /*  626944 */     GIR_EraseRootFromParent_Done,
     /*  626945 */   // Label 10088: @626945
     /*  626945 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(627020), // Rule ID 6068 //
     /*  626950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  626970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  626999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627018 */     GIR_RootConstrainSelectedInstOperands,
     /*  627019 */     // GIR_Coverage, 6068,
     /*  627019 */     GIR_EraseRootFromParent_Done,
     /*  627020 */   // Label 10089: @627020
     /*  627020 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(627095), // Rule ID 6069 //
     /*  627025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  627036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  627039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  627042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  627045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627093 */     GIR_RootConstrainSelectedInstOperands,
     /*  627094 */     // GIR_Coverage, 6069,
     /*  627094 */     GIR_EraseRootFromParent_Done,
     /*  627095 */   // Label 10090: @627095
     /*  627095 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(627170), // Rule ID 6072 //
     /*  627100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  627120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627168 */     GIR_RootConstrainSelectedInstOperands,
     /*  627169 */     // GIR_Coverage, 6072,
     /*  627169 */     GIR_EraseRootFromParent_Done,
     /*  627170 */   // Label 10091: @627170
     /*  627170 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(627245), // Rule ID 6073 //
     /*  627175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  627186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  627189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  627192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  627195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627243 */     GIR_RootConstrainSelectedInstOperands,
     /*  627244 */     // GIR_Coverage, 6073,
     /*  627244 */     GIR_EraseRootFromParent_Done,
     /*  627245 */   // Label 10092: @627245
     /*  627245 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(627320), // Rule ID 6076 //
     /*  627250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  627270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627318 */     GIR_RootConstrainSelectedInstOperands,
     /*  627319 */     // GIR_Coverage, 6076,
     /*  627319 */     GIR_EraseRootFromParent_Done,
     /*  627320 */   // Label 10093: @627320
     /*  627320 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(627395), // Rule ID 6077 //
     /*  627325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  627336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  627339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  627342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  627345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627393 */     GIR_RootConstrainSelectedInstOperands,
     /*  627394 */     // GIR_Coverage, 6077,
     /*  627394 */     GIR_EraseRootFromParent_Done,
     /*  627395 */   // Label 10094: @627395
     /*  627395 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(627470), // Rule ID 6080 //
     /*  627400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  627420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627468 */     GIR_RootConstrainSelectedInstOperands,
     /*  627469 */     // GIR_Coverage, 6080,
     /*  627469 */     GIR_EraseRootFromParent_Done,
     /*  627470 */   // Label 10095: @627470
     /*  627470 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(627545), // Rule ID 6081 //
     /*  627475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  627486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  627489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  627492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  627495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627543 */     GIR_RootConstrainSelectedInstOperands,
     /*  627544 */     // GIR_Coverage, 6081,
     /*  627544 */     GIR_EraseRootFromParent_Done,
     /*  627545 */   // Label 10096: @627545
     /*  627545 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(627620), // Rule ID 6084 //
     /*  627550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  627570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627618 */     GIR_RootConstrainSelectedInstOperands,
     /*  627619 */     // GIR_Coverage, 6084,
     /*  627619 */     GIR_EraseRootFromParent_Done,
     /*  627620 */   // Label 10097: @627620
     /*  627620 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(627695), // Rule ID 6085 //
     /*  627625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  627645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  627674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627693 */     GIR_RootConstrainSelectedInstOperands,
     /*  627694 */     // GIR_Coverage, 6085,
     /*  627694 */     GIR_EraseRootFromParent_Done,
     /*  627695 */   // Label 10098: @627695
     /*  627695 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(627770), // Rule ID 6088 //
     /*  627700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  627720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627768 */     GIR_RootConstrainSelectedInstOperands,
     /*  627769 */     // GIR_Coverage, 6088,
     /*  627769 */     GIR_EraseRootFromParent_Done,
     /*  627770 */   // Label 10099: @627770
     /*  627770 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(627845), // Rule ID 6089 //
     /*  627775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  627795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  627824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627843 */     GIR_RootConstrainSelectedInstOperands,
     /*  627844 */     // GIR_Coverage, 6089,
     /*  627844 */     GIR_EraseRootFromParent_Done,
     /*  627845 */   // Label 10100: @627845
     /*  627845 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(627920), // Rule ID 6092 //
     /*  627850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  627870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627918 */     GIR_RootConstrainSelectedInstOperands,
     /*  627919 */     // GIR_Coverage, 6092,
     /*  627919 */     GIR_EraseRootFromParent_Done,
     /*  627920 */   // Label 10101: @627920
     /*  627920 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(627995), // Rule ID 6093 //
     /*  627925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  627945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  627974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627993 */     GIR_RootConstrainSelectedInstOperands,
     /*  627994 */     // GIR_Coverage, 6093,
     /*  627994 */     GIR_EraseRootFromParent_Done,
     /*  627995 */   // Label 10102: @627995
     /*  627995 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(628070), // Rule ID 6096 //
     /*  628000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  628020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628068 */     GIR_RootConstrainSelectedInstOperands,
     /*  628069 */     // GIR_Coverage, 6096,
     /*  628069 */     GIR_EraseRootFromParent_Done,
     /*  628070 */   // Label 10103: @628070
     /*  628070 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(628145), // Rule ID 6097 //
     /*  628075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  628086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  628089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  628092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  628095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628143 */     GIR_RootConstrainSelectedInstOperands,
     /*  628144 */     // GIR_Coverage, 6097,
     /*  628144 */     GIR_EraseRootFromParent_Done,
     /*  628145 */   // Label 10104: @628145
     /*  628145 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(628220), // Rule ID 6100 //
     /*  628150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  628170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628218 */     GIR_RootConstrainSelectedInstOperands,
     /*  628219 */     // GIR_Coverage, 6100,
     /*  628219 */     GIR_EraseRootFromParent_Done,
     /*  628220 */   // Label 10105: @628220
     /*  628220 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(628295), // Rule ID 6101 //
     /*  628225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  628236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  628239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  628242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  628245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628293 */     GIR_RootConstrainSelectedInstOperands,
     /*  628294 */     // GIR_Coverage, 6101,
     /*  628294 */     GIR_EraseRootFromParent_Done,
     /*  628295 */   // Label 10106: @628295
     /*  628295 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(628370), // Rule ID 6104 //
     /*  628300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  628320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  628349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628368 */     GIR_RootConstrainSelectedInstOperands,
     /*  628369 */     // GIR_Coverage, 6104,
     /*  628369 */     GIR_EraseRootFromParent_Done,
     /*  628370 */   // Label 10107: @628370
     /*  628370 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(628445), // Rule ID 6105 //
     /*  628375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  628386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  628389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  628392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  628395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  628414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  628424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628443 */     GIR_RootConstrainSelectedInstOperands,
     /*  628444 */     // GIR_Coverage, 6105,
     /*  628444 */     GIR_EraseRootFromParent_Done,
     /*  628445 */   // Label 10108: @628445
     /*  628445 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(628520), // Rule ID 6108 //
     /*  628450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  628470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628518 */     GIR_RootConstrainSelectedInstOperands,
     /*  628519 */     // GIR_Coverage, 6108,
     /*  628519 */     GIR_EraseRootFromParent_Done,
     /*  628520 */   // Label 10109: @628520
     /*  628520 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(628595), // Rule ID 6109 //
     /*  628525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  628536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  628539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  628542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  628545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  628574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628593 */     GIR_RootConstrainSelectedInstOperands,
     /*  628594 */     // GIR_Coverage, 6109,
     /*  628594 */     GIR_EraseRootFromParent_Done,
     /*  628595 */   // Label 10110: @628595
     /*  628595 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(628670), // Rule ID 6112 //
     /*  628600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  628620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628668 */     GIR_RootConstrainSelectedInstOperands,
     /*  628669 */     // GIR_Coverage, 6112,
     /*  628669 */     GIR_EraseRootFromParent_Done,
     /*  628670 */   // Label 10111: @628670
     /*  628670 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(628745), // Rule ID 6113 //
     /*  628675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  628695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  628724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628743 */     GIR_RootConstrainSelectedInstOperands,
     /*  628744 */     // GIR_Coverage, 6113,
     /*  628744 */     GIR_EraseRootFromParent_Done,
     /*  628745 */   // Label 10112: @628745
     /*  628745 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(628820), // Rule ID 6116 //
     /*  628750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  628799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628818 */     GIR_RootConstrainSelectedInstOperands,
     /*  628819 */     // GIR_Coverage, 6116,
     /*  628819 */     GIR_EraseRootFromParent_Done,
     /*  628820 */   // Label 10113: @628820
     /*  628820 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(628895), // Rule ID 6117 //
     /*  628825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  628874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628893 */     GIR_RootConstrainSelectedInstOperands,
     /*  628894 */     // GIR_Coverage, 6117,
     /*  628894 */     GIR_EraseRootFromParent_Done,
     /*  628895 */   // Label 10114: @628895
     /*  628895 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(628970), // Rule ID 6120 //
     /*  628900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  628949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628968 */     GIR_RootConstrainSelectedInstOperands,
     /*  628969 */     // GIR_Coverage, 6120,
     /*  628969 */     GIR_EraseRootFromParent_Done,
     /*  628970 */   // Label 10115: @628970
     /*  628970 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(629045), // Rule ID 6121 //
     /*  628975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629043 */     GIR_RootConstrainSelectedInstOperands,
     /*  629044 */     // GIR_Coverage, 6121,
     /*  629044 */     GIR_EraseRootFromParent_Done,
     /*  629045 */   // Label 10116: @629045
     /*  629045 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(629120), // Rule ID 6124 //
     /*  629050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629118 */     GIR_RootConstrainSelectedInstOperands,
     /*  629119 */     // GIR_Coverage, 6124,
     /*  629119 */     GIR_EraseRootFromParent_Done,
     /*  629120 */   // Label 10117: @629120
     /*  629120 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(629195), // Rule ID 6125 //
     /*  629125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  629136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  629139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  629142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629193 */     GIR_RootConstrainSelectedInstOperands,
     /*  629194 */     // GIR_Coverage, 6125,
     /*  629194 */     GIR_EraseRootFromParent_Done,
     /*  629195 */   // Label 10118: @629195
     /*  629195 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(629270), // Rule ID 6128 //
     /*  629200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629268 */     GIR_RootConstrainSelectedInstOperands,
     /*  629269 */     // GIR_Coverage, 6128,
     /*  629269 */     GIR_EraseRootFromParent_Done,
     /*  629270 */   // Label 10119: @629270
     /*  629270 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(629345), // Rule ID 6129 //
     /*  629275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  629286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  629289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  629292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  629324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629343 */     GIR_RootConstrainSelectedInstOperands,
     /*  629344 */     // GIR_Coverage, 6129,
     /*  629344 */     GIR_EraseRootFromParent_Done,
     /*  629345 */   // Label 10120: @629345
     /*  629345 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(629420), // Rule ID 6132 //
     /*  629350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629418 */     GIR_RootConstrainSelectedInstOperands,
     /*  629419 */     // GIR_Coverage, 6132,
     /*  629419 */     GIR_EraseRootFromParent_Done,
     /*  629420 */   // Label 10121: @629420
     /*  629420 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(629495), // Rule ID 6133 //
     /*  629425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  629436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  629439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  629442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629493 */     GIR_RootConstrainSelectedInstOperands,
     /*  629494 */     // GIR_Coverage, 6133,
     /*  629494 */     GIR_EraseRootFromParent_Done,
     /*  629495 */   // Label 10122: @629495
     /*  629495 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(629570), // Rule ID 6136 //
     /*  629500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629568 */     GIR_RootConstrainSelectedInstOperands,
     /*  629569 */     // GIR_Coverage, 6136,
     /*  629569 */     GIR_EraseRootFromParent_Done,
     /*  629570 */   // Label 10123: @629570
     /*  629570 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(629645), // Rule ID 6137 //
     /*  629575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  629624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629643 */     GIR_RootConstrainSelectedInstOperands,
     /*  629644 */     // GIR_Coverage, 6137,
     /*  629644 */     GIR_EraseRootFromParent_Done,
     /*  629645 */   // Label 10124: @629645
     /*  629645 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(629720), // Rule ID 6140 //
     /*  629650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629718 */     GIR_RootConstrainSelectedInstOperands,
     /*  629719 */     // GIR_Coverage, 6140,
     /*  629719 */     GIR_EraseRootFromParent_Done,
     /*  629720 */   // Label 10125: @629720
     /*  629720 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(629795), // Rule ID 6141 //
     /*  629725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629793 */     GIR_RootConstrainSelectedInstOperands,
     /*  629794 */     // GIR_Coverage, 6141,
     /*  629794 */     GIR_EraseRootFromParent_Done,
     /*  629795 */   // Label 10126: @629795
     /*  629795 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(629870), // Rule ID 6144 //
     /*  629800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629868 */     GIR_RootConstrainSelectedInstOperands,
     /*  629869 */     // GIR_Coverage, 6144,
     /*  629869 */     GIR_EraseRootFromParent_Done,
     /*  629870 */   // Label 10127: @629870
     /*  629870 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(629945), // Rule ID 6145 //
     /*  629875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  629895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629943 */     GIR_RootConstrainSelectedInstOperands,
     /*  629944 */     // GIR_Coverage, 6145,
     /*  629944 */     GIR_EraseRootFromParent_Done,
     /*  629945 */   // Label 10128: @629945
     /*  629945 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(630020), // Rule ID 6148 //
     /*  629950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  629958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  629970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  629989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  629999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630018 */     GIR_RootConstrainSelectedInstOperands,
     /*  630019 */     // GIR_Coverage, 6148,
     /*  630019 */     GIR_EraseRootFromParent_Done,
     /*  630020 */   // Label 10129: @630020
     /*  630020 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(630095), // Rule ID 6149 //
     /*  630025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  630036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  630039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  630042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630093 */     GIR_RootConstrainSelectedInstOperands,
     /*  630094 */     // GIR_Coverage, 6149,
     /*  630094 */     GIR_EraseRootFromParent_Done,
     /*  630095 */   // Label 10130: @630095
     /*  630095 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(630170), // Rule ID 6152 //
     /*  630100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630168 */     GIR_RootConstrainSelectedInstOperands,
     /*  630169 */     // GIR_Coverage, 6152,
     /*  630169 */     GIR_EraseRootFromParent_Done,
     /*  630170 */   // Label 10131: @630170
     /*  630170 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(630245), // Rule ID 6153 //
     /*  630175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  630186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  630189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  630192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  630210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  630224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630243 */     GIR_RootConstrainSelectedInstOperands,
     /*  630244 */     // GIR_Coverage, 6153,
     /*  630244 */     GIR_EraseRootFromParent_Done,
     /*  630245 */   // Label 10132: @630245
     /*  630245 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(630320), // Rule ID 6156 //
     /*  630250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630318 */     GIR_RootConstrainSelectedInstOperands,
     /*  630319 */     // GIR_Coverage, 6156,
     /*  630319 */     GIR_EraseRootFromParent_Done,
     /*  630320 */   // Label 10133: @630320
     /*  630320 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(630395), // Rule ID 6157 //
     /*  630325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  630336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  630339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  630342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630393 */     GIR_RootConstrainSelectedInstOperands,
     /*  630394 */     // GIR_Coverage, 6157,
     /*  630394 */     GIR_EraseRootFromParent_Done,
     /*  630395 */   // Label 10134: @630395
     /*  630395 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(630470), // Rule ID 6160 //
     /*  630400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630468 */     GIR_RootConstrainSelectedInstOperands,
     /*  630469 */     // GIR_Coverage, 6160,
     /*  630469 */     GIR_EraseRootFromParent_Done,
     /*  630470 */   // Label 10135: @630470
     /*  630470 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(630545), // Rule ID 6161 //
     /*  630475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  630486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  630489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  630492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630543 */     GIR_RootConstrainSelectedInstOperands,
     /*  630544 */     // GIR_Coverage, 6161,
     /*  630544 */     GIR_EraseRootFromParent_Done,
     /*  630545 */   // Label 10136: @630545
     /*  630545 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(630620), // Rule ID 6164 //
     /*  630550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  630599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630618 */     GIR_RootConstrainSelectedInstOperands,
     /*  630619 */     // GIR_Coverage, 6164,
     /*  630619 */     GIR_EraseRootFromParent_Done,
     /*  630620 */   // Label 10137: @630620
     /*  630620 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(630695), // Rule ID 6165 //
     /*  630625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  630674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630693 */     GIR_RootConstrainSelectedInstOperands,
     /*  630694 */     // GIR_Coverage, 6165,
     /*  630694 */     GIR_EraseRootFromParent_Done,
     /*  630695 */   // Label 10138: @630695
     /*  630695 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(630770), // Rule ID 6168 //
     /*  630700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630768 */     GIR_RootConstrainSelectedInstOperands,
     /*  630769 */     // GIR_Coverage, 6168,
     /*  630769 */     GIR_EraseRootFromParent_Done,
     /*  630770 */   // Label 10139: @630770
     /*  630770 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(630845), // Rule ID 6169 //
     /*  630775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  630824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630843 */     GIR_RootConstrainSelectedInstOperands,
     /*  630844 */     // GIR_Coverage, 6169,
     /*  630844 */     GIR_EraseRootFromParent_Done,
     /*  630845 */   // Label 10140: @630845
     /*  630845 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(630920), // Rule ID 6172 //
     /*  630850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  630870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630918 */     GIR_RootConstrainSelectedInstOperands,
     /*  630919 */     // GIR_Coverage, 6172,
     /*  630919 */     GIR_EraseRootFromParent_Done,
     /*  630920 */   // Label 10141: @630920
     /*  630920 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(630995), // Rule ID 6173 //
     /*  630925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  630933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  630945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  630964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  630974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630993 */     GIR_RootConstrainSelectedInstOperands,
     /*  630994 */     // GIR_Coverage, 6173,
     /*  630994 */     GIR_EraseRootFromParent_Done,
     /*  630995 */   // Label 10142: @630995
     /*  630995 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(631070), // Rule ID 6176 //
     /*  631000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  631046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631068 */     GIR_RootConstrainSelectedInstOperands,
     /*  631069 */     // GIR_Coverage, 6176,
     /*  631069 */     GIR_EraseRootFromParent_Done,
     /*  631070 */   // Label 10143: @631070
     /*  631070 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(631145), // Rule ID 6177 //
     /*  631075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  631086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  631089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  631092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631143 */     GIR_RootConstrainSelectedInstOperands,
     /*  631144 */     // GIR_Coverage, 6177,
     /*  631144 */     GIR_EraseRootFromParent_Done,
     /*  631145 */   // Label 10144: @631145
     /*  631145 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(631220), // Rule ID 6180 //
     /*  631150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631218 */     GIR_RootConstrainSelectedInstOperands,
     /*  631219 */     // GIR_Coverage, 6180,
     /*  631219 */     GIR_EraseRootFromParent_Done,
     /*  631220 */   // Label 10145: @631220
     /*  631220 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(631295), // Rule ID 6181 //
     /*  631225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  631236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  631239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  631242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631293 */     GIR_RootConstrainSelectedInstOperands,
     /*  631294 */     // GIR_Coverage, 6181,
     /*  631294 */     GIR_EraseRootFromParent_Done,
     /*  631295 */   // Label 10146: @631295
     /*  631295 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(631370), // Rule ID 6184 //
     /*  631300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631368 */     GIR_RootConstrainSelectedInstOperands,
     /*  631369 */     // GIR_Coverage, 6184,
     /*  631369 */     GIR_EraseRootFromParent_Done,
     /*  631370 */   // Label 10147: @631370
     /*  631370 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(631445), // Rule ID 6185 //
     /*  631375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  631386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  631389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  631392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631443 */     GIR_RootConstrainSelectedInstOperands,
     /*  631444 */     // GIR_Coverage, 6185,
     /*  631444 */     GIR_EraseRootFromParent_Done,
     /*  631445 */   // Label 10148: @631445
     /*  631445 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(631520), // Rule ID 6188 //
     /*  631450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631518 */     GIR_RootConstrainSelectedInstOperands,
     /*  631519 */     // GIR_Coverage, 6188,
     /*  631519 */     GIR_EraseRootFromParent_Done,
     /*  631520 */   // Label 10149: @631520
     /*  631520 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(631595), // Rule ID 6189 //
     /*  631525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  631536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  631539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  631542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631593 */     GIR_RootConstrainSelectedInstOperands,
     /*  631594 */     // GIR_Coverage, 6189,
     /*  631594 */     GIR_EraseRootFromParent_Done,
     /*  631595 */   // Label 10150: @631595
     /*  631595 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(631670), // Rule ID 6192 //
     /*  631600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631668 */     GIR_RootConstrainSelectedInstOperands,
     /*  631669 */     // GIR_Coverage, 6192,
     /*  631669 */     GIR_EraseRootFromParent_Done,
     /*  631670 */   // Label 10151: @631670
     /*  631670 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(631745), // Rule ID 6193 //
     /*  631675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  631724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631743 */     GIR_RootConstrainSelectedInstOperands,
     /*  631744 */     // GIR_Coverage, 6193,
     /*  631744 */     GIR_EraseRootFromParent_Done,
     /*  631745 */   // Label 10152: @631745
     /*  631745 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(631820), // Rule ID 6196 //
     /*  631750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631818 */     GIR_RootConstrainSelectedInstOperands,
     /*  631819 */     // GIR_Coverage, 6196,
     /*  631819 */     GIR_EraseRootFromParent_Done,
     /*  631820 */   // Label 10153: @631820
     /*  631820 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(631895), // Rule ID 6197 //
     /*  631825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  631874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631893 */     GIR_RootConstrainSelectedInstOperands,
     /*  631894 */     // GIR_Coverage, 6197,
     /*  631894 */     GIR_EraseRootFromParent_Done,
     /*  631895 */   // Label 10154: @631895
     /*  631895 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(631970), // Rule ID 6200 //
     /*  631900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  631949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631968 */     GIR_RootConstrainSelectedInstOperands,
     /*  631969 */     // GIR_Coverage, 6200,
     /*  631969 */     GIR_EraseRootFromParent_Done,
     /*  631970 */   // Label 10155: @631970
     /*  631970 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(632045), // Rule ID 6201 //
     /*  631975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  631983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  632021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  632024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632043 */     GIR_RootConstrainSelectedInstOperands,
     /*  632044 */     // GIR_Coverage, 6201,
     /*  632044 */     GIR_EraseRootFromParent_Done,
     /*  632045 */   // Label 10156: @632045
     /*  632045 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(632120), // Rule ID 6292 //
     /*  632050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  632070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  632099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632118 */     GIR_RootConstrainSelectedInstOperands,
     /*  632119 */     // GIR_Coverage, 6292,
     /*  632119 */     GIR_EraseRootFromParent_Done,
     /*  632120 */   // Label 10157: @632120
     /*  632120 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(632195), // Rule ID 6293 //
     /*  632125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  632136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  632139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  632142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  632145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  632174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632193 */     GIR_RootConstrainSelectedInstOperands,
     /*  632194 */     // GIR_Coverage, 6293,
     /*  632194 */     GIR_EraseRootFromParent_Done,
     /*  632195 */   // Label 10158: @632195
     /*  632195 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(632270), // Rule ID 6296 //
     /*  632200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  632220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632268 */     GIR_RootConstrainSelectedInstOperands,
     /*  632269 */     // GIR_Coverage, 6296,
     /*  632269 */     GIR_EraseRootFromParent_Done,
     /*  632270 */   // Label 10159: @632270
     /*  632270 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(632345), // Rule ID 6297 //
     /*  632275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  632286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  632289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  632292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  632295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632343 */     GIR_RootConstrainSelectedInstOperands,
     /*  632344 */     // GIR_Coverage, 6297,
     /*  632344 */     GIR_EraseRootFromParent_Done,
     /*  632345 */   // Label 10160: @632345
     /*  632345 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(632420), // Rule ID 6300 //
     /*  632350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  632370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632418 */     GIR_RootConstrainSelectedInstOperands,
     /*  632419 */     // GIR_Coverage, 6300,
     /*  632419 */     GIR_EraseRootFromParent_Done,
     /*  632420 */   // Label 10161: @632420
     /*  632420 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(632495), // Rule ID 6301 //
     /*  632425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  632436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  632439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  632442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  632445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632493 */     GIR_RootConstrainSelectedInstOperands,
     /*  632494 */     // GIR_Coverage, 6301,
     /*  632494 */     GIR_EraseRootFromParent_Done,
     /*  632495 */   // Label 10162: @632495
     /*  632495 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(632570), // Rule ID 6304 //
     /*  632500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  632520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632568 */     GIR_RootConstrainSelectedInstOperands,
     /*  632569 */     // GIR_Coverage, 6304,
     /*  632569 */     GIR_EraseRootFromParent_Done,
     /*  632570 */   // Label 10163: @632570
     /*  632570 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(632645), // Rule ID 6305 //
     /*  632575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  632595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  632624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632643 */     GIR_RootConstrainSelectedInstOperands,
     /*  632644 */     // GIR_Coverage, 6305,
     /*  632644 */     GIR_EraseRootFromParent_Done,
     /*  632645 */   // Label 10164: @632645
     /*  632645 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(632720), // Rule ID 6308 //
     /*  632650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  632670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632718 */     GIR_RootConstrainSelectedInstOperands,
     /*  632719 */     // GIR_Coverage, 6308,
     /*  632719 */     GIR_EraseRootFromParent_Done,
     /*  632720 */   // Label 10165: @632720
     /*  632720 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(632795), // Rule ID 6309 //
     /*  632725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  632745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632793 */     GIR_RootConstrainSelectedInstOperands,
     /*  632794 */     // GIR_Coverage, 6309,
     /*  632794 */     GIR_EraseRootFromParent_Done,
     /*  632795 */   // Label 10166: @632795
     /*  632795 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(632870), // Rule ID 6312 //
     /*  632800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  632820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632868 */     GIR_RootConstrainSelectedInstOperands,
     /*  632869 */     // GIR_Coverage, 6312,
     /*  632869 */     GIR_EraseRootFromParent_Done,
     /*  632870 */   // Label 10167: @632870
     /*  632870 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(632945), // Rule ID 6313 //
     /*  632875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  632895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  632924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632943 */     GIR_RootConstrainSelectedInstOperands,
     /*  632944 */     // GIR_Coverage, 6313,
     /*  632944 */     GIR_EraseRootFromParent_Done,
     /*  632945 */   // Label 10168: @632945
     /*  632945 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(633020), // Rule ID 6316 //
     /*  632950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  632970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  632999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633018 */     GIR_RootConstrainSelectedInstOperands,
     /*  633019 */     // GIR_Coverage, 6316,
     /*  633019 */     GIR_EraseRootFromParent_Done,
     /*  633020 */   // Label 10169: @633020
     /*  633020 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(633095), // Rule ID 6317 //
     /*  633025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  633036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  633039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  633042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  633045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633093 */     GIR_RootConstrainSelectedInstOperands,
     /*  633094 */     // GIR_Coverage, 6317,
     /*  633094 */     GIR_EraseRootFromParent_Done,
     /*  633095 */   // Label 10170: @633095
     /*  633095 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(633170), // Rule ID 6320 //
     /*  633100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  633120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633168 */     GIR_RootConstrainSelectedInstOperands,
     /*  633169 */     // GIR_Coverage, 6320,
     /*  633169 */     GIR_EraseRootFromParent_Done,
     /*  633170 */   // Label 10171: @633170
     /*  633170 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(633245), // Rule ID 6321 //
     /*  633175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  633186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  633189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  633192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  633195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633243 */     GIR_RootConstrainSelectedInstOperands,
     /*  633244 */     // GIR_Coverage, 6321,
     /*  633244 */     GIR_EraseRootFromParent_Done,
     /*  633245 */   // Label 10172: @633245
     /*  633245 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(633320), // Rule ID 6324 //
     /*  633250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  633270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633318 */     GIR_RootConstrainSelectedInstOperands,
     /*  633319 */     // GIR_Coverage, 6324,
     /*  633319 */     GIR_EraseRootFromParent_Done,
     /*  633320 */   // Label 10173: @633320
     /*  633320 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(633395), // Rule ID 6325 //
     /*  633325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  633336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  633339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  633342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  633345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633393 */     GIR_RootConstrainSelectedInstOperands,
     /*  633394 */     // GIR_Coverage, 6325,
     /*  633394 */     GIR_EraseRootFromParent_Done,
     /*  633395 */   // Label 10174: @633395
     /*  633395 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(633470), // Rule ID 6328 //
     /*  633400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  633420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633468 */     GIR_RootConstrainSelectedInstOperands,
     /*  633469 */     // GIR_Coverage, 6328,
     /*  633469 */     GIR_EraseRootFromParent_Done,
     /*  633470 */   // Label 10175: @633470
     /*  633470 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(633545), // Rule ID 6329 //
     /*  633475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  633486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  633489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  633492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  633495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  633514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  633524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633543 */     GIR_RootConstrainSelectedInstOperands,
     /*  633544 */     // GIR_Coverage, 6329,
     /*  633544 */     GIR_EraseRootFromParent_Done,
     /*  633545 */   // Label 10176: @633545
     /*  633545 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(633620), // Rule ID 6332 //
     /*  633550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  633570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  633599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633618 */     GIR_RootConstrainSelectedInstOperands,
     /*  633619 */     // GIR_Coverage, 6332,
     /*  633619 */     GIR_EraseRootFromParent_Done,
     /*  633620 */   // Label 10177: @633620
     /*  633620 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(633695), // Rule ID 6333 //
     /*  633625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  633645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  633674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633693 */     GIR_RootConstrainSelectedInstOperands,
     /*  633694 */     // GIR_Coverage, 6333,
     /*  633694 */     GIR_EraseRootFromParent_Done,
     /*  633695 */   // Label 10178: @633695
     /*  633695 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(633770), // Rule ID 6336 //
     /*  633700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  633720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  633749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633768 */     GIR_RootConstrainSelectedInstOperands,
     /*  633769 */     // GIR_Coverage, 6336,
     /*  633769 */     GIR_EraseRootFromParent_Done,
     /*  633770 */   // Label 10179: @633770
     /*  633770 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(633845), // Rule ID 6337 //
     /*  633775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  633795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  633824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633843 */     GIR_RootConstrainSelectedInstOperands,
     /*  633844 */     // GIR_Coverage, 6337,
     /*  633844 */     GIR_EraseRootFromParent_Done,
     /*  633845 */   // Label 10180: @633845
     /*  633845 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(633920), // Rule ID 6340 //
     /*  633850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  633870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  633899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633918 */     GIR_RootConstrainSelectedInstOperands,
     /*  633919 */     // GIR_Coverage, 6340,
     /*  633919 */     GIR_EraseRootFromParent_Done,
     /*  633920 */   // Label 10181: @633920
     /*  633920 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(633995), // Rule ID 6341 //
     /*  633925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  633945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  633974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633993 */     GIR_RootConstrainSelectedInstOperands,
     /*  633994 */     // GIR_Coverage, 6341,
     /*  633994 */     GIR_EraseRootFromParent_Done,
     /*  633995 */   // Label 10182: @633995
     /*  633995 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(634070), // Rule ID 6344 //
     /*  634000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  634020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634068 */     GIR_RootConstrainSelectedInstOperands,
     /*  634069 */     // GIR_Coverage, 6344,
     /*  634069 */     GIR_EraseRootFromParent_Done,
     /*  634070 */   // Label 10183: @634070
     /*  634070 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(634145), // Rule ID 6345 //
     /*  634075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  634086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  634089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  634092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  634095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634143 */     GIR_RootConstrainSelectedInstOperands,
     /*  634144 */     // GIR_Coverage, 6345,
     /*  634144 */     GIR_EraseRootFromParent_Done,
     /*  634145 */   // Label 10184: @634145
     /*  634145 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(634220), // Rule ID 6348 //
     /*  634150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  634170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634218 */     GIR_RootConstrainSelectedInstOperands,
     /*  634219 */     // GIR_Coverage, 6348,
     /*  634219 */     GIR_EraseRootFromParent_Done,
     /*  634220 */   // Label 10185: @634220
     /*  634220 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(634295), // Rule ID 6349 //
     /*  634225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  634236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  634239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  634242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  634245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634293 */     GIR_RootConstrainSelectedInstOperands,
     /*  634294 */     // GIR_Coverage, 6349,
     /*  634294 */     GIR_EraseRootFromParent_Done,
     /*  634295 */   // Label 10186: @634295
     /*  634295 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(634370), // Rule ID 6352 //
     /*  634300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  634320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634368 */     GIR_RootConstrainSelectedInstOperands,
     /*  634369 */     // GIR_Coverage, 6352,
     /*  634369 */     GIR_EraseRootFromParent_Done,
     /*  634370 */   // Label 10187: @634370
     /*  634370 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(634445), // Rule ID 6353 //
     /*  634375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  634386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  634389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  634392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  634395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634443 */     GIR_RootConstrainSelectedInstOperands,
     /*  634444 */     // GIR_Coverage, 6353,
     /*  634444 */     GIR_EraseRootFromParent_Done,
     /*  634445 */   // Label 10188: @634445
     /*  634445 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(634520), // Rule ID 6356 //
     /*  634450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  634470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634518 */     GIR_RootConstrainSelectedInstOperands,
     /*  634519 */     // GIR_Coverage, 6356,
     /*  634519 */     GIR_EraseRootFromParent_Done,
     /*  634520 */   // Label 10189: @634520
     /*  634520 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(634595), // Rule ID 6357 //
     /*  634525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  634536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  634539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  634542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  634545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634593 */     GIR_RootConstrainSelectedInstOperands,
     /*  634594 */     // GIR_Coverage, 6357,
     /*  634594 */     GIR_EraseRootFromParent_Done,
     /*  634595 */   // Label 10190: @634595
     /*  634595 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(634670), // Rule ID 6360 //
     /*  634600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  634620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634668 */     GIR_RootConstrainSelectedInstOperands,
     /*  634669 */     // GIR_Coverage, 6360,
     /*  634669 */     GIR_EraseRootFromParent_Done,
     /*  634670 */   // Label 10191: @634670
     /*  634670 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(634745), // Rule ID 6361 //
     /*  634675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  634695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  634724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634743 */     GIR_RootConstrainSelectedInstOperands,
     /*  634744 */     // GIR_Coverage, 6361,
     /*  634744 */     GIR_EraseRootFromParent_Done,
     /*  634745 */   // Label 10192: @634745
     /*  634745 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(634820), // Rule ID 6364 //
     /*  634750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  634770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634818 */     GIR_RootConstrainSelectedInstOperands,
     /*  634819 */     // GIR_Coverage, 6364,
     /*  634819 */     GIR_EraseRootFromParent_Done,
     /*  634820 */   // Label 10193: @634820
     /*  634820 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(634895), // Rule ID 6365 //
     /*  634825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  634845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  634874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634893 */     GIR_RootConstrainSelectedInstOperands,
     /*  634894 */     // GIR_Coverage, 6365,
     /*  634894 */     GIR_EraseRootFromParent_Done,
     /*  634895 */   // Label 10194: @634895
     /*  634895 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(634970), // Rule ID 6368 //
     /*  634900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  634920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  634949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634968 */     GIR_RootConstrainSelectedInstOperands,
     /*  634969 */     // GIR_Coverage, 6368,
     /*  634969 */     GIR_EraseRootFromParent_Done,
     /*  634970 */   // Label 10195: @634970
     /*  634970 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(635045), // Rule ID 6369 //
     /*  634975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  634995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  635024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635043 */     GIR_RootConstrainSelectedInstOperands,
     /*  635044 */     // GIR_Coverage, 6369,
     /*  635044 */     GIR_EraseRootFromParent_Done,
     /*  635045 */   // Label 10196: @635045
     /*  635045 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(635120), // Rule ID 6372 //
     /*  635050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  635070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  635099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635118 */     GIR_RootConstrainSelectedInstOperands,
     /*  635119 */     // GIR_Coverage, 6372,
     /*  635119 */     GIR_EraseRootFromParent_Done,
     /*  635120 */   // Label 10197: @635120
     /*  635120 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(635195), // Rule ID 6373 //
     /*  635125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  635136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  635139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  635142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  635145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  635174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635193 */     GIR_RootConstrainSelectedInstOperands,
     /*  635194 */     // GIR_Coverage, 6373,
     /*  635194 */     GIR_EraseRootFromParent_Done,
     /*  635195 */   // Label 10198: @635195
     /*  635195 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(635270), // Rule ID 6376 //
     /*  635200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  635220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  635249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635268 */     GIR_RootConstrainSelectedInstOperands,
     /*  635269 */     // GIR_Coverage, 6376,
     /*  635269 */     GIR_EraseRootFromParent_Done,
     /*  635270 */   // Label 10199: @635270
     /*  635270 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(635345), // Rule ID 6377 //
     /*  635275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  635286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  635289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  635292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  635295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  635314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  635324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635343 */     GIR_RootConstrainSelectedInstOperands,
     /*  635344 */     // GIR_Coverage, 6377,
     /*  635344 */     GIR_EraseRootFromParent_Done,
     /*  635345 */   // Label 10200: @635345
     /*  635345 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(635420), // Rule ID 6380 //
     /*  635350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  635399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635418 */     GIR_RootConstrainSelectedInstOperands,
     /*  635419 */     // GIR_Coverage, 6380,
     /*  635419 */     GIR_EraseRootFromParent_Done,
     /*  635420 */   // Label 10201: @635420
     /*  635420 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(635495), // Rule ID 6381 //
     /*  635425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  635436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  635439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  635442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  635474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635493 */     GIR_RootConstrainSelectedInstOperands,
     /*  635494 */     // GIR_Coverage, 6381,
     /*  635494 */     GIR_EraseRootFromParent_Done,
     /*  635495 */   // Label 10202: @635495
     /*  635495 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(635570), // Rule ID 6384 //
     /*  635500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635568 */     GIR_RootConstrainSelectedInstOperands,
     /*  635569 */     // GIR_Coverage, 6384,
     /*  635569 */     GIR_EraseRootFromParent_Done,
     /*  635570 */   // Label 10203: @635570
     /*  635570 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(635645), // Rule ID 6385 //
     /*  635575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635643 */     GIR_RootConstrainSelectedInstOperands,
     /*  635644 */     // GIR_Coverage, 6385,
     /*  635644 */     GIR_EraseRootFromParent_Done,
     /*  635645 */   // Label 10204: @635645
     /*  635645 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(635720), // Rule ID 6388 //
     /*  635650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635718 */     GIR_RootConstrainSelectedInstOperands,
     /*  635719 */     // GIR_Coverage, 6388,
     /*  635719 */     GIR_EraseRootFromParent_Done,
     /*  635720 */   // Label 10205: @635720
     /*  635720 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(635795), // Rule ID 6389 //
     /*  635725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635793 */     GIR_RootConstrainSelectedInstOperands,
     /*  635794 */     // GIR_Coverage, 6389,
     /*  635794 */     GIR_EraseRootFromParent_Done,
     /*  635795 */   // Label 10206: @635795
     /*  635795 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(635870), // Rule ID 6392 //
     /*  635800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635868 */     GIR_RootConstrainSelectedInstOperands,
     /*  635869 */     // GIR_Coverage, 6392,
     /*  635869 */     GIR_EraseRootFromParent_Done,
     /*  635870 */   // Label 10207: @635870
     /*  635870 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(635945), // Rule ID 6393 //
     /*  635875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  635895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  635924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635943 */     GIR_RootConstrainSelectedInstOperands,
     /*  635944 */     // GIR_Coverage, 6393,
     /*  635944 */     GIR_EraseRootFromParent_Done,
     /*  635945 */   // Label 10208: @635945
     /*  635945 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(636020), // Rule ID 6396 //
     /*  635950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  635958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  635970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  635989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  635999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636018 */     GIR_RootConstrainSelectedInstOperands,
     /*  636019 */     // GIR_Coverage, 6396,
     /*  636019 */     GIR_EraseRootFromParent_Done,
     /*  636020 */   // Label 10209: @636020
     /*  636020 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(636095), // Rule ID 6397 //
     /*  636025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  636036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  636039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  636042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636093 */     GIR_RootConstrainSelectedInstOperands,
     /*  636094 */     // GIR_Coverage, 6397,
     /*  636094 */     GIR_EraseRootFromParent_Done,
     /*  636095 */   // Label 10210: @636095
     /*  636095 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(636170), // Rule ID 6400 //
     /*  636100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636168 */     GIR_RootConstrainSelectedInstOperands,
     /*  636169 */     // GIR_Coverage, 6400,
     /*  636169 */     GIR_EraseRootFromParent_Done,
     /*  636170 */   // Label 10211: @636170
     /*  636170 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(636245), // Rule ID 6401 //
     /*  636175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  636186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  636189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  636192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  636224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636243 */     GIR_RootConstrainSelectedInstOperands,
     /*  636244 */     // GIR_Coverage, 6401,
     /*  636244 */     GIR_EraseRootFromParent_Done,
     /*  636245 */   // Label 10212: @636245
     /*  636245 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(636320), // Rule ID 6404 //
     /*  636250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636318 */     GIR_RootConstrainSelectedInstOperands,
     /*  636319 */     // GIR_Coverage, 6404,
     /*  636319 */     GIR_EraseRootFromParent_Done,
     /*  636320 */   // Label 10213: @636320
     /*  636320 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(636395), // Rule ID 6405 //
     /*  636325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  636336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  636339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  636342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11614:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636393 */     GIR_RootConstrainSelectedInstOperands,
     /*  636394 */     // GIR_Coverage, 6405,
     /*  636394 */     GIR_EraseRootFromParent_Done,
     /*  636395 */   // Label 10214: @636395
     /*  636395 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(636470), // Rule ID 6408 //
     /*  636400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636468 */     GIR_RootConstrainSelectedInstOperands,
     /*  636469 */     // GIR_Coverage, 6408,
     /*  636469 */     GIR_EraseRootFromParent_Done,
     /*  636470 */   // Label 10215: @636470
     /*  636470 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(636545), // Rule ID 6409 //
     /*  636475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  636486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  636489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  636492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11614:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636543 */     GIR_RootConstrainSelectedInstOperands,
     /*  636544 */     // GIR_Coverage, 6409,
     /*  636544 */     GIR_EraseRootFromParent_Done,
     /*  636545 */   // Label 10216: @636545
     /*  636545 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(636620), // Rule ID 6412 //
     /*  636550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636618 */     GIR_RootConstrainSelectedInstOperands,
     /*  636619 */     // GIR_Coverage, 6412,
     /*  636619 */     GIR_EraseRootFromParent_Done,
     /*  636620 */   // Label 10217: @636620
     /*  636620 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(636695), // Rule ID 6413 //
     /*  636625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11614:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636693 */     GIR_RootConstrainSelectedInstOperands,
     /*  636694 */     // GIR_Coverage, 6413,
     /*  636694 */     GIR_EraseRootFromParent_Done,
     /*  636695 */   // Label 10218: @636695
     /*  636695 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(636770), // Rule ID 6416 //
     /*  636700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636768 */     GIR_RootConstrainSelectedInstOperands,
     /*  636769 */     // GIR_Coverage, 6416,
     /*  636769 */     GIR_EraseRootFromParent_Done,
     /*  636770 */   // Label 10219: @636770
     /*  636770 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(636845), // Rule ID 6417 //
     /*  636775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11614:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  636824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636843 */     GIR_RootConstrainSelectedInstOperands,
     /*  636844 */     // GIR_Coverage, 6417,
     /*  636844 */     GIR_EraseRootFromParent_Done,
     /*  636845 */   // Label 10220: @636845
     /*  636845 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(636920), // Rule ID 6420 //
     /*  636850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  636870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  636899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636918 */     GIR_RootConstrainSelectedInstOperands,
     /*  636919 */     // GIR_Coverage, 6420,
     /*  636919 */     GIR_EraseRootFromParent_Done,
     /*  636920 */   // Label 10221: @636920
     /*  636920 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(636995), // Rule ID 6421 //
     /*  636925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  636933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  636945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  636964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  636974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636993 */     GIR_RootConstrainSelectedInstOperands,
     /*  636994 */     // GIR_Coverage, 6421,
     /*  636994 */     GIR_EraseRootFromParent_Done,
     /*  636995 */   // Label 10222: @636995
     /*  636995 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(637070), // Rule ID 6424 //
     /*  637000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637068 */     GIR_RootConstrainSelectedInstOperands,
     /*  637069 */     // GIR_Coverage, 6424,
     /*  637069 */     GIR_EraseRootFromParent_Done,
     /*  637070 */   // Label 10223: @637070
     /*  637070 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(637145), // Rule ID 6425 //
     /*  637075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  637086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  637089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  637092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637143 */     GIR_RootConstrainSelectedInstOperands,
     /*  637144 */     // GIR_Coverage, 6425,
     /*  637144 */     GIR_EraseRootFromParent_Done,
     /*  637145 */   // Label 10224: @637145
     /*  637145 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(637220), // Rule ID 6428 //
     /*  637150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637218 */     GIR_RootConstrainSelectedInstOperands,
     /*  637219 */     // GIR_Coverage, 6428,
     /*  637219 */     GIR_EraseRootFromParent_Done,
     /*  637220 */   // Label 10225: @637220
     /*  637220 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(637295), // Rule ID 6429 //
     /*  637225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  637236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  637239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  637242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637293 */     GIR_RootConstrainSelectedInstOperands,
     /*  637294 */     // GIR_Coverage, 6429,
     /*  637294 */     GIR_EraseRootFromParent_Done,
     /*  637295 */   // Label 10226: @637295
     /*  637295 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(637370), // Rule ID 6432 //
     /*  637300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637368 */     GIR_RootConstrainSelectedInstOperands,
     /*  637369 */     // GIR_Coverage, 6432,
     /*  637369 */     GIR_EraseRootFromParent_Done,
     /*  637370 */   // Label 10227: @637370
     /*  637370 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(637445), // Rule ID 6433 //
     /*  637375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  637386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  637389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  637392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637443 */     GIR_RootConstrainSelectedInstOperands,
     /*  637444 */     // GIR_Coverage, 6433,
     /*  637444 */     GIR_EraseRootFromParent_Done,
     /*  637445 */   // Label 10228: @637445
     /*  637445 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(637520), // Rule ID 6436 //
     /*  637450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637518 */     GIR_RootConstrainSelectedInstOperands,
     /*  637519 */     // GIR_Coverage, 6436,
     /*  637519 */     GIR_EraseRootFromParent_Done,
     /*  637520 */   // Label 10229: @637520
     /*  637520 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(637595), // Rule ID 6437 //
     /*  637525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  637536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  637539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  637542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637593 */     GIR_RootConstrainSelectedInstOperands,
     /*  637594 */     // GIR_Coverage, 6437,
     /*  637594 */     GIR_EraseRootFromParent_Done,
     /*  637595 */   // Label 10230: @637595
     /*  637595 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(637670), // Rule ID 6440 //
     /*  637600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637668 */     GIR_RootConstrainSelectedInstOperands,
     /*  637669 */     // GIR_Coverage, 6440,
     /*  637669 */     GIR_EraseRootFromParent_Done,
     /*  637670 */   // Label 10231: @637670
     /*  637670 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(637745), // Rule ID 6441 //
     /*  637675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  637724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637743 */     GIR_RootConstrainSelectedInstOperands,
     /*  637744 */     // GIR_Coverage, 6441,
     /*  637744 */     GIR_EraseRootFromParent_Done,
     /*  637745 */   // Label 10232: @637745
     /*  637745 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(637820), // Rule ID 6444 //
     /*  637750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637818 */     GIR_RootConstrainSelectedInstOperands,
     /*  637819 */     // GIR_Coverage, 6444,
     /*  637819 */     GIR_EraseRootFromParent_Done,
     /*  637820 */   // Label 10233: @637820
     /*  637820 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(637895), // Rule ID 6445 //
     /*  637825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  637874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637893 */     GIR_RootConstrainSelectedInstOperands,
     /*  637894 */     // GIR_Coverage, 6445,
     /*  637894 */     GIR_EraseRootFromParent_Done,
     /*  637895 */   // Label 10234: @637895
     /*  637895 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(637970), // Rule ID 6448 //
     /*  637900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  637949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637968 */     GIR_RootConstrainSelectedInstOperands,
     /*  637969 */     // GIR_Coverage, 6448,
     /*  637969 */     GIR_EraseRootFromParent_Done,
     /*  637970 */   // Label 10235: @637970
     /*  637970 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(638045), // Rule ID 6449 //
     /*  637975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  637983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638043 */     GIR_RootConstrainSelectedInstOperands,
     /*  638044 */     // GIR_Coverage, 6449,
     /*  638044 */     GIR_EraseRootFromParent_Done,
     /*  638045 */   // Label 10236: @638045
     /*  638045 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(638120), // Rule ID 6452 //
     /*  638050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638118 */     GIR_RootConstrainSelectedInstOperands,
     /*  638119 */     // GIR_Coverage, 6452,
     /*  638119 */     GIR_EraseRootFromParent_Done,
     /*  638120 */   // Label 10237: @638120
     /*  638120 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(638195), // Rule ID 6453 //
     /*  638125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  638136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  638139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  638142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638193 */     GIR_RootConstrainSelectedInstOperands,
     /*  638194 */     // GIR_Coverage, 6453,
     /*  638194 */     GIR_EraseRootFromParent_Done,
     /*  638195 */   // Label 10238: @638195
     /*  638195 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(638270), // Rule ID 6456 //
     /*  638200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  638249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638268 */     GIR_RootConstrainSelectedInstOperands,
     /*  638269 */     // GIR_Coverage, 6456,
     /*  638269 */     GIR_EraseRootFromParent_Done,
     /*  638270 */   // Label 10239: @638270
     /*  638270 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(638345), // Rule ID 6457 //
     /*  638275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  638286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  638289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  638292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  638310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11614:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  638324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638343 */     GIR_RootConstrainSelectedInstOperands,
     /*  638344 */     // GIR_Coverage, 6457,
     /*  638344 */     GIR_EraseRootFromParent_Done,
     /*  638345 */   // Label 10240: @638345
     /*  638345 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(638420), // Rule ID 6460 //
     /*  638350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638418 */     GIR_RootConstrainSelectedInstOperands,
     /*  638419 */     // GIR_Coverage, 6460,
     /*  638419 */     GIR_EraseRootFromParent_Done,
     /*  638420 */   // Label 10241: @638420
     /*  638420 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(638495), // Rule ID 6461 //
     /*  638425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  638436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  638439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  638442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  638460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11614:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  638474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638493 */     GIR_RootConstrainSelectedInstOperands,
     /*  638494 */     // GIR_Coverage, 6461,
     /*  638494 */     GIR_EraseRootFromParent_Done,
     /*  638495 */   // Label 10242: @638495
     /*  638495 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(638570), // Rule ID 6464 //
     /*  638500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638568 */     GIR_RootConstrainSelectedInstOperands,
     /*  638569 */     // GIR_Coverage, 6464,
     /*  638569 */     GIR_EraseRootFromParent_Done,
     /*  638570 */   // Label 10243: @638570
     /*  638570 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(638645), // Rule ID 6465 //
     /*  638575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  638583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11614:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  638624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638643 */     GIR_RootConstrainSelectedInstOperands,
     /*  638644 */     // GIR_Coverage, 6465,
     /*  638644 */     GIR_EraseRootFromParent_Done,
     /*  638645 */   // Label 10244: @638645
     /*  638645 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(638720), // Rule ID 6556 //
     /*  638650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  638670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  638699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638718 */     GIR_RootConstrainSelectedInstOperands,
     /*  638719 */     // GIR_Coverage, 6556,
     /*  638719 */     GIR_EraseRootFromParent_Done,
     /*  638720 */   // Label 10245: @638720
     /*  638720 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(638795), // Rule ID 6557 //
     /*  638725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  638745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  638774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638793 */     GIR_RootConstrainSelectedInstOperands,
     /*  638794 */     // GIR_Coverage, 6557,
     /*  638794 */     GIR_EraseRootFromParent_Done,
     /*  638795 */   // Label 10246: @638795
     /*  638795 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(638870), // Rule ID 6560 //
     /*  638800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  638820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  638849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638868 */     GIR_RootConstrainSelectedInstOperands,
     /*  638869 */     // GIR_Coverage, 6560,
     /*  638869 */     GIR_EraseRootFromParent_Done,
     /*  638870 */   // Label 10247: @638870
     /*  638870 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(638945), // Rule ID 6561 //
     /*  638875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  638895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  638924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638943 */     GIR_RootConstrainSelectedInstOperands,
     /*  638944 */     // GIR_Coverage, 6561,
     /*  638944 */     GIR_EraseRootFromParent_Done,
     /*  638945 */   // Label 10248: @638945
     /*  638945 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(639020), // Rule ID 6564 //
     /*  638950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  638970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  638999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639018 */     GIR_RootConstrainSelectedInstOperands,
     /*  639019 */     // GIR_Coverage, 6564,
     /*  639019 */     GIR_EraseRootFromParent_Done,
     /*  639020 */   // Label 10249: @639020
     /*  639020 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(639095), // Rule ID 6565 //
     /*  639025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  639036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  639039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  639042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  639045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639093 */     GIR_RootConstrainSelectedInstOperands,
     /*  639094 */     // GIR_Coverage, 6565,
     /*  639094 */     GIR_EraseRootFromParent_Done,
     /*  639095 */   // Label 10250: @639095
     /*  639095 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(639170), // Rule ID 6568 //
     /*  639100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  639120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  639149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639168 */     GIR_RootConstrainSelectedInstOperands,
     /*  639169 */     // GIR_Coverage, 6568,
     /*  639169 */     GIR_EraseRootFromParent_Done,
     /*  639170 */   // Label 10251: @639170
     /*  639170 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(639245), // Rule ID 6569 //
     /*  639175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  639186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  639189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  639192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  639195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  639224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639243 */     GIR_RootConstrainSelectedInstOperands,
     /*  639244 */     // GIR_Coverage, 6569,
     /*  639244 */     GIR_EraseRootFromParent_Done,
     /*  639245 */   // Label 10252: @639245
     /*  639245 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(639320), // Rule ID 6572 //
     /*  639250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  639270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639318 */     GIR_RootConstrainSelectedInstOperands,
     /*  639319 */     // GIR_Coverage, 6572,
     /*  639319 */     GIR_EraseRootFromParent_Done,
     /*  639320 */   // Label 10253: @639320
     /*  639320 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(639395), // Rule ID 6573 //
     /*  639325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  639336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  639339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  639342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  639345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639393 */     GIR_RootConstrainSelectedInstOperands,
     /*  639394 */     // GIR_Coverage, 6573,
     /*  639394 */     GIR_EraseRootFromParent_Done,
     /*  639395 */   // Label 10254: @639395
     /*  639395 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(639470), // Rule ID 6576 //
     /*  639400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  639420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639468 */     GIR_RootConstrainSelectedInstOperands,
     /*  639469 */     // GIR_Coverage, 6576,
     /*  639469 */     GIR_EraseRootFromParent_Done,
     /*  639470 */   // Label 10255: @639470
     /*  639470 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(639545), // Rule ID 6577 //
     /*  639475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  639486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  639489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  639492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  639495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  639524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639543 */     GIR_RootConstrainSelectedInstOperands,
     /*  639544 */     // GIR_Coverage, 6577,
     /*  639544 */     GIR_EraseRootFromParent_Done,
     /*  639545 */   // Label 10256: @639545
     /*  639545 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(639620), // Rule ID 6580 //
     /*  639550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  639570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639618 */     GIR_RootConstrainSelectedInstOperands,
     /*  639619 */     // GIR_Coverage, 6580,
     /*  639619 */     GIR_EraseRootFromParent_Done,
     /*  639620 */   // Label 10257: @639620
     /*  639620 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(639695), // Rule ID 6581 //
     /*  639625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  639645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639693 */     GIR_RootConstrainSelectedInstOperands,
     /*  639694 */     // GIR_Coverage, 6581,
     /*  639694 */     GIR_EraseRootFromParent_Done,
     /*  639695 */   // Label 10258: @639695
     /*  639695 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(639770), // Rule ID 6584 //
     /*  639700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  639720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639768 */     GIR_RootConstrainSelectedInstOperands,
     /*  639769 */     // GIR_Coverage, 6584,
     /*  639769 */     GIR_EraseRootFromParent_Done,
     /*  639770 */   // Label 10259: @639770
     /*  639770 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(639845), // Rule ID 6585 //
     /*  639775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  639795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639843 */     GIR_RootConstrainSelectedInstOperands,
     /*  639844 */     // GIR_Coverage, 6585,
     /*  639844 */     GIR_EraseRootFromParent_Done,
     /*  639845 */   // Label 10260: @639845
     /*  639845 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(639920), // Rule ID 6588 //
     /*  639850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  639870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639918 */     GIR_RootConstrainSelectedInstOperands,
     /*  639919 */     // GIR_Coverage, 6588,
     /*  639919 */     GIR_EraseRootFromParent_Done,
     /*  639920 */   // Label 10261: @639920
     /*  639920 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(639995), // Rule ID 6589 //
     /*  639925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  639945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  639974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639993 */     GIR_RootConstrainSelectedInstOperands,
     /*  639994 */     // GIR_Coverage, 6589,
     /*  639994 */     GIR_EraseRootFromParent_Done,
     /*  639995 */   // Label 10262: @639995
     /*  639995 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(640070), // Rule ID 6592 //
     /*  640000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  640020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  640046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  640049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640068 */     GIR_RootConstrainSelectedInstOperands,
     /*  640069 */     // GIR_Coverage, 6592,
     /*  640069 */     GIR_EraseRootFromParent_Done,
     /*  640070 */   // Label 10263: @640070
     /*  640070 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(640145), // Rule ID 6593 //
     /*  640075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  640086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  640089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  640092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  640095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640121 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  640124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640143 */     GIR_RootConstrainSelectedInstOperands,
     /*  640144 */     // GIR_Coverage, 6593,
     /*  640144 */     GIR_EraseRootFromParent_Done,
     /*  640145 */   // Label 10264: @640145
     /*  640145 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(640220), // Rule ID 6596 //
     /*  640150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  640170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640218 */     GIR_RootConstrainSelectedInstOperands,
     /*  640219 */     // GIR_Coverage, 6596,
     /*  640219 */     GIR_EraseRootFromParent_Done,
     /*  640220 */   // Label 10265: @640220
     /*  640220 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(640295), // Rule ID 6597 //
     /*  640225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  640236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  640239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  640242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  640245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640293 */     GIR_RootConstrainSelectedInstOperands,
     /*  640294 */     // GIR_Coverage, 6597,
     /*  640294 */     GIR_EraseRootFromParent_Done,
     /*  640295 */   // Label 10266: @640295
     /*  640295 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(640370), // Rule ID 6600 //
     /*  640300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  640320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640346 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640368 */     GIR_RootConstrainSelectedInstOperands,
     /*  640369 */     // GIR_Coverage, 6600,
     /*  640369 */     GIR_EraseRootFromParent_Done,
     /*  640370 */   // Label 10267: @640370
     /*  640370 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(640445), // Rule ID 6601 //
     /*  640375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  640386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  640389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  640392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  640395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640443 */     GIR_RootConstrainSelectedInstOperands,
     /*  640444 */     // GIR_Coverage, 6601,
     /*  640444 */     GIR_EraseRootFromParent_Done,
     /*  640445 */   // Label 10268: @640445
     /*  640445 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(640520), // Rule ID 6604 //
     /*  640450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  640470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640518 */     GIR_RootConstrainSelectedInstOperands,
     /*  640519 */     // GIR_Coverage, 6604,
     /*  640519 */     GIR_EraseRootFromParent_Done,
     /*  640520 */   // Label 10269: @640520
     /*  640520 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(640595), // Rule ID 6605 //
     /*  640525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  640536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  640539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  640542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  640545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640571 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640593 */     GIR_RootConstrainSelectedInstOperands,
     /*  640594 */     // GIR_Coverage, 6605,
     /*  640594 */     GIR_EraseRootFromParent_Done,
     /*  640595 */   // Label 10270: @640595
     /*  640595 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(640670), // Rule ID 6608 //
     /*  640600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  640620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640668 */     GIR_RootConstrainSelectedInstOperands,
     /*  640669 */     // GIR_Coverage, 6608,
     /*  640669 */     GIR_EraseRootFromParent_Done,
     /*  640670 */   // Label 10271: @640670
     /*  640670 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(640745), // Rule ID 6609 //
     /*  640675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  640695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  640724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640743 */     GIR_RootConstrainSelectedInstOperands,
     /*  640744 */     // GIR_Coverage, 6609,
     /*  640744 */     GIR_EraseRootFromParent_Done,
     /*  640745 */   // Label 10272: @640745
     /*  640745 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(640820), // Rule ID 6612 //
     /*  640750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  640770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640818 */     GIR_RootConstrainSelectedInstOperands,
     /*  640819 */     // GIR_Coverage, 6612,
     /*  640819 */     GIR_EraseRootFromParent_Done,
     /*  640820 */   // Label 10273: @640820
     /*  640820 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(640895), // Rule ID 6613 //
     /*  640825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  640845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  640874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640893 */     GIR_RootConstrainSelectedInstOperands,
     /*  640894 */     // GIR_Coverage, 6613,
     /*  640894 */     GIR_EraseRootFromParent_Done,
     /*  640895 */   // Label 10274: @640895
     /*  640895 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(640970), // Rule ID 6616 //
     /*  640900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  640920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  640949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640968 */     GIR_RootConstrainSelectedInstOperands,
     /*  640969 */     // GIR_Coverage, 6616,
     /*  640969 */     GIR_EraseRootFromParent_Done,
     /*  640970 */   // Label 10275: @640970
     /*  640970 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(641045), // Rule ID 6617 //
     /*  640975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  640995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641043 */     GIR_RootConstrainSelectedInstOperands,
     /*  641044 */     // GIR_Coverage, 6617,
     /*  641044 */     GIR_EraseRootFromParent_Done,
     /*  641045 */   // Label 10276: @641045
     /*  641045 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(641120), // Rule ID 6620 //
     /*  641050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  641070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641118 */     GIR_RootConstrainSelectedInstOperands,
     /*  641119 */     // GIR_Coverage, 6620,
     /*  641119 */     GIR_EraseRootFromParent_Done,
     /*  641120 */   // Label 10277: @641120
     /*  641120 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(641195), // Rule ID 6621 //
     /*  641125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  641136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  641139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  641142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  641145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641193 */     GIR_RootConstrainSelectedInstOperands,
     /*  641194 */     // GIR_Coverage, 6621,
     /*  641194 */     GIR_EraseRootFromParent_Done,
     /*  641195 */   // Label 10278: @641195
     /*  641195 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(641270), // Rule ID 6624 //
     /*  641200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  641220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641268 */     GIR_RootConstrainSelectedInstOperands,
     /*  641269 */     // GIR_Coverage, 6624,
     /*  641269 */     GIR_EraseRootFromParent_Done,
     /*  641270 */   // Label 10279: @641270
     /*  641270 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(641345), // Rule ID 6625 //
     /*  641275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  641286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  641289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  641292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  641295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641343 */     GIR_RootConstrainSelectedInstOperands,
     /*  641344 */     // GIR_Coverage, 6625,
     /*  641344 */     GIR_EraseRootFromParent_Done,
     /*  641345 */   // Label 10280: @641345
     /*  641345 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(641420), // Rule ID 6628 //
     /*  641350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  641370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641418 */     GIR_RootConstrainSelectedInstOperands,
     /*  641419 */     // GIR_Coverage, 6628,
     /*  641419 */     GIR_EraseRootFromParent_Done,
     /*  641420 */   // Label 10281: @641420
     /*  641420 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(641495), // Rule ID 6629 //
     /*  641425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  641436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  641439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  641442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  641445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641493 */     GIR_RootConstrainSelectedInstOperands,
     /*  641494 */     // GIR_Coverage, 6629,
     /*  641494 */     GIR_EraseRootFromParent_Done,
     /*  641495 */   // Label 10282: @641495
     /*  641495 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(641570), // Rule ID 6632 //
     /*  641500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  641520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641568 */     GIR_RootConstrainSelectedInstOperands,
     /*  641569 */     // GIR_Coverage, 6632,
     /*  641569 */     GIR_EraseRootFromParent_Done,
     /*  641570 */   // Label 10283: @641570
     /*  641570 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(641645), // Rule ID 6633 //
     /*  641575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  641595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  641624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641643 */     GIR_RootConstrainSelectedInstOperands,
     /*  641644 */     // GIR_Coverage, 6633,
     /*  641644 */     GIR_EraseRootFromParent_Done,
     /*  641645 */   // Label 10284: @641645
     /*  641645 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(641720), // Rule ID 6636 //
     /*  641650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  641670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641718 */     GIR_RootConstrainSelectedInstOperands,
     /*  641719 */     // GIR_Coverage, 6636,
     /*  641719 */     GIR_EraseRootFromParent_Done,
     /*  641720 */   // Label 10285: @641720
     /*  641720 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(641795), // Rule ID 6637 //
     /*  641725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  641745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641771 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  641774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641793 */     GIR_RootConstrainSelectedInstOperands,
     /*  641794 */     // GIR_Coverage, 6637,
     /*  641794 */     GIR_EraseRootFromParent_Done,
     /*  641795 */   // Label 10286: @641795
     /*  641795 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(641870), // Rule ID 6640 //
     /*  641800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  641820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641868 */     GIR_RootConstrainSelectedInstOperands,
     /*  641869 */     // GIR_Coverage, 6640,
     /*  641869 */     GIR_EraseRootFromParent_Done,
     /*  641870 */   // Label 10287: @641870
     /*  641870 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(641945), // Rule ID 6641 //
     /*  641875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  641895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  641924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641943 */     GIR_RootConstrainSelectedInstOperands,
     /*  641944 */     // GIR_Coverage, 6641,
     /*  641944 */     GIR_EraseRootFromParent_Done,
     /*  641945 */   // Label 10288: @641945
     /*  641945 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(642020), // Rule ID 6644 //
     /*  641950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  641999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642018 */     GIR_RootConstrainSelectedInstOperands,
     /*  642019 */     // GIR_Coverage, 6644,
     /*  642019 */     GIR_EraseRootFromParent_Done,
     /*  642020 */   // Label 10289: @642020
     /*  642020 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(642095), // Rule ID 6645 //
     /*  642025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  642036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  642039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  642042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  642074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642093 */     GIR_RootConstrainSelectedInstOperands,
     /*  642094 */     // GIR_Coverage, 6645,
     /*  642094 */     GIR_EraseRootFromParent_Done,
     /*  642095 */   // Label 10290: @642095
     /*  642095 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(642170), // Rule ID 6648 //
     /*  642100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642168 */     GIR_RootConstrainSelectedInstOperands,
     /*  642169 */     // GIR_Coverage, 6648,
     /*  642169 */     GIR_EraseRootFromParent_Done,
     /*  642170 */   // Label 10291: @642170
     /*  642170 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(642245), // Rule ID 6649 //
     /*  642175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  642186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  642189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  642192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642243 */     GIR_RootConstrainSelectedInstOperands,
     /*  642244 */     // GIR_Coverage, 6649,
     /*  642244 */     GIR_EraseRootFromParent_Done,
     /*  642245 */   // Label 10292: @642245
     /*  642245 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(642320), // Rule ID 6652 //
     /*  642250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642318 */     GIR_RootConstrainSelectedInstOperands,
     /*  642319 */     // GIR_Coverage, 6652,
     /*  642319 */     GIR_EraseRootFromParent_Done,
     /*  642320 */   // Label 10293: @642320
     /*  642320 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(642395), // Rule ID 6653 //
     /*  642325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  642336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  642339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  642342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642393 */     GIR_RootConstrainSelectedInstOperands,
     /*  642394 */     // GIR_Coverage, 6653,
     /*  642394 */     GIR_EraseRootFromParent_Done,
     /*  642395 */   // Label 10294: @642395
     /*  642395 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(642470), // Rule ID 6656 //
     /*  642400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642468 */     GIR_RootConstrainSelectedInstOperands,
     /*  642469 */     // GIR_Coverage, 6656,
     /*  642469 */     GIR_EraseRootFromParent_Done,
     /*  642470 */   // Label 10295: @642470
     /*  642470 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(642545), // Rule ID 6657 //
     /*  642475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  642486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  642489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  642492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  642524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642543 */     GIR_RootConstrainSelectedInstOperands,
     /*  642544 */     // GIR_Coverage, 6657,
     /*  642544 */     GIR_EraseRootFromParent_Done,
     /*  642545 */   // Label 10296: @642545
     /*  642545 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(642620), // Rule ID 6660 //
     /*  642550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642618 */     GIR_RootConstrainSelectedInstOperands,
     /*  642619 */     // GIR_Coverage, 6660,
     /*  642619 */     GIR_EraseRootFromParent_Done,
     /*  642620 */   // Label 10297: @642620
     /*  642620 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(642695), // Rule ID 6661 //
     /*  642625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642693 */     GIR_RootConstrainSelectedInstOperands,
     /*  642694 */     // GIR_Coverage, 6661,
     /*  642694 */     GIR_EraseRootFromParent_Done,
     /*  642695 */   // Label 10298: @642695
     /*  642695 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(642770), // Rule ID 6664 //
     /*  642700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642768 */     GIR_RootConstrainSelectedInstOperands,
     /*  642769 */     // GIR_Coverage, 6664,
     /*  642769 */     GIR_EraseRootFromParent_Done,
     /*  642770 */   // Label 10299: @642770
     /*  642770 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(642845), // Rule ID 6665 //
     /*  642775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  642824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642843 */     GIR_RootConstrainSelectedInstOperands,
     /*  642844 */     // GIR_Coverage, 6665,
     /*  642844 */     GIR_EraseRootFromParent_Done,
     /*  642845 */   // Label 10300: @642845
     /*  642845 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(642920), // Rule ID 6668 //
     /*  642850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  642870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  642899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642918 */     GIR_RootConstrainSelectedInstOperands,
     /*  642919 */     // GIR_Coverage, 6668,
     /*  642919 */     GIR_EraseRootFromParent_Done,
     /*  642920 */   // Label 10301: @642920
     /*  642920 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(642995), // Rule ID 6669 //
     /*  642925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  642933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  642945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  642964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  642974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642993 */     GIR_RootConstrainSelectedInstOperands,
     /*  642994 */     // GIR_Coverage, 6669,
     /*  642994 */     GIR_EraseRootFromParent_Done,
     /*  642995 */   // Label 10302: @642995
     /*  642995 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(643070), // Rule ID 6672 //
     /*  643000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643068 */     GIR_RootConstrainSelectedInstOperands,
     /*  643069 */     // GIR_Coverage, 6672,
     /*  643069 */     GIR_EraseRootFromParent_Done,
     /*  643070 */   // Label 10303: @643070
     /*  643070 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(643145), // Rule ID 6673 //
     /*  643075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  643086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  643089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  643092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643143 */     GIR_RootConstrainSelectedInstOperands,
     /*  643144 */     // GIR_Coverage, 6673,
     /*  643144 */     GIR_EraseRootFromParent_Done,
     /*  643145 */   // Label 10304: @643145
     /*  643145 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(643220), // Rule ID 6676 //
     /*  643150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643218 */     GIR_RootConstrainSelectedInstOperands,
     /*  643219 */     // GIR_Coverage, 6676,
     /*  643219 */     GIR_EraseRootFromParent_Done,
     /*  643220 */   // Label 10305: @643220
     /*  643220 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(643295), // Rule ID 6677 //
     /*  643225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  643236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  643239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  643242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643293 */     GIR_RootConstrainSelectedInstOperands,
     /*  643294 */     // GIR_Coverage, 6677,
     /*  643294 */     GIR_EraseRootFromParent_Done,
     /*  643295 */   // Label 10306: @643295
     /*  643295 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(643370), // Rule ID 6680 //
     /*  643300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643368 */     GIR_RootConstrainSelectedInstOperands,
     /*  643369 */     // GIR_Coverage, 6680,
     /*  643369 */     GIR_EraseRootFromParent_Done,
     /*  643370 */   // Label 10307: @643370
     /*  643370 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(643445), // Rule ID 6681 //
     /*  643375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  643386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  643389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  643392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  643410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  643424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643443 */     GIR_RootConstrainSelectedInstOperands,
     /*  643444 */     // GIR_Coverage, 6681,
     /*  643444 */     GIR_EraseRootFromParent_Done,
     /*  643445 */   // Label 10308: @643445
     /*  643445 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(643520), // Rule ID 6684 //
     /*  643450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643518 */     GIR_RootConstrainSelectedInstOperands,
     /*  643519 */     // GIR_Coverage, 6684,
     /*  643519 */     GIR_EraseRootFromParent_Done,
     /*  643520 */   // Label 10309: @643520
     /*  643520 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(643595), // Rule ID 6685 //
     /*  643525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  643536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  643539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  643542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643593 */     GIR_RootConstrainSelectedInstOperands,
     /*  643594 */     // GIR_Coverage, 6685,
     /*  643594 */     GIR_EraseRootFromParent_Done,
     /*  643595 */   // Label 10310: @643595
     /*  643595 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(643670), // Rule ID 6688 //
     /*  643600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  643649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643668 */     GIR_RootConstrainSelectedInstOperands,
     /*  643669 */     // GIR_Coverage, 6688,
     /*  643669 */     GIR_EraseRootFromParent_Done,
     /*  643670 */   // Label 10311: @643670
     /*  643670 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(643745), // Rule ID 6689 //
     /*  643675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  643724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643743 */     GIR_RootConstrainSelectedInstOperands,
     /*  643744 */     // GIR_Coverage, 6689,
     /*  643744 */     GIR_EraseRootFromParent_Done,
     /*  643745 */   // Label 10312: @643745
     /*  643745 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(643820), // Rule ID 6692 //
     /*  643750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  643799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643818 */     GIR_RootConstrainSelectedInstOperands,
     /*  643819 */     // GIR_Coverage, 6692,
     /*  643819 */     GIR_EraseRootFromParent_Done,
     /*  643820 */   // Label 10313: @643820
     /*  643820 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(643895), // Rule ID 6693 //
     /*  643825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643871 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  643874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643893 */     GIR_RootConstrainSelectedInstOperands,
     /*  643894 */     // GIR_Coverage, 6693,
     /*  643894 */     GIR_EraseRootFromParent_Done,
     /*  643895 */   // Label 10314: @643895
     /*  643895 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(643970), // Rule ID 6696 //
     /*  643900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  643920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  643939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  643949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643968 */     GIR_RootConstrainSelectedInstOperands,
     /*  643969 */     // GIR_Coverage, 6696,
     /*  643969 */     GIR_EraseRootFromParent_Done,
     /*  643970 */   // Label 10315: @643970
     /*  643970 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(644045), // Rule ID 6697 //
     /*  643975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  643983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  643995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644043 */     GIR_RootConstrainSelectedInstOperands,
     /*  644044 */     // GIR_Coverage, 6697,
     /*  644044 */     GIR_EraseRootFromParent_Done,
     /*  644045 */   // Label 10316: @644045
     /*  644045 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(644120), // Rule ID 6700 //
     /*  644050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644118 */     GIR_RootConstrainSelectedInstOperands,
     /*  644119 */     // GIR_Coverage, 6700,
     /*  644119 */     GIR_EraseRootFromParent_Done,
     /*  644120 */   // Label 10317: @644120
     /*  644120 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(644195), // Rule ID 6701 //
     /*  644125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  644136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  644139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  644142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644171 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644193 */     GIR_RootConstrainSelectedInstOperands,
     /*  644194 */     // GIR_Coverage, 6701,
     /*  644194 */     GIR_EraseRootFromParent_Done,
     /*  644195 */   // Label 10318: @644195
     /*  644195 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(644270), // Rule ID 6704 //
     /*  644200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644268 */     GIR_RootConstrainSelectedInstOperands,
     /*  644269 */     // GIR_Coverage, 6704,
     /*  644269 */     GIR_EraseRootFromParent_Done,
     /*  644270 */   // Label 10319: @644270
     /*  644270 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(644345), // Rule ID 6705 //
     /*  644275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  644286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  644289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  644292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644343 */     GIR_RootConstrainSelectedInstOperands,
     /*  644344 */     // GIR_Coverage, 6705,
     /*  644344 */     GIR_EraseRootFromParent_Done,
     /*  644345 */   // Label 10320: @644345
     /*  644345 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(644420), // Rule ID 6708 //
     /*  644350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644418 */     GIR_RootConstrainSelectedInstOperands,
     /*  644419 */     // GIR_Coverage, 6708,
     /*  644419 */     GIR_EraseRootFromParent_Done,
     /*  644420 */   // Label 10321: @644420
     /*  644420 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(644495), // Rule ID 6709 //
     /*  644425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  644436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  644439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  644442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644493 */     GIR_RootConstrainSelectedInstOperands,
     /*  644494 */     // GIR_Coverage, 6709,
     /*  644494 */     GIR_EraseRootFromParent_Done,
     /*  644495 */   // Label 10322: @644495
     /*  644495 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(644570), // Rule ID 6712 //
     /*  644500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644568 */     GIR_RootConstrainSelectedInstOperands,
     /*  644569 */     // GIR_Coverage, 6712,
     /*  644569 */     GIR_EraseRootFromParent_Done,
     /*  644570 */   // Label 10323: @644570
     /*  644570 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(644645), // Rule ID 6713 //
     /*  644575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644643 */     GIR_RootConstrainSelectedInstOperands,
     /*  644644 */     // GIR_Coverage, 6713,
     /*  644644 */     GIR_EraseRootFromParent_Done,
     /*  644645 */   // Label 10324: @644645
     /*  644645 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(644720), // Rule ID 6716 //
     /*  644650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644718 */     GIR_RootConstrainSelectedInstOperands,
     /*  644719 */     // GIR_Coverage, 6716,
     /*  644719 */     GIR_EraseRootFromParent_Done,
     /*  644720 */   // Label 10325: @644720
     /*  644720 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(644795), // Rule ID 6717 //
     /*  644725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  644774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644793 */     GIR_RootConstrainSelectedInstOperands,
     /*  644794 */     // GIR_Coverage, 6717,
     /*  644794 */     GIR_EraseRootFromParent_Done,
     /*  644795 */   // Label 10326: @644795
     /*  644795 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(644870), // Rule ID 6720 //
     /*  644800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644868 */     GIR_RootConstrainSelectedInstOperands,
     /*  644869 */     // GIR_Coverage, 6720,
     /*  644869 */     GIR_EraseRootFromParent_Done,
     /*  644870 */   // Label 10327: @644870
     /*  644870 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(644945), // Rule ID 6721 //
     /*  644875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  644924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644943 */     GIR_RootConstrainSelectedInstOperands,
     /*  644944 */     // GIR_Coverage, 6721,
     /*  644944 */     GIR_EraseRootFromParent_Done,
     /*  644945 */   // Label 10328: @644945
     /*  644945 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(645020), // Rule ID 6724 //
     /*  644950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  644958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  644999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645018 */     GIR_RootConstrainSelectedInstOperands,
     /*  645019 */     // GIR_Coverage, 6724,
     /*  645019 */     GIR_EraseRootFromParent_Done,
     /*  645020 */   // Label 10329: @645020
     /*  645020 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(645095), // Rule ID 6725 //
     /*  645025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  645036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  645039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  645042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  645074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645093 */     GIR_RootConstrainSelectedInstOperands,
     /*  645094 */     // GIR_Coverage, 6725,
     /*  645094 */     GIR_EraseRootFromParent_Done,
     /*  645095 */   // Label 10330: @645095
     /*  645095 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(645170), // Rule ID 6728 //
     /*  645100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  645103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  645149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645168 */     GIR_RootConstrainSelectedInstOperands,
     /*  645169 */     // GIR_Coverage, 6728,
     /*  645169 */     GIR_EraseRootFromParent_Done,
     /*  645170 */   // Label 10331: @645170
     /*  645170 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(645245), // Rule ID 6729 //
     /*  645175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  645183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  645186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  645189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  645192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  645210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  645224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645243 */     GIR_RootConstrainSelectedInstOperands,
     /*  645244 */     // GIR_Coverage, 6729,
     /*  645244 */     GIR_EraseRootFromParent_Done,
     /*  645245 */   // Label 10332: @645245
     /*  645245 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(645320), // Rule ID 6820 //
     /*  645250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  645270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  645299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645318 */     GIR_RootConstrainSelectedInstOperands,
     /*  645319 */     // GIR_Coverage, 6820,
     /*  645319 */     GIR_EraseRootFromParent_Done,
     /*  645320 */   // Label 10333: @645320
     /*  645320 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(645395), // Rule ID 6821 //
     /*  645325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  645336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  645339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  645342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  645345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  645374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645393 */     GIR_RootConstrainSelectedInstOperands,
     /*  645394 */     // GIR_Coverage, 6821,
     /*  645394 */     GIR_EraseRootFromParent_Done,
     /*  645395 */   // Label 10334: @645395
     /*  645395 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(645470), // Rule ID 6824 //
     /*  645400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  645420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645468 */     GIR_RootConstrainSelectedInstOperands,
     /*  645469 */     // GIR_Coverage, 6824,
     /*  645469 */     GIR_EraseRootFromParent_Done,
     /*  645470 */   // Label 10335: @645470
     /*  645470 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(645545), // Rule ID 6825 //
     /*  645475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  645486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  645489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  645492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  645495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645543 */     GIR_RootConstrainSelectedInstOperands,
     /*  645544 */     // GIR_Coverage, 6825,
     /*  645544 */     GIR_EraseRootFromParent_Done,
     /*  645545 */   // Label 10336: @645545
     /*  645545 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(645620), // Rule ID 6828 //
     /*  645550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  645570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645618 */     GIR_RootConstrainSelectedInstOperands,
     /*  645619 */     // GIR_Coverage, 6828,
     /*  645619 */     GIR_EraseRootFromParent_Done,
     /*  645620 */   // Label 10337: @645620
     /*  645620 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(645695), // Rule ID 6829 //
     /*  645625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  645645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645693 */     GIR_RootConstrainSelectedInstOperands,
     /*  645694 */     // GIR_Coverage, 6829,
     /*  645694 */     GIR_EraseRootFromParent_Done,
     /*  645695 */   // Label 10338: @645695
     /*  645695 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(645770), // Rule ID 6832 //
     /*  645700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  645720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645768 */     GIR_RootConstrainSelectedInstOperands,
     /*  645769 */     // GIR_Coverage, 6832,
     /*  645769 */     GIR_EraseRootFromParent_Done,
     /*  645770 */   // Label 10339: @645770
     /*  645770 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(645845), // Rule ID 6833 //
     /*  645775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  645795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  645824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645843 */     GIR_RootConstrainSelectedInstOperands,
     /*  645844 */     // GIR_Coverage, 6833,
     /*  645844 */     GIR_EraseRootFromParent_Done,
     /*  645845 */   // Label 10340: @645845
     /*  645845 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(645920), // Rule ID 6836 //
     /*  645850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  645870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645918 */     GIR_RootConstrainSelectedInstOperands,
     /*  645919 */     // GIR_Coverage, 6836,
     /*  645919 */     GIR_EraseRootFromParent_Done,
     /*  645920 */   // Label 10341: @645920
     /*  645920 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(645995), // Rule ID 6837 //
     /*  645925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  645945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  645974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645993 */     GIR_RootConstrainSelectedInstOperands,
     /*  645994 */     // GIR_Coverage, 6837,
     /*  645994 */     GIR_EraseRootFromParent_Done,
     /*  645995 */   // Label 10342: @645995
     /*  645995 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(646070), // Rule ID 6840 //
     /*  646000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  646020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  646049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646068 */     GIR_RootConstrainSelectedInstOperands,
     /*  646069 */     // GIR_Coverage, 6840,
     /*  646069 */     GIR_EraseRootFromParent_Done,
     /*  646070 */   // Label 10343: @646070
     /*  646070 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(646145), // Rule ID 6841 //
     /*  646075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  646086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  646089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  646092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  646095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  646124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646143 */     GIR_RootConstrainSelectedInstOperands,
     /*  646144 */     // GIR_Coverage, 6841,
     /*  646144 */     GIR_EraseRootFromParent_Done,
     /*  646145 */   // Label 10344: @646145
     /*  646145 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(646220), // Rule ID 6844 //
     /*  646150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  646170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646218 */     GIR_RootConstrainSelectedInstOperands,
     /*  646219 */     // GIR_Coverage, 6844,
     /*  646219 */     GIR_EraseRootFromParent_Done,
     /*  646220 */   // Label 10345: @646220
     /*  646220 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(646295), // Rule ID 6845 //
     /*  646225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  646236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  646239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  646242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  646245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646293 */     GIR_RootConstrainSelectedInstOperands,
     /*  646294 */     // GIR_Coverage, 6845,
     /*  646294 */     GIR_EraseRootFromParent_Done,
     /*  646295 */   // Label 10346: @646295
     /*  646295 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(646370), // Rule ID 6848 //
     /*  646300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  646320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646368 */     GIR_RootConstrainSelectedInstOperands,
     /*  646369 */     // GIR_Coverage, 6848,
     /*  646369 */     GIR_EraseRootFromParent_Done,
     /*  646370 */   // Label 10347: @646370
     /*  646370 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(646445), // Rule ID 6849 //
     /*  646375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  646386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  646389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  646392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  646395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646443 */     GIR_RootConstrainSelectedInstOperands,
     /*  646444 */     // GIR_Coverage, 6849,
     /*  646444 */     GIR_EraseRootFromParent_Done,
     /*  646445 */   // Label 10348: @646445
     /*  646445 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(646520), // Rule ID 6852 //
     /*  646450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  646470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646518 */     GIR_RootConstrainSelectedInstOperands,
     /*  646519 */     // GIR_Coverage, 6852,
     /*  646519 */     GIR_EraseRootFromParent_Done,
     /*  646520 */   // Label 10349: @646520
     /*  646520 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(646595), // Rule ID 6853 //
     /*  646525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  646536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  646539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  646542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  646545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646593 */     GIR_RootConstrainSelectedInstOperands,
     /*  646594 */     // GIR_Coverage, 6853,
     /*  646594 */     GIR_EraseRootFromParent_Done,
     /*  646595 */   // Label 10350: @646595
     /*  646595 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(646670), // Rule ID 6856 //
     /*  646600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  646620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646668 */     GIR_RootConstrainSelectedInstOperands,
     /*  646669 */     // GIR_Coverage, 6856,
     /*  646669 */     GIR_EraseRootFromParent_Done,
     /*  646670 */   // Label 10351: @646670
     /*  646670 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(646745), // Rule ID 6857 //
     /*  646675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  646695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  646724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646743 */     GIR_RootConstrainSelectedInstOperands,
     /*  646744 */     // GIR_Coverage, 6857,
     /*  646744 */     GIR_EraseRootFromParent_Done,
     /*  646745 */   // Label 10352: @646745
     /*  646745 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(646820), // Rule ID 6860 //
     /*  646750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  646770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  646799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646818 */     GIR_RootConstrainSelectedInstOperands,
     /*  646819 */     // GIR_Coverage, 6860,
     /*  646819 */     GIR_EraseRootFromParent_Done,
     /*  646820 */   // Label 10353: @646820
     /*  646820 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(646895), // Rule ID 6861 //
     /*  646825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  646845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  646874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646893 */     GIR_RootConstrainSelectedInstOperands,
     /*  646894 */     // GIR_Coverage, 6861,
     /*  646894 */     GIR_EraseRootFromParent_Done,
     /*  646895 */   // Label 10354: @646895
     /*  646895 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(646970), // Rule ID 6864 //
     /*  646900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  646920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  646949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646968 */     GIR_RootConstrainSelectedInstOperands,
     /*  646969 */     // GIR_Coverage, 6864,
     /*  646969 */     GIR_EraseRootFromParent_Done,
     /*  646970 */   // Label 10355: @646970
     /*  646970 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(647045), // Rule ID 6865 //
     /*  646975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  646995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647043 */     GIR_RootConstrainSelectedInstOperands,
     /*  647044 */     // GIR_Coverage, 6865,
     /*  647044 */     GIR_EraseRootFromParent_Done,
     /*  647045 */   // Label 10356: @647045
     /*  647045 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(647120), // Rule ID 6868 //
     /*  647050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  647070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647118 */     GIR_RootConstrainSelectedInstOperands,
     /*  647119 */     // GIR_Coverage, 6868,
     /*  647119 */     GIR_EraseRootFromParent_Done,
     /*  647120 */   // Label 10357: @647120
     /*  647120 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(647195), // Rule ID 6869 //
     /*  647125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  647136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  647139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  647142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  647145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647193 */     GIR_RootConstrainSelectedInstOperands,
     /*  647194 */     // GIR_Coverage, 6869,
     /*  647194 */     GIR_EraseRootFromParent_Done,
     /*  647195 */   // Label 10358: @647195
     /*  647195 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(647270), // Rule ID 6872 //
     /*  647200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  647220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647268 */     GIR_RootConstrainSelectedInstOperands,
     /*  647269 */     // GIR_Coverage, 6872,
     /*  647269 */     GIR_EraseRootFromParent_Done,
     /*  647270 */   // Label 10359: @647270
     /*  647270 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(647345), // Rule ID 6873 //
     /*  647275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  647286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  647289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  647292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  647295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647343 */     GIR_RootConstrainSelectedInstOperands,
     /*  647344 */     // GIR_Coverage, 6873,
     /*  647344 */     GIR_EraseRootFromParent_Done,
     /*  647345 */   // Label 10360: @647345
     /*  647345 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(647420), // Rule ID 6876 //
     /*  647350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  647370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647418 */     GIR_RootConstrainSelectedInstOperands,
     /*  647419 */     // GIR_Coverage, 6876,
     /*  647419 */     GIR_EraseRootFromParent_Done,
     /*  647420 */   // Label 10361: @647420
     /*  647420 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(647495), // Rule ID 6877 //
     /*  647425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  647436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  647439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  647442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  647445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647493 */     GIR_RootConstrainSelectedInstOperands,
     /*  647494 */     // GIR_Coverage, 6877,
     /*  647494 */     GIR_EraseRootFromParent_Done,
     /*  647495 */   // Label 10362: @647495
     /*  647495 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(647570), // Rule ID 6880 //
     /*  647500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  647520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647568 */     GIR_RootConstrainSelectedInstOperands,
     /*  647569 */     // GIR_Coverage, 6880,
     /*  647569 */     GIR_EraseRootFromParent_Done,
     /*  647570 */   // Label 10363: @647570
     /*  647570 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(647645), // Rule ID 6881 //
     /*  647575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  647595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647643 */     GIR_RootConstrainSelectedInstOperands,
     /*  647644 */     // GIR_Coverage, 6881,
     /*  647644 */     GIR_EraseRootFromParent_Done,
     /*  647645 */   // Label 10364: @647645
     /*  647645 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(647720), // Rule ID 6884 //
     /*  647650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  647670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647718 */     GIR_RootConstrainSelectedInstOperands,
     /*  647719 */     // GIR_Coverage, 6884,
     /*  647719 */     GIR_EraseRootFromParent_Done,
     /*  647720 */   // Label 10365: @647720
     /*  647720 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(647795), // Rule ID 6885 //
     /*  647725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  647745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  647774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647793 */     GIR_RootConstrainSelectedInstOperands,
     /*  647794 */     // GIR_Coverage, 6885,
     /*  647794 */     GIR_EraseRootFromParent_Done,
     /*  647795 */   // Label 10366: @647795
     /*  647795 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(647870), // Rule ID 6888 //
     /*  647800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  647820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647868 */     GIR_RootConstrainSelectedInstOperands,
     /*  647869 */     // GIR_Coverage, 6888,
     /*  647869 */     GIR_EraseRootFromParent_Done,
     /*  647870 */   // Label 10367: @647870
     /*  647870 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(647945), // Rule ID 6889 //
     /*  647875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  647895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  647924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647943 */     GIR_RootConstrainSelectedInstOperands,
     /*  647944 */     // GIR_Coverage, 6889,
     /*  647944 */     GIR_EraseRootFromParent_Done,
     /*  647945 */   // Label 10368: @647945
     /*  647945 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(648020), // Rule ID 6892 //
     /*  647950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  647970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  647999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648018 */     GIR_RootConstrainSelectedInstOperands,
     /*  648019 */     // GIR_Coverage, 6892,
     /*  648019 */     GIR_EraseRootFromParent_Done,
     /*  648020 */   // Label 10369: @648020
     /*  648020 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(648095), // Rule ID 6893 //
     /*  648025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  648036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  648039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  648042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  648045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648093 */     GIR_RootConstrainSelectedInstOperands,
     /*  648094 */     // GIR_Coverage, 6893,
     /*  648094 */     GIR_EraseRootFromParent_Done,
     /*  648095 */   // Label 10370: @648095
     /*  648095 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(648170), // Rule ID 6896 //
     /*  648100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  648120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  648149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648168 */     GIR_RootConstrainSelectedInstOperands,
     /*  648169 */     // GIR_Coverage, 6896,
     /*  648169 */     GIR_EraseRootFromParent_Done,
     /*  648170 */   // Label 10371: @648170
     /*  648170 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(648245), // Rule ID 6897 //
     /*  648175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  648186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  648189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  648192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  648195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  648214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  648224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648243 */     GIR_RootConstrainSelectedInstOperands,
     /*  648244 */     // GIR_Coverage, 6897,
     /*  648244 */     GIR_EraseRootFromParent_Done,
     /*  648245 */   // Label 10372: @648245
     /*  648245 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(648320), // Rule ID 6900 //
     /*  648250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  648270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  648299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648318 */     GIR_RootConstrainSelectedInstOperands,
     /*  648319 */     // GIR_Coverage, 6900,
     /*  648319 */     GIR_EraseRootFromParent_Done,
     /*  648320 */   // Label 10373: @648320
     /*  648320 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(648395), // Rule ID 6901 //
     /*  648325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  648336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  648339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  648342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  648345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  648364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  648374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648393 */     GIR_RootConstrainSelectedInstOperands,
     /*  648394 */     // GIR_Coverage, 6901,
     /*  648394 */     GIR_EraseRootFromParent_Done,
     /*  648395 */   // Label 10374: @648395
     /*  648395 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(648470), // Rule ID 6904 //
     /*  648400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  648420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648468 */     GIR_RootConstrainSelectedInstOperands,
     /*  648469 */     // GIR_Coverage, 6904,
     /*  648469 */     GIR_EraseRootFromParent_Done,
     /*  648470 */   // Label 10375: @648470
     /*  648470 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(648545), // Rule ID 6905 //
     /*  648475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  648486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  648489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  648492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  648495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  648514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  648524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648543 */     GIR_RootConstrainSelectedInstOperands,
     /*  648544 */     // GIR_Coverage, 6905,
     /*  648544 */     GIR_EraseRootFromParent_Done,
     /*  648545 */   // Label 10376: @648545
     /*  648545 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(648620), // Rule ID 6908 //
     /*  648550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  648599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648618 */     GIR_RootConstrainSelectedInstOperands,
     /*  648619 */     // GIR_Coverage, 6908,
     /*  648619 */     GIR_EraseRootFromParent_Done,
     /*  648620 */   // Label 10377: @648620
     /*  648620 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(648695), // Rule ID 6909 //
     /*  648625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  648674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648693 */     GIR_RootConstrainSelectedInstOperands,
     /*  648694 */     // GIR_Coverage, 6909,
     /*  648694 */     GIR_EraseRootFromParent_Done,
     /*  648695 */   // Label 10378: @648695
     /*  648695 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(648770), // Rule ID 6912 //
     /*  648700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  648749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648768 */     GIR_RootConstrainSelectedInstOperands,
     /*  648769 */     // GIR_Coverage, 6912,
     /*  648769 */     GIR_EraseRootFromParent_Done,
     /*  648770 */   // Label 10379: @648770
     /*  648770 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(648845), // Rule ID 6913 //
     /*  648775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  648824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648843 */     GIR_RootConstrainSelectedInstOperands,
     /*  648844 */     // GIR_Coverage, 6913,
     /*  648844 */     GIR_EraseRootFromParent_Done,
     /*  648845 */   // Label 10380: @648845
     /*  648845 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(648920), // Rule ID 6916 //
     /*  648850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  648870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  648899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648918 */     GIR_RootConstrainSelectedInstOperands,
     /*  648919 */     // GIR_Coverage, 6916,
     /*  648919 */     GIR_EraseRootFromParent_Done,
     /*  648920 */   // Label 10381: @648920
     /*  648920 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(648995), // Rule ID 6917 //
     /*  648925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  648933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  648945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  648964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  648974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648993 */     GIR_RootConstrainSelectedInstOperands,
     /*  648994 */     // GIR_Coverage, 6917,
     /*  648994 */     GIR_EraseRootFromParent_Done,
     /*  648995 */   // Label 10382: @648995
     /*  648995 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(649070), // Rule ID 6920 //
     /*  649000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  649049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649068 */     GIR_RootConstrainSelectedInstOperands,
     /*  649069 */     // GIR_Coverage, 6920,
     /*  649069 */     GIR_EraseRootFromParent_Done,
     /*  649070 */   // Label 10383: @649070
     /*  649070 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(649145), // Rule ID 6921 //
     /*  649075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  649086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  649089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  649092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  649124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649143 */     GIR_RootConstrainSelectedInstOperands,
     /*  649144 */     // GIR_Coverage, 6921,
     /*  649144 */     GIR_EraseRootFromParent_Done,
     /*  649145 */   // Label 10384: @649145
     /*  649145 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(649220), // Rule ID 6924 //
     /*  649150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649218 */     GIR_RootConstrainSelectedInstOperands,
     /*  649219 */     // GIR_Coverage, 6924,
     /*  649219 */     GIR_EraseRootFromParent_Done,
     /*  649220 */   // Label 10385: @649220
     /*  649220 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(649295), // Rule ID 6925 //
     /*  649225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  649236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  649239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  649242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649293 */     GIR_RootConstrainSelectedInstOperands,
     /*  649294 */     // GIR_Coverage, 6925,
     /*  649294 */     GIR_EraseRootFromParent_Done,
     /*  649295 */   // Label 10386: @649295
     /*  649295 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(649370), // Rule ID 6928 //
     /*  649300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649368 */     GIR_RootConstrainSelectedInstOperands,
     /*  649369 */     // GIR_Coverage, 6928,
     /*  649369 */     GIR_EraseRootFromParent_Done,
     /*  649370 */   // Label 10387: @649370
     /*  649370 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(649445), // Rule ID 6929 //
     /*  649375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  649386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  649389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  649392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  649424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649443 */     GIR_RootConstrainSelectedInstOperands,
     /*  649444 */     // GIR_Coverage, 6929,
     /*  649444 */     GIR_EraseRootFromParent_Done,
     /*  649445 */   // Label 10388: @649445
     /*  649445 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(649520), // Rule ID 6932 //
     /*  649450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649518 */     GIR_RootConstrainSelectedInstOperands,
     /*  649519 */     // GIR_Coverage, 6932,
     /*  649519 */     GIR_EraseRootFromParent_Done,
     /*  649520 */   // Label 10389: @649520
     /*  649520 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(649595), // Rule ID 6933 //
     /*  649525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  649536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  649539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  649542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649593 */     GIR_RootConstrainSelectedInstOperands,
     /*  649594 */     // GIR_Coverage, 6933,
     /*  649594 */     GIR_EraseRootFromParent_Done,
     /*  649595 */   // Label 10390: @649595
     /*  649595 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(649670), // Rule ID 6936 //
     /*  649600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649668 */     GIR_RootConstrainSelectedInstOperands,
     /*  649669 */     // GIR_Coverage, 6936,
     /*  649669 */     GIR_EraseRootFromParent_Done,
     /*  649670 */   // Label 10391: @649670
     /*  649670 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(649745), // Rule ID 6937 //
     /*  649675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649743 */     GIR_RootConstrainSelectedInstOperands,
     /*  649744 */     // GIR_Coverage, 6937,
     /*  649744 */     GIR_EraseRootFromParent_Done,
     /*  649745 */   // Label 10392: @649745
     /*  649745 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(649820), // Rule ID 6940 //
     /*  649750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649818 */     GIR_RootConstrainSelectedInstOperands,
     /*  649819 */     // GIR_Coverage, 6940,
     /*  649819 */     GIR_EraseRootFromParent_Done,
     /*  649820 */   // Label 10393: @649820
     /*  649820 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(649895), // Rule ID 6941 //
     /*  649825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649893 */     GIR_RootConstrainSelectedInstOperands,
     /*  649894 */     // GIR_Coverage, 6941,
     /*  649894 */     GIR_EraseRootFromParent_Done,
     /*  649895 */   // Label 10394: @649895
     /*  649895 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(649970), // Rule ID 6944 //
     /*  649900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  649920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  649939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  649949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649968 */     GIR_RootConstrainSelectedInstOperands,
     /*  649969 */     // GIR_Coverage, 6944,
     /*  649969 */     GIR_EraseRootFromParent_Done,
     /*  649970 */   // Label 10395: @649970
     /*  649970 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(650045), // Rule ID 6945 //
     /*  649975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  649983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  649995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  650024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650043 */     GIR_RootConstrainSelectedInstOperands,
     /*  650044 */     // GIR_Coverage, 6945,
     /*  650044 */     GIR_EraseRootFromParent_Done,
     /*  650045 */   // Label 10396: @650045
     /*  650045 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(650120), // Rule ID 6948 //
     /*  650050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650118 */     GIR_RootConstrainSelectedInstOperands,
     /*  650119 */     // GIR_Coverage, 6948,
     /*  650119 */     GIR_EraseRootFromParent_Done,
     /*  650120 */   // Label 10397: @650120
     /*  650120 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(650195), // Rule ID 6949 //
     /*  650125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  650136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  650139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  650142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650193 */     GIR_RootConstrainSelectedInstOperands,
     /*  650194 */     // GIR_Coverage, 6949,
     /*  650194 */     GIR_EraseRootFromParent_Done,
     /*  650195 */   // Label 10398: @650195
     /*  650195 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(650270), // Rule ID 6952 //
     /*  650200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650268 */     GIR_RootConstrainSelectedInstOperands,
     /*  650269 */     // GIR_Coverage, 6952,
     /*  650269 */     GIR_EraseRootFromParent_Done,
     /*  650270 */   // Label 10399: @650270
     /*  650270 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(650345), // Rule ID 6953 //
     /*  650275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  650286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  650289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  650292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650343 */     GIR_RootConstrainSelectedInstOperands,
     /*  650344 */     // GIR_Coverage, 6953,
     /*  650344 */     GIR_EraseRootFromParent_Done,
     /*  650345 */   // Label 10400: @650345
     /*  650345 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(650420), // Rule ID 6956 //
     /*  650350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650418 */     GIR_RootConstrainSelectedInstOperands,
     /*  650419 */     // GIR_Coverage, 6956,
     /*  650419 */     GIR_EraseRootFromParent_Done,
     /*  650420 */   // Label 10401: @650420
     /*  650420 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(650495), // Rule ID 6957 //
     /*  650425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  650436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  650439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  650442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650493 */     GIR_RootConstrainSelectedInstOperands,
     /*  650494 */     // GIR_Coverage, 6957,
     /*  650494 */     GIR_EraseRootFromParent_Done,
     /*  650495 */   // Label 10402: @650495
     /*  650495 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(650570), // Rule ID 6960 //
     /*  650500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650568 */     GIR_RootConstrainSelectedInstOperands,
     /*  650569 */     // GIR_Coverage, 6960,
     /*  650569 */     GIR_EraseRootFromParent_Done,
     /*  650570 */   // Label 10403: @650570
     /*  650570 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(650645), // Rule ID 6961 //
     /*  650575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650643 */     GIR_RootConstrainSelectedInstOperands,
     /*  650644 */     // GIR_Coverage, 6961,
     /*  650644 */     GIR_EraseRootFromParent_Done,
     /*  650645 */   // Label 10404: @650645
     /*  650645 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(650720), // Rule ID 6964 //
     /*  650650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650718 */     GIR_RootConstrainSelectedInstOperands,
     /*  650719 */     // GIR_Coverage, 6964,
     /*  650719 */     GIR_EraseRootFromParent_Done,
     /*  650720 */   // Label 10405: @650720
     /*  650720 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(650795), // Rule ID 6965 //
     /*  650725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  650774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650793 */     GIR_RootConstrainSelectedInstOperands,
     /*  650794 */     // GIR_Coverage, 6965,
     /*  650794 */     GIR_EraseRootFromParent_Done,
     /*  650795 */   // Label 10406: @650795
     /*  650795 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(650870), // Rule ID 6968 //
     /*  650800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650868 */     GIR_RootConstrainSelectedInstOperands,
     /*  650869 */     // GIR_Coverage, 6968,
     /*  650869 */     GIR_EraseRootFromParent_Done,
     /*  650870 */   // Label 10407: @650870
     /*  650870 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(650945), // Rule ID 6969 //
     /*  650875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  650924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650943 */     GIR_RootConstrainSelectedInstOperands,
     /*  650944 */     // GIR_Coverage, 6969,
     /*  650944 */     GIR_EraseRootFromParent_Done,
     /*  650945 */   // Label 10408: @650945
     /*  650945 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(651020), // Rule ID 6972 //
     /*  650950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  650958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  650999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651018 */     GIR_RootConstrainSelectedInstOperands,
     /*  651019 */     // GIR_Coverage, 6972,
     /*  651019 */     GIR_EraseRootFromParent_Done,
     /*  651020 */   // Label 10409: @651020
     /*  651020 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(651095), // Rule ID 6973 //
     /*  651025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  651036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  651039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  651042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651093 */     GIR_RootConstrainSelectedInstOperands,
     /*  651094 */     // GIR_Coverage, 6973,
     /*  651094 */     GIR_EraseRootFromParent_Done,
     /*  651095 */   // Label 10410: @651095
     /*  651095 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(651170), // Rule ID 6976 //
     /*  651100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651168 */     GIR_RootConstrainSelectedInstOperands,
     /*  651169 */     // GIR_Coverage, 6976,
     /*  651169 */     GIR_EraseRootFromParent_Done,
     /*  651170 */   // Label 10411: @651170
     /*  651170 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(651245), // Rule ID 6977 //
     /*  651175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  651186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  651189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  651192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651243 */     GIR_RootConstrainSelectedInstOperands,
     /*  651244 */     // GIR_Coverage, 6977,
     /*  651244 */     GIR_EraseRootFromParent_Done,
     /*  651245 */   // Label 10412: @651245
     /*  651245 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(651320), // Rule ID 6980 //
     /*  651250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651318 */     GIR_RootConstrainSelectedInstOperands,
     /*  651319 */     // GIR_Coverage, 6980,
     /*  651319 */     GIR_EraseRootFromParent_Done,
     /*  651320 */   // Label 10413: @651320
     /*  651320 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(651395), // Rule ID 6981 //
     /*  651325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  651336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  651339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  651342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651393 */     GIR_RootConstrainSelectedInstOperands,
     /*  651394 */     // GIR_Coverage, 6981,
     /*  651394 */     GIR_EraseRootFromParent_Done,
     /*  651395 */   // Label 10414: @651395
     /*  651395 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(651470), // Rule ID 6984 //
     /*  651400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651468 */     GIR_RootConstrainSelectedInstOperands,
     /*  651469 */     // GIR_Coverage, 6984,
     /*  651469 */     GIR_EraseRootFromParent_Done,
     /*  651470 */   // Label 10415: @651470
     /*  651470 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(651545), // Rule ID 6985 //
     /*  651475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  651486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  651489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  651492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  651510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  651524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651543 */     GIR_RootConstrainSelectedInstOperands,
     /*  651544 */     // GIR_Coverage, 6985,
     /*  651544 */     GIR_EraseRootFromParent_Done,
     /*  651545 */   // Label 10416: @651545
     /*  651545 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(651620), // Rule ID 6988 //
     /*  651550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651618 */     GIR_RootConstrainSelectedInstOperands,
     /*  651619 */     // GIR_Coverage, 6988,
     /*  651619 */     GIR_EraseRootFromParent_Done,
     /*  651620 */   // Label 10417: @651620
     /*  651620 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(651695), // Rule ID 6989 //
     /*  651625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  651674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651693 */     GIR_RootConstrainSelectedInstOperands,
     /*  651694 */     // GIR_Coverage, 6989,
     /*  651694 */     GIR_EraseRootFromParent_Done,
     /*  651695 */   // Label 10418: @651695
     /*  651695 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(651770), // Rule ID 6992 //
     /*  651700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651768 */     GIR_RootConstrainSelectedInstOperands,
     /*  651769 */     // GIR_Coverage, 6992,
     /*  651769 */     GIR_EraseRootFromParent_Done,
     /*  651770 */   // Label 10419: @651770
     /*  651770 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(651845), // Rule ID 6993 //
     /*  651775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  651783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  651824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651843 */     GIR_RootConstrainSelectedInstOperands,
     /*  651844 */     // GIR_Coverage, 6993,
     /*  651844 */     GIR_EraseRootFromParent_Done,
     /*  651845 */   // Label 10420: @651845
     /*  651845 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(651920), // Rule ID 7084 //
     /*  651850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  651870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  651899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651918 */     GIR_RootConstrainSelectedInstOperands,
     /*  651919 */     // GIR_Coverage, 7084,
     /*  651919 */     GIR_EraseRootFromParent_Done,
     /*  651920 */   // Label 10421: @651920
     /*  651920 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(651995), // Rule ID 7085 //
     /*  651925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  651945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  651974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651993 */     GIR_RootConstrainSelectedInstOperands,
     /*  651994 */     // GIR_Coverage, 7085,
     /*  651994 */     GIR_EraseRootFromParent_Done,
     /*  651995 */   // Label 10422: @651995
     /*  651995 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(652070), // Rule ID 7088 //
     /*  652000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  652020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652068 */     GIR_RootConstrainSelectedInstOperands,
     /*  652069 */     // GIR_Coverage, 7088,
     /*  652069 */     GIR_EraseRootFromParent_Done,
     /*  652070 */   // Label 10423: @652070
     /*  652070 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(652145), // Rule ID 7089 //
     /*  652075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  652086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  652089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  652092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  652095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652143 */     GIR_RootConstrainSelectedInstOperands,
     /*  652144 */     // GIR_Coverage, 7089,
     /*  652144 */     GIR_EraseRootFromParent_Done,
     /*  652145 */   // Label 10424: @652145
     /*  652145 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(652220), // Rule ID 7092 //
     /*  652150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  652170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652218 */     GIR_RootConstrainSelectedInstOperands,
     /*  652219 */     // GIR_Coverage, 7092,
     /*  652219 */     GIR_EraseRootFromParent_Done,
     /*  652220 */   // Label 10425: @652220
     /*  652220 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(652295), // Rule ID 7093 //
     /*  652225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  652236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  652239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  652242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  652245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652293 */     GIR_RootConstrainSelectedInstOperands,
     /*  652294 */     // GIR_Coverage, 7093,
     /*  652294 */     GIR_EraseRootFromParent_Done,
     /*  652295 */   // Label 10426: @652295
     /*  652295 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(652370), // Rule ID 7096 //
     /*  652300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  652320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652368 */     GIR_RootConstrainSelectedInstOperands,
     /*  652369 */     // GIR_Coverage, 7096,
     /*  652369 */     GIR_EraseRootFromParent_Done,
     /*  652370 */   // Label 10427: @652370
     /*  652370 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(652445), // Rule ID 7097 //
     /*  652375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  652386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  652389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  652392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  652395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  652424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652443 */     GIR_RootConstrainSelectedInstOperands,
     /*  652444 */     // GIR_Coverage, 7097,
     /*  652444 */     GIR_EraseRootFromParent_Done,
     /*  652445 */   // Label 10428: @652445
     /*  652445 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(652520), // Rule ID 7100 //
     /*  652450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  652470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652518 */     GIR_RootConstrainSelectedInstOperands,
     /*  652519 */     // GIR_Coverage, 7100,
     /*  652519 */     GIR_EraseRootFromParent_Done,
     /*  652520 */   // Label 10429: @652520
     /*  652520 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(652595), // Rule ID 7101 //
     /*  652525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  652536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  652539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  652542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  652545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652593 */     GIR_RootConstrainSelectedInstOperands,
     /*  652594 */     // GIR_Coverage, 7101,
     /*  652594 */     GIR_EraseRootFromParent_Done,
     /*  652595 */   // Label 10430: @652595
     /*  652595 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(652670), // Rule ID 7104 //
     /*  652600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  652620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652668 */     GIR_RootConstrainSelectedInstOperands,
     /*  652669 */     // GIR_Coverage, 7104,
     /*  652669 */     GIR_EraseRootFromParent_Done,
     /*  652670 */   // Label 10431: @652670
     /*  652670 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(652745), // Rule ID 7105 //
     /*  652675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  652695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  652724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652743 */     GIR_RootConstrainSelectedInstOperands,
     /*  652744 */     // GIR_Coverage, 7105,
     /*  652744 */     GIR_EraseRootFromParent_Done,
     /*  652745 */   // Label 10432: @652745
     /*  652745 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(652820), // Rule ID 7108 //
     /*  652750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  652770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652818 */     GIR_RootConstrainSelectedInstOperands,
     /*  652819 */     // GIR_Coverage, 7108,
     /*  652819 */     GIR_EraseRootFromParent_Done,
     /*  652820 */   // Label 10433: @652820
     /*  652820 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(652895), // Rule ID 7109 //
     /*  652825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  652845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652893 */     GIR_RootConstrainSelectedInstOperands,
     /*  652894 */     // GIR_Coverage, 7109,
     /*  652894 */     GIR_EraseRootFromParent_Done,
     /*  652895 */   // Label 10434: @652895
     /*  652895 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(652970), // Rule ID 7112 //
     /*  652900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  652920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  652949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652968 */     GIR_RootConstrainSelectedInstOperands,
     /*  652969 */     // GIR_Coverage, 7112,
     /*  652969 */     GIR_EraseRootFromParent_Done,
     /*  652970 */   // Label 10435: @652970
     /*  652970 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(653045), // Rule ID 7113 //
     /*  652975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  652995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653043 */     GIR_RootConstrainSelectedInstOperands,
     /*  653044 */     // GIR_Coverage, 7113,
     /*  653044 */     GIR_EraseRootFromParent_Done,
     /*  653045 */   // Label 10436: @653045
     /*  653045 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(653120), // Rule ID 7116 //
     /*  653050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  653070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653118 */     GIR_RootConstrainSelectedInstOperands,
     /*  653119 */     // GIR_Coverage, 7116,
     /*  653119 */     GIR_EraseRootFromParent_Done,
     /*  653120 */   // Label 10437: @653120
     /*  653120 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(653195), // Rule ID 7117 //
     /*  653125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  653136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  653139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  653142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  653145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653193 */     GIR_RootConstrainSelectedInstOperands,
     /*  653194 */     // GIR_Coverage, 7117,
     /*  653194 */     GIR_EraseRootFromParent_Done,
     /*  653195 */   // Label 10438: @653195
     /*  653195 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(653270), // Rule ID 7120 //
     /*  653200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  653220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653268 */     GIR_RootConstrainSelectedInstOperands,
     /*  653269 */     // GIR_Coverage, 7120,
     /*  653269 */     GIR_EraseRootFromParent_Done,
     /*  653270 */   // Label 10439: @653270
     /*  653270 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(653345), // Rule ID 7121 //
     /*  653275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  653286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  653289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  653292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  653295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  653314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  653324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653343 */     GIR_RootConstrainSelectedInstOperands,
     /*  653344 */     // GIR_Coverage, 7121,
     /*  653344 */     GIR_EraseRootFromParent_Done,
     /*  653345 */   // Label 10440: @653345
     /*  653345 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(653420), // Rule ID 7124 //
     /*  653350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653418 */     GIR_RootConstrainSelectedInstOperands,
     /*  653419 */     // GIR_Coverage, 7124,
     /*  653419 */     GIR_EraseRootFromParent_Done,
     /*  653420 */   // Label 10441: @653420
     /*  653420 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(653495), // Rule ID 7125 //
     /*  653425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  653436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  653439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  653442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  653445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653493 */     GIR_RootConstrainSelectedInstOperands,
     /*  653494 */     // GIR_Coverage, 7125,
     /*  653494 */     GIR_EraseRootFromParent_Done,
     /*  653495 */   // Label 10442: @653495
     /*  653495 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(653570), // Rule ID 7128 //
     /*  653500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653568 */     GIR_RootConstrainSelectedInstOperands,
     /*  653569 */     // GIR_Coverage, 7128,
     /*  653569 */     GIR_EraseRootFromParent_Done,
     /*  653570 */   // Label 10443: @653570
     /*  653570 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(653645), // Rule ID 7129 //
     /*  653575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  653595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653643 */     GIR_RootConstrainSelectedInstOperands,
     /*  653644 */     // GIR_Coverage, 7129,
     /*  653644 */     GIR_EraseRootFromParent_Done,
     /*  653645 */   // Label 10444: @653645
     /*  653645 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(653720), // Rule ID 7132 //
     /*  653650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  653670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  653699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653718 */     GIR_RootConstrainSelectedInstOperands,
     /*  653719 */     // GIR_Coverage, 7132,
     /*  653719 */     GIR_EraseRootFromParent_Done,
     /*  653720 */   // Label 10445: @653720
     /*  653720 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(653795), // Rule ID 7133 //
     /*  653725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  653745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  653774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653793 */     GIR_RootConstrainSelectedInstOperands,
     /*  653794 */     // GIR_Coverage, 7133,
     /*  653794 */     GIR_EraseRootFromParent_Done,
     /*  653795 */   // Label 10446: @653795
     /*  653795 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(653870), // Rule ID 7136 //
     /*  653800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  653820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653868 */     GIR_RootConstrainSelectedInstOperands,
     /*  653869 */     // GIR_Coverage, 7136,
     /*  653869 */     GIR_EraseRootFromParent_Done,
     /*  653870 */   // Label 10447: @653870
     /*  653870 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(653945), // Rule ID 7137 //
     /*  653875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  653895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  653924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653943 */     GIR_RootConstrainSelectedInstOperands,
     /*  653944 */     // GIR_Coverage, 7137,
     /*  653944 */     GIR_EraseRootFromParent_Done,
     /*  653945 */   // Label 10448: @653945
     /*  653945 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(654020), // Rule ID 7140 //
     /*  653950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  653970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  653999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654018 */     GIR_RootConstrainSelectedInstOperands,
     /*  654019 */     // GIR_Coverage, 7140,
     /*  654019 */     GIR_EraseRootFromParent_Done,
     /*  654020 */   // Label 10449: @654020
     /*  654020 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(654095), // Rule ID 7141 //
     /*  654025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  654036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  654039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  654045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654093 */     GIR_RootConstrainSelectedInstOperands,
     /*  654094 */     // GIR_Coverage, 7141,
     /*  654094 */     GIR_EraseRootFromParent_Done,
     /*  654095 */   // Label 10450: @654095
     /*  654095 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(654170), // Rule ID 7144 //
     /*  654100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  654120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  654146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654168 */     GIR_RootConstrainSelectedInstOperands,
     /*  654169 */     // GIR_Coverage, 7144,
     /*  654169 */     GIR_EraseRootFromParent_Done,
     /*  654170 */   // Label 10451: @654170
     /*  654170 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(654245), // Rule ID 7145 //
     /*  654175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  654186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  654189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  654195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  654221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  654240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654243 */     GIR_RootConstrainSelectedInstOperands,
     /*  654244 */     // GIR_Coverage, 7145,
     /*  654244 */     GIR_EraseRootFromParent_Done,
     /*  654245 */   // Label 10452: @654245
     /*  654245 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(654320), // Rule ID 7148 //
     /*  654250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654318 */     GIR_RootConstrainSelectedInstOperands,
     /*  654319 */     // GIR_Coverage, 7148,
     /*  654319 */     GIR_EraseRootFromParent_Done,
     /*  654320 */   // Label 10453: @654320
     /*  654320 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(654395), // Rule ID 7149 //
     /*  654325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  654336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  654339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  654342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  654345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654393 */     GIR_RootConstrainSelectedInstOperands,
     /*  654394 */     // GIR_Coverage, 7149,
     /*  654394 */     GIR_EraseRootFromParent_Done,
     /*  654395 */   // Label 10454: @654395
     /*  654395 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(654470), // Rule ID 7152 //
     /*  654400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  654420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654468 */     GIR_RootConstrainSelectedInstOperands,
     /*  654469 */     // GIR_Coverage, 7152,
     /*  654469 */     GIR_EraseRootFromParent_Done,
     /*  654470 */   // Label 10455: @654470
     /*  654470 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(654545), // Rule ID 7153 //
     /*  654475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  654486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  654489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  654492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  654495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654543 */     GIR_RootConstrainSelectedInstOperands,
     /*  654544 */     // GIR_Coverage, 7153,
     /*  654544 */     GIR_EraseRootFromParent_Done,
     /*  654545 */   // Label 10456: @654545
     /*  654545 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(654620), // Rule ID 7156 //
     /*  654550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  654570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654618 */     GIR_RootConstrainSelectedInstOperands,
     /*  654619 */     // GIR_Coverage, 7156,
     /*  654619 */     GIR_EraseRootFromParent_Done,
     /*  654620 */   // Label 10457: @654620
     /*  654620 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(654695), // Rule ID 7157 //
     /*  654625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  654645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  654674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654693 */     GIR_RootConstrainSelectedInstOperands,
     /*  654694 */     // GIR_Coverage, 7157,
     /*  654694 */     GIR_EraseRootFromParent_Done,
     /*  654695 */   // Label 10458: @654695
     /*  654695 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(654770), // Rule ID 7160 //
     /*  654700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  654720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654768 */     GIR_RootConstrainSelectedInstOperands,
     /*  654769 */     // GIR_Coverage, 7160,
     /*  654769 */     GIR_EraseRootFromParent_Done,
     /*  654770 */   // Label 10459: @654770
     /*  654770 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(654845), // Rule ID 7161 //
     /*  654775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  654795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  654824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654843 */     GIR_RootConstrainSelectedInstOperands,
     /*  654844 */     // GIR_Coverage, 7161,
     /*  654844 */     GIR_EraseRootFromParent_Done,
     /*  654845 */   // Label 10460: @654845
     /*  654845 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(654920), // Rule ID 7164 //
     /*  654850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  654870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654918 */     GIR_RootConstrainSelectedInstOperands,
     /*  654919 */     // GIR_Coverage, 7164,
     /*  654919 */     GIR_EraseRootFromParent_Done,
     /*  654920 */   // Label 10461: @654920
     /*  654920 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(654995), // Rule ID 7165 //
     /*  654925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  654945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  654974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654993 */     GIR_RootConstrainSelectedInstOperands,
     /*  654994 */     // GIR_Coverage, 7165,
     /*  654994 */     GIR_EraseRootFromParent_Done,
     /*  654995 */   // Label 10462: @654995
     /*  654995 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(655070), // Rule ID 7168 //
     /*  655000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  655003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  655020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  655046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  655049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655068 */     GIR_RootConstrainSelectedInstOperands,
     /*  655069 */     // GIR_Coverage, 7168,
     /*  655069 */     GIR_EraseRootFromParent_Done,
     /*  655070 */   // Label 10463: @655070
     /*  655070 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(655145), // Rule ID 7169 //
     /*  655075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  655078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  655086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  655089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  655092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  655095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  655121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  655124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  655140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655143 */     GIR_RootConstrainSelectedInstOperands,
     /*  655144 */     // GIR_Coverage, 7169,
     /*  655144 */     GIR_EraseRootFromParent_Done,
     /*  655145 */   // Label 10464: @655145
     /*  655145 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(655220), // Rule ID 7172 //
     /*  655150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  655199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655218 */     GIR_RootConstrainSelectedInstOperands,
     /*  655219 */     // GIR_Coverage, 7172,
     /*  655219 */     GIR_EraseRootFromParent_Done,
     /*  655220 */   // Label 10465: @655220
     /*  655220 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(655295), // Rule ID 7173 //
     /*  655225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  655236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  655239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  655242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  655274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655293 */     GIR_RootConstrainSelectedInstOperands,
     /*  655294 */     // GIR_Coverage, 7173,
     /*  655294 */     GIR_EraseRootFromParent_Done,
     /*  655295 */   // Label 10466: @655295
     /*  655295 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(655370), // Rule ID 7176 //
     /*  655300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655368 */     GIR_RootConstrainSelectedInstOperands,
     /*  655369 */     // GIR_Coverage, 7176,
     /*  655369 */     GIR_EraseRootFromParent_Done,
     /*  655370 */   // Label 10467: @655370
     /*  655370 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(655445), // Rule ID 7177 //
     /*  655375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  655386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  655389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  655392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655443 */     GIR_RootConstrainSelectedInstOperands,
     /*  655444 */     // GIR_Coverage, 7177,
     /*  655444 */     GIR_EraseRootFromParent_Done,
     /*  655445 */   // Label 10468: @655445
     /*  655445 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(655520), // Rule ID 7180 //
     /*  655450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655518 */     GIR_RootConstrainSelectedInstOperands,
     /*  655519 */     // GIR_Coverage, 7180,
     /*  655519 */     GIR_EraseRootFromParent_Done,
     /*  655520 */   // Label 10469: @655520
     /*  655520 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(655595), // Rule ID 7181 //
     /*  655525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  655536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  655539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  655542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655593 */     GIR_RootConstrainSelectedInstOperands,
     /*  655594 */     // GIR_Coverage, 7181,
     /*  655594 */     GIR_EraseRootFromParent_Done,
     /*  655595 */   // Label 10470: @655595
     /*  655595 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(655670), // Rule ID 7184 //
     /*  655600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655668 */     GIR_RootConstrainSelectedInstOperands,
     /*  655669 */     // GIR_Coverage, 7184,
     /*  655669 */     GIR_EraseRootFromParent_Done,
     /*  655670 */   // Label 10471: @655670
     /*  655670 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(655745), // Rule ID 7185 //
     /*  655675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  655692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  655724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655743 */     GIR_RootConstrainSelectedInstOperands,
     /*  655744 */     // GIR_Coverage, 7185,
     /*  655744 */     GIR_EraseRootFromParent_Done,
     /*  655745 */   // Label 10472: @655745
     /*  655745 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(655820), // Rule ID 7188 //
     /*  655750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655818 */     GIR_RootConstrainSelectedInstOperands,
     /*  655819 */     // GIR_Coverage, 7188,
     /*  655819 */     GIR_EraseRootFromParent_Done,
     /*  655820 */   // Label 10473: @655820
     /*  655820 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(655895), // Rule ID 7189 //
     /*  655825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  655842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655893 */     GIR_RootConstrainSelectedInstOperands,
     /*  655894 */     // GIR_Coverage, 7189,
     /*  655894 */     GIR_EraseRootFromParent_Done,
     /*  655895 */   // Label 10474: @655895
     /*  655895 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(655970), // Rule ID 7192 //
     /*  655900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  655920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  655939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  655946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  655949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655968 */     GIR_RootConstrainSelectedInstOperands,
     /*  655969 */     // GIR_Coverage, 7192,
     /*  655969 */     GIR_EraseRootFromParent_Done,
     /*  655970 */   // Label 10475: @655970
     /*  655970 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(656045), // Rule ID 7193 //
     /*  655975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  655983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  655995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  656024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656043 */     GIR_RootConstrainSelectedInstOperands,
     /*  656044 */     // GIR_Coverage, 7193,
     /*  656044 */     GIR_EraseRootFromParent_Done,
     /*  656045 */   // Label 10476: @656045
     /*  656045 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(656120), // Rule ID 7196 //
     /*  656050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  656067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656118 */     GIR_RootConstrainSelectedInstOperands,
     /*  656119 */     // GIR_Coverage, 7196,
     /*  656119 */     GIR_EraseRootFromParent_Done,
     /*  656120 */   // Label 10477: @656120
     /*  656120 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(656195), // Rule ID 7197 //
     /*  656125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  656142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656193 */     GIR_RootConstrainSelectedInstOperands,
     /*  656194 */     // GIR_Coverage, 7197,
     /*  656194 */     GIR_EraseRootFromParent_Done,
     /*  656195 */   // Label 10478: @656195
     /*  656195 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(656270), // Rule ID 7200 //
     /*  656200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656268 */     GIR_RootConstrainSelectedInstOperands,
     /*  656269 */     // GIR_Coverage, 7200,
     /*  656269 */     GIR_EraseRootFromParent_Done,
     /*  656270 */   // Label 10479: @656270
     /*  656270 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(656345), // Rule ID 7201 //
     /*  656275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  656286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  656289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656343 */     GIR_RootConstrainSelectedInstOperands,
     /*  656344 */     // GIR_Coverage, 7201,
     /*  656344 */     GIR_EraseRootFromParent_Done,
     /*  656345 */   // Label 10480: @656345
     /*  656345 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(656420), // Rule ID 7204 //
     /*  656350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656418 */     GIR_RootConstrainSelectedInstOperands,
     /*  656419 */     // GIR_Coverage, 7204,
     /*  656419 */     GIR_EraseRootFromParent_Done,
     /*  656420 */   // Label 10481: @656420
     /*  656420 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(656495), // Rule ID 7205 //
     /*  656425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  656442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656493 */     GIR_RootConstrainSelectedInstOperands,
     /*  656494 */     // GIR_Coverage, 7205,
     /*  656494 */     GIR_EraseRootFromParent_Done,
     /*  656495 */   // Label 10482: @656495
     /*  656495 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(656570), // Rule ID 7208 //
     /*  656500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  656503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  656546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  656565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656568 */     GIR_RootConstrainSelectedInstOperands,
     /*  656569 */     // GIR_Coverage, 7208,
     /*  656569 */     GIR_EraseRootFromParent_Done,
     /*  656570 */   // Label 10483: @656570
     /*  656570 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(656645), // Rule ID 7209 //
     /*  656575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  656578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  656586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  656589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  656621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  656624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  656640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656643 */     GIR_RootConstrainSelectedInstOperands,
     /*  656644 */     // GIR_Coverage, 7209,
     /*  656644 */     GIR_EraseRootFromParent_Done,
     /*  656645 */   // Label 10484: @656645
     /*  656645 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(656720), // Rule ID 7212 //
     /*  656650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  656661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  656664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  656667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  656699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656718 */     GIR_RootConstrainSelectedInstOperands,
     /*  656719 */     // GIR_Coverage, 7212,
     /*  656719 */     GIR_EraseRootFromParent_Done,
     /*  656720 */   // Label 10485: @656720
     /*  656720 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(656795), // Rule ID 7213 //
     /*  656725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  656736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  656739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  656742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  656774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656793 */     GIR_RootConstrainSelectedInstOperands,
     /*  656794 */     // GIR_Coverage, 7213,
     /*  656794 */     GIR_EraseRootFromParent_Done,
     /*  656795 */   // Label 10486: @656795
     /*  656795 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(656870), // Rule ID 7216 //
     /*  656800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  656811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  656814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  656817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  656849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656868 */     GIR_RootConstrainSelectedInstOperands,
     /*  656869 */     // GIR_Coverage, 7216,
     /*  656869 */     GIR_EraseRootFromParent_Done,
     /*  656870 */   // Label 10487: @656870
     /*  656870 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(656945), // Rule ID 7217 //
     /*  656875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  656886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  656889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  656892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  656924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656943 */     GIR_RootConstrainSelectedInstOperands,
     /*  656944 */     // GIR_Coverage, 7217,
     /*  656944 */     GIR_EraseRootFromParent_Done,
     /*  656945 */   // Label 10488: @656945
     /*  656945 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(657020), // Rule ID 7220 //
     /*  656950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  656958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  656961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  656964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  656967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  656999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657018 */     GIR_RootConstrainSelectedInstOperands,
     /*  657019 */     // GIR_Coverage, 7220,
     /*  657019 */     GIR_EraseRootFromParent_Done,
     /*  657020 */   // Label 10489: @657020
     /*  657020 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(657095), // Rule ID 7221 //
     /*  657025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  657036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  657039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  657042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657093 */     GIR_RootConstrainSelectedInstOperands,
     /*  657094 */     // GIR_Coverage, 7221,
     /*  657094 */     GIR_EraseRootFromParent_Done,
     /*  657095 */   // Label 10490: @657095
     /*  657095 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(657170), // Rule ID 7224 //
     /*  657100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657168 */     GIR_RootConstrainSelectedInstOperands,
     /*  657169 */     // GIR_Coverage, 7224,
     /*  657169 */     GIR_EraseRootFromParent_Done,
     /*  657170 */   // Label 10491: @657170
     /*  657170 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(657245), // Rule ID 7225 //
     /*  657175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657243 */     GIR_RootConstrainSelectedInstOperands,
     /*  657244 */     // GIR_Coverage, 7225,
     /*  657244 */     GIR_EraseRootFromParent_Done,
     /*  657245 */   // Label 10492: @657245
     /*  657245 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(657320), // Rule ID 7228 //
     /*  657250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657318 */     GIR_RootConstrainSelectedInstOperands,
     /*  657319 */     // GIR_Coverage, 7228,
     /*  657319 */     GIR_EraseRootFromParent_Done,
     /*  657320 */   // Label 10493: @657320
     /*  657320 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(657395), // Rule ID 7229 //
     /*  657325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657393 */     GIR_RootConstrainSelectedInstOperands,
     /*  657394 */     // GIR_Coverage, 7229,
     /*  657394 */     GIR_EraseRootFromParent_Done,
     /*  657395 */   // Label 10494: @657395
     /*  657395 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(657470), // Rule ID 7232 //
     /*  657400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  657411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  657414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657468 */     GIR_RootConstrainSelectedInstOperands,
     /*  657469 */     // GIR_Coverage, 7232,
     /*  657469 */     GIR_EraseRootFromParent_Done,
     /*  657470 */   // Label 10495: @657470
     /*  657470 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(657545), // Rule ID 7233 //
     /*  657475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  657486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  657489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657543 */     GIR_RootConstrainSelectedInstOperands,
     /*  657544 */     // GIR_Coverage, 7233,
     /*  657544 */     GIR_EraseRootFromParent_Done,
     /*  657545 */   // Label 10496: @657545
     /*  657545 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(657620), // Rule ID 7236 //
     /*  657550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657618 */     GIR_RootConstrainSelectedInstOperands,
     /*  657619 */     // GIR_Coverage, 7236,
     /*  657619 */     GIR_EraseRootFromParent_Done,
     /*  657620 */   // Label 10497: @657620
     /*  657620 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(657695), // Rule ID 7237 //
     /*  657625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  657636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  657639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  657674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657693 */     GIR_RootConstrainSelectedInstOperands,
     /*  657694 */     // GIR_Coverage, 7237,
     /*  657694 */     GIR_EraseRootFromParent_Done,
     /*  657695 */   // Label 10498: @657695
     /*  657695 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(657770), // Rule ID 7240 //
     /*  657700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657768 */     GIR_RootConstrainSelectedInstOperands,
     /*  657769 */     // GIR_Coverage, 7240,
     /*  657769 */     GIR_EraseRootFromParent_Done,
     /*  657770 */   // Label 10499: @657770
     /*  657770 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(657845), // Rule ID 7241 //
     /*  657775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  657786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  657789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  657824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657843 */     GIR_RootConstrainSelectedInstOperands,
     /*  657844 */     // GIR_Coverage, 7241,
     /*  657844 */     GIR_EraseRootFromParent_Done,
     /*  657845 */   // Label 10500: @657845
     /*  657845 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(657920), // Rule ID 7244 //
     /*  657850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  657861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  657864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  657896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657918 */     GIR_RootConstrainSelectedInstOperands,
     /*  657919 */     // GIR_Coverage, 7244,
     /*  657919 */     GIR_EraseRootFromParent_Done,
     /*  657920 */   // Label 10501: @657920
     /*  657920 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(657995), // Rule ID 7245 //
     /*  657925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  657933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  657936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  657939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  657971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  657974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  657990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657993 */     GIR_RootConstrainSelectedInstOperands,
     /*  657994 */     // GIR_Coverage, 7245,
     /*  657994 */     GIR_EraseRootFromParent_Done,
     /*  657995 */   // Label 10502: @657995
     /*  657995 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(658070), // Rule ID 7248 //
     /*  658000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  658011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  658014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  658049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658068 */     GIR_RootConstrainSelectedInstOperands,
     /*  658069 */     // GIR_Coverage, 7248,
     /*  658069 */     GIR_EraseRootFromParent_Done,
     /*  658070 */   // Label 10503: @658070
     /*  658070 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(658145), // Rule ID 7249 //
     /*  658075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  658086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  658089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  658124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658143 */     GIR_RootConstrainSelectedInstOperands,
     /*  658144 */     // GIR_Coverage, 7249,
     /*  658144 */     GIR_EraseRootFromParent_Done,
     /*  658145 */   // Label 10504: @658145
     /*  658145 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(658220), // Rule ID 7252 //
     /*  658150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  658161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  658164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  658199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658218 */     GIR_RootConstrainSelectedInstOperands,
     /*  658219 */     // GIR_Coverage, 7252,
     /*  658219 */     GIR_EraseRootFromParent_Done,
     /*  658220 */   // Label 10505: @658220
     /*  658220 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(658295), // Rule ID 7253 //
     /*  658225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  658236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  658239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  658274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658293 */     GIR_RootConstrainSelectedInstOperands,
     /*  658294 */     // GIR_Coverage, 7253,
     /*  658294 */     GIR_EraseRootFromParent_Done,
     /*  658295 */   // Label 10506: @658295
     /*  658295 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(658370), // Rule ID 7256 //
     /*  658300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  658303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  658311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  658314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  658346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  658349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658368 */     GIR_RootConstrainSelectedInstOperands,
     /*  658369 */     // GIR_Coverage, 7256,
     /*  658369 */     GIR_EraseRootFromParent_Done,
     /*  658370 */   // Label 10507: @658370
     /*  658370 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(658445), // Rule ID 7257 //
     /*  658375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  658378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  658383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  658386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  658389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  658421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  658424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  658440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658443 */     GIR_RootConstrainSelectedInstOperands,
     /*  658444 */     // GIR_Coverage, 7257,
     /*  658444 */     GIR_EraseRootFromParent_Done,
     /*  658445 */   // Label 10508: @658445
     /*  658445 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(658520), // Rule ID 7436 //
     /*  658450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  658499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658518 */     GIR_RootConstrainSelectedInstOperands,
     /*  658519 */     // GIR_Coverage, 7436,
     /*  658519 */     GIR_EraseRootFromParent_Done,
     /*  658520 */   // Label 10509: @658520
     /*  658520 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(658595), // Rule ID 7437 //
     /*  658525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  658574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658593 */     GIR_RootConstrainSelectedInstOperands,
     /*  658594 */     // GIR_Coverage, 7437,
     /*  658594 */     GIR_EraseRootFromParent_Done,
     /*  658595 */   // Label 10510: @658595
     /*  658595 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(658670), // Rule ID 7440 //
     /*  658600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  658649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658668 */     GIR_RootConstrainSelectedInstOperands,
     /*  658669 */     // GIR_Coverage, 7440,
     /*  658669 */     GIR_EraseRootFromParent_Done,
     /*  658670 */   // Label 10511: @658670
     /*  658670 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(658745), // Rule ID 7441 //
     /*  658675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  658724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658743 */     GIR_RootConstrainSelectedInstOperands,
     /*  658744 */     // GIR_Coverage, 7441,
     /*  658744 */     GIR_EraseRootFromParent_Done,
     /*  658745 */   // Label 10512: @658745
     /*  658745 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(658820), // Rule ID 7444 //
     /*  658750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  658799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658818 */     GIR_RootConstrainSelectedInstOperands,
     /*  658819 */     // GIR_Coverage, 7444,
     /*  658819 */     GIR_EraseRootFromParent_Done,
     /*  658820 */   // Label 10513: @658820
     /*  658820 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(658895), // Rule ID 7445 //
     /*  658825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  658874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658893 */     GIR_RootConstrainSelectedInstOperands,
     /*  658894 */     // GIR_Coverage, 7445,
     /*  658894 */     GIR_EraseRootFromParent_Done,
     /*  658895 */   // Label 10514: @658895
     /*  658895 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(658970), // Rule ID 7448 //
     /*  658900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  658911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  658914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  658920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  658949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658968 */     GIR_RootConstrainSelectedInstOperands,
     /*  658969 */     // GIR_Coverage, 7448,
     /*  658969 */     GIR_EraseRootFromParent_Done,
     /*  658970 */   // Label 10515: @658970
     /*  658970 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(659045), // Rule ID 7449 //
     /*  658975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  658986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  658989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  658992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  658995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659021 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659043 */     GIR_RootConstrainSelectedInstOperands,
     /*  659044 */     // GIR_Coverage, 7449,
     /*  659044 */     GIR_EraseRootFromParent_Done,
     /*  659045 */   // Label 10516: @659045
     /*  659045 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(659120), // Rule ID 7452 //
     /*  659050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659118 */     GIR_RootConstrainSelectedInstOperands,
     /*  659119 */     // GIR_Coverage, 7452,
     /*  659119 */     GIR_EraseRootFromParent_Done,
     /*  659120 */   // Label 10517: @659120
     /*  659120 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(659195), // Rule ID 7453 //
     /*  659125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659193 */     GIR_RootConstrainSelectedInstOperands,
     /*  659194 */     // GIR_Coverage, 7453,
     /*  659194 */     GIR_EraseRootFromParent_Done,
     /*  659195 */   // Label 10518: @659195
     /*  659195 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(659270), // Rule ID 7456 //
     /*  659200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659268 */     GIR_RootConstrainSelectedInstOperands,
     /*  659269 */     // GIR_Coverage, 7456,
     /*  659269 */     GIR_EraseRootFromParent_Done,
     /*  659270 */   // Label 10519: @659270
     /*  659270 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(659345), // Rule ID 7457 //
     /*  659275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659343 */     GIR_RootConstrainSelectedInstOperands,
     /*  659344 */     // GIR_Coverage, 7457,
     /*  659344 */     GIR_EraseRootFromParent_Done,
     /*  659345 */   // Label 10520: @659345
     /*  659345 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(659420), // Rule ID 7460 //
     /*  659350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  659399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659418 */     GIR_RootConstrainSelectedInstOperands,
     /*  659419 */     // GIR_Coverage, 7460,
     /*  659419 */     GIR_EraseRootFromParent_Done,
     /*  659420 */   // Label 10521: @659420
     /*  659420 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(659495), // Rule ID 7461 //
     /*  659425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  659474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659493 */     GIR_RootConstrainSelectedInstOperands,
     /*  659494 */     // GIR_Coverage, 7461,
     /*  659494 */     GIR_EraseRootFromParent_Done,
     /*  659495 */   // Label 10522: @659495
     /*  659495 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(659570), // Rule ID 7464 //
     /*  659500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  659549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659568 */     GIR_RootConstrainSelectedInstOperands,
     /*  659569 */     // GIR_Coverage, 7464,
     /*  659569 */     GIR_EraseRootFromParent_Done,
     /*  659570 */   // Label 10523: @659570
     /*  659570 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(659645), // Rule ID 7465 //
     /*  659575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659621 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  659624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659643 */     GIR_RootConstrainSelectedInstOperands,
     /*  659644 */     // GIR_Coverage, 7465,
     /*  659644 */     GIR_EraseRootFromParent_Done,
     /*  659645 */   // Label 10524: @659645
     /*  659645 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(659720), // Rule ID 7468 //
     /*  659650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659718 */     GIR_RootConstrainSelectedInstOperands,
     /*  659719 */     // GIR_Coverage, 7468,
     /*  659719 */     GIR_EraseRootFromParent_Done,
     /*  659720 */   // Label 10525: @659720
     /*  659720 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(659795), // Rule ID 7469 //
     /*  659725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659771 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  659774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659793 */     GIR_RootConstrainSelectedInstOperands,
     /*  659794 */     // GIR_Coverage, 7469,
     /*  659794 */     GIR_EraseRootFromParent_Done,
     /*  659795 */   // Label 10526: @659795
     /*  659795 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(659870), // Rule ID 7472 //
     /*  659800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  659811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  659814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  659820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659868 */     GIR_RootConstrainSelectedInstOperands,
     /*  659869 */     // GIR_Coverage, 7472,
     /*  659869 */     GIR_EraseRootFromParent_Done,
     /*  659870 */   // Label 10527: @659870
     /*  659870 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(659945), // Rule ID 7473 //
     /*  659875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  659886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  659889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  659895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  659924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659943 */     GIR_RootConstrainSelectedInstOperands,
     /*  659944 */     // GIR_Coverage, 7473,
     /*  659944 */     GIR_EraseRootFromParent_Done,
     /*  659945 */   // Label 10528: @659945
     /*  659945 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(660020), // Rule ID 7476 //
     /*  659950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  659961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  659964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  659967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  659970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  659999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660018 */     GIR_RootConstrainSelectedInstOperands,
     /*  660019 */     // GIR_Coverage, 7476,
     /*  660019 */     GIR_EraseRootFromParent_Done,
     /*  660020 */   // Label 10529: @660020
     /*  660020 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(660095), // Rule ID 7477 //
     /*  660025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660093 */     GIR_RootConstrainSelectedInstOperands,
     /*  660094 */     // GIR_Coverage, 7477,
     /*  660094 */     GIR_EraseRootFromParent_Done,
     /*  660095 */   // Label 10530: @660095
     /*  660095 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(660170), // Rule ID 7480 //
     /*  660100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  660149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660168 */     GIR_RootConstrainSelectedInstOperands,
     /*  660169 */     // GIR_Coverage, 7480,
     /*  660169 */     GIR_EraseRootFromParent_Done,
     /*  660170 */   // Label 10531: @660170
     /*  660170 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(660245), // Rule ID 7481 //
     /*  660175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  660224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660243 */     GIR_RootConstrainSelectedInstOperands,
     /*  660244 */     // GIR_Coverage, 7481,
     /*  660244 */     GIR_EraseRootFromParent_Done,
     /*  660245 */   // Label 10532: @660245
     /*  660245 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(660320), // Rule ID 7484 //
     /*  660250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  660299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660318 */     GIR_RootConstrainSelectedInstOperands,
     /*  660319 */     // GIR_Coverage, 7484,
     /*  660319 */     GIR_EraseRootFromParent_Done,
     /*  660320 */   // Label 10533: @660320
     /*  660320 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(660395), // Rule ID 7485 //
     /*  660325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  660374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660393 */     GIR_RootConstrainSelectedInstOperands,
     /*  660394 */     // GIR_Coverage, 7485,
     /*  660394 */     GIR_EraseRootFromParent_Done,
     /*  660395 */   // Label 10534: @660395
     /*  660395 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(660470), // Rule ID 7488 //
     /*  660400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  660449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660468 */     GIR_RootConstrainSelectedInstOperands,
     /*  660469 */     // GIR_Coverage, 7488,
     /*  660469 */     GIR_EraseRootFromParent_Done,
     /*  660470 */   // Label 10535: @660470
     /*  660470 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(660545), // Rule ID 7489 //
     /*  660475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  660524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660543 */     GIR_RootConstrainSelectedInstOperands,
     /*  660544 */     // GIR_Coverage, 7489,
     /*  660544 */     GIR_EraseRootFromParent_Done,
     /*  660545 */   // Label 10536: @660545
     /*  660545 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(660620), // Rule ID 7492 //
     /*  660550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660618 */     GIR_RootConstrainSelectedInstOperands,
     /*  660619 */     // GIR_Coverage, 7492,
     /*  660619 */     GIR_EraseRootFromParent_Done,
     /*  660620 */   // Label 10537: @660620
     /*  660620 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(660695), // Rule ID 7493 //
     /*  660625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  660674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660693 */     GIR_RootConstrainSelectedInstOperands,
     /*  660694 */     // GIR_Coverage, 7493,
     /*  660694 */     GIR_EraseRootFromParent_Done,
     /*  660695 */   // Label 10538: @660695
     /*  660695 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(660770), // Rule ID 7496 //
     /*  660700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  660749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660768 */     GIR_RootConstrainSelectedInstOperands,
     /*  660769 */     // GIR_Coverage, 7496,
     /*  660769 */     GIR_EraseRootFromParent_Done,
     /*  660770 */   // Label 10539: @660770
     /*  660770 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(660845), // Rule ID 7497 //
     /*  660775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  660824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660843 */     GIR_RootConstrainSelectedInstOperands,
     /*  660844 */     // GIR_Coverage, 7497,
     /*  660844 */     GIR_EraseRootFromParent_Done,
     /*  660845 */   // Label 10540: @660845
     /*  660845 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(660920), // Rule ID 7500 //
     /*  660850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  660861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  660864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660896 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  660899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660918 */     GIR_RootConstrainSelectedInstOperands,
     /*  660919 */     // GIR_Coverage, 7500,
     /*  660919 */     GIR_EraseRootFromParent_Done,
     /*  660920 */   // Label 10541: @660920
     /*  660920 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(660995), // Rule ID 7501 //
     /*  660925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  660933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  660936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  660939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  660942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660971 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  660974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660993 */     GIR_RootConstrainSelectedInstOperands,
     /*  660994 */     // GIR_Coverage, 7501,
     /*  660994 */     GIR_EraseRootFromParent_Done,
     /*  660995 */   // Label 10542: @660995
     /*  660995 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(661070), // Rule ID 7504 //
     /*  661000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661068 */     GIR_RootConstrainSelectedInstOperands,
     /*  661069 */     // GIR_Coverage, 7504,
     /*  661069 */     GIR_EraseRootFromParent_Done,
     /*  661070 */   // Label 10543: @661070
     /*  661070 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(661145), // Rule ID 7505 //
     /*  661075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661121 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661143 */     GIR_RootConstrainSelectedInstOperands,
     /*  661144 */     // GIR_Coverage, 7505,
     /*  661144 */     GIR_EraseRootFromParent_Done,
     /*  661145 */   // Label 10544: @661145
     /*  661145 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(661220), // Rule ID 7508 //
     /*  661150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661218 */     GIR_RootConstrainSelectedInstOperands,
     /*  661219 */     // GIR_Coverage, 7508,
     /*  661219 */     GIR_EraseRootFromParent_Done,
     /*  661220 */   // Label 10545: @661220
     /*  661220 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(661295), // Rule ID 7509 //
     /*  661225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661293 */     GIR_RootConstrainSelectedInstOperands,
     /*  661294 */     // GIR_Coverage, 7509,
     /*  661294 */     GIR_EraseRootFromParent_Done,
     /*  661295 */   // Label 10546: @661295
     /*  661295 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(661370), // Rule ID 7512 //
     /*  661300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  661349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661368 */     GIR_RootConstrainSelectedInstOperands,
     /*  661369 */     // GIR_Coverage, 7512,
     /*  661369 */     GIR_EraseRootFromParent_Done,
     /*  661370 */   // Label 10547: @661370
     /*  661370 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(661445), // Rule ID 7513 //
     /*  661375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  661424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661443 */     GIR_RootConstrainSelectedInstOperands,
     /*  661444 */     // GIR_Coverage, 7513,
     /*  661444 */     GIR_EraseRootFromParent_Done,
     /*  661445 */   // Label 10548: @661445
     /*  661445 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(661520), // Rule ID 7516 //
     /*  661450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661496 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  661499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661518 */     GIR_RootConstrainSelectedInstOperands,
     /*  661519 */     // GIR_Coverage, 7516,
     /*  661519 */     GIR_EraseRootFromParent_Done,
     /*  661520 */   // Label 10549: @661520
     /*  661520 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(661595), // Rule ID 7517 //
     /*  661525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661571 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  661574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661593 */     GIR_RootConstrainSelectedInstOperands,
     /*  661594 */     // GIR_Coverage, 7517,
     /*  661594 */     GIR_EraseRootFromParent_Done,
     /*  661595 */   // Label 10550: @661595
     /*  661595 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(661670), // Rule ID 7520 //
     /*  661600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  661649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661668 */     GIR_RootConstrainSelectedInstOperands,
     /*  661669 */     // GIR_Coverage, 7520,
     /*  661669 */     GIR_EraseRootFromParent_Done,
     /*  661670 */   // Label 10551: @661670
     /*  661670 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(661745), // Rule ID 7521 //
     /*  661675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  661724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661743 */     GIR_RootConstrainSelectedInstOperands,
     /*  661744 */     // GIR_Coverage, 7521,
     /*  661744 */     GIR_EraseRootFromParent_Done,
     /*  661745 */   // Label 10552: @661745
     /*  661745 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(661820), // Rule ID 7524 //
     /*  661750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661818 */     GIR_RootConstrainSelectedInstOperands,
     /*  661819 */     // GIR_Coverage, 7524,
     /*  661819 */     GIR_EraseRootFromParent_Done,
     /*  661820 */   // Label 10553: @661820
     /*  661820 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(661895), // Rule ID 7525 //
     /*  661825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  661874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661893 */     GIR_RootConstrainSelectedInstOperands,
     /*  661894 */     // GIR_Coverage, 7525,
     /*  661894 */     GIR_EraseRootFromParent_Done,
     /*  661895 */   // Label 10554: @661895
     /*  661895 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(661970), // Rule ID 7528 //
     /*  661900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  661911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  661914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  661949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661968 */     GIR_RootConstrainSelectedInstOperands,
     /*  661969 */     // GIR_Coverage, 7528,
     /*  661969 */     GIR_EraseRootFromParent_Done,
     /*  661970 */   // Label 10555: @661970
     /*  661970 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(662045), // Rule ID 7529 //
     /*  661975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  661983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  661986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  661989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  661992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662043 */     GIR_RootConstrainSelectedInstOperands,
     /*  662044 */     // GIR_Coverage, 7529,
     /*  662044 */     GIR_EraseRootFromParent_Done,
     /*  662045 */   // Label 10556: @662045
     /*  662045 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(662120), // Rule ID 7532 //
     /*  662050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662118 */     GIR_RootConstrainSelectedInstOperands,
     /*  662119 */     // GIR_Coverage, 7532,
     /*  662119 */     GIR_EraseRootFromParent_Done,
     /*  662120 */   // Label 10557: @662120
     /*  662120 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(662195), // Rule ID 7533 //
     /*  662125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662193 */     GIR_RootConstrainSelectedInstOperands,
     /*  662194 */     // GIR_Coverage, 7533,
     /*  662194 */     GIR_EraseRootFromParent_Done,
     /*  662195 */   // Label 10558: @662195
     /*  662195 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(662270), // Rule ID 7536 //
     /*  662200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662268 */     GIR_RootConstrainSelectedInstOperands,
     /*  662269 */     // GIR_Coverage, 7536,
     /*  662269 */     GIR_EraseRootFromParent_Done,
     /*  662270 */   // Label 10559: @662270
     /*  662270 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(662345), // Rule ID 7537 //
     /*  662275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662343 */     GIR_RootConstrainSelectedInstOperands,
     /*  662344 */     // GIR_Coverage, 7537,
     /*  662344 */     GIR_EraseRootFromParent_Done,
     /*  662345 */   // Label 10560: @662345
     /*  662345 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(662420), // Rule ID 7540 //
     /*  662350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  662399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662418 */     GIR_RootConstrainSelectedInstOperands,
     /*  662419 */     // GIR_Coverage, 7540,
     /*  662419 */     GIR_EraseRootFromParent_Done,
     /*  662420 */   // Label 10561: @662420
     /*  662420 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(662495), // Rule ID 7541 //
     /*  662425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662471 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  662474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662493 */     GIR_RootConstrainSelectedInstOperands,
     /*  662494 */     // GIR_Coverage, 7541,
     /*  662494 */     GIR_EraseRootFromParent_Done,
     /*  662495 */   // Label 10562: @662495
     /*  662495 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(662570), // Rule ID 7544 //
     /*  662500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662568 */     GIR_RootConstrainSelectedInstOperands,
     /*  662569 */     // GIR_Coverage, 7544,
     /*  662569 */     GIR_EraseRootFromParent_Done,
     /*  662570 */   // Label 10563: @662570
     /*  662570 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(662645), // Rule ID 7545 //
     /*  662575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662621 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  662624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662643 */     GIR_RootConstrainSelectedInstOperands,
     /*  662644 */     // GIR_Coverage, 7545,
     /*  662644 */     GIR_EraseRootFromParent_Done,
     /*  662645 */   // Label 10564: @662645
     /*  662645 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(662720), // Rule ID 7548 //
     /*  662650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662718 */     GIR_RootConstrainSelectedInstOperands,
     /*  662719 */     // GIR_Coverage, 7548,
     /*  662719 */     GIR_EraseRootFromParent_Done,
     /*  662720 */   // Label 10565: @662720
     /*  662720 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(662795), // Rule ID 7549 //
     /*  662725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  662774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662793 */     GIR_RootConstrainSelectedInstOperands,
     /*  662794 */     // GIR_Coverage, 7549,
     /*  662794 */     GIR_EraseRootFromParent_Done,
     /*  662795 */   // Label 10566: @662795
     /*  662795 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(662870), // Rule ID 7552 //
     /*  662800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  662811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  662814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  662817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662868 */     GIR_RootConstrainSelectedInstOperands,
     /*  662869 */     // GIR_Coverage, 7552,
     /*  662869 */     GIR_EraseRootFromParent_Done,
     /*  662870 */   // Label 10567: @662870
     /*  662870 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(662945), // Rule ID 7553 //
     /*  662875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  662883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  662886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  662889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  662892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  662924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662943 */     GIR_RootConstrainSelectedInstOperands,
     /*  662944 */     // GIR_Coverage, 7553,
     /*  662944 */     GIR_EraseRootFromParent_Done,
     /*  662945 */   // Label 10568: @662945
     /*  662945 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(663020), // Rule ID 7616 //
     /*  662950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  662961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  662964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  662967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  662970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  662999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663018 */     GIR_RootConstrainSelectedInstOperands,
     /*  663019 */     // GIR_Coverage, 7616,
     /*  663019 */     GIR_EraseRootFromParent_Done,
     /*  663020 */   // Label 10569: @663020
     /*  663020 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(663095), // Rule ID 7617 //
     /*  663025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  663042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  663074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663093 */     GIR_RootConstrainSelectedInstOperands,
     /*  663094 */     // GIR_Coverage, 7617,
     /*  663094 */     GIR_EraseRootFromParent_Done,
     /*  663095 */   // Label 10570: @663095
     /*  663095 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(663170), // Rule ID 7620 //
     /*  663100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663168 */     GIR_RootConstrainSelectedInstOperands,
     /*  663169 */     // GIR_Coverage, 7620,
     /*  663169 */     GIR_EraseRootFromParent_Done,
     /*  663170 */   // Label 10571: @663170
     /*  663170 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(663245), // Rule ID 7621 //
     /*  663175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663243 */     GIR_RootConstrainSelectedInstOperands,
     /*  663244 */     // GIR_Coverage, 7621,
     /*  663244 */     GIR_EraseRootFromParent_Done,
     /*  663245 */   // Label 10572: @663245
     /*  663245 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(663320), // Rule ID 7624 //
     /*  663250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  663299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663318 */     GIR_RootConstrainSelectedInstOperands,
     /*  663319 */     // GIR_Coverage, 7624,
     /*  663319 */     GIR_EraseRootFromParent_Done,
     /*  663320 */   // Label 10573: @663320
     /*  663320 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(663395), // Rule ID 7625 //
     /*  663325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  663342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  663374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663393 */     GIR_RootConstrainSelectedInstOperands,
     /*  663394 */     // GIR_Coverage, 7625,
     /*  663394 */     GIR_EraseRootFromParent_Done,
     /*  663395 */   // Label 10574: @663395
     /*  663395 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(663470), // Rule ID 7628 //
     /*  663400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  663411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  663414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  663417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  663420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  663449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663468 */     GIR_RootConstrainSelectedInstOperands,
     /*  663469 */     // GIR_Coverage, 7628,
     /*  663469 */     GIR_EraseRootFromParent_Done,
     /*  663470 */   // Label 10575: @663470
     /*  663470 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(663545), // Rule ID 7629 //
     /*  663475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  663486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  663489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  663492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  663495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  663524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663543 */     GIR_RootConstrainSelectedInstOperands,
     /*  663544 */     // GIR_Coverage, 7629,
     /*  663544 */     GIR_EraseRootFromParent_Done,
     /*  663545 */   // Label 10576: @663545
     /*  663545 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(663620), // Rule ID 7632 //
     /*  663550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  663567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  663599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663618 */     GIR_RootConstrainSelectedInstOperands,
     /*  663619 */     // GIR_Coverage, 7632,
     /*  663619 */     GIR_EraseRootFromParent_Done,
     /*  663620 */   // Label 10577: @663620
     /*  663620 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(663695), // Rule ID 7633 //
     /*  663625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  663636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  663639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  663642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  663645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  663674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663693 */     GIR_RootConstrainSelectedInstOperands,
     /*  663694 */     // GIR_Coverage, 7633,
     /*  663694 */     GIR_EraseRootFromParent_Done,
     /*  663695 */   // Label 10578: @663695
     /*  663695 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(663770), // Rule ID 7636 //
     /*  663700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  663717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  663749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663768 */     GIR_RootConstrainSelectedInstOperands,
     /*  663769 */     // GIR_Coverage, 7636,
     /*  663769 */     GIR_EraseRootFromParent_Done,
     /*  663770 */   // Label 10579: @663770
     /*  663770 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(663845), // Rule ID 7637 //
     /*  663775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  663786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  663789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  663792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  663795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  663824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663843 */     GIR_RootConstrainSelectedInstOperands,
     /*  663844 */     // GIR_Coverage, 7637,
     /*  663844 */     GIR_EraseRootFromParent_Done,
     /*  663845 */   // Label 10580: @663845
     /*  663845 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(663920), // Rule ID 7640 //
     /*  663850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663918 */     GIR_RootConstrainSelectedInstOperands,
     /*  663919 */     // GIR_Coverage, 7640,
     /*  663919 */     GIR_EraseRootFromParent_Done,
     /*  663920 */   // Label 10581: @663920
     /*  663920 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(663995), // Rule ID 7641 //
     /*  663925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663971 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  663974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663993 */     GIR_RootConstrainSelectedInstOperands,
     /*  663994 */     // GIR_Coverage, 7641,
     /*  663994 */     GIR_EraseRootFromParent_Done,
     /*  663995 */   // Label 10582: @663995
     /*  663995 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(664070), // Rule ID 7644 //
     /*  664000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664068 */     GIR_RootConstrainSelectedInstOperands,
     /*  664069 */     // GIR_Coverage, 7644,
     /*  664069 */     GIR_EraseRootFromParent_Done,
     /*  664070 */   // Label 10583: @664070
     /*  664070 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(664145), // Rule ID 7645 //
     /*  664075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664121 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664143 */     GIR_RootConstrainSelectedInstOperands,
     /*  664144 */     // GIR_Coverage, 7645,
     /*  664144 */     GIR_EraseRootFromParent_Done,
     /*  664145 */   // Label 10584: @664145
     /*  664145 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(664220), // Rule ID 7648 //
     /*  664150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664218 */     GIR_RootConstrainSelectedInstOperands,
     /*  664219 */     // GIR_Coverage, 7648,
     /*  664219 */     GIR_EraseRootFromParent_Done,
     /*  664220 */   // Label 10585: @664220
     /*  664220 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(664295), // Rule ID 7649 //
     /*  664225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  664242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664271 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664293 */     GIR_RootConstrainSelectedInstOperands,
     /*  664294 */     // GIR_Coverage, 7649,
     /*  664294 */     GIR_EraseRootFromParent_Done,
     /*  664295 */   // Label 10586: @664295
     /*  664295 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(664370), // Rule ID 7652 //
     /*  664300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  664311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  664314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  664320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664368 */     GIR_RootConstrainSelectedInstOperands,
     /*  664369 */     // GIR_Coverage, 7652,
     /*  664369 */     GIR_EraseRootFromParent_Done,
     /*  664370 */   // Label 10587: @664370
     /*  664370 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(664445), // Rule ID 7653 //
     /*  664375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  664386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  664389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  664392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  664395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664443 */     GIR_RootConstrainSelectedInstOperands,
     /*  664444 */     // GIR_Coverage, 7653,
     /*  664444 */     GIR_EraseRootFromParent_Done,
     /*  664445 */   // Label 10588: @664445
     /*  664445 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(664520), // Rule ID 7656 //
     /*  664450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  664499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664518 */     GIR_RootConstrainSelectedInstOperands,
     /*  664519 */     // GIR_Coverage, 7656,
     /*  664519 */     GIR_EraseRootFromParent_Done,
     /*  664520 */   // Label 10589: @664520
     /*  664520 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(664595), // Rule ID 7657 //
     /*  664525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  664536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  664539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  664542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  664545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  664574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664593 */     GIR_RootConstrainSelectedInstOperands,
     /*  664594 */     // GIR_Coverage, 7657,
     /*  664594 */     GIR_EraseRootFromParent_Done,
     /*  664595 */   // Label 10590: @664595
     /*  664595 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(664670), // Rule ID 7660 //
     /*  664600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664668 */     GIR_RootConstrainSelectedInstOperands,
     /*  664669 */     // GIR_Coverage, 7660,
     /*  664669 */     GIR_EraseRootFromParent_Done,
     /*  664670 */   // Label 10591: @664670
     /*  664670 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(664745), // Rule ID 7661 //
     /*  664675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  664724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664743 */     GIR_RootConstrainSelectedInstOperands,
     /*  664744 */     // GIR_Coverage, 7661,
     /*  664744 */     GIR_EraseRootFromParent_Done,
     /*  664745 */   // Label 10592: @664745
     /*  664745 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(664820), // Rule ID 7664 //
     /*  664750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664818 */     GIR_RootConstrainSelectedInstOperands,
     /*  664819 */     // GIR_Coverage, 7664,
     /*  664819 */     GIR_EraseRootFromParent_Done,
     /*  664820 */   // Label 10593: @664820
     /*  664820 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(664895), // Rule ID 7665 //
     /*  664825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  664842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  664874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664893 */     GIR_RootConstrainSelectedInstOperands,
     /*  664894 */     // GIR_Coverage, 7665,
     /*  664894 */     GIR_EraseRootFromParent_Done,
     /*  664895 */   // Label 10594: @664895
     /*  664895 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(664970), // Rule ID 7668 //
     /*  664900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  664903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  664917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  664949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664968 */     GIR_RootConstrainSelectedInstOperands,
     /*  664969 */     // GIR_Coverage, 7668,
     /*  664969 */     GIR_EraseRootFromParent_Done,
     /*  664970 */   // Label 10595: @664970
     /*  664970 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(665045), // Rule ID 7669 //
     /*  664975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  664978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  664983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  664986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  664989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  664992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  664995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  665024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665043 */     GIR_RootConstrainSelectedInstOperands,
     /*  665044 */     // GIR_Coverage, 7669,
     /*  665044 */     GIR_EraseRootFromParent_Done,
     /*  665045 */   // Label 10596: @665045
     /*  665045 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(665120), // Rule ID 7672 //
     /*  665050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  665053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  665099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665118 */     GIR_RootConstrainSelectedInstOperands,
     /*  665119 */     // GIR_Coverage, 7672,
     /*  665119 */     GIR_EraseRootFromParent_Done,
     /*  665120 */   // Label 10597: @665120
     /*  665120 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(665195), // Rule ID 7673 //
     /*  665125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  665128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  665142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665171 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  665174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665193 */     GIR_RootConstrainSelectedInstOperands,
     /*  665194 */     // GIR_Coverage, 7673,
     /*  665194 */     GIR_EraseRootFromParent_Done,
     /*  665195 */   // Label 10598: @665195
     /*  665195 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(665270), // Rule ID 7676 //
     /*  665200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  665249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665268 */     GIR_RootConstrainSelectedInstOperands,
     /*  665269 */     // GIR_Coverage, 7676,
     /*  665269 */     GIR_EraseRootFromParent_Done,
     /*  665270 */   // Label 10599: @665270
     /*  665270 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(665345), // Rule ID 7677 //
     /*  665275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  665286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  665289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  665292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665321 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  665324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665343 */     GIR_RootConstrainSelectedInstOperands,
     /*  665344 */     // GIR_Coverage, 7677,
     /*  665344 */     GIR_EraseRootFromParent_Done,
     /*  665345 */   // Label 10600: @665345
     /*  665345 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(665420), // Rule ID 7680 //
     /*  665350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  665367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  665399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665418 */     GIR_RootConstrainSelectedInstOperands,
     /*  665419 */     // GIR_Coverage, 7680,
     /*  665419 */     GIR_EraseRootFromParent_Done,
     /*  665420 */   // Label 10601: @665420
     /*  665420 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(665495), // Rule ID 7681 //
     /*  665425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  665436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  665439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  665442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  665474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665493 */     GIR_RootConstrainSelectedInstOperands,
     /*  665494 */     // GIR_Coverage, 7681,
     /*  665494 */     GIR_EraseRootFromParent_Done,
     /*  665495 */   // Label 10602: @665495
     /*  665495 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(665570), // Rule ID 7684 //
     /*  665500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  665549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665568 */     GIR_RootConstrainSelectedInstOperands,
     /*  665569 */     // GIR_Coverage, 7684,
     /*  665569 */     GIR_EraseRootFromParent_Done,
     /*  665570 */   // Label 10603: @665570
     /*  665570 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(665645), // Rule ID 7685 //
     /*  665575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  665586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  665589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  665592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665621 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  665624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665643 */     GIR_RootConstrainSelectedInstOperands,
     /*  665644 */     // GIR_Coverage, 7685,
     /*  665644 */     GIR_EraseRootFromParent_Done,
     /*  665645 */   // Label 10604: @665645
     /*  665645 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(665720), // Rule ID 7688 //
     /*  665650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  665699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665718 */     GIR_RootConstrainSelectedInstOperands,
     /*  665719 */     // GIR_Coverage, 7688,
     /*  665719 */     GIR_EraseRootFromParent_Done,
     /*  665720 */   // Label 10605: @665720
     /*  665720 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(665795), // Rule ID 7689 //
     /*  665725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  665736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  665739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  665774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665793 */     GIR_RootConstrainSelectedInstOperands,
     /*  665794 */     // GIR_Coverage, 7689,
     /*  665794 */     GIR_EraseRootFromParent_Done,
     /*  665795 */   // Label 10606: @665795
     /*  665795 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(665870), // Rule ID 7692 //
     /*  665800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  665849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665868 */     GIR_RootConstrainSelectedInstOperands,
     /*  665869 */     // GIR_Coverage, 7692,
     /*  665869 */     GIR_EraseRootFromParent_Done,
     /*  665870 */   // Label 10607: @665870
     /*  665870 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(665945), // Rule ID 7693 //
     /*  665875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  665895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  665924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665943 */     GIR_RootConstrainSelectedInstOperands,
     /*  665944 */     // GIR_Coverage, 7693,
     /*  665944 */     GIR_EraseRootFromParent_Done,
     /*  665945 */   // Label 10608: @665945
     /*  665945 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(666020), // Rule ID 7696 //
     /*  665950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  665958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  665970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  665989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  665999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666018 */     GIR_RootConstrainSelectedInstOperands,
     /*  666019 */     // GIR_Coverage, 7696,
     /*  666019 */     GIR_EraseRootFromParent_Done,
     /*  666020 */   // Label 10609: @666020
     /*  666020 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(666095), // Rule ID 7697 //
     /*  666025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  666036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  666039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  666042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666071 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666093 */     GIR_RootConstrainSelectedInstOperands,
     /*  666094 */     // GIR_Coverage, 7697,
     /*  666094 */     GIR_EraseRootFromParent_Done,
     /*  666095 */   // Label 10610: @666095
     /*  666095 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(666170), // Rule ID 7700 //
     /*  666100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  666149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666168 */     GIR_RootConstrainSelectedInstOperands,
     /*  666169 */     // GIR_Coverage, 7700,
     /*  666169 */     GIR_EraseRootFromParent_Done,
     /*  666170 */   // Label 10611: @666170
     /*  666170 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(666245), // Rule ID 7701 //
     /*  666175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  666192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  666224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666243 */     GIR_RootConstrainSelectedInstOperands,
     /*  666244 */     // GIR_Coverage, 7701,
     /*  666244 */     GIR_EraseRootFromParent_Done,
     /*  666245 */   // Label 10612: @666245
     /*  666245 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(666320), // Rule ID 7704 //
     /*  666250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  666261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  666264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666318 */     GIR_RootConstrainSelectedInstOperands,
     /*  666319 */     // GIR_Coverage, 7704,
     /*  666319 */     GIR_EraseRootFromParent_Done,
     /*  666320 */   // Label 10613: @666320
     /*  666320 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(666395), // Rule ID 7705 //
     /*  666325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  666336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  666339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  666342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666393 */     GIR_RootConstrainSelectedInstOperands,
     /*  666394 */     // GIR_Coverage, 7705,
     /*  666394 */     GIR_EraseRootFromParent_Done,
     /*  666395 */   // Label 10614: @666395
     /*  666395 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(666470), // Rule ID 7708 //
     /*  666400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  666449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666468 */     GIR_RootConstrainSelectedInstOperands,
     /*  666469 */     // GIR_Coverage, 7708,
     /*  666469 */     GIR_EraseRootFromParent_Done,
     /*  666470 */   // Label 10615: @666470
     /*  666470 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(666545), // Rule ID 7709 //
     /*  666475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  666486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  666489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  666524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666543 */     GIR_RootConstrainSelectedInstOperands,
     /*  666544 */     // GIR_Coverage, 7709,
     /*  666544 */     GIR_EraseRootFromParent_Done,
     /*  666545 */   // Label 10616: @666545
     /*  666545 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(666620), // Rule ID 7712 //
     /*  666550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  666599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666618 */     GIR_RootConstrainSelectedInstOperands,
     /*  666619 */     // GIR_Coverage, 7712,
     /*  666619 */     GIR_EraseRootFromParent_Done,
     /*  666620 */   // Label 10617: @666620
     /*  666620 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(666695), // Rule ID 7713 //
     /*  666625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  666636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  666639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  666674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666693 */     GIR_RootConstrainSelectedInstOperands,
     /*  666694 */     // GIR_Coverage, 7713,
     /*  666694 */     GIR_EraseRootFromParent_Done,
     /*  666695 */   // Label 10618: @666695
     /*  666695 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(666770), // Rule ID 7716 //
     /*  666700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666768 */     GIR_RootConstrainSelectedInstOperands,
     /*  666769 */     // GIR_Coverage, 7716,
     /*  666769 */     GIR_EraseRootFromParent_Done,
     /*  666770 */   // Label 10619: @666770
     /*  666770 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(666845), // Rule ID 7717 //
     /*  666775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  666786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  666789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666821 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  666824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666843 */     GIR_RootConstrainSelectedInstOperands,
     /*  666844 */     // GIR_Coverage, 7717,
     /*  666844 */     GIR_EraseRootFromParent_Done,
     /*  666845 */   // Label 10620: @666845
     /*  666845 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(666920), // Rule ID 7720 //
     /*  666850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  666853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666896 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666918 */     GIR_RootConstrainSelectedInstOperands,
     /*  666919 */     // GIR_Coverage, 7720,
     /*  666919 */     GIR_EraseRootFromParent_Done,
     /*  666920 */   // Label 10621: @666920
     /*  666920 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(666995), // Rule ID 7721 //
     /*  666925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  666928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  666933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  666936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  666939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  666942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666971 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  666974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666993 */     GIR_RootConstrainSelectedInstOperands,
     /*  666994 */     // GIR_Coverage, 7721,
     /*  666994 */     GIR_EraseRootFromParent_Done,
     /*  666995 */   // Label 10622: @666995
     /*  666995 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(667070), // Rule ID 7724 //
     /*  667000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  667049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667068 */     GIR_RootConstrainSelectedInstOperands,
     /*  667069 */     // GIR_Coverage, 7724,
     /*  667069 */     GIR_EraseRootFromParent_Done,
     /*  667070 */   // Label 10623: @667070
     /*  667070 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(667145), // Rule ID 7725 //
     /*  667075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  667092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667121 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  667124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667143 */     GIR_RootConstrainSelectedInstOperands,
     /*  667144 */     // GIR_Coverage, 7725,
     /*  667144 */     GIR_EraseRootFromParent_Done,
     /*  667145 */   // Label 10624: @667145
     /*  667145 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(667220), // Rule ID 7728 //
     /*  667150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  667199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667218 */     GIR_RootConstrainSelectedInstOperands,
     /*  667219 */     // GIR_Coverage, 7728,
     /*  667219 */     GIR_EraseRootFromParent_Done,
     /*  667220 */   // Label 10625: @667220
     /*  667220 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(667295), // Rule ID 7729 //
     /*  667225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  667236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  667239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  667242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  667274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667293 */     GIR_RootConstrainSelectedInstOperands,
     /*  667294 */     // GIR_Coverage, 7729,
     /*  667294 */     GIR_EraseRootFromParent_Done,
     /*  667295 */   // Label 10626: @667295
     /*  667295 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(667370), // Rule ID 7732 //
     /*  667300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  667303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  667311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  667314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  667349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667368 */     GIR_RootConstrainSelectedInstOperands,
     /*  667369 */     // GIR_Coverage, 7732,
     /*  667369 */     GIR_EraseRootFromParent_Done,
     /*  667370 */   // Label 10627: @667370
     /*  667370 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(667445), // Rule ID 7733 //
     /*  667375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  667378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  667383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  667386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  667389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  667392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  667406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  667410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  667424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667443 */     GIR_RootConstrainSelectedInstOperands,
     /*  667444 */     // GIR_Coverage, 7733,
     /*  667444 */     GIR_EraseRootFromParent_Done,
     /*  667445 */   // Label 10628: @667445
     /*  667445 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(667520), // Rule ID 10248 //
     /*  667450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  667470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  667499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667518 */     GIR_RootConstrainSelectedInstOperands,
     /*  667519 */     // GIR_Coverage, 10248,
     /*  667519 */     GIR_EraseRootFromParent_Done,
     /*  667520 */   // Label 10629: @667520
     /*  667520 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(667595), // Rule ID 10249 //
     /*  667525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  667536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  667539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  667542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  667545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  667574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667593 */     GIR_RootConstrainSelectedInstOperands,
     /*  667594 */     // GIR_Coverage, 10249,
     /*  667594 */     GIR_EraseRootFromParent_Done,
     /*  667595 */   // Label 10630: @667595
     /*  667595 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(667670), // Rule ID 10252 //
     /*  667600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  667620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667668 */     GIR_RootConstrainSelectedInstOperands,
     /*  667669 */     // GIR_Coverage, 10252,
     /*  667669 */     GIR_EraseRootFromParent_Done,
     /*  667670 */   // Label 10631: @667670
     /*  667670 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(667745), // Rule ID 10253 //
     /*  667675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  667695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667743 */     GIR_RootConstrainSelectedInstOperands,
     /*  667744 */     // GIR_Coverage, 10253,
     /*  667744 */     GIR_EraseRootFromParent_Done,
     /*  667745 */   // Label 10632: @667745
     /*  667745 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(667820), // Rule ID 10256 //
     /*  667750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  667770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  667799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667818 */     GIR_RootConstrainSelectedInstOperands,
     /*  667819 */     // GIR_Coverage, 10256,
     /*  667819 */     GIR_EraseRootFromParent_Done,
     /*  667820 */   // Label 10633: @667820
     /*  667820 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(667895), // Rule ID 10257 //
     /*  667825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  667845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  667874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667893 */     GIR_RootConstrainSelectedInstOperands,
     /*  667894 */     // GIR_Coverage, 10257,
     /*  667894 */     GIR_EraseRootFromParent_Done,
     /*  667895 */   // Label 10634: @667895
     /*  667895 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(667970), // Rule ID 10260 //
     /*  667900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  667920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  667949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667968 */     GIR_RootConstrainSelectedInstOperands,
     /*  667969 */     // GIR_Coverage, 10260,
     /*  667969 */     GIR_EraseRootFromParent_Done,
     /*  667970 */   // Label 10635: @667970
     /*  667970 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(668045), // Rule ID 10261 //
     /*  667975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  667995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  668024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668043 */     GIR_RootConstrainSelectedInstOperands,
     /*  668044 */     // GIR_Coverage, 10261,
     /*  668044 */     GIR_EraseRootFromParent_Done,
     /*  668045 */   // Label 10636: @668045
     /*  668045 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(668120), // Rule ID 10264 //
     /*  668050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  668070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668118 */     GIR_RootConstrainSelectedInstOperands,
     /*  668119 */     // GIR_Coverage, 10264,
     /*  668119 */     GIR_EraseRootFromParent_Done,
     /*  668120 */   // Label 10637: @668120
     /*  668120 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(668195), // Rule ID 10265 //
     /*  668125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  668136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  668139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  668142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  668145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668193 */     GIR_RootConstrainSelectedInstOperands,
     /*  668194 */     // GIR_Coverage, 10265,
     /*  668194 */     GIR_EraseRootFromParent_Done,
     /*  668195 */   // Label 10638: @668195
     /*  668195 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(668270), // Rule ID 10268 //
     /*  668200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  668220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668268 */     GIR_RootConstrainSelectedInstOperands,
     /*  668269 */     // GIR_Coverage, 10268,
     /*  668269 */     GIR_EraseRootFromParent_Done,
     /*  668270 */   // Label 10639: @668270
     /*  668270 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(668345), // Rule ID 10269 //
     /*  668275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  668286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  668289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  668292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  668295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  668324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668343 */     GIR_RootConstrainSelectedInstOperands,
     /*  668344 */     // GIR_Coverage, 10269,
     /*  668344 */     GIR_EraseRootFromParent_Done,
     /*  668345 */   // Label 10640: @668345
     /*  668345 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(668420), // Rule ID 10272 //
     /*  668350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  668370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668418 */     GIR_RootConstrainSelectedInstOperands,
     /*  668419 */     // GIR_Coverage, 10272,
     /*  668419 */     GIR_EraseRootFromParent_Done,
     /*  668420 */   // Label 10641: @668420
     /*  668420 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(668495), // Rule ID 10273 //
     /*  668425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  668436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  668439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  668442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  668445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668493 */     GIR_RootConstrainSelectedInstOperands,
     /*  668494 */     // GIR_Coverage, 10273,
     /*  668494 */     GIR_EraseRootFromParent_Done,
     /*  668495 */   // Label 10642: @668495
     /*  668495 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(668570), // Rule ID 10276 //
     /*  668500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  668520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668568 */     GIR_RootConstrainSelectedInstOperands,
     /*  668569 */     // GIR_Coverage, 10276,
     /*  668569 */     GIR_EraseRootFromParent_Done,
     /*  668570 */   // Label 10643: @668570
     /*  668570 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(668645), // Rule ID 10277 //
     /*  668575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  668595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668643 */     GIR_RootConstrainSelectedInstOperands,
     /*  668644 */     // GIR_Coverage, 10277,
     /*  668644 */     GIR_EraseRootFromParent_Done,
     /*  668645 */   // Label 10644: @668645
     /*  668645 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(668720), // Rule ID 10280 //
     /*  668650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  668670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668718 */     GIR_RootConstrainSelectedInstOperands,
     /*  668719 */     // GIR_Coverage, 10280,
     /*  668719 */     GIR_EraseRootFromParent_Done,
     /*  668720 */   // Label 10645: @668720
     /*  668720 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(668795), // Rule ID 10281 //
     /*  668725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  668745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668793 */     GIR_RootConstrainSelectedInstOperands,
     /*  668794 */     // GIR_Coverage, 10281,
     /*  668794 */     GIR_EraseRootFromParent_Done,
     /*  668795 */   // Label 10646: @668795
     /*  668795 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(668870), // Rule ID 10284 //
     /*  668800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  668820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668868 */     GIR_RootConstrainSelectedInstOperands,
     /*  668869 */     // GIR_Coverage, 10284,
     /*  668869 */     GIR_EraseRootFromParent_Done,
     /*  668870 */   // Label 10647: @668870
     /*  668870 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(668945), // Rule ID 10285 //
     /*  668875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  668895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  668924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668943 */     GIR_RootConstrainSelectedInstOperands,
     /*  668944 */     // GIR_Coverage, 10285,
     /*  668944 */     GIR_EraseRootFromParent_Done,
     /*  668945 */   // Label 10648: @668945
     /*  668945 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(669020), // Rule ID 10288 //
     /*  668950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  668970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  668999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669018 */     GIR_RootConstrainSelectedInstOperands,
     /*  669019 */     // GIR_Coverage, 10288,
     /*  669019 */     GIR_EraseRootFromParent_Done,
     /*  669020 */   // Label 10649: @669020
     /*  669020 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(669095), // Rule ID 10289 //
     /*  669025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  669036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  669039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  669042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  669045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669093 */     GIR_RootConstrainSelectedInstOperands,
     /*  669094 */     // GIR_Coverage, 10289,
     /*  669094 */     GIR_EraseRootFromParent_Done,
     /*  669095 */   // Label 10650: @669095
     /*  669095 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(669170), // Rule ID 10292 //
     /*  669100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  669120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669168 */     GIR_RootConstrainSelectedInstOperands,
     /*  669169 */     // GIR_Coverage, 10292,
     /*  669169 */     GIR_EraseRootFromParent_Done,
     /*  669170 */   // Label 10651: @669170
     /*  669170 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(669245), // Rule ID 10293 //
     /*  669175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  669186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  669189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  669192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  669195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669243 */     GIR_RootConstrainSelectedInstOperands,
     /*  669244 */     // GIR_Coverage, 10293,
     /*  669244 */     GIR_EraseRootFromParent_Done,
     /*  669245 */   // Label 10652: @669245
     /*  669245 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(669320), // Rule ID 10296 //
     /*  669250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  669270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669318 */     GIR_RootConstrainSelectedInstOperands,
     /*  669319 */     // GIR_Coverage, 10296,
     /*  669319 */     GIR_EraseRootFromParent_Done,
     /*  669320 */   // Label 10653: @669320
     /*  669320 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(669395), // Rule ID 10297 //
     /*  669325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  669336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  669339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  669342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  669345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669393 */     GIR_RootConstrainSelectedInstOperands,
     /*  669394 */     // GIR_Coverage, 10297,
     /*  669394 */     GIR_EraseRootFromParent_Done,
     /*  669395 */   // Label 10654: @669395
     /*  669395 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(669470), // Rule ID 10300 //
     /*  669400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  669420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669468 */     GIR_RootConstrainSelectedInstOperands,
     /*  669469 */     // GIR_Coverage, 10300,
     /*  669469 */     GIR_EraseRootFromParent_Done,
     /*  669470 */   // Label 10655: @669470
     /*  669470 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(669545), // Rule ID 10301 //
     /*  669475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  669486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  669489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  669492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  669495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669543 */     GIR_RootConstrainSelectedInstOperands,
     /*  669544 */     // GIR_Coverage, 10301,
     /*  669544 */     GIR_EraseRootFromParent_Done,
     /*  669545 */   // Label 10656: @669545
     /*  669545 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(669620), // Rule ID 10304 //
     /*  669550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  669570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669618 */     GIR_RootConstrainSelectedInstOperands,
     /*  669619 */     // GIR_Coverage, 10304,
     /*  669619 */     GIR_EraseRootFromParent_Done,
     /*  669620 */   // Label 10657: @669620
     /*  669620 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(669695), // Rule ID 10305 //
     /*  669625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  669645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  669674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669693 */     GIR_RootConstrainSelectedInstOperands,
     /*  669694 */     // GIR_Coverage, 10305,
     /*  669694 */     GIR_EraseRootFromParent_Done,
     /*  669695 */   // Label 10658: @669695
     /*  669695 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(669770), // Rule ID 10308 //
     /*  669700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  669720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669768 */     GIR_RootConstrainSelectedInstOperands,
     /*  669769 */     // GIR_Coverage, 10308,
     /*  669769 */     GIR_EraseRootFromParent_Done,
     /*  669770 */   // Label 10659: @669770
     /*  669770 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(669845), // Rule ID 10309 //
     /*  669775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  669795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  669824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669843 */     GIR_RootConstrainSelectedInstOperands,
     /*  669844 */     // GIR_Coverage, 10309,
     /*  669844 */     GIR_EraseRootFromParent_Done,
     /*  669845 */   // Label 10660: @669845
     /*  669845 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(669920), // Rule ID 10312 //
     /*  669850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  669870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669918 */     GIR_RootConstrainSelectedInstOperands,
     /*  669919 */     // GIR_Coverage, 10312,
     /*  669919 */     GIR_EraseRootFromParent_Done,
     /*  669920 */   // Label 10661: @669920
     /*  669920 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(669995), // Rule ID 10313 //
     /*  669925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  669945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  669974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669993 */     GIR_RootConstrainSelectedInstOperands,
     /*  669994 */     // GIR_Coverage, 10313,
     /*  669994 */     GIR_EraseRootFromParent_Done,
     /*  669995 */   // Label 10662: @669995
     /*  669995 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(670070), // Rule ID 10316 //
     /*  670000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  670020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670068 */     GIR_RootConstrainSelectedInstOperands,
     /*  670069 */     // GIR_Coverage, 10316,
     /*  670069 */     GIR_EraseRootFromParent_Done,
     /*  670070 */   // Label 10663: @670070
     /*  670070 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(670145), // Rule ID 10317 //
     /*  670075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  670086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  670089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  670092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  670095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670143 */     GIR_RootConstrainSelectedInstOperands,
     /*  670144 */     // GIR_Coverage, 10317,
     /*  670144 */     GIR_EraseRootFromParent_Done,
     /*  670145 */   // Label 10664: @670145
     /*  670145 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(670220), // Rule ID 10320 //
     /*  670150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  670170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670218 */     GIR_RootConstrainSelectedInstOperands,
     /*  670219 */     // GIR_Coverage, 10320,
     /*  670219 */     GIR_EraseRootFromParent_Done,
     /*  670220 */   // Label 10665: @670220
     /*  670220 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(670295), // Rule ID 10321 //
     /*  670225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  670236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  670239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  670242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  670245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670293 */     GIR_RootConstrainSelectedInstOperands,
     /*  670294 */     // GIR_Coverage, 10321,
     /*  670294 */     GIR_EraseRootFromParent_Done,
     /*  670295 */   // Label 10666: @670295
     /*  670295 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(670370), // Rule ID 10324 //
     /*  670300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  670320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  670349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670368 */     GIR_RootConstrainSelectedInstOperands,
     /*  670369 */     // GIR_Coverage, 10324,
     /*  670369 */     GIR_EraseRootFromParent_Done,
     /*  670370 */   // Label 10667: @670370
     /*  670370 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(670445), // Rule ID 10325 //
     /*  670375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  670386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  670389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  670392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  670395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  670414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  670424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670443 */     GIR_RootConstrainSelectedInstOperands,
     /*  670444 */     // GIR_Coverage, 10325,
     /*  670444 */     GIR_EraseRootFromParent_Done,
     /*  670445 */   // Label 10668: @670445
     /*  670445 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(670520), // Rule ID 10328 //
     /*  670450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  670470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670518 */     GIR_RootConstrainSelectedInstOperands,
     /*  670519 */     // GIR_Coverage, 10328,
     /*  670519 */     GIR_EraseRootFromParent_Done,
     /*  670520 */   // Label 10669: @670520
     /*  670520 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(670595), // Rule ID 10329 //
     /*  670525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  670536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  670539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  670542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  670545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  670574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670593 */     GIR_RootConstrainSelectedInstOperands,
     /*  670594 */     // GIR_Coverage, 10329,
     /*  670594 */     GIR_EraseRootFromParent_Done,
     /*  670595 */   // Label 10670: @670595
     /*  670595 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(670670), // Rule ID 10332 //
     /*  670600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  670620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670668 */     GIR_RootConstrainSelectedInstOperands,
     /*  670669 */     // GIR_Coverage, 10332,
     /*  670669 */     GIR_EraseRootFromParent_Done,
     /*  670670 */   // Label 10671: @670670
     /*  670670 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(670745), // Rule ID 10333 //
     /*  670675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  670695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  670724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670743 */     GIR_RootConstrainSelectedInstOperands,
     /*  670744 */     // GIR_Coverage, 10333,
     /*  670744 */     GIR_EraseRootFromParent_Done,
     /*  670745 */   // Label 10672: @670745
     /*  670745 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(670820), // Rule ID 10336 //
     /*  670750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  670799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670818 */     GIR_RootConstrainSelectedInstOperands,
     /*  670819 */     // GIR_Coverage, 10336,
     /*  670819 */     GIR_EraseRootFromParent_Done,
     /*  670820 */   // Label 10673: @670820
     /*  670820 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(670895), // Rule ID 10337 //
     /*  670825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  670874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670893 */     GIR_RootConstrainSelectedInstOperands,
     /*  670894 */     // GIR_Coverage, 10337,
     /*  670894 */     GIR_EraseRootFromParent_Done,
     /*  670895 */   // Label 10674: @670895
     /*  670895 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(670970), // Rule ID 10340 //
     /*  670900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  670949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670968 */     GIR_RootConstrainSelectedInstOperands,
     /*  670969 */     // GIR_Coverage, 10340,
     /*  670969 */     GIR_EraseRootFromParent_Done,
     /*  670970 */   // Label 10675: @670970
     /*  670970 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(671045), // Rule ID 10341 //
     /*  670975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671043 */     GIR_RootConstrainSelectedInstOperands,
     /*  671044 */     // GIR_Coverage, 10341,
     /*  671044 */     GIR_EraseRootFromParent_Done,
     /*  671045 */   // Label 10676: @671045
     /*  671045 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(671120), // Rule ID 10344 //
     /*  671050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671118 */     GIR_RootConstrainSelectedInstOperands,
     /*  671119 */     // GIR_Coverage, 10344,
     /*  671119 */     GIR_EraseRootFromParent_Done,
     /*  671120 */   // Label 10677: @671120
     /*  671120 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(671195), // Rule ID 10345 //
     /*  671125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  671136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  671139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  671142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671193 */     GIR_RootConstrainSelectedInstOperands,
     /*  671194 */     // GIR_Coverage, 10345,
     /*  671194 */     GIR_EraseRootFromParent_Done,
     /*  671195 */   // Label 10678: @671195
     /*  671195 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(671270), // Rule ID 10348 //
     /*  671200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671268 */     GIR_RootConstrainSelectedInstOperands,
     /*  671269 */     // GIR_Coverage, 10348,
     /*  671269 */     GIR_EraseRootFromParent_Done,
     /*  671270 */   // Label 10679: @671270
     /*  671270 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(671345), // Rule ID 10349 //
     /*  671275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  671286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  671289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  671292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  671324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671343 */     GIR_RootConstrainSelectedInstOperands,
     /*  671344 */     // GIR_Coverage, 10349,
     /*  671344 */     GIR_EraseRootFromParent_Done,
     /*  671345 */   // Label 10680: @671345
     /*  671345 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(671420), // Rule ID 10352 //
     /*  671350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671418 */     GIR_RootConstrainSelectedInstOperands,
     /*  671419 */     // GIR_Coverage, 10352,
     /*  671419 */     GIR_EraseRootFromParent_Done,
     /*  671420 */   // Label 10681: @671420
     /*  671420 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(671495), // Rule ID 10353 //
     /*  671425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  671436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  671439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  671442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671493 */     GIR_RootConstrainSelectedInstOperands,
     /*  671494 */     // GIR_Coverage, 10353,
     /*  671494 */     GIR_EraseRootFromParent_Done,
     /*  671495 */   // Label 10682: @671495
     /*  671495 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(671570), // Rule ID 10356 //
     /*  671500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671568 */     GIR_RootConstrainSelectedInstOperands,
     /*  671569 */     // GIR_Coverage, 10356,
     /*  671569 */     GIR_EraseRootFromParent_Done,
     /*  671570 */   // Label 10683: @671570
     /*  671570 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(671645), // Rule ID 10357 //
     /*  671575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  671624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671643 */     GIR_RootConstrainSelectedInstOperands,
     /*  671644 */     // GIR_Coverage, 10357,
     /*  671644 */     GIR_EraseRootFromParent_Done,
     /*  671645 */   // Label 10684: @671645
     /*  671645 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(671720), // Rule ID 10360 //
     /*  671650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671718 */     GIR_RootConstrainSelectedInstOperands,
     /*  671719 */     // GIR_Coverage, 10360,
     /*  671719 */     GIR_EraseRootFromParent_Done,
     /*  671720 */   // Label 10685: @671720
     /*  671720 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(671795), // Rule ID 10361 //
     /*  671725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671793 */     GIR_RootConstrainSelectedInstOperands,
     /*  671794 */     // GIR_Coverage, 10361,
     /*  671794 */     GIR_EraseRootFromParent_Done,
     /*  671795 */   // Label 10686: @671795
     /*  671795 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(671870), // Rule ID 10364 //
     /*  671800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671868 */     GIR_RootConstrainSelectedInstOperands,
     /*  671869 */     // GIR_Coverage, 10364,
     /*  671869 */     GIR_EraseRootFromParent_Done,
     /*  671870 */   // Label 10687: @671870
     /*  671870 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(671945), // Rule ID 10365 //
     /*  671875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  671895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671943 */     GIR_RootConstrainSelectedInstOperands,
     /*  671944 */     // GIR_Coverage, 10365,
     /*  671944 */     GIR_EraseRootFromParent_Done,
     /*  671945 */   // Label 10688: @671945
     /*  671945 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(672020), // Rule ID 10368 //
     /*  671950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  671958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  671970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  671989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  671999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672018 */     GIR_RootConstrainSelectedInstOperands,
     /*  672019 */     // GIR_Coverage, 10368,
     /*  672019 */     GIR_EraseRootFromParent_Done,
     /*  672020 */   // Label 10689: @672020
     /*  672020 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(672095), // Rule ID 10369 //
     /*  672025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  672036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  672039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  672042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672093 */     GIR_RootConstrainSelectedInstOperands,
     /*  672094 */     // GIR_Coverage, 10369,
     /*  672094 */     GIR_EraseRootFromParent_Done,
     /*  672095 */   // Label 10690: @672095
     /*  672095 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(672170), // Rule ID 10372 //
     /*  672100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672168 */     GIR_RootConstrainSelectedInstOperands,
     /*  672169 */     // GIR_Coverage, 10372,
     /*  672169 */     GIR_EraseRootFromParent_Done,
     /*  672170 */   // Label 10691: @672170
     /*  672170 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(672245), // Rule ID 10373 //
     /*  672175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  672186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  672189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  672192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  672210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  672224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672243 */     GIR_RootConstrainSelectedInstOperands,
     /*  672244 */     // GIR_Coverage, 10373,
     /*  672244 */     GIR_EraseRootFromParent_Done,
     /*  672245 */   // Label 10692: @672245
     /*  672245 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(672320), // Rule ID 10376 //
     /*  672250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672318 */     GIR_RootConstrainSelectedInstOperands,
     /*  672319 */     // GIR_Coverage, 10376,
     /*  672319 */     GIR_EraseRootFromParent_Done,
     /*  672320 */   // Label 10693: @672320
     /*  672320 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(672395), // Rule ID 10377 //
     /*  672325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  672336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  672339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  672342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672393 */     GIR_RootConstrainSelectedInstOperands,
     /*  672394 */     // GIR_Coverage, 10377,
     /*  672394 */     GIR_EraseRootFromParent_Done,
     /*  672395 */   // Label 10694: @672395
     /*  672395 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(672470), // Rule ID 10380 //
     /*  672400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672468 */     GIR_RootConstrainSelectedInstOperands,
     /*  672469 */     // GIR_Coverage, 10380,
     /*  672469 */     GIR_EraseRootFromParent_Done,
     /*  672470 */   // Label 10695: @672470
     /*  672470 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(672545), // Rule ID 10381 //
     /*  672475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  672486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  672489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  672492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672543 */     GIR_RootConstrainSelectedInstOperands,
     /*  672544 */     // GIR_Coverage, 10381,
     /*  672544 */     GIR_EraseRootFromParent_Done,
     /*  672545 */   // Label 10696: @672545
     /*  672545 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(672620), // Rule ID 10384 //
     /*  672550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  672599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672618 */     GIR_RootConstrainSelectedInstOperands,
     /*  672619 */     // GIR_Coverage, 10384,
     /*  672619 */     GIR_EraseRootFromParent_Done,
     /*  672620 */   // Label 10697: @672620
     /*  672620 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(672695), // Rule ID 10385 //
     /*  672625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  672674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672693 */     GIR_RootConstrainSelectedInstOperands,
     /*  672694 */     // GIR_Coverage, 10385,
     /*  672694 */     GIR_EraseRootFromParent_Done,
     /*  672695 */   // Label 10698: @672695
     /*  672695 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(672770), // Rule ID 10388 //
     /*  672700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672768 */     GIR_RootConstrainSelectedInstOperands,
     /*  672769 */     // GIR_Coverage, 10388,
     /*  672769 */     GIR_EraseRootFromParent_Done,
     /*  672770 */   // Label 10699: @672770
     /*  672770 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(672845), // Rule ID 10389 //
     /*  672775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  672824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672843 */     GIR_RootConstrainSelectedInstOperands,
     /*  672844 */     // GIR_Coverage, 10389,
     /*  672844 */     GIR_EraseRootFromParent_Done,
     /*  672845 */   // Label 10700: @672845
     /*  672845 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(672920), // Rule ID 10392 //
     /*  672850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  672870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672918 */     GIR_RootConstrainSelectedInstOperands,
     /*  672919 */     // GIR_Coverage, 10392,
     /*  672919 */     GIR_EraseRootFromParent_Done,
     /*  672920 */   // Label 10701: @672920
     /*  672920 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(672995), // Rule ID 10393 //
     /*  672925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  672933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  672945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  672964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  672974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672993 */     GIR_RootConstrainSelectedInstOperands,
     /*  672994 */     // GIR_Coverage, 10393,
     /*  672994 */     GIR_EraseRootFromParent_Done,
     /*  672995 */   // Label 10702: @672995
     /*  672995 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(673070), // Rule ID 10396 //
     /*  673000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  673046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673068 */     GIR_RootConstrainSelectedInstOperands,
     /*  673069 */     // GIR_Coverage, 10396,
     /*  673069 */     GIR_EraseRootFromParent_Done,
     /*  673070 */   // Label 10703: @673070
     /*  673070 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(673145), // Rule ID 10397 //
     /*  673075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  673086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  673089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  673092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673143 */     GIR_RootConstrainSelectedInstOperands,
     /*  673144 */     // GIR_Coverage, 10397,
     /*  673144 */     GIR_EraseRootFromParent_Done,
     /*  673145 */   // Label 10704: @673145
     /*  673145 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(673220), // Rule ID 10400 //
     /*  673150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673218 */     GIR_RootConstrainSelectedInstOperands,
     /*  673219 */     // GIR_Coverage, 10400,
     /*  673219 */     GIR_EraseRootFromParent_Done,
     /*  673220 */   // Label 10705: @673220
     /*  673220 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(673295), // Rule ID 10401 //
     /*  673225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  673236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  673239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  673242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673293 */     GIR_RootConstrainSelectedInstOperands,
     /*  673294 */     // GIR_Coverage, 10401,
     /*  673294 */     GIR_EraseRootFromParent_Done,
     /*  673295 */   // Label 10706: @673295
     /*  673295 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(673370), // Rule ID 10404 //
     /*  673300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673368 */     GIR_RootConstrainSelectedInstOperands,
     /*  673369 */     // GIR_Coverage, 10404,
     /*  673369 */     GIR_EraseRootFromParent_Done,
     /*  673370 */   // Label 10707: @673370
     /*  673370 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(673445), // Rule ID 10405 //
     /*  673375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  673386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  673389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  673392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673443 */     GIR_RootConstrainSelectedInstOperands,
     /*  673444 */     // GIR_Coverage, 10405,
     /*  673444 */     GIR_EraseRootFromParent_Done,
     /*  673445 */   // Label 10708: @673445
     /*  673445 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(673520), // Rule ID 10408 //
     /*  673450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673518 */     GIR_RootConstrainSelectedInstOperands,
     /*  673519 */     // GIR_Coverage, 10408,
     /*  673519 */     GIR_EraseRootFromParent_Done,
     /*  673520 */   // Label 10709: @673520
     /*  673520 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(673595), // Rule ID 10409 //
     /*  673525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  673536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  673539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  673542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673593 */     GIR_RootConstrainSelectedInstOperands,
     /*  673594 */     // GIR_Coverage, 10409,
     /*  673594 */     GIR_EraseRootFromParent_Done,
     /*  673595 */   // Label 10710: @673595
     /*  673595 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(673670), // Rule ID 10412 //
     /*  673600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673668 */     GIR_RootConstrainSelectedInstOperands,
     /*  673669 */     // GIR_Coverage, 10412,
     /*  673669 */     GIR_EraseRootFromParent_Done,
     /*  673670 */   // Label 10711: @673670
     /*  673670 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(673745), // Rule ID 10413 //
     /*  673675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11373:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  673724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673743 */     GIR_RootConstrainSelectedInstOperands,
     /*  673744 */     // GIR_Coverage, 10413,
     /*  673744 */     GIR_EraseRootFromParent_Done,
     /*  673745 */   // Label 10712: @673745
     /*  673745 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(673820), // Rule ID 10416 //
     /*  673750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673818 */     GIR_RootConstrainSelectedInstOperands,
     /*  673819 */     // GIR_Coverage, 10416,
     /*  673819 */     GIR_EraseRootFromParent_Done,
     /*  673820 */   // Label 10713: @673820
     /*  673820 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(673895), // Rule ID 10417 //
     /*  673825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11373:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  673874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673893 */     GIR_RootConstrainSelectedInstOperands,
     /*  673894 */     // GIR_Coverage, 10417,
     /*  673894 */     GIR_EraseRootFromParent_Done,
     /*  673895 */   // Label 10714: @673895
     /*  673895 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(673970), // Rule ID 10420 //
     /*  673900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  673949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673968 */     GIR_RootConstrainSelectedInstOperands,
     /*  673969 */     // GIR_Coverage, 10420,
     /*  673969 */     GIR_EraseRootFromParent_Done,
     /*  673970 */   // Label 10715: @673970
     /*  673970 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(674045), // Rule ID 10421 //
     /*  673975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  673983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11373:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  674021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  674024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674043 */     GIR_RootConstrainSelectedInstOperands,
     /*  674044 */     // GIR_Coverage, 10421,
     /*  674044 */     GIR_EraseRootFromParent_Done,
     /*  674045 */   // Label 10716: @674045
     /*  674045 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(674120), // Rule ID 10424 //
     /*  674050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  674070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  674099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674118 */     GIR_RootConstrainSelectedInstOperands,
     /*  674119 */     // GIR_Coverage, 10424,
     /*  674119 */     GIR_EraseRootFromParent_Done,
     /*  674120 */   // Label 10717: @674120
     /*  674120 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(674195), // Rule ID 10425 //
     /*  674125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  674136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  674139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  674142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  674145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  674174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674193 */     GIR_RootConstrainSelectedInstOperands,
     /*  674194 */     // GIR_Coverage, 10425,
     /*  674194 */     GIR_EraseRootFromParent_Done,
     /*  674195 */   // Label 10718: @674195
     /*  674195 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(674270), // Rule ID 10428 //
     /*  674200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  674220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674268 */     GIR_RootConstrainSelectedInstOperands,
     /*  674269 */     // GIR_Coverage, 10428,
     /*  674269 */     GIR_EraseRootFromParent_Done,
     /*  674270 */   // Label 10719: @674270
     /*  674270 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(674345), // Rule ID 10429 //
     /*  674275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  674286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  674289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  674292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  674295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674343 */     GIR_RootConstrainSelectedInstOperands,
     /*  674344 */     // GIR_Coverage, 10429,
     /*  674344 */     GIR_EraseRootFromParent_Done,
     /*  674345 */   // Label 10720: @674345
     /*  674345 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(674420), // Rule ID 10432 //
     /*  674350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  674370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674418 */     GIR_RootConstrainSelectedInstOperands,
     /*  674419 */     // GIR_Coverage, 10432,
     /*  674419 */     GIR_EraseRootFromParent_Done,
     /*  674420 */   // Label 10721: @674420
     /*  674420 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(674495), // Rule ID 10433 //
     /*  674425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  674436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  674439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  674442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  674445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674493 */     GIR_RootConstrainSelectedInstOperands,
     /*  674494 */     // GIR_Coverage, 10433,
     /*  674494 */     GIR_EraseRootFromParent_Done,
     /*  674495 */   // Label 10722: @674495
     /*  674495 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(674570), // Rule ID 10436 //
     /*  674500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  674520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674568 */     GIR_RootConstrainSelectedInstOperands,
     /*  674569 */     // GIR_Coverage, 10436,
     /*  674569 */     GIR_EraseRootFromParent_Done,
     /*  674570 */   // Label 10723: @674570
     /*  674570 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(674645), // Rule ID 10437 //
     /*  674575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  674595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  674624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674643 */     GIR_RootConstrainSelectedInstOperands,
     /*  674644 */     // GIR_Coverage, 10437,
     /*  674644 */     GIR_EraseRootFromParent_Done,
     /*  674645 */   // Label 10724: @674645
     /*  674645 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(674720), // Rule ID 10440 //
     /*  674650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  674670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674718 */     GIR_RootConstrainSelectedInstOperands,
     /*  674719 */     // GIR_Coverage, 10440,
     /*  674719 */     GIR_EraseRootFromParent_Done,
     /*  674720 */   // Label 10725: @674720
     /*  674720 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(674795), // Rule ID 10441 //
     /*  674725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  674745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674793 */     GIR_RootConstrainSelectedInstOperands,
     /*  674794 */     // GIR_Coverage, 10441,
     /*  674794 */     GIR_EraseRootFromParent_Done,
     /*  674795 */   // Label 10726: @674795
     /*  674795 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(674870), // Rule ID 10444 //
     /*  674800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  674820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674868 */     GIR_RootConstrainSelectedInstOperands,
     /*  674869 */     // GIR_Coverage, 10444,
     /*  674869 */     GIR_EraseRootFromParent_Done,
     /*  674870 */   // Label 10727: @674870
     /*  674870 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(674945), // Rule ID 10445 //
     /*  674875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  674895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  674924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674943 */     GIR_RootConstrainSelectedInstOperands,
     /*  674944 */     // GIR_Coverage, 10445,
     /*  674944 */     GIR_EraseRootFromParent_Done,
     /*  674945 */   // Label 10728: @674945
     /*  674945 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(675020), // Rule ID 10448 //
     /*  674950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  674970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  674999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675018 */     GIR_RootConstrainSelectedInstOperands,
     /*  675019 */     // GIR_Coverage, 10448,
     /*  675019 */     GIR_EraseRootFromParent_Done,
     /*  675020 */   // Label 10729: @675020
     /*  675020 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(675095), // Rule ID 10449 //
     /*  675025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  675036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  675039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  675042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  675045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675093 */     GIR_RootConstrainSelectedInstOperands,
     /*  675094 */     // GIR_Coverage, 10449,
     /*  675094 */     GIR_EraseRootFromParent_Done,
     /*  675095 */   // Label 10730: @675095
     /*  675095 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(675170), // Rule ID 10452 //
     /*  675100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  675120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675168 */     GIR_RootConstrainSelectedInstOperands,
     /*  675169 */     // GIR_Coverage, 10452,
     /*  675169 */     GIR_EraseRootFromParent_Done,
     /*  675170 */   // Label 10731: @675170
     /*  675170 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(675245), // Rule ID 10453 //
     /*  675175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  675186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  675189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  675192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  675195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675243 */     GIR_RootConstrainSelectedInstOperands,
     /*  675244 */     // GIR_Coverage, 10453,
     /*  675244 */     GIR_EraseRootFromParent_Done,
     /*  675245 */   // Label 10732: @675245
     /*  675245 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(675320), // Rule ID 10456 //
     /*  675250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  675270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675318 */     GIR_RootConstrainSelectedInstOperands,
     /*  675319 */     // GIR_Coverage, 10456,
     /*  675319 */     GIR_EraseRootFromParent_Done,
     /*  675320 */   // Label 10733: @675320
     /*  675320 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(675395), // Rule ID 10457 //
     /*  675325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  675336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  675339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  675342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  675345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675393 */     GIR_RootConstrainSelectedInstOperands,
     /*  675394 */     // GIR_Coverage, 10457,
     /*  675394 */     GIR_EraseRootFromParent_Done,
     /*  675395 */   // Label 10734: @675395
     /*  675395 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(675470), // Rule ID 10460 //
     /*  675400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  675420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675468 */     GIR_RootConstrainSelectedInstOperands,
     /*  675469 */     // GIR_Coverage, 10460,
     /*  675469 */     GIR_EraseRootFromParent_Done,
     /*  675470 */   // Label 10735: @675470
     /*  675470 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(675545), // Rule ID 10461 //
     /*  675475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  675486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  675489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  675492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  675495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  675514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  675524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675543 */     GIR_RootConstrainSelectedInstOperands,
     /*  675544 */     // GIR_Coverage, 10461,
     /*  675544 */     GIR_EraseRootFromParent_Done,
     /*  675545 */   // Label 10736: @675545
     /*  675545 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(675620), // Rule ID 10464 //
     /*  675550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  675570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  675599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675618 */     GIR_RootConstrainSelectedInstOperands,
     /*  675619 */     // GIR_Coverage, 10464,
     /*  675619 */     GIR_EraseRootFromParent_Done,
     /*  675620 */   // Label 10737: @675620
     /*  675620 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(675695), // Rule ID 10465 //
     /*  675625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  675645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  675674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675693 */     GIR_RootConstrainSelectedInstOperands,
     /*  675694 */     // GIR_Coverage, 10465,
     /*  675694 */     GIR_EraseRootFromParent_Done,
     /*  675695 */   // Label 10738: @675695
     /*  675695 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(675770), // Rule ID 10468 //
     /*  675700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  675720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  675749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675768 */     GIR_RootConstrainSelectedInstOperands,
     /*  675769 */     // GIR_Coverage, 10468,
     /*  675769 */     GIR_EraseRootFromParent_Done,
     /*  675770 */   // Label 10739: @675770
     /*  675770 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(675845), // Rule ID 10469 //
     /*  675775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  675795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  675824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675843 */     GIR_RootConstrainSelectedInstOperands,
     /*  675844 */     // GIR_Coverage, 10469,
     /*  675844 */     GIR_EraseRootFromParent_Done,
     /*  675845 */   // Label 10740: @675845
     /*  675845 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(675920), // Rule ID 10472 //
     /*  675850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  675870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  675899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675918 */     GIR_RootConstrainSelectedInstOperands,
     /*  675919 */     // GIR_Coverage, 10472,
     /*  675919 */     GIR_EraseRootFromParent_Done,
     /*  675920 */   // Label 10741: @675920
     /*  675920 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(675995), // Rule ID 10473 //
     /*  675925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  675945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  675974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675993 */     GIR_RootConstrainSelectedInstOperands,
     /*  675994 */     // GIR_Coverage, 10473,
     /*  675994 */     GIR_EraseRootFromParent_Done,
     /*  675995 */   // Label 10742: @675995
     /*  675995 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(676070), // Rule ID 10476 //
     /*  676000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  676020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676068 */     GIR_RootConstrainSelectedInstOperands,
     /*  676069 */     // GIR_Coverage, 10476,
     /*  676069 */     GIR_EraseRootFromParent_Done,
     /*  676070 */   // Label 10743: @676070
     /*  676070 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(676145), // Rule ID 10477 //
     /*  676075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  676086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  676089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  676092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  676095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676143 */     GIR_RootConstrainSelectedInstOperands,
     /*  676144 */     // GIR_Coverage, 10477,
     /*  676144 */     GIR_EraseRootFromParent_Done,
     /*  676145 */   // Label 10744: @676145
     /*  676145 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(676220), // Rule ID 10480 //
     /*  676150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  676170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676218 */     GIR_RootConstrainSelectedInstOperands,
     /*  676219 */     // GIR_Coverage, 10480,
     /*  676219 */     GIR_EraseRootFromParent_Done,
     /*  676220 */   // Label 10745: @676220
     /*  676220 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(676295), // Rule ID 10481 //
     /*  676225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  676236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  676239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  676242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  676245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676293 */     GIR_RootConstrainSelectedInstOperands,
     /*  676294 */     // GIR_Coverage, 10481,
     /*  676294 */     GIR_EraseRootFromParent_Done,
     /*  676295 */   // Label 10746: @676295
     /*  676295 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(676370), // Rule ID 10484 //
     /*  676300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  676320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676368 */     GIR_RootConstrainSelectedInstOperands,
     /*  676369 */     // GIR_Coverage, 10484,
     /*  676369 */     GIR_EraseRootFromParent_Done,
     /*  676370 */   // Label 10747: @676370
     /*  676370 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(676445), // Rule ID 10485 //
     /*  676375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  676386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  676389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  676392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  676395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676443 */     GIR_RootConstrainSelectedInstOperands,
     /*  676444 */     // GIR_Coverage, 10485,
     /*  676444 */     GIR_EraseRootFromParent_Done,
     /*  676445 */   // Label 10748: @676445
     /*  676445 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(676520), // Rule ID 10488 //
     /*  676450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  676470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676518 */     GIR_RootConstrainSelectedInstOperands,
     /*  676519 */     // GIR_Coverage, 10488,
     /*  676519 */     GIR_EraseRootFromParent_Done,
     /*  676520 */   // Label 10749: @676520
     /*  676520 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(676595), // Rule ID 10489 //
     /*  676525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  676536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  676539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  676542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  676545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676593 */     GIR_RootConstrainSelectedInstOperands,
     /*  676594 */     // GIR_Coverage, 10489,
     /*  676594 */     GIR_EraseRootFromParent_Done,
     /*  676595 */   // Label 10750: @676595
     /*  676595 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(676670), // Rule ID 10492 //
     /*  676600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  676620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676668 */     GIR_RootConstrainSelectedInstOperands,
     /*  676669 */     // GIR_Coverage, 10492,
     /*  676669 */     GIR_EraseRootFromParent_Done,
     /*  676670 */   // Label 10751: @676670
     /*  676670 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(676745), // Rule ID 10493 //
     /*  676675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  676695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  676724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676743 */     GIR_RootConstrainSelectedInstOperands,
     /*  676744 */     // GIR_Coverage, 10493,
     /*  676744 */     GIR_EraseRootFromParent_Done,
     /*  676745 */   // Label 10752: @676745
     /*  676745 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(676820), // Rule ID 10496 //
     /*  676750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  676770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676818 */     GIR_RootConstrainSelectedInstOperands,
     /*  676819 */     // GIR_Coverage, 10496,
     /*  676819 */     GIR_EraseRootFromParent_Done,
     /*  676820 */   // Label 10753: @676820
     /*  676820 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(676895), // Rule ID 10497 //
     /*  676825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  676845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  676874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676893 */     GIR_RootConstrainSelectedInstOperands,
     /*  676894 */     // GIR_Coverage, 10497,
     /*  676894 */     GIR_EraseRootFromParent_Done,
     /*  676895 */   // Label 10754: @676895
     /*  676895 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(676970), // Rule ID 10500 //
     /*  676900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  676920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  676949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676968 */     GIR_RootConstrainSelectedInstOperands,
     /*  676969 */     // GIR_Coverage, 10500,
     /*  676969 */     GIR_EraseRootFromParent_Done,
     /*  676970 */   // Label 10755: @676970
     /*  676970 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(677045), // Rule ID 10501 //
     /*  676975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  676995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  677024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677043 */     GIR_RootConstrainSelectedInstOperands,
     /*  677044 */     // GIR_Coverage, 10501,
     /*  677044 */     GIR_EraseRootFromParent_Done,
     /*  677045 */   // Label 10756: @677045
     /*  677045 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(677120), // Rule ID 10504 //
     /*  677050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  677070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  677099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677118 */     GIR_RootConstrainSelectedInstOperands,
     /*  677119 */     // GIR_Coverage, 10504,
     /*  677119 */     GIR_EraseRootFromParent_Done,
     /*  677120 */   // Label 10757: @677120
     /*  677120 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(677195), // Rule ID 10505 //
     /*  677125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  677136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  677139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  677142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  677145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  677174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677193 */     GIR_RootConstrainSelectedInstOperands,
     /*  677194 */     // GIR_Coverage, 10505,
     /*  677194 */     GIR_EraseRootFromParent_Done,
     /*  677195 */   // Label 10758: @677195
     /*  677195 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(677270), // Rule ID 10508 //
     /*  677200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  677220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  677249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677268 */     GIR_RootConstrainSelectedInstOperands,
     /*  677269 */     // GIR_Coverage, 10508,
     /*  677269 */     GIR_EraseRootFromParent_Done,
     /*  677270 */   // Label 10759: @677270
     /*  677270 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(677345), // Rule ID 10509 //
     /*  677275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  677286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  677289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  677292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  677295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  677314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  677324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677343 */     GIR_RootConstrainSelectedInstOperands,
     /*  677344 */     // GIR_Coverage, 10509,
     /*  677344 */     GIR_EraseRootFromParent_Done,
     /*  677345 */   // Label 10760: @677345
     /*  677345 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(677420), // Rule ID 10512 //
     /*  677350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  677399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677418 */     GIR_RootConstrainSelectedInstOperands,
     /*  677419 */     // GIR_Coverage, 10512,
     /*  677419 */     GIR_EraseRootFromParent_Done,
     /*  677420 */   // Label 10761: @677420
     /*  677420 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(677495), // Rule ID 10513 //
     /*  677425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  677436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  677439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  677442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  677474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677493 */     GIR_RootConstrainSelectedInstOperands,
     /*  677494 */     // GIR_Coverage, 10513,
     /*  677494 */     GIR_EraseRootFromParent_Done,
     /*  677495 */   // Label 10762: @677495
     /*  677495 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(677570), // Rule ID 10516 //
     /*  677500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677568 */     GIR_RootConstrainSelectedInstOperands,
     /*  677569 */     // GIR_Coverage, 10516,
     /*  677569 */     GIR_EraseRootFromParent_Done,
     /*  677570 */   // Label 10763: @677570
     /*  677570 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(677645), // Rule ID 10517 //
     /*  677575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677643 */     GIR_RootConstrainSelectedInstOperands,
     /*  677644 */     // GIR_Coverage, 10517,
     /*  677644 */     GIR_EraseRootFromParent_Done,
     /*  677645 */   // Label 10764: @677645
     /*  677645 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(677720), // Rule ID 10520 //
     /*  677650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677718 */     GIR_RootConstrainSelectedInstOperands,
     /*  677719 */     // GIR_Coverage, 10520,
     /*  677719 */     GIR_EraseRootFromParent_Done,
     /*  677720 */   // Label 10765: @677720
     /*  677720 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(677795), // Rule ID 10521 //
     /*  677725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677793 */     GIR_RootConstrainSelectedInstOperands,
     /*  677794 */     // GIR_Coverage, 10521,
     /*  677794 */     GIR_EraseRootFromParent_Done,
     /*  677795 */   // Label 10766: @677795
     /*  677795 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(677870), // Rule ID 10524 //
     /*  677800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677868 */     GIR_RootConstrainSelectedInstOperands,
     /*  677869 */     // GIR_Coverage, 10524,
     /*  677869 */     GIR_EraseRootFromParent_Done,
     /*  677870 */   // Label 10767: @677870
     /*  677870 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(677945), // Rule ID 10525 //
     /*  677875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  677895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  677924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677943 */     GIR_RootConstrainSelectedInstOperands,
     /*  677944 */     // GIR_Coverage, 10525,
     /*  677944 */     GIR_EraseRootFromParent_Done,
     /*  677945 */   // Label 10768: @677945
     /*  677945 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(678020), // Rule ID 10528 //
     /*  677950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  677958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  677970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  677989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  677999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678018 */     GIR_RootConstrainSelectedInstOperands,
     /*  678019 */     // GIR_Coverage, 10528,
     /*  678019 */     GIR_EraseRootFromParent_Done,
     /*  678020 */   // Label 10769: @678020
     /*  678020 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(678095), // Rule ID 10529 //
     /*  678025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  678036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  678039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  678042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678093 */     GIR_RootConstrainSelectedInstOperands,
     /*  678094 */     // GIR_Coverage, 10529,
     /*  678094 */     GIR_EraseRootFromParent_Done,
     /*  678095 */   // Label 10770: @678095
     /*  678095 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(678170), // Rule ID 10532 //
     /*  678100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678168 */     GIR_RootConstrainSelectedInstOperands,
     /*  678169 */     // GIR_Coverage, 10532,
     /*  678169 */     GIR_EraseRootFromParent_Done,
     /*  678170 */   // Label 10771: @678170
     /*  678170 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(678245), // Rule ID 10533 //
     /*  678175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  678186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  678189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  678192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  678224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678243 */     GIR_RootConstrainSelectedInstOperands,
     /*  678244 */     // GIR_Coverage, 10533,
     /*  678244 */     GIR_EraseRootFromParent_Done,
     /*  678245 */   // Label 10772: @678245
     /*  678245 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(678320), // Rule ID 10536 //
     /*  678250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678318 */     GIR_RootConstrainSelectedInstOperands,
     /*  678319 */     // GIR_Coverage, 10536,
     /*  678319 */     GIR_EraseRootFromParent_Done,
     /*  678320 */   // Label 10773: @678320
     /*  678320 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(678395), // Rule ID 10537 //
     /*  678325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  678336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  678339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  678342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678393 */     GIR_RootConstrainSelectedInstOperands,
     /*  678394 */     // GIR_Coverage, 10537,
     /*  678394 */     GIR_EraseRootFromParent_Done,
     /*  678395 */   // Label 10774: @678395
     /*  678395 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(678470), // Rule ID 10540 //
     /*  678400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678468 */     GIR_RootConstrainSelectedInstOperands,
     /*  678469 */     // GIR_Coverage, 10540,
     /*  678469 */     GIR_EraseRootFromParent_Done,
     /*  678470 */   // Label 10775: @678470
     /*  678470 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(678545), // Rule ID 10541 //
     /*  678475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  678486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  678489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  678492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678543 */     GIR_RootConstrainSelectedInstOperands,
     /*  678544 */     // GIR_Coverage, 10541,
     /*  678544 */     GIR_EraseRootFromParent_Done,
     /*  678545 */   // Label 10776: @678545
     /*  678545 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(678620), // Rule ID 10544 //
     /*  678550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678618 */     GIR_RootConstrainSelectedInstOperands,
     /*  678619 */     // GIR_Coverage, 10544,
     /*  678619 */     GIR_EraseRootFromParent_Done,
     /*  678620 */   // Label 10777: @678620
     /*  678620 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(678695), // Rule ID 10545 //
     /*  678625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678693 */     GIR_RootConstrainSelectedInstOperands,
     /*  678694 */     // GIR_Coverage, 10545,
     /*  678694 */     GIR_EraseRootFromParent_Done,
     /*  678695 */   // Label 10778: @678695
     /*  678695 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(678770), // Rule ID 10548 //
     /*  678700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678768 */     GIR_RootConstrainSelectedInstOperands,
     /*  678769 */     // GIR_Coverage, 10548,
     /*  678769 */     GIR_EraseRootFromParent_Done,
     /*  678770 */   // Label 10779: @678770
     /*  678770 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(678845), // Rule ID 10549 //
     /*  678775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  678824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678843 */     GIR_RootConstrainSelectedInstOperands,
     /*  678844 */     // GIR_Coverage, 10549,
     /*  678844 */     GIR_EraseRootFromParent_Done,
     /*  678845 */   // Label 10780: @678845
     /*  678845 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(678920), // Rule ID 10552 //
     /*  678850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  678870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  678899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678918 */     GIR_RootConstrainSelectedInstOperands,
     /*  678919 */     // GIR_Coverage, 10552,
     /*  678919 */     GIR_EraseRootFromParent_Done,
     /*  678920 */   // Label 10781: @678920
     /*  678920 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(678995), // Rule ID 10553 //
     /*  678925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  678933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  678945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  678964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  678974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678993 */     GIR_RootConstrainSelectedInstOperands,
     /*  678994 */     // GIR_Coverage, 10553,
     /*  678994 */     GIR_EraseRootFromParent_Done,
     /*  678995 */   // Label 10782: @678995
     /*  678995 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(679070), // Rule ID 10556 //
     /*  679000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679068 */     GIR_RootConstrainSelectedInstOperands,
     /*  679069 */     // GIR_Coverage, 10556,
     /*  679069 */     GIR_EraseRootFromParent_Done,
     /*  679070 */   // Label 10783: @679070
     /*  679070 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(679145), // Rule ID 10557 //
     /*  679075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  679086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  679089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  679092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679143 */     GIR_RootConstrainSelectedInstOperands,
     /*  679144 */     // GIR_Coverage, 10557,
     /*  679144 */     GIR_EraseRootFromParent_Done,
     /*  679145 */   // Label 10784: @679145
     /*  679145 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(679220), // Rule ID 10560 //
     /*  679150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679218 */     GIR_RootConstrainSelectedInstOperands,
     /*  679219 */     // GIR_Coverage, 10560,
     /*  679219 */     GIR_EraseRootFromParent_Done,
     /*  679220 */   // Label 10785: @679220
     /*  679220 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(679295), // Rule ID 10561 //
     /*  679225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  679236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  679239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  679242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679293 */     GIR_RootConstrainSelectedInstOperands,
     /*  679294 */     // GIR_Coverage, 10561,
     /*  679294 */     GIR_EraseRootFromParent_Done,
     /*  679295 */   // Label 10786: @679295
     /*  679295 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(679370), // Rule ID 10564 //
     /*  679300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679368 */     GIR_RootConstrainSelectedInstOperands,
     /*  679369 */     // GIR_Coverage, 10564,
     /*  679369 */     GIR_EraseRootFromParent_Done,
     /*  679370 */   // Label 10787: @679370
     /*  679370 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(679445), // Rule ID 10565 //
     /*  679375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  679386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  679389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  679392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679443 */     GIR_RootConstrainSelectedInstOperands,
     /*  679444 */     // GIR_Coverage, 10565,
     /*  679444 */     GIR_EraseRootFromParent_Done,
     /*  679445 */   // Label 10788: @679445
     /*  679445 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(679520), // Rule ID 10568 //
     /*  679450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679518 */     GIR_RootConstrainSelectedInstOperands,
     /*  679519 */     // GIR_Coverage, 10568,
     /*  679519 */     GIR_EraseRootFromParent_Done,
     /*  679520 */   // Label 10789: @679520
     /*  679520 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(679595), // Rule ID 10569 //
     /*  679525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  679536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  679539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  679542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679593 */     GIR_RootConstrainSelectedInstOperands,
     /*  679594 */     // GIR_Coverage, 10569,
     /*  679594 */     GIR_EraseRootFromParent_Done,
     /*  679595 */   // Label 10790: @679595
     /*  679595 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(679670), // Rule ID 10572 //
     /*  679600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679668 */     GIR_RootConstrainSelectedInstOperands,
     /*  679669 */     // GIR_Coverage, 10572,
     /*  679669 */     GIR_EraseRootFromParent_Done,
     /*  679670 */   // Label 10791: @679670
     /*  679670 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(679745), // Rule ID 10573 //
     /*  679675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  679724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679743 */     GIR_RootConstrainSelectedInstOperands,
     /*  679744 */     // GIR_Coverage, 10573,
     /*  679744 */     GIR_EraseRootFromParent_Done,
     /*  679745 */   // Label 10792: @679745
     /*  679745 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(679820), // Rule ID 10576 //
     /*  679750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679818 */     GIR_RootConstrainSelectedInstOperands,
     /*  679819 */     // GIR_Coverage, 10576,
     /*  679819 */     GIR_EraseRootFromParent_Done,
     /*  679820 */   // Label 10793: @679820
     /*  679820 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(679895), // Rule ID 10577 //
     /*  679825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  679874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679893 */     GIR_RootConstrainSelectedInstOperands,
     /*  679894 */     // GIR_Coverage, 10577,
     /*  679894 */     GIR_EraseRootFromParent_Done,
     /*  679895 */   // Label 10794: @679895
     /*  679895 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(679970), // Rule ID 10580 //
     /*  679900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  679949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679968 */     GIR_RootConstrainSelectedInstOperands,
     /*  679969 */     // GIR_Coverage, 10580,
     /*  679969 */     GIR_EraseRootFromParent_Done,
     /*  679970 */   // Label 10795: @679970
     /*  679970 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(680045), // Rule ID 10581 //
     /*  679975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  679983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680043 */     GIR_RootConstrainSelectedInstOperands,
     /*  680044 */     // GIR_Coverage, 10581,
     /*  680044 */     GIR_EraseRootFromParent_Done,
     /*  680045 */   // Label 10796: @680045
     /*  680045 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(680120), // Rule ID 10584 //
     /*  680050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680118 */     GIR_RootConstrainSelectedInstOperands,
     /*  680119 */     // GIR_Coverage, 10584,
     /*  680119 */     GIR_EraseRootFromParent_Done,
     /*  680120 */   // Label 10797: @680120
     /*  680120 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(680195), // Rule ID 10585 //
     /*  680125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  680136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  680139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  680142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680193 */     GIR_RootConstrainSelectedInstOperands,
     /*  680194 */     // GIR_Coverage, 10585,
     /*  680194 */     GIR_EraseRootFromParent_Done,
     /*  680195 */   // Label 10798: @680195
     /*  680195 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(680270), // Rule ID 10588 //
     /*  680200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  680249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680268 */     GIR_RootConstrainSelectedInstOperands,
     /*  680269 */     // GIR_Coverage, 10588,
     /*  680269 */     GIR_EraseRootFromParent_Done,
     /*  680270 */   // Label 10799: @680270
     /*  680270 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(680345), // Rule ID 10589 //
     /*  680275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  680286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  680289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  680292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  680310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  680324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680343 */     GIR_RootConstrainSelectedInstOperands,
     /*  680344 */     // GIR_Coverage, 10589,
     /*  680344 */     GIR_EraseRootFromParent_Done,
     /*  680345 */   // Label 10800: @680345
     /*  680345 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(680420), // Rule ID 10592 //
     /*  680350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680418 */     GIR_RootConstrainSelectedInstOperands,
     /*  680419 */     // GIR_Coverage, 10592,
     /*  680419 */     GIR_EraseRootFromParent_Done,
     /*  680420 */   // Label 10801: @680420
     /*  680420 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(680495), // Rule ID 10593 //
     /*  680425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  680436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  680439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  680442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  680460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  680474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680493 */     GIR_RootConstrainSelectedInstOperands,
     /*  680494 */     // GIR_Coverage, 10593,
     /*  680494 */     GIR_EraseRootFromParent_Done,
     /*  680495 */   // Label 10802: @680495
     /*  680495 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(680570), // Rule ID 10596 //
     /*  680500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680568 */     GIR_RootConstrainSelectedInstOperands,
     /*  680569 */     // GIR_Coverage, 10596,
     /*  680569 */     GIR_EraseRootFromParent_Done,
     /*  680570 */   // Label 10803: @680570
     /*  680570 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(680645), // Rule ID 10597 //
     /*  680575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  680583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  680624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680643 */     GIR_RootConstrainSelectedInstOperands,
     /*  680644 */     // GIR_Coverage, 10597,
     /*  680644 */     GIR_EraseRootFromParent_Done,
     /*  680645 */   // Label 10804: @680645
     /*  680645 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(680720), // Rule ID 10600 //
     /*  680650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  680670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680696 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  680699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680718 */     GIR_RootConstrainSelectedInstOperands,
     /*  680719 */     // GIR_Coverage, 10600,
     /*  680719 */     GIR_EraseRootFromParent_Done,
     /*  680720 */   // Label 10805: @680720
     /*  680720 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(680795), // Rule ID 10601 //
     /*  680725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  680745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  680774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680793 */     GIR_RootConstrainSelectedInstOperands,
     /*  680794 */     // GIR_Coverage, 10601,
     /*  680794 */     GIR_EraseRootFromParent_Done,
     /*  680795 */   // Label 10806: @680795
     /*  680795 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(680870), // Rule ID 10604 //
     /*  680800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  680820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  680849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680868 */     GIR_RootConstrainSelectedInstOperands,
     /*  680869 */     // GIR_Coverage, 10604,
     /*  680869 */     GIR_EraseRootFromParent_Done,
     /*  680870 */   // Label 10807: @680870
     /*  680870 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(680945), // Rule ID 10605 //
     /*  680875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  680895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  680924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680943 */     GIR_RootConstrainSelectedInstOperands,
     /*  680944 */     // GIR_Coverage, 10605,
     /*  680944 */     GIR_EraseRootFromParent_Done,
     /*  680945 */   // Label 10808: @680945
     /*  680945 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(681020), // Rule ID 10608 //
     /*  680950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  680970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  680999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681018 */     GIR_RootConstrainSelectedInstOperands,
     /*  681019 */     // GIR_Coverage, 10608,
     /*  681019 */     GIR_EraseRootFromParent_Done,
     /*  681020 */   // Label 10809: @681020
     /*  681020 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(681095), // Rule ID 10609 //
     /*  681025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  681036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  681039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  681042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  681045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681071 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681093 */     GIR_RootConstrainSelectedInstOperands,
     /*  681094 */     // GIR_Coverage, 10609,
     /*  681094 */     GIR_EraseRootFromParent_Done,
     /*  681095 */   // Label 10810: @681095
     /*  681095 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(681170), // Rule ID 10612 //
     /*  681100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  681120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  681149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681168 */     GIR_RootConstrainSelectedInstOperands,
     /*  681169 */     // GIR_Coverage, 10612,
     /*  681169 */     GIR_EraseRootFromParent_Done,
     /*  681170 */   // Label 10811: @681170
     /*  681170 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(681245), // Rule ID 10613 //
     /*  681175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  681186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  681189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  681192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  681195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  681224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681243 */     GIR_RootConstrainSelectedInstOperands,
     /*  681244 */     // GIR_Coverage, 10613,
     /*  681244 */     GIR_EraseRootFromParent_Done,
     /*  681245 */   // Label 10812: @681245
     /*  681245 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(681320), // Rule ID 10616 //
     /*  681250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  681270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681318 */     GIR_RootConstrainSelectedInstOperands,
     /*  681319 */     // GIR_Coverage, 10616,
     /*  681319 */     GIR_EraseRootFromParent_Done,
     /*  681320 */   // Label 10813: @681320
     /*  681320 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(681395), // Rule ID 10617 //
     /*  681325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  681336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  681339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  681342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  681345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681393 */     GIR_RootConstrainSelectedInstOperands,
     /*  681394 */     // GIR_Coverage, 10617,
     /*  681394 */     GIR_EraseRootFromParent_Done,
     /*  681395 */   // Label 10814: @681395
     /*  681395 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(681470), // Rule ID 10620 //
     /*  681400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  681420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681468 */     GIR_RootConstrainSelectedInstOperands,
     /*  681469 */     // GIR_Coverage, 10620,
     /*  681469 */     GIR_EraseRootFromParent_Done,
     /*  681470 */   // Label 10815: @681470
     /*  681470 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(681545), // Rule ID 10621 //
     /*  681475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  681486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  681489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  681492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  681495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  681524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681543 */     GIR_RootConstrainSelectedInstOperands,
     /*  681544 */     // GIR_Coverage, 10621,
     /*  681544 */     GIR_EraseRootFromParent_Done,
     /*  681545 */   // Label 10816: @681545
     /*  681545 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(681620), // Rule ID 10624 //
     /*  681550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  681570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681618 */     GIR_RootConstrainSelectedInstOperands,
     /*  681619 */     // GIR_Coverage, 10624,
     /*  681619 */     GIR_EraseRootFromParent_Done,
     /*  681620 */   // Label 10817: @681620
     /*  681620 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(681695), // Rule ID 10625 //
     /*  681625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  681645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681693 */     GIR_RootConstrainSelectedInstOperands,
     /*  681694 */     // GIR_Coverage, 10625,
     /*  681694 */     GIR_EraseRootFromParent_Done,
     /*  681695 */   // Label 10818: @681695
     /*  681695 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(681770), // Rule ID 10628 //
     /*  681700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  681720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681768 */     GIR_RootConstrainSelectedInstOperands,
     /*  681769 */     // GIR_Coverage, 10628,
     /*  681769 */     GIR_EraseRootFromParent_Done,
     /*  681770 */   // Label 10819: @681770
     /*  681770 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(681845), // Rule ID 10629 //
     /*  681775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  681795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681843 */     GIR_RootConstrainSelectedInstOperands,
     /*  681844 */     // GIR_Coverage, 10629,
     /*  681844 */     GIR_EraseRootFromParent_Done,
     /*  681845 */   // Label 10820: @681845
     /*  681845 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(681920), // Rule ID 10632 //
     /*  681850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  681870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681918 */     GIR_RootConstrainSelectedInstOperands,
     /*  681919 */     // GIR_Coverage, 10632,
     /*  681919 */     GIR_EraseRootFromParent_Done,
     /*  681920 */   // Label 10821: @681920
     /*  681920 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(681995), // Rule ID 10633 //
     /*  681925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  681945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  681974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681993 */     GIR_RootConstrainSelectedInstOperands,
     /*  681994 */     // GIR_Coverage, 10633,
     /*  681994 */     GIR_EraseRootFromParent_Done,
     /*  681995 */   // Label 10822: @681995
     /*  681995 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(682070), // Rule ID 10636 //
     /*  682000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  682020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  682049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682068 */     GIR_RootConstrainSelectedInstOperands,
     /*  682069 */     // GIR_Coverage, 10636,
     /*  682069 */     GIR_EraseRootFromParent_Done,
     /*  682070 */   // Label 10823: @682070
     /*  682070 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(682145), // Rule ID 10637 //
     /*  682075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  682086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  682089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  682092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  682095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682121 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  682124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682143 */     GIR_RootConstrainSelectedInstOperands,
     /*  682144 */     // GIR_Coverage, 10637,
     /*  682144 */     GIR_EraseRootFromParent_Done,
     /*  682145 */   // Label 10824: @682145
     /*  682145 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(682220), // Rule ID 10640 //
     /*  682150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  682170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682218 */     GIR_RootConstrainSelectedInstOperands,
     /*  682219 */     // GIR_Coverage, 10640,
     /*  682219 */     GIR_EraseRootFromParent_Done,
     /*  682220 */   // Label 10825: @682220
     /*  682220 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(682295), // Rule ID 10641 //
     /*  682225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  682236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  682239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  682242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  682245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682293 */     GIR_RootConstrainSelectedInstOperands,
     /*  682294 */     // GIR_Coverage, 10641,
     /*  682294 */     GIR_EraseRootFromParent_Done,
     /*  682295 */   // Label 10826: @682295
     /*  682295 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(682370), // Rule ID 10644 //
     /*  682300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  682320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682346 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682368 */     GIR_RootConstrainSelectedInstOperands,
     /*  682369 */     // GIR_Coverage, 10644,
     /*  682369 */     GIR_EraseRootFromParent_Done,
     /*  682370 */   // Label 10827: @682370
     /*  682370 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(682445), // Rule ID 10645 //
     /*  682375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  682386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  682389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  682392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  682395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682421 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682443 */     GIR_RootConstrainSelectedInstOperands,
     /*  682444 */     // GIR_Coverage, 10645,
     /*  682444 */     GIR_EraseRootFromParent_Done,
     /*  682445 */   // Label 10828: @682445
     /*  682445 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(682520), // Rule ID 10648 //
     /*  682450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  682470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682518 */     GIR_RootConstrainSelectedInstOperands,
     /*  682519 */     // GIR_Coverage, 10648,
     /*  682519 */     GIR_EraseRootFromParent_Done,
     /*  682520 */   // Label 10829: @682520
     /*  682520 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(682595), // Rule ID 10649 //
     /*  682525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  682536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  682539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  682542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  682545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682571 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682593 */     GIR_RootConstrainSelectedInstOperands,
     /*  682594 */     // GIR_Coverage, 10649,
     /*  682594 */     GIR_EraseRootFromParent_Done,
     /*  682595 */   // Label 10830: @682595
     /*  682595 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(682670), // Rule ID 10652 //
     /*  682600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  682620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682668 */     GIR_RootConstrainSelectedInstOperands,
     /*  682669 */     // GIR_Coverage, 10652,
     /*  682669 */     GIR_EraseRootFromParent_Done,
     /*  682670 */   // Label 10831: @682670
     /*  682670 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(682745), // Rule ID 10653 //
     /*  682675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  682695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  682724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682743 */     GIR_RootConstrainSelectedInstOperands,
     /*  682744 */     // GIR_Coverage, 10653,
     /*  682744 */     GIR_EraseRootFromParent_Done,
     /*  682745 */   // Label 10832: @682745
     /*  682745 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(682820), // Rule ID 10656 //
     /*  682750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  682770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682818 */     GIR_RootConstrainSelectedInstOperands,
     /*  682819 */     // GIR_Coverage, 10656,
     /*  682819 */     GIR_EraseRootFromParent_Done,
     /*  682820 */   // Label 10833: @682820
     /*  682820 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(682895), // Rule ID 10657 //
     /*  682825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  682845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  682874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682893 */     GIR_RootConstrainSelectedInstOperands,
     /*  682894 */     // GIR_Coverage, 10657,
     /*  682894 */     GIR_EraseRootFromParent_Done,
     /*  682895 */   // Label 10834: @682895
     /*  682895 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(682970), // Rule ID 10660 //
     /*  682900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  682920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  682949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682968 */     GIR_RootConstrainSelectedInstOperands,
     /*  682969 */     // GIR_Coverage, 10660,
     /*  682969 */     GIR_EraseRootFromParent_Done,
     /*  682970 */   // Label 10835: @682970
     /*  682970 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(683045), // Rule ID 10661 //
     /*  682975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  682995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683043 */     GIR_RootConstrainSelectedInstOperands,
     /*  683044 */     // GIR_Coverage, 10661,
     /*  683044 */     GIR_EraseRootFromParent_Done,
     /*  683045 */   // Label 10836: @683045
     /*  683045 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(683120), // Rule ID 10664 //
     /*  683050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  683070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683118 */     GIR_RootConstrainSelectedInstOperands,
     /*  683119 */     // GIR_Coverage, 10664,
     /*  683119 */     GIR_EraseRootFromParent_Done,
     /*  683120 */   // Label 10837: @683120
     /*  683120 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(683195), // Rule ID 10665 //
     /*  683125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  683136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  683139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  683142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  683145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683193 */     GIR_RootConstrainSelectedInstOperands,
     /*  683194 */     // GIR_Coverage, 10665,
     /*  683194 */     GIR_EraseRootFromParent_Done,
     /*  683195 */   // Label 10838: @683195
     /*  683195 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(683270), // Rule ID 10668 //
     /*  683200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  683220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683268 */     GIR_RootConstrainSelectedInstOperands,
     /*  683269 */     // GIR_Coverage, 10668,
     /*  683269 */     GIR_EraseRootFromParent_Done,
     /*  683270 */   // Label 10839: @683270
     /*  683270 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(683345), // Rule ID 10669 //
     /*  683275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  683286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  683289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  683292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  683295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683343 */     GIR_RootConstrainSelectedInstOperands,
     /*  683344 */     // GIR_Coverage, 10669,
     /*  683344 */     GIR_EraseRootFromParent_Done,
     /*  683345 */   // Label 10840: @683345
     /*  683345 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(683420), // Rule ID 10672 //
     /*  683350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  683370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683418 */     GIR_RootConstrainSelectedInstOperands,
     /*  683419 */     // GIR_Coverage, 10672,
     /*  683419 */     GIR_EraseRootFromParent_Done,
     /*  683420 */   // Label 10841: @683420
     /*  683420 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(683495), // Rule ID 10673 //
     /*  683425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  683436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  683439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  683442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  683445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683493 */     GIR_RootConstrainSelectedInstOperands,
     /*  683494 */     // GIR_Coverage, 10673,
     /*  683494 */     GIR_EraseRootFromParent_Done,
     /*  683495 */   // Label 10842: @683495
     /*  683495 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(683570), // Rule ID 10676 //
     /*  683500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  683520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683568 */     GIR_RootConstrainSelectedInstOperands,
     /*  683569 */     // GIR_Coverage, 10676,
     /*  683569 */     GIR_EraseRootFromParent_Done,
     /*  683570 */   // Label 10843: @683570
     /*  683570 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(683645), // Rule ID 10677 //
     /*  683575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  683595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683621 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  683624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683643 */     GIR_RootConstrainSelectedInstOperands,
     /*  683644 */     // GIR_Coverage, 10677,
     /*  683644 */     GIR_EraseRootFromParent_Done,
     /*  683645 */   // Label 10844: @683645
     /*  683645 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(683720), // Rule ID 10680 //
     /*  683650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  683670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683718 */     GIR_RootConstrainSelectedInstOperands,
     /*  683719 */     // GIR_Coverage, 10680,
     /*  683719 */     GIR_EraseRootFromParent_Done,
     /*  683720 */   // Label 10845: @683720
     /*  683720 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(683795), // Rule ID 10681 //
     /*  683725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  683745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683771 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  683774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683793 */     GIR_RootConstrainSelectedInstOperands,
     /*  683794 */     // GIR_Coverage, 10681,
     /*  683794 */     GIR_EraseRootFromParent_Done,
     /*  683795 */   // Label 10846: @683795
     /*  683795 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(683870), // Rule ID 10684 //
     /*  683800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  683820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683868 */     GIR_RootConstrainSelectedInstOperands,
     /*  683869 */     // GIR_Coverage, 10684,
     /*  683869 */     GIR_EraseRootFromParent_Done,
     /*  683870 */   // Label 10847: @683870
     /*  683870 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(683945), // Rule ID 10685 //
     /*  683875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  683895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683921 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  683924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683943 */     GIR_RootConstrainSelectedInstOperands,
     /*  683944 */     // GIR_Coverage, 10685,
     /*  683944 */     GIR_EraseRootFromParent_Done,
     /*  683945 */   // Label 10848: @683945
     /*  683945 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(684020), // Rule ID 10688 //
     /*  683950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  683999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684018 */     GIR_RootConstrainSelectedInstOperands,
     /*  684019 */     // GIR_Coverage, 10688,
     /*  684019 */     GIR_EraseRootFromParent_Done,
     /*  684020 */   // Label 10849: @684020
     /*  684020 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(684095), // Rule ID 10689 //
     /*  684025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  684036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  684039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  684042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  684074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684093 */     GIR_RootConstrainSelectedInstOperands,
     /*  684094 */     // GIR_Coverage, 10689,
     /*  684094 */     GIR_EraseRootFromParent_Done,
     /*  684095 */   // Label 10850: @684095
     /*  684095 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(684170), // Rule ID 10692 //
     /*  684100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684168 */     GIR_RootConstrainSelectedInstOperands,
     /*  684169 */     // GIR_Coverage, 10692,
     /*  684169 */     GIR_EraseRootFromParent_Done,
     /*  684170 */   // Label 10851: @684170
     /*  684170 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(684245), // Rule ID 10693 //
     /*  684175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  684186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  684189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  684192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684243 */     GIR_RootConstrainSelectedInstOperands,
     /*  684244 */     // GIR_Coverage, 10693,
     /*  684244 */     GIR_EraseRootFromParent_Done,
     /*  684245 */   // Label 10852: @684245
     /*  684245 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(684320), // Rule ID 10696 //
     /*  684250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684318 */     GIR_RootConstrainSelectedInstOperands,
     /*  684319 */     // GIR_Coverage, 10696,
     /*  684319 */     GIR_EraseRootFromParent_Done,
     /*  684320 */   // Label 10853: @684320
     /*  684320 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(684395), // Rule ID 10697 //
     /*  684325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  684336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  684339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  684342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684393 */     GIR_RootConstrainSelectedInstOperands,
     /*  684394 */     // GIR_Coverage, 10697,
     /*  684394 */     GIR_EraseRootFromParent_Done,
     /*  684395 */   // Label 10854: @684395
     /*  684395 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(684470), // Rule ID 10700 //
     /*  684400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684468 */     GIR_RootConstrainSelectedInstOperands,
     /*  684469 */     // GIR_Coverage, 10700,
     /*  684469 */     GIR_EraseRootFromParent_Done,
     /*  684470 */   // Label 10855: @684470
     /*  684470 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(684545), // Rule ID 10701 //
     /*  684475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  684486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  684489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  684492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  684524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684543 */     GIR_RootConstrainSelectedInstOperands,
     /*  684544 */     // GIR_Coverage, 10701,
     /*  684544 */     GIR_EraseRootFromParent_Done,
     /*  684545 */   // Label 10856: @684545
     /*  684545 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(684620), // Rule ID 10704 //
     /*  684550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684618 */     GIR_RootConstrainSelectedInstOperands,
     /*  684619 */     // GIR_Coverage, 10704,
     /*  684619 */     GIR_EraseRootFromParent_Done,
     /*  684620 */   // Label 10857: @684620
     /*  684620 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(684695), // Rule ID 10705 //
     /*  684625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684693 */     GIR_RootConstrainSelectedInstOperands,
     /*  684694 */     // GIR_Coverage, 10705,
     /*  684694 */     GIR_EraseRootFromParent_Done,
     /*  684695 */   // Label 10858: @684695
     /*  684695 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(684770), // Rule ID 10708 //
     /*  684700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684768 */     GIR_RootConstrainSelectedInstOperands,
     /*  684769 */     // GIR_Coverage, 10708,
     /*  684769 */     GIR_EraseRootFromParent_Done,
     /*  684770 */   // Label 10859: @684770
     /*  684770 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(684845), // Rule ID 10709 //
     /*  684775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  684824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684843 */     GIR_RootConstrainSelectedInstOperands,
     /*  684844 */     // GIR_Coverage, 10709,
     /*  684844 */     GIR_EraseRootFromParent_Done,
     /*  684845 */   // Label 10860: @684845
     /*  684845 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(684920), // Rule ID 10712 //
     /*  684850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  684870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  684899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684918 */     GIR_RootConstrainSelectedInstOperands,
     /*  684919 */     // GIR_Coverage, 10712,
     /*  684919 */     GIR_EraseRootFromParent_Done,
     /*  684920 */   // Label 10861: @684920
     /*  684920 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(684995), // Rule ID 10713 //
     /*  684925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  684933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  684945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  684964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11355:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  684974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684993 */     GIR_RootConstrainSelectedInstOperands,
     /*  684994 */     // GIR_Coverage, 10713,
     /*  684994 */     GIR_EraseRootFromParent_Done,
     /*  684995 */   // Label 10862: @684995
     /*  684995 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(685070), // Rule ID 10716 //
     /*  685000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685068 */     GIR_RootConstrainSelectedInstOperands,
     /*  685069 */     // GIR_Coverage, 10716,
     /*  685069 */     GIR_EraseRootFromParent_Done,
     /*  685070 */   // Label 10863: @685070
     /*  685070 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(685145), // Rule ID 10717 //
     /*  685075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  685086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  685089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  685092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685143 */     GIR_RootConstrainSelectedInstOperands,
     /*  685144 */     // GIR_Coverage, 10717,
     /*  685144 */     GIR_EraseRootFromParent_Done,
     /*  685145 */   // Label 10864: @685145
     /*  685145 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(685220), // Rule ID 10720 //
     /*  685150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685218 */     GIR_RootConstrainSelectedInstOperands,
     /*  685219 */     // GIR_Coverage, 10720,
     /*  685219 */     GIR_EraseRootFromParent_Done,
     /*  685220 */   // Label 10865: @685220
     /*  685220 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(685295), // Rule ID 10721 //
     /*  685225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  685236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  685239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  685242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685293 */     GIR_RootConstrainSelectedInstOperands,
     /*  685294 */     // GIR_Coverage, 10721,
     /*  685294 */     GIR_EraseRootFromParent_Done,
     /*  685295 */   // Label 10866: @685295
     /*  685295 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(685370), // Rule ID 10724 //
     /*  685300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685368 */     GIR_RootConstrainSelectedInstOperands,
     /*  685369 */     // GIR_Coverage, 10724,
     /*  685369 */     GIR_EraseRootFromParent_Done,
     /*  685370 */   // Label 10867: @685370
     /*  685370 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(685445), // Rule ID 10725 //
     /*  685375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  685386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  685389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  685392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  685410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  685424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685443 */     GIR_RootConstrainSelectedInstOperands,
     /*  685444 */     // GIR_Coverage, 10725,
     /*  685444 */     GIR_EraseRootFromParent_Done,
     /*  685445 */   // Label 10868: @685445
     /*  685445 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(685520), // Rule ID 10728 //
     /*  685450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685518 */     GIR_RootConstrainSelectedInstOperands,
     /*  685519 */     // GIR_Coverage, 10728,
     /*  685519 */     GIR_EraseRootFromParent_Done,
     /*  685520 */   // Label 10869: @685520
     /*  685520 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(685595), // Rule ID 10729 //
     /*  685525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  685536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  685539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  685542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685593 */     GIR_RootConstrainSelectedInstOperands,
     /*  685594 */     // GIR_Coverage, 10729,
     /*  685594 */     GIR_EraseRootFromParent_Done,
     /*  685595 */   // Label 10870: @685595
     /*  685595 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(685670), // Rule ID 10732 //
     /*  685600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  685649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685668 */     GIR_RootConstrainSelectedInstOperands,
     /*  685669 */     // GIR_Coverage, 10732,
     /*  685669 */     GIR_EraseRootFromParent_Done,
     /*  685670 */   // Label 10871: @685670
     /*  685670 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(685745), // Rule ID 10733 //
     /*  685675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  685724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685743 */     GIR_RootConstrainSelectedInstOperands,
     /*  685744 */     // GIR_Coverage, 10733,
     /*  685744 */     GIR_EraseRootFromParent_Done,
     /*  685745 */   // Label 10872: @685745
     /*  685745 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(685820), // Rule ID 10736 //
     /*  685750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  685799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685818 */     GIR_RootConstrainSelectedInstOperands,
     /*  685819 */     // GIR_Coverage, 10736,
     /*  685819 */     GIR_EraseRootFromParent_Done,
     /*  685820 */   // Label 10873: @685820
     /*  685820 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(685895), // Rule ID 10737 //
     /*  685825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685871 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  685874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685893 */     GIR_RootConstrainSelectedInstOperands,
     /*  685894 */     // GIR_Coverage, 10737,
     /*  685894 */     GIR_EraseRootFromParent_Done,
     /*  685895 */   // Label 10874: @685895
     /*  685895 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(685970), // Rule ID 10740 //
     /*  685900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  685920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  685939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  685949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685968 */     GIR_RootConstrainSelectedInstOperands,
     /*  685969 */     // GIR_Coverage, 10740,
     /*  685969 */     GIR_EraseRootFromParent_Done,
     /*  685970 */   // Label 10875: @685970
     /*  685970 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(686045), // Rule ID 10741 //
     /*  685975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  685983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  685995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686043 */     GIR_RootConstrainSelectedInstOperands,
     /*  686044 */     // GIR_Coverage, 10741,
     /*  686044 */     GIR_EraseRootFromParent_Done,
     /*  686045 */   // Label 10876: @686045
     /*  686045 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(686120), // Rule ID 10744 //
     /*  686050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686118 */     GIR_RootConstrainSelectedInstOperands,
     /*  686119 */     // GIR_Coverage, 10744,
     /*  686119 */     GIR_EraseRootFromParent_Done,
     /*  686120 */   // Label 10877: @686120
     /*  686120 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(686195), // Rule ID 10745 //
     /*  686125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  686136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  686139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  686142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686171 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686193 */     GIR_RootConstrainSelectedInstOperands,
     /*  686194 */     // GIR_Coverage, 10745,
     /*  686194 */     GIR_EraseRootFromParent_Done,
     /*  686195 */   // Label 10878: @686195
     /*  686195 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(686270), // Rule ID 10748 //
     /*  686200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686268 */     GIR_RootConstrainSelectedInstOperands,
     /*  686269 */     // GIR_Coverage, 10748,
     /*  686269 */     GIR_EraseRootFromParent_Done,
     /*  686270 */   // Label 10879: @686270
     /*  686270 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(686345), // Rule ID 10749 //
     /*  686275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  686286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  686289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  686292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686343 */     GIR_RootConstrainSelectedInstOperands,
     /*  686344 */     // GIR_Coverage, 10749,
     /*  686344 */     GIR_EraseRootFromParent_Done,
     /*  686345 */   // Label 10880: @686345
     /*  686345 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(686420), // Rule ID 10752 //
     /*  686350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686418 */     GIR_RootConstrainSelectedInstOperands,
     /*  686419 */     // GIR_Coverage, 10752,
     /*  686419 */     GIR_EraseRootFromParent_Done,
     /*  686420 */   // Label 10881: @686420
     /*  686420 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(686495), // Rule ID 10753 //
     /*  686425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  686436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  686439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  686442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686493 */     GIR_RootConstrainSelectedInstOperands,
     /*  686494 */     // GIR_Coverage, 10753,
     /*  686494 */     GIR_EraseRootFromParent_Done,
     /*  686495 */   // Label 10882: @686495
     /*  686495 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(686570), // Rule ID 10756 //
     /*  686500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686568 */     GIR_RootConstrainSelectedInstOperands,
     /*  686569 */     // GIR_Coverage, 10756,
     /*  686569 */     GIR_EraseRootFromParent_Done,
     /*  686570 */   // Label 10883: @686570
     /*  686570 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(686645), // Rule ID 10757 //
     /*  686575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686643 */     GIR_RootConstrainSelectedInstOperands,
     /*  686644 */     // GIR_Coverage, 10757,
     /*  686644 */     GIR_EraseRootFromParent_Done,
     /*  686645 */   // Label 10884: @686645
     /*  686645 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(686720), // Rule ID 10760 //
     /*  686650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686718 */     GIR_RootConstrainSelectedInstOperands,
     /*  686719 */     // GIR_Coverage, 10760,
     /*  686719 */     GIR_EraseRootFromParent_Done,
     /*  686720 */   // Label 10885: @686720
     /*  686720 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(686795), // Rule ID 10761 //
     /*  686725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  686774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686793 */     GIR_RootConstrainSelectedInstOperands,
     /*  686794 */     // GIR_Coverage, 10761,
     /*  686794 */     GIR_EraseRootFromParent_Done,
     /*  686795 */   // Label 10886: @686795
     /*  686795 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(686870), // Rule ID 10764 //
     /*  686800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686868 */     GIR_RootConstrainSelectedInstOperands,
     /*  686869 */     // GIR_Coverage, 10764,
     /*  686869 */     GIR_EraseRootFromParent_Done,
     /*  686870 */   // Label 10887: @686870
     /*  686870 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(686945), // Rule ID 10765 //
     /*  686875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  686924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686943 */     GIR_RootConstrainSelectedInstOperands,
     /*  686944 */     // GIR_Coverage, 10765,
     /*  686944 */     GIR_EraseRootFromParent_Done,
     /*  686945 */   // Label 10888: @686945
     /*  686945 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(687020), // Rule ID 10768 //
     /*  686950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  686958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  686999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687018 */     GIR_RootConstrainSelectedInstOperands,
     /*  687019 */     // GIR_Coverage, 10768,
     /*  687019 */     GIR_EraseRootFromParent_Done,
     /*  687020 */   // Label 10889: @687020
     /*  687020 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(687095), // Rule ID 10769 //
     /*  687025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  687036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  687039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  687042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  687074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687093 */     GIR_RootConstrainSelectedInstOperands,
     /*  687094 */     // GIR_Coverage, 10769,
     /*  687094 */     GIR_EraseRootFromParent_Done,
     /*  687095 */   // Label 10890: @687095
     /*  687095 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(687170), // Rule ID 10772 //
     /*  687100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  687149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687168 */     GIR_RootConstrainSelectedInstOperands,
     /*  687169 */     // GIR_Coverage, 10772,
     /*  687169 */     GIR_EraseRootFromParent_Done,
     /*  687170 */   // Label 10891: @687170
     /*  687170 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(687245), // Rule ID 10773 //
     /*  687175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  687183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  687186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  687189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  687192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  687210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  687224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687243 */     GIR_RootConstrainSelectedInstOperands,
     /*  687244 */     // GIR_Coverage, 10773,
     /*  687244 */     GIR_EraseRootFromParent_Done,
     /*  687245 */   // Label 10892: @687245
     /*  687245 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(687320), // Rule ID 10776 //
     /*  687250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  687270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  687299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687318 */     GIR_RootConstrainSelectedInstOperands,
     /*  687319 */     // GIR_Coverage, 10776,
     /*  687319 */     GIR_EraseRootFromParent_Done,
     /*  687320 */   // Label 10893: @687320
     /*  687320 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(687395), // Rule ID 10777 //
     /*  687325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  687336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  687339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  687342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  687345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  687374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687393 */     GIR_RootConstrainSelectedInstOperands,
     /*  687394 */     // GIR_Coverage, 10777,
     /*  687394 */     GIR_EraseRootFromParent_Done,
     /*  687395 */   // Label 10894: @687395
     /*  687395 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(687470), // Rule ID 10780 //
     /*  687400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  687420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687468 */     GIR_RootConstrainSelectedInstOperands,
     /*  687469 */     // GIR_Coverage, 10780,
     /*  687469 */     GIR_EraseRootFromParent_Done,
     /*  687470 */   // Label 10895: @687470
     /*  687470 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(687545), // Rule ID 10781 //
     /*  687475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  687486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  687489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  687492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  687495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687543 */     GIR_RootConstrainSelectedInstOperands,
     /*  687544 */     // GIR_Coverage, 10781,
     /*  687544 */     GIR_EraseRootFromParent_Done,
     /*  687545 */   // Label 10896: @687545
     /*  687545 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(687620), // Rule ID 10784 //
     /*  687550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  687570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687618 */     GIR_RootConstrainSelectedInstOperands,
     /*  687619 */     // GIR_Coverage, 10784,
     /*  687619 */     GIR_EraseRootFromParent_Done,
     /*  687620 */   // Label 10897: @687620
     /*  687620 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(687695), // Rule ID 10785 //
     /*  687625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  687645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687693 */     GIR_RootConstrainSelectedInstOperands,
     /*  687694 */     // GIR_Coverage, 10785,
     /*  687694 */     GIR_EraseRootFromParent_Done,
     /*  687695 */   // Label 10898: @687695
     /*  687695 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(687770), // Rule ID 10788 //
     /*  687700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  687720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687768 */     GIR_RootConstrainSelectedInstOperands,
     /*  687769 */     // GIR_Coverage, 10788,
     /*  687769 */     GIR_EraseRootFromParent_Done,
     /*  687770 */   // Label 10899: @687770
     /*  687770 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(687845), // Rule ID 10789 //
     /*  687775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  687795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  687824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687843 */     GIR_RootConstrainSelectedInstOperands,
     /*  687844 */     // GIR_Coverage, 10789,
     /*  687844 */     GIR_EraseRootFromParent_Done,
     /*  687845 */   // Label 10900: @687845
     /*  687845 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(687920), // Rule ID 10792 //
     /*  687850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  687870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687918 */     GIR_RootConstrainSelectedInstOperands,
     /*  687919 */     // GIR_Coverage, 10792,
     /*  687919 */     GIR_EraseRootFromParent_Done,
     /*  687920 */   // Label 10901: @687920
     /*  687920 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(687995), // Rule ID 10793 //
     /*  687925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  687945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  687974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687993 */     GIR_RootConstrainSelectedInstOperands,
     /*  687994 */     // GIR_Coverage, 10793,
     /*  687994 */     GIR_EraseRootFromParent_Done,
     /*  687995 */   // Label 10902: @687995
     /*  687995 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(688070), // Rule ID 10796 //
     /*  688000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  688020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  688049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688068 */     GIR_RootConstrainSelectedInstOperands,
     /*  688069 */     // GIR_Coverage, 10796,
     /*  688069 */     GIR_EraseRootFromParent_Done,
     /*  688070 */   // Label 10903: @688070
     /*  688070 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(688145), // Rule ID 10797 //
     /*  688075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  688086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  688089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  688092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  688095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  688124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688143 */     GIR_RootConstrainSelectedInstOperands,
     /*  688144 */     // GIR_Coverage, 10797,
     /*  688144 */     GIR_EraseRootFromParent_Done,
     /*  688145 */   // Label 10904: @688145
     /*  688145 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(688220), // Rule ID 10800 //
     /*  688150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  688170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688218 */     GIR_RootConstrainSelectedInstOperands,
     /*  688219 */     // GIR_Coverage, 10800,
     /*  688219 */     GIR_EraseRootFromParent_Done,
     /*  688220 */   // Label 10905: @688220
     /*  688220 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(688295), // Rule ID 10801 //
     /*  688225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  688236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  688239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  688242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  688245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688293 */     GIR_RootConstrainSelectedInstOperands,
     /*  688294 */     // GIR_Coverage, 10801,
     /*  688294 */     GIR_EraseRootFromParent_Done,
     /*  688295 */   // Label 10906: @688295
     /*  688295 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(688370), // Rule ID 10804 //
     /*  688300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  688320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688368 */     GIR_RootConstrainSelectedInstOperands,
     /*  688369 */     // GIR_Coverage, 10804,
     /*  688369 */     GIR_EraseRootFromParent_Done,
     /*  688370 */   // Label 10907: @688370
     /*  688370 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(688445), // Rule ID 10805 //
     /*  688375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  688386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  688389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  688392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  688395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688443 */     GIR_RootConstrainSelectedInstOperands,
     /*  688444 */     // GIR_Coverage, 10805,
     /*  688444 */     GIR_EraseRootFromParent_Done,
     /*  688445 */   // Label 10908: @688445
     /*  688445 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(688520), // Rule ID 10808 //
     /*  688450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  688470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688518 */     GIR_RootConstrainSelectedInstOperands,
     /*  688519 */     // GIR_Coverage, 10808,
     /*  688519 */     GIR_EraseRootFromParent_Done,
     /*  688520 */   // Label 10909: @688520
     /*  688520 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(688595), // Rule ID 10809 //
     /*  688525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  688536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  688539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  688542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  688545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688593 */     GIR_RootConstrainSelectedInstOperands,
     /*  688594 */     // GIR_Coverage, 10809,
     /*  688594 */     GIR_EraseRootFromParent_Done,
     /*  688595 */   // Label 10910: @688595
     /*  688595 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(688670), // Rule ID 10812 //
     /*  688600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  688620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688668 */     GIR_RootConstrainSelectedInstOperands,
     /*  688669 */     // GIR_Coverage, 10812,
     /*  688669 */     GIR_EraseRootFromParent_Done,
     /*  688670 */   // Label 10911: @688670
     /*  688670 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(688745), // Rule ID 10813 //
     /*  688675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  688695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  688724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688743 */     GIR_RootConstrainSelectedInstOperands,
     /*  688744 */     // GIR_Coverage, 10813,
     /*  688744 */     GIR_EraseRootFromParent_Done,
     /*  688745 */   // Label 10912: @688745
     /*  688745 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(688820), // Rule ID 10816 //
     /*  688750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  688770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  688799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688818 */     GIR_RootConstrainSelectedInstOperands,
     /*  688819 */     // GIR_Coverage, 10816,
     /*  688819 */     GIR_EraseRootFromParent_Done,
     /*  688820 */   // Label 10913: @688820
     /*  688820 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(688895), // Rule ID 10817 //
     /*  688825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  688845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  688874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688893 */     GIR_RootConstrainSelectedInstOperands,
     /*  688894 */     // GIR_Coverage, 10817,
     /*  688894 */     GIR_EraseRootFromParent_Done,
     /*  688895 */   // Label 10914: @688895
     /*  688895 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(688970), // Rule ID 10820 //
     /*  688900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  688920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  688949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688968 */     GIR_RootConstrainSelectedInstOperands,
     /*  688969 */     // GIR_Coverage, 10820,
     /*  688969 */     GIR_EraseRootFromParent_Done,
     /*  688970 */   // Label 10915: @688970
     /*  688970 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(689045), // Rule ID 10821 //
     /*  688975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  688995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689043 */     GIR_RootConstrainSelectedInstOperands,
     /*  689044 */     // GIR_Coverage, 10821,
     /*  689044 */     GIR_EraseRootFromParent_Done,
     /*  689045 */   // Label 10916: @689045
     /*  689045 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(689120), // Rule ID 10824 //
     /*  689050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  689070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689118 */     GIR_RootConstrainSelectedInstOperands,
     /*  689119 */     // GIR_Coverage, 10824,
     /*  689119 */     GIR_EraseRootFromParent_Done,
     /*  689120 */   // Label 10917: @689120
     /*  689120 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(689195), // Rule ID 10825 //
     /*  689125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  689136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  689139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  689142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  689145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689193 */     GIR_RootConstrainSelectedInstOperands,
     /*  689194 */     // GIR_Coverage, 10825,
     /*  689194 */     GIR_EraseRootFromParent_Done,
     /*  689195 */   // Label 10918: @689195
     /*  689195 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(689270), // Rule ID 10828 //
     /*  689200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  689220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689268 */     GIR_RootConstrainSelectedInstOperands,
     /*  689269 */     // GIR_Coverage, 10828,
     /*  689269 */     GIR_EraseRootFromParent_Done,
     /*  689270 */   // Label 10919: @689270
     /*  689270 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(689345), // Rule ID 10829 //
     /*  689275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  689286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  689289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  689292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  689295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689343 */     GIR_RootConstrainSelectedInstOperands,
     /*  689344 */     // GIR_Coverage, 10829,
     /*  689344 */     GIR_EraseRootFromParent_Done,
     /*  689345 */   // Label 10920: @689345
     /*  689345 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(689420), // Rule ID 10832 //
     /*  689350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  689370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689418 */     GIR_RootConstrainSelectedInstOperands,
     /*  689419 */     // GIR_Coverage, 10832,
     /*  689419 */     GIR_EraseRootFromParent_Done,
     /*  689420 */   // Label 10921: @689420
     /*  689420 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(689495), // Rule ID 10833 //
     /*  689425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  689436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  689439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  689442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  689445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689493 */     GIR_RootConstrainSelectedInstOperands,
     /*  689494 */     // GIR_Coverage, 10833,
     /*  689494 */     GIR_EraseRootFromParent_Done,
     /*  689495 */   // Label 10922: @689495
     /*  689495 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(689570), // Rule ID 10836 //
     /*  689500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  689520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689568 */     GIR_RootConstrainSelectedInstOperands,
     /*  689569 */     // GIR_Coverage, 10836,
     /*  689569 */     GIR_EraseRootFromParent_Done,
     /*  689570 */   // Label 10923: @689570
     /*  689570 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(689645), // Rule ID 10837 //
     /*  689575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  689595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689643 */     GIR_RootConstrainSelectedInstOperands,
     /*  689644 */     // GIR_Coverage, 10837,
     /*  689644 */     GIR_EraseRootFromParent_Done,
     /*  689645 */   // Label 10924: @689645
     /*  689645 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(689720), // Rule ID 10840 //
     /*  689650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  689670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689718 */     GIR_RootConstrainSelectedInstOperands,
     /*  689719 */     // GIR_Coverage, 10840,
     /*  689719 */     GIR_EraseRootFromParent_Done,
     /*  689720 */   // Label 10925: @689720
     /*  689720 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(689795), // Rule ID 10841 //
     /*  689725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  689745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  689774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689793 */     GIR_RootConstrainSelectedInstOperands,
     /*  689794 */     // GIR_Coverage, 10841,
     /*  689794 */     GIR_EraseRootFromParent_Done,
     /*  689795 */   // Label 10926: @689795
     /*  689795 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(689870), // Rule ID 10844 //
     /*  689800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  689820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689868 */     GIR_RootConstrainSelectedInstOperands,
     /*  689869 */     // GIR_Coverage, 10844,
     /*  689869 */     GIR_EraseRootFromParent_Done,
     /*  689870 */   // Label 10927: @689870
     /*  689870 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(689945), // Rule ID 10845 //
     /*  689875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  689895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  689924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689943 */     GIR_RootConstrainSelectedInstOperands,
     /*  689944 */     // GIR_Coverage, 10845,
     /*  689944 */     GIR_EraseRootFromParent_Done,
     /*  689945 */   // Label 10928: @689945
     /*  689945 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(690020), // Rule ID 10848 //
     /*  689950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  689970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  689999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690018 */     GIR_RootConstrainSelectedInstOperands,
     /*  690019 */     // GIR_Coverage, 10848,
     /*  690019 */     GIR_EraseRootFromParent_Done,
     /*  690020 */   // Label 10929: @690020
     /*  690020 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(690095), // Rule ID 10849 //
     /*  690025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  690036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  690039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  690042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  690045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690093 */     GIR_RootConstrainSelectedInstOperands,
     /*  690094 */     // GIR_Coverage, 10849,
     /*  690094 */     GIR_EraseRootFromParent_Done,
     /*  690095 */   // Label 10930: @690095
     /*  690095 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(690170), // Rule ID 10852 //
     /*  690100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  690120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  690149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690168 */     GIR_RootConstrainSelectedInstOperands,
     /*  690169 */     // GIR_Coverage, 10852,
     /*  690169 */     GIR_EraseRootFromParent_Done,
     /*  690170 */   // Label 10931: @690170
     /*  690170 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(690245), // Rule ID 10853 //
     /*  690175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  690186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  690189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  690192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  690195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  690214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  690224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690243 */     GIR_RootConstrainSelectedInstOperands,
     /*  690244 */     // GIR_Coverage, 10853,
     /*  690244 */     GIR_EraseRootFromParent_Done,
     /*  690245 */   // Label 10932: @690245
     /*  690245 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(690320), // Rule ID 10856 //
     /*  690250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  690270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  690299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690318 */     GIR_RootConstrainSelectedInstOperands,
     /*  690319 */     // GIR_Coverage, 10856,
     /*  690319 */     GIR_EraseRootFromParent_Done,
     /*  690320 */   // Label 10933: @690320
     /*  690320 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(690395), // Rule ID 10857 //
     /*  690325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  690336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  690339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  690342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  690345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  690364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  690374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690393 */     GIR_RootConstrainSelectedInstOperands,
     /*  690394 */     // GIR_Coverage, 10857,
     /*  690394 */     GIR_EraseRootFromParent_Done,
     /*  690395 */   // Label 10934: @690395
     /*  690395 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(690470), // Rule ID 10860 //
     /*  690400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  690420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690468 */     GIR_RootConstrainSelectedInstOperands,
     /*  690469 */     // GIR_Coverage, 10860,
     /*  690469 */     GIR_EraseRootFromParent_Done,
     /*  690470 */   // Label 10935: @690470
     /*  690470 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(690545), // Rule ID 10861 //
     /*  690475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  690486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  690489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  690492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  690495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  690514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  690524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690543 */     GIR_RootConstrainSelectedInstOperands,
     /*  690544 */     // GIR_Coverage, 10861,
     /*  690544 */     GIR_EraseRootFromParent_Done,
     /*  690545 */   // Label 10936: @690545
     /*  690545 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(690620), // Rule ID 10864 //
     /*  690550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  690599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690618 */     GIR_RootConstrainSelectedInstOperands,
     /*  690619 */     // GIR_Coverage, 10864,
     /*  690619 */     GIR_EraseRootFromParent_Done,
     /*  690620 */   // Label 10937: @690620
     /*  690620 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(690695), // Rule ID 10865 //
     /*  690625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  690674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690693 */     GIR_RootConstrainSelectedInstOperands,
     /*  690694 */     // GIR_Coverage, 10865,
     /*  690694 */     GIR_EraseRootFromParent_Done,
     /*  690695 */   // Label 10938: @690695
     /*  690695 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(690770), // Rule ID 10868 //
     /*  690700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  690749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690768 */     GIR_RootConstrainSelectedInstOperands,
     /*  690769 */     // GIR_Coverage, 10868,
     /*  690769 */     GIR_EraseRootFromParent_Done,
     /*  690770 */   // Label 10939: @690770
     /*  690770 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(690845), // Rule ID 10869 //
     /*  690775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  690824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690843 */     GIR_RootConstrainSelectedInstOperands,
     /*  690844 */     // GIR_Coverage, 10869,
     /*  690844 */     GIR_EraseRootFromParent_Done,
     /*  690845 */   // Label 10940: @690845
     /*  690845 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(690920), // Rule ID 10872 //
     /*  690850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  690870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  690899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690918 */     GIR_RootConstrainSelectedInstOperands,
     /*  690919 */     // GIR_Coverage, 10872,
     /*  690919 */     GIR_EraseRootFromParent_Done,
     /*  690920 */   // Label 10941: @690920
     /*  690920 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(690995), // Rule ID 10873 //
     /*  690925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  690933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  690945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  690964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  690974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690993 */     GIR_RootConstrainSelectedInstOperands,
     /*  690994 */     // GIR_Coverage, 10873,
     /*  690994 */     GIR_EraseRootFromParent_Done,
     /*  690995 */   // Label 10942: @690995
     /*  690995 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(691070), // Rule ID 10876 //
     /*  691000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  691049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691068 */     GIR_RootConstrainSelectedInstOperands,
     /*  691069 */     // GIR_Coverage, 10876,
     /*  691069 */     GIR_EraseRootFromParent_Done,
     /*  691070 */   // Label 10943: @691070
     /*  691070 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(691145), // Rule ID 10877 //
     /*  691075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  691086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  691089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  691092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  691124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691143 */     GIR_RootConstrainSelectedInstOperands,
     /*  691144 */     // GIR_Coverage, 10877,
     /*  691144 */     GIR_EraseRootFromParent_Done,
     /*  691145 */   // Label 10944: @691145
     /*  691145 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(691220), // Rule ID 10880 //
     /*  691150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691218 */     GIR_RootConstrainSelectedInstOperands,
     /*  691219 */     // GIR_Coverage, 10880,
     /*  691219 */     GIR_EraseRootFromParent_Done,
     /*  691220 */   // Label 10945: @691220
     /*  691220 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(691295), // Rule ID 10881 //
     /*  691225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  691236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  691239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  691242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691293 */     GIR_RootConstrainSelectedInstOperands,
     /*  691294 */     // GIR_Coverage, 10881,
     /*  691294 */     GIR_EraseRootFromParent_Done,
     /*  691295 */   // Label 10946: @691295
     /*  691295 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(691370), // Rule ID 10884 //
     /*  691300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691368 */     GIR_RootConstrainSelectedInstOperands,
     /*  691369 */     // GIR_Coverage, 10884,
     /*  691369 */     GIR_EraseRootFromParent_Done,
     /*  691370 */   // Label 10947: @691370
     /*  691370 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(691445), // Rule ID 10885 //
     /*  691375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  691386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  691389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  691392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  691424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691443 */     GIR_RootConstrainSelectedInstOperands,
     /*  691444 */     // GIR_Coverage, 10885,
     /*  691444 */     GIR_EraseRootFromParent_Done,
     /*  691445 */   // Label 10948: @691445
     /*  691445 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(691520), // Rule ID 10888 //
     /*  691450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691518 */     GIR_RootConstrainSelectedInstOperands,
     /*  691519 */     // GIR_Coverage, 10888,
     /*  691519 */     GIR_EraseRootFromParent_Done,
     /*  691520 */   // Label 10949: @691520
     /*  691520 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(691595), // Rule ID 10889 //
     /*  691525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  691536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  691539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  691542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11353:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691593 */     GIR_RootConstrainSelectedInstOperands,
     /*  691594 */     // GIR_Coverage, 10889,
     /*  691594 */     GIR_EraseRootFromParent_Done,
     /*  691595 */   // Label 10950: @691595
     /*  691595 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(691670), // Rule ID 10892 //
     /*  691600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691668 */     GIR_RootConstrainSelectedInstOperands,
     /*  691669 */     // GIR_Coverage, 10892,
     /*  691669 */     GIR_EraseRootFromParent_Done,
     /*  691670 */   // Label 10951: @691670
     /*  691670 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(691745), // Rule ID 10893 //
     /*  691675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691743 */     GIR_RootConstrainSelectedInstOperands,
     /*  691744 */     // GIR_Coverage, 10893,
     /*  691744 */     GIR_EraseRootFromParent_Done,
     /*  691745 */   // Label 10952: @691745
     /*  691745 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(691820), // Rule ID 10896 //
     /*  691750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691818 */     GIR_RootConstrainSelectedInstOperands,
     /*  691819 */     // GIR_Coverage, 10896,
     /*  691819 */     GIR_EraseRootFromParent_Done,
     /*  691820 */   // Label 10953: @691820
     /*  691820 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(691895), // Rule ID 10897 //
     /*  691825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691893 */     GIR_RootConstrainSelectedInstOperands,
     /*  691894 */     // GIR_Coverage, 10897,
     /*  691894 */     GIR_EraseRootFromParent_Done,
     /*  691895 */   // Label 10954: @691895
     /*  691895 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(691970), // Rule ID 10900 //
     /*  691900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  691920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  691939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  691949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691968 */     GIR_RootConstrainSelectedInstOperands,
     /*  691969 */     // GIR_Coverage, 10900,
     /*  691969 */     GIR_EraseRootFromParent_Done,
     /*  691970 */   // Label 10955: @691970
     /*  691970 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(692045), // Rule ID 10901 //
     /*  691975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  691983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  691995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  692024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692043 */     GIR_RootConstrainSelectedInstOperands,
     /*  692044 */     // GIR_Coverage, 10901,
     /*  692044 */     GIR_EraseRootFromParent_Done,
     /*  692045 */   // Label 10956: @692045
     /*  692045 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(692120), // Rule ID 10904 //
     /*  692050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692118 */     GIR_RootConstrainSelectedInstOperands,
     /*  692119 */     // GIR_Coverage, 10904,
     /*  692119 */     GIR_EraseRootFromParent_Done,
     /*  692120 */   // Label 10957: @692120
     /*  692120 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(692195), // Rule ID 10905 //
     /*  692125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  692136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  692139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  692142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692193 */     GIR_RootConstrainSelectedInstOperands,
     /*  692194 */     // GIR_Coverage, 10905,
     /*  692194 */     GIR_EraseRootFromParent_Done,
     /*  692195 */   // Label 10958: @692195
     /*  692195 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(692270), // Rule ID 10908 //
     /*  692200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692268 */     GIR_RootConstrainSelectedInstOperands,
     /*  692269 */     // GIR_Coverage, 10908,
     /*  692269 */     GIR_EraseRootFromParent_Done,
     /*  692270 */   // Label 10959: @692270
     /*  692270 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(692345), // Rule ID 10909 //
     /*  692275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  692286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  692289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  692292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692343 */     GIR_RootConstrainSelectedInstOperands,
     /*  692344 */     // GIR_Coverage, 10909,
     /*  692344 */     GIR_EraseRootFromParent_Done,
     /*  692345 */   // Label 10960: @692345
     /*  692345 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(692420), // Rule ID 10912 //
     /*  692350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692418 */     GIR_RootConstrainSelectedInstOperands,
     /*  692419 */     // GIR_Coverage, 10912,
     /*  692419 */     GIR_EraseRootFromParent_Done,
     /*  692420 */   // Label 10961: @692420
     /*  692420 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(692495), // Rule ID 10913 //
     /*  692425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  692436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  692439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  692442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692493 */     GIR_RootConstrainSelectedInstOperands,
     /*  692494 */     // GIR_Coverage, 10913,
     /*  692494 */     GIR_EraseRootFromParent_Done,
     /*  692495 */   // Label 10962: @692495
     /*  692495 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(692570), // Rule ID 10916 //
     /*  692500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692568 */     GIR_RootConstrainSelectedInstOperands,
     /*  692569 */     // GIR_Coverage, 10916,
     /*  692569 */     GIR_EraseRootFromParent_Done,
     /*  692570 */   // Label 10963: @692570
     /*  692570 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(692645), // Rule ID 10917 //
     /*  692575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692643 */     GIR_RootConstrainSelectedInstOperands,
     /*  692644 */     // GIR_Coverage, 10917,
     /*  692644 */     GIR_EraseRootFromParent_Done,
     /*  692645 */   // Label 10964: @692645
     /*  692645 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(692720), // Rule ID 10920 //
     /*  692650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692718 */     GIR_RootConstrainSelectedInstOperands,
     /*  692719 */     // GIR_Coverage, 10920,
     /*  692719 */     GIR_EraseRootFromParent_Done,
     /*  692720 */   // Label 10965: @692720
     /*  692720 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(692795), // Rule ID 10921 //
     /*  692725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  692774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692793 */     GIR_RootConstrainSelectedInstOperands,
     /*  692794 */     // GIR_Coverage, 10921,
     /*  692794 */     GIR_EraseRootFromParent_Done,
     /*  692795 */   // Label 10966: @692795
     /*  692795 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(692870), // Rule ID 10924 //
     /*  692800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692868 */     GIR_RootConstrainSelectedInstOperands,
     /*  692869 */     // GIR_Coverage, 10924,
     /*  692869 */     GIR_EraseRootFromParent_Done,
     /*  692870 */   // Label 10967: @692870
     /*  692870 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(692945), // Rule ID 10925 //
     /*  692875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  692924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692943 */     GIR_RootConstrainSelectedInstOperands,
     /*  692944 */     // GIR_Coverage, 10925,
     /*  692944 */     GIR_EraseRootFromParent_Done,
     /*  692945 */   // Label 10968: @692945
     /*  692945 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(693020), // Rule ID 10928 //
     /*  692950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  692958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  692999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693018 */     GIR_RootConstrainSelectedInstOperands,
     /*  693019 */     // GIR_Coverage, 10928,
     /*  693019 */     GIR_EraseRootFromParent_Done,
     /*  693020 */   // Label 10969: @693020
     /*  693020 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(693095), // Rule ID 10929 //
     /*  693025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  693036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  693039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  693042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693093 */     GIR_RootConstrainSelectedInstOperands,
     /*  693094 */     // GIR_Coverage, 10929,
     /*  693094 */     GIR_EraseRootFromParent_Done,
     /*  693095 */   // Label 10970: @693095
     /*  693095 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(693170), // Rule ID 10932 //
     /*  693100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693168 */     GIR_RootConstrainSelectedInstOperands,
     /*  693169 */     // GIR_Coverage, 10932,
     /*  693169 */     GIR_EraseRootFromParent_Done,
     /*  693170 */   // Label 10971: @693170
     /*  693170 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(693245), // Rule ID 10933 //
     /*  693175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  693186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  693189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  693192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693243 */     GIR_RootConstrainSelectedInstOperands,
     /*  693244 */     // GIR_Coverage, 10933,
     /*  693244 */     GIR_EraseRootFromParent_Done,
     /*  693245 */   // Label 10972: @693245
     /*  693245 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(693320), // Rule ID 10936 //
     /*  693250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693318 */     GIR_RootConstrainSelectedInstOperands,
     /*  693319 */     // GIR_Coverage, 10936,
     /*  693319 */     GIR_EraseRootFromParent_Done,
     /*  693320 */   // Label 10973: @693320
     /*  693320 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(693395), // Rule ID 10937 //
     /*  693325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  693336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  693339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  693342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693393 */     GIR_RootConstrainSelectedInstOperands,
     /*  693394 */     // GIR_Coverage, 10937,
     /*  693394 */     GIR_EraseRootFromParent_Done,
     /*  693395 */   // Label 10974: @693395
     /*  693395 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(693470), // Rule ID 10940 //
     /*  693400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693468 */     GIR_RootConstrainSelectedInstOperands,
     /*  693469 */     // GIR_Coverage, 10940,
     /*  693469 */     GIR_EraseRootFromParent_Done,
     /*  693470 */   // Label 10975: @693470
     /*  693470 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(693545), // Rule ID 10941 //
     /*  693475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  693486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  693489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  693492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  693510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  693524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693543 */     GIR_RootConstrainSelectedInstOperands,
     /*  693544 */     // GIR_Coverage, 10941,
     /*  693544 */     GIR_EraseRootFromParent_Done,
     /*  693545 */   // Label 10976: @693545
     /*  693545 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(693620), // Rule ID 10944 //
     /*  693550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693618 */     GIR_RootConstrainSelectedInstOperands,
     /*  693619 */     // GIR_Coverage, 10944,
     /*  693619 */     GIR_EraseRootFromParent_Done,
     /*  693620 */   // Label 10977: @693620
     /*  693620 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(693695), // Rule ID 10945 //
     /*  693625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  693674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693693 */     GIR_RootConstrainSelectedInstOperands,
     /*  693694 */     // GIR_Coverage, 10945,
     /*  693694 */     GIR_EraseRootFromParent_Done,
     /*  693695 */   // Label 10978: @693695
     /*  693695 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(693770), // Rule ID 10948 //
     /*  693700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693768 */     GIR_RootConstrainSelectedInstOperands,
     /*  693769 */     // GIR_Coverage, 10948,
     /*  693769 */     GIR_EraseRootFromParent_Done,
     /*  693770 */   // Label 10979: @693770
     /*  693770 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(693845), // Rule ID 10949 //
     /*  693775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  693783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  693824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693843 */     GIR_RootConstrainSelectedInstOperands,
     /*  693844 */     // GIR_Coverage, 10949,
     /*  693844 */     GIR_EraseRootFromParent_Done,
     /*  693845 */   // Label 10980: @693845
     /*  693845 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(693920), // Rule ID 10952 //
     /*  693850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  693870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  693899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693918 */     GIR_RootConstrainSelectedInstOperands,
     /*  693919 */     // GIR_Coverage, 10952,
     /*  693919 */     GIR_EraseRootFromParent_Done,
     /*  693920 */   // Label 10981: @693920
     /*  693920 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(693995), // Rule ID 10953 //
     /*  693925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  693945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  693974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693993 */     GIR_RootConstrainSelectedInstOperands,
     /*  693994 */     // GIR_Coverage, 10953,
     /*  693994 */     GIR_EraseRootFromParent_Done,
     /*  693995 */   // Label 10982: @693995
     /*  693995 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(694070), // Rule ID 10956 //
     /*  694000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  694020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694068 */     GIR_RootConstrainSelectedInstOperands,
     /*  694069 */     // GIR_Coverage, 10956,
     /*  694069 */     GIR_EraseRootFromParent_Done,
     /*  694070 */   // Label 10983: @694070
     /*  694070 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(694145), // Rule ID 10957 //
     /*  694075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  694086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  694089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  694092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  694095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694143 */     GIR_RootConstrainSelectedInstOperands,
     /*  694144 */     // GIR_Coverage, 10957,
     /*  694144 */     GIR_EraseRootFromParent_Done,
     /*  694145 */   // Label 10984: @694145
     /*  694145 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(694220), // Rule ID 10960 //
     /*  694150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  694170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694218 */     GIR_RootConstrainSelectedInstOperands,
     /*  694219 */     // GIR_Coverage, 10960,
     /*  694219 */     GIR_EraseRootFromParent_Done,
     /*  694220 */   // Label 10985: @694220
     /*  694220 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(694295), // Rule ID 10961 //
     /*  694225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  694236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  694239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  694242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  694245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694293 */     GIR_RootConstrainSelectedInstOperands,
     /*  694294 */     // GIR_Coverage, 10961,
     /*  694294 */     GIR_EraseRootFromParent_Done,
     /*  694295 */   // Label 10986: @694295
     /*  694295 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(694370), // Rule ID 10964 //
     /*  694300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  694320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694368 */     GIR_RootConstrainSelectedInstOperands,
     /*  694369 */     // GIR_Coverage, 10964,
     /*  694369 */     GIR_EraseRootFromParent_Done,
     /*  694370 */   // Label 10987: @694370
     /*  694370 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(694445), // Rule ID 10965 //
     /*  694375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  694386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  694389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  694392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  694395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  694424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694443 */     GIR_RootConstrainSelectedInstOperands,
     /*  694444 */     // GIR_Coverage, 10965,
     /*  694444 */     GIR_EraseRootFromParent_Done,
     /*  694445 */   // Label 10988: @694445
     /*  694445 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(694520), // Rule ID 10968 //
     /*  694450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694518 */     GIR_RootConstrainSelectedInstOperands,
     /*  694519 */     // GIR_Coverage, 10968,
     /*  694519 */     GIR_EraseRootFromParent_Done,
     /*  694520 */   // Label 10989: @694520
     /*  694520 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(694595), // Rule ID 10969 //
     /*  694525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  694536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  694539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  694542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  694545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694593 */     GIR_RootConstrainSelectedInstOperands,
     /*  694594 */     // GIR_Coverage, 10969,
     /*  694594 */     GIR_EraseRootFromParent_Done,
     /*  694595 */   // Label 10990: @694595
     /*  694595 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(694670), // Rule ID 10972 //
     /*  694600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694668 */     GIR_RootConstrainSelectedInstOperands,
     /*  694669 */     // GIR_Coverage, 10972,
     /*  694669 */     GIR_EraseRootFromParent_Done,
     /*  694670 */   // Label 10991: @694670
     /*  694670 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(694745), // Rule ID 10973 //
     /*  694675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  694695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  694724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694743 */     GIR_RootConstrainSelectedInstOperands,
     /*  694744 */     // GIR_Coverage, 10973,
     /*  694744 */     GIR_EraseRootFromParent_Done,
     /*  694745 */   // Label 10992: @694745
     /*  694745 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(694820), // Rule ID 10976 //
     /*  694750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  694770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694818 */     GIR_RootConstrainSelectedInstOperands,
     /*  694819 */     // GIR_Coverage, 10976,
     /*  694819 */     GIR_EraseRootFromParent_Done,
     /*  694820 */   // Label 10993: @694820
     /*  694820 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(694895), // Rule ID 10977 //
     /*  694825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  694845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694893 */     GIR_RootConstrainSelectedInstOperands,
     /*  694894 */     // GIR_Coverage, 10977,
     /*  694894 */     GIR_EraseRootFromParent_Done,
     /*  694895 */   // Label 10994: @694895
     /*  694895 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(694970), // Rule ID 10980 //
     /*  694900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  694949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694968 */     GIR_RootConstrainSelectedInstOperands,
     /*  694969 */     // GIR_Coverage, 10980,
     /*  694969 */     GIR_EraseRootFromParent_Done,
     /*  694970 */   // Label 10995: @694970
     /*  694970 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(695045), // Rule ID 10981 //
     /*  694975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  694995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695043 */     GIR_RootConstrainSelectedInstOperands,
     /*  695044 */     // GIR_Coverage, 10981,
     /*  695044 */     GIR_EraseRootFromParent_Done,
     /*  695045 */   // Label 10996: @695045
     /*  695045 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(695120), // Rule ID 10984 //
     /*  695050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  695070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695118 */     GIR_RootConstrainSelectedInstOperands,
     /*  695119 */     // GIR_Coverage, 10984,
     /*  695119 */     GIR_EraseRootFromParent_Done,
     /*  695120 */   // Label 10997: @695120
     /*  695120 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(695195), // Rule ID 10985 //
     /*  695125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  695136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  695139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  695142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  695145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695193 */     GIR_RootConstrainSelectedInstOperands,
     /*  695194 */     // GIR_Coverage, 10985,
     /*  695194 */     GIR_EraseRootFromParent_Done,
     /*  695195 */   // Label 10998: @695195
     /*  695195 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(695270), // Rule ID 10988 //
     /*  695200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  695220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695268 */     GIR_RootConstrainSelectedInstOperands,
     /*  695269 */     // GIR_Coverage, 10988,
     /*  695269 */     GIR_EraseRootFromParent_Done,
     /*  695270 */   // Label 10999: @695270
     /*  695270 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(695345), // Rule ID 10989 //
     /*  695275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  695286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  695289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  695292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  695295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  695314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  695324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695343 */     GIR_RootConstrainSelectedInstOperands,
     /*  695344 */     // GIR_Coverage, 10989,
     /*  695344 */     GIR_EraseRootFromParent_Done,
     /*  695345 */   // Label 11000: @695345
     /*  695345 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(695420), // Rule ID 10992 //
     /*  695350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  695370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695418 */     GIR_RootConstrainSelectedInstOperands,
     /*  695419 */     // GIR_Coverage, 10992,
     /*  695419 */     GIR_EraseRootFromParent_Done,
     /*  695420 */   // Label 11001: @695420
     /*  695420 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(695495), // Rule ID 10993 //
     /*  695425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  695436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  695439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  695442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  695445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695493 */     GIR_RootConstrainSelectedInstOperands,
     /*  695494 */     // GIR_Coverage, 10993,
     /*  695494 */     GIR_EraseRootFromParent_Done,
     /*  695495 */   // Label 11002: @695495
     /*  695495 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(695570), // Rule ID 10996 //
     /*  695500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  695520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695568 */     GIR_RootConstrainSelectedInstOperands,
     /*  695569 */     // GIR_Coverage, 10996,
     /*  695569 */     GIR_EraseRootFromParent_Done,
     /*  695570 */   // Label 11003: @695570
     /*  695570 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(695645), // Rule ID 10997 //
     /*  695575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  695595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695643 */     GIR_RootConstrainSelectedInstOperands,
     /*  695644 */     // GIR_Coverage, 10997,
     /*  695644 */     GIR_EraseRootFromParent_Done,
     /*  695645 */   // Label 11004: @695645
     /*  695645 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(695720), // Rule ID 11000 //
     /*  695650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  695670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  695699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695718 */     GIR_RootConstrainSelectedInstOperands,
     /*  695719 */     // GIR_Coverage, 11000,
     /*  695719 */     GIR_EraseRootFromParent_Done,
     /*  695720 */   // Label 11005: @695720
     /*  695720 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(695795), // Rule ID 11001 //
     /*  695725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  695745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  695774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695793 */     GIR_RootConstrainSelectedInstOperands,
     /*  695794 */     // GIR_Coverage, 11001,
     /*  695794 */     GIR_EraseRootFromParent_Done,
     /*  695795 */   // Label 11006: @695795
     /*  695795 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(695870), // Rule ID 11004 //
     /*  695800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  695820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695868 */     GIR_RootConstrainSelectedInstOperands,
     /*  695869 */     // GIR_Coverage, 11004,
     /*  695869 */     GIR_EraseRootFromParent_Done,
     /*  695870 */   // Label 11007: @695870
     /*  695870 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(695945), // Rule ID 11005 //
     /*  695875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  695895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  695924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695943 */     GIR_RootConstrainSelectedInstOperands,
     /*  695944 */     // GIR_Coverage, 11005,
     /*  695944 */     GIR_EraseRootFromParent_Done,
     /*  695945 */   // Label 11008: @695945
     /*  695945 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(696020), // Rule ID 11008 //
     /*  695950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  695970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  695999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696018 */     GIR_RootConstrainSelectedInstOperands,
     /*  696019 */     // GIR_Coverage, 11008,
     /*  696019 */     GIR_EraseRootFromParent_Done,
     /*  696020 */   // Label 11009: @696020
     /*  696020 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(696095), // Rule ID 11009 //
     /*  696025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  696036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  696039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  696042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  696045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696093 */     GIR_RootConstrainSelectedInstOperands,
     /*  696094 */     // GIR_Coverage, 11009,
     /*  696094 */     GIR_EraseRootFromParent_Done,
     /*  696095 */   // Label 11010: @696095
     /*  696095 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(696170), // Rule ID 11012 //
     /*  696100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  696120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696168 */     GIR_RootConstrainSelectedInstOperands,
     /*  696169 */     // GIR_Coverage, 11012,
     /*  696169 */     GIR_EraseRootFromParent_Done,
     /*  696170 */   // Label 11011: @696170
     /*  696170 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(696245), // Rule ID 11013 //
     /*  696175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  696186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  696189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  696192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  696195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696243 */     GIR_RootConstrainSelectedInstOperands,
     /*  696244 */     // GIR_Coverage, 11013,
     /*  696244 */     GIR_EraseRootFromParent_Done,
     /*  696245 */   // Label 11012: @696245
     /*  696245 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(696320), // Rule ID 11016 //
     /*  696250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  696270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696318 */     GIR_RootConstrainSelectedInstOperands,
     /*  696319 */     // GIR_Coverage, 11016,
     /*  696319 */     GIR_EraseRootFromParent_Done,
     /*  696320 */   // Label 11013: @696320
     /*  696320 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(696395), // Rule ID 11017 //
     /*  696325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  696336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  696339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  696342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  696345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696393 */     GIR_RootConstrainSelectedInstOperands,
     /*  696394 */     // GIR_Coverage, 11017,
     /*  696394 */     GIR_EraseRootFromParent_Done,
     /*  696395 */   // Label 11014: @696395
     /*  696395 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(696470), // Rule ID 11020 //
     /*  696400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  696420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696468 */     GIR_RootConstrainSelectedInstOperands,
     /*  696469 */     // GIR_Coverage, 11020,
     /*  696469 */     GIR_EraseRootFromParent_Done,
     /*  696470 */   // Label 11015: @696470
     /*  696470 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(696545), // Rule ID 11021 //
     /*  696475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  696486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  696489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  696492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  696495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696543 */     GIR_RootConstrainSelectedInstOperands,
     /*  696544 */     // GIR_Coverage, 11021,
     /*  696544 */     GIR_EraseRootFromParent_Done,
     /*  696545 */   // Label 11016: @696545
     /*  696545 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(696620), // Rule ID 11024 //
     /*  696550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  696570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696618 */     GIR_RootConstrainSelectedInstOperands,
     /*  696619 */     // GIR_Coverage, 11024,
     /*  696619 */     GIR_EraseRootFromParent_Done,
     /*  696620 */   // Label 11017: @696620
     /*  696620 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(696695), // Rule ID 11025 //
     /*  696625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  696645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  696674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696693 */     GIR_RootConstrainSelectedInstOperands,
     /*  696694 */     // GIR_Coverage, 11025,
     /*  696694 */     GIR_EraseRootFromParent_Done,
     /*  696695 */   // Label 11018: @696695
     /*  696695 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(696770), // Rule ID 11028 //
     /*  696700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  696720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696768 */     GIR_RootConstrainSelectedInstOperands,
     /*  696769 */     // GIR_Coverage, 11028,
     /*  696769 */     GIR_EraseRootFromParent_Done,
     /*  696770 */   // Label 11019: @696770
     /*  696770 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(696845), // Rule ID 11029 //
     /*  696775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  696795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  696824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696843 */     GIR_RootConstrainSelectedInstOperands,
     /*  696844 */     // GIR_Coverage, 11029,
     /*  696844 */     GIR_EraseRootFromParent_Done,
     /*  696845 */   // Label 11020: @696845
     /*  696845 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(696920), // Rule ID 11032 //
     /*  696850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  696870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696918 */     GIR_RootConstrainSelectedInstOperands,
     /*  696919 */     // GIR_Coverage, 11032,
     /*  696919 */     GIR_EraseRootFromParent_Done,
     /*  696920 */   // Label 11021: @696920
     /*  696920 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(696995), // Rule ID 11033 //
     /*  696925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  696945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  696974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696993 */     GIR_RootConstrainSelectedInstOperands,
     /*  696994 */     // GIR_Coverage, 11033,
     /*  696994 */     GIR_EraseRootFromParent_Done,
     /*  696995 */   // Label 11022: @696995
     /*  696995 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(697070), // Rule ID 11036 //
     /*  697000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  697003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  697020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  697046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  697049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697068 */     GIR_RootConstrainSelectedInstOperands,
     /*  697069 */     // GIR_Coverage, 11036,
     /*  697069 */     GIR_EraseRootFromParent_Done,
     /*  697070 */   // Label 11023: @697070
     /*  697070 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(697145), // Rule ID 11037 //
     /*  697075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  697078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  697086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  697089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  697092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  697095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  697121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  697124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  697140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697143 */     GIR_RootConstrainSelectedInstOperands,
     /*  697144 */     // GIR_Coverage, 11037,
     /*  697144 */     GIR_EraseRootFromParent_Done,
     /*  697145 */   // Label 11024: @697145
     /*  697145 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(697220), // Rule ID 11040 //
     /*  697150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  697199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697218 */     GIR_RootConstrainSelectedInstOperands,
     /*  697219 */     // GIR_Coverage, 11040,
     /*  697219 */     GIR_EraseRootFromParent_Done,
     /*  697220 */   // Label 11025: @697220
     /*  697220 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(697295), // Rule ID 11041 //
     /*  697225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  697236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  697239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  697242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  697274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697293 */     GIR_RootConstrainSelectedInstOperands,
     /*  697294 */     // GIR_Coverage, 11041,
     /*  697294 */     GIR_EraseRootFromParent_Done,
     /*  697295 */   // Label 11026: @697295
     /*  697295 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(697370), // Rule ID 11044 //
     /*  697300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697368 */     GIR_RootConstrainSelectedInstOperands,
     /*  697369 */     // GIR_Coverage, 11044,
     /*  697369 */     GIR_EraseRootFromParent_Done,
     /*  697370 */   // Label 11027: @697370
     /*  697370 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(697445), // Rule ID 11045 //
     /*  697375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  697386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  697389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  697392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697443 */     GIR_RootConstrainSelectedInstOperands,
     /*  697444 */     // GIR_Coverage, 11045,
     /*  697444 */     GIR_EraseRootFromParent_Done,
     /*  697445 */   // Label 11028: @697445
     /*  697445 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(697520), // Rule ID 11048 //
     /*  697450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697518 */     GIR_RootConstrainSelectedInstOperands,
     /*  697519 */     // GIR_Coverage, 11048,
     /*  697519 */     GIR_EraseRootFromParent_Done,
     /*  697520 */   // Label 11029: @697520
     /*  697520 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(697595), // Rule ID 11049 //
     /*  697525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  697536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  697539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  697542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697593 */     GIR_RootConstrainSelectedInstOperands,
     /*  697594 */     // GIR_Coverage, 11049,
     /*  697594 */     GIR_EraseRootFromParent_Done,
     /*  697595 */   // Label 11030: @697595
     /*  697595 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(697670), // Rule ID 11052 //
     /*  697600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697668 */     GIR_RootConstrainSelectedInstOperands,
     /*  697669 */     // GIR_Coverage, 11052,
     /*  697669 */     GIR_EraseRootFromParent_Done,
     /*  697670 */   // Label 11031: @697670
     /*  697670 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(697745), // Rule ID 11053 //
     /*  697675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  697724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697743 */     GIR_RootConstrainSelectedInstOperands,
     /*  697744 */     // GIR_Coverage, 11053,
     /*  697744 */     GIR_EraseRootFromParent_Done,
     /*  697745 */   // Label 11032: @697745
     /*  697745 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(697820), // Rule ID 11056 //
     /*  697750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697818 */     GIR_RootConstrainSelectedInstOperands,
     /*  697819 */     // GIR_Coverage, 11056,
     /*  697819 */     GIR_EraseRootFromParent_Done,
     /*  697820 */   // Label 11033: @697820
     /*  697820 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(697895), // Rule ID 11057 //
     /*  697825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697893 */     GIR_RootConstrainSelectedInstOperands,
     /*  697894 */     // GIR_Coverage, 11057,
     /*  697894 */     GIR_EraseRootFromParent_Done,
     /*  697895 */   // Label 11034: @697895
     /*  697895 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(697970), // Rule ID 11060 //
     /*  697900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  697920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  697939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  697949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697968 */     GIR_RootConstrainSelectedInstOperands,
     /*  697969 */     // GIR_Coverage, 11060,
     /*  697969 */     GIR_EraseRootFromParent_Done,
     /*  697970 */   // Label 11035: @697970
     /*  697970 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(698045), // Rule ID 11061 //
     /*  697975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  697983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  697995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  698024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698043 */     GIR_RootConstrainSelectedInstOperands,
     /*  698044 */     // GIR_Coverage, 11061,
     /*  698044 */     GIR_EraseRootFromParent_Done,
     /*  698045 */   // Label 11036: @698045
     /*  698045 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(698120), // Rule ID 11064 //
     /*  698050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698118 */     GIR_RootConstrainSelectedInstOperands,
     /*  698119 */     // GIR_Coverage, 11064,
     /*  698119 */     GIR_EraseRootFromParent_Done,
     /*  698120 */   // Label 11037: @698120
     /*  698120 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(698195), // Rule ID 11065 //
     /*  698125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  698136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  698139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  698142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698193 */     GIR_RootConstrainSelectedInstOperands,
     /*  698194 */     // GIR_Coverage, 11065,
     /*  698194 */     GIR_EraseRootFromParent_Done,
     /*  698195 */   // Label 11038: @698195
     /*  698195 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(698270), // Rule ID 11068 //
     /*  698200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698268 */     GIR_RootConstrainSelectedInstOperands,
     /*  698269 */     // GIR_Coverage, 11068,
     /*  698269 */     GIR_EraseRootFromParent_Done,
     /*  698270 */   // Label 11039: @698270
     /*  698270 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(698345), // Rule ID 11069 //
     /*  698275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  698286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  698289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  698292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698343 */     GIR_RootConstrainSelectedInstOperands,
     /*  698344 */     // GIR_Coverage, 11069,
     /*  698344 */     GIR_EraseRootFromParent_Done,
     /*  698345 */   // Label 11040: @698345
     /*  698345 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(698420), // Rule ID 11072 //
     /*  698350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698418 */     GIR_RootConstrainSelectedInstOperands,
     /*  698419 */     // GIR_Coverage, 11072,
     /*  698419 */     GIR_EraseRootFromParent_Done,
     /*  698420 */   // Label 11041: @698420
     /*  698420 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(698495), // Rule ID 11073 //
     /*  698425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  698436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  698439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  698442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698493 */     GIR_RootConstrainSelectedInstOperands,
     /*  698494 */     // GIR_Coverage, 11073,
     /*  698494 */     GIR_EraseRootFromParent_Done,
     /*  698495 */   // Label 11042: @698495
     /*  698495 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(698570), // Rule ID 11076 //
     /*  698500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  698503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  698511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  698514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  698517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  698546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698568 */     GIR_RootConstrainSelectedInstOperands,
     /*  698569 */     // GIR_Coverage, 11076,
     /*  698569 */     GIR_EraseRootFromParent_Done,
     /*  698570 */   // Label 11043: @698570
     /*  698570 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(698645), // Rule ID 11077 //
     /*  698575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  698578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  698586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  698589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  698592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  698621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  698624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  698640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698643 */     GIR_RootConstrainSelectedInstOperands,
     /*  698644 */     // GIR_Coverage, 11077,
     /*  698644 */     GIR_EraseRootFromParent_Done,
     /*  698645 */   // Label 11044: @698645
     /*  698645 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(698720), // Rule ID 11080 //
     /*  698650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  698699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698718 */     GIR_RootConstrainSelectedInstOperands,
     /*  698719 */     // GIR_Coverage, 11080,
     /*  698719 */     GIR_EraseRootFromParent_Done,
     /*  698720 */   // Label 11045: @698720
     /*  698720 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(698795), // Rule ID 11081 //
     /*  698725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  698774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698793 */     GIR_RootConstrainSelectedInstOperands,
     /*  698794 */     // GIR_Coverage, 11081,
     /*  698794 */     GIR_EraseRootFromParent_Done,
     /*  698795 */   // Label 11046: @698795
     /*  698795 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(698870), // Rule ID 11084 //
     /*  698800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  698849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698868 */     GIR_RootConstrainSelectedInstOperands,
     /*  698869 */     // GIR_Coverage, 11084,
     /*  698869 */     GIR_EraseRootFromParent_Done,
     /*  698870 */   // Label 11047: @698870
     /*  698870 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(698945), // Rule ID 11085 //
     /*  698875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  698924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698943 */     GIR_RootConstrainSelectedInstOperands,
     /*  698944 */     // GIR_Coverage, 11085,
     /*  698944 */     GIR_EraseRootFromParent_Done,
     /*  698945 */   // Label 11048: @698945
     /*  698945 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(699020), // Rule ID 11088 //
     /*  698950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  698958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  698999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699018 */     GIR_RootConstrainSelectedInstOperands,
     /*  699019 */     // GIR_Coverage, 11088,
     /*  699019 */     GIR_EraseRootFromParent_Done,
     /*  699020 */   // Label 11049: @699020
     /*  699020 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(699095), // Rule ID 11089 //
     /*  699025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  699036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  699039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  699042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699093 */     GIR_RootConstrainSelectedInstOperands,
     /*  699094 */     // GIR_Coverage, 11089,
     /*  699094 */     GIR_EraseRootFromParent_Done,
     /*  699095 */   // Label 11050: @699095
     /*  699095 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(699170), // Rule ID 11092 //
     /*  699100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699168 */     GIR_RootConstrainSelectedInstOperands,
     /*  699169 */     // GIR_Coverage, 11092,
     /*  699169 */     GIR_EraseRootFromParent_Done,
     /*  699170 */   // Label 11051: @699170
     /*  699170 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(699245), // Rule ID 11093 //
     /*  699175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  699186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  699189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  699192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699243 */     GIR_RootConstrainSelectedInstOperands,
     /*  699244 */     // GIR_Coverage, 11093,
     /*  699244 */     GIR_EraseRootFromParent_Done,
     /*  699245 */   // Label 11052: @699245
     /*  699245 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(699320), // Rule ID 11096 //
     /*  699250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699318 */     GIR_RootConstrainSelectedInstOperands,
     /*  699319 */     // GIR_Coverage, 11096,
     /*  699319 */     GIR_EraseRootFromParent_Done,
     /*  699320 */   // Label 11053: @699320
     /*  699320 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(699395), // Rule ID 11097 //
     /*  699325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  699336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  699339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  699342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699393 */     GIR_RootConstrainSelectedInstOperands,
     /*  699394 */     // GIR_Coverage, 11097,
     /*  699394 */     GIR_EraseRootFromParent_Done,
     /*  699395 */   // Label 11054: @699395
     /*  699395 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(699470), // Rule ID 11100 //
     /*  699400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699468 */     GIR_RootConstrainSelectedInstOperands,
     /*  699469 */     // GIR_Coverage, 11100,
     /*  699469 */     GIR_EraseRootFromParent_Done,
     /*  699470 */   // Label 11055: @699470
     /*  699470 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(699545), // Rule ID 11101 //
     /*  699475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  699486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  699489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  699492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699543 */     GIR_RootConstrainSelectedInstOperands,
     /*  699544 */     // GIR_Coverage, 11101,
     /*  699544 */     GIR_EraseRootFromParent_Done,
     /*  699545 */   // Label 11056: @699545
     /*  699545 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(699620), // Rule ID 11104 //
     /*  699550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699618 */     GIR_RootConstrainSelectedInstOperands,
     /*  699619 */     // GIR_Coverage, 11104,
     /*  699619 */     GIR_EraseRootFromParent_Done,
     /*  699620 */   // Label 11057: @699620
     /*  699620 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(699695), // Rule ID 11105 //
     /*  699625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  699636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  699639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  699642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  699660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  699674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699693 */     GIR_RootConstrainSelectedInstOperands,
     /*  699694 */     // GIR_Coverage, 11105,
     /*  699694 */     GIR_EraseRootFromParent_Done,
     /*  699695 */   // Label 11058: @699695
     /*  699695 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(699770), // Rule ID 11108 //
     /*  699700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699768 */     GIR_RootConstrainSelectedInstOperands,
     /*  699769 */     // GIR_Coverage, 11108,
     /*  699769 */     GIR_EraseRootFromParent_Done,
     /*  699770 */   // Label 11059: @699770
     /*  699770 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(699845), // Rule ID 11109 //
     /*  699775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  699824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699843 */     GIR_RootConstrainSelectedInstOperands,
     /*  699844 */     // GIR_Coverage, 11109,
     /*  699844 */     GIR_EraseRootFromParent_Done,
     /*  699845 */   // Label 11060: @699845
     /*  699845 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(699920), // Rule ID 11112 //
     /*  699850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699918 */     GIR_RootConstrainSelectedInstOperands,
     /*  699919 */     // GIR_Coverage, 11112,
     /*  699919 */     GIR_EraseRootFromParent_Done,
     /*  699920 */   // Label 11061: @699920
     /*  699920 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(699995), // Rule ID 11113 //
     /*  699925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  699933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  699974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699993 */     GIR_RootConstrainSelectedInstOperands,
     /*  699994 */     // GIR_Coverage, 11113,
     /*  699994 */     GIR_EraseRootFromParent_Done,
     /*  699995 */   // Label 11062: @699995
     /*  699995 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(700070), // Rule ID 11116 //
     /*  700000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  700049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700068 */     GIR_RootConstrainSelectedInstOperands,
     /*  700069 */     // GIR_Coverage, 11116,
     /*  700069 */     GIR_EraseRootFromParent_Done,
     /*  700070 */   // Label 11063: @700070
     /*  700070 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(700145), // Rule ID 11117 //
     /*  700075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  700086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  700089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  700092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  700124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700143 */     GIR_RootConstrainSelectedInstOperands,
     /*  700144 */     // GIR_Coverage, 11117,
     /*  700144 */     GIR_EraseRootFromParent_Done,
     /*  700145 */   // Label 11064: @700145
     /*  700145 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(700220), // Rule ID 11120 //
     /*  700150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  700199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700218 */     GIR_RootConstrainSelectedInstOperands,
     /*  700219 */     // GIR_Coverage, 11120,
     /*  700219 */     GIR_EraseRootFromParent_Done,
     /*  700220 */   // Label 11065: @700220
     /*  700220 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(700295), // Rule ID 11121 //
     /*  700225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  700236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  700239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  700242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  700274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700293 */     GIR_RootConstrainSelectedInstOperands,
     /*  700294 */     // GIR_Coverage, 11121,
     /*  700294 */     GIR_EraseRootFromParent_Done,
     /*  700295 */   // Label 11066: @700295
     /*  700295 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(700370), // Rule ID 11124 //
     /*  700300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  700303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  700346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  700349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700368 */     GIR_RootConstrainSelectedInstOperands,
     /*  700369 */     // GIR_Coverage, 11124,
     /*  700369 */     GIR_EraseRootFromParent_Done,
     /*  700370 */   // Label 11067: @700370
     /*  700370 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(700445), // Rule ID 11125 //
     /*  700375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  700378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  700383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  700386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  700389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  700392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  700421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  700424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  700440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700443 */     GIR_RootConstrainSelectedInstOperands,
     /*  700444 */     // GIR_Coverage, 11125,
     /*  700444 */     GIR_EraseRootFromParent_Done,
     /*  700445 */   // Label 11068: @700445
     /*  700445 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(700520), // Rule ID 11128 //
     /*  700450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  700461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  700464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  700467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  700470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  700499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700518 */     GIR_RootConstrainSelectedInstOperands,
     /*  700519 */     // GIR_Coverage, 11128,
     /*  700519 */     GIR_EraseRootFromParent_Done,
     /*  700520 */   // Label 11069: @700520
     /*  700520 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(700595), // Rule ID 11129 //
     /*  700525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  700536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  700539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  700542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  700545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  700574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700593 */     GIR_RootConstrainSelectedInstOperands,
     /*  700594 */     // GIR_Coverage, 11129,
     /*  700594 */     GIR_EraseRootFromParent_Done,
     /*  700595 */   // Label 11070: @700595
     /*  700595 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(700670), // Rule ID 11132 //
     /*  700600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  700620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700668 */     GIR_RootConstrainSelectedInstOperands,
     /*  700669 */     // GIR_Coverage, 11132,
     /*  700669 */     GIR_EraseRootFromParent_Done,
     /*  700670 */   // Label 11071: @700670
     /*  700670 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(700745), // Rule ID 11133 //
     /*  700675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  700686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  700689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  700692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  700695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700743 */     GIR_RootConstrainSelectedInstOperands,
     /*  700744 */     // GIR_Coverage, 11133,
     /*  700744 */     GIR_EraseRootFromParent_Done,
     /*  700745 */   // Label 11072: @700745
     /*  700745 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(700820), // Rule ID 11136 //
     /*  700750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  700770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  700799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700818 */     GIR_RootConstrainSelectedInstOperands,
     /*  700819 */     // GIR_Coverage, 11136,
     /*  700819 */     GIR_EraseRootFromParent_Done,
     /*  700820 */   // Label 11073: @700820
     /*  700820 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(700895), // Rule ID 11137 //
     /*  700825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  700836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  700839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  700842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  700845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  700874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700893 */     GIR_RootConstrainSelectedInstOperands,
     /*  700894 */     // GIR_Coverage, 11137,
     /*  700894 */     GIR_EraseRootFromParent_Done,
     /*  700895 */   // Label 11074: @700895
     /*  700895 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(700970), // Rule ID 11140 //
     /*  700900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  700920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  700949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700968 */     GIR_RootConstrainSelectedInstOperands,
     /*  700969 */     // GIR_Coverage, 11140,
     /*  700969 */     GIR_EraseRootFromParent_Done,
     /*  700970 */   // Label 11075: @700970
     /*  700970 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(701045), // Rule ID 11141 //
     /*  700975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  700986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  700989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  700992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  700995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  701024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701043 */     GIR_RootConstrainSelectedInstOperands,
     /*  701044 */     // GIR_Coverage, 11141,
     /*  701044 */     GIR_EraseRootFromParent_Done,
     /*  701045 */   // Label 11076: @701045
     /*  701045 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(701120), // Rule ID 11144 //
     /*  701050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  701061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  701064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  701067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  701070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701118 */     GIR_RootConstrainSelectedInstOperands,
     /*  701119 */     // GIR_Coverage, 11144,
     /*  701119 */     GIR_EraseRootFromParent_Done,
     /*  701120 */   // Label 11077: @701120
     /*  701120 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(701195), // Rule ID 11145 //
     /*  701125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  701136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  701139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  701142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  701145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701193 */     GIR_RootConstrainSelectedInstOperands,
     /*  701194 */     // GIR_Coverage, 11145,
     /*  701194 */     GIR_EraseRootFromParent_Done,
     /*  701195 */   // Label 11078: @701195
     /*  701195 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(701270), // Rule ID 11148 //
     /*  701200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  701211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  701214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  701217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  701220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701268 */     GIR_RootConstrainSelectedInstOperands,
     /*  701269 */     // GIR_Coverage, 11148,
     /*  701269 */     GIR_EraseRootFromParent_Done,
     /*  701270 */   // Label 11079: @701270
     /*  701270 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(701345), // Rule ID 11149 //
     /*  701275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  701286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  701289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  701292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  701295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  701324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701343 */     GIR_RootConstrainSelectedInstOperands,
     /*  701344 */     // GIR_Coverage, 11149,
     /*  701344 */     GIR_EraseRootFromParent_Done,
     /*  701345 */   // Label 11080: @701345
     /*  701345 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(701420), // Rule ID 11152 //
     /*  701350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  701361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  701364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  701367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  701370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701418 */     GIR_RootConstrainSelectedInstOperands,
     /*  701419 */     // GIR_Coverage, 11152,
     /*  701419 */     GIR_EraseRootFromParent_Done,
     /*  701420 */   // Label 11081: @701420
     /*  701420 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(701495), // Rule ID 11153 //
     /*  701425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  701436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  701439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  701442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  701445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701493 */     GIR_RootConstrainSelectedInstOperands,
     /*  701494 */     // GIR_Coverage, 11153,
     /*  701494 */     GIR_EraseRootFromParent_Done,
     /*  701495 */   // Label 11082: @701495
     /*  701495 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(701570), // Rule ID 11156 //
     /*  701500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  701520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701568 */     GIR_RootConstrainSelectedInstOperands,
     /*  701569 */     // GIR_Coverage, 11156,
     /*  701569 */     GIR_EraseRootFromParent_Done,
     /*  701570 */   // Label 11083: @701570
     /*  701570 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(701645), // Rule ID 11157 //
     /*  701575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  701586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  701589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  701592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  701595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701643 */     GIR_RootConstrainSelectedInstOperands,
     /*  701644 */     // GIR_Coverage, 11157,
     /*  701644 */     GIR_EraseRootFromParent_Done,
     /*  701645 */   // Label 11084: @701645
     /*  701645 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(701720), // Rule ID 11160 //
     /*  701650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  701670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701718 */     GIR_RootConstrainSelectedInstOperands,
     /*  701719 */     // GIR_Coverage, 11160,
     /*  701719 */     GIR_EraseRootFromParent_Done,
     /*  701720 */   // Label 11085: @701720
     /*  701720 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(701795), // Rule ID 11161 //
     /*  701725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  701736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  701739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  701742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  701745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  701774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701793 */     GIR_RootConstrainSelectedInstOperands,
     /*  701794 */     // GIR_Coverage, 11161,
     /*  701794 */     GIR_EraseRootFromParent_Done,
     /*  701795 */   // Label 11086: @701795
     /*  701795 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(701870), // Rule ID 11164 //
     /*  701800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  701820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  701849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701868 */     GIR_RootConstrainSelectedInstOperands,
     /*  701869 */     // GIR_Coverage, 11164,
     /*  701869 */     GIR_EraseRootFromParent_Done,
     /*  701870 */   // Label 11087: @701870
     /*  701870 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(701945), // Rule ID 11165 //
     /*  701875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  701886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  701889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  701892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  701895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  701924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701943 */     GIR_RootConstrainSelectedInstOperands,
     /*  701944 */     // GIR_Coverage, 11165,
     /*  701944 */     GIR_EraseRootFromParent_Done,
     /*  701945 */   // Label 11088: @701945
     /*  701945 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(702020), // Rule ID 11168 //
     /*  701950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  701961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  701964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  701967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  701970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  701999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702018 */     GIR_RootConstrainSelectedInstOperands,
     /*  702019 */     // GIR_Coverage, 11168,
     /*  702019 */     GIR_EraseRootFromParent_Done,
     /*  702020 */   // Label 11089: @702020
     /*  702020 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(702095), // Rule ID 11169 //
     /*  702025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  702036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  702039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  702042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  702045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702071 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702093 */     GIR_RootConstrainSelectedInstOperands,
     /*  702094 */     // GIR_Coverage, 11169,
     /*  702094 */     GIR_EraseRootFromParent_Done,
     /*  702095 */   // Label 11090: @702095
     /*  702095 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(702170), // Rule ID 11172 //
     /*  702100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  702111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  702114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  702117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  702120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702168 */     GIR_RootConstrainSelectedInstOperands,
     /*  702169 */     // GIR_Coverage, 11172,
     /*  702169 */     GIR_EraseRootFromParent_Done,
     /*  702170 */   // Label 11091: @702170
     /*  702170 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(702245), // Rule ID 11173 //
     /*  702175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  702186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  702189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  702192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  702195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702221 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702243 */     GIR_RootConstrainSelectedInstOperands,
     /*  702244 */     // GIR_Coverage, 11173,
     /*  702244 */     GIR_EraseRootFromParent_Done,
     /*  702245 */   // Label 11092: @702245
     /*  702245 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(702320), // Rule ID 11176 //
     /*  702250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  702261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  702264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  702267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  702270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702318 */     GIR_RootConstrainSelectedInstOperands,
     /*  702319 */     // GIR_Coverage, 11176,
     /*  702319 */     GIR_EraseRootFromParent_Done,
     /*  702320 */   // Label 11093: @702320
     /*  702320 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(702395), // Rule ID 11177 //
     /*  702325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  702336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  702339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  702342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  702345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702393 */     GIR_RootConstrainSelectedInstOperands,
     /*  702394 */     // GIR_Coverage, 11177,
     /*  702394 */     GIR_EraseRootFromParent_Done,
     /*  702395 */   // Label 11094: @702395
     /*  702395 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(702470), // Rule ID 11180 //
     /*  702400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  702411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  702414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  702417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  702420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702468 */     GIR_RootConstrainSelectedInstOperands,
     /*  702469 */     // GIR_Coverage, 11180,
     /*  702469 */     GIR_EraseRootFromParent_Done,
     /*  702470 */   // Label 11095: @702470
     /*  702470 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(702545), // Rule ID 11181 //
     /*  702475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  702486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  702489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  702492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  702495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702521 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702543 */     GIR_RootConstrainSelectedInstOperands,
     /*  702544 */     // GIR_Coverage, 11181,
     /*  702544 */     GIR_EraseRootFromParent_Done,
     /*  702545 */   // Label 11096: @702545
     /*  702545 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(702620), // Rule ID 11184 //
     /*  702550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  702561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  702564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  702567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  702570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702618 */     GIR_RootConstrainSelectedInstOperands,
     /*  702619 */     // GIR_Coverage, 11184,
     /*  702619 */     GIR_EraseRootFromParent_Done,
     /*  702620 */   // Label 11097: @702620
     /*  702620 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(702695), // Rule ID 11185 //
     /*  702625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  702636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  702639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  702642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  702645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  702664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702671 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  702674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702693 */     GIR_RootConstrainSelectedInstOperands,
     /*  702694 */     // GIR_Coverage, 11185,
     /*  702694 */     GIR_EraseRootFromParent_Done,
     /*  702695 */   // Label 11098: @702695
     /*  702695 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(702770), // Rule ID 11188 //
     /*  702700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  702720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702768 */     GIR_RootConstrainSelectedInstOperands,
     /*  702769 */     // GIR_Coverage, 11188,
     /*  702769 */     GIR_EraseRootFromParent_Done,
     /*  702770 */   // Label 11099: @702770
     /*  702770 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(702845), // Rule ID 11189 //
     /*  702775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  702786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  702789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  702792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  702795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  702824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702843 */     GIR_RootConstrainSelectedInstOperands,
     /*  702844 */     // GIR_Coverage, 11189,
     /*  702844 */     GIR_EraseRootFromParent_Done,
     /*  702845 */   // Label 11100: @702845
     /*  702845 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(702920), // Rule ID 11192 //
     /*  702850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  702870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702918 */     GIR_RootConstrainSelectedInstOperands,
     /*  702919 */     // GIR_Coverage, 11192,
     /*  702919 */     GIR_EraseRootFromParent_Done,
     /*  702920 */   // Label 11101: @702920
     /*  702920 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(702995), // Rule ID 11193 //
     /*  702925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  702933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  702936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  702939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  702942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  702945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  702964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  702974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702993 */     GIR_RootConstrainSelectedInstOperands,
     /*  702994 */     // GIR_Coverage, 11193,
     /*  702994 */     GIR_EraseRootFromParent_Done,
     /*  702995 */   // Label 11102: @702995
     /*  702995 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(703070), // Rule ID 11196 //
     /*  703000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  703011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  703014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  703017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  703020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  703049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703068 */     GIR_RootConstrainSelectedInstOperands,
     /*  703069 */     // GIR_Coverage, 11196,
     /*  703069 */     GIR_EraseRootFromParent_Done,
     /*  703070 */   // Label 11103: @703070
     /*  703070 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(703145), // Rule ID 11197 //
     /*  703075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  703086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  703089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  703092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  703095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703121 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  703124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703143 */     GIR_RootConstrainSelectedInstOperands,
     /*  703144 */     // GIR_Coverage, 11197,
     /*  703144 */     GIR_EraseRootFromParent_Done,
     /*  703145 */   // Label 11104: @703145
     /*  703145 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(703220), // Rule ID 11200 //
     /*  703150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  703161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  703164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  703167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  703199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703218 */     GIR_RootConstrainSelectedInstOperands,
     /*  703219 */     // GIR_Coverage, 11200,
     /*  703219 */     GIR_EraseRootFromParent_Done,
     /*  703220 */   // Label 11105: @703220
     /*  703220 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(703295), // Rule ID 11201 //
     /*  703225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  703236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  703239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  703242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  703274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703293 */     GIR_RootConstrainSelectedInstOperands,
     /*  703294 */     // GIR_Coverage, 11201,
     /*  703294 */     GIR_EraseRootFromParent_Done,
     /*  703295 */   // Label 11106: @703295
     /*  703295 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(703370), // Rule ID 11204 //
     /*  703300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  703311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  703314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  703317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703368 */     GIR_RootConstrainSelectedInstOperands,
     /*  703369 */     // GIR_Coverage, 11204,
     /*  703369 */     GIR_EraseRootFromParent_Done,
     /*  703370 */   // Label 11107: @703370
     /*  703370 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(703445), // Rule ID 11205 //
     /*  703375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  703386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  703389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  703392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703443 */     GIR_RootConstrainSelectedInstOperands,
     /*  703444 */     // GIR_Coverage, 11205,
     /*  703444 */     GIR_EraseRootFromParent_Done,
     /*  703445 */   // Label 11108: @703445
     /*  703445 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(703520), // Rule ID 11208 //
     /*  703450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  703461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  703464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  703467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703518 */     GIR_RootConstrainSelectedInstOperands,
     /*  703519 */     // GIR_Coverage, 11208,
     /*  703519 */     GIR_EraseRootFromParent_Done,
     /*  703520 */   // Label 11109: @703520
     /*  703520 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(703595), // Rule ID 11209 //
     /*  703525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  703536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  703539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  703542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703593 */     GIR_RootConstrainSelectedInstOperands,
     /*  703594 */     // GIR_Coverage, 11209,
     /*  703594 */     GIR_EraseRootFromParent_Done,
     /*  703595 */   // Label 11110: @703595
     /*  703595 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(703670), // Rule ID 11212 //
     /*  703600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703668 */     GIR_RootConstrainSelectedInstOperands,
     /*  703669 */     // GIR_Coverage, 11212,
     /*  703669 */     GIR_EraseRootFromParent_Done,
     /*  703670 */   // Label 11111: @703670
     /*  703670 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(703745), // Rule ID 11213 //
     /*  703675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  703686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  703689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  703692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  703724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703743 */     GIR_RootConstrainSelectedInstOperands,
     /*  703744 */     // GIR_Coverage, 11213,
     /*  703744 */     GIR_EraseRootFromParent_Done,
     /*  703745 */   // Label 11112: @703745
     /*  703745 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(703820), // Rule ID 11216 //
     /*  703750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703818 */     GIR_RootConstrainSelectedInstOperands,
     /*  703819 */     // GIR_Coverage, 11216,
     /*  703819 */     GIR_EraseRootFromParent_Done,
     /*  703820 */   // Label 11113: @703820
     /*  703820 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(703895), // Rule ID 11217 //
     /*  703825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  703836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  703839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  703842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703893 */     GIR_RootConstrainSelectedInstOperands,
     /*  703894 */     // GIR_Coverage, 11217,
     /*  703894 */     GIR_EraseRootFromParent_Done,
     /*  703895 */   // Label 11114: @703895
     /*  703895 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(703970), // Rule ID 11220 //
     /*  703900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  703920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  703939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  703949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703968 */     GIR_RootConstrainSelectedInstOperands,
     /*  703969 */     // GIR_Coverage, 11220,
     /*  703969 */     GIR_EraseRootFromParent_Done,
     /*  703970 */   // Label 11115: @703970
     /*  703970 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(704045), // Rule ID 11221 //
     /*  703975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  703983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  703986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  703989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  703992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  703995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  704024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704043 */     GIR_RootConstrainSelectedInstOperands,
     /*  704044 */     // GIR_Coverage, 11221,
     /*  704044 */     GIR_EraseRootFromParent_Done,
     /*  704045 */   // Label 11116: @704045
     /*  704045 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(704120), // Rule ID 11224 //
     /*  704050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  704061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  704064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  704067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704118 */     GIR_RootConstrainSelectedInstOperands,
     /*  704119 */     // GIR_Coverage, 11224,
     /*  704119 */     GIR_EraseRootFromParent_Done,
     /*  704120 */   // Label 11117: @704120
     /*  704120 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(704195), // Rule ID 11225 //
     /*  704125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  704136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  704139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  704142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704193 */     GIR_RootConstrainSelectedInstOperands,
     /*  704194 */     // GIR_Coverage, 11225,
     /*  704194 */     GIR_EraseRootFromParent_Done,
     /*  704195 */   // Label 11118: @704195
     /*  704195 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(704270), // Rule ID 11228 //
     /*  704200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  704211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  704214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  704217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704268 */     GIR_RootConstrainSelectedInstOperands,
     /*  704269 */     // GIR_Coverage, 11228,
     /*  704269 */     GIR_EraseRootFromParent_Done,
     /*  704270 */   // Label 11119: @704270
     /*  704270 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(704345), // Rule ID 11229 //
     /*  704275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  704286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  704289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  704292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704343 */     GIR_RootConstrainSelectedInstOperands,
     /*  704344 */     // GIR_Coverage, 11229,
     /*  704344 */     GIR_EraseRootFromParent_Done,
     /*  704345 */   // Label 11120: @704345
     /*  704345 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(704420), // Rule ID 11232 //
     /*  704350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  704361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  704364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  704367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704418 */     GIR_RootConstrainSelectedInstOperands,
     /*  704419 */     // GIR_Coverage, 11232,
     /*  704419 */     GIR_EraseRootFromParent_Done,
     /*  704420 */   // Label 11121: @704420
     /*  704420 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(704495), // Rule ID 11233 //
     /*  704425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  704436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  704439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  704442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  704474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704493 */     GIR_RootConstrainSelectedInstOperands,
     /*  704494 */     // GIR_Coverage, 11233,
     /*  704494 */     GIR_EraseRootFromParent_Done,
     /*  704495 */   // Label 11122: @704495
     /*  704495 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(704570), // Rule ID 11236 //
     /*  704500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  704511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  704514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  704517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704546 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704568 */     GIR_RootConstrainSelectedInstOperands,
     /*  704569 */     // GIR_Coverage, 11236,
     /*  704569 */     GIR_EraseRootFromParent_Done,
     /*  704570 */   // Label 11123: @704570
     /*  704570 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(704645), // Rule ID 11237 //
     /*  704575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  704586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  704589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  704592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704643 */     GIR_RootConstrainSelectedInstOperands,
     /*  704644 */     // GIR_Coverage, 11237,
     /*  704644 */     GIR_EraseRootFromParent_Done,
     /*  704645 */   // Label 11124: @704645
     /*  704645 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(704720), // Rule ID 11240 //
     /*  704650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  704699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704718 */     GIR_RootConstrainSelectedInstOperands,
     /*  704719 */     // GIR_Coverage, 11240,
     /*  704719 */     GIR_EraseRootFromParent_Done,
     /*  704720 */   // Label 11125: @704720
     /*  704720 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(704795), // Rule ID 11241 //
     /*  704725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  704736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  704739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  704742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704771 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  704774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704793 */     GIR_RootConstrainSelectedInstOperands,
     /*  704794 */     // GIR_Coverage, 11241,
     /*  704794 */     GIR_EraseRootFromParent_Done,
     /*  704795 */   // Label 11126: @704795
     /*  704795 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(704870), // Rule ID 11244 //
     /*  704800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  704849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704868 */     GIR_RootConstrainSelectedInstOperands,
     /*  704869 */     // GIR_Coverage, 11244,
     /*  704869 */     GIR_EraseRootFromParent_Done,
     /*  704870 */   // Label 11127: @704870
     /*  704870 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(704945), // Rule ID 11245 //
     /*  704875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  704886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  704889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  704892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704921 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  704924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704943 */     GIR_RootConstrainSelectedInstOperands,
     /*  704944 */     // GIR_Coverage, 11245,
     /*  704944 */     GIR_EraseRootFromParent_Done,
     /*  704945 */   // Label 11128: @704945
     /*  704945 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(705020), // Rule ID 11248 //
     /*  704950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  704958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  704961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  704964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  704967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  704999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705018 */     GIR_RootConstrainSelectedInstOperands,
     /*  705019 */     // GIR_Coverage, 11248,
     /*  705019 */     GIR_EraseRootFromParent_Done,
     /*  705020 */   // Label 11129: @705020
     /*  705020 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(705095), // Rule ID 11249 //
     /*  705025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  705036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  705039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  705042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705093 */     GIR_RootConstrainSelectedInstOperands,
     /*  705094 */     // GIR_Coverage, 11249,
     /*  705094 */     GIR_EraseRootFromParent_Done,
     /*  705095 */   // Label 11130: @705095
     /*  705095 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(705170), // Rule ID 11252 //
     /*  705100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  705111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  705114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  705117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705168 */     GIR_RootConstrainSelectedInstOperands,
     /*  705169 */     // GIR_Coverage, 11252,
     /*  705169 */     GIR_EraseRootFromParent_Done,
     /*  705170 */   // Label 11131: @705170
     /*  705170 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(705245), // Rule ID 11253 //
     /*  705175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  705186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  705189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  705192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705221 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705243 */     GIR_RootConstrainSelectedInstOperands,
     /*  705244 */     // GIR_Coverage, 11253,
     /*  705244 */     GIR_EraseRootFromParent_Done,
     /*  705245 */   // Label 11132: @705245
     /*  705245 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(705320), // Rule ID 11256 //
     /*  705250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  705261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  705264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  705267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705318 */     GIR_RootConstrainSelectedInstOperands,
     /*  705319 */     // GIR_Coverage, 11256,
     /*  705319 */     GIR_EraseRootFromParent_Done,
     /*  705320 */   // Label 11133: @705320
     /*  705320 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(705395), // Rule ID 11257 //
     /*  705325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  705336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  705339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  705342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705371 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705393 */     GIR_RootConstrainSelectedInstOperands,
     /*  705394 */     // GIR_Coverage, 11257,
     /*  705394 */     GIR_EraseRootFromParent_Done,
     /*  705395 */   // Label 11134: @705395
     /*  705395 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(705470), // Rule ID 11260 //
     /*  705400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  705411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  705414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  705417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705468 */     GIR_RootConstrainSelectedInstOperands,
     /*  705469 */     // GIR_Coverage, 11260,
     /*  705469 */     GIR_EraseRootFromParent_Done,
     /*  705470 */   // Label 11135: @705470
     /*  705470 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(705545), // Rule ID 11261 //
     /*  705475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  705486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  705489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  705492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  705524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705543 */     GIR_RootConstrainSelectedInstOperands,
     /*  705544 */     // GIR_Coverage, 11261,
     /*  705544 */     GIR_EraseRootFromParent_Done,
     /*  705545 */   // Label 11136: @705545
     /*  705545 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(705620), // Rule ID 11264 //
     /*  705550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  705561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  705564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  705567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705618 */     GIR_RootConstrainSelectedInstOperands,
     /*  705619 */     // GIR_Coverage, 11264,
     /*  705619 */     GIR_EraseRootFromParent_Done,
     /*  705620 */   // Label 11137: @705620
     /*  705620 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(705695), // Rule ID 11265 //
     /*  705625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  705636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  705639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  705642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  705674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705693 */     GIR_RootConstrainSelectedInstOperands,
     /*  705694 */     // GIR_Coverage, 11265,
     /*  705694 */     GIR_EraseRootFromParent_Done,
     /*  705695 */   // Label 11138: @705695
     /*  705695 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(705770), // Rule ID 11268 //
     /*  705700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705768 */     GIR_RootConstrainSelectedInstOperands,
     /*  705769 */     // GIR_Coverage, 11268,
     /*  705769 */     GIR_EraseRootFromParent_Done,
     /*  705770 */   // Label 11139: @705770
     /*  705770 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(705845), // Rule ID 11269 //
     /*  705775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  705783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  705786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  705789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  705792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705821 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  705824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705843 */     GIR_RootConstrainSelectedInstOperands,
     /*  705844 */     // GIR_Coverage, 11269,
     /*  705844 */     GIR_EraseRootFromParent_Done,
     /*  705845 */   // Label 11140: @705845
     /*  705845 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(705920), // Rule ID 11272 //
     /*  705850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  705870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  705899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705918 */     GIR_RootConstrainSelectedInstOperands,
     /*  705919 */     // GIR_Coverage, 11272,
     /*  705919 */     GIR_EraseRootFromParent_Done,
     /*  705920 */   // Label 11141: @705920
     /*  705920 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(705995), // Rule ID 11273 //
     /*  705925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  705936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  705939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  705942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  705945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  705974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705993 */     GIR_RootConstrainSelectedInstOperands,
     /*  705994 */     // GIR_Coverage, 11273,
     /*  705994 */     GIR_EraseRootFromParent_Done,
     /*  705995 */   // Label 11142: @705995
     /*  705995 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(706070), // Rule ID 11276 //
     /*  706000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  706011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  706014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  706017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  706020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706068 */     GIR_RootConstrainSelectedInstOperands,
     /*  706069 */     // GIR_Coverage, 11276,
     /*  706069 */     GIR_EraseRootFromParent_Done,
     /*  706070 */   // Label 11143: @706070
     /*  706070 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(706145), // Rule ID 11277 //
     /*  706075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  706086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  706089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  706092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  706095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706143 */     GIR_RootConstrainSelectedInstOperands,
     /*  706144 */     // GIR_Coverage, 11277,
     /*  706144 */     GIR_EraseRootFromParent_Done,
     /*  706145 */   // Label 11144: @706145
     /*  706145 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(706220), // Rule ID 11280 //
     /*  706150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  706161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  706164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  706167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  706170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706218 */     GIR_RootConstrainSelectedInstOperands,
     /*  706219 */     // GIR_Coverage, 11280,
     /*  706219 */     GIR_EraseRootFromParent_Done,
     /*  706220 */   // Label 11145: @706220
     /*  706220 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(706295), // Rule ID 11281 //
     /*  706225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  706236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  706239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  706242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  706245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706293 */     GIR_RootConstrainSelectedInstOperands,
     /*  706294 */     // GIR_Coverage, 11281,
     /*  706294 */     GIR_EraseRootFromParent_Done,
     /*  706295 */   // Label 11146: @706295
     /*  706295 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(706370), // Rule ID 11284 //
     /*  706300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  706311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  706314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  706317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  706320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706368 */     GIR_RootConstrainSelectedInstOperands,
     /*  706369 */     // GIR_Coverage, 11284,
     /*  706369 */     GIR_EraseRootFromParent_Done,
     /*  706370 */   // Label 11147: @706370
     /*  706370 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(706445), // Rule ID 11285 //
     /*  706375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  706386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  706389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  706392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  706395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  706424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706443 */     GIR_RootConstrainSelectedInstOperands,
     /*  706444 */     // GIR_Coverage, 11285,
     /*  706444 */     GIR_EraseRootFromParent_Done,
     /*  706445 */   // Label 11148: @706445
     /*  706445 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(706520), // Rule ID 11288 //
     /*  706450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  706461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  706464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  706467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  706470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706518 */     GIR_RootConstrainSelectedInstOperands,
     /*  706519 */     // GIR_Coverage, 11288,
     /*  706519 */     GIR_EraseRootFromParent_Done,
     /*  706520 */   // Label 11149: @706520
     /*  706520 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(706595), // Rule ID 11289 //
     /*  706525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  706536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  706539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  706542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  706545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706593 */     GIR_RootConstrainSelectedInstOperands,
     /*  706594 */     // GIR_Coverage, 11289,
     /*  706594 */     GIR_EraseRootFromParent_Done,
     /*  706595 */   // Label 11150: @706595
     /*  706595 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(706670), // Rule ID 11292 //
     /*  706600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  706620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706668 */     GIR_RootConstrainSelectedInstOperands,
     /*  706669 */     // GIR_Coverage, 11292,
     /*  706669 */     GIR_EraseRootFromParent_Done,
     /*  706670 */   // Label 11151: @706670
     /*  706670 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(706745), // Rule ID 11293 //
     /*  706675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  706686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  706689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  706692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  706695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  706724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706743 */     GIR_RootConstrainSelectedInstOperands,
     /*  706744 */     // GIR_Coverage, 11293,
     /*  706744 */     GIR_EraseRootFromParent_Done,
     /*  706745 */   // Label 11152: @706745
     /*  706745 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(706820), // Rule ID 11296 //
     /*  706750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  706770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706818 */     GIR_RootConstrainSelectedInstOperands,
     /*  706819 */     // GIR_Coverage, 11296,
     /*  706819 */     GIR_EraseRootFromParent_Done,
     /*  706820 */   // Label 11153: @706820
     /*  706820 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(706895), // Rule ID 11297 //
     /*  706825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  706836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  706839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  706842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  706845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706893 */     GIR_RootConstrainSelectedInstOperands,
     /*  706894 */     // GIR_Coverage, 11297,
     /*  706894 */     GIR_EraseRootFromParent_Done,
     /*  706895 */   // Label 11154: @706895
     /*  706895 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(706970), // Rule ID 11300 //
     /*  706900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  706920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  706949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706968 */     GIR_RootConstrainSelectedInstOperands,
     /*  706969 */     // GIR_Coverage, 11300,
     /*  706969 */     GIR_EraseRootFromParent_Done,
     /*  706970 */   // Label 11155: @706970
     /*  706970 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(707045), // Rule ID 11301 //
     /*  706975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  706986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  706989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  706992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  706995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707043 */     GIR_RootConstrainSelectedInstOperands,
     /*  707044 */     // GIR_Coverage, 11301,
     /*  707044 */     GIR_EraseRootFromParent_Done,
     /*  707045 */   // Label 11156: @707045
     /*  707045 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(707120), // Rule ID 11304 //
     /*  707050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  707061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  707064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  707067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  707070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707118 */     GIR_RootConstrainSelectedInstOperands,
     /*  707119 */     // GIR_Coverage, 11304,
     /*  707119 */     GIR_EraseRootFromParent_Done,
     /*  707120 */   // Label 11157: @707120
     /*  707120 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(707195), // Rule ID 11305 //
     /*  707125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  707136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  707139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  707142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  707145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  707174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707193 */     GIR_RootConstrainSelectedInstOperands,
     /*  707194 */     // GIR_Coverage, 11305,
     /*  707194 */     GIR_EraseRootFromParent_Done,
     /*  707195 */   // Label 11158: @707195
     /*  707195 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(707270), // Rule ID 11308 //
     /*  707200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  707211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  707214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  707217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  707220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707268 */     GIR_RootConstrainSelectedInstOperands,
     /*  707269 */     // GIR_Coverage, 11308,
     /*  707269 */     GIR_EraseRootFromParent_Done,
     /*  707270 */   // Label 11159: @707270
     /*  707270 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(707345), // Rule ID 11309 //
     /*  707275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  707286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  707289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  707292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  707295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707321 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707343 */     GIR_RootConstrainSelectedInstOperands,
     /*  707344 */     // GIR_Coverage, 11309,
     /*  707344 */     GIR_EraseRootFromParent_Done,
     /*  707345 */   // Label 11160: @707345
     /*  707345 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(707420), // Rule ID 11312 //
     /*  707350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  707361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  707364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  707367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  707370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707418 */     GIR_RootConstrainSelectedInstOperands,
     /*  707419 */     // GIR_Coverage, 11312,
     /*  707419 */     GIR_EraseRootFromParent_Done,
     /*  707420 */   // Label 11161: @707420
     /*  707420 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(707495), // Rule ID 11313 //
     /*  707425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  707436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  707439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  707442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  707445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707493 */     GIR_RootConstrainSelectedInstOperands,
     /*  707494 */     // GIR_Coverage, 11313,
     /*  707494 */     GIR_EraseRootFromParent_Done,
     /*  707495 */   // Label 11162: @707495
     /*  707495 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(707570), // Rule ID 11316 //
     /*  707500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  707511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  707514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  707517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  707520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707568 */     GIR_RootConstrainSelectedInstOperands,
     /*  707569 */     // GIR_Coverage, 11316,
     /*  707569 */     GIR_EraseRootFromParent_Done,
     /*  707570 */   // Label 11163: @707570
     /*  707570 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(707645), // Rule ID 11317 //
     /*  707575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  707586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  707589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  707592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  707595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707643 */     GIR_RootConstrainSelectedInstOperands,
     /*  707644 */     // GIR_Coverage, 11317,
     /*  707644 */     GIR_EraseRootFromParent_Done,
     /*  707645 */   // Label 11164: @707645
     /*  707645 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(707720), // Rule ID 11320 //
     /*  707650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  707670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707718 */     GIR_RootConstrainSelectedInstOperands,
     /*  707719 */     // GIR_Coverage, 11320,
     /*  707719 */     GIR_EraseRootFromParent_Done,
     /*  707720 */   // Label 11165: @707720
     /*  707720 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(707795), // Rule ID 11321 //
     /*  707725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  707736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  707739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  707742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  707745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  707774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707793 */     GIR_RootConstrainSelectedInstOperands,
     /*  707794 */     // GIR_Coverage, 11321,
     /*  707794 */     GIR_EraseRootFromParent_Done,
     /*  707795 */   // Label 11166: @707795
     /*  707795 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(707870), // Rule ID 11324 //
     /*  707800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  707820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707868 */     GIR_RootConstrainSelectedInstOperands,
     /*  707869 */     // GIR_Coverage, 11324,
     /*  707869 */     GIR_EraseRootFromParent_Done,
     /*  707870 */   // Label 11167: @707870
     /*  707870 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(707945), // Rule ID 11325 //
     /*  707875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  707886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  707889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  707892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  707895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707921 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  707924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707943 */     GIR_RootConstrainSelectedInstOperands,
     /*  707944 */     // GIR_Coverage, 11325,
     /*  707944 */     GIR_EraseRootFromParent_Done,
     /*  707945 */   // Label 11168: @707945
     /*  707945 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(708020), // Rule ID 11328 //
     /*  707950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  707961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  707964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  707967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  707970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  707999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708018 */     GIR_RootConstrainSelectedInstOperands,
     /*  708019 */     // GIR_Coverage, 11328,
     /*  708019 */     GIR_EraseRootFromParent_Done,
     /*  708020 */   // Label 11169: @708020
     /*  708020 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(708095), // Rule ID 11329 //
     /*  708025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  708036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  708039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  708042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  708045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708071 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708093 */     GIR_RootConstrainSelectedInstOperands,
     /*  708094 */     // GIR_Coverage, 11329,
     /*  708094 */     GIR_EraseRootFromParent_Done,
     /*  708095 */   // Label 11170: @708095
     /*  708095 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(708170), // Rule ID 11332 //
     /*  708100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  708149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708168 */     GIR_RootConstrainSelectedInstOperands,
     /*  708169 */     // GIR_Coverage, 11332,
     /*  708169 */     GIR_EraseRootFromParent_Done,
     /*  708170 */   // Label 11171: @708170
     /*  708170 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(708245), // Rule ID 11333 //
     /*  708175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  708186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  708189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  708192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  708195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  708224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708243 */     GIR_RootConstrainSelectedInstOperands,
     /*  708244 */     // GIR_Coverage, 11333,
     /*  708244 */     GIR_EraseRootFromParent_Done,
     /*  708245 */   // Label 11172: @708245
     /*  708245 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(708320), // Rule ID 11336 //
     /*  708250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  708299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708318 */     GIR_RootConstrainSelectedInstOperands,
     /*  708319 */     // GIR_Coverage, 11336,
     /*  708319 */     GIR_EraseRootFromParent_Done,
     /*  708320 */   // Label 11173: @708320
     /*  708320 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(708395), // Rule ID 11337 //
     /*  708325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  708336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  708339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  708342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  708345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  708374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708393 */     GIR_RootConstrainSelectedInstOperands,
     /*  708394 */     // GIR_Coverage, 11337,
     /*  708394 */     GIR_EraseRootFromParent_Done,
     /*  708395 */   // Label 11174: @708395
     /*  708395 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(708470), // Rule ID 11340 //
     /*  708400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  708411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  708414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  708417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  708420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708468 */     GIR_RootConstrainSelectedInstOperands,
     /*  708469 */     // GIR_Coverage, 11340,
     /*  708469 */     GIR_EraseRootFromParent_Done,
     /*  708470 */   // Label 11175: @708470
     /*  708470 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(708545), // Rule ID 11341 //
     /*  708475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  708486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  708489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  708492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  708495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  708524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708543 */     GIR_RootConstrainSelectedInstOperands,
     /*  708544 */     // GIR_Coverage, 11341,
     /*  708544 */     GIR_EraseRootFromParent_Done,
     /*  708545 */   // Label 11176: @708545
     /*  708545 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(708620), // Rule ID 11344 //
     /*  708550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  708561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  708564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  708567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  708599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708618 */     GIR_RootConstrainSelectedInstOperands,
     /*  708619 */     // GIR_Coverage, 11344,
     /*  708619 */     GIR_EraseRootFromParent_Done,
     /*  708620 */   // Label 11177: @708620
     /*  708620 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(708695), // Rule ID 11345 //
     /*  708625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  708636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  708639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  708642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  708674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708693 */     GIR_RootConstrainSelectedInstOperands,
     /*  708694 */     // GIR_Coverage, 11345,
     /*  708694 */     GIR_EraseRootFromParent_Done,
     /*  708695 */   // Label 11178: @708695
     /*  708695 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(708770), // Rule ID 11348 //
     /*  708700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  708749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708768 */     GIR_RootConstrainSelectedInstOperands,
     /*  708769 */     // GIR_Coverage, 11348,
     /*  708769 */     GIR_EraseRootFromParent_Done,
     /*  708770 */   // Label 11179: @708770
     /*  708770 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(708845), // Rule ID 11349 //
     /*  708775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  708786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  708789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  708792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  708824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708843 */     GIR_RootConstrainSelectedInstOperands,
     /*  708844 */     // GIR_Coverage, 11349,
     /*  708844 */     GIR_EraseRootFromParent_Done,
     /*  708845 */   // Label 11180: @708845
     /*  708845 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(708920), // Rule ID 11352 //
     /*  708850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  708870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  708899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708918 */     GIR_RootConstrainSelectedInstOperands,
     /*  708919 */     // GIR_Coverage, 11352,
     /*  708919 */     GIR_EraseRootFromParent_Done,
     /*  708920 */   // Label 11181: @708920
     /*  708920 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(708995), // Rule ID 11353 //
     /*  708925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  708933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  708936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  708939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  708942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  708945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  708964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  708974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708993 */     GIR_RootConstrainSelectedInstOperands,
     /*  708994 */     // GIR_Coverage, 11353,
     /*  708994 */     GIR_EraseRootFromParent_Done,
     /*  708995 */   // Label 11182: @708995
     /*  708995 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(709070), // Rule ID 11356 //
     /*  709000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  709049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709068 */     GIR_RootConstrainSelectedInstOperands,
     /*  709069 */     // GIR_Coverage, 11356,
     /*  709069 */     GIR_EraseRootFromParent_Done,
     /*  709070 */   // Label 11183: @709070
     /*  709070 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(709145), // Rule ID 11357 //
     /*  709075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  709086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  709089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  709092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  709124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709143 */     GIR_RootConstrainSelectedInstOperands,
     /*  709144 */     // GIR_Coverage, 11357,
     /*  709144 */     GIR_EraseRootFromParent_Done,
     /*  709145 */   // Label 11184: @709145
     /*  709145 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(709220), // Rule ID 11360 //
     /*  709150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709218 */     GIR_RootConstrainSelectedInstOperands,
     /*  709219 */     // GIR_Coverage, 11360,
     /*  709219 */     GIR_EraseRootFromParent_Done,
     /*  709220 */   // Label 11185: @709220
     /*  709220 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(709295), // Rule ID 11361 //
     /*  709225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  709236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  709239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  709242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709293 */     GIR_RootConstrainSelectedInstOperands,
     /*  709294 */     // GIR_Coverage, 11361,
     /*  709294 */     GIR_EraseRootFromParent_Done,
     /*  709295 */   // Label 11186: @709295
     /*  709295 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(709370), // Rule ID 11364 //
     /*  709300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  709311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  709314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  709317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709368 */     GIR_RootConstrainSelectedInstOperands,
     /*  709369 */     // GIR_Coverage, 11364,
     /*  709369 */     GIR_EraseRootFromParent_Done,
     /*  709370 */   // Label 11187: @709370
     /*  709370 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(709445), // Rule ID 11365 //
     /*  709375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  709386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  709389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  709392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  709424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709443 */     GIR_RootConstrainSelectedInstOperands,
     /*  709444 */     // GIR_Coverage, 11365,
     /*  709444 */     GIR_EraseRootFromParent_Done,
     /*  709445 */   // Label 11188: @709445
     /*  709445 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(709520), // Rule ID 11368 //
     /*  709450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  709461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  709464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  709467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709518 */     GIR_RootConstrainSelectedInstOperands,
     /*  709519 */     // GIR_Coverage, 11368,
     /*  709519 */     GIR_EraseRootFromParent_Done,
     /*  709520 */   // Label 11189: @709520
     /*  709520 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(709595), // Rule ID 11369 //
     /*  709525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  709536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  709539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  709542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709593 */     GIR_RootConstrainSelectedInstOperands,
     /*  709594 */     // GIR_Coverage, 11369,
     /*  709594 */     GIR_EraseRootFromParent_Done,
     /*  709595 */   // Label 11190: @709595
     /*  709595 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(709670), // Rule ID 11372 //
     /*  709600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709668 */     GIR_RootConstrainSelectedInstOperands,
     /*  709669 */     // GIR_Coverage, 11372,
     /*  709669 */     GIR_EraseRootFromParent_Done,
     /*  709670 */   // Label 11191: @709670
     /*  709670 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(709745), // Rule ID 11373 //
     /*  709675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  709686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  709689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  709692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709743 */     GIR_RootConstrainSelectedInstOperands,
     /*  709744 */     // GIR_Coverage, 11373,
     /*  709744 */     GIR_EraseRootFromParent_Done,
     /*  709745 */   // Label 11192: @709745
     /*  709745 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(709820), // Rule ID 11376 //
     /*  709750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709818 */     GIR_RootConstrainSelectedInstOperands,
     /*  709819 */     // GIR_Coverage, 11376,
     /*  709819 */     GIR_EraseRootFromParent_Done,
     /*  709820 */   // Label 11193: @709820
     /*  709820 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(709895), // Rule ID 11377 //
     /*  709825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  709836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  709839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  709842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  709874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709893 */     GIR_RootConstrainSelectedInstOperands,
     /*  709894 */     // GIR_Coverage, 11377,
     /*  709894 */     GIR_EraseRootFromParent_Done,
     /*  709895 */   // Label 11194: @709895
     /*  709895 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(709970), // Rule ID 11380 //
     /*  709900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  709949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709968 */     GIR_RootConstrainSelectedInstOperands,
     /*  709969 */     // GIR_Coverage, 11380,
     /*  709969 */     GIR_EraseRootFromParent_Done,
     /*  709970 */   // Label 11195: @709970
     /*  709970 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(710045), // Rule ID 11381 //
     /*  709975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  709983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  709986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  709989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  709992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710043 */     GIR_RootConstrainSelectedInstOperands,
     /*  710044 */     // GIR_Coverage, 11381,
     /*  710044 */     GIR_EraseRootFromParent_Done,
     /*  710045 */   // Label 11196: @710045
     /*  710045 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(710120), // Rule ID 11384 //
     /*  710050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  710061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  710064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  710067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710118 */     GIR_RootConstrainSelectedInstOperands,
     /*  710119 */     // GIR_Coverage, 11384,
     /*  710119 */     GIR_EraseRootFromParent_Done,
     /*  710120 */   // Label 11197: @710120
     /*  710120 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(710195), // Rule ID 11385 //
     /*  710125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  710136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  710139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  710142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710193 */     GIR_RootConstrainSelectedInstOperands,
     /*  710194 */     // GIR_Coverage, 11385,
     /*  710194 */     GIR_EraseRootFromParent_Done,
     /*  710195 */   // Label 11198: @710195
     /*  710195 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(710270), // Rule ID 11388 //
     /*  710200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  710211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  710214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  710217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710268 */     GIR_RootConstrainSelectedInstOperands,
     /*  710269 */     // GIR_Coverage, 11388,
     /*  710269 */     GIR_EraseRootFromParent_Done,
     /*  710270 */   // Label 11199: @710270
     /*  710270 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(710345), // Rule ID 11389 //
     /*  710275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  710286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  710289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  710292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710321 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710343 */     GIR_RootConstrainSelectedInstOperands,
     /*  710344 */     // GIR_Coverage, 11389,
     /*  710344 */     GIR_EraseRootFromParent_Done,
     /*  710345 */   // Label 11200: @710345
     /*  710345 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(710420), // Rule ID 11392 //
     /*  710350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710418 */     GIR_RootConstrainSelectedInstOperands,
     /*  710419 */     // GIR_Coverage, 11392,
     /*  710419 */     GIR_EraseRootFromParent_Done,
     /*  710420 */   // Label 11201: @710420
     /*  710420 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(710495), // Rule ID 11393 //
     /*  710425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  710436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  710439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  710442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710493 */     GIR_RootConstrainSelectedInstOperands,
     /*  710494 */     // GIR_Coverage, 11393,
     /*  710494 */     GIR_EraseRootFromParent_Done,
     /*  710495 */   // Label 11202: @710495
     /*  710495 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(710570), // Rule ID 11396 //
     /*  710500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710568 */     GIR_RootConstrainSelectedInstOperands,
     /*  710569 */     // GIR_Coverage, 11396,
     /*  710569 */     GIR_EraseRootFromParent_Done,
     /*  710570 */   // Label 11203: @710570
     /*  710570 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(710645), // Rule ID 11397 //
     /*  710575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  710586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  710589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  710592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710643 */     GIR_RootConstrainSelectedInstOperands,
     /*  710644 */     // GIR_Coverage, 11397,
     /*  710644 */     GIR_EraseRootFromParent_Done,
     /*  710645 */   // Label 11204: @710645
     /*  710645 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(710720), // Rule ID 11400 //
     /*  710650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710718 */     GIR_RootConstrainSelectedInstOperands,
     /*  710719 */     // GIR_Coverage, 11400,
     /*  710719 */     GIR_EraseRootFromParent_Done,
     /*  710720 */   // Label 11205: @710720
     /*  710720 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(710795), // Rule ID 11401 //
     /*  710725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  710736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  710739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  710742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  710774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710793 */     GIR_RootConstrainSelectedInstOperands,
     /*  710794 */     // GIR_Coverage, 11401,
     /*  710794 */     GIR_EraseRootFromParent_Done,
     /*  710795 */   // Label 11206: @710795
     /*  710795 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(710870), // Rule ID 11404 //
     /*  710800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710868 */     GIR_RootConstrainSelectedInstOperands,
     /*  710869 */     // GIR_Coverage, 11404,
     /*  710869 */     GIR_EraseRootFromParent_Done,
     /*  710870 */   // Label 11207: @710870
     /*  710870 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(710945), // Rule ID 11405 //
     /*  710875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  710886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  710889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  710892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  710924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710943 */     GIR_RootConstrainSelectedInstOperands,
     /*  710944 */     // GIR_Coverage, 11405,
     /*  710944 */     GIR_EraseRootFromParent_Done,
     /*  710945 */   // Label 11208: @710945
     /*  710945 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(711020), // Rule ID 11408 //
     /*  710950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  710958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  710961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  710964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  710967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  710985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  710999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711018 */     GIR_RootConstrainSelectedInstOperands,
     /*  711019 */     // GIR_Coverage, 11408,
     /*  711019 */     GIR_EraseRootFromParent_Done,
     /*  711020 */   // Label 11209: @711020
     /*  711020 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(711095), // Rule ID 11409 //
     /*  711025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  711036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  711039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  711042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711071 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  711074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711093 */     GIR_RootConstrainSelectedInstOperands,
     /*  711094 */     // GIR_Coverage, 11409,
     /*  711094 */     GIR_EraseRootFromParent_Done,
     /*  711095 */   // Label 11210: @711095
     /*  711095 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(711170), // Rule ID 11412 //
     /*  711100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  711149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711168 */     GIR_RootConstrainSelectedInstOperands,
     /*  711169 */     // GIR_Coverage, 11412,
     /*  711169 */     GIR_EraseRootFromParent_Done,
     /*  711170 */   // Label 11211: @711170
     /*  711170 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(711245), // Rule ID 11413 //
     /*  711175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  711183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  711186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  711189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  711192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711221 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  711224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711243 */     GIR_RootConstrainSelectedInstOperands,
     /*  711244 */     // GIR_Coverage, 11413,
     /*  711244 */     GIR_EraseRootFromParent_Done,
     /*  711245 */   // Label 11212: @711245
     /*  711245 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(711320), // Rule ID 11416 //
     /*  711250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  711261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  711264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  711267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  711270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  711299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711318 */     GIR_RootConstrainSelectedInstOperands,
     /*  711319 */     // GIR_Coverage, 11416,
     /*  711319 */     GIR_EraseRootFromParent_Done,
     /*  711320 */   // Label 11213: @711320
     /*  711320 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(711395), // Rule ID 11417 //
     /*  711325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  711336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  711339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  711342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  711345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  711374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711393 */     GIR_RootConstrainSelectedInstOperands,
     /*  711394 */     // GIR_Coverage, 11417,
     /*  711394 */     GIR_EraseRootFromParent_Done,
     /*  711395 */   // Label 11214: @711395
     /*  711395 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(711470), // Rule ID 11420 //
     /*  711400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  711411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  711414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  711420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711468 */     GIR_RootConstrainSelectedInstOperands,
     /*  711469 */     // GIR_Coverage, 11420,
     /*  711469 */     GIR_EraseRootFromParent_Done,
     /*  711470 */   // Label 11215: @711470
     /*  711470 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(711545), // Rule ID 11421 //
     /*  711475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  711486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  711489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  711492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  711495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711543 */     GIR_RootConstrainSelectedInstOperands,
     /*  711544 */     // GIR_Coverage, 11421,
     /*  711544 */     GIR_EraseRootFromParent_Done,
     /*  711545 */   // Label 11216: @711545
     /*  711545 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(711620), // Rule ID 11424 //
     /*  711550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  711561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  711564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  711567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  711570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711618 */     GIR_RootConstrainSelectedInstOperands,
     /*  711619 */     // GIR_Coverage, 11424,
     /*  711619 */     GIR_EraseRootFromParent_Done,
     /*  711620 */   // Label 11217: @711620
     /*  711620 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(711695), // Rule ID 11425 //
     /*  711625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  711636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  711639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  711642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  711645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711693 */     GIR_RootConstrainSelectedInstOperands,
     /*  711694 */     // GIR_Coverage, 11425,
     /*  711694 */     GIR_EraseRootFromParent_Done,
     /*  711695 */   // Label 11218: @711695
     /*  711695 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(711770), // Rule ID 11428 //
     /*  711700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  711720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711768 */     GIR_RootConstrainSelectedInstOperands,
     /*  711769 */     // GIR_Coverage, 11428,
     /*  711769 */     GIR_EraseRootFromParent_Done,
     /*  711770 */   // Label 11219: @711770
     /*  711770 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(711845), // Rule ID 11429 //
     /*  711775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  711786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  711789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  711792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  711795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  711824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711843 */     GIR_RootConstrainSelectedInstOperands,
     /*  711844 */     // GIR_Coverage, 11429,
     /*  711844 */     GIR_EraseRootFromParent_Done,
     /*  711845 */   // Label 11220: @711845
     /*  711845 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(711920), // Rule ID 11432 //
     /*  711850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  711870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711918 */     GIR_RootConstrainSelectedInstOperands,
     /*  711919 */     // GIR_Coverage, 11432,
     /*  711919 */     GIR_EraseRootFromParent_Done,
     /*  711920 */   // Label 11221: @711920
     /*  711920 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(711995), // Rule ID 11433 //
     /*  711925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  711936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  711939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  711942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  711945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  711974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711993 */     GIR_RootConstrainSelectedInstOperands,
     /*  711994 */     // GIR_Coverage, 11433,
     /*  711994 */     GIR_EraseRootFromParent_Done,
     /*  711995 */   // Label 11222: @711995
     /*  711995 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(712070), // Rule ID 11436 //
     /*  712000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  712011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  712014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  712020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  712049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712068 */     GIR_RootConstrainSelectedInstOperands,
     /*  712069 */     // GIR_Coverage, 11436,
     /*  712069 */     GIR_EraseRootFromParent_Done,
     /*  712070 */   // Label 11223: @712070
     /*  712070 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(712145), // Rule ID 11437 //
     /*  712075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  712086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  712089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  712092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  712095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  712124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712143 */     GIR_RootConstrainSelectedInstOperands,
     /*  712144 */     // GIR_Coverage, 11437,
     /*  712144 */     GIR_EraseRootFromParent_Done,
     /*  712145 */   // Label 11224: @712145
     /*  712145 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(712220), // Rule ID 11440 //
     /*  712150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712218 */     GIR_RootConstrainSelectedInstOperands,
     /*  712219 */     // GIR_Coverage, 11440,
     /*  712219 */     GIR_EraseRootFromParent_Done,
     /*  712220 */   // Label 11225: @712220
     /*  712220 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(712295), // Rule ID 11441 //
     /*  712225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  712236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  712239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  712242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  712245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712293 */     GIR_RootConstrainSelectedInstOperands,
     /*  712294 */     // GIR_Coverage, 11441,
     /*  712294 */     GIR_EraseRootFromParent_Done,
     /*  712295 */   // Label 11226: @712295
     /*  712295 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(712370), // Rule ID 11444 //
     /*  712300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712368 */     GIR_RootConstrainSelectedInstOperands,
     /*  712369 */     // GIR_Coverage, 11444,
     /*  712369 */     GIR_EraseRootFromParent_Done,
     /*  712370 */   // Label 11227: @712370
     /*  712370 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(712445), // Rule ID 11445 //
     /*  712375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  712386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  712389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  712392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  712395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712443 */     GIR_RootConstrainSelectedInstOperands,
     /*  712444 */     // GIR_Coverage, 11445,
     /*  712444 */     GIR_EraseRootFromParent_Done,
     /*  712445 */   // Label 11228: @712445
     /*  712445 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(712520), // Rule ID 11448 //
     /*  712450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  712467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712518 */     GIR_RootConstrainSelectedInstOperands,
     /*  712519 */     // GIR_Coverage, 11448,
     /*  712519 */     GIR_EraseRootFromParent_Done,
     /*  712520 */   // Label 11229: @712520
     /*  712520 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(712595), // Rule ID 11449 //
     /*  712525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  712536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  712539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  712542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  712545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  712574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712593 */     GIR_RootConstrainSelectedInstOperands,
     /*  712594 */     // GIR_Coverage, 11449,
     /*  712594 */     GIR_EraseRootFromParent_Done,
     /*  712595 */   // Label 11230: @712595
     /*  712595 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(712670), // Rule ID 11452 //
     /*  712600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  712620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712646 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  712649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712668 */     GIR_RootConstrainSelectedInstOperands,
     /*  712669 */     // GIR_Coverage, 11452,
     /*  712669 */     GIR_EraseRootFromParent_Done,
     /*  712670 */   // Label 11231: @712670
     /*  712670 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(712745), // Rule ID 11453 //
     /*  712675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  712686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  712689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  712692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  712695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  712724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712743 */     GIR_RootConstrainSelectedInstOperands,
     /*  712744 */     // GIR_Coverage, 11453,
     /*  712744 */     GIR_EraseRootFromParent_Done,
     /*  712745 */   // Label 11232: @712745
     /*  712745 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(712820), // Rule ID 11456 //
     /*  712750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  712770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  712799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712818 */     GIR_RootConstrainSelectedInstOperands,
     /*  712819 */     // GIR_Coverage, 11456,
     /*  712819 */     GIR_EraseRootFromParent_Done,
     /*  712820 */   // Label 11233: @712820
     /*  712820 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(712895), // Rule ID 11457 //
     /*  712825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  712836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  712839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  712842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  712845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712871 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  712871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  712874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712893 */     GIR_RootConstrainSelectedInstOperands,
     /*  712894 */     // GIR_Coverage, 11457,
     /*  712894 */     GIR_EraseRootFromParent_Done,
     /*  712895 */   // Label 11234: @712895
     /*  712895 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(712970), // Rule ID 11460 //
     /*  712900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  712920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  712946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  712949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  712965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712968 */     GIR_RootConstrainSelectedInstOperands,
     /*  712969 */     // GIR_Coverage, 11460,
     /*  712969 */     GIR_EraseRootFromParent_Done,
     /*  712970 */   // Label 11235: @712970
     /*  712970 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(713045), // Rule ID 11461 //
     /*  712975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  712986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  712989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  712992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  712995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713021 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  713021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  713040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713043 */     GIR_RootConstrainSelectedInstOperands,
     /*  713044 */     // GIR_Coverage, 11461,
     /*  713044 */     GIR_EraseRootFromParent_Done,
     /*  713045 */   // Label 11236: @713045
     /*  713045 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(713120), // Rule ID 11464 //
     /*  713050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  713061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  713064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  713070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713118 */     GIR_RootConstrainSelectedInstOperands,
     /*  713119 */     // GIR_Coverage, 11464,
     /*  713119 */     GIR_EraseRootFromParent_Done,
     /*  713120 */   // Label 11237: @713120
     /*  713120 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(713195), // Rule ID 11465 //
     /*  713125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  713136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  713139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  713142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  713145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713193 */     GIR_RootConstrainSelectedInstOperands,
     /*  713194 */     // GIR_Coverage, 11465,
     /*  713194 */     GIR_EraseRootFromParent_Done,
     /*  713195 */   // Label 11238: @713195
     /*  713195 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(713270), // Rule ID 11468 //
     /*  713200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  713211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  713214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  713220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713268 */     GIR_RootConstrainSelectedInstOperands,
     /*  713269 */     // GIR_Coverage, 11468,
     /*  713269 */     GIR_EraseRootFromParent_Done,
     /*  713270 */   // Label 11239: @713270
     /*  713270 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(713345), // Rule ID 11469 //
     /*  713275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  713286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  713289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  713292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  713295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713321 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713343 */     GIR_RootConstrainSelectedInstOperands,
     /*  713344 */     // GIR_Coverage, 11469,
     /*  713344 */     GIR_EraseRootFromParent_Done,
     /*  713345 */   // Label 11240: @713345
     /*  713345 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(713420), // Rule ID 11472 //
     /*  713350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  713361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  713364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  713367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  713370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  713396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713418 */     GIR_RootConstrainSelectedInstOperands,
     /*  713419 */     // GIR_Coverage, 11472,
     /*  713419 */     GIR_EraseRootFromParent_Done,
     /*  713420 */   // Label 11241: @713420
     /*  713420 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(713495), // Rule ID 11473 //
     /*  713425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  713436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  713439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  713442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  713445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713471 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  713471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  713490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713493 */     GIR_RootConstrainSelectedInstOperands,
     /*  713494 */     // GIR_Coverage, 11473,
     /*  713494 */     GIR_EraseRootFromParent_Done,
     /*  713495 */   // Label 11242: @713495
     /*  713495 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(713570), // Rule ID 11476 //
     /*  713500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  713511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  713514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  713517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  713520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713568 */     GIR_RootConstrainSelectedInstOperands,
     /*  713569 */     // GIR_Coverage, 11476,
     /*  713569 */     GIR_EraseRootFromParent_Done,
     /*  713570 */   // Label 11243: @713570
     /*  713570 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(713645), // Rule ID 11477 //
     /*  713575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  713586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  713589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  713592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  713595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  713624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713643 */     GIR_RootConstrainSelectedInstOperands,
     /*  713644 */     // GIR_Coverage, 11477,
     /*  713644 */     GIR_EraseRootFromParent_Done,
     /*  713645 */   // Label 11244: @713645
     /*  713645 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(713720), // Rule ID 11480 //
     /*  713650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  713670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713718 */     GIR_RootConstrainSelectedInstOperands,
     /*  713719 */     // GIR_Coverage, 11480,
     /*  713719 */     GIR_EraseRootFromParent_Done,
     /*  713720 */   // Label 11245: @713720
     /*  713720 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(713795), // Rule ID 11481 //
     /*  713725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  713736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  713739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  713742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  713745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713771 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  713774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713793 */     GIR_RootConstrainSelectedInstOperands,
     /*  713794 */     // GIR_Coverage, 11481,
     /*  713794 */     GIR_EraseRootFromParent_Done,
     /*  713795 */   // Label 11246: @713795
     /*  713795 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(713870), // Rule ID 11484 //
     /*  713800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  713820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  713846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713868 */     GIR_RootConstrainSelectedInstOperands,
     /*  713869 */     // GIR_Coverage, 11484,
     /*  713869 */     GIR_EraseRootFromParent_Done,
     /*  713870 */   // Label 11247: @713870
     /*  713870 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(713945), // Rule ID 11485 //
     /*  713875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  713878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  713886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  713889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  713892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  713895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713921 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  713921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  713924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  713940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713943 */     GIR_RootConstrainSelectedInstOperands,
     /*  713944 */     // GIR_Coverage, 11485,
     /*  713944 */     GIR_EraseRootFromParent_Done,
     /*  713945 */   // Label 11248: @713945
     /*  713945 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(714020), // Rule ID 11488 //
     /*  713950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  713953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  713958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  713961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  713964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  713967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  713996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  713999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714018 */     GIR_RootConstrainSelectedInstOperands,
     /*  714019 */     // GIR_Coverage, 11488,
     /*  714019 */     GIR_EraseRootFromParent_Done,
     /*  714020 */   // Label 11249: @714020
     /*  714020 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(714095), // Rule ID 11489 //
     /*  714025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  714036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  714039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  714042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714071 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  714074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714093 */     GIR_RootConstrainSelectedInstOperands,
     /*  714094 */     // GIR_Coverage, 11489,
     /*  714094 */     GIR_EraseRootFromParent_Done,
     /*  714095 */   // Label 11250: @714095
     /*  714095 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(714170), // Rule ID 11492 //
     /*  714100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  714111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  714114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  714117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714146 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714168 */     GIR_RootConstrainSelectedInstOperands,
     /*  714169 */     // GIR_Coverage, 11492,
     /*  714169 */     GIR_EraseRootFromParent_Done,
     /*  714170 */   // Label 11251: @714170
     /*  714170 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(714245), // Rule ID 11493 //
     /*  714175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  714186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  714189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  714192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714221 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714243 */     GIR_RootConstrainSelectedInstOperands,
     /*  714244 */     // GIR_Coverage, 11493,
     /*  714244 */     GIR_EraseRootFromParent_Done,
     /*  714245 */   // Label 11252: @714245
     /*  714245 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(714320), // Rule ID 11496 //
     /*  714250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  714261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  714264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  714267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714318 */     GIR_RootConstrainSelectedInstOperands,
     /*  714319 */     // GIR_Coverage, 11496,
     /*  714319 */     GIR_EraseRootFromParent_Done,
     /*  714320 */   // Label 11253: @714320
     /*  714320 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(714395), // Rule ID 11497 //
     /*  714325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  714336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  714339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  714342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714371 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714393 */     GIR_RootConstrainSelectedInstOperands,
     /*  714394 */     // GIR_Coverage, 11497,
     /*  714394 */     GIR_EraseRootFromParent_Done,
     /*  714395 */   // Label 11254: @714395
     /*  714395 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(714470), // Rule ID 11500 //
     /*  714400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  714411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  714414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  714417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  714446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714468 */     GIR_RootConstrainSelectedInstOperands,
     /*  714469 */     // GIR_Coverage, 11500,
     /*  714469 */     GIR_EraseRootFromParent_Done,
     /*  714470 */   // Label 11255: @714470
     /*  714470 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(714545), // Rule ID 11501 //
     /*  714475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  714486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  714489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  714492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  714521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  714524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714543 */     GIR_RootConstrainSelectedInstOperands,
     /*  714544 */     // GIR_Coverage, 11501,
     /*  714544 */     GIR_EraseRootFromParent_Done,
     /*  714545 */   // Label 11256: @714545
     /*  714545 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(714620), // Rule ID 11504 //
     /*  714550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  714561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  714564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  714567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  714596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714618 */     GIR_RootConstrainSelectedInstOperands,
     /*  714619 */     // GIR_Coverage, 11504,
     /*  714619 */     GIR_EraseRootFromParent_Done,
     /*  714620 */   // Label 11257: @714620
     /*  714620 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(714695), // Rule ID 11505 //
     /*  714625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  714636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  714639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  714642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  714671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  714690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714693 */     GIR_RootConstrainSelectedInstOperands,
     /*  714694 */     // GIR_Coverage, 11505,
     /*  714694 */     GIR_EraseRootFromParent_Done,
     /*  714695 */   // Label 11258: @714695
     /*  714695 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(714770), // Rule ID 11508 //
     /*  714700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  714711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  714714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  714717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  714746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714768 */     GIR_RootConstrainSelectedInstOperands,
     /*  714769 */     // GIR_Coverage, 11508,
     /*  714769 */     GIR_EraseRootFromParent_Done,
     /*  714770 */   // Label 11259: @714770
     /*  714770 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(714845), // Rule ID 11509 //
     /*  714775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  714786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  714789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  714792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714821 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  714821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  714824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  714840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714843 */     GIR_RootConstrainSelectedInstOperands,
     /*  714844 */     // GIR_Coverage, 11509,
     /*  714844 */     GIR_EraseRootFromParent_Done,
     /*  714845 */   // Label 11260: @714845
     /*  714845 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(714920), // Rule ID 11512 //
     /*  714850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  714853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  714861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  714864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  714867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  714896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  714899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714918 */     GIR_RootConstrainSelectedInstOperands,
     /*  714919 */     // GIR_Coverage, 11512,
     /*  714919 */     GIR_EraseRootFromParent_Done,
     /*  714920 */   // Label 11261: @714920
     /*  714920 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(714995), // Rule ID 11513 //
     /*  714925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  714928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  714936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  714939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  714942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  714971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  714974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  714990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714993 */     GIR_RootConstrainSelectedInstOperands,
     /*  714994 */     // GIR_Coverage, 11513,
     /*  714994 */     GIR_EraseRootFromParent_Done,
     /*  714995 */   // Label 11262: @714995
     /*  714995 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(715070), // Rule ID 11516 //
     /*  715000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  715017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715068 */     GIR_RootConstrainSelectedInstOperands,
     /*  715069 */     // GIR_Coverage, 11516,
     /*  715069 */     GIR_EraseRootFromParent_Done,
     /*  715070 */   // Label 11263: @715070
     /*  715070 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(715145), // Rule ID 11517 //
     /*  715075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  715086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  715089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  715092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715143 */     GIR_RootConstrainSelectedInstOperands,
     /*  715144 */     // GIR_Coverage, 11517,
     /*  715144 */     GIR_EraseRootFromParent_Done,
     /*  715145 */   // Label 11264: @715145
     /*  715145 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(715220), // Rule ID 11520 //
     /*  715150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  715167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  715196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715218 */     GIR_RootConstrainSelectedInstOperands,
     /*  715219 */     // GIR_Coverage, 11520,
     /*  715219 */     GIR_EraseRootFromParent_Done,
     /*  715220 */   // Label 11265: @715220
     /*  715220 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(715295), // Rule ID 11521 //
     /*  715225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  715236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  715239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  715242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715271 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  715271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  715290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715293 */     GIR_RootConstrainSelectedInstOperands,
     /*  715294 */     // GIR_Coverage, 11521,
     /*  715294 */     GIR_EraseRootFromParent_Done,
     /*  715295 */   // Label 11266: @715295
     /*  715295 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(715370), // Rule ID 11524 //
     /*  715300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  715311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  715314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  715317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715368 */     GIR_RootConstrainSelectedInstOperands,
     /*  715369 */     // GIR_Coverage, 11524,
     /*  715369 */     GIR_EraseRootFromParent_Done,
     /*  715370 */   // Label 11267: @715370
     /*  715370 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(715445), // Rule ID 11525 //
     /*  715375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  715386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  715389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  715392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715443 */     GIR_RootConstrainSelectedInstOperands,
     /*  715444 */     // GIR_Coverage, 11525,
     /*  715444 */     GIR_EraseRootFromParent_Done,
     /*  715445 */   // Label 11268: @715445
     /*  715445 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(715520), // Rule ID 11528 //
     /*  715450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  715461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  715464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  715467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715496 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715518 */     GIR_RootConstrainSelectedInstOperands,
     /*  715519 */     // GIR_Coverage, 11528,
     /*  715519 */     GIR_EraseRootFromParent_Done,
     /*  715520 */   // Label 11269: @715520
     /*  715520 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(715595), // Rule ID 11529 //
     /*  715525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  715536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  715539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  715542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715571 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715593 */     GIR_RootConstrainSelectedInstOperands,
     /*  715594 */     // GIR_Coverage, 11529,
     /*  715594 */     GIR_EraseRootFromParent_Done,
     /*  715595 */   // Label 11270: @715595
     /*  715595 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(715670), // Rule ID 11532 //
     /*  715600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  715611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  715614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  715617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715646 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715668 */     GIR_RootConstrainSelectedInstOperands,
     /*  715669 */     // GIR_Coverage, 11532,
     /*  715669 */     GIR_EraseRootFromParent_Done,
     /*  715670 */   // Label 11271: @715670
     /*  715670 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(715745), // Rule ID 11533 //
     /*  715675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  715686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  715689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  715692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715721 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  715721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715743 */     GIR_RootConstrainSelectedInstOperands,
     /*  715744 */     // GIR_Coverage, 11533,
     /*  715744 */     GIR_EraseRootFromParent_Done,
     /*  715745 */   // Label 11272: @715745
     /*  715745 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(715820), // Rule ID 11536 //
     /*  715750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  715761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  715764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  715767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715818 */     GIR_RootConstrainSelectedInstOperands,
     /*  715819 */     // GIR_Coverage, 11536,
     /*  715819 */     GIR_EraseRootFromParent_Done,
     /*  715820 */   // Label 11273: @715820
     /*  715820 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(715895), // Rule ID 11537 //
     /*  715825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  715836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  715839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  715842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715871 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  715871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715893 */     GIR_RootConstrainSelectedInstOperands,
     /*  715894 */     // GIR_Coverage, 11537,
     /*  715894 */     GIR_EraseRootFromParent_Done,
     /*  715895 */   // Label 11274: @715895
     /*  715895 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(715970), // Rule ID 11540 //
     /*  715900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  715911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  715914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  715917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  715946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  715965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715968 */     GIR_RootConstrainSelectedInstOperands,
     /*  715969 */     // GIR_Coverage, 11540,
     /*  715969 */     GIR_EraseRootFromParent_Done,
     /*  715970 */   // Label 11275: @715970
     /*  715970 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(716045), // Rule ID 11541 //
     /*  715975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  715986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  715989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  715992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716021 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716043 */     GIR_RootConstrainSelectedInstOperands,
     /*  716044 */     // GIR_Coverage, 11541,
     /*  716044 */     GIR_EraseRootFromParent_Done,
     /*  716045 */   // Label 11276: @716045
     /*  716045 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(716120), // Rule ID 11544 //
     /*  716050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  716061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  716064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  716067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716118 */     GIR_RootConstrainSelectedInstOperands,
     /*  716119 */     // GIR_Coverage, 11544,
     /*  716119 */     GIR_EraseRootFromParent_Done,
     /*  716120 */   // Label 11277: @716120
     /*  716120 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(716195), // Rule ID 11545 //
     /*  716125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  716136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  716139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  716142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716171 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716193 */     GIR_RootConstrainSelectedInstOperands,
     /*  716194 */     // GIR_Coverage, 11545,
     /*  716194 */     GIR_EraseRootFromParent_Done,
     /*  716195 */   // Label 11278: @716195
     /*  716195 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(716270), // Rule ID 11548 //
     /*  716200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  716211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  716214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  716217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716268 */     GIR_RootConstrainSelectedInstOperands,
     /*  716269 */     // GIR_Coverage, 11548,
     /*  716269 */     GIR_EraseRootFromParent_Done,
     /*  716270 */   // Label 11279: @716270
     /*  716270 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(716345), // Rule ID 11549 //
     /*  716275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  716286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  716289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  716292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716343 */     GIR_RootConstrainSelectedInstOperands,
     /*  716344 */     // GIR_Coverage, 11549,
     /*  716344 */     GIR_EraseRootFromParent_Done,
     /*  716345 */   // Label 11280: @716345
     /*  716345 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(716420), // Rule ID 11552 //
     /*  716350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  716361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  716364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  716367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716418 */     GIR_RootConstrainSelectedInstOperands,
     /*  716419 */     // GIR_Coverage, 11552,
     /*  716419 */     GIR_EraseRootFromParent_Done,
     /*  716420 */   // Label 11281: @716420
     /*  716420 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(716495), // Rule ID 11553 //
     /*  716425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  716436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  716439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  716442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716471 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716493 */     GIR_RootConstrainSelectedInstOperands,
     /*  716494 */     // GIR_Coverage, 11553,
     /*  716494 */     GIR_EraseRootFromParent_Done,
     /*  716495 */   // Label 11282: @716495
     /*  716495 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(716570), // Rule ID 11556 //
     /*  716500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  716511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  716514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  716517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716568 */     GIR_RootConstrainSelectedInstOperands,
     /*  716569 */     // GIR_Coverage, 11556,
     /*  716569 */     GIR_EraseRootFromParent_Done,
     /*  716570 */   // Label 11283: @716570
     /*  716570 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(716645), // Rule ID 11557 //
     /*  716575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  716586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  716589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  716592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716621 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716643 */     GIR_RootConstrainSelectedInstOperands,
     /*  716644 */     // GIR_Coverage, 11557,
     /*  716644 */     GIR_EraseRootFromParent_Done,
     /*  716645 */   // Label 11284: @716645
     /*  716645 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(716720), // Rule ID 11560 //
     /*  716650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  716699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716718 */     GIR_RootConstrainSelectedInstOperands,
     /*  716719 */     // GIR_Coverage, 11560,
     /*  716719 */     GIR_EraseRootFromParent_Done,
     /*  716720 */   // Label 11285: @716720
     /*  716720 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(716795), // Rule ID 11561 //
     /*  716725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  716736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  716739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  716742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  716745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  716774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716793 */     GIR_RootConstrainSelectedInstOperands,
     /*  716794 */     // GIR_Coverage, 11561,
     /*  716794 */     GIR_EraseRootFromParent_Done,
     /*  716795 */   // Label 11286: @716795
     /*  716795 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(716870), // Rule ID 11564 //
     /*  716800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  716820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  716849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716868 */     GIR_RootConstrainSelectedInstOperands,
     /*  716869 */     // GIR_Coverage, 11564,
     /*  716869 */     GIR_EraseRootFromParent_Done,
     /*  716870 */   // Label 11287: @716870
     /*  716870 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(716945), // Rule ID 11565 //
     /*  716875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  716895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  716924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716943 */     GIR_RootConstrainSelectedInstOperands,
     /*  716944 */     // GIR_Coverage, 11565,
     /*  716944 */     GIR_EraseRootFromParent_Done,
     /*  716945 */   // Label 11288: @716945
     /*  716945 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(717020), // Rule ID 11568 //
     /*  716950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  716958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  716970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  716999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717018 */     GIR_RootConstrainSelectedInstOperands,
     /*  717019 */     // GIR_Coverage, 11568,
     /*  717019 */     GIR_EraseRootFromParent_Done,
     /*  717020 */   // Label 11289: @717020
     /*  717020 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(717095), // Rule ID 11569 //
     /*  717025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  717045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  717074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717093 */     GIR_RootConstrainSelectedInstOperands,
     /*  717094 */     // GIR_Coverage, 11569,
     /*  717094 */     GIR_EraseRootFromParent_Done,
     /*  717095 */   // Label 11290: @717095
     /*  717095 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(717170), // Rule ID 11572 //
     /*  717100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  717120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  717149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717168 */     GIR_RootConstrainSelectedInstOperands,
     /*  717169 */     // GIR_Coverage, 11572,
     /*  717169 */     GIR_EraseRootFromParent_Done,
     /*  717170 */   // Label 11291: @717170
     /*  717170 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(717245), // Rule ID 11573 //
     /*  717175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  717195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  717224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717243 */     GIR_RootConstrainSelectedInstOperands,
     /*  717244 */     // GIR_Coverage, 11573,
     /*  717244 */     GIR_EraseRootFromParent_Done,
     /*  717245 */   // Label 11292: @717245
     /*  717245 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(717320), // Rule ID 11576 //
     /*  717250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  717299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717318 */     GIR_RootConstrainSelectedInstOperands,
     /*  717319 */     // GIR_Coverage, 11576,
     /*  717319 */     GIR_EraseRootFromParent_Done,
     /*  717320 */   // Label 11293: @717320
     /*  717320 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(717395), // Rule ID 11577 //
     /*  717325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  717374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717393 */     GIR_RootConstrainSelectedInstOperands,
     /*  717394 */     // GIR_Coverage, 11577,
     /*  717394 */     GIR_EraseRootFromParent_Done,
     /*  717395 */   // Label 11294: @717395
     /*  717395 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(717470), // Rule ID 11580 //
     /*  717400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  717411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  717414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  717449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717468 */     GIR_RootConstrainSelectedInstOperands,
     /*  717469 */     // GIR_Coverage, 11580,
     /*  717469 */     GIR_EraseRootFromParent_Done,
     /*  717470 */   // Label 11295: @717470
     /*  717470 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(717545), // Rule ID 11581 //
     /*  717475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  717486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  717489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  717492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  717524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717543 */     GIR_RootConstrainSelectedInstOperands,
     /*  717544 */     // GIR_Coverage, 11581,
     /*  717544 */     GIR_EraseRootFromParent_Done,
     /*  717545 */   // Label 11296: @717545
     /*  717545 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(717620), // Rule ID 11584 //
     /*  717550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  717599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717618 */     GIR_RootConstrainSelectedInstOperands,
     /*  717619 */     // GIR_Coverage, 11584,
     /*  717619 */     GIR_EraseRootFromParent_Done,
     /*  717620 */   // Label 11297: @717620
     /*  717620 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(717695), // Rule ID 11585 //
     /*  717625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  717636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  717639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  717642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  717674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717693 */     GIR_RootConstrainSelectedInstOperands,
     /*  717694 */     // GIR_Coverage, 11585,
     /*  717694 */     GIR_EraseRootFromParent_Done,
     /*  717695 */   // Label 11298: @717695
     /*  717695 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(717770), // Rule ID 11588 //
     /*  717700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  717720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  717749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717768 */     GIR_RootConstrainSelectedInstOperands,
     /*  717769 */     // GIR_Coverage, 11588,
     /*  717769 */     GIR_EraseRootFromParent_Done,
     /*  717770 */   // Label 11299: @717770
     /*  717770 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(717845), // Rule ID 11589 //
     /*  717775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  717783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  717786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  717789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  717792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  717795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  717814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  717824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717843 */     GIR_RootConstrainSelectedInstOperands,
     /*  717844 */     // GIR_Coverage, 11589,
     /*  717844 */     GIR_EraseRootFromParent_Done,
     /*  717845 */   // Label 11300: @717845
     /*  717845 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(717920), // Rule ID 11592 //
     /*  717850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  717853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  717858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  717899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717918 */     GIR_RootConstrainSelectedInstOperands,
     /*  717919 */     // GIR_Coverage, 11592,
     /*  717919 */     GIR_EraseRootFromParent_Done,
     /*  717920 */   // Label 11301: @717920
     /*  717920 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(717995), // Rule ID 11593 //
     /*  717925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  717928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  717933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717971 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  717974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717993 */     GIR_RootConstrainSelectedInstOperands,
     /*  717994 */     // GIR_Coverage, 11593,
     /*  717994 */     GIR_EraseRootFromParent_Done,
     /*  717995 */   // Label 11302: @717995
     /*  717995 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(718070), // Rule ID 11596 //
     /*  718000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  718049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718068 */     GIR_RootConstrainSelectedInstOperands,
     /*  718069 */     // GIR_Coverage, 11596,
     /*  718069 */     GIR_EraseRootFromParent_Done,
     /*  718070 */   // Label 11303: @718070
     /*  718070 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(718145), // Rule ID 11597 //
     /*  718075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  718124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718143 */     GIR_RootConstrainSelectedInstOperands,
     /*  718144 */     // GIR_Coverage, 11597,
     /*  718144 */     GIR_EraseRootFromParent_Done,
     /*  718145 */   // Label 11304: @718145
     /*  718145 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(718220), // Rule ID 11600 //
     /*  718150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  718199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718218 */     GIR_RootConstrainSelectedInstOperands,
     /*  718219 */     // GIR_Coverage, 11600,
     /*  718219 */     GIR_EraseRootFromParent_Done,
     /*  718220 */   // Label 11305: @718220
     /*  718220 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(718295), // Rule ID 11601 //
     /*  718225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  718274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718293 */     GIR_RootConstrainSelectedInstOperands,
     /*  718294 */     // GIR_Coverage, 11601,
     /*  718294 */     GIR_EraseRootFromParent_Done,
     /*  718295 */   // Label 11306: @718295
     /*  718295 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(718370), // Rule ID 11604 //
     /*  718300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  718320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  718349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718368 */     GIR_RootConstrainSelectedInstOperands,
     /*  718369 */     // GIR_Coverage, 11604,
     /*  718369 */     GIR_EraseRootFromParent_Done,
     /*  718370 */   // Label 11307: @718370
     /*  718370 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(718445), // Rule ID 11605 //
     /*  718375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  718395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  718424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718443 */     GIR_RootConstrainSelectedInstOperands,
     /*  718444 */     // GIR_Coverage, 11605,
     /*  718444 */     GIR_EraseRootFromParent_Done,
     /*  718445 */   // Label 11308: @718445
     /*  718445 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(718520), // Rule ID 11608 //
     /*  718450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  718499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718518 */     GIR_RootConstrainSelectedInstOperands,
     /*  718519 */     // GIR_Coverage, 11608,
     /*  718519 */     GIR_EraseRootFromParent_Done,
     /*  718520 */   // Label 11309: @718520
     /*  718520 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(718595), // Rule ID 11609 //
     /*  718525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  718536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  718539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  718542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  718560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  718574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718593 */     GIR_RootConstrainSelectedInstOperands,
     /*  718594 */     // GIR_Coverage, 11609,
     /*  718594 */     GIR_EraseRootFromParent_Done,
     /*  718595 */   // Label 11310: @718595
     /*  718595 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(718670), // Rule ID 11612 //
     /*  718600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  718649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718668 */     GIR_RootConstrainSelectedInstOperands,
     /*  718669 */     // GIR_Coverage, 11612,
     /*  718669 */     GIR_EraseRootFromParent_Done,
     /*  718670 */   // Label 11311: @718670
     /*  718670 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(718745), // Rule ID 11613 //
     /*  718675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  718724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718743 */     GIR_RootConstrainSelectedInstOperands,
     /*  718744 */     // GIR_Coverage, 11613,
     /*  718744 */     GIR_EraseRootFromParent_Done,
     /*  718745 */   // Label 11312: @718745
     /*  718745 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(718820), // Rule ID 11616 //
     /*  718750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  718799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718818 */     GIR_RootConstrainSelectedInstOperands,
     /*  718819 */     // GIR_Coverage, 11616,
     /*  718819 */     GIR_EraseRootFromParent_Done,
     /*  718820 */   // Label 11313: @718820
     /*  718820 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(718895), // Rule ID 11617 //
     /*  718825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  718874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718893 */     GIR_RootConstrainSelectedInstOperands,
     /*  718894 */     // GIR_Coverage, 11617,
     /*  718894 */     GIR_EraseRootFromParent_Done,
     /*  718895 */   // Label 11314: @718895
     /*  718895 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(718970), // Rule ID 11620 //
     /*  718900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  718903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  718920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  718939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  718949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718968 */     GIR_RootConstrainSelectedInstOperands,
     /*  718969 */     // GIR_Coverage, 11620,
     /*  718969 */     GIR_EraseRootFromParent_Done,
     /*  718970 */   // Label 11315: @718970
     /*  718970 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(719045), // Rule ID 11621 //
     /*  718975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  718978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  718983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  718986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  718989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  718992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  718995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  719024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719043 */     GIR_RootConstrainSelectedInstOperands,
     /*  719044 */     // GIR_Coverage, 11621,
     /*  719044 */     GIR_EraseRootFromParent_Done,
     /*  719045 */   // Label 11316: @719045
     /*  719045 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(719120), // Rule ID 11624 //
     /*  719050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  719099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719118 */     GIR_RootConstrainSelectedInstOperands,
     /*  719119 */     // GIR_Coverage, 11624,
     /*  719119 */     GIR_EraseRootFromParent_Done,
     /*  719120 */   // Label 11317: @719120
     /*  719120 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(719195), // Rule ID 11625 //
     /*  719125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  719145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  719174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719193 */     GIR_RootConstrainSelectedInstOperands,
     /*  719194 */     // GIR_Coverage, 11625,
     /*  719194 */     GIR_EraseRootFromParent_Done,
     /*  719195 */   // Label 11318: @719195
     /*  719195 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(719270), // Rule ID 11628 //
     /*  719200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  719249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719268 */     GIR_RootConstrainSelectedInstOperands,
     /*  719269 */     // GIR_Coverage, 11628,
     /*  719269 */     GIR_EraseRootFromParent_Done,
     /*  719270 */   // Label 11319: @719270
     /*  719270 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(719345), // Rule ID 11629 //
     /*  719275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  719324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719343 */     GIR_RootConstrainSelectedInstOperands,
     /*  719344 */     // GIR_Coverage, 11629,
     /*  719344 */     GIR_EraseRootFromParent_Done,
     /*  719345 */   // Label 11320: @719345
     /*  719345 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(719420), // Rule ID 11632 //
     /*  719350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  719399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719418 */     GIR_RootConstrainSelectedInstOperands,
     /*  719419 */     // GIR_Coverage, 11632,
     /*  719419 */     GIR_EraseRootFromParent_Done,
     /*  719420 */   // Label 11321: @719420
     /*  719420 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(719495), // Rule ID 11633 //
     /*  719425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  719474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719493 */     GIR_RootConstrainSelectedInstOperands,
     /*  719494 */     // GIR_Coverage, 11633,
     /*  719494 */     GIR_EraseRootFromParent_Done,
     /*  719495 */   // Label 11322: @719495
     /*  719495 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(719570), // Rule ID 11636 //
     /*  719500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  719549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719568 */     GIR_RootConstrainSelectedInstOperands,
     /*  719569 */     // GIR_Coverage, 11636,
     /*  719569 */     GIR_EraseRootFromParent_Done,
     /*  719570 */   // Label 11323: @719570
     /*  719570 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(719645), // Rule ID 11637 //
     /*  719575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  719624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719643 */     GIR_RootConstrainSelectedInstOperands,
     /*  719644 */     // GIR_Coverage, 11637,
     /*  719644 */     GIR_EraseRootFromParent_Done,
     /*  719645 */   // Label 11324: @719645
     /*  719645 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(719720), // Rule ID 11640 //
     /*  719650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  719699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719718 */     GIR_RootConstrainSelectedInstOperands,
     /*  719719 */     // GIR_Coverage, 11640,
     /*  719719 */     GIR_EraseRootFromParent_Done,
     /*  719720 */   // Label 11325: @719720
     /*  719720 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(719795), // Rule ID 11641 //
     /*  719725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  719736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  719739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  719742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719771 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  719774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719793 */     GIR_RootConstrainSelectedInstOperands,
     /*  719794 */     // GIR_Coverage, 11641,
     /*  719794 */     GIR_EraseRootFromParent_Done,
     /*  719795 */   // Label 11326: @719795
     /*  719795 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(719870), // Rule ID 11644 //
     /*  719800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  719849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719868 */     GIR_RootConstrainSelectedInstOperands,
     /*  719869 */     // GIR_Coverage, 11644,
     /*  719869 */     GIR_EraseRootFromParent_Done,
     /*  719870 */   // Label 11327: @719870
     /*  719870 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(719945), // Rule ID 11645 //
     /*  719875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  719878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11412:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  719924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719943 */     GIR_RootConstrainSelectedInstOperands,
     /*  719944 */     // GIR_Coverage, 11645,
     /*  719944 */     GIR_EraseRootFromParent_Done,
     /*  719945 */   // Label 11328: @719945
     /*  719945 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(720020), // Rule ID 11648 //
     /*  719950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  719953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  719958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  719999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720018 */     GIR_RootConstrainSelectedInstOperands,
     /*  720019 */     // GIR_Coverage, 11648,
     /*  720019 */     GIR_EraseRootFromParent_Done,
     /*  720020 */   // Label 11329: @720020
     /*  720020 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(720095), // Rule ID 11649 //
     /*  720025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  720028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  720036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  720039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  720042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720071 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11412:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  720074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720093 */     GIR_RootConstrainSelectedInstOperands,
     /*  720094 */     // GIR_Coverage, 11649,
     /*  720094 */     GIR_EraseRootFromParent_Done,
     /*  720095 */   // Label 11330: @720095
     /*  720095 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(720170), // Rule ID 11652 //
     /*  720100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  720103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  720146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  720149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720168 */     GIR_RootConstrainSelectedInstOperands,
     /*  720169 */     // GIR_Coverage, 11652,
     /*  720169 */     GIR_EraseRootFromParent_Done,
     /*  720170 */   // Label 11331: @720170
     /*  720170 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(720245), // Rule ID 11653 //
     /*  720175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  720178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  720183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  720186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  720189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  720192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  720210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720221 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11412:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  720224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720243 */     GIR_RootConstrainSelectedInstOperands,
     /*  720244 */     // GIR_Coverage, 11653,
     /*  720244 */     GIR_EraseRootFromParent_Done,
     /*  720245 */   // Label 11332: @720245
     /*  720245 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(720320), // Rule ID 11656 //
     /*  720250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  720270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  720299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720318 */     GIR_RootConstrainSelectedInstOperands,
     /*  720319 */     // GIR_Coverage, 11656,
     /*  720319 */     GIR_EraseRootFromParent_Done,
     /*  720320 */   // Label 11333: @720320
     /*  720320 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(720395), // Rule ID 11657 //
     /*  720325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  720336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  720339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  720342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  720345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  720374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720393 */     GIR_RootConstrainSelectedInstOperands,
     /*  720394 */     // GIR_Coverage, 11657,
     /*  720394 */     GIR_EraseRootFromParent_Done,
     /*  720395 */   // Label 11334: @720395
     /*  720395 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(720470), // Rule ID 11660 //
     /*  720400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  720420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  720449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720468 */     GIR_RootConstrainSelectedInstOperands,
     /*  720469 */     // GIR_Coverage, 11660,
     /*  720469 */     GIR_EraseRootFromParent_Done,
     /*  720470 */   // Label 11335: @720470
     /*  720470 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(720545), // Rule ID 11661 //
     /*  720475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  720486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  720489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  720492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  720495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  720524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720543 */     GIR_RootConstrainSelectedInstOperands,
     /*  720544 */     // GIR_Coverage, 11661,
     /*  720544 */     GIR_EraseRootFromParent_Done,
     /*  720545 */   // Label 11336: @720545
     /*  720545 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(720620), // Rule ID 11664 //
     /*  720550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  720570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720596 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  720599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720618 */     GIR_RootConstrainSelectedInstOperands,
     /*  720619 */     // GIR_Coverage, 11664,
     /*  720619 */     GIR_EraseRootFromParent_Done,
     /*  720620 */   // Label 11337: @720620
     /*  720620 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(720695), // Rule ID 11665 //
     /*  720625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  720645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  720674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720693 */     GIR_RootConstrainSelectedInstOperands,
     /*  720694 */     // GIR_Coverage, 11665,
     /*  720694 */     GIR_EraseRootFromParent_Done,
     /*  720695 */   // Label 11338: @720695
     /*  720695 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(720770), // Rule ID 11668 //
     /*  720700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  720720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  720749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720768 */     GIR_RootConstrainSelectedInstOperands,
     /*  720769 */     // GIR_Coverage, 11668,
     /*  720769 */     GIR_EraseRootFromParent_Done,
     /*  720770 */   // Label 11339: @720770
     /*  720770 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(720845), // Rule ID 11669 //
     /*  720775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  720795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720821 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  720824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720843 */     GIR_RootConstrainSelectedInstOperands,
     /*  720844 */     // GIR_Coverage, 11669,
     /*  720844 */     GIR_EraseRootFromParent_Done,
     /*  720845 */   // Label 11340: @720845
     /*  720845 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(720920), // Rule ID 11672 //
     /*  720850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  720870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  720899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720918 */     GIR_RootConstrainSelectedInstOperands,
     /*  720919 */     // GIR_Coverage, 11672,
     /*  720919 */     GIR_EraseRootFromParent_Done,
     /*  720920 */   // Label 11341: @720920
     /*  720920 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(720995), // Rule ID 11673 //
     /*  720925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  720945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  720974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720993 */     GIR_RootConstrainSelectedInstOperands,
     /*  720994 */     // GIR_Coverage, 11673,
     /*  720994 */     GIR_EraseRootFromParent_Done,
     /*  720995 */   // Label 11342: @720995
     /*  720995 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(721070), // Rule ID 11676 //
     /*  721000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  721020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  721049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721068 */     GIR_RootConstrainSelectedInstOperands,
     /*  721069 */     // GIR_Coverage, 11676,
     /*  721069 */     GIR_EraseRootFromParent_Done,
     /*  721070 */   // Label 11343: @721070
     /*  721070 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(721145), // Rule ID 11677 //
     /*  721075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  721086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  721089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  721092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  721095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  721124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721143 */     GIR_RootConstrainSelectedInstOperands,
     /*  721144 */     // GIR_Coverage, 11677,
     /*  721144 */     GIR_EraseRootFromParent_Done,
     /*  721145 */   // Label 11344: @721145
     /*  721145 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(721220), // Rule ID 11680 //
     /*  721150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  721199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721218 */     GIR_RootConstrainSelectedInstOperands,
     /*  721219 */     // GIR_Coverage, 11680,
     /*  721219 */     GIR_EraseRootFromParent_Done,
     /*  721220 */   // Label 11345: @721220
     /*  721220 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(721295), // Rule ID 11681 //
     /*  721225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  721236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  721239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  721242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  721245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721271 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  721274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721293 */     GIR_RootConstrainSelectedInstOperands,
     /*  721294 */     // GIR_Coverage, 11681,
     /*  721294 */     GIR_EraseRootFromParent_Done,
     /*  721295 */   // Label 11346: @721295
     /*  721295 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(721370), // Rule ID 11684 //
     /*  721300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  721320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  721349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721368 */     GIR_RootConstrainSelectedInstOperands,
     /*  721369 */     // GIR_Coverage, 11684,
     /*  721369 */     GIR_EraseRootFromParent_Done,
     /*  721370 */   // Label 11347: @721370
     /*  721370 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(721445), // Rule ID 11685 //
     /*  721375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  721386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  721389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  721392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  721395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721421 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  721424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721443 */     GIR_RootConstrainSelectedInstOperands,
     /*  721444 */     // GIR_Coverage, 11685,
     /*  721444 */     GIR_EraseRootFromParent_Done,
     /*  721445 */   // Label 11348: @721445
     /*  721445 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(721520), // Rule ID 11688 //
     /*  721450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  721499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721518 */     GIR_RootConstrainSelectedInstOperands,
     /*  721519 */     // GIR_Coverage, 11688,
     /*  721519 */     GIR_EraseRootFromParent_Done,
     /*  721520 */   // Label 11349: @721520
     /*  721520 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(721595), // Rule ID 11689 //
     /*  721525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  721536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  721539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  721542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  721545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  721574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721593 */     GIR_RootConstrainSelectedInstOperands,
     /*  721594 */     // GIR_Coverage, 11689,
     /*  721594 */     GIR_EraseRootFromParent_Done,
     /*  721595 */   // Label 11350: @721595
     /*  721595 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(721670), // Rule ID 11692 //
     /*  721600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  721649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721668 */     GIR_RootConstrainSelectedInstOperands,
     /*  721669 */     // GIR_Coverage, 11692,
     /*  721669 */     GIR_EraseRootFromParent_Done,
     /*  721670 */   // Label 11351: @721670
     /*  721670 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(721745), // Rule ID 11693 //
     /*  721675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  721695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721721 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  721724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721743 */     GIR_RootConstrainSelectedInstOperands,
     /*  721744 */     // GIR_Coverage, 11693,
     /*  721744 */     GIR_EraseRootFromParent_Done,
     /*  721745 */   // Label 11352: @721745
     /*  721745 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(721820), // Rule ID 11696 //
     /*  721750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  721770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  721799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721818 */     GIR_RootConstrainSelectedInstOperands,
     /*  721819 */     // GIR_Coverage, 11696,
     /*  721819 */     GIR_EraseRootFromParent_Done,
     /*  721820 */   // Label 11353: @721820
     /*  721820 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(721895), // Rule ID 11697 //
     /*  721825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  721845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721871 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  721874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721893 */     GIR_RootConstrainSelectedInstOperands,
     /*  721894 */     // GIR_Coverage, 11697,
     /*  721894 */     GIR_EraseRootFromParent_Done,
     /*  721895 */   // Label 11354: @721895
     /*  721895 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(721970), // Rule ID 11700 //
     /*  721900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  721920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  721949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721968 */     GIR_RootConstrainSelectedInstOperands,
     /*  721969 */     // GIR_Coverage, 11700,
     /*  721969 */     GIR_EraseRootFromParent_Done,
     /*  721970 */   // Label 11355: @721970
     /*  721970 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(722045), // Rule ID 11701 //
     /*  721975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  721995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722021 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  722024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722043 */     GIR_RootConstrainSelectedInstOperands,
     /*  722044 */     // GIR_Coverage, 11701,
     /*  722044 */     GIR_EraseRootFromParent_Done,
     /*  722045 */   // Label 11356: @722045
     /*  722045 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(722120), // Rule ID 11704 //
     /*  722050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  722070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722096 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  722099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722118 */     GIR_RootConstrainSelectedInstOperands,
     /*  722119 */     // GIR_Coverage, 11704,
     /*  722119 */     GIR_EraseRootFromParent_Done,
     /*  722120 */   // Label 11357: @722120
     /*  722120 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(722195), // Rule ID 11705 //
     /*  722125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  722136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  722139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  722142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  722145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722171 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  722174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722193 */     GIR_RootConstrainSelectedInstOperands,
     /*  722194 */     // GIR_Coverage, 11705,
     /*  722194 */     GIR_EraseRootFromParent_Done,
     /*  722195 */   // Label 11358: @722195
     /*  722195 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(722270), // Rule ID 11708 //
     /*  722200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  722220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  722249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722268 */     GIR_RootConstrainSelectedInstOperands,
     /*  722269 */     // GIR_Coverage, 11708,
     /*  722269 */     GIR_EraseRootFromParent_Done,
     /*  722270 */   // Label 11359: @722270
     /*  722270 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(722345), // Rule ID 11709 //
     /*  722275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  722286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  722289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  722292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  722295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  722324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722343 */     GIR_RootConstrainSelectedInstOperands,
     /*  722344 */     // GIR_Coverage, 11709,
     /*  722344 */     GIR_EraseRootFromParent_Done,
     /*  722345 */   // Label 11360: @722345
     /*  722345 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(722420), // Rule ID 11712 //
     /*  722350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  722370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  722399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722418 */     GIR_RootConstrainSelectedInstOperands,
     /*  722419 */     // GIR_Coverage, 11712,
     /*  722419 */     GIR_EraseRootFromParent_Done,
     /*  722420 */   // Label 11361: @722420
     /*  722420 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(722495), // Rule ID 11713 //
     /*  722425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  722436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  722439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  722442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  722445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722471 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  722474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722493 */     GIR_RootConstrainSelectedInstOperands,
     /*  722494 */     // GIR_Coverage, 11713,
     /*  722494 */     GIR_EraseRootFromParent_Done,
     /*  722495 */   // Label 11362: @722495
     /*  722495 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(722570), // Rule ID 11716 //
     /*  722500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  722520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  722549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722568 */     GIR_RootConstrainSelectedInstOperands,
     /*  722569 */     // GIR_Coverage, 11716,
     /*  722569 */     GIR_EraseRootFromParent_Done,
     /*  722570 */   // Label 11363: @722570
     /*  722570 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(722645), // Rule ID 11717 //
     /*  722575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  722595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  722624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722643 */     GIR_RootConstrainSelectedInstOperands,
     /*  722644 */     // GIR_Coverage, 11717,
     /*  722644 */     GIR_EraseRootFromParent_Done,
     /*  722645 */   // Label 11364: @722645
     /*  722645 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(722720), // Rule ID 11720 //
     /*  722650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  722670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  722699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722718 */     GIR_RootConstrainSelectedInstOperands,
     /*  722719 */     // GIR_Coverage, 11720,
     /*  722719 */     GIR_EraseRootFromParent_Done,
     /*  722720 */   // Label 11365: @722720
     /*  722720 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(722795), // Rule ID 11721 //
     /*  722725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  722745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  722774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722793 */     GIR_RootConstrainSelectedInstOperands,
     /*  722794 */     // GIR_Coverage, 11721,
     /*  722794 */     GIR_EraseRootFromParent_Done,
     /*  722795 */   // Label 11366: @722795
     /*  722795 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(722870), // Rule ID 11724 //
     /*  722800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  722820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  722849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722868 */     GIR_RootConstrainSelectedInstOperands,
     /*  722869 */     // GIR_Coverage, 11724,
     /*  722869 */     GIR_EraseRootFromParent_Done,
     /*  722870 */   // Label 11367: @722870
     /*  722870 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(722945), // Rule ID 11725 //
     /*  722875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  722895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  722924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722943 */     GIR_RootConstrainSelectedInstOperands,
     /*  722944 */     // GIR_Coverage, 11725,
     /*  722944 */     GIR_EraseRootFromParent_Done,
     /*  722945 */   // Label 11368: @722945
     /*  722945 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(723020), // Rule ID 11728 //
     /*  722950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  722970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  722999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723018 */     GIR_RootConstrainSelectedInstOperands,
     /*  723019 */     // GIR_Coverage, 11728,
     /*  723019 */     GIR_EraseRootFromParent_Done,
     /*  723020 */   // Label 11369: @723020
     /*  723020 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(723095), // Rule ID 11729 //
     /*  723025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  723036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  723039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  723042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  723045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723071 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  723074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723093 */     GIR_RootConstrainSelectedInstOperands,
     /*  723094 */     // GIR_Coverage, 11729,
     /*  723094 */     GIR_EraseRootFromParent_Done,
     /*  723095 */   // Label 11370: @723095
     /*  723095 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(723170), // Rule ID 11732 //
     /*  723100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  723120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  723149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723168 */     GIR_RootConstrainSelectedInstOperands,
     /*  723169 */     // GIR_Coverage, 11732,
     /*  723169 */     GIR_EraseRootFromParent_Done,
     /*  723170 */   // Label 11371: @723170
     /*  723170 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(723245), // Rule ID 11733 //
     /*  723175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  723186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  723189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  723192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  723195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  723214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  723224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723243 */     GIR_RootConstrainSelectedInstOperands,
     /*  723244 */     // GIR_Coverage, 11733,
     /*  723244 */     GIR_EraseRootFromParent_Done,
     /*  723245 */   // Label 11372: @723245
     /*  723245 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(723320), // Rule ID 11736 //
     /*  723250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  723270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  723299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723318 */     GIR_RootConstrainSelectedInstOperands,
     /*  723319 */     // GIR_Coverage, 11736,
     /*  723319 */     GIR_EraseRootFromParent_Done,
     /*  723320 */   // Label 11373: @723320
     /*  723320 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(723395), // Rule ID 11737 //
     /*  723325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  723336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  723339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  723342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  723345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  723364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723371 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  723374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723393 */     GIR_RootConstrainSelectedInstOperands,
     /*  723394 */     // GIR_Coverage, 11737,
     /*  723394 */     GIR_EraseRootFromParent_Done,
     /*  723395 */   // Label 11374: @723395
     /*  723395 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(723470), // Rule ID 11740 //
     /*  723400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  723420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723446 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  723449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723468 */     GIR_RootConstrainSelectedInstOperands,
     /*  723469 */     // GIR_Coverage, 11740,
     /*  723469 */     GIR_EraseRootFromParent_Done,
     /*  723470 */   // Label 11375: @723470
     /*  723470 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(723545), // Rule ID 11741 //
     /*  723475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  723486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  723489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  723492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  723495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  723514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  723524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723543 */     GIR_RootConstrainSelectedInstOperands,
     /*  723544 */     // GIR_Coverage, 11741,
     /*  723544 */     GIR_EraseRootFromParent_Done,
     /*  723545 */   // Label 11376: @723545
     /*  723545 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(723620), // Rule ID 11744 //
     /*  723550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  723599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723618 */     GIR_RootConstrainSelectedInstOperands,
     /*  723619 */     // GIR_Coverage, 11744,
     /*  723619 */     GIR_EraseRootFromParent_Done,
     /*  723620 */   // Label 11377: @723620
     /*  723620 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(723695), // Rule ID 11745 //
     /*  723625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723671 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  723674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723693 */     GIR_RootConstrainSelectedInstOperands,
     /*  723694 */     // GIR_Coverage, 11745,
     /*  723694 */     GIR_EraseRootFromParent_Done,
     /*  723695 */   // Label 11378: @723695
     /*  723695 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(723770), // Rule ID 11748 //
     /*  723700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  723749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723768 */     GIR_RootConstrainSelectedInstOperands,
     /*  723769 */     // GIR_Coverage, 11748,
     /*  723769 */     GIR_EraseRootFromParent_Done,
     /*  723770 */   // Label 11379: @723770
     /*  723770 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(723845), // Rule ID 11749 //
     /*  723775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723821 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  723824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723843 */     GIR_RootConstrainSelectedInstOperands,
     /*  723844 */     // GIR_Coverage, 11749,
     /*  723844 */     GIR_EraseRootFromParent_Done,
     /*  723845 */   // Label 11380: @723845
     /*  723845 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(723920), // Rule ID 11752 //
     /*  723850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  723870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  723899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723918 */     GIR_RootConstrainSelectedInstOperands,
     /*  723919 */     // GIR_Coverage, 11752,
     /*  723919 */     GIR_EraseRootFromParent_Done,
     /*  723920 */   // Label 11381: @723920
     /*  723920 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(723995), // Rule ID 11753 //
     /*  723925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  723933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  723945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  723964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  723974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723993 */     GIR_RootConstrainSelectedInstOperands,
     /*  723994 */     // GIR_Coverage, 11753,
     /*  723994 */     GIR_EraseRootFromParent_Done,
     /*  723995 */   // Label 11382: @723995
     /*  723995 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(724070), // Rule ID 11756 //
     /*  724000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  724049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724068 */     GIR_RootConstrainSelectedInstOperands,
     /*  724069 */     // GIR_Coverage, 11756,
     /*  724069 */     GIR_EraseRootFromParent_Done,
     /*  724070 */   // Label 11383: @724070
     /*  724070 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(724145), // Rule ID 11757 //
     /*  724075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  724086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  724089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  724092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  724124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724143 */     GIR_RootConstrainSelectedInstOperands,
     /*  724144 */     // GIR_Coverage, 11757,
     /*  724144 */     GIR_EraseRootFromParent_Done,
     /*  724145 */   // Label 11384: @724145
     /*  724145 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(724220), // Rule ID 11760 //
     /*  724150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  724199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724218 */     GIR_RootConstrainSelectedInstOperands,
     /*  724219 */     // GIR_Coverage, 11760,
     /*  724219 */     GIR_EraseRootFromParent_Done,
     /*  724220 */   // Label 11385: @724220
     /*  724220 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(724295), // Rule ID 11761 //
     /*  724225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  724236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  724239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  724242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724271 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  724274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724293 */     GIR_RootConstrainSelectedInstOperands,
     /*  724294 */     // GIR_Coverage, 11761,
     /*  724294 */     GIR_EraseRootFromParent_Done,
     /*  724295 */   // Label 11386: @724295
     /*  724295 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(724370), // Rule ID 11764 //
     /*  724300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  724349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724368 */     GIR_RootConstrainSelectedInstOperands,
     /*  724369 */     // GIR_Coverage, 11764,
     /*  724369 */     GIR_EraseRootFromParent_Done,
     /*  724370 */   // Label 11387: @724370
     /*  724370 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(724445), // Rule ID 11765 //
     /*  724375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  724386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  724389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  724392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  724424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724443 */     GIR_RootConstrainSelectedInstOperands,
     /*  724444 */     // GIR_Coverage, 11765,
     /*  724444 */     GIR_EraseRootFromParent_Done,
     /*  724445 */   // Label 11388: @724445
     /*  724445 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(724520), // Rule ID 11768 //
     /*  724450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  724499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724518 */     GIR_RootConstrainSelectedInstOperands,
     /*  724519 */     // GIR_Coverage, 11768,
     /*  724519 */     GIR_EraseRootFromParent_Done,
     /*  724520 */   // Label 11389: @724520
     /*  724520 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(724595), // Rule ID 11769 //
     /*  724525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  724536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  724539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  724542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11122:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  724574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724593 */     GIR_RootConstrainSelectedInstOperands,
     /*  724594 */     // GIR_Coverage, 11769,
     /*  724594 */     GIR_EraseRootFromParent_Done,
     /*  724595 */   // Label 11390: @724595
     /*  724595 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(724670), // Rule ID 11772 //
     /*  724600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  724649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724668 */     GIR_RootConstrainSelectedInstOperands,
     /*  724669 */     // GIR_Coverage, 11772,
     /*  724669 */     GIR_EraseRootFromParent_Done,
     /*  724670 */   // Label 11391: @724670
     /*  724670 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(724745), // Rule ID 11773 //
     /*  724675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  724724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724743 */     GIR_RootConstrainSelectedInstOperands,
     /*  724744 */     // GIR_Coverage, 11773,
     /*  724744 */     GIR_EraseRootFromParent_Done,
     /*  724745 */   // Label 11392: @724745
     /*  724745 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(724820), // Rule ID 11776 //
     /*  724750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  724799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724818 */     GIR_RootConstrainSelectedInstOperands,
     /*  724819 */     // GIR_Coverage, 11776,
     /*  724819 */     GIR_EraseRootFromParent_Done,
     /*  724820 */   // Label 11393: @724820
     /*  724820 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(724895), // Rule ID 11777 //
     /*  724825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  724874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724893 */     GIR_RootConstrainSelectedInstOperands,
     /*  724894 */     // GIR_Coverage, 11777,
     /*  724894 */     GIR_EraseRootFromParent_Done,
     /*  724895 */   // Label 11394: @724895
     /*  724895 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(724970), // Rule ID 11780 //
     /*  724900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  724920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  724939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  724949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724968 */     GIR_RootConstrainSelectedInstOperands,
     /*  724969 */     // GIR_Coverage, 11780,
     /*  724969 */     GIR_EraseRootFromParent_Done,
     /*  724970 */   // Label 11395: @724970
     /*  724970 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(725045), // Rule ID 11781 //
     /*  724975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  724983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  724995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  725024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725043 */     GIR_RootConstrainSelectedInstOperands,
     /*  725044 */     // GIR_Coverage, 11781,
     /*  725044 */     GIR_EraseRootFromParent_Done,
     /*  725045 */   // Label 11396: @725045
     /*  725045 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(725120), // Rule ID 11784 //
     /*  725050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725096 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  725099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725118 */     GIR_RootConstrainSelectedInstOperands,
     /*  725119 */     // GIR_Coverage, 11784,
     /*  725119 */     GIR_EraseRootFromParent_Done,
     /*  725120 */   // Label 11397: @725120
     /*  725120 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(725195), // Rule ID 11785 //
     /*  725125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  725136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  725139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  725142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725171 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  725174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725193 */     GIR_RootConstrainSelectedInstOperands,
     /*  725194 */     // GIR_Coverage, 11785,
     /*  725194 */     GIR_EraseRootFromParent_Done,
     /*  725195 */   // Label 11398: @725195
     /*  725195 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(725270), // Rule ID 11788 //
     /*  725200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  725249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725268 */     GIR_RootConstrainSelectedInstOperands,
     /*  725269 */     // GIR_Coverage, 11788,
     /*  725269 */     GIR_EraseRootFromParent_Done,
     /*  725270 */   // Label 11399: @725270
     /*  725270 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(725345), // Rule ID 11789 //
     /*  725275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  725286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  725289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  725292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  725324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725343 */     GIR_RootConstrainSelectedInstOperands,
     /*  725344 */     // GIR_Coverage, 11789,
     /*  725344 */     GIR_EraseRootFromParent_Done,
     /*  725345 */   // Label 11400: @725345
     /*  725345 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(725420), // Rule ID 11792 //
     /*  725350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  725399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725418 */     GIR_RootConstrainSelectedInstOperands,
     /*  725419 */     // GIR_Coverage, 11792,
     /*  725419 */     GIR_EraseRootFromParent_Done,
     /*  725420 */   // Label 11401: @725420
     /*  725420 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(725495), // Rule ID 11793 //
     /*  725425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  725436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  725439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  725442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725471 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  725474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725493 */     GIR_RootConstrainSelectedInstOperands,
     /*  725494 */     // GIR_Coverage, 11793,
     /*  725494 */     GIR_EraseRootFromParent_Done,
     /*  725495 */   // Label 11402: @725495
     /*  725495 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(725570), // Rule ID 11796 //
     /*  725500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  725549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725568 */     GIR_RootConstrainSelectedInstOperands,
     /*  725569 */     // GIR_Coverage, 11796,
     /*  725569 */     GIR_EraseRootFromParent_Done,
     /*  725570 */   // Label 11403: @725570
     /*  725570 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(725645), // Rule ID 11797 //
     /*  725575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  725624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725643 */     GIR_RootConstrainSelectedInstOperands,
     /*  725644 */     // GIR_Coverage, 11797,
     /*  725644 */     GIR_EraseRootFromParent_Done,
     /*  725645 */   // Label 11404: @725645
     /*  725645 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(725720), // Rule ID 11800 //
     /*  725650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  725699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725718 */     GIR_RootConstrainSelectedInstOperands,
     /*  725719 */     // GIR_Coverage, 11800,
     /*  725719 */     GIR_EraseRootFromParent_Done,
     /*  725720 */   // Label 11405: @725720
     /*  725720 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(725795), // Rule ID 11801 //
     /*  725725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  725774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725793 */     GIR_RootConstrainSelectedInstOperands,
     /*  725794 */     // GIR_Coverage, 11801,
     /*  725794 */     GIR_EraseRootFromParent_Done,
     /*  725795 */   // Label 11406: @725795
     /*  725795 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(725870), // Rule ID 11804 //
     /*  725800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  725849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725868 */     GIR_RootConstrainSelectedInstOperands,
     /*  725869 */     // GIR_Coverage, 11804,
     /*  725869 */     GIR_EraseRootFromParent_Done,
     /*  725870 */   // Label 11407: @725870
     /*  725870 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(725945), // Rule ID 11805 //
     /*  725875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725921 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  725924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725943 */     GIR_RootConstrainSelectedInstOperands,
     /*  725944 */     // GIR_Coverage, 11805,
     /*  725944 */     GIR_EraseRootFromParent_Done,
     /*  725945 */   // Label 11408: @725945
     /*  725945 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(726020), // Rule ID 11808 //
     /*  725950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  725958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  725999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726018 */     GIR_RootConstrainSelectedInstOperands,
     /*  726019 */     // GIR_Coverage, 11808,
     /*  726019 */     GIR_EraseRootFromParent_Done,
     /*  726020 */   // Label 11409: @726020
     /*  726020 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(726095), // Rule ID 11809 //
     /*  726025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  726036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  726039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  726042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  726074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726093 */     GIR_RootConstrainSelectedInstOperands,
     /*  726094 */     // GIR_Coverage, 11809,
     /*  726094 */     GIR_EraseRootFromParent_Done,
     /*  726095 */   // Label 11410: @726095
     /*  726095 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(726170), // Rule ID 11812 //
     /*  726100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  726149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726168 */     GIR_RootConstrainSelectedInstOperands,
     /*  726169 */     // GIR_Coverage, 11812,
     /*  726169 */     GIR_EraseRootFromParent_Done,
     /*  726170 */   // Label 11411: @726170
     /*  726170 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(726245), // Rule ID 11813 //
     /*  726175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  726186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  726189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  726192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  726224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726243 */     GIR_RootConstrainSelectedInstOperands,
     /*  726244 */     // GIR_Coverage, 11813,
     /*  726244 */     GIR_EraseRootFromParent_Done,
     /*  726245 */   // Label 11412: @726245
     /*  726245 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(726320), // Rule ID 11816 //
     /*  726250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  726299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726318 */     GIR_RootConstrainSelectedInstOperands,
     /*  726319 */     // GIR_Coverage, 11816,
     /*  726319 */     GIR_EraseRootFromParent_Done,
     /*  726320 */   // Label 11413: @726320
     /*  726320 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(726395), // Rule ID 11817 //
     /*  726325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  726336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  726339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  726342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  726374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726393 */     GIR_RootConstrainSelectedInstOperands,
     /*  726394 */     // GIR_Coverage, 11817,
     /*  726394 */     GIR_EraseRootFromParent_Done,
     /*  726395 */   // Label 11414: @726395
     /*  726395 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(726470), // Rule ID 11820 //
     /*  726400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  726449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726468 */     GIR_RootConstrainSelectedInstOperands,
     /*  726469 */     // GIR_Coverage, 11820,
     /*  726469 */     GIR_EraseRootFromParent_Done,
     /*  726470 */   // Label 11415: @726470
     /*  726470 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(726545), // Rule ID 11821 //
     /*  726475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  726486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  726489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  726492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  726510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  726524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726543 */     GIR_RootConstrainSelectedInstOperands,
     /*  726544 */     // GIR_Coverage, 11821,
     /*  726544 */     GIR_EraseRootFromParent_Done,
     /*  726545 */   // Label 11416: @726545
     /*  726545 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(726620), // Rule ID 11824 //
     /*  726550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  726599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726618 */     GIR_RootConstrainSelectedInstOperands,
     /*  726619 */     // GIR_Coverage, 11824,
     /*  726619 */     GIR_EraseRootFromParent_Done,
     /*  726620 */   // Label 11417: @726620
     /*  726620 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(726695), // Rule ID 11825 //
     /*  726625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  726674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726693 */     GIR_RootConstrainSelectedInstOperands,
     /*  726694 */     // GIR_Coverage, 11825,
     /*  726694 */     GIR_EraseRootFromParent_Done,
     /*  726695 */   // Label 11418: @726695
     /*  726695 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(726770), // Rule ID 11828 //
     /*  726700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  726749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726768 */     GIR_RootConstrainSelectedInstOperands,
     /*  726769 */     // GIR_Coverage, 11828,
     /*  726769 */     GIR_EraseRootFromParent_Done,
     /*  726770 */   // Label 11419: @726770
     /*  726770 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(726845), // Rule ID 11829 //
     /*  726775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  726783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726821 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  726824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726843 */     GIR_RootConstrainSelectedInstOperands,
     /*  726844 */     // GIR_Coverage, 11829,
     /*  726844 */     GIR_EraseRootFromParent_Done,
     /*  726845 */   // Label 11420: @726845
     /*  726845 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(726920), // Rule ID 11832 //
     /*  726850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  726870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  726899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726918 */     GIR_RootConstrainSelectedInstOperands,
     /*  726919 */     // GIR_Coverage, 11832,
     /*  726919 */     GIR_EraseRootFromParent_Done,
     /*  726920 */   // Label 11421: @726920
     /*  726920 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(726995), // Rule ID 11833 //
     /*  726925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  726945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726971 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  726974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726993 */     GIR_RootConstrainSelectedInstOperands,
     /*  726994 */     // GIR_Coverage, 11833,
     /*  726994 */     GIR_EraseRootFromParent_Done,
     /*  726995 */   // Label 11422: @726995
     /*  726995 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(727070), // Rule ID 11836 //
     /*  727000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  727020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  727049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727068 */     GIR_RootConstrainSelectedInstOperands,
     /*  727069 */     // GIR_Coverage, 11836,
     /*  727069 */     GIR_EraseRootFromParent_Done,
     /*  727070 */   // Label 11423: @727070
     /*  727070 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(727145), // Rule ID 11837 //
     /*  727075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  727086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  727089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  727092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  727095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  727124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727143 */     GIR_RootConstrainSelectedInstOperands,
     /*  727144 */     // GIR_Coverage, 11837,
     /*  727144 */     GIR_EraseRootFromParent_Done,
     /*  727145 */   // Label 11424: @727145
     /*  727145 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(727220), // Rule ID 11840 //
     /*  727150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  727170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  727199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727218 */     GIR_RootConstrainSelectedInstOperands,
     /*  727219 */     // GIR_Coverage, 11840,
     /*  727219 */     GIR_EraseRootFromParent_Done,
     /*  727220 */   // Label 11425: @727220
     /*  727220 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(727295), // Rule ID 11841 //
     /*  727225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  727236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  727239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  727242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  727245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727271 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  727274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727293 */     GIR_RootConstrainSelectedInstOperands,
     /*  727294 */     // GIR_Coverage, 11841,
     /*  727294 */     GIR_EraseRootFromParent_Done,
     /*  727295 */   // Label 11426: @727295
     /*  727295 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(727370), // Rule ID 11844 //
     /*  727300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  727320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  727349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727368 */     GIR_RootConstrainSelectedInstOperands,
     /*  727369 */     // GIR_Coverage, 11844,
     /*  727369 */     GIR_EraseRootFromParent_Done,
     /*  727370 */   // Label 11427: @727370
     /*  727370 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(727445), // Rule ID 11845 //
     /*  727375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  727386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  727389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  727392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  727395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  727424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727443 */     GIR_RootConstrainSelectedInstOperands,
     /*  727444 */     // GIR_Coverage, 11845,
     /*  727444 */     GIR_EraseRootFromParent_Done,
     /*  727445 */   // Label 11428: @727445
     /*  727445 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(727520), // Rule ID 11848 //
     /*  727450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  727470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  727499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727518 */     GIR_RootConstrainSelectedInstOperands,
     /*  727519 */     // GIR_Coverage, 11848,
     /*  727519 */     GIR_EraseRootFromParent_Done,
     /*  727520 */   // Label 11429: @727520
     /*  727520 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(727595), // Rule ID 11849 //
     /*  727525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  727536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  727539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  727542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  727545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727571 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  727574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727593 */     GIR_RootConstrainSelectedInstOperands,
     /*  727594 */     // GIR_Coverage, 11849,
     /*  727594 */     GIR_EraseRootFromParent_Done,
     /*  727595 */   // Label 11430: @727595
     /*  727595 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(727670), // Rule ID 11852 //
     /*  727600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  727620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  727649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727668 */     GIR_RootConstrainSelectedInstOperands,
     /*  727669 */     // GIR_Coverage, 11852,
     /*  727669 */     GIR_EraseRootFromParent_Done,
     /*  727670 */   // Label 11431: @727670
     /*  727670 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(727745), // Rule ID 11853 //
     /*  727675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  727695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727721 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  727724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727743 */     GIR_RootConstrainSelectedInstOperands,
     /*  727744 */     // GIR_Coverage, 11853,
     /*  727744 */     GIR_EraseRootFromParent_Done,
     /*  727745 */   // Label 11432: @727745
     /*  727745 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(727820), // Rule ID 11856 //
     /*  727750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  727770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  727799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727818 */     GIR_RootConstrainSelectedInstOperands,
     /*  727819 */     // GIR_Coverage, 11856,
     /*  727819 */     GIR_EraseRootFromParent_Done,
     /*  727820 */   // Label 11433: @727820
     /*  727820 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(727895), // Rule ID 11857 //
     /*  727825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  727845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727871 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  727874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727893 */     GIR_RootConstrainSelectedInstOperands,
     /*  727894 */     // GIR_Coverage, 11857,
     /*  727894 */     GIR_EraseRootFromParent_Done,
     /*  727895 */   // Label 11434: @727895
     /*  727895 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(727970), // Rule ID 11860 //
     /*  727900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  727949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727968 */     GIR_RootConstrainSelectedInstOperands,
     /*  727969 */     // GIR_Coverage, 11860,
     /*  727969 */     GIR_EraseRootFromParent_Done,
     /*  727970 */   // Label 11435: @727970
     /*  727970 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(728045), // Rule ID 11861 //
     /*  727975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  727995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728021 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  728024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728043 */     GIR_RootConstrainSelectedInstOperands,
     /*  728044 */     // GIR_Coverage, 11861,
     /*  728044 */     GIR_EraseRootFromParent_Done,
     /*  728045 */   // Label 11436: @728045
     /*  728045 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(728120), // Rule ID 11864 //
     /*  728050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  728070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  728099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728118 */     GIR_RootConstrainSelectedInstOperands,
     /*  728119 */     // GIR_Coverage, 11864,
     /*  728119 */     GIR_EraseRootFromParent_Done,
     /*  728120 */   // Label 11437: @728120
     /*  728120 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(728195), // Rule ID 11865 //
     /*  728125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  728136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  728139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  728142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  728145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  728174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728193 */     GIR_RootConstrainSelectedInstOperands,
     /*  728194 */     // GIR_Coverage, 11865,
     /*  728194 */     GIR_EraseRootFromParent_Done,
     /*  728195 */   // Label 11438: @728195
     /*  728195 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(728270), // Rule ID 11868 //
     /*  728200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  728249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728268 */     GIR_RootConstrainSelectedInstOperands,
     /*  728269 */     // GIR_Coverage, 11868,
     /*  728269 */     GIR_EraseRootFromParent_Done,
     /*  728270 */   // Label 11439: @728270
     /*  728270 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(728345), // Rule ID 11869 //
     /*  728275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  728286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  728289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  728292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  728295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  728314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728321 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  728324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728343 */     GIR_RootConstrainSelectedInstOperands,
     /*  728344 */     // GIR_Coverage, 11869,
     /*  728344 */     GIR_EraseRootFromParent_Done,
     /*  728345 */   // Label 11440: @728345
     /*  728345 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(728420), // Rule ID 11872 //
     /*  728350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  728370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  728399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728418 */     GIR_RootConstrainSelectedInstOperands,
     /*  728419 */     // GIR_Coverage, 11872,
     /*  728419 */     GIR_EraseRootFromParent_Done,
     /*  728420 */   // Label 11441: @728420
     /*  728420 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(728495), // Rule ID 11873 //
     /*  728425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  728436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  728439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  728442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  728445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  728474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728493 */     GIR_RootConstrainSelectedInstOperands,
     /*  728494 */     // GIR_Coverage, 11873,
     /*  728494 */     GIR_EraseRootFromParent_Done,
     /*  728495 */   // Label 11442: @728495
     /*  728495 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(728570), // Rule ID 11876 //
     /*  728500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  728520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  728549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728568 */     GIR_RootConstrainSelectedInstOperands,
     /*  728569 */     // GIR_Coverage, 11876,
     /*  728569 */     GIR_EraseRootFromParent_Done,
     /*  728570 */   // Label 11443: @728570
     /*  728570 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(728645), // Rule ID 11877 //
     /*  728575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  728595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728621 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  728624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728643 */     GIR_RootConstrainSelectedInstOperands,
     /*  728644 */     // GIR_Coverage, 11877,
     /*  728644 */     GIR_EraseRootFromParent_Done,
     /*  728645 */   // Label 11444: @728645
     /*  728645 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(728720), // Rule ID 11880 //
     /*  728650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  728670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  728699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728718 */     GIR_RootConstrainSelectedInstOperands,
     /*  728719 */     // GIR_Coverage, 11880,
     /*  728719 */     GIR_EraseRootFromParent_Done,
     /*  728720 */   // Label 11445: @728720
     /*  728720 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(728795), // Rule ID 11881 //
     /*  728725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  728745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  728774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728793 */     GIR_RootConstrainSelectedInstOperands,
     /*  728794 */     // GIR_Coverage, 11881,
     /*  728794 */     GIR_EraseRootFromParent_Done,
     /*  728795 */   // Label 11446: @728795
     /*  728795 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(728870), // Rule ID 11884 //
     /*  728800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  728820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  728849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728868 */     GIR_RootConstrainSelectedInstOperands,
     /*  728869 */     // GIR_Coverage, 11884,
     /*  728869 */     GIR_EraseRootFromParent_Done,
     /*  728870 */   // Label 11447: @728870
     /*  728870 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(728945), // Rule ID 11885 //
     /*  728875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  728895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  728924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728943 */     GIR_RootConstrainSelectedInstOperands,
     /*  728944 */     // GIR_Coverage, 11885,
     /*  728944 */     GIR_EraseRootFromParent_Done,
     /*  728945 */   // Label 11448: @728945
     /*  728945 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(729020), // Rule ID 11888 //
     /*  728950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  728970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  728999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729018 */     GIR_RootConstrainSelectedInstOperands,
     /*  729019 */     // GIR_Coverage, 11888,
     /*  729019 */     GIR_EraseRootFromParent_Done,
     /*  729020 */   // Label 11449: @729020
     /*  729020 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(729095), // Rule ID 11889 //
     /*  729025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  729036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  729039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  729042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  729045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  729074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729093 */     GIR_RootConstrainSelectedInstOperands,
     /*  729094 */     // GIR_Coverage, 11889,
     /*  729094 */     GIR_EraseRootFromParent_Done,
     /*  729095 */   // Label 11450: @729095
     /*  729095 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(729170), // Rule ID 11892 //
     /*  729100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  729120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  729149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729168 */     GIR_RootConstrainSelectedInstOperands,
     /*  729169 */     // GIR_Coverage, 11892,
     /*  729169 */     GIR_EraseRootFromParent_Done,
     /*  729170 */   // Label 11451: @729170
     /*  729170 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(729245), // Rule ID 11893 //
     /*  729175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  729186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  729189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  729192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  729195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  729224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729243 */     GIR_RootConstrainSelectedInstOperands,
     /*  729244 */     // GIR_Coverage, 11893,
     /*  729244 */     GIR_EraseRootFromParent_Done,
     /*  729245 */   // Label 11452: @729245
     /*  729245 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(729320), // Rule ID 11896 //
     /*  729250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  729270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  729299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729318 */     GIR_RootConstrainSelectedInstOperands,
     /*  729319 */     // GIR_Coverage, 11896,
     /*  729319 */     GIR_EraseRootFromParent_Done,
     /*  729320 */   // Label 11453: @729320
     /*  729320 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(729395), // Rule ID 11897 //
     /*  729325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  729336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  729339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  729342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  729345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  729374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729393 */     GIR_RootConstrainSelectedInstOperands,
     /*  729394 */     // GIR_Coverage, 11897,
     /*  729394 */     GIR_EraseRootFromParent_Done,
     /*  729395 */   // Label 11454: @729395
     /*  729395 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(729470), // Rule ID 11900 //
     /*  729400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  729420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  729449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729468 */     GIR_RootConstrainSelectedInstOperands,
     /*  729469 */     // GIR_Coverage, 11900,
     /*  729469 */     GIR_EraseRootFromParent_Done,
     /*  729470 */   // Label 11455: @729470
     /*  729470 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(729545), // Rule ID 11901 //
     /*  729475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  729486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  729489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  729492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  729495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  729524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729543 */     GIR_RootConstrainSelectedInstOperands,
     /*  729544 */     // GIR_Coverage, 11901,
     /*  729544 */     GIR_EraseRootFromParent_Done,
     /*  729545 */   // Label 11456: @729545
     /*  729545 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(729620), // Rule ID 11904 //
     /*  729550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  729570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  729599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729618 */     GIR_RootConstrainSelectedInstOperands,
     /*  729619 */     // GIR_Coverage, 11904,
     /*  729619 */     GIR_EraseRootFromParent_Done,
     /*  729620 */   // Label 11457: @729620
     /*  729620 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(729695), // Rule ID 11905 //
     /*  729625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  729645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729671 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  729674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729693 */     GIR_RootConstrainSelectedInstOperands,
     /*  729694 */     // GIR_Coverage, 11905,
     /*  729694 */     GIR_EraseRootFromParent_Done,
     /*  729695 */   // Label 11458: @729695
     /*  729695 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(729770), // Rule ID 11908 //
     /*  729700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  729720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  729749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729768 */     GIR_RootConstrainSelectedInstOperands,
     /*  729769 */     // GIR_Coverage, 11908,
     /*  729769 */     GIR_EraseRootFromParent_Done,
     /*  729770 */   // Label 11459: @729770
     /*  729770 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(729845), // Rule ID 11909 //
     /*  729775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  729795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  729824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729843 */     GIR_RootConstrainSelectedInstOperands,
     /*  729844 */     // GIR_Coverage, 11909,
     /*  729844 */     GIR_EraseRootFromParent_Done,
     /*  729845 */   // Label 11460: @729845
     /*  729845 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(729920), // Rule ID 11912 //
     /*  729850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  729870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  729899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729918 */     GIR_RootConstrainSelectedInstOperands,
     /*  729919 */     // GIR_Coverage, 11912,
     /*  729919 */     GIR_EraseRootFromParent_Done,
     /*  729920 */   // Label 11461: @729920
     /*  729920 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(729995), // Rule ID 11913 //
     /*  729925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  729945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  729974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729993 */     GIR_RootConstrainSelectedInstOperands,
     /*  729994 */     // GIR_Coverage, 11913,
     /*  729994 */     GIR_EraseRootFromParent_Done,
     /*  729995 */   // Label 11462: @729995
     /*  729995 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(730070), // Rule ID 11916 //
     /*  730000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  730003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  730020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  730046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  730049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730068 */     GIR_RootConstrainSelectedInstOperands,
     /*  730069 */     // GIR_Coverage, 11916,
     /*  730069 */     GIR_EraseRootFromParent_Done,
     /*  730070 */   // Label 11463: @730070
     /*  730070 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(730145), // Rule ID 11917 //
     /*  730075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  730078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  730086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  730089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  730092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  730095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  730121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  730124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730143 */     GIR_RootConstrainSelectedInstOperands,
     /*  730144 */     // GIR_Coverage, 11917,
     /*  730144 */     GIR_EraseRootFromParent_Done,
     /*  730145 */   // Label 11464: @730145
     /*  730145 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(730220), // Rule ID 11920 //
     /*  730150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  730199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730218 */     GIR_RootConstrainSelectedInstOperands,
     /*  730219 */     // GIR_Coverage, 11920,
     /*  730219 */     GIR_EraseRootFromParent_Done,
     /*  730220 */   // Label 11465: @730220
     /*  730220 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(730295), // Rule ID 11921 //
     /*  730225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  730236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  730239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  730242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730271 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  730274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730293 */     GIR_RootConstrainSelectedInstOperands,
     /*  730294 */     // GIR_Coverage, 11921,
     /*  730294 */     GIR_EraseRootFromParent_Done,
     /*  730295 */   // Label 11466: @730295
     /*  730295 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(730370), // Rule ID 11924 //
     /*  730300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  730349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730368 */     GIR_RootConstrainSelectedInstOperands,
     /*  730369 */     // GIR_Coverage, 11924,
     /*  730369 */     GIR_EraseRootFromParent_Done,
     /*  730370 */   // Label 11467: @730370
     /*  730370 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(730445), // Rule ID 11925 //
     /*  730375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  730386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  730389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  730392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  730424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730443 */     GIR_RootConstrainSelectedInstOperands,
     /*  730444 */     // GIR_Coverage, 11925,
     /*  730444 */     GIR_EraseRootFromParent_Done,
     /*  730445 */   // Label 11468: @730445
     /*  730445 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(730520), // Rule ID 11928 //
     /*  730450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  730499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730518 */     GIR_RootConstrainSelectedInstOperands,
     /*  730519 */     // GIR_Coverage, 11928,
     /*  730519 */     GIR_EraseRootFromParent_Done,
     /*  730520 */   // Label 11469: @730520
     /*  730520 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(730595), // Rule ID 11929 //
     /*  730525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  730536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  730539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  730542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730571 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  730574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730593 */     GIR_RootConstrainSelectedInstOperands,
     /*  730594 */     // GIR_Coverage, 11929,
     /*  730594 */     GIR_EraseRootFromParent_Done,
     /*  730595 */   // Label 11470: @730595
     /*  730595 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(730670), // Rule ID 11932 //
     /*  730600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  730649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730668 */     GIR_RootConstrainSelectedInstOperands,
     /*  730669 */     // GIR_Coverage, 11932,
     /*  730669 */     GIR_EraseRootFromParent_Done,
     /*  730670 */   // Label 11471: @730670
     /*  730670 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(730745), // Rule ID 11933 //
     /*  730675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730721 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  730724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730743 */     GIR_RootConstrainSelectedInstOperands,
     /*  730744 */     // GIR_Coverage, 11933,
     /*  730744 */     GIR_EraseRootFromParent_Done,
     /*  730745 */   // Label 11472: @730745
     /*  730745 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(730820), // Rule ID 11936 //
     /*  730750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  730799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730818 */     GIR_RootConstrainSelectedInstOperands,
     /*  730819 */     // GIR_Coverage, 11936,
     /*  730819 */     GIR_EraseRootFromParent_Done,
     /*  730820 */   // Label 11473: @730820
     /*  730820 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(730895), // Rule ID 11937 //
     /*  730825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730871 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  730874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730893 */     GIR_RootConstrainSelectedInstOperands,
     /*  730894 */     // GIR_Coverage, 11937,
     /*  730894 */     GIR_EraseRootFromParent_Done,
     /*  730895 */   // Label 11474: @730895
     /*  730895 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(730970), // Rule ID 11940 //
     /*  730900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  730920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  730939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  730949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730968 */     GIR_RootConstrainSelectedInstOperands,
     /*  730969 */     // GIR_Coverage, 11940,
     /*  730969 */     GIR_EraseRootFromParent_Done,
     /*  730970 */   // Label 11475: @730970
     /*  730970 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(731045), // Rule ID 11941 //
     /*  730975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  730983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  730995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  731024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731043 */     GIR_RootConstrainSelectedInstOperands,
     /*  731044 */     // GIR_Coverage, 11941,
     /*  731044 */     GIR_EraseRootFromParent_Done,
     /*  731045 */   // Label 11476: @731045
     /*  731045 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(731120), // Rule ID 11944 //
     /*  731050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  731099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731118 */     GIR_RootConstrainSelectedInstOperands,
     /*  731119 */     // GIR_Coverage, 11944,
     /*  731119 */     GIR_EraseRootFromParent_Done,
     /*  731120 */   // Label 11477: @731120
     /*  731120 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(731195), // Rule ID 11945 //
     /*  731125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  731136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  731139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  731142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731171 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11120:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  731174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731193 */     GIR_RootConstrainSelectedInstOperands,
     /*  731194 */     // GIR_Coverage, 11945,
     /*  731194 */     GIR_EraseRootFromParent_Done,
     /*  731195 */   // Label 11478: @731195
     /*  731195 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(731270), // Rule ID 11948 //
     /*  731200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  731249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731268 */     GIR_RootConstrainSelectedInstOperands,
     /*  731269 */     // GIR_Coverage, 11948,
     /*  731269 */     GIR_EraseRootFromParent_Done,
     /*  731270 */   // Label 11479: @731270
     /*  731270 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(731345), // Rule ID 11949 //
     /*  731275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  731286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  731289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  731292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  731324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731343 */     GIR_RootConstrainSelectedInstOperands,
     /*  731344 */     // GIR_Coverage, 11949,
     /*  731344 */     GIR_EraseRootFromParent_Done,
     /*  731345 */   // Label 11480: @731345
     /*  731345 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(731420), // Rule ID 11952 //
     /*  731350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  731399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731418 */     GIR_RootConstrainSelectedInstOperands,
     /*  731419 */     // GIR_Coverage, 11952,
     /*  731419 */     GIR_EraseRootFromParent_Done,
     /*  731420 */   // Label 11481: @731420
     /*  731420 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(731495), // Rule ID 11953 //
     /*  731425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  731436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  731439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  731442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  731474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731493 */     GIR_RootConstrainSelectedInstOperands,
     /*  731494 */     // GIR_Coverage, 11953,
     /*  731494 */     GIR_EraseRootFromParent_Done,
     /*  731495 */   // Label 11482: @731495
     /*  731495 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(731570), // Rule ID 11956 //
     /*  731500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  731549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731568 */     GIR_RootConstrainSelectedInstOperands,
     /*  731569 */     // GIR_Coverage, 11956,
     /*  731569 */     GIR_EraseRootFromParent_Done,
     /*  731570 */   // Label 11483: @731570
     /*  731570 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(731645), // Rule ID 11957 //
     /*  731575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731621 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  731624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731643 */     GIR_RootConstrainSelectedInstOperands,
     /*  731644 */     // GIR_Coverage, 11957,
     /*  731644 */     GIR_EraseRootFromParent_Done,
     /*  731645 */   // Label 11484: @731645
     /*  731645 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(731720), // Rule ID 11960 //
     /*  731650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  731699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731718 */     GIR_RootConstrainSelectedInstOperands,
     /*  731719 */     // GIR_Coverage, 11960,
     /*  731719 */     GIR_EraseRootFromParent_Done,
     /*  731720 */   // Label 11485: @731720
     /*  731720 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(731795), // Rule ID 11961 //
     /*  731725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731771 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  731774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731793 */     GIR_RootConstrainSelectedInstOperands,
     /*  731794 */     // GIR_Coverage, 11961,
     /*  731794 */     GIR_EraseRootFromParent_Done,
     /*  731795 */   // Label 11486: @731795
     /*  731795 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(731870), // Rule ID 11964 //
     /*  731800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  731849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731868 */     GIR_RootConstrainSelectedInstOperands,
     /*  731869 */     // GIR_Coverage, 11964,
     /*  731869 */     GIR_EraseRootFromParent_Done,
     /*  731870 */   // Label 11487: @731870
     /*  731870 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(731945), // Rule ID 11965 //
     /*  731875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  731895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  731924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731943 */     GIR_RootConstrainSelectedInstOperands,
     /*  731944 */     // GIR_Coverage, 11965,
     /*  731944 */     GIR_EraseRootFromParent_Done,
     /*  731945 */   // Label 11488: @731945
     /*  731945 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(732020), // Rule ID 11968 //
     /*  731950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  731958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  731970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  731989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  731999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732018 */     GIR_RootConstrainSelectedInstOperands,
     /*  732019 */     // GIR_Coverage, 11968,
     /*  732019 */     GIR_EraseRootFromParent_Done,
     /*  732020 */   // Label 11489: @732020
     /*  732020 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(732095), // Rule ID 11969 //
     /*  732025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  732036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  732039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  732042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  732074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732093 */     GIR_RootConstrainSelectedInstOperands,
     /*  732094 */     // GIR_Coverage, 11969,
     /*  732094 */     GIR_EraseRootFromParent_Done,
     /*  732095 */   // Label 11490: @732095
     /*  732095 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(732170), // Rule ID 11972 //
     /*  732100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  732149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732168 */     GIR_RootConstrainSelectedInstOperands,
     /*  732169 */     // GIR_Coverage, 11972,
     /*  732169 */     GIR_EraseRootFromParent_Done,
     /*  732170 */   // Label 11491: @732170
     /*  732170 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(732245), // Rule ID 11973 //
     /*  732175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  732186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  732189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  732192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  732224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732243 */     GIR_RootConstrainSelectedInstOperands,
     /*  732244 */     // GIR_Coverage, 11973,
     /*  732244 */     GIR_EraseRootFromParent_Done,
     /*  732245 */   // Label 11492: @732245
     /*  732245 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(732320), // Rule ID 11976 //
     /*  732250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  732299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732318 */     GIR_RootConstrainSelectedInstOperands,
     /*  732319 */     // GIR_Coverage, 11976,
     /*  732319 */     GIR_EraseRootFromParent_Done,
     /*  732320 */   // Label 11493: @732320
     /*  732320 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(732395), // Rule ID 11977 //
     /*  732325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  732336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  732339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  732342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  732374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732393 */     GIR_RootConstrainSelectedInstOperands,
     /*  732394 */     // GIR_Coverage, 11977,
     /*  732394 */     GIR_EraseRootFromParent_Done,
     /*  732395 */   // Label 11494: @732395
     /*  732395 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(732470), // Rule ID 11980 //
     /*  732400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  732449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732468 */     GIR_RootConstrainSelectedInstOperands,
     /*  732469 */     // GIR_Coverage, 11980,
     /*  732469 */     GIR_EraseRootFromParent_Done,
     /*  732470 */   // Label 11495: @732470
     /*  732470 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(732545), // Rule ID 11981 //
     /*  732475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  732486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  732489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  732492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  732524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732543 */     GIR_RootConstrainSelectedInstOperands,
     /*  732544 */     // GIR_Coverage, 11981,
     /*  732544 */     GIR_EraseRootFromParent_Done,
     /*  732545 */   // Label 11496: @732545
     /*  732545 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(732620), // Rule ID 11984 //
     /*  732550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  732599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732618 */     GIR_RootConstrainSelectedInstOperands,
     /*  732619 */     // GIR_Coverage, 11984,
     /*  732619 */     GIR_EraseRootFromParent_Done,
     /*  732620 */   // Label 11497: @732620
     /*  732620 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(732695), // Rule ID 11985 //
     /*  732625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  732674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732693 */     GIR_RootConstrainSelectedInstOperands,
     /*  732694 */     // GIR_Coverage, 11985,
     /*  732694 */     GIR_EraseRootFromParent_Done,
     /*  732695 */   // Label 11498: @732695
     /*  732695 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(732770), // Rule ID 11988 //
     /*  732700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  732749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732768 */     GIR_RootConstrainSelectedInstOperands,
     /*  732769 */     // GIR_Coverage, 11988,
     /*  732769 */     GIR_EraseRootFromParent_Done,
     /*  732770 */   // Label 11499: @732770
     /*  732770 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(732845), // Rule ID 11989 //
     /*  732775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  732824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732843 */     GIR_RootConstrainSelectedInstOperands,
     /*  732844 */     // GIR_Coverage, 11989,
     /*  732844 */     GIR_EraseRootFromParent_Done,
     /*  732845 */   // Label 11500: @732845
     /*  732845 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(732920), // Rule ID 11992 //
     /*  732850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  732899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732918 */     GIR_RootConstrainSelectedInstOperands,
     /*  732919 */     // GIR_Coverage, 11992,
     /*  732919 */     GIR_EraseRootFromParent_Done,
     /*  732920 */   // Label 11501: @732920
     /*  732920 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(732995), // Rule ID 11993 //
     /*  732925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  732933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732971 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  732974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732993 */     GIR_RootConstrainSelectedInstOperands,
     /*  732994 */     // GIR_Coverage, 11993,
     /*  732994 */     GIR_EraseRootFromParent_Done,
     /*  732995 */   // Label 11502: @732995
     /*  732995 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(733070), // Rule ID 11996 //
     /*  733000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  733049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733068 */     GIR_RootConstrainSelectedInstOperands,
     /*  733069 */     // GIR_Coverage, 11996,
     /*  733069 */     GIR_EraseRootFromParent_Done,
     /*  733070 */   // Label 11503: @733070
     /*  733070 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(733145), // Rule ID 11997 //
     /*  733075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  733086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  733089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  733092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  733124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733143 */     GIR_RootConstrainSelectedInstOperands,
     /*  733144 */     // GIR_Coverage, 11997,
     /*  733144 */     GIR_EraseRootFromParent_Done,
     /*  733145 */   // Label 11504: @733145
     /*  733145 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(733220), // Rule ID 12000 //
     /*  733150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  733199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733218 */     GIR_RootConstrainSelectedInstOperands,
     /*  733219 */     // GIR_Coverage, 12000,
     /*  733219 */     GIR_EraseRootFromParent_Done,
     /*  733220 */   // Label 11505: @733220
     /*  733220 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(733295), // Rule ID 12001 //
     /*  733225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  733236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  733239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  733242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  733260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  733274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733293 */     GIR_RootConstrainSelectedInstOperands,
     /*  733294 */     // GIR_Coverage, 12001,
     /*  733294 */     GIR_EraseRootFromParent_Done,
     /*  733295 */   // Label 11506: @733295
     /*  733295 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(733370), // Rule ID 12004 //
     /*  733300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  733349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733368 */     GIR_RootConstrainSelectedInstOperands,
     /*  733369 */     // GIR_Coverage, 12004,
     /*  733369 */     GIR_EraseRootFromParent_Done,
     /*  733370 */   // Label 11507: @733370
     /*  733370 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(733445), // Rule ID 12005 //
     /*  733375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  733383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  733386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  733389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  733392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  733410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733421 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  733424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733443 */     GIR_RootConstrainSelectedInstOperands,
     /*  733444 */     // GIR_Coverage, 12005,
     /*  733444 */     GIR_EraseRootFromParent_Done,
     /*  733445 */   // Label 11508: @733445
     /*  733445 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(733520), // Rule ID 12008 //
     /*  733450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  733470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  733499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733518 */     GIR_RootConstrainSelectedInstOperands,
     /*  733519 */     // GIR_Coverage, 12008,
     /*  733519 */     GIR_EraseRootFromParent_Done,
     /*  733520 */   // Label 11509: @733520
     /*  733520 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(733595), // Rule ID 12009 //
     /*  733525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  733536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  733539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  733542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  733545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  733574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733593 */     GIR_RootConstrainSelectedInstOperands,
     /*  733594 */     // GIR_Coverage, 12009,
     /*  733594 */     GIR_EraseRootFromParent_Done,
     /*  733595 */   // Label 11510: @733595
     /*  733595 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(733670), // Rule ID 12012 //
     /*  733600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  733620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733646 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  733649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733668 */     GIR_RootConstrainSelectedInstOperands,
     /*  733669 */     // GIR_Coverage, 12012,
     /*  733669 */     GIR_EraseRootFromParent_Done,
     /*  733670 */   // Label 11511: @733670
     /*  733670 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(733745), // Rule ID 12013 //
     /*  733675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  733695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  733724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733743 */     GIR_RootConstrainSelectedInstOperands,
     /*  733744 */     // GIR_Coverage, 12013,
     /*  733744 */     GIR_EraseRootFromParent_Done,
     /*  733745 */   // Label 11512: @733745
     /*  733745 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(733820), // Rule ID 12016 //
     /*  733750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  733770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  733799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733818 */     GIR_RootConstrainSelectedInstOperands,
     /*  733819 */     // GIR_Coverage, 12016,
     /*  733819 */     GIR_EraseRootFromParent_Done,
     /*  733820 */   // Label 11513: @733820
     /*  733820 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(733895), // Rule ID 12017 //
     /*  733825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  733845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733871 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  733874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733893 */     GIR_RootConstrainSelectedInstOperands,
     /*  733894 */     // GIR_Coverage, 12017,
     /*  733894 */     GIR_EraseRootFromParent_Done,
     /*  733895 */   // Label 11514: @733895
     /*  733895 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(733970), // Rule ID 12020 //
     /*  733900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  733920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  733949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733968 */     GIR_RootConstrainSelectedInstOperands,
     /*  733969 */     // GIR_Coverage, 12020,
     /*  733969 */     GIR_EraseRootFromParent_Done,
     /*  733970 */   // Label 11515: @733970
     /*  733970 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(734045), // Rule ID 12021 //
     /*  733975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  733995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  734024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734043 */     GIR_RootConstrainSelectedInstOperands,
     /*  734044 */     // GIR_Coverage, 12021,
     /*  734044 */     GIR_EraseRootFromParent_Done,
     /*  734045 */   // Label 11516: @734045
     /*  734045 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(734120), // Rule ID 12024 //
     /*  734050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  734070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  734099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734118 */     GIR_RootConstrainSelectedInstOperands,
     /*  734119 */     // GIR_Coverage, 12024,
     /*  734119 */     GIR_EraseRootFromParent_Done,
     /*  734120 */   // Label 11517: @734120
     /*  734120 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(734195), // Rule ID 12025 //
     /*  734125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  734136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  734139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  734142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  734145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  734174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734193 */     GIR_RootConstrainSelectedInstOperands,
     /*  734194 */     // GIR_Coverage, 12025,
     /*  734194 */     GIR_EraseRootFromParent_Done,
     /*  734195 */   // Label 11518: @734195
     /*  734195 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(734270), // Rule ID 12028 //
     /*  734200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  734220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  734249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734268 */     GIR_RootConstrainSelectedInstOperands,
     /*  734269 */     // GIR_Coverage, 12028,
     /*  734269 */     GIR_EraseRootFromParent_Done,
     /*  734270 */   // Label 11519: @734270
     /*  734270 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(734345), // Rule ID 12029 //
     /*  734275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  734286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  734289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  734292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  734295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734321 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  734324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734343 */     GIR_RootConstrainSelectedInstOperands,
     /*  734344 */     // GIR_Coverage, 12029,
     /*  734344 */     GIR_EraseRootFromParent_Done,
     /*  734345 */   // Label 11520: @734345
     /*  734345 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(734420), // Rule ID 12032 //
     /*  734350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  734399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734418 */     GIR_RootConstrainSelectedInstOperands,
     /*  734419 */     // GIR_Coverage, 12032,
     /*  734419 */     GIR_EraseRootFromParent_Done,
     /*  734420 */   // Label 11521: @734420
     /*  734420 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(734495), // Rule ID 12033 //
     /*  734425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  734436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  734439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  734442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  734445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734471 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  734474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734493 */     GIR_RootConstrainSelectedInstOperands,
     /*  734494 */     // GIR_Coverage, 12033,
     /*  734494 */     GIR_EraseRootFromParent_Done,
     /*  734495 */   // Label 11522: @734495
     /*  734495 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(734570), // Rule ID 12036 //
     /*  734500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  734520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  734549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734568 */     GIR_RootConstrainSelectedInstOperands,
     /*  734569 */     // GIR_Coverage, 12036,
     /*  734569 */     GIR_EraseRootFromParent_Done,
     /*  734570 */   // Label 11523: @734570
     /*  734570 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(734645), // Rule ID 12037 //
     /*  734575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  734595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  734624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734643 */     GIR_RootConstrainSelectedInstOperands,
     /*  734644 */     // GIR_Coverage, 12037,
     /*  734644 */     GIR_EraseRootFromParent_Done,
     /*  734645 */   // Label 11524: @734645
     /*  734645 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(734720), // Rule ID 12040 //
     /*  734650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  734699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734718 */     GIR_RootConstrainSelectedInstOperands,
     /*  734719 */     // GIR_Coverage, 12040,
     /*  734719 */     GIR_EraseRootFromParent_Done,
     /*  734720 */   // Label 11525: @734720
     /*  734720 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(734795), // Rule ID 12041 //
     /*  734725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  734745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  734774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734793 */     GIR_RootConstrainSelectedInstOperands,
     /*  734794 */     // GIR_Coverage, 12041,
     /*  734794 */     GIR_EraseRootFromParent_Done,
     /*  734795 */   // Label 11526: @734795
     /*  734795 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(734870), // Rule ID 12044 //
     /*  734800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  734849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734868 */     GIR_RootConstrainSelectedInstOperands,
     /*  734869 */     // GIR_Coverage, 12044,
     /*  734869 */     GIR_EraseRootFromParent_Done,
     /*  734870 */   // Label 11527: @734870
     /*  734870 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(734945), // Rule ID 12045 //
     /*  734875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  734895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  734924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734943 */     GIR_RootConstrainSelectedInstOperands,
     /*  734944 */     // GIR_Coverage, 12045,
     /*  734944 */     GIR_EraseRootFromParent_Done,
     /*  734945 */   // Label 11528: @734945
     /*  734945 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(735020), // Rule ID 12048 //
     /*  734950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  734970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  734999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735018 */     GIR_RootConstrainSelectedInstOperands,
     /*  735019 */     // GIR_Coverage, 12048,
     /*  735019 */     GIR_EraseRootFromParent_Done,
     /*  735020 */   // Label 11529: @735020
     /*  735020 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(735095), // Rule ID 12049 //
     /*  735025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  735036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  735039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  735042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  735045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735071 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  735074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735093 */     GIR_RootConstrainSelectedInstOperands,
     /*  735094 */     // GIR_Coverage, 12049,
     /*  735094 */     GIR_EraseRootFromParent_Done,
     /*  735095 */   // Label 11530: @735095
     /*  735095 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(735170), // Rule ID 12052 //
     /*  735100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  735120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  735149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735168 */     GIR_RootConstrainSelectedInstOperands,
     /*  735169 */     // GIR_Coverage, 12052,
     /*  735169 */     GIR_EraseRootFromParent_Done,
     /*  735170 */   // Label 11531: @735170
     /*  735170 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(735245), // Rule ID 12053 //
     /*  735175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  735186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  735189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  735192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  735195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  735224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735243 */     GIR_RootConstrainSelectedInstOperands,
     /*  735244 */     // GIR_Coverage, 12053,
     /*  735244 */     GIR_EraseRootFromParent_Done,
     /*  735245 */   // Label 11532: @735245
     /*  735245 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(735320), // Rule ID 12056 //
     /*  735250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  735270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  735299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735318 */     GIR_RootConstrainSelectedInstOperands,
     /*  735319 */     // GIR_Coverage, 12056,
     /*  735319 */     GIR_EraseRootFromParent_Done,
     /*  735320 */   // Label 11533: @735320
     /*  735320 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(735395), // Rule ID 12057 //
     /*  735325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  735336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  735339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  735342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  735345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735371 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  735374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735393 */     GIR_RootConstrainSelectedInstOperands,
     /*  735394 */     // GIR_Coverage, 12057,
     /*  735394 */     GIR_EraseRootFromParent_Done,
     /*  735395 */   // Label 11534: @735395
     /*  735395 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(735470), // Rule ID 12060 //
     /*  735400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  735420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  735449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735468 */     GIR_RootConstrainSelectedInstOperands,
     /*  735469 */     // GIR_Coverage, 12060,
     /*  735469 */     GIR_EraseRootFromParent_Done,
     /*  735470 */   // Label 11535: @735470
     /*  735470 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(735545), // Rule ID 12061 //
     /*  735475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  735486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  735489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  735492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  735495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  735524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735543 */     GIR_RootConstrainSelectedInstOperands,
     /*  735544 */     // GIR_Coverage, 12061,
     /*  735544 */     GIR_EraseRootFromParent_Done,
     /*  735545 */   // Label 11536: @735545
     /*  735545 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(735620), // Rule ID 12064 //
     /*  735550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  735570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  735599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735618 */     GIR_RootConstrainSelectedInstOperands,
     /*  735619 */     // GIR_Coverage, 12064,
     /*  735619 */     GIR_EraseRootFromParent_Done,
     /*  735620 */   // Label 11537: @735620
     /*  735620 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(735695), // Rule ID 12065 //
     /*  735625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  735645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  735674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735693 */     GIR_RootConstrainSelectedInstOperands,
     /*  735694 */     // GIR_Coverage, 12065,
     /*  735694 */     GIR_EraseRootFromParent_Done,
     /*  735695 */   // Label 11538: @735695
     /*  735695 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(735770), // Rule ID 12068 //
     /*  735700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  735720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  735749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735768 */     GIR_RootConstrainSelectedInstOperands,
     /*  735769 */     // GIR_Coverage, 12068,
     /*  735769 */     GIR_EraseRootFromParent_Done,
     /*  735770 */   // Label 11539: @735770
     /*  735770 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(735845), // Rule ID 12069 //
     /*  735775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  735795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735821 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  735824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735843 */     GIR_RootConstrainSelectedInstOperands,
     /*  735844 */     // GIR_Coverage, 12069,
     /*  735844 */     GIR_EraseRootFromParent_Done,
     /*  735845 */   // Label 11540: @735845
     /*  735845 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(735920), // Rule ID 12072 //
     /*  735850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  735870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  735899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735918 */     GIR_RootConstrainSelectedInstOperands,
     /*  735919 */     // GIR_Coverage, 12072,
     /*  735919 */     GIR_EraseRootFromParent_Done,
     /*  735920 */   // Label 11541: @735920
     /*  735920 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(735995), // Rule ID 12073 //
     /*  735925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  735945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  735974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735993 */     GIR_RootConstrainSelectedInstOperands,
     /*  735994 */     // GIR_Coverage, 12073,
     /*  735994 */     GIR_EraseRootFromParent_Done,
     /*  735995 */   // Label 11542: @735995
     /*  735995 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(736070), // Rule ID 12076 //
     /*  736000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  736020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  736049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736068 */     GIR_RootConstrainSelectedInstOperands,
     /*  736069 */     // GIR_Coverage, 12076,
     /*  736069 */     GIR_EraseRootFromParent_Done,
     /*  736070 */   // Label 11543: @736070
     /*  736070 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(736145), // Rule ID 12077 //
     /*  736075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  736086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  736089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  736092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  736095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  736124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736143 */     GIR_RootConstrainSelectedInstOperands,
     /*  736144 */     // GIR_Coverage, 12077,
     /*  736144 */     GIR_EraseRootFromParent_Done,
     /*  736145 */   // Label 11544: @736145
     /*  736145 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(736220), // Rule ID 12080 //
     /*  736150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  736170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  736199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736218 */     GIR_RootConstrainSelectedInstOperands,
     /*  736219 */     // GIR_Coverage, 12080,
     /*  736219 */     GIR_EraseRootFromParent_Done,
     /*  736220 */   // Label 11545: @736220
     /*  736220 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(736295), // Rule ID 12081 //
     /*  736225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  736236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  736239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  736242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  736245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  736274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736293 */     GIR_RootConstrainSelectedInstOperands,
     /*  736294 */     // GIR_Coverage, 12081,
     /*  736294 */     GIR_EraseRootFromParent_Done,
     /*  736295 */   // Label 11546: @736295
     /*  736295 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(736370), // Rule ID 12084 //
     /*  736300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  736320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  736349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736368 */     GIR_RootConstrainSelectedInstOperands,
     /*  736369 */     // GIR_Coverage, 12084,
     /*  736369 */     GIR_EraseRootFromParent_Done,
     /*  736370 */   // Label 11547: @736370
     /*  736370 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(736445), // Rule ID 12085 //
     /*  736375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  736386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  736389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  736392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  736395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  736414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  736424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736443 */     GIR_RootConstrainSelectedInstOperands,
     /*  736444 */     // GIR_Coverage, 12085,
     /*  736444 */     GIR_EraseRootFromParent_Done,
     /*  736445 */   // Label 11548: @736445
     /*  736445 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(736520), // Rule ID 12088 //
     /*  736450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  736470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  736499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736518 */     GIR_RootConstrainSelectedInstOperands,
     /*  736519 */     // GIR_Coverage, 12088,
     /*  736519 */     GIR_EraseRootFromParent_Done,
     /*  736520 */   // Label 11549: @736520
     /*  736520 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(736595), // Rule ID 12089 //
     /*  736525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  736536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  736539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  736542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  736545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  736574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736593 */     GIR_RootConstrainSelectedInstOperands,
     /*  736594 */     // GIR_Coverage, 12089,
     /*  736594 */     GIR_EraseRootFromParent_Done,
     /*  736595 */   // Label 11550: @736595
     /*  736595 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(736670), // Rule ID 12092 //
     /*  736600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  736620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  736649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736668 */     GIR_RootConstrainSelectedInstOperands,
     /*  736669 */     // GIR_Coverage, 12092,
     /*  736669 */     GIR_EraseRootFromParent_Done,
     /*  736670 */   // Label 11551: @736670
     /*  736670 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(736745), // Rule ID 12093 //
     /*  736675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  736695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736721 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  736724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736743 */     GIR_RootConstrainSelectedInstOperands,
     /*  736744 */     // GIR_Coverage, 12093,
     /*  736744 */     GIR_EraseRootFromParent_Done,
     /*  736745 */   // Label 11552: @736745
     /*  736745 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(736820), // Rule ID 12096 //
     /*  736750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  736799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736818 */     GIR_RootConstrainSelectedInstOperands,
     /*  736819 */     // GIR_Coverage, 12096,
     /*  736819 */     GIR_EraseRootFromParent_Done,
     /*  736820 */   // Label 11553: @736820
     /*  736820 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(736895), // Rule ID 12097 //
     /*  736825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  736874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736893 */     GIR_RootConstrainSelectedInstOperands,
     /*  736894 */     // GIR_Coverage, 12097,
     /*  736894 */     GIR_EraseRootFromParent_Done,
     /*  736895 */   // Label 11554: @736895
     /*  736895 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(736970), // Rule ID 12100 //
     /*  736900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  736949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736968 */     GIR_RootConstrainSelectedInstOperands,
     /*  736969 */     // GIR_Coverage, 12100,
     /*  736969 */     GIR_EraseRootFromParent_Done,
     /*  736970 */   // Label 11555: @736970
     /*  736970 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(737045), // Rule ID 12101 //
     /*  736975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737021 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  737024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737043 */     GIR_RootConstrainSelectedInstOperands,
     /*  737044 */     // GIR_Coverage, 12101,
     /*  737044 */     GIR_EraseRootFromParent_Done,
     /*  737045 */   // Label 11556: @737045
     /*  737045 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(737120), // Rule ID 12104 //
     /*  737050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  737099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737118 */     GIR_RootConstrainSelectedInstOperands,
     /*  737119 */     // GIR_Coverage, 12104,
     /*  737119 */     GIR_EraseRootFromParent_Done,
     /*  737120 */   // Label 11557: @737120
     /*  737120 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(737195), // Rule ID 12105 //
     /*  737125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  737136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  737139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  737142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  737174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737193 */     GIR_RootConstrainSelectedInstOperands,
     /*  737194 */     // GIR_Coverage, 12105,
     /*  737194 */     GIR_EraseRootFromParent_Done,
     /*  737195 */   // Label 11558: @737195
     /*  737195 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(737270), // Rule ID 12108 //
     /*  737200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  737249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737268 */     GIR_RootConstrainSelectedInstOperands,
     /*  737269 */     // GIR_Coverage, 12108,
     /*  737269 */     GIR_EraseRootFromParent_Done,
     /*  737270 */   // Label 11559: @737270
     /*  737270 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(737345), // Rule ID 12109 //
     /*  737275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  737286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  737289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  737292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  737324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737343 */     GIR_RootConstrainSelectedInstOperands,
     /*  737344 */     // GIR_Coverage, 12109,
     /*  737344 */     GIR_EraseRootFromParent_Done,
     /*  737345 */   // Label 11560: @737345
     /*  737345 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(737420), // Rule ID 12112 //
     /*  737350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  737399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737418 */     GIR_RootConstrainSelectedInstOperands,
     /*  737419 */     // GIR_Coverage, 12112,
     /*  737419 */     GIR_EraseRootFromParent_Done,
     /*  737420 */   // Label 11561: @737420
     /*  737420 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(737495), // Rule ID 12113 //
     /*  737425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  737436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  737439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  737442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737471 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  737474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737493 */     GIR_RootConstrainSelectedInstOperands,
     /*  737494 */     // GIR_Coverage, 12113,
     /*  737494 */     GIR_EraseRootFromParent_Done,
     /*  737495 */   // Label 11562: @737495
     /*  737495 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(737570), // Rule ID 12116 //
     /*  737500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  737549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737568 */     GIR_RootConstrainSelectedInstOperands,
     /*  737569 */     // GIR_Coverage, 12116,
     /*  737569 */     GIR_EraseRootFromParent_Done,
     /*  737570 */   // Label 11563: @737570
     /*  737570 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(737645), // Rule ID 12117 //
     /*  737575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737621 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  737624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737643 */     GIR_RootConstrainSelectedInstOperands,
     /*  737644 */     // GIR_Coverage, 12117,
     /*  737644 */     GIR_EraseRootFromParent_Done,
     /*  737645 */   // Label 11564: @737645
     /*  737645 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(737720), // Rule ID 12120 //
     /*  737650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  737699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737718 */     GIR_RootConstrainSelectedInstOperands,
     /*  737719 */     // GIR_Coverage, 12120,
     /*  737719 */     GIR_EraseRootFromParent_Done,
     /*  737720 */   // Label 11565: @737720
     /*  737720 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(737795), // Rule ID 12121 //
     /*  737725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  737774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737793 */     GIR_RootConstrainSelectedInstOperands,
     /*  737794 */     // GIR_Coverage, 12121,
     /*  737794 */     GIR_EraseRootFromParent_Done,
     /*  737795 */   // Label 11566: @737795
     /*  737795 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(737870), // Rule ID 12124 //
     /*  737800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  737849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737868 */     GIR_RootConstrainSelectedInstOperands,
     /*  737869 */     // GIR_Coverage, 12124,
     /*  737869 */     GIR_EraseRootFromParent_Done,
     /*  737870 */   // Label 11567: @737870
     /*  737870 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(737945), // Rule ID 12125 //
     /*  737875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  737895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737921 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  737924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737943 */     GIR_RootConstrainSelectedInstOperands,
     /*  737944 */     // GIR_Coverage, 12125,
     /*  737944 */     GIR_EraseRootFromParent_Done,
     /*  737945 */   // Label 11568: @737945
     /*  737945 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(738020), // Rule ID 12128 //
     /*  737950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  737958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  737970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  737989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  737999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738018 */     GIR_RootConstrainSelectedInstOperands,
     /*  738019 */     // GIR_Coverage, 12128,
     /*  738019 */     GIR_EraseRootFromParent_Done,
     /*  738020 */   // Label 11569: @738020
     /*  738020 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(738095), // Rule ID 12129 //
     /*  738025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  738036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  738039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  738042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  738074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738093 */     GIR_RootConstrainSelectedInstOperands,
     /*  738094 */     // GIR_Coverage, 12129,
     /*  738094 */     GIR_EraseRootFromParent_Done,
     /*  738095 */   // Label 11570: @738095
     /*  738095 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(738170), // Rule ID 12132 //
     /*  738100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  738149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738168 */     GIR_RootConstrainSelectedInstOperands,
     /*  738169 */     // GIR_Coverage, 12132,
     /*  738169 */     GIR_EraseRootFromParent_Done,
     /*  738170 */   // Label 11571: @738170
     /*  738170 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(738245), // Rule ID 12133 //
     /*  738175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  738186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  738189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  738192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  738210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  738224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738243 */     GIR_RootConstrainSelectedInstOperands,
     /*  738244 */     // GIR_Coverage, 12133,
     /*  738244 */     GIR_EraseRootFromParent_Done,
     /*  738245 */   // Label 11572: @738245
     /*  738245 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(738320), // Rule ID 12136 //
     /*  738250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  738299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738318 */     GIR_RootConstrainSelectedInstOperands,
     /*  738319 */     // GIR_Coverage, 12136,
     /*  738319 */     GIR_EraseRootFromParent_Done,
     /*  738320 */   // Label 11573: @738320
     /*  738320 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(738395), // Rule ID 12137 //
     /*  738325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  738336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  738339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  738342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  738374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738393 */     GIR_RootConstrainSelectedInstOperands,
     /*  738394 */     // GIR_Coverage, 12137,
     /*  738394 */     GIR_EraseRootFromParent_Done,
     /*  738395 */   // Label 11574: @738395
     /*  738395 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(738470), // Rule ID 12140 //
     /*  738400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  738449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738468 */     GIR_RootConstrainSelectedInstOperands,
     /*  738469 */     // GIR_Coverage, 12140,
     /*  738469 */     GIR_EraseRootFromParent_Done,
     /*  738470 */   // Label 11575: @738470
     /*  738470 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(738545), // Rule ID 12141 //
     /*  738475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  738486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  738489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  738492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  738524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738543 */     GIR_RootConstrainSelectedInstOperands,
     /*  738544 */     // GIR_Coverage, 12141,
     /*  738544 */     GIR_EraseRootFromParent_Done,
     /*  738545 */   // Label 11576: @738545
     /*  738545 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(738620), // Rule ID 12144 //
     /*  738550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738596 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  738599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738618 */     GIR_RootConstrainSelectedInstOperands,
     /*  738619 */     // GIR_Coverage, 12144,
     /*  738619 */     GIR_EraseRootFromParent_Done,
     /*  738620 */   // Label 11577: @738620
     /*  738620 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(738695), // Rule ID 12145 //
     /*  738625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738671 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  738674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738693 */     GIR_RootConstrainSelectedInstOperands,
     /*  738694 */     // GIR_Coverage, 12145,
     /*  738694 */     GIR_EraseRootFromParent_Done,
     /*  738695 */   // Label 11578: @738695
     /*  738695 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(738770), // Rule ID 12148 //
     /*  738700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  738749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738768 */     GIR_RootConstrainSelectedInstOperands,
     /*  738769 */     // GIR_Coverage, 12148,
     /*  738769 */     GIR_EraseRootFromParent_Done,
     /*  738770 */   // Label 11579: @738770
     /*  738770 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(738845), // Rule ID 12149 //
     /*  738775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  738824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738843 */     GIR_RootConstrainSelectedInstOperands,
     /*  738844 */     // GIR_Coverage, 12149,
     /*  738844 */     GIR_EraseRootFromParent_Done,
     /*  738845 */   // Label 11580: @738845
     /*  738845 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(738920), // Rule ID 12152 //
     /*  738850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  738870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  738899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738918 */     GIR_RootConstrainSelectedInstOperands,
     /*  738919 */     // GIR_Coverage, 12152,
     /*  738919 */     GIR_EraseRootFromParent_Done,
     /*  738920 */   // Label 11581: @738920
     /*  738920 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(738995), // Rule ID 12153 //
     /*  738925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  738933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  738945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  738964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738971 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  738974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738993 */     GIR_RootConstrainSelectedInstOperands,
     /*  738994 */     // GIR_Coverage, 12153,
     /*  738994 */     GIR_EraseRootFromParent_Done,
     /*  738995 */   // Label 11582: @738995
     /*  738995 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(739070), // Rule ID 12156 //
     /*  739000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  739049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739068 */     GIR_RootConstrainSelectedInstOperands,
     /*  739069 */     // GIR_Coverage, 12156,
     /*  739069 */     GIR_EraseRootFromParent_Done,
     /*  739070 */   // Label 11583: @739070
     /*  739070 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(739145), // Rule ID 12157 //
     /*  739075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  739086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  739089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  739092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  739124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739143 */     GIR_RootConstrainSelectedInstOperands,
     /*  739144 */     // GIR_Coverage, 12157,
     /*  739144 */     GIR_EraseRootFromParent_Done,
     /*  739145 */   // Label 11584: @739145
     /*  739145 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(739220), // Rule ID 12160 //
     /*  739150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  739199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739218 */     GIR_RootConstrainSelectedInstOperands,
     /*  739219 */     // GIR_Coverage, 12160,
     /*  739219 */     GIR_EraseRootFromParent_Done,
     /*  739220 */   // Label 11585: @739220
     /*  739220 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(739295), // Rule ID 12161 //
     /*  739225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  739236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  739239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  739242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  739274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739293 */     GIR_RootConstrainSelectedInstOperands,
     /*  739294 */     // GIR_Coverage, 12161,
     /*  739294 */     GIR_EraseRootFromParent_Done,
     /*  739295 */   // Label 11586: @739295
     /*  739295 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(739370), // Rule ID 12164 //
     /*  739300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  739349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739368 */     GIR_RootConstrainSelectedInstOperands,
     /*  739369 */     // GIR_Coverage, 12164,
     /*  739369 */     GIR_EraseRootFromParent_Done,
     /*  739370 */   // Label 11587: @739370
     /*  739370 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(739445), // Rule ID 12165 //
     /*  739375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  739386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  739389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  739392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  739424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739443 */     GIR_RootConstrainSelectedInstOperands,
     /*  739444 */     // GIR_Coverage, 12165,
     /*  739444 */     GIR_EraseRootFromParent_Done,
     /*  739445 */   // Label 11588: @739445
     /*  739445 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(739520), // Rule ID 12168 //
     /*  739450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  739499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739518 */     GIR_RootConstrainSelectedInstOperands,
     /*  739519 */     // GIR_Coverage, 12168,
     /*  739519 */     GIR_EraseRootFromParent_Done,
     /*  739520 */   // Label 11589: @739520
     /*  739520 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(739595), // Rule ID 12169 //
     /*  739525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  739536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  739539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  739542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739571 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  739574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739593 */     GIR_RootConstrainSelectedInstOperands,
     /*  739594 */     // GIR_Coverage, 12169,
     /*  739594 */     GIR_EraseRootFromParent_Done,
     /*  739595 */   // Label 11590: @739595
     /*  739595 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(739670), // Rule ID 12172 //
     /*  739600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  739649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739668 */     GIR_RootConstrainSelectedInstOperands,
     /*  739669 */     // GIR_Coverage, 12172,
     /*  739669 */     GIR_EraseRootFromParent_Done,
     /*  739670 */   // Label 11591: @739670
     /*  739670 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(739745), // Rule ID 12173 //
     /*  739675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  739724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739743 */     GIR_RootConstrainSelectedInstOperands,
     /*  739744 */     // GIR_Coverage, 12173,
     /*  739744 */     GIR_EraseRootFromParent_Done,
     /*  739745 */   // Label 11592: @739745
     /*  739745 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(739820), // Rule ID 12176 //
     /*  739750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  739799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739818 */     GIR_RootConstrainSelectedInstOperands,
     /*  739819 */     // GIR_Coverage, 12176,
     /*  739819 */     GIR_EraseRootFromParent_Done,
     /*  739820 */   // Label 11593: @739820
     /*  739820 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(739895), // Rule ID 12177 //
     /*  739825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  739874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739893 */     GIR_RootConstrainSelectedInstOperands,
     /*  739894 */     // GIR_Coverage, 12177,
     /*  739894 */     GIR_EraseRootFromParent_Done,
     /*  739895 */   // Label 11594: @739895
     /*  739895 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(739970), // Rule ID 12180 //
     /*  739900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  739949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739968 */     GIR_RootConstrainSelectedInstOperands,
     /*  739969 */     // GIR_Coverage, 12180,
     /*  739969 */     GIR_EraseRootFromParent_Done,
     /*  739970 */   // Label 11595: @739970
     /*  739970 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(740045), // Rule ID 12181 //
     /*  739975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  739983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  740021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  740024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740043 */     GIR_RootConstrainSelectedInstOperands,
     /*  740044 */     // GIR_Coverage, 12181,
     /*  740044 */     GIR_EraseRootFromParent_Done,
     /*  740045 */   // Label 11596: @740045
     /*  740045 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(740120), // Rule ID 12184 //
     /*  740050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  740070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  740099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740118 */     GIR_RootConstrainSelectedInstOperands,
     /*  740119 */     // GIR_Coverage, 12184,
     /*  740119 */     GIR_EraseRootFromParent_Done,
     /*  740120 */   // Label 11597: @740120
     /*  740120 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(740195), // Rule ID 12185 //
     /*  740125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  740136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  740139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  740142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  740145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740171 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  740174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740193 */     GIR_RootConstrainSelectedInstOperands,
     /*  740194 */     // GIR_Coverage, 12185,
     /*  740194 */     GIR_EraseRootFromParent_Done,
     /*  740195 */   // Label 11598: @740195
     /*  740195 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(740270), // Rule ID 12188 //
     /*  740200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  740220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  740249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740268 */     GIR_RootConstrainSelectedInstOperands,
     /*  740269 */     // GIR_Coverage, 12188,
     /*  740269 */     GIR_EraseRootFromParent_Done,
     /*  740270 */   // Label 11599: @740270
     /*  740270 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(740345), // Rule ID 12189 //
     /*  740275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  740286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  740289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  740292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  740295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740321 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  740324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740343 */     GIR_RootConstrainSelectedInstOperands,
     /*  740344 */     // GIR_Coverage, 12189,
     /*  740344 */     GIR_EraseRootFromParent_Done,
     /*  740345 */   // Label 11600: @740345
     /*  740345 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(740420), // Rule ID 12192 //
     /*  740350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  740370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  740399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740418 */     GIR_RootConstrainSelectedInstOperands,
     /*  740419 */     // GIR_Coverage, 12192,
     /*  740419 */     GIR_EraseRootFromParent_Done,
     /*  740420 */   // Label 11601: @740420
     /*  740420 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(740495), // Rule ID 12193 //
     /*  740425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  740436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  740439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  740442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  740445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740471 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  740474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740493 */     GIR_RootConstrainSelectedInstOperands,
     /*  740494 */     // GIR_Coverage, 12193,
     /*  740494 */     GIR_EraseRootFromParent_Done,
     /*  740495 */   // Label 11602: @740495
     /*  740495 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(740570), // Rule ID 12196 //
     /*  740500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  740520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  740549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740568 */     GIR_RootConstrainSelectedInstOperands,
     /*  740569 */     // GIR_Coverage, 12196,
     /*  740569 */     GIR_EraseRootFromParent_Done,
     /*  740570 */   // Label 11603: @740570
     /*  740570 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(740645), // Rule ID 12197 //
     /*  740575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  740595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  740624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740643 */     GIR_RootConstrainSelectedInstOperands,
     /*  740644 */     // GIR_Coverage, 12197,
     /*  740644 */     GIR_EraseRootFromParent_Done,
     /*  740645 */   // Label 11604: @740645
     /*  740645 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(740720), // Rule ID 12200 //
     /*  740650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  740670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  740699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740718 */     GIR_RootConstrainSelectedInstOperands,
     /*  740719 */     // GIR_Coverage, 12200,
     /*  740719 */     GIR_EraseRootFromParent_Done,
     /*  740720 */   // Label 11605: @740720
     /*  740720 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(740795), // Rule ID 12201 //
     /*  740725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  740745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  740774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740793 */     GIR_RootConstrainSelectedInstOperands,
     /*  740794 */     // GIR_Coverage, 12201,
     /*  740794 */     GIR_EraseRootFromParent_Done,
     /*  740795 */   // Label 11606: @740795
     /*  740795 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(740870), // Rule ID 12204 //
     /*  740800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  740820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  740849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740868 */     GIR_RootConstrainSelectedInstOperands,
     /*  740869 */     // GIR_Coverage, 12204,
     /*  740869 */     GIR_EraseRootFromParent_Done,
     /*  740870 */   // Label 11607: @740870
     /*  740870 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(740945), // Rule ID 12205 //
     /*  740875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  740895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  740924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740943 */     GIR_RootConstrainSelectedInstOperands,
     /*  740944 */     // GIR_Coverage, 12205,
     /*  740944 */     GIR_EraseRootFromParent_Done,
     /*  740945 */   // Label 11608: @740945
     /*  740945 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(741020), // Rule ID 12208 //
     /*  740950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  740970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  740999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741018 */     GIR_RootConstrainSelectedInstOperands,
     /*  741019 */     // GIR_Coverage, 12208,
     /*  741019 */     GIR_EraseRootFromParent_Done,
     /*  741020 */   // Label 11609: @741020
     /*  741020 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(741095), // Rule ID 12209 //
     /*  741025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  741036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  741039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  741042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  741045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741071 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  741074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741093 */     GIR_RootConstrainSelectedInstOperands,
     /*  741094 */     // GIR_Coverage, 12209,
     /*  741094 */     GIR_EraseRootFromParent_Done,
     /*  741095 */   // Label 11610: @741095
     /*  741095 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(741170), // Rule ID 12212 //
     /*  741100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  741149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741168 */     GIR_RootConstrainSelectedInstOperands,
     /*  741169 */     // GIR_Coverage, 12212,
     /*  741169 */     GIR_EraseRootFromParent_Done,
     /*  741170 */   // Label 11611: @741170
     /*  741170 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(741245), // Rule ID 12213 //
     /*  741175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  741186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  741189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  741192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  741195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741221 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  741224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741243 */     GIR_RootConstrainSelectedInstOperands,
     /*  741244 */     // GIR_Coverage, 12213,
     /*  741244 */     GIR_EraseRootFromParent_Done,
     /*  741245 */   // Label 11612: @741245
     /*  741245 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(741320), // Rule ID 12216 //
     /*  741250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  741299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741318 */     GIR_RootConstrainSelectedInstOperands,
     /*  741319 */     // GIR_Coverage, 12216,
     /*  741319 */     GIR_EraseRootFromParent_Done,
     /*  741320 */   // Label 11613: @741320
     /*  741320 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(741395), // Rule ID 12217 //
     /*  741325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  741336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  741339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  741342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  741345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741371 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  741374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741393 */     GIR_RootConstrainSelectedInstOperands,
     /*  741394 */     // GIR_Coverage, 12217,
     /*  741394 */     GIR_EraseRootFromParent_Done,
     /*  741395 */   // Label 11614: @741395
     /*  741395 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(741470), // Rule ID 12220 //
     /*  741400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  741403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  741446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  741449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741468 */     GIR_RootConstrainSelectedInstOperands,
     /*  741469 */     // GIR_Coverage, 12220,
     /*  741469 */     GIR_EraseRootFromParent_Done,
     /*  741470 */   // Label 11615: @741470
     /*  741470 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(741545), // Rule ID 12221 //
     /*  741475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  741478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  741486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  741489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  741492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  741495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  741514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741521 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  741521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  741524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741543 */     GIR_RootConstrainSelectedInstOperands,
     /*  741544 */     // GIR_Coverage, 12221,
     /*  741544 */     GIR_EraseRootFromParent_Done,
     /*  741545 */   // Label 11616: @741545
     /*  741545 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(741620), // Rule ID 12224 //
     /*  741550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  741570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  741599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741618 */     GIR_RootConstrainSelectedInstOperands,
     /*  741619 */     // GIR_Coverage, 12224,
     /*  741619 */     GIR_EraseRootFromParent_Done,
     /*  741620 */   // Label 11617: @741620
     /*  741620 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(741695), // Rule ID 12225 //
     /*  741625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  741645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  741674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741693 */     GIR_RootConstrainSelectedInstOperands,
     /*  741694 */     // GIR_Coverage, 12225,
     /*  741694 */     GIR_EraseRootFromParent_Done,
     /*  741695 */   // Label 11618: @741695
     /*  741695 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(741770), // Rule ID 12228 //
     /*  741700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  741720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  741749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741768 */     GIR_RootConstrainSelectedInstOperands,
     /*  741769 */     // GIR_Coverage, 12228,
     /*  741769 */     GIR_EraseRootFromParent_Done,
     /*  741770 */   // Label 11619: @741770
     /*  741770 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(741845), // Rule ID 12229 //
     /*  741775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  741795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741821 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  741824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741843 */     GIR_RootConstrainSelectedInstOperands,
     /*  741844 */     // GIR_Coverage, 12229,
     /*  741844 */     GIR_EraseRootFromParent_Done,
     /*  741845 */   // Label 11620: @741845
     /*  741845 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(741920), // Rule ID 12232 //
     /*  741850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  741870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741896 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  741899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741918 */     GIR_RootConstrainSelectedInstOperands,
     /*  741919 */     // GIR_Coverage, 12232,
     /*  741919 */     GIR_EraseRootFromParent_Done,
     /*  741920 */   // Label 11621: @741920
     /*  741920 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(741995), // Rule ID 12233 //
     /*  741925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  741945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741971 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  741974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741993 */     GIR_RootConstrainSelectedInstOperands,
     /*  741994 */     // GIR_Coverage, 12233,
     /*  741994 */     GIR_EraseRootFromParent_Done,
     /*  741995 */   // Label 11622: @741995
     /*  741995 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(742070), // Rule ID 12236 //
     /*  742000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  742020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  742049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742068 */     GIR_RootConstrainSelectedInstOperands,
     /*  742069 */     // GIR_Coverage, 12236,
     /*  742069 */     GIR_EraseRootFromParent_Done,
     /*  742070 */   // Label 11623: @742070
     /*  742070 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(742145), // Rule ID 12237 //
     /*  742075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  742092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  742095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  742124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742143 */     GIR_RootConstrainSelectedInstOperands,
     /*  742144 */     // GIR_Coverage, 12237,
     /*  742144 */     GIR_EraseRootFromParent_Done,
     /*  742145 */   // Label 11624: @742145
     /*  742145 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(742220), // Rule ID 12240 //
     /*  742150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  742170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  742199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742218 */     GIR_RootConstrainSelectedInstOperands,
     /*  742219 */     // GIR_Coverage, 12240,
     /*  742219 */     GIR_EraseRootFromParent_Done,
     /*  742220 */   // Label 11625: @742220
     /*  742220 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(742295), // Rule ID 12241 //
     /*  742225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  742242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  742245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742271 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  742274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742293 */     GIR_RootConstrainSelectedInstOperands,
     /*  742294 */     // GIR_Coverage, 12241,
     /*  742294 */     GIR_EraseRootFromParent_Done,
     /*  742295 */   // Label 11626: @742295
     /*  742295 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(742370), // Rule ID 12244 //
     /*  742300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  742320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  742346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  742349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742368 */     GIR_RootConstrainSelectedInstOperands,
     /*  742369 */     // GIR_Coverage, 12244,
     /*  742369 */     GIR_EraseRootFromParent_Done,
     /*  742370 */   // Label 11627: @742370
     /*  742370 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(742445), // Rule ID 12245 //
     /*  742375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  742386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  742389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  742392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  742395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742421 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  742421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  742424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  742440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742443 */     GIR_RootConstrainSelectedInstOperands,
     /*  742444 */     // GIR_Coverage, 12245,
     /*  742444 */     GIR_EraseRootFromParent_Done,
     /*  742445 */   // Label 11628: @742445
     /*  742445 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(742520), // Rule ID 12248 //
     /*  742450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  742470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  742499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742518 */     GIR_RootConstrainSelectedInstOperands,
     /*  742519 */     // GIR_Coverage, 12248,
     /*  742519 */     GIR_EraseRootFromParent_Done,
     /*  742520 */   // Label 11629: @742520
     /*  742520 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(742595), // Rule ID 12249 //
     /*  742525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  742536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  742539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  742542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  742545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  742574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742593 */     GIR_RootConstrainSelectedInstOperands,
     /*  742594 */     // GIR_Coverage, 12249,
     /*  742594 */     GIR_EraseRootFromParent_Done,
     /*  742595 */   // Label 11630: @742595
     /*  742595 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(742670), // Rule ID 12252 //
     /*  742600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  742620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  742649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742668 */     GIR_RootConstrainSelectedInstOperands,
     /*  742669 */     // GIR_Coverage, 12252,
     /*  742669 */     GIR_EraseRootFromParent_Done,
     /*  742670 */   // Label 11631: @742670
     /*  742670 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(742745), // Rule ID 12253 //
     /*  742675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  742695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  742724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742743 */     GIR_RootConstrainSelectedInstOperands,
     /*  742744 */     // GIR_Coverage, 12253,
     /*  742744 */     GIR_EraseRootFromParent_Done,
     /*  742745 */   // Label 11632: @742745
     /*  742745 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(742820), // Rule ID 12256 //
     /*  742750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  742770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  742799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742818 */     GIR_RootConstrainSelectedInstOperands,
     /*  742819 */     // GIR_Coverage, 12256,
     /*  742819 */     GIR_EraseRootFromParent_Done,
     /*  742820 */   // Label 11633: @742820
     /*  742820 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(742895), // Rule ID 12257 //
     /*  742825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  742845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742871 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  742874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742893 */     GIR_RootConstrainSelectedInstOperands,
     /*  742894 */     // GIR_Coverage, 12257,
     /*  742894 */     GIR_EraseRootFromParent_Done,
     /*  742895 */   // Label 11634: @742895
     /*  742895 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(742970), // Rule ID 12260 //
     /*  742900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  742920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  742949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742968 */     GIR_RootConstrainSelectedInstOperands,
     /*  742969 */     // GIR_Coverage, 12260,
     /*  742969 */     GIR_EraseRootFromParent_Done,
     /*  742970 */   // Label 11635: @742970
     /*  742970 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(743045), // Rule ID 12261 //
     /*  742975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  742995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  743024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743043 */     GIR_RootConstrainSelectedInstOperands,
     /*  743044 */     // GIR_Coverage, 12261,
     /*  743044 */     GIR_EraseRootFromParent_Done,
     /*  743045 */   // Label 11636: @743045
     /*  743045 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(743120), // Rule ID 12264 //
     /*  743050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  743070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  743099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743118 */     GIR_RootConstrainSelectedInstOperands,
     /*  743119 */     // GIR_Coverage, 12264,
     /*  743119 */     GIR_EraseRootFromParent_Done,
     /*  743120 */   // Label 11637: @743120
     /*  743120 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(743195), // Rule ID 12265 //
     /*  743125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  743136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  743139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  743142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  743145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  743174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743193 */     GIR_RootConstrainSelectedInstOperands,
     /*  743194 */     // GIR_Coverage, 12265,
     /*  743194 */     GIR_EraseRootFromParent_Done,
     /*  743195 */   // Label 11638: @743195
     /*  743195 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(743270), // Rule ID 12268 //
     /*  743200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  743203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  743220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  743246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  743249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743268 */     GIR_RootConstrainSelectedInstOperands,
     /*  743269 */     // GIR_Coverage, 12268,
     /*  743269 */     GIR_EraseRootFromParent_Done,
     /*  743270 */   // Label 11639: @743270
     /*  743270 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(743345), // Rule ID 12269 //
     /*  743275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  743278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  743286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  743289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  743292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  743295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  743321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  743324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  743340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743343 */     GIR_RootConstrainSelectedInstOperands,
     /*  743344 */     // GIR_Coverage, 12269,
     /*  743344 */     GIR_EraseRootFromParent_Done,
     /*  743345 */   // Label 11640: @743345
     /*  743345 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(743420), // Rule ID 12272 //
     /*  743350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  743361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  743364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  743399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743418 */     GIR_RootConstrainSelectedInstOperands,
     /*  743419 */     // GIR_Coverage, 12272,
     /*  743419 */     GIR_EraseRootFromParent_Done,
     /*  743420 */   // Label 11641: @743420
     /*  743420 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(743495), // Rule ID 12273 //
     /*  743425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  743436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  743439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  743442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743471 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  743474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743493 */     GIR_RootConstrainSelectedInstOperands,
     /*  743494 */     // GIR_Coverage, 12273,
     /*  743494 */     GIR_EraseRootFromParent_Done,
     /*  743495 */   // Label 11642: @743495
     /*  743495 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(743570), // Rule ID 12276 //
     /*  743500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  743511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  743514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  743549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743568 */     GIR_RootConstrainSelectedInstOperands,
     /*  743569 */     // GIR_Coverage, 12276,
     /*  743569 */     GIR_EraseRootFromParent_Done,
     /*  743570 */   // Label 11643: @743570
     /*  743570 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(743645), // Rule ID 12277 //
     /*  743575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  743586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  743589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743621 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  743624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743643 */     GIR_RootConstrainSelectedInstOperands,
     /*  743644 */     // GIR_Coverage, 12277,
     /*  743644 */     GIR_EraseRootFromParent_Done,
     /*  743645 */   // Label 11644: @743645
     /*  743645 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(743720), // Rule ID 12280 //
     /*  743650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  743661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  743664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  743699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743718 */     GIR_RootConstrainSelectedInstOperands,
     /*  743719 */     // GIR_Coverage, 12280,
     /*  743719 */     GIR_EraseRootFromParent_Done,
     /*  743720 */   // Label 11645: @743720
     /*  743720 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(743795), // Rule ID 12281 //
     /*  743725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  743736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  743739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743771 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  743774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743793 */     GIR_RootConstrainSelectedInstOperands,
     /*  743794 */     // GIR_Coverage, 12281,
     /*  743794 */     GIR_EraseRootFromParent_Done,
     /*  743795 */   // Label 11646: @743795
     /*  743795 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(743870), // Rule ID 12284 //
     /*  743800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  743849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743868 */     GIR_RootConstrainSelectedInstOperands,
     /*  743869 */     // GIR_Coverage, 12284,
     /*  743869 */     GIR_EraseRootFromParent_Done,
     /*  743870 */   // Label 11647: @743870
     /*  743870 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(743945), // Rule ID 12285 //
     /*  743875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  743886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  743889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  743895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743921 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  743924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743943 */     GIR_RootConstrainSelectedInstOperands,
     /*  743944 */     // GIR_Coverage, 12285,
     /*  743944 */     GIR_EraseRootFromParent_Done,
     /*  743945 */   // Label 11648: @743945
     /*  743945 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(744020), // Rule ID 12288 //
     /*  743950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  743958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  743970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  743989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  743999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744018 */     GIR_RootConstrainSelectedInstOperands,
     /*  744019 */     // GIR_Coverage, 12288,
     /*  744019 */     GIR_EraseRootFromParent_Done,
     /*  744020 */   // Label 11649: @744020
     /*  744020 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(744095), // Rule ID 12289 //
     /*  744025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  744036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  744039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  744042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744071 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  744074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744093 */     GIR_RootConstrainSelectedInstOperands,
     /*  744094 */     // GIR_Coverage, 12289,
     /*  744094 */     GIR_EraseRootFromParent_Done,
     /*  744095 */   // Label 11650: @744095
     /*  744095 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(744170), // Rule ID 12292 //
     /*  744100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  744149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744168 */     GIR_RootConstrainSelectedInstOperands,
     /*  744169 */     // GIR_Coverage, 12292,
     /*  744169 */     GIR_EraseRootFromParent_Done,
     /*  744170 */   // Label 11651: @744170
     /*  744170 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(744245), // Rule ID 12293 //
     /*  744175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  744186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  744189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744221 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  744224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744243 */     GIR_RootConstrainSelectedInstOperands,
     /*  744244 */     // GIR_Coverage, 12293,
     /*  744244 */     GIR_EraseRootFromParent_Done,
     /*  744245 */   // Label 11652: @744245
     /*  744245 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(744320), // Rule ID 12296 //
     /*  744250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  744261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  744264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  744267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  744299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744318 */     GIR_RootConstrainSelectedInstOperands,
     /*  744319 */     // GIR_Coverage, 12296,
     /*  744319 */     GIR_EraseRootFromParent_Done,
     /*  744320 */   // Label 11653: @744320
     /*  744320 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(744395), // Rule ID 12297 //
     /*  744325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  744336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  744339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  744342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744371 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  744374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744393 */     GIR_RootConstrainSelectedInstOperands,
     /*  744394 */     // GIR_Coverage, 12297,
     /*  744394 */     GIR_EraseRootFromParent_Done,
     /*  744395 */   // Label 11654: @744395
     /*  744395 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(744470), // Rule ID 12300 //
     /*  744400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  744449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744468 */     GIR_RootConstrainSelectedInstOperands,
     /*  744469 */     // GIR_Coverage, 12300,
     /*  744469 */     GIR_EraseRootFromParent_Done,
     /*  744470 */   // Label 11655: @744470
     /*  744470 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(744545), // Rule ID 12301 //
     /*  744475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  744524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744543 */     GIR_RootConstrainSelectedInstOperands,
     /*  744544 */     // GIR_Coverage, 12301,
     /*  744544 */     GIR_EraseRootFromParent_Done,
     /*  744545 */   // Label 11656: @744545
     /*  744545 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(744620), // Rule ID 12304 //
     /*  744550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  744599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744618 */     GIR_RootConstrainSelectedInstOperands,
     /*  744619 */     // GIR_Coverage, 12304,
     /*  744619 */     GIR_EraseRootFromParent_Done,
     /*  744620 */   // Label 11657: @744620
     /*  744620 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(744695), // Rule ID 12305 //
     /*  744625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  744636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  744639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  744674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744693 */     GIR_RootConstrainSelectedInstOperands,
     /*  744694 */     // GIR_Coverage, 12305,
     /*  744694 */     GIR_EraseRootFromParent_Done,
     /*  744695 */   // Label 11658: @744695
     /*  744695 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(744770), // Rule ID 12308 //
     /*  744700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  744703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  744746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  744749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744768 */     GIR_RootConstrainSelectedInstOperands,
     /*  744769 */     // GIR_Coverage, 12308,
     /*  744769 */     GIR_EraseRootFromParent_Done,
     /*  744770 */   // Label 11659: @744770
     /*  744770 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(744845), // Rule ID 12309 //
     /*  744775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  744778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  744792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744821 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  744821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  744824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  744840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744843 */     GIR_RootConstrainSelectedInstOperands,
     /*  744844 */     // GIR_Coverage, 12309,
     /*  744844 */     GIR_EraseRootFromParent_Done,
     /*  744845 */   // Label 11660: @744845
     /*  744845 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(744920), // Rule ID 12312 //
     /*  744850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  744861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  744864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  744867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  744899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744918 */     GIR_RootConstrainSelectedInstOperands,
     /*  744919 */     // GIR_Coverage, 12312,
     /*  744919 */     GIR_EraseRootFromParent_Done,
     /*  744920 */   // Label 11661: @744920
     /*  744920 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(744995), // Rule ID 12313 //
     /*  744925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  744933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  744936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  744939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  744942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  744974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744993 */     GIR_RootConstrainSelectedInstOperands,
     /*  744994 */     // GIR_Coverage, 12313,
     /*  744994 */     GIR_EraseRootFromParent_Done,
     /*  744995 */   // Label 11662: @744995
     /*  744995 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(745070), // Rule ID 12316 //
     /*  745000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  745011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  745014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  745049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745068 */     GIR_RootConstrainSelectedInstOperands,
     /*  745069 */     // GIR_Coverage, 12316,
     /*  745069 */     GIR_EraseRootFromParent_Done,
     /*  745070 */   // Label 11663: @745070
     /*  745070 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(745145), // Rule ID 12317 //
     /*  745075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  745086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  745089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745121 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  745124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745143 */     GIR_RootConstrainSelectedInstOperands,
     /*  745144 */     // GIR_Coverage, 12317,
     /*  745144 */     GIR_EraseRootFromParent_Done,
     /*  745145 */   // Label 11664: @745145
     /*  745145 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(745220), // Rule ID 12320 //
     /*  745150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  745161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  745164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  745167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  745199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745218 */     GIR_RootConstrainSelectedInstOperands,
     /*  745219 */     // GIR_Coverage, 12320,
     /*  745219 */     GIR_EraseRootFromParent_Done,
     /*  745220 */   // Label 11665: @745220
     /*  745220 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(745295), // Rule ID 12321 //
     /*  745225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  745236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  745239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  745242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745271 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  745274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745293 */     GIR_RootConstrainSelectedInstOperands,
     /*  745294 */     // GIR_Coverage, 12321,
     /*  745294 */     GIR_EraseRootFromParent_Done,
     /*  745295 */   // Label 11666: @745295
     /*  745295 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(745370), // Rule ID 12324 //
     /*  745300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  745349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745368 */     GIR_RootConstrainSelectedInstOperands,
     /*  745369 */     // GIR_Coverage, 12324,
     /*  745369 */     GIR_EraseRootFromParent_Done,
     /*  745370 */   // Label 11667: @745370
     /*  745370 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(745445), // Rule ID 12325 //
     /*  745375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  745424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745443 */     GIR_RootConstrainSelectedInstOperands,
     /*  745444 */     // GIR_Coverage, 12325,
     /*  745444 */     GIR_EraseRootFromParent_Done,
     /*  745445 */   // Label 11668: @745445
     /*  745445 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(745520), // Rule ID 12328 //
     /*  745450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  745467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  745499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745518 */     GIR_RootConstrainSelectedInstOperands,
     /*  745519 */     // GIR_Coverage, 12328,
     /*  745519 */     GIR_EraseRootFromParent_Done,
     /*  745520 */   // Label 11669: @745520
     /*  745520 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(745595), // Rule ID 12329 //
     /*  745525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  745542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  745574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745593 */     GIR_RootConstrainSelectedInstOperands,
     /*  745594 */     // GIR_Coverage, 12329,
     /*  745594 */     GIR_EraseRootFromParent_Done,
     /*  745595 */   // Label 11670: @745595
     /*  745595 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(745670), // Rule ID 12332 //
     /*  745600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  745617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  745649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745668 */     GIR_RootConstrainSelectedInstOperands,
     /*  745669 */     // GIR_Coverage, 12332,
     /*  745669 */     GIR_EraseRootFromParent_Done,
     /*  745670 */   // Label 11671: @745670
     /*  745670 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(745745), // Rule ID 12333 //
     /*  745675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  745692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745721 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  745724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745743 */     GIR_RootConstrainSelectedInstOperands,
     /*  745744 */     // GIR_Coverage, 12333,
     /*  745744 */     GIR_EraseRootFromParent_Done,
     /*  745745 */   // Label 11672: @745745
     /*  745745 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(745820), // Rule ID 12336 //
     /*  745750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  745799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745818 */     GIR_RootConstrainSelectedInstOperands,
     /*  745819 */     // GIR_Coverage, 12336,
     /*  745819 */     GIR_EraseRootFromParent_Done,
     /*  745820 */   // Label 11673: @745820
     /*  745820 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(745895), // Rule ID 12337 //
     /*  745825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  745842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  745874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745893 */     GIR_RootConstrainSelectedInstOperands,
     /*  745894 */     // GIR_Coverage, 12337,
     /*  745894 */     GIR_EraseRootFromParent_Done,
     /*  745895 */   // Label 11674: @745895
     /*  745895 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(745970), // Rule ID 12340 //
     /*  745900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  745946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  745949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745968 */     GIR_RootConstrainSelectedInstOperands,
     /*  745969 */     // GIR_Coverage, 12340,
     /*  745969 */     GIR_EraseRootFromParent_Done,
     /*  745970 */   // Label 11675: @745970
     /*  745970 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(746045), // Rule ID 12341 //
     /*  745975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  745983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  745992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  746024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746043 */     GIR_RootConstrainSelectedInstOperands,
     /*  746044 */     // GIR_Coverage, 12341,
     /*  746044 */     GIR_EraseRootFromParent_Done,
     /*  746045 */   // Label 11676: @746045
     /*  746045 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(746120), // Rule ID 12344 //
     /*  746050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  746067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  746099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746118 */     GIR_RootConstrainSelectedInstOperands,
     /*  746119 */     // GIR_Coverage, 12344,
     /*  746119 */     GIR_EraseRootFromParent_Done,
     /*  746120 */   // Label 11677: @746120
     /*  746120 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(746195), // Rule ID 12345 //
     /*  746125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  746142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  746174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746193 */     GIR_RootConstrainSelectedInstOperands,
     /*  746194 */     // GIR_Coverage, 12345,
     /*  746194 */     GIR_EraseRootFromParent_Done,
     /*  746195 */   // Label 11678: @746195
     /*  746195 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(746270), // Rule ID 12348 //
     /*  746200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  746217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  746249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746268 */     GIR_RootConstrainSelectedInstOperands,
     /*  746269 */     // GIR_Coverage, 12348,
     /*  746269 */     GIR_EraseRootFromParent_Done,
     /*  746270 */   // Label 11679: @746270
     /*  746270 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(746345), // Rule ID 12349 //
     /*  746275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  746292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  746324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746343 */     GIR_RootConstrainSelectedInstOperands,
     /*  746344 */     // GIR_Coverage, 12349,
     /*  746344 */     GIR_EraseRootFromParent_Done,
     /*  746345 */   // Label 11680: @746345
     /*  746345 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(746420), // Rule ID 12352 //
     /*  746350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  746367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  746399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746418 */     GIR_RootConstrainSelectedInstOperands,
     /*  746419 */     // GIR_Coverage, 12352,
     /*  746419 */     GIR_EraseRootFromParent_Done,
     /*  746420 */   // Label 11681: @746420
     /*  746420 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(746495), // Rule ID 12353 //
     /*  746425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  746442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  746474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746493 */     GIR_RootConstrainSelectedInstOperands,
     /*  746494 */     // GIR_Coverage, 12353,
     /*  746494 */     GIR_EraseRootFromParent_Done,
     /*  746495 */   // Label 11682: @746495
     /*  746495 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(746570), // Rule ID 12356 //
     /*  746500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  746503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  746517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  746546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  746549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746568 */     GIR_RootConstrainSelectedInstOperands,
     /*  746569 */     // GIR_Coverage, 12356,
     /*  746569 */     GIR_EraseRootFromParent_Done,
     /*  746570 */   // Label 11683: @746570
     /*  746570 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(746645), // Rule ID 12357 //
     /*  746575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  746578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  746583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  746592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  746621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  746624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  746640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746643 */     GIR_RootConstrainSelectedInstOperands,
     /*  746644 */     // GIR_Coverage, 12357,
     /*  746644 */     GIR_EraseRootFromParent_Done,
     /*  746645 */   // Label 11684: @746645
     /*  746645 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(746720), // Rule ID 12360 //
     /*  746650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  746699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746718 */     GIR_RootConstrainSelectedInstOperands,
     /*  746719 */     // GIR_Coverage, 12360,
     /*  746719 */     GIR_EraseRootFromParent_Done,
     /*  746720 */   // Label 11685: @746720
     /*  746720 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(746795), // Rule ID 12361 //
     /*  746725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  746774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746793 */     GIR_RootConstrainSelectedInstOperands,
     /*  746794 */     // GIR_Coverage, 12361,
     /*  746794 */     GIR_EraseRootFromParent_Done,
     /*  746795 */   // Label 11686: @746795
     /*  746795 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(746870), // Rule ID 12364 //
     /*  746800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  746811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  746814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  746817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  746820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  746849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746868 */     GIR_RootConstrainSelectedInstOperands,
     /*  746869 */     // GIR_Coverage, 12364,
     /*  746869 */     GIR_EraseRootFromParent_Done,
     /*  746870 */   // Label 11687: @746870
     /*  746870 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(746945), // Rule ID 12365 //
     /*  746875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  746886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  746889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  746892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  746895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  746924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746943 */     GIR_RootConstrainSelectedInstOperands,
     /*  746944 */     // GIR_Coverage, 12365,
     /*  746944 */     GIR_EraseRootFromParent_Done,
     /*  746945 */   // Label 11688: @746945
     /*  746945 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(747020), // Rule ID 12368 //
     /*  746950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  746961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  746964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  746967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  746970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  746999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747018 */     GIR_RootConstrainSelectedInstOperands,
     /*  747019 */     // GIR_Coverage, 12368,
     /*  747019 */     GIR_EraseRootFromParent_Done,
     /*  747020 */   // Label 11689: @747020
     /*  747020 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(747095), // Rule ID 12369 //
     /*  747025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747093 */     GIR_RootConstrainSelectedInstOperands,
     /*  747094 */     // GIR_Coverage, 12369,
     /*  747094 */     GIR_EraseRootFromParent_Done,
     /*  747095 */   // Label 11690: @747095
     /*  747095 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(747170), // Rule ID 12372 //
     /*  747100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747168 */     GIR_RootConstrainSelectedInstOperands,
     /*  747169 */     // GIR_Coverage, 12372,
     /*  747169 */     GIR_EraseRootFromParent_Done,
     /*  747170 */   // Label 11691: @747170
     /*  747170 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(747245), // Rule ID 12373 //
     /*  747175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747243 */     GIR_RootConstrainSelectedInstOperands,
     /*  747244 */     // GIR_Coverage, 12373,
     /*  747244 */     GIR_EraseRootFromParent_Done,
     /*  747245 */   // Label 11692: @747245
     /*  747245 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(747320), // Rule ID 12376 //
     /*  747250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  747299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747318 */     GIR_RootConstrainSelectedInstOperands,
     /*  747319 */     // GIR_Coverage, 12376,
     /*  747319 */     GIR_EraseRootFromParent_Done,
     /*  747320 */   // Label 11693: @747320
     /*  747320 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(747395), // Rule ID 12377 //
     /*  747325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  747374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747393 */     GIR_RootConstrainSelectedInstOperands,
     /*  747394 */     // GIR_Coverage, 12377,
     /*  747394 */     GIR_EraseRootFromParent_Done,
     /*  747395 */   // Label 11694: @747395
     /*  747395 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(747470), // Rule ID 12380 //
     /*  747400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  747449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747468 */     GIR_RootConstrainSelectedInstOperands,
     /*  747469 */     // GIR_Coverage, 12380,
     /*  747469 */     GIR_EraseRootFromParent_Done,
     /*  747470 */   // Label 11695: @747470
     /*  747470 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(747545), // Rule ID 12381 //
     /*  747475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  747524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747543 */     GIR_RootConstrainSelectedInstOperands,
     /*  747544 */     // GIR_Coverage, 12381,
     /*  747544 */     GIR_EraseRootFromParent_Done,
     /*  747545 */   // Label 11696: @747545
     /*  747545 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(747620), // Rule ID 12384 //
     /*  747550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  747599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747618 */     GIR_RootConstrainSelectedInstOperands,
     /*  747619 */     // GIR_Coverage, 12384,
     /*  747619 */     GIR_EraseRootFromParent_Done,
     /*  747620 */   // Label 11697: @747620
     /*  747620 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(747695), // Rule ID 12385 //
     /*  747625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  747674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747693 */     GIR_RootConstrainSelectedInstOperands,
     /*  747694 */     // GIR_Coverage, 12385,
     /*  747694 */     GIR_EraseRootFromParent_Done,
     /*  747695 */   // Label 11698: @747695
     /*  747695 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(747770), // Rule ID 12388 //
     /*  747700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747768 */     GIR_RootConstrainSelectedInstOperands,
     /*  747769 */     // GIR_Coverage, 12388,
     /*  747769 */     GIR_EraseRootFromParent_Done,
     /*  747770 */   // Label 11699: @747770
     /*  747770 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(747845), // Rule ID 12389 //
     /*  747775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  747824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747843 */     GIR_RootConstrainSelectedInstOperands,
     /*  747844 */     // GIR_Coverage, 12389,
     /*  747844 */     GIR_EraseRootFromParent_Done,
     /*  747845 */   // Label 11700: @747845
     /*  747845 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(747920), // Rule ID 12392 //
     /*  747850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  747861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  747864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  747867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  747870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747918 */     GIR_RootConstrainSelectedInstOperands,
     /*  747919 */     // GIR_Coverage, 12392,
     /*  747919 */     GIR_EraseRootFromParent_Done,
     /*  747920 */   // Label 11701: @747920
     /*  747920 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(747995), // Rule ID 12393 //
     /*  747925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  747936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  747939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  747942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  747945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  747974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747993 */     GIR_RootConstrainSelectedInstOperands,
     /*  747994 */     // GIR_Coverage, 12393,
     /*  747994 */     GIR_EraseRootFromParent_Done,
     /*  747995 */   // Label 11702: @747995
     /*  747995 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(748070), // Rule ID 12396 //
     /*  748000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748068 */     GIR_RootConstrainSelectedInstOperands,
     /*  748069 */     // GIR_Coverage, 12396,
     /*  748069 */     GIR_EraseRootFromParent_Done,
     /*  748070 */   // Label 11703: @748070
     /*  748070 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(748145), // Rule ID 12397 //
     /*  748075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748143 */     GIR_RootConstrainSelectedInstOperands,
     /*  748144 */     // GIR_Coverage, 12397,
     /*  748144 */     GIR_EraseRootFromParent_Done,
     /*  748145 */   // Label 11704: @748145
     /*  748145 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(748220), // Rule ID 12400 //
     /*  748150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748218 */     GIR_RootConstrainSelectedInstOperands,
     /*  748219 */     // GIR_Coverage, 12400,
     /*  748219 */     GIR_EraseRootFromParent_Done,
     /*  748220 */   // Label 11705: @748220
     /*  748220 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(748295), // Rule ID 12401 //
     /*  748225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748293 */     GIR_RootConstrainSelectedInstOperands,
     /*  748294 */     // GIR_Coverage, 12401,
     /*  748294 */     GIR_EraseRootFromParent_Done,
     /*  748295 */   // Label 11706: @748295
     /*  748295 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(748370), // Rule ID 12404 //
     /*  748300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  748349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748368 */     GIR_RootConstrainSelectedInstOperands,
     /*  748369 */     // GIR_Coverage, 12404,
     /*  748369 */     GIR_EraseRootFromParent_Done,
     /*  748370 */   // Label 11707: @748370
     /*  748370 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(748445), // Rule ID 12405 //
     /*  748375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  748424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748443 */     GIR_RootConstrainSelectedInstOperands,
     /*  748444 */     // GIR_Coverage, 12405,
     /*  748444 */     GIR_EraseRootFromParent_Done,
     /*  748445 */   // Label 11708: @748445
     /*  748445 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(748520), // Rule ID 12408 //
     /*  748450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  748499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748518 */     GIR_RootConstrainSelectedInstOperands,
     /*  748519 */     // GIR_Coverage, 12408,
     /*  748519 */     GIR_EraseRootFromParent_Done,
     /*  748520 */   // Label 11709: @748520
     /*  748520 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(748595), // Rule ID 12409 //
     /*  748525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  748574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748593 */     GIR_RootConstrainSelectedInstOperands,
     /*  748594 */     // GIR_Coverage, 12409,
     /*  748594 */     GIR_EraseRootFromParent_Done,
     /*  748595 */   // Label 11710: @748595
     /*  748595 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(748670), // Rule ID 12412 //
     /*  748600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748668 */     GIR_RootConstrainSelectedInstOperands,
     /*  748669 */     // GIR_Coverage, 12412,
     /*  748669 */     GIR_EraseRootFromParent_Done,
     /*  748670 */   // Label 11711: @748670
     /*  748670 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(748745), // Rule ID 12413 //
     /*  748675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  748724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748743 */     GIR_RootConstrainSelectedInstOperands,
     /*  748744 */     // GIR_Coverage, 12413,
     /*  748744 */     GIR_EraseRootFromParent_Done,
     /*  748745 */   // Label 11712: @748745
     /*  748745 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(748820), // Rule ID 12416 //
     /*  748750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748818 */     GIR_RootConstrainSelectedInstOperands,
     /*  748819 */     // GIR_Coverage, 12416,
     /*  748819 */     GIR_EraseRootFromParent_Done,
     /*  748820 */   // Label 11713: @748820
     /*  748820 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(748895), // Rule ID 12417 //
     /*  748825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748871 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  748874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748893 */     GIR_RootConstrainSelectedInstOperands,
     /*  748894 */     // GIR_Coverage, 12417,
     /*  748894 */     GIR_EraseRootFromParent_Done,
     /*  748895 */   // Label 11714: @748895
     /*  748895 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(748970), // Rule ID 12420 //
     /*  748900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  748911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  748914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  748917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  748920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  748939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  748949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748968 */     GIR_RootConstrainSelectedInstOperands,
     /*  748969 */     // GIR_Coverage, 12420,
     /*  748969 */     GIR_EraseRootFromParent_Done,
     /*  748970 */   // Label 11715: @748970
     /*  748970 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(749045), // Rule ID 12421 //
     /*  748975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  748983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  748986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  748989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  748992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  748995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  749024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749043 */     GIR_RootConstrainSelectedInstOperands,
     /*  749044 */     // GIR_Coverage, 12421,
     /*  749044 */     GIR_EraseRootFromParent_Done,
     /*  749045 */   // Label 11716: @749045
     /*  749045 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(749120), // Rule ID 12424 //
     /*  749050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749118 */     GIR_RootConstrainSelectedInstOperands,
     /*  749119 */     // GIR_Coverage, 12424,
     /*  749119 */     GIR_EraseRootFromParent_Done,
     /*  749120 */   // Label 11717: @749120
     /*  749120 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(749195), // Rule ID 12425 //
     /*  749125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749193 */     GIR_RootConstrainSelectedInstOperands,
     /*  749194 */     // GIR_Coverage, 12425,
     /*  749194 */     GIR_EraseRootFromParent_Done,
     /*  749195 */   // Label 11718: @749195
     /*  749195 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(749270), // Rule ID 12428 //
     /*  749200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749268 */     GIR_RootConstrainSelectedInstOperands,
     /*  749269 */     // GIR_Coverage, 12428,
     /*  749269 */     GIR_EraseRootFromParent_Done,
     /*  749270 */   // Label 11719: @749270
     /*  749270 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(749345), // Rule ID 12429 //
     /*  749275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749343 */     GIR_RootConstrainSelectedInstOperands,
     /*  749344 */     // GIR_Coverage, 12429,
     /*  749344 */     GIR_EraseRootFromParent_Done,
     /*  749345 */   // Label 11720: @749345
     /*  749345 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(749420), // Rule ID 12432 //
     /*  749350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  749399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749418 */     GIR_RootConstrainSelectedInstOperands,
     /*  749419 */     // GIR_Coverage, 12432,
     /*  749419 */     GIR_EraseRootFromParent_Done,
     /*  749420 */   // Label 11721: @749420
     /*  749420 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(749495), // Rule ID 12433 //
     /*  749425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  749474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749493 */     GIR_RootConstrainSelectedInstOperands,
     /*  749494 */     // GIR_Coverage, 12433,
     /*  749494 */     GIR_EraseRootFromParent_Done,
     /*  749495 */   // Label 11722: @749495
     /*  749495 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(749570), // Rule ID 12436 //
     /*  749500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  749549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749568 */     GIR_RootConstrainSelectedInstOperands,
     /*  749569 */     // GIR_Coverage, 12436,
     /*  749569 */     GIR_EraseRootFromParent_Done,
     /*  749570 */   // Label 11723: @749570
     /*  749570 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(749645), // Rule ID 12437 //
     /*  749575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  749624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749643 */     GIR_RootConstrainSelectedInstOperands,
     /*  749644 */     // GIR_Coverage, 12437,
     /*  749644 */     GIR_EraseRootFromParent_Done,
     /*  749645 */   // Label 11724: @749645
     /*  749645 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(749720), // Rule ID 12440 //
     /*  749650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  749699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749718 */     GIR_RootConstrainSelectedInstOperands,
     /*  749719 */     // GIR_Coverage, 12440,
     /*  749719 */     GIR_EraseRootFromParent_Done,
     /*  749720 */   // Label 11725: @749720
     /*  749720 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(749795), // Rule ID 12441 //
     /*  749725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  749774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749793 */     GIR_RootConstrainSelectedInstOperands,
     /*  749794 */     // GIR_Coverage, 12441,
     /*  749794 */     GIR_EraseRootFromParent_Done,
     /*  749795 */   // Label 11726: @749795
     /*  749795 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(749870), // Rule ID 12444 //
     /*  749800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  749811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  749814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  749817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749868 */     GIR_RootConstrainSelectedInstOperands,
     /*  749869 */     // GIR_Coverage, 12444,
     /*  749869 */     GIR_EraseRootFromParent_Done,
     /*  749870 */   // Label 11727: @749870
     /*  749870 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(749945), // Rule ID 12445 //
     /*  749875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  749886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  749889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  749892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  749921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  749924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  749940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749943 */     GIR_RootConstrainSelectedInstOperands,
     /*  749944 */     // GIR_Coverage, 12445,
     /*  749944 */     GIR_EraseRootFromParent_Done,
     /*  749945 */   // Label 11728: @749945
     /*  749945 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(750020), // Rule ID 12448 //
     /*  749950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  749958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  749961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  749964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  749967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  749999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750018 */     GIR_RootConstrainSelectedInstOperands,
     /*  750019 */     // GIR_Coverage, 12448,
     /*  750019 */     GIR_EraseRootFromParent_Done,
     /*  750020 */   // Label 11729: @750020
     /*  750020 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(750095), // Rule ID 12449 //
     /*  750025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750093 */     GIR_RootConstrainSelectedInstOperands,
     /*  750094 */     // GIR_Coverage, 12449,
     /*  750094 */     GIR_EraseRootFromParent_Done,
     /*  750095 */   // Label 11730: @750095
     /*  750095 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(750170), // Rule ID 12452 //
     /*  750100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750168 */     GIR_RootConstrainSelectedInstOperands,
     /*  750169 */     // GIR_Coverage, 12452,
     /*  750169 */     GIR_EraseRootFromParent_Done,
     /*  750170 */   // Label 11731: @750170
     /*  750170 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(750245), // Rule ID 12453 //
     /*  750175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750243 */     GIR_RootConstrainSelectedInstOperands,
     /*  750244 */     // GIR_Coverage, 12453,
     /*  750244 */     GIR_EraseRootFromParent_Done,
     /*  750245 */   // Label 11732: @750245
     /*  750245 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(750320), // Rule ID 12456 //
     /*  750250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750318 */     GIR_RootConstrainSelectedInstOperands,
     /*  750319 */     // GIR_Coverage, 12456,
     /*  750319 */     GIR_EraseRootFromParent_Done,
     /*  750320 */   // Label 11733: @750320
     /*  750320 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(750395), // Rule ID 12457 //
     /*  750325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750393 */     GIR_RootConstrainSelectedInstOperands,
     /*  750394 */     // GIR_Coverage, 12457,
     /*  750394 */     GIR_EraseRootFromParent_Done,
     /*  750395 */   // Label 11734: @750395
     /*  750395 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(750470), // Rule ID 12460 //
     /*  750400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  750449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750468 */     GIR_RootConstrainSelectedInstOperands,
     /*  750469 */     // GIR_Coverage, 12460,
     /*  750469 */     GIR_EraseRootFromParent_Done,
     /*  750470 */   // Label 11735: @750470
     /*  750470 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(750545), // Rule ID 12461 //
     /*  750475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  750524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750543 */     GIR_RootConstrainSelectedInstOperands,
     /*  750544 */     // GIR_Coverage, 12461,
     /*  750544 */     GIR_EraseRootFromParent_Done,
     /*  750545 */   // Label 11736: @750545
     /*  750545 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(750620), // Rule ID 12464 //
     /*  750550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750618 */     GIR_RootConstrainSelectedInstOperands,
     /*  750619 */     // GIR_Coverage, 12464,
     /*  750619 */     GIR_EraseRootFromParent_Done,
     /*  750620 */   // Label 11737: @750620
     /*  750620 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(750695), // Rule ID 12465 //
     /*  750625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  750674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750693 */     GIR_RootConstrainSelectedInstOperands,
     /*  750694 */     // GIR_Coverage, 12465,
     /*  750694 */     GIR_EraseRootFromParent_Done,
     /*  750695 */   // Label 11738: @750695
     /*  750695 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(750770), // Rule ID 12468 //
     /*  750700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750768 */     GIR_RootConstrainSelectedInstOperands,
     /*  750769 */     // GIR_Coverage, 12468,
     /*  750769 */     GIR_EraseRootFromParent_Done,
     /*  750770 */   // Label 11739: @750770
     /*  750770 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(750845), // Rule ID 12469 //
     /*  750775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11594:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  750824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750843 */     GIR_RootConstrainSelectedInstOperands,
     /*  750844 */     // GIR_Coverage, 12469,
     /*  750844 */     GIR_EraseRootFromParent_Done,
     /*  750845 */   // Label 11740: @750845
     /*  750845 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(750920), // Rule ID 12472 //
     /*  750850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  750861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  750864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  750867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750918 */     GIR_RootConstrainSelectedInstOperands,
     /*  750919 */     // GIR_Coverage, 12472,
     /*  750919 */     GIR_EraseRootFromParent_Done,
     /*  750920 */   // Label 11741: @750920
     /*  750920 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(750995), // Rule ID 12473 //
     /*  750925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  750933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  750936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  750939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  750942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11594:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  750974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750993 */     GIR_RootConstrainSelectedInstOperands,
     /*  750994 */     // GIR_Coverage, 12473,
     /*  750994 */     GIR_EraseRootFromParent_Done,
     /*  750995 */   // Label 11742: @750995
     /*  750995 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(751070), // Rule ID 12476 //
     /*  751000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  751008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  751049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751068 */     GIR_RootConstrainSelectedInstOperands,
     /*  751069 */     // GIR_Coverage, 12476,
     /*  751069 */     GIR_EraseRootFromParent_Done,
     /*  751070 */   // Label 11743: @751070
     /*  751070 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(751145), // Rule ID 12477 //
     /*  751075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  751083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11594:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  751124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751143 */     GIR_RootConstrainSelectedInstOperands,
     /*  751144 */     // GIR_Coverage, 12477,
     /*  751144 */     GIR_EraseRootFromParent_Done,
     /*  751145 */   // Label 11744: @751145
     /*  751145 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(751220), // Rule ID 12480 //
     /*  751150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  751199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751218 */     GIR_RootConstrainSelectedInstOperands,
     /*  751219 */     // GIR_Coverage, 12480,
     /*  751219 */     GIR_EraseRootFromParent_Done,
     /*  751220 */   // Label 11745: @751220
     /*  751220 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(751295), // Rule ID 12481 //
     /*  751225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751271 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  751274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751293 */     GIR_RootConstrainSelectedInstOperands,
     /*  751294 */     // GIR_Coverage, 12481,
     /*  751294 */     GIR_EraseRootFromParent_Done,
     /*  751295 */   // Label 11746: @751295
     /*  751295 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(751370), // Rule ID 12484 //
     /*  751300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  751349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751368 */     GIR_RootConstrainSelectedInstOperands,
     /*  751369 */     // GIR_Coverage, 12484,
     /*  751369 */     GIR_EraseRootFromParent_Done,
     /*  751370 */   // Label 11747: @751370
     /*  751370 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(751445), // Rule ID 12485 //
     /*  751375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751421 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  751424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751443 */     GIR_RootConstrainSelectedInstOperands,
     /*  751444 */     // GIR_Coverage, 12485,
     /*  751444 */     GIR_EraseRootFromParent_Done,
     /*  751445 */   // Label 11748: @751445
     /*  751445 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(751520), // Rule ID 12488 //
     /*  751450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  751499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751518 */     GIR_RootConstrainSelectedInstOperands,
     /*  751519 */     // GIR_Coverage, 12488,
     /*  751519 */     GIR_EraseRootFromParent_Done,
     /*  751520 */   // Label 11749: @751520
     /*  751520 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(751595), // Rule ID 12489 //
     /*  751525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751571 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  751574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751593 */     GIR_RootConstrainSelectedInstOperands,
     /*  751594 */     // GIR_Coverage, 12489,
     /*  751594 */     GIR_EraseRootFromParent_Done,
     /*  751595 */   // Label 11750: @751595
     /*  751595 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(751670), // Rule ID 12492 //
     /*  751600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  751649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751668 */     GIR_RootConstrainSelectedInstOperands,
     /*  751669 */     // GIR_Coverage, 12492,
     /*  751669 */     GIR_EraseRootFromParent_Done,
     /*  751670 */   // Label 11751: @751670
     /*  751670 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(751745), // Rule ID 12493 //
     /*  751675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  751724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751743 */     GIR_RootConstrainSelectedInstOperands,
     /*  751744 */     // GIR_Coverage, 12493,
     /*  751744 */     GIR_EraseRootFromParent_Done,
     /*  751745 */   // Label 11752: @751745
     /*  751745 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(751820), // Rule ID 12496 //
     /*  751750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  751799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751818 */     GIR_RootConstrainSelectedInstOperands,
     /*  751819 */     // GIR_Coverage, 12496,
     /*  751819 */     GIR_EraseRootFromParent_Done,
     /*  751820 */   // Label 11753: @751820
     /*  751820 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(751895), // Rule ID 12497 //
     /*  751825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  751874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751893 */     GIR_RootConstrainSelectedInstOperands,
     /*  751894 */     // GIR_Coverage, 12497,
     /*  751894 */     GIR_EraseRootFromParent_Done,
     /*  751895 */   // Label 11754: @751895
     /*  751895 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(751970), // Rule ID 12500 //
     /*  751900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  751911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  751914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  751917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  751920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  751949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751968 */     GIR_RootConstrainSelectedInstOperands,
     /*  751969 */     // GIR_Coverage, 12500,
     /*  751969 */     GIR_EraseRootFromParent_Done,
     /*  751970 */   // Label 11755: @751970
     /*  751970 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(752045), // Rule ID 12501 //
     /*  751975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  751986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  751989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  751992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  751995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752021 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752043 */     GIR_RootConstrainSelectedInstOperands,
     /*  752044 */     // GIR_Coverage, 12501,
     /*  752044 */     GIR_EraseRootFromParent_Done,
     /*  752045 */   // Label 11756: @752045
     /*  752045 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(752120), // Rule ID 12504 //
     /*  752050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  752099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752118 */     GIR_RootConstrainSelectedInstOperands,
     /*  752119 */     // GIR_Coverage, 12504,
     /*  752119 */     GIR_EraseRootFromParent_Done,
     /*  752120 */   // Label 11757: @752120
     /*  752120 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(752195), // Rule ID 12505 //
     /*  752125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752171 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  752174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752193 */     GIR_RootConstrainSelectedInstOperands,
     /*  752194 */     // GIR_Coverage, 12505,
     /*  752194 */     GIR_EraseRootFromParent_Done,
     /*  752195 */   // Label 11758: @752195
     /*  752195 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(752270), // Rule ID 12508 //
     /*  752200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752268 */     GIR_RootConstrainSelectedInstOperands,
     /*  752269 */     // GIR_Coverage, 12508,
     /*  752269 */     GIR_EraseRootFromParent_Done,
     /*  752270 */   // Label 11759: @752270
     /*  752270 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(752345), // Rule ID 12509 //
     /*  752275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752343 */     GIR_RootConstrainSelectedInstOperands,
     /*  752344 */     // GIR_Coverage, 12509,
     /*  752344 */     GIR_EraseRootFromParent_Done,
     /*  752345 */   // Label 11760: @752345
     /*  752345 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(752420), // Rule ID 12512 //
     /*  752350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752418 */     GIR_RootConstrainSelectedInstOperands,
     /*  752419 */     // GIR_Coverage, 12512,
     /*  752419 */     GIR_EraseRootFromParent_Done,
     /*  752420 */   // Label 11761: @752420
     /*  752420 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(752495), // Rule ID 12513 //
     /*  752425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752493 */     GIR_RootConstrainSelectedInstOperands,
     /*  752494 */     // GIR_Coverage, 12513,
     /*  752494 */     GIR_EraseRootFromParent_Done,
     /*  752495 */   // Label 11762: @752495
     /*  752495 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(752570), // Rule ID 12516 //
     /*  752500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  752549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752568 */     GIR_RootConstrainSelectedInstOperands,
     /*  752569 */     // GIR_Coverage, 12516,
     /*  752569 */     GIR_EraseRootFromParent_Done,
     /*  752570 */   // Label 11763: @752570
     /*  752570 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(752645), // Rule ID 12517 //
     /*  752575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  752624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752643 */     GIR_RootConstrainSelectedInstOperands,
     /*  752644 */     // GIR_Coverage, 12517,
     /*  752644 */     GIR_EraseRootFromParent_Done,
     /*  752645 */   // Label 11764: @752645
     /*  752645 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(752720), // Rule ID 12520 //
     /*  752650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752718 */     GIR_RootConstrainSelectedInstOperands,
     /*  752719 */     // GIR_Coverage, 12520,
     /*  752719 */     GIR_EraseRootFromParent_Done,
     /*  752720 */   // Label 11765: @752720
     /*  752720 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(752795), // Rule ID 12521 //
     /*  752725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  752774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752793 */     GIR_RootConstrainSelectedInstOperands,
     /*  752794 */     // GIR_Coverage, 12521,
     /*  752794 */     GIR_EraseRootFromParent_Done,
     /*  752795 */   // Label 11766: @752795
     /*  752795 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(752870), // Rule ID 12524 //
     /*  752800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  752817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  752820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752868 */     GIR_RootConstrainSelectedInstOperands,
     /*  752869 */     // GIR_Coverage, 12524,
     /*  752869 */     GIR_EraseRootFromParent_Done,
     /*  752870 */   // Label 11767: @752870
     /*  752870 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(752945), // Rule ID 12525 //
     /*  752875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  752878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  752892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  752895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  752921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  752924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  752940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752943 */     GIR_RootConstrainSelectedInstOperands,
     /*  752944 */     // GIR_Coverage, 12525,
     /*  752944 */     GIR_EraseRootFromParent_Done,
     /*  752945 */   // Label 11768: @752945
     /*  752945 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(753020), // Rule ID 12528 //
     /*  752950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  752958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  752961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  752964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  752967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  752970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  752999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753018 */     GIR_RootConstrainSelectedInstOperands,
     /*  753019 */     // GIR_Coverage, 12528,
     /*  753019 */     GIR_EraseRootFromParent_Done,
     /*  753020 */   // Label 11769: @753020
     /*  753020 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(753095), // Rule ID 12529 //
     /*  753025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  753074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753093 */     GIR_RootConstrainSelectedInstOperands,
     /*  753094 */     // GIR_Coverage, 12529,
     /*  753094 */     GIR_EraseRootFromParent_Done,
     /*  753095 */   // Label 11770: @753095
     /*  753095 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(753170), // Rule ID 12532 //
     /*  753100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  753149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753168 */     GIR_RootConstrainSelectedInstOperands,
     /*  753169 */     // GIR_Coverage, 12532,
     /*  753169 */     GIR_EraseRootFromParent_Done,
     /*  753170 */   // Label 11771: @753170
     /*  753170 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(753245), // Rule ID 12533 //
     /*  753175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753221 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  753224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753243 */     GIR_RootConstrainSelectedInstOperands,
     /*  753244 */     // GIR_Coverage, 12533,
     /*  753244 */     GIR_EraseRootFromParent_Done,
     /*  753245 */   // Label 11772: @753245
     /*  753245 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(753320), // Rule ID 12536 //
     /*  753250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  753299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753318 */     GIR_RootConstrainSelectedInstOperands,
     /*  753319 */     // GIR_Coverage, 12536,
     /*  753319 */     GIR_EraseRootFromParent_Done,
     /*  753320 */   // Label 11773: @753320
     /*  753320 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(753395), // Rule ID 12537 //
     /*  753325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753371 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  753374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753393 */     GIR_RootConstrainSelectedInstOperands,
     /*  753394 */     // GIR_Coverage, 12537,
     /*  753394 */     GIR_EraseRootFromParent_Done,
     /*  753395 */   // Label 11774: @753395
     /*  753395 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(753470), // Rule ID 12540 //
     /*  753400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  753449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753468 */     GIR_RootConstrainSelectedInstOperands,
     /*  753469 */     // GIR_Coverage, 12540,
     /*  753469 */     GIR_EraseRootFromParent_Done,
     /*  753470 */   // Label 11775: @753470
     /*  753470 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(753545), // Rule ID 12541 //
     /*  753475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753521 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  753524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753543 */     GIR_RootConstrainSelectedInstOperands,
     /*  753544 */     // GIR_Coverage, 12541,
     /*  753544 */     GIR_EraseRootFromParent_Done,
     /*  753545 */   // Label 11776: @753545
     /*  753545 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(753620), // Rule ID 12544 //
     /*  753550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  753599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753618 */     GIR_RootConstrainSelectedInstOperands,
     /*  753619 */     // GIR_Coverage, 12544,
     /*  753619 */     GIR_EraseRootFromParent_Done,
     /*  753620 */   // Label 11777: @753620
     /*  753620 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(753695), // Rule ID 12545 //
     /*  753625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753671 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  753674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753693 */     GIR_RootConstrainSelectedInstOperands,
     /*  753694 */     // GIR_Coverage, 12545,
     /*  753694 */     GIR_EraseRootFromParent_Done,
     /*  753695 */   // Label 11778: @753695
     /*  753695 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(753770), // Rule ID 12548 //
     /*  753700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  753749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753768 */     GIR_RootConstrainSelectedInstOperands,
     /*  753769 */     // GIR_Coverage, 12548,
     /*  753769 */     GIR_EraseRootFromParent_Done,
     /*  753770 */   // Label 11779: @753770
     /*  753770 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(753845), // Rule ID 12549 //
     /*  753775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  753824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753843 */     GIR_RootConstrainSelectedInstOperands,
     /*  753844 */     // GIR_Coverage, 12549,
     /*  753844 */     GIR_EraseRootFromParent_Done,
     /*  753845 */   // Label 11780: @753845
     /*  753845 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(753920), // Rule ID 12552 //
     /*  753850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  753861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  753864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  753867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  753899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753918 */     GIR_RootConstrainSelectedInstOperands,
     /*  753919 */     // GIR_Coverage, 12552,
     /*  753919 */     GIR_EraseRootFromParent_Done,
     /*  753920 */   // Label 11781: @753920
     /*  753920 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(753995), // Rule ID 12553 //
     /*  753925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  753933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  753936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  753939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  753942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  753974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753993 */     GIR_RootConstrainSelectedInstOperands,
     /*  753994 */     // GIR_Coverage, 12553,
     /*  753994 */     GIR_EraseRootFromParent_Done,
     /*  753995 */   // Label 11782: @753995
     /*  753995 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(754070), // Rule ID 12556 //
     /*  754000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754068 */     GIR_RootConstrainSelectedInstOperands,
     /*  754069 */     // GIR_Coverage, 12556,
     /*  754069 */     GIR_EraseRootFromParent_Done,
     /*  754070 */   // Label 11783: @754070
     /*  754070 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(754145), // Rule ID 12557 //
     /*  754075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754121 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754143 */     GIR_RootConstrainSelectedInstOperands,
     /*  754144 */     // GIR_Coverage, 12557,
     /*  754144 */     GIR_EraseRootFromParent_Done,
     /*  754145 */   // Label 11784: @754145
     /*  754145 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(754220), // Rule ID 12560 //
     /*  754150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754218 */     GIR_RootConstrainSelectedInstOperands,
     /*  754219 */     // GIR_Coverage, 12560,
     /*  754219 */     GIR_EraseRootFromParent_Done,
     /*  754220 */   // Label 11785: @754220
     /*  754220 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(754295), // Rule ID 12561 //
     /*  754225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754271 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754293 */     GIR_RootConstrainSelectedInstOperands,
     /*  754294 */     // GIR_Coverage, 12561,
     /*  754294 */     GIR_EraseRootFromParent_Done,
     /*  754295 */   // Label 11786: @754295
     /*  754295 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(754370), // Rule ID 12564 //
     /*  754300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  754349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754368 */     GIR_RootConstrainSelectedInstOperands,
     /*  754369 */     // GIR_Coverage, 12564,
     /*  754369 */     GIR_EraseRootFromParent_Done,
     /*  754370 */   // Label 11787: @754370
     /*  754370 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(754445), // Rule ID 12565 //
     /*  754375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  754424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754443 */     GIR_RootConstrainSelectedInstOperands,
     /*  754444 */     // GIR_Coverage, 12565,
     /*  754444 */     GIR_EraseRootFromParent_Done,
     /*  754445 */   // Label 11788: @754445
     /*  754445 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(754520), // Rule ID 12568 //
     /*  754450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  754499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754518 */     GIR_RootConstrainSelectedInstOperands,
     /*  754519 */     // GIR_Coverage, 12568,
     /*  754519 */     GIR_EraseRootFromParent_Done,
     /*  754520 */   // Label 11789: @754520
     /*  754520 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(754595), // Rule ID 12569 //
     /*  754525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  754574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754593 */     GIR_RootConstrainSelectedInstOperands,
     /*  754594 */     // GIR_Coverage, 12569,
     /*  754594 */     GIR_EraseRootFromParent_Done,
     /*  754595 */   // Label 11790: @754595
     /*  754595 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(754670), // Rule ID 12572 //
     /*  754600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  754649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754668 */     GIR_RootConstrainSelectedInstOperands,
     /*  754669 */     // GIR_Coverage, 12572,
     /*  754669 */     GIR_EraseRootFromParent_Done,
     /*  754670 */   // Label 11791: @754670
     /*  754670 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(754745), // Rule ID 12573 //
     /*  754675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  754724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754743 */     GIR_RootConstrainSelectedInstOperands,
     /*  754744 */     // GIR_Coverage, 12573,
     /*  754744 */     GIR_EraseRootFromParent_Done,
     /*  754745 */   // Label 11792: @754745
     /*  754745 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(754820), // Rule ID 12576 //
     /*  754750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754818 */     GIR_RootConstrainSelectedInstOperands,
     /*  754819 */     // GIR_Coverage, 12576,
     /*  754819 */     GIR_EraseRootFromParent_Done,
     /*  754820 */   // Label 11793: @754820
     /*  754820 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(754895), // Rule ID 12577 //
     /*  754825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  754874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754893 */     GIR_RootConstrainSelectedInstOperands,
     /*  754894 */     // GIR_Coverage, 12577,
     /*  754894 */     GIR_EraseRootFromParent_Done,
     /*  754895 */   // Label 11794: @754895
     /*  754895 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(754970), // Rule ID 12580 //
     /*  754900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  754911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  754914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  754917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  754949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754968 */     GIR_RootConstrainSelectedInstOperands,
     /*  754969 */     // GIR_Coverage, 12580,
     /*  754969 */     GIR_EraseRootFromParent_Done,
     /*  754970 */   // Label 11795: @754970
     /*  754970 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(755045), // Rule ID 12581 //
     /*  754975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  754983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  754986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  754989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  754992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755043 */     GIR_RootConstrainSelectedInstOperands,
     /*  755044 */     // GIR_Coverage, 12581,
     /*  755044 */     GIR_EraseRootFromParent_Done,
     /*  755045 */   // Label 11796: @755045
     /*  755045 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(755120), // Rule ID 12584 //
     /*  755050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  755099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755118 */     GIR_RootConstrainSelectedInstOperands,
     /*  755119 */     // GIR_Coverage, 12584,
     /*  755119 */     GIR_EraseRootFromParent_Done,
     /*  755120 */   // Label 11797: @755120
     /*  755120 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(755195), // Rule ID 12585 //
     /*  755125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755171 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  755174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755193 */     GIR_RootConstrainSelectedInstOperands,
     /*  755194 */     // GIR_Coverage, 12585,
     /*  755194 */     GIR_EraseRootFromParent_Done,
     /*  755195 */   // Label 11798: @755195
     /*  755195 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(755270), // Rule ID 12588 //
     /*  755200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  755249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755268 */     GIR_RootConstrainSelectedInstOperands,
     /*  755269 */     // GIR_Coverage, 12588,
     /*  755269 */     GIR_EraseRootFromParent_Done,
     /*  755270 */   // Label 11799: @755270
     /*  755270 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(755345), // Rule ID 12589 //
     /*  755275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  755324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755343 */     GIR_RootConstrainSelectedInstOperands,
     /*  755344 */     // GIR_Coverage, 12589,
     /*  755344 */     GIR_EraseRootFromParent_Done,
     /*  755345 */   // Label 11800: @755345
     /*  755345 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(755420), // Rule ID 12592 //
     /*  755350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  755399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755418 */     GIR_RootConstrainSelectedInstOperands,
     /*  755419 */     // GIR_Coverage, 12592,
     /*  755419 */     GIR_EraseRootFromParent_Done,
     /*  755420 */   // Label 11801: @755420
     /*  755420 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(755495), // Rule ID 12593 //
     /*  755425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755471 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  755474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755493 */     GIR_RootConstrainSelectedInstOperands,
     /*  755494 */     // GIR_Coverage, 12593,
     /*  755494 */     GIR_EraseRootFromParent_Done,
     /*  755495 */   // Label 11802: @755495
     /*  755495 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(755570), // Rule ID 12596 //
     /*  755500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755568 */     GIR_RootConstrainSelectedInstOperands,
     /*  755569 */     // GIR_Coverage, 12596,
     /*  755569 */     GIR_EraseRootFromParent_Done,
     /*  755570 */   // Label 11803: @755570
     /*  755570 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(755645), // Rule ID 12597 //
     /*  755575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  755583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  755624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755643 */     GIR_RootConstrainSelectedInstOperands,
     /*  755644 */     // GIR_Coverage, 12597,
     /*  755644 */     GIR_EraseRootFromParent_Done,
     /*  755645 */   // Label 11804: @755645
     /*  755645 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(755720), // Rule ID 12600 //
     /*  755650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  755661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  755664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  755699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755718 */     GIR_RootConstrainSelectedInstOperands,
     /*  755719 */     // GIR_Coverage, 12600,
     /*  755719 */     GIR_EraseRootFromParent_Done,
     /*  755720 */   // Label 11805: @755720
     /*  755720 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(755795), // Rule ID 12601 //
     /*  755725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  755736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  755739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755771 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  755774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755793 */     GIR_RootConstrainSelectedInstOperands,
     /*  755794 */     // GIR_Coverage, 12601,
     /*  755794 */     GIR_EraseRootFromParent_Done,
     /*  755795 */   // Label 11806: @755795
     /*  755795 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(755870), // Rule ID 12604 //
     /*  755800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  755811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  755814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  755817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  755820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  755849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755868 */     GIR_RootConstrainSelectedInstOperands,
     /*  755869 */     // GIR_Coverage, 12604,
     /*  755869 */     GIR_EraseRootFromParent_Done,
     /*  755870 */   // Label 11807: @755870
     /*  755870 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(755945), // Rule ID 12605 //
     /*  755875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  755886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  755889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  755892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  755895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755921 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  755924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755943 */     GIR_RootConstrainSelectedInstOperands,
     /*  755944 */     // GIR_Coverage, 12605,
     /*  755944 */     GIR_EraseRootFromParent_Done,
     /*  755945 */   // Label 11808: @755945
     /*  755945 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(756020), // Rule ID 12608 //
     /*  755950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  755961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  755964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  755967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  755970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  755999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756018 */     GIR_RootConstrainSelectedInstOperands,
     /*  756019 */     // GIR_Coverage, 12608,
     /*  756019 */     GIR_EraseRootFromParent_Done,
     /*  756020 */   // Label 11809: @756020
     /*  756020 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(756095), // Rule ID 12609 //
     /*  756025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  756036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  756039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756093 */     GIR_RootConstrainSelectedInstOperands,
     /*  756094 */     // GIR_Coverage, 12609,
     /*  756094 */     GIR_EraseRootFromParent_Done,
     /*  756095 */   // Label 11810: @756095
     /*  756095 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(756170), // Rule ID 12612 //
     /*  756100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756168 */     GIR_RootConstrainSelectedInstOperands,
     /*  756169 */     // GIR_Coverage, 12612,
     /*  756169 */     GIR_EraseRootFromParent_Done,
     /*  756170 */   // Label 11811: @756170
     /*  756170 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(756245), // Rule ID 12613 //
     /*  756175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  756186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  756189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756243 */     GIR_RootConstrainSelectedInstOperands,
     /*  756244 */     // GIR_Coverage, 12613,
     /*  756244 */     GIR_EraseRootFromParent_Done,
     /*  756245 */   // Label 11812: @756245
     /*  756245 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(756320), // Rule ID 12616 //
     /*  756250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  756267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  756270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  756299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756318 */     GIR_RootConstrainSelectedInstOperands,
     /*  756319 */     // GIR_Coverage, 12616,
     /*  756319 */     GIR_EraseRootFromParent_Done,
     /*  756320 */   // Label 11813: @756320
     /*  756320 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(756395), // Rule ID 12617 //
     /*  756325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  756336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  756339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  756342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  756345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756371 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  756374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756393 */     GIR_RootConstrainSelectedInstOperands,
     /*  756394 */     // GIR_Coverage, 12617,
     /*  756394 */     GIR_EraseRootFromParent_Done,
     /*  756395 */   // Label 11814: @756395
     /*  756395 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(756470), // Rule ID 12620 //
     /*  756400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  756417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  756420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756446 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  756449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756468 */     GIR_RootConstrainSelectedInstOperands,
     /*  756469 */     // GIR_Coverage, 12620,
     /*  756469 */     GIR_EraseRootFromParent_Done,
     /*  756470 */   // Label 11815: @756470
     /*  756470 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(756545), // Rule ID 12621 //
     /*  756475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  756486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  756489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  756492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  756495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756521 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  756524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756543 */     GIR_RootConstrainSelectedInstOperands,
     /*  756544 */     // GIR_Coverage, 12621,
     /*  756544 */     GIR_EraseRootFromParent_Done,
     /*  756545 */   // Label 11816: @756545
     /*  756545 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(756620), // Rule ID 12624 //
     /*  756550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  756599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756618 */     GIR_RootConstrainSelectedInstOperands,
     /*  756619 */     // GIR_Coverage, 12624,
     /*  756619 */     GIR_EraseRootFromParent_Done,
     /*  756620 */   // Label 11817: @756620
     /*  756620 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(756695), // Rule ID 12625 //
     /*  756625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756671 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  756674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756693 */     GIR_RootConstrainSelectedInstOperands,
     /*  756694 */     // GIR_Coverage, 12625,
     /*  756694 */     GIR_EraseRootFromParent_Done,
     /*  756695 */   // Label 11818: @756695
     /*  756695 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(756770), // Rule ID 12628 //
     /*  756700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  756711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  756714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756768 */     GIR_RootConstrainSelectedInstOperands,
     /*  756769 */     // GIR_Coverage, 12628,
     /*  756769 */     GIR_EraseRootFromParent_Done,
     /*  756770 */   // Label 11819: @756770
     /*  756770 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(756845), // Rule ID 12629 //
     /*  756775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  756786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  756789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  756824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756843 */     GIR_RootConstrainSelectedInstOperands,
     /*  756844 */     // GIR_Coverage, 12629,
     /*  756844 */     GIR_EraseRootFromParent_Done,
     /*  756845 */   // Label 11820: @756845
     /*  756845 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(756920), // Rule ID 12632 //
     /*  756850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756918 */     GIR_RootConstrainSelectedInstOperands,
     /*  756919 */     // GIR_Coverage, 12632,
     /*  756919 */     GIR_EraseRootFromParent_Done,
     /*  756920 */   // Label 11821: @756920
     /*  756920 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(756995), // Rule ID 12633 //
     /*  756925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  756936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  756939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  756974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756993 */     GIR_RootConstrainSelectedInstOperands,
     /*  756994 */     // GIR_Coverage, 12633,
     /*  756994 */     GIR_EraseRootFromParent_Done,
     /*  756995 */   // Label 11822: @756995
     /*  756995 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(757070), // Rule ID 12636 //
     /*  757000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  757011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  757014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757068 */     GIR_RootConstrainSelectedInstOperands,
     /*  757069 */     // GIR_Coverage, 12636,
     /*  757069 */     GIR_EraseRootFromParent_Done,
     /*  757070 */   // Label 11823: @757070
     /*  757070 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(757145), // Rule ID 12637 //
     /*  757075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  757086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  757089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757121 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757143 */     GIR_RootConstrainSelectedInstOperands,
     /*  757144 */     // GIR_Coverage, 12637,
     /*  757144 */     GIR_EraseRootFromParent_Done,
     /*  757145 */   // Label 11824: @757145
     /*  757145 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(757220), // Rule ID 12640 //
     /*  757150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  757167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  757170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757196 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757218 */     GIR_RootConstrainSelectedInstOperands,
     /*  757219 */     // GIR_Coverage, 12640,
     /*  757219 */     GIR_EraseRootFromParent_Done,
     /*  757220 */   // Label 11825: @757220
     /*  757220 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(757295), // Rule ID 12641 //
     /*  757225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  757236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  757239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  757242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  757245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757293 */     GIR_RootConstrainSelectedInstOperands,
     /*  757294 */     // GIR_Coverage, 12641,
     /*  757294 */     GIR_EraseRootFromParent_Done,
     /*  757295 */   // Label 11826: @757295
     /*  757295 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(757370), // Rule ID 12644 //
     /*  757300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  757349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757368 */     GIR_RootConstrainSelectedInstOperands,
     /*  757369 */     // GIR_Coverage, 12644,
     /*  757369 */     GIR_EraseRootFromParent_Done,
     /*  757370 */   // Label 11827: @757370
     /*  757370 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(757445), // Rule ID 12645 //
     /*  757375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  757424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757443 */     GIR_RootConstrainSelectedInstOperands,
     /*  757444 */     // GIR_Coverage, 12645,
     /*  757444 */     GIR_EraseRootFromParent_Done,
     /*  757445 */   // Label 11828: @757445
     /*  757445 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(757520), // Rule ID 12648 //
     /*  757450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  757499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757518 */     GIR_RootConstrainSelectedInstOperands,
     /*  757519 */     // GIR_Coverage, 12648,
     /*  757519 */     GIR_EraseRootFromParent_Done,
     /*  757520 */   // Label 11829: @757520
     /*  757520 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(757595), // Rule ID 12649 //
     /*  757525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  757536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  757539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  757574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757593 */     GIR_RootConstrainSelectedInstOperands,
     /*  757594 */     // GIR_Coverage, 12649,
     /*  757594 */     GIR_EraseRootFromParent_Done,
     /*  757595 */   // Label 11830: @757595
     /*  757595 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(757670), // Rule ID 12652 //
     /*  757600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  757617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  757620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757668 */     GIR_RootConstrainSelectedInstOperands,
     /*  757669 */     // GIR_Coverage, 12652,
     /*  757669 */     GIR_EraseRootFromParent_Done,
     /*  757670 */   // Label 11831: @757670
     /*  757670 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(757745), // Rule ID 12653 //
     /*  757675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  757686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  757689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  757692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  757695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  757724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757743 */     GIR_RootConstrainSelectedInstOperands,
     /*  757744 */     // GIR_Coverage, 12653,
     /*  757744 */     GIR_EraseRootFromParent_Done,
     /*  757745 */   // Label 11832: @757745
     /*  757745 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(757820), // Rule ID 12656 //
     /*  757750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  757753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  757767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  757770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757818 */     GIR_RootConstrainSelectedInstOperands,
     /*  757819 */     // GIR_Coverage, 12656,
     /*  757819 */     GIR_EraseRootFromParent_Done,
     /*  757820 */   // Label 11833: @757820
     /*  757820 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(757895), // Rule ID 12657 //
     /*  757825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  757828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  757836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  757839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  757842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  757845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757871 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  757874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757893 */     GIR_RootConstrainSelectedInstOperands,
     /*  757894 */     // GIR_Coverage, 12657,
     /*  757894 */     GIR_EraseRootFromParent_Done,
     /*  757895 */   // Label 11834: @757895
     /*  757895 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(757970), // Rule ID 12660 //
     /*  757900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  757917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  757920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  757939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  757949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757968 */     GIR_RootConstrainSelectedInstOperands,
     /*  757969 */     // GIR_Coverage, 12660,
     /*  757969 */     GIR_EraseRootFromParent_Done,
     /*  757970 */   // Label 11835: @757970
     /*  757970 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(758045), // Rule ID 12661 //
     /*  757975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  757983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  757986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  757989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  757992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  757995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758021 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  758024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758043 */     GIR_RootConstrainSelectedInstOperands,
     /*  758044 */     // GIR_Coverage, 12661,
     /*  758044 */     GIR_EraseRootFromParent_Done,
     /*  758045 */   // Label 11836: @758045
     /*  758045 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(758120), // Rule ID 12664 //
     /*  758050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  758061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  758064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  758067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758118 */     GIR_RootConstrainSelectedInstOperands,
     /*  758119 */     // GIR_Coverage, 12664,
     /*  758119 */     GIR_EraseRootFromParent_Done,
     /*  758120 */   // Label 11837: @758120
     /*  758120 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(758195), // Rule ID 12665 //
     /*  758125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  758136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  758139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  758142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758171 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758193 */     GIR_RootConstrainSelectedInstOperands,
     /*  758194 */     // GIR_Coverage, 12665,
     /*  758194 */     GIR_EraseRootFromParent_Done,
     /*  758195 */   // Label 11838: @758195
     /*  758195 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(758270), // Rule ID 12668 //
     /*  758200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  758217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758268 */     GIR_RootConstrainSelectedInstOperands,
     /*  758269 */     // GIR_Coverage, 12668,
     /*  758269 */     GIR_EraseRootFromParent_Done,
     /*  758270 */   // Label 11839: @758270
     /*  758270 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(758345), // Rule ID 12669 //
     /*  758275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  758286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  758289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  758292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758343 */     GIR_RootConstrainSelectedInstOperands,
     /*  758344 */     // GIR_Coverage, 12669,
     /*  758344 */     GIR_EraseRootFromParent_Done,
     /*  758345 */   // Label 11840: @758345
     /*  758345 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(758420), // Rule ID 12672 //
     /*  758350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  758367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  758399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758418 */     GIR_RootConstrainSelectedInstOperands,
     /*  758419 */     // GIR_Coverage, 12672,
     /*  758419 */     GIR_EraseRootFromParent_Done,
     /*  758420 */   // Label 11841: @758420
     /*  758420 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(758495), // Rule ID 12673 //
     /*  758425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  758442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  758474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758493 */     GIR_RootConstrainSelectedInstOperands,
     /*  758494 */     // GIR_Coverage, 12673,
     /*  758494 */     GIR_EraseRootFromParent_Done,
     /*  758495 */   // Label 11842: @758495
     /*  758495 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(758570), // Rule ID 12676 //
     /*  758500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  758549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758568 */     GIR_RootConstrainSelectedInstOperands,
     /*  758569 */     // GIR_Coverage, 12676,
     /*  758569 */     GIR_EraseRootFromParent_Done,
     /*  758570 */   // Label 11843: @758570
     /*  758570 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(758645), // Rule ID 12677 //
     /*  758575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  758592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  758624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758643 */     GIR_RootConstrainSelectedInstOperands,
     /*  758644 */     // GIR_Coverage, 12677,
     /*  758644 */     GIR_EraseRootFromParent_Done,
     /*  758645 */   // Label 11844: @758645
     /*  758645 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(758720), // Rule ID 12680 //
     /*  758650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  758699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758718 */     GIR_RootConstrainSelectedInstOperands,
     /*  758719 */     // GIR_Coverage, 12680,
     /*  758719 */     GIR_EraseRootFromParent_Done,
     /*  758720 */   // Label 11845: @758720
     /*  758720 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(758795), // Rule ID 12681 //
     /*  758725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758771 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  758774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758793 */     GIR_RootConstrainSelectedInstOperands,
     /*  758794 */     // GIR_Coverage, 12681,
     /*  758794 */     GIR_EraseRootFromParent_Done,
     /*  758795 */   // Label 11846: @758795
     /*  758795 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(758870), // Rule ID 12684 //
     /*  758800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  758811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  758814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  758817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758868 */     GIR_RootConstrainSelectedInstOperands,
     /*  758869 */     // GIR_Coverage, 12684,
     /*  758869 */     GIR_EraseRootFromParent_Done,
     /*  758870 */   // Label 11847: @758870
     /*  758870 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(758945), // Rule ID 12685 //
     /*  758875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  758886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  758889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  758892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  758895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758921 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  758924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758943 */     GIR_RootConstrainSelectedInstOperands,
     /*  758944 */     // GIR_Coverage, 12685,
     /*  758944 */     GIR_EraseRootFromParent_Done,
     /*  758945 */   // Label 11848: @758945
     /*  758945 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(759020), // Rule ID 12688 //
     /*  758950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  758958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  758961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  758964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  758967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  758970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  758985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  758989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  758999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759018 */     GIR_RootConstrainSelectedInstOperands,
     /*  759019 */     // GIR_Coverage, 12688,
     /*  759019 */     GIR_EraseRootFromParent_Done,
     /*  759020 */   // Label 11849: @759020
     /*  759020 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(759095), // Rule ID 12689 //
     /*  759025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  759036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  759039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  759042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759093 */     GIR_RootConstrainSelectedInstOperands,
     /*  759094 */     // GIR_Coverage, 12689,
     /*  759094 */     GIR_EraseRootFromParent_Done,
     /*  759095 */   // Label 11850: @759095
     /*  759095 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(759170), // Rule ID 12692 //
     /*  759100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  759117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759168 */     GIR_RootConstrainSelectedInstOperands,
     /*  759169 */     // GIR_Coverage, 12692,
     /*  759169 */     GIR_EraseRootFromParent_Done,
     /*  759170 */   // Label 11851: @759170
     /*  759170 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(759245), // Rule ID 12693 //
     /*  759175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  759186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  759189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  759192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759243 */     GIR_RootConstrainSelectedInstOperands,
     /*  759244 */     // GIR_Coverage, 12693,
     /*  759244 */     GIR_EraseRootFromParent_Done,
     /*  759245 */   // Label 11852: @759245
     /*  759245 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(759320), // Rule ID 12696 //
     /*  759250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  759267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759318 */     GIR_RootConstrainSelectedInstOperands,
     /*  759319 */     // GIR_Coverage, 12696,
     /*  759319 */     GIR_EraseRootFromParent_Done,
     /*  759320 */   // Label 11853: @759320
     /*  759320 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(759395), // Rule ID 12697 //
     /*  759325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  759342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759371 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759393 */     GIR_RootConstrainSelectedInstOperands,
     /*  759394 */     // GIR_Coverage, 12697,
     /*  759394 */     GIR_EraseRootFromParent_Done,
     /*  759395 */   // Label 11854: @759395
     /*  759395 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(759470), // Rule ID 12700 //
     /*  759400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  759449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759468 */     GIR_RootConstrainSelectedInstOperands,
     /*  759469 */     // GIR_Coverage, 12700,
     /*  759469 */     GIR_EraseRootFromParent_Done,
     /*  759470 */   // Label 11855: @759470
     /*  759470 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(759545), // Rule ID 12701 //
     /*  759475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  759492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759521 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  759524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759543 */     GIR_RootConstrainSelectedInstOperands,
     /*  759544 */     // GIR_Coverage, 12701,
     /*  759544 */     GIR_EraseRootFromParent_Done,
     /*  759545 */   // Label 11856: @759545
     /*  759545 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(759620), // Rule ID 12704 //
     /*  759550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  759561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  759564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  759567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759618 */     GIR_RootConstrainSelectedInstOperands,
     /*  759619 */     // GIR_Coverage, 12704,
     /*  759619 */     GIR_EraseRootFromParent_Done,
     /*  759620 */   // Label 11857: @759620
     /*  759620 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(759695), // Rule ID 12705 //
     /*  759625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  759636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  759639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  759642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  759674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759693 */     GIR_RootConstrainSelectedInstOperands,
     /*  759694 */     // GIR_Coverage, 12705,
     /*  759694 */     GIR_EraseRootFromParent_Done,
     /*  759695 */   // Label 11858: @759695
     /*  759695 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(759770), // Rule ID 12708 //
     /*  759700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  759717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759768 */     GIR_RootConstrainSelectedInstOperands,
     /*  759769 */     // GIR_Coverage, 12708,
     /*  759769 */     GIR_EraseRootFromParent_Done,
     /*  759770 */   // Label 11859: @759770
     /*  759770 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(759845), // Rule ID 12709 //
     /*  759775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  759792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  759824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759843 */     GIR_RootConstrainSelectedInstOperands,
     /*  759844 */     // GIR_Coverage, 12709,
     /*  759844 */     GIR_EraseRootFromParent_Done,
     /*  759845 */   // Label 11860: @759845
     /*  759845 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(759920), // Rule ID 12712 //
     /*  759850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  759853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759918 */     GIR_RootConstrainSelectedInstOperands,
     /*  759919 */     // GIR_Coverage, 12712,
     /*  759919 */     GIR_EraseRootFromParent_Done,
     /*  759920 */   // Label 11861: @759920
     /*  759920 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(759995), // Rule ID 12713 //
     /*  759925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  759928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  759933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  759942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759971 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  759974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759993 */     GIR_RootConstrainSelectedInstOperands,
     /*  759994 */     // GIR_Coverage, 12713,
     /*  759994 */     GIR_EraseRootFromParent_Done,
     /*  759995 */   // Label 11862: @759995
     /*  759995 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(760070), // Rule ID 12716 //
     /*  760000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  760003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  760008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  760017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  760049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760068 */     GIR_RootConstrainSelectedInstOperands,
     /*  760069 */     // GIR_Coverage, 12716,
     /*  760069 */     GIR_EraseRootFromParent_Done,
     /*  760070 */   // Label 11863: @760070
     /*  760070 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(760145), // Rule ID 12717 //
     /*  760075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  760078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  760083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  760086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  760089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  760092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  760106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760121 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  760124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760143 */     GIR_RootConstrainSelectedInstOperands,
     /*  760144 */     // GIR_Coverage, 12717,
     /*  760144 */     GIR_EraseRootFromParent_Done,
     /*  760145 */   // Label 11864: @760145
     /*  760145 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(760223), // Rule ID 14046 //
     /*  760150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  760170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  760199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760221 */     GIR_RootConstrainSelectedInstOperands,
     /*  760222 */     // GIR_Coverage, 14046,
     /*  760222 */     GIR_EraseRootFromParent_Done,
     /*  760223 */   // Label 11865: @760223
     /*  760223 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(760301), // Rule ID 14047 //
     /*  760228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  760239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  760242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  760245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  760248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  760277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760299 */     GIR_RootConstrainSelectedInstOperands,
     /*  760300 */     // GIR_Coverage, 14047,
     /*  760300 */     GIR_EraseRootFromParent_Done,
     /*  760301 */   // Label 11866: @760301
     /*  760301 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(760379), // Rule ID 14050 //
     /*  760306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  760326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760352 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760377 */     GIR_RootConstrainSelectedInstOperands,
     /*  760378 */     // GIR_Coverage, 14050,
     /*  760378 */     GIR_EraseRootFromParent_Done,
     /*  760379 */   // Label 11867: @760379
     /*  760379 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(760457), // Rule ID 14051 //
     /*  760384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  760395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  760398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  760401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  760404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760430 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760455 */     GIR_RootConstrainSelectedInstOperands,
     /*  760456 */     // GIR_Coverage, 14051,
     /*  760456 */     GIR_EraseRootFromParent_Done,
     /*  760457 */   // Label 11868: @760457
     /*  760457 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(760535), // Rule ID 14054 //
     /*  760462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  760482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760533 */     GIR_RootConstrainSelectedInstOperands,
     /*  760534 */     // GIR_Coverage, 14054,
     /*  760534 */     GIR_EraseRootFromParent_Done,
     /*  760535 */   // Label 11869: @760535
     /*  760535 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(760613), // Rule ID 14055 //
     /*  760540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  760560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760611 */     GIR_RootConstrainSelectedInstOperands,
     /*  760612 */     // GIR_Coverage, 14055,
     /*  760612 */     GIR_EraseRootFromParent_Done,
     /*  760613 */   // Label 11870: @760613
     /*  760613 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(760691), // Rule ID 14058 //
     /*  760618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  760638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760689 */     GIR_RootConstrainSelectedInstOperands,
     /*  760690 */     // GIR_Coverage, 14058,
     /*  760690 */     GIR_EraseRootFromParent_Done,
     /*  760691 */   // Label 11871: @760691
     /*  760691 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(760769), // Rule ID 14059 //
     /*  760696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  760716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  760745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760767 */     GIR_RootConstrainSelectedInstOperands,
     /*  760768 */     // GIR_Coverage, 14059,
     /*  760768 */     GIR_EraseRootFromParent_Done,
     /*  760769 */   // Label 11872: @760769
     /*  760769 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(760847), // Rule ID 14062 //
     /*  760774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  760794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760845 */     GIR_RootConstrainSelectedInstOperands,
     /*  760846 */     // GIR_Coverage, 14062,
     /*  760846 */     GIR_EraseRootFromParent_Done,
     /*  760847 */   // Label 11873: @760847
     /*  760847 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(760925), // Rule ID 14063 //
     /*  760852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  760872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760898 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760923 */     GIR_RootConstrainSelectedInstOperands,
     /*  760924 */     // GIR_Coverage, 14063,
     /*  760924 */     GIR_EraseRootFromParent_Done,
     /*  760925 */   // Label 11874: @760925
     /*  760925 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(761003), // Rule ID 14066 //
     /*  760930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  760950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  760979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761001 */     GIR_RootConstrainSelectedInstOperands,
     /*  761002 */     // GIR_Coverage, 14066,
     /*  761002 */     GIR_EraseRootFromParent_Done,
     /*  761003 */   // Label 11875: @761003
     /*  761003 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(761081), // Rule ID 14067 //
     /*  761008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  761019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  761022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  761025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  761028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  761057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761079 */     GIR_RootConstrainSelectedInstOperands,
     /*  761080 */     // GIR_Coverage, 14067,
     /*  761080 */     GIR_EraseRootFromParent_Done,
     /*  761081 */   // Label 11876: @761081
     /*  761081 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(761159), // Rule ID 14070 //
     /*  761086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  761106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761157 */     GIR_RootConstrainSelectedInstOperands,
     /*  761158 */     // GIR_Coverage, 14070,
     /*  761158 */     GIR_EraseRootFromParent_Done,
     /*  761159 */   // Label 11877: @761159
     /*  761159 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(761237), // Rule ID 14071 //
     /*  761164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  761175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  761178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  761181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  761184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761235 */     GIR_RootConstrainSelectedInstOperands,
     /*  761236 */     // GIR_Coverage, 14071,
     /*  761236 */     GIR_EraseRootFromParent_Done,
     /*  761237 */   // Label 11878: @761237
     /*  761237 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(761315), // Rule ID 14074 //
     /*  761242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  761262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761313 */     GIR_RootConstrainSelectedInstOperands,
     /*  761314 */     // GIR_Coverage, 14074,
     /*  761314 */     GIR_EraseRootFromParent_Done,
     /*  761315 */   // Label 11879: @761315
     /*  761315 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(761393), // Rule ID 14075 //
     /*  761320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  761331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  761334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  761337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  761340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761391 */     GIR_RootConstrainSelectedInstOperands,
     /*  761392 */     // GIR_Coverage, 14075,
     /*  761392 */     GIR_EraseRootFromParent_Done,
     /*  761393 */   // Label 11880: @761393
     /*  761393 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(761471), // Rule ID 14078 //
     /*  761398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  761418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761469 */     GIR_RootConstrainSelectedInstOperands,
     /*  761470 */     // GIR_Coverage, 14078,
     /*  761470 */     GIR_EraseRootFromParent_Done,
     /*  761471 */   // Label 11881: @761471
     /*  761471 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(761549), // Rule ID 14079 //
     /*  761476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  761496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761547 */     GIR_RootConstrainSelectedInstOperands,
     /*  761548 */     // GIR_Coverage, 14079,
     /*  761548 */     GIR_EraseRootFromParent_Done,
     /*  761549 */   // Label 11882: @761549
     /*  761549 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(761627), // Rule ID 14082 //
     /*  761554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  761574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761625 */     GIR_RootConstrainSelectedInstOperands,
     /*  761626 */     // GIR_Coverage, 14082,
     /*  761626 */     GIR_EraseRootFromParent_Done,
     /*  761627 */   // Label 11883: @761627
     /*  761627 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(761705), // Rule ID 14083 //
     /*  761632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  761652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  761681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761703 */     GIR_RootConstrainSelectedInstOperands,
     /*  761704 */     // GIR_Coverage, 14083,
     /*  761704 */     GIR_EraseRootFromParent_Done,
     /*  761705 */   // Label 11884: @761705
     /*  761705 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(761783), // Rule ID 14086 //
     /*  761710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  761730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  761759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761781 */     GIR_RootConstrainSelectedInstOperands,
     /*  761782 */     // GIR_Coverage, 14086,
     /*  761782 */     GIR_EraseRootFromParent_Done,
     /*  761783 */   // Label 11885: @761783
     /*  761783 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(761861), // Rule ID 14087 //
     /*  761788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  761808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  761837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761859 */     GIR_RootConstrainSelectedInstOperands,
     /*  761860 */     // GIR_Coverage, 14087,
     /*  761860 */     GIR_EraseRootFromParent_Done,
     /*  761861 */   // Label 11886: @761861
     /*  761861 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(761939), // Rule ID 14090 //
     /*  761866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  761886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761912 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  761915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761937 */     GIR_RootConstrainSelectedInstOperands,
     /*  761938 */     // GIR_Coverage, 14090,
     /*  761938 */     GIR_EraseRootFromParent_Done,
     /*  761939 */   // Label 11887: @761939
     /*  761939 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(762017), // Rule ID 14091 //
     /*  761944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  761964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  761993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762015 */     GIR_RootConstrainSelectedInstOperands,
     /*  762016 */     // GIR_Coverage, 14091,
     /*  762016 */     GIR_EraseRootFromParent_Done,
     /*  762017 */   // Label 11888: @762017
     /*  762017 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(762095), // Rule ID 14094 //
     /*  762022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  762042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762068 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762093 */     GIR_RootConstrainSelectedInstOperands,
     /*  762094 */     // GIR_Coverage, 14094,
     /*  762094 */     GIR_EraseRootFromParent_Done,
     /*  762095 */   // Label 11889: @762095
     /*  762095 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(762173), // Rule ID 14095 //
     /*  762100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  762111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  762114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  762117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  762120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762171 */     GIR_RootConstrainSelectedInstOperands,
     /*  762172 */     // GIR_Coverage, 14095,
     /*  762172 */     GIR_EraseRootFromParent_Done,
     /*  762173 */   // Label 11890: @762173
     /*  762173 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(762251), // Rule ID 14098 //
     /*  762178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  762198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762249 */     GIR_RootConstrainSelectedInstOperands,
     /*  762250 */     // GIR_Coverage, 14098,
     /*  762250 */     GIR_EraseRootFromParent_Done,
     /*  762251 */   // Label 11891: @762251
     /*  762251 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(762329), // Rule ID 14099 //
     /*  762256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  762267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  762270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  762273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  762276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762327 */     GIR_RootConstrainSelectedInstOperands,
     /*  762328 */     // GIR_Coverage, 14099,
     /*  762328 */     GIR_EraseRootFromParent_Done,
     /*  762329 */   // Label 11892: @762329
     /*  762329 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(762407), // Rule ID 14102 //
     /*  762334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  762354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762405 */     GIR_RootConstrainSelectedInstOperands,
     /*  762406 */     // GIR_Coverage, 14102,
     /*  762406 */     GIR_EraseRootFromParent_Done,
     /*  762407 */   // Label 11893: @762407
     /*  762407 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(762485), // Rule ID 14103 //
     /*  762412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  762432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762483 */     GIR_RootConstrainSelectedInstOperands,
     /*  762484 */     // GIR_Coverage, 14103,
     /*  762484 */     GIR_EraseRootFromParent_Done,
     /*  762485 */   // Label 11894: @762485
     /*  762485 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(762563), // Rule ID 14106 //
     /*  762490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  762510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762561 */     GIR_RootConstrainSelectedInstOperands,
     /*  762562 */     // GIR_Coverage, 14106,
     /*  762562 */     GIR_EraseRootFromParent_Done,
     /*  762563 */   // Label 11895: @762563
     /*  762563 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(762641), // Rule ID 14107 //
     /*  762568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  762588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  762617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762639 */     GIR_RootConstrainSelectedInstOperands,
     /*  762640 */     // GIR_Coverage, 14107,
     /*  762640 */     GIR_EraseRootFromParent_Done,
     /*  762641 */   // Label 11896: @762641
     /*  762641 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(762719), // Rule ID 14110 //
     /*  762646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  762666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762717 */     GIR_RootConstrainSelectedInstOperands,
     /*  762718 */     // GIR_Coverage, 14110,
     /*  762718 */     GIR_EraseRootFromParent_Done,
     /*  762719 */   // Label 11897: @762719
     /*  762719 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(762797), // Rule ID 14111 //
     /*  762724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  762744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  762773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762795 */     GIR_RootConstrainSelectedInstOperands,
     /*  762796 */     // GIR_Coverage, 14111,
     /*  762796 */     GIR_EraseRootFromParent_Done,
     /*  762797 */   // Label 11898: @762797
     /*  762797 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(762875), // Rule ID 14114 //
     /*  762802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  762822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762873 */     GIR_RootConstrainSelectedInstOperands,
     /*  762874 */     // GIR_Coverage, 14114,
     /*  762874 */     GIR_EraseRootFromParent_Done,
     /*  762875 */   // Label 11899: @762875
     /*  762875 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(762953), // Rule ID 14115 //
     /*  762880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  762900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  762929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762951 */     GIR_RootConstrainSelectedInstOperands,
     /*  762952 */     // GIR_Coverage, 14115,
     /*  762952 */     GIR_EraseRootFromParent_Done,
     /*  762953 */   // Label 11900: @762953
     /*  762953 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(763031), // Rule ID 14118 //
     /*  762958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  762978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763029 */     GIR_RootConstrainSelectedInstOperands,
     /*  763030 */     // GIR_Coverage, 14118,
     /*  763030 */     GIR_EraseRootFromParent_Done,
     /*  763031 */   // Label 11901: @763031
     /*  763031 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(763109), // Rule ID 14119 //
     /*  763036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  763047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  763050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  763053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  763056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763107 */     GIR_RootConstrainSelectedInstOperands,
     /*  763108 */     // GIR_Coverage, 14119,
     /*  763108 */     GIR_EraseRootFromParent_Done,
     /*  763109 */   // Label 11902: @763109
     /*  763109 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(763187), // Rule ID 14122 //
     /*  763114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  763134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  763163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763185 */     GIR_RootConstrainSelectedInstOperands,
     /*  763186 */     // GIR_Coverage, 14122,
     /*  763186 */     GIR_EraseRootFromParent_Done,
     /*  763187 */   // Label 11903: @763187
     /*  763187 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(763265), // Rule ID 14123 //
     /*  763192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  763203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  763206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  763209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  763212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  763231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  763241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763263 */     GIR_RootConstrainSelectedInstOperands,
     /*  763264 */     // GIR_Coverage, 14123,
     /*  763264 */     GIR_EraseRootFromParent_Done,
     /*  763265 */   // Label 11904: @763265
     /*  763265 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(763343), // Rule ID 14126 //
     /*  763270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  763290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  763319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763341 */     GIR_RootConstrainSelectedInstOperands,
     /*  763342 */     // GIR_Coverage, 14126,
     /*  763342 */     GIR_EraseRootFromParent_Done,
     /*  763343 */   // Label 11905: @763343
     /*  763343 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(763421), // Rule ID 14127 //
     /*  763348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  763359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  763362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  763365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  763368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  763387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  763397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763419 */     GIR_RootConstrainSelectedInstOperands,
     /*  763420 */     // GIR_Coverage, 14127,
     /*  763420 */     GIR_EraseRootFromParent_Done,
     /*  763421 */   // Label 11906: @763421
     /*  763421 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(763499), // Rule ID 14130 //
     /*  763426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  763446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763497 */     GIR_RootConstrainSelectedInstOperands,
     /*  763498 */     // GIR_Coverage, 14130,
     /*  763498 */     GIR_EraseRootFromParent_Done,
     /*  763499 */   // Label 11907: @763499
     /*  763499 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(763577), // Rule ID 14131 //
     /*  763504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  763524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  763553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763575 */     GIR_RootConstrainSelectedInstOperands,
     /*  763576 */     // GIR_Coverage, 14131,
     /*  763576 */     GIR_EraseRootFromParent_Done,
     /*  763577 */   // Label 11908: @763577
     /*  763577 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(763655), // Rule ID 14134 //
     /*  763582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  763631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763653 */     GIR_RootConstrainSelectedInstOperands,
     /*  763654 */     // GIR_Coverage, 14134,
     /*  763654 */     GIR_EraseRootFromParent_Done,
     /*  763655 */   // Label 11909: @763655
     /*  763655 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(763733), // Rule ID 14135 //
     /*  763660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  763709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763731 */     GIR_RootConstrainSelectedInstOperands,
     /*  763732 */     // GIR_Coverage, 14135,
     /*  763732 */     GIR_EraseRootFromParent_Done,
     /*  763733 */   // Label 11910: @763733
     /*  763733 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(763811), // Rule ID 14138 //
     /*  763738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  763787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763809 */     GIR_RootConstrainSelectedInstOperands,
     /*  763810 */     // GIR_Coverage, 14138,
     /*  763810 */     GIR_EraseRootFromParent_Done,
     /*  763811 */   // Label 11911: @763811
     /*  763811 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(763889), // Rule ID 14139 //
     /*  763816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763862 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  763865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763887 */     GIR_RootConstrainSelectedInstOperands,
     /*  763888 */     // GIR_Coverage, 14139,
     /*  763888 */     GIR_EraseRootFromParent_Done,
     /*  763889 */   // Label 11912: @763889
     /*  763889 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(763967), // Rule ID 14142 //
     /*  763894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  763943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763965 */     GIR_RootConstrainSelectedInstOperands,
     /*  763966 */     // GIR_Coverage, 14142,
     /*  763966 */     GIR_EraseRootFromParent_Done,
     /*  763967 */   // Label 11913: @763967
     /*  763967 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(764045), // Rule ID 14143 //
     /*  763972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764043 */     GIR_RootConstrainSelectedInstOperands,
     /*  764044 */     // GIR_Coverage, 14143,
     /*  764044 */     GIR_EraseRootFromParent_Done,
     /*  764045 */   // Label 11914: @764045
     /*  764045 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(764123), // Rule ID 14146 //
     /*  764050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  764099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764121 */     GIR_RootConstrainSelectedInstOperands,
     /*  764122 */     // GIR_Coverage, 14146,
     /*  764122 */     GIR_EraseRootFromParent_Done,
     /*  764123 */   // Label 11915: @764123
     /*  764123 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(764201), // Rule ID 14147 //
     /*  764128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  764139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  764142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  764145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  764177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764199 */     GIR_RootConstrainSelectedInstOperands,
     /*  764200 */     // GIR_Coverage, 14147,
     /*  764200 */     GIR_EraseRootFromParent_Done,
     /*  764201 */   // Label 11916: @764201
     /*  764201 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(764279), // Rule ID 14150 //
     /*  764206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764277 */     GIR_RootConstrainSelectedInstOperands,
     /*  764278 */     // GIR_Coverage, 14150,
     /*  764278 */     GIR_EraseRootFromParent_Done,
     /*  764279 */   // Label 11917: @764279
     /*  764279 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(764357), // Rule ID 14151 //
     /*  764284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  764295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  764298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  764301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764355 */     GIR_RootConstrainSelectedInstOperands,
     /*  764356 */     // GIR_Coverage, 14151,
     /*  764356 */     GIR_EraseRootFromParent_Done,
     /*  764357 */   // Label 11918: @764357
     /*  764357 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(764435), // Rule ID 14154 //
     /*  764362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764433 */     GIR_RootConstrainSelectedInstOperands,
     /*  764434 */     // GIR_Coverage, 14154,
     /*  764434 */     GIR_EraseRootFromParent_Done,
     /*  764435 */   // Label 11919: @764435
     /*  764435 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(764513), // Rule ID 14155 //
     /*  764440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  764489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764511 */     GIR_RootConstrainSelectedInstOperands,
     /*  764512 */     // GIR_Coverage, 14155,
     /*  764512 */     GIR_EraseRootFromParent_Done,
     /*  764513 */   // Label 11920: @764513
     /*  764513 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(764591), // Rule ID 14158 //
     /*  764518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764589 */     GIR_RootConstrainSelectedInstOperands,
     /*  764590 */     // GIR_Coverage, 14158,
     /*  764590 */     GIR_EraseRootFromParent_Done,
     /*  764591 */   // Label 11921: @764591
     /*  764591 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(764669), // Rule ID 14159 //
     /*  764596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764642 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764667 */     GIR_RootConstrainSelectedInstOperands,
     /*  764668 */     // GIR_Coverage, 14159,
     /*  764668 */     GIR_EraseRootFromParent_Done,
     /*  764669 */   // Label 11922: @764669
     /*  764669 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(764747), // Rule ID 14162 //
     /*  764674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764745 */     GIR_RootConstrainSelectedInstOperands,
     /*  764746 */     // GIR_Coverage, 14162,
     /*  764746 */     GIR_EraseRootFromParent_Done,
     /*  764747 */   // Label 11923: @764747
     /*  764747 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(764825), // Rule ID 14163 //
     /*  764752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764823 */     GIR_RootConstrainSelectedInstOperands,
     /*  764824 */     // GIR_Coverage, 14163,
     /*  764824 */     GIR_EraseRootFromParent_Done,
     /*  764825 */   // Label 11924: @764825
     /*  764825 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(764903), // Rule ID 14166 //
     /*  764830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  764850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764901 */     GIR_RootConstrainSelectedInstOperands,
     /*  764902 */     // GIR_Coverage, 14166,
     /*  764902 */     GIR_EraseRootFromParent_Done,
     /*  764903 */   // Label 11925: @764903
     /*  764903 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(764981), // Rule ID 14167 //
     /*  764908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  764928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  764947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  764957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764979 */     GIR_RootConstrainSelectedInstOperands,
     /*  764980 */     // GIR_Coverage, 14167,
     /*  764980 */     GIR_EraseRootFromParent_Done,
     /*  764981 */   // Label 11926: @764981
     /*  764981 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(765059), // Rule ID 14170 //
     /*  764986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  764994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  765035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765057 */     GIR_RootConstrainSelectedInstOperands,
     /*  765058 */     // GIR_Coverage, 14170,
     /*  765058 */     GIR_EraseRootFromParent_Done,
     /*  765059 */   // Label 11927: @765059
     /*  765059 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(765137), // Rule ID 14171 //
     /*  765064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  765075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  765078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  765081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  765099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  765113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765135 */     GIR_RootConstrainSelectedInstOperands,
     /*  765136 */     // GIR_Coverage, 14171,
     /*  765136 */     GIR_EraseRootFromParent_Done,
     /*  765137 */   // Label 11928: @765137
     /*  765137 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(765215), // Rule ID 14174 //
     /*  765142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765213 */     GIR_RootConstrainSelectedInstOperands,
     /*  765214 */     // GIR_Coverage, 14174,
     /*  765214 */     GIR_EraseRootFromParent_Done,
     /*  765215 */   // Label 11929: @765215
     /*  765215 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(765293), // Rule ID 14175 //
     /*  765220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  765231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  765234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  765237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765291 */     GIR_RootConstrainSelectedInstOperands,
     /*  765292 */     // GIR_Coverage, 14175,
     /*  765292 */     GIR_EraseRootFromParent_Done,
     /*  765293 */   // Label 11930: @765293
     /*  765293 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(765371), // Rule ID 14178 //
     /*  765298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765369 */     GIR_RootConstrainSelectedInstOperands,
     /*  765370 */     // GIR_Coverage, 14178,
     /*  765370 */     GIR_EraseRootFromParent_Done,
     /*  765371 */   // Label 11931: @765371
     /*  765371 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(765449), // Rule ID 14179 //
     /*  765376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  765387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  765390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  765393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765447 */     GIR_RootConstrainSelectedInstOperands,
     /*  765448 */     // GIR_Coverage, 14179,
     /*  765448 */     GIR_EraseRootFromParent_Done,
     /*  765449 */   // Label 11932: @765449
     /*  765449 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(765527), // Rule ID 14182 //
     /*  765454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765500 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765525 */     GIR_RootConstrainSelectedInstOperands,
     /*  765526 */     // GIR_Coverage, 14182,
     /*  765526 */     GIR_EraseRootFromParent_Done,
     /*  765527 */   // Label 11933: @765527
     /*  765527 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(765605), // Rule ID 14183 //
     /*  765532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765578 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765603 */     GIR_RootConstrainSelectedInstOperands,
     /*  765604 */     // GIR_Coverage, 14183,
     /*  765604 */     GIR_EraseRootFromParent_Done,
     /*  765605 */   // Label 11934: @765605
     /*  765605 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(765683), // Rule ID 14186 //
     /*  765610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765681 */     GIR_RootConstrainSelectedInstOperands,
     /*  765682 */     // GIR_Coverage, 14186,
     /*  765682 */     GIR_EraseRootFromParent_Done,
     /*  765683 */   // Label 11935: @765683
     /*  765683 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(765761), // Rule ID 14187 //
     /*  765688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  765737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765759 */     GIR_RootConstrainSelectedInstOperands,
     /*  765760 */     // GIR_Coverage, 14187,
     /*  765760 */     GIR_EraseRootFromParent_Done,
     /*  765761 */   // Label 11936: @765761
     /*  765761 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(765839), // Rule ID 14190 //
     /*  765766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765837 */     GIR_RootConstrainSelectedInstOperands,
     /*  765838 */     // GIR_Coverage, 14190,
     /*  765838 */     GIR_EraseRootFromParent_Done,
     /*  765839 */   // Label 11937: @765839
     /*  765839 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(765917), // Rule ID 14191 //
     /*  765844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  765864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  765893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765915 */     GIR_RootConstrainSelectedInstOperands,
     /*  765916 */     // GIR_Coverage, 14191,
     /*  765916 */     GIR_EraseRootFromParent_Done,
     /*  765917 */   // Label 11938: @765917
     /*  765917 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(765995), // Rule ID 14194 //
     /*  765922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  765930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  765942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  765961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  765971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765993 */     GIR_RootConstrainSelectedInstOperands,
     /*  765994 */     // GIR_Coverage, 14194,
     /*  765994 */     GIR_EraseRootFromParent_Done,
     /*  765995 */   // Label 11939: @765995
     /*  765995 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(766073), // Rule ID 14195 //
     /*  766000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  766011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  766014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  766017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766071 */     GIR_RootConstrainSelectedInstOperands,
     /*  766072 */     // GIR_Coverage, 14195,
     /*  766072 */     GIR_EraseRootFromParent_Done,
     /*  766073 */   // Label 11940: @766073
     /*  766073 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(766151), // Rule ID 14198 //
     /*  766078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766149 */     GIR_RootConstrainSelectedInstOperands,
     /*  766150 */     // GIR_Coverage, 14198,
     /*  766150 */     GIR_EraseRootFromParent_Done,
     /*  766151 */   // Label 11941: @766151
     /*  766151 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(766229), // Rule ID 14199 //
     /*  766156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  766167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  766170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  766173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766227 */     GIR_RootConstrainSelectedInstOperands,
     /*  766228 */     // GIR_Coverage, 14199,
     /*  766228 */     GIR_EraseRootFromParent_Done,
     /*  766229 */   // Label 11942: @766229
     /*  766229 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(766307), // Rule ID 14202 //
     /*  766234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766305 */     GIR_RootConstrainSelectedInstOperands,
     /*  766306 */     // GIR_Coverage, 14202,
     /*  766306 */     GIR_EraseRootFromParent_Done,
     /*  766307 */   // Label 11943: @766307
     /*  766307 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(766385), // Rule ID 14203 //
     /*  766312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  766323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  766326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  766329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766383 */     GIR_RootConstrainSelectedInstOperands,
     /*  766384 */     // GIR_Coverage, 14203,
     /*  766384 */     GIR_EraseRootFromParent_Done,
     /*  766385 */   // Label 11944: @766385
     /*  766385 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(766463), // Rule ID 14206 //
     /*  766390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766461 */     GIR_RootConstrainSelectedInstOperands,
     /*  766462 */     // GIR_Coverage, 14206,
     /*  766462 */     GIR_EraseRootFromParent_Done,
     /*  766463 */   // Label 11945: @766463
     /*  766463 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(766541), // Rule ID 14207 //
     /*  766468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766539 */     GIR_RootConstrainSelectedInstOperands,
     /*  766540 */     // GIR_Coverage, 14207,
     /*  766540 */     GIR_EraseRootFromParent_Done,
     /*  766541 */   // Label 11946: @766541
     /*  766541 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(766619), // Rule ID 14210 //
     /*  766546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766617 */     GIR_RootConstrainSelectedInstOperands,
     /*  766618 */     // GIR_Coverage, 14210,
     /*  766618 */     GIR_EraseRootFromParent_Done,
     /*  766619 */   // Label 11947: @766619
     /*  766619 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(766697), // Rule ID 14211 //
     /*  766624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  766673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766695 */     GIR_RootConstrainSelectedInstOperands,
     /*  766696 */     // GIR_Coverage, 14211,
     /*  766696 */     GIR_EraseRootFromParent_Done,
     /*  766697 */   // Label 11948: @766697
     /*  766697 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(766775), // Rule ID 14214 //
     /*  766702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766773 */     GIR_RootConstrainSelectedInstOperands,
     /*  766774 */     // GIR_Coverage, 14214,
     /*  766774 */     GIR_EraseRootFromParent_Done,
     /*  766775 */   // Label 11949: @766775
     /*  766775 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(766853), // Rule ID 14215 //
     /*  766780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  766829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766851 */     GIR_RootConstrainSelectedInstOperands,
     /*  766852 */     // GIR_Coverage, 14215,
     /*  766852 */     GIR_EraseRootFromParent_Done,
     /*  766853 */   // Label 11950: @766853
     /*  766853 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(766931), // Rule ID 14218 //
     /*  766858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766929 */     GIR_RootConstrainSelectedInstOperands,
     /*  766930 */     // GIR_Coverage, 14218,
     /*  766930 */     GIR_EraseRootFromParent_Done,
     /*  766931 */   // Label 11951: @766931
     /*  766931 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(767009), // Rule ID 14219 //
     /*  766936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  766944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  766985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767007 */     GIR_RootConstrainSelectedInstOperands,
     /*  767008 */     // GIR_Coverage, 14219,
     /*  767008 */     GIR_EraseRootFromParent_Done,
     /*  767009 */   // Label 11952: @767009
     /*  767009 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(767087), // Rule ID 14310 //
     /*  767014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  767034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  767063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767085 */     GIR_RootConstrainSelectedInstOperands,
     /*  767086 */     // GIR_Coverage, 14310,
     /*  767086 */     GIR_EraseRootFromParent_Done,
     /*  767087 */   // Label 11953: @767087
     /*  767087 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(767165), // Rule ID 14311 //
     /*  767092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  767103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  767106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  767109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  767112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  767141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767163 */     GIR_RootConstrainSelectedInstOperands,
     /*  767164 */     // GIR_Coverage, 14311,
     /*  767164 */     GIR_EraseRootFromParent_Done,
     /*  767165 */   // Label 11954: @767165
     /*  767165 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(767243), // Rule ID 14314 //
     /*  767170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  767190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767241 */     GIR_RootConstrainSelectedInstOperands,
     /*  767242 */     // GIR_Coverage, 14314,
     /*  767242 */     GIR_EraseRootFromParent_Done,
     /*  767243 */   // Label 11955: @767243
     /*  767243 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(767321), // Rule ID 14315 //
     /*  767248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  767259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  767262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  767265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  767268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767319 */     GIR_RootConstrainSelectedInstOperands,
     /*  767320 */     // GIR_Coverage, 14315,
     /*  767320 */     GIR_EraseRootFromParent_Done,
     /*  767321 */   // Label 11956: @767321
     /*  767321 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(767399), // Rule ID 14318 //
     /*  767326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  767346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767397 */     GIR_RootConstrainSelectedInstOperands,
     /*  767398 */     // GIR_Coverage, 14318,
     /*  767398 */     GIR_EraseRootFromParent_Done,
     /*  767399 */   // Label 11957: @767399
     /*  767399 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(767477), // Rule ID 14319 //
     /*  767404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  767424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767475 */     GIR_RootConstrainSelectedInstOperands,
     /*  767476 */     // GIR_Coverage, 14319,
     /*  767476 */     GIR_EraseRootFromParent_Done,
     /*  767477 */   // Label 11958: @767477
     /*  767477 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(767555), // Rule ID 14322 //
     /*  767482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  767502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767553 */     GIR_RootConstrainSelectedInstOperands,
     /*  767554 */     // GIR_Coverage, 14322,
     /*  767554 */     GIR_EraseRootFromParent_Done,
     /*  767555 */   // Label 11959: @767555
     /*  767555 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(767633), // Rule ID 14323 //
     /*  767560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  767580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767606 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  767609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767631 */     GIR_RootConstrainSelectedInstOperands,
     /*  767632 */     // GIR_Coverage, 14323,
     /*  767632 */     GIR_EraseRootFromParent_Done,
     /*  767633 */   // Label 11960: @767633
     /*  767633 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(767711), // Rule ID 14326 //
     /*  767638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  767658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767709 */     GIR_RootConstrainSelectedInstOperands,
     /*  767710 */     // GIR_Coverage, 14326,
     /*  767710 */     GIR_EraseRootFromParent_Done,
     /*  767711 */   // Label 11961: @767711
     /*  767711 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(767789), // Rule ID 14327 //
     /*  767716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  767736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767762 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767787 */     GIR_RootConstrainSelectedInstOperands,
     /*  767788 */     // GIR_Coverage, 14327,
     /*  767788 */     GIR_EraseRootFromParent_Done,
     /*  767789 */   // Label 11962: @767789
     /*  767789 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(767867), // Rule ID 14330 //
     /*  767794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  767814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767865 */     GIR_RootConstrainSelectedInstOperands,
     /*  767866 */     // GIR_Coverage, 14330,
     /*  767866 */     GIR_EraseRootFromParent_Done,
     /*  767867 */   // Label 11963: @767867
     /*  767867 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(767945), // Rule ID 14331 //
     /*  767872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  767892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  767921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767943 */     GIR_RootConstrainSelectedInstOperands,
     /*  767944 */     // GIR_Coverage, 14331,
     /*  767944 */     GIR_EraseRootFromParent_Done,
     /*  767945 */   // Label 11964: @767945
     /*  767945 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(768023), // Rule ID 14334 //
     /*  767950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  767970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  767999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768021 */     GIR_RootConstrainSelectedInstOperands,
     /*  768022 */     // GIR_Coverage, 14334,
     /*  768022 */     GIR_EraseRootFromParent_Done,
     /*  768023 */   // Label 11965: @768023
     /*  768023 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(768101), // Rule ID 14335 //
     /*  768028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  768039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  768042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  768045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  768048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768099 */     GIR_RootConstrainSelectedInstOperands,
     /*  768100 */     // GIR_Coverage, 14335,
     /*  768100 */     GIR_EraseRootFromParent_Done,
     /*  768101 */   // Label 11966: @768101
     /*  768101 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(768179), // Rule ID 14338 //
     /*  768106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  768126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768177 */     GIR_RootConstrainSelectedInstOperands,
     /*  768178 */     // GIR_Coverage, 14338,
     /*  768178 */     GIR_EraseRootFromParent_Done,
     /*  768179 */   // Label 11967: @768179
     /*  768179 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(768257), // Rule ID 14339 //
     /*  768184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  768195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  768198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  768201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  768204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768255 */     GIR_RootConstrainSelectedInstOperands,
     /*  768256 */     // GIR_Coverage, 14339,
     /*  768256 */     GIR_EraseRootFromParent_Done,
     /*  768257 */   // Label 11968: @768257
     /*  768257 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(768335), // Rule ID 14342 //
     /*  768262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  768282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768333 */     GIR_RootConstrainSelectedInstOperands,
     /*  768334 */     // GIR_Coverage, 14342,
     /*  768334 */     GIR_EraseRootFromParent_Done,
     /*  768335 */   // Label 11969: @768335
     /*  768335 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(768413), // Rule ID 14343 //
     /*  768340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  768351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  768354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  768357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  768360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768411 */     GIR_RootConstrainSelectedInstOperands,
     /*  768412 */     // GIR_Coverage, 14343,
     /*  768412 */     GIR_EraseRootFromParent_Done,
     /*  768413 */   // Label 11970: @768413
     /*  768413 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(768491), // Rule ID 14346 //
     /*  768418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  768438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768489 */     GIR_RootConstrainSelectedInstOperands,
     /*  768490 */     // GIR_Coverage, 14346,
     /*  768490 */     GIR_EraseRootFromParent_Done,
     /*  768491 */   // Label 11971: @768491
     /*  768491 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(768569), // Rule ID 14347 //
     /*  768496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  768516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  768545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768567 */     GIR_RootConstrainSelectedInstOperands,
     /*  768568 */     // GIR_Coverage, 14347,
     /*  768568 */     GIR_EraseRootFromParent_Done,
     /*  768569 */   // Label 11972: @768569
     /*  768569 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(768647), // Rule ID 14350 //
     /*  768574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  768594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  768623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768645 */     GIR_RootConstrainSelectedInstOperands,
     /*  768646 */     // GIR_Coverage, 14350,
     /*  768646 */     GIR_EraseRootFromParent_Done,
     /*  768647 */   // Label 11973: @768647
     /*  768647 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(768725), // Rule ID 14351 //
     /*  768652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  768672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  768701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768723 */     GIR_RootConstrainSelectedInstOperands,
     /*  768724 */     // GIR_Coverage, 14351,
     /*  768724 */     GIR_EraseRootFromParent_Done,
     /*  768725 */   // Label 11974: @768725
     /*  768725 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(768803), // Rule ID 14354 //
     /*  768730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  768750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768776 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  768779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768801 */     GIR_RootConstrainSelectedInstOperands,
     /*  768802 */     // GIR_Coverage, 14354,
     /*  768802 */     GIR_EraseRootFromParent_Done,
     /*  768803 */   // Label 11975: @768803
     /*  768803 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(768881), // Rule ID 14355 //
     /*  768808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  768828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  768857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768879 */     GIR_RootConstrainSelectedInstOperands,
     /*  768880 */     // GIR_Coverage, 14355,
     /*  768880 */     GIR_EraseRootFromParent_Done,
     /*  768881 */   // Label 11976: @768881
     /*  768881 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(768959), // Rule ID 14358 //
     /*  768886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  768906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768932 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  768935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768957 */     GIR_RootConstrainSelectedInstOperands,
     /*  768958 */     // GIR_Coverage, 14358,
     /*  768958 */     GIR_EraseRootFromParent_Done,
     /*  768959 */   // Label 11977: @768959
     /*  768959 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(769037), // Rule ID 14359 //
     /*  768964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  768984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769010 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769035 */     GIR_RootConstrainSelectedInstOperands,
     /*  769036 */     // GIR_Coverage, 14359,
     /*  769036 */     GIR_EraseRootFromParent_Done,
     /*  769037 */   // Label 11978: @769037
     /*  769037 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(769115), // Rule ID 14362 //
     /*  769042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769113 */     GIR_RootConstrainSelectedInstOperands,
     /*  769114 */     // GIR_Coverage, 14362,
     /*  769114 */     GIR_EraseRootFromParent_Done,
     /*  769115 */   // Label 11979: @769115
     /*  769115 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(769193), // Rule ID 14363 //
     /*  769120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  769131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  769134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  769137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  769140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769191 */     GIR_RootConstrainSelectedInstOperands,
     /*  769192 */     // GIR_Coverage, 14363,
     /*  769192 */     GIR_EraseRootFromParent_Done,
     /*  769193 */   // Label 11980: @769193
     /*  769193 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(769271), // Rule ID 14366 //
     /*  769198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  769218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769269 */     GIR_RootConstrainSelectedInstOperands,
     /*  769270 */     // GIR_Coverage, 14366,
     /*  769270 */     GIR_EraseRootFromParent_Done,
     /*  769271 */   // Label 11981: @769271
     /*  769271 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(769349), // Rule ID 14367 //
     /*  769276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  769287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  769290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  769293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  769296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769347 */     GIR_RootConstrainSelectedInstOperands,
     /*  769348 */     // GIR_Coverage, 14367,
     /*  769348 */     GIR_EraseRootFromParent_Done,
     /*  769349 */   // Label 11982: @769349
     /*  769349 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(769427), // Rule ID 14370 //
     /*  769354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  769374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  769400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769425 */     GIR_RootConstrainSelectedInstOperands,
     /*  769426 */     // GIR_Coverage, 14370,
     /*  769426 */     GIR_EraseRootFromParent_Done,
     /*  769427 */   // Label 11983: @769427
     /*  769427 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(769505), // Rule ID 14371 //
     /*  769432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  769452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769503 */     GIR_RootConstrainSelectedInstOperands,
     /*  769504 */     // GIR_Coverage, 14371,
     /*  769504 */     GIR_EraseRootFromParent_Done,
     /*  769505 */   // Label 11984: @769505
     /*  769505 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(769583), // Rule ID 14374 //
     /*  769510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  769530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769581 */     GIR_RootConstrainSelectedInstOperands,
     /*  769582 */     // GIR_Coverage, 14374,
     /*  769582 */     GIR_EraseRootFromParent_Done,
     /*  769583 */   // Label 11985: @769583
     /*  769583 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(769661), // Rule ID 14375 //
     /*  769588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  769608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  769637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769659 */     GIR_RootConstrainSelectedInstOperands,
     /*  769660 */     // GIR_Coverage, 14375,
     /*  769660 */     GIR_EraseRootFromParent_Done,
     /*  769661 */   // Label 11986: @769661
     /*  769661 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(769739), // Rule ID 14378 //
     /*  769666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  769686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769737 */     GIR_RootConstrainSelectedInstOperands,
     /*  769738 */     // GIR_Coverage, 14378,
     /*  769738 */     GIR_EraseRootFromParent_Done,
     /*  769739 */   // Label 11987: @769739
     /*  769739 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(769817), // Rule ID 14379 //
     /*  769744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  769764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  769793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769815 */     GIR_RootConstrainSelectedInstOperands,
     /*  769816 */     // GIR_Coverage, 14379,
     /*  769816 */     GIR_EraseRootFromParent_Done,
     /*  769817 */   // Label 11988: @769817
     /*  769817 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(769895), // Rule ID 14382 //
     /*  769822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  769842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769893 */     GIR_RootConstrainSelectedInstOperands,
     /*  769894 */     // GIR_Coverage, 14382,
     /*  769894 */     GIR_EraseRootFromParent_Done,
     /*  769895 */   // Label 11989: @769895
     /*  769895 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(769973), // Rule ID 14383 //
     /*  769900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  769920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769946 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  769949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769971 */     GIR_RootConstrainSelectedInstOperands,
     /*  769972 */     // GIR_Coverage, 14383,
     /*  769972 */     GIR_EraseRootFromParent_Done,
     /*  769973 */   // Label 11990: @769973
     /*  769973 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(770051), // Rule ID 14386 //
     /*  769978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  769998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  770027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770049 */     GIR_RootConstrainSelectedInstOperands,
     /*  770050 */     // GIR_Coverage, 14386,
     /*  770050 */     GIR_EraseRootFromParent_Done,
     /*  770051 */   // Label 11991: @770051
     /*  770051 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(770129), // Rule ID 14387 //
     /*  770056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  770067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  770070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  770073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  770076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  770095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  770105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770127 */     GIR_RootConstrainSelectedInstOperands,
     /*  770128 */     // GIR_Coverage, 14387,
     /*  770128 */     GIR_EraseRootFromParent_Done,
     /*  770129 */   // Label 11992: @770129
     /*  770129 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(770207), // Rule ID 14390 //
     /*  770134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  770154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770180 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  770183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770205 */     GIR_RootConstrainSelectedInstOperands,
     /*  770206 */     // GIR_Coverage, 14390,
     /*  770206 */     GIR_EraseRootFromParent_Done,
     /*  770207 */   // Label 11993: @770207
     /*  770207 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(770285), // Rule ID 14391 //
     /*  770212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  770223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  770226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  770229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  770232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  770251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  770261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770283 */     GIR_RootConstrainSelectedInstOperands,
     /*  770284 */     // GIR_Coverage, 14391,
     /*  770284 */     GIR_EraseRootFromParent_Done,
     /*  770285 */   // Label 11994: @770285
     /*  770285 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(770363), // Rule ID 14394 //
     /*  770290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  770310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  770339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770361 */     GIR_RootConstrainSelectedInstOperands,
     /*  770362 */     // GIR_Coverage, 14394,
     /*  770362 */     GIR_EraseRootFromParent_Done,
     /*  770363 */   // Label 11995: @770363
     /*  770363 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(770441), // Rule ID 14395 //
     /*  770368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  770371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  770379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  770382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  770385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  770388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  770407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  770417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770439 */     GIR_RootConstrainSelectedInstOperands,
     /*  770440 */     // GIR_Coverage, 14395,
     /*  770440 */     GIR_EraseRootFromParent_Done,
     /*  770441 */   // Label 11996: @770441
     /*  770441 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(770519), // Rule ID 14398 //
     /*  770446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  770495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770517 */     GIR_RootConstrainSelectedInstOperands,
     /*  770518 */     // GIR_Coverage, 14398,
     /*  770518 */     GIR_EraseRootFromParent_Done,
     /*  770519 */   // Label 11997: @770519
     /*  770519 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(770597), // Rule ID 14399 //
     /*  770524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  770573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770595 */     GIR_RootConstrainSelectedInstOperands,
     /*  770596 */     // GIR_Coverage, 14399,
     /*  770596 */     GIR_EraseRootFromParent_Done,
     /*  770597 */   // Label 11998: @770597
     /*  770597 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(770675), // Rule ID 14402 //
     /*  770602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770648 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770673 */     GIR_RootConstrainSelectedInstOperands,
     /*  770674 */     // GIR_Coverage, 14402,
     /*  770674 */     GIR_EraseRootFromParent_Done,
     /*  770675 */   // Label 11999: @770675
     /*  770675 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(770753), // Rule ID 14403 //
     /*  770680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770726 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770751 */     GIR_RootConstrainSelectedInstOperands,
     /*  770752 */     // GIR_Coverage, 14403,
     /*  770752 */     GIR_EraseRootFromParent_Done,
     /*  770753 */   // Label 12000: @770753
     /*  770753 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(770831), // Rule ID 14406 //
     /*  770758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  770807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770829 */     GIR_RootConstrainSelectedInstOperands,
     /*  770830 */     // GIR_Coverage, 14406,
     /*  770830 */     GIR_EraseRootFromParent_Done,
     /*  770831 */   // Label 12001: @770831
     /*  770831 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(770909), // Rule ID 14407 //
     /*  770836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  770856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  770885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770907 */     GIR_RootConstrainSelectedInstOperands,
     /*  770908 */     // GIR_Coverage, 14407,
     /*  770908 */     GIR_EraseRootFromParent_Done,
     /*  770909 */   // Label 12002: @770909
     /*  770909 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(770987), // Rule ID 14410 //
     /*  770914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  770922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  770934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  770953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  770963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770985 */     GIR_RootConstrainSelectedInstOperands,
     /*  770986 */     // GIR_Coverage, 14410,
     /*  770986 */     GIR_EraseRootFromParent_Done,
     /*  770987 */   // Label 12003: @770987
     /*  770987 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(771065), // Rule ID 14411 //
     /*  770992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  771003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  771006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  771009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  771041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771063 */     GIR_RootConstrainSelectedInstOperands,
     /*  771064 */     // GIR_Coverage, 14411,
     /*  771064 */     GIR_EraseRootFromParent_Done,
     /*  771065 */   // Label 12004: @771065
     /*  771065 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(771143), // Rule ID 14414 //
     /*  771070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771141 */     GIR_RootConstrainSelectedInstOperands,
     /*  771142 */     // GIR_Coverage, 14414,
     /*  771142 */     GIR_EraseRootFromParent_Done,
     /*  771143 */   // Label 12005: @771143
     /*  771143 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(771221), // Rule ID 14415 //
     /*  771148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  771159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  771162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  771165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771219 */     GIR_RootConstrainSelectedInstOperands,
     /*  771220 */     // GIR_Coverage, 14415,
     /*  771220 */     GIR_EraseRootFromParent_Done,
     /*  771221 */   // Label 12006: @771221
     /*  771221 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(771299), // Rule ID 14418 //
     /*  771226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771297 */     GIR_RootConstrainSelectedInstOperands,
     /*  771298 */     // GIR_Coverage, 14418,
     /*  771298 */     GIR_EraseRootFromParent_Done,
     /*  771299 */   // Label 12007: @771299
     /*  771299 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(771377), // Rule ID 14419 //
     /*  771304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  771315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  771318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  771321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  771353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771375 */     GIR_RootConstrainSelectedInstOperands,
     /*  771376 */     // GIR_Coverage, 14419,
     /*  771376 */     GIR_EraseRootFromParent_Done,
     /*  771377 */   // Label 12008: @771377
     /*  771377 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(771455), // Rule ID 14422 //
     /*  771382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771428 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771453 */     GIR_RootConstrainSelectedInstOperands,
     /*  771454 */     // GIR_Coverage, 14422,
     /*  771454 */     GIR_EraseRootFromParent_Done,
     /*  771455 */   // Label 12009: @771455
     /*  771455 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(771533), // Rule ID 14423 //
     /*  771460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771506 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771531 */     GIR_RootConstrainSelectedInstOperands,
     /*  771532 */     // GIR_Coverage, 14423,
     /*  771532 */     GIR_EraseRootFromParent_Done,
     /*  771533 */   // Label 12010: @771533
     /*  771533 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(771611), // Rule ID 14426 //
     /*  771538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771609 */     GIR_RootConstrainSelectedInstOperands,
     /*  771610 */     // GIR_Coverage, 14426,
     /*  771610 */     GIR_EraseRootFromParent_Done,
     /*  771611 */   // Label 12011: @771611
     /*  771611 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(771689), // Rule ID 14427 //
     /*  771616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771687 */     GIR_RootConstrainSelectedInstOperands,
     /*  771688 */     // GIR_Coverage, 14427,
     /*  771688 */     GIR_EraseRootFromParent_Done,
     /*  771689 */   // Label 12012: @771689
     /*  771689 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(771767), // Rule ID 14430 //
     /*  771694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771765 */     GIR_RootConstrainSelectedInstOperands,
     /*  771766 */     // GIR_Coverage, 14430,
     /*  771766 */     GIR_EraseRootFromParent_Done,
     /*  771767 */   // Label 12013: @771767
     /*  771767 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(771845), // Rule ID 14431 //
     /*  771772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771843 */     GIR_RootConstrainSelectedInstOperands,
     /*  771844 */     // GIR_Coverage, 14431,
     /*  771844 */     GIR_EraseRootFromParent_Done,
     /*  771845 */   // Label 12014: @771845
     /*  771845 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(771923), // Rule ID 14434 //
     /*  771850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  771870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771921 */     GIR_RootConstrainSelectedInstOperands,
     /*  771922 */     // GIR_Coverage, 14434,
     /*  771922 */     GIR_EraseRootFromParent_Done,
     /*  771923 */   // Label 12015: @771923
     /*  771923 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(772001), // Rule ID 14435 //
     /*  771928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  771936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  771948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  771967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  771977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771999 */     GIR_RootConstrainSelectedInstOperands,
     /*  772000 */     // GIR_Coverage, 14435,
     /*  772000 */     GIR_EraseRootFromParent_Done,
     /*  772001 */   // Label 12016: @772001
     /*  772001 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(772079), // Rule ID 14438 //
     /*  772006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772077 */     GIR_RootConstrainSelectedInstOperands,
     /*  772078 */     // GIR_Coverage, 14438,
     /*  772078 */     GIR_EraseRootFromParent_Done,
     /*  772079 */   // Label 12017: @772079
     /*  772079 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(772157), // Rule ID 14439 //
     /*  772084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  772095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  772098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  772101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772155 */     GIR_RootConstrainSelectedInstOperands,
     /*  772156 */     // GIR_Coverage, 14439,
     /*  772156 */     GIR_EraseRootFromParent_Done,
     /*  772157 */   // Label 12018: @772157
     /*  772157 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(772235), // Rule ID 14442 //
     /*  772162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772208 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772233 */     GIR_RootConstrainSelectedInstOperands,
     /*  772234 */     // GIR_Coverage, 14442,
     /*  772234 */     GIR_EraseRootFromParent_Done,
     /*  772235 */   // Label 12019: @772235
     /*  772235 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(772313), // Rule ID 14443 //
     /*  772240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  772251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  772254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  772257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772311 */     GIR_RootConstrainSelectedInstOperands,
     /*  772312 */     // GIR_Coverage, 14443,
     /*  772312 */     GIR_EraseRootFromParent_Done,
     /*  772313 */   // Label 12020: @772313
     /*  772313 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(772391), // Rule ID 14446 //
     /*  772318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  772364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772389 */     GIR_RootConstrainSelectedInstOperands,
     /*  772390 */     // GIR_Coverage, 14446,
     /*  772390 */     GIR_EraseRootFromParent_Done,
     /*  772391 */   // Label 12021: @772391
     /*  772391 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(772469), // Rule ID 14447 //
     /*  772396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  772407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  772410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772442 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772467 */     GIR_RootConstrainSelectedInstOperands,
     /*  772468 */     // GIR_Coverage, 14447,
     /*  772468 */     GIR_EraseRootFromParent_Done,
     /*  772469 */   // Label 12022: @772469
     /*  772469 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(772547), // Rule ID 14450 //
     /*  772474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772545 */     GIR_RootConstrainSelectedInstOperands,
     /*  772546 */     // GIR_Coverage, 14450,
     /*  772546 */     GIR_EraseRootFromParent_Done,
     /*  772547 */   // Label 12023: @772547
     /*  772547 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(772625), // Rule ID 14451 //
     /*  772552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772623 */     GIR_RootConstrainSelectedInstOperands,
     /*  772624 */     // GIR_Coverage, 14451,
     /*  772624 */     GIR_EraseRootFromParent_Done,
     /*  772625 */   // Label 12024: @772625
     /*  772625 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(772703), // Rule ID 14454 //
     /*  772630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772701 */     GIR_RootConstrainSelectedInstOperands,
     /*  772702 */     // GIR_Coverage, 14454,
     /*  772702 */     GIR_EraseRootFromParent_Done,
     /*  772703 */   // Label 12025: @772703
     /*  772703 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(772781), // Rule ID 14455 //
     /*  772708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772754 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  772757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772779 */     GIR_RootConstrainSelectedInstOperands,
     /*  772780 */     // GIR_Coverage, 14455,
     /*  772780 */     GIR_EraseRootFromParent_Done,
     /*  772781 */   // Label 12026: @772781
     /*  772781 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(772859), // Rule ID 14458 //
     /*  772786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772857 */     GIR_RootConstrainSelectedInstOperands,
     /*  772858 */     // GIR_Coverage, 14458,
     /*  772858 */     GIR_EraseRootFromParent_Done,
     /*  772859 */   // Label 12027: @772859
     /*  772859 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(772937), // Rule ID 14459 //
     /*  772864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  772884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  772913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772935 */     GIR_RootConstrainSelectedInstOperands,
     /*  772936 */     // GIR_Coverage, 14459,
     /*  772936 */     GIR_EraseRootFromParent_Done,
     /*  772937 */   // Label 12028: @772937
     /*  772937 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(773015), // Rule ID 14462 //
     /*  772942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  772950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  772991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773013 */     GIR_RootConstrainSelectedInstOperands,
     /*  773014 */     // GIR_Coverage, 14462,
     /*  773014 */     GIR_EraseRootFromParent_Done,
     /*  773015 */   // Label 12029: @773015
     /*  773015 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(773093), // Rule ID 14463 //
     /*  773020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  773031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  773034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  773037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773091 */     GIR_RootConstrainSelectedInstOperands,
     /*  773092 */     // GIR_Coverage, 14463,
     /*  773092 */     GIR_EraseRootFromParent_Done,
     /*  773093 */   // Label 12030: @773093
     /*  773093 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(773171), // Rule ID 14466 //
     /*  773098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773169 */     GIR_RootConstrainSelectedInstOperands,
     /*  773170 */     // GIR_Coverage, 14466,
     /*  773170 */     GIR_EraseRootFromParent_Done,
     /*  773171 */   // Label 12031: @773171
     /*  773171 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(773249), // Rule ID 14467 //
     /*  773176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  773187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  773190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  773193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773247 */     GIR_RootConstrainSelectedInstOperands,
     /*  773248 */     // GIR_Coverage, 14467,
     /*  773248 */     GIR_EraseRootFromParent_Done,
     /*  773249 */   // Label 12032: @773249
     /*  773249 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(773327), // Rule ID 14470 //
     /*  773254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773325 */     GIR_RootConstrainSelectedInstOperands,
     /*  773326 */     // GIR_Coverage, 14470,
     /*  773326 */     GIR_EraseRootFromParent_Done,
     /*  773327 */   // Label 12033: @773327
     /*  773327 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(773405), // Rule ID 14471 //
     /*  773332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  773343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  773346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  773349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773403 */     GIR_RootConstrainSelectedInstOperands,
     /*  773404 */     // GIR_Coverage, 14471,
     /*  773404 */     GIR_EraseRootFromParent_Done,
     /*  773405 */   // Label 12034: @773405
     /*  773405 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(773483), // Rule ID 14474 //
     /*  773410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773481 */     GIR_RootConstrainSelectedInstOperands,
     /*  773482 */     // GIR_Coverage, 14474,
     /*  773482 */     GIR_EraseRootFromParent_Done,
     /*  773483 */   // Label 12035: @773483
     /*  773483 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(773561), // Rule ID 14475 //
     /*  773488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  773537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773559 */     GIR_RootConstrainSelectedInstOperands,
     /*  773560 */     // GIR_Coverage, 14475,
     /*  773560 */     GIR_EraseRootFromParent_Done,
     /*  773561 */   // Label 12036: @773561
     /*  773561 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(773639), // Rule ID 14478 //
     /*  773566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773637 */     GIR_RootConstrainSelectedInstOperands,
     /*  773638 */     // GIR_Coverage, 14478,
     /*  773638 */     GIR_EraseRootFromParent_Done,
     /*  773639 */   // Label 12037: @773639
     /*  773639 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(773717), // Rule ID 14479 //
     /*  773644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  773693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773715 */     GIR_RootConstrainSelectedInstOperands,
     /*  773716 */     // GIR_Coverage, 14479,
     /*  773716 */     GIR_EraseRootFromParent_Done,
     /*  773717 */   // Label 12038: @773717
     /*  773717 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(773795), // Rule ID 14482 //
     /*  773722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773793 */     GIR_RootConstrainSelectedInstOperands,
     /*  773794 */     // GIR_Coverage, 14482,
     /*  773794 */     GIR_EraseRootFromParent_Done,
     /*  773795 */   // Label 12039: @773795
     /*  773795 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(773873), // Rule ID 14483 //
     /*  773800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  773808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  773849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773871 */     GIR_RootConstrainSelectedInstOperands,
     /*  773872 */     // GIR_Coverage, 14483,
     /*  773872 */     GIR_EraseRootFromParent_Done,
     /*  773873 */   // Label 12040: @773873
     /*  773873 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(773951), // Rule ID 14574 //
     /*  773878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  773898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  773927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773949 */     GIR_RootConstrainSelectedInstOperands,
     /*  773950 */     // GIR_Coverage, 14574,
     /*  773950 */     GIR_EraseRootFromParent_Done,
     /*  773951 */   // Label 12041: @773951
     /*  773951 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(774029), // Rule ID 14575 //
     /*  773956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  773976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  774005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774027 */     GIR_RootConstrainSelectedInstOperands,
     /*  774028 */     // GIR_Coverage, 14575,
     /*  774028 */     GIR_EraseRootFromParent_Done,
     /*  774029 */   // Label 12042: @774029
     /*  774029 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(774107), // Rule ID 14578 //
     /*  774034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  774054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774080 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774105 */     GIR_RootConstrainSelectedInstOperands,
     /*  774106 */     // GIR_Coverage, 14578,
     /*  774106 */     GIR_EraseRootFromParent_Done,
     /*  774107 */   // Label 12043: @774107
     /*  774107 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(774185), // Rule ID 14579 //
     /*  774112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  774123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  774126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  774129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  774132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774158 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774183 */     GIR_RootConstrainSelectedInstOperands,
     /*  774184 */     // GIR_Coverage, 14579,
     /*  774184 */     GIR_EraseRootFromParent_Done,
     /*  774185 */   // Label 12044: @774185
     /*  774185 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(774263), // Rule ID 14582 //
     /*  774190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  774210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774261 */     GIR_RootConstrainSelectedInstOperands,
     /*  774262 */     // GIR_Coverage, 14582,
     /*  774262 */     GIR_EraseRootFromParent_Done,
     /*  774263 */   // Label 12045: @774263
     /*  774263 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(774341), // Rule ID 14583 //
     /*  774268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  774279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  774282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  774285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  774288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774314 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774339 */     GIR_RootConstrainSelectedInstOperands,
     /*  774340 */     // GIR_Coverage, 14583,
     /*  774340 */     GIR_EraseRootFromParent_Done,
     /*  774341 */   // Label 12046: @774341
     /*  774341 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(774419), // Rule ID 14586 //
     /*  774346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774417 */     GIR_RootConstrainSelectedInstOperands,
     /*  774418 */     // GIR_Coverage, 14586,
     /*  774418 */     GIR_EraseRootFromParent_Done,
     /*  774419 */   // Label 12047: @774419
     /*  774419 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(774497), // Rule ID 14587 //
     /*  774424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  774444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  774473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774495 */     GIR_RootConstrainSelectedInstOperands,
     /*  774496 */     // GIR_Coverage, 14587,
     /*  774496 */     GIR_EraseRootFromParent_Done,
     /*  774497 */   // Label 12048: @774497
     /*  774497 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(774575), // Rule ID 14590 //
     /*  774502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774573 */     GIR_RootConstrainSelectedInstOperands,
     /*  774574 */     // GIR_Coverage, 14590,
     /*  774574 */     GIR_EraseRootFromParent_Done,
     /*  774575 */   // Label 12049: @774575
     /*  774575 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(774653), // Rule ID 14591 //
     /*  774580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  774600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774651 */     GIR_RootConstrainSelectedInstOperands,
     /*  774652 */     // GIR_Coverage, 14591,
     /*  774652 */     GIR_EraseRootFromParent_Done,
     /*  774653 */   // Label 12050: @774653
     /*  774653 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(774731), // Rule ID 14594 //
     /*  774658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  774678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774729 */     GIR_RootConstrainSelectedInstOperands,
     /*  774730 */     // GIR_Coverage, 14594,
     /*  774730 */     GIR_EraseRootFromParent_Done,
     /*  774731 */   // Label 12051: @774731
     /*  774731 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(774809), // Rule ID 14595 //
     /*  774736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  774756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  774785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774807 */     GIR_RootConstrainSelectedInstOperands,
     /*  774808 */     // GIR_Coverage, 14595,
     /*  774808 */     GIR_EraseRootFromParent_Done,
     /*  774809 */   // Label 12052: @774809
     /*  774809 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(774887), // Rule ID 14598 //
     /*  774814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  774834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  774863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774885 */     GIR_RootConstrainSelectedInstOperands,
     /*  774886 */     // GIR_Coverage, 14598,
     /*  774886 */     GIR_EraseRootFromParent_Done,
     /*  774887 */   // Label 12053: @774887
     /*  774887 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(774965), // Rule ID 14599 //
     /*  774892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  774912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774938 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  774941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774963 */     GIR_RootConstrainSelectedInstOperands,
     /*  774964 */     // GIR_Coverage, 14599,
     /*  774964 */     GIR_EraseRootFromParent_Done,
     /*  774965 */   // Label 12054: @774965
     /*  774965 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(775043), // Rule ID 14602 //
     /*  774970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  774990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775041 */     GIR_RootConstrainSelectedInstOperands,
     /*  775042 */     // GIR_Coverage, 14602,
     /*  775042 */     GIR_EraseRootFromParent_Done,
     /*  775043 */   // Label 12055: @775043
     /*  775043 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(775121), // Rule ID 14603 //
     /*  775048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  775059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  775062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  775065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  775068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775119 */     GIR_RootConstrainSelectedInstOperands,
     /*  775120 */     // GIR_Coverage, 14603,
     /*  775120 */     GIR_EraseRootFromParent_Done,
     /*  775121 */   // Label 12056: @775121
     /*  775121 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(775199), // Rule ID 14606 //
     /*  775126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  775146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775197 */     GIR_RootConstrainSelectedInstOperands,
     /*  775198 */     // GIR_Coverage, 14606,
     /*  775198 */     GIR_EraseRootFromParent_Done,
     /*  775199 */   // Label 12057: @775199
     /*  775199 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(775277), // Rule ID 14607 //
     /*  775204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  775215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  775218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  775221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  775224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775275 */     GIR_RootConstrainSelectedInstOperands,
     /*  775276 */     // GIR_Coverage, 14607,
     /*  775276 */     GIR_EraseRootFromParent_Done,
     /*  775277 */   // Label 12058: @775277
     /*  775277 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(775355), // Rule ID 14610 //
     /*  775282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  775285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  775302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  775328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775353 */     GIR_RootConstrainSelectedInstOperands,
     /*  775354 */     // GIR_Coverage, 14610,
     /*  775354 */     GIR_EraseRootFromParent_Done,
     /*  775355 */   // Label 12059: @775355
     /*  775355 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(775433), // Rule ID 14611 //
     /*  775360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  775363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  775371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  775374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  775377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  775380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  775399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  775406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  775409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775431 */     GIR_RootConstrainSelectedInstOperands,
     /*  775432 */     // GIR_Coverage, 14611,
     /*  775432 */     GIR_EraseRootFromParent_Done,
     /*  775433 */   // Label 12060: @775433
     /*  775433 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(775511), // Rule ID 14614 //
     /*  775438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  775458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775509 */     GIR_RootConstrainSelectedInstOperands,
     /*  775510 */     // GIR_Coverage, 14614,
     /*  775510 */     GIR_EraseRootFromParent_Done,
     /*  775511 */   // Label 12061: @775511
     /*  775511 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(775589), // Rule ID 14615 //
     /*  775516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  775536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775587 */     GIR_RootConstrainSelectedInstOperands,
     /*  775588 */     // GIR_Coverage, 14615,
     /*  775588 */     GIR_EraseRootFromParent_Done,
     /*  775589 */   // Label 12062: @775589
     /*  775589 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(775667), // Rule ID 14618 //
     /*  775594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  775614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775640 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  775643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775665 */     GIR_RootConstrainSelectedInstOperands,
     /*  775666 */     // GIR_Coverage, 14618,
     /*  775666 */     GIR_EraseRootFromParent_Done,
     /*  775667 */   // Label 12063: @775667
     /*  775667 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(775745), // Rule ID 14619 //
     /*  775672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  775692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775718 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  775721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775743 */     GIR_RootConstrainSelectedInstOperands,
     /*  775744 */     // GIR_Coverage, 14619,
     /*  775744 */     GIR_EraseRootFromParent_Done,
     /*  775745 */   // Label 12064: @775745
     /*  775745 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(775823), // Rule ID 14622 //
     /*  775750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  775770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  775799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775821 */     GIR_RootConstrainSelectedInstOperands,
     /*  775822 */     // GIR_Coverage, 14622,
     /*  775822 */     GIR_EraseRootFromParent_Done,
     /*  775823 */   // Label 12065: @775823
     /*  775823 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(775901), // Rule ID 14623 //
     /*  775828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  775848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  775877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775899 */     GIR_RootConstrainSelectedInstOperands,
     /*  775900 */     // GIR_Coverage, 14623,
     /*  775900 */     GIR_EraseRootFromParent_Done,
     /*  775901 */   // Label 12066: @775901
     /*  775901 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(775979), // Rule ID 14626 //
     /*  775906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  775926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  775955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775977 */     GIR_RootConstrainSelectedInstOperands,
     /*  775978 */     // GIR_Coverage, 14626,
     /*  775978 */     GIR_EraseRootFromParent_Done,
     /*  775979 */   // Label 12067: @775979
     /*  775979 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(776057), // Rule ID 14627 //
     /*  775984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  776001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  776004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776055 */     GIR_RootConstrainSelectedInstOperands,
     /*  776056 */     // GIR_Coverage, 14627,
     /*  776056 */     GIR_EraseRootFromParent_Done,
     /*  776057 */   // Label 12068: @776057
     /*  776057 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(776135), // Rule ID 14630 //
     /*  776062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  776082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776133 */     GIR_RootConstrainSelectedInstOperands,
     /*  776134 */     // GIR_Coverage, 14630,
     /*  776134 */     GIR_EraseRootFromParent_Done,
     /*  776135 */   // Label 12069: @776135
     /*  776135 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(776213), // Rule ID 14631 //
     /*  776140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  776151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  776154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  776157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  776160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776186 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776211 */     GIR_RootConstrainSelectedInstOperands,
     /*  776212 */     // GIR_Coverage, 14631,
     /*  776212 */     GIR_EraseRootFromParent_Done,
     /*  776213 */   // Label 12070: @776213
     /*  776213 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(776291), // Rule ID 14634 //
     /*  776218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  776238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776264 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776289 */     GIR_RootConstrainSelectedInstOperands,
     /*  776290 */     // GIR_Coverage, 14634,
     /*  776290 */     GIR_EraseRootFromParent_Done,
     /*  776291 */   // Label 12071: @776291
     /*  776291 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(776369), // Rule ID 14635 //
     /*  776296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  776307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  776310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  776313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  776316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776367 */     GIR_RootConstrainSelectedInstOperands,
     /*  776368 */     // GIR_Coverage, 14635,
     /*  776368 */     GIR_EraseRootFromParent_Done,
     /*  776369 */   // Label 12072: @776369
     /*  776369 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(776447), // Rule ID 14638 //
     /*  776374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  776394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776445 */     GIR_RootConstrainSelectedInstOperands,
     /*  776446 */     // GIR_Coverage, 14638,
     /*  776446 */     GIR_EraseRootFromParent_Done,
     /*  776447 */   // Label 12073: @776447
     /*  776447 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(776525), // Rule ID 14639 //
     /*  776452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  776472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776523 */     GIR_RootConstrainSelectedInstOperands,
     /*  776524 */     // GIR_Coverage, 14639,
     /*  776524 */     GIR_EraseRootFromParent_Done,
     /*  776525 */   // Label 12074: @776525
     /*  776525 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(776603), // Rule ID 14642 //
     /*  776530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  776550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776601 */     GIR_RootConstrainSelectedInstOperands,
     /*  776602 */     // GIR_Coverage, 14642,
     /*  776602 */     GIR_EraseRootFromParent_Done,
     /*  776603 */   // Label 12075: @776603
     /*  776603 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(776681), // Rule ID 14643 //
     /*  776608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  776628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  776657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776679 */     GIR_RootConstrainSelectedInstOperands,
     /*  776680 */     // GIR_Coverage, 14643,
     /*  776680 */     GIR_EraseRootFromParent_Done,
     /*  776681 */   // Label 12076: @776681
     /*  776681 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(776759), // Rule ID 14646 //
     /*  776686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  776706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776757 */     GIR_RootConstrainSelectedInstOperands,
     /*  776758 */     // GIR_Coverage, 14646,
     /*  776758 */     GIR_EraseRootFromParent_Done,
     /*  776759 */   // Label 12077: @776759
     /*  776759 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(776837), // Rule ID 14647 //
     /*  776764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  776784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776810 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  776813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776835 */     GIR_RootConstrainSelectedInstOperands,
     /*  776836 */     // GIR_Coverage, 14647,
     /*  776836 */     GIR_EraseRootFromParent_Done,
     /*  776837 */   // Label 12078: @776837
     /*  776837 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(776915), // Rule ID 14650 //
     /*  776842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  776862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776913 */     GIR_RootConstrainSelectedInstOperands,
     /*  776914 */     // GIR_Coverage, 14650,
     /*  776914 */     GIR_EraseRootFromParent_Done,
     /*  776915 */   // Label 12079: @776915
     /*  776915 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(776993), // Rule ID 14651 //
     /*  776920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  776940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  776969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776991 */     GIR_RootConstrainSelectedInstOperands,
     /*  776992 */     // GIR_Coverage, 14651,
     /*  776992 */     GIR_EraseRootFromParent_Done,
     /*  776993 */   // Label 12080: @776993
     /*  776993 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(777071), // Rule ID 14654 //
     /*  776998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  777018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  777047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777069 */     GIR_RootConstrainSelectedInstOperands,
     /*  777070 */     // GIR_Coverage, 14654,
     /*  777070 */     GIR_EraseRootFromParent_Done,
     /*  777071 */   // Label 12081: @777071
     /*  777071 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(777149), // Rule ID 14655 //
     /*  777076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  777087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  777090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  777093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  777096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  777115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  777125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777147 */     GIR_RootConstrainSelectedInstOperands,
     /*  777148 */     // GIR_Coverage, 14655,
     /*  777148 */     GIR_EraseRootFromParent_Done,
     /*  777149 */   // Label 12082: @777149
     /*  777149 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(777227), // Rule ID 14658 //
     /*  777154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  777174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  777203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777225 */     GIR_RootConstrainSelectedInstOperands,
     /*  777226 */     // GIR_Coverage, 14658,
     /*  777226 */     GIR_EraseRootFromParent_Done,
     /*  777227 */   // Label 12083: @777227
     /*  777227 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(777305), // Rule ID 14659 //
     /*  777232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  777243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  777246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  777249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  777252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  777271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  777281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777303 */     GIR_RootConstrainSelectedInstOperands,
     /*  777304 */     // GIR_Coverage, 14659,
     /*  777304 */     GIR_EraseRootFromParent_Done,
     /*  777305 */   // Label 12084: @777305
     /*  777305 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(777383), // Rule ID 14662 //
     /*  777310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  777359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777381 */     GIR_RootConstrainSelectedInstOperands,
     /*  777382 */     // GIR_Coverage, 14662,
     /*  777382 */     GIR_EraseRootFromParent_Done,
     /*  777383 */   // Label 12085: @777383
     /*  777383 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(777461), // Rule ID 14663 //
     /*  777388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  777399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  777402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  777405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777434 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  777437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777459 */     GIR_RootConstrainSelectedInstOperands,
     /*  777460 */     // GIR_Coverage, 14663,
     /*  777460 */     GIR_EraseRootFromParent_Done,
     /*  777461 */   // Label 12086: @777461
     /*  777461 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(777539), // Rule ID 14666 //
     /*  777466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777512 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777537 */     GIR_RootConstrainSelectedInstOperands,
     /*  777538 */     // GIR_Coverage, 14666,
     /*  777538 */     GIR_EraseRootFromParent_Done,
     /*  777539 */   // Label 12087: @777539
     /*  777539 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(777617), // Rule ID 14667 //
     /*  777544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777590 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777615 */     GIR_RootConstrainSelectedInstOperands,
     /*  777616 */     // GIR_Coverage, 14667,
     /*  777616 */     GIR_EraseRootFromParent_Done,
     /*  777617 */   // Label 12088: @777617
     /*  777617 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(777695), // Rule ID 14670 //
     /*  777622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777693 */     GIR_RootConstrainSelectedInstOperands,
     /*  777694 */     // GIR_Coverage, 14670,
     /*  777694 */     GIR_EraseRootFromParent_Done,
     /*  777695 */   // Label 12089: @777695
     /*  777695 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(777773), // Rule ID 14671 //
     /*  777700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777746 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777771 */     GIR_RootConstrainSelectedInstOperands,
     /*  777772 */     // GIR_Coverage, 14671,
     /*  777772 */     GIR_EraseRootFromParent_Done,
     /*  777773 */   // Label 12090: @777773
     /*  777773 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(777851), // Rule ID 14674 //
     /*  777778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777849 */     GIR_RootConstrainSelectedInstOperands,
     /*  777850 */     // GIR_Coverage, 14674,
     /*  777850 */     GIR_EraseRootFromParent_Done,
     /*  777851 */   // Label 12091: @777851
     /*  777851 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(777929), // Rule ID 14675 //
     /*  777856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  777876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  777905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777927 */     GIR_RootConstrainSelectedInstOperands,
     /*  777928 */     // GIR_Coverage, 14675,
     /*  777928 */     GIR_EraseRootFromParent_Done,
     /*  777929 */   // Label 12092: @777929
     /*  777929 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(778007), // Rule ID 14678 //
     /*  777934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  777942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  777954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  777973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  777983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778005 */     GIR_RootConstrainSelectedInstOperands,
     /*  778006 */     // GIR_Coverage, 14678,
     /*  778006 */     GIR_EraseRootFromParent_Done,
     /*  778007 */   // Label 12093: @778007
     /*  778007 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(778085), // Rule ID 14679 //
     /*  778012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  778023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  778026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  778029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778083 */     GIR_RootConstrainSelectedInstOperands,
     /*  778084 */     // GIR_Coverage, 14679,
     /*  778084 */     GIR_EraseRootFromParent_Done,
     /*  778085 */   // Label 12094: @778085
     /*  778085 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(778163), // Rule ID 14682 //
     /*  778090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778161 */     GIR_RootConstrainSelectedInstOperands,
     /*  778162 */     // GIR_Coverage, 14682,
     /*  778162 */     GIR_EraseRootFromParent_Done,
     /*  778163 */   // Label 12095: @778163
     /*  778163 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(778241), // Rule ID 14683 //
     /*  778168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  778179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  778182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  778185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  778217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778239 */     GIR_RootConstrainSelectedInstOperands,
     /*  778240 */     // GIR_Coverage, 14683,
     /*  778240 */     GIR_EraseRootFromParent_Done,
     /*  778241 */   // Label 12096: @778241
     /*  778241 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(778319), // Rule ID 14686 //
     /*  778246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778317 */     GIR_RootConstrainSelectedInstOperands,
     /*  778318 */     // GIR_Coverage, 14686,
     /*  778318 */     GIR_EraseRootFromParent_Done,
     /*  778319 */   // Label 12097: @778319
     /*  778319 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(778397), // Rule ID 14687 //
     /*  778324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  778335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  778338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  778341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778370 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11558:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778395 */     GIR_RootConstrainSelectedInstOperands,
     /*  778396 */     // GIR_Coverage, 14687,
     /*  778396 */     GIR_EraseRootFromParent_Done,
     /*  778397 */   // Label 12098: @778397
     /*  778397 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(778475), // Rule ID 14690 //
     /*  778402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778473 */     GIR_RootConstrainSelectedInstOperands,
     /*  778474 */     // GIR_Coverage, 14690,
     /*  778474 */     GIR_EraseRootFromParent_Done,
     /*  778475 */   // Label 12099: @778475
     /*  778475 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(778553), // Rule ID 14691 //
     /*  778480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11558:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778551 */     GIR_RootConstrainSelectedInstOperands,
     /*  778552 */     // GIR_Coverage, 14691,
     /*  778552 */     GIR_EraseRootFromParent_Done,
     /*  778553 */   // Label 12100: @778553
     /*  778553 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(778631), // Rule ID 14694 //
     /*  778558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778629 */     GIR_RootConstrainSelectedInstOperands,
     /*  778630 */     // GIR_Coverage, 14694,
     /*  778630 */     GIR_EraseRootFromParent_Done,
     /*  778631 */   // Label 12101: @778631
     /*  778631 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(778709), // Rule ID 14695 //
     /*  778636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778707 */     GIR_RootConstrainSelectedInstOperands,
     /*  778708 */     // GIR_Coverage, 14695,
     /*  778708 */     GIR_EraseRootFromParent_Done,
     /*  778709 */   // Label 12102: @778709
     /*  778709 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(778787), // Rule ID 14698 //
     /*  778714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778785 */     GIR_RootConstrainSelectedInstOperands,
     /*  778786 */     // GIR_Coverage, 14698,
     /*  778786 */     GIR_EraseRootFromParent_Done,
     /*  778787 */   // Label 12103: @778787
     /*  778787 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(778865), // Rule ID 14699 //
     /*  778792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  778841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778863 */     GIR_RootConstrainSelectedInstOperands,
     /*  778864 */     // GIR_Coverage, 14699,
     /*  778864 */     GIR_EraseRootFromParent_Done,
     /*  778865 */   // Label 12104: @778865
     /*  778865 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(778943), // Rule ID 14702 //
     /*  778870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  778890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  778919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778941 */     GIR_RootConstrainSelectedInstOperands,
     /*  778942 */     // GIR_Coverage, 14702,
     /*  778942 */     GIR_EraseRootFromParent_Done,
     /*  778943 */   // Label 12105: @778943
     /*  778943 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(779021), // Rule ID 14703 //
     /*  778948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  778956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  778968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  778987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  778997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779019 */     GIR_RootConstrainSelectedInstOperands,
     /*  779020 */     // GIR_Coverage, 14703,
     /*  779020 */     GIR_EraseRootFromParent_Done,
     /*  779021 */   // Label 12106: @779021
     /*  779021 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(779099), // Rule ID 14706 //
     /*  779026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779072 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779097 */     GIR_RootConstrainSelectedInstOperands,
     /*  779098 */     // GIR_Coverage, 14706,
     /*  779098 */     GIR_EraseRootFromParent_Done,
     /*  779099 */   // Label 12107: @779099
     /*  779099 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(779177), // Rule ID 14707 //
     /*  779104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  779115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  779118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  779121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779150 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779175 */     GIR_RootConstrainSelectedInstOperands,
     /*  779176 */     // GIR_Coverage, 14707,
     /*  779176 */     GIR_EraseRootFromParent_Done,
     /*  779177 */   // Label 12108: @779177
     /*  779177 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(779255), // Rule ID 14710 //
     /*  779182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779253 */     GIR_RootConstrainSelectedInstOperands,
     /*  779254 */     // GIR_Coverage, 14710,
     /*  779254 */     GIR_EraseRootFromParent_Done,
     /*  779255 */   // Label 12109: @779255
     /*  779255 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(779333), // Rule ID 14711 //
     /*  779260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  779271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  779274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  779277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779331 */     GIR_RootConstrainSelectedInstOperands,
     /*  779332 */     // GIR_Coverage, 14711,
     /*  779332 */     GIR_EraseRootFromParent_Done,
     /*  779333 */   // Label 12110: @779333
     /*  779333 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(779411), // Rule ID 14714 //
     /*  779338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779409 */     GIR_RootConstrainSelectedInstOperands,
     /*  779410 */     // GIR_Coverage, 14714,
     /*  779410 */     GIR_EraseRootFromParent_Done,
     /*  779411 */   // Label 12111: @779411
     /*  779411 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(779489), // Rule ID 14715 //
     /*  779416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779487 */     GIR_RootConstrainSelectedInstOperands,
     /*  779488 */     // GIR_Coverage, 14715,
     /*  779488 */     GIR_EraseRootFromParent_Done,
     /*  779489 */   // Label 12112: @779489
     /*  779489 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(779567), // Rule ID 14718 //
     /*  779494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779565 */     GIR_RootConstrainSelectedInstOperands,
     /*  779566 */     // GIR_Coverage, 14718,
     /*  779566 */     GIR_EraseRootFromParent_Done,
     /*  779567 */   // Label 12113: @779567
     /*  779567 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(779645), // Rule ID 14719 //
     /*  779572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779618 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  779621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779643 */     GIR_RootConstrainSelectedInstOperands,
     /*  779644 */     // GIR_Coverage, 14719,
     /*  779644 */     GIR_EraseRootFromParent_Done,
     /*  779645 */   // Label 12114: @779645
     /*  779645 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(779723), // Rule ID 14722 //
     /*  779650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779721 */     GIR_RootConstrainSelectedInstOperands,
     /*  779722 */     // GIR_Coverage, 14722,
     /*  779722 */     GIR_EraseRootFromParent_Done,
     /*  779723 */   // Label 12115: @779723
     /*  779723 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(779801), // Rule ID 14723 //
     /*  779728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  779777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779799 */     GIR_RootConstrainSelectedInstOperands,
     /*  779800 */     // GIR_Coverage, 14723,
     /*  779800 */     GIR_EraseRootFromParent_Done,
     /*  779801 */   // Label 12116: @779801
     /*  779801 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(779879), // Rule ID 14726 //
     /*  779806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779877 */     GIR_RootConstrainSelectedInstOperands,
     /*  779878 */     // GIR_Coverage, 14726,
     /*  779878 */     GIR_EraseRootFromParent_Done,
     /*  779879 */   // Label 12117: @779879
     /*  779879 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(779957), // Rule ID 14727 //
     /*  779884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  779933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779955 */     GIR_RootConstrainSelectedInstOperands,
     /*  779956 */     // GIR_Coverage, 14727,
     /*  779956 */     GIR_EraseRootFromParent_Done,
     /*  779957 */   // Label 12118: @779957
     /*  779957 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(780035), // Rule ID 14730 //
     /*  779962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  779970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780033 */     GIR_RootConstrainSelectedInstOperands,
     /*  780034 */     // GIR_Coverage, 14730,
     /*  780034 */     GIR_EraseRootFromParent_Done,
     /*  780035 */   // Label 12119: @780035
     /*  780035 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(780113), // Rule ID 14731 //
     /*  780040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  780051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  780054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  780057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780111 */     GIR_RootConstrainSelectedInstOperands,
     /*  780112 */     // GIR_Coverage, 14731,
     /*  780112 */     GIR_EraseRootFromParent_Done,
     /*  780113 */   // Label 12120: @780113
     /*  780113 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(780191), // Rule ID 14734 //
     /*  780118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780189 */     GIR_RootConstrainSelectedInstOperands,
     /*  780190 */     // GIR_Coverage, 14734,
     /*  780190 */     GIR_EraseRootFromParent_Done,
     /*  780191 */   // Label 12121: @780191
     /*  780191 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(780269), // Rule ID 14735 //
     /*  780196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  780207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  780210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  780213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780267 */     GIR_RootConstrainSelectedInstOperands,
     /*  780268 */     // GIR_Coverage, 14735,
     /*  780268 */     GIR_EraseRootFromParent_Done,
     /*  780269 */   // Label 12122: @780269
     /*  780269 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(780347), // Rule ID 14738 //
     /*  780274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  780323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780345 */     GIR_RootConstrainSelectedInstOperands,
     /*  780346 */     // GIR_Coverage, 14738,
     /*  780346 */     GIR_EraseRootFromParent_Done,
     /*  780347 */   // Label 12123: @780347
     /*  780347 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(780425), // Rule ID 14739 //
     /*  780352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  780363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  780366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  780369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  780387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  780401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780423 */     GIR_RootConstrainSelectedInstOperands,
     /*  780424 */     // GIR_Coverage, 14739,
     /*  780424 */     GIR_EraseRootFromParent_Done,
     /*  780425 */   // Label 12124: @780425
     /*  780425 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(780503), // Rule ID 14742 //
     /*  780430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780501 */     GIR_RootConstrainSelectedInstOperands,
     /*  780502 */     // GIR_Coverage, 14742,
     /*  780502 */     GIR_EraseRootFromParent_Done,
     /*  780503 */   // Label 12125: @780503
     /*  780503 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(780581), // Rule ID 14743 //
     /*  780508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  780557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780579 */     GIR_RootConstrainSelectedInstOperands,
     /*  780580 */     // GIR_Coverage, 14743,
     /*  780580 */     GIR_EraseRootFromParent_Done,
     /*  780581 */   // Label 12126: @780581
     /*  780581 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(780659), // Rule ID 14746 //
     /*  780586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780657 */     GIR_RootConstrainSelectedInstOperands,
     /*  780658 */     // GIR_Coverage, 14746,
     /*  780658 */     GIR_EraseRootFromParent_Done,
     /*  780659 */   // Label 12127: @780659
     /*  780659 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(780737), // Rule ID 14747 //
     /*  780664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  780672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  780713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780735 */     GIR_RootConstrainSelectedInstOperands,
     /*  780736 */     // GIR_Coverage, 14747,
     /*  780736 */     GIR_EraseRootFromParent_Done,
     /*  780737 */   // Label 12128: @780737
     /*  780737 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(780815), // Rule ID 14750 //
     /*  780742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  780762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  780791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780813 */     GIR_RootConstrainSelectedInstOperands,
     /*  780814 */     // GIR_Coverage, 14750,
     /*  780814 */     GIR_EraseRootFromParent_Done,
     /*  780815 */   // Label 12129: @780815
     /*  780815 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(780893), // Rule ID 14751 //
     /*  780820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  780840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  780869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780891 */     GIR_RootConstrainSelectedInstOperands,
     /*  780892 */     // GIR_Coverage, 14751,
     /*  780892 */     GIR_EraseRootFromParent_Done,
     /*  780893 */   // Label 12130: @780893
     /*  780893 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(780971), // Rule ID 14754 //
     /*  780898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  780918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780944 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  780947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780969 */     GIR_RootConstrainSelectedInstOperands,
     /*  780970 */     // GIR_Coverage, 14754,
     /*  780970 */     GIR_EraseRootFromParent_Done,
     /*  780971 */   // Label 12131: @780971
     /*  780971 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(781049), // Rule ID 14755 //
     /*  780976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  780996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781022 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781047 */     GIR_RootConstrainSelectedInstOperands,
     /*  781048 */     // GIR_Coverage, 14755,
     /*  781048 */     GIR_EraseRootFromParent_Done,
     /*  781049 */   // Label 12132: @781049
     /*  781049 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(781127), // Rule ID 14758 //
     /*  781054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  781074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781125 */     GIR_RootConstrainSelectedInstOperands,
     /*  781126 */     // GIR_Coverage, 14758,
     /*  781126 */     GIR_EraseRootFromParent_Done,
     /*  781127 */   // Label 12133: @781127
     /*  781127 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(781205), // Rule ID 14759 //
     /*  781132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  781143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  781146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  781149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  781152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781178 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781203 */     GIR_RootConstrainSelectedInstOperands,
     /*  781204 */     // GIR_Coverage, 14759,
     /*  781204 */     GIR_EraseRootFromParent_Done,
     /*  781205 */   // Label 12134: @781205
     /*  781205 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(781283), // Rule ID 14762 //
     /*  781210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  781230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781281 */     GIR_RootConstrainSelectedInstOperands,
     /*  781282 */     // GIR_Coverage, 14762,
     /*  781282 */     GIR_EraseRootFromParent_Done,
     /*  781283 */   // Label 12135: @781283
     /*  781283 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(781361), // Rule ID 14763 //
     /*  781288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  781299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  781302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  781305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  781308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  781337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781359 */     GIR_RootConstrainSelectedInstOperands,
     /*  781360 */     // GIR_Coverage, 14763,
     /*  781360 */     GIR_EraseRootFromParent_Done,
     /*  781361 */   // Label 12136: @781361
     /*  781361 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(781439), // Rule ID 14766 //
     /*  781366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  781386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781437 */     GIR_RootConstrainSelectedInstOperands,
     /*  781438 */     // GIR_Coverage, 14766,
     /*  781438 */     GIR_EraseRootFromParent_Done,
     /*  781439 */   // Label 12137: @781439
     /*  781439 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(781517), // Rule ID 14767 //
     /*  781444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  781464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781515 */     GIR_RootConstrainSelectedInstOperands,
     /*  781516 */     // GIR_Coverage, 14767,
     /*  781516 */     GIR_EraseRootFromParent_Done,
     /*  781517 */   // Label 12138: @781517
     /*  781517 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(781595), // Rule ID 14770 //
     /*  781522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  781542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781593 */     GIR_RootConstrainSelectedInstOperands,
     /*  781594 */     // GIR_Coverage, 14770,
     /*  781594 */     GIR_EraseRootFromParent_Done,
     /*  781595 */   // Label 12139: @781595
     /*  781595 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(781673), // Rule ID 14771 //
     /*  781600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  781620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  781649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781671 */     GIR_RootConstrainSelectedInstOperands,
     /*  781672 */     // GIR_Coverage, 14771,
     /*  781672 */     GIR_EraseRootFromParent_Done,
     /*  781673 */   // Label 12140: @781673
     /*  781673 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(781751), // Rule ID 14774 //
     /*  781678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  781698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781749 */     GIR_RootConstrainSelectedInstOperands,
     /*  781750 */     // GIR_Coverage, 14774,
     /*  781750 */     GIR_EraseRootFromParent_Done,
     /*  781751 */   // Label 12141: @781751
     /*  781751 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(781829), // Rule ID 14775 //
     /*  781756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  781776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781827 */     GIR_RootConstrainSelectedInstOperands,
     /*  781828 */     // GIR_Coverage, 14775,
     /*  781828 */     GIR_EraseRootFromParent_Done,
     /*  781829 */   // Label 12142: @781829
     /*  781829 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(781907), // Rule ID 14778 //
     /*  781834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  781854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781905 */     GIR_RootConstrainSelectedInstOperands,
     /*  781906 */     // GIR_Coverage, 14778,
     /*  781906 */     GIR_EraseRootFromParent_Done,
     /*  781907 */   // Label 12143: @781907
     /*  781907 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(781985), // Rule ID 14779 //
     /*  781912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  781932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  781961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781983 */     GIR_RootConstrainSelectedInstOperands,
     /*  781984 */     // GIR_Coverage, 14779,
     /*  781984 */     GIR_EraseRootFromParent_Done,
     /*  781985 */   // Label 12144: @781985
     /*  781985 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(782063), // Rule ID 14782 //
     /*  781990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  782010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782061 */     GIR_RootConstrainSelectedInstOperands,
     /*  782062 */     // GIR_Coverage, 14782,
     /*  782062 */     GIR_EraseRootFromParent_Done,
     /*  782063 */   // Label 12145: @782063
     /*  782063 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(782141), // Rule ID 14783 //
     /*  782068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  782079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  782082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  782085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  782088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782139 */     GIR_RootConstrainSelectedInstOperands,
     /*  782140 */     // GIR_Coverage, 14783,
     /*  782140 */     GIR_EraseRootFromParent_Done,
     /*  782141 */   // Label 12146: @782141
     /*  782141 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(782219), // Rule ID 14786 //
     /*  782146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  782166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782217 */     GIR_RootConstrainSelectedInstOperands,
     /*  782218 */     // GIR_Coverage, 14786,
     /*  782218 */     GIR_EraseRootFromParent_Done,
     /*  782219 */   // Label 12147: @782219
     /*  782219 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(782297), // Rule ID 14787 //
     /*  782224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  782227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  782235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  782238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  782241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  782244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  782263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  782270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  782273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782295 */     GIR_RootConstrainSelectedInstOperands,
     /*  782296 */     // GIR_Coverage, 14787,
     /*  782296 */     GIR_EraseRootFromParent_Done,
     /*  782297 */   // Label 12148: @782297
     /*  782297 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(782375), // Rule ID 14790 //
     /*  782302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  782322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782373 */     GIR_RootConstrainSelectedInstOperands,
     /*  782374 */     // GIR_Coverage, 14790,
     /*  782374 */     GIR_EraseRootFromParent_Done,
     /*  782375 */   // Label 12149: @782375
     /*  782375 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(782453), // Rule ID 14791 //
     /*  782380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  782391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  782394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  782397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  782400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782451 */     GIR_RootConstrainSelectedInstOperands,
     /*  782452 */     // GIR_Coverage, 14791,
     /*  782452 */     GIR_EraseRootFromParent_Done,
     /*  782453 */   // Label 12150: @782453
     /*  782453 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(782531), // Rule ID 14794 //
     /*  782458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  782478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782504 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782529 */     GIR_RootConstrainSelectedInstOperands,
     /*  782530 */     // GIR_Coverage, 14794,
     /*  782530 */     GIR_EraseRootFromParent_Done,
     /*  782531 */   // Label 12151: @782531
     /*  782531 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(782609), // Rule ID 14795 //
     /*  782536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  782556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782607 */     GIR_RootConstrainSelectedInstOperands,
     /*  782608 */     // GIR_Coverage, 14795,
     /*  782608 */     GIR_EraseRootFromParent_Done,
     /*  782609 */   // Label 12152: @782609
     /*  782609 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(782687), // Rule ID 14798 //
     /*  782614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  782634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  782663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782685 */     GIR_RootConstrainSelectedInstOperands,
     /*  782686 */     // GIR_Coverage, 14798,
     /*  782686 */     GIR_EraseRootFromParent_Done,
     /*  782687 */   // Label 12153: @782687
     /*  782687 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(782765), // Rule ID 14799 //
     /*  782692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  782712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  782741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782763 */     GIR_RootConstrainSelectedInstOperands,
     /*  782764 */     // GIR_Coverage, 14799,
     /*  782764 */     GIR_EraseRootFromParent_Done,
     /*  782765 */   // Label 12154: @782765
     /*  782765 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(782843), // Rule ID 14802 //
     /*  782770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  782790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782841 */     GIR_RootConstrainSelectedInstOperands,
     /*  782842 */     // GIR_Coverage, 14802,
     /*  782842 */     GIR_EraseRootFromParent_Done,
     /*  782843 */   // Label 12155: @782843
     /*  782843 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(782921), // Rule ID 14803 //
     /*  782848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  782868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  782897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782919 */     GIR_RootConstrainSelectedInstOperands,
     /*  782920 */     // GIR_Coverage, 14803,
     /*  782920 */     GIR_EraseRootFromParent_Done,
     /*  782921 */   // Label 12156: @782921
     /*  782921 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(782999), // Rule ID 14806 //
     /*  782926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  782946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  782975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782997 */     GIR_RootConstrainSelectedInstOperands,
     /*  782998 */     // GIR_Coverage, 14806,
     /*  782998 */     GIR_EraseRootFromParent_Done,
     /*  782999 */   // Label 12157: @782999
     /*  782999 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(783077), // Rule ID 14807 //
     /*  783004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  783015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  783018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  783021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  783024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783075 */     GIR_RootConstrainSelectedInstOperands,
     /*  783076 */     // GIR_Coverage, 14807,
     /*  783076 */     GIR_EraseRootFromParent_Done,
     /*  783077 */   // Label 12158: @783077
     /*  783077 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(783155), // Rule ID 14810 //
     /*  783082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  783102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783153 */     GIR_RootConstrainSelectedInstOperands,
     /*  783154 */     // GIR_Coverage, 14810,
     /*  783154 */     GIR_EraseRootFromParent_Done,
     /*  783155 */   // Label 12159: @783155
     /*  783155 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(783233), // Rule ID 14811 //
     /*  783160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  783171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  783174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  783177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  783180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783231 */     GIR_RootConstrainSelectedInstOperands,
     /*  783232 */     // GIR_Coverage, 14811,
     /*  783232 */     GIR_EraseRootFromParent_Done,
     /*  783233 */   // Label 12160: @783233
     /*  783233 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(783311), // Rule ID 14814 //
     /*  783238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  783258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783309 */     GIR_RootConstrainSelectedInstOperands,
     /*  783310 */     // GIR_Coverage, 14814,
     /*  783310 */     GIR_EraseRootFromParent_Done,
     /*  783311 */   // Label 12161: @783311
     /*  783311 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(783389), // Rule ID 14815 //
     /*  783316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  783327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  783330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  783333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  783336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783387 */     GIR_RootConstrainSelectedInstOperands,
     /*  783388 */     // GIR_Coverage, 14815,
     /*  783388 */     GIR_EraseRootFromParent_Done,
     /*  783389 */   // Label 12162: @783389
     /*  783389 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(783467), // Rule ID 14818 //
     /*  783394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  783414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783465 */     GIR_RootConstrainSelectedInstOperands,
     /*  783466 */     // GIR_Coverage, 14818,
     /*  783466 */     GIR_EraseRootFromParent_Done,
     /*  783467 */   // Label 12163: @783467
     /*  783467 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(783545), // Rule ID 14819 //
     /*  783472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  783492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783543 */     GIR_RootConstrainSelectedInstOperands,
     /*  783544 */     // GIR_Coverage, 14819,
     /*  783544 */     GIR_EraseRootFromParent_Done,
     /*  783545 */   // Label 12164: @783545
     /*  783545 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(783623), // Rule ID 14822 //
     /*  783550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  783570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783621 */     GIR_RootConstrainSelectedInstOperands,
     /*  783622 */     // GIR_Coverage, 14822,
     /*  783622 */     GIR_EraseRootFromParent_Done,
     /*  783623 */   // Label 12165: @783623
     /*  783623 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(783701), // Rule ID 14823 //
     /*  783628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  783648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  783677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783699 */     GIR_RootConstrainSelectedInstOperands,
     /*  783700 */     // GIR_Coverage, 14823,
     /*  783700 */     GIR_EraseRootFromParent_Done,
     /*  783701 */   // Label 12166: @783701
     /*  783701 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(783779), // Rule ID 14826 //
     /*  783706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  783726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783777 */     GIR_RootConstrainSelectedInstOperands,
     /*  783778 */     // GIR_Coverage, 14826,
     /*  783778 */     GIR_EraseRootFromParent_Done,
     /*  783779 */   // Label 12167: @783779
     /*  783779 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(783857), // Rule ID 14827 //
     /*  783784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  783804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  783833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783855 */     GIR_RootConstrainSelectedInstOperands,
     /*  783856 */     // GIR_Coverage, 14827,
     /*  783856 */     GIR_EraseRootFromParent_Done,
     /*  783857 */   // Label 12168: @783857
     /*  783857 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(783935), // Rule ID 14830 //
     /*  783862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  783882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783933 */     GIR_RootConstrainSelectedInstOperands,
     /*  783934 */     // GIR_Coverage, 14830,
     /*  783934 */     GIR_EraseRootFromParent_Done,
     /*  783935 */   // Label 12169: @783935
     /*  783935 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(784013), // Rule ID 14831 //
     /*  783940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  783960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  783989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784011 */     GIR_RootConstrainSelectedInstOperands,
     /*  784012 */     // GIR_Coverage, 14831,
     /*  784012 */     GIR_EraseRootFromParent_Done,
     /*  784013 */   // Label 12170: @784013
     /*  784013 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(784091), // Rule ID 14834 //
     /*  784018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  784021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  784038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784064 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  784067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784089 */     GIR_RootConstrainSelectedInstOperands,
     /*  784090 */     // GIR_Coverage, 14834,
     /*  784090 */     GIR_EraseRootFromParent_Done,
     /*  784091 */   // Label 12171: @784091
     /*  784091 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(784169), // Rule ID 14835 //
     /*  784096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  784099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  784107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  784110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  784113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  784116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  784145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784167 */     GIR_RootConstrainSelectedInstOperands,
     /*  784168 */     // GIR_Coverage, 14835,
     /*  784168 */     GIR_EraseRootFromParent_Done,
     /*  784169 */   // Label 12172: @784169
     /*  784169 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(784247), // Rule ID 14838 //
     /*  784174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  784185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  784188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  784191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  784223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784245 */     GIR_RootConstrainSelectedInstOperands,
     /*  784246 */     // GIR_Coverage, 14838,
     /*  784246 */     GIR_EraseRootFromParent_Done,
     /*  784247 */   // Label 12173: @784247
     /*  784247 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(784325), // Rule ID 14839 //
     /*  784252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  784263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  784266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  784269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784298 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  784301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784323 */     GIR_RootConstrainSelectedInstOperands,
     /*  784324 */     // GIR_Coverage, 14839,
     /*  784324 */     GIR_EraseRootFromParent_Done,
     /*  784325 */   // Label 12174: @784325
     /*  784325 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(784403), // Rule ID 14842 //
     /*  784330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  784341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  784344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784401 */     GIR_RootConstrainSelectedInstOperands,
     /*  784402 */     // GIR_Coverage, 14842,
     /*  784402 */     GIR_EraseRootFromParent_Done,
     /*  784403 */   // Label 12175: @784403
     /*  784403 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(784481), // Rule ID 14843 //
     /*  784408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  784419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  784422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  784425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784479 */     GIR_RootConstrainSelectedInstOperands,
     /*  784480 */     // GIR_Coverage, 14843,
     /*  784480 */     GIR_EraseRootFromParent_Done,
     /*  784481 */   // Label 12176: @784481
     /*  784481 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(784559), // Rule ID 14846 //
     /*  784486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  784497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  784500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  784532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784557 */     GIR_RootConstrainSelectedInstOperands,
     /*  784558 */     // GIR_Coverage, 14846,
     /*  784558 */     GIR_EraseRootFromParent_Done,
     /*  784559 */   // Label 12177: @784559
     /*  784559 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(784637), // Rule ID 14847 //
     /*  784564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  784575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  784578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  784581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  784610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  784629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784635 */     GIR_RootConstrainSelectedInstOperands,
     /*  784636 */     // GIR_Coverage, 14847,
     /*  784636 */     GIR_EraseRootFromParent_Done,
     /*  784637 */   // Label 12178: @784637
     /*  784637 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(784715), // Rule ID 14850 //
     /*  784642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784688 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784713 */     GIR_RootConstrainSelectedInstOperands,
     /*  784714 */     // GIR_Coverage, 14850,
     /*  784714 */     GIR_EraseRootFromParent_Done,
     /*  784715 */   // Label 12179: @784715
     /*  784715 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(784793), // Rule ID 14851 //
     /*  784720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  784731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  784734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  784737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  784769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784791 */     GIR_RootConstrainSelectedInstOperands,
     /*  784792 */     // GIR_Coverage, 14851,
     /*  784792 */     GIR_EraseRootFromParent_Done,
     /*  784793 */   // Label 12180: @784793
     /*  784793 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(784871), // Rule ID 14854 //
     /*  784798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784869 */     GIR_RootConstrainSelectedInstOperands,
     /*  784870 */     // GIR_Coverage, 14854,
     /*  784870 */     GIR_EraseRootFromParent_Done,
     /*  784871 */   // Label 12181: @784871
     /*  784871 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(784949), // Rule ID 14855 //
     /*  784876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  784879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  784887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  784896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  784925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  784947 */     GIR_RootConstrainSelectedInstOperands,
     /*  784948 */     // GIR_Coverage, 14855,
     /*  784948 */     GIR_EraseRootFromParent_Done,
     /*  784949 */   // Label 12182: @784949
     /*  784949 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(785027), // Rule ID 14858 //
     /*  784954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  784957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  784962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  784974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  784993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  785003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785025 */     GIR_RootConstrainSelectedInstOperands,
     /*  785026 */     // GIR_Coverage, 14858,
     /*  785026 */     GIR_EraseRootFromParent_Done,
     /*  785027 */   // Label 12183: @785027
     /*  785027 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(785105), // Rule ID 14859 //
     /*  785032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  785043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  785046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  785081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785103 */     GIR_RootConstrainSelectedInstOperands,
     /*  785104 */     // GIR_Coverage, 14859,
     /*  785104 */     GIR_EraseRootFromParent_Done,
     /*  785105 */   // Label 12184: @785105
     /*  785105 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(785183), // Rule ID 14862 //
     /*  785110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  785121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  785124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  785127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785181 */     GIR_RootConstrainSelectedInstOperands,
     /*  785182 */     // GIR_Coverage, 14862,
     /*  785182 */     GIR_EraseRootFromParent_Done,
     /*  785183 */   // Label 12185: @785183
     /*  785183 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(785261), // Rule ID 14863 //
     /*  785188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  785199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  785202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  785205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11556:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  785234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785259 */     GIR_RootConstrainSelectedInstOperands,
     /*  785260 */     // GIR_Coverage, 14863,
     /*  785260 */     GIR_EraseRootFromParent_Done,
     /*  785261 */   // Label 12186: @785261
     /*  785261 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(785339), // Rule ID 14866 //
     /*  785266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  785277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  785280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785337 */     GIR_RootConstrainSelectedInstOperands,
     /*  785338 */     // GIR_Coverage, 14866,
     /*  785338 */     GIR_EraseRootFromParent_Done,
     /*  785339 */   // Label 12187: @785339
     /*  785339 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(785417), // Rule ID 14867 //
     /*  785344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  785355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  785358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11556:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785415 */     GIR_RootConstrainSelectedInstOperands,
     /*  785416 */     // GIR_Coverage, 14867,
     /*  785416 */     GIR_EraseRootFromParent_Done,
     /*  785417 */   // Label 12188: @785417
     /*  785417 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(785495), // Rule ID 14870 //
     /*  785422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785493 */     GIR_RootConstrainSelectedInstOperands,
     /*  785494 */     // GIR_Coverage, 14870,
     /*  785494 */     GIR_EraseRootFromParent_Done,
     /*  785495 */   // Label 12189: @785495
     /*  785495 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(785573), // Rule ID 14871 //
     /*  785500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  785511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  785514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  785517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785571 */     GIR_RootConstrainSelectedInstOperands,
     /*  785572 */     // GIR_Coverage, 14871,
     /*  785572 */     GIR_EraseRootFromParent_Done,
     /*  785573 */   // Label 12190: @785573
     /*  785573 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(785651), // Rule ID 14874 //
     /*  785578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  785581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785649 */     GIR_RootConstrainSelectedInstOperands,
     /*  785650 */     // GIR_Coverage, 14874,
     /*  785650 */     GIR_EraseRootFromParent_Done,
     /*  785651 */   // Label 12191: @785651
     /*  785651 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(785729), // Rule ID 14875 //
     /*  785656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  785659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  785667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  785670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  785673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  785705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785727 */     GIR_RootConstrainSelectedInstOperands,
     /*  785728 */     // GIR_Coverage, 14875,
     /*  785728 */     GIR_EraseRootFromParent_Done,
     /*  785729 */   // Label 12192: @785729
     /*  785729 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(785807), // Rule ID 14878 //
     /*  785734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  785745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  785748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  785751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  785783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785805 */     GIR_RootConstrainSelectedInstOperands,
     /*  785806 */     // GIR_Coverage, 14878,
     /*  785806 */     GIR_EraseRootFromParent_Done,
     /*  785807 */   // Label 12193: @785807
     /*  785807 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(785885), // Rule ID 14879 //
     /*  785812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  785823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  785826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  785829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  785858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  785861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785883 */     GIR_RootConstrainSelectedInstOperands,
     /*  785884 */     // GIR_Coverage, 14879,
     /*  785884 */     GIR_EraseRootFromParent_Done,
     /*  785885 */   // Label 12194: @785885
     /*  785885 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(785963), // Rule ID 14882 //
     /*  785890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  785893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  785901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  785904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  785907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  785910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  785929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  785936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  785939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  785955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  785961 */     GIR_RootConstrainSelectedInstOperands,
     /*  785962 */     // GIR_Coverage, 14882,
     /*  785962 */     GIR_EraseRootFromParent_Done,
     /*  785963 */   // Label 12195: @785963
     /*  785963 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(786041), // Rule ID 14883 //
     /*  785968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  785971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  785976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  785979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  785982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  785985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786039 */     GIR_RootConstrainSelectedInstOperands,
     /*  786040 */     // GIR_Coverage, 14883,
     /*  786040 */     GIR_EraseRootFromParent_Done,
     /*  786041 */   // Label 12196: @786041
     /*  786041 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(786119), // Rule ID 14886 //
     /*  786046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  786057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  786060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  786063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  786092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786117 */     GIR_RootConstrainSelectedInstOperands,
     /*  786118 */     // GIR_Coverage, 14886,
     /*  786118 */     GIR_EraseRootFromParent_Done,
     /*  786119 */   // Label 12197: @786119
     /*  786119 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(786197), // Rule ID 14887 //
     /*  786124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  786135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  786138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  786141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  786170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  786189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786195 */     GIR_RootConstrainSelectedInstOperands,
     /*  786196 */     // GIR_Coverage, 14887,
     /*  786196 */     GIR_EraseRootFromParent_Done,
     /*  786197 */   // Label 12198: @786197
     /*  786197 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(786275), // Rule ID 14890 //
     /*  786202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786273 */     GIR_RootConstrainSelectedInstOperands,
     /*  786274 */     // GIR_Coverage, 14890,
     /*  786274 */     GIR_EraseRootFromParent_Done,
     /*  786275 */   // Label 12199: @786275
     /*  786275 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(786353), // Rule ID 14891 //
     /*  786280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786351 */     GIR_RootConstrainSelectedInstOperands,
     /*  786352 */     // GIR_Coverage, 14891,
     /*  786352 */     GIR_EraseRootFromParent_Done,
     /*  786353 */   // Label 12200: @786353
     /*  786353 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(786431), // Rule ID 14894 //
     /*  786358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786429 */     GIR_RootConstrainSelectedInstOperands,
     /*  786430 */     // GIR_Coverage, 14894,
     /*  786430 */     GIR_EraseRootFromParent_Done,
     /*  786431 */   // Label 12201: @786431
     /*  786431 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(786509), // Rule ID 14895 //
     /*  786436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786507 */     GIR_RootConstrainSelectedInstOperands,
     /*  786508 */     // GIR_Coverage, 14895,
     /*  786508 */     GIR_EraseRootFromParent_Done,
     /*  786509 */   // Label 12202: @786509
     /*  786509 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(786587), // Rule ID 14898 //
     /*  786514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786585 */     GIR_RootConstrainSelectedInstOperands,
     /*  786586 */     // GIR_Coverage, 14898,
     /*  786586 */     GIR_EraseRootFromParent_Done,
     /*  786587 */   // Label 12203: @786587
     /*  786587 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(786665), // Rule ID 14899 //
     /*  786592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  786641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786663 */     GIR_RootConstrainSelectedInstOperands,
     /*  786664 */     // GIR_Coverage, 14899,
     /*  786664 */     GIR_EraseRootFromParent_Done,
     /*  786665 */   // Label 12204: @786665
     /*  786665 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(786743), // Rule ID 14902 //
     /*  786670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786741 */     GIR_RootConstrainSelectedInstOperands,
     /*  786742 */     // GIR_Coverage, 14902,
     /*  786742 */     GIR_EraseRootFromParent_Done,
     /*  786743 */   // Label 12205: @786743
     /*  786743 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(786821), // Rule ID 14903 //
     /*  786748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  786797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786819 */     GIR_RootConstrainSelectedInstOperands,
     /*  786820 */     // GIR_Coverage, 14903,
     /*  786820 */     GIR_EraseRootFromParent_Done,
     /*  786821 */   // Label 12206: @786821
     /*  786821 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(786899), // Rule ID 14906 //
     /*  786826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  786837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  786840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786897 */     GIR_RootConstrainSelectedInstOperands,
     /*  786898 */     // GIR_Coverage, 14906,
     /*  786898 */     GIR_EraseRootFromParent_Done,
     /*  786899 */   // Label 12207: @786899
     /*  786899 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(786977), // Rule ID 14907 //
     /*  786904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  786907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  786915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  786918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  786921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  786943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  786953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  786975 */     GIR_RootConstrainSelectedInstOperands,
     /*  786976 */     // GIR_Coverage, 14907,
     /*  786976 */     GIR_EraseRootFromParent_Done,
     /*  786977 */   // Label 12208: @786977
     /*  786977 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(787055), // Rule ID 14910 //
     /*  786982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  786985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  786990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  786993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  786996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  786999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787053 */     GIR_RootConstrainSelectedInstOperands,
     /*  787054 */     // GIR_Coverage, 14910,
     /*  787054 */     GIR_EraseRootFromParent_Done,
     /*  787055 */   // Label 12209: @787055
     /*  787055 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(787133), // Rule ID 14911 //
     /*  787060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  787063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787131 */     GIR_RootConstrainSelectedInstOperands,
     /*  787132 */     // GIR_Coverage, 14911,
     /*  787132 */     GIR_EraseRootFromParent_Done,
     /*  787133 */   // Label 12210: @787133
     /*  787133 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(787211), // Rule ID 14914 //
     /*  787138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  787187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787209 */     GIR_RootConstrainSelectedInstOperands,
     /*  787210 */     // GIR_Coverage, 14914,
     /*  787210 */     GIR_EraseRootFromParent_Done,
     /*  787211 */   // Label 12211: @787211
     /*  787211 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(787289), // Rule ID 14915 //
     /*  787216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  787265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787287 */     GIR_RootConstrainSelectedInstOperands,
     /*  787288 */     // GIR_Coverage, 14915,
     /*  787288 */     GIR_EraseRootFromParent_Done,
     /*  787289 */   // Label 12212: @787289
     /*  787289 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(787367), // Rule ID 14918 //
     /*  787294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  787343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787365 */     GIR_RootConstrainSelectedInstOperands,
     /*  787366 */     // GIR_Coverage, 14918,
     /*  787366 */     GIR_EraseRootFromParent_Done,
     /*  787367 */   // Label 12213: @787367
     /*  787367 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(787445), // Rule ID 14919 //
     /*  787372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  787421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787443 */     GIR_RootConstrainSelectedInstOperands,
     /*  787444 */     // GIR_Coverage, 14919,
     /*  787444 */     GIR_EraseRootFromParent_Done,
     /*  787445 */   // Label 12214: @787445
     /*  787445 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(787523), // Rule ID 14922 //
     /*  787450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  787453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787521 */     GIR_RootConstrainSelectedInstOperands,
     /*  787522 */     // GIR_Coverage, 14922,
     /*  787522 */     GIR_EraseRootFromParent_Done,
     /*  787523 */   // Label 12215: @787523
     /*  787523 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(787601), // Rule ID 14923 //
     /*  787528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  787531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  787536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  787567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  787577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  787599 */     GIR_RootConstrainSelectedInstOperands,
     /*  787600 */     // GIR_Coverage, 14923,
     /*  787600 */     GIR_EraseRootFromParent_Done,
     /*  787601 */   // Label 12216: @787601
     /*  787601 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(787676), // Rule ID 19164 //
     /*  787606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  787655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787674 */     GIR_RootConstrainSelectedInstOperands,
     /*  787675 */     // GIR_Coverage, 19164,
     /*  787675 */     GIR_EraseRootFromParent_Done,
     /*  787676 */   // Label 12217: @787676
     /*  787676 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(787751), // Rule ID 19165 //
     /*  787681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  787730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787749 */     GIR_RootConstrainSelectedInstOperands,
     /*  787750 */     // GIR_Coverage, 19165,
     /*  787750 */     GIR_EraseRootFromParent_Done,
     /*  787751 */   // Label 12218: @787751
     /*  787751 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(787826), // Rule ID 19168 //
     /*  787756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  787805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787824 */     GIR_RootConstrainSelectedInstOperands,
     /*  787825 */     // GIR_Coverage, 19168,
     /*  787825 */     GIR_EraseRootFromParent_Done,
     /*  787826 */   // Label 12219: @787826
     /*  787826 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(787901), // Rule ID 19169 //
     /*  787831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  787880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787899 */     GIR_RootConstrainSelectedInstOperands,
     /*  787900 */     // GIR_Coverage, 19169,
     /*  787900 */     GIR_EraseRootFromParent_Done,
     /*  787901 */   // Label 12220: @787901
     /*  787901 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(787976), // Rule ID 19172 //
     /*  787906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  787926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  787955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787974 */     GIR_RootConstrainSelectedInstOperands,
     /*  787975 */     // GIR_Coverage, 19172,
     /*  787975 */     GIR_EraseRootFromParent_Done,
     /*  787976 */   // Label 12221: @787976
     /*  787976 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(788051), // Rule ID 19173 //
     /*  787981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  787992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  787995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  787998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  788030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788049 */     GIR_RootConstrainSelectedInstOperands,
     /*  788050 */     // GIR_Coverage, 19173,
     /*  788050 */     GIR_EraseRootFromParent_Done,
     /*  788051 */   // Label 12222: @788051
     /*  788051 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(788126), // Rule ID 19176 //
     /*  788056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  788105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788124 */     GIR_RootConstrainSelectedInstOperands,
     /*  788125 */     // GIR_Coverage, 19176,
     /*  788125 */     GIR_EraseRootFromParent_Done,
     /*  788126 */   // Label 12223: @788126
     /*  788126 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(788201), // Rule ID 19177 //
     /*  788131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  788180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788199 */     GIR_RootConstrainSelectedInstOperands,
     /*  788200 */     // GIR_Coverage, 19177,
     /*  788200 */     GIR_EraseRootFromParent_Done,
     /*  788201 */   // Label 12224: @788201
     /*  788201 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(788276), // Rule ID 19180 //
     /*  788206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  788255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788274 */     GIR_RootConstrainSelectedInstOperands,
     /*  788275 */     // GIR_Coverage, 19180,
     /*  788275 */     GIR_EraseRootFromParent_Done,
     /*  788276 */   // Label 12225: @788276
     /*  788276 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(788351), // Rule ID 19181 //
     /*  788281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  788330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788349 */     GIR_RootConstrainSelectedInstOperands,
     /*  788350 */     // GIR_Coverage, 19181,
     /*  788350 */     GIR_EraseRootFromParent_Done,
     /*  788351 */   // Label 12226: @788351
     /*  788351 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(788426), // Rule ID 19184 //
     /*  788356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  788405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788424 */     GIR_RootConstrainSelectedInstOperands,
     /*  788425 */     // GIR_Coverage, 19184,
     /*  788425 */     GIR_EraseRootFromParent_Done,
     /*  788426 */   // Label 12227: @788426
     /*  788426 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(788501), // Rule ID 19185 //
     /*  788431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  788480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788499 */     GIR_RootConstrainSelectedInstOperands,
     /*  788500 */     // GIR_Coverage, 19185,
     /*  788500 */     GIR_EraseRootFromParent_Done,
     /*  788501 */   // Label 12228: @788501
     /*  788501 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(788576), // Rule ID 19188 //
     /*  788506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  788555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788574 */     GIR_RootConstrainSelectedInstOperands,
     /*  788575 */     // GIR_Coverage, 19188,
     /*  788575 */     GIR_EraseRootFromParent_Done,
     /*  788576 */   // Label 12229: @788576
     /*  788576 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(788651), // Rule ID 19189 //
     /*  788581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  788630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788649 */     GIR_RootConstrainSelectedInstOperands,
     /*  788650 */     // GIR_Coverage, 19189,
     /*  788650 */     GIR_EraseRootFromParent_Done,
     /*  788651 */   // Label 12230: @788651
     /*  788651 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(788726), // Rule ID 19192 //
     /*  788656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  788705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788724 */     GIR_RootConstrainSelectedInstOperands,
     /*  788725 */     // GIR_Coverage, 19192,
     /*  788725 */     GIR_EraseRootFromParent_Done,
     /*  788726 */   // Label 12231: @788726
     /*  788726 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(788801), // Rule ID 19193 //
     /*  788731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  788780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788799 */     GIR_RootConstrainSelectedInstOperands,
     /*  788800 */     // GIR_Coverage, 19193,
     /*  788800 */     GIR_EraseRootFromParent_Done,
     /*  788801 */   // Label 12232: @788801
     /*  788801 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(788876), // Rule ID 19196 //
     /*  788806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  788817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  788820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  788823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  788826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  788855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788874 */     GIR_RootConstrainSelectedInstOperands,
     /*  788875 */     // GIR_Coverage, 19196,
     /*  788875 */     GIR_EraseRootFromParent_Done,
     /*  788876 */   // Label 12233: @788876
     /*  788876 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(788951), // Rule ID 19197 //
     /*  788881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  788892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  788895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  788898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  788901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  788930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788949 */     GIR_RootConstrainSelectedInstOperands,
     /*  788950 */     // GIR_Coverage, 19197,
     /*  788950 */     GIR_EraseRootFromParent_Done,
     /*  788951 */   // Label 12234: @788951
     /*  788951 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(789026), // Rule ID 19200 //
     /*  788956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  788967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  788970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  788973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  788976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  789005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789024 */     GIR_RootConstrainSelectedInstOperands,
     /*  789025 */     // GIR_Coverage, 19200,
     /*  789025 */     GIR_EraseRootFromParent_Done,
     /*  789026 */   // Label 12235: @789026
     /*  789026 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(789101), // Rule ID 19201 //
     /*  789031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  789080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789099 */     GIR_RootConstrainSelectedInstOperands,
     /*  789100 */     // GIR_Coverage, 19201,
     /*  789100 */     GIR_EraseRootFromParent_Done,
     /*  789101 */   // Label 12236: @789101
     /*  789101 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(789176), // Rule ID 19204 //
     /*  789106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  789155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789174 */     GIR_RootConstrainSelectedInstOperands,
     /*  789175 */     // GIR_Coverage, 19204,
     /*  789175 */     GIR_EraseRootFromParent_Done,
     /*  789176 */   // Label 12237: @789176
     /*  789176 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(789251), // Rule ID 19205 //
     /*  789181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  789230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789249 */     GIR_RootConstrainSelectedInstOperands,
     /*  789250 */     // GIR_Coverage, 19205,
     /*  789250 */     GIR_EraseRootFromParent_Done,
     /*  789251 */   // Label 12238: @789251
     /*  789251 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(789326), // Rule ID 19208 //
     /*  789256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  789305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789324 */     GIR_RootConstrainSelectedInstOperands,
     /*  789325 */     // GIR_Coverage, 19208,
     /*  789325 */     GIR_EraseRootFromParent_Done,
     /*  789326 */   // Label 12239: @789326
     /*  789326 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(789401), // Rule ID 19209 //
     /*  789331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  789380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789399 */     GIR_RootConstrainSelectedInstOperands,
     /*  789400 */     // GIR_Coverage, 19209,
     /*  789400 */     GIR_EraseRootFromParent_Done,
     /*  789401 */   // Label 12240: @789401
     /*  789401 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(789476), // Rule ID 19212 //
     /*  789406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  789455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789474 */     GIR_RootConstrainSelectedInstOperands,
     /*  789475 */     // GIR_Coverage, 19212,
     /*  789475 */     GIR_EraseRootFromParent_Done,
     /*  789476 */   // Label 12241: @789476
     /*  789476 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(789551), // Rule ID 19213 //
     /*  789481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  789530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789549 */     GIR_RootConstrainSelectedInstOperands,
     /*  789550 */     // GIR_Coverage, 19213,
     /*  789550 */     GIR_EraseRootFromParent_Done,
     /*  789551 */   // Label 12242: @789551
     /*  789551 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(789626), // Rule ID 19216 //
     /*  789556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  789605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789624 */     GIR_RootConstrainSelectedInstOperands,
     /*  789625 */     // GIR_Coverage, 19216,
     /*  789625 */     GIR_EraseRootFromParent_Done,
     /*  789626 */   // Label 12243: @789626
     /*  789626 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(789701), // Rule ID 19217 //
     /*  789631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  789680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789699 */     GIR_RootConstrainSelectedInstOperands,
     /*  789700 */     // GIR_Coverage, 19217,
     /*  789700 */     GIR_EraseRootFromParent_Done,
     /*  789701 */   // Label 12244: @789701
     /*  789701 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(789776), // Rule ID 19220 //
     /*  789706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  789755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789774 */     GIR_RootConstrainSelectedInstOperands,
     /*  789775 */     // GIR_Coverage, 19220,
     /*  789775 */     GIR_EraseRootFromParent_Done,
     /*  789776 */   // Label 12245: @789776
     /*  789776 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(789851), // Rule ID 19221 //
     /*  789781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  789830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789849 */     GIR_RootConstrainSelectedInstOperands,
     /*  789850 */     // GIR_Coverage, 19221,
     /*  789850 */     GIR_EraseRootFromParent_Done,
     /*  789851 */   // Label 12246: @789851
     /*  789851 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(789926), // Rule ID 19224 //
     /*  789856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  789867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  789870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  789873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  789876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  789895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  789905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789924 */     GIR_RootConstrainSelectedInstOperands,
     /*  789925 */     // GIR_Coverage, 19224,
     /*  789925 */     GIR_EraseRootFromParent_Done,
     /*  789926 */   // Label 12247: @789926
     /*  789926 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(790001), // Rule ID 19225 //
     /*  789931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  789939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  789942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  789945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  789948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  789951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  789970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  789980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789999 */     GIR_RootConstrainSelectedInstOperands,
     /*  790000 */     // GIR_Coverage, 19225,
     /*  790000 */     GIR_EraseRootFromParent_Done,
     /*  790001 */   // Label 12248: @790001
     /*  790001 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(790076), // Rule ID 19228 //
     /*  790006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  790055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790074 */     GIR_RootConstrainSelectedInstOperands,
     /*  790075 */     // GIR_Coverage, 19228,
     /*  790075 */     GIR_EraseRootFromParent_Done,
     /*  790076 */   // Label 12249: @790076
     /*  790076 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(790151), // Rule ID 19229 //
     /*  790081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  790130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790149 */     GIR_RootConstrainSelectedInstOperands,
     /*  790150 */     // GIR_Coverage, 19229,
     /*  790150 */     GIR_EraseRootFromParent_Done,
     /*  790151 */   // Label 12250: @790151
     /*  790151 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(790226), // Rule ID 19232 //
     /*  790156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  790205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790224 */     GIR_RootConstrainSelectedInstOperands,
     /*  790225 */     // GIR_Coverage, 19232,
     /*  790225 */     GIR_EraseRootFromParent_Done,
     /*  790226 */   // Label 12251: @790226
     /*  790226 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(790301), // Rule ID 19233 //
     /*  790231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  790280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790299 */     GIR_RootConstrainSelectedInstOperands,
     /*  790300 */     // GIR_Coverage, 19233,
     /*  790300 */     GIR_EraseRootFromParent_Done,
     /*  790301 */   // Label 12252: @790301
     /*  790301 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(790376), // Rule ID 19236 //
     /*  790306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  790355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790374 */     GIR_RootConstrainSelectedInstOperands,
     /*  790375 */     // GIR_Coverage, 19236,
     /*  790375 */     GIR_EraseRootFromParent_Done,
     /*  790376 */   // Label 12253: @790376
     /*  790376 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(790451), // Rule ID 19237 //
     /*  790381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11151:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  790430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790449 */     GIR_RootConstrainSelectedInstOperands,
     /*  790450 */     // GIR_Coverage, 19237,
     /*  790450 */     GIR_EraseRootFromParent_Done,
     /*  790451 */   // Label 12254: @790451
     /*  790451 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(790526), // Rule ID 19240 //
     /*  790456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  790505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790524 */     GIR_RootConstrainSelectedInstOperands,
     /*  790525 */     // GIR_Coverage, 19240,
     /*  790525 */     GIR_EraseRootFromParent_Done,
     /*  790526 */   // Label 12255: @790526
     /*  790526 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(790601), // Rule ID 19241 //
     /*  790531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  790580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790599 */     GIR_RootConstrainSelectedInstOperands,
     /*  790600 */     // GIR_Coverage, 19241,
     /*  790600 */     GIR_EraseRootFromParent_Done,
     /*  790601 */   // Label 12256: @790601
     /*  790601 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(790676), // Rule ID 19244 //
     /*  790606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  790655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790674 */     GIR_RootConstrainSelectedInstOperands,
     /*  790675 */     // GIR_Coverage, 19244,
     /*  790675 */     GIR_EraseRootFromParent_Done,
     /*  790676 */   // Label 12257: @790676
     /*  790676 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(790751), // Rule ID 19245 //
     /*  790681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  790730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790749 */     GIR_RootConstrainSelectedInstOperands,
     /*  790750 */     // GIR_Coverage, 19245,
     /*  790750 */     GIR_EraseRootFromParent_Done,
     /*  790751 */   // Label 12258: @790751
     /*  790751 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(790826), // Rule ID 19248 //
     /*  790756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  790805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790824 */     GIR_RootConstrainSelectedInstOperands,
     /*  790825 */     // GIR_Coverage, 19248,
     /*  790825 */     GIR_EraseRootFromParent_Done,
     /*  790826 */   // Label 12259: @790826
     /*  790826 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(790901), // Rule ID 19249 //
     /*  790831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  790880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790899 */     GIR_RootConstrainSelectedInstOperands,
     /*  790900 */     // GIR_Coverage, 19249,
     /*  790900 */     GIR_EraseRootFromParent_Done,
     /*  790901 */   // Label 12260: @790901
     /*  790901 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(790976), // Rule ID 19252 //
     /*  790906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  790917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  790920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  790923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  790955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790974 */     GIR_RootConstrainSelectedInstOperands,
     /*  790975 */     // GIR_Coverage, 19252,
     /*  790975 */     GIR_EraseRootFromParent_Done,
     /*  790976 */   // Label 12261: @790976
     /*  790976 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(791051), // Rule ID 19253 //
     /*  790981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  790989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  790992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  790995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  790998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  791030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791049 */     GIR_RootConstrainSelectedInstOperands,
     /*  791050 */     // GIR_Coverage, 19253,
     /*  791050 */     GIR_EraseRootFromParent_Done,
     /*  791051 */   // Label 12262: @791051
     /*  791051 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(791126), // Rule ID 19256 //
     /*  791056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  791105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791124 */     GIR_RootConstrainSelectedInstOperands,
     /*  791125 */     // GIR_Coverage, 19256,
     /*  791125 */     GIR_EraseRootFromParent_Done,
     /*  791126 */   // Label 12263: @791126
     /*  791126 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(791201), // Rule ID 19257 //
     /*  791131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  791180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791199 */     GIR_RootConstrainSelectedInstOperands,
     /*  791200 */     // GIR_Coverage, 19257,
     /*  791200 */     GIR_EraseRootFromParent_Done,
     /*  791201 */   // Label 12264: @791201
     /*  791201 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(791276), // Rule ID 19260 //
     /*  791206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  791255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791274 */     GIR_RootConstrainSelectedInstOperands,
     /*  791275 */     // GIR_Coverage, 19260,
     /*  791275 */     GIR_EraseRootFromParent_Done,
     /*  791276 */   // Label 12265: @791276
     /*  791276 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(791351), // Rule ID 19261 //
     /*  791281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  791330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791349 */     GIR_RootConstrainSelectedInstOperands,
     /*  791350 */     // GIR_Coverage, 19261,
     /*  791350 */     GIR_EraseRootFromParent_Done,
     /*  791351 */   // Label 12266: @791351
     /*  791351 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(791426), // Rule ID 19264 //
     /*  791356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  791405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791424 */     GIR_RootConstrainSelectedInstOperands,
     /*  791425 */     // GIR_Coverage, 19264,
     /*  791425 */     GIR_EraseRootFromParent_Done,
     /*  791426 */   // Label 12267: @791426
     /*  791426 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(791501), // Rule ID 19265 //
     /*  791431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  791480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791499 */     GIR_RootConstrainSelectedInstOperands,
     /*  791500 */     // GIR_Coverage, 19265,
     /*  791500 */     GIR_EraseRootFromParent_Done,
     /*  791501 */   // Label 12268: @791501
     /*  791501 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(791576), // Rule ID 19268 //
     /*  791506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  791555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791574 */     GIR_RootConstrainSelectedInstOperands,
     /*  791575 */     // GIR_Coverage, 19268,
     /*  791575 */     GIR_EraseRootFromParent_Done,
     /*  791576 */   // Label 12269: @791576
     /*  791576 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(791651), // Rule ID 19269 //
     /*  791581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  791630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791649 */     GIR_RootConstrainSelectedInstOperands,
     /*  791650 */     // GIR_Coverage, 19269,
     /*  791650 */     GIR_EraseRootFromParent_Done,
     /*  791651 */   // Label 12270: @791651
     /*  791651 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(791726), // Rule ID 19272 //
     /*  791656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  791705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791724 */     GIR_RootConstrainSelectedInstOperands,
     /*  791725 */     // GIR_Coverage, 19272,
     /*  791725 */     GIR_EraseRootFromParent_Done,
     /*  791726 */   // Label 12271: @791726
     /*  791726 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(791801), // Rule ID 19273 //
     /*  791731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  791780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791799 */     GIR_RootConstrainSelectedInstOperands,
     /*  791800 */     // GIR_Coverage, 19273,
     /*  791800 */     GIR_EraseRootFromParent_Done,
     /*  791801 */   // Label 12272: @791801
     /*  791801 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(791876), // Rule ID 19276 //
     /*  791806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  791817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  791820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  791823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  791855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791874 */     GIR_RootConstrainSelectedInstOperands,
     /*  791875 */     // GIR_Coverage, 19276,
     /*  791875 */     GIR_EraseRootFromParent_Done,
     /*  791876 */   // Label 12273: @791876
     /*  791876 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(791951), // Rule ID 19277 //
     /*  791881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  791892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  791895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  791898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  791930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791949 */     GIR_RootConstrainSelectedInstOperands,
     /*  791950 */     // GIR_Coverage, 19277,
     /*  791950 */     GIR_EraseRootFromParent_Done,
     /*  791951 */   // Label 12274: @791951
     /*  791951 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(792026), // Rule ID 19280 //
     /*  791956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  791964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  791967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  791970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  791973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  792005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792024 */     GIR_RootConstrainSelectedInstOperands,
     /*  792025 */     // GIR_Coverage, 19280,
     /*  792025 */     GIR_EraseRootFromParent_Done,
     /*  792026 */   // Label 12275: @792026
     /*  792026 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(792101), // Rule ID 19281 //
     /*  792031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  792039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  792080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792099 */     GIR_RootConstrainSelectedInstOperands,
     /*  792100 */     // GIR_Coverage, 19281,
     /*  792100 */     GIR_EraseRootFromParent_Done,
     /*  792101 */   // Label 12276: @792101
     /*  792101 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(792176), // Rule ID 19284 //
     /*  792106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  792155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792174 */     GIR_RootConstrainSelectedInstOperands,
     /*  792175 */     // GIR_Coverage, 19284,
     /*  792175 */     GIR_EraseRootFromParent_Done,
     /*  792176 */   // Label 12277: @792176
     /*  792176 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(792251), // Rule ID 19285 //
     /*  792181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  792230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792249 */     GIR_RootConstrainSelectedInstOperands,
     /*  792250 */     // GIR_Coverage, 19285,
     /*  792250 */     GIR_EraseRootFromParent_Done,
     /*  792251 */   // Label 12278: @792251
     /*  792251 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(792326), // Rule ID 19288 //
     /*  792256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  792305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792324 */     GIR_RootConstrainSelectedInstOperands,
     /*  792325 */     // GIR_Coverage, 19288,
     /*  792325 */     GIR_EraseRootFromParent_Done,
     /*  792326 */   // Label 12279: @792326
     /*  792326 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(792401), // Rule ID 19289 //
     /*  792331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  792380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792399 */     GIR_RootConstrainSelectedInstOperands,
     /*  792400 */     // GIR_Coverage, 19289,
     /*  792400 */     GIR_EraseRootFromParent_Done,
     /*  792401 */   // Label 12280: @792401
     /*  792401 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(792476), // Rule ID 19292 //
     /*  792406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  792455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792474 */     GIR_RootConstrainSelectedInstOperands,
     /*  792475 */     // GIR_Coverage, 19292,
     /*  792475 */     GIR_EraseRootFromParent_Done,
     /*  792476 */   // Label 12281: @792476
     /*  792476 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(792551), // Rule ID 19293 //
     /*  792481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  792530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792549 */     GIR_RootConstrainSelectedInstOperands,
     /*  792550 */     // GIR_Coverage, 19293,
     /*  792550 */     GIR_EraseRootFromParent_Done,
     /*  792551 */   // Label 12282: @792551
     /*  792551 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(792626), // Rule ID 19296 //
     /*  792556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  792605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792624 */     GIR_RootConstrainSelectedInstOperands,
     /*  792625 */     // GIR_Coverage, 19296,
     /*  792625 */     GIR_EraseRootFromParent_Done,
     /*  792626 */   // Label 12283: @792626
     /*  792626 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(792701), // Rule ID 19297 //
     /*  792631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  792680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792699 */     GIR_RootConstrainSelectedInstOperands,
     /*  792700 */     // GIR_Coverage, 19297,
     /*  792700 */     GIR_EraseRootFromParent_Done,
     /*  792701 */   // Label 12284: @792701
     /*  792701 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(792776), // Rule ID 19300 //
     /*  792706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  792755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792774 */     GIR_RootConstrainSelectedInstOperands,
     /*  792775 */     // GIR_Coverage, 19300,
     /*  792775 */     GIR_EraseRootFromParent_Done,
     /*  792776 */   // Label 12285: @792776
     /*  792776 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(792851), // Rule ID 19301 //
     /*  792781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  792830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792849 */     GIR_RootConstrainSelectedInstOperands,
     /*  792850 */     // GIR_Coverage, 19301,
     /*  792850 */     GIR_EraseRootFromParent_Done,
     /*  792851 */   // Label 12286: @792851
     /*  792851 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(792926), // Rule ID 19304 //
     /*  792856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  792905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792924 */     GIR_RootConstrainSelectedInstOperands,
     /*  792925 */     // GIR_Coverage, 19304,
     /*  792925 */     GIR_EraseRootFromParent_Done,
     /*  792926 */   // Label 12287: @792926
     /*  792926 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(793001), // Rule ID 19305 //
     /*  792931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  792942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  792945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  792948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  792951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  792980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792999 */     GIR_RootConstrainSelectedInstOperands,
     /*  793000 */     // GIR_Coverage, 19305,
     /*  793000 */     GIR_EraseRootFromParent_Done,
     /*  793001 */   // Label 12288: @793001
     /*  793001 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(793076), // Rule ID 19308 //
     /*  793006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  793055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793074 */     GIR_RootConstrainSelectedInstOperands,
     /*  793075 */     // GIR_Coverage, 19308,
     /*  793075 */     GIR_EraseRootFromParent_Done,
     /*  793076 */   // Label 12289: @793076
     /*  793076 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(793151), // Rule ID 19309 //
     /*  793081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  793130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793149 */     GIR_RootConstrainSelectedInstOperands,
     /*  793150 */     // GIR_Coverage, 19309,
     /*  793150 */     GIR_EraseRootFromParent_Done,
     /*  793151 */   // Label 12290: @793151
     /*  793151 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(793226), // Rule ID 19312 //
     /*  793156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  793205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793224 */     GIR_RootConstrainSelectedInstOperands,
     /*  793225 */     // GIR_Coverage, 19312,
     /*  793225 */     GIR_EraseRootFromParent_Done,
     /*  793226 */   // Label 12291: @793226
     /*  793226 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(793301), // Rule ID 19313 //
     /*  793231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  793280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793299 */     GIR_RootConstrainSelectedInstOperands,
     /*  793300 */     // GIR_Coverage, 19313,
     /*  793300 */     GIR_EraseRootFromParent_Done,
     /*  793301 */   // Label 12292: @793301
     /*  793301 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(793376), // Rule ID 19316 //
     /*  793306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  793355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793374 */     GIR_RootConstrainSelectedInstOperands,
     /*  793375 */     // GIR_Coverage, 19316,
     /*  793375 */     GIR_EraseRootFromParent_Done,
     /*  793376 */   // Label 12293: @793376
     /*  793376 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(793451), // Rule ID 19317 //
     /*  793381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  793430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793449 */     GIR_RootConstrainSelectedInstOperands,
     /*  793450 */     // GIR_Coverage, 19317,
     /*  793450 */     GIR_EraseRootFromParent_Done,
     /*  793451 */   // Label 12294: @793451
     /*  793451 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(793526), // Rule ID 19320 //
     /*  793456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  793505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793524 */     GIR_RootConstrainSelectedInstOperands,
     /*  793525 */     // GIR_Coverage, 19320,
     /*  793525 */     GIR_EraseRootFromParent_Done,
     /*  793526 */   // Label 12295: @793526
     /*  793526 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(793601), // Rule ID 19321 //
     /*  793531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  793580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793599 */     GIR_RootConstrainSelectedInstOperands,
     /*  793600 */     // GIR_Coverage, 19321,
     /*  793600 */     GIR_EraseRootFromParent_Done,
     /*  793601 */   // Label 12296: @793601
     /*  793601 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(793676), // Rule ID 19324 //
     /*  793606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  793655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793674 */     GIR_RootConstrainSelectedInstOperands,
     /*  793675 */     // GIR_Coverage, 19324,
     /*  793675 */     GIR_EraseRootFromParent_Done,
     /*  793676 */   // Label 12297: @793676
     /*  793676 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(793751), // Rule ID 19325 //
     /*  793681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  793730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793749 */     GIR_RootConstrainSelectedInstOperands,
     /*  793750 */     // GIR_Coverage, 19325,
     /*  793750 */     GIR_EraseRootFromParent_Done,
     /*  793751 */   // Label 12298: @793751
     /*  793751 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(793826), // Rule ID 19328 //
     /*  793756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  793805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793824 */     GIR_RootConstrainSelectedInstOperands,
     /*  793825 */     // GIR_Coverage, 19328,
     /*  793825 */     GIR_EraseRootFromParent_Done,
     /*  793826 */   // Label 12299: @793826
     /*  793826 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(793901), // Rule ID 19329 //
     /*  793831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  793880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793899 */     GIR_RootConstrainSelectedInstOperands,
     /*  793900 */     // GIR_Coverage, 19329,
     /*  793900 */     GIR_EraseRootFromParent_Done,
     /*  793901 */   // Label 12300: @793901
     /*  793901 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(793976), // Rule ID 19332 //
     /*  793906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  793926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  793955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793974 */     GIR_RootConstrainSelectedInstOperands,
     /*  793975 */     // GIR_Coverage, 19332,
     /*  793975 */     GIR_EraseRootFromParent_Done,
     /*  793976 */   // Label 12301: @793976
     /*  793976 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(794051), // Rule ID 19333 //
     /*  793981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  793989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  793992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  793995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  793998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  794030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794049 */     GIR_RootConstrainSelectedInstOperands,
     /*  794050 */     // GIR_Coverage, 19333,
     /*  794050 */     GIR_EraseRootFromParent_Done,
     /*  794051 */   // Label 12302: @794051
     /*  794051 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(794126), // Rule ID 19336 //
     /*  794056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  794105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794124 */     GIR_RootConstrainSelectedInstOperands,
     /*  794125 */     // GIR_Coverage, 19336,
     /*  794125 */     GIR_EraseRootFromParent_Done,
     /*  794126 */   // Label 12303: @794126
     /*  794126 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(794201), // Rule ID 19337 //
     /*  794131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  794180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794199 */     GIR_RootConstrainSelectedInstOperands,
     /*  794200 */     // GIR_Coverage, 19337,
     /*  794200 */     GIR_EraseRootFromParent_Done,
     /*  794201 */   // Label 12304: @794201
     /*  794201 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(794276), // Rule ID 19340 //
     /*  794206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  794255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794274 */     GIR_RootConstrainSelectedInstOperands,
     /*  794275 */     // GIR_Coverage, 19340,
     /*  794275 */     GIR_EraseRootFromParent_Done,
     /*  794276 */   // Label 12305: @794276
     /*  794276 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(794351), // Rule ID 19341 //
     /*  794281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  794330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794349 */     GIR_RootConstrainSelectedInstOperands,
     /*  794350 */     // GIR_Coverage, 19341,
     /*  794350 */     GIR_EraseRootFromParent_Done,
     /*  794351 */   // Label 12306: @794351
     /*  794351 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(794426), // Rule ID 19344 //
     /*  794356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  794405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794424 */     GIR_RootConstrainSelectedInstOperands,
     /*  794425 */     // GIR_Coverage, 19344,
     /*  794425 */     GIR_EraseRootFromParent_Done,
     /*  794426 */   // Label 12307: @794426
     /*  794426 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(794501), // Rule ID 19345 //
     /*  794431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794477 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  794480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794499 */     GIR_RootConstrainSelectedInstOperands,
     /*  794500 */     // GIR_Coverage, 19345,
     /*  794500 */     GIR_EraseRootFromParent_Done,
     /*  794501 */   // Label 12308: @794501
     /*  794501 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(794576), // Rule ID 19348 //
     /*  794506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  794555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794574 */     GIR_RootConstrainSelectedInstOperands,
     /*  794575 */     // GIR_Coverage, 19348,
     /*  794575 */     GIR_EraseRootFromParent_Done,
     /*  794576 */   // Label 12309: @794576
     /*  794576 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(794651), // Rule ID 19349 //
     /*  794581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794627 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  794630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794649 */     GIR_RootConstrainSelectedInstOperands,
     /*  794650 */     // GIR_Coverage, 19349,
     /*  794650 */     GIR_EraseRootFromParent_Done,
     /*  794651 */   // Label 12310: @794651
     /*  794651 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(794726), // Rule ID 19352 //
     /*  794656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  794705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794724 */     GIR_RootConstrainSelectedInstOperands,
     /*  794725 */     // GIR_Coverage, 19352,
     /*  794725 */     GIR_EraseRootFromParent_Done,
     /*  794726 */   // Label 12311: @794726
     /*  794726 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(794801), // Rule ID 19353 //
     /*  794731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794777 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  794780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794799 */     GIR_RootConstrainSelectedInstOperands,
     /*  794800 */     // GIR_Coverage, 19353,
     /*  794800 */     GIR_EraseRootFromParent_Done,
     /*  794801 */   // Label 12312: @794801
     /*  794801 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(794876), // Rule ID 19356 //
     /*  794806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  794817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  794820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  794823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  794855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794874 */     GIR_RootConstrainSelectedInstOperands,
     /*  794875 */     // GIR_Coverage, 19356,
     /*  794875 */     GIR_EraseRootFromParent_Done,
     /*  794876 */   // Label 12313: @794876
     /*  794876 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(794951), // Rule ID 19357 //
     /*  794881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  794892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  794895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  794898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  794930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794949 */     GIR_RootConstrainSelectedInstOperands,
     /*  794950 */     // GIR_Coverage, 19357,
     /*  794950 */     GIR_EraseRootFromParent_Done,
     /*  794951 */   // Label 12314: @794951
     /*  794951 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(795026), // Rule ID 19360 //
     /*  794956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  794964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  794967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  794970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  794973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  795005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795024 */     GIR_RootConstrainSelectedInstOperands,
     /*  795025 */     // GIR_Coverage, 19360,
     /*  795025 */     GIR_EraseRootFromParent_Done,
     /*  795026 */   // Label 12315: @795026
     /*  795026 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(795101), // Rule ID 19361 //
     /*  795031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795077 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  795080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795099 */     GIR_RootConstrainSelectedInstOperands,
     /*  795100 */     // GIR_Coverage, 19361,
     /*  795100 */     GIR_EraseRootFromParent_Done,
     /*  795101 */   // Label 12316: @795101
     /*  795101 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(795176), // Rule ID 19364 //
     /*  795106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  795155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795174 */     GIR_RootConstrainSelectedInstOperands,
     /*  795175 */     // GIR_Coverage, 19364,
     /*  795175 */     GIR_EraseRootFromParent_Done,
     /*  795176 */   // Label 12317: @795176
     /*  795176 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(795251), // Rule ID 19365 //
     /*  795181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  795230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795249 */     GIR_RootConstrainSelectedInstOperands,
     /*  795250 */     // GIR_Coverage, 19365,
     /*  795250 */     GIR_EraseRootFromParent_Done,
     /*  795251 */   // Label 12318: @795251
     /*  795251 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(795326), // Rule ID 19368 //
     /*  795256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  795305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795324 */     GIR_RootConstrainSelectedInstOperands,
     /*  795325 */     // GIR_Coverage, 19368,
     /*  795325 */     GIR_EraseRootFromParent_Done,
     /*  795326 */   // Label 12319: @795326
     /*  795326 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(795401), // Rule ID 19369 //
     /*  795331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  795380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795399 */     GIR_RootConstrainSelectedInstOperands,
     /*  795400 */     // GIR_Coverage, 19369,
     /*  795400 */     GIR_EraseRootFromParent_Done,
     /*  795401 */   // Label 12320: @795401
     /*  795401 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(795476), // Rule ID 19372 //
     /*  795406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  795455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795474 */     GIR_RootConstrainSelectedInstOperands,
     /*  795475 */     // GIR_Coverage, 19372,
     /*  795475 */     GIR_EraseRootFromParent_Done,
     /*  795476 */   // Label 12321: @795476
     /*  795476 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(795551), // Rule ID 19373 //
     /*  795481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  795530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795549 */     GIR_RootConstrainSelectedInstOperands,
     /*  795550 */     // GIR_Coverage, 19373,
     /*  795550 */     GIR_EraseRootFromParent_Done,
     /*  795551 */   // Label 12322: @795551
     /*  795551 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(795626), // Rule ID 19376 //
     /*  795556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  795605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795624 */     GIR_RootConstrainSelectedInstOperands,
     /*  795625 */     // GIR_Coverage, 19376,
     /*  795625 */     GIR_EraseRootFromParent_Done,
     /*  795626 */   // Label 12323: @795626
     /*  795626 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(795701), // Rule ID 19377 //
     /*  795631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  795680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795699 */     GIR_RootConstrainSelectedInstOperands,
     /*  795700 */     // GIR_Coverage, 19377,
     /*  795700 */     GIR_EraseRootFromParent_Done,
     /*  795701 */   // Label 12324: @795701
     /*  795701 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(795776), // Rule ID 19380 //
     /*  795706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  795755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795774 */     GIR_RootConstrainSelectedInstOperands,
     /*  795775 */     // GIR_Coverage, 19380,
     /*  795775 */     GIR_EraseRootFromParent_Done,
     /*  795776 */   // Label 12325: @795776
     /*  795776 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(795851), // Rule ID 19381 //
     /*  795781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  795830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795849 */     GIR_RootConstrainSelectedInstOperands,
     /*  795850 */     // GIR_Coverage, 19381,
     /*  795850 */     GIR_EraseRootFromParent_Done,
     /*  795851 */   // Label 12326: @795851
     /*  795851 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(795926), // Rule ID 19384 //
     /*  795856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  795867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  795870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  795873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795902 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  795905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795924 */     GIR_RootConstrainSelectedInstOperands,
     /*  795925 */     // GIR_Coverage, 19384,
     /*  795925 */     GIR_EraseRootFromParent_Done,
     /*  795926 */   // Label 12327: @795926
     /*  795926 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(796001), // Rule ID 19385 //
     /*  795931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  795939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  795942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  795945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  795948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795977 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  795980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795999 */     GIR_RootConstrainSelectedInstOperands,
     /*  796000 */     // GIR_Coverage, 19385,
     /*  796000 */     GIR_EraseRootFromParent_Done,
     /*  796001 */   // Label 12328: @796001
     /*  796001 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(796076), // Rule ID 19388 //
     /*  796006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796052 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  796055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796074 */     GIR_RootConstrainSelectedInstOperands,
     /*  796075 */     // GIR_Coverage, 19388,
     /*  796075 */     GIR_EraseRootFromParent_Done,
     /*  796076 */   // Label 12329: @796076
     /*  796076 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(796151), // Rule ID 19389 //
     /*  796081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796127 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  796130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796149 */     GIR_RootConstrainSelectedInstOperands,
     /*  796150 */     // GIR_Coverage, 19389,
     /*  796150 */     GIR_EraseRootFromParent_Done,
     /*  796151 */   // Label 12330: @796151
     /*  796151 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(796226), // Rule ID 19392 //
     /*  796156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  796205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796224 */     GIR_RootConstrainSelectedInstOperands,
     /*  796225 */     // GIR_Coverage, 19392,
     /*  796225 */     GIR_EraseRootFromParent_Done,
     /*  796226 */   // Label 12331: @796226
     /*  796226 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(796301), // Rule ID 19393 //
     /*  796231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796277 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  796280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796299 */     GIR_RootConstrainSelectedInstOperands,
     /*  796300 */     // GIR_Coverage, 19393,
     /*  796300 */     GIR_EraseRootFromParent_Done,
     /*  796301 */   // Label 12332: @796301
     /*  796301 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(796376), // Rule ID 19396 //
     /*  796306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  796355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796374 */     GIR_RootConstrainSelectedInstOperands,
     /*  796375 */     // GIR_Coverage, 19396,
     /*  796375 */     GIR_EraseRootFromParent_Done,
     /*  796376 */   // Label 12333: @796376
     /*  796376 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(796451), // Rule ID 19397 //
     /*  796381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796427 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  796430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796449 */     GIR_RootConstrainSelectedInstOperands,
     /*  796450 */     // GIR_Coverage, 19397,
     /*  796450 */     GIR_EraseRootFromParent_Done,
     /*  796451 */   // Label 12334: @796451
     /*  796451 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(796526), // Rule ID 19400 //
     /*  796456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  796505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796524 */     GIR_RootConstrainSelectedInstOperands,
     /*  796525 */     // GIR_Coverage, 19400,
     /*  796525 */     GIR_EraseRootFromParent_Done,
     /*  796526 */   // Label 12335: @796526
     /*  796526 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(796601), // Rule ID 19401 //
     /*  796531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  796539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796577 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  796580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796599 */     GIR_RootConstrainSelectedInstOperands,
     /*  796600 */     // GIR_Coverage, 19401,
     /*  796600 */     GIR_EraseRootFromParent_Done,
     /*  796601 */   // Label 12336: @796601
     /*  796601 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(796676), // Rule ID 19404 //
     /*  796606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  796655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796674 */     GIR_RootConstrainSelectedInstOperands,
     /*  796675 */     // GIR_Coverage, 19404,
     /*  796675 */     GIR_EraseRootFromParent_Done,
     /*  796676 */   // Label 12337: @796676
     /*  796676 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(796751), // Rule ID 19405 //
     /*  796681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  796730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796749 */     GIR_RootConstrainSelectedInstOperands,
     /*  796750 */     // GIR_Coverage, 19405,
     /*  796750 */     GIR_EraseRootFromParent_Done,
     /*  796751 */   // Label 12338: @796751
     /*  796751 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(796826), // Rule ID 19408 //
     /*  796756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  796805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796824 */     GIR_RootConstrainSelectedInstOperands,
     /*  796825 */     // GIR_Coverage, 19408,
     /*  796825 */     GIR_EraseRootFromParent_Done,
     /*  796826 */   // Label 12339: @796826
     /*  796826 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(796901), // Rule ID 19409 //
     /*  796831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  796880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796899 */     GIR_RootConstrainSelectedInstOperands,
     /*  796900 */     // GIR_Coverage, 19409,
     /*  796900 */     GIR_EraseRootFromParent_Done,
     /*  796901 */   // Label 12340: @796901
     /*  796901 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(796976), // Rule ID 19412 //
     /*  796906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  796917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  796920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  796923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  796926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  796955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796974 */     GIR_RootConstrainSelectedInstOperands,
     /*  796975 */     // GIR_Coverage, 19412,
     /*  796975 */     GIR_EraseRootFromParent_Done,
     /*  796976 */   // Label 12341: @796976
     /*  796976 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(797051), // Rule ID 19413 //
     /*  796981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  796992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  796995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  796998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  797030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797049 */     GIR_RootConstrainSelectedInstOperands,
     /*  797050 */     // GIR_Coverage, 19413,
     /*  797050 */     GIR_EraseRootFromParent_Done,
     /*  797051 */   // Label 12342: @797051
     /*  797051 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(797126), // Rule ID 19416 //
     /*  797056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  797105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797124 */     GIR_RootConstrainSelectedInstOperands,
     /*  797125 */     // GIR_Coverage, 19416,
     /*  797125 */     GIR_EraseRootFromParent_Done,
     /*  797126 */   // Label 12343: @797126
     /*  797126 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(797201), // Rule ID 19417 //
     /*  797131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  797180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797199 */     GIR_RootConstrainSelectedInstOperands,
     /*  797200 */     // GIR_Coverage, 19417,
     /*  797200 */     GIR_EraseRootFromParent_Done,
     /*  797201 */   // Label 12344: @797201
     /*  797201 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(797276), // Rule ID 19420 //
     /*  797206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  797255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797274 */     GIR_RootConstrainSelectedInstOperands,
     /*  797275 */     // GIR_Coverage, 19420,
     /*  797275 */     GIR_EraseRootFromParent_Done,
     /*  797276 */   // Label 12345: @797276
     /*  797276 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(797351), // Rule ID 19421 //
     /*  797281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  797330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797349 */     GIR_RootConstrainSelectedInstOperands,
     /*  797350 */     // GIR_Coverage, 19421,
     /*  797350 */     GIR_EraseRootFromParent_Done,
     /*  797351 */   // Label 12346: @797351
     /*  797351 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(797426), // Rule ID 19424 //
     /*  797356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  797405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797424 */     GIR_RootConstrainSelectedInstOperands,
     /*  797425 */     // GIR_Coverage, 19424,
     /*  797425 */     GIR_EraseRootFromParent_Done,
     /*  797426 */   // Label 12347: @797426
     /*  797426 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(797501), // Rule ID 19425 //
     /*  797431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  797480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797499 */     GIR_RootConstrainSelectedInstOperands,
     /*  797500 */     // GIR_Coverage, 19425,
     /*  797500 */     GIR_EraseRootFromParent_Done,
     /*  797501 */   // Label 12348: @797501
     /*  797501 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(797576), // Rule ID 19428 //
     /*  797506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  797555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797574 */     GIR_RootConstrainSelectedInstOperands,
     /*  797575 */     // GIR_Coverage, 19428,
     /*  797575 */     GIR_EraseRootFromParent_Done,
     /*  797576 */   // Label 12349: @797576
     /*  797576 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(797651), // Rule ID 19429 //
     /*  797581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  797630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797649 */     GIR_RootConstrainSelectedInstOperands,
     /*  797650 */     // GIR_Coverage, 19429,
     /*  797650 */     GIR_EraseRootFromParent_Done,
     /*  797651 */   // Label 12350: @797651
     /*  797651 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(797726), // Rule ID 19432 //
     /*  797656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  797705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797724 */     GIR_RootConstrainSelectedInstOperands,
     /*  797725 */     // GIR_Coverage, 19432,
     /*  797725 */     GIR_EraseRootFromParent_Done,
     /*  797726 */   // Label 12351: @797726
     /*  797726 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(797801), // Rule ID 19433 //
     /*  797731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  797780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797799 */     GIR_RootConstrainSelectedInstOperands,
     /*  797800 */     // GIR_Coverage, 19433,
     /*  797800 */     GIR_EraseRootFromParent_Done,
     /*  797801 */   // Label 12352: @797801
     /*  797801 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(797876), // Rule ID 19436 //
     /*  797806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  797817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  797820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  797823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  797826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  797855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797874 */     GIR_RootConstrainSelectedInstOperands,
     /*  797875 */     // GIR_Coverage, 19436,
     /*  797875 */     GIR_EraseRootFromParent_Done,
     /*  797876 */   // Label 12353: @797876
     /*  797876 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(797951), // Rule ID 19437 //
     /*  797881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  797892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  797895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  797898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  797901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  797930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797949 */     GIR_RootConstrainSelectedInstOperands,
     /*  797950 */     // GIR_Coverage, 19437,
     /*  797950 */     GIR_EraseRootFromParent_Done,
     /*  797951 */   // Label 12354: @797951
     /*  797951 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(798026), // Rule ID 19440 //
     /*  797956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  797967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  797970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  797973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  797976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  798005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798024 */     GIR_RootConstrainSelectedInstOperands,
     /*  798025 */     // GIR_Coverage, 19440,
     /*  798025 */     GIR_EraseRootFromParent_Done,
     /*  798026 */   // Label 12355: @798026
     /*  798026 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(798101), // Rule ID 19441 //
     /*  798031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  798080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798099 */     GIR_RootConstrainSelectedInstOperands,
     /*  798100 */     // GIR_Coverage, 19441,
     /*  798100 */     GIR_EraseRootFromParent_Done,
     /*  798101 */   // Label 12356: @798101
     /*  798101 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(798176), // Rule ID 19444 //
     /*  798106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  798155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798174 */     GIR_RootConstrainSelectedInstOperands,
     /*  798175 */     // GIR_Coverage, 19444,
     /*  798175 */     GIR_EraseRootFromParent_Done,
     /*  798176 */   // Label 12357: @798176
     /*  798176 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(798251), // Rule ID 19445 //
     /*  798181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  798230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798249 */     GIR_RootConstrainSelectedInstOperands,
     /*  798250 */     // GIR_Coverage, 19445,
     /*  798250 */     GIR_EraseRootFromParent_Done,
     /*  798251 */   // Label 12358: @798251
     /*  798251 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(798326), // Rule ID 19448 //
     /*  798256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  798305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798324 */     GIR_RootConstrainSelectedInstOperands,
     /*  798325 */     // GIR_Coverage, 19448,
     /*  798325 */     GIR_EraseRootFromParent_Done,
     /*  798326 */   // Label 12359: @798326
     /*  798326 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(798401), // Rule ID 19449 //
     /*  798331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  798380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798399 */     GIR_RootConstrainSelectedInstOperands,
     /*  798400 */     // GIR_Coverage, 19449,
     /*  798400 */     GIR_EraseRootFromParent_Done,
     /*  798401 */   // Label 12360: @798401
     /*  798401 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(798476), // Rule ID 19452 //
     /*  798406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  798455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798474 */     GIR_RootConstrainSelectedInstOperands,
     /*  798475 */     // GIR_Coverage, 19452,
     /*  798475 */     GIR_EraseRootFromParent_Done,
     /*  798476 */   // Label 12361: @798476
     /*  798476 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(798551), // Rule ID 19453 //
     /*  798481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  798530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798549 */     GIR_RootConstrainSelectedInstOperands,
     /*  798550 */     // GIR_Coverage, 19453,
     /*  798550 */     GIR_EraseRootFromParent_Done,
     /*  798551 */   // Label 12362: @798551
     /*  798551 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(798626), // Rule ID 19456 //
     /*  798556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  798605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798624 */     GIR_RootConstrainSelectedInstOperands,
     /*  798625 */     // GIR_Coverage, 19456,
     /*  798625 */     GIR_EraseRootFromParent_Done,
     /*  798626 */   // Label 12363: @798626
     /*  798626 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(798701), // Rule ID 19457 //
     /*  798631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  798680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798699 */     GIR_RootConstrainSelectedInstOperands,
     /*  798700 */     // GIR_Coverage, 19457,
     /*  798700 */     GIR_EraseRootFromParent_Done,
     /*  798701 */   // Label 12364: @798701
     /*  798701 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(798776), // Rule ID 19460 //
     /*  798706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  798755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798774 */     GIR_RootConstrainSelectedInstOperands,
     /*  798775 */     // GIR_Coverage, 19460,
     /*  798775 */     GIR_EraseRootFromParent_Done,
     /*  798776 */   // Label 12365: @798776
     /*  798776 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(798851), // Rule ID 19461 //
     /*  798781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  798830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798849 */     GIR_RootConstrainSelectedInstOperands,
     /*  798850 */     // GIR_Coverage, 19461,
     /*  798850 */     GIR_EraseRootFromParent_Done,
     /*  798851 */   // Label 12366: @798851
     /*  798851 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(798926), // Rule ID 19464 //
     /*  798856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  798867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  798870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  798873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  798876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  798895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  798905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798924 */     GIR_RootConstrainSelectedInstOperands,
     /*  798925 */     // GIR_Coverage, 19464,
     /*  798925 */     GIR_EraseRootFromParent_Done,
     /*  798926 */   // Label 12367: @798926
     /*  798926 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(799001), // Rule ID 19465 //
     /*  798931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  798939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  798942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  798945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  798948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  798951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  798970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  798980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798999 */     GIR_RootConstrainSelectedInstOperands,
     /*  799000 */     // GIR_Coverage, 19465,
     /*  799000 */     GIR_EraseRootFromParent_Done,
     /*  799001 */   // Label 12368: @799001
     /*  799001 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(799076), // Rule ID 19468 //
     /*  799006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  799055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799074 */     GIR_RootConstrainSelectedInstOperands,
     /*  799075 */     // GIR_Coverage, 19468,
     /*  799075 */     GIR_EraseRootFromParent_Done,
     /*  799076 */   // Label 12369: @799076
     /*  799076 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(799151), // Rule ID 19469 //
     /*  799081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  799130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799149 */     GIR_RootConstrainSelectedInstOperands,
     /*  799150 */     // GIR_Coverage, 19469,
     /*  799150 */     GIR_EraseRootFromParent_Done,
     /*  799151 */   // Label 12370: @799151
     /*  799151 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(799226), // Rule ID 19472 //
     /*  799156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  799205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799224 */     GIR_RootConstrainSelectedInstOperands,
     /*  799225 */     // GIR_Coverage, 19472,
     /*  799225 */     GIR_EraseRootFromParent_Done,
     /*  799226 */   // Label 12371: @799226
     /*  799226 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(799301), // Rule ID 19473 //
     /*  799231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  799280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799299 */     GIR_RootConstrainSelectedInstOperands,
     /*  799300 */     // GIR_Coverage, 19473,
     /*  799300 */     GIR_EraseRootFromParent_Done,
     /*  799301 */   // Label 12372: @799301
     /*  799301 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(799376), // Rule ID 19476 //
     /*  799306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  799355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799374 */     GIR_RootConstrainSelectedInstOperands,
     /*  799375 */     // GIR_Coverage, 19476,
     /*  799375 */     GIR_EraseRootFromParent_Done,
     /*  799376 */   // Label 12373: @799376
     /*  799376 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(799451), // Rule ID 19477 //
     /*  799381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  799430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799449 */     GIR_RootConstrainSelectedInstOperands,
     /*  799450 */     // GIR_Coverage, 19477,
     /*  799450 */     GIR_EraseRootFromParent_Done,
     /*  799451 */   // Label 12374: @799451
     /*  799451 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(799526), // Rule ID 19480 //
     /*  799456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  799505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799524 */     GIR_RootConstrainSelectedInstOperands,
     /*  799525 */     // GIR_Coverage, 19480,
     /*  799525 */     GIR_EraseRootFromParent_Done,
     /*  799526 */   // Label 12375: @799526
     /*  799526 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(799601), // Rule ID 19481 //
     /*  799531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  799580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799599 */     GIR_RootConstrainSelectedInstOperands,
     /*  799600 */     // GIR_Coverage, 19481,
     /*  799600 */     GIR_EraseRootFromParent_Done,
     /*  799601 */   // Label 12376: @799601
     /*  799601 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(799676), // Rule ID 19484 //
     /*  799606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  799655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799674 */     GIR_RootConstrainSelectedInstOperands,
     /*  799675 */     // GIR_Coverage, 19484,
     /*  799675 */     GIR_EraseRootFromParent_Done,
     /*  799676 */   // Label 12377: @799676
     /*  799676 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(799751), // Rule ID 19485 //
     /*  799681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  799730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799749 */     GIR_RootConstrainSelectedInstOperands,
     /*  799750 */     // GIR_Coverage, 19485,
     /*  799750 */     GIR_EraseRootFromParent_Done,
     /*  799751 */   // Label 12378: @799751
     /*  799751 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(799826), // Rule ID 19488 //
     /*  799756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  799805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799824 */     GIR_RootConstrainSelectedInstOperands,
     /*  799825 */     // GIR_Coverage, 19488,
     /*  799825 */     GIR_EraseRootFromParent_Done,
     /*  799826 */   // Label 12379: @799826
     /*  799826 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(799901), // Rule ID 19489 //
     /*  799831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  799880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799899 */     GIR_RootConstrainSelectedInstOperands,
     /*  799900 */     // GIR_Coverage, 19489,
     /*  799900 */     GIR_EraseRootFromParent_Done,
     /*  799901 */   // Label 12380: @799901
     /*  799901 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(799976), // Rule ID 19492 //
     /*  799906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  799955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799974 */     GIR_RootConstrainSelectedInstOperands,
     /*  799975 */     // GIR_Coverage, 19492,
     /*  799975 */     GIR_EraseRootFromParent_Done,
     /*  799976 */   // Label 12381: @799976
     /*  799976 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(800051), // Rule ID 19493 //
     /*  799981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  799989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  799992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  799995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  799998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  800030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800049 */     GIR_RootConstrainSelectedInstOperands,
     /*  800050 */     // GIR_Coverage, 19493,
     /*  800050 */     GIR_EraseRootFromParent_Done,
     /*  800051 */   // Label 12382: @800051
     /*  800051 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(800126), // Rule ID 19496 //
     /*  800056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  800105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800124 */     GIR_RootConstrainSelectedInstOperands,
     /*  800125 */     // GIR_Coverage, 19496,
     /*  800125 */     GIR_EraseRootFromParent_Done,
     /*  800126 */   // Label 12383: @800126
     /*  800126 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(800201), // Rule ID 19497 //
     /*  800131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  800180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800199 */     GIR_RootConstrainSelectedInstOperands,
     /*  800200 */     // GIR_Coverage, 19497,
     /*  800200 */     GIR_EraseRootFromParent_Done,
     /*  800201 */   // Label 12384: @800201
     /*  800201 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(800276), // Rule ID 19500 //
     /*  800206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  800255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800274 */     GIR_RootConstrainSelectedInstOperands,
     /*  800275 */     // GIR_Coverage, 19500,
     /*  800275 */     GIR_EraseRootFromParent_Done,
     /*  800276 */   // Label 12385: @800276
     /*  800276 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(800351), // Rule ID 19501 //
     /*  800281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  800330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800349 */     GIR_RootConstrainSelectedInstOperands,
     /*  800350 */     // GIR_Coverage, 19501,
     /*  800350 */     GIR_EraseRootFromParent_Done,
     /*  800351 */   // Label 12386: @800351
     /*  800351 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(800426), // Rule ID 19504 //
     /*  800356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  800405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800424 */     GIR_RootConstrainSelectedInstOperands,
     /*  800425 */     // GIR_Coverage, 19504,
     /*  800425 */     GIR_EraseRootFromParent_Done,
     /*  800426 */   // Label 12387: @800426
     /*  800426 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(800501), // Rule ID 19505 //
     /*  800431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  800480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800499 */     GIR_RootConstrainSelectedInstOperands,
     /*  800500 */     // GIR_Coverage, 19505,
     /*  800500 */     GIR_EraseRootFromParent_Done,
     /*  800501 */   // Label 12388: @800501
     /*  800501 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(800576), // Rule ID 19508 //
     /*  800506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  800555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800574 */     GIR_RootConstrainSelectedInstOperands,
     /*  800575 */     // GIR_Coverage, 19508,
     /*  800575 */     GIR_EraseRootFromParent_Done,
     /*  800576 */   // Label 12389: @800576
     /*  800576 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(800651), // Rule ID 19509 //
     /*  800581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  800630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800649 */     GIR_RootConstrainSelectedInstOperands,
     /*  800650 */     // GIR_Coverage, 19509,
     /*  800650 */     GIR_EraseRootFromParent_Done,
     /*  800651 */   // Label 12390: @800651
     /*  800651 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(800726), // Rule ID 19512 //
     /*  800656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  800705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800724 */     GIR_RootConstrainSelectedInstOperands,
     /*  800725 */     // GIR_Coverage, 19512,
     /*  800725 */     GIR_EraseRootFromParent_Done,
     /*  800726 */   // Label 12391: @800726
     /*  800726 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(800801), // Rule ID 19513 //
     /*  800731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  800780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800799 */     GIR_RootConstrainSelectedInstOperands,
     /*  800800 */     // GIR_Coverage, 19513,
     /*  800800 */     GIR_EraseRootFromParent_Done,
     /*  800801 */   // Label 12392: @800801
     /*  800801 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(800876), // Rule ID 19516 //
     /*  800806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  800855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800874 */     GIR_RootConstrainSelectedInstOperands,
     /*  800875 */     // GIR_Coverage, 19516,
     /*  800875 */     GIR_EraseRootFromParent_Done,
     /*  800876 */   // Label 12393: @800876
     /*  800876 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(800951), // Rule ID 19517 //
     /*  800881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  800930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800949 */     GIR_RootConstrainSelectedInstOperands,
     /*  800950 */     // GIR_Coverage, 19517,
     /*  800950 */     GIR_EraseRootFromParent_Done,
     /*  800951 */   // Label 12394: @800951
     /*  800951 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(801026), // Rule ID 19520 //
     /*  800956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  800964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  800967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  800970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  800973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  801005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801024 */     GIR_RootConstrainSelectedInstOperands,
     /*  801025 */     // GIR_Coverage, 19520,
     /*  801025 */     GIR_EraseRootFromParent_Done,
     /*  801026 */   // Label 12395: @801026
     /*  801026 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(801101), // Rule ID 19521 //
     /*  801031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  801039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  801080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801099 */     GIR_RootConstrainSelectedInstOperands,
     /*  801100 */     // GIR_Coverage, 19521,
     /*  801100 */     GIR_EraseRootFromParent_Done,
     /*  801101 */   // Label 12396: @801101
     /*  801101 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(801176), // Rule ID 19524 //
     /*  801106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  801155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801174 */     GIR_RootConstrainSelectedInstOperands,
     /*  801175 */     // GIR_Coverage, 19524,
     /*  801175 */     GIR_EraseRootFromParent_Done,
     /*  801176 */   // Label 12397: @801176
     /*  801176 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(801251), // Rule ID 19525 //
     /*  801181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  801230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801249 */     GIR_RootConstrainSelectedInstOperands,
     /*  801250 */     // GIR_Coverage, 19525,
     /*  801250 */     GIR_EraseRootFromParent_Done,
     /*  801251 */   // Label 12398: @801251
     /*  801251 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(801326), // Rule ID 19528 //
     /*  801256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  801305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801324 */     GIR_RootConstrainSelectedInstOperands,
     /*  801325 */     // GIR_Coverage, 19528,
     /*  801325 */     GIR_EraseRootFromParent_Done,
     /*  801326 */   // Label 12399: @801326
     /*  801326 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(801401), // Rule ID 19529 //
     /*  801331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  801380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801399 */     GIR_RootConstrainSelectedInstOperands,
     /*  801400 */     // GIR_Coverage, 19529,
     /*  801400 */     GIR_EraseRootFromParent_Done,
     /*  801401 */   // Label 12400: @801401
     /*  801401 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(801476), // Rule ID 19532 //
     /*  801406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  801455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801474 */     GIR_RootConstrainSelectedInstOperands,
     /*  801475 */     // GIR_Coverage, 19532,
     /*  801475 */     GIR_EraseRootFromParent_Done,
     /*  801476 */   // Label 12401: @801476
     /*  801476 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(801551), // Rule ID 19533 //
     /*  801481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  801530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801549 */     GIR_RootConstrainSelectedInstOperands,
     /*  801550 */     // GIR_Coverage, 19533,
     /*  801550 */     GIR_EraseRootFromParent_Done,
     /*  801551 */   // Label 12402: @801551
     /*  801551 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(801626), // Rule ID 19536 //
     /*  801556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  801605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801624 */     GIR_RootConstrainSelectedInstOperands,
     /*  801625 */     // GIR_Coverage, 19536,
     /*  801625 */     GIR_EraseRootFromParent_Done,
     /*  801626 */   // Label 12403: @801626
     /*  801626 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(801701), // Rule ID 19537 //
     /*  801631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  801680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801699 */     GIR_RootConstrainSelectedInstOperands,
     /*  801700 */     // GIR_Coverage, 19537,
     /*  801700 */     GIR_EraseRootFromParent_Done,
     /*  801701 */   // Label 12404: @801701
     /*  801701 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(801776), // Rule ID 19540 //
     /*  801706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  801755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801774 */     GIR_RootConstrainSelectedInstOperands,
     /*  801775 */     // GIR_Coverage, 19540,
     /*  801775 */     GIR_EraseRootFromParent_Done,
     /*  801776 */   // Label 12405: @801776
     /*  801776 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(801851), // Rule ID 19541 //
     /*  801781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  801830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801849 */     GIR_RootConstrainSelectedInstOperands,
     /*  801850 */     // GIR_Coverage, 19541,
     /*  801850 */     GIR_EraseRootFromParent_Done,
     /*  801851 */   // Label 12406: @801851
     /*  801851 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(801926), // Rule ID 19544 //
     /*  801856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  801867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  801870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  801873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  801876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  801905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801924 */     GIR_RootConstrainSelectedInstOperands,
     /*  801925 */     // GIR_Coverage, 19544,
     /*  801925 */     GIR_EraseRootFromParent_Done,
     /*  801926 */   // Label 12407: @801926
     /*  801926 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(802001), // Rule ID 19545 //
     /*  801931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  801942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  801945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  801948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  801951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  801980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801999 */     GIR_RootConstrainSelectedInstOperands,
     /*  802000 */     // GIR_Coverage, 19545,
     /*  802000 */     GIR_EraseRootFromParent_Done,
     /*  802001 */   // Label 12408: @802001
     /*  802001 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(802076), // Rule ID 19548 //
     /*  802006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  802055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802074 */     GIR_RootConstrainSelectedInstOperands,
     /*  802075 */     // GIR_Coverage, 19548,
     /*  802075 */     GIR_EraseRootFromParent_Done,
     /*  802076 */   // Label 12409: @802076
     /*  802076 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(802151), // Rule ID 19549 //
     /*  802081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  802130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802149 */     GIR_RootConstrainSelectedInstOperands,
     /*  802150 */     // GIR_Coverage, 19549,
     /*  802150 */     GIR_EraseRootFromParent_Done,
     /*  802151 */   // Label 12410: @802151
     /*  802151 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(802226), // Rule ID 19552 //
     /*  802156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  802205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802224 */     GIR_RootConstrainSelectedInstOperands,
     /*  802225 */     // GIR_Coverage, 19552,
     /*  802225 */     GIR_EraseRootFromParent_Done,
     /*  802226 */   // Label 12411: @802226
     /*  802226 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(802301), // Rule ID 19553 //
     /*  802231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  802280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802299 */     GIR_RootConstrainSelectedInstOperands,
     /*  802300 */     // GIR_Coverage, 19553,
     /*  802300 */     GIR_EraseRootFromParent_Done,
     /*  802301 */   // Label 12412: @802301
     /*  802301 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(802376), // Rule ID 19556 //
     /*  802306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  802355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802374 */     GIR_RootConstrainSelectedInstOperands,
     /*  802375 */     // GIR_Coverage, 19556,
     /*  802375 */     GIR_EraseRootFromParent_Done,
     /*  802376 */   // Label 12413: @802376
     /*  802376 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(802451), // Rule ID 19557 //
     /*  802381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  802430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802449 */     GIR_RootConstrainSelectedInstOperands,
     /*  802450 */     // GIR_Coverage, 19557,
     /*  802450 */     GIR_EraseRootFromParent_Done,
     /*  802451 */   // Label 12414: @802451
     /*  802451 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(802526), // Rule ID 19560 //
     /*  802456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  802505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802524 */     GIR_RootConstrainSelectedInstOperands,
     /*  802525 */     // GIR_Coverage, 19560,
     /*  802525 */     GIR_EraseRootFromParent_Done,
     /*  802526 */   // Label 12415: @802526
     /*  802526 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(802601), // Rule ID 19561 //
     /*  802531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  802580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802599 */     GIR_RootConstrainSelectedInstOperands,
     /*  802600 */     // GIR_Coverage, 19561,
     /*  802600 */     GIR_EraseRootFromParent_Done,
     /*  802601 */   // Label 12416: @802601
     /*  802601 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(802676), // Rule ID 19564 //
     /*  802606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  802655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802674 */     GIR_RootConstrainSelectedInstOperands,
     /*  802675 */     // GIR_Coverage, 19564,
     /*  802675 */     GIR_EraseRootFromParent_Done,
     /*  802676 */   // Label 12417: @802676
     /*  802676 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(802751), // Rule ID 19565 //
     /*  802681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  802730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802749 */     GIR_RootConstrainSelectedInstOperands,
     /*  802750 */     // GIR_Coverage, 19565,
     /*  802750 */     GIR_EraseRootFromParent_Done,
     /*  802751 */   // Label 12418: @802751
     /*  802751 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(802826), // Rule ID 19568 //
     /*  802756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  802805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802824 */     GIR_RootConstrainSelectedInstOperands,
     /*  802825 */     // GIR_Coverage, 19568,
     /*  802825 */     GIR_EraseRootFromParent_Done,
     /*  802826 */   // Label 12419: @802826
     /*  802826 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(802901), // Rule ID 19569 //
     /*  802831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  802880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802899 */     GIR_RootConstrainSelectedInstOperands,
     /*  802900 */     // GIR_Coverage, 19569,
     /*  802900 */     GIR_EraseRootFromParent_Done,
     /*  802901 */   // Label 12420: @802901
     /*  802901 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(802976), // Rule ID 19572 //
     /*  802906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  802917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  802920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  802923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  802926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  802955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802974 */     GIR_RootConstrainSelectedInstOperands,
     /*  802975 */     // GIR_Coverage, 19572,
     /*  802975 */     GIR_EraseRootFromParent_Done,
     /*  802976 */   // Label 12421: @802976
     /*  802976 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(803051), // Rule ID 19573 //
     /*  802981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  802989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  802992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  802995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  802998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  803030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803049 */     GIR_RootConstrainSelectedInstOperands,
     /*  803050 */     // GIR_Coverage, 19573,
     /*  803050 */     GIR_EraseRootFromParent_Done,
     /*  803051 */   // Label 12422: @803051
     /*  803051 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(803126), // Rule ID 19576 //
     /*  803056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  803105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803124 */     GIR_RootConstrainSelectedInstOperands,
     /*  803125 */     // GIR_Coverage, 19576,
     /*  803125 */     GIR_EraseRootFromParent_Done,
     /*  803126 */   // Label 12423: @803126
     /*  803126 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(803201), // Rule ID 19577 //
     /*  803131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  803180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803199 */     GIR_RootConstrainSelectedInstOperands,
     /*  803200 */     // GIR_Coverage, 19577,
     /*  803200 */     GIR_EraseRootFromParent_Done,
     /*  803201 */   // Label 12424: @803201
     /*  803201 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(803276), // Rule ID 19580 //
     /*  803206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  803255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803274 */     GIR_RootConstrainSelectedInstOperands,
     /*  803275 */     // GIR_Coverage, 19580,
     /*  803275 */     GIR_EraseRootFromParent_Done,
     /*  803276 */   // Label 12425: @803276
     /*  803276 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(803351), // Rule ID 19581 //
     /*  803281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  803330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803349 */     GIR_RootConstrainSelectedInstOperands,
     /*  803350 */     // GIR_Coverage, 19581,
     /*  803350 */     GIR_EraseRootFromParent_Done,
     /*  803351 */   // Label 12426: @803351
     /*  803351 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(803426), // Rule ID 19584 //
     /*  803356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  803405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803424 */     GIR_RootConstrainSelectedInstOperands,
     /*  803425 */     // GIR_Coverage, 19584,
     /*  803425 */     GIR_EraseRootFromParent_Done,
     /*  803426 */   // Label 12427: @803426
     /*  803426 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(803501), // Rule ID 19585 //
     /*  803431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803477 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  803480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803499 */     GIR_RootConstrainSelectedInstOperands,
     /*  803500 */     // GIR_Coverage, 19585,
     /*  803500 */     GIR_EraseRootFromParent_Done,
     /*  803501 */   // Label 12428: @803501
     /*  803501 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(803576), // Rule ID 19588 //
     /*  803506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803552 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  803555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803574 */     GIR_RootConstrainSelectedInstOperands,
     /*  803575 */     // GIR_Coverage, 19588,
     /*  803575 */     GIR_EraseRootFromParent_Done,
     /*  803576 */   // Label 12429: @803576
     /*  803576 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(803651), // Rule ID 19589 //
     /*  803581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803627 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  803630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803649 */     GIR_RootConstrainSelectedInstOperands,
     /*  803650 */     // GIR_Coverage, 19589,
     /*  803650 */     GIR_EraseRootFromParent_Done,
     /*  803651 */   // Label 12430: @803651
     /*  803651 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(803726), // Rule ID 19592 //
     /*  803656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  803705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803724 */     GIR_RootConstrainSelectedInstOperands,
     /*  803725 */     // GIR_Coverage, 19592,
     /*  803725 */     GIR_EraseRootFromParent_Done,
     /*  803726 */   // Label 12431: @803726
     /*  803726 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(803801), // Rule ID 19593 //
     /*  803731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803777 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  803780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803799 */     GIR_RootConstrainSelectedInstOperands,
     /*  803800 */     // GIR_Coverage, 19593,
     /*  803800 */     GIR_EraseRootFromParent_Done,
     /*  803801 */   // Label 12432: @803801
     /*  803801 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(803876), // Rule ID 19596 //
     /*  803806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  803817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  803820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  803823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  803855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803874 */     GIR_RootConstrainSelectedInstOperands,
     /*  803875 */     // GIR_Coverage, 19596,
     /*  803875 */     GIR_EraseRootFromParent_Done,
     /*  803876 */   // Label 12433: @803876
     /*  803876 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(803951), // Rule ID 19597 //
     /*  803881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  803892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  803895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  803898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  803930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803949 */     GIR_RootConstrainSelectedInstOperands,
     /*  803950 */     // GIR_Coverage, 19597,
     /*  803950 */     GIR_EraseRootFromParent_Done,
     /*  803951 */   // Label 12434: @803951
     /*  803951 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(804026), // Rule ID 19600 //
     /*  803956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  803964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  803967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  803970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  803973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804002 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  804005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804024 */     GIR_RootConstrainSelectedInstOperands,
     /*  804025 */     // GIR_Coverage, 19600,
     /*  804025 */     GIR_EraseRootFromParent_Done,
     /*  804026 */   // Label 12435: @804026
     /*  804026 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(804101), // Rule ID 19601 //
     /*  804031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804077 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  804080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804099 */     GIR_RootConstrainSelectedInstOperands,
     /*  804100 */     // GIR_Coverage, 19601,
     /*  804100 */     GIR_EraseRootFromParent_Done,
     /*  804101 */   // Label 12436: @804101
     /*  804101 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(804176), // Rule ID 19604 //
     /*  804106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  804155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804174 */     GIR_RootConstrainSelectedInstOperands,
     /*  804175 */     // GIR_Coverage, 19604,
     /*  804175 */     GIR_EraseRootFromParent_Done,
     /*  804176 */   // Label 12437: @804176
     /*  804176 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(804251), // Rule ID 19605 //
     /*  804181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  804230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804249 */     GIR_RootConstrainSelectedInstOperands,
     /*  804250 */     // GIR_Coverage, 19605,
     /*  804250 */     GIR_EraseRootFromParent_Done,
     /*  804251 */   // Label 12438: @804251
     /*  804251 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(804326), // Rule ID 19608 //
     /*  804256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  804305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804324 */     GIR_RootConstrainSelectedInstOperands,
     /*  804325 */     // GIR_Coverage, 19608,
     /*  804325 */     GIR_EraseRootFromParent_Done,
     /*  804326 */   // Label 12439: @804326
     /*  804326 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(804401), // Rule ID 19609 //
     /*  804331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  804380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804399 */     GIR_RootConstrainSelectedInstOperands,
     /*  804400 */     // GIR_Coverage, 19609,
     /*  804400 */     GIR_EraseRootFromParent_Done,
     /*  804401 */   // Label 12440: @804401
     /*  804401 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(804476), // Rule ID 19612 //
     /*  804406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  804455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804474 */     GIR_RootConstrainSelectedInstOperands,
     /*  804475 */     // GIR_Coverage, 19612,
     /*  804475 */     GIR_EraseRootFromParent_Done,
     /*  804476 */   // Label 12441: @804476
     /*  804476 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(804551), // Rule ID 19613 //
     /*  804481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  804530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804549 */     GIR_RootConstrainSelectedInstOperands,
     /*  804550 */     // GIR_Coverage, 19613,
     /*  804550 */     GIR_EraseRootFromParent_Done,
     /*  804551 */   // Label 12442: @804551
     /*  804551 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(804626), // Rule ID 19616 //
     /*  804556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  804605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804624 */     GIR_RootConstrainSelectedInstOperands,
     /*  804625 */     // GIR_Coverage, 19616,
     /*  804625 */     GIR_EraseRootFromParent_Done,
     /*  804626 */   // Label 12443: @804626
     /*  804626 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(804701), // Rule ID 19617 //
     /*  804631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  804680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804699 */     GIR_RootConstrainSelectedInstOperands,
     /*  804700 */     // GIR_Coverage, 19617,
     /*  804700 */     GIR_EraseRootFromParent_Done,
     /*  804701 */   // Label 12444: @804701
     /*  804701 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(804776), // Rule ID 19620 //
     /*  804706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  804755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804774 */     GIR_RootConstrainSelectedInstOperands,
     /*  804775 */     // GIR_Coverage, 19620,
     /*  804775 */     GIR_EraseRootFromParent_Done,
     /*  804776 */   // Label 12445: @804776
     /*  804776 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(804851), // Rule ID 19621 //
     /*  804781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804827 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  804830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804849 */     GIR_RootConstrainSelectedInstOperands,
     /*  804850 */     // GIR_Coverage, 19621,
     /*  804850 */     GIR_EraseRootFromParent_Done,
     /*  804851 */   // Label 12446: @804851
     /*  804851 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(804926), // Rule ID 19624 //
     /*  804856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  804867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  804870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  804873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804902 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  804905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804924 */     GIR_RootConstrainSelectedInstOperands,
     /*  804925 */     // GIR_Coverage, 19624,
     /*  804925 */     GIR_EraseRootFromParent_Done,
     /*  804926 */   // Label 12447: @804926
     /*  804926 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(805001), // Rule ID 19625 //
     /*  804931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  804939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  804942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  804945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  804948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804977 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  804980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804999 */     GIR_RootConstrainSelectedInstOperands,
     /*  805000 */     // GIR_Coverage, 19625,
     /*  805000 */     GIR_EraseRootFromParent_Done,
     /*  805001 */   // Label 12448: @805001
     /*  805001 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(805076), // Rule ID 19628 //
     /*  805006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805052 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  805055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805074 */     GIR_RootConstrainSelectedInstOperands,
     /*  805075 */     // GIR_Coverage, 19628,
     /*  805075 */     GIR_EraseRootFromParent_Done,
     /*  805076 */   // Label 12449: @805076
     /*  805076 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(805151), // Rule ID 19629 //
     /*  805081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805127 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  805130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805149 */     GIR_RootConstrainSelectedInstOperands,
     /*  805150 */     // GIR_Coverage, 19629,
     /*  805150 */     GIR_EraseRootFromParent_Done,
     /*  805151 */   // Label 12450: @805151
     /*  805151 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(805226), // Rule ID 19632 //
     /*  805156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  805205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805224 */     GIR_RootConstrainSelectedInstOperands,
     /*  805225 */     // GIR_Coverage, 19632,
     /*  805225 */     GIR_EraseRootFromParent_Done,
     /*  805226 */   // Label 12451: @805226
     /*  805226 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(805301), // Rule ID 19633 //
     /*  805231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805277 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  805280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805299 */     GIR_RootConstrainSelectedInstOperands,
     /*  805300 */     // GIR_Coverage, 19633,
     /*  805300 */     GIR_EraseRootFromParent_Done,
     /*  805301 */   // Label 12452: @805301
     /*  805301 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(805376), // Rule ID 19636 //
     /*  805306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  805355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805374 */     GIR_RootConstrainSelectedInstOperands,
     /*  805375 */     // GIR_Coverage, 19636,
     /*  805375 */     GIR_EraseRootFromParent_Done,
     /*  805376 */   // Label 12453: @805376
     /*  805376 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(805451), // Rule ID 19637 //
     /*  805381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805427 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  805430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805449 */     GIR_RootConstrainSelectedInstOperands,
     /*  805450 */     // GIR_Coverage, 19637,
     /*  805450 */     GIR_EraseRootFromParent_Done,
     /*  805451 */   // Label 12454: @805451
     /*  805451 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(805526), // Rule ID 19640 //
     /*  805456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  805505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805524 */     GIR_RootConstrainSelectedInstOperands,
     /*  805525 */     // GIR_Coverage, 19640,
     /*  805525 */     GIR_EraseRootFromParent_Done,
     /*  805526 */   // Label 12455: @805526
     /*  805526 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(805601), // Rule ID 19641 //
     /*  805531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  805539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805577 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  805580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805599 */     GIR_RootConstrainSelectedInstOperands,
     /*  805600 */     // GIR_Coverage, 19641,
     /*  805600 */     GIR_EraseRootFromParent_Done,
     /*  805601 */   // Label 12456: @805601
     /*  805601 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(805676), // Rule ID 19644 //
     /*  805606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  805617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  805620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  805623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  805626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  805655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805674 */     GIR_RootConstrainSelectedInstOperands,
     /*  805675 */     // GIR_Coverage, 19644,
     /*  805675 */     GIR_EraseRootFromParent_Done,
     /*  805676 */   // Label 12457: @805676
     /*  805676 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(805751), // Rule ID 19645 //
     /*  805681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  805692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  805695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  805698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  805701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  805730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805749 */     GIR_RootConstrainSelectedInstOperands,
     /*  805750 */     // GIR_Coverage, 19645,
     /*  805750 */     GIR_EraseRootFromParent_Done,
     /*  805751 */   // Label 12458: @805751
     /*  805751 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(805826), // Rule ID 19648 //
     /*  805756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  805767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  805770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  805773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  805776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  805805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805824 */     GIR_RootConstrainSelectedInstOperands,
     /*  805825 */     // GIR_Coverage, 19648,
     /*  805825 */     GIR_EraseRootFromParent_Done,
     /*  805826 */   // Label 12459: @805826
     /*  805826 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(805901), // Rule ID 19649 //
     /*  805831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  805842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  805845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  805848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  805851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  805880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805899 */     GIR_RootConstrainSelectedInstOperands,
     /*  805900 */     // GIR_Coverage, 19649,
     /*  805900 */     GIR_EraseRootFromParent_Done,
     /*  805901 */   // Label 12460: @805901
     /*  805901 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(805976), // Rule ID 19652 //
     /*  805906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  805917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  805920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  805923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  805926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  805955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805974 */     GIR_RootConstrainSelectedInstOperands,
     /*  805975 */     // GIR_Coverage, 19652,
     /*  805975 */     GIR_EraseRootFromParent_Done,
     /*  805976 */   // Label 12461: @805976
     /*  805976 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(806051), // Rule ID 19653 //
     /*  805981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  805992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  805995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  805998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  806001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  806030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806049 */     GIR_RootConstrainSelectedInstOperands,
     /*  806050 */     // GIR_Coverage, 19653,
     /*  806050 */     GIR_EraseRootFromParent_Done,
     /*  806051 */   // Label 12462: @806051
     /*  806051 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(806126), // Rule ID 19656 //
     /*  806056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  806105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806124 */     GIR_RootConstrainSelectedInstOperands,
     /*  806125 */     // GIR_Coverage, 19656,
     /*  806125 */     GIR_EraseRootFromParent_Done,
     /*  806126 */   // Label 12463: @806126
     /*  806126 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(806201), // Rule ID 19657 //
     /*  806131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  806180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806199 */     GIR_RootConstrainSelectedInstOperands,
     /*  806200 */     // GIR_Coverage, 19657,
     /*  806200 */     GIR_EraseRootFromParent_Done,
     /*  806201 */   // Label 12464: @806201
     /*  806201 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(806276), // Rule ID 19660 //
     /*  806206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  806255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806274 */     GIR_RootConstrainSelectedInstOperands,
     /*  806275 */     // GIR_Coverage, 19660,
     /*  806275 */     GIR_EraseRootFromParent_Done,
     /*  806276 */   // Label 12465: @806276
     /*  806276 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(806351), // Rule ID 19661 //
     /*  806281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  806284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  806330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806349 */     GIR_RootConstrainSelectedInstOperands,
     /*  806350 */     // GIR_Coverage, 19661,
     /*  806350 */     GIR_EraseRootFromParent_Done,
     /*  806351 */   // Label 12466: @806351
     /*  806351 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(806426), // Rule ID 19664 //
     /*  806356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  806367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  806370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  806373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  806376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  806405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806424 */     GIR_RootConstrainSelectedInstOperands,
     /*  806425 */     // GIR_Coverage, 19664,
     /*  806425 */     GIR_EraseRootFromParent_Done,
     /*  806426 */   // Label 12467: @806426
     /*  806426 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(806501), // Rule ID 19665 //
     /*  806431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  806442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  806445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  806448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  806451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  806480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806499 */     GIR_RootConstrainSelectedInstOperands,
     /*  806500 */     // GIR_Coverage, 19665,
     /*  806500 */     GIR_EraseRootFromParent_Done,
     /*  806501 */   // Label 12468: @806501
     /*  806501 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(806576), // Rule ID 19668 //
     /*  806506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  806555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806574 */     GIR_RootConstrainSelectedInstOperands,
     /*  806575 */     // GIR_Coverage, 19668,
     /*  806575 */     GIR_EraseRootFromParent_Done,
     /*  806576 */   // Label 12469: @806576
     /*  806576 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(806651), // Rule ID 19669 //
     /*  806581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  806592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  806595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  806598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  806601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  806630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806649 */     GIR_RootConstrainSelectedInstOperands,
     /*  806650 */     // GIR_Coverage, 19669,
     /*  806650 */     GIR_EraseRootFromParent_Done,
     /*  806651 */   // Label 12470: @806651
     /*  806651 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(806726), // Rule ID 19672 //
     /*  806656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  806705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806724 */     GIR_RootConstrainSelectedInstOperands,
     /*  806725 */     // GIR_Coverage, 19672,
     /*  806725 */     GIR_EraseRootFromParent_Done,
     /*  806726 */   // Label 12471: @806726
     /*  806726 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(806801), // Rule ID 19673 //
     /*  806731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  806742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  806745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  806748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  806751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  806780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806799 */     GIR_RootConstrainSelectedInstOperands,
     /*  806800 */     // GIR_Coverage, 19673,
     /*  806800 */     GIR_EraseRootFromParent_Done,
     /*  806801 */   // Label 12472: @806801
     /*  806801 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(806876), // Rule ID 19676 //
     /*  806806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  806809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  806855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806874 */     GIR_RootConstrainSelectedInstOperands,
     /*  806875 */     // GIR_Coverage, 19676,
     /*  806875 */     GIR_EraseRootFromParent_Done,
     /*  806876 */   // Label 12473: @806876
     /*  806876 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(806951), // Rule ID 19677 //
     /*  806881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  806884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  806892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  806895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  806898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  806901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  806930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806949 */     GIR_RootConstrainSelectedInstOperands,
     /*  806950 */     // GIR_Coverage, 19677,
     /*  806950 */     GIR_EraseRootFromParent_Done,
     /*  806951 */   // Label 12474: @806951
     /*  806951 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(807026), // Rule ID 19680 //
     /*  806956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  806959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  806967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  806970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  806973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  806976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  806995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  807005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807024 */     GIR_RootConstrainSelectedInstOperands,
     /*  807025 */     // GIR_Coverage, 19680,
     /*  807025 */     GIR_EraseRootFromParent_Done,
     /*  807026 */   // Label 12475: @807026
     /*  807026 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(807101), // Rule ID 19681 //
     /*  807031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  807042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  807045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  807048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  807051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  807080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807099 */     GIR_RootConstrainSelectedInstOperands,
     /*  807100 */     // GIR_Coverage, 19681,
     /*  807100 */     GIR_EraseRootFromParent_Done,
     /*  807101 */   // Label 12476: @807101
     /*  807101 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(807176), // Rule ID 19684 //
     /*  807106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  807109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  807117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  807120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  807123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  807126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  807155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807174 */     GIR_RootConstrainSelectedInstOperands,
     /*  807175 */     // GIR_Coverage, 19684,
     /*  807175 */     GIR_EraseRootFromParent_Done,
     /*  807176 */   // Label 12477: @807176
     /*  807176 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(807251), // Rule ID 19685 //
     /*  807181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  807192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  807195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  807198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  807201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  807230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807249 */     GIR_RootConstrainSelectedInstOperands,
     /*  807250 */     // GIR_Coverage, 19685,
     /*  807250 */     GIR_EraseRootFromParent_Done,
     /*  807251 */   // Label 12478: @807251
     /*  807251 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(807326), // Rule ID 19688 //
     /*  807256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  807259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  807267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  807270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  807273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  807276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  807305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807324 */     GIR_RootConstrainSelectedInstOperands,
     /*  807325 */     // GIR_Coverage, 19688,
     /*  807325 */     GIR_EraseRootFromParent_Done,
     /*  807326 */   // Label 12479: @807326
     /*  807326 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(807401), // Rule ID 19689 //
     /*  807331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  807334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  807342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  807345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  807348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  807351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  807380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807399 */     GIR_RootConstrainSelectedInstOperands,
     /*  807400 */     // GIR_Coverage, 19689,
     /*  807400 */     GIR_EraseRootFromParent_Done,
     /*  807401 */   // Label 12480: @807401
     /*  807401 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(807476), // Rule ID 19692 //
     /*  807406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  807417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  807420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  807423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  807426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  807455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807474 */     GIR_RootConstrainSelectedInstOperands,
     /*  807475 */     // GIR_Coverage, 19692,
     /*  807475 */     GIR_EraseRootFromParent_Done,
     /*  807476 */   // Label 12481: @807476
     /*  807476 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(807551), // Rule ID 19693 //
     /*  807481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  807492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  807495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  807498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  807501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  807530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807549 */     GIR_RootConstrainSelectedInstOperands,
     /*  807550 */     // GIR_Coverage, 19693,
     /*  807550 */     GIR_EraseRootFromParent_Done,
     /*  807551 */   // Label 12482: @807551
     /*  807551 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(807626), // Rule ID 19696 //
     /*  807556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  807605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807624 */     GIR_RootConstrainSelectedInstOperands,
     /*  807625 */     // GIR_Coverage, 19696,
     /*  807625 */     GIR_EraseRootFromParent_Done,
     /*  807626 */   // Label 12483: @807626
     /*  807626 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(807701), // Rule ID 19697 //
     /*  807631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  807642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  807645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  807648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  807651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  807680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807699 */     GIR_RootConstrainSelectedInstOperands,
     /*  807700 */     // GIR_Coverage, 19697,
     /*  807700 */     GIR_EraseRootFromParent_Done,
     /*  807701 */   // Label 12484: @807701
     /*  807701 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(807776), // Rule ID 19700 //
     /*  807706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  807709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  807755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807774 */     GIR_RootConstrainSelectedInstOperands,
     /*  807775 */     // GIR_Coverage, 19700,
     /*  807775 */     GIR_EraseRootFromParent_Done,
     /*  807776 */   // Label 12485: @807776
     /*  807776 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(807851), // Rule ID 19701 //
     /*  807781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  807784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  807792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  807795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  807798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  807801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  807830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807849 */     GIR_RootConstrainSelectedInstOperands,
     /*  807850 */     // GIR_Coverage, 19701,
     /*  807850 */     GIR_EraseRootFromParent_Done,
     /*  807851 */   // Label 12486: @807851
     /*  807851 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(807926), // Rule ID 19704 //
     /*  807856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  807859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  807876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  807895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  807905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807924 */     GIR_RootConstrainSelectedInstOperands,
     /*  807925 */     // GIR_Coverage, 19704,
     /*  807925 */     GIR_EraseRootFromParent_Done,
     /*  807926 */   // Label 12487: @807926
     /*  807926 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(808001), // Rule ID 19705 //
     /*  807931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  807934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  807939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  807942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  807945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  807948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  807951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  807970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  807980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  807984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807999 */     GIR_RootConstrainSelectedInstOperands,
     /*  808000 */     // GIR_Coverage, 19705,
     /*  808000 */     GIR_EraseRootFromParent_Done,
     /*  808001 */   // Label 12488: @808001
     /*  808001 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(808076), // Rule ID 19708 //
     /*  808006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  808017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  808020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  808023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  808055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808074 */     GIR_RootConstrainSelectedInstOperands,
     /*  808075 */     // GIR_Coverage, 19708,
     /*  808075 */     GIR_EraseRootFromParent_Done,
     /*  808076 */   // Label 12489: @808076
     /*  808076 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(808151), // Rule ID 19709 //
     /*  808081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  808092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  808095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  808098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  808130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808149 */     GIR_RootConstrainSelectedInstOperands,
     /*  808150 */     // GIR_Coverage, 19709,
     /*  808150 */     GIR_EraseRootFromParent_Done,
     /*  808151 */   // Label 12490: @808151
     /*  808151 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(808226), // Rule ID 19712 //
     /*  808156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  808159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  808205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808224 */     GIR_RootConstrainSelectedInstOperands,
     /*  808225 */     // GIR_Coverage, 19712,
     /*  808225 */     GIR_EraseRootFromParent_Done,
     /*  808226 */   // Label 12491: @808226
     /*  808226 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(808301), // Rule ID 19713 //
     /*  808231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  808234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  808242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  808245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  808248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  808280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808299 */     GIR_RootConstrainSelectedInstOperands,
     /*  808300 */     // GIR_Coverage, 19713,
     /*  808300 */     GIR_EraseRootFromParent_Done,
     /*  808301 */   // Label 12492: @808301
     /*  808301 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(808376), // Rule ID 19716 //
     /*  808306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  808355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808374 */     GIR_RootConstrainSelectedInstOperands,
     /*  808375 */     // GIR_Coverage, 19716,
     /*  808375 */     GIR_EraseRootFromParent_Done,
     /*  808376 */   // Label 12493: @808376
     /*  808376 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(808451), // Rule ID 19717 //
     /*  808381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  808398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  808430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808449 */     GIR_RootConstrainSelectedInstOperands,
     /*  808450 */     // GIR_Coverage, 19717,
     /*  808450 */     GIR_EraseRootFromParent_Done,
     /*  808451 */   // Label 12494: @808451
     /*  808451 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(808526), // Rule ID 19720 //
     /*  808456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  808459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  808505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808524 */     GIR_RootConstrainSelectedInstOperands,
     /*  808525 */     // GIR_Coverage, 19720,
     /*  808525 */     GIR_EraseRootFromParent_Done,
     /*  808526 */   // Label 12495: @808526
     /*  808526 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(808601), // Rule ID 19721 //
     /*  808531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  808534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  808548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  808551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  808570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  808580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808599 */     GIR_RootConstrainSelectedInstOperands,
     /*  808600 */     // GIR_Coverage, 19721,
     /*  808600 */     GIR_EraseRootFromParent_Done,
     /*  808601 */   // Label 12496: @808601
     /*  808601 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(808676), // Rule ID 19724 //
     /*  808606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  808609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  808645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  808655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808674 */     GIR_RootConstrainSelectedInstOperands,
     /*  808675 */     // GIR_Coverage, 19724,
     /*  808675 */     GIR_EraseRootFromParent_Done,
     /*  808676 */   // Label 12497: @808676
     /*  808676 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(808751), // Rule ID 19725 //
     /*  808681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  808684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  808698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  808701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  808720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  808730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808749 */     GIR_RootConstrainSelectedInstOperands,
     /*  808750 */     // GIR_Coverage, 19725,
     /*  808750 */     GIR_EraseRootFromParent_Done,
     /*  808751 */   // Label 12498: @808751
     /*  808751 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(808826), // Rule ID 19728 //
     /*  808756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  808767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  808770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  808805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808824 */     GIR_RootConstrainSelectedInstOperands,
     /*  808825 */     // GIR_Coverage, 19728,
     /*  808825 */     GIR_EraseRootFromParent_Done,
     /*  808826 */   // Label 12499: @808826
     /*  808826 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(808901), // Rule ID 19729 //
     /*  808831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  808842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  808845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  808880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808899 */     GIR_RootConstrainSelectedInstOperands,
     /*  808900 */     // GIR_Coverage, 19729,
     /*  808900 */     GIR_EraseRootFromParent_Done,
     /*  808901 */   // Label 12500: @808901
     /*  808901 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(808976), // Rule ID 19732 //
     /*  808906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  808909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  808917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  808920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  808926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  808945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  808955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  808959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808974 */     GIR_RootConstrainSelectedInstOperands,
     /*  808975 */     // GIR_Coverage, 19732,
     /*  808975 */     GIR_EraseRootFromParent_Done,
     /*  808976 */   // Label 12501: @808976
     /*  808976 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(809051), // Rule ID 19733 //
     /*  808981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  808984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  808989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  808992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  808995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  809030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809049 */     GIR_RootConstrainSelectedInstOperands,
     /*  809050 */     // GIR_Coverage, 19733,
     /*  809050 */     GIR_EraseRootFromParent_Done,
     /*  809051 */   // Label 12502: @809051
     /*  809051 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(809126), // Rule ID 19736 //
     /*  809056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  809059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  809105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809124 */     GIR_RootConstrainSelectedInstOperands,
     /*  809125 */     // GIR_Coverage, 19736,
     /*  809125 */     GIR_EraseRootFromParent_Done,
     /*  809126 */   // Label 12503: @809126
     /*  809126 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(809201), // Rule ID 19737 //
     /*  809131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  809134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  809142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  809145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  809148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  809151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  809170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  809180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809199 */     GIR_RootConstrainSelectedInstOperands,
     /*  809200 */     // GIR_Coverage, 19737,
     /*  809200 */     GIR_EraseRootFromParent_Done,
     /*  809201 */   // Label 12504: @809201
     /*  809201 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(809276), // Rule ID 19740 //
     /*  809206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  809255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809274 */     GIR_RootConstrainSelectedInstOperands,
     /*  809275 */     // GIR_Coverage, 19740,
     /*  809275 */     GIR_EraseRootFromParent_Done,
     /*  809276 */   // Label 12505: @809276
     /*  809276 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(809351), // Rule ID 19741 //
     /*  809281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  809292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  809295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  809298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  809330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809349 */     GIR_RootConstrainSelectedInstOperands,
     /*  809350 */     // GIR_Coverage, 19741,
     /*  809350 */     GIR_EraseRootFromParent_Done,
     /*  809351 */   // Label 12506: @809351
     /*  809351 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(809426), // Rule ID 19744 //
     /*  809356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  809405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809424 */     GIR_RootConstrainSelectedInstOperands,
     /*  809425 */     // GIR_Coverage, 19744,
     /*  809425 */     GIR_EraseRootFromParent_Done,
     /*  809426 */   // Label 12507: @809426
     /*  809426 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(809501), // Rule ID 19745 //
     /*  809431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  809442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  809445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  809448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  809480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809499 */     GIR_RootConstrainSelectedInstOperands,
     /*  809500 */     // GIR_Coverage, 19745,
     /*  809500 */     GIR_EraseRootFromParent_Done,
     /*  809501 */   // Label 12508: @809501
     /*  809501 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(809576), // Rule ID 19748 //
     /*  809506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  809509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  809517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  809520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  809555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809574 */     GIR_RootConstrainSelectedInstOperands,
     /*  809575 */     // GIR_Coverage, 19748,
     /*  809575 */     GIR_EraseRootFromParent_Done,
     /*  809576 */   // Label 12509: @809576
     /*  809576 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(809651), // Rule ID 19749 //
     /*  809581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  809584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  809592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  809595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  809598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  809601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  809620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  809630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809649 */     GIR_RootConstrainSelectedInstOperands,
     /*  809650 */     // GIR_Coverage, 19749,
     /*  809650 */     GIR_EraseRootFromParent_Done,
     /*  809651 */   // Label 12510: @809651
     /*  809651 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(809726), // Rule ID 19752 //
     /*  809656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  809667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  809670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  809705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809724 */     GIR_RootConstrainSelectedInstOperands,
     /*  809725 */     // GIR_Coverage, 19752,
     /*  809725 */     GIR_EraseRootFromParent_Done,
     /*  809726 */   // Label 12511: @809726
     /*  809726 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(809801), // Rule ID 19753 //
     /*  809731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  809734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  809742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  809745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  809780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809799 */     GIR_RootConstrainSelectedInstOperands,
     /*  809800 */     // GIR_Coverage, 19753,
     /*  809800 */     GIR_EraseRootFromParent_Done,
     /*  809801 */   // Label 12512: @809801
     /*  809801 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(809876), // Rule ID 19756 //
     /*  809806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  809817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  809820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  809855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809874 */     GIR_RootConstrainSelectedInstOperands,
     /*  809875 */     // GIR_Coverage, 19756,
     /*  809875 */     GIR_EraseRootFromParent_Done,
     /*  809876 */   // Label 12513: @809876
     /*  809876 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(809951), // Rule ID 19757 //
     /*  809881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  809884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  809892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  809895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  809930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  809934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809949 */     GIR_RootConstrainSelectedInstOperands,
     /*  809950 */     // GIR_Coverage, 19757,
     /*  809950 */     GIR_EraseRootFromParent_Done,
     /*  809951 */   // Label 12514: @809951
     /*  809951 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(810026), // Rule ID 19760 //
     /*  809956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  809959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  809964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  809967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  809970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  809976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  809995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  810005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810024 */     GIR_RootConstrainSelectedInstOperands,
     /*  810025 */     // GIR_Coverage, 19760,
     /*  810025 */     GIR_EraseRootFromParent_Done,
     /*  810026 */   // Label 12515: @810026
     /*  810026 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(810101), // Rule ID 19761 //
     /*  810031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  810034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  810039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  810042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  810045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  810048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  810051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  810070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  810080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  810084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810099 */     GIR_RootConstrainSelectedInstOperands,
     /*  810100 */     // GIR_Coverage, 19761,
     /*  810100 */     GIR_EraseRootFromParent_Done,
     /*  810101 */   // Label 12516: @810101
     /*  810101 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(810176), // Rule ID 21978 //
     /*  810106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  810155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810174 */     GIR_RootConstrainSelectedInstOperands,
     /*  810175 */     // GIR_Coverage, 21978,
     /*  810175 */     GIR_EraseRootFromParent_Done,
     /*  810176 */   // Label 12517: @810176
     /*  810176 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(810251), // Rule ID 21979 //
     /*  810181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  810198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  810230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810249 */     GIR_RootConstrainSelectedInstOperands,
     /*  810250 */     // GIR_Coverage, 21979,
     /*  810250 */     GIR_EraseRootFromParent_Done,
     /*  810251 */   // Label 12518: @810251
     /*  810251 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(810326), // Rule ID 21982 //
     /*  810256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  810305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810324 */     GIR_RootConstrainSelectedInstOperands,
     /*  810325 */     // GIR_Coverage, 21982,
     /*  810325 */     GIR_EraseRootFromParent_Done,
     /*  810326 */   // Label 12519: @810326
     /*  810326 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(810401), // Rule ID 21983 //
     /*  810331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  810348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  810380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810399 */     GIR_RootConstrainSelectedInstOperands,
     /*  810400 */     // GIR_Coverage, 21983,
     /*  810400 */     GIR_EraseRootFromParent_Done,
     /*  810401 */   // Label 12520: @810401
     /*  810401 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(810476), // Rule ID 21986 //
     /*  810406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  810455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810474 */     GIR_RootConstrainSelectedInstOperands,
     /*  810475 */     // GIR_Coverage, 21986,
     /*  810475 */     GIR_EraseRootFromParent_Done,
     /*  810476 */   // Label 12521: @810476
     /*  810476 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(810551), // Rule ID 21987 //
     /*  810481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  810498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  810530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810549 */     GIR_RootConstrainSelectedInstOperands,
     /*  810550 */     // GIR_Coverage, 21987,
     /*  810550 */     GIR_EraseRootFromParent_Done,
     /*  810551 */   // Label 12522: @810551
     /*  810551 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(810626), // Rule ID 21990 //
     /*  810556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  810605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810624 */     GIR_RootConstrainSelectedInstOperands,
     /*  810625 */     // GIR_Coverage, 21990,
     /*  810625 */     GIR_EraseRootFromParent_Done,
     /*  810626 */   // Label 12523: @810626
     /*  810626 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(810701), // Rule ID 21991 //
     /*  810631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  810680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810699 */     GIR_RootConstrainSelectedInstOperands,
     /*  810700 */     // GIR_Coverage, 21991,
     /*  810700 */     GIR_EraseRootFromParent_Done,
     /*  810701 */   // Label 12524: @810701
     /*  810701 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(810776), // Rule ID 21994 //
     /*  810706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  810755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810774 */     GIR_RootConstrainSelectedInstOperands,
     /*  810775 */     // GIR_Coverage, 21994,
     /*  810775 */     GIR_EraseRootFromParent_Done,
     /*  810776 */   // Label 12525: @810776
     /*  810776 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(810851), // Rule ID 21995 //
     /*  810781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  810830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810849 */     GIR_RootConstrainSelectedInstOperands,
     /*  810850 */     // GIR_Coverage, 21995,
     /*  810850 */     GIR_EraseRootFromParent_Done,
     /*  810851 */   // Label 12526: @810851
     /*  810851 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(810926), // Rule ID 21998 //
     /*  810856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  810905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810924 */     GIR_RootConstrainSelectedInstOperands,
     /*  810925 */     // GIR_Coverage, 21998,
     /*  810925 */     GIR_EraseRootFromParent_Done,
     /*  810926 */   // Label 12527: @810926
     /*  810926 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(811001), // Rule ID 21999 //
     /*  810931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  810939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  810980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810999 */     GIR_RootConstrainSelectedInstOperands,
     /*  811000 */     // GIR_Coverage, 21999,
     /*  811000 */     GIR_EraseRootFromParent_Done,
     /*  811001 */   // Label 12528: @811001
     /*  811001 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(811076), // Rule ID 22002 //
     /*  811006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  811055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811074 */     GIR_RootConstrainSelectedInstOperands,
     /*  811075 */     // GIR_Coverage, 22002,
     /*  811075 */     GIR_EraseRootFromParent_Done,
     /*  811076 */   // Label 12529: @811076
     /*  811076 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(811151), // Rule ID 22003 //
     /*  811081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  811098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  811130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811149 */     GIR_RootConstrainSelectedInstOperands,
     /*  811150 */     // GIR_Coverage, 22003,
     /*  811150 */     GIR_EraseRootFromParent_Done,
     /*  811151 */   // Label 12530: @811151
     /*  811151 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(811226), // Rule ID 22006 //
     /*  811156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  811205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811224 */     GIR_RootConstrainSelectedInstOperands,
     /*  811225 */     // GIR_Coverage, 22006,
     /*  811225 */     GIR_EraseRootFromParent_Done,
     /*  811226 */   // Label 12531: @811226
     /*  811226 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(811301), // Rule ID 22007 //
     /*  811231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  811248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  811280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811299 */     GIR_RootConstrainSelectedInstOperands,
     /*  811300 */     // GIR_Coverage, 22007,
     /*  811300 */     GIR_EraseRootFromParent_Done,
     /*  811301 */   // Label 12532: @811301
     /*  811301 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(811376), // Rule ID 22010 //
     /*  811306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  811355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811374 */     GIR_RootConstrainSelectedInstOperands,
     /*  811375 */     // GIR_Coverage, 22010,
     /*  811375 */     GIR_EraseRootFromParent_Done,
     /*  811376 */   // Label 12533: @811376
     /*  811376 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(811451), // Rule ID 22011 //
     /*  811381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  811398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  811427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  811430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811449 */     GIR_RootConstrainSelectedInstOperands,
     /*  811450 */     // GIR_Coverage, 22011,
     /*  811450 */     GIR_EraseRootFromParent_Done,
     /*  811451 */   // Label 12534: @811451
     /*  811451 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(811526), // Rule ID 22014 //
     /*  811456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  811505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811524 */     GIR_RootConstrainSelectedInstOperands,
     /*  811525 */     // GIR_Coverage, 22014,
     /*  811525 */     GIR_EraseRootFromParent_Done,
     /*  811526 */   // Label 12535: @811526
     /*  811526 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(811601), // Rule ID 22015 //
     /*  811531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  811580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811599 */     GIR_RootConstrainSelectedInstOperands,
     /*  811600 */     // GIR_Coverage, 22015,
     /*  811600 */     GIR_EraseRootFromParent_Done,
     /*  811601 */   // Label 12536: @811601
     /*  811601 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(811676), // Rule ID 22018 //
     /*  811606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  811655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811674 */     GIR_RootConstrainSelectedInstOperands,
     /*  811675 */     // GIR_Coverage, 22018,
     /*  811675 */     GIR_EraseRootFromParent_Done,
     /*  811676 */   // Label 12537: @811676
     /*  811676 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(811751), // Rule ID 22019 //
     /*  811681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  811730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811749 */     GIR_RootConstrainSelectedInstOperands,
     /*  811750 */     // GIR_Coverage, 22019,
     /*  811750 */     GIR_EraseRootFromParent_Done,
     /*  811751 */   // Label 12538: @811751
     /*  811751 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(811826), // Rule ID 22022 //
     /*  811756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  811805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811824 */     GIR_RootConstrainSelectedInstOperands,
     /*  811825 */     // GIR_Coverage, 22022,
     /*  811825 */     GIR_EraseRootFromParent_Done,
     /*  811826 */   // Label 12539: @811826
     /*  811826 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(811901), // Rule ID 22023 //
     /*  811831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  811880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811899 */     GIR_RootConstrainSelectedInstOperands,
     /*  811900 */     // GIR_Coverage, 22023,
     /*  811900 */     GIR_EraseRootFromParent_Done,
     /*  811901 */   // Label 12540: @811901
     /*  811901 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(811976), // Rule ID 22026 //
     /*  811906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  811955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811974 */     GIR_RootConstrainSelectedInstOperands,
     /*  811975 */     // GIR_Coverage, 22026,
     /*  811975 */     GIR_EraseRootFromParent_Done,
     /*  811976 */   // Label 12541: @811976
     /*  811976 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(812051), // Rule ID 22027 //
     /*  811981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  811989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  812030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812049 */     GIR_RootConstrainSelectedInstOperands,
     /*  812050 */     // GIR_Coverage, 22027,
     /*  812050 */     GIR_EraseRootFromParent_Done,
     /*  812051 */   // Label 12542: @812051
     /*  812051 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(812126), // Rule ID 22030 //
     /*  812056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  812105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812124 */     GIR_RootConstrainSelectedInstOperands,
     /*  812125 */     // GIR_Coverage, 22030,
     /*  812125 */     GIR_EraseRootFromParent_Done,
     /*  812126 */   // Label 12543: @812126
     /*  812126 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(812201), // Rule ID 22031 //
     /*  812131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  812148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  812180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812199 */     GIR_RootConstrainSelectedInstOperands,
     /*  812200 */     // GIR_Coverage, 22031,
     /*  812200 */     GIR_EraseRootFromParent_Done,
     /*  812201 */   // Label 12544: @812201
     /*  812201 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(812276), // Rule ID 22034 //
     /*  812206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  812255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812274 */     GIR_RootConstrainSelectedInstOperands,
     /*  812275 */     // GIR_Coverage, 22034,
     /*  812275 */     GIR_EraseRootFromParent_Done,
     /*  812276 */   // Label 12545: @812276
     /*  812276 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(812351), // Rule ID 22035 //
     /*  812281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  812298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  812330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812349 */     GIR_RootConstrainSelectedInstOperands,
     /*  812350 */     // GIR_Coverage, 22035,
     /*  812350 */     GIR_EraseRootFromParent_Done,
     /*  812351 */   // Label 12546: @812351
     /*  812351 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(812426), // Rule ID 22038 //
     /*  812356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  812405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812424 */     GIR_RootConstrainSelectedInstOperands,
     /*  812425 */     // GIR_Coverage, 22038,
     /*  812425 */     GIR_EraseRootFromParent_Done,
     /*  812426 */   // Label 12547: @812426
     /*  812426 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(812501), // Rule ID 22039 //
     /*  812431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  812448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  812480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812499 */     GIR_RootConstrainSelectedInstOperands,
     /*  812500 */     // GIR_Coverage, 22039,
     /*  812500 */     GIR_EraseRootFromParent_Done,
     /*  812501 */   // Label 12548: @812501
     /*  812501 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(812576), // Rule ID 22042 //
     /*  812506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  812555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812574 */     GIR_RootConstrainSelectedInstOperands,
     /*  812575 */     // GIR_Coverage, 22042,
     /*  812575 */     GIR_EraseRootFromParent_Done,
     /*  812576 */   // Label 12549: @812576
     /*  812576 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(812651), // Rule ID 22043 //
     /*  812581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  812630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812649 */     GIR_RootConstrainSelectedInstOperands,
     /*  812650 */     // GIR_Coverage, 22043,
     /*  812650 */     GIR_EraseRootFromParent_Done,
     /*  812651 */   // Label 12550: @812651
     /*  812651 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(812726), // Rule ID 22046 //
     /*  812656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  812705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812724 */     GIR_RootConstrainSelectedInstOperands,
     /*  812725 */     // GIR_Coverage, 22046,
     /*  812725 */     GIR_EraseRootFromParent_Done,
     /*  812726 */   // Label 12551: @812726
     /*  812726 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(812801), // Rule ID 22047 //
     /*  812731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  812780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812799 */     GIR_RootConstrainSelectedInstOperands,
     /*  812800 */     // GIR_Coverage, 22047,
     /*  812800 */     GIR_EraseRootFromParent_Done,
     /*  812801 */   // Label 12552: @812801
     /*  812801 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(812876), // Rule ID 22050 //
     /*  812806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  812855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812874 */     GIR_RootConstrainSelectedInstOperands,
     /*  812875 */     // GIR_Coverage, 22050,
     /*  812875 */     GIR_EraseRootFromParent_Done,
     /*  812876 */   // Label 12553: @812876
     /*  812876 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(812951), // Rule ID 22051 //
     /*  812881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  812930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812949 */     GIR_RootConstrainSelectedInstOperands,
     /*  812950 */     // GIR_Coverage, 22051,
     /*  812950 */     GIR_EraseRootFromParent_Done,
     /*  812951 */   // Label 12554: @812951
     /*  812951 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(813026), // Rule ID 22054 //
     /*  812956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  812964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  813005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813024 */     GIR_RootConstrainSelectedInstOperands,
     /*  813025 */     // GIR_Coverage, 22054,
     /*  813025 */     GIR_EraseRootFromParent_Done,
     /*  813026 */   // Label 12555: @813026
     /*  813026 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(813101), // Rule ID 22055 //
     /*  813031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  813048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  813080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813099 */     GIR_RootConstrainSelectedInstOperands,
     /*  813100 */     // GIR_Coverage, 22055,
     /*  813100 */     GIR_EraseRootFromParent_Done,
     /*  813101 */   // Label 12556: @813101
     /*  813101 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(813176), // Rule ID 22058 //
     /*  813106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  813109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  813155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813174 */     GIR_RootConstrainSelectedInstOperands,
     /*  813175 */     // GIR_Coverage, 22058,
     /*  813175 */     GIR_EraseRootFromParent_Done,
     /*  813176 */   // Label 12557: @813176
     /*  813176 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(813251), // Rule ID 22059 //
     /*  813181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  813189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  813198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  813216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  813230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813249 */     GIR_RootConstrainSelectedInstOperands,
     /*  813250 */     // GIR_Coverage, 22059,
     /*  813250 */     GIR_EraseRootFromParent_Done,
     /*  813251 */   // Label 12558: @813251
     /*  813251 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(813326), // Rule ID 22062 //
     /*  813256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  813305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813324 */     GIR_RootConstrainSelectedInstOperands,
     /*  813325 */     // GIR_Coverage, 22062,
     /*  813325 */     GIR_EraseRootFromParent_Done,
     /*  813326 */   // Label 12559: @813326
     /*  813326 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(813401), // Rule ID 22063 //
     /*  813331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  813348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  813380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813399 */     GIR_RootConstrainSelectedInstOperands,
     /*  813400 */     // GIR_Coverage, 22063,
     /*  813400 */     GIR_EraseRootFromParent_Done,
     /*  813401 */   // Label 12560: @813401
     /*  813401 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(813476), // Rule ID 22066 //
     /*  813406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  813455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813474 */     GIR_RootConstrainSelectedInstOperands,
     /*  813475 */     // GIR_Coverage, 22066,
     /*  813475 */     GIR_EraseRootFromParent_Done,
     /*  813476 */   // Label 12561: @813476
     /*  813476 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(813551), // Rule ID 22067 //
     /*  813481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  813498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  813530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813549 */     GIR_RootConstrainSelectedInstOperands,
     /*  813550 */     // GIR_Coverage, 22067,
     /*  813550 */     GIR_EraseRootFromParent_Done,
     /*  813551 */   // Label 12562: @813551
     /*  813551 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(813626), // Rule ID 22070 //
     /*  813556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  813605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813624 */     GIR_RootConstrainSelectedInstOperands,
     /*  813625 */     // GIR_Coverage, 22070,
     /*  813625 */     GIR_EraseRootFromParent_Done,
     /*  813626 */   // Label 12563: @813626
     /*  813626 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(813701), // Rule ID 22071 //
     /*  813631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  813680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813699 */     GIR_RootConstrainSelectedInstOperands,
     /*  813700 */     // GIR_Coverage, 22071,
     /*  813700 */     GIR_EraseRootFromParent_Done,
     /*  813701 */   // Label 12564: @813701
     /*  813701 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(813776), // Rule ID 22074 //
     /*  813706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  813755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813774 */     GIR_RootConstrainSelectedInstOperands,
     /*  813775 */     // GIR_Coverage, 22074,
     /*  813775 */     GIR_EraseRootFromParent_Done,
     /*  813776 */   // Label 12565: @813776
     /*  813776 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(813851), // Rule ID 22075 //
     /*  813781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  813830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813849 */     GIR_RootConstrainSelectedInstOperands,
     /*  813850 */     // GIR_Coverage, 22075,
     /*  813850 */     GIR_EraseRootFromParent_Done,
     /*  813851 */   // Label 12566: @813851
     /*  813851 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(813926), // Rule ID 22078 //
     /*  813856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  813905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813924 */     GIR_RootConstrainSelectedInstOperands,
     /*  813925 */     // GIR_Coverage, 22078,
     /*  813925 */     GIR_EraseRootFromParent_Done,
     /*  813926 */   // Label 12567: @813926
     /*  813926 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(814001), // Rule ID 22079 //
     /*  813931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  813939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  813980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813999 */     GIR_RootConstrainSelectedInstOperands,
     /*  814000 */     // GIR_Coverage, 22079,
     /*  814000 */     GIR_EraseRootFromParent_Done,
     /*  814001 */   // Label 12568: @814001
     /*  814001 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(814076), // Rule ID 22082 //
     /*  814006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  814055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814074 */     GIR_RootConstrainSelectedInstOperands,
     /*  814075 */     // GIR_Coverage, 22082,
     /*  814075 */     GIR_EraseRootFromParent_Done,
     /*  814076 */   // Label 12569: @814076
     /*  814076 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(814151), // Rule ID 22083 //
     /*  814081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  814098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  814130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814149 */     GIR_RootConstrainSelectedInstOperands,
     /*  814150 */     // GIR_Coverage, 22083,
     /*  814150 */     GIR_EraseRootFromParent_Done,
     /*  814151 */   // Label 12570: @814151
     /*  814151 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(814226), // Rule ID 22086 //
     /*  814156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  814205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814224 */     GIR_RootConstrainSelectedInstOperands,
     /*  814225 */     // GIR_Coverage, 22086,
     /*  814225 */     GIR_EraseRootFromParent_Done,
     /*  814226 */   // Label 12571: @814226
     /*  814226 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(814301), // Rule ID 22087 //
     /*  814231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  814248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  814280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814299 */     GIR_RootConstrainSelectedInstOperands,
     /*  814300 */     // GIR_Coverage, 22087,
     /*  814300 */     GIR_EraseRootFromParent_Done,
     /*  814301 */   // Label 12572: @814301
     /*  814301 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(814376), // Rule ID 22090 //
     /*  814306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  814355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814374 */     GIR_RootConstrainSelectedInstOperands,
     /*  814375 */     // GIR_Coverage, 22090,
     /*  814375 */     GIR_EraseRootFromParent_Done,
     /*  814376 */   // Label 12573: @814376
     /*  814376 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(814451), // Rule ID 22091 //
     /*  814381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  814398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  814430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814449 */     GIR_RootConstrainSelectedInstOperands,
     /*  814450 */     // GIR_Coverage, 22091,
     /*  814450 */     GIR_EraseRootFromParent_Done,
     /*  814451 */   // Label 12574: @814451
     /*  814451 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(814526), // Rule ID 22094 //
     /*  814456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  814505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814524 */     GIR_RootConstrainSelectedInstOperands,
     /*  814525 */     // GIR_Coverage, 22094,
     /*  814525 */     GIR_EraseRootFromParent_Done,
     /*  814526 */   // Label 12575: @814526
     /*  814526 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(814601), // Rule ID 22095 //
     /*  814531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  814580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814599 */     GIR_RootConstrainSelectedInstOperands,
     /*  814600 */     // GIR_Coverage, 22095,
     /*  814600 */     GIR_EraseRootFromParent_Done,
     /*  814601 */   // Label 12576: @814601
     /*  814601 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(814676), // Rule ID 22098 //
     /*  814606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  814655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814674 */     GIR_RootConstrainSelectedInstOperands,
     /*  814675 */     // GIR_Coverage, 22098,
     /*  814675 */     GIR_EraseRootFromParent_Done,
     /*  814676 */   // Label 12577: @814676
     /*  814676 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(814751), // Rule ID 22099 //
     /*  814681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  814730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814749 */     GIR_RootConstrainSelectedInstOperands,
     /*  814750 */     // GIR_Coverage, 22099,
     /*  814750 */     GIR_EraseRootFromParent_Done,
     /*  814751 */   // Label 12578: @814751
     /*  814751 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(814826), // Rule ID 22102 //
     /*  814756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  814805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814824 */     GIR_RootConstrainSelectedInstOperands,
     /*  814825 */     // GIR_Coverage, 22102,
     /*  814825 */     GIR_EraseRootFromParent_Done,
     /*  814826 */   // Label 12579: @814826
     /*  814826 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(814901), // Rule ID 22103 //
     /*  814831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  814880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814899 */     GIR_RootConstrainSelectedInstOperands,
     /*  814900 */     // GIR_Coverage, 22103,
     /*  814900 */     GIR_EraseRootFromParent_Done,
     /*  814901 */   // Label 12580: @814901
     /*  814901 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(814976), // Rule ID 22106 //
     /*  814906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  814955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814974 */     GIR_RootConstrainSelectedInstOperands,
     /*  814975 */     // GIR_Coverage, 22106,
     /*  814975 */     GIR_EraseRootFromParent_Done,
     /*  814976 */   // Label 12581: @814976
     /*  814976 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(815051), // Rule ID 22107 //
     /*  814981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  814989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  815030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815049 */     GIR_RootConstrainSelectedInstOperands,
     /*  815050 */     // GIR_Coverage, 22107,
     /*  815050 */     GIR_EraseRootFromParent_Done,
     /*  815051 */   // Label 12582: @815051
     /*  815051 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(815126), // Rule ID 22110 //
     /*  815056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  815105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815124 */     GIR_RootConstrainSelectedInstOperands,
     /*  815125 */     // GIR_Coverage, 22110,
     /*  815125 */     GIR_EraseRootFromParent_Done,
     /*  815126 */   // Label 12583: @815126
     /*  815126 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(815201), // Rule ID 22111 //
     /*  815131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  815148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  815180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815199 */     GIR_RootConstrainSelectedInstOperands,
     /*  815200 */     // GIR_Coverage, 22111,
     /*  815200 */     GIR_EraseRootFromParent_Done,
     /*  815201 */   // Label 12584: @815201
     /*  815201 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(815276), // Rule ID 22114 //
     /*  815206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  815255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815274 */     GIR_RootConstrainSelectedInstOperands,
     /*  815275 */     // GIR_Coverage, 22114,
     /*  815275 */     GIR_EraseRootFromParent_Done,
     /*  815276 */   // Label 12585: @815276
     /*  815276 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(815351), // Rule ID 22115 //
     /*  815281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  815298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  815330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815349 */     GIR_RootConstrainSelectedInstOperands,
     /*  815350 */     // GIR_Coverage, 22115,
     /*  815350 */     GIR_EraseRootFromParent_Done,
     /*  815351 */   // Label 12586: @815351
     /*  815351 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(815426), // Rule ID 22118 //
     /*  815356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  815405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815424 */     GIR_RootConstrainSelectedInstOperands,
     /*  815425 */     // GIR_Coverage, 22118,
     /*  815425 */     GIR_EraseRootFromParent_Done,
     /*  815426 */   // Label 12587: @815426
     /*  815426 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(815501), // Rule ID 22119 //
     /*  815431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  815448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  815480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815499 */     GIR_RootConstrainSelectedInstOperands,
     /*  815500 */     // GIR_Coverage, 22119,
     /*  815500 */     GIR_EraseRootFromParent_Done,
     /*  815501 */   // Label 12588: @815501
     /*  815501 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(815576), // Rule ID 22122 //
     /*  815506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  815555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815574 */     GIR_RootConstrainSelectedInstOperands,
     /*  815575 */     // GIR_Coverage, 22122,
     /*  815575 */     GIR_EraseRootFromParent_Done,
     /*  815576 */   // Label 12589: @815576
     /*  815576 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(815651), // Rule ID 22123 //
     /*  815581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  815630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815649 */     GIR_RootConstrainSelectedInstOperands,
     /*  815650 */     // GIR_Coverage, 22123,
     /*  815650 */     GIR_EraseRootFromParent_Done,
     /*  815651 */   // Label 12590: @815651
     /*  815651 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(815726), // Rule ID 22126 //
     /*  815656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  815705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815724 */     GIR_RootConstrainSelectedInstOperands,
     /*  815725 */     // GIR_Coverage, 22126,
     /*  815725 */     GIR_EraseRootFromParent_Done,
     /*  815726 */   // Label 12591: @815726
     /*  815726 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(815801), // Rule ID 22127 //
     /*  815731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  815780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815799 */     GIR_RootConstrainSelectedInstOperands,
     /*  815800 */     // GIR_Coverage, 22127,
     /*  815800 */     GIR_EraseRootFromParent_Done,
     /*  815801 */   // Label 12592: @815801
     /*  815801 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(815876), // Rule ID 22130 //
     /*  815806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  815855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815874 */     GIR_RootConstrainSelectedInstOperands,
     /*  815875 */     // GIR_Coverage, 22130,
     /*  815875 */     GIR_EraseRootFromParent_Done,
     /*  815876 */   // Label 12593: @815876
     /*  815876 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(815951), // Rule ID 22131 //
     /*  815881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  815930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815949 */     GIR_RootConstrainSelectedInstOperands,
     /*  815950 */     // GIR_Coverage, 22131,
     /*  815950 */     GIR_EraseRootFromParent_Done,
     /*  815951 */   // Label 12594: @815951
     /*  815951 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(816026), // Rule ID 22134 //
     /*  815956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  815964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  816005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816024 */     GIR_RootConstrainSelectedInstOperands,
     /*  816025 */     // GIR_Coverage, 22134,
     /*  816025 */     GIR_EraseRootFromParent_Done,
     /*  816026 */   // Label 12595: @816026
     /*  816026 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(816101), // Rule ID 22135 //
     /*  816031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  816048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  816080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816099 */     GIR_RootConstrainSelectedInstOperands,
     /*  816100 */     // GIR_Coverage, 22135,
     /*  816100 */     GIR_EraseRootFromParent_Done,
     /*  816101 */   // Label 12596: @816101
     /*  816101 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(816176), // Rule ID 22138 //
     /*  816106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  816155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816174 */     GIR_RootConstrainSelectedInstOperands,
     /*  816175 */     // GIR_Coverage, 22138,
     /*  816175 */     GIR_EraseRootFromParent_Done,
     /*  816176 */   // Label 12597: @816176
     /*  816176 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(816251), // Rule ID 22139 //
     /*  816181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  816198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  816216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  816230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816249 */     GIR_RootConstrainSelectedInstOperands,
     /*  816250 */     // GIR_Coverage, 22139,
     /*  816250 */     GIR_EraseRootFromParent_Done,
     /*  816251 */   // Label 12598: @816251
     /*  816251 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(816326), // Rule ID 22142 //
     /*  816256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  816305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816324 */     GIR_RootConstrainSelectedInstOperands,
     /*  816325 */     // GIR_Coverage, 22142,
     /*  816325 */     GIR_EraseRootFromParent_Done,
     /*  816326 */   // Label 12599: @816326
     /*  816326 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(816401), // Rule ID 22143 //
     /*  816331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  816348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  816366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  816380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816399 */     GIR_RootConstrainSelectedInstOperands,
     /*  816400 */     // GIR_Coverage, 22143,
     /*  816400 */     GIR_EraseRootFromParent_Done,
     /*  816401 */   // Label 12600: @816401
     /*  816401 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(816476), // Rule ID 22146 //
     /*  816406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  816455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816474 */     GIR_RootConstrainSelectedInstOperands,
     /*  816475 */     // GIR_Coverage, 22146,
     /*  816475 */     GIR_EraseRootFromParent_Done,
     /*  816476 */   // Label 12601: @816476
     /*  816476 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(816551), // Rule ID 22147 //
     /*  816481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  816489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  816498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  816516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  816530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816549 */     GIR_RootConstrainSelectedInstOperands,
     /*  816550 */     // GIR_Coverage, 22147,
     /*  816550 */     GIR_EraseRootFromParent_Done,
     /*  816551 */   // Label 12602: @816551
     /*  816551 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(816626), // Rule ID 22150 //
     /*  816556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  816605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816624 */     GIR_RootConstrainSelectedInstOperands,
     /*  816625 */     // GIR_Coverage, 22150,
     /*  816625 */     GIR_EraseRootFromParent_Done,
     /*  816626 */   // Label 12603: @816626
     /*  816626 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(816701), // Rule ID 22151 //
     /*  816631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  816680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816699 */     GIR_RootConstrainSelectedInstOperands,
     /*  816700 */     // GIR_Coverage, 22151,
     /*  816700 */     GIR_EraseRootFromParent_Done,
     /*  816701 */   // Label 12604: @816701
     /*  816701 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(816776), // Rule ID 22154 //
     /*  816706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  816755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816774 */     GIR_RootConstrainSelectedInstOperands,
     /*  816775 */     // GIR_Coverage, 22154,
     /*  816775 */     GIR_EraseRootFromParent_Done,
     /*  816776 */   // Label 12605: @816776
     /*  816776 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(816851), // Rule ID 22155 //
     /*  816781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  816830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816849 */     GIR_RootConstrainSelectedInstOperands,
     /*  816850 */     // GIR_Coverage, 22155,
     /*  816850 */     GIR_EraseRootFromParent_Done,
     /*  816851 */   // Label 12606: @816851
     /*  816851 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(816926), // Rule ID 22158 //
     /*  816856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  816905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816924 */     GIR_RootConstrainSelectedInstOperands,
     /*  816925 */     // GIR_Coverage, 22158,
     /*  816925 */     GIR_EraseRootFromParent_Done,
     /*  816926 */   // Label 12607: @816926
     /*  816926 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(817001), // Rule ID 22159 //
     /*  816931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  816939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  816980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816999 */     GIR_RootConstrainSelectedInstOperands,
     /*  817000 */     // GIR_Coverage, 22159,
     /*  817000 */     GIR_EraseRootFromParent_Done,
     /*  817001 */   // Label 12608: @817001
     /*  817001 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(817076), // Rule ID 22162 //
     /*  817006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  817055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817074 */     GIR_RootConstrainSelectedInstOperands,
     /*  817075 */     // GIR_Coverage, 22162,
     /*  817075 */     GIR_EraseRootFromParent_Done,
     /*  817076 */   // Label 12609: @817076
     /*  817076 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(817151), // Rule ID 22163 //
     /*  817081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  817098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  817130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817149 */     GIR_RootConstrainSelectedInstOperands,
     /*  817150 */     // GIR_Coverage, 22163,
     /*  817150 */     GIR_EraseRootFromParent_Done,
     /*  817151 */   // Label 12610: @817151
     /*  817151 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(817226), // Rule ID 22166 //
     /*  817156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  817205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817224 */     GIR_RootConstrainSelectedInstOperands,
     /*  817225 */     // GIR_Coverage, 22166,
     /*  817225 */     GIR_EraseRootFromParent_Done,
     /*  817226 */   // Label 12611: @817226
     /*  817226 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(817301), // Rule ID 22167 //
     /*  817231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  817248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  817280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817299 */     GIR_RootConstrainSelectedInstOperands,
     /*  817300 */     // GIR_Coverage, 22167,
     /*  817300 */     GIR_EraseRootFromParent_Done,
     /*  817301 */   // Label 12612: @817301
     /*  817301 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(817376), // Rule ID 22170 //
     /*  817306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  817355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817374 */     GIR_RootConstrainSelectedInstOperands,
     /*  817375 */     // GIR_Coverage, 22170,
     /*  817375 */     GIR_EraseRootFromParent_Done,
     /*  817376 */   // Label 12613: @817376
     /*  817376 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(817451), // Rule ID 22171 //
     /*  817381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  817398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  817430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817449 */     GIR_RootConstrainSelectedInstOperands,
     /*  817450 */     // GIR_Coverage, 22171,
     /*  817450 */     GIR_EraseRootFromParent_Done,
     /*  817451 */   // Label 12614: @817451
     /*  817451 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(817526), // Rule ID 22174 //
     /*  817456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  817505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817524 */     GIR_RootConstrainSelectedInstOperands,
     /*  817525 */     // GIR_Coverage, 22174,
     /*  817525 */     GIR_EraseRootFromParent_Done,
     /*  817526 */   // Label 12615: @817526
     /*  817526 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(817601), // Rule ID 22175 //
     /*  817531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  817580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817599 */     GIR_RootConstrainSelectedInstOperands,
     /*  817600 */     // GIR_Coverage, 22175,
     /*  817600 */     GIR_EraseRootFromParent_Done,
     /*  817601 */   // Label 12616: @817601
     /*  817601 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(817676), // Rule ID 22178 //
     /*  817606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  817655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817674 */     GIR_RootConstrainSelectedInstOperands,
     /*  817675 */     // GIR_Coverage, 22178,
     /*  817675 */     GIR_EraseRootFromParent_Done,
     /*  817676 */   // Label 12617: @817676
     /*  817676 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(817751), // Rule ID 22179 //
     /*  817681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  817730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817749 */     GIR_RootConstrainSelectedInstOperands,
     /*  817750 */     // GIR_Coverage, 22179,
     /*  817750 */     GIR_EraseRootFromParent_Done,
     /*  817751 */   // Label 12618: @817751
     /*  817751 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(817826), // Rule ID 22182 //
     /*  817756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  817805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817824 */     GIR_RootConstrainSelectedInstOperands,
     /*  817825 */     // GIR_Coverage, 22182,
     /*  817825 */     GIR_EraseRootFromParent_Done,
     /*  817826 */   // Label 12619: @817826
     /*  817826 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(817901), // Rule ID 22183 //
     /*  817831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  817880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817899 */     GIR_RootConstrainSelectedInstOperands,
     /*  817900 */     // GIR_Coverage, 22183,
     /*  817900 */     GIR_EraseRootFromParent_Done,
     /*  817901 */   // Label 12620: @817901
     /*  817901 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(817976), // Rule ID 22186 //
     /*  817906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  817955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817974 */     GIR_RootConstrainSelectedInstOperands,
     /*  817975 */     // GIR_Coverage, 22186,
     /*  817975 */     GIR_EraseRootFromParent_Done,
     /*  817976 */   // Label 12621: @817976
     /*  817976 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(818051), // Rule ID 22187 //
     /*  817981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  817989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  818030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818049 */     GIR_RootConstrainSelectedInstOperands,
     /*  818050 */     // GIR_Coverage, 22187,
     /*  818050 */     GIR_EraseRootFromParent_Done,
     /*  818051 */   // Label 12622: @818051
     /*  818051 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(818126), // Rule ID 22190 //
     /*  818056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  818105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818124 */     GIR_RootConstrainSelectedInstOperands,
     /*  818125 */     // GIR_Coverage, 22190,
     /*  818125 */     GIR_EraseRootFromParent_Done,
     /*  818126 */   // Label 12623: @818126
     /*  818126 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(818201), // Rule ID 22191 //
     /*  818131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  818148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  818180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818199 */     GIR_RootConstrainSelectedInstOperands,
     /*  818200 */     // GIR_Coverage, 22191,
     /*  818200 */     GIR_EraseRootFromParent_Done,
     /*  818201 */   // Label 12624: @818201
     /*  818201 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(818276), // Rule ID 22194 //
     /*  818206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  818255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818274 */     GIR_RootConstrainSelectedInstOperands,
     /*  818275 */     // GIR_Coverage, 22194,
     /*  818275 */     GIR_EraseRootFromParent_Done,
     /*  818276 */   // Label 12625: @818276
     /*  818276 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(818351), // Rule ID 22195 //
     /*  818281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  818298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  818330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818349 */     GIR_RootConstrainSelectedInstOperands,
     /*  818350 */     // GIR_Coverage, 22195,
     /*  818350 */     GIR_EraseRootFromParent_Done,
     /*  818351 */   // Label 12626: @818351
     /*  818351 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(818426), // Rule ID 22198 //
     /*  818356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  818405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818424 */     GIR_RootConstrainSelectedInstOperands,
     /*  818425 */     // GIR_Coverage, 22198,
     /*  818425 */     GIR_EraseRootFromParent_Done,
     /*  818426 */   // Label 12627: @818426
     /*  818426 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(818501), // Rule ID 22199 //
     /*  818431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  818448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  818480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818499 */     GIR_RootConstrainSelectedInstOperands,
     /*  818500 */     // GIR_Coverage, 22199,
     /*  818500 */     GIR_EraseRootFromParent_Done,
     /*  818501 */   // Label 12628: @818501
     /*  818501 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(818576), // Rule ID 22202 //
     /*  818506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  818555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818574 */     GIR_RootConstrainSelectedInstOperands,
     /*  818575 */     // GIR_Coverage, 22202,
     /*  818575 */     GIR_EraseRootFromParent_Done,
     /*  818576 */   // Label 12629: @818576
     /*  818576 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(818651), // Rule ID 22203 //
     /*  818581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  818630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818649 */     GIR_RootConstrainSelectedInstOperands,
     /*  818650 */     // GIR_Coverage, 22203,
     /*  818650 */     GIR_EraseRootFromParent_Done,
     /*  818651 */   // Label 12630: @818651
     /*  818651 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(818726), // Rule ID 22206 //
     /*  818656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  818705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818724 */     GIR_RootConstrainSelectedInstOperands,
     /*  818725 */     // GIR_Coverage, 22206,
     /*  818725 */     GIR_EraseRootFromParent_Done,
     /*  818726 */   // Label 12631: @818726
     /*  818726 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(818801), // Rule ID 22207 //
     /*  818731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  818780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818799 */     GIR_RootConstrainSelectedInstOperands,
     /*  818800 */     // GIR_Coverage, 22207,
     /*  818800 */     GIR_EraseRootFromParent_Done,
     /*  818801 */   // Label 12632: @818801
     /*  818801 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(818876), // Rule ID 22210 //
     /*  818806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  818855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818874 */     GIR_RootConstrainSelectedInstOperands,
     /*  818875 */     // GIR_Coverage, 22210,
     /*  818875 */     GIR_EraseRootFromParent_Done,
     /*  818876 */   // Label 12633: @818876
     /*  818876 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(818951), // Rule ID 22211 //
     /*  818881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  818930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818949 */     GIR_RootConstrainSelectedInstOperands,
     /*  818950 */     // GIR_Coverage, 22211,
     /*  818950 */     GIR_EraseRootFromParent_Done,
     /*  818951 */   // Label 12634: @818951
     /*  818951 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(819026), // Rule ID 22214 //
     /*  818956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  818964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  819005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819024 */     GIR_RootConstrainSelectedInstOperands,
     /*  819025 */     // GIR_Coverage, 22214,
     /*  819025 */     GIR_EraseRootFromParent_Done,
     /*  819026 */   // Label 12635: @819026
     /*  819026 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(819101), // Rule ID 22215 //
     /*  819031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  819048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  819080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819099 */     GIR_RootConstrainSelectedInstOperands,
     /*  819100 */     // GIR_Coverage, 22215,
     /*  819100 */     GIR_EraseRootFromParent_Done,
     /*  819101 */   // Label 12636: @819101
     /*  819101 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(819176), // Rule ID 22218 //
     /*  819106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  819155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819174 */     GIR_RootConstrainSelectedInstOperands,
     /*  819175 */     // GIR_Coverage, 22218,
     /*  819175 */     GIR_EraseRootFromParent_Done,
     /*  819176 */   // Label 12637: @819176
     /*  819176 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(819251), // Rule ID 22219 //
     /*  819181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  819198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  819230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819249 */     GIR_RootConstrainSelectedInstOperands,
     /*  819250 */     // GIR_Coverage, 22219,
     /*  819250 */     GIR_EraseRootFromParent_Done,
     /*  819251 */   // Label 12638: @819251
     /*  819251 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(819326), // Rule ID 22222 //
     /*  819256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  819305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819324 */     GIR_RootConstrainSelectedInstOperands,
     /*  819325 */     // GIR_Coverage, 22222,
     /*  819325 */     GIR_EraseRootFromParent_Done,
     /*  819326 */   // Label 12639: @819326
     /*  819326 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(819401), // Rule ID 22223 //
     /*  819331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  819348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  819380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819399 */     GIR_RootConstrainSelectedInstOperands,
     /*  819400 */     // GIR_Coverage, 22223,
     /*  819400 */     GIR_EraseRootFromParent_Done,
     /*  819401 */   // Label 12640: @819401
     /*  819401 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(819476), // Rule ID 22226 //
     /*  819406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  819455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819474 */     GIR_RootConstrainSelectedInstOperands,
     /*  819475 */     // GIR_Coverage, 22226,
     /*  819475 */     GIR_EraseRootFromParent_Done,
     /*  819476 */   // Label 12641: @819476
     /*  819476 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(819551), // Rule ID 22227 //
     /*  819481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  819498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  819516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  819530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819549 */     GIR_RootConstrainSelectedInstOperands,
     /*  819550 */     // GIR_Coverage, 22227,
     /*  819550 */     GIR_EraseRootFromParent_Done,
     /*  819551 */   // Label 12642: @819551
     /*  819551 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(819626), // Rule ID 22230 //
     /*  819556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  819605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819624 */     GIR_RootConstrainSelectedInstOperands,
     /*  819625 */     // GIR_Coverage, 22230,
     /*  819625 */     GIR_EraseRootFromParent_Done,
     /*  819626 */   // Label 12643: @819626
     /*  819626 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(819701), // Rule ID 22231 //
     /*  819631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  819680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819699 */     GIR_RootConstrainSelectedInstOperands,
     /*  819700 */     // GIR_Coverage, 22231,
     /*  819700 */     GIR_EraseRootFromParent_Done,
     /*  819701 */   // Label 12644: @819701
     /*  819701 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(819776), // Rule ID 22234 //
     /*  819706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  819755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819774 */     GIR_RootConstrainSelectedInstOperands,
     /*  819775 */     // GIR_Coverage, 22234,
     /*  819775 */     GIR_EraseRootFromParent_Done,
     /*  819776 */   // Label 12645: @819776
     /*  819776 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(819851), // Rule ID 22235 //
     /*  819781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  819789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  819830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819849 */     GIR_RootConstrainSelectedInstOperands,
     /*  819850 */     // GIR_Coverage, 22235,
     /*  819850 */     GIR_EraseRootFromParent_Done,
     /*  819851 */   // Label 12646: @819851
     /*  819851 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(819926), // Rule ID 22238 //
     /*  819856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  819905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819924 */     GIR_RootConstrainSelectedInstOperands,
     /*  819925 */     // GIR_Coverage, 22238,
     /*  819925 */     GIR_EraseRootFromParent_Done,
     /*  819926 */   // Label 12647: @819926
     /*  819926 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(820001), // Rule ID 22239 //
     /*  819931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  819980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819999 */     GIR_RootConstrainSelectedInstOperands,
     /*  820000 */     // GIR_Coverage, 22239,
     /*  820000 */     GIR_EraseRootFromParent_Done,
     /*  820001 */   // Label 12648: @820001
     /*  820001 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(820076), // Rule ID 22242 //
     /*  820006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  820055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820074 */     GIR_RootConstrainSelectedInstOperands,
     /*  820075 */     // GIR_Coverage, 22242,
     /*  820075 */     GIR_EraseRootFromParent_Done,
     /*  820076 */   // Label 12649: @820076
     /*  820076 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(820151), // Rule ID 22243 //
     /*  820081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  820098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  820130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820149 */     GIR_RootConstrainSelectedInstOperands,
     /*  820150 */     // GIR_Coverage, 22243,
     /*  820150 */     GIR_EraseRootFromParent_Done,
     /*  820151 */   // Label 12650: @820151
     /*  820151 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(820226), // Rule ID 22246 //
     /*  820156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  820205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820224 */     GIR_RootConstrainSelectedInstOperands,
     /*  820225 */     // GIR_Coverage, 22246,
     /*  820225 */     GIR_EraseRootFromParent_Done,
     /*  820226 */   // Label 12651: @820226
     /*  820226 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(820301), // Rule ID 22247 //
     /*  820231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  820248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  820280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820299 */     GIR_RootConstrainSelectedInstOperands,
     /*  820300 */     // GIR_Coverage, 22247,
     /*  820300 */     GIR_EraseRootFromParent_Done,
     /*  820301 */   // Label 12652: @820301
     /*  820301 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(820376), // Rule ID 22250 //
     /*  820306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  820355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820374 */     GIR_RootConstrainSelectedInstOperands,
     /*  820375 */     // GIR_Coverage, 22250,
     /*  820375 */     GIR_EraseRootFromParent_Done,
     /*  820376 */   // Label 12653: @820376
     /*  820376 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(820451), // Rule ID 22251 //
     /*  820381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  820398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  820430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820449 */     GIR_RootConstrainSelectedInstOperands,
     /*  820450 */     // GIR_Coverage, 22251,
     /*  820450 */     GIR_EraseRootFromParent_Done,
     /*  820451 */   // Label 12654: @820451
     /*  820451 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(820526), // Rule ID 22254 //
     /*  820456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  820505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820524 */     GIR_RootConstrainSelectedInstOperands,
     /*  820525 */     // GIR_Coverage, 22254,
     /*  820525 */     GIR_EraseRootFromParent_Done,
     /*  820526 */   // Label 12655: @820526
     /*  820526 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(820601), // Rule ID 22255 //
     /*  820531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  820580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820599 */     GIR_RootConstrainSelectedInstOperands,
     /*  820600 */     // GIR_Coverage, 22255,
     /*  820600 */     GIR_EraseRootFromParent_Done,
     /*  820601 */   // Label 12656: @820601
     /*  820601 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(820676), // Rule ID 22258 //
     /*  820606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  820655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820674 */     GIR_RootConstrainSelectedInstOperands,
     /*  820675 */     // GIR_Coverage, 22258,
     /*  820675 */     GIR_EraseRootFromParent_Done,
     /*  820676 */   // Label 12657: @820676
     /*  820676 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(820751), // Rule ID 22259 //
     /*  820681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  820730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820749 */     GIR_RootConstrainSelectedInstOperands,
     /*  820750 */     // GIR_Coverage, 22259,
     /*  820750 */     GIR_EraseRootFromParent_Done,
     /*  820751 */   // Label 12658: @820751
     /*  820751 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(820826), // Rule ID 22262 //
     /*  820756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  820805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820824 */     GIR_RootConstrainSelectedInstOperands,
     /*  820825 */     // GIR_Coverage, 22262,
     /*  820825 */     GIR_EraseRootFromParent_Done,
     /*  820826 */   // Label 12659: @820826
     /*  820826 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(820901), // Rule ID 22263 //
     /*  820831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  820880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820899 */     GIR_RootConstrainSelectedInstOperands,
     /*  820900 */     // GIR_Coverage, 22263,
     /*  820900 */     GIR_EraseRootFromParent_Done,
     /*  820901 */   // Label 12660: @820901
     /*  820901 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(820976), // Rule ID 22266 //
     /*  820906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  820955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820974 */     GIR_RootConstrainSelectedInstOperands,
     /*  820975 */     // GIR_Coverage, 22266,
     /*  820975 */     GIR_EraseRootFromParent_Done,
     /*  820976 */   // Label 12661: @820976
     /*  820976 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(821051), // Rule ID 22267 //
     /*  820981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  820989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  821030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821049 */     GIR_RootConstrainSelectedInstOperands,
     /*  821050 */     // GIR_Coverage, 22267,
     /*  821050 */     GIR_EraseRootFromParent_Done,
     /*  821051 */   // Label 12662: @821051
     /*  821051 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(821126), // Rule ID 22270 //
     /*  821056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  821105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821124 */     GIR_RootConstrainSelectedInstOperands,
     /*  821125 */     // GIR_Coverage, 22270,
     /*  821125 */     GIR_EraseRootFromParent_Done,
     /*  821126 */   // Label 12663: @821126
     /*  821126 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(821201), // Rule ID 22271 //
     /*  821131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  821148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  821180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821199 */     GIR_RootConstrainSelectedInstOperands,
     /*  821200 */     // GIR_Coverage, 22271,
     /*  821200 */     GIR_EraseRootFromParent_Done,
     /*  821201 */   // Label 12664: @821201
     /*  821201 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(821276), // Rule ID 22274 //
     /*  821206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  821255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821274 */     GIR_RootConstrainSelectedInstOperands,
     /*  821275 */     // GIR_Coverage, 22274,
     /*  821275 */     GIR_EraseRootFromParent_Done,
     /*  821276 */   // Label 12665: @821276
     /*  821276 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(821351), // Rule ID 22275 //
     /*  821281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  821298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  821330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821349 */     GIR_RootConstrainSelectedInstOperands,
     /*  821350 */     // GIR_Coverage, 22275,
     /*  821350 */     GIR_EraseRootFromParent_Done,
     /*  821351 */   // Label 12666: @821351
     /*  821351 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(821426), // Rule ID 22278 //
     /*  821356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  821405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821424 */     GIR_RootConstrainSelectedInstOperands,
     /*  821425 */     // GIR_Coverage, 22278,
     /*  821425 */     GIR_EraseRootFromParent_Done,
     /*  821426 */   // Label 12667: @821426
     /*  821426 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(821501), // Rule ID 22279 //
     /*  821431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  821448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  821480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821499 */     GIR_RootConstrainSelectedInstOperands,
     /*  821500 */     // GIR_Coverage, 22279,
     /*  821500 */     GIR_EraseRootFromParent_Done,
     /*  821501 */   // Label 12668: @821501
     /*  821501 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(821576), // Rule ID 22282 //
     /*  821506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  821555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821574 */     GIR_RootConstrainSelectedInstOperands,
     /*  821575 */     // GIR_Coverage, 22282,
     /*  821575 */     GIR_EraseRootFromParent_Done,
     /*  821576 */   // Label 12669: @821576
     /*  821576 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(821651), // Rule ID 22283 //
     /*  821581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  821630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821649 */     GIR_RootConstrainSelectedInstOperands,
     /*  821650 */     // GIR_Coverage, 22283,
     /*  821650 */     GIR_EraseRootFromParent_Done,
     /*  821651 */   // Label 12670: @821651
     /*  821651 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(821726), // Rule ID 22286 //
     /*  821656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  821705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821724 */     GIR_RootConstrainSelectedInstOperands,
     /*  821725 */     // GIR_Coverage, 22286,
     /*  821725 */     GIR_EraseRootFromParent_Done,
     /*  821726 */   // Label 12671: @821726
     /*  821726 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(821801), // Rule ID 22287 //
     /*  821731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  821780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821799 */     GIR_RootConstrainSelectedInstOperands,
     /*  821800 */     // GIR_Coverage, 22287,
     /*  821800 */     GIR_EraseRootFromParent_Done,
     /*  821801 */   // Label 12672: @821801
     /*  821801 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(821876), // Rule ID 22290 //
     /*  821806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  821855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821874 */     GIR_RootConstrainSelectedInstOperands,
     /*  821875 */     // GIR_Coverage, 22290,
     /*  821875 */     GIR_EraseRootFromParent_Done,
     /*  821876 */   // Label 12673: @821876
     /*  821876 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(821951), // Rule ID 22291 //
     /*  821881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  821930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821949 */     GIR_RootConstrainSelectedInstOperands,
     /*  821950 */     // GIR_Coverage, 22291,
     /*  821950 */     GIR_EraseRootFromParent_Done,
     /*  821951 */   // Label 12674: @821951
     /*  821951 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(822026), // Rule ID 22294 //
     /*  821956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  821964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  822005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822024 */     GIR_RootConstrainSelectedInstOperands,
     /*  822025 */     // GIR_Coverage, 22294,
     /*  822025 */     GIR_EraseRootFromParent_Done,
     /*  822026 */   // Label 12675: @822026
     /*  822026 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(822101), // Rule ID 22295 //
     /*  822031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  822048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  822080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822099 */     GIR_RootConstrainSelectedInstOperands,
     /*  822100 */     // GIR_Coverage, 22295,
     /*  822100 */     GIR_EraseRootFromParent_Done,
     /*  822101 */   // Label 12676: @822101
     /*  822101 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(822176), // Rule ID 22298 //
     /*  822106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  822155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822174 */     GIR_RootConstrainSelectedInstOperands,
     /*  822175 */     // GIR_Coverage, 22298,
     /*  822175 */     GIR_EraseRootFromParent_Done,
     /*  822176 */   // Label 12677: @822176
     /*  822176 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(822251), // Rule ID 22299 //
     /*  822181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  822198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  822230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822249 */     GIR_RootConstrainSelectedInstOperands,
     /*  822250 */     // GIR_Coverage, 22299,
     /*  822250 */     GIR_EraseRootFromParent_Done,
     /*  822251 */   // Label 12678: @822251
     /*  822251 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(822326), // Rule ID 22302 //
     /*  822256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  822305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822324 */     GIR_RootConstrainSelectedInstOperands,
     /*  822325 */     // GIR_Coverage, 22302,
     /*  822325 */     GIR_EraseRootFromParent_Done,
     /*  822326 */   // Label 12679: @822326
     /*  822326 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(822401), // Rule ID 22303 //
     /*  822331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  822348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  822380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822399 */     GIR_RootConstrainSelectedInstOperands,
     /*  822400 */     // GIR_Coverage, 22303,
     /*  822400 */     GIR_EraseRootFromParent_Done,
     /*  822401 */   // Label 12680: @822401
     /*  822401 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(822476), // Rule ID 22306 //
     /*  822406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  822455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822474 */     GIR_RootConstrainSelectedInstOperands,
     /*  822475 */     // GIR_Coverage, 22306,
     /*  822475 */     GIR_EraseRootFromParent_Done,
     /*  822476 */   // Label 12681: @822476
     /*  822476 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(822551), // Rule ID 22307 //
     /*  822481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  822498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  822530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822549 */     GIR_RootConstrainSelectedInstOperands,
     /*  822550 */     // GIR_Coverage, 22307,
     /*  822550 */     GIR_EraseRootFromParent_Done,
     /*  822551 */   // Label 12682: @822551
     /*  822551 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(822626), // Rule ID 22310 //
     /*  822556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  822605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822624 */     GIR_RootConstrainSelectedInstOperands,
     /*  822625 */     // GIR_Coverage, 22310,
     /*  822625 */     GIR_EraseRootFromParent_Done,
     /*  822626 */   // Label 12683: @822626
     /*  822626 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(822701), // Rule ID 22311 //
     /*  822631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  822680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822699 */     GIR_RootConstrainSelectedInstOperands,
     /*  822700 */     // GIR_Coverage, 22311,
     /*  822700 */     GIR_EraseRootFromParent_Done,
     /*  822701 */   // Label 12684: @822701
     /*  822701 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(822776), // Rule ID 22314 //
     /*  822706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  822755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822774 */     GIR_RootConstrainSelectedInstOperands,
     /*  822775 */     // GIR_Coverage, 22314,
     /*  822775 */     GIR_EraseRootFromParent_Done,
     /*  822776 */   // Label 12685: @822776
     /*  822776 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(822851), // Rule ID 22315 //
     /*  822781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  822830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822849 */     GIR_RootConstrainSelectedInstOperands,
     /*  822850 */     // GIR_Coverage, 22315,
     /*  822850 */     GIR_EraseRootFromParent_Done,
     /*  822851 */   // Label 12686: @822851
     /*  822851 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(822926), // Rule ID 22318 //
     /*  822856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  822905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822924 */     GIR_RootConstrainSelectedInstOperands,
     /*  822925 */     // GIR_Coverage, 22318,
     /*  822925 */     GIR_EraseRootFromParent_Done,
     /*  822926 */   // Label 12687: @822926
     /*  822926 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(823001), // Rule ID 22319 //
     /*  822931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  822939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  822980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822999 */     GIR_RootConstrainSelectedInstOperands,
     /*  823000 */     // GIR_Coverage, 22319,
     /*  823000 */     GIR_EraseRootFromParent_Done,
     /*  823001 */   // Label 12688: @823001
     /*  823001 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(823076), // Rule ID 22322 //
     /*  823006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  823014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  823052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  823055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823074 */     GIR_RootConstrainSelectedInstOperands,
     /*  823075 */     // GIR_Coverage, 22322,
     /*  823075 */     GIR_EraseRootFromParent_Done,
     /*  823076 */   // Label 12689: @823076
     /*  823076 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(823151), // Rule ID 22323 //
     /*  823081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  823089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  823098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  823127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  823130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823149 */     GIR_RootConstrainSelectedInstOperands,
     /*  823150 */     // GIR_Coverage, 22323,
     /*  823150 */     GIR_EraseRootFromParent_Done,
     /*  823151 */   // Label 12690: @823151
     /*  823151 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(823226), // Rule ID 22326 //
     /*  823156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  823205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823224 */     GIR_RootConstrainSelectedInstOperands,
     /*  823225 */     // GIR_Coverage, 22326,
     /*  823225 */     GIR_EraseRootFromParent_Done,
     /*  823226 */   // Label 12691: @823226
     /*  823226 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(823301), // Rule ID 22327 //
     /*  823231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  823248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  823280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823299 */     GIR_RootConstrainSelectedInstOperands,
     /*  823300 */     // GIR_Coverage, 22327,
     /*  823300 */     GIR_EraseRootFromParent_Done,
     /*  823301 */   // Label 12692: @823301
     /*  823301 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(823376), // Rule ID 22330 //
     /*  823306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  823355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823374 */     GIR_RootConstrainSelectedInstOperands,
     /*  823375 */     // GIR_Coverage, 22330,
     /*  823375 */     GIR_EraseRootFromParent_Done,
     /*  823376 */   // Label 12693: @823376
     /*  823376 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(823451), // Rule ID 22331 //
     /*  823381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  823398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  823430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823449 */     GIR_RootConstrainSelectedInstOperands,
     /*  823450 */     // GIR_Coverage, 22331,
     /*  823450 */     GIR_EraseRootFromParent_Done,
     /*  823451 */   // Label 12694: @823451
     /*  823451 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(823526), // Rule ID 22334 //
     /*  823456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  823505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823524 */     GIR_RootConstrainSelectedInstOperands,
     /*  823525 */     // GIR_Coverage, 22334,
     /*  823525 */     GIR_EraseRootFromParent_Done,
     /*  823526 */   // Label 12695: @823526
     /*  823526 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(823601), // Rule ID 22335 //
     /*  823531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  823580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823599 */     GIR_RootConstrainSelectedInstOperands,
     /*  823600 */     // GIR_Coverage, 22335,
     /*  823600 */     GIR_EraseRootFromParent_Done,
     /*  823601 */   // Label 12696: @823601
     /*  823601 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(823676), // Rule ID 22338 //
     /*  823606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  823655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823674 */     GIR_RootConstrainSelectedInstOperands,
     /*  823675 */     // GIR_Coverage, 22338,
     /*  823675 */     GIR_EraseRootFromParent_Done,
     /*  823676 */   // Label 12697: @823676
     /*  823676 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(823751), // Rule ID 22339 //
     /*  823681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  823730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823749 */     GIR_RootConstrainSelectedInstOperands,
     /*  823750 */     // GIR_Coverage, 22339,
     /*  823750 */     GIR_EraseRootFromParent_Done,
     /*  823751 */   // Label 12698: @823751
     /*  823751 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(823826), // Rule ID 22342 //
     /*  823756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  823805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823824 */     GIR_RootConstrainSelectedInstOperands,
     /*  823825 */     // GIR_Coverage, 22342,
     /*  823825 */     GIR_EraseRootFromParent_Done,
     /*  823826 */   // Label 12699: @823826
     /*  823826 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(823901), // Rule ID 22343 //
     /*  823831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  823880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823899 */     GIR_RootConstrainSelectedInstOperands,
     /*  823900 */     // GIR_Coverage, 22343,
     /*  823900 */     GIR_EraseRootFromParent_Done,
     /*  823901 */   // Label 12700: @823901
     /*  823901 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(823976), // Rule ID 22346 //
     /*  823906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  823955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823974 */     GIR_RootConstrainSelectedInstOperands,
     /*  823975 */     // GIR_Coverage, 22346,
     /*  823975 */     GIR_EraseRootFromParent_Done,
     /*  823976 */   // Label 12701: @823976
     /*  823976 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(824051), // Rule ID 22347 //
     /*  823981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  823989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  824030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824049 */     GIR_RootConstrainSelectedInstOperands,
     /*  824050 */     // GIR_Coverage, 22347,
     /*  824050 */     GIR_EraseRootFromParent_Done,
     /*  824051 */   // Label 12702: @824051
     /*  824051 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(824126), // Rule ID 22350 //
     /*  824056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  824105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824124 */     GIR_RootConstrainSelectedInstOperands,
     /*  824125 */     // GIR_Coverage, 22350,
     /*  824125 */     GIR_EraseRootFromParent_Done,
     /*  824126 */   // Label 12703: @824126
     /*  824126 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(824201), // Rule ID 22351 //
     /*  824131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  824148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  824180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824199 */     GIR_RootConstrainSelectedInstOperands,
     /*  824200 */     // GIR_Coverage, 22351,
     /*  824200 */     GIR_EraseRootFromParent_Done,
     /*  824201 */   // Label 12704: @824201
     /*  824201 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(824276), // Rule ID 22354 //
     /*  824206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  824255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824274 */     GIR_RootConstrainSelectedInstOperands,
     /*  824275 */     // GIR_Coverage, 22354,
     /*  824275 */     GIR_EraseRootFromParent_Done,
     /*  824276 */   // Label 12705: @824276
     /*  824276 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(824351), // Rule ID 22355 //
     /*  824281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  824298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  824330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824349 */     GIR_RootConstrainSelectedInstOperands,
     /*  824350 */     // GIR_Coverage, 22355,
     /*  824350 */     GIR_EraseRootFromParent_Done,
     /*  824351 */   // Label 12706: @824351
     /*  824351 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(824426), // Rule ID 22358 //
     /*  824356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  824405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824424 */     GIR_RootConstrainSelectedInstOperands,
     /*  824425 */     // GIR_Coverage, 22358,
     /*  824425 */     GIR_EraseRootFromParent_Done,
     /*  824426 */   // Label 12707: @824426
     /*  824426 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(824501), // Rule ID 22359 //
     /*  824431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  824448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  824480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824499 */     GIR_RootConstrainSelectedInstOperands,
     /*  824500 */     // GIR_Coverage, 22359,
     /*  824500 */     GIR_EraseRootFromParent_Done,
     /*  824501 */   // Label 12708: @824501
     /*  824501 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(824576), // Rule ID 22362 //
     /*  824506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824552 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  824555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824574 */     GIR_RootConstrainSelectedInstOperands,
     /*  824575 */     // GIR_Coverage, 22362,
     /*  824575 */     GIR_EraseRootFromParent_Done,
     /*  824576 */   // Label 12709: @824576
     /*  824576 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(824651), // Rule ID 22363 //
     /*  824581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  824630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824649 */     GIR_RootConstrainSelectedInstOperands,
     /*  824650 */     // GIR_Coverage, 22363,
     /*  824650 */     GIR_EraseRootFromParent_Done,
     /*  824651 */   // Label 12710: @824651
     /*  824651 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(824726), // Rule ID 22366 //
     /*  824656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  824705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824724 */     GIR_RootConstrainSelectedInstOperands,
     /*  824725 */     // GIR_Coverage, 22366,
     /*  824725 */     GIR_EraseRootFromParent_Done,
     /*  824726 */   // Label 12711: @824726
     /*  824726 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(824801), // Rule ID 22367 //
     /*  824731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  824780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824799 */     GIR_RootConstrainSelectedInstOperands,
     /*  824800 */     // GIR_Coverage, 22367,
     /*  824800 */     GIR_EraseRootFromParent_Done,
     /*  824801 */   // Label 12712: @824801
     /*  824801 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(824876), // Rule ID 22370 //
     /*  824806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  824855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824874 */     GIR_RootConstrainSelectedInstOperands,
     /*  824875 */     // GIR_Coverage, 22370,
     /*  824875 */     GIR_EraseRootFromParent_Done,
     /*  824876 */   // Label 12713: @824876
     /*  824876 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(824951), // Rule ID 22371 //
     /*  824881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  824930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824949 */     GIR_RootConstrainSelectedInstOperands,
     /*  824950 */     // GIR_Coverage, 22371,
     /*  824950 */     GIR_EraseRootFromParent_Done,
     /*  824951 */   // Label 12714: @824951
     /*  824951 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(825026), // Rule ID 22374 //
     /*  824956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  824964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  825005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825024 */     GIR_RootConstrainSelectedInstOperands,
     /*  825025 */     // GIR_Coverage, 22374,
     /*  825025 */     GIR_EraseRootFromParent_Done,
     /*  825026 */   // Label 12715: @825026
     /*  825026 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(825101), // Rule ID 22375 //
     /*  825031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  825048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  825080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825099 */     GIR_RootConstrainSelectedInstOperands,
     /*  825100 */     // GIR_Coverage, 22375,
     /*  825100 */     GIR_EraseRootFromParent_Done,
     /*  825101 */   // Label 12716: @825101
     /*  825101 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(825176), // Rule ID 22378 //
     /*  825106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  825155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825174 */     GIR_RootConstrainSelectedInstOperands,
     /*  825175 */     // GIR_Coverage, 22378,
     /*  825175 */     GIR_EraseRootFromParent_Done,
     /*  825176 */   // Label 12717: @825176
     /*  825176 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(825251), // Rule ID 22379 //
     /*  825181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  825198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  825230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825249 */     GIR_RootConstrainSelectedInstOperands,
     /*  825250 */     // GIR_Coverage, 22379,
     /*  825250 */     GIR_EraseRootFromParent_Done,
     /*  825251 */   // Label 12718: @825251
     /*  825251 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(825326), // Rule ID 22382 //
     /*  825256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  825305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825324 */     GIR_RootConstrainSelectedInstOperands,
     /*  825325 */     // GIR_Coverage, 22382,
     /*  825325 */     GIR_EraseRootFromParent_Done,
     /*  825326 */   // Label 12719: @825326
     /*  825326 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(825401), // Rule ID 22383 //
     /*  825331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  825348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  825380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825399 */     GIR_RootConstrainSelectedInstOperands,
     /*  825400 */     // GIR_Coverage, 22383,
     /*  825400 */     GIR_EraseRootFromParent_Done,
     /*  825401 */   // Label 12720: @825401
     /*  825401 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(825476), // Rule ID 22386 //
     /*  825406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  825455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825474 */     GIR_RootConstrainSelectedInstOperands,
     /*  825475 */     // GIR_Coverage, 22386,
     /*  825475 */     GIR_EraseRootFromParent_Done,
     /*  825476 */   // Label 12721: @825476
     /*  825476 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(825551), // Rule ID 22387 //
     /*  825481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  825498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  825530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825549 */     GIR_RootConstrainSelectedInstOperands,
     /*  825550 */     // GIR_Coverage, 22387,
     /*  825550 */     GIR_EraseRootFromParent_Done,
     /*  825551 */   // Label 12722: @825551
     /*  825551 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(825626), // Rule ID 22390 //
     /*  825556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  825605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825624 */     GIR_RootConstrainSelectedInstOperands,
     /*  825625 */     // GIR_Coverage, 22390,
     /*  825625 */     GIR_EraseRootFromParent_Done,
     /*  825626 */   // Label 12723: @825626
     /*  825626 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(825701), // Rule ID 22391 //
     /*  825631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  825680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825699 */     GIR_RootConstrainSelectedInstOperands,
     /*  825700 */     // GIR_Coverage, 22391,
     /*  825700 */     GIR_EraseRootFromParent_Done,
     /*  825701 */   // Label 12724: @825701
     /*  825701 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(825776), // Rule ID 22394 //
     /*  825706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  825755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825774 */     GIR_RootConstrainSelectedInstOperands,
     /*  825775 */     // GIR_Coverage, 22394,
     /*  825775 */     GIR_EraseRootFromParent_Done,
     /*  825776 */   // Label 12725: @825776
     /*  825776 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(825851), // Rule ID 22395 //
     /*  825781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  825830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825849 */     GIR_RootConstrainSelectedInstOperands,
     /*  825850 */     // GIR_Coverage, 22395,
     /*  825850 */     GIR_EraseRootFromParent_Done,
     /*  825851 */   // Label 12726: @825851
     /*  825851 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(825926), // Rule ID 22398 //
     /*  825856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  825905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825924 */     GIR_RootConstrainSelectedInstOperands,
     /*  825925 */     // GIR_Coverage, 22398,
     /*  825925 */     GIR_EraseRootFromParent_Done,
     /*  825926 */   // Label 12727: @825926
     /*  825926 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(826001), // Rule ID 22399 //
     /*  825931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  825939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  825980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825999 */     GIR_RootConstrainSelectedInstOperands,
     /*  826000 */     // GIR_Coverage, 22399,
     /*  826000 */     GIR_EraseRootFromParent_Done,
     /*  826001 */   // Label 12728: @826001
     /*  826001 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(826076), // Rule ID 22402 //
     /*  826006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  826055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826074 */     GIR_RootConstrainSelectedInstOperands,
     /*  826075 */     // GIR_Coverage, 22402,
     /*  826075 */     GIR_EraseRootFromParent_Done,
     /*  826076 */   // Label 12729: @826076
     /*  826076 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(826151), // Rule ID 22403 //
     /*  826081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  826098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  826130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826149 */     GIR_RootConstrainSelectedInstOperands,
     /*  826150 */     // GIR_Coverage, 22403,
     /*  826150 */     GIR_EraseRootFromParent_Done,
     /*  826151 */   // Label 12730: @826151
     /*  826151 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(826226), // Rule ID 22406 //
     /*  826156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  826205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826224 */     GIR_RootConstrainSelectedInstOperands,
     /*  826225 */     // GIR_Coverage, 22406,
     /*  826225 */     GIR_EraseRootFromParent_Done,
     /*  826226 */   // Label 12731: @826226
     /*  826226 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(826301), // Rule ID 22407 //
     /*  826231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  826248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  826266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  826280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826299 */     GIR_RootConstrainSelectedInstOperands,
     /*  826300 */     // GIR_Coverage, 22407,
     /*  826300 */     GIR_EraseRootFromParent_Done,
     /*  826301 */   // Label 12732: @826301
     /*  826301 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(826376), // Rule ID 22410 //
     /*  826306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  826355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826374 */     GIR_RootConstrainSelectedInstOperands,
     /*  826375 */     // GIR_Coverage, 22410,
     /*  826375 */     GIR_EraseRootFromParent_Done,
     /*  826376 */   // Label 12733: @826376
     /*  826376 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(826451), // Rule ID 22411 //
     /*  826381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  826389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  826398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  826416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  826430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826449 */     GIR_RootConstrainSelectedInstOperands,
     /*  826450 */     // GIR_Coverage, 22411,
     /*  826450 */     GIR_EraseRootFromParent_Done,
     /*  826451 */   // Label 12734: @826451
     /*  826451 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(826526), // Rule ID 22414 //
     /*  826456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  826505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826524 */     GIR_RootConstrainSelectedInstOperands,
     /*  826525 */     // GIR_Coverage, 22414,
     /*  826525 */     GIR_EraseRootFromParent_Done,
     /*  826526 */   // Label 12735: @826526
     /*  826526 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(826601), // Rule ID 22415 //
     /*  826531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  826580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826599 */     GIR_RootConstrainSelectedInstOperands,
     /*  826600 */     // GIR_Coverage, 22415,
     /*  826600 */     GIR_EraseRootFromParent_Done,
     /*  826601 */   // Label 12736: @826601
     /*  826601 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(826676), // Rule ID 22418 //
     /*  826606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  826655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826674 */     GIR_RootConstrainSelectedInstOperands,
     /*  826675 */     // GIR_Coverage, 22418,
     /*  826675 */     GIR_EraseRootFromParent_Done,
     /*  826676 */   // Label 12737: @826676
     /*  826676 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(826751), // Rule ID 22419 //
     /*  826681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  826730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826749 */     GIR_RootConstrainSelectedInstOperands,
     /*  826750 */     // GIR_Coverage, 22419,
     /*  826750 */     GIR_EraseRootFromParent_Done,
     /*  826751 */   // Label 12738: @826751
     /*  826751 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(826826), // Rule ID 22422 //
     /*  826756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  826805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826824 */     GIR_RootConstrainSelectedInstOperands,
     /*  826825 */     // GIR_Coverage, 22422,
     /*  826825 */     GIR_EraseRootFromParent_Done,
     /*  826826 */   // Label 12739: @826826
     /*  826826 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(826901), // Rule ID 22423 //
     /*  826831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  826880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826899 */     GIR_RootConstrainSelectedInstOperands,
     /*  826900 */     // GIR_Coverage, 22423,
     /*  826900 */     GIR_EraseRootFromParent_Done,
     /*  826901 */   // Label 12740: @826901
     /*  826901 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(826976), // Rule ID 22426 //
     /*  826906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  826955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826974 */     GIR_RootConstrainSelectedInstOperands,
     /*  826975 */     // GIR_Coverage, 22426,
     /*  826975 */     GIR_EraseRootFromParent_Done,
     /*  826976 */   // Label 12741: @826976
     /*  826976 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(827051), // Rule ID 22427 //
     /*  826981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  826989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  827030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827049 */     GIR_RootConstrainSelectedInstOperands,
     /*  827050 */     // GIR_Coverage, 22427,
     /*  827050 */     GIR_EraseRootFromParent_Done,
     /*  827051 */   // Label 12742: @827051
     /*  827051 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(827126), // Rule ID 22430 //
     /*  827056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  827105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827124 */     GIR_RootConstrainSelectedInstOperands,
     /*  827125 */     // GIR_Coverage, 22430,
     /*  827125 */     GIR_EraseRootFromParent_Done,
     /*  827126 */   // Label 12743: @827126
     /*  827126 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(827201), // Rule ID 22431 //
     /*  827131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  827148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  827180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827199 */     GIR_RootConstrainSelectedInstOperands,
     /*  827200 */     // GIR_Coverage, 22431,
     /*  827200 */     GIR_EraseRootFromParent_Done,
     /*  827201 */   // Label 12744: @827201
     /*  827201 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(827276), // Rule ID 22434 //
     /*  827206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  827255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827274 */     GIR_RootConstrainSelectedInstOperands,
     /*  827275 */     // GIR_Coverage, 22434,
     /*  827275 */     GIR_EraseRootFromParent_Done,
     /*  827276 */   // Label 12745: @827276
     /*  827276 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(827351), // Rule ID 22435 //
     /*  827281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  827298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  827330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827349 */     GIR_RootConstrainSelectedInstOperands,
     /*  827350 */     // GIR_Coverage, 22435,
     /*  827350 */     GIR_EraseRootFromParent_Done,
     /*  827351 */   // Label 12746: @827351
     /*  827351 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(827426), // Rule ID 22438 //
     /*  827356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  827405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827424 */     GIR_RootConstrainSelectedInstOperands,
     /*  827425 */     // GIR_Coverage, 22438,
     /*  827425 */     GIR_EraseRootFromParent_Done,
     /*  827426 */   // Label 12747: @827426
     /*  827426 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(827501), // Rule ID 22439 //
     /*  827431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  827448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  827480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827499 */     GIR_RootConstrainSelectedInstOperands,
     /*  827500 */     // GIR_Coverage, 22439,
     /*  827500 */     GIR_EraseRootFromParent_Done,
     /*  827501 */   // Label 12748: @827501
     /*  827501 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(827576), // Rule ID 22442 //
     /*  827506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  827555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827574 */     GIR_RootConstrainSelectedInstOperands,
     /*  827575 */     // GIR_Coverage, 22442,
     /*  827575 */     GIR_EraseRootFromParent_Done,
     /*  827576 */   // Label 12749: @827576
     /*  827576 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(827651), // Rule ID 22443 //
     /*  827581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  827630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827649 */     GIR_RootConstrainSelectedInstOperands,
     /*  827650 */     // GIR_Coverage, 22443,
     /*  827650 */     GIR_EraseRootFromParent_Done,
     /*  827651 */   // Label 12750: @827651
     /*  827651 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(827726), // Rule ID 22446 //
     /*  827656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  827705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827724 */     GIR_RootConstrainSelectedInstOperands,
     /*  827725 */     // GIR_Coverage, 22446,
     /*  827725 */     GIR_EraseRootFromParent_Done,
     /*  827726 */   // Label 12751: @827726
     /*  827726 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(827801), // Rule ID 22447 //
     /*  827731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  827780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827799 */     GIR_RootConstrainSelectedInstOperands,
     /*  827800 */     // GIR_Coverage, 22447,
     /*  827800 */     GIR_EraseRootFromParent_Done,
     /*  827801 */   // Label 12752: @827801
     /*  827801 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(827876), // Rule ID 22450 //
     /*  827806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  827855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827874 */     GIR_RootConstrainSelectedInstOperands,
     /*  827875 */     // GIR_Coverage, 22450,
     /*  827875 */     GIR_EraseRootFromParent_Done,
     /*  827876 */   // Label 12753: @827876
     /*  827876 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(827951), // Rule ID 22451 //
     /*  827881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  827930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827949 */     GIR_RootConstrainSelectedInstOperands,
     /*  827950 */     // GIR_Coverage, 22451,
     /*  827950 */     GIR_EraseRootFromParent_Done,
     /*  827951 */   // Label 12754: @827951
     /*  827951 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(828026), // Rule ID 22454 //
     /*  827956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  827964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  828005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828024 */     GIR_RootConstrainSelectedInstOperands,
     /*  828025 */     // GIR_Coverage, 22454,
     /*  828025 */     GIR_EraseRootFromParent_Done,
     /*  828026 */   // Label 12755: @828026
     /*  828026 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(828101), // Rule ID 22455 //
     /*  828031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  828048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  828080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828099 */     GIR_RootConstrainSelectedInstOperands,
     /*  828100 */     // GIR_Coverage, 22455,
     /*  828100 */     GIR_EraseRootFromParent_Done,
     /*  828101 */   // Label 12756: @828101
     /*  828101 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(828176), // Rule ID 22458 //
     /*  828106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  828155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828174 */     GIR_RootConstrainSelectedInstOperands,
     /*  828175 */     // GIR_Coverage, 22458,
     /*  828175 */     GIR_EraseRootFromParent_Done,
     /*  828176 */   // Label 12757: @828176
     /*  828176 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(828251), // Rule ID 22459 //
     /*  828181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  828198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  828230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828249 */     GIR_RootConstrainSelectedInstOperands,
     /*  828250 */     // GIR_Coverage, 22459,
     /*  828250 */     GIR_EraseRootFromParent_Done,
     /*  828251 */   // Label 12758: @828251
     /*  828251 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(828326), // Rule ID 22462 //
     /*  828256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  828305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828324 */     GIR_RootConstrainSelectedInstOperands,
     /*  828325 */     // GIR_Coverage, 22462,
     /*  828325 */     GIR_EraseRootFromParent_Done,
     /*  828326 */   // Label 12759: @828326
     /*  828326 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(828401), // Rule ID 22463 //
     /*  828331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  828348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  828380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828399 */     GIR_RootConstrainSelectedInstOperands,
     /*  828400 */     // GIR_Coverage, 22463,
     /*  828400 */     GIR_EraseRootFromParent_Done,
     /*  828401 */   // Label 12760: @828401
     /*  828401 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(828476), // Rule ID 22466 //
     /*  828406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  828455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828474 */     GIR_RootConstrainSelectedInstOperands,
     /*  828475 */     // GIR_Coverage, 22466,
     /*  828475 */     GIR_EraseRootFromParent_Done,
     /*  828476 */   // Label 12761: @828476
     /*  828476 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(828551), // Rule ID 22467 //
     /*  828481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  828498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  828530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828549 */     GIR_RootConstrainSelectedInstOperands,
     /*  828550 */     // GIR_Coverage, 22467,
     /*  828550 */     GIR_EraseRootFromParent_Done,
     /*  828551 */   // Label 12762: @828551
     /*  828551 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(828626), // Rule ID 22470 //
     /*  828556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  828605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828624 */     GIR_RootConstrainSelectedInstOperands,
     /*  828625 */     // GIR_Coverage, 22470,
     /*  828625 */     GIR_EraseRootFromParent_Done,
     /*  828626 */   // Label 12763: @828626
     /*  828626 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(828701), // Rule ID 22471 //
     /*  828631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  828680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828699 */     GIR_RootConstrainSelectedInstOperands,
     /*  828700 */     // GIR_Coverage, 22471,
     /*  828700 */     GIR_EraseRootFromParent_Done,
     /*  828701 */   // Label 12764: @828701
     /*  828701 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(828776), // Rule ID 22474 //
     /*  828706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  828755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828774 */     GIR_RootConstrainSelectedInstOperands,
     /*  828775 */     // GIR_Coverage, 22474,
     /*  828775 */     GIR_EraseRootFromParent_Done,
     /*  828776 */   // Label 12765: @828776
     /*  828776 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(828851), // Rule ID 22475 //
     /*  828781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  828830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828849 */     GIR_RootConstrainSelectedInstOperands,
     /*  828850 */     // GIR_Coverage, 22475,
     /*  828850 */     GIR_EraseRootFromParent_Done,
     /*  828851 */   // Label 12766: @828851
     /*  828851 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(828926), // Rule ID 22478 //
     /*  828856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  828905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828924 */     GIR_RootConstrainSelectedInstOperands,
     /*  828925 */     // GIR_Coverage, 22478,
     /*  828925 */     GIR_EraseRootFromParent_Done,
     /*  828926 */   // Label 12767: @828926
     /*  828926 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(829001), // Rule ID 22479 //
     /*  828931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  828939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  828980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828999 */     GIR_RootConstrainSelectedInstOperands,
     /*  829000 */     // GIR_Coverage, 22479,
     /*  829000 */     GIR_EraseRootFromParent_Done,
     /*  829001 */   // Label 12768: @829001
     /*  829001 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(829076), // Rule ID 22482 //
     /*  829006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  829055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829074 */     GIR_RootConstrainSelectedInstOperands,
     /*  829075 */     // GIR_Coverage, 22482,
     /*  829075 */     GIR_EraseRootFromParent_Done,
     /*  829076 */   // Label 12769: @829076
     /*  829076 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(829151), // Rule ID 22483 //
     /*  829081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  829098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  829130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829149 */     GIR_RootConstrainSelectedInstOperands,
     /*  829150 */     // GIR_Coverage, 22483,
     /*  829150 */     GIR_EraseRootFromParent_Done,
     /*  829151 */   // Label 12770: @829151
     /*  829151 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(829226), // Rule ID 22486 //
     /*  829156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  829205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829224 */     GIR_RootConstrainSelectedInstOperands,
     /*  829225 */     // GIR_Coverage, 22486,
     /*  829225 */     GIR_EraseRootFromParent_Done,
     /*  829226 */   // Label 12771: @829226
     /*  829226 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(829301), // Rule ID 22487 //
     /*  829231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  829248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  829280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829299 */     GIR_RootConstrainSelectedInstOperands,
     /*  829300 */     // GIR_Coverage, 22487,
     /*  829300 */     GIR_EraseRootFromParent_Done,
     /*  829301 */   // Label 12772: @829301
     /*  829301 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(829376), // Rule ID 22490 //
     /*  829306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  829355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829374 */     GIR_RootConstrainSelectedInstOperands,
     /*  829375 */     // GIR_Coverage, 22490,
     /*  829375 */     GIR_EraseRootFromParent_Done,
     /*  829376 */   // Label 12773: @829376
     /*  829376 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(829451), // Rule ID 22491 //
     /*  829381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  829398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  829416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  829430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829449 */     GIR_RootConstrainSelectedInstOperands,
     /*  829450 */     // GIR_Coverage, 22491,
     /*  829450 */     GIR_EraseRootFromParent_Done,
     /*  829451 */   // Label 12774: @829451
     /*  829451 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(829526), // Rule ID 22494 //
     /*  829456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  829505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829524 */     GIR_RootConstrainSelectedInstOperands,
     /*  829525 */     // GIR_Coverage, 22494,
     /*  829525 */     GIR_EraseRootFromParent_Done,
     /*  829526 */   // Label 12775: @829526
     /*  829526 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(829601), // Rule ID 22495 //
     /*  829531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  829580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829599 */     GIR_RootConstrainSelectedInstOperands,
     /*  829600 */     // GIR_Coverage, 22495,
     /*  829600 */     GIR_EraseRootFromParent_Done,
     /*  829601 */   // Label 12776: @829601
     /*  829601 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(829676), // Rule ID 22498 //
     /*  829606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  829655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829674 */     GIR_RootConstrainSelectedInstOperands,
     /*  829675 */     // GIR_Coverage, 22498,
     /*  829675 */     GIR_EraseRootFromParent_Done,
     /*  829676 */   // Label 12777: @829676
     /*  829676 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(829751), // Rule ID 22499 //
     /*  829681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  829689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  829730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829749 */     GIR_RootConstrainSelectedInstOperands,
     /*  829750 */     // GIR_Coverage, 22499,
     /*  829750 */     GIR_EraseRootFromParent_Done,
     /*  829751 */   // Label 12778: @829751
     /*  829751 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(829826), // Rule ID 22502 //
     /*  829756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  829805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829824 */     GIR_RootConstrainSelectedInstOperands,
     /*  829825 */     // GIR_Coverage, 22502,
     /*  829825 */     GIR_EraseRootFromParent_Done,
     /*  829826 */   // Label 12779: @829826
     /*  829826 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(829901), // Rule ID 22503 //
     /*  829831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829877 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  829880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829899 */     GIR_RootConstrainSelectedInstOperands,
     /*  829900 */     // GIR_Coverage, 22503,
     /*  829900 */     GIR_EraseRootFromParent_Done,
     /*  829901 */   // Label 12780: @829901
     /*  829901 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(829976), // Rule ID 22506 //
     /*  829906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  829955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829974 */     GIR_RootConstrainSelectedInstOperands,
     /*  829975 */     // GIR_Coverage, 22506,
     /*  829975 */     GIR_EraseRootFromParent_Done,
     /*  829976 */   // Label 12781: @829976
     /*  829976 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(830051), // Rule ID 22507 //
     /*  829981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  830030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830049 */     GIR_RootConstrainSelectedInstOperands,
     /*  830050 */     // GIR_Coverage, 22507,
     /*  830050 */     GIR_EraseRootFromParent_Done,
     /*  830051 */   // Label 12782: @830051
     /*  830051 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(830126), // Rule ID 22510 //
     /*  830056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  830105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830124 */     GIR_RootConstrainSelectedInstOperands,
     /*  830125 */     // GIR_Coverage, 22510,
     /*  830125 */     GIR_EraseRootFromParent_Done,
     /*  830126 */   // Label 12783: @830126
     /*  830126 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(830201), // Rule ID 22511 //
     /*  830131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  830148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  830180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830199 */     GIR_RootConstrainSelectedInstOperands,
     /*  830200 */     // GIR_Coverage, 22511,
     /*  830200 */     GIR_EraseRootFromParent_Done,
     /*  830201 */   // Label 12784: @830201
     /*  830201 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(830276), // Rule ID 22514 //
     /*  830206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  830255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830274 */     GIR_RootConstrainSelectedInstOperands,
     /*  830275 */     // GIR_Coverage, 22514,
     /*  830275 */     GIR_EraseRootFromParent_Done,
     /*  830276 */   // Label 12785: @830276
     /*  830276 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(830351), // Rule ID 22515 //
     /*  830281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  830298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  830330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830349 */     GIR_RootConstrainSelectedInstOperands,
     /*  830350 */     // GIR_Coverage, 22515,
     /*  830350 */     GIR_EraseRootFromParent_Done,
     /*  830351 */   // Label 12786: @830351
     /*  830351 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(830426), // Rule ID 22518 //
     /*  830356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  830405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830424 */     GIR_RootConstrainSelectedInstOperands,
     /*  830425 */     // GIR_Coverage, 22518,
     /*  830425 */     GIR_EraseRootFromParent_Done,
     /*  830426 */   // Label 12787: @830426
     /*  830426 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(830501), // Rule ID 22519 //
     /*  830431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  830448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  830480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830499 */     GIR_RootConstrainSelectedInstOperands,
     /*  830500 */     // GIR_Coverage, 22519,
     /*  830500 */     GIR_EraseRootFromParent_Done,
     /*  830501 */   // Label 12788: @830501
     /*  830501 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(830576), // Rule ID 22522 //
     /*  830506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  830555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830574 */     GIR_RootConstrainSelectedInstOperands,
     /*  830575 */     // GIR_Coverage, 22522,
     /*  830575 */     GIR_EraseRootFromParent_Done,
     /*  830576 */   // Label 12789: @830576
     /*  830576 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(830651), // Rule ID 22523 //
     /*  830581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  830630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830649 */     GIR_RootConstrainSelectedInstOperands,
     /*  830650 */     // GIR_Coverage, 22523,
     /*  830650 */     GIR_EraseRootFromParent_Done,
     /*  830651 */   // Label 12790: @830651
     /*  830651 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(830726), // Rule ID 22526 //
     /*  830656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  830705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830724 */     GIR_RootConstrainSelectedInstOperands,
     /*  830725 */     // GIR_Coverage, 22526,
     /*  830725 */     GIR_EraseRootFromParent_Done,
     /*  830726 */   // Label 12791: @830726
     /*  830726 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(830801), // Rule ID 22527 //
     /*  830731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830777 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  830780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830799 */     GIR_RootConstrainSelectedInstOperands,
     /*  830800 */     // GIR_Coverage, 22527,
     /*  830800 */     GIR_EraseRootFromParent_Done,
     /*  830801 */   // Label 12792: @830801
     /*  830801 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(830876), // Rule ID 22530 //
     /*  830806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  830855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830874 */     GIR_RootConstrainSelectedInstOperands,
     /*  830875 */     // GIR_Coverage, 22530,
     /*  830875 */     GIR_EraseRootFromParent_Done,
     /*  830876 */   // Label 12793: @830876
     /*  830876 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(830951), // Rule ID 22531 //
     /*  830881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  830930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830949 */     GIR_RootConstrainSelectedInstOperands,
     /*  830950 */     // GIR_Coverage, 22531,
     /*  830950 */     GIR_EraseRootFromParent_Done,
     /*  830951 */   // Label 12794: @830951
     /*  830951 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(831026), // Rule ID 22534 //
     /*  830956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  830964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  831005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831024 */     GIR_RootConstrainSelectedInstOperands,
     /*  831025 */     // GIR_Coverage, 22534,
     /*  831025 */     GIR_EraseRootFromParent_Done,
     /*  831026 */   // Label 12795: @831026
     /*  831026 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(831101), // Rule ID 22535 //
     /*  831031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  831048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  831080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831099 */     GIR_RootConstrainSelectedInstOperands,
     /*  831100 */     // GIR_Coverage, 22535,
     /*  831100 */     GIR_EraseRootFromParent_Done,
     /*  831101 */   // Label 12796: @831101
     /*  831101 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(831176), // Rule ID 22538 //
     /*  831106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  831155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831174 */     GIR_RootConstrainSelectedInstOperands,
     /*  831175 */     // GIR_Coverage, 22538,
     /*  831175 */     GIR_EraseRootFromParent_Done,
     /*  831176 */   // Label 12797: @831176
     /*  831176 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(831251), // Rule ID 22539 //
     /*  831181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  831198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  831230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831249 */     GIR_RootConstrainSelectedInstOperands,
     /*  831250 */     // GIR_Coverage, 22539,
     /*  831250 */     GIR_EraseRootFromParent_Done,
     /*  831251 */   // Label 12798: @831251
     /*  831251 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(831326), // Rule ID 22542 //
     /*  831256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  831305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831324 */     GIR_RootConstrainSelectedInstOperands,
     /*  831325 */     // GIR_Coverage, 22542,
     /*  831325 */     GIR_EraseRootFromParent_Done,
     /*  831326 */   // Label 12799: @831326
     /*  831326 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(831401), // Rule ID 22543 //
     /*  831331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  831348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  831380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831399 */     GIR_RootConstrainSelectedInstOperands,
     /*  831400 */     // GIR_Coverage, 22543,
     /*  831400 */     GIR_EraseRootFromParent_Done,
     /*  831401 */   // Label 12800: @831401
     /*  831401 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(831476), // Rule ID 22546 //
     /*  831406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  831455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831474 */     GIR_RootConstrainSelectedInstOperands,
     /*  831475 */     // GIR_Coverage, 22546,
     /*  831475 */     GIR_EraseRootFromParent_Done,
     /*  831476 */   // Label 12801: @831476
     /*  831476 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(831551), // Rule ID 22547 //
     /*  831481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  831498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  831530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831549 */     GIR_RootConstrainSelectedInstOperands,
     /*  831550 */     // GIR_Coverage, 22547,
     /*  831550 */     GIR_EraseRootFromParent_Done,
     /*  831551 */   // Label 12802: @831551
     /*  831551 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(831626), // Rule ID 22550 //
     /*  831556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  831605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831624 */     GIR_RootConstrainSelectedInstOperands,
     /*  831625 */     // GIR_Coverage, 22550,
     /*  831625 */     GIR_EraseRootFromParent_Done,
     /*  831626 */   // Label 12803: @831626
     /*  831626 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(831701), // Rule ID 22551 //
     /*  831631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  831680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831699 */     GIR_RootConstrainSelectedInstOperands,
     /*  831700 */     // GIR_Coverage, 22551,
     /*  831700 */     GIR_EraseRootFromParent_Done,
     /*  831701 */   // Label 12804: @831701
     /*  831701 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(831776), // Rule ID 22554 //
     /*  831706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  831755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831774 */     GIR_RootConstrainSelectedInstOperands,
     /*  831775 */     // GIR_Coverage, 22554,
     /*  831775 */     GIR_EraseRootFromParent_Done,
     /*  831776 */   // Label 12805: @831776
     /*  831776 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(831851), // Rule ID 22555 //
     /*  831781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  831830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831849 */     GIR_RootConstrainSelectedInstOperands,
     /*  831850 */     // GIR_Coverage, 22555,
     /*  831850 */     GIR_EraseRootFromParent_Done,
     /*  831851 */   // Label 12806: @831851
     /*  831851 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(831926), // Rule ID 22558 //
     /*  831856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  831905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831924 */     GIR_RootConstrainSelectedInstOperands,
     /*  831925 */     // GIR_Coverage, 22558,
     /*  831925 */     GIR_EraseRootFromParent_Done,
     /*  831926 */   // Label 12807: @831926
     /*  831926 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(832001), // Rule ID 22559 //
     /*  831931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  831939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  831980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831999 */     GIR_RootConstrainSelectedInstOperands,
     /*  832000 */     // GIR_Coverage, 22559,
     /*  832000 */     GIR_EraseRootFromParent_Done,
     /*  832001 */   // Label 12808: @832001
     /*  832001 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(832076), // Rule ID 22562 //
     /*  832006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  832052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  832055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832074 */     GIR_RootConstrainSelectedInstOperands,
     /*  832075 */     // GIR_Coverage, 22562,
     /*  832075 */     GIR_EraseRootFromParent_Done,
     /*  832076 */   // Label 12809: @832076
     /*  832076 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(832151), // Rule ID 22563 //
     /*  832081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  832098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  832130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832149 */     GIR_RootConstrainSelectedInstOperands,
     /*  832150 */     // GIR_Coverage, 22563,
     /*  832150 */     GIR_EraseRootFromParent_Done,
     /*  832151 */   // Label 12810: @832151
     /*  832151 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(832226), // Rule ID 22566 //
     /*  832156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  832205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832224 */     GIR_RootConstrainSelectedInstOperands,
     /*  832225 */     // GIR_Coverage, 22566,
     /*  832225 */     GIR_EraseRootFromParent_Done,
     /*  832226 */   // Label 12811: @832226
     /*  832226 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(832301), // Rule ID 22567 //
     /*  832231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  832248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  832280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832299 */     GIR_RootConstrainSelectedInstOperands,
     /*  832300 */     // GIR_Coverage, 22567,
     /*  832300 */     GIR_EraseRootFromParent_Done,
     /*  832301 */   // Label 12812: @832301
     /*  832301 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(832376), // Rule ID 22570 //
     /*  832306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  832355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832374 */     GIR_RootConstrainSelectedInstOperands,
     /*  832375 */     // GIR_Coverage, 22570,
     /*  832375 */     GIR_EraseRootFromParent_Done,
     /*  832376 */   // Label 12813: @832376
     /*  832376 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(832451), // Rule ID 22571 //
     /*  832381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  832398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  832430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832449 */     GIR_RootConstrainSelectedInstOperands,
     /*  832450 */     // GIR_Coverage, 22571,
     /*  832450 */     GIR_EraseRootFromParent_Done,
     /*  832451 */   // Label 12814: @832451
     /*  832451 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(832526), // Rule ID 22574 //
     /*  832456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  832505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832524 */     GIR_RootConstrainSelectedInstOperands,
     /*  832525 */     // GIR_Coverage, 22574,
     /*  832525 */     GIR_EraseRootFromParent_Done,
     /*  832526 */   // Label 12815: @832526
     /*  832526 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(832601), // Rule ID 22575 //
     /*  832531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  832580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832599 */     GIR_RootConstrainSelectedInstOperands,
     /*  832600 */     // GIR_Coverage, 22575,
     /*  832600 */     GIR_EraseRootFromParent_Done,
     /*  832601 */   // Label 12816: @832601
     /*  832601 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(832676), // Rule ID 22578 //
     /*  832606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  832655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832674 */     GIR_RootConstrainSelectedInstOperands,
     /*  832675 */     // GIR_Coverage, 22578,
     /*  832675 */     GIR_EraseRootFromParent_Done,
     /*  832676 */   // Label 12817: @832676
     /*  832676 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(832751), // Rule ID 22579 //
     /*  832681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  832730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832749 */     GIR_RootConstrainSelectedInstOperands,
     /*  832750 */     // GIR_Coverage, 22579,
     /*  832750 */     GIR_EraseRootFromParent_Done,
     /*  832751 */   // Label 12818: @832751
     /*  832751 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(832826), // Rule ID 22582 //
     /*  832756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  832805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832824 */     GIR_RootConstrainSelectedInstOperands,
     /*  832825 */     // GIR_Coverage, 22582,
     /*  832825 */     GIR_EraseRootFromParent_Done,
     /*  832826 */   // Label 12819: @832826
     /*  832826 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(832901), // Rule ID 22583 //
     /*  832831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  832880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832899 */     GIR_RootConstrainSelectedInstOperands,
     /*  832900 */     // GIR_Coverage, 22583,
     /*  832900 */     GIR_EraseRootFromParent_Done,
     /*  832901 */   // Label 12820: @832901
     /*  832901 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(832976), // Rule ID 22586 //
     /*  832906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  832955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832974 */     GIR_RootConstrainSelectedInstOperands,
     /*  832975 */     // GIR_Coverage, 22586,
     /*  832975 */     GIR_EraseRootFromParent_Done,
     /*  832976 */   // Label 12821: @832976
     /*  832976 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(833051), // Rule ID 22587 //
     /*  832981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  832989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  833016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  833027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  833030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  833046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833049 */     GIR_RootConstrainSelectedInstOperands,
     /*  833050 */     // GIR_Coverage, 22587,
     /*  833050 */     GIR_EraseRootFromParent_Done,
     /*  833051 */   // Label 12822: @833051
     /*  833051 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(833126), // Rule ID 22590 //
     /*  833056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  833105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833124 */     GIR_RootConstrainSelectedInstOperands,
     /*  833125 */     // GIR_Coverage, 22590,
     /*  833125 */     GIR_EraseRootFromParent_Done,
     /*  833126 */   // Label 12823: @833126
     /*  833126 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(833201), // Rule ID 22591 //
     /*  833131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  833148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  833180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833199 */     GIR_RootConstrainSelectedInstOperands,
     /*  833200 */     // GIR_Coverage, 22591,
     /*  833200 */     GIR_EraseRootFromParent_Done,
     /*  833201 */   // Label 12824: @833201
     /*  833201 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(833276), // Rule ID 22594 //
     /*  833206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  833255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833274 */     GIR_RootConstrainSelectedInstOperands,
     /*  833275 */     // GIR_Coverage, 22594,
     /*  833275 */     GIR_EraseRootFromParent_Done,
     /*  833276 */   // Label 12825: @833276
     /*  833276 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(833351), // Rule ID 22595 //
     /*  833281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  833298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  833330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833349 */     GIR_RootConstrainSelectedInstOperands,
     /*  833350 */     // GIR_Coverage, 22595,
     /*  833350 */     GIR_EraseRootFromParent_Done,
     /*  833351 */   // Label 12826: @833351
     /*  833351 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(833426), // Rule ID 22598 //
     /*  833356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  833405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833424 */     GIR_RootConstrainSelectedInstOperands,
     /*  833425 */     // GIR_Coverage, 22598,
     /*  833425 */     GIR_EraseRootFromParent_Done,
     /*  833426 */   // Label 12827: @833426
     /*  833426 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(833501), // Rule ID 22599 //
     /*  833431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  833448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  833480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833499 */     GIR_RootConstrainSelectedInstOperands,
     /*  833500 */     // GIR_Coverage, 22599,
     /*  833500 */     GIR_EraseRootFromParent_Done,
     /*  833501 */   // Label 12828: @833501
     /*  833501 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(833576), // Rule ID 22602 //
     /*  833506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  833555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833574 */     GIR_RootConstrainSelectedInstOperands,
     /*  833575 */     // GIR_Coverage, 22602,
     /*  833575 */     GIR_EraseRootFromParent_Done,
     /*  833576 */   // Label 12829: @833576
     /*  833576 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(833651), // Rule ID 22603 //
     /*  833581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  833630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833649 */     GIR_RootConstrainSelectedInstOperands,
     /*  833650 */     // GIR_Coverage, 22603,
     /*  833650 */     GIR_EraseRootFromParent_Done,
     /*  833651 */   // Label 12830: @833651
     /*  833651 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(833726), // Rule ID 22606 //
     /*  833656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  833705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833724 */     GIR_RootConstrainSelectedInstOperands,
     /*  833725 */     // GIR_Coverage, 22606,
     /*  833725 */     GIR_EraseRootFromParent_Done,
     /*  833726 */   // Label 12831: @833726
     /*  833726 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(833801), // Rule ID 22607 //
     /*  833731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  833780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833799 */     GIR_RootConstrainSelectedInstOperands,
     /*  833800 */     // GIR_Coverage, 22607,
     /*  833800 */     GIR_EraseRootFromParent_Done,
     /*  833801 */   // Label 12832: @833801
     /*  833801 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(833876), // Rule ID 22610 //
     /*  833806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  833855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833874 */     GIR_RootConstrainSelectedInstOperands,
     /*  833875 */     // GIR_Coverage, 22610,
     /*  833875 */     GIR_EraseRootFromParent_Done,
     /*  833876 */   // Label 12833: @833876
     /*  833876 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(833951), // Rule ID 22611 //
     /*  833881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  833930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833949 */     GIR_RootConstrainSelectedInstOperands,
     /*  833950 */     // GIR_Coverage, 22611,
     /*  833950 */     GIR_EraseRootFromParent_Done,
     /*  833951 */   // Label 12834: @833951
     /*  833951 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(834026), // Rule ID 22614 //
     /*  833956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  833964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  833967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  833970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  833976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  834005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834024 */     GIR_RootConstrainSelectedInstOperands,
     /*  834025 */     // GIR_Coverage, 22614,
     /*  834025 */     GIR_EraseRootFromParent_Done,
     /*  834026 */   // Label 12835: @834026
     /*  834026 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(834101), // Rule ID 22615 //
     /*  834031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  834048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  834080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834099 */     GIR_RootConstrainSelectedInstOperands,
     /*  834100 */     // GIR_Coverage, 22615,
     /*  834100 */     GIR_EraseRootFromParent_Done,
     /*  834101 */   // Label 12836: @834101
     /*  834101 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(834176), // Rule ID 22618 //
     /*  834106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  834155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834174 */     GIR_RootConstrainSelectedInstOperands,
     /*  834175 */     // GIR_Coverage, 22618,
     /*  834175 */     GIR_EraseRootFromParent_Done,
     /*  834176 */   // Label 12837: @834176
     /*  834176 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(834251), // Rule ID 22619 //
     /*  834181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  834198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  834230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834249 */     GIR_RootConstrainSelectedInstOperands,
     /*  834250 */     // GIR_Coverage, 22619,
     /*  834250 */     GIR_EraseRootFromParent_Done,
     /*  834251 */   // Label 12838: @834251
     /*  834251 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(834326), // Rule ID 22622 //
     /*  834256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  834305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834324 */     GIR_RootConstrainSelectedInstOperands,
     /*  834325 */     // GIR_Coverage, 22622,
     /*  834325 */     GIR_EraseRootFromParent_Done,
     /*  834326 */   // Label 12839: @834326
     /*  834326 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(834401), // Rule ID 22623 //
     /*  834331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  834348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834377 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  834380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834399 */     GIR_RootConstrainSelectedInstOperands,
     /*  834400 */     // GIR_Coverage, 22623,
     /*  834400 */     GIR_EraseRootFromParent_Done,
     /*  834401 */   // Label 12840: @834401
     /*  834401 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(834476), // Rule ID 22626 //
     /*  834406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  834409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  834452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  834455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834474 */     GIR_RootConstrainSelectedInstOperands,
     /*  834475 */     // GIR_Coverage, 22626,
     /*  834475 */     GIR_EraseRootFromParent_Done,
     /*  834476 */   // Label 12841: @834476
     /*  834476 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(834551), // Rule ID 22627 //
     /*  834481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  834484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  834498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  834527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  834530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  834546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834549 */     GIR_RootConstrainSelectedInstOperands,
     /*  834550 */     // GIR_Coverage, 22627,
     /*  834550 */     GIR_EraseRootFromParent_Done,
     /*  834551 */   // Label 12842: @834551
     /*  834551 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(834626), // Rule ID 22630 //
     /*  834556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  834605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834624 */     GIR_RootConstrainSelectedInstOperands,
     /*  834625 */     // GIR_Coverage, 22630,
     /*  834625 */     GIR_EraseRootFromParent_Done,
     /*  834626 */   // Label 12843: @834626
     /*  834626 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(834701), // Rule ID 22631 //
     /*  834631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  834648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  834680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834699 */     GIR_RootConstrainSelectedInstOperands,
     /*  834700 */     // GIR_Coverage, 22631,
     /*  834700 */     GIR_EraseRootFromParent_Done,
     /*  834701 */   // Label 12844: @834701
     /*  834701 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(834776), // Rule ID 22634 //
     /*  834706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  834755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834774 */     GIR_RootConstrainSelectedInstOperands,
     /*  834775 */     // GIR_Coverage, 22634,
     /*  834775 */     GIR_EraseRootFromParent_Done,
     /*  834776 */   // Label 12845: @834776
     /*  834776 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(834851), // Rule ID 22635 //
     /*  834781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  834830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834849 */     GIR_RootConstrainSelectedInstOperands,
     /*  834850 */     // GIR_Coverage, 22635,
     /*  834850 */     GIR_EraseRootFromParent_Done,
     /*  834851 */   // Label 12846: @834851
     /*  834851 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(834926), // Rule ID 22638 //
     /*  834856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  834905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834924 */     GIR_RootConstrainSelectedInstOperands,
     /*  834925 */     // GIR_Coverage, 22638,
     /*  834925 */     GIR_EraseRootFromParent_Done,
     /*  834926 */   // Label 12847: @834926
     /*  834926 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(835001), // Rule ID 22639 //
     /*  834931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  834939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  834942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  834945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  834951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  834980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834999 */     GIR_RootConstrainSelectedInstOperands,
     /*  835000 */     // GIR_Coverage, 22639,
     /*  835000 */     GIR_EraseRootFromParent_Done,
     /*  835001 */   // Label 12848: @835001
     /*  835001 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(835076), // Rule ID 22642 //
     /*  835006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  835023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  835055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835074 */     GIR_RootConstrainSelectedInstOperands,
     /*  835075 */     // GIR_Coverage, 22642,
     /*  835075 */     GIR_EraseRootFromParent_Done,
     /*  835076 */   // Label 12849: @835076
     /*  835076 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(835151), // Rule ID 22643 //
     /*  835081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  835098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  835130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835149 */     GIR_RootConstrainSelectedInstOperands,
     /*  835150 */     // GIR_Coverage, 22643,
     /*  835150 */     GIR_EraseRootFromParent_Done,
     /*  835151 */   // Label 12850: @835151
     /*  835151 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(835226), // Rule ID 22646 //
     /*  835156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  835205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835224 */     GIR_RootConstrainSelectedInstOperands,
     /*  835225 */     // GIR_Coverage, 22646,
     /*  835225 */     GIR_EraseRootFromParent_Done,
     /*  835226 */   // Label 12851: @835226
     /*  835226 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(835301), // Rule ID 22647 //
     /*  835231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  835248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  835280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835299 */     GIR_RootConstrainSelectedInstOperands,
     /*  835300 */     // GIR_Coverage, 22647,
     /*  835300 */     GIR_EraseRootFromParent_Done,
     /*  835301 */   // Label 12852: @835301
     /*  835301 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(835376), // Rule ID 22650 //
     /*  835306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  835355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835374 */     GIR_RootConstrainSelectedInstOperands,
     /*  835375 */     // GIR_Coverage, 22650,
     /*  835375 */     GIR_EraseRootFromParent_Done,
     /*  835376 */   // Label 12853: @835376
     /*  835376 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(835451), // Rule ID 22651 //
     /*  835381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  835398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  835430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835449 */     GIR_RootConstrainSelectedInstOperands,
     /*  835450 */     // GIR_Coverage, 22651,
     /*  835450 */     GIR_EraseRootFromParent_Done,
     /*  835451 */   // Label 12854: @835451
     /*  835451 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(835526), // Rule ID 22654 //
     /*  835456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  835505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835524 */     GIR_RootConstrainSelectedInstOperands,
     /*  835525 */     // GIR_Coverage, 22654,
     /*  835525 */     GIR_EraseRootFromParent_Done,
     /*  835526 */   // Label 12855: @835526
     /*  835526 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(835601), // Rule ID 22655 //
     /*  835531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  835548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  835580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835599 */     GIR_RootConstrainSelectedInstOperands,
     /*  835600 */     // GIR_Coverage, 22655,
     /*  835600 */     GIR_EraseRootFromParent_Done,
     /*  835601 */   // Label 12856: @835601
     /*  835601 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(835676), // Rule ID 22658 //
     /*  835606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  835655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835674 */     GIR_RootConstrainSelectedInstOperands,
     /*  835675 */     // GIR_Coverage, 22658,
     /*  835675 */     GIR_EraseRootFromParent_Done,
     /*  835676 */   // Label 12857: @835676
     /*  835676 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(835751), // Rule ID 22659 //
     /*  835681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  835730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835749 */     GIR_RootConstrainSelectedInstOperands,
     /*  835750 */     // GIR_Coverage, 22659,
     /*  835750 */     GIR_EraseRootFromParent_Done,
     /*  835751 */   // Label 12858: @835751
     /*  835751 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(835826), // Rule ID 22662 //
     /*  835756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  835805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835824 */     GIR_RootConstrainSelectedInstOperands,
     /*  835825 */     // GIR_Coverage, 22662,
     /*  835825 */     GIR_EraseRootFromParent_Done,
     /*  835826 */   // Label 12859: @835826
     /*  835826 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(835901), // Rule ID 22663 //
     /*  835831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  835880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835899 */     GIR_RootConstrainSelectedInstOperands,
     /*  835900 */     // GIR_Coverage, 22663,
     /*  835900 */     GIR_EraseRootFromParent_Done,
     /*  835901 */   // Label 12860: @835901
     /*  835901 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(835976), // Rule ID 22666 //
     /*  835906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  835909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  835923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  835941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  835952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  835955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  835971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835974 */     GIR_RootConstrainSelectedInstOperands,
     /*  835975 */     // GIR_Coverage, 22666,
     /*  835975 */     GIR_EraseRootFromParent_Done,
     /*  835976 */   // Label 12861: @835976
     /*  835976 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(836051), // Rule ID 22667 //
     /*  835981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  835984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  835989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  835998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  836030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836049 */     GIR_RootConstrainSelectedInstOperands,
     /*  836050 */     // GIR_Coverage, 22667,
     /*  836050 */     GIR_EraseRootFromParent_Done,
     /*  836051 */   // Label 12862: @836051
     /*  836051 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(836126), // Rule ID 22670 //
     /*  836056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  836105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836124 */     GIR_RootConstrainSelectedInstOperands,
     /*  836125 */     // GIR_Coverage, 22670,
     /*  836125 */     GIR_EraseRootFromParent_Done,
     /*  836126 */   // Label 12863: @836126
     /*  836126 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(836201), // Rule ID 22671 //
     /*  836131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  836148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  836180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836199 */     GIR_RootConstrainSelectedInstOperands,
     /*  836200 */     // GIR_Coverage, 22671,
     /*  836200 */     GIR_EraseRootFromParent_Done,
     /*  836201 */   // Label 12864: @836201
     /*  836201 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(836276), // Rule ID 22674 //
     /*  836206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  836209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  836252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  836255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836274 */     GIR_RootConstrainSelectedInstOperands,
     /*  836275 */     // GIR_Coverage, 22674,
     /*  836275 */     GIR_EraseRootFromParent_Done,
     /*  836276 */   // Label 12865: @836276
     /*  836276 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(836351), // Rule ID 22675 //
     /*  836281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  836284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  836289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  836298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  836327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  836330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  836346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836349 */     GIR_RootConstrainSelectedInstOperands,
     /*  836350 */     // GIR_Coverage, 22675,
     /*  836350 */     GIR_EraseRootFromParent_Done,
     /*  836351 */   // Label 12866: @836351
     /*  836351 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(836426), // Rule ID 22678 //
     /*  836356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  836405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836424 */     GIR_RootConstrainSelectedInstOperands,
     /*  836425 */     // GIR_Coverage, 22678,
     /*  836425 */     GIR_EraseRootFromParent_Done,
     /*  836426 */   // Label 12867: @836426
     /*  836426 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(836501), // Rule ID 22679 //
     /*  836431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  836448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  836480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836499 */     GIR_RootConstrainSelectedInstOperands,
     /*  836500 */     // GIR_Coverage, 22679,
     /*  836500 */     GIR_EraseRootFromParent_Done,
     /*  836501 */   // Label 12868: @836501
     /*  836501 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(836576), // Rule ID 22682 //
     /*  836506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  836555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836574 */     GIR_RootConstrainSelectedInstOperands,
     /*  836575 */     // GIR_Coverage, 22682,
     /*  836575 */     GIR_EraseRootFromParent_Done,
     /*  836576 */   // Label 12869: @836576
     /*  836576 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(836651), // Rule ID 22683 //
     /*  836581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  836598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  836630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836649 */     GIR_RootConstrainSelectedInstOperands,
     /*  836650 */     // GIR_Coverage, 22683,
     /*  836650 */     GIR_EraseRootFromParent_Done,
     /*  836651 */   // Label 12870: @836651
     /*  836651 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(836726), // Rule ID 22686 //
     /*  836656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  836705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836724 */     GIR_RootConstrainSelectedInstOperands,
     /*  836725 */     // GIR_Coverage, 22686,
     /*  836725 */     GIR_EraseRootFromParent_Done,
     /*  836726 */   // Label 12871: @836726
     /*  836726 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(836801), // Rule ID 22687 //
     /*  836731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  836748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  836780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836799 */     GIR_RootConstrainSelectedInstOperands,
     /*  836800 */     // GIR_Coverage, 22687,
     /*  836800 */     GIR_EraseRootFromParent_Done,
     /*  836801 */   // Label 12872: @836801
     /*  836801 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(836876), // Rule ID 22690 //
     /*  836806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  836855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836874 */     GIR_RootConstrainSelectedInstOperands,
     /*  836875 */     // GIR_Coverage, 22690,
     /*  836875 */     GIR_EraseRootFromParent_Done,
     /*  836876 */   // Label 12873: @836876
     /*  836876 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(836951), // Rule ID 22691 //
     /*  836881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  836898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  836930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836949 */     GIR_RootConstrainSelectedInstOperands,
     /*  836950 */     // GIR_Coverage, 22691,
     /*  836950 */     GIR_EraseRootFromParent_Done,
     /*  836951 */   // Label 12874: @836951
     /*  836951 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(837026), // Rule ID 22694 //
     /*  836956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  836964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  836973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  837005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837024 */     GIR_RootConstrainSelectedInstOperands,
     /*  837025 */     // GIR_Coverage, 22694,
     /*  837025 */     GIR_EraseRootFromParent_Done,
     /*  837026 */   // Label 12875: @837026
     /*  837026 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(837101), // Rule ID 22695 //
     /*  837031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837077 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  837080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837099 */     GIR_RootConstrainSelectedInstOperands,
     /*  837100 */     // GIR_Coverage, 22695,
     /*  837100 */     GIR_EraseRootFromParent_Done,
     /*  837101 */   // Label 12876: @837101
     /*  837101 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(837176), // Rule ID 22698 //
     /*  837106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  837155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837174 */     GIR_RootConstrainSelectedInstOperands,
     /*  837175 */     // GIR_Coverage, 22698,
     /*  837175 */     GIR_EraseRootFromParent_Done,
     /*  837176 */   // Label 12877: @837176
     /*  837176 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(837251), // Rule ID 22699 //
     /*  837181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837227 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  837230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837249 */     GIR_RootConstrainSelectedInstOperands,
     /*  837250 */     // GIR_Coverage, 22699,
     /*  837250 */     GIR_EraseRootFromParent_Done,
     /*  837251 */   // Label 12878: @837251
     /*  837251 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(837326), // Rule ID 22702 //
     /*  837256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  837305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837324 */     GIR_RootConstrainSelectedInstOperands,
     /*  837325 */     // GIR_Coverage, 22702,
     /*  837325 */     GIR_EraseRootFromParent_Done,
     /*  837326 */   // Label 12879: @837326
     /*  837326 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(837401), // Rule ID 22703 //
     /*  837331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  837348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  837380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837399 */     GIR_RootConstrainSelectedInstOperands,
     /*  837400 */     // GIR_Coverage, 22703,
     /*  837400 */     GIR_EraseRootFromParent_Done,
     /*  837401 */   // Label 12880: @837401
     /*  837401 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(837476), // Rule ID 22706 //
     /*  837406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  837455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837474 */     GIR_RootConstrainSelectedInstOperands,
     /*  837475 */     // GIR_Coverage, 22706,
     /*  837475 */     GIR_EraseRootFromParent_Done,
     /*  837476 */   // Label 12881: @837476
     /*  837476 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(837551), // Rule ID 22707 //
     /*  837481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  837530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837549 */     GIR_RootConstrainSelectedInstOperands,
     /*  837550 */     // GIR_Coverage, 22707,
     /*  837550 */     GIR_EraseRootFromParent_Done,
     /*  837551 */   // Label 12882: @837551
     /*  837551 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(837626), // Rule ID 22710 //
     /*  837556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  837573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  837605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837624 */     GIR_RootConstrainSelectedInstOperands,
     /*  837625 */     // GIR_Coverage, 22710,
     /*  837625 */     GIR_EraseRootFromParent_Done,
     /*  837626 */   // Label 12883: @837626
     /*  837626 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(837701), // Rule ID 22711 //
     /*  837631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  837648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  837680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837699 */     GIR_RootConstrainSelectedInstOperands,
     /*  837700 */     // GIR_Coverage, 22711,
     /*  837700 */     GIR_EraseRootFromParent_Done,
     /*  837701 */   // Label 12884: @837701
     /*  837701 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(837776), // Rule ID 22714 //
     /*  837706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  837755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837774 */     GIR_RootConstrainSelectedInstOperands,
     /*  837775 */     // GIR_Coverage, 22714,
     /*  837775 */     GIR_EraseRootFromParent_Done,
     /*  837776 */   // Label 12885: @837776
     /*  837776 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(837851), // Rule ID 22715 //
     /*  837781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  837798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  837830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837849 */     GIR_RootConstrainSelectedInstOperands,
     /*  837850 */     // GIR_Coverage, 22715,
     /*  837850 */     GIR_EraseRootFromParent_Done,
     /*  837851 */   // Label 12886: @837851
     /*  837851 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(837926), // Rule ID 22718 //
     /*  837856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  837902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  837905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837924 */     GIR_RootConstrainSelectedInstOperands,
     /*  837925 */     // GIR_Coverage, 22718,
     /*  837925 */     GIR_EraseRootFromParent_Done,
     /*  837926 */   // Label 12887: @837926
     /*  837926 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(838001), // Rule ID 22719 //
     /*  837931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  837939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  837948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  837977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  837980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837999 */     GIR_RootConstrainSelectedInstOperands,
     /*  838000 */     // GIR_Coverage, 22719,
     /*  838000 */     GIR_EraseRootFromParent_Done,
     /*  838001 */   // Label 12888: @838001
     /*  838001 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(838076), // Rule ID 22722 //
     /*  838006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  838052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  838055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838074 */     GIR_RootConstrainSelectedInstOperands,
     /*  838075 */     // GIR_Coverage, 22722,
     /*  838075 */     GIR_EraseRootFromParent_Done,
     /*  838076 */   // Label 12889: @838076
     /*  838076 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(838151), // Rule ID 22723 //
     /*  838081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  838098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  838127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  838130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  838146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838149 */     GIR_RootConstrainSelectedInstOperands,
     /*  838150 */     // GIR_Coverage, 22723,
     /*  838150 */     GIR_EraseRootFromParent_Done,
     /*  838151 */   // Label 12890: @838151
     /*  838151 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(838226), // Rule ID 22726 //
     /*  838156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  838205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838224 */     GIR_RootConstrainSelectedInstOperands,
     /*  838225 */     // GIR_Coverage, 22726,
     /*  838225 */     GIR_EraseRootFromParent_Done,
     /*  838226 */   // Label 12891: @838226
     /*  838226 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(838301), // Rule ID 22727 //
     /*  838231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  838280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838299 */     GIR_RootConstrainSelectedInstOperands,
     /*  838300 */     // GIR_Coverage, 22727,
     /*  838300 */     GIR_EraseRootFromParent_Done,
     /*  838301 */   // Label 12892: @838301
     /*  838301 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(838376), // Rule ID 22730 //
     /*  838306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  838355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838374 */     GIR_RootConstrainSelectedInstOperands,
     /*  838375 */     // GIR_Coverage, 22730,
     /*  838375 */     GIR_EraseRootFromParent_Done,
     /*  838376 */   // Label 12893: @838376
     /*  838376 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(838451), // Rule ID 22731 //
     /*  838381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  838430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838449 */     GIR_RootConstrainSelectedInstOperands,
     /*  838450 */     // GIR_Coverage, 22731,
     /*  838450 */     GIR_EraseRootFromParent_Done,
     /*  838451 */   // Label 12894: @838451
     /*  838451 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(838526), // Rule ID 22734 //
     /*  838456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  838505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838524 */     GIR_RootConstrainSelectedInstOperands,
     /*  838525 */     // GIR_Coverage, 22734,
     /*  838525 */     GIR_EraseRootFromParent_Done,
     /*  838526 */   // Label 12895: @838526
     /*  838526 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(838601), // Rule ID 22735 //
     /*  838531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  838580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838599 */     GIR_RootConstrainSelectedInstOperands,
     /*  838600 */     // GIR_Coverage, 22735,
     /*  838600 */     GIR_EraseRootFromParent_Done,
     /*  838601 */   // Label 12896: @838601
     /*  838601 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(838676), // Rule ID 22738 //
     /*  838606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  838655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838674 */     GIR_RootConstrainSelectedInstOperands,
     /*  838675 */     // GIR_Coverage, 22738,
     /*  838675 */     GIR_EraseRootFromParent_Done,
     /*  838676 */   // Label 12897: @838676
     /*  838676 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(838751), // Rule ID 22739 //
     /*  838681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  838730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838749 */     GIR_RootConstrainSelectedInstOperands,
     /*  838750 */     // GIR_Coverage, 22739,
     /*  838750 */     GIR_EraseRootFromParent_Done,
     /*  838751 */   // Label 12898: @838751
     /*  838751 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(838826), // Rule ID 22742 //
     /*  838756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  838805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838824 */     GIR_RootConstrainSelectedInstOperands,
     /*  838825 */     // GIR_Coverage, 22742,
     /*  838825 */     GIR_EraseRootFromParent_Done,
     /*  838826 */   // Label 12899: @838826
     /*  838826 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(838901), // Rule ID 22743 //
     /*  838831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  838880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838899 */     GIR_RootConstrainSelectedInstOperands,
     /*  838900 */     // GIR_Coverage, 22743,
     /*  838900 */     GIR_EraseRootFromParent_Done,
     /*  838901 */   // Label 12900: @838901
     /*  838901 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(838976), // Rule ID 22746 //
     /*  838906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  838909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  838955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838974 */     GIR_RootConstrainSelectedInstOperands,
     /*  838975 */     // GIR_Coverage, 22746,
     /*  838975 */     GIR_EraseRootFromParent_Done,
     /*  838976 */   // Label 12901: @838976
     /*  838976 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(839051), // Rule ID 22747 //
     /*  838981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  838984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  838989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  838998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  839030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839049 */     GIR_RootConstrainSelectedInstOperands,
     /*  839050 */     // GIR_Coverage, 22747,
     /*  839050 */     GIR_EraseRootFromParent_Done,
     /*  839051 */   // Label 12902: @839051
     /*  839051 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(839126), // Rule ID 22750 //
     /*  839056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  839073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  839105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839124 */     GIR_RootConstrainSelectedInstOperands,
     /*  839125 */     // GIR_Coverage, 22750,
     /*  839125 */     GIR_EraseRootFromParent_Done,
     /*  839126 */   // Label 12903: @839126
     /*  839126 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(839201), // Rule ID 22751 //
     /*  839131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  839148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  839180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839199 */     GIR_RootConstrainSelectedInstOperands,
     /*  839200 */     // GIR_Coverage, 22751,
     /*  839200 */     GIR_EraseRootFromParent_Done,
     /*  839201 */   // Label 12904: @839201
     /*  839201 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(839276), // Rule ID 22754 //
     /*  839206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  839223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839252 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  839255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839274 */     GIR_RootConstrainSelectedInstOperands,
     /*  839275 */     // GIR_Coverage, 22754,
     /*  839275 */     GIR_EraseRootFromParent_Done,
     /*  839276 */   // Label 12905: @839276
     /*  839276 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(839351), // Rule ID 22755 //
     /*  839281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  839298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  839330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839349 */     GIR_RootConstrainSelectedInstOperands,
     /*  839350 */     // GIR_Coverage, 22755,
     /*  839350 */     GIR_EraseRootFromParent_Done,
     /*  839351 */   // Label 12906: @839351
     /*  839351 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(839426), // Rule ID 22758 //
     /*  839356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  839373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  839402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  839405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839424 */     GIR_RootConstrainSelectedInstOperands,
     /*  839425 */     // GIR_Coverage, 22758,
     /*  839425 */     GIR_EraseRootFromParent_Done,
     /*  839426 */   // Label 12907: @839426
     /*  839426 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(839501), // Rule ID 22759 //
     /*  839431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  839448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  839477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  839480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  839496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839499 */     GIR_RootConstrainSelectedInstOperands,
     /*  839500 */     // GIR_Coverage, 22759,
     /*  839500 */     GIR_EraseRootFromParent_Done,
     /*  839501 */   // Label 12908: @839501
     /*  839501 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(839576), // Rule ID 22762 //
     /*  839506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  839555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839574 */     GIR_RootConstrainSelectedInstOperands,
     /*  839575 */     // GIR_Coverage, 22762,
     /*  839575 */     GIR_EraseRootFromParent_Done,
     /*  839576 */   // Label 12909: @839576
     /*  839576 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(839651), // Rule ID 22763 //
     /*  839581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  839630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839649 */     GIR_RootConstrainSelectedInstOperands,
     /*  839650 */     // GIR_Coverage, 22763,
     /*  839650 */     GIR_EraseRootFromParent_Done,
     /*  839651 */   // Label 12910: @839651
     /*  839651 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(839726), // Rule ID 22766 //
     /*  839656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  839705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839724 */     GIR_RootConstrainSelectedInstOperands,
     /*  839725 */     // GIR_Coverage, 22766,
     /*  839725 */     GIR_EraseRootFromParent_Done,
     /*  839726 */   // Label 12911: @839726
     /*  839726 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(839801), // Rule ID 22767 //
     /*  839731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  839780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839799 */     GIR_RootConstrainSelectedInstOperands,
     /*  839800 */     // GIR_Coverage, 22767,
     /*  839800 */     GIR_EraseRootFromParent_Done,
     /*  839801 */   // Label 12912: @839801
     /*  839801 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(839876), // Rule ID 22770 //
     /*  839806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  839823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  839855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839874 */     GIR_RootConstrainSelectedInstOperands,
     /*  839875 */     // GIR_Coverage, 22770,
     /*  839875 */     GIR_EraseRootFromParent_Done,
     /*  839876 */   // Label 12913: @839876
     /*  839876 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(839951), // Rule ID 22771 //
     /*  839881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  839884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  839898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  839930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839949 */     GIR_RootConstrainSelectedInstOperands,
     /*  839950 */     // GIR_Coverage, 22771,
     /*  839950 */     GIR_EraseRootFromParent_Done,
     /*  839951 */   // Label 12914: @839951
     /*  839951 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(840026), // Rule ID 22774 //
     /*  839956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  839959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  839964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  839973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  840005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840024 */     GIR_RootConstrainSelectedInstOperands,
     /*  840025 */     // GIR_Coverage, 22774,
     /*  840025 */     GIR_EraseRootFromParent_Done,
     /*  840026 */   // Label 12915: @840026
     /*  840026 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(840101), // Rule ID 22775 //
     /*  840031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  840048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  840080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840099 */     GIR_RootConstrainSelectedInstOperands,
     /*  840100 */     // GIR_Coverage, 22775,
     /*  840100 */     GIR_EraseRootFromParent_Done,
     /*  840101 */   // Label 12916: @840101
     /*  840101 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(840176), // Rule ID 22778 //
     /*  840106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  840155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840174 */     GIR_RootConstrainSelectedInstOperands,
     /*  840175 */     // GIR_Coverage, 22778,
     /*  840175 */     GIR_EraseRootFromParent_Done,
     /*  840176 */   // Label 12917: @840176
     /*  840176 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(840251), // Rule ID 22779 //
     /*  840181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  840230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840249 */     GIR_RootConstrainSelectedInstOperands,
     /*  840250 */     // GIR_Coverage, 22779,
     /*  840250 */     GIR_EraseRootFromParent_Done,
     /*  840251 */   // Label 12918: @840251
     /*  840251 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(840326), // Rule ID 22782 //
     /*  840256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  840305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840324 */     GIR_RootConstrainSelectedInstOperands,
     /*  840325 */     // GIR_Coverage, 22782,
     /*  840325 */     GIR_EraseRootFromParent_Done,
     /*  840326 */   // Label 12919: @840326
     /*  840326 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(840401), // Rule ID 22783 //
     /*  840331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  840380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840399 */     GIR_RootConstrainSelectedInstOperands,
     /*  840400 */     // GIR_Coverage, 22783,
     /*  840400 */     GIR_EraseRootFromParent_Done,
     /*  840401 */   // Label 12920: @840401
     /*  840401 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(840476), // Rule ID 22786 //
     /*  840406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  840423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  840455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840474 */     GIR_RootConstrainSelectedInstOperands,
     /*  840475 */     // GIR_Coverage, 22786,
     /*  840475 */     GIR_EraseRootFromParent_Done,
     /*  840476 */   // Label 12921: @840476
     /*  840476 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(840551), // Rule ID 22787 //
     /*  840481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  840498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  840530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840549 */     GIR_RootConstrainSelectedInstOperands,
     /*  840550 */     // GIR_Coverage, 22787,
     /*  840550 */     GIR_EraseRootFromParent_Done,
     /*  840551 */   // Label 12922: @840551
     /*  840551 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(840626), // Rule ID 22790 //
     /*  840556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  840573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  840605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840624 */     GIR_RootConstrainSelectedInstOperands,
     /*  840625 */     // GIR_Coverage, 22790,
     /*  840625 */     GIR_EraseRootFromParent_Done,
     /*  840626 */   // Label 12923: @840626
     /*  840626 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(840701), // Rule ID 22791 //
     /*  840631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  840648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  840680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840699 */     GIR_RootConstrainSelectedInstOperands,
     /*  840700 */     // GIR_Coverage, 22791,
     /*  840700 */     GIR_EraseRootFromParent_Done,
     /*  840701 */   // Label 12924: @840701
     /*  840701 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(840776), // Rule ID 22794 //
     /*  840706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  840723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  840752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  840755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840774 */     GIR_RootConstrainSelectedInstOperands,
     /*  840775 */     // GIR_Coverage, 22794,
     /*  840775 */     GIR_EraseRootFromParent_Done,
     /*  840776 */   // Label 12925: @840776
     /*  840776 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(840851), // Rule ID 22795 //
     /*  840781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  840798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  840827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  840830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  840846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840849 */     GIR_RootConstrainSelectedInstOperands,
     /*  840850 */     // GIR_Coverage, 22795,
     /*  840850 */     GIR_EraseRootFromParent_Done,
     /*  840851 */   // Label 12926: @840851
     /*  840851 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(840926), // Rule ID 22798 //
     /*  840856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  840859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  840905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840924 */     GIR_RootConstrainSelectedInstOperands,
     /*  840925 */     // GIR_Coverage, 22798,
     /*  840925 */     GIR_EraseRootFromParent_Done,
     /*  840926 */   // Label 12927: @840926
     /*  840926 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(841001), // Rule ID 22799 //
     /*  840931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  840934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  840939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  840980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840999 */     GIR_RootConstrainSelectedInstOperands,
     /*  841000 */     // GIR_Coverage, 22799,
     /*  841000 */     GIR_EraseRootFromParent_Done,
     /*  841001 */   // Label 12928: @841001
     /*  841001 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(841076), // Rule ID 22802 //
     /*  841006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  841055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841074 */     GIR_RootConstrainSelectedInstOperands,
     /*  841075 */     // GIR_Coverage, 22802,
     /*  841075 */     GIR_EraseRootFromParent_Done,
     /*  841076 */   // Label 12929: @841076
     /*  841076 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(841151), // Rule ID 22803 //
     /*  841081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  841130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841149 */     GIR_RootConstrainSelectedInstOperands,
     /*  841150 */     // GIR_Coverage, 22803,
     /*  841150 */     GIR_EraseRootFromParent_Done,
     /*  841151 */   // Label 12930: @841151
     /*  841151 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(841226), // Rule ID 22806 //
     /*  841156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  841205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841224 */     GIR_RootConstrainSelectedInstOperands,
     /*  841225 */     // GIR_Coverage, 22806,
     /*  841225 */     GIR_EraseRootFromParent_Done,
     /*  841226 */   // Label 12931: @841226
     /*  841226 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(841301), // Rule ID 22807 //
     /*  841231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  841280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841299 */     GIR_RootConstrainSelectedInstOperands,
     /*  841300 */     // GIR_Coverage, 22807,
     /*  841300 */     GIR_EraseRootFromParent_Done,
     /*  841301 */   // Label 12932: @841301
     /*  841301 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(841376), // Rule ID 22810 //
     /*  841306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  841355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841374 */     GIR_RootConstrainSelectedInstOperands,
     /*  841375 */     // GIR_Coverage, 22810,
     /*  841375 */     GIR_EraseRootFromParent_Done,
     /*  841376 */   // Label 12933: @841376
     /*  841376 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(841451), // Rule ID 22811 //
     /*  841381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  841430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841449 */     GIR_RootConstrainSelectedInstOperands,
     /*  841450 */     // GIR_Coverage, 22811,
     /*  841450 */     GIR_EraseRootFromParent_Done,
     /*  841451 */   // Label 12934: @841451
     /*  841451 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(841526), // Rule ID 22814 //
     /*  841456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  841505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841524 */     GIR_RootConstrainSelectedInstOperands,
     /*  841525 */     // GIR_Coverage, 22814,
     /*  841525 */     GIR_EraseRootFromParent_Done,
     /*  841526 */   // Label 12935: @841526
     /*  841526 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(841601), // Rule ID 22815 //
     /*  841531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  841580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841599 */     GIR_RootConstrainSelectedInstOperands,
     /*  841600 */     // GIR_Coverage, 22815,
     /*  841600 */     GIR_EraseRootFromParent_Done,
     /*  841601 */   // Label 12936: @841601
     /*  841601 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(841676), // Rule ID 22818 //
     /*  841606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  841609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  841655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841674 */     GIR_RootConstrainSelectedInstOperands,
     /*  841675 */     // GIR_Coverage, 22818,
     /*  841675 */     GIR_EraseRootFromParent_Done,
     /*  841676 */   // Label 12937: @841676
     /*  841676 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(841751), // Rule ID 22819 //
     /*  841681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  841684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  841689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  841730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841749 */     GIR_RootConstrainSelectedInstOperands,
     /*  841750 */     // GIR_Coverage, 22819,
     /*  841750 */     GIR_EraseRootFromParent_Done,
     /*  841751 */   // Label 12938: @841751
     /*  841751 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(841826), // Rule ID 22938 //
     /*  841756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  841773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841802 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  841805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841824 */     GIR_RootConstrainSelectedInstOperands,
     /*  841825 */     // GIR_Coverage, 22938,
     /*  841825 */     GIR_EraseRootFromParent_Done,
     /*  841826 */   // Label 12939: @841826
     /*  841826 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(841901), // Rule ID 22939 //
     /*  841831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  841848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841877 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  841880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841899 */     GIR_RootConstrainSelectedInstOperands,
     /*  841900 */     // GIR_Coverage, 22939,
     /*  841900 */     GIR_EraseRootFromParent_Done,
     /*  841901 */   // Label 12940: @841901
     /*  841901 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(841976), // Rule ID 22942 //
     /*  841906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  841923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841952 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  841955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841974 */     GIR_RootConstrainSelectedInstOperands,
     /*  841975 */     // GIR_Coverage, 22942,
     /*  841975 */     GIR_EraseRootFromParent_Done,
     /*  841976 */   // Label 12941: @841976
     /*  841976 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(842051), // Rule ID 22943 //
     /*  841981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  841989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  841998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842027 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  842030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842049 */     GIR_RootConstrainSelectedInstOperands,
     /*  842050 */     // GIR_Coverage, 22943,
     /*  842050 */     GIR_EraseRootFromParent_Done,
     /*  842051 */   // Label 12942: @842051
     /*  842051 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(842126), // Rule ID 22946 //
     /*  842056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  842073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  842105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842124 */     GIR_RootConstrainSelectedInstOperands,
     /*  842125 */     // GIR_Coverage, 22946,
     /*  842125 */     GIR_EraseRootFromParent_Done,
     /*  842126 */   // Label 12943: @842126
     /*  842126 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(842201), // Rule ID 22947 //
     /*  842131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  842148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842177 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  842180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842199 */     GIR_RootConstrainSelectedInstOperands,
     /*  842200 */     // GIR_Coverage, 22947,
     /*  842200 */     GIR_EraseRootFromParent_Done,
     /*  842201 */   // Label 12944: @842201
     /*  842201 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(842276), // Rule ID 22950 //
     /*  842206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  842223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842252 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  842255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842274 */     GIR_RootConstrainSelectedInstOperands,
     /*  842275 */     // GIR_Coverage, 22950,
     /*  842275 */     GIR_EraseRootFromParent_Done,
     /*  842276 */   // Label 12945: @842276
     /*  842276 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(842351), // Rule ID 22951 //
     /*  842281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  842298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  842330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842349 */     GIR_RootConstrainSelectedInstOperands,
     /*  842350 */     // GIR_Coverage, 22951,
     /*  842350 */     GIR_EraseRootFromParent_Done,
     /*  842351 */   // Label 12946: @842351
     /*  842351 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(842426), // Rule ID 22954 //
     /*  842356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  842359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  842373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  842402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  842405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842424 */     GIR_RootConstrainSelectedInstOperands,
     /*  842425 */     // GIR_Coverage, 22954,
     /*  842425 */     GIR_EraseRootFromParent_Done,
     /*  842426 */   // Label 12947: @842426
     /*  842426 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(842501), // Rule ID 22955 //
     /*  842431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  842434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  842442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  842445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  842448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  842451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  842477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  842480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  842496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842499 */     GIR_RootConstrainSelectedInstOperands,
     /*  842500 */     // GIR_Coverage, 22955,
     /*  842500 */     GIR_EraseRootFromParent_Done,
     /*  842501 */   // Label 12948: @842501
     /*  842501 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(842576), // Rule ID 22958 //
     /*  842506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842552 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  842555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842574 */     GIR_RootConstrainSelectedInstOperands,
     /*  842575 */     // GIR_Coverage, 22958,
     /*  842575 */     GIR_EraseRootFromParent_Done,
     /*  842576 */   // Label 12949: @842576
     /*  842576 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(842651), // Rule ID 22959 //
     /*  842581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  842598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842627 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  842630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842649 */     GIR_RootConstrainSelectedInstOperands,
     /*  842650 */     // GIR_Coverage, 22959,
     /*  842650 */     GIR_EraseRootFromParent_Done,
     /*  842651 */   // Label 12950: @842651
     /*  842651 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(842726), // Rule ID 22962 //
     /*  842656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  842673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  842705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842724 */     GIR_RootConstrainSelectedInstOperands,
     /*  842725 */     // GIR_Coverage, 22962,
     /*  842725 */     GIR_EraseRootFromParent_Done,
     /*  842726 */   // Label 12951: @842726
     /*  842726 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(842801), // Rule ID 22963 //
     /*  842731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  842748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842777 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  842780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842799 */     GIR_RootConstrainSelectedInstOperands,
     /*  842800 */     // GIR_Coverage, 22963,
     /*  842800 */     GIR_EraseRootFromParent_Done,
     /*  842801 */   // Label 12952: @842801
     /*  842801 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(842876), // Rule ID 22966 //
     /*  842806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  842823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842852 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  842852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  842855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842874 */     GIR_RootConstrainSelectedInstOperands,
     /*  842875 */     // GIR_Coverage, 22966,
     /*  842875 */     GIR_EraseRootFromParent_Done,
     /*  842876 */   // Label 12953: @842876
     /*  842876 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(842951), // Rule ID 22967 //
     /*  842881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  842884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  842898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842927 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  842927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  842930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  842946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842949 */     GIR_RootConstrainSelectedInstOperands,
     /*  842950 */     // GIR_Coverage, 22967,
     /*  842950 */     GIR_EraseRootFromParent_Done,
     /*  842951 */   // Label 12954: @842951
     /*  842951 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(843026), // Rule ID 22970 //
     /*  842956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  842959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  842964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  842967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  842970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  842973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  842976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  843002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  843005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  843021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843024 */     GIR_RootConstrainSelectedInstOperands,
     /*  843025 */     // GIR_Coverage, 22970,
     /*  843025 */     GIR_EraseRootFromParent_Done,
     /*  843026 */   // Label 12955: @843026
     /*  843026 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(843101), // Rule ID 22971 //
     /*  843031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  843034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  843042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  843045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  843048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  843051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843077 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  843077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  843080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  843096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843099 */     GIR_RootConstrainSelectedInstOperands,
     /*  843100 */     // GIR_Coverage, 22971,
     /*  843100 */     GIR_EraseRootFromParent_Done,
     /*  843101 */   // Label 12956: @843101
     /*  843101 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(843176), // Rule ID 22974 //
     /*  843106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  843123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843152 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  843155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843174 */     GIR_RootConstrainSelectedInstOperands,
     /*  843175 */     // GIR_Coverage, 22974,
     /*  843175 */     GIR_EraseRootFromParent_Done,
     /*  843176 */   // Label 12957: @843176
     /*  843176 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(843251), // Rule ID 22975 //
     /*  843181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  843198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843227 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  843230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843249 */     GIR_RootConstrainSelectedInstOperands,
     /*  843250 */     // GIR_Coverage, 22975,
     /*  843250 */     GIR_EraseRootFromParent_Done,
     /*  843251 */   // Label 12958: @843251
     /*  843251 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(843326), // Rule ID 22978 //
     /*  843256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  843273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  843305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843324 */     GIR_RootConstrainSelectedInstOperands,
     /*  843325 */     // GIR_Coverage, 22978,
     /*  843325 */     GIR_EraseRootFromParent_Done,
     /*  843326 */   // Label 12959: @843326
     /*  843326 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(843401), // Rule ID 22979 //
     /*  843331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  843348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  843380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843399 */     GIR_RootConstrainSelectedInstOperands,
     /*  843400 */     // GIR_Coverage, 22979,
     /*  843400 */     GIR_EraseRootFromParent_Done,
     /*  843401 */   // Label 12960: @843401
     /*  843401 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(843476), // Rule ID 22982 //
     /*  843406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  843409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  843423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843452 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  843452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  843455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843474 */     GIR_RootConstrainSelectedInstOperands,
     /*  843475 */     // GIR_Coverage, 22982,
     /*  843475 */     GIR_EraseRootFromParent_Done,
     /*  843476 */   // Label 12961: @843476
     /*  843476 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(843551), // Rule ID 22983 //
     /*  843481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  843484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  843492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  843495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  843498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  843501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843527 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  843527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  843530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  843546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843549 */     GIR_RootConstrainSelectedInstOperands,
     /*  843550 */     // GIR_Coverage, 22983,
     /*  843550 */     GIR_EraseRootFromParent_Done,
     /*  843551 */   // Label 12962: @843551
     /*  843551 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(843626), // Rule ID 22986 //
     /*  843556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  843573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843602 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  843605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843624 */     GIR_RootConstrainSelectedInstOperands,
     /*  843625 */     // GIR_Coverage, 22986,
     /*  843625 */     GIR_EraseRootFromParent_Done,
     /*  843626 */   // Label 12963: @843626
     /*  843626 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(843701), // Rule ID 22987 //
     /*  843631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  843648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  843666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843677 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  843680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843699 */     GIR_RootConstrainSelectedInstOperands,
     /*  843700 */     // GIR_Coverage, 22987,
     /*  843700 */     GIR_EraseRootFromParent_Done,
     /*  843701 */   // Label 12964: @843701
     /*  843701 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(843776), // Rule ID 22990 //
     /*  843706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  843723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843752 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  843755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843774 */     GIR_RootConstrainSelectedInstOperands,
     /*  843775 */     // GIR_Coverage, 22990,
     /*  843775 */     GIR_EraseRootFromParent_Done,
     /*  843776 */   // Label 12965: @843776
     /*  843776 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(843851), // Rule ID 22991 //
     /*  843781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  843798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  843816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843827 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  843830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843849 */     GIR_RootConstrainSelectedInstOperands,
     /*  843850 */     // GIR_Coverage, 22991,
     /*  843850 */     GIR_EraseRootFromParent_Done,
     /*  843851 */   // Label 12966: @843851
     /*  843851 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(843926), // Rule ID 22994 //
     /*  843856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  843859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  843902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  843905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843924 */     GIR_RootConstrainSelectedInstOperands,
     /*  843925 */     // GIR_Coverage, 22994,
     /*  843925 */     GIR_EraseRootFromParent_Done,
     /*  843926 */   // Label 12967: @843926
     /*  843926 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(844001), // Rule ID 22995 //
     /*  843931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  843934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  843939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  843942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  843945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  843948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  843951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  843966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  843977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  843980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  843984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  843986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  843988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  843996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843999 */     GIR_RootConstrainSelectedInstOperands,
     /*  844000 */     // GIR_Coverage, 22995,
     /*  844000 */     GIR_EraseRootFromParent_Done,
     /*  844001 */   // Label 12968: @844001
     /*  844001 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(844076), // Rule ID 22998 //
     /*  844006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  844023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  844055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844074 */     GIR_RootConstrainSelectedInstOperands,
     /*  844075 */     // GIR_Coverage, 22998,
     /*  844075 */     GIR_EraseRootFromParent_Done,
     /*  844076 */   // Label 12969: @844076
     /*  844076 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(844151), // Rule ID 22999 //
     /*  844081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  844098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  844130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844149 */     GIR_RootConstrainSelectedInstOperands,
     /*  844150 */     // GIR_Coverage, 22999,
     /*  844150 */     GIR_EraseRootFromParent_Done,
     /*  844151 */   // Label 12970: @844151
     /*  844151 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(844226), // Rule ID 23002 //
     /*  844156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  844173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844202 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  844205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844224 */     GIR_RootConstrainSelectedInstOperands,
     /*  844225 */     // GIR_Coverage, 23002,
     /*  844225 */     GIR_EraseRootFromParent_Done,
     /*  844226 */   // Label 12971: @844226
     /*  844226 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(844301), // Rule ID 23003 //
     /*  844231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  844248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844277 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  844280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844299 */     GIR_RootConstrainSelectedInstOperands,
     /*  844300 */     // GIR_Coverage, 23003,
     /*  844300 */     GIR_EraseRootFromParent_Done,
     /*  844301 */   // Label 12972: @844301
     /*  844301 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(844376), // Rule ID 23006 //
     /*  844306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  844309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844352 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  844352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  844355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844374 */     GIR_RootConstrainSelectedInstOperands,
     /*  844375 */     // GIR_Coverage, 23006,
     /*  844375 */     GIR_EraseRootFromParent_Done,
     /*  844376 */   // Label 12973: @844376
     /*  844376 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(844451), // Rule ID 23007 //
     /*  844381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  844384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  844398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844427 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  844427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  844430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844449 */     GIR_RootConstrainSelectedInstOperands,
     /*  844450 */     // GIR_Coverage, 23007,
     /*  844450 */     GIR_EraseRootFromParent_Done,
     /*  844451 */   // Label 12974: @844451
     /*  844451 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(844526), // Rule ID 23010 //
     /*  844456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  844473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  844505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844524 */     GIR_RootConstrainSelectedInstOperands,
     /*  844525 */     // GIR_Coverage, 23010,
     /*  844525 */     GIR_EraseRootFromParent_Done,
     /*  844526 */   // Label 12975: @844526
     /*  844526 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(844601), // Rule ID 23011 //
     /*  844531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  844548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844577 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  844577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  844580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844599 */     GIR_RootConstrainSelectedInstOperands,
     /*  844600 */     // GIR_Coverage, 23011,
     /*  844600 */     GIR_EraseRootFromParent_Done,
     /*  844601 */   // Label 12976: @844601
     /*  844601 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(844676), // Rule ID 23014 //
     /*  844606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  844609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  844652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  844655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844674 */     GIR_RootConstrainSelectedInstOperands,
     /*  844675 */     // GIR_Coverage, 23014,
     /*  844675 */     GIR_EraseRootFromParent_Done,
     /*  844676 */   // Label 12977: @844676
     /*  844676 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(844751), // Rule ID 23015 //
     /*  844681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  844684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  844692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  844695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  844698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  844701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  844727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  844730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  844746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844749 */     GIR_RootConstrainSelectedInstOperands,
     /*  844750 */     // GIR_Coverage, 23015,
     /*  844750 */     GIR_EraseRootFromParent_Done,
     /*  844751 */   // Label 12978: @844751
     /*  844751 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(844826), // Rule ID 23018 //
     /*  844756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  844759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  844767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  844770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  844773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  844776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  844802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  844805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  844821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844824 */     GIR_RootConstrainSelectedInstOperands,
     /*  844825 */     // GIR_Coverage, 23018,
     /*  844825 */     GIR_EraseRootFromParent_Done,
     /*  844826 */   // Label 12979: @844826
     /*  844826 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(844901), // Rule ID 23019 //
     /*  844831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  844834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  844842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  844845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  844848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  844851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  844877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  844880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  844896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844899 */     GIR_RootConstrainSelectedInstOperands,
     /*  844900 */     // GIR_Coverage, 23019,
     /*  844900 */     GIR_EraseRootFromParent_Done,
     /*  844901 */   // Label 12980: @844901
     /*  844901 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(844976), // Rule ID 23022 //
     /*  844906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  844909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  844923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  844926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  844941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844952 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  844952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  844955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  844959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  844971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844974 */     GIR_RootConstrainSelectedInstOperands,
     /*  844975 */     // GIR_Coverage, 23022,
     /*  844975 */     GIR_EraseRootFromParent_Done,
     /*  844976 */   // Label 12981: @844976
     /*  844976 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(845051), // Rule ID 23023 //
     /*  844981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  844984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  844989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  844992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  844995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  844998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845027 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  845030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845049 */     GIR_RootConstrainSelectedInstOperands,
     /*  845050 */     // GIR_Coverage, 23023,
     /*  845050 */     GIR_EraseRootFromParent_Done,
     /*  845051 */   // Label 12982: @845051
     /*  845051 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(845126), // Rule ID 23026 //
     /*  845056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  845059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  845073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  845105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845124 */     GIR_RootConstrainSelectedInstOperands,
     /*  845125 */     // GIR_Coverage, 23026,
     /*  845125 */     GIR_EraseRootFromParent_Done,
     /*  845126 */   // Label 12983: @845126
     /*  845126 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(845201), // Rule ID 23027 //
     /*  845131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  845134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  845148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  845180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845199 */     GIR_RootConstrainSelectedInstOperands,
     /*  845200 */     // GIR_Coverage, 23027,
     /*  845200 */     GIR_EraseRootFromParent_Done,
     /*  845201 */   // Label 12984: @845201
     /*  845201 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(845276), // Rule ID 23030 //
     /*  845206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  845209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  845223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845252 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  845255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845274 */     GIR_RootConstrainSelectedInstOperands,
     /*  845275 */     // GIR_Coverage, 23030,
     /*  845275 */     GIR_EraseRootFromParent_Done,
     /*  845276 */   // Label 12985: @845276
     /*  845276 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(845351), // Rule ID 23031 //
     /*  845281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  845284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  845298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  845301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  845330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845349 */     GIR_RootConstrainSelectedInstOperands,
     /*  845350 */     // GIR_Coverage, 23031,
     /*  845350 */     GIR_EraseRootFromParent_Done,
     /*  845351 */   // Label 12986: @845351
     /*  845351 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(845426), // Rule ID 23034 //
     /*  845356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  845373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  845405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845424 */     GIR_RootConstrainSelectedInstOperands,
     /*  845425 */     // GIR_Coverage, 23034,
     /*  845425 */     GIR_EraseRootFromParent_Done,
     /*  845426 */   // Label 12987: @845426
     /*  845426 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(845501), // Rule ID 23035 //
     /*  845431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  845448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845477 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  845480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845499 */     GIR_RootConstrainSelectedInstOperands,
     /*  845500 */     // GIR_Coverage, 23035,
     /*  845500 */     GIR_EraseRootFromParent_Done,
     /*  845501 */   // Label 12988: @845501
     /*  845501 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(845576), // Rule ID 23038 //
     /*  845506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  845555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845574 */     GIR_RootConstrainSelectedInstOperands,
     /*  845575 */     // GIR_Coverage, 23038,
     /*  845575 */     GIR_EraseRootFromParent_Done,
     /*  845576 */   // Label 12989: @845576
     /*  845576 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(845651), // Rule ID 23039 //
     /*  845581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  845598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845627 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  845630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845649 */     GIR_RootConstrainSelectedInstOperands,
     /*  845650 */     // GIR_Coverage, 23039,
     /*  845650 */     GIR_EraseRootFromParent_Done,
     /*  845651 */   // Label 12990: @845651
     /*  845651 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(845726), // Rule ID 23042 //
     /*  845656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  845659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  845705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845724 */     GIR_RootConstrainSelectedInstOperands,
     /*  845725 */     // GIR_Coverage, 23042,
     /*  845725 */     GIR_EraseRootFromParent_Done,
     /*  845726 */   // Label 12991: @845726
     /*  845726 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(845801), // Rule ID 23043 //
     /*  845731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  845734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  845742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  845745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  845748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  845751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  845766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845777 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  845780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845799 */     GIR_RootConstrainSelectedInstOperands,
     /*  845800 */     // GIR_Coverage, 23043,
     /*  845800 */     GIR_EraseRootFromParent_Done,
     /*  845801 */   // Label 12992: @845801
     /*  845801 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(845876), // Rule ID 23046 //
     /*  845806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  845809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845852 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  845852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  845855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  845871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845874 */     GIR_RootConstrainSelectedInstOperands,
     /*  845875 */     // GIR_Coverage, 23046,
     /*  845875 */     GIR_EraseRootFromParent_Done,
     /*  845876 */   // Label 12993: @845876
     /*  845876 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(845951), // Rule ID 23047 //
     /*  845881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  845884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  845898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  845916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845927 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  845927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  845930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  845934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  845946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845949 */     GIR_RootConstrainSelectedInstOperands,
     /*  845950 */     // GIR_Coverage, 23047,
     /*  845950 */     GIR_EraseRootFromParent_Done,
     /*  845951 */   // Label 12994: @845951
     /*  845951 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(846026), // Rule ID 23050 //
     /*  845956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  845959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  845964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  845967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  845970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  845973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  845976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  845991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  846005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846024 */     GIR_RootConstrainSelectedInstOperands,
     /*  846025 */     // GIR_Coverage, 23050,
     /*  846025 */     GIR_EraseRootFromParent_Done,
     /*  846026 */   // Label 12995: @846026
     /*  846026 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(846101), // Rule ID 23051 //
     /*  846031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  846034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  846048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846077 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  846080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846099 */     GIR_RootConstrainSelectedInstOperands,
     /*  846100 */     // GIR_Coverage, 23051,
     /*  846100 */     GIR_EraseRootFromParent_Done,
     /*  846101 */   // Label 12996: @846101
     /*  846101 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(846176), // Rule ID 23054 //
     /*  846106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  846109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  846123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  846155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846174 */     GIR_RootConstrainSelectedInstOperands,
     /*  846175 */     // GIR_Coverage, 23054,
     /*  846175 */     GIR_EraseRootFromParent_Done,
     /*  846176 */   // Label 12997: @846176
     /*  846176 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(846251), // Rule ID 23055 //
     /*  846181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  846184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  846189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  846198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  846201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  846230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  846234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846249 */     GIR_RootConstrainSelectedInstOperands,
     /*  846250 */     // GIR_Coverage, 23055,
     /*  846250 */     GIR_EraseRootFromParent_Done,
     /*  846251 */   // Label 12998: @846251
     /*  846251 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(846326), // Rule ID 23336 //
     /*  846256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  846267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  846270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  846273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  846276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  846305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846324 */     GIR_RootConstrainSelectedInstOperands,
     /*  846325 */     // GIR_Coverage, 23336,
     /*  846325 */     GIR_EraseRootFromParent_Done,
     /*  846326 */   // Label 12999: @846326
     /*  846326 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(846401), // Rule ID 23337 //
     /*  846331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  846342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  846345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  846348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  846351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846377 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  846380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846399 */     GIR_RootConstrainSelectedInstOperands,
     /*  846400 */     // GIR_Coverage, 23337,
     /*  846400 */     GIR_EraseRootFromParent_Done,
     /*  846401 */   // Label 13000: @846401
     /*  846401 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(846476), // Rule ID 23340 //
     /*  846406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  846417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  846420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  846423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  846426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  846455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846474 */     GIR_RootConstrainSelectedInstOperands,
     /*  846475 */     // GIR_Coverage, 23340,
     /*  846475 */     GIR_EraseRootFromParent_Done,
     /*  846476 */   // Label 13001: @846476
     /*  846476 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(846551), // Rule ID 23341 //
     /*  846481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  846492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  846495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  846498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  846501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846527 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  846530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846549 */     GIR_RootConstrainSelectedInstOperands,
     /*  846550 */     // GIR_Coverage, 23341,
     /*  846550 */     GIR_EraseRootFromParent_Done,
     /*  846551 */   // Label 13002: @846551
     /*  846551 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(846626), // Rule ID 23344 //
     /*  846556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  846567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  846570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  846573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  846576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846602 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  846605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846624 */     GIR_RootConstrainSelectedInstOperands,
     /*  846625 */     // GIR_Coverage, 23344,
     /*  846625 */     GIR_EraseRootFromParent_Done,
     /*  846626 */   // Label 13003: @846626
     /*  846626 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(846701), // Rule ID 23345 //
     /*  846631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  846642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  846645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  846648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  846651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  846680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846699 */     GIR_RootConstrainSelectedInstOperands,
     /*  846700 */     // GIR_Coverage, 23345,
     /*  846700 */     GIR_EraseRootFromParent_Done,
     /*  846701 */   // Label 13004: @846701
     /*  846701 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(846776), // Rule ID 23348 //
     /*  846706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  846717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  846720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  846723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  846726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846752 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  846755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846774 */     GIR_RootConstrainSelectedInstOperands,
     /*  846775 */     // GIR_Coverage, 23348,
     /*  846775 */     GIR_EraseRootFromParent_Done,
     /*  846776 */   // Label 13005: @846776
     /*  846776 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(846851), // Rule ID 23349 //
     /*  846781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  846792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  846795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  846798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  846801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  846830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846849 */     GIR_RootConstrainSelectedInstOperands,
     /*  846850 */     // GIR_Coverage, 23349,
     /*  846850 */     GIR_EraseRootFromParent_Done,
     /*  846851 */   // Label 13006: @846851
     /*  846851 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(846926), // Rule ID 23352 //
     /*  846856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  846859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  846867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  846870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  846873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  846876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846902 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  846902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  846905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846924 */     GIR_RootConstrainSelectedInstOperands,
     /*  846925 */     // GIR_Coverage, 23352,
     /*  846925 */     GIR_EraseRootFromParent_Done,
     /*  846926 */   // Label 13007: @846926
     /*  846926 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(847001), // Rule ID 23353 //
     /*  846931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  846934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  846939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  846942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  846945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  846948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  846951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  846958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  846970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846977 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  846977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  846980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  846986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  846988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  846999 */     GIR_RootConstrainSelectedInstOperands,
     /*  847000 */     // GIR_Coverage, 23353,
     /*  847000 */     GIR_EraseRootFromParent_Done,
     /*  847001 */   // Label 13008: @847001
     /*  847001 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(847076), // Rule ID 23356 //
     /*  847006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  847014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  847017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  847020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  847023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  847026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847052 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  847055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847074 */     GIR_RootConstrainSelectedInstOperands,
     /*  847075 */     // GIR_Coverage, 23356,
     /*  847075 */     GIR_EraseRootFromParent_Done,
     /*  847076 */   // Label 13009: @847076
     /*  847076 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(847151), // Rule ID 23357 //
     /*  847081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  847089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  847092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  847095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  847098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  847101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847127 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  847130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847149 */     GIR_RootConstrainSelectedInstOperands,
     /*  847150 */     // GIR_Coverage, 23357,
     /*  847150 */     GIR_EraseRootFromParent_Done,
     /*  847151 */   // Label 13010: @847151
     /*  847151 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(847226), // Rule ID 23360 //
     /*  847156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  847167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  847170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  847173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  847176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  847205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847224 */     GIR_RootConstrainSelectedInstOperands,
     /*  847225 */     // GIR_Coverage, 23360,
     /*  847225 */     GIR_EraseRootFromParent_Done,
     /*  847226 */   // Label 13011: @847226
     /*  847226 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(847301), // Rule ID 23361 //
     /*  847231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  847242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  847245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  847248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  847251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847277 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  847280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847299 */     GIR_RootConstrainSelectedInstOperands,
     /*  847300 */     // GIR_Coverage, 23361,
     /*  847300 */     GIR_EraseRootFromParent_Done,
     /*  847301 */   // Label 13012: @847301
     /*  847301 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(847376), // Rule ID 23364 //
     /*  847306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  847317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  847320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  847323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  847326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  847355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847374 */     GIR_RootConstrainSelectedInstOperands,
     /*  847375 */     // GIR_Coverage, 23364,
     /*  847375 */     GIR_EraseRootFromParent_Done,
     /*  847376 */   // Label 13013: @847376
     /*  847376 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(847451), // Rule ID 23365 //
     /*  847381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  847392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  847395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  847398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  847401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847427 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  847430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847449 */     GIR_RootConstrainSelectedInstOperands,
     /*  847450 */     // GIR_Coverage, 23365,
     /*  847450 */     GIR_EraseRootFromParent_Done,
     /*  847451 */   // Label 13014: @847451
     /*  847451 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(847526), // Rule ID 23368 //
     /*  847456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  847467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  847470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  847473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  847476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  847505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847524 */     GIR_RootConstrainSelectedInstOperands,
     /*  847525 */     // GIR_Coverage, 23368,
     /*  847525 */     GIR_EraseRootFromParent_Done,
     /*  847526 */   // Label 13015: @847526
     /*  847526 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(847601), // Rule ID 23369 //
     /*  847531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  847542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  847545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  847548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  847551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  847580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847599 */     GIR_RootConstrainSelectedInstOperands,
     /*  847600 */     // GIR_Coverage, 23369,
     /*  847600 */     GIR_EraseRootFromParent_Done,
     /*  847601 */   // Label 13016: @847601
     /*  847601 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(847676), // Rule ID 23372 //
     /*  847606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  847617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  847620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  847623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  847626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  847655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847674 */     GIR_RootConstrainSelectedInstOperands,
     /*  847675 */     // GIR_Coverage, 23372,
     /*  847675 */     GIR_EraseRootFromParent_Done,
     /*  847676 */   // Label 13017: @847676
     /*  847676 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(847751), // Rule ID 23373 //
     /*  847681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  847692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  847695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  847698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  847701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  847730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847749 */     GIR_RootConstrainSelectedInstOperands,
     /*  847750 */     // GIR_Coverage, 23373,
     /*  847750 */     GIR_EraseRootFromParent_Done,
     /*  847751 */   // Label 13018: @847751
     /*  847751 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(847826), // Rule ID 23376 //
     /*  847756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  847767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  847770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  847773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  847776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  847805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847824 */     GIR_RootConstrainSelectedInstOperands,
     /*  847825 */     // GIR_Coverage, 23376,
     /*  847825 */     GIR_EraseRootFromParent_Done,
     /*  847826 */   // Label 13019: @847826
     /*  847826 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(847901), // Rule ID 23377 //
     /*  847831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  847842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  847845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  847848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  847851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  847877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  847880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847899 */     GIR_RootConstrainSelectedInstOperands,
     /*  847900 */     // GIR_Coverage, 23377,
     /*  847900 */     GIR_EraseRootFromParent_Done,
     /*  847901 */   // Label 13020: @847901
     /*  847901 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(847976), // Rule ID 23380 //
     /*  847906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  847909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  847917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  847920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  847923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  847926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  847933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  847941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  847945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  847952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  847955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  847961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  847963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  847974 */     GIR_RootConstrainSelectedInstOperands,
     /*  847975 */     // GIR_Coverage, 23380,
     /*  847975 */     GIR_EraseRootFromParent_Done,
     /*  847976 */   // Label 13021: @847976
     /*  847976 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(848051), // Rule ID 23381 //
     /*  847981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  847984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  847989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  847992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  847995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  847998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  848001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848027 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  848030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848049 */     GIR_RootConstrainSelectedInstOperands,
     /*  848050 */     // GIR_Coverage, 23381,
     /*  848050 */     GIR_EraseRootFromParent_Done,
     /*  848051 */   // Label 13022: @848051
     /*  848051 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(848126), // Rule ID 23384 //
     /*  848056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  848064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  848067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  848070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  848073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  848076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848102 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  848105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848124 */     GIR_RootConstrainSelectedInstOperands,
     /*  848125 */     // GIR_Coverage, 23384,
     /*  848125 */     GIR_EraseRootFromParent_Done,
     /*  848126 */   // Label 13023: @848126
     /*  848126 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(848201), // Rule ID 23385 //
     /*  848131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  848139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  848142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  848145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  848148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  848151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848177 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  848180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848199 */     GIR_RootConstrainSelectedInstOperands,
     /*  848200 */     // GIR_Coverage, 23385,
     /*  848200 */     GIR_EraseRootFromParent_Done,
     /*  848201 */   // Label 13024: @848201
     /*  848201 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(848276), // Rule ID 23388 //
     /*  848206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  848217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  848220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  848223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  848226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  848255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848274 */     GIR_RootConstrainSelectedInstOperands,
     /*  848275 */     // GIR_Coverage, 23388,
     /*  848275 */     GIR_EraseRootFromParent_Done,
     /*  848276 */   // Label 13025: @848276
     /*  848276 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(848351), // Rule ID 23389 //
     /*  848281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  848292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  848295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  848298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  848301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848327 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  848330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848349 */     GIR_RootConstrainSelectedInstOperands,
     /*  848350 */     // GIR_Coverage, 23389,
     /*  848350 */     GIR_EraseRootFromParent_Done,
     /*  848351 */   // Label 13026: @848351
     /*  848351 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(848426), // Rule ID 23392 //
     /*  848356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  848367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  848370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  848373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  848376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848402 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  848405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848424 */     GIR_RootConstrainSelectedInstOperands,
     /*  848425 */     // GIR_Coverage, 23392,
     /*  848425 */     GIR_EraseRootFromParent_Done,
     /*  848426 */   // Label 13027: @848426
     /*  848426 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(848501), // Rule ID 23393 //
     /*  848431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  848442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  848445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  848448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  848451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  848480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848499 */     GIR_RootConstrainSelectedInstOperands,
     /*  848500 */     // GIR_Coverage, 23393,
     /*  848500 */     GIR_EraseRootFromParent_Done,
     /*  848501 */   // Label 13028: @848501
     /*  848501 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(848576), // Rule ID 23396 //
     /*  848506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  848517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  848520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  848523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  848526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  848555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848574 */     GIR_RootConstrainSelectedInstOperands,
     /*  848575 */     // GIR_Coverage, 23396,
     /*  848575 */     GIR_EraseRootFromParent_Done,
     /*  848576 */   // Label 13029: @848576
     /*  848576 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(848651), // Rule ID 23397 //
     /*  848581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  848592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  848595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  848598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  848601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  848630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848649 */     GIR_RootConstrainSelectedInstOperands,
     /*  848650 */     // GIR_Coverage, 23397,
     /*  848650 */     GIR_EraseRootFromParent_Done,
     /*  848651 */   // Label 13030: @848651
     /*  848651 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(848726), // Rule ID 23400 //
     /*  848656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  848667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  848670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  848673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  848676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  848705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848724 */     GIR_RootConstrainSelectedInstOperands,
     /*  848725 */     // GIR_Coverage, 23400,
     /*  848725 */     GIR_EraseRootFromParent_Done,
     /*  848726 */   // Label 13031: @848726
     /*  848726 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(848801), // Rule ID 23401 //
     /*  848731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  848742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  848745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  848748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  848751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848777 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  848780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848799 */     GIR_RootConstrainSelectedInstOperands,
     /*  848800 */     // GIR_Coverage, 23401,
     /*  848800 */     GIR_EraseRootFromParent_Done,
     /*  848801 */   // Label 13032: @848801
     /*  848801 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(848876), // Rule ID 23404 //
     /*  848806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  848817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  848820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  848823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  848826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  848852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  848855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848874 */     GIR_RootConstrainSelectedInstOperands,
     /*  848875 */     // GIR_Coverage, 23404,
     /*  848875 */     GIR_EraseRootFromParent_Done,
     /*  848876 */   // Label 13033: @848876
     /*  848876 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(848951), // Rule ID 23405 //
     /*  848881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  848884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  848892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  848895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  848898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  848901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  848927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  848930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  848936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  848938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  848949 */     GIR_RootConstrainSelectedInstOperands,
     /*  848950 */     // GIR_Coverage, 23405,
     /*  848950 */     GIR_EraseRootFromParent_Done,
     /*  848951 */   // Label 13034: @848951
     /*  848951 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(849026), // Rule ID 23408 //
     /*  848956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  848959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  848964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  848967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  848970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  848973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  848976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  848983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  848995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849002 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  849002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  849005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849024 */     GIR_RootConstrainSelectedInstOperands,
     /*  849025 */     // GIR_Coverage, 23408,
     /*  849025 */     GIR_EraseRootFromParent_Done,
     /*  849026 */   // Label 13035: @849026
     /*  849026 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(849101), // Rule ID 23409 //
     /*  849031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  849034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  849042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  849045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  849048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  849051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849077 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  849077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  849080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849099 */     GIR_RootConstrainSelectedInstOperands,
     /*  849100 */     // GIR_Coverage, 23409,
     /*  849100 */     GIR_EraseRootFromParent_Done,
     /*  849101 */   // Label 13036: @849101
     /*  849101 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(849176), // Rule ID 23412 //
     /*  849106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  849109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  849117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  849120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  849123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  849126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849152 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  849152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  849155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849174 */     GIR_RootConstrainSelectedInstOperands,
     /*  849175 */     // GIR_Coverage, 23412,
     /*  849175 */     GIR_EraseRootFromParent_Done,
     /*  849176 */   // Label 13037: @849176
     /*  849176 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(849251), // Rule ID 23413 //
     /*  849181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  849184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  849189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  849192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  849195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  849198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  849201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  849208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  849220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849227 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11407:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  849227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  849230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  849236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  849238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  849249 */     GIR_RootConstrainSelectedInstOperands,
     /*  849250 */     // GIR_Coverage, 23413,
     /*  849250 */     GIR_EraseRootFromParent_Done,
     /*  849251 */   // Label 13038: @849251
     /*  849251 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(849326), // Rule ID 23954 //
     /*  849256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  849305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849324 */     GIR_RootConstrainSelectedInstOperands,
     /*  849325 */     // GIR_Coverage, 23954,
     /*  849325 */     GIR_EraseRootFromParent_Done,
     /*  849326 */   // Label 13039: @849326
     /*  849326 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(849401), // Rule ID 23955 //
     /*  849331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  849342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  849345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  849348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849377 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  849380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849399 */     GIR_RootConstrainSelectedInstOperands,
     /*  849400 */     // GIR_Coverage, 23955,
     /*  849400 */     GIR_EraseRootFromParent_Done,
     /*  849401 */   // Label 13040: @849401
     /*  849401 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(849476), // Rule ID 23958 //
     /*  849406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849474 */     GIR_RootConstrainSelectedInstOperands,
     /*  849475 */     // GIR_Coverage, 23958,
     /*  849475 */     GIR_EraseRootFromParent_Done,
     /*  849476 */   // Label 13041: @849476
     /*  849476 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(849551), // Rule ID 23959 //
     /*  849481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  849492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  849495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  849498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849527 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849549 */     GIR_RootConstrainSelectedInstOperands,
     /*  849550 */     // GIR_Coverage, 23959,
     /*  849550 */     GIR_EraseRootFromParent_Done,
     /*  849551 */   // Label 13042: @849551
     /*  849551 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(849626), // Rule ID 23962 //
     /*  849556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849602 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849624 */     GIR_RootConstrainSelectedInstOperands,
     /*  849625 */     // GIR_Coverage, 23962,
     /*  849625 */     GIR_EraseRootFromParent_Done,
     /*  849626 */   // Label 13043: @849626
     /*  849626 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(849701), // Rule ID 23963 //
     /*  849631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849677 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849699 */     GIR_RootConstrainSelectedInstOperands,
     /*  849700 */     // GIR_Coverage, 23963,
     /*  849700 */     GIR_EraseRootFromParent_Done,
     /*  849701 */   // Label 13044: @849701
     /*  849701 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(849776), // Rule ID 23966 //
     /*  849706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849774 */     GIR_RootConstrainSelectedInstOperands,
     /*  849775 */     // GIR_Coverage, 23966,
     /*  849775 */     GIR_EraseRootFromParent_Done,
     /*  849776 */   // Label 13045: @849776
     /*  849776 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(849851), // Rule ID 23967 //
     /*  849781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849827 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  849830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849849 */     GIR_RootConstrainSelectedInstOperands,
     /*  849850 */     // GIR_Coverage, 23967,
     /*  849850 */     GIR_EraseRootFromParent_Done,
     /*  849851 */   // Label 13046: @849851
     /*  849851 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(849926), // Rule ID 23970 //
     /*  849856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849924 */     GIR_RootConstrainSelectedInstOperands,
     /*  849925 */     // GIR_Coverage, 23970,
     /*  849925 */     GIR_EraseRootFromParent_Done,
     /*  849926 */   // Label 13047: @849926
     /*  849926 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(850001), // Rule ID 23971 //
     /*  849931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  849939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  849980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849999 */     GIR_RootConstrainSelectedInstOperands,
     /*  850000 */     // GIR_Coverage, 23971,
     /*  850000 */     GIR_EraseRootFromParent_Done,
     /*  850001 */   // Label 13048: @850001
     /*  850001 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(850076), // Rule ID 23974 //
     /*  850006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  850055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850074 */     GIR_RootConstrainSelectedInstOperands,
     /*  850075 */     // GIR_Coverage, 23974,
     /*  850075 */     GIR_EraseRootFromParent_Done,
     /*  850076 */   // Label 13049: @850076
     /*  850076 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(850151), // Rule ID 23975 //
     /*  850081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  850092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  850095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  850098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850127 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  850130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850149 */     GIR_RootConstrainSelectedInstOperands,
     /*  850150 */     // GIR_Coverage, 23975,
     /*  850150 */     GIR_EraseRootFromParent_Done,
     /*  850151 */   // Label 13050: @850151
     /*  850151 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(850226), // Rule ID 23978 //
     /*  850156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850224 */     GIR_RootConstrainSelectedInstOperands,
     /*  850225 */     // GIR_Coverage, 23978,
     /*  850225 */     GIR_EraseRootFromParent_Done,
     /*  850226 */   // Label 13051: @850226
     /*  850226 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(850301), // Rule ID 23979 //
     /*  850231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  850242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  850245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  850248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850277 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850299 */     GIR_RootConstrainSelectedInstOperands,
     /*  850300 */     // GIR_Coverage, 23979,
     /*  850300 */     GIR_EraseRootFromParent_Done,
     /*  850301 */   // Label 13052: @850301
     /*  850301 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(850376), // Rule ID 23982 //
     /*  850306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850374 */     GIR_RootConstrainSelectedInstOperands,
     /*  850375 */     // GIR_Coverage, 23982,
     /*  850375 */     GIR_EraseRootFromParent_Done,
     /*  850376 */   // Label 13053: @850376
     /*  850376 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(850451), // Rule ID 23983 //
     /*  850381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  850392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  850395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  850398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850449 */     GIR_RootConstrainSelectedInstOperands,
     /*  850450 */     // GIR_Coverage, 23983,
     /*  850450 */     GIR_EraseRootFromParent_Done,
     /*  850451 */   // Label 13054: @850451
     /*  850451 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(850526), // Rule ID 23986 //
     /*  850456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850524 */     GIR_RootConstrainSelectedInstOperands,
     /*  850525 */     // GIR_Coverage, 23986,
     /*  850525 */     GIR_EraseRootFromParent_Done,
     /*  850526 */   // Label 13055: @850526
     /*  850526 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(850601), // Rule ID 23987 //
     /*  850531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  850542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850577 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850599 */     GIR_RootConstrainSelectedInstOperands,
     /*  850600 */     // GIR_Coverage, 23987,
     /*  850600 */     GIR_EraseRootFromParent_Done,
     /*  850601 */   // Label 13056: @850601
     /*  850601 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(850676), // Rule ID 23990 //
     /*  850606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850674 */     GIR_RootConstrainSelectedInstOperands,
     /*  850675 */     // GIR_Coverage, 23990,
     /*  850675 */     GIR_EraseRootFromParent_Done,
     /*  850676 */   // Label 13057: @850676
     /*  850676 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(850751), // Rule ID 23991 //
     /*  850681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  850730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850749 */     GIR_RootConstrainSelectedInstOperands,
     /*  850750 */     // GIR_Coverage, 23991,
     /*  850750 */     GIR_EraseRootFromParent_Done,
     /*  850751 */   // Label 13058: @850751
     /*  850751 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(850826), // Rule ID 23994 //
     /*  850756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  850805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850824 */     GIR_RootConstrainSelectedInstOperands,
     /*  850825 */     // GIR_Coverage, 23994,
     /*  850825 */     GIR_EraseRootFromParent_Done,
     /*  850826 */   // Label 13059: @850826
     /*  850826 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(850901), // Rule ID 23995 //
     /*  850831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  850880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850899 */     GIR_RootConstrainSelectedInstOperands,
     /*  850900 */     // GIR_Coverage, 23995,
     /*  850900 */     GIR_EraseRootFromParent_Done,
     /*  850901 */   // Label 13060: @850901
     /*  850901 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(850976), // Rule ID 23998 //
     /*  850906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  850955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850974 */     GIR_RootConstrainSelectedInstOperands,
     /*  850975 */     // GIR_Coverage, 23998,
     /*  850975 */     GIR_EraseRootFromParent_Done,
     /*  850976 */   // Label 13061: @850976
     /*  850976 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(851051), // Rule ID 23999 //
     /*  850981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  850989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851027 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851049 */     GIR_RootConstrainSelectedInstOperands,
     /*  851050 */     // GIR_Coverage, 23999,
     /*  851050 */     GIR_EraseRootFromParent_Done,
     /*  851051 */   // Label 13062: @851051
     /*  851051 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(851126), // Rule ID 24002 //
     /*  851056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  851102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851124 */     GIR_RootConstrainSelectedInstOperands,
     /*  851125 */     // GIR_Coverage, 24002,
     /*  851125 */     GIR_EraseRootFromParent_Done,
     /*  851126 */   // Label 13063: @851126
     /*  851126 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(851201), // Rule ID 24003 //
     /*  851131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  851142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  851145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  851148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851177 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  851177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  851196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851199 */     GIR_RootConstrainSelectedInstOperands,
     /*  851200 */     // GIR_Coverage, 24003,
     /*  851200 */     GIR_EraseRootFromParent_Done,
     /*  851201 */   // Label 13064: @851201
     /*  851201 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(851276), // Rule ID 24006 //
     /*  851206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851274 */     GIR_RootConstrainSelectedInstOperands,
     /*  851275 */     // GIR_Coverage, 24006,
     /*  851275 */     GIR_EraseRootFromParent_Done,
     /*  851276 */   // Label 13065: @851276
     /*  851276 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(851351), // Rule ID 24007 //
     /*  851281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  851292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  851295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  851298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851349 */     GIR_RootConstrainSelectedInstOperands,
     /*  851350 */     // GIR_Coverage, 24007,
     /*  851350 */     GIR_EraseRootFromParent_Done,
     /*  851351 */   // Label 13066: @851351
     /*  851351 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(851426), // Rule ID 24010 //
     /*  851356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851424 */     GIR_RootConstrainSelectedInstOperands,
     /*  851425 */     // GIR_Coverage, 24010,
     /*  851425 */     GIR_EraseRootFromParent_Done,
     /*  851426 */   // Label 13067: @851426
     /*  851426 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(851501), // Rule ID 24011 //
     /*  851431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  851442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  851445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  851448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851499 */     GIR_RootConstrainSelectedInstOperands,
     /*  851500 */     // GIR_Coverage, 24011,
     /*  851500 */     GIR_EraseRootFromParent_Done,
     /*  851501 */   // Label 13068: @851501
     /*  851501 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(851576), // Rule ID 24014 //
     /*  851506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851574 */     GIR_RootConstrainSelectedInstOperands,
     /*  851575 */     // GIR_Coverage, 24014,
     /*  851575 */     GIR_EraseRootFromParent_Done,
     /*  851576 */   // Label 13069: @851576
     /*  851576 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(851651), // Rule ID 24015 //
     /*  851581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851627 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  851630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851649 */     GIR_RootConstrainSelectedInstOperands,
     /*  851650 */     // GIR_Coverage, 24015,
     /*  851650 */     GIR_EraseRootFromParent_Done,
     /*  851651 */   // Label 13070: @851651
     /*  851651 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(851726), // Rule ID 24018 //
     /*  851656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851724 */     GIR_RootConstrainSelectedInstOperands,
     /*  851725 */     // GIR_Coverage, 24018,
     /*  851725 */     GIR_EraseRootFromParent_Done,
     /*  851726 */   // Label 13071: @851726
     /*  851726 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(851801), // Rule ID 24019 //
     /*  851731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  851780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851799 */     GIR_RootConstrainSelectedInstOperands,
     /*  851800 */     // GIR_Coverage, 24019,
     /*  851800 */     GIR_EraseRootFromParent_Done,
     /*  851801 */   // Label 13072: @851801
     /*  851801 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(851876), // Rule ID 24022 //
     /*  851806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851874 */     GIR_RootConstrainSelectedInstOperands,
     /*  851875 */     // GIR_Coverage, 24022,
     /*  851875 */     GIR_EraseRootFromParent_Done,
     /*  851876 */   // Label 13073: @851876
     /*  851876 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(851951), // Rule ID 24023 //
     /*  851881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851927 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  851930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851949 */     GIR_RootConstrainSelectedInstOperands,
     /*  851950 */     // GIR_Coverage, 24023,
     /*  851950 */     GIR_EraseRootFromParent_Done,
     /*  851951 */   // Label 13074: @851951
     /*  851951 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(852026), // Rule ID 24026 //
     /*  851956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  851964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852024 */     GIR_RootConstrainSelectedInstOperands,
     /*  852025 */     // GIR_Coverage, 24026,
     /*  852025 */     GIR_EraseRootFromParent_Done,
     /*  852026 */   // Label 13075: @852026
     /*  852026 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(852101), // Rule ID 24027 //
     /*  852031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  852042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  852045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  852048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852077 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852099 */     GIR_RootConstrainSelectedInstOperands,
     /*  852100 */     // GIR_Coverage, 24027,
     /*  852100 */     GIR_EraseRootFromParent_Done,
     /*  852101 */   // Label 13076: @852101
     /*  852101 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(852176), // Rule ID 24030 //
     /*  852106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  852155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852174 */     GIR_RootConstrainSelectedInstOperands,
     /*  852175 */     // GIR_Coverage, 24030,
     /*  852175 */     GIR_EraseRootFromParent_Done,
     /*  852176 */   // Label 13077: @852176
     /*  852176 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(852251), // Rule ID 24031 //
     /*  852181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  852192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  852195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  852198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  852230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852249 */     GIR_RootConstrainSelectedInstOperands,
     /*  852250 */     // GIR_Coverage, 24031,
     /*  852250 */     GIR_EraseRootFromParent_Done,
     /*  852251 */   // Label 13078: @852251
     /*  852251 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(852326), // Rule ID 24034 //
     /*  852256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  852305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852324 */     GIR_RootConstrainSelectedInstOperands,
     /*  852325 */     // GIR_Coverage, 24034,
     /*  852325 */     GIR_EraseRootFromParent_Done,
     /*  852326 */   // Label 13079: @852326
     /*  852326 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(852401), // Rule ID 24035 //
     /*  852331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  852342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  852345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  852348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852377 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  852380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852399 */     GIR_RootConstrainSelectedInstOperands,
     /*  852400 */     // GIR_Coverage, 24035,
     /*  852400 */     GIR_EraseRootFromParent_Done,
     /*  852401 */   // Label 13080: @852401
     /*  852401 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(852476), // Rule ID 24038 //
     /*  852406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  852409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852474 */     GIR_RootConstrainSelectedInstOperands,
     /*  852475 */     // GIR_Coverage, 24038,
     /*  852475 */     GIR_EraseRootFromParent_Done,
     /*  852476 */   // Label 13081: @852476
     /*  852476 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(852551), // Rule ID 24039 //
     /*  852481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  852484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  852489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  852492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  852495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  852498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11486:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  852530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852549 */     GIR_RootConstrainSelectedInstOperands,
     /*  852550 */     // GIR_Coverage, 24039,
     /*  852550 */     GIR_EraseRootFromParent_Done,
     /*  852551 */   // Label 13082: @852551
     /*  852551 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(852626), // Rule ID 24042 //
     /*  852556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  852567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  852570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  852573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  852605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852624 */     GIR_RootConstrainSelectedInstOperands,
     /*  852625 */     // GIR_Coverage, 24042,
     /*  852625 */     GIR_EraseRootFromParent_Done,
     /*  852626 */   // Label 13083: @852626
     /*  852626 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(852701), // Rule ID 24043 //
     /*  852631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  852642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  852645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  852648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852677 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  852680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852699 */     GIR_RootConstrainSelectedInstOperands,
     /*  852700 */     // GIR_Coverage, 24043,
     /*  852700 */     GIR_EraseRootFromParent_Done,
     /*  852701 */   // Label 13084: @852701
     /*  852701 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(852776), // Rule ID 24046 //
     /*  852706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  852717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  852720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  852723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852752 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  852755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852774 */     GIR_RootConstrainSelectedInstOperands,
     /*  852775 */     // GIR_Coverage, 24046,
     /*  852775 */     GIR_EraseRootFromParent_Done,
     /*  852776 */   // Label 13085: @852776
     /*  852776 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(852851), // Rule ID 24047 //
     /*  852781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  852792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  852795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  852798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852827 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  852830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852849 */     GIR_RootConstrainSelectedInstOperands,
     /*  852850 */     // GIR_Coverage, 24047,
     /*  852850 */     GIR_EraseRootFromParent_Done,
     /*  852851 */   // Label 13086: @852851
     /*  852851 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(852926), // Rule ID 24050 //
     /*  852856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  852859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  852867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  852870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  852873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  852902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  852905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852924 */     GIR_RootConstrainSelectedInstOperands,
     /*  852925 */     // GIR_Coverage, 24050,
     /*  852925 */     GIR_EraseRootFromParent_Done,
     /*  852926 */   // Label 13087: @852926
     /*  852926 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(853001), // Rule ID 24051 //
     /*  852931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  852934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  852939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  852942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  852945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  852948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  852970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852977 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  852977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  852980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  852996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852999 */     GIR_RootConstrainSelectedInstOperands,
     /*  853000 */     // GIR_Coverage, 24051,
     /*  853000 */     GIR_EraseRootFromParent_Done,
     /*  853001 */   // Label 13088: @853001
     /*  853001 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(853076), // Rule ID 24054 //
     /*  853006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  853055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853074 */     GIR_RootConstrainSelectedInstOperands,
     /*  853075 */     // GIR_Coverage, 24054,
     /*  853075 */     GIR_EraseRootFromParent_Done,
     /*  853076 */   // Label 13089: @853076
     /*  853076 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(853151), // Rule ID 24055 //
     /*  853081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853127 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  853130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853149 */     GIR_RootConstrainSelectedInstOperands,
     /*  853150 */     // GIR_Coverage, 24055,
     /*  853150 */     GIR_EraseRootFromParent_Done,
     /*  853151 */   // Label 13090: @853151
     /*  853151 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(853226), // Rule ID 24058 //
     /*  853156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853224 */     GIR_RootConstrainSelectedInstOperands,
     /*  853225 */     // GIR_Coverage, 24058,
     /*  853225 */     GIR_EraseRootFromParent_Done,
     /*  853226 */   // Label 13091: @853226
     /*  853226 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(853301), // Rule ID 24059 //
     /*  853231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853277 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853299 */     GIR_RootConstrainSelectedInstOperands,
     /*  853300 */     // GIR_Coverage, 24059,
     /*  853300 */     GIR_EraseRootFromParent_Done,
     /*  853301 */   // Label 13092: @853301
     /*  853301 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(853376), // Rule ID 24062 //
     /*  853306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  853317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  853320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  853323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853374 */     GIR_RootConstrainSelectedInstOperands,
     /*  853375 */     // GIR_Coverage, 24062,
     /*  853375 */     GIR_EraseRootFromParent_Done,
     /*  853376 */   // Label 13093: @853376
     /*  853376 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(853451), // Rule ID 24063 //
     /*  853381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  853392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  853395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  853398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853427 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  853430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853449 */     GIR_RootConstrainSelectedInstOperands,
     /*  853450 */     // GIR_Coverage, 24063,
     /*  853450 */     GIR_EraseRootFromParent_Done,
     /*  853451 */   // Label 13094: @853451
     /*  853451 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(853526), // Rule ID 24066 //
     /*  853456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  853467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  853470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  853473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  853502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853524 */     GIR_RootConstrainSelectedInstOperands,
     /*  853525 */     // GIR_Coverage, 24066,
     /*  853525 */     GIR_EraseRootFromParent_Done,
     /*  853526 */   // Label 13095: @853526
     /*  853526 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(853601), // Rule ID 24067 //
     /*  853531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  853542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  853545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  853548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853577 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  853577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  853596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853599 */     GIR_RootConstrainSelectedInstOperands,
     /*  853600 */     // GIR_Coverage, 24067,
     /*  853600 */     GIR_EraseRootFromParent_Done,
     /*  853601 */   // Label 13096: @853601
     /*  853601 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(853676), // Rule ID 24070 //
     /*  853606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853674 */     GIR_RootConstrainSelectedInstOperands,
     /*  853675 */     // GIR_Coverage, 24070,
     /*  853675 */     GIR_EraseRootFromParent_Done,
     /*  853676 */   // Label 13097: @853676
     /*  853676 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(853751), // Rule ID 24071 //
     /*  853681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  853692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  853695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  853698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853749 */     GIR_RootConstrainSelectedInstOperands,
     /*  853750 */     // GIR_Coverage, 24071,
     /*  853750 */     GIR_EraseRootFromParent_Done,
     /*  853751 */   // Label 13098: @853751
     /*  853751 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(853826), // Rule ID 24074 //
     /*  853756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  853759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853824 */     GIR_RootConstrainSelectedInstOperands,
     /*  853825 */     // GIR_Coverage, 24074,
     /*  853825 */     GIR_EraseRootFromParent_Done,
     /*  853826 */   // Label 13099: @853826
     /*  853826 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(853901), // Rule ID 24075 //
     /*  853831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  853834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  853842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  853845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  853848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853899 */     GIR_RootConstrainSelectedInstOperands,
     /*  853900 */     // GIR_Coverage, 24075,
     /*  853900 */     GIR_EraseRootFromParent_Done,
     /*  853901 */   // Label 13100: @853901
     /*  853901 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(853976), // Rule ID 24078 //
     /*  853906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  853909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  853945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  853955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853974 */     GIR_RootConstrainSelectedInstOperands,
     /*  853975 */     // GIR_Coverage, 24078,
     /*  853975 */     GIR_EraseRootFromParent_Done,
     /*  853976 */   // Label 13101: @853976
     /*  853976 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(854051), // Rule ID 24079 //
     /*  853981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  853984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  853989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  853992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  853995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  853998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  854030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854049 */     GIR_RootConstrainSelectedInstOperands,
     /*  854050 */     // GIR_Coverage, 24079,
     /*  854050 */     GIR_EraseRootFromParent_Done,
     /*  854051 */   // Label 13102: @854051
     /*  854051 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(854126), // Rule ID 24082 //
     /*  854056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  854067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  854070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  854073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854124 */     GIR_RootConstrainSelectedInstOperands,
     /*  854125 */     // GIR_Coverage, 24082,
     /*  854125 */     GIR_EraseRootFromParent_Done,
     /*  854126 */   // Label 13103: @854126
     /*  854126 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(854201), // Rule ID 24083 //
     /*  854131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  854142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  854145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  854148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854199 */     GIR_RootConstrainSelectedInstOperands,
     /*  854200 */     // GIR_Coverage, 24083,
     /*  854200 */     GIR_EraseRootFromParent_Done,
     /*  854201 */   // Label 13104: @854201
     /*  854201 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(854276), // Rule ID 24086 //
     /*  854206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  854217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  854220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  854223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854274 */     GIR_RootConstrainSelectedInstOperands,
     /*  854275 */     // GIR_Coverage, 24086,
     /*  854275 */     GIR_EraseRootFromParent_Done,
     /*  854276 */   // Label 13105: @854276
     /*  854276 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(854351), // Rule ID 24087 //
     /*  854281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  854292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  854295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  854298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854327 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854349 */     GIR_RootConstrainSelectedInstOperands,
     /*  854350 */     // GIR_Coverage, 24087,
     /*  854350 */     GIR_EraseRootFromParent_Done,
     /*  854351 */   // Label 13106: @854351
     /*  854351 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(854426), // Rule ID 24090 //
     /*  854356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  854370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854402 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  854402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854424 */     GIR_RootConstrainSelectedInstOperands,
     /*  854425 */     // GIR_Coverage, 24090,
     /*  854425 */     GIR_EraseRootFromParent_Done,
     /*  854426 */   // Label 13107: @854426
     /*  854426 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(854501), // Rule ID 24091 //
     /*  854431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  854442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  854445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  854448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854477 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  854477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  854496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854499 */     GIR_RootConstrainSelectedInstOperands,
     /*  854500 */     // GIR_Coverage, 24091,
     /*  854500 */     GIR_EraseRootFromParent_Done,
     /*  854501 */   // Label 13108: @854501
     /*  854501 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(854576), // Rule ID 24094 //
     /*  854506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854574 */     GIR_RootConstrainSelectedInstOperands,
     /*  854575 */     // GIR_Coverage, 24094,
     /*  854575 */     GIR_EraseRootFromParent_Done,
     /*  854576 */   // Label 13109: @854576
     /*  854576 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(854651), // Rule ID 24095 //
     /*  854581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  854630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854649 */     GIR_RootConstrainSelectedInstOperands,
     /*  854650 */     // GIR_Coverage, 24095,
     /*  854650 */     GIR_EraseRootFromParent_Done,
     /*  854651 */   // Label 13110: @854651
     /*  854651 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(854726), // Rule ID 24098 //
     /*  854656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854724 */     GIR_RootConstrainSelectedInstOperands,
     /*  854725 */     // GIR_Coverage, 24098,
     /*  854725 */     GIR_EraseRootFromParent_Done,
     /*  854726 */   // Label 13111: @854726
     /*  854726 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(854801), // Rule ID 24099 //
     /*  854731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  854780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854799 */     GIR_RootConstrainSelectedInstOperands,
     /*  854800 */     // GIR_Coverage, 24099,
     /*  854800 */     GIR_EraseRootFromParent_Done,
     /*  854801 */   // Label 13112: @854801
     /*  854801 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(854876), // Rule ID 24102 //
     /*  854806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  854817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  854820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  854823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854874 */     GIR_RootConstrainSelectedInstOperands,
     /*  854875 */     // GIR_Coverage, 24102,
     /*  854875 */     GIR_EraseRootFromParent_Done,
     /*  854876 */   // Label 13113: @854876
     /*  854876 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(854951), // Rule ID 24103 //
     /*  854881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  854884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  854892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  854895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  854898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  854930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854949 */     GIR_RootConstrainSelectedInstOperands,
     /*  854950 */     // GIR_Coverage, 24103,
     /*  854950 */     GIR_EraseRootFromParent_Done,
     /*  854951 */   // Label 13114: @854951
     /*  854951 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(855026), // Rule ID 24106 //
     /*  854956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  854959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  854964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  854967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  854970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  854973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  854995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855024 */     GIR_RootConstrainSelectedInstOperands,
     /*  855025 */     // GIR_Coverage, 24106,
     /*  855025 */     GIR_EraseRootFromParent_Done,
     /*  855026 */   // Label 13115: @855026
     /*  855026 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(855101), // Rule ID 24107 //
     /*  855031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855099 */     GIR_RootConstrainSelectedInstOperands,
     /*  855100 */     // GIR_Coverage, 24107,
     /*  855100 */     GIR_EraseRootFromParent_Done,
     /*  855101 */   // Label 13116: @855101
     /*  855101 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(855176), // Rule ID 24110 //
     /*  855106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  855109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855174 */     GIR_RootConstrainSelectedInstOperands,
     /*  855175 */     // GIR_Coverage, 24110,
     /*  855175 */     GIR_EraseRootFromParent_Done,
     /*  855176 */   // Label 13117: @855176
     /*  855176 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(855251), // Rule ID 24111 //
     /*  855181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855249 */     GIR_RootConstrainSelectedInstOperands,
     /*  855250 */     // GIR_Coverage, 24111,
     /*  855250 */     GIR_EraseRootFromParent_Done,
     /*  855251 */   // Label 13118: @855251
     /*  855251 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(855326), // Rule ID 24114 //
     /*  855256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  855259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855324 */     GIR_RootConstrainSelectedInstOperands,
     /*  855325 */     // GIR_Coverage, 24114,
     /*  855325 */     GIR_EraseRootFromParent_Done,
     /*  855326 */   // Label 13119: @855326
     /*  855326 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(855401), // Rule ID 24115 //
     /*  855331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  855334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855399 */     GIR_RootConstrainSelectedInstOperands,
     /*  855400 */     // GIR_Coverage, 24115,
     /*  855400 */     GIR_EraseRootFromParent_Done,
     /*  855401 */   // Label 13120: @855401
     /*  855401 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(855476), // Rule ID 24118 //
     /*  855406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855474 */     GIR_RootConstrainSelectedInstOperands,
     /*  855475 */     // GIR_Coverage, 24118,
     /*  855475 */     GIR_EraseRootFromParent_Done,
     /*  855476 */   // Label 13121: @855476
     /*  855476 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(855551), // Rule ID 24119 //
     /*  855481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855527 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  855530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855549 */     GIR_RootConstrainSelectedInstOperands,
     /*  855550 */     // GIR_Coverage, 24119,
     /*  855550 */     GIR_EraseRootFromParent_Done,
     /*  855551 */   // Label 13122: @855551
     /*  855551 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(855626), // Rule ID 24122 //
     /*  855556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855624 */     GIR_RootConstrainSelectedInstOperands,
     /*  855625 */     // GIR_Coverage, 24122,
     /*  855625 */     GIR_EraseRootFromParent_Done,
     /*  855626 */   // Label 13123: @855626
     /*  855626 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(855701), // Rule ID 24123 //
     /*  855631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855677 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  855680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855699 */     GIR_RootConstrainSelectedInstOperands,
     /*  855700 */     // GIR_Coverage, 24123,
     /*  855700 */     GIR_EraseRootFromParent_Done,
     /*  855701 */   // Label 13124: @855701
     /*  855701 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(855776), // Rule ID 24126 //
     /*  855706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  855709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855774 */     GIR_RootConstrainSelectedInstOperands,
     /*  855775 */     // GIR_Coverage, 24126,
     /*  855775 */     GIR_EraseRootFromParent_Done,
     /*  855776 */   // Label 13125: @855776
     /*  855776 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(855851), // Rule ID 24127 //
     /*  855781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  855784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  855789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  855820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855827 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  855830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855849 */     GIR_RootConstrainSelectedInstOperands,
     /*  855850 */     // GIR_Coverage, 24127,
     /*  855850 */     GIR_EraseRootFromParent_Done,
     /*  855851 */   // Label 13126: @855851
     /*  855851 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(855926), // Rule ID 24370 //
     /*  855856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  855864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  855867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  855870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  855873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  855905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855924 */     GIR_RootConstrainSelectedInstOperands,
     /*  855925 */     // GIR_Coverage, 24370,
     /*  855925 */     GIR_EraseRootFromParent_Done,
     /*  855926 */   // Label 13127: @855926
     /*  855926 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(856001), // Rule ID 24371 //
     /*  855931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  855939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  855942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  855945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  855948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855977 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  855980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855999 */     GIR_RootConstrainSelectedInstOperands,
     /*  856000 */     // GIR_Coverage, 24371,
     /*  856000 */     GIR_EraseRootFromParent_Done,
     /*  856001 */   // Label 13128: @856001
     /*  856001 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(856076), // Rule ID 24374 //
     /*  856006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  856055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856074 */     GIR_RootConstrainSelectedInstOperands,
     /*  856075 */     // GIR_Coverage, 24374,
     /*  856075 */     GIR_EraseRootFromParent_Done,
     /*  856076 */   // Label 13129: @856076
     /*  856076 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(856151), // Rule ID 24375 //
     /*  856081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856127 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  856130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856149 */     GIR_RootConstrainSelectedInstOperands,
     /*  856150 */     // GIR_Coverage, 24375,
     /*  856150 */     GIR_EraseRootFromParent_Done,
     /*  856151 */   // Label 13130: @856151
     /*  856151 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(856226), // Rule ID 24378 //
     /*  856156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  856205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856224 */     GIR_RootConstrainSelectedInstOperands,
     /*  856225 */     // GIR_Coverage, 24378,
     /*  856225 */     GIR_EraseRootFromParent_Done,
     /*  856226 */   // Label 13131: @856226
     /*  856226 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(856301), // Rule ID 24379 //
     /*  856231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856277 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  856280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856299 */     GIR_RootConstrainSelectedInstOperands,
     /*  856300 */     // GIR_Coverage, 24379,
     /*  856300 */     GIR_EraseRootFromParent_Done,
     /*  856301 */   // Label 13132: @856301
     /*  856301 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(856376), // Rule ID 24382 //
     /*  856306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  856317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  856320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  856323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  856355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856374 */     GIR_RootConstrainSelectedInstOperands,
     /*  856375 */     // GIR_Coverage, 24382,
     /*  856375 */     GIR_EraseRootFromParent_Done,
     /*  856376 */   // Label 13133: @856376
     /*  856376 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(856451), // Rule ID 24383 //
     /*  856381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  856392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  856395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  856398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856427 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  856430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856449 */     GIR_RootConstrainSelectedInstOperands,
     /*  856450 */     // GIR_Coverage, 24383,
     /*  856450 */     GIR_EraseRootFromParent_Done,
     /*  856451 */   // Label 13134: @856451
     /*  856451 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(856526), // Rule ID 24386 //
     /*  856456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  856459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  856467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  856470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  856473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856502 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  856505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856524 */     GIR_RootConstrainSelectedInstOperands,
     /*  856525 */     // GIR_Coverage, 24386,
     /*  856525 */     GIR_EraseRootFromParent_Done,
     /*  856526 */   // Label 13135: @856526
     /*  856526 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(856601), // Rule ID 24387 //
     /*  856531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  856534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  856542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  856545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  856548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  856580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856599 */     GIR_RootConstrainSelectedInstOperands,
     /*  856600 */     // GIR_Coverage, 24387,
     /*  856600 */     GIR_EraseRootFromParent_Done,
     /*  856601 */   // Label 13136: @856601
     /*  856601 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(856676), // Rule ID 24390 //
     /*  856606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  856617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  856620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  856623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856652 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  856655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856674 */     GIR_RootConstrainSelectedInstOperands,
     /*  856675 */     // GIR_Coverage, 24390,
     /*  856675 */     GIR_EraseRootFromParent_Done,
     /*  856676 */   // Label 13137: @856676
     /*  856676 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(856751), // Rule ID 24391 //
     /*  856681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  856692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  856695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  856698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  856730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856749 */     GIR_RootConstrainSelectedInstOperands,
     /*  856750 */     // GIR_Coverage, 24391,
     /*  856750 */     GIR_EraseRootFromParent_Done,
     /*  856751 */   // Label 13138: @856751
     /*  856751 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(856826), // Rule ID 24394 //
     /*  856756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  856767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  856770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  856773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856802 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  856805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856824 */     GIR_RootConstrainSelectedInstOperands,
     /*  856825 */     // GIR_Coverage, 24394,
     /*  856825 */     GIR_EraseRootFromParent_Done,
     /*  856826 */   // Label 13139: @856826
     /*  856826 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(856901), // Rule ID 24395 //
     /*  856831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  856842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  856845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  856848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  856880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856899 */     GIR_RootConstrainSelectedInstOperands,
     /*  856900 */     // GIR_Coverage, 24395,
     /*  856900 */     GIR_EraseRootFromParent_Done,
     /*  856901 */   // Label 13140: @856901
     /*  856901 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(856976), // Rule ID 24398 //
     /*  856906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  856909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  856917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  856920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  856923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  856926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  856945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  856955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856974 */     GIR_RootConstrainSelectedInstOperands,
     /*  856975 */     // GIR_Coverage, 24398,
     /*  856975 */     GIR_EraseRootFromParent_Done,
     /*  856976 */   // Label 13141: @856976
     /*  856976 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(857051), // Rule ID 24399 //
     /*  856981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  856984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  856989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  856992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  856995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  856998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857027 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  857030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857049 */     GIR_RootConstrainSelectedInstOperands,
     /*  857050 */     // GIR_Coverage, 24399,
     /*  857050 */     GIR_EraseRootFromParent_Done,
     /*  857051 */   // Label 13142: @857051
     /*  857051 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(857126), // Rule ID 24402 //
     /*  857056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  857059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  857067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  857070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  857073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  857105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857124 */     GIR_RootConstrainSelectedInstOperands,
     /*  857125 */     // GIR_Coverage, 24402,
     /*  857125 */     GIR_EraseRootFromParent_Done,
     /*  857126 */   // Label 13143: @857126
     /*  857126 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(857201), // Rule ID 24403 //
     /*  857131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  857134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  857142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  857145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  857148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  857151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  857170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857177 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  857180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857199 */     GIR_RootConstrainSelectedInstOperands,
     /*  857200 */     // GIR_Coverage, 24403,
     /*  857200 */     GIR_EraseRootFromParent_Done,
     /*  857201 */   // Label 13144: @857201
     /*  857201 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(857276), // Rule ID 24406 //
     /*  857206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  857217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  857220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  857223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  857255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857274 */     GIR_RootConstrainSelectedInstOperands,
     /*  857275 */     // GIR_Coverage, 24406,
     /*  857275 */     GIR_EraseRootFromParent_Done,
     /*  857276 */   // Label 13145: @857276
     /*  857276 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(857351), // Rule ID 24407 //
     /*  857281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  857292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  857295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  857298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  857330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857349 */     GIR_RootConstrainSelectedInstOperands,
     /*  857350 */     // GIR_Coverage, 24407,
     /*  857350 */     GIR_EraseRootFromParent_Done,
     /*  857351 */   // Label 13146: @857351
     /*  857351 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(857426), // Rule ID 24410 //
     /*  857356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  857367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  857370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  857373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857402 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  857405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857424 */     GIR_RootConstrainSelectedInstOperands,
     /*  857425 */     // GIR_Coverage, 24410,
     /*  857425 */     GIR_EraseRootFromParent_Done,
     /*  857426 */   // Label 13147: @857426
     /*  857426 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(857501), // Rule ID 24411 //
     /*  857431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  857442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  857445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  857448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  857480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857499 */     GIR_RootConstrainSelectedInstOperands,
     /*  857500 */     // GIR_Coverage, 24411,
     /*  857500 */     GIR_EraseRootFromParent_Done,
     /*  857501 */   // Label 13148: @857501
     /*  857501 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(857576), // Rule ID 24414 //
     /*  857506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  857509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  857520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857552 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  857555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857574 */     GIR_RootConstrainSelectedInstOperands,
     /*  857575 */     // GIR_Coverage, 24414,
     /*  857575 */     GIR_EraseRootFromParent_Done,
     /*  857576 */   // Label 13149: @857576
     /*  857576 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(857651), // Rule ID 24415 //
     /*  857581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  857584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  857592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  857595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  857598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  857601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  857620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857627 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  857630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857649 */     GIR_RootConstrainSelectedInstOperands,
     /*  857650 */     // GIR_Coverage, 24415,
     /*  857650 */     GIR_EraseRootFromParent_Done,
     /*  857651 */   // Label 13150: @857651
     /*  857651 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(857726), // Rule ID 24418 //
     /*  857656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  857670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  857705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857724 */     GIR_RootConstrainSelectedInstOperands,
     /*  857725 */     // GIR_Coverage, 24418,
     /*  857725 */     GIR_EraseRootFromParent_Done,
     /*  857726 */   // Label 13151: @857726
     /*  857726 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(857801), // Rule ID 24419 //
     /*  857731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  857734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  857742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  857745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  857748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857777 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  857780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857799 */     GIR_RootConstrainSelectedInstOperands,
     /*  857800 */     // GIR_Coverage, 24419,
     /*  857800 */     GIR_EraseRootFromParent_Done,
     /*  857801 */   // Label 13152: @857801
     /*  857801 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(857876), // Rule ID 24422 //
     /*  857806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  857820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  857855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857874 */     GIR_RootConstrainSelectedInstOperands,
     /*  857875 */     // GIR_Coverage, 24422,
     /*  857875 */     GIR_EraseRootFromParent_Done,
     /*  857876 */   // Label 13153: @857876
     /*  857876 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(857951), // Rule ID 24423 //
     /*  857881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  857884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  857892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  857895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  857898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  857930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857949 */     GIR_RootConstrainSelectedInstOperands,
     /*  857950 */     // GIR_Coverage, 24423,
     /*  857950 */     GIR_EraseRootFromParent_Done,
     /*  857951 */   // Label 13154: @857951
     /*  857951 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(858026), // Rule ID 24426 //
     /*  857956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  857959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  857964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  857967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  857970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  857973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  857976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  857995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  858005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858024 */     GIR_RootConstrainSelectedInstOperands,
     /*  858025 */     // GIR_Coverage, 24426,
     /*  858025 */     GIR_EraseRootFromParent_Done,
     /*  858026 */   // Label 13155: @858026
     /*  858026 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(858101), // Rule ID 24427 //
     /*  858031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  858034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  858039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  858042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  858045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  858048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858077 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  858080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858099 */     GIR_RootConstrainSelectedInstOperands,
     /*  858100 */     // GIR_Coverage, 24427,
     /*  858100 */     GIR_EraseRootFromParent_Done,
     /*  858101 */   // Label 13156: @858101
     /*  858101 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(858176), // Rule ID 24430 //
     /*  858106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  858120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  858155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858174 */     GIR_RootConstrainSelectedInstOperands,
     /*  858175 */     // GIR_Coverage, 24430,
     /*  858175 */     GIR_EraseRootFromParent_Done,
     /*  858176 */   // Label 13157: @858176
     /*  858176 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(858251), // Rule ID 24431 //
     /*  858181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  858192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  858195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  858198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858227 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  858230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858249 */     GIR_RootConstrainSelectedInstOperands,
     /*  858250 */     // GIR_Coverage, 24431,
     /*  858250 */     GIR_EraseRootFromParent_Done,
     /*  858251 */   // Label 13158: @858251
     /*  858251 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(858326), // Rule ID 24434 //
     /*  858256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  858267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  858270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  858273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858302 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  858305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858324 */     GIR_RootConstrainSelectedInstOperands,
     /*  858325 */     // GIR_Coverage, 24434,
     /*  858325 */     GIR_EraseRootFromParent_Done,
     /*  858326 */   // Label 13159: @858326
     /*  858326 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(858401), // Rule ID 24435 //
     /*  858331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  858342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  858345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  858348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  858380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858399 */     GIR_RootConstrainSelectedInstOperands,
     /*  858400 */     // GIR_Coverage, 24435,
     /*  858400 */     GIR_EraseRootFromParent_Done,
     /*  858401 */   // Label 13160: @858401
     /*  858401 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(858476), // Rule ID 24438 //
     /*  858406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  858409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  858417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  858420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  858423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  858455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858474 */     GIR_RootConstrainSelectedInstOperands,
     /*  858475 */     // GIR_Coverage, 24438,
     /*  858475 */     GIR_EraseRootFromParent_Done,
     /*  858476 */   // Label 13161: @858476
     /*  858476 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(858551), // Rule ID 24439 //
     /*  858481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  858484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  858492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  858495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  858498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  858530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858549 */     GIR_RootConstrainSelectedInstOperands,
     /*  858550 */     // GIR_Coverage, 24439,
     /*  858550 */     GIR_EraseRootFromParent_Done,
     /*  858551 */   // Label 13162: @858551
     /*  858551 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(858626), // Rule ID 24442 //
     /*  858556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  858559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858602 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  858605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858624 */     GIR_RootConstrainSelectedInstOperands,
     /*  858625 */     // GIR_Coverage, 24442,
     /*  858625 */     GIR_EraseRootFromParent_Done,
     /*  858626 */   // Label 13163: @858626
     /*  858626 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(858701), // Rule ID 24443 //
     /*  858631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  858634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  858642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  858645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  858648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  858651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  858670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858677 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  858680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858699 */     GIR_RootConstrainSelectedInstOperands,
     /*  858700 */     // GIR_Coverage, 24443,
     /*  858700 */     GIR_EraseRootFromParent_Done,
     /*  858701 */   // Label 13164: @858701
     /*  858701 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(858776), // Rule ID 24446 //
     /*  858706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  858709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858752 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  858755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858774 */     GIR_RootConstrainSelectedInstOperands,
     /*  858775 */     // GIR_Coverage, 24446,
     /*  858775 */     GIR_EraseRootFromParent_Done,
     /*  858776 */   // Label 13165: @858776
     /*  858776 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(858851), // Rule ID 24447 //
     /*  858781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  858784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  858792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  858795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  858798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  858801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  858820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858827 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  858830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858849 */     GIR_RootConstrainSelectedInstOperands,
     /*  858850 */     // GIR_Coverage, 24447,
     /*  858850 */     GIR_EraseRootFromParent_Done,
     /*  858851 */   // Label 13166: @858851
     /*  858851 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(858926), // Rule ID 24450 //
     /*  858856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  858859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  858905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858924 */     GIR_RootConstrainSelectedInstOperands,
     /*  858925 */     // GIR_Coverage, 24450,
     /*  858925 */     GIR_EraseRootFromParent_Done,
     /*  858926 */   // Label 13167: @858926
     /*  858926 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(859001), // Rule ID 24451 //
     /*  858931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  858934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  858939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  858942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  858945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  858948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  858951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  858966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  858970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858977 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  858980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858999 */     GIR_RootConstrainSelectedInstOperands,
     /*  859000 */     // GIR_Coverage, 24451,
     /*  859000 */     GIR_EraseRootFromParent_Done,
     /*  859001 */   // Label 13168: @859001
     /*  859001 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(859076), // Rule ID 24454 //
     /*  859006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859052 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  859055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859074 */     GIR_RootConstrainSelectedInstOperands,
     /*  859075 */     // GIR_Coverage, 24454,
     /*  859075 */     GIR_EraseRootFromParent_Done,
     /*  859076 */   // Label 13169: @859076
     /*  859076 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(859151), // Rule ID 24455 //
     /*  859081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  859092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  859095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  859098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  859130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859149 */     GIR_RootConstrainSelectedInstOperands,
     /*  859150 */     // GIR_Coverage, 24455,
     /*  859150 */     GIR_EraseRootFromParent_Done,
     /*  859151 */   // Label 13170: @859151
     /*  859151 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(859226), // Rule ID 24458 //
     /*  859156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859202 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  859205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859224 */     GIR_RootConstrainSelectedInstOperands,
     /*  859225 */     // GIR_Coverage, 24458,
     /*  859225 */     GIR_EraseRootFromParent_Done,
     /*  859226 */   // Label 13171: @859226
     /*  859226 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(859301), // Rule ID 24459 //
     /*  859231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  859242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  859245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  859248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859277 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  859280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859299 */     GIR_RootConstrainSelectedInstOperands,
     /*  859300 */     // GIR_Coverage, 24459,
     /*  859300 */     GIR_EraseRootFromParent_Done,
     /*  859301 */   // Label 13172: @859301
     /*  859301 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(859376), // Rule ID 24462 //
     /*  859306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  859309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859352 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  859355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859374 */     GIR_RootConstrainSelectedInstOperands,
     /*  859375 */     // GIR_Coverage, 24462,
     /*  859375 */     GIR_EraseRootFromParent_Done,
     /*  859376 */   // Label 13173: @859376
     /*  859376 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(859451), // Rule ID 24463 //
     /*  859381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  859384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  859392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  859395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  859398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  859401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  859420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859427 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  859430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859449 */     GIR_RootConstrainSelectedInstOperands,
     /*  859450 */     // GIR_Coverage, 24463,
     /*  859450 */     GIR_EraseRootFromParent_Done,
     /*  859451 */   // Label 13174: @859451
     /*  859451 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(859526), // Rule ID 24466 //
     /*  859456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  859505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859524 */     GIR_RootConstrainSelectedInstOperands,
     /*  859525 */     // GIR_Coverage, 24466,
     /*  859525 */     GIR_EraseRootFromParent_Done,
     /*  859526 */   // Label 13175: @859526
     /*  859526 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(859601), // Rule ID 24467 //
     /*  859531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  859542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  859580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859599 */     GIR_RootConstrainSelectedInstOperands,
     /*  859600 */     // GIR_Coverage, 24467,
     /*  859600 */     GIR_EraseRootFromParent_Done,
     /*  859601 */   // Label 13176: @859601
     /*  859601 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(859676), // Rule ID 24470 //
     /*  859606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  859655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859674 */     GIR_RootConstrainSelectedInstOperands,
     /*  859675 */     // GIR_Coverage, 24470,
     /*  859675 */     GIR_EraseRootFromParent_Done,
     /*  859676 */   // Label 13177: @859676
     /*  859676 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(859751), // Rule ID 24471 //
     /*  859681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859727 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  859730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859749 */     GIR_RootConstrainSelectedInstOperands,
     /*  859750 */     // GIR_Coverage, 24471,
     /*  859750 */     GIR_EraseRootFromParent_Done,
     /*  859751 */   // Label 13178: @859751
     /*  859751 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(859826), // Rule ID 24474 //
     /*  859756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  859759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  859805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859824 */     GIR_RootConstrainSelectedInstOperands,
     /*  859825 */     // GIR_Coverage, 24474,
     /*  859825 */     GIR_EraseRootFromParent_Done,
     /*  859826 */   // Label 13179: @859826
     /*  859826 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(859901), // Rule ID 24475 //
     /*  859831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  859834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  859870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859877 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  859880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859899 */     GIR_RootConstrainSelectedInstOperands,
     /*  859900 */     // GIR_Coverage, 24475,
     /*  859900 */     GIR_EraseRootFromParent_Done,
     /*  859901 */   // Label 13180: @859901
     /*  859901 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(859976), // Rule ID 24478 //
     /*  859906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  859909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  859945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  859955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859974 */     GIR_RootConstrainSelectedInstOperands,
     /*  859975 */     // GIR_Coverage, 24478,
     /*  859975 */     GIR_EraseRootFromParent_Done,
     /*  859976 */   // Label 13181: @859976
     /*  859976 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(860051), // Rule ID 24479 //
     /*  859981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  859984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  859989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  860030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860049 */     GIR_RootConstrainSelectedInstOperands,
     /*  860050 */     // GIR_Coverage, 24479,
     /*  860050 */     GIR_EraseRootFromParent_Done,
     /*  860051 */   // Label 13182: @860051
     /*  860051 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(860126), // Rule ID 24482 //
     /*  860056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  860059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  860105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860124 */     GIR_RootConstrainSelectedInstOperands,
     /*  860125 */     // GIR_Coverage, 24482,
     /*  860125 */     GIR_EraseRootFromParent_Done,
     /*  860126 */   // Label 13183: @860126
     /*  860126 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(860201), // Rule ID 24483 //
     /*  860131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  860134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  860142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  860145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  860148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  860180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860199 */     GIR_RootConstrainSelectedInstOperands,
     /*  860200 */     // GIR_Coverage, 24483,
     /*  860200 */     GIR_EraseRootFromParent_Done,
     /*  860201 */   // Label 13184: @860201
     /*  860201 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(860276), // Rule ID 24486 //
     /*  860206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  860209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860252 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  860255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860274 */     GIR_RootConstrainSelectedInstOperands,
     /*  860275 */     // GIR_Coverage, 24486,
     /*  860275 */     GIR_EraseRootFromParent_Done,
     /*  860276 */   // Label 13185: @860276
     /*  860276 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(860351), // Rule ID 24487 //
     /*  860281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  860284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  860289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  860292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  860295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  860298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  860316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  860320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  860330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860349 */     GIR_RootConstrainSelectedInstOperands,
     /*  860350 */     // GIR_Coverage, 24487,
     /*  860350 */     GIR_EraseRootFromParent_Done,
     /*  860351 */   // Label 13186: @860351
     /*  860351 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(860426), // Rule ID 24490 //
     /*  860356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  860376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  860405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860424 */     GIR_RootConstrainSelectedInstOperands,
     /*  860425 */     // GIR_Coverage, 24490,
     /*  860425 */     GIR_EraseRootFromParent_Done,
     /*  860426 */   // Label 13187: @860426
     /*  860426 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(860501), // Rule ID 24491 //
     /*  860431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  860442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  860445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  860448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  860451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  860480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860499 */     GIR_RootConstrainSelectedInstOperands,
     /*  860500 */     // GIR_Coverage, 24491,
     /*  860500 */     GIR_EraseRootFromParent_Done,
     /*  860501 */   // Label 13188: @860501
     /*  860501 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(860576), // Rule ID 24494 //
     /*  860506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  860526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  860555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860574 */     GIR_RootConstrainSelectedInstOperands,
     /*  860575 */     // GIR_Coverage, 24494,
     /*  860575 */     GIR_EraseRootFromParent_Done,
     /*  860576 */   // Label 13189: @860576
     /*  860576 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(860651), // Rule ID 24495 //
     /*  860581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  860601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860627 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  860630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860649 */     GIR_RootConstrainSelectedInstOperands,
     /*  860650 */     // GIR_Coverage, 24495,
     /*  860650 */     GIR_EraseRootFromParent_Done,
     /*  860651 */   // Label 13190: @860651
     /*  860651 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(860726), // Rule ID 24498 //
     /*  860656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  860676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  860705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860724 */     GIR_RootConstrainSelectedInstOperands,
     /*  860725 */     // GIR_Coverage, 24498,
     /*  860725 */     GIR_EraseRootFromParent_Done,
     /*  860726 */   // Label 13191: @860726
     /*  860726 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(860801), // Rule ID 24499 //
     /*  860731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  860751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860777 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  860780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860799 */     GIR_RootConstrainSelectedInstOperands,
     /*  860800 */     // GIR_Coverage, 24499,
     /*  860800 */     GIR_EraseRootFromParent_Done,
     /*  860801 */   // Label 13192: @860801
     /*  860801 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(860876), // Rule ID 24502 //
     /*  860806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  860855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860874 */     GIR_RootConstrainSelectedInstOperands,
     /*  860875 */     // GIR_Coverage, 24502,
     /*  860875 */     GIR_EraseRootFromParent_Done,
     /*  860876 */   // Label 13193: @860876
     /*  860876 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(860951), // Rule ID 24503 //
     /*  860881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  860901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860927 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  860930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860949 */     GIR_RootConstrainSelectedInstOperands,
     /*  860950 */     // GIR_Coverage, 24503,
     /*  860950 */     GIR_EraseRootFromParent_Done,
     /*  860951 */   // Label 13194: @860951
     /*  860951 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(861026), // Rule ID 24506 //
     /*  860956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  860964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  860976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  861005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861024 */     GIR_RootConstrainSelectedInstOperands,
     /*  861025 */     // GIR_Coverage, 24506,
     /*  861025 */     GIR_EraseRootFromParent_Done,
     /*  861026 */   // Label 13195: @861026
     /*  861026 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(861101), // Rule ID 24507 //
     /*  861031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  861042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  861045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  861048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  861051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  861080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861099 */     GIR_RootConstrainSelectedInstOperands,
     /*  861100 */     // GIR_Coverage, 24507,
     /*  861100 */     GIR_EraseRootFromParent_Done,
     /*  861101 */   // Label 13196: @861101
     /*  861101 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(861176), // Rule ID 24510 //
     /*  861106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  861126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  861155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861174 */     GIR_RootConstrainSelectedInstOperands,
     /*  861175 */     // GIR_Coverage, 24510,
     /*  861175 */     GIR_EraseRootFromParent_Done,
     /*  861176 */   // Label 13197: @861176
     /*  861176 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(861251), // Rule ID 24511 //
     /*  861181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  861192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  861195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  861198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  861201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861227 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  861230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861249 */     GIR_RootConstrainSelectedInstOperands,
     /*  861250 */     // GIR_Coverage, 24511,
     /*  861250 */     GIR_EraseRootFromParent_Done,
     /*  861251 */   // Label 13198: @861251
     /*  861251 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(861326), // Rule ID 24514 //
     /*  861256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  861276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  861305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861324 */     GIR_RootConstrainSelectedInstOperands,
     /*  861325 */     // GIR_Coverage, 24514,
     /*  861325 */     GIR_EraseRootFromParent_Done,
     /*  861326 */   // Label 13199: @861326
     /*  861326 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(861401), // Rule ID 24515 //
     /*  861331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  861342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  861345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  861348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  861351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861377 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  861380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861399 */     GIR_RootConstrainSelectedInstOperands,
     /*  861400 */     // GIR_Coverage, 24515,
     /*  861400 */     GIR_EraseRootFromParent_Done,
     /*  861401 */   // Label 13200: @861401
     /*  861401 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(861476), // Rule ID 24518 //
     /*  861406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  861455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861474 */     GIR_RootConstrainSelectedInstOperands,
     /*  861475 */     // GIR_Coverage, 24518,
     /*  861475 */     GIR_EraseRootFromParent_Done,
     /*  861476 */   // Label 13201: @861476
     /*  861476 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(861551), // Rule ID 24519 //
     /*  861481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  861492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  861495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  861498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  861501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861527 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  861530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861549 */     GIR_RootConstrainSelectedInstOperands,
     /*  861550 */     // GIR_Coverage, 24519,
     /*  861550 */     GIR_EraseRootFromParent_Done,
     /*  861551 */   // Label 13202: @861551
     /*  861551 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(861626), // Rule ID 24522 //
     /*  861556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  861576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  861605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861624 */     GIR_RootConstrainSelectedInstOperands,
     /*  861625 */     // GIR_Coverage, 24522,
     /*  861625 */     GIR_EraseRootFromParent_Done,
     /*  861626 */   // Label 13203: @861626
     /*  861626 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(861701), // Rule ID 24523 //
     /*  861631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  861651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  861680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861699 */     GIR_RootConstrainSelectedInstOperands,
     /*  861700 */     // GIR_Coverage, 24523,
     /*  861700 */     GIR_EraseRootFromParent_Done,
     /*  861701 */   // Label 13204: @861701
     /*  861701 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(861776), // Rule ID 24526 //
     /*  861706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  861726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  861755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861774 */     GIR_RootConstrainSelectedInstOperands,
     /*  861775 */     // GIR_Coverage, 24526,
     /*  861775 */     GIR_EraseRootFromParent_Done,
     /*  861776 */   // Label 13205: @861776
     /*  861776 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(861851), // Rule ID 24527 //
     /*  861781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  861801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  861830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861849 */     GIR_RootConstrainSelectedInstOperands,
     /*  861850 */     // GIR_Coverage, 24527,
     /*  861850 */     GIR_EraseRootFromParent_Done,
     /*  861851 */   // Label 13206: @861851
     /*  861851 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(861926), // Rule ID 24530 //
     /*  861856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  861876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  861905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861924 */     GIR_RootConstrainSelectedInstOperands,
     /*  861925 */     // GIR_Coverage, 24530,
     /*  861925 */     GIR_EraseRootFromParent_Done,
     /*  861926 */   // Label 13207: @861926
     /*  861926 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(862001), // Rule ID 24531 //
     /*  861931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  861939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  861951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861977 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  861980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861999 */     GIR_RootConstrainSelectedInstOperands,
     /*  862000 */     // GIR_Coverage, 24531,
     /*  862000 */     GIR_EraseRootFromParent_Done,
     /*  862001 */   // Label 13208: @862001
     /*  862001 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(862076), // Rule ID 24534 //
     /*  862006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  862026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862052 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  862055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862074 */     GIR_RootConstrainSelectedInstOperands,
     /*  862075 */     // GIR_Coverage, 24534,
     /*  862075 */     GIR_EraseRootFromParent_Done,
     /*  862076 */   // Label 13209: @862076
     /*  862076 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(862151), // Rule ID 24535 //
     /*  862081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  862092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  862095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  862098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  862101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862127 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  862130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862149 */     GIR_RootConstrainSelectedInstOperands,
     /*  862150 */     // GIR_Coverage, 24535,
     /*  862150 */     GIR_EraseRootFromParent_Done,
     /*  862151 */   // Label 13210: @862151
     /*  862151 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(862226), // Rule ID 24538 //
     /*  862156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  862176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  862205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862224 */     GIR_RootConstrainSelectedInstOperands,
     /*  862225 */     // GIR_Coverage, 24538,
     /*  862225 */     GIR_EraseRootFromParent_Done,
     /*  862226 */   // Label 13211: @862226
     /*  862226 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(862301), // Rule ID 24539 //
     /*  862231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  862242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  862245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  862248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  862251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862277 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  862280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862299 */     GIR_RootConstrainSelectedInstOperands,
     /*  862300 */     // GIR_Coverage, 24539,
     /*  862300 */     GIR_EraseRootFromParent_Done,
     /*  862301 */   // Label 13212: @862301
     /*  862301 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(862376), // Rule ID 24542 //
     /*  862306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  862355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862374 */     GIR_RootConstrainSelectedInstOperands,
     /*  862375 */     // GIR_Coverage, 24542,
     /*  862375 */     GIR_EraseRootFromParent_Done,
     /*  862376 */   // Label 13213: @862376
     /*  862376 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(862451), // Rule ID 24543 //
     /*  862381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  862392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  862395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  862398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  862401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  862430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862449 */     GIR_RootConstrainSelectedInstOperands,
     /*  862450 */     // GIR_Coverage, 24543,
     /*  862450 */     GIR_EraseRootFromParent_Done,
     /*  862451 */   // Label 13214: @862451
     /*  862451 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(862526), // Rule ID 24546 //
     /*  862456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  862505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862524 */     GIR_RootConstrainSelectedInstOperands,
     /*  862525 */     // GIR_Coverage, 24546,
     /*  862525 */     GIR_EraseRootFromParent_Done,
     /*  862526 */   // Label 13215: @862526
     /*  862526 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(862601), // Rule ID 24547 //
     /*  862531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  862542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  862551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862577 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  862580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862599 */     GIR_RootConstrainSelectedInstOperands,
     /*  862600 */     // GIR_Coverage, 24547,
     /*  862600 */     GIR_EraseRootFromParent_Done,
     /*  862601 */   // Label 13216: @862601
     /*  862601 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(862676), // Rule ID 24550 //
     /*  862606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  862626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  862655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862674 */     GIR_RootConstrainSelectedInstOperands,
     /*  862675 */     // GIR_Coverage, 24550,
     /*  862675 */     GIR_EraseRootFromParent_Done,
     /*  862676 */   // Label 13217: @862676
     /*  862676 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(862751), // Rule ID 24551 //
     /*  862681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  862701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862727 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  862730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862749 */     GIR_RootConstrainSelectedInstOperands,
     /*  862750 */     // GIR_Coverage, 24551,
     /*  862750 */     GIR_EraseRootFromParent_Done,
     /*  862751 */   // Label 13218: @862751
     /*  862751 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(862826), // Rule ID 24554 //
     /*  862756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  862776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  862805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862824 */     GIR_RootConstrainSelectedInstOperands,
     /*  862825 */     // GIR_Coverage, 24554,
     /*  862825 */     GIR_EraseRootFromParent_Done,
     /*  862826 */   // Label 13219: @862826
     /*  862826 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(862901), // Rule ID 24555 //
     /*  862831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  862851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  862880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862899 */     GIR_RootConstrainSelectedInstOperands,
     /*  862900 */     // GIR_Coverage, 24555,
     /*  862900 */     GIR_EraseRootFromParent_Done,
     /*  862901 */   // Label 13220: @862901
     /*  862901 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(862976), // Rule ID 24558 //
     /*  862906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  862926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  862955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862974 */     GIR_RootConstrainSelectedInstOperands,
     /*  862975 */     // GIR_Coverage, 24558,
     /*  862975 */     GIR_EraseRootFromParent_Done,
     /*  862976 */   // Label 13221: @862976
     /*  862976 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(863051), // Rule ID 24559 //
     /*  862981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  862989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  863001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  863030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863049 */     GIR_RootConstrainSelectedInstOperands,
     /*  863050 */     // GIR_Coverage, 24559,
     /*  863050 */     GIR_EraseRootFromParent_Done,
     /*  863051 */   // Label 13222: @863051
     /*  863051 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(863126), // Rule ID 24562 //
     /*  863056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  863076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  863105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863124 */     GIR_RootConstrainSelectedInstOperands,
     /*  863125 */     // GIR_Coverage, 24562,
     /*  863125 */     GIR_EraseRootFromParent_Done,
     /*  863126 */   // Label 13223: @863126
     /*  863126 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(863201), // Rule ID 24563 //
     /*  863131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  863142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  863145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  863148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  863151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  863180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863199 */     GIR_RootConstrainSelectedInstOperands,
     /*  863200 */     // GIR_Coverage, 24563,
     /*  863200 */     GIR_EraseRootFromParent_Done,
     /*  863201 */   // Label 13224: @863201
     /*  863201 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(863276), // Rule ID 24566 //
     /*  863206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  863226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  863255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863274 */     GIR_RootConstrainSelectedInstOperands,
     /*  863275 */     // GIR_Coverage, 24566,
     /*  863275 */     GIR_EraseRootFromParent_Done,
     /*  863276 */   // Label 13225: @863276
     /*  863276 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(863351), // Rule ID 24567 //
     /*  863281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  863292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  863295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  863298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  863301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  863330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863349 */     GIR_RootConstrainSelectedInstOperands,
     /*  863350 */     // GIR_Coverage, 24567,
     /*  863350 */     GIR_EraseRootFromParent_Done,
     /*  863351 */   // Label 13226: @863351
     /*  863351 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(863426), // Rule ID 24570 //
     /*  863356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  863376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  863405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863424 */     GIR_RootConstrainSelectedInstOperands,
     /*  863425 */     // GIR_Coverage, 24570,
     /*  863425 */     GIR_EraseRootFromParent_Done,
     /*  863426 */   // Label 13227: @863426
     /*  863426 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(863501), // Rule ID 24571 //
     /*  863431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  863442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  863445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  863448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  863451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  863470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863477 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  863480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863499 */     GIR_RootConstrainSelectedInstOperands,
     /*  863500 */     // GIR_Coverage, 24571,
     /*  863500 */     GIR_EraseRootFromParent_Done,
     /*  863501 */   // Label 13228: @863501
     /*  863501 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(863576), // Rule ID 24574 //
     /*  863506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  863509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  863526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  863555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863574 */     GIR_RootConstrainSelectedInstOperands,
     /*  863575 */     // GIR_Coverage, 24574,
     /*  863575 */     GIR_EraseRootFromParent_Done,
     /*  863576 */   // Label 13229: @863576
     /*  863576 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(863651), // Rule ID 24575 //
     /*  863581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  863589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  863601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863627 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  863630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863649 */     GIR_RootConstrainSelectedInstOperands,
     /*  863650 */     // GIR_Coverage, 24575,
     /*  863650 */     GIR_EraseRootFromParent_Done,
     /*  863651 */   // Label 13230: @863651
     /*  863651 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(863726), // Rule ID 24578 //
     /*  863656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  863705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863724 */     GIR_RootConstrainSelectedInstOperands,
     /*  863725 */     // GIR_Coverage, 24578,
     /*  863725 */     GIR_EraseRootFromParent_Done,
     /*  863726 */   // Label 13231: @863726
     /*  863726 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(863801), // Rule ID 24579 //
     /*  863731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863777 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  863780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863799 */     GIR_RootConstrainSelectedInstOperands,
     /*  863800 */     // GIR_Coverage, 24579,
     /*  863800 */     GIR_EraseRootFromParent_Done,
     /*  863801 */   // Label 13232: @863801
     /*  863801 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(863876), // Rule ID 24582 //
     /*  863806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863852 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  863855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863874 */     GIR_RootConstrainSelectedInstOperands,
     /*  863875 */     // GIR_Coverage, 24582,
     /*  863875 */     GIR_EraseRootFromParent_Done,
     /*  863876 */   // Label 13233: @863876
     /*  863876 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(863951), // Rule ID 24583 //
     /*  863881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  863930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863949 */     GIR_RootConstrainSelectedInstOperands,
     /*  863950 */     // GIR_Coverage, 24583,
     /*  863950 */     GIR_EraseRootFromParent_Done,
     /*  863951 */   // Label 13234: @863951
     /*  863951 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(864026), // Rule ID 24586 //
     /*  863956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  863976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864024 */     GIR_RootConstrainSelectedInstOperands,
     /*  864025 */     // GIR_Coverage, 24586,
     /*  864025 */     GIR_EraseRootFromParent_Done,
     /*  864026 */   // Label 13235: @864026
     /*  864026 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(864101), // Rule ID 24587 //
     /*  864031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  864042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  864045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  864048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864099 */     GIR_RootConstrainSelectedInstOperands,
     /*  864100 */     // GIR_Coverage, 24587,
     /*  864100 */     GIR_EraseRootFromParent_Done,
     /*  864101 */   // Label 13236: @864101
     /*  864101 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(864176), // Rule ID 24590 //
     /*  864106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864152 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  864155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864174 */     GIR_RootConstrainSelectedInstOperands,
     /*  864175 */     // GIR_Coverage, 24590,
     /*  864175 */     GIR_EraseRootFromParent_Done,
     /*  864176 */   // Label 13237: @864176
     /*  864176 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(864251), // Rule ID 24591 //
     /*  864181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  864192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  864195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  864198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864227 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  864230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864249 */     GIR_RootConstrainSelectedInstOperands,
     /*  864250 */     // GIR_Coverage, 24591,
     /*  864250 */     GIR_EraseRootFromParent_Done,
     /*  864251 */   // Label 13238: @864251
     /*  864251 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(864326), // Rule ID 24594 //
     /*  864256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864324 */     GIR_RootConstrainSelectedInstOperands,
     /*  864325 */     // GIR_Coverage, 24594,
     /*  864325 */     GIR_EraseRootFromParent_Done,
     /*  864326 */   // Label 13239: @864326
     /*  864326 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(864401), // Rule ID 24595 //
     /*  864331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  864342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  864345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  864348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864377 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864399 */     GIR_RootConstrainSelectedInstOperands,
     /*  864400 */     // GIR_Coverage, 24595,
     /*  864400 */     GIR_EraseRootFromParent_Done,
     /*  864401 */   // Label 13240: @864401
     /*  864401 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(864476), // Rule ID 24598 //
     /*  864406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864474 */     GIR_RootConstrainSelectedInstOperands,
     /*  864475 */     // GIR_Coverage, 24598,
     /*  864475 */     GIR_EraseRootFromParent_Done,
     /*  864476 */   // Label 13241: @864476
     /*  864476 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(864551), // Rule ID 24599 //
     /*  864481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  864492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  864495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  864498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864527 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  864530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864549 */     GIR_RootConstrainSelectedInstOperands,
     /*  864550 */     // GIR_Coverage, 24599,
     /*  864550 */     GIR_EraseRootFromParent_Done,
     /*  864551 */   // Label 13242: @864551
     /*  864551 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(864626), // Rule ID 24602 //
     /*  864556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864624 */     GIR_RootConstrainSelectedInstOperands,
     /*  864625 */     // GIR_Coverage, 24602,
     /*  864625 */     GIR_EraseRootFromParent_Done,
     /*  864626 */   // Label 13243: @864626
     /*  864626 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(864701), // Rule ID 24603 //
     /*  864631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864699 */     GIR_RootConstrainSelectedInstOperands,
     /*  864700 */     // GIR_Coverage, 24603,
     /*  864700 */     GIR_EraseRootFromParent_Done,
     /*  864701 */   // Label 13244: @864701
     /*  864701 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(864776), // Rule ID 24606 //
     /*  864706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864774 */     GIR_RootConstrainSelectedInstOperands,
     /*  864775 */     // GIR_Coverage, 24606,
     /*  864775 */     GIR_EraseRootFromParent_Done,
     /*  864776 */   // Label 13245: @864776
     /*  864776 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(864851), // Rule ID 24607 //
     /*  864781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864849 */     GIR_RootConstrainSelectedInstOperands,
     /*  864850 */     // GIR_Coverage, 24607,
     /*  864850 */     GIR_EraseRootFromParent_Done,
     /*  864851 */   // Label 13246: @864851
     /*  864851 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(864926), // Rule ID 24610 //
     /*  864856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  864876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864924 */     GIR_RootConstrainSelectedInstOperands,
     /*  864925 */     // GIR_Coverage, 24610,
     /*  864925 */     GIR_EraseRootFromParent_Done,
     /*  864926 */   // Label 13247: @864926
     /*  864926 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(865001), // Rule ID 24611 //
     /*  864931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  864939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  864951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  864970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  864980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864999 */     GIR_RootConstrainSelectedInstOperands,
     /*  865000 */     // GIR_Coverage, 24611,
     /*  865000 */     GIR_EraseRootFromParent_Done,
     /*  865001 */   // Label 13248: @865001
     /*  865001 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(865076), // Rule ID 24614 //
     /*  865006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  865009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  865055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865074 */     GIR_RootConstrainSelectedInstOperands,
     /*  865075 */     // GIR_Coverage, 24614,
     /*  865075 */     GIR_EraseRootFromParent_Done,
     /*  865076 */   // Label 13249: @865076
     /*  865076 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(865151), // Rule ID 24615 //
     /*  865081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  865084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  865092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  865095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  865098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  865130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865149 */     GIR_RootConstrainSelectedInstOperands,
     /*  865150 */     // GIR_Coverage, 24615,
     /*  865150 */     GIR_EraseRootFromParent_Done,
     /*  865151 */   // Label 13250: @865151
     /*  865151 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(865226), // Rule ID 24618 //
     /*  865156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865202 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865224 */     GIR_RootConstrainSelectedInstOperands,
     /*  865225 */     // GIR_Coverage, 24618,
     /*  865225 */     GIR_EraseRootFromParent_Done,
     /*  865226 */   // Label 13251: @865226
     /*  865226 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(865301), // Rule ID 24619 //
     /*  865231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  865242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  865245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  865248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865299 */     GIR_RootConstrainSelectedInstOperands,
     /*  865300 */     // GIR_Coverage, 24619,
     /*  865300 */     GIR_EraseRootFromParent_Done,
     /*  865301 */   // Label 13252: @865301
     /*  865301 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(865376), // Rule ID 24622 //
     /*  865306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865374 */     GIR_RootConstrainSelectedInstOperands,
     /*  865375 */     // GIR_Coverage, 24622,
     /*  865375 */     GIR_EraseRootFromParent_Done,
     /*  865376 */   // Label 13253: @865376
     /*  865376 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(865451), // Rule ID 24623 //
     /*  865381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  865392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  865395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  865398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865427 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865449 */     GIR_RootConstrainSelectedInstOperands,
     /*  865450 */     // GIR_Coverage, 24623,
     /*  865450 */     GIR_EraseRootFromParent_Done,
     /*  865451 */   // Label 13254: @865451
     /*  865451 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(865526), // Rule ID 24626 //
     /*  865456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  865467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  865470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  865473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865502 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  865502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865524 */     GIR_RootConstrainSelectedInstOperands,
     /*  865525 */     // GIR_Coverage, 24626,
     /*  865525 */     GIR_EraseRootFromParent_Done,
     /*  865526 */   // Label 13255: @865526
     /*  865526 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(865601), // Rule ID 24627 //
     /*  865531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  865542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  865545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  865548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865577 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  865577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  865596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865599 */     GIR_RootConstrainSelectedInstOperands,
     /*  865600 */     // GIR_Coverage, 24627,
     /*  865600 */     GIR_EraseRootFromParent_Done,
     /*  865601 */   // Label 13256: @865601
     /*  865601 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(865676), // Rule ID 24630 //
     /*  865606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865674 */     GIR_RootConstrainSelectedInstOperands,
     /*  865675 */     // GIR_Coverage, 24630,
     /*  865675 */     GIR_EraseRootFromParent_Done,
     /*  865676 */   // Label 13257: @865676
     /*  865676 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(865751), // Rule ID 24631 //
     /*  865681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  865692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865727 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  865730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865749 */     GIR_RootConstrainSelectedInstOperands,
     /*  865750 */     // GIR_Coverage, 24631,
     /*  865750 */     GIR_EraseRootFromParent_Done,
     /*  865751 */   // Label 13258: @865751
     /*  865751 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(865826), // Rule ID 24634 //
     /*  865756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865824 */     GIR_RootConstrainSelectedInstOperands,
     /*  865825 */     // GIR_Coverage, 24634,
     /*  865825 */     GIR_EraseRootFromParent_Done,
     /*  865826 */   // Label 13259: @865826
     /*  865826 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(865901), // Rule ID 24635 //
     /*  865831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  865851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865877 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  865880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865899 */     GIR_RootConstrainSelectedInstOperands,
     /*  865900 */     // GIR_Coverage, 24635,
     /*  865900 */     GIR_EraseRootFromParent_Done,
     /*  865901 */   // Label 13260: @865901
     /*  865901 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(865976), // Rule ID 24638 //
     /*  865906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  865926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  865945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  865955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865974 */     GIR_RootConstrainSelectedInstOperands,
     /*  865975 */     // GIR_Coverage, 24638,
     /*  865975 */     GIR_EraseRootFromParent_Done,
     /*  865976 */   // Label 13261: @865976
     /*  865976 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(866051), // Rule ID 24639 //
     /*  865981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  865989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866027 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866049 */     GIR_RootConstrainSelectedInstOperands,
     /*  866050 */     // GIR_Coverage, 24639,
     /*  866050 */     GIR_EraseRootFromParent_Done,
     /*  866051 */   // Label 13262: @866051
     /*  866051 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(866126), // Rule ID 24642 //
     /*  866056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866124 */     GIR_RootConstrainSelectedInstOperands,
     /*  866125 */     // GIR_Coverage, 24642,
     /*  866125 */     GIR_EraseRootFromParent_Done,
     /*  866126 */   // Label 13263: @866126
     /*  866126 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(866201), // Rule ID 24643 //
     /*  866131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866199 */     GIR_RootConstrainSelectedInstOperands,
     /*  866200 */     // GIR_Coverage, 24643,
     /*  866200 */     GIR_EraseRootFromParent_Done,
     /*  866201 */   // Label 13264: @866201
     /*  866201 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(866276), // Rule ID 24646 //
     /*  866206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866274 */     GIR_RootConstrainSelectedInstOperands,
     /*  866275 */     // GIR_Coverage, 24646,
     /*  866275 */     GIR_EraseRootFromParent_Done,
     /*  866276 */   // Label 13265: @866276
     /*  866276 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(866351), // Rule ID 24647 //
     /*  866281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866349 */     GIR_RootConstrainSelectedInstOperands,
     /*  866350 */     // GIR_Coverage, 24647,
     /*  866350 */     GIR_EraseRootFromParent_Done,
     /*  866351 */   // Label 13266: @866351
     /*  866351 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(866426), // Rule ID 24650 //
     /*  866356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866424 */     GIR_RootConstrainSelectedInstOperands,
     /*  866425 */     // GIR_Coverage, 24650,
     /*  866425 */     GIR_EraseRootFromParent_Done,
     /*  866426 */   // Label 13267: @866426
     /*  866426 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(866501), // Rule ID 24651 //
     /*  866431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  866434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866499 */     GIR_RootConstrainSelectedInstOperands,
     /*  866500 */     // GIR_Coverage, 24651,
     /*  866500 */     GIR_EraseRootFromParent_Done,
     /*  866501 */   // Label 13268: @866501
     /*  866501 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(866576), // Rule ID 24654 //
     /*  866506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866574 */     GIR_RootConstrainSelectedInstOperands,
     /*  866575 */     // GIR_Coverage, 24654,
     /*  866575 */     GIR_EraseRootFromParent_Done,
     /*  866576 */   // Label 13269: @866576
     /*  866576 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(866651), // Rule ID 24655 //
     /*  866581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  866630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866649 */     GIR_RootConstrainSelectedInstOperands,
     /*  866650 */     // GIR_Coverage, 24655,
     /*  866650 */     GIR_EraseRootFromParent_Done,
     /*  866651 */   // Label 13270: @866651
     /*  866651 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(866726), // Rule ID 24658 //
     /*  866656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866724 */     GIR_RootConstrainSelectedInstOperands,
     /*  866725 */     // GIR_Coverage, 24658,
     /*  866725 */     GIR_EraseRootFromParent_Done,
     /*  866726 */   // Label 13271: @866726
     /*  866726 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(866801), // Rule ID 24659 //
     /*  866731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866777 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  866780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866799 */     GIR_RootConstrainSelectedInstOperands,
     /*  866800 */     // GIR_Coverage, 24659,
     /*  866800 */     GIR_EraseRootFromParent_Done,
     /*  866801 */   // Label 13272: @866801
     /*  866801 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(866876), // Rule ID 24662 //
     /*  866806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  866809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  866826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866874 */     GIR_RootConstrainSelectedInstOperands,
     /*  866875 */     // GIR_Coverage, 24662,
     /*  866875 */     GIR_EraseRootFromParent_Done,
     /*  866876 */   // Label 13273: @866876
     /*  866876 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(866951), // Rule ID 24663 //
     /*  866881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  866884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  866889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  866901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  866920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866927 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  866930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866949 */     GIR_RootConstrainSelectedInstOperands,
     /*  866950 */     // GIR_Coverage, 24663,
     /*  866950 */     GIR_EraseRootFromParent_Done,
     /*  866951 */   // Label 13274: @866951
     /*  866951 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(867026), // Rule ID 24754 //
     /*  866956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  866959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  866967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  866970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  866973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867002 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  867005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867024 */     GIR_RootConstrainSelectedInstOperands,
     /*  867025 */     // GIR_Coverage, 24754,
     /*  867025 */     GIR_EraseRootFromParent_Done,
     /*  867026 */   // Label 13275: @867026
     /*  867026 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(867101), // Rule ID 24755 //
     /*  867031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  867042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  867045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  867048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867077 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  867080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867099 */     GIR_RootConstrainSelectedInstOperands,
     /*  867100 */     // GIR_Coverage, 24755,
     /*  867100 */     GIR_EraseRootFromParent_Done,
     /*  867101 */   // Label 13276: @867101
     /*  867101 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(867176), // Rule ID 24758 //
     /*  867106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  867117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  867120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  867123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  867155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867174 */     GIR_RootConstrainSelectedInstOperands,
     /*  867175 */     // GIR_Coverage, 24758,
     /*  867175 */     GIR_EraseRootFromParent_Done,
     /*  867176 */   // Label 13277: @867176
     /*  867176 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(867251), // Rule ID 24759 //
     /*  867181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  867192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  867195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  867198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867227 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  867230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867249 */     GIR_RootConstrainSelectedInstOperands,
     /*  867250 */     // GIR_Coverage, 24759,
     /*  867250 */     GIR_EraseRootFromParent_Done,
     /*  867251 */   // Label 13278: @867251
     /*  867251 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(867326), // Rule ID 24762 //
     /*  867256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  867267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  867270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  867273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867302 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  867305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867324 */     GIR_RootConstrainSelectedInstOperands,
     /*  867325 */     // GIR_Coverage, 24762,
     /*  867325 */     GIR_EraseRootFromParent_Done,
     /*  867326 */   // Label 13279: @867326
     /*  867326 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(867401), // Rule ID 24763 //
     /*  867331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  867342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  867345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  867348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  867351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867377 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  867380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867399 */     GIR_RootConstrainSelectedInstOperands,
     /*  867400 */     // GIR_Coverage, 24763,
     /*  867400 */     GIR_EraseRootFromParent_Done,
     /*  867401 */   // Label 13280: @867401
     /*  867401 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(867476), // Rule ID 24766 //
     /*  867406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  867417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  867420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  867423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  867455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867474 */     GIR_RootConstrainSelectedInstOperands,
     /*  867475 */     // GIR_Coverage, 24766,
     /*  867475 */     GIR_EraseRootFromParent_Done,
     /*  867476 */   // Label 13281: @867476
     /*  867476 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(867551), // Rule ID 24767 //
     /*  867481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  867492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  867495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  867498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867527 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  867530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867549 */     GIR_RootConstrainSelectedInstOperands,
     /*  867550 */     // GIR_Coverage, 24767,
     /*  867550 */     GIR_EraseRootFromParent_Done,
     /*  867551 */   // Label 13282: @867551
     /*  867551 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(867626), // Rule ID 24770 //
     /*  867556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  867567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  867570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  867573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  867605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867624 */     GIR_RootConstrainSelectedInstOperands,
     /*  867625 */     // GIR_Coverage, 24770,
     /*  867625 */     GIR_EraseRootFromParent_Done,
     /*  867626 */   // Label 13283: @867626
     /*  867626 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(867701), // Rule ID 24771 //
     /*  867631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  867642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  867645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  867648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  867651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867677 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  867680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867699 */     GIR_RootConstrainSelectedInstOperands,
     /*  867700 */     // GIR_Coverage, 24771,
     /*  867700 */     GIR_EraseRootFromParent_Done,
     /*  867701 */   // Label 13284: @867701
     /*  867701 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(867776), // Rule ID 24774 //
     /*  867706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  867755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867774 */     GIR_RootConstrainSelectedInstOperands,
     /*  867775 */     // GIR_Coverage, 24774,
     /*  867775 */     GIR_EraseRootFromParent_Done,
     /*  867776 */   // Label 13285: @867776
     /*  867776 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(867851), // Rule ID 24775 //
     /*  867781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  867801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  867830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867849 */     GIR_RootConstrainSelectedInstOperands,
     /*  867850 */     // GIR_Coverage, 24775,
     /*  867850 */     GIR_EraseRootFromParent_Done,
     /*  867851 */   // Label 13286: @867851
     /*  867851 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(867926), // Rule ID 24778 //
     /*  867856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  867859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  867867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  867870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  867873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  867902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  867905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867924 */     GIR_RootConstrainSelectedInstOperands,
     /*  867925 */     // GIR_Coverage, 24778,
     /*  867925 */     GIR_EraseRootFromParent_Done,
     /*  867926 */   // Label 13287: @867926
     /*  867926 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(868001), // Rule ID 24779 //
     /*  867931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  867934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  867939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  867942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  867945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  867948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867977 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  867977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  867980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  867996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867999 */     GIR_RootConstrainSelectedInstOperands,
     /*  868000 */     // GIR_Coverage, 24779,
     /*  868000 */     GIR_EraseRootFromParent_Done,
     /*  868001 */   // Label 13288: @868001
     /*  868001 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(868076), // Rule ID 24782 //
     /*  868006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  868055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868074 */     GIR_RootConstrainSelectedInstOperands,
     /*  868075 */     // GIR_Coverage, 24782,
     /*  868075 */     GIR_EraseRootFromParent_Done,
     /*  868076 */   // Label 13289: @868076
     /*  868076 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(868151), // Rule ID 24783 //
     /*  868081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868127 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  868130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868149 */     GIR_RootConstrainSelectedInstOperands,
     /*  868150 */     // GIR_Coverage, 24783,
     /*  868150 */     GIR_EraseRootFromParent_Done,
     /*  868151 */   // Label 13290: @868151
     /*  868151 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(868226), // Rule ID 24786 //
     /*  868156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  868167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  868170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  868173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  868205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868224 */     GIR_RootConstrainSelectedInstOperands,
     /*  868225 */     // GIR_Coverage, 24786,
     /*  868225 */     GIR_EraseRootFromParent_Done,
     /*  868226 */   // Label 13291: @868226
     /*  868226 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(868301), // Rule ID 24787 //
     /*  868231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  868242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  868245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  868248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  868280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868299 */     GIR_RootConstrainSelectedInstOperands,
     /*  868300 */     // GIR_Coverage, 24787,
     /*  868300 */     GIR_EraseRootFromParent_Done,
     /*  868301 */   // Label 13292: @868301
     /*  868301 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(868376), // Rule ID 24790 //
     /*  868306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  868309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  868317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  868320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  868323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  868355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868374 */     GIR_RootConstrainSelectedInstOperands,
     /*  868375 */     // GIR_Coverage, 24790,
     /*  868375 */     GIR_EraseRootFromParent_Done,
     /*  868376 */   // Label 13293: @868376
     /*  868376 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(868451), // Rule ID 24791 //
     /*  868381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  868384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  868392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  868395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  868398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  868430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868449 */     GIR_RootConstrainSelectedInstOperands,
     /*  868450 */     // GIR_Coverage, 24791,
     /*  868450 */     GIR_EraseRootFromParent_Done,
     /*  868451 */   // Label 13294: @868451
     /*  868451 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(868526), // Rule ID 24794 //
     /*  868456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  868467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  868470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  868473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  868502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  868505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868524 */     GIR_RootConstrainSelectedInstOperands,
     /*  868525 */     // GIR_Coverage, 24794,
     /*  868525 */     GIR_EraseRootFromParent_Done,
     /*  868526 */   // Label 13295: @868526
     /*  868526 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(868601), // Rule ID 24795 //
     /*  868531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  868542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  868545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  868548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  868577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  868580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868599 */     GIR_RootConstrainSelectedInstOperands,
     /*  868600 */     // GIR_Coverage, 24795,
     /*  868600 */     GIR_EraseRootFromParent_Done,
     /*  868601 */   // Label 13296: @868601
     /*  868601 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(868676), // Rule ID 24798 //
     /*  868606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  868617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  868620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  868623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  868652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  868655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868674 */     GIR_RootConstrainSelectedInstOperands,
     /*  868675 */     // GIR_Coverage, 24798,
     /*  868675 */     GIR_EraseRootFromParent_Done,
     /*  868676 */   // Label 13297: @868676
     /*  868676 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(868751), // Rule ID 24799 //
     /*  868681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  868692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  868695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  868698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  868701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  868727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  868730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  868746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868749 */     GIR_RootConstrainSelectedInstOperands,
     /*  868750 */     // GIR_Coverage, 24799,
     /*  868750 */     GIR_EraseRootFromParent_Done,
     /*  868751 */   // Label 13298: @868751
     /*  868751 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(868826), // Rule ID 24802 //
     /*  868756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  868805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868824 */     GIR_RootConstrainSelectedInstOperands,
     /*  868825 */     // GIR_Coverage, 24802,
     /*  868825 */     GIR_EraseRootFromParent_Done,
     /*  868826 */   // Label 13299: @868826
     /*  868826 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(868901), // Rule ID 24803 //
     /*  868831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  868880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868899 */     GIR_RootConstrainSelectedInstOperands,
     /*  868900 */     // GIR_Coverage, 24803,
     /*  868900 */     GIR_EraseRootFromParent_Done,
     /*  868901 */   // Label 13300: @868901
     /*  868901 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(868976), // Rule ID 24806 //
     /*  868906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  868909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  868917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  868920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  868923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  868926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  868955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868974 */     GIR_RootConstrainSelectedInstOperands,
     /*  868975 */     // GIR_Coverage, 24806,
     /*  868975 */     GIR_EraseRootFromParent_Done,
     /*  868976 */   // Label 13301: @868976
     /*  868976 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(869051), // Rule ID 24807 //
     /*  868981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  868984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  868989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  868992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  868995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  868998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  869030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869049 */     GIR_RootConstrainSelectedInstOperands,
     /*  869050 */     // GIR_Coverage, 24807,
     /*  869050 */     GIR_EraseRootFromParent_Done,
     /*  869051 */   // Label 13302: @869051
     /*  869051 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(869126), // Rule ID 24810 //
     /*  869056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  869105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869124 */     GIR_RootConstrainSelectedInstOperands,
     /*  869125 */     // GIR_Coverage, 24810,
     /*  869125 */     GIR_EraseRootFromParent_Done,
     /*  869126 */   // Label 13303: @869126
     /*  869126 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(869201), // Rule ID 24811 //
     /*  869131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  869180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869199 */     GIR_RootConstrainSelectedInstOperands,
     /*  869200 */     // GIR_Coverage, 24811,
     /*  869200 */     GIR_EraseRootFromParent_Done,
     /*  869201 */   // Label 13304: @869201
     /*  869201 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(869276), // Rule ID 24814 //
     /*  869206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  869255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869274 */     GIR_RootConstrainSelectedInstOperands,
     /*  869275 */     // GIR_Coverage, 24814,
     /*  869275 */     GIR_EraseRootFromParent_Done,
     /*  869276 */   // Label 13305: @869276
     /*  869276 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(869351), // Rule ID 24815 //
     /*  869281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  869330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869349 */     GIR_RootConstrainSelectedInstOperands,
     /*  869350 */     // GIR_Coverage, 24815,
     /*  869350 */     GIR_EraseRootFromParent_Done,
     /*  869351 */   // Label 13306: @869351
     /*  869351 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(869426), // Rule ID 24818 //
     /*  869356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  869367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  869370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  869373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  869405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869424 */     GIR_RootConstrainSelectedInstOperands,
     /*  869425 */     // GIR_Coverage, 24818,
     /*  869425 */     GIR_EraseRootFromParent_Done,
     /*  869426 */   // Label 13307: @869426
     /*  869426 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(869501), // Rule ID 24819 //
     /*  869431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  869442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  869445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  869448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  869480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869499 */     GIR_RootConstrainSelectedInstOperands,
     /*  869500 */     // GIR_Coverage, 24819,
     /*  869500 */     GIR_EraseRootFromParent_Done,
     /*  869501 */   // Label 13308: @869501
     /*  869501 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(869576), // Rule ID 24822 //
     /*  869506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  869509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  869517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  869520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  869523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  869555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869574 */     GIR_RootConstrainSelectedInstOperands,
     /*  869575 */     // GIR_Coverage, 24822,
     /*  869575 */     GIR_EraseRootFromParent_Done,
     /*  869576 */   // Label 13309: @869576
     /*  869576 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(869651), // Rule ID 24823 //
     /*  869581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  869584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  869592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  869595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  869598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869627 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  869630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869649 */     GIR_RootConstrainSelectedInstOperands,
     /*  869650 */     // GIR_Coverage, 24823,
     /*  869650 */     GIR_EraseRootFromParent_Done,
     /*  869651 */   // Label 13310: @869651
     /*  869651 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(869726), // Rule ID 24826 //
     /*  869656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  869667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  869670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  869673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  869676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  869705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869724 */     GIR_RootConstrainSelectedInstOperands,
     /*  869725 */     // GIR_Coverage, 24826,
     /*  869725 */     GIR_EraseRootFromParent_Done,
     /*  869726 */   // Label 13311: @869726
     /*  869726 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(869801), // Rule ID 24827 //
     /*  869731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  869734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  869742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  869745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  869748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  869751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  869780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869799 */     GIR_RootConstrainSelectedInstOperands,
     /*  869800 */     // GIR_Coverage, 24827,
     /*  869800 */     GIR_EraseRootFromParent_Done,
     /*  869801 */   // Label 13312: @869801
     /*  869801 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(869876), // Rule ID 24830 //
     /*  869806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  869817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  869820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  869823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  869855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869874 */     GIR_RootConstrainSelectedInstOperands,
     /*  869875 */     // GIR_Coverage, 24830,
     /*  869875 */     GIR_EraseRootFromParent_Done,
     /*  869876 */   // Label 13313: @869876
     /*  869876 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(869951), // Rule ID 24831 //
     /*  869881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  869884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  869892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  869895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  869898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  869901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  869930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869949 */     GIR_RootConstrainSelectedInstOperands,
     /*  869950 */     // GIR_Coverage, 24831,
     /*  869950 */     GIR_EraseRootFromParent_Done,
     /*  869951 */   // Label 13314: @869951
     /*  869951 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(870026), // Rule ID 24834 //
     /*  869956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  869959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  869964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  869967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  869970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  869973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  869976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  870005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870024 */     GIR_RootConstrainSelectedInstOperands,
     /*  870025 */     // GIR_Coverage, 24834,
     /*  870025 */     GIR_EraseRootFromParent_Done,
     /*  870026 */   // Label 13315: @870026
     /*  870026 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(870101), // Rule ID 24835 //
     /*  870031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  870034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  870051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  870080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870099 */     GIR_RootConstrainSelectedInstOperands,
     /*  870100 */     // GIR_Coverage, 24835,
     /*  870100 */     GIR_EraseRootFromParent_Done,
     /*  870101 */   // Label 13316: @870101
     /*  870101 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(870176), // Rule ID 24838 //
     /*  870106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  870126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870152 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  870155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870174 */     GIR_RootConstrainSelectedInstOperands,
     /*  870175 */     // GIR_Coverage, 24838,
     /*  870175 */     GIR_EraseRootFromParent_Done,
     /*  870176 */   // Label 13317: @870176
     /*  870176 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(870251), // Rule ID 24839 //
     /*  870181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  870201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870227 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  870230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870249 */     GIR_RootConstrainSelectedInstOperands,
     /*  870250 */     // GIR_Coverage, 24839,
     /*  870250 */     GIR_EraseRootFromParent_Done,
     /*  870251 */   // Label 13318: @870251
     /*  870251 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(870326), // Rule ID 24842 //
     /*  870256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  870276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870302 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  870305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870324 */     GIR_RootConstrainSelectedInstOperands,
     /*  870325 */     // GIR_Coverage, 24842,
     /*  870325 */     GIR_EraseRootFromParent_Done,
     /*  870326 */   // Label 13319: @870326
     /*  870326 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(870401), // Rule ID 24843 //
     /*  870331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  870351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  870380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870399 */     GIR_RootConstrainSelectedInstOperands,
     /*  870400 */     // GIR_Coverage, 24843,
     /*  870400 */     GIR_EraseRootFromParent_Done,
     /*  870401 */   // Label 13320: @870401
     /*  870401 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(870476), // Rule ID 24846 //
     /*  870406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  870409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  870417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  870420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  870423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  870426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  870455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870474 */     GIR_RootConstrainSelectedInstOperands,
     /*  870475 */     // GIR_Coverage, 24846,
     /*  870475 */     GIR_EraseRootFromParent_Done,
     /*  870476 */   // Label 13321: @870476
     /*  870476 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(870551), // Rule ID 24847 //
     /*  870481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  870484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  870492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  870495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  870498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  870501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870527 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  870530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870549 */     GIR_RootConstrainSelectedInstOperands,
     /*  870550 */     // GIR_Coverage, 24847,
     /*  870550 */     GIR_EraseRootFromParent_Done,
     /*  870551 */   // Label 13322: @870551
     /*  870551 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(870626), // Rule ID 24850 //
     /*  870556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  870576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  870605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870624 */     GIR_RootConstrainSelectedInstOperands,
     /*  870625 */     // GIR_Coverage, 24850,
     /*  870625 */     GIR_EraseRootFromParent_Done,
     /*  870626 */   // Label 13323: @870626
     /*  870626 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(870701), // Rule ID 24851 //
     /*  870631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  870642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  870645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  870648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  870651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  870680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870699 */     GIR_RootConstrainSelectedInstOperands,
     /*  870700 */     // GIR_Coverage, 24851,
     /*  870700 */     GIR_EraseRootFromParent_Done,
     /*  870701 */   // Label 13324: @870701
     /*  870701 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(870776), // Rule ID 24854 //
     /*  870706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  870726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870752 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  870755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870774 */     GIR_RootConstrainSelectedInstOperands,
     /*  870775 */     // GIR_Coverage, 24854,
     /*  870775 */     GIR_EraseRootFromParent_Done,
     /*  870776 */   // Label 13325: @870776
     /*  870776 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(870851), // Rule ID 24855 //
     /*  870781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  870801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870827 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  870830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870849 */     GIR_RootConstrainSelectedInstOperands,
     /*  870850 */     // GIR_Coverage, 24855,
     /*  870850 */     GIR_EraseRootFromParent_Done,
     /*  870851 */   // Label 13326: @870851
     /*  870851 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(870926), // Rule ID 24858 //
     /*  870856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  870876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870902 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  870905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870924 */     GIR_RootConstrainSelectedInstOperands,
     /*  870925 */     // GIR_Coverage, 24858,
     /*  870925 */     GIR_EraseRootFromParent_Done,
     /*  870926 */   // Label 13327: @870926
     /*  870926 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(871001), // Rule ID 24859 //
     /*  870931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  870939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  870951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870977 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  870980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870999 */     GIR_RootConstrainSelectedInstOperands,
     /*  871000 */     // GIR_Coverage, 24859,
     /*  871000 */     GIR_EraseRootFromParent_Done,
     /*  871001 */   // Label 13328: @871001
     /*  871001 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(871076), // Rule ID 24862 //
     /*  871006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  871017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  871020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  871023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  871026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871052 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  871055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871074 */     GIR_RootConstrainSelectedInstOperands,
     /*  871075 */     // GIR_Coverage, 24862,
     /*  871075 */     GIR_EraseRootFromParent_Done,
     /*  871076 */   // Label 13329: @871076
     /*  871076 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(871151), // Rule ID 24863 //
     /*  871081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  871092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  871095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  871098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  871101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  871130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871149 */     GIR_RootConstrainSelectedInstOperands,
     /*  871150 */     // GIR_Coverage, 24863,
     /*  871150 */     GIR_EraseRootFromParent_Done,
     /*  871151 */   // Label 13330: @871151
     /*  871151 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(871226), // Rule ID 24866 //
     /*  871156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  871176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871202 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  871205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871224 */     GIR_RootConstrainSelectedInstOperands,
     /*  871225 */     // GIR_Coverage, 24866,
     /*  871225 */     GIR_EraseRootFromParent_Done,
     /*  871226 */   // Label 13331: @871226
     /*  871226 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(871301), // Rule ID 24867 //
     /*  871231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  871242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  871245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  871248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  871251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871277 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  871280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871299 */     GIR_RootConstrainSelectedInstOperands,
     /*  871300 */     // GIR_Coverage, 24867,
     /*  871300 */     GIR_EraseRootFromParent_Done,
     /*  871301 */   // Label 13332: @871301
     /*  871301 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(871376), // Rule ID 24870 //
     /*  871306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  871326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  871355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871374 */     GIR_RootConstrainSelectedInstOperands,
     /*  871375 */     // GIR_Coverage, 24870,
     /*  871375 */     GIR_EraseRootFromParent_Done,
     /*  871376 */   // Label 13333: @871376
     /*  871376 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(871451), // Rule ID 24871 //
     /*  871381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  871389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  871392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  871395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  871398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  871401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871427 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  871430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871449 */     GIR_RootConstrainSelectedInstOperands,
     /*  871450 */     // GIR_Coverage, 24871,
     /*  871450 */     GIR_EraseRootFromParent_Done,
     /*  871451 */   // Label 13334: @871451
     /*  871451 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(871526), // Rule ID 24874 //
     /*  871456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871502 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  871505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871524 */     GIR_RootConstrainSelectedInstOperands,
     /*  871525 */     // GIR_Coverage, 24874,
     /*  871525 */     GIR_EraseRootFromParent_Done,
     /*  871526 */   // Label 13335: @871526
     /*  871526 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(871601), // Rule ID 24875 //
     /*  871531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871577 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  871580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871599 */     GIR_RootConstrainSelectedInstOperands,
     /*  871600 */     // GIR_Coverage, 24875,
     /*  871600 */     GIR_EraseRootFromParent_Done,
     /*  871601 */   // Label 13336: @871601
     /*  871601 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(871676), // Rule ID 24878 //
     /*  871606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871674 */     GIR_RootConstrainSelectedInstOperands,
     /*  871675 */     // GIR_Coverage, 24878,
     /*  871675 */     GIR_EraseRootFromParent_Done,
     /*  871676 */   // Label 13337: @871676
     /*  871676 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(871751), // Rule ID 24879 //
     /*  871681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871749 */     GIR_RootConstrainSelectedInstOperands,
     /*  871750 */     // GIR_Coverage, 24879,
     /*  871750 */     GIR_EraseRootFromParent_Done,
     /*  871751 */   // Label 13338: @871751
     /*  871751 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(871826), // Rule ID 24882 //
     /*  871756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  871759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871824 */     GIR_RootConstrainSelectedInstOperands,
     /*  871825 */     // GIR_Coverage, 24882,
     /*  871825 */     GIR_EraseRootFromParent_Done,
     /*  871826 */   // Label 13339: @871826
     /*  871826 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(871901), // Rule ID 24883 //
     /*  871831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  871834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  871851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  871880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871899 */     GIR_RootConstrainSelectedInstOperands,
     /*  871900 */     // GIR_Coverage, 24883,
     /*  871900 */     GIR_EraseRootFromParent_Done,
     /*  871901 */   // Label 13340: @871901
     /*  871901 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(871976), // Rule ID 24886 //
     /*  871906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  871909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  871926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  871945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871952 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  871955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871974 */     GIR_RootConstrainSelectedInstOperands,
     /*  871975 */     // GIR_Coverage, 24886,
     /*  871975 */     GIR_EraseRootFromParent_Done,
     /*  871976 */   // Label 13341: @871976
     /*  871976 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(872051), // Rule ID 24887 //
     /*  871981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  871984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  871989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872027 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872049 */     GIR_RootConstrainSelectedInstOperands,
     /*  872050 */     // GIR_Coverage, 24887,
     /*  872050 */     GIR_EraseRootFromParent_Done,
     /*  872051 */   // Label 13342: @872051
     /*  872051 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(872126), // Rule ID 24890 //
     /*  872056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  872059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872124 */     GIR_RootConstrainSelectedInstOperands,
     /*  872125 */     // GIR_Coverage, 24890,
     /*  872125 */     GIR_EraseRootFromParent_Done,
     /*  872126 */   // Label 13343: @872126
     /*  872126 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(872201), // Rule ID 24891 //
     /*  872131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  872134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872177 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872199 */     GIR_RootConstrainSelectedInstOperands,
     /*  872200 */     // GIR_Coverage, 24891,
     /*  872200 */     GIR_EraseRootFromParent_Done,
     /*  872201 */   // Label 13344: @872201
     /*  872201 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(872276), // Rule ID 24894 //
     /*  872206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  872209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872252 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872274 */     GIR_RootConstrainSelectedInstOperands,
     /*  872275 */     // GIR_Coverage, 24894,
     /*  872275 */     GIR_EraseRootFromParent_Done,
     /*  872276 */   // Label 13345: @872276
     /*  872276 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(872351), // Rule ID 24895 //
     /*  872281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  872284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872327 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872349 */     GIR_RootConstrainSelectedInstOperands,
     /*  872350 */     // GIR_Coverage, 24895,
     /*  872350 */     GIR_EraseRootFromParent_Done,
     /*  872351 */   // Label 13346: @872351
     /*  872351 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(872426), // Rule ID 24898 //
     /*  872356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872402 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872424 */     GIR_RootConstrainSelectedInstOperands,
     /*  872425 */     // GIR_Coverage, 24898,
     /*  872425 */     GIR_EraseRootFromParent_Done,
     /*  872426 */   // Label 13347: @872426
     /*  872426 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(872501), // Rule ID 24899 //
     /*  872431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  872480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872499 */     GIR_RootConstrainSelectedInstOperands,
     /*  872500 */     // GIR_Coverage, 24899,
     /*  872500 */     GIR_EraseRootFromParent_Done,
     /*  872501 */   // Label 13348: @872501
     /*  872501 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(872576), // Rule ID 24902 //
     /*  872506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872574 */     GIR_RootConstrainSelectedInstOperands,
     /*  872575 */     // GIR_Coverage, 24902,
     /*  872575 */     GIR_EraseRootFromParent_Done,
     /*  872576 */   // Label 13349: @872576
     /*  872576 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(872651), // Rule ID 24903 //
     /*  872581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872627 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  872630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872649 */     GIR_RootConstrainSelectedInstOperands,
     /*  872650 */     // GIR_Coverage, 24903,
     /*  872650 */     GIR_EraseRootFromParent_Done,
     /*  872651 */   // Label 13350: @872651
     /*  872651 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(872726), // Rule ID 24906 //
     /*  872656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  872659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  872676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872724 */     GIR_RootConstrainSelectedInstOperands,
     /*  872725 */     // GIR_Coverage, 24906,
     /*  872725 */     GIR_EraseRootFromParent_Done,
     /*  872726 */   // Label 13351: @872726
     /*  872726 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(872801), // Rule ID 24907 //
     /*  872731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  872734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  872739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  872751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  872770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872777 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  872780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872799 */     GIR_RootConstrainSelectedInstOperands,
     /*  872800 */     // GIR_Coverage, 24907,
     /*  872800 */     GIR_EraseRootFromParent_Done,
     /*  872801 */   // Label 13352: @872801
     /*  872801 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(872876), // Rule ID 24946 //
     /*  872806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  872809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872852 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  872855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872874 */     GIR_RootConstrainSelectedInstOperands,
     /*  872875 */     // GIR_Coverage, 24946,
     /*  872875 */     GIR_EraseRootFromParent_Done,
     /*  872876 */   // Label 13353: @872876
     /*  872876 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(872951), // Rule ID 24947 //
     /*  872881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  872884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  872901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872927 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  872930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872949 */     GIR_RootConstrainSelectedInstOperands,
     /*  872950 */     // GIR_Coverage, 24947,
     /*  872950 */     GIR_EraseRootFromParent_Done,
     /*  872951 */   // Label 13354: @872951
     /*  872951 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(873026), // Rule ID 24950 //
     /*  872956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  872959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  872964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  872967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  872970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  872973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873002 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  873005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873024 */     GIR_RootConstrainSelectedInstOperands,
     /*  873025 */     // GIR_Coverage, 24950,
     /*  873025 */     GIR_EraseRootFromParent_Done,
     /*  873026 */   // Label 13355: @873026
     /*  873026 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(873101), // Rule ID 24951 //
     /*  873031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  873051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873077 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  873080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873099 */     GIR_RootConstrainSelectedInstOperands,
     /*  873100 */     // GIR_Coverage, 24951,
     /*  873100 */     GIR_EraseRootFromParent_Done,
     /*  873101 */   // Label 13356: @873101
     /*  873101 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(873176), // Rule ID 24954 //
     /*  873106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873152 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  873155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873174 */     GIR_RootConstrainSelectedInstOperands,
     /*  873175 */     // GIR_Coverage, 24954,
     /*  873175 */     GIR_EraseRootFromParent_Done,
     /*  873176 */   // Label 13357: @873176
     /*  873176 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(873251), // Rule ID 24955 //
     /*  873181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  873201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873227 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  873230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873249 */     GIR_RootConstrainSelectedInstOperands,
     /*  873250 */     // GIR_Coverage, 24955,
     /*  873250 */     GIR_EraseRootFromParent_Done,
     /*  873251 */   // Label 13358: @873251
     /*  873251 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(873326), // Rule ID 24958 //
     /*  873256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  873267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  873270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  873273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  873305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873324 */     GIR_RootConstrainSelectedInstOperands,
     /*  873325 */     // GIR_Coverage, 24958,
     /*  873325 */     GIR_EraseRootFromParent_Done,
     /*  873326 */   // Label 13359: @873326
     /*  873326 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(873401), // Rule ID 24959 //
     /*  873331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  873342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  873345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  873348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  873351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  873380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873399 */     GIR_RootConstrainSelectedInstOperands,
     /*  873400 */     // GIR_Coverage, 24959,
     /*  873400 */     GIR_EraseRootFromParent_Done,
     /*  873401 */   // Label 13360: @873401
     /*  873401 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(873476), // Rule ID 24962 //
     /*  873406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  873417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  873420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  873423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  873426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873452 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  873455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873474 */     GIR_RootConstrainSelectedInstOperands,
     /*  873475 */     // GIR_Coverage, 24962,
     /*  873475 */     GIR_EraseRootFromParent_Done,
     /*  873476 */   // Label 13361: @873476
     /*  873476 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(873551), // Rule ID 24963 //
     /*  873481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  873492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  873495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  873498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  873501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873527 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  873530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873549 */     GIR_RootConstrainSelectedInstOperands,
     /*  873550 */     // GIR_Coverage, 24963,
     /*  873550 */     GIR_EraseRootFromParent_Done,
     /*  873551 */   // Label 13362: @873551
     /*  873551 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(873626), // Rule ID 24966 //
     /*  873556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  873567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  873570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  873573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  873576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  873605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873624 */     GIR_RootConstrainSelectedInstOperands,
     /*  873625 */     // GIR_Coverage, 24966,
     /*  873625 */     GIR_EraseRootFromParent_Done,
     /*  873626 */   // Label 13363: @873626
     /*  873626 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(873701), // Rule ID 24967 //
     /*  873631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  873639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  873642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  873645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  873648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  873651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  873670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873677 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  873680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873699 */     GIR_RootConstrainSelectedInstOperands,
     /*  873700 */     // GIR_Coverage, 24967,
     /*  873700 */     GIR_EraseRootFromParent_Done,
     /*  873701 */   // Label 13364: @873701
     /*  873701 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(873776), // Rule ID 24970 //
     /*  873706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873752 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  873755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873774 */     GIR_RootConstrainSelectedInstOperands,
     /*  873775 */     // GIR_Coverage, 24970,
     /*  873775 */     GIR_EraseRootFromParent_Done,
     /*  873776 */   // Label 13365: @873776
     /*  873776 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(873851), // Rule ID 24971 //
     /*  873781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873827 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  873830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873849 */     GIR_RootConstrainSelectedInstOperands,
     /*  873850 */     // GIR_Coverage, 24971,
     /*  873850 */     GIR_EraseRootFromParent_Done,
     /*  873851 */   // Label 13366: @873851
     /*  873851 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(873926), // Rule ID 24974 //
     /*  873856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  873859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  873876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873902 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  873902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  873905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873924 */     GIR_RootConstrainSelectedInstOperands,
     /*  873925 */     // GIR_Coverage, 24974,
     /*  873925 */     GIR_EraseRootFromParent_Done,
     /*  873926 */   // Label 13367: @873926
     /*  873926 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(874001), // Rule ID 24975 //
     /*  873931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  873934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  873939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  873951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  873970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873977 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  873977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  873980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873999 */     GIR_RootConstrainSelectedInstOperands,
     /*  874000 */     // GIR_Coverage, 24975,
     /*  874000 */     GIR_EraseRootFromParent_Done,
     /*  874001 */   // Label 13368: @874001
     /*  874001 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(874076), // Rule ID 24978 //
     /*  874006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  874055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874074 */     GIR_RootConstrainSelectedInstOperands,
     /*  874075 */     // GIR_Coverage, 24978,
     /*  874075 */     GIR_EraseRootFromParent_Done,
     /*  874076 */   // Label 13369: @874076
     /*  874076 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(874151), // Rule ID 24979 //
     /*  874081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  874092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  874095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  874098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  874130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874149 */     GIR_RootConstrainSelectedInstOperands,
     /*  874150 */     // GIR_Coverage, 24979,
     /*  874150 */     GIR_EraseRootFromParent_Done,
     /*  874151 */   // Label 13370: @874151
     /*  874151 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(874226), // Rule ID 24982 //
     /*  874156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874202 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  874205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874224 */     GIR_RootConstrainSelectedInstOperands,
     /*  874225 */     // GIR_Coverage, 24982,
     /*  874225 */     GIR_EraseRootFromParent_Done,
     /*  874226 */   // Label 13371: @874226
     /*  874226 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(874301), // Rule ID 24983 //
     /*  874231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874277 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  874280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874299 */     GIR_RootConstrainSelectedInstOperands,
     /*  874300 */     // GIR_Coverage, 24983,
     /*  874300 */     GIR_EraseRootFromParent_Done,
     /*  874301 */   // Label 13372: @874301
     /*  874301 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(874376), // Rule ID 24986 //
     /*  874306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874352 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  874355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874374 */     GIR_RootConstrainSelectedInstOperands,
     /*  874375 */     // GIR_Coverage, 24986,
     /*  874375 */     GIR_EraseRootFromParent_Done,
     /*  874376 */   // Label 13373: @874376
     /*  874376 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(874451), // Rule ID 24987 //
     /*  874381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874427 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  874430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874449 */     GIR_RootConstrainSelectedInstOperands,
     /*  874450 */     // GIR_Coverage, 24987,
     /*  874450 */     GIR_EraseRootFromParent_Done,
     /*  874451 */   // Label 13374: @874451
     /*  874451 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(874526), // Rule ID 24990 //
     /*  874456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  874459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  874476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874502 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  874505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874524 */     GIR_RootConstrainSelectedInstOperands,
     /*  874525 */     // GIR_Coverage, 24990,
     /*  874525 */     GIR_EraseRootFromParent_Done,
     /*  874526 */   // Label 13375: @874526
     /*  874526 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(874601), // Rule ID 24991 //
     /*  874531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  874534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  874539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  874551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  874570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874577 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  874580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874599 */     GIR_RootConstrainSelectedInstOperands,
     /*  874600 */     // GIR_Coverage, 24991,
     /*  874600 */     GIR_EraseRootFromParent_Done,
     /*  874601 */   // Label 13376: @874601
     /*  874601 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(874676), // Rule ID 25018 //
     /*  874606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  874609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  874617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  874620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874652 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  874655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874674 */     GIR_RootConstrainSelectedInstOperands,
     /*  874675 */     // GIR_Coverage, 25018,
     /*  874675 */     GIR_EraseRootFromParent_Done,
     /*  874676 */   // Label 13377: @874676
     /*  874676 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(874751), // Rule ID 25019 //
     /*  874681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  874684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  874692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  874695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  874698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874727 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  874730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874749 */     GIR_RootConstrainSelectedInstOperands,
     /*  874750 */     // GIR_Coverage, 25019,
     /*  874750 */     GIR_EraseRootFromParent_Done,
     /*  874751 */   // Label 13378: @874751
     /*  874751 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(874826), // Rule ID 25022 //
     /*  874756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  874759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  874767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  874770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  874776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  874802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  874805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874824 */     GIR_RootConstrainSelectedInstOperands,
     /*  874825 */     // GIR_Coverage, 25022,
     /*  874825 */     GIR_EraseRootFromParent_Done,
     /*  874826 */   // Label 13379: @874826
     /*  874826 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(874901), // Rule ID 25023 //
     /*  874831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  874834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  874842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  874845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  874848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  874851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874877 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  874877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  874880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874899 */     GIR_RootConstrainSelectedInstOperands,
     /*  874900 */     // GIR_Coverage, 25023,
     /*  874900 */     GIR_EraseRootFromParent_Done,
     /*  874901 */   // Label 13380: @874901
     /*  874901 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(874976), // Rule ID 25026 //
     /*  874906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  874909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  874926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  874952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  874955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  874974 */     GIR_RootConstrainSelectedInstOperands,
     /*  874975 */     // GIR_Coverage, 25026,
     /*  874975 */     GIR_EraseRootFromParent_Done,
     /*  874976 */   // Label 13381: @874976
     /*  874976 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(875051), // Rule ID 25027 //
     /*  874981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  874984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  874989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  874992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  874995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  874998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875027 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  875027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  875030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875049 */     GIR_RootConstrainSelectedInstOperands,
     /*  875050 */     // GIR_Coverage, 25027,
     /*  875050 */     GIR_EraseRootFromParent_Done,
     /*  875051 */   // Label 13382: @875051
     /*  875051 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(875126), // Rule ID 25030 //
     /*  875056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  875067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  875070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  875073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  875105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875124 */     GIR_RootConstrainSelectedInstOperands,
     /*  875125 */     // GIR_Coverage, 25030,
     /*  875125 */     GIR_EraseRootFromParent_Done,
     /*  875126 */   // Label 13383: @875126
     /*  875126 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(875201), // Rule ID 25031 //
     /*  875131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  875142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  875145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  875148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875177 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  875180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875199 */     GIR_RootConstrainSelectedInstOperands,
     /*  875200 */     // GIR_Coverage, 25031,
     /*  875200 */     GIR_EraseRootFromParent_Done,
     /*  875201 */   // Label 13384: @875201
     /*  875201 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(875276), // Rule ID 25034 //
     /*  875206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  875209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  875226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  875252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  875255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875274 */     GIR_RootConstrainSelectedInstOperands,
     /*  875275 */     // GIR_Coverage, 25034,
     /*  875275 */     GIR_EraseRootFromParent_Done,
     /*  875276 */   // Label 13385: @875276
     /*  875276 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(875351), // Rule ID 25035 //
     /*  875281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  875284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  875301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875327 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  875327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  875330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875349 */     GIR_RootConstrainSelectedInstOperands,
     /*  875350 */     // GIR_Coverage, 25035,
     /*  875350 */     GIR_EraseRootFromParent_Done,
     /*  875351 */   // Label 13386: @875351
     /*  875351 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(875426), // Rule ID 25038 //
     /*  875356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  875359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  875402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  875405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875424 */     GIR_RootConstrainSelectedInstOperands,
     /*  875425 */     // GIR_Coverage, 25038,
     /*  875425 */     GIR_EraseRootFromParent_Done,
     /*  875426 */   // Label 13387: @875426
     /*  875426 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(875501), // Rule ID 25039 //
     /*  875431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  875434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  875451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  875477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  875480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875499 */     GIR_RootConstrainSelectedInstOperands,
     /*  875500 */     // GIR_Coverage, 25039,
     /*  875500 */     GIR_EraseRootFromParent_Done,
     /*  875501 */   // Label 13388: @875501
     /*  875501 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(875576), // Rule ID 25042 //
     /*  875506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  875526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  875555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875574 */     GIR_RootConstrainSelectedInstOperands,
     /*  875575 */     // GIR_Coverage, 25042,
     /*  875575 */     GIR_EraseRootFromParent_Done,
     /*  875576 */   // Label 13389: @875576
     /*  875576 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(875651), // Rule ID 25043 //
     /*  875581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  875592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  875595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  875598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  875601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  875630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875649 */     GIR_RootConstrainSelectedInstOperands,
     /*  875650 */     // GIR_Coverage, 25043,
     /*  875650 */     GIR_EraseRootFromParent_Done,
     /*  875651 */   // Label 13390: @875651
     /*  875651 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(875726), // Rule ID 25046 //
     /*  875656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  875676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875702 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  875705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875724 */     GIR_RootConstrainSelectedInstOperands,
     /*  875725 */     // GIR_Coverage, 25046,
     /*  875725 */     GIR_EraseRootFromParent_Done,
     /*  875726 */   // Label 13391: @875726
     /*  875726 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(875801), // Rule ID 25047 //
     /*  875731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  875742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  875745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  875748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  875751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875777 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  875780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875799 */     GIR_RootConstrainSelectedInstOperands,
     /*  875800 */     // GIR_Coverage, 25047,
     /*  875800 */     GIR_EraseRootFromParent_Done,
     /*  875801 */   // Label 13392: @875801
     /*  875801 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(875876), // Rule ID 25050 //
     /*  875806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  875809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  875826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875852 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  875852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  875855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875874 */     GIR_RootConstrainSelectedInstOperands,
     /*  875875 */     // GIR_Coverage, 25050,
     /*  875875 */     GIR_EraseRootFromParent_Done,
     /*  875876 */   // Label 13393: @875876
     /*  875876 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(875951), // Rule ID 25051 //
     /*  875881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  875884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  875901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875927 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  875927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  875930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  875949 */     GIR_RootConstrainSelectedInstOperands,
     /*  875950 */     // GIR_Coverage, 25051,
     /*  875950 */     GIR_EraseRootFromParent_Done,
     /*  875951 */   // Label 13394: @875951
     /*  875951 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(876026), // Rule ID 25054 //
     /*  875956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  875959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  875964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  875976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876002 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  876005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876024 */     GIR_RootConstrainSelectedInstOperands,
     /*  876025 */     // GIR_Coverage, 25054,
     /*  876025 */     GIR_EraseRootFromParent_Done,
     /*  876026 */   // Label 13395: @876026
     /*  876026 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(876101), // Rule ID 25055 //
     /*  876031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  876042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  876045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  876048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876077 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  876080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876099 */     GIR_RootConstrainSelectedInstOperands,
     /*  876100 */     // GIR_Coverage, 25055,
     /*  876100 */     GIR_EraseRootFromParent_Done,
     /*  876101 */   // Label 13396: @876101
     /*  876101 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(876176), // Rule ID 25058 //
     /*  876106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  876109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876152 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  876155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876174 */     GIR_RootConstrainSelectedInstOperands,
     /*  876175 */     // GIR_Coverage, 25058,
     /*  876175 */     GIR_EraseRootFromParent_Done,
     /*  876176 */   // Label 13397: @876176
     /*  876176 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(876251), // Rule ID 25059 //
     /*  876181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876227 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  876230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876249 */     GIR_RootConstrainSelectedInstOperands,
     /*  876250 */     // GIR_Coverage, 25059,
     /*  876250 */     GIR_EraseRootFromParent_Done,
     /*  876251 */   // Label 13398: @876251
     /*  876251 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(876326), // Rule ID 25062 //
     /*  876256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  876259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  876276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876302 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  876302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  876305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876324 */     GIR_RootConstrainSelectedInstOperands,
     /*  876325 */     // GIR_Coverage, 25062,
     /*  876325 */     GIR_EraseRootFromParent_Done,
     /*  876326 */   // Label 13399: @876326
     /*  876326 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(876401), // Rule ID 25063 //
     /*  876331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  876334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  876351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876377 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  876377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  876380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876399 */     GIR_RootConstrainSelectedInstOperands,
     /*  876400 */     // GIR_Coverage, 25063,
     /*  876400 */     GIR_EraseRootFromParent_Done,
     /*  876401 */   // Label 13400: @876401
     /*  876401 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(876476), // Rule ID 25066 //
     /*  876406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  876426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  876455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876474 */     GIR_RootConstrainSelectedInstOperands,
     /*  876475 */     // GIR_Coverage, 25066,
     /*  876475 */     GIR_EraseRootFromParent_Done,
     /*  876476 */   // Label 13401: @876476
     /*  876476 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(876551), // Rule ID 25067 //
     /*  876481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  876501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  876530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876549 */     GIR_RootConstrainSelectedInstOperands,
     /*  876550 */     // GIR_Coverage, 25067,
     /*  876550 */     GIR_EraseRootFromParent_Done,
     /*  876551 */   // Label 13402: @876551
     /*  876551 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(876626), // Rule ID 25070 //
     /*  876556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876602 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  876605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876624 */     GIR_RootConstrainSelectedInstOperands,
     /*  876625 */     // GIR_Coverage, 25070,
     /*  876625 */     GIR_EraseRootFromParent_Done,
     /*  876626 */   // Label 13403: @876626
     /*  876626 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(876701), // Rule ID 25071 //
     /*  876631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  876651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876677 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  876680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876699 */     GIR_RootConstrainSelectedInstOperands,
     /*  876700 */     // GIR_Coverage, 25071,
     /*  876700 */     GIR_EraseRootFromParent_Done,
     /*  876701 */   // Label 13404: @876701
     /*  876701 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(876776), // Rule ID 25074 //
     /*  876706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  876709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  876752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  876755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876774 */     GIR_RootConstrainSelectedInstOperands,
     /*  876775 */     // GIR_Coverage, 25074,
     /*  876775 */     GIR_EraseRootFromParent_Done,
     /*  876776 */   // Label 13405: @876776
     /*  876776 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(876851), // Rule ID 25075 //
     /*  876781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  876784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  876789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  876801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876827 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  876827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  876830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  876849 */     GIR_RootConstrainSelectedInstOperands,
     /*  876850 */     // GIR_Coverage, 25075,
     /*  876850 */     GIR_EraseRootFromParent_Done,
     /*  876851 */   // Label 13406: @876851
     /*  876851 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(876923), // Rule ID 25078 //
     /*  876856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  876859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  876867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  876870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  876873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  876902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  876905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  876921 */     GIR_RootConstrainSelectedInstOperands,
     /*  876922 */     // GIR_Coverage, 25078,
     /*  876922 */     GIR_EraseRootFromParent_Done,
     /*  876923 */   // Label 13407: @876923
     /*  876923 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(876995), // Rule ID 25079 //
     /*  876928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  876931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  876939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  876942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  876945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876974 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  876974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  876977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  876993 */     GIR_RootConstrainSelectedInstOperands,
     /*  876994 */     // GIR_Coverage, 25079,
     /*  876994 */     GIR_EraseRootFromParent_Done,
     /*  876995 */   // Label 13408: @876995
     /*  876995 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(877067), // Rule ID 25080 //
     /*  877000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  877011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  877014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  877017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  877046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  877049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877065 */     GIR_RootConstrainSelectedInstOperands,
     /*  877066 */     // GIR_Coverage, 25080,
     /*  877066 */     GIR_EraseRootFromParent_Done,
     /*  877067 */   // Label 13409: @877067
     /*  877067 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(877139), // Rule ID 25081 //
     /*  877072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  877083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  877086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  877089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  877118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  877121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877137 */     GIR_RootConstrainSelectedInstOperands,
     /*  877138 */     // GIR_Coverage, 25081,
     /*  877138 */     GIR_EraseRootFromParent_Done,
     /*  877139 */   // Label 13410: @877139
     /*  877139 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(877211), // Rule ID 25082 //
     /*  877144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  877161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  877193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877209 */     GIR_RootConstrainSelectedInstOperands,
     /*  877210 */     // GIR_Coverage, 25082,
     /*  877210 */     GIR_EraseRootFromParent_Done,
     /*  877211 */   // Label 13411: @877211
     /*  877211 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(877283), // Rule ID 25083 //
     /*  877216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  877233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  877265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877281 */     GIR_RootConstrainSelectedInstOperands,
     /*  877282 */     // GIR_Coverage, 25083,
     /*  877282 */     GIR_EraseRootFromParent_Done,
     /*  877283 */   // Label 13412: @877283
     /*  877283 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(877355), // Rule ID 25084 //
     /*  877288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  877302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  877305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877334 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877353 */     GIR_RootConstrainSelectedInstOperands,
     /*  877354 */     // GIR_Coverage, 25084,
     /*  877354 */     GIR_EraseRootFromParent_Done,
     /*  877355 */   // Label 13413: @877355
     /*  877355 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(877427), // Rule ID 25085 //
     /*  877360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  877374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  877377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877425 */     GIR_RootConstrainSelectedInstOperands,
     /*  877426 */     // GIR_Coverage, 25085,
     /*  877426 */     GIR_EraseRootFromParent_Done,
     /*  877427 */   // Label 13414: @877427
     /*  877427 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(877499), // Rule ID 25086 //
     /*  877432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  877481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877497 */     GIR_RootConstrainSelectedInstOperands,
     /*  877498 */     // GIR_Coverage, 25086,
     /*  877498 */     GIR_EraseRootFromParent_Done,
     /*  877499 */   // Label 13415: @877499
     /*  877499 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(877571), // Rule ID 25087 //
     /*  877504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  877524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  877553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877569 */     GIR_RootConstrainSelectedInstOperands,
     /*  877570 */     // GIR_Coverage, 25087,
     /*  877570 */     GIR_EraseRootFromParent_Done,
     /*  877571 */   // Label 13416: @877571
     /*  877571 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(877643), // Rule ID 25088 //
     /*  877576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  877587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  877590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  877593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  877622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  877625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877641 */     GIR_RootConstrainSelectedInstOperands,
     /*  877642 */     // GIR_Coverage, 25088,
     /*  877642 */     GIR_EraseRootFromParent_Done,
     /*  877643 */   // Label 13417: @877643
     /*  877643 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(877715), // Rule ID 25089 //
     /*  877648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  877659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  877662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  877665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  877694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  877697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877713 */     GIR_RootConstrainSelectedInstOperands,
     /*  877714 */     // GIR_Coverage, 25089,
     /*  877714 */     GIR_EraseRootFromParent_Done,
     /*  877715 */   // Label 13418: @877715
     /*  877715 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(877787), // Rule ID 25090 //
     /*  877720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877785 */     GIR_RootConstrainSelectedInstOperands,
     /*  877786 */     // GIR_Coverage, 25090,
     /*  877786 */     GIR_EraseRootFromParent_Done,
     /*  877787 */   // Label 13419: @877787
     /*  877787 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(877859), // Rule ID 25091 //
     /*  877792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877857 */     GIR_RootConstrainSelectedInstOperands,
     /*  877858 */     // GIR_Coverage, 25091,
     /*  877858 */     GIR_EraseRootFromParent_Done,
     /*  877859 */   // Label 13420: @877859
     /*  877859 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(877931), // Rule ID 25092 //
     /*  877864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  877867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877929 */     GIR_RootConstrainSelectedInstOperands,
     /*  877930 */     // GIR_Coverage, 25092,
     /*  877930 */     GIR_EraseRootFromParent_Done,
     /*  877931 */   // Label 13421: @877931
     /*  877931 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(878003), // Rule ID 25093 //
     /*  877936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  877939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  877947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  877950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  877953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  877985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878001 */     GIR_RootConstrainSelectedInstOperands,
     /*  878002 */     // GIR_Coverage, 25093,
     /*  878002 */     GIR_EraseRootFromParent_Done,
     /*  878003 */   // Label 13422: @878003
     /*  878003 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(878075), // Rule ID 25094 //
     /*  878008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  878011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  878019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  878022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  878025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  878028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  878057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878073 */     GIR_RootConstrainSelectedInstOperands,
     /*  878074 */     // GIR_Coverage, 25094,
     /*  878074 */     GIR_EraseRootFromParent_Done,
     /*  878075 */   // Label 13423: @878075
     /*  878075 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(878147), // Rule ID 25095 //
     /*  878080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  878083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  878091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  878094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  878097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  878100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  878129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878145 */     GIR_RootConstrainSelectedInstOperands,
     /*  878146 */     // GIR_Coverage, 25095,
     /*  878146 */     GIR_EraseRootFromParent_Done,
     /*  878147 */   // Label 13424: @878147
     /*  878147 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(878219), // Rule ID 25096 //
     /*  878152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  878163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  878166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  878201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878217 */     GIR_RootConstrainSelectedInstOperands,
     /*  878218 */     // GIR_Coverage, 25096,
     /*  878218 */     GIR_EraseRootFromParent_Done,
     /*  878219 */   // Label 13425: @878219
     /*  878219 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(878291), // Rule ID 25097 //
     /*  878224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  878235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  878238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878270 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  878273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878289 */     GIR_RootConstrainSelectedInstOperands,
     /*  878290 */     // GIR_Coverage, 25097,
     /*  878290 */     GIR_EraseRootFromParent_Done,
     /*  878291 */   // Label 13426: @878291
     /*  878291 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(878363), // Rule ID 25098 //
     /*  878296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  878307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  878310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  878345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878361 */     GIR_RootConstrainSelectedInstOperands,
     /*  878362 */     // GIR_Coverage, 25098,
     /*  878362 */     GIR_EraseRootFromParent_Done,
     /*  878363 */   // Label 13427: @878363
     /*  878363 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(878435), // Rule ID 25099 //
     /*  878368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  878379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  878382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  878417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878433 */     GIR_RootConstrainSelectedInstOperands,
     /*  878434 */     // GIR_Coverage, 25099,
     /*  878434 */     GIR_EraseRootFromParent_Done,
     /*  878435 */   // Label 13428: @878435
     /*  878435 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(878507), // Rule ID 25100 //
     /*  878440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  878451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  878454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  878457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  878460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  878486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  878489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878505 */     GIR_RootConstrainSelectedInstOperands,
     /*  878506 */     // GIR_Coverage, 25100,
     /*  878506 */     GIR_EraseRootFromParent_Done,
     /*  878507 */   // Label 13429: @878507
     /*  878507 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(878579), // Rule ID 25101 //
     /*  878512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  878523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  878526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  878529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  878532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  878558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  878561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878577 */     GIR_RootConstrainSelectedInstOperands,
     /*  878578 */     // GIR_Coverage, 25101,
     /*  878578 */     GIR_EraseRootFromParent_Done,
     /*  878579 */   // Label 13430: @878579
     /*  878579 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(878651), // Rule ID 25102 //
     /*  878584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  878601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  878633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878649 */     GIR_RootConstrainSelectedInstOperands,
     /*  878650 */     // GIR_Coverage, 25102,
     /*  878650 */     GIR_EraseRootFromParent_Done,
     /*  878651 */   // Label 13431: @878651
     /*  878651 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(878723), // Rule ID 25103 //
     /*  878656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  878673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  878705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878721 */     GIR_RootConstrainSelectedInstOperands,
     /*  878722 */     // GIR_Coverage, 25103,
     /*  878722 */     GIR_EraseRootFromParent_Done,
     /*  878723 */   // Label 13432: @878723
     /*  878723 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(878795), // Rule ID 25104 //
     /*  878728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  878745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  878777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878793 */     GIR_RootConstrainSelectedInstOperands,
     /*  878794 */     // GIR_Coverage, 25104,
     /*  878794 */     GIR_EraseRootFromParent_Done,
     /*  878795 */   // Label 13433: @878795
     /*  878795 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(878867), // Rule ID 25105 //
     /*  878800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  878817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  878820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  878849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878865 */     GIR_RootConstrainSelectedInstOperands,
     /*  878866 */     // GIR_Coverage, 25105,
     /*  878866 */     GIR_EraseRootFromParent_Done,
     /*  878867 */   // Label 13434: @878867
     /*  878867 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(878939), // Rule ID 25106 //
     /*  878872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  878875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  878889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  878918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  878921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878937 */     GIR_RootConstrainSelectedInstOperands,
     /*  878938 */     // GIR_Coverage, 25106,
     /*  878938 */     GIR_EraseRootFromParent_Done,
     /*  878939 */   // Label 13435: @878939
     /*  878939 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(879011), // Rule ID 25107 //
     /*  878944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  878947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  878961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  878964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  878990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  878993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879009 */     GIR_RootConstrainSelectedInstOperands,
     /*  879010 */     // GIR_Coverage, 25107,
     /*  879010 */     GIR_EraseRootFromParent_Done,
     /*  879011 */   // Label 13436: @879011
     /*  879011 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(879083), // Rule ID 25108 //
     /*  879016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  879065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879081 */     GIR_RootConstrainSelectedInstOperands,
     /*  879082 */     // GIR_Coverage, 25108,
     /*  879082 */     GIR_EraseRootFromParent_Done,
     /*  879083 */   // Label 13437: @879083
     /*  879083 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(879155), // Rule ID 25109 //
     /*  879088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  879137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879153 */     GIR_RootConstrainSelectedInstOperands,
     /*  879154 */     // GIR_Coverage, 25109,
     /*  879154 */     GIR_EraseRootFromParent_Done,
     /*  879155 */   // Label 13438: @879155
     /*  879155 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(879227), // Rule ID 25110 //
     /*  879160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  879177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  879209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879225 */     GIR_RootConstrainSelectedInstOperands,
     /*  879226 */     // GIR_Coverage, 25110,
     /*  879226 */     GIR_EraseRootFromParent_Done,
     /*  879227 */   // Label 13439: @879227
     /*  879227 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(879299), // Rule ID 25111 //
     /*  879232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  879249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  879281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879297 */     GIR_RootConstrainSelectedInstOperands,
     /*  879298 */     // GIR_Coverage, 25111,
     /*  879298 */     GIR_EraseRootFromParent_Done,
     /*  879299 */   // Label 13440: @879299
     /*  879299 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(879371), // Rule ID 25112 //
     /*  879304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  879307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  879321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  879324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  879353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879369 */     GIR_RootConstrainSelectedInstOperands,
     /*  879370 */     // GIR_Coverage, 25112,
     /*  879370 */     GIR_EraseRootFromParent_Done,
     /*  879371 */   // Label 13441: @879371
     /*  879371 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(879443), // Rule ID 25113 //
     /*  879376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  879379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  879393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  879396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  879425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879441 */     GIR_RootConstrainSelectedInstOperands,
     /*  879442 */     // GIR_Coverage, 25113,
     /*  879442 */     GIR_EraseRootFromParent_Done,
     /*  879443 */   // Label 13442: @879443
     /*  879443 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(879515), // Rule ID 25114 //
     /*  879448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  879465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  879468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  879497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879513 */     GIR_RootConstrainSelectedInstOperands,
     /*  879514 */     // GIR_Coverage, 25114,
     /*  879514 */     GIR_EraseRootFromParent_Done,
     /*  879515 */   // Label 13443: @879515
     /*  879515 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(879587), // Rule ID 25115 //
     /*  879520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  879537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  879540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  879569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879585 */     GIR_RootConstrainSelectedInstOperands,
     /*  879586 */     // GIR_Coverage, 25115,
     /*  879586 */     GIR_EraseRootFromParent_Done,
     /*  879587 */   // Label 13444: @879587
     /*  879587 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(879659), // Rule ID 25116 //
     /*  879592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  879609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  879641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879657 */     GIR_RootConstrainSelectedInstOperands,
     /*  879658 */     // GIR_Coverage, 25116,
     /*  879658 */     GIR_EraseRootFromParent_Done,
     /*  879659 */   // Label 13445: @879659
     /*  879659 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(879731), // Rule ID 25117 //
     /*  879664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  879681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  879684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  879713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879729 */     GIR_RootConstrainSelectedInstOperands,
     /*  879730 */     // GIR_Coverage, 25117,
     /*  879730 */     GIR_EraseRootFromParent_Done,
     /*  879731 */   // Label 13446: @879731
     /*  879731 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(879803), // Rule ID 25118 //
     /*  879736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  879739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  879747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  879750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  879753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  879782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  879785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879801 */     GIR_RootConstrainSelectedInstOperands,
     /*  879802 */     // GIR_Coverage, 25118,
     /*  879802 */     GIR_EraseRootFromParent_Done,
     /*  879803 */   // Label 13447: @879803
     /*  879803 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(879875), // Rule ID 25119 //
     /*  879808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  879811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  879819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  879822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  879825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  879828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  879854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  879857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  879873 */     GIR_RootConstrainSelectedInstOperands,
     /*  879874 */     // GIR_Coverage, 25119,
     /*  879874 */     GIR_EraseRootFromParent_Done,
     /*  879875 */   // Label 13448: @879875
     /*  879875 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(879947), // Rule ID 25120 //
     /*  879880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  879883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  879900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879926 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  879926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  879929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879945 */     GIR_RootConstrainSelectedInstOperands,
     /*  879946 */     // GIR_Coverage, 25120,
     /*  879946 */     GIR_EraseRootFromParent_Done,
     /*  879947 */   // Label 13449: @879947
     /*  879947 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(880019), // Rule ID 25121 //
     /*  879952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  879955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  879960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  879972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  879998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  880001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880017 */     GIR_RootConstrainSelectedInstOperands,
     /*  880018 */     // GIR_Coverage, 25121,
     /*  880018 */     GIR_EraseRootFromParent_Done,
     /*  880019 */   // Label 13450: @880019
     /*  880019 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(880091), // Rule ID 25122 //
     /*  880024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  880035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  880038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  880073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880089 */     GIR_RootConstrainSelectedInstOperands,
     /*  880090 */     // GIR_Coverage, 25122,
     /*  880090 */     GIR_EraseRootFromParent_Done,
     /*  880091 */   // Label 13451: @880091
     /*  880091 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(880163), // Rule ID 25123 //
     /*  880096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  880107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  880110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  880145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880161 */     GIR_RootConstrainSelectedInstOperands,
     /*  880162 */     // GIR_Coverage, 25123,
     /*  880162 */     GIR_EraseRootFromParent_Done,
     /*  880163 */   // Label 13452: @880163
     /*  880163 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(880235), // Rule ID 25124 //
     /*  880168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  880185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  880188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  880217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880233 */     GIR_RootConstrainSelectedInstOperands,
     /*  880234 */     // GIR_Coverage, 25124,
     /*  880234 */     GIR_EraseRootFromParent_Done,
     /*  880235 */   // Label 13453: @880235
     /*  880235 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(880307), // Rule ID 25125 //
     /*  880240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  880257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  880260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880286 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  880286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  880289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880305 */     GIR_RootConstrainSelectedInstOperands,
     /*  880306 */     // GIR_Coverage, 25125,
     /*  880306 */     GIR_EraseRootFromParent_Done,
     /*  880307 */   // Label 13454: @880307
     /*  880307 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(880379), // Rule ID 25126 //
     /*  880312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  880361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880377 */     GIR_RootConstrainSelectedInstOperands,
     /*  880378 */     // GIR_Coverage, 25126,
     /*  880378 */     GIR_EraseRootFromParent_Done,
     /*  880379 */   // Label 13455: @880379
     /*  880379 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(880451), // Rule ID 25127 //
     /*  880384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  880395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  880398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880430 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  880433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880449 */     GIR_RootConstrainSelectedInstOperands,
     /*  880450 */     // GIR_Coverage, 25127,
     /*  880450 */     GIR_EraseRootFromParent_Done,
     /*  880451 */   // Label 13456: @880451
     /*  880451 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(880523), // Rule ID 25128 //
     /*  880456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  880476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880502 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  880505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880521 */     GIR_RootConstrainSelectedInstOperands,
     /*  880522 */     // GIR_Coverage, 25128,
     /*  880522 */     GIR_EraseRootFromParent_Done,
     /*  880523 */   // Label 13457: @880523
     /*  880523 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(880595), // Rule ID 25129 //
     /*  880528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  880539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  880542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  880548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  880577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880593 */     GIR_RootConstrainSelectedInstOperands,
     /*  880594 */     // GIR_Coverage, 25129,
     /*  880594 */     GIR_EraseRootFromParent_Done,
     /*  880595 */   // Label 13458: @880595
     /*  880595 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(880667), // Rule ID 25130 //
     /*  880600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  880603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  880617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  880620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880646 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  880646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  880649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880665 */     GIR_RootConstrainSelectedInstOperands,
     /*  880666 */     // GIR_Coverage, 25130,
     /*  880666 */     GIR_EraseRootFromParent_Done,
     /*  880667 */   // Label 13459: @880667
     /*  880667 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(880739), // Rule ID 25131 //
     /*  880672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  880675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  880683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  880686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  880689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  880692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880718 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  880718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  880721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880737 */     GIR_RootConstrainSelectedInstOperands,
     /*  880738 */     // GIR_Coverage, 25131,
     /*  880738 */     GIR_EraseRootFromParent_Done,
     /*  880739 */   // Label 13460: @880739
     /*  880739 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(880811), // Rule ID 25132 //
     /*  880744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  880761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  880793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880809 */     GIR_RootConstrainSelectedInstOperands,
     /*  880810 */     // GIR_Coverage, 25132,
     /*  880810 */     GIR_EraseRootFromParent_Done,
     /*  880811 */   // Label 13461: @880811
     /*  880811 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(880883), // Rule ID 25133 //
     /*  880816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  880833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  880836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  880862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  880865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880881 */     GIR_RootConstrainSelectedInstOperands,
     /*  880882 */     // GIR_Coverage, 25133,
     /*  880882 */     GIR_EraseRootFromParent_Done,
     /*  880883 */   // Label 13462: @880883
     /*  880883 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(880955), // Rule ID 25134 //
     /*  880888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  880891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  880905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880934 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  880934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  880937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  880953 */     GIR_RootConstrainSelectedInstOperands,
     /*  880954 */     // GIR_Coverage, 25134,
     /*  880954 */     GIR_EraseRootFromParent_Done,
     /*  880955 */   // Label 13463: @880955
     /*  880955 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(881027), // Rule ID 25135 //
     /*  880960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  880963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  880968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  880977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  880980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881006 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  881006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  881009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881025 */     GIR_RootConstrainSelectedInstOperands,
     /*  881026 */     // GIR_Coverage, 25135,
     /*  881026 */     GIR_EraseRootFromParent_Done,
     /*  881027 */   // Label 13464: @881027
     /*  881027 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(881099), // Rule ID 25136 //
     /*  881032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  881035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  881043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881078 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  881078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  881081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881097 */     GIR_RootConstrainSelectedInstOperands,
     /*  881098 */     // GIR_Coverage, 25136,
     /*  881098 */     GIR_EraseRootFromParent_Done,
     /*  881099 */   // Label 13465: @881099
     /*  881099 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(881171), // Rule ID 25137 //
     /*  881104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  881107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  881115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  881118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  881121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  881150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  881153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  881169 */     GIR_RootConstrainSelectedInstOperands,
     /*  881170 */     // GIR_Coverage, 25137,
     /*  881170 */     GIR_EraseRootFromParent_Done,
     /*  881171 */   // Label 13466: @881171
     /*  881171 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(881243), // Rule ID 25138 //
     /*  881176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  881196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  881225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881241 */     GIR_RootConstrainSelectedInstOperands,
     /*  881242 */     // GIR_Coverage, 25138,
     /*  881242 */     GIR_EraseRootFromParent_Done,
     /*  881243 */   // Label 13467: @881243
     /*  881243 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(881315), // Rule ID 25139 //
     /*  881248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  881259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  881262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  881268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881294 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  881297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881313 */     GIR_RootConstrainSelectedInstOperands,
     /*  881314 */     // GIR_Coverage, 25139,
     /*  881314 */     GIR_EraseRootFromParent_Done,
     /*  881315 */   // Label 13468: @881315
     /*  881315 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(881387), // Rule ID 25140 //
     /*  881320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  881340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881366 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  881369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881385 */     GIR_RootConstrainSelectedInstOperands,
     /*  881386 */     // GIR_Coverage, 25140,
     /*  881386 */     GIR_EraseRootFromParent_Done,
     /*  881387 */   // Label 13469: @881387
     /*  881387 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(881459), // Rule ID 25141 //
     /*  881392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  881403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  881406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  881412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881438 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  881441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881457 */     GIR_RootConstrainSelectedInstOperands,
     /*  881458 */     // GIR_Coverage, 25141,
     /*  881458 */     GIR_EraseRootFromParent_Done,
     /*  881459 */   // Label 13470: @881459
     /*  881459 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(881531), // Rule ID 25142 //
     /*  881464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  881484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881510 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  881513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881529 */     GIR_RootConstrainSelectedInstOperands,
     /*  881530 */     // GIR_Coverage, 25142,
     /*  881530 */     GIR_EraseRootFromParent_Done,
     /*  881531 */   // Label 13471: @881531
     /*  881531 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(881603), // Rule ID 25143 //
     /*  881536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  881547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  881550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  881556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  881585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881601 */     GIR_RootConstrainSelectedInstOperands,
     /*  881602 */     // GIR_Coverage, 25143,
     /*  881602 */     GIR_EraseRootFromParent_Done,
     /*  881603 */   // Label 13472: @881603
     /*  881603 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(881675), // Rule ID 25144 //
     /*  881608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  881657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881673 */     GIR_RootConstrainSelectedInstOperands,
     /*  881674 */     // GIR_Coverage, 25144,
     /*  881674 */     GIR_EraseRootFromParent_Done,
     /*  881675 */   // Label 13473: @881675
     /*  881675 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(881747), // Rule ID 25145 //
     /*  881680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  881700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  881729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881745 */     GIR_RootConstrainSelectedInstOperands,
     /*  881746 */     // GIR_Coverage, 25145,
     /*  881746 */     GIR_EraseRootFromParent_Done,
     /*  881747 */   // Label 13474: @881747
     /*  881747 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(881819), // Rule ID 25146 //
     /*  881752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  881772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881798 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  881801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881817 */     GIR_RootConstrainSelectedInstOperands,
     /*  881818 */     // GIR_Coverage, 25146,
     /*  881818 */     GIR_EraseRootFromParent_Done,
     /*  881819 */   // Label 13475: @881819
     /*  881819 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(881891), // Rule ID 25147 //
     /*  881824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  881844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881870 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  881870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  881873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881889 */     GIR_RootConstrainSelectedInstOperands,
     /*  881890 */     // GIR_Coverage, 25147,
     /*  881890 */     GIR_EraseRootFromParent_Done,
     /*  881891 */   // Label 13476: @881891
     /*  881891 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(881963), // Rule ID 25148 //
     /*  881896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  881899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  881913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  881916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  881942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  881945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881961 */     GIR_RootConstrainSelectedInstOperands,
     /*  881962 */     // GIR_Coverage, 25148,
     /*  881962 */     GIR_EraseRootFromParent_Done,
     /*  881963 */   // Label 13477: @881963
     /*  881963 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(882035), // Rule ID 25149 //
     /*  881968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  881971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  881976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  881985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  881988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882014 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  882014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  882017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882033 */     GIR_RootConstrainSelectedInstOperands,
     /*  882034 */     // GIR_Coverage, 25149,
     /*  882034 */     GIR_EraseRootFromParent_Done,
     /*  882035 */   // Label 13478: @882035
     /*  882035 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(882110), // Rule ID 60604 //
     /*  882040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  882043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  882048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  882060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  882089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882108 */     GIR_RootConstrainSelectedInstOperands,
     /*  882109 */     // GIR_Coverage, 60604,
     /*  882109 */     GIR_EraseRootFromParent_Done,
     /*  882110 */   // Label 13479: @882110
     /*  882110 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(882185), // Rule ID 60605 //
     /*  882115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  882118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  882123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  882126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  882129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  882135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  882164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882183 */     GIR_RootConstrainSelectedInstOperands,
     /*  882184 */     // GIR_Coverage, 60605,
     /*  882184 */     GIR_EraseRootFromParent_Done,
     /*  882185 */   // Label 13480: @882185
     /*  882185 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(882260), // Rule ID 60962 //
     /*  882190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  882201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  882204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  882207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  882210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  882239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882258 */     GIR_RootConstrainSelectedInstOperands,
     /*  882259 */     // GIR_Coverage, 60962,
     /*  882259 */     GIR_EraseRootFromParent_Done,
     /*  882260 */   // Label 13481: @882260
     /*  882260 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(882335), // Rule ID 60963 //
     /*  882265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  882276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  882279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  882282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  882285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  882314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882333 */     GIR_RootConstrainSelectedInstOperands,
     /*  882334 */     // GIR_Coverage, 60963,
     /*  882334 */     GIR_EraseRootFromParent_Done,
     /*  882335 */   // Label 13482: @882335
     /*  882335 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(882410), // Rule ID 60966 //
     /*  882340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  882351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  882354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  882360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  882389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882408 */     GIR_RootConstrainSelectedInstOperands,
     /*  882409 */     // GIR_Coverage, 60966,
     /*  882409 */     GIR_EraseRootFromParent_Done,
     /*  882410 */   // Label 13483: @882410
     /*  882410 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(882485), // Rule ID 60967 //
     /*  882415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  882426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  882429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  882432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  882435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  882464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882483 */     GIR_RootConstrainSelectedInstOperands,
     /*  882484 */     // GIR_Coverage, 60967,
     /*  882484 */     GIR_EraseRootFromParent_Done,
     /*  882485 */   // Label 13484: @882485
     /*  882485 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(882560), // Rule ID 60970 //
     /*  882490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  882501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  882504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  882510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  882539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882558 */     GIR_RootConstrainSelectedInstOperands,
     /*  882559 */     // GIR_Coverage, 60970,
     /*  882559 */     GIR_EraseRootFromParent_Done,
     /*  882560 */   // Label 13485: @882560
     /*  882560 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(882635), // Rule ID 60971 //
     /*  882565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  882576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  882579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  882582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  882585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  882614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882633 */     GIR_RootConstrainSelectedInstOperands,
     /*  882634 */     // GIR_Coverage, 60971,
     /*  882634 */     GIR_EraseRootFromParent_Done,
     /*  882635 */   // Label 13486: @882635
     /*  882635 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(882710), // Rule ID 60974 //
     /*  882640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  882651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  882654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  882657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  882660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  882689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882708 */     GIR_RootConstrainSelectedInstOperands,
     /*  882709 */     // GIR_Coverage, 60974,
     /*  882709 */     GIR_EraseRootFromParent_Done,
     /*  882710 */   // Label 13487: @882710
     /*  882710 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(882785), // Rule ID 60975 //
     /*  882715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  882726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  882729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  882732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  882735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  882764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882783 */     GIR_RootConstrainSelectedInstOperands,
     /*  882784 */     // GIR_Coverage, 60975,
     /*  882784 */     GIR_EraseRootFromParent_Done,
     /*  882785 */   // Label 13488: @882785
     /*  882785 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(882860), // Rule ID 60978 //
     /*  882790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  882801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  882804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  882807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  882810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  882839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882858 */     GIR_RootConstrainSelectedInstOperands,
     /*  882859 */     // GIR_Coverage, 60978,
     /*  882859 */     GIR_EraseRootFromParent_Done,
     /*  882860 */   // Label 13489: @882860
     /*  882860 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(882935), // Rule ID 60979 //
     /*  882865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  882876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  882879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  882882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  882885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  882911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  882914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  882930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882933 */     GIR_RootConstrainSelectedInstOperands,
     /*  882934 */     // GIR_Coverage, 60979,
     /*  882934 */     GIR_EraseRootFromParent_Done,
     /*  882935 */   // Label 13490: @882935
     /*  882935 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(883010), // Rule ID 60982 //
     /*  882940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  882951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  882954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  882957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  882960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  882986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  882989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883008 */     GIR_RootConstrainSelectedInstOperands,
     /*  883009 */     // GIR_Coverage, 60982,
     /*  883009 */     GIR_EraseRootFromParent_Done,
     /*  883010 */   // Label 13491: @883010
     /*  883010 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(883085), // Rule ID 60983 //
     /*  883015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  883026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  883029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  883032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  883035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  883061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  883080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883083 */     GIR_RootConstrainSelectedInstOperands,
     /*  883084 */     // GIR_Coverage, 60983,
     /*  883084 */     GIR_EraseRootFromParent_Done,
     /*  883085 */   // Label 13492: @883085
     /*  883085 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(883160), // Rule ID 60986 //
     /*  883090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  883101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  883104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  883107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  883110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  883139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883158 */     GIR_RootConstrainSelectedInstOperands,
     /*  883159 */     // GIR_Coverage, 60986,
     /*  883159 */     GIR_EraseRootFromParent_Done,
     /*  883160 */   // Label 13493: @883160
     /*  883160 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(883235), // Rule ID 60987 //
     /*  883165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  883176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  883179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  883182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  883185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  883214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883233 */     GIR_RootConstrainSelectedInstOperands,
     /*  883234 */     // GIR_Coverage, 60987,
     /*  883234 */     GIR_EraseRootFromParent_Done,
     /*  883235 */   // Label 13494: @883235
     /*  883235 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(883310), // Rule ID 60990 //
     /*  883240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  883251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  883254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  883257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  883260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883308 */     GIR_RootConstrainSelectedInstOperands,
     /*  883309 */     // GIR_Coverage, 60990,
     /*  883309 */     GIR_EraseRootFromParent_Done,
     /*  883310 */   // Label 13495: @883310
     /*  883310 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(883385), // Rule ID 60991 //
     /*  883315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  883326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  883329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  883332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  883335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883361 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883383 */     GIR_RootConstrainSelectedInstOperands,
     /*  883384 */     // GIR_Coverage, 60991,
     /*  883384 */     GIR_EraseRootFromParent_Done,
     /*  883385 */   // Label 13496: @883385
     /*  883385 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(883460), // Rule ID 60994 //
     /*  883390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  883401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  883404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  883410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  883439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883458 */     GIR_RootConstrainSelectedInstOperands,
     /*  883459 */     // GIR_Coverage, 60994,
     /*  883459 */     GIR_EraseRootFromParent_Done,
     /*  883460 */   // Label 13497: @883460
     /*  883460 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(883535), // Rule ID 60995 //
     /*  883465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  883476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  883479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  883482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  883485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  883514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883533 */     GIR_RootConstrainSelectedInstOperands,
     /*  883534 */     // GIR_Coverage, 60995,
     /*  883534 */     GIR_EraseRootFromParent_Done,
     /*  883535 */   // Label 13498: @883535
     /*  883535 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(883610), // Rule ID 60998 //
     /*  883540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  883551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  883554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  883557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  883560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  883589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883608 */     GIR_RootConstrainSelectedInstOperands,
     /*  883609 */     // GIR_Coverage, 60998,
     /*  883609 */     GIR_EraseRootFromParent_Done,
     /*  883610 */   // Label 13499: @883610
     /*  883610 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(883685), // Rule ID 60999 //
     /*  883615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  883626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  883629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  883632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  883635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  883664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883683 */     GIR_RootConstrainSelectedInstOperands,
     /*  883684 */     // GIR_Coverage, 60999,
     /*  883684 */     GIR_EraseRootFromParent_Done,
     /*  883685 */   // Label 13500: @883685
     /*  883685 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(883760), // Rule ID 61002 //
     /*  883690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  883701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  883704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  883707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  883710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  883736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883758 */     GIR_RootConstrainSelectedInstOperands,
     /*  883759 */     // GIR_Coverage, 61002,
     /*  883759 */     GIR_EraseRootFromParent_Done,
     /*  883760 */   // Label 13501: @883760
     /*  883760 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(883835), // Rule ID 61003 //
     /*  883765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  883776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  883779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  883782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  883785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  883811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  883814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  883830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883833 */     GIR_RootConstrainSelectedInstOperands,
     /*  883834 */     // GIR_Coverage, 61003,
     /*  883834 */     GIR_EraseRootFromParent_Done,
     /*  883835 */   // Label 13502: @883835
     /*  883835 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(883910), // Rule ID 61006 //
     /*  883840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  883857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  883860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883886 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  883886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883908 */     GIR_RootConstrainSelectedInstOperands,
     /*  883909 */     // GIR_Coverage, 61006,
     /*  883909 */     GIR_EraseRootFromParent_Done,
     /*  883910 */   // Label 13503: @883910
     /*  883910 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(883985), // Rule ID 61007 //
     /*  883915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  883918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  883932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  883935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883961 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  883961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  883964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  883980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883983 */     GIR_RootConstrainSelectedInstOperands,
     /*  883984 */     // GIR_Coverage, 61007,
     /*  883984 */     GIR_EraseRootFromParent_Done,
     /*  883985 */   // Label 13504: @883985
     /*  883985 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(884060), // Rule ID 61010 //
     /*  883990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  883993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  883998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  884007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  884010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  884039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884058 */     GIR_RootConstrainSelectedInstOperands,
     /*  884059 */     // GIR_Coverage, 61010,
     /*  884059 */     GIR_EraseRootFromParent_Done,
     /*  884060 */   // Label 13505: @884060
     /*  884060 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(884135), // Rule ID 61011 //
     /*  884065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  884082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  884085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  884114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884133 */     GIR_RootConstrainSelectedInstOperands,
     /*  884134 */     // GIR_Coverage, 61011,
     /*  884134 */     GIR_EraseRootFromParent_Done,
     /*  884135 */   // Label 13506: @884135
     /*  884135 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(884210), // Rule ID 61014 //
     /*  884140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  884160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  884189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884208 */     GIR_RootConstrainSelectedInstOperands,
     /*  884209 */     // GIR_Coverage, 61014,
     /*  884209 */     GIR_EraseRootFromParent_Done,
     /*  884210 */   // Label 13507: @884210
     /*  884210 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(884285), // Rule ID 61015 //
     /*  884215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  884232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  884235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  884264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884283 */     GIR_RootConstrainSelectedInstOperands,
     /*  884284 */     // GIR_Coverage, 61015,
     /*  884284 */     GIR_EraseRootFromParent_Done,
     /*  884285 */   // Label 13508: @884285
     /*  884285 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(884360), // Rule ID 61018 //
     /*  884290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  884307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  884310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  884336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  884339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884358 */     GIR_RootConstrainSelectedInstOperands,
     /*  884359 */     // GIR_Coverage, 61018,
     /*  884359 */     GIR_EraseRootFromParent_Done,
     /*  884360 */   // Label 13509: @884360
     /*  884360 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(884435), // Rule ID 61019 //
     /*  884365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  884382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  884385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  884411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  884414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  884430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884433 */     GIR_RootConstrainSelectedInstOperands,
     /*  884434 */     // GIR_Coverage, 61019,
     /*  884434 */     GIR_EraseRootFromParent_Done,
     /*  884435 */   // Label 13510: @884435
     /*  884435 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(884510), // Rule ID 61022 //
     /*  884440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  884451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  884454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  884489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884508 */     GIR_RootConstrainSelectedInstOperands,
     /*  884509 */     // GIR_Coverage, 61022,
     /*  884509 */     GIR_EraseRootFromParent_Done,
     /*  884510 */   // Label 13511: @884510
     /*  884510 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(884585), // Rule ID 61023 //
     /*  884515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  884526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  884529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  884564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884583 */     GIR_RootConstrainSelectedInstOperands,
     /*  884584 */     // GIR_Coverage, 61023,
     /*  884584 */     GIR_EraseRootFromParent_Done,
     /*  884585 */   // Label 13512: @884585
     /*  884585 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(884660), // Rule ID 61030 //
     /*  884590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  884601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  884604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  884639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884658 */     GIR_RootConstrainSelectedInstOperands,
     /*  884659 */     // GIR_Coverage, 61030,
     /*  884659 */     GIR_EraseRootFromParent_Done,
     /*  884660 */   // Label 13513: @884660
     /*  884660 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(884735), // Rule ID 61031 //
     /*  884665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  884676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  884679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884711 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  884714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884733 */     GIR_RootConstrainSelectedInstOperands,
     /*  884734 */     // GIR_Coverage, 61031,
     /*  884734 */     GIR_EraseRootFromParent_Done,
     /*  884735 */   // Label 13514: @884735
     /*  884735 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(884810), // Rule ID 61038 //
     /*  884740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  884751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  884754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  884757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  884789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884808 */     GIR_RootConstrainSelectedInstOperands,
     /*  884809 */     // GIR_Coverage, 61038,
     /*  884809 */     GIR_EraseRootFromParent_Done,
     /*  884810 */   // Label 13515: @884810
     /*  884810 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(884885), // Rule ID 61039 //
     /*  884815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  884826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  884829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  884832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  884864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884883 */     GIR_RootConstrainSelectedInstOperands,
     /*  884884 */     // GIR_Coverage, 61039,
     /*  884884 */     GIR_EraseRootFromParent_Done,
     /*  884885 */   // Label 13516: @884885
     /*  884885 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(884960), // Rule ID 61046 //
     /*  884890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  884893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  884901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  884904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  884907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  884939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884958 */     GIR_RootConstrainSelectedInstOperands,
     /*  884959 */     // GIR_Coverage, 61046,
     /*  884959 */     GIR_EraseRootFromParent_Done,
     /*  884960 */   // Label 13517: @884960
     /*  884960 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(885035), // Rule ID 61047 //
     /*  884965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  884968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  884973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  884976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  884979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  884982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885011 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885033 */     GIR_RootConstrainSelectedInstOperands,
     /*  885034 */     // GIR_Coverage, 61047,
     /*  885034 */     GIR_EraseRootFromParent_Done,
     /*  885035 */   // Label 13518: @885035
     /*  885035 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(885110), // Rule ID 61054 //
     /*  885040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  885051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  885054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  885057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885086 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885108 */     GIR_RootConstrainSelectedInstOperands,
     /*  885109 */     // GIR_Coverage, 61054,
     /*  885109 */     GIR_EraseRootFromParent_Done,
     /*  885110 */   // Label 13519: @885110
     /*  885110 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(885185), // Rule ID 61055 //
     /*  885115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  885126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  885129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  885132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885183 */     GIR_RootConstrainSelectedInstOperands,
     /*  885184 */     // GIR_Coverage, 61055,
     /*  885184 */     GIR_EraseRootFromParent_Done,
     /*  885185 */   // Label 13520: @885185
     /*  885185 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(885260), // Rule ID 61062 //
     /*  885190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  885201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  885204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  885207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885258 */     GIR_RootConstrainSelectedInstOperands,
     /*  885259 */     // GIR_Coverage, 61062,
     /*  885259 */     GIR_EraseRootFromParent_Done,
     /*  885260 */   // Label 13521: @885260
     /*  885260 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(885335), // Rule ID 61063 //
     /*  885265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  885276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  885279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  885282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885311 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885333 */     GIR_RootConstrainSelectedInstOperands,
     /*  885334 */     // GIR_Coverage, 61063,
     /*  885334 */     GIR_EraseRootFromParent_Done,
     /*  885335 */   // Label 13522: @885335
     /*  885335 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(885410), // Rule ID 61070 //
     /*  885340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  885389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885408 */     GIR_RootConstrainSelectedInstOperands,
     /*  885409 */     // GIR_Coverage, 61070,
     /*  885409 */     GIR_EraseRootFromParent_Done,
     /*  885410 */   // Label 13523: @885410
     /*  885410 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(885485), // Rule ID 61071 //
     /*  885415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  885464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885483 */     GIR_RootConstrainSelectedInstOperands,
     /*  885484 */     // GIR_Coverage, 61071,
     /*  885484 */     GIR_EraseRootFromParent_Done,
     /*  885485 */   // Label 13524: @885485
     /*  885485 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(885560), // Rule ID 61078 //
     /*  885490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  885501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  885504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  885539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885558 */     GIR_RootConstrainSelectedInstOperands,
     /*  885559 */     // GIR_Coverage, 61078,
     /*  885559 */     GIR_EraseRootFromParent_Done,
     /*  885560 */   // Label 13525: @885560
     /*  885560 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(885635), // Rule ID 61079 //
     /*  885565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  885576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  885579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  885614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885633 */     GIR_RootConstrainSelectedInstOperands,
     /*  885634 */     // GIR_Coverage, 61079,
     /*  885634 */     GIR_EraseRootFromParent_Done,
     /*  885635 */   // Label 13526: @885635
     /*  885635 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(885710), // Rule ID 61086 //
     /*  885640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  885651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  885654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885708 */     GIR_RootConstrainSelectedInstOperands,
     /*  885709 */     // GIR_Coverage, 61086,
     /*  885709 */     GIR_EraseRootFromParent_Done,
     /*  885710 */   // Label 13527: @885710
     /*  885710 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(885785), // Rule ID 61087 //
     /*  885715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  885726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  885729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  885764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885783 */     GIR_RootConstrainSelectedInstOperands,
     /*  885784 */     // GIR_Coverage, 61087,
     /*  885784 */     GIR_EraseRootFromParent_Done,
     /*  885785 */   // Label 13528: @885785
     /*  885785 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(885860), // Rule ID 61094 //
     /*  885790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  885801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  885804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  885807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885858 */     GIR_RootConstrainSelectedInstOperands,
     /*  885859 */     // GIR_Coverage, 61094,
     /*  885859 */     GIR_EraseRootFromParent_Done,
     /*  885860 */   // Label 13529: @885860
     /*  885860 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(885935), // Rule ID 61095 //
     /*  885865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  885868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  885876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  885879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  885882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  885900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885911 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  885914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885933 */     GIR_RootConstrainSelectedInstOperands,
     /*  885934 */     // GIR_Coverage, 61095,
     /*  885934 */     GIR_EraseRootFromParent_Done,
     /*  885935 */   // Label 13530: @885935
     /*  885935 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(886010), // Rule ID 61102 //
     /*  885940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  885943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  885948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  885951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  885954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  885957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  885989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886008 */     GIR_RootConstrainSelectedInstOperands,
     /*  886009 */     // GIR_Coverage, 61102,
     /*  886009 */     GIR_EraseRootFromParent_Done,
     /*  886010 */   // Label 13531: @886010
     /*  886010 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(886085), // Rule ID 61103 //
     /*  886015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  886026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  886029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  886032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886083 */     GIR_RootConstrainSelectedInstOperands,
     /*  886084 */     // GIR_Coverage, 61103,
     /*  886084 */     GIR_EraseRootFromParent_Done,
     /*  886085 */   // Label 13532: @886085
     /*  886085 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(886160), // Rule ID 61110 //
     /*  886090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  886139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886158 */     GIR_RootConstrainSelectedInstOperands,
     /*  886159 */     // GIR_Coverage, 61110,
     /*  886159 */     GIR_EraseRootFromParent_Done,
     /*  886160 */   // Label 13533: @886160
     /*  886160 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(886235), // Rule ID 61111 //
     /*  886165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  886214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886233 */     GIR_RootConstrainSelectedInstOperands,
     /*  886234 */     // GIR_Coverage, 61111,
     /*  886234 */     GIR_EraseRootFromParent_Done,
     /*  886235 */   // Label 13534: @886235
     /*  886235 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(886310), // Rule ID 61118 //
     /*  886240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  886289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886308 */     GIR_RootConstrainSelectedInstOperands,
     /*  886309 */     // GIR_Coverage, 61118,
     /*  886309 */     GIR_EraseRootFromParent_Done,
     /*  886310 */   // Label 13535: @886310
     /*  886310 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(886385), // Rule ID 61119 //
     /*  886315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  886364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886383 */     GIR_RootConstrainSelectedInstOperands,
     /*  886384 */     // GIR_Coverage, 61119,
     /*  886384 */     GIR_EraseRootFromParent_Done,
     /*  886385 */   // Label 13536: @886385
     /*  886385 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(886460), // Rule ID 61126 //
     /*  886390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  886401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  886404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  886407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  886439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886458 */     GIR_RootConstrainSelectedInstOperands,
     /*  886459 */     // GIR_Coverage, 61126,
     /*  886459 */     GIR_EraseRootFromParent_Done,
     /*  886460 */   // Label 13537: @886460
     /*  886460 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(886535), // Rule ID 61127 //
     /*  886465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  886476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  886479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  886482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  886514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886533 */     GIR_RootConstrainSelectedInstOperands,
     /*  886534 */     // GIR_Coverage, 61127,
     /*  886534 */     GIR_EraseRootFromParent_Done,
     /*  886535 */   // Label 13538: @886535
     /*  886535 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(886610), // Rule ID 61134 //
     /*  886540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  886543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  886551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  886554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  886557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  886560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886608 */     GIR_RootConstrainSelectedInstOperands,
     /*  886609 */     // GIR_Coverage, 61134,
     /*  886609 */     GIR_EraseRootFromParent_Done,
     /*  886610 */   // Label 13539: @886610
     /*  886610 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(886685), // Rule ID 61135 //
     /*  886615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  886618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  886623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  886626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  886629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  886632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  886635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  886654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  886664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886683 */     GIR_RootConstrainSelectedInstOperands,
     /*  886684 */     // GIR_Coverage, 61135,
     /*  886684 */     GIR_EraseRootFromParent_Done,
     /*  886685 */   // Label 13540: @886685
     /*  886685 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(886760), // Rule ID 61142 //
     /*  886690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  886739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886758 */     GIR_RootConstrainSelectedInstOperands,
     /*  886759 */     // GIR_Coverage, 61142,
     /*  886759 */     GIR_EraseRootFromParent_Done,
     /*  886760 */   // Label 13541: @886760
     /*  886760 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(886835), // Rule ID 61143 //
     /*  886765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  886768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886811 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  886814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886833 */     GIR_RootConstrainSelectedInstOperands,
     /*  886834 */     // GIR_Coverage, 61143,
     /*  886834 */     GIR_EraseRootFromParent_Done,
     /*  886835 */   // Label 13542: @886835
     /*  886835 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(886910), // Rule ID 61146 //
     /*  886840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  886857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  886860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  886889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886908 */     GIR_RootConstrainSelectedInstOperands,
     /*  886909 */     // GIR_Coverage, 61146,
     /*  886909 */     GIR_EraseRootFromParent_Done,
     /*  886910 */   // Label 13543: @886910
     /*  886910 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(886985), // Rule ID 61147 //
     /*  886915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  886918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  886926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  886929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  886932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  886935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  886964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886983 */     GIR_RootConstrainSelectedInstOperands,
     /*  886984 */     // GIR_Coverage, 61147,
     /*  886984 */     GIR_EraseRootFromParent_Done,
     /*  886985 */   // Label 13544: @886985
     /*  886985 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(887060), // Rule ID 61150 //
     /*  886990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  886993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  886998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  887039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887058 */     GIR_RootConstrainSelectedInstOperands,
     /*  887059 */     // GIR_Coverage, 61150,
     /*  887059 */     GIR_EraseRootFromParent_Done,
     /*  887060 */   // Label 13545: @887060
     /*  887060 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(887135), // Rule ID 61151 //
     /*  887065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  887114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887133 */     GIR_RootConstrainSelectedInstOperands,
     /*  887134 */     // GIR_Coverage, 61151,
     /*  887134 */     GIR_EraseRootFromParent_Done,
     /*  887135 */   // Label 13546: @887135
     /*  887135 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(887210), // Rule ID 61154 //
     /*  887140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  887189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887208 */     GIR_RootConstrainSelectedInstOperands,
     /*  887209 */     // GIR_Coverage, 61154,
     /*  887209 */     GIR_EraseRootFromParent_Done,
     /*  887210 */   // Label 13547: @887210
     /*  887210 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(887285), // Rule ID 61155 //
     /*  887215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  887264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887283 */     GIR_RootConstrainSelectedInstOperands,
     /*  887284 */     // GIR_Coverage, 61155,
     /*  887284 */     GIR_EraseRootFromParent_Done,
     /*  887285 */   // Label 13548: @887285
     /*  887285 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(887360), // Rule ID 61158 //
     /*  887290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  887339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887358 */     GIR_RootConstrainSelectedInstOperands,
     /*  887359 */     // GIR_Coverage, 61158,
     /*  887359 */     GIR_EraseRootFromParent_Done,
     /*  887360 */   // Label 13549: @887360
     /*  887360 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(887435), // Rule ID 61159 //
     /*  887365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  887414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887433 */     GIR_RootConstrainSelectedInstOperands,
     /*  887434 */     // GIR_Coverage, 61159,
     /*  887434 */     GIR_EraseRootFromParent_Done,
     /*  887435 */   // Label 13550: @887435
     /*  887435 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(887510), // Rule ID 61162 //
     /*  887440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  887489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887508 */     GIR_RootConstrainSelectedInstOperands,
     /*  887509 */     // GIR_Coverage, 61162,
     /*  887509 */     GIR_EraseRootFromParent_Done,
     /*  887510 */   // Label 13551: @887510
     /*  887510 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(887585), // Rule ID 61163 //
     /*  887515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  887564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887583 */     GIR_RootConstrainSelectedInstOperands,
     /*  887584 */     // GIR_Coverage, 61163,
     /*  887584 */     GIR_EraseRootFromParent_Done,
     /*  887585 */   // Label 13552: @887585
     /*  887585 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(887660), // Rule ID 61166 //
     /*  887590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  887639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887658 */     GIR_RootConstrainSelectedInstOperands,
     /*  887659 */     // GIR_Coverage, 61166,
     /*  887659 */     GIR_EraseRootFromParent_Done,
     /*  887660 */   // Label 13553: @887660
     /*  887660 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(887735), // Rule ID 61167 //
     /*  887665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  887714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887733 */     GIR_RootConstrainSelectedInstOperands,
     /*  887734 */     // GIR_Coverage, 61167,
     /*  887734 */     GIR_EraseRootFromParent_Done,
     /*  887735 */   // Label 13554: @887735
     /*  887735 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(887810), // Rule ID 61170 //
     /*  887740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  887760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  887789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887808 */     GIR_RootConstrainSelectedInstOperands,
     /*  887809 */     // GIR_Coverage, 61170,
     /*  887809 */     GIR_EraseRootFromParent_Done,
     /*  887810 */   // Label 13555: @887810
     /*  887810 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(887885), // Rule ID 61171 //
     /*  887815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  887823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  887835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  887854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  887864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887883 */     GIR_RootConstrainSelectedInstOperands,
     /*  887884 */     // GIR_Coverage, 61171,
     /*  887884 */     GIR_EraseRootFromParent_Done,
     /*  887885 */   // Label 13556: @887885
     /*  887885 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(887960), // Rule ID 61174 //
     /*  887890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  887893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  887898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  887939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887958 */     GIR_RootConstrainSelectedInstOperands,
     /*  887959 */     // GIR_Coverage, 61174,
     /*  887959 */     GIR_EraseRootFromParent_Done,
     /*  887960 */   // Label 13557: @887960
     /*  887960 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(888035), // Rule ID 61175 //
     /*  887965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  887968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  887973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  887976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  887979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  887982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  887985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  887996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888011 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  888014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888033 */     GIR_RootConstrainSelectedInstOperands,
     /*  888034 */     // GIR_Coverage, 61175,
     /*  888034 */     GIR_EraseRootFromParent_Done,
     /*  888035 */   // Label 13558: @888035
     /*  888035 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(888110), // Rule ID 61178 //
     /*  888040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  888089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888108 */     GIR_RootConstrainSelectedInstOperands,
     /*  888109 */     // GIR_Coverage, 61178,
     /*  888109 */     GIR_EraseRootFromParent_Done,
     /*  888110 */   // Label 13559: @888110
     /*  888110 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(888185), // Rule ID 61179 //
     /*  888115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  888164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888183 */     GIR_RootConstrainSelectedInstOperands,
     /*  888184 */     // GIR_Coverage, 61179,
     /*  888184 */     GIR_EraseRootFromParent_Done,
     /*  888185 */   // Label 13560: @888185
     /*  888185 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(888260), // Rule ID 61182 //
     /*  888190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  888239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888258 */     GIR_RootConstrainSelectedInstOperands,
     /*  888259 */     // GIR_Coverage, 61182,
     /*  888259 */     GIR_EraseRootFromParent_Done,
     /*  888260 */   // Label 13561: @888260
     /*  888260 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(888335), // Rule ID 61183 //
     /*  888265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  888314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888333 */     GIR_RootConstrainSelectedInstOperands,
     /*  888334 */     // GIR_Coverage, 61183,
     /*  888334 */     GIR_EraseRootFromParent_Done,
     /*  888335 */   // Label 13562: @888335
     /*  888335 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(888410), // Rule ID 61186 //
     /*  888340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  888389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888408 */     GIR_RootConstrainSelectedInstOperands,
     /*  888409 */     // GIR_Coverage, 61186,
     /*  888409 */     GIR_EraseRootFromParent_Done,
     /*  888410 */   // Label 13563: @888410
     /*  888410 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(888485), // Rule ID 61187 //
     /*  888415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888461 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  888464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888483 */     GIR_RootConstrainSelectedInstOperands,
     /*  888484 */     // GIR_Coverage, 61187,
     /*  888484 */     GIR_EraseRootFromParent_Done,
     /*  888485 */   // Label 13564: @888485
     /*  888485 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(888560), // Rule ID 61190 //
     /*  888490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  888501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  888504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  888507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  888539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888558 */     GIR_RootConstrainSelectedInstOperands,
     /*  888559 */     // GIR_Coverage, 61190,
     /*  888559 */     GIR_EraseRootFromParent_Done,
     /*  888560 */   // Label 13565: @888560
     /*  888560 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(888635), // Rule ID 61191 //
     /*  888565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  888576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  888579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  888582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888611 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  888614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888633 */     GIR_RootConstrainSelectedInstOperands,
     /*  888634 */     // GIR_Coverage, 61191,
     /*  888634 */     GIR_EraseRootFromParent_Done,
     /*  888635 */   // Label 13566: @888635
     /*  888635 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(888710), // Rule ID 61194 //
     /*  888640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  888689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888708 */     GIR_RootConstrainSelectedInstOperands,
     /*  888709 */     // GIR_Coverage, 61194,
     /*  888709 */     GIR_EraseRootFromParent_Done,
     /*  888710 */   // Label 13567: @888710
     /*  888710 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(888785), // Rule ID 61195 //
     /*  888715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  888764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888783 */     GIR_RootConstrainSelectedInstOperands,
     /*  888784 */     // GIR_Coverage, 61195,
     /*  888784 */     GIR_EraseRootFromParent_Done,
     /*  888785 */   // Label 13568: @888785
     /*  888785 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(888860), // Rule ID 61198 //
     /*  888790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888836 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  888839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888858 */     GIR_RootConstrainSelectedInstOperands,
     /*  888859 */     // GIR_Coverage, 61198,
     /*  888859 */     GIR_EraseRootFromParent_Done,
     /*  888860 */   // Label 13569: @888860
     /*  888860 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(888935), // Rule ID 61199 //
     /*  888865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  888868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888911 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  888914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888933 */     GIR_RootConstrainSelectedInstOperands,
     /*  888934 */     // GIR_Coverage, 61199,
     /*  888934 */     GIR_EraseRootFromParent_Done,
     /*  888935 */   // Label 13570: @888935
     /*  888935 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(889010), // Rule ID 61202 //
     /*  888940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  888943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  888948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  888989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889008 */     GIR_RootConstrainSelectedInstOperands,
     /*  889009 */     // GIR_Coverage, 61202,
     /*  889009 */     GIR_EraseRootFromParent_Done,
     /*  889010 */   // Label 13571: @889010
     /*  889010 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(889085), // Rule ID 61203 //
     /*  889015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  889018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  889023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  889026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  889029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  889032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  889061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  889064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889083 */     GIR_RootConstrainSelectedInstOperands,
     /*  889084 */     // GIR_Coverage, 61203,
     /*  889084 */     GIR_EraseRootFromParent_Done,
     /*  889085 */   // Label 13572: @889085
     /*  889085 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(889160), // Rule ID 61206 //
     /*  889090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  889110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  889139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889158 */     GIR_RootConstrainSelectedInstOperands,
     /*  889159 */     // GIR_Coverage, 61206,
     /*  889159 */     GIR_EraseRootFromParent_Done,
     /*  889160 */   // Label 13573: @889160
     /*  889160 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(889235), // Rule ID 61207 //
     /*  889165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  889176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  889179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  889182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  889185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  889214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889233 */     GIR_RootConstrainSelectedInstOperands,
     /*  889234 */     // GIR_Coverage, 61207,
     /*  889234 */     GIR_EraseRootFromParent_Done,
     /*  889235 */   // Label 13574: @889235
     /*  889235 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(889310), // Rule ID 61210 //
     /*  889240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  889260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889308 */     GIR_RootConstrainSelectedInstOperands,
     /*  889309 */     // GIR_Coverage, 61210,
     /*  889309 */     GIR_EraseRootFromParent_Done,
     /*  889310 */   // Label 13575: @889310
     /*  889310 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(889385), // Rule ID 61211 //
     /*  889315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  889326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  889329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  889332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  889335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889361 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889383 */     GIR_RootConstrainSelectedInstOperands,
     /*  889384 */     // GIR_Coverage, 61211,
     /*  889384 */     GIR_EraseRootFromParent_Done,
     /*  889385 */   // Label 13576: @889385
     /*  889385 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(889460), // Rule ID 61214 //
     /*  889390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  889410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889458 */     GIR_RootConstrainSelectedInstOperands,
     /*  889459 */     // GIR_Coverage, 61214,
     /*  889459 */     GIR_EraseRootFromParent_Done,
     /*  889460 */   // Label 13577: @889460
     /*  889460 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(889535), // Rule ID 61215 //
     /*  889465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  889476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  889479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  889482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  889485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889511 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889533 */     GIR_RootConstrainSelectedInstOperands,
     /*  889534 */     // GIR_Coverage, 61215,
     /*  889534 */     GIR_EraseRootFromParent_Done,
     /*  889535 */   // Label 13578: @889535
     /*  889535 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(889610), // Rule ID 61218 //
     /*  889540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  889560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889608 */     GIR_RootConstrainSelectedInstOperands,
     /*  889609 */     // GIR_Coverage, 61218,
     /*  889609 */     GIR_EraseRootFromParent_Done,
     /*  889610 */   // Label 13579: @889610
     /*  889610 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(889685), // Rule ID 61219 //
     /*  889615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  889635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889661 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  889664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889683 */     GIR_RootConstrainSelectedInstOperands,
     /*  889684 */     // GIR_Coverage, 61219,
     /*  889684 */     GIR_EraseRootFromParent_Done,
     /*  889685 */   // Label 13580: @889685
     /*  889685 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(889760), // Rule ID 61222 //
     /*  889690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  889710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889758 */     GIR_RootConstrainSelectedInstOperands,
     /*  889759 */     // GIR_Coverage, 61222,
     /*  889759 */     GIR_EraseRootFromParent_Done,
     /*  889760 */   // Label 13581: @889760
     /*  889760 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(889835), // Rule ID 61223 //
     /*  889765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  889785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889811 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889833 */     GIR_RootConstrainSelectedInstOperands,
     /*  889834 */     // GIR_Coverage, 61223,
     /*  889834 */     GIR_EraseRootFromParent_Done,
     /*  889835 */   // Label 13582: @889835
     /*  889835 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(889910), // Rule ID 61226 //
     /*  889840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  889860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889908 */     GIR_RootConstrainSelectedInstOperands,
     /*  889909 */     // GIR_Coverage, 61226,
     /*  889909 */     GIR_EraseRootFromParent_Done,
     /*  889910 */   // Label 13583: @889910
     /*  889910 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(889985), // Rule ID 61227 //
     /*  889915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  889935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889961 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  889964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889983 */     GIR_RootConstrainSelectedInstOperands,
     /*  889984 */     // GIR_Coverage, 61227,
     /*  889984 */     GIR_EraseRootFromParent_Done,
     /*  889985 */   // Label 13584: @889985
     /*  889985 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(890060), // Rule ID 61230 //
     /*  889990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  890001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  890010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890058 */     GIR_RootConstrainSelectedInstOperands,
     /*  890059 */     // GIR_Coverage, 61230,
     /*  890059 */     GIR_EraseRootFromParent_Done,
     /*  890060 */   // Label 13585: @890060
     /*  890060 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(890135), // Rule ID 61231 //
     /*  890065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  890076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  890079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  890082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  890085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890111 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890133 */     GIR_RootConstrainSelectedInstOperands,
     /*  890134 */     // GIR_Coverage, 61231,
     /*  890134 */     GIR_EraseRootFromParent_Done,
     /*  890135 */   // Label 13586: @890135
     /*  890135 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(890210), // Rule ID 61234 //
     /*  890140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  890160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890208 */     GIR_RootConstrainSelectedInstOperands,
     /*  890209 */     // GIR_Coverage, 61234,
     /*  890209 */     GIR_EraseRootFromParent_Done,
     /*  890210 */   // Label 13587: @890210
     /*  890210 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(890285), // Rule ID 61235 //
     /*  890215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  890226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  890229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  890232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  890235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890283 */     GIR_RootConstrainSelectedInstOperands,
     /*  890284 */     // GIR_Coverage, 61235,
     /*  890284 */     GIR_EraseRootFromParent_Done,
     /*  890285 */   // Label 13588: @890285
     /*  890285 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(890360), // Rule ID 61238 //
     /*  890290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  890310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890358 */     GIR_RootConstrainSelectedInstOperands,
     /*  890359 */     // GIR_Coverage, 61238,
     /*  890359 */     GIR_EraseRootFromParent_Done,
     /*  890360 */   // Label 13589: @890360
     /*  890360 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(890435), // Rule ID 61239 //
     /*  890365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  890376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  890379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  890382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  890385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890433 */     GIR_RootConstrainSelectedInstOperands,
     /*  890434 */     // GIR_Coverage, 61239,
     /*  890434 */     GIR_EraseRootFromParent_Done,
     /*  890435 */   // Label 13590: @890435
     /*  890435 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(890510), // Rule ID 61242 //
     /*  890440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  890460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  890486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890508 */     GIR_RootConstrainSelectedInstOperands,
     /*  890509 */     // GIR_Coverage, 61242,
     /*  890509 */     GIR_EraseRootFromParent_Done,
     /*  890510 */   // Label 13591: @890510
     /*  890510 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(890585), // Rule ID 61243 //
     /*  890515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  890526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  890529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  890532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  890535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890561 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  890564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890583 */     GIR_RootConstrainSelectedInstOperands,
     /*  890584 */     // GIR_Coverage, 61243,
     /*  890584 */     GIR_EraseRootFromParent_Done,
     /*  890585 */   // Label 13592: @890585
     /*  890585 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(890660), // Rule ID 61246 //
     /*  890590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  890610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  890639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890658 */     GIR_RootConstrainSelectedInstOperands,
     /*  890659 */     // GIR_Coverage, 61246,
     /*  890659 */     GIR_EraseRootFromParent_Done,
     /*  890660 */   // Label 13593: @890660
     /*  890660 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(890735), // Rule ID 61247 //
     /*  890665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  890685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  890714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890733 */     GIR_RootConstrainSelectedInstOperands,
     /*  890734 */     // GIR_Coverage, 61247,
     /*  890734 */     GIR_EraseRootFromParent_Done,
     /*  890735 */   // Label 13594: @890735
     /*  890735 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(890810), // Rule ID 61250 //
     /*  890740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  890760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  890789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890808 */     GIR_RootConstrainSelectedInstOperands,
     /*  890809 */     // GIR_Coverage, 61250,
     /*  890809 */     GIR_EraseRootFromParent_Done,
     /*  890810 */   // Label 13595: @890810
     /*  890810 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(890885), // Rule ID 61251 //
     /*  890815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  890835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890861 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  890864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890883 */     GIR_RootConstrainSelectedInstOperands,
     /*  890884 */     // GIR_Coverage, 61251,
     /*  890884 */     GIR_EraseRootFromParent_Done,
     /*  890885 */   // Label 13596: @890885
     /*  890885 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(890960), // Rule ID 61254 //
     /*  890890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  890910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890936 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  890939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890958 */     GIR_RootConstrainSelectedInstOperands,
     /*  890959 */     // GIR_Coverage, 61254,
     /*  890959 */     GIR_EraseRootFromParent_Done,
     /*  890960 */   // Label 13597: @890960
     /*  890960 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(891035), // Rule ID 61255 //
     /*  890965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  890985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891011 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891033 */     GIR_RootConstrainSelectedInstOperands,
     /*  891034 */     // GIR_Coverage, 61255,
     /*  891034 */     GIR_EraseRootFromParent_Done,
     /*  891035 */   // Label 13598: @891035
     /*  891035 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(891110), // Rule ID 61258 //
     /*  891040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  891060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891108 */     GIR_RootConstrainSelectedInstOperands,
     /*  891109 */     // GIR_Coverage, 61258,
     /*  891109 */     GIR_EraseRootFromParent_Done,
     /*  891110 */   // Label 13599: @891110
     /*  891110 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(891185), // Rule ID 61259 //
     /*  891115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  891126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  891129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  891132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  891135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891183 */     GIR_RootConstrainSelectedInstOperands,
     /*  891184 */     // GIR_Coverage, 61259,
     /*  891184 */     GIR_EraseRootFromParent_Done,
     /*  891185 */   // Label 13600: @891185
     /*  891185 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(891260), // Rule ID 61262 //
     /*  891190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  891210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891258 */     GIR_RootConstrainSelectedInstOperands,
     /*  891259 */     // GIR_Coverage, 61262,
     /*  891259 */     GIR_EraseRootFromParent_Done,
     /*  891260 */   // Label 13601: @891260
     /*  891260 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(891335), // Rule ID 61263 //
     /*  891265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  891276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  891279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  891282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  891285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891311 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891333 */     GIR_RootConstrainSelectedInstOperands,
     /*  891334 */     // GIR_Coverage, 61263,
     /*  891334 */     GIR_EraseRootFromParent_Done,
     /*  891335 */   // Label 13602: @891335
     /*  891335 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(891410), // Rule ID 61266 //
     /*  891340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  891360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891408 */     GIR_RootConstrainSelectedInstOperands,
     /*  891409 */     // GIR_Coverage, 61266,
     /*  891409 */     GIR_EraseRootFromParent_Done,
     /*  891410 */   // Label 13603: @891410
     /*  891410 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(891485), // Rule ID 61267 //
     /*  891415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  891426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  891429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  891432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  891435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891461 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891483 */     GIR_RootConstrainSelectedInstOperands,
     /*  891484 */     // GIR_Coverage, 61267,
     /*  891484 */     GIR_EraseRootFromParent_Done,
     /*  891485 */   // Label 13604: @891485
     /*  891485 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(891560), // Rule ID 61270 //
     /*  891490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  891510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891558 */     GIR_RootConstrainSelectedInstOperands,
     /*  891559 */     // GIR_Coverage, 61270,
     /*  891559 */     GIR_EraseRootFromParent_Done,
     /*  891560 */   // Label 13605: @891560
     /*  891560 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(891635), // Rule ID 61271 //
     /*  891565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  891585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891633 */     GIR_RootConstrainSelectedInstOperands,
     /*  891634 */     // GIR_Coverage, 61271,
     /*  891634 */     GIR_EraseRootFromParent_Done,
     /*  891635 */   // Label 13606: @891635
     /*  891635 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(891710), // Rule ID 61274 //
     /*  891640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  891660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891708 */     GIR_RootConstrainSelectedInstOperands,
     /*  891709 */     // GIR_Coverage, 61274,
     /*  891709 */     GIR_EraseRootFromParent_Done,
     /*  891710 */   // Label 13607: @891710
     /*  891710 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(891785), // Rule ID 61275 //
     /*  891715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  891735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  891764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891783 */     GIR_RootConstrainSelectedInstOperands,
     /*  891784 */     // GIR_Coverage, 61275,
     /*  891784 */     GIR_EraseRootFromParent_Done,
     /*  891785 */   // Label 13608: @891785
     /*  891785 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(891860), // Rule ID 61278 //
     /*  891790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  891810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891858 */     GIR_RootConstrainSelectedInstOperands,
     /*  891859 */     // GIR_Coverage, 61278,
     /*  891859 */     GIR_EraseRootFromParent_Done,
     /*  891860 */   // Label 13609: @891860
     /*  891860 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(891935), // Rule ID 61279 //
     /*  891865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  891885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891911 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  891914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891933 */     GIR_RootConstrainSelectedInstOperands,
     /*  891934 */     // GIR_Coverage, 61279,
     /*  891934 */     GIR_EraseRootFromParent_Done,
     /*  891935 */   // Label 13610: @891935
     /*  891935 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(892010), // Rule ID 61282 //
     /*  891940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  891960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  891989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892008 */     GIR_RootConstrainSelectedInstOperands,
     /*  892009 */     // GIR_Coverage, 61282,
     /*  892009 */     GIR_EraseRootFromParent_Done,
     /*  892010 */   // Label 13611: @892010
     /*  892010 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(892085), // Rule ID 61283 //
     /*  892015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  892026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  892029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  892032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  892035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  892064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892083 */     GIR_RootConstrainSelectedInstOperands,
     /*  892084 */     // GIR_Coverage, 61283,
     /*  892084 */     GIR_EraseRootFromParent_Done,
     /*  892085 */   // Label 13612: @892085
     /*  892085 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(892160), // Rule ID 61286 //
     /*  892090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  892110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  892139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892158 */     GIR_RootConstrainSelectedInstOperands,
     /*  892159 */     // GIR_Coverage, 61286,
     /*  892159 */     GIR_EraseRootFromParent_Done,
     /*  892160 */   // Label 13613: @892160
     /*  892160 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(892235), // Rule ID 61287 //
     /*  892165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  892176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  892179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  892182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  892185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  892204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  892214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892233 */     GIR_RootConstrainSelectedInstOperands,
     /*  892234 */     // GIR_Coverage, 61287,
     /*  892234 */     GIR_EraseRootFromParent_Done,
     /*  892235 */   // Label 13614: @892235
     /*  892235 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(892310), // Rule ID 61290 //
     /*  892240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  892260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892286 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  892289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892308 */     GIR_RootConstrainSelectedInstOperands,
     /*  892309 */     // GIR_Coverage, 61290,
     /*  892309 */     GIR_EraseRootFromParent_Done,
     /*  892310 */   // Label 13615: @892310
     /*  892310 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(892385), // Rule ID 61291 //
     /*  892315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  892326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  892329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  892332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  892335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  892354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  892364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892383 */     GIR_RootConstrainSelectedInstOperands,
     /*  892384 */     // GIR_Coverage, 61291,
     /*  892384 */     GIR_EraseRootFromParent_Done,
     /*  892385 */   // Label 13616: @892385
     /*  892385 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(892460), // Rule ID 61294 //
     /*  892390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  892439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892458 */     GIR_RootConstrainSelectedInstOperands,
     /*  892459 */     // GIR_Coverage, 61294,
     /*  892459 */     GIR_EraseRootFromParent_Done,
     /*  892460 */   // Label 13617: @892460
     /*  892460 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(892535), // Rule ID 61295 //
     /*  892465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  892476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  892479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  892482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892511 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  892514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892533 */     GIR_RootConstrainSelectedInstOperands,
     /*  892534 */     // GIR_Coverage, 61295,
     /*  892534 */     GIR_EraseRootFromParent_Done,
     /*  892535 */   // Label 13618: @892535
     /*  892535 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(892610), // Rule ID 61298 //
     /*  892540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892586 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892608 */     GIR_RootConstrainSelectedInstOperands,
     /*  892609 */     // GIR_Coverage, 61298,
     /*  892609 */     GIR_EraseRootFromParent_Done,
     /*  892610 */   // Label 13619: @892610
     /*  892610 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(892685), // Rule ID 61299 //
     /*  892615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892661 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892683 */     GIR_RootConstrainSelectedInstOperands,
     /*  892684 */     // GIR_Coverage, 61299,
     /*  892684 */     GIR_EraseRootFromParent_Done,
     /*  892685 */   // Label 13620: @892685
     /*  892685 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(892760), // Rule ID 61302 //
     /*  892690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  892739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892758 */     GIR_RootConstrainSelectedInstOperands,
     /*  892759 */     // GIR_Coverage, 61302,
     /*  892759 */     GIR_EraseRootFromParent_Done,
     /*  892760 */   // Label 13621: @892760
     /*  892760 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(892835), // Rule ID 61303 //
     /*  892765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892811 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  892814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892833 */     GIR_RootConstrainSelectedInstOperands,
     /*  892834 */     // GIR_Coverage, 61303,
     /*  892834 */     GIR_EraseRootFromParent_Done,
     /*  892835 */   // Label 13622: @892835
     /*  892835 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(892910), // Rule ID 61306 //
     /*  892840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  892860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892908 */     GIR_RootConstrainSelectedInstOperands,
     /*  892909 */     // GIR_Coverage, 61306,
     /*  892909 */     GIR_EraseRootFromParent_Done,
     /*  892910 */   // Label 13623: @892910
     /*  892910 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(892985), // Rule ID 61307 //
     /*  892915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  892935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  892954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892961 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  892964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892983 */     GIR_RootConstrainSelectedInstOperands,
     /*  892984 */     // GIR_Coverage, 61307,
     /*  892984 */     GIR_EraseRootFromParent_Done,
     /*  892985 */   // Label 13624: @892985
     /*  892985 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(893060), // Rule ID 61310 //
     /*  892990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  892998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  893001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893058 */     GIR_RootConstrainSelectedInstOperands,
     /*  893059 */     // GIR_Coverage, 61310,
     /*  893059 */     GIR_EraseRootFromParent_Done,
     /*  893060 */   // Label 13625: @893060
     /*  893060 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(893135), // Rule ID 61311 //
     /*  893065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  893076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  893079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  893082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893111 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893133 */     GIR_RootConstrainSelectedInstOperands,
     /*  893134 */     // GIR_Coverage, 61311,
     /*  893134 */     GIR_EraseRootFromParent_Done,
     /*  893135 */   // Label 13626: @893135
     /*  893135 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(893210), // Rule ID 61314 //
     /*  893140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893208 */     GIR_RootConstrainSelectedInstOperands,
     /*  893209 */     // GIR_Coverage, 61314,
     /*  893209 */     GIR_EraseRootFromParent_Done,
     /*  893210 */   // Label 13627: @893210
     /*  893210 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(893285), // Rule ID 61315 //
     /*  893215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  893226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  893229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  893232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893261 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  893264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893283 */     GIR_RootConstrainSelectedInstOperands,
     /*  893284 */     // GIR_Coverage, 61315,
     /*  893284 */     GIR_EraseRootFromParent_Done,
     /*  893285 */   // Label 13628: @893285
     /*  893285 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(893360), // Rule ID 61318 //
     /*  893290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893358 */     GIR_RootConstrainSelectedInstOperands,
     /*  893359 */     // GIR_Coverage, 61318,
     /*  893359 */     GIR_EraseRootFromParent_Done,
     /*  893360 */   // Label 13629: @893360
     /*  893360 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(893435), // Rule ID 61319 //
     /*  893365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  893376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  893379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  893382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893411 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893433 */     GIR_RootConstrainSelectedInstOperands,
     /*  893434 */     // GIR_Coverage, 61319,
     /*  893434 */     GIR_EraseRootFromParent_Done,
     /*  893435 */   // Label 13630: @893435
     /*  893435 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(893510), // Rule ID 61322 //
     /*  893440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893508 */     GIR_RootConstrainSelectedInstOperands,
     /*  893509 */     // GIR_Coverage, 61322,
     /*  893509 */     GIR_EraseRootFromParent_Done,
     /*  893510 */   // Label 13631: @893510
     /*  893510 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(893585), // Rule ID 61323 //
     /*  893515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  893526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  893529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  893532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893583 */     GIR_RootConstrainSelectedInstOperands,
     /*  893584 */     // GIR_Coverage, 61323,
     /*  893584 */     GIR_EraseRootFromParent_Done,
     /*  893585 */   // Label 13632: @893585
     /*  893585 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(893660), // Rule ID 61326 //
     /*  893590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893658 */     GIR_RootConstrainSelectedInstOperands,
     /*  893659 */     // GIR_Coverage, 61326,
     /*  893659 */     GIR_EraseRootFromParent_Done,
     /*  893660 */   // Label 13633: @893660
     /*  893660 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(893735), // Rule ID 61327 //
     /*  893665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893711 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893733 */     GIR_RootConstrainSelectedInstOperands,
     /*  893734 */     // GIR_Coverage, 61327,
     /*  893734 */     GIR_EraseRootFromParent_Done,
     /*  893735 */   // Label 13634: @893735
     /*  893735 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(893810), // Rule ID 61330 //
     /*  893740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893808 */     GIR_RootConstrainSelectedInstOperands,
     /*  893809 */     // GIR_Coverage, 61330,
     /*  893809 */     GIR_EraseRootFromParent_Done,
     /*  893810 */   // Label 13635: @893810
     /*  893810 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(893885), // Rule ID 61331 //
     /*  893815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  893864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893883 */     GIR_RootConstrainSelectedInstOperands,
     /*  893884 */     // GIR_Coverage, 61331,
     /*  893884 */     GIR_EraseRootFromParent_Done,
     /*  893885 */   // Label 13636: @893885
     /*  893885 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(893960), // Rule ID 61334 //
     /*  893890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  893910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  893929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  893939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893958 */     GIR_RootConstrainSelectedInstOperands,
     /*  893959 */     // GIR_Coverage, 61334,
     /*  893959 */     GIR_EraseRootFromParent_Done,
     /*  893960 */   // Label 13637: @893960
     /*  893960 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(894035), // Rule ID 61335 //
     /*  893965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  893973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  893985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894033 */     GIR_RootConstrainSelectedInstOperands,
     /*  894034 */     // GIR_Coverage, 61335,
     /*  894034 */     GIR_EraseRootFromParent_Done,
     /*  894035 */   // Label 13638: @894035
     /*  894035 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(894110), // Rule ID 61338 //
     /*  894040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894108 */     GIR_RootConstrainSelectedInstOperands,
     /*  894109 */     // GIR_Coverage, 61338,
     /*  894109 */     GIR_EraseRootFromParent_Done,
     /*  894110 */   // Label 13639: @894110
     /*  894110 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(894185), // Rule ID 61339 //
     /*  894115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  894126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  894129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  894132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894161 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894183 */     GIR_RootConstrainSelectedInstOperands,
     /*  894184 */     // GIR_Coverage, 61339,
     /*  894184 */     GIR_EraseRootFromParent_Done,
     /*  894185 */   // Label 13640: @894185
     /*  894185 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(894260), // Rule ID 61342 //
     /*  894190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894236 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894258 */     GIR_RootConstrainSelectedInstOperands,
     /*  894259 */     // GIR_Coverage, 61342,
     /*  894259 */     GIR_EraseRootFromParent_Done,
     /*  894260 */   // Label 13641: @894260
     /*  894260 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(894335), // Rule ID 61343 //
     /*  894265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  894276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  894279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  894282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894311 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894333 */     GIR_RootConstrainSelectedInstOperands,
     /*  894334 */     // GIR_Coverage, 61343,
     /*  894334 */     GIR_EraseRootFromParent_Done,
     /*  894335 */   // Label 13642: @894335
     /*  894335 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(894410), // Rule ID 61346 //
     /*  894340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894408 */     GIR_RootConstrainSelectedInstOperands,
     /*  894409 */     // GIR_Coverage, 61346,
     /*  894409 */     GIR_EraseRootFromParent_Done,
     /*  894410 */   // Label 13643: @894410
     /*  894410 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(894485), // Rule ID 61347 //
     /*  894415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  894426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  894429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  894432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894483 */     GIR_RootConstrainSelectedInstOperands,
     /*  894484 */     // GIR_Coverage, 61347,
     /*  894484 */     GIR_EraseRootFromParent_Done,
     /*  894485 */   // Label 13644: @894485
     /*  894485 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(894560), // Rule ID 61350 //
     /*  894490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894558 */     GIR_RootConstrainSelectedInstOperands,
     /*  894559 */     // GIR_Coverage, 61350,
     /*  894559 */     GIR_EraseRootFromParent_Done,
     /*  894560 */   // Label 13645: @894560
     /*  894560 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(894635), // Rule ID 61351 //
     /*  894565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894611 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894633 */     GIR_RootConstrainSelectedInstOperands,
     /*  894634 */     // GIR_Coverage, 61351,
     /*  894634 */     GIR_EraseRootFromParent_Done,
     /*  894635 */   // Label 13646: @894635
     /*  894635 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(894710), // Rule ID 61354 //
     /*  894640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894708 */     GIR_RootConstrainSelectedInstOperands,
     /*  894709 */     // GIR_Coverage, 61354,
     /*  894709 */     GIR_EraseRootFromParent_Done,
     /*  894710 */   // Label 13647: @894710
     /*  894710 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(894785), // Rule ID 61355 //
     /*  894715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  894764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894783 */     GIR_RootConstrainSelectedInstOperands,
     /*  894784 */     // GIR_Coverage, 61355,
     /*  894784 */     GIR_EraseRootFromParent_Done,
     /*  894785 */   // Label 13648: @894785
     /*  894785 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(894860), // Rule ID 61358 //
     /*  894790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894858 */     GIR_RootConstrainSelectedInstOperands,
     /*  894859 */     // GIR_Coverage, 61358,
     /*  894859 */     GIR_EraseRootFromParent_Done,
     /*  894860 */   // Label 13649: @894860
     /*  894860 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(894935), // Rule ID 61359 //
     /*  894865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  894914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894933 */     GIR_RootConstrainSelectedInstOperands,
     /*  894934 */     // GIR_Coverage, 61359,
     /*  894934 */     GIR_EraseRootFromParent_Done,
     /*  894935 */   // Label 13650: @894935
     /*  894935 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(895010), // Rule ID 61362 //
     /*  894940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  894948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  894989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895008 */     GIR_RootConstrainSelectedInstOperands,
     /*  895009 */     // GIR_Coverage, 61362,
     /*  895009 */     GIR_EraseRootFromParent_Done,
     /*  895010 */   // Label 13651: @895010
     /*  895010 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(895085), // Rule ID 61363 //
     /*  895015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  895026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  895029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  895032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895061 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895083 */     GIR_RootConstrainSelectedInstOperands,
     /*  895084 */     // GIR_Coverage, 61363,
     /*  895084 */     GIR_EraseRootFromParent_Done,
     /*  895085 */   // Label 13652: @895085
     /*  895085 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(895160), // Rule ID 61366 //
     /*  895090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895158 */     GIR_RootConstrainSelectedInstOperands,
     /*  895159 */     // GIR_Coverage, 61366,
     /*  895159 */     GIR_EraseRootFromParent_Done,
     /*  895160 */   // Label 13653: @895160
     /*  895160 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(895235), // Rule ID 61367 //
     /*  895165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  895176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  895179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  895182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895211 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895233 */     GIR_RootConstrainSelectedInstOperands,
     /*  895234 */     // GIR_Coverage, 61367,
     /*  895234 */     GIR_EraseRootFromParent_Done,
     /*  895235 */   // Label 13654: @895235
     /*  895235 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(895310), // Rule ID 61370 //
     /*  895240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  895289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895308 */     GIR_RootConstrainSelectedInstOperands,
     /*  895309 */     // GIR_Coverage, 61370,
     /*  895309 */     GIR_EraseRootFromParent_Done,
     /*  895310 */   // Label 13655: @895310
     /*  895310 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(895385), // Rule ID 61371 //
     /*  895315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  895326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  895329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  895332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  895350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  895364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895383 */     GIR_RootConstrainSelectedInstOperands,
     /*  895384 */     // GIR_Coverage, 61371,
     /*  895384 */     GIR_EraseRootFromParent_Done,
     /*  895385 */   // Label 13656: @895385
     /*  895385 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(895460), // Rule ID 61374 //
     /*  895390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895458 */     GIR_RootConstrainSelectedInstOperands,
     /*  895459 */     // GIR_Coverage, 61374,
     /*  895459 */     GIR_EraseRootFromParent_Done,
     /*  895460 */   // Label 13657: @895460
     /*  895460 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(895535), // Rule ID 61375 //
     /*  895465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  895476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  895479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  895482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  895500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  895514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895533 */     GIR_RootConstrainSelectedInstOperands,
     /*  895534 */     // GIR_Coverage, 61375,
     /*  895534 */     GIR_EraseRootFromParent_Done,
     /*  895535 */   // Label 13658: @895535
     /*  895535 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(895610), // Rule ID 61378 //
     /*  895540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895608 */     GIR_RootConstrainSelectedInstOperands,
     /*  895609 */     // GIR_Coverage, 61378,
     /*  895609 */     GIR_EraseRootFromParent_Done,
     /*  895610 */   // Label 13659: @895610
     /*  895610 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(895685), // Rule ID 61379 //
     /*  895615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  895623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  895664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895683 */     GIR_RootConstrainSelectedInstOperands,
     /*  895684 */     // GIR_Coverage, 61379,
     /*  895684 */     GIR_EraseRootFromParent_Done,
     /*  895685 */   // Label 13660: @895685
     /*  895685 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(895760), // Rule ID 61558 //
     /*  895690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  895710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  895739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895758 */     GIR_RootConstrainSelectedInstOperands,
     /*  895759 */     // GIR_Coverage, 61558,
     /*  895759 */     GIR_EraseRootFromParent_Done,
     /*  895760 */   // Label 13661: @895760
     /*  895760 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(895835), // Rule ID 61559 //
     /*  895765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  895785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895811 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  895814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895833 */     GIR_RootConstrainSelectedInstOperands,
     /*  895834 */     // GIR_Coverage, 61559,
     /*  895834 */     GIR_EraseRootFromParent_Done,
     /*  895835 */   // Label 13662: @895835
     /*  895835 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(895910), // Rule ID 61562 //
     /*  895840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  895860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  895889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895908 */     GIR_RootConstrainSelectedInstOperands,
     /*  895909 */     // GIR_Coverage, 61562,
     /*  895909 */     GIR_EraseRootFromParent_Done,
     /*  895910 */   // Label 13663: @895910
     /*  895910 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(895985), // Rule ID 61563 //
     /*  895915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  895935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895961 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  895964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895983 */     GIR_RootConstrainSelectedInstOperands,
     /*  895984 */     // GIR_Coverage, 61563,
     /*  895984 */     GIR_EraseRootFromParent_Done,
     /*  895985 */   // Label 13664: @895985
     /*  895985 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(896060), // Rule ID 61566 //
     /*  895990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  896001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  896010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896058 */     GIR_RootConstrainSelectedInstOperands,
     /*  896059 */     // GIR_Coverage, 61566,
     /*  896059 */     GIR_EraseRootFromParent_Done,
     /*  896060 */   // Label 13665: @896060
     /*  896060 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(896135), // Rule ID 61567 //
     /*  896065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  896076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  896079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  896082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  896085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896111 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896133 */     GIR_RootConstrainSelectedInstOperands,
     /*  896134 */     // GIR_Coverage, 61567,
     /*  896134 */     GIR_EraseRootFromParent_Done,
     /*  896135 */   // Label 13666: @896135
     /*  896135 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(896210), // Rule ID 61570 //
     /*  896140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  896160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  896189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896208 */     GIR_RootConstrainSelectedInstOperands,
     /*  896209 */     // GIR_Coverage, 61570,
     /*  896209 */     GIR_EraseRootFromParent_Done,
     /*  896210 */   // Label 13667: @896210
     /*  896210 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(896285), // Rule ID 61571 //
     /*  896215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  896226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  896229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  896232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  896235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896261 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  896264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896283 */     GIR_RootConstrainSelectedInstOperands,
     /*  896284 */     // GIR_Coverage, 61571,
     /*  896284 */     GIR_EraseRootFromParent_Done,
     /*  896285 */   // Label 13668: @896285
     /*  896285 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(896360), // Rule ID 61574 //
     /*  896290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  896310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896358 */     GIR_RootConstrainSelectedInstOperands,
     /*  896359 */     // GIR_Coverage, 61574,
     /*  896359 */     GIR_EraseRootFromParent_Done,
     /*  896360 */   // Label 13669: @896360
     /*  896360 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(896435), // Rule ID 61575 //
     /*  896365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  896376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  896379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  896382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  896385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896433 */     GIR_RootConstrainSelectedInstOperands,
     /*  896434 */     // GIR_Coverage, 61575,
     /*  896434 */     GIR_EraseRootFromParent_Done,
     /*  896435 */   // Label 13670: @896435
     /*  896435 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(896510), // Rule ID 61578 //
     /*  896440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  896460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896508 */     GIR_RootConstrainSelectedInstOperands,
     /*  896509 */     // GIR_Coverage, 61578,
     /*  896509 */     GIR_EraseRootFromParent_Done,
     /*  896510 */   // Label 13671: @896510
     /*  896510 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(896585), // Rule ID 61579 //
     /*  896515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  896526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  896529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  896532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  896535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  896564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896583 */     GIR_RootConstrainSelectedInstOperands,
     /*  896584 */     // GIR_Coverage, 61579,
     /*  896584 */     GIR_EraseRootFromParent_Done,
     /*  896585 */   // Label 13672: @896585
     /*  896585 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(896660), // Rule ID 61582 //
     /*  896590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  896610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896636 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896658 */     GIR_RootConstrainSelectedInstOperands,
     /*  896659 */     // GIR_Coverage, 61582,
     /*  896659 */     GIR_EraseRootFromParent_Done,
     /*  896660 */   // Label 13673: @896660
     /*  896660 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(896735), // Rule ID 61583 //
     /*  896665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  896685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896711 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896733 */     GIR_RootConstrainSelectedInstOperands,
     /*  896734 */     // GIR_Coverage, 61583,
     /*  896734 */     GIR_EraseRootFromParent_Done,
     /*  896735 */   // Label 13674: @896735
     /*  896735 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(896810), // Rule ID 61586 //
     /*  896740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  896760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896808 */     GIR_RootConstrainSelectedInstOperands,
     /*  896809 */     // GIR_Coverage, 61586,
     /*  896809 */     GIR_EraseRootFromParent_Done,
     /*  896810 */   // Label 13675: @896810
     /*  896810 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(896885), // Rule ID 61587 //
     /*  896815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  896835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896883 */     GIR_RootConstrainSelectedInstOperands,
     /*  896884 */     // GIR_Coverage, 61587,
     /*  896884 */     GIR_EraseRootFromParent_Done,
     /*  896885 */   // Label 13676: @896885
     /*  896885 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(896960), // Rule ID 61590 //
     /*  896890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  896910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  896939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896958 */     GIR_RootConstrainSelectedInstOperands,
     /*  896959 */     // GIR_Coverage, 61590,
     /*  896959 */     GIR_EraseRootFromParent_Done,
     /*  896960 */   // Label 13677: @896960
     /*  896960 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(897035), // Rule ID 61591 //
     /*  896965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  896985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897011 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897033 */     GIR_RootConstrainSelectedInstOperands,
     /*  897034 */     // GIR_Coverage, 61591,
     /*  897034 */     GIR_EraseRootFromParent_Done,
     /*  897035 */   // Label 13678: @897035
     /*  897035 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(897110), // Rule ID 61594 //
     /*  897040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  897060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897108 */     GIR_RootConstrainSelectedInstOperands,
     /*  897109 */     // GIR_Coverage, 61594,
     /*  897109 */     GIR_EraseRootFromParent_Done,
     /*  897110 */   // Label 13679: @897110
     /*  897110 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(897185), // Rule ID 61595 //
     /*  897115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  897126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  897129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  897132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  897135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  897164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897183 */     GIR_RootConstrainSelectedInstOperands,
     /*  897184 */     // GIR_Coverage, 61595,
     /*  897184 */     GIR_EraseRootFromParent_Done,
     /*  897185 */   // Label 13680: @897185
     /*  897185 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(897260), // Rule ID 61598 //
     /*  897190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  897210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897258 */     GIR_RootConstrainSelectedInstOperands,
     /*  897259 */     // GIR_Coverage, 61598,
     /*  897259 */     GIR_EraseRootFromParent_Done,
     /*  897260 */   // Label 13681: @897260
     /*  897260 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(897335), // Rule ID 61599 //
     /*  897265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  897276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  897279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  897282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  897285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897333 */     GIR_RootConstrainSelectedInstOperands,
     /*  897334 */     // GIR_Coverage, 61599,
     /*  897334 */     GIR_EraseRootFromParent_Done,
     /*  897335 */   // Label 13682: @897335
     /*  897335 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(897410), // Rule ID 61602 //
     /*  897340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  897360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897386 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897408 */     GIR_RootConstrainSelectedInstOperands,
     /*  897409 */     // GIR_Coverage, 61602,
     /*  897409 */     GIR_EraseRootFromParent_Done,
     /*  897410 */   // Label 13683: @897410
     /*  897410 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(897485), // Rule ID 61603 //
     /*  897415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  897426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  897429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  897432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  897435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897461 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897483 */     GIR_RootConstrainSelectedInstOperands,
     /*  897484 */     // GIR_Coverage, 61603,
     /*  897484 */     GIR_EraseRootFromParent_Done,
     /*  897485 */   // Label 13684: @897485
     /*  897485 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(897560), // Rule ID 61606 //
     /*  897490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  897510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897536 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897558 */     GIR_RootConstrainSelectedInstOperands,
     /*  897559 */     // GIR_Coverage, 61606,
     /*  897559 */     GIR_EraseRootFromParent_Done,
     /*  897560 */   // Label 13685: @897560
     /*  897560 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(897635), // Rule ID 61607 //
     /*  897565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  897585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897611 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897633 */     GIR_RootConstrainSelectedInstOperands,
     /*  897634 */     // GIR_Coverage, 61607,
     /*  897634 */     GIR_EraseRootFromParent_Done,
     /*  897635 */   // Label 13686: @897635
     /*  897635 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(897710), // Rule ID 61610 //
     /*  897640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  897660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897708 */     GIR_RootConstrainSelectedInstOperands,
     /*  897709 */     // GIR_Coverage, 61610,
     /*  897709 */     GIR_EraseRootFromParent_Done,
     /*  897710 */   // Label 13687: @897710
     /*  897710 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(897785), // Rule ID 61611 //
     /*  897715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  897735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  897764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897783 */     GIR_RootConstrainSelectedInstOperands,
     /*  897784 */     // GIR_Coverage, 61611,
     /*  897784 */     GIR_EraseRootFromParent_Done,
     /*  897785 */   // Label 13688: @897785
     /*  897785 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(897860), // Rule ID 61614 //
     /*  897790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  897810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897858 */     GIR_RootConstrainSelectedInstOperands,
     /*  897859 */     // GIR_Coverage, 61614,
     /*  897859 */     GIR_EraseRootFromParent_Done,
     /*  897860 */   // Label 13689: @897860
     /*  897860 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(897935), // Rule ID 61615 //
     /*  897865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  897885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  897914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897933 */     GIR_RootConstrainSelectedInstOperands,
     /*  897934 */     // GIR_Coverage, 61615,
     /*  897934 */     GIR_EraseRootFromParent_Done,
     /*  897935 */   // Label 13690: @897935
     /*  897935 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(898010), // Rule ID 61618 //
     /*  897940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  897960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  897989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898008 */     GIR_RootConstrainSelectedInstOperands,
     /*  898009 */     // GIR_Coverage, 61618,
     /*  898009 */     GIR_EraseRootFromParent_Done,
     /*  898010 */   // Label 13691: @898010
     /*  898010 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(898085), // Rule ID 61619 //
     /*  898015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  898026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  898029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  898032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  898035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898083 */     GIR_RootConstrainSelectedInstOperands,
     /*  898084 */     // GIR_Coverage, 61619,
     /*  898084 */     GIR_EraseRootFromParent_Done,
     /*  898085 */   // Label 13692: @898085
     /*  898085 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(898160), // Rule ID 61622 //
     /*  898090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  898110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898158 */     GIR_RootConstrainSelectedInstOperands,
     /*  898159 */     // GIR_Coverage, 61622,
     /*  898159 */     GIR_EraseRootFromParent_Done,
     /*  898160 */   // Label 13693: @898160
     /*  898160 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(898235), // Rule ID 61623 //
     /*  898165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  898176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  898179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  898182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  898185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898233 */     GIR_RootConstrainSelectedInstOperands,
     /*  898234 */     // GIR_Coverage, 61623,
     /*  898234 */     GIR_EraseRootFromParent_Done,
     /*  898235 */   // Label 13694: @898235
     /*  898235 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(898310), // Rule ID 61626 //
     /*  898240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  898260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898308 */     GIR_RootConstrainSelectedInstOperands,
     /*  898309 */     // GIR_Coverage, 61626,
     /*  898309 */     GIR_EraseRootFromParent_Done,
     /*  898310 */   // Label 13695: @898310
     /*  898310 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(898385), // Rule ID 61627 //
     /*  898315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  898326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  898329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  898332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  898335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898361 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898383 */     GIR_RootConstrainSelectedInstOperands,
     /*  898384 */     // GIR_Coverage, 61627,
     /*  898384 */     GIR_EraseRootFromParent_Done,
     /*  898385 */   // Label 13696: @898385
     /*  898385 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(898460), // Rule ID 61630 //
     /*  898390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  898410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898436 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898458 */     GIR_RootConstrainSelectedInstOperands,
     /*  898459 */     // GIR_Coverage, 61630,
     /*  898459 */     GIR_EraseRootFromParent_Done,
     /*  898460 */   // Label 13697: @898460
     /*  898460 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(898535), // Rule ID 61631 //
     /*  898465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  898476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  898479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  898482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  898485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898533 */     GIR_RootConstrainSelectedInstOperands,
     /*  898534 */     // GIR_Coverage, 61631,
     /*  898534 */     GIR_EraseRootFromParent_Done,
     /*  898535 */   // Label 13698: @898535
     /*  898535 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(898610), // Rule ID 61634 //
     /*  898540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  898560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898608 */     GIR_RootConstrainSelectedInstOperands,
     /*  898609 */     // GIR_Coverage, 61634,
     /*  898609 */     GIR_EraseRootFromParent_Done,
     /*  898610 */   // Label 13699: @898610
     /*  898610 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(898685), // Rule ID 61635 //
     /*  898615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  898635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  898664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898683 */     GIR_RootConstrainSelectedInstOperands,
     /*  898684 */     // GIR_Coverage, 61635,
     /*  898684 */     GIR_EraseRootFromParent_Done,
     /*  898685 */   // Label 13700: @898685
     /*  898685 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(898760), // Rule ID 61638 //
     /*  898690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  898710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898758 */     GIR_RootConstrainSelectedInstOperands,
     /*  898759 */     // GIR_Coverage, 61638,
     /*  898759 */     GIR_EraseRootFromParent_Done,
     /*  898760 */   // Label 13701: @898760
     /*  898760 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(898835), // Rule ID 61639 //
     /*  898765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  898785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898811 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  898814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898833 */     GIR_RootConstrainSelectedInstOperands,
     /*  898834 */     // GIR_Coverage, 61639,
     /*  898834 */     GIR_EraseRootFromParent_Done,
     /*  898835 */   // Label 13702: @898835
     /*  898835 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(898910), // Rule ID 61642 //
     /*  898840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  898860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898908 */     GIR_RootConstrainSelectedInstOperands,
     /*  898909 */     // GIR_Coverage, 61642,
     /*  898909 */     GIR_EraseRootFromParent_Done,
     /*  898910 */   // Label 13703: @898910
     /*  898910 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(898985), // Rule ID 61643 //
     /*  898915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  898935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898961 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  898964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898983 */     GIR_RootConstrainSelectedInstOperands,
     /*  898984 */     // GIR_Coverage, 61643,
     /*  898984 */     GIR_EraseRootFromParent_Done,
     /*  898985 */   // Label 13704: @898985
     /*  898985 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(899060), // Rule ID 61646 //
     /*  898990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  899001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899036 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  899039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899058 */     GIR_RootConstrainSelectedInstOperands,
     /*  899059 */     // GIR_Coverage, 61646,
     /*  899059 */     GIR_EraseRootFromParent_Done,
     /*  899060 */   // Label 13705: @899060
     /*  899060 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(899135), // Rule ID 61647 //
     /*  899065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  899076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  899079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  899082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899111 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  899114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899133 */     GIR_RootConstrainSelectedInstOperands,
     /*  899134 */     // GIR_Coverage, 61647,
     /*  899134 */     GIR_EraseRootFromParent_Done,
     /*  899135 */   // Label 13706: @899135
     /*  899135 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(899210), // Rule ID 61650 //
     /*  899140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899208 */     GIR_RootConstrainSelectedInstOperands,
     /*  899209 */     // GIR_Coverage, 61650,
     /*  899209 */     GIR_EraseRootFromParent_Done,
     /*  899210 */   // Label 13707: @899210
     /*  899210 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(899285), // Rule ID 61651 //
     /*  899215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  899226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  899229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  899232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899261 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899283 */     GIR_RootConstrainSelectedInstOperands,
     /*  899284 */     // GIR_Coverage, 61651,
     /*  899284 */     GIR_EraseRootFromParent_Done,
     /*  899285 */   // Label 13708: @899285
     /*  899285 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(899360), // Rule ID 61654 //
     /*  899290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899358 */     GIR_RootConstrainSelectedInstOperands,
     /*  899359 */     // GIR_Coverage, 61654,
     /*  899359 */     GIR_EraseRootFromParent_Done,
     /*  899360 */   // Label 13709: @899360
     /*  899360 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(899435), // Rule ID 61655 //
     /*  899365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  899376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  899379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  899382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899433 */     GIR_RootConstrainSelectedInstOperands,
     /*  899434 */     // GIR_Coverage, 61655,
     /*  899434 */     GIR_EraseRootFromParent_Done,
     /*  899435 */   // Label 13710: @899435
     /*  899435 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(899510), // Rule ID 61658 //
     /*  899440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899508 */     GIR_RootConstrainSelectedInstOperands,
     /*  899509 */     // GIR_Coverage, 61658,
     /*  899509 */     GIR_EraseRootFromParent_Done,
     /*  899510 */   // Label 13711: @899510
     /*  899510 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(899585), // Rule ID 61659 //
     /*  899515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  899526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  899529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  899532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  899564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899583 */     GIR_RootConstrainSelectedInstOperands,
     /*  899584 */     // GIR_Coverage, 61659,
     /*  899584 */     GIR_EraseRootFromParent_Done,
     /*  899585 */   // Label 13712: @899585
     /*  899585 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(899660), // Rule ID 61662 //
     /*  899590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899658 */     GIR_RootConstrainSelectedInstOperands,
     /*  899659 */     // GIR_Coverage, 61662,
     /*  899659 */     GIR_EraseRootFromParent_Done,
     /*  899660 */   // Label 13713: @899660
     /*  899660 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(899735), // Rule ID 61663 //
     /*  899665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899711 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899733 */     GIR_RootConstrainSelectedInstOperands,
     /*  899734 */     // GIR_Coverage, 61663,
     /*  899734 */     GIR_EraseRootFromParent_Done,
     /*  899735 */   // Label 13714: @899735
     /*  899735 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(899810), // Rule ID 61666 //
     /*  899740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899808 */     GIR_RootConstrainSelectedInstOperands,
     /*  899809 */     // GIR_Coverage, 61666,
     /*  899809 */     GIR_EraseRootFromParent_Done,
     /*  899810 */   // Label 13715: @899810
     /*  899810 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(899885), // Rule ID 61667 //
     /*  899815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899861 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  899864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899883 */     GIR_RootConstrainSelectedInstOperands,
     /*  899884 */     // GIR_Coverage, 61667,
     /*  899884 */     GIR_EraseRootFromParent_Done,
     /*  899885 */   // Label 13716: @899885
     /*  899885 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(899960), // Rule ID 61670 //
     /*  899890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  899910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  899929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  899939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899958 */     GIR_RootConstrainSelectedInstOperands,
     /*  899959 */     // GIR_Coverage, 61670,
     /*  899959 */     GIR_EraseRootFromParent_Done,
     /*  899960 */   // Label 13717: @899960
     /*  899960 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(900035), // Rule ID 61671 //
     /*  899965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  899973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  899985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900033 */     GIR_RootConstrainSelectedInstOperands,
     /*  900034 */     // GIR_Coverage, 61671,
     /*  900034 */     GIR_EraseRootFromParent_Done,
     /*  900035 */   // Label 13718: @900035
     /*  900035 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(900110), // Rule ID 61674 //
     /*  900040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900108 */     GIR_RootConstrainSelectedInstOperands,
     /*  900109 */     // GIR_Coverage, 61674,
     /*  900109 */     GIR_EraseRootFromParent_Done,
     /*  900110 */   // Label 13719: @900110
     /*  900110 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(900185), // Rule ID 61675 //
     /*  900115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  900126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  900129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  900132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900183 */     GIR_RootConstrainSelectedInstOperands,
     /*  900184 */     // GIR_Coverage, 61675,
     /*  900184 */     GIR_EraseRootFromParent_Done,
     /*  900185 */   // Label 13720: @900185
     /*  900185 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(900260), // Rule ID 61678 //
     /*  900190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900258 */     GIR_RootConstrainSelectedInstOperands,
     /*  900259 */     // GIR_Coverage, 61678,
     /*  900259 */     GIR_EraseRootFromParent_Done,
     /*  900260 */   // Label 13721: @900260
     /*  900260 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(900335), // Rule ID 61679 //
     /*  900265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  900276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  900279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  900282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900333 */     GIR_RootConstrainSelectedInstOperands,
     /*  900334 */     // GIR_Coverage, 61679,
     /*  900334 */     GIR_EraseRootFromParent_Done,
     /*  900335 */   // Label 13722: @900335
     /*  900335 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(900410), // Rule ID 61682 //
     /*  900340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900408 */     GIR_RootConstrainSelectedInstOperands,
     /*  900409 */     // GIR_Coverage, 61682,
     /*  900409 */     GIR_EraseRootFromParent_Done,
     /*  900410 */   // Label 13723: @900410
     /*  900410 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(900485), // Rule ID 61683 //
     /*  900415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  900426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  900429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  900432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  900450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900461 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  900461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  900464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900483 */     GIR_RootConstrainSelectedInstOperands,
     /*  900484 */     // GIR_Coverage, 61683,
     /*  900484 */     GIR_EraseRootFromParent_Done,
     /*  900485 */   // Label 13724: @900485
     /*  900485 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(900560), // Rule ID 61686 //
     /*  900490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900558 */     GIR_RootConstrainSelectedInstOperands,
     /*  900559 */     // GIR_Coverage, 61686,
     /*  900559 */     GIR_EraseRootFromParent_Done,
     /*  900560 */   // Label 13725: @900560
     /*  900560 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(900635), // Rule ID 61687 //
     /*  900565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900611 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900633 */     GIR_RootConstrainSelectedInstOperands,
     /*  900634 */     // GIR_Coverage, 61687,
     /*  900634 */     GIR_EraseRootFromParent_Done,
     /*  900635 */   // Label 13726: @900635
     /*  900635 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(900710), // Rule ID 61690 //
     /*  900640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900686 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  900689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900708 */     GIR_RootConstrainSelectedInstOperands,
     /*  900709 */     // GIR_Coverage, 61690,
     /*  900709 */     GIR_EraseRootFromParent_Done,
     /*  900710 */   // Label 13727: @900710
     /*  900710 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(900785), // Rule ID 61691 //
     /*  900715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900761 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  900764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900783 */     GIR_RootConstrainSelectedInstOperands,
     /*  900784 */     // GIR_Coverage, 61691,
     /*  900784 */     GIR_EraseRootFromParent_Done,
     /*  900785 */   // Label 13728: @900785
     /*  900785 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(900860), // Rule ID 61694 //
     /*  900790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900836 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  900839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900858 */     GIR_RootConstrainSelectedInstOperands,
     /*  900859 */     // GIR_Coverage, 61694,
     /*  900859 */     GIR_EraseRootFromParent_Done,
     /*  900860 */   // Label 13729: @900860
     /*  900860 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(900935), // Rule ID 61695 //
     /*  900865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  900885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900911 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  900914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900933 */     GIR_RootConstrainSelectedInstOperands,
     /*  900934 */     // GIR_Coverage, 61695,
     /*  900934 */     GIR_EraseRootFromParent_Done,
     /*  900935 */   // Label 13730: @900935
     /*  900935 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(901010), // Rule ID 61698 //
     /*  900940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  900948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  900960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  900979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  900989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901008 */     GIR_RootConstrainSelectedInstOperands,
     /*  901009 */     // GIR_Coverage, 61698,
     /*  901009 */     GIR_EraseRootFromParent_Done,
     /*  901010 */   // Label 13731: @901010
     /*  901010 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(901085), // Rule ID 61699 //
     /*  901015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  901026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  901029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  901032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901083 */     GIR_RootConstrainSelectedInstOperands,
     /*  901084 */     // GIR_Coverage, 61699,
     /*  901084 */     GIR_EraseRootFromParent_Done,
     /*  901085 */   // Label 13732: @901085
     /*  901085 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(901160), // Rule ID 61702 //
     /*  901090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901158 */     GIR_RootConstrainSelectedInstOperands,
     /*  901159 */     // GIR_Coverage, 61702,
     /*  901159 */     GIR_EraseRootFromParent_Done,
     /*  901160 */   // Label 13733: @901160
     /*  901160 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(901235), // Rule ID 61703 //
     /*  901165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  901176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  901179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  901182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901211 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901233 */     GIR_RootConstrainSelectedInstOperands,
     /*  901234 */     // GIR_Coverage, 61703,
     /*  901234 */     GIR_EraseRootFromParent_Done,
     /*  901235 */   // Label 13734: @901235
     /*  901235 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(901310), // Rule ID 61706 //
     /*  901240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901308 */     GIR_RootConstrainSelectedInstOperands,
     /*  901309 */     // GIR_Coverage, 61706,
     /*  901309 */     GIR_EraseRootFromParent_Done,
     /*  901310 */   // Label 13735: @901310
     /*  901310 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(901385), // Rule ID 61707 //
     /*  901315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  901326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  901329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  901332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901361 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901383 */     GIR_RootConstrainSelectedInstOperands,
     /*  901384 */     // GIR_Coverage, 61707,
     /*  901384 */     GIR_EraseRootFromParent_Done,
     /*  901385 */   // Label 13736: @901385
     /*  901385 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(901460), // Rule ID 61710 //
     /*  901390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901458 */     GIR_RootConstrainSelectedInstOperands,
     /*  901459 */     // GIR_Coverage, 61710,
     /*  901459 */     GIR_EraseRootFromParent_Done,
     /*  901460 */   // Label 13737: @901460
     /*  901460 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(901535), // Rule ID 61711 //
     /*  901465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  901476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  901479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  901482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901533 */     GIR_RootConstrainSelectedInstOperands,
     /*  901534 */     // GIR_Coverage, 61711,
     /*  901534 */     GIR_EraseRootFromParent_Done,
     /*  901535 */   // Label 13738: @901535
     /*  901535 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(901610), // Rule ID 61714 //
     /*  901540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901608 */     GIR_RootConstrainSelectedInstOperands,
     /*  901609 */     // GIR_Coverage, 61714,
     /*  901609 */     GIR_EraseRootFromParent_Done,
     /*  901610 */   // Label 13739: @901610
     /*  901610 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(901685), // Rule ID 61715 //
     /*  901615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  901664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901683 */     GIR_RootConstrainSelectedInstOperands,
     /*  901684 */     // GIR_Coverage, 61715,
     /*  901684 */     GIR_EraseRootFromParent_Done,
     /*  901685 */   // Label 13740: @901685
     /*  901685 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(901760), // Rule ID 61718 //
     /*  901690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901758 */     GIR_RootConstrainSelectedInstOperands,
     /*  901759 */     // GIR_Coverage, 61718,
     /*  901759 */     GIR_EraseRootFromParent_Done,
     /*  901760 */   // Label 13741: @901760
     /*  901760 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(901835), // Rule ID 61719 //
     /*  901765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  901814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901833 */     GIR_RootConstrainSelectedInstOperands,
     /*  901834 */     // GIR_Coverage, 61719,
     /*  901834 */     GIR_EraseRootFromParent_Done,
     /*  901835 */   // Label 13742: @901835
     /*  901835 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(901910), // Rule ID 61722 //
     /*  901840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901908 */     GIR_RootConstrainSelectedInstOperands,
     /*  901909 */     // GIR_Coverage, 61722,
     /*  901909 */     GIR_EraseRootFromParent_Done,
     /*  901910 */   // Label 13743: @901910
     /*  901910 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(901985), // Rule ID 61723 //
     /*  901915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  901964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901983 */     GIR_RootConstrainSelectedInstOperands,
     /*  901984 */     // GIR_Coverage, 61723,
     /*  901984 */     GIR_EraseRootFromParent_Done,
     /*  901985 */   // Label 13744: @901985
     /*  901985 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(902060), // Rule ID 61726 //
     /*  901990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  901998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  902001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  902039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902058 */     GIR_RootConstrainSelectedInstOperands,
     /*  902059 */     // GIR_Coverage, 61726,
     /*  902059 */     GIR_EraseRootFromParent_Done,
     /*  902060 */   // Label 13745: @902060
     /*  902060 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(902135), // Rule ID 61727 //
     /*  902065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  902076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  902079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  902082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902111 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  902114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902133 */     GIR_RootConstrainSelectedInstOperands,
     /*  902134 */     // GIR_Coverage, 61727,
     /*  902134 */     GIR_EraseRootFromParent_Done,
     /*  902135 */   // Label 13746: @902135
     /*  902135 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(902210), // Rule ID 61730 //
     /*  902140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  902189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902208 */     GIR_RootConstrainSelectedInstOperands,
     /*  902209 */     // GIR_Coverage, 61730,
     /*  902209 */     GIR_EraseRootFromParent_Done,
     /*  902210 */   // Label 13747: @902210
     /*  902210 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(902285), // Rule ID 61731 //
     /*  902215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  902223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  902226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  902229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  902232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  902250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  902264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902283 */     GIR_RootConstrainSelectedInstOperands,
     /*  902284 */     // GIR_Coverage, 61731,
     /*  902284 */     GIR_EraseRootFromParent_Done,
     /*  902285 */   // Label 13748: @902285
     /*  902285 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(902360), // Rule ID 61818 //
     /*  902290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  902310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  902339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902358 */     GIR_RootConstrainSelectedInstOperands,
     /*  902359 */     // GIR_Coverage, 61818,
     /*  902359 */     GIR_EraseRootFromParent_Done,
     /*  902360 */   // Label 13749: @902360
     /*  902360 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(902435), // Rule ID 61819 //
     /*  902365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  902376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  902379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  902382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  902385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902411 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  902414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902433 */     GIR_RootConstrainSelectedInstOperands,
     /*  902434 */     // GIR_Coverage, 61819,
     /*  902434 */     GIR_EraseRootFromParent_Done,
     /*  902435 */   // Label 13750: @902435
     /*  902435 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(902510), // Rule ID 61822 //
     /*  902440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  902460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902508 */     GIR_RootConstrainSelectedInstOperands,
     /*  902509 */     // GIR_Coverage, 61822,
     /*  902509 */     GIR_EraseRootFromParent_Done,
     /*  902510 */   // Label 13751: @902510
     /*  902510 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(902585), // Rule ID 61823 //
     /*  902515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  902526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  902529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  902532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  902535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902561 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902583 */     GIR_RootConstrainSelectedInstOperands,
     /*  902584 */     // GIR_Coverage, 61823,
     /*  902584 */     GIR_EraseRootFromParent_Done,
     /*  902585 */   // Label 13752: @902585
     /*  902585 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(902660), // Rule ID 61826 //
     /*  902590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  902610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902636 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902658 */     GIR_RootConstrainSelectedInstOperands,
     /*  902659 */     // GIR_Coverage, 61826,
     /*  902659 */     GIR_EraseRootFromParent_Done,
     /*  902660 */   // Label 13753: @902660
     /*  902660 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(902735), // Rule ID 61827 //
     /*  902665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  902685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902711 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902733 */     GIR_RootConstrainSelectedInstOperands,
     /*  902734 */     // GIR_Coverage, 61827,
     /*  902734 */     GIR_EraseRootFromParent_Done,
     /*  902735 */   // Label 13754: @902735
     /*  902735 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(902810), // Rule ID 61830 //
     /*  902740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  902760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902808 */     GIR_RootConstrainSelectedInstOperands,
     /*  902809 */     // GIR_Coverage, 61830,
     /*  902809 */     GIR_EraseRootFromParent_Done,
     /*  902810 */   // Label 13755: @902810
     /*  902810 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(902885), // Rule ID 61831 //
     /*  902815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  902835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  902864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902883 */     GIR_RootConstrainSelectedInstOperands,
     /*  902884 */     // GIR_Coverage, 61831,
     /*  902884 */     GIR_EraseRootFromParent_Done,
     /*  902885 */   // Label 13756: @902885
     /*  902885 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(902960), // Rule ID 61834 //
     /*  902890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  902910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902936 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  902939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902958 */     GIR_RootConstrainSelectedInstOperands,
     /*  902959 */     // GIR_Coverage, 61834,
     /*  902959 */     GIR_EraseRootFromParent_Done,
     /*  902960 */   // Label 13757: @902960
     /*  902960 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(903035), // Rule ID 61835 //
     /*  902965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  902985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903033 */     GIR_RootConstrainSelectedInstOperands,
     /*  903034 */     // GIR_Coverage, 61835,
     /*  903034 */     GIR_EraseRootFromParent_Done,
     /*  903035 */   // Label 13758: @903035
     /*  903035 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(903110), // Rule ID 61838 //
     /*  903040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  903060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903108 */     GIR_RootConstrainSelectedInstOperands,
     /*  903109 */     // GIR_Coverage, 61838,
     /*  903109 */     GIR_EraseRootFromParent_Done,
     /*  903110 */   // Label 13759: @903110
     /*  903110 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(903185), // Rule ID 61839 //
     /*  903115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  903126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  903129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  903132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  903135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  903164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903183 */     GIR_RootConstrainSelectedInstOperands,
     /*  903184 */     // GIR_Coverage, 61839,
     /*  903184 */     GIR_EraseRootFromParent_Done,
     /*  903185 */   // Label 13760: @903185
     /*  903185 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(903260), // Rule ID 61842 //
     /*  903190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  903210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903258 */     GIR_RootConstrainSelectedInstOperands,
     /*  903259 */     // GIR_Coverage, 61842,
     /*  903259 */     GIR_EraseRootFromParent_Done,
     /*  903260 */   // Label 13761: @903260
     /*  903260 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(903335), // Rule ID 61843 //
     /*  903265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  903276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  903279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  903282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  903285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903333 */     GIR_RootConstrainSelectedInstOperands,
     /*  903334 */     // GIR_Coverage, 61843,
     /*  903334 */     GIR_EraseRootFromParent_Done,
     /*  903335 */   // Label 13762: @903335
     /*  903335 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(903410), // Rule ID 61846 //
     /*  903340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  903360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903408 */     GIR_RootConstrainSelectedInstOperands,
     /*  903409 */     // GIR_Coverage, 61846,
     /*  903409 */     GIR_EraseRootFromParent_Done,
     /*  903410 */   // Label 13763: @903410
     /*  903410 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(903485), // Rule ID 61847 //
     /*  903415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  903426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  903429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  903432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  903435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903461 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903483 */     GIR_RootConstrainSelectedInstOperands,
     /*  903484 */     // GIR_Coverage, 61847,
     /*  903484 */     GIR_EraseRootFromParent_Done,
     /*  903485 */   // Label 13764: @903485
     /*  903485 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(903560), // Rule ID 61850 //
     /*  903490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  903510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903558 */     GIR_RootConstrainSelectedInstOperands,
     /*  903559 */     // GIR_Coverage, 61850,
     /*  903559 */     GIR_EraseRootFromParent_Done,
     /*  903560 */   // Label 13765: @903560
     /*  903560 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(903635), // Rule ID 61851 //
     /*  903565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  903585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903633 */     GIR_RootConstrainSelectedInstOperands,
     /*  903634 */     // GIR_Coverage, 61851,
     /*  903634 */     GIR_EraseRootFromParent_Done,
     /*  903635 */   // Label 13766: @903635
     /*  903635 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(903710), // Rule ID 61854 //
     /*  903640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  903660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903708 */     GIR_RootConstrainSelectedInstOperands,
     /*  903709 */     // GIR_Coverage, 61854,
     /*  903709 */     GIR_EraseRootFromParent_Done,
     /*  903710 */   // Label 13767: @903710
     /*  903710 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(903785), // Rule ID 61855 //
     /*  903715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  903735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903761 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  903764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903783 */     GIR_RootConstrainSelectedInstOperands,
     /*  903784 */     // GIR_Coverage, 61855,
     /*  903784 */     GIR_EraseRootFromParent_Done,
     /*  903785 */   // Label 13768: @903785
     /*  903785 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(903860), // Rule ID 61858 //
     /*  903790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  903810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  903839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903858 */     GIR_RootConstrainSelectedInstOperands,
     /*  903859 */     // GIR_Coverage, 61858,
     /*  903859 */     GIR_EraseRootFromParent_Done,
     /*  903860 */   // Label 13769: @903860
     /*  903860 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(903935), // Rule ID 61859 //
     /*  903865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  903885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903911 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  903914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903933 */     GIR_RootConstrainSelectedInstOperands,
     /*  903934 */     // GIR_Coverage, 61859,
     /*  903934 */     GIR_EraseRootFromParent_Done,
     /*  903935 */   // Label 13770: @903935
     /*  903935 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(904010), // Rule ID 61862 //
     /*  903940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  903960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903986 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  903989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904008 */     GIR_RootConstrainSelectedInstOperands,
     /*  904009 */     // GIR_Coverage, 61862,
     /*  904009 */     GIR_EraseRootFromParent_Done,
     /*  904010 */   // Label 13771: @904010
     /*  904010 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(904085), // Rule ID 61863 //
     /*  904015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  904026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  904029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  904032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  904035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904061 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904083 */     GIR_RootConstrainSelectedInstOperands,
     /*  904084 */     // GIR_Coverage, 61863,
     /*  904084 */     GIR_EraseRootFromParent_Done,
     /*  904085 */   // Label 13772: @904085
     /*  904085 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(904160), // Rule ID 61866 //
     /*  904090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  904110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  904136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904158 */     GIR_RootConstrainSelectedInstOperands,
     /*  904159 */     // GIR_Coverage, 61866,
     /*  904159 */     GIR_EraseRootFromParent_Done,
     /*  904160 */   // Label 13773: @904160
     /*  904160 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(904235), // Rule ID 61867 //
     /*  904165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  904176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  904179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  904182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  904185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904211 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  904211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  904230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904233 */     GIR_RootConstrainSelectedInstOperands,
     /*  904234 */     // GIR_Coverage, 61867,
     /*  904234 */     GIR_EraseRootFromParent_Done,
     /*  904235 */   // Label 13774: @904235
     /*  904235 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(904310), // Rule ID 61870 //
     /*  904240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  904260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904308 */     GIR_RootConstrainSelectedInstOperands,
     /*  904309 */     // GIR_Coverage, 61870,
     /*  904309 */     GIR_EraseRootFromParent_Done,
     /*  904310 */   // Label 13775: @904310
     /*  904310 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(904385), // Rule ID 61871 //
     /*  904315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  904326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  904329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  904332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  904335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904383 */     GIR_RootConstrainSelectedInstOperands,
     /*  904384 */     // GIR_Coverage, 61871,
     /*  904384 */     GIR_EraseRootFromParent_Done,
     /*  904385 */   // Label 13776: @904385
     /*  904385 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(904460), // Rule ID 61874 //
     /*  904390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  904410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904458 */     GIR_RootConstrainSelectedInstOperands,
     /*  904459 */     // GIR_Coverage, 61874,
     /*  904459 */     GIR_EraseRootFromParent_Done,
     /*  904460 */   // Label 13777: @904460
     /*  904460 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(904535), // Rule ID 61875 //
     /*  904465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  904476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  904479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  904482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  904485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904533 */     GIR_RootConstrainSelectedInstOperands,
     /*  904534 */     // GIR_Coverage, 61875,
     /*  904534 */     GIR_EraseRootFromParent_Done,
     /*  904535 */   // Label 13778: @904535
     /*  904535 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(904610), // Rule ID 61878 //
     /*  904540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  904560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904608 */     GIR_RootConstrainSelectedInstOperands,
     /*  904609 */     // GIR_Coverage, 61878,
     /*  904609 */     GIR_EraseRootFromParent_Done,
     /*  904610 */   // Label 13779: @904610
     /*  904610 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(904685), // Rule ID 61879 //
     /*  904615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  904635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904661 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  904664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904683 */     GIR_RootConstrainSelectedInstOperands,
     /*  904684 */     // GIR_Coverage, 61879,
     /*  904684 */     GIR_EraseRootFromParent_Done,
     /*  904685 */   // Label 13780: @904685
     /*  904685 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(904760), // Rule ID 61882 //
     /*  904690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904758 */     GIR_RootConstrainSelectedInstOperands,
     /*  904759 */     // GIR_Coverage, 61882,
     /*  904759 */     GIR_EraseRootFromParent_Done,
     /*  904760 */   // Label 13781: @904760
     /*  904760 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(904835), // Rule ID 61883 //
     /*  904765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  904814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904833 */     GIR_RootConstrainSelectedInstOperands,
     /*  904834 */     // GIR_Coverage, 61883,
     /*  904834 */     GIR_EraseRootFromParent_Done,
     /*  904835 */   // Label 13782: @904835
     /*  904835 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(904910), // Rule ID 61886 //
     /*  904840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904908 */     GIR_RootConstrainSelectedInstOperands,
     /*  904909 */     // GIR_Coverage, 61886,
     /*  904909 */     GIR_EraseRootFromParent_Done,
     /*  904910 */   // Label 13783: @904910
     /*  904910 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(904985), // Rule ID 61887 //
     /*  904915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  904964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904983 */     GIR_RootConstrainSelectedInstOperands,
     /*  904984 */     // GIR_Coverage, 61887,
     /*  904984 */     GIR_EraseRootFromParent_Done,
     /*  904985 */   // Label 13784: @904985
     /*  904985 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(905060), // Rule ID 61890 //
     /*  904990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905058 */     GIR_RootConstrainSelectedInstOperands,
     /*  905059 */     // GIR_Coverage, 61890,
     /*  905059 */     GIR_EraseRootFromParent_Done,
     /*  905060 */   // Label 13785: @905060
     /*  905060 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(905135), // Rule ID 61891 //
     /*  905065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905133 */     GIR_RootConstrainSelectedInstOperands,
     /*  905134 */     // GIR_Coverage, 61891,
     /*  905134 */     GIR_EraseRootFromParent_Done,
     /*  905135 */   // Label 13786: @905135
     /*  905135 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(905210), // Rule ID 61894 //
     /*  905140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  905160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  905189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905208 */     GIR_RootConstrainSelectedInstOperands,
     /*  905209 */     // GIR_Coverage, 61894,
     /*  905209 */     GIR_EraseRootFromParent_Done,
     /*  905210 */   // Label 13787: @905210
     /*  905210 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(905285), // Rule ID 61895 //
     /*  905215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  905226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  905229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  905232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  905235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  905264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905283 */     GIR_RootConstrainSelectedInstOperands,
     /*  905284 */     // GIR_Coverage, 61895,
     /*  905284 */     GIR_EraseRootFromParent_Done,
     /*  905285 */   // Label 13788: @905285
     /*  905285 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(905360), // Rule ID 61898 //
     /*  905290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  905310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  905339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905358 */     GIR_RootConstrainSelectedInstOperands,
     /*  905359 */     // GIR_Coverage, 61898,
     /*  905359 */     GIR_EraseRootFromParent_Done,
     /*  905360 */   // Label 13789: @905360
     /*  905360 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(905435), // Rule ID 61899 //
     /*  905365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  905376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  905379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  905382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  905385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905411 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  905414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905433 */     GIR_RootConstrainSelectedInstOperands,
     /*  905434 */     // GIR_Coverage, 61899,
     /*  905434 */     GIR_EraseRootFromParent_Done,
     /*  905435 */   // Label 13790: @905435
     /*  905435 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(905510), // Rule ID 61902 //
     /*  905440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  905460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905486 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  905486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905508 */     GIR_RootConstrainSelectedInstOperands,
     /*  905509 */     // GIR_Coverage, 61902,
     /*  905509 */     GIR_EraseRootFromParent_Done,
     /*  905510 */   // Label 13791: @905510
     /*  905510 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(905585), // Rule ID 61903 //
     /*  905515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  905526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  905529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  905532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  905535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905561 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  905564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905583 */     GIR_RootConstrainSelectedInstOperands,
     /*  905584 */     // GIR_Coverage, 61903,
     /*  905584 */     GIR_EraseRootFromParent_Done,
     /*  905585 */   // Label 13792: @905585
     /*  905585 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(905660), // Rule ID 61906 //
     /*  905590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  905604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  905639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905658 */     GIR_RootConstrainSelectedInstOperands,
     /*  905659 */     // GIR_Coverage, 61906,
     /*  905659 */     GIR_EraseRootFromParent_Done,
     /*  905660 */   // Label 13793: @905660
     /*  905660 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(905735), // Rule ID 61907 //
     /*  905665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  905679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905711 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  905711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  905714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905733 */     GIR_RootConstrainSelectedInstOperands,
     /*  905734 */     // GIR_Coverage, 61907,
     /*  905734 */     GIR_EraseRootFromParent_Done,
     /*  905735 */   // Label 13794: @905735
     /*  905735 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(905810), // Rule ID 61910 //
     /*  905740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  905754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  905789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905808 */     GIR_RootConstrainSelectedInstOperands,
     /*  905809 */     // GIR_Coverage, 61910,
     /*  905809 */     GIR_EraseRootFromParent_Done,
     /*  905810 */   // Label 13795: @905810
     /*  905810 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(905885), // Rule ID 61911 //
     /*  905815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  905829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905861 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  905861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  905864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905883 */     GIR_RootConstrainSelectedInstOperands,
     /*  905884 */     // GIR_Coverage, 61911,
     /*  905884 */     GIR_EraseRootFromParent_Done,
     /*  905885 */   // Label 13796: @905885
     /*  905885 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(905960), // Rule ID 61914 //
     /*  905890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  905893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  905901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  905904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  905910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905936 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  905936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  905939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905958 */     GIR_RootConstrainSelectedInstOperands,
     /*  905959 */     // GIR_Coverage, 61914,
     /*  905959 */     GIR_EraseRootFromParent_Done,
     /*  905960 */   // Label 13797: @905960
     /*  905960 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(906035), // Rule ID 61915 //
     /*  905965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  905968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  905973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  905976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  905979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  905982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906011 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  906011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906033 */     GIR_RootConstrainSelectedInstOperands,
     /*  906034 */     // GIR_Coverage, 61915,
     /*  906034 */     GIR_EraseRootFromParent_Done,
     /*  906035 */   // Label 13798: @906035
     /*  906035 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(906110), // Rule ID 61918 //
     /*  906040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  906089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906108 */     GIR_RootConstrainSelectedInstOperands,
     /*  906109 */     // GIR_Coverage, 61918,
     /*  906109 */     GIR_EraseRootFromParent_Done,
     /*  906110 */   // Label 13799: @906110
     /*  906110 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(906185), // Rule ID 61919 //
     /*  906115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  906129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906161 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  906164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906183 */     GIR_RootConstrainSelectedInstOperands,
     /*  906184 */     // GIR_Coverage, 61919,
     /*  906184 */     GIR_EraseRootFromParent_Done,
     /*  906185 */   // Label 13800: @906185
     /*  906185 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(906260), // Rule ID 61922 //
     /*  906190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906258 */     GIR_RootConstrainSelectedInstOperands,
     /*  906259 */     // GIR_Coverage, 61922,
     /*  906259 */     GIR_EraseRootFromParent_Done,
     /*  906260 */   // Label 13801: @906260
     /*  906260 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(906335), // Rule ID 61923 //
     /*  906265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  906279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906333 */     GIR_RootConstrainSelectedInstOperands,
     /*  906334 */     // GIR_Coverage, 61923,
     /*  906334 */     GIR_EraseRootFromParent_Done,
     /*  906335 */   // Label 13802: @906335
     /*  906335 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(906410), // Rule ID 61926 //
     /*  906340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  906354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906408 */     GIR_RootConstrainSelectedInstOperands,
     /*  906409 */     // GIR_Coverage, 61926,
     /*  906409 */     GIR_EraseRootFromParent_Done,
     /*  906410 */   // Label 13803: @906410
     /*  906410 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(906485), // Rule ID 61927 //
     /*  906415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  906429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906461 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  906464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906483 */     GIR_RootConstrainSelectedInstOperands,
     /*  906484 */     // GIR_Coverage, 61927,
     /*  906484 */     GIR_EraseRootFromParent_Done,
     /*  906485 */   // Label 13804: @906485
     /*  906485 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(906560), // Rule ID 61930 //
     /*  906490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  906504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  906536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906558 */     GIR_RootConstrainSelectedInstOperands,
     /*  906559 */     // GIR_Coverage, 61930,
     /*  906559 */     GIR_EraseRootFromParent_Done,
     /*  906560 */   // Label 13805: @906560
     /*  906560 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(906635), // Rule ID 61931 //
     /*  906565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  906579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906611 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  906611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906633 */     GIR_RootConstrainSelectedInstOperands,
     /*  906634 */     // GIR_Coverage, 61931,
     /*  906634 */     GIR_EraseRootFromParent_Done,
     /*  906635 */   // Label 13806: @906635
     /*  906635 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(906710), // Rule ID 61934 //
     /*  906640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906686 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  906686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906708 */     GIR_RootConstrainSelectedInstOperands,
     /*  906709 */     // GIR_Coverage, 61934,
     /*  906709 */     GIR_EraseRootFromParent_Done,
     /*  906710 */   // Label 13807: @906710
     /*  906710 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(906785), // Rule ID 61935 //
     /*  906715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  906729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906761 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  906761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906783 */     GIR_RootConstrainSelectedInstOperands,
     /*  906784 */     // GIR_Coverage, 61935,
     /*  906784 */     GIR_EraseRootFromParent_Done,
     /*  906785 */   // Label 13808: @906785
     /*  906785 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(906860), // Rule ID 61938 //
     /*  906790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  906801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  906804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  906807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  906836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906858 */     GIR_RootConstrainSelectedInstOperands,
     /*  906859 */     // GIR_Coverage, 61938,
     /*  906859 */     GIR_EraseRootFromParent_Done,
     /*  906860 */   // Label 13809: @906860
     /*  906860 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(906935), // Rule ID 61939 //
     /*  906865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  906868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  906876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  906879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  906882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  906888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  906911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  906933 */     GIR_RootConstrainSelectedInstOperands,
     /*  906934 */     // GIR_Coverage, 61939,
     /*  906934 */     GIR_EraseRootFromParent_Done,
     /*  906935 */   // Label 13810: @906935
     /*  906935 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(907010), // Rule ID 61942 //
     /*  906940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  906943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  906948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  906951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  906954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  906957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  906960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  906963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906986 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  906986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  906989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  906993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  906995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  906997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907008 */     GIR_RootConstrainSelectedInstOperands,
     /*  907009 */     // GIR_Coverage, 61942,
     /*  907009 */     GIR_EraseRootFromParent_Done,
     /*  907010 */   // Label 13811: @907010
     /*  907010 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(907085), // Rule ID 61943 //
     /*  907015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  907029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907061 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  907061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  907064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907083 */     GIR_RootConstrainSelectedInstOperands,
     /*  907084 */     // GIR_Coverage, 61943,
     /*  907084 */     GIR_EraseRootFromParent_Done,
     /*  907085 */   // Label 13812: @907085
     /*  907085 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(907160), // Rule ID 61946 //
     /*  907090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  907104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907158 */     GIR_RootConstrainSelectedInstOperands,
     /*  907159 */     // GIR_Coverage, 61946,
     /*  907159 */     GIR_EraseRootFromParent_Done,
     /*  907160 */   // Label 13813: @907160
     /*  907160 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(907235), // Rule ID 61947 //
     /*  907165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  907179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907233 */     GIR_RootConstrainSelectedInstOperands,
     /*  907234 */     // GIR_Coverage, 61947,
     /*  907234 */     GIR_EraseRootFromParent_Done,
     /*  907235 */   // Label 13814: @907235
     /*  907235 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(907310), // Rule ID 61950 //
     /*  907240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  907254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907308 */     GIR_RootConstrainSelectedInstOperands,
     /*  907309 */     // GIR_Coverage, 61950,
     /*  907309 */     GIR_EraseRootFromParent_Done,
     /*  907310 */   // Label 13815: @907310
     /*  907310 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(907385), // Rule ID 61951 //
     /*  907315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  907329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907361 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907383 */     GIR_RootConstrainSelectedInstOperands,
     /*  907384 */     // GIR_Coverage, 61951,
     /*  907384 */     GIR_EraseRootFromParent_Done,
     /*  907385 */   // Label 13816: @907385
     /*  907385 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(907460), // Rule ID 61954 //
     /*  907390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  907404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907436 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  907436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907458 */     GIR_RootConstrainSelectedInstOperands,
     /*  907459 */     // GIR_Coverage, 61954,
     /*  907459 */     GIR_EraseRootFromParent_Done,
     /*  907460 */   // Label 13817: @907460
     /*  907460 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(907535), // Rule ID 61955 //
     /*  907465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  907479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907511 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  907511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907533 */     GIR_RootConstrainSelectedInstOperands,
     /*  907534 */     // GIR_Coverage, 61955,
     /*  907534 */     GIR_EraseRootFromParent_Done,
     /*  907535 */   // Label 13818: @907535
     /*  907535 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(907610), // Rule ID 61958 //
     /*  907540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  907554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907608 */     GIR_RootConstrainSelectedInstOperands,
     /*  907609 */     // GIR_Coverage, 61958,
     /*  907609 */     GIR_EraseRootFromParent_Done,
     /*  907610 */   // Label 13819: @907610
     /*  907610 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(907685), // Rule ID 61959 //
     /*  907615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  907629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  907664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907683 */     GIR_RootConstrainSelectedInstOperands,
     /*  907684 */     // GIR_Coverage, 61959,
     /*  907684 */     GIR_EraseRootFromParent_Done,
     /*  907685 */   // Label 13820: @907685
     /*  907685 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(907760), // Rule ID 61962 //
     /*  907690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  907701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  907704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907758 */     GIR_RootConstrainSelectedInstOperands,
     /*  907759 */     // GIR_Coverage, 61962,
     /*  907759 */     GIR_EraseRootFromParent_Done,
     /*  907760 */   // Label 13821: @907760
     /*  907760 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(907835), // Rule ID 61963 //
     /*  907765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  907776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  907779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907811 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  907814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907833 */     GIR_RootConstrainSelectedInstOperands,
     /*  907834 */     // GIR_Coverage, 61963,
     /*  907834 */     GIR_EraseRootFromParent_Done,
     /*  907835 */   // Label 13822: @907835
     /*  907835 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(907910), // Rule ID 61966 //
     /*  907840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  907851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  907854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  907857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  907860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  907863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907886 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  907886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907908 */     GIR_RootConstrainSelectedInstOperands,
     /*  907909 */     // GIR_Coverage, 61966,
     /*  907909 */     GIR_EraseRootFromParent_Done,
     /*  907910 */   // Label 13823: @907910
     /*  907910 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(907985), // Rule ID 61967 //
     /*  907915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  907918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  907926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  907929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  907932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  907935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  907938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  907954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  907961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  907964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  907968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  907970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  907972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  907983 */     GIR_RootConstrainSelectedInstOperands,
     /*  907984 */     // GIR_Coverage, 61967,
     /*  907984 */     GIR_EraseRootFromParent_Done,
     /*  907985 */   // Label 13824: @907985
     /*  907985 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(908060), // Rule ID 61970 //
     /*  907990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  907993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  907998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908058 */     GIR_RootConstrainSelectedInstOperands,
     /*  908059 */     // GIR_Coverage, 61970,
     /*  908059 */     GIR_EraseRootFromParent_Done,
     /*  908060 */   // Label 13825: @908060
     /*  908060 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(908135), // Rule ID 61971 //
     /*  908065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  908079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908133 */     GIR_RootConstrainSelectedInstOperands,
     /*  908134 */     // GIR_Coverage, 61971,
     /*  908134 */     GIR_EraseRootFromParent_Done,
     /*  908135 */   // Label 13826: @908135
     /*  908135 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(908210), // Rule ID 61974 //
     /*  908140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908208 */     GIR_RootConstrainSelectedInstOperands,
     /*  908209 */     // GIR_Coverage, 61974,
     /*  908209 */     GIR_EraseRootFromParent_Done,
     /*  908210 */   // Label 13827: @908210
     /*  908210 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(908285), // Rule ID 61975 //
     /*  908215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  908229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908261 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908283 */     GIR_RootConstrainSelectedInstOperands,
     /*  908284 */     // GIR_Coverage, 61975,
     /*  908284 */     GIR_EraseRootFromParent_Done,
     /*  908285 */   // Label 13828: @908285
     /*  908285 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(908360), // Rule ID 61978 //
     /*  908290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  908304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908358 */     GIR_RootConstrainSelectedInstOperands,
     /*  908359 */     // GIR_Coverage, 61978,
     /*  908359 */     GIR_EraseRootFromParent_Done,
     /*  908360 */   // Label 13829: @908360
     /*  908360 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(908435), // Rule ID 61979 //
     /*  908365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  908379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908411 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  908411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908433 */     GIR_RootConstrainSelectedInstOperands,
     /*  908434 */     // GIR_Coverage, 61979,
     /*  908434 */     GIR_EraseRootFromParent_Done,
     /*  908435 */   // Label 13830: @908435
     /*  908435 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(908510), // Rule ID 61982 //
     /*  908440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  908454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908486 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908508 */     GIR_RootConstrainSelectedInstOperands,
     /*  908509 */     // GIR_Coverage, 61982,
     /*  908509 */     GIR_EraseRootFromParent_Done,
     /*  908510 */   // Label 13831: @908510
     /*  908510 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(908585), // Rule ID 61983 //
     /*  908515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  908529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  908564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908583 */     GIR_RootConstrainSelectedInstOperands,
     /*  908584 */     // GIR_Coverage, 61983,
     /*  908584 */     GIR_EraseRootFromParent_Done,
     /*  908585 */   // Label 13832: @908585
     /*  908585 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(908660), // Rule ID 61986 //
     /*  908590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  908607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908658 */     GIR_RootConstrainSelectedInstOperands,
     /*  908659 */     // GIR_Coverage, 61986,
     /*  908659 */     GIR_EraseRootFromParent_Done,
     /*  908660 */   // Label 13833: @908660
     /*  908660 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(908735), // Rule ID 61987 //
     /*  908665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  908679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  908682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  908714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908733 */     GIR_RootConstrainSelectedInstOperands,
     /*  908734 */     // GIR_Coverage, 61987,
     /*  908734 */     GIR_EraseRootFromParent_Done,
     /*  908735 */   // Label 13834: @908735
     /*  908735 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(908810), // Rule ID 61990 //
     /*  908740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  908743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  908757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  908760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  908786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908808 */     GIR_RootConstrainSelectedInstOperands,
     /*  908809 */     // GIR_Coverage, 61990,
     /*  908809 */     GIR_EraseRootFromParent_Done,
     /*  908810 */   // Label 13835: @908810
     /*  908810 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(908885), // Rule ID 61991 //
     /*  908815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  908818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  908823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  908826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  908829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  908832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  908835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  908854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908861 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  908861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  908864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908883 */     GIR_RootConstrainSelectedInstOperands,
     /*  908884 */     // GIR_Coverage, 61991,
     /*  908884 */     GIR_EraseRootFromParent_Done,
     /*  908885 */   // Label 13836: @908885
     /*  908885 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(908960), // Rule ID 62434 //
     /*  908890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  908893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  908898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  908913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  908936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  908939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  908943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  908945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  908947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  908958 */     GIR_RootConstrainSelectedInstOperands,
     /*  908959 */     // GIR_Coverage, 62434,
     /*  908959 */     GIR_EraseRootFromParent_Done,
     /*  908960 */   // Label 13837: @908960
     /*  908960 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(909035), // Rule ID 62435 //
     /*  908965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  908968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  908973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  908976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  908979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  908982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  908985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  908988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  908996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909011 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  909014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909033 */     GIR_RootConstrainSelectedInstOperands,
     /*  909034 */     // GIR_Coverage, 62435,
     /*  909034 */     GIR_EraseRootFromParent_Done,
     /*  909035 */   // Label 13838: @909035
     /*  909035 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(909110), // Rule ID 62436 //
     /*  909040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  909054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  909089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909108 */     GIR_RootConstrainSelectedInstOperands,
     /*  909109 */     // GIR_Coverage, 62436,
     /*  909109 */     GIR_EraseRootFromParent_Done,
     /*  909110 */   // Label 13839: @909110
     /*  909110 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(909185), // Rule ID 62437 //
     /*  909115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  909126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  909129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  909132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  909135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  909164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909183 */     GIR_RootConstrainSelectedInstOperands,
     /*  909184 */     // GIR_Coverage, 62437,
     /*  909184 */     GIR_EraseRootFromParent_Done,
     /*  909185 */   // Label 13840: @909185
     /*  909185 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(909260), // Rule ID 62438 //
     /*  909190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  909204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  909239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909258 */     GIR_RootConstrainSelectedInstOperands,
     /*  909259 */     // GIR_Coverage, 62438,
     /*  909259 */     GIR_EraseRootFromParent_Done,
     /*  909260 */   // Label 13841: @909260
     /*  909260 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(909335), // Rule ID 62439 //
     /*  909265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  909279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909311 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  909314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909333 */     GIR_RootConstrainSelectedInstOperands,
     /*  909334 */     // GIR_Coverage, 62439,
     /*  909334 */     GIR_EraseRootFromParent_Done,
     /*  909335 */   // Label 13842: @909335
     /*  909335 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(909410), // Rule ID 62440 //
     /*  909340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  909343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  909363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909386 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  909386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  909389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909408 */     GIR_RootConstrainSelectedInstOperands,
     /*  909409 */     // GIR_Coverage, 62440,
     /*  909409 */     GIR_EraseRootFromParent_Done,
     /*  909410 */   // Label 13843: @909410
     /*  909410 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(909485), // Rule ID 62441 //
     /*  909415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  909418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  909423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  909429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  909438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  909461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  909464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  909468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  909470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  909472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  909483 */     GIR_RootConstrainSelectedInstOperands,
     /*  909484 */     // GIR_Coverage, 62441,
     /*  909484 */     GIR_EraseRootFromParent_Done,
     /*  909485 */   // Label 13844: @909485
     /*  909485 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(909549), // Rule ID 64510 //
     /*  909490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  909498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909526 */     // MIs[0] imm5
     /*  909526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909534 */     // (intrinsic_wo_chain:{ *:[i32] } 10947:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  909537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909545 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909547 */     GIR_RootConstrainSelectedInstOperands,
     /*  909548 */     // GIR_Coverage, 64510,
     /*  909548 */     GIR_EraseRootFromParent_Done,
     /*  909549 */   // Label 13845: @909549
     /*  909549 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(909613), // Rule ID 64511 //
     /*  909554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  909562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909590 */     // MIs[0] imm5
     /*  909590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909598 */     // (intrinsic_wo_chain:{ *:[i32] } 10943:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  909601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909609 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909611 */     GIR_RootConstrainSelectedInstOperands,
     /*  909612 */     // GIR_Coverage, 64511,
     /*  909612 */     GIR_EraseRootFromParent_Done,
     /*  909613 */   // Label 13846: @909613
     /*  909613 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(909677), // Rule ID 64512 //
     /*  909618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  909626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909654 */     // MIs[0] imm5
     /*  909654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909662 */     // (intrinsic_wo_chain:{ *:[i32] } 10945:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  909665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909673 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909675 */     GIR_RootConstrainSelectedInstOperands,
     /*  909676 */     // GIR_Coverage, 64512,
     /*  909676 */     GIR_EraseRootFromParent_Done,
     /*  909677 */   // Label 13847: @909677
     /*  909677 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(909741), // Rule ID 64513 //
     /*  909682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  909690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909718 */     // MIs[0] imm5
     /*  909718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909726 */     // (intrinsic_wo_chain:{ *:[i32] } 10941:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  909729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909737 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909739 */     GIR_RootConstrainSelectedInstOperands,
     /*  909740 */     // GIR_Coverage, 64513,
     /*  909740 */     GIR_EraseRootFromParent_Done,
     /*  909741 */   // Label 13848: @909741
     /*  909741 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(909805), // Rule ID 64514 //
     /*  909746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  909754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909782 */     // MIs[0] imm5
     /*  909782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909790 */     // (intrinsic_wo_chain:{ *:[i32] } 10948:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  909793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909801 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909803 */     GIR_RootConstrainSelectedInstOperands,
     /*  909804 */     // GIR_Coverage, 64514,
     /*  909804 */     GIR_EraseRootFromParent_Done,
     /*  909805 */   // Label 13849: @909805
     /*  909805 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(909869), // Rule ID 64515 //
     /*  909810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  909818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909846 */     // MIs[0] imm5
     /*  909846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909854 */     // (intrinsic_wo_chain:{ *:[i32] } 10944:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  909857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909865 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909867 */     GIR_RootConstrainSelectedInstOperands,
     /*  909868 */     // GIR_Coverage, 64515,
     /*  909868 */     GIR_EraseRootFromParent_Done,
     /*  909869 */   // Label 13850: @909869
     /*  909869 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(909933), // Rule ID 64516 //
     /*  909874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  909882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909910 */     // MIs[0] imm5
     /*  909910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909918 */     // (intrinsic_wo_chain:{ *:[i32] } 10946:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  909921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909929 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909931 */     GIR_RootConstrainSelectedInstOperands,
     /*  909932 */     // GIR_Coverage, 64516,
     /*  909932 */     GIR_EraseRootFromParent_Done,
     /*  909933 */   // Label 13851: @909933
     /*  909933 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(909997), // Rule ID 64517 //
     /*  909938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  909941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  909946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  909949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  909952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  909955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  909958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  909974 */     // MIs[0] imm5
     /*  909974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  909982 */     // (intrinsic_wo_chain:{ *:[i32] } 10942:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  909982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  909985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  909987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  909989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  909991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  909993 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  909995 */     GIR_RootConstrainSelectedInstOperands,
     /*  909996 */     // GIR_Coverage, 64517,
     /*  909996 */     GIR_EraseRootFromParent_Done,
     /*  909997 */   // Label 13852: @909997
     /*  909997 */   GIM_Reject,
     /*  909998 */ // Label 7006: @909998
     /*  909998 */ GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(1399471),
     /*  910003 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  910006 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(910089), // Rule ID 62849 //
     /*  910011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  910022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  910025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910035 */     // MIs[0] op1
     /*  910035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910051 */     // MIs[0] op4
     /*  910051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  910069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910077 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910087 */     GIR_RootConstrainSelectedInstOperands,
     /*  910088 */     // GIR_Coverage, 62849,
     /*  910088 */     GIR_EraseRootFromParent_Done,
     /*  910089 */   // Label 13854: @910089
     /*  910089 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(910172), // Rule ID 62850 //
     /*  910094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  910105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  910108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  910111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910118 */     // MIs[0] op1
     /*  910118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910134 */     // MIs[0] op4
     /*  910134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  910152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910154 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910156 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910158 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910160 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910170 */     GIR_RootConstrainSelectedInstOperands,
     /*  910171 */     // GIR_Coverage, 62850,
     /*  910171 */     GIR_EraseRootFromParent_Done,
     /*  910172 */   // Label 13855: @910172
     /*  910172 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(910255), // Rule ID 62893 //
     /*  910177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910201 */     // MIs[0] op1
     /*  910201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910217 */     // MIs[0] op4
     /*  910217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910237 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910239 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910241 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910243 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910253 */     GIR_RootConstrainSelectedInstOperands,
     /*  910254 */     // GIR_Coverage, 62893,
     /*  910254 */     GIR_EraseRootFromParent_Done,
     /*  910255 */   // Label 13856: @910255
     /*  910255 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(910338), // Rule ID 62894 //
     /*  910260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  910271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  910274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910284 */     // MIs[0] op1
     /*  910284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910300 */     // MIs[0] op4
     /*  910300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910315 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910320 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910322 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910324 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910326 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910336 */     GIR_RootConstrainSelectedInstOperands,
     /*  910337 */     // GIR_Coverage, 62894,
     /*  910337 */     GIR_EraseRootFromParent_Done,
     /*  910338 */   // Label 13857: @910338
     /*  910338 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(910421), // Rule ID 62937 //
     /*  910343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910367 */     // MIs[0] op1
     /*  910367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910383 */     // MIs[0] op4
     /*  910383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910398 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910403 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910405 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910407 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910409 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910419 */     GIR_RootConstrainSelectedInstOperands,
     /*  910420 */     // GIR_Coverage, 62937,
     /*  910420 */     GIR_EraseRootFromParent_Done,
     /*  910421 */   // Label 13858: @910421
     /*  910421 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(910504), // Rule ID 62938 //
     /*  910426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  910437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  910440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910450 */     // MIs[0] op1
     /*  910450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910466 */     // MIs[0] op4
     /*  910466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910481 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910502 */     GIR_RootConstrainSelectedInstOperands,
     /*  910503 */     // GIR_Coverage, 62938,
     /*  910503 */     GIR_EraseRootFromParent_Done,
     /*  910504 */   // Label 13859: @910504
     /*  910504 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(910587), // Rule ID 62981 //
     /*  910509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910533 */     // MIs[0] op1
     /*  910533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910549 */     // MIs[0] op4
     /*  910549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910564 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910575 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910585 */     GIR_RootConstrainSelectedInstOperands,
     /*  910586 */     // GIR_Coverage, 62981,
     /*  910586 */     GIR_EraseRootFromParent_Done,
     /*  910587 */   // Label 13860: @910587
     /*  910587 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(910670), // Rule ID 62982 //
     /*  910592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  910603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  910606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910616 */     // MIs[0] op1
     /*  910616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910632 */     // MIs[0] op4
     /*  910632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910647 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  910650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910668 */     GIR_RootConstrainSelectedInstOperands,
     /*  910669 */     // GIR_Coverage, 62982,
     /*  910669 */     GIR_EraseRootFromParent_Done,
     /*  910670 */   // Label 13861: @910670
     /*  910670 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(910753), // Rule ID 63037 //
     /*  910675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910699 */     // MIs[0] op1
     /*  910699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910715 */     // MIs[0] op4
     /*  910715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910735 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910737 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910739 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910741 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910751 */     GIR_RootConstrainSelectedInstOperands,
     /*  910752 */     // GIR_Coverage, 63037,
     /*  910752 */     GIR_EraseRootFromParent_Done,
     /*  910753 */   // Label 13862: @910753
     /*  910753 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(910836), // Rule ID 63038 //
     /*  910758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910782 */     // MIs[0] op1
     /*  910782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910798 */     // MIs[0] op4
     /*  910798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910813 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910834 */     GIR_RootConstrainSelectedInstOperands,
     /*  910835 */     // GIR_Coverage, 63038,
     /*  910835 */     GIR_EraseRootFromParent_Done,
     /*  910836 */   // Label 13863: @910836
     /*  910836 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(910919), // Rule ID 63093 //
     /*  910841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  910858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910865 */     // MIs[0] op1
     /*  910865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910881 */     // MIs[0] op4
     /*  910881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910896 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  910896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910907 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  910917 */     GIR_RootConstrainSelectedInstOperands,
     /*  910918 */     // GIR_Coverage, 63093,
     /*  910918 */     GIR_EraseRootFromParent_Done,
     /*  910919 */   // Label 13864: @910919
     /*  910919 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(911002), // Rule ID 63094 //
     /*  910924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  910932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  910941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910948 */     // MIs[0] op1
     /*  910948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910964 */     // MIs[0] op4
     /*  910964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  910979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  910982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910984 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910986 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910988 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910990 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911000 */     GIR_RootConstrainSelectedInstOperands,
     /*  911001 */     // GIR_Coverage, 63094,
     /*  911001 */     GIR_EraseRootFromParent_Done,
     /*  911002 */   // Label 13865: @911002
     /*  911002 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(911085), // Rule ID 63149 //
     /*  911007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911031 */     // MIs[0] op1
     /*  911031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911047 */     // MIs[0] op4
     /*  911047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911067 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911069 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911071 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911073 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911083 */     GIR_RootConstrainSelectedInstOperands,
     /*  911084 */     // GIR_Coverage, 63149,
     /*  911084 */     GIR_EraseRootFromParent_Done,
     /*  911085 */   // Label 13866: @911085
     /*  911085 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(911168), // Rule ID 63150 //
     /*  911090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  911101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  911104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  911107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911114 */     // MIs[0] op1
     /*  911114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911130 */     // MIs[0] op4
     /*  911130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911166 */     GIR_RootConstrainSelectedInstOperands,
     /*  911167 */     // GIR_Coverage, 63150,
     /*  911167 */     GIR_EraseRootFromParent_Done,
     /*  911168 */   // Label 13867: @911168
     /*  911168 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(911251), // Rule ID 63193 //
     /*  911173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911197 */     // MIs[0] op1
     /*  911197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911213 */     // MIs[0] op4
     /*  911213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911239 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911249 */     GIR_RootConstrainSelectedInstOperands,
     /*  911250 */     // GIR_Coverage, 63193,
     /*  911250 */     GIR_EraseRootFromParent_Done,
     /*  911251 */   // Label 13868: @911251
     /*  911251 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(911334), // Rule ID 63194 //
     /*  911256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  911267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  911270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911280 */     // MIs[0] op1
     /*  911280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911296 */     // MIs[0] op4
     /*  911296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911299 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911311 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911332 */     GIR_RootConstrainSelectedInstOperands,
     /*  911333 */     // GIR_Coverage, 63194,
     /*  911333 */     GIR_EraseRootFromParent_Done,
     /*  911334 */   // Label 13869: @911334
     /*  911334 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(911417), // Rule ID 63249 //
     /*  911339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911363 */     // MIs[0] op1
     /*  911363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911379 */     // MIs[0] op4
     /*  911379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911399 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911401 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911403 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911405 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911415 */     GIR_RootConstrainSelectedInstOperands,
     /*  911416 */     // GIR_Coverage, 63249,
     /*  911416 */     GIR_EraseRootFromParent_Done,
     /*  911417 */   // Label 13870: @911417
     /*  911417 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(911500), // Rule ID 63250 //
     /*  911422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911446 */     // MIs[0] op1
     /*  911446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911462 */     // MIs[0] op4
     /*  911462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911488 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911498 */     GIR_RootConstrainSelectedInstOperands,
     /*  911499 */     // GIR_Coverage, 63250,
     /*  911499 */     GIR_EraseRootFromParent_Done,
     /*  911500 */   // Label 13871: @911500
     /*  911500 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(911583), // Rule ID 63305 //
     /*  911505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911529 */     // MIs[0] op1
     /*  911529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911545 */     // MIs[0] op4
     /*  911545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  911560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911571 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911581 */     GIR_RootConstrainSelectedInstOperands,
     /*  911582 */     // GIR_Coverage, 63305,
     /*  911582 */     GIR_EraseRootFromParent_Done,
     /*  911583 */   // Label 13872: @911583
     /*  911583 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(911666), // Rule ID 63306 //
     /*  911588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  911605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911612 */     // MIs[0] op1
     /*  911612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911628 */     // MIs[0] op4
     /*  911628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  911643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  911646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911648 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911650 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911652 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911654 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  911664 */     GIR_RootConstrainSelectedInstOperands,
     /*  911665 */     // GIR_Coverage, 63306,
     /*  911665 */     GIR_EraseRootFromParent_Done,
     /*  911666 */   // Label 13873: @911666
     /*  911666 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(911749), // Rule ID 63361 //
     /*  911671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911695 */     // MIs[0] op1
     /*  911695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911711 */     // MIs[0] op4
     /*  911711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  911729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911731 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911733 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911735 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911737 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911747 */     GIR_RootConstrainSelectedInstOperands,
     /*  911748 */     // GIR_Coverage, 63361,
     /*  911748 */     GIR_EraseRootFromParent_Done,
     /*  911749 */   // Label 13874: @911749
     /*  911749 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(911832), // Rule ID 63362 //
     /*  911754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  911765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  911768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  911771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911778 */     // MIs[0] op1
     /*  911778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911794 */     // MIs[0] op4
     /*  911794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  911812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911830 */     GIR_RootConstrainSelectedInstOperands,
     /*  911831 */     // GIR_Coverage, 63362,
     /*  911831 */     GIR_EraseRootFromParent_Done,
     /*  911832 */   // Label 13875: @911832
     /*  911832 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(911915), // Rule ID 63405 //
     /*  911837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  911848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  911851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911861 */     // MIs[0] op1
     /*  911861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911877 */     // MIs[0] op4
     /*  911877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  911892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  911895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911897 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911899 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911901 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911903 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911913 */     GIR_RootConstrainSelectedInstOperands,
     /*  911914 */     // GIR_Coverage, 63405,
     /*  911914 */     GIR_EraseRootFromParent_Done,
     /*  911915 */   // Label 13876: @911915
     /*  911915 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(911998), // Rule ID 63406 //
     /*  911920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  911928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  911931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  911934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  911937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911944 */     // MIs[0] op1
     /*  911944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911960 */     // MIs[0] op4
     /*  911960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911975 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  911975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  911978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  911996 */     GIR_RootConstrainSelectedInstOperands,
     /*  911997 */     // GIR_Coverage, 63406,
     /*  911997 */     GIR_EraseRootFromParent_Done,
     /*  911998 */   // Label 13877: @911998
     /*  911998 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(912081), // Rule ID 63449 //
     /*  912003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912027 */     // MIs[0] op1
     /*  912027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912043 */     // MIs[0] op4
     /*  912043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912058 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  912058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912069 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912079 */     GIR_RootConstrainSelectedInstOperands,
     /*  912080 */     // GIR_Coverage, 63449,
     /*  912080 */     GIR_EraseRootFromParent_Done,
     /*  912081 */   // Label 13878: @912081
     /*  912081 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(912164), // Rule ID 63450 //
     /*  912086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  912097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  912100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  912103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912110 */     // MIs[0] op1
     /*  912110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912126 */     // MIs[0] op4
     /*  912126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912141 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  912141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  912162 */     GIR_RootConstrainSelectedInstOperands,
     /*  912163 */     // GIR_Coverage, 63450,
     /*  912163 */     GIR_EraseRootFromParent_Done,
     /*  912164 */   // Label 13879: @912164
     /*  912164 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(912247), // Rule ID 63493 //
     /*  912169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912193 */     // MIs[0] op1
     /*  912193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912209 */     // MIs[0] op4
     /*  912209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912229 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912231 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912233 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912235 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912245 */     GIR_RootConstrainSelectedInstOperands,
     /*  912246 */     // GIR_Coverage, 63493,
     /*  912246 */     GIR_EraseRootFromParent_Done,
     /*  912247 */   // Label 13880: @912247
     /*  912247 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(912330), // Rule ID 63494 //
     /*  912252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  912263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  912266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  912269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912276 */     // MIs[0] op1
     /*  912276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912292 */     // MIs[0] op4
     /*  912292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912312 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912314 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912316 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912318 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912328 */     GIR_RootConstrainSelectedInstOperands,
     /*  912329 */     // GIR_Coverage, 63494,
     /*  912329 */     GIR_EraseRootFromParent_Done,
     /*  912330 */   // Label 13881: @912330
     /*  912330 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(912413), // Rule ID 63549 //
     /*  912335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912359 */     // MIs[0] op1
     /*  912359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912375 */     // MIs[0] op4
     /*  912375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912395 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912397 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912399 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912401 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912411 */     GIR_RootConstrainSelectedInstOperands,
     /*  912412 */     // GIR_Coverage, 63549,
     /*  912412 */     GIR_EraseRootFromParent_Done,
     /*  912413 */   // Label 13882: @912413
     /*  912413 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(912496), // Rule ID 63550 //
     /*  912418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  912429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  912432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  912435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912442 */     // MIs[0] op1
     /*  912442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912458 */     // MIs[0] op4
     /*  912458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912473 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912494 */     GIR_RootConstrainSelectedInstOperands,
     /*  912495 */     // GIR_Coverage, 63550,
     /*  912495 */     GIR_EraseRootFromParent_Done,
     /*  912496 */   // Label 13883: @912496
     /*  912496 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(912579), // Rule ID 63605 //
     /*  912501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912525 */     // MIs[0] op1
     /*  912525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912541 */     // MIs[0] op4
     /*  912541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  912556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912561 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912563 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912565 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912567 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912577 */     GIR_RootConstrainSelectedInstOperands,
     /*  912578 */     // GIR_Coverage, 63605,
     /*  912578 */     GIR_EraseRootFromParent_Done,
     /*  912579 */   // Label 13884: @912579
     /*  912579 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(912662), // Rule ID 63606 //
     /*  912584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  912595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  912598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  912601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912608 */     // MIs[0] op1
     /*  912608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912624 */     // MIs[0] op4
     /*  912624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912639 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  912639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  912642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  912660 */     GIR_RootConstrainSelectedInstOperands,
     /*  912661 */     // GIR_Coverage, 63606,
     /*  912661 */     GIR_EraseRootFromParent_Done,
     /*  912662 */   // Label 13885: @912662
     /*  912662 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(912745), // Rule ID 63661 //
     /*  912667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912691 */     // MIs[0] op1
     /*  912691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912707 */     // MIs[0] op4
     /*  912707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912733 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912743 */     GIR_RootConstrainSelectedInstOperands,
     /*  912744 */     // GIR_Coverage, 63661,
     /*  912744 */     GIR_EraseRootFromParent_Done,
     /*  912745 */   // Label 13886: @912745
     /*  912745 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(912828), // Rule ID 63662 //
     /*  912750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912774 */     // MIs[0] op1
     /*  912774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912790 */     // MIs[0] op4
     /*  912790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  912808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912816 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912826 */     GIR_RootConstrainSelectedInstOperands,
     /*  912827 */     // GIR_Coverage, 63662,
     /*  912827 */     GIR_EraseRootFromParent_Done,
     /*  912828 */   // Label 13887: @912828
     /*  912828 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(912911), // Rule ID 63717 //
     /*  912833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912857 */     // MIs[0] op1
     /*  912857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912873 */     // MIs[0] op4
     /*  912873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912893 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912895 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912897 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912899 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912909 */     GIR_RootConstrainSelectedInstOperands,
     /*  912910 */     // GIR_Coverage, 63717,
     /*  912910 */     GIR_EraseRootFromParent_Done,
     /*  912911 */   // Label 13888: @912911
     /*  912911 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(912994), // Rule ID 63718 //
     /*  912916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  912924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912940 */     // MIs[0] op1
     /*  912940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912956 */     // MIs[0] op4
     /*  912956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  912974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912976 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912978 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912980 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912982 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912992 */     GIR_RootConstrainSelectedInstOperands,
     /*  912993 */     // GIR_Coverage, 63718,
     /*  912993 */     GIR_EraseRootFromParent_Done,
     /*  912994 */   // Label 13889: @912994
     /*  912994 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(913077), // Rule ID 63773 //
     /*  912999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913023 */     // MIs[0] op1
     /*  913023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913039 */     // MIs[0] op4
     /*  913039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  913054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913059 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913061 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913063 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913065 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913075 */     GIR_RootConstrainSelectedInstOperands,
     /*  913076 */     // GIR_Coverage, 63773,
     /*  913076 */     GIR_EraseRootFromParent_Done,
     /*  913077 */   // Label 13890: @913077
     /*  913077 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(913160), // Rule ID 63774 //
     /*  913082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  913099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913106 */     // MIs[0] op1
     /*  913106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913122 */     // MIs[0] op4
     /*  913122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  913137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913148 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913158 */     GIR_RootConstrainSelectedInstOperands,
     /*  913159 */     // GIR_Coverage, 63774,
     /*  913159 */     GIR_EraseRootFromParent_Done,
     /*  913160 */   // Label 13891: @913160
     /*  913160 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(913243), // Rule ID 63829 //
     /*  913165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913189 */     // MIs[0] op1
     /*  913189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913205 */     // MIs[0] op4
     /*  913205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  913223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913225 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913227 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913229 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913231 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913241 */     GIR_RootConstrainSelectedInstOperands,
     /*  913242 */     // GIR_Coverage, 63829,
     /*  913242 */     GIR_EraseRootFromParent_Done,
     /*  913243 */   // Label 13892: @913243
     /*  913243 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(913326), // Rule ID 63830 //
     /*  913248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  913259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  913262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  913265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913272 */     // MIs[0] op1
     /*  913272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913288 */     // MIs[0] op4
     /*  913288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  913306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913314 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913324 */     GIR_RootConstrainSelectedInstOperands,
     /*  913325 */     // GIR_Coverage, 63830,
     /*  913325 */     GIR_EraseRootFromParent_Done,
     /*  913326 */   // Label 13893: @913326
     /*  913326 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(913409), // Rule ID 63885 //
     /*  913331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913355 */     // MIs[0] op1
     /*  913355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913371 */     // MIs[0] op4
     /*  913371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  913389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913391 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913393 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913395 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913397 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913407 */     GIR_RootConstrainSelectedInstOperands,
     /*  913408 */     // GIR_Coverage, 63885,
     /*  913408 */     GIR_EraseRootFromParent_Done,
     /*  913409 */   // Label 13894: @913409
     /*  913409 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(913492), // Rule ID 63886 //
     /*  913414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  913425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  913428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  913431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913438 */     // MIs[0] op1
     /*  913438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913454 */     // MIs[0] op4
     /*  913454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913469 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  913472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913474 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913476 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913478 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913480 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913490 */     GIR_RootConstrainSelectedInstOperands,
     /*  913491 */     // GIR_Coverage, 63886,
     /*  913491 */     GIR_EraseRootFromParent_Done,
     /*  913492 */   // Label 13895: @913492
     /*  913492 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(913575), // Rule ID 63941 //
     /*  913497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913521 */     // MIs[0] op1
     /*  913521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913537 */     // MIs[0] op4
     /*  913537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  913552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913557 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913559 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913561 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913563 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913573 */     GIR_RootConstrainSelectedInstOperands,
     /*  913574 */     // GIR_Coverage, 63941,
     /*  913574 */     GIR_EraseRootFromParent_Done,
     /*  913575 */   // Label 13896: @913575
     /*  913575 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(913658), // Rule ID 63942 //
     /*  913580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  913588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  913591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  913594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  913597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913604 */     // MIs[0] op1
     /*  913604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913620 */     // MIs[0] op4
     /*  913620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913635 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  913635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  913638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913640 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913642 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913644 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913646 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  913656 */     GIR_RootConstrainSelectedInstOperands,
     /*  913657 */     // GIR_Coverage, 63942,
     /*  913657 */     GIR_EraseRootFromParent_Done,
     /*  913658 */   // Label 13897: @913658
     /*  913658 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(913741), // Rule ID 63971 //
     /*  913663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913687 */     // MIs[0] op1
     /*  913687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913703 */     // MIs[0] op4
     /*  913703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  913718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  913721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913723 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913725 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913727 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913729 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913739 */     GIR_RootConstrainSelectedInstOperands,
     /*  913740 */     // GIR_Coverage, 63971,
     /*  913740 */     GIR_EraseRootFromParent_Done,
     /*  913741 */   // Label 13898: @913741
     /*  913741 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(913824), // Rule ID 63972 //
     /*  913746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  913763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913770 */     // MIs[0] op1
     /*  913770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913786 */     // MIs[0] op4
     /*  913786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913801 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  913801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  913804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913822 */     GIR_RootConstrainSelectedInstOperands,
     /*  913823 */     // GIR_Coverage, 63972,
     /*  913823 */     GIR_EraseRootFromParent_Done,
     /*  913824 */   // Label 13899: @913824
     /*  913824 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(913907), // Rule ID 63989 //
     /*  913829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  913840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  913843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  913849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913853 */     // MIs[0] op1
     /*  913853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913869 */     // MIs[0] op4
     /*  913869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  913884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  913887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913889 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913891 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913893 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913895 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913905 */     GIR_RootConstrainSelectedInstOperands,
     /*  913906 */     // GIR_Coverage, 63989,
     /*  913906 */     GIR_EraseRootFromParent_Done,
     /*  913907 */   // Label 13900: @913907
     /*  913907 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(913990), // Rule ID 63990 //
     /*  913912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  913915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  913920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  913923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  913926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  913929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  913932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913936 */     // MIs[0] op1
     /*  913936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  913939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  913944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913952 */     // MIs[0] op4
     /*  913952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  913955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  913960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  913967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  913970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913972 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  913974 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  913976 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  913978 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  913980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913988 */     GIR_RootConstrainSelectedInstOperands,
     /*  913989 */     // GIR_Coverage, 63990,
     /*  913989 */     GIR_EraseRootFromParent_Done,
     /*  913990 */   // Label 13901: @913990
     /*  913990 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(914073), // Rule ID 64007 //
     /*  913995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  913998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  914012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914019 */     // MIs[0] op1
     /*  914019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914035 */     // MIs[0] op4
     /*  914035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914055 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914057 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914059 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914061 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914071 */     GIR_RootConstrainSelectedInstOperands,
     /*  914072 */     // GIR_Coverage, 64007,
     /*  914072 */     GIR_EraseRootFromParent_Done,
     /*  914073 */   // Label 13902: @914073
     /*  914073 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(914156), // Rule ID 64008 //
     /*  914078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  914095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914102 */     // MIs[0] op1
     /*  914102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914118 */     // MIs[0] op4
     /*  914118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914144 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914154 */     GIR_RootConstrainSelectedInstOperands,
     /*  914155 */     // GIR_Coverage, 64008,
     /*  914155 */     GIR_EraseRootFromParent_Done,
     /*  914156 */   // Label 13903: @914156
     /*  914156 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(914239), // Rule ID 64025 //
     /*  914161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  914172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  914175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914185 */     // MIs[0] op1
     /*  914185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914201 */     // MIs[0] op4
     /*  914201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  914219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914227 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914237 */     GIR_RootConstrainSelectedInstOperands,
     /*  914238 */     // GIR_Coverage, 64025,
     /*  914238 */     GIR_EraseRootFromParent_Done,
     /*  914239 */   // Label 13904: @914239
     /*  914239 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(914322), // Rule ID 64026 //
     /*  914244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  914255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  914258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  914261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914268 */     // MIs[0] op1
     /*  914268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914284 */     // MIs[0] op4
     /*  914284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  914302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914304 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914306 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914308 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914310 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914320 */     GIR_RootConstrainSelectedInstOperands,
     /*  914321 */     // GIR_Coverage, 64026,
     /*  914321 */     GIR_EraseRootFromParent_Done,
     /*  914322 */   // Label 13905: @914322
     /*  914322 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(914405), // Rule ID 64043 //
     /*  914327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  914338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  914341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  914344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914351 */     // MIs[0] op1
     /*  914351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914367 */     // MIs[0] op4
     /*  914367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  914385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914387 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914389 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914391 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914393 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914403 */     GIR_RootConstrainSelectedInstOperands,
     /*  914404 */     // GIR_Coverage, 64043,
     /*  914404 */     GIR_EraseRootFromParent_Done,
     /*  914405 */   // Label 13906: @914405
     /*  914405 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(914488), // Rule ID 64044 //
     /*  914410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  914421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  914424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  914427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914434 */     // MIs[0] op1
     /*  914434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  914450 */     // MIs[0] op4
     /*  914450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914465 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  914468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914476 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914486 */     GIR_RootConstrainSelectedInstOperands,
     /*  914487 */     // GIR_Coverage, 64044,
     /*  914487 */     GIR_EraseRootFromParent_Done,
     /*  914488 */   // Label 13907: @914488
     /*  914488 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(914571), // Rule ID 64061 //
     /*  914493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  914504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  914507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  914510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914517 */     // MIs[0] op1
     /*  914517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914533 */     // MIs[0] op4
     /*  914533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  914548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  914551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914553 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914555 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914557 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914559 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914569 */     GIR_RootConstrainSelectedInstOperands,
     /*  914570 */     // GIR_Coverage, 64061,
     /*  914570 */     GIR_EraseRootFromParent_Done,
     /*  914571 */   // Label 13908: @914571
     /*  914571 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(914654), // Rule ID 64062 //
     /*  914576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  914587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  914590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  914593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914600 */     // MIs[0] op1
     /*  914600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  914612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  914616 */     // MIs[0] op4
     /*  914616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  914631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  914634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914652 */     GIR_RootConstrainSelectedInstOperands,
     /*  914653 */     // GIR_Coverage, 64062,
     /*  914653 */     GIR_EraseRootFromParent_Done,
     /*  914654 */   // Label 13909: @914654
     /*  914654 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(914737), // Rule ID 64079 //
     /*  914659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914683 */     // MIs[0] op1
     /*  914683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914699 */     // MIs[0] op4
     /*  914699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  914714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  914717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914719 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914721 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914723 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914725 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914735 */     GIR_RootConstrainSelectedInstOperands,
     /*  914736 */     // GIR_Coverage, 64079,
     /*  914736 */     GIR_EraseRootFromParent_Done,
     /*  914737 */   // Label 13910: @914737
     /*  914737 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(914820), // Rule ID 64080 //
     /*  914742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  914759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914766 */     // MIs[0] op1
     /*  914766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914782 */     // MIs[0] op4
     /*  914782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  914797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  914800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914818 */     GIR_RootConstrainSelectedInstOperands,
     /*  914819 */     // GIR_Coverage, 64080,
     /*  914819 */     GIR_EraseRootFromParent_Done,
     /*  914820 */   // Label 13911: @914820
     /*  914820 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(914903), // Rule ID 64103 //
     /*  914825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  914845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914849 */     // MIs[0] op1
     /*  914849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914865 */     // MIs[0] op4
     /*  914865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  914880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914891 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914901 */     GIR_RootConstrainSelectedInstOperands,
     /*  914902 */     // GIR_Coverage, 64103,
     /*  914902 */     GIR_EraseRootFromParent_Done,
     /*  914903 */   // Label 13912: @914903
     /*  914903 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(914986), // Rule ID 64104 //
     /*  914908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  914911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  914925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  914928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914932 */     // MIs[0] op1
     /*  914932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  914935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  914940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914948 */     // MIs[0] op4
     /*  914948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  914951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  914956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914963 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  914963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  914966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  914970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  914972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  914974 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  914976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914984 */     GIR_RootConstrainSelectedInstOperands,
     /*  914985 */     // GIR_Coverage, 64104,
     /*  914985 */     GIR_EraseRootFromParent_Done,
     /*  914986 */   // Label 13913: @914986
     /*  914986 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(915069), // Rule ID 64127 //
     /*  914991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  914994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  914999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  915002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  915005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  915008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915015 */     // MIs[0] op1
     /*  915015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915031 */     // MIs[0] op4
     /*  915031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915057 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915067 */     GIR_RootConstrainSelectedInstOperands,
     /*  915068 */     // GIR_Coverage, 64127,
     /*  915068 */     GIR_EraseRootFromParent_Done,
     /*  915069 */   // Label 13914: @915069
     /*  915069 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(915152), // Rule ID 64128 //
     /*  915074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  915085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  915088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  915091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915098 */     // MIs[0] op1
     /*  915098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915114 */     // MIs[0] op4
     /*  915114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915150 */     GIR_RootConstrainSelectedInstOperands,
     /*  915151 */     // GIR_Coverage, 64128,
     /*  915151 */     GIR_EraseRootFromParent_Done,
     /*  915152 */   // Label 13915: @915152
     /*  915152 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(915235), // Rule ID 64151 //
     /*  915157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  915168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  915171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915181 */     // MIs[0] op1
     /*  915181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915197 */     // MIs[0] op4
     /*  915197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915223 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915233 */     GIR_RootConstrainSelectedInstOperands,
     /*  915234 */     // GIR_Coverage, 64151,
     /*  915234 */     GIR_EraseRootFromParent_Done,
     /*  915235 */   // Label 13916: @915235
     /*  915235 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(915318), // Rule ID 64152 //
     /*  915240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  915251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  915254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  915257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915264 */     // MIs[0] op1
     /*  915264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915280 */     // MIs[0] op4
     /*  915280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915295 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915316 */     GIR_RootConstrainSelectedInstOperands,
     /*  915317 */     // GIR_Coverage, 64152,
     /*  915317 */     GIR_EraseRootFromParent_Done,
     /*  915318 */   // Label 13917: @915318
     /*  915318 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(915401), // Rule ID 64175 //
     /*  915323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  915334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  915337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915347 */     // MIs[0] op1
     /*  915347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915363 */     // MIs[0] op4
     /*  915363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915378 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  915378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  915381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915389 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915399 */     GIR_RootConstrainSelectedInstOperands,
     /*  915400 */     // GIR_Coverage, 64175,
     /*  915400 */     GIR_EraseRootFromParent_Done,
     /*  915401 */   // Label 13918: @915401
     /*  915401 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(915484), // Rule ID 64176 //
     /*  915406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  915417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  915420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  915423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915430 */     // MIs[0] op1
     /*  915430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915446 */     // MIs[0] op4
     /*  915446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  915461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  915464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915466 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915468 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915470 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915472 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915482 */     GIR_RootConstrainSelectedInstOperands,
     /*  915483 */     // GIR_Coverage, 64176,
     /*  915483 */     GIR_EraseRootFromParent_Done,
     /*  915484 */   // Label 13919: @915484
     /*  915484 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(915567), // Rule ID 64199 //
     /*  915489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  915506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915513 */     // MIs[0] op1
     /*  915513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915529 */     // MIs[0] op4
     /*  915529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  915547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915555 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915565 */     GIR_RootConstrainSelectedInstOperands,
     /*  915566 */     // GIR_Coverage, 64199,
     /*  915566 */     GIR_EraseRootFromParent_Done,
     /*  915567 */   // Label 13920: @915567
     /*  915567 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(915650), // Rule ID 64200 //
     /*  915572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  915589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915596 */     // MIs[0] op1
     /*  915596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915612 */     // MIs[0] op4
     /*  915612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915627 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  915630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915648 */     GIR_RootConstrainSelectedInstOperands,
     /*  915649 */     // GIR_Coverage, 64200,
     /*  915649 */     GIR_EraseRootFromParent_Done,
     /*  915650 */   // Label 13921: @915650
     /*  915650 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(915733), // Rule ID 64223 //
     /*  915655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  915666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  915669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  915672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915679 */     // MIs[0] op1
     /*  915679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915695 */     // MIs[0] op4
     /*  915695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915721 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915731 */     GIR_RootConstrainSelectedInstOperands,
     /*  915732 */     // GIR_Coverage, 64223,
     /*  915732 */     GIR_EraseRootFromParent_Done,
     /*  915733 */   // Label 13922: @915733
     /*  915733 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(915816), // Rule ID 64224 //
     /*  915738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  915749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  915752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  915755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915762 */     // MIs[0] op1
     /*  915762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915778 */     // MIs[0] op4
     /*  915778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  915796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915814 */     GIR_RootConstrainSelectedInstOperands,
     /*  915815 */     // GIR_Coverage, 64224,
     /*  915815 */     GIR_EraseRootFromParent_Done,
     /*  915816 */   // Label 13923: @915816
     /*  915816 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(915899), // Rule ID 64247 //
     /*  915821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  915832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  915835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  915838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  915841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915845 */     // MIs[0] op1
     /*  915845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915861 */     // MIs[0] op4
     /*  915861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  915876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915887 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915897 */     GIR_RootConstrainSelectedInstOperands,
     /*  915898 */     // GIR_Coverage, 64247,
     /*  915898 */     GIR_EraseRootFromParent_Done,
     /*  915899 */   // Label 13924: @915899
     /*  915899 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(915982), // Rule ID 64248 //
     /*  915904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  915907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  915915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  915918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  915921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  915924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915928 */     // MIs[0] op1
     /*  915928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  915931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  915936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915944 */     // MIs[0] op4
     /*  915944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  915947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  915952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  915959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  915962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  915966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  915968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  915970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  915972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915980 */     GIR_RootConstrainSelectedInstOperands,
     /*  915981 */     // GIR_Coverage, 64248,
     /*  915981 */     GIR_EraseRootFromParent_Done,
     /*  915982 */   // Label 13925: @915982
     /*  915982 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(916065), // Rule ID 64271 //
     /*  915987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  915990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  915995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  915998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  916001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  916007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916011 */     // MIs[0] op1
     /*  916011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  916014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  916019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916027 */     // MIs[0] op4
     /*  916027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  916030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  916035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  916042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  916045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  916049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  916051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  916053 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  916055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916063 */     GIR_RootConstrainSelectedInstOperands,
     /*  916064 */     // GIR_Coverage, 64271,
     /*  916064 */     GIR_EraseRootFromParent_Done,
     /*  916065 */   // Label 13926: @916065
     /*  916065 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(916148), // Rule ID 64272 //
     /*  916070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  916073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  916078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  916081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  916084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  916087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  916090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916094 */     // MIs[0] op1
     /*  916094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  916097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  916102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916110 */     // MIs[0] op4
     /*  916110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  916113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  916118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  916125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  916128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  916132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  916134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  916136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  916138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916146 */     GIR_RootConstrainSelectedInstOperands,
     /*  916147 */     // GIR_Coverage, 64272,
     /*  916147 */     GIR_EraseRootFromParent_Done,
     /*  916148 */   // Label 13927: @916148
     /*  916148 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(916226), // Rule ID 60600 //
     /*  916153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916185 */     // MIs[0] rs2
     /*  916185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916193 */     // MIs[0] policy
     /*  916193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916203 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  916206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916224 */     GIR_RootConstrainSelectedInstOperands,
     /*  916225 */     // GIR_Coverage, 60600,
     /*  916225 */     GIR_EraseRootFromParent_Done,
     /*  916226 */   // Label 13928: @916226
     /*  916226 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(916304), // Rule ID 60601 //
     /*  916231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916263 */     // MIs[0] rs2
     /*  916263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916271 */     // MIs[0] policy
     /*  916271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  916284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916302 */     GIR_RootConstrainSelectedInstOperands,
     /*  916303 */     // GIR_Coverage, 60601,
     /*  916303 */     GIR_EraseRootFromParent_Done,
     /*  916304 */   // Label 13929: @916304
     /*  916304 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(916382), // Rule ID 62256 //
     /*  916309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  916320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  916323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  916326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916341 */     // MIs[0] rs2
     /*  916341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916349 */     // MIs[0] policy
     /*  916349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  916362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916380 */     GIR_RootConstrainSelectedInstOperands,
     /*  916381 */     // GIR_Coverage, 62256,
     /*  916381 */     GIR_EraseRootFromParent_Done,
     /*  916382 */   // Label 13930: @916382
     /*  916382 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(916460), // Rule ID 62257 //
     /*  916387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  916398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  916401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  916404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916419 */     // MIs[0] rs2
     /*  916419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916427 */     // MIs[0] policy
     /*  916427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  916440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916458 */     GIR_RootConstrainSelectedInstOperands,
     /*  916459 */     // GIR_Coverage, 62257,
     /*  916459 */     GIR_EraseRootFromParent_Done,
     /*  916460 */   // Label 13931: @916460
     /*  916460 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(916538), // Rule ID 62258 //
     /*  916465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916497 */     // MIs[0] rs2
     /*  916497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916505 */     // MIs[0] policy
     /*  916505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  916518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916536 */     GIR_RootConstrainSelectedInstOperands,
     /*  916537 */     // GIR_Coverage, 62258,
     /*  916537 */     GIR_EraseRootFromParent_Done,
     /*  916538 */   // Label 13932: @916538
     /*  916538 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(916616), // Rule ID 62259 //
     /*  916543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916575 */     // MIs[0] rs2
     /*  916575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916583 */     // MIs[0] policy
     /*  916583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  916596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916614 */     GIR_RootConstrainSelectedInstOperands,
     /*  916615 */     // GIR_Coverage, 62259,
     /*  916615 */     GIR_EraseRootFromParent_Done,
     /*  916616 */   // Label 13933: @916616
     /*  916616 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(916694), // Rule ID 62260 //
     /*  916621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916653 */     // MIs[0] rs2
     /*  916653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916661 */     // MIs[0] policy
     /*  916661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  916674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916692 */     GIR_RootConstrainSelectedInstOperands,
     /*  916693 */     // GIR_Coverage, 62260,
     /*  916693 */     GIR_EraseRootFromParent_Done,
     /*  916694 */   // Label 13934: @916694
     /*  916694 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(916772), // Rule ID 62261 //
     /*  916699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916731 */     // MIs[0] rs2
     /*  916731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916739 */     // MIs[0] policy
     /*  916739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916749 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  916752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916770 */     GIR_RootConstrainSelectedInstOperands,
     /*  916771 */     // GIR_Coverage, 62261,
     /*  916771 */     GIR_EraseRootFromParent_Done,
     /*  916772 */   // Label 13935: @916772
     /*  916772 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(916850), // Rule ID 62262 //
     /*  916777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  916780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916809 */     // MIs[0] rs2
     /*  916809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916817 */     // MIs[0] policy
     /*  916817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  916830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916848 */     GIR_RootConstrainSelectedInstOperands,
     /*  916849 */     // GIR_Coverage, 62262,
     /*  916849 */     GIR_EraseRootFromParent_Done,
     /*  916850 */   // Label 13936: @916850
     /*  916850 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(916928), // Rule ID 62263 //
     /*  916855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  916858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  916863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916887 */     // MIs[0] rs2
     /*  916887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916895 */     // MIs[0] policy
     /*  916895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  916908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916926 */     GIR_RootConstrainSelectedInstOperands,
     /*  916927 */     // GIR_Coverage, 62263,
     /*  916927 */     GIR_EraseRootFromParent_Done,
     /*  916928 */   // Label 13937: @916928
     /*  916928 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(917006), // Rule ID 62424 //
     /*  916933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  916936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  916941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  916944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  916947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  916950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  916965 */     // MIs[0] rs2
     /*  916965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  916968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  916973 */     // MIs[0] policy
     /*  916973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916983 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  916986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  916988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  916994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917004 */     GIR_RootConstrainSelectedInstOperands,
     /*  917005 */     // GIR_Coverage, 62424,
     /*  917005 */     GIR_EraseRootFromParent_Done,
     /*  917006 */   // Label 13938: @917006
     /*  917006 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(917084), // Rule ID 62425 //
     /*  917011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  917022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  917025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  917028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917043 */     // MIs[0] rs2
     /*  917043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917051 */     // MIs[0] policy
     /*  917051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  917064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917082 */     GIR_RootConstrainSelectedInstOperands,
     /*  917083 */     // GIR_Coverage, 62425,
     /*  917083 */     GIR_EraseRootFromParent_Done,
     /*  917084 */   // Label 13939: @917084
     /*  917084 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(917162), // Rule ID 62426 //
     /*  917089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  917100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  917103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  917106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917121 */     // MIs[0] rs2
     /*  917121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917129 */     // MIs[0] policy
     /*  917129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  917142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917160 */     GIR_RootConstrainSelectedInstOperands,
     /*  917161 */     // GIR_Coverage, 62426,
     /*  917161 */     GIR_EraseRootFromParent_Done,
     /*  917162 */   // Label 13940: @917162
     /*  917162 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(917240), // Rule ID 62427 //
     /*  917167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  917178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  917181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  917184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917199 */     // MIs[0] rs2
     /*  917199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917207 */     // MIs[0] policy
     /*  917207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  917220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917238 */     GIR_RootConstrainSelectedInstOperands,
     /*  917239 */     // GIR_Coverage, 62427,
     /*  917239 */     GIR_EraseRootFromParent_Done,
     /*  917240 */   // Label 13941: @917240
     /*  917240 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(917318), // Rule ID 62428 //
     /*  917245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917277 */     // MIs[0] rs2
     /*  917277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917285 */     // MIs[0] policy
     /*  917285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  917298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917316 */     GIR_RootConstrainSelectedInstOperands,
     /*  917317 */     // GIR_Coverage, 62428,
     /*  917317 */     GIR_EraseRootFromParent_Done,
     /*  917318 */   // Label 13942: @917318
     /*  917318 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(917396), // Rule ID 62429 //
     /*  917323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  917334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  917337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  917340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917355 */     // MIs[0] rs2
     /*  917355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917363 */     // MIs[0] policy
     /*  917363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  917376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917394 */     GIR_RootConstrainSelectedInstOperands,
     /*  917395 */     // GIR_Coverage, 62429,
     /*  917395 */     GIR_EraseRootFromParent_Done,
     /*  917396 */   // Label 13943: @917396
     /*  917396 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(917474), // Rule ID 62430 //
     /*  917401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917433 */     // MIs[0] rs2
     /*  917433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917441 */     // MIs[0] policy
     /*  917441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  917454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917472 */     GIR_RootConstrainSelectedInstOperands,
     /*  917473 */     // GIR_Coverage, 62430,
     /*  917473 */     GIR_EraseRootFromParent_Done,
     /*  917474 */   // Label 13944: @917474
     /*  917474 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(917552), // Rule ID 62431 //
     /*  917479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  917490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  917493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  917496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917511 */     // MIs[0] rs2
     /*  917511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917519 */     // MIs[0] policy
     /*  917519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  917532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917550 */     GIR_RootConstrainSelectedInstOperands,
     /*  917551 */     // GIR_Coverage, 62431,
     /*  917551 */     GIR_EraseRootFromParent_Done,
     /*  917552 */   // Label 13945: @917552
     /*  917552 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(917630), // Rule ID 62432 //
     /*  917557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  917560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917589 */     // MIs[0] rs2
     /*  917589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917597 */     // MIs[0] policy
     /*  917597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917607 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  917610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917628 */     GIR_RootConstrainSelectedInstOperands,
     /*  917629 */     // GIR_Coverage, 62432,
     /*  917629 */     GIR_EraseRootFromParent_Done,
     /*  917630 */   // Label 13946: @917630
     /*  917630 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(917708), // Rule ID 62433 //
     /*  917635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  917638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  917643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917667 */     // MIs[0] rs2
     /*  917667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  917670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  917675 */     // MIs[0] policy
     /*  917675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917685 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  917688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  917690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  917696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917706 */     GIR_RootConstrainSelectedInstOperands,
     /*  917707 */     // GIR_Coverage, 62433,
     /*  917707 */     GIR_EraseRootFromParent_Done,
     /*  917708 */   // Label 13947: @917708
     /*  917708 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(917796), // Rule ID 23690 //
     /*  917713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917760 */     // MIs[1] Operand 1
     /*  917760 */     // No operand predicates
     /*  917760 */     // MIs[0] policy
     /*  917760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  917775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917794 */     GIR_RootConstrainSelectedInstOperands,
     /*  917795 */     // GIR_Coverage, 23690,
     /*  917795 */     GIR_EraseRootFromParent_Done,
     /*  917796 */   // Label 13948: @917796
     /*  917796 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(917884), // Rule ID 23691 //
     /*  917801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917848 */     // MIs[1] Operand 1
     /*  917848 */     // No operand predicates
     /*  917848 */     // MIs[0] policy
     /*  917848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  917863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917882 */     GIR_RootConstrainSelectedInstOperands,
     /*  917883 */     // GIR_Coverage, 23691,
     /*  917883 */     GIR_EraseRootFromParent_Done,
     /*  917884 */   // Label 13949: @917884
     /*  917884 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(917972), // Rule ID 23694 //
     /*  917889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917936 */     // MIs[1] Operand 1
     /*  917936 */     // No operand predicates
     /*  917936 */     // MIs[0] policy
     /*  917936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  917951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917970 */     GIR_RootConstrainSelectedInstOperands,
     /*  917971 */     // GIR_Coverage, 23694,
     /*  917971 */     GIR_EraseRootFromParent_Done,
     /*  917972 */   // Label 13950: @917972
     /*  917972 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(918060), // Rule ID 23695 //
     /*  917977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918024 */     // MIs[1] Operand 1
     /*  918024 */     // No operand predicates
     /*  918024 */     // MIs[0] policy
     /*  918024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918058 */     GIR_RootConstrainSelectedInstOperands,
     /*  918059 */     // GIR_Coverage, 23695,
     /*  918059 */     GIR_EraseRootFromParent_Done,
     /*  918060 */   // Label 13951: @918060
     /*  918060 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(918148), // Rule ID 23698 //
     /*  918065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918112 */     // MIs[1] Operand 1
     /*  918112 */     // No operand predicates
     /*  918112 */     // MIs[0] policy
     /*  918112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918146 */     GIR_RootConstrainSelectedInstOperands,
     /*  918147 */     // GIR_Coverage, 23698,
     /*  918147 */     GIR_EraseRootFromParent_Done,
     /*  918148 */   // Label 13952: @918148
     /*  918148 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(918236), // Rule ID 23699 //
     /*  918153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918200 */     // MIs[1] Operand 1
     /*  918200 */     // No operand predicates
     /*  918200 */     // MIs[0] policy
     /*  918200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918234 */     GIR_RootConstrainSelectedInstOperands,
     /*  918235 */     // GIR_Coverage, 23699,
     /*  918235 */     GIR_EraseRootFromParent_Done,
     /*  918236 */   // Label 13953: @918236
     /*  918236 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(918324), // Rule ID 23702 //
     /*  918241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918288 */     // MIs[1] Operand 1
     /*  918288 */     // No operand predicates
     /*  918288 */     // MIs[0] policy
     /*  918288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918322 */     GIR_RootConstrainSelectedInstOperands,
     /*  918323 */     // GIR_Coverage, 23702,
     /*  918323 */     GIR_EraseRootFromParent_Done,
     /*  918324 */   // Label 13954: @918324
     /*  918324 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(918412), // Rule ID 23703 //
     /*  918329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918376 */     // MIs[1] Operand 1
     /*  918376 */     // No operand predicates
     /*  918376 */     // MIs[0] policy
     /*  918376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  918391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918410 */     GIR_RootConstrainSelectedInstOperands,
     /*  918411 */     // GIR_Coverage, 23703,
     /*  918411 */     GIR_EraseRootFromParent_Done,
     /*  918412 */   // Label 13955: @918412
     /*  918412 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(918500), // Rule ID 23706 //
     /*  918417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918464 */     // MIs[1] Operand 1
     /*  918464 */     // No operand predicates
     /*  918464 */     // MIs[0] policy
     /*  918464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918498 */     GIR_RootConstrainSelectedInstOperands,
     /*  918499 */     // GIR_Coverage, 23706,
     /*  918499 */     GIR_EraseRootFromParent_Done,
     /*  918500 */   // Label 13956: @918500
     /*  918500 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(918588), // Rule ID 23707 //
     /*  918505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918552 */     // MIs[1] Operand 1
     /*  918552 */     // No operand predicates
     /*  918552 */     // MIs[0] policy
     /*  918552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918586 */     GIR_RootConstrainSelectedInstOperands,
     /*  918587 */     // GIR_Coverage, 23707,
     /*  918587 */     GIR_EraseRootFromParent_Done,
     /*  918588 */   // Label 13957: @918588
     /*  918588 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(918676), // Rule ID 23710 //
     /*  918593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918640 */     // MIs[1] Operand 1
     /*  918640 */     // No operand predicates
     /*  918640 */     // MIs[0] policy
     /*  918640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918674 */     GIR_RootConstrainSelectedInstOperands,
     /*  918675 */     // GIR_Coverage, 23710,
     /*  918675 */     GIR_EraseRootFromParent_Done,
     /*  918676 */   // Label 13958: @918676
     /*  918676 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(918764), // Rule ID 23711 //
     /*  918681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918728 */     // MIs[1] Operand 1
     /*  918728 */     // No operand predicates
     /*  918728 */     // MIs[0] policy
     /*  918728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  918743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918762 */     GIR_RootConstrainSelectedInstOperands,
     /*  918763 */     // GIR_Coverage, 23711,
     /*  918763 */     GIR_EraseRootFromParent_Done,
     /*  918764 */   // Label 13959: @918764
     /*  918764 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(918852), // Rule ID 23714 //
     /*  918769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918816 */     // MIs[1] Operand 1
     /*  918816 */     // No operand predicates
     /*  918816 */     // MIs[0] policy
     /*  918816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  918831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918850 */     GIR_RootConstrainSelectedInstOperands,
     /*  918851 */     // GIR_Coverage, 23714,
     /*  918851 */     GIR_EraseRootFromParent_Done,
     /*  918852 */   // Label 13960: @918852
     /*  918852 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(918940), // Rule ID 23715 //
     /*  918857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918904 */     // MIs[1] Operand 1
     /*  918904 */     // No operand predicates
     /*  918904 */     // MIs[0] policy
     /*  918904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  918919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918938 */     GIR_RootConstrainSelectedInstOperands,
     /*  918939 */     // GIR_Coverage, 23715,
     /*  918939 */     GIR_EraseRootFromParent_Done,
     /*  918940 */   // Label 13961: @918940
     /*  918940 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(919028), // Rule ID 23718 //
     /*  918945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  918953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918992 */     // MIs[1] Operand 1
     /*  918992 */     // No operand predicates
     /*  918992 */     // MIs[0] policy
     /*  918992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919026 */     GIR_RootConstrainSelectedInstOperands,
     /*  919027 */     // GIR_Coverage, 23718,
     /*  919027 */     GIR_EraseRootFromParent_Done,
     /*  919028 */   // Label 13962: @919028
     /*  919028 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(919116), // Rule ID 23719 //
     /*  919033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919080 */     // MIs[1] Operand 1
     /*  919080 */     // No operand predicates
     /*  919080 */     // MIs[0] policy
     /*  919080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919114 */     GIR_RootConstrainSelectedInstOperands,
     /*  919115 */     // GIR_Coverage, 23719,
     /*  919115 */     GIR_EraseRootFromParent_Done,
     /*  919116 */   // Label 13963: @919116
     /*  919116 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(919204), // Rule ID 23722 //
     /*  919121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919168 */     // MIs[1] Operand 1
     /*  919168 */     // No operand predicates
     /*  919168 */     // MIs[0] policy
     /*  919168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919202 */     GIR_RootConstrainSelectedInstOperands,
     /*  919203 */     // GIR_Coverage, 23722,
     /*  919203 */     GIR_EraseRootFromParent_Done,
     /*  919204 */   // Label 13964: @919204
     /*  919204 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(919292), // Rule ID 23723 //
     /*  919209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919256 */     // MIs[1] Operand 1
     /*  919256 */     // No operand predicates
     /*  919256 */     // MIs[0] policy
     /*  919256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919290 */     GIR_RootConstrainSelectedInstOperands,
     /*  919291 */     // GIR_Coverage, 23723,
     /*  919291 */     GIR_EraseRootFromParent_Done,
     /*  919292 */   // Label 13965: @919292
     /*  919292 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(919380), // Rule ID 23726 //
     /*  919297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919344 */     // MIs[1] Operand 1
     /*  919344 */     // No operand predicates
     /*  919344 */     // MIs[0] policy
     /*  919344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919378 */     GIR_RootConstrainSelectedInstOperands,
     /*  919379 */     // GIR_Coverage, 23726,
     /*  919379 */     GIR_EraseRootFromParent_Done,
     /*  919380 */   // Label 13966: @919380
     /*  919380 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(919468), // Rule ID 23727 //
     /*  919385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919432 */     // MIs[1] Operand 1
     /*  919432 */     // No operand predicates
     /*  919432 */     // MIs[0] policy
     /*  919432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  919447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919466 */     GIR_RootConstrainSelectedInstOperands,
     /*  919467 */     // GIR_Coverage, 23727,
     /*  919467 */     GIR_EraseRootFromParent_Done,
     /*  919468 */   // Label 13967: @919468
     /*  919468 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(919556), // Rule ID 23730 //
     /*  919473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919520 */     // MIs[1] Operand 1
     /*  919520 */     // No operand predicates
     /*  919520 */     // MIs[0] policy
     /*  919520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  919535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919554 */     GIR_RootConstrainSelectedInstOperands,
     /*  919555 */     // GIR_Coverage, 23730,
     /*  919555 */     GIR_EraseRootFromParent_Done,
     /*  919556 */   // Label 13968: @919556
     /*  919556 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(919644), // Rule ID 23731 //
     /*  919561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919608 */     // MIs[1] Operand 1
     /*  919608 */     // No operand predicates
     /*  919608 */     // MIs[0] policy
     /*  919608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  919623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919642 */     GIR_RootConstrainSelectedInstOperands,
     /*  919643 */     // GIR_Coverage, 23731,
     /*  919643 */     GIR_EraseRootFromParent_Done,
     /*  919644 */   // Label 13969: @919644
     /*  919644 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(919732), // Rule ID 23734 //
     /*  919649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919696 */     // MIs[1] Operand 1
     /*  919696 */     // No operand predicates
     /*  919696 */     // MIs[0] policy
     /*  919696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919708 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  919711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919730 */     GIR_RootConstrainSelectedInstOperands,
     /*  919731 */     // GIR_Coverage, 23734,
     /*  919731 */     GIR_EraseRootFromParent_Done,
     /*  919732 */   // Label 13970: @919732
     /*  919732 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(919820), // Rule ID 23735 //
     /*  919737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919784 */     // MIs[1] Operand 1
     /*  919784 */     // No operand predicates
     /*  919784 */     // MIs[0] policy
     /*  919784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  919799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919818 */     GIR_RootConstrainSelectedInstOperands,
     /*  919819 */     // GIR_Coverage, 23735,
     /*  919819 */     GIR_EraseRootFromParent_Done,
     /*  919820 */   // Label 13971: @919820
     /*  919820 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(919908), // Rule ID 23738 //
     /*  919825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919872 */     // MIs[1] Operand 1
     /*  919872 */     // No operand predicates
     /*  919872 */     // MIs[0] policy
     /*  919872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919884 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  919887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919906 */     GIR_RootConstrainSelectedInstOperands,
     /*  919907 */     // GIR_Coverage, 23738,
     /*  919907 */     GIR_EraseRootFromParent_Done,
     /*  919908 */   // Label 13972: @919908
     /*  919908 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(919996), // Rule ID 23739 //
     /*  919913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  919921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919960 */     // MIs[1] Operand 1
     /*  919960 */     // No operand predicates
     /*  919960 */     // MIs[0] policy
     /*  919960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  919975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919994 */     GIR_RootConstrainSelectedInstOperands,
     /*  919995 */     // GIR_Coverage, 23739,
     /*  919995 */     GIR_EraseRootFromParent_Done,
     /*  919996 */   // Label 13973: @919996
     /*  919996 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(920084), // Rule ID 23742 //
     /*  920001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920048 */     // MIs[1] Operand 1
     /*  920048 */     // No operand predicates
     /*  920048 */     // MIs[0] policy
     /*  920048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920082 */     GIR_RootConstrainSelectedInstOperands,
     /*  920083 */     // GIR_Coverage, 23742,
     /*  920083 */     GIR_EraseRootFromParent_Done,
     /*  920084 */   // Label 13974: @920084
     /*  920084 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(920172), // Rule ID 23743 //
     /*  920089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920136 */     // MIs[1] Operand 1
     /*  920136 */     // No operand predicates
     /*  920136 */     // MIs[0] policy
     /*  920136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920170 */     GIR_RootConstrainSelectedInstOperands,
     /*  920171 */     // GIR_Coverage, 23743,
     /*  920171 */     GIR_EraseRootFromParent_Done,
     /*  920172 */   // Label 13975: @920172
     /*  920172 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(920260), // Rule ID 23746 //
     /*  920177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920224 */     // MIs[1] Operand 1
     /*  920224 */     // No operand predicates
     /*  920224 */     // MIs[0] policy
     /*  920224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920258 */     GIR_RootConstrainSelectedInstOperands,
     /*  920259 */     // GIR_Coverage, 23746,
     /*  920259 */     GIR_EraseRootFromParent_Done,
     /*  920260 */   // Label 13976: @920260
     /*  920260 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(920348), // Rule ID 23747 //
     /*  920265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920312 */     // MIs[1] Operand 1
     /*  920312 */     // No operand predicates
     /*  920312 */     // MIs[0] policy
     /*  920312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920346 */     GIR_RootConstrainSelectedInstOperands,
     /*  920347 */     // GIR_Coverage, 23747,
     /*  920347 */     GIR_EraseRootFromParent_Done,
     /*  920348 */   // Label 13977: @920348
     /*  920348 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(920436), // Rule ID 23750 //
     /*  920353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920400 */     // MIs[1] Operand 1
     /*  920400 */     // No operand predicates
     /*  920400 */     // MIs[0] policy
     /*  920400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920434 */     GIR_RootConstrainSelectedInstOperands,
     /*  920435 */     // GIR_Coverage, 23750,
     /*  920435 */     GIR_EraseRootFromParent_Done,
     /*  920436 */   // Label 13978: @920436
     /*  920436 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(920524), // Rule ID 23751 //
     /*  920441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920488 */     // MIs[1] Operand 1
     /*  920488 */     // No operand predicates
     /*  920488 */     // MIs[0] policy
     /*  920488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920522 */     GIR_RootConstrainSelectedInstOperands,
     /*  920523 */     // GIR_Coverage, 23751,
     /*  920523 */     GIR_EraseRootFromParent_Done,
     /*  920524 */   // Label 13979: @920524
     /*  920524 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(920612), // Rule ID 23754 //
     /*  920529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920576 */     // MIs[1] Operand 1
     /*  920576 */     // No operand predicates
     /*  920576 */     // MIs[0] policy
     /*  920576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920610 */     GIR_RootConstrainSelectedInstOperands,
     /*  920611 */     // GIR_Coverage, 23754,
     /*  920611 */     GIR_EraseRootFromParent_Done,
     /*  920612 */   // Label 13980: @920612
     /*  920612 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(920700), // Rule ID 23755 //
     /*  920617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920664 */     // MIs[1] Operand 1
     /*  920664 */     // No operand predicates
     /*  920664 */     // MIs[0] policy
     /*  920664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  920679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920698 */     GIR_RootConstrainSelectedInstOperands,
     /*  920699 */     // GIR_Coverage, 23755,
     /*  920699 */     GIR_EraseRootFromParent_Done,
     /*  920700 */   // Label 13981: @920700
     /*  920700 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(920788), // Rule ID 23758 //
     /*  920705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920752 */     // MIs[1] Operand 1
     /*  920752 */     // No operand predicates
     /*  920752 */     // MIs[0] policy
     /*  920752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920786 */     GIR_RootConstrainSelectedInstOperands,
     /*  920787 */     // GIR_Coverage, 23758,
     /*  920787 */     GIR_EraseRootFromParent_Done,
     /*  920788 */   // Label 13982: @920788
     /*  920788 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(920876), // Rule ID 23759 //
     /*  920793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920840 */     // MIs[1] Operand 1
     /*  920840 */     // No operand predicates
     /*  920840 */     // MIs[0] policy
     /*  920840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  920855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920874 */     GIR_RootConstrainSelectedInstOperands,
     /*  920875 */     // GIR_Coverage, 23759,
     /*  920875 */     GIR_EraseRootFromParent_Done,
     /*  920876 */   // Label 13983: @920876
     /*  920876 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(920964), // Rule ID 23762 //
     /*  920881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920928 */     // MIs[1] Operand 1
     /*  920928 */     // No operand predicates
     /*  920928 */     // MIs[0] policy
     /*  920928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  920943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920962 */     GIR_RootConstrainSelectedInstOperands,
     /*  920963 */     // GIR_Coverage, 23762,
     /*  920963 */     GIR_EraseRootFromParent_Done,
     /*  920964 */   // Label 13984: @920964
     /*  920964 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(921052), // Rule ID 23763 //
     /*  920969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  920977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921016 */     // MIs[1] Operand 1
     /*  921016 */     // No operand predicates
     /*  921016 */     // MIs[0] policy
     /*  921016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921050 */     GIR_RootConstrainSelectedInstOperands,
     /*  921051 */     // GIR_Coverage, 23763,
     /*  921051 */     GIR_EraseRootFromParent_Done,
     /*  921052 */   // Label 13985: @921052
     /*  921052 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(921140), // Rule ID 23766 //
     /*  921057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921104 */     // MIs[1] Operand 1
     /*  921104 */     // No operand predicates
     /*  921104 */     // MIs[0] policy
     /*  921104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  921119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921138 */     GIR_RootConstrainSelectedInstOperands,
     /*  921139 */     // GIR_Coverage, 23766,
     /*  921139 */     GIR_EraseRootFromParent_Done,
     /*  921140 */   // Label 13986: @921140
     /*  921140 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(921228), // Rule ID 23767 //
     /*  921145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921192 */     // MIs[1] Operand 1
     /*  921192 */     // No operand predicates
     /*  921192 */     // MIs[0] policy
     /*  921192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  921207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921226 */     GIR_RootConstrainSelectedInstOperands,
     /*  921227 */     // GIR_Coverage, 23767,
     /*  921227 */     GIR_EraseRootFromParent_Done,
     /*  921228 */   // Label 13987: @921228
     /*  921228 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(921316), // Rule ID 23770 //
     /*  921233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921280 */     // MIs[1] Operand 1
     /*  921280 */     // No operand predicates
     /*  921280 */     // MIs[0] policy
     /*  921280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921292 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  921295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921314 */     GIR_RootConstrainSelectedInstOperands,
     /*  921315 */     // GIR_Coverage, 23770,
     /*  921315 */     GIR_EraseRootFromParent_Done,
     /*  921316 */   // Label 13988: @921316
     /*  921316 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(921404), // Rule ID 23771 //
     /*  921321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921368 */     // MIs[1] Operand 1
     /*  921368 */     // No operand predicates
     /*  921368 */     // MIs[0] policy
     /*  921368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  921383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921402 */     GIR_RootConstrainSelectedInstOperands,
     /*  921403 */     // GIR_Coverage, 23771,
     /*  921403 */     GIR_EraseRootFromParent_Done,
     /*  921404 */   // Label 13989: @921404
     /*  921404 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(921492), // Rule ID 23774 //
     /*  921409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921456 */     // MIs[1] Operand 1
     /*  921456 */     // No operand predicates
     /*  921456 */     // MIs[0] policy
     /*  921456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921490 */     GIR_RootConstrainSelectedInstOperands,
     /*  921491 */     // GIR_Coverage, 23774,
     /*  921491 */     GIR_EraseRootFromParent_Done,
     /*  921492 */   // Label 13990: @921492
     /*  921492 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(921580), // Rule ID 23775 //
     /*  921497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921544 */     // MIs[1] Operand 1
     /*  921544 */     // No operand predicates
     /*  921544 */     // MIs[0] policy
     /*  921544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921556 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  921559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921578 */     GIR_RootConstrainSelectedInstOperands,
     /*  921579 */     // GIR_Coverage, 23775,
     /*  921579 */     GIR_EraseRootFromParent_Done,
     /*  921580 */   // Label 13991: @921580
     /*  921580 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(921668), // Rule ID 23866 //
     /*  921585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  921596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  921599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  921602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921632 */     // MIs[1] Operand 1
     /*  921632 */     // No operand predicates
     /*  921632 */     // MIs[0] policy
     /*  921632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  921647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921666 */     GIR_RootConstrainSelectedInstOperands,
     /*  921667 */     // GIR_Coverage, 23866,
     /*  921667 */     GIR_EraseRootFromParent_Done,
     /*  921668 */   // Label 13992: @921668
     /*  921668 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(921756), // Rule ID 23867 //
     /*  921673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  921684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  921687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  921690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921720 */     // MIs[1] Operand 1
     /*  921720 */     // No operand predicates
     /*  921720 */     // MIs[0] policy
     /*  921720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  921735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921754 */     GIR_RootConstrainSelectedInstOperands,
     /*  921755 */     // GIR_Coverage, 23867,
     /*  921755 */     GIR_EraseRootFromParent_Done,
     /*  921756 */   // Label 13993: @921756
     /*  921756 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(921844), // Rule ID 23870 //
     /*  921761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  921772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  921775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  921778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921808 */     // MIs[1] Operand 1
     /*  921808 */     // No operand predicates
     /*  921808 */     // MIs[0] policy
     /*  921808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  921823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921842 */     GIR_RootConstrainSelectedInstOperands,
     /*  921843 */     // GIR_Coverage, 23870,
     /*  921843 */     GIR_EraseRootFromParent_Done,
     /*  921844 */   // Label 13994: @921844
     /*  921844 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(921932), // Rule ID 23871 //
     /*  921849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  921860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  921863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  921866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921896 */     // MIs[1] Operand 1
     /*  921896 */     // No operand predicates
     /*  921896 */     // MIs[0] policy
     /*  921896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  921911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  921928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921930 */     GIR_RootConstrainSelectedInstOperands,
     /*  921931 */     // GIR_Coverage, 23871,
     /*  921931 */     GIR_EraseRootFromParent_Done,
     /*  921932 */   // Label 13995: @921932
     /*  921932 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(922020), // Rule ID 23874 //
     /*  921937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  921940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  921948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  921951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  921954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921984 */     // MIs[1] Operand 1
     /*  921984 */     // No operand predicates
     /*  921984 */     // MIs[0] policy
     /*  921984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  921999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922018 */     GIR_RootConstrainSelectedInstOperands,
     /*  922019 */     // GIR_Coverage, 23874,
     /*  922019 */     GIR_EraseRootFromParent_Done,
     /*  922020 */   // Label 13996: @922020
     /*  922020 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(922108), // Rule ID 23875 //
     /*  922025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  922036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  922039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  922042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922072 */     // MIs[1] Operand 1
     /*  922072 */     // No operand predicates
     /*  922072 */     // MIs[0] policy
     /*  922072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922084 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922106 */     GIR_RootConstrainSelectedInstOperands,
     /*  922107 */     // GIR_Coverage, 23875,
     /*  922107 */     GIR_EraseRootFromParent_Done,
     /*  922108 */   // Label 13997: @922108
     /*  922108 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(922196), // Rule ID 23878 //
     /*  922113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922160 */     // MIs[1] Operand 1
     /*  922160 */     // No operand predicates
     /*  922160 */     // MIs[0] policy
     /*  922160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922172 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  922175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922194 */     GIR_RootConstrainSelectedInstOperands,
     /*  922195 */     // GIR_Coverage, 23878,
     /*  922195 */     GIR_EraseRootFromParent_Done,
     /*  922196 */   // Label 13998: @922196
     /*  922196 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(922284), // Rule ID 23879 //
     /*  922201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  922212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  922215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  922218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922248 */     // MIs[1] Operand 1
     /*  922248 */     // No operand predicates
     /*  922248 */     // MIs[0] policy
     /*  922248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  922263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922282 */     GIR_RootConstrainSelectedInstOperands,
     /*  922283 */     // GIR_Coverage, 23879,
     /*  922283 */     GIR_EraseRootFromParent_Done,
     /*  922284 */   // Label 13999: @922284
     /*  922284 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(922372), // Rule ID 23882 //
     /*  922289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922336 */     // MIs[1] Operand 1
     /*  922336 */     // No operand predicates
     /*  922336 */     // MIs[0] policy
     /*  922336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922370 */     GIR_RootConstrainSelectedInstOperands,
     /*  922371 */     // GIR_Coverage, 23882,
     /*  922371 */     GIR_EraseRootFromParent_Done,
     /*  922372 */   // Label 14000: @922372
     /*  922372 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(922460), // Rule ID 23883 //
     /*  922377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  922388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  922391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  922394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922424 */     // MIs[1] Operand 1
     /*  922424 */     // No operand predicates
     /*  922424 */     // MIs[0] policy
     /*  922424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922458 */     GIR_RootConstrainSelectedInstOperands,
     /*  922459 */     // GIR_Coverage, 23883,
     /*  922459 */     GIR_EraseRootFromParent_Done,
     /*  922460 */   // Label 14001: @922460
     /*  922460 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(922548), // Rule ID 23886 //
     /*  922465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922512 */     // MIs[1] Operand 1
     /*  922512 */     // No operand predicates
     /*  922512 */     // MIs[0] policy
     /*  922512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922546 */     GIR_RootConstrainSelectedInstOperands,
     /*  922547 */     // GIR_Coverage, 23886,
     /*  922547 */     GIR_EraseRootFromParent_Done,
     /*  922548 */   // Label 14002: @922548
     /*  922548 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(922636), // Rule ID 23887 //
     /*  922553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922600 */     // MIs[1] Operand 1
     /*  922600 */     // No operand predicates
     /*  922600 */     // MIs[0] policy
     /*  922600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  922615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922634 */     GIR_RootConstrainSelectedInstOperands,
     /*  922635 */     // GIR_Coverage, 23887,
     /*  922635 */     GIR_EraseRootFromParent_Done,
     /*  922636 */   // Label 14003: @922636
     /*  922636 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(922724), // Rule ID 23890 //
     /*  922641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  922652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  922655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  922658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922688 */     // MIs[1] Operand 1
     /*  922688 */     // No operand predicates
     /*  922688 */     // MIs[0] policy
     /*  922688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922722 */     GIR_RootConstrainSelectedInstOperands,
     /*  922723 */     // GIR_Coverage, 23890,
     /*  922723 */     GIR_EraseRootFromParent_Done,
     /*  922724 */   // Label 14004: @922724
     /*  922724 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(922812), // Rule ID 23891 //
     /*  922729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  922740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  922743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  922746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922776 */     // MIs[1] Operand 1
     /*  922776 */     // No operand predicates
     /*  922776 */     // MIs[0] policy
     /*  922776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  922808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922810 */     GIR_RootConstrainSelectedInstOperands,
     /*  922811 */     // GIR_Coverage, 23891,
     /*  922811 */     GIR_EraseRootFromParent_Done,
     /*  922812 */   // Label 14005: @922812
     /*  922812 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(922900), // Rule ID 23894 //
     /*  922817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922864 */     // MIs[1] Operand 1
     /*  922864 */     // No operand predicates
     /*  922864 */     // MIs[0] policy
     /*  922864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922898 */     GIR_RootConstrainSelectedInstOperands,
     /*  922899 */     // GIR_Coverage, 23894,
     /*  922899 */     GIR_EraseRootFromParent_Done,
     /*  922900 */   // Label 14006: @922900
     /*  922900 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(922988), // Rule ID 23895 //
     /*  922905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  922908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  922913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922952 */     // MIs[1] Operand 1
     /*  922952 */     // No operand predicates
     /*  922952 */     // MIs[0] policy
     /*  922952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  922967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922986 */     GIR_RootConstrainSelectedInstOperands,
     /*  922987 */     // GIR_Coverage, 23895,
     /*  922987 */     GIR_EraseRootFromParent_Done,
     /*  922988 */   // Label 14007: @922988
     /*  922988 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(923076), // Rule ID 23898 //
     /*  922993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  922996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  923004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  923007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  923010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923040 */     // MIs[1] Operand 1
     /*  923040 */     // No operand predicates
     /*  923040 */     // MIs[0] policy
     /*  923040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923074 */     GIR_RootConstrainSelectedInstOperands,
     /*  923075 */     // GIR_Coverage, 23898,
     /*  923075 */     GIR_EraseRootFromParent_Done,
     /*  923076 */   // Label 14008: @923076
     /*  923076 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(923164), // Rule ID 23899 //
     /*  923081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  923092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  923095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  923098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923128 */     // MIs[1] Operand 1
     /*  923128 */     // No operand predicates
     /*  923128 */     // MIs[0] policy
     /*  923128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923162 */     GIR_RootConstrainSelectedInstOperands,
     /*  923163 */     // GIR_Coverage, 23899,
     /*  923163 */     GIR_EraseRootFromParent_Done,
     /*  923164 */   // Label 14009: @923164
     /*  923164 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(923252), // Rule ID 23902 //
     /*  923169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  923172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923216 */     // MIs[1] Operand 1
     /*  923216 */     // No operand predicates
     /*  923216 */     // MIs[0] policy
     /*  923216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923228 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923250 */     GIR_RootConstrainSelectedInstOperands,
     /*  923251 */     // GIR_Coverage, 23902,
     /*  923251 */     GIR_EraseRootFromParent_Done,
     /*  923252 */   // Label 14010: @923252
     /*  923252 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(923340), // Rule ID 23903 //
     /*  923257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  923260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  923268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  923271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  923274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923304 */     // MIs[1] Operand 1
     /*  923304 */     // No operand predicates
     /*  923304 */     // MIs[0] policy
     /*  923304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  923319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923338 */     GIR_RootConstrainSelectedInstOperands,
     /*  923339 */     // GIR_Coverage, 23903,
     /*  923339 */     GIR_EraseRootFromParent_Done,
     /*  923340 */   // Label 14011: @923340
     /*  923340 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(923428), // Rule ID 23906 //
     /*  923345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  923356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  923359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  923362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923392 */     // MIs[1] Operand 1
     /*  923392 */     // No operand predicates
     /*  923392 */     // MIs[0] policy
     /*  923392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923426 */     GIR_RootConstrainSelectedInstOperands,
     /*  923427 */     // GIR_Coverage, 23906,
     /*  923427 */     GIR_EraseRootFromParent_Done,
     /*  923428 */   // Label 14012: @923428
     /*  923428 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(923516), // Rule ID 23907 //
     /*  923433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  923444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  923447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  923450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923480 */     // MIs[1] Operand 1
     /*  923480 */     // No operand predicates
     /*  923480 */     // MIs[0] policy
     /*  923480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923514 */     GIR_RootConstrainSelectedInstOperands,
     /*  923515 */     // GIR_Coverage, 23907,
     /*  923515 */     GIR_EraseRootFromParent_Done,
     /*  923516 */   // Label 14013: @923516
     /*  923516 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(923604), // Rule ID 23910 //
     /*  923521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  923532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  923535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  923538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923568 */     // MIs[1] Operand 1
     /*  923568 */     // No operand predicates
     /*  923568 */     // MIs[0] policy
     /*  923568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  923583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923602 */     GIR_RootConstrainSelectedInstOperands,
     /*  923603 */     // GIR_Coverage, 23910,
     /*  923603 */     GIR_EraseRootFromParent_Done,
     /*  923604 */   // Label 14014: @923604
     /*  923604 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(923692), // Rule ID 23911 //
     /*  923609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  923620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  923623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  923626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923656 */     // MIs[1] Operand 1
     /*  923656 */     // No operand predicates
     /*  923656 */     // MIs[0] policy
     /*  923656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  923671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923690 */     GIR_RootConstrainSelectedInstOperands,
     /*  923691 */     // GIR_Coverage, 23911,
     /*  923691 */     GIR_EraseRootFromParent_Done,
     /*  923692 */   // Label 14015: @923692
     /*  923692 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(923780), // Rule ID 23914 //
     /*  923697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  923708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  923711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  923714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923744 */     // MIs[1] Operand 1
     /*  923744 */     // No operand predicates
     /*  923744 */     // MIs[0] policy
     /*  923744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  923759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923778 */     GIR_RootConstrainSelectedInstOperands,
     /*  923779 */     // GIR_Coverage, 23914,
     /*  923779 */     GIR_EraseRootFromParent_Done,
     /*  923780 */   // Label 14016: @923780
     /*  923780 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(923868), // Rule ID 23915 //
     /*  923785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  923796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  923799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  923802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923832 */     // MIs[1] Operand 1
     /*  923832 */     // No operand predicates
     /*  923832 */     // MIs[0] policy
     /*  923832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  923847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  923864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923866 */     GIR_RootConstrainSelectedInstOperands,
     /*  923867 */     // GIR_Coverage, 23915,
     /*  923867 */     GIR_EraseRootFromParent_Done,
     /*  923868 */   // Label 14017: @923868
     /*  923868 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(923956), // Rule ID 23918 //
     /*  923873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  923876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923920 */     // MIs[1] Operand 1
     /*  923920 */     // No operand predicates
     /*  923920 */     // MIs[0] policy
     /*  923920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  923935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923954 */     GIR_RootConstrainSelectedInstOperands,
     /*  923955 */     // GIR_Coverage, 23918,
     /*  923955 */     GIR_EraseRootFromParent_Done,
     /*  923956 */   // Label 14018: @923956
     /*  923956 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(924044), // Rule ID 23919 //
     /*  923961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  923964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  923972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  923975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  923978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924008 */     // MIs[1] Operand 1
     /*  924008 */     // No operand predicates
     /*  924008 */     // MIs[0] policy
     /*  924008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924042 */     GIR_RootConstrainSelectedInstOperands,
     /*  924043 */     // GIR_Coverage, 23919,
     /*  924043 */     GIR_EraseRootFromParent_Done,
     /*  924044 */   // Label 14019: @924044
     /*  924044 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(924132), // Rule ID 23922 //
     /*  924049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  924060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  924063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  924066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924096 */     // MIs[1] Operand 1
     /*  924096 */     // No operand predicates
     /*  924096 */     // MIs[0] policy
     /*  924096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924130 */     GIR_RootConstrainSelectedInstOperands,
     /*  924131 */     // GIR_Coverage, 23922,
     /*  924131 */     GIR_EraseRootFromParent_Done,
     /*  924132 */   // Label 14020: @924132
     /*  924132 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(924220), // Rule ID 23923 //
     /*  924137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  924148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  924151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  924154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924184 */     // MIs[1] Operand 1
     /*  924184 */     // No operand predicates
     /*  924184 */     // MIs[0] policy
     /*  924184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924218 */     GIR_RootConstrainSelectedInstOperands,
     /*  924219 */     // GIR_Coverage, 23923,
     /*  924219 */     GIR_EraseRootFromParent_Done,
     /*  924220 */   // Label 14021: @924220
     /*  924220 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(924308), // Rule ID 23926 //
     /*  924225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  924236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  924239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  924242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924272 */     // MIs[1] Operand 1
     /*  924272 */     // No operand predicates
     /*  924272 */     // MIs[0] policy
     /*  924272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924306 */     GIR_RootConstrainSelectedInstOperands,
     /*  924307 */     // GIR_Coverage, 23926,
     /*  924307 */     GIR_EraseRootFromParent_Done,
     /*  924308 */   // Label 14022: @924308
     /*  924308 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(924396), // Rule ID 23927 //
     /*  924313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  924324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  924327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  924330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924360 */     // MIs[1] Operand 1
     /*  924360 */     // No operand predicates
     /*  924360 */     // MIs[0] policy
     /*  924360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924394 */     GIR_RootConstrainSelectedInstOperands,
     /*  924395 */     // GIR_Coverage, 23927,
     /*  924395 */     GIR_EraseRootFromParent_Done,
     /*  924396 */   // Label 14023: @924396
     /*  924396 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(924484), // Rule ID 23930 //
     /*  924401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  924412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  924415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  924418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924448 */     // MIs[1] Operand 1
     /*  924448 */     // No operand predicates
     /*  924448 */     // MIs[0] policy
     /*  924448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924482 */     GIR_RootConstrainSelectedInstOperands,
     /*  924483 */     // GIR_Coverage, 23930,
     /*  924483 */     GIR_EraseRootFromParent_Done,
     /*  924484 */   // Label 14024: @924484
     /*  924484 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(924572), // Rule ID 23931 //
     /*  924489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  924500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  924503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  924506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924536 */     // MIs[1] Operand 1
     /*  924536 */     // No operand predicates
     /*  924536 */     // MIs[0] policy
     /*  924536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924570 */     GIR_RootConstrainSelectedInstOperands,
     /*  924571 */     // GIR_Coverage, 23931,
     /*  924571 */     GIR_EraseRootFromParent_Done,
     /*  924572 */   // Label 14025: @924572
     /*  924572 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(924660), // Rule ID 23934 //
     /*  924577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  924588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  924591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  924594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924624 */     // MIs[1] Operand 1
     /*  924624 */     // No operand predicates
     /*  924624 */     // MIs[0] policy
     /*  924624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924658 */     GIR_RootConstrainSelectedInstOperands,
     /*  924659 */     // GIR_Coverage, 23934,
     /*  924659 */     GIR_EraseRootFromParent_Done,
     /*  924660 */   // Label 14026: @924660
     /*  924660 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(924748), // Rule ID 23935 //
     /*  924665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  924676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  924679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  924682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924712 */     // MIs[1] Operand 1
     /*  924712 */     // No operand predicates
     /*  924712 */     // MIs[0] policy
     /*  924712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  924727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924746 */     GIR_RootConstrainSelectedInstOperands,
     /*  924747 */     // GIR_Coverage, 23935,
     /*  924747 */     GIR_EraseRootFromParent_Done,
     /*  924748 */   // Label 14027: @924748
     /*  924748 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(924836), // Rule ID 23938 //
     /*  924753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  924756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924800 */     // MIs[1] Operand 1
     /*  924800 */     // No operand predicates
     /*  924800 */     // MIs[0] policy
     /*  924800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924834 */     GIR_RootConstrainSelectedInstOperands,
     /*  924835 */     // GIR_Coverage, 23938,
     /*  924835 */     GIR_EraseRootFromParent_Done,
     /*  924836 */   // Label 14028: @924836
     /*  924836 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(924924), // Rule ID 23939 //
     /*  924841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  924844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  924852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  924855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  924858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924888 */     // MIs[1] Operand 1
     /*  924888 */     // No operand predicates
     /*  924888 */     // MIs[0] policy
     /*  924888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924900 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  924903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924922 */     GIR_RootConstrainSelectedInstOperands,
     /*  924923 */     // GIR_Coverage, 23939,
     /*  924923 */     GIR_EraseRootFromParent_Done,
     /*  924924 */   // Label 14029: @924924
     /*  924924 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(925012), // Rule ID 23942 //
     /*  924929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  924932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  924940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  924943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  924946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924976 */     // MIs[1] Operand 1
     /*  924976 */     // No operand predicates
     /*  924976 */     // MIs[0] policy
     /*  924976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925010 */     GIR_RootConstrainSelectedInstOperands,
     /*  925011 */     // GIR_Coverage, 23942,
     /*  925011 */     GIR_EraseRootFromParent_Done,
     /*  925012 */   // Label 14030: @925012
     /*  925012 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(925100), // Rule ID 23943 //
     /*  925017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  925028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  925031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  925034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925064 */     // MIs[1] Operand 1
     /*  925064 */     // No operand predicates
     /*  925064 */     // MIs[0] policy
     /*  925064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925076 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925098 */     GIR_RootConstrainSelectedInstOperands,
     /*  925099 */     // GIR_Coverage, 23943,
     /*  925099 */     GIR_EraseRootFromParent_Done,
     /*  925100 */   // Label 14031: @925100
     /*  925100 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(925188), // Rule ID 23946 //
     /*  925105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  925116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  925119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  925122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925152 */     // MIs[1] Operand 1
     /*  925152 */     // No operand predicates
     /*  925152 */     // MIs[0] policy
     /*  925152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925186 */     GIR_RootConstrainSelectedInstOperands,
     /*  925187 */     // GIR_Coverage, 23946,
     /*  925187 */     GIR_EraseRootFromParent_Done,
     /*  925188 */   // Label 14032: @925188
     /*  925188 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(925276), // Rule ID 23947 //
     /*  925193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  925204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  925207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  925210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925240 */     // MIs[1] Operand 1
     /*  925240 */     // No operand predicates
     /*  925240 */     // MIs[0] policy
     /*  925240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925274 */     GIR_RootConstrainSelectedInstOperands,
     /*  925275 */     // GIR_Coverage, 23947,
     /*  925275 */     GIR_EraseRootFromParent_Done,
     /*  925276 */   // Label 14033: @925276
     /*  925276 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(925364), // Rule ID 23950 //
     /*  925281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  925284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  925292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  925295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  925298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925328 */     // MIs[1] Operand 1
     /*  925328 */     // No operand predicates
     /*  925328 */     // MIs[0] policy
     /*  925328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925362 */     GIR_RootConstrainSelectedInstOperands,
     /*  925363 */     // GIR_Coverage, 23950,
     /*  925363 */     GIR_EraseRootFromParent_Done,
     /*  925364 */   // Label 14034: @925364
     /*  925364 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(925452), // Rule ID 23951 //
     /*  925369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  925372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  925380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  925383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  925386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925416 */     // MIs[1] Operand 1
     /*  925416 */     // No operand predicates
     /*  925416 */     // MIs[0] policy
     /*  925416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925450 */     GIR_RootConstrainSelectedInstOperands,
     /*  925451 */     // GIR_Coverage, 23951,
     /*  925451 */     GIR_EraseRootFromParent_Done,
     /*  925452 */   // Label 14035: @925452
     /*  925452 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(925540), // Rule ID 24190 //
     /*  925457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  925468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  925471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  925474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925504 */     // MIs[1] Operand 1
     /*  925504 */     // No operand predicates
     /*  925504 */     // MIs[0] policy
     /*  925504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925516 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  925519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925538 */     GIR_RootConstrainSelectedInstOperands,
     /*  925539 */     // GIR_Coverage, 24190,
     /*  925539 */     GIR_EraseRootFromParent_Done,
     /*  925540 */   // Label 14036: @925540
     /*  925540 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(925628), // Rule ID 24191 //
     /*  925545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  925556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  925559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  925562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925592 */     // MIs[1] Operand 1
     /*  925592 */     // No operand predicates
     /*  925592 */     // MIs[0] policy
     /*  925592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925604 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  925607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925626 */     GIR_RootConstrainSelectedInstOperands,
     /*  925627 */     // GIR_Coverage, 24191,
     /*  925627 */     GIR_EraseRootFromParent_Done,
     /*  925628 */   // Label 14037: @925628
     /*  925628 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(925716), // Rule ID 24194 //
     /*  925633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  925644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  925647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925680 */     // MIs[1] Operand 1
     /*  925680 */     // No operand predicates
     /*  925680 */     // MIs[0] policy
     /*  925680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925714 */     GIR_RootConstrainSelectedInstOperands,
     /*  925715 */     // GIR_Coverage, 24194,
     /*  925715 */     GIR_EraseRootFromParent_Done,
     /*  925716 */   // Label 14038: @925716
     /*  925716 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(925804), // Rule ID 24195 //
     /*  925721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  925732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  925735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  925738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925768 */     // MIs[1] Operand 1
     /*  925768 */     // No operand predicates
     /*  925768 */     // MIs[0] policy
     /*  925768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925780 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925802 */     GIR_RootConstrainSelectedInstOperands,
     /*  925803 */     // GIR_Coverage, 24195,
     /*  925803 */     GIR_EraseRootFromParent_Done,
     /*  925804 */   // Label 14039: @925804
     /*  925804 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(925892), // Rule ID 24198 //
     /*  925809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925856 */     // MIs[1] Operand 1
     /*  925856 */     // No operand predicates
     /*  925856 */     // MIs[0] policy
     /*  925856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925868 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925890 */     GIR_RootConstrainSelectedInstOperands,
     /*  925891 */     // GIR_Coverage, 24198,
     /*  925891 */     GIR_EraseRootFromParent_Done,
     /*  925892 */   // Label 14040: @925892
     /*  925892 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(925980), // Rule ID 24199 //
     /*  925897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  925908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  925911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  925914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925944 */     // MIs[1] Operand 1
     /*  925944 */     // No operand predicates
     /*  925944 */     // MIs[0] policy
     /*  925944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  925959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925978 */     GIR_RootConstrainSelectedInstOperands,
     /*  925979 */     // GIR_Coverage, 24199,
     /*  925979 */     GIR_EraseRootFromParent_Done,
     /*  925980 */   // Label 14041: @925980
     /*  925980 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(926068), // Rule ID 24202 //
     /*  925985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  925993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  925996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  925999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  926002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926032 */     // MIs[1] Operand 1
     /*  926032 */     // No operand predicates
     /*  926032 */     // MIs[0] policy
     /*  926032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926066 */     GIR_RootConstrainSelectedInstOperands,
     /*  926067 */     // GIR_Coverage, 24202,
     /*  926067 */     GIR_EraseRootFromParent_Done,
     /*  926068 */   // Label 14042: @926068
     /*  926068 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(926156), // Rule ID 24203 //
     /*  926073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  926084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  926087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  926090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926120 */     // MIs[1] Operand 1
     /*  926120 */     // No operand predicates
     /*  926120 */     // MIs[0] policy
     /*  926120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926154 */     GIR_RootConstrainSelectedInstOperands,
     /*  926155 */     // GIR_Coverage, 24203,
     /*  926155 */     GIR_EraseRootFromParent_Done,
     /*  926156 */   // Label 14043: @926156
     /*  926156 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(926244), // Rule ID 24206 //
     /*  926161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  926164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  926172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  926175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  926178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926208 */     // MIs[1] Operand 1
     /*  926208 */     // No operand predicates
     /*  926208 */     // MIs[0] policy
     /*  926208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926220 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926242 */     GIR_RootConstrainSelectedInstOperands,
     /*  926243 */     // GIR_Coverage, 24206,
     /*  926243 */     GIR_EraseRootFromParent_Done,
     /*  926244 */   // Label 14044: @926244
     /*  926244 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(926332), // Rule ID 24207 //
     /*  926249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  926252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  926260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  926263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  926266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926296 */     // MIs[1] Operand 1
     /*  926296 */     // No operand predicates
     /*  926296 */     // MIs[0] policy
     /*  926296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926330 */     GIR_RootConstrainSelectedInstOperands,
     /*  926331 */     // GIR_Coverage, 24207,
     /*  926331 */     GIR_EraseRootFromParent_Done,
     /*  926332 */   // Label 14045: @926332
     /*  926332 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(926420), // Rule ID 24210 //
     /*  926337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  926348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  926351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  926354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926384 */     // MIs[1] Operand 1
     /*  926384 */     // No operand predicates
     /*  926384 */     // MIs[0] policy
     /*  926384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926418 */     GIR_RootConstrainSelectedInstOperands,
     /*  926419 */     // GIR_Coverage, 24210,
     /*  926419 */     GIR_EraseRootFromParent_Done,
     /*  926420 */   // Label 14046: @926420
     /*  926420 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(926508), // Rule ID 24211 //
     /*  926425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  926436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  926439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  926442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926472 */     // MIs[1] Operand 1
     /*  926472 */     // No operand predicates
     /*  926472 */     // MIs[0] policy
     /*  926472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  926487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926506 */     GIR_RootConstrainSelectedInstOperands,
     /*  926507 */     // GIR_Coverage, 24211,
     /*  926507 */     GIR_EraseRootFromParent_Done,
     /*  926508 */   // Label 14047: @926508
     /*  926508 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(926596), // Rule ID 24214 //
     /*  926513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  926524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  926527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  926530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926560 */     // MIs[1] Operand 1
     /*  926560 */     // No operand predicates
     /*  926560 */     // MIs[0] policy
     /*  926560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  926575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926594 */     GIR_RootConstrainSelectedInstOperands,
     /*  926595 */     // GIR_Coverage, 24214,
     /*  926595 */     GIR_EraseRootFromParent_Done,
     /*  926596 */   // Label 14048: @926596
     /*  926596 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(926684), // Rule ID 24215 //
     /*  926601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  926612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  926615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  926618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926648 */     // MIs[1] Operand 1
     /*  926648 */     // No operand predicates
     /*  926648 */     // MIs[0] policy
     /*  926648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926660 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  926663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926682 */     GIR_RootConstrainSelectedInstOperands,
     /*  926683 */     // GIR_Coverage, 24215,
     /*  926683 */     GIR_EraseRootFromParent_Done,
     /*  926684 */   // Label 14049: @926684
     /*  926684 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(926772), // Rule ID 24218 //
     /*  926689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926736 */     // MIs[1] Operand 1
     /*  926736 */     // No operand predicates
     /*  926736 */     // MIs[0] policy
     /*  926736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926748 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  926751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926770 */     GIR_RootConstrainSelectedInstOperands,
     /*  926771 */     // GIR_Coverage, 24218,
     /*  926771 */     GIR_EraseRootFromParent_Done,
     /*  926772 */   // Label 14050: @926772
     /*  926772 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(926860), // Rule ID 24219 //
     /*  926777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  926788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  926791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  926794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926824 */     // MIs[1] Operand 1
     /*  926824 */     // No operand predicates
     /*  926824 */     // MIs[0] policy
     /*  926824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926836 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  926839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926858 */     GIR_RootConstrainSelectedInstOperands,
     /*  926859 */     // GIR_Coverage, 24219,
     /*  926859 */     GIR_EraseRootFromParent_Done,
     /*  926860 */   // Label 14051: @926860
     /*  926860 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(926948), // Rule ID 24222 //
     /*  926865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  926868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926912 */     // MIs[1] Operand 1
     /*  926912 */     // No operand predicates
     /*  926912 */     // MIs[0] policy
     /*  926912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  926927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  926944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926946 */     GIR_RootConstrainSelectedInstOperands,
     /*  926947 */     // GIR_Coverage, 24222,
     /*  926947 */     GIR_EraseRootFromParent_Done,
     /*  926948 */   // Label 14052: @926948
     /*  926948 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(927036), // Rule ID 24223 //
     /*  926953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  926956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  926961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  926964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  926967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  926970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927000 */     // MIs[1] Operand 1
     /*  927000 */     // No operand predicates
     /*  927000 */     // MIs[0] policy
     /*  927000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927012 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927034 */     GIR_RootConstrainSelectedInstOperands,
     /*  927035 */     // GIR_Coverage, 24223,
     /*  927035 */     GIR_EraseRootFromParent_Done,
     /*  927036 */   // Label 14053: @927036
     /*  927036 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(927124), // Rule ID 24226 //
     /*  927041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  927052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  927055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  927058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927088 */     // MIs[1] Operand 1
     /*  927088 */     // No operand predicates
     /*  927088 */     // MIs[0] policy
     /*  927088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927122 */     GIR_RootConstrainSelectedInstOperands,
     /*  927123 */     // GIR_Coverage, 24226,
     /*  927123 */     GIR_EraseRootFromParent_Done,
     /*  927124 */   // Label 14054: @927124
     /*  927124 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(927212), // Rule ID 24227 //
     /*  927129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  927140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  927143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  927146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927176 */     // MIs[1] Operand 1
     /*  927176 */     // No operand predicates
     /*  927176 */     // MIs[0] policy
     /*  927176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927188 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927210 */     GIR_RootConstrainSelectedInstOperands,
     /*  927211 */     // GIR_Coverage, 24227,
     /*  927211 */     GIR_EraseRootFromParent_Done,
     /*  927212 */   // Label 14055: @927212
     /*  927212 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(927300), // Rule ID 24230 //
     /*  927217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  927228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  927231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  927234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927264 */     // MIs[1] Operand 1
     /*  927264 */     // No operand predicates
     /*  927264 */     // MIs[0] policy
     /*  927264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927298 */     GIR_RootConstrainSelectedInstOperands,
     /*  927299 */     // GIR_Coverage, 24230,
     /*  927299 */     GIR_EraseRootFromParent_Done,
     /*  927300 */   // Label 14056: @927300
     /*  927300 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(927388), // Rule ID 24231 //
     /*  927305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  927316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  927319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  927322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927352 */     // MIs[1] Operand 1
     /*  927352 */     // No operand predicates
     /*  927352 */     // MIs[0] policy
     /*  927352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927364 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927386 */     GIR_RootConstrainSelectedInstOperands,
     /*  927387 */     // GIR_Coverage, 24231,
     /*  927387 */     GIR_EraseRootFromParent_Done,
     /*  927388 */   // Label 14057: @927388
     /*  927388 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(927476), // Rule ID 24234 //
     /*  927393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  927396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  927404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  927407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  927410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927440 */     // MIs[1] Operand 1
     /*  927440 */     // No operand predicates
     /*  927440 */     // MIs[0] policy
     /*  927440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927452 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927474 */     GIR_RootConstrainSelectedInstOperands,
     /*  927475 */     // GIR_Coverage, 24234,
     /*  927475 */     GIR_EraseRootFromParent_Done,
     /*  927476 */   // Label 14058: @927476
     /*  927476 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(927564), // Rule ID 24235 //
     /*  927481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  927484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  927492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  927495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  927498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927528 */     // MIs[1] Operand 1
     /*  927528 */     // No operand predicates
     /*  927528 */     // MIs[0] policy
     /*  927528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927540 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927562 */     GIR_RootConstrainSelectedInstOperands,
     /*  927563 */     // GIR_Coverage, 24235,
     /*  927563 */     GIR_EraseRootFromParent_Done,
     /*  927564 */   // Label 14059: @927564
     /*  927564 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(927652), // Rule ID 24238 //
     /*  927569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  927580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  927583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  927586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927616 */     // MIs[1] Operand 1
     /*  927616 */     // No operand predicates
     /*  927616 */     // MIs[0] policy
     /*  927616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927650 */     GIR_RootConstrainSelectedInstOperands,
     /*  927651 */     // GIR_Coverage, 24238,
     /*  927651 */     GIR_EraseRootFromParent_Done,
     /*  927652 */   // Label 14060: @927652
     /*  927652 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(927740), // Rule ID 24239 //
     /*  927657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  927660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  927668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  927671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  927674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  927692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927704 */     // MIs[1] Operand 1
     /*  927704 */     // No operand predicates
     /*  927704 */     // MIs[0] policy
     /*  927704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  927719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927738 */     GIR_RootConstrainSelectedInstOperands,
     /*  927739 */     // GIR_Coverage, 24239,
     /*  927739 */     GIR_EraseRootFromParent_Done,
     /*  927740 */   // Label 14061: @927740
     /*  927740 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(927828), // Rule ID 24242 //
     /*  927745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927792 */     // MIs[1] Operand 1
     /*  927792 */     // No operand predicates
     /*  927792 */     // MIs[0] policy
     /*  927792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927826 */     GIR_RootConstrainSelectedInstOperands,
     /*  927827 */     // GIR_Coverage, 24242,
     /*  927827 */     GIR_EraseRootFromParent_Done,
     /*  927828 */   // Label 14062: @927828
     /*  927828 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(927916), // Rule ID 24243 //
     /*  927833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  927836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  927844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  927847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  927850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  927856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  927868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927880 */     // MIs[1] Operand 1
     /*  927880 */     // No operand predicates
     /*  927880 */     // MIs[0] policy
     /*  927880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927892 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  927892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  927895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  927912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  927914 */     GIR_RootConstrainSelectedInstOperands,
     /*  927915 */     // GIR_Coverage, 24243,
     /*  927915 */     GIR_EraseRootFromParent_Done,
     /*  927916 */   // Label 14063: @927916
     /*  927916 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(928004), // Rule ID 24246 //
     /*  927921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  927924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  927929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  927932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  927935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  927938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  927944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  927956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927968 */     // MIs[1] Operand 1
     /*  927968 */     // No operand predicates
     /*  927968 */     // MIs[0] policy
     /*  927968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  927971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927980 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  927980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  927983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  927987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928002 */     GIR_RootConstrainSelectedInstOperands,
     /*  928003 */     // GIR_Coverage, 24246,
     /*  928003 */     GIR_EraseRootFromParent_Done,
     /*  928004 */   // Label 14064: @928004
     /*  928004 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(928092), // Rule ID 24247 //
     /*  928009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  928012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  928017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  928020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  928023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  928026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928056 */     // MIs[1] Operand 1
     /*  928056 */     // No operand predicates
     /*  928056 */     // MIs[0] policy
     /*  928056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928068 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  928071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928090 */     GIR_RootConstrainSelectedInstOperands,
     /*  928091 */     // GIR_Coverage, 24247,
     /*  928091 */     GIR_EraseRootFromParent_Done,
     /*  928092 */   // Label 14065: @928092
     /*  928092 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(928180), // Rule ID 24310 //
     /*  928097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928144 */     // MIs[1] Operand 1
     /*  928144 */     // No operand predicates
     /*  928144 */     // MIs[0] policy
     /*  928144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928156 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  928159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928178 */     GIR_RootConstrainSelectedInstOperands,
     /*  928179 */     // GIR_Coverage, 24310,
     /*  928179 */     GIR_EraseRootFromParent_Done,
     /*  928180 */   // Label 14066: @928180
     /*  928180 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(928268), // Rule ID 24311 //
     /*  928185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  928196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  928199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  928202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928232 */     // MIs[1] Operand 1
     /*  928232 */     // No operand predicates
     /*  928232 */     // MIs[0] policy
     /*  928232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928244 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  928247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928266 */     GIR_RootConstrainSelectedInstOperands,
     /*  928267 */     // GIR_Coverage, 24311,
     /*  928267 */     GIR_EraseRootFromParent_Done,
     /*  928268 */   // Label 14067: @928268
     /*  928268 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(928356), // Rule ID 24314 //
     /*  928273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928320 */     // MIs[1] Operand 1
     /*  928320 */     // No operand predicates
     /*  928320 */     // MIs[0] policy
     /*  928320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928332 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928354 */     GIR_RootConstrainSelectedInstOperands,
     /*  928355 */     // GIR_Coverage, 24314,
     /*  928355 */     GIR_EraseRootFromParent_Done,
     /*  928356 */   // Label 14068: @928356
     /*  928356 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(928444), // Rule ID 24315 //
     /*  928361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  928372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  928375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  928378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928408 */     // MIs[1] Operand 1
     /*  928408 */     // No operand predicates
     /*  928408 */     // MIs[0] policy
     /*  928408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928420 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928442 */     GIR_RootConstrainSelectedInstOperands,
     /*  928443 */     // GIR_Coverage, 24315,
     /*  928443 */     GIR_EraseRootFromParent_Done,
     /*  928444 */   // Label 14069: @928444
     /*  928444 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(928532), // Rule ID 24318 //
     /*  928449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  928452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928496 */     // MIs[1] Operand 1
     /*  928496 */     // No operand predicates
     /*  928496 */     // MIs[0] policy
     /*  928496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928508 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928530 */     GIR_RootConstrainSelectedInstOperands,
     /*  928531 */     // GIR_Coverage, 24318,
     /*  928531 */     GIR_EraseRootFromParent_Done,
     /*  928532 */   // Label 14070: @928532
     /*  928532 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(928620), // Rule ID 24319 //
     /*  928537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  928540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  928548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  928551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  928554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928584 */     // MIs[1] Operand 1
     /*  928584 */     // No operand predicates
     /*  928584 */     // MIs[0] policy
     /*  928584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  928599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928618 */     GIR_RootConstrainSelectedInstOperands,
     /*  928619 */     // GIR_Coverage, 24319,
     /*  928619 */     GIR_EraseRootFromParent_Done,
     /*  928620 */   // Label 14071: @928620
     /*  928620 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(928708), // Rule ID 24322 //
     /*  928625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  928628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928672 */     // MIs[1] Operand 1
     /*  928672 */     // No operand predicates
     /*  928672 */     // MIs[0] policy
     /*  928672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928706 */     GIR_RootConstrainSelectedInstOperands,
     /*  928707 */     // GIR_Coverage, 24322,
     /*  928707 */     GIR_EraseRootFromParent_Done,
     /*  928708 */   // Label 14072: @928708
     /*  928708 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(928796), // Rule ID 24323 //
     /*  928713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  928716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928760 */     // MIs[1] Operand 1
     /*  928760 */     // No operand predicates
     /*  928760 */     // MIs[0] policy
     /*  928760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928794 */     GIR_RootConstrainSelectedInstOperands,
     /*  928795 */     // GIR_Coverage, 24323,
     /*  928795 */     GIR_EraseRootFromParent_Done,
     /*  928796 */   // Label 14073: @928796
     /*  928796 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(928884), // Rule ID 24326 //
     /*  928801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  928804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  928824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928848 */     // MIs[1] Operand 1
     /*  928848 */     // No operand predicates
     /*  928848 */     // MIs[0] policy
     /*  928848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  928860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928882 */     GIR_RootConstrainSelectedInstOperands,
     /*  928883 */     // GIR_Coverage, 24326,
     /*  928883 */     GIR_EraseRootFromParent_Done,
     /*  928884 */   // Label 14074: @928884
     /*  928884 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(928972), // Rule ID 24327 //
     /*  928889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  928892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  928912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928936 */     // MIs[1] Operand 1
     /*  928936 */     // No operand predicates
     /*  928936 */     // MIs[0] policy
     /*  928936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  928939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  928948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  928951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  928955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  928970 */     GIR_RootConstrainSelectedInstOperands,
     /*  928971 */     // GIR_Coverage, 24327,
     /*  928971 */     GIR_EraseRootFromParent_Done,
     /*  928972 */   // Label 14075: @928972
     /*  928972 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(929060), // Rule ID 24330 //
     /*  928977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  928980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  928985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929024 */     // MIs[1] Operand 1
     /*  929024 */     // No operand predicates
     /*  929024 */     // MIs[0] policy
     /*  929024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  929039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929058 */     GIR_RootConstrainSelectedInstOperands,
     /*  929059 */     // GIR_Coverage, 24330,
     /*  929059 */     GIR_EraseRootFromParent_Done,
     /*  929060 */   // Label 14076: @929060
     /*  929060 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(929148), // Rule ID 24331 //
     /*  929065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  929068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  929076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  929079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  929082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  929100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929112 */     // MIs[1] Operand 1
     /*  929112 */     // No operand predicates
     /*  929112 */     // MIs[0] policy
     /*  929112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929124 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  929127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929146 */     GIR_RootConstrainSelectedInstOperands,
     /*  929147 */     // GIR_Coverage, 24331,
     /*  929147 */     GIR_EraseRootFromParent_Done,
     /*  929148 */   // Label 14077: @929148
     /*  929148 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(929236), // Rule ID 24334 //
     /*  929153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929200 */     // MIs[1] Operand 1
     /*  929200 */     // No operand predicates
     /*  929200 */     // MIs[0] policy
     /*  929200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929234 */     GIR_RootConstrainSelectedInstOperands,
     /*  929235 */     // GIR_Coverage, 24334,
     /*  929235 */     GIR_EraseRootFromParent_Done,
     /*  929236 */   // Label 14078: @929236
     /*  929236 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(929324), // Rule ID 24335 //
     /*  929241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929288 */     // MIs[1] Operand 1
     /*  929288 */     // No operand predicates
     /*  929288 */     // MIs[0] policy
     /*  929288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929300 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929322 */     GIR_RootConstrainSelectedInstOperands,
     /*  929323 */     // GIR_Coverage, 24335,
     /*  929323 */     GIR_EraseRootFromParent_Done,
     /*  929324 */   // Label 14079: @929324
     /*  929324 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(929412), // Rule ID 24338 //
     /*  929329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929376 */     // MIs[1] Operand 1
     /*  929376 */     // No operand predicates
     /*  929376 */     // MIs[0] policy
     /*  929376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929388 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929410 */     GIR_RootConstrainSelectedInstOperands,
     /*  929411 */     // GIR_Coverage, 24338,
     /*  929411 */     GIR_EraseRootFromParent_Done,
     /*  929412 */   // Label 14080: @929412
     /*  929412 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(929500), // Rule ID 24339 //
     /*  929417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929464 */     // MIs[1] Operand 1
     /*  929464 */     // No operand predicates
     /*  929464 */     // MIs[0] policy
     /*  929464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929476 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929498 */     GIR_RootConstrainSelectedInstOperands,
     /*  929499 */     // GIR_Coverage, 24339,
     /*  929499 */     GIR_EraseRootFromParent_Done,
     /*  929500 */   // Label 14081: @929500
     /*  929500 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(929588), // Rule ID 24342 //
     /*  929505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  929508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929552 */     // MIs[1] Operand 1
     /*  929552 */     // No operand predicates
     /*  929552 */     // MIs[0] policy
     /*  929552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929564 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  929567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929586 */     GIR_RootConstrainSelectedInstOperands,
     /*  929587 */     // GIR_Coverage, 24342,
     /*  929587 */     GIR_EraseRootFromParent_Done,
     /*  929588 */   // Label 14082: @929588
     /*  929588 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(929676), // Rule ID 24343 //
     /*  929593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  929596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929640 */     // MIs[1] Operand 1
     /*  929640 */     // No operand predicates
     /*  929640 */     // MIs[0] policy
     /*  929640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929652 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  929655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929674 */     GIR_RootConstrainSelectedInstOperands,
     /*  929675 */     // GIR_Coverage, 24343,
     /*  929675 */     GIR_EraseRootFromParent_Done,
     /*  929676 */   // Label 14083: @929676
     /*  929676 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(929764), // Rule ID 24346 //
     /*  929681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  929684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929728 */     // MIs[1] Operand 1
     /*  929728 */     // No operand predicates
     /*  929728 */     // MIs[0] policy
     /*  929728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929740 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929762 */     GIR_RootConstrainSelectedInstOperands,
     /*  929763 */     // GIR_Coverage, 24346,
     /*  929763 */     GIR_EraseRootFromParent_Done,
     /*  929764 */   // Label 14084: @929764
     /*  929764 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(929852), // Rule ID 24347 //
     /*  929769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  929772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929816 */     // MIs[1] Operand 1
     /*  929816 */     // No operand predicates
     /*  929816 */     // MIs[0] policy
     /*  929816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929828 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  929828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  929831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929850 */     GIR_RootConstrainSelectedInstOperands,
     /*  929851 */     // GIR_Coverage, 24347,
     /*  929851 */     GIR_EraseRootFromParent_Done,
     /*  929852 */   // Label 14085: @929852
     /*  929852 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(929940), // Rule ID 24350 //
     /*  929857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  929860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  929880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929904 */     // MIs[1] Operand 1
     /*  929904 */     // No operand predicates
     /*  929904 */     // MIs[0] policy
     /*  929904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  929916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  929919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  929923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  929938 */     GIR_RootConstrainSelectedInstOperands,
     /*  929939 */     // GIR_Coverage, 24350,
     /*  929939 */     GIR_EraseRootFromParent_Done,
     /*  929940 */   // Label 14086: @929940
     /*  929940 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(930028), // Rule ID 24351 //
     /*  929945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  929948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  929953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  929968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929992 */     // MIs[1] Operand 1
     /*  929992 */     // No operand predicates
     /*  929992 */     // MIs[0] policy
     /*  929992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  929995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930026 */     GIR_RootConstrainSelectedInstOperands,
     /*  930027 */     // GIR_Coverage, 24351,
     /*  930027 */     GIR_EraseRootFromParent_Done,
     /*  930028 */   // Label 14087: @930028
     /*  930028 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(930116), // Rule ID 24354 //
     /*  930033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  930036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930080 */     // MIs[1] Operand 1
     /*  930080 */     // No operand predicates
     /*  930080 */     // MIs[0] policy
     /*  930080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930114 */     GIR_RootConstrainSelectedInstOperands,
     /*  930115 */     // GIR_Coverage, 24354,
     /*  930115 */     GIR_EraseRootFromParent_Done,
     /*  930116 */   // Label 14088: @930116
     /*  930116 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(930204), // Rule ID 24355 //
     /*  930121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  930124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930168 */     // MIs[1] Operand 1
     /*  930168 */     // No operand predicates
     /*  930168 */     // MIs[0] policy
     /*  930168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930202 */     GIR_RootConstrainSelectedInstOperands,
     /*  930203 */     // GIR_Coverage, 24355,
     /*  930203 */     GIR_EraseRootFromParent_Done,
     /*  930204 */   // Label 14089: @930204
     /*  930204 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(930292), // Rule ID 24358 //
     /*  930209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930256 */     // MIs[1] Operand 1
     /*  930256 */     // No operand predicates
     /*  930256 */     // MIs[0] policy
     /*  930256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930268 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  930271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930290 */     GIR_RootConstrainSelectedInstOperands,
     /*  930291 */     // GIR_Coverage, 24358,
     /*  930291 */     GIR_EraseRootFromParent_Done,
     /*  930292 */   // Label 14090: @930292
     /*  930292 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(930380), // Rule ID 24359 //
     /*  930297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930344 */     // MIs[1] Operand 1
     /*  930344 */     // No operand predicates
     /*  930344 */     // MIs[0] policy
     /*  930344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930356 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  930359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930378 */     GIR_RootConstrainSelectedInstOperands,
     /*  930379 */     // GIR_Coverage, 24359,
     /*  930379 */     GIR_EraseRootFromParent_Done,
     /*  930380 */   // Label 14091: @930380
     /*  930380 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(930468), // Rule ID 24362 //
     /*  930385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930432 */     // MIs[1] Operand 1
     /*  930432 */     // No operand predicates
     /*  930432 */     // MIs[0] policy
     /*  930432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930444 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930466 */     GIR_RootConstrainSelectedInstOperands,
     /*  930467 */     // GIR_Coverage, 24362,
     /*  930467 */     GIR_EraseRootFromParent_Done,
     /*  930468 */   // Label 14092: @930468
     /*  930468 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(930556), // Rule ID 24363 //
     /*  930473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930520 */     // MIs[1] Operand 1
     /*  930520 */     // No operand predicates
     /*  930520 */     // MIs[0] policy
     /*  930520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  930535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930554 */     GIR_RootConstrainSelectedInstOperands,
     /*  930555 */     // GIR_Coverage, 24363,
     /*  930555 */     GIR_EraseRootFromParent_Done,
     /*  930556 */   // Label 14093: @930556
     /*  930556 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(930644), // Rule ID 24366 //
     /*  930561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  930564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  930584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930608 */     // MIs[1] Operand 1
     /*  930608 */     // No operand predicates
     /*  930608 */     // MIs[0] policy
     /*  930608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930620 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  930620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930642 */     GIR_RootConstrainSelectedInstOperands,
     /*  930643 */     // GIR_Coverage, 24366,
     /*  930643 */     GIR_EraseRootFromParent_Done,
     /*  930644 */   // Label 14094: @930644
     /*  930644 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(930732), // Rule ID 24367 //
     /*  930649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  930652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  930657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  930672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930696 */     // MIs[1] Operand 1
     /*  930696 */     // No operand predicates
     /*  930696 */     // MIs[0] policy
     /*  930696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  930699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930708 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  930708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  930711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  930715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  930730 */     GIR_RootConstrainSelectedInstOperands,
     /*  930731 */     // GIR_Coverage, 24367,
     /*  930731 */     GIR_EraseRootFromParent_Done,
     /*  930732 */   // Label 14095: @930732
     /*  930732 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(930823), // Rule ID 15978 //
     /*  930737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930784 */     // MIs[1] Operand 1
     /*  930784 */     // No operand predicates
     /*  930784 */     // MIs[0] round
     /*  930784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  930799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930821 */     GIR_RootConstrainSelectedInstOperands,
     /*  930822 */     // GIR_Coverage, 15978,
     /*  930822 */     GIR_EraseRootFromParent_Done,
     /*  930823 */   // Label 14096: @930823
     /*  930823 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(930914), // Rule ID 15979 //
     /*  930828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930875 */     // MIs[1] Operand 1
     /*  930875 */     // No operand predicates
     /*  930875 */     // MIs[0] round
     /*  930875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930887 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  930887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  930890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930912 */     GIR_RootConstrainSelectedInstOperands,
     /*  930913 */     // GIR_Coverage, 15979,
     /*  930913 */     GIR_EraseRootFromParent_Done,
     /*  930914 */   // Label 14097: @930914
     /*  930914 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(931005), // Rule ID 15982 //
     /*  930919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930966 */     // MIs[1] Operand 1
     /*  930966 */     // No operand predicates
     /*  930966 */     // MIs[0] round
     /*  930966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930978 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  930981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931003 */     GIR_RootConstrainSelectedInstOperands,
     /*  931004 */     // GIR_Coverage, 15982,
     /*  931004 */     GIR_EraseRootFromParent_Done,
     /*  931005 */   // Label 14098: @931005
     /*  931005 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(931096), // Rule ID 15983 //
     /*  931010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931057 */     // MIs[1] Operand 1
     /*  931057 */     // No operand predicates
     /*  931057 */     // MIs[0] round
     /*  931057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931094 */     GIR_RootConstrainSelectedInstOperands,
     /*  931095 */     // GIR_Coverage, 15983,
     /*  931095 */     GIR_EraseRootFromParent_Done,
     /*  931096 */   // Label 14099: @931096
     /*  931096 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(931187), // Rule ID 15986 //
     /*  931101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931148 */     // MIs[1] Operand 1
     /*  931148 */     // No operand predicates
     /*  931148 */     // MIs[0] round
     /*  931148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931172 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931185 */     GIR_RootConstrainSelectedInstOperands,
     /*  931186 */     // GIR_Coverage, 15986,
     /*  931186 */     GIR_EraseRootFromParent_Done,
     /*  931187 */   // Label 14100: @931187
     /*  931187 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(931278), // Rule ID 15987 //
     /*  931192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931239 */     // MIs[1] Operand 1
     /*  931239 */     // No operand predicates
     /*  931239 */     // MIs[0] round
     /*  931239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931251 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931276 */     GIR_RootConstrainSelectedInstOperands,
     /*  931277 */     // GIR_Coverage, 15987,
     /*  931277 */     GIR_EraseRootFromParent_Done,
     /*  931278 */   // Label 14101: @931278
     /*  931278 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(931369), // Rule ID 15990 //
     /*  931283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931330 */     // MIs[1] Operand 1
     /*  931330 */     // No operand predicates
     /*  931330 */     // MIs[0] round
     /*  931330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931367 */     GIR_RootConstrainSelectedInstOperands,
     /*  931368 */     // GIR_Coverage, 15990,
     /*  931368 */     GIR_EraseRootFromParent_Done,
     /*  931369 */   // Label 14102: @931369
     /*  931369 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(931460), // Rule ID 15991 //
     /*  931374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931421 */     // MIs[1] Operand 1
     /*  931421 */     // No operand predicates
     /*  931421 */     // MIs[0] round
     /*  931421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931433 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  931436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931458 */     GIR_RootConstrainSelectedInstOperands,
     /*  931459 */     // GIR_Coverage, 15991,
     /*  931459 */     GIR_EraseRootFromParent_Done,
     /*  931460 */   // Label 14103: @931460
     /*  931460 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(931551), // Rule ID 15994 //
     /*  931465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931512 */     // MIs[1] Operand 1
     /*  931512 */     // No operand predicates
     /*  931512 */     // MIs[0] round
     /*  931512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931549 */     GIR_RootConstrainSelectedInstOperands,
     /*  931550 */     // GIR_Coverage, 15994,
     /*  931550 */     GIR_EraseRootFromParent_Done,
     /*  931551 */   // Label 14104: @931551
     /*  931551 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(931642), // Rule ID 15995 //
     /*  931556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931603 */     // MIs[1] Operand 1
     /*  931603 */     // No operand predicates
     /*  931603 */     // MIs[0] round
     /*  931603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931640 */     GIR_RootConstrainSelectedInstOperands,
     /*  931641 */     // GIR_Coverage, 15995,
     /*  931641 */     GIR_EraseRootFromParent_Done,
     /*  931642 */   // Label 14105: @931642
     /*  931642 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(931733), // Rule ID 15998 //
     /*  931647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931694 */     // MIs[1] Operand 1
     /*  931694 */     // No operand predicates
     /*  931694 */     // MIs[0] round
     /*  931694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931718 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931731 */     GIR_RootConstrainSelectedInstOperands,
     /*  931732 */     // GIR_Coverage, 15998,
     /*  931732 */     GIR_EraseRootFromParent_Done,
     /*  931733 */   // Label 14106: @931733
     /*  931733 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(931824), // Rule ID 15999 //
     /*  931738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931785 */     // MIs[1] Operand 1
     /*  931785 */     // No operand predicates
     /*  931785 */     // MIs[0] round
     /*  931785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  931800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931822 */     GIR_RootConstrainSelectedInstOperands,
     /*  931823 */     // GIR_Coverage, 15999,
     /*  931823 */     GIR_EraseRootFromParent_Done,
     /*  931824 */   // Label 14107: @931824
     /*  931824 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(931915), // Rule ID 16002 //
     /*  931829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931876 */     // MIs[1] Operand 1
     /*  931876 */     // No operand predicates
     /*  931876 */     // MIs[0] round
     /*  931876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  931891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931913 */     GIR_RootConstrainSelectedInstOperands,
     /*  931914 */     // GIR_Coverage, 16002,
     /*  931914 */     GIR_EraseRootFromParent_Done,
     /*  931915 */   // Label 14108: @931915
     /*  931915 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(932006), // Rule ID 16003 //
     /*  931920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  931928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931967 */     // MIs[1] Operand 1
     /*  931967 */     // No operand predicates
     /*  931967 */     // MIs[0] round
     /*  931967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931979 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  931982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932004 */     GIR_RootConstrainSelectedInstOperands,
     /*  932005 */     // GIR_Coverage, 16003,
     /*  932005 */     GIR_EraseRootFromParent_Done,
     /*  932006 */   // Label 14109: @932006
     /*  932006 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(932097), // Rule ID 16006 //
     /*  932011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932058 */     // MIs[1] Operand 1
     /*  932058 */     // No operand predicates
     /*  932058 */     // MIs[0] round
     /*  932058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932095 */     GIR_RootConstrainSelectedInstOperands,
     /*  932096 */     // GIR_Coverage, 16006,
     /*  932096 */     GIR_EraseRootFromParent_Done,
     /*  932097 */   // Label 14110: @932097
     /*  932097 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(932188), // Rule ID 16007 //
     /*  932102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932149 */     // MIs[1] Operand 1
     /*  932149 */     // No operand predicates
     /*  932149 */     // MIs[0] round
     /*  932149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932161 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932186 */     GIR_RootConstrainSelectedInstOperands,
     /*  932187 */     // GIR_Coverage, 16007,
     /*  932187 */     GIR_EraseRootFromParent_Done,
     /*  932188 */   // Label 14111: @932188
     /*  932188 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(932279), // Rule ID 16010 //
     /*  932193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932240 */     // MIs[1] Operand 1
     /*  932240 */     // No operand predicates
     /*  932240 */     // MIs[0] round
     /*  932240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932264 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932277 */     GIR_RootConstrainSelectedInstOperands,
     /*  932278 */     // GIR_Coverage, 16010,
     /*  932278 */     GIR_EraseRootFromParent_Done,
     /*  932279 */   // Label 14112: @932279
     /*  932279 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(932370), // Rule ID 16011 //
     /*  932284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932331 */     // MIs[1] Operand 1
     /*  932331 */     // No operand predicates
     /*  932331 */     // MIs[0] round
     /*  932331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932343 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932368 */     GIR_RootConstrainSelectedInstOperands,
     /*  932369 */     // GIR_Coverage, 16011,
     /*  932369 */     GIR_EraseRootFromParent_Done,
     /*  932370 */   // Label 14113: @932370
     /*  932370 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(932461), // Rule ID 16014 //
     /*  932375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  932378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932422 */     // MIs[1] Operand 1
     /*  932422 */     // No operand predicates
     /*  932422 */     // MIs[0] round
     /*  932422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  932434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932459 */     GIR_RootConstrainSelectedInstOperands,
     /*  932460 */     // GIR_Coverage, 16014,
     /*  932460 */     GIR_EraseRootFromParent_Done,
     /*  932461 */   // Label 14114: @932461
     /*  932461 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(932552), // Rule ID 16015 //
     /*  932466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932513 */     // MIs[1] Operand 1
     /*  932513 */     // No operand predicates
     /*  932513 */     // MIs[0] round
     /*  932513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  932525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  932528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932550 */     GIR_RootConstrainSelectedInstOperands,
     /*  932551 */     // GIR_Coverage, 16015,
     /*  932551 */     GIR_EraseRootFromParent_Done,
     /*  932552 */   // Label 14115: @932552
     /*  932552 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(932643), // Rule ID 16018 //
     /*  932557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932604 */     // MIs[1] Operand 1
     /*  932604 */     // No operand predicates
     /*  932604 */     // MIs[0] round
     /*  932604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  932619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932641 */     GIR_RootConstrainSelectedInstOperands,
     /*  932642 */     // GIR_Coverage, 16018,
     /*  932642 */     GIR_EraseRootFromParent_Done,
     /*  932643 */   // Label 14116: @932643
     /*  932643 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(932734), // Rule ID 16019 //
     /*  932648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932695 */     // MIs[1] Operand 1
     /*  932695 */     // No operand predicates
     /*  932695 */     // MIs[0] round
     /*  932695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  932710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932732 */     GIR_RootConstrainSelectedInstOperands,
     /*  932733 */     // GIR_Coverage, 16019,
     /*  932733 */     GIR_EraseRootFromParent_Done,
     /*  932734 */   // Label 14117: @932734
     /*  932734 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(932825), // Rule ID 16022 //
     /*  932739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932786 */     // MIs[1] Operand 1
     /*  932786 */     // No operand predicates
     /*  932786 */     // MIs[0] round
     /*  932786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  932801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932810 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932823 */     GIR_RootConstrainSelectedInstOperands,
     /*  932824 */     // GIR_Coverage, 16022,
     /*  932824 */     GIR_EraseRootFromParent_Done,
     /*  932825 */   // Label 14118: @932825
     /*  932825 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(932916), // Rule ID 16023 //
     /*  932830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932877 */     // MIs[1] Operand 1
     /*  932877 */     // No operand predicates
     /*  932877 */     // MIs[0] round
     /*  932877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932889 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  932892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932914 */     GIR_RootConstrainSelectedInstOperands,
     /*  932915 */     // GIR_Coverage, 16023,
     /*  932915 */     GIR_EraseRootFromParent_Done,
     /*  932916 */   // Label 14119: @932916
     /*  932916 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(933007), // Rule ID 16026 //
     /*  932921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  932929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932968 */     // MIs[1] Operand 1
     /*  932968 */     // No operand predicates
     /*  932968 */     // MIs[0] round
     /*  932968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  932983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932992 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933005 */     GIR_RootConstrainSelectedInstOperands,
     /*  933006 */     // GIR_Coverage, 16026,
     /*  933006 */     GIR_EraseRootFromParent_Done,
     /*  933007 */   // Label 14120: @933007
     /*  933007 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(933098), // Rule ID 16027 //
     /*  933012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933059 */     // MIs[1] Operand 1
     /*  933059 */     // No operand predicates
     /*  933059 */     // MIs[0] round
     /*  933059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933096 */     GIR_RootConstrainSelectedInstOperands,
     /*  933097 */     // GIR_Coverage, 16027,
     /*  933097 */     GIR_EraseRootFromParent_Done,
     /*  933098 */   // Label 14121: @933098
     /*  933098 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(933189), // Rule ID 16030 //
     /*  933103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933150 */     // MIs[1] Operand 1
     /*  933150 */     // No operand predicates
     /*  933150 */     // MIs[0] round
     /*  933150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933162 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933187 */     GIR_RootConstrainSelectedInstOperands,
     /*  933188 */     // GIR_Coverage, 16030,
     /*  933188 */     GIR_EraseRootFromParent_Done,
     /*  933189 */   // Label 14122: @933189
     /*  933189 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(933280), // Rule ID 16031 //
     /*  933194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933241 */     // MIs[1] Operand 1
     /*  933241 */     // No operand predicates
     /*  933241 */     // MIs[0] round
     /*  933241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933253 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933278 */     GIR_RootConstrainSelectedInstOperands,
     /*  933279 */     // GIR_Coverage, 16031,
     /*  933279 */     GIR_EraseRootFromParent_Done,
     /*  933280 */   // Label 14123: @933280
     /*  933280 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(933371), // Rule ID 16034 //
     /*  933285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933332 */     // MIs[1] Operand 1
     /*  933332 */     // No operand predicates
     /*  933332 */     // MIs[0] round
     /*  933332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933356 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933369 */     GIR_RootConstrainSelectedInstOperands,
     /*  933370 */     // GIR_Coverage, 16034,
     /*  933370 */     GIR_EraseRootFromParent_Done,
     /*  933371 */   // Label 14124: @933371
     /*  933371 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(933462), // Rule ID 16035 //
     /*  933376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933423 */     // MIs[1] Operand 1
     /*  933423 */     // No operand predicates
     /*  933423 */     // MIs[0] round
     /*  933423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933435 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933460 */     GIR_RootConstrainSelectedInstOperands,
     /*  933461 */     // GIR_Coverage, 16035,
     /*  933461 */     GIR_EraseRootFromParent_Done,
     /*  933462 */   // Label 14125: @933462
     /*  933462 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(933553), // Rule ID 16038 //
     /*  933467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933514 */     // MIs[1] Operand 1
     /*  933514 */     // No operand predicates
     /*  933514 */     // MIs[0] round
     /*  933514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933538 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933551 */     GIR_RootConstrainSelectedInstOperands,
     /*  933552 */     // GIR_Coverage, 16038,
     /*  933552 */     GIR_EraseRootFromParent_Done,
     /*  933553 */   // Label 14126: @933553
     /*  933553 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(933644), // Rule ID 16039 //
     /*  933558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933605 */     // MIs[1] Operand 1
     /*  933605 */     // No operand predicates
     /*  933605 */     // MIs[0] round
     /*  933605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933617 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  933620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933642 */     GIR_RootConstrainSelectedInstOperands,
     /*  933643 */     // GIR_Coverage, 16039,
     /*  933643 */     GIR_EraseRootFromParent_Done,
     /*  933644 */   // Label 14127: @933644
     /*  933644 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(933735), // Rule ID 16042 //
     /*  933649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933696 */     // MIs[1] Operand 1
     /*  933696 */     // No operand predicates
     /*  933696 */     // MIs[0] round
     /*  933696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933733 */     GIR_RootConstrainSelectedInstOperands,
     /*  933734 */     // GIR_Coverage, 16042,
     /*  933734 */     GIR_EraseRootFromParent_Done,
     /*  933735 */   // Label 14128: @933735
     /*  933735 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(933826), // Rule ID 16043 //
     /*  933740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933787 */     // MIs[1] Operand 1
     /*  933787 */     // No operand predicates
     /*  933787 */     // MIs[0] round
     /*  933787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  933802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933824 */     GIR_RootConstrainSelectedInstOperands,
     /*  933825 */     // GIR_Coverage, 16043,
     /*  933825 */     GIR_EraseRootFromParent_Done,
     /*  933826 */   // Label 14129: @933826
     /*  933826 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(933917), // Rule ID 16046 //
     /*  933831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933878 */     // MIs[1] Operand 1
     /*  933878 */     // No operand predicates
     /*  933878 */     // MIs[0] round
     /*  933878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933915 */     GIR_RootConstrainSelectedInstOperands,
     /*  933916 */     // GIR_Coverage, 16046,
     /*  933916 */     GIR_EraseRootFromParent_Done,
     /*  933917 */   // Label 14130: @933917
     /*  933917 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(934008), // Rule ID 16047 //
     /*  933922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  933930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933969 */     // MIs[1] Operand 1
     /*  933969 */     // No operand predicates
     /*  933969 */     // MIs[0] round
     /*  933969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  933984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934006 */     GIR_RootConstrainSelectedInstOperands,
     /*  934007 */     // GIR_Coverage, 16047,
     /*  934007 */     GIR_EraseRootFromParent_Done,
     /*  934008 */   // Label 14131: @934008
     /*  934008 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(934099), // Rule ID 16050 //
     /*  934013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934060 */     // MIs[1] Operand 1
     /*  934060 */     // No operand predicates
     /*  934060 */     // MIs[0] round
     /*  934060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934072 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934097 */     GIR_RootConstrainSelectedInstOperands,
     /*  934098 */     // GIR_Coverage, 16050,
     /*  934098 */     GIR_EraseRootFromParent_Done,
     /*  934099 */   // Label 14132: @934099
     /*  934099 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(934190), // Rule ID 16051 //
     /*  934104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934151 */     // MIs[1] Operand 1
     /*  934151 */     // No operand predicates
     /*  934151 */     // MIs[0] round
     /*  934151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934163 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934188 */     GIR_RootConstrainSelectedInstOperands,
     /*  934189 */     // GIR_Coverage, 16051,
     /*  934189 */     GIR_EraseRootFromParent_Done,
     /*  934190 */   // Label 14133: @934190
     /*  934190 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(934281), // Rule ID 16054 //
     /*  934195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934242 */     // MIs[1] Operand 1
     /*  934242 */     // No operand predicates
     /*  934242 */     // MIs[0] round
     /*  934242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  934257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934279 */     GIR_RootConstrainSelectedInstOperands,
     /*  934280 */     // GIR_Coverage, 16054,
     /*  934280 */     GIR_EraseRootFromParent_Done,
     /*  934281 */   // Label 14134: @934281
     /*  934281 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(934372), // Rule ID 16055 //
     /*  934286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934333 */     // MIs[1] Operand 1
     /*  934333 */     // No operand predicates
     /*  934333 */     // MIs[0] round
     /*  934333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  934348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934370 */     GIR_RootConstrainSelectedInstOperands,
     /*  934371 */     // GIR_Coverage, 16055,
     /*  934371 */     GIR_EraseRootFromParent_Done,
     /*  934372 */   // Label 14135: @934372
     /*  934372 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(934463), // Rule ID 16058 //
     /*  934377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934424 */     // MIs[1] Operand 1
     /*  934424 */     // No operand predicates
     /*  934424 */     // MIs[0] round
     /*  934424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  934439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934461 */     GIR_RootConstrainSelectedInstOperands,
     /*  934462 */     // GIR_Coverage, 16058,
     /*  934462 */     GIR_EraseRootFromParent_Done,
     /*  934463 */   // Label 14136: @934463
     /*  934463 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(934554), // Rule ID 16059 //
     /*  934468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934515 */     // MIs[1] Operand 1
     /*  934515 */     // No operand predicates
     /*  934515 */     // MIs[0] round
     /*  934515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  934530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934552 */     GIR_RootConstrainSelectedInstOperands,
     /*  934553 */     // GIR_Coverage, 16059,
     /*  934553 */     GIR_EraseRootFromParent_Done,
     /*  934554 */   // Label 14137: @934554
     /*  934554 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(934645), // Rule ID 16062 //
     /*  934559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934606 */     // MIs[1] Operand 1
     /*  934606 */     // No operand predicates
     /*  934606 */     // MIs[0] round
     /*  934606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934643 */     GIR_RootConstrainSelectedInstOperands,
     /*  934644 */     // GIR_Coverage, 16062,
     /*  934644 */     GIR_EraseRootFromParent_Done,
     /*  934645 */   // Label 14138: @934645
     /*  934645 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(934736), // Rule ID 16063 //
     /*  934650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  934658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934697 */     // MIs[1] Operand 1
     /*  934697 */     // No operand predicates
     /*  934697 */     // MIs[0] round
     /*  934697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  934712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934734 */     GIR_RootConstrainSelectedInstOperands,
     /*  934735 */     // GIR_Coverage, 16063,
     /*  934735 */     GIR_EraseRootFromParent_Done,
     /*  934736 */   // Label 14139: @934736
     /*  934736 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(934827), // Rule ID 16242 //
     /*  934741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  934758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934788 */     // MIs[1] Operand 1
     /*  934788 */     // No operand predicates
     /*  934788 */     // MIs[0] round
     /*  934788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934800 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  934803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934825 */     GIR_RootConstrainSelectedInstOperands,
     /*  934826 */     // GIR_Coverage, 16242,
     /*  934826 */     GIR_EraseRootFromParent_Done,
     /*  934827 */   // Label 14140: @934827
     /*  934827 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(934918), // Rule ID 16243 //
     /*  934832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  934849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934879 */     // MIs[1] Operand 1
     /*  934879 */     // No operand predicates
     /*  934879 */     // MIs[0] round
     /*  934879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934891 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  934891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  934894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934916 */     GIR_RootConstrainSelectedInstOperands,
     /*  934917 */     // GIR_Coverage, 16243,
     /*  934917 */     GIR_EraseRootFromParent_Done,
     /*  934918 */   // Label 14141: @934918
     /*  934918 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(935009), // Rule ID 16246 //
     /*  934923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  934940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934970 */     // MIs[1] Operand 1
     /*  934970 */     // No operand predicates
     /*  934970 */     // MIs[0] round
     /*  934970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  934985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934994 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935007 */     GIR_RootConstrainSelectedInstOperands,
     /*  935008 */     // GIR_Coverage, 16246,
     /*  935008 */     GIR_EraseRootFromParent_Done,
     /*  935009 */   // Label 14142: @935009
     /*  935009 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(935100), // Rule ID 16247 //
     /*  935014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  935031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935061 */     // MIs[1] Operand 1
     /*  935061 */     // No operand predicates
     /*  935061 */     // MIs[0] round
     /*  935061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935073 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935098 */     GIR_RootConstrainSelectedInstOperands,
     /*  935099 */     // GIR_Coverage, 16247,
     /*  935099 */     GIR_EraseRootFromParent_Done,
     /*  935100 */   // Label 14143: @935100
     /*  935100 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(935191), // Rule ID 16250 //
     /*  935105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  935122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935152 */     // MIs[1] Operand 1
     /*  935152 */     // No operand predicates
     /*  935152 */     // MIs[0] round
     /*  935152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935176 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935189 */     GIR_RootConstrainSelectedInstOperands,
     /*  935190 */     // GIR_Coverage, 16250,
     /*  935190 */     GIR_EraseRootFromParent_Done,
     /*  935191 */   // Label 14144: @935191
     /*  935191 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(935282), // Rule ID 16251 //
     /*  935196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  935213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935243 */     // MIs[1] Operand 1
     /*  935243 */     // No operand predicates
     /*  935243 */     // MIs[0] round
     /*  935243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935255 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935280 */     GIR_RootConstrainSelectedInstOperands,
     /*  935281 */     // GIR_Coverage, 16251,
     /*  935281 */     GIR_EraseRootFromParent_Done,
     /*  935282 */   // Label 14145: @935282
     /*  935282 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(935373), // Rule ID 16254 //
     /*  935287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935334 */     // MIs[1] Operand 1
     /*  935334 */     // No operand predicates
     /*  935334 */     // MIs[0] round
     /*  935334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935358 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935371 */     GIR_RootConstrainSelectedInstOperands,
     /*  935372 */     // GIR_Coverage, 16254,
     /*  935372 */     GIR_EraseRootFromParent_Done,
     /*  935373 */   // Label 14146: @935373
     /*  935373 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(935464), // Rule ID 16255 //
     /*  935378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935425 */     // MIs[1] Operand 1
     /*  935425 */     // No operand predicates
     /*  935425 */     // MIs[0] round
     /*  935425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  935440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935462 */     GIR_RootConstrainSelectedInstOperands,
     /*  935463 */     // GIR_Coverage, 16255,
     /*  935463 */     GIR_EraseRootFromParent_Done,
     /*  935464 */   // Label 14147: @935464
     /*  935464 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(935555), // Rule ID 16258 //
     /*  935469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935516 */     // MIs[1] Operand 1
     /*  935516 */     // No operand predicates
     /*  935516 */     // MIs[0] round
     /*  935516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935553 */     GIR_RootConstrainSelectedInstOperands,
     /*  935554 */     // GIR_Coverage, 16258,
     /*  935554 */     GIR_EraseRootFromParent_Done,
     /*  935555 */   // Label 14148: @935555
     /*  935555 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(935646), // Rule ID 16259 //
     /*  935560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935607 */     // MIs[1] Operand 1
     /*  935607 */     // No operand predicates
     /*  935607 */     // MIs[0] round
     /*  935607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935644 */     GIR_RootConstrainSelectedInstOperands,
     /*  935645 */     // GIR_Coverage, 16259,
     /*  935645 */     GIR_EraseRootFromParent_Done,
     /*  935646 */   // Label 14149: @935646
     /*  935646 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(935737), // Rule ID 16262 //
     /*  935651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  935662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  935665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935698 */     // MIs[1] Operand 1
     /*  935698 */     // No operand predicates
     /*  935698 */     // MIs[0] round
     /*  935698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  935710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935722 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935735 */     GIR_RootConstrainSelectedInstOperands,
     /*  935736 */     // GIR_Coverage, 16262,
     /*  935736 */     GIR_EraseRootFromParent_Done,
     /*  935737 */   // Label 14150: @935737
     /*  935737 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(935828), // Rule ID 16263 //
     /*  935742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  935753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  935756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935789 */     // MIs[1] Operand 1
     /*  935789 */     // No operand predicates
     /*  935789 */     // MIs[0] round
     /*  935789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935801 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  935801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  935804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  935823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935826 */     GIR_RootConstrainSelectedInstOperands,
     /*  935827 */     // GIR_Coverage, 16263,
     /*  935827 */     GIR_EraseRootFromParent_Done,
     /*  935828 */   // Label 14151: @935828
     /*  935828 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(935919), // Rule ID 16266 //
     /*  935833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  935850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935880 */     // MIs[1] Operand 1
     /*  935880 */     // No operand predicates
     /*  935880 */     // MIs[0] round
     /*  935880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  935895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935917 */     GIR_RootConstrainSelectedInstOperands,
     /*  935918 */     // GIR_Coverage, 16266,
     /*  935918 */     GIR_EraseRootFromParent_Done,
     /*  935919 */   // Label 14152: @935919
     /*  935919 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(936010), // Rule ID 16267 //
     /*  935924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  935932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  935941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935971 */     // MIs[1] Operand 1
     /*  935971 */     // No operand predicates
     /*  935971 */     // MIs[0] round
     /*  935971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  935986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936008 */     GIR_RootConstrainSelectedInstOperands,
     /*  936009 */     // GIR_Coverage, 16267,
     /*  936009 */     GIR_EraseRootFromParent_Done,
     /*  936010 */   // Label 14153: @936010
     /*  936010 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(936101), // Rule ID 16270 //
     /*  936015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  936032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936062 */     // MIs[1] Operand 1
     /*  936062 */     // No operand predicates
     /*  936062 */     // MIs[0] round
     /*  936062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936099 */     GIR_RootConstrainSelectedInstOperands,
     /*  936100 */     // GIR_Coverage, 16270,
     /*  936100 */     GIR_EraseRootFromParent_Done,
     /*  936101 */   // Label 14154: @936101
     /*  936101 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(936192), // Rule ID 16271 //
     /*  936106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  936123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936153 */     // MIs[1] Operand 1
     /*  936153 */     // No operand predicates
     /*  936153 */     // MIs[0] round
     /*  936153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936190 */     GIR_RootConstrainSelectedInstOperands,
     /*  936191 */     // GIR_Coverage, 16271,
     /*  936191 */     GIR_EraseRootFromParent_Done,
     /*  936192 */   // Label 14155: @936192
     /*  936192 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(936283), // Rule ID 16274 //
     /*  936197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936244 */     // MIs[1] Operand 1
     /*  936244 */     // No operand predicates
     /*  936244 */     // MIs[0] round
     /*  936244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  936256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936281 */     GIR_RootConstrainSelectedInstOperands,
     /*  936282 */     // GIR_Coverage, 16274,
     /*  936282 */     GIR_EraseRootFromParent_Done,
     /*  936283 */   // Label 14156: @936283
     /*  936283 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(936374), // Rule ID 16275 //
     /*  936288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936335 */     // MIs[1] Operand 1
     /*  936335 */     // No operand predicates
     /*  936335 */     // MIs[0] round
     /*  936335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936347 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  936347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936372 */     GIR_RootConstrainSelectedInstOperands,
     /*  936373 */     // GIR_Coverage, 16275,
     /*  936373 */     GIR_EraseRootFromParent_Done,
     /*  936374 */   // Label 14157: @936374
     /*  936374 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(936465), // Rule ID 16278 //
     /*  936379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  936382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  936390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  936393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936426 */     // MIs[1] Operand 1
     /*  936426 */     // No operand predicates
     /*  936426 */     // MIs[0] round
     /*  936426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  936438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  936460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936463 */     GIR_RootConstrainSelectedInstOperands,
     /*  936464 */     // GIR_Coverage, 16278,
     /*  936464 */     GIR_EraseRootFromParent_Done,
     /*  936465 */   // Label 14158: @936465
     /*  936465 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(936556), // Rule ID 16279 //
     /*  936470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  936473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  936481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  936484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936517 */     // MIs[1] Operand 1
     /*  936517 */     // No operand predicates
     /*  936517 */     // MIs[0] round
     /*  936517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936529 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  936529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  936532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  936551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936554 */     GIR_RootConstrainSelectedInstOperands,
     /*  936555 */     // GIR_Coverage, 16279,
     /*  936555 */     GIR_EraseRootFromParent_Done,
     /*  936556 */   // Label 14159: @936556
     /*  936556 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(936647), // Rule ID 16282 //
     /*  936561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  936578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936608 */     // MIs[1] Operand 1
     /*  936608 */     // No operand predicates
     /*  936608 */     // MIs[0] round
     /*  936608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  936623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936645 */     GIR_RootConstrainSelectedInstOperands,
     /*  936646 */     // GIR_Coverage, 16282,
     /*  936646 */     GIR_EraseRootFromParent_Done,
     /*  936647 */   // Label 14160: @936647
     /*  936647 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(936738), // Rule ID 16283 //
     /*  936652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  936663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  936666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  936669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936699 */     // MIs[1] Operand 1
     /*  936699 */     // No operand predicates
     /*  936699 */     // MIs[0] round
     /*  936699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  936714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936736 */     GIR_RootConstrainSelectedInstOperands,
     /*  936737 */     // GIR_Coverage, 16283,
     /*  936737 */     GIR_EraseRootFromParent_Done,
     /*  936738 */   // Label 14161: @936738
     /*  936738 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(936829), // Rule ID 16286 //
     /*  936743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  936760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936790 */     // MIs[1] Operand 1
     /*  936790 */     // No operand predicates
     /*  936790 */     // MIs[0] round
     /*  936790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  936805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936827 */     GIR_RootConstrainSelectedInstOperands,
     /*  936828 */     // GIR_Coverage, 16286,
     /*  936828 */     GIR_EraseRootFromParent_Done,
     /*  936829 */   // Label 14162: @936829
     /*  936829 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(936920), // Rule ID 16287 //
     /*  936834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  936845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  936848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  936851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936881 */     // MIs[1] Operand 1
     /*  936881 */     // No operand predicates
     /*  936881 */     // MIs[0] round
     /*  936881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936893 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  936893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  936896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936918 */     GIR_RootConstrainSelectedInstOperands,
     /*  936919 */     // GIR_Coverage, 16287,
     /*  936919 */     GIR_EraseRootFromParent_Done,
     /*  936920 */   // Label 14163: @936920
     /*  936920 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(937011), // Rule ID 16290 //
     /*  936925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  936933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  936936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  936939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  936942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936972 */     // MIs[1] Operand 1
     /*  936972 */     // No operand predicates
     /*  936972 */     // MIs[0] round
     /*  936972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  936984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  936987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936996 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937009 */     GIR_RootConstrainSelectedInstOperands,
     /*  937010 */     // GIR_Coverage, 16290,
     /*  937010 */     GIR_EraseRootFromParent_Done,
     /*  937011 */   // Label 14164: @937011
     /*  937011 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(937102), // Rule ID 16291 //
     /*  937016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  937027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  937030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  937033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937063 */     // MIs[1] Operand 1
     /*  937063 */     // No operand predicates
     /*  937063 */     // MIs[0] round
     /*  937063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937075 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937100 */     GIR_RootConstrainSelectedInstOperands,
     /*  937101 */     // GIR_Coverage, 16291,
     /*  937101 */     GIR_EraseRootFromParent_Done,
     /*  937102 */   // Label 14165: @937102
     /*  937102 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(937193), // Rule ID 16294 //
     /*  937107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937154 */     // MIs[1] Operand 1
     /*  937154 */     // No operand predicates
     /*  937154 */     // MIs[0] round
     /*  937154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937178 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937191 */     GIR_RootConstrainSelectedInstOperands,
     /*  937192 */     // GIR_Coverage, 16294,
     /*  937192 */     GIR_EraseRootFromParent_Done,
     /*  937193 */   // Label 14166: @937193
     /*  937193 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(937284), // Rule ID 16295 //
     /*  937198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  937209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  937212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937245 */     // MIs[1] Operand 1
     /*  937245 */     // No operand predicates
     /*  937245 */     // MIs[0] round
     /*  937245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937282 */     GIR_RootConstrainSelectedInstOperands,
     /*  937283 */     // GIR_Coverage, 16295,
     /*  937283 */     GIR_EraseRootFromParent_Done,
     /*  937284 */   // Label 14167: @937284
     /*  937284 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(937375), // Rule ID 16298 //
     /*  937289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  937306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937336 */     // MIs[1] Operand 1
     /*  937336 */     // No operand predicates
     /*  937336 */     // MIs[0] round
     /*  937336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937360 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937373 */     GIR_RootConstrainSelectedInstOperands,
     /*  937374 */     // GIR_Coverage, 16298,
     /*  937374 */     GIR_EraseRootFromParent_Done,
     /*  937375 */   // Label 14168: @937375
     /*  937375 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(937466), // Rule ID 16299 //
     /*  937380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  937391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  937394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  937397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937427 */     // MIs[1] Operand 1
     /*  937427 */     // No operand predicates
     /*  937427 */     // MIs[0] round
     /*  937427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937464 */     GIR_RootConstrainSelectedInstOperands,
     /*  937465 */     // GIR_Coverage, 16299,
     /*  937465 */     GIR_EraseRootFromParent_Done,
     /*  937466 */   // Label 14169: @937466
     /*  937466 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(937557), // Rule ID 16302 //
     /*  937471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  937482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  937485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  937488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937518 */     // MIs[1] Operand 1
     /*  937518 */     // No operand predicates
     /*  937518 */     // MIs[0] round
     /*  937518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  937530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937555 */     GIR_RootConstrainSelectedInstOperands,
     /*  937556 */     // GIR_Coverage, 16302,
     /*  937556 */     GIR_EraseRootFromParent_Done,
     /*  937557 */   // Label 14170: @937557
     /*  937557 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(937648), // Rule ID 16303 //
     /*  937562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  937573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  937576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  937579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937609 */     // MIs[1] Operand 1
     /*  937609 */     // No operand predicates
     /*  937609 */     // MIs[0] round
     /*  937609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  937621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  937624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  937643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937646 */     GIR_RootConstrainSelectedInstOperands,
     /*  937647 */     // GIR_Coverage, 16303,
     /*  937647 */     GIR_EraseRootFromParent_Done,
     /*  937648 */   // Label 14171: @937648
     /*  937648 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(937739), // Rule ID 16306 //
     /*  937653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  937670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937700 */     // MIs[1] Operand 1
     /*  937700 */     // No operand predicates
     /*  937700 */     // MIs[0] round
     /*  937700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937737 */     GIR_RootConstrainSelectedInstOperands,
     /*  937738 */     // GIR_Coverage, 16306,
     /*  937738 */     GIR_EraseRootFromParent_Done,
     /*  937739 */   // Label 14172: @937739
     /*  937739 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(937830), // Rule ID 16307 //
     /*  937744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  937761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937791 */     // MIs[1] Operand 1
     /*  937791 */     // No operand predicates
     /*  937791 */     // MIs[0] round
     /*  937791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  937806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937828 */     GIR_RootConstrainSelectedInstOperands,
     /*  937829 */     // GIR_Coverage, 16307,
     /*  937829 */     GIR_EraseRootFromParent_Done,
     /*  937830 */   // Label 14173: @937830
     /*  937830 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(937921), // Rule ID 16310 //
     /*  937835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937882 */     // MIs[1] Operand 1
     /*  937882 */     // No operand predicates
     /*  937882 */     // MIs[0] round
     /*  937882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937919 */     GIR_RootConstrainSelectedInstOperands,
     /*  937920 */     // GIR_Coverage, 16310,
     /*  937920 */     GIR_EraseRootFromParent_Done,
     /*  937921 */   // Label 14174: @937921
     /*  937921 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(938012), // Rule ID 16311 //
     /*  937926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  937934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  937943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937973 */     // MIs[1] Operand 1
     /*  937973 */     // No operand predicates
     /*  937973 */     // MIs[0] round
     /*  937973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  937988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938010 */     GIR_RootConstrainSelectedInstOperands,
     /*  938011 */     // GIR_Coverage, 16311,
     /*  938011 */     GIR_EraseRootFromParent_Done,
     /*  938012 */   // Label 14175: @938012
     /*  938012 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(938103), // Rule ID 16314 //
     /*  938017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  938034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938064 */     // MIs[1] Operand 1
     /*  938064 */     // No operand predicates
     /*  938064 */     // MIs[0] round
     /*  938064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  938076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938101 */     GIR_RootConstrainSelectedInstOperands,
     /*  938102 */     // GIR_Coverage, 16314,
     /*  938102 */     GIR_EraseRootFromParent_Done,
     /*  938103 */   // Label 14176: @938103
     /*  938103 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(938194), // Rule ID 16315 //
     /*  938108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  938119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  938122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  938125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938155 */     // MIs[1] Operand 1
     /*  938155 */     // No operand predicates
     /*  938155 */     // MIs[0] round
     /*  938155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938167 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  938167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  938189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938192 */     GIR_RootConstrainSelectedInstOperands,
     /*  938193 */     // GIR_Coverage, 16315,
     /*  938193 */     GIR_EraseRootFromParent_Done,
     /*  938194 */   // Label 14177: @938194
     /*  938194 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(938285), // Rule ID 16318 //
     /*  938199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  938210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  938213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  938216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938246 */     // MIs[1] Operand 1
     /*  938246 */     // No operand predicates
     /*  938246 */     // MIs[0] round
     /*  938246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  938261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938283 */     GIR_RootConstrainSelectedInstOperands,
     /*  938284 */     // GIR_Coverage, 16318,
     /*  938284 */     GIR_EraseRootFromParent_Done,
     /*  938285 */   // Label 14178: @938285
     /*  938285 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(938376), // Rule ID 16319 //
     /*  938290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  938301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  938304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  938307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938337 */     // MIs[1] Operand 1
     /*  938337 */     // No operand predicates
     /*  938337 */     // MIs[0] round
     /*  938337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  938352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938374 */     GIR_RootConstrainSelectedInstOperands,
     /*  938375 */     // GIR_Coverage, 16319,
     /*  938375 */     GIR_EraseRootFromParent_Done,
     /*  938376 */   // Label 14179: @938376
     /*  938376 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(938467), // Rule ID 16322 //
     /*  938381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  938392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  938395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  938398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938428 */     // MIs[1] Operand 1
     /*  938428 */     // No operand predicates
     /*  938428 */     // MIs[0] round
     /*  938428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938440 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  938443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938465 */     GIR_RootConstrainSelectedInstOperands,
     /*  938466 */     // GIR_Coverage, 16322,
     /*  938466 */     GIR_EraseRootFromParent_Done,
     /*  938467 */   // Label 14180: @938467
     /*  938467 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(938558), // Rule ID 16323 //
     /*  938472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  938483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  938486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  938489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938519 */     // MIs[1] Operand 1
     /*  938519 */     // No operand predicates
     /*  938519 */     // MIs[0] round
     /*  938519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  938534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938556 */     GIR_RootConstrainSelectedInstOperands,
     /*  938557 */     // GIR_Coverage, 16323,
     /*  938557 */     GIR_EraseRootFromParent_Done,
     /*  938558 */   // Label 14181: @938558
     /*  938558 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(938649), // Rule ID 16326 //
     /*  938563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  938566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  938574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  938577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938610 */     // MIs[1] Operand 1
     /*  938610 */     // No operand predicates
     /*  938610 */     // MIs[0] round
     /*  938610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  938622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938647 */     GIR_RootConstrainSelectedInstOperands,
     /*  938648 */     // GIR_Coverage, 16326,
     /*  938648 */     GIR_EraseRootFromParent_Done,
     /*  938649 */   // Label 14182: @938649
     /*  938649 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(938740), // Rule ID 16327 //
     /*  938654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  938657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  938662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  938665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  938668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  938671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938701 */     // MIs[1] Operand 1
     /*  938701 */     // No operand predicates
     /*  938701 */     // MIs[0] round
     /*  938701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938713 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  938713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  938716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  938735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938738 */     GIR_RootConstrainSelectedInstOperands,
     /*  938739 */     // GIR_Coverage, 16327,
     /*  938739 */     GIR_EraseRootFromParent_Done,
     /*  938740 */   // Label 14183: @938740
     /*  938740 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(938834), // Rule ID 16450 //
     /*  938745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938792 */     // MIs[1] Operand 1
     /*  938792 */     // No operand predicates
     /*  938792 */     // MIs[0] round
     /*  938792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  938807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938832 */     GIR_RootConstrainSelectedInstOperands,
     /*  938833 */     // GIR_Coverage, 16450,
     /*  938833 */     GIR_EraseRootFromParent_Done,
     /*  938834 */   // Label 14184: @938834
     /*  938834 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(938928), // Rule ID 16451 //
     /*  938839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  938850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  938853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  938856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938886 */     // MIs[1] Operand 1
     /*  938886 */     // No operand predicates
     /*  938886 */     // MIs[0] round
     /*  938886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  938901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938926 */     GIR_RootConstrainSelectedInstOperands,
     /*  938927 */     // GIR_Coverage, 16451,
     /*  938927 */     GIR_EraseRootFromParent_Done,
     /*  938928 */   // Label 14185: @938928
     /*  938928 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(939022), // Rule ID 16454 //
     /*  938933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  938941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938980 */     // MIs[1] Operand 1
     /*  938980 */     // No operand predicates
     /*  938980 */     // MIs[0] round
     /*  938980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938992 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  938995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939004 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939020 */     GIR_RootConstrainSelectedInstOperands,
     /*  939021 */     // GIR_Coverage, 16454,
     /*  939021 */     GIR_EraseRootFromParent_Done,
     /*  939022 */   // Label 14186: @939022
     /*  939022 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(939116), // Rule ID 16455 //
     /*  939027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  939038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  939041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  939044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939074 */     // MIs[1] Operand 1
     /*  939074 */     // No operand predicates
     /*  939074 */     // MIs[0] round
     /*  939074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  939089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939114 */     GIR_RootConstrainSelectedInstOperands,
     /*  939115 */     // GIR_Coverage, 16455,
     /*  939115 */     GIR_EraseRootFromParent_Done,
     /*  939116 */   // Label 14187: @939116
     /*  939116 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(939210), // Rule ID 16458 //
     /*  939121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  939132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  939135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  939138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939168 */     // MIs[1] Operand 1
     /*  939168 */     // No operand predicates
     /*  939168 */     // MIs[0] round
     /*  939168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  939183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939192 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939208 */     GIR_RootConstrainSelectedInstOperands,
     /*  939209 */     // GIR_Coverage, 16458,
     /*  939209 */     GIR_EraseRootFromParent_Done,
     /*  939210 */   // Label 14188: @939210
     /*  939210 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(939304), // Rule ID 16459 //
     /*  939215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  939226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  939229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  939232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939262 */     // MIs[1] Operand 1
     /*  939262 */     // No operand predicates
     /*  939262 */     // MIs[0] round
     /*  939262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  939277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939302 */     GIR_RootConstrainSelectedInstOperands,
     /*  939303 */     // GIR_Coverage, 16459,
     /*  939303 */     GIR_EraseRootFromParent_Done,
     /*  939304 */   // Label 14189: @939304
     /*  939304 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(939398), // Rule ID 16462 //
     /*  939309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  939320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  939323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  939326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939356 */     // MIs[1] Operand 1
     /*  939356 */     // No operand predicates
     /*  939356 */     // MIs[0] round
     /*  939356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  939371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939380 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939396 */     GIR_RootConstrainSelectedInstOperands,
     /*  939397 */     // GIR_Coverage, 16462,
     /*  939397 */     GIR_EraseRootFromParent_Done,
     /*  939398 */   // Label 14190: @939398
     /*  939398 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(939492), // Rule ID 16463 //
     /*  939403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  939414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  939417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  939420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939450 */     // MIs[1] Operand 1
     /*  939450 */     // No operand predicates
     /*  939450 */     // MIs[0] round
     /*  939450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  939465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939474 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939490 */     GIR_RootConstrainSelectedInstOperands,
     /*  939491 */     // GIR_Coverage, 16463,
     /*  939491 */     GIR_EraseRootFromParent_Done,
     /*  939492 */   // Label 14191: @939492
     /*  939492 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(939586), // Rule ID 16466 //
     /*  939497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939544 */     // MIs[1] Operand 1
     /*  939544 */     // No operand predicates
     /*  939544 */     // MIs[0] round
     /*  939544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  939559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939584 */     GIR_RootConstrainSelectedInstOperands,
     /*  939585 */     // GIR_Coverage, 16466,
     /*  939585 */     GIR_EraseRootFromParent_Done,
     /*  939586 */   // Label 14192: @939586
     /*  939586 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(939680), // Rule ID 16467 //
     /*  939591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  939602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  939605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  939608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939638 */     // MIs[1] Operand 1
     /*  939638 */     // No operand predicates
     /*  939638 */     // MIs[0] round
     /*  939638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  939653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939662 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939678 */     GIR_RootConstrainSelectedInstOperands,
     /*  939679 */     // GIR_Coverage, 16467,
     /*  939679 */     GIR_EraseRootFromParent_Done,
     /*  939680 */   // Label 14193: @939680
     /*  939680 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(939774), // Rule ID 16470 //
     /*  939685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939732 */     // MIs[1] Operand 1
     /*  939732 */     // No operand predicates
     /*  939732 */     // MIs[0] round
     /*  939732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  939744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  939747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939772 */     GIR_RootConstrainSelectedInstOperands,
     /*  939773 */     // GIR_Coverage, 16470,
     /*  939773 */     GIR_EraseRootFromParent_Done,
     /*  939774 */   // Label 14194: @939774
     /*  939774 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(939868), // Rule ID 16471 //
     /*  939779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  939790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  939793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  939796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939826 */     // MIs[1] Operand 1
     /*  939826 */     // No operand predicates
     /*  939826 */     // MIs[0] round
     /*  939826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  939838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  939841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939850 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  939860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939866 */     GIR_RootConstrainSelectedInstOperands,
     /*  939867 */     // GIR_Coverage, 16471,
     /*  939867 */     GIR_EraseRootFromParent_Done,
     /*  939868 */   // Label 14195: @939868
     /*  939868 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(939962), // Rule ID 16474 //
     /*  939873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939920 */     // MIs[1] Operand 1
     /*  939920 */     // No operand predicates
     /*  939920 */     // MIs[0] round
     /*  939920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  939935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939960 */     GIR_RootConstrainSelectedInstOperands,
     /*  939961 */     // GIR_Coverage, 16474,
     /*  939961 */     GIR_EraseRootFromParent_Done,
     /*  939962 */   // Label 14196: @939962
     /*  939962 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(940056), // Rule ID 16475 //
     /*  939967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  939975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  939978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  939981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  939984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940014 */     // MIs[1] Operand 1
     /*  940014 */     // No operand predicates
     /*  940014 */     // MIs[0] round
     /*  940014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  940029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940038 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940054 */     GIR_RootConstrainSelectedInstOperands,
     /*  940055 */     // GIR_Coverage, 16475,
     /*  940055 */     GIR_EraseRootFromParent_Done,
     /*  940056 */   // Label 14197: @940056
     /*  940056 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(940150), // Rule ID 16478 //
     /*  940061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  940072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  940075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940108 */     // MIs[1] Operand 1
     /*  940108 */     // No operand predicates
     /*  940108 */     // MIs[0] round
     /*  940108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940148 */     GIR_RootConstrainSelectedInstOperands,
     /*  940149 */     // GIR_Coverage, 16478,
     /*  940149 */     GIR_EraseRootFromParent_Done,
     /*  940150 */   // Label 14198: @940150
     /*  940150 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(940244), // Rule ID 16479 //
     /*  940155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  940166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  940169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940202 */     // MIs[1] Operand 1
     /*  940202 */     // No operand predicates
     /*  940202 */     // MIs[0] round
     /*  940202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940226 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940242 */     GIR_RootConstrainSelectedInstOperands,
     /*  940243 */     // GIR_Coverage, 16479,
     /*  940243 */     GIR_EraseRootFromParent_Done,
     /*  940244 */   // Label 14199: @940244
     /*  940244 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(940338), // Rule ID 16482 //
     /*  940249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  940260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  940263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940296 */     // MIs[1] Operand 1
     /*  940296 */     // No operand predicates
     /*  940296 */     // MIs[0] round
     /*  940296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  940311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940320 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940336 */     GIR_RootConstrainSelectedInstOperands,
     /*  940337 */     // GIR_Coverage, 16482,
     /*  940337 */     GIR_EraseRootFromParent_Done,
     /*  940338 */   // Label 14200: @940338
     /*  940338 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(940432), // Rule ID 16483 //
     /*  940343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  940354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  940357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940390 */     // MIs[1] Operand 1
     /*  940390 */     // No operand predicates
     /*  940390 */     // MIs[0] round
     /*  940390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  940405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940430 */     GIR_RootConstrainSelectedInstOperands,
     /*  940431 */     // GIR_Coverage, 16483,
     /*  940431 */     GIR_EraseRootFromParent_Done,
     /*  940432 */   // Label 14201: @940432
     /*  940432 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(940526), // Rule ID 16486 //
     /*  940437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940484 */     // MIs[1] Operand 1
     /*  940484 */     // No operand predicates
     /*  940484 */     // MIs[0] round
     /*  940484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  940499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940508 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940524 */     GIR_RootConstrainSelectedInstOperands,
     /*  940525 */     // GIR_Coverage, 16486,
     /*  940525 */     GIR_EraseRootFromParent_Done,
     /*  940526 */   // Label 14202: @940526
     /*  940526 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(940620), // Rule ID 16487 //
     /*  940531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  940542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  940545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940578 */     // MIs[1] Operand 1
     /*  940578 */     // No operand predicates
     /*  940578 */     // MIs[0] round
     /*  940578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  940593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940618 */     GIR_RootConstrainSelectedInstOperands,
     /*  940619 */     // GIR_Coverage, 16487,
     /*  940619 */     GIR_EraseRootFromParent_Done,
     /*  940620 */   // Label 14203: @940620
     /*  940620 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(940714), // Rule ID 16490 //
     /*  940625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  940628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940672 */     // MIs[1] Operand 1
     /*  940672 */     // No operand predicates
     /*  940672 */     // MIs[0] round
     /*  940672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  940684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  940687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940696 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940712 */     GIR_RootConstrainSelectedInstOperands,
     /*  940713 */     // GIR_Coverage, 16490,
     /*  940713 */     GIR_EraseRootFromParent_Done,
     /*  940714 */   // Label 14204: @940714
     /*  940714 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(940808), // Rule ID 16491 //
     /*  940719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  940722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  940730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  940733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940766 */     // MIs[1] Operand 1
     /*  940766 */     // No operand predicates
     /*  940766 */     // MIs[0] round
     /*  940766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  940778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  940781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940806 */     GIR_RootConstrainSelectedInstOperands,
     /*  940807 */     // GIR_Coverage, 16491,
     /*  940807 */     GIR_EraseRootFromParent_Done,
     /*  940808 */   // Label 14205: @940808
     /*  940808 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(940902), // Rule ID 16494 //
     /*  940813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940860 */     // MIs[1] Operand 1
     /*  940860 */     // No operand predicates
     /*  940860 */     // MIs[0] round
     /*  940860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940884 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940900 */     GIR_RootConstrainSelectedInstOperands,
     /*  940901 */     // GIR_Coverage, 16494,
     /*  940901 */     GIR_EraseRootFromParent_Done,
     /*  940902 */   // Label 14206: @940902
     /*  940902 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(940996), // Rule ID 16495 //
     /*  940907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  940915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940954 */     // MIs[1] Operand 1
     /*  940954 */     // No operand predicates
     /*  940954 */     // MIs[0] round
     /*  940954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  940969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940994 */     GIR_RootConstrainSelectedInstOperands,
     /*  940995 */     // GIR_Coverage, 16495,
     /*  940995 */     GIR_EraseRootFromParent_Done,
     /*  940996 */   // Label 14207: @940996
     /*  940996 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(941090), // Rule ID 16498 //
     /*  941001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941048 */     // MIs[1] Operand 1
     /*  941048 */     // No operand predicates
     /*  941048 */     // MIs[0] round
     /*  941048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  941063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941088 */     GIR_RootConstrainSelectedInstOperands,
     /*  941089 */     // GIR_Coverage, 16498,
     /*  941089 */     GIR_EraseRootFromParent_Done,
     /*  941090 */   // Label 14208: @941090
     /*  941090 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(941184), // Rule ID 16499 //
     /*  941095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941142 */     // MIs[1] Operand 1
     /*  941142 */     // No operand predicates
     /*  941142 */     // MIs[0] round
     /*  941142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  941157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941166 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941182 */     GIR_RootConstrainSelectedInstOperands,
     /*  941183 */     // GIR_Coverage, 16499,
     /*  941183 */     GIR_EraseRootFromParent_Done,
     /*  941184 */   // Label 14209: @941184
     /*  941184 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(941278), // Rule ID 16502 //
     /*  941189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941236 */     // MIs[1] Operand 1
     /*  941236 */     // No operand predicates
     /*  941236 */     // MIs[0] round
     /*  941236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  941251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941260 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941276 */     GIR_RootConstrainSelectedInstOperands,
     /*  941277 */     // GIR_Coverage, 16502,
     /*  941277 */     GIR_EraseRootFromParent_Done,
     /*  941278 */   // Label 14210: @941278
     /*  941278 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(941372), // Rule ID 16503 //
     /*  941283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941330 */     // MIs[1] Operand 1
     /*  941330 */     // No operand predicates
     /*  941330 */     // MIs[0] round
     /*  941330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  941345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941354 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941370 */     GIR_RootConstrainSelectedInstOperands,
     /*  941371 */     // GIR_Coverage, 16503,
     /*  941371 */     GIR_EraseRootFromParent_Done,
     /*  941372 */   // Label 14211: @941372
     /*  941372 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(941466), // Rule ID 16506 //
     /*  941377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  941380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941424 */     // MIs[1] Operand 1
     /*  941424 */     // No operand predicates
     /*  941424 */     // MIs[0] round
     /*  941424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  941436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  941439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941464 */     GIR_RootConstrainSelectedInstOperands,
     /*  941465 */     // GIR_Coverage, 16506,
     /*  941465 */     GIR_EraseRootFromParent_Done,
     /*  941466 */   // Label 14212: @941466
     /*  941466 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(941560), // Rule ID 16507 //
     /*  941471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  941474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  941479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941518 */     // MIs[1] Operand 1
     /*  941518 */     // No operand predicates
     /*  941518 */     // MIs[0] round
     /*  941518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  941530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  941533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941542 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941558 */     GIR_RootConstrainSelectedInstOperands,
     /*  941559 */     // GIR_Coverage, 16507,
     /*  941559 */     GIR_EraseRootFromParent_Done,
     /*  941560 */   // Label 14213: @941560
     /*  941560 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(941654), // Rule ID 16630 //
     /*  941565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  941576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  941579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  941582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941612 */     // MIs[1] Operand 1
     /*  941612 */     // No operand predicates
     /*  941612 */     // MIs[0] round
     /*  941612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  941624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  941627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941652 */     GIR_RootConstrainSelectedInstOperands,
     /*  941653 */     // GIR_Coverage, 16630,
     /*  941653 */     GIR_EraseRootFromParent_Done,
     /*  941654 */   // Label 14214: @941654
     /*  941654 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(941748), // Rule ID 16631 //
     /*  941659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  941670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  941673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  941676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941706 */     // MIs[1] Operand 1
     /*  941706 */     // No operand predicates
     /*  941706 */     // MIs[0] round
     /*  941706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941718 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  941718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  941721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941746 */     GIR_RootConstrainSelectedInstOperands,
     /*  941747 */     // GIR_Coverage, 16631,
     /*  941747 */     GIR_EraseRootFromParent_Done,
     /*  941748 */   // Label 14215: @941748
     /*  941748 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(941842), // Rule ID 16634 //
     /*  941753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  941764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  941767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  941770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941800 */     // MIs[1] Operand 1
     /*  941800 */     // No operand predicates
     /*  941800 */     // MIs[0] round
     /*  941800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  941812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  941815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941840 */     GIR_RootConstrainSelectedInstOperands,
     /*  941841 */     // GIR_Coverage, 16634,
     /*  941841 */     GIR_EraseRootFromParent_Done,
     /*  941842 */   // Label 14216: @941842
     /*  941842 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(941936), // Rule ID 16635 //
     /*  941847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  941850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  941858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  941861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  941864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  941867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941894 */     // MIs[1] Operand 1
     /*  941894 */     // No operand predicates
     /*  941894 */     // MIs[0] round
     /*  941894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  941906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  941909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  941913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  941918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  941928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  941931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  941934 */     GIR_RootConstrainSelectedInstOperands,
     /*  941935 */     // GIR_Coverage, 16635,
     /*  941935 */     GIR_EraseRootFromParent_Done,
     /*  941936 */   // Label 14217: @941936
     /*  941936 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(942030), // Rule ID 16638 //
     /*  941941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  941944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  941949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  941952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  941955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  941958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  941961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  941980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  941984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  941988 */     // MIs[1] Operand 1
     /*  941988 */     // No operand predicates
     /*  941988 */     // MIs[0] round
     /*  941988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942012 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942028 */     GIR_RootConstrainSelectedInstOperands,
     /*  942029 */     // GIR_Coverage, 16638,
     /*  942029 */     GIR_EraseRootFromParent_Done,
     /*  942030 */   // Label 14218: @942030
     /*  942030 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(942124), // Rule ID 16639 //
     /*  942035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  942046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  942049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  942052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942082 */     // MIs[1] Operand 1
     /*  942082 */     // No operand predicates
     /*  942082 */     // MIs[0] round
     /*  942082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942122 */     GIR_RootConstrainSelectedInstOperands,
     /*  942123 */     // GIR_Coverage, 16639,
     /*  942123 */     GIR_EraseRootFromParent_Done,
     /*  942124 */   // Label 14219: @942124
     /*  942124 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(942218), // Rule ID 16642 //
     /*  942129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  942140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  942143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  942146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942176 */     // MIs[1] Operand 1
     /*  942176 */     // No operand predicates
     /*  942176 */     // MIs[0] round
     /*  942176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  942191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942200 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942216 */     GIR_RootConstrainSelectedInstOperands,
     /*  942217 */     // GIR_Coverage, 16642,
     /*  942217 */     GIR_EraseRootFromParent_Done,
     /*  942218 */   // Label 14220: @942218
     /*  942218 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(942312), // Rule ID 16643 //
     /*  942223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  942234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  942237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  942240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942270 */     // MIs[1] Operand 1
     /*  942270 */     // No operand predicates
     /*  942270 */     // MIs[0] round
     /*  942270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  942285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942310 */     GIR_RootConstrainSelectedInstOperands,
     /*  942311 */     // GIR_Coverage, 16643,
     /*  942311 */     GIR_EraseRootFromParent_Done,
     /*  942312 */   // Label 14221: @942312
     /*  942312 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(942406), // Rule ID 16646 //
     /*  942317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  942328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  942331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  942334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942364 */     // MIs[1] Operand 1
     /*  942364 */     // No operand predicates
     /*  942364 */     // MIs[0] round
     /*  942364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  942379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942388 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942404 */     GIR_RootConstrainSelectedInstOperands,
     /*  942405 */     // GIR_Coverage, 16646,
     /*  942405 */     GIR_EraseRootFromParent_Done,
     /*  942406 */   // Label 14222: @942406
     /*  942406 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(942500), // Rule ID 16647 //
     /*  942411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  942422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  942425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  942428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942458 */     // MIs[1] Operand 1
     /*  942458 */     // No operand predicates
     /*  942458 */     // MIs[0] round
     /*  942458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  942473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942482 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942498 */     GIR_RootConstrainSelectedInstOperands,
     /*  942499 */     // GIR_Coverage, 16647,
     /*  942499 */     GIR_EraseRootFromParent_Done,
     /*  942500 */   // Label 14223: @942500
     /*  942500 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(942594), // Rule ID 16650 //
     /*  942505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  942516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  942519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  942522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942552 */     // MIs[1] Operand 1
     /*  942552 */     // No operand predicates
     /*  942552 */     // MIs[0] round
     /*  942552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942564 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  942564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  942567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942592 */     GIR_RootConstrainSelectedInstOperands,
     /*  942593 */     // GIR_Coverage, 16650,
     /*  942593 */     GIR_EraseRootFromParent_Done,
     /*  942594 */   // Label 14224: @942594
     /*  942594 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(942688), // Rule ID 16651 //
     /*  942599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  942610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  942613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  942616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942646 */     // MIs[1] Operand 1
     /*  942646 */     // No operand predicates
     /*  942646 */     // MIs[0] round
     /*  942646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942658 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  942658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  942661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942670 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  942680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942686 */     GIR_RootConstrainSelectedInstOperands,
     /*  942687 */     // GIR_Coverage, 16651,
     /*  942687 */     GIR_EraseRootFromParent_Done,
     /*  942688 */   // Label 14225: @942688
     /*  942688 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(942782), // Rule ID 16654 //
     /*  942693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  942704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  942707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942740 */     // MIs[1] Operand 1
     /*  942740 */     // No operand predicates
     /*  942740 */     // MIs[0] round
     /*  942740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  942752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  942755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942780 */     GIR_RootConstrainSelectedInstOperands,
     /*  942781 */     // GIR_Coverage, 16654,
     /*  942781 */     GIR_EraseRootFromParent_Done,
     /*  942782 */   // Label 14226: @942782
     /*  942782 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(942876), // Rule ID 16655 //
     /*  942787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  942798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  942801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942834 */     // MIs[1] Operand 1
     /*  942834 */     // No operand predicates
     /*  942834 */     // MIs[0] round
     /*  942834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  942846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  942849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942858 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942874 */     GIR_RootConstrainSelectedInstOperands,
     /*  942875 */     // GIR_Coverage, 16655,
     /*  942875 */     GIR_EraseRootFromParent_Done,
     /*  942876 */   // Label 14227: @942876
     /*  942876 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(942970), // Rule ID 16658 //
     /*  942881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  942884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  942901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  942920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  942924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  942928 */     // MIs[1] Operand 1
     /*  942928 */     // No operand predicates
     /*  942928 */     // MIs[0] round
     /*  942928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942940 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  942940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  942943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  942947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  942952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  942965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  942968 */     GIR_RootConstrainSelectedInstOperands,
     /*  942969 */     // GIR_Coverage, 16658,
     /*  942969 */     GIR_EraseRootFromParent_Done,
     /*  942970 */   // Label 14228: @942970
     /*  942970 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(943064), // Rule ID 16659 //
     /*  942975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  942978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  942983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  942986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  942989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  942995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943022 */     // MIs[1] Operand 1
     /*  943022 */     // No operand predicates
     /*  943022 */     // MIs[0] round
     /*  943022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943046 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943062 */     GIR_RootConstrainSelectedInstOperands,
     /*  943063 */     // GIR_Coverage, 16659,
     /*  943063 */     GIR_EraseRootFromParent_Done,
     /*  943064 */   // Label 14229: @943064
     /*  943064 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(943158), // Rule ID 16662 //
     /*  943069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  943080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  943083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  943086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943116 */     // MIs[1] Operand 1
     /*  943116 */     // No operand predicates
     /*  943116 */     // MIs[0] round
     /*  943116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943156 */     GIR_RootConstrainSelectedInstOperands,
     /*  943157 */     // GIR_Coverage, 16662,
     /*  943157 */     GIR_EraseRootFromParent_Done,
     /*  943158 */   // Label 14230: @943158
     /*  943158 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(943252), // Rule ID 16663 //
     /*  943163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  943174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  943177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  943180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943210 */     // MIs[1] Operand 1
     /*  943210 */     // No operand predicates
     /*  943210 */     // MIs[0] round
     /*  943210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943234 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943250 */     GIR_RootConstrainSelectedInstOperands,
     /*  943251 */     // GIR_Coverage, 16663,
     /*  943251 */     GIR_EraseRootFromParent_Done,
     /*  943252 */   // Label 14231: @943252
     /*  943252 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(943346), // Rule ID 16666 //
     /*  943257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  943268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  943271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943304 */     // MIs[1] Operand 1
     /*  943304 */     // No operand predicates
     /*  943304 */     // MIs[0] round
     /*  943304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  943319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943328 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943344 */     GIR_RootConstrainSelectedInstOperands,
     /*  943345 */     // GIR_Coverage, 16666,
     /*  943345 */     GIR_EraseRootFromParent_Done,
     /*  943346 */   // Label 14232: @943346
     /*  943346 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(943440), // Rule ID 16667 //
     /*  943351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  943362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  943365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  943368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943398 */     // MIs[1] Operand 1
     /*  943398 */     // No operand predicates
     /*  943398 */     // MIs[0] round
     /*  943398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  943413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943438 */     GIR_RootConstrainSelectedInstOperands,
     /*  943439 */     // GIR_Coverage, 16667,
     /*  943439 */     GIR_EraseRootFromParent_Done,
     /*  943440 */   // Label 14233: @943440
     /*  943440 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(943534), // Rule ID 16670 //
     /*  943445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  943448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  943456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  943459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943492 */     // MIs[1] Operand 1
     /*  943492 */     // No operand predicates
     /*  943492 */     // MIs[0] round
     /*  943492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  943504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  943507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943516 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943532 */     GIR_RootConstrainSelectedInstOperands,
     /*  943533 */     // GIR_Coverage, 16670,
     /*  943533 */     GIR_EraseRootFromParent_Done,
     /*  943534 */   // Label 14234: @943534
     /*  943534 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(943628), // Rule ID 16671 //
     /*  943539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  943542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  943550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  943553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  943556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943586 */     // MIs[1] Operand 1
     /*  943586 */     // No operand predicates
     /*  943586 */     // MIs[0] round
     /*  943586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  943598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  943601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  943620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943626 */     GIR_RootConstrainSelectedInstOperands,
     /*  943627 */     // GIR_Coverage, 16671,
     /*  943627 */     GIR_EraseRootFromParent_Done,
     /*  943628 */   // Label 14235: @943628
     /*  943628 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(943722), // Rule ID 16674 //
     /*  943633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  943644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  943647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943680 */     // MIs[1] Operand 1
     /*  943680 */     // No operand predicates
     /*  943680 */     // MIs[0] round
     /*  943680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943692 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  943692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943704 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943720 */     GIR_RootConstrainSelectedInstOperands,
     /*  943721 */     // GIR_Coverage, 16674,
     /*  943721 */     GIR_EraseRootFromParent_Done,
     /*  943722 */   // Label 14236: @943722
     /*  943722 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(943816), // Rule ID 16675 //
     /*  943727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  943738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  943741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  943744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943774 */     // MIs[1] Operand 1
     /*  943774 */     // No operand predicates
     /*  943774 */     // MIs[0] round
     /*  943774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  943786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  943789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943814 */     GIR_RootConstrainSelectedInstOperands,
     /*  943815 */     // GIR_Coverage, 16675,
     /*  943815 */     GIR_EraseRootFromParent_Done,
     /*  943816 */   // Label 14237: @943816
     /*  943816 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(943910), // Rule ID 16678 //
     /*  943821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  943824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  943841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943868 */     // MIs[1] Operand 1
     /*  943868 */     // No operand predicates
     /*  943868 */     // MIs[0] round
     /*  943868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  943880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  943908 */     GIR_RootConstrainSelectedInstOperands,
     /*  943909 */     // GIR_Coverage, 16678,
     /*  943909 */     GIR_EraseRootFromParent_Done,
     /*  943910 */   // Label 14238: @943910
     /*  943910 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(944004), // Rule ID 16679 //
     /*  943915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  943918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  943923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  943926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  943929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  943935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  943954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  943958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  943962 */     // MIs[1] Operand 1
     /*  943962 */     // No operand predicates
     /*  943962 */     // MIs[0] round
     /*  943962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  943974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  943977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  943981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  943986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  943999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944002 */     GIR_RootConstrainSelectedInstOperands,
     /*  944003 */     // GIR_Coverage, 16679,
     /*  944003 */     GIR_EraseRootFromParent_Done,
     /*  944004 */   // Label 14239: @944004
     /*  944004 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(944098), // Rule ID 16682 //
     /*  944009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  944012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  944026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  944029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944056 */     // MIs[1] Operand 1
     /*  944056 */     // No operand predicates
     /*  944056 */     // MIs[0] round
     /*  944056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  944068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  944071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944096 */     GIR_RootConstrainSelectedInstOperands,
     /*  944097 */     // GIR_Coverage, 16682,
     /*  944097 */     GIR_EraseRootFromParent_Done,
     /*  944098 */   // Label 14240: @944098
     /*  944098 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(944192), // Rule ID 16683 //
     /*  944103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  944120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  944123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944150 */     // MIs[1] Operand 1
     /*  944150 */     // No operand predicates
     /*  944150 */     // MIs[0] round
     /*  944150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  944162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  944165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944174 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944190 */     GIR_RootConstrainSelectedInstOperands,
     /*  944191 */     // GIR_Coverage, 16683,
     /*  944191 */     GIR_EraseRootFromParent_Done,
     /*  944192 */   // Label 14241: @944192
     /*  944192 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(944286), // Rule ID 16686 //
     /*  944197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  944200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  944214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  944217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944244 */     // MIs[1] Operand 1
     /*  944244 */     // No operand predicates
     /*  944244 */     // MIs[0] round
     /*  944244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  944256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  944259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944284 */     GIR_RootConstrainSelectedInstOperands,
     /*  944285 */     // GIR_Coverage, 16686,
     /*  944285 */     GIR_EraseRootFromParent_Done,
     /*  944286 */   // Label 14242: @944286
     /*  944286 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(944380), // Rule ID 16687 //
     /*  944291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  944294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  944299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  944308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  944311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  944326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  944330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  944334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  944338 */     // MIs[1] Operand 1
     /*  944338 */     // No operand predicates
     /*  944338 */     // MIs[0] round
     /*  944338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  944350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  944353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  944357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  944362 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  944372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  944375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  944378 */     GIR_RootConstrainSelectedInstOperands,
     /*  944379 */     // GIR_Coverage, 16687,
     /*  944379 */     GIR_EraseRootFromParent_Done,
     /*  944380 */   // Label 14243: @944380
     /*  944380 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(944464), // Rule ID 2754 //
     /*  944385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  944396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  944399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  944402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944428 */     // MIs[0] round
     /*  944428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944440 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  944443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944462 */     GIR_RootConstrainSelectedInstOperands,
     /*  944463 */     // GIR_Coverage, 2754,
     /*  944463 */     GIR_EraseRootFromParent_Done,
     /*  944464 */   // Label 14244: @944464
     /*  944464 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(944548), // Rule ID 2755 //
     /*  944469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  944480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  944483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  944486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944512 */     // MIs[0] round
     /*  944512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944524 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  944527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944546 */     GIR_RootConstrainSelectedInstOperands,
     /*  944547 */     // GIR_Coverage, 2755,
     /*  944547 */     GIR_EraseRootFromParent_Done,
     /*  944548 */   // Label 14245: @944548
     /*  944548 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(944632), // Rule ID 17134 //
     /*  944553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  944564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  944567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  944570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944596 */     // MIs[0] round
     /*  944596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  944611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944630 */     GIR_RootConstrainSelectedInstOperands,
     /*  944631 */     // GIR_Coverage, 17134,
     /*  944631 */     GIR_EraseRootFromParent_Done,
     /*  944632 */   // Label 14246: @944632
     /*  944632 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(944716), // Rule ID 17135 //
     /*  944637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  944648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  944651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  944654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944680 */     // MIs[0] round
     /*  944680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  944695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944714 */     GIR_RootConstrainSelectedInstOperands,
     /*  944715 */     // GIR_Coverage, 17135,
     /*  944715 */     GIR_EraseRootFromParent_Done,
     /*  944716 */   // Label 14247: @944716
     /*  944716 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(944800), // Rule ID 17144 //
     /*  944721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  944738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  944741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944764 */     // MIs[0] round
     /*  944764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  944779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944798 */     GIR_RootConstrainSelectedInstOperands,
     /*  944799 */     // GIR_Coverage, 17144,
     /*  944799 */     GIR_EraseRootFromParent_Done,
     /*  944800 */   // Label 14248: @944800
     /*  944800 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(944884), // Rule ID 17145 //
     /*  944805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  944816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  944819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  944822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  944825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944848 */     // MIs[0] round
     /*  944848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  944860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  944863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944882 */     GIR_RootConstrainSelectedInstOperands,
     /*  944883 */     // GIR_Coverage, 17145,
     /*  944883 */     GIR_EraseRootFromParent_Done,
     /*  944884 */   // Label 14249: @944884
     /*  944884 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(944968), // Rule ID 17154 //
     /*  944889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  944892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  944909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  944920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  944924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  944928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  944932 */     // MIs[0] round
     /*  944932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  944935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  944937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944944 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  944944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  944947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  944951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  944953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  944955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  944966 */     GIR_RootConstrainSelectedInstOperands,
     /*  944967 */     // GIR_Coverage, 17154,
     /*  944967 */     GIR_EraseRootFromParent_Done,
     /*  944968 */   // Label 14250: @944968
     /*  944968 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(945052), // Rule ID 17155 //
     /*  944973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  944976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  944981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  944984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  944987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  944990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  944993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945016 */     // MIs[0] round
     /*  945016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945028 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  945028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  945031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945050 */     GIR_RootConstrainSelectedInstOperands,
     /*  945051 */     // GIR_Coverage, 17155,
     /*  945051 */     GIR_EraseRootFromParent_Done,
     /*  945052 */   // Label 14251: @945052
     /*  945052 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(945136), // Rule ID 17164 //
     /*  945057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  945060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  945074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945100 */     // MIs[0] round
     /*  945100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945112 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  945112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  945115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945134 */     GIR_RootConstrainSelectedInstOperands,
     /*  945135 */     // GIR_Coverage, 17164,
     /*  945135 */     GIR_EraseRootFromParent_Done,
     /*  945136 */   // Label 14252: @945136
     /*  945136 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(945220), // Rule ID 17165 //
     /*  945141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  945144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  945152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  945155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  945158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  945161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945184 */     // MIs[0] round
     /*  945184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945196 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  945196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  945199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945218 */     GIR_RootConstrainSelectedInstOperands,
     /*  945219 */     // GIR_Coverage, 17165,
     /*  945219 */     GIR_EraseRootFromParent_Done,
     /*  945220 */   // Label 14253: @945220
     /*  945220 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(945304), // Rule ID 17174 //
     /*  945225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  945236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  945239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  945242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945268 */     // MIs[0] round
     /*  945268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945280 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  945283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945302 */     GIR_RootConstrainSelectedInstOperands,
     /*  945303 */     // GIR_Coverage, 17174,
     /*  945303 */     GIR_EraseRootFromParent_Done,
     /*  945304 */   // Label 14254: @945304
     /*  945304 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(945388), // Rule ID 17175 //
     /*  945309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  945320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  945323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  945326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945352 */     // MIs[0] round
     /*  945352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945364 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  945367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945386 */     GIR_RootConstrainSelectedInstOperands,
     /*  945387 */     // GIR_Coverage, 17175,
     /*  945387 */     GIR_EraseRootFromParent_Done,
     /*  945388 */   // Label 14255: @945388
     /*  945388 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(945472), // Rule ID 17184 //
     /*  945393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  945404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  945407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  945410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  945413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945436 */     // MIs[0] round
     /*  945436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945448 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  945451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945470 */     GIR_RootConstrainSelectedInstOperands,
     /*  945471 */     // GIR_Coverage, 17184,
     /*  945471 */     GIR_EraseRootFromParent_Done,
     /*  945472 */   // Label 14256: @945472
     /*  945472 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(945556), // Rule ID 17185 //
     /*  945477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  945488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  945491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  945494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  945497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945520 */     // MIs[0] round
     /*  945520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  945535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945554 */     GIR_RootConstrainSelectedInstOperands,
     /*  945555 */     // GIR_Coverage, 17185,
     /*  945555 */     GIR_EraseRootFromParent_Done,
     /*  945556 */   // Label 14257: @945556
     /*  945556 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(945640), // Rule ID 17194 //
     /*  945561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  945572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  945575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  945578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  945581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945604 */     // MIs[0] round
     /*  945604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  945619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945638 */     GIR_RootConstrainSelectedInstOperands,
     /*  945639 */     // GIR_Coverage, 17194,
     /*  945639 */     GIR_EraseRootFromParent_Done,
     /*  945640 */   // Label 14258: @945640
     /*  945640 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(945724), // Rule ID 17195 //
     /*  945645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  945656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  945659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  945662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  945665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  945688 */     // MIs[0] round
     /*  945688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945700 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  945703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945722 */     GIR_RootConstrainSelectedInstOperands,
     /*  945723 */     // GIR_Coverage, 17195,
     /*  945723 */     GIR_EraseRootFromParent_Done,
     /*  945724 */   // Label 14259: @945724
     /*  945724 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(945808), // Rule ID 17204 //
     /*  945729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  945732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  945740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  945743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  945746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  945749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945772 */     // MIs[0] round
     /*  945772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  945784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  945787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945806 */     GIR_RootConstrainSelectedInstOperands,
     /*  945807 */     // GIR_Coverage, 17204,
     /*  945807 */     GIR_EraseRootFromParent_Done,
     /*  945808 */   // Label 14260: @945808
     /*  945808 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(945892), // Rule ID 17205 //
     /*  945813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  945816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  945821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  945824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  945827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  945830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  945833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  945852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  945856 */     // MIs[0] round
     /*  945856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945868 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  945868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  945871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945890 */     GIR_RootConstrainSelectedInstOperands,
     /*  945891 */     // GIR_Coverage, 17205,
     /*  945891 */     GIR_EraseRootFromParent_Done,
     /*  945892 */   // Label 14261: @945892
     /*  945892 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(945976), // Rule ID 17250 //
     /*  945897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  945900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  945905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  945917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  945928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  945932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945940 */     // MIs[0] round
     /*  945940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  945943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  945945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  945952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  945955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  945959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  945961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  945963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  945974 */     GIR_RootConstrainSelectedInstOperands,
     /*  945975 */     // GIR_Coverage, 17250,
     /*  945975 */     GIR_EraseRootFromParent_Done,
     /*  945976 */   // Label 14262: @945976
     /*  945976 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(946060), // Rule ID 17251 //
     /*  945981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  945984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  945989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  945995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  946001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946024 */     // MIs[0] round
     /*  946024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946036 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  946039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946058 */     GIR_RootConstrainSelectedInstOperands,
     /*  946059 */     // GIR_Coverage, 17251,
     /*  946059 */     GIR_EraseRootFromParent_Done,
     /*  946060 */   // Label 14263: @946060
     /*  946060 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(946144), // Rule ID 17260 //
     /*  946065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  946079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  946085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946108 */     // MIs[0] round
     /*  946108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946120 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  946123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946142 */     GIR_RootConstrainSelectedInstOperands,
     /*  946143 */     // GIR_Coverage, 17260,
     /*  946143 */     GIR_EraseRootFromParent_Done,
     /*  946144 */   // Label 14264: @946144
     /*  946144 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(946228), // Rule ID 17261 //
     /*  946149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  946163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  946169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946192 */     // MIs[0] round
     /*  946192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946204 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  946207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946226 */     GIR_RootConstrainSelectedInstOperands,
     /*  946227 */     // GIR_Coverage, 17261,
     /*  946227 */     GIR_EraseRootFromParent_Done,
     /*  946228 */   // Label 14265: @946228
     /*  946228 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(946312), // Rule ID 17270 //
     /*  946233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  946244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  946247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  946250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946276 */     // MIs[0] round
     /*  946276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946288 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  946291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946310 */     GIR_RootConstrainSelectedInstOperands,
     /*  946311 */     // GIR_Coverage, 17270,
     /*  946311 */     GIR_EraseRootFromParent_Done,
     /*  946312 */   // Label 14266: @946312
     /*  946312 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(946396), // Rule ID 17271 //
     /*  946317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  946328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  946331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  946334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946360 */     // MIs[0] round
     /*  946360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946372 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  946375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946394 */     GIR_RootConstrainSelectedInstOperands,
     /*  946395 */     // GIR_Coverage, 17271,
     /*  946395 */     GIR_EraseRootFromParent_Done,
     /*  946396 */   // Label 14267: @946396
     /*  946396 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(946480), // Rule ID 17280 //
     /*  946401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  946412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  946415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  946418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  946421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946444 */     // MIs[0] round
     /*  946444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  946459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946478 */     GIR_RootConstrainSelectedInstOperands,
     /*  946479 */     // GIR_Coverage, 17280,
     /*  946479 */     GIR_EraseRootFromParent_Done,
     /*  946480 */   // Label 14268: @946480
     /*  946480 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(946564), // Rule ID 17281 //
     /*  946485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  946496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  946499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  946502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  946505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946528 */     // MIs[0] round
     /*  946528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946540 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  946543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946562 */     GIR_RootConstrainSelectedInstOperands,
     /*  946563 */     // GIR_Coverage, 17281,
     /*  946563 */     GIR_EraseRootFromParent_Done,
     /*  946564 */   // Label 14269: @946564
     /*  946564 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(946648), // Rule ID 17290 //
     /*  946569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  946572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  946580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  946583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  946586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  946589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946612 */     // MIs[0] round
     /*  946612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  946624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  946627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946646 */     GIR_RootConstrainSelectedInstOperands,
     /*  946647 */     // GIR_Coverage, 17290,
     /*  946647 */     GIR_EraseRootFromParent_Done,
     /*  946648 */   // Label 14270: @946648
     /*  946648 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(946732), // Rule ID 17291 //
     /*  946653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  946656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  946664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  946667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  946670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  946673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  946692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  946696 */     // MIs[0] round
     /*  946696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  946708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  946711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946730 */     GIR_RootConstrainSelectedInstOperands,
     /*  946731 */     // GIR_Coverage, 17291,
     /*  946731 */     GIR_EraseRootFromParent_Done,
     /*  946732 */   // Label 14271: @946732
     /*  946732 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(946816), // Rule ID 17300 //
     /*  946737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  946740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  946751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946780 */     // MIs[0] round
     /*  946780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946792 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  946792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  946795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946814 */     GIR_RootConstrainSelectedInstOperands,
     /*  946815 */     // GIR_Coverage, 17300,
     /*  946815 */     GIR_EraseRootFromParent_Done,
     /*  946816 */   // Label 14272: @946816
     /*  946816 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(946900), // Rule ID 17301 //
     /*  946821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  946824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  946835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  946841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946864 */     // MIs[0] round
     /*  946864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946876 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  946876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  946879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946898 */     GIR_RootConstrainSelectedInstOperands,
     /*  946899 */     // GIR_Coverage, 17301,
     /*  946899 */     GIR_EraseRootFromParent_Done,
     /*  946900 */   // Label 14273: @946900
     /*  946900 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(946984), // Rule ID 17310 //
     /*  946905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  946908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  946916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  946919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  946922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  946936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  946940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  946944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946948 */     // MIs[0] round
     /*  946948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  946951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  946953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946960 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  946960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  946963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  946967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  946969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  946971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  946982 */     GIR_RootConstrainSelectedInstOperands,
     /*  946983 */     // GIR_Coverage, 17310,
     /*  946983 */     GIR_EraseRootFromParent_Done,
     /*  946984 */   // Label 14274: @946984
     /*  946984 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(947068), // Rule ID 17311 //
     /*  946989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  946992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  946997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  947000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  947003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  947006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947032 */     // MIs[0] round
     /*  947032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  947047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947066 */     GIR_RootConstrainSelectedInstOperands,
     /*  947067 */     // GIR_Coverage, 17311,
     /*  947067 */     GIR_EraseRootFromParent_Done,
     /*  947068 */   // Label 14275: @947068
     /*  947068 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(947152), // Rule ID 17320 //
     /*  947073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  947076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  947084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  947087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  947090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  947093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947116 */     // MIs[0] round
     /*  947116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  947128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  947131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947150 */     GIR_RootConstrainSelectedInstOperands,
     /*  947151 */     // GIR_Coverage, 17320,
     /*  947151 */     GIR_EraseRootFromParent_Done,
     /*  947152 */   // Label 14276: @947152
     /*  947152 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(947236), // Rule ID 17321 //
     /*  947157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  947160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  947168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  947171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  947174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  947177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947200 */     // MIs[0] round
     /*  947200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947212 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  947215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947234 */     GIR_RootConstrainSelectedInstOperands,
     /*  947235 */     // GIR_Coverage, 17321,
     /*  947235 */     GIR_EraseRootFromParent_Done,
     /*  947236 */   // Label 14277: @947236
     /*  947236 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(947320), // Rule ID 17330 //
     /*  947241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  947244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  947252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  947255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  947258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  947261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947284 */     // MIs[0] round
     /*  947284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947296 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  947296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  947299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947318 */     GIR_RootConstrainSelectedInstOperands,
     /*  947319 */     // GIR_Coverage, 17330,
     /*  947319 */     GIR_EraseRootFromParent_Done,
     /*  947320 */   // Label 14278: @947320
     /*  947320 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(947404), // Rule ID 17331 //
     /*  947325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  947328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  947333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  947336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  947339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  947342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  947345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  947356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  947360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  947364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947368 */     // MIs[0] round
     /*  947368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  947371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  947373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947380 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  947380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  947383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  947387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  947389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  947391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  947402 */     GIR_RootConstrainSelectedInstOperands,
     /*  947403 */     // GIR_Coverage, 17331,
     /*  947403 */     GIR_EraseRootFromParent_Done,
     /*  947404 */   // Label 14279: @947404
     /*  947404 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(947486), // Rule ID 62825 //
     /*  947409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947436 */     // MIs[0] op1
     /*  947436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947463 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  947466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947474 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947484 */     GIR_RootConstrainSelectedInstOperands,
     /*  947485 */     // GIR_Coverage, 62825,
     /*  947485 */     GIR_EraseRootFromParent_Done,
     /*  947486 */   // Label 14280: @947486
     /*  947486 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(947568), // Rule ID 62826 //
     /*  947491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947518 */     // MIs[0] op1
     /*  947518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  947548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947550 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947552 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947554 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947556 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947566 */     GIR_RootConstrainSelectedInstOperands,
     /*  947567 */     // GIR_Coverage, 62826,
     /*  947567 */     GIR_EraseRootFromParent_Done,
     /*  947568 */   // Label 14281: @947568
     /*  947568 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(947650), // Rule ID 62855 //
     /*  947573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  947593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947600 */     // MIs[0] op1
     /*  947600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  947630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947648 */     GIR_RootConstrainSelectedInstOperands,
     /*  947649 */     // GIR_Coverage, 62855,
     /*  947649 */     GIR_EraseRootFromParent_Done,
     /*  947650 */   // Label 14282: @947650
     /*  947650 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(947732), // Rule ID 62856 //
     /*  947655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  947666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  947669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  947672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  947675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947682 */     // MIs[0] op1
     /*  947682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947709 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  947712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947714 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947716 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947718 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947720 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947730 */     GIR_RootConstrainSelectedInstOperands,
     /*  947731 */     // GIR_Coverage, 62856,
     /*  947731 */     GIR_EraseRootFromParent_Done,
     /*  947732 */   // Label 14283: @947732
     /*  947732 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(947814), // Rule ID 62887 //
     /*  947737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947764 */     // MIs[0] op1
     /*  947764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947791 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  947794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947796 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947798 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947800 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947802 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947812 */     GIR_RootConstrainSelectedInstOperands,
     /*  947813 */     // GIR_Coverage, 62887,
     /*  947813 */     GIR_EraseRootFromParent_Done,
     /*  947814 */   // Label 14284: @947814
     /*  947814 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(947896), // Rule ID 62888 //
     /*  947819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947846 */     // MIs[0] op1
     /*  947846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947873 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  947876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947878 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947880 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947882 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947884 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947894 */     GIR_RootConstrainSelectedInstOperands,
     /*  947895 */     // GIR_Coverage, 62888,
     /*  947895 */     GIR_EraseRootFromParent_Done,
     /*  947896 */   // Label 14285: @947896
     /*  947896 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(947978), // Rule ID 62899 //
     /*  947901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  947918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  947921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947928 */     // MIs[0] op1
     /*  947928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947955 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  947958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947966 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947976 */     GIR_RootConstrainSelectedInstOperands,
     /*  947977 */     // GIR_Coverage, 62899,
     /*  947977 */     GIR_EraseRootFromParent_Done,
     /*  947978 */   // Label 14286: @947978
     /*  947978 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(948060), // Rule ID 62900 //
     /*  947983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  947994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  947997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  948000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  948003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948010 */     // MIs[0] op1
     /*  948010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948037 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948042 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948044 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948046 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948048 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948058 */     GIR_RootConstrainSelectedInstOperands,
     /*  948059 */     // GIR_Coverage, 62900,
     /*  948059 */     GIR_EraseRootFromParent_Done,
     /*  948060 */   // Label 14287: @948060
     /*  948060 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(948142), // Rule ID 62931 //
     /*  948065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948092 */     // MIs[0] op1
     /*  948092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948119 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948130 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948140 */     GIR_RootConstrainSelectedInstOperands,
     /*  948141 */     // GIR_Coverage, 62931,
     /*  948141 */     GIR_EraseRootFromParent_Done,
     /*  948142 */   // Label 14288: @948142
     /*  948142 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(948224), // Rule ID 62932 //
     /*  948147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948174 */     // MIs[0] op1
     /*  948174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948201 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948206 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948208 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948210 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948212 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948222 */     GIR_RootConstrainSelectedInstOperands,
     /*  948223 */     // GIR_Coverage, 62932,
     /*  948223 */     GIR_EraseRootFromParent_Done,
     /*  948224 */   // Label 14289: @948224
     /*  948224 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(948306), // Rule ID 62943 //
     /*  948229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  948249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948256 */     // MIs[0] op1
     /*  948256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948283 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  948286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948294 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948304 */     GIR_RootConstrainSelectedInstOperands,
     /*  948305 */     // GIR_Coverage, 62943,
     /*  948305 */     GIR_EraseRootFromParent_Done,
     /*  948306 */   // Label 14290: @948306
     /*  948306 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(948388), // Rule ID 62944 //
     /*  948311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  948322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  948325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  948328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  948331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948338 */     // MIs[0] op1
     /*  948338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948365 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  948368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948370 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948372 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948374 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948376 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948386 */     GIR_RootConstrainSelectedInstOperands,
     /*  948387 */     // GIR_Coverage, 62944,
     /*  948387 */     GIR_EraseRootFromParent_Done,
     /*  948388 */   // Label 14291: @948388
     /*  948388 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(948470), // Rule ID 62975 //
     /*  948393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948420 */     // MIs[0] op1
     /*  948420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  948450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948452 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948454 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948456 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948458 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948468 */     GIR_RootConstrainSelectedInstOperands,
     /*  948469 */     // GIR_Coverage, 62975,
     /*  948469 */     GIR_EraseRootFromParent_Done,
     /*  948470 */   // Label 14292: @948470
     /*  948470 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(948552), // Rule ID 62976 //
     /*  948475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948502 */     // MIs[0] op1
     /*  948502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948529 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  948532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948534 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948536 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948538 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948540 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948550 */     GIR_RootConstrainSelectedInstOperands,
     /*  948551 */     // GIR_Coverage, 62976,
     /*  948551 */     GIR_EraseRootFromParent_Done,
     /*  948552 */   // Label 14293: @948552
     /*  948552 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(948634), // Rule ID 62987 //
     /*  948557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  948577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948584 */     // MIs[0] op1
     /*  948584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948616 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948618 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948620 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948622 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948632 */     GIR_RootConstrainSelectedInstOperands,
     /*  948633 */     // GIR_Coverage, 62987,
     /*  948633 */     GIR_EraseRootFromParent_Done,
     /*  948634 */   // Label 14294: @948634
     /*  948634 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(948716), // Rule ID 62988 //
     /*  948639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  948659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948666 */     // MIs[0] op1
     /*  948666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948693 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  948696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948698 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948700 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948702 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948704 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948714 */     GIR_RootConstrainSelectedInstOperands,
     /*  948715 */     // GIR_Coverage, 62988,
     /*  948715 */     GIR_EraseRootFromParent_Done,
     /*  948716 */   // Label 14295: @948716
     /*  948716 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(948798), // Rule ID 62999 //
     /*  948721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948748 */     // MIs[0] op1
     /*  948748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948775 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  948778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948780 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948782 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948784 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948786 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948796 */     GIR_RootConstrainSelectedInstOperands,
     /*  948797 */     // GIR_Coverage, 62999,
     /*  948797 */     GIR_EraseRootFromParent_Done,
     /*  948798 */   // Label 14296: @948798
     /*  948798 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(948880), // Rule ID 63000 //
     /*  948803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  948814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  948817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  948820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948830 */     // MIs[0] op1
     /*  948830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948857 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  948860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948862 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948864 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948866 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948868 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948878 */     GIR_RootConstrainSelectedInstOperands,
     /*  948879 */     // GIR_Coverage, 63000,
     /*  948879 */     GIR_EraseRootFromParent_Done,
     /*  948880 */   // Label 14297: @948880
     /*  948880 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(948962), // Rule ID 63031 //
     /*  948885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  948896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  948899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  948902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948912 */     // MIs[0] op1
     /*  948912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  948942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948944 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948946 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948948 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948950 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948960 */     GIR_RootConstrainSelectedInstOperands,
     /*  948961 */     // GIR_Coverage, 63031,
     /*  948961 */     GIR_EraseRootFromParent_Done,
     /*  948962 */   // Label 14298: @948962
     /*  948962 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(949044), // Rule ID 63032 //
     /*  948967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  948978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  948981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  948984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  948994 */     // MIs[0] op1
     /*  948994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949021 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949032 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949042 */     GIR_RootConstrainSelectedInstOperands,
     /*  949043 */     // GIR_Coverage, 63032,
     /*  949043 */     GIR_EraseRootFromParent_Done,
     /*  949044 */   // Label 14299: @949044
     /*  949044 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(949126), // Rule ID 63043 //
     /*  949049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  949069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949076 */     // MIs[0] op1
     /*  949076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949103 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949108 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949110 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949112 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949114 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949124 */     GIR_RootConstrainSelectedInstOperands,
     /*  949125 */     // GIR_Coverage, 63043,
     /*  949125 */     GIR_EraseRootFromParent_Done,
     /*  949126 */   // Label 14300: @949126
     /*  949126 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(949208), // Rule ID 63044 //
     /*  949131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  949151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949158 */     // MIs[0] op1
     /*  949158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949185 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949190 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949192 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949194 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949196 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949206 */     GIR_RootConstrainSelectedInstOperands,
     /*  949207 */     // GIR_Coverage, 63044,
     /*  949207 */     GIR_EraseRootFromParent_Done,
     /*  949208 */   // Label 14301: @949208
     /*  949208 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(949290), // Rule ID 63055 //
     /*  949213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949240 */     // MIs[0] op1
     /*  949240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  949270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949272 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949274 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949276 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949278 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949288 */     GIR_RootConstrainSelectedInstOperands,
     /*  949289 */     // GIR_Coverage, 63055,
     /*  949289 */     GIR_EraseRootFromParent_Done,
     /*  949290 */   // Label 14302: @949290
     /*  949290 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(949372), // Rule ID 63056 //
     /*  949295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  949306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  949309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  949312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949322 */     // MIs[0] op1
     /*  949322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949349 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  949352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949354 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949356 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949358 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949360 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949370 */     GIR_RootConstrainSelectedInstOperands,
     /*  949371 */     // GIR_Coverage, 63056,
     /*  949371 */     GIR_EraseRootFromParent_Done,
     /*  949372 */   // Label 14303: @949372
     /*  949372 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(949454), // Rule ID 63087 //
     /*  949377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949404 */     // MIs[0] op1
     /*  949404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949431 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949442 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949452 */     GIR_RootConstrainSelectedInstOperands,
     /*  949453 */     // GIR_Coverage, 63087,
     /*  949453 */     GIR_EraseRootFromParent_Done,
     /*  949454 */   // Label 14304: @949454
     /*  949454 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(949536), // Rule ID 63088 //
     /*  949459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949486 */     // MIs[0] op1
     /*  949486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949513 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  949516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949518 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949520 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949522 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949524 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949534 */     GIR_RootConstrainSelectedInstOperands,
     /*  949535 */     // GIR_Coverage, 63088,
     /*  949535 */     GIR_EraseRootFromParent_Done,
     /*  949536 */   // Label 14305: @949536
     /*  949536 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(949618), // Rule ID 63099 //
     /*  949541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  949561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949568 */     // MIs[0] op1
     /*  949568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949600 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949602 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949604 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949606 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949616 */     GIR_RootConstrainSelectedInstOperands,
     /*  949617 */     // GIR_Coverage, 63099,
     /*  949617 */     GIR_EraseRootFromParent_Done,
     /*  949618 */   // Label 14306: @949618
     /*  949618 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(949700), // Rule ID 63100 //
     /*  949623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  949643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949650 */     // MIs[0] op1
     /*  949650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  949680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949682 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949684 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949686 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949688 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949698 */     GIR_RootConstrainSelectedInstOperands,
     /*  949699 */     // GIR_Coverage, 63100,
     /*  949699 */     GIR_EraseRootFromParent_Done,
     /*  949700 */   // Label 14307: @949700
     /*  949700 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(949782), // Rule ID 63111 //
     /*  949705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949732 */     // MIs[0] op1
     /*  949732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949735 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  949752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949759 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  949762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949764 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949766 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949768 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949770 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949780 */     GIR_RootConstrainSelectedInstOperands,
     /*  949781 */     // GIR_Coverage, 63111,
     /*  949781 */     GIR_EraseRootFromParent_Done,
     /*  949782 */   // Label 14308: @949782
     /*  949782 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(949864), // Rule ID 63112 //
     /*  949787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  949798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  949801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  949804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949814 */     // MIs[0] op1
     /*  949814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  949834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949841 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  949844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949846 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949848 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949850 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949852 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949862 */     GIR_RootConstrainSelectedInstOperands,
     /*  949863 */     // GIR_Coverage, 63112,
     /*  949863 */     GIR_EraseRootFromParent_Done,
     /*  949864 */   // Label 14309: @949864
     /*  949864 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(949946), // Rule ID 63143 //
     /*  949869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  949880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  949883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949896 */     // MIs[0] op1
     /*  949896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949923 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  949923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  949926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949928 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949930 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949932 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949934 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  949944 */     GIR_RootConstrainSelectedInstOperands,
     /*  949945 */     // GIR_Coverage, 63143,
     /*  949945 */     GIR_EraseRootFromParent_Done,
     /*  949946 */   // Label 14310: @949946
     /*  949946 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(950028), // Rule ID 63144 //
     /*  949951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  949962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  949965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  949968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949978 */     // MIs[0] op1
     /*  949978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  949994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950005 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  950005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950010 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950012 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950014 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950016 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950026 */     GIR_RootConstrainSelectedInstOperands,
     /*  950027 */     // GIR_Coverage, 63144,
     /*  950027 */     GIR_EraseRootFromParent_Done,
     /*  950028 */   // Label 14311: @950028
     /*  950028 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(950110), // Rule ID 63155 //
     /*  950033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  950044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  950047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  950050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  950053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950060 */     // MIs[0] op1
     /*  950060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950087 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  950087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950092 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950094 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950096 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950098 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950108 */     GIR_RootConstrainSelectedInstOperands,
     /*  950109 */     // GIR_Coverage, 63155,
     /*  950109 */     GIR_EraseRootFromParent_Done,
     /*  950110 */   // Label 14312: @950110
     /*  950110 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(950192), // Rule ID 63156 //
     /*  950115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  950126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  950129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  950132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  950135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950142 */     // MIs[0] op1
     /*  950142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950169 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  950169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950174 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950176 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950178 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950180 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  950190 */     GIR_RootConstrainSelectedInstOperands,
     /*  950191 */     // GIR_Coverage, 63156,
     /*  950191 */     GIR_EraseRootFromParent_Done,
     /*  950192 */   // Label 14313: @950192
     /*  950192 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(950274), // Rule ID 63187 //
     /*  950197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950224 */     // MIs[0] op1
     /*  950224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950251 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950256 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950258 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950260 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950262 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950272 */     GIR_RootConstrainSelectedInstOperands,
     /*  950273 */     // GIR_Coverage, 63187,
     /*  950273 */     GIR_EraseRootFromParent_Done,
     /*  950274 */   // Label 14314: @950274
     /*  950274 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(950356), // Rule ID 63188 //
     /*  950279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950306 */     // MIs[0] op1
     /*  950306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950338 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950340 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950342 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950344 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950354 */     GIR_RootConstrainSelectedInstOperands,
     /*  950355 */     // GIR_Coverage, 63188,
     /*  950355 */     GIR_EraseRootFromParent_Done,
     /*  950356 */   // Label 14315: @950356
     /*  950356 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(950438), // Rule ID 63199 //
     /*  950361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  950381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950388 */     // MIs[0] op1
     /*  950388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950415 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950420 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950422 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950424 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950426 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950436 */     GIR_RootConstrainSelectedInstOperands,
     /*  950437 */     // GIR_Coverage, 63199,
     /*  950437 */     GIR_EraseRootFromParent_Done,
     /*  950438 */   // Label 14316: @950438
     /*  950438 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(950520), // Rule ID 63200 //
     /*  950443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  950463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950470 */     // MIs[0] op1
     /*  950470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950502 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950504 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950506 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950508 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950518 */     GIR_RootConstrainSelectedInstOperands,
     /*  950519 */     // GIR_Coverage, 63200,
     /*  950519 */     GIR_EraseRootFromParent_Done,
     /*  950520 */   // Label 14317: @950520
     /*  950520 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(950602), // Rule ID 63211 //
     /*  950525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950552 */     // MIs[0] op1
     /*  950552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950579 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  950582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950584 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950586 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950588 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950590 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950600 */     GIR_RootConstrainSelectedInstOperands,
     /*  950601 */     // GIR_Coverage, 63211,
     /*  950601 */     GIR_EraseRootFromParent_Done,
     /*  950602 */   // Label 14318: @950602
     /*  950602 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(950684), // Rule ID 63212 //
     /*  950607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  950618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  950621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  950624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950634 */     // MIs[0] op1
     /*  950634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950661 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  950664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950666 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950668 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950670 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950672 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950682 */     GIR_RootConstrainSelectedInstOperands,
     /*  950683 */     // GIR_Coverage, 63212,
     /*  950683 */     GIR_EraseRootFromParent_Done,
     /*  950684 */   // Label 14319: @950684
     /*  950684 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(950766), // Rule ID 63243 //
     /*  950689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950716 */     // MIs[0] op1
     /*  950716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950743 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950748 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950750 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950752 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950754 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950764 */     GIR_RootConstrainSelectedInstOperands,
     /*  950765 */     // GIR_Coverage, 63243,
     /*  950765 */     GIR_EraseRootFromParent_Done,
     /*  950766 */   // Label 14320: @950766
     /*  950766 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(950848), // Rule ID 63244 //
     /*  950771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950798 */     // MIs[0] op1
     /*  950798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950825 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  950828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950830 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950832 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950834 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950836 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950846 */     GIR_RootConstrainSelectedInstOperands,
     /*  950847 */     // GIR_Coverage, 63244,
     /*  950847 */     GIR_EraseRootFromParent_Done,
     /*  950848 */   // Label 14321: @950848
     /*  950848 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(950930), // Rule ID 63255 //
     /*  950853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  950873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950880 */     // MIs[0] op1
     /*  950880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950907 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950912 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950914 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950916 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950918 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950928 */     GIR_RootConstrainSelectedInstOperands,
     /*  950929 */     // GIR_Coverage, 63255,
     /*  950929 */     GIR_EraseRootFromParent_Done,
     /*  950930 */   // Label 14322: @950930
     /*  950930 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(951012), // Rule ID 63256 //
     /*  950935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  950946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  950949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  950952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  950955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950962 */     // MIs[0] op1
     /*  950962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  950982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950989 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  950992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951000 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951010 */     GIR_RootConstrainSelectedInstOperands,
     /*  951011 */     // GIR_Coverage, 63256,
     /*  951011 */     GIR_EraseRootFromParent_Done,
     /*  951012 */   // Label 14323: @951012
     /*  951012 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(951094), // Rule ID 63267 //
     /*  951017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  951028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  951031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  951034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951044 */     // MIs[0] op1
     /*  951044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951071 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  951074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951076 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951078 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951080 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951082 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951092 */     GIR_RootConstrainSelectedInstOperands,
     /*  951093 */     // GIR_Coverage, 63267,
     /*  951093 */     GIR_EraseRootFromParent_Done,
     /*  951094 */   // Label 14324: @951094
     /*  951094 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(951176), // Rule ID 63268 //
     /*  951099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  951110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  951113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  951116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951126 */     // MIs[0] op1
     /*  951126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951153 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  951156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951158 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951160 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951162 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951164 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951174 */     GIR_RootConstrainSelectedInstOperands,
     /*  951175 */     // GIR_Coverage, 63268,
     /*  951175 */     GIR_EraseRootFromParent_Done,
     /*  951176 */   // Label 14325: @951176
     /*  951176 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(951258), // Rule ID 63299 //
     /*  951181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951208 */     // MIs[0] op1
     /*  951208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  951238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951240 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951242 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951244 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951246 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951256 */     GIR_RootConstrainSelectedInstOperands,
     /*  951257 */     // GIR_Coverage, 63299,
     /*  951257 */     GIR_EraseRootFromParent_Done,
     /*  951258 */   // Label 14326: @951258
     /*  951258 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(951340), // Rule ID 63300 //
     /*  951263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951290 */     // MIs[0] op1
     /*  951290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951317 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  951320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951322 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951324 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951326 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951328 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951338 */     GIR_RootConstrainSelectedInstOperands,
     /*  951339 */     // GIR_Coverage, 63300,
     /*  951339 */     GIR_EraseRootFromParent_Done,
     /*  951340 */   // Label 14327: @951340
     /*  951340 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(951422), // Rule ID 63311 //
     /*  951345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  951365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951372 */     // MIs[0] op1
     /*  951372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  951402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951404 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951406 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951408 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951410 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951420 */     GIR_RootConstrainSelectedInstOperands,
     /*  951421 */     // GIR_Coverage, 63311,
     /*  951421 */     GIR_EraseRootFromParent_Done,
     /*  951422 */   // Label 14328: @951422
     /*  951422 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(951504), // Rule ID 63312 //
     /*  951427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  951447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951454 */     // MIs[0] op1
     /*  951454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951481 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  951484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951492 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951502 */     GIR_RootConstrainSelectedInstOperands,
     /*  951503 */     // GIR_Coverage, 63312,
     /*  951503 */     GIR_EraseRootFromParent_Done,
     /*  951504 */   // Label 14329: @951504
     /*  951504 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(951586), // Rule ID 63323 //
     /*  951509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951536 */     // MIs[0] op1
     /*  951536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951563 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  951566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951568 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951570 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951572 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951574 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951584 */     GIR_RootConstrainSelectedInstOperands,
     /*  951585 */     // GIR_Coverage, 63323,
     /*  951585 */     GIR_EraseRootFromParent_Done,
     /*  951586 */   // Label 14330: @951586
     /*  951586 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(951668), // Rule ID 63324 //
     /*  951591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  951602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  951605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  951608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951618 */     // MIs[0] op1
     /*  951618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  951634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951645 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  951648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951650 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951652 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951654 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951656 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951666 */     GIR_RootConstrainSelectedInstOperands,
     /*  951667 */     // GIR_Coverage, 63324,
     /*  951667 */     GIR_EraseRootFromParent_Done,
     /*  951668 */   // Label 14331: @951668
     /*  951668 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(951750), // Rule ID 63355 //
     /*  951673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951700 */     // MIs[0] op1
     /*  951700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  951727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951732 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951734 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951736 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951738 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951748 */     GIR_RootConstrainSelectedInstOperands,
     /*  951749 */     // GIR_Coverage, 63355,
     /*  951749 */     GIR_EraseRootFromParent_Done,
     /*  951750 */   // Label 14332: @951750
     /*  951750 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(951832), // Rule ID 63356 //
     /*  951755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951782 */     // MIs[0] op1
     /*  951782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  951809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951814 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951816 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951818 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951820 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951830 */     GIR_RootConstrainSelectedInstOperands,
     /*  951831 */     // GIR_Coverage, 63356,
     /*  951831 */     GIR_EraseRootFromParent_Done,
     /*  951832 */   // Label 14333: @951832
     /*  951832 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(951914), // Rule ID 63367 //
     /*  951837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  951857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951864 */     // MIs[0] op1
     /*  951864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  951891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951896 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951898 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951900 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951902 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951912 */     GIR_RootConstrainSelectedInstOperands,
     /*  951913 */     // GIR_Coverage, 63367,
     /*  951913 */     GIR_EraseRootFromParent_Done,
     /*  951914 */   // Label 14334: @951914
     /*  951914 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(951996), // Rule ID 63368 //
     /*  951919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  951930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  951933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  951936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  951939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951946 */     // MIs[0] op1
     /*  951946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951973 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  951973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951984 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  951994 */     GIR_RootConstrainSelectedInstOperands,
     /*  951995 */     // GIR_Coverage, 63368,
     /*  951995 */     GIR_EraseRootFromParent_Done,
     /*  951996 */   // Label 14335: @951996
     /*  951996 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(952078), // Rule ID 63399 //
     /*  952001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952028 */     // MIs[0] op1
     /*  952028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952055 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952060 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952062 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952064 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952066 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952076 */     GIR_RootConstrainSelectedInstOperands,
     /*  952077 */     // GIR_Coverage, 63399,
     /*  952077 */     GIR_EraseRootFromParent_Done,
     /*  952078 */   // Label 14336: @952078
     /*  952078 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(952160), // Rule ID 63400 //
     /*  952083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952110 */     // MIs[0] op1
     /*  952110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952137 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952142 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952144 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952146 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952148 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952158 */     GIR_RootConstrainSelectedInstOperands,
     /*  952159 */     // GIR_Coverage, 63400,
     /*  952159 */     GIR_EraseRootFromParent_Done,
     /*  952160 */   // Label 14337: @952160
     /*  952160 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(952242), // Rule ID 63411 //
     /*  952165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  952185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952192 */     // MIs[0] op1
     /*  952192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952219 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952224 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952226 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952228 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952230 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952240 */     GIR_RootConstrainSelectedInstOperands,
     /*  952241 */     // GIR_Coverage, 63411,
     /*  952241 */     GIR_EraseRootFromParent_Done,
     /*  952242 */   // Label 14338: @952242
     /*  952242 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(952324), // Rule ID 63412 //
     /*  952247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  952258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  952261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  952264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  952267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952274 */     // MIs[0] op1
     /*  952274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952301 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952312 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952322 */     GIR_RootConstrainSelectedInstOperands,
     /*  952323 */     // GIR_Coverage, 63412,
     /*  952323 */     GIR_EraseRootFromParent_Done,
     /*  952324 */   // Label 14339: @952324
     /*  952324 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(952406), // Rule ID 63443 //
     /*  952329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952356 */     // MIs[0] op1
     /*  952356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952383 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952388 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952390 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952392 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952394 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952404 */     GIR_RootConstrainSelectedInstOperands,
     /*  952405 */     // GIR_Coverage, 63443,
     /*  952405 */     GIR_EraseRootFromParent_Done,
     /*  952406 */   // Label 14340: @952406
     /*  952406 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(952488), // Rule ID 63444 //
     /*  952411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952438 */     // MIs[0] op1
     /*  952438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952465 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952470 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952472 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952474 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952476 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952486 */     GIR_RootConstrainSelectedInstOperands,
     /*  952487 */     // GIR_Coverage, 63444,
     /*  952487 */     GIR_EraseRootFromParent_Done,
     /*  952488 */   // Label 14341: @952488
     /*  952488 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(952570), // Rule ID 63455 //
     /*  952493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  952513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952520 */     // MIs[0] op1
     /*  952520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952547 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952552 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952554 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952556 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952558 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952568 */     GIR_RootConstrainSelectedInstOperands,
     /*  952569 */     // GIR_Coverage, 63455,
     /*  952569 */     GIR_EraseRootFromParent_Done,
     /*  952570 */   // Label 14342: @952570
     /*  952570 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(952652), // Rule ID 63456 //
     /*  952575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  952586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  952589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  952592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  952595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952602 */     // MIs[0] op1
     /*  952602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952629 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952634 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952636 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952638 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952640 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952650 */     GIR_RootConstrainSelectedInstOperands,
     /*  952651 */     // GIR_Coverage, 63456,
     /*  952651 */     GIR_EraseRootFromParent_Done,
     /*  952652 */   // Label 14343: @952652
     /*  952652 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(952734), // Rule ID 63487 //
     /*  952657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952684 */     // MIs[0] op1
     /*  952684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952711 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  952711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  952714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952716 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952718 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952720 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952722 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952732 */     GIR_RootConstrainSelectedInstOperands,
     /*  952733 */     // GIR_Coverage, 63487,
     /*  952733 */     GIR_EraseRootFromParent_Done,
     /*  952734 */   // Label 14344: @952734
     /*  952734 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(952816), // Rule ID 63488 //
     /*  952739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952766 */     // MIs[0] op1
     /*  952766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  952793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  952796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952814 */     GIR_RootConstrainSelectedInstOperands,
     /*  952815 */     // GIR_Coverage, 63488,
     /*  952815 */     GIR_EraseRootFromParent_Done,
     /*  952816 */   // Label 14345: @952816
     /*  952816 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(952898), // Rule ID 63499 //
     /*  952821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  952841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952848 */     // MIs[0] op1
     /*  952848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  952875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  952878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952880 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952882 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952884 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952886 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952896 */     GIR_RootConstrainSelectedInstOperands,
     /*  952897 */     // GIR_Coverage, 63499,
     /*  952897 */     GIR_EraseRootFromParent_Done,
     /*  952898 */   // Label 14346: @952898
     /*  952898 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(952980), // Rule ID 63500 //
     /*  952903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  952920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  952923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952930 */     // MIs[0] op1
     /*  952930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  952957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  952960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952962 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952964 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952966 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952968 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  952978 */     GIR_RootConstrainSelectedInstOperands,
     /*  952979 */     // GIR_Coverage, 63500,
     /*  952979 */     GIR_EraseRootFromParent_Done,
     /*  952980 */   // Label 14347: @952980
     /*  952980 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(953062), // Rule ID 63511 //
     /*  952985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  952996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  952999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  953002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953012 */     // MIs[0] op1
     /*  953012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  953042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953044 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953046 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953048 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953050 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953060 */     GIR_RootConstrainSelectedInstOperands,
     /*  953061 */     // GIR_Coverage, 63511,
     /*  953061 */     GIR_EraseRootFromParent_Done,
     /*  953062 */   // Label 14348: @953062
     /*  953062 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(953144), // Rule ID 63512 //
     /*  953067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  953084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953094 */     // MIs[0] op1
     /*  953094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  953124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953132 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953142 */     GIR_RootConstrainSelectedInstOperands,
     /*  953143 */     // GIR_Coverage, 63512,
     /*  953143 */     GIR_EraseRootFromParent_Done,
     /*  953144 */   // Label 14349: @953144
     /*  953144 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(953226), // Rule ID 63543 //
     /*  953149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953176 */     // MIs[0] op1
     /*  953176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953203 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  953206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953208 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953210 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953212 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953214 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953224 */     GIR_RootConstrainSelectedInstOperands,
     /*  953225 */     // GIR_Coverage, 63543,
     /*  953225 */     GIR_EraseRootFromParent_Done,
     /*  953226 */   // Label 14350: @953226
     /*  953226 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(953308), // Rule ID 63544 //
     /*  953231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953258 */     // MIs[0] op1
     /*  953258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953285 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  953288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953290 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953292 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953294 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953296 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953306 */     GIR_RootConstrainSelectedInstOperands,
     /*  953307 */     // GIR_Coverage, 63544,
     /*  953307 */     GIR_EraseRootFromParent_Done,
     /*  953308 */   // Label 14351: @953308
     /*  953308 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(953390), // Rule ID 63555 //
     /*  953313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  953333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953340 */     // MIs[0] op1
     /*  953340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953367 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  953370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953372 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953374 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953376 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953378 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953388 */     GIR_RootConstrainSelectedInstOperands,
     /*  953389 */     // GIR_Coverage, 63555,
     /*  953389 */     GIR_EraseRootFromParent_Done,
     /*  953390 */   // Label 14352: @953390
     /*  953390 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(953472), // Rule ID 63556 //
     /*  953395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  953415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953422 */     // MIs[0] op1
     /*  953422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  953452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953460 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953470 */     GIR_RootConstrainSelectedInstOperands,
     /*  953471 */     // GIR_Coverage, 63556,
     /*  953471 */     GIR_EraseRootFromParent_Done,
     /*  953472 */   // Label 14353: @953472
     /*  953472 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(953554), // Rule ID 63567 //
     /*  953477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953504 */     // MIs[0] op1
     /*  953504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953531 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  953534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953536 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953538 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953540 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953542 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953552 */     GIR_RootConstrainSelectedInstOperands,
     /*  953553 */     // GIR_Coverage, 63567,
     /*  953553 */     GIR_EraseRootFromParent_Done,
     /*  953554 */   // Label 14354: @953554
     /*  953554 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(953636), // Rule ID 63568 //
     /*  953559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  953570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  953573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  953576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953586 */     // MIs[0] op1
     /*  953586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  953602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  953606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953613 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  953616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953618 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953620 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953622 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953624 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953634 */     GIR_RootConstrainSelectedInstOperands,
     /*  953635 */     // GIR_Coverage, 63568,
     /*  953635 */     GIR_EraseRootFromParent_Done,
     /*  953636 */   // Label 14355: @953636
     /*  953636 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(953718), // Rule ID 63599 //
     /*  953641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953668 */     // MIs[0] op1
     /*  953668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953695 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  953698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953700 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953702 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953704 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953706 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953716 */     GIR_RootConstrainSelectedInstOperands,
     /*  953717 */     // GIR_Coverage, 63599,
     /*  953717 */     GIR_EraseRootFromParent_Done,
     /*  953718 */   // Label 14356: @953718
     /*  953718 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(953800), // Rule ID 63600 //
     /*  953723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  953731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953750 */     // MIs[0] op1
     /*  953750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  953780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953782 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953784 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953786 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953788 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953798 */     GIR_RootConstrainSelectedInstOperands,
     /*  953799 */     // GIR_Coverage, 63600,
     /*  953799 */     GIR_EraseRootFromParent_Done,
     /*  953800 */   // Label 14357: @953800
     /*  953800 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(953882), // Rule ID 63611 //
     /*  953805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  953825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953832 */     // MIs[0] op1
     /*  953832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953859 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  953859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  953862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953864 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953866 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953868 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953870 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953880 */     GIR_RootConstrainSelectedInstOperands,
     /*  953881 */     // GIR_Coverage, 63611,
     /*  953881 */     GIR_EraseRootFromParent_Done,
     /*  953882 */   // Label 14358: @953882
     /*  953882 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(953964), // Rule ID 63612 //
     /*  953887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  953907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953914 */     // MIs[0] op1
     /*  953914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  953941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  953944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953946 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953948 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953950 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953952 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  953962 */     GIR_RootConstrainSelectedInstOperands,
     /*  953963 */     // GIR_Coverage, 63612,
     /*  953963 */     GIR_EraseRootFromParent_Done,
     /*  953964 */   // Label 14359: @953964
     /*  953964 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(954046), // Rule ID 63623 //
     /*  953969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  953980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  953983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  953986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  953989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953996 */     // MIs[0] op1
     /*  953996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  954016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954023 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  954023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  954026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954028 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954030 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954032 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954034 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954044 */     GIR_RootConstrainSelectedInstOperands,
     /*  954045 */     // GIR_Coverage, 63623,
     /*  954045 */     GIR_EraseRootFromParent_Done,
     /*  954046 */   // Label 14360: @954046
     /*  954046 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(954128), // Rule ID 63624 //
     /*  954051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  954068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  954071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954078 */     // MIs[0] op1
     /*  954078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  954098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  954105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  954108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954110 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954112 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954114 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954116 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954126 */     GIR_RootConstrainSelectedInstOperands,
     /*  954127 */     // GIR_Coverage, 63624,
     /*  954127 */     GIR_EraseRootFromParent_Done,
     /*  954128 */   // Label 14361: @954128
     /*  954128 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(954210), // Rule ID 63655 //
     /*  954133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954160 */     // MIs[0] op1
     /*  954160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  954190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954192 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954194 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954196 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954198 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954208 */     GIR_RootConstrainSelectedInstOperands,
     /*  954209 */     // GIR_Coverage, 63655,
     /*  954209 */     GIR_EraseRootFromParent_Done,
     /*  954210 */   // Label 14362: @954210
     /*  954210 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(954292), // Rule ID 63656 //
     /*  954215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954242 */     // MIs[0] op1
     /*  954242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  954272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954274 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954276 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954278 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954280 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954290 */     GIR_RootConstrainSelectedInstOperands,
     /*  954291 */     // GIR_Coverage, 63656,
     /*  954291 */     GIR_EraseRootFromParent_Done,
     /*  954292 */   // Label 14363: @954292
     /*  954292 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(954374), // Rule ID 63667 //
     /*  954297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  954317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954324 */     // MIs[0] op1
     /*  954324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954351 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  954354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954356 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954358 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954360 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954362 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954372 */     GIR_RootConstrainSelectedInstOperands,
     /*  954373 */     // GIR_Coverage, 63667,
     /*  954373 */     GIR_EraseRootFromParent_Done,
     /*  954374 */   // Label 14364: @954374
     /*  954374 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(954456), // Rule ID 63668 //
     /*  954379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  954399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954406 */     // MIs[0] op1
     /*  954406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  954436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954444 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954454 */     GIR_RootConstrainSelectedInstOperands,
     /*  954455 */     // GIR_Coverage, 63668,
     /*  954455 */     GIR_EraseRootFromParent_Done,
     /*  954456 */   // Label 14365: @954456
     /*  954456 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(954538), // Rule ID 63679 //
     /*  954461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954488 */     // MIs[0] op1
     /*  954488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  954508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  954518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954520 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954522 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954524 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954526 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954536 */     GIR_RootConstrainSelectedInstOperands,
     /*  954537 */     // GIR_Coverage, 63679,
     /*  954537 */     GIR_EraseRootFromParent_Done,
     /*  954538 */   // Label 14366: @954538
     /*  954538 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(954620), // Rule ID 63680 //
     /*  954543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  954554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  954557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  954560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954570 */     // MIs[0] op1
     /*  954570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  954590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  954600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954602 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954604 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954606 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954608 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954618 */     GIR_RootConstrainSelectedInstOperands,
     /*  954619 */     // GIR_Coverage, 63680,
     /*  954619 */     GIR_EraseRootFromParent_Done,
     /*  954620 */   // Label 14367: @954620
     /*  954620 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(954702), // Rule ID 63711 //
     /*  954625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954652 */     // MIs[0] op1
     /*  954652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954679 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  954682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954684 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954686 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954688 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954690 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954700 */     GIR_RootConstrainSelectedInstOperands,
     /*  954701 */     // GIR_Coverage, 63711,
     /*  954701 */     GIR_EraseRootFromParent_Done,
     /*  954702 */   // Label 14368: @954702
     /*  954702 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(954784), // Rule ID 63712 //
     /*  954707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  954715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954734 */     // MIs[0] op1
     /*  954734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  954764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954766 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954768 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954770 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954772 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954782 */     GIR_RootConstrainSelectedInstOperands,
     /*  954783 */     // GIR_Coverage, 63712,
     /*  954783 */     GIR_EraseRootFromParent_Done,
     /*  954784 */   // Label 14369: @954784
     /*  954784 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(954866), // Rule ID 63723 //
     /*  954789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  954809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954816 */     // MIs[0] op1
     /*  954816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  954843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  954846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954848 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954850 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954852 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954854 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954864 */     GIR_RootConstrainSelectedInstOperands,
     /*  954865 */     // GIR_Coverage, 63723,
     /*  954865 */     GIR_EraseRootFromParent_Done,
     /*  954866 */   // Label 14370: @954866
     /*  954866 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(954948), // Rule ID 63724 //
     /*  954871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  954879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  954891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954898 */     // MIs[0] op1
     /*  954898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954925 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  954925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  954928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954930 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954932 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954934 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954936 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  954946 */     GIR_RootConstrainSelectedInstOperands,
     /*  954947 */     // GIR_Coverage, 63724,
     /*  954947 */     GIR_EraseRootFromParent_Done,
     /*  954948 */   // Label 14371: @954948
     /*  954948 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(955030), // Rule ID 63735 //
     /*  954953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  954961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  954964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  954967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  954970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954980 */     // MIs[0] op1
     /*  954980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  954988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955007 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  955010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955012 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955014 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955016 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955018 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955028 */     GIR_RootConstrainSelectedInstOperands,
     /*  955029 */     // GIR_Coverage, 63735,
     /*  955029 */     GIR_EraseRootFromParent_Done,
     /*  955030 */   // Label 14372: @955030
     /*  955030 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(955112), // Rule ID 63736 //
     /*  955035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  955046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  955049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  955052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955062 */     // MIs[0] op1
     /*  955062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955089 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  955092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955094 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955096 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955098 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955100 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955110 */     GIR_RootConstrainSelectedInstOperands,
     /*  955111 */     // GIR_Coverage, 63736,
     /*  955111 */     GIR_EraseRootFromParent_Done,
     /*  955112 */   // Label 14373: @955112
     /*  955112 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(955194), // Rule ID 63767 //
     /*  955117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955144 */     // MIs[0] op1
     /*  955144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955171 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  955174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955176 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955178 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955180 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955182 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955192 */     GIR_RootConstrainSelectedInstOperands,
     /*  955193 */     // GIR_Coverage, 63767,
     /*  955193 */     GIR_EraseRootFromParent_Done,
     /*  955194 */   // Label 14374: @955194
     /*  955194 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(955276), // Rule ID 63768 //
     /*  955199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955226 */     // MIs[0] op1
     /*  955226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955253 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  955256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955258 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955260 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955262 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955264 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955274 */     GIR_RootConstrainSelectedInstOperands,
     /*  955275 */     // GIR_Coverage, 63768,
     /*  955275 */     GIR_EraseRootFromParent_Done,
     /*  955276 */   // Label 14375: @955276
     /*  955276 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(955358), // Rule ID 63779 //
     /*  955281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  955301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955308 */     // MIs[0] op1
     /*  955308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  955338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955340 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955342 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955344 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955346 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955356 */     GIR_RootConstrainSelectedInstOperands,
     /*  955357 */     // GIR_Coverage, 63779,
     /*  955357 */     GIR_EraseRootFromParent_Done,
     /*  955358 */   // Label 14376: @955358
     /*  955358 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(955440), // Rule ID 63780 //
     /*  955363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  955383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955390 */     // MIs[0] op1
     /*  955390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955417 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  955420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955422 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955424 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955426 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955428 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955438 */     GIR_RootConstrainSelectedInstOperands,
     /*  955439 */     // GIR_Coverage, 63780,
     /*  955439 */     GIR_EraseRootFromParent_Done,
     /*  955440 */   // Label 14377: @955440
     /*  955440 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(955522), // Rule ID 63791 //
     /*  955445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955472 */     // MIs[0] op1
     /*  955472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  955499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  955502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955504 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955506 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955508 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955510 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955520 */     GIR_RootConstrainSelectedInstOperands,
     /*  955521 */     // GIR_Coverage, 63791,
     /*  955521 */     GIR_EraseRootFromParent_Done,
     /*  955522 */   // Label 14378: @955522
     /*  955522 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(955604), // Rule ID 63792 //
     /*  955527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  955538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  955541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  955544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955554 */     // MIs[0] op1
     /*  955554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  955574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  955581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  955584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955592 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  955602 */     GIR_RootConstrainSelectedInstOperands,
     /*  955603 */     // GIR_Coverage, 63792,
     /*  955603 */     GIR_EraseRootFromParent_Done,
     /*  955604 */   // Label 14379: @955604
     /*  955604 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(955686), // Rule ID 63823 //
     /*  955609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955636 */     // MIs[0] op1
     /*  955636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955663 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  955666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955668 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955670 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955672 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955674 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955684 */     GIR_RootConstrainSelectedInstOperands,
     /*  955685 */     // GIR_Coverage, 63823,
     /*  955685 */     GIR_EraseRootFromParent_Done,
     /*  955686 */   // Label 14380: @955686
     /*  955686 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(955768), // Rule ID 63824 //
     /*  955691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  955699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955718 */     // MIs[0] op1
     /*  955718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  955745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  955748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955750 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955752 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955754 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955756 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955766 */     GIR_RootConstrainSelectedInstOperands,
     /*  955767 */     // GIR_Coverage, 63824,
     /*  955767 */     GIR_EraseRootFromParent_Done,
     /*  955768 */   // Label 14381: @955768
     /*  955768 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(955850), // Rule ID 63835 //
     /*  955773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  955793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955800 */     // MIs[0] op1
     /*  955800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  955830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955832 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955834 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955836 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955838 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955848 */     GIR_RootConstrainSelectedInstOperands,
     /*  955849 */     // GIR_Coverage, 63835,
     /*  955849 */     GIR_EraseRootFromParent_Done,
     /*  955850 */   // Label 14382: @955850
     /*  955850 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(955932), // Rule ID 63836 //
     /*  955855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  955863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  955875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955882 */     // MIs[0] op1
     /*  955882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  955909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  955912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955914 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955916 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955918 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955920 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  955930 */     GIR_RootConstrainSelectedInstOperands,
     /*  955931 */     // GIR_Coverage, 63836,
     /*  955931 */     GIR_EraseRootFromParent_Done,
     /*  955932 */   // Label 14383: @955932
     /*  955932 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(956014), // Rule ID 63847 //
     /*  955937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  955945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  955948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  955951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  955954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955964 */     // MIs[0] op1
     /*  955964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  955984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  955991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  955994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955996 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955998 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956000 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956002 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956012 */     GIR_RootConstrainSelectedInstOperands,
     /*  956013 */     // GIR_Coverage, 63847,
     /*  956013 */     GIR_EraseRootFromParent_Done,
     /*  956014 */   // Label 14384: @956014
     /*  956014 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(956096), // Rule ID 63848 //
     /*  956019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  956030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  956033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  956036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956046 */     // MIs[0] op1
     /*  956046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956073 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  956076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956078 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956080 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956082 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956084 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956094 */     GIR_RootConstrainSelectedInstOperands,
     /*  956095 */     // GIR_Coverage, 63848,
     /*  956095 */     GIR_EraseRootFromParent_Done,
     /*  956096 */   // Label 14385: @956096
     /*  956096 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(956178), // Rule ID 63879 //
     /*  956101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956128 */     // MIs[0] op1
     /*  956128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956155 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  956158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956160 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956162 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956164 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956166 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956176 */     GIR_RootConstrainSelectedInstOperands,
     /*  956177 */     // GIR_Coverage, 63879,
     /*  956177 */     GIR_EraseRootFromParent_Done,
     /*  956178 */   // Label 14386: @956178
     /*  956178 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(956260), // Rule ID 63880 //
     /*  956183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956210 */     // MIs[0] op1
     /*  956210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  956240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956242 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956244 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956246 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956248 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956258 */     GIR_RootConstrainSelectedInstOperands,
     /*  956259 */     // GIR_Coverage, 63880,
     /*  956259 */     GIR_EraseRootFromParent_Done,
     /*  956260 */   // Label 14387: @956260
     /*  956260 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(956342), // Rule ID 63891 //
     /*  956265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  956285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956292 */     // MIs[0] op1
     /*  956292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  956322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956324 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956326 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956328 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956330 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956340 */     GIR_RootConstrainSelectedInstOperands,
     /*  956341 */     // GIR_Coverage, 63891,
     /*  956341 */     GIR_EraseRootFromParent_Done,
     /*  956342 */   // Label 14388: @956342
     /*  956342 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(956424), // Rule ID 63892 //
     /*  956347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  956367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956374 */     // MIs[0] op1
     /*  956374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  956404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956406 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956408 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956410 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956412 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956422 */     GIR_RootConstrainSelectedInstOperands,
     /*  956423 */     // GIR_Coverage, 63892,
     /*  956423 */     GIR_EraseRootFromParent_Done,
     /*  956424 */   // Label 14389: @956424
     /*  956424 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(956506), // Rule ID 63903 //
     /*  956429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956456 */     // MIs[0] op1
     /*  956456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  956486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956488 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956490 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956492 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956494 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956504 */     GIR_RootConstrainSelectedInstOperands,
     /*  956505 */     // GIR_Coverage, 63903,
     /*  956505 */     GIR_EraseRootFromParent_Done,
     /*  956506 */   // Label 14390: @956506
     /*  956506 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(956588), // Rule ID 63904 //
     /*  956511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  956522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  956525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  956528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956538 */     // MIs[0] op1
     /*  956538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956565 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  956568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956570 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956572 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956574 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956576 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956586 */     GIR_RootConstrainSelectedInstOperands,
     /*  956587 */     // GIR_Coverage, 63904,
     /*  956587 */     GIR_EraseRootFromParent_Done,
     /*  956588 */   // Label 14391: @956588
     /*  956588 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(956670), // Rule ID 63935 //
     /*  956593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956620 */     // MIs[0] op1
     /*  956620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956647 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  956650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956652 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956654 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956656 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956658 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956668 */     GIR_RootConstrainSelectedInstOperands,
     /*  956669 */     // GIR_Coverage, 63935,
     /*  956669 */     GIR_EraseRootFromParent_Done,
     /*  956670 */   // Label 14392: @956670
     /*  956670 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(956752), // Rule ID 63936 //
     /*  956675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  956683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956702 */     // MIs[0] op1
     /*  956702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956729 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  956732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956734 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956736 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956738 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956740 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956750 */     GIR_RootConstrainSelectedInstOperands,
     /*  956751 */     // GIR_Coverage, 63936,
     /*  956751 */     GIR_EraseRootFromParent_Done,
     /*  956752 */   // Label 14393: @956752
     /*  956752 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(956834), // Rule ID 63947 //
     /*  956757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  956777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956784 */     // MIs[0] op1
     /*  956784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956811 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  956814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956816 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956818 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956820 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956822 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956832 */     GIR_RootConstrainSelectedInstOperands,
     /*  956833 */     // GIR_Coverage, 63947,
     /*  956833 */     GIR_EraseRootFromParent_Done,
     /*  956834 */   // Label 14394: @956834
     /*  956834 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(956916), // Rule ID 63948 //
     /*  956839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  956847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  956859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956866 */     // MIs[0] op1
     /*  956866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956893 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  956893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  956896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956898 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956900 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956902 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956904 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956914 */     GIR_RootConstrainSelectedInstOperands,
     /*  956915 */     // GIR_Coverage, 63948,
     /*  956915 */     GIR_EraseRootFromParent_Done,
     /*  956916 */   // Label 14395: @956916
     /*  956916 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(956998), // Rule ID 63959 //
     /*  956921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  956929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  956932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  956935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  956938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956948 */     // MIs[0] op1
     /*  956948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  956968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956975 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  956975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  956978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956980 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956982 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956984 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956986 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  956996 */     GIR_RootConstrainSelectedInstOperands,
     /*  956997 */     // GIR_Coverage, 63959,
     /*  956997 */     GIR_EraseRootFromParent_Done,
     /*  956998 */   // Label 14396: @956998
     /*  956998 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(957080), // Rule ID 63960 //
     /*  957003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  957011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  957014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  957017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  957020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957030 */     // MIs[0] op1
     /*  957030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  957050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  957057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  957060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957062 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957064 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957066 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957068 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  957078 */     GIR_RootConstrainSelectedInstOperands,
     /*  957079 */     // GIR_Coverage, 63960,
     /*  957079 */     GIR_EraseRootFromParent_Done,
     /*  957080 */   // Label 14397: @957080
     /*  957080 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(957162), // Rule ID 63965 //
     /*  957085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957112 */     // MIs[0] op1
     /*  957112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957139 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  957142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957150 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957160 */     GIR_RootConstrainSelectedInstOperands,
     /*  957161 */     // GIR_Coverage, 63965,
     /*  957161 */     GIR_EraseRootFromParent_Done,
     /*  957162 */   // Label 14398: @957162
     /*  957162 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(957244), // Rule ID 63966 //
     /*  957167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957194 */     // MIs[0] op1
     /*  957194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957197 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  957224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957226 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957228 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957230 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957232 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957242 */     GIR_RootConstrainSelectedInstOperands,
     /*  957243 */     // GIR_Coverage, 63966,
     /*  957243 */     GIR_EraseRootFromParent_Done,
     /*  957244 */   // Label 14399: @957244
     /*  957244 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(957326), // Rule ID 63977 //
     /*  957249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  957269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957276 */     // MIs[0] op1
     /*  957276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  957306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957308 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957310 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957312 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957314 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957324 */     GIR_RootConstrainSelectedInstOperands,
     /*  957325 */     // GIR_Coverage, 63977,
     /*  957325 */     GIR_EraseRootFromParent_Done,
     /*  957326 */   // Label 14400: @957326
     /*  957326 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(957408), // Rule ID 63978 //
     /*  957331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  957342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  957345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  957348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  957351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957358 */     // MIs[0] op1
     /*  957358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957385 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  957388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957390 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957392 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957394 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957396 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957406 */     GIR_RootConstrainSelectedInstOperands,
     /*  957407 */     // GIR_Coverage, 63978,
     /*  957407 */     GIR_EraseRootFromParent_Done,
     /*  957408 */   // Label 14401: @957408
     /*  957408 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(957490), // Rule ID 63983 //
     /*  957413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957440 */     // MIs[0] op1
     /*  957440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  957470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957472 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957474 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957476 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957478 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957488 */     GIR_RootConstrainSelectedInstOperands,
     /*  957489 */     // GIR_Coverage, 63983,
     /*  957489 */     GIR_EraseRootFromParent_Done,
     /*  957490 */   // Label 14402: @957490
     /*  957490 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(957572), // Rule ID 63984 //
     /*  957495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957522 */     // MIs[0] op1
     /*  957522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  957552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957554 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957556 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957558 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957560 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957570 */     GIR_RootConstrainSelectedInstOperands,
     /*  957571 */     // GIR_Coverage, 63984,
     /*  957571 */     GIR_EraseRootFromParent_Done,
     /*  957572 */   // Label 14403: @957572
     /*  957572 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(957654), // Rule ID 63995 //
     /*  957577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  957597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957604 */     // MIs[0] op1
     /*  957604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957631 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  957634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957642 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957652 */     GIR_RootConstrainSelectedInstOperands,
     /*  957653 */     // GIR_Coverage, 63995,
     /*  957653 */     GIR_EraseRootFromParent_Done,
     /*  957654 */   // Label 14404: @957654
     /*  957654 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(957736), // Rule ID 63996 //
     /*  957659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  957670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  957673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  957676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  957679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957686 */     // MIs[0] op1
     /*  957686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957713 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  957716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957718 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957720 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957722 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957724 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957734 */     GIR_RootConstrainSelectedInstOperands,
     /*  957735 */     // GIR_Coverage, 63996,
     /*  957735 */     GIR_EraseRootFromParent_Done,
     /*  957736 */   // Label 14405: @957736
     /*  957736 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(957818), // Rule ID 64001 //
     /*  957741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957768 */     // MIs[0] op1
     /*  957768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957795 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957816 */     GIR_RootConstrainSelectedInstOperands,
     /*  957817 */     // GIR_Coverage, 64001,
     /*  957817 */     GIR_EraseRootFromParent_Done,
     /*  957818 */   // Label 14406: @957818
     /*  957818 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(957900), // Rule ID 64002 //
     /*  957823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957850 */     // MIs[0] op1
     /*  957850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  957877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957882 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957884 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957886 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957888 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957898 */     GIR_RootConstrainSelectedInstOperands,
     /*  957899 */     // GIR_Coverage, 64002,
     /*  957899 */     GIR_EraseRootFromParent_Done,
     /*  957900 */   // Label 14407: @957900
     /*  957900 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(957982), // Rule ID 64013 //
     /*  957905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  957919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  957922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  957925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957932 */     // MIs[0] op1
     /*  957932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957959 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  957959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  957980 */     GIR_RootConstrainSelectedInstOperands,
     /*  957981 */     // GIR_Coverage, 64013,
     /*  957981 */     GIR_EraseRootFromParent_Done,
     /*  957982 */   // Label 14408: @957982
     /*  957982 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(958064), // Rule ID 64014 //
     /*  957987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  957998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  958001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  958004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  958007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958014 */     // MIs[0] op1
     /*  958014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958041 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  958044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958046 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958048 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958050 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958052 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958062 */     GIR_RootConstrainSelectedInstOperands,
     /*  958063 */     // GIR_Coverage, 64014,
     /*  958063 */     GIR_EraseRootFromParent_Done,
     /*  958064 */   // Label 14409: @958064
     /*  958064 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(958146), // Rule ID 64019 //
     /*  958069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958096 */     // MIs[0] op1
     /*  958096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958134 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958144 */     GIR_RootConstrainSelectedInstOperands,
     /*  958145 */     // GIR_Coverage, 64019,
     /*  958145 */     GIR_EraseRootFromParent_Done,
     /*  958146 */   // Label 14410: @958146
     /*  958146 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(958228), // Rule ID 64020 //
     /*  958151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958178 */     // MIs[0] op1
     /*  958178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958210 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958212 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958214 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958216 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958226 */     GIR_RootConstrainSelectedInstOperands,
     /*  958227 */     // GIR_Coverage, 64020,
     /*  958227 */     GIR_EraseRootFromParent_Done,
     /*  958228 */   // Label 14411: @958228
     /*  958228 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(958310), // Rule ID 64031 //
     /*  958233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  958253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958260 */     // MIs[0] op1
     /*  958260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958298 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958308 */     GIR_RootConstrainSelectedInstOperands,
     /*  958309 */     // GIR_Coverage, 64031,
     /*  958309 */     GIR_EraseRootFromParent_Done,
     /*  958310 */   // Label 14412: @958310
     /*  958310 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(958392), // Rule ID 64032 //
     /*  958315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  958326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  958329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  958332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  958335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958342 */     // MIs[0] op1
     /*  958342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958374 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958376 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958378 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958380 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958390 */     GIR_RootConstrainSelectedInstOperands,
     /*  958391 */     // GIR_Coverage, 64032,
     /*  958391 */     GIR_EraseRootFromParent_Done,
     /*  958392 */   // Label 14413: @958392
     /*  958392 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(958474), // Rule ID 64037 //
     /*  958397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958424 */     // MIs[0] op1
     /*  958424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958451 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958462 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958472 */     GIR_RootConstrainSelectedInstOperands,
     /*  958473 */     // GIR_Coverage, 64037,
     /*  958473 */     GIR_EraseRootFromParent_Done,
     /*  958474 */   // Label 14414: @958474
     /*  958474 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(958556), // Rule ID 64038 //
     /*  958479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958506 */     // MIs[0] op1
     /*  958506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958509 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958533 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958538 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958540 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958542 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958544 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958554 */     GIR_RootConstrainSelectedInstOperands,
     /*  958555 */     // GIR_Coverage, 64038,
     /*  958555 */     GIR_EraseRootFromParent_Done,
     /*  958556 */   // Label 14415: @958556
     /*  958556 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(958638), // Rule ID 64049 //
     /*  958561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  958581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958588 */     // MIs[0] op1
     /*  958588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958615 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958620 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958622 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958624 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958626 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958636 */     GIR_RootConstrainSelectedInstOperands,
     /*  958637 */     // GIR_Coverage, 64049,
     /*  958637 */     GIR_EraseRootFromParent_Done,
     /*  958638 */   // Label 14416: @958638
     /*  958638 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(958720), // Rule ID 64050 //
     /*  958643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  958654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  958657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  958660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  958663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958670 */     // MIs[0] op1
     /*  958670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958697 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958702 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958704 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958706 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958708 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958718 */     GIR_RootConstrainSelectedInstOperands,
     /*  958719 */     // GIR_Coverage, 64050,
     /*  958719 */     GIR_EraseRootFromParent_Done,
     /*  958720 */   // Label 14417: @958720
     /*  958720 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(958802), // Rule ID 64055 //
     /*  958725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958752 */     // MIs[0] op1
     /*  958752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958779 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958784 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958786 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958788 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958790 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958800 */     GIR_RootConstrainSelectedInstOperands,
     /*  958801 */     // GIR_Coverage, 64055,
     /*  958801 */     GIR_EraseRootFromParent_Done,
     /*  958802 */   // Label 14418: @958802
     /*  958802 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(958884), // Rule ID 64056 //
     /*  958807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958834 */     // MIs[0] op1
     /*  958834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958837 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  958861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958872 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958882 */     GIR_RootConstrainSelectedInstOperands,
     /*  958883 */     // GIR_Coverage, 64056,
     /*  958883 */     GIR_EraseRootFromParent_Done,
     /*  958884 */   // Label 14419: @958884
     /*  958884 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(958966), // Rule ID 64067 //
     /*  958889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  958909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958916 */     // MIs[0] op1
     /*  958916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958943 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  958943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  958946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958948 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958950 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958952 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958954 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  958964 */     GIR_RootConstrainSelectedInstOperands,
     /*  958965 */     // GIR_Coverage, 64067,
     /*  958965 */     GIR_EraseRootFromParent_Done,
     /*  958966 */   // Label 14420: @958966
     /*  958966 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(959048), // Rule ID 64068 //
     /*  958971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  958982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  958985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  958988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  958991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958998 */     // MIs[0] op1
     /*  958998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959025 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  959028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959030 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959032 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959034 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959036 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959046 */     GIR_RootConstrainSelectedInstOperands,
     /*  959047 */     // GIR_Coverage, 64068,
     /*  959047 */     GIR_EraseRootFromParent_Done,
     /*  959048 */   // Label 14421: @959048
     /*  959048 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(959130), // Rule ID 64073 //
     /*  959053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959080 */     // MIs[0] op1
     /*  959080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959107 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  959110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959112 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959114 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959116 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959118 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959128 */     GIR_RootConstrainSelectedInstOperands,
     /*  959129 */     // GIR_Coverage, 64073,
     /*  959129 */     GIR_EraseRootFromParent_Done,
     /*  959130 */   // Label 14422: @959130
     /*  959130 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(959212), // Rule ID 64074 //
     /*  959135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959162 */     // MIs[0] op1
     /*  959162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  959192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959200 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959210 */     GIR_RootConstrainSelectedInstOperands,
     /*  959211 */     // GIR_Coverage, 64074,
     /*  959211 */     GIR_EraseRootFromParent_Done,
     /*  959212 */   // Label 14423: @959212
     /*  959212 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(959294), // Rule ID 64085 //
     /*  959217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  959237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959244 */     // MIs[0] op1
     /*  959244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  959274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959276 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959278 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959280 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959282 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959292 */     GIR_RootConstrainSelectedInstOperands,
     /*  959293 */     // GIR_Coverage, 64085,
     /*  959293 */     GIR_EraseRootFromParent_Done,
     /*  959294 */   // Label 14424: @959294
     /*  959294 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(959376), // Rule ID 64086 //
     /*  959299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  959319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959326 */     // MIs[0] op1
     /*  959326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959353 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  959356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959358 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959360 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959362 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959364 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959374 */     GIR_RootConstrainSelectedInstOperands,
     /*  959375 */     // GIR_Coverage, 64086,
     /*  959375 */     GIR_EraseRootFromParent_Done,
     /*  959376 */   // Label 14425: @959376
     /*  959376 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(959458), // Rule ID 64091 //
     /*  959381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959408 */     // MIs[0] op1
     /*  959408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959435 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  959438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959440 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959442 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959444 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959446 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959456 */     GIR_RootConstrainSelectedInstOperands,
     /*  959457 */     // GIR_Coverage, 64091,
     /*  959457 */     GIR_EraseRootFromParent_Done,
     /*  959458 */   // Label 14426: @959458
     /*  959458 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(959540), // Rule ID 64092 //
     /*  959463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  959474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  959477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  959480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959490 */     // MIs[0] op1
     /*  959490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959517 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  959520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959522 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959524 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959526 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959528 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959538 */     GIR_RootConstrainSelectedInstOperands,
     /*  959539 */     // GIR_Coverage, 64092,
     /*  959539 */     GIR_EraseRootFromParent_Done,
     /*  959540 */   // Label 14427: @959540
     /*  959540 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(959622), // Rule ID 64097 //
     /*  959545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959572 */     // MIs[0] op1
     /*  959572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  959602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959604 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959606 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959608 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959610 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959620 */     GIR_RootConstrainSelectedInstOperands,
     /*  959621 */     // GIR_Coverage, 64097,
     /*  959621 */     GIR_EraseRootFromParent_Done,
     /*  959622 */   // Label 14428: @959622
     /*  959622 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(959704), // Rule ID 64098 //
     /*  959627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959654 */     // MIs[0] op1
     /*  959654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  959684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959692 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959702 */     GIR_RootConstrainSelectedInstOperands,
     /*  959703 */     // GIR_Coverage, 64098,
     /*  959703 */     GIR_EraseRootFromParent_Done,
     /*  959704 */   // Label 14429: @959704
     /*  959704 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(959786), // Rule ID 64109 //
     /*  959709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  959729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959736 */     // MIs[0] op1
     /*  959736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959763 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  959766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959768 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959770 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959772 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959774 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959784 */     GIR_RootConstrainSelectedInstOperands,
     /*  959785 */     // GIR_Coverage, 64109,
     /*  959785 */     GIR_EraseRootFromParent_Done,
     /*  959786 */   // Label 14430: @959786
     /*  959786 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(959868), // Rule ID 64110 //
     /*  959791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  959811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959818 */     // MIs[0] op1
     /*  959818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959845 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  959848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959850 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959852 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959854 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959856 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959866 */     GIR_RootConstrainSelectedInstOperands,
     /*  959867 */     // GIR_Coverage, 64110,
     /*  959867 */     GIR_EraseRootFromParent_Done,
     /*  959868 */   // Label 14431: @959868
     /*  959868 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(959950), // Rule ID 64115 //
     /*  959873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959900 */     // MIs[0] op1
     /*  959900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  959920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  959930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959932 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959934 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959936 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959938 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959948 */     GIR_RootConstrainSelectedInstOperands,
     /*  959949 */     // GIR_Coverage, 64115,
     /*  959949 */     GIR_EraseRootFromParent_Done,
     /*  959950 */   // Label 14432: @959950
     /*  959950 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(960032), // Rule ID 64116 //
     /*  959955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  959966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  959969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  959972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  959975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959982 */     // MIs[0] op1
     /*  959982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  960012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960014 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960016 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960018 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960020 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960030 */     GIR_RootConstrainSelectedInstOperands,
     /*  960031 */     // GIR_Coverage, 64116,
     /*  960031 */     GIR_EraseRootFromParent_Done,
     /*  960032 */   // Label 14433: @960032
     /*  960032 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(960114), // Rule ID 64121 //
     /*  960037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960064 */     // MIs[0] op1
     /*  960064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  960094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960096 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960098 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960100 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960102 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960112 */     GIR_RootConstrainSelectedInstOperands,
     /*  960113 */     // GIR_Coverage, 64121,
     /*  960113 */     GIR_EraseRootFromParent_Done,
     /*  960114 */   // Label 14434: @960114
     /*  960114 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(960196), // Rule ID 64122 //
     /*  960119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960146 */     // MIs[0] op1
     /*  960146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  960176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960178 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960180 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960182 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960184 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960194 */     GIR_RootConstrainSelectedInstOperands,
     /*  960195 */     // GIR_Coverage, 64122,
     /*  960195 */     GIR_EraseRootFromParent_Done,
     /*  960196 */   // Label 14435: @960196
     /*  960196 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(960278), // Rule ID 64133 //
     /*  960201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  960221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960228 */     // MIs[0] op1
     /*  960228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  960258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960266 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960276 */     GIR_RootConstrainSelectedInstOperands,
     /*  960277 */     // GIR_Coverage, 64133,
     /*  960277 */     GIR_EraseRootFromParent_Done,
     /*  960278 */   // Label 14436: @960278
     /*  960278 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(960360), // Rule ID 64134 //
     /*  960283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  960303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960310 */     // MIs[0] op1
     /*  960310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  960340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960342 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960344 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960346 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960348 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960358 */     GIR_RootConstrainSelectedInstOperands,
     /*  960359 */     // GIR_Coverage, 64134,
     /*  960359 */     GIR_EraseRootFromParent_Done,
     /*  960360 */   // Label 14437: @960360
     /*  960360 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(960442), // Rule ID 64139 //
     /*  960365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960392 */     // MIs[0] op1
     /*  960392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  960422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960424 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960426 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960428 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960430 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960440 */     GIR_RootConstrainSelectedInstOperands,
     /*  960441 */     // GIR_Coverage, 64139,
     /*  960441 */     GIR_EraseRootFromParent_Done,
     /*  960442 */   // Label 14438: @960442
     /*  960442 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(960524), // Rule ID 64140 //
     /*  960447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  960458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  960461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  960464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960474 */     // MIs[0] op1
     /*  960474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  960504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960506 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960508 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960510 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960512 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960522 */     GIR_RootConstrainSelectedInstOperands,
     /*  960523 */     // GIR_Coverage, 64140,
     /*  960523 */     GIR_EraseRootFromParent_Done,
     /*  960524 */   // Label 14439: @960524
     /*  960524 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(960606), // Rule ID 64145 //
     /*  960529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  960549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960556 */     // MIs[0] op1
     /*  960556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  960586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960594 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960604 */     GIR_RootConstrainSelectedInstOperands,
     /*  960605 */     // GIR_Coverage, 64145,
     /*  960605 */     GIR_EraseRootFromParent_Done,
     /*  960606 */   // Label 14440: @960606
     /*  960606 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(960688), // Rule ID 64146 //
     /*  960611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  960619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  960631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960638 */     // MIs[0] op1
     /*  960638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  960658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  960668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960670 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960672 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960674 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960676 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960686 */     GIR_RootConstrainSelectedInstOperands,
     /*  960687 */     // GIR_Coverage, 64146,
     /*  960687 */     GIR_EraseRootFromParent_Done,
     /*  960688 */   // Label 14441: @960688
     /*  960688 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(960770), // Rule ID 64157 //
     /*  960693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  960713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960720 */     // MIs[0] op1
     /*  960720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960747 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  960750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960758 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960768 */     GIR_RootConstrainSelectedInstOperands,
     /*  960769 */     // GIR_Coverage, 64157,
     /*  960769 */     GIR_EraseRootFromParent_Done,
     /*  960770 */   // Label 14442: @960770
     /*  960770 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(960852), // Rule ID 64158 //
     /*  960775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  960783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  960795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960802 */     // MIs[0] op1
     /*  960802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  960810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960829 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  960832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960834 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960836 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960838 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960840 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960850 */     GIR_RootConstrainSelectedInstOperands,
     /*  960851 */     // GIR_Coverage, 64158,
     /*  960851 */     GIR_EraseRootFromParent_Done,
     /*  960852 */   // Label 14443: @960852
     /*  960852 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(960934), // Rule ID 64163 //
     /*  960857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  960860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960884 */     // MIs[0] op1
     /*  960884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960911 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  960914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960916 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  960918 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  960920 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  960922 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  960924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960932 */     GIR_RootConstrainSelectedInstOperands,
     /*  960933 */     // GIR_Coverage, 64163,
     /*  960933 */     GIR_EraseRootFromParent_Done,
     /*  960934 */   // Label 14444: @960934
     /*  960934 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(961016), // Rule ID 64164 //
     /*  960939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  960942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  960947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  960950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  960953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  960956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  960959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960966 */     // MIs[0] op1
     /*  960966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  960969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  960974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  960978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  960982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  960986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960993 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  960996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960998 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961000 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961002 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961004 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961014 */     GIR_RootConstrainSelectedInstOperands,
     /*  961015 */     // GIR_Coverage, 64164,
     /*  961015 */     GIR_EraseRootFromParent_Done,
     /*  961016 */   // Label 14445: @961016
     /*  961016 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(961098), // Rule ID 64169 //
     /*  961021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961048 */     // MIs[0] op1
     /*  961048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  961078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961080 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961082 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961084 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961086 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961096 */     GIR_RootConstrainSelectedInstOperands,
     /*  961097 */     // GIR_Coverage, 64169,
     /*  961097 */     GIR_EraseRootFromParent_Done,
     /*  961098 */   // Label 14446: @961098
     /*  961098 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(961180), // Rule ID 64170 //
     /*  961103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961130 */     // MIs[0] op1
     /*  961130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961157 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  961160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961162 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961164 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961166 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961168 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961178 */     GIR_RootConstrainSelectedInstOperands,
     /*  961179 */     // GIR_Coverage, 64170,
     /*  961179 */     GIR_EraseRootFromParent_Done,
     /*  961180 */   // Label 14447: @961180
     /*  961180 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(961262), // Rule ID 64181 //
     /*  961185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  961205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961212 */     // MIs[0] op1
     /*  961212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961239 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  961242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961244 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961246 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961248 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961250 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961260 */     GIR_RootConstrainSelectedInstOperands,
     /*  961261 */     // GIR_Coverage, 64181,
     /*  961261 */     GIR_EraseRootFromParent_Done,
     /*  961262 */   // Label 14448: @961262
     /*  961262 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(961344), // Rule ID 64182 //
     /*  961267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  961287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961294 */     // MIs[0] op1
     /*  961294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961321 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  961324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961326 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961328 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961330 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961332 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961342 */     GIR_RootConstrainSelectedInstOperands,
     /*  961343 */     // GIR_Coverage, 64182,
     /*  961343 */     GIR_EraseRootFromParent_Done,
     /*  961344 */   // Label 14449: @961344
     /*  961344 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(961426), // Rule ID 64187 //
     /*  961349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  961369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961376 */     // MIs[0] op1
     /*  961376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  961396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  961406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961408 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961410 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961412 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961414 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961424 */     GIR_RootConstrainSelectedInstOperands,
     /*  961425 */     // GIR_Coverage, 64187,
     /*  961425 */     GIR_EraseRootFromParent_Done,
     /*  961426 */   // Label 14450: @961426
     /*  961426 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(961508), // Rule ID 64188 //
     /*  961431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  961442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  961445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  961448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  961451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961458 */     // MIs[0] op1
     /*  961458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  961478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961485 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  961488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961490 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961492 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961494 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961496 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961506 */     GIR_RootConstrainSelectedInstOperands,
     /*  961507 */     // GIR_Coverage, 64188,
     /*  961507 */     GIR_EraseRootFromParent_Done,
     /*  961508 */   // Label 14451: @961508
     /*  961508 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(961590), // Rule ID 64193 //
     /*  961513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  961533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961540 */     // MIs[0] op1
     /*  961540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961567 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  961570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961572 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961574 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961576 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961578 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961588 */     GIR_RootConstrainSelectedInstOperands,
     /*  961589 */     // GIR_Coverage, 64193,
     /*  961589 */     GIR_EraseRootFromParent_Done,
     /*  961590 */   // Label 14452: @961590
     /*  961590 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(961672), // Rule ID 64194 //
     /*  961595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  961603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961622 */     // MIs[0] op1
     /*  961622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  961642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  961652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961654 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961656 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961658 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961660 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961670 */     GIR_RootConstrainSelectedInstOperands,
     /*  961671 */     // GIR_Coverage, 64194,
     /*  961671 */     GIR_EraseRootFromParent_Done,
     /*  961672 */   // Label 14453: @961672
     /*  961672 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(961754), // Rule ID 64205 //
     /*  961677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  961697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961704 */     // MIs[0] op1
     /*  961704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  961734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961736 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961738 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961740 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961742 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961752 */     GIR_RootConstrainSelectedInstOperands,
     /*  961753 */     // GIR_Coverage, 64205,
     /*  961753 */     GIR_EraseRootFromParent_Done,
     /*  961754 */   // Label 14454: @961754
     /*  961754 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(961836), // Rule ID 64206 //
     /*  961759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  961767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  961779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961786 */     // MIs[0] op1
     /*  961786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  961794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961813 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  961816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961818 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961820 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961822 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961824 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961834 */     GIR_RootConstrainSelectedInstOperands,
     /*  961835 */     // GIR_Coverage, 64206,
     /*  961835 */     GIR_EraseRootFromParent_Done,
     /*  961836 */   // Label 14455: @961836
     /*  961836 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(961918), // Rule ID 64211 //
     /*  961841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  961844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961868 */     // MIs[0] op1
     /*  961868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  961888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  961898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961900 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961902 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961904 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961906 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961916 */     GIR_RootConstrainSelectedInstOperands,
     /*  961917 */     // GIR_Coverage, 64211,
     /*  961917 */     GIR_EraseRootFromParent_Done,
     /*  961918 */   // Label 14456: @961918
     /*  961918 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(962000), // Rule ID 64212 //
     /*  961923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  961926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  961931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  961940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  961943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961950 */     // MIs[0] op1
     /*  961950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  961953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  961958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  961970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  961980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961982 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  961984 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  961986 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  961988 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  961990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961998 */     GIR_RootConstrainSelectedInstOperands,
     /*  961999 */     // GIR_Coverage, 64212,
     /*  961999 */     GIR_EraseRootFromParent_Done,
     /*  962000 */   // Label 14457: @962000
     /*  962000 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(962082), // Rule ID 64217 //
     /*  962005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962032 */     // MIs[0] op1
     /*  962032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  962062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962064 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962066 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962068 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962070 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962080 */     GIR_RootConstrainSelectedInstOperands,
     /*  962081 */     // GIR_Coverage, 64217,
     /*  962081 */     GIR_EraseRootFromParent_Done,
     /*  962082 */   // Label 14458: @962082
     /*  962082 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(962164), // Rule ID 64218 //
     /*  962087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962114 */     // MIs[0] op1
     /*  962114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  962144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962152 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962162 */     GIR_RootConstrainSelectedInstOperands,
     /*  962163 */     // GIR_Coverage, 64218,
     /*  962163 */     GIR_EraseRootFromParent_Done,
     /*  962164 */   // Label 14459: @962164
     /*  962164 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(962246), // Rule ID 64229 //
     /*  962169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  962189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962196 */     // MIs[0] op1
     /*  962196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  962226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962228 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962230 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962232 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962234 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962244 */     GIR_RootConstrainSelectedInstOperands,
     /*  962245 */     // GIR_Coverage, 64229,
     /*  962245 */     GIR_EraseRootFromParent_Done,
     /*  962246 */   // Label 14460: @962246
     /*  962246 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(962328), // Rule ID 64230 //
     /*  962251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  962271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962278 */     // MIs[0] op1
     /*  962278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  962308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962316 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962326 */     GIR_RootConstrainSelectedInstOperands,
     /*  962327 */     // GIR_Coverage, 64230,
     /*  962327 */     GIR_EraseRootFromParent_Done,
     /*  962328 */   // Label 14461: @962328
     /*  962328 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(962410), // Rule ID 64235 //
     /*  962333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962360 */     // MIs[0] op1
     /*  962360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  962390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962392 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962394 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962396 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962398 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962408 */     GIR_RootConstrainSelectedInstOperands,
     /*  962409 */     // GIR_Coverage, 64235,
     /*  962409 */     GIR_EraseRootFromParent_Done,
     /*  962410 */   // Label 14462: @962410
     /*  962410 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(962492), // Rule ID 64236 //
     /*  962415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  962432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962442 */     // MIs[0] op1
     /*  962442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  962458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  962472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962474 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962476 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962478 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962480 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962490 */     GIR_RootConstrainSelectedInstOperands,
     /*  962491 */     // GIR_Coverage, 64236,
     /*  962491 */     GIR_EraseRootFromParent_Done,
     /*  962492 */   // Label 14463: @962492
     /*  962492 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(962574), // Rule ID 64241 //
     /*  962497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  962517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962524 */     // MIs[0] op1
     /*  962524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  962554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962556 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962558 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962560 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962562 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962572 */     GIR_RootConstrainSelectedInstOperands,
     /*  962573 */     // GIR_Coverage, 64241,
     /*  962573 */     GIR_EraseRootFromParent_Done,
     /*  962574 */   // Label 14464: @962574
     /*  962574 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(962656), // Rule ID 64242 //
     /*  962579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962606 */     // MIs[0] op1
     /*  962606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  962626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962633 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  962636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962644 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962654 */     GIR_RootConstrainSelectedInstOperands,
     /*  962655 */     // GIR_Coverage, 64242,
     /*  962655 */     GIR_EraseRootFromParent_Done,
     /*  962656 */   // Label 14465: @962656
     /*  962656 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(962738), // Rule ID 64253 //
     /*  962661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  962681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962688 */     // MIs[0] op1
     /*  962688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962715 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  962718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962720 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962722 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962724 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962726 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962736 */     GIR_RootConstrainSelectedInstOperands,
     /*  962737 */     // GIR_Coverage, 64253,
     /*  962737 */     GIR_EraseRootFromParent_Done,
     /*  962738 */   // Label 14466: @962738
     /*  962738 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(962820), // Rule ID 64254 //
     /*  962743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  962751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  962763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962770 */     // MIs[0] op1
     /*  962770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  962778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  962800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962818 */     GIR_RootConstrainSelectedInstOperands,
     /*  962819 */     // GIR_Coverage, 64254,
     /*  962819 */     GIR_EraseRootFromParent_Done,
     /*  962820 */   // Label 14467: @962820
     /*  962820 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(962902), // Rule ID 64259 //
     /*  962825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962852 */     // MIs[0] op1
     /*  962852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  962882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962884 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962886 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962888 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962890 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962900 */     GIR_RootConstrainSelectedInstOperands,
     /*  962901 */     // GIR_Coverage, 64259,
     /*  962901 */     GIR_EraseRootFromParent_Done,
     /*  962902 */   // Label 14468: @962902
     /*  962902 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(962984), // Rule ID 64260 //
     /*  962907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  962910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  962915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  962924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  962927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962934 */     // MIs[0] op1
     /*  962934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  962937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  962942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  962954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962961 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  962964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962966 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  962968 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  962970 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  962972 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  962974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962982 */     GIR_RootConstrainSelectedInstOperands,
     /*  962983 */     // GIR_Coverage, 64260,
     /*  962983 */     GIR_EraseRootFromParent_Done,
     /*  962984 */   // Label 14469: @962984
     /*  962984 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(963066), // Rule ID 64265 //
     /*  962989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  962992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  962997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  963009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963016 */     // MIs[0] op1
     /*  963016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  963036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  963046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963054 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963064 */     GIR_RootConstrainSelectedInstOperands,
     /*  963065 */     // GIR_Coverage, 64265,
     /*  963065 */     GIR_EraseRootFromParent_Done,
     /*  963066 */   // Label 14470: @963066
     /*  963066 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(963148), // Rule ID 64266 //
     /*  963071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  963079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963098 */     // MIs[0] op1
     /*  963098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  963118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  963128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963146 */     GIR_RootConstrainSelectedInstOperands,
     /*  963147 */     // GIR_Coverage, 64266,
     /*  963147 */     GIR_EraseRootFromParent_Done,
     /*  963148 */   // Label 14471: @963148
     /*  963148 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(963230), // Rule ID 64277 //
     /*  963153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  963156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  963161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  963173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963180 */     // MIs[0] op1
     /*  963180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963207 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  963210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963212 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963214 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963216 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963218 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963228 */     GIR_RootConstrainSelectedInstOperands,
     /*  963229 */     // GIR_Coverage, 64277,
     /*  963229 */     GIR_EraseRootFromParent_Done,
     /*  963230 */   // Label 14472: @963230
     /*  963230 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(963312), // Rule ID 64278 //
     /*  963235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  963243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  963255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963262 */     // MIs[0] op1
     /*  963262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  963270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963289 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  963292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963300 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963310 */     GIR_RootConstrainSelectedInstOperands,
     /*  963311 */     // GIR_Coverage, 64278,
     /*  963311 */     GIR_EraseRootFromParent_Done,
     /*  963312 */   // Label 14473: @963312
     /*  963312 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(963394), // Rule ID 64283 //
     /*  963317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  963320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  963325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963344 */     // MIs[0] op1
     /*  963344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  963352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  963364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963371 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  963374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963376 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963378 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963380 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963382 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963392 */     GIR_RootConstrainSelectedInstOperands,
     /*  963393 */     // GIR_Coverage, 64283,
     /*  963393 */     GIR_EraseRootFromParent_Done,
     /*  963394 */   // Label 14474: @963394
     /*  963394 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(963476), // Rule ID 64284 //
     /*  963399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  963402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  963407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  963416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  963419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963426 */     // MIs[0] op1
     /*  963426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  963429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  963434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  963446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963453 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  963456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  963460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  963462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  963464 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  963466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963474 */     GIR_RootConstrainSelectedInstOperands,
     /*  963475 */     // GIR_Coverage, 64284,
     /*  963475 */     GIR_EraseRootFromParent_Done,
     /*  963476 */   // Label 14475: @963476
     /*  963476 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(963568), // Rule ID 5196 //
     /*  963481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  963492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  963495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963531 */     // MIs[1] Operand 1
     /*  963531 */     // No operand predicates
     /*  963531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  963547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963566 */     GIR_RootConstrainSelectedInstOperands,
     /*  963567 */     // GIR_Coverage, 5196,
     /*  963567 */     GIR_EraseRootFromParent_Done,
     /*  963568 */   // Label 14476: @963568
     /*  963568 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(963660), // Rule ID 5197 //
     /*  963573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  963584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  963587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963623 */     // MIs[1] Operand 1
     /*  963623 */     // No operand predicates
     /*  963623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  963636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  963639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963658 */     GIR_RootConstrainSelectedInstOperands,
     /*  963659 */     // GIR_Coverage, 5197,
     /*  963659 */     GIR_EraseRootFromParent_Done,
     /*  963660 */   // Label 14477: @963660
     /*  963660 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(963752), // Rule ID 5198 //
     /*  963665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  963676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  963679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963715 */     // MIs[1] Operand 1
     /*  963715 */     // No operand predicates
     /*  963715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963728 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  963731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963750 */     GIR_RootConstrainSelectedInstOperands,
     /*  963751 */     // GIR_Coverage, 5198,
     /*  963751 */     GIR_EraseRootFromParent_Done,
     /*  963752 */   // Label 14478: @963752
     /*  963752 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(963844), // Rule ID 5199 //
     /*  963757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  963768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  963771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963807 */     // MIs[1] Operand 1
     /*  963807 */     // No operand predicates
     /*  963807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  963820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  963823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963842 */     GIR_RootConstrainSelectedInstOperands,
     /*  963843 */     // GIR_Coverage, 5199,
     /*  963843 */     GIR_EraseRootFromParent_Done,
     /*  963844 */   // Label 14479: @963844
     /*  963844 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(963936), // Rule ID 5200 //
     /*  963849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  963860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  963863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963899 */     // MIs[1] Operand 1
     /*  963899 */     // No operand predicates
     /*  963899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  963912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  963915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963934 */     GIR_RootConstrainSelectedInstOperands,
     /*  963935 */     // GIR_Coverage, 5200,
     /*  963935 */     GIR_EraseRootFromParent_Done,
     /*  963936 */   // Label 14480: @963936
     /*  963936 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(964028), // Rule ID 5201 //
     /*  963941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  963952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  963955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  963971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963991 */     // MIs[1] Operand 1
     /*  963991 */     // No operand predicates
     /*  963991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  964004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964026 */     GIR_RootConstrainSelectedInstOperands,
     /*  964027 */     // GIR_Coverage, 5201,
     /*  964027 */     GIR_EraseRootFromParent_Done,
     /*  964028 */   // Label 14481: @964028
     /*  964028 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(964120), // Rule ID 5202 //
     /*  964033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  964044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  964047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964083 */     // MIs[1] Operand 1
     /*  964083 */     // No operand predicates
     /*  964083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  964099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964118 */     GIR_RootConstrainSelectedInstOperands,
     /*  964119 */     // GIR_Coverage, 5202,
     /*  964119 */     GIR_EraseRootFromParent_Done,
     /*  964120 */   // Label 14482: @964120
     /*  964120 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(964212), // Rule ID 5203 //
     /*  964125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  964136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  964139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964175 */     // MIs[1] Operand 1
     /*  964175 */     // No operand predicates
     /*  964175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  964191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964210 */     GIR_RootConstrainSelectedInstOperands,
     /*  964211 */     // GIR_Coverage, 5203,
     /*  964211 */     GIR_EraseRootFromParent_Done,
     /*  964212 */   // Label 14483: @964212
     /*  964212 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(964304), // Rule ID 5204 //
     /*  964217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  964228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  964231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964267 */     // MIs[1] Operand 1
     /*  964267 */     // No operand predicates
     /*  964267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964302 */     GIR_RootConstrainSelectedInstOperands,
     /*  964303 */     // GIR_Coverage, 5204,
     /*  964303 */     GIR_EraseRootFromParent_Done,
     /*  964304 */   // Label 14484: @964304
     /*  964304 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(964396), // Rule ID 5205 //
     /*  964309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  964320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  964323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964359 */     // MIs[1] Operand 1
     /*  964359 */     // No operand predicates
     /*  964359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964394 */     GIR_RootConstrainSelectedInstOperands,
     /*  964395 */     // GIR_Coverage, 5205,
     /*  964395 */     GIR_EraseRootFromParent_Done,
     /*  964396 */   // Label 14485: @964396
     /*  964396 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(964488), // Rule ID 5206 //
     /*  964401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  964412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  964415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964451 */     // MIs[1] Operand 1
     /*  964451 */     // No operand predicates
     /*  964451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  964464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964486 */     GIR_RootConstrainSelectedInstOperands,
     /*  964487 */     // GIR_Coverage, 5206,
     /*  964487 */     GIR_EraseRootFromParent_Done,
     /*  964488 */   // Label 14486: @964488
     /*  964488 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(964580), // Rule ID 5207 //
     /*  964493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  964504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  964507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964543 */     // MIs[1] Operand 1
     /*  964543 */     // No operand predicates
     /*  964543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  964556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  964559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964578 */     GIR_RootConstrainSelectedInstOperands,
     /*  964579 */     // GIR_Coverage, 5207,
     /*  964579 */     GIR_EraseRootFromParent_Done,
     /*  964580 */   // Label 14487: @964580
     /*  964580 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(964672), // Rule ID 5208 //
     /*  964585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  964596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  964599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964635 */     // MIs[1] Operand 1
     /*  964635 */     // No operand predicates
     /*  964635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964648 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  964648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964670 */     GIR_RootConstrainSelectedInstOperands,
     /*  964671 */     // GIR_Coverage, 5208,
     /*  964671 */     GIR_EraseRootFromParent_Done,
     /*  964672 */   // Label 14488: @964672
     /*  964672 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(964764), // Rule ID 5209 //
     /*  964677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  964688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  964691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964727 */     // MIs[1] Operand 1
     /*  964727 */     // No operand predicates
     /*  964727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  964740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964762 */     GIR_RootConstrainSelectedInstOperands,
     /*  964763 */     // GIR_Coverage, 5209,
     /*  964763 */     GIR_EraseRootFromParent_Done,
     /*  964764 */   // Label 14489: @964764
     /*  964764 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(964856), // Rule ID 5210 //
     /*  964769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  964780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  964783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964819 */     // MIs[1] Operand 1
     /*  964819 */     // No operand predicates
     /*  964819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  964832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964854 */     GIR_RootConstrainSelectedInstOperands,
     /*  964855 */     // GIR_Coverage, 5210,
     /*  964855 */     GIR_EraseRootFromParent_Done,
     /*  964856 */   // Label 14490: @964856
     /*  964856 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(964948), // Rule ID 5211 //
     /*  964861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  964872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  964875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964911 */     // MIs[1] Operand 1
     /*  964911 */     // No operand predicates
     /*  964911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  964924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  964927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964946 */     GIR_RootConstrainSelectedInstOperands,
     /*  964947 */     // GIR_Coverage, 5211,
     /*  964947 */     GIR_EraseRootFromParent_Done,
     /*  964948 */   // Label 14491: @964948
     /*  964948 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(965040), // Rule ID 5212 //
     /*  964953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  964961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  964964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  964967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  964983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965003 */     // MIs[1] Operand 1
     /*  965003 */     // No operand predicates
     /*  965003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  965016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965038 */     GIR_RootConstrainSelectedInstOperands,
     /*  965039 */     // GIR_Coverage, 5212,
     /*  965039 */     GIR_EraseRootFromParent_Done,
     /*  965040 */   // Label 14492: @965040
     /*  965040 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(965132), // Rule ID 5213 //
     /*  965045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  965056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  965059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965095 */     // MIs[1] Operand 1
     /*  965095 */     // No operand predicates
     /*  965095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  965108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965130 */     GIR_RootConstrainSelectedInstOperands,
     /*  965131 */     // GIR_Coverage, 5213,
     /*  965131 */     GIR_EraseRootFromParent_Done,
     /*  965132 */   // Label 14493: @965132
     /*  965132 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(965224), // Rule ID 5214 //
     /*  965137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  965148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  965151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965187 */     // MIs[1] Operand 1
     /*  965187 */     // No operand predicates
     /*  965187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  965200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965222 */     GIR_RootConstrainSelectedInstOperands,
     /*  965223 */     // GIR_Coverage, 5214,
     /*  965223 */     GIR_EraseRootFromParent_Done,
     /*  965224 */   // Label 14494: @965224
     /*  965224 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(965316), // Rule ID 5215 //
     /*  965229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  965240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  965243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  965259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965279 */     // MIs[1] Operand 1
     /*  965279 */     // No operand predicates
     /*  965279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  965292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  965295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965314 */     GIR_RootConstrainSelectedInstOperands,
     /*  965315 */     // GIR_Coverage, 5215,
     /*  965315 */     GIR_EraseRootFromParent_Done,
     /*  965316 */   // Label 14495: @965316
     /*  965316 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(965408), // Rule ID 5216 //
     /*  965321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  965332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  965335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965371 */     // MIs[1] Operand 1
     /*  965371 */     // No operand predicates
     /*  965371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965406 */     GIR_RootConstrainSelectedInstOperands,
     /*  965407 */     // GIR_Coverage, 5216,
     /*  965407 */     GIR_EraseRootFromParent_Done,
     /*  965408 */   // Label 14496: @965408
     /*  965408 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(965500), // Rule ID 5217 //
     /*  965413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  965424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  965427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965463 */     // MIs[1] Operand 1
     /*  965463 */     // No operand predicates
     /*  965463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965498 */     GIR_RootConstrainSelectedInstOperands,
     /*  965499 */     // GIR_Coverage, 5217,
     /*  965499 */     GIR_EraseRootFromParent_Done,
     /*  965500 */   // Label 14497: @965500
     /*  965500 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(965592), // Rule ID 5218 //
     /*  965505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  965516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  965519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965555 */     // MIs[1] Operand 1
     /*  965555 */     // No operand predicates
     /*  965555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  965571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965590 */     GIR_RootConstrainSelectedInstOperands,
     /*  965591 */     // GIR_Coverage, 5218,
     /*  965591 */     GIR_EraseRootFromParent_Done,
     /*  965592 */   // Label 14498: @965592
     /*  965592 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(965684), // Rule ID 5219 //
     /*  965597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  965608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  965611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  965627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965647 */     // MIs[1] Operand 1
     /*  965647 */     // No operand predicates
     /*  965647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  965663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965682 */     GIR_RootConstrainSelectedInstOperands,
     /*  965683 */     // GIR_Coverage, 5219,
     /*  965683 */     GIR_EraseRootFromParent_Done,
     /*  965684 */   // Label 14499: @965684
     /*  965684 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(965776), // Rule ID 5220 //
     /*  965689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  965700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  965703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965739 */     // MIs[1] Operand 1
     /*  965739 */     // No operand predicates
     /*  965739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  965752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  965755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965774 */     GIR_RootConstrainSelectedInstOperands,
     /*  965775 */     // GIR_Coverage, 5220,
     /*  965775 */     GIR_EraseRootFromParent_Done,
     /*  965776 */   // Label 14500: @965776
     /*  965776 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(965868), // Rule ID 5221 //
     /*  965781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  965792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  965795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  965811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965831 */     // MIs[1] Operand 1
     /*  965831 */     // No operand predicates
     /*  965831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  965844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  965847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965866 */     GIR_RootConstrainSelectedInstOperands,
     /*  965867 */     // GIR_Coverage, 5221,
     /*  965867 */     GIR_EraseRootFromParent_Done,
     /*  965868 */   // Label 14501: @965868
     /*  965868 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(965960), // Rule ID 5222 //
     /*  965873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965923 */     // MIs[1] Operand 1
     /*  965923 */     // No operand predicates
     /*  965923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  965936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  965939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965958 */     GIR_RootConstrainSelectedInstOperands,
     /*  965959 */     // GIR_Coverage, 5222,
     /*  965959 */     GIR_EraseRootFromParent_Done,
     /*  965960 */   // Label 14502: @965960
     /*  965960 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(966052), // Rule ID 5223 //
     /*  965965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  965973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  965976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  965979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  965995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966015 */     // MIs[1] Operand 1
     /*  966015 */     // No operand predicates
     /*  966015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966050 */     GIR_RootConstrainSelectedInstOperands,
     /*  966051 */     // GIR_Coverage, 5223,
     /*  966051 */     GIR_EraseRootFromParent_Done,
     /*  966052 */   // Label 14503: @966052
     /*  966052 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(966144), // Rule ID 5224 //
     /*  966057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  966068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  966071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966107 */     // MIs[1] Operand 1
     /*  966107 */     // No operand predicates
     /*  966107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966120 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  966120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966142 */     GIR_RootConstrainSelectedInstOperands,
     /*  966143 */     // GIR_Coverage, 5224,
     /*  966143 */     GIR_EraseRootFromParent_Done,
     /*  966144 */   // Label 14504: @966144
     /*  966144 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(966236), // Rule ID 5225 //
     /*  966149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  966160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  966163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966199 */     // MIs[1] Operand 1
     /*  966199 */     // No operand predicates
     /*  966199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966212 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966234 */     GIR_RootConstrainSelectedInstOperands,
     /*  966235 */     // GIR_Coverage, 5225,
     /*  966235 */     GIR_EraseRootFromParent_Done,
     /*  966236 */   // Label 14505: @966236
     /*  966236 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(966328), // Rule ID 5226 //
     /*  966241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966291 */     // MIs[1] Operand 1
     /*  966291 */     // No operand predicates
     /*  966291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  966304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966326 */     GIR_RootConstrainSelectedInstOperands,
     /*  966327 */     // GIR_Coverage, 5226,
     /*  966327 */     GIR_EraseRootFromParent_Done,
     /*  966328 */   // Label 14506: @966328
     /*  966328 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(966420), // Rule ID 5227 //
     /*  966333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  966344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  966347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966383 */     // MIs[1] Operand 1
     /*  966383 */     // No operand predicates
     /*  966383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  966396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966418 */     GIR_RootConstrainSelectedInstOperands,
     /*  966419 */     // GIR_Coverage, 5227,
     /*  966419 */     GIR_EraseRootFromParent_Done,
     /*  966420 */   // Label 14507: @966420
     /*  966420 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(966512), // Rule ID 5228 //
     /*  966425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966475 */     // MIs[1] Operand 1
     /*  966475 */     // No operand predicates
     /*  966475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966510 */     GIR_RootConstrainSelectedInstOperands,
     /*  966511 */     // GIR_Coverage, 5228,
     /*  966511 */     GIR_EraseRootFromParent_Done,
     /*  966512 */   // Label 14508: @966512
     /*  966512 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(966604), // Rule ID 5229 //
     /*  966517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  966528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  966531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  966547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966567 */     // MIs[1] Operand 1
     /*  966567 */     // No operand predicates
     /*  966567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  966583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966602 */     GIR_RootConstrainSelectedInstOperands,
     /*  966603 */     // GIR_Coverage, 5229,
     /*  966603 */     GIR_EraseRootFromParent_Done,
     /*  966604 */   // Label 14509: @966604
     /*  966604 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(966696), // Rule ID 5230 //
     /*  966609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966659 */     // MIs[1] Operand 1
     /*  966659 */     // No operand predicates
     /*  966659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966672 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966694 */     GIR_RootConstrainSelectedInstOperands,
     /*  966695 */     // GIR_Coverage, 5230,
     /*  966695 */     GIR_EraseRootFromParent_Done,
     /*  966696 */   // Label 14510: @966696
     /*  966696 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(966788), // Rule ID 5231 //
     /*  966701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  966712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  966715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  966731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966751 */     // MIs[1] Operand 1
     /*  966751 */     // No operand predicates
     /*  966751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966764 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  966767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966786 */     GIR_RootConstrainSelectedInstOperands,
     /*  966787 */     // GIR_Coverage, 5231,
     /*  966787 */     GIR_EraseRootFromParent_Done,
     /*  966788 */   // Label 14511: @966788
     /*  966788 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(966880), // Rule ID 5232 //
     /*  966793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966843 */     // MIs[1] Operand 1
     /*  966843 */     // No operand predicates
     /*  966843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966856 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  966856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966878 */     GIR_RootConstrainSelectedInstOperands,
     /*  966879 */     // GIR_Coverage, 5232,
     /*  966879 */     GIR_EraseRootFromParent_Done,
     /*  966880 */   // Label 14512: @966880
     /*  966880 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(966972), // Rule ID 5233 //
     /*  966885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  966896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  966899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  966915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966935 */     // MIs[1] Operand 1
     /*  966935 */     // No operand predicates
     /*  966935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  966948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  966951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966970 */     GIR_RootConstrainSelectedInstOperands,
     /*  966971 */     // GIR_Coverage, 5233,
     /*  966971 */     GIR_EraseRootFromParent_Done,
     /*  966972 */   // Label 14513: @966972
     /*  966972 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(967064), // Rule ID 5234 //
     /*  966977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  966980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  966985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  966988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  966991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  966994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967027 */     // MIs[1] Operand 1
     /*  967027 */     // No operand predicates
     /*  967027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  967043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967062 */     GIR_RootConstrainSelectedInstOperands,
     /*  967063 */     // GIR_Coverage, 5234,
     /*  967063 */     GIR_EraseRootFromParent_Done,
     /*  967064 */   // Label 14514: @967064
     /*  967064 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(967156), // Rule ID 5235 //
     /*  967069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  967080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  967083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  967099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967119 */     // MIs[1] Operand 1
     /*  967119 */     // No operand predicates
     /*  967119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  967135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967154 */     GIR_RootConstrainSelectedInstOperands,
     /*  967155 */     // GIR_Coverage, 5235,
     /*  967155 */     GIR_EraseRootFromParent_Done,
     /*  967156 */   // Label 14515: @967156
     /*  967156 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(967248), // Rule ID 5236 //
     /*  967161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967211 */     // MIs[1] Operand 1
     /*  967211 */     // No operand predicates
     /*  967211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  967227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967246 */     GIR_RootConstrainSelectedInstOperands,
     /*  967247 */     // GIR_Coverage, 5236,
     /*  967247 */     GIR_EraseRootFromParent_Done,
     /*  967248 */   // Label 14516: @967248
     /*  967248 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(967340), // Rule ID 5237 //
     /*  967253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  967264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  967267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  967283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967303 */     // MIs[1] Operand 1
     /*  967303 */     // No operand predicates
     /*  967303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  967319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967338 */     GIR_RootConstrainSelectedInstOperands,
     /*  967339 */     // GIR_Coverage, 5237,
     /*  967339 */     GIR_EraseRootFromParent_Done,
     /*  967340 */   // Label 14517: @967340
     /*  967340 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(967432), // Rule ID 5238 //
     /*  967345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967395 */     // MIs[1] Operand 1
     /*  967395 */     // No operand predicates
     /*  967395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  967408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  967411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967430 */     GIR_RootConstrainSelectedInstOperands,
     /*  967431 */     // GIR_Coverage, 5238,
     /*  967431 */     GIR_EraseRootFromParent_Done,
     /*  967432 */   // Label 14518: @967432
     /*  967432 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(967524), // Rule ID 5239 //
     /*  967437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  967445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  967448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  967451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  967467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967487 */     // MIs[1] Operand 1
     /*  967487 */     // No operand predicates
     /*  967487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  967500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  967503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967522 */     GIR_RootConstrainSelectedInstOperands,
     /*  967523 */     // GIR_Coverage, 5239,
     /*  967523 */     GIR_EraseRootFromParent_Done,
     /*  967524 */   // Label 14519: @967524
     /*  967524 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(967619), // Rule ID 7970 //
     /*  967529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967579 */     // MIs[1] Operand 1
     /*  967579 */     // No operand predicates
     /*  967579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  967595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967617 */     GIR_RootConstrainSelectedInstOperands,
     /*  967618 */     // GIR_Coverage, 7970,
     /*  967618 */     GIR_EraseRootFromParent_Done,
     /*  967619 */   // Label 14520: @967619
     /*  967619 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(967714), // Rule ID 7971 //
     /*  967624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967674 */     // MIs[1] Operand 1
     /*  967674 */     // No operand predicates
     /*  967674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  967690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967712 */     GIR_RootConstrainSelectedInstOperands,
     /*  967713 */     // GIR_Coverage, 7971,
     /*  967713 */     GIR_EraseRootFromParent_Done,
     /*  967714 */   // Label 14521: @967714
     /*  967714 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(967809), // Rule ID 7974 //
     /*  967719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967769 */     // MIs[1] Operand 1
     /*  967769 */     // No operand predicates
     /*  967769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967782 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  967785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967807 */     GIR_RootConstrainSelectedInstOperands,
     /*  967808 */     // GIR_Coverage, 7974,
     /*  967808 */     GIR_EraseRootFromParent_Done,
     /*  967809 */   // Label 14522: @967809
     /*  967809 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(967904), // Rule ID 7975 //
     /*  967814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967864 */     // MIs[1] Operand 1
     /*  967864 */     // No operand predicates
     /*  967864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967877 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  967880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967902 */     GIR_RootConstrainSelectedInstOperands,
     /*  967903 */     // GIR_Coverage, 7975,
     /*  967903 */     GIR_EraseRootFromParent_Done,
     /*  967904 */   // Label 14523: @967904
     /*  967904 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(967999), // Rule ID 7978 //
     /*  967909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967959 */     // MIs[1] Operand 1
     /*  967959 */     // No operand predicates
     /*  967959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  967975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967997 */     GIR_RootConstrainSelectedInstOperands,
     /*  967998 */     // GIR_Coverage, 7978,
     /*  967998 */     GIR_EraseRootFromParent_Done,
     /*  967999 */   // Label 14524: @967999
     /*  967999 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(968094), // Rule ID 7979 //
     /*  968004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968054 */     // MIs[1] Operand 1
     /*  968054 */     // No operand predicates
     /*  968054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968067 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968092 */     GIR_RootConstrainSelectedInstOperands,
     /*  968093 */     // GIR_Coverage, 7979,
     /*  968093 */     GIR_EraseRootFromParent_Done,
     /*  968094 */   // Label 14525: @968094
     /*  968094 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(968189), // Rule ID 7982 //
     /*  968099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968149 */     // MIs[1] Operand 1
     /*  968149 */     // No operand predicates
     /*  968149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  968165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968187 */     GIR_RootConstrainSelectedInstOperands,
     /*  968188 */     // GIR_Coverage, 7982,
     /*  968188 */     GIR_EraseRootFromParent_Done,
     /*  968189 */   // Label 14526: @968189
     /*  968189 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(968284), // Rule ID 7983 //
     /*  968194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968244 */     // MIs[1] Operand 1
     /*  968244 */     // No operand predicates
     /*  968244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968257 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  968260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968282 */     GIR_RootConstrainSelectedInstOperands,
     /*  968283 */     // GIR_Coverage, 7983,
     /*  968283 */     GIR_EraseRootFromParent_Done,
     /*  968284 */   // Label 14527: @968284
     /*  968284 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(968379), // Rule ID 7986 //
     /*  968289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968339 */     // MIs[1] Operand 1
     /*  968339 */     // No operand predicates
     /*  968339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968377 */     GIR_RootConstrainSelectedInstOperands,
     /*  968378 */     // GIR_Coverage, 7986,
     /*  968378 */     GIR_EraseRootFromParent_Done,
     /*  968379 */   // Label 14528: @968379
     /*  968379 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(968474), // Rule ID 7987 //
     /*  968384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968434 */     // MIs[1] Operand 1
     /*  968434 */     // No operand predicates
     /*  968434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968472 */     GIR_RootConstrainSelectedInstOperands,
     /*  968473 */     // GIR_Coverage, 7987,
     /*  968473 */     GIR_EraseRootFromParent_Done,
     /*  968474 */   // Label 14529: @968474
     /*  968474 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(968569), // Rule ID 7990 //
     /*  968479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968529 */     // MIs[1] Operand 1
     /*  968529 */     // No operand predicates
     /*  968529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968567 */     GIR_RootConstrainSelectedInstOperands,
     /*  968568 */     // GIR_Coverage, 7990,
     /*  968568 */     GIR_EraseRootFromParent_Done,
     /*  968569 */   // Label 14530: @968569
     /*  968569 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(968664), // Rule ID 7991 //
     /*  968574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968624 */     // MIs[1] Operand 1
     /*  968624 */     // No operand predicates
     /*  968624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968637 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  968637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  968640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968662 */     GIR_RootConstrainSelectedInstOperands,
     /*  968663 */     // GIR_Coverage, 7991,
     /*  968663 */     GIR_EraseRootFromParent_Done,
     /*  968664 */   // Label 14531: @968664
     /*  968664 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(968759), // Rule ID 7994 //
     /*  968669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968719 */     // MIs[1] Operand 1
     /*  968719 */     // No operand predicates
     /*  968719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968757 */     GIR_RootConstrainSelectedInstOperands,
     /*  968758 */     // GIR_Coverage, 7994,
     /*  968758 */     GIR_EraseRootFromParent_Done,
     /*  968759 */   // Label 14532: @968759
     /*  968759 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(968854), // Rule ID 7995 //
     /*  968764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968814 */     // MIs[1] Operand 1
     /*  968814 */     // No operand predicates
     /*  968814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968852 */     GIR_RootConstrainSelectedInstOperands,
     /*  968853 */     // GIR_Coverage, 7995,
     /*  968853 */     GIR_EraseRootFromParent_Done,
     /*  968854 */   // Label 14533: @968854
     /*  968854 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(968949), // Rule ID 7998 //
     /*  968859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968909 */     // MIs[1] Operand 1
     /*  968909 */     // No operand predicates
     /*  968909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  968925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968947 */     GIR_RootConstrainSelectedInstOperands,
     /*  968948 */     // GIR_Coverage, 7998,
     /*  968948 */     GIR_EraseRootFromParent_Done,
     /*  968949 */   // Label 14534: @968949
     /*  968949 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(969044), // Rule ID 7999 //
     /*  968954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  968962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969004 */     // MIs[1] Operand 1
     /*  969004 */     // No operand predicates
     /*  969004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969042 */     GIR_RootConstrainSelectedInstOperands,
     /*  969043 */     // GIR_Coverage, 7999,
     /*  969043 */     GIR_EraseRootFromParent_Done,
     /*  969044 */   // Label 14535: @969044
     /*  969044 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(969139), // Rule ID 8002 //
     /*  969049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969099 */     // MIs[1] Operand 1
     /*  969099 */     // No operand predicates
     /*  969099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969137 */     GIR_RootConstrainSelectedInstOperands,
     /*  969138 */     // GIR_Coverage, 8002,
     /*  969138 */     GIR_EraseRootFromParent_Done,
     /*  969139 */   // Label 14536: @969139
     /*  969139 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(969234), // Rule ID 8003 //
     /*  969144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969194 */     // MIs[1] Operand 1
     /*  969194 */     // No operand predicates
     /*  969194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969207 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969232 */     GIR_RootConstrainSelectedInstOperands,
     /*  969233 */     // GIR_Coverage, 8003,
     /*  969233 */     GIR_EraseRootFromParent_Done,
     /*  969234 */   // Label 14537: @969234
     /*  969234 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(969329), // Rule ID 8006 //
     /*  969239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  969242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969289 */     // MIs[1] Operand 1
     /*  969289 */     // No operand predicates
     /*  969289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  969302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969327 */     GIR_RootConstrainSelectedInstOperands,
     /*  969328 */     // GIR_Coverage, 8006,
     /*  969328 */     GIR_EraseRootFromParent_Done,
     /*  969329 */   // Label 14538: @969329
     /*  969329 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(969424), // Rule ID 8007 //
     /*  969334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  969337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969384 */     // MIs[1] Operand 1
     /*  969384 */     // No operand predicates
     /*  969384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969397 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  969397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  969400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969422 */     GIR_RootConstrainSelectedInstOperands,
     /*  969423 */     // GIR_Coverage, 8007,
     /*  969423 */     GIR_EraseRootFromParent_Done,
     /*  969424 */   // Label 14539: @969424
     /*  969424 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(969519), // Rule ID 8010 //
     /*  969429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969479 */     // MIs[1] Operand 1
     /*  969479 */     // No operand predicates
     /*  969479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969492 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  969495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969517 */     GIR_RootConstrainSelectedInstOperands,
     /*  969518 */     // GIR_Coverage, 8010,
     /*  969518 */     GIR_EraseRootFromParent_Done,
     /*  969519 */   // Label 14540: @969519
     /*  969519 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(969614), // Rule ID 8011 //
     /*  969524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969574 */     // MIs[1] Operand 1
     /*  969574 */     // No operand predicates
     /*  969574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  969590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969612 */     GIR_RootConstrainSelectedInstOperands,
     /*  969613 */     // GIR_Coverage, 8011,
     /*  969613 */     GIR_EraseRootFromParent_Done,
     /*  969614 */   // Label 14541: @969614
     /*  969614 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(969709), // Rule ID 8014 //
     /*  969619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969669 */     // MIs[1] Operand 1
     /*  969669 */     // No operand predicates
     /*  969669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969682 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  969685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969707 */     GIR_RootConstrainSelectedInstOperands,
     /*  969708 */     // GIR_Coverage, 8014,
     /*  969708 */     GIR_EraseRootFromParent_Done,
     /*  969709 */   // Label 14542: @969709
     /*  969709 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(969804), // Rule ID 8015 //
     /*  969714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969764 */     // MIs[1] Operand 1
     /*  969764 */     // No operand predicates
     /*  969764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969777 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  969780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969802 */     GIR_RootConstrainSelectedInstOperands,
     /*  969803 */     // GIR_Coverage, 8015,
     /*  969803 */     GIR_EraseRootFromParent_Done,
     /*  969804 */   // Label 14543: @969804
     /*  969804 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(969899), // Rule ID 8018 //
     /*  969809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969859 */     // MIs[1] Operand 1
     /*  969859 */     // No operand predicates
     /*  969859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969872 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  969875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969897 */     GIR_RootConstrainSelectedInstOperands,
     /*  969898 */     // GIR_Coverage, 8018,
     /*  969898 */     GIR_EraseRootFromParent_Done,
     /*  969899 */   // Label 14544: @969899
     /*  969899 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(969994), // Rule ID 8019 //
     /*  969904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  969912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969954 */     // MIs[1] Operand 1
     /*  969954 */     // No operand predicates
     /*  969954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969967 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  969970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969992 */     GIR_RootConstrainSelectedInstOperands,
     /*  969993 */     // GIR_Coverage, 8019,
     /*  969993 */     GIR_EraseRootFromParent_Done,
     /*  969994 */   // Label 14545: @969994
     /*  969994 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(970089), // Rule ID 8022 //
     /*  969999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970049 */     // MIs[1] Operand 1
     /*  970049 */     // No operand predicates
     /*  970049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970087 */     GIR_RootConstrainSelectedInstOperands,
     /*  970088 */     // GIR_Coverage, 8022,
     /*  970088 */     GIR_EraseRootFromParent_Done,
     /*  970089 */   // Label 14546: @970089
     /*  970089 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(970184), // Rule ID 8023 //
     /*  970094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970144 */     // MIs[1] Operand 1
     /*  970144 */     // No operand predicates
     /*  970144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970157 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970182 */     GIR_RootConstrainSelectedInstOperands,
     /*  970183 */     // GIR_Coverage, 8023,
     /*  970183 */     GIR_EraseRootFromParent_Done,
     /*  970184 */   // Label 14547: @970184
     /*  970184 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(970279), // Rule ID 8026 //
     /*  970189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970239 */     // MIs[1] Operand 1
     /*  970239 */     // No operand predicates
     /*  970239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970277 */     GIR_RootConstrainSelectedInstOperands,
     /*  970278 */     // GIR_Coverage, 8026,
     /*  970278 */     GIR_EraseRootFromParent_Done,
     /*  970279 */   // Label 14548: @970279
     /*  970279 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(970374), // Rule ID 8027 //
     /*  970284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970334 */     // MIs[1] Operand 1
     /*  970334 */     // No operand predicates
     /*  970334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970347 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970372 */     GIR_RootConstrainSelectedInstOperands,
     /*  970373 */     // GIR_Coverage, 8027,
     /*  970373 */     GIR_EraseRootFromParent_Done,
     /*  970374 */   // Label 14549: @970374
     /*  970374 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(970469), // Rule ID 8030 //
     /*  970379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970429 */     // MIs[1] Operand 1
     /*  970429 */     // No operand predicates
     /*  970429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970442 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  970445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970467 */     GIR_RootConstrainSelectedInstOperands,
     /*  970468 */     // GIR_Coverage, 8030,
     /*  970468 */     GIR_EraseRootFromParent_Done,
     /*  970469 */   // Label 14550: @970469
     /*  970469 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(970564), // Rule ID 8031 //
     /*  970474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970524 */     // MIs[1] Operand 1
     /*  970524 */     // No operand predicates
     /*  970524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970537 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  970540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970562 */     GIR_RootConstrainSelectedInstOperands,
     /*  970563 */     // GIR_Coverage, 8031,
     /*  970563 */     GIR_EraseRootFromParent_Done,
     /*  970564 */   // Label 14551: @970564
     /*  970564 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(970659), // Rule ID 8034 //
     /*  970569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970619 */     // MIs[1] Operand 1
     /*  970619 */     // No operand predicates
     /*  970619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970657 */     GIR_RootConstrainSelectedInstOperands,
     /*  970658 */     // GIR_Coverage, 8034,
     /*  970658 */     GIR_EraseRootFromParent_Done,
     /*  970659 */   // Label 14552: @970659
     /*  970659 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(970754), // Rule ID 8035 //
     /*  970664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970714 */     // MIs[1] Operand 1
     /*  970714 */     // No operand predicates
     /*  970714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  970730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970752 */     GIR_RootConstrainSelectedInstOperands,
     /*  970753 */     // GIR_Coverage, 8035,
     /*  970753 */     GIR_EraseRootFromParent_Done,
     /*  970754 */   // Label 14553: @970754
     /*  970754 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(970849), // Rule ID 8038 //
     /*  970759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970809 */     // MIs[1] Operand 1
     /*  970809 */     // No operand predicates
     /*  970809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970847 */     GIR_RootConstrainSelectedInstOperands,
     /*  970848 */     // GIR_Coverage, 8038,
     /*  970848 */     GIR_EraseRootFromParent_Done,
     /*  970849 */   // Label 14554: @970849
     /*  970849 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(970944), // Rule ID 8039 //
     /*  970854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970904 */     // MIs[1] Operand 1
     /*  970904 */     // No operand predicates
     /*  970904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  970920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970942 */     GIR_RootConstrainSelectedInstOperands,
     /*  970943 */     // GIR_Coverage, 8039,
     /*  970943 */     GIR_EraseRootFromParent_Done,
     /*  970944 */   // Label 14555: @970944
     /*  970944 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(971039), // Rule ID 8042 //
     /*  970949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  970957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  970966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970999 */     // MIs[1] Operand 1
     /*  970999 */     // No operand predicates
     /*  970999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971012 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971037 */     GIR_RootConstrainSelectedInstOperands,
     /*  971038 */     // GIR_Coverage, 8042,
     /*  971038 */     GIR_EraseRootFromParent_Done,
     /*  971039 */   // Label 14556: @971039
     /*  971039 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(971134), // Rule ID 8043 //
     /*  971044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971094 */     // MIs[1] Operand 1
     /*  971094 */     // No operand predicates
     /*  971094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971132 */     GIR_RootConstrainSelectedInstOperands,
     /*  971133 */     // GIR_Coverage, 8043,
     /*  971133 */     GIR_EraseRootFromParent_Done,
     /*  971134 */   // Label 14557: @971134
     /*  971134 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(971229), // Rule ID 8046 //
     /*  971139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971189 */     // MIs[1] Operand 1
     /*  971189 */     // No operand predicates
     /*  971189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  971205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971227 */     GIR_RootConstrainSelectedInstOperands,
     /*  971228 */     // GIR_Coverage, 8046,
     /*  971228 */     GIR_EraseRootFromParent_Done,
     /*  971229 */   // Label 14558: @971229
     /*  971229 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(971324), // Rule ID 8047 //
     /*  971234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971284 */     // MIs[1] Operand 1
     /*  971284 */     // No operand predicates
     /*  971284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971297 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  971300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971322 */     GIR_RootConstrainSelectedInstOperands,
     /*  971323 */     // GIR_Coverage, 8047,
     /*  971323 */     GIR_EraseRootFromParent_Done,
     /*  971324 */   // Label 14559: @971324
     /*  971324 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(971419), // Rule ID 8050 //
     /*  971329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971379 */     // MIs[1] Operand 1
     /*  971379 */     // No operand predicates
     /*  971379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  971395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971417 */     GIR_RootConstrainSelectedInstOperands,
     /*  971418 */     // GIR_Coverage, 8050,
     /*  971418 */     GIR_EraseRootFromParent_Done,
     /*  971419 */   // Label 14560: @971419
     /*  971419 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(971514), // Rule ID 8051 //
     /*  971424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971474 */     // MIs[1] Operand 1
     /*  971474 */     // No operand predicates
     /*  971474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971487 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  971490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971512 */     GIR_RootConstrainSelectedInstOperands,
     /*  971513 */     // GIR_Coverage, 8051,
     /*  971513 */     GIR_EraseRootFromParent_Done,
     /*  971514 */   // Label 14561: @971514
     /*  971514 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(971609), // Rule ID 8054 //
     /*  971519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971569 */     // MIs[1] Operand 1
     /*  971569 */     // No operand predicates
     /*  971569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971607 */     GIR_RootConstrainSelectedInstOperands,
     /*  971608 */     // GIR_Coverage, 8054,
     /*  971608 */     GIR_EraseRootFromParent_Done,
     /*  971609 */   // Label 14562: @971609
     /*  971609 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(971704), // Rule ID 8055 //
     /*  971614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  971622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971664 */     // MIs[1] Operand 1
     /*  971664 */     // No operand predicates
     /*  971664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  971680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971702 */     GIR_RootConstrainSelectedInstOperands,
     /*  971703 */     // GIR_Coverage, 8055,
     /*  971703 */     GIR_EraseRootFromParent_Done,
     /*  971704 */   // Label 14563: @971704
     /*  971704 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(971799), // Rule ID 8234 //
     /*  971709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971759 */     // MIs[1] Operand 1
     /*  971759 */     // No operand predicates
     /*  971759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  971775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971797 */     GIR_RootConstrainSelectedInstOperands,
     /*  971798 */     // GIR_Coverage, 8234,
     /*  971798 */     GIR_EraseRootFromParent_Done,
     /*  971799 */   // Label 14564: @971799
     /*  971799 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(971894), // Rule ID 8235 //
     /*  971804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971854 */     // MIs[1] Operand 1
     /*  971854 */     // No operand predicates
     /*  971854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971867 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  971867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  971870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971892 */     GIR_RootConstrainSelectedInstOperands,
     /*  971893 */     // GIR_Coverage, 8235,
     /*  971893 */     GIR_EraseRootFromParent_Done,
     /*  971894 */   // Label 14565: @971894
     /*  971894 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(971989), // Rule ID 8238 //
     /*  971899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  971916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971949 */     // MIs[1] Operand 1
     /*  971949 */     // No operand predicates
     /*  971949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  971965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971987 */     GIR_RootConstrainSelectedInstOperands,
     /*  971988 */     // GIR_Coverage, 8238,
     /*  971988 */     GIR_EraseRootFromParent_Done,
     /*  971989 */   // Label 14566: @971989
     /*  971989 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(972084), // Rule ID 8239 //
     /*  971994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972044 */     // MIs[1] Operand 1
     /*  972044 */     // No operand predicates
     /*  972044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972057 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972082 */     GIR_RootConstrainSelectedInstOperands,
     /*  972083 */     // GIR_Coverage, 8239,
     /*  972083 */     GIR_EraseRootFromParent_Done,
     /*  972084 */   // Label 14567: @972084
     /*  972084 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(972179), // Rule ID 8242 //
     /*  972089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972139 */     // MIs[1] Operand 1
     /*  972139 */     // No operand predicates
     /*  972139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972177 */     GIR_RootConstrainSelectedInstOperands,
     /*  972178 */     // GIR_Coverage, 8242,
     /*  972178 */     GIR_EraseRootFromParent_Done,
     /*  972179 */   // Label 14568: @972179
     /*  972179 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(972274), // Rule ID 8243 //
     /*  972184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972234 */     // MIs[1] Operand 1
     /*  972234 */     // No operand predicates
     /*  972234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972272 */     GIR_RootConstrainSelectedInstOperands,
     /*  972273 */     // GIR_Coverage, 8243,
     /*  972273 */     GIR_EraseRootFromParent_Done,
     /*  972274 */   // Label 14569: @972274
     /*  972274 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(972369), // Rule ID 8246 //
     /*  972279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972329 */     // MIs[1] Operand 1
     /*  972329 */     // No operand predicates
     /*  972329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972342 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972367 */     GIR_RootConstrainSelectedInstOperands,
     /*  972368 */     // GIR_Coverage, 8246,
     /*  972368 */     GIR_EraseRootFromParent_Done,
     /*  972369 */   // Label 14570: @972369
     /*  972369 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(972464), // Rule ID 8247 //
     /*  972374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972424 */     // MIs[1] Operand 1
     /*  972424 */     // No operand predicates
     /*  972424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972437 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  972440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972462 */     GIR_RootConstrainSelectedInstOperands,
     /*  972463 */     // GIR_Coverage, 8247,
     /*  972463 */     GIR_EraseRootFromParent_Done,
     /*  972464 */   // Label 14571: @972464
     /*  972464 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(972559), // Rule ID 8250 //
     /*  972469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972519 */     // MIs[1] Operand 1
     /*  972519 */     // No operand predicates
     /*  972519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972557 */     GIR_RootConstrainSelectedInstOperands,
     /*  972558 */     // GIR_Coverage, 8250,
     /*  972558 */     GIR_EraseRootFromParent_Done,
     /*  972559 */   // Label 14572: @972559
     /*  972559 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(972654), // Rule ID 8251 //
     /*  972564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972614 */     // MIs[1] Operand 1
     /*  972614 */     // No operand predicates
     /*  972614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972652 */     GIR_RootConstrainSelectedInstOperands,
     /*  972653 */     // GIR_Coverage, 8251,
     /*  972653 */     GIR_EraseRootFromParent_Done,
     /*  972654 */   // Label 14573: @972654
     /*  972654 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(972749), // Rule ID 8254 //
     /*  972659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972709 */     // MIs[1] Operand 1
     /*  972709 */     // No operand predicates
     /*  972709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  972722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972747 */     GIR_RootConstrainSelectedInstOperands,
     /*  972748 */     // GIR_Coverage, 8254,
     /*  972748 */     GIR_EraseRootFromParent_Done,
     /*  972749 */   // Label 14574: @972749
     /*  972749 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(972844), // Rule ID 8255 //
     /*  972754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972804 */     // MIs[1] Operand 1
     /*  972804 */     // No operand predicates
     /*  972804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972817 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  972817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  972820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972842 */     GIR_RootConstrainSelectedInstOperands,
     /*  972843 */     // GIR_Coverage, 8255,
     /*  972843 */     GIR_EraseRootFromParent_Done,
     /*  972844 */   // Label 14575: @972844
     /*  972844 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(972939), // Rule ID 8258 //
     /*  972849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972899 */     // MIs[1] Operand 1
     /*  972899 */     // No operand predicates
     /*  972899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  972915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972937 */     GIR_RootConstrainSelectedInstOperands,
     /*  972938 */     // GIR_Coverage, 8258,
     /*  972938 */     GIR_EraseRootFromParent_Done,
     /*  972939 */   // Label 14576: @972939
     /*  972939 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(973034), // Rule ID 8259 //
     /*  972944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  972952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972994 */     // MIs[1] Operand 1
     /*  972994 */     // No operand predicates
     /*  972994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973032 */     GIR_RootConstrainSelectedInstOperands,
     /*  973033 */     // GIR_Coverage, 8259,
     /*  973033 */     GIR_EraseRootFromParent_Done,
     /*  973034 */   // Label 14577: @973034
     /*  973034 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(973129), // Rule ID 8262 //
     /*  973039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973089 */     // MIs[1] Operand 1
     /*  973089 */     // No operand predicates
     /*  973089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973127 */     GIR_RootConstrainSelectedInstOperands,
     /*  973128 */     // GIR_Coverage, 8262,
     /*  973128 */     GIR_EraseRootFromParent_Done,
     /*  973129 */   // Label 14578: @973129
     /*  973129 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(973224), // Rule ID 8263 //
     /*  973134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973184 */     // MIs[1] Operand 1
     /*  973184 */     // No operand predicates
     /*  973184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973197 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973222 */     GIR_RootConstrainSelectedInstOperands,
     /*  973223 */     // GIR_Coverage, 8263,
     /*  973223 */     GIR_EraseRootFromParent_Done,
     /*  973224 */   // Label 14579: @973224
     /*  973224 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(973319), // Rule ID 8266 //
     /*  973229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973279 */     // MIs[1] Operand 1
     /*  973279 */     // No operand predicates
     /*  973279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973317 */     GIR_RootConstrainSelectedInstOperands,
     /*  973318 */     // GIR_Coverage, 8266,
     /*  973318 */     GIR_EraseRootFromParent_Done,
     /*  973319 */   // Label 14580: @973319
     /*  973319 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(973414), // Rule ID 8267 //
     /*  973324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973374 */     // MIs[1] Operand 1
     /*  973374 */     // No operand predicates
     /*  973374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973387 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973412 */     GIR_RootConstrainSelectedInstOperands,
     /*  973413 */     // GIR_Coverage, 8267,
     /*  973413 */     GIR_EraseRootFromParent_Done,
     /*  973414 */   // Label 14581: @973414
     /*  973414 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(973509), // Rule ID 8270 //
     /*  973419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  973422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973469 */     // MIs[1] Operand 1
     /*  973469 */     // No operand predicates
     /*  973469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  973482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973507 */     GIR_RootConstrainSelectedInstOperands,
     /*  973508 */     // GIR_Coverage, 8270,
     /*  973508 */     GIR_EraseRootFromParent_Done,
     /*  973509 */   // Label 14582: @973509
     /*  973509 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(973604), // Rule ID 8271 //
     /*  973514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  973517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973564 */     // MIs[1] Operand 1
     /*  973564 */     // No operand predicates
     /*  973564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973577 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  973577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  973580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973602 */     GIR_RootConstrainSelectedInstOperands,
     /*  973603 */     // GIR_Coverage, 8271,
     /*  973603 */     GIR_EraseRootFromParent_Done,
     /*  973604 */   // Label 14583: @973604
     /*  973604 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(973699), // Rule ID 8274 //
     /*  973609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973659 */     // MIs[1] Operand 1
     /*  973659 */     // No operand predicates
     /*  973659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973672 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  973675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973697 */     GIR_RootConstrainSelectedInstOperands,
     /*  973698 */     // GIR_Coverage, 8274,
     /*  973698 */     GIR_EraseRootFromParent_Done,
     /*  973699 */   // Label 14584: @973699
     /*  973699 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(973794), // Rule ID 8275 //
     /*  973704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973754 */     // MIs[1] Operand 1
     /*  973754 */     // No operand predicates
     /*  973754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973767 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  973770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973792 */     GIR_RootConstrainSelectedInstOperands,
     /*  973793 */     // GIR_Coverage, 8275,
     /*  973793 */     GIR_EraseRootFromParent_Done,
     /*  973794 */   // Label 14585: @973794
     /*  973794 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(973889), // Rule ID 8278 //
     /*  973799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973849 */     // MIs[1] Operand 1
     /*  973849 */     // No operand predicates
     /*  973849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973862 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  973865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973887 */     GIR_RootConstrainSelectedInstOperands,
     /*  973888 */     // GIR_Coverage, 8278,
     /*  973888 */     GIR_EraseRootFromParent_Done,
     /*  973889 */   // Label 14586: @973889
     /*  973889 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(973984), // Rule ID 8279 //
     /*  973894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973944 */     // MIs[1] Operand 1
     /*  973944 */     // No operand predicates
     /*  973944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973957 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  973960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973982 */     GIR_RootConstrainSelectedInstOperands,
     /*  973983 */     // GIR_Coverage, 8279,
     /*  973983 */     GIR_EraseRootFromParent_Done,
     /*  973984 */   // Label 14587: @973984
     /*  973984 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(974079), // Rule ID 8282 //
     /*  973989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  973997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974039 */     // MIs[1] Operand 1
     /*  974039 */     // No operand predicates
     /*  974039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974052 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974077 */     GIR_RootConstrainSelectedInstOperands,
     /*  974078 */     // GIR_Coverage, 8282,
     /*  974078 */     GIR_EraseRootFromParent_Done,
     /*  974079 */   // Label 14588: @974079
     /*  974079 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(974174), // Rule ID 8283 //
     /*  974084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974134 */     // MIs[1] Operand 1
     /*  974134 */     // No operand predicates
     /*  974134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974147 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974172 */     GIR_RootConstrainSelectedInstOperands,
     /*  974173 */     // GIR_Coverage, 8283,
     /*  974173 */     GIR_EraseRootFromParent_Done,
     /*  974174 */   // Label 14589: @974174
     /*  974174 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(974269), // Rule ID 8286 //
     /*  974179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974229 */     // MIs[1] Operand 1
     /*  974229 */     // No operand predicates
     /*  974229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974267 */     GIR_RootConstrainSelectedInstOperands,
     /*  974268 */     // GIR_Coverage, 8286,
     /*  974268 */     GIR_EraseRootFromParent_Done,
     /*  974269 */   // Label 14590: @974269
     /*  974269 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(974364), // Rule ID 8287 //
     /*  974274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974324 */     // MIs[1] Operand 1
     /*  974324 */     // No operand predicates
     /*  974324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974362 */     GIR_RootConstrainSelectedInstOperands,
     /*  974363 */     // GIR_Coverage, 8287,
     /*  974363 */     GIR_EraseRootFromParent_Done,
     /*  974364 */   // Label 14591: @974364
     /*  974364 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(974459), // Rule ID 8290 //
     /*  974369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974419 */     // MIs[1] Operand 1
     /*  974419 */     // No operand predicates
     /*  974419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  974435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974457 */     GIR_RootConstrainSelectedInstOperands,
     /*  974458 */     // GIR_Coverage, 8290,
     /*  974458 */     GIR_EraseRootFromParent_Done,
     /*  974459 */   // Label 14592: @974459
     /*  974459 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(974554), // Rule ID 8291 //
     /*  974464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974514 */     // MIs[1] Operand 1
     /*  974514 */     // No operand predicates
     /*  974514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974527 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  974530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974552 */     GIR_RootConstrainSelectedInstOperands,
     /*  974553 */     // GIR_Coverage, 8291,
     /*  974553 */     GIR_EraseRootFromParent_Done,
     /*  974554 */   // Label 14593: @974554
     /*  974554 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(974649), // Rule ID 8294 //
     /*  974559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974609 */     // MIs[1] Operand 1
     /*  974609 */     // No operand predicates
     /*  974609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974647 */     GIR_RootConstrainSelectedInstOperands,
     /*  974648 */     // GIR_Coverage, 8294,
     /*  974648 */     GIR_EraseRootFromParent_Done,
     /*  974649 */   // Label 14594: @974649
     /*  974649 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(974744), // Rule ID 8295 //
     /*  974654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974704 */     // MIs[1] Operand 1
     /*  974704 */     // No operand predicates
     /*  974704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974717 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  974720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974742 */     GIR_RootConstrainSelectedInstOperands,
     /*  974743 */     // GIR_Coverage, 8295,
     /*  974743 */     GIR_EraseRootFromParent_Done,
     /*  974744 */   // Label 14595: @974744
     /*  974744 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(974839), // Rule ID 8298 //
     /*  974749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974799 */     // MIs[1] Operand 1
     /*  974799 */     // No operand predicates
     /*  974799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974837 */     GIR_RootConstrainSelectedInstOperands,
     /*  974838 */     // GIR_Coverage, 8298,
     /*  974838 */     GIR_EraseRootFromParent_Done,
     /*  974839 */   // Label 14596: @974839
     /*  974839 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(974934), // Rule ID 8299 //
     /*  974844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974894 */     // MIs[1] Operand 1
     /*  974894 */     // No operand predicates
     /*  974894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974907 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  974910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974932 */     GIR_RootConstrainSelectedInstOperands,
     /*  974933 */     // GIR_Coverage, 8299,
     /*  974933 */     GIR_EraseRootFromParent_Done,
     /*  974934 */   // Label 14597: @974934
     /*  974934 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(975029), // Rule ID 8302 //
     /*  974939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  974947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  974956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974989 */     // MIs[1] Operand 1
     /*  974989 */     // No operand predicates
     /*  974989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975027 */     GIR_RootConstrainSelectedInstOperands,
     /*  975028 */     // GIR_Coverage, 8302,
     /*  975028 */     GIR_EraseRootFromParent_Done,
     /*  975029 */   // Label 14598: @975029
     /*  975029 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(975124), // Rule ID 8303 //
     /*  975034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975084 */     // MIs[1] Operand 1
     /*  975084 */     // No operand predicates
     /*  975084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975097 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975122 */     GIR_RootConstrainSelectedInstOperands,
     /*  975123 */     // GIR_Coverage, 8303,
     /*  975123 */     GIR_EraseRootFromParent_Done,
     /*  975124 */   // Label 14599: @975124
     /*  975124 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(975219), // Rule ID 8306 //
     /*  975129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975179 */     // MIs[1] Operand 1
     /*  975179 */     // No operand predicates
     /*  975179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975217 */     GIR_RootConstrainSelectedInstOperands,
     /*  975218 */     // GIR_Coverage, 8306,
     /*  975218 */     GIR_EraseRootFromParent_Done,
     /*  975219 */   // Label 14600: @975219
     /*  975219 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(975314), // Rule ID 8307 //
     /*  975224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975274 */     // MIs[1] Operand 1
     /*  975274 */     // No operand predicates
     /*  975274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975312 */     GIR_RootConstrainSelectedInstOperands,
     /*  975313 */     // GIR_Coverage, 8307,
     /*  975313 */     GIR_EraseRootFromParent_Done,
     /*  975314 */   // Label 14601: @975314
     /*  975314 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(975409), // Rule ID 8310 //
     /*  975319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975369 */     // MIs[1] Operand 1
     /*  975369 */     // No operand predicates
     /*  975369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  975385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975407 */     GIR_RootConstrainSelectedInstOperands,
     /*  975408 */     // GIR_Coverage, 8310,
     /*  975408 */     GIR_EraseRootFromParent_Done,
     /*  975409 */   // Label 14602: @975409
     /*  975409 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(975504), // Rule ID 8311 //
     /*  975414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975464 */     // MIs[1] Operand 1
     /*  975464 */     // No operand predicates
     /*  975464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975477 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  975480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975502 */     GIR_RootConstrainSelectedInstOperands,
     /*  975503 */     // GIR_Coverage, 8311,
     /*  975503 */     GIR_EraseRootFromParent_Done,
     /*  975504 */   // Label 14603: @975504
     /*  975504 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(975599), // Rule ID 8314 //
     /*  975509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975559 */     // MIs[1] Operand 1
     /*  975559 */     // No operand predicates
     /*  975559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975597 */     GIR_RootConstrainSelectedInstOperands,
     /*  975598 */     // GIR_Coverage, 8314,
     /*  975598 */     GIR_EraseRootFromParent_Done,
     /*  975599 */   // Label 14604: @975599
     /*  975599 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(975694), // Rule ID 8315 //
     /*  975604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975654 */     // MIs[1] Operand 1
     /*  975654 */     // No operand predicates
     /*  975654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975667 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  975670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975692 */     GIR_RootConstrainSelectedInstOperands,
     /*  975693 */     // GIR_Coverage, 8315,
     /*  975693 */     GIR_EraseRootFromParent_Done,
     /*  975694 */   // Label 14605: @975694
     /*  975694 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(975789), // Rule ID 8318 //
     /*  975699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975749 */     // MIs[1] Operand 1
     /*  975749 */     // No operand predicates
     /*  975749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975762 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975787 */     GIR_RootConstrainSelectedInstOperands,
     /*  975788 */     // GIR_Coverage, 8318,
     /*  975788 */     GIR_EraseRootFromParent_Done,
     /*  975789 */   // Label 14606: @975789
     /*  975789 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(975884), // Rule ID 8319 //
     /*  975794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  975802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975844 */     // MIs[1] Operand 1
     /*  975844 */     // No operand predicates
     /*  975844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  975860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975882 */     GIR_RootConstrainSelectedInstOperands,
     /*  975883 */     // GIR_Coverage, 8319,
     /*  975883 */     GIR_EraseRootFromParent_Done,
     /*  975884 */   // Label 14607: @975884
     /*  975884 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(975979), // Rule ID 8850 //
     /*  975889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  975906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  975912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975939 */     // MIs[1] Operand 1
     /*  975939 */     // No operand predicates
     /*  975939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  975952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  975955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  975974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975977 */     GIR_RootConstrainSelectedInstOperands,
     /*  975978 */     // GIR_Coverage, 8850,
     /*  975978 */     GIR_EraseRootFromParent_Done,
     /*  975979 */   // Label 14608: @975979
     /*  975979 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(976074), // Rule ID 8851 //
     /*  975984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976034 */     // MIs[1] Operand 1
     /*  976034 */     // No operand predicates
     /*  976034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976047 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  976050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976072 */     GIR_RootConstrainSelectedInstOperands,
     /*  976073 */     // GIR_Coverage, 8851,
     /*  976073 */     GIR_EraseRootFromParent_Done,
     /*  976074 */   // Label 14609: @976074
     /*  976074 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(976169), // Rule ID 8854 //
     /*  976079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976129 */     // MIs[1] Operand 1
     /*  976129 */     // No operand predicates
     /*  976129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976167 */     GIR_RootConstrainSelectedInstOperands,
     /*  976168 */     // GIR_Coverage, 8854,
     /*  976168 */     GIR_EraseRootFromParent_Done,
     /*  976169 */   // Label 14610: @976169
     /*  976169 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(976264), // Rule ID 8855 //
     /*  976174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976224 */     // MIs[1] Operand 1
     /*  976224 */     // No operand predicates
     /*  976224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976237 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976262 */     GIR_RootConstrainSelectedInstOperands,
     /*  976263 */     // GIR_Coverage, 8855,
     /*  976263 */     GIR_EraseRootFromParent_Done,
     /*  976264 */   // Label 14611: @976264
     /*  976264 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(976359), // Rule ID 8858 //
     /*  976269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976319 */     // MIs[1] Operand 1
     /*  976319 */     // No operand predicates
     /*  976319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976357 */     GIR_RootConstrainSelectedInstOperands,
     /*  976358 */     // GIR_Coverage, 8858,
     /*  976358 */     GIR_EraseRootFromParent_Done,
     /*  976359 */   // Label 14612: @976359
     /*  976359 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(976454), // Rule ID 8859 //
     /*  976364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976414 */     // MIs[1] Operand 1
     /*  976414 */     // No operand predicates
     /*  976414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976427 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976452 */     GIR_RootConstrainSelectedInstOperands,
     /*  976453 */     // GIR_Coverage, 8859,
     /*  976453 */     GIR_EraseRootFromParent_Done,
     /*  976454 */   // Label 14613: @976454
     /*  976454 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(976549), // Rule ID 8862 //
     /*  976459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976509 */     // MIs[1] Operand 1
     /*  976509 */     // No operand predicates
     /*  976509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976547 */     GIR_RootConstrainSelectedInstOperands,
     /*  976548 */     // GIR_Coverage, 8862,
     /*  976548 */     GIR_EraseRootFromParent_Done,
     /*  976549 */   // Label 14614: @976549
     /*  976549 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(976644), // Rule ID 8863 //
     /*  976554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976604 */     // MIs[1] Operand 1
     /*  976604 */     // No operand predicates
     /*  976604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976617 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  976620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976642 */     GIR_RootConstrainSelectedInstOperands,
     /*  976643 */     // GIR_Coverage, 8863,
     /*  976643 */     GIR_EraseRootFromParent_Done,
     /*  976644 */   // Label 14615: @976644
     /*  976644 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(976739), // Rule ID 8866 //
     /*  976649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976699 */     // MIs[1] Operand 1
     /*  976699 */     // No operand predicates
     /*  976699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976737 */     GIR_RootConstrainSelectedInstOperands,
     /*  976738 */     // GIR_Coverage, 8866,
     /*  976738 */     GIR_EraseRootFromParent_Done,
     /*  976739 */   // Label 14616: @976739
     /*  976739 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(976834), // Rule ID 8867 //
     /*  976744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976794 */     // MIs[1] Operand 1
     /*  976794 */     // No operand predicates
     /*  976794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976832 */     GIR_RootConstrainSelectedInstOperands,
     /*  976833 */     // GIR_Coverage, 8867,
     /*  976833 */     GIR_EraseRootFromParent_Done,
     /*  976834 */   // Label 14617: @976834
     /*  976834 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(976929), // Rule ID 8870 //
     /*  976839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976889 */     // MIs[1] Operand 1
     /*  976889 */     // No operand predicates
     /*  976889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976902 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  976902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  976905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976927 */     GIR_RootConstrainSelectedInstOperands,
     /*  976928 */     // GIR_Coverage, 8870,
     /*  976928 */     GIR_EraseRootFromParent_Done,
     /*  976929 */   // Label 14618: @976929
     /*  976929 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(977024), // Rule ID 8871 //
     /*  976934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976984 */     // MIs[1] Operand 1
     /*  976984 */     // No operand predicates
     /*  976984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976997 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  976997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  977000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977022 */     GIR_RootConstrainSelectedInstOperands,
     /*  977023 */     // GIR_Coverage, 8871,
     /*  977023 */     GIR_EraseRootFromParent_Done,
     /*  977024 */   // Label 14619: @977024
     /*  977024 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(977119), // Rule ID 8874 //
     /*  977029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977079 */     // MIs[1] Operand 1
     /*  977079 */     // No operand predicates
     /*  977079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977117 */     GIR_RootConstrainSelectedInstOperands,
     /*  977118 */     // GIR_Coverage, 8874,
     /*  977118 */     GIR_EraseRootFromParent_Done,
     /*  977119 */   // Label 14620: @977119
     /*  977119 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(977214), // Rule ID 8875 //
     /*  977124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977174 */     // MIs[1] Operand 1
     /*  977174 */     // No operand predicates
     /*  977174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977212 */     GIR_RootConstrainSelectedInstOperands,
     /*  977213 */     // GIR_Coverage, 8875,
     /*  977213 */     GIR_EraseRootFromParent_Done,
     /*  977214 */   // Label 14621: @977214
     /*  977214 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(977309), // Rule ID 8878 //
     /*  977219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977269 */     // MIs[1] Operand 1
     /*  977269 */     // No operand predicates
     /*  977269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977307 */     GIR_RootConstrainSelectedInstOperands,
     /*  977308 */     // GIR_Coverage, 8878,
     /*  977308 */     GIR_EraseRootFromParent_Done,
     /*  977309 */   // Label 14622: @977309
     /*  977309 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(977404), // Rule ID 8879 //
     /*  977314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977364 */     // MIs[1] Operand 1
     /*  977364 */     // No operand predicates
     /*  977364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977377 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977402 */     GIR_RootConstrainSelectedInstOperands,
     /*  977403 */     // GIR_Coverage, 8879,
     /*  977403 */     GIR_EraseRootFromParent_Done,
     /*  977404 */   // Label 14623: @977404
     /*  977404 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(977499), // Rule ID 8882 //
     /*  977409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977459 */     // MIs[1] Operand 1
     /*  977459 */     // No operand predicates
     /*  977459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977497 */     GIR_RootConstrainSelectedInstOperands,
     /*  977498 */     // GIR_Coverage, 8882,
     /*  977498 */     GIR_EraseRootFromParent_Done,
     /*  977499 */   // Label 14624: @977499
     /*  977499 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(977594), // Rule ID 8883 //
     /*  977504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977554 */     // MIs[1] Operand 1
     /*  977554 */     // No operand predicates
     /*  977554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977567 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977592 */     GIR_RootConstrainSelectedInstOperands,
     /*  977593 */     // GIR_Coverage, 8883,
     /*  977593 */     GIR_EraseRootFromParent_Done,
     /*  977594 */   // Label 14625: @977594
     /*  977594 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(977689), // Rule ID 8886 //
     /*  977599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  977602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977649 */     // MIs[1] Operand 1
     /*  977649 */     // No operand predicates
     /*  977649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  977662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977687 */     GIR_RootConstrainSelectedInstOperands,
     /*  977688 */     // GIR_Coverage, 8886,
     /*  977688 */     GIR_EraseRootFromParent_Done,
     /*  977689 */   // Label 14626: @977689
     /*  977689 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(977784), // Rule ID 8887 //
     /*  977694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  977697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977744 */     // MIs[1] Operand 1
     /*  977744 */     // No operand predicates
     /*  977744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977757 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  977757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  977760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977782 */     GIR_RootConstrainSelectedInstOperands,
     /*  977783 */     // GIR_Coverage, 8887,
     /*  977783 */     GIR_EraseRootFromParent_Done,
     /*  977784 */   // Label 14627: @977784
     /*  977784 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(977879), // Rule ID 8890 //
     /*  977789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977839 */     // MIs[1] Operand 1
     /*  977839 */     // No operand predicates
     /*  977839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  977855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977877 */     GIR_RootConstrainSelectedInstOperands,
     /*  977878 */     // GIR_Coverage, 8890,
     /*  977878 */     GIR_EraseRootFromParent_Done,
     /*  977879 */   // Label 14628: @977879
     /*  977879 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(977974), // Rule ID 8891 //
     /*  977884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977934 */     // MIs[1] Operand 1
     /*  977934 */     // No operand predicates
     /*  977934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  977950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977972 */     GIR_RootConstrainSelectedInstOperands,
     /*  977973 */     // GIR_Coverage, 8891,
     /*  977973 */     GIR_EraseRootFromParent_Done,
     /*  977974 */   // Label 14629: @977974
     /*  977974 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(978069), // Rule ID 8894 //
     /*  977979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  977987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  977990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  977993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  977996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978029 */     // MIs[1] Operand 1
     /*  978029 */     // No operand predicates
     /*  978029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978042 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978067 */     GIR_RootConstrainSelectedInstOperands,
     /*  978068 */     // GIR_Coverage, 8894,
     /*  978068 */     GIR_EraseRootFromParent_Done,
     /*  978069 */   // Label 14630: @978069
     /*  978069 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(978164), // Rule ID 8895 //
     /*  978074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978124 */     // MIs[1] Operand 1
     /*  978124 */     // No operand predicates
     /*  978124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978137 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978162 */     GIR_RootConstrainSelectedInstOperands,
     /*  978163 */     // GIR_Coverage, 8895,
     /*  978163 */     GIR_EraseRootFromParent_Done,
     /*  978164 */   // Label 14631: @978164
     /*  978164 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(978259), // Rule ID 8898 //
     /*  978169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978219 */     // MIs[1] Operand 1
     /*  978219 */     // No operand predicates
     /*  978219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978232 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978257 */     GIR_RootConstrainSelectedInstOperands,
     /*  978258 */     // GIR_Coverage, 8898,
     /*  978258 */     GIR_EraseRootFromParent_Done,
     /*  978259 */   // Label 14632: @978259
     /*  978259 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(978354), // Rule ID 8899 //
     /*  978264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978314 */     // MIs[1] Operand 1
     /*  978314 */     // No operand predicates
     /*  978314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978327 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978352 */     GIR_RootConstrainSelectedInstOperands,
     /*  978353 */     // GIR_Coverage, 8899,
     /*  978353 */     GIR_EraseRootFromParent_Done,
     /*  978354 */   // Label 14633: @978354
     /*  978354 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(978449), // Rule ID 8902 //
     /*  978359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978409 */     // MIs[1] Operand 1
     /*  978409 */     // No operand predicates
     /*  978409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978447 */     GIR_RootConstrainSelectedInstOperands,
     /*  978448 */     // GIR_Coverage, 8902,
     /*  978448 */     GIR_EraseRootFromParent_Done,
     /*  978449 */   // Label 14634: @978449
     /*  978449 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(978544), // Rule ID 8903 //
     /*  978454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978504 */     // MIs[1] Operand 1
     /*  978504 */     // No operand predicates
     /*  978504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978517 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978542 */     GIR_RootConstrainSelectedInstOperands,
     /*  978543 */     // GIR_Coverage, 8903,
     /*  978543 */     GIR_EraseRootFromParent_Done,
     /*  978544 */   // Label 14635: @978544
     /*  978544 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(978639), // Rule ID 8906 //
     /*  978549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978599 */     // MIs[1] Operand 1
     /*  978599 */     // No operand predicates
     /*  978599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978637 */     GIR_RootConstrainSelectedInstOperands,
     /*  978638 */     // GIR_Coverage, 8906,
     /*  978638 */     GIR_EraseRootFromParent_Done,
     /*  978639 */   // Label 14636: @978639
     /*  978639 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(978734), // Rule ID 8907 //
     /*  978644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978694 */     // MIs[1] Operand 1
     /*  978694 */     // No operand predicates
     /*  978694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978707 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  978710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978732 */     GIR_RootConstrainSelectedInstOperands,
     /*  978733 */     // GIR_Coverage, 8907,
     /*  978733 */     GIR_EraseRootFromParent_Done,
     /*  978734 */   // Label 14637: @978734
     /*  978734 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(978829), // Rule ID 8910 //
     /*  978739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978789 */     // MIs[1] Operand 1
     /*  978789 */     // No operand predicates
     /*  978789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978802 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978827 */     GIR_RootConstrainSelectedInstOperands,
     /*  978828 */     // GIR_Coverage, 8910,
     /*  978828 */     GIR_EraseRootFromParent_Done,
     /*  978829 */   // Label 14638: @978829
     /*  978829 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(978924), // Rule ID 8911 //
     /*  978834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978884 */     // MIs[1] Operand 1
     /*  978884 */     // No operand predicates
     /*  978884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978897 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  978900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978922 */     GIR_RootConstrainSelectedInstOperands,
     /*  978923 */     // GIR_Coverage, 8911,
     /*  978923 */     GIR_EraseRootFromParent_Done,
     /*  978924 */   // Label 14639: @978924
     /*  978924 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(979019), // Rule ID 8914 //
     /*  978929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  978937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  978946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978979 */     // MIs[1] Operand 1
     /*  978979 */     // No operand predicates
     /*  978979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  978992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  978995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979017 */     GIR_RootConstrainSelectedInstOperands,
     /*  979018 */     // GIR_Coverage, 8914,
     /*  979018 */     GIR_EraseRootFromParent_Done,
     /*  979019 */   // Label 14640: @979019
     /*  979019 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(979114), // Rule ID 8915 //
     /*  979024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979074 */     // MIs[1] Operand 1
     /*  979074 */     // No operand predicates
     /*  979074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979112 */     GIR_RootConstrainSelectedInstOperands,
     /*  979113 */     // GIR_Coverage, 8915,
     /*  979113 */     GIR_EraseRootFromParent_Done,
     /*  979114 */   // Label 14641: @979114
     /*  979114 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(979209), // Rule ID 8918 //
     /*  979119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979169 */     // MIs[1] Operand 1
     /*  979169 */     // No operand predicates
     /*  979169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979207 */     GIR_RootConstrainSelectedInstOperands,
     /*  979208 */     // GIR_Coverage, 8918,
     /*  979208 */     GIR_EraseRootFromParent_Done,
     /*  979209 */   // Label 14642: @979209
     /*  979209 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(979304), // Rule ID 8919 //
     /*  979214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979264 */     // MIs[1] Operand 1
     /*  979264 */     // No operand predicates
     /*  979264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979277 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979302 */     GIR_RootConstrainSelectedInstOperands,
     /*  979303 */     // GIR_Coverage, 8919,
     /*  979303 */     GIR_EraseRootFromParent_Done,
     /*  979304 */   // Label 14643: @979304
     /*  979304 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(979399), // Rule ID 8922 //
     /*  979309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979359 */     // MIs[1] Operand 1
     /*  979359 */     // No operand predicates
     /*  979359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979397 */     GIR_RootConstrainSelectedInstOperands,
     /*  979398 */     // GIR_Coverage, 8922,
     /*  979398 */     GIR_EraseRootFromParent_Done,
     /*  979399 */   // Label 14644: @979399
     /*  979399 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(979494), // Rule ID 8923 //
     /*  979404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979454 */     // MIs[1] Operand 1
     /*  979454 */     // No operand predicates
     /*  979454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979492 */     GIR_RootConstrainSelectedInstOperands,
     /*  979493 */     // GIR_Coverage, 8923,
     /*  979493 */     GIR_EraseRootFromParent_Done,
     /*  979494 */   // Label 14645: @979494
     /*  979494 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(979589), // Rule ID 8926 //
     /*  979499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979549 */     // MIs[1] Operand 1
     /*  979549 */     // No operand predicates
     /*  979549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979587 */     GIR_RootConstrainSelectedInstOperands,
     /*  979588 */     // GIR_Coverage, 8926,
     /*  979588 */     GIR_EraseRootFromParent_Done,
     /*  979589 */   // Label 14646: @979589
     /*  979589 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(979684), // Rule ID 8927 //
     /*  979594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979644 */     // MIs[1] Operand 1
     /*  979644 */     // No operand predicates
     /*  979644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  979660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979682 */     GIR_RootConstrainSelectedInstOperands,
     /*  979683 */     // GIR_Coverage, 8927,
     /*  979683 */     GIR_EraseRootFromParent_Done,
     /*  979684 */   // Label 14647: @979684
     /*  979684 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(979779), // Rule ID 8930 //
     /*  979689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979739 */     // MIs[1] Operand 1
     /*  979739 */     // No operand predicates
     /*  979739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979777 */     GIR_RootConstrainSelectedInstOperands,
     /*  979778 */     // GIR_Coverage, 8930,
     /*  979778 */     GIR_EraseRootFromParent_Done,
     /*  979779 */   // Label 14648: @979779
     /*  979779 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(979874), // Rule ID 8931 //
     /*  979784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979834 */     // MIs[1] Operand 1
     /*  979834 */     // No operand predicates
     /*  979834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  979850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979872 */     GIR_RootConstrainSelectedInstOperands,
     /*  979873 */     // GIR_Coverage, 8931,
     /*  979873 */     GIR_EraseRootFromParent_Done,
     /*  979874 */   // Label 14649: @979874
     /*  979874 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(979969), // Rule ID 8934 //
     /*  979879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979929 */     // MIs[1] Operand 1
     /*  979929 */     // No operand predicates
     /*  979929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  979945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979967 */     GIR_RootConstrainSelectedInstOperands,
     /*  979968 */     // GIR_Coverage, 8934,
     /*  979968 */     GIR_EraseRootFromParent_Done,
     /*  979969 */   // Label 14650: @979969
     /*  979969 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(980064), // Rule ID 8935 //
     /*  979974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  979982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980024 */     // MIs[1] Operand 1
     /*  980024 */     // No operand predicates
     /*  980024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980037 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  980040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980062 */     GIR_RootConstrainSelectedInstOperands,
     /*  980063 */     // GIR_Coverage, 8935,
     /*  980063 */     GIR_EraseRootFromParent_Done,
     /*  980064 */   // Label 14651: @980064
     /*  980064 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(980159), // Rule ID 9114 //
     /*  980069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980119 */     // MIs[1] Operand 1
     /*  980119 */     // No operand predicates
     /*  980119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  980135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980157 */     GIR_RootConstrainSelectedInstOperands,
     /*  980158 */     // GIR_Coverage, 9114,
     /*  980158 */     GIR_EraseRootFromParent_Done,
     /*  980159 */   // Label 14652: @980159
     /*  980159 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(980254), // Rule ID 9115 //
     /*  980164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980214 */     // MIs[1] Operand 1
     /*  980214 */     // No operand predicates
     /*  980214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  980230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980252 */     GIR_RootConstrainSelectedInstOperands,
     /*  980253 */     // GIR_Coverage, 9115,
     /*  980253 */     GIR_EraseRootFromParent_Done,
     /*  980254 */   // Label 14653: @980254
     /*  980254 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(980349), // Rule ID 9118 //
     /*  980259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980309 */     // MIs[1] Operand 1
     /*  980309 */     // No operand predicates
     /*  980309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980347 */     GIR_RootConstrainSelectedInstOperands,
     /*  980348 */     // GIR_Coverage, 9118,
     /*  980348 */     GIR_EraseRootFromParent_Done,
     /*  980349 */   // Label 14654: @980349
     /*  980349 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(980444), // Rule ID 9119 //
     /*  980354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980404 */     // MIs[1] Operand 1
     /*  980404 */     // No operand predicates
     /*  980404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980442 */     GIR_RootConstrainSelectedInstOperands,
     /*  980443 */     // GIR_Coverage, 9119,
     /*  980443 */     GIR_EraseRootFromParent_Done,
     /*  980444 */   // Label 14655: @980444
     /*  980444 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(980539), // Rule ID 9122 //
     /*  980449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980499 */     // MIs[1] Operand 1
     /*  980499 */     // No operand predicates
     /*  980499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980537 */     GIR_RootConstrainSelectedInstOperands,
     /*  980538 */     // GIR_Coverage, 9122,
     /*  980538 */     GIR_EraseRootFromParent_Done,
     /*  980539 */   // Label 14656: @980539
     /*  980539 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(980634), // Rule ID 9123 //
     /*  980544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980594 */     // MIs[1] Operand 1
     /*  980594 */     // No operand predicates
     /*  980594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980632 */     GIR_RootConstrainSelectedInstOperands,
     /*  980633 */     // GIR_Coverage, 9123,
     /*  980633 */     GIR_EraseRootFromParent_Done,
     /*  980634 */   // Label 14657: @980634
     /*  980634 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(980729), // Rule ID 9126 //
     /*  980639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980689 */     // MIs[1] Operand 1
     /*  980689 */     // No operand predicates
     /*  980689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980727 */     GIR_RootConstrainSelectedInstOperands,
     /*  980728 */     // GIR_Coverage, 9126,
     /*  980728 */     GIR_EraseRootFromParent_Done,
     /*  980729 */   // Label 14658: @980729
     /*  980729 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(980824), // Rule ID 9127 //
     /*  980734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980784 */     // MIs[1] Operand 1
     /*  980784 */     // No operand predicates
     /*  980784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980797 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  980800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980822 */     GIR_RootConstrainSelectedInstOperands,
     /*  980823 */     // GIR_Coverage, 9127,
     /*  980823 */     GIR_EraseRootFromParent_Done,
     /*  980824 */   // Label 14659: @980824
     /*  980824 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(980919), // Rule ID 9130 //
     /*  980829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980879 */     // MIs[1] Operand 1
     /*  980879 */     // No operand predicates
     /*  980879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980917 */     GIR_RootConstrainSelectedInstOperands,
     /*  980918 */     // GIR_Coverage, 9130,
     /*  980918 */     GIR_EraseRootFromParent_Done,
     /*  980919 */   // Label 14660: @980919
     /*  980919 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(981014), // Rule ID 9131 //
     /*  980924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980974 */     // MIs[1] Operand 1
     /*  980974 */     // No operand predicates
     /*  980974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980987 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  980990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981012 */     GIR_RootConstrainSelectedInstOperands,
     /*  981013 */     // GIR_Coverage, 9131,
     /*  981013 */     GIR_EraseRootFromParent_Done,
     /*  981014 */   // Label 14661: @981014
     /*  981014 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(981109), // Rule ID 9134 //
     /*  981019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981069 */     // MIs[1] Operand 1
     /*  981069 */     // No operand predicates
     /*  981069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981082 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  981085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981107 */     GIR_RootConstrainSelectedInstOperands,
     /*  981108 */     // GIR_Coverage, 9134,
     /*  981108 */     GIR_EraseRootFromParent_Done,
     /*  981109 */   // Label 14662: @981109
     /*  981109 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(981204), // Rule ID 9135 //
     /*  981114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981164 */     // MIs[1] Operand 1
     /*  981164 */     // No operand predicates
     /*  981164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  981180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981202 */     GIR_RootConstrainSelectedInstOperands,
     /*  981203 */     // GIR_Coverage, 9135,
     /*  981203 */     GIR_EraseRootFromParent_Done,
     /*  981204 */   // Label 14663: @981204
     /*  981204 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(981299), // Rule ID 9138 //
     /*  981209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981259 */     // MIs[1] Operand 1
     /*  981259 */     // No operand predicates
     /*  981259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981297 */     GIR_RootConstrainSelectedInstOperands,
     /*  981298 */     // GIR_Coverage, 9138,
     /*  981298 */     GIR_EraseRootFromParent_Done,
     /*  981299 */   // Label 14664: @981299
     /*  981299 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(981394), // Rule ID 9139 //
     /*  981304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981354 */     // MIs[1] Operand 1
     /*  981354 */     // No operand predicates
     /*  981354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981392 */     GIR_RootConstrainSelectedInstOperands,
     /*  981393 */     // GIR_Coverage, 9139,
     /*  981393 */     GIR_EraseRootFromParent_Done,
     /*  981394 */   // Label 14665: @981394
     /*  981394 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(981489), // Rule ID 9142 //
     /*  981399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981449 */     // MIs[1] Operand 1
     /*  981449 */     // No operand predicates
     /*  981449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981487 */     GIR_RootConstrainSelectedInstOperands,
     /*  981488 */     // GIR_Coverage, 9142,
     /*  981488 */     GIR_EraseRootFromParent_Done,
     /*  981489 */   // Label 14666: @981489
     /*  981489 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(981584), // Rule ID 9143 //
     /*  981494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981544 */     // MIs[1] Operand 1
     /*  981544 */     // No operand predicates
     /*  981544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981557 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981582 */     GIR_RootConstrainSelectedInstOperands,
     /*  981583 */     // GIR_Coverage, 9143,
     /*  981583 */     GIR_EraseRootFromParent_Done,
     /*  981584 */   // Label 14667: @981584
     /*  981584 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(981679), // Rule ID 9146 //
     /*  981589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981639 */     // MIs[1] Operand 1
     /*  981639 */     // No operand predicates
     /*  981639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981677 */     GIR_RootConstrainSelectedInstOperands,
     /*  981678 */     // GIR_Coverage, 9146,
     /*  981678 */     GIR_EraseRootFromParent_Done,
     /*  981679 */   // Label 14668: @981679
     /*  981679 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(981774), // Rule ID 9147 //
     /*  981684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981734 */     // MIs[1] Operand 1
     /*  981734 */     // No operand predicates
     /*  981734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981772 */     GIR_RootConstrainSelectedInstOperands,
     /*  981773 */     // GIR_Coverage, 9147,
     /*  981773 */     GIR_EraseRootFromParent_Done,
     /*  981774 */   // Label 14669: @981774
     /*  981774 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(981869), // Rule ID 9150 //
     /*  981779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  981782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981829 */     // MIs[1] Operand 1
     /*  981829 */     // No operand predicates
     /*  981829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981842 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  981842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981867 */     GIR_RootConstrainSelectedInstOperands,
     /*  981868 */     // GIR_Coverage, 9150,
     /*  981868 */     GIR_EraseRootFromParent_Done,
     /*  981869 */   // Label 14670: @981869
     /*  981869 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(981964), // Rule ID 9151 //
     /*  981874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  981877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981924 */     // MIs[1] Operand 1
     /*  981924 */     // No operand predicates
     /*  981924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981937 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  981937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  981940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981962 */     GIR_RootConstrainSelectedInstOperands,
     /*  981963 */     // GIR_Coverage, 9151,
     /*  981963 */     GIR_EraseRootFromParent_Done,
     /*  981964 */   // Label 14671: @981964
     /*  981964 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(982059), // Rule ID 9154 //
     /*  981969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  981977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  981980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  981983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  981986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  981992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982019 */     // MIs[1] Operand 1
     /*  982019 */     // No operand predicates
     /*  982019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982057 */     GIR_RootConstrainSelectedInstOperands,
     /*  982058 */     // GIR_Coverage, 9154,
     /*  982058 */     GIR_EraseRootFromParent_Done,
     /*  982059 */   // Label 14672: @982059
     /*  982059 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(982154), // Rule ID 9155 //
     /*  982064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982114 */     // MIs[1] Operand 1
     /*  982114 */     // No operand predicates
     /*  982114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982127 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982152 */     GIR_RootConstrainSelectedInstOperands,
     /*  982153 */     // GIR_Coverage, 9155,
     /*  982153 */     GIR_EraseRootFromParent_Done,
     /*  982154 */   // Label 14673: @982154
     /*  982154 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(982249), // Rule ID 9158 //
     /*  982159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982209 */     // MIs[1] Operand 1
     /*  982209 */     // No operand predicates
     /*  982209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982222 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982247 */     GIR_RootConstrainSelectedInstOperands,
     /*  982248 */     // GIR_Coverage, 9158,
     /*  982248 */     GIR_EraseRootFromParent_Done,
     /*  982249 */   // Label 14674: @982249
     /*  982249 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(982344), // Rule ID 9159 //
     /*  982254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982304 */     // MIs[1] Operand 1
     /*  982304 */     // No operand predicates
     /*  982304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982317 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982342 */     GIR_RootConstrainSelectedInstOperands,
     /*  982343 */     // GIR_Coverage, 9159,
     /*  982343 */     GIR_EraseRootFromParent_Done,
     /*  982344 */   // Label 14675: @982344
     /*  982344 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(982439), // Rule ID 9162 //
     /*  982349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982399 */     // MIs[1] Operand 1
     /*  982399 */     // No operand predicates
     /*  982399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982412 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982437 */     GIR_RootConstrainSelectedInstOperands,
     /*  982438 */     // GIR_Coverage, 9162,
     /*  982438 */     GIR_EraseRootFromParent_Done,
     /*  982439 */   // Label 14676: @982439
     /*  982439 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(982534), // Rule ID 9163 //
     /*  982444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982494 */     // MIs[1] Operand 1
     /*  982494 */     // No operand predicates
     /*  982494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982507 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982532 */     GIR_RootConstrainSelectedInstOperands,
     /*  982533 */     // GIR_Coverage, 9163,
     /*  982533 */     GIR_EraseRootFromParent_Done,
     /*  982534 */   // Label 14677: @982534
     /*  982534 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(982629), // Rule ID 9166 //
     /*  982539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982589 */     // MIs[1] Operand 1
     /*  982589 */     // No operand predicates
     /*  982589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982602 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982627 */     GIR_RootConstrainSelectedInstOperands,
     /*  982628 */     // GIR_Coverage, 9166,
     /*  982628 */     GIR_EraseRootFromParent_Done,
     /*  982629 */   // Label 14678: @982629
     /*  982629 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(982724), // Rule ID 9167 //
     /*  982634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982684 */     // MIs[1] Operand 1
     /*  982684 */     // No operand predicates
     /*  982684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  982700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982722 */     GIR_RootConstrainSelectedInstOperands,
     /*  982723 */     // GIR_Coverage, 9167,
     /*  982723 */     GIR_EraseRootFromParent_Done,
     /*  982724 */   // Label 14679: @982724
     /*  982724 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(982819), // Rule ID 9170 //
     /*  982729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982779 */     // MIs[1] Operand 1
     /*  982779 */     // No operand predicates
     /*  982779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982792 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982817 */     GIR_RootConstrainSelectedInstOperands,
     /*  982818 */     // GIR_Coverage, 9170,
     /*  982818 */     GIR_EraseRootFromParent_Done,
     /*  982819 */   // Label 14680: @982819
     /*  982819 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(982914), // Rule ID 9171 //
     /*  982824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982874 */     // MIs[1] Operand 1
     /*  982874 */     // No operand predicates
     /*  982874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982887 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  982890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982912 */     GIR_RootConstrainSelectedInstOperands,
     /*  982913 */     // GIR_Coverage, 9171,
     /*  982913 */     GIR_EraseRootFromParent_Done,
     /*  982914 */   // Label 14681: @982914
     /*  982914 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(983009), // Rule ID 9174 //
     /*  982919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  982927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982969 */     // MIs[1] Operand 1
     /*  982969 */     // No operand predicates
     /*  982969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982982 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  982985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983007 */     GIR_RootConstrainSelectedInstOperands,
     /*  983008 */     // GIR_Coverage, 9174,
     /*  983008 */     GIR_EraseRootFromParent_Done,
     /*  983009 */   // Label 14682: @983009
     /*  983009 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(983104), // Rule ID 9175 //
     /*  983014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983064 */     // MIs[1] Operand 1
     /*  983064 */     // No operand predicates
     /*  983064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983077 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983102 */     GIR_RootConstrainSelectedInstOperands,
     /*  983103 */     // GIR_Coverage, 9175,
     /*  983103 */     GIR_EraseRootFromParent_Done,
     /*  983104 */   // Label 14683: @983104
     /*  983104 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(983199), // Rule ID 9178 //
     /*  983109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983159 */     // MIs[1] Operand 1
     /*  983159 */     // No operand predicates
     /*  983159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983197 */     GIR_RootConstrainSelectedInstOperands,
     /*  983198 */     // GIR_Coverage, 9178,
     /*  983198 */     GIR_EraseRootFromParent_Done,
     /*  983199 */   // Label 14684: @983199
     /*  983199 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(983294), // Rule ID 9179 //
     /*  983204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983254 */     // MIs[1] Operand 1
     /*  983254 */     // No operand predicates
     /*  983254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983292 */     GIR_RootConstrainSelectedInstOperands,
     /*  983293 */     // GIR_Coverage, 9179,
     /*  983293 */     GIR_EraseRootFromParent_Done,
     /*  983294 */   // Label 14685: @983294
     /*  983294 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(983389), // Rule ID 9182 //
     /*  983299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983349 */     // MIs[1] Operand 1
     /*  983349 */     // No operand predicates
     /*  983349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983387 */     GIR_RootConstrainSelectedInstOperands,
     /*  983388 */     // GIR_Coverage, 9182,
     /*  983388 */     GIR_EraseRootFromParent_Done,
     /*  983389 */   // Label 14686: @983389
     /*  983389 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(983484), // Rule ID 9183 //
     /*  983394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983444 */     // MIs[1] Operand 1
     /*  983444 */     // No operand predicates
     /*  983444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983457 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983482 */     GIR_RootConstrainSelectedInstOperands,
     /*  983483 */     // GIR_Coverage, 9183,
     /*  983483 */     GIR_EraseRootFromParent_Done,
     /*  983484 */   // Label 14687: @983484
     /*  983484 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(983579), // Rule ID 9186 //
     /*  983489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983539 */     // MIs[1] Operand 1
     /*  983539 */     // No operand predicates
     /*  983539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983577 */     GIR_RootConstrainSelectedInstOperands,
     /*  983578 */     // GIR_Coverage, 9186,
     /*  983578 */     GIR_EraseRootFromParent_Done,
     /*  983579 */   // Label 14688: @983579
     /*  983579 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(983674), // Rule ID 9187 //
     /*  983584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983634 */     // MIs[1] Operand 1
     /*  983634 */     // No operand predicates
     /*  983634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983647 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  983650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983672 */     GIR_RootConstrainSelectedInstOperands,
     /*  983673 */     // GIR_Coverage, 9187,
     /*  983673 */     GIR_EraseRootFromParent_Done,
     /*  983674 */   // Label 14689: @983674
     /*  983674 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(983769), // Rule ID 9190 //
     /*  983679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983729 */     // MIs[1] Operand 1
     /*  983729 */     // No operand predicates
     /*  983729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983767 */     GIR_RootConstrainSelectedInstOperands,
     /*  983768 */     // GIR_Coverage, 9190,
     /*  983768 */     GIR_EraseRootFromParent_Done,
     /*  983769 */   // Label 14690: @983769
     /*  983769 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(983864), // Rule ID 9191 //
     /*  983774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983824 */     // MIs[1] Operand 1
     /*  983824 */     // No operand predicates
     /*  983824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983837 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  983837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  983840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983862 */     GIR_RootConstrainSelectedInstOperands,
     /*  983863 */     // GIR_Coverage, 9191,
     /*  983863 */     GIR_EraseRootFromParent_Done,
     /*  983864 */   // Label 14691: @983864
     /*  983864 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(983959), // Rule ID 9194 //
     /*  983869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983919 */     // MIs[1] Operand 1
     /*  983919 */     // No operand predicates
     /*  983919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  983935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983957 */     GIR_RootConstrainSelectedInstOperands,
     /*  983958 */     // GIR_Coverage, 9194,
     /*  983958 */     GIR_EraseRootFromParent_Done,
     /*  983959 */   // Label 14692: @983959
     /*  983959 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(984054), // Rule ID 9195 //
     /*  983964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  983972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984014 */     // MIs[1] Operand 1
     /*  984014 */     // No operand predicates
     /*  984014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984027 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  984030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984052 */     GIR_RootConstrainSelectedInstOperands,
     /*  984053 */     // GIR_Coverage, 9195,
     /*  984053 */     GIR_EraseRootFromParent_Done,
     /*  984054 */   // Label 14693: @984054
     /*  984054 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(984149), // Rule ID 9198 //
     /*  984059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  984067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984109 */     // MIs[1] Operand 1
     /*  984109 */     // No operand predicates
     /*  984109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  984125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984147 */     GIR_RootConstrainSelectedInstOperands,
     /*  984148 */     // GIR_Coverage, 9198,
     /*  984148 */     GIR_EraseRootFromParent_Done,
     /*  984149 */   // Label 14694: @984149
     /*  984149 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(984244), // Rule ID 9199 //
     /*  984154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  984162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984204 */     // MIs[1] Operand 1
     /*  984204 */     // No operand predicates
     /*  984204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  984220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984242 */     GIR_RootConstrainSelectedInstOperands,
     /*  984243 */     // GIR_Coverage, 9199,
     /*  984243 */     GIR_EraseRootFromParent_Done,
     /*  984244 */   // Label 14695: @984244
     /*  984244 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(984339), // Rule ID 9290 //
     /*  984249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984299 */     // MIs[1] Operand 1
     /*  984299 */     // No operand predicates
     /*  984299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  984315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984337 */     GIR_RootConstrainSelectedInstOperands,
     /*  984338 */     // GIR_Coverage, 9290,
     /*  984338 */     GIR_EraseRootFromParent_Done,
     /*  984339 */   // Label 14696: @984339
     /*  984339 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(984434), // Rule ID 9291 //
     /*  984344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984394 */     // MIs[1] Operand 1
     /*  984394 */     // No operand predicates
     /*  984394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  984410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984432 */     GIR_RootConstrainSelectedInstOperands,
     /*  984433 */     // GIR_Coverage, 9291,
     /*  984433 */     GIR_EraseRootFromParent_Done,
     /*  984434 */   // Label 14697: @984434
     /*  984434 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(984529), // Rule ID 9294 //
     /*  984439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984489 */     // MIs[1] Operand 1
     /*  984489 */     // No operand predicates
     /*  984489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984527 */     GIR_RootConstrainSelectedInstOperands,
     /*  984528 */     // GIR_Coverage, 9294,
     /*  984528 */     GIR_EraseRootFromParent_Done,
     /*  984529 */   // Label 14698: @984529
     /*  984529 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(984624), // Rule ID 9295 //
     /*  984534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984584 */     // MIs[1] Operand 1
     /*  984584 */     // No operand predicates
     /*  984584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984622 */     GIR_RootConstrainSelectedInstOperands,
     /*  984623 */     // GIR_Coverage, 9295,
     /*  984623 */     GIR_EraseRootFromParent_Done,
     /*  984624 */   // Label 14699: @984624
     /*  984624 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(984719), // Rule ID 9298 //
     /*  984629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984679 */     // MIs[1] Operand 1
     /*  984679 */     // No operand predicates
     /*  984679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  984695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984717 */     GIR_RootConstrainSelectedInstOperands,
     /*  984718 */     // GIR_Coverage, 9298,
     /*  984718 */     GIR_EraseRootFromParent_Done,
     /*  984719 */   // Label 14700: @984719
     /*  984719 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(984814), // Rule ID 9299 //
     /*  984724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984774 */     // MIs[1] Operand 1
     /*  984774 */     // No operand predicates
     /*  984774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984787 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  984790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984812 */     GIR_RootConstrainSelectedInstOperands,
     /*  984813 */     // GIR_Coverage, 9299,
     /*  984813 */     GIR_EraseRootFromParent_Done,
     /*  984814 */   // Label 14701: @984814
     /*  984814 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(984909), // Rule ID 9302 //
     /*  984819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984869 */     // MIs[1] Operand 1
     /*  984869 */     // No operand predicates
     /*  984869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  984882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984907 */     GIR_RootConstrainSelectedInstOperands,
     /*  984908 */     // GIR_Coverage, 9302,
     /*  984908 */     GIR_EraseRootFromParent_Done,
     /*  984909 */   // Label 14702: @984909
     /*  984909 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(985004), // Rule ID 9303 //
     /*  984914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984964 */     // MIs[1] Operand 1
     /*  984964 */     // No operand predicates
     /*  984964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984977 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  984977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  984980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985002 */     GIR_RootConstrainSelectedInstOperands,
     /*  985003 */     // GIR_Coverage, 9303,
     /*  985003 */     GIR_EraseRootFromParent_Done,
     /*  985004 */   // Label 14703: @985004
     /*  985004 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(985099), // Rule ID 9306 //
     /*  985009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985059 */     // MIs[1] Operand 1
     /*  985059 */     // No operand predicates
     /*  985059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985097 */     GIR_RootConstrainSelectedInstOperands,
     /*  985098 */     // GIR_Coverage, 9306,
     /*  985098 */     GIR_EraseRootFromParent_Done,
     /*  985099 */   // Label 14704: @985099
     /*  985099 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(985194), // Rule ID 9307 //
     /*  985104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985154 */     // MIs[1] Operand 1
     /*  985154 */     // No operand predicates
     /*  985154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985167 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985192 */     GIR_RootConstrainSelectedInstOperands,
     /*  985193 */     // GIR_Coverage, 9307,
     /*  985193 */     GIR_EraseRootFromParent_Done,
     /*  985194 */   // Label 14705: @985194
     /*  985194 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(985289), // Rule ID 9310 //
     /*  985199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985249 */     // MIs[1] Operand 1
     /*  985249 */     // No operand predicates
     /*  985249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985287 */     GIR_RootConstrainSelectedInstOperands,
     /*  985288 */     // GIR_Coverage, 9310,
     /*  985288 */     GIR_EraseRootFromParent_Done,
     /*  985289 */   // Label 14706: @985289
     /*  985289 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(985384), // Rule ID 9311 //
     /*  985294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985344 */     // MIs[1] Operand 1
     /*  985344 */     // No operand predicates
     /*  985344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985357 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  985360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985382 */     GIR_RootConstrainSelectedInstOperands,
     /*  985383 */     // GIR_Coverage, 9311,
     /*  985383 */     GIR_EraseRootFromParent_Done,
     /*  985384 */   // Label 14707: @985384
     /*  985384 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(985479), // Rule ID 9314 //
     /*  985389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985439 */     // MIs[1] Operand 1
     /*  985439 */     // No operand predicates
     /*  985439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985477 */     GIR_RootConstrainSelectedInstOperands,
     /*  985478 */     // GIR_Coverage, 9314,
     /*  985478 */     GIR_EraseRootFromParent_Done,
     /*  985479 */   // Label 14708: @985479
     /*  985479 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(985574), // Rule ID 9315 //
     /*  985484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985534 */     // MIs[1] Operand 1
     /*  985534 */     // No operand predicates
     /*  985534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985572 */     GIR_RootConstrainSelectedInstOperands,
     /*  985573 */     // GIR_Coverage, 9315,
     /*  985573 */     GIR_EraseRootFromParent_Done,
     /*  985574 */   // Label 14709: @985574
     /*  985574 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(985669), // Rule ID 9318 //
     /*  985579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985629 */     // MIs[1] Operand 1
     /*  985629 */     // No operand predicates
     /*  985629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985667 */     GIR_RootConstrainSelectedInstOperands,
     /*  985668 */     // GIR_Coverage, 9318,
     /*  985668 */     GIR_EraseRootFromParent_Done,
     /*  985669 */   // Label 14710: @985669
     /*  985669 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(985764), // Rule ID 9319 //
     /*  985674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985724 */     // MIs[1] Operand 1
     /*  985724 */     // No operand predicates
     /*  985724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985737 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985762 */     GIR_RootConstrainSelectedInstOperands,
     /*  985763 */     // GIR_Coverage, 9319,
     /*  985763 */     GIR_EraseRootFromParent_Done,
     /*  985764 */   // Label 14711: @985764
     /*  985764 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(985859), // Rule ID 9322 //
     /*  985769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985819 */     // MIs[1] Operand 1
     /*  985819 */     // No operand predicates
     /*  985819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985857 */     GIR_RootConstrainSelectedInstOperands,
     /*  985858 */     // GIR_Coverage, 9322,
     /*  985858 */     GIR_EraseRootFromParent_Done,
     /*  985859 */   // Label 14712: @985859
     /*  985859 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(985954), // Rule ID 9323 //
     /*  985864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985914 */     // MIs[1] Operand 1
     /*  985914 */     // No operand predicates
     /*  985914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  985930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985952 */     GIR_RootConstrainSelectedInstOperands,
     /*  985953 */     // GIR_Coverage, 9323,
     /*  985953 */     GIR_EraseRootFromParent_Done,
     /*  985954 */   // Label 14713: @985954
     /*  985954 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(986049), // Rule ID 9326 //
     /*  985959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  985962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  985967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986009 */     // MIs[1] Operand 1
     /*  986009 */     // No operand predicates
     /*  986009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  986025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986047 */     GIR_RootConstrainSelectedInstOperands,
     /*  986048 */     // GIR_Coverage, 9326,
     /*  986048 */     GIR_EraseRootFromParent_Done,
     /*  986049 */   // Label 14714: @986049
     /*  986049 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(986144), // Rule ID 9327 //
     /*  986054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986104 */     // MIs[1] Operand 1
     /*  986104 */     // No operand predicates
     /*  986104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986117 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  986120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986142 */     GIR_RootConstrainSelectedInstOperands,
     /*  986143 */     // GIR_Coverage, 9327,
     /*  986143 */     GIR_EraseRootFromParent_Done,
     /*  986144 */   // Label 14715: @986144
     /*  986144 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(986239), // Rule ID 9330 //
     /*  986149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986199 */     // MIs[1] Operand 1
     /*  986199 */     // No operand predicates
     /*  986199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986237 */     GIR_RootConstrainSelectedInstOperands,
     /*  986238 */     // GIR_Coverage, 9330,
     /*  986238 */     GIR_EraseRootFromParent_Done,
     /*  986239 */   // Label 14716: @986239
     /*  986239 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(986334), // Rule ID 9331 //
     /*  986244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986294 */     // MIs[1] Operand 1
     /*  986294 */     // No operand predicates
     /*  986294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986307 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986332 */     GIR_RootConstrainSelectedInstOperands,
     /*  986333 */     // GIR_Coverage, 9331,
     /*  986333 */     GIR_EraseRootFromParent_Done,
     /*  986334 */   // Label 14717: @986334
     /*  986334 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(986429), // Rule ID 9334 //
     /*  986339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986389 */     // MIs[1] Operand 1
     /*  986389 */     // No operand predicates
     /*  986389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986427 */     GIR_RootConstrainSelectedInstOperands,
     /*  986428 */     // GIR_Coverage, 9334,
     /*  986428 */     GIR_EraseRootFromParent_Done,
     /*  986429 */   // Label 14718: @986429
     /*  986429 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(986524), // Rule ID 9335 //
     /*  986434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986484 */     // MIs[1] Operand 1
     /*  986484 */     // No operand predicates
     /*  986484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986497 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986522 */     GIR_RootConstrainSelectedInstOperands,
     /*  986523 */     // GIR_Coverage, 9335,
     /*  986523 */     GIR_EraseRootFromParent_Done,
     /*  986524 */   // Label 14719: @986524
     /*  986524 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(986619), // Rule ID 9338 //
     /*  986529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986579 */     // MIs[1] Operand 1
     /*  986579 */     // No operand predicates
     /*  986579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986592 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  986595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986617 */     GIR_RootConstrainSelectedInstOperands,
     /*  986618 */     // GIR_Coverage, 9338,
     /*  986618 */     GIR_EraseRootFromParent_Done,
     /*  986619 */   // Label 14720: @986619
     /*  986619 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(986714), // Rule ID 9339 //
     /*  986624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986674 */     // MIs[1] Operand 1
     /*  986674 */     // No operand predicates
     /*  986674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986687 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  986690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986712 */     GIR_RootConstrainSelectedInstOperands,
     /*  986713 */     // GIR_Coverage, 9339,
     /*  986713 */     GIR_EraseRootFromParent_Done,
     /*  986714 */   // Label 14721: @986714
     /*  986714 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(986809), // Rule ID 9342 //
     /*  986719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986769 */     // MIs[1] Operand 1
     /*  986769 */     // No operand predicates
     /*  986769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986807 */     GIR_RootConstrainSelectedInstOperands,
     /*  986808 */     // GIR_Coverage, 9342,
     /*  986808 */     GIR_EraseRootFromParent_Done,
     /*  986809 */   // Label 14722: @986809
     /*  986809 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(986904), // Rule ID 9343 //
     /*  986814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986864 */     // MIs[1] Operand 1
     /*  986864 */     // No operand predicates
     /*  986864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986877 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  986880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986902 */     GIR_RootConstrainSelectedInstOperands,
     /*  986903 */     // GIR_Coverage, 9343,
     /*  986903 */     GIR_EraseRootFromParent_Done,
     /*  986904 */   // Label 14723: @986904
     /*  986904 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(986999), // Rule ID 9346 //
     /*  986909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  986917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986959 */     // MIs[1] Operand 1
     /*  986959 */     // No operand predicates
     /*  986959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  986975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986997 */     GIR_RootConstrainSelectedInstOperands,
     /*  986998 */     // GIR_Coverage, 9346,
     /*  986998 */     GIR_EraseRootFromParent_Done,
     /*  986999 */   // Label 14724: @986999
     /*  986999 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(987094), // Rule ID 9347 //
     /*  987004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987054 */     // MIs[1] Operand 1
     /*  987054 */     // No operand predicates
     /*  987054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987092 */     GIR_RootConstrainSelectedInstOperands,
     /*  987093 */     // GIR_Coverage, 9347,
     /*  987093 */     GIR_EraseRootFromParent_Done,
     /*  987094 */   // Label 14725: @987094
     /*  987094 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(987189), // Rule ID 9350 //
     /*  987099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987149 */     // MIs[1] Operand 1
     /*  987149 */     // No operand predicates
     /*  987149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987187 */     GIR_RootConstrainSelectedInstOperands,
     /*  987188 */     // GIR_Coverage, 9350,
     /*  987188 */     GIR_EraseRootFromParent_Done,
     /*  987189 */   // Label 14726: @987189
     /*  987189 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(987284), // Rule ID 9351 //
     /*  987194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987244 */     // MIs[1] Operand 1
     /*  987244 */     // No operand predicates
     /*  987244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987257 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987282 */     GIR_RootConstrainSelectedInstOperands,
     /*  987283 */     // GIR_Coverage, 9351,
     /*  987283 */     GIR_EraseRootFromParent_Done,
     /*  987284 */   // Label 14727: @987284
     /*  987284 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(987379), // Rule ID 9354 //
     /*  987289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987339 */     // MIs[1] Operand 1
     /*  987339 */     // No operand predicates
     /*  987339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987377 */     GIR_RootConstrainSelectedInstOperands,
     /*  987378 */     // GIR_Coverage, 9354,
     /*  987378 */     GIR_EraseRootFromParent_Done,
     /*  987379 */   // Label 14728: @987379
     /*  987379 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(987474), // Rule ID 9355 //
     /*  987384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987434 */     // MIs[1] Operand 1
     /*  987434 */     // No operand predicates
     /*  987434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987447 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987472 */     GIR_RootConstrainSelectedInstOperands,
     /*  987473 */     // GIR_Coverage, 9355,
     /*  987473 */     GIR_EraseRootFromParent_Done,
     /*  987474 */   // Label 14729: @987474
     /*  987474 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(987569), // Rule ID 9358 //
     /*  987479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987529 */     // MIs[1] Operand 1
     /*  987529 */     // No operand predicates
     /*  987529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987567 */     GIR_RootConstrainSelectedInstOperands,
     /*  987568 */     // GIR_Coverage, 9358,
     /*  987568 */     GIR_EraseRootFromParent_Done,
     /*  987569 */   // Label 14730: @987569
     /*  987569 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(987664), // Rule ID 9359 //
     /*  987574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987624 */     // MIs[1] Operand 1
     /*  987624 */     // No operand predicates
     /*  987624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  987640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987662 */     GIR_RootConstrainSelectedInstOperands,
     /*  987663 */     // GIR_Coverage, 9359,
     /*  987663 */     GIR_EraseRootFromParent_Done,
     /*  987664 */   // Label 14731: @987664
     /*  987664 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(987759), // Rule ID 9362 //
     /*  987669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987719 */     // MIs[1] Operand 1
     /*  987719 */     // No operand predicates
     /*  987719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987757 */     GIR_RootConstrainSelectedInstOperands,
     /*  987758 */     // GIR_Coverage, 9362,
     /*  987758 */     GIR_EraseRootFromParent_Done,
     /*  987759 */   // Label 14732: @987759
     /*  987759 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(987854), // Rule ID 9363 //
     /*  987764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987814 */     // MIs[1] Operand 1
     /*  987814 */     // No operand predicates
     /*  987814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  987830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987852 */     GIR_RootConstrainSelectedInstOperands,
     /*  987853 */     // GIR_Coverage, 9363,
     /*  987853 */     GIR_EraseRootFromParent_Done,
     /*  987854 */   // Label 14733: @987854
     /*  987854 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(987949), // Rule ID 9366 //
     /*  987859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  987862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987909 */     // MIs[1] Operand 1
     /*  987909 */     // No operand predicates
     /*  987909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  987922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  987925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987947 */     GIR_RootConstrainSelectedInstOperands,
     /*  987948 */     // GIR_Coverage, 9366,
     /*  987948 */     GIR_EraseRootFromParent_Done,
     /*  987949 */   // Label 14734: @987949
     /*  987949 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(988044), // Rule ID 9367 //
     /*  987954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  987962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988004 */     // MIs[1] Operand 1
     /*  988004 */     // No operand predicates
     /*  988004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988017 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  988020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988042 */     GIR_RootConstrainSelectedInstOperands,
     /*  988043 */     // GIR_Coverage, 9367,
     /*  988043 */     GIR_EraseRootFromParent_Done,
     /*  988044 */   // Label 14735: @988044
     /*  988044 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(988139), // Rule ID 9370 //
     /*  988049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988099 */     // MIs[1] Operand 1
     /*  988099 */     // No operand predicates
     /*  988099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  988115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988137 */     GIR_RootConstrainSelectedInstOperands,
     /*  988138 */     // GIR_Coverage, 9370,
     /*  988138 */     GIR_EraseRootFromParent_Done,
     /*  988139 */   // Label 14736: @988139
     /*  988139 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(988234), // Rule ID 9371 //
     /*  988144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988194 */     // MIs[1] Operand 1
     /*  988194 */     // No operand predicates
     /*  988194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  988210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988232 */     GIR_RootConstrainSelectedInstOperands,
     /*  988233 */     // GIR_Coverage, 9371,
     /*  988233 */     GIR_EraseRootFromParent_Done,
     /*  988234 */   // Label 14737: @988234
     /*  988234 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(988329), // Rule ID 9374 //
     /*  988239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988289 */     // MIs[1] Operand 1
     /*  988289 */     // No operand predicates
     /*  988289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  988305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988327 */     GIR_RootConstrainSelectedInstOperands,
     /*  988328 */     // GIR_Coverage, 9374,
     /*  988328 */     GIR_EraseRootFromParent_Done,
     /*  988329 */   // Label 14738: @988329
     /*  988329 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(988424), // Rule ID 9375 //
     /*  988334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  988342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988384 */     // MIs[1] Operand 1
     /*  988384 */     // No operand predicates
     /*  988384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  988400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988422 */     GIR_RootConstrainSelectedInstOperands,
     /*  988423 */     // GIR_Coverage, 9375,
     /*  988423 */     GIR_EraseRootFromParent_Done,
     /*  988424 */   // Label 14739: @988424
     /*  988424 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(988519), // Rule ID 9466 //
     /*  988429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  988440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  988443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988479 */     // MIs[1] Operand 1
     /*  988479 */     // No operand predicates
     /*  988479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  988495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988517 */     GIR_RootConstrainSelectedInstOperands,
     /*  988518 */     // GIR_Coverage, 9466,
     /*  988518 */     GIR_EraseRootFromParent_Done,
     /*  988519 */   // Label 14740: @988519
     /*  988519 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(988614), // Rule ID 9467 //
     /*  988524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  988535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  988538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988574 */     // MIs[1] Operand 1
     /*  988574 */     // No operand predicates
     /*  988574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988587 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  988590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988612 */     GIR_RootConstrainSelectedInstOperands,
     /*  988613 */     // GIR_Coverage, 9467,
     /*  988613 */     GIR_EraseRootFromParent_Done,
     /*  988614 */   // Label 14741: @988614
     /*  988614 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(988709), // Rule ID 9470 //
     /*  988619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988669 */     // MIs[1] Operand 1
     /*  988669 */     // No operand predicates
     /*  988669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  988685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988707 */     GIR_RootConstrainSelectedInstOperands,
     /*  988708 */     // GIR_Coverage, 9470,
     /*  988708 */     GIR_EraseRootFromParent_Done,
     /*  988709 */   // Label 14742: @988709
     /*  988709 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(988804), // Rule ID 9471 //
     /*  988714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988764 */     // MIs[1] Operand 1
     /*  988764 */     // No operand predicates
     /*  988764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  988780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988802 */     GIR_RootConstrainSelectedInstOperands,
     /*  988803 */     // GIR_Coverage, 9471,
     /*  988803 */     GIR_EraseRootFromParent_Done,
     /*  988804 */   // Label 14743: @988804
     /*  988804 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(988899), // Rule ID 9474 //
     /*  988809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988859 */     // MIs[1] Operand 1
     /*  988859 */     // No operand predicates
     /*  988859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  988872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  988875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988897 */     GIR_RootConstrainSelectedInstOperands,
     /*  988898 */     // GIR_Coverage, 9474,
     /*  988898 */     GIR_EraseRootFromParent_Done,
     /*  988899 */   // Label 14744: @988899
     /*  988899 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(988994), // Rule ID 9475 //
     /*  988904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988954 */     // MIs[1] Operand 1
     /*  988954 */     // No operand predicates
     /*  988954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988967 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  988967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  988970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988992 */     GIR_RootConstrainSelectedInstOperands,
     /*  988993 */     // GIR_Coverage, 9475,
     /*  988993 */     GIR_EraseRootFromParent_Done,
     /*  988994 */   // Label 14745: @988994
     /*  988994 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(989089), // Rule ID 9478 //
     /*  988999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989049 */     // MIs[1] Operand 1
     /*  989049 */     // No operand predicates
     /*  989049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  989065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989087 */     GIR_RootConstrainSelectedInstOperands,
     /*  989088 */     // GIR_Coverage, 9478,
     /*  989088 */     GIR_EraseRootFromParent_Done,
     /*  989089 */   // Label 14746: @989089
     /*  989089 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(989184), // Rule ID 9479 //
     /*  989094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989144 */     // MIs[1] Operand 1
     /*  989144 */     // No operand predicates
     /*  989144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989157 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  989160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989182 */     GIR_RootConstrainSelectedInstOperands,
     /*  989183 */     // GIR_Coverage, 9479,
     /*  989183 */     GIR_EraseRootFromParent_Done,
     /*  989184 */   // Label 14747: @989184
     /*  989184 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(989279), // Rule ID 9482 //
     /*  989189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989239 */     // MIs[1] Operand 1
     /*  989239 */     // No operand predicates
     /*  989239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989277 */     GIR_RootConstrainSelectedInstOperands,
     /*  989278 */     // GIR_Coverage, 9482,
     /*  989278 */     GIR_EraseRootFromParent_Done,
     /*  989279 */   // Label 14748: @989279
     /*  989279 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(989374), // Rule ID 9483 //
     /*  989284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989334 */     // MIs[1] Operand 1
     /*  989334 */     // No operand predicates
     /*  989334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989372 */     GIR_RootConstrainSelectedInstOperands,
     /*  989373 */     // GIR_Coverage, 9483,
     /*  989373 */     GIR_EraseRootFromParent_Done,
     /*  989374 */   // Label 14749: @989374
     /*  989374 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(989469), // Rule ID 9486 //
     /*  989379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989429 */     // MIs[1] Operand 1
     /*  989429 */     // No operand predicates
     /*  989429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989442 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  989442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989467 */     GIR_RootConstrainSelectedInstOperands,
     /*  989468 */     // GIR_Coverage, 9486,
     /*  989468 */     GIR_EraseRootFromParent_Done,
     /*  989469 */   // Label 14750: @989469
     /*  989469 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(989564), // Rule ID 9487 //
     /*  989474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  989485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  989488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989524 */     // MIs[1] Operand 1
     /*  989524 */     // No operand predicates
     /*  989524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989537 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  989537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  989540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989562 */     GIR_RootConstrainSelectedInstOperands,
     /*  989563 */     // GIR_Coverage, 9487,
     /*  989563 */     GIR_EraseRootFromParent_Done,
     /*  989564 */   // Label 14751: @989564
     /*  989564 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(989659), // Rule ID 9490 //
     /*  989569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989619 */     // MIs[1] Operand 1
     /*  989619 */     // No operand predicates
     /*  989619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  989632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989657 */     GIR_RootConstrainSelectedInstOperands,
     /*  989658 */     // GIR_Coverage, 9490,
     /*  989658 */     GIR_EraseRootFromParent_Done,
     /*  989659 */   // Label 14752: @989659
     /*  989659 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(989754), // Rule ID 9491 //
     /*  989664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  989675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  989678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989714 */     // MIs[1] Operand 1
     /*  989714 */     // No operand predicates
     /*  989714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  989727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989752 */     GIR_RootConstrainSelectedInstOperands,
     /*  989753 */     // GIR_Coverage, 9491,
     /*  989753 */     GIR_EraseRootFromParent_Done,
     /*  989754 */   // Label 14753: @989754
     /*  989754 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(989849), // Rule ID 9494 //
     /*  989759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  989770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  989773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989809 */     // MIs[1] Operand 1
     /*  989809 */     // No operand predicates
     /*  989809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  989822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989847 */     GIR_RootConstrainSelectedInstOperands,
     /*  989848 */     // GIR_Coverage, 9494,
     /*  989848 */     GIR_EraseRootFromParent_Done,
     /*  989849 */   // Label 14754: @989849
     /*  989849 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(989944), // Rule ID 9495 //
     /*  989854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  989865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  989868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989904 */     // MIs[1] Operand 1
     /*  989904 */     // No operand predicates
     /*  989904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989917 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  989917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  989920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  989942 */     GIR_RootConstrainSelectedInstOperands,
     /*  989943 */     // GIR_Coverage, 9495,
     /*  989943 */     GIR_EraseRootFromParent_Done,
     /*  989944 */   // Label 14755: @989944
     /*  989944 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(990039), // Rule ID 9498 //
     /*  989949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  989957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  989960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  989963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  989966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989999 */     // MIs[1] Operand 1
     /*  989999 */     // No operand predicates
     /*  989999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  990012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990037 */     GIR_RootConstrainSelectedInstOperands,
     /*  990038 */     // GIR_Coverage, 9498,
     /*  990038 */     GIR_EraseRootFromParent_Done,
     /*  990039 */   // Label 14756: @990039
     /*  990039 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(990134), // Rule ID 9499 //
     /*  990044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  990055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  990058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990094 */     // MIs[1] Operand 1
     /*  990094 */     // No operand predicates
     /*  990094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  990107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990132 */     GIR_RootConstrainSelectedInstOperands,
     /*  990133 */     // GIR_Coverage, 9499,
     /*  990133 */     GIR_EraseRootFromParent_Done,
     /*  990134 */   // Label 14757: @990134
     /*  990134 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(990229), // Rule ID 9502 //
     /*  990139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  990150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  990153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990189 */     // MIs[1] Operand 1
     /*  990189 */     // No operand predicates
     /*  990189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  990202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990227 */     GIR_RootConstrainSelectedInstOperands,
     /*  990228 */     // GIR_Coverage, 9502,
     /*  990228 */     GIR_EraseRootFromParent_Done,
     /*  990229 */   // Label 14758: @990229
     /*  990229 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(990324), // Rule ID 9503 //
     /*  990234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  990245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  990248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990284 */     // MIs[1] Operand 1
     /*  990284 */     // No operand predicates
     /*  990284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990297 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  990297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  990300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990322 */     GIR_RootConstrainSelectedInstOperands,
     /*  990323 */     // GIR_Coverage, 9503,
     /*  990323 */     GIR_EraseRootFromParent_Done,
     /*  990324 */   // Label 14759: @990324
     /*  990324 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(990419), // Rule ID 9506 //
     /*  990329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  990340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  990343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990379 */     // MIs[1] Operand 1
     /*  990379 */     // No operand predicates
     /*  990379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990417 */     GIR_RootConstrainSelectedInstOperands,
     /*  990418 */     // GIR_Coverage, 9506,
     /*  990418 */     GIR_EraseRootFromParent_Done,
     /*  990419 */   // Label 14760: @990419
     /*  990419 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(990514), // Rule ID 9507 //
     /*  990424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  990435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  990438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990474 */     // MIs[1] Operand 1
     /*  990474 */     // No operand predicates
     /*  990474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990512 */     GIR_RootConstrainSelectedInstOperands,
     /*  990513 */     // GIR_Coverage, 9507,
     /*  990513 */     GIR_EraseRootFromParent_Done,
     /*  990514 */   // Label 14761: @990514
     /*  990514 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(990609), // Rule ID 9510 //
     /*  990519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  990530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  990533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990569 */     // MIs[1] Operand 1
     /*  990569 */     // No operand predicates
     /*  990569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  990585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990607 */     GIR_RootConstrainSelectedInstOperands,
     /*  990608 */     // GIR_Coverage, 9510,
     /*  990608 */     GIR_EraseRootFromParent_Done,
     /*  990609 */   // Label 14762: @990609
     /*  990609 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(990704), // Rule ID 9511 //
     /*  990614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  990625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  990628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990664 */     // MIs[1] Operand 1
     /*  990664 */     // No operand predicates
     /*  990664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990677 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  990680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990702 */     GIR_RootConstrainSelectedInstOperands,
     /*  990703 */     // GIR_Coverage, 9511,
     /*  990703 */     GIR_EraseRootFromParent_Done,
     /*  990704 */   // Label 14763: @990704
     /*  990704 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(990799), // Rule ID 9514 //
     /*  990709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  990720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  990723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990759 */     // MIs[1] Operand 1
     /*  990759 */     // No operand predicates
     /*  990759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990772 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  990772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  990775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990797 */     GIR_RootConstrainSelectedInstOperands,
     /*  990798 */     // GIR_Coverage, 9514,
     /*  990798 */     GIR_EraseRootFromParent_Done,
     /*  990799 */   // Label 14764: @990799
     /*  990799 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(990894), // Rule ID 9515 //
     /*  990804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  990815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  990818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990854 */     // MIs[1] Operand 1
     /*  990854 */     // No operand predicates
     /*  990854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990867 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  990867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  990870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990892 */     GIR_RootConstrainSelectedInstOperands,
     /*  990893 */     // GIR_Coverage, 9515,
     /*  990893 */     GIR_EraseRootFromParent_Done,
     /*  990894 */   // Label 14765: @990894
     /*  990894 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(990989), // Rule ID 9518 //
     /*  990899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  990907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  990910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  990913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990949 */     // MIs[1] Operand 1
     /*  990949 */     // No operand predicates
     /*  990949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  990962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  990965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  990987 */     GIR_RootConstrainSelectedInstOperands,
     /*  990988 */     // GIR_Coverage, 9518,
     /*  990988 */     GIR_EraseRootFromParent_Done,
     /*  990989 */   // Label 14766: @990989
     /*  990989 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(991084), // Rule ID 9519 //
     /*  990994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991044 */     // MIs[1] Operand 1
     /*  991044 */     // No operand predicates
     /*  991044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991082 */     GIR_RootConstrainSelectedInstOperands,
     /*  991083 */     // GIR_Coverage, 9519,
     /*  991083 */     GIR_EraseRootFromParent_Done,
     /*  991084 */   // Label 14767: @991084
     /*  991084 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(991179), // Rule ID 9522 //
     /*  991089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991139 */     // MIs[1] Operand 1
     /*  991139 */     // No operand predicates
     /*  991139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  991152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991177 */     GIR_RootConstrainSelectedInstOperands,
     /*  991178 */     // GIR_Coverage, 9522,
     /*  991178 */     GIR_EraseRootFromParent_Done,
     /*  991179 */   // Label 14768: @991179
     /*  991179 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(991274), // Rule ID 9523 //
     /*  991184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991234 */     // MIs[1] Operand 1
     /*  991234 */     // No operand predicates
     /*  991234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991272 */     GIR_RootConstrainSelectedInstOperands,
     /*  991273 */     // GIR_Coverage, 9523,
     /*  991273 */     GIR_EraseRootFromParent_Done,
     /*  991274 */   // Label 14769: @991274
     /*  991274 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(991369), // Rule ID 9526 //
     /*  991279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  991290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  991293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991329 */     // MIs[1] Operand 1
     /*  991329 */     // No operand predicates
     /*  991329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991342 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  991342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991367 */     GIR_RootConstrainSelectedInstOperands,
     /*  991368 */     // GIR_Coverage, 9526,
     /*  991368 */     GIR_EraseRootFromParent_Done,
     /*  991369 */   // Label 14770: @991369
     /*  991369 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(991464), // Rule ID 9527 //
     /*  991374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  991385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  991388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991424 */     // MIs[1] Operand 1
     /*  991424 */     // No operand predicates
     /*  991424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991437 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  991437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991462 */     GIR_RootConstrainSelectedInstOperands,
     /*  991463 */     // GIR_Coverage, 9527,
     /*  991463 */     GIR_EraseRootFromParent_Done,
     /*  991464 */   // Label 14771: @991464
     /*  991464 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(991559), // Rule ID 9530 //
     /*  991469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  991480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  991483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991519 */     // MIs[1] Operand 1
     /*  991519 */     // No operand predicates
     /*  991519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991557 */     GIR_RootConstrainSelectedInstOperands,
     /*  991558 */     // GIR_Coverage, 9530,
     /*  991558 */     GIR_EraseRootFromParent_Done,
     /*  991559 */   // Label 14772: @991559
     /*  991559 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(991654), // Rule ID 9531 //
     /*  991564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  991575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  991578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991614 */     // MIs[1] Operand 1
     /*  991614 */     // No operand predicates
     /*  991614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991627 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  991627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  991630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991652 */     GIR_RootConstrainSelectedInstOperands,
     /*  991653 */     // GIR_Coverage, 9531,
     /*  991653 */     GIR_EraseRootFromParent_Done,
     /*  991654 */   // Label 14773: @991654
     /*  991654 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(991749), // Rule ID 9534 //
     /*  991659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991709 */     // MIs[1] Operand 1
     /*  991709 */     // No operand predicates
     /*  991709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991722 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991747 */     GIR_RootConstrainSelectedInstOperands,
     /*  991748 */     // GIR_Coverage, 9534,
     /*  991748 */     GIR_EraseRootFromParent_Done,
     /*  991749 */   // Label 14774: @991749
     /*  991749 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(991844), // Rule ID 9535 //
     /*  991754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  991765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  991768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991804 */     // MIs[1] Operand 1
     /*  991804 */     // No operand predicates
     /*  991804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  991817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  991820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991842 */     GIR_RootConstrainSelectedInstOperands,
     /*  991843 */     // GIR_Coverage, 9535,
     /*  991843 */     GIR_EraseRootFromParent_Done,
     /*  991844 */   // Label 14775: @991844
     /*  991844 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(991939), // Rule ID 9538 //
     /*  991849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991899 */     // MIs[1] Operand 1
     /*  991899 */     // No operand predicates
     /*  991899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  991912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  991915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  991937 */     GIR_RootConstrainSelectedInstOperands,
     /*  991938 */     // GIR_Coverage, 9538,
     /*  991938 */     GIR_EraseRootFromParent_Done,
     /*  991939 */   // Label 14776: @991939
     /*  991939 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(992034), // Rule ID 9539 //
     /*  991944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  991952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  991955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  991958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  991978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991994 */     // MIs[1] Operand 1
     /*  991994 */     // No operand predicates
     /*  991994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  992007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992032 */     GIR_RootConstrainSelectedInstOperands,
     /*  992033 */     // GIR_Coverage, 9539,
     /*  992033 */     GIR_EraseRootFromParent_Done,
     /*  992034 */   // Label 14777: @992034
     /*  992034 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(992129), // Rule ID 9542 //
     /*  992039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  992050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  992053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992089 */     // MIs[1] Operand 1
     /*  992089 */     // No operand predicates
     /*  992089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992102 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  992105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992127 */     GIR_RootConstrainSelectedInstOperands,
     /*  992128 */     // GIR_Coverage, 9542,
     /*  992128 */     GIR_EraseRootFromParent_Done,
     /*  992129 */   // Label 14778: @992129
     /*  992129 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(992224), // Rule ID 9543 //
     /*  992134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  992145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  992148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992184 */     // MIs[1] Operand 1
     /*  992184 */     // No operand predicates
     /*  992184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992197 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  992200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992222 */     GIR_RootConstrainSelectedInstOperands,
     /*  992223 */     // GIR_Coverage, 9543,
     /*  992223 */     GIR_EraseRootFromParent_Done,
     /*  992224 */   // Label 14779: @992224
     /*  992224 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(992319), // Rule ID 9546 //
     /*  992229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  992240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  992243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992279 */     // MIs[1] Operand 1
     /*  992279 */     // No operand predicates
     /*  992279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  992295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992317 */     GIR_RootConstrainSelectedInstOperands,
     /*  992318 */     // GIR_Coverage, 9546,
     /*  992318 */     GIR_EraseRootFromParent_Done,
     /*  992319 */   // Label 14780: @992319
     /*  992319 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(992414), // Rule ID 9547 //
     /*  992324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  992335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  992338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992374 */     // MIs[1] Operand 1
     /*  992374 */     // No operand predicates
     /*  992374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992387 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  992390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992412 */     GIR_RootConstrainSelectedInstOperands,
     /*  992413 */     // GIR_Coverage, 9547,
     /*  992413 */     GIR_EraseRootFromParent_Done,
     /*  992414 */   // Label 14781: @992414
     /*  992414 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(992509), // Rule ID 9550 //
     /*  992419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  992430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  992433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992469 */     // MIs[1] Operand 1
     /*  992469 */     // No operand predicates
     /*  992469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  992482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992507 */     GIR_RootConstrainSelectedInstOperands,
     /*  992508 */     // GIR_Coverage, 9550,
     /*  992508 */     GIR_EraseRootFromParent_Done,
     /*  992509 */   // Label 14782: @992509
     /*  992509 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(992604), // Rule ID 9551 //
     /*  992514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  992522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  992525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  992528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992564 */     // MIs[1] Operand 1
     /*  992564 */     // No operand predicates
     /*  992564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992577 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  992577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  992580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  992602 */     GIR_RootConstrainSelectedInstOperands,
     /*  992603 */     // GIR_Coverage, 9551,
     /*  992603 */     GIR_EraseRootFromParent_Done,
     /*  992604 */   // Label 14783: @992604
     /*  992604 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(992696), // Rule ID 13928 //
     /*  992609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  992632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992659 */     // MIs[1] Operand 1
     /*  992659 */     // No operand predicates
     /*  992659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992672 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  992672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  992675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992694 */     GIR_RootConstrainSelectedInstOperands,
     /*  992695 */     // GIR_Coverage, 13928,
     /*  992695 */     GIR_EraseRootFromParent_Done,
     /*  992696 */   // Label 14784: @992696
     /*  992696 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(992788), // Rule ID 13929 //
     /*  992701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  992712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  992715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  992718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  992724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992751 */     // MIs[1] Operand 1
     /*  992751 */     // No operand predicates
     /*  992751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  992764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  992767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992786 */     GIR_RootConstrainSelectedInstOperands,
     /*  992787 */     // GIR_Coverage, 13929,
     /*  992787 */     GIR_EraseRootFromParent_Done,
     /*  992788 */   // Label 14785: @992788
     /*  992788 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(992880), // Rule ID 13930 //
     /*  992793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992843 */     // MIs[1] Operand 1
     /*  992843 */     // No operand predicates
     /*  992843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  992856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  992859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992878 */     GIR_RootConstrainSelectedInstOperands,
     /*  992879 */     // GIR_Coverage, 13930,
     /*  992879 */     GIR_EraseRootFromParent_Done,
     /*  992880 */   // Label 14786: @992880
     /*  992880 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(992972), // Rule ID 13931 //
     /*  992885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  992896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  992899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  992902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  992915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992935 */     // MIs[1] Operand 1
     /*  992935 */     // No operand predicates
     /*  992935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992948 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  992948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  992951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  992970 */     GIR_RootConstrainSelectedInstOperands,
     /*  992971 */     // GIR_Coverage, 13931,
     /*  992971 */     GIR_EraseRootFromParent_Done,
     /*  992972 */   // Label 14787: @992972
     /*  992972 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(993064), // Rule ID 13932 //
     /*  992977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  992988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  992991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  992994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993027 */     // MIs[1] Operand 1
     /*  993027 */     // No operand predicates
     /*  993027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  993040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993062 */     GIR_RootConstrainSelectedInstOperands,
     /*  993063 */     // GIR_Coverage, 13932,
     /*  993063 */     GIR_EraseRootFromParent_Done,
     /*  993064 */   // Label 14788: @993064
     /*  993064 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(993156), // Rule ID 13933 //
     /*  993069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  993080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  993083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  993086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993119 */     // MIs[1] Operand 1
     /*  993119 */     // No operand predicates
     /*  993119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  993132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993154 */     GIR_RootConstrainSelectedInstOperands,
     /*  993155 */     // GIR_Coverage, 13933,
     /*  993155 */     GIR_EraseRootFromParent_Done,
     /*  993156 */   // Label 14789: @993156
     /*  993156 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(993248), // Rule ID 13934 //
     /*  993161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  993172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  993175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  993178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993211 */     // MIs[1] Operand 1
     /*  993211 */     // No operand predicates
     /*  993211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  993227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993246 */     GIR_RootConstrainSelectedInstOperands,
     /*  993247 */     // GIR_Coverage, 13934,
     /*  993247 */     GIR_EraseRootFromParent_Done,
     /*  993248 */   // Label 14790: @993248
     /*  993248 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(993340), // Rule ID 13935 //
     /*  993253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  993264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  993267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  993270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993303 */     // MIs[1] Operand 1
     /*  993303 */     // No operand predicates
     /*  993303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  993316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  993319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993338 */     GIR_RootConstrainSelectedInstOperands,
     /*  993339 */     // GIR_Coverage, 13935,
     /*  993339 */     GIR_EraseRootFromParent_Done,
     /*  993340 */   // Label 14791: @993340
     /*  993340 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(993432), // Rule ID 13936 //
     /*  993345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  993356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  993359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  993362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  993368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993395 */     // MIs[1] Operand 1
     /*  993395 */     // No operand predicates
     /*  993395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993430 */     GIR_RootConstrainSelectedInstOperands,
     /*  993431 */     // GIR_Coverage, 13936,
     /*  993431 */     GIR_EraseRootFromParent_Done,
     /*  993432 */   // Label 14792: @993432
     /*  993432 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(993524), // Rule ID 13937 //
     /*  993437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  993448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  993451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  993454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  993460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993487 */     // MIs[1] Operand 1
     /*  993487 */     // No operand predicates
     /*  993487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  993500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993522 */     GIR_RootConstrainSelectedInstOperands,
     /*  993523 */     // GIR_Coverage, 13937,
     /*  993523 */     GIR_EraseRootFromParent_Done,
     /*  993524 */   // Label 14793: @993524
     /*  993524 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(993616), // Rule ID 13938 //
     /*  993529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  993546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993579 */     // MIs[1] Operand 1
     /*  993579 */     // No operand predicates
     /*  993579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  993592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993614 */     GIR_RootConstrainSelectedInstOperands,
     /*  993615 */     // GIR_Coverage, 13938,
     /*  993615 */     GIR_EraseRootFromParent_Done,
     /*  993616 */   // Label 14794: @993616
     /*  993616 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(993708), // Rule ID 13939 //
     /*  993621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  993638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  993644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993671 */     // MIs[1] Operand 1
     /*  993671 */     // No operand predicates
     /*  993671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  993684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  993687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993706 */     GIR_RootConstrainSelectedInstOperands,
     /*  993707 */     // GIR_Coverage, 13939,
     /*  993707 */     GIR_EraseRootFromParent_Done,
     /*  993708 */   // Label 14795: @993708
     /*  993708 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(993800), // Rule ID 13940 //
     /*  993713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  993724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  993727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  993730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993763 */     // MIs[1] Operand 1
     /*  993763 */     // No operand predicates
     /*  993763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  993776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993798 */     GIR_RootConstrainSelectedInstOperands,
     /*  993799 */     // GIR_Coverage, 13940,
     /*  993799 */     GIR_EraseRootFromParent_Done,
     /*  993800 */   // Label 14796: @993800
     /*  993800 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(993892), // Rule ID 13941 //
     /*  993805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  993816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  993819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  993822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  993825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  993828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993855 */     // MIs[1] Operand 1
     /*  993855 */     // No operand predicates
     /*  993855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  993868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  993890 */     GIR_RootConstrainSelectedInstOperands,
     /*  993891 */     // GIR_Coverage, 13941,
     /*  993891 */     GIR_EraseRootFromParent_Done,
     /*  993892 */   // Label 14797: @993892
     /*  993892 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(993984), // Rule ID 13942 //
     /*  993897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  993900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  993908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  993911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  993914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  993917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  993920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  993927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  993939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  993943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  993947 */     // MIs[1] Operand 1
     /*  993947 */     // No operand predicates
     /*  993947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  993951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  993960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  993963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  993969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  993972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  993974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993982 */     GIR_RootConstrainSelectedInstOperands,
     /*  993983 */     // GIR_Coverage, 13942,
     /*  993983 */     GIR_EraseRootFromParent_Done,
     /*  993984 */   // Label 14798: @993984
     /*  993984 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(994076), // Rule ID 13943 //
     /*  993989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  993992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  993997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  994000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  994003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  994006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  994012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994039 */     // MIs[1] Operand 1
     /*  994039 */     // No operand predicates
     /*  994039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  994052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994074 */     GIR_RootConstrainSelectedInstOperands,
     /*  994075 */     // GIR_Coverage, 13943,
     /*  994075 */     GIR_EraseRootFromParent_Done,
     /*  994076 */   // Label 14799: @994076
     /*  994076 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(994168), // Rule ID 13944 //
     /*  994081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  994098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  994104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994131 */     // MIs[1] Operand 1
     /*  994131 */     // No operand predicates
     /*  994131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  994144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994166 */     GIR_RootConstrainSelectedInstOperands,
     /*  994167 */     // GIR_Coverage, 13944,
     /*  994167 */     GIR_EraseRootFromParent_Done,
     /*  994168 */   // Label 14800: @994168
     /*  994168 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(994260), // Rule ID 13945 //
     /*  994173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  994190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  994196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994223 */     // MIs[1] Operand 1
     /*  994223 */     // No operand predicates
     /*  994223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  994236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994258 */     GIR_RootConstrainSelectedInstOperands,
     /*  994259 */     // GIR_Coverage, 13945,
     /*  994259 */     GIR_EraseRootFromParent_Done,
     /*  994260 */   // Label 14801: @994260
     /*  994260 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(994352), // Rule ID 13946 //
     /*  994265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  994268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  994282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  994288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994315 */     // MIs[1] Operand 1
     /*  994315 */     // No operand predicates
     /*  994315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  994328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  994350 */     GIR_RootConstrainSelectedInstOperands,
     /*  994351 */     // GIR_Coverage, 13946,
     /*  994351 */     GIR_EraseRootFromParent_Done,
     /*  994352 */   // Label 14802: @994352
     /*  994352 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(994444), // Rule ID 13947 //
     /*  994357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  994360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  994374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  994380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  994387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994407 */     // MIs[1] Operand 1
     /*  994407 */     // No operand predicates
     /*  994407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  994420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  994423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  994442 */     GIR_RootConstrainSelectedInstOperands,
     /*  994443 */     // GIR_Coverage, 13947,
     /*  994443 */     GIR_EraseRootFromParent_Done,
     /*  994444 */   // Label 14803: @994444
     /*  994444 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(994536), // Rule ID 13948 //
     /*  994449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  994460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  994463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  994466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  994472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994499 */     // MIs[1] Operand 1
     /*  994499 */     // No operand predicates
     /*  994499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  994515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994534 */     GIR_RootConstrainSelectedInstOperands,
     /*  994535 */     // GIR_Coverage, 13948,
     /*  994535 */     GIR_EraseRootFromParent_Done,
     /*  994536 */   // Label 14804: @994536
     /*  994536 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(994628), // Rule ID 13949 //
     /*  994541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  994552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  994555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  994558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  994564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  994571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994591 */     // MIs[1] Operand 1
     /*  994591 */     // No operand predicates
     /*  994591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  994607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994626 */     GIR_RootConstrainSelectedInstOperands,
     /*  994627 */     // GIR_Coverage, 13949,
     /*  994627 */     GIR_EraseRootFromParent_Done,
     /*  994628 */   // Label 14805: @994628
     /*  994628 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(994720), // Rule ID 13950 //
     /*  994633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  994644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  994647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  994650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  994656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994683 */     // MIs[1] Operand 1
     /*  994683 */     // No operand predicates
     /*  994683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  994699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994718 */     GIR_RootConstrainSelectedInstOperands,
     /*  994719 */     // GIR_Coverage, 13950,
     /*  994719 */     GIR_EraseRootFromParent_Done,
     /*  994720 */   // Label 14806: @994720
     /*  994720 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(994812), // Rule ID 13951 //
     /*  994725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  994736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  994739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  994742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  994748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  994755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994775 */     // MIs[1] Operand 1
     /*  994775 */     // No operand predicates
     /*  994775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994788 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  994791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994810 */     GIR_RootConstrainSelectedInstOperands,
     /*  994811 */     // GIR_Coverage, 13951,
     /*  994811 */     GIR_EraseRootFromParent_Done,
     /*  994812 */   // Label 14807: @994812
     /*  994812 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(994904), // Rule ID 13952 //
     /*  994817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  994820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  994828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  994831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  994834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  994837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  994840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994867 */     // MIs[1] Operand 1
     /*  994867 */     // No operand predicates
     /*  994867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994880 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  994880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  994883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994902 */     GIR_RootConstrainSelectedInstOperands,
     /*  994903 */     // GIR_Coverage, 13952,
     /*  994903 */     GIR_EraseRootFromParent_Done,
     /*  994904 */   // Label 14808: @994904
     /*  994904 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(994996), // Rule ID 13953 //
     /*  994909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  994912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  994917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  994920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  994923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  994926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  994929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  994932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  994939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  994951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  994955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  994959 */     // MIs[1] Operand 1
     /*  994959 */     // No operand predicates
     /*  994959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  994963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  994965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  994972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  994975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  994981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  994984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  994986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  994994 */     GIR_RootConstrainSelectedInstOperands,
     /*  994995 */     // GIR_Coverage, 13953,
     /*  994995 */     GIR_EraseRootFromParent_Done,
     /*  994996 */   // Label 14809: @994996
     /*  994996 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(995088), // Rule ID 13954 //
     /*  995001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  995012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  995015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  995018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995051 */     // MIs[1] Operand 1
     /*  995051 */     // No operand predicates
     /*  995051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995086 */     GIR_RootConstrainSelectedInstOperands,
     /*  995087 */     // GIR_Coverage, 13954,
     /*  995087 */     GIR_EraseRootFromParent_Done,
     /*  995088 */   // Label 14810: @995088
     /*  995088 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(995180), // Rule ID 13955 //
     /*  995093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  995104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  995107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  995110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995143 */     // MIs[1] Operand 1
     /*  995143 */     // No operand predicates
     /*  995143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995178 */     GIR_RootConstrainSelectedInstOperands,
     /*  995179 */     // GIR_Coverage, 13955,
     /*  995179 */     GIR_EraseRootFromParent_Done,
     /*  995180 */   // Label 14811: @995180
     /*  995180 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(995272), // Rule ID 13956 //
     /*  995185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  995196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  995199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  995202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995235 */     // MIs[1] Operand 1
     /*  995235 */     // No operand predicates
     /*  995235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995270 */     GIR_RootConstrainSelectedInstOperands,
     /*  995271 */     // GIR_Coverage, 13956,
     /*  995271 */     GIR_EraseRootFromParent_Done,
     /*  995272 */   // Label 14812: @995272
     /*  995272 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(995364), // Rule ID 13957 //
     /*  995277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  995288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  995291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  995294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995327 */     // MIs[1] Operand 1
     /*  995327 */     // No operand predicates
     /*  995327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995362 */     GIR_RootConstrainSelectedInstOperands,
     /*  995363 */     // GIR_Coverage, 13957,
     /*  995363 */     GIR_EraseRootFromParent_Done,
     /*  995364 */   // Label 14813: @995364
     /*  995364 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(995456), // Rule ID 13958 //
     /*  995369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  995380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  995383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  995386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  995392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995419 */     // MIs[1] Operand 1
     /*  995419 */     // No operand predicates
     /*  995419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  995432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995454 */     GIR_RootConstrainSelectedInstOperands,
     /*  995455 */     // GIR_Coverage, 13958,
     /*  995455 */     GIR_EraseRootFromParent_Done,
     /*  995456 */   // Label 14814: @995456
     /*  995456 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(995548), // Rule ID 13959 //
     /*  995461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  995472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  995475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  995478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  995484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995511 */     // MIs[1] Operand 1
     /*  995511 */     // No operand predicates
     /*  995511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  995524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995546 */     GIR_RootConstrainSelectedInstOperands,
     /*  995547 */     // GIR_Coverage, 13959,
     /*  995547 */     GIR_EraseRootFromParent_Done,
     /*  995548 */   // Label 14815: @995548
     /*  995548 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(995640), // Rule ID 13960 //
     /*  995553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  995570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  995576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995603 */     // MIs[1] Operand 1
     /*  995603 */     // No operand predicates
     /*  995603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995638 */     GIR_RootConstrainSelectedInstOperands,
     /*  995639 */     // GIR_Coverage, 13960,
     /*  995639 */     GIR_EraseRootFromParent_Done,
     /*  995640 */   // Label 14816: @995640
     /*  995640 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(995732), // Rule ID 13961 //
     /*  995645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  995656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  995659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  995662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  995668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  995675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995695 */     // MIs[1] Operand 1
     /*  995695 */     // No operand predicates
     /*  995695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  995708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  995711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995730 */     GIR_RootConstrainSelectedInstOperands,
     /*  995731 */     // GIR_Coverage, 13961,
     /*  995731 */     GIR_EraseRootFromParent_Done,
     /*  995732 */   // Label 14817: @995732
     /*  995732 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(995824), // Rule ID 13962 //
     /*  995737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  995754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995787 */     // MIs[1] Operand 1
     /*  995787 */     // No operand predicates
     /*  995787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995822 */     GIR_RootConstrainSelectedInstOperands,
     /*  995823 */     // GIR_Coverage, 13962,
     /*  995823 */     GIR_EraseRootFromParent_Done,
     /*  995824 */   // Label 14818: @995824
     /*  995824 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(995916), // Rule ID 13963 //
     /*  995829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  995840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  995843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  995846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  995849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  995852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  995859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995879 */     // MIs[1] Operand 1
     /*  995879 */     // No operand predicates
     /*  995879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  995892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  995895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995914 */     GIR_RootConstrainSelectedInstOperands,
     /*  995915 */     // GIR_Coverage, 13963,
     /*  995915 */     GIR_EraseRootFromParent_Done,
     /*  995916 */   // Label 14819: @995916
     /*  995916 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(996008), // Rule ID 13964 //
     /*  995921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  995929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  995932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  995935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  995938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  995941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  995944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  995951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  995963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  995967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  995971 */     // MIs[1] Operand 1
     /*  995971 */     // No operand predicates
     /*  995971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  995977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  995984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  995987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  995996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  995998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996006 */     GIR_RootConstrainSelectedInstOperands,
     /*  996007 */     // GIR_Coverage, 13964,
     /*  996007 */     GIR_EraseRootFromParent_Done,
     /*  996008 */   // Label 14820: @996008
     /*  996008 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(996100), // Rule ID 13965 //
     /*  996013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  996024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  996027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  996030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  996036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996063 */     // MIs[1] Operand 1
     /*  996063 */     // No operand predicates
     /*  996063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  996076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996098 */     GIR_RootConstrainSelectedInstOperands,
     /*  996099 */     // GIR_Coverage, 13965,
     /*  996099 */     GIR_EraseRootFromParent_Done,
     /*  996100 */   // Label 14821: @996100
     /*  996100 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(996192), // Rule ID 13966 //
     /*  996105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  996116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  996119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  996122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  996128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996155 */     // MIs[1] Operand 1
     /*  996155 */     // No operand predicates
     /*  996155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  996171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996190 */     GIR_RootConstrainSelectedInstOperands,
     /*  996191 */     // GIR_Coverage, 13966,
     /*  996191 */     GIR_EraseRootFromParent_Done,
     /*  996192 */   // Label 14822: @996192
     /*  996192 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(996284), // Rule ID 13967 //
     /*  996197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  996208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  996211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  996214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  996220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996247 */     // MIs[1] Operand 1
     /*  996247 */     // No operand predicates
     /*  996247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  996263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996282 */     GIR_RootConstrainSelectedInstOperands,
     /*  996283 */     // GIR_Coverage, 13967,
     /*  996283 */     GIR_EraseRootFromParent_Done,
     /*  996284 */   // Label 14823: @996284
     /*  996284 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(996376), // Rule ID 13968 //
     /*  996289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  996300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  996303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  996306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  996312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996339 */     // MIs[1] Operand 1
     /*  996339 */     // No operand predicates
     /*  996339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  996355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996374 */     GIR_RootConstrainSelectedInstOperands,
     /*  996375 */     // GIR_Coverage, 13968,
     /*  996375 */     GIR_EraseRootFromParent_Done,
     /*  996376 */   // Label 14824: @996376
     /*  996376 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(996468), // Rule ID 13969 //
     /*  996381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  996392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  996395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  996398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  996404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996431 */     // MIs[1] Operand 1
     /*  996431 */     // No operand predicates
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  996447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996466 */     GIR_RootConstrainSelectedInstOperands,
     /*  996467 */     // GIR_Coverage, 13969,
     /*  996467 */     GIR_EraseRootFromParent_Done,
     /*  996468 */   // Label 14825: @996468
     /*  996468 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(996560), // Rule ID 13970 //
     /*  996473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  996476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  996484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  996487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  996490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  996493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  996496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996523 */     // MIs[1] Operand 1
     /*  996523 */     // No operand predicates
     /*  996523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  996536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996558 */     GIR_RootConstrainSelectedInstOperands,
     /*  996559 */     // GIR_Coverage, 13970,
     /*  996559 */     GIR_EraseRootFromParent_Done,
     /*  996560 */   // Label 14826: @996560
     /*  996560 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(996652), // Rule ID 13971 //
     /*  996565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  996568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  996573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  996576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  996579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  996582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  996585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  996588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  996607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  996611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  996615 */     // MIs[1] Operand 1
     /*  996615 */     // No operand predicates
     /*  996615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  996621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  996628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  996631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  996640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  996642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  996650 */     GIR_RootConstrainSelectedInstOperands,
     /*  996651 */     // GIR_Coverage, 13971,
     /*  996651 */     GIR_EraseRootFromParent_Done,
     /*  996652 */   // Label 14827: @996652
     /*  996652 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(996728), // Rule ID 2758 //
     /*  996657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  996674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996685 */     // MIs[0] passthru
     /*  996685 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996694 */     // MIs[0] round
     /*  996694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  996704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  996707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996726 */     GIR_RootConstrainSelectedInstOperands,
     /*  996727 */     // GIR_Coverage, 2758,
     /*  996727 */     GIR_EraseRootFromParent_Done,
     /*  996728 */   // Label 14828: @996728
     /*  996728 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(996804), // Rule ID 2759 //
     /*  996733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  996736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  996750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996761 */     // MIs[0] passthru
     /*  996761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996770 */     // MIs[0] round
     /*  996770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996780 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  996780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  996783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996802 */     GIR_RootConstrainSelectedInstOperands,
     /*  996803 */     // GIR_Coverage, 2759,
     /*  996803 */     GIR_EraseRootFromParent_Done,
     /*  996804 */   // Label 14829: @996804
     /*  996804 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(996880), // Rule ID 17138 //
     /*  996809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  996826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996837 */     // MIs[0] passthru
     /*  996837 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996846 */     // MIs[0] round
     /*  996846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  996856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  996859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996878 */     GIR_RootConstrainSelectedInstOperands,
     /*  996879 */     // GIR_Coverage, 17138,
     /*  996879 */     GIR_EraseRootFromParent_Done,
     /*  996880 */   // Label 14830: @996880
     /*  996880 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(996956), // Rule ID 17139 //
     /*  996885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  996888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  996902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  996905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996913 */     // MIs[0] passthru
     /*  996913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996922 */     // MIs[0] round
     /*  996922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  996925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996932 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  996932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  996935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  996943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  996954 */     GIR_RootConstrainSelectedInstOperands,
     /*  996955 */     // GIR_Coverage, 17139,
     /*  996955 */     GIR_EraseRootFromParent_Done,
     /*  996956 */   // Label 14831: @996956
     /*  996956 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(997032), // Rule ID 17148 //
     /*  996961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  996964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  996969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  996972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  996975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  996978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  996981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996989 */     // MIs[0] passthru
     /*  996989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  996994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996998 */     // MIs[0] round
     /*  996998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997008 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  997011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997030 */     GIR_RootConstrainSelectedInstOperands,
     /*  997031 */     // GIR_Coverage, 17148,
     /*  997031 */     GIR_EraseRootFromParent_Done,
     /*  997032 */   // Label 14832: @997032
     /*  997032 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(997108), // Rule ID 17149 //
     /*  997037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  997054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997065 */     // MIs[0] passthru
     /*  997065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997074 */     // MIs[0] round
     /*  997074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  997087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997106 */     GIR_RootConstrainSelectedInstOperands,
     /*  997107 */     // GIR_Coverage, 17149,
     /*  997107 */     GIR_EraseRootFromParent_Done,
     /*  997108 */   // Label 14833: @997108
     /*  997108 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(997184), // Rule ID 17158 //
     /*  997113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  997116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  997130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997141 */     // MIs[0] passthru
     /*  997141 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997150 */     // MIs[0] round
     /*  997150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997160 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  997163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997182 */     GIR_RootConstrainSelectedInstOperands,
     /*  997183 */     // GIR_Coverage, 17158,
     /*  997183 */     GIR_EraseRootFromParent_Done,
     /*  997184 */   // Label 14834: @997184
     /*  997184 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(997260), // Rule ID 17159 //
     /*  997189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  997206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997217 */     // MIs[0] passthru
     /*  997217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997226 */     // MIs[0] round
     /*  997226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  997239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997258 */     GIR_RootConstrainSelectedInstOperands,
     /*  997259 */     // GIR_Coverage, 17159,
     /*  997259 */     GIR_EraseRootFromParent_Done,
     /*  997260 */   // Label 14835: @997260
     /*  997260 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(997336), // Rule ID 17168 //
     /*  997265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  997268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  997282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997293 */     // MIs[0] passthru
     /*  997293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997302 */     // MIs[0] round
     /*  997302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  997312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  997315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997334 */     GIR_RootConstrainSelectedInstOperands,
     /*  997335 */     // GIR_Coverage, 17168,
     /*  997335 */     GIR_EraseRootFromParent_Done,
     /*  997336 */   // Label 14836: @997336
     /*  997336 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(997412), // Rule ID 17169 //
     /*  997341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  997344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  997358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997369 */     // MIs[0] passthru
     /*  997369 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997378 */     // MIs[0] round
     /*  997378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997388 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  997388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  997391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997410 */     GIR_RootConstrainSelectedInstOperands,
     /*  997411 */     // GIR_Coverage, 17169,
     /*  997411 */     GIR_EraseRootFromParent_Done,
     /*  997412 */   // Label 14837: @997412
     /*  997412 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(997488), // Rule ID 17178 //
     /*  997417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  997434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997445 */     // MIs[0] passthru
     /*  997445 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997454 */     // MIs[0] round
     /*  997454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  997467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997486 */     GIR_RootConstrainSelectedInstOperands,
     /*  997487 */     // GIR_Coverage, 17178,
     /*  997487 */     GIR_EraseRootFromParent_Done,
     /*  997488 */   // Label 14838: @997488
     /*  997488 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(997564), // Rule ID 17179 //
     /*  997493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  997510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997521 */     // MIs[0] passthru
     /*  997521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997530 */     // MIs[0] round
     /*  997530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  997543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997562 */     GIR_RootConstrainSelectedInstOperands,
     /*  997563 */     // GIR_Coverage, 17179,
     /*  997563 */     GIR_EraseRootFromParent_Done,
     /*  997564 */   // Label 14839: @997564
     /*  997564 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(997640), // Rule ID 17188 //
     /*  997569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  997586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997597 */     // MIs[0] passthru
     /*  997597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997606 */     // MIs[0] round
     /*  997606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  997619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997638 */     GIR_RootConstrainSelectedInstOperands,
     /*  997639 */     // GIR_Coverage, 17188,
     /*  997639 */     GIR_EraseRootFromParent_Done,
     /*  997640 */   // Label 14840: @997640
     /*  997640 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(997716), // Rule ID 17189 //
     /*  997645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  997662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997673 */     // MIs[0] passthru
     /*  997673 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997682 */     // MIs[0] round
     /*  997682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997692 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  997695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997714 */     GIR_RootConstrainSelectedInstOperands,
     /*  997715 */     // GIR_Coverage, 17189,
     /*  997715 */     GIR_EraseRootFromParent_Done,
     /*  997716 */   // Label 14841: @997716
     /*  997716 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(997792), // Rule ID 17198 //
     /*  997721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  997738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997749 */     // MIs[0] passthru
     /*  997749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997758 */     // MIs[0] round
     /*  997758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997768 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  997771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997790 */     GIR_RootConstrainSelectedInstOperands,
     /*  997791 */     // GIR_Coverage, 17198,
     /*  997791 */     GIR_EraseRootFromParent_Done,
     /*  997792 */   // Label 14842: @997792
     /*  997792 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(997868), // Rule ID 17199 //
     /*  997797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  997814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997825 */     // MIs[0] passthru
     /*  997825 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997834 */     // MIs[0] round
     /*  997834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997844 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  997847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997866 */     GIR_RootConstrainSelectedInstOperands,
     /*  997867 */     // GIR_Coverage, 17199,
     /*  997867 */     GIR_EraseRootFromParent_Done,
     /*  997868 */   // Label 14843: @997868
     /*  997868 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(997944), // Rule ID 17208 //
     /*  997873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  997876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  997890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  997893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997901 */     // MIs[0] passthru
     /*  997901 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997910 */     // MIs[0] round
     /*  997910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997920 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  997920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  997923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  997929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  997931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  997942 */     GIR_RootConstrainSelectedInstOperands,
     /*  997943 */     // GIR_Coverage, 17208,
     /*  997943 */     GIR_EraseRootFromParent_Done,
     /*  997944 */   // Label 14844: @997944
     /*  997944 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(998020), // Rule ID 17209 //
     /*  997949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  997952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  997957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  997966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  997969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997977 */     // MIs[0] passthru
     /*  997977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  997982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997986 */     // MIs[0] round
     /*  997986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  997989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  997996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  997999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998018 */     GIR_RootConstrainSelectedInstOperands,
     /*  998019 */     // GIR_Coverage, 17209,
     /*  998019 */     GIR_EraseRootFromParent_Done,
     /*  998020 */   // Label 14845: @998020
     /*  998020 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(998096), // Rule ID 17254 //
     /*  998025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  998042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998053 */     // MIs[0] passthru
     /*  998053 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998062 */     // MIs[0] round
     /*  998062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998072 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  998075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998094 */     GIR_RootConstrainSelectedInstOperands,
     /*  998095 */     // GIR_Coverage, 17254,
     /*  998095 */     GIR_EraseRootFromParent_Done,
     /*  998096 */   // Label 14846: @998096
     /*  998096 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(998172), // Rule ID 17255 //
     /*  998101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  998118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998129 */     // MIs[0] passthru
     /*  998129 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998138 */     // MIs[0] round
     /*  998138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998148 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  998151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998170 */     GIR_RootConstrainSelectedInstOperands,
     /*  998171 */     // GIR_Coverage, 17255,
     /*  998171 */     GIR_EraseRootFromParent_Done,
     /*  998172 */   // Label 14847: @998172
     /*  998172 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(998248), // Rule ID 17264 //
     /*  998177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  998194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998205 */     // MIs[0] passthru
     /*  998205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998214 */     // MIs[0] round
     /*  998214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  998227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998246 */     GIR_RootConstrainSelectedInstOperands,
     /*  998247 */     // GIR_Coverage, 17264,
     /*  998247 */     GIR_EraseRootFromParent_Done,
     /*  998248 */   // Label 14848: @998248
     /*  998248 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(998324), // Rule ID 17265 //
     /*  998253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  998270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998281 */     // MIs[0] passthru
     /*  998281 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998290 */     // MIs[0] round
     /*  998290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  998303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998322 */     GIR_RootConstrainSelectedInstOperands,
     /*  998323 */     // GIR_Coverage, 17265,
     /*  998323 */     GIR_EraseRootFromParent_Done,
     /*  998324 */   // Label 14849: @998324
     /*  998324 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(998400), // Rule ID 17274 //
     /*  998329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  998346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998357 */     // MIs[0] passthru
     /*  998357 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998366 */     // MIs[0] round
     /*  998366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  998379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998398 */     GIR_RootConstrainSelectedInstOperands,
     /*  998399 */     // GIR_Coverage, 17274,
     /*  998399 */     GIR_EraseRootFromParent_Done,
     /*  998400 */   // Label 14850: @998400
     /*  998400 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(998476), // Rule ID 17275 //
     /*  998405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  998422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998433 */     // MIs[0] passthru
     /*  998433 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998442 */     // MIs[0] round
     /*  998442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  998455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998474 */     GIR_RootConstrainSelectedInstOperands,
     /*  998475 */     // GIR_Coverage, 17275,
     /*  998475 */     GIR_EraseRootFromParent_Done,
     /*  998476 */   // Label 14851: @998476
     /*  998476 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(998552), // Rule ID 17284 //
     /*  998481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  998498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998509 */     // MIs[0] passthru
     /*  998509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998518 */     // MIs[0] round
     /*  998518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  998531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998550 */     GIR_RootConstrainSelectedInstOperands,
     /*  998551 */     // GIR_Coverage, 17284,
     /*  998551 */     GIR_EraseRootFromParent_Done,
     /*  998552 */   // Label 14852: @998552
     /*  998552 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(998628), // Rule ID 17285 //
     /*  998557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  998574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998585 */     // MIs[0] passthru
     /*  998585 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998594 */     // MIs[0] round
     /*  998594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  998607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998626 */     GIR_RootConstrainSelectedInstOperands,
     /*  998627 */     // GIR_Coverage, 17285,
     /*  998627 */     GIR_EraseRootFromParent_Done,
     /*  998628 */   // Label 14853: @998628
     /*  998628 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(998704), // Rule ID 17294 //
     /*  998633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  998636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  998650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998661 */     // MIs[0] passthru
     /*  998661 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998670 */     // MIs[0] round
     /*  998670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998680 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  998680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  998683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998702 */     GIR_RootConstrainSelectedInstOperands,
     /*  998703 */     // GIR_Coverage, 17294,
     /*  998703 */     GIR_EraseRootFromParent_Done,
     /*  998704 */   // Label 14854: @998704
     /*  998704 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(998780), // Rule ID 17295 //
     /*  998709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  998712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  998726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998737 */     // MIs[0] passthru
     /*  998737 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998746 */     // MIs[0] round
     /*  998746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  998756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  998759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  998775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998778 */     GIR_RootConstrainSelectedInstOperands,
     /*  998779 */     // GIR_Coverage, 17295,
     /*  998779 */     GIR_EraseRootFromParent_Done,
     /*  998780 */   // Label 14855: @998780
     /*  998780 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(998856), // Rule ID 17304 //
     /*  998785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  998788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  998802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998813 */     // MIs[0] passthru
     /*  998813 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998822 */     // MIs[0] round
     /*  998822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998832 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  998832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  998835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998854 */     GIR_RootConstrainSelectedInstOperands,
     /*  998855 */     // GIR_Coverage, 17304,
     /*  998855 */     GIR_EraseRootFromParent_Done,
     /*  998856 */   // Label 14856: @998856
     /*  998856 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(998932), // Rule ID 17305 //
     /*  998861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  998864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  998878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  998881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998889 */     // MIs[0] passthru
     /*  998889 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998898 */     // MIs[0] round
     /*  998898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998908 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  998908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  998911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  998930 */     GIR_RootConstrainSelectedInstOperands,
     /*  998931 */     // GIR_Coverage, 17305,
     /*  998931 */     GIR_EraseRootFromParent_Done,
     /*  998932 */   // Label 14857: @998932
     /*  998932 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(999008), // Rule ID 17314 //
     /*  998937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  998940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  998945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  998954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  998957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998965 */     // MIs[0] passthru
     /*  998965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  998970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998974 */     // MIs[0] round
     /*  998974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  998977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  998984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  998987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  998993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  998995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999006 */     GIR_RootConstrainSelectedInstOperands,
     /*  999007 */     // GIR_Coverage, 17314,
     /*  999007 */     GIR_EraseRootFromParent_Done,
     /*  999008 */   // Label 14858: @999008
     /*  999008 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(999084), // Rule ID 17315 //
     /*  999013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  999030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999041 */     // MIs[0] passthru
     /*  999041 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999050 */     // MIs[0] round
     /*  999050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  999063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999082 */     GIR_RootConstrainSelectedInstOperands,
     /*  999083 */     // GIR_Coverage, 17315,
     /*  999083 */     GIR_EraseRootFromParent_Done,
     /*  999084 */   // Label 14859: @999084
     /*  999084 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(999160), // Rule ID 17324 //
     /*  999089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  999092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  999106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  999109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999117 */     // MIs[0] passthru
     /*  999117 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999126 */     // MIs[0] round
     /*  999126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999136 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  999136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  999139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999158 */     GIR_RootConstrainSelectedInstOperands,
     /*  999159 */     // GIR_Coverage, 17324,
     /*  999159 */     GIR_EraseRootFromParent_Done,
     /*  999160 */   // Label 14860: @999160
     /*  999160 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(999236), // Rule ID 17325 //
     /*  999165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  999182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999193 */     // MIs[0] passthru
     /*  999193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999202 */     // MIs[0] round
     /*  999202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999212 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  999215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999234 */     GIR_RootConstrainSelectedInstOperands,
     /*  999235 */     // GIR_Coverage, 17325,
     /*  999235 */     GIR_EraseRootFromParent_Done,
     /*  999236 */   // Label 14861: @999236
     /*  999236 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(999312), // Rule ID 17334 //
     /*  999241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  999244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  999258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  999261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999269 */     // MIs[0] passthru
     /*  999269 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999278 */     // MIs[0] round
     /*  999278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999288 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  999288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  999291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999310 */     GIR_RootConstrainSelectedInstOperands,
     /*  999311 */     // GIR_Coverage, 17334,
     /*  999311 */     GIR_EraseRootFromParent_Done,
     /*  999312 */   // Label 14862: @999312
     /*  999312 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(999388), // Rule ID 17335 //
     /*  999317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  999320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  999325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  999334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  999337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999345 */     // MIs[0] passthru
     /*  999345 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  999350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999354 */     // MIs[0] round
     /*  999354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  999357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  999364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  999367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  999373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  999375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  999386 */     GIR_RootConstrainSelectedInstOperands,
     /*  999387 */     // GIR_Coverage, 17335,
     /*  999387 */     GIR_EraseRootFromParent_Done,
     /*  999388 */   // Label 14863: @999388
     /*  999388 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(999465), // Rule ID 2688 //
     /*  999393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  999401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  999404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  999407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  999410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999432 */     // MIs[0] policy
     /*  999432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  999445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999463 */     GIR_RootConstrainSelectedInstOperands,
     /*  999464 */     // GIR_Coverage, 2688,
     /*  999464 */     GIR_EraseRootFromParent_Done,
     /*  999465 */   // Label 14864: @999465
     /*  999465 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(999542), // Rule ID 2689 //
     /*  999470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  999478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  999481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  999484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  999487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999509 */     // MIs[0] policy
     /*  999509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  999522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  999538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999540 */     GIR_RootConstrainSelectedInstOperands,
     /*  999541 */     // GIR_Coverage, 2689,
     /*  999541 */     GIR_EraseRootFromParent_Done,
     /*  999542 */   // Label 14865: @999542
     /*  999542 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(999619), // Rule ID 2692 //
     /*  999547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999586 */     // MIs[0] policy
     /*  999586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  999599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999617 */     GIR_RootConstrainSelectedInstOperands,
     /*  999618 */     // GIR_Coverage, 2692,
     /*  999618 */     GIR_EraseRootFromParent_Done,
     /*  999619 */   // Label 14866: @999619
     /*  999619 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(999696), // Rule ID 2693 //
     /*  999624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999663 */     // MIs[0] policy
     /*  999663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999673 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  999676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999694 */     GIR_RootConstrainSelectedInstOperands,
     /*  999695 */     // GIR_Coverage, 2693,
     /*  999695 */     GIR_EraseRootFromParent_Done,
     /*  999696 */   // Label 14867: @999696
     /*  999696 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(999773), // Rule ID 2696 //
     /*  999701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  999704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  999709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999740 */     // MIs[0] policy
     /*  999740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  999753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999771 */     GIR_RootConstrainSelectedInstOperands,
     /*  999772 */     // GIR_Coverage, 2696,
     /*  999772 */     GIR_EraseRootFromParent_Done,
     /*  999773 */   // Label 14868: @999773
     /*  999773 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(999850), // Rule ID 2697 //
     /*  999778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  999781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  999786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999817 */     // MIs[0] policy
     /*  999817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999827 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  999830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999848 */     GIR_RootConstrainSelectedInstOperands,
     /*  999849 */     // GIR_Coverage, 2697,
     /*  999849 */     GIR_EraseRootFromParent_Done,
     /*  999850 */   // Label 14869: @999850
     /*  999850 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(999927), // Rule ID 2732 //
     /*  999855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  999858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  999863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999894 */     // MIs[0] policy
     /*  999894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  999907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  999923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999925 */     GIR_RootConstrainSelectedInstOperands,
     /*  999926 */     // GIR_Coverage, 2732,
     /*  999926 */     GIR_EraseRootFromParent_Done,
     /*  999927 */   // Label 14870: @999927
     /*  999927 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(1000004), // Rule ID 2733 //
     /*  999932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  999935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  999940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999971 */     // MIs[0] policy
     /*  999971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999981 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  999984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000003 */     // GIR_Coverage, 2733,
     /* 1000003 */     GIR_EraseRootFromParent_Done,
     /* 1000004 */   // Label 14871: @1000004
     /* 1000004 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(1000081), // Rule ID 2764 //
     /* 1000009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1000017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1000020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1000023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1000029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000048 */     // MIs[0] policy
     /* 1000048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /* 1000061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1000065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1000067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1000069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000080 */     // GIR_Coverage, 2764,
     /* 1000080 */     GIR_EraseRootFromParent_Done,
     /* 1000081 */   // Label 14872: @1000081
     /* 1000081 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(1000158), // Rule ID 2765 //
     /* 1000086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1000094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1000097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1000100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1000106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000125 */     // MIs[0] policy
     /* 1000125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000135 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /* 1000138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1000142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1000144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1000146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1000154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000157 */     // GIR_Coverage, 2765,
     /* 1000157 */     GIR_EraseRootFromParent_Done,
     /* 1000158 */   // Label 14873: @1000158
     /* 1000158 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(1000235), // Rule ID 4892 //
     /* 1000163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000202 */     // MIs[0] policy
     /* 1000202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000234 */     // GIR_Coverage, 4892,
     /* 1000234 */     GIR_EraseRootFromParent_Done,
     /* 1000235 */   // Label 14874: @1000235
     /* 1000235 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(1000312), // Rule ID 4893 //
     /* 1000240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000279 */     // MIs[0] policy
     /* 1000279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000311 */     // GIR_Coverage, 4893,
     /* 1000311 */     GIR_EraseRootFromParent_Done,
     /* 1000312 */   // Label 14875: @1000312
     /* 1000312 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(1000389), // Rule ID 4896 //
     /* 1000317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000356 */     // MIs[0] policy
     /* 1000356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1000369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000388 */     // GIR_Coverage, 4896,
     /* 1000388 */     GIR_EraseRootFromParent_Done,
     /* 1000389 */   // Label 14876: @1000389
     /* 1000389 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(1000466), // Rule ID 4897 //
     /* 1000394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000433 */     // MIs[0] policy
     /* 1000433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1000446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000465 */     // GIR_Coverage, 4897,
     /* 1000465 */     GIR_EraseRootFromParent_Done,
     /* 1000466 */   // Label 14877: @1000466
     /* 1000466 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(1000543), // Rule ID 4900 //
     /* 1000471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000510 */     // MIs[0] policy
     /* 1000510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1000523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000542 */     // GIR_Coverage, 4900,
     /* 1000542 */     GIR_EraseRootFromParent_Done,
     /* 1000543 */   // Label 14878: @1000543
     /* 1000543 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(1000620), // Rule ID 4901 //
     /* 1000548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000587 */     // MIs[0] policy
     /* 1000587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1000600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000619 */     // GIR_Coverage, 4901,
     /* 1000619 */     GIR_EraseRootFromParent_Done,
     /* 1000620 */   // Label 14879: @1000620
     /* 1000620 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(1000697), // Rule ID 4904 //
     /* 1000625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000664 */     // MIs[0] policy
     /* 1000664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1000677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000696 */     // GIR_Coverage, 4904,
     /* 1000696 */     GIR_EraseRootFromParent_Done,
     /* 1000697 */   // Label 14880: @1000697
     /* 1000697 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(1000774), // Rule ID 4905 //
     /* 1000702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000741 */     // MIs[0] policy
     /* 1000741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000751 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1000754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000773 */     // GIR_Coverage, 4905,
     /* 1000773 */     GIR_EraseRootFromParent_Done,
     /* 1000774 */   // Label 14881: @1000774
     /* 1000774 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(1000851), // Rule ID 4908 //
     /* 1000779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000818 */     // MIs[0] policy
     /* 1000818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1000831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000850 */     // GIR_Coverage, 4908,
     /* 1000850 */     GIR_EraseRootFromParent_Done,
     /* 1000851 */   // Label 14882: @1000851
     /* 1000851 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(1000928), // Rule ID 4909 //
     /* 1000856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000895 */     // MIs[0] policy
     /* 1000895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000905 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1000908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000927 */     // GIR_Coverage, 4909,
     /* 1000927 */     GIR_EraseRootFromParent_Done,
     /* 1000928 */   // Label 14883: @1000928
     /* 1000928 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(1001005), // Rule ID 4912 //
     /* 1000933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1000944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1000947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1000950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000972 */     // MIs[0] policy
     /* 1000972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1000985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001004 */     // GIR_Coverage, 4912,
     /* 1001004 */     GIR_EraseRootFromParent_Done,
     /* 1001005 */   // Label 14884: @1001005
     /* 1001005 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(1001082), // Rule ID 4913 //
     /* 1001010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001049 */     // MIs[0] policy
     /* 1001049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001059 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /* 1001062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001081 */     // GIR_Coverage, 4913,
     /* 1001081 */     GIR_EraseRootFromParent_Done,
     /* 1001082 */   // Label 14885: @1001082
     /* 1001082 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(1001159), // Rule ID 4916 //
     /* 1001087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001126 */     // MIs[0] policy
     /* 1001126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001158 */     // GIR_Coverage, 4916,
     /* 1001158 */     GIR_EraseRootFromParent_Done,
     /* 1001159 */   // Label 14886: @1001159
     /* 1001159 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(1001236), // Rule ID 4917 //
     /* 1001164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001203 */     // MIs[0] policy
     /* 1001203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001235 */     // GIR_Coverage, 4917,
     /* 1001235 */     GIR_EraseRootFromParent_Done,
     /* 1001236 */   // Label 14887: @1001236
     /* 1001236 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(1001313), // Rule ID 4920 //
     /* 1001241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001280 */     // MIs[0] policy
     /* 1001280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001312 */     // GIR_Coverage, 4920,
     /* 1001312 */     GIR_EraseRootFromParent_Done,
     /* 1001313 */   // Label 14888: @1001313
     /* 1001313 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(1001390), // Rule ID 4921 //
     /* 1001318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001357 */     // MIs[0] policy
     /* 1001357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001389 */     // GIR_Coverage, 4921,
     /* 1001389 */     GIR_EraseRootFromParent_Done,
     /* 1001390 */   // Label 14889: @1001390
     /* 1001390 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(1001467), // Rule ID 4924 //
     /* 1001395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001434 */     // MIs[0] policy
     /* 1001434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1001447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001466 */     // GIR_Coverage, 4924,
     /* 1001466 */     GIR_EraseRootFromParent_Done,
     /* 1001467 */   // Label 14890: @1001467
     /* 1001467 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(1001544), // Rule ID 4925 //
     /* 1001472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001511 */     // MIs[0] policy
     /* 1001511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1001524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001543 */     // GIR_Coverage, 4925,
     /* 1001543 */     GIR_EraseRootFromParent_Done,
     /* 1001544 */   // Label 14891: @1001544
     /* 1001544 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(1001621), // Rule ID 4928 //
     /* 1001549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001588 */     // MIs[0] policy
     /* 1001588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1001601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001620 */     // GIR_Coverage, 4928,
     /* 1001620 */     GIR_EraseRootFromParent_Done,
     /* 1001621 */   // Label 14892: @1001621
     /* 1001621 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1001698), // Rule ID 4929 //
     /* 1001626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001665 */     // MIs[0] policy
     /* 1001665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001675 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1001678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001697 */     // GIR_Coverage, 4929,
     /* 1001697 */     GIR_EraseRootFromParent_Done,
     /* 1001698 */   // Label 14893: @1001698
     /* 1001698 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1001775), // Rule ID 4932 //
     /* 1001703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001742 */     // MIs[0] policy
     /* 1001742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001774 */     // GIR_Coverage, 4932,
     /* 1001774 */     GIR_EraseRootFromParent_Done,
     /* 1001775 */   // Label 14894: @1001775
     /* 1001775 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1001852), // Rule ID 4933 //
     /* 1001780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001819 */     // MIs[0] policy
     /* 1001819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001829 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /* 1001832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001851 */     // GIR_Coverage, 4933,
     /* 1001851 */     GIR_EraseRootFromParent_Done,
     /* 1001852 */   // Label 14895: @1001852
     /* 1001852 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1001929), // Rule ID 4936 //
     /* 1001857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001896 */     // MIs[0] policy
     /* 1001896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001928 */     // GIR_Coverage, 4936,
     /* 1001928 */     GIR_EraseRootFromParent_Done,
     /* 1001929 */   // Label 14896: @1001929
     /* 1001929 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1002006), // Rule ID 4937 //
     /* 1001934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1001942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001973 */     // MIs[0] policy
     /* 1001973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /* 1001986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002005 */     // GIR_Coverage, 4937,
     /* 1002005 */     GIR_EraseRootFromParent_Done,
     /* 1002006 */   // Label 14897: @1002006
     /* 1002006 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1002083), // Rule ID 4940 //
     /* 1002011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002050 */     // MIs[0] policy
     /* 1002050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1002063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002082 */     // GIR_Coverage, 4940,
     /* 1002082 */     GIR_EraseRootFromParent_Done,
     /* 1002083 */   // Label 14898: @1002083
     /* 1002083 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1002160), // Rule ID 4941 //
     /* 1002088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002127 */     // MIs[0] policy
     /* 1002127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002137 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /* 1002140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002159 */     // GIR_Coverage, 4941,
     /* 1002159 */     GIR_EraseRootFromParent_Done,
     /* 1002160 */   // Label 14899: @1002160
     /* 1002160 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1002237), // Rule ID 4944 //
     /* 1002165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002204 */     // MIs[0] policy
     /* 1002204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1002217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002236 */     // GIR_Coverage, 4944,
     /* 1002236 */     GIR_EraseRootFromParent_Done,
     /* 1002237 */   // Label 14900: @1002237
     /* 1002237 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1002314), // Rule ID 4945 //
     /* 1002242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002281 */     // MIs[0] policy
     /* 1002281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /* 1002294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002313 */     // GIR_Coverage, 4945,
     /* 1002313 */     GIR_EraseRootFromParent_Done,
     /* 1002314 */   // Label 14901: @1002314
     /* 1002314 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1002391), // Rule ID 4948 //
     /* 1002319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002358 */     // MIs[0] policy
     /* 1002358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /* 1002371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002390 */     // GIR_Coverage, 4948,
     /* 1002390 */     GIR_EraseRootFromParent_Done,
     /* 1002391 */   // Label 14902: @1002391
     /* 1002391 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1002468), // Rule ID 4949 //
     /* 1002396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002435 */     // MIs[0] policy
     /* 1002435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002445 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /* 1002448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002467 */     // GIR_Coverage, 4949,
     /* 1002467 */     GIR_EraseRootFromParent_Done,
     /* 1002468 */   // Label 14903: @1002468
     /* 1002468 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1002545), // Rule ID 4952 //
     /* 1002473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002512 */     // MIs[0] policy
     /* 1002512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1002525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002544 */     // GIR_Coverage, 4952,
     /* 1002544 */     GIR_EraseRootFromParent_Done,
     /* 1002545 */   // Label 14904: @1002545
     /* 1002545 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1002622), // Rule ID 4953 //
     /* 1002550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002589 */     // MIs[0] policy
     /* 1002589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1002602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002621 */     // GIR_Coverage, 4953,
     /* 1002621 */     GIR_EraseRootFromParent_Done,
     /* 1002622 */   // Label 14905: @1002622
     /* 1002622 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1002699), // Rule ID 4956 //
     /* 1002627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002666 */     // MIs[0] policy
     /* 1002666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1002679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002698 */     // GIR_Coverage, 4956,
     /* 1002698 */     GIR_EraseRootFromParent_Done,
     /* 1002699 */   // Label 14906: @1002699
     /* 1002699 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1002776), // Rule ID 4957 //
     /* 1002704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002743 */     // MIs[0] policy
     /* 1002743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1002756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002775 */     // GIR_Coverage, 4957,
     /* 1002775 */     GIR_EraseRootFromParent_Done,
     /* 1002776 */   // Label 14907: @1002776
     /* 1002776 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1002853), // Rule ID 4960 //
     /* 1002781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002820 */     // MIs[0] policy
     /* 1002820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1002833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002852 */     // GIR_Coverage, 4960,
     /* 1002852 */     GIR_EraseRootFromParent_Done,
     /* 1002853 */   // Label 14908: @1002853
     /* 1002853 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1002930), // Rule ID 4961 //
     /* 1002858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002897 */     // MIs[0] policy
     /* 1002897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002907 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1002910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002929 */     // GIR_Coverage, 4961,
     /* 1002929 */     GIR_EraseRootFromParent_Done,
     /* 1002930 */   // Label 14909: @1002930
     /* 1002930 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1003007), // Rule ID 4964 //
     /* 1002935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1002943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1002952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002974 */     // MIs[0] policy
     /* 1002974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1002987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003006 */     // GIR_Coverage, 4964,
     /* 1003006 */     GIR_EraseRootFromParent_Done,
     /* 1003007 */   // Label 14910: @1003007
     /* 1003007 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1003084), // Rule ID 4965 //
     /* 1003012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003051 */     // MIs[0] policy
     /* 1003051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003083 */     // GIR_Coverage, 4965,
     /* 1003083 */     GIR_EraseRootFromParent_Done,
     /* 1003084 */   // Label 14911: @1003084
     /* 1003084 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1003161), // Rule ID 4968 //
     /* 1003089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003128 */     // MIs[0] policy
     /* 1003128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1003141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003160 */     // GIR_Coverage, 4968,
     /* 1003160 */     GIR_EraseRootFromParent_Done,
     /* 1003161 */   // Label 14912: @1003161
     /* 1003161 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1003238), // Rule ID 4969 //
     /* 1003166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003205 */     // MIs[0] policy
     /* 1003205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /* 1003218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003237 */     // GIR_Coverage, 4969,
     /* 1003237 */     GIR_EraseRootFromParent_Done,
     /* 1003238 */   // Label 14913: @1003238
     /* 1003238 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1003315), // Rule ID 4972 //
     /* 1003243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003282 */     // MIs[0] policy
     /* 1003282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1003295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003314 */     // GIR_Coverage, 4972,
     /* 1003314 */     GIR_EraseRootFromParent_Done,
     /* 1003315 */   // Label 14914: @1003315
     /* 1003315 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1003392), // Rule ID 4973 //
     /* 1003320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003359 */     // MIs[0] policy
     /* 1003359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /* 1003372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003391 */     // GIR_Coverage, 4973,
     /* 1003391 */     GIR_EraseRootFromParent_Done,
     /* 1003392 */   // Label 14915: @1003392
     /* 1003392 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1003469), // Rule ID 4976 //
     /* 1003397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003436 */     // MIs[0] policy
     /* 1003436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1003449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003468 */     // GIR_Coverage, 4976,
     /* 1003468 */     GIR_EraseRootFromParent_Done,
     /* 1003469 */   // Label 14916: @1003469
     /* 1003469 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1003546), // Rule ID 4977 //
     /* 1003474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003513 */     // MIs[0] policy
     /* 1003513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003523 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /* 1003526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003545 */     // GIR_Coverage, 4977,
     /* 1003545 */     GIR_EraseRootFromParent_Done,
     /* 1003546 */   // Label 14917: @1003546
     /* 1003546 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1003623), // Rule ID 4980 //
     /* 1003551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003590 */     // MIs[0] policy
     /* 1003590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003600 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003622 */     // GIR_Coverage, 4980,
     /* 1003622 */     GIR_EraseRootFromParent_Done,
     /* 1003623 */   // Label 14918: @1003623
     /* 1003623 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1003700), // Rule ID 4981 //
     /* 1003628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003667 */     // MIs[0] policy
     /* 1003667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /* 1003680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003699 */     // GIR_Coverage, 4981,
     /* 1003699 */     GIR_EraseRootFromParent_Done,
     /* 1003700 */   // Label 14919: @1003700
     /* 1003700 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1003777), // Rule ID 4984 //
     /* 1003705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003744 */     // MIs[0] policy
     /* 1003744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1003757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003776 */     // GIR_Coverage, 4984,
     /* 1003776 */     GIR_EraseRootFromParent_Done,
     /* 1003777 */   // Label 14920: @1003777
     /* 1003777 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1003854), // Rule ID 4985 //
     /* 1003782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003821 */     // MIs[0] policy
     /* 1003821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003831 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /* 1003834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003853 */     // GIR_Coverage, 4985,
     /* 1003853 */     GIR_EraseRootFromParent_Done,
     /* 1003854 */   // Label 14921: @1003854
     /* 1003854 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1003931), // Rule ID 4988 //
     /* 1003859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003898 */     // MIs[0] policy
     /* 1003898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1003911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003930 */     // GIR_Coverage, 4988,
     /* 1003930 */     GIR_EraseRootFromParent_Done,
     /* 1003931 */   // Label 14922: @1003931
     /* 1003931 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1004008), // Rule ID 4989 //
     /* 1003936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1003944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003975 */     // MIs[0] policy
     /* 1003975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1003988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004007 */     // GIR_Coverage, 4989,
     /* 1004007 */     GIR_EraseRootFromParent_Done,
     /* 1004008 */   // Label 14923: @1004008
     /* 1004008 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1004085), // Rule ID 4992 //
     /* 1004013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004052 */     // MIs[0] policy
     /* 1004052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1004065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004084 */     // GIR_Coverage, 4992,
     /* 1004084 */     GIR_EraseRootFromParent_Done,
     /* 1004085 */   // Label 14924: @1004085
     /* 1004085 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1004162), // Rule ID 4993 //
     /* 1004090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004129 */     // MIs[0] policy
     /* 1004129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004139 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1004142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004161 */     // GIR_Coverage, 4993,
     /* 1004161 */     GIR_EraseRootFromParent_Done,
     /* 1004162 */   // Label 14925: @1004162
     /* 1004162 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1004239), // Rule ID 4996 //
     /* 1004167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004206 */     // MIs[0] policy
     /* 1004206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1004219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004238 */     // GIR_Coverage, 4996,
     /* 1004238 */     GIR_EraseRootFromParent_Done,
     /* 1004239 */   // Label 14926: @1004239
     /* 1004239 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1004316), // Rule ID 4997 //
     /* 1004244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1004252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004283 */     // MIs[0] policy
     /* 1004283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004293 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1004296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004315 */     // GIR_Coverage, 4997,
     /* 1004315 */     GIR_EraseRootFromParent_Done,
     /* 1004316 */   // Label 14927: @1004316
     /* 1004316 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1004393), // Rule ID 5000 //
     /* 1004321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004360 */     // MIs[0] policy
     /* 1004360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1004373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004392 */     // GIR_Coverage, 5000,
     /* 1004392 */     GIR_EraseRootFromParent_Done,
     /* 1004393 */   // Label 14928: @1004393
     /* 1004393 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1004470), // Rule ID 5001 //
     /* 1004398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004437 */     // MIs[0] policy
     /* 1004437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1004450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004469 */     // GIR_Coverage, 5001,
     /* 1004469 */     GIR_EraseRootFromParent_Done,
     /* 1004470 */   // Label 14929: @1004470
     /* 1004470 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1004547), // Rule ID 5004 //
     /* 1004475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004514 */     // MIs[0] policy
     /* 1004514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1004527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004546 */     // GIR_Coverage, 5004,
     /* 1004546 */     GIR_EraseRootFromParent_Done,
     /* 1004547 */   // Label 14930: @1004547
     /* 1004547 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1004624), // Rule ID 5005 //
     /* 1004552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004591 */     // MIs[0] policy
     /* 1004591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1004604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004623 */     // GIR_Coverage, 5005,
     /* 1004623 */     GIR_EraseRootFromParent_Done,
     /* 1004624 */   // Label 14931: @1004624
     /* 1004624 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1004701), // Rule ID 5008 //
     /* 1004629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1004640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1004643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004668 */     // MIs[0] policy
     /* 1004668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004678 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1004681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004700 */     // GIR_Coverage, 5008,
     /* 1004700 */     GIR_EraseRootFromParent_Done,
     /* 1004701 */   // Label 14932: @1004701
     /* 1004701 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1004778), // Rule ID 5009 //
     /* 1004706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1004717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1004720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004745 */     // MIs[0] policy
     /* 1004745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004755 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1004758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004777 */     // GIR_Coverage, 5009,
     /* 1004777 */     GIR_EraseRootFromParent_Done,
     /* 1004778 */   // Label 14933: @1004778
     /* 1004778 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1004855), // Rule ID 5012 //
     /* 1004783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004822 */     // MIs[0] policy
     /* 1004822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1004835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004854 */     // GIR_Coverage, 5012,
     /* 1004854 */     GIR_EraseRootFromParent_Done,
     /* 1004855 */   // Label 14934: @1004855
     /* 1004855 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1004932), // Rule ID 5013 //
     /* 1004860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1004871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1004874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004899 */     // MIs[0] policy
     /* 1004899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1004912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004931 */     // GIR_Coverage, 5013,
     /* 1004931 */     GIR_EraseRootFromParent_Done,
     /* 1004932 */   // Label 14935: @1004932
     /* 1004932 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1005009), // Rule ID 5016 //
     /* 1004937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1004948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1004951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1004954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1004957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004976 */     // MIs[0] policy
     /* 1004976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1004989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005008 */     // GIR_Coverage, 5016,
     /* 1005008 */     GIR_EraseRootFromParent_Done,
     /* 1005009 */   // Label 14936: @1005009
     /* 1005009 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1005086), // Rule ID 5017 //
     /* 1005014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1005025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1005028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1005031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005053 */     // MIs[0] policy
     /* 1005053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005063 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005085 */     // GIR_Coverage, 5017,
     /* 1005085 */     GIR_EraseRootFromParent_Done,
     /* 1005086 */   // Label 14937: @1005086
     /* 1005086 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1005163), // Rule ID 5020 //
     /* 1005091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1005102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1005105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1005111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005130 */     // MIs[0] policy
     /* 1005130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005140 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005162 */     // GIR_Coverage, 5020,
     /* 1005162 */     GIR_EraseRootFromParent_Done,
     /* 1005163 */   // Label 14938: @1005163
     /* 1005163 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1005240), // Rule ID 5021 //
     /* 1005168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1005179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1005182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1005188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005207 */     // MIs[0] policy
     /* 1005207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005217 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005239 */     // GIR_Coverage, 5021,
     /* 1005239 */     GIR_EraseRootFromParent_Done,
     /* 1005240 */   // Label 14939: @1005240
     /* 1005240 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1005317), // Rule ID 5024 //
     /* 1005245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005284 */     // MIs[0] policy
     /* 1005284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1005297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005316 */     // GIR_Coverage, 5024,
     /* 1005316 */     GIR_EraseRootFromParent_Done,
     /* 1005317 */   // Label 14940: @1005317
     /* 1005317 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1005394), // Rule ID 5025 //
     /* 1005322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1005342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005361 */     // MIs[0] policy
     /* 1005361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1005374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005393 */     // GIR_Coverage, 5025,
     /* 1005393 */     GIR_EraseRootFromParent_Done,
     /* 1005394 */   // Label 14941: @1005394
     /* 1005394 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1005471), // Rule ID 5028 //
     /* 1005399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005438 */     // MIs[0] policy
     /* 1005438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1005451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005470 */     // GIR_Coverage, 5028,
     /* 1005470 */     GIR_EraseRootFromParent_Done,
     /* 1005471 */   // Label 14942: @1005471
     /* 1005471 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1005548), // Rule ID 5029 //
     /* 1005476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1005496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1005503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005515 */     // MIs[0] policy
     /* 1005515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1005528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005547 */     // GIR_Coverage, 5029,
     /* 1005547 */     GIR_EraseRootFromParent_Done,
     /* 1005548 */   // Label 14943: @1005548
     /* 1005548 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1005625), // Rule ID 5032 //
     /* 1005553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1005564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1005567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005592 */     // MIs[0] policy
     /* 1005592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1005605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005624 */     // GIR_Coverage, 5032,
     /* 1005624 */     GIR_EraseRootFromParent_Done,
     /* 1005625 */   // Label 14944: @1005625
     /* 1005625 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1005702), // Rule ID 5033 //
     /* 1005630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1005641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1005644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1005650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1005657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005669 */     // MIs[0] policy
     /* 1005669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1005682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005701 */     // GIR_Coverage, 5033,
     /* 1005701 */     GIR_EraseRootFromParent_Done,
     /* 1005702 */   // Label 14945: @1005702
     /* 1005702 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1005779), // Rule ID 5036 //
     /* 1005707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1005718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1005721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1005724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005746 */     // MIs[0] policy
     /* 1005746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005778 */     // GIR_Coverage, 5036,
     /* 1005778 */     GIR_EraseRootFromParent_Done,
     /* 1005779 */   // Label 14946: @1005779
     /* 1005779 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1005856), // Rule ID 5037 //
     /* 1005784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1005795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1005798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1005801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1005804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1005811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005823 */     // MIs[0] policy
     /* 1005823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1005836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005855 */     // GIR_Coverage, 5037,
     /* 1005855 */     GIR_EraseRootFromParent_Done,
     /* 1005856 */   // Label 14947: @1005856
     /* 1005856 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1005933), // Rule ID 5040 //
     /* 1005861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1005872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1005875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1005878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005900 */     // MIs[0] policy
     /* 1005900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005932 */     // GIR_Coverage, 5040,
     /* 1005932 */     GIR_EraseRootFromParent_Done,
     /* 1005933 */   // Label 14948: @1005933
     /* 1005933 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1006010), // Rule ID 5041 //
     /* 1005938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1005946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1005949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1005952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1005955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1005958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1005965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1005969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1005977 */     // MIs[0] policy
     /* 1005977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005987 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1005990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1005994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1005996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1005998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006009 */     // GIR_Coverage, 5041,
     /* 1006009 */     GIR_EraseRootFromParent_Done,
     /* 1006010 */   // Label 14949: @1006010
     /* 1006010 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1006087), // Rule ID 5044 //
     /* 1006015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006054 */     // MIs[0] policy
     /* 1006054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1006067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006086 */     // GIR_Coverage, 5044,
     /* 1006086 */     GIR_EraseRootFromParent_Done,
     /* 1006087 */   // Label 14950: @1006087
     /* 1006087 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1006164), // Rule ID 5045 //
     /* 1006092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1006109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006131 */     // MIs[0] policy
     /* 1006131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006141 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1006144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006163 */     // GIR_Coverage, 5045,
     /* 1006163 */     GIR_EraseRootFromParent_Done,
     /* 1006164 */   // Label 14951: @1006164
     /* 1006164 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1006241), // Rule ID 5048 //
     /* 1006169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1006180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1006183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006208 */     // MIs[0] policy
     /* 1006208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1006221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006240 */     // GIR_Coverage, 5048,
     /* 1006240 */     GIR_EraseRootFromParent_Done,
     /* 1006241 */   // Label 14952: @1006241
     /* 1006241 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1006318), // Rule ID 5049 //
     /* 1006246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1006257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1006260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1006263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006285 */     // MIs[0] policy
     /* 1006285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006295 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1006298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006317 */     // GIR_Coverage, 5049,
     /* 1006317 */     GIR_EraseRootFromParent_Done,
     /* 1006318 */   // Label 14953: @1006318
     /* 1006318 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1006395), // Rule ID 5052 //
     /* 1006323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1006334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1006337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1006350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006362 */     // MIs[0] policy
     /* 1006362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1006375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006394 */     // GIR_Coverage, 5052,
     /* 1006394 */     GIR_EraseRootFromParent_Done,
     /* 1006395 */   // Label 14954: @1006395
     /* 1006395 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1006472), // Rule ID 5053 //
     /* 1006400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1006411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1006414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1006427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006439 */     // MIs[0] policy
     /* 1006439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006449 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1006452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006471 */     // GIR_Coverage, 5053,
     /* 1006471 */     GIR_EraseRootFromParent_Done,
     /* 1006472 */   // Label 14955: @1006472
     /* 1006472 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1006549), // Rule ID 5056 //
     /* 1006477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1006480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1006488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1006491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1006504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006516 */     // MIs[0] policy
     /* 1006516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1006529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006548 */     // GIR_Coverage, 5056,
     /* 1006548 */     GIR_EraseRootFromParent_Done,
     /* 1006549 */   // Label 14956: @1006549
     /* 1006549 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1006626), // Rule ID 5057 //
     /* 1006554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1006557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1006565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1006568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1006574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1006581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006593 */     // MIs[0] policy
     /* 1006593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006603 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1006606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006625 */     // GIR_Coverage, 5057,
     /* 1006625 */     GIR_EraseRootFromParent_Done,
     /* 1006626 */   // Label 14957: @1006626
     /* 1006626 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1006703), // Rule ID 5060 //
     /* 1006631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1006648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006670 */     // MIs[0] policy
     /* 1006670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1006683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006702 */     // GIR_Coverage, 5060,
     /* 1006702 */     GIR_EraseRootFromParent_Done,
     /* 1006703 */   // Label 14958: @1006703
     /* 1006703 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1006780), // Rule ID 5061 //
     /* 1006708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1006719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1006722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1006725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1006728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006747 */     // MIs[0] policy
     /* 1006747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006757 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1006760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006779 */     // GIR_Coverage, 5061,
     /* 1006779 */     GIR_EraseRootFromParent_Done,
     /* 1006780 */   // Label 14959: @1006780
     /* 1006780 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1006857), // Rule ID 5064 //
     /* 1006785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1006802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006824 */     // MIs[0] policy
     /* 1006824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1006837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006856 */     // GIR_Coverage, 5064,
     /* 1006856 */     GIR_EraseRootFromParent_Done,
     /* 1006857 */   // Label 14960: @1006857
     /* 1006857 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1006934), // Rule ID 5065 //
     /* 1006862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1006873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1006876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1006879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1006882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1006889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006901 */     // MIs[0] policy
     /* 1006901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1006914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006933 */     // GIR_Coverage, 5065,
     /* 1006933 */     GIR_EraseRootFromParent_Done,
     /* 1006934 */   // Label 14961: @1006934
     /* 1006934 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1007011), // Rule ID 5068 //
     /* 1006939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1006947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1006950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1006953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1006956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1006959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1006966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1006978 */     // MIs[0] policy
     /* 1006978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006988 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1006991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1006995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1006997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1006999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007010 */     // GIR_Coverage, 5068,
     /* 1007010 */     GIR_EraseRootFromParent_Done,
     /* 1007011 */   // Label 14962: @1007011
     /* 1007011 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1007088), // Rule ID 5069 //
     /* 1007016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1007033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007055 */     // MIs[0] policy
     /* 1007055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007065 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007087 */     // GIR_Coverage, 5069,
     /* 1007087 */     GIR_EraseRootFromParent_Done,
     /* 1007088 */   // Label 14963: @1007088
     /* 1007088 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1007165), // Rule ID 5072 //
     /* 1007093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1007110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007132 */     // MIs[0] policy
     /* 1007132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007164 */     // GIR_Coverage, 5072,
     /* 1007164 */     GIR_EraseRootFromParent_Done,
     /* 1007165 */   // Label 14964: @1007165
     /* 1007165 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1007242), // Rule ID 5073 //
     /* 1007170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1007187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007209 */     // MIs[0] policy
     /* 1007209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007219 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007241 */     // GIR_Coverage, 5073,
     /* 1007241 */     GIR_EraseRootFromParent_Done,
     /* 1007242 */   // Label 14965: @1007242
     /* 1007242 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1007319), // Rule ID 5076 //
     /* 1007247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007286 */     // MIs[0] policy
     /* 1007286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007318 */     // GIR_Coverage, 5076,
     /* 1007318 */     GIR_EraseRootFromParent_Done,
     /* 1007319 */   // Label 14966: @1007319
     /* 1007319 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1007396), // Rule ID 5077 //
     /* 1007324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1007341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1007344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007363 */     // MIs[0] policy
     /* 1007363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007373 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007395 */     // GIR_Coverage, 5077,
     /* 1007395 */     GIR_EraseRootFromParent_Done,
     /* 1007396 */   // Label 14967: @1007396
     /* 1007396 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1007473), // Rule ID 5080 //
     /* 1007401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1007412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1007415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1007418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1007421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1007428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007440 */     // MIs[0] policy
     /* 1007440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1007453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007472 */     // GIR_Coverage, 5080,
     /* 1007472 */     GIR_EraseRootFromParent_Done,
     /* 1007473 */   // Label 14968: @1007473
     /* 1007473 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1007550), // Rule ID 5081 //
     /* 1007478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1007489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1007492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1007495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1007498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1007505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007517 */     // MIs[0] policy
     /* 1007517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1007530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007549 */     // GIR_Coverage, 5081,
     /* 1007549 */     GIR_EraseRootFromParent_Done,
     /* 1007550 */   // Label 14969: @1007550
     /* 1007550 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1007627), // Rule ID 5084 //
     /* 1007555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1007572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1007575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007594 */     // MIs[0] policy
     /* 1007594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007626 */     // GIR_Coverage, 5084,
     /* 1007626 */     GIR_EraseRootFromParent_Done,
     /* 1007627 */   // Label 14970: @1007627
     /* 1007627 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1007704), // Rule ID 5085 //
     /* 1007632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1007649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1007652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1007659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007671 */     // MIs[0] policy
     /* 1007671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1007684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007703 */     // GIR_Coverage, 5085,
     /* 1007703 */     GIR_EraseRootFromParent_Done,
     /* 1007704 */   // Label 14971: @1007704
     /* 1007704 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1007781), // Rule ID 5088 //
     /* 1007709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1007726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007748 */     // MIs[0] policy
     /* 1007748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007780 */     // GIR_Coverage, 5088,
     /* 1007780 */     GIR_EraseRootFromParent_Done,
     /* 1007781 */   // Label 14972: @1007781
     /* 1007781 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1007858), // Rule ID 5089 //
     /* 1007786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1007803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1007806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1007813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007825 */     // MIs[0] policy
     /* 1007825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007835 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1007838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007857 */     // GIR_Coverage, 5089,
     /* 1007857 */     GIR_EraseRootFromParent_Done,
     /* 1007858 */   // Label 14973: @1007858
     /* 1007858 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1007935), // Rule ID 5092 //
     /* 1007863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1007866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007902 */     // MIs[0] policy
     /* 1007902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1007923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007934 */     // GIR_Coverage, 5092,
     /* 1007934 */     GIR_EraseRootFromParent_Done,
     /* 1007935 */   // Label 14974: @1007935
     /* 1007935 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1008012), // Rule ID 5093 //
     /* 1007940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1007943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1007948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1007957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1007960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1007967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1007979 */     // MIs[0] policy
     /* 1007979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007989 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1007992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1007996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1007998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008011 */     // GIR_Coverage, 5093,
     /* 1008011 */     GIR_EraseRootFromParent_Done,
     /* 1008012 */   // Label 14975: @1008012
     /* 1008012 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1008089), // Rule ID 5096 //
     /* 1008017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1008034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1008037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1008044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008056 */     // MIs[0] policy
     /* 1008056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1008069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008088 */     // GIR_Coverage, 5096,
     /* 1008088 */     GIR_EraseRootFromParent_Done,
     /* 1008089 */   // Label 14976: @1008089
     /* 1008089 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1008166), // Rule ID 5097 //
     /* 1008094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1008111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1008114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1008121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008133 */     // MIs[0] policy
     /* 1008133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1008146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008165 */     // GIR_Coverage, 5097,
     /* 1008165 */     GIR_EraseRootFromParent_Done,
     /* 1008166 */   // Label 14977: @1008166
     /* 1008166 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1008243), // Rule ID 5100 //
     /* 1008171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008210 */     // MIs[0] policy
     /* 1008210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1008223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008242 */     // GIR_Coverage, 5100,
     /* 1008242 */     GIR_EraseRootFromParent_Done,
     /* 1008243 */   // Label 14978: @1008243
     /* 1008243 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1008320), // Rule ID 5101 //
     /* 1008248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1008259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1008262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1008268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1008275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1008279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008287 */     // MIs[0] policy
     /* 1008287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1008300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008319 */     // GIR_Coverage, 5101,
     /* 1008319 */     GIR_EraseRootFromParent_Done,
     /* 1008320 */   // Label 14979: @1008320
     /* 1008320 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1008397), // Rule ID 5104 //
     /* 1008325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008364 */     // MIs[0] policy
     /* 1008364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1008377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008396 */     // GIR_Coverage, 5104,
     /* 1008396 */     GIR_EraseRootFromParent_Done,
     /* 1008397 */   // Label 14980: @1008397
     /* 1008397 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1008474), // Rule ID 5105 //
     /* 1008402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1008413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1008416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1008422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1008429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1008433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008441 */     // MIs[0] policy
     /* 1008441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008451 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1008454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008473 */     // GIR_Coverage, 5105,
     /* 1008473 */     GIR_EraseRootFromParent_Done,
     /* 1008474 */   // Label 14981: @1008474
     /* 1008474 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1008551), // Rule ID 5108 //
     /* 1008479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1008482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1008496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008518 */     // MIs[0] policy
     /* 1008518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1008531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008550 */     // GIR_Coverage, 5108,
     /* 1008550 */     GIR_EraseRootFromParent_Done,
     /* 1008551 */   // Label 14982: @1008551
     /* 1008551 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1008628), // Rule ID 5109 //
     /* 1008556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1008559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1008564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1008567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1008570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1008573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1008576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1008583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1008587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1008595 */     // MIs[0] policy
     /* 1008595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008605 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1008608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1008612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1008614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1008616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008627 */     // GIR_Coverage, 5109,
     /* 1008627 */     GIR_EraseRootFromParent_Done,
     /* 1008628 */   // Label 14983: @1008628
     /* 1008628 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1008705), // Rule ID 12720 //
     /* 1008633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008672 */     // MIs[0] policy
     /* 1008672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008704 */     // GIR_Coverage, 12720,
     /* 1008704 */     GIR_EraseRootFromParent_Done,
     /* 1008705 */   // Label 14984: @1008705
     /* 1008705 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1008782), // Rule ID 12721 //
     /* 1008710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1008727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008749 */     // MIs[0] policy
     /* 1008749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008759 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008781 */     // GIR_Coverage, 12721,
     /* 1008781 */     GIR_EraseRootFromParent_Done,
     /* 1008782 */   // Label 14985: @1008782
     /* 1008782 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1008859), // Rule ID 12724 //
     /* 1008787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008826 */     // MIs[0] policy
     /* 1008826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1008839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008858 */     // GIR_Coverage, 12724,
     /* 1008858 */     GIR_EraseRootFromParent_Done,
     /* 1008859 */   // Label 14986: @1008859
     /* 1008859 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1008936), // Rule ID 12725 //
     /* 1008864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1008881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008903 */     // MIs[0] policy
     /* 1008903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008913 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1008916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008935 */     // GIR_Coverage, 12725,
     /* 1008935 */     GIR_EraseRootFromParent_Done,
     /* 1008936 */   // Label 14987: @1008936
     /* 1008936 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1009013), // Rule ID 12728 //
     /* 1008941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1008958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008980 */     // MIs[0] policy
     /* 1008980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1008993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009012 */     // GIR_Coverage, 12728,
     /* 1009012 */     GIR_EraseRootFromParent_Done,
     /* 1009013 */   // Label 14988: @1009013
     /* 1009013 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1009090), // Rule ID 12729 //
     /* 1009018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1009029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1009032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1009035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1009038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009057 */     // MIs[0] policy
     /* 1009057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009067 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1009070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009089 */     // GIR_Coverage, 12729,
     /* 1009089 */     GIR_EraseRootFromParent_Done,
     /* 1009090 */   // Label 14989: @1009090
     /* 1009090 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1009167), // Rule ID 12732 //
     /* 1009095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009134 */     // MIs[0] policy
     /* 1009134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009166 */     // GIR_Coverage, 12732,
     /* 1009166 */     GIR_EraseRootFromParent_Done,
     /* 1009167 */   // Label 14990: @1009167
     /* 1009167 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1009244), // Rule ID 12733 //
     /* 1009172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1009183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1009186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1009189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1009192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009211 */     // MIs[0] policy
     /* 1009211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009221 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009243 */     // GIR_Coverage, 12733,
     /* 1009243 */     GIR_EraseRootFromParent_Done,
     /* 1009244 */   // Label 14991: @1009244
     /* 1009244 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1009321), // Rule ID 12736 //
     /* 1009249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009288 */     // MIs[0] policy
     /* 1009288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009320 */     // GIR_Coverage, 12736,
     /* 1009320 */     GIR_EraseRootFromParent_Done,
     /* 1009321 */   // Label 14992: @1009321
     /* 1009321 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1009398), // Rule ID 12737 //
     /* 1009326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1009337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1009340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1009343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1009346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009365 */     // MIs[0] policy
     /* 1009365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1009378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009397 */     // GIR_Coverage, 12737,
     /* 1009397 */     GIR_EraseRootFromParent_Done,
     /* 1009398 */   // Label 14993: @1009398
     /* 1009398 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1009475), // Rule ID 12740 //
     /* 1009403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009442 */     // MIs[0] policy
     /* 1009442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009474 */     // GIR_Coverage, 12740,
     /* 1009474 */     GIR_EraseRootFromParent_Done,
     /* 1009475 */   // Label 14994: @1009475
     /* 1009475 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1009552), // Rule ID 12741 //
     /* 1009480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1009497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009519 */     // MIs[0] policy
     /* 1009519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009529 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009551 */     // GIR_Coverage, 12741,
     /* 1009551 */     GIR_EraseRootFromParent_Done,
     /* 1009552 */   // Label 14995: @1009552
     /* 1009552 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1009629), // Rule ID 12744 //
     /* 1009557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1009574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009596 */     // MIs[0] policy
     /* 1009596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009628 */     // GIR_Coverage, 12744,
     /* 1009628 */     GIR_EraseRootFromParent_Done,
     /* 1009629 */   // Label 14996: @1009629
     /* 1009629 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1009706), // Rule ID 12745 //
     /* 1009634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1009651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009673 */     // MIs[0] policy
     /* 1009673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009705 */     // GIR_Coverage, 12745,
     /* 1009705 */     GIR_EraseRootFromParent_Done,
     /* 1009706 */   // Label 14997: @1009706
     /* 1009706 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1009783), // Rule ID 12748 //
     /* 1009711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1009728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009750 */     // MIs[0] policy
     /* 1009750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009782 */     // GIR_Coverage, 12748,
     /* 1009782 */     GIR_EraseRootFromParent_Done,
     /* 1009783 */   // Label 14998: @1009783
     /* 1009783 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1009860), // Rule ID 12749 //
     /* 1009788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1009805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009827 */     // MIs[0] policy
     /* 1009827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009859 */     // GIR_Coverage, 12749,
     /* 1009859 */     GIR_EraseRootFromParent_Done,
     /* 1009860 */   // Label 14999: @1009860
     /* 1009860 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1009937), // Rule ID 12752 //
     /* 1009865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1009882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009904 */     // MIs[0] policy
     /* 1009904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009936 */     // GIR_Coverage, 12752,
     /* 1009936 */     GIR_EraseRootFromParent_Done,
     /* 1009937 */   // Label 15000: @1009937
     /* 1009937 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1010014), // Rule ID 12753 //
     /* 1009942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1009959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009981 */     // MIs[0] policy
     /* 1009981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1009994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010013 */     // GIR_Coverage, 12753,
     /* 1010013 */     GIR_EraseRootFromParent_Done,
     /* 1010014 */   // Label 15001: @1010014
     /* 1010014 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1010091), // Rule ID 12756 //
     /* 1010019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010058 */     // MIs[0] policy
     /* 1010058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010090 */     // GIR_Coverage, 12756,
     /* 1010090 */     GIR_EraseRootFromParent_Done,
     /* 1010091 */   // Label 15002: @1010091
     /* 1010091 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1010168), // Rule ID 12757 //
     /* 1010096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1010107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1010110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1010113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1010116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010135 */     // MIs[0] policy
     /* 1010135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010145 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010167 */     // GIR_Coverage, 12757,
     /* 1010167 */     GIR_EraseRootFromParent_Done,
     /* 1010168 */   // Label 15003: @1010168
     /* 1010168 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1010245), // Rule ID 12760 //
     /* 1010173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010212 */     // MIs[0] policy
     /* 1010212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010244 */     // GIR_Coverage, 12760,
     /* 1010244 */     GIR_EraseRootFromParent_Done,
     /* 1010245 */   // Label 15004: @1010245
     /* 1010245 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1010322), // Rule ID 12761 //
     /* 1010250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1010261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1010264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1010267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1010270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010289 */     // MIs[0] policy
     /* 1010289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010321 */     // GIR_Coverage, 12761,
     /* 1010321 */     GIR_EraseRootFromParent_Done,
     /* 1010322 */   // Label 15005: @1010322
     /* 1010322 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1010399), // Rule ID 12764 //
     /* 1010327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010366 */     // MIs[0] policy
     /* 1010366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010376 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010398 */     // GIR_Coverage, 12764,
     /* 1010398 */     GIR_EraseRootFromParent_Done,
     /* 1010399 */   // Label 15006: @1010399
     /* 1010399 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1010476), // Rule ID 12765 //
     /* 1010404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1010415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1010418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1010421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1010424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010443 */     // MIs[0] policy
     /* 1010443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010453 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010475 */     // GIR_Coverage, 12765,
     /* 1010475 */     GIR_EraseRootFromParent_Done,
     /* 1010476 */   // Label 15007: @1010476
     /* 1010476 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1010553), // Rule ID 12768 //
     /* 1010481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1010498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010520 */     // MIs[0] policy
     /* 1010520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010552 */     // GIR_Coverage, 12768,
     /* 1010552 */     GIR_EraseRootFromParent_Done,
     /* 1010553 */   // Label 15008: @1010553
     /* 1010553 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1010630), // Rule ID 12769 //
     /* 1010558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1010575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010597 */     // MIs[0] policy
     /* 1010597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010629 */     // GIR_Coverage, 12769,
     /* 1010629 */     GIR_EraseRootFromParent_Done,
     /* 1010630 */   // Label 15009: @1010630
     /* 1010630 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1010707), // Rule ID 12772 //
     /* 1010635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1010652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010674 */     // MIs[0] policy
     /* 1010674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010706 */     // GIR_Coverage, 12772,
     /* 1010706 */     GIR_EraseRootFromParent_Done,
     /* 1010707 */   // Label 15010: @1010707
     /* 1010707 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1010784), // Rule ID 12773 //
     /* 1010712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1010729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010751 */     // MIs[0] policy
     /* 1010751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010761 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1010764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010783 */     // GIR_Coverage, 12773,
     /* 1010783 */     GIR_EraseRootFromParent_Done,
     /* 1010784 */   // Label 15011: @1010784
     /* 1010784 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1010861), // Rule ID 12776 //
     /* 1010789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1010806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010828 */     // MIs[0] policy
     /* 1010828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010838 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010860 */     // GIR_Coverage, 12776,
     /* 1010860 */     GIR_EraseRootFromParent_Done,
     /* 1010861 */   // Label 15012: @1010861
     /* 1010861 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1010938), // Rule ID 12777 //
     /* 1010866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1010883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010905 */     // MIs[0] policy
     /* 1010905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010915 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1010918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010937 */     // GIR_Coverage, 12777,
     /* 1010937 */     GIR_EraseRootFromParent_Done,
     /* 1010938 */   // Label 15013: @1010938
     /* 1010938 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1011015), // Rule ID 12780 //
     /* 1010943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1010960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010982 */     // MIs[0] policy
     /* 1010982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1010995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011014 */     // GIR_Coverage, 12780,
     /* 1011014 */     GIR_EraseRootFromParent_Done,
     /* 1011015 */   // Label 15014: @1011015
     /* 1011015 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1011092), // Rule ID 12781 //
     /* 1011020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1011031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1011034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1011037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1011040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011059 */     // MIs[0] policy
     /* 1011059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011091 */     // GIR_Coverage, 12781,
     /* 1011091 */     GIR_EraseRootFromParent_Done,
     /* 1011092 */   // Label 15015: @1011092
     /* 1011092 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1011169), // Rule ID 12784 //
     /* 1011097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011136 */     // MIs[0] policy
     /* 1011136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011168 */     // GIR_Coverage, 12784,
     /* 1011168 */     GIR_EraseRootFromParent_Done,
     /* 1011169 */   // Label 15016: @1011169
     /* 1011169 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1011246), // Rule ID 12785 //
     /* 1011174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1011185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1011188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1011191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1011194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011213 */     // MIs[0] policy
     /* 1011213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011223 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011245 */     // GIR_Coverage, 12785,
     /* 1011245 */     GIR_EraseRootFromParent_Done,
     /* 1011246 */   // Label 15017: @1011246
     /* 1011246 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1011323), // Rule ID 12788 //
     /* 1011251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011290 */     // MIs[0] policy
     /* 1011290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011322 */     // GIR_Coverage, 12788,
     /* 1011322 */     GIR_EraseRootFromParent_Done,
     /* 1011323 */   // Label 15018: @1011323
     /* 1011323 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1011400), // Rule ID 12789 //
     /* 1011328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1011339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1011342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1011345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1011348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011367 */     // MIs[0] policy
     /* 1011367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011399 */     // GIR_Coverage, 12789,
     /* 1011399 */     GIR_EraseRootFromParent_Done,
     /* 1011400 */   // Label 15019: @1011400
     /* 1011400 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1011477), // Rule ID 12792 //
     /* 1011405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011444 */     // MIs[0] policy
     /* 1011444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011476 */     // GIR_Coverage, 12792,
     /* 1011476 */     GIR_EraseRootFromParent_Done,
     /* 1011477 */   // Label 15020: @1011477
     /* 1011477 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1011554), // Rule ID 12793 //
     /* 1011482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1011499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011521 */     // MIs[0] policy
     /* 1011521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1011534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011553 */     // GIR_Coverage, 12793,
     /* 1011553 */     GIR_EraseRootFromParent_Done,
     /* 1011554 */   // Label 15021: @1011554
     /* 1011554 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1011631), // Rule ID 12796 //
     /* 1011559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1011576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011598 */     // MIs[0] policy
     /* 1011598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011608 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011630 */     // GIR_Coverage, 12796,
     /* 1011630 */     GIR_EraseRootFromParent_Done,
     /* 1011631 */   // Label 15022: @1011631
     /* 1011631 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1011708), // Rule ID 12797 //
     /* 1011636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1011653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011675 */     // MIs[0] policy
     /* 1011675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011685 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1011688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011707 */     // GIR_Coverage, 12797,
     /* 1011707 */     GIR_EraseRootFromParent_Done,
     /* 1011708 */   // Label 15023: @1011708
     /* 1011708 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1011785), // Rule ID 12800 //
     /* 1011713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1011730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011752 */     // MIs[0] policy
     /* 1011752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011762 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011784 */     // GIR_Coverage, 12800,
     /* 1011784 */     GIR_EraseRootFromParent_Done,
     /* 1011785 */   // Label 15024: @1011785
     /* 1011785 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1011862), // Rule ID 12801 //
     /* 1011790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1011807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011829 */     // MIs[0] policy
     /* 1011829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011839 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1011842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011861 */     // GIR_Coverage, 12801,
     /* 1011861 */     GIR_EraseRootFromParent_Done,
     /* 1011862 */   // Label 15025: @1011862
     /* 1011862 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1011939), // Rule ID 12804 //
     /* 1011867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011906 */     // MIs[0] policy
     /* 1011906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1011919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011938 */     // GIR_Coverage, 12804,
     /* 1011938 */     GIR_EraseRootFromParent_Done,
     /* 1011939 */   // Label 15026: @1011939
     /* 1011939 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1012016), // Rule ID 12805 //
     /* 1011944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011983 */     // MIs[0] policy
     /* 1011983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011993 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1011996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012015 */     // GIR_Coverage, 12805,
     /* 1012015 */     GIR_EraseRootFromParent_Done,
     /* 1012016 */   // Label 15027: @1012016
     /* 1012016 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1012093), // Rule ID 12808 //
     /* 1012021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012060 */     // MIs[0] policy
     /* 1012060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012092 */     // GIR_Coverage, 12808,
     /* 1012092 */     GIR_EraseRootFromParent_Done,
     /* 1012093 */   // Label 15028: @1012093
     /* 1012093 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1012170), // Rule ID 12809 //
     /* 1012098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1012109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1012112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1012118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012137 */     // MIs[0] policy
     /* 1012137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012147 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012169 */     // GIR_Coverage, 12809,
     /* 1012169 */     GIR_EraseRootFromParent_Done,
     /* 1012170 */   // Label 15029: @1012170
     /* 1012170 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1012247), // Rule ID 12812 //
     /* 1012175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012214 */     // MIs[0] policy
     /* 1012214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012246 */     // GIR_Coverage, 12812,
     /* 1012246 */     GIR_EraseRootFromParent_Done,
     /* 1012247 */   // Label 15030: @1012247
     /* 1012247 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1012324), // Rule ID 12813 //
     /* 1012252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1012263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1012266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1012272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012291 */     // MIs[0] policy
     /* 1012291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012323 */     // GIR_Coverage, 12813,
     /* 1012323 */     GIR_EraseRootFromParent_Done,
     /* 1012324 */   // Label 15031: @1012324
     /* 1012324 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1012401), // Rule ID 12816 //
     /* 1012329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012368 */     // MIs[0] policy
     /* 1012368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012400 */     // GIR_Coverage, 12816,
     /* 1012400 */     GIR_EraseRootFromParent_Done,
     /* 1012401 */   // Label 15032: @1012401
     /* 1012401 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1012478), // Rule ID 12817 //
     /* 1012406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1012417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1012420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1012426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012445 */     // MIs[0] policy
     /* 1012445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012455 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1012458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012477 */     // GIR_Coverage, 12817,
     /* 1012477 */     GIR_EraseRootFromParent_Done,
     /* 1012478 */   // Label 15033: @1012478
     /* 1012478 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1012555), // Rule ID 12820 //
     /* 1012483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012522 */     // MIs[0] policy
     /* 1012522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012554 */     // GIR_Coverage, 12820,
     /* 1012554 */     GIR_EraseRootFromParent_Done,
     /* 1012555 */   // Label 15034: @1012555
     /* 1012555 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1012632), // Rule ID 12821 //
     /* 1012560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012599 */     // MIs[0] policy
     /* 1012599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012609 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012631 */     // GIR_Coverage, 12821,
     /* 1012631 */     GIR_EraseRootFromParent_Done,
     /* 1012632 */   // Label 15035: @1012632
     /* 1012632 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1012709), // Rule ID 12824 //
     /* 1012637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012676 */     // MIs[0] policy
     /* 1012676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012708 */     // GIR_Coverage, 12824,
     /* 1012708 */     GIR_EraseRootFromParent_Done,
     /* 1012709 */   // Label 15036: @1012709
     /* 1012709 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1012786), // Rule ID 12825 //
     /* 1012714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012753 */     // MIs[0] policy
     /* 1012753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012763 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1012766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012785 */     // GIR_Coverage, 12825,
     /* 1012785 */     GIR_EraseRootFromParent_Done,
     /* 1012786 */   // Label 15037: @1012786
     /* 1012786 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1012863), // Rule ID 12828 //
     /* 1012791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012830 */     // MIs[0] policy
     /* 1012830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012862 */     // GIR_Coverage, 12828,
     /* 1012862 */     GIR_EraseRootFromParent_Done,
     /* 1012863 */   // Label 15038: @1012863
     /* 1012863 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1012940), // Rule ID 12829 //
     /* 1012868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1012885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012907 */     // MIs[0] policy
     /* 1012907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012917 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11349:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012939 */     // GIR_Coverage, 12829,
     /* 1012939 */     GIR_EraseRootFromParent_Done,
     /* 1012940 */   // Label 15039: @1012940
     /* 1012940 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1013017), // Rule ID 12832 //
     /* 1012945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1012953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1012962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1012980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012984 */     // MIs[0] policy
     /* 1012984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1012997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013016 */     // GIR_Coverage, 12832,
     /* 1013016 */     GIR_EraseRootFromParent_Done,
     /* 1013017 */   // Label 15040: @1013017
     /* 1013017 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1013094), // Rule ID 12833 //
     /* 1013022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1013033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1013036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1013042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013061 */     // MIs[0] policy
     /* 1013061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11349:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013093 */     // GIR_Coverage, 12833,
     /* 1013093 */     GIR_EraseRootFromParent_Done,
     /* 1013094 */   // Label 15041: @1013094
     /* 1013094 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1013171), // Rule ID 12836 //
     /* 1013099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013138 */     // MIs[0] policy
     /* 1013138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013170 */     // GIR_Coverage, 12836,
     /* 1013170 */     GIR_EraseRootFromParent_Done,
     /* 1013171 */   // Label 15042: @1013171
     /* 1013171 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1013248), // Rule ID 12837 //
     /* 1013176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1013187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1013190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1013196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013215 */     // MIs[0] policy
     /* 1013215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11349:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013247 */     // GIR_Coverage, 12837,
     /* 1013247 */     GIR_EraseRootFromParent_Done,
     /* 1013248 */   // Label 15043: @1013248
     /* 1013248 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1013325), // Rule ID 12840 //
     /* 1013253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013292 */     // MIs[0] policy
     /* 1013292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013324 */     // GIR_Coverage, 12840,
     /* 1013324 */     GIR_EraseRootFromParent_Done,
     /* 1013325 */   // Label 15044: @1013325
     /* 1013325 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1013402), // Rule ID 12841 //
     /* 1013330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1013333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1013341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1013344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1013350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1013369 */     // MIs[0] policy
     /* 1013369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013379 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11349:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1013382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013401 */     // GIR_Coverage, 12841,
     /* 1013401 */     GIR_EraseRootFromParent_Done,
     /* 1013402 */   // Label 15045: @1013402
     /* 1013402 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1013479), // Rule ID 12844 //
     /* 1013407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013446 */     // MIs[0] policy
     /* 1013446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013478 */     // GIR_Coverage, 12844,
     /* 1013478 */     GIR_EraseRootFromParent_Done,
     /* 1013479 */   // Label 15046: @1013479
     /* 1013479 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1013556), // Rule ID 12845 //
     /* 1013484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013523 */     // MIs[0] policy
     /* 1013523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013533 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013555 */     // GIR_Coverage, 12845,
     /* 1013555 */     GIR_EraseRootFromParent_Done,
     /* 1013556 */   // Label 15047: @1013556
     /* 1013556 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1013633), // Rule ID 12848 //
     /* 1013561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013600 */     // MIs[0] policy
     /* 1013600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1013613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013632 */     // GIR_Coverage, 12848,
     /* 1013632 */     GIR_EraseRootFromParent_Done,
     /* 1013633 */   // Label 15048: @1013633
     /* 1013633 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1013710), // Rule ID 12849 //
     /* 1013638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013677 */     // MIs[0] policy
     /* 1013677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013687 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1013690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013709 */     // GIR_Coverage, 12849,
     /* 1013709 */     GIR_EraseRootFromParent_Done,
     /* 1013710 */   // Label 15049: @1013710
     /* 1013710 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1013787), // Rule ID 12852 //
     /* 1013715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013754 */     // MIs[0] policy
     /* 1013754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1013767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013786 */     // GIR_Coverage, 12852,
     /* 1013786 */     GIR_EraseRootFromParent_Done,
     /* 1013787 */   // Label 15050: @1013787
     /* 1013787 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1013864), // Rule ID 12853 //
     /* 1013792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013831 */     // MIs[0] policy
     /* 1013831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013841 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1013844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013863 */     // GIR_Coverage, 12853,
     /* 1013863 */     GIR_EraseRootFromParent_Done,
     /* 1013864 */   // Label 15051: @1013864
     /* 1013864 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1013941), // Rule ID 12856 //
     /* 1013869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1013886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013908 */     // MIs[0] policy
     /* 1013908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013940 */     // GIR_Coverage, 12856,
     /* 1013940 */     GIR_EraseRootFromParent_Done,
     /* 1013941 */   // Label 15052: @1013941
     /* 1013941 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1014018), // Rule ID 12857 //
     /* 1013946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1013954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1013963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1013981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013985 */     // MIs[0] policy
     /* 1013985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1013998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014017 */     // GIR_Coverage, 12857,
     /* 1014017 */     GIR_EraseRootFromParent_Done,
     /* 1014018 */   // Label 15053: @1014018
     /* 1014018 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1014095), // Rule ID 12860 //
     /* 1014023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014062 */     // MIs[0] policy
     /* 1014062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014072 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014094 */     // GIR_Coverage, 12860,
     /* 1014094 */     GIR_EraseRootFromParent_Done,
     /* 1014095 */   // Label 15054: @1014095
     /* 1014095 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1014172), // Rule ID 12861 //
     /* 1014100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1014111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1014114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1014120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014139 */     // MIs[0] policy
     /* 1014139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014149 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014171 */     // GIR_Coverage, 12861,
     /* 1014171 */     GIR_EraseRootFromParent_Done,
     /* 1014172 */   // Label 15055: @1014172
     /* 1014172 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1014249), // Rule ID 12864 //
     /* 1014177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014216 */     // MIs[0] policy
     /* 1014216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014248 */     // GIR_Coverage, 12864,
     /* 1014248 */     GIR_EraseRootFromParent_Done,
     /* 1014249 */   // Label 15056: @1014249
     /* 1014249 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1014326), // Rule ID 12865 //
     /* 1014254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1014265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1014268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1014274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014293 */     // MIs[0] policy
     /* 1014293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014303 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014325 */     // GIR_Coverage, 12865,
     /* 1014325 */     GIR_EraseRootFromParent_Done,
     /* 1014326 */   // Label 15057: @1014326
     /* 1014326 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1014403), // Rule ID 12868 //
     /* 1014331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014370 */     // MIs[0] policy
     /* 1014370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014402 */     // GIR_Coverage, 12868,
     /* 1014402 */     GIR_EraseRootFromParent_Done,
     /* 1014403 */   // Label 15058: @1014403
     /* 1014403 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1014480), // Rule ID 12869 //
     /* 1014408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1014419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1014422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1014428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014447 */     // MIs[0] policy
     /* 1014447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014479 */     // GIR_Coverage, 12869,
     /* 1014479 */     GIR_EraseRootFromParent_Done,
     /* 1014480 */   // Label 15059: @1014480
     /* 1014480 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1014557), // Rule ID 12872 //
     /* 1014485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014524 */     // MIs[0] policy
     /* 1014524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014556 */     // GIR_Coverage, 12872,
     /* 1014556 */     GIR_EraseRootFromParent_Done,
     /* 1014557 */   // Label 15060: @1014557
     /* 1014557 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1014634), // Rule ID 12873 //
     /* 1014562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014601 */     // MIs[0] policy
     /* 1014601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014633 */     // GIR_Coverage, 12873,
     /* 1014633 */     GIR_EraseRootFromParent_Done,
     /* 1014634 */   // Label 15061: @1014634
     /* 1014634 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1014711), // Rule ID 12876 //
     /* 1014639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014678 */     // MIs[0] policy
     /* 1014678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014710 */     // GIR_Coverage, 12876,
     /* 1014710 */     GIR_EraseRootFromParent_Done,
     /* 1014711 */   // Label 15062: @1014711
     /* 1014711 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1014788), // Rule ID 12877 //
     /* 1014716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014755 */     // MIs[0] policy
     /* 1014755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014765 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1014768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014787 */     // GIR_Coverage, 12877,
     /* 1014787 */     GIR_EraseRootFromParent_Done,
     /* 1014788 */   // Label 15063: @1014788
     /* 1014788 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1014865), // Rule ID 12880 //
     /* 1014793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014832 */     // MIs[0] policy
     /* 1014832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014864 */     // GIR_Coverage, 12880,
     /* 1014864 */     GIR_EraseRootFromParent_Done,
     /* 1014865 */   // Label 15064: @1014865
     /* 1014865 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1014942), // Rule ID 12881 //
     /* 1014870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014909 */     // MIs[0] policy
     /* 1014909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11349:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1014922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014941 */     // GIR_Coverage, 12881,
     /* 1014941 */     GIR_EraseRootFromParent_Done,
     /* 1014942 */   // Label 15065: @1014942
     /* 1014942 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1015019), // Rule ID 12884 //
     /* 1014947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1014955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014986 */     // MIs[0] policy
     /* 1014986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1014999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015018 */     // GIR_Coverage, 12884,
     /* 1015018 */     GIR_EraseRootFromParent_Done,
     /* 1015019 */   // Label 15066: @1015019
     /* 1015019 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1015096), // Rule ID 12885 //
     /* 1015024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1015035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1015038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1015044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1015063 */     // MIs[0] policy
     /* 1015063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015073 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11349:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1015076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015095 */     // GIR_Coverage, 12885,
     /* 1015095 */     GIR_EraseRootFromParent_Done,
     /* 1015096 */   // Label 15067: @1015096
     /* 1015096 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1015173), // Rule ID 12888 //
     /* 1015101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1015104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015140 */     // MIs[0] policy
     /* 1015140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1015153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015172 */     // GIR_Coverage, 12888,
     /* 1015172 */     GIR_EraseRootFromParent_Done,
     /* 1015173 */   // Label 15068: @1015173
     /* 1015173 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1015250), // Rule ID 12889 //
     /* 1015178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1015186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1015189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1015192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1015198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1015217 */     // MIs[0] policy
     /* 1015217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015227 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11349:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1015230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015249 */     // GIR_Coverage, 12889,
     /* 1015249 */     GIR_EraseRootFromParent_Done,
     /* 1015250 */   // Label 15069: @1015250
     /* 1015250 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1015327), // Rule ID 12892 //
     /* 1015255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1015272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015294 */     // MIs[0] policy
     /* 1015294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1015307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015326 */     // GIR_Coverage, 12892,
     /* 1015326 */     GIR_EraseRootFromParent_Done,
     /* 1015327 */   // Label 15070: @1015327
     /* 1015327 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1015404), // Rule ID 12893 //
     /* 1015332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1015343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1015346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1015349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1015352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015371 */     // MIs[0] policy
     /* 1015371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015381 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1015384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015403 */     // GIR_Coverage, 12893,
     /* 1015403 */     GIR_EraseRootFromParent_Done,
     /* 1015404 */   // Label 15071: @1015404
     /* 1015404 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1015481), // Rule ID 12896 //
     /* 1015409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1015426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015448 */     // MIs[0] policy
     /* 1015448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015458 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015480 */     // GIR_Coverage, 12896,
     /* 1015480 */     GIR_EraseRootFromParent_Done,
     /* 1015481 */   // Label 15072: @1015481
     /* 1015481 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1015558), // Rule ID 12897 //
     /* 1015486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1015503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015525 */     // MIs[0] policy
     /* 1015525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015535 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015557 */     // GIR_Coverage, 12897,
     /* 1015557 */     GIR_EraseRootFromParent_Done,
     /* 1015558 */   // Label 15073: @1015558
     /* 1015558 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1015635), // Rule ID 12900 //
     /* 1015563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1015580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015602 */     // MIs[0] policy
     /* 1015602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015634 */     // GIR_Coverage, 12900,
     /* 1015634 */     GIR_EraseRootFromParent_Done,
     /* 1015635 */   // Label 15074: @1015635
     /* 1015635 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1015712), // Rule ID 12901 //
     /* 1015640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1015657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015679 */     // MIs[0] policy
     /* 1015679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015689 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015711 */     // GIR_Coverage, 12901,
     /* 1015711 */     GIR_EraseRootFromParent_Done,
     /* 1015712 */   // Label 15075: @1015712
     /* 1015712 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1015789), // Rule ID 12904 //
     /* 1015717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1015734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015756 */     // MIs[0] policy
     /* 1015756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015788 */     // GIR_Coverage, 12904,
     /* 1015788 */     GIR_EraseRootFromParent_Done,
     /* 1015789 */   // Label 15076: @1015789
     /* 1015789 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1015866), // Rule ID 12905 //
     /* 1015794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1015811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015833 */     // MIs[0] policy
     /* 1015833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1015846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015865 */     // GIR_Coverage, 12905,
     /* 1015865 */     GIR_EraseRootFromParent_Done,
     /* 1015866 */   // Label 15077: @1015866
     /* 1015866 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1015943), // Rule ID 12908 //
     /* 1015871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1015888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015910 */     // MIs[0] policy
     /* 1015910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1015923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015942 */     // GIR_Coverage, 12908,
     /* 1015942 */     GIR_EraseRootFromParent_Done,
     /* 1015943 */   // Label 15078: @1015943
     /* 1015943 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1016020), // Rule ID 12909 //
     /* 1015948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1015965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015987 */     // MIs[0] policy
     /* 1015987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015997 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016019 */     // GIR_Coverage, 12909,
     /* 1016019 */     GIR_EraseRootFromParent_Done,
     /* 1016020 */   // Label 15079: @1016020
     /* 1016020 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1016097), // Rule ID 12912 //
     /* 1016025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016064 */     // MIs[0] policy
     /* 1016064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016096 */     // GIR_Coverage, 12912,
     /* 1016096 */     GIR_EraseRootFromParent_Done,
     /* 1016097 */   // Label 15080: @1016097
     /* 1016097 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1016174), // Rule ID 12913 //
     /* 1016102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1016113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1016116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1016119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1016122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016141 */     // MIs[0] policy
     /* 1016141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1016154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016173 */     // GIR_Coverage, 12913,
     /* 1016173 */     GIR_EraseRootFromParent_Done,
     /* 1016174 */   // Label 15081: @1016174
     /* 1016174 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1016251), // Rule ID 12916 //
     /* 1016179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1016196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016218 */     // MIs[0] policy
     /* 1016218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016250 */     // GIR_Coverage, 12916,
     /* 1016250 */     GIR_EraseRootFromParent_Done,
     /* 1016251 */   // Label 15082: @1016251
     /* 1016251 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1016328), // Rule ID 12917 //
     /* 1016256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1016267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1016270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1016273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1016276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016295 */     // MIs[0] policy
     /* 1016295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016305 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016327 */     // GIR_Coverage, 12917,
     /* 1016327 */     GIR_EraseRootFromParent_Done,
     /* 1016328 */   // Label 15083: @1016328
     /* 1016328 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1016405), // Rule ID 12920 //
     /* 1016333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1016350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016372 */     // MIs[0] policy
     /* 1016372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016404 */     // GIR_Coverage, 12920,
     /* 1016404 */     GIR_EraseRootFromParent_Done,
     /* 1016405 */   // Label 15084: @1016405
     /* 1016405 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1016482), // Rule ID 12921 //
     /* 1016410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1016421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1016424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1016427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1016430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016449 */     // MIs[0] policy
     /* 1016449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016481 */     // GIR_Coverage, 12921,
     /* 1016481 */     GIR_EraseRootFromParent_Done,
     /* 1016482 */   // Label 15085: @1016482
     /* 1016482 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1016559), // Rule ID 12924 //
     /* 1016487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016526 */     // MIs[0] policy
     /* 1016526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016558 */     // GIR_Coverage, 12924,
     /* 1016558 */     GIR_EraseRootFromParent_Done,
     /* 1016559 */   // Label 15086: @1016559
     /* 1016559 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1016636), // Rule ID 12925 //
     /* 1016564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1016581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016603 */     // MIs[0] policy
     /* 1016603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016613 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016635 */     // GIR_Coverage, 12925,
     /* 1016635 */     GIR_EraseRootFromParent_Done,
     /* 1016636 */   // Label 15087: @1016636
     /* 1016636 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1016713), // Rule ID 12928 //
     /* 1016641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1016658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016680 */     // MIs[0] policy
     /* 1016680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016712 */     // GIR_Coverage, 12928,
     /* 1016712 */     GIR_EraseRootFromParent_Done,
     /* 1016713 */   // Label 15088: @1016713
     /* 1016713 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1016790), // Rule ID 12929 //
     /* 1016718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1016735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016757 */     // MIs[0] policy
     /* 1016757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016767 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1016770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016789 */     // GIR_Coverage, 12929,
     /* 1016789 */     GIR_EraseRootFromParent_Done,
     /* 1016790 */   // Label 15089: @1016790
     /* 1016790 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1016867), // Rule ID 12932 //
     /* 1016795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1016812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016834 */     // MIs[0] policy
     /* 1016834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1016847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016866 */     // GIR_Coverage, 12932,
     /* 1016866 */     GIR_EraseRootFromParent_Done,
     /* 1016867 */   // Label 15090: @1016867
     /* 1016867 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1016944), // Rule ID 12933 //
     /* 1016872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1016889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016911 */     // MIs[0] policy
     /* 1016911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1016924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016943 */     // GIR_Coverage, 12933,
     /* 1016943 */     GIR_EraseRootFromParent_Done,
     /* 1016944 */   // Label 15091: @1016944
     /* 1016944 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1017021), // Rule ID 12936 //
     /* 1016949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1016966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016988 */     // MIs[0] policy
     /* 1016988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017020 */     // GIR_Coverage, 12936,
     /* 1017020 */     GIR_EraseRootFromParent_Done,
     /* 1017021 */   // Label 15092: @1017021
     /* 1017021 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1017098), // Rule ID 12937 //
     /* 1017026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1017037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1017040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1017043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1017046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017065 */     // MIs[0] policy
     /* 1017065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017075 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017097 */     // GIR_Coverage, 12937,
     /* 1017097 */     GIR_EraseRootFromParent_Done,
     /* 1017098 */   // Label 15093: @1017098
     /* 1017098 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1017175), // Rule ID 12940 //
     /* 1017103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1017120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017142 */     // MIs[0] policy
     /* 1017142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017174 */     // GIR_Coverage, 12940,
     /* 1017174 */     GIR_EraseRootFromParent_Done,
     /* 1017175 */   // Label 15094: @1017175
     /* 1017175 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1017252), // Rule ID 12941 //
     /* 1017180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1017191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1017194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1017197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1017200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017219 */     // MIs[0] policy
     /* 1017219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017229 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017251 */     // GIR_Coverage, 12941,
     /* 1017251 */     GIR_EraseRootFromParent_Done,
     /* 1017252 */   // Label 15095: @1017252
     /* 1017252 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1017329), // Rule ID 12944 //
     /* 1017257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1017274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017296 */     // MIs[0] policy
     /* 1017296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017328 */     // GIR_Coverage, 12944,
     /* 1017328 */     GIR_EraseRootFromParent_Done,
     /* 1017329 */   // Label 15096: @1017329
     /* 1017329 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1017406), // Rule ID 12945 //
     /* 1017334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1017345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1017348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1017351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1017354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017373 */     // MIs[0] policy
     /* 1017373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017405 */     // GIR_Coverage, 12945,
     /* 1017405 */     GIR_EraseRootFromParent_Done,
     /* 1017406 */   // Label 15097: @1017406
     /* 1017406 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1017483), // Rule ID 12948 //
     /* 1017411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1017428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017450 */     // MIs[0] policy
     /* 1017450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017482 */     // GIR_Coverage, 12948,
     /* 1017482 */     GIR_EraseRootFromParent_Done,
     /* 1017483 */   // Label 15098: @1017483
     /* 1017483 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1017560), // Rule ID 12949 //
     /* 1017488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1017505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017527 */     // MIs[0] policy
     /* 1017527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017559 */     // GIR_Coverage, 12949,
     /* 1017559 */     GIR_EraseRootFromParent_Done,
     /* 1017560 */   // Label 15099: @1017560
     /* 1017560 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1017637), // Rule ID 12952 //
     /* 1017565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1017582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017604 */     // MIs[0] policy
     /* 1017604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017636 */     // GIR_Coverage, 12952,
     /* 1017636 */     GIR_EraseRootFromParent_Done,
     /* 1017637 */   // Label 15100: @1017637
     /* 1017637 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1017714), // Rule ID 12953 //
     /* 1017642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1017659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017681 */     // MIs[0] policy
     /* 1017681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1017694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017713 */     // GIR_Coverage, 12953,
     /* 1017713 */     GIR_EraseRootFromParent_Done,
     /* 1017714 */   // Label 15101: @1017714
     /* 1017714 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1017791), // Rule ID 12956 //
     /* 1017719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017758 */     // MIs[0] policy
     /* 1017758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017790 */     // GIR_Coverage, 12956,
     /* 1017790 */     GIR_EraseRootFromParent_Done,
     /* 1017791 */   // Label 15102: @1017791
     /* 1017791 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1017868), // Rule ID 12957 //
     /* 1017796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1017813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017835 */     // MIs[0] policy
     /* 1017835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1017848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017867 */     // GIR_Coverage, 12957,
     /* 1017867 */     GIR_EraseRootFromParent_Done,
     /* 1017868 */   // Label 15103: @1017868
     /* 1017868 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1017945), // Rule ID 12960 //
     /* 1017873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017912 */     // MIs[0] policy
     /* 1017912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1017925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017944 */     // GIR_Coverage, 12960,
     /* 1017944 */     GIR_EraseRootFromParent_Done,
     /* 1017945 */   // Label 15104: @1017945
     /* 1017945 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1018022), // Rule ID 12961 //
     /* 1017950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1017967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017989 */     // MIs[0] policy
     /* 1017989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018021 */     // GIR_Coverage, 12961,
     /* 1018021 */     GIR_EraseRootFromParent_Done,
     /* 1018022 */   // Label 15105: @1018022
     /* 1018022 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1018099), // Rule ID 12964 //
     /* 1018027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018066 */     // MIs[0] policy
     /* 1018066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018098 */     // GIR_Coverage, 12964,
     /* 1018098 */     GIR_EraseRootFromParent_Done,
     /* 1018099 */   // Label 15106: @1018099
     /* 1018099 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1018176), // Rule ID 12965 //
     /* 1018104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1018115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1018118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1018121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1018124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018143 */     // MIs[0] policy
     /* 1018143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018153 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018175 */     // GIR_Coverage, 12965,
     /* 1018175 */     GIR_EraseRootFromParent_Done,
     /* 1018176 */   // Label 15107: @1018176
     /* 1018176 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1018253), // Rule ID 12968 //
     /* 1018181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1018198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018220 */     // MIs[0] policy
     /* 1018220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1018233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018252 */     // GIR_Coverage, 12968,
     /* 1018252 */     GIR_EraseRootFromParent_Done,
     /* 1018253 */   // Label 15108: @1018253
     /* 1018253 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1018330), // Rule ID 12969 //
     /* 1018258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1018269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1018272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1018275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1018278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1018297 */     // MIs[0] policy
     /* 1018297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1018310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018329 */     // GIR_Coverage, 12969,
     /* 1018329 */     GIR_EraseRootFromParent_Done,
     /* 1018330 */   // Label 15109: @1018330
     /* 1018330 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1018407), // Rule ID 12972 //
     /* 1018335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1018352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018374 */     // MIs[0] policy
     /* 1018374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018406 */     // GIR_Coverage, 12972,
     /* 1018406 */     GIR_EraseRootFromParent_Done,
     /* 1018407 */   // Label 15110: @1018407
     /* 1018407 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1018484), // Rule ID 12973 //
     /* 1018412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1018423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1018426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1018429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1018432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1018451 */     // MIs[0] policy
     /* 1018451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1018464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018483 */     // GIR_Coverage, 12973,
     /* 1018483 */     GIR_EraseRootFromParent_Done,
     /* 1018484 */   // Label 15111: @1018484
     /* 1018484 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1018561), // Rule ID 12976 //
     /* 1018489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1018506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018528 */     // MIs[0] policy
     /* 1018528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018538 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018560 */     // GIR_Coverage, 12976,
     /* 1018560 */     GIR_EraseRootFromParent_Done,
     /* 1018561 */   // Label 15112: @1018561
     /* 1018561 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1018638), // Rule ID 12977 //
     /* 1018566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1018583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018605 */     // MIs[0] policy
     /* 1018605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018615 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1018618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018637 */     // GIR_Coverage, 12977,
     /* 1018637 */     GIR_EraseRootFromParent_Done,
     /* 1018638 */   // Label 15113: @1018638
     /* 1018638 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1018715), // Rule ID 12980 //
     /* 1018643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018682 */     // MIs[0] policy
     /* 1018682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018692 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1018695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018714 */     // GIR_Coverage, 12980,
     /* 1018714 */     GIR_EraseRootFromParent_Done,
     /* 1018715 */   // Label 15114: @1018715
     /* 1018715 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1018792), // Rule ID 12981 //
     /* 1018720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018759 */     // MIs[0] policy
     /* 1018759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018769 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1018772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018791 */     // GIR_Coverage, 12981,
     /* 1018791 */     GIR_EraseRootFromParent_Done,
     /* 1018792 */   // Label 15115: @1018792
     /* 1018792 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1018869), // Rule ID 12984 //
     /* 1018797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018836 */     // MIs[0] policy
     /* 1018836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1018849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018868 */     // GIR_Coverage, 12984,
     /* 1018868 */     GIR_EraseRootFromParent_Done,
     /* 1018869 */   // Label 15116: @1018869
     /* 1018869 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1018946), // Rule ID 12985 //
     /* 1018874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018913 */     // MIs[0] policy
     /* 1018913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018923 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1018926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018945 */     // GIR_Coverage, 12985,
     /* 1018945 */     GIR_EraseRootFromParent_Done,
     /* 1018946 */   // Label 15117: @1018946
     /* 1018946 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1019023), // Rule ID 12988 //
     /* 1018951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018990 */     // MIs[0] policy
     /* 1018990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019022 */     // GIR_Coverage, 12988,
     /* 1019022 */     GIR_EraseRootFromParent_Done,
     /* 1019023 */   // Label 15118: @1019023
     /* 1019023 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1019100), // Rule ID 12989 //
     /* 1019028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1019039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1019042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1019048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019067 */     // MIs[0] policy
     /* 1019067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019077 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019099 */     // GIR_Coverage, 12989,
     /* 1019099 */     GIR_EraseRootFromParent_Done,
     /* 1019100 */   // Label 15119: @1019100
     /* 1019100 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1019177), // Rule ID 12992 //
     /* 1019105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019144 */     // MIs[0] policy
     /* 1019144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1019157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019176 */     // GIR_Coverage, 12992,
     /* 1019176 */     GIR_EraseRootFromParent_Done,
     /* 1019177 */   // Label 15120: @1019177
     /* 1019177 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1019254), // Rule ID 12993 //
     /* 1019182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1019193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1019196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1019202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019221 */     // MIs[0] policy
     /* 1019221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019231 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1019234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019253 */     // GIR_Coverage, 12993,
     /* 1019253 */     GIR_EraseRootFromParent_Done,
     /* 1019254 */   // Label 15121: @1019254
     /* 1019254 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1019331), // Rule ID 12996 //
     /* 1019259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019298 */     // MIs[0] policy
     /* 1019298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019330 */     // GIR_Coverage, 12996,
     /* 1019330 */     GIR_EraseRootFromParent_Done,
     /* 1019331 */   // Label 15122: @1019331
     /* 1019331 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1019408), // Rule ID 12997 //
     /* 1019336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1019347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1019350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1019356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019375 */     // MIs[0] policy
     /* 1019375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019385 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019407 */     // GIR_Coverage, 12997,
     /* 1019407 */     GIR_EraseRootFromParent_Done,
     /* 1019408 */   // Label 15123: @1019408
     /* 1019408 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1019485), // Rule ID 13000 //
     /* 1019413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019452 */     // MIs[0] policy
     /* 1019452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019484 */     // GIR_Coverage, 13000,
     /* 1019484 */     GIR_EraseRootFromParent_Done,
     /* 1019485 */   // Label 15124: @1019485
     /* 1019485 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1019562), // Rule ID 13001 //
     /* 1019490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019529 */     // MIs[0] policy
     /* 1019529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019539 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1019542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019561 */     // GIR_Coverage, 13001,
     /* 1019561 */     GIR_EraseRootFromParent_Done,
     /* 1019562 */   // Label 15125: @1019562
     /* 1019562 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1019639), // Rule ID 13004 //
     /* 1019567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019606 */     // MIs[0] policy
     /* 1019606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019638 */     // GIR_Coverage, 13004,
     /* 1019638 */     GIR_EraseRootFromParent_Done,
     /* 1019639 */   // Label 15126: @1019639
     /* 1019639 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1019716), // Rule ID 13005 //
     /* 1019644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019683 */     // MIs[0] policy
     /* 1019683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019715 */     // GIR_Coverage, 13005,
     /* 1019715 */     GIR_EraseRootFromParent_Done,
     /* 1019716 */   // Label 15127: @1019716
     /* 1019716 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1019793), // Rule ID 13008 //
     /* 1019721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019760 */     // MIs[0] policy
     /* 1019760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019792 */     // GIR_Coverage, 13008,
     /* 1019792 */     GIR_EraseRootFromParent_Done,
     /* 1019793 */   // Label 15128: @1019793
     /* 1019793 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1019870), // Rule ID 13009 //
     /* 1019798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019837 */     // MIs[0] policy
     /* 1019837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019847 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019869 */     // GIR_Coverage, 13009,
     /* 1019869 */     GIR_EraseRootFromParent_Done,
     /* 1019870 */   // Label 15129: @1019870
     /* 1019870 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1019947), // Rule ID 13012 //
     /* 1019875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1019892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019914 */     // MIs[0] policy
     /* 1019914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1019927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019946 */     // GIR_Coverage, 13012,
     /* 1019946 */     GIR_EraseRootFromParent_Done,
     /* 1019947 */   // Label 15130: @1019947
     /* 1019947 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1020024), // Rule ID 13013 //
     /* 1019952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1019960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1019969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1019987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019991 */     // MIs[0] policy
     /* 1019991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020023 */     // GIR_Coverage, 13013,
     /* 1020023 */     GIR_EraseRootFromParent_Done,
     /* 1020024 */   // Label 15131: @1020024
     /* 1020024 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1020101), // Rule ID 13016 //
     /* 1020029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020068 */     // MIs[0] policy
     /* 1020068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020100 */     // GIR_Coverage, 13016,
     /* 1020100 */     GIR_EraseRootFromParent_Done,
     /* 1020101 */   // Label 15132: @1020101
     /* 1020101 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1020178), // Rule ID 13017 //
     /* 1020106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1020117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1020120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1020126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1020145 */     // MIs[0] policy
     /* 1020145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020155 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1020158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020177 */     // GIR_Coverage, 13017,
     /* 1020177 */     GIR_EraseRootFromParent_Done,
     /* 1020178 */   // Label 15133: @1020178
     /* 1020178 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1020255), // Rule ID 13020 //
     /* 1020183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020222 */     // MIs[0] policy
     /* 1020222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020232 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020254 */     // GIR_Coverage, 13020,
     /* 1020254 */     GIR_EraseRootFromParent_Done,
     /* 1020255 */   // Label 15134: @1020255
     /* 1020255 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1020332), // Rule ID 13021 //
     /* 1020260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1020271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1020274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1020280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020299 */     // MIs[0] policy
     /* 1020299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020309 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020331 */     // GIR_Coverage, 13021,
     /* 1020331 */     GIR_EraseRootFromParent_Done,
     /* 1020332 */   // Label 15135: @1020332
     /* 1020332 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1020409), // Rule ID 13024 //
     /* 1020337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020376 */     // MIs[0] policy
     /* 1020376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020386 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020408 */     // GIR_Coverage, 13024,
     /* 1020408 */     GIR_EraseRootFromParent_Done,
     /* 1020409 */   // Label 15136: @1020409
     /* 1020409 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1020486), // Rule ID 13025 //
     /* 1020414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1020425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1020428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1020434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020453 */     // MIs[0] policy
     /* 1020453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020463 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020485 */     // GIR_Coverage, 13025,
     /* 1020485 */     GIR_EraseRootFromParent_Done,
     /* 1020486 */   // Label 15137: @1020486
     /* 1020486 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1020563), // Rule ID 13028 //
     /* 1020491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020530 */     // MIs[0] policy
     /* 1020530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020540 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1020543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020562 */     // GIR_Coverage, 13028,
     /* 1020562 */     GIR_EraseRootFromParent_Done,
     /* 1020563 */   // Label 15138: @1020563
     /* 1020563 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1020640), // Rule ID 13029 //
     /* 1020568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020607 */     // MIs[0] policy
     /* 1020607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020617 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1020620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020639 */     // GIR_Coverage, 13029,
     /* 1020639 */     GIR_EraseRootFromParent_Done,
     /* 1020640 */   // Label 15139: @1020640
     /* 1020640 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1020717), // Rule ID 13032 //
     /* 1020645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020684 */     // MIs[0] policy
     /* 1020684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020716 */     // GIR_Coverage, 13032,
     /* 1020716 */     GIR_EraseRootFromParent_Done,
     /* 1020717 */   // Label 15140: @1020717
     /* 1020717 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1020794), // Rule ID 13033 //
     /* 1020722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020761 */     // MIs[0] policy
     /* 1020761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1020774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020793 */     // GIR_Coverage, 13033,
     /* 1020793 */     GIR_EraseRootFromParent_Done,
     /* 1020794 */   // Label 15141: @1020794
     /* 1020794 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1020871), // Rule ID 13036 //
     /* 1020799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020838 */     // MIs[0] policy
     /* 1020838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020870 */     // GIR_Coverage, 13036,
     /* 1020870 */     GIR_EraseRootFromParent_Done,
     /* 1020871 */   // Label 15142: @1020871
     /* 1020871 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1020948), // Rule ID 13037 //
     /* 1020876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1020893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020915 */     // MIs[0] policy
     /* 1020915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020925 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1020928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020947 */     // GIR_Coverage, 13037,
     /* 1020947 */     GIR_EraseRootFromParent_Done,
     /* 1020948 */   // Label 15143: @1020948
     /* 1020948 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1021025), // Rule ID 13040 //
     /* 1020953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1020961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1020970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1020988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020992 */     // MIs[0] policy
     /* 1020992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021024 */     // GIR_Coverage, 13040,
     /* 1021024 */     GIR_EraseRootFromParent_Done,
     /* 1021025 */   // Label 15144: @1021025
     /* 1021025 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1021102), // Rule ID 13041 //
     /* 1021030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1021041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1021044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1021050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021069 */     // MIs[0] policy
     /* 1021069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021079 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021101 */     // GIR_Coverage, 13041,
     /* 1021101 */     GIR_EraseRootFromParent_Done,
     /* 1021102 */   // Label 15145: @1021102
     /* 1021102 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1021179), // Rule ID 13044 //
     /* 1021107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021146 */     // MIs[0] policy
     /* 1021146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021178 */     // GIR_Coverage, 13044,
     /* 1021178 */     GIR_EraseRootFromParent_Done,
     /* 1021179 */   // Label 15146: @1021179
     /* 1021179 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1021256), // Rule ID 13045 //
     /* 1021184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1021195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1021198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1021204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021223 */     // MIs[0] policy
     /* 1021223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021255 */     // GIR_Coverage, 13045,
     /* 1021255 */     GIR_EraseRootFromParent_Done,
     /* 1021256 */   // Label 15147: @1021256
     /* 1021256 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1021333), // Rule ID 13048 //
     /* 1021261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021300 */     // MIs[0] policy
     /* 1021300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021332 */     // GIR_Coverage, 13048,
     /* 1021332 */     GIR_EraseRootFromParent_Done,
     /* 1021333 */   // Label 15148: @1021333
     /* 1021333 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1021410), // Rule ID 13049 //
     /* 1021338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1021349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1021352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1021358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021377 */     // MIs[0] policy
     /* 1021377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021387 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021409 */     // GIR_Coverage, 13049,
     /* 1021409 */     GIR_EraseRootFromParent_Done,
     /* 1021410 */   // Label 15149: @1021410
     /* 1021410 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1021487), // Rule ID 13052 //
     /* 1021415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021454 */     // MIs[0] policy
     /* 1021454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021486 */     // GIR_Coverage, 13052,
     /* 1021486 */     GIR_EraseRootFromParent_Done,
     /* 1021487 */   // Label 15150: @1021487
     /* 1021487 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1021564), // Rule ID 13053 //
     /* 1021492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021531 */     // MIs[0] policy
     /* 1021531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021541 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021563 */     // GIR_Coverage, 13053,
     /* 1021563 */     GIR_EraseRootFromParent_Done,
     /* 1021564 */   // Label 15151: @1021564
     /* 1021564 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1021641), // Rule ID 13056 //
     /* 1021569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021608 */     // MIs[0] policy
     /* 1021608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021640 */     // GIR_Coverage, 13056,
     /* 1021640 */     GIR_EraseRootFromParent_Done,
     /* 1021641 */   // Label 15152: @1021641
     /* 1021641 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1021718), // Rule ID 13057 //
     /* 1021646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021685 */     // MIs[0] policy
     /* 1021685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1021698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021717 */     // GIR_Coverage, 13057,
     /* 1021717 */     GIR_EraseRootFromParent_Done,
     /* 1021718 */   // Label 15153: @1021718
     /* 1021718 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1021795), // Rule ID 13060 //
     /* 1021723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021762 */     // MIs[0] policy
     /* 1021762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021794 */     // GIR_Coverage, 13060,
     /* 1021794 */     GIR_EraseRootFromParent_Done,
     /* 1021795 */   // Label 15154: @1021795
     /* 1021795 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1021872), // Rule ID 13061 //
     /* 1021800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021839 */     // MIs[0] policy
     /* 1021839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021849 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1021852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021871 */     // GIR_Coverage, 13061,
     /* 1021871 */     GIR_EraseRootFromParent_Done,
     /* 1021872 */   // Label 15155: @1021872
     /* 1021872 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1021949), // Rule ID 13064 //
     /* 1021877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021916 */     // MIs[0] policy
     /* 1021916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1021929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021948 */     // GIR_Coverage, 13064,
     /* 1021948 */     GIR_EraseRootFromParent_Done,
     /* 1021949 */   // Label 15156: @1021949
     /* 1021949 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1022026), // Rule ID 13065 //
     /* 1021954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1021962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021993 */     // MIs[0] policy
     /* 1021993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022003 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1022006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022025 */     // GIR_Coverage, 13065,
     /* 1022025 */     GIR_EraseRootFromParent_Done,
     /* 1022026 */   // Label 15157: @1022026
     /* 1022026 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1022103), // Rule ID 13068 //
     /* 1022031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1022048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022070 */     // MIs[0] policy
     /* 1022070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1022083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022102 */     // GIR_Coverage, 13068,
     /* 1022102 */     GIR_EraseRootFromParent_Done,
     /* 1022103 */   // Label 15158: @1022103
     /* 1022103 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1022180), // Rule ID 13069 //
     /* 1022108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1022119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1022122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1022125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1022128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022147 */     // MIs[0] policy
     /* 1022147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022157 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1022160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022179 */     // GIR_Coverage, 13069,
     /* 1022179 */     GIR_EraseRootFromParent_Done,
     /* 1022180 */   // Label 15159: @1022180
     /* 1022180 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1022257), // Rule ID 13072 //
     /* 1022185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1022202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022224 */     // MIs[0] policy
     /* 1022224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022256 */     // GIR_Coverage, 13072,
     /* 1022256 */     GIR_EraseRootFromParent_Done,
     /* 1022257 */   // Label 15160: @1022257
     /* 1022257 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1022334), // Rule ID 13073 //
     /* 1022262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1022273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1022276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1022279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1022282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022301 */     // MIs[0] policy
     /* 1022301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022311 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022333 */     // GIR_Coverage, 13073,
     /* 1022333 */     GIR_EraseRootFromParent_Done,
     /* 1022334 */   // Label 15161: @1022334
     /* 1022334 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1022411), // Rule ID 13076 //
     /* 1022339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022378 */     // MIs[0] policy
     /* 1022378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022388 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022410 */     // GIR_Coverage, 13076,
     /* 1022410 */     GIR_EraseRootFromParent_Done,
     /* 1022411 */   // Label 15162: @1022411
     /* 1022411 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1022488), // Rule ID 13077 //
     /* 1022416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1022427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1022430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1022433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1022436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022455 */     // MIs[0] policy
     /* 1022455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022465 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022487 */     // GIR_Coverage, 13077,
     /* 1022487 */     GIR_EraseRootFromParent_Done,
     /* 1022488 */   // Label 15163: @1022488
     /* 1022488 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1022565), // Rule ID 13080 //
     /* 1022493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1022510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022532 */     // MIs[0] policy
     /* 1022532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022564 */     // GIR_Coverage, 13080,
     /* 1022564 */     GIR_EraseRootFromParent_Done,
     /* 1022565 */   // Label 15164: @1022565
     /* 1022565 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1022642), // Rule ID 13081 //
     /* 1022570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1022587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022609 */     // MIs[0] policy
     /* 1022609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022619 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1022622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022641 */     // GIR_Coverage, 13081,
     /* 1022641 */     GIR_EraseRootFromParent_Done,
     /* 1022642 */   // Label 15165: @1022642
     /* 1022642 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1022719), // Rule ID 13084 //
     /* 1022647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1022664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022686 */     // MIs[0] policy
     /* 1022686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022718 */     // GIR_Coverage, 13084,
     /* 1022718 */     GIR_EraseRootFromParent_Done,
     /* 1022719 */   // Label 15166: @1022719
     /* 1022719 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1022796), // Rule ID 13085 //
     /* 1022724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1022741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022763 */     // MIs[0] policy
     /* 1022763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022773 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022795 */     // GIR_Coverage, 13085,
     /* 1022795 */     GIR_EraseRootFromParent_Done,
     /* 1022796 */   // Label 15167: @1022796
     /* 1022796 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1022873), // Rule ID 13088 //
     /* 1022801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1022818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022840 */     // MIs[0] policy
     /* 1022840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022872 */     // GIR_Coverage, 13088,
     /* 1022872 */     GIR_EraseRootFromParent_Done,
     /* 1022873 */   // Label 15168: @1022873
     /* 1022873 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1022950), // Rule ID 13089 //
     /* 1022878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1022895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022917 */     // MIs[0] policy
     /* 1022917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1022930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022949 */     // GIR_Coverage, 13089,
     /* 1022949 */     GIR_EraseRootFromParent_Done,
     /* 1022950 */   // Label 15169: @1022950
     /* 1022950 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1023027), // Rule ID 13092 //
     /* 1022955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1022972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022994 */     // MIs[0] policy
     /* 1022994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023026 */     // GIR_Coverage, 13092,
     /* 1023026 */     GIR_EraseRootFromParent_Done,
     /* 1023027 */   // Label 15170: @1023027
     /* 1023027 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1023104), // Rule ID 13093 //
     /* 1023032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1023043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1023046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1023049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1023052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023071 */     // MIs[0] policy
     /* 1023071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023081 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023103 */     // GIR_Coverage, 13093,
     /* 1023103 */     GIR_EraseRootFromParent_Done,
     /* 1023104 */   // Label 15171: @1023104
     /* 1023104 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1023181), // Rule ID 13096 //
     /* 1023109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1023126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023148 */     // MIs[0] policy
     /* 1023148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023180 */     // GIR_Coverage, 13096,
     /* 1023180 */     GIR_EraseRootFromParent_Done,
     /* 1023181 */   // Label 15172: @1023181
     /* 1023181 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1023258), // Rule ID 13097 //
     /* 1023186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1023197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1023200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1023203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1023206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023225 */     // MIs[0] policy
     /* 1023225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023235 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023257 */     // GIR_Coverage, 13097,
     /* 1023257 */     GIR_EraseRootFromParent_Done,
     /* 1023258 */   // Label 15173: @1023258
     /* 1023258 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1023335), // Rule ID 13100 //
     /* 1023263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1023280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023302 */     // MIs[0] policy
     /* 1023302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023334 */     // GIR_Coverage, 13100,
     /* 1023334 */     GIR_EraseRootFromParent_Done,
     /* 1023335 */   // Label 15174: @1023335
     /* 1023335 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1023412), // Rule ID 13101 //
     /* 1023340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1023351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1023354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1023357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1023360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023379 */     // MIs[0] policy
     /* 1023379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023389 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023411 */     // GIR_Coverage, 13101,
     /* 1023411 */     GIR_EraseRootFromParent_Done,
     /* 1023412 */   // Label 15175: @1023412
     /* 1023412 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1023489), // Rule ID 13104 //
     /* 1023417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1023420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1023434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023456 */     // MIs[0] policy
     /* 1023456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023488 */     // GIR_Coverage, 13104,
     /* 1023488 */     GIR_EraseRootFromParent_Done,
     /* 1023489 */   // Label 15176: @1023489
     /* 1023489 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1023566), // Rule ID 13105 //
     /* 1023494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1023511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023533 */     // MIs[0] policy
     /* 1023533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1023546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023565 */     // GIR_Coverage, 13105,
     /* 1023565 */     GIR_EraseRootFromParent_Done,
     /* 1023566 */   // Label 15177: @1023566
     /* 1023566 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1023643), // Rule ID 13108 //
     /* 1023571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1023588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023610 */     // MIs[0] policy
     /* 1023610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1023623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023642 */     // GIR_Coverage, 13108,
     /* 1023642 */     GIR_EraseRootFromParent_Done,
     /* 1023643 */   // Label 15178: @1023643
     /* 1023643 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1023720), // Rule ID 13109 //
     /* 1023648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1023665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023687 */     // MIs[0] policy
     /* 1023687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023697 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1023700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023719 */     // GIR_Coverage, 13109,
     /* 1023719 */     GIR_EraseRootFromParent_Done,
     /* 1023720 */   // Label 15179: @1023720
     /* 1023720 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1023797), // Rule ID 13112 //
     /* 1023725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1023742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023764 */     // MIs[0] policy
     /* 1023764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1023777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023796 */     // GIR_Coverage, 13112,
     /* 1023796 */     GIR_EraseRootFromParent_Done,
     /* 1023797 */   // Label 15180: @1023797
     /* 1023797 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1023874), // Rule ID 13113 //
     /* 1023802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1023819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023841 */     // MIs[0] policy
     /* 1023841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023851 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1023854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023873 */     // GIR_Coverage, 13113,
     /* 1023873 */     GIR_EraseRootFromParent_Done,
     /* 1023874 */   // Label 15181: @1023874
     /* 1023874 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1023951), // Rule ID 13116 //
     /* 1023879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023918 */     // MIs[0] policy
     /* 1023918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1023931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023950 */     // GIR_Coverage, 13116,
     /* 1023950 */     GIR_EraseRootFromParent_Done,
     /* 1023951 */   // Label 15182: @1023951
     /* 1023951 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1024028), // Rule ID 13117 //
     /* 1023956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1023973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023995 */     // MIs[0] policy
     /* 1023995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024005 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024027 */     // GIR_Coverage, 13117,
     /* 1024027 */     GIR_EraseRootFromParent_Done,
     /* 1024028 */   // Label 15183: @1024028
     /* 1024028 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1024105), // Rule ID 13120 //
     /* 1024033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1024050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024072 */     // MIs[0] policy
     /* 1024072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024104 */     // GIR_Coverage, 13120,
     /* 1024104 */     GIR_EraseRootFromParent_Done,
     /* 1024105 */   // Label 15184: @1024105
     /* 1024105 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1024182), // Rule ID 13121 //
     /* 1024110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1024121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1024124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1024127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1024130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024149 */     // MIs[0] policy
     /* 1024149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024181 */     // GIR_Coverage, 13121,
     /* 1024181 */     GIR_EraseRootFromParent_Done,
     /* 1024182 */   // Label 15185: @1024182
     /* 1024182 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1024259), // Rule ID 13124 //
     /* 1024187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1024204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024226 */     // MIs[0] policy
     /* 1024226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024258 */     // GIR_Coverage, 13124,
     /* 1024258 */     GIR_EraseRootFromParent_Done,
     /* 1024259 */   // Label 15186: @1024259
     /* 1024259 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1024336), // Rule ID 13125 //
     /* 1024264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1024275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1024278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1024281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1024284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024303 */     // MIs[0] policy
     /* 1024303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024313 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024335 */     // GIR_Coverage, 13125,
     /* 1024335 */     GIR_EraseRootFromParent_Done,
     /* 1024336 */   // Label 15187: @1024336
     /* 1024336 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1024413), // Rule ID 13128 //
     /* 1024341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1024358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024380 */     // MIs[0] policy
     /* 1024380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024412 */     // GIR_Coverage, 13128,
     /* 1024412 */     GIR_EraseRootFromParent_Done,
     /* 1024413 */   // Label 15188: @1024413
     /* 1024413 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1024490), // Rule ID 13129 //
     /* 1024418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1024429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1024432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1024435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1024438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024457 */     // MIs[0] policy
     /* 1024457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024467 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024489 */     // GIR_Coverage, 13129,
     /* 1024489 */     GIR_EraseRootFromParent_Done,
     /* 1024490 */   // Label 15189: @1024490
     /* 1024490 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1024567), // Rule ID 13132 //
     /* 1024495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1024512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024534 */     // MIs[0] policy
     /* 1024534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024566 */     // GIR_Coverage, 13132,
     /* 1024566 */     GIR_EraseRootFromParent_Done,
     /* 1024567 */   // Label 15190: @1024567
     /* 1024567 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1024644), // Rule ID 13133 //
     /* 1024572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1024589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024611 */     // MIs[0] policy
     /* 1024611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1024624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024643 */     // GIR_Coverage, 13133,
     /* 1024643 */     GIR_EraseRootFromParent_Done,
     /* 1024644 */   // Label 15191: @1024644
     /* 1024644 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1024721), // Rule ID 13136 //
     /* 1024649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1024666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024688 */     // MIs[0] policy
     /* 1024688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024720 */     // GIR_Coverage, 13136,
     /* 1024720 */     GIR_EraseRootFromParent_Done,
     /* 1024721 */   // Label 15192: @1024721
     /* 1024721 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1024798), // Rule ID 13137 //
     /* 1024726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1024743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024765 */     // MIs[0] policy
     /* 1024765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024775 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1024778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024797 */     // GIR_Coverage, 13137,
     /* 1024797 */     GIR_EraseRootFromParent_Done,
     /* 1024798 */   // Label 15193: @1024798
     /* 1024798 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1024875), // Rule ID 13140 //
     /* 1024803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1024820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024842 */     // MIs[0] policy
     /* 1024842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024874 */     // GIR_Coverage, 13140,
     /* 1024874 */     GIR_EraseRootFromParent_Done,
     /* 1024875 */   // Label 15194: @1024875
     /* 1024875 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1024952), // Rule ID 13141 //
     /* 1024880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1024897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024919 */     // MIs[0] policy
     /* 1024919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024929 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1024932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024951 */     // GIR_Coverage, 13141,
     /* 1024951 */     GIR_EraseRootFromParent_Done,
     /* 1024952 */   // Label 15195: @1024952
     /* 1024952 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1025029), // Rule ID 13144 //
     /* 1024957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1024974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024996 */     // MIs[0] policy
     /* 1024996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1025009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025028 */     // GIR_Coverage, 13144,
     /* 1025028 */     GIR_EraseRootFromParent_Done,
     /* 1025029 */   // Label 15196: @1025029
     /* 1025029 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1025106), // Rule ID 13145 //
     /* 1025034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1025045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1025048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1025051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1025054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1025073 */     // MIs[0] policy
     /* 1025073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025083 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1025086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025105 */     // GIR_Coverage, 13145,
     /* 1025105 */     GIR_EraseRootFromParent_Done,
     /* 1025106 */   // Label 15197: @1025106
     /* 1025106 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1025183), // Rule ID 13148 //
     /* 1025111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1025128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025150 */     // MIs[0] policy
     /* 1025150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025160 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1025163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025182 */     // GIR_Coverage, 13148,
     /* 1025182 */     GIR_EraseRootFromParent_Done,
     /* 1025183 */   // Label 15198: @1025183
     /* 1025183 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1025260), // Rule ID 13149 //
     /* 1025188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1025199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1025202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1025205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1025208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1025227 */     // MIs[0] policy
     /* 1025227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1025240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025259 */     // GIR_Coverage, 13149,
     /* 1025259 */     GIR_EraseRootFromParent_Done,
     /* 1025260 */   // Label 15199: @1025260
     /* 1025260 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1025337), // Rule ID 13152 //
     /* 1025265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1025282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025304 */     // MIs[0] policy
     /* 1025304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1025317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025336 */     // GIR_Coverage, 13152,
     /* 1025336 */     GIR_EraseRootFromParent_Done,
     /* 1025337 */   // Label 15200: @1025337
     /* 1025337 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1025414), // Rule ID 13153 //
     /* 1025342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1025353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1025356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1025359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1025362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1025381 */     // MIs[0] policy
     /* 1025381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025391 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1025394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025413 */     // GIR_Coverage, 13153,
     /* 1025413 */     GIR_EraseRootFromParent_Done,
     /* 1025414 */   // Label 15201: @1025414
     /* 1025414 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1025491), // Rule ID 13156 //
     /* 1025419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025458 */     // MIs[0] policy
     /* 1025458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1025471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025490 */     // GIR_Coverage, 13156,
     /* 1025490 */     GIR_EraseRootFromParent_Done,
     /* 1025491 */   // Label 15202: @1025491
     /* 1025491 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1025568), // Rule ID 13157 //
     /* 1025496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025535 */     // MIs[0] policy
     /* 1025535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025545 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1025548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025567 */     // GIR_Coverage, 13157,
     /* 1025567 */     GIR_EraseRootFromParent_Done,
     /* 1025568 */   // Label 15203: @1025568
     /* 1025568 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1025645), // Rule ID 13160 //
     /* 1025573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025612 */     // MIs[0] policy
     /* 1025612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025644 */     // GIR_Coverage, 13160,
     /* 1025644 */     GIR_EraseRootFromParent_Done,
     /* 1025645 */   // Label 15204: @1025645
     /* 1025645 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1025722), // Rule ID 13161 //
     /* 1025650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025689 */     // MIs[0] policy
     /* 1025689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025699 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025721 */     // GIR_Coverage, 13161,
     /* 1025721 */     GIR_EraseRootFromParent_Done,
     /* 1025722 */   // Label 15205: @1025722
     /* 1025722 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1025799), // Rule ID 13164 //
     /* 1025727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025766 */     // MIs[0] policy
     /* 1025766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1025779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025798 */     // GIR_Coverage, 13164,
     /* 1025798 */     GIR_EraseRootFromParent_Done,
     /* 1025799 */   // Label 15206: @1025799
     /* 1025799 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1025876), // Rule ID 13165 //
     /* 1025804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025843 */     // MIs[0] policy
     /* 1025843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025853 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1025856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025875 */     // GIR_Coverage, 13165,
     /* 1025875 */     GIR_EraseRootFromParent_Done,
     /* 1025876 */   // Label 15207: @1025876
     /* 1025876 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1025953), // Rule ID 13168 //
     /* 1025881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1025898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025920 */     // MIs[0] policy
     /* 1025920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1025933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025952 */     // GIR_Coverage, 13168,
     /* 1025952 */     GIR_EraseRootFromParent_Done,
     /* 1025953 */   // Label 15208: @1025953
     /* 1025953 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1026030), // Rule ID 13169 //
     /* 1025958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1025966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1025975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1025993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025997 */     // MIs[0] policy
     /* 1025997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026007 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1026010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026029 */     // GIR_Coverage, 13169,
     /* 1026029 */     GIR_EraseRootFromParent_Done,
     /* 1026030 */   // Label 15209: @1026030
     /* 1026030 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1026107), // Rule ID 13172 //
     /* 1026035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026074 */     // MIs[0] policy
     /* 1026074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026106 */     // GIR_Coverage, 13172,
     /* 1026106 */     GIR_EraseRootFromParent_Done,
     /* 1026107 */   // Label 15210: @1026107
     /* 1026107 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1026184), // Rule ID 13173 //
     /* 1026112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1026123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1026126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1026132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026151 */     // MIs[0] policy
     /* 1026151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026183 */     // GIR_Coverage, 13173,
     /* 1026183 */     GIR_EraseRootFromParent_Done,
     /* 1026184 */   // Label 15211: @1026184
     /* 1026184 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1026261), // Rule ID 13176 //
     /* 1026189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026228 */     // MIs[0] policy
     /* 1026228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026260 */     // GIR_Coverage, 13176,
     /* 1026260 */     GIR_EraseRootFromParent_Done,
     /* 1026261 */   // Label 15212: @1026261
     /* 1026261 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1026338), // Rule ID 13177 //
     /* 1026266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1026277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1026280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1026286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026305 */     // MIs[0] policy
     /* 1026305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026315 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1026318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026337 */     // GIR_Coverage, 13177,
     /* 1026337 */     GIR_EraseRootFromParent_Done,
     /* 1026338 */   // Label 15213: @1026338
     /* 1026338 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1026415), // Rule ID 13180 //
     /* 1026343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026382 */     // MIs[0] policy
     /* 1026382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026414 */     // GIR_Coverage, 13180,
     /* 1026414 */     GIR_EraseRootFromParent_Done,
     /* 1026415 */   // Label 15214: @1026415
     /* 1026415 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1026492), // Rule ID 13181 //
     /* 1026420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1026431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1026434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1026440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026459 */     // MIs[0] policy
     /* 1026459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026469 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026491 */     // GIR_Coverage, 13181,
     /* 1026491 */     GIR_EraseRootFromParent_Done,
     /* 1026492 */   // Label 15215: @1026492
     /* 1026492 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1026569), // Rule ID 13184 //
     /* 1026497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026536 */     // MIs[0] policy
     /* 1026536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026568 */     // GIR_Coverage, 13184,
     /* 1026568 */     GIR_EraseRootFromParent_Done,
     /* 1026569 */   // Label 15216: @1026569
     /* 1026569 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1026646), // Rule ID 13185 //
     /* 1026574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026613 */     // MIs[0] policy
     /* 1026613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026623 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026645 */     // GIR_Coverage, 13185,
     /* 1026645 */     GIR_EraseRootFromParent_Done,
     /* 1026646 */   // Label 15217: @1026646
     /* 1026646 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1026723), // Rule ID 13188 //
     /* 1026651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026690 */     // MIs[0] policy
     /* 1026690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026722 */     // GIR_Coverage, 13188,
     /* 1026722 */     GIR_EraseRootFromParent_Done,
     /* 1026723 */   // Label 15218: @1026723
     /* 1026723 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1026800), // Rule ID 13189 //
     /* 1026728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026767 */     // MIs[0] policy
     /* 1026767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026799 */     // GIR_Coverage, 13189,
     /* 1026799 */     GIR_EraseRootFromParent_Done,
     /* 1026800 */   // Label 15219: @1026800
     /* 1026800 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1026877), // Rule ID 13192 //
     /* 1026805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026844 */     // MIs[0] policy
     /* 1026844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026876 */     // GIR_Coverage, 13192,
     /* 1026876 */     GIR_EraseRootFromParent_Done,
     /* 1026877 */   // Label 15220: @1026877
     /* 1026877 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1026954), // Rule ID 13193 //
     /* 1026882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1026899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026921 */     // MIs[0] policy
     /* 1026921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026931 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1026934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026953 */     // GIR_Coverage, 13193,
     /* 1026953 */     GIR_EraseRootFromParent_Done,
     /* 1026954 */   // Label 15221: @1026954
     /* 1026954 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1027031), // Rule ID 13196 //
     /* 1026959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1026967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1026976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1026994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026998 */     // MIs[0] policy
     /* 1026998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027030 */     // GIR_Coverage, 13196,
     /* 1027030 */     GIR_EraseRootFromParent_Done,
     /* 1027031 */   // Label 15222: @1027031
     /* 1027031 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1027108), // Rule ID 13197 //
     /* 1027036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1027047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1027050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1027056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027075 */     // MIs[0] policy
     /* 1027075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027107 */     // GIR_Coverage, 13197,
     /* 1027107 */     GIR_EraseRootFromParent_Done,
     /* 1027108 */   // Label 15223: @1027108
     /* 1027108 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1027185), // Rule ID 13200 //
     /* 1027113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027152 */     // MIs[0] policy
     /* 1027152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027162 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027184 */     // GIR_Coverage, 13200,
     /* 1027184 */     GIR_EraseRootFromParent_Done,
     /* 1027185 */   // Label 15224: @1027185
     /* 1027185 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1027262), // Rule ID 13201 //
     /* 1027190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1027201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1027204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1027210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027229 */     // MIs[0] policy
     /* 1027229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027261 */     // GIR_Coverage, 13201,
     /* 1027261 */     GIR_EraseRootFromParent_Done,
     /* 1027262 */   // Label 15225: @1027262
     /* 1027262 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1027339), // Rule ID 13204 //
     /* 1027267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027306 */     // MIs[0] policy
     /* 1027306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027338 */     // GIR_Coverage, 13204,
     /* 1027338 */     GIR_EraseRootFromParent_Done,
     /* 1027339 */   // Label 15226: @1027339
     /* 1027339 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1027416), // Rule ID 13205 //
     /* 1027344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1027355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1027358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1027364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027383 */     // MIs[0] policy
     /* 1027383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027393 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027415 */     // GIR_Coverage, 13205,
     /* 1027415 */     GIR_EraseRootFromParent_Done,
     /* 1027416 */   // Label 15227: @1027416
     /* 1027416 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1027493), // Rule ID 13208 //
     /* 1027421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027460 */     // MIs[0] policy
     /* 1027460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027492 */     // GIR_Coverage, 13208,
     /* 1027492 */     GIR_EraseRootFromParent_Done,
     /* 1027493 */   // Label 15228: @1027493
     /* 1027493 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1027570), // Rule ID 13209 //
     /* 1027498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027537 */     // MIs[0] policy
     /* 1027537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027569 */     // GIR_Coverage, 13209,
     /* 1027569 */     GIR_EraseRootFromParent_Done,
     /* 1027570 */   // Label 15229: @1027570
     /* 1027570 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1027647), // Rule ID 13212 //
     /* 1027575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027614 */     // MIs[0] policy
     /* 1027614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027646 */     // GIR_Coverage, 13212,
     /* 1027646 */     GIR_EraseRootFromParent_Done,
     /* 1027647 */   // Label 15230: @1027647
     /* 1027647 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1027724), // Rule ID 13213 //
     /* 1027652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027691 */     // MIs[0] policy
     /* 1027691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027701 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1027704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027723 */     // GIR_Coverage, 13213,
     /* 1027723 */     GIR_EraseRootFromParent_Done,
     /* 1027724 */   // Label 15231: @1027724
     /* 1027724 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1027801), // Rule ID 13216 //
     /* 1027729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027768 */     // MIs[0] policy
     /* 1027768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027800 */     // GIR_Coverage, 13216,
     /* 1027800 */     GIR_EraseRootFromParent_Done,
     /* 1027801 */   // Label 15232: @1027801
     /* 1027801 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1027878), // Rule ID 13217 //
     /* 1027806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027845 */     // MIs[0] policy
     /* 1027845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027855 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1027858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027877 */     // GIR_Coverage, 13217,
     /* 1027877 */     GIR_EraseRootFromParent_Done,
     /* 1027878 */   // Label 15233: @1027878
     /* 1027878 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1027955), // Rule ID 13220 //
     /* 1027883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027922 */     // MIs[0] policy
     /* 1027922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1027935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027954 */     // GIR_Coverage, 13220,
     /* 1027954 */     GIR_EraseRootFromParent_Done,
     /* 1027955 */   // Label 15234: @1027955
     /* 1027955 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1028032), // Rule ID 13221 //
     /* 1027960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1027968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027999 */     // MIs[0] policy
     /* 1027999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028031 */     // GIR_Coverage, 13221,
     /* 1028031 */     GIR_EraseRootFromParent_Done,
     /* 1028032 */   // Label 15235: @1028032
     /* 1028032 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1028109), // Rule ID 13224 //
     /* 1028037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028076 */     // MIs[0] policy
     /* 1028076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028086 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028108 */     // GIR_Coverage, 13224,
     /* 1028108 */     GIR_EraseRootFromParent_Done,
     /* 1028109 */   // Label 15236: @1028109
     /* 1028109 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1028186), // Rule ID 13225 //
     /* 1028114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1028125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1028128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1028134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028153 */     // MIs[0] policy
     /* 1028153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028163 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028185 */     // GIR_Coverage, 13225,
     /* 1028185 */     GIR_EraseRootFromParent_Done,
     /* 1028186 */   // Label 15237: @1028186
     /* 1028186 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1028263), // Rule ID 13228 //
     /* 1028191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028230 */     // MIs[0] policy
     /* 1028230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028240 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028262 */     // GIR_Coverage, 13228,
     /* 1028262 */     GIR_EraseRootFromParent_Done,
     /* 1028263 */   // Label 15238: @1028263
     /* 1028263 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1028340), // Rule ID 13229 //
     /* 1028268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1028279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1028282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1028288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028307 */     // MIs[0] policy
     /* 1028307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028317 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028339 */     // GIR_Coverage, 13229,
     /* 1028339 */     GIR_EraseRootFromParent_Done,
     /* 1028340 */   // Label 15239: @1028340
     /* 1028340 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1028417), // Rule ID 13232 //
     /* 1028345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028384 */     // MIs[0] policy
     /* 1028384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028416 */     // GIR_Coverage, 13232,
     /* 1028416 */     GIR_EraseRootFromParent_Done,
     /* 1028417 */   // Label 15240: @1028417
     /* 1028417 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1028494), // Rule ID 13233 //
     /* 1028422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1028433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1028436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1028442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028461 */     // MIs[0] policy
     /* 1028461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1028474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028493 */     // GIR_Coverage, 13233,
     /* 1028493 */     GIR_EraseRootFromParent_Done,
     /* 1028494 */   // Label 15241: @1028494
     /* 1028494 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1028571), // Rule ID 13236 //
     /* 1028499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028538 */     // MIs[0] policy
     /* 1028538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028570 */     // GIR_Coverage, 13236,
     /* 1028570 */     GIR_EraseRootFromParent_Done,
     /* 1028571 */   // Label 15242: @1028571
     /* 1028571 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1028648), // Rule ID 13237 //
     /* 1028576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028615 */     // MIs[0] policy
     /* 1028615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028625 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1028628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028647 */     // GIR_Coverage, 13237,
     /* 1028647 */     GIR_EraseRootFromParent_Done,
     /* 1028648 */   // Label 15243: @1028648
     /* 1028648 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1028725), // Rule ID 13240 //
     /* 1028653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028692 */     // MIs[0] policy
     /* 1028692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028724 */     // GIR_Coverage, 13240,
     /* 1028724 */     GIR_EraseRootFromParent_Done,
     /* 1028725 */   // Label 15244: @1028725
     /* 1028725 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1028802), // Rule ID 13241 //
     /* 1028730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1028738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028769 */     // MIs[0] policy
     /* 1028769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028779 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1028782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028801 */     // GIR_Coverage, 13241,
     /* 1028801 */     GIR_EraseRootFromParent_Done,
     /* 1028802 */   // Label 15245: @1028802
     /* 1028802 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1028879), // Rule ID 13244 //
     /* 1028807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1028824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028846 */     // MIs[0] policy
     /* 1028846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1028859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028878 */     // GIR_Coverage, 13244,
     /* 1028878 */     GIR_EraseRootFromParent_Done,
     /* 1028879 */   // Label 15246: @1028879
     /* 1028879 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1028956), // Rule ID 13245 //
     /* 1028884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1028901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028923 */     // MIs[0] policy
     /* 1028923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028933 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1028936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028955 */     // GIR_Coverage, 13245,
     /* 1028955 */     GIR_EraseRootFromParent_Done,
     /* 1028956 */   // Label 15247: @1028956
     /* 1028956 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1029033), // Rule ID 13248 //
     /* 1028961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1028978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029000 */     // MIs[0] policy
     /* 1029000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029010 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029032 */     // GIR_Coverage, 13248,
     /* 1029032 */     GIR_EraseRootFromParent_Done,
     /* 1029033 */   // Label 15248: @1029033
     /* 1029033 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1029110), // Rule ID 13249 //
     /* 1029038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1029049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1029052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1029055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1029058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029077 */     // MIs[0] policy
     /* 1029077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029087 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029109 */     // GIR_Coverage, 13249,
     /* 1029109 */     GIR_EraseRootFromParent_Done,
     /* 1029110 */   // Label 15249: @1029110
     /* 1029110 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1029187), // Rule ID 13252 //
     /* 1029115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1029132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029154 */     // MIs[0] policy
     /* 1029154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029164 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029186 */     // GIR_Coverage, 13252,
     /* 1029186 */     GIR_EraseRootFromParent_Done,
     /* 1029187 */   // Label 15250: @1029187
     /* 1029187 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1029264), // Rule ID 13253 //
     /* 1029192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1029203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1029206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1029209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1029212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029231 */     // MIs[0] policy
     /* 1029231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029241 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029263 */     // GIR_Coverage, 13253,
     /* 1029263 */     GIR_EraseRootFromParent_Done,
     /* 1029264 */   // Label 15251: @1029264
     /* 1029264 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1029341), // Rule ID 13256 //
     /* 1029269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1029286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029308 */     // MIs[0] policy
     /* 1029308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029340 */     // GIR_Coverage, 13256,
     /* 1029340 */     GIR_EraseRootFromParent_Done,
     /* 1029341 */   // Label 15252: @1029341
     /* 1029341 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1029418), // Rule ID 13257 //
     /* 1029346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1029357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1029360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1029363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1029366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029385 */     // MIs[0] policy
     /* 1029385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1029398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029417 */     // GIR_Coverage, 13257,
     /* 1029417 */     GIR_EraseRootFromParent_Done,
     /* 1029418 */   // Label 15253: @1029418
     /* 1029418 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1029495), // Rule ID 13260 //
     /* 1029423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1029440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029462 */     // MIs[0] policy
     /* 1029462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029494 */     // GIR_Coverage, 13260,
     /* 1029494 */     GIR_EraseRootFromParent_Done,
     /* 1029495 */   // Label 15254: @1029495
     /* 1029495 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1029572), // Rule ID 13261 //
     /* 1029500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1029517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029539 */     // MIs[0] policy
     /* 1029539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029549 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029571 */     // GIR_Coverage, 13261,
     /* 1029571 */     GIR_EraseRootFromParent_Done,
     /* 1029572 */   // Label 15255: @1029572
     /* 1029572 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1029649), // Rule ID 13264 //
     /* 1029577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1029594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029616 */     // MIs[0] policy
     /* 1029616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029626 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029648 */     // GIR_Coverage, 13264,
     /* 1029648 */     GIR_EraseRootFromParent_Done,
     /* 1029649 */   // Label 15256: @1029649
     /* 1029649 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1029726), // Rule ID 13265 //
     /* 1029654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1029671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029693 */     // MIs[0] policy
     /* 1029693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1029706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029725 */     // GIR_Coverage, 13265,
     /* 1029725 */     GIR_EraseRootFromParent_Done,
     /* 1029726 */   // Label 15257: @1029726
     /* 1029726 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1029803), // Rule ID 13268 //
     /* 1029731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029770 */     // MIs[0] policy
     /* 1029770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029802 */     // GIR_Coverage, 13268,
     /* 1029802 */     GIR_EraseRootFromParent_Done,
     /* 1029803 */   // Label 15258: @1029803
     /* 1029803 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1029880), // Rule ID 13269 //
     /* 1029808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1029825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029847 */     // MIs[0] policy
     /* 1029847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029857 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029879 */     // GIR_Coverage, 13269,
     /* 1029879 */     GIR_EraseRootFromParent_Done,
     /* 1029880 */   // Label 15259: @1029880
     /* 1029880 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1029957), // Rule ID 13272 //
     /* 1029885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1029902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029924 */     // MIs[0] policy
     /* 1029924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1029937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029956 */     // GIR_Coverage, 13272,
     /* 1029956 */     GIR_EraseRootFromParent_Done,
     /* 1029957 */   // Label 15260: @1029957
     /* 1029957 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1030034), // Rule ID 13273 //
     /* 1029962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1029979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030001 */     // MIs[0] policy
     /* 1030001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030011 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030033 */     // GIR_Coverage, 13273,
     /* 1030033 */     GIR_EraseRootFromParent_Done,
     /* 1030034 */   // Label 15261: @1030034
     /* 1030034 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1030111), // Rule ID 13276 //
     /* 1030039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1030056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030078 */     // MIs[0] policy
     /* 1030078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030110 */     // GIR_Coverage, 13276,
     /* 1030110 */     GIR_EraseRootFromParent_Done,
     /* 1030111 */   // Label 15262: @1030111
     /* 1030111 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1030188), // Rule ID 13277 //
     /* 1030116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1030127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1030130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1030133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1030136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030155 */     // MIs[0] policy
     /* 1030155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030187 */     // GIR_Coverage, 13277,
     /* 1030187 */     GIR_EraseRootFromParent_Done,
     /* 1030188 */   // Label 15263: @1030188
     /* 1030188 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1030265), // Rule ID 13280 //
     /* 1030193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1030210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030232 */     // MIs[0] policy
     /* 1030232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030264 */     // GIR_Coverage, 13280,
     /* 1030264 */     GIR_EraseRootFromParent_Done,
     /* 1030265 */   // Label 15264: @1030265
     /* 1030265 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1030342), // Rule ID 13281 //
     /* 1030270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1030273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1030281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1030284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1030287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1030290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1030309 */     // MIs[0] policy
     /* 1030309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030319 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1030322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030341 */     // GIR_Coverage, 13281,
     /* 1030341 */     GIR_EraseRootFromParent_Done,
     /* 1030342 */   // Label 15265: @1030342
     /* 1030342 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1030419), // Rule ID 13284 //
     /* 1030347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1030364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030386 */     // MIs[0] policy
     /* 1030386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030418 */     // GIR_Coverage, 13284,
     /* 1030418 */     GIR_EraseRootFromParent_Done,
     /* 1030419 */   // Label 15266: @1030419
     /* 1030419 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1030496), // Rule ID 13285 //
     /* 1030424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1030435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1030438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1030441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1030444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030463 */     // MIs[0] policy
     /* 1030463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030473 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030495 */     // GIR_Coverage, 13285,
     /* 1030495 */     GIR_EraseRootFromParent_Done,
     /* 1030496 */   // Label 15267: @1030496
     /* 1030496 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1030573), // Rule ID 13288 //
     /* 1030501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1030518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030540 */     // MIs[0] policy
     /* 1030540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030550 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1030553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030572 */     // GIR_Coverage, 13288,
     /* 1030572 */     GIR_EraseRootFromParent_Done,
     /* 1030573 */   // Label 15268: @1030573
     /* 1030573 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1030650), // Rule ID 13289 //
     /* 1030578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1030595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030617 */     // MIs[0] policy
     /* 1030617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1030630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030649 */     // GIR_Coverage, 13289,
     /* 1030649 */     GIR_EraseRootFromParent_Done,
     /* 1030650 */   // Label 15269: @1030650
     /* 1030650 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1030727), // Rule ID 13292 //
     /* 1030655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1030672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030694 */     // MIs[0] policy
     /* 1030694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1030707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030726 */     // GIR_Coverage, 13292,
     /* 1030726 */     GIR_EraseRootFromParent_Done,
     /* 1030727 */   // Label 15270: @1030727
     /* 1030727 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1030804), // Rule ID 13293 //
     /* 1030732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1030749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030771 */     // MIs[0] policy
     /* 1030771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030781 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1030784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030803 */     // GIR_Coverage, 13293,
     /* 1030803 */     GIR_EraseRootFromParent_Done,
     /* 1030804 */   // Label 15271: @1030804
     /* 1030804 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1030881), // Rule ID 13296 //
     /* 1030809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1030826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030848 */     // MIs[0] policy
     /* 1030848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030880 */     // GIR_Coverage, 13296,
     /* 1030880 */     GIR_EraseRootFromParent_Done,
     /* 1030881 */   // Label 15272: @1030881
     /* 1030881 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1030958), // Rule ID 13297 //
     /* 1030886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1030903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030925 */     // MIs[0] policy
     /* 1030925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1030938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030957 */     // GIR_Coverage, 13297,
     /* 1030957 */     GIR_EraseRootFromParent_Done,
     /* 1030958 */   // Label 15273: @1030958
     /* 1030958 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1031035), // Rule ID 13300 //
     /* 1030963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1030980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031002 */     // MIs[0] policy
     /* 1031002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031034 */     // GIR_Coverage, 13300,
     /* 1031034 */     GIR_EraseRootFromParent_Done,
     /* 1031035 */   // Label 15274: @1031035
     /* 1031035 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1031112), // Rule ID 13301 //
     /* 1031040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1031057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1031060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031079 */     // MIs[0] policy
     /* 1031079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031089 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031111 */     // GIR_Coverage, 13301,
     /* 1031111 */     GIR_EraseRootFromParent_Done,
     /* 1031112 */   // Label 15275: @1031112
     /* 1031112 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1031189), // Rule ID 13304 //
     /* 1031117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1031134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031156 */     // MIs[0] policy
     /* 1031156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031188 */     // GIR_Coverage, 13304,
     /* 1031188 */     GIR_EraseRootFromParent_Done,
     /* 1031189 */   // Label 15276: @1031189
     /* 1031189 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1031266), // Rule ID 13305 //
     /* 1031194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1031205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1031208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1031211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1031214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031233 */     // MIs[0] policy
     /* 1031233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031243 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1031262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031265 */     // GIR_Coverage, 13305,
     /* 1031265 */     GIR_EraseRootFromParent_Done,
     /* 1031266 */   // Label 15277: @1031266
     /* 1031266 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1031343), // Rule ID 13308 //
     /* 1031271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1031288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031310 */     // MIs[0] policy
     /* 1031310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031342 */     // GIR_Coverage, 13308,
     /* 1031342 */     GIR_EraseRootFromParent_Done,
     /* 1031343 */   // Label 15278: @1031343
     /* 1031343 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1031420), // Rule ID 13309 //
     /* 1031348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1031359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1031362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1031365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1031368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031387 */     // MIs[0] policy
     /* 1031387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031419 */     // GIR_Coverage, 13309,
     /* 1031419 */     GIR_EraseRootFromParent_Done,
     /* 1031420 */   // Label 15279: @1031420
     /* 1031420 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1031497), // Rule ID 13312 //
     /* 1031425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1031442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031464 */     // MIs[0] policy
     /* 1031464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031496 */     // GIR_Coverage, 13312,
     /* 1031496 */     GIR_EraseRootFromParent_Done,
     /* 1031497 */   // Label 15280: @1031497
     /* 1031497 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1031574), // Rule ID 13313 //
     /* 1031502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1031519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031541 */     // MIs[0] policy
     /* 1031541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031573 */     // GIR_Coverage, 13313,
     /* 1031573 */     GIR_EraseRootFromParent_Done,
     /* 1031574 */   // Label 15281: @1031574
     /* 1031574 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1031651), // Rule ID 13316 //
     /* 1031579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1031596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031618 */     // MIs[0] policy
     /* 1031618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031628 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031650 */     // GIR_Coverage, 13316,
     /* 1031650 */     GIR_EraseRootFromParent_Done,
     /* 1031651 */   // Label 15282: @1031651
     /* 1031651 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1031728), // Rule ID 13317 //
     /* 1031656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1031673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031695 */     // MIs[0] policy
     /* 1031695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031705 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1031708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031727 */     // GIR_Coverage, 13317,
     /* 1031727 */     GIR_EraseRootFromParent_Done,
     /* 1031728 */   // Label 15283: @1031728
     /* 1031728 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1031805), // Rule ID 13320 //
     /* 1031733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1031750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031772 */     // MIs[0] policy
     /* 1031772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031804 */     // GIR_Coverage, 13320,
     /* 1031804 */     GIR_EraseRootFromParent_Done,
     /* 1031805 */   // Label 15284: @1031805
     /* 1031805 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1031882), // Rule ID 13321 //
     /* 1031810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1031827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031849 */     // MIs[0] policy
     /* 1031849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1031862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031881 */     // GIR_Coverage, 13321,
     /* 1031881 */     GIR_EraseRootFromParent_Done,
     /* 1031882 */   // Label 15285: @1031882
     /* 1031882 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1031959), // Rule ID 13324 //
     /* 1031887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1031904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031926 */     // MIs[0] policy
     /* 1031926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1031939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031958 */     // GIR_Coverage, 13324,
     /* 1031958 */     GIR_EraseRootFromParent_Done,
     /* 1031959 */   // Label 15286: @1031959
     /* 1031959 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1032036), // Rule ID 13325 //
     /* 1031964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1031981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032003 */     // MIs[0] policy
     /* 1032003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032013 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1032016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032035 */     // GIR_Coverage, 13325,
     /* 1032035 */     GIR_EraseRootFromParent_Done,
     /* 1032036 */   // Label 15287: @1032036
     /* 1032036 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1032113), // Rule ID 13328 //
     /* 1032041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1032044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1032058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032080 */     // MIs[0] policy
     /* 1032080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1032093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032112 */     // GIR_Coverage, 13328,
     /* 1032112 */     GIR_EraseRootFromParent_Done,
     /* 1032113 */   // Label 15288: @1032113
     /* 1032113 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1032190), // Rule ID 13329 //
     /* 1032118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1032121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1032129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1032132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1032135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1032138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032157 */     // MIs[0] policy
     /* 1032157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032167 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1032170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1032186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032189 */     // GIR_Coverage, 13329,
     /* 1032189 */     GIR_EraseRootFromParent_Done,
     /* 1032190 */   // Label 15289: @1032190
     /* 1032190 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1032267), // Rule ID 13332 //
     /* 1032195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1032206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1032209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032234 */     // MIs[0] policy
     /* 1032234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1032247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032266 */     // GIR_Coverage, 13332,
     /* 1032266 */     GIR_EraseRootFromParent_Done,
     /* 1032267 */   // Label 15290: @1032267
     /* 1032267 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1032344), // Rule ID 13333 //
     /* 1032272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1032283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1032286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1032292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032311 */     // MIs[0] policy
     /* 1032311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032321 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1032324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032343 */     // GIR_Coverage, 13333,
     /* 1032343 */     GIR_EraseRootFromParent_Done,
     /* 1032344 */   // Label 15291: @1032344
     /* 1032344 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1032421), // Rule ID 13336 //
     /* 1032349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1032360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1032363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032388 */     // MIs[0] policy
     /* 1032388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032420 */     // GIR_Coverage, 13336,
     /* 1032420 */     GIR_EraseRootFromParent_Done,
     /* 1032421 */   // Label 15292: @1032421
     /* 1032421 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1032498), // Rule ID 13337 //
     /* 1032426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1032437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1032440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1032446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032465 */     // MIs[0] policy
     /* 1032465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032497 */     // GIR_Coverage, 13337,
     /* 1032497 */     GIR_EraseRootFromParent_Done,
     /* 1032498 */   // Label 15293: @1032498
     /* 1032498 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1032575), // Rule ID 13340 //
     /* 1032503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1032514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1032517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032542 */     // MIs[0] policy
     /* 1032542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032574 */     // GIR_Coverage, 13340,
     /* 1032574 */     GIR_EraseRootFromParent_Done,
     /* 1032575 */   // Label 15294: @1032575
     /* 1032575 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1032652), // Rule ID 13341 //
     /* 1032580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1032591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1032594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032619 */     // MIs[0] policy
     /* 1032619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032629 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032651 */     // GIR_Coverage, 13341,
     /* 1032651 */     GIR_EraseRootFromParent_Done,
     /* 1032652 */   // Label 15295: @1032652
     /* 1032652 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1032729), // Rule ID 13344 //
     /* 1032657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032696 */     // MIs[0] policy
     /* 1032696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032728 */     // GIR_Coverage, 13344,
     /* 1032728 */     GIR_EraseRootFromParent_Done,
     /* 1032729 */   // Label 15296: @1032729
     /* 1032729 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1032806), // Rule ID 13345 //
     /* 1032734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1032745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1032748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032773 */     // MIs[0] policy
     /* 1032773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032783 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1032786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032805 */     // GIR_Coverage, 13345,
     /* 1032805 */     GIR_EraseRootFromParent_Done,
     /* 1032806 */   // Label 15297: @1032806
     /* 1032806 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1032883), // Rule ID 13348 //
     /* 1032811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032850 */     // MIs[0] policy
     /* 1032850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032882 */     // GIR_Coverage, 13348,
     /* 1032882 */     GIR_EraseRootFromParent_Done,
     /* 1032883 */   // Label 15298: @1032883
     /* 1032883 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1032960), // Rule ID 13349 //
     /* 1032888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1032899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1032902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1032905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1032923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032927 */     // MIs[0] policy
     /* 1032927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1032940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032959 */     // GIR_Coverage, 13349,
     /* 1032959 */     GIR_EraseRootFromParent_Done,
     /* 1032960 */   // Label 15299: @1032960
     /* 1032960 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1033037), // Rule ID 13352 //
     /* 1032965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1032973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1032982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1032985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033004 */     // MIs[0] policy
     /* 1033004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1033017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033036 */     // GIR_Coverage, 13352,
     /* 1033036 */     GIR_EraseRootFromParent_Done,
     /* 1033037 */   // Label 15300: @1033037
     /* 1033037 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1033114), // Rule ID 13353 //
     /* 1033042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1033053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1033056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033081 */     // MIs[0] policy
     /* 1033081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1033094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033113 */     // GIR_Coverage, 13353,
     /* 1033113 */     GIR_EraseRootFromParent_Done,
     /* 1033114 */   // Label 15301: @1033114
     /* 1033114 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1033191), // Rule ID 13356 //
     /* 1033119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1033130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1033133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1033139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033158 */     // MIs[0] policy
     /* 1033158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033190 */     // GIR_Coverage, 13356,
     /* 1033190 */     GIR_EraseRootFromParent_Done,
     /* 1033191 */   // Label 15302: @1033191
     /* 1033191 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1033268), // Rule ID 13357 //
     /* 1033196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1033207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1033210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1033216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033235 */     // MIs[0] policy
     /* 1033235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033245 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033267 */     // GIR_Coverage, 13357,
     /* 1033267 */     GIR_EraseRootFromParent_Done,
     /* 1033268 */   // Label 15303: @1033268
     /* 1033268 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1033345), // Rule ID 13360 //
     /* 1033273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033312 */     // MIs[0] policy
     /* 1033312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033344 */     // GIR_Coverage, 13360,
     /* 1033344 */     GIR_EraseRootFromParent_Done,
     /* 1033345 */   // Label 15304: @1033345
     /* 1033345 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1033422), // Rule ID 13361 //
     /* 1033350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033389 */     // MIs[0] policy
     /* 1033389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033421 */     // GIR_Coverage, 13361,
     /* 1033421 */     GIR_EraseRootFromParent_Done,
     /* 1033422 */   // Label 15305: @1033422
     /* 1033422 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1033499), // Rule ID 13364 //
     /* 1033427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033466 */     // MIs[0] policy
     /* 1033466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033498 */     // GIR_Coverage, 13364,
     /* 1033498 */     GIR_EraseRootFromParent_Done,
     /* 1033499 */   // Label 15306: @1033499
     /* 1033499 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1033576), // Rule ID 13365 //
     /* 1033504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1033515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1033518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033543 */     // MIs[0] policy
     /* 1033543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033553 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033575 */     // GIR_Coverage, 13365,
     /* 1033575 */     GIR_EraseRootFromParent_Done,
     /* 1033576 */   // Label 15307: @1033576
     /* 1033576 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1033653), // Rule ID 13368 //
     /* 1033581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1033584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1033601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033620 */     // MIs[0] policy
     /* 1033620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033652 */     // GIR_Coverage, 13368,
     /* 1033652 */     GIR_EraseRootFromParent_Done,
     /* 1033653 */   // Label 15308: @1033653
     /* 1033653 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1033730), // Rule ID 13369 //
     /* 1033658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1033661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1033678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033697 */     // MIs[0] policy
     /* 1033697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033707 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1033710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1033726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033729 */     // GIR_Coverage, 13369,
     /* 1033729 */     GIR_EraseRootFromParent_Done,
     /* 1033730 */   // Label 15309: @1033730
     /* 1033730 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1033807), // Rule ID 13372 //
     /* 1033735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1033746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1033749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1033755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033774 */     // MIs[0] policy
     /* 1033774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1033787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033806 */     // GIR_Coverage, 13372,
     /* 1033806 */     GIR_EraseRootFromParent_Done,
     /* 1033807 */   // Label 15310: @1033807
     /* 1033807 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1033884), // Rule ID 13373 //
     /* 1033812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1033823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1033826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1033832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033851 */     // MIs[0] policy
     /* 1033851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1033864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033883 */     // GIR_Coverage, 13373,
     /* 1033883 */     GIR_EraseRootFromParent_Done,
     /* 1033884 */   // Label 15311: @1033884
     /* 1033884 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1033961), // Rule ID 13376 //
     /* 1033889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1033900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1033903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033928 */     // MIs[0] policy
     /* 1033928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1033941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033960 */     // GIR_Coverage, 13376,
     /* 1033960 */     GIR_EraseRootFromParent_Done,
     /* 1033961 */   // Label 15312: @1033961
     /* 1033961 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1034038), // Rule ID 13377 //
     /* 1033966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1033974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1033977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1033980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1033986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034005 */     // MIs[0] policy
     /* 1034005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034015 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034037 */     // GIR_Coverage, 13377,
     /* 1034037 */     GIR_EraseRootFromParent_Done,
     /* 1034038 */   // Label 15313: @1034038
     /* 1034038 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1034115), // Rule ID 13380 //
     /* 1034043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1034054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1034057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1034063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034082 */     // MIs[0] policy
     /* 1034082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034114 */     // GIR_Coverage, 13380,
     /* 1034114 */     GIR_EraseRootFromParent_Done,
     /* 1034115 */   // Label 15314: @1034115
     /* 1034115 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1034192), // Rule ID 13381 //
     /* 1034120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1034131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1034134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1034140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034159 */     // MIs[0] policy
     /* 1034159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034169 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034191 */     // GIR_Coverage, 13381,
     /* 1034191 */     GIR_EraseRootFromParent_Done,
     /* 1034192 */   // Label 15315: @1034192
     /* 1034192 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1034269), // Rule ID 13384 //
     /* 1034197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1034217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034236 */     // MIs[0] policy
     /* 1034236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034268 */     // GIR_Coverage, 13384,
     /* 1034268 */     GIR_EraseRootFromParent_Done,
     /* 1034269 */   // Label 15316: @1034269
     /* 1034269 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1034346), // Rule ID 13385 //
     /* 1034274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1034294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034313 */     // MIs[0] policy
     /* 1034313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034345 */     // GIR_Coverage, 13385,
     /* 1034345 */     GIR_EraseRootFromParent_Done,
     /* 1034346 */   // Label 15317: @1034346
     /* 1034346 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1034423), // Rule ID 13388 //
     /* 1034351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1034371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034390 */     // MIs[0] policy
     /* 1034390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034422 */     // GIR_Coverage, 13388,
     /* 1034422 */     GIR_EraseRootFromParent_Done,
     /* 1034423 */   // Label 15318: @1034423
     /* 1034423 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1034500), // Rule ID 13389 //
     /* 1034428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1034448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034467 */     // MIs[0] policy
     /* 1034467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034499 */     // GIR_Coverage, 13389,
     /* 1034499 */     GIR_EraseRootFromParent_Done,
     /* 1034500 */   // Label 15319: @1034500
     /* 1034500 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1034577), // Rule ID 13392 //
     /* 1034505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1034525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034544 */     // MIs[0] policy
     /* 1034544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034576 */     // GIR_Coverage, 13392,
     /* 1034576 */     GIR_EraseRootFromParent_Done,
     /* 1034577 */   // Label 15320: @1034577
     /* 1034577 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1034654), // Rule ID 13393 //
     /* 1034582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1034602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034621 */     // MIs[0] policy
     /* 1034621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1034634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034653 */     // GIR_Coverage, 13393,
     /* 1034653 */     GIR_EraseRootFromParent_Done,
     /* 1034654 */   // Label 15321: @1034654
     /* 1034654 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1034731), // Rule ID 13396 //
     /* 1034659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034698 */     // MIs[0] policy
     /* 1034698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034730 */     // GIR_Coverage, 13396,
     /* 1034730 */     GIR_EraseRootFromParent_Done,
     /* 1034731 */   // Label 15322: @1034731
     /* 1034731 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1034808), // Rule ID 13397 //
     /* 1034736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1034756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034775 */     // MIs[0] policy
     /* 1034775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1034788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034807 */     // GIR_Coverage, 13397,
     /* 1034807 */     GIR_EraseRootFromParent_Done,
     /* 1034808 */   // Label 15323: @1034808
     /* 1034808 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1034885), // Rule ID 13400 //
     /* 1034813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1034824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1034827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034852 */     // MIs[0] policy
     /* 1034852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034884 */     // GIR_Coverage, 13400,
     /* 1034884 */     GIR_EraseRootFromParent_Done,
     /* 1034885 */   // Label 15324: @1034885
     /* 1034885 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1034962), // Rule ID 13401 //
     /* 1034890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1034901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1034904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1034910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034929 */     // MIs[0] policy
     /* 1034929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034939 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1034942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034961 */     // GIR_Coverage, 13401,
     /* 1034961 */     GIR_EraseRootFromParent_Done,
     /* 1034962 */   // Label 15325: @1034962
     /* 1034962 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1035039), // Rule ID 13404 //
     /* 1034967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1034975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1034978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1034981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1034987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035006 */     // MIs[0] policy
     /* 1035006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035038 */     // GIR_Coverage, 13404,
     /* 1035038 */     GIR_EraseRootFromParent_Done,
     /* 1035039 */   // Label 15326: @1035039
     /* 1035039 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1035116), // Rule ID 13405 //
     /* 1035044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1035064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035083 */     // MIs[0] policy
     /* 1035083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035115 */     // GIR_Coverage, 13405,
     /* 1035115 */     GIR_EraseRootFromParent_Done,
     /* 1035116 */   // Label 15327: @1035116
     /* 1035116 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1035193), // Rule ID 13408 //
     /* 1035121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1035141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035160 */     // MIs[0] policy
     /* 1035160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1035173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035192 */     // GIR_Coverage, 13408,
     /* 1035192 */     GIR_EraseRootFromParent_Done,
     /* 1035193 */   // Label 15328: @1035193
     /* 1035193 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1035270), // Rule ID 13409 //
     /* 1035198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1035218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035237 */     // MIs[0] policy
     /* 1035237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1035250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035269 */     // GIR_Coverage, 13409,
     /* 1035269 */     GIR_EraseRootFromParent_Done,
     /* 1035270 */   // Label 15329: @1035270
     /* 1035270 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1035347), // Rule ID 13412 //
     /* 1035275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1035295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035314 */     // MIs[0] policy
     /* 1035314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1035327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035346 */     // GIR_Coverage, 13412,
     /* 1035346 */     GIR_EraseRootFromParent_Done,
     /* 1035347 */   // Label 15330: @1035347
     /* 1035347 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1035424), // Rule ID 13413 //
     /* 1035352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1035372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035391 */     // MIs[0] policy
     /* 1035391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035401 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1035404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035423 */     // GIR_Coverage, 13413,
     /* 1035423 */     GIR_EraseRootFromParent_Done,
     /* 1035424 */   // Label 15331: @1035424
     /* 1035424 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1035501), // Rule ID 13416 //
     /* 1035429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1035432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1035449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035468 */     // MIs[0] policy
     /* 1035468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035500 */     // GIR_Coverage, 13416,
     /* 1035500 */     GIR_EraseRootFromParent_Done,
     /* 1035501 */   // Label 15332: @1035501
     /* 1035501 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1035578), // Rule ID 13417 //
     /* 1035506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1035509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1035514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1035526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035545 */     // MIs[0] policy
     /* 1035545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1035558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1035574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035577 */     // GIR_Coverage, 13417,
     /* 1035577 */     GIR_EraseRootFromParent_Done,
     /* 1035578 */   // Label 15333: @1035578
     /* 1035578 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1035655), // Rule ID 13420 //
     /* 1035583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035622 */     // MIs[0] policy
     /* 1035622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035632 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1035635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035654 */     // GIR_Coverage, 13420,
     /* 1035654 */     GIR_EraseRootFromParent_Done,
     /* 1035655 */   // Label 15334: @1035655
     /* 1035655 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1035732), // Rule ID 13421 //
     /* 1035660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035699 */     // MIs[0] policy
     /* 1035699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035709 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1035712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035731 */     // GIR_Coverage, 13421,
     /* 1035731 */     GIR_EraseRootFromParent_Done,
     /* 1035732 */   // Label 15335: @1035732
     /* 1035732 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1035809), // Rule ID 13424 //
     /* 1035737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1035748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1035751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1035754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1035757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035776 */     // MIs[0] policy
     /* 1035776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1035789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035808 */     // GIR_Coverage, 13424,
     /* 1035808 */     GIR_EraseRootFromParent_Done,
     /* 1035809 */   // Label 15336: @1035809
     /* 1035809 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1035886), // Rule ID 13425 //
     /* 1035814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1035825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1035828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1035831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1035834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035853 */     // MIs[0] policy
     /* 1035853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035863 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1035866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035885 */     // GIR_Coverage, 13425,
     /* 1035885 */     GIR_EraseRootFromParent_Done,
     /* 1035886 */   // Label 15337: @1035886
     /* 1035886 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1035963), // Rule ID 13428 //
     /* 1035891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1035902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1035905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1035908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1035911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035930 */     // MIs[0] policy
     /* 1035930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1035943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035962 */     // GIR_Coverage, 13428,
     /* 1035962 */     GIR_EraseRootFromParent_Done,
     /* 1035963 */   // Label 15338: @1035963
     /* 1035963 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1036040), // Rule ID 13429 //
     /* 1035968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1035979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1035982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1035985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1035988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036007 */     // MIs[0] policy
     /* 1036007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036017 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036039 */     // GIR_Coverage, 13429,
     /* 1036039 */     GIR_EraseRootFromParent_Done,
     /* 1036040 */   // Label 15339: @1036040
     /* 1036040 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1036117), // Rule ID 13432 //
     /* 1036045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036084 */     // MIs[0] policy
     /* 1036084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036116 */     // GIR_Coverage, 13432,
     /* 1036116 */     GIR_EraseRootFromParent_Done,
     /* 1036117 */   // Label 15340: @1036117
     /* 1036117 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1036194), // Rule ID 13433 //
     /* 1036122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036161 */     // MIs[0] policy
     /* 1036161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036193 */     // GIR_Coverage, 13433,
     /* 1036193 */     GIR_EraseRootFromParent_Done,
     /* 1036194 */   // Label 15341: @1036194
     /* 1036194 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1036271), // Rule ID 13436 //
     /* 1036199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036238 */     // MIs[0] policy
     /* 1036238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036248 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1036251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036270 */     // GIR_Coverage, 13436,
     /* 1036270 */     GIR_EraseRootFromParent_Done,
     /* 1036271 */   // Label 15342: @1036271
     /* 1036271 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1036348), // Rule ID 13437 //
     /* 1036276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036315 */     // MIs[0] policy
     /* 1036315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036325 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1036328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036347 */     // GIR_Coverage, 13437,
     /* 1036347 */     GIR_EraseRootFromParent_Done,
     /* 1036348 */   // Label 15343: @1036348
     /* 1036348 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1036425), // Rule ID 13440 //
     /* 1036353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036392 */     // MIs[0] policy
     /* 1036392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1036405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036424 */     // GIR_Coverage, 13440,
     /* 1036424 */     GIR_EraseRootFromParent_Done,
     /* 1036425 */   // Label 15344: @1036425
     /* 1036425 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1036502), // Rule ID 13441 //
     /* 1036430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036469 */     // MIs[0] policy
     /* 1036469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036479 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1036482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036501 */     // GIR_Coverage, 13441,
     /* 1036501 */     GIR_EraseRootFromParent_Done,
     /* 1036502 */   // Label 15345: @1036502
     /* 1036502 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1036579), // Rule ID 13444 //
     /* 1036507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036546 */     // MIs[0] policy
     /* 1036546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1036559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036578 */     // GIR_Coverage, 13444,
     /* 1036578 */     GIR_EraseRootFromParent_Done,
     /* 1036579 */   // Label 15346: @1036579
     /* 1036579 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1036656), // Rule ID 13445 //
     /* 1036584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036623 */     // MIs[0] policy
     /* 1036623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036633 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1036636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036655 */     // GIR_Coverage, 13445,
     /* 1036655 */     GIR_EraseRootFromParent_Done,
     /* 1036656 */   // Label 15347: @1036656
     /* 1036656 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1036733), // Rule ID 13448 //
     /* 1036661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1036672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1036675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1036678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1036681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036700 */     // MIs[0] policy
     /* 1036700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036732 */     // GIR_Coverage, 13448,
     /* 1036732 */     GIR_EraseRootFromParent_Done,
     /* 1036733 */   // Label 15348: @1036733
     /* 1036733 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1036810), // Rule ID 13449 //
     /* 1036738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1036749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1036752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1036755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1036758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036777 */     // MIs[0] policy
     /* 1036777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1036790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036809 */     // GIR_Coverage, 13449,
     /* 1036809 */     GIR_EraseRootFromParent_Done,
     /* 1036810 */   // Label 15349: @1036810
     /* 1036810 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1036887), // Rule ID 13452 //
     /* 1036815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1036832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1036835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036854 */     // MIs[0] policy
     /* 1036854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036886 */     // GIR_Coverage, 13452,
     /* 1036886 */     GIR_EraseRootFromParent_Done,
     /* 1036887 */   // Label 15350: @1036887
     /* 1036887 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1036964), // Rule ID 13453 //
     /* 1036892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1036903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1036906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1036909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1036912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036931 */     // MIs[0] policy
     /* 1036931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1036944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036963 */     // GIR_Coverage, 13453,
     /* 1036963 */     GIR_EraseRootFromParent_Done,
     /* 1036964 */   // Label 15351: @1036964
     /* 1036964 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1037041), // Rule ID 13456 //
     /* 1036969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1036980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1036983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1036986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1036989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037008 */     // MIs[0] policy
     /* 1037008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037040 */     // GIR_Coverage, 13456,
     /* 1037040 */     GIR_EraseRootFromParent_Done,
     /* 1037041 */   // Label 15352: @1037041
     /* 1037041 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1037118), // Rule ID 13457 //
     /* 1037046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037085 */     // MIs[0] policy
     /* 1037085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037117 */     // GIR_Coverage, 13457,
     /* 1037117 */     GIR_EraseRootFromParent_Done,
     /* 1037118 */   // Label 15353: @1037118
     /* 1037118 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1037195), // Rule ID 13460 //
     /* 1037123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037162 */     // MIs[0] policy
     /* 1037162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037194 */     // GIR_Coverage, 13460,
     /* 1037194 */     GIR_EraseRootFromParent_Done,
     /* 1037195 */   // Label 15354: @1037195
     /* 1037195 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1037272), // Rule ID 13461 //
     /* 1037200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037239 */     // MIs[0] policy
     /* 1037239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037271 */     // GIR_Coverage, 13461,
     /* 1037271 */     GIR_EraseRootFromParent_Done,
     /* 1037272 */   // Label 15355: @1037272
     /* 1037272 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1037349), // Rule ID 13464 //
     /* 1037277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037316 */     // MIs[0] policy
     /* 1037316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1037329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037348 */     // GIR_Coverage, 13464,
     /* 1037348 */     GIR_EraseRootFromParent_Done,
     /* 1037349 */   // Label 15356: @1037349
     /* 1037349 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1037426), // Rule ID 13465 //
     /* 1037354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037393 */     // MIs[0] policy
     /* 1037393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037403 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1037406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037425 */     // GIR_Coverage, 13465,
     /* 1037425 */     GIR_EraseRootFromParent_Done,
     /* 1037426 */   // Label 15357: @1037426
     /* 1037426 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1037503), // Rule ID 13468 //
     /* 1037431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037470 */     // MIs[0] policy
     /* 1037470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1037483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037502 */     // GIR_Coverage, 13468,
     /* 1037502 */     GIR_EraseRootFromParent_Done,
     /* 1037503 */   // Label 15358: @1037503
     /* 1037503 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1037580), // Rule ID 13469 //
     /* 1037508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037547 */     // MIs[0] policy
     /* 1037547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1037560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037579 */     // GIR_Coverage, 13469,
     /* 1037579 */     GIR_EraseRootFromParent_Done,
     /* 1037580 */   // Label 15359: @1037580
     /* 1037580 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1037657), // Rule ID 13472 //
     /* 1037585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037624 */     // MIs[0] policy
     /* 1037624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037656 */     // GIR_Coverage, 13472,
     /* 1037656 */     GIR_EraseRootFromParent_Done,
     /* 1037657 */   // Label 15360: @1037657
     /* 1037657 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1037734), // Rule ID 13473 //
     /* 1037662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037701 */     // MIs[0] policy
     /* 1037701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1037714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037733 */     // GIR_Coverage, 13473,
     /* 1037733 */     GIR_EraseRootFromParent_Done,
     /* 1037734 */   // Label 15361: @1037734
     /* 1037734 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1037811), // Rule ID 13476 //
     /* 1037739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1037750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1037753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1037756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1037759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037778 */     // MIs[0] policy
     /* 1037778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037810 */     // GIR_Coverage, 13476,
     /* 1037810 */     GIR_EraseRootFromParent_Done,
     /* 1037811 */   // Label 15362: @1037811
     /* 1037811 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1037888), // Rule ID 13477 //
     /* 1037816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1037827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1037830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1037833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1037836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037855 */     // MIs[0] policy
     /* 1037855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1037868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037887 */     // GIR_Coverage, 13477,
     /* 1037887 */     GIR_EraseRootFromParent_Done,
     /* 1037888 */   // Label 15363: @1037888
     /* 1037888 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1037965), // Rule ID 13480 //
     /* 1037893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1037910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1037928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037932 */     // MIs[0] policy
     /* 1037932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1037945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037964 */     // GIR_Coverage, 13480,
     /* 1037964 */     GIR_EraseRootFromParent_Done,
     /* 1037965 */   // Label 15364: @1037965
     /* 1037965 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1038042), // Rule ID 13481 //
     /* 1037970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1037978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1037981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1037984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1037987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1037990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038009 */     // MIs[0] policy
     /* 1038009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038019 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1038022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038041 */     // GIR_Coverage, 13481,
     /* 1038041 */     GIR_EraseRootFromParent_Done,
     /* 1038042 */   // Label 15365: @1038042
     /* 1038042 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1038119), // Rule ID 13484 //
     /* 1038047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038086 */     // MIs[0] policy
     /* 1038086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038118 */     // GIR_Coverage, 13484,
     /* 1038118 */     GIR_EraseRootFromParent_Done,
     /* 1038119 */   // Label 15366: @1038119
     /* 1038119 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1038196), // Rule ID 13485 //
     /* 1038124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038163 */     // MIs[0] policy
     /* 1038163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038195 */     // GIR_Coverage, 13485,
     /* 1038195 */     GIR_EraseRootFromParent_Done,
     /* 1038196 */   // Label 15367: @1038196
     /* 1038196 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1038273), // Rule ID 13488 //
     /* 1038201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038240 */     // MIs[0] policy
     /* 1038240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1038253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038272 */     // GIR_Coverage, 13488,
     /* 1038272 */     GIR_EraseRootFromParent_Done,
     /* 1038273 */   // Label 15368: @1038273
     /* 1038273 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1038350), // Rule ID 13489 //
     /* 1038278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038317 */     // MIs[0] policy
     /* 1038317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038327 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1038330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038349 */     // GIR_Coverage, 13489,
     /* 1038349 */     GIR_EraseRootFromParent_Done,
     /* 1038350 */   // Label 15369: @1038350
     /* 1038350 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1038427), // Rule ID 13492 //
     /* 1038355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038394 */     // MIs[0] policy
     /* 1038394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1038407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038426 */     // GIR_Coverage, 13492,
     /* 1038426 */     GIR_EraseRootFromParent_Done,
     /* 1038427 */   // Label 15370: @1038427
     /* 1038427 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1038504), // Rule ID 13493 //
     /* 1038432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038471 */     // MIs[0] policy
     /* 1038471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1038484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038503 */     // GIR_Coverage, 13493,
     /* 1038503 */     GIR_EraseRootFromParent_Done,
     /* 1038504 */   // Label 15371: @1038504
     /* 1038504 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1038581), // Rule ID 13496 //
     /* 1038509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038548 */     // MIs[0] policy
     /* 1038548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1038561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038580 */     // GIR_Coverage, 13496,
     /* 1038580 */     GIR_EraseRootFromParent_Done,
     /* 1038581 */   // Label 15372: @1038581
     /* 1038581 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1038658), // Rule ID 13497 //
     /* 1038586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038625 */     // MIs[0] policy
     /* 1038625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038635 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1038638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038657 */     // GIR_Coverage, 13497,
     /* 1038657 */     GIR_EraseRootFromParent_Done,
     /* 1038658 */   // Label 15373: @1038658
     /* 1038658 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1038735), // Rule ID 13500 //
     /* 1038663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1038674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1038677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038702 */     // MIs[0] policy
     /* 1038702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1038715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038734 */     // GIR_Coverage, 13500,
     /* 1038734 */     GIR_EraseRootFromParent_Done,
     /* 1038735 */   // Label 15374: @1038735
     /* 1038735 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1038812), // Rule ID 13501 //
     /* 1038740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1038751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1038754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038779 */     // MIs[0] policy
     /* 1038779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038789 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1038792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038811 */     // GIR_Coverage, 13501,
     /* 1038811 */     GIR_EraseRootFromParent_Done,
     /* 1038812 */   // Label 15375: @1038812
     /* 1038812 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1038889), // Rule ID 13504 //
     /* 1038817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1038828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1038831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1038837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038856 */     // MIs[0] policy
     /* 1038856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038888 */     // GIR_Coverage, 13504,
     /* 1038888 */     GIR_EraseRootFromParent_Done,
     /* 1038889 */   // Label 15376: @1038889
     /* 1038889 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1038966), // Rule ID 13505 //
     /* 1038894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1038905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1038908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1038914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038933 */     // MIs[0] policy
     /* 1038933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1038946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038965 */     // GIR_Coverage, 13505,
     /* 1038965 */     GIR_EraseRootFromParent_Done,
     /* 1038966 */   // Label 15377: @1038966
     /* 1038966 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1039043), // Rule ID 13508 //
     /* 1038971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1038979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1038982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1038985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1038991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039010 */     // MIs[0] policy
     /* 1039010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039042 */     // GIR_Coverage, 13508,
     /* 1039042 */     GIR_EraseRootFromParent_Done,
     /* 1039043 */   // Label 15378: @1039043
     /* 1039043 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1039120), // Rule ID 13509 //
     /* 1039048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039087 */     // MIs[0] policy
     /* 1039087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039097 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039119 */     // GIR_Coverage, 13509,
     /* 1039119 */     GIR_EraseRootFromParent_Done,
     /* 1039120 */   // Label 15379: @1039120
     /* 1039120 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1039197), // Rule ID 13512 //
     /* 1039125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039164 */     // MIs[0] policy
     /* 1039164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039196 */     // GIR_Coverage, 13512,
     /* 1039196 */     GIR_EraseRootFromParent_Done,
     /* 1039197 */   // Label 15380: @1039197
     /* 1039197 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1039274), // Rule ID 13513 //
     /* 1039202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039241 */     // MIs[0] policy
     /* 1039241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039273 */     // GIR_Coverage, 13513,
     /* 1039273 */     GIR_EraseRootFromParent_Done,
     /* 1039274 */   // Label 15381: @1039274
     /* 1039274 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1039351), // Rule ID 13516 //
     /* 1039279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039318 */     // MIs[0] policy
     /* 1039318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039350 */     // GIR_Coverage, 13516,
     /* 1039350 */     GIR_EraseRootFromParent_Done,
     /* 1039351 */   // Label 15382: @1039351
     /* 1039351 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1039428), // Rule ID 13517 //
     /* 1039356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039395 */     // MIs[0] policy
     /* 1039395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039427 */     // GIR_Coverage, 13517,
     /* 1039427 */     GIR_EraseRootFromParent_Done,
     /* 1039428 */   // Label 15383: @1039428
     /* 1039428 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1039505), // Rule ID 13520 //
     /* 1039433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039472 */     // MIs[0] policy
     /* 1039472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1039485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039504 */     // GIR_Coverage, 13520,
     /* 1039504 */     GIR_EraseRootFromParent_Done,
     /* 1039505 */   // Label 15384: @1039505
     /* 1039505 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1039582), // Rule ID 13521 //
     /* 1039510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039549 */     // MIs[0] policy
     /* 1039549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1039562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039581 */     // GIR_Coverage, 13521,
     /* 1039581 */     GIR_EraseRootFromParent_Done,
     /* 1039582 */   // Label 15385: @1039582
     /* 1039582 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1039659), // Rule ID 13524 //
     /* 1039587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039626 */     // MIs[0] policy
     /* 1039626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039658 */     // GIR_Coverage, 13524,
     /* 1039658 */     GIR_EraseRootFromParent_Done,
     /* 1039659 */   // Label 15386: @1039659
     /* 1039659 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1039736), // Rule ID 13525 //
     /* 1039664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039703 */     // MIs[0] policy
     /* 1039703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1039716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039735 */     // GIR_Coverage, 13525,
     /* 1039735 */     GIR_EraseRootFromParent_Done,
     /* 1039736 */   // Label 15387: @1039736
     /* 1039736 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1039813), // Rule ID 13528 //
     /* 1039741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1039752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1039755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1039761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039780 */     // MIs[0] policy
     /* 1039780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039812 */     // GIR_Coverage, 13528,
     /* 1039812 */     GIR_EraseRootFromParent_Done,
     /* 1039813 */   // Label 15388: @1039813
     /* 1039813 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1039890), // Rule ID 13529 //
     /* 1039818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1039829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1039832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1039838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039857 */     // MIs[0] policy
     /* 1039857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1039870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039889 */     // GIR_Coverage, 13529,
     /* 1039889 */     GIR_EraseRootFromParent_Done,
     /* 1039890 */   // Label 15389: @1039890
     /* 1039890 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1039967), // Rule ID 13532 //
     /* 1039895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1039906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1039909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039934 */     // MIs[0] policy
     /* 1039934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1039947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039966 */     // GIR_Coverage, 13532,
     /* 1039966 */     GIR_EraseRootFromParent_Done,
     /* 1039967 */   // Label 15390: @1039967
     /* 1039967 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1040044), // Rule ID 13533 //
     /* 1039972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1039980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1039983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1039986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1039992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040011 */     // MIs[0] policy
     /* 1040011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040021 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1040024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040043 */     // GIR_Coverage, 13533,
     /* 1040043 */     GIR_EraseRootFromParent_Done,
     /* 1040044 */   // Label 15391: @1040044
     /* 1040044 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1040121), // Rule ID 13536 //
     /* 1040049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1040057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040088 */     // MIs[0] policy
     /* 1040088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1040101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040120 */     // GIR_Coverage, 13536,
     /* 1040120 */     GIR_EraseRootFromParent_Done,
     /* 1040121 */   // Label 15392: @1040121
     /* 1040121 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1040198), // Rule ID 13537 //
     /* 1040126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1040134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040165 */     // MIs[0] policy
     /* 1040165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040175 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1040178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040197 */     // GIR_Coverage, 13537,
     /* 1040197 */     GIR_EraseRootFromParent_Done,
     /* 1040198 */   // Label 15393: @1040198
     /* 1040198 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1040275), // Rule ID 13540 //
     /* 1040203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040242 */     // MIs[0] policy
     /* 1040242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1040255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040274 */     // GIR_Coverage, 13540,
     /* 1040274 */     GIR_EraseRootFromParent_Done,
     /* 1040275 */   // Label 15394: @1040275
     /* 1040275 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1040352), // Rule ID 13541 //
     /* 1040280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040319 */     // MIs[0] policy
     /* 1040319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040329 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1040332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040351 */     // GIR_Coverage, 13541,
     /* 1040351 */     GIR_EraseRootFromParent_Done,
     /* 1040352 */   // Label 15395: @1040352
     /* 1040352 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1040429), // Rule ID 13544 //
     /* 1040357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040396 */     // MIs[0] policy
     /* 1040396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1040409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040428 */     // GIR_Coverage, 13544,
     /* 1040428 */     GIR_EraseRootFromParent_Done,
     /* 1040429 */   // Label 15396: @1040429
     /* 1040429 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1040506), // Rule ID 13545 //
     /* 1040434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040473 */     // MIs[0] policy
     /* 1040473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040483 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1040486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040505 */     // GIR_Coverage, 13545,
     /* 1040505 */     GIR_EraseRootFromParent_Done,
     /* 1040506 */   // Label 15397: @1040506
     /* 1040506 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1040583), // Rule ID 13548 //
     /* 1040511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040550 */     // MIs[0] policy
     /* 1040550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1040563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040582 */     // GIR_Coverage, 13548,
     /* 1040582 */     GIR_EraseRootFromParent_Done,
     /* 1040583 */   // Label 15398: @1040583
     /* 1040583 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1040660), // Rule ID 13549 //
     /* 1040588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040627 */     // MIs[0] policy
     /* 1040627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040637 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1040640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040659 */     // GIR_Coverage, 13549,
     /* 1040659 */     GIR_EraseRootFromParent_Done,
     /* 1040660 */   // Label 15399: @1040660
     /* 1040660 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1040737), // Rule ID 13552 //
     /* 1040665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1040676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1040679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1040682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1040685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040704 */     // MIs[0] policy
     /* 1040704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1040717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040736 */     // GIR_Coverage, 13552,
     /* 1040736 */     GIR_EraseRootFromParent_Done,
     /* 1040737 */   // Label 15400: @1040737
     /* 1040737 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1040814), // Rule ID 13553 //
     /* 1040742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1040753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1040756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1040759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1040762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040781 */     // MIs[0] policy
     /* 1040781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1040794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040813 */     // GIR_Coverage, 13553,
     /* 1040813 */     GIR_EraseRootFromParent_Done,
     /* 1040814 */   // Label 15401: @1040814
     /* 1040814 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1040891), // Rule ID 13556 //
     /* 1040819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1040830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1040833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1040836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1040839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040858 */     // MIs[0] policy
     /* 1040858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1040871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040890 */     // GIR_Coverage, 13556,
     /* 1040890 */     GIR_EraseRootFromParent_Done,
     /* 1040891 */   // Label 15402: @1040891
     /* 1040891 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1040968), // Rule ID 13557 //
     /* 1040896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1040907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1040910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1040913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1040916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040935 */     // MIs[0] policy
     /* 1040935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040945 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1040948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040967 */     // GIR_Coverage, 13557,
     /* 1040967 */     GIR_EraseRootFromParent_Done,
     /* 1040968 */   // Label 15403: @1040968
     /* 1040968 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1041045), // Rule ID 13560 //
     /* 1040973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1040984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1040987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1040990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1040993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041012 */     // MIs[0] policy
     /* 1041012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041044 */     // GIR_Coverage, 13560,
     /* 1041044 */     GIR_EraseRootFromParent_Done,
     /* 1041045 */   // Label 15404: @1041045
     /* 1041045 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1041122), // Rule ID 13561 //
     /* 1041050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041089 */     // MIs[0] policy
     /* 1041089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041121 */     // GIR_Coverage, 13561,
     /* 1041121 */     GIR_EraseRootFromParent_Done,
     /* 1041122 */   // Label 15405: @1041122
     /* 1041122 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1041199), // Rule ID 13564 //
     /* 1041127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041166 */     // MIs[0] policy
     /* 1041166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1041179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041198 */     // GIR_Coverage, 13564,
     /* 1041198 */     GIR_EraseRootFromParent_Done,
     /* 1041199 */   // Label 15406: @1041199
     /* 1041199 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1041276), // Rule ID 13565 //
     /* 1041204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041243 */     // MIs[0] policy
     /* 1041243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041253 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1041256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041275 */     // GIR_Coverage, 13565,
     /* 1041275 */     GIR_EraseRootFromParent_Done,
     /* 1041276 */   // Label 15407: @1041276
     /* 1041276 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1041353), // Rule ID 13568 //
     /* 1041281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041320 */     // MIs[0] policy
     /* 1041320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041352 */     // GIR_Coverage, 13568,
     /* 1041352 */     GIR_EraseRootFromParent_Done,
     /* 1041353 */   // Label 15408: @1041353
     /* 1041353 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1041430), // Rule ID 13569 //
     /* 1041358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041397 */     // MIs[0] policy
     /* 1041397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041429 */     // GIR_Coverage, 13569,
     /* 1041429 */     GIR_EraseRootFromParent_Done,
     /* 1041430 */   // Label 15409: @1041430
     /* 1041430 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1041507), // Rule ID 13572 //
     /* 1041435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041474 */     // MIs[0] policy
     /* 1041474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1041487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041506 */     // GIR_Coverage, 13572,
     /* 1041506 */     GIR_EraseRootFromParent_Done,
     /* 1041507 */   // Label 15410: @1041507
     /* 1041507 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1041584), // Rule ID 13573 //
     /* 1041512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041551 */     // MIs[0] policy
     /* 1041551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1041564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041583 */     // GIR_Coverage, 13573,
     /* 1041583 */     GIR_EraseRootFromParent_Done,
     /* 1041584 */   // Label 15411: @1041584
     /* 1041584 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1041661), // Rule ID 13576 //
     /* 1041589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041628 */     // MIs[0] policy
     /* 1041628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1041641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041660 */     // GIR_Coverage, 13576,
     /* 1041660 */     GIR_EraseRootFromParent_Done,
     /* 1041661 */   // Label 15412: @1041661
     /* 1041661 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1041738), // Rule ID 13577 //
     /* 1041666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041705 */     // MIs[0] policy
     /* 1041705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041715 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1041718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041737 */     // GIR_Coverage, 13577,
     /* 1041737 */     GIR_EraseRootFromParent_Done,
     /* 1041738 */   // Label 15413: @1041738
     /* 1041738 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1041815), // Rule ID 13580 //
     /* 1041743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1041754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1041757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1041760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1041763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041782 */     // MIs[0] policy
     /* 1041782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041814 */     // GIR_Coverage, 13580,
     /* 1041814 */     GIR_EraseRootFromParent_Done,
     /* 1041815 */   // Label 15414: @1041815
     /* 1041815 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1041892), // Rule ID 13581 //
     /* 1041820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1041831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1041834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1041837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1041840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041859 */     // MIs[0] policy
     /* 1041859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1041872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041891 */     // GIR_Coverage, 13581,
     /* 1041891 */     GIR_EraseRootFromParent_Done,
     /* 1041892 */   // Label 15415: @1041892
     /* 1041892 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1041969), // Rule ID 13584 //
     /* 1041897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1041900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1041908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1041911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1041917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041936 */     // MIs[0] policy
     /* 1041936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1041949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1041965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041968 */     // GIR_Coverage, 13584,
     /* 1041968 */     GIR_EraseRootFromParent_Done,
     /* 1041969 */   // Label 15416: @1041969
     /* 1041969 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1042046), // Rule ID 13585 //
     /* 1041974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1041977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1041982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1041985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1041988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1041991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1041994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042013 */     // MIs[0] policy
     /* 1042013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042023 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1042026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042045 */     // GIR_Coverage, 13585,
     /* 1042045 */     GIR_EraseRootFromParent_Done,
     /* 1042046 */   // Label 15417: @1042046
     /* 1042046 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1042123), // Rule ID 13588 //
     /* 1042051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042090 */     // MIs[0] policy
     /* 1042090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1042103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042122 */     // GIR_Coverage, 13588,
     /* 1042122 */     GIR_EraseRootFromParent_Done,
     /* 1042123 */   // Label 15418: @1042123
     /* 1042123 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1042200), // Rule ID 13589 //
     /* 1042128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042167 */     // MIs[0] policy
     /* 1042167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1042180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042199 */     // GIR_Coverage, 13589,
     /* 1042199 */     GIR_EraseRootFromParent_Done,
     /* 1042200 */   // Label 15419: @1042200
     /* 1042200 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1042277), // Rule ID 13592 //
     /* 1042205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042244 */     // MIs[0] policy
     /* 1042244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1042257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042276 */     // GIR_Coverage, 13592,
     /* 1042276 */     GIR_EraseRootFromParent_Done,
     /* 1042277 */   // Label 15420: @1042277
     /* 1042277 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1042354), // Rule ID 13593 //
     /* 1042282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042321 */     // MIs[0] policy
     /* 1042321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042331 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1042334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042353 */     // GIR_Coverage, 13593,
     /* 1042353 */     GIR_EraseRootFromParent_Done,
     /* 1042354 */   // Label 15421: @1042354
     /* 1042354 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1042431), // Rule ID 13596 //
     /* 1042359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042398 */     // MIs[0] policy
     /* 1042398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1042411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042430 */     // GIR_Coverage, 13596,
     /* 1042430 */     GIR_EraseRootFromParent_Done,
     /* 1042431 */   // Label 15422: @1042431
     /* 1042431 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1042508), // Rule ID 13597 //
     /* 1042436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042475 */     // MIs[0] policy
     /* 1042475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042485 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1042488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042507 */     // GIR_Coverage, 13597,
     /* 1042507 */     GIR_EraseRootFromParent_Done,
     /* 1042508 */   // Label 15423: @1042508
     /* 1042508 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1042585), // Rule ID 13600 //
     /* 1042513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042552 */     // MIs[0] policy
     /* 1042552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1042565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042584 */     // GIR_Coverage, 13600,
     /* 1042584 */     GIR_EraseRootFromParent_Done,
     /* 1042585 */   // Label 15424: @1042585
     /* 1042585 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1042662), // Rule ID 13601 //
     /* 1042590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042629 */     // MIs[0] policy
     /* 1042629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042639 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1042642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042661 */     // GIR_Coverage, 13601,
     /* 1042661 */     GIR_EraseRootFromParent_Done,
     /* 1042662 */   // Label 15425: @1042662
     /* 1042662 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1042739), // Rule ID 13604 //
     /* 1042667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1042678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1042681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1042687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042706 */     // MIs[0] policy
     /* 1042706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1042719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042738 */     // GIR_Coverage, 13604,
     /* 1042738 */     GIR_EraseRootFromParent_Done,
     /* 1042739 */   // Label 15426: @1042739
     /* 1042739 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1042816), // Rule ID 13605 //
     /* 1042744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1042755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1042758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1042764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042783 */     // MIs[0] policy
     /* 1042783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1042796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042815 */     // GIR_Coverage, 13605,
     /* 1042815 */     GIR_EraseRootFromParent_Done,
     /* 1042816 */   // Label 15427: @1042816
     /* 1042816 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1042893), // Rule ID 13608 //
     /* 1042821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1042832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1042835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1042841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042860 */     // MIs[0] policy
     /* 1042860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1042873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042892 */     // GIR_Coverage, 13608,
     /* 1042892 */     GIR_EraseRootFromParent_Done,
     /* 1042893 */   // Label 15428: @1042893
     /* 1042893 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1042970), // Rule ID 13609 //
     /* 1042898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1042909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1042912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1042918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042937 */     // MIs[0] policy
     /* 1042937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042947 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1042950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042969 */     // GIR_Coverage, 13609,
     /* 1042969 */     GIR_EraseRootFromParent_Done,
     /* 1042970 */   // Label 15429: @1042970
     /* 1042970 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1043047), // Rule ID 13612 //
     /* 1042975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1042983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1042986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1042989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1042995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043014 */     // MIs[0] policy
     /* 1043014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043046 */     // GIR_Coverage, 13612,
     /* 1043046 */     GIR_EraseRootFromParent_Done,
     /* 1043047 */   // Label 15430: @1043047
     /* 1043047 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1043124), // Rule ID 13613 //
     /* 1043052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043091 */     // MIs[0] policy
     /* 1043091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043123 */     // GIR_Coverage, 13613,
     /* 1043123 */     GIR_EraseRootFromParent_Done,
     /* 1043124 */   // Label 15431: @1043124
     /* 1043124 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1043201), // Rule ID 13616 //
     /* 1043129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043168 */     // MIs[0] policy
     /* 1043168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043178 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043200 */     // GIR_Coverage, 13616,
     /* 1043200 */     GIR_EraseRootFromParent_Done,
     /* 1043201 */   // Label 15432: @1043201
     /* 1043201 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1043278), // Rule ID 13617 //
     /* 1043206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043245 */     // MIs[0] policy
     /* 1043245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043255 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043277 */     // GIR_Coverage, 13617,
     /* 1043277 */     GIR_EraseRootFromParent_Done,
     /* 1043278 */   // Label 15433: @1043278
     /* 1043278 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1043355), // Rule ID 13620 //
     /* 1043283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043322 */     // MIs[0] policy
     /* 1043322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1043335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043354 */     // GIR_Coverage, 13620,
     /* 1043354 */     GIR_EraseRootFromParent_Done,
     /* 1043355 */   // Label 15434: @1043355
     /* 1043355 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1043432), // Rule ID 13621 //
     /* 1043360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043399 */     // MIs[0] policy
     /* 1043399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1043412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043431 */     // GIR_Coverage, 13621,
     /* 1043431 */     GIR_EraseRootFromParent_Done,
     /* 1043432 */   // Label 15435: @1043432
     /* 1043432 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1043509), // Rule ID 13624 //
     /* 1043437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043476 */     // MIs[0] policy
     /* 1043476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1043489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043508 */     // GIR_Coverage, 13624,
     /* 1043508 */     GIR_EraseRootFromParent_Done,
     /* 1043509 */   // Label 15436: @1043509
     /* 1043509 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1043586), // Rule ID 13625 //
     /* 1043514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043553 */     // MIs[0] policy
     /* 1043553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043563 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1043566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043585 */     // GIR_Coverage, 13625,
     /* 1043585 */     GIR_EraseRootFromParent_Done,
     /* 1043586 */   // Label 15437: @1043586
     /* 1043586 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1043663), // Rule ID 13628 //
     /* 1043591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043630 */     // MIs[0] policy
     /* 1043630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1043643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043662 */     // GIR_Coverage, 13628,
     /* 1043662 */     GIR_EraseRootFromParent_Done,
     /* 1043663 */   // Label 15438: @1043663
     /* 1043663 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1043740), // Rule ID 13629 //
     /* 1043668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043707 */     // MIs[0] policy
     /* 1043707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043717 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1043720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043739 */     // GIR_Coverage, 13629,
     /* 1043739 */     GIR_EraseRootFromParent_Done,
     /* 1043740 */   // Label 15439: @1043740
     /* 1043740 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1043817), // Rule ID 13632 //
     /* 1043745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1043765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043784 */     // MIs[0] policy
     /* 1043784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043816 */     // GIR_Coverage, 13632,
     /* 1043816 */     GIR_EraseRootFromParent_Done,
     /* 1043817 */   // Label 15440: @1043817
     /* 1043817 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1043894), // Rule ID 13633 //
     /* 1043822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1043833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1043836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1043842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043861 */     // MIs[0] policy
     /* 1043861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1043874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043893 */     // GIR_Coverage, 13633,
     /* 1043893 */     GIR_EraseRootFromParent_Done,
     /* 1043894 */   // Label 15441: @1043894
     /* 1043894 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1043971), // Rule ID 13636 //
     /* 1043899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1043919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043938 */     // MIs[0] policy
     /* 1043938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1043951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043970 */     // GIR_Coverage, 13636,
     /* 1043970 */     GIR_EraseRootFromParent_Done,
     /* 1043971 */   // Label 15442: @1043971
     /* 1043971 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1044048), // Rule ID 13637 //
     /* 1043976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1043984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1043987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1043990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1043996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044015 */     // MIs[0] policy
     /* 1044015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044025 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044047 */     // GIR_Coverage, 13637,
     /* 1044047 */     GIR_EraseRootFromParent_Done,
     /* 1044048 */   // Label 15443: @1044048
     /* 1044048 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1044125), // Rule ID 13640 //
     /* 1044053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044092 */     // MIs[0] policy
     /* 1044092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044124 */     // GIR_Coverage, 13640,
     /* 1044124 */     GIR_EraseRootFromParent_Done,
     /* 1044125 */   // Label 15444: @1044125
     /* 1044125 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1044202), // Rule ID 13641 //
     /* 1044130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044169 */     // MIs[0] policy
     /* 1044169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044179 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044201 */     // GIR_Coverage, 13641,
     /* 1044201 */     GIR_EraseRootFromParent_Done,
     /* 1044202 */   // Label 15445: @1044202
     /* 1044202 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1044279), // Rule ID 13644 //
     /* 1044207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044246 */     // MIs[0] policy
     /* 1044246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1044259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044278 */     // GIR_Coverage, 13644,
     /* 1044278 */     GIR_EraseRootFromParent_Done,
     /* 1044279 */   // Label 15446: @1044279
     /* 1044279 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1044356), // Rule ID 13645 //
     /* 1044284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044323 */     // MIs[0] policy
     /* 1044323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044333 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1044336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044355 */     // GIR_Coverage, 13645,
     /* 1044355 */     GIR_EraseRootFromParent_Done,
     /* 1044356 */   // Label 15447: @1044356
     /* 1044356 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1044433), // Rule ID 13648 //
     /* 1044361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044400 */     // MIs[0] policy
     /* 1044400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1044413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044432 */     // GIR_Coverage, 13648,
     /* 1044432 */     GIR_EraseRootFromParent_Done,
     /* 1044433 */   // Label 15448: @1044433
     /* 1044433 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1044510), // Rule ID 13649 //
     /* 1044438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044477 */     // MIs[0] policy
     /* 1044477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1044490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044509 */     // GIR_Coverage, 13649,
     /* 1044509 */     GIR_EraseRootFromParent_Done,
     /* 1044510 */   // Label 15449: @1044510
     /* 1044510 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1044587), // Rule ID 13652 //
     /* 1044515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044554 */     // MIs[0] policy
     /* 1044554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044586 */     // GIR_Coverage, 13652,
     /* 1044586 */     GIR_EraseRootFromParent_Done,
     /* 1044587 */   // Label 15450: @1044587
     /* 1044587 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1044664), // Rule ID 13653 //
     /* 1044592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044631 */     // MIs[0] policy
     /* 1044631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1044644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044663 */     // GIR_Coverage, 13653,
     /* 1044663 */     GIR_EraseRootFromParent_Done,
     /* 1044664 */   // Label 15451: @1044664
     /* 1044664 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1044741), // Rule ID 13656 //
     /* 1044669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1044689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044708 */     // MIs[0] policy
     /* 1044708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044718 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044740 */     // GIR_Coverage, 13656,
     /* 1044740 */     GIR_EraseRootFromParent_Done,
     /* 1044741 */   // Label 15452: @1044741
     /* 1044741 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1044818), // Rule ID 13657 //
     /* 1044746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1044754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1044766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044785 */     // MIs[0] policy
     /* 1044785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044795 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1044798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044817 */     // GIR_Coverage, 13657,
     /* 1044817 */     GIR_EraseRootFromParent_Done,
     /* 1044818 */   // Label 15453: @1044818
     /* 1044818 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1044895), // Rule ID 13660 //
     /* 1044823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044862 */     // MIs[0] policy
     /* 1044862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1044875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044894 */     // GIR_Coverage, 13660,
     /* 1044894 */     GIR_EraseRootFromParent_Done,
     /* 1044895 */   // Label 15454: @1044895
     /* 1044895 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1044972), // Rule ID 13661 //
     /* 1044900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1044911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1044914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1044917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1044920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044939 */     // MIs[0] policy
     /* 1044939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044949 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1044952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044971 */     // GIR_Coverage, 13661,
     /* 1044971 */     GIR_EraseRootFromParent_Done,
     /* 1044972 */   // Label 15455: @1044972
     /* 1044972 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1045049), // Rule ID 13664 //
     /* 1044977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1044988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1044991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1044994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1044997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045016 */     // MIs[0] policy
     /* 1045016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045048 */     // GIR_Coverage, 13664,
     /* 1045048 */     GIR_EraseRootFromParent_Done,
     /* 1045049 */   // Label 15456: @1045049
     /* 1045049 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1045126), // Rule ID 13665 //
     /* 1045054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1045071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045093 */     // MIs[0] policy
     /* 1045093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045103 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045125 */     // GIR_Coverage, 13665,
     /* 1045125 */     GIR_EraseRootFromParent_Done,
     /* 1045126 */   // Label 15457: @1045126
     /* 1045126 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1045203), // Rule ID 13668 //
     /* 1045131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1045148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045170 */     // MIs[0] policy
     /* 1045170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045202 */     // GIR_Coverage, 13668,
     /* 1045202 */     GIR_EraseRootFromParent_Done,
     /* 1045203 */   // Label 15458: @1045203
     /* 1045203 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1045280), // Rule ID 13669 //
     /* 1045208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1045225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045247 */     // MIs[0] policy
     /* 1045247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045257 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045279 */     // GIR_Coverage, 13669,
     /* 1045279 */     GIR_EraseRootFromParent_Done,
     /* 1045280 */   // Label 15459: @1045280
     /* 1045280 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1045357), // Rule ID 13672 //
     /* 1045285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045324 */     // MIs[0] policy
     /* 1045324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1045337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045356 */     // GIR_Coverage, 13672,
     /* 1045356 */     GIR_EraseRootFromParent_Done,
     /* 1045357 */   // Label 15460: @1045357
     /* 1045357 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1045434), // Rule ID 13673 //
     /* 1045362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1045379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045401 */     // MIs[0] policy
     /* 1045401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045411 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1045414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045433 */     // GIR_Coverage, 13673,
     /* 1045433 */     GIR_EraseRootFromParent_Done,
     /* 1045434 */   // Label 15461: @1045434
     /* 1045434 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1045511), // Rule ID 13676 //
     /* 1045439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045478 */     // MIs[0] policy
     /* 1045478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1045491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045510 */     // GIR_Coverage, 13676,
     /* 1045510 */     GIR_EraseRootFromParent_Done,
     /* 1045511 */   // Label 15462: @1045511
     /* 1045511 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1045588), // Rule ID 13677 //
     /* 1045516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1045533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045555 */     // MIs[0] policy
     /* 1045555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045565 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1045568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045587 */     // GIR_Coverage, 13677,
     /* 1045587 */     GIR_EraseRootFromParent_Done,
     /* 1045588 */   // Label 15463: @1045588
     /* 1045588 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1045665), // Rule ID 13680 //
     /* 1045593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1045610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045632 */     // MIs[0] policy
     /* 1045632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1045645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045664 */     // GIR_Coverage, 13680,
     /* 1045664 */     GIR_EraseRootFromParent_Done,
     /* 1045665 */   // Label 15464: @1045665
     /* 1045665 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1045742), // Rule ID 13681 //
     /* 1045670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1045687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045709 */     // MIs[0] policy
     /* 1045709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045719 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1045722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045741 */     // GIR_Coverage, 13681,
     /* 1045741 */     GIR_EraseRootFromParent_Done,
     /* 1045742 */   // Label 15465: @1045742
     /* 1045742 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1045819), // Rule ID 13684 //
     /* 1045747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1045758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1045761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1045764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1045767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045786 */     // MIs[0] policy
     /* 1045786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045818 */     // GIR_Coverage, 13684,
     /* 1045818 */     GIR_EraseRootFromParent_Done,
     /* 1045819 */   // Label 15466: @1045819
     /* 1045819 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1045896), // Rule ID 13685 //
     /* 1045824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1045835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1045838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1045841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1045844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045863 */     // MIs[0] policy
     /* 1045863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1045876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045895 */     // GIR_Coverage, 13685,
     /* 1045895 */     GIR_EraseRootFromParent_Done,
     /* 1045896 */   // Label 15467: @1045896
     /* 1045896 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1045973), // Rule ID 13688 //
     /* 1045901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1045918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1045921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045940 */     // MIs[0] policy
     /* 1045940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1045953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1045969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045972 */     // GIR_Coverage, 13688,
     /* 1045972 */     GIR_EraseRootFromParent_Done,
     /* 1045973 */   // Label 15468: @1045973
     /* 1045973 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1046050), // Rule ID 13689 //
     /* 1045978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1045989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1045992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1045995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1045998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046017 */     // MIs[0] policy
     /* 1046017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046049 */     // GIR_Coverage, 13689,
     /* 1046049 */     GIR_EraseRootFromParent_Done,
     /* 1046050 */   // Label 15469: @1046050
     /* 1046050 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1046127), // Rule ID 13692 //
     /* 1046055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1046072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046094 */     // MIs[0] policy
     /* 1046094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046126 */     // GIR_Coverage, 13692,
     /* 1046126 */     GIR_EraseRootFromParent_Done,
     /* 1046127 */   // Label 15470: @1046127
     /* 1046127 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1046204), // Rule ID 13693 //
     /* 1046132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1046149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046171 */     // MIs[0] policy
     /* 1046171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046203 */     // GIR_Coverage, 13693,
     /* 1046203 */     GIR_EraseRootFromParent_Done,
     /* 1046204 */   // Label 15471: @1046204
     /* 1046204 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1046281), // Rule ID 13696 //
     /* 1046209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046248 */     // MIs[0] policy
     /* 1046248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046280 */     // GIR_Coverage, 13696,
     /* 1046280 */     GIR_EraseRootFromParent_Done,
     /* 1046281 */   // Label 15472: @1046281
     /* 1046281 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1046358), // Rule ID 13697 //
     /* 1046286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1046303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046325 */     // MIs[0] policy
     /* 1046325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046335 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046357 */     // GIR_Coverage, 13697,
     /* 1046357 */     GIR_EraseRootFromParent_Done,
     /* 1046358 */   // Label 15473: @1046358
     /* 1046358 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1046435), // Rule ID 13700 //
     /* 1046363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046402 */     // MIs[0] policy
     /* 1046402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1046415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046434 */     // GIR_Coverage, 13700,
     /* 1046434 */     GIR_EraseRootFromParent_Done,
     /* 1046435 */   // Label 15474: @1046435
     /* 1046435 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1046512), // Rule ID 13701 //
     /* 1046440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1046457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046479 */     // MIs[0] policy
     /* 1046479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046489 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1046492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046511 */     // GIR_Coverage, 13701,
     /* 1046511 */     GIR_EraseRootFromParent_Done,
     /* 1046512 */   // Label 15475: @1046512
     /* 1046512 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1046589), // Rule ID 13704 //
     /* 1046517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1046534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046556 */     // MIs[0] policy
     /* 1046556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046588 */     // GIR_Coverage, 13704,
     /* 1046588 */     GIR_EraseRootFromParent_Done,
     /* 1046589 */   // Label 15476: @1046589
     /* 1046589 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1046666), // Rule ID 13705 //
     /* 1046594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1046611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046633 */     // MIs[0] policy
     /* 1046633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046643 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1046646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046665 */     // GIR_Coverage, 13705,
     /* 1046665 */     GIR_EraseRootFromParent_Done,
     /* 1046666 */   // Label 15477: @1046666
     /* 1046666 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1046743), // Rule ID 13708 //
     /* 1046671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1046682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1046685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1046688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1046691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046710 */     // MIs[0] policy
     /* 1046710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046742 */     // GIR_Coverage, 13708,
     /* 1046742 */     GIR_EraseRootFromParent_Done,
     /* 1046743 */   // Label 15478: @1046743
     /* 1046743 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1046820), // Rule ID 13709 //
     /* 1046748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1046759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1046762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1046765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1046768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046787 */     // MIs[0] policy
     /* 1046787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046797 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1046800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046819 */     // GIR_Coverage, 13709,
     /* 1046819 */     GIR_EraseRootFromParent_Done,
     /* 1046820 */   // Label 15479: @1046820
     /* 1046820 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1046897), // Rule ID 13712 //
     /* 1046825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1046836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1046839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046864 */     // MIs[0] policy
     /* 1046864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046896 */     // GIR_Coverage, 13712,
     /* 1046896 */     GIR_EraseRootFromParent_Done,
     /* 1046897 */   // Label 15480: @1046897
     /* 1046897 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1046974), // Rule ID 13713 //
     /* 1046902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1046913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1046916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1046919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1046922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046941 */     // MIs[0] policy
     /* 1046941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046951 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1046954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046973 */     // GIR_Coverage, 13713,
     /* 1046973 */     GIR_EraseRootFromParent_Done,
     /* 1046974 */   // Label 15481: @1046974
     /* 1046974 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1047051), // Rule ID 13716 //
     /* 1046979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1046987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1046990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1046993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1046996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1046999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047018 */     // MIs[0] policy
     /* 1047018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1047031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047050 */     // GIR_Coverage, 13716,
     /* 1047050 */     GIR_EraseRootFromParent_Done,
     /* 1047051 */   // Label 15482: @1047051
     /* 1047051 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1047128), // Rule ID 13717 //
     /* 1047056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1047073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047095 */     // MIs[0] policy
     /* 1047095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047105 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1047108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047127 */     // GIR_Coverage, 13717,
     /* 1047127 */     GIR_EraseRootFromParent_Done,
     /* 1047128 */   // Label 15483: @1047128
     /* 1047128 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1047205), // Rule ID 13720 //
     /* 1047133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1047144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1047147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1047153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047172 */     // MIs[0] policy
     /* 1047172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1047185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047204 */     // GIR_Coverage, 13720,
     /* 1047204 */     GIR_EraseRootFromParent_Done,
     /* 1047205 */   // Label 15484: @1047205
     /* 1047205 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1047282), // Rule ID 13721 //
     /* 1047210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1047221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1047224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1047230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047249 */     // MIs[0] policy
     /* 1047249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047259 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1047262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047281 */     // GIR_Coverage, 13721,
     /* 1047281 */     GIR_EraseRootFromParent_Done,
     /* 1047282 */   // Label 15485: @1047282
     /* 1047282 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1047359), // Rule ID 13724 //
     /* 1047287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1047307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047326 */     // MIs[0] policy
     /* 1047326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1047339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047358 */     // GIR_Coverage, 13724,
     /* 1047358 */     GIR_EraseRootFromParent_Done,
     /* 1047359 */   // Label 15486: @1047359
     /* 1047359 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1047436), // Rule ID 13725 //
     /* 1047364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1047384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047403 */     // MIs[0] policy
     /* 1047403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047413 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1047416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047435 */     // GIR_Coverage, 13725,
     /* 1047435 */     GIR_EraseRootFromParent_Done,
     /* 1047436 */   // Label 15487: @1047436
     /* 1047436 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1047513), // Rule ID 13728 //
     /* 1047441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1047461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047480 */     // MIs[0] policy
     /* 1047480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1047493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047512 */     // GIR_Coverage, 13728,
     /* 1047512 */     GIR_EraseRootFromParent_Done,
     /* 1047513 */   // Label 15488: @1047513
     /* 1047513 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1047590), // Rule ID 13729 //
     /* 1047518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1047538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047557 */     // MIs[0] policy
     /* 1047557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047567 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1047570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047589 */     // GIR_Coverage, 13729,
     /* 1047589 */     GIR_EraseRootFromParent_Done,
     /* 1047590 */   // Label 15489: @1047590
     /* 1047590 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1047667), // Rule ID 13732 //
     /* 1047595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1047606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1047609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1047615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047634 */     // MIs[0] policy
     /* 1047634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1047647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047666 */     // GIR_Coverage, 13732,
     /* 1047666 */     GIR_EraseRootFromParent_Done,
     /* 1047667 */   // Label 15490: @1047667
     /* 1047667 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1047744), // Rule ID 13733 //
     /* 1047672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1047683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1047686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1047692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047711 */     // MIs[0] policy
     /* 1047711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1047724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047743 */     // GIR_Coverage, 13733,
     /* 1047743 */     GIR_EraseRootFromParent_Done,
     /* 1047744 */   // Label 15491: @1047744
     /* 1047744 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1047821), // Rule ID 13736 //
     /* 1047749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1047760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1047763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1047769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047788 */     // MIs[0] policy
     /* 1047788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1047801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047820 */     // GIR_Coverage, 13736,
     /* 1047820 */     GIR_EraseRootFromParent_Done,
     /* 1047821 */   // Label 15492: @1047821
     /* 1047821 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1047898), // Rule ID 13737 //
     /* 1047826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1047837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1047840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1047846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047865 */     // MIs[0] policy
     /* 1047865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047875 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1047878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047897 */     // GIR_Coverage, 13737,
     /* 1047897 */     GIR_EraseRootFromParent_Done,
     /* 1047898 */   // Label 15493: @1047898
     /* 1047898 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1047975), // Rule ID 13740 //
     /* 1047903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1047914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1047917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1047923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047942 */     // MIs[0] policy
     /* 1047942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1047955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1047971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047974 */     // GIR_Coverage, 13740,
     /* 1047974 */     GIR_EraseRootFromParent_Done,
     /* 1047975 */   // Label 15494: @1047975
     /* 1047975 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1048052), // Rule ID 13741 //
     /* 1047980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1047988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1047991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1047994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1048000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048019 */     // MIs[0] policy
     /* 1048019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048029 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1048048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048051 */     // GIR_Coverage, 13741,
     /* 1048051 */     GIR_EraseRootFromParent_Done,
     /* 1048052 */   // Label 15495: @1048052
     /* 1048052 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1048129), // Rule ID 13744 //
     /* 1048057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1048077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048096 */     // MIs[0] policy
     /* 1048096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1048109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048128 */     // GIR_Coverage, 13744,
     /* 1048128 */     GIR_EraseRootFromParent_Done,
     /* 1048129 */   // Label 15496: @1048129
     /* 1048129 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1048206), // Rule ID 13745 //
     /* 1048134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1048154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048173 */     // MIs[0] policy
     /* 1048173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048183 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1048186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048205 */     // GIR_Coverage, 13745,
     /* 1048205 */     GIR_EraseRootFromParent_Done,
     /* 1048206 */   // Label 15497: @1048206
     /* 1048206 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1048283), // Rule ID 13748 //
     /* 1048211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1048231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048250 */     // MIs[0] policy
     /* 1048250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048282 */     // GIR_Coverage, 13748,
     /* 1048282 */     GIR_EraseRootFromParent_Done,
     /* 1048283 */   // Label 15498: @1048283
     /* 1048283 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1048360), // Rule ID 13749 //
     /* 1048288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1048308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048327 */     // MIs[0] policy
     /* 1048327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048359 */     // GIR_Coverage, 13749,
     /* 1048359 */     GIR_EraseRootFromParent_Done,
     /* 1048360 */   // Label 15499: @1048360
     /* 1048360 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1048437), // Rule ID 13752 //
     /* 1048365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1048385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048404 */     // MIs[0] policy
     /* 1048404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1048417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048436 */     // GIR_Coverage, 13752,
     /* 1048436 */     GIR_EraseRootFromParent_Done,
     /* 1048437 */   // Label 15500: @1048437
     /* 1048437 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1048514), // Rule ID 13753 //
     /* 1048442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1048462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048481 */     // MIs[0] policy
     /* 1048481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1048494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048513 */     // GIR_Coverage, 13753,
     /* 1048513 */     GIR_EraseRootFromParent_Done,
     /* 1048514 */   // Label 15501: @1048514
     /* 1048514 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1048591), // Rule ID 13756 //
     /* 1048519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1048539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048558 */     // MIs[0] policy
     /* 1048558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1048571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048590 */     // GIR_Coverage, 13756,
     /* 1048590 */     GIR_EraseRootFromParent_Done,
     /* 1048591 */   // Label 15502: @1048591
     /* 1048591 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1048668), // Rule ID 13757 //
     /* 1048596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1048616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048635 */     // MIs[0] policy
     /* 1048635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1048648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048667 */     // GIR_Coverage, 13757,
     /* 1048667 */     GIR_EraseRootFromParent_Done,
     /* 1048668 */   // Label 15503: @1048668
     /* 1048668 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1048745), // Rule ID 13760 //
     /* 1048673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1048676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1048684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1048687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1048693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048712 */     // MIs[0] policy
     /* 1048712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048744 */     // GIR_Coverage, 13760,
     /* 1048744 */     GIR_EraseRootFromParent_Done,
     /* 1048745 */   // Label 15504: @1048745
     /* 1048745 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1048822), // Rule ID 13761 //
     /* 1048750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1048753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1048761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1048764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1048770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048789 */     // MIs[0] policy
     /* 1048789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1048802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048821 */     // GIR_Coverage, 13761,
     /* 1048821 */     GIR_EraseRootFromParent_Done,
     /* 1048822 */   // Label 15505: @1048822
     /* 1048822 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1048899), // Rule ID 13764 //
     /* 1048827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1048847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048866 */     // MIs[0] policy
     /* 1048866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048898 */     // GIR_Coverage, 13764,
     /* 1048898 */     GIR_EraseRootFromParent_Done,
     /* 1048899 */   // Label 15506: @1048899
     /* 1048899 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1048976), // Rule ID 13765 //
     /* 1048904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1048907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1048921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1048924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1048939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048943 */     // MIs[0] policy
     /* 1048943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048953 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1048956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1048960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1048962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1048964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048975 */     // GIR_Coverage, 13765,
     /* 1048975 */     GIR_EraseRootFromParent_Done,
     /* 1048976 */   // Label 15507: @1048976
     /* 1048976 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1049053), // Rule ID 13768 //
     /* 1048981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1048984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1048989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1048992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1048995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1048998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1049001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049020 */     // MIs[0] policy
     /* 1049020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1049033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049052 */     // GIR_Coverage, 13768,
     /* 1049052 */     GIR_EraseRootFromParent_Done,
     /* 1049053 */   // Label 15508: @1049053
     /* 1049053 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1049130), // Rule ID 13769 //
     /* 1049058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1049078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049097 */     // MIs[0] policy
     /* 1049097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1049110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049129 */     // GIR_Coverage, 13769,
     /* 1049129 */     GIR_EraseRootFromParent_Done,
     /* 1049130 */   // Label 15509: @1049130
     /* 1049130 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1049207), // Rule ID 13772 //
     /* 1049135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1049138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1049155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049174 */     // MIs[0] policy
     /* 1049174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1049187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049206 */     // GIR_Coverage, 13772,
     /* 1049206 */     GIR_EraseRootFromParent_Done,
     /* 1049207 */   // Label 15510: @1049207
     /* 1049207 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1049284), // Rule ID 13773 //
     /* 1049212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1049232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049251 */     // MIs[0] policy
     /* 1049251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049261 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1049264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049283 */     // GIR_Coverage, 13773,
     /* 1049283 */     GIR_EraseRootFromParent_Done,
     /* 1049284 */   // Label 15511: @1049284
     /* 1049284 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1049361), // Rule ID 13776 //
     /* 1049289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1049292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1049309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049328 */     // MIs[0] policy
     /* 1049328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1049341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049360 */     // GIR_Coverage, 13776,
     /* 1049360 */     GIR_EraseRootFromParent_Done,
     /* 1049361 */   // Label 15512: @1049361
     /* 1049361 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1049438), // Rule ID 13777 //
     /* 1049366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1049369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1049374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1049386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049405 */     // MIs[0] policy
     /* 1049405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049415 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1049418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049437 */     // GIR_Coverage, 13777,
     /* 1049437 */     GIR_EraseRootFromParent_Done,
     /* 1049438 */   // Label 15513: @1049438
     /* 1049438 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1049515), // Rule ID 13780 //
     /* 1049443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1049454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1049457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1049463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049482 */     // MIs[0] policy
     /* 1049482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049492 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1049495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049514 */     // GIR_Coverage, 13780,
     /* 1049514 */     GIR_EraseRootFromParent_Done,
     /* 1049515 */   // Label 15514: @1049515
     /* 1049515 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1049592), // Rule ID 13781 //
     /* 1049520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1049531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1049534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1049540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049559 */     // MIs[0] policy
     /* 1049559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1049572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049591 */     // GIR_Coverage, 13781,
     /* 1049591 */     GIR_EraseRootFromParent_Done,
     /* 1049592 */   // Label 15515: @1049592
     /* 1049592 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1049669), // Rule ID 13784 //
     /* 1049597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1049617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049636 */     // MIs[0] policy
     /* 1049636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1049649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049668 */     // GIR_Coverage, 13784,
     /* 1049668 */     GIR_EraseRootFromParent_Done,
     /* 1049669 */   // Label 15516: @1049669
     /* 1049669 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1049746), // Rule ID 13785 //
     /* 1049674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1049694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049713 */     // MIs[0] policy
     /* 1049713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049723 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1049726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049745 */     // GIR_Coverage, 13785,
     /* 1049745 */     GIR_EraseRootFromParent_Done,
     /* 1049746 */   // Label 15517: @1049746
     /* 1049746 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1049823), // Rule ID 13788 //
     /* 1049751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1049771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049790 */     // MIs[0] policy
     /* 1049790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1049803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049822 */     // GIR_Coverage, 13788,
     /* 1049822 */     GIR_EraseRootFromParent_Done,
     /* 1049823 */   // Label 15518: @1049823
     /* 1049823 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1049900), // Rule ID 13789 //
     /* 1049828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1049848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049867 */     // MIs[0] policy
     /* 1049867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1049880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049899 */     // GIR_Coverage, 13789,
     /* 1049899 */     GIR_EraseRootFromParent_Done,
     /* 1049900 */   // Label 15519: @1049900
     /* 1049900 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1049977), // Rule ID 13792 //
     /* 1049905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1049908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1049922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1049925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1049940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049944 */     // MIs[0] policy
     /* 1049944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1049957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1049961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1049963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1049965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1049973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049976 */     // GIR_Coverage, 13792,
     /* 1049976 */     GIR_EraseRootFromParent_Done,
     /* 1049977 */   // Label 15520: @1049977
     /* 1049977 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1050054), // Rule ID 13793 //
     /* 1049982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1049985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1049990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1049993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1049996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1049999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1050002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050021 */     // MIs[0] policy
     /* 1050021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050053 */     // GIR_Coverage, 13793,
     /* 1050053 */     GIR_EraseRootFromParent_Done,
     /* 1050054 */   // Label 15521: @1050054
     /* 1050054 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1050131), // Rule ID 13796 //
     /* 1050059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1050079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050098 */     // MIs[0] policy
     /* 1050098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050130 */     // GIR_Coverage, 13796,
     /* 1050130 */     GIR_EraseRootFromParent_Done,
     /* 1050131 */   // Label 15522: @1050131
     /* 1050131 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1050208), // Rule ID 13797 //
     /* 1050136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1050156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050175 */     // MIs[0] policy
     /* 1050175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050185 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050207 */     // GIR_Coverage, 13797,
     /* 1050207 */     GIR_EraseRootFromParent_Done,
     /* 1050208 */   // Label 15523: @1050208
     /* 1050208 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1050285), // Rule ID 13800 //
     /* 1050213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1050233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050252 */     // MIs[0] policy
     /* 1050252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1050265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050284 */     // GIR_Coverage, 13800,
     /* 1050284 */     GIR_EraseRootFromParent_Done,
     /* 1050285 */   // Label 15524: @1050285
     /* 1050285 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1050362), // Rule ID 13801 //
     /* 1050290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1050310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050329 */     // MIs[0] policy
     /* 1050329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1050342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1050358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050361 */     // GIR_Coverage, 13801,
     /* 1050361 */     GIR_EraseRootFromParent_Done,
     /* 1050362 */   // Label 15525: @1050362
     /* 1050362 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1050439), // Rule ID 13804 //
     /* 1050367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1050387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050406 */     // MIs[0] policy
     /* 1050406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1050419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050438 */     // GIR_Coverage, 13804,
     /* 1050438 */     GIR_EraseRootFromParent_Done,
     /* 1050439 */   // Label 15526: @1050439
     /* 1050439 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1050516), // Rule ID 13805 //
     /* 1050444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1050464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050483 */     // MIs[0] policy
     /* 1050483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1050496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050515 */     // GIR_Coverage, 13805,
     /* 1050515 */     GIR_EraseRootFromParent_Done,
     /* 1050516 */   // Label 15527: @1050516
     /* 1050516 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1050593), // Rule ID 13808 //
     /* 1050521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1050541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050560 */     // MIs[0] policy
     /* 1050560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1050573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050592 */     // GIR_Coverage, 13808,
     /* 1050592 */     GIR_EraseRootFromParent_Done,
     /* 1050593 */   // Label 15528: @1050593
     /* 1050593 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1050670), // Rule ID 13809 //
     /* 1050598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1050618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050637 */     // MIs[0] policy
     /* 1050637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1050650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050669 */     // GIR_Coverage, 13809,
     /* 1050669 */     GIR_EraseRootFromParent_Done,
     /* 1050670 */   // Label 15529: @1050670
     /* 1050670 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1050747), // Rule ID 13812 //
     /* 1050675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1050695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050714 */     // MIs[0] policy
     /* 1050714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050746 */     // GIR_Coverage, 13812,
     /* 1050746 */     GIR_EraseRootFromParent_Done,
     /* 1050747 */   // Label 15530: @1050747
     /* 1050747 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1050824), // Rule ID 13813 //
     /* 1050752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1050772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050791 */     // MIs[0] policy
     /* 1050791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1050804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050823 */     // GIR_Coverage, 13813,
     /* 1050823 */     GIR_EraseRootFromParent_Done,
     /* 1050824 */   // Label 15531: @1050824
     /* 1050824 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1050901), // Rule ID 13816 //
     /* 1050829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1050846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1050849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050868 */     // MIs[0] policy
     /* 1050868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050900 */     // GIR_Coverage, 13816,
     /* 1050900 */     GIR_EraseRootFromParent_Done,
     /* 1050901 */   // Label 15532: @1050901
     /* 1050901 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1050978), // Rule ID 13817 //
     /* 1050906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1050909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1050923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1050926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1050941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050945 */     // MIs[0] policy
     /* 1050945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050955 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1050958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1050962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1050964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1050966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050977 */     // GIR_Coverage, 13817,
     /* 1050977 */     GIR_EraseRootFromParent_Done,
     /* 1050978 */   // Label 15533: @1050978
     /* 1050978 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1051055), // Rule ID 13820 //
     /* 1050983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1050986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1050991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1050994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1050997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1051003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051022 */     // MIs[0] policy
     /* 1051022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051032 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051054 */     // GIR_Coverage, 13820,
     /* 1051054 */     GIR_EraseRootFromParent_Done,
     /* 1051055 */   // Label 15534: @1051055
     /* 1051055 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1051132), // Rule ID 13821 //
     /* 1051060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1051063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1051080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051099 */     // MIs[0] policy
     /* 1051099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051131 */     // GIR_Coverage, 13821,
     /* 1051131 */     GIR_EraseRootFromParent_Done,
     /* 1051132 */   // Label 15535: @1051132
     /* 1051132 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1051209), // Rule ID 13824 //
     /* 1051137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1051157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051176 */     // MIs[0] policy
     /* 1051176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1051189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051208 */     // GIR_Coverage, 13824,
     /* 1051208 */     GIR_EraseRootFromParent_Done,
     /* 1051209 */   // Label 15536: @1051209
     /* 1051209 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1051286), // Rule ID 13825 //
     /* 1051214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1051225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1051228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1051234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051253 */     // MIs[0] policy
     /* 1051253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051263 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1051266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051285 */     // GIR_Coverage, 13825,
     /* 1051285 */     GIR_EraseRootFromParent_Done,
     /* 1051286 */   // Label 15537: @1051286
     /* 1051286 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1051363), // Rule ID 13828 //
     /* 1051291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1051311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051330 */     // MIs[0] policy
     /* 1051330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1051343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051362 */     // GIR_Coverage, 13828,
     /* 1051362 */     GIR_EraseRootFromParent_Done,
     /* 1051363 */   // Label 15538: @1051363
     /* 1051363 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1051440), // Rule ID 13829 //
     /* 1051368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1051388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051407 */     // MIs[0] policy
     /* 1051407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11592:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1051420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051439 */     // GIR_Coverage, 13829,
     /* 1051439 */     GIR_EraseRootFromParent_Done,
     /* 1051440 */   // Label 15539: @1051440
     /* 1051440 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1051517), // Rule ID 13832 //
     /* 1051445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1051465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051484 */     // MIs[0] policy
     /* 1051484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051494 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1051497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051516 */     // GIR_Coverage, 13832,
     /* 1051516 */     GIR_EraseRootFromParent_Done,
     /* 1051517 */   // Label 15540: @1051517
     /* 1051517 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1051594), // Rule ID 13833 //
     /* 1051522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1051542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051561 */     // MIs[0] policy
     /* 1051561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051571 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11592:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1051574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051593 */     // GIR_Coverage, 13833,
     /* 1051593 */     GIR_EraseRootFromParent_Done,
     /* 1051594 */   // Label 15541: @1051594
     /* 1051594 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1051671), // Rule ID 13836 //
     /* 1051599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1051602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1051616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1051619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051638 */     // MIs[0] policy
     /* 1051638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051648 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051670 */     // GIR_Coverage, 13836,
     /* 1051670 */     GIR_EraseRootFromParent_Done,
     /* 1051671 */   // Label 15542: @1051671
     /* 1051671 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1051748), // Rule ID 13837 //
     /* 1051676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1051679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1051684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1051693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1051696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1051711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051715 */     // MIs[0] policy
     /* 1051715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051725 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11592:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1051728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1051732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1051734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1051736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051747 */     // GIR_Coverage, 13837,
     /* 1051747 */     GIR_EraseRootFromParent_Done,
     /* 1051748 */   // Label 15543: @1051748
     /* 1051748 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1051825), // Rule ID 19050 //
     /* 1051753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1051756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051792 */     // MIs[0] policy
     /* 1051792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051802 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1051805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051824 */     // GIR_Coverage, 19050,
     /* 1051824 */     GIR_EraseRootFromParent_Done,
     /* 1051825 */   // Label 15544: @1051825
     /* 1051825 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1051902), // Rule ID 19051 //
     /* 1051830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1051833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051869 */     // MIs[0] policy
     /* 1051869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1051882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051901 */     // GIR_Coverage, 19051,
     /* 1051901 */     GIR_EraseRootFromParent_Done,
     /* 1051902 */   // Label 15545: @1051902
     /* 1051902 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1051979), // Rule ID 19054 //
     /* 1051907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1051910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1051918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1051921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1051924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051946 */     // MIs[0] policy
     /* 1051946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051956 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1051959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051978 */     // GIR_Coverage, 19054,
     /* 1051978 */     GIR_EraseRootFromParent_Done,
     /* 1051979 */   // Label 15546: @1051979
     /* 1051979 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1052056), // Rule ID 19055 //
     /* 1051984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1051987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1051992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1051995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1051998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052023 */     // MIs[0] policy
     /* 1052023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1052036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052055 */     // GIR_Coverage, 19055,
     /* 1052055 */     GIR_EraseRootFromParent_Done,
     /* 1052056 */   // Label 15547: @1052056
     /* 1052056 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1052133), // Rule ID 19058 //
     /* 1052061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052100 */     // MIs[0] policy
     /* 1052100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1052113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052132 */     // GIR_Coverage, 19058,
     /* 1052132 */     GIR_EraseRootFromParent_Done,
     /* 1052133 */   // Label 15548: @1052133
     /* 1052133 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1052210), // Rule ID 19059 //
     /* 1052138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052177 */     // MIs[0] policy
     /* 1052177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052187 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1052190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052209 */     // GIR_Coverage, 19059,
     /* 1052209 */     GIR_EraseRootFromParent_Done,
     /* 1052210 */   // Label 15549: @1052210
     /* 1052210 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1052287), // Rule ID 19062 //
     /* 1052215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1052218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052254 */     // MIs[0] policy
     /* 1052254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1052267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052286 */     // GIR_Coverage, 19062,
     /* 1052286 */     GIR_EraseRootFromParent_Done,
     /* 1052287 */   // Label 15550: @1052287
     /* 1052287 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1052364), // Rule ID 19063 //
     /* 1052292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1052295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052331 */     // MIs[0] policy
     /* 1052331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1052344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052363 */     // GIR_Coverage, 19063,
     /* 1052363 */     GIR_EraseRootFromParent_Done,
     /* 1052364 */   // Label 15551: @1052364
     /* 1052364 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1052441), // Rule ID 19066 //
     /* 1052369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1052372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052408 */     // MIs[0] policy
     /* 1052408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052418 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1052421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052440 */     // GIR_Coverage, 19066,
     /* 1052440 */     GIR_EraseRootFromParent_Done,
     /* 1052441 */   // Label 15552: @1052441
     /* 1052441 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1052518), // Rule ID 19067 //
     /* 1052446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1052449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052485 */     // MIs[0] policy
     /* 1052485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052495 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1052498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052517 */     // GIR_Coverage, 19067,
     /* 1052517 */     GIR_EraseRootFromParent_Done,
     /* 1052518 */   // Label 15553: @1052518
     /* 1052518 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1052595), // Rule ID 19070 //
     /* 1052523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052562 */     // MIs[0] policy
     /* 1052562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1052575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052594 */     // GIR_Coverage, 19070,
     /* 1052594 */     GIR_EraseRootFromParent_Done,
     /* 1052595 */   // Label 15554: @1052595
     /* 1052595 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1052672), // Rule ID 19071 //
     /* 1052600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052639 */     // MIs[0] policy
     /* 1052639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052649 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1052652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052671 */     // GIR_Coverage, 19071,
     /* 1052671 */     GIR_EraseRootFromParent_Done,
     /* 1052672 */   // Label 15555: @1052672
     /* 1052672 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1052749), // Rule ID 19074 //
     /* 1052677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052716 */     // MIs[0] policy
     /* 1052716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052726 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1052729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052748 */     // GIR_Coverage, 19074,
     /* 1052748 */     GIR_EraseRootFromParent_Done,
     /* 1052749 */   // Label 15556: @1052749
     /* 1052749 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1052826), // Rule ID 19075 //
     /* 1052754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052793 */     // MIs[0] policy
     /* 1052793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052803 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1052806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052825 */     // GIR_Coverage, 19075,
     /* 1052825 */     GIR_EraseRootFromParent_Done,
     /* 1052826 */   // Label 15557: @1052826
     /* 1052826 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1052903), // Rule ID 19078 //
     /* 1052831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1052834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1052842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1052845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1052848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1052851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052870 */     // MIs[0] policy
     /* 1052870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052880 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1052883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052902 */     // GIR_Coverage, 19078,
     /* 1052902 */     GIR_EraseRootFromParent_Done,
     /* 1052903 */   // Label 15558: @1052903
     /* 1052903 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1052980), // Rule ID 19079 //
     /* 1052908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1052911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1052919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1052922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1052925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1052928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052947 */     // MIs[0] policy
     /* 1052947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052957 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1052960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052979 */     // GIR_Coverage, 19079,
     /* 1052979 */     GIR_EraseRootFromParent_Done,
     /* 1052980 */   // Label 15559: @1052980
     /* 1052980 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1053057), // Rule ID 19082 //
     /* 1052985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1052988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1052993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1052996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1052999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053024 */     // MIs[0] policy
     /* 1053024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053034 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1053037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053056 */     // GIR_Coverage, 19082,
     /* 1053056 */     GIR_EraseRootFromParent_Done,
     /* 1053057 */   // Label 15560: @1053057
     /* 1053057 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1053134), // Rule ID 19083 //
     /* 1053062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053101 */     // MIs[0] policy
     /* 1053101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053111 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1053114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053133 */     // GIR_Coverage, 19083,
     /* 1053133 */     GIR_EraseRootFromParent_Done,
     /* 1053134 */   // Label 15561: @1053134
     /* 1053134 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1053211), // Rule ID 19086 //
     /* 1053139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1053142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053178 */     // MIs[0] policy
     /* 1053178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053188 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1053191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053210 */     // GIR_Coverage, 19086,
     /* 1053210 */     GIR_EraseRootFromParent_Done,
     /* 1053211 */   // Label 15562: @1053211
     /* 1053211 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1053288), // Rule ID 19087 //
     /* 1053216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053255 */     // MIs[0] policy
     /* 1053255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053265 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1053268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053287 */     // GIR_Coverage, 19087,
     /* 1053287 */     GIR_EraseRootFromParent_Done,
     /* 1053288 */   // Label 15563: @1053288
     /* 1053288 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1053365), // Rule ID 19090 //
     /* 1053293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1053296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053332 */     // MIs[0] policy
     /* 1053332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1053345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053364 */     // GIR_Coverage, 19090,
     /* 1053364 */     GIR_EraseRootFromParent_Done,
     /* 1053365 */   // Label 15564: @1053365
     /* 1053365 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1053442), // Rule ID 19091 //
     /* 1053370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1053373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053409 */     // MIs[0] policy
     /* 1053409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053419 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1053422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053441 */     // GIR_Coverage, 19091,
     /* 1053441 */     GIR_EraseRootFromParent_Done,
     /* 1053442 */   // Label 15565: @1053442
     /* 1053442 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1053519), // Rule ID 19094 //
     /* 1053447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053486 */     // MIs[0] policy
     /* 1053486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1053499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053518 */     // GIR_Coverage, 19094,
     /* 1053518 */     GIR_EraseRootFromParent_Done,
     /* 1053519 */   // Label 15566: @1053519
     /* 1053519 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1053596), // Rule ID 19095 //
     /* 1053524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053563 */     // MIs[0] policy
     /* 1053563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053573 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1053576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053595 */     // GIR_Coverage, 19095,
     /* 1053595 */     GIR_EraseRootFromParent_Done,
     /* 1053596 */   // Label 15567: @1053596
     /* 1053596 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1053673), // Rule ID 19098 //
     /* 1053601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053640 */     // MIs[0] policy
     /* 1053640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1053653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053672 */     // GIR_Coverage, 19098,
     /* 1053672 */     GIR_EraseRootFromParent_Done,
     /* 1053673 */   // Label 15568: @1053673
     /* 1053673 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1053750), // Rule ID 19099 //
     /* 1053678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053717 */     // MIs[0] policy
     /* 1053717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053727 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1053730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053749 */     // GIR_Coverage, 19099,
     /* 1053749 */     GIR_EraseRootFromParent_Done,
     /* 1053750 */   // Label 15569: @1053750
     /* 1053750 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1053827), // Rule ID 19102 //
     /* 1053755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1053758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053794 */     // MIs[0] policy
     /* 1053794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1053807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053826 */     // GIR_Coverage, 19102,
     /* 1053826 */     GIR_EraseRootFromParent_Done,
     /* 1053827 */   // Label 15570: @1053827
     /* 1053827 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1053904), // Rule ID 19103 //
     /* 1053832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1053835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1053840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053871 */     // MIs[0] policy
     /* 1053871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053881 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1053884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053903 */     // GIR_Coverage, 19103,
     /* 1053903 */     GIR_EraseRootFromParent_Done,
     /* 1053904 */   // Label 15571: @1053904
     /* 1053904 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1053981), // Rule ID 20486 //
     /* 1053909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1053917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1053920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1053923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1053926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053948 */     // MIs[0] policy
     /* 1053948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1053961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053980 */     // GIR_Coverage, 20486,
     /* 1053980 */     GIR_EraseRootFromParent_Done,
     /* 1053981 */   // Label 15572: @1053981
     /* 1053981 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1054058), // Rule ID 20487 //
     /* 1053986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1053994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1053997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054025 */     // MIs[0] policy
     /* 1054025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054035 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054057 */     // GIR_Coverage, 20487,
     /* 1054057 */     GIR_EraseRootFromParent_Done,
     /* 1054058 */   // Label 15573: @1054058
     /* 1054058 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1054135), // Rule ID 20490 //
     /* 1054063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054102 */     // MIs[0] policy
     /* 1054102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054134 */     // GIR_Coverage, 20490,
     /* 1054134 */     GIR_EraseRootFromParent_Done,
     /* 1054135 */   // Label 15574: @1054135
     /* 1054135 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1054212), // Rule ID 20491 //
     /* 1054140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054179 */     // MIs[0] policy
     /* 1054179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1054192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054211 */     // GIR_Coverage, 20491,
     /* 1054211 */     GIR_EraseRootFromParent_Done,
     /* 1054212 */   // Label 15575: @1054212
     /* 1054212 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1054289), // Rule ID 20494 //
     /* 1054217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054256 */     // MIs[0] policy
     /* 1054256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054288 */     // GIR_Coverage, 20494,
     /* 1054288 */     GIR_EraseRootFromParent_Done,
     /* 1054289 */   // Label 15576: @1054289
     /* 1054289 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1054366), // Rule ID 20495 //
     /* 1054294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054333 */     // MIs[0] policy
     /* 1054333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054343 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054365 */     // GIR_Coverage, 20495,
     /* 1054365 */     GIR_EraseRootFromParent_Done,
     /* 1054366 */   // Label 15577: @1054366
     /* 1054366 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1054443), // Rule ID 20498 //
     /* 1054371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054410 */     // MIs[0] policy
     /* 1054410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054420 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054442 */     // GIR_Coverage, 20498,
     /* 1054442 */     GIR_EraseRootFromParent_Done,
     /* 1054443 */   // Label 15578: @1054443
     /* 1054443 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1054520), // Rule ID 20499 //
     /* 1054448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054487 */     // MIs[0] policy
     /* 1054487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054497 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054519 */     // GIR_Coverage, 20499,
     /* 1054519 */     GIR_EraseRootFromParent_Done,
     /* 1054520 */   // Label 15579: @1054520
     /* 1054520 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1054597), // Rule ID 20502 //
     /* 1054525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054564 */     // MIs[0] policy
     /* 1054564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054596 */     // GIR_Coverage, 20502,
     /* 1054596 */     GIR_EraseRootFromParent_Done,
     /* 1054597 */   // Label 15580: @1054597
     /* 1054597 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1054674), // Rule ID 20503 //
     /* 1054602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054641 */     // MIs[0] policy
     /* 1054641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054651 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1054654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054673 */     // GIR_Coverage, 20503,
     /* 1054673 */     GIR_EraseRootFromParent_Done,
     /* 1054674 */   // Label 15581: @1054674
     /* 1054674 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1054751), // Rule ID 20506 //
     /* 1054679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1054690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1054693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1054696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054718 */     // MIs[0] policy
     /* 1054718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1054731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054750 */     // GIR_Coverage, 20506,
     /* 1054750 */     GIR_EraseRootFromParent_Done,
     /* 1054751 */   // Label 15582: @1054751
     /* 1054751 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1054828), // Rule ID 20507 //
     /* 1054756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1054767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1054770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1054773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054795 */     // MIs[0] policy
     /* 1054795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1054808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054827 */     // GIR_Coverage, 20507,
     /* 1054827 */     GIR_EraseRootFromParent_Done,
     /* 1054828 */   // Label 15583: @1054828
     /* 1054828 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1054905), // Rule ID 20510 //
     /* 1054833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1054844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1054847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1054850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054872 */     // MIs[0] policy
     /* 1054872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1054885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054904 */     // GIR_Coverage, 20510,
     /* 1054904 */     GIR_EraseRootFromParent_Done,
     /* 1054905 */   // Label 15584: @1054905
     /* 1054905 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1054982), // Rule ID 20511 //
     /* 1054910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1054921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1054924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1054927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054949 */     // MIs[0] policy
     /* 1054949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1054962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054981 */     // GIR_Coverage, 20511,
     /* 1054981 */     GIR_EraseRootFromParent_Done,
     /* 1054982 */   // Label 15585: @1054982
     /* 1054982 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1055059), // Rule ID 20514 //
     /* 1054987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1054995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1054998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055026 */     // MIs[0] policy
     /* 1055026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055058 */     // GIR_Coverage, 20514,
     /* 1055058 */     GIR_EraseRootFromParent_Done,
     /* 1055059 */   // Label 15586: @1055059
     /* 1055059 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1055136), // Rule ID 20515 //
     /* 1055064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055103 */     // MIs[0] policy
     /* 1055103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055113 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055135 */     // GIR_Coverage, 20515,
     /* 1055135 */     GIR_EraseRootFromParent_Done,
     /* 1055136 */   // Label 15587: @1055136
     /* 1055136 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1055213), // Rule ID 20518 //
     /* 1055141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055180 */     // MIs[0] policy
     /* 1055180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055212 */     // GIR_Coverage, 20518,
     /* 1055212 */     GIR_EraseRootFromParent_Done,
     /* 1055213 */   // Label 15588: @1055213
     /* 1055213 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1055290), // Rule ID 20519 //
     /* 1055218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055257 */     // MIs[0] policy
     /* 1055257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055289 */     // GIR_Coverage, 20519,
     /* 1055289 */     GIR_EraseRootFromParent_Done,
     /* 1055290 */   // Label 15589: @1055290
     /* 1055290 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1055367), // Rule ID 20522 //
     /* 1055295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055334 */     // MIs[0] policy
     /* 1055334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055366 */     // GIR_Coverage, 20522,
     /* 1055366 */     GIR_EraseRootFromParent_Done,
     /* 1055367 */   // Label 15590: @1055367
     /* 1055367 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1055444), // Rule ID 20523 //
     /* 1055372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055411 */     // MIs[0] policy
     /* 1055411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055443 */     // GIR_Coverage, 20523,
     /* 1055443 */     GIR_EraseRootFromParent_Done,
     /* 1055444 */   // Label 15591: @1055444
     /* 1055444 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1055521), // Rule ID 20526 //
     /* 1055449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055488 */     // MIs[0] policy
     /* 1055488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055520 */     // GIR_Coverage, 20526,
     /* 1055520 */     GIR_EraseRootFromParent_Done,
     /* 1055521 */   // Label 15592: @1055521
     /* 1055521 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1055598), // Rule ID 20527 //
     /* 1055526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055565 */     // MIs[0] policy
     /* 1055565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055597 */     // GIR_Coverage, 20527,
     /* 1055597 */     GIR_EraseRootFromParent_Done,
     /* 1055598 */   // Label 15593: @1055598
     /* 1055598 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1055675), // Rule ID 20530 //
     /* 1055603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055642 */     // MIs[0] policy
     /* 1055642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055674 */     // GIR_Coverage, 20530,
     /* 1055674 */     GIR_EraseRootFromParent_Done,
     /* 1055675 */   // Label 15594: @1055675
     /* 1055675 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1055752), // Rule ID 20531 //
     /* 1055680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055719 */     // MIs[0] policy
     /* 1055719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1055732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055751 */     // GIR_Coverage, 20531,
     /* 1055751 */     GIR_EraseRootFromParent_Done,
     /* 1055752 */   // Label 15595: @1055752
     /* 1055752 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1055829), // Rule ID 20534 //
     /* 1055757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1055768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1055771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1055774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055796 */     // MIs[0] policy
     /* 1055796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055828 */     // GIR_Coverage, 20534,
     /* 1055828 */     GIR_EraseRootFromParent_Done,
     /* 1055829 */   // Label 15596: @1055829
     /* 1055829 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1055906), // Rule ID 20535 //
     /* 1055834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1055845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1055848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1055851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055873 */     // MIs[0] policy
     /* 1055873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1055886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055905 */     // GIR_Coverage, 20535,
     /* 1055905 */     GIR_EraseRootFromParent_Done,
     /* 1055906 */   // Label 15597: @1055906
     /* 1055906 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1055983), // Rule ID 20538 //
     /* 1055911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1055922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1055925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1055928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055950 */     // MIs[0] policy
     /* 1055950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1055963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055982 */     // GIR_Coverage, 20538,
     /* 1055982 */     GIR_EraseRootFromParent_Done,
     /* 1055983 */   // Label 15598: @1055983
     /* 1055983 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1056060), // Rule ID 20539 //
     /* 1055988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1055996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1055999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056027 */     // MIs[0] policy
     /* 1056027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1056040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056059 */     // GIR_Coverage, 20539,
     /* 1056059 */     GIR_EraseRootFromParent_Done,
     /* 1056060 */   // Label 15599: @1056060
     /* 1056060 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1056137), // Rule ID 20864 //
     /* 1056065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1056076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1056079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056104 */     // MIs[0] policy
     /* 1056104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056136 */     // GIR_Coverage, 20864,
     /* 1056136 */     GIR_EraseRootFromParent_Done,
     /* 1056137 */   // Label 15600: @1056137
     /* 1056137 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1056214), // Rule ID 20865 //
     /* 1056142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1056153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1056156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056181 */     // MIs[0] policy
     /* 1056181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056213 */     // GIR_Coverage, 20865,
     /* 1056213 */     GIR_EraseRootFromParent_Done,
     /* 1056214 */   // Label 15601: @1056214
     /* 1056214 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1056291), // Rule ID 20868 //
     /* 1056219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1056230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1056233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056258 */     // MIs[0] policy
     /* 1056258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056290 */     // GIR_Coverage, 20868,
     /* 1056290 */     GIR_EraseRootFromParent_Done,
     /* 1056291 */   // Label 15602: @1056291
     /* 1056291 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1056368), // Rule ID 20869 //
     /* 1056296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1056307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1056310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056335 */     // MIs[0] policy
     /* 1056335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056345 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056367 */     // GIR_Coverage, 20869,
     /* 1056367 */     GIR_EraseRootFromParent_Done,
     /* 1056368 */   // Label 15603: @1056368
     /* 1056368 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1056445), // Rule ID 20872 //
     /* 1056373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1056390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056412 */     // MIs[0] policy
     /* 1056412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056444 */     // GIR_Coverage, 20872,
     /* 1056444 */     GIR_EraseRootFromParent_Done,
     /* 1056445 */   // Label 15604: @1056445
     /* 1056445 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1056522), // Rule ID 20873 //
     /* 1056450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1056467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056489 */     // MIs[0] policy
     /* 1056489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056521 */     // GIR_Coverage, 20873,
     /* 1056521 */     GIR_EraseRootFromParent_Done,
     /* 1056522 */   // Label 15605: @1056522
     /* 1056522 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1056599), // Rule ID 20876 //
     /* 1056527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1056538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1056541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056566 */     // MIs[0] policy
     /* 1056566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056598 */     // GIR_Coverage, 20876,
     /* 1056598 */     GIR_EraseRootFromParent_Done,
     /* 1056599 */   // Label 15606: @1056599
     /* 1056599 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1056676), // Rule ID 20877 //
     /* 1056604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1056615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1056618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056643 */     // MIs[0] policy
     /* 1056643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056653 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056675 */     // GIR_Coverage, 20877,
     /* 1056675 */     GIR_EraseRootFromParent_Done,
     /* 1056676 */   // Label 15607: @1056676
     /* 1056676 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1056753), // Rule ID 20880 //
     /* 1056681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056720 */     // MIs[0] policy
     /* 1056720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056752 */     // GIR_Coverage, 20880,
     /* 1056752 */     GIR_EraseRootFromParent_Done,
     /* 1056753 */   // Label 15608: @1056753
     /* 1056753 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1056830), // Rule ID 20881 //
     /* 1056758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1056775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056797 */     // MIs[0] policy
     /* 1056797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056807 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056829 */     // GIR_Coverage, 20881,
     /* 1056829 */     GIR_EraseRootFromParent_Done,
     /* 1056830 */   // Label 15609: @1056830
     /* 1056830 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1056907), // Rule ID 20884 //
     /* 1056835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056874 */     // MIs[0] policy
     /* 1056874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056906 */     // GIR_Coverage, 20884,
     /* 1056906 */     GIR_EraseRootFromParent_Done,
     /* 1056907 */   // Label 15610: @1056907
     /* 1056907 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1056984), // Rule ID 20885 //
     /* 1056912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1056923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1056926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1056929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056951 */     // MIs[0] policy
     /* 1056951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056961 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056983 */     // GIR_Coverage, 20885,
     /* 1056983 */     GIR_EraseRootFromParent_Done,
     /* 1056984 */   // Label 15611: @1056984
     /* 1056984 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1057061), // Rule ID 20888 //
     /* 1056989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1056997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1057000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1057003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057028 */     // MIs[0] policy
     /* 1057028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057060 */     // GIR_Coverage, 20888,
     /* 1057060 */     GIR_EraseRootFromParent_Done,
     /* 1057061 */   // Label 15612: @1057061
     /* 1057061 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1057138), // Rule ID 20889 //
     /* 1057066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1057077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1057080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057105 */     // MIs[0] policy
     /* 1057105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057137 */     // GIR_Coverage, 20889,
     /* 1057137 */     GIR_EraseRootFromParent_Done,
     /* 1057138 */   // Label 15613: @1057138
     /* 1057138 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1057215), // Rule ID 20892 //
     /* 1057143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1057154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1057157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057182 */     // MIs[0] policy
     /* 1057182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057214 */     // GIR_Coverage, 20892,
     /* 1057214 */     GIR_EraseRootFromParent_Done,
     /* 1057215 */   // Label 15614: @1057215
     /* 1057215 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1057292), // Rule ID 20893 //
     /* 1057220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1057231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1057234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057259 */     // MIs[0] policy
     /* 1057259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057291 */     // GIR_Coverage, 20893,
     /* 1057291 */     GIR_EraseRootFromParent_Done,
     /* 1057292 */   // Label 15615: @1057292
     /* 1057292 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1057369), // Rule ID 20896 //
     /* 1057297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1057317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057336 */     // MIs[0] policy
     /* 1057336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057346 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057368 */     // GIR_Coverage, 20896,
     /* 1057368 */     GIR_EraseRootFromParent_Done,
     /* 1057369 */   // Label 15616: @1057369
     /* 1057369 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1057446), // Rule ID 20897 //
     /* 1057374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1057385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1057388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1057391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1057394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057413 */     // MIs[0] policy
     /* 1057413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057423 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057445 */     // GIR_Coverage, 20897,
     /* 1057445 */     GIR_EraseRootFromParent_Done,
     /* 1057446 */   // Label 15617: @1057446
     /* 1057446 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1057523), // Rule ID 20900 //
     /* 1057451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057490 */     // MIs[0] policy
     /* 1057490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057522 */     // GIR_Coverage, 20900,
     /* 1057522 */     GIR_EraseRootFromParent_Done,
     /* 1057523 */   // Label 15618: @1057523
     /* 1057523 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1057600), // Rule ID 20901 //
     /* 1057528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057567 */     // MIs[0] policy
     /* 1057567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057599 */     // GIR_Coverage, 20901,
     /* 1057599 */     GIR_EraseRootFromParent_Done,
     /* 1057600 */   // Label 15619: @1057600
     /* 1057600 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1057677), // Rule ID 20904 //
     /* 1057605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057644 */     // MIs[0] policy
     /* 1057644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057676 */     // GIR_Coverage, 20904,
     /* 1057676 */     GIR_EraseRootFromParent_Done,
     /* 1057677 */   // Label 15620: @1057677
     /* 1057677 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1057754), // Rule ID 20905 //
     /* 1057682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057721 */     // MIs[0] policy
     /* 1057721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057753 */     // GIR_Coverage, 20905,
     /* 1057753 */     GIR_EraseRootFromParent_Done,
     /* 1057754 */   // Label 15621: @1057754
     /* 1057754 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1057831), // Rule ID 20908 //
     /* 1057759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1057762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057798 */     // MIs[0] policy
     /* 1057798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057830 */     // GIR_Coverage, 20908,
     /* 1057830 */     GIR_EraseRootFromParent_Done,
     /* 1057831 */   // Label 15622: @1057831
     /* 1057831 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1057908), // Rule ID 20909 //
     /* 1057836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1057839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1057853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057875 */     // MIs[0] policy
     /* 1057875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057885 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1057888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057907 */     // GIR_Coverage, 20909,
     /* 1057907 */     GIR_EraseRootFromParent_Done,
     /* 1057908 */   // Label 15623: @1057908
     /* 1057908 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1057985), // Rule ID 20912 //
     /* 1057913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1057916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1057930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057952 */     // MIs[0] policy
     /* 1057952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1057981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057984 */     // GIR_Coverage, 20912,
     /* 1057984 */     GIR_EraseRootFromParent_Done,
     /* 1057985 */   // Label 15624: @1057985
     /* 1057985 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1058062), // Rule ID 20913 //
     /* 1057990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1057993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1057998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1058007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058029 */     // MIs[0] policy
     /* 1058029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11135:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058061 */     // GIR_Coverage, 20913,
     /* 1058061 */     GIR_EraseRootFromParent_Done,
     /* 1058062 */   // Label 15625: @1058062
     /* 1058062 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1058139), // Rule ID 20916 //
     /* 1058067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1058070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1058084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058106 */     // MIs[0] policy
     /* 1058106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058138 */     // GIR_Coverage, 20916,
     /* 1058138 */     GIR_EraseRootFromParent_Done,
     /* 1058139 */   // Label 15626: @1058139
     /* 1058139 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1058216), // Rule ID 20917 //
     /* 1058144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1058147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1058161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058183 */     // MIs[0] policy
     /* 1058183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058193 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11135:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058215 */     // GIR_Coverage, 20917,
     /* 1058215 */     GIR_EraseRootFromParent_Done,
     /* 1058216 */   // Label 15627: @1058216
     /* 1058216 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1058293), // Rule ID 20920 //
     /* 1058221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1058224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058260 */     // MIs[0] policy
     /* 1058260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1058273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058292 */     // GIR_Coverage, 20920,
     /* 1058292 */     GIR_EraseRootFromParent_Done,
     /* 1058293 */   // Label 15628: @1058293
     /* 1058293 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1058370), // Rule ID 20921 //
     /* 1058298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1058301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1058306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1058315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058337 */     // MIs[0] policy
     /* 1058337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11135:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1058350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1058366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058369 */     // GIR_Coverage, 20921,
     /* 1058369 */     GIR_EraseRootFromParent_Done,
     /* 1058370 */   // Label 15629: @1058370
     /* 1058370 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1058447), // Rule ID 20924 //
     /* 1058375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058414 */     // MIs[0] policy
     /* 1058414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058446 */     // GIR_Coverage, 20924,
     /* 1058446 */     GIR_EraseRootFromParent_Done,
     /* 1058447 */   // Label 15630: @1058447
     /* 1058447 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1058524), // Rule ID 20925 //
     /* 1058452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1058463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1058466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058491 */     // MIs[0] policy
     /* 1058491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058501 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058523 */     // GIR_Coverage, 20925,
     /* 1058523 */     GIR_EraseRootFromParent_Done,
     /* 1058524 */   // Label 15631: @1058524
     /* 1058524 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1058601), // Rule ID 20928 //
     /* 1058529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058568 */     // MIs[0] policy
     /* 1058568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058600 */     // GIR_Coverage, 20928,
     /* 1058600 */     GIR_EraseRootFromParent_Done,
     /* 1058601 */   // Label 15632: @1058601
     /* 1058601 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1058678), // Rule ID 20929 //
     /* 1058606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1058617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1058620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058645 */     // MIs[0] policy
     /* 1058645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058677 */     // GIR_Coverage, 20929,
     /* 1058677 */     GIR_EraseRootFromParent_Done,
     /* 1058678 */   // Label 15633: @1058678
     /* 1058678 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1058755), // Rule ID 20932 //
     /* 1058683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1058686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058722 */     // MIs[0] policy
     /* 1058722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058754 */     // GIR_Coverage, 20932,
     /* 1058754 */     GIR_EraseRootFromParent_Done,
     /* 1058755 */   // Label 15634: @1058755
     /* 1058755 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1058832), // Rule ID 20933 //
     /* 1058760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1058763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058799 */     // MIs[0] policy
     /* 1058799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058831 */     // GIR_Coverage, 20933,
     /* 1058831 */     GIR_EraseRootFromParent_Done,
     /* 1058832 */   // Label 15635: @1058832
     /* 1058832 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1058909), // Rule ID 20936 //
     /* 1058837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1058848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1058851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058876 */     // MIs[0] policy
     /* 1058876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1058889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058908 */     // GIR_Coverage, 20936,
     /* 1058908 */     GIR_EraseRootFromParent_Done,
     /* 1058909 */   // Label 15636: @1058909
     /* 1058909 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1058986), // Rule ID 20937 //
     /* 1058914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1058925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1058928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058953 */     // MIs[0] policy
     /* 1058953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058963 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1058966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058985 */     // GIR_Coverage, 20937,
     /* 1058985 */     GIR_EraseRootFromParent_Done,
     /* 1058986 */   // Label 15637: @1058986
     /* 1058986 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1059063), // Rule ID 20940 //
     /* 1058991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1058994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1058999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059030 */     // MIs[0] policy
     /* 1059030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059062 */     // GIR_Coverage, 20940,
     /* 1059062 */     GIR_EraseRootFromParent_Done,
     /* 1059063 */   // Label 15638: @1059063
     /* 1059063 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1059140), // Rule ID 20941 //
     /* 1059068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1059079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1059082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059107 */     // MIs[0] policy
     /* 1059107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059139 */     // GIR_Coverage, 20941,
     /* 1059139 */     GIR_EraseRootFromParent_Done,
     /* 1059140 */   // Label 15639: @1059140
     /* 1059140 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1059217), // Rule ID 20944 //
     /* 1059145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1059148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1059162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059184 */     // MIs[0] policy
     /* 1059184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1059213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059216 */     // GIR_Coverage, 20944,
     /* 1059216 */     GIR_EraseRootFromParent_Done,
     /* 1059217 */   // Label 15640: @1059217
     /* 1059217 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1059294), // Rule ID 20945 //
     /* 1059222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1059225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1059239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059261 */     // MIs[0] policy
     /* 1059261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059271 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1059274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1059290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059293 */     // GIR_Coverage, 20945,
     /* 1059293 */     GIR_EraseRootFromParent_Done,
     /* 1059294 */   // Label 15641: @1059294
     /* 1059294 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1059371), // Rule ID 20948 //
     /* 1059299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059338 */     // MIs[0] policy
     /* 1059338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059370 */     // GIR_Coverage, 20948,
     /* 1059370 */     GIR_EraseRootFromParent_Done,
     /* 1059371 */   // Label 15642: @1059371
     /* 1059371 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1059448), // Rule ID 20949 //
     /* 1059376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1059393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059415 */     // MIs[0] policy
     /* 1059415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059447 */     // GIR_Coverage, 20949,
     /* 1059447 */     GIR_EraseRootFromParent_Done,
     /* 1059448 */   // Label 15643: @1059448
     /* 1059448 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1059525), // Rule ID 20952 //
     /* 1059453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059492 */     // MIs[0] policy
     /* 1059492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059524 */     // GIR_Coverage, 20952,
     /* 1059524 */     GIR_EraseRootFromParent_Done,
     /* 1059525 */   // Label 15644: @1059525
     /* 1059525 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1059602), // Rule ID 20953 //
     /* 1059530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1059547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059569 */     // MIs[0] policy
     /* 1059569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059579 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059601 */     // GIR_Coverage, 20953,
     /* 1059601 */     GIR_EraseRootFromParent_Done,
     /* 1059602 */   // Label 15645: @1059602
     /* 1059602 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1059679), // Rule ID 20956 //
     /* 1059607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1059624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059646 */     // MIs[0] policy
     /* 1059646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1059659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059678 */     // GIR_Coverage, 20956,
     /* 1059678 */     GIR_EraseRootFromParent_Done,
     /* 1059679 */   // Label 15646: @1059679
     /* 1059679 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1059756), // Rule ID 20957 //
     /* 1059684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1059701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059723 */     // MIs[0] policy
     /* 1059723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059733 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1059736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1059752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059755 */     // GIR_Coverage, 20957,
     /* 1059755 */     GIR_EraseRootFromParent_Done,
     /* 1059756 */   // Label 15647: @1059756
     /* 1059756 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1059833), // Rule ID 20960 //
     /* 1059761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1059764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059800 */     // MIs[0] policy
     /* 1059800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059832 */     // GIR_Coverage, 20960,
     /* 1059832 */     GIR_EraseRootFromParent_Done,
     /* 1059833 */   // Label 15648: @1059833
     /* 1059833 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1059910), // Rule ID 20961 //
     /* 1059838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1059849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1059852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059877 */     // MIs[0] policy
     /* 1059877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1059890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059909 */     // GIR_Coverage, 20961,
     /* 1059909 */     GIR_EraseRootFromParent_Done,
     /* 1059910 */   // Label 15649: @1059910
     /* 1059910 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1059987), // Rule ID 20964 //
     /* 1059915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1059918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1059923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1059926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1059929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059954 */     // MIs[0] policy
     /* 1059954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1059967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059986 */     // GIR_Coverage, 20964,
     /* 1059986 */     GIR_EraseRootFromParent_Done,
     /* 1059987 */   // Label 15650: @1059987
     /* 1059987 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1060064), // Rule ID 20965 //
     /* 1059992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1059995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1060009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060031 */     // MIs[0] policy
     /* 1060031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060041 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060063 */     // GIR_Coverage, 20965,
     /* 1060063 */     GIR_EraseRootFromParent_Done,
     /* 1060064 */   // Label 15651: @1060064
     /* 1060064 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1060141), // Rule ID 20968 //
     /* 1060069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1060086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060108 */     // MIs[0] policy
     /* 1060108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060140 */     // GIR_Coverage, 20968,
     /* 1060140 */     GIR_EraseRootFromParent_Done,
     /* 1060141 */   // Label 15652: @1060141
     /* 1060141 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1060218), // Rule ID 20969 //
     /* 1060146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1060163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060185 */     // MIs[0] policy
     /* 1060185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060217 */     // GIR_Coverage, 20969,
     /* 1060217 */     GIR_EraseRootFromParent_Done,
     /* 1060218 */   // Label 15653: @1060218
     /* 1060218 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1060295), // Rule ID 20972 //
     /* 1060223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1060234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1060237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1060240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060262 */     // MIs[0] policy
     /* 1060262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1060275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060294 */     // GIR_Coverage, 20972,
     /* 1060294 */     GIR_EraseRootFromParent_Done,
     /* 1060295 */   // Label 15654: @1060295
     /* 1060295 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1060372), // Rule ID 20973 //
     /* 1060300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1060311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1060314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1060317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060339 */     // MIs[0] policy
     /* 1060339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1060352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060371 */     // GIR_Coverage, 20973,
     /* 1060371 */     GIR_EraseRootFromParent_Done,
     /* 1060372 */   // Label 15655: @1060372
     /* 1060372 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1060449), // Rule ID 20976 //
     /* 1060377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1060388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1060391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1060394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060416 */     // MIs[0] policy
     /* 1060416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060448 */     // GIR_Coverage, 20976,
     /* 1060448 */     GIR_EraseRootFromParent_Done,
     /* 1060449 */   // Label 15656: @1060449
     /* 1060449 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1060526), // Rule ID 20977 //
     /* 1060454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1060465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1060468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1060471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060493 */     // MIs[0] policy
     /* 1060493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060503 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1060506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060525 */     // GIR_Coverage, 20977,
     /* 1060525 */     GIR_EraseRootFromParent_Done,
     /* 1060526 */   // Label 15657: @1060526
     /* 1060526 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1060603), // Rule ID 20980 //
     /* 1060531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1060534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1060548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060570 */     // MIs[0] policy
     /* 1060570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060602 */     // GIR_Coverage, 20980,
     /* 1060602 */     GIR_EraseRootFromParent_Done,
     /* 1060603 */   // Label 15658: @1060603
     /* 1060603 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1060680), // Rule ID 20981 //
     /* 1060608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1060611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1060616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1060619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1060622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1060625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060647 */     // MIs[0] policy
     /* 1060647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060657 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1060660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1060676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060679 */     // GIR_Coverage, 20981,
     /* 1060679 */     GIR_EraseRootFromParent_Done,
     /* 1060680 */   // Label 15659: @1060680
     /* 1060680 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1060757), // Rule ID 21248 //
     /* 1060685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060724 */     // MIs[0] policy
     /* 1060724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1060737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060756 */     // GIR_Coverage, 21248,
     /* 1060756 */     GIR_EraseRootFromParent_Done,
     /* 1060757 */   // Label 15660: @1060757
     /* 1060757 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1060834), // Rule ID 21249 //
     /* 1060762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060801 */     // MIs[0] policy
     /* 1060801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060811 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1060814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060833 */     // GIR_Coverage, 21249,
     /* 1060833 */     GIR_EraseRootFromParent_Done,
     /* 1060834 */   // Label 15661: @1060834
     /* 1060834 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1060911), // Rule ID 21252 //
     /* 1060839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060878 */     // MIs[0] policy
     /* 1060878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1060891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060910 */     // GIR_Coverage, 21252,
     /* 1060910 */     GIR_EraseRootFromParent_Done,
     /* 1060911 */   // Label 15662: @1060911
     /* 1060911 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1060988), // Rule ID 21253 //
     /* 1060916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1060924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060955 */     // MIs[0] policy
     /* 1060955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060965 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1060968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060987 */     // GIR_Coverage, 21253,
     /* 1060987 */     GIR_EraseRootFromParent_Done,
     /* 1060988 */   // Label 15663: @1060988
     /* 1060988 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1061065), // Rule ID 21256 //
     /* 1060993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061032 */     // MIs[0] policy
     /* 1061032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061064 */     // GIR_Coverage, 21256,
     /* 1061064 */     GIR_EraseRootFromParent_Done,
     /* 1061065 */   // Label 15664: @1061065
     /* 1061065 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1061142), // Rule ID 21257 //
     /* 1061070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1061081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1061084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1061087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061109 */     // MIs[0] policy
     /* 1061109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061141 */     // GIR_Coverage, 21257,
     /* 1061141 */     GIR_EraseRootFromParent_Done,
     /* 1061142 */   // Label 15665: @1061142
     /* 1061142 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1061219), // Rule ID 21260 //
     /* 1061147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061186 */     // MIs[0] policy
     /* 1061186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061218 */     // GIR_Coverage, 21260,
     /* 1061218 */     GIR_EraseRootFromParent_Done,
     /* 1061219 */   // Label 15666: @1061219
     /* 1061219 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1061296), // Rule ID 21261 //
     /* 1061224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061263 */     // MIs[0] policy
     /* 1061263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061273 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061295 */     // GIR_Coverage, 21261,
     /* 1061295 */     GIR_EraseRootFromParent_Done,
     /* 1061296 */   // Label 15667: @1061296
     /* 1061296 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1061373), // Rule ID 21264 //
     /* 1061301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061340 */     // MIs[0] policy
     /* 1061340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061350 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061372 */     // GIR_Coverage, 21264,
     /* 1061372 */     GIR_EraseRootFromParent_Done,
     /* 1061373 */   // Label 15668: @1061373
     /* 1061373 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1061450), // Rule ID 21265 //
     /* 1061378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061417 */     // MIs[0] policy
     /* 1061417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061449 */     // GIR_Coverage, 21265,
     /* 1061449 */     GIR_EraseRootFromParent_Done,
     /* 1061450 */   // Label 15669: @1061450
     /* 1061450 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1061527), // Rule ID 21268 //
     /* 1061455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061494 */     // MIs[0] policy
     /* 1061494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1061507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061526 */     // GIR_Coverage, 21268,
     /* 1061526 */     GIR_EraseRootFromParent_Done,
     /* 1061527 */   // Label 15670: @1061527
     /* 1061527 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1061604), // Rule ID 21269 //
     /* 1061532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061571 */     // MIs[0] policy
     /* 1061571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061581 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1061584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061603 */     // GIR_Coverage, 21269,
     /* 1061603 */     GIR_EraseRootFromParent_Done,
     /* 1061604 */   // Label 15671: @1061604
     /* 1061604 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1061681), // Rule ID 21272 //
     /* 1061609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061648 */     // MIs[0] policy
     /* 1061648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061680 */     // GIR_Coverage, 21272,
     /* 1061680 */     GIR_EraseRootFromParent_Done,
     /* 1061681 */   // Label 15672: @1061681
     /* 1061681 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1061758), // Rule ID 21273 //
     /* 1061686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061725 */     // MIs[0] policy
     /* 1061725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1061738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061757 */     // GIR_Coverage, 21273,
     /* 1061757 */     GIR_EraseRootFromParent_Done,
     /* 1061758 */   // Label 15673: @1061758
     /* 1061758 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1061835), // Rule ID 21276 //
     /* 1061763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061802 */     // MIs[0] policy
     /* 1061802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061834 */     // GIR_Coverage, 21276,
     /* 1061834 */     GIR_EraseRootFromParent_Done,
     /* 1061835 */   // Label 15674: @1061835
     /* 1061835 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1061912), // Rule ID 21277 //
     /* 1061840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061879 */     // MIs[0] policy
     /* 1061879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061889 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1061892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061911 */     // GIR_Coverage, 21277,
     /* 1061911 */     GIR_EraseRootFromParent_Done,
     /* 1061912 */   // Label 15675: @1061912
     /* 1061912 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1061989), // Rule ID 21280 //
     /* 1061917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1061920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1061925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061956 */     // MIs[0] policy
     /* 1061956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1061969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061988 */     // GIR_Coverage, 21280,
     /* 1061988 */     GIR_EraseRootFromParent_Done,
     /* 1061989 */   // Label 15676: @1061989
     /* 1061989 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1062066), // Rule ID 21281 //
     /* 1061994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1061997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1062002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1062005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1062008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1062011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062033 */     // MIs[0] policy
     /* 1062033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062043 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1062046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062065 */     // GIR_Coverage, 21281,
     /* 1062065 */     GIR_EraseRootFromParent_Done,
     /* 1062066 */   // Label 15677: @1062066
     /* 1062066 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1062143), // Rule ID 21284 //
     /* 1062071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062110 */     // MIs[0] policy
     /* 1062110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062120 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1062123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062142 */     // GIR_Coverage, 21284,
     /* 1062142 */     GIR_EraseRootFromParent_Done,
     /* 1062143 */   // Label 15678: @1062143
     /* 1062143 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1062220), // Rule ID 21285 //
     /* 1062148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062187 */     // MIs[0] policy
     /* 1062187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062197 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1062200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062219 */     // GIR_Coverage, 21285,
     /* 1062219 */     GIR_EraseRootFromParent_Done,
     /* 1062220 */   // Label 15679: @1062220
     /* 1062220 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1062297), // Rule ID 21288 //
     /* 1062225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062264 */     // MIs[0] policy
     /* 1062264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062296 */     // GIR_Coverage, 21288,
     /* 1062296 */     GIR_EraseRootFromParent_Done,
     /* 1062297 */   // Label 15680: @1062297
     /* 1062297 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1062374), // Rule ID 21289 //
     /* 1062302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062341 */     // MIs[0] policy
     /* 1062341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062351 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062373 */     // GIR_Coverage, 21289,
     /* 1062373 */     GIR_EraseRootFromParent_Done,
     /* 1062374 */   // Label 15681: @1062374
     /* 1062374 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1062451), // Rule ID 21292 //
     /* 1062379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062418 */     // MIs[0] policy
     /* 1062418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1062431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062450 */     // GIR_Coverage, 21292,
     /* 1062450 */     GIR_EraseRootFromParent_Done,
     /* 1062451 */   // Label 15682: @1062451
     /* 1062451 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1062528), // Rule ID 21293 //
     /* 1062456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062495 */     // MIs[0] policy
     /* 1062495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1062508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062527 */     // GIR_Coverage, 21293,
     /* 1062527 */     GIR_EraseRootFromParent_Done,
     /* 1062528 */   // Label 15683: @1062528
     /* 1062528 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1062605), // Rule ID 21296 //
     /* 1062533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062572 */     // MIs[0] policy
     /* 1062572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1062585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062604 */     // GIR_Coverage, 21296,
     /* 1062604 */     GIR_EraseRootFromParent_Done,
     /* 1062605 */   // Label 15684: @1062605
     /* 1062605 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1062682), // Rule ID 21297 //
     /* 1062610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062649 */     // MIs[0] policy
     /* 1062649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062659 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1062662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062681 */     // GIR_Coverage, 21297,
     /* 1062681 */     GIR_EraseRootFromParent_Done,
     /* 1062682 */   // Label 15685: @1062682
     /* 1062682 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1062759), // Rule ID 21300 //
     /* 1062687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1062698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1062701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1062704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062726 */     // MIs[0] policy
     /* 1062726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1062739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062758 */     // GIR_Coverage, 21300,
     /* 1062758 */     GIR_EraseRootFromParent_Done,
     /* 1062759 */   // Label 15686: @1062759
     /* 1062759 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1062836), // Rule ID 21301 //
     /* 1062764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1062775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1062778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1062781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062803 */     // MIs[0] policy
     /* 1062803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062813 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1062816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062835 */     // GIR_Coverage, 21301,
     /* 1062835 */     GIR_EraseRootFromParent_Done,
     /* 1062836 */   // Label 15687: @1062836
     /* 1062836 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1062913), // Rule ID 21304 //
     /* 1062841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1062844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1062852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1062855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062880 */     // MIs[0] policy
     /* 1062880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062912 */     // GIR_Coverage, 21304,
     /* 1062912 */     GIR_EraseRootFromParent_Done,
     /* 1062913 */   // Label 15688: @1062913
     /* 1062913 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1062990), // Rule ID 21305 //
     /* 1062918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1062921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1062926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1062929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1062932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1062935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062957 */     // MIs[0] policy
     /* 1062957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062967 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1062970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1062986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062989 */     // GIR_Coverage, 21305,
     /* 1062989 */     GIR_EraseRootFromParent_Done,
     /* 1062990 */   // Label 15689: @1062990
     /* 1062990 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1063067), // Rule ID 21308 //
     /* 1062995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1062998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063034 */     // MIs[0] policy
     /* 1063034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1063047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063066 */     // GIR_Coverage, 21308,
     /* 1063066 */     GIR_EraseRootFromParent_Done,
     /* 1063067 */   // Label 15690: @1063067
     /* 1063067 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1063144), // Rule ID 21309 //
     /* 1063072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063111 */     // MIs[0] policy
     /* 1063111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1063124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063143 */     // GIR_Coverage, 21309,
     /* 1063143 */     GIR_EraseRootFromParent_Done,
     /* 1063144 */   // Label 15691: @1063144
     /* 1063144 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1063221), // Rule ID 21312 //
     /* 1063149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1063152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063188 */     // MIs[0] policy
     /* 1063188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063198 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1063201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063220 */     // GIR_Coverage, 21312,
     /* 1063220 */     GIR_EraseRootFromParent_Done,
     /* 1063221 */   // Label 15692: @1063221
     /* 1063221 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1063298), // Rule ID 21313 //
     /* 1063226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063265 */     // MIs[0] policy
     /* 1063265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063275 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1063278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063297 */     // GIR_Coverage, 21313,
     /* 1063297 */     GIR_EraseRootFromParent_Done,
     /* 1063298 */   // Label 15693: @1063298
     /* 1063298 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1063375), // Rule ID 21316 //
     /* 1063303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1063306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063342 */     // MIs[0] policy
     /* 1063342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1063355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063374 */     // GIR_Coverage, 21316,
     /* 1063374 */     GIR_EraseRootFromParent_Done,
     /* 1063375 */   // Label 15694: @1063375
     /* 1063375 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1063452), // Rule ID 21317 //
     /* 1063380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1063383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1063388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063419 */     // MIs[0] policy
     /* 1063419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063429 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11229:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1063432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063451 */     // GIR_Coverage, 21317,
     /* 1063451 */     GIR_EraseRootFromParent_Done,
     /* 1063452 */   // Label 15695: @1063452
     /* 1063452 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1063529), // Rule ID 21320 //
     /* 1063457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1063468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1063471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1063474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063496 */     // MIs[0] policy
     /* 1063496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063506 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1063509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063528 */     // GIR_Coverage, 21320,
     /* 1063528 */     GIR_EraseRootFromParent_Done,
     /* 1063529 */   // Label 15696: @1063529
     /* 1063529 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1063606), // Rule ID 21321 //
     /* 1063534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1063545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1063548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1063551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063573 */     // MIs[0] policy
     /* 1063573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063583 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1063586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063605 */     // GIR_Coverage, 21321,
     /* 1063605 */     GIR_EraseRootFromParent_Done,
     /* 1063606 */   // Label 15697: @1063606
     /* 1063606 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1063683), // Rule ID 21324 //
     /* 1063611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1063622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1063625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1063628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063650 */     // MIs[0] policy
     /* 1063650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063660 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1063663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063682 */     // GIR_Coverage, 21324,
     /* 1063682 */     GIR_EraseRootFromParent_Done,
     /* 1063683 */   // Label 15698: @1063683
     /* 1063683 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1063760), // Rule ID 21325 //
     /* 1063688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1063699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1063702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1063705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063727 */     // MIs[0] policy
     /* 1063727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063737 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1063740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063759 */     // GIR_Coverage, 21325,
     /* 1063759 */     GIR_EraseRootFromParent_Done,
     /* 1063760 */   // Label 15699: @1063760
     /* 1063760 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1063837), // Rule ID 21328 //
     /* 1063765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1063776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1063779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1063782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063804 */     // MIs[0] policy
     /* 1063804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063814 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1063817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063836 */     // GIR_Coverage, 21328,
     /* 1063836 */     GIR_EraseRootFromParent_Done,
     /* 1063837 */   // Label 15700: @1063837
     /* 1063837 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1063914), // Rule ID 21329 //
     /* 1063842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1063853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1063856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1063859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063881 */     // MIs[0] policy
     /* 1063881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063891 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1063894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063913 */     // GIR_Coverage, 21329,
     /* 1063913 */     GIR_EraseRootFromParent_Done,
     /* 1063914 */   // Label 15701: @1063914
     /* 1063914 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1063991), // Rule ID 21332 //
     /* 1063919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1063922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1063927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1063930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1063933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1063936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063958 */     // MIs[0] policy
     /* 1063958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1063971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1063987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063990 */     // GIR_Coverage, 21332,
     /* 1063990 */     GIR_EraseRootFromParent_Done,
     /* 1063991 */   // Label 15702: @1063991
     /* 1063991 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1064068), // Rule ID 21333 //
     /* 1063996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1063999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1064007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1064010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1064013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064035 */     // MIs[0] policy
     /* 1064035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1064048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064067 */     // GIR_Coverage, 21333,
     /* 1064067 */     GIR_EraseRootFromParent_Done,
     /* 1064068 */   // Label 15703: @1064068
     /* 1064068 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1064145), // Rule ID 21336 //
     /* 1064073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1064076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1064084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1064087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1064090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064112 */     // MIs[0] policy
     /* 1064112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1064125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064144 */     // GIR_Coverage, 21336,
     /* 1064144 */     GIR_EraseRootFromParent_Done,
     /* 1064145 */   // Label 15704: @1064145
     /* 1064145 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1064222), // Rule ID 21337 //
     /* 1064150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1064153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1064161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1064164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1064167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064189 */     // MIs[0] policy
     /* 1064189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064199 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1064202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064221 */     // GIR_Coverage, 21337,
     /* 1064221 */     GIR_EraseRootFromParent_Done,
     /* 1064222 */   // Label 15705: @1064222
     /* 1064222 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1064299), // Rule ID 21340 //
     /* 1064227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1064230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1064238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1064241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1064244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1064247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064266 */     // MIs[0] policy
     /* 1064266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064276 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1064279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064298 */     // GIR_Coverage, 21340,
     /* 1064298 */     GIR_EraseRootFromParent_Done,
     /* 1064299 */   // Label 15706: @1064299
     /* 1064299 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1064376), // Rule ID 21341 //
     /* 1064304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1064307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1064315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1064318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1064321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1064324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064343 */     // MIs[0] policy
     /* 1064343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064353 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1064356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1064372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064375 */     // GIR_Coverage, 21341,
     /* 1064375 */     GIR_EraseRootFromParent_Done,
     /* 1064376 */   // Label 15707: @1064376
     /* 1064376 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1064453), // Rule ID 21344 //
     /* 1064381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064420 */     // MIs[0] policy
     /* 1064420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1064433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064452 */     // GIR_Coverage, 21344,
     /* 1064452 */     GIR_EraseRootFromParent_Done,
     /* 1064453 */   // Label 15708: @1064453
     /* 1064453 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1064530), // Rule ID 21345 //
     /* 1064458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064497 */     // MIs[0] policy
     /* 1064497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064507 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1064510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064529 */     // GIR_Coverage, 21345,
     /* 1064529 */     GIR_EraseRootFromParent_Done,
     /* 1064530 */   // Label 15709: @1064530
     /* 1064530 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1064607), // Rule ID 21348 //
     /* 1064535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064574 */     // MIs[0] policy
     /* 1064574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1064587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064606 */     // GIR_Coverage, 21348,
     /* 1064606 */     GIR_EraseRootFromParent_Done,
     /* 1064607 */   // Label 15710: @1064607
     /* 1064607 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1064684), // Rule ID 21349 //
     /* 1064612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064651 */     // MIs[0] policy
     /* 1064651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064661 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1064664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064683 */     // GIR_Coverage, 21349,
     /* 1064683 */     GIR_EraseRootFromParent_Done,
     /* 1064684 */   // Label 15711: @1064684
     /* 1064684 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1064761), // Rule ID 21352 //
     /* 1064689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064728 */     // MIs[0] policy
     /* 1064728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064738 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1064741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064760 */     // GIR_Coverage, 21352,
     /* 1064760 */     GIR_EraseRootFromParent_Done,
     /* 1064761 */   // Label 15712: @1064761
     /* 1064761 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1064838), // Rule ID 21353 //
     /* 1064766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064805 */     // MIs[0] policy
     /* 1064805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064815 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1064818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064837 */     // GIR_Coverage, 21353,
     /* 1064837 */     GIR_EraseRootFromParent_Done,
     /* 1064838 */   // Label 15713: @1064838
     /* 1064838 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1064915), // Rule ID 21356 //
     /* 1064843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1064846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064882 */     // MIs[0] policy
     /* 1064882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064892 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1064895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064914 */     // GIR_Coverage, 21356,
     /* 1064914 */     GIR_EraseRootFromParent_Done,
     /* 1064915 */   // Label 15714: @1064915
     /* 1064915 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1064992), // Rule ID 21357 //
     /* 1064920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1064923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1064928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064959 */     // MIs[0] policy
     /* 1064959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064969 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1064972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064991 */     // GIR_Coverage, 21357,
     /* 1064991 */     GIR_EraseRootFromParent_Done,
     /* 1064992 */   // Label 15715: @1064992
     /* 1064992 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1065069), // Rule ID 21360 //
     /* 1064997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1065000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065036 */     // MIs[0] policy
     /* 1065036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065046 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1065049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065068 */     // GIR_Coverage, 21360,
     /* 1065068 */     GIR_EraseRootFromParent_Done,
     /* 1065069 */   // Label 15716: @1065069
     /* 1065069 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1065146), // Rule ID 21361 //
     /* 1065074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1065077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1065085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1065088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065113 */     // MIs[0] policy
     /* 1065113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065123 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1065126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1065142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065145 */     // GIR_Coverage, 21361,
     /* 1065145 */     GIR_EraseRootFromParent_Done,
     /* 1065146 */   // Label 15717: @1065146
     /* 1065146 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1065223), // Rule ID 21364 //
     /* 1065151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065190 */     // MIs[0] policy
     /* 1065190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1065203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065222 */     // GIR_Coverage, 21364,
     /* 1065222 */     GIR_EraseRootFromParent_Done,
     /* 1065223 */   // Label 15718: @1065223
     /* 1065223 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1065300), // Rule ID 21365 //
     /* 1065228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065267 */     // MIs[0] policy
     /* 1065267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065277 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1065280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065299 */     // GIR_Coverage, 21365,
     /* 1065299 */     GIR_EraseRootFromParent_Done,
     /* 1065300 */   // Label 15719: @1065300
     /* 1065300 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1065377), // Rule ID 21368 //
     /* 1065305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065344 */     // MIs[0] policy
     /* 1065344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1065357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065376 */     // GIR_Coverage, 21368,
     /* 1065376 */     GIR_EraseRootFromParent_Done,
     /* 1065377 */   // Label 15720: @1065377
     /* 1065377 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1065454), // Rule ID 21369 //
     /* 1065382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065421 */     // MIs[0] policy
     /* 1065421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065431 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1065434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065453 */     // GIR_Coverage, 21369,
     /* 1065453 */     GIR_EraseRootFromParent_Done,
     /* 1065454 */   // Label 15721: @1065454
     /* 1065454 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1065531), // Rule ID 21372 //
     /* 1065459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065498 */     // MIs[0] policy
     /* 1065498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1065511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065530 */     // GIR_Coverage, 21372,
     /* 1065530 */     GIR_EraseRootFromParent_Done,
     /* 1065531 */   // Label 15722: @1065531
     /* 1065531 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1065608), // Rule ID 21373 //
     /* 1065536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065575 */     // MIs[0] policy
     /* 1065575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065585 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1065588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065607 */     // GIR_Coverage, 21373,
     /* 1065607 */     GIR_EraseRootFromParent_Done,
     /* 1065608 */   // Label 15723: @1065608
     /* 1065608 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1065685), // Rule ID 21376 //
     /* 1065613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1065616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065652 */     // MIs[0] policy
     /* 1065652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065662 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1065665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065684 */     // GIR_Coverage, 21376,
     /* 1065684 */     GIR_EraseRootFromParent_Done,
     /* 1065685 */   // Label 15724: @1065685
     /* 1065685 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1065762), // Rule ID 21377 //
     /* 1065690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1065693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1065698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065729 */     // MIs[0] policy
     /* 1065729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065739 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1065742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065761 */     // GIR_Coverage, 21377,
     /* 1065761 */     GIR_EraseRootFromParent_Done,
     /* 1065762 */   // Label 15725: @1065762
     /* 1065762 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1065839), // Rule ID 21380 //
     /* 1065767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1065778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1065781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065806 */     // MIs[0] policy
     /* 1065806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1065819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065838 */     // GIR_Coverage, 21380,
     /* 1065838 */     GIR_EraseRootFromParent_Done,
     /* 1065839 */   // Label 15726: @1065839
     /* 1065839 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1065916), // Rule ID 21381 //
     /* 1065844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1065855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1065858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1065861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065883 */     // MIs[0] policy
     /* 1065883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065893 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1065896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065915 */     // GIR_Coverage, 21381,
     /* 1065915 */     GIR_EraseRootFromParent_Done,
     /* 1065916 */   // Label 15727: @1065916
     /* 1065916 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1065993), // Rule ID 21384 //
     /* 1065921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1065929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1065932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1065935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1065938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065960 */     // MIs[0] policy
     /* 1065960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1065973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065992 */     // GIR_Coverage, 21384,
     /* 1065992 */     GIR_EraseRootFromParent_Done,
     /* 1065993 */   // Label 15728: @1065993
     /* 1065993 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1066070), // Rule ID 21385 //
     /* 1065998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1066015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066037 */     // MIs[0] policy
     /* 1066037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066047 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1066050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066069 */     // GIR_Coverage, 21385,
     /* 1066069 */     GIR_EraseRootFromParent_Done,
     /* 1066070 */   // Label 15729: @1066070
     /* 1066070 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1066147), // Rule ID 21388 //
     /* 1066075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1066092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066114 */     // MIs[0] policy
     /* 1066114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1066127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066146 */     // GIR_Coverage, 21388,
     /* 1066146 */     GIR_EraseRootFromParent_Done,
     /* 1066147 */   // Label 15730: @1066147
     /* 1066147 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1066224), // Rule ID 21389 //
     /* 1066152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1066169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066191 */     // MIs[0] policy
     /* 1066191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066201 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1066204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066223 */     // GIR_Coverage, 21389,
     /* 1066223 */     GIR_EraseRootFromParent_Done,
     /* 1066224 */   // Label 15731: @1066224
     /* 1066224 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1066301), // Rule ID 21392 //
     /* 1066229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066268 */     // MIs[0] policy
     /* 1066268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1066281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066300 */     // GIR_Coverage, 21392,
     /* 1066300 */     GIR_EraseRootFromParent_Done,
     /* 1066301 */   // Label 15732: @1066301
     /* 1066301 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1066378), // Rule ID 21393 //
     /* 1066306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1066323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066345 */     // MIs[0] policy
     /* 1066345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066355 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1066358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066377 */     // GIR_Coverage, 21393,
     /* 1066377 */     GIR_EraseRootFromParent_Done,
     /* 1066378 */   // Label 15733: @1066378
     /* 1066378 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1066455), // Rule ID 21396 //
     /* 1066383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1066400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066422 */     // MIs[0] policy
     /* 1066422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066432 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1066435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066454 */     // GIR_Coverage, 21396,
     /* 1066454 */     GIR_EraseRootFromParent_Done,
     /* 1066455 */   // Label 15734: @1066455
     /* 1066455 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1066532), // Rule ID 21397 //
     /* 1066460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1066477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066499 */     // MIs[0] policy
     /* 1066499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066509 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1066512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066531 */     // GIR_Coverage, 21397,
     /* 1066531 */     GIR_EraseRootFromParent_Done,
     /* 1066532 */   // Label 15735: @1066532
     /* 1066532 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1066609), // Rule ID 21400 //
     /* 1066537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1066548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1066551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1066554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066576 */     // MIs[0] policy
     /* 1066576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066586 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1066589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066608 */     // GIR_Coverage, 21400,
     /* 1066608 */     GIR_EraseRootFromParent_Done,
     /* 1066609 */   // Label 15736: @1066609
     /* 1066609 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1066686), // Rule ID 21401 //
     /* 1066614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1066625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1066628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1066631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1066641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066653 */     // MIs[0] policy
     /* 1066653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066663 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1066666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066685 */     // GIR_Coverage, 21401,
     /* 1066685 */     GIR_EraseRootFromParent_Done,
     /* 1066686 */   // Label 15737: @1066686
     /* 1066686 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1066763), // Rule ID 21404 //
     /* 1066691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066730 */     // MIs[0] policy
     /* 1066730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066740 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1066743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066762 */     // GIR_Coverage, 21404,
     /* 1066762 */     GIR_EraseRootFromParent_Done,
     /* 1066763 */   // Label 15738: @1066763
     /* 1066763 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1066840), // Rule ID 21405 //
     /* 1066768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1066785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066807 */     // MIs[0] policy
     /* 1066807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066817 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1066820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066839 */     // GIR_Coverage, 21405,
     /* 1066839 */     GIR_EraseRootFromParent_Done,
     /* 1066840 */   // Label 15739: @1066840
     /* 1066840 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1066917), // Rule ID 21408 //
     /* 1066845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066884 */     // MIs[0] policy
     /* 1066884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1066897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066916 */     // GIR_Coverage, 21408,
     /* 1066916 */     GIR_EraseRootFromParent_Done,
     /* 1066917 */   // Label 15740: @1066917
     /* 1066917 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1066994), // Rule ID 21409 //
     /* 1066922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1066930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1066939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066961 */     // MIs[0] policy
     /* 1066961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1066974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066993 */     // GIR_Coverage, 21409,
     /* 1066993 */     GIR_EraseRootFromParent_Done,
     /* 1066994 */   // Label 15741: @1066994
     /* 1066994 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1067071), // Rule ID 21412 //
     /* 1066999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067038 */     // MIs[0] policy
     /* 1067038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067048 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1067051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067070 */     // GIR_Coverage, 21412,
     /* 1067070 */     GIR_EraseRootFromParent_Done,
     /* 1067071 */   // Label 15742: @1067071
     /* 1067071 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1067148), // Rule ID 21413 //
     /* 1067076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067115 */     // MIs[0] policy
     /* 1067115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067125 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1067128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067147 */     // GIR_Coverage, 21413,
     /* 1067147 */     GIR_EraseRootFromParent_Done,
     /* 1067148 */   // Label 15743: @1067148
     /* 1067148 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1067225), // Rule ID 21416 //
     /* 1067153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067192 */     // MIs[0] policy
     /* 1067192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067202 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1067205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067224 */     // GIR_Coverage, 21416,
     /* 1067224 */     GIR_EraseRootFromParent_Done,
     /* 1067225 */   // Label 15744: @1067225
     /* 1067225 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1067302), // Rule ID 21417 //
     /* 1067230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067269 */     // MIs[0] policy
     /* 1067269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067279 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1067282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067301 */     // GIR_Coverage, 21417,
     /* 1067301 */     GIR_EraseRootFromParent_Done,
     /* 1067302 */   // Label 15745: @1067302
     /* 1067302 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1067379), // Rule ID 21420 //
     /* 1067307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1067318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1067321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067346 */     // MIs[0] policy
     /* 1067346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067356 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1067359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067378 */     // GIR_Coverage, 21420,
     /* 1067378 */     GIR_EraseRootFromParent_Done,
     /* 1067379 */   // Label 15746: @1067379
     /* 1067379 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1067456), // Rule ID 21421 //
     /* 1067384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1067395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1067398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1067401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067423 */     // MIs[0] policy
     /* 1067423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067433 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1067436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067455 */     // GIR_Coverage, 21421,
     /* 1067455 */     GIR_EraseRootFromParent_Done,
     /* 1067456 */   // Label 15747: @1067456
     /* 1067456 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1067533), // Rule ID 21424 //
     /* 1067461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1067472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1067475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067500 */     // MIs[0] policy
     /* 1067500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1067513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067532 */     // GIR_Coverage, 21424,
     /* 1067532 */     GIR_EraseRootFromParent_Done,
     /* 1067533 */   // Label 15748: @1067533
     /* 1067533 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1067610), // Rule ID 21425 //
     /* 1067538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1067549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1067552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1067555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067577 */     // MIs[0] policy
     /* 1067577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067587 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1067590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067609 */     // GIR_Coverage, 21425,
     /* 1067609 */     GIR_EraseRootFromParent_Done,
     /* 1067610 */   // Label 15749: @1067610
     /* 1067610 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1067687), // Rule ID 21428 //
     /* 1067615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1067626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1067629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067654 */     // MIs[0] policy
     /* 1067654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1067667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067686 */     // GIR_Coverage, 21428,
     /* 1067686 */     GIR_EraseRootFromParent_Done,
     /* 1067687 */   // Label 15750: @1067687
     /* 1067687 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1067764), // Rule ID 21429 //
     /* 1067692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1067703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1067706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1067709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067731 */     // MIs[0] policy
     /* 1067731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067741 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1067744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067763 */     // GIR_Coverage, 21429,
     /* 1067763 */     GIR_EraseRootFromParent_Done,
     /* 1067764 */   // Label 15751: @1067764
     /* 1067764 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1067841), // Rule ID 21432 //
     /* 1067769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1067780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1067783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067808 */     // MIs[0] policy
     /* 1067808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067818 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1067821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067840 */     // GIR_Coverage, 21432,
     /* 1067840 */     GIR_EraseRootFromParent_Done,
     /* 1067841 */   // Label 15752: @1067841
     /* 1067841 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1067918), // Rule ID 21433 //
     /* 1067846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1067857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1067860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1067863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067885 */     // MIs[0] policy
     /* 1067885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067895 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1067898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067917 */     // GIR_Coverage, 21433,
     /* 1067917 */     GIR_EraseRootFromParent_Done,
     /* 1067918 */   // Label 15753: @1067918
     /* 1067918 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1067995), // Rule ID 21436 //
     /* 1067923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1067931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1067934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1067937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1067950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067962 */     // MIs[0] policy
     /* 1067962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067972 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1067975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067994 */     // GIR_Coverage, 21436,
     /* 1067994 */     GIR_EraseRootFromParent_Done,
     /* 1067995 */   // Label 15754: @1067995
     /* 1067995 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1068072), // Rule ID 21437 //
     /* 1068000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1068003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1068008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1068011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1068014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068039 */     // MIs[0] policy
     /* 1068039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1068052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068071 */     // GIR_Coverage, 21437,
     /* 1068071 */     GIR_EraseRootFromParent_Done,
     /* 1068072 */   // Label 15755: @1068072
     /* 1068072 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1068149), // Rule ID 21440 //
     /* 1068077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1068088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1068091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068116 */     // MIs[0] policy
     /* 1068116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068126 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1068129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068148 */     // GIR_Coverage, 21440,
     /* 1068148 */     GIR_EraseRootFromParent_Done,
     /* 1068149 */   // Label 15756: @1068149
     /* 1068149 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1068226), // Rule ID 21441 //
     /* 1068154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1068165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1068168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068193 */     // MIs[0] policy
     /* 1068193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068203 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1068206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068225 */     // GIR_Coverage, 21441,
     /* 1068225 */     GIR_EraseRootFromParent_Done,
     /* 1068226 */   // Label 15757: @1068226
     /* 1068226 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1068303), // Rule ID 21444 //
     /* 1068231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068270 */     // MIs[0] policy
     /* 1068270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068280 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1068283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068302 */     // GIR_Coverage, 21444,
     /* 1068302 */     GIR_EraseRootFromParent_Done,
     /* 1068303 */   // Label 15758: @1068303
     /* 1068303 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1068380), // Rule ID 21445 //
     /* 1068308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1068319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1068322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068347 */     // MIs[0] policy
     /* 1068347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068357 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1068360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068379 */     // GIR_Coverage, 21445,
     /* 1068379 */     GIR_EraseRootFromParent_Done,
     /* 1068380 */   // Label 15759: @1068380
     /* 1068380 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1068457), // Rule ID 21448 //
     /* 1068385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068424 */     // MIs[0] policy
     /* 1068424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1068437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068456 */     // GIR_Coverage, 21448,
     /* 1068456 */     GIR_EraseRootFromParent_Done,
     /* 1068457 */   // Label 15760: @1068457
     /* 1068457 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1068534), // Rule ID 21449 //
     /* 1068462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1068473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1068476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068501 */     // MIs[0] policy
     /* 1068501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068511 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1068514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068533 */     // GIR_Coverage, 21449,
     /* 1068533 */     GIR_EraseRootFromParent_Done,
     /* 1068534 */   // Label 15761: @1068534
     /* 1068534 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1068611), // Rule ID 21452 //
     /* 1068539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068578 */     // MIs[0] policy
     /* 1068578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1068591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068610 */     // GIR_Coverage, 21452,
     /* 1068610 */     GIR_EraseRootFromParent_Done,
     /* 1068611 */   // Label 15762: @1068611
     /* 1068611 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1068688), // Rule ID 21453 //
     /* 1068616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1068627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1068630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068655 */     // MIs[0] policy
     /* 1068655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068665 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1068668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068687 */     // GIR_Coverage, 21453,
     /* 1068687 */     GIR_EraseRootFromParent_Done,
     /* 1068688 */   // Label 15763: @1068688
     /* 1068688 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1068765), // Rule ID 21456 //
     /* 1068693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1068696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068732 */     // MIs[0] policy
     /* 1068732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1068745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068764 */     // GIR_Coverage, 21456,
     /* 1068764 */     GIR_EraseRootFromParent_Done,
     /* 1068765 */   // Label 15764: @1068765
     /* 1068765 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1068842), // Rule ID 21457 //
     /* 1068770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1068773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1068781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1068784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1068797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068809 */     // MIs[0] policy
     /* 1068809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1068822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068841 */     // GIR_Coverage, 21457,
     /* 1068841 */     GIR_EraseRootFromParent_Done,
     /* 1068842 */   // Label 15765: @1068842
     /* 1068842 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1068919), // Rule ID 21460 //
     /* 1068847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1068850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1068858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1068861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068886 */     // MIs[0] policy
     /* 1068886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1068899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068918 */     // GIR_Coverage, 21460,
     /* 1068918 */     GIR_EraseRootFromParent_Done,
     /* 1068919 */   // Label 15766: @1068919
     /* 1068919 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1068996), // Rule ID 21461 //
     /* 1068924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1068927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1068932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1068935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1068938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068963 */     // MIs[0] policy
     /* 1068963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068973 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1068976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1068992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068995 */     // GIR_Coverage, 21461,
     /* 1068995 */     GIR_EraseRootFromParent_Done,
     /* 1068996 */   // Label 15767: @1068996
     /* 1068996 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1069073), // Rule ID 21464 //
     /* 1069001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1069012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1069015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069040 */     // MIs[0] policy
     /* 1069040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1069053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069072 */     // GIR_Coverage, 21464,
     /* 1069072 */     GIR_EraseRootFromParent_Done,
     /* 1069073 */   // Label 15768: @1069073
     /* 1069073 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1069150), // Rule ID 21465 //
     /* 1069078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1069089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1069092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069117 */     // MIs[0] policy
     /* 1069117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1069130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069149 */     // GIR_Coverage, 21465,
     /* 1069149 */     GIR_EraseRootFromParent_Done,
     /* 1069150 */   // Label 15769: @1069150
     /* 1069150 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1069227), // Rule ID 21468 //
     /* 1069155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1069166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1069169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069194 */     // MIs[0] policy
     /* 1069194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069204 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1069207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069226 */     // GIR_Coverage, 21468,
     /* 1069226 */     GIR_EraseRootFromParent_Done,
     /* 1069227 */   // Label 15770: @1069227
     /* 1069227 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1069304), // Rule ID 21469 //
     /* 1069232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1069243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1069246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069271 */     // MIs[0] policy
     /* 1069271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069281 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1069284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069303 */     // GIR_Coverage, 21469,
     /* 1069303 */     GIR_EraseRootFromParent_Done,
     /* 1069304 */   // Label 15771: @1069304
     /* 1069304 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1069381), // Rule ID 21472 //
     /* 1069309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1069312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1069320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1069323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1069336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069348 */     // MIs[0] policy
     /* 1069348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069358 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1069361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069380 */     // GIR_Coverage, 21472,
     /* 1069380 */     GIR_EraseRootFromParent_Done,
     /* 1069381 */   // Label 15772: @1069381
     /* 1069381 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1069458), // Rule ID 21473 //
     /* 1069386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1069389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1069394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1069397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1069400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1069413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069425 */     // MIs[0] policy
     /* 1069425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069435 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1069438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069457 */     // GIR_Coverage, 21473,
     /* 1069457 */     GIR_EraseRootFromParent_Done,
     /* 1069458 */   // Label 15773: @1069458
     /* 1069458 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1069535), // Rule ID 21716 //
     /* 1069463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069502 */     // MIs[0] policy
     /* 1069502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1069515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069534 */     // GIR_Coverage, 21716,
     /* 1069534 */     GIR_EraseRootFromParent_Done,
     /* 1069535 */   // Label 15774: @1069535
     /* 1069535 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1069612), // Rule ID 21717 //
     /* 1069540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1069551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1069554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1069557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069579 */     // MIs[0] policy
     /* 1069579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069589 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1069592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069611 */     // GIR_Coverage, 21717,
     /* 1069611 */     GIR_EraseRootFromParent_Done,
     /* 1069612 */   // Label 15775: @1069612
     /* 1069612 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1069689), // Rule ID 21720 //
     /* 1069617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069656 */     // MIs[0] policy
     /* 1069656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1069669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069688 */     // GIR_Coverage, 21720,
     /* 1069688 */     GIR_EraseRootFromParent_Done,
     /* 1069689 */   // Label 15776: @1069689
     /* 1069689 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1069766), // Rule ID 21721 //
     /* 1069694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1069705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1069708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1069711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069733 */     // MIs[0] policy
     /* 1069733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069743 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1069746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069765 */     // GIR_Coverage, 21721,
     /* 1069765 */     GIR_EraseRootFromParent_Done,
     /* 1069766 */   // Label 15777: @1069766
     /* 1069766 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1069843), // Rule ID 21724 //
     /* 1069771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1069788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069810 */     // MIs[0] policy
     /* 1069810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069820 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1069823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069842 */     // GIR_Coverage, 21724,
     /* 1069842 */     GIR_EraseRootFromParent_Done,
     /* 1069843 */   // Label 15778: @1069843
     /* 1069843 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1069920), // Rule ID 21725 //
     /* 1069848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1069851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1069859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1069862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1069865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069887 */     // MIs[0] policy
     /* 1069887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069897 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1069900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069919 */     // GIR_Coverage, 21725,
     /* 1069919 */     GIR_EraseRootFromParent_Done,
     /* 1069920 */   // Label 15779: @1069920
     /* 1069920 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1069997), // Rule ID 21728 //
     /* 1069925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1069928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1069933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1069936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1069939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1069942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069964 */     // MIs[0] policy
     /* 1069964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1069977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1069993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069996 */     // GIR_Coverage, 21728,
     /* 1069996 */     GIR_EraseRootFromParent_Done,
     /* 1069997 */   // Label 15780: @1069997
     /* 1069997 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1070074), // Rule ID 21729 //
     /* 1070002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1070013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1070016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1070019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070041 */     // MIs[0] policy
     /* 1070041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070051 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070073 */     // GIR_Coverage, 21729,
     /* 1070073 */     GIR_EraseRootFromParent_Done,
     /* 1070074 */   // Label 15781: @1070074
     /* 1070074 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1070151), // Rule ID 21732 //
     /* 1070079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1070082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1070096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070118 */     // MIs[0] policy
     /* 1070118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070150 */     // GIR_Coverage, 21732,
     /* 1070150 */     GIR_EraseRootFromParent_Done,
     /* 1070151 */   // Label 15782: @1070151
     /* 1070151 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1070228), // Rule ID 21733 //
     /* 1070156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1070167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1070170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1070173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070195 */     // MIs[0] policy
     /* 1070195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070205 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070227 */     // GIR_Coverage, 21733,
     /* 1070227 */     GIR_EraseRootFromParent_Done,
     /* 1070228 */   // Label 15783: @1070228
     /* 1070228 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1070305), // Rule ID 21736 //
     /* 1070233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1070236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1070250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1070253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070272 */     // MIs[0] policy
     /* 1070272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070282 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1070285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070304 */     // GIR_Coverage, 21736,
     /* 1070304 */     GIR_EraseRootFromParent_Done,
     /* 1070305 */   // Label 15784: @1070305
     /* 1070305 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1070382), // Rule ID 21737 //
     /* 1070310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1070313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1070321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1070324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1070327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1070330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070349 */     // MIs[0] policy
     /* 1070349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070359 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1070362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1070378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070381 */     // GIR_Coverage, 21737,
     /* 1070381 */     GIR_EraseRootFromParent_Done,
     /* 1070382 */   // Label 15785: @1070382
     /* 1070382 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1070459), // Rule ID 21740 //
     /* 1070387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070426 */     // MIs[0] policy
     /* 1070426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1070439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070458 */     // GIR_Coverage, 21740,
     /* 1070458 */     GIR_EraseRootFromParent_Done,
     /* 1070459 */   // Label 15786: @1070459
     /* 1070459 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1070536), // Rule ID 21741 //
     /* 1070464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070503 */     // MIs[0] policy
     /* 1070503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070513 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1070516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070535 */     // GIR_Coverage, 21741,
     /* 1070535 */     GIR_EraseRootFromParent_Done,
     /* 1070536 */   // Label 15787: @1070536
     /* 1070536 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1070613), // Rule ID 21744 //
     /* 1070541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070580 */     // MIs[0] policy
     /* 1070580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1070593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070612 */     // GIR_Coverage, 21744,
     /* 1070612 */     GIR_EraseRootFromParent_Done,
     /* 1070613 */   // Label 15788: @1070613
     /* 1070613 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1070690), // Rule ID 21745 //
     /* 1070618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070657 */     // MIs[0] policy
     /* 1070657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070667 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1070670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070689 */     // GIR_Coverage, 21745,
     /* 1070689 */     GIR_EraseRootFromParent_Done,
     /* 1070690 */   // Label 15789: @1070690
     /* 1070690 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1070767), // Rule ID 21748 //
     /* 1070695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070734 */     // MIs[0] policy
     /* 1070734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070766 */     // GIR_Coverage, 21748,
     /* 1070766 */     GIR_EraseRootFromParent_Done,
     /* 1070767 */   // Label 15790: @1070767
     /* 1070767 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1070844), // Rule ID 21749 //
     /* 1070772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070811 */     // MIs[0] policy
     /* 1070811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070821 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1070824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070843 */     // GIR_Coverage, 21749,
     /* 1070843 */     GIR_EraseRootFromParent_Done,
     /* 1070844 */   // Label 15791: @1070844
     /* 1070844 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1070921), // Rule ID 21752 //
     /* 1070849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1070852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070888 */     // MIs[0] policy
     /* 1070888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070920 */     // GIR_Coverage, 21752,
     /* 1070920 */     GIR_EraseRootFromParent_Done,
     /* 1070921 */   // Label 15792: @1070921
     /* 1070921 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1070998), // Rule ID 21753 //
     /* 1070926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1070929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1070934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070965 */     // MIs[0] policy
     /* 1070965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1070978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070997 */     // GIR_Coverage, 21753,
     /* 1070997 */     GIR_EraseRootFromParent_Done,
     /* 1070998 */   // Label 15793: @1070998
     /* 1070998 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1071075), // Rule ID 21756 //
     /* 1071003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1071006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071042 */     // MIs[0] policy
     /* 1071042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071074 */     // GIR_Coverage, 21756,
     /* 1071074 */     GIR_EraseRootFromParent_Done,
     /* 1071075 */   // Label 15794: @1071075
     /* 1071075 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1071152), // Rule ID 21757 //
     /* 1071080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1071083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1071091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1071094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1071097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1071100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071119 */     // MIs[0] policy
     /* 1071119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071129 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071151 */     // GIR_Coverage, 21757,
     /* 1071151 */     GIR_EraseRootFromParent_Done,
     /* 1071152 */   // Label 15795: @1071152
     /* 1071152 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1071229), // Rule ID 21760 //
     /* 1071157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071196 */     // MIs[0] policy
     /* 1071196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071206 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1071209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071228 */     // GIR_Coverage, 21760,
     /* 1071228 */     GIR_EraseRootFromParent_Done,
     /* 1071229 */   // Label 15796: @1071229
     /* 1071229 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1071306), // Rule ID 21761 //
     /* 1071234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071273 */     // MIs[0] policy
     /* 1071273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071283 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1071286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071305 */     // GIR_Coverage, 21761,
     /* 1071305 */     GIR_EraseRootFromParent_Done,
     /* 1071306 */   // Label 15797: @1071306
     /* 1071306 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1071383), // Rule ID 21764 //
     /* 1071311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071350 */     // MIs[0] policy
     /* 1071350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1071363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071382 */     // GIR_Coverage, 21764,
     /* 1071382 */     GIR_EraseRootFromParent_Done,
     /* 1071383 */   // Label 15798: @1071383
     /* 1071383 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1071460), // Rule ID 21765 //
     /* 1071388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071427 */     // MIs[0] policy
     /* 1071427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071437 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1071440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071459 */     // GIR_Coverage, 21765,
     /* 1071459 */     GIR_EraseRootFromParent_Done,
     /* 1071460 */   // Label 15799: @1071460
     /* 1071460 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1071537), // Rule ID 21768 //
     /* 1071465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071504 */     // MIs[0] policy
     /* 1071504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1071517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071536 */     // GIR_Coverage, 21768,
     /* 1071536 */     GIR_EraseRootFromParent_Done,
     /* 1071537 */   // Label 15800: @1071537
     /* 1071537 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1071614), // Rule ID 21769 //
     /* 1071542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071581 */     // MIs[0] policy
     /* 1071581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071591 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1071594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071613 */     // GIR_Coverage, 21769,
     /* 1071613 */     GIR_EraseRootFromParent_Done,
     /* 1071614 */   // Label 15801: @1071614
     /* 1071614 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1071691), // Rule ID 21772 //
     /* 1071619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1071622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071658 */     // MIs[0] policy
     /* 1071658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071690 */     // GIR_Coverage, 21772,
     /* 1071690 */     GIR_EraseRootFromParent_Done,
     /* 1071691 */   // Label 15802: @1071691
     /* 1071691 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1071768), // Rule ID 21773 //
     /* 1071696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1071699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1071704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071735 */     // MIs[0] policy
     /* 1071735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071745 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1071748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071767 */     // GIR_Coverage, 21773,
     /* 1071767 */     GIR_EraseRootFromParent_Done,
     /* 1071768 */   // Label 15803: @1071768
     /* 1071768 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1071845), // Rule ID 21776 //
     /* 1071773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1071776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1071784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1071787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1071790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071812 */     // MIs[0] policy
     /* 1071812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071822 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1071825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071844 */     // GIR_Coverage, 21776,
     /* 1071844 */     GIR_EraseRootFromParent_Done,
     /* 1071845 */   // Label 15804: @1071845
     /* 1071845 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1071922), // Rule ID 21777 //
     /* 1071850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1071853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1071861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1071864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1071867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071889 */     // MIs[0] policy
     /* 1071889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071899 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1071902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071921 */     // GIR_Coverage, 21777,
     /* 1071921 */     GIR_EraseRootFromParent_Done,
     /* 1071922 */   // Label 15805: @1071922
     /* 1071922 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1071999), // Rule ID 21780 //
     /* 1071927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1071930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1071935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1071944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071966 */     // MIs[0] policy
     /* 1071966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1071979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071998 */     // GIR_Coverage, 21780,
     /* 1071998 */     GIR_EraseRootFromParent_Done,
     /* 1071999 */   // Label 15806: @1071999
     /* 1071999 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1072076), // Rule ID 21781 //
     /* 1072004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1072015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1072018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1072021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072043 */     // MIs[0] policy
     /* 1072043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072053 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072075 */     // GIR_Coverage, 21781,
     /* 1072075 */     GIR_EraseRootFromParent_Done,
     /* 1072076 */   // Label 15807: @1072076
     /* 1072076 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1072153), // Rule ID 21784 //
     /* 1072081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1072098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072120 */     // MIs[0] policy
     /* 1072120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072130 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072152 */     // GIR_Coverage, 21784,
     /* 1072152 */     GIR_EraseRootFromParent_Done,
     /* 1072153 */   // Label 15808: @1072153
     /* 1072153 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1072230), // Rule ID 21785 //
     /* 1072158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1072169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1072172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1072175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072197 */     // MIs[0] policy
     /* 1072197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072207 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072229 */     // GIR_Coverage, 21785,
     /* 1072229 */     GIR_EraseRootFromParent_Done,
     /* 1072230 */   // Label 15809: @1072230
     /* 1072230 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1072307), // Rule ID 21788 //
     /* 1072235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1072252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072274 */     // MIs[0] policy
     /* 1072274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1072287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072306 */     // GIR_Coverage, 21788,
     /* 1072306 */     GIR_EraseRootFromParent_Done,
     /* 1072307 */   // Label 15810: @1072307
     /* 1072307 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1072384), // Rule ID 21789 //
     /* 1072312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1072329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072351 */     // MIs[0] policy
     /* 1072351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072361 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11171:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1072364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072383 */     // GIR_Coverage, 21789,
     /* 1072383 */     GIR_EraseRootFromParent_Done,
     /* 1072384 */   // Label 15811: @1072384
     /* 1072384 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1072461), // Rule ID 21792 //
     /* 1072389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1072406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072428 */     // MIs[0] policy
     /* 1072428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1072441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072460 */     // GIR_Coverage, 21792,
     /* 1072460 */     GIR_EraseRootFromParent_Done,
     /* 1072461 */   // Label 15812: @1072461
     /* 1072461 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1072538), // Rule ID 21793 //
     /* 1072466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1072483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072505 */     // MIs[0] policy
     /* 1072505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072515 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1072518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072537 */     // GIR_Coverage, 21793,
     /* 1072537 */     GIR_EraseRootFromParent_Done,
     /* 1072538 */   // Label 15813: @1072538
     /* 1072538 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1072615), // Rule ID 21796 //
     /* 1072543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1072546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1072560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072582 */     // MIs[0] policy
     /* 1072582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1072595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072614 */     // GIR_Coverage, 21796,
     /* 1072614 */     GIR_EraseRootFromParent_Done,
     /* 1072615 */   // Label 15814: @1072615
     /* 1072615 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1072692), // Rule ID 21797 //
     /* 1072620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1072623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1072637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072659 */     // MIs[0] policy
     /* 1072659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072669 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1072672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072691 */     // GIR_Coverage, 21797,
     /* 1072691 */     GIR_EraseRootFromParent_Done,
     /* 1072692 */   // Label 15815: @1072692
     /* 1072692 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1072769), // Rule ID 21800 //
     /* 1072697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1072700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1072714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072736 */     // MIs[0] policy
     /* 1072736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072768 */     // GIR_Coverage, 21800,
     /* 1072768 */     GIR_EraseRootFromParent_Done,
     /* 1072769 */   // Label 15816: @1072769
     /* 1072769 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1072846), // Rule ID 21801 //
     /* 1072774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1072777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1072791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072813 */     // MIs[0] policy
     /* 1072813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1072826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072845 */     // GIR_Coverage, 21801,
     /* 1072845 */     GIR_EraseRootFromParent_Done,
     /* 1072846 */   // Label 15817: @1072846
     /* 1072846 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1072923), // Rule ID 21804 //
     /* 1072851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1072854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1072868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072890 */     // MIs[0] policy
     /* 1072890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072922 */     // GIR_Coverage, 21804,
     /* 1072922 */     GIR_EraseRootFromParent_Done,
     /* 1072923 */   // Label 15818: @1072923
     /* 1072923 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1073000), // Rule ID 21805 //
     /* 1072928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1072931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1072936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1072945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072967 */     // MIs[0] policy
     /* 1072967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072977 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1072980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072999 */     // GIR_Coverage, 21805,
     /* 1072999 */     GIR_EraseRootFromParent_Done,
     /* 1073000 */   // Label 15819: @1073000
     /* 1073000 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1073077), // Rule ID 21808 //
     /* 1073005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1073022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073044 */     // MIs[0] policy
     /* 1073044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073076 */     // GIR_Coverage, 21808,
     /* 1073076 */     GIR_EraseRootFromParent_Done,
     /* 1073077 */   // Label 15820: @1073077
     /* 1073077 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1073154), // Rule ID 21809 //
     /* 1073082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1073093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1073096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1073099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073121 */     // MIs[0] policy
     /* 1073121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073131 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11171:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073153 */     // GIR_Coverage, 21809,
     /* 1073153 */     GIR_EraseRootFromParent_Done,
     /* 1073154 */   // Label 15821: @1073154
     /* 1073154 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1073231), // Rule ID 21812 //
     /* 1073159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1073176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073198 */     // MIs[0] policy
     /* 1073198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073230 */     // GIR_Coverage, 21812,
     /* 1073230 */     GIR_EraseRootFromParent_Done,
     /* 1073231 */   // Label 15822: @1073231
     /* 1073231 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1073308), // Rule ID 21813 //
     /* 1073236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1073253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073275 */     // MIs[0] policy
     /* 1073275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073307 */     // GIR_Coverage, 21813,
     /* 1073307 */     GIR_EraseRootFromParent_Done,
     /* 1073308 */   // Label 15823: @1073308
     /* 1073308 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1073385), // Rule ID 21816 //
     /* 1073313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1073316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1073330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073352 */     // MIs[0] policy
     /* 1073352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073384 */     // GIR_Coverage, 21816,
     /* 1073384 */     GIR_EraseRootFromParent_Done,
     /* 1073385 */   // Label 15824: @1073385
     /* 1073385 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1073462), // Rule ID 21817 //
     /* 1073390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1073393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1073407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073429 */     // MIs[0] policy
     /* 1073429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073461 */     // GIR_Coverage, 21817,
     /* 1073461 */     GIR_EraseRootFromParent_Done,
     /* 1073462 */   // Label 15825: @1073462
     /* 1073462 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1073539), // Rule ID 21820 //
     /* 1073467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1073484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073506 */     // MIs[0] policy
     /* 1073506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073516 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1073519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073538 */     // GIR_Coverage, 21820,
     /* 1073538 */     GIR_EraseRootFromParent_Done,
     /* 1073539 */   // Label 15826: @1073539
     /* 1073539 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1073616), // Rule ID 21821 //
     /* 1073544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1073555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1073558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1073561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1073564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073583 */     // MIs[0] policy
     /* 1073583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073593 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1073596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073615 */     // GIR_Coverage, 21821,
     /* 1073615 */     GIR_EraseRootFromParent_Done,
     /* 1073616 */   // Label 15827: @1073616
     /* 1073616 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1073693), // Rule ID 21824 //
     /* 1073621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1073638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073660 */     // MIs[0] policy
     /* 1073660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073692 */     // GIR_Coverage, 21824,
     /* 1073692 */     GIR_EraseRootFromParent_Done,
     /* 1073693 */   // Label 15828: @1073693
     /* 1073693 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1073770), // Rule ID 21825 //
     /* 1073698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1073709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1073712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1073715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1073725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073737 */     // MIs[0] policy
     /* 1073737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11171:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1073750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073769 */     // GIR_Coverage, 21825,
     /* 1073769 */     GIR_EraseRootFromParent_Done,
     /* 1073770 */   // Label 15829: @1073770
     /* 1073770 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1073847), // Rule ID 21828 //
     /* 1073775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1073792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073814 */     // MIs[0] policy
     /* 1073814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073846 */     // GIR_Coverage, 21828,
     /* 1073846 */     GIR_EraseRootFromParent_Done,
     /* 1073847 */   // Label 15830: @1073847
     /* 1073847 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1073924), // Rule ID 21829 //
     /* 1073852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1073855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1073869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073891 */     // MIs[0] policy
     /* 1073891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073901 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1073904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073923 */     // GIR_Coverage, 21829,
     /* 1073923 */     GIR_EraseRootFromParent_Done,
     /* 1073924 */   // Label 15831: @1073924
     /* 1073924 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1074001), // Rule ID 21832 //
     /* 1073929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1073932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1073937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1073940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1073943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1073946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073968 */     // MIs[0] policy
     /* 1073968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1073981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074000 */     // GIR_Coverage, 21832,
     /* 1074000 */     GIR_EraseRootFromParent_Done,
     /* 1074001 */   // Label 15832: @1074001
     /* 1074001 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1074078), // Rule ID 21833 //
     /* 1074006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1074009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1074014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1074023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074045 */     // MIs[0] policy
     /* 1074045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074055 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1074058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074077 */     // GIR_Coverage, 21833,
     /* 1074077 */     GIR_EraseRootFromParent_Done,
     /* 1074078 */   // Label 15833: @1074078
     /* 1074078 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1074155), // Rule ID 21944 //
     /* 1074083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1074100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074122 */     // MIs[0] policy
     /* 1074122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074132 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1074135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074154 */     // GIR_Coverage, 21944,
     /* 1074154 */     GIR_EraseRootFromParent_Done,
     /* 1074155 */   // Label 15834: @1074155
     /* 1074155 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1074232), // Rule ID 21945 //
     /* 1074160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1074177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074199 */     // MIs[0] policy
     /* 1074199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074209 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1074212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074231 */     // GIR_Coverage, 21945,
     /* 1074231 */     GIR_EraseRootFromParent_Done,
     /* 1074232 */   // Label 15835: @1074232
     /* 1074232 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1074309), // Rule ID 21948 //
     /* 1074237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1074248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1074251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1074254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074276 */     // MIs[0] policy
     /* 1074276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074286 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1074289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074308 */     // GIR_Coverage, 21948,
     /* 1074308 */     GIR_EraseRootFromParent_Done,
     /* 1074309 */   // Label 15836: @1074309
     /* 1074309 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1074386), // Rule ID 21949 //
     /* 1074314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1074325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1074328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1074331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074353 */     // MIs[0] policy
     /* 1074353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074363 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1074366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074385 */     // GIR_Coverage, 21949,
     /* 1074385 */     GIR_EraseRootFromParent_Done,
     /* 1074386 */   // Label 15837: @1074386
     /* 1074386 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1074463), // Rule ID 21952 //
     /* 1074391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1074402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1074405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1074408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074430 */     // MIs[0] policy
     /* 1074430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074440 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1074443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074462 */     // GIR_Coverage, 21952,
     /* 1074462 */     GIR_EraseRootFromParent_Done,
     /* 1074463 */   // Label 15838: @1074463
     /* 1074463 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1074540), // Rule ID 21953 //
     /* 1074468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1074479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1074482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1074485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074507 */     // MIs[0] policy
     /* 1074507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074517 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1074520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074539 */     // GIR_Coverage, 21953,
     /* 1074539 */     GIR_EraseRootFromParent_Done,
     /* 1074540 */   // Label 15839: @1074540
     /* 1074540 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1074617), // Rule ID 21956 //
     /* 1074545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1074562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074584 */     // MIs[0] policy
     /* 1074584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074594 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1074597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074616 */     // GIR_Coverage, 21956,
     /* 1074616 */     GIR_EraseRootFromParent_Done,
     /* 1074617 */   // Label 15840: @1074617
     /* 1074617 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1074694), // Rule ID 21957 //
     /* 1074622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1074633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1074636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1074639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074661 */     // MIs[0] policy
     /* 1074661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1074674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074693 */     // GIR_Coverage, 21957,
     /* 1074693 */     GIR_EraseRootFromParent_Done,
     /* 1074694 */   // Label 15841: @1074694
     /* 1074694 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1074771), // Rule ID 21960 //
     /* 1074699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1074702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1074716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074738 */     // MIs[0] policy
     /* 1074738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074748 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1074751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074770 */     // GIR_Coverage, 21960,
     /* 1074770 */     GIR_EraseRootFromParent_Done,
     /* 1074771 */   // Label 15842: @1074771
     /* 1074771 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1074848), // Rule ID 21961 //
     /* 1074776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1074779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1074787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1074790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1074793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074815 */     // MIs[0] policy
     /* 1074815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074825 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1074828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074847 */     // GIR_Coverage, 21961,
     /* 1074847 */     GIR_EraseRootFromParent_Done,
     /* 1074848 */   // Label 15843: @1074848
     /* 1074848 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1074925), // Rule ID 21964 //
     /* 1074853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1074856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1074864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1074867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074892 */     // MIs[0] policy
     /* 1074892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074902 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1074905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074924 */     // GIR_Coverage, 21964,
     /* 1074924 */     GIR_EraseRootFromParent_Done,
     /* 1074925 */   // Label 15844: @1074925
     /* 1074925 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1075002), // Rule ID 21965 //
     /* 1074930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1074933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1074938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1074941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1074944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1074947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1074950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1074957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074969 */     // MIs[0] policy
     /* 1074969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074979 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1074982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075001 */     // GIR_Coverage, 21965,
     /* 1075001 */     GIR_EraseRootFromParent_Done,
     /* 1075002 */   // Label 15845: @1075002
     /* 1075002 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1075079), // Rule ID 21968 //
     /* 1075007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075046 */     // MIs[0] policy
     /* 1075046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1075059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075078 */     // GIR_Coverage, 21968,
     /* 1075078 */     GIR_EraseRootFromParent_Done,
     /* 1075079 */   // Label 15846: @1075079
     /* 1075079 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1075156), // Rule ID 21969 //
     /* 1075084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1075101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075123 */     // MIs[0] policy
     /* 1075123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075133 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1075136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075155 */     // GIR_Coverage, 21969,
     /* 1075155 */     GIR_EraseRootFromParent_Done,
     /* 1075156 */   // Label 15847: @1075156
     /* 1075156 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1075233), // Rule ID 21972 //
     /* 1075161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1075188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075200 */     // MIs[0] policy
     /* 1075200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075210 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1075213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075232 */     // GIR_Coverage, 21972,
     /* 1075232 */     GIR_EraseRootFromParent_Done,
     /* 1075233 */   // Label 15848: @1075233
     /* 1075233 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1075310), // Rule ID 21973 //
     /* 1075238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1075249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1075252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1075255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1075265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075277 */     // MIs[0] policy
     /* 1075277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075287 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1075290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075309 */     // GIR_Coverage, 21973,
     /* 1075309 */     GIR_EraseRootFromParent_Done,
     /* 1075310 */   // Label 15849: @1075310
     /* 1075310 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1075387), // Rule ID 21976 //
     /* 1075315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1075318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1075332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075354 */     // MIs[0] policy
     /* 1075354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075364 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1075367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075386 */     // GIR_Coverage, 21976,
     /* 1075386 */     GIR_EraseRootFromParent_Done,
     /* 1075387 */   // Label 15850: @1075387
     /* 1075387 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1075464), // Rule ID 21977 //
     /* 1075392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1075395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1075400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1075403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1075406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1075409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1075412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1075419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1075423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1075427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075431 */     // MIs[0] policy
     /* 1075431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075441 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1075444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075463 */     // GIR_Coverage, 21977,
     /* 1075463 */     GIR_EraseRootFromParent_Done,
     /* 1075464 */   // Label 15851: @1075464
     /* 1075464 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1075541), // Rule ID 23416 //
     /* 1075469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075508 */     // MIs[0] policy
     /* 1075508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075518 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075540 */     // GIR_Coverage, 23416,
     /* 1075540 */     GIR_EraseRootFromParent_Done,
     /* 1075541 */   // Label 15852: @1075541
     /* 1075541 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1075618), // Rule ID 23417 //
     /* 1075546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075585 */     // MIs[0] policy
     /* 1075585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075595 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075617 */     // GIR_Coverage, 23417,
     /* 1075617 */     GIR_EraseRootFromParent_Done,
     /* 1075618 */   // Label 15853: @1075618
     /* 1075618 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1075695), // Rule ID 23420 //
     /* 1075623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075662 */     // MIs[0] policy
     /* 1075662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075694 */     // GIR_Coverage, 23420,
     /* 1075694 */     GIR_EraseRootFromParent_Done,
     /* 1075695 */   // Label 15854: @1075695
     /* 1075695 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1075772), // Rule ID 23421 //
     /* 1075700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1075717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1075720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075739 */     // MIs[0] policy
     /* 1075739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075749 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075771 */     // GIR_Coverage, 23421,
     /* 1075771 */     GIR_EraseRootFromParent_Done,
     /* 1075772 */   // Label 15855: @1075772
     /* 1075772 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1075849), // Rule ID 23424 //
     /* 1075777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1075794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1075797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075816 */     // MIs[0] policy
     /* 1075816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075848 */     // GIR_Coverage, 23424,
     /* 1075848 */     GIR_EraseRootFromParent_Done,
     /* 1075849 */   // Label 15856: @1075849
     /* 1075849 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1075926), // Rule ID 23425 //
     /* 1075854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1075871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1075874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075893 */     // MIs[0] policy
     /* 1075893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075903 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1075906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075925 */     // GIR_Coverage, 23425,
     /* 1075925 */     GIR_EraseRootFromParent_Done,
     /* 1075926 */   // Label 15857: @1075926
     /* 1075926 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1076003), // Rule ID 23428 //
     /* 1075931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1075939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1075948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1075951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1075958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1075970 */     // MIs[0] policy
     /* 1075970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1075983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1075987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1075989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1075991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076002 */     // GIR_Coverage, 23428,
     /* 1076002 */     GIR_EraseRootFromParent_Done,
     /* 1076003 */   // Label 15858: @1076003
     /* 1076003 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1076080), // Rule ID 23429 //
     /* 1076008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1076019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1076022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076047 */     // MIs[0] policy
     /* 1076047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076057 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076079 */     // GIR_Coverage, 23429,
     /* 1076079 */     GIR_EraseRootFromParent_Done,
     /* 1076080 */   // Label 15859: @1076080
     /* 1076080 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1076157), // Rule ID 23432 //
     /* 1076085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076124 */     // MIs[0] policy
     /* 1076124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076156 */     // GIR_Coverage, 23432,
     /* 1076156 */     GIR_EraseRootFromParent_Done,
     /* 1076157 */   // Label 15860: @1076157
     /* 1076157 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1076234), // Rule ID 23433 //
     /* 1076162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1076173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1076176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076201 */     // MIs[0] policy
     /* 1076201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1076214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076233 */     // GIR_Coverage, 23433,
     /* 1076233 */     GIR_EraseRootFromParent_Done,
     /* 1076234 */   // Label 15861: @1076234
     /* 1076234 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1076311), // Rule ID 23436 //
     /* 1076239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1076256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1076259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076278 */     // MIs[0] policy
     /* 1076278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076310 */     // GIR_Coverage, 23436,
     /* 1076310 */     GIR_EraseRootFromParent_Done,
     /* 1076311 */   // Label 15862: @1076311
     /* 1076311 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1076388), // Rule ID 23437 //
     /* 1076316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1076327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1076330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1076333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1076336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076355 */     // MIs[0] policy
     /* 1076355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11263:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076387 */     // GIR_Coverage, 23437,
     /* 1076387 */     GIR_EraseRootFromParent_Done,
     /* 1076388 */   // Label 15863: @1076388
     /* 1076388 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1076465), // Rule ID 23440 //
     /* 1076393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1076410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1076413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076432 */     // MIs[0] policy
     /* 1076432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076442 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076464 */     // GIR_Coverage, 23440,
     /* 1076464 */     GIR_EraseRootFromParent_Done,
     /* 1076465 */   // Label 15864: @1076465
     /* 1076465 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1076542), // Rule ID 23441 //
     /* 1076470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1076487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1076490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076509 */     // MIs[0] policy
     /* 1076509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076519 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076541 */     // GIR_Coverage, 23441,
     /* 1076541 */     GIR_EraseRootFromParent_Done,
     /* 1076542 */   // Label 15865: @1076542
     /* 1076542 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1076619), // Rule ID 23444 //
     /* 1076547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076586 */     // MIs[0] policy
     /* 1076586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076618 */     // GIR_Coverage, 23444,
     /* 1076618 */     GIR_EraseRootFromParent_Done,
     /* 1076619 */   // Label 15866: @1076619
     /* 1076619 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1076696), // Rule ID 23445 //
     /* 1076624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1076641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1076644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076663 */     // MIs[0] policy
     /* 1076663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076673 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076695 */     // GIR_Coverage, 23445,
     /* 1076695 */     GIR_EraseRootFromParent_Done,
     /* 1076696 */   // Label 15867: @1076696
     /* 1076696 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1076773), // Rule ID 23448 //
     /* 1076701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076740 */     // MIs[0] policy
     /* 1076740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076772 */     // GIR_Coverage, 23448,
     /* 1076772 */     GIR_EraseRootFromParent_Done,
     /* 1076773 */   // Label 15868: @1076773
     /* 1076773 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1076850), // Rule ID 23449 //
     /* 1076778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1076795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1076798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1076805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076817 */     // MIs[0] policy
     /* 1076817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1076830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076849 */     // GIR_Coverage, 23449,
     /* 1076849 */     GIR_EraseRootFromParent_Done,
     /* 1076850 */   // Label 15869: @1076850
     /* 1076850 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1076927), // Rule ID 23452 //
     /* 1076855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1076872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1076875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1076882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076894 */     // MIs[0] policy
     /* 1076894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1076907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076926 */     // GIR_Coverage, 23452,
     /* 1076926 */     GIR_EraseRootFromParent_Done,
     /* 1076927 */   // Label 15870: @1076927
     /* 1076927 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1077004), // Rule ID 23453 //
     /* 1076932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1076940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1076949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1076952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1076959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1076971 */     // MIs[0] policy
     /* 1076971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076981 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1076984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1076988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1076990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1076992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077003 */     // GIR_Coverage, 23453,
     /* 1077003 */     GIR_EraseRootFromParent_Done,
     /* 1077004 */   // Label 15871: @1077004
     /* 1077004 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1077081), // Rule ID 23456 //
     /* 1077009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077048 */     // MIs[0] policy
     /* 1077048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077080 */     // GIR_Coverage, 23456,
     /* 1077080 */     GIR_EraseRootFromParent_Done,
     /* 1077081 */   // Label 15872: @1077081
     /* 1077081 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1077158), // Rule ID 23457 //
     /* 1077086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1077097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1077100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077125 */     // MIs[0] policy
     /* 1077125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077135 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077157 */     // GIR_Coverage, 23457,
     /* 1077157 */     GIR_EraseRootFromParent_Done,
     /* 1077158 */   // Label 15873: @1077158
     /* 1077158 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1077235), // Rule ID 23460 //
     /* 1077163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1077180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1077183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077202 */     // MIs[0] policy
     /* 1077202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077234 */     // GIR_Coverage, 23460,
     /* 1077234 */     GIR_EraseRootFromParent_Done,
     /* 1077235 */   // Label 15874: @1077235
     /* 1077235 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1077312), // Rule ID 23461 //
     /* 1077240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1077251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1077254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1077257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1077260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077279 */     // MIs[0] policy
     /* 1077279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077289 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077311 */     // GIR_Coverage, 23461,
     /* 1077311 */     GIR_EraseRootFromParent_Done,
     /* 1077312 */   // Label 15875: @1077312
     /* 1077312 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1077389), // Rule ID 23464 //
     /* 1077317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077356 */     // MIs[0] policy
     /* 1077356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077388 */     // GIR_Coverage, 23464,
     /* 1077388 */     GIR_EraseRootFromParent_Done,
     /* 1077389 */   // Label 15876: @1077389
     /* 1077389 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1077466), // Rule ID 23465 //
     /* 1077394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1077405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1077408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077433 */     // MIs[0] policy
     /* 1077433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077465 */     // GIR_Coverage, 23465,
     /* 1077465 */     GIR_EraseRootFromParent_Done,
     /* 1077466 */   // Label 15877: @1077466
     /* 1077466 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1077543), // Rule ID 23468 //
     /* 1077471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1077488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1077491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077510 */     // MIs[0] policy
     /* 1077510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077542 */     // GIR_Coverage, 23468,
     /* 1077542 */     GIR_EraseRootFromParent_Done,
     /* 1077543 */   // Label 15878: @1077543
     /* 1077543 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1077620), // Rule ID 23469 //
     /* 1077548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1077565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1077568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077587 */     // MIs[0] policy
     /* 1077587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077597 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077619 */     // GIR_Coverage, 23469,
     /* 1077619 */     GIR_EraseRootFromParent_Done,
     /* 1077620 */   // Label 15879: @1077620
     /* 1077620 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1077697), // Rule ID 23472 //
     /* 1077625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077664 */     // MIs[0] policy
     /* 1077664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077696 */     // GIR_Coverage, 23472,
     /* 1077696 */     GIR_EraseRootFromParent_Done,
     /* 1077697 */   // Label 15880: @1077697
     /* 1077697 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1077774), // Rule ID 23473 //
     /* 1077702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1077719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1077722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1077729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077741 */     // MIs[0] policy
     /* 1077741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077751 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1077754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077773 */     // GIR_Coverage, 23473,
     /* 1077773 */     GIR_EraseRootFromParent_Done,
     /* 1077774 */   // Label 15881: @1077774
     /* 1077774 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1077851), // Rule ID 23476 //
     /* 1077779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1077796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1077799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077818 */     // MIs[0] policy
     /* 1077818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077850 */     // GIR_Coverage, 23476,
     /* 1077850 */     GIR_EraseRootFromParent_Done,
     /* 1077851 */   // Label 15882: @1077851
     /* 1077851 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1077928), // Rule ID 23477 //
     /* 1077856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1077873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1077876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1077883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077895 */     // MIs[0] policy
     /* 1077895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1077908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077927 */     // GIR_Coverage, 23477,
     /* 1077927 */     GIR_EraseRootFromParent_Done,
     /* 1077928 */   // Label 15883: @1077928
     /* 1077928 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1078005), // Rule ID 23480 //
     /* 1077933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1077941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1077950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1077953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1077960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1077972 */     // MIs[0] policy
     /* 1077972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1077985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1077989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1077991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1077993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078004 */     // GIR_Coverage, 23480,
     /* 1078004 */     GIR_EraseRootFromParent_Done,
     /* 1078005 */   // Label 15884: @1078005
     /* 1078005 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1078082), // Rule ID 23481 //
     /* 1078010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1078021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1078024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078049 */     // MIs[0] policy
     /* 1078049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078059 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078081 */     // GIR_Coverage, 23481,
     /* 1078081 */     GIR_EraseRootFromParent_Done,
     /* 1078082 */   // Label 15885: @1078082
     /* 1078082 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1078159), // Rule ID 23484 //
     /* 1078087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1078104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1078107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078126 */     // MIs[0] policy
     /* 1078126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078136 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078158 */     // GIR_Coverage, 23484,
     /* 1078158 */     GIR_EraseRootFromParent_Done,
     /* 1078159 */   // Label 15886: @1078159
     /* 1078159 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1078236), // Rule ID 23485 //
     /* 1078164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1078175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1078178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1078181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1078184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078203 */     // MIs[0] policy
     /* 1078203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078213 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078235 */     // GIR_Coverage, 23485,
     /* 1078235 */     GIR_EraseRootFromParent_Done,
     /* 1078236 */   // Label 15887: @1078236
     /* 1078236 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1078313), // Rule ID 23488 //
     /* 1078241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1078258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1078261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1078268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078280 */     // MIs[0] policy
     /* 1078280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1078293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078312 */     // GIR_Coverage, 23488,
     /* 1078312 */     GIR_EraseRootFromParent_Done,
     /* 1078313 */   // Label 15888: @1078313
     /* 1078313 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1078390), // Rule ID 23489 //
     /* 1078318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1078329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1078332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1078335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1078338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1078345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1078349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078357 */     // MIs[0] policy
     /* 1078357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1078370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078389 */     // GIR_Coverage, 23489,
     /* 1078389 */     GIR_EraseRootFromParent_Done,
     /* 1078390 */   // Label 15889: @1078390
     /* 1078390 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1078467), // Rule ID 23492 //
     /* 1078395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1078412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1078415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078434 */     // MIs[0] policy
     /* 1078434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078466 */     // GIR_Coverage, 23492,
     /* 1078466 */     GIR_EraseRootFromParent_Done,
     /* 1078467 */   // Label 15890: @1078467
     /* 1078467 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1078544), // Rule ID 23493 //
     /* 1078472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1078489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1078492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1078499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078511 */     // MIs[0] policy
     /* 1078511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078521 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1078524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078543 */     // GIR_Coverage, 23493,
     /* 1078543 */     GIR_EraseRootFromParent_Done,
     /* 1078544 */   // Label 15891: @1078544
     /* 1078544 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1078621), // Rule ID 23496 //
     /* 1078549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078588 */     // MIs[0] policy
     /* 1078588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078620 */     // GIR_Coverage, 23496,
     /* 1078620 */     GIR_EraseRootFromParent_Done,
     /* 1078621 */   // Label 15892: @1078621
     /* 1078621 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1078698), // Rule ID 23497 //
     /* 1078626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1078634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1078643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1078646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1078653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1078665 */     // MIs[0] policy
     /* 1078665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078675 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1078678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1078682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1078684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1078686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078697 */     // GIR_Coverage, 23497,
     /* 1078697 */     GIR_EraseRootFromParent_Done,
     /* 1078698 */   // Label 15893: @1078698
     /* 1078698 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1078775), // Rule ID 23602 //
     /* 1078703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078742 */     // MIs[0] policy
     /* 1078742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1078755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078774 */     // GIR_Coverage, 23602,
     /* 1078774 */     GIR_EraseRootFromParent_Done,
     /* 1078775 */   // Label 15894: @1078775
     /* 1078775 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1078852), // Rule ID 23603 //
     /* 1078780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078819 */     // MIs[0] policy
     /* 1078819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078829 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1078832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078851 */     // GIR_Coverage, 23603,
     /* 1078851 */     GIR_EraseRootFromParent_Done,
     /* 1078852 */   // Label 15895: @1078852
     /* 1078852 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1078929), // Rule ID 23606 //
     /* 1078857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078896 */     // MIs[0] policy
     /* 1078896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1078909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078928 */     // GIR_Coverage, 23606,
     /* 1078928 */     GIR_EraseRootFromParent_Done,
     /* 1078929 */   // Label 15896: @1078929
     /* 1078929 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1079006), // Rule ID 23607 //
     /* 1078934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078973 */     // MIs[0] policy
     /* 1078973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1078986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079005 */     // GIR_Coverage, 23607,
     /* 1079005 */     GIR_EraseRootFromParent_Done,
     /* 1079006 */   // Label 15897: @1079006
     /* 1079006 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1079083), // Rule ID 23610 //
     /* 1079011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079050 */     // MIs[0] policy
     /* 1079050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079082 */     // GIR_Coverage, 23610,
     /* 1079082 */     GIR_EraseRootFromParent_Done,
     /* 1079083 */   // Label 15898: @1079083
     /* 1079083 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1079160), // Rule ID 23611 //
     /* 1079088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1079099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1079102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1079105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079127 */     // MIs[0] policy
     /* 1079127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079137 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079159 */     // GIR_Coverage, 23611,
     /* 1079159 */     GIR_EraseRootFromParent_Done,
     /* 1079160 */   // Label 15899: @1079160
     /* 1079160 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1079237), // Rule ID 23614 //
     /* 1079165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079204 */     // MIs[0] policy
     /* 1079204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1079217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079236 */     // GIR_Coverage, 23614,
     /* 1079236 */     GIR_EraseRootFromParent_Done,
     /* 1079237 */   // Label 15900: @1079237
     /* 1079237 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1079314), // Rule ID 23615 //
     /* 1079242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1079253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1079256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1079259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079281 */     // MIs[0] policy
     /* 1079281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1079294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079313 */     // GIR_Coverage, 23615,
     /* 1079313 */     GIR_EraseRootFromParent_Done,
     /* 1079314 */   // Label 15901: @1079314
     /* 1079314 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1079391), // Rule ID 23618 //
     /* 1079319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079358 */     // MIs[0] policy
     /* 1079358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079390 */     // GIR_Coverage, 23618,
     /* 1079390 */     GIR_EraseRootFromParent_Done,
     /* 1079391 */   // Label 15902: @1079391
     /* 1079391 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1079468), // Rule ID 23619 //
     /* 1079396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1079407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1079410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1079413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079435 */     // MIs[0] policy
     /* 1079435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079467 */     // GIR_Coverage, 23619,
     /* 1079467 */     GIR_EraseRootFromParent_Done,
     /* 1079468 */   // Label 15903: @1079468
     /* 1079468 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1079545), // Rule ID 23622 //
     /* 1079473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079512 */     // MIs[0] policy
     /* 1079512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079522 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079544 */     // GIR_Coverage, 23622,
     /* 1079544 */     GIR_EraseRootFromParent_Done,
     /* 1079545 */   // Label 15904: @1079545
     /* 1079545 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1079622), // Rule ID 23623 //
     /* 1079550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079589 */     // MIs[0] policy
     /* 1079589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079599 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1079602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079621 */     // GIR_Coverage, 23623,
     /* 1079621 */     GIR_EraseRootFromParent_Done,
     /* 1079622 */   // Label 15905: @1079622
     /* 1079622 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1079699), // Rule ID 23626 //
     /* 1079627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079666 */     // MIs[0] policy
     /* 1079666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079698 */     // GIR_Coverage, 23626,
     /* 1079698 */     GIR_EraseRootFromParent_Done,
     /* 1079699 */   // Label 15906: @1079699
     /* 1079699 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1079776), // Rule ID 23627 //
     /* 1079704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079743 */     // MIs[0] policy
     /* 1079743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079753 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079775 */     // GIR_Coverage, 23627,
     /* 1079775 */     GIR_EraseRootFromParent_Done,
     /* 1079776 */   // Label 15907: @1079776
     /* 1079776 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1079853), // Rule ID 23630 //
     /* 1079781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079820 */     // MIs[0] policy
     /* 1079820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079852 */     // GIR_Coverage, 23630,
     /* 1079852 */     GIR_EraseRootFromParent_Done,
     /* 1079853 */   // Label 15908: @1079853
     /* 1079853 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1079930), // Rule ID 23631 //
     /* 1079858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079897 */     // MIs[0] policy
     /* 1079897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079907 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079929 */     // GIR_Coverage, 23631,
     /* 1079929 */     GIR_EraseRootFromParent_Done,
     /* 1079930 */   // Label 15909: @1079930
     /* 1079930 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1080007), // Rule ID 23634 //
     /* 1079935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1079943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079974 */     // MIs[0] policy
     /* 1079974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1079987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080006 */     // GIR_Coverage, 23634,
     /* 1080006 */     GIR_EraseRootFromParent_Done,
     /* 1080007 */   // Label 15910: @1080007
     /* 1080007 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1080084), // Rule ID 23635 //
     /* 1080012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1080023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1080026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1080029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080051 */     // MIs[0] policy
     /* 1080051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080083 */     // GIR_Coverage, 23635,
     /* 1080083 */     GIR_EraseRootFromParent_Done,
     /* 1080084 */   // Label 15911: @1080084
     /* 1080084 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1080161), // Rule ID 23638 //
     /* 1080089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080128 */     // MIs[0] policy
     /* 1080128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080160 */     // GIR_Coverage, 23638,
     /* 1080160 */     GIR_EraseRootFromParent_Done,
     /* 1080161 */   // Label 15912: @1080161
     /* 1080161 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1080238), // Rule ID 23639 //
     /* 1080166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1080177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1080180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1080183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1080201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080205 */     // MIs[0] policy
     /* 1080205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1080218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080237 */     // GIR_Coverage, 23639,
     /* 1080237 */     GIR_EraseRootFromParent_Done,
     /* 1080238 */   // Label 15913: @1080238
     /* 1080238 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1080315), // Rule ID 23642 //
     /* 1080243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080282 */     // MIs[0] policy
     /* 1080282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080314 */     // GIR_Coverage, 23642,
     /* 1080314 */     GIR_EraseRootFromParent_Done,
     /* 1080315 */   // Label 15914: @1080315
     /* 1080315 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1080392), // Rule ID 23643 //
     /* 1080320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1080331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1080334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1080337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080359 */     // MIs[0] policy
     /* 1080359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080369 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080391 */     // GIR_Coverage, 23643,
     /* 1080391 */     GIR_EraseRootFromParent_Done,
     /* 1080392 */   // Label 15915: @1080392
     /* 1080392 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1080469), // Rule ID 23646 //
     /* 1080397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080436 */     // MIs[0] policy
     /* 1080436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080468 */     // GIR_Coverage, 23646,
     /* 1080468 */     GIR_EraseRootFromParent_Done,
     /* 1080469 */   // Label 15916: @1080469
     /* 1080469 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1080546), // Rule ID 23647 //
     /* 1080474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080513 */     // MIs[0] policy
     /* 1080513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080523 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080545 */     // GIR_Coverage, 23647,
     /* 1080545 */     GIR_EraseRootFromParent_Done,
     /* 1080546 */   // Label 15917: @1080546
     /* 1080546 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1080623), // Rule ID 23650 //
     /* 1080551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080590 */     // MIs[0] policy
     /* 1080590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1080603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080622 */     // GIR_Coverage, 23650,
     /* 1080622 */     GIR_EraseRootFromParent_Done,
     /* 1080623 */   // Label 15918: @1080623
     /* 1080623 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1080700), // Rule ID 23651 //
     /* 1080628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080667 */     // MIs[0] policy
     /* 1080667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080677 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1080680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080699 */     // GIR_Coverage, 23651,
     /* 1080699 */     GIR_EraseRootFromParent_Done,
     /* 1080700 */   // Label 15919: @1080700
     /* 1080700 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1080777), // Rule ID 23654 //
     /* 1080705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080744 */     // MIs[0] policy
     /* 1080744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080776 */     // GIR_Coverage, 23654,
     /* 1080776 */     GIR_EraseRootFromParent_Done,
     /* 1080777 */   // Label 15920: @1080777
     /* 1080777 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1080854), // Rule ID 23655 //
     /* 1080782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080821 */     // MIs[0] policy
     /* 1080821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1080834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080853 */     // GIR_Coverage, 23655,
     /* 1080853 */     GIR_EraseRootFromParent_Done,
     /* 1080854 */   // Label 15921: @1080854
     /* 1080854 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1080931), // Rule ID 23658 //
     /* 1080859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080898 */     // MIs[0] policy
     /* 1080898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080930 */     // GIR_Coverage, 23658,
     /* 1080930 */     GIR_EraseRootFromParent_Done,
     /* 1080931 */   // Label 15922: @1080931
     /* 1080931 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1081008), // Rule ID 23659 //
     /* 1080936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1080944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080975 */     // MIs[0] policy
     /* 1080975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080985 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1080988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081007 */     // GIR_Coverage, 23659,
     /* 1081007 */     GIR_EraseRootFromParent_Done,
     /* 1081008 */   // Label 15923: @1081008
     /* 1081008 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1081085), // Rule ID 23662 //
     /* 1081013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081052 */     // MIs[0] policy
     /* 1081052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081084 */     // GIR_Coverage, 23662,
     /* 1081084 */     GIR_EraseRootFromParent_Done,
     /* 1081085 */   // Label 15924: @1081085
     /* 1081085 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1081162), // Rule ID 23663 //
     /* 1081090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1081101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1081104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1081107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081129 */     // MIs[0] policy
     /* 1081129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081139 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081161 */     // GIR_Coverage, 23663,
     /* 1081161 */     GIR_EraseRootFromParent_Done,
     /* 1081162 */   // Label 15925: @1081162
     /* 1081162 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1081239), // Rule ID 23666 //
     /* 1081167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081206 */     // MIs[0] policy
     /* 1081206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081238 */     // GIR_Coverage, 23666,
     /* 1081238 */     GIR_EraseRootFromParent_Done,
     /* 1081239 */   // Label 15926: @1081239
     /* 1081239 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1081316), // Rule ID 23667 //
     /* 1081244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1081255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1081258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1081261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081283 */     // MIs[0] policy
     /* 1081283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081315 */     // GIR_Coverage, 23667,
     /* 1081315 */     GIR_EraseRootFromParent_Done,
     /* 1081316 */   // Label 15927: @1081316
     /* 1081316 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1081393), // Rule ID 23670 //
     /* 1081321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081360 */     // MIs[0] policy
     /* 1081360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081392 */     // GIR_Coverage, 23670,
     /* 1081392 */     GIR_EraseRootFromParent_Done,
     /* 1081393 */   // Label 15928: @1081393
     /* 1081393 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1081470), // Rule ID 23671 //
     /* 1081398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1081409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1081412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1081415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081437 */     // MIs[0] policy
     /* 1081437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081447 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081469 */     // GIR_Coverage, 23671,
     /* 1081469 */     GIR_EraseRootFromParent_Done,
     /* 1081470 */   // Label 15929: @1081470
     /* 1081470 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1081547), // Rule ID 23674 //
     /* 1081475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081514 */     // MIs[0] policy
     /* 1081514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081546 */     // GIR_Coverage, 23674,
     /* 1081546 */     GIR_EraseRootFromParent_Done,
     /* 1081547 */   // Label 15930: @1081547
     /* 1081547 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1081624), // Rule ID 23675 //
     /* 1081552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081591 */     // MIs[0] policy
     /* 1081591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081623 */     // GIR_Coverage, 23675,
     /* 1081623 */     GIR_EraseRootFromParent_Done,
     /* 1081624 */   // Label 15931: @1081624
     /* 1081624 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1081701), // Rule ID 23678 //
     /* 1081629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081668 */     // MIs[0] policy
     /* 1081668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081700 */     // GIR_Coverage, 23678,
     /* 1081700 */     GIR_EraseRootFromParent_Done,
     /* 1081701 */   // Label 15932: @1081701
     /* 1081701 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1081778), // Rule ID 23679 //
     /* 1081706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081745 */     // MIs[0] policy
     /* 1081745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1081758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081777 */     // GIR_Coverage, 23679,
     /* 1081777 */     GIR_EraseRootFromParent_Done,
     /* 1081778 */   // Label 15933: @1081778
     /* 1081778 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1081855), // Rule ID 23682 //
     /* 1081783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081822 */     // MIs[0] policy
     /* 1081822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081854 */     // GIR_Coverage, 23682,
     /* 1081854 */     GIR_EraseRootFromParent_Done,
     /* 1081855 */   // Label 15934: @1081855
     /* 1081855 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1081932), // Rule ID 23683 //
     /* 1081860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081899 */     // MIs[0] policy
     /* 1081899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1081912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081931 */     // GIR_Coverage, 23683,
     /* 1081931 */     GIR_EraseRootFromParent_Done,
     /* 1081932 */   // Label 15935: @1081932
     /* 1081932 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1082009), // Rule ID 23686 //
     /* 1081937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081976 */     // MIs[0] policy
     /* 1081976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1081989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082008 */     // GIR_Coverage, 23686,
     /* 1082008 */     GIR_EraseRootFromParent_Done,
     /* 1082009 */   // Label 15936: @1082009
     /* 1082009 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1082086), // Rule ID 23687 //
     /* 1082014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1082017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1082025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1082028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1082031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082053 */     // MIs[0] policy
     /* 1082053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082063 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082085 */     // GIR_Coverage, 23687,
     /* 1082085 */     GIR_EraseRootFromParent_Done,
     /* 1082086 */   // Label 15937: @1082086
     /* 1082086 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1082163), // Rule ID 23778 //
     /* 1082091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1082108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082130 */     // MIs[0] policy
     /* 1082130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1082143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082162 */     // GIR_Coverage, 23778,
     /* 1082162 */     GIR_EraseRootFromParent_Done,
     /* 1082163 */   // Label 15938: @1082163
     /* 1082163 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1082240), // Rule ID 23779 //
     /* 1082168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1082179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1082182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1082185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082207 */     // MIs[0] policy
     /* 1082207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082217 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1082220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082239 */     // GIR_Coverage, 23779,
     /* 1082239 */     GIR_EraseRootFromParent_Done,
     /* 1082240 */   // Label 15939: @1082240
     /* 1082240 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1082317), // Rule ID 23782 //
     /* 1082245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1082262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082284 */     // MIs[0] policy
     /* 1082284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082316 */     // GIR_Coverage, 23782,
     /* 1082316 */     GIR_EraseRootFromParent_Done,
     /* 1082317 */   // Label 15940: @1082317
     /* 1082317 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1082394), // Rule ID 23783 //
     /* 1082322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1082333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1082336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1082339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082361 */     // MIs[0] policy
     /* 1082361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082371 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082393 */     // GIR_Coverage, 23783,
     /* 1082393 */     GIR_EraseRootFromParent_Done,
     /* 1082394 */   // Label 15941: @1082394
     /* 1082394 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1082471), // Rule ID 23786 //
     /* 1082399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1082416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082438 */     // MIs[0] policy
     /* 1082438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082448 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082470 */     // GIR_Coverage, 23786,
     /* 1082470 */     GIR_EraseRootFromParent_Done,
     /* 1082471 */   // Label 15942: @1082471
     /* 1082471 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1082548), // Rule ID 23787 //
     /* 1082476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1082487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1082490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1082493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082515 */     // MIs[0] policy
     /* 1082515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082525 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1082544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082547 */     // GIR_Coverage, 23787,
     /* 1082547 */     GIR_EraseRootFromParent_Done,
     /* 1082548 */   // Label 15943: @1082548
     /* 1082548 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1082625), // Rule ID 23790 //
     /* 1082553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082592 */     // MIs[0] policy
     /* 1082592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082624 */     // GIR_Coverage, 23790,
     /* 1082624 */     GIR_EraseRootFromParent_Done,
     /* 1082625 */   // Label 15944: @1082625
     /* 1082625 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1082702), // Rule ID 23791 //
     /* 1082630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1082641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1082644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1082647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082669 */     // MIs[0] policy
     /* 1082669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082679 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1082682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082701 */     // GIR_Coverage, 23791,
     /* 1082701 */     GIR_EraseRootFromParent_Done,
     /* 1082702 */   // Label 15945: @1082702
     /* 1082702 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1082779), // Rule ID 23794 //
     /* 1082707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082746 */     // MIs[0] policy
     /* 1082746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082778 */     // GIR_Coverage, 23794,
     /* 1082778 */     GIR_EraseRootFromParent_Done,
     /* 1082779 */   // Label 15946: @1082779
     /* 1082779 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1082856), // Rule ID 23795 //
     /* 1082784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1082795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1082798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1082801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082823 */     // MIs[0] policy
     /* 1082823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082855 */     // GIR_Coverage, 23795,
     /* 1082855 */     GIR_EraseRootFromParent_Done,
     /* 1082856 */   // Label 15947: @1082856
     /* 1082856 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1082933), // Rule ID 23798 //
     /* 1082861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1082864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082900 */     // MIs[0] policy
     /* 1082900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082932 */     // GIR_Coverage, 23798,
     /* 1082932 */     GIR_EraseRootFromParent_Done,
     /* 1082933 */   // Label 15948: @1082933
     /* 1082933 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1083010), // Rule ID 23799 //
     /* 1082938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1082941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1082946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082977 */     // MIs[0] policy
     /* 1082977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082987 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1082990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083009 */     // GIR_Coverage, 23799,
     /* 1083009 */     GIR_EraseRootFromParent_Done,
     /* 1083010 */   // Label 15949: @1083010
     /* 1083010 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1083087), // Rule ID 23802 //
     /* 1083015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1083026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1083029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1083032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083054 */     // MIs[0] policy
     /* 1083054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083086 */     // GIR_Coverage, 23802,
     /* 1083086 */     GIR_EraseRootFromParent_Done,
     /* 1083087 */   // Label 15950: @1083087
     /* 1083087 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1083164), // Rule ID 23803 //
     /* 1083092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1083103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1083106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1083109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083131 */     // MIs[0] policy
     /* 1083131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083141 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083163 */     // GIR_Coverage, 23803,
     /* 1083163 */     GIR_EraseRootFromParent_Done,
     /* 1083164 */   // Label 15951: @1083164
     /* 1083164 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1083241), // Rule ID 23806 //
     /* 1083169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083208 */     // MIs[0] policy
     /* 1083208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083240 */     // GIR_Coverage, 23806,
     /* 1083240 */     GIR_EraseRootFromParent_Done,
     /* 1083241 */   // Label 15952: @1083241
     /* 1083241 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1083318), // Rule ID 23807 //
     /* 1083246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083285 */     // MIs[0] policy
     /* 1083285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083295 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083317 */     // GIR_Coverage, 23807,
     /* 1083317 */     GIR_EraseRootFromParent_Done,
     /* 1083318 */   // Label 15953: @1083318
     /* 1083318 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1083395), // Rule ID 23810 //
     /* 1083323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1083334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1083337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083362 */     // MIs[0] policy
     /* 1083362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083394 */     // GIR_Coverage, 23810,
     /* 1083394 */     GIR_EraseRootFromParent_Done,
     /* 1083395 */   // Label 15954: @1083395
     /* 1083395 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1083472), // Rule ID 23811 //
     /* 1083400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1083411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1083414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1083417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083439 */     // MIs[0] policy
     /* 1083439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083471 */     // GIR_Coverage, 23811,
     /* 1083471 */     GIR_EraseRootFromParent_Done,
     /* 1083472 */   // Label 15955: @1083472
     /* 1083472 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1083549), // Rule ID 23814 //
     /* 1083477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1083480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1083488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1083491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1083494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083516 */     // MIs[0] policy
     /* 1083516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083548 */     // GIR_Coverage, 23814,
     /* 1083548 */     GIR_EraseRootFromParent_Done,
     /* 1083549 */   // Label 15956: @1083549
     /* 1083549 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1083626), // Rule ID 23815 //
     /* 1083554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1083557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1083565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1083568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1083571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083593 */     // MIs[0] policy
     /* 1083593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083603 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083625 */     // GIR_Coverage, 23815,
     /* 1083625 */     GIR_EraseRootFromParent_Done,
     /* 1083626 */   // Label 15957: @1083626
     /* 1083626 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1083703), // Rule ID 23818 //
     /* 1083631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1083642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1083645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1083648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083670 */     // MIs[0] policy
     /* 1083670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1083683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083702 */     // GIR_Coverage, 23818,
     /* 1083702 */     GIR_EraseRootFromParent_Done,
     /* 1083703 */   // Label 15958: @1083703
     /* 1083703 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1083780), // Rule ID 23819 //
     /* 1083708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1083719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1083722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1083725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083747 */     // MIs[0] policy
     /* 1083747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1083760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083779 */     // GIR_Coverage, 23819,
     /* 1083779 */     GIR_EraseRootFromParent_Done,
     /* 1083780 */   // Label 15959: @1083780
     /* 1083780 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1083857), // Rule ID 23822 //
     /* 1083785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1083796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1083799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1083802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083824 */     // MIs[0] policy
     /* 1083824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1083837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083856 */     // GIR_Coverage, 23822,
     /* 1083856 */     GIR_EraseRootFromParent_Done,
     /* 1083857 */   // Label 15960: @1083857
     /* 1083857 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1083934), // Rule ID 23823 //
     /* 1083862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1083865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1083873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1083876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1083879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083901 */     // MIs[0] policy
     /* 1083901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083911 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1083914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1083930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083933 */     // GIR_Coverage, 23823,
     /* 1083933 */     GIR_EraseRootFromParent_Done,
     /* 1083934 */   // Label 15961: @1083934
     /* 1083934 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1084011), // Rule ID 23826 //
     /* 1083939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1083942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1083950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1083953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1083956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083978 */     // MIs[0] policy
     /* 1083978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1083991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084010 */     // GIR_Coverage, 23826,
     /* 1084010 */     GIR_EraseRootFromParent_Done,
     /* 1084011 */   // Label 15962: @1084011
     /* 1084011 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1084088), // Rule ID 23827 //
     /* 1084016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1084027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1084030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1084033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084055 */     // MIs[0] policy
     /* 1084055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084065 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1084084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084087 */     // GIR_Coverage, 23827,
     /* 1084087 */     GIR_EraseRootFromParent_Done,
     /* 1084088 */   // Label 15963: @1084088
     /* 1084088 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1084165), // Rule ID 23830 //
     /* 1084093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084132 */     // MIs[0] policy
     /* 1084132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084164 */     // GIR_Coverage, 23830,
     /* 1084164 */     GIR_EraseRootFromParent_Done,
     /* 1084165 */   // Label 15964: @1084165
     /* 1084165 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1084242), // Rule ID 23831 //
     /* 1084170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084209 */     // MIs[0] policy
     /* 1084209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084241 */     // GIR_Coverage, 23831,
     /* 1084241 */     GIR_EraseRootFromParent_Done,
     /* 1084242 */   // Label 15965: @1084242
     /* 1084242 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1084319), // Rule ID 23834 //
     /* 1084247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084286 */     // MIs[0] policy
     /* 1084286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084318 */     // GIR_Coverage, 23834,
     /* 1084318 */     GIR_EraseRootFromParent_Done,
     /* 1084319 */   // Label 15966: @1084319
     /* 1084319 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1084396), // Rule ID 23835 //
     /* 1084324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084363 */     // MIs[0] policy
     /* 1084363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084373 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084395 */     // GIR_Coverage, 23835,
     /* 1084395 */     GIR_EraseRootFromParent_Done,
     /* 1084396 */   // Label 15967: @1084396
     /* 1084396 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1084473), // Rule ID 23838 //
     /* 1084401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084440 */     // MIs[0] policy
     /* 1084440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084472 */     // GIR_Coverage, 23838,
     /* 1084472 */     GIR_EraseRootFromParent_Done,
     /* 1084473 */   // Label 15968: @1084473
     /* 1084473 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1084550), // Rule ID 23839 //
     /* 1084478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084517 */     // MIs[0] policy
     /* 1084517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084527 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084549 */     // GIR_Coverage, 23839,
     /* 1084549 */     GIR_EraseRootFromParent_Done,
     /* 1084550 */   // Label 15969: @1084550
     /* 1084550 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1084627), // Rule ID 23842 //
     /* 1084555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084594 */     // MIs[0] policy
     /* 1084594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084626 */     // GIR_Coverage, 23842,
     /* 1084626 */     GIR_EraseRootFromParent_Done,
     /* 1084627 */   // Label 15970: @1084627
     /* 1084627 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1084704), // Rule ID 23843 //
     /* 1084632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084671 */     // MIs[0] policy
     /* 1084671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084703 */     // GIR_Coverage, 23843,
     /* 1084703 */     GIR_EraseRootFromParent_Done,
     /* 1084704 */   // Label 15971: @1084704
     /* 1084704 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1084781), // Rule ID 23846 //
     /* 1084709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1084726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084748 */     // MIs[0] policy
     /* 1084748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084780 */     // GIR_Coverage, 23846,
     /* 1084780 */     GIR_EraseRootFromParent_Done,
     /* 1084781 */   // Label 15972: @1084781
     /* 1084781 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1084858), // Rule ID 23847 //
     /* 1084786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1084803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084825 */     // MIs[0] policy
     /* 1084825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084835 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084857 */     // GIR_Coverage, 23847,
     /* 1084857 */     GIR_EraseRootFromParent_Done,
     /* 1084858 */   // Label 15973: @1084858
     /* 1084858 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1084935), // Rule ID 23850 //
     /* 1084863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1084866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1084874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1084877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1084880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084902 */     // MIs[0] policy
     /* 1084902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084934 */     // GIR_Coverage, 23850,
     /* 1084934 */     GIR_EraseRootFromParent_Done,
     /* 1084935 */   // Label 15974: @1084935
     /* 1084935 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1085012), // Rule ID 23851 //
     /* 1084940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1084943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1084951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1084954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1084957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084979 */     // MIs[0] policy
     /* 1084979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084989 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085011 */     // GIR_Coverage, 23851,
     /* 1085011 */     GIR_EraseRootFromParent_Done,
     /* 1085012 */   // Label 15975: @1085012
     /* 1085012 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1085089), // Rule ID 23854 //
     /* 1085017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085056 */     // MIs[0] policy
     /* 1085056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085088 */     // GIR_Coverage, 23854,
     /* 1085088 */     GIR_EraseRootFromParent_Done,
     /* 1085089 */   // Label 15976: @1085089
     /* 1085089 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1085166), // Rule ID 23855 //
     /* 1085094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085133 */     // MIs[0] policy
     /* 1085133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085165 */     // GIR_Coverage, 23855,
     /* 1085165 */     GIR_EraseRootFromParent_Done,
     /* 1085166 */   // Label 15977: @1085166
     /* 1085166 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1085243), // Rule ID 23858 //
     /* 1085171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085210 */     // MIs[0] policy
     /* 1085210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085242 */     // GIR_Coverage, 23858,
     /* 1085242 */     GIR_EraseRootFromParent_Done,
     /* 1085243 */   // Label 15978: @1085243
     /* 1085243 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1085320), // Rule ID 23859 //
     /* 1085248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085287 */     // MIs[0] policy
     /* 1085287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085297 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085319 */     // GIR_Coverage, 23859,
     /* 1085319 */     GIR_EraseRootFromParent_Done,
     /* 1085320 */   // Label 15979: @1085320
     /* 1085320 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1085397), // Rule ID 23862 //
     /* 1085325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1085328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085364 */     // MIs[0] policy
     /* 1085364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085396 */     // GIR_Coverage, 23862,
     /* 1085396 */     GIR_EraseRootFromParent_Done,
     /* 1085397 */   // Label 15980: @1085397
     /* 1085397 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1085474), // Rule ID 23863 //
     /* 1085402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1085405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085441 */     // MIs[0] policy
     /* 1085441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085451 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085473 */     // GIR_Coverage, 23863,
     /* 1085473 */     GIR_EraseRootFromParent_Done,
     /* 1085474 */   // Label 15981: @1085474
     /* 1085474 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1085551), // Rule ID 24130 //
     /* 1085479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1085496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085518 */     // MIs[0] policy
     /* 1085518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085528 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1085531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085550 */     // GIR_Coverage, 24130,
     /* 1085550 */     GIR_EraseRootFromParent_Done,
     /* 1085551 */   // Label 15982: @1085551
     /* 1085551 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1085628), // Rule ID 24131 //
     /* 1085556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1085559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1085567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1085570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1085573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085595 */     // MIs[0] policy
     /* 1085595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085605 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1085608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085627 */     // GIR_Coverage, 24131,
     /* 1085627 */     GIR_EraseRootFromParent_Done,
     /* 1085628 */   // Label 15983: @1085628
     /* 1085628 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1085705), // Rule ID 24134 //
     /* 1085633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1085650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085672 */     // MIs[0] policy
     /* 1085672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085704 */     // GIR_Coverage, 24134,
     /* 1085704 */     GIR_EraseRootFromParent_Done,
     /* 1085705 */   // Label 15984: @1085705
     /* 1085705 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1085782), // Rule ID 24135 //
     /* 1085710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1085713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1085721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1085724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1085727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085749 */     // MIs[0] policy
     /* 1085749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085759 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085781 */     // GIR_Coverage, 24135,
     /* 1085781 */     GIR_EraseRootFromParent_Done,
     /* 1085782 */   // Label 15985: @1085782
     /* 1085782 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1085859), // Rule ID 24138 //
     /* 1085787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085826 */     // MIs[0] policy
     /* 1085826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085858 */     // GIR_Coverage, 24138,
     /* 1085858 */     GIR_EraseRootFromParent_Done,
     /* 1085859 */   // Label 15986: @1085859
     /* 1085859 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1085936), // Rule ID 24139 //
     /* 1085864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085903 */     // MIs[0] policy
     /* 1085903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085913 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1085916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085935 */     // GIR_Coverage, 24139,
     /* 1085935 */     GIR_EraseRootFromParent_Done,
     /* 1085936 */   // Label 15987: @1085936
     /* 1085936 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1086013), // Rule ID 24142 //
     /* 1085941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1085944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1085949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1085952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1085955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1085958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085980 */     // MIs[0] policy
     /* 1085980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085990 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1085993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086012 */     // GIR_Coverage, 24142,
     /* 1086012 */     GIR_EraseRootFromParent_Done,
     /* 1086013 */   // Label 15988: @1086013
     /* 1086013 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1086090), // Rule ID 24143 //
     /* 1086018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1086029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1086032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1086035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086057 */     // MIs[0] policy
     /* 1086057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086067 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086089 */     // GIR_Coverage, 24143,
     /* 1086089 */     GIR_EraseRootFromParent_Done,
     /* 1086090 */   // Label 15989: @1086090
     /* 1086090 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1086167), // Rule ID 24146 //
     /* 1086095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1086098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1086112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086134 */     // MIs[0] policy
     /* 1086134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086166 */     // GIR_Coverage, 24146,
     /* 1086166 */     GIR_EraseRootFromParent_Done,
     /* 1086167 */   // Label 15990: @1086167
     /* 1086167 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1086244), // Rule ID 24147 //
     /* 1086172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1086175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1086183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1086186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1086189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086211 */     // MIs[0] policy
     /* 1086211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086221 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086243 */     // GIR_Coverage, 24147,
     /* 1086243 */     GIR_EraseRootFromParent_Done,
     /* 1086244 */   // Label 15991: @1086244
     /* 1086244 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1086321), // Rule ID 24150 //
     /* 1086249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1086252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1086260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1086263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086288 */     // MIs[0] policy
     /* 1086288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086320 */     // GIR_Coverage, 24150,
     /* 1086320 */     GIR_EraseRootFromParent_Done,
     /* 1086321 */   // Label 15992: @1086321
     /* 1086321 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1086398), // Rule ID 24151 //
     /* 1086326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1086329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1086337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1086340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1086343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086365 */     // MIs[0] policy
     /* 1086365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1086378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086397 */     // GIR_Coverage, 24151,
     /* 1086397 */     GIR_EraseRootFromParent_Done,
     /* 1086398 */   // Label 15993: @1086398
     /* 1086398 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1086475), // Rule ID 24154 //
     /* 1086403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1086420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086442 */     // MIs[0] policy
     /* 1086442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086474 */     // GIR_Coverage, 24154,
     /* 1086474 */     GIR_EraseRootFromParent_Done,
     /* 1086475 */   // Label 15994: @1086475
     /* 1086475 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1086552), // Rule ID 24155 //
     /* 1086480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1086491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1086494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1086497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086519 */     // MIs[0] policy
     /* 1086519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086529 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086551 */     // GIR_Coverage, 24155,
     /* 1086551 */     GIR_EraseRootFromParent_Done,
     /* 1086552 */   // Label 15995: @1086552
     /* 1086552 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1086629), // Rule ID 24158 //
     /* 1086557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1086574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086596 */     // MIs[0] policy
     /* 1086596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1086609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086628 */     // GIR_Coverage, 24158,
     /* 1086628 */     GIR_EraseRootFromParent_Done,
     /* 1086629 */   // Label 15996: @1086629
     /* 1086629 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1086706), // Rule ID 24159 //
     /* 1086634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1086645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1086648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1086651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086673 */     // MIs[0] policy
     /* 1086673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1086686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086705 */     // GIR_Coverage, 24159,
     /* 1086705 */     GIR_EraseRootFromParent_Done,
     /* 1086706 */   // Label 15997: @1086706
     /* 1086706 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1086783), // Rule ID 24162 //
     /* 1086711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1086714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1086722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1086725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1086728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086750 */     // MIs[0] policy
     /* 1086750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086760 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1086763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086782 */     // GIR_Coverage, 24162,
     /* 1086782 */     GIR_EraseRootFromParent_Done,
     /* 1086783 */   // Label 15998: @1086783
     /* 1086783 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1086860), // Rule ID 24163 //
     /* 1086788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1086791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1086799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1086802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1086805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086827 */     // MIs[0] policy
     /* 1086827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086837 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1086840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086859 */     // GIR_Coverage, 24163,
     /* 1086859 */     GIR_EraseRootFromParent_Done,
     /* 1086860 */   // Label 15999: @1086860
     /* 1086860 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1086937), // Rule ID 24166 //
     /* 1086865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1086868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1086882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086904 */     // MIs[0] policy
     /* 1086904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086914 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086936 */     // GIR_Coverage, 24166,
     /* 1086936 */     GIR_EraseRootFromParent_Done,
     /* 1086937 */   // Label 16000: @1086937
     /* 1086937 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1087014), // Rule ID 24167 //
     /* 1086942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1086945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1086950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1086953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1086956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1086959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1086977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086981 */     // MIs[0] policy
     /* 1086981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1086994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087013 */     // GIR_Coverage, 24167,
     /* 1087013 */     GIR_EraseRootFromParent_Done,
     /* 1087014 */   // Label 16001: @1087014
     /* 1087014 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1087091), // Rule ID 24170 //
     /* 1087019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1087022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1087030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1087033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1087036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087058 */     // MIs[0] policy
     /* 1087058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087090 */     // GIR_Coverage, 24170,
     /* 1087090 */     GIR_EraseRootFromParent_Done,
     /* 1087091 */   // Label 16002: @1087091
     /* 1087091 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1087168), // Rule ID 24171 //
     /* 1087096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1087099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1087107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1087110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1087113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087135 */     // MIs[0] policy
     /* 1087135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087145 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087167 */     // GIR_Coverage, 24171,
     /* 1087167 */     GIR_EraseRootFromParent_Done,
     /* 1087168 */   // Label 16003: @1087168
     /* 1087168 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1087245), // Rule ID 24174 //
     /* 1087173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1087176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1087184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1087187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1087190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087212 */     // MIs[0] policy
     /* 1087212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087222 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087244 */     // GIR_Coverage, 24174,
     /* 1087244 */     GIR_EraseRootFromParent_Done,
     /* 1087245 */   // Label 16004: @1087245
     /* 1087245 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1087322), // Rule ID 24175 //
     /* 1087250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1087253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1087261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1087264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1087267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087289 */     // MIs[0] policy
     /* 1087289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087299 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087321 */     // GIR_Coverage, 24175,
     /* 1087321 */     GIR_EraseRootFromParent_Done,
     /* 1087322 */   // Label 16005: @1087322
     /* 1087322 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1087399), // Rule ID 24178 //
     /* 1087327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1087338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1087341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1087344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087366 */     // MIs[0] policy
     /* 1087366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1087379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087398 */     // GIR_Coverage, 24178,
     /* 1087398 */     GIR_EraseRootFromParent_Done,
     /* 1087399 */   // Label 16006: @1087399
     /* 1087399 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1087476), // Rule ID 24179 //
     /* 1087404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1087415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1087418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1087421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087443 */     // MIs[0] policy
     /* 1087443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087453 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1087456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087475 */     // GIR_Coverage, 24179,
     /* 1087475 */     GIR_EraseRootFromParent_Done,
     /* 1087476 */   // Label 16007: @1087476
     /* 1087476 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1087553), // Rule ID 24182 //
     /* 1087481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1087492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1087495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1087498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087520 */     // MIs[0] policy
     /* 1087520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087552 */     // GIR_Coverage, 24182,
     /* 1087552 */     GIR_EraseRootFromParent_Done,
     /* 1087553 */   // Label 16008: @1087553
     /* 1087553 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1087630), // Rule ID 24183 //
     /* 1087558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1087569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1087572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1087575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087597 */     // MIs[0] policy
     /* 1087597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087607 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1087610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087629 */     // GIR_Coverage, 24183,
     /* 1087629 */     GIR_EraseRootFromParent_Done,
     /* 1087630 */   // Label 16009: @1087630
     /* 1087630 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1087707), // Rule ID 24186 //
     /* 1087635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1087638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1087646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1087649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1087652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087674 */     // MIs[0] policy
     /* 1087674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087706 */     // GIR_Coverage, 24186,
     /* 1087706 */     GIR_EraseRootFromParent_Done,
     /* 1087707 */   // Label 16010: @1087707
     /* 1087707 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1087784), // Rule ID 24187 //
     /* 1087712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1087715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1087720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1087723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1087726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1087729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087751 */     // MIs[0] policy
     /* 1087751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087761 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1087764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087783 */     // GIR_Coverage, 24187,
     /* 1087783 */     GIR_EraseRootFromParent_Done,
     /* 1087784 */   // Label 16011: @1087784
     /* 1087784 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1087861), // Rule ID 24250 //
     /* 1087789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1087792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087828 */     // MIs[0] policy
     /* 1087828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087838 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1087841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087860 */     // GIR_Coverage, 24250,
     /* 1087860 */     GIR_EraseRootFromParent_Done,
     /* 1087861 */   // Label 16012: @1087861
     /* 1087861 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1087938), // Rule ID 24251 //
     /* 1087866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1087869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1087877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1087880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1087883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1087886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087905 */     // MIs[0] policy
     /* 1087905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087915 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1087918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1087924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1087926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087937 */     // GIR_Coverage, 24251,
     /* 1087937 */     GIR_EraseRootFromParent_Done,
     /* 1087938 */   // Label 16013: @1087938
     /* 1087938 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1088015), // Rule ID 24254 //
     /* 1087943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1087946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1087951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1087963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1087982 */     // MIs[0] policy
     /* 1087982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087992 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1087995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1087999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088014 */     // GIR_Coverage, 24254,
     /* 1088014 */     GIR_EraseRootFromParent_Done,
     /* 1088015 */   // Label 16014: @1088015
     /* 1088015 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1088092), // Rule ID 24255 //
     /* 1088020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1088031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1088034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1088037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088059 */     // MIs[0] policy
     /* 1088059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088069 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088091 */     // GIR_Coverage, 24255,
     /* 1088091 */     GIR_EraseRootFromParent_Done,
     /* 1088092 */   // Label 16015: @1088092
     /* 1088092 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1088169), // Rule ID 24258 //
     /* 1088097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1088100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1088108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1088111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088136 */     // MIs[0] policy
     /* 1088136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088168 */     // GIR_Coverage, 24258,
     /* 1088168 */     GIR_EraseRootFromParent_Done,
     /* 1088169 */   // Label 16016: @1088169
     /* 1088169 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1088246), // Rule ID 24259 //
     /* 1088174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1088177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1088185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1088188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1088191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088213 */     // MIs[0] policy
     /* 1088213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088223 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1088226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088245 */     // GIR_Coverage, 24259,
     /* 1088245 */     GIR_EraseRootFromParent_Done,
     /* 1088246 */   // Label 16017: @1088246
     /* 1088246 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1088323), // Rule ID 24262 //
     /* 1088251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088290 */     // MIs[0] policy
     /* 1088290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088322 */     // GIR_Coverage, 24262,
     /* 1088322 */     GIR_EraseRootFromParent_Done,
     /* 1088323 */   // Label 16018: @1088323
     /* 1088323 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1088400), // Rule ID 24263 //
     /* 1088328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1088339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1088342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1088345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088367 */     // MIs[0] policy
     /* 1088367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088377 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088399 */     // GIR_Coverage, 24263,
     /* 1088399 */     GIR_EraseRootFromParent_Done,
     /* 1088400 */   // Label 16019: @1088400
     /* 1088400 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1088477), // Rule ID 24266 //
     /* 1088405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1088408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088444 */     // MIs[0] policy
     /* 1088444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088476 */     // GIR_Coverage, 24266,
     /* 1088476 */     GIR_EraseRootFromParent_Done,
     /* 1088477 */   // Label 16020: @1088477
     /* 1088477 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1088554), // Rule ID 24267 //
     /* 1088482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1088485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1088493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1088496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1088499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088521 */     // MIs[0] policy
     /* 1088521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088531 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088553 */     // GIR_Coverage, 24267,
     /* 1088553 */     GIR_EraseRootFromParent_Done,
     /* 1088554 */   // Label 16021: @1088554
     /* 1088554 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1088631), // Rule ID 24270 //
     /* 1088559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1088562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088598 */     // MIs[0] policy
     /* 1088598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088608 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088630 */     // GIR_Coverage, 24270,
     /* 1088630 */     GIR_EraseRootFromParent_Done,
     /* 1088631 */   // Label 16022: @1088631
     /* 1088631 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1088708), // Rule ID 24271 //
     /* 1088636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1088639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1088647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1088650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1088653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1088671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088675 */     // MIs[0] policy
     /* 1088675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088685 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1088688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088707 */     // GIR_Coverage, 24271,
     /* 1088707 */     GIR_EraseRootFromParent_Done,
     /* 1088708 */   // Label 16023: @1088708
     /* 1088708 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1088785), // Rule ID 24274 //
     /* 1088713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088752 */     // MIs[0] policy
     /* 1088752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1088765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088784 */     // GIR_Coverage, 24274,
     /* 1088784 */     GIR_EraseRootFromParent_Done,
     /* 1088785 */   // Label 16024: @1088785
     /* 1088785 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1088862), // Rule ID 24275 //
     /* 1088790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088829 */     // MIs[0] policy
     /* 1088829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088839 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1088842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088861 */     // GIR_Coverage, 24275,
     /* 1088861 */     GIR_EraseRootFromParent_Done,
     /* 1088862 */   // Label 16025: @1088862
     /* 1088862 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1088939), // Rule ID 24278 //
     /* 1088867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1088870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1088887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088906 */     // MIs[0] policy
     /* 1088906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088916 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1088919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1088923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1088925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1088927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088938 */     // GIR_Coverage, 24278,
     /* 1088938 */     GIR_EraseRootFromParent_Done,
     /* 1088939 */   // Label 16026: @1088939
     /* 1088939 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1089016), // Rule ID 24279 //
     /* 1088944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1088947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1088952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1088964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1088983 */     // MIs[0] policy
     /* 1088983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088993 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1088996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089015 */     // GIR_Coverage, 24279,
     /* 1089015 */     GIR_EraseRootFromParent_Done,
     /* 1089016 */   // Label 16027: @1089016
     /* 1089016 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1089093), // Rule ID 24282 //
     /* 1089021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1089024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089060 */     // MIs[0] policy
     /* 1089060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089070 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089092 */     // GIR_Coverage, 24282,
     /* 1089092 */     GIR_EraseRootFromParent_Done,
     /* 1089093 */   // Label 16028: @1089093
     /* 1089093 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1089170), // Rule ID 24283 //
     /* 1089098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1089101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1089109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1089112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1089115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089137 */     // MIs[0] policy
     /* 1089137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089147 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089169 */     // GIR_Coverage, 24283,
     /* 1089169 */     GIR_EraseRootFromParent_Done,
     /* 1089170 */   // Label 16029: @1089170
     /* 1089170 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1089247), // Rule ID 24286 //
     /* 1089175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089214 */     // MIs[0] policy
     /* 1089214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089246 */     // GIR_Coverage, 24286,
     /* 1089246 */     GIR_EraseRootFromParent_Done,
     /* 1089247 */   // Label 16030: @1089247
     /* 1089247 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1089324), // Rule ID 24287 //
     /* 1089252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1089263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1089266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1089269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089291 */     // MIs[0] policy
     /* 1089291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089301 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089323 */     // GIR_Coverage, 24287,
     /* 1089323 */     GIR_EraseRootFromParent_Done,
     /* 1089324 */   // Label 16031: @1089324
     /* 1089324 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1089401), // Rule ID 24290 //
     /* 1089329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089368 */     // MIs[0] policy
     /* 1089368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089378 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089400 */     // GIR_Coverage, 24290,
     /* 1089400 */     GIR_EraseRootFromParent_Done,
     /* 1089401 */   // Label 16032: @1089401
     /* 1089401 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1089478), // Rule ID 24291 //
     /* 1089406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089445 */     // MIs[0] policy
     /* 1089445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089455 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089477 */     // GIR_Coverage, 24291,
     /* 1089477 */     GIR_EraseRootFromParent_Done,
     /* 1089478 */   // Label 16033: @1089478
     /* 1089478 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1089555), // Rule ID 24294 //
     /* 1089483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1089486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089522 */     // MIs[0] policy
     /* 1089522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089532 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089554 */     // GIR_Coverage, 24294,
     /* 1089554 */     GIR_EraseRootFromParent_Done,
     /* 1089555 */   // Label 16034: @1089555
     /* 1089555 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1089632), // Rule ID 24295 //
     /* 1089560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1089563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089599 */     // MIs[0] policy
     /* 1089599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089609 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089631 */     // GIR_Coverage, 24295,
     /* 1089631 */     GIR_EraseRootFromParent_Done,
     /* 1089632 */   // Label 16035: @1089632
     /* 1089632 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1089709), // Rule ID 24298 //
     /* 1089637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089676 */     // MIs[0] policy
     /* 1089676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089686 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089708 */     // GIR_Coverage, 24298,
     /* 1089708 */     GIR_EraseRootFromParent_Done,
     /* 1089709 */   // Label 16036: @1089709
     /* 1089709 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1089786), // Rule ID 24299 //
     /* 1089714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1089717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089753 */     // MIs[0] policy
     /* 1089753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089763 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1089766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089785 */     // GIR_Coverage, 24299,
     /* 1089785 */     GIR_EraseRootFromParent_Done,
     /* 1089786 */   // Label 16037: @1089786
     /* 1089786 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1089863), // Rule ID 24302 //
     /* 1089791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089830 */     // MIs[0] policy
     /* 1089830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089840 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089862 */     // GIR_Coverage, 24302,
     /* 1089862 */     GIR_EraseRootFromParent_Done,
     /* 1089863 */   // Label 16038: @1089863
     /* 1089863 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1089940), // Rule ID 24303 //
     /* 1089868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1089871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1089888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089907 */     // MIs[0] policy
     /* 1089907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089917 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1089920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1089924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1089926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1089928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089939 */     // GIR_Coverage, 24303,
     /* 1089939 */     GIR_EraseRootFromParent_Done,
     /* 1089940 */   // Label 16039: @1089940
     /* 1089940 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1090017), // Rule ID 24306 //
     /* 1089945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1089948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1089953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1089965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1089984 */     // MIs[0] policy
     /* 1089984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089994 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1089997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090016 */     // GIR_Coverage, 24306,
     /* 1090016 */     GIR_EraseRootFromParent_Done,
     /* 1090017 */   // Label 16040: @1090017
     /* 1090017 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1090094), // Rule ID 24307 //
     /* 1090022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1090025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1090030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1090033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1090036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1090039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1090042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1090057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1090061 */     // MIs[0] policy
     /* 1090061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090071 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1090074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090093 */     // GIR_Coverage, 24307,
     /* 1090093 */     GIR_EraseRootFromParent_Done,
     /* 1090094 */   // Label 16041: @1090094
     /* 1090094 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1090171), // Rule ID 60598 //
     /* 1090099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1090102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1090107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1090119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090138 */     // MIs[0] policy
     /* 1090138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1090151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1090153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090170 */     // GIR_Coverage, 60598,
     /* 1090170 */     GIR_EraseRootFromParent_Done,
     /* 1090171 */   // Label 16042: @1090171
     /* 1090171 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1090248), // Rule ID 60599 //
     /* 1090176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1090179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1090184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1090196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090215 */     // MIs[0] policy
     /* 1090215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090225 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1090228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1090230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1090232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1090234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1090236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090247 */     // GIR_Coverage, 60599,
     /* 1090247 */     GIR_EraseRootFromParent_Done,
     /* 1090248 */   // Label 16043: @1090248
     /* 1090248 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1090325), // Rule ID 60612 //
     /* 1090253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090292 */     // MIs[0] policy
     /* 1090292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1090305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090324 */     // GIR_Coverage, 60612,
     /* 1090324 */     GIR_EraseRootFromParent_Done,
     /* 1090325 */   // Label 16044: @1090325
     /* 1090325 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1090402), // Rule ID 60613 //
     /* 1090330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1090341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1090344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1090347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090369 */     // MIs[0] policy
     /* 1090369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090379 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1090382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090401 */     // GIR_Coverage, 60613,
     /* 1090401 */     GIR_EraseRootFromParent_Done,
     /* 1090402 */   // Label 16045: @1090402
     /* 1090402 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1090479), // Rule ID 60616 //
     /* 1090407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090446 */     // MIs[0] policy
     /* 1090446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090456 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090478 */     // GIR_Coverage, 60616,
     /* 1090478 */     GIR_EraseRootFromParent_Done,
     /* 1090479 */   // Label 16046: @1090479
     /* 1090479 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1090556), // Rule ID 60617 //
     /* 1090484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090523 */     // MIs[0] policy
     /* 1090523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090533 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090555 */     // GIR_Coverage, 60617,
     /* 1090555 */     GIR_EraseRootFromParent_Done,
     /* 1090556 */   // Label 16047: @1090556
     /* 1090556 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1090633), // Rule ID 60620 //
     /* 1090561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090600 */     // MIs[0] policy
     /* 1090600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090632 */     // GIR_Coverage, 60620,
     /* 1090632 */     GIR_EraseRootFromParent_Done,
     /* 1090633 */   // Label 16048: @1090633
     /* 1090633 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1090710), // Rule ID 60621 //
     /* 1090638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090677 */     // MIs[0] policy
     /* 1090677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090687 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090709 */     // GIR_Coverage, 60621,
     /* 1090709 */     GIR_EraseRootFromParent_Done,
     /* 1090710 */   // Label 16049: @1090710
     /* 1090710 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1090787), // Rule ID 60624 //
     /* 1090715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090754 */     // MIs[0] policy
     /* 1090754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090786 */     // GIR_Coverage, 60624,
     /* 1090786 */     GIR_EraseRootFromParent_Done,
     /* 1090787 */   // Label 16050: @1090787
     /* 1090787 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1090864), // Rule ID 60625 //
     /* 1090792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090831 */     // MIs[0] policy
     /* 1090831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090841 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1090844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090863 */     // GIR_Coverage, 60625,
     /* 1090863 */     GIR_EraseRootFromParent_Done,
     /* 1090864 */   // Label 16051: @1090864
     /* 1090864 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1090941), // Rule ID 60628 //
     /* 1090869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090908 */     // MIs[0] policy
     /* 1090908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090940 */     // GIR_Coverage, 60628,
     /* 1090940 */     GIR_EraseRootFromParent_Done,
     /* 1090941 */   // Label 16052: @1090941
     /* 1090941 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1091018), // Rule ID 60629 //
     /* 1090946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1090954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090985 */     // MIs[0] policy
     /* 1090985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090995 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1090998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091017 */     // GIR_Coverage, 60629,
     /* 1091017 */     GIR_EraseRootFromParent_Done,
     /* 1091018 */   // Label 16053: @1091018
     /* 1091018 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1091095), // Rule ID 60632 //
     /* 1091023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091062 */     // MIs[0] policy
     /* 1091062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1091075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091094 */     // GIR_Coverage, 60632,
     /* 1091094 */     GIR_EraseRootFromParent_Done,
     /* 1091095 */   // Label 16054: @1091095
     /* 1091095 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1091172), // Rule ID 60633 //
     /* 1091100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1091111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1091114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1091117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091139 */     // MIs[0] policy
     /* 1091139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1091152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091171 */     // GIR_Coverage, 60633,
     /* 1091171 */     GIR_EraseRootFromParent_Done,
     /* 1091172 */   // Label 16055: @1091172
     /* 1091172 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1091249), // Rule ID 60636 //
     /* 1091177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091216 */     // MIs[0] policy
     /* 1091216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091248 */     // GIR_Coverage, 60636,
     /* 1091248 */     GIR_EraseRootFromParent_Done,
     /* 1091249 */   // Label 16056: @1091249
     /* 1091249 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1091326), // Rule ID 60637 //
     /* 1091254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1091265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1091268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1091271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091293 */     // MIs[0] policy
     /* 1091293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091303 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091325 */     // GIR_Coverage, 60637,
     /* 1091325 */     GIR_EraseRootFromParent_Done,
     /* 1091326 */   // Label 16057: @1091326
     /* 1091326 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1091403), // Rule ID 60640 //
     /* 1091331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091370 */     // MIs[0] policy
     /* 1091370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091402 */     // GIR_Coverage, 60640,
     /* 1091402 */     GIR_EraseRootFromParent_Done,
     /* 1091403 */   // Label 16058: @1091403
     /* 1091403 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1091480), // Rule ID 60641 //
     /* 1091408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1091419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1091422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1091425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091447 */     // MIs[0] policy
     /* 1091447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091457 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091479 */     // GIR_Coverage, 60641,
     /* 1091479 */     GIR_EraseRootFromParent_Done,
     /* 1091480 */   // Label 16059: @1091480
     /* 1091480 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1091557), // Rule ID 60644 //
     /* 1091485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091524 */     // MIs[0] policy
     /* 1091524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091556 */     // GIR_Coverage, 60644,
     /* 1091556 */     GIR_EraseRootFromParent_Done,
     /* 1091557 */   // Label 16060: @1091557
     /* 1091557 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1091634), // Rule ID 60645 //
     /* 1091562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091601 */     // MIs[0] policy
     /* 1091601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091633 */     // GIR_Coverage, 60645,
     /* 1091633 */     GIR_EraseRootFromParent_Done,
     /* 1091634 */   // Label 16061: @1091634
     /* 1091634 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1091711), // Rule ID 60648 //
     /* 1091639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091678 */     // MIs[0] policy
     /* 1091678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091710 */     // GIR_Coverage, 60648,
     /* 1091710 */     GIR_EraseRootFromParent_Done,
     /* 1091711 */   // Label 16062: @1091711
     /* 1091711 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1091788), // Rule ID 60649 //
     /* 1091716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091755 */     // MIs[0] policy
     /* 1091755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091765 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1091768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091787 */     // GIR_Coverage, 60649,
     /* 1091787 */     GIR_EraseRootFromParent_Done,
     /* 1091788 */   // Label 16063: @1091788
     /* 1091788 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1091865), // Rule ID 60652 //
     /* 1091793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091832 */     // MIs[0] policy
     /* 1091832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1091845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091864 */     // GIR_Coverage, 60652,
     /* 1091864 */     GIR_EraseRootFromParent_Done,
     /* 1091865 */   // Label 16064: @1091865
     /* 1091865 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1091942), // Rule ID 60653 //
     /* 1091870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091909 */     // MIs[0] policy
     /* 1091909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1091922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091941 */     // GIR_Coverage, 60653,
     /* 1091941 */     GIR_EraseRootFromParent_Done,
     /* 1091942 */   // Label 16065: @1091942
     /* 1091942 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1092019), // Rule ID 60656 //
     /* 1091947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1091955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091986 */     // MIs[0] policy
     /* 1091986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091996 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1091999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092018 */     // GIR_Coverage, 60656,
     /* 1092018 */     GIR_EraseRootFromParent_Done,
     /* 1092019 */   // Label 16066: @1092019
     /* 1092019 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1092096), // Rule ID 60657 //
     /* 1092024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1092035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1092038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1092041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092063 */     // MIs[0] policy
     /* 1092063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092073 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092095 */     // GIR_Coverage, 60657,
     /* 1092095 */     GIR_EraseRootFromParent_Done,
     /* 1092096 */   // Label 16067: @1092096
     /* 1092096 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1092173), // Rule ID 60660 //
     /* 1092101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092140 */     // MIs[0] policy
     /* 1092140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092172 */     // GIR_Coverage, 60660,
     /* 1092172 */     GIR_EraseRootFromParent_Done,
     /* 1092173 */   // Label 16068: @1092173
     /* 1092173 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1092250), // Rule ID 60661 //
     /* 1092178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1092189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1092192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1092195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1092198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092217 */     // MIs[0] policy
     /* 1092217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092249 */     // GIR_Coverage, 60661,
     /* 1092249 */     GIR_EraseRootFromParent_Done,
     /* 1092250 */   // Label 16069: @1092250
     /* 1092250 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1092327), // Rule ID 60664 //
     /* 1092255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092294 */     // MIs[0] policy
     /* 1092294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092326 */     // GIR_Coverage, 60664,
     /* 1092326 */     GIR_EraseRootFromParent_Done,
     /* 1092327 */   // Label 16070: @1092327
     /* 1092327 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1092404), // Rule ID 60665 //
     /* 1092332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1092343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1092346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1092349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092371 */     // MIs[0] policy
     /* 1092371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092381 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092403 */     // GIR_Coverage, 60665,
     /* 1092403 */     GIR_EraseRootFromParent_Done,
     /* 1092404 */   // Label 16071: @1092404
     /* 1092404 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1092481), // Rule ID 60668 //
     /* 1092409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092448 */     // MIs[0] policy
     /* 1092448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092458 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092480 */     // GIR_Coverage, 60668,
     /* 1092480 */     GIR_EraseRootFromParent_Done,
     /* 1092481 */   // Label 16072: @1092481
     /* 1092481 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1092558), // Rule ID 60669 //
     /* 1092486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092525 */     // MIs[0] policy
     /* 1092525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092535 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092557 */     // GIR_Coverage, 60669,
     /* 1092557 */     GIR_EraseRootFromParent_Done,
     /* 1092558 */   // Label 16073: @1092558
     /* 1092558 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1092635), // Rule ID 60672 //
     /* 1092563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092602 */     // MIs[0] policy
     /* 1092602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092612 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092634 */     // GIR_Coverage, 60672,
     /* 1092634 */     GIR_EraseRootFromParent_Done,
     /* 1092635 */   // Label 16074: @1092635
     /* 1092635 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1092712), // Rule ID 60673 //
     /* 1092640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092679 */     // MIs[0] policy
     /* 1092679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1092692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092711 */     // GIR_Coverage, 60673,
     /* 1092711 */     GIR_EraseRootFromParent_Done,
     /* 1092712 */   // Label 16075: @1092712
     /* 1092712 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1092789), // Rule ID 60676 //
     /* 1092717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092756 */     // MIs[0] policy
     /* 1092756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092788 */     // GIR_Coverage, 60676,
     /* 1092788 */     GIR_EraseRootFromParent_Done,
     /* 1092789 */   // Label 16076: @1092789
     /* 1092789 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1092866), // Rule ID 60677 //
     /* 1092794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092833 */     // MIs[0] policy
     /* 1092833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1092846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092865 */     // GIR_Coverage, 60677,
     /* 1092865 */     GIR_EraseRootFromParent_Done,
     /* 1092866 */   // Label 16077: @1092866
     /* 1092866 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1092943), // Rule ID 60680 //
     /* 1092871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092910 */     // MIs[0] policy
     /* 1092910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1092923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092942 */     // GIR_Coverage, 60680,
     /* 1092942 */     GIR_EraseRootFromParent_Done,
     /* 1092943 */   // Label 16078: @1092943
     /* 1092943 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1093020), // Rule ID 60681 //
     /* 1092948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1092956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092987 */     // MIs[0] policy
     /* 1092987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093019 */     // GIR_Coverage, 60681,
     /* 1093019 */     GIR_EraseRootFromParent_Done,
     /* 1093020 */   // Label 16079: @1093020
     /* 1093020 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1093097), // Rule ID 60684 //
     /* 1093025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093064 */     // MIs[0] policy
     /* 1093064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093096 */     // GIR_Coverage, 60684,
     /* 1093096 */     GIR_EraseRootFromParent_Done,
     /* 1093097 */   // Label 16080: @1093097
     /* 1093097 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1093174), // Rule ID 60685 //
     /* 1093102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1093113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1093116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1093119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1093122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093141 */     // MIs[0] policy
     /* 1093141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093173 */     // GIR_Coverage, 60685,
     /* 1093173 */     GIR_EraseRootFromParent_Done,
     /* 1093174 */   // Label 16081: @1093174
     /* 1093174 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1093251), // Rule ID 60688 //
     /* 1093179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093218 */     // MIs[0] policy
     /* 1093218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1093231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093250 */     // GIR_Coverage, 60688,
     /* 1093250 */     GIR_EraseRootFromParent_Done,
     /* 1093251 */   // Label 16082: @1093251
     /* 1093251 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1093328), // Rule ID 60689 //
     /* 1093256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1093267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1093270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1093273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1093283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1093291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093295 */     // MIs[0] policy
     /* 1093295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1093308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093327 */     // GIR_Coverage, 60689,
     /* 1093327 */     GIR_EraseRootFromParent_Done,
     /* 1093328 */   // Label 16083: @1093328
     /* 1093328 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1093405), // Rule ID 60692 //
     /* 1093333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093372 */     // MIs[0] policy
     /* 1093372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093404 */     // GIR_Coverage, 60692,
     /* 1093404 */     GIR_EraseRootFromParent_Done,
     /* 1093405 */   // Label 16084: @1093405
     /* 1093405 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1093482), // Rule ID 60693 //
     /* 1093410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1093421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1093424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1093427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1093437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1093445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093449 */     // MIs[0] policy
     /* 1093449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1093462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093481 */     // GIR_Coverage, 60693,
     /* 1093481 */     GIR_EraseRootFromParent_Done,
     /* 1093482 */   // Label 16085: @1093482
     /* 1093482 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1093559), // Rule ID 60696 //
     /* 1093487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093526 */     // MIs[0] policy
     /* 1093526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093558 */     // GIR_Coverage, 60696,
     /* 1093558 */     GIR_EraseRootFromParent_Done,
     /* 1093559 */   // Label 16086: @1093559
     /* 1093559 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1093636), // Rule ID 60697 //
     /* 1093564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1093572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093603 */     // MIs[0] policy
     /* 1093603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093613 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1093616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093635 */     // GIR_Coverage, 60697,
     /* 1093635 */     GIR_EraseRootFromParent_Done,
     /* 1093636 */   // Label 16087: @1093636
     /* 1093636 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1093713), // Rule ID 60700 //
     /* 1093641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093680 */     // MIs[0] policy
     /* 1093680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1093693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093712 */     // GIR_Coverage, 60700,
     /* 1093712 */     GIR_EraseRootFromParent_Done,
     /* 1093713 */   // Label 16088: @1093713
     /* 1093713 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1093790), // Rule ID 60701 //
     /* 1093718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093757 */     // MIs[0] policy
     /* 1093757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093767 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1093770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093789 */     // GIR_Coverage, 60701,
     /* 1093789 */     GIR_EraseRootFromParent_Done,
     /* 1093790 */   // Label 16089: @1093790
     /* 1093790 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1093867), // Rule ID 60704 //
     /* 1093795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093834 */     // MIs[0] policy
     /* 1093834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1093847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093866 */     // GIR_Coverage, 60704,
     /* 1093866 */     GIR_EraseRootFromParent_Done,
     /* 1093867 */   // Label 16090: @1093867
     /* 1093867 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1093944), // Rule ID 60705 //
     /* 1093872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093911 */     // MIs[0] policy
     /* 1093911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093921 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1093924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093943 */     // GIR_Coverage, 60705,
     /* 1093943 */     GIR_EraseRootFromParent_Done,
     /* 1093944 */   // Label 16091: @1093944
     /* 1093944 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1094021), // Rule ID 60708 //
     /* 1093949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093988 */     // MIs[0] policy
     /* 1093988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094020 */     // GIR_Coverage, 60708,
     /* 1094020 */     GIR_EraseRootFromParent_Done,
     /* 1094021 */   // Label 16092: @1094021
     /* 1094021 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1094098), // Rule ID 60709 //
     /* 1094026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1094037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1094040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1094043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094065 */     // MIs[0] policy
     /* 1094065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094075 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094097 */     // GIR_Coverage, 60709,
     /* 1094097 */     GIR_EraseRootFromParent_Done,
     /* 1094098 */   // Label 16093: @1094098
     /* 1094098 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1094175), // Rule ID 60712 //
     /* 1094103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094142 */     // MIs[0] policy
     /* 1094142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094152 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1094155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094174 */     // GIR_Coverage, 60712,
     /* 1094174 */     GIR_EraseRootFromParent_Done,
     /* 1094175 */   // Label 16094: @1094175
     /* 1094175 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1094252), // Rule ID 60713 //
     /* 1094180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1094191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1094194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1094197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094219 */     // MIs[0] policy
     /* 1094219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094229 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1094232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094251 */     // GIR_Coverage, 60713,
     /* 1094251 */     GIR_EraseRootFromParent_Done,
     /* 1094252 */   // Label 16095: @1094252
     /* 1094252 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1094329), // Rule ID 60716 //
     /* 1094257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094296 */     // MIs[0] policy
     /* 1094296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094328 */     // GIR_Coverage, 60716,
     /* 1094328 */     GIR_EraseRootFromParent_Done,
     /* 1094329 */   // Label 16096: @1094329
     /* 1094329 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1094406), // Rule ID 60717 //
     /* 1094334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1094345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1094348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1094351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094373 */     // MIs[0] policy
     /* 1094373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094383 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094405 */     // GIR_Coverage, 60717,
     /* 1094405 */     GIR_EraseRootFromParent_Done,
     /* 1094406 */   // Label 16097: @1094406
     /* 1094406 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1094483), // Rule ID 60720 //
     /* 1094411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094450 */     // MIs[0] policy
     /* 1094450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094482 */     // GIR_Coverage, 60720,
     /* 1094482 */     GIR_EraseRootFromParent_Done,
     /* 1094483 */   // Label 16098: @1094483
     /* 1094483 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1094560), // Rule ID 60721 //
     /* 1094488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094527 */     // MIs[0] policy
     /* 1094527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094537 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1094540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094559 */     // GIR_Coverage, 60721,
     /* 1094559 */     GIR_EraseRootFromParent_Done,
     /* 1094560 */   // Label 16099: @1094560
     /* 1094560 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1094637), // Rule ID 60724 //
     /* 1094565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094604 */     // MIs[0] policy
     /* 1094604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094636 */     // GIR_Coverage, 60724,
     /* 1094636 */     GIR_EraseRootFromParent_Done,
     /* 1094637 */   // Label 16100: @1094637
     /* 1094637 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1094714), // Rule ID 60725 //
     /* 1094642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094681 */     // MIs[0] policy
     /* 1094681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094691 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094713 */     // GIR_Coverage, 60725,
     /* 1094713 */     GIR_EraseRootFromParent_Done,
     /* 1094714 */   // Label 16101: @1094714
     /* 1094714 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1094791), // Rule ID 60728 //
     /* 1094719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094758 */     // MIs[0] policy
     /* 1094758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094790 */     // GIR_Coverage, 60728,
     /* 1094790 */     GIR_EraseRootFromParent_Done,
     /* 1094791 */   // Label 16102: @1094791
     /* 1094791 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1094868), // Rule ID 60729 //
     /* 1094796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094835 */     // MIs[0] policy
     /* 1094835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094867 */     // GIR_Coverage, 60729,
     /* 1094867 */     GIR_EraseRootFromParent_Done,
     /* 1094868 */   // Label 16103: @1094868
     /* 1094868 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1094945), // Rule ID 60732 //
     /* 1094873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094912 */     // MIs[0] policy
     /* 1094912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1094925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094944 */     // GIR_Coverage, 60732,
     /* 1094944 */     GIR_EraseRootFromParent_Done,
     /* 1094945 */   // Label 16104: @1094945
     /* 1094945 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1095022), // Rule ID 60733 //
     /* 1094950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1094958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094989 */     // MIs[0] policy
     /* 1094989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095021 */     // GIR_Coverage, 60733,
     /* 1095021 */     GIR_EraseRootFromParent_Done,
     /* 1095022 */   // Label 16105: @1095022
     /* 1095022 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1095099), // Rule ID 60736 //
     /* 1095027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095066 */     // MIs[0] policy
     /* 1095066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095098 */     // GIR_Coverage, 60736,
     /* 1095098 */     GIR_EraseRootFromParent_Done,
     /* 1095099 */   // Label 16106: @1095099
     /* 1095099 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1095176), // Rule ID 60737 //
     /* 1095104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1095115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1095118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1095121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1095124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1095131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1095139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095143 */     // MIs[0] policy
     /* 1095143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1095156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095175 */     // GIR_Coverage, 60737,
     /* 1095175 */     GIR_EraseRootFromParent_Done,
     /* 1095176 */   // Label 16107: @1095176
     /* 1095176 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1095253), // Rule ID 60740 //
     /* 1095181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095220 */     // MIs[0] policy
     /* 1095220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095252 */     // GIR_Coverage, 60740,
     /* 1095252 */     GIR_EraseRootFromParent_Done,
     /* 1095253 */   // Label 16108: @1095253
     /* 1095253 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1095330), // Rule ID 60741 //
     /* 1095258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1095269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1095272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1095275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095297 */     // MIs[0] policy
     /* 1095297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095329 */     // GIR_Coverage, 60741,
     /* 1095329 */     GIR_EraseRootFromParent_Done,
     /* 1095330 */   // Label 16109: @1095330
     /* 1095330 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1095407), // Rule ID 60744 //
     /* 1095335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095374 */     // MIs[0] policy
     /* 1095374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095406 */     // GIR_Coverage, 60744,
     /* 1095406 */     GIR_EraseRootFromParent_Done,
     /* 1095407 */   // Label 16110: @1095407
     /* 1095407 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1095484), // Rule ID 60745 //
     /* 1095412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1095423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1095426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1095429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095451 */     // MIs[0] policy
     /* 1095451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095461 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095483 */     // GIR_Coverage, 60745,
     /* 1095483 */     GIR_EraseRootFromParent_Done,
     /* 1095484 */   // Label 16111: @1095484
     /* 1095484 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1095561), // Rule ID 60748 //
     /* 1095489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095528 */     // MIs[0] policy
     /* 1095528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095538 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1095541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095560 */     // GIR_Coverage, 60748,
     /* 1095560 */     GIR_EraseRootFromParent_Done,
     /* 1095561 */   // Label 16112: @1095561
     /* 1095561 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1095638), // Rule ID 60749 //
     /* 1095566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095605 */     // MIs[0] policy
     /* 1095605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095615 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1095618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095637 */     // GIR_Coverage, 60749,
     /* 1095637 */     GIR_EraseRootFromParent_Done,
     /* 1095638 */   // Label 16113: @1095638
     /* 1095638 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1095715), // Rule ID 60752 //
     /* 1095643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095682 */     // MIs[0] policy
     /* 1095682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095714 */     // GIR_Coverage, 60752,
     /* 1095714 */     GIR_EraseRootFromParent_Done,
     /* 1095715 */   // Label 16114: @1095715
     /* 1095715 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1095792), // Rule ID 60753 //
     /* 1095720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095759 */     // MIs[0] policy
     /* 1095759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1095772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095791 */     // GIR_Coverage, 60753,
     /* 1095791 */     GIR_EraseRootFromParent_Done,
     /* 1095792 */   // Label 16115: @1095792
     /* 1095792 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1095869), // Rule ID 60756 //
     /* 1095797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095836 */     // MIs[0] policy
     /* 1095836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095868 */     // GIR_Coverage, 60756,
     /* 1095868 */     GIR_EraseRootFromParent_Done,
     /* 1095869 */   // Label 16116: @1095869
     /* 1095869 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1095946), // Rule ID 60757 //
     /* 1095874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095913 */     // MIs[0] policy
     /* 1095913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095923 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1095926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095945 */     // GIR_Coverage, 60757,
     /* 1095945 */     GIR_EraseRootFromParent_Done,
     /* 1095946 */   // Label 16117: @1095946
     /* 1095946 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1096023), // Rule ID 60760 //
     /* 1095951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1095959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095990 */     // MIs[0] policy
     /* 1095990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096022 */     // GIR_Coverage, 60760,
     /* 1096022 */     GIR_EraseRootFromParent_Done,
     /* 1096023 */   // Label 16118: @1096023
     /* 1096023 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1096100), // Rule ID 60761 //
     /* 1096028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1096039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1096042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1096045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1096048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096067 */     // MIs[0] policy
     /* 1096067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096099 */     // GIR_Coverage, 60761,
     /* 1096099 */     GIR_EraseRootFromParent_Done,
     /* 1096100 */   // Label 16119: @1096100
     /* 1096100 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1096177), // Rule ID 60764 //
     /* 1096105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096144 */     // MIs[0] policy
     /* 1096144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096176 */     // GIR_Coverage, 60764,
     /* 1096176 */     GIR_EraseRootFromParent_Done,
     /* 1096177 */   // Label 16120: @1096177
     /* 1096177 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1096254), // Rule ID 60765 //
     /* 1096182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1096193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1096196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1096199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096221 */     // MIs[0] policy
     /* 1096221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096253 */     // GIR_Coverage, 60765,
     /* 1096253 */     GIR_EraseRootFromParent_Done,
     /* 1096254 */   // Label 16121: @1096254
     /* 1096254 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1096331), // Rule ID 60768 //
     /* 1096259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096298 */     // MIs[0] policy
     /* 1096298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096330 */     // GIR_Coverage, 60768,
     /* 1096330 */     GIR_EraseRootFromParent_Done,
     /* 1096331 */   // Label 16122: @1096331
     /* 1096331 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1096408), // Rule ID 60769 //
     /* 1096336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1096347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1096350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1096353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096375 */     // MIs[0] policy
     /* 1096375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096385 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096407 */     // GIR_Coverage, 60769,
     /* 1096407 */     GIR_EraseRootFromParent_Done,
     /* 1096408 */   // Label 16123: @1096408
     /* 1096408 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1096485), // Rule ID 60772 //
     /* 1096413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096452 */     // MIs[0] policy
     /* 1096452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096484 */     // GIR_Coverage, 60772,
     /* 1096484 */     GIR_EraseRootFromParent_Done,
     /* 1096485 */   // Label 16124: @1096485
     /* 1096485 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1096562), // Rule ID 60773 //
     /* 1096490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096529 */     // MIs[0] policy
     /* 1096529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096539 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096561 */     // GIR_Coverage, 60773,
     /* 1096561 */     GIR_EraseRootFromParent_Done,
     /* 1096562 */   // Label 16125: @1096562
     /* 1096562 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1096639), // Rule ID 60776 //
     /* 1096567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096606 */     // MIs[0] policy
     /* 1096606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096638 */     // GIR_Coverage, 60776,
     /* 1096638 */     GIR_EraseRootFromParent_Done,
     /* 1096639 */   // Label 16126: @1096639
     /* 1096639 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1096716), // Rule ID 60777 //
     /* 1096644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096683 */     // MIs[0] policy
     /* 1096683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1096696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096715 */     // GIR_Coverage, 60777,
     /* 1096715 */     GIR_EraseRootFromParent_Done,
     /* 1096716 */   // Label 16127: @1096716
     /* 1096716 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1096793), // Rule ID 60780 //
     /* 1096721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096760 */     // MIs[0] policy
     /* 1096760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096792 */     // GIR_Coverage, 60780,
     /* 1096792 */     GIR_EraseRootFromParent_Done,
     /* 1096793 */   // Label 16128: @1096793
     /* 1096793 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1096870), // Rule ID 60781 //
     /* 1096798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096837 */     // MIs[0] policy
     /* 1096837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096847 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1096850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096869 */     // GIR_Coverage, 60781,
     /* 1096869 */     GIR_EraseRootFromParent_Done,
     /* 1096870 */   // Label 16129: @1096870
     /* 1096870 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1096947), // Rule ID 60784 //
     /* 1096875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096914 */     // MIs[0] policy
     /* 1096914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1096927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096946 */     // GIR_Coverage, 60784,
     /* 1096946 */     GIR_EraseRootFromParent_Done,
     /* 1096947 */   // Label 16130: @1096947
     /* 1096947 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1097024), // Rule ID 60785 //
     /* 1096952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1096960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096991 */     // MIs[0] policy
     /* 1096991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1097004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097023 */     // GIR_Coverage, 60785,
     /* 1097023 */     GIR_EraseRootFromParent_Done,
     /* 1097024 */   // Label 16131: @1097024
     /* 1097024 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1097101), // Rule ID 60788 //
     /* 1097029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097068 */     // MIs[0] policy
     /* 1097068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1097081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097100 */     // GIR_Coverage, 60788,
     /* 1097100 */     GIR_EraseRootFromParent_Done,
     /* 1097101 */   // Label 16132: @1097101
     /* 1097101 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1097178), // Rule ID 60789 //
     /* 1097106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1097117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1097120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1097123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097145 */     // MIs[0] policy
     /* 1097145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097155 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1097158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097177 */     // GIR_Coverage, 60789,
     /* 1097177 */     GIR_EraseRootFromParent_Done,
     /* 1097178 */   // Label 16133: @1097178
     /* 1097178 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1097255), // Rule ID 60792 //
     /* 1097183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097222 */     // MIs[0] policy
     /* 1097222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097254 */     // GIR_Coverage, 60792,
     /* 1097254 */     GIR_EraseRootFromParent_Done,
     /* 1097255 */   // Label 16134: @1097255
     /* 1097255 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1097332), // Rule ID 60793 //
     /* 1097260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1097271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1097274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1097277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097299 */     // MIs[0] policy
     /* 1097299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097331 */     // GIR_Coverage, 60793,
     /* 1097331 */     GIR_EraseRootFromParent_Done,
     /* 1097332 */   // Label 16135: @1097332
     /* 1097332 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1097409), // Rule ID 60796 //
     /* 1097337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097376 */     // MIs[0] policy
     /* 1097376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097386 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097408 */     // GIR_Coverage, 60796,
     /* 1097408 */     GIR_EraseRootFromParent_Done,
     /* 1097409 */   // Label 16136: @1097409
     /* 1097409 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1097486), // Rule ID 60797 //
     /* 1097414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1097425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1097428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1097431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097453 */     // MIs[0] policy
     /* 1097453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097463 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097485 */     // GIR_Coverage, 60797,
     /* 1097485 */     GIR_EraseRootFromParent_Done,
     /* 1097486 */   // Label 16137: @1097486
     /* 1097486 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1097563), // Rule ID 60800 //
     /* 1097491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097530 */     // MIs[0] policy
     /* 1097530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097562 */     // GIR_Coverage, 60800,
     /* 1097562 */     GIR_EraseRootFromParent_Done,
     /* 1097563 */   // Label 16138: @1097563
     /* 1097563 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1097640), // Rule ID 60801 //
     /* 1097568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097607 */     // MIs[0] policy
     /* 1097607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097617 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1097620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097639 */     // GIR_Coverage, 60801,
     /* 1097639 */     GIR_EraseRootFromParent_Done,
     /* 1097640 */   // Label 16139: @1097640
     /* 1097640 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1097717), // Rule ID 60804 //
     /* 1097645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097684 */     // MIs[0] policy
     /* 1097684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097716 */     // GIR_Coverage, 60804,
     /* 1097716 */     GIR_EraseRootFromParent_Done,
     /* 1097717 */   // Label 16140: @1097717
     /* 1097717 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1097794), // Rule ID 60805 //
     /* 1097722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097761 */     // MIs[0] policy
     /* 1097761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097793 */     // GIR_Coverage, 60805,
     /* 1097793 */     GIR_EraseRootFromParent_Done,
     /* 1097794 */   // Label 16141: @1097794
     /* 1097794 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1097871), // Rule ID 60808 //
     /* 1097799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097838 */     // MIs[0] policy
     /* 1097838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097870 */     // GIR_Coverage, 60808,
     /* 1097870 */     GIR_EraseRootFromParent_Done,
     /* 1097871 */   // Label 16142: @1097871
     /* 1097871 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1097948), // Rule ID 60809 //
     /* 1097876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097915 */     // MIs[0] policy
     /* 1097915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097925 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1097928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097947 */     // GIR_Coverage, 60809,
     /* 1097947 */     GIR_EraseRootFromParent_Done,
     /* 1097948 */   // Label 16143: @1097948
     /* 1097948 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1098025), // Rule ID 60812 //
     /* 1097953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1097961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097992 */     // MIs[0] policy
     /* 1097992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098002 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098024 */     // GIR_Coverage, 60812,
     /* 1098024 */     GIR_EraseRootFromParent_Done,
     /* 1098025 */   // Label 16144: @1098025
     /* 1098025 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1098102), // Rule ID 60813 //
     /* 1098030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1098041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1098044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1098047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098069 */     // MIs[0] policy
     /* 1098069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098079 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11119:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098101 */     // GIR_Coverage, 60813,
     /* 1098101 */     GIR_EraseRootFromParent_Done,
     /* 1098102 */   // Label 16145: @1098102
     /* 1098102 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1098179), // Rule ID 60816 //
     /* 1098107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098146 */     // MIs[0] policy
     /* 1098146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098178 */     // GIR_Coverage, 60816,
     /* 1098178 */     GIR_EraseRootFromParent_Done,
     /* 1098179 */   // Label 16146: @1098179
     /* 1098179 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1098256), // Rule ID 60817 //
     /* 1098184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1098195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1098198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1098201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098223 */     // MIs[0] policy
     /* 1098223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098233 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098255 */     // GIR_Coverage, 60817,
     /* 1098255 */     GIR_EraseRootFromParent_Done,
     /* 1098256 */   // Label 16147: @1098256
     /* 1098256 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1098333), // Rule ID 60820 //
     /* 1098261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098300 */     // MIs[0] policy
     /* 1098300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098332 */     // GIR_Coverage, 60820,
     /* 1098332 */     GIR_EraseRootFromParent_Done,
     /* 1098333 */   // Label 16148: @1098333
     /* 1098333 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1098410), // Rule ID 60821 //
     /* 1098338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1098349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1098352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1098355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1098358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098377 */     // MIs[0] policy
     /* 1098377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098387 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098409 */     // GIR_Coverage, 60821,
     /* 1098409 */     GIR_EraseRootFromParent_Done,
     /* 1098410 */   // Label 16149: @1098410
     /* 1098410 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1098487), // Rule ID 60824 //
     /* 1098415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098454 */     // MIs[0] policy
     /* 1098454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098486 */     // GIR_Coverage, 60824,
     /* 1098486 */     GIR_EraseRootFromParent_Done,
     /* 1098487 */   // Label 16150: @1098487
     /* 1098487 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1098564), // Rule ID 60825 //
     /* 1098492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098531 */     // MIs[0] policy
     /* 1098531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098541 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1098544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098563 */     // GIR_Coverage, 60825,
     /* 1098563 */     GIR_EraseRootFromParent_Done,
     /* 1098564 */   // Label 16151: @1098564
     /* 1098564 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1098641), // Rule ID 60828 //
     /* 1098569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098608 */     // MIs[0] policy
     /* 1098608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1098621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098640 */     // GIR_Coverage, 60828,
     /* 1098640 */     GIR_EraseRootFromParent_Done,
     /* 1098641 */   // Label 16152: @1098641
     /* 1098641 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1098718), // Rule ID 60829 //
     /* 1098646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098685 */     // MIs[0] policy
     /* 1098685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098695 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1098698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098717 */     // GIR_Coverage, 60829,
     /* 1098717 */     GIR_EraseRootFromParent_Done,
     /* 1098718 */   // Label 16153: @1098718
     /* 1098718 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1098795), // Rule ID 60832 //
     /* 1098723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098762 */     // MIs[0] policy
     /* 1098762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098772 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1098775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098794 */     // GIR_Coverage, 60832,
     /* 1098794 */     GIR_EraseRootFromParent_Done,
     /* 1098795 */   // Label 16154: @1098795
     /* 1098795 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1098872), // Rule ID 60833 //
     /* 1098800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098839 */     // MIs[0] policy
     /* 1098839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098849 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1098852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098871 */     // GIR_Coverage, 60833,
     /* 1098871 */     GIR_EraseRootFromParent_Done,
     /* 1098872 */   // Label 16155: @1098872
     /* 1098872 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1098949), // Rule ID 60836 //
     /* 1098877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098916 */     // MIs[0] policy
     /* 1098916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1098929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098948 */     // GIR_Coverage, 60836,
     /* 1098948 */     GIR_EraseRootFromParent_Done,
     /* 1098949 */   // Label 16156: @1098949
     /* 1098949 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1099026), // Rule ID 60837 //
     /* 1098954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1098962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098993 */     // MIs[0] policy
     /* 1098993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099003 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099025 */     // GIR_Coverage, 60837,
     /* 1099025 */     GIR_EraseRootFromParent_Done,
     /* 1099026 */   // Label 16157: @1099026
     /* 1099026 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1099103), // Rule ID 60840 //
     /* 1099031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099070 */     // MIs[0] policy
     /* 1099070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099102 */     // GIR_Coverage, 60840,
     /* 1099102 */     GIR_EraseRootFromParent_Done,
     /* 1099103 */   // Label 16158: @1099103
     /* 1099103 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1099180), // Rule ID 60841 //
     /* 1099108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1099119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1099122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1099125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099147 */     // MIs[0] policy
     /* 1099147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099157 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099179 */     // GIR_Coverage, 60841,
     /* 1099179 */     GIR_EraseRootFromParent_Done,
     /* 1099180 */   // Label 16159: @1099180
     /* 1099180 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1099257), // Rule ID 60844 //
     /* 1099185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099224 */     // MIs[0] policy
     /* 1099224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099256 */     // GIR_Coverage, 60844,
     /* 1099256 */     GIR_EraseRootFromParent_Done,
     /* 1099257 */   // Label 16160: @1099257
     /* 1099257 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1099334), // Rule ID 60845 //
     /* 1099262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1099273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1099276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1099279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099301 */     // MIs[0] policy
     /* 1099301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099311 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099333 */     // GIR_Coverage, 60845,
     /* 1099333 */     GIR_EraseRootFromParent_Done,
     /* 1099334 */   // Label 16161: @1099334
     /* 1099334 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1099411), // Rule ID 60848 //
     /* 1099339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099378 */     // MIs[0] policy
     /* 1099378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099410 */     // GIR_Coverage, 60848,
     /* 1099410 */     GIR_EraseRootFromParent_Done,
     /* 1099411 */   // Label 16162: @1099411
     /* 1099411 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1099488), // Rule ID 60849 //
     /* 1099416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1099427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1099430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1099433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1099436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099455 */     // MIs[0] policy
     /* 1099455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099465 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099487 */     // GIR_Coverage, 60849,
     /* 1099487 */     GIR_EraseRootFromParent_Done,
     /* 1099488 */   // Label 16163: @1099488
     /* 1099488 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1099565), // Rule ID 60852 //
     /* 1099493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099532 */     // MIs[0] policy
     /* 1099532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099564 */     // GIR_Coverage, 60852,
     /* 1099564 */     GIR_EraseRootFromParent_Done,
     /* 1099565 */   // Label 16164: @1099565
     /* 1099565 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1099642), // Rule ID 60853 //
     /* 1099570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099609 */     // MIs[0] policy
     /* 1099609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1099622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099641 */     // GIR_Coverage, 60853,
     /* 1099641 */     GIR_EraseRootFromParent_Done,
     /* 1099642 */   // Label 16165: @1099642
     /* 1099642 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1099719), // Rule ID 60856 //
     /* 1099647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099686 */     // MIs[0] policy
     /* 1099686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099718 */     // GIR_Coverage, 60856,
     /* 1099718 */     GIR_EraseRootFromParent_Done,
     /* 1099719 */   // Label 16166: @1099719
     /* 1099719 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1099796), // Rule ID 60857 //
     /* 1099724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099763 */     // MIs[0] policy
     /* 1099763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1099776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099795 */     // GIR_Coverage, 60857,
     /* 1099795 */     GIR_EraseRootFromParent_Done,
     /* 1099796 */   // Label 16167: @1099796
     /* 1099796 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1099873), // Rule ID 60860 //
     /* 1099801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099840 */     // MIs[0] policy
     /* 1099840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099872 */     // GIR_Coverage, 60860,
     /* 1099872 */     GIR_EraseRootFromParent_Done,
     /* 1099873 */   // Label 16168: @1099873
     /* 1099873 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1099950), // Rule ID 60861 //
     /* 1099878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099917 */     // MIs[0] policy
     /* 1099917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1099930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099949 */     // GIR_Coverage, 60861,
     /* 1099949 */     GIR_EraseRootFromParent_Done,
     /* 1099950 */   // Label 16169: @1099950
     /* 1099950 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1100027), // Rule ID 60864 //
     /* 1099955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1099963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099994 */     // MIs[0] policy
     /* 1099994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1100007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100026 */     // GIR_Coverage, 60864,
     /* 1100026 */     GIR_EraseRootFromParent_Done,
     /* 1100027 */   // Label 16170: @1100027
     /* 1100027 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1100104), // Rule ID 60865 //
     /* 1100032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1100043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1100046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1100049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1100059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1100067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100071 */     // MIs[0] policy
     /* 1100071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1100084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100103 */     // GIR_Coverage, 60865,
     /* 1100103 */     GIR_EraseRootFromParent_Done,
     /* 1100104 */   // Label 16171: @1100104
     /* 1100104 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1100181), // Rule ID 60868 //
     /* 1100109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100148 */     // MIs[0] policy
     /* 1100148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100158 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1100161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100180 */     // GIR_Coverage, 60868,
     /* 1100180 */     GIR_EraseRootFromParent_Done,
     /* 1100181 */   // Label 16172: @1100181
     /* 1100181 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1100258), // Rule ID 60869 //
     /* 1100186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1100197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1100200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1100203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1100213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1100221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100225 */     // MIs[0] policy
     /* 1100225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100235 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1100238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100257 */     // GIR_Coverage, 60869,
     /* 1100257 */     GIR_EraseRootFromParent_Done,
     /* 1100258 */   // Label 16173: @1100258
     /* 1100258 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1100335), // Rule ID 60872 //
     /* 1100263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100302 */     // MIs[0] policy
     /* 1100302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1100315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100334 */     // GIR_Coverage, 60872,
     /* 1100334 */     GIR_EraseRootFromParent_Done,
     /* 1100335 */   // Label 16174: @1100335
     /* 1100335 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1100412), // Rule ID 60873 //
     /* 1100340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1100348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1100351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1100354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1100357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1100367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1100375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100379 */     // MIs[0] policy
     /* 1100379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1100392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100411 */     // GIR_Coverage, 60873,
     /* 1100411 */     GIR_EraseRootFromParent_Done,
     /* 1100412 */   // Label 16175: @1100412
     /* 1100412 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1100489), // Rule ID 60876 //
     /* 1100417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100456 */     // MIs[0] policy
     /* 1100456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1100469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100488 */     // GIR_Coverage, 60876,
     /* 1100488 */     GIR_EraseRootFromParent_Done,
     /* 1100489 */   // Label 16176: @1100489
     /* 1100489 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1100566), // Rule ID 60877 //
     /* 1100494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100533 */     // MIs[0] policy
     /* 1100533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100543 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1100546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100565 */     // GIR_Coverage, 60877,
     /* 1100565 */     GIR_EraseRootFromParent_Done,
     /* 1100566 */   // Label 16177: @1100566
     /* 1100566 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1100643), // Rule ID 60880 //
     /* 1100571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100610 */     // MIs[0] policy
     /* 1100610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100642 */     // GIR_Coverage, 60880,
     /* 1100642 */     GIR_EraseRootFromParent_Done,
     /* 1100643 */   // Label 16178: @1100643
     /* 1100643 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1100720), // Rule ID 60881 //
     /* 1100648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100687 */     // MIs[0] policy
     /* 1100687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100719 */     // GIR_Coverage, 60881,
     /* 1100719 */     GIR_EraseRootFromParent_Done,
     /* 1100720 */   // Label 16179: @1100720
     /* 1100720 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1100797), // Rule ID 60884 //
     /* 1100725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100764 */     // MIs[0] policy
     /* 1100764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1100777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100796 */     // GIR_Coverage, 60884,
     /* 1100796 */     GIR_EraseRootFromParent_Done,
     /* 1100797 */   // Label 16180: @1100797
     /* 1100797 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1100874), // Rule ID 60885 //
     /* 1100802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100841 */     // MIs[0] policy
     /* 1100841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100851 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1100854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100873 */     // GIR_Coverage, 60885,
     /* 1100873 */     GIR_EraseRootFromParent_Done,
     /* 1100874 */   // Label 16181: @1100874
     /* 1100874 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1100951), // Rule ID 60888 //
     /* 1100879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1100882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100918 */     // MIs[0] policy
     /* 1100918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1100931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100950 */     // GIR_Coverage, 60888,
     /* 1100950 */     GIR_EraseRootFromParent_Done,
     /* 1100951 */   // Label 16182: @1100951
     /* 1100951 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1101028), // Rule ID 60889 //
     /* 1100956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1100959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1100964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100995 */     // MIs[0] policy
     /* 1100995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101005 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1101008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101027 */     // GIR_Coverage, 60889,
     /* 1101027 */     GIR_EraseRootFromParent_Done,
     /* 1101028 */   // Label 16183: @1101028
     /* 1101028 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1101105), // Rule ID 60892 //
     /* 1101033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101072 */     // MIs[0] policy
     /* 1101072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101104 */     // GIR_Coverage, 60892,
     /* 1101104 */     GIR_EraseRootFromParent_Done,
     /* 1101105 */   // Label 16184: @1101105
     /* 1101105 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1101182), // Rule ID 60893 //
     /* 1101110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1101121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1101124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1101127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101149 */     // MIs[0] policy
     /* 1101149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101181 */     // GIR_Coverage, 60893,
     /* 1101181 */     GIR_EraseRootFromParent_Done,
     /* 1101182 */   // Label 16185: @1101182
     /* 1101182 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1101259), // Rule ID 60896 //
     /* 1101187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101226 */     // MIs[0] policy
     /* 1101226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101258 */     // GIR_Coverage, 60896,
     /* 1101258 */     GIR_EraseRootFromParent_Done,
     /* 1101259 */   // Label 16186: @1101259
     /* 1101259 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1101336), // Rule ID 60897 //
     /* 1101264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1101275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1101278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1101281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101303 */     // MIs[0] policy
     /* 1101303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101313 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1101316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101335 */     // GIR_Coverage, 60897,
     /* 1101335 */     GIR_EraseRootFromParent_Done,
     /* 1101336 */   // Label 16187: @1101336
     /* 1101336 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1101413), // Rule ID 60900 //
     /* 1101341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101380 */     // MIs[0] policy
     /* 1101380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101412 */     // GIR_Coverage, 60900,
     /* 1101412 */     GIR_EraseRootFromParent_Done,
     /* 1101413 */   // Label 16188: @1101413
     /* 1101413 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1101490), // Rule ID 60901 //
     /* 1101418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1101429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1101432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1101435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101457 */     // MIs[0] policy
     /* 1101457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101467 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11117:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101489 */     // GIR_Coverage, 60901,
     /* 1101489 */     GIR_EraseRootFromParent_Done,
     /* 1101490 */   // Label 16189: @1101490
     /* 1101490 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1101567), // Rule ID 60904 //
     /* 1101495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101534 */     // MIs[0] policy
     /* 1101534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101566 */     // GIR_Coverage, 60904,
     /* 1101566 */     GIR_EraseRootFromParent_Done,
     /* 1101567 */   // Label 16190: @1101567
     /* 1101567 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1101644), // Rule ID 60905 //
     /* 1101572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101611 */     // MIs[0] policy
     /* 1101611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101643 */     // GIR_Coverage, 60905,
     /* 1101643 */     GIR_EraseRootFromParent_Done,
     /* 1101644 */   // Label 16191: @1101644
     /* 1101644 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1101721), // Rule ID 60908 //
     /* 1101649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101688 */     // MIs[0] policy
     /* 1101688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101720 */     // GIR_Coverage, 60908,
     /* 1101720 */     GIR_EraseRootFromParent_Done,
     /* 1101721 */   // Label 16192: @1101721
     /* 1101721 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1101798), // Rule ID 60909 //
     /* 1101726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101765 */     // MIs[0] policy
     /* 1101765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101797 */     // GIR_Coverage, 60909,
     /* 1101797 */     GIR_EraseRootFromParent_Done,
     /* 1101798 */   // Label 16193: @1101798
     /* 1101798 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1101875), // Rule ID 60912 //
     /* 1101803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101842 */     // MIs[0] policy
     /* 1101842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101874 */     // GIR_Coverage, 60912,
     /* 1101874 */     GIR_EraseRootFromParent_Done,
     /* 1101875 */   // Label 16194: @1101875
     /* 1101875 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1101952), // Rule ID 60913 //
     /* 1101880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1101883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101919 */     // MIs[0] policy
     /* 1101919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101929 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1101932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101951 */     // GIR_Coverage, 60913,
     /* 1101951 */     GIR_EraseRootFromParent_Done,
     /* 1101952 */   // Label 16195: @1101952
     /* 1101952 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1102029), // Rule ID 60916 //
     /* 1101957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1101960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1101965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101996 */     // MIs[0] policy
     /* 1101996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102028 */     // GIR_Coverage, 60916,
     /* 1102028 */     GIR_EraseRootFromParent_Done,
     /* 1102029 */   // Label 16196: @1102029
     /* 1102029 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1102106), // Rule ID 60917 //
     /* 1102034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1102045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1102048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1102051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102073 */     // MIs[0] policy
     /* 1102073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102105 */     // GIR_Coverage, 60917,
     /* 1102105 */     GIR_EraseRootFromParent_Done,
     /* 1102106 */   // Label 16197: @1102106
     /* 1102106 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1102183), // Rule ID 60920 //
     /* 1102111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102150 */     // MIs[0] policy
     /* 1102150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102182 */     // GIR_Coverage, 60920,
     /* 1102182 */     GIR_EraseRootFromParent_Done,
     /* 1102183 */   // Label 16198: @1102183
     /* 1102183 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1102260), // Rule ID 60921 //
     /* 1102188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1102199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1102202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1102205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102227 */     // MIs[0] policy
     /* 1102227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102237 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102259 */     // GIR_Coverage, 60921,
     /* 1102259 */     GIR_EraseRootFromParent_Done,
     /* 1102260 */   // Label 16199: @1102260
     /* 1102260 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1102337), // Rule ID 60924 //
     /* 1102265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102304 */     // MIs[0] policy
     /* 1102304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102336 */     // GIR_Coverage, 60924,
     /* 1102336 */     GIR_EraseRootFromParent_Done,
     /* 1102337 */   // Label 16200: @1102337
     /* 1102337 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1102414), // Rule ID 60925 //
     /* 1102342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1102353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1102356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1102359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1102362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102381 */     // MIs[0] policy
     /* 1102381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102391 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102413 */     // GIR_Coverage, 60925,
     /* 1102413 */     GIR_EraseRootFromParent_Done,
     /* 1102414 */   // Label 16201: @1102414
     /* 1102414 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1102491), // Rule ID 60928 //
     /* 1102419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102458 */     // MIs[0] policy
     /* 1102458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102490 */     // GIR_Coverage, 60928,
     /* 1102490 */     GIR_EraseRootFromParent_Done,
     /* 1102491 */   // Label 16202: @1102491
     /* 1102491 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1102568), // Rule ID 60929 //
     /* 1102496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102535 */     // MIs[0] policy
     /* 1102535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102567 */     // GIR_Coverage, 60929,
     /* 1102567 */     GIR_EraseRootFromParent_Done,
     /* 1102568 */   // Label 16203: @1102568
     /* 1102568 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1102645), // Rule ID 60932 //
     /* 1102573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102612 */     // MIs[0] policy
     /* 1102612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102622 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102644 */     // GIR_Coverage, 60932,
     /* 1102644 */     GIR_EraseRootFromParent_Done,
     /* 1102645 */   // Label 16204: @1102645
     /* 1102645 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1102722), // Rule ID 60933 //
     /* 1102650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102689 */     // MIs[0] policy
     /* 1102689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1102702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102721 */     // GIR_Coverage, 60933,
     /* 1102721 */     GIR_EraseRootFromParent_Done,
     /* 1102722 */   // Label 16205: @1102722
     /* 1102722 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1102799), // Rule ID 60936 //
     /* 1102727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102766 */     // MIs[0] policy
     /* 1102766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102798 */     // GIR_Coverage, 60936,
     /* 1102798 */     GIR_EraseRootFromParent_Done,
     /* 1102799 */   // Label 16206: @1102799
     /* 1102799 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1102876), // Rule ID 60937 //
     /* 1102804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102843 */     // MIs[0] policy
     /* 1102843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102853 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1102856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102875 */     // GIR_Coverage, 60937,
     /* 1102875 */     GIR_EraseRootFromParent_Done,
     /* 1102876 */   // Label 16207: @1102876
     /* 1102876 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1102953), // Rule ID 60940 //
     /* 1102881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1102884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102920 */     // MIs[0] policy
     /* 1102920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1102933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102952 */     // GIR_Coverage, 60940,
     /* 1102952 */     GIR_EraseRootFromParent_Done,
     /* 1102953 */   // Label 16208: @1102953
     /* 1102953 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1103030), // Rule ID 60941 //
     /* 1102958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1102961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1102966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102997 */     // MIs[0] policy
     /* 1102997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103029 */     // GIR_Coverage, 60941,
     /* 1103029 */     GIR_EraseRootFromParent_Done,
     /* 1103030 */   // Label 16209: @1103030
     /* 1103030 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1103107), // Rule ID 60944 //
     /* 1103035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103074 */     // MIs[0] policy
     /* 1103074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103106 */     // GIR_Coverage, 60944,
     /* 1103106 */     GIR_EraseRootFromParent_Done,
     /* 1103107 */   // Label 16210: @1103107
     /* 1103107 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1103184), // Rule ID 60945 //
     /* 1103112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1103123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1103126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1103129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103151 */     // MIs[0] policy
     /* 1103151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103161 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103183 */     // GIR_Coverage, 60945,
     /* 1103183 */     GIR_EraseRootFromParent_Done,
     /* 1103184 */   // Label 16211: @1103184
     /* 1103184 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1103261), // Rule ID 60948 //
     /* 1103189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103228 */     // MIs[0] policy
     /* 1103228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103260 */     // GIR_Coverage, 60948,
     /* 1103260 */     GIR_EraseRootFromParent_Done,
     /* 1103261 */   // Label 16212: @1103261
     /* 1103261 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1103338), // Rule ID 60949 //
     /* 1103266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1103277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1103280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1103283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1103286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103305 */     // MIs[0] policy
     /* 1103305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103337 */     // GIR_Coverage, 60949,
     /* 1103337 */     GIR_EraseRootFromParent_Done,
     /* 1103338 */   // Label 16213: @1103338
     /* 1103338 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1103415), // Rule ID 60952 //
     /* 1103343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103382 */     // MIs[0] policy
     /* 1103382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103414 */     // GIR_Coverage, 60952,
     /* 1103414 */     GIR_EraseRootFromParent_Done,
     /* 1103415 */   // Label 16214: @1103415
     /* 1103415 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1103492), // Rule ID 60953 //
     /* 1103420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1103431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1103434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1103437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1103447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1103455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103459 */     // MIs[0] policy
     /* 1103459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1103472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103491 */     // GIR_Coverage, 60953,
     /* 1103491 */     GIR_EraseRootFromParent_Done,
     /* 1103492 */   // Label 16215: @1103492
     /* 1103492 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1103569), // Rule ID 60956 //
     /* 1103497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103536 */     // MIs[0] policy
     /* 1103536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103568 */     // GIR_Coverage, 60956,
     /* 1103568 */     GIR_EraseRootFromParent_Done,
     /* 1103569 */   // Label 16216: @1103569
     /* 1103569 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1103646), // Rule ID 60957 //
     /* 1103574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103613 */     // MIs[0] policy
     /* 1103613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103623 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1103626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103645 */     // GIR_Coverage, 60957,
     /* 1103645 */     GIR_EraseRootFromParent_Done,
     /* 1103646 */   // Label 16217: @1103646
     /* 1103646 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1103723), // Rule ID 60960 //
     /* 1103651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1103654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103690 */     // MIs[0] policy
     /* 1103690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103722 */     // GIR_Coverage, 60960,
     /* 1103722 */     GIR_EraseRootFromParent_Done,
     /* 1103723 */   // Label 16218: @1103723
     /* 1103723 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1103800), // Rule ID 60961 //
     /* 1103728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1103731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1103736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103767 */     // MIs[0] policy
     /* 1103767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1103780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103799 */     // GIR_Coverage, 60961,
     /* 1103799 */     GIR_EraseRootFromParent_Done,
     /* 1103800 */   // Label 16219: @1103800
     /* 1103800 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1103877), // Rule ID 61384 //
     /* 1103805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103844 */     // MIs[0] policy
     /* 1103844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1103857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103876 */     // GIR_Coverage, 61384,
     /* 1103876 */     GIR_EraseRootFromParent_Done,
     /* 1103877 */   // Label 16220: @1103877
     /* 1103877 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1103954), // Rule ID 61385 //
     /* 1103882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103921 */     // MIs[0] policy
     /* 1103921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103931 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1103934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103953 */     // GIR_Coverage, 61385,
     /* 1103953 */     GIR_EraseRootFromParent_Done,
     /* 1103954 */   // Label 16221: @1103954
     /* 1103954 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1104031), // Rule ID 61388 //
     /* 1103959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103998 */     // MIs[0] policy
     /* 1103998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104030 */     // GIR_Coverage, 61388,
     /* 1104030 */     GIR_EraseRootFromParent_Done,
     /* 1104031 */   // Label 16222: @1104031
     /* 1104031 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1104108), // Rule ID 61389 //
     /* 1104036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1104047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1104050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1104053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104075 */     // MIs[0] policy
     /* 1104075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104085 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104107 */     // GIR_Coverage, 61389,
     /* 1104107 */     GIR_EraseRootFromParent_Done,
     /* 1104108 */   // Label 16223: @1104108
     /* 1104108 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1104185), // Rule ID 61392 //
     /* 1104113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104152 */     // MIs[0] policy
     /* 1104152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104184 */     // GIR_Coverage, 61392,
     /* 1104184 */     GIR_EraseRootFromParent_Done,
     /* 1104185 */   // Label 16224: @1104185
     /* 1104185 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1104262), // Rule ID 61393 //
     /* 1104190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1104201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1104204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1104207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104229 */     // MIs[0] policy
     /* 1104229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104261 */     // GIR_Coverage, 61393,
     /* 1104261 */     GIR_EraseRootFromParent_Done,
     /* 1104262 */   // Label 16225: @1104262
     /* 1104262 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1104339), // Rule ID 61396 //
     /* 1104267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104306 */     // MIs[0] policy
     /* 1104306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104338 */     // GIR_Coverage, 61396,
     /* 1104338 */     GIR_EraseRootFromParent_Done,
     /* 1104339 */   // Label 16226: @1104339
     /* 1104339 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1104416), // Rule ID 61397 //
     /* 1104344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1104355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1104358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1104361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104383 */     // MIs[0] policy
     /* 1104383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104393 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1104396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104415 */     // GIR_Coverage, 61397,
     /* 1104415 */     GIR_EraseRootFromParent_Done,
     /* 1104416 */   // Label 16227: @1104416
     /* 1104416 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1104493), // Rule ID 61400 //
     /* 1104421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104460 */     // MIs[0] policy
     /* 1104460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104470 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104492 */     // GIR_Coverage, 61400,
     /* 1104492 */     GIR_EraseRootFromParent_Done,
     /* 1104493 */   // Label 16228: @1104493
     /* 1104493 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1104570), // Rule ID 61401 //
     /* 1104498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104537 */     // MIs[0] policy
     /* 1104537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104547 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104569 */     // GIR_Coverage, 61401,
     /* 1104569 */     GIR_EraseRootFromParent_Done,
     /* 1104570 */   // Label 16229: @1104570
     /* 1104570 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1104647), // Rule ID 61404 //
     /* 1104575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104614 */     // MIs[0] policy
     /* 1104614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104646 */     // GIR_Coverage, 61404,
     /* 1104646 */     GIR_EraseRootFromParent_Done,
     /* 1104647 */   // Label 16230: @1104647
     /* 1104647 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1104724), // Rule ID 61405 //
     /* 1104652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104691 */     // MIs[0] policy
     /* 1104691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104701 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1104704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104723 */     // GIR_Coverage, 61405,
     /* 1104723 */     GIR_EraseRootFromParent_Done,
     /* 1104724 */   // Label 16231: @1104724
     /* 1104724 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1104801), // Rule ID 61408 //
     /* 1104729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104768 */     // MIs[0] policy
     /* 1104768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104800 */     // GIR_Coverage, 61408,
     /* 1104800 */     GIR_EraseRootFromParent_Done,
     /* 1104801 */   // Label 16232: @1104801
     /* 1104801 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1104878), // Rule ID 61409 //
     /* 1104806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104845 */     // MIs[0] policy
     /* 1104845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104855 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104877 */     // GIR_Coverage, 61409,
     /* 1104877 */     GIR_EraseRootFromParent_Done,
     /* 1104878 */   // Label 16233: @1104878
     /* 1104878 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1104955), // Rule ID 61412 //
     /* 1104883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104922 */     // MIs[0] policy
     /* 1104922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1104935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104954 */     // GIR_Coverage, 61412,
     /* 1104954 */     GIR_EraseRootFromParent_Done,
     /* 1104955 */   // Label 16234: @1104955
     /* 1104955 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1105032), // Rule ID 61413 //
     /* 1104960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1104968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104999 */     // MIs[0] policy
     /* 1104999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105009 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105031 */     // GIR_Coverage, 61413,
     /* 1105031 */     GIR_EraseRootFromParent_Done,
     /* 1105032 */   // Label 16235: @1105032
     /* 1105032 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1105109), // Rule ID 61416 //
     /* 1105037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105076 */     // MIs[0] policy
     /* 1105076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105108 */     // GIR_Coverage, 61416,
     /* 1105108 */     GIR_EraseRootFromParent_Done,
     /* 1105109 */   // Label 16236: @1105109
     /* 1105109 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1105186), // Rule ID 61417 //
     /* 1105114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1105125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1105128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1105131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105153 */     // MIs[0] policy
     /* 1105153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105163 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105185 */     // GIR_Coverage, 61417,
     /* 1105185 */     GIR_EraseRootFromParent_Done,
     /* 1105186 */   // Label 16237: @1105186
     /* 1105186 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1105263), // Rule ID 61420 //
     /* 1105191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105230 */     // MIs[0] policy
     /* 1105230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105262 */     // GIR_Coverage, 61420,
     /* 1105262 */     GIR_EraseRootFromParent_Done,
     /* 1105263 */   // Label 16238: @1105263
     /* 1105263 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1105340), // Rule ID 61421 //
     /* 1105268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1105279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1105282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1105285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1105288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1105295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1105303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105307 */     // MIs[0] policy
     /* 1105307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105317 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1105320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105339 */     // GIR_Coverage, 61421,
     /* 1105339 */     GIR_EraseRootFromParent_Done,
     /* 1105340 */   // Label 16239: @1105340
     /* 1105340 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1105417), // Rule ID 61424 //
     /* 1105345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105384 */     // MIs[0] policy
     /* 1105384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105416 */     // GIR_Coverage, 61424,
     /* 1105416 */     GIR_EraseRootFromParent_Done,
     /* 1105417 */   // Label 16240: @1105417
     /* 1105417 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1105494), // Rule ID 61425 //
     /* 1105422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1105433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1105436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1105439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105461 */     // MIs[0] policy
     /* 1105461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105493 */     // GIR_Coverage, 61425,
     /* 1105493 */     GIR_EraseRootFromParent_Done,
     /* 1105494 */   // Label 16241: @1105494
     /* 1105494 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1105571), // Rule ID 61428 //
     /* 1105499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105538 */     // MIs[0] policy
     /* 1105538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105548 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1105551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105570 */     // GIR_Coverage, 61428,
     /* 1105570 */     GIR_EraseRootFromParent_Done,
     /* 1105571 */   // Label 16242: @1105571
     /* 1105571 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1105648), // Rule ID 61429 //
     /* 1105576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105615 */     // MIs[0] policy
     /* 1105615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105625 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1105628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105647 */     // GIR_Coverage, 61429,
     /* 1105647 */     GIR_EraseRootFromParent_Done,
     /* 1105648 */   // Label 16243: @1105648
     /* 1105648 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1105725), // Rule ID 61432 //
     /* 1105653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105692 */     // MIs[0] policy
     /* 1105692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1105705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105724 */     // GIR_Coverage, 61432,
     /* 1105724 */     GIR_EraseRootFromParent_Done,
     /* 1105725 */   // Label 16244: @1105725
     /* 1105725 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1105802), // Rule ID 61433 //
     /* 1105730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105769 */     // MIs[0] policy
     /* 1105769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105779 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1105782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105801 */     // GIR_Coverage, 61433,
     /* 1105801 */     GIR_EraseRootFromParent_Done,
     /* 1105802 */   // Label 16245: @1105802
     /* 1105802 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1105879), // Rule ID 61436 //
     /* 1105807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105846 */     // MIs[0] policy
     /* 1105846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105878 */     // GIR_Coverage, 61436,
     /* 1105878 */     GIR_EraseRootFromParent_Done,
     /* 1105879 */   // Label 16246: @1105879
     /* 1105879 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1105956), // Rule ID 61437 //
     /* 1105884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105923 */     // MIs[0] policy
     /* 1105923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1105936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105955 */     // GIR_Coverage, 61437,
     /* 1105955 */     GIR_EraseRootFromParent_Done,
     /* 1105956 */   // Label 16247: @1105956
     /* 1105956 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1106033), // Rule ID 61440 //
     /* 1105961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1105969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106000 */     // MIs[0] policy
     /* 1106000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106032 */     // GIR_Coverage, 61440,
     /* 1106032 */     GIR_EraseRootFromParent_Done,
     /* 1106033 */   // Label 16248: @1106033
     /* 1106033 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1106110), // Rule ID 61441 //
     /* 1106038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1106049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1106052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1106055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106077 */     // MIs[0] policy
     /* 1106077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106109 */     // GIR_Coverage, 61441,
     /* 1106109 */     GIR_EraseRootFromParent_Done,
     /* 1106110 */   // Label 16249: @1106110
     /* 1106110 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1106187), // Rule ID 61444 //
     /* 1106115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106154 */     // MIs[0] policy
     /* 1106154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106186 */     // GIR_Coverage, 61444,
     /* 1106186 */     GIR_EraseRootFromParent_Done,
     /* 1106187 */   // Label 16250: @1106187
     /* 1106187 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1106264), // Rule ID 61445 //
     /* 1106192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1106203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1106206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1106209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1106212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106231 */     // MIs[0] policy
     /* 1106231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1106260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106263 */     // GIR_Coverage, 61445,
     /* 1106263 */     GIR_EraseRootFromParent_Done,
     /* 1106264 */   // Label 16251: @1106264
     /* 1106264 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1106341), // Rule ID 61448 //
     /* 1106269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106308 */     // MIs[0] policy
     /* 1106308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106340 */     // GIR_Coverage, 61448,
     /* 1106340 */     GIR_EraseRootFromParent_Done,
     /* 1106341 */   // Label 16252: @1106341
     /* 1106341 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1106418), // Rule ID 61449 //
     /* 1106346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106385 */     // MIs[0] policy
     /* 1106385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106417 */     // GIR_Coverage, 61449,
     /* 1106417 */     GIR_EraseRootFromParent_Done,
     /* 1106418 */   // Label 16253: @1106418
     /* 1106418 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1106495), // Rule ID 61452 //
     /* 1106423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106462 */     // MIs[0] policy
     /* 1106462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106494 */     // GIR_Coverage, 61452,
     /* 1106494 */     GIR_EraseRootFromParent_Done,
     /* 1106495 */   // Label 16254: @1106495
     /* 1106495 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1106572), // Rule ID 61453 //
     /* 1106500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106539 */     // MIs[0] policy
     /* 1106539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106549 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106571 */     // GIR_Coverage, 61453,
     /* 1106571 */     GIR_EraseRootFromParent_Done,
     /* 1106572 */   // Label 16255: @1106572
     /* 1106572 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1106649), // Rule ID 61456 //
     /* 1106577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106616 */     // MIs[0] policy
     /* 1106616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106648 */     // GIR_Coverage, 61456,
     /* 1106648 */     GIR_EraseRootFromParent_Done,
     /* 1106649 */   // Label 16256: @1106649
     /* 1106649 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1106726), // Rule ID 61457 //
     /* 1106654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106693 */     // MIs[0] policy
     /* 1106693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106703 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1106706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106725 */     // GIR_Coverage, 61457,
     /* 1106725 */     GIR_EraseRootFromParent_Done,
     /* 1106726 */   // Label 16257: @1106726
     /* 1106726 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1106803), // Rule ID 61460 //
     /* 1106731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106770 */     // MIs[0] policy
     /* 1106770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106802 */     // GIR_Coverage, 61460,
     /* 1106802 */     GIR_EraseRootFromParent_Done,
     /* 1106803 */   // Label 16258: @1106803
     /* 1106803 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1106880), // Rule ID 61461 //
     /* 1106808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106847 */     // MIs[0] policy
     /* 1106847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1106860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106879 */     // GIR_Coverage, 61461,
     /* 1106879 */     GIR_EraseRootFromParent_Done,
     /* 1106880 */   // Label 16259: @1106880
     /* 1106880 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1106957), // Rule ID 61464 //
     /* 1106885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106924 */     // MIs[0] policy
     /* 1106924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106934 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1106937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106956 */     // GIR_Coverage, 61464,
     /* 1106956 */     GIR_EraseRootFromParent_Done,
     /* 1106957 */   // Label 16260: @1106957
     /* 1106957 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1107034), // Rule ID 61465 //
     /* 1106962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1106970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107001 */     // MIs[0] policy
     /* 1107001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107011 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1107014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107033 */     // GIR_Coverage, 61465,
     /* 1107033 */     GIR_EraseRootFromParent_Done,
     /* 1107034 */   // Label 16261: @1107034
     /* 1107034 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1107111), // Rule ID 61468 //
     /* 1107039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1107047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107078 */     // MIs[0] policy
     /* 1107078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1107091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107110 */     // GIR_Coverage, 61468,
     /* 1107110 */     GIR_EraseRootFromParent_Done,
     /* 1107111 */   // Label 16262: @1107111
     /* 1107111 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1107188), // Rule ID 61469 //
     /* 1107116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1107124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1107127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1107130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1107133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1107136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1107143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107155 */     // MIs[0] policy
     /* 1107155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1107168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1107184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107187 */     // GIR_Coverage, 61469,
     /* 1107187 */     GIR_EraseRootFromParent_Done,
     /* 1107188 */   // Label 16263: @1107188
     /* 1107188 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1107265), // Rule ID 61472 //
     /* 1107193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1107204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1107207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1107210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107232 */     // MIs[0] policy
     /* 1107232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1107245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107264 */     // GIR_Coverage, 61472,
     /* 1107264 */     GIR_EraseRootFromParent_Done,
     /* 1107265 */   // Label 16264: @1107265
     /* 1107265 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1107342), // Rule ID 61473 //
     /* 1107270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1107281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1107284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1107287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107309 */     // MIs[0] policy
     /* 1107309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1107322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107341 */     // GIR_Coverage, 61473,
     /* 1107341 */     GIR_EraseRootFromParent_Done,
     /* 1107342 */   // Label 16265: @1107342
     /* 1107342 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1107419), // Rule ID 61476 //
     /* 1107347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1107358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1107361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1107364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107386 */     // MIs[0] policy
     /* 1107386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107396 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107418 */     // GIR_Coverage, 61476,
     /* 1107418 */     GIR_EraseRootFromParent_Done,
     /* 1107419 */   // Label 16266: @1107419
     /* 1107419 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1107496), // Rule ID 61477 //
     /* 1107424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1107435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1107438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1107441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107463 */     // MIs[0] policy
     /* 1107463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107495 */     // GIR_Coverage, 61477,
     /* 1107495 */     GIR_EraseRootFromParent_Done,
     /* 1107496 */   // Label 16267: @1107496
     /* 1107496 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1107573), // Rule ID 61480 //
     /* 1107501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1107512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1107515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1107518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1107521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107540 */     // MIs[0] policy
     /* 1107540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107572 */     // GIR_Coverage, 61480,
     /* 1107572 */     GIR_EraseRootFromParent_Done,
     /* 1107573 */   // Label 16268: @1107573
     /* 1107573 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1107650), // Rule ID 61481 //
     /* 1107578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1107589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1107592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1107595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1107598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107617 */     // MIs[0] policy
     /* 1107617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1107646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107649 */     // GIR_Coverage, 61481,
     /* 1107649 */     GIR_EraseRootFromParent_Done,
     /* 1107650 */   // Label 16269: @1107650
     /* 1107650 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1107727), // Rule ID 61484 //
     /* 1107655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1107666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1107669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1107672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107694 */     // MIs[0] policy
     /* 1107694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107726 */     // GIR_Coverage, 61484,
     /* 1107726 */     GIR_EraseRootFromParent_Done,
     /* 1107727 */   // Label 16270: @1107727
     /* 1107727 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1107804), // Rule ID 61485 //
     /* 1107732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1107743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1107746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1107749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107771 */     // MIs[0] policy
     /* 1107771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1107784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107803 */     // GIR_Coverage, 61485,
     /* 1107803 */     GIR_EraseRootFromParent_Done,
     /* 1107804 */   // Label 16271: @1107804
     /* 1107804 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1107881), // Rule ID 61488 //
     /* 1107809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1107820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1107823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1107826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107848 */     // MIs[0] policy
     /* 1107848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107880 */     // GIR_Coverage, 61488,
     /* 1107880 */     GIR_EraseRootFromParent_Done,
     /* 1107881 */   // Label 16272: @1107881
     /* 1107881 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1107958), // Rule ID 61489 //
     /* 1107886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1107889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1107897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1107900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1107903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1107906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1107925 */     // MIs[0] policy
     /* 1107925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107935 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1107938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1107940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1107942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1107944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1107946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1107954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107957 */     // GIR_Coverage, 61489,
     /* 1107957 */     GIR_EraseRootFromParent_Done,
     /* 1107958 */   // Label 16273: @1107958
     /* 1107958 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1108035), // Rule ID 61492 //
     /* 1107963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1107966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1107971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1107983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1107990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108002 */     // MIs[0] policy
     /* 1108002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108012 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1108015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108034 */     // GIR_Coverage, 61492,
     /* 1108034 */     GIR_EraseRootFromParent_Done,
     /* 1108035 */   // Label 16274: @1108035
     /* 1108035 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1108112), // Rule ID 61493 //
     /* 1108040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108079 */     // MIs[0] policy
     /* 1108079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108089 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1108092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108111 */     // GIR_Coverage, 61493,
     /* 1108111 */     GIR_EraseRootFromParent_Done,
     /* 1108112 */   // Label 16275: @1108112
     /* 1108112 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1108189), // Rule ID 61496 //
     /* 1108117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1108128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1108131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1108134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1108137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108156 */     // MIs[0] policy
     /* 1108156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108188 */     // GIR_Coverage, 61496,
     /* 1108188 */     GIR_EraseRootFromParent_Done,
     /* 1108189 */   // Label 16276: @1108189
     /* 1108189 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1108266), // Rule ID 61497 //
     /* 1108194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1108205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1108208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1108211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1108214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108233 */     // MIs[0] policy
     /* 1108233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108243 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108265 */     // GIR_Coverage, 61497,
     /* 1108265 */     GIR_EraseRootFromParent_Done,
     /* 1108266 */   // Label 16277: @1108266
     /* 1108266 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1108343), // Rule ID 61500 //
     /* 1108271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1108282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1108285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1108288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1108291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108310 */     // MIs[0] policy
     /* 1108310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108342 */     // GIR_Coverage, 61500,
     /* 1108342 */     GIR_EraseRootFromParent_Done,
     /* 1108343 */   // Label 16278: @1108343
     /* 1108343 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1108420), // Rule ID 61501 //
     /* 1108348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1108359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1108362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1108365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1108368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108387 */     // MIs[0] policy
     /* 1108387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108397 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1108416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108419 */     // GIR_Coverage, 61501,
     /* 1108419 */     GIR_EraseRootFromParent_Done,
     /* 1108420 */   // Label 16279: @1108420
     /* 1108420 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1108497), // Rule ID 61504 //
     /* 1108425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1108445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108464 */     // MIs[0] policy
     /* 1108464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108496 */     // GIR_Coverage, 61504,
     /* 1108496 */     GIR_EraseRootFromParent_Done,
     /* 1108497 */   // Label 16280: @1108497
     /* 1108497 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1108574), // Rule ID 61505 //
     /* 1108502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1108522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108541 */     // MIs[0] policy
     /* 1108541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108551 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108573 */     // GIR_Coverage, 61505,
     /* 1108573 */     GIR_EraseRootFromParent_Done,
     /* 1108574 */   // Label 16281: @1108574
     /* 1108574 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1108651), // Rule ID 61508 //
     /* 1108579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1108590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1108593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1108596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108618 */     // MIs[0] policy
     /* 1108618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1108647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108650 */     // GIR_Coverage, 61508,
     /* 1108650 */     GIR_EraseRootFromParent_Done,
     /* 1108651 */   // Label 16282: @1108651
     /* 1108651 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1108728), // Rule ID 61509 //
     /* 1108656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1108667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1108670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1108673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1108676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1108683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108695 */     // MIs[0] policy
     /* 1108695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108705 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1108708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1108724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108727 */     // GIR_Coverage, 61509,
     /* 1108727 */     GIR_EraseRootFromParent_Done,
     /* 1108728 */   // Label 16283: @1108728
     /* 1108728 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1108805), // Rule ID 61512 //
     /* 1108733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1108744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1108747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1108750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1108753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1108760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108772 */     // MIs[0] policy
     /* 1108772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1108785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108804 */     // GIR_Coverage, 61512,
     /* 1108804 */     GIR_EraseRootFromParent_Done,
     /* 1108805 */   // Label 16284: @1108805
     /* 1108805 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1108882), // Rule ID 61513 //
     /* 1108810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1108821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1108824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1108827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1108830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1108837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108849 */     // MIs[0] policy
     /* 1108849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1108862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108881 */     // GIR_Coverage, 61513,
     /* 1108881 */     GIR_EraseRootFromParent_Done,
     /* 1108882 */   // Label 16285: @1108882
     /* 1108882 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1108959), // Rule ID 61516 //
     /* 1108887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1108890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1108898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1108901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1108904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1108907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1108914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1108926 */     // MIs[0] policy
     /* 1108926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108936 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1108939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1108941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1108943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1108945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1108947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1108955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108958 */     // GIR_Coverage, 61516,
     /* 1108958 */     GIR_EraseRootFromParent_Done,
     /* 1108959 */   // Label 16286: @1108959
     /* 1108959 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1109036), // Rule ID 61517 //
     /* 1108964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1108967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1108972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1108975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1108978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1108981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1108984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1108991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109003 */     // MIs[0] policy
     /* 1109003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109013 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109035 */     // GIR_Coverage, 61517,
     /* 1109035 */     GIR_EraseRootFromParent_Done,
     /* 1109036 */   // Label 16287: @1109036
     /* 1109036 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1109113), // Rule ID 61520 //
     /* 1109041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1109052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1109055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1109058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1109061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109080 */     // MIs[0] policy
     /* 1109080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109112 */     // GIR_Coverage, 61520,
     /* 1109112 */     GIR_EraseRootFromParent_Done,
     /* 1109113 */   // Label 16288: @1109113
     /* 1109113 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1109190), // Rule ID 61521 //
     /* 1109118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1109129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1109132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1109135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1109138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109157 */     // MIs[0] policy
     /* 1109157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109167 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1109186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109189 */     // GIR_Coverage, 61521,
     /* 1109189 */     GIR_EraseRootFromParent_Done,
     /* 1109190 */   // Label 16289: @1109190
     /* 1109190 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1109267), // Rule ID 61524 //
     /* 1109195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1109206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1109209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1109212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109234 */     // MIs[0] policy
     /* 1109234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109266 */     // GIR_Coverage, 61524,
     /* 1109266 */     GIR_EraseRootFromParent_Done,
     /* 1109267 */   // Label 16290: @1109267
     /* 1109267 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1109344), // Rule ID 61525 //
     /* 1109272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1109283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1109286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1109289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109311 */     // MIs[0] policy
     /* 1109311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109343 */     // GIR_Coverage, 61525,
     /* 1109343 */     GIR_EraseRootFromParent_Done,
     /* 1109344 */   // Label 16291: @1109344
     /* 1109344 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1109421), // Rule ID 61528 //
     /* 1109349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1109360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1109363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1109366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109388 */     // MIs[0] policy
     /* 1109388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109420 */     // GIR_Coverage, 61528,
     /* 1109420 */     GIR_EraseRootFromParent_Done,
     /* 1109421 */   // Label 16292: @1109421
     /* 1109421 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1109498), // Rule ID 61529 //
     /* 1109426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1109437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1109440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1109443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109465 */     // MIs[0] policy
     /* 1109465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109475 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109497 */     // GIR_Coverage, 61529,
     /* 1109497 */     GIR_EraseRootFromParent_Done,
     /* 1109498 */   // Label 16293: @1109498
     /* 1109498 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1109575), // Rule ID 61532 //
     /* 1109503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1109514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1109517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1109520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1109523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109542 */     // MIs[0] policy
     /* 1109542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109574 */     // GIR_Coverage, 61532,
     /* 1109574 */     GIR_EraseRootFromParent_Done,
     /* 1109575 */   // Label 16294: @1109575
     /* 1109575 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1109652), // Rule ID 61533 //
     /* 1109580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1109591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1109594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1109597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1109600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109619 */     // MIs[0] policy
     /* 1109619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109629 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1109632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1109648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109651 */     // GIR_Coverage, 61533,
     /* 1109651 */     GIR_EraseRootFromParent_Done,
     /* 1109652 */   // Label 16295: @1109652
     /* 1109652 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1109729), // Rule ID 61536 //
     /* 1109657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1109677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109696 */     // MIs[0] policy
     /* 1109696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109728 */     // GIR_Coverage, 61536,
     /* 1109728 */     GIR_EraseRootFromParent_Done,
     /* 1109729 */   // Label 16296: @1109729
     /* 1109729 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1109806), // Rule ID 61537 //
     /* 1109734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1109754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1109761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109773 */     // MIs[0] policy
     /* 1109773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1109786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109805 */     // GIR_Coverage, 61537,
     /* 1109805 */     GIR_EraseRootFromParent_Done,
     /* 1109806 */   // Label 16297: @1109806
     /* 1109806 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1109883), // Rule ID 61540 //
     /* 1109811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109850 */     // MIs[0] policy
     /* 1109850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109882 */     // GIR_Coverage, 61540,
     /* 1109882 */     GIR_EraseRootFromParent_Done,
     /* 1109883 */   // Label 16298: @1109883
     /* 1109883 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1109960), // Rule ID 61541 //
     /* 1109888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1109891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1109908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1109915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1109927 */     // MIs[0] policy
     /* 1109927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109937 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1109940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1109942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1109944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1109946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1109948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109959 */     // GIR_Coverage, 61541,
     /* 1109959 */     GIR_EraseRootFromParent_Done,
     /* 1109960 */   // Label 16299: @1109960
     /* 1109960 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1110037), // Rule ID 61544 //
     /* 1109965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1109968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1109973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1109985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1109992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110004 */     // MIs[0] policy
     /* 1110004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110036 */     // GIR_Coverage, 61544,
     /* 1110036 */     GIR_EraseRootFromParent_Done,
     /* 1110037 */   // Label 16300: @1110037
     /* 1110037 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1110114), // Rule ID 61545 //
     /* 1110042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1110062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110081 */     // MIs[0] policy
     /* 1110081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110113 */     // GIR_Coverage, 61545,
     /* 1110113 */     GIR_EraseRootFromParent_Done,
     /* 1110114 */   // Label 16301: @1110114
     /* 1110114 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1110191), // Rule ID 61548 //
     /* 1110119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1110139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1110146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110158 */     // MIs[0] policy
     /* 1110158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1110171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110190 */     // GIR_Coverage, 61548,
     /* 1110190 */     GIR_EraseRootFromParent_Done,
     /* 1110191 */   // Label 16302: @1110191
     /* 1110191 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1110268), // Rule ID 61549 //
     /* 1110196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1110216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1110223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110235 */     // MIs[0] policy
     /* 1110235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110245 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1110248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110267 */     // GIR_Coverage, 61549,
     /* 1110267 */     GIR_EraseRootFromParent_Done,
     /* 1110268 */   // Label 16303: @1110268
     /* 1110268 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1110345), // Rule ID 61552 //
     /* 1110273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1110293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1110300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110312 */     // MIs[0] policy
     /* 1110312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1110325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110344 */     // GIR_Coverage, 61552,
     /* 1110344 */     GIR_EraseRootFromParent_Done,
     /* 1110345 */   // Label 16304: @1110345
     /* 1110345 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1110422), // Rule ID 61553 //
     /* 1110350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1110370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1110377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110389 */     // MIs[0] policy
     /* 1110389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110399 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1110402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110421 */     // GIR_Coverage, 61553,
     /* 1110421 */     GIR_EraseRootFromParent_Done,
     /* 1110422 */   // Label 16305: @1110422
     /* 1110422 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1110499), // Rule ID 61556 //
     /* 1110427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1110430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1110447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110466 */     // MIs[0] policy
     /* 1110466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110498 */     // GIR_Coverage, 61556,
     /* 1110498 */     GIR_EraseRootFromParent_Done,
     /* 1110499 */   // Label 16306: @1110499
     /* 1110499 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1110576), // Rule ID 61557 //
     /* 1110504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1110507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1110512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1110524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1110531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1110543 */     // MIs[0] policy
     /* 1110543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110553 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1110556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1110558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1110560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1110562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1110564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110575 */     // GIR_Coverage, 61557,
     /* 1110575 */     GIR_EraseRootFromParent_Done,
     /* 1110576 */   // Label 16307: @1110576
     /* 1110576 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1110653), // Rule ID 62082 //
     /* 1110581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110620 */     // MIs[0] policy
     /* 1110620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1110633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110652 */     // GIR_Coverage, 62082,
     /* 1110652 */     GIR_EraseRootFromParent_Done,
     /* 1110653 */   // Label 16308: @1110653
     /* 1110653 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1110730), // Rule ID 62083 //
     /* 1110658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110697 */     // MIs[0] policy
     /* 1110697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1110710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110729 */     // GIR_Coverage, 62083,
     /* 1110729 */     GIR_EraseRootFromParent_Done,
     /* 1110730 */   // Label 16309: @1110730
     /* 1110730 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1110807), // Rule ID 62084 //
     /* 1110735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110774 */     // MIs[0] policy
     /* 1110774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1110787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110806 */     // GIR_Coverage, 62084,
     /* 1110806 */     GIR_EraseRootFromParent_Done,
     /* 1110807 */   // Label 16310: @1110807
     /* 1110807 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1110884), // Rule ID 62085 //
     /* 1110812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110851 */     // MIs[0] policy
     /* 1110851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11258:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1110864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110883 */     // GIR_Coverage, 62085,
     /* 1110883 */     GIR_EraseRootFromParent_Done,
     /* 1110884 */   // Label 16311: @1110884
     /* 1110884 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1110961), // Rule ID 62086 //
     /* 1110889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1110892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110928 */     // MIs[0] policy
     /* 1110928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1110941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110960 */     // GIR_Coverage, 62086,
     /* 1110960 */     GIR_EraseRootFromParent_Done,
     /* 1110961 */   // Label 16312: @1110961
     /* 1110961 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1111038), // Rule ID 62087 //
     /* 1110966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1110969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1110974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111005 */     // MIs[0] policy
     /* 1111005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111015 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11258:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1111018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111037 */     // GIR_Coverage, 62087,
     /* 1111037 */     GIR_EraseRootFromParent_Done,
     /* 1111038 */   // Label 16313: @1111038
     /* 1111038 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1111115), // Rule ID 62088 //
     /* 1111043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1111046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1111051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111082 */     // MIs[0] policy
     /* 1111082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1111095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111114 */     // GIR_Coverage, 62088,
     /* 1111114 */     GIR_EraseRootFromParent_Done,
     /* 1111115 */   // Label 16314: @1111115
     /* 1111115 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1111192), // Rule ID 62089 //
     /* 1111120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1111123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1111128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111159 */     // MIs[0] policy
     /* 1111159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11258:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1111172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111191 */     // GIR_Coverage, 62089,
     /* 1111191 */     GIR_EraseRootFromParent_Done,
     /* 1111192 */   // Label 16315: @1111192
     /* 1111192 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1111269), // Rule ID 62292 //
     /* 1111197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111236 */     // MIs[0] policy
     /* 1111236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111268 */     // GIR_Coverage, 62292,
     /* 1111268 */     GIR_EraseRootFromParent_Done,
     /* 1111269 */   // Label 16316: @1111269
     /* 1111269 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1111346), // Rule ID 62293 //
     /* 1111274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111313 */     // MIs[0] policy
     /* 1111313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111323 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111345 */     // GIR_Coverage, 62293,
     /* 1111345 */     GIR_EraseRootFromParent_Done,
     /* 1111346 */   // Label 16317: @1111346
     /* 1111346 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1111423), // Rule ID 62294 //
     /* 1111351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111390 */     // MIs[0] policy
     /* 1111390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111422 */     // GIR_Coverage, 62294,
     /* 1111422 */     GIR_EraseRootFromParent_Done,
     /* 1111423 */   // Label 16318: @1111423
     /* 1111423 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1111500), // Rule ID 62295 //
     /* 1111428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111467 */     // MIs[0] policy
     /* 1111467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111499 */     // GIR_Coverage, 62295,
     /* 1111499 */     GIR_EraseRootFromParent_Done,
     /* 1111500 */   // Label 16319: @1111500
     /* 1111500 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1111577), // Rule ID 62296 //
     /* 1111505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111544 */     // MIs[0] policy
     /* 1111544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111576 */     // GIR_Coverage, 62296,
     /* 1111576 */     GIR_EraseRootFromParent_Done,
     /* 1111577 */   // Label 16320: @1111577
     /* 1111577 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1111654), // Rule ID 62297 //
     /* 1111582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111621 */     // MIs[0] policy
     /* 1111621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111631 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111653 */     // GIR_Coverage, 62297,
     /* 1111653 */     GIR_EraseRootFromParent_Done,
     /* 1111654 */   // Label 16321: @1111654
     /* 1111654 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1111731), // Rule ID 62298 //
     /* 1111659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111698 */     // MIs[0] policy
     /* 1111698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111730 */     // GIR_Coverage, 62298,
     /* 1111730 */     GIR_EraseRootFromParent_Done,
     /* 1111731 */   // Label 16322: @1111731
     /* 1111731 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1111808), // Rule ID 62299 //
     /* 1111736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111775 */     // MIs[0] policy
     /* 1111775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111785 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111807 */     // GIR_Coverage, 62299,
     /* 1111807 */     GIR_EraseRootFromParent_Done,
     /* 1111808 */   // Label 16323: @1111808
     /* 1111808 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1111885), // Rule ID 62300 //
     /* 1111813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111852 */     // MIs[0] policy
     /* 1111852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111862 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111884 */     // GIR_Coverage, 62300,
     /* 1111884 */     GIR_EraseRootFromParent_Done,
     /* 1111885 */   // Label 16324: @1111885
     /* 1111885 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1111962), // Rule ID 62301 //
     /* 1111890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1111893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1111898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111929 */     // MIs[0] policy
     /* 1111929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111939 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111961 */     // GIR_Coverage, 62301,
     /* 1111961 */     GIR_EraseRootFromParent_Done,
     /* 1111962 */   // Label 16325: @1111962
     /* 1111962 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1112039), // Rule ID 62302 //
     /* 1111967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1111970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112006 */     // MIs[0] policy
     /* 1112006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1112019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112038 */     // GIR_Coverage, 62302,
     /* 1112038 */     GIR_EraseRootFromParent_Done,
     /* 1112039 */   // Label 16326: @1112039
     /* 1112039 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1112116), // Rule ID 62303 //
     /* 1112044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112083 */     // MIs[0] policy
     /* 1112083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1112096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112115 */     // GIR_Coverage, 62303,
     /* 1112115 */     GIR_EraseRootFromParent_Done,
     /* 1112116 */   // Label 16327: @1112116
     /* 1112116 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1112193), // Rule ID 62304 //
     /* 1112121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112160 */     // MIs[0] policy
     /* 1112160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1112173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112192 */     // GIR_Coverage, 62304,
     /* 1112192 */     GIR_EraseRootFromParent_Done,
     /* 1112193 */   // Label 16328: @1112193
     /* 1112193 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1112270), // Rule ID 62305 //
     /* 1112198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112237 */     // MIs[0] policy
     /* 1112237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1112250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112269 */     // GIR_Coverage, 62305,
     /* 1112269 */     GIR_EraseRootFromParent_Done,
     /* 1112270 */   // Label 16329: @1112270
     /* 1112270 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1112347), // Rule ID 62306 //
     /* 1112275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112314 */     // MIs[0] policy
     /* 1112314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112346 */     // GIR_Coverage, 62306,
     /* 1112346 */     GIR_EraseRootFromParent_Done,
     /* 1112347 */   // Label 16330: @1112347
     /* 1112347 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1112424), // Rule ID 62307 //
     /* 1112352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112391 */     // MIs[0] policy
     /* 1112391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112423 */     // GIR_Coverage, 62307,
     /* 1112423 */     GIR_EraseRootFromParent_Done,
     /* 1112424 */   // Label 16331: @1112424
     /* 1112424 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1112501), // Rule ID 62308 //
     /* 1112429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112468 */     // MIs[0] policy
     /* 1112468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112500 */     // GIR_Coverage, 62308,
     /* 1112500 */     GIR_EraseRootFromParent_Done,
     /* 1112501 */   // Label 16332: @1112501
     /* 1112501 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1112578), // Rule ID 62309 //
     /* 1112506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112545 */     // MIs[0] policy
     /* 1112545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112577 */     // GIR_Coverage, 62309,
     /* 1112577 */     GIR_EraseRootFromParent_Done,
     /* 1112578 */   // Label 16333: @1112578
     /* 1112578 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1112655), // Rule ID 62310 //
     /* 1112583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112622 */     // MIs[0] policy
     /* 1112622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112654 */     // GIR_Coverage, 62310,
     /* 1112654 */     GIR_EraseRootFromParent_Done,
     /* 1112655 */   // Label 16334: @1112655
     /* 1112655 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1112732), // Rule ID 62311 //
     /* 1112660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112699 */     // MIs[0] policy
     /* 1112699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112731 */     // GIR_Coverage, 62311,
     /* 1112731 */     GIR_EraseRootFromParent_Done,
     /* 1112732 */   // Label 16335: @1112732
     /* 1112732 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1112809), // Rule ID 62312 //
     /* 1112737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112776 */     // MIs[0] policy
     /* 1112776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112786 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112808 */     // GIR_Coverage, 62312,
     /* 1112808 */     GIR_EraseRootFromParent_Done,
     /* 1112809 */   // Label 16336: @1112809
     /* 1112809 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1112886), // Rule ID 62313 //
     /* 1112814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112853 */     // MIs[0] policy
     /* 1112853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112863 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112885 */     // GIR_Coverage, 62313,
     /* 1112885 */     GIR_EraseRootFromParent_Done,
     /* 1112886 */   // Label 16337: @1112886
     /* 1112886 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1112963), // Rule ID 62314 //
     /* 1112891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1112894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112930 */     // MIs[0] policy
     /* 1112930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112962 */     // GIR_Coverage, 62314,
     /* 1112962 */     GIR_EraseRootFromParent_Done,
     /* 1112963 */   // Label 16338: @1112963
     /* 1112963 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1113040), // Rule ID 62315 //
     /* 1112968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1112971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113007 */     // MIs[0] policy
     /* 1113007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113017 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1113020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113039 */     // GIR_Coverage, 62315,
     /* 1113039 */     GIR_EraseRootFromParent_Done,
     /* 1113040 */   // Label 16339: @1113040
     /* 1113040 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1113117), // Rule ID 62316 //
     /* 1113045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113084 */     // MIs[0] policy
     /* 1113084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113116 */     // GIR_Coverage, 62316,
     /* 1113116 */     GIR_EraseRootFromParent_Done,
     /* 1113117 */   // Label 16340: @1113117
     /* 1113117 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1113194), // Rule ID 62317 //
     /* 1113122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113161 */     // MIs[0] policy
     /* 1113161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113193 */     // GIR_Coverage, 62317,
     /* 1113193 */     GIR_EraseRootFromParent_Done,
     /* 1113194 */   // Label 16341: @1113194
     /* 1113194 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1113271), // Rule ID 62318 //
     /* 1113199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113238 */     // MIs[0] policy
     /* 1113238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113270 */     // GIR_Coverage, 62318,
     /* 1113270 */     GIR_EraseRootFromParent_Done,
     /* 1113271 */   // Label 16342: @1113271
     /* 1113271 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1113348), // Rule ID 62319 //
     /* 1113276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113315 */     // MIs[0] policy
     /* 1113315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113325 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113347 */     // GIR_Coverage, 62319,
     /* 1113347 */     GIR_EraseRootFromParent_Done,
     /* 1113348 */   // Label 16343: @1113348
     /* 1113348 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1113425), // Rule ID 62320 //
     /* 1113353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1113356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113392 */     // MIs[0] policy
     /* 1113392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113424 */     // GIR_Coverage, 62320,
     /* 1113424 */     GIR_EraseRootFromParent_Done,
     /* 1113425 */   // Label 16344: @1113425
     /* 1113425 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1113502), // Rule ID 62321 //
     /* 1113430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1113433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113469 */     // MIs[0] policy
     /* 1113469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113479 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113501 */     // GIR_Coverage, 62321,
     /* 1113501 */     GIR_EraseRootFromParent_Done,
     /* 1113502 */   // Label 16345: @1113502
     /* 1113502 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1113579), // Rule ID 62322 //
     /* 1113507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113546 */     // MIs[0] policy
     /* 1113546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1113559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113578 */     // GIR_Coverage, 62322,
     /* 1113578 */     GIR_EraseRootFromParent_Done,
     /* 1113579 */   // Label 16346: @1113579
     /* 1113579 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1113656), // Rule ID 62323 //
     /* 1113584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1113601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1113604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113623 */     // MIs[0] policy
     /* 1113623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113633 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1113636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113655 */     // GIR_Coverage, 62323,
     /* 1113655 */     GIR_EraseRootFromParent_Done,
     /* 1113656 */   // Label 16347: @1113656
     /* 1113656 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1113733), // Rule ID 62324 //
     /* 1113661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113700 */     // MIs[0] policy
     /* 1113700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113732 */     // GIR_Coverage, 62324,
     /* 1113732 */     GIR_EraseRootFromParent_Done,
     /* 1113733 */   // Label 16348: @1113733
     /* 1113733 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1113810), // Rule ID 62325 //
     /* 1113738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1113755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1113758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113777 */     // MIs[0] policy
     /* 1113777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113809 */     // GIR_Coverage, 62325,
     /* 1113809 */     GIR_EraseRootFromParent_Done,
     /* 1113810 */   // Label 16349: @1113810
     /* 1113810 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1113887), // Rule ID 62326 //
     /* 1113815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113854 */     // MIs[0] policy
     /* 1113854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113886 */     // GIR_Coverage, 62326,
     /* 1113886 */     GIR_EraseRootFromParent_Done,
     /* 1113887 */   // Label 16350: @1113887
     /* 1113887 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1113964), // Rule ID 62327 //
     /* 1113892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1113903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1113906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1113909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1113912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113931 */     // MIs[0] policy
     /* 1113931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113941 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1113944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113963 */     // GIR_Coverage, 62327,
     /* 1113963 */     GIR_EraseRootFromParent_Done,
     /* 1113964 */   // Label 16351: @1113964
     /* 1113964 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1114041), // Rule ID 62328 //
     /* 1113969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1113977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1113986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1113989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114008 */     // MIs[0] policy
     /* 1114008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114040 */     // GIR_Coverage, 62328,
     /* 1114040 */     GIR_EraseRootFromParent_Done,
     /* 1114041 */   // Label 16352: @1114041
     /* 1114041 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1114118), // Rule ID 62329 //
     /* 1114046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1114063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1114066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114085 */     // MIs[0] policy
     /* 1114085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114095 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114117 */     // GIR_Coverage, 62329,
     /* 1114117 */     GIR_EraseRootFromParent_Done,
     /* 1114118 */   // Label 16353: @1114118
     /* 1114118 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1114195), // Rule ID 62330 //
     /* 1114123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114162 */     // MIs[0] policy
     /* 1114162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114194 */     // GIR_Coverage, 62330,
     /* 1114194 */     GIR_EraseRootFromParent_Done,
     /* 1114195 */   // Label 16354: @1114195
     /* 1114195 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1114272), // Rule ID 62331 //
     /* 1114200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1114217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1114220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114239 */     // MIs[0] policy
     /* 1114239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114249 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114271 */     // GIR_Coverage, 62331,
     /* 1114271 */     GIR_EraseRootFromParent_Done,
     /* 1114272 */   // Label 16355: @1114272
     /* 1114272 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1114349), // Rule ID 62332 //
     /* 1114277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114316 */     // MIs[0] policy
     /* 1114316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114348 */     // GIR_Coverage, 62332,
     /* 1114348 */     GIR_EraseRootFromParent_Done,
     /* 1114349 */   // Label 16356: @1114349
     /* 1114349 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1114426), // Rule ID 62333 //
     /* 1114354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1114371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1114374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114393 */     // MIs[0] policy
     /* 1114393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114403 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114425 */     // GIR_Coverage, 62333,
     /* 1114425 */     GIR_EraseRootFromParent_Done,
     /* 1114426 */   // Label 16357: @1114426
     /* 1114426 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1114503), // Rule ID 62334 //
     /* 1114431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114470 */     // MIs[0] policy
     /* 1114470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114502 */     // GIR_Coverage, 62334,
     /* 1114502 */     GIR_EraseRootFromParent_Done,
     /* 1114503 */   // Label 16358: @1114503
     /* 1114503 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1114580), // Rule ID 62335 //
     /* 1114508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1114519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1114522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1114525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1114528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114547 */     // MIs[0] policy
     /* 1114547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1114560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114579 */     // GIR_Coverage, 62335,
     /* 1114579 */     GIR_EraseRootFromParent_Done,
     /* 1114580 */   // Label 16359: @1114580
     /* 1114580 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1114657), // Rule ID 62336 //
     /* 1114585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114624 */     // MIs[0] policy
     /* 1114624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114656 */     // GIR_Coverage, 62336,
     /* 1114656 */     GIR_EraseRootFromParent_Done,
     /* 1114657 */   // Label 16360: @1114657
     /* 1114657 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1114734), // Rule ID 62337 //
     /* 1114662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1114673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1114676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1114679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1114682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114701 */     // MIs[0] policy
     /* 1114701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114711 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1114714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114733 */     // GIR_Coverage, 62337,
     /* 1114733 */     GIR_EraseRootFromParent_Done,
     /* 1114734 */   // Label 16361: @1114734
     /* 1114734 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1114811), // Rule ID 62338 //
     /* 1114739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114778 */     // MIs[0] policy
     /* 1114778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114810 */     // GIR_Coverage, 62338,
     /* 1114810 */     GIR_EraseRootFromParent_Done,
     /* 1114811 */   // Label 16362: @1114811
     /* 1114811 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1114888), // Rule ID 62339 //
     /* 1114816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1114824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1114827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1114830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1114833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1114836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114855 */     // MIs[0] policy
     /* 1114855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1114868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1114884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114887 */     // GIR_Coverage, 62339,
     /* 1114887 */     GIR_EraseRootFromParent_Done,
     /* 1114888 */   // Label 16363: @1114888
     /* 1114888 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1114965), // Rule ID 62340 //
     /* 1114893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1114896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1114901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1114910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1114913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114932 */     // MIs[0] policy
     /* 1114932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1114945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1114947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114964 */     // GIR_Coverage, 62340,
     /* 1114964 */     GIR_EraseRootFromParent_Done,
     /* 1114965 */   // Label 16364: @1114965
     /* 1114965 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1115042), // Rule ID 62341 //
     /* 1114970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1114973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1114978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1114987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1114990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115009 */     // MIs[0] policy
     /* 1115009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1115022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115041 */     // GIR_Coverage, 62341,
     /* 1115041 */     GIR_EraseRootFromParent_Done,
     /* 1115042 */   // Label 16365: @1115042
     /* 1115042 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1115119), // Rule ID 62342 //
     /* 1115047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1115064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1115067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115086 */     // MIs[0] policy
     /* 1115086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115118 */     // GIR_Coverage, 62342,
     /* 1115118 */     GIR_EraseRootFromParent_Done,
     /* 1115119 */   // Label 16366: @1115119
     /* 1115119 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1115196), // Rule ID 62343 //
     /* 1115124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1115141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1115144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115163 */     // MIs[0] policy
     /* 1115163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115195 */     // GIR_Coverage, 62343,
     /* 1115195 */     GIR_EraseRootFromParent_Done,
     /* 1115196 */   // Label 16367: @1115196
     /* 1115196 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1115273), // Rule ID 62344 //
     /* 1115201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1115212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1115215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1115218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1115221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115240 */     // MIs[0] policy
     /* 1115240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115272 */     // GIR_Coverage, 62344,
     /* 1115272 */     GIR_EraseRootFromParent_Done,
     /* 1115273 */   // Label 16368: @1115273
     /* 1115273 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1115350), // Rule ID 62345 //
     /* 1115278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1115289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1115292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1115295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1115298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115317 */     // MIs[0] policy
     /* 1115317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1115330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115349 */     // GIR_Coverage, 62345,
     /* 1115349 */     GIR_EraseRootFromParent_Done,
     /* 1115350 */   // Label 16369: @1115350
     /* 1115350 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1115427), // Rule ID 62346 //
     /* 1115355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1115372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1115375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115394 */     // MIs[0] policy
     /* 1115394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115426 */     // GIR_Coverage, 62346,
     /* 1115426 */     GIR_EraseRootFromParent_Done,
     /* 1115427 */   // Label 16370: @1115427
     /* 1115427 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1115504), // Rule ID 62347 //
     /* 1115432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1115449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1115452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115471 */     // MIs[0] policy
     /* 1115471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115503 */     // GIR_Coverage, 62347,
     /* 1115503 */     GIR_EraseRootFromParent_Done,
     /* 1115504 */   // Label 16371: @1115504
     /* 1115504 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1115581), // Rule ID 62348 //
     /* 1115509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1115526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1115529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115548 */     // MIs[0] policy
     /* 1115548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1115561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115580 */     // GIR_Coverage, 62348,
     /* 1115580 */     GIR_EraseRootFromParent_Done,
     /* 1115581 */   // Label 16372: @1115581
     /* 1115581 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1115658), // Rule ID 62349 //
     /* 1115586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1115603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1115606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115625 */     // MIs[0] policy
     /* 1115625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1115638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115657 */     // GIR_Coverage, 62349,
     /* 1115657 */     GIR_EraseRootFromParent_Done,
     /* 1115658 */   // Label 16373: @1115658
     /* 1115658 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1115735), // Rule ID 62350 //
     /* 1115663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1115680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1115683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115702 */     // MIs[0] policy
     /* 1115702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1115715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115734 */     // GIR_Coverage, 62350,
     /* 1115734 */     GIR_EraseRootFromParent_Done,
     /* 1115735 */   // Label 16374: @1115735
     /* 1115735 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1115812), // Rule ID 62351 //
     /* 1115740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1115757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1115760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115779 */     // MIs[0] policy
     /* 1115779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115789 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1115792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115811 */     // GIR_Coverage, 62351,
     /* 1115811 */     GIR_EraseRootFromParent_Done,
     /* 1115812 */   // Label 16375: @1115812
     /* 1115812 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1115889), // Rule ID 62352 //
     /* 1115817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1115828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1115831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1115834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1115837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115856 */     // MIs[0] policy
     /* 1115856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115888 */     // GIR_Coverage, 62352,
     /* 1115888 */     GIR_EraseRootFromParent_Done,
     /* 1115889 */   // Label 16376: @1115889
     /* 1115889 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1115966), // Rule ID 62353 //
     /* 1115894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1115897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1115905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1115908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1115911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1115914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115933 */     // MIs[0] policy
     /* 1115933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1115946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1115948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1115962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115965 */     // GIR_Coverage, 62353,
     /* 1115965 */     GIR_EraseRootFromParent_Done,
     /* 1115966 */   // Label 16377: @1115966
     /* 1115966 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1116043), // Rule ID 62354 //
     /* 1115971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1115974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1115979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1115982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1115985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1115988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1115991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116010 */     // MIs[0] policy
     /* 1116010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1116023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116042 */     // GIR_Coverage, 62354,
     /* 1116042 */     GIR_EraseRootFromParent_Done,
     /* 1116043 */   // Label 16378: @1116043
     /* 1116043 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1116120), // Rule ID 62355 //
     /* 1116048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1116059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1116062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1116065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1116068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116087 */     // MIs[0] policy
     /* 1116087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1116100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116119 */     // GIR_Coverage, 62355,
     /* 1116119 */     GIR_EraseRootFromParent_Done,
     /* 1116120 */   // Label 16379: @1116120
     /* 1116120 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1116197), // Rule ID 62356 //
     /* 1116125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1116136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1116139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1116142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1116145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116164 */     // MIs[0] policy
     /* 1116164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1116177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116196 */     // GIR_Coverage, 62356,
     /* 1116196 */     GIR_EraseRootFromParent_Done,
     /* 1116197 */   // Label 16380: @1116197
     /* 1116197 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1116274), // Rule ID 62357 //
     /* 1116202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1116210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1116213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1116216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1116219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1116222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116241 */     // MIs[0] policy
     /* 1116241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1116254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116273 */     // GIR_Coverage, 62357,
     /* 1116273 */     GIR_EraseRootFromParent_Done,
     /* 1116274 */   // Label 16381: @1116274
     /* 1116274 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1116351), // Rule ID 62358 //
     /* 1116279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1116296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1116299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116318 */     // MIs[0] policy
     /* 1116318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1116331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116350 */     // GIR_Coverage, 62358,
     /* 1116350 */     GIR_EraseRootFromParent_Done,
     /* 1116351 */   // Label 16382: @1116351
     /* 1116351 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1116428), // Rule ID 62359 //
     /* 1116356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1116373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1116376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116395 */     // MIs[0] policy
     /* 1116395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116405 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1116408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116427 */     // GIR_Coverage, 62359,
     /* 1116427 */     GIR_EraseRootFromParent_Done,
     /* 1116428 */   // Label 16383: @1116428
     /* 1116428 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1116505), // Rule ID 62360 //
     /* 1116433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1116450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1116453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116472 */     // MIs[0] policy
     /* 1116472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1116485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116504 */     // GIR_Coverage, 62360,
     /* 1116504 */     GIR_EraseRootFromParent_Done,
     /* 1116505 */   // Label 16384: @1116505
     /* 1116505 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1116582), // Rule ID 62361 //
     /* 1116510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1116527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1116530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116549 */     // MIs[0] policy
     /* 1116549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1116562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116581 */     // GIR_Coverage, 62361,
     /* 1116581 */     GIR_EraseRootFromParent_Done,
     /* 1116582 */   // Label 16385: @1116582
     /* 1116582 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1116659), // Rule ID 62362 //
     /* 1116587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1116607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116626 */     // MIs[0] policy
     /* 1116626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1116639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116658 */     // GIR_Coverage, 62362,
     /* 1116658 */     GIR_EraseRootFromParent_Done,
     /* 1116659 */   // Label 16386: @1116659
     /* 1116659 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1116736), // Rule ID 62363 //
     /* 1116664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1116675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1116678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1116681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1116684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116703 */     // MIs[0] policy
     /* 1116703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1116716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1116732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116735 */     // GIR_Coverage, 62363,
     /* 1116735 */     GIR_EraseRootFromParent_Done,
     /* 1116736 */   // Label 16387: @1116736
     /* 1116736 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1116813), // Rule ID 62364 //
     /* 1116741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1116761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116780 */     // MIs[0] policy
     /* 1116780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1116793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116812 */     // GIR_Coverage, 62364,
     /* 1116812 */     GIR_EraseRootFromParent_Done,
     /* 1116813 */   // Label 16388: @1116813
     /* 1116813 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1116890), // Rule ID 62365 //
     /* 1116818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1116835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1116838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116857 */     // MIs[0] policy
     /* 1116857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116867 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1116870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116889 */     // GIR_Coverage, 62365,
     /* 1116889 */     GIR_EraseRootFromParent_Done,
     /* 1116890 */   // Label 16389: @1116890
     /* 1116890 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1116967), // Rule ID 62366 //
     /* 1116895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1116898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1116912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1116915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116934 */     // MIs[0] policy
     /* 1116934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1116947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1116949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116966 */     // GIR_Coverage, 62366,
     /* 1116966 */     GIR_EraseRootFromParent_Done,
     /* 1116967 */   // Label 16390: @1116967
     /* 1116967 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1117044), // Rule ID 62367 //
     /* 1116972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1116975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1116980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1116989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1116992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117011 */     // MIs[0] policy
     /* 1117011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1117024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117043 */     // GIR_Coverage, 62367,
     /* 1117043 */     GIR_EraseRootFromParent_Done,
     /* 1117044 */   // Label 16391: @1117044
     /* 1117044 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1117121), // Rule ID 62368 //
     /* 1117049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1117069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117088 */     // MIs[0] policy
     /* 1117088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117098 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1117101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117120 */     // GIR_Coverage, 62368,
     /* 1117120 */     GIR_EraseRootFromParent_Done,
     /* 1117121 */   // Label 16392: @1117121
     /* 1117121 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1117198), // Rule ID 62369 //
     /* 1117126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1117143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1117146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117165 */     // MIs[0] policy
     /* 1117165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117175 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1117178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117197 */     // GIR_Coverage, 62369,
     /* 1117197 */     GIR_EraseRootFromParent_Done,
     /* 1117198 */   // Label 16393: @1117198
     /* 1117198 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1117275), // Rule ID 62370 //
     /* 1117203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1117223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117242 */     // MIs[0] policy
     /* 1117242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1117255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117274 */     // GIR_Coverage, 62370,
     /* 1117274 */     GIR_EraseRootFromParent_Done,
     /* 1117275 */   // Label 16394: @1117275
     /* 1117275 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1117352), // Rule ID 62371 //
     /* 1117280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1117291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1117294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1117297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1117300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117319 */     // MIs[0] policy
     /* 1117319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1117332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117351 */     // GIR_Coverage, 62371,
     /* 1117351 */     GIR_EraseRootFromParent_Done,
     /* 1117352 */   // Label 16395: @1117352
     /* 1117352 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1117429), // Rule ID 62372 //
     /* 1117357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1117377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117396 */     // MIs[0] policy
     /* 1117396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1117409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117428 */     // GIR_Coverage, 62372,
     /* 1117428 */     GIR_EraseRootFromParent_Done,
     /* 1117429 */   // Label 16396: @1117429
     /* 1117429 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1117506), // Rule ID 62373 //
     /* 1117434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1117445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1117448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1117451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1117454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117473 */     // MIs[0] policy
     /* 1117473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1117486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117505 */     // GIR_Coverage, 62373,
     /* 1117505 */     GIR_EraseRootFromParent_Done,
     /* 1117506 */   // Label 16397: @1117506
     /* 1117506 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1117583), // Rule ID 62374 //
     /* 1117511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1117514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1117531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117550 */     // MIs[0] policy
     /* 1117550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1117563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117582 */     // GIR_Coverage, 62374,
     /* 1117582 */     GIR_EraseRootFromParent_Done,
     /* 1117583 */   // Label 16398: @1117583
     /* 1117583 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1117660), // Rule ID 62375 //
     /* 1117588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1117591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1117596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1117599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1117602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1117605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1117608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117627 */     // MIs[0] policy
     /* 1117627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117637 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1117640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1117642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1117656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117659 */     // GIR_Coverage, 62375,
     /* 1117659 */     GIR_EraseRootFromParent_Done,
     /* 1117660 */   // Label 16399: @1117660
     /* 1117660 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1117737), // Rule ID 62596 //
     /* 1117665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117704 */     // MIs[0] policy
     /* 1117704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1117717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117736 */     // GIR_Coverage, 62596,
     /* 1117736 */     GIR_EraseRootFromParent_Done,
     /* 1117737 */   // Label 16400: @1117737
     /* 1117737 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1117814), // Rule ID 62597 //
     /* 1117742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1117759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117781 */     // MIs[0] policy
     /* 1117781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1117794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117813 */     // GIR_Coverage, 62597,
     /* 1117813 */     GIR_EraseRootFromParent_Done,
     /* 1117814 */   // Label 16401: @1117814
     /* 1117814 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1117891), // Rule ID 62600 //
     /* 1117819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117858 */     // MIs[0] policy
     /* 1117858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1117871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117890 */     // GIR_Coverage, 62600,
     /* 1117890 */     GIR_EraseRootFromParent_Done,
     /* 1117891 */   // Label 16402: @1117891
     /* 1117891 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1117968), // Rule ID 62601 //
     /* 1117896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117935 */     // MIs[0] policy
     /* 1117935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1117948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117967 */     // GIR_Coverage, 62601,
     /* 1117967 */     GIR_EraseRootFromParent_Done,
     /* 1117968 */   // Label 16403: @1117968
     /* 1117968 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1118045), // Rule ID 62604 //
     /* 1117973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1117981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118012 */     // MIs[0] policy
     /* 1118012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118022 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1118025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118044 */     // GIR_Coverage, 62604,
     /* 1118044 */     GIR_EraseRootFromParent_Done,
     /* 1118045 */   // Label 16404: @1118045
     /* 1118045 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1118122), // Rule ID 62605 //
     /* 1118050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1118067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118089 */     // MIs[0] policy
     /* 1118089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1118102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118121 */     // GIR_Coverage, 62605,
     /* 1118121 */     GIR_EraseRootFromParent_Done,
     /* 1118122 */   // Label 16405: @1118122
     /* 1118122 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1118199), // Rule ID 62608 //
     /* 1118127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1118144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118166 */     // MIs[0] policy
     /* 1118166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1118179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118198 */     // GIR_Coverage, 62608,
     /* 1118198 */     GIR_EraseRootFromParent_Done,
     /* 1118199 */   // Label 16406: @1118199
     /* 1118199 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1118276), // Rule ID 62609 //
     /* 1118204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1118221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118243 */     // MIs[0] policy
     /* 1118243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118253 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1118256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118275 */     // GIR_Coverage, 62609,
     /* 1118275 */     GIR_EraseRootFromParent_Done,
     /* 1118276 */   // Label 16407: @1118276
     /* 1118276 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1118353), // Rule ID 62612 //
     /* 1118281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118320 */     // MIs[0] policy
     /* 1118320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1118333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118352 */     // GIR_Coverage, 62612,
     /* 1118352 */     GIR_EraseRootFromParent_Done,
     /* 1118353 */   // Label 16408: @1118353
     /* 1118353 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1118430), // Rule ID 62613 //
     /* 1118358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1118375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118397 */     // MIs[0] policy
     /* 1118397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118407 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1118410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118429 */     // GIR_Coverage, 62613,
     /* 1118429 */     GIR_EraseRootFromParent_Done,
     /* 1118430 */   // Label 16409: @1118430
     /* 1118430 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1118507), // Rule ID 62616 //
     /* 1118435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118474 */     // MIs[0] policy
     /* 1118474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1118487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118506 */     // GIR_Coverage, 62616,
     /* 1118506 */     GIR_EraseRootFromParent_Done,
     /* 1118507 */   // Label 16410: @1118507
     /* 1118507 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1118584), // Rule ID 62617 //
     /* 1118512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118551 */     // MIs[0] policy
     /* 1118551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1118564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118583 */     // GIR_Coverage, 62617,
     /* 1118583 */     GIR_EraseRootFromParent_Done,
     /* 1118584 */   // Label 16411: @1118584
     /* 1118584 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1118661), // Rule ID 62620 //
     /* 1118589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118628 */     // MIs[0] policy
     /* 1118628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1118641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118660 */     // GIR_Coverage, 62620,
     /* 1118660 */     GIR_EraseRootFromParent_Done,
     /* 1118661 */   // Label 16412: @1118661
     /* 1118661 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1118738), // Rule ID 62621 //
     /* 1118666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118705 */     // MIs[0] policy
     /* 1118705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11066:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1118718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118737 */     // GIR_Coverage, 62621,
     /* 1118737 */     GIR_EraseRootFromParent_Done,
     /* 1118738 */   // Label 16413: @1118738
     /* 1118738 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1118815), // Rule ID 62624 //
     /* 1118743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118782 */     // MIs[0] policy
     /* 1118782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1118795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118814 */     // GIR_Coverage, 62624,
     /* 1118814 */     GIR_EraseRootFromParent_Done,
     /* 1118815 */   // Label 16414: @1118815
     /* 1118815 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1118892), // Rule ID 62625 //
     /* 1118820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118859 */     // MIs[0] policy
     /* 1118859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11066:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1118872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118891 */     // GIR_Coverage, 62625,
     /* 1118891 */     GIR_EraseRootFromParent_Done,
     /* 1118892 */   // Label 16415: @1118892
     /* 1118892 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1118969), // Rule ID 62628 //
     /* 1118897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118936 */     // MIs[0] policy
     /* 1118936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1118949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118968 */     // GIR_Coverage, 62628,
     /* 1118968 */     GIR_EraseRootFromParent_Done,
     /* 1118969 */   // Label 16416: @1118969
     /* 1118969 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1119046), // Rule ID 62629 //
     /* 1118974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1118982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119013 */     // MIs[0] policy
     /* 1119013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11066:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1119026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119045 */     // GIR_Coverage, 62629,
     /* 1119045 */     GIR_EraseRootFromParent_Done,
     /* 1119046 */   // Label 16417: @1119046
     /* 1119046 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1119123), // Rule ID 62632 //
     /* 1119051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1119059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119090 */     // MIs[0] policy
     /* 1119090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1119103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119122 */     // GIR_Coverage, 62632,
     /* 1119122 */     GIR_EraseRootFromParent_Done,
     /* 1119123 */   // Label 16418: @1119123
     /* 1119123 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1119200), // Rule ID 62633 //
     /* 1119128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1119136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119167 */     // MIs[0] policy
     /* 1119167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11066:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1119180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119199 */     // GIR_Coverage, 62633,
     /* 1119199 */     GIR_EraseRootFromParent_Done,
     /* 1119200 */   // Label 16419: @1119200
     /* 1119200 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1119277), // Rule ID 62636 //
     /* 1119205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1119222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119244 */     // MIs[0] policy
     /* 1119244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1119257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119276 */     // GIR_Coverage, 62636,
     /* 1119276 */     GIR_EraseRootFromParent_Done,
     /* 1119277 */   // Label 16420: @1119277
     /* 1119277 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1119354), // Rule ID 62637 //
     /* 1119282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1119299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119321 */     // MIs[0] policy
     /* 1119321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1119334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119353 */     // GIR_Coverage, 62637,
     /* 1119353 */     GIR_EraseRootFromParent_Done,
     /* 1119354 */   // Label 16421: @1119354
     /* 1119354 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1119431), // Rule ID 62640 //
     /* 1119359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119398 */     // MIs[0] policy
     /* 1119398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119430 */     // GIR_Coverage, 62640,
     /* 1119430 */     GIR_EraseRootFromParent_Done,
     /* 1119431 */   // Label 16422: @1119431
     /* 1119431 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1119508), // Rule ID 62641 //
     /* 1119436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119475 */     // MIs[0] policy
     /* 1119475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119485 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1119488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119507 */     // GIR_Coverage, 62641,
     /* 1119507 */     GIR_EraseRootFromParent_Done,
     /* 1119508 */   // Label 16423: @1119508
     /* 1119508 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1119585), // Rule ID 62644 //
     /* 1119513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1119530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119552 */     // MIs[0] policy
     /* 1119552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1119565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119584 */     // GIR_Coverage, 62644,
     /* 1119584 */     GIR_EraseRootFromParent_Done,
     /* 1119585 */   // Label 16424: @1119585
     /* 1119585 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1119662), // Rule ID 62645 //
     /* 1119590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1119607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119629 */     // MIs[0] policy
     /* 1119629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1119642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119661 */     // GIR_Coverage, 62645,
     /* 1119661 */     GIR_EraseRootFromParent_Done,
     /* 1119662 */   // Label 16425: @1119662
     /* 1119662 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1119739), // Rule ID 62648 //
     /* 1119667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1119684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119706 */     // MIs[0] policy
     /* 1119706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1119719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119738 */     // GIR_Coverage, 62648,
     /* 1119738 */     GIR_EraseRootFromParent_Done,
     /* 1119739 */   // Label 16426: @1119739
     /* 1119739 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1119816), // Rule ID 62649 //
     /* 1119744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1119761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119783 */     // MIs[0] policy
     /* 1119783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1119796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119815 */     // GIR_Coverage, 62649,
     /* 1119815 */     GIR_EraseRootFromParent_Done,
     /* 1119816 */   // Label 16427: @1119816
     /* 1119816 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1119893), // Rule ID 62652 //
     /* 1119821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1119838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119860 */     // MIs[0] policy
     /* 1119860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1119873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119892 */     // GIR_Coverage, 62652,
     /* 1119892 */     GIR_EraseRootFromParent_Done,
     /* 1119893 */   // Label 16428: @1119893
     /* 1119893 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1119970), // Rule ID 62653 //
     /* 1119898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1119915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119937 */     // MIs[0] policy
     /* 1119937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119947 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1119950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119969 */     // GIR_Coverage, 62653,
     /* 1119969 */     GIR_EraseRootFromParent_Done,
     /* 1119970 */   // Label 16429: @1119970
     /* 1119970 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1120047), // Rule ID 62656 //
     /* 1119975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1119983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1119986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1119989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1119995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120014 */     // MIs[0] policy
     /* 1120014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1120027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120046 */     // GIR_Coverage, 62656,
     /* 1120046 */     GIR_EraseRootFromParent_Done,
     /* 1120047 */   // Label 16430: @1120047
     /* 1120047 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1120124), // Rule ID 62657 //
     /* 1120052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120091 */     // MIs[0] policy
     /* 1120091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1120104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120123 */     // GIR_Coverage, 62657,
     /* 1120123 */     GIR_EraseRootFromParent_Done,
     /* 1120124 */   // Label 16431: @1120124
     /* 1120124 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1120201), // Rule ID 62660 //
     /* 1120129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120168 */     // MIs[0] policy
     /* 1120168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1120181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120200 */     // GIR_Coverage, 62660,
     /* 1120200 */     GIR_EraseRootFromParent_Done,
     /* 1120201 */   // Label 16432: @1120201
     /* 1120201 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1120278), // Rule ID 62661 //
     /* 1120206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120245 */     // MIs[0] policy
     /* 1120245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120255 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1120258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120277 */     // GIR_Coverage, 62661,
     /* 1120277 */     GIR_EraseRootFromParent_Done,
     /* 1120278 */   // Label 16433: @1120278
     /* 1120278 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1120355), // Rule ID 62664 //
     /* 1120283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120322 */     // MIs[0] policy
     /* 1120322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1120335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120354 */     // GIR_Coverage, 62664,
     /* 1120354 */     GIR_EraseRootFromParent_Done,
     /* 1120355 */   // Label 16434: @1120355
     /* 1120355 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1120432), // Rule ID 62665 //
     /* 1120360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120399 */     // MIs[0] policy
     /* 1120399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1120412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120431 */     // GIR_Coverage, 62665,
     /* 1120431 */     GIR_EraseRootFromParent_Done,
     /* 1120432 */   // Label 16435: @1120432
     /* 1120432 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1120509), // Rule ID 62668 //
     /* 1120437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120476 */     // MIs[0] policy
     /* 1120476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1120489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120508 */     // GIR_Coverage, 62668,
     /* 1120508 */     GIR_EraseRootFromParent_Done,
     /* 1120509 */   // Label 16436: @1120509
     /* 1120509 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1120586), // Rule ID 62669 //
     /* 1120514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120553 */     // MIs[0] policy
     /* 1120553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1120566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120585 */     // GIR_Coverage, 62669,
     /* 1120585 */     GIR_EraseRootFromParent_Done,
     /* 1120586 */   // Label 16437: @1120586
     /* 1120586 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1120663), // Rule ID 62672 //
     /* 1120591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1120608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120630 */     // MIs[0] policy
     /* 1120630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1120643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120662 */     // GIR_Coverage, 62672,
     /* 1120662 */     GIR_EraseRootFromParent_Done,
     /* 1120663 */   // Label 16438: @1120663
     /* 1120663 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1120740), // Rule ID 62673 //
     /* 1120668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1120676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1120685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1120703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120707 */     // MIs[0] policy
     /* 1120707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120717 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1120720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120739 */     // GIR_Coverage, 62673,
     /* 1120739 */     GIR_EraseRootFromParent_Done,
     /* 1120740 */   // Label 16439: @1120740
     /* 1120740 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1120817), // Rule ID 62676 //
     /* 1120745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1120762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120784 */     // MIs[0] policy
     /* 1120784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1120797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120816 */     // GIR_Coverage, 62676,
     /* 1120816 */     GIR_EraseRootFromParent_Done,
     /* 1120817 */   // Label 16440: @1120817
     /* 1120817 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1120894), // Rule ID 62677 //
     /* 1120822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1120833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1120836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1120839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1120842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120861 */     // MIs[0] policy
     /* 1120861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120871 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1120874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120893 */     // GIR_Coverage, 62677,
     /* 1120893 */     GIR_EraseRootFromParent_Done,
     /* 1120894 */   // Label 16441: @1120894
     /* 1120894 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1120971), // Rule ID 62680 //
     /* 1120899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1120902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120938 */     // MIs[0] policy
     /* 1120938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1120951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1120967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120970 */     // GIR_Coverage, 62680,
     /* 1120970 */     GIR_EraseRootFromParent_Done,
     /* 1120971 */   // Label 16442: @1120971
     /* 1120971 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1121048), // Rule ID 62681 //
     /* 1120976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1120979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1120984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121015 */     // MIs[0] policy
     /* 1121015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1121028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121047 */     // GIR_Coverage, 62681,
     /* 1121047 */     GIR_EraseRootFromParent_Done,
     /* 1121048 */   // Label 16443: @1121048
     /* 1121048 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1121125), // Rule ID 62684 //
     /* 1121053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1121070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121092 */     // MIs[0] policy
     /* 1121092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1121105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121124 */     // GIR_Coverage, 62684,
     /* 1121124 */     GIR_EraseRootFromParent_Done,
     /* 1121125 */   // Label 16444: @1121125
     /* 1121125 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1121202), // Rule ID 62685 //
     /* 1121130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1121147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121169 */     // MIs[0] policy
     /* 1121169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121179 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1121182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121201 */     // GIR_Coverage, 62685,
     /* 1121201 */     GIR_EraseRootFromParent_Done,
     /* 1121202 */   // Label 16445: @1121202
     /* 1121202 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1121279), // Rule ID 62688 //
     /* 1121207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1121224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121246 */     // MIs[0] policy
     /* 1121246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1121259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121278 */     // GIR_Coverage, 62688,
     /* 1121278 */     GIR_EraseRootFromParent_Done,
     /* 1121279 */   // Label 16446: @1121279
     /* 1121279 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1121356), // Rule ID 62689 //
     /* 1121284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1121301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121323 */     // MIs[0] policy
     /* 1121323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121333 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1121336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121355 */     // GIR_Coverage, 62689,
     /* 1121355 */     GIR_EraseRootFromParent_Done,
     /* 1121356 */   // Label 16447: @1121356
     /* 1121356 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1121433), // Rule ID 62692 //
     /* 1121361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1121378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121400 */     // MIs[0] policy
     /* 1121400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1121413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121432 */     // GIR_Coverage, 62692,
     /* 1121432 */     GIR_EraseRootFromParent_Done,
     /* 1121433 */   // Label 16448: @1121433
     /* 1121433 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1121510), // Rule ID 62693 //
     /* 1121438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1121455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121477 */     // MIs[0] policy
     /* 1121477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121487 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1121490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121509 */     // GIR_Coverage, 62693,
     /* 1121509 */     GIR_EraseRootFromParent_Done,
     /* 1121510 */   // Label 16449: @1121510
     /* 1121510 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1121587), // Rule ID 62696 //
     /* 1121515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1121526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1121529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121554 */     // MIs[0] policy
     /* 1121554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1121567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121586 */     // GIR_Coverage, 62696,
     /* 1121586 */     GIR_EraseRootFromParent_Done,
     /* 1121587 */   // Label 16450: @1121587
     /* 1121587 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1121664), // Rule ID 62697 //
     /* 1121592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1121603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1121606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121631 */     // MIs[0] policy
     /* 1121631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1121644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121663 */     // GIR_Coverage, 62697,
     /* 1121663 */     GIR_EraseRootFromParent_Done,
     /* 1121664 */   // Label 16451: @1121664
     /* 1121664 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1121741), // Rule ID 62700 //
     /* 1121669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121708 */     // MIs[0] policy
     /* 1121708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1121721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121740 */     // GIR_Coverage, 62700,
     /* 1121740 */     GIR_EraseRootFromParent_Done,
     /* 1121741 */   // Label 16452: @1121741
     /* 1121741 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1121818), // Rule ID 62701 //
     /* 1121746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121785 */     // MIs[0] policy
     /* 1121785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121795 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11068:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1121798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121817 */     // GIR_Coverage, 62701,
     /* 1121817 */     GIR_EraseRootFromParent_Done,
     /* 1121818 */   // Label 16453: @1121818
     /* 1121818 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1121895), // Rule ID 62704 //
     /* 1121823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121862 */     // MIs[0] policy
     /* 1121862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1121875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121894 */     // GIR_Coverage, 62704,
     /* 1121894 */     GIR_EraseRootFromParent_Done,
     /* 1121895 */   // Label 16454: @1121895
     /* 1121895 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1121972), // Rule ID 62705 //
     /* 1121900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1121903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1121917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1121935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121939 */     // MIs[0] policy
     /* 1121939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11068:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1121952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1121968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121971 */     // GIR_Coverage, 62705,
     /* 1121971 */     GIR_EraseRootFromParent_Done,
     /* 1121972 */   // Label 16455: @1121972
     /* 1121972 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1122049), // Rule ID 62708 //
     /* 1121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1121980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1121985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1121994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122016 */     // MIs[0] policy
     /* 1122016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1122029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122048 */     // GIR_Coverage, 62708,
     /* 1122048 */     GIR_EraseRootFromParent_Done,
     /* 1122049 */   // Label 16456: @1122049
     /* 1122049 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1122126), // Rule ID 62709 //
     /* 1122054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122093 */     // MIs[0] policy
     /* 1122093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122103 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11068:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1122106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122125 */     // GIR_Coverage, 62709,
     /* 1122125 */     GIR_EraseRootFromParent_Done,
     /* 1122126 */   // Label 16457: @1122126
     /* 1122126 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1122203), // Rule ID 62712 //
     /* 1122131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122170 */     // MIs[0] policy
     /* 1122170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1122183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122202 */     // GIR_Coverage, 62712,
     /* 1122202 */     GIR_EraseRootFromParent_Done,
     /* 1122203 */   // Label 16458: @1122203
     /* 1122203 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1122280), // Rule ID 62713 //
     /* 1122208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1122216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122247 */     // MIs[0] policy
     /* 1122247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122257 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11068:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1122260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122279 */     // GIR_Coverage, 62713,
     /* 1122279 */     GIR_EraseRootFromParent_Done,
     /* 1122280 */   // Label 16459: @1122280
     /* 1122280 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1122357), // Rule ID 62716 //
     /* 1122285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122324 */     // MIs[0] policy
     /* 1122324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1122337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122356 */     // GIR_Coverage, 62716,
     /* 1122356 */     GIR_EraseRootFromParent_Done,
     /* 1122357 */   // Label 16460: @1122357
     /* 1122357 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1122434), // Rule ID 62717 //
     /* 1122362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1122373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1122376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122401 */     // MIs[0] policy
     /* 1122401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1122414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122433 */     // GIR_Coverage, 62717,
     /* 1122433 */     GIR_EraseRootFromParent_Done,
     /* 1122434 */   // Label 16461: @1122434
     /* 1122434 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1122511), // Rule ID 62720 //
     /* 1122439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122478 */     // MIs[0] policy
     /* 1122478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1122491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122510 */     // GIR_Coverage, 62720,
     /* 1122510 */     GIR_EraseRootFromParent_Done,
     /* 1122511 */   // Label 16462: @1122511
     /* 1122511 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1122588), // Rule ID 62721 //
     /* 1122516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122555 */     // MIs[0] policy
     /* 1122555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122565 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1122568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122587 */     // GIR_Coverage, 62721,
     /* 1122587 */     GIR_EraseRootFromParent_Done,
     /* 1122588 */   // Label 16463: @1122588
     /* 1122588 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1122665), // Rule ID 62724 //
     /* 1122593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122632 */     // MIs[0] policy
     /* 1122632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1122645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122664 */     // GIR_Coverage, 62724,
     /* 1122664 */     GIR_EraseRootFromParent_Done,
     /* 1122665 */   // Label 16464: @1122665
     /* 1122665 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1122742), // Rule ID 62725 //
     /* 1122670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122709 */     // MIs[0] policy
     /* 1122709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1122722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122741 */     // GIR_Coverage, 62725,
     /* 1122741 */     GIR_EraseRootFromParent_Done,
     /* 1122742 */   // Label 16465: @1122742
     /* 1122742 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1122819), // Rule ID 62728 //
     /* 1122747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122786 */     // MIs[0] policy
     /* 1122786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122796 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1122799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122818 */     // GIR_Coverage, 62728,
     /* 1122818 */     GIR_EraseRootFromParent_Done,
     /* 1122819 */   // Label 16466: @1122819
     /* 1122819 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1122896), // Rule ID 62729 //
     /* 1122824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122863 */     // MIs[0] policy
     /* 1122863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122873 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1122876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122895 */     // GIR_Coverage, 62729,
     /* 1122895 */     GIR_EraseRootFromParent_Done,
     /* 1122896 */   // Label 16467: @1122896
     /* 1122896 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1122973), // Rule ID 62732 //
     /* 1122901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1122904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1122918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1122936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122940 */     // MIs[0] policy
     /* 1122940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1122953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1122969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122972 */     // GIR_Coverage, 62732,
     /* 1122972 */     GIR_EraseRootFromParent_Done,
     /* 1122973 */   // Label 16468: @1122973
     /* 1122973 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1123050), // Rule ID 62733 //
     /* 1122978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1122981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1122986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1122995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1122998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1123013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123017 */     // MIs[0] policy
     /* 1123017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1123030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1123046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123049 */     // GIR_Coverage, 62733,
     /* 1123049 */     GIR_EraseRootFromParent_Done,
     /* 1123050 */   // Label 16469: @1123050
     /* 1123050 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1123127), // Rule ID 62827 //
     /* 1123055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123094 */     // MIs[0] policy
     /* 1123094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1123107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123126 */     // GIR_Coverage, 62827,
     /* 1123126 */     GIR_EraseRootFromParent_Done,
     /* 1123127 */   // Label 16470: @1123127
     /* 1123127 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1123204), // Rule ID 62828 //
     /* 1123132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123171 */     // MIs[0] policy
     /* 1123171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11044:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1123184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123203 */     // GIR_Coverage, 62828,
     /* 1123203 */     GIR_EraseRootFromParent_Done,
     /* 1123204 */   // Label 16471: @1123204
     /* 1123204 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1123281), // Rule ID 64285 //
     /* 1123209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123248 */     // MIs[0] policy
     /* 1123248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11044:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1123261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123280 */     // GIR_Coverage, 64285,
     /* 1123280 */     GIR_EraseRootFromParent_Done,
     /* 1123281 */   // Label 16472: @1123281
     /* 1123281 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1123358), // Rule ID 64286 //
     /* 1123286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123325 */     // MIs[0] policy
     /* 1123325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11044:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1123338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123357 */     // GIR_Coverage, 64286,
     /* 1123357 */     GIR_EraseRootFromParent_Done,
     /* 1123358 */   // Label 16473: @1123358
     /* 1123358 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1123435), // Rule ID 64287 //
     /* 1123363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123402 */     // MIs[0] policy
     /* 1123402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11044:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1123415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123434 */     // GIR_Coverage, 64287,
     /* 1123434 */     GIR_EraseRootFromParent_Done,
     /* 1123435 */   // Label 16474: @1123435
     /* 1123435 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1123512), // Rule ID 64288 //
     /* 1123440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123479 */     // MIs[0] policy
     /* 1123479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123489 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11044:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1123492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123511 */     // GIR_Coverage, 64288,
     /* 1123511 */     GIR_EraseRootFromParent_Done,
     /* 1123512 */   // Label 16475: @1123512
     /* 1123512 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1123589), // Rule ID 64289 //
     /* 1123517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1123537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123556 */     // MIs[0] policy
     /* 1123556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11044:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1123569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123588 */     // GIR_Coverage, 64289,
     /* 1123588 */     GIR_EraseRootFromParent_Done,
     /* 1123589 */   // Label 16476: @1123589
     /* 1123589 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1123666), // Rule ID 64290 //
     /* 1123594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1123602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1123614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123633 */     // MIs[0] policy
     /* 1123633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11044:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1123646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123665 */     // GIR_Coverage, 64290,
     /* 1123665 */     GIR_EraseRootFromParent_Done,
     /* 1123666 */   // Label 16477: @1123666
     /* 1123666 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1123743), // Rule ID 64291 //
     /* 1123671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123710 */     // MIs[0] policy
     /* 1123710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1123723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123742 */     // GIR_Coverage, 64291,
     /* 1123742 */     GIR_EraseRootFromParent_Done,
     /* 1123743 */   // Label 16478: @1123743
     /* 1123743 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1123820), // Rule ID 64292 //
     /* 1123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123787 */     // MIs[0] policy
     /* 1123787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123797 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11040:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1123800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123819 */     // GIR_Coverage, 64292,
     /* 1123819 */     GIR_EraseRootFromParent_Done,
     /* 1123820 */   // Label 16479: @1123820
     /* 1123820 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1123897), // Rule ID 64293 //
     /* 1123825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123864 */     // MIs[0] policy
     /* 1123864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1123877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123896 */     // GIR_Coverage, 64293,
     /* 1123896 */     GIR_EraseRootFromParent_Done,
     /* 1123897 */   // Label 16480: @1123897
     /* 1123897 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1123974), // Rule ID 64294 //
     /* 1123902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1123905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123941 */     // MIs[0] policy
     /* 1123941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11040:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1123954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123973 */     // GIR_Coverage, 64294,
     /* 1123973 */     GIR_EraseRootFromParent_Done,
     /* 1123974 */   // Label 16481: @1123974
     /* 1123974 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1124051), // Rule ID 64295 //
     /* 1123979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1123982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1123987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124018 */     // MIs[0] policy
     /* 1124018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1124031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124050 */     // GIR_Coverage, 64295,
     /* 1124050 */     GIR_EraseRootFromParent_Done,
     /* 1124051 */   // Label 16482: @1124051
     /* 1124051 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1124128), // Rule ID 64296 //
     /* 1124056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124095 */     // MIs[0] policy
     /* 1124095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124105 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11040:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1124108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124127 */     // GIR_Coverage, 64296,
     /* 1124127 */     GIR_EraseRootFromParent_Done,
     /* 1124128 */   // Label 16483: @1124128
     /* 1124128 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1124205), // Rule ID 64297 //
     /* 1124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124172 */     // MIs[0] policy
     /* 1124172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1124185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124204 */     // GIR_Coverage, 64297,
     /* 1124204 */     GIR_EraseRootFromParent_Done,
     /* 1124205 */   // Label 16484: @1124205
     /* 1124205 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1124282), // Rule ID 64298 //
     /* 1124210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1124218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124249 */     // MIs[0] policy
     /* 1124249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124259 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11040:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1124262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124281 */     // GIR_Coverage, 64298,
     /* 1124281 */     GIR_EraseRootFromParent_Done,
     /* 1124282 */   // Label 16485: @1124282
     /* 1124282 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1124359), // Rule ID 64299 //
     /* 1124287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124326 */     // MIs[0] policy
     /* 1124326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1124339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124358 */     // GIR_Coverage, 64299,
     /* 1124358 */     GIR_EraseRootFromParent_Done,
     /* 1124359 */   // Label 16486: @1124359
     /* 1124359 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1124436), // Rule ID 64300 //
     /* 1124364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124403 */     // MIs[0] policy
     /* 1124403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11046:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1124416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124435 */     // GIR_Coverage, 64300,
     /* 1124435 */     GIR_EraseRootFromParent_Done,
     /* 1124436 */   // Label 16487: @1124436
     /* 1124436 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1124513), // Rule ID 64301 //
     /* 1124441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124480 */     // MIs[0] policy
     /* 1124480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11046:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1124493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124512 */     // GIR_Coverage, 64301,
     /* 1124512 */     GIR_EraseRootFromParent_Done,
     /* 1124513 */   // Label 16488: @1124513
     /* 1124513 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1124590), // Rule ID 64302 //
     /* 1124518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124557 */     // MIs[0] policy
     /* 1124557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11046:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1124570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124589 */     // GIR_Coverage, 64302,
     /* 1124589 */     GIR_EraseRootFromParent_Done,
     /* 1124590 */   // Label 16489: @1124590
     /* 1124590 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1124667), // Rule ID 64303 //
     /* 1124595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124634 */     // MIs[0] policy
     /* 1124634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11046:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1124647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124666 */     // GIR_Coverage, 64303,
     /* 1124666 */     GIR_EraseRootFromParent_Done,
     /* 1124667 */   // Label 16490: @1124667
     /* 1124667 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1124744), // Rule ID 64304 //
     /* 1124672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124711 */     // MIs[0] policy
     /* 1124711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124721 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11046:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1124724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124743 */     // GIR_Coverage, 64304,
     /* 1124743 */     GIR_EraseRootFromParent_Done,
     /* 1124744 */   // Label 16491: @1124744
     /* 1124744 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1124821), // Rule ID 64305 //
     /* 1124749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124788 */     // MIs[0] policy
     /* 1124788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11046:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124820 */     // GIR_Coverage, 64305,
     /* 1124820 */     GIR_EraseRootFromParent_Done,
     /* 1124821 */   // Label 16492: @1124821
     /* 1124821 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1124898), // Rule ID 64306 //
     /* 1124826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1124834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124865 */     // MIs[0] policy
     /* 1124865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11046:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1124878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124897 */     // GIR_Coverage, 64306,
     /* 1124897 */     GIR_EraseRootFromParent_Done,
     /* 1124898 */   // Label 16493: @1124898
     /* 1124898 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1124975), // Rule ID 64307 //
     /* 1124903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1124906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1124911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124942 */     // MIs[0] policy
     /* 1124942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1124955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124974 */     // GIR_Coverage, 64307,
     /* 1124974 */     GIR_EraseRootFromParent_Done,
     /* 1124975 */   // Label 16494: @1124975
     /* 1124975 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1125052), // Rule ID 64308 //
     /* 1124980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1124983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1124988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125019 */     // MIs[0] policy
     /* 1125019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125029 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11042:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1125032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125051 */     // GIR_Coverage, 64308,
     /* 1125051 */     GIR_EraseRootFromParent_Done,
     /* 1125052 */   // Label 16495: @1125052
     /* 1125052 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1125129), // Rule ID 64309 //
     /* 1125057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125096 */     // MIs[0] policy
     /* 1125096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1125109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125128 */     // GIR_Coverage, 64309,
     /* 1125128 */     GIR_EraseRootFromParent_Done,
     /* 1125129 */   // Label 16496: @1125129
     /* 1125129 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1125206), // Rule ID 64310 //
     /* 1125134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125173 */     // MIs[0] policy
     /* 1125173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11042:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1125186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125205 */     // GIR_Coverage, 64310,
     /* 1125205 */     GIR_EraseRootFromParent_Done,
     /* 1125206 */   // Label 16497: @1125206
     /* 1125206 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1125283), // Rule ID 64311 //
     /* 1125211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125250 */     // MIs[0] policy
     /* 1125250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1125263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125282 */     // GIR_Coverage, 64311,
     /* 1125282 */     GIR_EraseRootFromParent_Done,
     /* 1125283 */   // Label 16498: @1125283
     /* 1125283 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1125360), // Rule ID 64312 //
     /* 1125288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125327 */     // MIs[0] policy
     /* 1125327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125337 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11042:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1125340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125359 */     // GIR_Coverage, 64312,
     /* 1125359 */     GIR_EraseRootFromParent_Done,
     /* 1125360 */   // Label 16499: @1125360
     /* 1125360 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1125437), // Rule ID 64313 //
     /* 1125365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1125368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125404 */     // MIs[0] policy
     /* 1125404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1125417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125436 */     // GIR_Coverage, 64313,
     /* 1125436 */     GIR_EraseRootFromParent_Done,
     /* 1125437 */   // Label 16500: @1125437
     /* 1125437 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1125514), // Rule ID 64314 //
     /* 1125442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1125445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1125450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125481 */     // MIs[0] policy
     /* 1125481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11042:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1125494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125513 */     // GIR_Coverage, 64314,
     /* 1125513 */     GIR_EraseRootFromParent_Done,
     /* 1125514 */   // Label 16501: @1125514
     /* 1125514 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1125591), // Rule ID 64315 //
     /* 1125519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125558 */     // MIs[0] policy
     /* 1125558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125568 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1125571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125590 */     // GIR_Coverage, 64315,
     /* 1125590 */     GIR_EraseRootFromParent_Done,
     /* 1125591 */   // Label 16502: @1125591
     /* 1125591 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1125668), // Rule ID 64316 //
     /* 1125596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125635 */     // MIs[0] policy
     /* 1125635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125645 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11045:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1125648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125667 */     // GIR_Coverage, 64316,
     /* 1125667 */     GIR_EraseRootFromParent_Done,
     /* 1125668 */   // Label 16503: @1125668
     /* 1125668 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1125745), // Rule ID 64317 //
     /* 1125673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125712 */     // MIs[0] policy
     /* 1125712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11045:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125744 */     // GIR_Coverage, 64317,
     /* 1125744 */     GIR_EraseRootFromParent_Done,
     /* 1125745 */   // Label 16504: @1125745
     /* 1125745 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1125822), // Rule ID 64318 //
     /* 1125750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125789 */     // MIs[0] policy
     /* 1125789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11045:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1125802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125821 */     // GIR_Coverage, 64318,
     /* 1125821 */     GIR_EraseRootFromParent_Done,
     /* 1125822 */   // Label 16505: @1125822
     /* 1125822 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1125899), // Rule ID 64319 //
     /* 1125827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125866 */     // MIs[0] policy
     /* 1125866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11045:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1125879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125898 */     // GIR_Coverage, 64319,
     /* 1125898 */     GIR_EraseRootFromParent_Done,
     /* 1125899 */   // Label 16506: @1125899
     /* 1125899 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1125976), // Rule ID 64320 //
     /* 1125904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1125907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1125918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125943 */     // MIs[0] policy
     /* 1125943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125953 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11045:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1125956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125975 */     // GIR_Coverage, 64320,
     /* 1125975 */     GIR_EraseRootFromParent_Done,
     /* 1125976 */   // Label 16507: @1125976
     /* 1125976 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1126053), // Rule ID 64321 //
     /* 1125981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1125984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1125989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1125992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1125995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126020 */     // MIs[0] policy
     /* 1126020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11045:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1126033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126052 */     // GIR_Coverage, 64321,
     /* 1126052 */     GIR_EraseRootFromParent_Done,
     /* 1126053 */   // Label 16508: @1126053
     /* 1126053 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1126130), // Rule ID 64322 //
     /* 1126058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1126066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126097 */     // MIs[0] policy
     /* 1126097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11045:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1126110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126129 */     // GIR_Coverage, 64322,
     /* 1126129 */     GIR_EraseRootFromParent_Done,
     /* 1126130 */   // Label 16509: @1126130
     /* 1126130 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1126207), // Rule ID 64323 //
     /* 1126135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126174 */     // MIs[0] policy
     /* 1126174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1126187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126206 */     // GIR_Coverage, 64323,
     /* 1126206 */     GIR_EraseRootFromParent_Done,
     /* 1126207 */   // Label 16510: @1126207
     /* 1126207 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1126284), // Rule ID 64324 //
     /* 1126212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126251 */     // MIs[0] policy
     /* 1126251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11041:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1126264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126283 */     // GIR_Coverage, 64324,
     /* 1126283 */     GIR_EraseRootFromParent_Done,
     /* 1126284 */   // Label 16511: @1126284
     /* 1126284 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1126361), // Rule ID 64325 //
     /* 1126289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126328 */     // MIs[0] policy
     /* 1126328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1126341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126360 */     // GIR_Coverage, 64325,
     /* 1126360 */     GIR_EraseRootFromParent_Done,
     /* 1126361 */   // Label 16512: @1126361
     /* 1126361 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1126438), // Rule ID 64326 //
     /* 1126366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126405 */     // MIs[0] policy
     /* 1126405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11041:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126437 */     // GIR_Coverage, 64326,
     /* 1126437 */     GIR_EraseRootFromParent_Done,
     /* 1126438 */   // Label 16513: @1126438
     /* 1126438 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1126515), // Rule ID 64327 //
     /* 1126443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126482 */     // MIs[0] policy
     /* 1126482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126492 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1126495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126514 */     // GIR_Coverage, 64327,
     /* 1126514 */     GIR_EraseRootFromParent_Done,
     /* 1126515 */   // Label 16514: @1126515
     /* 1126515 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1126592), // Rule ID 64328 //
     /* 1126520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1126540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126559 */     // MIs[0] policy
     /* 1126559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11041:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1126572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126591 */     // GIR_Coverage, 64328,
     /* 1126591 */     GIR_EraseRootFromParent_Done,
     /* 1126592 */   // Label 16515: @1126592
     /* 1126592 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1126669), // Rule ID 64329 //
     /* 1126597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126636 */     // MIs[0] policy
     /* 1126636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1126649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126668 */     // GIR_Coverage, 64329,
     /* 1126668 */     GIR_EraseRootFromParent_Done,
     /* 1126669 */   // Label 16516: @1126669
     /* 1126669 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1126746), // Rule ID 64330 //
     /* 1126674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1126682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126713 */     // MIs[0] policy
     /* 1126713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11041:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1126726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126745 */     // GIR_Coverage, 64330,
     /* 1126745 */     GIR_EraseRootFromParent_Done,
     /* 1126746 */   // Label 16517: @1126746
     /* 1126746 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1126823), // Rule ID 64331 //
     /* 1126751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126790 */     // MIs[0] policy
     /* 1126790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1126803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126822 */     // GIR_Coverage, 64331,
     /* 1126822 */     GIR_EraseRootFromParent_Done,
     /* 1126823 */   // Label 16518: @1126823
     /* 1126823 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1126900), // Rule ID 64332 //
     /* 1126828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1126839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1126842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126867 */     // MIs[0] policy
     /* 1126867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126877 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11047:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1126880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126899 */     // GIR_Coverage, 64332,
     /* 1126899 */     GIR_EraseRootFromParent_Done,
     /* 1126900 */   // Label 16519: @1126900
     /* 1126900 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1126977), // Rule ID 64333 //
     /* 1126905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1126908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1126925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126944 */     // MIs[0] policy
     /* 1126944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1126957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126976 */     // GIR_Coverage, 64333,
     /* 1126976 */     GIR_EraseRootFromParent_Done,
     /* 1126977 */   // Label 16520: @1126977
     /* 1126977 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1127054), // Rule ID 64334 //
     /* 1126982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1126985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1126990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1126999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127021 */     // MIs[0] policy
     /* 1127021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11047:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1127034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127053 */     // GIR_Coverage, 64334,
     /* 1127053 */     GIR_EraseRootFromParent_Done,
     /* 1127054 */   // Label 16521: @1127054
     /* 1127054 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1127131), // Rule ID 64335 //
     /* 1127059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127098 */     // MIs[0] policy
     /* 1127098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1127111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127130 */     // GIR_Coverage, 64335,
     /* 1127130 */     GIR_EraseRootFromParent_Done,
     /* 1127131 */   // Label 16522: @1127131
     /* 1127131 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1127208), // Rule ID 64336 //
     /* 1127136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127175 */     // MIs[0] policy
     /* 1127175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127185 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11047:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1127188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127207 */     // GIR_Coverage, 64336,
     /* 1127207 */     GIR_EraseRootFromParent_Done,
     /* 1127208 */   // Label 16523: @1127208
     /* 1127208 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1127285), // Rule ID 64337 //
     /* 1127213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127252 */     // MIs[0] policy
     /* 1127252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1127265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127284 */     // GIR_Coverage, 64337,
     /* 1127284 */     GIR_EraseRootFromParent_Done,
     /* 1127285 */   // Label 16524: @1127285
     /* 1127285 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1127362), // Rule ID 64338 //
     /* 1127290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1127298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127329 */     // MIs[0] policy
     /* 1127329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127339 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11047:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1127342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127361 */     // GIR_Coverage, 64338,
     /* 1127361 */     GIR_EraseRootFromParent_Done,
     /* 1127362 */   // Label 16525: @1127362
     /* 1127362 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1127439), // Rule ID 64339 //
     /* 1127367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127406 */     // MIs[0] policy
     /* 1127406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1127419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127438 */     // GIR_Coverage, 64339,
     /* 1127438 */     GIR_EraseRootFromParent_Done,
     /* 1127439 */   // Label 16526: @1127439
     /* 1127439 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1127516), // Rule ID 64340 //
     /* 1127444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127483 */     // MIs[0] policy
     /* 1127483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11043:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1127496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127515 */     // GIR_Coverage, 64340,
     /* 1127515 */     GIR_EraseRootFromParent_Done,
     /* 1127516 */   // Label 16527: @1127516
     /* 1127516 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1127593), // Rule ID 64341 //
     /* 1127521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127560 */     // MIs[0] policy
     /* 1127560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11043:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1127573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127592 */     // GIR_Coverage, 64341,
     /* 1127592 */     GIR_EraseRootFromParent_Done,
     /* 1127593 */   // Label 16528: @1127593
     /* 1127593 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1127670), // Rule ID 64342 //
     /* 1127598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127637 */     // MIs[0] policy
     /* 1127637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11043:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1127650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127669 */     // GIR_Coverage, 64342,
     /* 1127669 */     GIR_EraseRootFromParent_Done,
     /* 1127670 */   // Label 16529: @1127670
     /* 1127670 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1127747), // Rule ID 64343 //
     /* 1127675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127714 */     // MIs[0] policy
     /* 1127714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11043:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1127727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127746 */     // GIR_Coverage, 64343,
     /* 1127746 */     GIR_EraseRootFromParent_Done,
     /* 1127747 */   // Label 16530: @1127747
     /* 1127747 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1127824), // Rule ID 64344 //
     /* 1127752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127791 */     // MIs[0] policy
     /* 1127791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11043:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1127804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127823 */     // GIR_Coverage, 64344,
     /* 1127823 */     GIR_EraseRootFromParent_Done,
     /* 1127824 */   // Label 16531: @1127824
     /* 1127824 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1127901), // Rule ID 64345 //
     /* 1127829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1127832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127868 */     // MIs[0] policy
     /* 1127868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11043:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1127881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127900 */     // GIR_Coverage, 64345,
     /* 1127900 */     GIR_EraseRootFromParent_Done,
     /* 1127901 */   // Label 16532: @1127901
     /* 1127901 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1127978), // Rule ID 64346 //
     /* 1127906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1127909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1127914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127945 */     // MIs[0] policy
     /* 1127945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127955 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11043:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1127958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127977 */     // GIR_Coverage, 64346,
     /* 1127977 */     GIR_EraseRootFromParent_Done,
     /* 1127978 */   // Label 16533: @1127978
     /* 1127978 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1128058), // Rule ID 2716 //
     /* 1127983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1127994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1127997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128022 */     // MIs[0] round
     /* 1128022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128057 */     // GIR_Coverage, 2716,
     /* 1128057 */     GIR_EraseRootFromParent_Done,
     /* 1128058 */   // Label 16534: @1128058
     /* 1128058 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1128138), // Rule ID 2717 //
     /* 1128063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128102 */     // MIs[0] round
     /* 1128102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128112 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128137 */     // GIR_Coverage, 2717,
     /* 1128137 */     GIR_EraseRootFromParent_Done,
     /* 1128138 */   // Label 16535: @1128138
     /* 1128138 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1128218), // Rule ID 2756 //
     /* 1128143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1128146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128182 */     // MIs[0] round
     /* 1128182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128192 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128217 */     // GIR_Coverage, 2756,
     /* 1128217 */     GIR_EraseRootFromParent_Done,
     /* 1128218 */   // Label 16536: @1128218
     /* 1128218 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1128298), // Rule ID 2757 //
     /* 1128223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1128226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128262 */     // MIs[0] round
     /* 1128262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128272 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128297 */     // GIR_Coverage, 2757,
     /* 1128297 */     GIR_EraseRootFromParent_Done,
     /* 1128298 */   // Label 16537: @1128298
     /* 1128298 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1128378), // Rule ID 2776 //
     /* 1128303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128342 */     // MIs[0] round
     /* 1128342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128377 */     // GIR_Coverage, 2776,
     /* 1128377 */     GIR_EraseRootFromParent_Done,
     /* 1128378 */   // Label 16538: @1128378
     /* 1128378 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1128458), // Rule ID 2777 //
     /* 1128383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128422 */     // MIs[0] round
     /* 1128422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128432 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128457 */     // GIR_Coverage, 2777,
     /* 1128457 */     GIR_EraseRootFromParent_Done,
     /* 1128458 */   // Label 16539: @1128458
     /* 1128458 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1128538), // Rule ID 14926 //
     /* 1128463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128502 */     // MIs[0] round
     /* 1128502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128512 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128537 */     // GIR_Coverage, 14926,
     /* 1128537 */     GIR_EraseRootFromParent_Done,
     /* 1128538 */   // Label 16540: @1128538
     /* 1128538 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1128618), // Rule ID 14927 //
     /* 1128543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128582 */     // MIs[0] round
     /* 1128582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128617 */     // GIR_Coverage, 14927,
     /* 1128617 */     GIR_EraseRootFromParent_Done,
     /* 1128618 */   // Label 16541: @1128618
     /* 1128618 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1128698), // Rule ID 14930 //
     /* 1128623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1128634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1128637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128662 */     // MIs[0] round
     /* 1128662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128672 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1128675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128697 */     // GIR_Coverage, 14930,
     /* 1128697 */     GIR_EraseRootFromParent_Done,
     /* 1128698 */   // Label 16542: @1128698
     /* 1128698 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1128778), // Rule ID 14931 //
     /* 1128703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1128714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1128717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128742 */     // MIs[0] round
     /* 1128742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1128755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128777 */     // GIR_Coverage, 14931,
     /* 1128777 */     GIR_EraseRootFromParent_Done,
     /* 1128778 */   // Label 16543: @1128778
     /* 1128778 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1128858), // Rule ID 14934 //
     /* 1128783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1128794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1128797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128822 */     // MIs[0] round
     /* 1128822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128857 */     // GIR_Coverage, 14934,
     /* 1128857 */     GIR_EraseRootFromParent_Done,
     /* 1128858 */   // Label 16544: @1128858
     /* 1128858 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1128938), // Rule ID 14935 //
     /* 1128863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1128874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1128877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128902 */     // MIs[0] round
     /* 1128902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128937 */     // GIR_Coverage, 14935,
     /* 1128937 */     GIR_EraseRootFromParent_Done,
     /* 1128938 */   // Label 16545: @1128938
     /* 1128938 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1129018), // Rule ID 14938 //
     /* 1128943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1128954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1128957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1128960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1128963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128982 */     // MIs[0] round
     /* 1128982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128992 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1128995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129017 */     // GIR_Coverage, 14938,
     /* 1129017 */     GIR_EraseRootFromParent_Done,
     /* 1129018 */   // Label 16546: @1129018
     /* 1129018 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1129098), // Rule ID 14939 //
     /* 1129023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129062 */     // MIs[0] round
     /* 1129062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129097 */     // GIR_Coverage, 14939,
     /* 1129097 */     GIR_EraseRootFromParent_Done,
     /* 1129098 */   // Label 16547: @1129098
     /* 1129098 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1129178), // Rule ID 14942 //
     /* 1129103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129142 */     // MIs[0] round
     /* 1129142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129177 */     // GIR_Coverage, 14942,
     /* 1129177 */     GIR_EraseRootFromParent_Done,
     /* 1129178 */   // Label 16548: @1129178
     /* 1129178 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1129258), // Rule ID 14943 //
     /* 1129183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129222 */     // MIs[0] round
     /* 1129222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129232 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129257 */     // GIR_Coverage, 14943,
     /* 1129257 */     GIR_EraseRootFromParent_Done,
     /* 1129258 */   // Label 16549: @1129258
     /* 1129258 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1129338), // Rule ID 14946 //
     /* 1129263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129302 */     // MIs[0] round
     /* 1129302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129337 */     // GIR_Coverage, 14946,
     /* 1129337 */     GIR_EraseRootFromParent_Done,
     /* 1129338 */   // Label 16550: @1129338
     /* 1129338 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1129418), // Rule ID 14947 //
     /* 1129343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129382 */     // MIs[0] round
     /* 1129382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129417 */     // GIR_Coverage, 14947,
     /* 1129417 */     GIR_EraseRootFromParent_Done,
     /* 1129418 */   // Label 16551: @1129418
     /* 1129418 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1129498), // Rule ID 14950 //
     /* 1129423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129462 */     // MIs[0] round
     /* 1129462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129497 */     // GIR_Coverage, 14950,
     /* 1129497 */     GIR_EraseRootFromParent_Done,
     /* 1129498 */   // Label 16552: @1129498
     /* 1129498 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1129578), // Rule ID 14951 //
     /* 1129503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129542 */     // MIs[0] round
     /* 1129542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129577 */     // GIR_Coverage, 14951,
     /* 1129577 */     GIR_EraseRootFromParent_Done,
     /* 1129578 */   // Label 16553: @1129578
     /* 1129578 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1129658), // Rule ID 14954 //
     /* 1129583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1129600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129622 */     // MIs[0] round
     /* 1129622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129657 */     // GIR_Coverage, 14954,
     /* 1129657 */     GIR_EraseRootFromParent_Done,
     /* 1129658 */   // Label 16554: @1129658
     /* 1129658 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1129738), // Rule ID 14955 //
     /* 1129663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1129680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129702 */     // MIs[0] round
     /* 1129702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129737 */     // GIR_Coverage, 14955,
     /* 1129737 */     GIR_EraseRootFromParent_Done,
     /* 1129738 */   // Label 16555: @1129738
     /* 1129738 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1129818), // Rule ID 14958 //
     /* 1129743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1129746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1129760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129782 */     // MIs[0] round
     /* 1129782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129817 */     // GIR_Coverage, 14958,
     /* 1129817 */     GIR_EraseRootFromParent_Done,
     /* 1129818 */   // Label 16556: @1129818
     /* 1129818 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1129898), // Rule ID 14959 //
     /* 1129823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1129826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1129840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1129843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129862 */     // MIs[0] round
     /* 1129862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129897 */     // GIR_Coverage, 14959,
     /* 1129897 */     GIR_EraseRootFromParent_Done,
     /* 1129898 */   // Label 16557: @1129898
     /* 1129898 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1129978), // Rule ID 14962 //
     /* 1129903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1129914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1129917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1129920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1129923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129942 */     // MIs[0] round
     /* 1129942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1129955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129977 */     // GIR_Coverage, 14962,
     /* 1129977 */     GIR_EraseRootFromParent_Done,
     /* 1129978 */   // Label 16558: @1129978
     /* 1129978 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1130058), // Rule ID 14963 //
     /* 1129983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1129994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1129997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130022 */     // MIs[0] round
     /* 1130022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130057 */     // GIR_Coverage, 14963,
     /* 1130057 */     GIR_EraseRootFromParent_Done,
     /* 1130058 */   // Label 16559: @1130058
     /* 1130058 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1130138), // Rule ID 14966 //
     /* 1130063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130102 */     // MIs[0] round
     /* 1130102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130112 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130137 */     // GIR_Coverage, 14966,
     /* 1130137 */     GIR_EraseRootFromParent_Done,
     /* 1130138 */   // Label 16560: @1130138
     /* 1130138 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1130218), // Rule ID 14967 //
     /* 1130143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130182 */     // MIs[0] round
     /* 1130182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130217 */     // GIR_Coverage, 14967,
     /* 1130217 */     GIR_EraseRootFromParent_Done,
     /* 1130218 */   // Label 16561: @1130218
     /* 1130218 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1130298), // Rule ID 14970 //
     /* 1130223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130262 */     // MIs[0] round
     /* 1130262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130297 */     // GIR_Coverage, 14970,
     /* 1130297 */     GIR_EraseRootFromParent_Done,
     /* 1130298 */   // Label 16562: @1130298
     /* 1130298 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1130378), // Rule ID 14971 //
     /* 1130303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130342 */     // MIs[0] round
     /* 1130342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130377 */     // GIR_Coverage, 14971,
     /* 1130377 */     GIR_EraseRootFromParent_Done,
     /* 1130378 */   // Label 16563: @1130378
     /* 1130378 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1130458), // Rule ID 14974 //
     /* 1130383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130422 */     // MIs[0] round
     /* 1130422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130457 */     // GIR_Coverage, 14974,
     /* 1130457 */     GIR_EraseRootFromParent_Done,
     /* 1130458 */   // Label 16564: @1130458
     /* 1130458 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1130538), // Rule ID 14975 //
     /* 1130463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130502 */     // MIs[0] round
     /* 1130502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130537 */     // GIR_Coverage, 14975,
     /* 1130537 */     GIR_EraseRootFromParent_Done,
     /* 1130538 */   // Label 16565: @1130538
     /* 1130538 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1130618), // Rule ID 14978 //
     /* 1130543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130582 */     // MIs[0] round
     /* 1130582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130592 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130617 */     // GIR_Coverage, 14978,
     /* 1130617 */     GIR_EraseRootFromParent_Done,
     /* 1130618 */   // Label 16566: @1130618
     /* 1130618 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1130698), // Rule ID 14979 //
     /* 1130623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130662 */     // MIs[0] round
     /* 1130662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130697 */     // GIR_Coverage, 14979,
     /* 1130697 */     GIR_EraseRootFromParent_Done,
     /* 1130698 */   // Label 16567: @1130698
     /* 1130698 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1130778), // Rule ID 14982 //
     /* 1130703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1130714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1130717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1130720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1130723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130742 */     // MIs[0] round
     /* 1130742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130752 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130777 */     // GIR_Coverage, 14982,
     /* 1130777 */     GIR_EraseRootFromParent_Done,
     /* 1130778 */   // Label 16568: @1130778
     /* 1130778 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1130858), // Rule ID 14983 //
     /* 1130783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1130794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1130797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1130800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1130803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130822 */     // MIs[0] round
     /* 1130822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130857 */     // GIR_Coverage, 14983,
     /* 1130857 */     GIR_EraseRootFromParent_Done,
     /* 1130858 */   // Label 16569: @1130858
     /* 1130858 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1130938), // Rule ID 14986 //
     /* 1130863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1130874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1130877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1130880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1130883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130902 */     // MIs[0] round
     /* 1130902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130937 */     // GIR_Coverage, 14986,
     /* 1130937 */     GIR_EraseRootFromParent_Done,
     /* 1130938 */   // Label 16570: @1130938
     /* 1130938 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1131018), // Rule ID 14987 //
     /* 1130943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1130954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1130957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1130960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1130963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130982 */     // MIs[0] round
     /* 1130982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131017 */     // GIR_Coverage, 14987,
     /* 1131017 */     GIR_EraseRootFromParent_Done,
     /* 1131018 */   // Label 16571: @1131018
     /* 1131018 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1131098), // Rule ID 14990 //
     /* 1131023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131062 */     // MIs[0] round
     /* 1131062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131097 */     // GIR_Coverage, 14990,
     /* 1131097 */     GIR_EraseRootFromParent_Done,
     /* 1131098 */   // Label 16572: @1131098
     /* 1131098 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1131178), // Rule ID 14991 //
     /* 1131103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131142 */     // MIs[0] round
     /* 1131142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131177 */     // GIR_Coverage, 14991,
     /* 1131177 */     GIR_EraseRootFromParent_Done,
     /* 1131178 */   // Label 16573: @1131178
     /* 1131178 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1131258), // Rule ID 14994 //
     /* 1131183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131222 */     // MIs[0] round
     /* 1131222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131257 */     // GIR_Coverage, 14994,
     /* 1131257 */     GIR_EraseRootFromParent_Done,
     /* 1131258 */   // Label 16574: @1131258
     /* 1131258 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1131338), // Rule ID 14995 //
     /* 1131263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131302 */     // MIs[0] round
     /* 1131302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131337 */     // GIR_Coverage, 14995,
     /* 1131337 */     GIR_EraseRootFromParent_Done,
     /* 1131338 */   // Label 16575: @1131338
     /* 1131338 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1131418), // Rule ID 14998 //
     /* 1131343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131382 */     // MIs[0] round
     /* 1131382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131417 */     // GIR_Coverage, 14998,
     /* 1131417 */     GIR_EraseRootFromParent_Done,
     /* 1131418 */   // Label 16576: @1131418
     /* 1131418 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1131498), // Rule ID 14999 //
     /* 1131423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131462 */     // MIs[0] round
     /* 1131462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131497 */     // GIR_Coverage, 14999,
     /* 1131497 */     GIR_EraseRootFromParent_Done,
     /* 1131498 */   // Label 16577: @1131498
     /* 1131498 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1131578), // Rule ID 15002 //
     /* 1131503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131542 */     // MIs[0] round
     /* 1131542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131577 */     // GIR_Coverage, 15002,
     /* 1131577 */     GIR_EraseRootFromParent_Done,
     /* 1131578 */   // Label 16578: @1131578
     /* 1131578 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1131658), // Rule ID 15003 //
     /* 1131583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131622 */     // MIs[0] round
     /* 1131622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131657 */     // GIR_Coverage, 15003,
     /* 1131657 */     GIR_EraseRootFromParent_Done,
     /* 1131658 */   // Label 16579: @1131658
     /* 1131658 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1131738), // Rule ID 15006 //
     /* 1131663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1131674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1131677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1131680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1131683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131702 */     // MIs[0] round
     /* 1131702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131737 */     // GIR_Coverage, 15006,
     /* 1131737 */     GIR_EraseRootFromParent_Done,
     /* 1131738 */   // Label 16580: @1131738
     /* 1131738 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1131818), // Rule ID 15007 //
     /* 1131743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1131754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1131757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1131760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1131763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131782 */     // MIs[0] round
     /* 1131782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131792 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131817 */     // GIR_Coverage, 15007,
     /* 1131817 */     GIR_EraseRootFromParent_Done,
     /* 1131818 */   // Label 16581: @1131818
     /* 1131818 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1131898), // Rule ID 15010 //
     /* 1131823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1131834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1131837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1131840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1131843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1131862 */     // MIs[0] round
     /* 1131862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1131875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131897 */     // GIR_Coverage, 15010,
     /* 1131897 */     GIR_EraseRootFromParent_Done,
     /* 1131898 */   // Label 16582: @1131898
     /* 1131898 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1131978), // Rule ID 15011 //
     /* 1131903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1131914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1131917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1131920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1131923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1131942 */     // MIs[0] round
     /* 1131942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1131955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131977 */     // GIR_Coverage, 15011,
     /* 1131977 */     GIR_EraseRootFromParent_Done,
     /* 1131978 */   // Label 16583: @1131978
     /* 1131978 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1132058), // Rule ID 15014 //
     /* 1131983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1131994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1131997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132022 */     // MIs[0] round
     /* 1132022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132032 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132057 */     // GIR_Coverage, 15014,
     /* 1132057 */     GIR_EraseRootFromParent_Done,
     /* 1132058 */   // Label 16584: @1132058
     /* 1132058 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1132138), // Rule ID 15015 //
     /* 1132063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132102 */     // MIs[0] round
     /* 1132102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132112 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132137 */     // GIR_Coverage, 15015,
     /* 1132137 */     GIR_EraseRootFromParent_Done,
     /* 1132138 */   // Label 16585: @1132138
     /* 1132138 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1132218), // Rule ID 15018 //
     /* 1132143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132182 */     // MIs[0] round
     /* 1132182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132217 */     // GIR_Coverage, 15018,
     /* 1132217 */     GIR_EraseRootFromParent_Done,
     /* 1132218 */   // Label 16586: @1132218
     /* 1132218 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1132298), // Rule ID 15019 //
     /* 1132223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132262 */     // MIs[0] round
     /* 1132262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132272 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132297 */     // GIR_Coverage, 15019,
     /* 1132297 */     GIR_EraseRootFromParent_Done,
     /* 1132298 */   // Label 16587: @1132298
     /* 1132298 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1132378), // Rule ID 15022 //
     /* 1132303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132342 */     // MIs[0] round
     /* 1132342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132377 */     // GIR_Coverage, 15022,
     /* 1132377 */     GIR_EraseRootFromParent_Done,
     /* 1132378 */   // Label 16588: @1132378
     /* 1132378 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1132458), // Rule ID 15023 //
     /* 1132383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132422 */     // MIs[0] round
     /* 1132422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132432 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132457 */     // GIR_Coverage, 15023,
     /* 1132457 */     GIR_EraseRootFromParent_Done,
     /* 1132458 */   // Label 16589: @1132458
     /* 1132458 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1132538), // Rule ID 15026 //
     /* 1132463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132502 */     // MIs[0] round
     /* 1132502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132537 */     // GIR_Coverage, 15026,
     /* 1132537 */     GIR_EraseRootFromParent_Done,
     /* 1132538 */   // Label 16590: @1132538
     /* 1132538 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1132618), // Rule ID 15027 //
     /* 1132543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132582 */     // MIs[0] round
     /* 1132582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132617 */     // GIR_Coverage, 15027,
     /* 1132617 */     GIR_EraseRootFromParent_Done,
     /* 1132618 */   // Label 16591: @1132618
     /* 1132618 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1132698), // Rule ID 15030 //
     /* 1132623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132662 */     // MIs[0] round
     /* 1132662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132697 */     // GIR_Coverage, 15030,
     /* 1132697 */     GIR_EraseRootFromParent_Done,
     /* 1132698 */   // Label 16592: @1132698
     /* 1132698 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1132778), // Rule ID 15031 //
     /* 1132703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132742 */     // MIs[0] round
     /* 1132742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132777 */     // GIR_Coverage, 15031,
     /* 1132777 */     GIR_EraseRootFromParent_Done,
     /* 1132778 */   // Label 16593: @1132778
     /* 1132778 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1132858), // Rule ID 15034 //
     /* 1132783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1132794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1132797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1132800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132822 */     // MIs[0] round
     /* 1132822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1132835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132857 */     // GIR_Coverage, 15034,
     /* 1132857 */     GIR_EraseRootFromParent_Done,
     /* 1132858 */   // Label 16594: @1132858
     /* 1132858 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1132938), // Rule ID 15035 //
     /* 1132863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1132874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1132877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1132880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132902 */     // MIs[0] round
     /* 1132902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11079:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1132915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132937 */     // GIR_Coverage, 15035,
     /* 1132937 */     GIR_EraseRootFromParent_Done,
     /* 1132938 */   // Label 16595: @1132938
     /* 1132938 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1133018), // Rule ID 15038 //
     /* 1132943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1132954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1132957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1132960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132982 */     // MIs[0] round
     /* 1132982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1132995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133017 */     // GIR_Coverage, 15038,
     /* 1133017 */     GIR_EraseRootFromParent_Done,
     /* 1133018 */   // Label 16596: @1133018
     /* 1133018 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1133098), // Rule ID 15039 //
     /* 1133023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133062 */     // MIs[0] round
     /* 1133062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133097 */     // GIR_Coverage, 15039,
     /* 1133097 */     GIR_EraseRootFromParent_Done,
     /* 1133098 */   // Label 16597: @1133098
     /* 1133098 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1133178), // Rule ID 15042 //
     /* 1133103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133142 */     // MIs[0] round
     /* 1133142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133177 */     // GIR_Coverage, 15042,
     /* 1133177 */     GIR_EraseRootFromParent_Done,
     /* 1133178 */   // Label 16598: @1133178
     /* 1133178 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1133258), // Rule ID 15043 //
     /* 1133183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133222 */     // MIs[0] round
     /* 1133222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133257 */     // GIR_Coverage, 15043,
     /* 1133257 */     GIR_EraseRootFromParent_Done,
     /* 1133258 */   // Label 16599: @1133258
     /* 1133258 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1133338), // Rule ID 15046 //
     /* 1133263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1133266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133302 */     // MIs[0] round
     /* 1133302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133337 */     // GIR_Coverage, 15046,
     /* 1133337 */     GIR_EraseRootFromParent_Done,
     /* 1133338 */   // Label 16600: @1133338
     /* 1133338 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1133418), // Rule ID 15047 //
     /* 1133343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1133346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133382 */     // MIs[0] round
     /* 1133382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133392 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133417 */     // GIR_Coverage, 15047,
     /* 1133417 */     GIR_EraseRootFromParent_Done,
     /* 1133418 */   // Label 16601: @1133418
     /* 1133418 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1133498), // Rule ID 15050 //
     /* 1133423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133462 */     // MIs[0] round
     /* 1133462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133497 */     // GIR_Coverage, 15050,
     /* 1133497 */     GIR_EraseRootFromParent_Done,
     /* 1133498 */   // Label 16602: @1133498
     /* 1133498 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1133578), // Rule ID 15051 //
     /* 1133503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133542 */     // MIs[0] round
     /* 1133542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133577 */     // GIR_Coverage, 15051,
     /* 1133577 */     GIR_EraseRootFromParent_Done,
     /* 1133578 */   // Label 16603: @1133578
     /* 1133578 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1133658), // Rule ID 15054 //
     /* 1133583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1133594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1133597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1133600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133622 */     // MIs[0] round
     /* 1133622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133632 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1133635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133657 */     // GIR_Coverage, 15054,
     /* 1133657 */     GIR_EraseRootFromParent_Done,
     /* 1133658 */   // Label 16604: @1133658
     /* 1133658 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1133738), // Rule ID 15055 //
     /* 1133663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1133674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1133677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1133680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133702 */     // MIs[0] round
     /* 1133702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133712 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1133715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133737 */     // GIR_Coverage, 15055,
     /* 1133737 */     GIR_EraseRootFromParent_Done,
     /* 1133738 */   // Label 16605: @1133738
     /* 1133738 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1133818), // Rule ID 15058 //
     /* 1133743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1133754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1133757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1133760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133782 */     // MIs[0] round
     /* 1133782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1133795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133817 */     // GIR_Coverage, 15058,
     /* 1133817 */     GIR_EraseRootFromParent_Done,
     /* 1133818 */   // Label 16606: @1133818
     /* 1133818 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1133898), // Rule ID 15059 //
     /* 1133823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1133834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1133837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1133840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133862 */     // MIs[0] round
     /* 1133862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1133875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133897 */     // GIR_Coverage, 15059,
     /* 1133897 */     GIR_EraseRootFromParent_Done,
     /* 1133898 */   // Label 16607: @1133898
     /* 1133898 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1133978), // Rule ID 15062 //
     /* 1133903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1133914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1133917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1133920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133942 */     // MIs[0] round
     /* 1133942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133977 */     // GIR_Coverage, 15062,
     /* 1133977 */     GIR_EraseRootFromParent_Done,
     /* 1133978 */   // Label 16608: @1133978
     /* 1133978 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1134058), // Rule ID 15063 //
     /* 1133983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1133994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1133997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134022 */     // MIs[0] round
     /* 1134022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134057 */     // GIR_Coverage, 15063,
     /* 1134057 */     GIR_EraseRootFromParent_Done,
     /* 1134058 */   // Label 16609: @1134058
     /* 1134058 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1134138), // Rule ID 15066 //
     /* 1134063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134102 */     // MIs[0] round
     /* 1134102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134112 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134137 */     // GIR_Coverage, 15066,
     /* 1134137 */     GIR_EraseRootFromParent_Done,
     /* 1134138 */   // Label 16610: @1134138
     /* 1134138 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1134218), // Rule ID 15067 //
     /* 1134143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134182 */     // MIs[0] round
     /* 1134182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134217 */     // GIR_Coverage, 15067,
     /* 1134217 */     GIR_EraseRootFromParent_Done,
     /* 1134218 */   // Label 16611: @1134218
     /* 1134218 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1134298), // Rule ID 15070 //
     /* 1134223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134262 */     // MIs[0] round
     /* 1134262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134272 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134297 */     // GIR_Coverage, 15070,
     /* 1134297 */     GIR_EraseRootFromParent_Done,
     /* 1134298 */   // Label 16612: @1134298
     /* 1134298 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1134378), // Rule ID 15071 //
     /* 1134303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134342 */     // MIs[0] round
     /* 1134342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134352 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134377 */     // GIR_Coverage, 15071,
     /* 1134377 */     GIR_EraseRootFromParent_Done,
     /* 1134378 */   // Label 16613: @1134378
     /* 1134378 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1134458), // Rule ID 15074 //
     /* 1134383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134422 */     // MIs[0] round
     /* 1134422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134457 */     // GIR_Coverage, 15074,
     /* 1134457 */     GIR_EraseRootFromParent_Done,
     /* 1134458 */   // Label 16614: @1134458
     /* 1134458 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1134538), // Rule ID 15075 //
     /* 1134463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134502 */     // MIs[0] round
     /* 1134502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134537 */     // GIR_Coverage, 15075,
     /* 1134537 */     GIR_EraseRootFromParent_Done,
     /* 1134538 */   // Label 16615: @1134538
     /* 1134538 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1134618), // Rule ID 15078 //
     /* 1134543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134582 */     // MIs[0] round
     /* 1134582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134617 */     // GIR_Coverage, 15078,
     /* 1134617 */     GIR_EraseRootFromParent_Done,
     /* 1134618 */   // Label 16616: @1134618
     /* 1134618 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1134698), // Rule ID 15079 //
     /* 1134623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134662 */     // MIs[0] round
     /* 1134662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134672 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134697 */     // GIR_Coverage, 15079,
     /* 1134697 */     GIR_EraseRootFromParent_Done,
     /* 1134698 */   // Label 16617: @1134698
     /* 1134698 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1134778), // Rule ID 15082 //
     /* 1134703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1134714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1134717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1134720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134742 */     // MIs[0] round
     /* 1134742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134777 */     // GIR_Coverage, 15082,
     /* 1134777 */     GIR_EraseRootFromParent_Done,
     /* 1134778 */   // Label 16618: @1134778
     /* 1134778 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1134858), // Rule ID 15083 //
     /* 1134783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1134794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1134797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1134800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134822 */     // MIs[0] round
     /* 1134822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134857 */     // GIR_Coverage, 15083,
     /* 1134857 */     GIR_EraseRootFromParent_Done,
     /* 1134858 */   // Label 16619: @1134858
     /* 1134858 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1134938), // Rule ID 15086 //
     /* 1134863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1134874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1134877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1134880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134902 */     // MIs[0] round
     /* 1134902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134937 */     // GIR_Coverage, 15086,
     /* 1134937 */     GIR_EraseRootFromParent_Done,
     /* 1134938 */   // Label 16620: @1134938
     /* 1134938 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1135018), // Rule ID 15087 //
     /* 1134943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1134954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1134957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1134960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134982 */     // MIs[0] round
     /* 1134982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135017 */     // GIR_Coverage, 15087,
     /* 1135017 */     GIR_EraseRootFromParent_Done,
     /* 1135018 */   // Label 16621: @1135018
     /* 1135018 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1135098), // Rule ID 15090 //
     /* 1135023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135062 */     // MIs[0] round
     /* 1135062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135097 */     // GIR_Coverage, 15090,
     /* 1135097 */     GIR_EraseRootFromParent_Done,
     /* 1135098 */   // Label 16622: @1135098
     /* 1135098 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1135178), // Rule ID 15091 //
     /* 1135103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135142 */     // MIs[0] round
     /* 1135142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135177 */     // GIR_Coverage, 15091,
     /* 1135177 */     GIR_EraseRootFromParent_Done,
     /* 1135178 */   // Label 16623: @1135178
     /* 1135178 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1135258), // Rule ID 15094 //
     /* 1135183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135222 */     // MIs[0] round
     /* 1135222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135257 */     // GIR_Coverage, 15094,
     /* 1135257 */     GIR_EraseRootFromParent_Done,
     /* 1135258 */   // Label 16624: @1135258
     /* 1135258 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1135338), // Rule ID 15095 //
     /* 1135263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135302 */     // MIs[0] round
     /* 1135302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135337 */     // GIR_Coverage, 15095,
     /* 1135337 */     GIR_EraseRootFromParent_Done,
     /* 1135338 */   // Label 16625: @1135338
     /* 1135338 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1135418), // Rule ID 15098 //
     /* 1135343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135382 */     // MIs[0] round
     /* 1135382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135392 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135417 */     // GIR_Coverage, 15098,
     /* 1135417 */     GIR_EraseRootFromParent_Done,
     /* 1135418 */   // Label 16626: @1135418
     /* 1135418 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1135498), // Rule ID 15099 //
     /* 1135423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135462 */     // MIs[0] round
     /* 1135462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135497 */     // GIR_Coverage, 15099,
     /* 1135497 */     GIR_EraseRootFromParent_Done,
     /* 1135498 */   // Label 16627: @1135498
     /* 1135498 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1135578), // Rule ID 15102 //
     /* 1135503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135542 */     // MIs[0] round
     /* 1135542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135577 */     // GIR_Coverage, 15102,
     /* 1135577 */     GIR_EraseRootFromParent_Done,
     /* 1135578 */   // Label 16628: @1135578
     /* 1135578 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1135658), // Rule ID 15103 //
     /* 1135583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135622 */     // MIs[0] round
     /* 1135622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135657 */     // GIR_Coverage, 15103,
     /* 1135657 */     GIR_EraseRootFromParent_Done,
     /* 1135658 */   // Label 16629: @1135658
     /* 1135658 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1135738), // Rule ID 15106 //
     /* 1135663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1135674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1135677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1135680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1135683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135702 */     // MIs[0] round
     /* 1135702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135712 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1135715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135737 */     // GIR_Coverage, 15106,
     /* 1135737 */     GIR_EraseRootFromParent_Done,
     /* 1135738 */   // Label 16630: @1135738
     /* 1135738 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1135818), // Rule ID 15107 //
     /* 1135743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1135754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1135757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1135760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1135763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135782 */     // MIs[0] round
     /* 1135782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1135795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135817 */     // GIR_Coverage, 15107,
     /* 1135817 */     GIR_EraseRootFromParent_Done,
     /* 1135818 */   // Label 16631: @1135818
     /* 1135818 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1135898), // Rule ID 15110 //
     /* 1135823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1135834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1135837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1135840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1135843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135862 */     // MIs[0] round
     /* 1135862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135897 */     // GIR_Coverage, 15110,
     /* 1135897 */     GIR_EraseRootFromParent_Done,
     /* 1135898 */   // Label 16632: @1135898
     /* 1135898 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1135978), // Rule ID 15111 //
     /* 1135903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1135914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1135917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1135920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1135923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135942 */     // MIs[0] round
     /* 1135942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135952 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135977 */     // GIR_Coverage, 15111,
     /* 1135977 */     GIR_EraseRootFromParent_Done,
     /* 1135978 */   // Label 16633: @1135978
     /* 1135978 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1136058), // Rule ID 15114 //
     /* 1135983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1135994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1135997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136022 */     // MIs[0] round
     /* 1136022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136032 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136057 */     // GIR_Coverage, 15114,
     /* 1136057 */     GIR_EraseRootFromParent_Done,
     /* 1136058 */   // Label 16634: @1136058
     /* 1136058 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1136138), // Rule ID 15115 //
     /* 1136063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136102 */     // MIs[0] round
     /* 1136102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136137 */     // GIR_Coverage, 15115,
     /* 1136137 */     GIR_EraseRootFromParent_Done,
     /* 1136138 */   // Label 16635: @1136138
     /* 1136138 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1136218), // Rule ID 15118 //
     /* 1136143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136182 */     // MIs[0] round
     /* 1136182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136217 */     // GIR_Coverage, 15118,
     /* 1136217 */     GIR_EraseRootFromParent_Done,
     /* 1136218 */   // Label 16636: @1136218
     /* 1136218 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1136298), // Rule ID 15119 //
     /* 1136223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136262 */     // MIs[0] round
     /* 1136262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136297 */     // GIR_Coverage, 15119,
     /* 1136297 */     GIR_EraseRootFromParent_Done,
     /* 1136298 */   // Label 16637: @1136298
     /* 1136298 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1136378), // Rule ID 15122 //
     /* 1136303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136342 */     // MIs[0] round
     /* 1136342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136377 */     // GIR_Coverage, 15122,
     /* 1136377 */     GIR_EraseRootFromParent_Done,
     /* 1136378 */   // Label 16638: @1136378
     /* 1136378 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1136458), // Rule ID 15123 //
     /* 1136383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136422 */     // MIs[0] round
     /* 1136422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136457 */     // GIR_Coverage, 15123,
     /* 1136457 */     GIR_EraseRootFromParent_Done,
     /* 1136458 */   // Label 16639: @1136458
     /* 1136458 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1136538), // Rule ID 15126 //
     /* 1136463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136502 */     // MIs[0] round
     /* 1136502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136537 */     // GIR_Coverage, 15126,
     /* 1136537 */     GIR_EraseRootFromParent_Done,
     /* 1136538 */   // Label 16640: @1136538
     /* 1136538 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1136618), // Rule ID 15127 //
     /* 1136543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136582 */     // MIs[0] round
     /* 1136582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136617 */     // GIR_Coverage, 15127,
     /* 1136617 */     GIR_EraseRootFromParent_Done,
     /* 1136618 */   // Label 16641: @1136618
     /* 1136618 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1136698), // Rule ID 15130 //
     /* 1136623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1136634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1136637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1136643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136662 */     // MIs[0] round
     /* 1136662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136697 */     // GIR_Coverage, 15130,
     /* 1136697 */     GIR_EraseRootFromParent_Done,
     /* 1136698 */   // Label 16642: @1136698
     /* 1136698 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1136778), // Rule ID 15131 //
     /* 1136703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1136714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1136717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1136723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136742 */     // MIs[0] round
     /* 1136742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136777 */     // GIR_Coverage, 15131,
     /* 1136777 */     GIR_EraseRootFromParent_Done,
     /* 1136778 */   // Label 16643: @1136778
     /* 1136778 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1136858), // Rule ID 15134 //
     /* 1136783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1136786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1136794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1136797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1136800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1136803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136822 */     // MIs[0] round
     /* 1136822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136857 */     // GIR_Coverage, 15134,
     /* 1136857 */     GIR_EraseRootFromParent_Done,
     /* 1136858 */   // Label 16644: @1136858
     /* 1136858 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1136938), // Rule ID 15135 //
     /* 1136863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1136866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1136874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1136877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1136880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1136883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136902 */     // MIs[0] round
     /* 1136902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136937 */     // GIR_Coverage, 15135,
     /* 1136937 */     GIR_EraseRootFromParent_Done,
     /* 1136938 */   // Label 16645: @1136938
     /* 1136938 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1137018), // Rule ID 15138 //
     /* 1136943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1136954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1136957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1136960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1136963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136982 */     // MIs[0] round
     /* 1136982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136992 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1136995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137017 */     // GIR_Coverage, 15138,
     /* 1137017 */     GIR_EraseRootFromParent_Done,
     /* 1137018 */   // Label 16646: @1137018
     /* 1137018 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1137098), // Rule ID 15139 //
     /* 1137023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137062 */     // MIs[0] round
     /* 1137062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137097 */     // GIR_Coverage, 15139,
     /* 1137097 */     GIR_EraseRootFromParent_Done,
     /* 1137098 */   // Label 16647: @1137098
     /* 1137098 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1137178), // Rule ID 15142 //
     /* 1137103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137142 */     // MIs[0] round
     /* 1137142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137177 */     // GIR_Coverage, 15142,
     /* 1137177 */     GIR_EraseRootFromParent_Done,
     /* 1137178 */   // Label 16648: @1137178
     /* 1137178 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1137258), // Rule ID 15143 //
     /* 1137183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137222 */     // MIs[0] round
     /* 1137222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137257 */     // GIR_Coverage, 15143,
     /* 1137257 */     GIR_EraseRootFromParent_Done,
     /* 1137258 */   // Label 16649: @1137258
     /* 1137258 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1137338), // Rule ID 15146 //
     /* 1137263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137302 */     // MIs[0] round
     /* 1137302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137337 */     // GIR_Coverage, 15146,
     /* 1137337 */     GIR_EraseRootFromParent_Done,
     /* 1137338 */   // Label 16650: @1137338
     /* 1137338 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1137418), // Rule ID 15147 //
     /* 1137343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137382 */     // MIs[0] round
     /* 1137382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137417 */     // GIR_Coverage, 15147,
     /* 1137417 */     GIR_EraseRootFromParent_Done,
     /* 1137418 */   // Label 16651: @1137418
     /* 1137418 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1137498), // Rule ID 15150 //
     /* 1137423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137462 */     // MIs[0] round
     /* 1137462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137497 */     // GIR_Coverage, 15150,
     /* 1137497 */     GIR_EraseRootFromParent_Done,
     /* 1137498 */   // Label 16652: @1137498
     /* 1137498 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1137578), // Rule ID 15151 //
     /* 1137503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137542 */     // MIs[0] round
     /* 1137542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137577 */     // GIR_Coverage, 15151,
     /* 1137577 */     GIR_EraseRootFromParent_Done,
     /* 1137578 */   // Label 16653: @1137578
     /* 1137578 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1137658), // Rule ID 15154 //
     /* 1137583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1137594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1137597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1137600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1137603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137622 */     // MIs[0] round
     /* 1137622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137657 */     // GIR_Coverage, 15154,
     /* 1137657 */     GIR_EraseRootFromParent_Done,
     /* 1137658 */   // Label 16654: @1137658
     /* 1137658 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1137738), // Rule ID 15155 //
     /* 1137663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1137674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1137677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1137680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1137683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137702 */     // MIs[0] round
     /* 1137702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137737 */     // GIR_Coverage, 15155,
     /* 1137737 */     GIR_EraseRootFromParent_Done,
     /* 1137738 */   // Label 16655: @1137738
     /* 1137738 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1137818), // Rule ID 15158 //
     /* 1137743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1137754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1137757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1137760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1137763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137782 */     // MIs[0] round
     /* 1137782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137817 */     // GIR_Coverage, 15158,
     /* 1137817 */     GIR_EraseRootFromParent_Done,
     /* 1137818 */   // Label 16656: @1137818
     /* 1137818 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1137898), // Rule ID 15159 //
     /* 1137823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1137834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1137837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1137840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1137843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137862 */     // MIs[0] round
     /* 1137862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137897 */     // GIR_Coverage, 15159,
     /* 1137897 */     GIR_EraseRootFromParent_Done,
     /* 1137898 */   // Label 16657: @1137898
     /* 1137898 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1137978), // Rule ID 15162 //
     /* 1137903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1137914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1137917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1137920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1137923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137942 */     // MIs[0] round
     /* 1137942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137977 */     // GIR_Coverage, 15162,
     /* 1137977 */     GIR_EraseRootFromParent_Done,
     /* 1137978 */   // Label 16658: @1137978
     /* 1137978 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1138058), // Rule ID 15163 //
     /* 1137983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1137994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1137997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138022 */     // MIs[0] round
     /* 1138022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138057 */     // GIR_Coverage, 15163,
     /* 1138057 */     GIR_EraseRootFromParent_Done,
     /* 1138058 */   // Label 16659: @1138058
     /* 1138058 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1138138), // Rule ID 15166 //
     /* 1138063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138102 */     // MIs[0] round
     /* 1138102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138137 */     // GIR_Coverage, 15166,
     /* 1138137 */     GIR_EraseRootFromParent_Done,
     /* 1138138 */   // Label 16660: @1138138
     /* 1138138 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1138218), // Rule ID 15167 //
     /* 1138143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138182 */     // MIs[0] round
     /* 1138182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138217 */     // GIR_Coverage, 15167,
     /* 1138217 */     GIR_EraseRootFromParent_Done,
     /* 1138218 */   // Label 16661: @1138218
     /* 1138218 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1138298), // Rule ID 15170 //
     /* 1138223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138262 */     // MIs[0] round
     /* 1138262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138297 */     // GIR_Coverage, 15170,
     /* 1138297 */     GIR_EraseRootFromParent_Done,
     /* 1138298 */   // Label 16662: @1138298
     /* 1138298 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1138378), // Rule ID 15171 //
     /* 1138303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138342 */     // MIs[0] round
     /* 1138342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138377 */     // GIR_Coverage, 15171,
     /* 1138377 */     GIR_EraseRootFromParent_Done,
     /* 1138378 */   // Label 16663: @1138378
     /* 1138378 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1138458), // Rule ID 15174 //
     /* 1138383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138422 */     // MIs[0] round
     /* 1138422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138457 */     // GIR_Coverage, 15174,
     /* 1138457 */     GIR_EraseRootFromParent_Done,
     /* 1138458 */   // Label 16664: @1138458
     /* 1138458 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1138538), // Rule ID 15175 //
     /* 1138463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138502 */     // MIs[0] round
     /* 1138502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138537 */     // GIR_Coverage, 15175,
     /* 1138537 */     GIR_EraseRootFromParent_Done,
     /* 1138538 */   // Label 16665: @1138538
     /* 1138538 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1138618), // Rule ID 15178 //
     /* 1138543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138582 */     // MIs[0] round
     /* 1138582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138617 */     // GIR_Coverage, 15178,
     /* 1138617 */     GIR_EraseRootFromParent_Done,
     /* 1138618 */   // Label 16666: @1138618
     /* 1138618 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1138698), // Rule ID 15179 //
     /* 1138623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138662 */     // MIs[0] round
     /* 1138662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138697 */     // GIR_Coverage, 15179,
     /* 1138697 */     GIR_EraseRootFromParent_Done,
     /* 1138698 */   // Label 16667: @1138698
     /* 1138698 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1138778), // Rule ID 15182 //
     /* 1138703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1138714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1138717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1138720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1138723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138742 */     // MIs[0] round
     /* 1138742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138777 */     // GIR_Coverage, 15182,
     /* 1138777 */     GIR_EraseRootFromParent_Done,
     /* 1138778 */   // Label 16668: @1138778
     /* 1138778 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1138858), // Rule ID 15183 //
     /* 1138783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1138794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1138797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1138800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1138803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138822 */     // MIs[0] round
     /* 1138822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138832 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138857 */     // GIR_Coverage, 15183,
     /* 1138857 */     GIR_EraseRootFromParent_Done,
     /* 1138858 */   // Label 16669: @1138858
     /* 1138858 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1138938), // Rule ID 15186 //
     /* 1138863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1138874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1138877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1138883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138902 */     // MIs[0] round
     /* 1138902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138912 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1138915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138937 */     // GIR_Coverage, 15186,
     /* 1138937 */     GIR_EraseRootFromParent_Done,
     /* 1138938 */   // Label 16670: @1138938
     /* 1138938 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1139018), // Rule ID 15187 //
     /* 1138943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1138954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1138957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1138963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1138982 */     // MIs[0] round
     /* 1138982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1138995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139017 */     // GIR_Coverage, 15187,
     /* 1139017 */     GIR_EraseRootFromParent_Done,
     /* 1139018 */   // Label 16671: @1139018
     /* 1139018 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1139098), // Rule ID 15190 //
     /* 1139023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139062 */     // MIs[0] round
     /* 1139062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139072 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139097 */     // GIR_Coverage, 15190,
     /* 1139097 */     GIR_EraseRootFromParent_Done,
     /* 1139098 */   // Label 16672: @1139098
     /* 1139098 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1139178), // Rule ID 15191 //
     /* 1139103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139142 */     // MIs[0] round
     /* 1139142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139177 */     // GIR_Coverage, 15191,
     /* 1139177 */     GIR_EraseRootFromParent_Done,
     /* 1139178 */   // Label 16673: @1139178
     /* 1139178 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1139258), // Rule ID 15194 //
     /* 1139183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139222 */     // MIs[0] round
     /* 1139222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139232 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139257 */     // GIR_Coverage, 15194,
     /* 1139257 */     GIR_EraseRootFromParent_Done,
     /* 1139258 */   // Label 16674: @1139258
     /* 1139258 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1139338), // Rule ID 15195 //
     /* 1139263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139302 */     // MIs[0] round
     /* 1139302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139312 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139337 */     // GIR_Coverage, 15195,
     /* 1139337 */     GIR_EraseRootFromParent_Done,
     /* 1139338 */   // Label 16675: @1139338
     /* 1139338 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1139418), // Rule ID 15198 //
     /* 1139343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139382 */     // MIs[0] round
     /* 1139382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139417 */     // GIR_Coverage, 15198,
     /* 1139417 */     GIR_EraseRootFromParent_Done,
     /* 1139418 */   // Label 16676: @1139418
     /* 1139418 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1139498), // Rule ID 15199 //
     /* 1139423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139462 */     // MIs[0] round
     /* 1139462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139497 */     // GIR_Coverage, 15199,
     /* 1139497 */     GIR_EraseRootFromParent_Done,
     /* 1139498 */   // Label 16677: @1139498
     /* 1139498 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1139578), // Rule ID 15202 //
     /* 1139503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139542 */     // MIs[0] round
     /* 1139542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139577 */     // GIR_Coverage, 15202,
     /* 1139577 */     GIR_EraseRootFromParent_Done,
     /* 1139578 */   // Label 16678: @1139578
     /* 1139578 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1139658), // Rule ID 15203 //
     /* 1139583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139622 */     // MIs[0] round
     /* 1139622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139657 */     // GIR_Coverage, 15203,
     /* 1139657 */     GIR_EraseRootFromParent_Done,
     /* 1139658 */   // Label 16679: @1139658
     /* 1139658 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1139738), // Rule ID 15206 //
     /* 1139663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1139674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1139677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1139680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139702 */     // MIs[0] round
     /* 1139702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139737 */     // GIR_Coverage, 15206,
     /* 1139737 */     GIR_EraseRootFromParent_Done,
     /* 1139738 */   // Label 16680: @1139738
     /* 1139738 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1139818), // Rule ID 15207 //
     /* 1139743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1139754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1139757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1139760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139782 */     // MIs[0] round
     /* 1139782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139817 */     // GIR_Coverage, 15207,
     /* 1139817 */     GIR_EraseRootFromParent_Done,
     /* 1139818 */   // Label 16681: @1139818
     /* 1139818 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1139898), // Rule ID 15210 //
     /* 1139823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139862 */     // MIs[0] round
     /* 1139862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1139875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139897 */     // GIR_Coverage, 15210,
     /* 1139897 */     GIR_EraseRootFromParent_Done,
     /* 1139898 */   // Label 16682: @1139898
     /* 1139898 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1139978), // Rule ID 15211 //
     /* 1139903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139942 */     // MIs[0] round
     /* 1139942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11101:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1139955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139977 */     // GIR_Coverage, 15211,
     /* 1139977 */     GIR_EraseRootFromParent_Done,
     /* 1139978 */   // Label 16683: @1139978
     /* 1139978 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1140058), // Rule ID 15214 //
     /* 1139983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1139994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1139997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140022 */     // MIs[0] round
     /* 1140022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140057 */     // GIR_Coverage, 15214,
     /* 1140057 */     GIR_EraseRootFromParent_Done,
     /* 1140058 */   // Label 16684: @1140058
     /* 1140058 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1140138), // Rule ID 15215 //
     /* 1140063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140102 */     // MIs[0] round
     /* 1140102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11101:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140137 */     // GIR_Coverage, 15215,
     /* 1140137 */     GIR_EraseRootFromParent_Done,
     /* 1140138 */   // Label 16685: @1140138
     /* 1140138 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1140218), // Rule ID 15218 //
     /* 1140143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140182 */     // MIs[0] round
     /* 1140182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140217 */     // GIR_Coverage, 15218,
     /* 1140217 */     GIR_EraseRootFromParent_Done,
     /* 1140218 */   // Label 16686: @1140218
     /* 1140218 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1140298), // Rule ID 15219 //
     /* 1140223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140262 */     // MIs[0] round
     /* 1140262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140297 */     // GIR_Coverage, 15219,
     /* 1140297 */     GIR_EraseRootFromParent_Done,
     /* 1140298 */   // Label 16687: @1140298
     /* 1140298 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1140378), // Rule ID 15222 //
     /* 1140303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1140306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140342 */     // MIs[0] round
     /* 1140342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140377 */     // GIR_Coverage, 15222,
     /* 1140377 */     GIR_EraseRootFromParent_Done,
     /* 1140378 */   // Label 16688: @1140378
     /* 1140378 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1140458), // Rule ID 15223 //
     /* 1140383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1140386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140422 */     // MIs[0] round
     /* 1140422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140457 */     // GIR_Coverage, 15223,
     /* 1140457 */     GIR_EraseRootFromParent_Done,
     /* 1140458 */   // Label 16689: @1140458
     /* 1140458 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1140538), // Rule ID 15226 //
     /* 1140463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140502 */     // MIs[0] round
     /* 1140502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140537 */     // GIR_Coverage, 15226,
     /* 1140537 */     GIR_EraseRootFromParent_Done,
     /* 1140538 */   // Label 16690: @1140538
     /* 1140538 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1140618), // Rule ID 15227 //
     /* 1140543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140582 */     // MIs[0] round
     /* 1140582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140617 */     // GIR_Coverage, 15227,
     /* 1140617 */     GIR_EraseRootFromParent_Done,
     /* 1140618 */   // Label 16691: @1140618
     /* 1140618 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1140698), // Rule ID 15230 //
     /* 1140623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1140634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1140637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1140640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140662 */     // MIs[0] round
     /* 1140662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1140675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140697 */     // GIR_Coverage, 15230,
     /* 1140697 */     GIR_EraseRootFromParent_Done,
     /* 1140698 */   // Label 16692: @1140698
     /* 1140698 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1140778), // Rule ID 15231 //
     /* 1140703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1140714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1140717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1140720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140742 */     // MIs[0] round
     /* 1140742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1140755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140777 */     // GIR_Coverage, 15231,
     /* 1140777 */     GIR_EraseRootFromParent_Done,
     /* 1140778 */   // Label 16693: @1140778
     /* 1140778 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1140858), // Rule ID 15234 //
     /* 1140783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1140794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1140797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1140800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140822 */     // MIs[0] round
     /* 1140822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140832 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1140835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140857 */     // GIR_Coverage, 15234,
     /* 1140857 */     GIR_EraseRootFromParent_Done,
     /* 1140858 */   // Label 16694: @1140858
     /* 1140858 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1140938), // Rule ID 15235 //
     /* 1140863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1140874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1140877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1140880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140902 */     // MIs[0] round
     /* 1140902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140912 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1140915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140937 */     // GIR_Coverage, 15235,
     /* 1140937 */     GIR_EraseRootFromParent_Done,
     /* 1140938 */   // Label 16695: @1140938
     /* 1140938 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1141018), // Rule ID 15238 //
     /* 1140943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1140954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1140957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1140960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140982 */     // MIs[0] round
     /* 1140982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140992 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141017 */     // GIR_Coverage, 15238,
     /* 1141017 */     GIR_EraseRootFromParent_Done,
     /* 1141018 */   // Label 16696: @1141018
     /* 1141018 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1141098), // Rule ID 15239 //
     /* 1141023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141062 */     // MIs[0] round
     /* 1141062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141097 */     // GIR_Coverage, 15239,
     /* 1141097 */     GIR_EraseRootFromParent_Done,
     /* 1141098 */   // Label 16697: @1141098
     /* 1141098 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1141178), // Rule ID 15242 //
     /* 1141103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141142 */     // MIs[0] round
     /* 1141142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141177 */     // GIR_Coverage, 15242,
     /* 1141177 */     GIR_EraseRootFromParent_Done,
     /* 1141178 */   // Label 16698: @1141178
     /* 1141178 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1141258), // Rule ID 15243 //
     /* 1141183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141222 */     // MIs[0] round
     /* 1141222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141257 */     // GIR_Coverage, 15243,
     /* 1141257 */     GIR_EraseRootFromParent_Done,
     /* 1141258 */   // Label 16699: @1141258
     /* 1141258 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1141338), // Rule ID 15246 //
     /* 1141263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141302 */     // MIs[0] round
     /* 1141302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141337 */     // GIR_Coverage, 15246,
     /* 1141337 */     GIR_EraseRootFromParent_Done,
     /* 1141338 */   // Label 16700: @1141338
     /* 1141338 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1141418), // Rule ID 15247 //
     /* 1141343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141382 */     // MIs[0] round
     /* 1141382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141417 */     // GIR_Coverage, 15247,
     /* 1141417 */     GIR_EraseRootFromParent_Done,
     /* 1141418 */   // Label 16701: @1141418
     /* 1141418 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1141498), // Rule ID 15250 //
     /* 1141423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141462 */     // MIs[0] round
     /* 1141462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141472 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141497 */     // GIR_Coverage, 15250,
     /* 1141497 */     GIR_EraseRootFromParent_Done,
     /* 1141498 */   // Label 16702: @1141498
     /* 1141498 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1141578), // Rule ID 15251 //
     /* 1141503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141542 */     // MIs[0] round
     /* 1141542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141577 */     // GIR_Coverage, 15251,
     /* 1141577 */     GIR_EraseRootFromParent_Done,
     /* 1141578 */   // Label 16703: @1141578
     /* 1141578 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1141658), // Rule ID 15254 //
     /* 1141583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1141594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1141597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1141600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141622 */     // MIs[0] round
     /* 1141622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141657 */     // GIR_Coverage, 15254,
     /* 1141657 */     GIR_EraseRootFromParent_Done,
     /* 1141658 */   // Label 16704: @1141658
     /* 1141658 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1141738), // Rule ID 15255 //
     /* 1141663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1141674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1141677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1141680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141702 */     // MIs[0] round
     /* 1141702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141737 */     // GIR_Coverage, 15255,
     /* 1141737 */     GIR_EraseRootFromParent_Done,
     /* 1141738 */   // Label 16705: @1141738
     /* 1141738 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1141818), // Rule ID 15258 //
     /* 1141743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1141754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1141757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1141760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141782 */     // MIs[0] round
     /* 1141782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141817 */     // GIR_Coverage, 15258,
     /* 1141817 */     GIR_EraseRootFromParent_Done,
     /* 1141818 */   // Label 16706: @1141818
     /* 1141818 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1141898), // Rule ID 15259 //
     /* 1141823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1141834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1141837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1141840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141862 */     // MIs[0] round
     /* 1141862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141897 */     // GIR_Coverage, 15259,
     /* 1141897 */     GIR_EraseRootFromParent_Done,
     /* 1141898 */   // Label 16707: @1141898
     /* 1141898 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1141978), // Rule ID 15262 //
     /* 1141903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1141920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141942 */     // MIs[0] round
     /* 1141942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141977 */     // GIR_Coverage, 15262,
     /* 1141977 */     GIR_EraseRootFromParent_Done,
     /* 1141978 */   // Label 16708: @1141978
     /* 1141978 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1142058), // Rule ID 15263 //
     /* 1141983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142022 */     // MIs[0] round
     /* 1142022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142057 */     // GIR_Coverage, 15263,
     /* 1142057 */     GIR_EraseRootFromParent_Done,
     /* 1142058 */   // Label 16709: @1142058
     /* 1142058 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1142138), // Rule ID 15266 //
     /* 1142063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142102 */     // MIs[0] round
     /* 1142102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142137 */     // GIR_Coverage, 15266,
     /* 1142137 */     GIR_EraseRootFromParent_Done,
     /* 1142138 */   // Label 16710: @1142138
     /* 1142138 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1142218), // Rule ID 15267 //
     /* 1142143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142182 */     // MIs[0] round
     /* 1142182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142217 */     // GIR_Coverage, 15267,
     /* 1142217 */     GIR_EraseRootFromParent_Done,
     /* 1142218 */   // Label 16711: @1142218
     /* 1142218 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1142298), // Rule ID 15270 //
     /* 1142223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142262 */     // MIs[0] round
     /* 1142262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142297 */     // GIR_Coverage, 15270,
     /* 1142297 */     GIR_EraseRootFromParent_Done,
     /* 1142298 */   // Label 16712: @1142298
     /* 1142298 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1142378), // Rule ID 15271 //
     /* 1142303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142342 */     // MIs[0] round
     /* 1142342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142377 */     // GIR_Coverage, 15271,
     /* 1142377 */     GIR_EraseRootFromParent_Done,
     /* 1142378 */   // Label 16713: @1142378
     /* 1142378 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1142458), // Rule ID 15274 //
     /* 1142383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142422 */     // MIs[0] round
     /* 1142422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142457 */     // GIR_Coverage, 15274,
     /* 1142457 */     GIR_EraseRootFromParent_Done,
     /* 1142458 */   // Label 16714: @1142458
     /* 1142458 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1142538), // Rule ID 15275 //
     /* 1142463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142502 */     // MIs[0] round
     /* 1142502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142537 */     // GIR_Coverage, 15275,
     /* 1142537 */     GIR_EraseRootFromParent_Done,
     /* 1142538 */   // Label 16715: @1142538
     /* 1142538 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1142618), // Rule ID 15278 //
     /* 1142543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142582 */     // MIs[0] round
     /* 1142582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142617 */     // GIR_Coverage, 15278,
     /* 1142617 */     GIR_EraseRootFromParent_Done,
     /* 1142618 */   // Label 16716: @1142618
     /* 1142618 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1142698), // Rule ID 15279 //
     /* 1142623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142662 */     // MIs[0] round
     /* 1142662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142672 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142697 */     // GIR_Coverage, 15279,
     /* 1142697 */     GIR_EraseRootFromParent_Done,
     /* 1142698 */   // Label 16717: @1142698
     /* 1142698 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1142778), // Rule ID 15282 //
     /* 1142703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1142714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1142717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1142720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1142723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142742 */     // MIs[0] round
     /* 1142742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1142755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142777 */     // GIR_Coverage, 15282,
     /* 1142777 */     GIR_EraseRootFromParent_Done,
     /* 1142778 */   // Label 16718: @1142778
     /* 1142778 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1142858), // Rule ID 15283 //
     /* 1142783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1142794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1142797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1142800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1142803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142822 */     // MIs[0] round
     /* 1142822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1142835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142857 */     // GIR_Coverage, 15283,
     /* 1142857 */     GIR_EraseRootFromParent_Done,
     /* 1142858 */   // Label 16719: @1142858
     /* 1142858 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1142938), // Rule ID 15286 //
     /* 1142863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1142883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142902 */     // MIs[0] round
     /* 1142902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142937 */     // GIR_Coverage, 15286,
     /* 1142937 */     GIR_EraseRootFromParent_Done,
     /* 1142938 */   // Label 16720: @1142938
     /* 1142938 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1143018), // Rule ID 15287 //
     /* 1142943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1142963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142982 */     // MIs[0] round
     /* 1142982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143017 */     // GIR_Coverage, 15287,
     /* 1143017 */     GIR_EraseRootFromParent_Done,
     /* 1143018 */   // Label 16721: @1143018
     /* 1143018 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1143098), // Rule ID 15290 //
     /* 1143023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143062 */     // MIs[0] round
     /* 1143062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143097 */     // GIR_Coverage, 15290,
     /* 1143097 */     GIR_EraseRootFromParent_Done,
     /* 1143098 */   // Label 16722: @1143098
     /* 1143098 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1143178), // Rule ID 15291 //
     /* 1143103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143142 */     // MIs[0] round
     /* 1143142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143177 */     // GIR_Coverage, 15291,
     /* 1143177 */     GIR_EraseRootFromParent_Done,
     /* 1143178 */   // Label 16723: @1143178
     /* 1143178 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1143258), // Rule ID 15294 //
     /* 1143183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143222 */     // MIs[0] round
     /* 1143222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143232 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143257 */     // GIR_Coverage, 15294,
     /* 1143257 */     GIR_EraseRootFromParent_Done,
     /* 1143258 */   // Label 16724: @1143258
     /* 1143258 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1143338), // Rule ID 15295 //
     /* 1143263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143302 */     // MIs[0] round
     /* 1143302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143337 */     // GIR_Coverage, 15295,
     /* 1143337 */     GIR_EraseRootFromParent_Done,
     /* 1143338 */   // Label 16725: @1143338
     /* 1143338 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1143418), // Rule ID 15298 //
     /* 1143343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143382 */     // MIs[0] round
     /* 1143382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143417 */     // GIR_Coverage, 15298,
     /* 1143417 */     GIR_EraseRootFromParent_Done,
     /* 1143418 */   // Label 16726: @1143418
     /* 1143418 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1143498), // Rule ID 15299 //
     /* 1143423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143462 */     // MIs[0] round
     /* 1143462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143497 */     // GIR_Coverage, 15299,
     /* 1143497 */     GIR_EraseRootFromParent_Done,
     /* 1143498 */   // Label 16727: @1143498
     /* 1143498 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1143578), // Rule ID 15302 //
     /* 1143503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143542 */     // MIs[0] round
     /* 1143542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143577 */     // GIR_Coverage, 15302,
     /* 1143577 */     GIR_EraseRootFromParent_Done,
     /* 1143578 */   // Label 16728: @1143578
     /* 1143578 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1143658), // Rule ID 15303 //
     /* 1143583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143622 */     // MIs[0] round
     /* 1143622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143657 */     // GIR_Coverage, 15303,
     /* 1143657 */     GIR_EraseRootFromParent_Done,
     /* 1143658 */   // Label 16729: @1143658
     /* 1143658 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1143738), // Rule ID 15306 //
     /* 1143663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1143674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1143677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1143680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1143683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143702 */     // MIs[0] round
     /* 1143702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143737 */     // GIR_Coverage, 15306,
     /* 1143737 */     GIR_EraseRootFromParent_Done,
     /* 1143738 */   // Label 16730: @1143738
     /* 1143738 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1143818), // Rule ID 15307 //
     /* 1143743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1143754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1143757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1143760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1143763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143782 */     // MIs[0] round
     /* 1143782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143817 */     // GIR_Coverage, 15307,
     /* 1143817 */     GIR_EraseRootFromParent_Done,
     /* 1143818 */   // Label 16731: @1143818
     /* 1143818 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1143898), // Rule ID 15310 //
     /* 1143823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1143826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1143843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143862 */     // MIs[0] round
     /* 1143862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143897 */     // GIR_Coverage, 15310,
     /* 1143897 */     GIR_EraseRootFromParent_Done,
     /* 1143898 */   // Label 16732: @1143898
     /* 1143898 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1143978), // Rule ID 15311 //
     /* 1143903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1143906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1143923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143942 */     // MIs[0] round
     /* 1143942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143977 */     // GIR_Coverage, 15311,
     /* 1143977 */     GIR_EraseRootFromParent_Done,
     /* 1143978 */   // Label 16733: @1143978
     /* 1143978 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1144058), // Rule ID 15314 //
     /* 1143983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1143994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1143997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144022 */     // MIs[0] round
     /* 1144022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144057 */     // GIR_Coverage, 15314,
     /* 1144057 */     GIR_EraseRootFromParent_Done,
     /* 1144058 */   // Label 16734: @1144058
     /* 1144058 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1144138), // Rule ID 15315 //
     /* 1144063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144102 */     // MIs[0] round
     /* 1144102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144112 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144137 */     // GIR_Coverage, 15315,
     /* 1144137 */     GIR_EraseRootFromParent_Done,
     /* 1144138 */   // Label 16735: @1144138
     /* 1144138 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1144218), // Rule ID 15318 //
     /* 1144143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144182 */     // MIs[0] round
     /* 1144182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144217 */     // GIR_Coverage, 15318,
     /* 1144217 */     GIR_EraseRootFromParent_Done,
     /* 1144218 */   // Label 16736: @1144218
     /* 1144218 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1144298), // Rule ID 15319 //
     /* 1144223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144262 */     // MIs[0] round
     /* 1144262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144297 */     // GIR_Coverage, 15319,
     /* 1144297 */     GIR_EraseRootFromParent_Done,
     /* 1144298 */   // Label 16737: @1144298
     /* 1144298 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1144378), // Rule ID 15322 //
     /* 1144303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144342 */     // MIs[0] round
     /* 1144342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144377 */     // GIR_Coverage, 15322,
     /* 1144377 */     GIR_EraseRootFromParent_Done,
     /* 1144378 */   // Label 16738: @1144378
     /* 1144378 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1144458), // Rule ID 15323 //
     /* 1144383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144422 */     // MIs[0] round
     /* 1144422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144432 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144457 */     // GIR_Coverage, 15323,
     /* 1144457 */     GIR_EraseRootFromParent_Done,
     /* 1144458 */   // Label 16739: @1144458
     /* 1144458 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1144538), // Rule ID 15326 //
     /* 1144463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144502 */     // MIs[0] round
     /* 1144502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144537 */     // GIR_Coverage, 15326,
     /* 1144537 */     GIR_EraseRootFromParent_Done,
     /* 1144538 */   // Label 16740: @1144538
     /* 1144538 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1144618), // Rule ID 15327 //
     /* 1144543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144582 */     // MIs[0] round
     /* 1144582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144617 */     // GIR_Coverage, 15327,
     /* 1144617 */     GIR_EraseRootFromParent_Done,
     /* 1144618 */   // Label 16741: @1144618
     /* 1144618 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1144698), // Rule ID 15330 //
     /* 1144623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1144634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1144637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1144640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1144643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144662 */     // MIs[0] round
     /* 1144662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144697 */     // GIR_Coverage, 15330,
     /* 1144697 */     GIR_EraseRootFromParent_Done,
     /* 1144698 */   // Label 16742: @1144698
     /* 1144698 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1144778), // Rule ID 15331 //
     /* 1144703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1144714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1144717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1144720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1144723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144742 */     // MIs[0] round
     /* 1144742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144777 */     // GIR_Coverage, 15331,
     /* 1144777 */     GIR_EraseRootFromParent_Done,
     /* 1144778 */   // Label 16743: @1144778
     /* 1144778 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1144858), // Rule ID 15334 //
     /* 1144783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1144794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1144797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1144800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1144803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144822 */     // MIs[0] round
     /* 1144822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144857 */     // GIR_Coverage, 15334,
     /* 1144857 */     GIR_EraseRootFromParent_Done,
     /* 1144858 */   // Label 16744: @1144858
     /* 1144858 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1144938), // Rule ID 15335 //
     /* 1144863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1144874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1144877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1144880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1144883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144902 */     // MIs[0] round
     /* 1144902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144912 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144937 */     // GIR_Coverage, 15335,
     /* 1144937 */     GIR_EraseRootFromParent_Done,
     /* 1144938 */   // Label 16745: @1144938
     /* 1144938 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1145018), // Rule ID 15338 //
     /* 1144943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1144954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1144957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1144960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1144963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144982 */     // MIs[0] round
     /* 1144982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145017 */     // GIR_Coverage, 15338,
     /* 1145017 */     GIR_EraseRootFromParent_Done,
     /* 1145018 */   // Label 16746: @1145018
     /* 1145018 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1145098), // Rule ID 15339 //
     /* 1145023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145062 */     // MIs[0] round
     /* 1145062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145097 */     // GIR_Coverage, 15339,
     /* 1145097 */     GIR_EraseRootFromParent_Done,
     /* 1145098 */   // Label 16747: @1145098
     /* 1145098 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1145178), // Rule ID 15342 //
     /* 1145103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145142 */     // MIs[0] round
     /* 1145142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145177 */     // GIR_Coverage, 15342,
     /* 1145177 */     GIR_EraseRootFromParent_Done,
     /* 1145178 */   // Label 16748: @1145178
     /* 1145178 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1145258), // Rule ID 15343 //
     /* 1145183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145222 */     // MIs[0] round
     /* 1145222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145257 */     // GIR_Coverage, 15343,
     /* 1145257 */     GIR_EraseRootFromParent_Done,
     /* 1145258 */   // Label 16749: @1145258
     /* 1145258 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1145338), // Rule ID 15346 //
     /* 1145263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145302 */     // MIs[0] round
     /* 1145302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145337 */     // GIR_Coverage, 15346,
     /* 1145337 */     GIR_EraseRootFromParent_Done,
     /* 1145338 */   // Label 16750: @1145338
     /* 1145338 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1145418), // Rule ID 15347 //
     /* 1145343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145382 */     // MIs[0] round
     /* 1145382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145417 */     // GIR_Coverage, 15347,
     /* 1145417 */     GIR_EraseRootFromParent_Done,
     /* 1145418 */   // Label 16751: @1145418
     /* 1145418 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1145498), // Rule ID 15350 //
     /* 1145423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145462 */     // MIs[0] round
     /* 1145462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145497 */     // GIR_Coverage, 15350,
     /* 1145497 */     GIR_EraseRootFromParent_Done,
     /* 1145498 */   // Label 16752: @1145498
     /* 1145498 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1145578), // Rule ID 15351 //
     /* 1145503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145542 */     // MIs[0] round
     /* 1145542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145577 */     // GIR_Coverage, 15351,
     /* 1145577 */     GIR_EraseRootFromParent_Done,
     /* 1145578 */   // Label 16753: @1145578
     /* 1145578 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1145658), // Rule ID 15354 //
     /* 1145583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1145594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1145597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1145600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1145603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145622 */     // MIs[0] round
     /* 1145622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145657 */     // GIR_Coverage, 15354,
     /* 1145657 */     GIR_EraseRootFromParent_Done,
     /* 1145658 */   // Label 16754: @1145658
     /* 1145658 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1145738), // Rule ID 15355 //
     /* 1145663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1145674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1145677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1145680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1145683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145702 */     // MIs[0] round
     /* 1145702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145737 */     // GIR_Coverage, 15355,
     /* 1145737 */     GIR_EraseRootFromParent_Done,
     /* 1145738 */   // Label 16755: @1145738
     /* 1145738 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1145818), // Rule ID 15358 //
     /* 1145743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1145754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1145757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1145760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1145763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145782 */     // MIs[0] round
     /* 1145782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145792 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145817 */     // GIR_Coverage, 15358,
     /* 1145817 */     GIR_EraseRootFromParent_Done,
     /* 1145818 */   // Label 16756: @1145818
     /* 1145818 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1145898), // Rule ID 15359 //
     /* 1145823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1145834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1145837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1145840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1145843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145862 */     // MIs[0] round
     /* 1145862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145897 */     // GIR_Coverage, 15359,
     /* 1145897 */     GIR_EraseRootFromParent_Done,
     /* 1145898 */   // Label 16757: @1145898
     /* 1145898 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1145978), // Rule ID 15362 //
     /* 1145903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1145920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1145923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145942 */     // MIs[0] round
     /* 1145942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1145955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145977 */     // GIR_Coverage, 15362,
     /* 1145977 */     GIR_EraseRootFromParent_Done,
     /* 1145978 */   // Label 16758: @1145978
     /* 1145978 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1146058), // Rule ID 15363 //
     /* 1145983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146022 */     // MIs[0] round
     /* 1146022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146032 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146057 */     // GIR_Coverage, 15363,
     /* 1146057 */     GIR_EraseRootFromParent_Done,
     /* 1146058 */   // Label 16759: @1146058
     /* 1146058 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1146138), // Rule ID 15366 //
     /* 1146063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146102 */     // MIs[0] round
     /* 1146102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146112 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146137 */     // GIR_Coverage, 15366,
     /* 1146137 */     GIR_EraseRootFromParent_Done,
     /* 1146138 */   // Label 16760: @1146138
     /* 1146138 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1146218), // Rule ID 15367 //
     /* 1146143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146182 */     // MIs[0] round
     /* 1146182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146192 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146217 */     // GIR_Coverage, 15367,
     /* 1146217 */     GIR_EraseRootFromParent_Done,
     /* 1146218 */   // Label 16761: @1146218
     /* 1146218 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1146298), // Rule ID 15370 //
     /* 1146223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146262 */     // MIs[0] round
     /* 1146262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146272 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146297 */     // GIR_Coverage, 15370,
     /* 1146297 */     GIR_EraseRootFromParent_Done,
     /* 1146298 */   // Label 16762: @1146298
     /* 1146298 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1146378), // Rule ID 15371 //
     /* 1146303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146342 */     // MIs[0] round
     /* 1146342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146377 */     // GIR_Coverage, 15371,
     /* 1146377 */     GIR_EraseRootFromParent_Done,
     /* 1146378 */   // Label 16763: @1146378
     /* 1146378 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1146458), // Rule ID 15374 //
     /* 1146383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146422 */     // MIs[0] round
     /* 1146422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146432 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146457 */     // GIR_Coverage, 15374,
     /* 1146457 */     GIR_EraseRootFromParent_Done,
     /* 1146458 */   // Label 16764: @1146458
     /* 1146458 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1146538), // Rule ID 15375 //
     /* 1146463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146502 */     // MIs[0] round
     /* 1146502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146537 */     // GIR_Coverage, 15375,
     /* 1146537 */     GIR_EraseRootFromParent_Done,
     /* 1146538 */   // Label 16765: @1146538
     /* 1146538 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1146618), // Rule ID 15378 //
     /* 1146543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146582 */     // MIs[0] round
     /* 1146582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146617 */     // GIR_Coverage, 15378,
     /* 1146617 */     GIR_EraseRootFromParent_Done,
     /* 1146618 */   // Label 16766: @1146618
     /* 1146618 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1146698), // Rule ID 15379 //
     /* 1146623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146662 */     // MIs[0] round
     /* 1146662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146697 */     // GIR_Coverage, 15379,
     /* 1146697 */     GIR_EraseRootFromParent_Done,
     /* 1146698 */   // Label 16767: @1146698
     /* 1146698 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1146778), // Rule ID 15382 //
     /* 1146703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1146714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1146717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1146720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146742 */     // MIs[0] round
     /* 1146742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146777 */     // GIR_Coverage, 15382,
     /* 1146777 */     GIR_EraseRootFromParent_Done,
     /* 1146778 */   // Label 16768: @1146778
     /* 1146778 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1146858), // Rule ID 15383 //
     /* 1146783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1146794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1146797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1146800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146822 */     // MIs[0] round
     /* 1146822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146857 */     // GIR_Coverage, 15383,
     /* 1146857 */     GIR_EraseRootFromParent_Done,
     /* 1146858 */   // Label 16769: @1146858
     /* 1146858 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1146938), // Rule ID 15386 //
     /* 1146863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146902 */     // MIs[0] round
     /* 1146902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1146915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146937 */     // GIR_Coverage, 15386,
     /* 1146937 */     GIR_EraseRootFromParent_Done,
     /* 1146938 */   // Label 16770: @1146938
     /* 1146938 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1147018), // Rule ID 15387 //
     /* 1146943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146982 */     // MIs[0] round
     /* 1146982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1146995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147017 */     // GIR_Coverage, 15387,
     /* 1147017 */     GIR_EraseRootFromParent_Done,
     /* 1147018 */   // Label 16771: @1147018
     /* 1147018 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1147098), // Rule ID 15390 //
     /* 1147023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147062 */     // MIs[0] round
     /* 1147062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147097 */     // GIR_Coverage, 15390,
     /* 1147097 */     GIR_EraseRootFromParent_Done,
     /* 1147098 */   // Label 16772: @1147098
     /* 1147098 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1147178), // Rule ID 15391 //
     /* 1147103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147142 */     // MIs[0] round
     /* 1147142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147177 */     // GIR_Coverage, 15391,
     /* 1147177 */     GIR_EraseRootFromParent_Done,
     /* 1147178 */   // Label 16773: @1147178
     /* 1147178 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1147258), // Rule ID 15394 //
     /* 1147183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147222 */     // MIs[0] round
     /* 1147222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147257 */     // GIR_Coverage, 15394,
     /* 1147257 */     GIR_EraseRootFromParent_Done,
     /* 1147258 */   // Label 16774: @1147258
     /* 1147258 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1147338), // Rule ID 15395 //
     /* 1147263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147302 */     // MIs[0] round
     /* 1147302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147337 */     // GIR_Coverage, 15395,
     /* 1147337 */     GIR_EraseRootFromParent_Done,
     /* 1147338 */   // Label 16775: @1147338
     /* 1147338 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1147418), // Rule ID 15398 //
     /* 1147343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1147346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147382 */     // MIs[0] round
     /* 1147382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147392 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147417 */     // GIR_Coverage, 15398,
     /* 1147417 */     GIR_EraseRootFromParent_Done,
     /* 1147418 */   // Label 16776: @1147418
     /* 1147418 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1147498), // Rule ID 15399 //
     /* 1147423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1147426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147462 */     // MIs[0] round
     /* 1147462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147497 */     // GIR_Coverage, 15399,
     /* 1147497 */     GIR_EraseRootFromParent_Done,
     /* 1147498 */   // Label 16777: @1147498
     /* 1147498 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1147578), // Rule ID 15402 //
     /* 1147503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147542 */     // MIs[0] round
     /* 1147542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147577 */     // GIR_Coverage, 15402,
     /* 1147577 */     GIR_EraseRootFromParent_Done,
     /* 1147578 */   // Label 16778: @1147578
     /* 1147578 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1147658), // Rule ID 15403 //
     /* 1147583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147622 */     // MIs[0] round
     /* 1147622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147632 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147657 */     // GIR_Coverage, 15403,
     /* 1147657 */     GIR_EraseRootFromParent_Done,
     /* 1147658 */   // Label 16779: @1147658
     /* 1147658 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1147738), // Rule ID 15406 //
     /* 1147663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1147674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1147677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1147680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147702 */     // MIs[0] round
     /* 1147702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147712 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1147715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147737 */     // GIR_Coverage, 15406,
     /* 1147737 */     GIR_EraseRootFromParent_Done,
     /* 1147738 */   // Label 16780: @1147738
     /* 1147738 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1147818), // Rule ID 15407 //
     /* 1147743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1147754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1147757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1147760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147782 */     // MIs[0] round
     /* 1147782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147792 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1147795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147817 */     // GIR_Coverage, 15407,
     /* 1147817 */     GIR_EraseRootFromParent_Done,
     /* 1147818 */   // Label 16781: @1147818
     /* 1147818 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1147898), // Rule ID 15410 //
     /* 1147823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147862 */     // MIs[0] round
     /* 1147862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1147875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147897 */     // GIR_Coverage, 15410,
     /* 1147897 */     GIR_EraseRootFromParent_Done,
     /* 1147898 */   // Label 16782: @1147898
     /* 1147898 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1147978), // Rule ID 15411 //
     /* 1147903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147942 */     // MIs[0] round
     /* 1147942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1147955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147977 */     // GIR_Coverage, 15411,
     /* 1147977 */     GIR_EraseRootFromParent_Done,
     /* 1147978 */   // Label 16783: @1147978
     /* 1147978 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1148058), // Rule ID 15414 //
     /* 1147983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1147994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1147997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148022 */     // MIs[0] round
     /* 1148022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148057 */     // GIR_Coverage, 15414,
     /* 1148057 */     GIR_EraseRootFromParent_Done,
     /* 1148058 */   // Label 16784: @1148058
     /* 1148058 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1148138), // Rule ID 15415 //
     /* 1148063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148102 */     // MIs[0] round
     /* 1148102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148137 */     // GIR_Coverage, 15415,
     /* 1148137 */     GIR_EraseRootFromParent_Done,
     /* 1148138 */   // Label 16785: @1148138
     /* 1148138 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1148218), // Rule ID 15418 //
     /* 1148143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148182 */     // MIs[0] round
     /* 1148182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148192 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148217 */     // GIR_Coverage, 15418,
     /* 1148217 */     GIR_EraseRootFromParent_Done,
     /* 1148218 */   // Label 16786: @1148218
     /* 1148218 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1148298), // Rule ID 15419 //
     /* 1148223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148262 */     // MIs[0] round
     /* 1148262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148297 */     // GIR_Coverage, 15419,
     /* 1148297 */     GIR_EraseRootFromParent_Done,
     /* 1148298 */   // Label 16787: @1148298
     /* 1148298 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1148378), // Rule ID 15422 //
     /* 1148303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148342 */     // MIs[0] round
     /* 1148342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148352 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148377 */     // GIR_Coverage, 15422,
     /* 1148377 */     GIR_EraseRootFromParent_Done,
     /* 1148378 */   // Label 16788: @1148378
     /* 1148378 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1148458), // Rule ID 15423 //
     /* 1148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148422 */     // MIs[0] round
     /* 1148422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148457 */     // GIR_Coverage, 15423,
     /* 1148457 */     GIR_EraseRootFromParent_Done,
     /* 1148458 */   // Label 16789: @1148458
     /* 1148458 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1148538), // Rule ID 15426 //
     /* 1148463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148502 */     // MIs[0] round
     /* 1148502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148537 */     // GIR_Coverage, 15426,
     /* 1148537 */     GIR_EraseRootFromParent_Done,
     /* 1148538 */   // Label 16790: @1148538
     /* 1148538 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1148618), // Rule ID 15427 //
     /* 1148543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148582 */     // MIs[0] round
     /* 1148582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148617 */     // GIR_Coverage, 15427,
     /* 1148617 */     GIR_EraseRootFromParent_Done,
     /* 1148618 */   // Label 16791: @1148618
     /* 1148618 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1148698), // Rule ID 15430 //
     /* 1148623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1148634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1148637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1148640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148662 */     // MIs[0] round
     /* 1148662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148672 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148697 */     // GIR_Coverage, 15430,
     /* 1148697 */     GIR_EraseRootFromParent_Done,
     /* 1148698 */   // Label 16792: @1148698
     /* 1148698 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1148778), // Rule ID 15431 //
     /* 1148703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1148714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1148717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1148720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148742 */     // MIs[0] round
     /* 1148742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148777 */     // GIR_Coverage, 15431,
     /* 1148777 */     GIR_EraseRootFromParent_Done,
     /* 1148778 */   // Label 16793: @1148778
     /* 1148778 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1148858), // Rule ID 15434 //
     /* 1148783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1148794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1148797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1148800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148822 */     // MIs[0] round
     /* 1148822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148857 */     // GIR_Coverage, 15434,
     /* 1148857 */     GIR_EraseRootFromParent_Done,
     /* 1148858 */   // Label 16794: @1148858
     /* 1148858 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1148938), // Rule ID 15435 //
     /* 1148863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1148874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1148877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1148880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148902 */     // MIs[0] round
     /* 1148902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148937 */     // GIR_Coverage, 15435,
     /* 1148937 */     GIR_EraseRootFromParent_Done,
     /* 1148938 */   // Label 16795: @1148938
     /* 1148938 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1149018), // Rule ID 15438 //
     /* 1148943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1148954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1148957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1148960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148982 */     // MIs[0] round
     /* 1148982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149017 */     // GIR_Coverage, 15438,
     /* 1149017 */     GIR_EraseRootFromParent_Done,
     /* 1149018 */   // Label 16796: @1149018
     /* 1149018 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1149098), // Rule ID 15439 //
     /* 1149023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149062 */     // MIs[0] round
     /* 1149062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149097 */     // GIR_Coverage, 15439,
     /* 1149097 */     GIR_EraseRootFromParent_Done,
     /* 1149098 */   // Label 16797: @1149098
     /* 1149098 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1149178), // Rule ID 15442 //
     /* 1149103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149142 */     // MIs[0] round
     /* 1149142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149177 */     // GIR_Coverage, 15442,
     /* 1149177 */     GIR_EraseRootFromParent_Done,
     /* 1149178 */   // Label 16798: @1149178
     /* 1149178 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1149258), // Rule ID 15443 //
     /* 1149183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149222 */     // MIs[0] round
     /* 1149222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149232 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149257 */     // GIR_Coverage, 15443,
     /* 1149257 */     GIR_EraseRootFromParent_Done,
     /* 1149258 */   // Label 16799: @1149258
     /* 1149258 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1149338), // Rule ID 15446 //
     /* 1149263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149302 */     // MIs[0] round
     /* 1149302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149337 */     // GIR_Coverage, 15446,
     /* 1149337 */     GIR_EraseRootFromParent_Done,
     /* 1149338 */   // Label 16800: @1149338
     /* 1149338 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1149418), // Rule ID 15447 //
     /* 1149343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149382 */     // MIs[0] round
     /* 1149382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149417 */     // GIR_Coverage, 15447,
     /* 1149417 */     GIR_EraseRootFromParent_Done,
     /* 1149418 */   // Label 16801: @1149418
     /* 1149418 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1149498), // Rule ID 15450 //
     /* 1149423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149462 */     // MIs[0] round
     /* 1149462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149497 */     // GIR_Coverage, 15450,
     /* 1149497 */     GIR_EraseRootFromParent_Done,
     /* 1149498 */   // Label 16802: @1149498
     /* 1149498 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1149578), // Rule ID 15451 //
     /* 1149503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149542 */     // MIs[0] round
     /* 1149542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149552 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149577 */     // GIR_Coverage, 15451,
     /* 1149577 */     GIR_EraseRootFromParent_Done,
     /* 1149578 */   // Label 16803: @1149578
     /* 1149578 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1149658), // Rule ID 15454 //
     /* 1149583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1149603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149622 */     // MIs[0] round
     /* 1149622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1149635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149657 */     // GIR_Coverage, 15454,
     /* 1149657 */     GIR_EraseRootFromParent_Done,
     /* 1149658 */   // Label 16804: @1149658
     /* 1149658 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1149738), // Rule ID 15455 //
     /* 1149663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1149683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149702 */     // MIs[0] round
     /* 1149702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1149715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149737 */     // GIR_Coverage, 15455,
     /* 1149737 */     GIR_EraseRootFromParent_Done,
     /* 1149738 */   // Label 16805: @1149738
     /* 1149738 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1149818), // Rule ID 15458 //
     /* 1149743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1149754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1149757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1149760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1149763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149782 */     // MIs[0] round
     /* 1149782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1149795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149817 */     // GIR_Coverage, 15458,
     /* 1149817 */     GIR_EraseRootFromParent_Done,
     /* 1149818 */   // Label 16806: @1149818
     /* 1149818 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1149898), // Rule ID 15459 //
     /* 1149823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1149834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1149837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1149840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1149843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149862 */     // MIs[0] round
     /* 1149862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149872 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1149875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149897 */     // GIR_Coverage, 15459,
     /* 1149897 */     GIR_EraseRootFromParent_Done,
     /* 1149898 */   // Label 16807: @1149898
     /* 1149898 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1149978), // Rule ID 15462 //
     /* 1149903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1149920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1149923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149942 */     // MIs[0] round
     /* 1149942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149952 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1149955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149977 */     // GIR_Coverage, 15462,
     /* 1149977 */     GIR_EraseRootFromParent_Done,
     /* 1149978 */   // Label 16808: @1149978
     /* 1149978 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1150058), // Rule ID 15463 //
     /* 1149983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150022 */     // MIs[0] round
     /* 1150022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150057 */     // GIR_Coverage, 15463,
     /* 1150057 */     GIR_EraseRootFromParent_Done,
     /* 1150058 */   // Label 16809: @1150058
     /* 1150058 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1150138), // Rule ID 15466 //
     /* 1150063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150102 */     // MIs[0] round
     /* 1150102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150137 */     // GIR_Coverage, 15466,
     /* 1150137 */     GIR_EraseRootFromParent_Done,
     /* 1150138 */   // Label 16810: @1150138
     /* 1150138 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1150218), // Rule ID 15467 //
     /* 1150143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150182 */     // MIs[0] round
     /* 1150182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150217 */     // GIR_Coverage, 15467,
     /* 1150217 */     GIR_EraseRootFromParent_Done,
     /* 1150218 */   // Label 16811: @1150218
     /* 1150218 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1150298), // Rule ID 15470 //
     /* 1150223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150262 */     // MIs[0] round
     /* 1150262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150297 */     // GIR_Coverage, 15470,
     /* 1150297 */     GIR_EraseRootFromParent_Done,
     /* 1150298 */   // Label 16812: @1150298
     /* 1150298 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1150378), // Rule ID 15471 //
     /* 1150303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150342 */     // MIs[0] round
     /* 1150342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150377 */     // GIR_Coverage, 15471,
     /* 1150377 */     GIR_EraseRootFromParent_Done,
     /* 1150378 */   // Label 16813: @1150378
     /* 1150378 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1150458), // Rule ID 15474 //
     /* 1150383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150422 */     // MIs[0] round
     /* 1150422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150457 */     // GIR_Coverage, 15474,
     /* 1150457 */     GIR_EraseRootFromParent_Done,
     /* 1150458 */   // Label 16814: @1150458
     /* 1150458 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1150538), // Rule ID 15475 //
     /* 1150463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150502 */     // MIs[0] round
     /* 1150502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150537 */     // GIR_Coverage, 15475,
     /* 1150537 */     GIR_EraseRootFromParent_Done,
     /* 1150538 */   // Label 16815: @1150538
     /* 1150538 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1150618), // Rule ID 15478 //
     /* 1150543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150582 */     // MIs[0] round
     /* 1150582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150617 */     // GIR_Coverage, 15478,
     /* 1150617 */     GIR_EraseRootFromParent_Done,
     /* 1150618 */   // Label 16816: @1150618
     /* 1150618 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1150698), // Rule ID 15479 //
     /* 1150623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150662 */     // MIs[0] round
     /* 1150662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150697 */     // GIR_Coverage, 15479,
     /* 1150697 */     GIR_EraseRootFromParent_Done,
     /* 1150698 */   // Label 16817: @1150698
     /* 1150698 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1150778), // Rule ID 15482 //
     /* 1150703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1150714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1150717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1150720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1150723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150742 */     // MIs[0] round
     /* 1150742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150777 */     // GIR_Coverage, 15482,
     /* 1150777 */     GIR_EraseRootFromParent_Done,
     /* 1150778 */   // Label 16818: @1150778
     /* 1150778 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1150858), // Rule ID 15483 //
     /* 1150783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1150794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1150797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1150800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1150803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150822 */     // MIs[0] round
     /* 1150822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150857 */     // GIR_Coverage, 15483,
     /* 1150857 */     GIR_EraseRootFromParent_Done,
     /* 1150858 */   // Label 16819: @1150858
     /* 1150858 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1150938), // Rule ID 15486 //
     /* 1150863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1150866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1150883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150902 */     // MIs[0] round
     /* 1150902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150937 */     // GIR_Coverage, 15486,
     /* 1150937 */     GIR_EraseRootFromParent_Done,
     /* 1150938 */   // Label 16820: @1150938
     /* 1150938 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1151018), // Rule ID 15487 //
     /* 1150943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1150946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1150963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150982 */     // MIs[0] round
     /* 1150982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151017 */     // GIR_Coverage, 15487,
     /* 1151017 */     GIR_EraseRootFromParent_Done,
     /* 1151018 */   // Label 16821: @1151018
     /* 1151018 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1151098), // Rule ID 15490 //
     /* 1151023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151062 */     // MIs[0] round
     /* 1151062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151097 */     // GIR_Coverage, 15490,
     /* 1151097 */     GIR_EraseRootFromParent_Done,
     /* 1151098 */   // Label 16822: @1151098
     /* 1151098 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1151178), // Rule ID 15491 //
     /* 1151103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151142 */     // MIs[0] round
     /* 1151142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151177 */     // GIR_Coverage, 15491,
     /* 1151177 */     GIR_EraseRootFromParent_Done,
     /* 1151178 */   // Label 16823: @1151178
     /* 1151178 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1151258), // Rule ID 15494 //
     /* 1151183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151222 */     // MIs[0] round
     /* 1151222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151257 */     // GIR_Coverage, 15494,
     /* 1151257 */     GIR_EraseRootFromParent_Done,
     /* 1151258 */   // Label 16824: @1151258
     /* 1151258 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1151338), // Rule ID 15495 //
     /* 1151263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151302 */     // MIs[0] round
     /* 1151302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151312 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151337 */     // GIR_Coverage, 15495,
     /* 1151337 */     GIR_EraseRootFromParent_Done,
     /* 1151338 */   // Label 16825: @1151338
     /* 1151338 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1151418), // Rule ID 15498 //
     /* 1151343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151382 */     // MIs[0] round
     /* 1151382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151417 */     // GIR_Coverage, 15498,
     /* 1151417 */     GIR_EraseRootFromParent_Done,
     /* 1151418 */   // Label 16826: @1151418
     /* 1151418 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1151498), // Rule ID 15499 //
     /* 1151423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151462 */     // MIs[0] round
     /* 1151462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151472 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151497 */     // GIR_Coverage, 15499,
     /* 1151497 */     GIR_EraseRootFromParent_Done,
     /* 1151498 */   // Label 16827: @1151498
     /* 1151498 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1151578), // Rule ID 15502 //
     /* 1151503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151542 */     // MIs[0] round
     /* 1151542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151577 */     // GIR_Coverage, 15502,
     /* 1151577 */     GIR_EraseRootFromParent_Done,
     /* 1151578 */   // Label 16828: @1151578
     /* 1151578 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1151658), // Rule ID 15503 //
     /* 1151583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151622 */     // MIs[0] round
     /* 1151622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151657 */     // GIR_Coverage, 15503,
     /* 1151657 */     GIR_EraseRootFromParent_Done,
     /* 1151658 */   // Label 16829: @1151658
     /* 1151658 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1151738), // Rule ID 15506 //
     /* 1151663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1151674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1151677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1151680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1151683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151702 */     // MIs[0] round
     /* 1151702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151737 */     // GIR_Coverage, 15506,
     /* 1151737 */     GIR_EraseRootFromParent_Done,
     /* 1151738 */   // Label 16830: @1151738
     /* 1151738 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1151818), // Rule ID 15507 //
     /* 1151743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1151754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1151757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1151760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1151763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151782 */     // MIs[0] round
     /* 1151782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151792 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151817 */     // GIR_Coverage, 15507,
     /* 1151817 */     GIR_EraseRootFromParent_Done,
     /* 1151818 */   // Label 16831: @1151818
     /* 1151818 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1151898), // Rule ID 15510 //
     /* 1151823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1151843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151862 */     // MIs[0] round
     /* 1151862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151897 */     // GIR_Coverage, 15510,
     /* 1151897 */     GIR_EraseRootFromParent_Done,
     /* 1151898 */   // Label 16832: @1151898
     /* 1151898 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1151978), // Rule ID 15511 //
     /* 1151903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1151923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151942 */     // MIs[0] round
     /* 1151942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151977 */     // GIR_Coverage, 15511,
     /* 1151977 */     GIR_EraseRootFromParent_Done,
     /* 1151978 */   // Label 16833: @1151978
     /* 1151978 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1152058), // Rule ID 15514 //
     /* 1151983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1151994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1151997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152022 */     // MIs[0] round
     /* 1152022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152057 */     // GIR_Coverage, 15514,
     /* 1152057 */     GIR_EraseRootFromParent_Done,
     /* 1152058 */   // Label 16834: @1152058
     /* 1152058 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1152138), // Rule ID 15515 //
     /* 1152063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152102 */     // MIs[0] round
     /* 1152102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152137 */     // GIR_Coverage, 15515,
     /* 1152137 */     GIR_EraseRootFromParent_Done,
     /* 1152138 */   // Label 16835: @1152138
     /* 1152138 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1152218), // Rule ID 15518 //
     /* 1152143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152182 */     // MIs[0] round
     /* 1152182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152217 */     // GIR_Coverage, 15518,
     /* 1152217 */     GIR_EraseRootFromParent_Done,
     /* 1152218 */   // Label 16836: @1152218
     /* 1152218 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1152298), // Rule ID 15519 //
     /* 1152223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152262 */     // MIs[0] round
     /* 1152262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152297 */     // GIR_Coverage, 15519,
     /* 1152297 */     GIR_EraseRootFromParent_Done,
     /* 1152298 */   // Label 16837: @1152298
     /* 1152298 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1152378), // Rule ID 15522 //
     /* 1152303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152342 */     // MIs[0] round
     /* 1152342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152377 */     // GIR_Coverage, 15522,
     /* 1152377 */     GIR_EraseRootFromParent_Done,
     /* 1152378 */   // Label 16838: @1152378
     /* 1152378 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1152458), // Rule ID 15523 //
     /* 1152383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152422 */     // MIs[0] round
     /* 1152422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152457 */     // GIR_Coverage, 15523,
     /* 1152457 */     GIR_EraseRootFromParent_Done,
     /* 1152458 */   // Label 16839: @1152458
     /* 1152458 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1152538), // Rule ID 15526 //
     /* 1152463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152502 */     // MIs[0] round
     /* 1152502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152537 */     // GIR_Coverage, 15526,
     /* 1152537 */     GIR_EraseRootFromParent_Done,
     /* 1152538 */   // Label 16840: @1152538
     /* 1152538 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1152618), // Rule ID 15527 //
     /* 1152543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152582 */     // MIs[0] round
     /* 1152582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152617 */     // GIR_Coverage, 15527,
     /* 1152617 */     GIR_EraseRootFromParent_Done,
     /* 1152618 */   // Label 16841: @1152618
     /* 1152618 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1152698), // Rule ID 15530 //
     /* 1152623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1152643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152662 */     // MIs[0] round
     /* 1152662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152697 */     // GIR_Coverage, 15530,
     /* 1152697 */     GIR_EraseRootFromParent_Done,
     /* 1152698 */   // Label 16842: @1152698
     /* 1152698 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1152778), // Rule ID 15531 //
     /* 1152703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1152723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152742 */     // MIs[0] round
     /* 1152742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152777 */     // GIR_Coverage, 15531,
     /* 1152777 */     GIR_EraseRootFromParent_Done,
     /* 1152778 */   // Label 16843: @1152778
     /* 1152778 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1152858), // Rule ID 15534 //
     /* 1152783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1152794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1152797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1152800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1152803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152822 */     // MIs[0] round
     /* 1152822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152832 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152857 */     // GIR_Coverage, 15534,
     /* 1152857 */     GIR_EraseRootFromParent_Done,
     /* 1152858 */   // Label 16844: @1152858
     /* 1152858 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1152938), // Rule ID 15535 //
     /* 1152863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1152874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1152877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1152880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1152883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152902 */     // MIs[0] round
     /* 1152902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152937 */     // GIR_Coverage, 15535,
     /* 1152937 */     GIR_EraseRootFromParent_Done,
     /* 1152938 */   // Label 16845: @1152938
     /* 1152938 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1153018), // Rule ID 15538 //
     /* 1152943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1152954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1152957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1152960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1152963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152982 */     // MIs[0] round
     /* 1152982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1152995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153017 */     // GIR_Coverage, 15538,
     /* 1153017 */     GIR_EraseRootFromParent_Done,
     /* 1153018 */   // Label 16846: @1153018
     /* 1153018 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1153098), // Rule ID 15539 //
     /* 1153023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153062 */     // MIs[0] round
     /* 1153062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153097 */     // GIR_Coverage, 15539,
     /* 1153097 */     GIR_EraseRootFromParent_Done,
     /* 1153098 */   // Label 16847: @1153098
     /* 1153098 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1153178), // Rule ID 15542 //
     /* 1153103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153142 */     // MIs[0] round
     /* 1153142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153177 */     // GIR_Coverage, 15542,
     /* 1153177 */     GIR_EraseRootFromParent_Done,
     /* 1153178 */   // Label 16848: @1153178
     /* 1153178 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1153258), // Rule ID 15543 //
     /* 1153183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153222 */     // MIs[0] round
     /* 1153222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153257 */     // GIR_Coverage, 15543,
     /* 1153257 */     GIR_EraseRootFromParent_Done,
     /* 1153258 */   // Label 16849: @1153258
     /* 1153258 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1153338), // Rule ID 15546 //
     /* 1153263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153302 */     // MIs[0] round
     /* 1153302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153312 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153337 */     // GIR_Coverage, 15546,
     /* 1153337 */     GIR_EraseRootFromParent_Done,
     /* 1153338 */   // Label 16850: @1153338
     /* 1153338 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1153418), // Rule ID 15547 //
     /* 1153343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153382 */     // MIs[0] round
     /* 1153382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153417 */     // GIR_Coverage, 15547,
     /* 1153417 */     GIR_EraseRootFromParent_Done,
     /* 1153418 */   // Label 16851: @1153418
     /* 1153418 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1153498), // Rule ID 15550 //
     /* 1153423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153462 */     // MIs[0] round
     /* 1153462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153497 */     // GIR_Coverage, 15550,
     /* 1153497 */     GIR_EraseRootFromParent_Done,
     /* 1153498 */   // Label 16852: @1153498
     /* 1153498 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1153578), // Rule ID 15551 //
     /* 1153503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153542 */     // MIs[0] round
     /* 1153542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153577 */     // GIR_Coverage, 15551,
     /* 1153577 */     GIR_EraseRootFromParent_Done,
     /* 1153578 */   // Label 16853: @1153578
     /* 1153578 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1153658), // Rule ID 15554 //
     /* 1153583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1153594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1153597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1153600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153622 */     // MIs[0] round
     /* 1153622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153657 */     // GIR_Coverage, 15554,
     /* 1153657 */     GIR_EraseRootFromParent_Done,
     /* 1153658 */   // Label 16854: @1153658
     /* 1153658 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1153738), // Rule ID 15555 //
     /* 1153663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1153674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1153677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1153680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153702 */     // MIs[0] round
     /* 1153702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153712 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153737 */     // GIR_Coverage, 15555,
     /* 1153737 */     GIR_EraseRootFromParent_Done,
     /* 1153738 */   // Label 16855: @1153738
     /* 1153738 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1153818), // Rule ID 15558 //
     /* 1153743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1153754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1153757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1153760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153782 */     // MIs[0] round
     /* 1153782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153817 */     // GIR_Coverage, 15558,
     /* 1153817 */     GIR_EraseRootFromParent_Done,
     /* 1153818 */   // Label 16856: @1153818
     /* 1153818 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1153898), // Rule ID 15559 //
     /* 1153823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1153834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1153837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1153840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153862 */     // MIs[0] round
     /* 1153862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153897 */     // GIR_Coverage, 15559,
     /* 1153897 */     GIR_EraseRootFromParent_Done,
     /* 1153898 */   // Label 16857: @1153898
     /* 1153898 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1153978), // Rule ID 15562 //
     /* 1153903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1153914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1153917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1153920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153942 */     // MIs[0] round
     /* 1153942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1153955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153977 */     // GIR_Coverage, 15562,
     /* 1153977 */     GIR_EraseRootFromParent_Done,
     /* 1153978 */   // Label 16858: @1153978
     /* 1153978 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1154058), // Rule ID 15563 //
     /* 1153983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1153994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1153997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154022 */     // MIs[0] round
     /* 1154022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154057 */     // GIR_Coverage, 15563,
     /* 1154057 */     GIR_EraseRootFromParent_Done,
     /* 1154058 */   // Label 16859: @1154058
     /* 1154058 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1154138), // Rule ID 15566 //
     /* 1154063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154102 */     // MIs[0] round
     /* 1154102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154137 */     // GIR_Coverage, 15566,
     /* 1154137 */     GIR_EraseRootFromParent_Done,
     /* 1154138 */   // Label 16860: @1154138
     /* 1154138 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1154218), // Rule ID 15567 //
     /* 1154143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154182 */     // MIs[0] round
     /* 1154182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154217 */     // GIR_Coverage, 15567,
     /* 1154217 */     GIR_EraseRootFromParent_Done,
     /* 1154218 */   // Label 16861: @1154218
     /* 1154218 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1154298), // Rule ID 15570 //
     /* 1154223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154262 */     // MIs[0] round
     /* 1154262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154297 */     // GIR_Coverage, 15570,
     /* 1154297 */     GIR_EraseRootFromParent_Done,
     /* 1154298 */   // Label 16862: @1154298
     /* 1154298 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1154378), // Rule ID 15571 //
     /* 1154303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154342 */     // MIs[0] round
     /* 1154342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154377 */     // GIR_Coverage, 15571,
     /* 1154377 */     GIR_EraseRootFromParent_Done,
     /* 1154378 */   // Label 16863: @1154378
     /* 1154378 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1154458), // Rule ID 15574 //
     /* 1154383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1154386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154422 */     // MIs[0] round
     /* 1154422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154457 */     // GIR_Coverage, 15574,
     /* 1154457 */     GIR_EraseRootFromParent_Done,
     /* 1154458 */   // Label 16864: @1154458
     /* 1154458 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1154538), // Rule ID 15575 //
     /* 1154463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1154466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154502 */     // MIs[0] round
     /* 1154502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154537 */     // GIR_Coverage, 15575,
     /* 1154537 */     GIR_EraseRootFromParent_Done,
     /* 1154538 */   // Label 16865: @1154538
     /* 1154538 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1154618), // Rule ID 15578 //
     /* 1154543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154582 */     // MIs[0] round
     /* 1154582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1154595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154617 */     // GIR_Coverage, 15578,
     /* 1154617 */     GIR_EraseRootFromParent_Done,
     /* 1154618 */   // Label 16866: @1154618
     /* 1154618 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1154698), // Rule ID 15579 //
     /* 1154623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154662 */     // MIs[0] round
     /* 1154662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1154675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154697 */     // GIR_Coverage, 15579,
     /* 1154697 */     GIR_EraseRootFromParent_Done,
     /* 1154698 */   // Label 16867: @1154698
     /* 1154698 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1154778), // Rule ID 15582 //
     /* 1154703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1154714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1154717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1154720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154742 */     // MIs[0] round
     /* 1154742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1154755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154777 */     // GIR_Coverage, 15582,
     /* 1154777 */     GIR_EraseRootFromParent_Done,
     /* 1154778 */   // Label 16868: @1154778
     /* 1154778 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1154858), // Rule ID 15583 //
     /* 1154783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1154794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1154797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1154800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154822 */     // MIs[0] round
     /* 1154822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154832 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1154835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154857 */     // GIR_Coverage, 15583,
     /* 1154857 */     GIR_EraseRootFromParent_Done,
     /* 1154858 */   // Label 16869: @1154858
     /* 1154858 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1154938), // Rule ID 15586 //
     /* 1154863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1154874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1154877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1154880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154902 */     // MIs[0] round
     /* 1154902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154912 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1154915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154937 */     // GIR_Coverage, 15586,
     /* 1154937 */     GIR_EraseRootFromParent_Done,
     /* 1154938 */   // Label 16870: @1154938
     /* 1154938 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1155018), // Rule ID 15587 //
     /* 1154943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1154954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1154957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1154960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154982 */     // MIs[0] round
     /* 1154982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1154995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155017 */     // GIR_Coverage, 15587,
     /* 1155017 */     GIR_EraseRootFromParent_Done,
     /* 1155018 */   // Label 16871: @1155018
     /* 1155018 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1155098), // Rule ID 15590 //
     /* 1155023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155062 */     // MIs[0] round
     /* 1155062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155097 */     // GIR_Coverage, 15590,
     /* 1155097 */     GIR_EraseRootFromParent_Done,
     /* 1155098 */   // Label 16872: @1155098
     /* 1155098 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1155178), // Rule ID 15591 //
     /* 1155103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155142 */     // MIs[0] round
     /* 1155142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155177 */     // GIR_Coverage, 15591,
     /* 1155177 */     GIR_EraseRootFromParent_Done,
     /* 1155178 */   // Label 16873: @1155178
     /* 1155178 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1155258), // Rule ID 15594 //
     /* 1155183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155222 */     // MIs[0] round
     /* 1155222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155257 */     // GIR_Coverage, 15594,
     /* 1155257 */     GIR_EraseRootFromParent_Done,
     /* 1155258 */   // Label 16874: @1155258
     /* 1155258 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1155338), // Rule ID 15595 //
     /* 1155263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155302 */     // MIs[0] round
     /* 1155302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155312 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155337 */     // GIR_Coverage, 15595,
     /* 1155337 */     GIR_EraseRootFromParent_Done,
     /* 1155338 */   // Label 16875: @1155338
     /* 1155338 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1155418), // Rule ID 15598 //
     /* 1155343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155382 */     // MIs[0] round
     /* 1155382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155417 */     // GIR_Coverage, 15598,
     /* 1155417 */     GIR_EraseRootFromParent_Done,
     /* 1155418 */   // Label 16876: @1155418
     /* 1155418 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1155498), // Rule ID 15599 //
     /* 1155423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155462 */     // MIs[0] round
     /* 1155462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155497 */     // GIR_Coverage, 15599,
     /* 1155497 */     GIR_EraseRootFromParent_Done,
     /* 1155498 */   // Label 16877: @1155498
     /* 1155498 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1155578), // Rule ID 15602 //
     /* 1155503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155542 */     // MIs[0] round
     /* 1155542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155577 */     // GIR_Coverage, 15602,
     /* 1155577 */     GIR_EraseRootFromParent_Done,
     /* 1155578 */   // Label 16878: @1155578
     /* 1155578 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1155658), // Rule ID 15603 //
     /* 1155583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155622 */     // MIs[0] round
     /* 1155622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155657 */     // GIR_Coverage, 15603,
     /* 1155657 */     GIR_EraseRootFromParent_Done,
     /* 1155658 */   // Label 16879: @1155658
     /* 1155658 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1155738), // Rule ID 15606 //
     /* 1155663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1155674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1155677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1155680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155702 */     // MIs[0] round
     /* 1155702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155737 */     // GIR_Coverage, 15606,
     /* 1155737 */     GIR_EraseRootFromParent_Done,
     /* 1155738 */   // Label 16880: @1155738
     /* 1155738 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1155818), // Rule ID 15607 //
     /* 1155743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1155754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1155757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1155760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155782 */     // MIs[0] round
     /* 1155782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155792 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155817 */     // GIR_Coverage, 15607,
     /* 1155817 */     GIR_EraseRootFromParent_Done,
     /* 1155818 */   // Label 16881: @1155818
     /* 1155818 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1155898), // Rule ID 15610 //
     /* 1155823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1155834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1155837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1155840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155862 */     // MIs[0] round
     /* 1155862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155872 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155897 */     // GIR_Coverage, 15610,
     /* 1155897 */     GIR_EraseRootFromParent_Done,
     /* 1155898 */   // Label 16882: @1155898
     /* 1155898 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1155978), // Rule ID 15611 //
     /* 1155903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1155914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1155917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1155920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155942 */     // MIs[0] round
     /* 1155942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155977 */     // GIR_Coverage, 15611,
     /* 1155977 */     GIR_EraseRootFromParent_Done,
     /* 1155978 */   // Label 16883: @1155978
     /* 1155978 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1156058), // Rule ID 15614 //
     /* 1155983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1155986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1155994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1155997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156022 */     // MIs[0] round
     /* 1156022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156057 */     // GIR_Coverage, 15614,
     /* 1156057 */     GIR_EraseRootFromParent_Done,
     /* 1156058 */   // Label 16884: @1156058
     /* 1156058 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1156138), // Rule ID 15615 //
     /* 1156063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156102 */     // MIs[0] round
     /* 1156102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156137 */     // GIR_Coverage, 15615,
     /* 1156137 */     GIR_EraseRootFromParent_Done,
     /* 1156138 */   // Label 16885: @1156138
     /* 1156138 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1156218), // Rule ID 15618 //
     /* 1156143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156182 */     // MIs[0] round
     /* 1156182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156217 */     // GIR_Coverage, 15618,
     /* 1156217 */     GIR_EraseRootFromParent_Done,
     /* 1156218 */   // Label 16886: @1156218
     /* 1156218 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1156298), // Rule ID 15619 //
     /* 1156223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156262 */     // MIs[0] round
     /* 1156262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156272 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156297 */     // GIR_Coverage, 15619,
     /* 1156297 */     GIR_EraseRootFromParent_Done,
     /* 1156298 */   // Label 16887: @1156298
     /* 1156298 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1156378), // Rule ID 15622 //
     /* 1156303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156342 */     // MIs[0] round
     /* 1156342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156377 */     // GIR_Coverage, 15622,
     /* 1156377 */     GIR_EraseRootFromParent_Done,
     /* 1156378 */   // Label 16888: @1156378
     /* 1156378 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1156458), // Rule ID 15623 //
     /* 1156383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156422 */     // MIs[0] round
     /* 1156422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156457 */     // GIR_Coverage, 15623,
     /* 1156457 */     GIR_EraseRootFromParent_Done,
     /* 1156458 */   // Label 16889: @1156458
     /* 1156458 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1156541), // Rule ID 15626 //
     /* 1156463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156502 */     // MIs[0] round
     /* 1156502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156540 */     // GIR_Coverage, 15626,
     /* 1156540 */     GIR_EraseRootFromParent_Done,
     /* 1156541 */   // Label 16890: @1156541
     /* 1156541 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1156624), // Rule ID 15627 //
     /* 1156546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156585 */     // MIs[0] round
     /* 1156585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156595 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156623 */     // GIR_Coverage, 15627,
     /* 1156623 */     GIR_EraseRootFromParent_Done,
     /* 1156624 */   // Label 16891: @1156624
     /* 1156624 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1156707), // Rule ID 15630 //
     /* 1156629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1156640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1156643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1156649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156668 */     // MIs[0] round
     /* 1156668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1156681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156706 */     // GIR_Coverage, 15630,
     /* 1156706 */     GIR_EraseRootFromParent_Done,
     /* 1156707 */   // Label 16892: @1156707
     /* 1156707 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1156790), // Rule ID 15631 //
     /* 1156712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1156723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1156726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1156732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156751 */     // MIs[0] round
     /* 1156751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156761 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1156764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156772 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156789 */     // GIR_Coverage, 15631,
     /* 1156789 */     GIR_EraseRootFromParent_Done,
     /* 1156790 */   // Label 16893: @1156790
     /* 1156790 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1156873), // Rule ID 15634 //
     /* 1156795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1156806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1156809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1156812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1156815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156834 */     // MIs[0] round
     /* 1156834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1156847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156872 */     // GIR_Coverage, 15634,
     /* 1156872 */     GIR_EraseRootFromParent_Done,
     /* 1156873 */   // Label 16894: @1156873
     /* 1156873 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1156956), // Rule ID 15635 //
     /* 1156878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1156889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1156892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1156895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1156898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156917 */     // MIs[0] round
     /* 1156917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1156930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156955 */     // GIR_Coverage, 15635,
     /* 1156955 */     GIR_EraseRootFromParent_Done,
     /* 1156956 */   // Label 16895: @1156956
     /* 1156956 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1157039), // Rule ID 15638 //
     /* 1156961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1156972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1156975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1156978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1156981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157000 */     // MIs[0] round
     /* 1157000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157038 */     // GIR_Coverage, 15638,
     /* 1157038 */     GIR_EraseRootFromParent_Done,
     /* 1157039 */   // Label 16896: @1157039
     /* 1157039 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1157122), // Rule ID 15639 //
     /* 1157044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157083 */     // MIs[0] round
     /* 1157083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157121 */     // GIR_Coverage, 15639,
     /* 1157121 */     GIR_EraseRootFromParent_Done,
     /* 1157122 */   // Label 16897: @1157122
     /* 1157122 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1157205), // Rule ID 15642 //
     /* 1157127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157166 */     // MIs[0] round
     /* 1157166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157204 */     // GIR_Coverage, 15642,
     /* 1157204 */     GIR_EraseRootFromParent_Done,
     /* 1157205 */   // Label 16898: @1157205
     /* 1157205 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1157288), // Rule ID 15643 //
     /* 1157210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157249 */     // MIs[0] round
     /* 1157249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157287 */     // GIR_Coverage, 15643,
     /* 1157287 */     GIR_EraseRootFromParent_Done,
     /* 1157288 */   // Label 16899: @1157288
     /* 1157288 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1157371), // Rule ID 15646 //
     /* 1157293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157332 */     // MIs[0] round
     /* 1157332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157370 */     // GIR_Coverage, 15646,
     /* 1157370 */     GIR_EraseRootFromParent_Done,
     /* 1157371 */   // Label 16900: @1157371
     /* 1157371 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1157454), // Rule ID 15647 //
     /* 1157376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157415 */     // MIs[0] round
     /* 1157415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157425 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157453 */     // GIR_Coverage, 15647,
     /* 1157453 */     GIR_EraseRootFromParent_Done,
     /* 1157454 */   // Label 16901: @1157454
     /* 1157454 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1157537), // Rule ID 15650 //
     /* 1157459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157498 */     // MIs[0] round
     /* 1157498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157536 */     // GIR_Coverage, 15650,
     /* 1157536 */     GIR_EraseRootFromParent_Done,
     /* 1157537 */   // Label 16902: @1157537
     /* 1157537 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1157620), // Rule ID 15651 //
     /* 1157542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157581 */     // MIs[0] round
     /* 1157581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157591 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157619 */     // GIR_Coverage, 15651,
     /* 1157619 */     GIR_EraseRootFromParent_Done,
     /* 1157620 */   // Label 16903: @1157620
     /* 1157620 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1157703), // Rule ID 15654 //
     /* 1157625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1157636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1157639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1157645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157664 */     // MIs[0] round
     /* 1157664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157702 */     // GIR_Coverage, 15654,
     /* 1157702 */     GIR_EraseRootFromParent_Done,
     /* 1157703 */   // Label 16904: @1157703
     /* 1157703 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1157786), // Rule ID 15655 //
     /* 1157708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1157719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1157722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1157728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157747 */     // MIs[0] round
     /* 1157747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157757 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157768 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157785 */     // GIR_Coverage, 15655,
     /* 1157785 */     GIR_EraseRootFromParent_Done,
     /* 1157786 */   // Label 16905: @1157786
     /* 1157786 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1157869), // Rule ID 15658 //
     /* 1157791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1157802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1157805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1157808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1157811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157830 */     // MIs[0] round
     /* 1157830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157868 */     // GIR_Coverage, 15658,
     /* 1157868 */     GIR_EraseRootFromParent_Done,
     /* 1157869 */   // Label 16906: @1157869
     /* 1157869 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1157952), // Rule ID 15659 //
     /* 1157874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1157885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1157888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1157891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1157894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157913 */     // MIs[0] round
     /* 1157913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157923 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157951 */     // GIR_Coverage, 15659,
     /* 1157951 */     GIR_EraseRootFromParent_Done,
     /* 1157952 */   // Label 16907: @1157952
     /* 1157952 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1158035), // Rule ID 15662 //
     /* 1157957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1157968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1157971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1157974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1157977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157996 */     // MIs[0] round
     /* 1157996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158034 */     // GIR_Coverage, 15662,
     /* 1158034 */     GIR_EraseRootFromParent_Done,
     /* 1158035 */   // Label 16908: @1158035
     /* 1158035 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1158118), // Rule ID 15663 //
     /* 1158040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158079 */     // MIs[0] round
     /* 1158079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158117 */     // GIR_Coverage, 15663,
     /* 1158117 */     GIR_EraseRootFromParent_Done,
     /* 1158118 */   // Label 16909: @1158118
     /* 1158118 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1158201), // Rule ID 15666 //
     /* 1158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158162 */     // MIs[0] round
     /* 1158162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158200 */     // GIR_Coverage, 15666,
     /* 1158200 */     GIR_EraseRootFromParent_Done,
     /* 1158201 */   // Label 16910: @1158201
     /* 1158201 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1158284), // Rule ID 15667 //
     /* 1158206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158245 */     // MIs[0] round
     /* 1158245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158255 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158283 */     // GIR_Coverage, 15667,
     /* 1158283 */     GIR_EraseRootFromParent_Done,
     /* 1158284 */   // Label 16911: @1158284
     /* 1158284 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1158367), // Rule ID 15670 //
     /* 1158289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158328 */     // MIs[0] round
     /* 1158328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158366 */     // GIR_Coverage, 15670,
     /* 1158366 */     GIR_EraseRootFromParent_Done,
     /* 1158367 */   // Label 16912: @1158367
     /* 1158367 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1158450), // Rule ID 15671 //
     /* 1158372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158411 */     // MIs[0] round
     /* 1158411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158421 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158449 */     // GIR_Coverage, 15671,
     /* 1158449 */     GIR_EraseRootFromParent_Done,
     /* 1158450 */   // Label 16913: @1158450
     /* 1158450 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1158533), // Rule ID 15674 //
     /* 1158455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158494 */     // MIs[0] round
     /* 1158494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158532 */     // GIR_Coverage, 15674,
     /* 1158532 */     GIR_EraseRootFromParent_Done,
     /* 1158533 */   // Label 16914: @1158533
     /* 1158533 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1158616), // Rule ID 15675 //
     /* 1158538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158577 */     // MIs[0] round
     /* 1158577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158598 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158615 */     // GIR_Coverage, 15675,
     /* 1158615 */     GIR_EraseRootFromParent_Done,
     /* 1158616 */   // Label 16915: @1158616
     /* 1158616 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1158699), // Rule ID 15678 //
     /* 1158621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1158632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1158635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1158641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158660 */     // MIs[0] round
     /* 1158660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158698 */     // GIR_Coverage, 15678,
     /* 1158698 */     GIR_EraseRootFromParent_Done,
     /* 1158699 */   // Label 16916: @1158699
     /* 1158699 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1158782), // Rule ID 15679 //
     /* 1158704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1158715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1158718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1158724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158743 */     // MIs[0] round
     /* 1158743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158753 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158764 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158781 */     // GIR_Coverage, 15679,
     /* 1158781 */     GIR_EraseRootFromParent_Done,
     /* 1158782 */   // Label 16917: @1158782
     /* 1158782 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1158865), // Rule ID 15682 //
     /* 1158787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1158798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1158801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1158804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1158807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158826 */     // MIs[0] round
     /* 1158826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158836 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158864 */     // GIR_Coverage, 15682,
     /* 1158864 */     GIR_EraseRootFromParent_Done,
     /* 1158865 */   // Label 16918: @1158865
     /* 1158865 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1158948), // Rule ID 15683 //
     /* 1158870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1158881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1158884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1158887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1158890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158909 */     // MIs[0] round
     /* 1158909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158919 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158930 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158947 */     // GIR_Coverage, 15683,
     /* 1158947 */     GIR_EraseRootFromParent_Done,
     /* 1158948 */   // Label 16919: @1158948
     /* 1158948 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1159031), // Rule ID 15686 //
     /* 1158953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1158964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1158967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1158970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1158973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158992 */     // MIs[0] round
     /* 1158992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159030 */     // GIR_Coverage, 15686,
     /* 1159030 */     GIR_EraseRootFromParent_Done,
     /* 1159031 */   // Label 16920: @1159031
     /* 1159031 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1159114), // Rule ID 15687 //
     /* 1159036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159075 */     // MIs[0] round
     /* 1159075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159085 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159113 */     // GIR_Coverage, 15687,
     /* 1159113 */     GIR_EraseRootFromParent_Done,
     /* 1159114 */   // Label 16921: @1159114
     /* 1159114 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1159197), // Rule ID 15690 //
     /* 1159119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159158 */     // MIs[0] round
     /* 1159158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159196 */     // GIR_Coverage, 15690,
     /* 1159196 */     GIR_EraseRootFromParent_Done,
     /* 1159197 */   // Label 16922: @1159197
     /* 1159197 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1159280), // Rule ID 15691 //
     /* 1159202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159241 */     // MIs[0] round
     /* 1159241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159251 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159279 */     // GIR_Coverage, 15691,
     /* 1159279 */     GIR_EraseRootFromParent_Done,
     /* 1159280 */   // Label 16923: @1159280
     /* 1159280 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1159363), // Rule ID 15694 //
     /* 1159285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159324 */     // MIs[0] round
     /* 1159324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159362 */     // GIR_Coverage, 15694,
     /* 1159362 */     GIR_EraseRootFromParent_Done,
     /* 1159363 */   // Label 16924: @1159363
     /* 1159363 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1159446), // Rule ID 15695 //
     /* 1159368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159407 */     // MIs[0] round
     /* 1159407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159417 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159428 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159445 */     // GIR_Coverage, 15695,
     /* 1159445 */     GIR_EraseRootFromParent_Done,
     /* 1159446 */   // Label 16925: @1159446
     /* 1159446 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1159529), // Rule ID 15698 //
     /* 1159451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159490 */     // MIs[0] round
     /* 1159490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159500 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159528 */     // GIR_Coverage, 15698,
     /* 1159528 */     GIR_EraseRootFromParent_Done,
     /* 1159529 */   // Label 16926: @1159529
     /* 1159529 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1159612), // Rule ID 15699 //
     /* 1159534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159573 */     // MIs[0] round
     /* 1159573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159583 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159594 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159611 */     // GIR_Coverage, 15699,
     /* 1159611 */     GIR_EraseRootFromParent_Done,
     /* 1159612 */   // Label 16927: @1159612
     /* 1159612 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1159695), // Rule ID 15702 //
     /* 1159617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159656 */     // MIs[0] round
     /* 1159656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1159669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159694 */     // GIR_Coverage, 15702,
     /* 1159694 */     GIR_EraseRootFromParent_Done,
     /* 1159695 */   // Label 16928: @1159695
     /* 1159695 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1159778), // Rule ID 15703 //
     /* 1159700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159739 */     // MIs[0] round
     /* 1159739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159749 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1159752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159760 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159777 */     // GIR_Coverage, 15703,
     /* 1159777 */     GIR_EraseRootFromParent_Done,
     /* 1159778 */   // Label 16929: @1159778
     /* 1159778 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1159861), // Rule ID 15706 //
     /* 1159783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1159794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1159797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159822 */     // MIs[0] round
     /* 1159822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159832 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1159835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159860 */     // GIR_Coverage, 15706,
     /* 1159860 */     GIR_EraseRootFromParent_Done,
     /* 1159861 */   // Label 16930: @1159861
     /* 1159861 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1159944), // Rule ID 15707 //
     /* 1159866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1159877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1159880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159905 */     // MIs[0] round
     /* 1159905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159915 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1159918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159926 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159943 */     // GIR_Coverage, 15707,
     /* 1159943 */     GIR_EraseRootFromParent_Done,
     /* 1159944 */   // Label 16931: @1159944
     /* 1159944 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1160027), // Rule ID 15710 //
     /* 1159949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1159960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1159963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1159966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159988 */     // MIs[0] round
     /* 1159988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160026 */     // GIR_Coverage, 15710,
     /* 1160026 */     GIR_EraseRootFromParent_Done,
     /* 1160027 */   // Label 16932: @1160027
     /* 1160027 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1160110), // Rule ID 15711 //
     /* 1160032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160071 */     // MIs[0] round
     /* 1160071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160092 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160109 */     // GIR_Coverage, 15711,
     /* 1160109 */     GIR_EraseRootFromParent_Done,
     /* 1160110 */   // Label 16933: @1160110
     /* 1160110 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1160193), // Rule ID 15714 //
     /* 1160115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160154 */     // MIs[0] round
     /* 1160154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160192 */     // GIR_Coverage, 15714,
     /* 1160192 */     GIR_EraseRootFromParent_Done,
     /* 1160193 */   // Label 16934: @1160193
     /* 1160193 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1160276), // Rule ID 15715 //
     /* 1160198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160237 */     // MIs[0] round
     /* 1160237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160247 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160275 */     // GIR_Coverage, 15715,
     /* 1160275 */     GIR_EraseRootFromParent_Done,
     /* 1160276 */   // Label 16935: @1160276
     /* 1160276 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1160359), // Rule ID 15718 //
     /* 1160281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160320 */     // MIs[0] round
     /* 1160320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160358 */     // GIR_Coverage, 15718,
     /* 1160358 */     GIR_EraseRootFromParent_Done,
     /* 1160359 */   // Label 16936: @1160359
     /* 1160359 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1160442), // Rule ID 15719 //
     /* 1160364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160403 */     // MIs[0] round
     /* 1160403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160413 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160441 */     // GIR_Coverage, 15719,
     /* 1160441 */     GIR_EraseRootFromParent_Done,
     /* 1160442 */   // Label 16937: @1160442
     /* 1160442 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1160525), // Rule ID 15722 //
     /* 1160447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160486 */     // MIs[0] round
     /* 1160486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160496 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160524 */     // GIR_Coverage, 15722,
     /* 1160524 */     GIR_EraseRootFromParent_Done,
     /* 1160525 */   // Label 16938: @1160525
     /* 1160525 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1160608), // Rule ID 15723 //
     /* 1160530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160569 */     // MIs[0] round
     /* 1160569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160579 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160590 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160607 */     // GIR_Coverage, 15723,
     /* 1160607 */     GIR_EraseRootFromParent_Done,
     /* 1160608 */   // Label 16939: @1160608
     /* 1160608 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1160691), // Rule ID 15726 //
     /* 1160613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160652 */     // MIs[0] round
     /* 1160652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160690 */     // GIR_Coverage, 15726,
     /* 1160690 */     GIR_EraseRootFromParent_Done,
     /* 1160691 */   // Label 16940: @1160691
     /* 1160691 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1160774), // Rule ID 15727 //
     /* 1160696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160735 */     // MIs[0] round
     /* 1160735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160756 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160773 */     // GIR_Coverage, 15727,
     /* 1160773 */     GIR_EraseRootFromParent_Done,
     /* 1160774 */   // Label 16941: @1160774
     /* 1160774 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1160857), // Rule ID 15730 //
     /* 1160779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1160790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1160793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160818 */     // MIs[0] round
     /* 1160818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160856 */     // GIR_Coverage, 15730,
     /* 1160856 */     GIR_EraseRootFromParent_Done,
     /* 1160857 */   // Label 16942: @1160857
     /* 1160857 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1160940), // Rule ID 15731 //
     /* 1160862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1160873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1160876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160901 */     // MIs[0] round
     /* 1160901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160911 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160922 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160939 */     // GIR_Coverage, 15731,
     /* 1160939 */     GIR_EraseRootFromParent_Done,
     /* 1160940 */   // Label 16943: @1160940
     /* 1160940 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1161023), // Rule ID 15734 //
     /* 1160945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1160956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1160959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1160962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1160980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160984 */     // MIs[0] round
     /* 1160984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1160997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161022 */     // GIR_Coverage, 15734,
     /* 1161022 */     GIR_EraseRootFromParent_Done,
     /* 1161023 */   // Label 16944: @1161023
     /* 1161023 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1161106), // Rule ID 15735 //
     /* 1161028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161067 */     // MIs[0] round
     /* 1161067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161088 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161105 */     // GIR_Coverage, 15735,
     /* 1161105 */     GIR_EraseRootFromParent_Done,
     /* 1161106 */   // Label 16945: @1161106
     /* 1161106 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1161189), // Rule ID 15738 //
     /* 1161111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161150 */     // MIs[0] round
     /* 1161150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161188 */     // GIR_Coverage, 15738,
     /* 1161188 */     GIR_EraseRootFromParent_Done,
     /* 1161189 */   // Label 16946: @1161189
     /* 1161189 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1161272), // Rule ID 15739 //
     /* 1161194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161233 */     // MIs[0] round
     /* 1161233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161243 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161271 */     // GIR_Coverage, 15739,
     /* 1161271 */     GIR_EraseRootFromParent_Done,
     /* 1161272 */   // Label 16947: @1161272
     /* 1161272 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1161355), // Rule ID 15742 //
     /* 1161277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161316 */     // MIs[0] round
     /* 1161316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161354 */     // GIR_Coverage, 15742,
     /* 1161354 */     GIR_EraseRootFromParent_Done,
     /* 1161355 */   // Label 16948: @1161355
     /* 1161355 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1161438), // Rule ID 15743 //
     /* 1161360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161399 */     // MIs[0] round
     /* 1161399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161409 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161437 */     // GIR_Coverage, 15743,
     /* 1161437 */     GIR_EraseRootFromParent_Done,
     /* 1161438 */   // Label 16949: @1161438
     /* 1161438 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1161521), // Rule ID 15746 //
     /* 1161443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161482 */     // MIs[0] round
     /* 1161482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161520 */     // GIR_Coverage, 15746,
     /* 1161520 */     GIR_EraseRootFromParent_Done,
     /* 1161521 */   // Label 16950: @1161521
     /* 1161521 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1161604), // Rule ID 15747 //
     /* 1161526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161565 */     // MIs[0] round
     /* 1161565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161586 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161603 */     // GIR_Coverage, 15747,
     /* 1161603 */     GIR_EraseRootFromParent_Done,
     /* 1161604 */   // Label 16951: @1161604
     /* 1161604 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1161687), // Rule ID 15750 //
     /* 1161609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161648 */     // MIs[0] round
     /* 1161648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161686 */     // GIR_Coverage, 15750,
     /* 1161686 */     GIR_EraseRootFromParent_Done,
     /* 1161687 */   // Label 16952: @1161687
     /* 1161687 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1161770), // Rule ID 15751 //
     /* 1161692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161731 */     // MIs[0] round
     /* 1161731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161741 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161752 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161769 */     // GIR_Coverage, 15751,
     /* 1161769 */     GIR_EraseRootFromParent_Done,
     /* 1161770 */   // Label 16953: @1161770
     /* 1161770 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1161853), // Rule ID 15754 //
     /* 1161775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1161786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1161789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1161792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161814 */     // MIs[0] round
     /* 1161814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161852 */     // GIR_Coverage, 15754,
     /* 1161852 */     GIR_EraseRootFromParent_Done,
     /* 1161853 */   // Label 16954: @1161853
     /* 1161853 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1161936), // Rule ID 15755 //
     /* 1161858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1161869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1161872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1161875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161897 */     // MIs[0] round
     /* 1161897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161907 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161935 */     // GIR_Coverage, 15755,
     /* 1161935 */     GIR_EraseRootFromParent_Done,
     /* 1161936 */   // Label 16955: @1161936
     /* 1161936 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1162019), // Rule ID 15758 //
     /* 1161941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1161952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1161955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1161958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161980 */     // MIs[0] round
     /* 1161980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162018 */     // GIR_Coverage, 15758,
     /* 1162018 */     GIR_EraseRootFromParent_Done,
     /* 1162019 */   // Label 16956: @1162019
     /* 1162019 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1162102), // Rule ID 15759 //
     /* 1162024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162063 */     // MIs[0] round
     /* 1162063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162101 */     // GIR_Coverage, 15759,
     /* 1162101 */     GIR_EraseRootFromParent_Done,
     /* 1162102 */   // Label 16957: @1162102
     /* 1162102 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1162185), // Rule ID 15762 //
     /* 1162107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162146 */     // MIs[0] round
     /* 1162146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162156 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162184 */     // GIR_Coverage, 15762,
     /* 1162184 */     GIR_EraseRootFromParent_Done,
     /* 1162185 */   // Label 16958: @1162185
     /* 1162185 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1162268), // Rule ID 15763 //
     /* 1162190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162229 */     // MIs[0] round
     /* 1162229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162239 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162267 */     // GIR_Coverage, 15763,
     /* 1162267 */     GIR_EraseRootFromParent_Done,
     /* 1162268 */   // Label 16959: @1162268
     /* 1162268 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1162351), // Rule ID 15766 //
     /* 1162273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162312 */     // MIs[0] round
     /* 1162312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162350 */     // GIR_Coverage, 15766,
     /* 1162350 */     GIR_EraseRootFromParent_Done,
     /* 1162351 */   // Label 16960: @1162351
     /* 1162351 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1162434), // Rule ID 15767 //
     /* 1162356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162395 */     // MIs[0] round
     /* 1162395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162405 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162433 */     // GIR_Coverage, 15767,
     /* 1162433 */     GIR_EraseRootFromParent_Done,
     /* 1162434 */   // Label 16961: @1162434
     /* 1162434 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1162517), // Rule ID 15770 //
     /* 1162439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162478 */     // MIs[0] round
     /* 1162478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162516 */     // GIR_Coverage, 15770,
     /* 1162516 */     GIR_EraseRootFromParent_Done,
     /* 1162517 */   // Label 16962: @1162517
     /* 1162517 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1162600), // Rule ID 15771 //
     /* 1162522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1162525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162561 */     // MIs[0] round
     /* 1162561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162571 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162599 */     // GIR_Coverage, 15771,
     /* 1162599 */     GIR_EraseRootFromParent_Done,
     /* 1162600 */   // Label 16963: @1162600
     /* 1162600 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1162683), // Rule ID 15774 //
     /* 1162605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162644 */     // MIs[0] round
     /* 1162644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162682 */     // GIR_Coverage, 15774,
     /* 1162682 */     GIR_EraseRootFromParent_Done,
     /* 1162683 */   // Label 16964: @1162683
     /* 1162683 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1162766), // Rule ID 15775 //
     /* 1162688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1162691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162727 */     // MIs[0] round
     /* 1162727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162748 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162765 */     // GIR_Coverage, 15775,
     /* 1162765 */     GIR_EraseRootFromParent_Done,
     /* 1162766 */   // Label 16965: @1162766
     /* 1162766 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1162849), // Rule ID 15778 //
     /* 1162771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1162782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1162785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1162788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1162791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162810 */     // MIs[0] round
     /* 1162810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162848 */     // GIR_Coverage, 15778,
     /* 1162848 */     GIR_EraseRootFromParent_Done,
     /* 1162849 */   // Label 16966: @1162849
     /* 1162849 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1162932), // Rule ID 15779 //
     /* 1162854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1162857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1162865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1162868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1162871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1162874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162893 */     // MIs[0] round
     /* 1162893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162903 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1162906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162931 */     // GIR_Coverage, 15779,
     /* 1162931 */     GIR_EraseRootFromParent_Done,
     /* 1162932 */   // Label 16967: @1162932
     /* 1162932 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1163015), // Rule ID 15782 //
     /* 1162937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1162948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1162951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1162954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1162957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162976 */     // MIs[0] round
     /* 1162976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1162989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163014 */     // GIR_Coverage, 15782,
     /* 1163014 */     GIR_EraseRootFromParent_Done,
     /* 1163015 */   // Label 16968: @1163015
     /* 1163015 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1163098), // Rule ID 15783 //
     /* 1163020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163059 */     // MIs[0] round
     /* 1163059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163097 */     // GIR_Coverage, 15783,
     /* 1163097 */     GIR_EraseRootFromParent_Done,
     /* 1163098 */   // Label 16969: @1163098
     /* 1163098 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1163181), // Rule ID 15786 //
     /* 1163103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163142 */     // MIs[0] round
     /* 1163142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163180 */     // GIR_Coverage, 15786,
     /* 1163180 */     GIR_EraseRootFromParent_Done,
     /* 1163181 */   // Label 16970: @1163181
     /* 1163181 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1163264), // Rule ID 15787 //
     /* 1163186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163225 */     // MIs[0] round
     /* 1163225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163263 */     // GIR_Coverage, 15787,
     /* 1163263 */     GIR_EraseRootFromParent_Done,
     /* 1163264 */   // Label 16971: @1163264
     /* 1163264 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1163347), // Rule ID 15790 //
     /* 1163269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163308 */     // MIs[0] round
     /* 1163308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163346 */     // GIR_Coverage, 15790,
     /* 1163346 */     GIR_EraseRootFromParent_Done,
     /* 1163347 */   // Label 16972: @1163347
     /* 1163347 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1163430), // Rule ID 15791 //
     /* 1163352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163391 */     // MIs[0] round
     /* 1163391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11500:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163429 */     // GIR_Coverage, 15791,
     /* 1163429 */     GIR_EraseRootFromParent_Done,
     /* 1163430 */   // Label 16973: @1163430
     /* 1163430 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1163513), // Rule ID 15794 //
     /* 1163435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163474 */     // MIs[0] round
     /* 1163474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163512 */     // GIR_Coverage, 15794,
     /* 1163512 */     GIR_EraseRootFromParent_Done,
     /* 1163513 */   // Label 16974: @1163513
     /* 1163513 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1163596), // Rule ID 15795 //
     /* 1163518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163557 */     // MIs[0] round
     /* 1163557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163567 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11500:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163595 */     // GIR_Coverage, 15795,
     /* 1163595 */     GIR_EraseRootFromParent_Done,
     /* 1163596 */   // Label 16975: @1163596
     /* 1163596 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1163679), // Rule ID 15798 //
     /* 1163601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163640 */     // MIs[0] round
     /* 1163640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163678 */     // GIR_Coverage, 15798,
     /* 1163678 */     GIR_EraseRootFromParent_Done,
     /* 1163679 */   // Label 16976: @1163679
     /* 1163679 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1163762), // Rule ID 15799 //
     /* 1163684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163723 */     // MIs[0] round
     /* 1163723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163733 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11500:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163761 */     // GIR_Coverage, 15799,
     /* 1163761 */     GIR_EraseRootFromParent_Done,
     /* 1163762 */   // Label 16977: @1163762
     /* 1163762 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1163842), // Rule ID 15802 //
     /* 1163767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1163778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1163781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1163787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163806 */     // MIs[0] round
     /* 1163806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163816 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1163819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163841 */     // GIR_Coverage, 15802,
     /* 1163841 */     GIR_EraseRootFromParent_Done,
     /* 1163842 */   // Label 16978: @1163842
     /* 1163842 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1163922), // Rule ID 15803 //
     /* 1163847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1163858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1163861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1163867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163886 */     // MIs[0] round
     /* 1163886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1163899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163921 */     // GIR_Coverage, 15803,
     /* 1163921 */     GIR_EraseRootFromParent_Done,
     /* 1163922 */   // Label 16979: @1163922
     /* 1163922 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1164002), // Rule ID 15806 //
     /* 1163927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1163938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1163941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1163947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163966 */     // MIs[0] round
     /* 1163966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1163979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164001 */     // GIR_Coverage, 15806,
     /* 1164001 */     GIR_EraseRootFromParent_Done,
     /* 1164002 */   // Label 16980: @1164002
     /* 1164002 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1164082), // Rule ID 15807 //
     /* 1164007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164046 */     // MIs[0] round
     /* 1164046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164056 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164081 */     // GIR_Coverage, 15807,
     /* 1164081 */     GIR_EraseRootFromParent_Done,
     /* 1164082 */   // Label 16981: @1164082
     /* 1164082 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1164162), // Rule ID 15810 //
     /* 1164087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164126 */     // MIs[0] round
     /* 1164126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164161 */     // GIR_Coverage, 15810,
     /* 1164161 */     GIR_EraseRootFromParent_Done,
     /* 1164162 */   // Label 16982: @1164162
     /* 1164162 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1164242), // Rule ID 15811 //
     /* 1164167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164206 */     // MIs[0] round
     /* 1164206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164241 */     // GIR_Coverage, 15811,
     /* 1164241 */     GIR_EraseRootFromParent_Done,
     /* 1164242 */   // Label 16983: @1164242
     /* 1164242 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1164322), // Rule ID 15814 //
     /* 1164247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164286 */     // MIs[0] round
     /* 1164286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164321 */     // GIR_Coverage, 15814,
     /* 1164321 */     GIR_EraseRootFromParent_Done,
     /* 1164322 */   // Label 16984: @1164322
     /* 1164322 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1164402), // Rule ID 15815 //
     /* 1164327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164366 */     // MIs[0] round
     /* 1164366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164401 */     // GIR_Coverage, 15815,
     /* 1164401 */     GIR_EraseRootFromParent_Done,
     /* 1164402 */   // Label 16985: @1164402
     /* 1164402 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1164482), // Rule ID 15818 //
     /* 1164407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164446 */     // MIs[0] round
     /* 1164446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164481 */     // GIR_Coverage, 15818,
     /* 1164481 */     GIR_EraseRootFromParent_Done,
     /* 1164482 */   // Label 16986: @1164482
     /* 1164482 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1164562), // Rule ID 15819 //
     /* 1164487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164526 */     // MIs[0] round
     /* 1164526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164561 */     // GIR_Coverage, 15819,
     /* 1164561 */     GIR_EraseRootFromParent_Done,
     /* 1164562 */   // Label 16987: @1164562
     /* 1164562 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1164642), // Rule ID 15822 //
     /* 1164567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164606 */     // MIs[0] round
     /* 1164606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164641 */     // GIR_Coverage, 15822,
     /* 1164641 */     GIR_EraseRootFromParent_Done,
     /* 1164642 */   // Label 16988: @1164642
     /* 1164642 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1164722), // Rule ID 15823 //
     /* 1164647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164686 */     // MIs[0] round
     /* 1164686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164721 */     // GIR_Coverage, 15823,
     /* 1164721 */     GIR_EraseRootFromParent_Done,
     /* 1164722 */   // Label 16989: @1164722
     /* 1164722 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1164802), // Rule ID 15826 //
     /* 1164727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1164738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1164741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1164747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164766 */     // MIs[0] round
     /* 1164766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1164779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164801 */     // GIR_Coverage, 15826,
     /* 1164801 */     GIR_EraseRootFromParent_Done,
     /* 1164802 */   // Label 16990: @1164802
     /* 1164802 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1164882), // Rule ID 15827 //
     /* 1164807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1164818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1164821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1164824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1164827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164846 */     // MIs[0] round
     /* 1164846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1164859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164881 */     // GIR_Coverage, 15827,
     /* 1164881 */     GIR_EraseRootFromParent_Done,
     /* 1164882 */   // Label 16991: @1164882
     /* 1164882 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1164962), // Rule ID 15830 //
     /* 1164887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1164907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164926 */     // MIs[0] round
     /* 1164926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1164939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164961 */     // GIR_Coverage, 15830,
     /* 1164961 */     GIR_EraseRootFromParent_Done,
     /* 1164962 */   // Label 16992: @1164962
     /* 1164962 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1165042), // Rule ID 15831 //
     /* 1164967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1164987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165006 */     // MIs[0] round
     /* 1165006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165041 */     // GIR_Coverage, 15831,
     /* 1165041 */     GIR_EraseRootFromParent_Done,
     /* 1165042 */   // Label 16993: @1165042
     /* 1165042 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1165122), // Rule ID 15834 //
     /* 1165047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165086 */     // MIs[0] round
     /* 1165086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165121 */     // GIR_Coverage, 15834,
     /* 1165121 */     GIR_EraseRootFromParent_Done,
     /* 1165122 */   // Label 16994: @1165122
     /* 1165122 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1165202), // Rule ID 15835 //
     /* 1165127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165166 */     // MIs[0] round
     /* 1165166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165201 */     // GIR_Coverage, 15835,
     /* 1165201 */     GIR_EraseRootFromParent_Done,
     /* 1165202 */   // Label 16995: @1165202
     /* 1165202 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1165282), // Rule ID 15838 //
     /* 1165207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165246 */     // MIs[0] round
     /* 1165246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165281 */     // GIR_Coverage, 15838,
     /* 1165281 */     GIR_EraseRootFromParent_Done,
     /* 1165282 */   // Label 16996: @1165282
     /* 1165282 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1165362), // Rule ID 15839 //
     /* 1165287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1165290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165326 */     // MIs[0] round
     /* 1165326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165361 */     // GIR_Coverage, 15839,
     /* 1165361 */     GIR_EraseRootFromParent_Done,
     /* 1165362 */   // Label 16997: @1165362
     /* 1165362 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1165442), // Rule ID 15842 //
     /* 1165367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165406 */     // MIs[0] round
     /* 1165406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165441 */     // GIR_Coverage, 15842,
     /* 1165441 */     GIR_EraseRootFromParent_Done,
     /* 1165442 */   // Label 16998: @1165442
     /* 1165442 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1165522), // Rule ID 15843 //
     /* 1165447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165486 */     // MIs[0] round
     /* 1165486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165496 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165521 */     // GIR_Coverage, 15843,
     /* 1165521 */     GIR_EraseRootFromParent_Done,
     /* 1165522 */   // Label 16999: @1165522
     /* 1165522 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1165602), // Rule ID 15846 //
     /* 1165527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165566 */     // MIs[0] round
     /* 1165566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165576 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165601 */     // GIR_Coverage, 15846,
     /* 1165601 */     GIR_EraseRootFromParent_Done,
     /* 1165602 */   // Label 17000: @1165602
     /* 1165602 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1165682), // Rule ID 15847 //
     /* 1165607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165646 */     // MIs[0] round
     /* 1165646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165681 */     // GIR_Coverage, 15847,
     /* 1165681 */     GIR_EraseRootFromParent_Done,
     /* 1165682 */   // Label 17001: @1165682
     /* 1165682 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1165762), // Rule ID 15850 //
     /* 1165687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1165698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1165701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1165707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165726 */     // MIs[0] round
     /* 1165726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165736 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1165739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165761 */     // GIR_Coverage, 15850,
     /* 1165761 */     GIR_EraseRootFromParent_Done,
     /* 1165762 */   // Label 17002: @1165762
     /* 1165762 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1165842), // Rule ID 15851 //
     /* 1165767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1165778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1165781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1165784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1165787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165806 */     // MIs[0] round
     /* 1165806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165816 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165841 */     // GIR_Coverage, 15851,
     /* 1165841 */     GIR_EraseRootFromParent_Done,
     /* 1165842 */   // Label 17003: @1165842
     /* 1165842 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1165922), // Rule ID 15854 //
     /* 1165847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1165867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165886 */     // MIs[0] round
     /* 1165886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165921 */     // GIR_Coverage, 15854,
     /* 1165921 */     GIR_EraseRootFromParent_Done,
     /* 1165922 */   // Label 17004: @1165922
     /* 1165922 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1166002), // Rule ID 15855 //
     /* 1165927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1165947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165966 */     // MIs[0] round
     /* 1165966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166001 */     // GIR_Coverage, 15855,
     /* 1166001 */     GIR_EraseRootFromParent_Done,
     /* 1166002 */   // Label 17005: @1166002
     /* 1166002 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1166082), // Rule ID 15858 //
     /* 1166007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166046 */     // MIs[0] round
     /* 1166046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166081 */     // GIR_Coverage, 15858,
     /* 1166081 */     GIR_EraseRootFromParent_Done,
     /* 1166082 */   // Label 17006: @1166082
     /* 1166082 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1166162), // Rule ID 15859 //
     /* 1166087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166126 */     // MIs[0] round
     /* 1166126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166161 */     // GIR_Coverage, 15859,
     /* 1166161 */     GIR_EraseRootFromParent_Done,
     /* 1166162 */   // Label 17007: @1166162
     /* 1166162 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1166242), // Rule ID 15862 //
     /* 1166167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166206 */     // MIs[0] round
     /* 1166206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166216 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166241 */     // GIR_Coverage, 15862,
     /* 1166241 */     GIR_EraseRootFromParent_Done,
     /* 1166242 */   // Label 17008: @1166242
     /* 1166242 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1166322), // Rule ID 15863 //
     /* 1166247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166286 */     // MIs[0] round
     /* 1166286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166321 */     // GIR_Coverage, 15863,
     /* 1166321 */     GIR_EraseRootFromParent_Done,
     /* 1166322 */   // Label 17009: @1166322
     /* 1166322 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1166402), // Rule ID 15866 //
     /* 1166327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166366 */     // MIs[0] round
     /* 1166366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166401 */     // GIR_Coverage, 15866,
     /* 1166401 */     GIR_EraseRootFromParent_Done,
     /* 1166402 */   // Label 17010: @1166402
     /* 1166402 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1166482), // Rule ID 15867 //
     /* 1166407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166446 */     // MIs[0] round
     /* 1166446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166481 */     // GIR_Coverage, 15867,
     /* 1166481 */     GIR_EraseRootFromParent_Done,
     /* 1166482 */   // Label 17011: @1166482
     /* 1166482 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1166562), // Rule ID 15870 //
     /* 1166487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166526 */     // MIs[0] round
     /* 1166526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166561 */     // GIR_Coverage, 15870,
     /* 1166561 */     GIR_EraseRootFromParent_Done,
     /* 1166562 */   // Label 17012: @1166562
     /* 1166562 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1166642), // Rule ID 15871 //
     /* 1166567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166606 */     // MIs[0] round
     /* 1166606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166641 */     // GIR_Coverage, 15871,
     /* 1166641 */     GIR_EraseRootFromParent_Done,
     /* 1166642 */   // Label 17013: @1166642
     /* 1166642 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1166722), // Rule ID 15874 //
     /* 1166647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1166667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166686 */     // MIs[0] round
     /* 1166686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166721 */     // GIR_Coverage, 15874,
     /* 1166721 */     GIR_EraseRootFromParent_Done,
     /* 1166722 */   // Label 17014: @1166722
     /* 1166722 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1166802), // Rule ID 15875 //
     /* 1166727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1166747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166766 */     // MIs[0] round
     /* 1166766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166801 */     // GIR_Coverage, 15875,
     /* 1166801 */     GIR_EraseRootFromParent_Done,
     /* 1166802 */   // Label 17015: @1166802
     /* 1166802 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1166882), // Rule ID 15878 //
     /* 1166807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1166818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1166821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1166827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166846 */     // MIs[0] round
     /* 1166846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166881 */     // GIR_Coverage, 15878,
     /* 1166881 */     GIR_EraseRootFromParent_Done,
     /* 1166882 */   // Label 17016: @1166882
     /* 1166882 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1166962), // Rule ID 15879 //
     /* 1166887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1166898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1166901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1166907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166926 */     // MIs[0] round
     /* 1166926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166961 */     // GIR_Coverage, 15879,
     /* 1166961 */     GIR_EraseRootFromParent_Done,
     /* 1166962 */   // Label 17017: @1166962
     /* 1166962 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1167042), // Rule ID 15882 //
     /* 1166967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1166978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1166981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1166987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167006 */     // MIs[0] round
     /* 1167006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167041 */     // GIR_Coverage, 15882,
     /* 1167041 */     GIR_EraseRootFromParent_Done,
     /* 1167042 */   // Label 17018: @1167042
     /* 1167042 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1167122), // Rule ID 15883 //
     /* 1167047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167086 */     // MIs[0] round
     /* 1167086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167096 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167121 */     // GIR_Coverage, 15883,
     /* 1167121 */     GIR_EraseRootFromParent_Done,
     /* 1167122 */   // Label 17019: @1167122
     /* 1167122 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1167202), // Rule ID 15886 //
     /* 1167127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167166 */     // MIs[0] round
     /* 1167166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167201 */     // GIR_Coverage, 15886,
     /* 1167201 */     GIR_EraseRootFromParent_Done,
     /* 1167202 */   // Label 17020: @1167202
     /* 1167202 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1167282), // Rule ID 15887 //
     /* 1167207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167246 */     // MIs[0] round
     /* 1167246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167281 */     // GIR_Coverage, 15887,
     /* 1167281 */     GIR_EraseRootFromParent_Done,
     /* 1167282 */   // Label 17021: @1167282
     /* 1167282 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1167362), // Rule ID 15890 //
     /* 1167287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167326 */     // MIs[0] round
     /* 1167326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167361 */     // GIR_Coverage, 15890,
     /* 1167361 */     GIR_EraseRootFromParent_Done,
     /* 1167362 */   // Label 17022: @1167362
     /* 1167362 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1167442), // Rule ID 15891 //
     /* 1167367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167406 */     // MIs[0] round
     /* 1167406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167441 */     // GIR_Coverage, 15891,
     /* 1167441 */     GIR_EraseRootFromParent_Done,
     /* 1167442 */   // Label 17023: @1167442
     /* 1167442 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1167522), // Rule ID 15894 //
     /* 1167447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167486 */     // MIs[0] round
     /* 1167486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167521 */     // GIR_Coverage, 15894,
     /* 1167521 */     GIR_EraseRootFromParent_Done,
     /* 1167522 */   // Label 17024: @1167522
     /* 1167522 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1167602), // Rule ID 15895 //
     /* 1167527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167566 */     // MIs[0] round
     /* 1167566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167601 */     // GIR_Coverage, 15895,
     /* 1167601 */     GIR_EraseRootFromParent_Done,
     /* 1167602 */   // Label 17025: @1167602
     /* 1167602 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1167682), // Rule ID 15898 //
     /* 1167607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1167618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1167621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167646 */     // MIs[0] round
     /* 1167646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167656 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1167659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167681 */     // GIR_Coverage, 15898,
     /* 1167681 */     GIR_EraseRootFromParent_Done,
     /* 1167682 */   // Label 17026: @1167682
     /* 1167682 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1167762), // Rule ID 15899 //
     /* 1167687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1167698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1167701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167726 */     // MIs[0] round
     /* 1167726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1167739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167761 */     // GIR_Coverage, 15899,
     /* 1167761 */     GIR_EraseRootFromParent_Done,
     /* 1167762 */   // Label 17027: @1167762
     /* 1167762 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1167842), // Rule ID 15902 //
     /* 1167767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1167778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1167781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1167784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167806 */     // MIs[0] round
     /* 1167806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167841 */     // GIR_Coverage, 15902,
     /* 1167841 */     GIR_EraseRootFromParent_Done,
     /* 1167842 */   // Label 17028: @1167842
     /* 1167842 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1167922), // Rule ID 15903 //
     /* 1167847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1167858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1167861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1167864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167886 */     // MIs[0] round
     /* 1167886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167921 */     // GIR_Coverage, 15903,
     /* 1167921 */     GIR_EraseRootFromParent_Done,
     /* 1167922 */   // Label 17029: @1167922
     /* 1167922 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1168002), // Rule ID 15906 //
     /* 1167927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1167938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1167941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1167944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167966 */     // MIs[0] round
     /* 1167966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1167979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168001 */     // GIR_Coverage, 15906,
     /* 1168001 */     GIR_EraseRootFromParent_Done,
     /* 1168002 */   // Label 17030: @1168002
     /* 1168002 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1168082), // Rule ID 15907 //
     /* 1168007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168046 */     // MIs[0] round
     /* 1168046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168081 */     // GIR_Coverage, 15907,
     /* 1168081 */     GIR_EraseRootFromParent_Done,
     /* 1168082 */   // Label 17031: @1168082
     /* 1168082 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1168162), // Rule ID 15910 //
     /* 1168087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168126 */     // MIs[0] round
     /* 1168126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168161 */     // GIR_Coverage, 15910,
     /* 1168161 */     GIR_EraseRootFromParent_Done,
     /* 1168162 */   // Label 17032: @1168162
     /* 1168162 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1168242), // Rule ID 15911 //
     /* 1168167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168206 */     // MIs[0] round
     /* 1168206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168241 */     // GIR_Coverage, 15911,
     /* 1168241 */     GIR_EraseRootFromParent_Done,
     /* 1168242 */   // Label 17033: @1168242
     /* 1168242 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1168322), // Rule ID 15914 //
     /* 1168247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168286 */     // MIs[0] round
     /* 1168286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168321 */     // GIR_Coverage, 15914,
     /* 1168321 */     GIR_EraseRootFromParent_Done,
     /* 1168322 */   // Label 17034: @1168322
     /* 1168322 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1168402), // Rule ID 15915 //
     /* 1168327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168366 */     // MIs[0] round
     /* 1168366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168376 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11540:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168401 */     // GIR_Coverage, 15915,
     /* 1168401 */     GIR_EraseRootFromParent_Done,
     /* 1168402 */   // Label 17035: @1168402
     /* 1168402 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1168482), // Rule ID 15918 //
     /* 1168407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168446 */     // MIs[0] round
     /* 1168446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168481 */     // GIR_Coverage, 15918,
     /* 1168481 */     GIR_EraseRootFromParent_Done,
     /* 1168482 */   // Label 17036: @1168482
     /* 1168482 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1168562), // Rule ID 15919 //
     /* 1168487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168526 */     // MIs[0] round
     /* 1168526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168561 */     // GIR_Coverage, 15919,
     /* 1168561 */     GIR_EraseRootFromParent_Done,
     /* 1168562 */   // Label 17037: @1168562
     /* 1168562 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1168642), // Rule ID 15922 //
     /* 1168567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168606 */     // MIs[0] round
     /* 1168606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168641 */     // GIR_Coverage, 15922,
     /* 1168641 */     GIR_EraseRootFromParent_Done,
     /* 1168642 */   // Label 17038: @1168642
     /* 1168642 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1168722), // Rule ID 15923 //
     /* 1168647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168686 */     // MIs[0] round
     /* 1168686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168721 */     // GIR_Coverage, 15923,
     /* 1168721 */     GIR_EraseRootFromParent_Done,
     /* 1168722 */   // Label 17039: @1168722
     /* 1168722 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1168802), // Rule ID 15926 //
     /* 1168727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1168730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1168738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1168741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1168744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168766 */     // MIs[0] round
     /* 1168766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168801 */     // GIR_Coverage, 15926,
     /* 1168801 */     GIR_EraseRootFromParent_Done,
     /* 1168802 */   // Label 17040: @1168802
     /* 1168802 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1168882), // Rule ID 15927 //
     /* 1168807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1168810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1168818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1168821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1168824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168846 */     // MIs[0] round
     /* 1168846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168881 */     // GIR_Coverage, 15927,
     /* 1168881 */     GIR_EraseRootFromParent_Done,
     /* 1168882 */   // Label 17041: @1168882
     /* 1168882 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1168962), // Rule ID 15930 //
     /* 1168887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1168898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1168901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168926 */     // MIs[0] round
     /* 1168926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1168939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168961 */     // GIR_Coverage, 15930,
     /* 1168961 */     GIR_EraseRootFromParent_Done,
     /* 1168962 */   // Label 17042: @1168962
     /* 1168962 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1169042), // Rule ID 15931 //
     /* 1168967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1168978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1168981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169006 */     // MIs[0] round
     /* 1169006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169041 */     // GIR_Coverage, 15931,
     /* 1169041 */     GIR_EraseRootFromParent_Done,
     /* 1169042 */   // Label 17043: @1169042
     /* 1169042 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1169122), // Rule ID 15934 //
     /* 1169047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169086 */     // MIs[0] round
     /* 1169086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169121 */     // GIR_Coverage, 15934,
     /* 1169121 */     GIR_EraseRootFromParent_Done,
     /* 1169122 */   // Label 17044: @1169122
     /* 1169122 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1169202), // Rule ID 15935 //
     /* 1169127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169166 */     // MIs[0] round
     /* 1169166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169201 */     // GIR_Coverage, 15935,
     /* 1169201 */     GIR_EraseRootFromParent_Done,
     /* 1169202 */   // Label 17045: @1169202
     /* 1169202 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1169282), // Rule ID 15938 //
     /* 1169207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169246 */     // MIs[0] round
     /* 1169246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169256 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169281 */     // GIR_Coverage, 15938,
     /* 1169281 */     GIR_EraseRootFromParent_Done,
     /* 1169282 */   // Label 17046: @1169282
     /* 1169282 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1169362), // Rule ID 15939 //
     /* 1169287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169326 */     // MIs[0] round
     /* 1169326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169336 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169361 */     // GIR_Coverage, 15939,
     /* 1169361 */     GIR_EraseRootFromParent_Done,
     /* 1169362 */   // Label 17047: @1169362
     /* 1169362 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1169442), // Rule ID 15942 //
     /* 1169367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169406 */     // MIs[0] round
     /* 1169406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169441 */     // GIR_Coverage, 15942,
     /* 1169441 */     GIR_EraseRootFromParent_Done,
     /* 1169442 */   // Label 17048: @1169442
     /* 1169442 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1169522), // Rule ID 15943 //
     /* 1169447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169486 */     // MIs[0] round
     /* 1169486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169521 */     // GIR_Coverage, 15943,
     /* 1169521 */     GIR_EraseRootFromParent_Done,
     /* 1169522 */   // Label 17049: @1169522
     /* 1169522 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1169602), // Rule ID 15946 //
     /* 1169527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169566 */     // MIs[0] round
     /* 1169566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169601 */     // GIR_Coverage, 15946,
     /* 1169601 */     GIR_EraseRootFromParent_Done,
     /* 1169602 */   // Label 17050: @1169602
     /* 1169602 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1169682), // Rule ID 15947 //
     /* 1169607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169646 */     // MIs[0] round
     /* 1169646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169681 */     // GIR_Coverage, 15947,
     /* 1169681 */     GIR_EraseRootFromParent_Done,
     /* 1169682 */   // Label 17051: @1169682
     /* 1169682 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1169762), // Rule ID 15950 //
     /* 1169687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1169698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1169701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1169704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169726 */     // MIs[0] round
     /* 1169726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169761 */     // GIR_Coverage, 15950,
     /* 1169761 */     GIR_EraseRootFromParent_Done,
     /* 1169762 */   // Label 17052: @1169762
     /* 1169762 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1169842), // Rule ID 15951 //
     /* 1169767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1169778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1169781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1169784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169806 */     // MIs[0] round
     /* 1169806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169816 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169841 */     // GIR_Coverage, 15951,
     /* 1169841 */     GIR_EraseRootFromParent_Done,
     /* 1169842 */   // Label 17053: @1169842
     /* 1169842 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1169922), // Rule ID 15954 //
     /* 1169847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1169858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1169861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169886 */     // MIs[0] round
     /* 1169886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169921 */     // GIR_Coverage, 15954,
     /* 1169921 */     GIR_EraseRootFromParent_Done,
     /* 1169922 */   // Label 17054: @1169922
     /* 1169922 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1170002), // Rule ID 15955 //
     /* 1169927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1169938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1169941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169966 */     // MIs[0] round
     /* 1169966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169976 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170001 */     // GIR_Coverage, 15955,
     /* 1170001 */     GIR_EraseRootFromParent_Done,
     /* 1170002 */   // Label 17055: @1170002
     /* 1170002 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1170082), // Rule ID 15958 //
     /* 1170007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170046 */     // MIs[0] round
     /* 1170046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170081 */     // GIR_Coverage, 15958,
     /* 1170081 */     GIR_EraseRootFromParent_Done,
     /* 1170082 */   // Label 17056: @1170082
     /* 1170082 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1170162), // Rule ID 15959 //
     /* 1170087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170126 */     // MIs[0] round
     /* 1170126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170161 */     // GIR_Coverage, 15959,
     /* 1170161 */     GIR_EraseRootFromParent_Done,
     /* 1170162 */   // Label 17057: @1170162
     /* 1170162 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1170242), // Rule ID 15962 //
     /* 1170167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170206 */     // MIs[0] round
     /* 1170206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170241 */     // GIR_Coverage, 15962,
     /* 1170241 */     GIR_EraseRootFromParent_Done,
     /* 1170242 */   // Label 17058: @1170242
     /* 1170242 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1170322), // Rule ID 15963 //
     /* 1170247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170286 */     // MIs[0] round
     /* 1170286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170321 */     // GIR_Coverage, 15963,
     /* 1170321 */     GIR_EraseRootFromParent_Done,
     /* 1170322 */   // Label 17059: @1170322
     /* 1170322 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1170402), // Rule ID 15966 //
     /* 1170327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170366 */     // MIs[0] round
     /* 1170366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170401 */     // GIR_Coverage, 15966,
     /* 1170401 */     GIR_EraseRootFromParent_Done,
     /* 1170402 */   // Label 17060: @1170402
     /* 1170402 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1170482), // Rule ID 15967 //
     /* 1170407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170446 */     // MIs[0] round
     /* 1170446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170481 */     // GIR_Coverage, 15967,
     /* 1170481 */     GIR_EraseRootFromParent_Done,
     /* 1170482 */   // Label 17061: @1170482
     /* 1170482 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1170562), // Rule ID 15970 //
     /* 1170487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170526 */     // MIs[0] round
     /* 1170526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170561 */     // GIR_Coverage, 15970,
     /* 1170561 */     GIR_EraseRootFromParent_Done,
     /* 1170562 */   // Label 17062: @1170562
     /* 1170562 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1170642), // Rule ID 15971 //
     /* 1170567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170606 */     // MIs[0] round
     /* 1170606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170641 */     // GIR_Coverage, 15971,
     /* 1170641 */     GIR_EraseRootFromParent_Done,
     /* 1170642 */   // Label 17063: @1170642
     /* 1170642 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1170722), // Rule ID 15974 //
     /* 1170647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1170658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1170661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170686 */     // MIs[0] round
     /* 1170686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170696 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170721 */     // GIR_Coverage, 15974,
     /* 1170721 */     GIR_EraseRootFromParent_Done,
     /* 1170722 */   // Label 17064: @1170722
     /* 1170722 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1170802), // Rule ID 15975 //
     /* 1170727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1170738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1170741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170766 */     // MIs[0] round
     /* 1170766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170801 */     // GIR_Coverage, 15975,
     /* 1170801 */     GIR_EraseRootFromParent_Done,
     /* 1170802 */   // Label 17065: @1170802
     /* 1170802 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1170882), // Rule ID 16066 //
     /* 1170807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1170818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1170821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1170824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1170827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170846 */     // MIs[0] round
     /* 1170846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1170859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170881 */     // GIR_Coverage, 16066,
     /* 1170881 */     GIR_EraseRootFromParent_Done,
     /* 1170882 */   // Label 17066: @1170882
     /* 1170882 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1170962), // Rule ID 16067 //
     /* 1170887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1170898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1170901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1170904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1170907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170926 */     // MIs[0] round
     /* 1170926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1170939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170961 */     // GIR_Coverage, 16067,
     /* 1170961 */     GIR_EraseRootFromParent_Done,
     /* 1170962 */   // Label 17067: @1170962
     /* 1170962 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1171042), // Rule ID 16070 //
     /* 1170967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1170978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1170981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1170984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1170987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171006 */     // MIs[0] round
     /* 1171006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171016 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171041 */     // GIR_Coverage, 16070,
     /* 1171041 */     GIR_EraseRootFromParent_Done,
     /* 1171042 */   // Label 17068: @1171042
     /* 1171042 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1171122), // Rule ID 16071 //
     /* 1171047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171086 */     // MIs[0] round
     /* 1171086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171121 */     // GIR_Coverage, 16071,
     /* 1171121 */     GIR_EraseRootFromParent_Done,
     /* 1171122 */   // Label 17069: @1171122
     /* 1171122 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1171202), // Rule ID 16074 //
     /* 1171127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171166 */     // MIs[0] round
     /* 1171166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171176 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171201 */     // GIR_Coverage, 16074,
     /* 1171201 */     GIR_EraseRootFromParent_Done,
     /* 1171202 */   // Label 17070: @1171202
     /* 1171202 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1171282), // Rule ID 16075 //
     /* 1171207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171246 */     // MIs[0] round
     /* 1171246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171281 */     // GIR_Coverage, 16075,
     /* 1171281 */     GIR_EraseRootFromParent_Done,
     /* 1171282 */   // Label 17071: @1171282
     /* 1171282 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1171362), // Rule ID 16078 //
     /* 1171287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171326 */     // MIs[0] round
     /* 1171326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171361 */     // GIR_Coverage, 16078,
     /* 1171361 */     GIR_EraseRootFromParent_Done,
     /* 1171362 */   // Label 17072: @1171362
     /* 1171362 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1171442), // Rule ID 16079 //
     /* 1171367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171406 */     // MIs[0] round
     /* 1171406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171441 */     // GIR_Coverage, 16079,
     /* 1171441 */     GIR_EraseRootFromParent_Done,
     /* 1171442 */   // Label 17073: @1171442
     /* 1171442 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1171522), // Rule ID 16082 //
     /* 1171447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171486 */     // MIs[0] round
     /* 1171486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171496 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171521 */     // GIR_Coverage, 16082,
     /* 1171521 */     GIR_EraseRootFromParent_Done,
     /* 1171522 */   // Label 17074: @1171522
     /* 1171522 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1171602), // Rule ID 16083 //
     /* 1171527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171566 */     // MIs[0] round
     /* 1171566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171601 */     // GIR_Coverage, 16083,
     /* 1171601 */     GIR_EraseRootFromParent_Done,
     /* 1171602 */   // Label 17075: @1171602
     /* 1171602 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1171682), // Rule ID 16086 //
     /* 1171607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1171618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1171621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1171627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171646 */     // MIs[0] round
     /* 1171646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171681 */     // GIR_Coverage, 16086,
     /* 1171681 */     GIR_EraseRootFromParent_Done,
     /* 1171682 */   // Label 17076: @1171682
     /* 1171682 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1171762), // Rule ID 16087 //
     /* 1171687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1171698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1171701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1171707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171726 */     // MIs[0] round
     /* 1171726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171736 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171761 */     // GIR_Coverage, 16087,
     /* 1171761 */     GIR_EraseRootFromParent_Done,
     /* 1171762 */   // Label 17077: @1171762
     /* 1171762 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1171842), // Rule ID 16090 //
     /* 1171767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1171778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1171781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1171784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1171787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171806 */     // MIs[0] round
     /* 1171806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1171819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171841 */     // GIR_Coverage, 16090,
     /* 1171841 */     GIR_EraseRootFromParent_Done,
     /* 1171842 */   // Label 17078: @1171842
     /* 1171842 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1171922), // Rule ID 16091 //
     /* 1171847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1171858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1171861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1171864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1171867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171886 */     // MIs[0] round
     /* 1171886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1171899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171921 */     // GIR_Coverage, 16091,
     /* 1171921 */     GIR_EraseRootFromParent_Done,
     /* 1171922 */   // Label 17079: @1171922
     /* 1171922 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1172002), // Rule ID 16094 //
     /* 1171927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1171938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1171941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1171944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1171947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171966 */     // MIs[0] round
     /* 1171966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1171979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172001 */     // GIR_Coverage, 16094,
     /* 1172001 */     GIR_EraseRootFromParent_Done,
     /* 1172002 */   // Label 17080: @1172002
     /* 1172002 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1172082), // Rule ID 16095 //
     /* 1172007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172046 */     // MIs[0] round
     /* 1172046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172081 */     // GIR_Coverage, 16095,
     /* 1172081 */     GIR_EraseRootFromParent_Done,
     /* 1172082 */   // Label 17081: @1172082
     /* 1172082 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1172162), // Rule ID 16098 //
     /* 1172087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172126 */     // MIs[0] round
     /* 1172126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172161 */     // GIR_Coverage, 16098,
     /* 1172161 */     GIR_EraseRootFromParent_Done,
     /* 1172162 */   // Label 17082: @1172162
     /* 1172162 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1172242), // Rule ID 16099 //
     /* 1172167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172206 */     // MIs[0] round
     /* 1172206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172241 */     // GIR_Coverage, 16099,
     /* 1172241 */     GIR_EraseRootFromParent_Done,
     /* 1172242 */   // Label 17083: @1172242
     /* 1172242 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1172322), // Rule ID 16102 //
     /* 1172247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1172250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172286 */     // MIs[0] round
     /* 1172286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172321 */     // GIR_Coverage, 16102,
     /* 1172321 */     GIR_EraseRootFromParent_Done,
     /* 1172322 */   // Label 17084: @1172322
     /* 1172322 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1172402), // Rule ID 16103 //
     /* 1172327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1172330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172366 */     // MIs[0] round
     /* 1172366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172401 */     // GIR_Coverage, 16103,
     /* 1172401 */     GIR_EraseRootFromParent_Done,
     /* 1172402 */   // Label 17085: @1172402
     /* 1172402 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1172482), // Rule ID 16106 //
     /* 1172407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172446 */     // MIs[0] round
     /* 1172446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172481 */     // GIR_Coverage, 16106,
     /* 1172481 */     GIR_EraseRootFromParent_Done,
     /* 1172482 */   // Label 17086: @1172482
     /* 1172482 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1172562), // Rule ID 16107 //
     /* 1172487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172526 */     // MIs[0] round
     /* 1172526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172561 */     // GIR_Coverage, 16107,
     /* 1172561 */     GIR_EraseRootFromParent_Done,
     /* 1172562 */   // Label 17087: @1172562
     /* 1172562 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1172642), // Rule ID 16110 //
     /* 1172567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172606 */     // MIs[0] round
     /* 1172606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172616 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1172619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172641 */     // GIR_Coverage, 16110,
     /* 1172641 */     GIR_EraseRootFromParent_Done,
     /* 1172642 */   // Label 17088: @1172642
     /* 1172642 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1172722), // Rule ID 16111 //
     /* 1172647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172686 */     // MIs[0] round
     /* 1172686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1172699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172721 */     // GIR_Coverage, 16111,
     /* 1172721 */     GIR_EraseRootFromParent_Done,
     /* 1172722 */   // Label 17089: @1172722
     /* 1172722 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1172802), // Rule ID 16114 //
     /* 1172727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1172738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1172741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1172744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1172747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172766 */     // MIs[0] round
     /* 1172766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172776 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1172779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172801 */     // GIR_Coverage, 16114,
     /* 1172801 */     GIR_EraseRootFromParent_Done,
     /* 1172802 */   // Label 17090: @1172802
     /* 1172802 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1172882), // Rule ID 16115 //
     /* 1172807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1172818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1172821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1172824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1172827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172846 */     // MIs[0] round
     /* 1172846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1172859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172881 */     // GIR_Coverage, 16115,
     /* 1172881 */     GIR_EraseRootFromParent_Done,
     /* 1172882 */   // Label 17091: @1172882
     /* 1172882 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1172962), // Rule ID 16118 //
     /* 1172887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1172898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1172901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1172907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172926 */     // MIs[0] round
     /* 1172926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172961 */     // GIR_Coverage, 16118,
     /* 1172961 */     GIR_EraseRootFromParent_Done,
     /* 1172962 */   // Label 17092: @1172962
     /* 1172962 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1173042), // Rule ID 16119 //
     /* 1172967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1172978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1172981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1172987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173006 */     // MIs[0] round
     /* 1173006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173041 */     // GIR_Coverage, 16119,
     /* 1173041 */     GIR_EraseRootFromParent_Done,
     /* 1173042 */   // Label 17093: @1173042
     /* 1173042 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1173122), // Rule ID 16122 //
     /* 1173047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173086 */     // MIs[0] round
     /* 1173086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173121 */     // GIR_Coverage, 16122,
     /* 1173121 */     GIR_EraseRootFromParent_Done,
     /* 1173122 */   // Label 17094: @1173122
     /* 1173122 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1173202), // Rule ID 16123 //
     /* 1173127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173166 */     // MIs[0] round
     /* 1173166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173201 */     // GIR_Coverage, 16123,
     /* 1173201 */     GIR_EraseRootFromParent_Done,
     /* 1173202 */   // Label 17095: @1173202
     /* 1173202 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1173282), // Rule ID 16126 //
     /* 1173207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173246 */     // MIs[0] round
     /* 1173246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173281 */     // GIR_Coverage, 16126,
     /* 1173281 */     GIR_EraseRootFromParent_Done,
     /* 1173282 */   // Label 17096: @1173282
     /* 1173282 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1173362), // Rule ID 16127 //
     /* 1173287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173326 */     // MIs[0] round
     /* 1173326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173361 */     // GIR_Coverage, 16127,
     /* 1173361 */     GIR_EraseRootFromParent_Done,
     /* 1173362 */   // Label 17097: @1173362
     /* 1173362 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1173442), // Rule ID 16130 //
     /* 1173367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173406 */     // MIs[0] round
     /* 1173406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173441 */     // GIR_Coverage, 16130,
     /* 1173441 */     GIR_EraseRootFromParent_Done,
     /* 1173442 */   // Label 17098: @1173442
     /* 1173442 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1173522), // Rule ID 16131 //
     /* 1173447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173486 */     // MIs[0] round
     /* 1173486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173521 */     // GIR_Coverage, 16131,
     /* 1173521 */     GIR_EraseRootFromParent_Done,
     /* 1173522 */   // Label 17099: @1173522
     /* 1173522 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1173602), // Rule ID 16134 //
     /* 1173527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173566 */     // MIs[0] round
     /* 1173566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173601 */     // GIR_Coverage, 16134,
     /* 1173601 */     GIR_EraseRootFromParent_Done,
     /* 1173602 */   // Label 17100: @1173602
     /* 1173602 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1173682), // Rule ID 16135 //
     /* 1173607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173646 */     // MIs[0] round
     /* 1173646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173681 */     // GIR_Coverage, 16135,
     /* 1173681 */     GIR_EraseRootFromParent_Done,
     /* 1173682 */   // Label 17101: @1173682
     /* 1173682 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1173762), // Rule ID 16138 //
     /* 1173687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1173698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1173701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1173704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1173707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173726 */     // MIs[0] round
     /* 1173726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173761 */     // GIR_Coverage, 16138,
     /* 1173761 */     GIR_EraseRootFromParent_Done,
     /* 1173762 */   // Label 17102: @1173762
     /* 1173762 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1173842), // Rule ID 16139 //
     /* 1173767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1173778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1173781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1173784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1173787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173806 */     // MIs[0] round
     /* 1173806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173841 */     // GIR_Coverage, 16139,
     /* 1173841 */     GIR_EraseRootFromParent_Done,
     /* 1173842 */   // Label 17103: @1173842
     /* 1173842 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1173922), // Rule ID 16142 //
     /* 1173847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1173858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1173861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1173867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173886 */     // MIs[0] round
     /* 1173886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173921 */     // GIR_Coverage, 16142,
     /* 1173921 */     GIR_EraseRootFromParent_Done,
     /* 1173922 */   // Label 17104: @1173922
     /* 1173922 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1174002), // Rule ID 16143 //
     /* 1173927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1173938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1173941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1173947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173966 */     // MIs[0] round
     /* 1173966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174001 */     // GIR_Coverage, 16143,
     /* 1174001 */     GIR_EraseRootFromParent_Done,
     /* 1174002 */   // Label 17105: @1174002
     /* 1174002 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1174082), // Rule ID 16146 //
     /* 1174007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174046 */     // MIs[0] round
     /* 1174046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174056 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174081 */     // GIR_Coverage, 16146,
     /* 1174081 */     GIR_EraseRootFromParent_Done,
     /* 1174082 */   // Label 17106: @1174082
     /* 1174082 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1174162), // Rule ID 16147 //
     /* 1174087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174126 */     // MIs[0] round
     /* 1174126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174161 */     // GIR_Coverage, 16147,
     /* 1174161 */     GIR_EraseRootFromParent_Done,
     /* 1174162 */   // Label 17107: @1174162
     /* 1174162 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1174242), // Rule ID 16150 //
     /* 1174167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174206 */     // MIs[0] round
     /* 1174206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174241 */     // GIR_Coverage, 16150,
     /* 1174241 */     GIR_EraseRootFromParent_Done,
     /* 1174242 */   // Label 17108: @1174242
     /* 1174242 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1174322), // Rule ID 16151 //
     /* 1174247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174286 */     // MIs[0] round
     /* 1174286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174321 */     // GIR_Coverage, 16151,
     /* 1174321 */     GIR_EraseRootFromParent_Done,
     /* 1174322 */   // Label 17109: @1174322
     /* 1174322 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1174402), // Rule ID 16154 //
     /* 1174327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174366 */     // MIs[0] round
     /* 1174366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174401 */     // GIR_Coverage, 16154,
     /* 1174401 */     GIR_EraseRootFromParent_Done,
     /* 1174402 */   // Label 17110: @1174402
     /* 1174402 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1174482), // Rule ID 16155 //
     /* 1174407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174446 */     // MIs[0] round
     /* 1174446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174456 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174481 */     // GIR_Coverage, 16155,
     /* 1174481 */     GIR_EraseRootFromParent_Done,
     /* 1174482 */   // Label 17111: @1174482
     /* 1174482 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1174562), // Rule ID 16158 //
     /* 1174487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174526 */     // MIs[0] round
     /* 1174526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174561 */     // GIR_Coverage, 16158,
     /* 1174561 */     GIR_EraseRootFromParent_Done,
     /* 1174562 */   // Label 17112: @1174562
     /* 1174562 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1174642), // Rule ID 16159 //
     /* 1174567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174606 */     // MIs[0] round
     /* 1174606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174641 */     // GIR_Coverage, 16159,
     /* 1174641 */     GIR_EraseRootFromParent_Done,
     /* 1174642 */   // Label 17113: @1174642
     /* 1174642 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1174722), // Rule ID 16162 //
     /* 1174647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1174658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1174661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174686 */     // MIs[0] round
     /* 1174686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174696 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1174699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174721 */     // GIR_Coverage, 16162,
     /* 1174721 */     GIR_EraseRootFromParent_Done,
     /* 1174722 */   // Label 17114: @1174722
     /* 1174722 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1174802), // Rule ID 16163 //
     /* 1174727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1174738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1174741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174766 */     // MIs[0] round
     /* 1174766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1174779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174801 */     // GIR_Coverage, 16163,
     /* 1174801 */     GIR_EraseRootFromParent_Done,
     /* 1174802 */   // Label 17115: @1174802
     /* 1174802 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1174882), // Rule ID 16166 //
     /* 1174807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1174818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1174821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1174824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174846 */     // MIs[0] round
     /* 1174846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174881 */     // GIR_Coverage, 16166,
     /* 1174881 */     GIR_EraseRootFromParent_Done,
     /* 1174882 */   // Label 17116: @1174882
     /* 1174882 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1174962), // Rule ID 16167 //
     /* 1174887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1174898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1174901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1174904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174926 */     // MIs[0] round
     /* 1174926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174961 */     // GIR_Coverage, 16167,
     /* 1174961 */     GIR_EraseRootFromParent_Done,
     /* 1174962 */   // Label 17117: @1174962
     /* 1174962 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1175042), // Rule ID 16170 //
     /* 1174967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1174978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1174981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1174984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175006 */     // MIs[0] round
     /* 1175006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175041 */     // GIR_Coverage, 16170,
     /* 1175041 */     GIR_EraseRootFromParent_Done,
     /* 1175042 */   // Label 17118: @1175042
     /* 1175042 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1175122), // Rule ID 16171 //
     /* 1175047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175086 */     // MIs[0] round
     /* 1175086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175121 */     // GIR_Coverage, 16171,
     /* 1175121 */     GIR_EraseRootFromParent_Done,
     /* 1175122 */   // Label 17119: @1175122
     /* 1175122 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1175202), // Rule ID 16174 //
     /* 1175127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175166 */     // MIs[0] round
     /* 1175166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175201 */     // GIR_Coverage, 16174,
     /* 1175201 */     GIR_EraseRootFromParent_Done,
     /* 1175202 */   // Label 17120: @1175202
     /* 1175202 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1175282), // Rule ID 16175 //
     /* 1175207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175246 */     // MIs[0] round
     /* 1175246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175281 */     // GIR_Coverage, 16175,
     /* 1175281 */     GIR_EraseRootFromParent_Done,
     /* 1175282 */   // Label 17121: @1175282
     /* 1175282 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1175362), // Rule ID 16178 //
     /* 1175287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175326 */     // MIs[0] round
     /* 1175326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175361 */     // GIR_Coverage, 16178,
     /* 1175361 */     GIR_EraseRootFromParent_Done,
     /* 1175362 */   // Label 17122: @1175362
     /* 1175362 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1175442), // Rule ID 16179 //
     /* 1175367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175406 */     // MIs[0] round
     /* 1175406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175416 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11538:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175441 */     // GIR_Coverage, 16179,
     /* 1175441 */     GIR_EraseRootFromParent_Done,
     /* 1175442 */   // Label 17123: @1175442
     /* 1175442 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1175522), // Rule ID 16182 //
     /* 1175447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175486 */     // MIs[0] round
     /* 1175486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175521 */     // GIR_Coverage, 16182,
     /* 1175521 */     GIR_EraseRootFromParent_Done,
     /* 1175522 */   // Label 17124: @1175522
     /* 1175522 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1175602), // Rule ID 16183 //
     /* 1175527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175566 */     // MIs[0] round
     /* 1175566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11538:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175601 */     // GIR_Coverage, 16183,
     /* 1175601 */     GIR_EraseRootFromParent_Done,
     /* 1175602 */   // Label 17125: @1175602
     /* 1175602 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1175682), // Rule ID 16186 //
     /* 1175607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175646 */     // MIs[0] round
     /* 1175646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175681 */     // GIR_Coverage, 16186,
     /* 1175681 */     GIR_EraseRootFromParent_Done,
     /* 1175682 */   // Label 17126: @1175682
     /* 1175682 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1175762), // Rule ID 16187 //
     /* 1175687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175726 */     // MIs[0] round
     /* 1175726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11538:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175761 */     // GIR_Coverage, 16187,
     /* 1175761 */     GIR_EraseRootFromParent_Done,
     /* 1175762 */   // Label 17127: @1175762
     /* 1175762 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1175842), // Rule ID 16190 //
     /* 1175767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1175770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1175778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1175781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175806 */     // MIs[0] round
     /* 1175806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175841 */     // GIR_Coverage, 16190,
     /* 1175841 */     GIR_EraseRootFromParent_Done,
     /* 1175842 */   // Label 17128: @1175842
     /* 1175842 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1175922), // Rule ID 16191 //
     /* 1175847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1175850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1175858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1175861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175886 */     // MIs[0] round
     /* 1175886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11538:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1175917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175921 */     // GIR_Coverage, 16191,
     /* 1175921 */     GIR_EraseRootFromParent_Done,
     /* 1175922 */   // Label 17129: @1175922
     /* 1175922 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1176002), // Rule ID 16194 //
     /* 1175927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1175938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1175941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1175944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175966 */     // MIs[0] round
     /* 1175966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1175979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176001 */     // GIR_Coverage, 16194,
     /* 1176001 */     GIR_EraseRootFromParent_Done,
     /* 1176002 */   // Label 17130: @1176002
     /* 1176002 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1176082), // Rule ID 16195 //
     /* 1176007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176046 */     // MIs[0] round
     /* 1176046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176081 */     // GIR_Coverage, 16195,
     /* 1176081 */     GIR_EraseRootFromParent_Done,
     /* 1176082 */   // Label 17131: @1176082
     /* 1176082 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1176162), // Rule ID 16198 //
     /* 1176087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176126 */     // MIs[0] round
     /* 1176126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176161 */     // GIR_Coverage, 16198,
     /* 1176161 */     GIR_EraseRootFromParent_Done,
     /* 1176162 */   // Label 17132: @1176162
     /* 1176162 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1176242), // Rule ID 16199 //
     /* 1176167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176206 */     // MIs[0] round
     /* 1176206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176241 */     // GIR_Coverage, 16199,
     /* 1176241 */     GIR_EraseRootFromParent_Done,
     /* 1176242 */   // Label 17133: @1176242
     /* 1176242 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1176322), // Rule ID 16202 //
     /* 1176247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176286 */     // MIs[0] round
     /* 1176286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176296 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176321 */     // GIR_Coverage, 16202,
     /* 1176321 */     GIR_EraseRootFromParent_Done,
     /* 1176322 */   // Label 17134: @1176322
     /* 1176322 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1176402), // Rule ID 16203 //
     /* 1176327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176366 */     // MIs[0] round
     /* 1176366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176376 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176401 */     // GIR_Coverage, 16203,
     /* 1176401 */     GIR_EraseRootFromParent_Done,
     /* 1176402 */   // Label 17135: @1176402
     /* 1176402 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1176482), // Rule ID 16206 //
     /* 1176407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176446 */     // MIs[0] round
     /* 1176446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176481 */     // GIR_Coverage, 16206,
     /* 1176481 */     GIR_EraseRootFromParent_Done,
     /* 1176482 */   // Label 17136: @1176482
     /* 1176482 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1176562), // Rule ID 16207 //
     /* 1176487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176526 */     // MIs[0] round
     /* 1176526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176561 */     // GIR_Coverage, 16207,
     /* 1176561 */     GIR_EraseRootFromParent_Done,
     /* 1176562 */   // Label 17137: @1176562
     /* 1176562 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1176642), // Rule ID 16210 //
     /* 1176567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176606 */     // MIs[0] round
     /* 1176606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176641 */     // GIR_Coverage, 16210,
     /* 1176641 */     GIR_EraseRootFromParent_Done,
     /* 1176642 */   // Label 17138: @1176642
     /* 1176642 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1176722), // Rule ID 16211 //
     /* 1176647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176686 */     // MIs[0] round
     /* 1176686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176721 */     // GIR_Coverage, 16211,
     /* 1176721 */     GIR_EraseRootFromParent_Done,
     /* 1176722 */   // Label 17139: @1176722
     /* 1176722 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1176802), // Rule ID 16214 //
     /* 1176727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1176738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1176741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176766 */     // MIs[0] round
     /* 1176766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176801 */     // GIR_Coverage, 16214,
     /* 1176801 */     GIR_EraseRootFromParent_Done,
     /* 1176802 */   // Label 17140: @1176802
     /* 1176802 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1176882), // Rule ID 16215 //
     /* 1176807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1176818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1176821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176846 */     // MIs[0] round
     /* 1176846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176881 */     // GIR_Coverage, 16215,
     /* 1176881 */     GIR_EraseRootFromParent_Done,
     /* 1176882 */   // Label 17141: @1176882
     /* 1176882 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1176962), // Rule ID 16218 //
     /* 1176887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1176898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1176901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1176904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176926 */     // MIs[0] round
     /* 1176926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176961 */     // GIR_Coverage, 16218,
     /* 1176961 */     GIR_EraseRootFromParent_Done,
     /* 1176962 */   // Label 17142: @1176962
     /* 1176962 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1177042), // Rule ID 16219 //
     /* 1176967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1176978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1176981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1176984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177006 */     // MIs[0] round
     /* 1177006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177041 */     // GIR_Coverage, 16219,
     /* 1177041 */     GIR_EraseRootFromParent_Done,
     /* 1177042 */   // Label 17143: @1177042
     /* 1177042 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1177122), // Rule ID 16222 //
     /* 1177047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177086 */     // MIs[0] round
     /* 1177086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177121 */     // GIR_Coverage, 16222,
     /* 1177121 */     GIR_EraseRootFromParent_Done,
     /* 1177122 */   // Label 17144: @1177122
     /* 1177122 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1177202), // Rule ID 16223 //
     /* 1177127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177166 */     // MIs[0] round
     /* 1177166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177201 */     // GIR_Coverage, 16223,
     /* 1177201 */     GIR_EraseRootFromParent_Done,
     /* 1177202 */   // Label 17145: @1177202
     /* 1177202 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1177282), // Rule ID 16226 //
     /* 1177207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177246 */     // MIs[0] round
     /* 1177246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177281 */     // GIR_Coverage, 16226,
     /* 1177281 */     GIR_EraseRootFromParent_Done,
     /* 1177282 */   // Label 17146: @1177282
     /* 1177282 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1177362), // Rule ID 16227 //
     /* 1177287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177326 */     // MIs[0] round
     /* 1177326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177361 */     // GIR_Coverage, 16227,
     /* 1177361 */     GIR_EraseRootFromParent_Done,
     /* 1177362 */   // Label 17147: @1177362
     /* 1177362 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1177442), // Rule ID 16230 //
     /* 1177367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177406 */     // MIs[0] round
     /* 1177406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177441 */     // GIR_Coverage, 16230,
     /* 1177441 */     GIR_EraseRootFromParent_Done,
     /* 1177442 */   // Label 17148: @1177442
     /* 1177442 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1177522), // Rule ID 16231 //
     /* 1177447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177486 */     // MIs[0] round
     /* 1177486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11538:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177521 */     // GIR_Coverage, 16231,
     /* 1177521 */     GIR_EraseRootFromParent_Done,
     /* 1177522 */   // Label 17149: @1177522
     /* 1177522 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1177602), // Rule ID 16234 //
     /* 1177527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177566 */     // MIs[0] round
     /* 1177566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177601 */     // GIR_Coverage, 16234,
     /* 1177601 */     GIR_EraseRootFromParent_Done,
     /* 1177602 */   // Label 17150: @1177602
     /* 1177602 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1177682), // Rule ID 16235 //
     /* 1177607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177646 */     // MIs[0] round
     /* 1177646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11538:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177681 */     // GIR_Coverage, 16235,
     /* 1177681 */     GIR_EraseRootFromParent_Done,
     /* 1177682 */   // Label 17151: @1177682
     /* 1177682 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1177762), // Rule ID 16238 //
     /* 1177687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1177698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1177701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1177704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177726 */     // MIs[0] round
     /* 1177726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177761 */     // GIR_Coverage, 16238,
     /* 1177761 */     GIR_EraseRootFromParent_Done,
     /* 1177762 */   // Label 17152: @1177762
     /* 1177762 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1177842), // Rule ID 16239 //
     /* 1177767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1177778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1177781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1177784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177806 */     // MIs[0] round
     /* 1177806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11538:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177841 */     // GIR_Coverage, 16239,
     /* 1177841 */     GIR_EraseRootFromParent_Done,
     /* 1177842 */   // Label 17153: @1177842
     /* 1177842 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1177925), // Rule ID 16330 //
     /* 1177847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1177858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1177861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1177864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1177867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177886 */     // MIs[0] round
     /* 1177886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177896 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1177899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1177917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177924 */     // GIR_Coverage, 16330,
     /* 1177924 */     GIR_EraseRootFromParent_Done,
     /* 1177925 */   // Label 17154: @1177925
     /* 1177925 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1178008), // Rule ID 16331 //
     /* 1177930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1177941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1177944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1177947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1177950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177969 */     // MIs[0] round
     /* 1177969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177979 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1177982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177990 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178007 */     // GIR_Coverage, 16331,
     /* 1178007 */     GIR_EraseRootFromParent_Done,
     /* 1178008 */   // Label 17155: @1178008
     /* 1178008 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1178091), // Rule ID 16334 //
     /* 1178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178052 */     // MIs[0] round
     /* 1178052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178090 */     // GIR_Coverage, 16334,
     /* 1178090 */     GIR_EraseRootFromParent_Done,
     /* 1178091 */   // Label 17156: @1178091
     /* 1178091 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1178174), // Rule ID 16335 //
     /* 1178096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178135 */     // MIs[0] round
     /* 1178135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178145 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178156 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178173 */     // GIR_Coverage, 16335,
     /* 1178173 */     GIR_EraseRootFromParent_Done,
     /* 1178174 */   // Label 17157: @1178174
     /* 1178174 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1178257), // Rule ID 16338 //
     /* 1178179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178218 */     // MIs[0] round
     /* 1178218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178256 */     // GIR_Coverage, 16338,
     /* 1178256 */     GIR_EraseRootFromParent_Done,
     /* 1178257 */   // Label 17158: @1178257
     /* 1178257 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1178340), // Rule ID 16339 //
     /* 1178262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178301 */     // MIs[0] round
     /* 1178301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178311 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178322 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178339 */     // GIR_Coverage, 16339,
     /* 1178339 */     GIR_EraseRootFromParent_Done,
     /* 1178340 */   // Label 17159: @1178340
     /* 1178340 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1178423), // Rule ID 16342 //
     /* 1178345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178384 */     // MIs[0] round
     /* 1178384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178394 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178422 */     // GIR_Coverage, 16342,
     /* 1178422 */     GIR_EraseRootFromParent_Done,
     /* 1178423 */   // Label 17160: @1178423
     /* 1178423 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1178506), // Rule ID 16343 //
     /* 1178428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178467 */     // MIs[0] round
     /* 1178467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178477 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178488 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178505 */     // GIR_Coverage, 16343,
     /* 1178505 */     GIR_EraseRootFromParent_Done,
     /* 1178506 */   // Label 17161: @1178506
     /* 1178506 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1178589), // Rule ID 16346 //
     /* 1178511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178550 */     // MIs[0] round
     /* 1178550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178588 */     // GIR_Coverage, 16346,
     /* 1178588 */     GIR_EraseRootFromParent_Done,
     /* 1178589 */   // Label 17162: @1178589
     /* 1178589 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1178672), // Rule ID 16347 //
     /* 1178594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178633 */     // MIs[0] round
     /* 1178633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178643 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178654 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178671 */     // GIR_Coverage, 16347,
     /* 1178671 */     GIR_EraseRootFromParent_Done,
     /* 1178672 */   // Label 17163: @1178672
     /* 1178672 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1178755), // Rule ID 16350 //
     /* 1178677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1178688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1178691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1178694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1178697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178716 */     // MIs[0] round
     /* 1178716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178726 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1178729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178754 */     // GIR_Coverage, 16350,
     /* 1178754 */     GIR_EraseRootFromParent_Done,
     /* 1178755 */   // Label 17164: @1178755
     /* 1178755 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1178838), // Rule ID 16351 //
     /* 1178760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1178771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1178774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1178777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1178780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178799 */     // MIs[0] round
     /* 1178799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178809 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1178812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178820 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178837 */     // GIR_Coverage, 16351,
     /* 1178837 */     GIR_EraseRootFromParent_Done,
     /* 1178838 */   // Label 17165: @1178838
     /* 1178838 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1178921), // Rule ID 16354 //
     /* 1178843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1178854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1178857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1178860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1178863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178882 */     // MIs[0] round
     /* 1178882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178920 */     // GIR_Coverage, 16354,
     /* 1178920 */     GIR_EraseRootFromParent_Done,
     /* 1178921 */   // Label 17166: @1178921
     /* 1178921 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1179004), // Rule ID 16355 //
     /* 1178926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1178937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1178940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1178943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1178946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178965 */     // MIs[0] round
     /* 1178965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178975 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178986 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1178996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179003 */     // GIR_Coverage, 16355,
     /* 1179003 */     GIR_EraseRootFromParent_Done,
     /* 1179004 */   // Label 17167: @1179004
     /* 1179004 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1179087), // Rule ID 16358 //
     /* 1179009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179048 */     // MIs[0] round
     /* 1179048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179086 */     // GIR_Coverage, 16358,
     /* 1179086 */     GIR_EraseRootFromParent_Done,
     /* 1179087 */   // Label 17168: @1179087
     /* 1179087 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1179170), // Rule ID 16359 //
     /* 1179092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179131 */     // MIs[0] round
     /* 1179131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179141 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179169 */     // GIR_Coverage, 16359,
     /* 1179169 */     GIR_EraseRootFromParent_Done,
     /* 1179170 */   // Label 17169: @1179170
     /* 1179170 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1179253), // Rule ID 16362 //
     /* 1179175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179214 */     // MIs[0] round
     /* 1179214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179252 */     // GIR_Coverage, 16362,
     /* 1179252 */     GIR_EraseRootFromParent_Done,
     /* 1179253 */   // Label 17170: @1179253
     /* 1179253 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1179336), // Rule ID 16363 //
     /* 1179258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179297 */     // MIs[0] round
     /* 1179297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179307 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179335 */     // GIR_Coverage, 16363,
     /* 1179335 */     GIR_EraseRootFromParent_Done,
     /* 1179336 */   // Label 17171: @1179336
     /* 1179336 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1179419), // Rule ID 16366 //
     /* 1179341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179380 */     // MIs[0] round
     /* 1179380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179418 */     // GIR_Coverage, 16366,
     /* 1179418 */     GIR_EraseRootFromParent_Done,
     /* 1179419 */   // Label 17172: @1179419
     /* 1179419 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1179502), // Rule ID 16367 //
     /* 1179424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179463 */     // MIs[0] round
     /* 1179463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179501 */     // GIR_Coverage, 16367,
     /* 1179501 */     GIR_EraseRootFromParent_Done,
     /* 1179502 */   // Label 17173: @1179502
     /* 1179502 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1179585), // Rule ID 16370 //
     /* 1179507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179546 */     // MIs[0] round
     /* 1179546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179584 */     // GIR_Coverage, 16370,
     /* 1179584 */     GIR_EraseRootFromParent_Done,
     /* 1179585 */   // Label 17174: @1179585
     /* 1179585 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1179668), // Rule ID 16371 //
     /* 1179590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179629 */     // MIs[0] round
     /* 1179629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179650 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179667 */     // GIR_Coverage, 16371,
     /* 1179667 */     GIR_EraseRootFromParent_Done,
     /* 1179668 */   // Label 17175: @1179668
     /* 1179668 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1179751), // Rule ID 16374 //
     /* 1179673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1179676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1179684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1179687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1179690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1179693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179712 */     // MIs[0] round
     /* 1179712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179750 */     // GIR_Coverage, 16374,
     /* 1179750 */     GIR_EraseRootFromParent_Done,
     /* 1179751 */   // Label 17176: @1179751
     /* 1179751 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1179834), // Rule ID 16375 //
     /* 1179756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1179759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1179767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1179770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1179773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1179776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179795 */     // MIs[0] round
     /* 1179795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179805 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179816 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179833 */     // GIR_Coverage, 16375,
     /* 1179833 */     GIR_EraseRootFromParent_Done,
     /* 1179834 */   // Label 17177: @1179834
     /* 1179834 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1179917), // Rule ID 16378 //
     /* 1179839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1179842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1179850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1179853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1179856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1179859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179878 */     // MIs[0] round
     /* 1179878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179916 */     // GIR_Coverage, 16378,
     /* 1179916 */     GIR_EraseRootFromParent_Done,
     /* 1179917 */   // Label 17178: @1179917
     /* 1179917 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1180000), // Rule ID 16379 //
     /* 1179922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1179925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1179933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1179936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1179939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1179942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179961 */     // MIs[0] round
     /* 1179961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179982 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1179992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179999 */     // GIR_Coverage, 16379,
     /* 1179999 */     GIR_EraseRootFromParent_Done,
     /* 1180000 */   // Label 17179: @1180000
     /* 1180000 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1180083), // Rule ID 16382 //
     /* 1180005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180044 */     // MIs[0] round
     /* 1180044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180082 */     // GIR_Coverage, 16382,
     /* 1180082 */     GIR_EraseRootFromParent_Done,
     /* 1180083 */   // Label 17180: @1180083
     /* 1180083 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1180166), // Rule ID 16383 //
     /* 1180088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180127 */     // MIs[0] round
     /* 1180127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180165 */     // GIR_Coverage, 16383,
     /* 1180165 */     GIR_EraseRootFromParent_Done,
     /* 1180166 */   // Label 17181: @1180166
     /* 1180166 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1180249), // Rule ID 16386 //
     /* 1180171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180210 */     // MIs[0] round
     /* 1180210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180248 */     // GIR_Coverage, 16386,
     /* 1180248 */     GIR_EraseRootFromParent_Done,
     /* 1180249 */   // Label 17182: @1180249
     /* 1180249 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1180332), // Rule ID 16387 //
     /* 1180254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180293 */     // MIs[0] round
     /* 1180293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180303 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180314 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180331 */     // GIR_Coverage, 16387,
     /* 1180331 */     GIR_EraseRootFromParent_Done,
     /* 1180332 */   // Label 17183: @1180332
     /* 1180332 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1180415), // Rule ID 16390 //
     /* 1180337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180376 */     // MIs[0] round
     /* 1180376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180414 */     // GIR_Coverage, 16390,
     /* 1180414 */     GIR_EraseRootFromParent_Done,
     /* 1180415 */   // Label 17184: @1180415
     /* 1180415 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1180498), // Rule ID 16391 //
     /* 1180420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180459 */     // MIs[0] round
     /* 1180459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180480 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180497 */     // GIR_Coverage, 16391,
     /* 1180497 */     GIR_EraseRootFromParent_Done,
     /* 1180498 */   // Label 17185: @1180498
     /* 1180498 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1180581), // Rule ID 16394 //
     /* 1180503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180542 */     // MIs[0] round
     /* 1180542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180580 */     // GIR_Coverage, 16394,
     /* 1180580 */     GIR_EraseRootFromParent_Done,
     /* 1180581 */   // Label 17186: @1180581
     /* 1180581 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1180664), // Rule ID 16395 //
     /* 1180586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180625 */     // MIs[0] round
     /* 1180625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180635 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180646 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180663 */     // GIR_Coverage, 16395,
     /* 1180663 */     GIR_EraseRootFromParent_Done,
     /* 1180664 */   // Label 17187: @1180664
     /* 1180664 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1180747), // Rule ID 16398 //
     /* 1180669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1180680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1180683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1180686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180708 */     // MIs[0] round
     /* 1180708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1180721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180746 */     // GIR_Coverage, 16398,
     /* 1180746 */     GIR_EraseRootFromParent_Done,
     /* 1180747 */   // Label 17188: @1180747
     /* 1180747 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1180830), // Rule ID 16399 //
     /* 1180752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1180763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1180766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1180769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180791 */     // MIs[0] round
     /* 1180791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180801 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1180804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180812 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180829 */     // GIR_Coverage, 16399,
     /* 1180829 */     GIR_EraseRootFromParent_Done,
     /* 1180830 */   // Label 17189: @1180830
     /* 1180830 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1180913), // Rule ID 16402 //
     /* 1180835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1180846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1180849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180874 */     // MIs[0] round
     /* 1180874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180884 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1180887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180912 */     // GIR_Coverage, 16402,
     /* 1180912 */     GIR_EraseRootFromParent_Done,
     /* 1180913 */   // Label 17190: @1180913
     /* 1180913 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1180996), // Rule ID 16403 //
     /* 1180918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1180929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1180932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1180935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180957 */     // MIs[0] round
     /* 1180957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180967 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1180970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180978 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180995 */     // GIR_Coverage, 16403,
     /* 1180995 */     GIR_EraseRootFromParent_Done,
     /* 1180996 */   // Label 17191: @1180996
     /* 1180996 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1181079), // Rule ID 16406 //
     /* 1181001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181040 */     // MIs[0] round
     /* 1181040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181078 */     // GIR_Coverage, 16406,
     /* 1181078 */     GIR_EraseRootFromParent_Done,
     /* 1181079 */   // Label 17192: @1181079
     /* 1181079 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1181162), // Rule ID 16407 //
     /* 1181084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181123 */     // MIs[0] round
     /* 1181123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181133 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181144 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181161 */     // GIR_Coverage, 16407,
     /* 1181161 */     GIR_EraseRootFromParent_Done,
     /* 1181162 */   // Label 17193: @1181162
     /* 1181162 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1181245), // Rule ID 16410 //
     /* 1181167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181206 */     // MIs[0] round
     /* 1181206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181244 */     // GIR_Coverage, 16410,
     /* 1181244 */     GIR_EraseRootFromParent_Done,
     /* 1181245 */   // Label 17194: @1181245
     /* 1181245 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1181328), // Rule ID 16411 //
     /* 1181250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181289 */     // MIs[0] round
     /* 1181289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181327 */     // GIR_Coverage, 16411,
     /* 1181327 */     GIR_EraseRootFromParent_Done,
     /* 1181328 */   // Label 17195: @1181328
     /* 1181328 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1181411), // Rule ID 16414 //
     /* 1181333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181372 */     // MIs[0] round
     /* 1181372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181410 */     // GIR_Coverage, 16414,
     /* 1181410 */     GIR_EraseRootFromParent_Done,
     /* 1181411 */   // Label 17196: @1181411
     /* 1181411 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1181494), // Rule ID 16415 //
     /* 1181416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181455 */     // MIs[0] round
     /* 1181455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181465 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181493 */     // GIR_Coverage, 16415,
     /* 1181493 */     GIR_EraseRootFromParent_Done,
     /* 1181494 */   // Label 17197: @1181494
     /* 1181494 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1181577), // Rule ID 16418 //
     /* 1181499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181538 */     // MIs[0] round
     /* 1181538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181576 */     // GIR_Coverage, 16418,
     /* 1181576 */     GIR_EraseRootFromParent_Done,
     /* 1181577 */   // Label 17198: @1181577
     /* 1181577 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1181660), // Rule ID 16419 //
     /* 1181582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181621 */     // MIs[0] round
     /* 1181621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181631 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181659 */     // GIR_Coverage, 16419,
     /* 1181659 */     GIR_EraseRootFromParent_Done,
     /* 1181660 */   // Label 17199: @1181660
     /* 1181660 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1181743), // Rule ID 16422 //
     /* 1181665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1181676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1181679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1181682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181704 */     // MIs[0] round
     /* 1181704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181742 */     // GIR_Coverage, 16422,
     /* 1181742 */     GIR_EraseRootFromParent_Done,
     /* 1181743 */   // Label 17200: @1181743
     /* 1181743 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1181826), // Rule ID 16423 //
     /* 1181748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1181759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1181762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1181765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181787 */     // MIs[0] round
     /* 1181787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181797 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181808 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181825 */     // GIR_Coverage, 16423,
     /* 1181825 */     GIR_EraseRootFromParent_Done,
     /* 1181826 */   // Label 17201: @1181826
     /* 1181826 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1181909), // Rule ID 16426 //
     /* 1181831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1181842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1181845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1181848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181870 */     // MIs[0] round
     /* 1181870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181908 */     // GIR_Coverage, 16426,
     /* 1181908 */     GIR_EraseRootFromParent_Done,
     /* 1181909 */   // Label 17202: @1181909
     /* 1181909 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1181992), // Rule ID 16427 //
     /* 1181914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1181925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1181928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1181931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181953 */     // MIs[0] round
     /* 1181953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181974 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181991 */     // GIR_Coverage, 16427,
     /* 1181991 */     GIR_EraseRootFromParent_Done,
     /* 1181992 */   // Label 17203: @1181992
     /* 1181992 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1182075), // Rule ID 16430 //
     /* 1181997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182036 */     // MIs[0] round
     /* 1182036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182074 */     // GIR_Coverage, 16430,
     /* 1182074 */     GIR_EraseRootFromParent_Done,
     /* 1182075 */   // Label 17204: @1182075
     /* 1182075 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1182158), // Rule ID 16431 //
     /* 1182080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182119 */     // MIs[0] round
     /* 1182119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182129 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182140 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182157 */     // GIR_Coverage, 16431,
     /* 1182157 */     GIR_EraseRootFromParent_Done,
     /* 1182158 */   // Label 17205: @1182158
     /* 1182158 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1182241), // Rule ID 16434 //
     /* 1182163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182202 */     // MIs[0] round
     /* 1182202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182240 */     // GIR_Coverage, 16434,
     /* 1182240 */     GIR_EraseRootFromParent_Done,
     /* 1182241 */   // Label 17206: @1182241
     /* 1182241 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1182324), // Rule ID 16435 //
     /* 1182246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182285 */     // MIs[0] round
     /* 1182285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182295 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182306 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182323 */     // GIR_Coverage, 16435,
     /* 1182323 */     GIR_EraseRootFromParent_Done,
     /* 1182324 */   // Label 17207: @1182324
     /* 1182324 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1182407), // Rule ID 16438 //
     /* 1182329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182368 */     // MIs[0] round
     /* 1182368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182406 */     // GIR_Coverage, 16438,
     /* 1182406 */     GIR_EraseRootFromParent_Done,
     /* 1182407 */   // Label 17208: @1182407
     /* 1182407 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1182490), // Rule ID 16439 //
     /* 1182412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182451 */     // MIs[0] round
     /* 1182451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182461 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182489 */     // GIR_Coverage, 16439,
     /* 1182489 */     GIR_EraseRootFromParent_Done,
     /* 1182490 */   // Label 17209: @1182490
     /* 1182490 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1182573), // Rule ID 16442 //
     /* 1182495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182534 */     // MIs[0] round
     /* 1182534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182572 */     // GIR_Coverage, 16442,
     /* 1182572 */     GIR_EraseRootFromParent_Done,
     /* 1182573 */   // Label 17210: @1182573
     /* 1182573 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1182656), // Rule ID 16443 //
     /* 1182578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182617 */     // MIs[0] round
     /* 1182617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182655 */     // GIR_Coverage, 16443,
     /* 1182655 */     GIR_EraseRootFromParent_Done,
     /* 1182656 */   // Label 17211: @1182656
     /* 1182656 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1182739), // Rule ID 16446 //
     /* 1182661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1182672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1182675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1182678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182700 */     // MIs[0] round
     /* 1182700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182738 */     // GIR_Coverage, 16446,
     /* 1182738 */     GIR_EraseRootFromParent_Done,
     /* 1182739 */   // Label 17212: @1182739
     /* 1182739 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1182822), // Rule ID 16447 //
     /* 1182744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1182755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1182758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1182761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182783 */     // MIs[0] round
     /* 1182783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182821 */     // GIR_Coverage, 16447,
     /* 1182821 */     GIR_EraseRootFromParent_Done,
     /* 1182822 */   // Label 17213: @1182822
     /* 1182822 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1182905), // Rule ID 16510 //
     /* 1182827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1182838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1182841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1182847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182866 */     // MIs[0] round
     /* 1182866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182876 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1182879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182904 */     // GIR_Coverage, 16510,
     /* 1182904 */     GIR_EraseRootFromParent_Done,
     /* 1182905 */   // Label 17214: @1182905
     /* 1182905 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1182988), // Rule ID 16511 //
     /* 1182910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1182921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1182924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1182927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1182930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182949 */     // MIs[0] round
     /* 1182949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182959 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1182962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1182980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182987 */     // GIR_Coverage, 16511,
     /* 1182987 */     GIR_EraseRootFromParent_Done,
     /* 1182988 */   // Label 17215: @1182988
     /* 1182988 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1183071), // Rule ID 16514 //
     /* 1182993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183032 */     // MIs[0] round
     /* 1183032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183042 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183070 */     // GIR_Coverage, 16514,
     /* 1183070 */     GIR_EraseRootFromParent_Done,
     /* 1183071 */   // Label 17216: @1183071
     /* 1183071 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1183154), // Rule ID 16515 //
     /* 1183076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183115 */     // MIs[0] round
     /* 1183115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183125 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183153 */     // GIR_Coverage, 16515,
     /* 1183153 */     GIR_EraseRootFromParent_Done,
     /* 1183154 */   // Label 17217: @1183154
     /* 1183154 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1183237), // Rule ID 16518 //
     /* 1183159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183198 */     // MIs[0] round
     /* 1183198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183236 */     // GIR_Coverage, 16518,
     /* 1183236 */     GIR_EraseRootFromParent_Done,
     /* 1183237 */   // Label 17218: @1183237
     /* 1183237 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1183320), // Rule ID 16519 //
     /* 1183242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183281 */     // MIs[0] round
     /* 1183281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183291 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183319 */     // GIR_Coverage, 16519,
     /* 1183319 */     GIR_EraseRootFromParent_Done,
     /* 1183320 */   // Label 17219: @1183320
     /* 1183320 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1183403), // Rule ID 16522 //
     /* 1183325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183364 */     // MIs[0] round
     /* 1183364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183402 */     // GIR_Coverage, 16522,
     /* 1183402 */     GIR_EraseRootFromParent_Done,
     /* 1183403 */   // Label 17220: @1183403
     /* 1183403 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1183486), // Rule ID 16523 //
     /* 1183408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183447 */     // MIs[0] round
     /* 1183447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183457 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183485 */     // GIR_Coverage, 16523,
     /* 1183485 */     GIR_EraseRootFromParent_Done,
     /* 1183486 */   // Label 17221: @1183486
     /* 1183486 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1183569), // Rule ID 16526 //
     /* 1183491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183530 */     // MIs[0] round
     /* 1183530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183540 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183568 */     // GIR_Coverage, 16526,
     /* 1183568 */     GIR_EraseRootFromParent_Done,
     /* 1183569 */   // Label 17222: @1183569
     /* 1183569 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1183652), // Rule ID 16527 //
     /* 1183574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183613 */     // MIs[0] round
     /* 1183613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183623 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183651 */     // GIR_Coverage, 16527,
     /* 1183651 */     GIR_EraseRootFromParent_Done,
     /* 1183652 */   // Label 17223: @1183652
     /* 1183652 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1183735), // Rule ID 16530 //
     /* 1183657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1183668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1183671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1183674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1183677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183696 */     // MIs[0] round
     /* 1183696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1183709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183734 */     // GIR_Coverage, 16530,
     /* 1183734 */     GIR_EraseRootFromParent_Done,
     /* 1183735 */   // Label 17224: @1183735
     /* 1183735 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1183818), // Rule ID 16531 //
     /* 1183740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1183751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1183754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1183757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1183760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183779 */     // MIs[0] round
     /* 1183779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183789 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1183792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183817 */     // GIR_Coverage, 16531,
     /* 1183817 */     GIR_EraseRootFromParent_Done,
     /* 1183818 */   // Label 17225: @1183818
     /* 1183818 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1183901), // Rule ID 16534 //
     /* 1183823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183862 */     // MIs[0] round
     /* 1183862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183900 */     // GIR_Coverage, 16534,
     /* 1183900 */     GIR_EraseRootFromParent_Done,
     /* 1183901 */   // Label 17226: @1183901
     /* 1183901 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1183984), // Rule ID 16535 //
     /* 1183906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183945 */     // MIs[0] round
     /* 1183945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183955 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183983 */     // GIR_Coverage, 16535,
     /* 1183983 */     GIR_EraseRootFromParent_Done,
     /* 1183984 */   // Label 17227: @1183984
     /* 1183984 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1184067), // Rule ID 16538 //
     /* 1183989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184028 */     // MIs[0] round
     /* 1184028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184038 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184066 */     // GIR_Coverage, 16538,
     /* 1184066 */     GIR_EraseRootFromParent_Done,
     /* 1184067 */   // Label 17228: @1184067
     /* 1184067 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1184150), // Rule ID 16539 //
     /* 1184072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184111 */     // MIs[0] round
     /* 1184111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184121 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184149 */     // GIR_Coverage, 16539,
     /* 1184149 */     GIR_EraseRootFromParent_Done,
     /* 1184150 */   // Label 17229: @1184150
     /* 1184150 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1184233), // Rule ID 16542 //
     /* 1184155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184194 */     // MIs[0] round
     /* 1184194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184232 */     // GIR_Coverage, 16542,
     /* 1184232 */     GIR_EraseRootFromParent_Done,
     /* 1184233 */   // Label 17230: @1184233
     /* 1184233 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1184316), // Rule ID 16543 //
     /* 1184238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184277 */     // MIs[0] round
     /* 1184277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184287 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184315 */     // GIR_Coverage, 16543,
     /* 1184315 */     GIR_EraseRootFromParent_Done,
     /* 1184316 */   // Label 17231: @1184316
     /* 1184316 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1184399), // Rule ID 16546 //
     /* 1184321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184360 */     // MIs[0] round
     /* 1184360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184398 */     // GIR_Coverage, 16546,
     /* 1184398 */     GIR_EraseRootFromParent_Done,
     /* 1184399 */   // Label 17232: @1184399
     /* 1184399 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1184482), // Rule ID 16547 //
     /* 1184404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184443 */     // MIs[0] round
     /* 1184443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184481 */     // GIR_Coverage, 16547,
     /* 1184481 */     GIR_EraseRootFromParent_Done,
     /* 1184482 */   // Label 17233: @1184482
     /* 1184482 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1184565), // Rule ID 16550 //
     /* 1184487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184526 */     // MIs[0] round
     /* 1184526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184564 */     // GIR_Coverage, 16550,
     /* 1184564 */     GIR_EraseRootFromParent_Done,
     /* 1184565 */   // Label 17234: @1184565
     /* 1184565 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1184648), // Rule ID 16551 //
     /* 1184570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184609 */     // MIs[0] round
     /* 1184609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184647 */     // GIR_Coverage, 16551,
     /* 1184647 */     GIR_EraseRootFromParent_Done,
     /* 1184648 */   // Label 17235: @1184648
     /* 1184648 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1184731), // Rule ID 16554 //
     /* 1184653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1184664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1184667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1184673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184692 */     // MIs[0] round
     /* 1184692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184730 */     // GIR_Coverage, 16554,
     /* 1184730 */     GIR_EraseRootFromParent_Done,
     /* 1184731 */   // Label 17236: @1184731
     /* 1184731 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1184814), // Rule ID 16555 //
     /* 1184736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1184739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1184747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1184750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1184756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184775 */     // MIs[0] round
     /* 1184775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184785 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184813 */     // GIR_Coverage, 16555,
     /* 1184813 */     GIR_EraseRootFromParent_Done,
     /* 1184814 */   // Label 17237: @1184814
     /* 1184814 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1184897), // Rule ID 16558 //
     /* 1184819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1184836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184858 */     // MIs[0] round
     /* 1184858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184896 */     // GIR_Coverage, 16558,
     /* 1184896 */     GIR_EraseRootFromParent_Done,
     /* 1184897 */   // Label 17238: @1184897
     /* 1184897 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1184980), // Rule ID 16559 //
     /* 1184902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1184905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1184919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184941 */     // MIs[0] round
     /* 1184941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184962 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184979 */     // GIR_Coverage, 16559,
     /* 1184979 */     GIR_EraseRootFromParent_Done,
     /* 1184980 */   // Label 17239: @1184980
     /* 1184980 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1185063), // Rule ID 16562 //
     /* 1184985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1184996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1184999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185024 */     // MIs[0] round
     /* 1185024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185034 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185062 */     // GIR_Coverage, 16562,
     /* 1185062 */     GIR_EraseRootFromParent_Done,
     /* 1185063 */   // Label 17240: @1185063
     /* 1185063 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1185146), // Rule ID 16563 //
     /* 1185068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185107 */     // MIs[0] round
     /* 1185107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185128 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185145 */     // GIR_Coverage, 16563,
     /* 1185145 */     GIR_EraseRootFromParent_Done,
     /* 1185146 */   // Label 17241: @1185146
     /* 1185146 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1185229), // Rule ID 16566 //
     /* 1185151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185190 */     // MIs[0] round
     /* 1185190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185228 */     // GIR_Coverage, 16566,
     /* 1185228 */     GIR_EraseRootFromParent_Done,
     /* 1185229 */   // Label 17242: @1185229
     /* 1185229 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1185312), // Rule ID 16567 //
     /* 1185234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185273 */     // MIs[0] round
     /* 1185273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185311 */     // GIR_Coverage, 16567,
     /* 1185311 */     GIR_EraseRootFromParent_Done,
     /* 1185312 */   // Label 17243: @1185312
     /* 1185312 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1185395), // Rule ID 16570 //
     /* 1185317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185356 */     // MIs[0] round
     /* 1185356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185394 */     // GIR_Coverage, 16570,
     /* 1185394 */     GIR_EraseRootFromParent_Done,
     /* 1185395 */   // Label 17244: @1185395
     /* 1185395 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1185478), // Rule ID 16571 //
     /* 1185400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185439 */     // MIs[0] round
     /* 1185439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185449 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185477 */     // GIR_Coverage, 16571,
     /* 1185477 */     GIR_EraseRootFromParent_Done,
     /* 1185478 */   // Label 17245: @1185478
     /* 1185478 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1185561), // Rule ID 16574 //
     /* 1185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185522 */     // MIs[0] round
     /* 1185522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185560 */     // GIR_Coverage, 16574,
     /* 1185560 */     GIR_EraseRootFromParent_Done,
     /* 1185561 */   // Label 17246: @1185561
     /* 1185561 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1185644), // Rule ID 16575 //
     /* 1185566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185605 */     // MIs[0] round
     /* 1185605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185615 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185643 */     // GIR_Coverage, 16575,
     /* 1185643 */     GIR_EraseRootFromParent_Done,
     /* 1185644 */   // Label 17247: @1185644
     /* 1185644 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1185727), // Rule ID 16578 //
     /* 1185649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1185660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1185663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1185666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185688 */     // MIs[0] round
     /* 1185688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1185701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185726 */     // GIR_Coverage, 16578,
     /* 1185726 */     GIR_EraseRootFromParent_Done,
     /* 1185727 */   // Label 17248: @1185727
     /* 1185727 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1185810), // Rule ID 16579 //
     /* 1185732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1185743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1185746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1185749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185771 */     // MIs[0] round
     /* 1185771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185781 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1185784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185809 */     // GIR_Coverage, 16579,
     /* 1185809 */     GIR_EraseRootFromParent_Done,
     /* 1185810 */   // Label 17249: @1185810
     /* 1185810 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1185893), // Rule ID 16582 //
     /* 1185815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1185826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1185829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1185832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185854 */     // MIs[0] round
     /* 1185854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1185867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185892 */     // GIR_Coverage, 16582,
     /* 1185892 */     GIR_EraseRootFromParent_Done,
     /* 1185893 */   // Label 17250: @1185893
     /* 1185893 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1185976), // Rule ID 16583 //
     /* 1185898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1185909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1185912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1185915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185937 */     // MIs[0] round
     /* 1185937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185947 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1185950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185975 */     // GIR_Coverage, 16583,
     /* 1185975 */     GIR_EraseRootFromParent_Done,
     /* 1185976 */   // Label 17251: @1185976
     /* 1185976 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1186059), // Rule ID 16586 //
     /* 1185981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1185992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1185995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1185998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186020 */     // MIs[0] round
     /* 1186020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186058 */     // GIR_Coverage, 16586,
     /* 1186058 */     GIR_EraseRootFromParent_Done,
     /* 1186059 */   // Label 17252: @1186059
     /* 1186059 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1186142), // Rule ID 16587 //
     /* 1186064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186103 */     // MIs[0] round
     /* 1186103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186141 */     // GIR_Coverage, 16587,
     /* 1186141 */     GIR_EraseRootFromParent_Done,
     /* 1186142 */   // Label 17253: @1186142
     /* 1186142 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1186225), // Rule ID 16590 //
     /* 1186147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186186 */     // MIs[0] round
     /* 1186186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186224 */     // GIR_Coverage, 16590,
     /* 1186224 */     GIR_EraseRootFromParent_Done,
     /* 1186225 */   // Label 17254: @1186225
     /* 1186225 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1186308), // Rule ID 16591 //
     /* 1186230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186269 */     // MIs[0] round
     /* 1186269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186279 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186290 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186307 */     // GIR_Coverage, 16591,
     /* 1186307 */     GIR_EraseRootFromParent_Done,
     /* 1186308 */   // Label 17255: @1186308
     /* 1186308 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1186391), // Rule ID 16594 //
     /* 1186313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186352 */     // MIs[0] round
     /* 1186352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186390 */     // GIR_Coverage, 16594,
     /* 1186390 */     GIR_EraseRootFromParent_Done,
     /* 1186391 */   // Label 17256: @1186391
     /* 1186391 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1186474), // Rule ID 16595 //
     /* 1186396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186435 */     // MIs[0] round
     /* 1186435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186445 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186456 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186473 */     // GIR_Coverage, 16595,
     /* 1186473 */     GIR_EraseRootFromParent_Done,
     /* 1186474 */   // Label 17257: @1186474
     /* 1186474 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1186557), // Rule ID 16598 //
     /* 1186479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186518 */     // MIs[0] round
     /* 1186518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186556 */     // GIR_Coverage, 16598,
     /* 1186556 */     GIR_EraseRootFromParent_Done,
     /* 1186557 */   // Label 17258: @1186557
     /* 1186557 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1186640), // Rule ID 16599 //
     /* 1186562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186601 */     // MIs[0] round
     /* 1186601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186611 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186639 */     // GIR_Coverage, 16599,
     /* 1186639 */     GIR_EraseRootFromParent_Done,
     /* 1186640 */   // Label 17259: @1186640
     /* 1186640 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1186723), // Rule ID 16602 //
     /* 1186645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1186662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186684 */     // MIs[0] round
     /* 1186684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186722 */     // GIR_Coverage, 16602,
     /* 1186722 */     GIR_EraseRootFromParent_Done,
     /* 1186723 */   // Label 17260: @1186723
     /* 1186723 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1186806), // Rule ID 16603 //
     /* 1186728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1186745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186767 */     // MIs[0] round
     /* 1186767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186805 */     // GIR_Coverage, 16603,
     /* 1186805 */     GIR_EraseRootFromParent_Done,
     /* 1186806 */   // Label 17261: @1186806
     /* 1186806 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1186889), // Rule ID 16606 //
     /* 1186811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1186828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186850 */     // MIs[0] round
     /* 1186850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186888 */     // GIR_Coverage, 16606,
     /* 1186888 */     GIR_EraseRootFromParent_Done,
     /* 1186889 */   // Label 17262: @1186889
     /* 1186889 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1186972), // Rule ID 16607 //
     /* 1186894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1186911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186933 */     // MIs[0] round
     /* 1186933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186971 */     // GIR_Coverage, 16607,
     /* 1186971 */     GIR_EraseRootFromParent_Done,
     /* 1186972 */   // Label 17263: @1186972
     /* 1186972 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1187055), // Rule ID 16610 //
     /* 1186977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1186988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1186991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1186994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187016 */     // MIs[0] round
     /* 1187016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187054 */     // GIR_Coverage, 16610,
     /* 1187054 */     GIR_EraseRootFromParent_Done,
     /* 1187055 */   // Label 17264: @1187055
     /* 1187055 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1187138), // Rule ID 16611 //
     /* 1187060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187099 */     // MIs[0] round
     /* 1187099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187109 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187137 */     // GIR_Coverage, 16611,
     /* 1187137 */     GIR_EraseRootFromParent_Done,
     /* 1187138 */   // Label 17265: @1187138
     /* 1187138 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1187221), // Rule ID 16614 //
     /* 1187143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187182 */     // MIs[0] round
     /* 1187182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187220 */     // GIR_Coverage, 16614,
     /* 1187220 */     GIR_EraseRootFromParent_Done,
     /* 1187221 */   // Label 17266: @1187221
     /* 1187221 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1187304), // Rule ID 16615 //
     /* 1187226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187265 */     // MIs[0] round
     /* 1187265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187275 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187303 */     // GIR_Coverage, 16615,
     /* 1187303 */     GIR_EraseRootFromParent_Done,
     /* 1187304 */   // Label 17267: @1187304
     /* 1187304 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1187387), // Rule ID 16618 //
     /* 1187309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187348 */     // MIs[0] round
     /* 1187348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187386 */     // GIR_Coverage, 16618,
     /* 1187386 */     GIR_EraseRootFromParent_Done,
     /* 1187387 */   // Label 17268: @1187387
     /* 1187387 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1187470), // Rule ID 16619 //
     /* 1187392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187431 */     // MIs[0] round
     /* 1187431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187441 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187469 */     // GIR_Coverage, 16619,
     /* 1187469 */     GIR_EraseRootFromParent_Done,
     /* 1187470 */   // Label 17269: @1187470
     /* 1187470 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1187553), // Rule ID 16622 //
     /* 1187475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187514 */     // MIs[0] round
     /* 1187514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187552 */     // GIR_Coverage, 16622,
     /* 1187552 */     GIR_EraseRootFromParent_Done,
     /* 1187553 */   // Label 17270: @1187553
     /* 1187553 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1187636), // Rule ID 16623 //
     /* 1187558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187597 */     // MIs[0] round
     /* 1187597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187635 */     // GIR_Coverage, 16623,
     /* 1187635 */     GIR_EraseRootFromParent_Done,
     /* 1187636 */   // Label 17271: @1187636
     /* 1187636 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1187719), // Rule ID 16626 //
     /* 1187641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1187658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187680 */     // MIs[0] round
     /* 1187680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187718 */     // GIR_Coverage, 16626,
     /* 1187718 */     GIR_EraseRootFromParent_Done,
     /* 1187719 */   // Label 17272: @1187719
     /* 1187719 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1187802), // Rule ID 16627 //
     /* 1187724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1187741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187763 */     // MIs[0] round
     /* 1187763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187773 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187801 */     // GIR_Coverage, 16627,
     /* 1187801 */     GIR_EraseRootFromParent_Done,
     /* 1187802 */   // Label 17273: @1187802
     /* 1187802 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1187882), // Rule ID 16690 //
     /* 1187807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1187810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1187824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1187827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187846 */     // MIs[0] round
     /* 1187846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187856 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1187859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187881 */     // GIR_Coverage, 16690,
     /* 1187881 */     GIR_EraseRootFromParent_Done,
     /* 1187882 */   // Label 17274: @1187882
     /* 1187882 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1187962), // Rule ID 16691 //
     /* 1187887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1187890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1187898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1187901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1187904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1187907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187926 */     // MIs[0] round
     /* 1187926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187936 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1187939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187961 */     // GIR_Coverage, 16691,
     /* 1187961 */     GIR_EraseRootFromParent_Done,
     /* 1187962 */   // Label 17275: @1187962
     /* 1187962 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1188042), // Rule ID 16694 //
     /* 1187967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1187970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1187978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1187981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1187984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1187987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188006 */     // MIs[0] round
     /* 1188006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188016 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188041 */     // GIR_Coverage, 16694,
     /* 1188041 */     GIR_EraseRootFromParent_Done,
     /* 1188042 */   // Label 17276: @1188042
     /* 1188042 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1188122), // Rule ID 16695 //
     /* 1188047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188086 */     // MIs[0] round
     /* 1188086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188096 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188121 */     // GIR_Coverage, 16695,
     /* 1188121 */     GIR_EraseRootFromParent_Done,
     /* 1188122 */   // Label 17277: @1188122
     /* 1188122 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1188202), // Rule ID 16698 //
     /* 1188127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188166 */     // MIs[0] round
     /* 1188166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188176 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188201 */     // GIR_Coverage, 16698,
     /* 1188201 */     GIR_EraseRootFromParent_Done,
     /* 1188202 */   // Label 17278: @1188202
     /* 1188202 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1188282), // Rule ID 16699 //
     /* 1188207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188246 */     // MIs[0] round
     /* 1188246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188281 */     // GIR_Coverage, 16699,
     /* 1188281 */     GIR_EraseRootFromParent_Done,
     /* 1188282 */   // Label 17279: @1188282
     /* 1188282 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1188362), // Rule ID 16702 //
     /* 1188287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188326 */     // MIs[0] round
     /* 1188326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188336 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188361 */     // GIR_Coverage, 16702,
     /* 1188361 */     GIR_EraseRootFromParent_Done,
     /* 1188362 */   // Label 17280: @1188362
     /* 1188362 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1188442), // Rule ID 16703 //
     /* 1188367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188406 */     // MIs[0] round
     /* 1188406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188441 */     // GIR_Coverage, 16703,
     /* 1188441 */     GIR_EraseRootFromParent_Done,
     /* 1188442 */   // Label 17281: @1188442
     /* 1188442 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1188522), // Rule ID 16706 //
     /* 1188447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188486 */     // MIs[0] round
     /* 1188486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188521 */     // GIR_Coverage, 16706,
     /* 1188521 */     GIR_EraseRootFromParent_Done,
     /* 1188522 */   // Label 17282: @1188522
     /* 1188522 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1188602), // Rule ID 16707 //
     /* 1188527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188566 */     // MIs[0] round
     /* 1188566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188601 */     // GIR_Coverage, 16707,
     /* 1188601 */     GIR_EraseRootFromParent_Done,
     /* 1188602 */   // Label 17283: @1188602
     /* 1188602 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1188682), // Rule ID 16710 //
     /* 1188607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1188610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1188618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1188621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1188627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188646 */     // MIs[0] round
     /* 1188646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1188659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188681 */     // GIR_Coverage, 16710,
     /* 1188681 */     GIR_EraseRootFromParent_Done,
     /* 1188682 */   // Label 17284: @1188682
     /* 1188682 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1188762), // Rule ID 16711 //
     /* 1188687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1188690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1188698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1188701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1188707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188726 */     // MIs[0] round
     /* 1188726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1188739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188761 */     // GIR_Coverage, 16711,
     /* 1188761 */     GIR_EraseRootFromParent_Done,
     /* 1188762 */   // Label 17285: @1188762
     /* 1188762 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1188842), // Rule ID 16714 //
     /* 1188767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1188778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1188781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1188784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1188787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188806 */     // MIs[0] round
     /* 1188806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1188819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188841 */     // GIR_Coverage, 16714,
     /* 1188841 */     GIR_EraseRootFromParent_Done,
     /* 1188842 */   // Label 17286: @1188842
     /* 1188842 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1188922), // Rule ID 16715 //
     /* 1188847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1188858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1188861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1188864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1188867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1188886 */     // MIs[0] round
     /* 1188886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188896 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1188899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188921 */     // GIR_Coverage, 16715,
     /* 1188921 */     GIR_EraseRootFromParent_Done,
     /* 1188922 */   // Label 17287: @1188922
     /* 1188922 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1189002), // Rule ID 16718 //
     /* 1188927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1188938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1188941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1188944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1188947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188966 */     // MIs[0] round
     /* 1188966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188976 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1188979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189001 */     // GIR_Coverage, 16718,
     /* 1189001 */     GIR_EraseRootFromParent_Done,
     /* 1189002 */   // Label 17288: @1189002
     /* 1189002 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1189082), // Rule ID 16719 //
     /* 1189007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189046 */     // MIs[0] round
     /* 1189046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189056 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189081 */     // GIR_Coverage, 16719,
     /* 1189081 */     GIR_EraseRootFromParent_Done,
     /* 1189082 */   // Label 17289: @1189082
     /* 1189082 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1189162), // Rule ID 16722 //
     /* 1189087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189126 */     // MIs[0] round
     /* 1189126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189136 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189161 */     // GIR_Coverage, 16722,
     /* 1189161 */     GIR_EraseRootFromParent_Done,
     /* 1189162 */   // Label 17290: @1189162
     /* 1189162 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1189242), // Rule ID 16723 //
     /* 1189167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189206 */     // MIs[0] round
     /* 1189206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189241 */     // GIR_Coverage, 16723,
     /* 1189241 */     GIR_EraseRootFromParent_Done,
     /* 1189242 */   // Label 17291: @1189242
     /* 1189242 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1189322), // Rule ID 16726 //
     /* 1189247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189286 */     // MIs[0] round
     /* 1189286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189321 */     // GIR_Coverage, 16726,
     /* 1189321 */     GIR_EraseRootFromParent_Done,
     /* 1189322 */   // Label 17292: @1189322
     /* 1189322 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1189402), // Rule ID 16727 //
     /* 1189327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189366 */     // MIs[0] round
     /* 1189366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189401 */     // GIR_Coverage, 16727,
     /* 1189401 */     GIR_EraseRootFromParent_Done,
     /* 1189402 */   // Label 17293: @1189402
     /* 1189402 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1189482), // Rule ID 16730 //
     /* 1189407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189446 */     // MIs[0] round
     /* 1189446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189481 */     // GIR_Coverage, 16730,
     /* 1189481 */     GIR_EraseRootFromParent_Done,
     /* 1189482 */   // Label 17294: @1189482
     /* 1189482 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1189562), // Rule ID 16731 //
     /* 1189487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189526 */     // MIs[0] round
     /* 1189526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189536 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189561 */     // GIR_Coverage, 16731,
     /* 1189561 */     GIR_EraseRootFromParent_Done,
     /* 1189562 */   // Label 17295: @1189562
     /* 1189562 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1189642), // Rule ID 16734 //
     /* 1189567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189606 */     // MIs[0] round
     /* 1189606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189616 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1189619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189641 */     // GIR_Coverage, 16734,
     /* 1189641 */     GIR_EraseRootFromParent_Done,
     /* 1189642 */   // Label 17296: @1189642
     /* 1189642 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1189722), // Rule ID 16735 //
     /* 1189647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189686 */     // MIs[0] round
     /* 1189686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189696 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1189699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189721 */     // GIR_Coverage, 16735,
     /* 1189721 */     GIR_EraseRootFromParent_Done,
     /* 1189722 */   // Label 17297: @1189722
     /* 1189722 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1189802), // Rule ID 16738 //
     /* 1189727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1189730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1189738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1189741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1189744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1189747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189766 */     // MIs[0] round
     /* 1189766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1189779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189801 */     // GIR_Coverage, 16738,
     /* 1189801 */     GIR_EraseRootFromParent_Done,
     /* 1189802 */   // Label 17298: @1189802
     /* 1189802 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1189882), // Rule ID 16739 //
     /* 1189807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1189818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1189821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1189824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1189827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189846 */     // MIs[0] round
     /* 1189846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1189859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189881 */     // GIR_Coverage, 16739,
     /* 1189881 */     GIR_EraseRootFromParent_Done,
     /* 1189882 */   // Label 17299: @1189882
     /* 1189882 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1189962), // Rule ID 16742 //
     /* 1189887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1189890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1189898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1189901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1189904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1189907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189926 */     // MIs[0] round
     /* 1189926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189936 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1189939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189961 */     // GIR_Coverage, 16742,
     /* 1189961 */     GIR_EraseRootFromParent_Done,
     /* 1189962 */   // Label 17300: @1189962
     /* 1189962 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1190042), // Rule ID 16743 //
     /* 1189967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1189978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1189981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1189984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1189987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190006 */     // MIs[0] round
     /* 1190006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190016 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190041 */     // GIR_Coverage, 16743,
     /* 1190041 */     GIR_EraseRootFromParent_Done,
     /* 1190042 */   // Label 17301: @1190042
     /* 1190042 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1190122), // Rule ID 16746 //
     /* 1190047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190086 */     // MIs[0] round
     /* 1190086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190096 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190121 */     // GIR_Coverage, 16746,
     /* 1190121 */     GIR_EraseRootFromParent_Done,
     /* 1190122 */   // Label 17302: @1190122
     /* 1190122 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1190202), // Rule ID 16747 //
     /* 1190127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190166 */     // MIs[0] round
     /* 1190166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190176 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190201 */     // GIR_Coverage, 16747,
     /* 1190201 */     GIR_EraseRootFromParent_Done,
     /* 1190202 */   // Label 17303: @1190202
     /* 1190202 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1190282), // Rule ID 16750 //
     /* 1190207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190246 */     // MIs[0] round
     /* 1190246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190256 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190281 */     // GIR_Coverage, 16750,
     /* 1190281 */     GIR_EraseRootFromParent_Done,
     /* 1190282 */   // Label 17304: @1190282
     /* 1190282 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1190362), // Rule ID 16751 //
     /* 1190287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190326 */     // MIs[0] round
     /* 1190326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190361 */     // GIR_Coverage, 16751,
     /* 1190361 */     GIR_EraseRootFromParent_Done,
     /* 1190362 */   // Label 17305: @1190362
     /* 1190362 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1190442), // Rule ID 16754 //
     /* 1190367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190406 */     // MIs[0] round
     /* 1190406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190416 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190441 */     // GIR_Coverage, 16754,
     /* 1190441 */     GIR_EraseRootFromParent_Done,
     /* 1190442 */   // Label 17306: @1190442
     /* 1190442 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1190522), // Rule ID 16755 //
     /* 1190447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190486 */     // MIs[0] round
     /* 1190486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190496 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190521 */     // GIR_Coverage, 16755,
     /* 1190521 */     GIR_EraseRootFromParent_Done,
     /* 1190522 */   // Label 17307: @1190522
     /* 1190522 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1190602), // Rule ID 16758 //
     /* 1190527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190566 */     // MIs[0] round
     /* 1190566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190576 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190601 */     // GIR_Coverage, 16758,
     /* 1190601 */     GIR_EraseRootFromParent_Done,
     /* 1190602 */   // Label 17308: @1190602
     /* 1190602 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1190682), // Rule ID 16759 //
     /* 1190607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190646 */     // MIs[0] round
     /* 1190646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190656 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190681 */     // GIR_Coverage, 16759,
     /* 1190681 */     GIR_EraseRootFromParent_Done,
     /* 1190682 */   // Label 17309: @1190682
     /* 1190682 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1190762), // Rule ID 16762 //
     /* 1190687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1190698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1190701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1190704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190726 */     // MIs[0] round
     /* 1190726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190736 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1190739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190761 */     // GIR_Coverage, 16762,
     /* 1190761 */     GIR_EraseRootFromParent_Done,
     /* 1190762 */   // Label 17310: @1190762
     /* 1190762 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1190842), // Rule ID 16763 //
     /* 1190767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1190778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1190781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1190784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190806 */     // MIs[0] round
     /* 1190806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190816 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1190819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190841 */     // GIR_Coverage, 16763,
     /* 1190841 */     GIR_EraseRootFromParent_Done,
     /* 1190842 */   // Label 17311: @1190842
     /* 1190842 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1190922), // Rule ID 16766 //
     /* 1190847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1190858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1190861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190886 */     // MIs[0] round
     /* 1190886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1190899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190921 */     // GIR_Coverage, 16766,
     /* 1190921 */     GIR_EraseRootFromParent_Done,
     /* 1190922 */   // Label 17312: @1190922
     /* 1190922 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1191002), // Rule ID 16767 //
     /* 1190927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1190938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1190941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1190944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190966 */     // MIs[0] round
     /* 1190966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1190979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191001 */     // GIR_Coverage, 16767,
     /* 1191001 */     GIR_EraseRootFromParent_Done,
     /* 1191002 */   // Label 17313: @1191002
     /* 1191002 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1191082), // Rule ID 16770 //
     /* 1191007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191046 */     // MIs[0] round
     /* 1191046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191081 */     // GIR_Coverage, 16770,
     /* 1191081 */     GIR_EraseRootFromParent_Done,
     /* 1191082 */   // Label 17314: @1191082
     /* 1191082 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1191162), // Rule ID 16771 //
     /* 1191087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191126 */     // MIs[0] round
     /* 1191126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191161 */     // GIR_Coverage, 16771,
     /* 1191161 */     GIR_EraseRootFromParent_Done,
     /* 1191162 */   // Label 17315: @1191162
     /* 1191162 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1191242), // Rule ID 16774 //
     /* 1191167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191206 */     // MIs[0] round
     /* 1191206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191216 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191241 */     // GIR_Coverage, 16774,
     /* 1191241 */     GIR_EraseRootFromParent_Done,
     /* 1191242 */   // Label 17316: @1191242
     /* 1191242 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1191322), // Rule ID 16775 //
     /* 1191247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191286 */     // MIs[0] round
     /* 1191286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191296 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191321 */     // GIR_Coverage, 16775,
     /* 1191321 */     GIR_EraseRootFromParent_Done,
     /* 1191322 */   // Label 17317: @1191322
     /* 1191322 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1191402), // Rule ID 16778 //
     /* 1191327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191366 */     // MIs[0] round
     /* 1191366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191376 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191401 */     // GIR_Coverage, 16778,
     /* 1191401 */     GIR_EraseRootFromParent_Done,
     /* 1191402 */   // Label 17318: @1191402
     /* 1191402 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1191482), // Rule ID 16779 //
     /* 1191407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191446 */     // MIs[0] round
     /* 1191446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191456 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191481 */     // GIR_Coverage, 16779,
     /* 1191481 */     GIR_EraseRootFromParent_Done,
     /* 1191482 */   // Label 17319: @1191482
     /* 1191482 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1191562), // Rule ID 16782 //
     /* 1191487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191526 */     // MIs[0] round
     /* 1191526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191536 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191561 */     // GIR_Coverage, 16782,
     /* 1191561 */     GIR_EraseRootFromParent_Done,
     /* 1191562 */   // Label 17320: @1191562
     /* 1191562 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1191642), // Rule ID 16783 //
     /* 1191567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191606 */     // MIs[0] round
     /* 1191606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191616 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191641 */     // GIR_Coverage, 16783,
     /* 1191641 */     GIR_EraseRootFromParent_Done,
     /* 1191642 */   // Label 17321: @1191642
     /* 1191642 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1191722), // Rule ID 16786 //
     /* 1191647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191686 */     // MIs[0] round
     /* 1191686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191696 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1191699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191721 */     // GIR_Coverage, 16786,
     /* 1191721 */     GIR_EraseRootFromParent_Done,
     /* 1191722 */   // Label 17322: @1191722
     /* 1191722 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1191802), // Rule ID 16787 //
     /* 1191727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191766 */     // MIs[0] round
     /* 1191766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1191779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191801 */     // GIR_Coverage, 16787,
     /* 1191801 */     GIR_EraseRootFromParent_Done,
     /* 1191802 */   // Label 17323: @1191802
     /* 1191802 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1191882), // Rule ID 16790 //
     /* 1191807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1191818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1191821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1191824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191846 */     // MIs[0] round
     /* 1191846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1191859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191881 */     // GIR_Coverage, 16790,
     /* 1191881 */     GIR_EraseRootFromParent_Done,
     /* 1191882 */   // Label 17324: @1191882
     /* 1191882 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1191962), // Rule ID 16791 //
     /* 1191887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1191898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1191901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1191904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191926 */     // MIs[0] round
     /* 1191926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1191939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191961 */     // GIR_Coverage, 16791,
     /* 1191961 */     GIR_EraseRootFromParent_Done,
     /* 1191962 */   // Label 17325: @1191962
     /* 1191962 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1192042), // Rule ID 16794 //
     /* 1191967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1191978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1191981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1191984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192006 */     // MIs[0] round
     /* 1192006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192016 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192041 */     // GIR_Coverage, 16794,
     /* 1192041 */     GIR_EraseRootFromParent_Done,
     /* 1192042 */   // Label 17326: @1192042
     /* 1192042 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1192122), // Rule ID 16795 //
     /* 1192047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192086 */     // MIs[0] round
     /* 1192086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192096 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192121 */     // GIR_Coverage, 16795,
     /* 1192121 */     GIR_EraseRootFromParent_Done,
     /* 1192122 */   // Label 17327: @1192122
     /* 1192122 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1192202), // Rule ID 16798 //
     /* 1192127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192166 */     // MIs[0] round
     /* 1192166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192201 */     // GIR_Coverage, 16798,
     /* 1192201 */     GIR_EraseRootFromParent_Done,
     /* 1192202 */   // Label 17328: @1192202
     /* 1192202 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1192282), // Rule ID 16799 //
     /* 1192207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192246 */     // MIs[0] round
     /* 1192246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192281 */     // GIR_Coverage, 16799,
     /* 1192281 */     GIR_EraseRootFromParent_Done,
     /* 1192282 */   // Label 17329: @1192282
     /* 1192282 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1192362), // Rule ID 16802 //
     /* 1192287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192326 */     // MIs[0] round
     /* 1192326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192361 */     // GIR_Coverage, 16802,
     /* 1192361 */     GIR_EraseRootFromParent_Done,
     /* 1192362 */   // Label 17330: @1192362
     /* 1192362 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1192442), // Rule ID 16803 //
     /* 1192367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192406 */     // MIs[0] round
     /* 1192406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192441 */     // GIR_Coverage, 16803,
     /* 1192441 */     GIR_EraseRootFromParent_Done,
     /* 1192442 */   // Label 17331: @1192442
     /* 1192442 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1192522), // Rule ID 16806 //
     /* 1192447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192486 */     // MIs[0] round
     /* 1192486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192496 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192521 */     // GIR_Coverage, 16806,
     /* 1192521 */     GIR_EraseRootFromParent_Done,
     /* 1192522 */   // Label 17332: @1192522
     /* 1192522 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1192602), // Rule ID 16807 //
     /* 1192527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192566 */     // MIs[0] round
     /* 1192566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192576 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192601 */     // GIR_Coverage, 16807,
     /* 1192601 */     GIR_EraseRootFromParent_Done,
     /* 1192602 */   // Label 17333: @1192602
     /* 1192602 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1192682), // Rule ID 16810 //
     /* 1192607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1192618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1192621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1192624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1192627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192646 */     // MIs[0] round
     /* 1192646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192656 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1192659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192681 */     // GIR_Coverage, 16810,
     /* 1192681 */     GIR_EraseRootFromParent_Done,
     /* 1192682 */   // Label 17334: @1192682
     /* 1192682 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1192762), // Rule ID 16811 //
     /* 1192687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1192698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1192701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1192704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1192707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192726 */     // MIs[0] round
     /* 1192726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192736 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1192739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192761 */     // GIR_Coverage, 16811,
     /* 1192761 */     GIR_EraseRootFromParent_Done,
     /* 1192762 */   // Label 17335: @1192762
     /* 1192762 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1192842), // Rule ID 16814 //
     /* 1192767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1192778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1192781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1192784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1192787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192806 */     // MIs[0] round
     /* 1192806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192816 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1192819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192841 */     // GIR_Coverage, 16814,
     /* 1192841 */     GIR_EraseRootFromParent_Done,
     /* 1192842 */   // Label 17336: @1192842
     /* 1192842 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1192922), // Rule ID 16815 //
     /* 1192847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1192858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1192861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1192864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1192867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192886 */     // MIs[0] round
     /* 1192886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192896 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1192899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192921 */     // GIR_Coverage, 16815,
     /* 1192921 */     GIR_EraseRootFromParent_Done,
     /* 1192922 */   // Label 17337: @1192922
     /* 1192922 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1193002), // Rule ID 16818 //
     /* 1192927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1192938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1192941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1192944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1192947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192966 */     // MIs[0] round
     /* 1192966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192976 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1192979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193001 */     // GIR_Coverage, 16818,
     /* 1193001 */     GIR_EraseRootFromParent_Done,
     /* 1193002 */   // Label 17338: @1193002
     /* 1193002 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1193082), // Rule ID 16819 //
     /* 1193007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193046 */     // MIs[0] round
     /* 1193046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193081 */     // GIR_Coverage, 16819,
     /* 1193081 */     GIR_EraseRootFromParent_Done,
     /* 1193082 */   // Label 17339: @1193082
     /* 1193082 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1193162), // Rule ID 16822 //
     /* 1193087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193126 */     // MIs[0] round
     /* 1193126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193136 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193161 */     // GIR_Coverage, 16822,
     /* 1193161 */     GIR_EraseRootFromParent_Done,
     /* 1193162 */   // Label 17340: @1193162
     /* 1193162 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1193242), // Rule ID 16823 //
     /* 1193167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193206 */     // MIs[0] round
     /* 1193206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193216 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193241 */     // GIR_Coverage, 16823,
     /* 1193241 */     GIR_EraseRootFromParent_Done,
     /* 1193242 */   // Label 17341: @1193242
     /* 1193242 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1193322), // Rule ID 16826 //
     /* 1193247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193286 */     // MIs[0] round
     /* 1193286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193296 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193321 */     // GIR_Coverage, 16826,
     /* 1193321 */     GIR_EraseRootFromParent_Done,
     /* 1193322 */   // Label 17342: @1193322
     /* 1193322 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1193402), // Rule ID 16827 //
     /* 1193327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193366 */     // MIs[0] round
     /* 1193366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193376 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193401 */     // GIR_Coverage, 16827,
     /* 1193401 */     GIR_EraseRootFromParent_Done,
     /* 1193402 */   // Label 17343: @1193402
     /* 1193402 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1193482), // Rule ID 16830 //
     /* 1193407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193446 */     // MIs[0] round
     /* 1193446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193481 */     // GIR_Coverage, 16830,
     /* 1193481 */     GIR_EraseRootFromParent_Done,
     /* 1193482 */   // Label 17344: @1193482
     /* 1193482 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1193562), // Rule ID 16831 //
     /* 1193487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193526 */     // MIs[0] round
     /* 1193526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193536 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193561 */     // GIR_Coverage, 16831,
     /* 1193561 */     GIR_EraseRootFromParent_Done,
     /* 1193562 */   // Label 17345: @1193562
     /* 1193562 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1193642), // Rule ID 16834 //
     /* 1193567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193606 */     // MIs[0] round
     /* 1193606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193616 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1193619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193641 */     // GIR_Coverage, 16834,
     /* 1193641 */     GIR_EraseRootFromParent_Done,
     /* 1193642 */   // Label 17346: @1193642
     /* 1193642 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1193722), // Rule ID 16835 //
     /* 1193647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193686 */     // MIs[0] round
     /* 1193686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193696 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1193699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193721 */     // GIR_Coverage, 16835,
     /* 1193721 */     GIR_EraseRootFromParent_Done,
     /* 1193722 */   // Label 17347: @1193722
     /* 1193722 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1193802), // Rule ID 16838 //
     /* 1193727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1193738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1193741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1193744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1193747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193766 */     // MIs[0] round
     /* 1193766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193776 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1193779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193801 */     // GIR_Coverage, 16838,
     /* 1193801 */     GIR_EraseRootFromParent_Done,
     /* 1193802 */   // Label 17348: @1193802
     /* 1193802 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1193882), // Rule ID 16839 //
     /* 1193807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1193818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1193821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1193824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1193827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1193846 */     // MIs[0] round
     /* 1193846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193856 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1193859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193881 */     // GIR_Coverage, 16839,
     /* 1193881 */     GIR_EraseRootFromParent_Done,
     /* 1193882 */   // Label 17349: @1193882
     /* 1193882 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1193962), // Rule ID 16842 //
     /* 1193887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1193898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1193901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1193904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1193907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193926 */     // MIs[0] round
     /* 1193926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193936 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1193939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193961 */     // GIR_Coverage, 16842,
     /* 1193961 */     GIR_EraseRootFromParent_Done,
     /* 1193962 */   // Label 17350: @1193962
     /* 1193962 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1194042), // Rule ID 16843 //
     /* 1193967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1193978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1193981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1193984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1193987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194006 */     // MIs[0] round
     /* 1194006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194016 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194041 */     // GIR_Coverage, 16843,
     /* 1194041 */     GIR_EraseRootFromParent_Done,
     /* 1194042 */   // Label 17351: @1194042
     /* 1194042 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1194122), // Rule ID 16846 //
     /* 1194047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194086 */     // MIs[0] round
     /* 1194086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194121 */     // GIR_Coverage, 16846,
     /* 1194121 */     GIR_EraseRootFromParent_Done,
     /* 1194122 */   // Label 17352: @1194122
     /* 1194122 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1194202), // Rule ID 16847 //
     /* 1194127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194166 */     // MIs[0] round
     /* 1194166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194201 */     // GIR_Coverage, 16847,
     /* 1194201 */     GIR_EraseRootFromParent_Done,
     /* 1194202 */   // Label 17353: @1194202
     /* 1194202 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1194282), // Rule ID 16850 //
     /* 1194207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194246 */     // MIs[0] round
     /* 1194246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194256 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194281 */     // GIR_Coverage, 16850,
     /* 1194281 */     GIR_EraseRootFromParent_Done,
     /* 1194282 */   // Label 17354: @1194282
     /* 1194282 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1194362), // Rule ID 16851 //
     /* 1194287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194326 */     // MIs[0] round
     /* 1194326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194361 */     // GIR_Coverage, 16851,
     /* 1194361 */     GIR_EraseRootFromParent_Done,
     /* 1194362 */   // Label 17355: @1194362
     /* 1194362 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1194442), // Rule ID 16854 //
     /* 1194367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194406 */     // MIs[0] round
     /* 1194406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194416 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194441 */     // GIR_Coverage, 16854,
     /* 1194441 */     GIR_EraseRootFromParent_Done,
     /* 1194442 */   // Label 17356: @1194442
     /* 1194442 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1194522), // Rule ID 16855 //
     /* 1194447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194486 */     // MIs[0] round
     /* 1194486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194496 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194521 */     // GIR_Coverage, 16855,
     /* 1194521 */     GIR_EraseRootFromParent_Done,
     /* 1194522 */   // Label 17357: @1194522
     /* 1194522 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1194602), // Rule ID 16858 //
     /* 1194527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194566 */     // MIs[0] round
     /* 1194566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194576 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194601 */     // GIR_Coverage, 16858,
     /* 1194601 */     GIR_EraseRootFromParent_Done,
     /* 1194602 */   // Label 17358: @1194602
     /* 1194602 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1194682), // Rule ID 16859 //
     /* 1194607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194646 */     // MIs[0] round
     /* 1194646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194656 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194681 */     // GIR_Coverage, 16859,
     /* 1194681 */     GIR_EraseRootFromParent_Done,
     /* 1194682 */   // Label 17359: @1194682
     /* 1194682 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1194762), // Rule ID 16862 //
     /* 1194687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1194698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1194701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1194704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1194707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194726 */     // MIs[0] round
     /* 1194726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194736 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1194739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194761 */     // GIR_Coverage, 16862,
     /* 1194761 */     GIR_EraseRootFromParent_Done,
     /* 1194762 */   // Label 17360: @1194762
     /* 1194762 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1194842), // Rule ID 16863 //
     /* 1194767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1194778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1194781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1194784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1194787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194806 */     // MIs[0] round
     /* 1194806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194816 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1194819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194841 */     // GIR_Coverage, 16863,
     /* 1194841 */     GIR_EraseRootFromParent_Done,
     /* 1194842 */   // Label 17361: @1194842
     /* 1194842 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1194922), // Rule ID 16866 //
     /* 1194847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1194858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1194861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1194864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1194867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194886 */     // MIs[0] round
     /* 1194886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194896 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1194899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194921 */     // GIR_Coverage, 16866,
     /* 1194921 */     GIR_EraseRootFromParent_Done,
     /* 1194922 */   // Label 17362: @1194922
     /* 1194922 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1195002), // Rule ID 16867 //
     /* 1194927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1194938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1194941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1194944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1194947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194966 */     // MIs[0] round
     /* 1194966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194976 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1194979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195001 */     // GIR_Coverage, 16867,
     /* 1195001 */     GIR_EraseRootFromParent_Done,
     /* 1195002 */   // Label 17363: @1195002
     /* 1195002 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1195082), // Rule ID 16870 //
     /* 1195007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195046 */     // MIs[0] round
     /* 1195046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195056 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195081 */     // GIR_Coverage, 16870,
     /* 1195081 */     GIR_EraseRootFromParent_Done,
     /* 1195082 */   // Label 17364: @1195082
     /* 1195082 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1195162), // Rule ID 16871 //
     /* 1195087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195126 */     // MIs[0] round
     /* 1195126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195136 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195161 */     // GIR_Coverage, 16871,
     /* 1195161 */     GIR_EraseRootFromParent_Done,
     /* 1195162 */   // Label 17365: @1195162
     /* 1195162 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1195242), // Rule ID 16874 //
     /* 1195167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195206 */     // MIs[0] round
     /* 1195206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195216 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195241 */     // GIR_Coverage, 16874,
     /* 1195241 */     GIR_EraseRootFromParent_Done,
     /* 1195242 */   // Label 17366: @1195242
     /* 1195242 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1195322), // Rule ID 16875 //
     /* 1195247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195286 */     // MIs[0] round
     /* 1195286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195296 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195321 */     // GIR_Coverage, 16875,
     /* 1195321 */     GIR_EraseRootFromParent_Done,
     /* 1195322 */   // Label 17367: @1195322
     /* 1195322 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1195402), // Rule ID 16878 //
     /* 1195327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195366 */     // MIs[0] round
     /* 1195366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195401 */     // GIR_Coverage, 16878,
     /* 1195401 */     GIR_EraseRootFromParent_Done,
     /* 1195402 */   // Label 17368: @1195402
     /* 1195402 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1195482), // Rule ID 16879 //
     /* 1195407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195446 */     // MIs[0] round
     /* 1195446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195456 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195481 */     // GIR_Coverage, 16879,
     /* 1195481 */     GIR_EraseRootFromParent_Done,
     /* 1195482 */   // Label 17369: @1195482
     /* 1195482 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1195562), // Rule ID 16882 //
     /* 1195487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195526 */     // MIs[0] round
     /* 1195526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195536 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195561 */     // GIR_Coverage, 16882,
     /* 1195561 */     GIR_EraseRootFromParent_Done,
     /* 1195562 */   // Label 17370: @1195562
     /* 1195562 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1195642), // Rule ID 16883 //
     /* 1195567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195606 */     // MIs[0] round
     /* 1195606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195641 */     // GIR_Coverage, 16883,
     /* 1195641 */     GIR_EraseRootFromParent_Done,
     /* 1195642 */   // Label 17371: @1195642
     /* 1195642 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1195722), // Rule ID 16886 //
     /* 1195647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195686 */     // MIs[0] round
     /* 1195686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1195699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195721 */     // GIR_Coverage, 16886,
     /* 1195721 */     GIR_EraseRootFromParent_Done,
     /* 1195722 */   // Label 17372: @1195722
     /* 1195722 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1195802), // Rule ID 16887 //
     /* 1195727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195766 */     // MIs[0] round
     /* 1195766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1195779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195801 */     // GIR_Coverage, 16887,
     /* 1195801 */     GIR_EraseRootFromParent_Done,
     /* 1195802 */   // Label 17373: @1195802
     /* 1195802 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1195882), // Rule ID 16890 //
     /* 1195807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1195818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1195821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1195824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195846 */     // MIs[0] round
     /* 1195846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1195859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195881 */     // GIR_Coverage, 16890,
     /* 1195881 */     GIR_EraseRootFromParent_Done,
     /* 1195882 */   // Label 17374: @1195882
     /* 1195882 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1195962), // Rule ID 16891 //
     /* 1195887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1195898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1195901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1195904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195926 */     // MIs[0] round
     /* 1195926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195936 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1195939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195961 */     // GIR_Coverage, 16891,
     /* 1195961 */     GIR_EraseRootFromParent_Done,
     /* 1195962 */   // Label 17375: @1195962
     /* 1195962 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1196042), // Rule ID 16894 //
     /* 1195967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1195978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1195981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196006 */     // MIs[0] round
     /* 1196006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196016 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196041 */     // GIR_Coverage, 16894,
     /* 1196041 */     GIR_EraseRootFromParent_Done,
     /* 1196042 */   // Label 17376: @1196042
     /* 1196042 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1196122), // Rule ID 16895 //
     /* 1196047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196086 */     // MIs[0] round
     /* 1196086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196096 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196121 */     // GIR_Coverage, 16895,
     /* 1196121 */     GIR_EraseRootFromParent_Done,
     /* 1196122 */   // Label 17377: @1196122
     /* 1196122 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1196202), // Rule ID 16898 //
     /* 1196127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196166 */     // MIs[0] round
     /* 1196166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196176 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196201 */     // GIR_Coverage, 16898,
     /* 1196201 */     GIR_EraseRootFromParent_Done,
     /* 1196202 */   // Label 17378: @1196202
     /* 1196202 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1196282), // Rule ID 16899 //
     /* 1196207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196246 */     // MIs[0] round
     /* 1196246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196256 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196281 */     // GIR_Coverage, 16899,
     /* 1196281 */     GIR_EraseRootFromParent_Done,
     /* 1196282 */   // Label 17379: @1196282
     /* 1196282 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1196362), // Rule ID 16902 //
     /* 1196287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196326 */     // MIs[0] round
     /* 1196326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196336 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196361 */     // GIR_Coverage, 16902,
     /* 1196361 */     GIR_EraseRootFromParent_Done,
     /* 1196362 */   // Label 17380: @1196362
     /* 1196362 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1196442), // Rule ID 16903 //
     /* 1196367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196406 */     // MIs[0] round
     /* 1196406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196416 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196441 */     // GIR_Coverage, 16903,
     /* 1196441 */     GIR_EraseRootFromParent_Done,
     /* 1196442 */   // Label 17381: @1196442
     /* 1196442 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1196522), // Rule ID 16906 //
     /* 1196447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196486 */     // MIs[0] round
     /* 1196486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196496 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196521 */     // GIR_Coverage, 16906,
     /* 1196521 */     GIR_EraseRootFromParent_Done,
     /* 1196522 */   // Label 17382: @1196522
     /* 1196522 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1196602), // Rule ID 16907 //
     /* 1196527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196566 */     // MIs[0] round
     /* 1196566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196601 */     // GIR_Coverage, 16907,
     /* 1196601 */     GIR_EraseRootFromParent_Done,
     /* 1196602 */   // Label 17383: @1196602
     /* 1196602 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1196682), // Rule ID 16910 //
     /* 1196607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196646 */     // MIs[0] round
     /* 1196646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196656 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1196659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196681 */     // GIR_Coverage, 16910,
     /* 1196681 */     GIR_EraseRootFromParent_Done,
     /* 1196682 */   // Label 17384: @1196682
     /* 1196682 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1196762), // Rule ID 16911 //
     /* 1196687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196726 */     // MIs[0] round
     /* 1196726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196736 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1196739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196761 */     // GIR_Coverage, 16911,
     /* 1196761 */     GIR_EraseRootFromParent_Done,
     /* 1196762 */   // Label 17385: @1196762
     /* 1196762 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1196842), // Rule ID 16914 //
     /* 1196767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1196784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196806 */     // MIs[0] round
     /* 1196806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196816 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1196819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196841 */     // GIR_Coverage, 16914,
     /* 1196841 */     GIR_EraseRootFromParent_Done,
     /* 1196842 */   // Label 17386: @1196842
     /* 1196842 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1196922), // Rule ID 16915 //
     /* 1196847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1196864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196886 */     // MIs[0] round
     /* 1196886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196896 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1196899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196921 */     // GIR_Coverage, 16915,
     /* 1196921 */     GIR_EraseRootFromParent_Done,
     /* 1196922 */   // Label 17387: @1196922
     /* 1196922 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1197002), // Rule ID 16918 //
     /* 1196927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1196938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1196941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1196944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196966 */     // MIs[0] round
     /* 1196966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196976 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1196979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197001 */     // GIR_Coverage, 16918,
     /* 1197001 */     GIR_EraseRootFromParent_Done,
     /* 1197002 */   // Label 17388: @1197002
     /* 1197002 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1197082), // Rule ID 16919 //
     /* 1197007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197046 */     // MIs[0] round
     /* 1197046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197056 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197081 */     // GIR_Coverage, 16919,
     /* 1197081 */     GIR_EraseRootFromParent_Done,
     /* 1197082 */   // Label 17389: @1197082
     /* 1197082 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1197162), // Rule ID 16922 //
     /* 1197087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197126 */     // MIs[0] round
     /* 1197126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197136 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197161 */     // GIR_Coverage, 16922,
     /* 1197161 */     GIR_EraseRootFromParent_Done,
     /* 1197162 */   // Label 17390: @1197162
     /* 1197162 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1197242), // Rule ID 16923 //
     /* 1197167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197206 */     // MIs[0] round
     /* 1197206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197216 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197241 */     // GIR_Coverage, 16923,
     /* 1197241 */     GIR_EraseRootFromParent_Done,
     /* 1197242 */   // Label 17391: @1197242
     /* 1197242 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1197322), // Rule ID 16926 //
     /* 1197247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197286 */     // MIs[0] round
     /* 1197286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197296 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197321 */     // GIR_Coverage, 16926,
     /* 1197321 */     GIR_EraseRootFromParent_Done,
     /* 1197322 */   // Label 17392: @1197322
     /* 1197322 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1197402), // Rule ID 16927 //
     /* 1197327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197366 */     // MIs[0] round
     /* 1197366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197376 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197401 */     // GIR_Coverage, 16927,
     /* 1197401 */     GIR_EraseRootFromParent_Done,
     /* 1197402 */   // Label 17393: @1197402
     /* 1197402 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1197482), // Rule ID 16930 //
     /* 1197407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197446 */     // MIs[0] round
     /* 1197446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197481 */     // GIR_Coverage, 16930,
     /* 1197481 */     GIR_EraseRootFromParent_Done,
     /* 1197482 */   // Label 17394: @1197482
     /* 1197482 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1197562), // Rule ID 16931 //
     /* 1197487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197526 */     // MIs[0] round
     /* 1197526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197536 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197561 */     // GIR_Coverage, 16931,
     /* 1197561 */     GIR_EraseRootFromParent_Done,
     /* 1197562 */   // Label 17395: @1197562
     /* 1197562 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1197642), // Rule ID 16934 //
     /* 1197567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197606 */     // MIs[0] round
     /* 1197606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197616 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1197619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197641 */     // GIR_Coverage, 16934,
     /* 1197641 */     GIR_EraseRootFromParent_Done,
     /* 1197642 */   // Label 17396: @1197642
     /* 1197642 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1197722), // Rule ID 16935 //
     /* 1197647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197686 */     // MIs[0] round
     /* 1197686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197696 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1197699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197721 */     // GIR_Coverage, 16935,
     /* 1197721 */     GIR_EraseRootFromParent_Done,
     /* 1197722 */   // Label 17397: @1197722
     /* 1197722 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1197802), // Rule ID 16938 //
     /* 1197727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1197738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1197741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197766 */     // MIs[0] round
     /* 1197766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197776 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1197779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197801 */     // GIR_Coverage, 16938,
     /* 1197801 */     GIR_EraseRootFromParent_Done,
     /* 1197802 */   // Label 17398: @1197802
     /* 1197802 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1197882), // Rule ID 16939 //
     /* 1197807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1197818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1197821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197846 */     // MIs[0] round
     /* 1197846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197856 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1197859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197881 */     // GIR_Coverage, 16939,
     /* 1197881 */     GIR_EraseRootFromParent_Done,
     /* 1197882 */   // Label 17399: @1197882
     /* 1197882 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1197962), // Rule ID 16942 //
     /* 1197887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1197898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1197901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197926 */     // MIs[0] round
     /* 1197926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197936 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1197939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197961 */     // GIR_Coverage, 16942,
     /* 1197961 */     GIR_EraseRootFromParent_Done,
     /* 1197962 */   // Label 17400: @1197962
     /* 1197962 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1198042), // Rule ID 16943 //
     /* 1197967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1197978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1197981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198006 */     // MIs[0] round
     /* 1198006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198016 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198041 */     // GIR_Coverage, 16943,
     /* 1198041 */     GIR_EraseRootFromParent_Done,
     /* 1198042 */   // Label 17401: @1198042
     /* 1198042 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1198122), // Rule ID 16946 //
     /* 1198047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198086 */     // MIs[0] round
     /* 1198086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198096 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198121 */     // GIR_Coverage, 16946,
     /* 1198121 */     GIR_EraseRootFromParent_Done,
     /* 1198122 */   // Label 17402: @1198122
     /* 1198122 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1198202), // Rule ID 16947 //
     /* 1198127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198166 */     // MIs[0] round
     /* 1198166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198201 */     // GIR_Coverage, 16947,
     /* 1198201 */     GIR_EraseRootFromParent_Done,
     /* 1198202 */   // Label 17403: @1198202
     /* 1198202 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1198282), // Rule ID 16950 //
     /* 1198207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198246 */     // MIs[0] round
     /* 1198246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198281 */     // GIR_Coverage, 16950,
     /* 1198281 */     GIR_EraseRootFromParent_Done,
     /* 1198282 */   // Label 17404: @1198282
     /* 1198282 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1198362), // Rule ID 16951 //
     /* 1198287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198326 */     // MIs[0] round
     /* 1198326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198361 */     // GIR_Coverage, 16951,
     /* 1198361 */     GIR_EraseRootFromParent_Done,
     /* 1198362 */   // Label 17405: @1198362
     /* 1198362 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1198442), // Rule ID 16954 //
     /* 1198367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198406 */     // MIs[0] round
     /* 1198406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198416 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198441 */     // GIR_Coverage, 16954,
     /* 1198441 */     GIR_EraseRootFromParent_Done,
     /* 1198442 */   // Label 17406: @1198442
     /* 1198442 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1198522), // Rule ID 16955 //
     /* 1198447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198486 */     // MIs[0] round
     /* 1198486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198496 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198521 */     // GIR_Coverage, 16955,
     /* 1198521 */     GIR_EraseRootFromParent_Done,
     /* 1198522 */   // Label 17407: @1198522
     /* 1198522 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1198602), // Rule ID 16958 //
     /* 1198527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198566 */     // MIs[0] round
     /* 1198566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198576 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198601 */     // GIR_Coverage, 16958,
     /* 1198601 */     GIR_EraseRootFromParent_Done,
     /* 1198602 */   // Label 17408: @1198602
     /* 1198602 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1198682), // Rule ID 16959 //
     /* 1198607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198646 */     // MIs[0] round
     /* 1198646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198681 */     // GIR_Coverage, 16959,
     /* 1198681 */     GIR_EraseRootFromParent_Done,
     /* 1198682 */   // Label 17409: @1198682
     /* 1198682 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1198762), // Rule ID 16962 //
     /* 1198687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1198698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1198701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1198704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198726 */     // MIs[0] round
     /* 1198726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198736 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1198739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198761 */     // GIR_Coverage, 16962,
     /* 1198761 */     GIR_EraseRootFromParent_Done,
     /* 1198762 */   // Label 17410: @1198762
     /* 1198762 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1198842), // Rule ID 16963 //
     /* 1198767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1198778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1198781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1198784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198806 */     // MIs[0] round
     /* 1198806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198816 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1198819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198841 */     // GIR_Coverage, 16963,
     /* 1198841 */     GIR_EraseRootFromParent_Done,
     /* 1198842 */   // Label 17411: @1198842
     /* 1198842 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1198922), // Rule ID 16966 //
     /* 1198847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198886 */     // MIs[0] round
     /* 1198886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198896 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1198899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198921 */     // GIR_Coverage, 16966,
     /* 1198921 */     GIR_EraseRootFromParent_Done,
     /* 1198922 */   // Label 17412: @1198922
     /* 1198922 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1199002), // Rule ID 16967 //
     /* 1198927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198966 */     // MIs[0] round
     /* 1198966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1198979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199001 */     // GIR_Coverage, 16967,
     /* 1199001 */     GIR_EraseRootFromParent_Done,
     /* 1199002 */   // Label 17413: @1199002
     /* 1199002 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1199082), // Rule ID 16970 //
     /* 1199007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199046 */     // MIs[0] round
     /* 1199046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199056 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199081 */     // GIR_Coverage, 16970,
     /* 1199081 */     GIR_EraseRootFromParent_Done,
     /* 1199082 */   // Label 17414: @1199082
     /* 1199082 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1199162), // Rule ID 16971 //
     /* 1199087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199126 */     // MIs[0] round
     /* 1199126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199136 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199161 */     // GIR_Coverage, 16971,
     /* 1199161 */     GIR_EraseRootFromParent_Done,
     /* 1199162 */   // Label 17415: @1199162
     /* 1199162 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1199242), // Rule ID 16974 //
     /* 1199167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199206 */     // MIs[0] round
     /* 1199206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199216 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199241 */     // GIR_Coverage, 16974,
     /* 1199241 */     GIR_EraseRootFromParent_Done,
     /* 1199242 */   // Label 17416: @1199242
     /* 1199242 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1199322), // Rule ID 16975 //
     /* 1199247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199286 */     // MIs[0] round
     /* 1199286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199296 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199321 */     // GIR_Coverage, 16975,
     /* 1199321 */     GIR_EraseRootFromParent_Done,
     /* 1199322 */   // Label 17417: @1199322
     /* 1199322 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1199402), // Rule ID 16978 //
     /* 1199327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199366 */     // MIs[0] round
     /* 1199366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199401 */     // GIR_Coverage, 16978,
     /* 1199401 */     GIR_EraseRootFromParent_Done,
     /* 1199402 */   // Label 17418: @1199402
     /* 1199402 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1199482), // Rule ID 16979 //
     /* 1199407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199446 */     // MIs[0] round
     /* 1199446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199456 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199481 */     // GIR_Coverage, 16979,
     /* 1199481 */     GIR_EraseRootFromParent_Done,
     /* 1199482 */   // Label 17419: @1199482
     /* 1199482 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1199562), // Rule ID 16982 //
     /* 1199487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199526 */     // MIs[0] round
     /* 1199526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199536 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199561 */     // GIR_Coverage, 16982,
     /* 1199561 */     GIR_EraseRootFromParent_Done,
     /* 1199562 */   // Label 17420: @1199562
     /* 1199562 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1199642), // Rule ID 16983 //
     /* 1199567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199606 */     // MIs[0] round
     /* 1199606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199616 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199641 */     // GIR_Coverage, 16983,
     /* 1199641 */     GIR_EraseRootFromParent_Done,
     /* 1199642 */   // Label 17421: @1199642
     /* 1199642 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1199722), // Rule ID 16986 //
     /* 1199647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199686 */     // MIs[0] round
     /* 1199686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199696 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1199699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199721 */     // GIR_Coverage, 16986,
     /* 1199721 */     GIR_EraseRootFromParent_Done,
     /* 1199722 */   // Label 17422: @1199722
     /* 1199722 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1199802), // Rule ID 16987 //
     /* 1199727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199766 */     // MIs[0] round
     /* 1199766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199776 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1199779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199801 */     // GIR_Coverage, 16987,
     /* 1199801 */     GIR_EraseRootFromParent_Done,
     /* 1199802 */   // Label 17423: @1199802
     /* 1199802 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1199882), // Rule ID 16990 //
     /* 1199807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1199810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1199815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1199827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199846 */     // MIs[0] round
     /* 1199846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199856 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1199859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199881 */     // GIR_Coverage, 16990,
     /* 1199881 */     GIR_EraseRootFromParent_Done,
     /* 1199882 */   // Label 17424: @1199882
     /* 1199882 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1199962), // Rule ID 16991 //
     /* 1199887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1199890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1199895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1199907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199926 */     // MIs[0] round
     /* 1199926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199936 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1199939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199961 */     // GIR_Coverage, 16991,
     /* 1199961 */     GIR_EraseRootFromParent_Done,
     /* 1199962 */   // Label 17425: @1199962
     /* 1199962 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1200042), // Rule ID 16994 //
     /* 1199967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1199970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1199975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1199978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1199981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1199984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1199987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200006 */     // MIs[0] round
     /* 1200006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200041 */     // GIR_Coverage, 16994,
     /* 1200041 */     GIR_EraseRootFromParent_Done,
     /* 1200042 */   // Label 17426: @1200042
     /* 1200042 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1200122), // Rule ID 16995 //
     /* 1200047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200086 */     // MIs[0] round
     /* 1200086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200096 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200121 */     // GIR_Coverage, 16995,
     /* 1200121 */     GIR_EraseRootFromParent_Done,
     /* 1200122 */   // Label 17427: @1200122
     /* 1200122 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1200202), // Rule ID 16998 //
     /* 1200127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200166 */     // MIs[0] round
     /* 1200166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200201 */     // GIR_Coverage, 16998,
     /* 1200201 */     GIR_EraseRootFromParent_Done,
     /* 1200202 */   // Label 17428: @1200202
     /* 1200202 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1200282), // Rule ID 16999 //
     /* 1200207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200246 */     // MIs[0] round
     /* 1200246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200256 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200281 */     // GIR_Coverage, 16999,
     /* 1200281 */     GIR_EraseRootFromParent_Done,
     /* 1200282 */   // Label 17429: @1200282
     /* 1200282 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1200362), // Rule ID 17002 //
     /* 1200287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200326 */     // MIs[0] round
     /* 1200326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200361 */     // GIR_Coverage, 17002,
     /* 1200361 */     GIR_EraseRootFromParent_Done,
     /* 1200362 */   // Label 17430: @1200362
     /* 1200362 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1200442), // Rule ID 17003 //
     /* 1200367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200406 */     // MIs[0] round
     /* 1200406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200416 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200441 */     // GIR_Coverage, 17003,
     /* 1200441 */     GIR_EraseRootFromParent_Done,
     /* 1200442 */   // Label 17431: @1200442
     /* 1200442 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1200522), // Rule ID 17006 //
     /* 1200447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200486 */     // MIs[0] round
     /* 1200486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200496 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200521 */     // GIR_Coverage, 17006,
     /* 1200521 */     GIR_EraseRootFromParent_Done,
     /* 1200522 */   // Label 17432: @1200522
     /* 1200522 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1200602), // Rule ID 17007 //
     /* 1200527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200566 */     // MIs[0] round
     /* 1200566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200576 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200601 */     // GIR_Coverage, 17007,
     /* 1200601 */     GIR_EraseRootFromParent_Done,
     /* 1200602 */   // Label 17433: @1200602
     /* 1200602 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1200682), // Rule ID 17010 //
     /* 1200607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1200627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200646 */     // MIs[0] round
     /* 1200646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1200659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200681 */     // GIR_Coverage, 17010,
     /* 1200681 */     GIR_EraseRootFromParent_Done,
     /* 1200682 */   // Label 17434: @1200682
     /* 1200682 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1200762), // Rule ID 17011 //
     /* 1200687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1200690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1200707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200726 */     // MIs[0] round
     /* 1200726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1200739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200761 */     // GIR_Coverage, 17011,
     /* 1200761 */     GIR_EraseRootFromParent_Done,
     /* 1200762 */   // Label 17435: @1200762
     /* 1200762 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1200842), // Rule ID 17014 //
     /* 1200767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1200784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1200787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200806 */     // MIs[0] round
     /* 1200806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200816 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1200819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200841 */     // GIR_Coverage, 17014,
     /* 1200841 */     GIR_EraseRootFromParent_Done,
     /* 1200842 */   // Label 17436: @1200842
     /* 1200842 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1200922), // Rule ID 17015 //
     /* 1200847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1200850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1200864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1200867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200886 */     // MIs[0] round
     /* 1200886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200896 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1200899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200921 */     // GIR_Coverage, 17015,
     /* 1200921 */     GIR_EraseRootFromParent_Done,
     /* 1200922 */   // Label 17437: @1200922
     /* 1200922 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1201002), // Rule ID 17018 //
     /* 1200927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1200944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1200947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200966 */     // MIs[0] round
     /* 1200966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200976 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1200979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201001 */     // GIR_Coverage, 17018,
     /* 1201001 */     GIR_EraseRootFromParent_Done,
     /* 1201002 */   // Label 17438: @1201002
     /* 1201002 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1201082), // Rule ID 17019 //
     /* 1201007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201046 */     // MIs[0] round
     /* 1201046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201056 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201081 */     // GIR_Coverage, 17019,
     /* 1201081 */     GIR_EraseRootFromParent_Done,
     /* 1201082 */   // Label 17439: @1201082
     /* 1201082 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1201162), // Rule ID 17022 //
     /* 1201087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201126 */     // MIs[0] round
     /* 1201126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201136 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201161 */     // GIR_Coverage, 17022,
     /* 1201161 */     GIR_EraseRootFromParent_Done,
     /* 1201162 */   // Label 17440: @1201162
     /* 1201162 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1201242), // Rule ID 17023 //
     /* 1201167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201206 */     // MIs[0] round
     /* 1201206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201216 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201241 */     // GIR_Coverage, 17023,
     /* 1201241 */     GIR_EraseRootFromParent_Done,
     /* 1201242 */   // Label 17441: @1201242
     /* 1201242 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1201322), // Rule ID 17026 //
     /* 1201247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201286 */     // MIs[0] round
     /* 1201286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201321 */     // GIR_Coverage, 17026,
     /* 1201321 */     GIR_EraseRootFromParent_Done,
     /* 1201322 */   // Label 17442: @1201322
     /* 1201322 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1201402), // Rule ID 17027 //
     /* 1201327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201366 */     // MIs[0] round
     /* 1201366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201401 */     // GIR_Coverage, 17027,
     /* 1201401 */     GIR_EraseRootFromParent_Done,
     /* 1201402 */   // Label 17443: @1201402
     /* 1201402 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1201482), // Rule ID 17030 //
     /* 1201407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201446 */     // MIs[0] round
     /* 1201446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201481 */     // GIR_Coverage, 17030,
     /* 1201481 */     GIR_EraseRootFromParent_Done,
     /* 1201482 */   // Label 17444: @1201482
     /* 1201482 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1201562), // Rule ID 17031 //
     /* 1201487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201526 */     // MIs[0] round
     /* 1201526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201561 */     // GIR_Coverage, 17031,
     /* 1201561 */     GIR_EraseRootFromParent_Done,
     /* 1201562 */   // Label 17445: @1201562
     /* 1201562 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1201642), // Rule ID 17034 //
     /* 1201567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201606 */     // MIs[0] round
     /* 1201606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1201619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201641 */     // GIR_Coverage, 17034,
     /* 1201641 */     GIR_EraseRootFromParent_Done,
     /* 1201642 */   // Label 17446: @1201642
     /* 1201642 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1201722), // Rule ID 17035 //
     /* 1201647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201686 */     // MIs[0] round
     /* 1201686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201696 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1201699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201721 */     // GIR_Coverage, 17035,
     /* 1201721 */     GIR_EraseRootFromParent_Done,
     /* 1201722 */   // Label 17447: @1201722
     /* 1201722 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1201802), // Rule ID 17038 //
     /* 1201727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201766 */     // MIs[0] round
     /* 1201766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201776 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1201779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201801 */     // GIR_Coverage, 17038,
     /* 1201801 */     GIR_EraseRootFromParent_Done,
     /* 1201802 */   // Label 17448: @1201802
     /* 1201802 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1201882), // Rule ID 17039 //
     /* 1201807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1201824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201846 */     // MIs[0] round
     /* 1201846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1201859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201881 */     // GIR_Coverage, 17039,
     /* 1201881 */     GIR_EraseRootFromParent_Done,
     /* 1201882 */   // Label 17449: @1201882
     /* 1201882 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1201962), // Rule ID 17042 //
     /* 1201887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201926 */     // MIs[0] round
     /* 1201926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201936 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1201939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201961 */     // GIR_Coverage, 17042,
     /* 1201961 */     GIR_EraseRootFromParent_Done,
     /* 1201962 */   // Label 17450: @1201962
     /* 1201962 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1202042), // Rule ID 17043 //
     /* 1201967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1201984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202006 */     // MIs[0] round
     /* 1202006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202016 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202041 */     // GIR_Coverage, 17043,
     /* 1202041 */     GIR_EraseRootFromParent_Done,
     /* 1202042 */   // Label 17451: @1202042
     /* 1202042 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1202122), // Rule ID 17046 //
     /* 1202047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202086 */     // MIs[0] round
     /* 1202086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202121 */     // GIR_Coverage, 17046,
     /* 1202121 */     GIR_EraseRootFromParent_Done,
     /* 1202122 */   // Label 17452: @1202122
     /* 1202122 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1202202), // Rule ID 17047 //
     /* 1202127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202166 */     // MIs[0] round
     /* 1202166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202201 */     // GIR_Coverage, 17047,
     /* 1202201 */     GIR_EraseRootFromParent_Done,
     /* 1202202 */   // Label 17453: @1202202
     /* 1202202 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1202282), // Rule ID 17050 //
     /* 1202207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202246 */     // MIs[0] round
     /* 1202246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202281 */     // GIR_Coverage, 17050,
     /* 1202281 */     GIR_EraseRootFromParent_Done,
     /* 1202282 */   // Label 17454: @1202282
     /* 1202282 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1202362), // Rule ID 17051 //
     /* 1202287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202326 */     // MIs[0] round
     /* 1202326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202361 */     // GIR_Coverage, 17051,
     /* 1202361 */     GIR_EraseRootFromParent_Done,
     /* 1202362 */   // Label 17455: @1202362
     /* 1202362 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1202442), // Rule ID 17054 //
     /* 1202367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202406 */     // MIs[0] round
     /* 1202406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202441 */     // GIR_Coverage, 17054,
     /* 1202441 */     GIR_EraseRootFromParent_Done,
     /* 1202442 */   // Label 17456: @1202442
     /* 1202442 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1202522), // Rule ID 17055 //
     /* 1202447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202486 */     // MIs[0] round
     /* 1202486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202521 */     // GIR_Coverage, 17055,
     /* 1202521 */     GIR_EraseRootFromParent_Done,
     /* 1202522 */   // Label 17457: @1202522
     /* 1202522 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1202602), // Rule ID 17058 //
     /* 1202527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202566 */     // MIs[0] round
     /* 1202566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202576 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202601 */     // GIR_Coverage, 17058,
     /* 1202601 */     GIR_EraseRootFromParent_Done,
     /* 1202602 */   // Label 17458: @1202602
     /* 1202602 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1202682), // Rule ID 17059 //
     /* 1202607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202646 */     // MIs[0] round
     /* 1202646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202656 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202681 */     // GIR_Coverage, 17059,
     /* 1202681 */     GIR_EraseRootFromParent_Done,
     /* 1202682 */   // Label 17459: @1202682
     /* 1202682 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1202762), // Rule ID 17062 //
     /* 1202687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1202695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1202707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202726 */     // MIs[0] round
     /* 1202726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202736 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1202739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202761 */     // GIR_Coverage, 17062,
     /* 1202761 */     GIR_EraseRootFromParent_Done,
     /* 1202762 */   // Label 17460: @1202762
     /* 1202762 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1202842), // Rule ID 17063 //
     /* 1202767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1202775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1202784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1202787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202806 */     // MIs[0] round
     /* 1202806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202816 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1202819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202841 */     // GIR_Coverage, 17063,
     /* 1202841 */     GIR_EraseRootFromParent_Done,
     /* 1202842 */   // Label 17461: @1202842
     /* 1202842 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1202922), // Rule ID 17066 //
     /* 1202847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1202855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1202867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202886 */     // MIs[0] round
     /* 1202886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1202899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202921 */     // GIR_Coverage, 17066,
     /* 1202921 */     GIR_EraseRootFromParent_Done,
     /* 1202922 */   // Label 17462: @1202922
     /* 1202922 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1203002), // Rule ID 17067 //
     /* 1202927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1202935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1202944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1202947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202966 */     // MIs[0] round
     /* 1202966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1202979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203001 */     // GIR_Coverage, 17067,
     /* 1203001 */     GIR_EraseRootFromParent_Done,
     /* 1203002 */   // Label 17463: @1203002
     /* 1203002 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1203082), // Rule ID 17070 //
     /* 1203007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203046 */     // MIs[0] round
     /* 1203046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203081 */     // GIR_Coverage, 17070,
     /* 1203081 */     GIR_EraseRootFromParent_Done,
     /* 1203082 */   // Label 17464: @1203082
     /* 1203082 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1203162), // Rule ID 17071 //
     /* 1203087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203126 */     // MIs[0] round
     /* 1203126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203161 */     // GIR_Coverage, 17071,
     /* 1203161 */     GIR_EraseRootFromParent_Done,
     /* 1203162 */   // Label 17465: @1203162
     /* 1203162 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1203242), // Rule ID 17074 //
     /* 1203167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203206 */     // MIs[0] round
     /* 1203206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203216 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203241 */     // GIR_Coverage, 17074,
     /* 1203241 */     GIR_EraseRootFromParent_Done,
     /* 1203242 */   // Label 17466: @1203242
     /* 1203242 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1203322), // Rule ID 17075 //
     /* 1203247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203286 */     // MIs[0] round
     /* 1203286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203296 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203321 */     // GIR_Coverage, 17075,
     /* 1203321 */     GIR_EraseRootFromParent_Done,
     /* 1203322 */   // Label 17467: @1203322
     /* 1203322 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1203402), // Rule ID 17078 //
     /* 1203327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203366 */     // MIs[0] round
     /* 1203366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203376 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203401 */     // GIR_Coverage, 17078,
     /* 1203401 */     GIR_EraseRootFromParent_Done,
     /* 1203402 */   // Label 17468: @1203402
     /* 1203402 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1203482), // Rule ID 17079 //
     /* 1203407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203446 */     // MIs[0] round
     /* 1203446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203456 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203481 */     // GIR_Coverage, 17079,
     /* 1203481 */     GIR_EraseRootFromParent_Done,
     /* 1203482 */   // Label 17469: @1203482
     /* 1203482 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1203562), // Rule ID 17082 //
     /* 1203487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203526 */     // MIs[0] round
     /* 1203526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203536 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203561 */     // GIR_Coverage, 17082,
     /* 1203561 */     GIR_EraseRootFromParent_Done,
     /* 1203562 */   // Label 17470: @1203562
     /* 1203562 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1203642), // Rule ID 17083 //
     /* 1203567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203606 */     // MIs[0] round
     /* 1203606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203616 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203641 */     // GIR_Coverage, 17083,
     /* 1203641 */     GIR_EraseRootFromParent_Done,
     /* 1203642 */   // Label 17471: @1203642
     /* 1203642 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1203722), // Rule ID 17086 //
     /* 1203647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1203667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203686 */     // MIs[0] round
     /* 1203686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203696 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1203699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203721 */     // GIR_Coverage, 17086,
     /* 1203721 */     GIR_EraseRootFromParent_Done,
     /* 1203722 */   // Label 17472: @1203722
     /* 1203722 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1203802), // Rule ID 17087 //
     /* 1203727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1203747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203766 */     // MIs[0] round
     /* 1203766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1203779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203801 */     // GIR_Coverage, 17087,
     /* 1203801 */     GIR_EraseRootFromParent_Done,
     /* 1203802 */   // Label 17473: @1203802
     /* 1203802 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1203882), // Rule ID 17090 //
     /* 1203807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1203827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203846 */     // MIs[0] round
     /* 1203846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203856 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1203859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203881 */     // GIR_Coverage, 17090,
     /* 1203881 */     GIR_EraseRootFromParent_Done,
     /* 1203882 */   // Label 17474: @1203882
     /* 1203882 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1203962), // Rule ID 17091 //
     /* 1203887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1203904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1203907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203926 */     // MIs[0] round
     /* 1203926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203936 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1203939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203961 */     // GIR_Coverage, 17091,
     /* 1203961 */     GIR_EraseRootFromParent_Done,
     /* 1203962 */   // Label 17475: @1203962
     /* 1203962 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1204042), // Rule ID 17094 //
     /* 1203967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1203987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204006 */     // MIs[0] round
     /* 1204006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204016 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204041 */     // GIR_Coverage, 17094,
     /* 1204041 */     GIR_EraseRootFromParent_Done,
     /* 1204042 */   // Label 17476: @1204042
     /* 1204042 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1204122), // Rule ID 17095 //
     /* 1204047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204086 */     // MIs[0] round
     /* 1204086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204096 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204121 */     // GIR_Coverage, 17095,
     /* 1204121 */     GIR_EraseRootFromParent_Done,
     /* 1204122 */   // Label 17477: @1204122
     /* 1204122 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1204202), // Rule ID 17098 //
     /* 1204127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204166 */     // MIs[0] round
     /* 1204166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204176 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204201 */     // GIR_Coverage, 17098,
     /* 1204201 */     GIR_EraseRootFromParent_Done,
     /* 1204202 */   // Label 17478: @1204202
     /* 1204202 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1204282), // Rule ID 17099 //
     /* 1204207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204246 */     // MIs[0] round
     /* 1204246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204281 */     // GIR_Coverage, 17099,
     /* 1204281 */     GIR_EraseRootFromParent_Done,
     /* 1204282 */   // Label 17479: @1204282
     /* 1204282 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1204362), // Rule ID 17102 //
     /* 1204287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204326 */     // MIs[0] round
     /* 1204326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204361 */     // GIR_Coverage, 17102,
     /* 1204361 */     GIR_EraseRootFromParent_Done,
     /* 1204362 */   // Label 17480: @1204362
     /* 1204362 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1204442), // Rule ID 17103 //
     /* 1204367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204406 */     // MIs[0] round
     /* 1204406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204416 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204441 */     // GIR_Coverage, 17103,
     /* 1204441 */     GIR_EraseRootFromParent_Done,
     /* 1204442 */   // Label 17481: @1204442
     /* 1204442 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1204522), // Rule ID 17106 //
     /* 1204447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204486 */     // MIs[0] round
     /* 1204486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204496 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204521 */     // GIR_Coverage, 17106,
     /* 1204521 */     GIR_EraseRootFromParent_Done,
     /* 1204522 */   // Label 17482: @1204522
     /* 1204522 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1204602), // Rule ID 17107 //
     /* 1204527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204566 */     // MIs[0] round
     /* 1204566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204601 */     // GIR_Coverage, 17107,
     /* 1204601 */     GIR_EraseRootFromParent_Done,
     /* 1204602 */   // Label 17483: @1204602
     /* 1204602 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1204682), // Rule ID 17110 //
     /* 1204607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204646 */     // MIs[0] round
     /* 1204646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204656 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1204659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204681 */     // GIR_Coverage, 17110,
     /* 1204681 */     GIR_EraseRootFromParent_Done,
     /* 1204682 */   // Label 17484: @1204682
     /* 1204682 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1204762), // Rule ID 17111 //
     /* 1204687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204726 */     // MIs[0] round
     /* 1204726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204736 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1204739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204761 */     // GIR_Coverage, 17111,
     /* 1204761 */     GIR_EraseRootFromParent_Done,
     /* 1204762 */   // Label 17485: @1204762
     /* 1204762 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1204842), // Rule ID 17114 //
     /* 1204767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204806 */     // MIs[0] round
     /* 1204806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204816 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1204819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204841 */     // GIR_Coverage, 17114,
     /* 1204841 */     GIR_EraseRootFromParent_Done,
     /* 1204842 */   // Label 17486: @1204842
     /* 1204842 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1204922), // Rule ID 17115 //
     /* 1204847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1204864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204886 */     // MIs[0] round
     /* 1204886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204896 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1204899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204921 */     // GIR_Coverage, 17115,
     /* 1204921 */     GIR_EraseRootFromParent_Done,
     /* 1204922 */   // Label 17487: @1204922
     /* 1204922 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1205002), // Rule ID 17118 //
     /* 1204927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1204947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1204966 */     // MIs[0] round
     /* 1204966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1204979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205001 */     // GIR_Coverage, 17118,
     /* 1205001 */     GIR_EraseRootFromParent_Done,
     /* 1205002 */   // Label 17488: @1205002
     /* 1205002 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1205082), // Rule ID 17119 //
     /* 1205007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205046 */     // MIs[0] round
     /* 1205046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205081 */     // GIR_Coverage, 17119,
     /* 1205081 */     GIR_EraseRootFromParent_Done,
     /* 1205082 */   // Label 17489: @1205082
     /* 1205082 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1205162), // Rule ID 17122 //
     /* 1205087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205126 */     // MIs[0] round
     /* 1205126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205136 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205161 */     // GIR_Coverage, 17122,
     /* 1205161 */     GIR_EraseRootFromParent_Done,
     /* 1205162 */   // Label 17490: @1205162
     /* 1205162 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1205242), // Rule ID 17123 //
     /* 1205167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205206 */     // MIs[0] round
     /* 1205206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205216 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205241 */     // GIR_Coverage, 17123,
     /* 1205241 */     GIR_EraseRootFromParent_Done,
     /* 1205242 */   // Label 17491: @1205242
     /* 1205242 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1205322), // Rule ID 17126 //
     /* 1205247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205286 */     // MIs[0] round
     /* 1205286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205296 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205321 */     // GIR_Coverage, 17126,
     /* 1205321 */     GIR_EraseRootFromParent_Done,
     /* 1205322 */   // Label 17492: @1205322
     /* 1205322 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1205402), // Rule ID 17127 //
     /* 1205327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205366 */     // MIs[0] round
     /* 1205366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205376 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205401 */     // GIR_Coverage, 17127,
     /* 1205401 */     GIR_EraseRootFromParent_Done,
     /* 1205402 */   // Label 17493: @1205402
     /* 1205402 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1205482), // Rule ID 17130 //
     /* 1205407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205446 */     // MIs[0] round
     /* 1205446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205456 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205481 */     // GIR_Coverage, 17130,
     /* 1205481 */     GIR_EraseRootFromParent_Done,
     /* 1205482 */   // Label 17494: @1205482
     /* 1205482 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1205562), // Rule ID 17131 //
     /* 1205487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205526 */     // MIs[0] round
     /* 1205526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205536 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205561 */     // GIR_Coverage, 17131,
     /* 1205561 */     GIR_EraseRootFromParent_Done,
     /* 1205562 */   // Label 17495: @1205562
     /* 1205562 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1205642), // Rule ID 17136 //
     /* 1205567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205606 */     // MIs[0] round
     /* 1205606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1205619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205641 */     // GIR_Coverage, 17136,
     /* 1205641 */     GIR_EraseRootFromParent_Done,
     /* 1205642 */   // Label 17496: @1205642
     /* 1205642 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1205722), // Rule ID 17137 //
     /* 1205647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205686 */     // MIs[0] round
     /* 1205686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1205699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205721 */     // GIR_Coverage, 17137,
     /* 1205721 */     GIR_EraseRootFromParent_Done,
     /* 1205722 */   // Label 17497: @1205722
     /* 1205722 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1205802), // Rule ID 17146 //
     /* 1205727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1205747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205766 */     // MIs[0] round
     /* 1205766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1205779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205801 */     // GIR_Coverage, 17146,
     /* 1205801 */     GIR_EraseRootFromParent_Done,
     /* 1205802 */   // Label 17498: @1205802
     /* 1205802 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1205882), // Rule ID 17147 //
     /* 1205807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1205827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205846 */     // MIs[0] round
     /* 1205846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1205859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205881 */     // GIR_Coverage, 17147,
     /* 1205881 */     GIR_EraseRootFromParent_Done,
     /* 1205882 */   // Label 17499: @1205882
     /* 1205882 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1205962), // Rule ID 17156 //
     /* 1205887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1205907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205926 */     // MIs[0] round
     /* 1205926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1205939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205961 */     // GIR_Coverage, 17156,
     /* 1205961 */     GIR_EraseRootFromParent_Done,
     /* 1205962 */   // Label 17500: @1205962
     /* 1205962 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1206042), // Rule ID 17157 //
     /* 1205967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1205987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206006 */     // MIs[0] round
     /* 1206006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206041 */     // GIR_Coverage, 17157,
     /* 1206041 */     GIR_EraseRootFromParent_Done,
     /* 1206042 */   // Label 17501: @1206042
     /* 1206042 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1206122), // Rule ID 17166 //
     /* 1206047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206086 */     // MIs[0] round
     /* 1206086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206096 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206121 */     // GIR_Coverage, 17166,
     /* 1206121 */     GIR_EraseRootFromParent_Done,
     /* 1206122 */   // Label 17502: @1206122
     /* 1206122 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1206202), // Rule ID 17167 //
     /* 1206127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206166 */     // MIs[0] round
     /* 1206166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206176 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206201 */     // GIR_Coverage, 17167,
     /* 1206201 */     GIR_EraseRootFromParent_Done,
     /* 1206202 */   // Label 17503: @1206202
     /* 1206202 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1206282), // Rule ID 17176 //
     /* 1206207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206246 */     // MIs[0] round
     /* 1206246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206281 */     // GIR_Coverage, 17176,
     /* 1206281 */     GIR_EraseRootFromParent_Done,
     /* 1206282 */   // Label 17504: @1206282
     /* 1206282 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1206362), // Rule ID 17177 //
     /* 1206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206326 */     // MIs[0] round
     /* 1206326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206361 */     // GIR_Coverage, 17177,
     /* 1206361 */     GIR_EraseRootFromParent_Done,
     /* 1206362 */   // Label 17505: @1206362
     /* 1206362 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1206442), // Rule ID 17186 //
     /* 1206367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206406 */     // MIs[0] round
     /* 1206406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206416 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206441 */     // GIR_Coverage, 17186,
     /* 1206441 */     GIR_EraseRootFromParent_Done,
     /* 1206442 */   // Label 17506: @1206442
     /* 1206442 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1206522), // Rule ID 17187 //
     /* 1206447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206486 */     // MIs[0] round
     /* 1206486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206521 */     // GIR_Coverage, 17187,
     /* 1206521 */     GIR_EraseRootFromParent_Done,
     /* 1206522 */   // Label 17507: @1206522
     /* 1206522 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1206602), // Rule ID 17196 //
     /* 1206527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206566 */     // MIs[0] round
     /* 1206566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206576 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206601 */     // GIR_Coverage, 17196,
     /* 1206601 */     GIR_EraseRootFromParent_Done,
     /* 1206602 */   // Label 17508: @1206602
     /* 1206602 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1206682), // Rule ID 17197 //
     /* 1206607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206646 */     // MIs[0] round
     /* 1206646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206656 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206681 */     // GIR_Coverage, 17197,
     /* 1206681 */     GIR_EraseRootFromParent_Done,
     /* 1206682 */   // Label 17509: @1206682
     /* 1206682 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1206762), // Rule ID 17206 //
     /* 1206687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1206704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1206707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206726 */     // MIs[0] round
     /* 1206726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206736 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1206739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206761 */     // GIR_Coverage, 17206,
     /* 1206761 */     GIR_EraseRootFromParent_Done,
     /* 1206762 */   // Label 17510: @1206762
     /* 1206762 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1206842), // Rule ID 17207 //
     /* 1206767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1206784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1206787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206806 */     // MIs[0] round
     /* 1206806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206816 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1206819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206841 */     // GIR_Coverage, 17207,
     /* 1206841 */     GIR_EraseRootFromParent_Done,
     /* 1206842 */   // Label 17511: @1206842
     /* 1206842 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1206922), // Rule ID 17214 //
     /* 1206847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1206858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1206861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1206864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206886 */     // MIs[0] round
     /* 1206886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1206899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206921 */     // GIR_Coverage, 17214,
     /* 1206921 */     GIR_EraseRootFromParent_Done,
     /* 1206922 */   // Label 17512: @1206922
     /* 1206922 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1207002), // Rule ID 17215 //
     /* 1206927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1206938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1206941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1206944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206966 */     // MIs[0] round
     /* 1206966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206976 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1206979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207001 */     // GIR_Coverage, 17215,
     /* 1207001 */     GIR_EraseRootFromParent_Done,
     /* 1207002 */   // Label 17513: @1207002
     /* 1207002 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1207082), // Rule ID 17218 //
     /* 1207007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207046 */     // MIs[0] round
     /* 1207046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207081 */     // GIR_Coverage, 17218,
     /* 1207081 */     GIR_EraseRootFromParent_Done,
     /* 1207082 */   // Label 17514: @1207082
     /* 1207082 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1207162), // Rule ID 17219 //
     /* 1207087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207126 */     // MIs[0] round
     /* 1207126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207136 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207161 */     // GIR_Coverage, 17219,
     /* 1207161 */     GIR_EraseRootFromParent_Done,
     /* 1207162 */   // Label 17515: @1207162
     /* 1207162 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1207242), // Rule ID 17222 //
     /* 1207167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207206 */     // MIs[0] round
     /* 1207206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207241 */     // GIR_Coverage, 17222,
     /* 1207241 */     GIR_EraseRootFromParent_Done,
     /* 1207242 */   // Label 17516: @1207242
     /* 1207242 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1207322), // Rule ID 17223 //
     /* 1207247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207286 */     // MIs[0] round
     /* 1207286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207321 */     // GIR_Coverage, 17223,
     /* 1207321 */     GIR_EraseRootFromParent_Done,
     /* 1207322 */   // Label 17517: @1207322
     /* 1207322 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1207402), // Rule ID 17226 //
     /* 1207327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207366 */     // MIs[0] round
     /* 1207366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207376 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207401 */     // GIR_Coverage, 17226,
     /* 1207401 */     GIR_EraseRootFromParent_Done,
     /* 1207402 */   // Label 17518: @1207402
     /* 1207402 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1207482), // Rule ID 17227 //
     /* 1207407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207446 */     // MIs[0] round
     /* 1207446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207481 */     // GIR_Coverage, 17227,
     /* 1207481 */     GIR_EraseRootFromParent_Done,
     /* 1207482 */   // Label 17519: @1207482
     /* 1207482 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1207562), // Rule ID 17230 //
     /* 1207487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207526 */     // MIs[0] round
     /* 1207526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207536 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207561 */     // GIR_Coverage, 17230,
     /* 1207561 */     GIR_EraseRootFromParent_Done,
     /* 1207562 */   // Label 17520: @1207562
     /* 1207562 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1207642), // Rule ID 17231 //
     /* 1207567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207606 */     // MIs[0] round
     /* 1207606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207616 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207641 */     // GIR_Coverage, 17231,
     /* 1207641 */     GIR_EraseRootFromParent_Done,
     /* 1207642 */   // Label 17521: @1207642
     /* 1207642 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1207722), // Rule ID 17234 //
     /* 1207647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1207686 */     // MIs[0] round
     /* 1207686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1207699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207721 */     // GIR_Coverage, 17234,
     /* 1207721 */     GIR_EraseRootFromParent_Done,
     /* 1207722 */   // Label 17522: @1207722
     /* 1207722 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1207802), // Rule ID 17235 //
     /* 1207727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1207766 */     // MIs[0] round
     /* 1207766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1207779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207801 */     // GIR_Coverage, 17235,
     /* 1207801 */     GIR_EraseRootFromParent_Done,
     /* 1207802 */   // Label 17523: @1207802
     /* 1207802 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1207882), // Rule ID 17238 //
     /* 1207807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1207846 */     // MIs[0] round
     /* 1207846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1207859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207881 */     // GIR_Coverage, 17238,
     /* 1207881 */     GIR_EraseRootFromParent_Done,
     /* 1207882 */   // Label 17524: @1207882
     /* 1207882 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1207962), // Rule ID 17239 //
     /* 1207887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1207898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1207901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1207904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1207926 */     // MIs[0] round
     /* 1207926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1207939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207961 */     // GIR_Coverage, 17239,
     /* 1207961 */     GIR_EraseRootFromParent_Done,
     /* 1207962 */   // Label 17525: @1207962
     /* 1207962 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1208042), // Rule ID 17242 //
     /* 1207967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1207978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1207981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1207984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208006 */     // MIs[0] round
     /* 1208006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208016 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208041 */     // GIR_Coverage, 17242,
     /* 1208041 */     GIR_EraseRootFromParent_Done,
     /* 1208042 */   // Label 17526: @1208042
     /* 1208042 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1208122), // Rule ID 17243 //
     /* 1208047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208086 */     // MIs[0] round
     /* 1208086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208096 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208121 */     // GIR_Coverage, 17243,
     /* 1208121 */     GIR_EraseRootFromParent_Done,
     /* 1208122 */   // Label 17527: @1208122
     /* 1208122 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1208202), // Rule ID 17246 //
     /* 1208127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208166 */     // MIs[0] round
     /* 1208166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208176 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208201 */     // GIR_Coverage, 17246,
     /* 1208201 */     GIR_EraseRootFromParent_Done,
     /* 1208202 */   // Label 17528: @1208202
     /* 1208202 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1208282), // Rule ID 17247 //
     /* 1208207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208246 */     // MIs[0] round
     /* 1208246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208256 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208281 */     // GIR_Coverage, 17247,
     /* 1208281 */     GIR_EraseRootFromParent_Done,
     /* 1208282 */   // Label 17529: @1208282
     /* 1208282 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1208362), // Rule ID 17252 //
     /* 1208287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208326 */     // MIs[0] round
     /* 1208326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208336 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208361 */     // GIR_Coverage, 17252,
     /* 1208361 */     GIR_EraseRootFromParent_Done,
     /* 1208362 */   // Label 17530: @1208362
     /* 1208362 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1208442), // Rule ID 17253 //
     /* 1208367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208406 */     // MIs[0] round
     /* 1208406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208416 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208441 */     // GIR_Coverage, 17253,
     /* 1208441 */     GIR_EraseRootFromParent_Done,
     /* 1208442 */   // Label 17531: @1208442
     /* 1208442 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1208522), // Rule ID 17262 //
     /* 1208447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208486 */     // MIs[0] round
     /* 1208486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208521 */     // GIR_Coverage, 17262,
     /* 1208521 */     GIR_EraseRootFromParent_Done,
     /* 1208522 */   // Label 17532: @1208522
     /* 1208522 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1208602), // Rule ID 17263 //
     /* 1208527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208566 */     // MIs[0] round
     /* 1208566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208601 */     // GIR_Coverage, 17263,
     /* 1208601 */     GIR_EraseRootFromParent_Done,
     /* 1208602 */   // Label 17533: @1208602
     /* 1208602 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1208682), // Rule ID 17272 //
     /* 1208607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208646 */     // MIs[0] round
     /* 1208646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208656 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1208659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208681 */     // GIR_Coverage, 17272,
     /* 1208681 */     GIR_EraseRootFromParent_Done,
     /* 1208682 */   // Label 17534: @1208682
     /* 1208682 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1208762), // Rule ID 17273 //
     /* 1208687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208726 */     // MIs[0] round
     /* 1208726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208736 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1208739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208761 */     // GIR_Coverage, 17273,
     /* 1208761 */     GIR_EraseRootFromParent_Done,
     /* 1208762 */   // Label 17535: @1208762
     /* 1208762 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1208842), // Rule ID 17282 //
     /* 1208767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1208787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208806 */     // MIs[0] round
     /* 1208806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1208819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208841 */     // GIR_Coverage, 17282,
     /* 1208841 */     GIR_EraseRootFromParent_Done,
     /* 1208842 */   // Label 17536: @1208842
     /* 1208842 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1208922), // Rule ID 17283 //
     /* 1208847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1208867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208886 */     // MIs[0] round
     /* 1208886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208896 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1208899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208921 */     // GIR_Coverage, 17283,
     /* 1208921 */     GIR_EraseRootFromParent_Done,
     /* 1208922 */   // Label 17537: @1208922
     /* 1208922 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1209002), // Rule ID 17292 //
     /* 1208927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1208947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208966 */     // MIs[0] round
     /* 1208966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208976 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1208979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209001 */     // GIR_Coverage, 17292,
     /* 1209001 */     GIR_EraseRootFromParent_Done,
     /* 1209002 */   // Label 17538: @1209002
     /* 1209002 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1209082), // Rule ID 17293 //
     /* 1209007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209046 */     // MIs[0] round
     /* 1209046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209056 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209081 */     // GIR_Coverage, 17293,
     /* 1209081 */     GIR_EraseRootFromParent_Done,
     /* 1209082 */   // Label 17539: @1209082
     /* 1209082 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1209162), // Rule ID 17302 //
     /* 1209087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209126 */     // MIs[0] round
     /* 1209126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209161 */     // GIR_Coverage, 17302,
     /* 1209161 */     GIR_EraseRootFromParent_Done,
     /* 1209162 */   // Label 17540: @1209162
     /* 1209162 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1209242), // Rule ID 17303 //
     /* 1209167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209206 */     // MIs[0] round
     /* 1209206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209216 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209241 */     // GIR_Coverage, 17303,
     /* 1209241 */     GIR_EraseRootFromParent_Done,
     /* 1209242 */   // Label 17541: @1209242
     /* 1209242 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1209322), // Rule ID 17312 //
     /* 1209247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209286 */     // MIs[0] round
     /* 1209286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209296 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209321 */     // GIR_Coverage, 17312,
     /* 1209321 */     GIR_EraseRootFromParent_Done,
     /* 1209322 */   // Label 17542: @1209322
     /* 1209322 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1209402), // Rule ID 17313 //
     /* 1209327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209366 */     // MIs[0] round
     /* 1209366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209401 */     // GIR_Coverage, 17313,
     /* 1209401 */     GIR_EraseRootFromParent_Done,
     /* 1209402 */   // Label 17543: @1209402
     /* 1209402 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1209482), // Rule ID 17322 //
     /* 1209407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209446 */     // MIs[0] round
     /* 1209446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209456 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209481 */     // GIR_Coverage, 17322,
     /* 1209481 */     GIR_EraseRootFromParent_Done,
     /* 1209482 */   // Label 17544: @1209482
     /* 1209482 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1209562), // Rule ID 17323 //
     /* 1209487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209526 */     // MIs[0] round
     /* 1209526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209536 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209561 */     // GIR_Coverage, 17323,
     /* 1209561 */     GIR_EraseRootFromParent_Done,
     /* 1209562 */   // Label 17545: @1209562
     /* 1209562 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1209642), // Rule ID 17332 //
     /* 1209567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209606 */     // MIs[0] round
     /* 1209606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209616 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1209619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209641 */     // GIR_Coverage, 17332,
     /* 1209641 */     GIR_EraseRootFromParent_Done,
     /* 1209642 */   // Label 17546: @1209642
     /* 1209642 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1209722), // Rule ID 17333 //
     /* 1209647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209686 */     // MIs[0] round
     /* 1209686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209696 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1209699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209721 */     // GIR_Coverage, 17333,
     /* 1209721 */     GIR_EraseRootFromParent_Done,
     /* 1209722 */   // Label 17547: @1209722
     /* 1209722 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1209802), // Rule ID 17340 //
     /* 1209727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209766 */     // MIs[0] round
     /* 1209766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209776 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1209779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209801 */     // GIR_Coverage, 17340,
     /* 1209801 */     GIR_EraseRootFromParent_Done,
     /* 1209802 */   // Label 17548: @1209802
     /* 1209802 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1209882), // Rule ID 17341 //
     /* 1209807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209846 */     // MIs[0] round
     /* 1209846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209856 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1209859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209881 */     // GIR_Coverage, 17341,
     /* 1209881 */     GIR_EraseRootFromParent_Done,
     /* 1209882 */   // Label 17549: @1209882
     /* 1209882 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1209962), // Rule ID 17344 //
     /* 1209887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209926 */     // MIs[0] round
     /* 1209926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209936 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1209939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209961 */     // GIR_Coverage, 17344,
     /* 1209961 */     GIR_EraseRootFromParent_Done,
     /* 1209962 */   // Label 17550: @1209962
     /* 1209962 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1210042), // Rule ID 17345 //
     /* 1209967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210006 */     // MIs[0] round
     /* 1210006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210041 */     // GIR_Coverage, 17345,
     /* 1210041 */     GIR_EraseRootFromParent_Done,
     /* 1210042 */   // Label 17551: @1210042
     /* 1210042 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1210122), // Rule ID 17348 //
     /* 1210047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210086 */     // MIs[0] round
     /* 1210086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210121 */     // GIR_Coverage, 17348,
     /* 1210121 */     GIR_EraseRootFromParent_Done,
     /* 1210122 */   // Label 17552: @1210122
     /* 1210122 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1210202), // Rule ID 17349 //
     /* 1210127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210166 */     // MIs[0] round
     /* 1210166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210176 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210201 */     // GIR_Coverage, 17349,
     /* 1210201 */     GIR_EraseRootFromParent_Done,
     /* 1210202 */   // Label 17553: @1210202
     /* 1210202 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1210282), // Rule ID 17352 //
     /* 1210207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210246 */     // MIs[0] round
     /* 1210246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210256 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210281 */     // GIR_Coverage, 17352,
     /* 1210281 */     GIR_EraseRootFromParent_Done,
     /* 1210282 */   // Label 17554: @1210282
     /* 1210282 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1210362), // Rule ID 17353 //
     /* 1210287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210326 */     // MIs[0] round
     /* 1210326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210361 */     // GIR_Coverage, 17353,
     /* 1210361 */     GIR_EraseRootFromParent_Done,
     /* 1210362 */   // Label 17555: @1210362
     /* 1210362 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1210442), // Rule ID 17356 //
     /* 1210367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210406 */     // MIs[0] round
     /* 1210406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210416 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210441 */     // GIR_Coverage, 17356,
     /* 1210441 */     GIR_EraseRootFromParent_Done,
     /* 1210442 */   // Label 17556: @1210442
     /* 1210442 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1210522), // Rule ID 17357 //
     /* 1210447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210486 */     // MIs[0] round
     /* 1210486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210496 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210521 */     // GIR_Coverage, 17357,
     /* 1210521 */     GIR_EraseRootFromParent_Done,
     /* 1210522 */   // Label 17557: @1210522
     /* 1210522 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1210602), // Rule ID 17360 //
     /* 1210527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210566 */     // MIs[0] round
     /* 1210566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210601 */     // GIR_Coverage, 17360,
     /* 1210601 */     GIR_EraseRootFromParent_Done,
     /* 1210602 */   // Label 17558: @1210602
     /* 1210602 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1210682), // Rule ID 17361 //
     /* 1210607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210646 */     // MIs[0] round
     /* 1210646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210681 */     // GIR_Coverage, 17361,
     /* 1210681 */     GIR_EraseRootFromParent_Done,
     /* 1210682 */   // Label 17559: @1210682
     /* 1210682 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1210762), // Rule ID 17364 //
     /* 1210687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210726 */     // MIs[0] round
     /* 1210726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1210739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210761 */     // GIR_Coverage, 17364,
     /* 1210761 */     GIR_EraseRootFromParent_Done,
     /* 1210762 */   // Label 17560: @1210762
     /* 1210762 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1210842), // Rule ID 17365 //
     /* 1210767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1210778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1210781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1210784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210806 */     // MIs[0] round
     /* 1210806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210816 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11256:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1210819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210841 */     // GIR_Coverage, 17365,
     /* 1210841 */     GIR_EraseRootFromParent_Done,
     /* 1210842 */   // Label 17561: @1210842
     /* 1210842 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1210922), // Rule ID 17368 //
     /* 1210847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210886 */     // MIs[0] round
     /* 1210886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210896 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1210899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210921 */     // GIR_Coverage, 17368,
     /* 1210921 */     GIR_EraseRootFromParent_Done,
     /* 1210922 */   // Label 17562: @1210922
     /* 1210922 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1211002), // Rule ID 17369 //
     /* 1210927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1210938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1210941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1210944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210966 */     // MIs[0] round
     /* 1210966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210976 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11256:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1210979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211001 */     // GIR_Coverage, 17369,
     /* 1211001 */     GIR_EraseRootFromParent_Done,
     /* 1211002 */   // Label 17563: @1211002
     /* 1211002 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1211082), // Rule ID 17372 //
     /* 1211007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211046 */     // MIs[0] round
     /* 1211046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211056 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211081 */     // GIR_Coverage, 17372,
     /* 1211081 */     GIR_EraseRootFromParent_Done,
     /* 1211082 */   // Label 17564: @1211082
     /* 1211082 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1211162), // Rule ID 17373 //
     /* 1211087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211126 */     // MIs[0] round
     /* 1211126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211136 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11256:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211161 */     // GIR_Coverage, 17373,
     /* 1211161 */     GIR_EraseRootFromParent_Done,
     /* 1211162 */   // Label 17565: @1211162
     /* 1211162 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1211242), // Rule ID 17376 //
     /* 1211167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211206 */     // MIs[0] round
     /* 1211206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211241 */     // GIR_Coverage, 17376,
     /* 1211241 */     GIR_EraseRootFromParent_Done,
     /* 1211242 */   // Label 17566: @1211242
     /* 1211242 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1211322), // Rule ID 17377 //
     /* 1211247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211286 */     // MIs[0] round
     /* 1211286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211321 */     // GIR_Coverage, 17377,
     /* 1211321 */     GIR_EraseRootFromParent_Done,
     /* 1211322 */   // Label 17567: @1211322
     /* 1211322 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1211402), // Rule ID 17380 //
     /* 1211327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211366 */     // MIs[0] round
     /* 1211366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211376 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211401 */     // GIR_Coverage, 17380,
     /* 1211401 */     GIR_EraseRootFromParent_Done,
     /* 1211402 */   // Label 17568: @1211402
     /* 1211402 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1211482), // Rule ID 17381 //
     /* 1211407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211446 */     // MIs[0] round
     /* 1211446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211456 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211481 */     // GIR_Coverage, 17381,
     /* 1211481 */     GIR_EraseRootFromParent_Done,
     /* 1211482 */   // Label 17569: @1211482
     /* 1211482 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1211562), // Rule ID 17384 //
     /* 1211487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1211490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211526 */     // MIs[0] round
     /* 1211526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211536 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211561 */     // GIR_Coverage, 17384,
     /* 1211561 */     GIR_EraseRootFromParent_Done,
     /* 1211562 */   // Label 17570: @1211562
     /* 1211562 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1211642), // Rule ID 17385 //
     /* 1211567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1211570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211606 */     // MIs[0] round
     /* 1211606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211616 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211641 */     // GIR_Coverage, 17385,
     /* 1211641 */     GIR_EraseRootFromParent_Done,
     /* 1211642 */   // Label 17571: @1211642
     /* 1211642 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1211722), // Rule ID 17388 //
     /* 1211647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1211658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1211661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1211664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1211667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211686 */     // MIs[0] round
     /* 1211686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211696 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1211699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211721 */     // GIR_Coverage, 17388,
     /* 1211721 */     GIR_EraseRootFromParent_Done,
     /* 1211722 */   // Label 17572: @1211722
     /* 1211722 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1211802), // Rule ID 17389 //
     /* 1211727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1211738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1211741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1211744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1211747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211766 */     // MIs[0] round
     /* 1211766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1211779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211801 */     // GIR_Coverage, 17389,
     /* 1211801 */     GIR_EraseRootFromParent_Done,
     /* 1211802 */   // Label 17573: @1211802
     /* 1211802 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1211882), // Rule ID 17392 //
     /* 1211807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1211810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1211818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1211821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1211824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1211827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211846 */     // MIs[0] round
     /* 1211846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1211859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211881 */     // GIR_Coverage, 17392,
     /* 1211881 */     GIR_EraseRootFromParent_Done,
     /* 1211882 */   // Label 17574: @1211882
     /* 1211882 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1211962), // Rule ID 17393 //
     /* 1211887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1211890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1211898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1211901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1211904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1211907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211926 */     // MIs[0] round
     /* 1211926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211936 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1211939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211961 */     // GIR_Coverage, 17393,
     /* 1211961 */     GIR_EraseRootFromParent_Done,
     /* 1211962 */   // Label 17575: @1211962
     /* 1211962 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1212042), // Rule ID 17396 //
     /* 1211967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1211970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1211978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1211981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1211984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1211987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212006 */     // MIs[0] round
     /* 1212006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212041 */     // GIR_Coverage, 17396,
     /* 1212041 */     GIR_EraseRootFromParent_Done,
     /* 1212042 */   // Label 17576: @1212042
     /* 1212042 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1212122), // Rule ID 17397 //
     /* 1212047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212086 */     // MIs[0] round
     /* 1212086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212121 */     // GIR_Coverage, 17397,
     /* 1212121 */     GIR_EraseRootFromParent_Done,
     /* 1212122 */   // Label 17577: @1212122
     /* 1212122 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1212202), // Rule ID 17400 //
     /* 1212127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212166 */     // MIs[0] round
     /* 1212166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212176 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212201 */     // GIR_Coverage, 17400,
     /* 1212201 */     GIR_EraseRootFromParent_Done,
     /* 1212202 */   // Label 17578: @1212202
     /* 1212202 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1212282), // Rule ID 17401 //
     /* 1212207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212246 */     // MIs[0] round
     /* 1212246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212256 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212281 */     // GIR_Coverage, 17401,
     /* 1212281 */     GIR_EraseRootFromParent_Done,
     /* 1212282 */   // Label 17579: @1212282
     /* 1212282 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1212362), // Rule ID 17404 //
     /* 1212287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212326 */     // MIs[0] round
     /* 1212326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212336 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212361 */     // GIR_Coverage, 17404,
     /* 1212361 */     GIR_EraseRootFromParent_Done,
     /* 1212362 */   // Label 17580: @1212362
     /* 1212362 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1212442), // Rule ID 17405 //
     /* 1212367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212406 */     // MIs[0] round
     /* 1212406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212416 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212441 */     // GIR_Coverage, 17405,
     /* 1212441 */     GIR_EraseRootFromParent_Done,
     /* 1212442 */   // Label 17581: @1212442
     /* 1212442 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1212522), // Rule ID 17408 //
     /* 1212447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212486 */     // MIs[0] round
     /* 1212486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212496 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212521 */     // GIR_Coverage, 17408,
     /* 1212521 */     GIR_EraseRootFromParent_Done,
     /* 1212522 */   // Label 17582: @1212522
     /* 1212522 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1212602), // Rule ID 17409 //
     /* 1212527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212566 */     // MIs[0] round
     /* 1212566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212576 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212601 */     // GIR_Coverage, 17409,
     /* 1212601 */     GIR_EraseRootFromParent_Done,
     /* 1212602 */   // Label 17583: @1212602
     /* 1212602 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1212682), // Rule ID 17412 //
     /* 1212607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1212627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212646 */     // MIs[0] round
     /* 1212646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212656 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1212659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212681 */     // GIR_Coverage, 17412,
     /* 1212681 */     GIR_EraseRootFromParent_Done,
     /* 1212682 */   // Label 17584: @1212682
     /* 1212682 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1212762), // Rule ID 17413 //
     /* 1212687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1212707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212726 */     // MIs[0] round
     /* 1212726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212736 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1212739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212761 */     // GIR_Coverage, 17413,
     /* 1212761 */     GIR_EraseRootFromParent_Done,
     /* 1212762 */   // Label 17585: @1212762
     /* 1212762 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1212842), // Rule ID 17416 //
     /* 1212767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1212778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1212781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1212784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1212787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212806 */     // MIs[0] round
     /* 1212806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1212819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212841 */     // GIR_Coverage, 17416,
     /* 1212841 */     GIR_EraseRootFromParent_Done,
     /* 1212842 */   // Label 17586: @1212842
     /* 1212842 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1212922), // Rule ID 17417 //
     /* 1212847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1212858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1212861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1212864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1212867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212886 */     // MIs[0] round
     /* 1212886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212896 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1212899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212921 */     // GIR_Coverage, 17417,
     /* 1212921 */     GIR_EraseRootFromParent_Done,
     /* 1212922 */   // Label 17587: @1212922
     /* 1212922 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1213002), // Rule ID 17420 //
     /* 1212927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1212938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1212941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1212944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1212947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212966 */     // MIs[0] round
     /* 1212966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212976 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1212979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213001 */     // GIR_Coverage, 17420,
     /* 1213001 */     GIR_EraseRootFromParent_Done,
     /* 1213002 */   // Label 17588: @1213002
     /* 1213002 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1213082), // Rule ID 17421 //
     /* 1213007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213046 */     // MIs[0] round
     /* 1213046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213056 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213081 */     // GIR_Coverage, 17421,
     /* 1213081 */     GIR_EraseRootFromParent_Done,
     /* 1213082 */   // Label 17589: @1213082
     /* 1213082 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1213162), // Rule ID 17424 //
     /* 1213087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213126 */     // MIs[0] round
     /* 1213126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213136 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213161 */     // GIR_Coverage, 17424,
     /* 1213161 */     GIR_EraseRootFromParent_Done,
     /* 1213162 */   // Label 17590: @1213162
     /* 1213162 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1213242), // Rule ID 17425 //
     /* 1213167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213206 */     // MIs[0] round
     /* 1213206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213216 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213241 */     // GIR_Coverage, 17425,
     /* 1213241 */     GIR_EraseRootFromParent_Done,
     /* 1213242 */   // Label 17591: @1213242
     /* 1213242 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1213322), // Rule ID 17428 //
     /* 1213247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213286 */     // MIs[0] round
     /* 1213286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213296 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213321 */     // GIR_Coverage, 17428,
     /* 1213321 */     GIR_EraseRootFromParent_Done,
     /* 1213322 */   // Label 17592: @1213322
     /* 1213322 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1213402), // Rule ID 17429 //
     /* 1213327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213366 */     // MIs[0] round
     /* 1213366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213376 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213401 */     // GIR_Coverage, 17429,
     /* 1213401 */     GIR_EraseRootFromParent_Done,
     /* 1213402 */   // Label 17593: @1213402
     /* 1213402 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1213482), // Rule ID 17432 //
     /* 1213407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213446 */     // MIs[0] round
     /* 1213446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213456 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213481 */     // GIR_Coverage, 17432,
     /* 1213481 */     GIR_EraseRootFromParent_Done,
     /* 1213482 */   // Label 17594: @1213482
     /* 1213482 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1213562), // Rule ID 17433 //
     /* 1213487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213526 */     // MIs[0] round
     /* 1213526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213536 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213561 */     // GIR_Coverage, 17433,
     /* 1213561 */     GIR_EraseRootFromParent_Done,
     /* 1213562 */   // Label 17595: @1213562
     /* 1213562 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1213642), // Rule ID 17436 //
     /* 1213567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213606 */     // MIs[0] round
     /* 1213606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213616 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1213619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213641 */     // GIR_Coverage, 17436,
     /* 1213641 */     GIR_EraseRootFromParent_Done,
     /* 1213642 */   // Label 17596: @1213642
     /* 1213642 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1213722), // Rule ID 17437 //
     /* 1213647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213686 */     // MIs[0] round
     /* 1213686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213696 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1213699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213721 */     // GIR_Coverage, 17437,
     /* 1213721 */     GIR_EraseRootFromParent_Done,
     /* 1213722 */   // Label 17597: @1213722
     /* 1213722 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1213802), // Rule ID 17440 //
     /* 1213727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1213738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1213741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1213744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213766 */     // MIs[0] round
     /* 1213766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213776 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1213779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213801 */     // GIR_Coverage, 17440,
     /* 1213801 */     GIR_EraseRootFromParent_Done,
     /* 1213802 */   // Label 17598: @1213802
     /* 1213802 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1213882), // Rule ID 17441 //
     /* 1213807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1213818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1213821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1213824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213846 */     // MIs[0] round
     /* 1213846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213856 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1213859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213881 */     // GIR_Coverage, 17441,
     /* 1213881 */     GIR_EraseRootFromParent_Done,
     /* 1213882 */   // Label 17599: @1213882
     /* 1213882 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1213962), // Rule ID 17444 //
     /* 1213887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1213898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1213901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1213904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1213907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1213926 */     // MIs[0] round
     /* 1213926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213936 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1213939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213961 */     // GIR_Coverage, 17444,
     /* 1213961 */     GIR_EraseRootFromParent_Done,
     /* 1213962 */   // Label 17600: @1213962
     /* 1213962 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1214042), // Rule ID 17445 //
     /* 1213967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1213978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1213981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1213984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1213987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214006 */     // MIs[0] round
     /* 1214006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214016 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214041 */     // GIR_Coverage, 17445,
     /* 1214041 */     GIR_EraseRootFromParent_Done,
     /* 1214042 */   // Label 17601: @1214042
     /* 1214042 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1214122), // Rule ID 17448 //
     /* 1214047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214086 */     // MIs[0] round
     /* 1214086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214096 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214121 */     // GIR_Coverage, 17448,
     /* 1214121 */     GIR_EraseRootFromParent_Done,
     /* 1214122 */   // Label 17602: @1214122
     /* 1214122 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1214202), // Rule ID 17449 //
     /* 1214127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214166 */     // MIs[0] round
     /* 1214166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214176 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214201 */     // GIR_Coverage, 17449,
     /* 1214201 */     GIR_EraseRootFromParent_Done,
     /* 1214202 */   // Label 17603: @1214202
     /* 1214202 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1214282), // Rule ID 17452 //
     /* 1214207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214246 */     // MIs[0] round
     /* 1214246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214281 */     // GIR_Coverage, 17452,
     /* 1214281 */     GIR_EraseRootFromParent_Done,
     /* 1214282 */   // Label 17604: @1214282
     /* 1214282 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1214362), // Rule ID 17453 //
     /* 1214287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214326 */     // MIs[0] round
     /* 1214326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214361 */     // GIR_Coverage, 17453,
     /* 1214361 */     GIR_EraseRootFromParent_Done,
     /* 1214362 */   // Label 17605: @1214362
     /* 1214362 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1214442), // Rule ID 17456 //
     /* 1214367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214406 */     // MIs[0] round
     /* 1214406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214441 */     // GIR_Coverage, 17456,
     /* 1214441 */     GIR_EraseRootFromParent_Done,
     /* 1214442 */   // Label 17606: @1214442
     /* 1214442 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1214522), // Rule ID 17457 //
     /* 1214447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214486 */     // MIs[0] round
     /* 1214486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214521 */     // GIR_Coverage, 17457,
     /* 1214521 */     GIR_EraseRootFromParent_Done,
     /* 1214522 */   // Label 17607: @1214522
     /* 1214522 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1214602), // Rule ID 17460 //
     /* 1214527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214566 */     // MIs[0] round
     /* 1214566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214576 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214601 */     // GIR_Coverage, 17460,
     /* 1214601 */     GIR_EraseRootFromParent_Done,
     /* 1214602 */   // Label 17608: @1214602
     /* 1214602 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1214682), // Rule ID 17461 //
     /* 1214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214646 */     // MIs[0] round
     /* 1214646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214681 */     // GIR_Coverage, 17461,
     /* 1214681 */     GIR_EraseRootFromParent_Done,
     /* 1214682 */   // Label 17609: @1214682
     /* 1214682 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1214762), // Rule ID 17464 //
     /* 1214687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1214698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1214701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1214704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214726 */     // MIs[0] round
     /* 1214726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1214739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214761 */     // GIR_Coverage, 17464,
     /* 1214761 */     GIR_EraseRootFromParent_Done,
     /* 1214762 */   // Label 17610: @1214762
     /* 1214762 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1214842), // Rule ID 17465 //
     /* 1214767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1214778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1214781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1214784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1214802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214806 */     // MIs[0] round
     /* 1214806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214816 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1214819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214841 */     // GIR_Coverage, 17465,
     /* 1214841 */     GIR_EraseRootFromParent_Done,
     /* 1214842 */   // Label 17611: @1214842
     /* 1214842 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1214922), // Rule ID 17468 //
     /* 1214847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1214858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1214861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1214864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214886 */     // MIs[0] round
     /* 1214886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214896 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1214899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214921 */     // GIR_Coverage, 17468,
     /* 1214921 */     GIR_EraseRootFromParent_Done,
     /* 1214922 */   // Label 17612: @1214922
     /* 1214922 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1215002), // Rule ID 17469 //
     /* 1214927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1214938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1214941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1214944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1214962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214966 */     // MIs[0] round
     /* 1214966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214976 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1214979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215001 */     // GIR_Coverage, 17469,
     /* 1215001 */     GIR_EraseRootFromParent_Done,
     /* 1215002 */   // Label 17613: @1215002
     /* 1215002 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1215082), // Rule ID 17472 //
     /* 1215007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215046 */     // MIs[0] round
     /* 1215046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215081 */     // GIR_Coverage, 17472,
     /* 1215081 */     GIR_EraseRootFromParent_Done,
     /* 1215082 */   // Label 17614: @1215082
     /* 1215082 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1215162), // Rule ID 17473 //
     /* 1215087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215126 */     // MIs[0] round
     /* 1215126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215161 */     // GIR_Coverage, 17473,
     /* 1215161 */     GIR_EraseRootFromParent_Done,
     /* 1215162 */   // Label 17615: @1215162
     /* 1215162 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1215242), // Rule ID 17476 //
     /* 1215167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215206 */     // MIs[0] round
     /* 1215206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215216 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215241 */     // GIR_Coverage, 17476,
     /* 1215241 */     GIR_EraseRootFromParent_Done,
     /* 1215242 */   // Label 17616: @1215242
     /* 1215242 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1215322), // Rule ID 17477 //
     /* 1215247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215286 */     // MIs[0] round
     /* 1215286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215296 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215321 */     // GIR_Coverage, 17477,
     /* 1215321 */     GIR_EraseRootFromParent_Done,
     /* 1215322 */   // Label 17617: @1215322
     /* 1215322 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1215402), // Rule ID 17480 //
     /* 1215327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215366 */     // MIs[0] round
     /* 1215366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215376 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215401 */     // GIR_Coverage, 17480,
     /* 1215401 */     GIR_EraseRootFromParent_Done,
     /* 1215402 */   // Label 17618: @1215402
     /* 1215402 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1215482), // Rule ID 17481 //
     /* 1215407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215446 */     // MIs[0] round
     /* 1215446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215456 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215481 */     // GIR_Coverage, 17481,
     /* 1215481 */     GIR_EraseRootFromParent_Done,
     /* 1215482 */   // Label 17619: @1215482
     /* 1215482 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1215562), // Rule ID 17484 //
     /* 1215487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215526 */     // MIs[0] round
     /* 1215526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215561 */     // GIR_Coverage, 17484,
     /* 1215561 */     GIR_EraseRootFromParent_Done,
     /* 1215562 */   // Label 17620: @1215562
     /* 1215562 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1215642), // Rule ID 17485 //
     /* 1215567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215606 */     // MIs[0] round
     /* 1215606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215641 */     // GIR_Coverage, 17485,
     /* 1215641 */     GIR_EraseRootFromParent_Done,
     /* 1215642 */   // Label 17621: @1215642
     /* 1215642 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1215722), // Rule ID 17488 //
     /* 1215647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215686 */     // MIs[0] round
     /* 1215686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215696 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1215699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215721 */     // GIR_Coverage, 17488,
     /* 1215721 */     GIR_EraseRootFromParent_Done,
     /* 1215722 */   // Label 17622: @1215722
     /* 1215722 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1215802), // Rule ID 17489 //
     /* 1215727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215766 */     // MIs[0] round
     /* 1215766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1215779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215801 */     // GIR_Coverage, 17489,
     /* 1215801 */     GIR_EraseRootFromParent_Done,
     /* 1215802 */   // Label 17623: @1215802
     /* 1215802 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1215882), // Rule ID 17492 //
     /* 1215807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1215818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1215821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1215824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215846 */     // MIs[0] round
     /* 1215846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215856 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1215859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215881 */     // GIR_Coverage, 17492,
     /* 1215881 */     GIR_EraseRootFromParent_Done,
     /* 1215882 */   // Label 17624: @1215882
     /* 1215882 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1215962), // Rule ID 17493 //
     /* 1215887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1215898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1215901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1215904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215926 */     // MIs[0] round
     /* 1215926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215936 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1215939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215961 */     // GIR_Coverage, 17493,
     /* 1215961 */     GIR_EraseRootFromParent_Done,
     /* 1215962 */   // Label 17625: @1215962
     /* 1215962 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1216042), // Rule ID 17496 //
     /* 1215967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1215978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1215981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1215984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1215987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1215998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216006 */     // MIs[0] round
     /* 1216006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216016 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216041 */     // GIR_Coverage, 17496,
     /* 1216041 */     GIR_EraseRootFromParent_Done,
     /* 1216042 */   // Label 17626: @1216042
     /* 1216042 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1216122), // Rule ID 17497 //
     /* 1216047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216086 */     // MIs[0] round
     /* 1216086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216096 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216121 */     // GIR_Coverage, 17497,
     /* 1216121 */     GIR_EraseRootFromParent_Done,
     /* 1216122 */   // Label 17627: @1216122
     /* 1216122 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1216202), // Rule ID 17500 //
     /* 1216127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216166 */     // MIs[0] round
     /* 1216166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216176 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216201 */     // GIR_Coverage, 17500,
     /* 1216201 */     GIR_EraseRootFromParent_Done,
     /* 1216202 */   // Label 17628: @1216202
     /* 1216202 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1216282), // Rule ID 17501 //
     /* 1216207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216246 */     // MIs[0] round
     /* 1216246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216256 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216281 */     // GIR_Coverage, 17501,
     /* 1216281 */     GIR_EraseRootFromParent_Done,
     /* 1216282 */   // Label 17629: @1216282
     /* 1216282 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1216362), // Rule ID 17504 //
     /* 1216287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216326 */     // MIs[0] round
     /* 1216326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216336 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216361 */     // GIR_Coverage, 17504,
     /* 1216361 */     GIR_EraseRootFromParent_Done,
     /* 1216362 */   // Label 17630: @1216362
     /* 1216362 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1216442), // Rule ID 17505 //
     /* 1216367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216406 */     // MIs[0] round
     /* 1216406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216416 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216441 */     // GIR_Coverage, 17505,
     /* 1216441 */     GIR_EraseRootFromParent_Done,
     /* 1216442 */   // Label 17631: @1216442
     /* 1216442 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1216522), // Rule ID 17508 //
     /* 1216447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216486 */     // MIs[0] round
     /* 1216486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216521 */     // GIR_Coverage, 17508,
     /* 1216521 */     GIR_EraseRootFromParent_Done,
     /* 1216522 */   // Label 17632: @1216522
     /* 1216522 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1216602), // Rule ID 17509 //
     /* 1216527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216566 */     // MIs[0] round
     /* 1216566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216576 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216601 */     // GIR_Coverage, 17509,
     /* 1216601 */     GIR_EraseRootFromParent_Done,
     /* 1216602 */   // Label 17633: @1216602
     /* 1216602 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1216682), // Rule ID 17512 //
     /* 1216607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1216618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1216621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216646 */     // MIs[0] round
     /* 1216646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1216659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216681 */     // GIR_Coverage, 17512,
     /* 1216681 */     GIR_EraseRootFromParent_Done,
     /* 1216682 */   // Label 17634: @1216682
     /* 1216682 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1216762), // Rule ID 17513 //
     /* 1216687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1216698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1216701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216726 */     // MIs[0] round
     /* 1216726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1216739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216761 */     // GIR_Coverage, 17513,
     /* 1216761 */     GIR_EraseRootFromParent_Done,
     /* 1216762 */   // Label 17635: @1216762
     /* 1216762 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1216842), // Rule ID 17516 //
     /* 1216767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1216778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1216781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216806 */     // MIs[0] round
     /* 1216806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1216819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216841 */     // GIR_Coverage, 17516,
     /* 1216841 */     GIR_EraseRootFromParent_Done,
     /* 1216842 */   // Label 17636: @1216842
     /* 1216842 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1216922), // Rule ID 17517 //
     /* 1216847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1216858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1216861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1216864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1216867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216886 */     // MIs[0] round
     /* 1216886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1216899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216921 */     // GIR_Coverage, 17517,
     /* 1216921 */     GIR_EraseRootFromParent_Done,
     /* 1216922 */   // Label 17637: @1216922
     /* 1216922 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1217002), // Rule ID 17520 //
     /* 1216927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1216938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1216941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1216944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1216947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216966 */     // MIs[0] round
     /* 1216966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1216979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217001 */     // GIR_Coverage, 17520,
     /* 1217001 */     GIR_EraseRootFromParent_Done,
     /* 1217002 */   // Label 17638: @1217002
     /* 1217002 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1217082), // Rule ID 17521 //
     /* 1217007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217046 */     // MIs[0] round
     /* 1217046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217056 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217081 */     // GIR_Coverage, 17521,
     /* 1217081 */     GIR_EraseRootFromParent_Done,
     /* 1217082 */   // Label 17639: @1217082
     /* 1217082 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1217162), // Rule ID 17524 //
     /* 1217087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217126 */     // MIs[0] round
     /* 1217126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217136 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217161 */     // GIR_Coverage, 17524,
     /* 1217161 */     GIR_EraseRootFromParent_Done,
     /* 1217162 */   // Label 17640: @1217162
     /* 1217162 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1217242), // Rule ID 17525 //
     /* 1217167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217206 */     // MIs[0] round
     /* 1217206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217216 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217241 */     // GIR_Coverage, 17525,
     /* 1217241 */     GIR_EraseRootFromParent_Done,
     /* 1217242 */   // Label 17641: @1217242
     /* 1217242 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1217322), // Rule ID 17528 //
     /* 1217247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217286 */     // MIs[0] round
     /* 1217286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217296 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217321 */     // GIR_Coverage, 17528,
     /* 1217321 */     GIR_EraseRootFromParent_Done,
     /* 1217322 */   // Label 17642: @1217322
     /* 1217322 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1217402), // Rule ID 17529 //
     /* 1217327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217366 */     // MIs[0] round
     /* 1217366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217376 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217401 */     // GIR_Coverage, 17529,
     /* 1217401 */     GIR_EraseRootFromParent_Done,
     /* 1217402 */   // Label 17643: @1217402
     /* 1217402 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1217482), // Rule ID 17532 //
     /* 1217407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217446 */     // MIs[0] round
     /* 1217446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217456 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217481 */     // GIR_Coverage, 17532,
     /* 1217481 */     GIR_EraseRootFromParent_Done,
     /* 1217482 */   // Label 17644: @1217482
     /* 1217482 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1217562), // Rule ID 17533 //
     /* 1217487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217526 */     // MIs[0] round
     /* 1217526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217561 */     // GIR_Coverage, 17533,
     /* 1217561 */     GIR_EraseRootFromParent_Done,
     /* 1217562 */   // Label 17645: @1217562
     /* 1217562 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1217642), // Rule ID 17536 //
     /* 1217567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217606 */     // MIs[0] round
     /* 1217606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217616 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1217619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217641 */     // GIR_Coverage, 17536,
     /* 1217641 */     GIR_EraseRootFromParent_Done,
     /* 1217642 */   // Label 17646: @1217642
     /* 1217642 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1217722), // Rule ID 17537 //
     /* 1217647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217686 */     // MIs[0] round
     /* 1217686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1217699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217721 */     // GIR_Coverage, 17537,
     /* 1217721 */     GIR_EraseRootFromParent_Done,
     /* 1217722 */   // Label 17647: @1217722
     /* 1217722 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1217802), // Rule ID 17540 //
     /* 1217727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1217738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1217741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217766 */     // MIs[0] round
     /* 1217766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217776 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1217779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217801 */     // GIR_Coverage, 17540,
     /* 1217801 */     GIR_EraseRootFromParent_Done,
     /* 1217802 */   // Label 17648: @1217802
     /* 1217802 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1217882), // Rule ID 17541 //
     /* 1217807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1217818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1217821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1217824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1217827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217846 */     // MIs[0] round
     /* 1217846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217856 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1217859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217881 */     // GIR_Coverage, 17541,
     /* 1217881 */     GIR_EraseRootFromParent_Done,
     /* 1217882 */   // Label 17649: @1217882
     /* 1217882 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1217962), // Rule ID 17544 //
     /* 1217887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1217898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1217901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1217904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1217907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217926 */     // MIs[0] round
     /* 1217926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1217939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217961 */     // GIR_Coverage, 17544,
     /* 1217961 */     GIR_EraseRootFromParent_Done,
     /* 1217962 */   // Label 17650: @1217962
     /* 1217962 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1218042), // Rule ID 17545 //
     /* 1217967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1217978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1217981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1217984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1217987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218006 */     // MIs[0] round
     /* 1218006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218041 */     // GIR_Coverage, 17545,
     /* 1218041 */     GIR_EraseRootFromParent_Done,
     /* 1218042 */   // Label 17651: @1218042
     /* 1218042 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1218122), // Rule ID 17548 //
     /* 1218047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218086 */     // MIs[0] round
     /* 1218086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218096 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218121 */     // GIR_Coverage, 17548,
     /* 1218121 */     GIR_EraseRootFromParent_Done,
     /* 1218122 */   // Label 17652: @1218122
     /* 1218122 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1218202), // Rule ID 17549 //
     /* 1218127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218166 */     // MIs[0] round
     /* 1218166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218176 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218201 */     // GIR_Coverage, 17549,
     /* 1218201 */     GIR_EraseRootFromParent_Done,
     /* 1218202 */   // Label 17653: @1218202
     /* 1218202 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1218282), // Rule ID 17552 //
     /* 1218207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218246 */     // MIs[0] round
     /* 1218246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218256 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218281 */     // GIR_Coverage, 17552,
     /* 1218281 */     GIR_EraseRootFromParent_Done,
     /* 1218282 */   // Label 17654: @1218282
     /* 1218282 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1218362), // Rule ID 17553 //
     /* 1218287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218326 */     // MIs[0] round
     /* 1218326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218336 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218361 */     // GIR_Coverage, 17553,
     /* 1218361 */     GIR_EraseRootFromParent_Done,
     /* 1218362 */   // Label 17655: @1218362
     /* 1218362 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1218442), // Rule ID 17556 //
     /* 1218367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218406 */     // MIs[0] round
     /* 1218406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218416 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218441 */     // GIR_Coverage, 17556,
     /* 1218441 */     GIR_EraseRootFromParent_Done,
     /* 1218442 */   // Label 17656: @1218442
     /* 1218442 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1218522), // Rule ID 17557 //
     /* 1218447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218486 */     // MIs[0] round
     /* 1218486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218496 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218521 */     // GIR_Coverage, 17557,
     /* 1218521 */     GIR_EraseRootFromParent_Done,
     /* 1218522 */   // Label 17657: @1218522
     /* 1218522 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1218602), // Rule ID 17560 //
     /* 1218527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218566 */     // MIs[0] round
     /* 1218566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218576 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218601 */     // GIR_Coverage, 17560,
     /* 1218601 */     GIR_EraseRootFromParent_Done,
     /* 1218602 */   // Label 17658: @1218602
     /* 1218602 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1218682), // Rule ID 17561 //
     /* 1218607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218646 */     // MIs[0] round
     /* 1218646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218656 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218681 */     // GIR_Coverage, 17561,
     /* 1218681 */     GIR_EraseRootFromParent_Done,
     /* 1218682 */   // Label 17659: @1218682
     /* 1218682 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1218762), // Rule ID 17564 //
     /* 1218687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1218704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218726 */     // MIs[0] round
     /* 1218726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218736 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1218739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218761 */     // GIR_Coverage, 17564,
     /* 1218761 */     GIR_EraseRootFromParent_Done,
     /* 1218762 */   // Label 17660: @1218762
     /* 1218762 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1218842), // Rule ID 17565 //
     /* 1218767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1218784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218806 */     // MIs[0] round
     /* 1218806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218816 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1218819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218841 */     // GIR_Coverage, 17565,
     /* 1218841 */     GIR_EraseRootFromParent_Done,
     /* 1218842 */   // Label 17661: @1218842
     /* 1218842 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1218922), // Rule ID 17568 //
     /* 1218847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1218858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1218861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1218864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218886 */     // MIs[0] round
     /* 1218886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1218899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218921 */     // GIR_Coverage, 17568,
     /* 1218921 */     GIR_EraseRootFromParent_Done,
     /* 1218922 */   // Label 17662: @1218922
     /* 1218922 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1219002), // Rule ID 17569 //
     /* 1218927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1218938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1218941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1218944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218966 */     // MIs[0] round
     /* 1218966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218976 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1218979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219001 */     // GIR_Coverage, 17569,
     /* 1219001 */     GIR_EraseRootFromParent_Done,
     /* 1219002 */   // Label 17663: @1219002
     /* 1219002 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1219082), // Rule ID 17572 //
     /* 1219007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219046 */     // MIs[0] round
     /* 1219046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219081 */     // GIR_Coverage, 17572,
     /* 1219081 */     GIR_EraseRootFromParent_Done,
     /* 1219082 */   // Label 17664: @1219082
     /* 1219082 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1219162), // Rule ID 17573 //
     /* 1219087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219126 */     // MIs[0] round
     /* 1219126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219136 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219161 */     // GIR_Coverage, 17573,
     /* 1219161 */     GIR_EraseRootFromParent_Done,
     /* 1219162 */   // Label 17665: @1219162
     /* 1219162 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1219242), // Rule ID 17576 //
     /* 1219167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219206 */     // MIs[0] round
     /* 1219206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219216 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219241 */     // GIR_Coverage, 17576,
     /* 1219241 */     GIR_EraseRootFromParent_Done,
     /* 1219242 */   // Label 17666: @1219242
     /* 1219242 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1219322), // Rule ID 17577 //
     /* 1219247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219286 */     // MIs[0] round
     /* 1219286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219296 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219321 */     // GIR_Coverage, 17577,
     /* 1219321 */     GIR_EraseRootFromParent_Done,
     /* 1219322 */   // Label 17667: @1219322
     /* 1219322 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1219402), // Rule ID 17580 //
     /* 1219327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219366 */     // MIs[0] round
     /* 1219366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219376 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219401 */     // GIR_Coverage, 17580,
     /* 1219401 */     GIR_EraseRootFromParent_Done,
     /* 1219402 */   // Label 17668: @1219402
     /* 1219402 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1219482), // Rule ID 17581 //
     /* 1219407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219446 */     // MIs[0] round
     /* 1219446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219456 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219481 */     // GIR_Coverage, 17581,
     /* 1219481 */     GIR_EraseRootFromParent_Done,
     /* 1219482 */   // Label 17669: @1219482
     /* 1219482 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1219562), // Rule ID 17584 //
     /* 1219487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219526 */     // MIs[0] round
     /* 1219526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219536 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219561 */     // GIR_Coverage, 17584,
     /* 1219561 */     GIR_EraseRootFromParent_Done,
     /* 1219562 */   // Label 17670: @1219562
     /* 1219562 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1219642), // Rule ID 17585 //
     /* 1219567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219606 */     // MIs[0] round
     /* 1219606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219616 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219641 */     // GIR_Coverage, 17585,
     /* 1219641 */     GIR_EraseRootFromParent_Done,
     /* 1219642 */   // Label 17671: @1219642
     /* 1219642 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1219722), // Rule ID 17588 //
     /* 1219647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219686 */     // MIs[0] round
     /* 1219686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219696 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1219699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219721 */     // GIR_Coverage, 17588,
     /* 1219721 */     GIR_EraseRootFromParent_Done,
     /* 1219722 */   // Label 17672: @1219722
     /* 1219722 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1219802), // Rule ID 17589 //
     /* 1219727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219766 */     // MIs[0] round
     /* 1219766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219776 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1219779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219801 */     // GIR_Coverage, 17589,
     /* 1219801 */     GIR_EraseRootFromParent_Done,
     /* 1219802 */   // Label 17673: @1219802
     /* 1219802 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1219882), // Rule ID 17592 //
     /* 1219807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1219824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219846 */     // MIs[0] round
     /* 1219846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219856 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1219859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219881 */     // GIR_Coverage, 17592,
     /* 1219881 */     GIR_EraseRootFromParent_Done,
     /* 1219882 */   // Label 17674: @1219882
     /* 1219882 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1219962), // Rule ID 17593 //
     /* 1219887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1219904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219926 */     // MIs[0] round
     /* 1219926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1219939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219961 */     // GIR_Coverage, 17593,
     /* 1219961 */     GIR_EraseRootFromParent_Done,
     /* 1219962 */   // Label 17675: @1219962
     /* 1219962 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1220042), // Rule ID 17596 //
     /* 1219967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1219978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1219981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1219984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220006 */     // MIs[0] round
     /* 1220006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220041 */     // GIR_Coverage, 17596,
     /* 1220041 */     GIR_EraseRootFromParent_Done,
     /* 1220042 */   // Label 17676: @1220042
     /* 1220042 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1220122), // Rule ID 17597 //
     /* 1220047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220086 */     // MIs[0] round
     /* 1220086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220121 */     // GIR_Coverage, 17597,
     /* 1220121 */     GIR_EraseRootFromParent_Done,
     /* 1220122 */   // Label 17677: @1220122
     /* 1220122 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1220202), // Rule ID 17600 //
     /* 1220127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220166 */     // MIs[0] round
     /* 1220166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220176 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220201 */     // GIR_Coverage, 17600,
     /* 1220201 */     GIR_EraseRootFromParent_Done,
     /* 1220202 */   // Label 17678: @1220202
     /* 1220202 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1220282), // Rule ID 17601 //
     /* 1220207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220246 */     // MIs[0] round
     /* 1220246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220256 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220281 */     // GIR_Coverage, 17601,
     /* 1220281 */     GIR_EraseRootFromParent_Done,
     /* 1220282 */   // Label 17679: @1220282
     /* 1220282 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1220362), // Rule ID 17604 //
     /* 1220287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220326 */     // MIs[0] round
     /* 1220326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220336 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220361 */     // GIR_Coverage, 17604,
     /* 1220361 */     GIR_EraseRootFromParent_Done,
     /* 1220362 */   // Label 17680: @1220362
     /* 1220362 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1220442), // Rule ID 17605 //
     /* 1220367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220406 */     // MIs[0] round
     /* 1220406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220416 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220441 */     // GIR_Coverage, 17605,
     /* 1220441 */     GIR_EraseRootFromParent_Done,
     /* 1220442 */   // Label 17681: @1220442
     /* 1220442 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1220522), // Rule ID 17608 //
     /* 1220447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220486 */     // MIs[0] round
     /* 1220486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220521 */     // GIR_Coverage, 17608,
     /* 1220521 */     GIR_EraseRootFromParent_Done,
     /* 1220522 */   // Label 17682: @1220522
     /* 1220522 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1220602), // Rule ID 17609 //
     /* 1220527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220566 */     // MIs[0] round
     /* 1220566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220576 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220601 */     // GIR_Coverage, 17609,
     /* 1220601 */     GIR_EraseRootFromParent_Done,
     /* 1220602 */   // Label 17683: @1220602
     /* 1220602 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1220682), // Rule ID 17612 //
     /* 1220607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1220624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220646 */     // MIs[0] round
     /* 1220646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220656 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1220659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220681 */     // GIR_Coverage, 17612,
     /* 1220681 */     GIR_EraseRootFromParent_Done,
     /* 1220682 */   // Label 17684: @1220682
     /* 1220682 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1220762), // Rule ID 17613 //
     /* 1220687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1220704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220726 */     // MIs[0] round
     /* 1220726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220736 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1220739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220761 */     // GIR_Coverage, 17613,
     /* 1220761 */     GIR_EraseRootFromParent_Done,
     /* 1220762 */   // Label 17685: @1220762
     /* 1220762 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1220842), // Rule ID 17616 //
     /* 1220767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1220775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1220778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1220781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220806 */     // MIs[0] round
     /* 1220806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220816 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1220819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220841 */     // GIR_Coverage, 17616,
     /* 1220841 */     GIR_EraseRootFromParent_Done,
     /* 1220842 */   // Label 17686: @1220842
     /* 1220842 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1220922), // Rule ID 17617 //
     /* 1220847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1220855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1220858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1220861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220886 */     // MIs[0] round
     /* 1220886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220896 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1220899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220921 */     // GIR_Coverage, 17617,
     /* 1220921 */     GIR_EraseRootFromParent_Done,
     /* 1220922 */   // Label 17687: @1220922
     /* 1220922 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1221002), // Rule ID 17620 //
     /* 1220927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1220930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1220935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1220938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1220941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1220944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220966 */     // MIs[0] round
     /* 1220966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220976 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1220979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221001 */     // GIR_Coverage, 17620,
     /* 1221001 */     GIR_EraseRootFromParent_Done,
     /* 1221002 */   // Label 17688: @1221002
     /* 1221002 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1221082), // Rule ID 17621 //
     /* 1221007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221046 */     // MIs[0] round
     /* 1221046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221056 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221081 */     // GIR_Coverage, 17621,
     /* 1221081 */     GIR_EraseRootFromParent_Done,
     /* 1221082 */   // Label 17689: @1221082
     /* 1221082 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1221162), // Rule ID 17624 //
     /* 1221087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221126 */     // MIs[0] round
     /* 1221126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221161 */     // GIR_Coverage, 17624,
     /* 1221161 */     GIR_EraseRootFromParent_Done,
     /* 1221162 */   // Label 17690: @1221162
     /* 1221162 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1221242), // Rule ID 17625 //
     /* 1221167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221206 */     // MIs[0] round
     /* 1221206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221241 */     // GIR_Coverage, 17625,
     /* 1221241 */     GIR_EraseRootFromParent_Done,
     /* 1221242 */   // Label 17691: @1221242
     /* 1221242 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1221322), // Rule ID 17628 //
     /* 1221247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221286 */     // MIs[0] round
     /* 1221286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221296 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221321 */     // GIR_Coverage, 17628,
     /* 1221321 */     GIR_EraseRootFromParent_Done,
     /* 1221322 */   // Label 17692: @1221322
     /* 1221322 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1221402), // Rule ID 17629 //
     /* 1221327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221366 */     // MIs[0] round
     /* 1221366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221376 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221401 */     // GIR_Coverage, 17629,
     /* 1221401 */     GIR_EraseRootFromParent_Done,
     /* 1221402 */   // Label 17693: @1221402
     /* 1221402 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1221482), // Rule ID 17632 //
     /* 1221407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221446 */     // MIs[0] round
     /* 1221446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221481 */     // GIR_Coverage, 17632,
     /* 1221481 */     GIR_EraseRootFromParent_Done,
     /* 1221482 */   // Label 17694: @1221482
     /* 1221482 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1221562), // Rule ID 17633 //
     /* 1221487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221526 */     // MIs[0] round
     /* 1221526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221561 */     // GIR_Coverage, 17633,
     /* 1221561 */     GIR_EraseRootFromParent_Done,
     /* 1221562 */   // Label 17695: @1221562
     /* 1221562 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1221642), // Rule ID 17636 //
     /* 1221567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221606 */     // MIs[0] round
     /* 1221606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221616 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1221619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221641 */     // GIR_Coverage, 17636,
     /* 1221641 */     GIR_EraseRootFromParent_Done,
     /* 1221642 */   // Label 17696: @1221642
     /* 1221642 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1221722), // Rule ID 17637 //
     /* 1221647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221686 */     // MIs[0] round
     /* 1221686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1221699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221721 */     // GIR_Coverage, 17637,
     /* 1221721 */     GIR_EraseRootFromParent_Done,
     /* 1221722 */   // Label 17697: @1221722
     /* 1221722 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1221802), // Rule ID 17640 //
     /* 1221727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1221738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1221741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1221744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221766 */     // MIs[0] round
     /* 1221766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221776 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1221779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221801 */     // GIR_Coverage, 17640,
     /* 1221801 */     GIR_EraseRootFromParent_Done,
     /* 1221802 */   // Label 17698: @1221802
     /* 1221802 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1221882), // Rule ID 17641 //
     /* 1221807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1221818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1221821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1221824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221846 */     // MIs[0] round
     /* 1221846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221856 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1221859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221881 */     // GIR_Coverage, 17641,
     /* 1221881 */     GIR_EraseRootFromParent_Done,
     /* 1221882 */   // Label 17699: @1221882
     /* 1221882 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1221962), // Rule ID 17644 //
     /* 1221887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1221898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1221901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1221904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221926 */     // MIs[0] round
     /* 1221926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221936 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1221939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221961 */     // GIR_Coverage, 17644,
     /* 1221961 */     GIR_EraseRootFromParent_Done,
     /* 1221962 */   // Label 17700: @1221962
     /* 1221962 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1222042), // Rule ID 17645 //
     /* 1221967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1221978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1221981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1221984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222006 */     // MIs[0] round
     /* 1222006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222016 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222041 */     // GIR_Coverage, 17645,
     /* 1222041 */     GIR_EraseRootFromParent_Done,
     /* 1222042 */   // Label 17701: @1222042
     /* 1222042 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1222122), // Rule ID 17648 //
     /* 1222047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222086 */     // MIs[0] round
     /* 1222086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222096 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222121 */     // GIR_Coverage, 17648,
     /* 1222121 */     GIR_EraseRootFromParent_Done,
     /* 1222122 */   // Label 17702: @1222122
     /* 1222122 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1222202), // Rule ID 17649 //
     /* 1222127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222166 */     // MIs[0] round
     /* 1222166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222176 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222201 */     // GIR_Coverage, 17649,
     /* 1222201 */     GIR_EraseRootFromParent_Done,
     /* 1222202 */   // Label 17703: @1222202
     /* 1222202 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1222282), // Rule ID 17652 //
     /* 1222207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222246 */     // MIs[0] round
     /* 1222246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222256 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222281 */     // GIR_Coverage, 17652,
     /* 1222281 */     GIR_EraseRootFromParent_Done,
     /* 1222282 */   // Label 17704: @1222282
     /* 1222282 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1222362), // Rule ID 17653 //
     /* 1222287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222326 */     // MIs[0] round
     /* 1222326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222336 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222361 */     // GIR_Coverage, 17653,
     /* 1222361 */     GIR_EraseRootFromParent_Done,
     /* 1222362 */   // Label 17705: @1222362
     /* 1222362 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1222442), // Rule ID 17656 //
     /* 1222367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222406 */     // MIs[0] round
     /* 1222406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222416 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222441 */     // GIR_Coverage, 17656,
     /* 1222441 */     GIR_EraseRootFromParent_Done,
     /* 1222442 */   // Label 17706: @1222442
     /* 1222442 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1222522), // Rule ID 17657 //
     /* 1222447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222486 */     // MIs[0] round
     /* 1222486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222496 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222521 */     // GIR_Coverage, 17657,
     /* 1222521 */     GIR_EraseRootFromParent_Done,
     /* 1222522 */   // Label 17707: @1222522
     /* 1222522 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1222602), // Rule ID 17660 //
     /* 1222527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222566 */     // MIs[0] round
     /* 1222566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222576 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222601 */     // GIR_Coverage, 17660,
     /* 1222601 */     GIR_EraseRootFromParent_Done,
     /* 1222602 */   // Label 17708: @1222602
     /* 1222602 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1222682), // Rule ID 17661 //
     /* 1222607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222646 */     // MIs[0] round
     /* 1222646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222656 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222681 */     // GIR_Coverage, 17661,
     /* 1222681 */     GIR_EraseRootFromParent_Done,
     /* 1222682 */   // Label 17709: @1222682
     /* 1222682 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1222762), // Rule ID 17664 //
     /* 1222687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1222698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1222701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1222704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222726 */     // MIs[0] round
     /* 1222726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1222739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222761 */     // GIR_Coverage, 17664,
     /* 1222761 */     GIR_EraseRootFromParent_Done,
     /* 1222762 */   // Label 17710: @1222762
     /* 1222762 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1222842), // Rule ID 17665 //
     /* 1222767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1222778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1222781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1222784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222806 */     // MIs[0] round
     /* 1222806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222816 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1222819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222841 */     // GIR_Coverage, 17665,
     /* 1222841 */     GIR_EraseRootFromParent_Done,
     /* 1222842 */   // Label 17711: @1222842
     /* 1222842 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1222922), // Rule ID 17668 //
     /* 1222847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1222858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1222861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1222864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222886 */     // MIs[0] round
     /* 1222886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222896 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1222899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222921 */     // GIR_Coverage, 17668,
     /* 1222921 */     GIR_EraseRootFromParent_Done,
     /* 1222922 */   // Label 17712: @1222922
     /* 1222922 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1223002), // Rule ID 17669 //
     /* 1222927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1222938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1222941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1222944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1222947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222966 */     // MIs[0] round
     /* 1222966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222976 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1222979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223001 */     // GIR_Coverage, 17669,
     /* 1223001 */     GIR_EraseRootFromParent_Done,
     /* 1223002 */   // Label 17713: @1223002
     /* 1223002 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1223082), // Rule ID 17672 //
     /* 1223007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223046 */     // MIs[0] round
     /* 1223046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223056 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223081 */     // GIR_Coverage, 17672,
     /* 1223081 */     GIR_EraseRootFromParent_Done,
     /* 1223082 */   // Label 17714: @1223082
     /* 1223082 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1223162), // Rule ID 17673 //
     /* 1223087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223126 */     // MIs[0] round
     /* 1223126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223136 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223161 */     // GIR_Coverage, 17673,
     /* 1223161 */     GIR_EraseRootFromParent_Done,
     /* 1223162 */   // Label 17715: @1223162
     /* 1223162 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1223242), // Rule ID 17676 //
     /* 1223167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223206 */     // MIs[0] round
     /* 1223206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223241 */     // GIR_Coverage, 17676,
     /* 1223241 */     GIR_EraseRootFromParent_Done,
     /* 1223242 */   // Label 17716: @1223242
     /* 1223242 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1223322), // Rule ID 17677 //
     /* 1223247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223286 */     // MIs[0] round
     /* 1223286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223321 */     // GIR_Coverage, 17677,
     /* 1223321 */     GIR_EraseRootFromParent_Done,
     /* 1223322 */   // Label 17717: @1223322
     /* 1223322 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1223402), // Rule ID 17680 //
     /* 1223327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223366 */     // MIs[0] round
     /* 1223366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223376 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223401 */     // GIR_Coverage, 17680,
     /* 1223401 */     GIR_EraseRootFromParent_Done,
     /* 1223402 */   // Label 17718: @1223402
     /* 1223402 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1223482), // Rule ID 17681 //
     /* 1223407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223446 */     // MIs[0] round
     /* 1223446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223481 */     // GIR_Coverage, 17681,
     /* 1223481 */     GIR_EraseRootFromParent_Done,
     /* 1223482 */   // Label 17719: @1223482
     /* 1223482 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1223562), // Rule ID 17684 //
     /* 1223487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223526 */     // MIs[0] round
     /* 1223526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223561 */     // GIR_Coverage, 17684,
     /* 1223561 */     GIR_EraseRootFromParent_Done,
     /* 1223562 */   // Label 17720: @1223562
     /* 1223562 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1223642), // Rule ID 17685 //
     /* 1223567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223606 */     // MIs[0] round
     /* 1223606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223616 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223641 */     // GIR_Coverage, 17685,
     /* 1223641 */     GIR_EraseRootFromParent_Done,
     /* 1223642 */   // Label 17721: @1223642
     /* 1223642 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1223722), // Rule ID 17688 //
     /* 1223647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1223667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223686 */     // MIs[0] round
     /* 1223686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1223699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223721 */     // GIR_Coverage, 17688,
     /* 1223721 */     GIR_EraseRootFromParent_Done,
     /* 1223722 */   // Label 17722: @1223722
     /* 1223722 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1223802), // Rule ID 17689 //
     /* 1223727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1223747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223766 */     // MIs[0] round
     /* 1223766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223776 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1223779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223801 */     // GIR_Coverage, 17689,
     /* 1223801 */     GIR_EraseRootFromParent_Done,
     /* 1223802 */   // Label 17723: @1223802
     /* 1223802 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1223882), // Rule ID 17692 //
     /* 1223807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1223824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1223827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223846 */     // MIs[0] round
     /* 1223846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223856 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1223859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223881 */     // GIR_Coverage, 17692,
     /* 1223881 */     GIR_EraseRootFromParent_Done,
     /* 1223882 */   // Label 17724: @1223882
     /* 1223882 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1223962), // Rule ID 17693 //
     /* 1223887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1223898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1223901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1223904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1223907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223926 */     // MIs[0] round
     /* 1223926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223936 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1223939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223961 */     // GIR_Coverage, 17693,
     /* 1223961 */     GIR_EraseRootFromParent_Done,
     /* 1223962 */   // Label 17725: @1223962
     /* 1223962 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1224042), // Rule ID 17696 //
     /* 1223967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1223970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1223984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1223987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224006 */     // MIs[0] round
     /* 1224006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224041 */     // GIR_Coverage, 17696,
     /* 1224041 */     GIR_EraseRootFromParent_Done,
     /* 1224042 */   // Label 17726: @1224042
     /* 1224042 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1224122), // Rule ID 17697 //
     /* 1224047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224086 */     // MIs[0] round
     /* 1224086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224121 */     // GIR_Coverage, 17697,
     /* 1224121 */     GIR_EraseRootFromParent_Done,
     /* 1224122 */   // Label 17727: @1224122
     /* 1224122 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1224202), // Rule ID 17700 //
     /* 1224127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224166 */     // MIs[0] round
     /* 1224166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224201 */     // GIR_Coverage, 17700,
     /* 1224201 */     GIR_EraseRootFromParent_Done,
     /* 1224202 */   // Label 17728: @1224202
     /* 1224202 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1224282), // Rule ID 17701 //
     /* 1224207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224246 */     // MIs[0] round
     /* 1224246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224281 */     // GIR_Coverage, 17701,
     /* 1224281 */     GIR_EraseRootFromParent_Done,
     /* 1224282 */   // Label 17729: @1224282
     /* 1224282 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1224362), // Rule ID 17704 //
     /* 1224287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224326 */     // MIs[0] round
     /* 1224326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224361 */     // GIR_Coverage, 17704,
     /* 1224361 */     GIR_EraseRootFromParent_Done,
     /* 1224362 */   // Label 17730: @1224362
     /* 1224362 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1224442), // Rule ID 17705 //
     /* 1224367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224406 */     // MIs[0] round
     /* 1224406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224441 */     // GIR_Coverage, 17705,
     /* 1224441 */     GIR_EraseRootFromParent_Done,
     /* 1224442 */   // Label 17731: @1224442
     /* 1224442 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1224522), // Rule ID 17708 //
     /* 1224447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224486 */     // MIs[0] round
     /* 1224486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224496 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224521 */     // GIR_Coverage, 17708,
     /* 1224521 */     GIR_EraseRootFromParent_Done,
     /* 1224522 */   // Label 17732: @1224522
     /* 1224522 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1224602), // Rule ID 17709 //
     /* 1224527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224566 */     // MIs[0] round
     /* 1224566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224576 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224601 */     // GIR_Coverage, 17709,
     /* 1224601 */     GIR_EraseRootFromParent_Done,
     /* 1224602 */   // Label 17733: @1224602
     /* 1224602 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1224682), // Rule ID 17712 //
     /* 1224607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224646 */     // MIs[0] round
     /* 1224646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224656 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1224659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224681 */     // GIR_Coverage, 17712,
     /* 1224681 */     GIR_EraseRootFromParent_Done,
     /* 1224682 */   // Label 17734: @1224682
     /* 1224682 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1224762), // Rule ID 17713 //
     /* 1224687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224726 */     // MIs[0] round
     /* 1224726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224736 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1224739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224761 */     // GIR_Coverage, 17713,
     /* 1224761 */     GIR_EraseRootFromParent_Done,
     /* 1224762 */   // Label 17735: @1224762
     /* 1224762 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1224842), // Rule ID 17716 //
     /* 1224767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224806 */     // MIs[0] round
     /* 1224806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224816 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1224819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224841 */     // GIR_Coverage, 17716,
     /* 1224841 */     GIR_EraseRootFromParent_Done,
     /* 1224842 */   // Label 17736: @1224842
     /* 1224842 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1224922), // Rule ID 17717 //
     /* 1224847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224886 */     // MIs[0] round
     /* 1224886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1224899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224921 */     // GIR_Coverage, 17717,
     /* 1224921 */     GIR_EraseRootFromParent_Done,
     /* 1224922 */   // Label 17737: @1224922
     /* 1224922 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1225002), // Rule ID 17720 //
     /* 1224927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1224938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1224941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224966 */     // MIs[0] round
     /* 1224966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1224979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225001 */     // GIR_Coverage, 17720,
     /* 1225001 */     GIR_EraseRootFromParent_Done,
     /* 1225002 */   // Label 17738: @1225002
     /* 1225002 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1225082), // Rule ID 17721 //
     /* 1225007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225046 */     // MIs[0] round
     /* 1225046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225081 */     // GIR_Coverage, 17721,
     /* 1225081 */     GIR_EraseRootFromParent_Done,
     /* 1225082 */   // Label 17739: @1225082
     /* 1225082 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1225162), // Rule ID 17724 //
     /* 1225087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225126 */     // MIs[0] round
     /* 1225126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225136 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225161 */     // GIR_Coverage, 17724,
     /* 1225161 */     GIR_EraseRootFromParent_Done,
     /* 1225162 */   // Label 17740: @1225162
     /* 1225162 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1225242), // Rule ID 17725 //
     /* 1225167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225206 */     // MIs[0] round
     /* 1225206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225216 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225241 */     // GIR_Coverage, 17725,
     /* 1225241 */     GIR_EraseRootFromParent_Done,
     /* 1225242 */   // Label 17741: @1225242
     /* 1225242 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1225322), // Rule ID 17728 //
     /* 1225247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225286 */     // MIs[0] round
     /* 1225286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225296 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225321 */     // GIR_Coverage, 17728,
     /* 1225321 */     GIR_EraseRootFromParent_Done,
     /* 1225322 */   // Label 17742: @1225322
     /* 1225322 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1225402), // Rule ID 17729 //
     /* 1225327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225366 */     // MIs[0] round
     /* 1225366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225376 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225401 */     // GIR_Coverage, 17729,
     /* 1225401 */     GIR_EraseRootFromParent_Done,
     /* 1225402 */   // Label 17743: @1225402
     /* 1225402 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1225482), // Rule ID 17732 //
     /* 1225407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225446 */     // MIs[0] round
     /* 1225446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225481 */     // GIR_Coverage, 17732,
     /* 1225481 */     GIR_EraseRootFromParent_Done,
     /* 1225482 */   // Label 17744: @1225482
     /* 1225482 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1225562), // Rule ID 17733 //
     /* 1225487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225526 */     // MIs[0] round
     /* 1225526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225536 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225561 */     // GIR_Coverage, 17733,
     /* 1225561 */     GIR_EraseRootFromParent_Done,
     /* 1225562 */   // Label 17745: @1225562
     /* 1225562 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1225642), // Rule ID 17736 //
     /* 1225567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225606 */     // MIs[0] round
     /* 1225606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1225619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225641 */     // GIR_Coverage, 17736,
     /* 1225641 */     GIR_EraseRootFromParent_Done,
     /* 1225642 */   // Label 17746: @1225642
     /* 1225642 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1225722), // Rule ID 17737 //
     /* 1225647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225686 */     // MIs[0] round
     /* 1225686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225696 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1225699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225721 */     // GIR_Coverage, 17737,
     /* 1225721 */     GIR_EraseRootFromParent_Done,
     /* 1225722 */   // Label 17747: @1225722
     /* 1225722 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1225802), // Rule ID 17740 //
     /* 1225727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225766 */     // MIs[0] round
     /* 1225766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1225779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225801 */     // GIR_Coverage, 17740,
     /* 1225801 */     GIR_EraseRootFromParent_Done,
     /* 1225802 */   // Label 17748: @1225802
     /* 1225802 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1225882), // Rule ID 17741 //
     /* 1225807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1225818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1225821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225846 */     // MIs[0] round
     /* 1225846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225856 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1225859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225881 */     // GIR_Coverage, 17741,
     /* 1225881 */     GIR_EraseRootFromParent_Done,
     /* 1225882 */   // Label 17749: @1225882
     /* 1225882 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1225962), // Rule ID 17744 //
     /* 1225887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225926 */     // MIs[0] round
     /* 1225926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225936 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1225939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225961 */     // GIR_Coverage, 17744,
     /* 1225961 */     GIR_EraseRootFromParent_Done,
     /* 1225962 */   // Label 17750: @1225962
     /* 1225962 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1226042), // Rule ID 17745 //
     /* 1225967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1225978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1225981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226006 */     // MIs[0] round
     /* 1226006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226016 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226041 */     // GIR_Coverage, 17745,
     /* 1226041 */     GIR_EraseRootFromParent_Done,
     /* 1226042 */   // Label 17751: @1226042
     /* 1226042 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1226122), // Rule ID 22822 //
     /* 1226047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226086 */     // MIs[0] round
     /* 1226086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226096 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226121 */     // GIR_Coverage, 22822,
     /* 1226121 */     GIR_EraseRootFromParent_Done,
     /* 1226122 */   // Label 17752: @1226122
     /* 1226122 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1226202), // Rule ID 22823 //
     /* 1226127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226166 */     // MIs[0] round
     /* 1226166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226176 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226201 */     // GIR_Coverage, 22823,
     /* 1226201 */     GIR_EraseRootFromParent_Done,
     /* 1226202 */   // Label 17753: @1226202
     /* 1226202 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1226282), // Rule ID 22826 //
     /* 1226207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226246 */     // MIs[0] round
     /* 1226246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226281 */     // GIR_Coverage, 22826,
     /* 1226281 */     GIR_EraseRootFromParent_Done,
     /* 1226282 */   // Label 17754: @1226282
     /* 1226282 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1226362), // Rule ID 22827 //
     /* 1226287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226326 */     // MIs[0] round
     /* 1226326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226361 */     // GIR_Coverage, 22827,
     /* 1226361 */     GIR_EraseRootFromParent_Done,
     /* 1226362 */   // Label 17755: @1226362
     /* 1226362 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1226442), // Rule ID 22830 //
     /* 1226367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226406 */     // MIs[0] round
     /* 1226406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226441 */     // GIR_Coverage, 22830,
     /* 1226441 */     GIR_EraseRootFromParent_Done,
     /* 1226442 */   // Label 17756: @1226442
     /* 1226442 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1226522), // Rule ID 22831 //
     /* 1226447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226486 */     // MIs[0] round
     /* 1226486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226521 */     // GIR_Coverage, 22831,
     /* 1226521 */     GIR_EraseRootFromParent_Done,
     /* 1226522 */   // Label 17757: @1226522
     /* 1226522 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1226602), // Rule ID 22834 //
     /* 1226527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226566 */     // MIs[0] round
     /* 1226566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226601 */     // GIR_Coverage, 22834,
     /* 1226601 */     GIR_EraseRootFromParent_Done,
     /* 1226602 */   // Label 17758: @1226602
     /* 1226602 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1226682), // Rule ID 22835 //
     /* 1226607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226646 */     // MIs[0] round
     /* 1226646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226681 */     // GIR_Coverage, 22835,
     /* 1226681 */     GIR_EraseRootFromParent_Done,
     /* 1226682 */   // Label 17759: @1226682
     /* 1226682 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1226762), // Rule ID 22838 //
     /* 1226687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1226690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1226704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226726 */     // MIs[0] round
     /* 1226726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1226739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226761 */     // GIR_Coverage, 22838,
     /* 1226761 */     GIR_EraseRootFromParent_Done,
     /* 1226762 */   // Label 17760: @1226762
     /* 1226762 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1226842), // Rule ID 22839 //
     /* 1226767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1226770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1226784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226806 */     // MIs[0] round
     /* 1226806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1226819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226841 */     // GIR_Coverage, 22839,
     /* 1226841 */     GIR_EraseRootFromParent_Done,
     /* 1226842 */   // Label 17761: @1226842
     /* 1226842 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1226922), // Rule ID 22842 //
     /* 1226847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1226864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226886 */     // MIs[0] round
     /* 1226886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1226899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226921 */     // GIR_Coverage, 22842,
     /* 1226921 */     GIR_EraseRootFromParent_Done,
     /* 1226922 */   // Label 17762: @1226922
     /* 1226922 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1227002), // Rule ID 22843 //
     /* 1226927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1226944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226966 */     // MIs[0] round
     /* 1226966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226976 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1226979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227001 */     // GIR_Coverage, 22843,
     /* 1227001 */     GIR_EraseRootFromParent_Done,
     /* 1227002 */   // Label 17763: @1227002
     /* 1227002 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1227082), // Rule ID 22846 //
     /* 1227007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227046 */     // MIs[0] round
     /* 1227046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227056 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227081 */     // GIR_Coverage, 22846,
     /* 1227081 */     GIR_EraseRootFromParent_Done,
     /* 1227082 */   // Label 17764: @1227082
     /* 1227082 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1227162), // Rule ID 22847 //
     /* 1227087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227126 */     // MIs[0] round
     /* 1227126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227136 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227161 */     // GIR_Coverage, 22847,
     /* 1227161 */     GIR_EraseRootFromParent_Done,
     /* 1227162 */   // Label 17765: @1227162
     /* 1227162 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1227242), // Rule ID 22850 //
     /* 1227167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227206 */     // MIs[0] round
     /* 1227206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227216 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227241 */     // GIR_Coverage, 22850,
     /* 1227241 */     GIR_EraseRootFromParent_Done,
     /* 1227242 */   // Label 17766: @1227242
     /* 1227242 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1227322), // Rule ID 22851 //
     /* 1227247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227286 */     // MIs[0] round
     /* 1227286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227296 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227321 */     // GIR_Coverage, 22851,
     /* 1227321 */     GIR_EraseRootFromParent_Done,
     /* 1227322 */   // Label 17767: @1227322
     /* 1227322 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1227402), // Rule ID 22854 //
     /* 1227327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227366 */     // MIs[0] round
     /* 1227366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227376 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227401 */     // GIR_Coverage, 22854,
     /* 1227401 */     GIR_EraseRootFromParent_Done,
     /* 1227402 */   // Label 17768: @1227402
     /* 1227402 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1227482), // Rule ID 22855 //
     /* 1227407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227446 */     // MIs[0] round
     /* 1227446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227481 */     // GIR_Coverage, 22855,
     /* 1227481 */     GIR_EraseRootFromParent_Done,
     /* 1227482 */   // Label 17769: @1227482
     /* 1227482 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1227562), // Rule ID 22858 //
     /* 1227487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227526 */     // MIs[0] round
     /* 1227526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227561 */     // GIR_Coverage, 22858,
     /* 1227561 */     GIR_EraseRootFromParent_Done,
     /* 1227562 */   // Label 17770: @1227562
     /* 1227562 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1227642), // Rule ID 22859 //
     /* 1227567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227606 */     // MIs[0] round
     /* 1227606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227641 */     // GIR_Coverage, 22859,
     /* 1227641 */     GIR_EraseRootFromParent_Done,
     /* 1227642 */   // Label 17771: @1227642
     /* 1227642 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1227722), // Rule ID 22862 //
     /* 1227647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227686 */     // MIs[0] round
     /* 1227686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1227699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227721 */     // GIR_Coverage, 22862,
     /* 1227721 */     GIR_EraseRootFromParent_Done,
     /* 1227722 */   // Label 17772: @1227722
     /* 1227722 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1227802), // Rule ID 22863 //
     /* 1227727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227766 */     // MIs[0] round
     /* 1227766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1227779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227801 */     // GIR_Coverage, 22863,
     /* 1227801 */     GIR_EraseRootFromParent_Done,
     /* 1227802 */   // Label 17773: @1227802
     /* 1227802 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1227882), // Rule ID 22866 //
     /* 1227807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1227824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227846 */     // MIs[0] round
     /* 1227846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1227859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227881 */     // GIR_Coverage, 22866,
     /* 1227881 */     GIR_EraseRootFromParent_Done,
     /* 1227882 */   // Label 17774: @1227882
     /* 1227882 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1227962), // Rule ID 22867 //
     /* 1227887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1227904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227926 */     // MIs[0] round
     /* 1227926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227936 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1227939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227961 */     // GIR_Coverage, 22867,
     /* 1227961 */     GIR_EraseRootFromParent_Done,
     /* 1227962 */   // Label 17775: @1227962
     /* 1227962 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1228042), // Rule ID 22870 //
     /* 1227967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1227984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228006 */     // MIs[0] round
     /* 1228006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228041 */     // GIR_Coverage, 22870,
     /* 1228041 */     GIR_EraseRootFromParent_Done,
     /* 1228042 */   // Label 17776: @1228042
     /* 1228042 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1228122), // Rule ID 22871 //
     /* 1228047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228086 */     // MIs[0] round
     /* 1228086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228121 */     // GIR_Coverage, 22871,
     /* 1228121 */     GIR_EraseRootFromParent_Done,
     /* 1228122 */   // Label 17777: @1228122
     /* 1228122 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1228202), // Rule ID 22874 //
     /* 1228127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228166 */     // MIs[0] round
     /* 1228166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228201 */     // GIR_Coverage, 22874,
     /* 1228201 */     GIR_EraseRootFromParent_Done,
     /* 1228202 */   // Label 17778: @1228202
     /* 1228202 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1228282), // Rule ID 22875 //
     /* 1228207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228246 */     // MIs[0] round
     /* 1228246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228281 */     // GIR_Coverage, 22875,
     /* 1228281 */     GIR_EraseRootFromParent_Done,
     /* 1228282 */   // Label 17779: @1228282
     /* 1228282 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1228362), // Rule ID 22878 //
     /* 1228287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228326 */     // MIs[0] round
     /* 1228326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228336 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228361 */     // GIR_Coverage, 22878,
     /* 1228361 */     GIR_EraseRootFromParent_Done,
     /* 1228362 */   // Label 17780: @1228362
     /* 1228362 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1228442), // Rule ID 22879 //
     /* 1228367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228406 */     // MIs[0] round
     /* 1228406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228441 */     // GIR_Coverage, 22879,
     /* 1228441 */     GIR_EraseRootFromParent_Done,
     /* 1228442 */   // Label 17781: @1228442
     /* 1228442 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1228522), // Rule ID 22882 //
     /* 1228447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228486 */     // MIs[0] round
     /* 1228486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228521 */     // GIR_Coverage, 22882,
     /* 1228521 */     GIR_EraseRootFromParent_Done,
     /* 1228522 */   // Label 17782: @1228522
     /* 1228522 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1228602), // Rule ID 22883 //
     /* 1228527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228566 */     // MIs[0] round
     /* 1228566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228576 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228601 */     // GIR_Coverage, 22883,
     /* 1228601 */     GIR_EraseRootFromParent_Done,
     /* 1228602 */   // Label 17783: @1228602
     /* 1228602 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1228682), // Rule ID 22886 //
     /* 1228607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228646 */     // MIs[0] round
     /* 1228646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1228659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228681 */     // GIR_Coverage, 22886,
     /* 1228681 */     GIR_EraseRootFromParent_Done,
     /* 1228682 */   // Label 17784: @1228682
     /* 1228682 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1228762), // Rule ID 22887 //
     /* 1228687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228726 */     // MIs[0] round
     /* 1228726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1228739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228761 */     // GIR_Coverage, 22887,
     /* 1228761 */     GIR_EraseRootFromParent_Done,
     /* 1228762 */   // Label 17785: @1228762
     /* 1228762 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1228842), // Rule ID 22890 //
     /* 1228767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228806 */     // MIs[0] round
     /* 1228806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228816 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1228819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228841 */     // GIR_Coverage, 22890,
     /* 1228841 */     GIR_EraseRootFromParent_Done,
     /* 1228842 */   // Label 17786: @1228842
     /* 1228842 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1228922), // Rule ID 22891 //
     /* 1228847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228886 */     // MIs[0] round
     /* 1228886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228896 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1228899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228921 */     // GIR_Coverage, 22891,
     /* 1228921 */     GIR_EraseRootFromParent_Done,
     /* 1228922 */   // Label 17787: @1228922
     /* 1228922 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1229002), // Rule ID 22894 //
     /* 1228927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228966 */     // MIs[0] round
     /* 1228966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1228979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229001 */     // GIR_Coverage, 22894,
     /* 1229001 */     GIR_EraseRootFromParent_Done,
     /* 1229002 */   // Label 17788: @1229002
     /* 1229002 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1229082), // Rule ID 22895 //
     /* 1229007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229046 */     // MIs[0] round
     /* 1229046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229081 */     // GIR_Coverage, 22895,
     /* 1229081 */     GIR_EraseRootFromParent_Done,
     /* 1229082 */   // Label 17789: @1229082
     /* 1229082 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1229162), // Rule ID 22898 //
     /* 1229087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229126 */     // MIs[0] round
     /* 1229126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229161 */     // GIR_Coverage, 22898,
     /* 1229161 */     GIR_EraseRootFromParent_Done,
     /* 1229162 */   // Label 17790: @1229162
     /* 1229162 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1229242), // Rule ID 22899 //
     /* 1229167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229206 */     // MIs[0] round
     /* 1229206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229216 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229241 */     // GIR_Coverage, 22899,
     /* 1229241 */     GIR_EraseRootFromParent_Done,
     /* 1229242 */   // Label 17791: @1229242
     /* 1229242 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1229322), // Rule ID 22902 //
     /* 1229247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229286 */     // MIs[0] round
     /* 1229286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229296 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229321 */     // GIR_Coverage, 22902,
     /* 1229321 */     GIR_EraseRootFromParent_Done,
     /* 1229322 */   // Label 17792: @1229322
     /* 1229322 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1229402), // Rule ID 22903 //
     /* 1229327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229366 */     // MIs[0] round
     /* 1229366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229376 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229401 */     // GIR_Coverage, 22903,
     /* 1229401 */     GIR_EraseRootFromParent_Done,
     /* 1229402 */   // Label 17793: @1229402
     /* 1229402 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1229482), // Rule ID 22906 //
     /* 1229407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229446 */     // MIs[0] round
     /* 1229446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229481 */     // GIR_Coverage, 22906,
     /* 1229481 */     GIR_EraseRootFromParent_Done,
     /* 1229482 */   // Label 17794: @1229482
     /* 1229482 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1229562), // Rule ID 22907 //
     /* 1229487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229526 */     // MIs[0] round
     /* 1229526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229536 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229561 */     // GIR_Coverage, 22907,
     /* 1229561 */     GIR_EraseRootFromParent_Done,
     /* 1229562 */   // Label 17795: @1229562
     /* 1229562 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1229642), // Rule ID 22910 //
     /* 1229567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229606 */     // MIs[0] round
     /* 1229606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1229619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229641 */     // GIR_Coverage, 22910,
     /* 1229641 */     GIR_EraseRootFromParent_Done,
     /* 1229642 */   // Label 17796: @1229642
     /* 1229642 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1229722), // Rule ID 22911 //
     /* 1229647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229686 */     // MIs[0] round
     /* 1229686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229696 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1229699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229721 */     // GIR_Coverage, 22911,
     /* 1229721 */     GIR_EraseRootFromParent_Done,
     /* 1229722 */   // Label 17797: @1229722
     /* 1229722 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1229802), // Rule ID 22914 //
     /* 1229727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229766 */     // MIs[0] round
     /* 1229766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1229779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229801 */     // GIR_Coverage, 22914,
     /* 1229801 */     GIR_EraseRootFromParent_Done,
     /* 1229802 */   // Label 17798: @1229802
     /* 1229802 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1229882), // Rule ID 22915 //
     /* 1229807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229846 */     // MIs[0] round
     /* 1229846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1229859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229881 */     // GIR_Coverage, 22915,
     /* 1229881 */     GIR_EraseRootFromParent_Done,
     /* 1229882 */   // Label 17799: @1229882
     /* 1229882 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1229962), // Rule ID 22918 //
     /* 1229887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229926 */     // MIs[0] round
     /* 1229926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229936 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1229939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229961 */     // GIR_Coverage, 22918,
     /* 1229961 */     GIR_EraseRootFromParent_Done,
     /* 1229962 */   // Label 17800: @1229962
     /* 1229962 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1230042), // Rule ID 22919 //
     /* 1229967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230006 */     // MIs[0] round
     /* 1230006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230041 */     // GIR_Coverage, 22919,
     /* 1230041 */     GIR_EraseRootFromParent_Done,
     /* 1230042 */   // Label 17801: @1230042
     /* 1230042 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1230122), // Rule ID 22922 //
     /* 1230047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230086 */     // MIs[0] round
     /* 1230086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230096 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230121 */     // GIR_Coverage, 22922,
     /* 1230121 */     GIR_EraseRootFromParent_Done,
     /* 1230122 */   // Label 17802: @1230122
     /* 1230122 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1230202), // Rule ID 22923 //
     /* 1230127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230166 */     // MIs[0] round
     /* 1230166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230201 */     // GIR_Coverage, 22923,
     /* 1230201 */     GIR_EraseRootFromParent_Done,
     /* 1230202 */   // Label 17803: @1230202
     /* 1230202 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1230282), // Rule ID 22926 //
     /* 1230207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230246 */     // MIs[0] round
     /* 1230246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230281 */     // GIR_Coverage, 22926,
     /* 1230281 */     GIR_EraseRootFromParent_Done,
     /* 1230282 */   // Label 17804: @1230282
     /* 1230282 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1230362), // Rule ID 22927 //
     /* 1230287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230326 */     // MIs[0] round
     /* 1230326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230361 */     // GIR_Coverage, 22927,
     /* 1230361 */     GIR_EraseRootFromParent_Done,
     /* 1230362 */   // Label 17805: @1230362
     /* 1230362 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1230442), // Rule ID 22930 //
     /* 1230367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230406 */     // MIs[0] round
     /* 1230406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230441 */     // GIR_Coverage, 22930,
     /* 1230441 */     GIR_EraseRootFromParent_Done,
     /* 1230442 */   // Label 17806: @1230442
     /* 1230442 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1230522), // Rule ID 22931 //
     /* 1230447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230486 */     // MIs[0] round
     /* 1230486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230521 */     // GIR_Coverage, 22931,
     /* 1230521 */     GIR_EraseRootFromParent_Done,
     /* 1230522 */   // Label 17807: @1230522
     /* 1230522 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1230602), // Rule ID 22934 //
     /* 1230527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230566 */     // MIs[0] round
     /* 1230566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230601 */     // GIR_Coverage, 22934,
     /* 1230601 */     GIR_EraseRootFromParent_Done,
     /* 1230602 */   // Label 17808: @1230602
     /* 1230602 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1230682), // Rule ID 22935 //
     /* 1230607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230646 */     // MIs[0] round
     /* 1230646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230681 */     // GIR_Coverage, 22935,
     /* 1230681 */     GIR_EraseRootFromParent_Done,
     /* 1230682 */   // Label 17809: @1230682
     /* 1230682 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1230762), // Rule ID 23058 //
     /* 1230687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1230695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1230704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230726 */     // MIs[0] round
     /* 1230726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1230739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230761 */     // GIR_Coverage, 23058,
     /* 1230761 */     GIR_EraseRootFromParent_Done,
     /* 1230762 */   // Label 17810: @1230762
     /* 1230762 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1230842), // Rule ID 23059 //
     /* 1230767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1230775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1230784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230806 */     // MIs[0] round
     /* 1230806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230816 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1230819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230841 */     // GIR_Coverage, 23059,
     /* 1230841 */     GIR_EraseRootFromParent_Done,
     /* 1230842 */   // Label 17811: @1230842
     /* 1230842 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1230922), // Rule ID 23062 //
     /* 1230847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1230850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1230855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230886 */     // MIs[0] round
     /* 1230886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1230899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230921 */     // GIR_Coverage, 23062,
     /* 1230921 */     GIR_EraseRootFromParent_Done,
     /* 1230922 */   // Label 17812: @1230922
     /* 1230922 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1231002), // Rule ID 23063 //
     /* 1230927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1230930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1230935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1230944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230966 */     // MIs[0] round
     /* 1230966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1230979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231001 */     // GIR_Coverage, 23063,
     /* 1231001 */     GIR_EraseRootFromParent_Done,
     /* 1231002 */   // Label 17813: @1231002
     /* 1231002 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1231082), // Rule ID 23066 //
     /* 1231007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231046 */     // MIs[0] round
     /* 1231046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231081 */     // GIR_Coverage, 23066,
     /* 1231081 */     GIR_EraseRootFromParent_Done,
     /* 1231082 */   // Label 17814: @1231082
     /* 1231082 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1231162), // Rule ID 23067 //
     /* 1231087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231126 */     // MIs[0] round
     /* 1231126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231161 */     // GIR_Coverage, 23067,
     /* 1231161 */     GIR_EraseRootFromParent_Done,
     /* 1231162 */   // Label 17815: @1231162
     /* 1231162 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1231242), // Rule ID 23070 //
     /* 1231167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231206 */     // MIs[0] round
     /* 1231206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231216 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231241 */     // GIR_Coverage, 23070,
     /* 1231241 */     GIR_EraseRootFromParent_Done,
     /* 1231242 */   // Label 17816: @1231242
     /* 1231242 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1231322), // Rule ID 23071 //
     /* 1231247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231286 */     // MIs[0] round
     /* 1231286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231296 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231321 */     // GIR_Coverage, 23071,
     /* 1231321 */     GIR_EraseRootFromParent_Done,
     /* 1231322 */   // Label 17817: @1231322
     /* 1231322 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1231402), // Rule ID 23074 //
     /* 1231327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231366 */     // MIs[0] round
     /* 1231366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231376 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231401 */     // GIR_Coverage, 23074,
     /* 1231401 */     GIR_EraseRootFromParent_Done,
     /* 1231402 */   // Label 17818: @1231402
     /* 1231402 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1231482), // Rule ID 23075 //
     /* 1231407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231446 */     // MIs[0] round
     /* 1231446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231456 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231481 */     // GIR_Coverage, 23075,
     /* 1231481 */     GIR_EraseRootFromParent_Done,
     /* 1231482 */   // Label 17819: @1231482
     /* 1231482 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1231562), // Rule ID 23078 //
     /* 1231487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231526 */     // MIs[0] round
     /* 1231526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231561 */     // GIR_Coverage, 23078,
     /* 1231561 */     GIR_EraseRootFromParent_Done,
     /* 1231562 */   // Label 17820: @1231562
     /* 1231562 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1231642), // Rule ID 23079 //
     /* 1231567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231606 */     // MIs[0] round
     /* 1231606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231641 */     // GIR_Coverage, 23079,
     /* 1231641 */     GIR_EraseRootFromParent_Done,
     /* 1231642 */   // Label 17821: @1231642
     /* 1231642 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1231722), // Rule ID 23082 //
     /* 1231647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231686 */     // MIs[0] round
     /* 1231686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1231699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231721 */     // GIR_Coverage, 23082,
     /* 1231721 */     GIR_EraseRootFromParent_Done,
     /* 1231722 */   // Label 17822: @1231722
     /* 1231722 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1231802), // Rule ID 23083 //
     /* 1231727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231766 */     // MIs[0] round
     /* 1231766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1231779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231801 */     // GIR_Coverage, 23083,
     /* 1231801 */     GIR_EraseRootFromParent_Done,
     /* 1231802 */   // Label 17823: @1231802
     /* 1231802 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1231882), // Rule ID 23086 //
     /* 1231807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1231824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231846 */     // MIs[0] round
     /* 1231846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1231859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231881 */     // GIR_Coverage, 23086,
     /* 1231881 */     GIR_EraseRootFromParent_Done,
     /* 1231882 */   // Label 17824: @1231882
     /* 1231882 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1231962), // Rule ID 23087 //
     /* 1231887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1231904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231926 */     // MIs[0] round
     /* 1231926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231936 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1231939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231961 */     // GIR_Coverage, 23087,
     /* 1231961 */     GIR_EraseRootFromParent_Done,
     /* 1231962 */   // Label 17825: @1231962
     /* 1231962 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1232042), // Rule ID 23090 //
     /* 1231967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1231984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232006 */     // MIs[0] round
     /* 1232006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232041 */     // GIR_Coverage, 23090,
     /* 1232041 */     GIR_EraseRootFromParent_Done,
     /* 1232042 */   // Label 17826: @1232042
     /* 1232042 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1232122), // Rule ID 23091 //
     /* 1232047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232086 */     // MIs[0] round
     /* 1232086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232121 */     // GIR_Coverage, 23091,
     /* 1232121 */     GIR_EraseRootFromParent_Done,
     /* 1232122 */   // Label 17827: @1232122
     /* 1232122 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1232202), // Rule ID 23094 //
     /* 1232127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232166 */     // MIs[0] round
     /* 1232166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232201 */     // GIR_Coverage, 23094,
     /* 1232201 */     GIR_EraseRootFromParent_Done,
     /* 1232202 */   // Label 17828: @1232202
     /* 1232202 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1232282), // Rule ID 23095 //
     /* 1232207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232246 */     // MIs[0] round
     /* 1232246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232281 */     // GIR_Coverage, 23095,
     /* 1232281 */     GIR_EraseRootFromParent_Done,
     /* 1232282 */   // Label 17829: @1232282
     /* 1232282 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1232362), // Rule ID 23098 //
     /* 1232287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232326 */     // MIs[0] round
     /* 1232326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232361 */     // GIR_Coverage, 23098,
     /* 1232361 */     GIR_EraseRootFromParent_Done,
     /* 1232362 */   // Label 17830: @1232362
     /* 1232362 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1232442), // Rule ID 23099 //
     /* 1232367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232406 */     // MIs[0] round
     /* 1232406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232441 */     // GIR_Coverage, 23099,
     /* 1232441 */     GIR_EraseRootFromParent_Done,
     /* 1232442 */   // Label 17831: @1232442
     /* 1232442 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1232522), // Rule ID 23102 //
     /* 1232447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232486 */     // MIs[0] round
     /* 1232486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232521 */     // GIR_Coverage, 23102,
     /* 1232521 */     GIR_EraseRootFromParent_Done,
     /* 1232522 */   // Label 17832: @1232522
     /* 1232522 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1232602), // Rule ID 23103 //
     /* 1232527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232566 */     // MIs[0] round
     /* 1232566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232601 */     // GIR_Coverage, 23103,
     /* 1232601 */     GIR_EraseRootFromParent_Done,
     /* 1232602 */   // Label 17833: @1232602
     /* 1232602 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1232682), // Rule ID 23106 //
     /* 1232607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232646 */     // MIs[0] round
     /* 1232646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232656 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1232659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232681 */     // GIR_Coverage, 23106,
     /* 1232681 */     GIR_EraseRootFromParent_Done,
     /* 1232682 */   // Label 17834: @1232682
     /* 1232682 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1232762), // Rule ID 23107 //
     /* 1232687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232726 */     // MIs[0] round
     /* 1232726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232736 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1232739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232761 */     // GIR_Coverage, 23107,
     /* 1232761 */     GIR_EraseRootFromParent_Done,
     /* 1232762 */   // Label 17835: @1232762
     /* 1232762 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1232842), // Rule ID 23110 //
     /* 1232767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232806 */     // MIs[0] round
     /* 1232806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1232819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232841 */     // GIR_Coverage, 23110,
     /* 1232841 */     GIR_EraseRootFromParent_Done,
     /* 1232842 */   // Label 17836: @1232842
     /* 1232842 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1232922), // Rule ID 23111 //
     /* 1232847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232886 */     // MIs[0] round
     /* 1232886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1232899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232921 */     // GIR_Coverage, 23111,
     /* 1232921 */     GIR_EraseRootFromParent_Done,
     /* 1232922 */   // Label 17837: @1232922
     /* 1232922 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1233002), // Rule ID 23114 //
     /* 1232927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1232944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232966 */     // MIs[0] round
     /* 1232966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1232979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233001 */     // GIR_Coverage, 23114,
     /* 1233001 */     GIR_EraseRootFromParent_Done,
     /* 1233002 */   // Label 17838: @1233002
     /* 1233002 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1233082), // Rule ID 23115 //
     /* 1233007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233046 */     // MIs[0] round
     /* 1233046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233056 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233081 */     // GIR_Coverage, 23115,
     /* 1233081 */     GIR_EraseRootFromParent_Done,
     /* 1233082 */   // Label 17839: @1233082
     /* 1233082 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1233162), // Rule ID 23118 //
     /* 1233087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233126 */     // MIs[0] round
     /* 1233126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233161 */     // GIR_Coverage, 23118,
     /* 1233161 */     GIR_EraseRootFromParent_Done,
     /* 1233162 */   // Label 17840: @1233162
     /* 1233162 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1233242), // Rule ID 23119 //
     /* 1233167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233206 */     // MIs[0] round
     /* 1233206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233216 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233241 */     // GIR_Coverage, 23119,
     /* 1233241 */     GIR_EraseRootFromParent_Done,
     /* 1233242 */   // Label 17841: @1233242
     /* 1233242 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1233322), // Rule ID 23122 //
     /* 1233247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233286 */     // MIs[0] round
     /* 1233286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233296 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233321 */     // GIR_Coverage, 23122,
     /* 1233321 */     GIR_EraseRootFromParent_Done,
     /* 1233322 */   // Label 17842: @1233322
     /* 1233322 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1233402), // Rule ID 23123 //
     /* 1233327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233366 */     // MIs[0] round
     /* 1233366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233376 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233401 */     // GIR_Coverage, 23123,
     /* 1233401 */     GIR_EraseRootFromParent_Done,
     /* 1233402 */   // Label 17843: @1233402
     /* 1233402 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1233482), // Rule ID 23126 //
     /* 1233407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233446 */     // MIs[0] round
     /* 1233446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233481 */     // GIR_Coverage, 23126,
     /* 1233481 */     GIR_EraseRootFromParent_Done,
     /* 1233482 */   // Label 17844: @1233482
     /* 1233482 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1233562), // Rule ID 23127 //
     /* 1233487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233526 */     // MIs[0] round
     /* 1233526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233561 */     // GIR_Coverage, 23127,
     /* 1233561 */     GIR_EraseRootFromParent_Done,
     /* 1233562 */   // Label 17845: @1233562
     /* 1233562 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1233642), // Rule ID 23130 //
     /* 1233567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233606 */     // MIs[0] round
     /* 1233606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1233619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233641 */     // GIR_Coverage, 23130,
     /* 1233641 */     GIR_EraseRootFromParent_Done,
     /* 1233642 */   // Label 17846: @1233642
     /* 1233642 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1233722), // Rule ID 23131 //
     /* 1233647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233686 */     // MIs[0] round
     /* 1233686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1233699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233721 */     // GIR_Coverage, 23131,
     /* 1233721 */     GIR_EraseRootFromParent_Done,
     /* 1233722 */   // Label 17847: @1233722
     /* 1233722 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1233802), // Rule ID 23134 //
     /* 1233727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1233744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233766 */     // MIs[0] round
     /* 1233766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1233779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233801 */     // GIR_Coverage, 23134,
     /* 1233801 */     GIR_EraseRootFromParent_Done,
     /* 1233802 */   // Label 17848: @1233802
     /* 1233802 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1233882), // Rule ID 23135 //
     /* 1233807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1233824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233846 */     // MIs[0] round
     /* 1233846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1233859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233881 */     // GIR_Coverage, 23135,
     /* 1233881 */     GIR_EraseRootFromParent_Done,
     /* 1233882 */   // Label 17849: @1233882
     /* 1233882 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1233962), // Rule ID 23138 //
     /* 1233887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1233904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233926 */     // MIs[0] round
     /* 1233926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233936 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1233939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233961 */     // GIR_Coverage, 23138,
     /* 1233961 */     GIR_EraseRootFromParent_Done,
     /* 1233962 */   // Label 17850: @1233962
     /* 1233962 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1234042), // Rule ID 23139 //
     /* 1233967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1233984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234006 */     // MIs[0] round
     /* 1234006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234041 */     // GIR_Coverage, 23139,
     /* 1234041 */     GIR_EraseRootFromParent_Done,
     /* 1234042 */   // Label 17851: @1234042
     /* 1234042 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1234122), // Rule ID 23142 //
     /* 1234047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234086 */     // MIs[0] round
     /* 1234086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234121 */     // GIR_Coverage, 23142,
     /* 1234121 */     GIR_EraseRootFromParent_Done,
     /* 1234122 */   // Label 17852: @1234122
     /* 1234122 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1234202), // Rule ID 23143 //
     /* 1234127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234166 */     // MIs[0] round
     /* 1234166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234201 */     // GIR_Coverage, 23143,
     /* 1234201 */     GIR_EraseRootFromParent_Done,
     /* 1234202 */   // Label 17853: @1234202
     /* 1234202 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1234282), // Rule ID 64347 //
     /* 1234207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234246 */     // MIs[0] round
     /* 1234246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234256 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1234259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234281 */     // GIR_Coverage, 64347,
     /* 1234281 */     GIR_EraseRootFromParent_Done,
     /* 1234282 */   // Label 17854: @1234282
     /* 1234282 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1234362), // Rule ID 64348 //
     /* 1234287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234326 */     // MIs[0] round
     /* 1234326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234336 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1234339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234361 */     // GIR_Coverage, 64348,
     /* 1234361 */     GIR_EraseRootFromParent_Done,
     /* 1234362 */   // Label 17855: @1234362
     /* 1234362 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1234442), // Rule ID 64351 //
     /* 1234367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234406 */     // MIs[0] round
     /* 1234406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1234419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234441 */     // GIR_Coverage, 64351,
     /* 1234441 */     GIR_EraseRootFromParent_Done,
     /* 1234442 */   // Label 17856: @1234442
     /* 1234442 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1234522), // Rule ID 64352 //
     /* 1234447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234486 */     // MIs[0] round
     /* 1234486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1234499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234521 */     // GIR_Coverage, 64352,
     /* 1234521 */     GIR_EraseRootFromParent_Done,
     /* 1234522 */   // Label 17857: @1234522
     /* 1234522 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1234602), // Rule ID 64355 //
     /* 1234527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234566 */     // MIs[0] round
     /* 1234566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234576 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1234579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234601 */     // GIR_Coverage, 64355,
     /* 1234601 */     GIR_EraseRootFromParent_Done,
     /* 1234602 */   // Label 17858: @1234602
     /* 1234602 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1234682), // Rule ID 64356 //
     /* 1234607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234646 */     // MIs[0] round
     /* 1234646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234656 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1234659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234681 */     // GIR_Coverage, 64356,
     /* 1234681 */     GIR_EraseRootFromParent_Done,
     /* 1234682 */   // Label 17859: @1234682
     /* 1234682 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1234762), // Rule ID 64359 //
     /* 1234687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1234698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1234701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234726 */     // MIs[0] round
     /* 1234726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1234739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234761 */     // GIR_Coverage, 64359,
     /* 1234761 */     GIR_EraseRootFromParent_Done,
     /* 1234762 */   // Label 17860: @1234762
     /* 1234762 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1234842), // Rule ID 64360 //
     /* 1234767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1234778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1234781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234806 */     // MIs[0] round
     /* 1234806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11037:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1234819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234841 */     // GIR_Coverage, 64360,
     /* 1234841 */     GIR_EraseRootFromParent_Done,
     /* 1234842 */   // Label 17861: @1234842
     /* 1234842 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1234922), // Rule ID 64363 //
     /* 1234847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1234858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1234861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234886 */     // MIs[0] round
     /* 1234886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1234899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234921 */     // GIR_Coverage, 64363,
     /* 1234921 */     GIR_EraseRootFromParent_Done,
     /* 1234922 */   // Label 17862: @1234922
     /* 1234922 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1235002), // Rule ID 64364 //
     /* 1234927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1234938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1234941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234966 */     // MIs[0] round
     /* 1234966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1234979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235001 */     // GIR_Coverage, 64364,
     /* 1235001 */     GIR_EraseRootFromParent_Done,
     /* 1235002 */   // Label 17863: @1235002
     /* 1235002 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1235082), // Rule ID 64367 //
     /* 1235007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235046 */     // MIs[0] round
     /* 1235046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1235059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235081 */     // GIR_Coverage, 64367,
     /* 1235081 */     GIR_EraseRootFromParent_Done,
     /* 1235082 */   // Label 17864: @1235082
     /* 1235082 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1235162), // Rule ID 64368 //
     /* 1235087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235126 */     // MIs[0] round
     /* 1235126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1235139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235161 */     // GIR_Coverage, 64368,
     /* 1235161 */     GIR_EraseRootFromParent_Done,
     /* 1235162 */   // Label 17865: @1235162
     /* 1235162 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1235242), // Rule ID 64371 //
     /* 1235167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235206 */     // MIs[0] round
     /* 1235206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1235219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235241 */     // GIR_Coverage, 64371,
     /* 1235241 */     GIR_EraseRootFromParent_Done,
     /* 1235242 */   // Label 17866: @1235242
     /* 1235242 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1235322), // Rule ID 64372 //
     /* 1235247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235286 */     // MIs[0] round
     /* 1235286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1235299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235321 */     // GIR_Coverage, 64372,
     /* 1235321 */     GIR_EraseRootFromParent_Done,
     /* 1235322 */   // Label 17867: @1235322
     /* 1235322 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1235402), // Rule ID 64375 //
     /* 1235327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235366 */     // MIs[0] round
     /* 1235366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235376 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1235379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235401 */     // GIR_Coverage, 64375,
     /* 1235401 */     GIR_EraseRootFromParent_Done,
     /* 1235402 */   // Label 17868: @1235402
     /* 1235402 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1235482), // Rule ID 64376 //
     /* 1235407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235446 */     // MIs[0] round
     /* 1235446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1235459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235481 */     // GIR_Coverage, 64376,
     /* 1235481 */     GIR_EraseRootFromParent_Done,
     /* 1235482 */   // Label 17869: @1235482
     /* 1235482 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1235562), // Rule ID 64379 //
     /* 1235487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235526 */     // MIs[0] round
     /* 1235526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1235539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235561 */     // GIR_Coverage, 64379,
     /* 1235561 */     GIR_EraseRootFromParent_Done,
     /* 1235562 */   // Label 17870: @1235562
     /* 1235562 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1235642), // Rule ID 64380 //
     /* 1235567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235606 */     // MIs[0] round
     /* 1235606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11035:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1235619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235641 */     // GIR_Coverage, 64380,
     /* 1235641 */     GIR_EraseRootFromParent_Done,
     /* 1235642 */   // Label 17871: @1235642
     /* 1235642 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1235722), // Rule ID 64383 //
     /* 1235647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235686 */     // MIs[0] round
     /* 1235686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1235699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235721 */     // GIR_Coverage, 64383,
     /* 1235721 */     GIR_EraseRootFromParent_Done,
     /* 1235722 */   // Label 17872: @1235722
     /* 1235722 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1235802), // Rule ID 64384 //
     /* 1235727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235766 */     // MIs[0] round
     /* 1235766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1235779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235801 */     // GIR_Coverage, 64384,
     /* 1235801 */     GIR_EraseRootFromParent_Done,
     /* 1235802 */   // Label 17873: @1235802
     /* 1235802 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1235886), // Rule ID 2710 //
     /* 1235807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1235810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1235815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1235818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1235821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1235824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1235827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1235860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1235863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235885 */     // GIR_Coverage, 2710,
     /* 1235885 */     GIR_EraseRootFromParent_Done,
     /* 1235886 */   // Label 17874: @1235886
     /* 1235886 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1235970), // Rule ID 2711 //
     /* 1235891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1235894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1235899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1235902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1235905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1235908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1235911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1235944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1235947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1235968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235969 */     // GIR_Coverage, 2711,
     /* 1235969 */     GIR_EraseRootFromParent_Done,
     /* 1235970 */   // Label 17875: @1235970
     /* 1235970 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1236054), // Rule ID 2722 //
     /* 1235975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1235978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1235983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1235986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1235989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1235992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1235995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1236028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1236031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1236037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1236039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236053 */     // GIR_Coverage, 2722,
     /* 1236053 */     GIR_EraseRootFromParent_Done,
     /* 1236054 */   // Label 17876: @1236054
     /* 1236054 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1236138), // Rule ID 2723 //
     /* 1236059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1236067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1236070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1236073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1236076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1236079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1236112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1236115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1236121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1236123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1236136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236137 */     // GIR_Coverage, 2723,
     /* 1236137 */     GIR_EraseRootFromParent_Done,
     /* 1236138 */   // Label 17877: @1236138
     /* 1236138 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1236219), // Rule ID 2724 //
     /* 1236143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1236154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1236157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1236160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1236163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1236196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1236199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236218 */     // GIR_Coverage, 2724,
     /* 1236218 */     GIR_EraseRootFromParent_Done,
     /* 1236219 */   // Label 17878: @1236219
     /* 1236219 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1236300), // Rule ID 2725 //
     /* 1236224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1236235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1236238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1236241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1236244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236277 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1236277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1236280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236299 */     // GIR_Coverage, 2725,
     /* 1236299 */     GIR_EraseRootFromParent_Done,
     /* 1236300 */   // Label 17879: @1236300
     /* 1236300 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1236384), // Rule ID 2774 //
     /* 1236305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1236313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1236322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1236325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1236361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236383 */     // GIR_Coverage, 2774,
     /* 1236383 */     GIR_EraseRootFromParent_Done,
     /* 1236384 */   // Label 17880: @1236384
     /* 1236384 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1236468), // Rule ID 2775 //
     /* 1236389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1236397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1236406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1236409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1236445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1236449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236467 */     // GIR_Coverage, 2775,
     /* 1236467 */     GIR_EraseRootFromParent_Done,
     /* 1236468 */   // Label 17881: @1236468
     /* 1236468 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1236549), // Rule ID 5110 //
     /* 1236473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1236484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1236487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1236490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1236493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1236526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1236529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236548 */     // GIR_Coverage, 5110,
     /* 1236548 */     GIR_EraseRootFromParent_Done,
     /* 1236549 */   // Label 17882: @1236549
     /* 1236549 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1236630), // Rule ID 5111 //
     /* 1236554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1236565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1236568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1236571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1236574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236607 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1236607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1236610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236629 */     // GIR_Coverage, 5111,
     /* 1236629 */     GIR_EraseRootFromParent_Done,
     /* 1236630 */   // Label 17883: @1236630
     /* 1236630 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1236711), // Rule ID 5112 //
     /* 1236635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1236652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1236655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1236688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1236691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236710 */     // GIR_Coverage, 5112,
     /* 1236710 */     GIR_EraseRootFromParent_Done,
     /* 1236711 */   // Label 17884: @1236711
     /* 1236711 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1236792), // Rule ID 5113 //
     /* 1236716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1236727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1236730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1236733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1236736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236769 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1236769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1236772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236791 */     // GIR_Coverage, 5113,
     /* 1236791 */     GIR_EraseRootFromParent_Done,
     /* 1236792 */   // Label 17885: @1236792
     /* 1236792 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1236873), // Rule ID 5114 //
     /* 1236797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1236817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236850 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1236850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1236853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236872 */     // GIR_Coverage, 5114,
     /* 1236872 */     GIR_EraseRootFromParent_Done,
     /* 1236873 */   // Label 17886: @1236873
     /* 1236873 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1236954), // Rule ID 5115 //
     /* 1236878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1236898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236931 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1236931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1236934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236953 */     // GIR_Coverage, 5115,
     /* 1236953 */     GIR_EraseRootFromParent_Done,
     /* 1236954 */   // Label 17887: @1236954
     /* 1236954 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1237035), // Rule ID 5116 //
     /* 1236959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1236979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1237012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1237015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237034 */     // GIR_Coverage, 5116,
     /* 1237034 */     GIR_EraseRootFromParent_Done,
     /* 1237035 */   // Label 17888: @1237035
     /* 1237035 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1237116), // Rule ID 5117 //
     /* 1237040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1237060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1237063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1237093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1237096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237115 */     // GIR_Coverage, 5117,
     /* 1237115 */     GIR_EraseRootFromParent_Done,
     /* 1237116 */   // Label 17889: @1237116
     /* 1237116 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1237197), // Rule ID 5118 //
     /* 1237121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1237132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1237135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1237138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1237141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1237174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1237177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237196 */     // GIR_Coverage, 5118,
     /* 1237196 */     GIR_EraseRootFromParent_Done,
     /* 1237197 */   // Label 17890: @1237197
     /* 1237197 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1237278), // Rule ID 5119 //
     /* 1237202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1237213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1237216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1237219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1237222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237255 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1237255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1237258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237277 */     // GIR_Coverage, 5119,
     /* 1237277 */     GIR_EraseRootFromParent_Done,
     /* 1237278 */   // Label 17891: @1237278
     /* 1237278 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1237359), // Rule ID 5120 //
     /* 1237283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1237294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1237297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1237300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1237303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1237336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237358 */     // GIR_Coverage, 5120,
     /* 1237358 */     GIR_EraseRootFromParent_Done,
     /* 1237359 */   // Label 17892: @1237359
     /* 1237359 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1237440), // Rule ID 5121 //
     /* 1237364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1237375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1237378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1237381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1237384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237417 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1237417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237439 */     // GIR_Coverage, 5121,
     /* 1237439 */     GIR_EraseRootFromParent_Done,
     /* 1237440 */   // Label 17893: @1237440
     /* 1237440 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1237521), // Rule ID 5122 //
     /* 1237445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1237465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1237468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1237498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237520 */     // GIR_Coverage, 5122,
     /* 1237520 */     GIR_EraseRootFromParent_Done,
     /* 1237521 */   // Label 17894: @1237521
     /* 1237521 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1237602), // Rule ID 5123 //
     /* 1237526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1237546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1237549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237579 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1237579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237601 */     // GIR_Coverage, 5123,
     /* 1237601 */     GIR_EraseRootFromParent_Done,
     /* 1237602 */   // Label 17895: @1237602
     /* 1237602 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1237683), // Rule ID 5124 //
     /* 1237607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1237624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1237630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1237660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237682 */     // GIR_Coverage, 5124,
     /* 1237682 */     GIR_EraseRootFromParent_Done,
     /* 1237683 */   // Label 17896: @1237683
     /* 1237683 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1237764), // Rule ID 5125 //
     /* 1237688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1237699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1237702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1237705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1237708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1237711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237741 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1237741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1237762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237763 */     // GIR_Coverage, 5125,
     /* 1237763 */     GIR_EraseRootFromParent_Done,
     /* 1237764 */   // Label 17897: @1237764
     /* 1237764 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1237845), // Rule ID 5126 //
     /* 1237769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1237772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1237786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1237822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237844 */     // GIR_Coverage, 5126,
     /* 1237844 */     GIR_EraseRootFromParent_Done,
     /* 1237845 */   // Label 17898: @1237845
     /* 1237845 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1237926), // Rule ID 5127 //
     /* 1237850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1237853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1237867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1237870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237903 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1237903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1237906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237925 */     // GIR_Coverage, 5127,
     /* 1237925 */     GIR_EraseRootFromParent_Done,
     /* 1237926 */   // Label 17899: @1237926
     /* 1237926 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1238007), // Rule ID 5128 //
     /* 1237931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1237942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1237945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1237948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1237951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1237961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237984 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1237984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1237987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238006 */     // GIR_Coverage, 5128,
     /* 1238006 */     GIR_EraseRootFromParent_Done,
     /* 1238007 */   // Label 17900: @1238007
     /* 1238007 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1238088), // Rule ID 5129 //
     /* 1238012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1238023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1238026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1238029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1238032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1238035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238065 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1238068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238087 */     // GIR_Coverage, 5129,
     /* 1238087 */     GIR_EraseRootFromParent_Done,
     /* 1238088 */   // Label 17901: @1238088
     /* 1238088 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1238169), // Rule ID 5130 //
     /* 1238093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1238104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1238107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1238110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1238113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1238116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1238149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238168 */     // GIR_Coverage, 5130,
     /* 1238168 */     GIR_EraseRootFromParent_Done,
     /* 1238169 */   // Label 17902: @1238169
     /* 1238169 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1238250), // Rule ID 5131 //
     /* 1238174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1238185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1238188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1238191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1238194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1238197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238227 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1238230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238249 */     // GIR_Coverage, 5131,
     /* 1238249 */     GIR_EraseRootFromParent_Done,
     /* 1238250 */   // Label 17903: @1238250
     /* 1238250 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1238331), // Rule ID 5132 //
     /* 1238255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1238266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1238269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1238272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1238275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1238278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1238311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238330 */     // GIR_Coverage, 5132,
     /* 1238330 */     GIR_EraseRootFromParent_Done,
     /* 1238331 */   // Label 17904: @1238331
     /* 1238331 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1238412), // Rule ID 5133 //
     /* 1238336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1238347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1238350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1238353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1238356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1238359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238389 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1238392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238411 */     // GIR_Coverage, 5133,
     /* 1238411 */     GIR_EraseRootFromParent_Done,
     /* 1238412 */   // Label 17905: @1238412
     /* 1238412 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1238493), // Rule ID 5134 //
     /* 1238417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1238437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1238470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1238473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238492 */     // GIR_Coverage, 5134,
     /* 1238492 */     GIR_EraseRootFromParent_Done,
     /* 1238493 */   // Label 17906: @1238493
     /* 1238493 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1238574), // Rule ID 5135 //
     /* 1238498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1238509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1238512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1238515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1238518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1238551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1238554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238573 */     // GIR_Coverage, 5135,
     /* 1238573 */     GIR_EraseRootFromParent_Done,
     /* 1238574 */   // Label 17907: @1238574
     /* 1238574 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1238655), // Rule ID 5136 //
     /* 1238579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1238599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1238602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1238632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1238635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238654 */     // GIR_Coverage, 5136,
     /* 1238654 */     GIR_EraseRootFromParent_Done,
     /* 1238655 */   // Label 17908: @1238655
     /* 1238655 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1238736), // Rule ID 5137 //
     /* 1238660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1238671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1238674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1238677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1238680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1238683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238713 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1238713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1238716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238735 */     // GIR_Coverage, 5137,
     /* 1238735 */     GIR_EraseRootFromParent_Done,
     /* 1238736 */   // Label 17909: @1238736
     /* 1238736 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1238817), // Rule ID 5138 //
     /* 1238741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1238761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1238764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1238794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1238797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238816 */     // GIR_Coverage, 5138,
     /* 1238816 */     GIR_EraseRootFromParent_Done,
     /* 1238817 */   // Label 17910: @1238817
     /* 1238817 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1238898), // Rule ID 5139 //
     /* 1238822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1238842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1238845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238875 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1238875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1238878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238897 */     // GIR_Coverage, 5139,
     /* 1238897 */     GIR_EraseRootFromParent_Done,
     /* 1238898 */   // Label 17911: @1238898
     /* 1238898 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1238979), // Rule ID 5140 //
     /* 1238903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1238914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1238917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1238920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1238923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1238956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1238959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238978 */     // GIR_Coverage, 5140,
     /* 1238978 */     GIR_EraseRootFromParent_Done,
     /* 1238979 */   // Label 17912: @1238979
     /* 1238979 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1239060), // Rule ID 5141 //
     /* 1238984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1238995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1238998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1239001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1239004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1239014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1239040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239059 */     // GIR_Coverage, 5141,
     /* 1239059 */     GIR_EraseRootFromParent_Done,
     /* 1239060 */   // Label 17913: @1239060
     /* 1239060 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1239141), // Rule ID 5142 //
     /* 1239065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1239076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1239079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1239082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1239085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1239095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1239121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239140 */     // GIR_Coverage, 5142,
     /* 1239140 */     GIR_EraseRootFromParent_Done,
     /* 1239141 */   // Label 17914: @1239141
     /* 1239141 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1239222), // Rule ID 5143 //
     /* 1239146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1239157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1239160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1239163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1239166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1239176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1239202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239221 */     // GIR_Coverage, 5143,
     /* 1239221 */     GIR_EraseRootFromParent_Done,
     /* 1239222 */   // Label 17915: @1239222
     /* 1239222 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1239303), // Rule ID 5144 //
     /* 1239227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1239238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1239241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1239247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1239250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1239257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1239283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239302 */     // GIR_Coverage, 5144,
     /* 1239302 */     GIR_EraseRootFromParent_Done,
     /* 1239303 */   // Label 17916: @1239303
     /* 1239303 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1239384), // Rule ID 5145 //
     /* 1239308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1239319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1239322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1239325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1239328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1239331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1239338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1239364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239383 */     // GIR_Coverage, 5145,
     /* 1239383 */     GIR_EraseRootFromParent_Done,
     /* 1239384 */   // Label 17917: @1239384
     /* 1239384 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1239465), // Rule ID 5146 //
     /* 1239389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1239392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1239400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1239403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1239406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1239409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1239419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1239442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1239445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239464 */     // GIR_Coverage, 5146,
     /* 1239464 */     GIR_EraseRootFromParent_Done,
     /* 1239465 */   // Label 17918: @1239465
     /* 1239465 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1239546), // Rule ID 5147 //
     /* 1239470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1239473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1239481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1239484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1239487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1239490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1239500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1239512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1239523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1239526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239545 */     // GIR_Coverage, 5147,
     /* 1239545 */     GIR_EraseRootFromParent_Done,
     /* 1239546 */   // Label 17919: @1239546
     /* 1239546 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1239627), // Rule ID 5148 //
     /* 1239551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1239554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1239562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1239565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1239568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1239571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1239581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1239604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1239607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239626 */     // GIR_Coverage, 5148,
     /* 1239626 */     GIR_EraseRootFromParent_Done,
     /* 1239627 */   // Label 17920: @1239627
     /* 1239627 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1239708), // Rule ID 5149 //
     /* 1239632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1239635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1239643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1239646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1239649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1239652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1239662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1239674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239685 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1239685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1239688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239707 */     // GIR_Coverage, 5149,
     /* 1239707 */     GIR_EraseRootFromParent_Done,
     /* 1239708 */   // Label 17921: @1239708
     /* 1239708 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1239789), // Rule ID 5150 //
     /* 1239713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1239716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1239724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1239727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1239730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1239733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1239743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1239766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1239769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239788 */     // GIR_Coverage, 5150,
     /* 1239788 */     GIR_EraseRootFromParent_Done,
     /* 1239789 */   // Label 17922: @1239789
     /* 1239789 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1239870), // Rule ID 5151 //
     /* 1239794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1239797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1239805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1239808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1239811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1239814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1239824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239847 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1239847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1239850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239869 */     // GIR_Coverage, 5151,
     /* 1239869 */     GIR_EraseRootFromParent_Done,
     /* 1239870 */   // Label 17923: @1239870
     /* 1239870 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1239951), // Rule ID 5152 //
     /* 1239875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1239895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1239917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1239931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239950 */     // GIR_Coverage, 5152,
     /* 1239950 */     GIR_EraseRootFromParent_Done,
     /* 1239951 */   // Label 17924: @1239951
     /* 1239951 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1240032), // Rule ID 5153 //
     /* 1239956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1239998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240009 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1240012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240031 */     // GIR_Coverage, 5153,
     /* 1240031 */     GIR_EraseRootFromParent_Done,
     /* 1240032 */   // Label 17925: @1240032
     /* 1240032 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1240113), // Rule ID 5154 //
     /* 1240037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1240048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1240051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1240054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240090 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1240093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240112 */     // GIR_Coverage, 5154,
     /* 1240112 */     GIR_EraseRootFromParent_Done,
     /* 1240113 */   // Label 17926: @1240113
     /* 1240113 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1240194), // Rule ID 5155 //
     /* 1240118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1240129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1240132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1240135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240171 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1240174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240193 */     // GIR_Coverage, 5155,
     /* 1240193 */     GIR_EraseRootFromParent_Done,
     /* 1240194 */   // Label 17927: @1240194
     /* 1240194 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1240275), // Rule ID 5156 //
     /* 1240199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1240210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1240213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1240216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240274 */     // GIR_Coverage, 5156,
     /* 1240274 */     GIR_EraseRootFromParent_Done,
     /* 1240275 */   // Label 17928: @1240275
     /* 1240275 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1240356), // Rule ID 5157 //
     /* 1240280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1240291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1240294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1240297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240333 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240355 */     // GIR_Coverage, 5157,
     /* 1240355 */     GIR_EraseRootFromParent_Done,
     /* 1240356 */   // Label 17929: @1240356
     /* 1240356 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1240437), // Rule ID 5158 //
     /* 1240361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1240372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1240375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1240417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240436 */     // GIR_Coverage, 5158,
     /* 1240436 */     GIR_EraseRootFromParent_Done,
     /* 1240437 */   // Label 17930: @1240437
     /* 1240437 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1240518), // Rule ID 5159 //
     /* 1240442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1240453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1240456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1240459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240495 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1240498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240517 */     // GIR_Coverage, 5159,
     /* 1240517 */     GIR_EraseRootFromParent_Done,
     /* 1240518 */   // Label 17931: @1240518
     /* 1240518 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1240599), // Rule ID 5160 //
     /* 1240523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1240534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1240537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1240540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240598 */     // GIR_Coverage, 5160,
     /* 1240598 */     GIR_EraseRootFromParent_Done,
     /* 1240599 */   // Label 17932: @1240599
     /* 1240599 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1240680), // Rule ID 5161 //
     /* 1240604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1240615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1240618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1240621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240657 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240679 */     // GIR_Coverage, 5161,
     /* 1240679 */     GIR_EraseRootFromParent_Done,
     /* 1240680 */   // Label 17933: @1240680
     /* 1240680 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1240761), // Rule ID 5162 //
     /* 1240685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1240696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1240699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1240702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1240738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240760 */     // GIR_Coverage, 5162,
     /* 1240760 */     GIR_EraseRootFromParent_Done,
     /* 1240761 */   // Label 17934: @1240761
     /* 1240761 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1240842), // Rule ID 5163 //
     /* 1240766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1240777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1240780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1240783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1240819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1240822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240841 */     // GIR_Coverage, 5163,
     /* 1240841 */     GIR_EraseRootFromParent_Done,
     /* 1240842 */   // Label 17935: @1240842
     /* 1240842 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1240923), // Rule ID 5164 //
     /* 1240847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1240867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1240903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240922 */     // GIR_Coverage, 5164,
     /* 1240922 */     GIR_EraseRootFromParent_Done,
     /* 1240923 */   // Label 17936: @1240923
     /* 1240923 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1241004), // Rule ID 5165 //
     /* 1240928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1240948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1240970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240981 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1240984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241003 */     // GIR_Coverage, 5165,
     /* 1241003 */     GIR_EraseRootFromParent_Done,
     /* 1241004 */   // Label 17937: @1241004
     /* 1241004 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1241085), // Rule ID 5166 //
     /* 1241009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1241020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1241023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241084 */     // GIR_Coverage, 5166,
     /* 1241084 */     GIR_EraseRootFromParent_Done,
     /* 1241085 */   // Label 17938: @1241085
     /* 1241085 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1241166), // Rule ID 5167 //
     /* 1241090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1241101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1241104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1241107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241143 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241165 */     // GIR_Coverage, 5167,
     /* 1241165 */     GIR_EraseRootFromParent_Done,
     /* 1241166 */   // Label 17939: @1241166
     /* 1241166 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1241247), // Rule ID 5168 //
     /* 1241171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1241182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1241185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1241188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241246 */     // GIR_Coverage, 5168,
     /* 1241246 */     GIR_EraseRootFromParent_Done,
     /* 1241247 */   // Label 17940: @1241247
     /* 1241247 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1241328), // Rule ID 5169 //
     /* 1241252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1241263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1241266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1241269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241305 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241327 */     // GIR_Coverage, 5169,
     /* 1241327 */     GIR_EraseRootFromParent_Done,
     /* 1241328 */   // Label 17941: @1241328
     /* 1241328 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1241409), // Rule ID 5170 //
     /* 1241333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1241344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1241347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1241350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1241386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241408 */     // GIR_Coverage, 5170,
     /* 1241408 */     GIR_EraseRootFromParent_Done,
     /* 1241409 */   // Label 17942: @1241409
     /* 1241409 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1241490), // Rule ID 5171 //
     /* 1241414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1241417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1241425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1241428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1241431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1241437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1241444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1241452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241467 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1241467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1241470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241489 */     // GIR_Coverage, 5171,
     /* 1241489 */     GIR_EraseRootFromParent_Done,
     /* 1241490 */   // Label 17943: @1241490
     /* 1241490 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1241571), // Rule ID 5172 //
     /* 1241495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1241506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1241509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1241512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1241551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241570 */     // GIR_Coverage, 5172,
     /* 1241570 */     GIR_EraseRootFromParent_Done,
     /* 1241571 */   // Label 17944: @1241571
     /* 1241571 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1241652), // Rule ID 5173 //
     /* 1241576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1241587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1241590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1241593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241629 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1241632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241651 */     // GIR_Coverage, 5173,
     /* 1241651 */     GIR_EraseRootFromParent_Done,
     /* 1241652 */   // Label 17945: @1241652
     /* 1241652 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1241733), // Rule ID 5174 //
     /* 1241657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1241668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1241671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1241674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1241713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241732 */     // GIR_Coverage, 5174,
     /* 1241732 */     GIR_EraseRootFromParent_Done,
     /* 1241733 */   // Label 17946: @1241733
     /* 1241733 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1241814), // Rule ID 5175 //
     /* 1241738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1241749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1241752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1241755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241791 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1241794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241813 */     // GIR_Coverage, 5175,
     /* 1241813 */     GIR_EraseRootFromParent_Done,
     /* 1241814 */   // Label 17947: @1241814
     /* 1241814 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1241895), // Rule ID 5176 //
     /* 1241819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1241839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241872 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1241875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241894 */     // GIR_Coverage, 5176,
     /* 1241894 */     GIR_EraseRootFromParent_Done,
     /* 1241895 */   // Label 17948: @1241895
     /* 1241895 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1241976), // Rule ID 5177 //
     /* 1241900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1241920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1241942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241953 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1241956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241975 */     // GIR_Coverage, 5177,
     /* 1241975 */     GIR_EraseRootFromParent_Done,
     /* 1241976 */   // Label 17949: @1241976
     /* 1241976 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1242057), // Rule ID 5178 //
     /* 1241981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1242037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242056 */     // GIR_Coverage, 5178,
     /* 1242056 */     GIR_EraseRootFromParent_Done,
     /* 1242057 */   // Label 17950: @1242057
     /* 1242057 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1242138), // Rule ID 5179 //
     /* 1242062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1242073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1242076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1242079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1242118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242137 */     // GIR_Coverage, 5179,
     /* 1242137 */     GIR_EraseRootFromParent_Done,
     /* 1242138 */   // Label 17951: @1242138
     /* 1242138 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1242219), // Rule ID 5180 //
     /* 1242143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1242154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1242157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1242160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1242199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242218 */     // GIR_Coverage, 5180,
     /* 1242218 */     GIR_EraseRootFromParent_Done,
     /* 1242219 */   // Label 17952: @1242219
     /* 1242219 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1242300), // Rule ID 5181 //
     /* 1242224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1242235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1242238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1242241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242277 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1242280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242299 */     // GIR_Coverage, 5181,
     /* 1242299 */     GIR_EraseRootFromParent_Done,
     /* 1242300 */   // Label 17953: @1242300
     /* 1242300 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1242381), // Rule ID 5182 //
     /* 1242305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1242316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1242319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1242322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1242328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242358 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1242361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242380 */     // GIR_Coverage, 5182,
     /* 1242380 */     GIR_EraseRootFromParent_Done,
     /* 1242381 */   // Label 17954: @1242381
     /* 1242381 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1242462), // Rule ID 5183 //
     /* 1242386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1242397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1242400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1242403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1242409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242439 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1242442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242461 */     // GIR_Coverage, 5183,
     /* 1242461 */     GIR_EraseRootFromParent_Done,
     /* 1242462 */   // Label 17955: @1242462
     /* 1242462 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1242543), // Rule ID 5184 //
     /* 1242467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1242478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1242481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1242484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1242523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242542 */     // GIR_Coverage, 5184,
     /* 1242542 */     GIR_EraseRootFromParent_Done,
     /* 1242543 */   // Label 17956: @1242543
     /* 1242543 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1242624), // Rule ID 5185 //
     /* 1242548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1242559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1242562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1242565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1242604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242623 */     // GIR_Coverage, 5185,
     /* 1242623 */     GIR_EraseRootFromParent_Done,
     /* 1242624 */   // Label 17957: @1242624
     /* 1242624 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1242705), // Rule ID 5186 //
     /* 1242629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1242640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1242643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1242646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1242685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242704 */     // GIR_Coverage, 5186,
     /* 1242704 */     GIR_EraseRootFromParent_Done,
     /* 1242705 */   // Label 17958: @1242705
     /* 1242705 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1242786), // Rule ID 5187 //
     /* 1242710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1242721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1242724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1242727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242763 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1242766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242785 */     // GIR_Coverage, 5187,
     /* 1242785 */     GIR_EraseRootFromParent_Done,
     /* 1242786 */   // Label 17959: @1242786
     /* 1242786 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1242867), // Rule ID 5188 //
     /* 1242791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1242847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242866 */     // GIR_Coverage, 5188,
     /* 1242866 */     GIR_EraseRootFromParent_Done,
     /* 1242867 */   // Label 17960: @1242867
     /* 1242867 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1242948), // Rule ID 5189 //
     /* 1242872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242925 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1242928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242947 */     // GIR_Coverage, 5189,
     /* 1242947 */     GIR_EraseRootFromParent_Done,
     /* 1242948 */   // Label 17961: @1242948
     /* 1242948 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1243029), // Rule ID 5190 //
     /* 1242953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243028 */     // GIR_Coverage, 5190,
     /* 1243028 */     GIR_EraseRootFromParent_Done,
     /* 1243029 */   // Label 17962: @1243029
     /* 1243029 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1243110), // Rule ID 5191 //
     /* 1243034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1243045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1243048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1243051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1243064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243109 */     // GIR_Coverage, 5191,
     /* 1243109 */     GIR_EraseRootFromParent_Done,
     /* 1243110 */   // Label 17963: @1243110
     /* 1243110 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1243191), // Rule ID 5192 //
     /* 1243115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1243118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1243126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1243129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1243132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1243145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1243171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243190 */     // GIR_Coverage, 5192,
     /* 1243190 */     GIR_EraseRootFromParent_Done,
     /* 1243191 */   // Label 17964: @1243191
     /* 1243191 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1243272), // Rule ID 5193 //
     /* 1243196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1243207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1243210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1243213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1243226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243249 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1243252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243271 */     // GIR_Coverage, 5193,
     /* 1243271 */     GIR_EraseRootFromParent_Done,
     /* 1243272 */   // Label 17965: @1243272
     /* 1243272 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1243353), // Rule ID 5194 //
     /* 1243277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1243280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1243288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1243291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1243294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1243307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1243333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243352 */     // GIR_Coverage, 5194,
     /* 1243352 */     GIR_EraseRootFromParent_Done,
     /* 1243353 */   // Label 17966: @1243353
     /* 1243353 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1243434), // Rule ID 5195 //
     /* 1243358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1243369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1243372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1243375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1243388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1243396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243411 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1243414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243433 */     // GIR_Coverage, 5195,
     /* 1243433 */     GIR_EraseRootFromParent_Done,
     /* 1243434 */   // Label 17967: @1243434
     /* 1243434 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1243515), // Rule ID 5500 //
     /* 1243439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1243450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1243453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1243456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1243459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1243495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243514 */     // GIR_Coverage, 5500,
     /* 1243514 */     GIR_EraseRootFromParent_Done,
     /* 1243515 */   // Label 17968: @1243515
     /* 1243515 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1243596), // Rule ID 5501 //
     /* 1243520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1243531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1243534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1243537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1243540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243573 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1243576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243595 */     // GIR_Coverage, 5501,
     /* 1243595 */     GIR_EraseRootFromParent_Done,
     /* 1243596 */   // Label 17969: @1243596
     /* 1243596 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1243677), // Rule ID 5502 //
     /* 1243601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1243612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1243615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1243618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1243621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1243657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243676 */     // GIR_Coverage, 5502,
     /* 1243676 */     GIR_EraseRootFromParent_Done,
     /* 1243677 */   // Label 17970: @1243677
     /* 1243677 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1243758), // Rule ID 5503 //
     /* 1243682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1243693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1243696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1243699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1243702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243735 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1243738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243757 */     // GIR_Coverage, 5503,
     /* 1243757 */     GIR_EraseRootFromParent_Done,
     /* 1243758 */   // Label 17971: @1243758
     /* 1243758 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1243839), // Rule ID 5504 //
     /* 1243763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1243774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1243777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1243780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1243783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1243819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243838 */     // GIR_Coverage, 5504,
     /* 1243838 */     GIR_EraseRootFromParent_Done,
     /* 1243839 */   // Label 17972: @1243839
     /* 1243839 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1243920), // Rule ID 5505 //
     /* 1243844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1243855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1243858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1243861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1243864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243897 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1243900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243919 */     // GIR_Coverage, 5505,
     /* 1243919 */     GIR_EraseRootFromParent_Done,
     /* 1243920 */   // Label 17973: @1243920
     /* 1243920 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1244001), // Rule ID 5506 //
     /* 1243925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1243945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1243981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244000 */     // GIR_Coverage, 5506,
     /* 1244000 */     GIR_EraseRootFromParent_Done,
     /* 1244001 */   // Label 17974: @1244001
     /* 1244001 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1244082), // Rule ID 5507 //
     /* 1244006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1244017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1244020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1244023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1244026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1244062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244081 */     // GIR_Coverage, 5507,
     /* 1244081 */     GIR_EraseRootFromParent_Done,
     /* 1244082 */   // Label 17975: @1244082
     /* 1244082 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1244163), // Rule ID 5508 //
     /* 1244087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1244098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1244101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1244104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1244107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1244143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244162 */     // GIR_Coverage, 5508,
     /* 1244162 */     GIR_EraseRootFromParent_Done,
     /* 1244163 */   // Label 17976: @1244163
     /* 1244163 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1244244), // Rule ID 5509 //
     /* 1244168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1244179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1244182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1244185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1244188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244221 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1244224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244243 */     // GIR_Coverage, 5509,
     /* 1244243 */     GIR_EraseRootFromParent_Done,
     /* 1244244 */   // Label 17977: @1244244
     /* 1244244 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1244325), // Rule ID 5510 //
     /* 1244249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1244260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1244263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1244266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1244269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1244305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244324 */     // GIR_Coverage, 5510,
     /* 1244324 */     GIR_EraseRootFromParent_Done,
     /* 1244325 */   // Label 17978: @1244325
     /* 1244325 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1244406), // Rule ID 5511 //
     /* 1244330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1244341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1244344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1244347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1244350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244383 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1244386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244405 */     // GIR_Coverage, 5511,
     /* 1244405 */     GIR_EraseRootFromParent_Done,
     /* 1244406 */   // Label 17979: @1244406
     /* 1244406 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1244487), // Rule ID 5512 //
     /* 1244411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1244422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1244425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1244428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1244431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244486 */     // GIR_Coverage, 5512,
     /* 1244486 */     GIR_EraseRootFromParent_Done,
     /* 1244487 */   // Label 17980: @1244487
     /* 1244487 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1244568), // Rule ID 5513 //
     /* 1244492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1244503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1244506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1244509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1244512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244567 */     // GIR_Coverage, 5513,
     /* 1244567 */     GIR_EraseRootFromParent_Done,
     /* 1244568 */   // Label 17981: @1244568
     /* 1244568 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1244649), // Rule ID 5514 //
     /* 1244573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1244584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1244587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1244590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1244593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244648 */     // GIR_Coverage, 5514,
     /* 1244648 */     GIR_EraseRootFromParent_Done,
     /* 1244649 */   // Label 17982: @1244649
     /* 1244649 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1244730), // Rule ID 5515 //
     /* 1244654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1244665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1244668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1244671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1244674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244707 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244729 */     // GIR_Coverage, 5515,
     /* 1244729 */     GIR_EraseRootFromParent_Done,
     /* 1244730 */   // Label 17983: @1244730
     /* 1244730 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1244811), // Rule ID 5516 //
     /* 1244735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1244746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1244749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1244752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1244755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244810 */     // GIR_Coverage, 5516,
     /* 1244810 */     GIR_EraseRootFromParent_Done,
     /* 1244811 */   // Label 17984: @1244811
     /* 1244811 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1244892), // Rule ID 5517 //
     /* 1244816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1244827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1244830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1244833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1244836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244869 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244891 */     // GIR_Coverage, 5517,
     /* 1244891 */     GIR_EraseRootFromParent_Done,
     /* 1244892 */   // Label 17985: @1244892
     /* 1244892 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1244973), // Rule ID 5518 //
     /* 1244897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1244900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1244917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1244950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1244953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244972 */     // GIR_Coverage, 5518,
     /* 1244972 */     GIR_EraseRootFromParent_Done,
     /* 1244973 */   // Label 17986: @1244973
     /* 1244973 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1245054), // Rule ID 5519 //
     /* 1244978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1244981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1244998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1245034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245053 */     // GIR_Coverage, 5519,
     /* 1245053 */     GIR_EraseRootFromParent_Done,
     /* 1245054 */   // Label 17987: @1245054
     /* 1245054 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1245135), // Rule ID 5520 //
     /* 1245059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1245070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1245073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1245076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1245079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245112 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1245115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245134 */     // GIR_Coverage, 5520,
     /* 1245134 */     GIR_EraseRootFromParent_Done,
     /* 1245135 */   // Label 17988: @1245135
     /* 1245135 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1245216), // Rule ID 5521 //
     /* 1245140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1245151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1245154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1245157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1245160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1245196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245215 */     // GIR_Coverage, 5521,
     /* 1245215 */     GIR_EraseRootFromParent_Done,
     /* 1245216 */   // Label 17989: @1245216
     /* 1245216 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1245297), // Rule ID 5522 //
     /* 1245221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1245232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1245235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1245238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1245241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1245277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245296 */     // GIR_Coverage, 5522,
     /* 1245296 */     GIR_EraseRootFromParent_Done,
     /* 1245297 */   // Label 17990: @1245297
     /* 1245297 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1245378), // Rule ID 5523 //
     /* 1245302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1245313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1245316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1245319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1245322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245355 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1245358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245377 */     // GIR_Coverage, 5523,
     /* 1245377 */     GIR_EraseRootFromParent_Done,
     /* 1245378 */   // Label 17991: @1245378
     /* 1245378 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1245459), // Rule ID 5524 //
     /* 1245383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1245394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1245397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1245400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1245403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1245406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245436 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1245439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245458 */     // GIR_Coverage, 5524,
     /* 1245458 */     GIR_EraseRootFromParent_Done,
     /* 1245459 */   // Label 17992: @1245459
     /* 1245459 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1245540), // Rule ID 5525 //
     /* 1245464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1245475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1245478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1245481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1245484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1245487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245517 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1245520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245539 */     // GIR_Coverage, 5525,
     /* 1245539 */     GIR_EraseRootFromParent_Done,
     /* 1245540 */   // Label 17993: @1245540
     /* 1245540 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1245621), // Rule ID 5526 //
     /* 1245545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1245556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1245559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1245562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1245565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1245601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245620 */     // GIR_Coverage, 5526,
     /* 1245620 */     GIR_EraseRootFromParent_Done,
     /* 1245621 */   // Label 17994: @1245621
     /* 1245621 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1245702), // Rule ID 5527 //
     /* 1245626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1245637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1245640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1245643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1245646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1245682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245701 */     // GIR_Coverage, 5527,
     /* 1245701 */     GIR_EraseRootFromParent_Done,
     /* 1245702 */   // Label 17995: @1245702
     /* 1245702 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1245783), // Rule ID 5528 //
     /* 1245707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1245718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1245721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1245724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1245727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245760 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1245763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245782 */     // GIR_Coverage, 5528,
     /* 1245782 */     GIR_EraseRootFromParent_Done,
     /* 1245783 */   // Label 17996: @1245783
     /* 1245783 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1245864), // Rule ID 5529 //
     /* 1245788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1245799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1245802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1245805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1245808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1245844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245863 */     // GIR_Coverage, 5529,
     /* 1245863 */     GIR_EraseRootFromParent_Done,
     /* 1245864 */   // Label 17997: @1245864
     /* 1245864 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1245945), // Rule ID 5530 //
     /* 1245869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1245889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245922 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1245925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245944 */     // GIR_Coverage, 5530,
     /* 1245944 */     GIR_EraseRootFromParent_Done,
     /* 1245945 */   // Label 17998: @1245945
     /* 1245945 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1246026), // Rule ID 5531 //
     /* 1245950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1245970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246003 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1246006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246025 */     // GIR_Coverage, 5531,
     /* 1246025 */     GIR_EraseRootFromParent_Done,
     /* 1246026 */   // Label 17999: @1246026
     /* 1246026 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1246107), // Rule ID 5532 //
     /* 1246031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1246042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1246045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1246048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1246051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1246061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1246087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246106 */     // GIR_Coverage, 5532,
     /* 1246106 */     GIR_EraseRootFromParent_Done,
     /* 1246107 */   // Label 18000: @1246107
     /* 1246107 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1246188), // Rule ID 5533 //
     /* 1246112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1246123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1246126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1246129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1246132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1246142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1246168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246187 */     // GIR_Coverage, 5533,
     /* 1246187 */     GIR_EraseRootFromParent_Done,
     /* 1246188 */   // Label 18001: @1246188
     /* 1246188 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1246269), // Rule ID 5534 //
     /* 1246193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1246204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1246207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1246210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1246213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1246223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1246249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246268 */     // GIR_Coverage, 5534,
     /* 1246268 */     GIR_EraseRootFromParent_Done,
     /* 1246269 */   // Label 18002: @1246269
     /* 1246269 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1246350), // Rule ID 5535 //
     /* 1246274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1246285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1246288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1246291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1246294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1246304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1246330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246349 */     // GIR_Coverage, 5535,
     /* 1246349 */     GIR_EraseRootFromParent_Done,
     /* 1246350 */   // Label 18003: @1246350
     /* 1246350 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1246431), // Rule ID 5536 //
     /* 1246355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1246366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1246369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1246372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1246375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1246378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1246411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246430 */     // GIR_Coverage, 5536,
     /* 1246430 */     GIR_EraseRootFromParent_Done,
     /* 1246431 */   // Label 18004: @1246431
     /* 1246431 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1246512), // Rule ID 5537 //
     /* 1246436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1246447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1246450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1246453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1246456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1246459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246489 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1246492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246511 */     // GIR_Coverage, 5537,
     /* 1246511 */     GIR_EraseRootFromParent_Done,
     /* 1246512 */   // Label 18005: @1246512
     /* 1246512 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1246593), // Rule ID 5538 //
     /* 1246517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1246520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1246528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1246531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1246534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1246537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1246547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1246573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246592 */     // GIR_Coverage, 5538,
     /* 1246592 */     GIR_EraseRootFromParent_Done,
     /* 1246593 */   // Label 18006: @1246593
     /* 1246593 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1246674), // Rule ID 5539 //
     /* 1246598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1246609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1246612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1246615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1246618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1246628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1246640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1246654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246673 */     // GIR_Coverage, 5539,
     /* 1246673 */     GIR_EraseRootFromParent_Done,
     /* 1246674 */   // Label 18007: @1246674
     /* 1246674 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1246755), // Rule ID 5540 //
     /* 1246679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1246682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1246690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1246693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1246696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1246699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1246709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1246735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246754 */     // GIR_Coverage, 5540,
     /* 1246754 */     GIR_EraseRootFromParent_Done,
     /* 1246755 */   // Label 18008: @1246755
     /* 1246755 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1246836), // Rule ID 5541 //
     /* 1246760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1246771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1246774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1246777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1246780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1246790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246813 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1246816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246835 */     // GIR_Coverage, 5541,
     /* 1246835 */     GIR_EraseRootFromParent_Done,
     /* 1246836 */   // Label 18009: @1246836
     /* 1246836 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1246917), // Rule ID 5542 //
     /* 1246841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1246844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1246861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1246897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246916 */     // GIR_Coverage, 5542,
     /* 1246916 */     GIR_EraseRootFromParent_Done,
     /* 1246917 */   // Label 18010: @1246917
     /* 1246917 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1246998), // Rule ID 5543 //
     /* 1246922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1246942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246975 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1246978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246997 */     // GIR_Coverage, 5543,
     /* 1246997 */     GIR_EraseRootFromParent_Done,
     /* 1246998 */   // Label 18011: @1246998
     /* 1246998 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1247079), // Rule ID 5544 //
     /* 1247003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1247014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1247017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1247020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1247059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247078 */     // GIR_Coverage, 5544,
     /* 1247078 */     GIR_EraseRootFromParent_Done,
     /* 1247079 */   // Label 18012: @1247079
     /* 1247079 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1247160), // Rule ID 5545 //
     /* 1247084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1247095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1247098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1247101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247137 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1247140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247159 */     // GIR_Coverage, 5545,
     /* 1247159 */     GIR_EraseRootFromParent_Done,
     /* 1247160 */   // Label 18013: @1247160
     /* 1247160 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1247241), // Rule ID 5546 //
     /* 1247165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1247176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1247179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1247182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1247221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247240 */     // GIR_Coverage, 5546,
     /* 1247240 */     GIR_EraseRootFromParent_Done,
     /* 1247241 */   // Label 18014: @1247241
     /* 1247241 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1247322), // Rule ID 5547 //
     /* 1247246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1247257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1247260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1247263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247299 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1247302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247321 */     // GIR_Coverage, 5547,
     /* 1247321 */     GIR_EraseRootFromParent_Done,
     /* 1247322 */   // Label 18015: @1247322
     /* 1247322 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1247403), // Rule ID 5548 //
     /* 1247327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1247338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1247341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1247344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247380 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247402 */     // GIR_Coverage, 5548,
     /* 1247402 */     GIR_EraseRootFromParent_Done,
     /* 1247403 */   // Label 18016: @1247403
     /* 1247403 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1247484), // Rule ID 5549 //
     /* 1247408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1247419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1247422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1247425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247461 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247483 */     // GIR_Coverage, 5549,
     /* 1247483 */     GIR_EraseRootFromParent_Done,
     /* 1247484 */   // Label 18017: @1247484
     /* 1247484 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1247565), // Rule ID 5550 //
     /* 1247489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1247500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1247503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1247506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247542 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1247545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247564 */     // GIR_Coverage, 5550,
     /* 1247564 */     GIR_EraseRootFromParent_Done,
     /* 1247565 */   // Label 18018: @1247565
     /* 1247565 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1247646), // Rule ID 5551 //
     /* 1247570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1247581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1247584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1247587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247623 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1247626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247645 */     // GIR_Coverage, 5551,
     /* 1247645 */     GIR_EraseRootFromParent_Done,
     /* 1247646 */   // Label 18019: @1247646
     /* 1247646 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1247727), // Rule ID 5552 //
     /* 1247651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1247662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1247665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1247668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247726 */     // GIR_Coverage, 5552,
     /* 1247726 */     GIR_EraseRootFromParent_Done,
     /* 1247727 */   // Label 18020: @1247727
     /* 1247727 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1247808), // Rule ID 5553 //
     /* 1247732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1247743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1247746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1247749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247785 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247807 */     // GIR_Coverage, 5553,
     /* 1247807 */     GIR_EraseRootFromParent_Done,
     /* 1247808 */   // Label 18021: @1247808
     /* 1247808 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1247889), // Rule ID 5554 //
     /* 1247813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1247824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1247827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1247830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247888 */     // GIR_Coverage, 5554,
     /* 1247888 */     GIR_EraseRootFromParent_Done,
     /* 1247889 */   // Label 18022: @1247889
     /* 1247889 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1247970), // Rule ID 5555 //
     /* 1247894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1247905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1247908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1247911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1247914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1247936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247947 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1247950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247969 */     // GIR_Coverage, 5555,
     /* 1247969 */     GIR_EraseRootFromParent_Done,
     /* 1247970 */   // Label 18023: @1247970
     /* 1247970 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1248051), // Rule ID 5556 //
     /* 1247975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1247986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1247989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1247995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1248028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248050 */     // GIR_Coverage, 5556,
     /* 1248050 */     GIR_EraseRootFromParent_Done,
     /* 1248051 */   // Label 18024: @1248051
     /* 1248051 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1248132), // Rule ID 5557 //
     /* 1248056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1248067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1248070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1248073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248109 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248131 */     // GIR_Coverage, 5557,
     /* 1248131 */     GIR_EraseRootFromParent_Done,
     /* 1248132 */   // Label 18025: @1248132
     /* 1248132 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1248213), // Rule ID 5558 //
     /* 1248137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1248148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1248151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1248154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248212 */     // GIR_Coverage, 5558,
     /* 1248212 */     GIR_EraseRootFromParent_Done,
     /* 1248213 */   // Label 18026: @1248213
     /* 1248213 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1248294), // Rule ID 5559 //
     /* 1248218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1248229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1248232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1248235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248271 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248293 */     // GIR_Coverage, 5559,
     /* 1248293 */     GIR_EraseRootFromParent_Done,
     /* 1248294 */   // Label 18027: @1248294
     /* 1248294 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1248375), // Rule ID 5560 //
     /* 1248299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1248310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1248313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1248316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248374 */     // GIR_Coverage, 5560,
     /* 1248374 */     GIR_EraseRootFromParent_Done,
     /* 1248375 */   // Label 18028: @1248375
     /* 1248375 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1248456), // Rule ID 5561 //
     /* 1248380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1248391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1248394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1248397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248455 */     // GIR_Coverage, 5561,
     /* 1248455 */     GIR_EraseRootFromParent_Done,
     /* 1248456 */   // Label 18029: @1248456
     /* 1248456 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1248537), // Rule ID 5562 //
     /* 1248461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1248464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1248472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1248475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1248478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1248514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248536 */     // GIR_Coverage, 5562,
     /* 1248536 */     GIR_EraseRootFromParent_Done,
     /* 1248537 */   // Label 18030: @1248537
     /* 1248537 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1248618), // Rule ID 5563 //
     /* 1248542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1248545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1248553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1248556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1248559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1248565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1248572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1248595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1248598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248617 */     // GIR_Coverage, 5563,
     /* 1248617 */     GIR_EraseRootFromParent_Done,
     /* 1248618 */   // Label 18031: @1248618
     /* 1248618 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1248699), // Rule ID 5564 //
     /* 1248623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1248634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1248637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1248640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1248676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1248679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248698 */     // GIR_Coverage, 5564,
     /* 1248698 */     GIR_EraseRootFromParent_Done,
     /* 1248699 */   // Label 18032: @1248699
     /* 1248699 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1248780), // Rule ID 5565 //
     /* 1248704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1248715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1248718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1248721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1248760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248779 */     // GIR_Coverage, 5565,
     /* 1248779 */     GIR_EraseRootFromParent_Done,
     /* 1248780 */   // Label 18033: @1248780
     /* 1248780 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1248861), // Rule ID 5566 //
     /* 1248785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1248796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1248799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1248802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248838 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1248838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1248841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248860 */     // GIR_Coverage, 5566,
     /* 1248860 */     GIR_EraseRootFromParent_Done,
     /* 1248861 */   // Label 18034: @1248861
     /* 1248861 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1248942), // Rule ID 5567 //
     /* 1248866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1248877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1248880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1248883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1248886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248919 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1248919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1248922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248941 */     // GIR_Coverage, 5567,
     /* 1248941 */     GIR_EraseRootFromParent_Done,
     /* 1248942 */   // Label 18035: @1248942
     /* 1248942 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1249023), // Rule ID 5568 //
     /* 1248947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1248958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1248961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1248967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1248989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1249003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249022 */     // GIR_Coverage, 5568,
     /* 1249022 */     GIR_EraseRootFromParent_Done,
     /* 1249023 */   // Label 18036: @1249023
     /* 1249023 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1249104), // Rule ID 5569 //
     /* 1249028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1249039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1249042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1249045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1249051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249081 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1249084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249103 */     // GIR_Coverage, 5569,
     /* 1249103 */     GIR_EraseRootFromParent_Done,
     /* 1249104 */   // Label 18037: @1249104
     /* 1249104 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1249185), // Rule ID 5570 //
     /* 1249109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1249120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1249123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1249126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249162 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1249165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249184 */     // GIR_Coverage, 5570,
     /* 1249184 */     GIR_EraseRootFromParent_Done,
     /* 1249185 */   // Label 18038: @1249185
     /* 1249185 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1249266), // Rule ID 5571 //
     /* 1249190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1249201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1249204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1249207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1249243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1249246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249265 */     // GIR_Coverage, 5571,
     /* 1249265 */     GIR_EraseRootFromParent_Done,
     /* 1249266 */   // Label 18039: @1249266
     /* 1249266 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1249347), // Rule ID 5572 //
     /* 1249271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1249282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1249285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1249288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1249327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249346 */     // GIR_Coverage, 5572,
     /* 1249346 */     GIR_EraseRootFromParent_Done,
     /* 1249347 */   // Label 18040: @1249347
     /* 1249347 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1249428), // Rule ID 5573 //
     /* 1249352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1249363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1249366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1249369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249405 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1249405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1249408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249427 */     // GIR_Coverage, 5573,
     /* 1249427 */     GIR_EraseRootFromParent_Done,
     /* 1249428 */   // Label 18041: @1249428
     /* 1249428 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1249509), // Rule ID 5574 //
     /* 1249433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1249444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1249447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1249450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1249456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1249489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249508 */     // GIR_Coverage, 5574,
     /* 1249508 */     GIR_EraseRootFromParent_Done,
     /* 1249509 */   // Label 18042: @1249509
     /* 1249509 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1249590), // Rule ID 5575 //
     /* 1249514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1249525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1249528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1249531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1249537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249567 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1249567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1249570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249589 */     // GIR_Coverage, 5575,
     /* 1249589 */     GIR_EraseRootFromParent_Done,
     /* 1249590 */   // Label 18043: @1249590
     /* 1249590 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1249671), // Rule ID 5576 //
     /* 1249595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1249606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1249609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1249612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1249648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1249651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249670 */     // GIR_Coverage, 5576,
     /* 1249670 */     GIR_EraseRootFromParent_Done,
     /* 1249671 */   // Label 18044: @1249671
     /* 1249671 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1249752), // Rule ID 5577 //
     /* 1249676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1249687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1249690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1249693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1249706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1249732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249751 */     // GIR_Coverage, 5577,
     /* 1249751 */     GIR_EraseRootFromParent_Done,
     /* 1249752 */   // Label 18045: @1249752
     /* 1249752 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1249833), // Rule ID 5578 //
     /* 1249757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1249768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1249771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1249774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1249810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1249813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249832 */     // GIR_Coverage, 5578,
     /* 1249832 */     GIR_EraseRootFromParent_Done,
     /* 1249833 */   // Label 18046: @1249833
     /* 1249833 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1249914), // Rule ID 5579 //
     /* 1249838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1249849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1249852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1249855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1249891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1249894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249913 */     // GIR_Coverage, 5579,
     /* 1249913 */     GIR_EraseRootFromParent_Done,
     /* 1249914 */   // Label 18047: @1249914
     /* 1249914 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1249995), // Rule ID 5580 //
     /* 1249919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1249930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1249933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1249972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1249975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249994 */     // GIR_Coverage, 5580,
     /* 1249994 */     GIR_EraseRootFromParent_Done,
     /* 1249995 */   // Label 18048: @1249995
     /* 1249995 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1250076), // Rule ID 5581 //
     /* 1250000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1250011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1250014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1250017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1250030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250053 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1250056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250075 */     // GIR_Coverage, 5581,
     /* 1250075 */     GIR_EraseRootFromParent_Done,
     /* 1250076 */   // Label 18049: @1250076
     /* 1250076 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1250157), // Rule ID 5582 //
     /* 1250081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1250092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1250095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1250098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1250134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1250137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250156 */     // GIR_Coverage, 5582,
     /* 1250156 */     GIR_EraseRootFromParent_Done,
     /* 1250157 */   // Label 18050: @1250157
     /* 1250157 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1250238), // Rule ID 5583 //
     /* 1250162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1250165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1250173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1250176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1250179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1250215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1250218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250237 */     // GIR_Coverage, 5583,
     /* 1250237 */     GIR_EraseRootFromParent_Done,
     /* 1250238 */   // Label 18051: @1250238
     /* 1250238 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1250319), // Rule ID 5584 //
     /* 1250243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1250254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1250257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1250260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1250273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1250296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1250299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250318 */     // GIR_Coverage, 5584,
     /* 1250318 */     GIR_EraseRootFromParent_Done,
     /* 1250319 */   // Label 18052: @1250319
     /* 1250319 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1250400), // Rule ID 5585 //
     /* 1250324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1250327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1250335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1250338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1250341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1250354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1250362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250377 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1250377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1250380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250399 */     // GIR_Coverage, 5585,
     /* 1250399 */     GIR_EraseRootFromParent_Done,
     /* 1250400 */   // Label 18053: @1250400
     /* 1250400 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1250481), // Rule ID 5586 //
     /* 1250405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1250416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1250419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1250422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1250435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250458 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1250458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1250461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250480 */     // GIR_Coverage, 5586,
     /* 1250480 */     GIR_EraseRootFromParent_Done,
     /* 1250481 */   // Label 18054: @1250481
     /* 1250481 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1250562), // Rule ID 5587 //
     /* 1250486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1250489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1250497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1250500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1250503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1250516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1250524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250539 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1250539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1250542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250561 */     // GIR_Coverage, 5587,
     /* 1250561 */     GIR_EraseRootFromParent_Done,
     /* 1250562 */   // Label 18055: @1250562
     /* 1250562 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1250646), // Rule ID 7798 //
     /* 1250567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1250584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1250587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1250623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250645 */     // GIR_Coverage, 7798,
     /* 1250645 */     GIR_EraseRootFromParent_Done,
     /* 1250646 */   // Label 18056: @1250646
     /* 1250646 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1250730), // Rule ID 7799 //
     /* 1250651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1250668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1250671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1250707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250729 */     // GIR_Coverage, 7799,
     /* 1250729 */     GIR_EraseRootFromParent_Done,
     /* 1250730 */   // Label 18057: @1250730
     /* 1250730 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1250814), // Rule ID 7802 //
     /* 1250735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1250755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1250791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250813 */     // GIR_Coverage, 7802,
     /* 1250813 */     GIR_EraseRootFromParent_Done,
     /* 1250814 */   // Label 18058: @1250814
     /* 1250814 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1250898), // Rule ID 7803 //
     /* 1250819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1250839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1250875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250897 */     // GIR_Coverage, 7803,
     /* 1250897 */     GIR_EraseRootFromParent_Done,
     /* 1250898 */   // Label 18059: @1250898
     /* 1250898 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1250982), // Rule ID 7806 //
     /* 1250903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1250923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1250959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250981 */     // GIR_Coverage, 7806,
     /* 1250981 */     GIR_EraseRootFromParent_Done,
     /* 1250982 */   // Label 18060: @1250982
     /* 1250982 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1251066), // Rule ID 7807 //
     /* 1250987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1251004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1251007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1251043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251065 */     // GIR_Coverage, 7807,
     /* 1251065 */     GIR_EraseRootFromParent_Done,
     /* 1251066 */   // Label 18061: @1251066
     /* 1251066 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1251150), // Rule ID 7810 //
     /* 1251071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1251088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1251091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1251127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251149 */     // GIR_Coverage, 7810,
     /* 1251149 */     GIR_EraseRootFromParent_Done,
     /* 1251150 */   // Label 18062: @1251150
     /* 1251150 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1251234), // Rule ID 7811 //
     /* 1251155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1251172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1251175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1251211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251233 */     // GIR_Coverage, 7811,
     /* 1251233 */     GIR_EraseRootFromParent_Done,
     /* 1251234 */   // Label 18063: @1251234
     /* 1251234 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1251318), // Rule ID 7814 //
     /* 1251239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1251256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1251259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1251295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251317 */     // GIR_Coverage, 7814,
     /* 1251317 */     GIR_EraseRootFromParent_Done,
     /* 1251318 */   // Label 18064: @1251318
     /* 1251318 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1251402), // Rule ID 7815 //
     /* 1251323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1251340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1251343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1251379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251401 */     // GIR_Coverage, 7815,
     /* 1251401 */     GIR_EraseRootFromParent_Done,
     /* 1251402 */   // Label 18065: @1251402
     /* 1251402 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1251486), // Rule ID 7818 //
     /* 1251407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1251418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1251421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1251424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1251427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251485 */     // GIR_Coverage, 7818,
     /* 1251485 */     GIR_EraseRootFromParent_Done,
     /* 1251486 */   // Label 18066: @1251486
     /* 1251486 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1251570), // Rule ID 7819 //
     /* 1251491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1251502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1251505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1251508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1251511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251569 */     // GIR_Coverage, 7819,
     /* 1251569 */     GIR_EraseRootFromParent_Done,
     /* 1251570 */   // Label 18067: @1251570
     /* 1251570 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1251654), // Rule ID 7822 //
     /* 1251575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1251586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1251589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1251592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1251595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251653 */     // GIR_Coverage, 7822,
     /* 1251653 */     GIR_EraseRootFromParent_Done,
     /* 1251654 */   // Label 18068: @1251654
     /* 1251654 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1251738), // Rule ID 7823 //
     /* 1251659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1251670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1251673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1251676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1251679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251737 */     // GIR_Coverage, 7823,
     /* 1251737 */     GIR_EraseRootFromParent_Done,
     /* 1251738 */   // Label 18069: @1251738
     /* 1251738 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1251822), // Rule ID 7826 //
     /* 1251743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1251763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251821 */     // GIR_Coverage, 7826,
     /* 1251821 */     GIR_EraseRootFromParent_Done,
     /* 1251822 */   // Label 18070: @1251822
     /* 1251822 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1251906), // Rule ID 7827 //
     /* 1251827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1251847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251905 */     // GIR_Coverage, 7827,
     /* 1251905 */     GIR_EraseRootFromParent_Done,
     /* 1251906 */   // Label 18071: @1251906
     /* 1251906 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1251990), // Rule ID 7830 //
     /* 1251911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1251914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1251931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1251967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251989 */     // GIR_Coverage, 7830,
     /* 1251989 */     GIR_EraseRootFromParent_Done,
     /* 1251990 */   // Label 18072: @1251990
     /* 1251990 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1252074), // Rule ID 7831 //
     /* 1251995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1251998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1252006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1252009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1252012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1252015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1252018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1252051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252073 */     // GIR_Coverage, 7831,
     /* 1252073 */     GIR_EraseRootFromParent_Done,
     /* 1252074 */   // Label 18073: @1252074
     /* 1252074 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1252158), // Rule ID 7834 //
     /* 1252079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1252096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1252099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1252135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252157 */     // GIR_Coverage, 7834,
     /* 1252157 */     GIR_EraseRootFromParent_Done,
     /* 1252158 */   // Label 18074: @1252158
     /* 1252158 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1252242), // Rule ID 7835 //
     /* 1252163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1252180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1252183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1252219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252241 */     // GIR_Coverage, 7835,
     /* 1252241 */     GIR_EraseRootFromParent_Done,
     /* 1252242 */   // Label 18075: @1252242
     /* 1252242 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1252326), // Rule ID 7838 //
     /* 1252247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1252264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1252267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252300 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1252303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252325 */     // GIR_Coverage, 7838,
     /* 1252325 */     GIR_EraseRootFromParent_Done,
     /* 1252326 */   // Label 18076: @1252326
     /* 1252326 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1252410), // Rule ID 7839 //
     /* 1252331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1252348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1252351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1252387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252409 */     // GIR_Coverage, 7839,
     /* 1252409 */     GIR_EraseRootFromParent_Done,
     /* 1252410 */   // Label 18077: @1252410
     /* 1252410 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1252494), // Rule ID 7842 //
     /* 1252415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1252426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1252429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1252432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1252435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1252438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252468 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1252471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252493 */     // GIR_Coverage, 7842,
     /* 1252493 */     GIR_EraseRootFromParent_Done,
     /* 1252494 */   // Label 18078: @1252494
     /* 1252494 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1252578), // Rule ID 7843 //
     /* 1252499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1252510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1252513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1252516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1252519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1252522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252552 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1252555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252577 */     // GIR_Coverage, 7843,
     /* 1252577 */     GIR_EraseRootFromParent_Done,
     /* 1252578 */   // Label 18079: @1252578
     /* 1252578 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1252662), // Rule ID 7846 //
     /* 1252583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1252600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1252603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1252639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252661 */     // GIR_Coverage, 7846,
     /* 1252661 */     GIR_EraseRootFromParent_Done,
     /* 1252662 */   // Label 18080: @1252662
     /* 1252662 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1252746), // Rule ID 7847 //
     /* 1252667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1252684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1252687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1252723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252745 */     // GIR_Coverage, 7847,
     /* 1252745 */     GIR_EraseRootFromParent_Done,
     /* 1252746 */   // Label 18081: @1252746
     /* 1252746 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1252830), // Rule ID 7850 //
     /* 1252751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1252771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1252807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252829 */     // GIR_Coverage, 7850,
     /* 1252829 */     GIR_EraseRootFromParent_Done,
     /* 1252830 */   // Label 18082: @1252830
     /* 1252830 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1252914), // Rule ID 7851 //
     /* 1252835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1252855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1252891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252913 */     // GIR_Coverage, 7851,
     /* 1252913 */     GIR_EraseRootFromParent_Done,
     /* 1252914 */   // Label 18083: @1252914
     /* 1252914 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1252998), // Rule ID 7854 //
     /* 1252919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1252939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252972 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1252975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252997 */     // GIR_Coverage, 7854,
     /* 1252997 */     GIR_EraseRootFromParent_Done,
     /* 1252998 */   // Label 18084: @1252998
     /* 1252998 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1253082), // Rule ID 7855 //
     /* 1253003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1253014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1253017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1253020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1253023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1253026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1253059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253081 */     // GIR_Coverage, 7855,
     /* 1253081 */     GIR_EraseRootFromParent_Done,
     /* 1253082 */   // Label 18085: @1253082
     /* 1253082 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1253166), // Rule ID 7858 //
     /* 1253087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1253104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1253107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1253143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253165 */     // GIR_Coverage, 7858,
     /* 1253165 */     GIR_EraseRootFromParent_Done,
     /* 1253166 */   // Label 18086: @1253166
     /* 1253166 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1253250), // Rule ID 7859 //
     /* 1253171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1253188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1253191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1253227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253249 */     // GIR_Coverage, 7859,
     /* 1253249 */     GIR_EraseRootFromParent_Done,
     /* 1253250 */   // Label 18087: @1253250
     /* 1253250 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1253334), // Rule ID 7862 //
     /* 1253255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1253272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1253275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1253311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253333 */     // GIR_Coverage, 7862,
     /* 1253333 */     GIR_EraseRootFromParent_Done,
     /* 1253334 */   // Label 18088: @1253334
     /* 1253334 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1253418), // Rule ID 7863 //
     /* 1253339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1253356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1253359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1253395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253417 */     // GIR_Coverage, 7863,
     /* 1253417 */     GIR_EraseRootFromParent_Done,
     /* 1253418 */   // Label 18089: @1253418
     /* 1253418 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1253502), // Rule ID 7866 //
     /* 1253423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1253434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1253437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1253440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1253443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1253446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1253479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253501 */     // GIR_Coverage, 7866,
     /* 1253501 */     GIR_EraseRootFromParent_Done,
     /* 1253502 */   // Label 18090: @1253502
     /* 1253502 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1253586), // Rule ID 7867 //
     /* 1253507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1253518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1253521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1253524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1253527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1253530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1253563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253585 */     // GIR_Coverage, 7867,
     /* 1253585 */     GIR_EraseRootFromParent_Done,
     /* 1253586 */   // Label 18091: @1253586
     /* 1253586 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1253670), // Rule ID 7870 //
     /* 1253591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1253608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1253611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1253647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253669 */     // GIR_Coverage, 7870,
     /* 1253669 */     GIR_EraseRootFromParent_Done,
     /* 1253670 */   // Label 18092: @1253670
     /* 1253670 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1253754), // Rule ID 7871 //
     /* 1253675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1253692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1253695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1253731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253753 */     // GIR_Coverage, 7871,
     /* 1253753 */     GIR_EraseRootFromParent_Done,
     /* 1253754 */   // Label 18093: @1253754
     /* 1253754 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1253838), // Rule ID 7874 //
     /* 1253759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1253779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1253815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253837 */     // GIR_Coverage, 7874,
     /* 1253837 */     GIR_EraseRootFromParent_Done,
     /* 1253838 */   // Label 18094: @1253838
     /* 1253838 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1253922), // Rule ID 7875 //
     /* 1253843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1253863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1253899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253921 */     // GIR_Coverage, 7875,
     /* 1253921 */     GIR_EraseRootFromParent_Done,
     /* 1253922 */   // Label 18095: @1253922
     /* 1253922 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1254006), // Rule ID 7878 //
     /* 1253927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1253947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1253983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254005 */     // GIR_Coverage, 7878,
     /* 1254005 */     GIR_EraseRootFromParent_Done,
     /* 1254006 */   // Label 18096: @1254006
     /* 1254006 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1254090), // Rule ID 7879 //
     /* 1254011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1254028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1254031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1254067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254089 */     // GIR_Coverage, 7879,
     /* 1254089 */     GIR_EraseRootFromParent_Done,
     /* 1254090 */   // Label 18097: @1254090
     /* 1254090 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1254174), // Rule ID 7882 //
     /* 1254095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1254112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1254151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254173 */     // GIR_Coverage, 7882,
     /* 1254173 */     GIR_EraseRootFromParent_Done,
     /* 1254174 */   // Label 18098: @1254174
     /* 1254174 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1254258), // Rule ID 7883 //
     /* 1254179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1254196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1254235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254257 */     // GIR_Coverage, 7883,
     /* 1254257 */     GIR_EraseRootFromParent_Done,
     /* 1254258 */   // Label 18099: @1254258
     /* 1254258 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1254342), // Rule ID 7886 //
     /* 1254263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1254280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1254319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254341 */     // GIR_Coverage, 7886,
     /* 1254341 */     GIR_EraseRootFromParent_Done,
     /* 1254342 */   // Label 18100: @1254342
     /* 1254342 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1254426), // Rule ID 7887 //
     /* 1254347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1254364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1254403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254425 */     // GIR_Coverage, 7887,
     /* 1254425 */     GIR_EraseRootFromParent_Done,
     /* 1254426 */   // Label 18101: @1254426
     /* 1254426 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1254510), // Rule ID 7890 //
     /* 1254431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1254448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1254487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254509 */     // GIR_Coverage, 7890,
     /* 1254509 */     GIR_EraseRootFromParent_Done,
     /* 1254510 */   // Label 18102: @1254510
     /* 1254510 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1254594), // Rule ID 7891 //
     /* 1254515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1254532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1254571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254593 */     // GIR_Coverage, 7891,
     /* 1254593 */     GIR_EraseRootFromParent_Done,
     /* 1254594 */   // Label 18103: @1254594
     /* 1254594 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1254678), // Rule ID 7894 //
     /* 1254599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1254616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1254655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254677 */     // GIR_Coverage, 7894,
     /* 1254677 */     GIR_EraseRootFromParent_Done,
     /* 1254678 */   // Label 18104: @1254678
     /* 1254678 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1254762), // Rule ID 7895 //
     /* 1254683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1254700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1254739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254761 */     // GIR_Coverage, 7895,
     /* 1254761 */     GIR_EraseRootFromParent_Done,
     /* 1254762 */   // Label 18105: @1254762
     /* 1254762 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1254846), // Rule ID 7898 //
     /* 1254767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1254784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1254823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254845 */     // GIR_Coverage, 7898,
     /* 1254845 */     GIR_EraseRootFromParent_Done,
     /* 1254846 */   // Label 18106: @1254846
     /* 1254846 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1254930), // Rule ID 7899 //
     /* 1254851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1254868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1254871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1254907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254929 */     // GIR_Coverage, 7899,
     /* 1254929 */     GIR_EraseRootFromParent_Done,
     /* 1254930 */   // Label 18107: @1254930
     /* 1254930 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1255014), // Rule ID 7902 //
     /* 1254935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1254952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1254955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1254977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1254991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255013 */     // GIR_Coverage, 7902,
     /* 1255013 */     GIR_EraseRootFromParent_Done,
     /* 1255014 */   // Label 18108: @1255014
     /* 1255014 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1255098), // Rule ID 7903 //
     /* 1255019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1255030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1255033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1255036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255072 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1255075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255097 */     // GIR_Coverage, 7903,
     /* 1255097 */     GIR_EraseRootFromParent_Done,
     /* 1255098 */   // Label 18109: @1255098
     /* 1255098 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1255182), // Rule ID 7906 //
     /* 1255103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1255120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255181 */     // GIR_Coverage, 7906,
     /* 1255181 */     GIR_EraseRootFromParent_Done,
     /* 1255182 */   // Label 18110: @1255182
     /* 1255182 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1255266), // Rule ID 7907 //
     /* 1255187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1255204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255265 */     // GIR_Coverage, 7907,
     /* 1255265 */     GIR_EraseRootFromParent_Done,
     /* 1255266 */   // Label 18111: @1255266
     /* 1255266 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1255350), // Rule ID 7910 //
     /* 1255271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1255288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255349 */     // GIR_Coverage, 7910,
     /* 1255349 */     GIR_EraseRootFromParent_Done,
     /* 1255350 */   // Label 18112: @1255350
     /* 1255350 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1255434), // Rule ID 7911 //
     /* 1255355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1255372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255433 */     // GIR_Coverage, 7911,
     /* 1255433 */     GIR_EraseRootFromParent_Done,
     /* 1255434 */   // Label 18113: @1255434
     /* 1255434 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1255518), // Rule ID 7914 //
     /* 1255439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1255456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255517 */     // GIR_Coverage, 7914,
     /* 1255517 */     GIR_EraseRootFromParent_Done,
     /* 1255518 */   // Label 18114: @1255518
     /* 1255518 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1255602), // Rule ID 7915 //
     /* 1255523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1255540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255576 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255601 */     // GIR_Coverage, 7915,
     /* 1255601 */     GIR_EraseRootFromParent_Done,
     /* 1255602 */   // Label 18115: @1255602
     /* 1255602 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1255686), // Rule ID 7918 //
     /* 1255607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1255610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1255618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1255621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1255624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255685 */     // GIR_Coverage, 7918,
     /* 1255685 */     GIR_EraseRootFromParent_Done,
     /* 1255686 */   // Label 18116: @1255686
     /* 1255686 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1255770), // Rule ID 7919 //
     /* 1255691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1255694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1255702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1255705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1255708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1255747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255769 */     // GIR_Coverage, 7919,
     /* 1255769 */     GIR_EraseRootFromParent_Done,
     /* 1255770 */   // Label 18117: @1255770
     /* 1255770 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1255854), // Rule ID 7922 //
     /* 1255775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1255792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1255831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255853 */     // GIR_Coverage, 7922,
     /* 1255853 */     GIR_EraseRootFromParent_Done,
     /* 1255854 */   // Label 18118: @1255854
     /* 1255854 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1255938), // Rule ID 7923 //
     /* 1255859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1255876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1255879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1255915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255937 */     // GIR_Coverage, 7923,
     /* 1255937 */     GIR_EraseRootFromParent_Done,
     /* 1255938 */   // Label 18119: @1255938
     /* 1255938 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1256022), // Rule ID 7926 //
     /* 1255943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1255960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1255963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1255985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255996 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1255999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256021 */     // GIR_Coverage, 7926,
     /* 1256021 */     GIR_EraseRootFromParent_Done,
     /* 1256022 */   // Label 18120: @1256022
     /* 1256022 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1256106), // Rule ID 7927 //
     /* 1256027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1256038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1256041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1256044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1256050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1256083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256105 */     // GIR_Coverage, 7927,
     /* 1256105 */     GIR_EraseRootFromParent_Done,
     /* 1256106 */   // Label 18121: @1256106
     /* 1256106 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1256190), // Rule ID 7930 //
     /* 1256111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1256122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1256125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1256128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1256134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256164 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1256167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256189 */     // GIR_Coverage, 7930,
     /* 1256189 */     GIR_EraseRootFromParent_Done,
     /* 1256190 */   // Label 18122: @1256190
     /* 1256190 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1256274), // Rule ID 7931 //
     /* 1256195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1256206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1256209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1256212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1256218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256248 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1256251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256273 */     // GIR_Coverage, 7931,
     /* 1256273 */     GIR_EraseRootFromParent_Done,
     /* 1256274 */   // Label 18123: @1256274
     /* 1256274 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1256358), // Rule ID 7934 //
     /* 1256279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1256296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1256335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256357 */     // GIR_Coverage, 7934,
     /* 1256357 */     GIR_EraseRootFromParent_Done,
     /* 1256358 */   // Label 18124: @1256358
     /* 1256358 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1256442), // Rule ID 7935 //
     /* 1256363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1256380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1256419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256441 */     // GIR_Coverage, 7935,
     /* 1256441 */     GIR_EraseRootFromParent_Done,
     /* 1256442 */   // Label 18125: @1256442
     /* 1256442 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1256526), // Rule ID 7938 //
     /* 1256447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1256464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1256503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256525 */     // GIR_Coverage, 7938,
     /* 1256525 */     GIR_EraseRootFromParent_Done,
     /* 1256526 */   // Label 18126: @1256526
     /* 1256526 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1256610), // Rule ID 7939 //
     /* 1256531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1256548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1256587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256609 */     // GIR_Coverage, 7939,
     /* 1256609 */     GIR_EraseRootFromParent_Done,
     /* 1256610 */   // Label 18127: @1256610
     /* 1256610 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1256694), // Rule ID 7942 //
     /* 1256615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1256626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1256629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1256632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1256638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256668 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1256671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256693 */     // GIR_Coverage, 7942,
     /* 1256693 */     GIR_EraseRootFromParent_Done,
     /* 1256694 */   // Label 18128: @1256694
     /* 1256694 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1256778), // Rule ID 7943 //
     /* 1256699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1256710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1256713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1256716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1256722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256752 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1256755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256777 */     // GIR_Coverage, 7943,
     /* 1256777 */     GIR_EraseRootFromParent_Done,
     /* 1256778 */   // Label 18129: @1256778
     /* 1256778 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1256862), // Rule ID 7946 //
     /* 1256783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1256800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1256839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256861 */     // GIR_Coverage, 7946,
     /* 1256861 */     GIR_EraseRootFromParent_Done,
     /* 1256862 */   // Label 18130: @1256862
     /* 1256862 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1256946), // Rule ID 7947 //
     /* 1256867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1256884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1256923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256945 */     // GIR_Coverage, 7947,
     /* 1256945 */     GIR_EraseRootFromParent_Done,
     /* 1256946 */   // Label 18131: @1256946
     /* 1256946 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1257030), // Rule ID 7950 //
     /* 1256951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1256968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1257007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257029 */     // GIR_Coverage, 7950,
     /* 1257029 */     GIR_EraseRootFromParent_Done,
     /* 1257030 */   // Label 18132: @1257030
     /* 1257030 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1257114), // Rule ID 7951 //
     /* 1257035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1257052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1257073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1257091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257113 */     // GIR_Coverage, 7951,
     /* 1257113 */     GIR_EraseRootFromParent_Done,
     /* 1257114 */   // Label 18133: @1257114
     /* 1257114 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1257198), // Rule ID 7954 //
     /* 1257119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1257130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1257133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1257136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1257142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1257175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257197 */     // GIR_Coverage, 7954,
     /* 1257197 */     GIR_EraseRootFromParent_Done,
     /* 1257198 */   // Label 18134: @1257198
     /* 1257198 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1257282), // Rule ID 7955 //
     /* 1257203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1257214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1257217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1257220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1257226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1257259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257281 */     // GIR_Coverage, 7955,
     /* 1257281 */     GIR_EraseRootFromParent_Done,
     /* 1257282 */   // Label 18135: @1257282
     /* 1257282 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1257366), // Rule ID 7958 //
     /* 1257287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1257304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1257343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257365 */     // GIR_Coverage, 7958,
     /* 1257365 */     GIR_EraseRootFromParent_Done,
     /* 1257366 */   // Label 18136: @1257366
     /* 1257366 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1257450), // Rule ID 7959 //
     /* 1257371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1257388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1257409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1257427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257449 */     // GIR_Coverage, 7959,
     /* 1257449 */     GIR_EraseRootFromParent_Done,
     /* 1257450 */   // Label 18137: @1257450
     /* 1257450 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1257534), // Rule ID 7962 //
     /* 1257455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1257472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1257493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1257511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257533 */     // GIR_Coverage, 7962,
     /* 1257533 */     GIR_EraseRootFromParent_Done,
     /* 1257534 */   // Label 18138: @1257534
     /* 1257534 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1257618), // Rule ID 7963 //
     /* 1257539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1257556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1257577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257592 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1257595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257617 */     // GIR_Coverage, 7963,
     /* 1257617 */     GIR_EraseRootFromParent_Done,
     /* 1257618 */   // Label 18139: @1257618
     /* 1257618 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1257702), // Rule ID 7966 //
     /* 1257623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1257640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1257679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257701 */     // GIR_Coverage, 7966,
     /* 1257701 */     GIR_EraseRootFromParent_Done,
     /* 1257702 */   // Label 18140: @1257702
     /* 1257702 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1257786), // Rule ID 7967 //
     /* 1257707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1257724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1257763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257785 */     // GIR_Coverage, 7967,
     /* 1257785 */     GIR_EraseRootFromParent_Done,
     /* 1257786 */   // Label 18141: @1257786
     /* 1257786 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1257870), // Rule ID 8058 //
     /* 1257791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1257808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1257811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1257847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257869 */     // GIR_Coverage, 8058,
     /* 1257869 */     GIR_EraseRootFromParent_Done,
     /* 1257870 */   // Label 18142: @1257870
     /* 1257870 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1257954), // Rule ID 8059 //
     /* 1257875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1257892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1257895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1257931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257953 */     // GIR_Coverage, 8059,
     /* 1257953 */     GIR_EraseRootFromParent_Done,
     /* 1257954 */   // Label 18143: @1257954
     /* 1257954 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1258038), // Rule ID 8062 //
     /* 1257959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1257976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1257979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1258015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258037 */     // GIR_Coverage, 8062,
     /* 1258037 */     GIR_EraseRootFromParent_Done,
     /* 1258038 */   // Label 18144: @1258038
     /* 1258038 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1258122), // Rule ID 8063 //
     /* 1258043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1258060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1258063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1258099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258121 */     // GIR_Coverage, 8063,
     /* 1258121 */     GIR_EraseRootFromParent_Done,
     /* 1258122 */   // Label 18145: @1258122
     /* 1258122 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1258206), // Rule ID 8066 //
     /* 1258127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1258144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1258147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258205 */     // GIR_Coverage, 8066,
     /* 1258205 */     GIR_EraseRootFromParent_Done,
     /* 1258206 */   // Label 18146: @1258206
     /* 1258206 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1258290), // Rule ID 8067 //
     /* 1258211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1258228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1258231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258289 */     // GIR_Coverage, 8067,
     /* 1258289 */     GIR_EraseRootFromParent_Done,
     /* 1258290 */   // Label 18147: @1258290
     /* 1258290 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1258374), // Rule ID 8070 //
     /* 1258295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1258312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1258315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258348 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1258351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258373 */     // GIR_Coverage, 8070,
     /* 1258373 */     GIR_EraseRootFromParent_Done,
     /* 1258374 */   // Label 18148: @1258374
     /* 1258374 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1258458), // Rule ID 8071 //
     /* 1258379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1258396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1258399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1258435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258457 */     // GIR_Coverage, 8071,
     /* 1258457 */     GIR_EraseRootFromParent_Done,
     /* 1258458 */   // Label 18149: @1258458
     /* 1258458 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1258542), // Rule ID 8074 //
     /* 1258463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1258480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1258483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258541 */     // GIR_Coverage, 8074,
     /* 1258541 */     GIR_EraseRootFromParent_Done,
     /* 1258542 */   // Label 18150: @1258542
     /* 1258542 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1258626), // Rule ID 8075 //
     /* 1258547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1258564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1258567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258625 */     // GIR_Coverage, 8075,
     /* 1258625 */     GIR_EraseRootFromParent_Done,
     /* 1258626 */   // Label 18151: @1258626
     /* 1258626 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1258710), // Rule ID 8078 //
     /* 1258631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1258648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1258651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258684 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258709 */     // GIR_Coverage, 8078,
     /* 1258709 */     GIR_EraseRootFromParent_Done,
     /* 1258710 */   // Label 18152: @1258710
     /* 1258710 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1258794), // Rule ID 8079 //
     /* 1258715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1258732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1258735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1258771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258793 */     // GIR_Coverage, 8079,
     /* 1258793 */     GIR_EraseRootFromParent_Done,
     /* 1258794 */   // Label 18153: @1258794
     /* 1258794 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1258878), // Rule ID 8082 //
     /* 1258799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1258816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1258819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1258855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258877 */     // GIR_Coverage, 8082,
     /* 1258877 */     GIR_EraseRootFromParent_Done,
     /* 1258878 */   // Label 18154: @1258878
     /* 1258878 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1258962), // Rule ID 8083 //
     /* 1258883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1258900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1258903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1258939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258961 */     // GIR_Coverage, 8083,
     /* 1258961 */     GIR_EraseRootFromParent_Done,
     /* 1258962 */   // Label 18155: @1258962
     /* 1258962 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1259046), // Rule ID 8086 //
     /* 1258967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1258984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1258987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259045 */     // GIR_Coverage, 8086,
     /* 1259045 */     GIR_EraseRootFromParent_Done,
     /* 1259046 */   // Label 18156: @1259046
     /* 1259046 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1259130), // Rule ID 8087 //
     /* 1259051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1259068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1259071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259129 */     // GIR_Coverage, 8087,
     /* 1259129 */     GIR_EraseRootFromParent_Done,
     /* 1259130 */   // Label 18157: @1259130
     /* 1259130 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1259214), // Rule ID 8090 //
     /* 1259135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1259152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1259155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259213 */     // GIR_Coverage, 8090,
     /* 1259213 */     GIR_EraseRootFromParent_Done,
     /* 1259214 */   // Label 18158: @1259214
     /* 1259214 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1259298), // Rule ID 8091 //
     /* 1259219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1259236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1259239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259272 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259297 */     // GIR_Coverage, 8091,
     /* 1259297 */     GIR_EraseRootFromParent_Done,
     /* 1259298 */   // Label 18159: @1259298
     /* 1259298 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1259382), // Rule ID 8094 //
     /* 1259303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1259314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1259317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1259320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1259323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1259326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259381 */     // GIR_Coverage, 8094,
     /* 1259381 */     GIR_EraseRootFromParent_Done,
     /* 1259382 */   // Label 18160: @1259382
     /* 1259382 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1259466), // Rule ID 8095 //
     /* 1259387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1259398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1259401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1259404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1259407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1259410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259440 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1259443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259465 */     // GIR_Coverage, 8095,
     /* 1259465 */     GIR_EraseRootFromParent_Done,
     /* 1259466 */   // Label 18161: @1259466
     /* 1259466 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1259550), // Rule ID 8098 //
     /* 1259471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1259488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1259491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1259527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259549 */     // GIR_Coverage, 8098,
     /* 1259549 */     GIR_EraseRootFromParent_Done,
     /* 1259550 */   // Label 18162: @1259550
     /* 1259550 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1259634), // Rule ID 8099 //
     /* 1259555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1259572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1259575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1259611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259633 */     // GIR_Coverage, 8099,
     /* 1259633 */     GIR_EraseRootFromParent_Done,
     /* 1259634 */   // Label 18163: @1259634
     /* 1259634 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1259718), // Rule ID 8102 //
     /* 1259639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1259656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1259659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259692 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1259695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259717 */     // GIR_Coverage, 8102,
     /* 1259717 */     GIR_EraseRootFromParent_Done,
     /* 1259718 */   // Label 18164: @1259718
     /* 1259718 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1259802), // Rule ID 8103 //
     /* 1259723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1259740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1259743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259776 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1259779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259801 */     // GIR_Coverage, 8103,
     /* 1259801 */     GIR_EraseRootFromParent_Done,
     /* 1259802 */   // Label 18165: @1259802
     /* 1259802 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1259886), // Rule ID 8106 //
     /* 1259807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1259818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1259821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1259824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1259827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1259830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259860 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1259863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259885 */     // GIR_Coverage, 8106,
     /* 1259885 */     GIR_EraseRootFromParent_Done,
     /* 1259886 */   // Label 18166: @1259886
     /* 1259886 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1259970), // Rule ID 8107 //
     /* 1259891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1259902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1259905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1259908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1259911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1259914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259944 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1259947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259969 */     // GIR_Coverage, 8107,
     /* 1259969 */     GIR_EraseRootFromParent_Done,
     /* 1259970 */   // Label 18167: @1259970
     /* 1259970 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1260054), // Rule ID 8110 //
     /* 1259975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1259995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1260031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260053 */     // GIR_Coverage, 8110,
     /* 1260053 */     GIR_EraseRootFromParent_Done,
     /* 1260054 */   // Label 18168: @1260054
     /* 1260054 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1260138), // Rule ID 8111 //
     /* 1260059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1260076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1260079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1260115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260137 */     // GIR_Coverage, 8111,
     /* 1260137 */     GIR_EraseRootFromParent_Done,
     /* 1260138 */   // Label 18169: @1260138
     /* 1260138 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1260222), // Rule ID 8114 //
     /* 1260143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1260160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1260163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1260199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260221 */     // GIR_Coverage, 8114,
     /* 1260221 */     GIR_EraseRootFromParent_Done,
     /* 1260222 */   // Label 18170: @1260222
     /* 1260222 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1260306), // Rule ID 8115 //
     /* 1260227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1260244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1260247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260280 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1260283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260305 */     // GIR_Coverage, 8115,
     /* 1260305 */     GIR_EraseRootFromParent_Done,
     /* 1260306 */   // Label 18171: @1260306
     /* 1260306 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1260390), // Rule ID 8118 //
     /* 1260311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1260322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1260325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1260328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1260331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1260334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1260367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260389 */     // GIR_Coverage, 8118,
     /* 1260389 */     GIR_EraseRootFromParent_Done,
     /* 1260390 */   // Label 18172: @1260390
     /* 1260390 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1260474), // Rule ID 8119 //
     /* 1260395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1260406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1260409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1260412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1260415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1260418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260448 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1260451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260473 */     // GIR_Coverage, 8119,
     /* 1260473 */     GIR_EraseRootFromParent_Done,
     /* 1260474 */   // Label 18173: @1260474
     /* 1260474 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1260558), // Rule ID 8122 //
     /* 1260479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1260496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1260499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1260535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260557 */     // GIR_Coverage, 8122,
     /* 1260557 */     GIR_EraseRootFromParent_Done,
     /* 1260558 */   // Label 18174: @1260558
     /* 1260558 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1260642), // Rule ID 8123 //
     /* 1260563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1260580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1260583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1260619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260641 */     // GIR_Coverage, 8123,
     /* 1260641 */     GIR_EraseRootFromParent_Done,
     /* 1260642 */   // Label 18175: @1260642
     /* 1260642 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1260726), // Rule ID 8126 //
     /* 1260647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1260664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1260667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1260703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260725 */     // GIR_Coverage, 8126,
     /* 1260725 */     GIR_EraseRootFromParent_Done,
     /* 1260726 */   // Label 18176: @1260726
     /* 1260726 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1260810), // Rule ID 8127 //
     /* 1260731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1260748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1260751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1260787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260809 */     // GIR_Coverage, 8127,
     /* 1260809 */     GIR_EraseRootFromParent_Done,
     /* 1260810 */   // Label 18177: @1260810
     /* 1260810 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1260894), // Rule ID 8130 //
     /* 1260815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1260832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1260835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1260871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260893 */     // GIR_Coverage, 8130,
     /* 1260893 */     GIR_EraseRootFromParent_Done,
     /* 1260894 */   // Label 18178: @1260894
     /* 1260894 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1260978), // Rule ID 8131 //
     /* 1260899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1260916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1260919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1260955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260977 */     // GIR_Coverage, 8131,
     /* 1260977 */     GIR_EraseRootFromParent_Done,
     /* 1260978 */   // Label 18179: @1260978
     /* 1260978 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1261062), // Rule ID 8134 //
     /* 1260983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1261000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1261003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261061 */     // GIR_Coverage, 8134,
     /* 1261061 */     GIR_EraseRootFromParent_Done,
     /* 1261062 */   // Label 18180: @1261062
     /* 1261062 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1261146), // Rule ID 8135 //
     /* 1261067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1261084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1261087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261145 */     // GIR_Coverage, 8135,
     /* 1261145 */     GIR_EraseRootFromParent_Done,
     /* 1261146 */   // Label 18181: @1261146
     /* 1261146 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1261230), // Rule ID 8138 //
     /* 1261151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1261154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1261168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1261171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1261207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261229 */     // GIR_Coverage, 8138,
     /* 1261229 */     GIR_EraseRootFromParent_Done,
     /* 1261230 */   // Label 18182: @1261230
     /* 1261230 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1261314), // Rule ID 8139 //
     /* 1261235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1261252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1261255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1261291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261313 */     // GIR_Coverage, 8139,
     /* 1261313 */     GIR_EraseRootFromParent_Done,
     /* 1261314 */   // Label 18183: @1261314
     /* 1261314 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1261398), // Rule ID 8142 //
     /* 1261319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1261322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1261336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1261339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1261357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1261361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1261375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261397 */     // GIR_Coverage, 8142,
     /* 1261397 */     GIR_EraseRootFromParent_Done,
     /* 1261398 */   // Label 18184: @1261398
     /* 1261398 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1261482), // Rule ID 8143 //
     /* 1261403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1261420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1261423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1261441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1261445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1261459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261481 */     // GIR_Coverage, 8143,
     /* 1261481 */     GIR_EraseRootFromParent_Done,
     /* 1261482 */   // Label 18185: @1261482
     /* 1261482 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1261566), // Rule ID 8146 //
     /* 1261487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1261504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261540 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1261543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261565 */     // GIR_Coverage, 8146,
     /* 1261565 */     GIR_EraseRootFromParent_Done,
     /* 1261566 */   // Label 18186: @1261566
     /* 1261566 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1261650), // Rule ID 8147 //
     /* 1261571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1261588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1261627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261649 */     // GIR_Coverage, 8147,
     /* 1261649 */     GIR_EraseRootFromParent_Done,
     /* 1261650 */   // Label 18187: @1261650
     /* 1261650 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1261734), // Rule ID 8150 //
     /* 1261655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1261672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1261711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261733 */     // GIR_Coverage, 8150,
     /* 1261733 */     GIR_EraseRootFromParent_Done,
     /* 1261734 */   // Label 18188: @1261734
     /* 1261734 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1261818), // Rule ID 8151 //
     /* 1261739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1261756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1261795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261817 */     // GIR_Coverage, 8151,
     /* 1261817 */     GIR_EraseRootFromParent_Done,
     /* 1261818 */   // Label 18189: @1261818
     /* 1261818 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1261902), // Rule ID 8154 //
     /* 1261823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1261840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1261843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1261879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261901 */     // GIR_Coverage, 8154,
     /* 1261901 */     GIR_EraseRootFromParent_Done,
     /* 1261902 */   // Label 18190: @1261902
     /* 1261902 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1261986), // Rule ID 8155 //
     /* 1261907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1261924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1261927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1261949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261960 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1261963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261985 */     // GIR_Coverage, 8155,
     /* 1261985 */     GIR_EraseRootFromParent_Done,
     /* 1261986 */   // Label 18191: @1261986
     /* 1261986 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1262070), // Rule ID 8158 //
     /* 1261991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1262008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1262047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262069 */     // GIR_Coverage, 8158,
     /* 1262069 */     GIR_EraseRootFromParent_Done,
     /* 1262070 */   // Label 18192: @1262070
     /* 1262070 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1262154), // Rule ID 8159 //
     /* 1262075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1262092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1262131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262153 */     // GIR_Coverage, 8159,
     /* 1262153 */     GIR_EraseRootFromParent_Done,
     /* 1262154 */   // Label 18193: @1262154
     /* 1262154 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1262238), // Rule ID 8162 //
     /* 1262159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1262176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1262215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262237 */     // GIR_Coverage, 8162,
     /* 1262237 */     GIR_EraseRootFromParent_Done,
     /* 1262238 */   // Label 18194: @1262238
     /* 1262238 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1262322), // Rule ID 8163 //
     /* 1262243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1262260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1262299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262321 */     // GIR_Coverage, 8163,
     /* 1262321 */     GIR_EraseRootFromParent_Done,
     /* 1262322 */   // Label 18195: @1262322
     /* 1262322 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1262406), // Rule ID 8166 //
     /* 1262327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1262344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1262383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262405 */     // GIR_Coverage, 8166,
     /* 1262405 */     GIR_EraseRootFromParent_Done,
     /* 1262406 */   // Label 18196: @1262406
     /* 1262406 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1262490), // Rule ID 8167 //
     /* 1262411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1262428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1262467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262489 */     // GIR_Coverage, 8167,
     /* 1262489 */     GIR_EraseRootFromParent_Done,
     /* 1262490 */   // Label 18197: @1262490
     /* 1262490 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1262574), // Rule ID 8170 //
     /* 1262495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1262512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262573 */     // GIR_Coverage, 8170,
     /* 1262573 */     GIR_EraseRootFromParent_Done,
     /* 1262574 */   // Label 18198: @1262574
     /* 1262574 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1262658), // Rule ID 8171 //
     /* 1262579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1262596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262657 */     // GIR_Coverage, 8171,
     /* 1262657 */     GIR_EraseRootFromParent_Done,
     /* 1262658 */   // Label 18199: @1262658
     /* 1262658 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1262742), // Rule ID 8174 //
     /* 1262663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1262680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262741 */     // GIR_Coverage, 8174,
     /* 1262741 */     GIR_EraseRootFromParent_Done,
     /* 1262742 */   // Label 18200: @1262742
     /* 1262742 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1262826), // Rule ID 8175 //
     /* 1262747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1262764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262825 */     // GIR_Coverage, 8175,
     /* 1262825 */     GIR_EraseRootFromParent_Done,
     /* 1262826 */   // Label 18201: @1262826
     /* 1262826 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1262910), // Rule ID 8178 //
     /* 1262831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1262848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1262851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262909 */     // GIR_Coverage, 8178,
     /* 1262909 */     GIR_EraseRootFromParent_Done,
     /* 1262910 */   // Label 18202: @1262910
     /* 1262910 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1262994), // Rule ID 8179 //
     /* 1262915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1262932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1262935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1262957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1262971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262993 */     // GIR_Coverage, 8179,
     /* 1262993 */     GIR_EraseRootFromParent_Done,
     /* 1262994 */   // Label 18203: @1262994
     /* 1262994 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1263078), // Rule ID 8182 //
     /* 1262999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1263016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1263055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263077 */     // GIR_Coverage, 8182,
     /* 1263077 */     GIR_EraseRootFromParent_Done,
     /* 1263078 */   // Label 18204: @1263078
     /* 1263078 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1263162), // Rule ID 8183 //
     /* 1263083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1263100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263136 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1263139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263161 */     // GIR_Coverage, 8183,
     /* 1263161 */     GIR_EraseRootFromParent_Done,
     /* 1263162 */   // Label 18205: @1263162
     /* 1263162 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1263246), // Rule ID 8186 //
     /* 1263167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1263184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1263223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263245 */     // GIR_Coverage, 8186,
     /* 1263245 */     GIR_EraseRootFromParent_Done,
     /* 1263246 */   // Label 18206: @1263246
     /* 1263246 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1263330), // Rule ID 8187 //
     /* 1263251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1263268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263304 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1263307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263329 */     // GIR_Coverage, 8187,
     /* 1263329 */     GIR_EraseRootFromParent_Done,
     /* 1263330 */   // Label 18207: @1263330
     /* 1263330 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1263414), // Rule ID 8190 //
     /* 1263335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1263352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263388 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1263391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263413 */     // GIR_Coverage, 8190,
     /* 1263413 */     GIR_EraseRootFromParent_Done,
     /* 1263414 */   // Label 18208: @1263414
     /* 1263414 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1263498), // Rule ID 8191 //
     /* 1263419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1263436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263472 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1263475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263497 */     // GIR_Coverage, 8191,
     /* 1263497 */     GIR_EraseRootFromParent_Done,
     /* 1263498 */   // Label 18209: @1263498
     /* 1263498 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1263582), // Rule ID 8194 //
     /* 1263503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1263514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1263517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1263520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1263526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263556 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1263559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263581 */     // GIR_Coverage, 8194,
     /* 1263581 */     GIR_EraseRootFromParent_Done,
     /* 1263582 */   // Label 18210: @1263582
     /* 1263582 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1263666), // Rule ID 8195 //
     /* 1263587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1263598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1263601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1263604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1263610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263640 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1263643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263665 */     // GIR_Coverage, 8195,
     /* 1263665 */     GIR_EraseRootFromParent_Done,
     /* 1263666 */   // Label 18211: @1263666
     /* 1263666 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1263750), // Rule ID 8198 //
     /* 1263671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1263688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1263727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263749 */     // GIR_Coverage, 8198,
     /* 1263749 */     GIR_EraseRootFromParent_Done,
     /* 1263750 */   // Label 18212: @1263750
     /* 1263750 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1263834), // Rule ID 8199 //
     /* 1263755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1263772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1263811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263833 */     // GIR_Coverage, 8199,
     /* 1263833 */     GIR_EraseRootFromParent_Done,
     /* 1263834 */   // Label 18213: @1263834
     /* 1263834 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1263918), // Rule ID 8202 //
     /* 1263839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1263856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1263895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263917 */     // GIR_Coverage, 8202,
     /* 1263917 */     GIR_EraseRootFromParent_Done,
     /* 1263918 */   // Label 18214: @1263918
     /* 1263918 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1264002), // Rule ID 8203 //
     /* 1263923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1263940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1263979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264001 */     // GIR_Coverage, 8203,
     /* 1264001 */     GIR_EraseRootFromParent_Done,
     /* 1264002 */   // Label 18215: @1264002
     /* 1264002 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1264086), // Rule ID 8206 //
     /* 1264007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1264018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1264021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1264024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1264030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1264063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264085 */     // GIR_Coverage, 8206,
     /* 1264085 */     GIR_EraseRootFromParent_Done,
     /* 1264086 */   // Label 18216: @1264086
     /* 1264086 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1264170), // Rule ID 8207 //
     /* 1264091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1264102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1264105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1264108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1264114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264144 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1264147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264169 */     // GIR_Coverage, 8207,
     /* 1264169 */     GIR_EraseRootFromParent_Done,
     /* 1264170 */   // Label 18217: @1264170
     /* 1264170 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1264254), // Rule ID 8210 //
     /* 1264175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1264192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1264231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264253 */     // GIR_Coverage, 8210,
     /* 1264253 */     GIR_EraseRootFromParent_Done,
     /* 1264254 */   // Label 18218: @1264254
     /* 1264254 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1264338), // Rule ID 8211 //
     /* 1264259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1264276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264312 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1264315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264337 */     // GIR_Coverage, 8211,
     /* 1264337 */     GIR_EraseRootFromParent_Done,
     /* 1264338 */   // Label 18219: @1264338
     /* 1264338 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1264422), // Rule ID 8214 //
     /* 1264343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1264360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264396 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1264399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264421 */     // GIR_Coverage, 8214,
     /* 1264421 */     GIR_EraseRootFromParent_Done,
     /* 1264422 */   // Label 18220: @1264422
     /* 1264422 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1264506), // Rule ID 8215 //
     /* 1264427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1264444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264480 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1264483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264505 */     // GIR_Coverage, 8215,
     /* 1264505 */     GIR_EraseRootFromParent_Done,
     /* 1264506 */   // Label 18221: @1264506
     /* 1264506 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1264590), // Rule ID 8218 //
     /* 1264511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1264522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1264525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1264528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1264534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1264567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264589 */     // GIR_Coverage, 8218,
     /* 1264589 */     GIR_EraseRootFromParent_Done,
     /* 1264590 */   // Label 18222: @1264590
     /* 1264590 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1264674), // Rule ID 8219 //
     /* 1264595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1264606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1264609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1264612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1264618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1264651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264673 */     // GIR_Coverage, 8219,
     /* 1264673 */     GIR_EraseRootFromParent_Done,
     /* 1264674 */   // Label 18223: @1264674
     /* 1264674 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1264758), // Rule ID 8222 //
     /* 1264679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1264696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1264735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264757 */     // GIR_Coverage, 8222,
     /* 1264757 */     GIR_EraseRootFromParent_Done,
     /* 1264758 */   // Label 18224: @1264758
     /* 1264758 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1264842), // Rule ID 8223 //
     /* 1264763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1264780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1264819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264841 */     // GIR_Coverage, 8223,
     /* 1264841 */     GIR_EraseRootFromParent_Done,
     /* 1264842 */   // Label 18225: @1264842
     /* 1264842 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1264926), // Rule ID 8226 //
     /* 1264847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1264864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1264903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264925 */     // GIR_Coverage, 8226,
     /* 1264925 */     GIR_EraseRootFromParent_Done,
     /* 1264926 */   // Label 18226: @1264926
     /* 1264926 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1265010), // Rule ID 8227 //
     /* 1264931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1264948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1264987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265009 */     // GIR_Coverage, 8227,
     /* 1265009 */     GIR_EraseRootFromParent_Done,
     /* 1265010 */   // Label 18227: @1265010
     /* 1265010 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1265094), // Rule ID 8230 //
     /* 1265015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1265032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265093 */     // GIR_Coverage, 8230,
     /* 1265093 */     GIR_EraseRootFromParent_Done,
     /* 1265094 */   // Label 18228: @1265094
     /* 1265094 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1265178), // Rule ID 8231 //
     /* 1265099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1265116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265177 */     // GIR_Coverage, 8231,
     /* 1265177 */     GIR_EraseRootFromParent_Done,
     /* 1265178 */   // Label 18229: @1265178
     /* 1265178 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1265262), // Rule ID 8322 //
     /* 1265183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1265200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1265203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265236 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1265239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265261 */     // GIR_Coverage, 8322,
     /* 1265261 */     GIR_EraseRootFromParent_Done,
     /* 1265262 */   // Label 18230: @1265262
     /* 1265262 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1265346), // Rule ID 8323 //
     /* 1265267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1265284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1265287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1265323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265345 */     // GIR_Coverage, 8323,
     /* 1265345 */     GIR_EraseRootFromParent_Done,
     /* 1265346 */   // Label 18231: @1265346
     /* 1265346 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1265430), // Rule ID 8326 //
     /* 1265351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1265368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1265371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1265407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265429 */     // GIR_Coverage, 8326,
     /* 1265429 */     GIR_EraseRootFromParent_Done,
     /* 1265430 */   // Label 18232: @1265430
     /* 1265430 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1265514), // Rule ID 8327 //
     /* 1265435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1265452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1265455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1265491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265513 */     // GIR_Coverage, 8327,
     /* 1265513 */     GIR_EraseRootFromParent_Done,
     /* 1265514 */   // Label 18233: @1265514
     /* 1265514 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1265598), // Rule ID 8330 //
     /* 1265519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1265536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1265539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1265575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265597 */     // GIR_Coverage, 8330,
     /* 1265597 */     GIR_EraseRootFromParent_Done,
     /* 1265598 */   // Label 18234: @1265598
     /* 1265598 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1265682), // Rule ID 8331 //
     /* 1265603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1265620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1265623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1265659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265681 */     // GIR_Coverage, 8331,
     /* 1265681 */     GIR_EraseRootFromParent_Done,
     /* 1265682 */   // Label 18235: @1265682
     /* 1265682 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1265766), // Rule ID 8334 //
     /* 1265687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1265704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1265707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1265743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265765 */     // GIR_Coverage, 8334,
     /* 1265765 */     GIR_EraseRootFromParent_Done,
     /* 1265766 */   // Label 18236: @1265766
     /* 1265766 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1265850), // Rule ID 8335 //
     /* 1265771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1265788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1265791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1265827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265849 */     // GIR_Coverage, 8335,
     /* 1265849 */     GIR_EraseRootFromParent_Done,
     /* 1265850 */   // Label 18237: @1265850
     /* 1265850 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1265934), // Rule ID 8338 //
     /* 1265855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1265872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1265875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1265911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265933 */     // GIR_Coverage, 8338,
     /* 1265933 */     GIR_EraseRootFromParent_Done,
     /* 1265934 */   // Label 18238: @1265934
     /* 1265934 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1266018), // Rule ID 8339 //
     /* 1265939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1265956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1265959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265992 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1265995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266017 */     // GIR_Coverage, 8339,
     /* 1266017 */     GIR_EraseRootFromParent_Done,
     /* 1266018 */   // Label 18239: @1266018
     /* 1266018 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1266102), // Rule ID 8342 //
     /* 1266023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1266040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1266043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1266079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266101 */     // GIR_Coverage, 8342,
     /* 1266101 */     GIR_EraseRootFromParent_Done,
     /* 1266102 */   // Label 18240: @1266102
     /* 1266102 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1266186), // Rule ID 8343 //
     /* 1266107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1266124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1266127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1266163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266185 */     // GIR_Coverage, 8343,
     /* 1266185 */     GIR_EraseRootFromParent_Done,
     /* 1266186 */   // Label 18241: @1266186
     /* 1266186 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1266270), // Rule ID 8346 //
     /* 1266191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1266208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266269 */     // GIR_Coverage, 8346,
     /* 1266269 */     GIR_EraseRootFromParent_Done,
     /* 1266270 */   // Label 18242: @1266270
     /* 1266270 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1266354), // Rule ID 8347 //
     /* 1266275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1266292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1266295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266353 */     // GIR_Coverage, 8347,
     /* 1266353 */     GIR_EraseRootFromParent_Done,
     /* 1266354 */   // Label 18243: @1266354
     /* 1266354 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1266438), // Rule ID 8350 //
     /* 1266359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1266376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266437 */     // GIR_Coverage, 8350,
     /* 1266437 */     GIR_EraseRootFromParent_Done,
     /* 1266438 */   // Label 18244: @1266438
     /* 1266438 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1266522), // Rule ID 8351 //
     /* 1266443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1266460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1266463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266521 */     // GIR_Coverage, 8351,
     /* 1266521 */     GIR_EraseRootFromParent_Done,
     /* 1266522 */   // Label 18245: @1266522
     /* 1266522 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1266606), // Rule ID 8354 //
     /* 1266527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1266538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1266541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1266544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1266547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1266550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266605 */     // GIR_Coverage, 8354,
     /* 1266605 */     GIR_EraseRootFromParent_Done,
     /* 1266606 */   // Label 18246: @1266606
     /* 1266606 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1266690), // Rule ID 8355 //
     /* 1266611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1266622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1266625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1266628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1266631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1266634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266664 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266689 */     // GIR_Coverage, 8355,
     /* 1266689 */     GIR_EraseRootFromParent_Done,
     /* 1266690 */   // Label 18247: @1266690
     /* 1266690 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1266774), // Rule ID 8358 //
     /* 1266695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1266698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1266712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1266715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266773 */     // GIR_Coverage, 8358,
     /* 1266773 */     GIR_EraseRootFromParent_Done,
     /* 1266774 */   // Label 18248: @1266774
     /* 1266774 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1266858), // Rule ID 8359 //
     /* 1266779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1266782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1266796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1266799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1266835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266857 */     // GIR_Coverage, 8359,
     /* 1266857 */     GIR_EraseRootFromParent_Done,
     /* 1266858 */   // Label 18249: @1266858
     /* 1266858 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1266942), // Rule ID 8362 //
     /* 1266863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1266880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1266883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1266919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266941 */     // GIR_Coverage, 8362,
     /* 1266941 */     GIR_EraseRootFromParent_Done,
     /* 1266942 */   // Label 18250: @1266942
     /* 1266942 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1267026), // Rule ID 8363 //
     /* 1266947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1266964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1266967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1267003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267025 */     // GIR_Coverage, 8363,
     /* 1267025 */     GIR_EraseRootFromParent_Done,
     /* 1267026 */   // Label 18251: @1267026
     /* 1267026 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1267110), // Rule ID 8366 //
     /* 1267031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1267048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1267051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267084 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1267087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267109 */     // GIR_Coverage, 8366,
     /* 1267109 */     GIR_EraseRootFromParent_Done,
     /* 1267110 */   // Label 18252: @1267110
     /* 1267110 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1267194), // Rule ID 8367 //
     /* 1267115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1267132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1267135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267168 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1267171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267193 */     // GIR_Coverage, 8367,
     /* 1267193 */     GIR_EraseRootFromParent_Done,
     /* 1267194 */   // Label 18253: @1267194
     /* 1267194 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1267278), // Rule ID 8370 //
     /* 1267199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1267210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1267213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1267216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1267219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1267222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267252 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1267255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267277 */     // GIR_Coverage, 8370,
     /* 1267277 */     GIR_EraseRootFromParent_Done,
     /* 1267278 */   // Label 18254: @1267278
     /* 1267278 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1267362), // Rule ID 8371 //
     /* 1267283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1267294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1267297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1267300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1267303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1267306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267336 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1267339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267361 */     // GIR_Coverage, 8371,
     /* 1267361 */     GIR_EraseRootFromParent_Done,
     /* 1267362 */   // Label 18255: @1267362
     /* 1267362 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1267446), // Rule ID 8374 //
     /* 1267367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1267384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1267387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1267423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267445 */     // GIR_Coverage, 8374,
     /* 1267445 */     GIR_EraseRootFromParent_Done,
     /* 1267446 */   // Label 18256: @1267446
     /* 1267446 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1267530), // Rule ID 8375 //
     /* 1267451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1267468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1267471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1267507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267529 */     // GIR_Coverage, 8375,
     /* 1267529 */     GIR_EraseRootFromParent_Done,
     /* 1267530 */   // Label 18257: @1267530
     /* 1267530 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1267614), // Rule ID 8378 //
     /* 1267535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1267552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1267555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1267591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267613 */     // GIR_Coverage, 8378,
     /* 1267613 */     GIR_EraseRootFromParent_Done,
     /* 1267614 */   // Label 18258: @1267614
     /* 1267614 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1267698), // Rule ID 8379 //
     /* 1267619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1267636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1267639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267672 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1267675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267697 */     // GIR_Coverage, 8379,
     /* 1267697 */     GIR_EraseRootFromParent_Done,
     /* 1267698 */   // Label 18259: @1267698
     /* 1267698 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1267782), // Rule ID 8382 //
     /* 1267703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1267720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1267723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267756 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1267759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267781 */     // GIR_Coverage, 8382,
     /* 1267781 */     GIR_EraseRootFromParent_Done,
     /* 1267782 */   // Label 18260: @1267782
     /* 1267782 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1267866), // Rule ID 8383 //
     /* 1267787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1267804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1267807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267840 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1267843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267865 */     // GIR_Coverage, 8383,
     /* 1267865 */     GIR_EraseRootFromParent_Done,
     /* 1267866 */   // Label 18261: @1267866
     /* 1267866 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1267950), // Rule ID 8386 //
     /* 1267871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1267888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1267891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1267927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267949 */     // GIR_Coverage, 8386,
     /* 1267949 */     GIR_EraseRootFromParent_Done,
     /* 1267950 */   // Label 18262: @1267950
     /* 1267950 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1268034), // Rule ID 8387 //
     /* 1267955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1267972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1267975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268008 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1268011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268033 */     // GIR_Coverage, 8387,
     /* 1268033 */     GIR_EraseRootFromParent_Done,
     /* 1268034 */   // Label 18263: @1268034
     /* 1268034 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1268118), // Rule ID 8390 //
     /* 1268039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1268056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1268059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268092 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1268095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268117 */     // GIR_Coverage, 8390,
     /* 1268117 */     GIR_EraseRootFromParent_Done,
     /* 1268118 */   // Label 18264: @1268118
     /* 1268118 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1268202), // Rule ID 8391 //
     /* 1268123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1268140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1268143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268176 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1268179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268201 */     // GIR_Coverage, 8391,
     /* 1268201 */     GIR_EraseRootFromParent_Done,
     /* 1268202 */   // Label 18265: @1268202
     /* 1268202 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1268286), // Rule ID 8394 //
     /* 1268207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1268218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1268221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1268224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1268227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1268230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1268263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268285 */     // GIR_Coverage, 8394,
     /* 1268285 */     GIR_EraseRootFromParent_Done,
     /* 1268286 */   // Label 18266: @1268286
     /* 1268286 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1268370), // Rule ID 8395 //
     /* 1268291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1268302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1268305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1268308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1268311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1268314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268344 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1268347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268369 */     // GIR_Coverage, 8395,
     /* 1268369 */     GIR_EraseRootFromParent_Done,
     /* 1268370 */   // Label 18267: @1268370
     /* 1268370 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1268454), // Rule ID 8398 //
     /* 1268375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1268392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1268395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1268413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1268417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1268431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268453 */     // GIR_Coverage, 8398,
     /* 1268453 */     GIR_EraseRootFromParent_Done,
     /* 1268454 */   // Label 18268: @1268454
     /* 1268454 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1268538), // Rule ID 8399 //
     /* 1268459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1268462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1268476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1268479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1268497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1268501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1268515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268537 */     // GIR_Coverage, 8399,
     /* 1268537 */     GIR_EraseRootFromParent_Done,
     /* 1268538 */   // Label 18269: @1268538
     /* 1268538 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1268622), // Rule ID 8402 //
     /* 1268543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1268560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1268563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1268599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268621 */     // GIR_Coverage, 8402,
     /* 1268621 */     GIR_EraseRootFromParent_Done,
     /* 1268622 */   // Label 18270: @1268622
     /* 1268622 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1268706), // Rule ID 8403 //
     /* 1268627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1268630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1268644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1268647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1268683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268705 */     // GIR_Coverage, 8403,
     /* 1268705 */     GIR_EraseRootFromParent_Done,
     /* 1268706 */   // Label 18271: @1268706
     /* 1268706 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1268790), // Rule ID 8406 //
     /* 1268711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1268728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1268731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1268767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268789 */     // GIR_Coverage, 8406,
     /* 1268789 */     GIR_EraseRootFromParent_Done,
     /* 1268790 */   // Label 18272: @1268790
     /* 1268790 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1268874), // Rule ID 8407 //
     /* 1268795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1268798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1268812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1268815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1268851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268873 */     // GIR_Coverage, 8407,
     /* 1268873 */     GIR_EraseRootFromParent_Done,
     /* 1268874 */   // Label 18273: @1268874
     /* 1268874 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1268958), // Rule ID 8410 //
     /* 1268879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1268896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1268935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268957 */     // GIR_Coverage, 8410,
     /* 1268957 */     GIR_EraseRootFromParent_Done,
     /* 1268958 */   // Label 18274: @1268958
     /* 1268958 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1269042), // Rule ID 8411 //
     /* 1268963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1268980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1269019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269041 */     // GIR_Coverage, 8411,
     /* 1269041 */     GIR_EraseRootFromParent_Done,
     /* 1269042 */   // Label 18275: @1269042
     /* 1269042 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1269126), // Rule ID 8414 //
     /* 1269047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1269064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1269103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269125 */     // GIR_Coverage, 8414,
     /* 1269125 */     GIR_EraseRootFromParent_Done,
     /* 1269126 */   // Label 18276: @1269126
     /* 1269126 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1269210), // Rule ID 8415 //
     /* 1269131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1269148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1269187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269209 */     // GIR_Coverage, 8415,
     /* 1269209 */     GIR_EraseRootFromParent_Done,
     /* 1269210 */   // Label 18277: @1269210
     /* 1269210 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1269294), // Rule ID 8418 //
     /* 1269215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1269232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269293 */     // GIR_Coverage, 8418,
     /* 1269293 */     GIR_EraseRootFromParent_Done,
     /* 1269294 */   // Label 18278: @1269294
     /* 1269294 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1269378), // Rule ID 8419 //
     /* 1269299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1269316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269377 */     // GIR_Coverage, 8419,
     /* 1269377 */     GIR_EraseRootFromParent_Done,
     /* 1269378 */   // Label 18279: @1269378
     /* 1269378 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1269462), // Rule ID 8422 //
     /* 1269383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1269400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1269439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269461 */     // GIR_Coverage, 8422,
     /* 1269461 */     GIR_EraseRootFromParent_Done,
     /* 1269462 */   // Label 18280: @1269462
     /* 1269462 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1269546), // Rule ID 8423 //
     /* 1269467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1269484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1269523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269545 */     // GIR_Coverage, 8423,
     /* 1269545 */     GIR_EraseRootFromParent_Done,
     /* 1269546 */   // Label 18281: @1269546
     /* 1269546 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1269630), // Rule ID 8426 //
     /* 1269551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1269568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269629 */     // GIR_Coverage, 8426,
     /* 1269629 */     GIR_EraseRootFromParent_Done,
     /* 1269630 */   // Label 18282: @1269630
     /* 1269630 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1269714), // Rule ID 8427 //
     /* 1269635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1269652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269713 */     // GIR_Coverage, 8427,
     /* 1269713 */     GIR_EraseRootFromParent_Done,
     /* 1269714 */   // Label 18283: @1269714
     /* 1269714 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1269798), // Rule ID 8430 //
     /* 1269719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1269736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269797 */     // GIR_Coverage, 8430,
     /* 1269797 */     GIR_EraseRootFromParent_Done,
     /* 1269798 */   // Label 18284: @1269798
     /* 1269798 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1269882), // Rule ID 8431 //
     /* 1269803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1269820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269856 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1269859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269881 */     // GIR_Coverage, 8431,
     /* 1269881 */     GIR_EraseRootFromParent_Done,
     /* 1269882 */   // Label 18285: @1269882
     /* 1269882 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1269966), // Rule ID 8434 //
     /* 1269887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1269907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1269929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1269943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269965 */     // GIR_Coverage, 8434,
     /* 1269965 */     GIR_EraseRootFromParent_Done,
     /* 1269966 */   // Label 18286: @1269966
     /* 1269966 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1270050), // Rule ID 8435 //
     /* 1269971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1269991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270049 */     // GIR_Coverage, 8435,
     /* 1270049 */     GIR_EraseRootFromParent_Done,
     /* 1270050 */   // Label 18287: @1270050
     /* 1270050 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1270134), // Rule ID 8438 //
     /* 1270055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1270072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270133 */     // GIR_Coverage, 8438,
     /* 1270133 */     GIR_EraseRootFromParent_Done,
     /* 1270134 */   // Label 18288: @1270134
     /* 1270134 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1270218), // Rule ID 8439 //
     /* 1270139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1270156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270217 */     // GIR_Coverage, 8439,
     /* 1270217 */     GIR_EraseRootFromParent_Done,
     /* 1270218 */   // Label 18289: @1270218
     /* 1270218 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1270302), // Rule ID 8442 //
     /* 1270223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1270240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270301 */     // GIR_Coverage, 8442,
     /* 1270301 */     GIR_EraseRootFromParent_Done,
     /* 1270302 */   // Label 18290: @1270302
     /* 1270302 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1270386), // Rule ID 8443 //
     /* 1270307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1270324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270385 */     // GIR_Coverage, 8443,
     /* 1270385 */     GIR_EraseRootFromParent_Done,
     /* 1270386 */   // Label 18291: @1270386
     /* 1270386 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1270470), // Rule ID 8446 //
     /* 1270391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1270402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1270405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1270408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1270414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270469 */     // GIR_Coverage, 8446,
     /* 1270469 */     GIR_EraseRootFromParent_Done,
     /* 1270470 */   // Label 18292: @1270470
     /* 1270470 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1270554), // Rule ID 8447 //
     /* 1270475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1270486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1270489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1270492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1270498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270528 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1270531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270553 */     // GIR_Coverage, 8447,
     /* 1270553 */     GIR_EraseRootFromParent_Done,
     /* 1270554 */   // Label 18293: @1270554
     /* 1270554 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1270638), // Rule ID 8450 //
     /* 1270559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1270576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1270615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270637 */     // GIR_Coverage, 8450,
     /* 1270637 */     GIR_EraseRootFromParent_Done,
     /* 1270638 */   // Label 18294: @1270638
     /* 1270638 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1270722), // Rule ID 8451 //
     /* 1270643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1270660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1270699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270721 */     // GIR_Coverage, 8451,
     /* 1270721 */     GIR_EraseRootFromParent_Done,
     /* 1270722 */   // Label 18295: @1270722
     /* 1270722 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1270806), // Rule ID 8454 //
     /* 1270727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1270744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270780 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1270783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270805 */     // GIR_Coverage, 8454,
     /* 1270805 */     GIR_EraseRootFromParent_Done,
     /* 1270806 */   // Label 18296: @1270806
     /* 1270806 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1270890), // Rule ID 8455 //
     /* 1270811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1270828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270864 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1270867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270889 */     // GIR_Coverage, 8455,
     /* 1270889 */     GIR_EraseRootFromParent_Done,
     /* 1270890 */   // Label 18297: @1270890
     /* 1270890 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1270974), // Rule ID 8458 //
     /* 1270895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1270906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1270909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1270915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1270937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270948 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1270951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270973 */     // GIR_Coverage, 8458,
     /* 1270973 */     GIR_EraseRootFromParent_Done,
     /* 1270974 */   // Label 18298: @1270974
     /* 1270974 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1271058), // Rule ID 8459 //
     /* 1270979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1270990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1270993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1270999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1271002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271032 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1271035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271057 */     // GIR_Coverage, 8459,
     /* 1271057 */     GIR_EraseRootFromParent_Done,
     /* 1271058 */   // Label 18299: @1271058
     /* 1271058 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1271142), // Rule ID 8462 //
     /* 1271063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1271080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1271119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271141 */     // GIR_Coverage, 8462,
     /* 1271141 */     GIR_EraseRootFromParent_Done,
     /* 1271142 */   // Label 18300: @1271142
     /* 1271142 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1271226), // Rule ID 8463 //
     /* 1271147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1271164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271200 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1271203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271225 */     // GIR_Coverage, 8463,
     /* 1271225 */     GIR_EraseRootFromParent_Done,
     /* 1271226 */   // Label 18301: @1271226
     /* 1271226 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1271310), // Rule ID 8466 //
     /* 1271231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1271248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1271287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271309 */     // GIR_Coverage, 8466,
     /* 1271309 */     GIR_EraseRootFromParent_Done,
     /* 1271310 */   // Label 18302: @1271310
     /* 1271310 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1271394), // Rule ID 8467 //
     /* 1271315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1271332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1271371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271393 */     // GIR_Coverage, 8467,
     /* 1271393 */     GIR_EraseRootFromParent_Done,
     /* 1271394 */   // Label 18303: @1271394
     /* 1271394 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1271478), // Rule ID 8470 //
     /* 1271399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1271410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1271413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1271416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1271422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271452 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1271455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271477 */     // GIR_Coverage, 8470,
     /* 1271477 */     GIR_EraseRootFromParent_Done,
     /* 1271478 */   // Label 18304: @1271478
     /* 1271478 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1271562), // Rule ID 8471 //
     /* 1271483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1271494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1271497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1271500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1271506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271536 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1271539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271561 */     // GIR_Coverage, 8471,
     /* 1271561 */     GIR_EraseRootFromParent_Done,
     /* 1271562 */   // Label 18305: @1271562
     /* 1271562 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1271646), // Rule ID 8474 //
     /* 1271567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1271584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1271623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271645 */     // GIR_Coverage, 8474,
     /* 1271645 */     GIR_EraseRootFromParent_Done,
     /* 1271646 */   // Label 18306: @1271646
     /* 1271646 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1271730), // Rule ID 8475 //
     /* 1271651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1271668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271704 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1271707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271729 */     // GIR_Coverage, 8475,
     /* 1271729 */     GIR_EraseRootFromParent_Done,
     /* 1271730 */   // Label 18307: @1271730
     /* 1271730 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1271814), // Rule ID 8478 //
     /* 1271735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1271752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1271791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271813 */     // GIR_Coverage, 8478,
     /* 1271813 */     GIR_EraseRootFromParent_Done,
     /* 1271814 */   // Label 18308: @1271814
     /* 1271814 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1271898), // Rule ID 8479 //
     /* 1271819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1271836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1271875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271897 */     // GIR_Coverage, 8479,
     /* 1271897 */     GIR_EraseRootFromParent_Done,
     /* 1271898 */   // Label 18309: @1271898
     /* 1271898 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1271982), // Rule ID 8482 //
     /* 1271903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1271959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271981 */     // GIR_Coverage, 8482,
     /* 1271981 */     GIR_EraseRootFromParent_Done,
     /* 1271982 */   // Label 18310: @1271982
     /* 1271982 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1272066), // Rule ID 8483 //
     /* 1271987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1272004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1272025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1272043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272065 */     // GIR_Coverage, 8483,
     /* 1272065 */     GIR_EraseRootFromParent_Done,
     /* 1272066 */   // Label 18311: @1272066
     /* 1272066 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1272150), // Rule ID 8486 //
     /* 1272071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1272088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272149 */     // GIR_Coverage, 8486,
     /* 1272149 */     GIR_EraseRootFromParent_Done,
     /* 1272150 */   // Label 18312: @1272150
     /* 1272150 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1272234), // Rule ID 8487 //
     /* 1272155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1272172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272233 */     // GIR_Coverage, 8487,
     /* 1272233 */     GIR_EraseRootFromParent_Done,
     /* 1272234 */   // Label 18313: @1272234
     /* 1272234 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1272318), // Rule ID 8490 //
     /* 1272239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1272256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1272277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1272295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272317 */     // GIR_Coverage, 8490,
     /* 1272317 */     GIR_EraseRootFromParent_Done,
     /* 1272318 */   // Label 18314: @1272318
     /* 1272318 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1272402), // Rule ID 8491 //
     /* 1272323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1272340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1272361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1272379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272401 */     // GIR_Coverage, 8491,
     /* 1272401 */     GIR_EraseRootFromParent_Done,
     /* 1272402 */   // Label 18315: @1272402
     /* 1272402 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1272486), // Rule ID 8494 //
     /* 1272407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1272424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1272445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1272463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272485 */     // GIR_Coverage, 8494,
     /* 1272485 */     GIR_EraseRootFromParent_Done,
     /* 1272486 */   // Label 18316: @1272486
     /* 1272486 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1272570), // Rule ID 8495 //
     /* 1272491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1272508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1272529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1272547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272569 */     // GIR_Coverage, 8495,
     /* 1272569 */     GIR_EraseRootFromParent_Done,
     /* 1272570 */   // Label 18317: @1272570
     /* 1272570 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1272654), // Rule ID 8498 //
     /* 1272575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1272592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1272595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1272631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272653 */     // GIR_Coverage, 8498,
     /* 1272653 */     GIR_EraseRootFromParent_Done,
     /* 1272654 */   // Label 18318: @1272654
     /* 1272654 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1272738), // Rule ID 8499 //
     /* 1272659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1272676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1272679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1272715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272737 */     // GIR_Coverage, 8499,
     /* 1272737 */     GIR_EraseRootFromParent_Done,
     /* 1272738 */   // Label 18319: @1272738
     /* 1272738 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1272822), // Rule ID 8502 //
     /* 1272743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1272760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1272763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1272799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272821 */     // GIR_Coverage, 8502,
     /* 1272821 */     GIR_EraseRootFromParent_Done,
     /* 1272822 */   // Label 18320: @1272822
     /* 1272822 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1272906), // Rule ID 8503 //
     /* 1272827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1272844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1272847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1272883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272905 */     // GIR_Coverage, 8503,
     /* 1272905 */     GIR_EraseRootFromParent_Done,
     /* 1272906 */   // Label 18321: @1272906
     /* 1272906 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1272990), // Rule ID 8506 //
     /* 1272911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1272931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1272967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272989 */     // GIR_Coverage, 8506,
     /* 1272989 */     GIR_EraseRootFromParent_Done,
     /* 1272990 */   // Label 18322: @1272990
     /* 1272990 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1273074), // Rule ID 8507 //
     /* 1272995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1273012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1273015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273048 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1273051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273073 */     // GIR_Coverage, 8507,
     /* 1273073 */     GIR_EraseRootFromParent_Done,
     /* 1273074 */   // Label 18323: @1273074
     /* 1273074 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1273158), // Rule ID 8510 //
     /* 1273079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1273096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1273099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273132 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1273135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273157 */     // GIR_Coverage, 8510,
     /* 1273157 */     GIR_EraseRootFromParent_Done,
     /* 1273158 */   // Label 18324: @1273158
     /* 1273158 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1273242), // Rule ID 8511 //
     /* 1273163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1273180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1273183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273216 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1273219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273241 */     // GIR_Coverage, 8511,
     /* 1273241 */     GIR_EraseRootFromParent_Done,
     /* 1273242 */   // Label 18325: @1273242
     /* 1273242 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1273326), // Rule ID 8514 //
     /* 1273247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1273264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1273267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1273303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273325 */     // GIR_Coverage, 8514,
     /* 1273325 */     GIR_EraseRootFromParent_Done,
     /* 1273326 */   // Label 18326: @1273326
     /* 1273326 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1273410), // Rule ID 8515 //
     /* 1273331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1273348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1273351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1273387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273409 */     // GIR_Coverage, 8515,
     /* 1273409 */     GIR_EraseRootFromParent_Done,
     /* 1273410 */   // Label 18327: @1273410
     /* 1273410 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1273494), // Rule ID 8518 //
     /* 1273415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1273432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1273435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1273471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273493 */     // GIR_Coverage, 8518,
     /* 1273493 */     GIR_EraseRootFromParent_Done,
     /* 1273494 */   // Label 18328: @1273494
     /* 1273494 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1273578), // Rule ID 8519 //
     /* 1273499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1273516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1273519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1273555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273577 */     // GIR_Coverage, 8519,
     /* 1273577 */     GIR_EraseRootFromParent_Done,
     /* 1273578 */   // Label 18329: @1273578
     /* 1273578 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1273662), // Rule ID 8522 //
     /* 1273583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1273600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1273639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273661 */     // GIR_Coverage, 8522,
     /* 1273661 */     GIR_EraseRootFromParent_Done,
     /* 1273662 */   // Label 18330: @1273662
     /* 1273662 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1273746), // Rule ID 8523 //
     /* 1273667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1273684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1273687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1273723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273745 */     // GIR_Coverage, 8523,
     /* 1273745 */     GIR_EraseRootFromParent_Done,
     /* 1273746 */   // Label 18331: @1273746
     /* 1273746 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1273830), // Rule ID 8526 //
     /* 1273751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1273768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1273771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1273807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273829 */     // GIR_Coverage, 8526,
     /* 1273829 */     GIR_EraseRootFromParent_Done,
     /* 1273830 */   // Label 18332: @1273830
     /* 1273830 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1273914), // Rule ID 8527 //
     /* 1273835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1273852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1273855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1273891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273913 */     // GIR_Coverage, 8527,
     /* 1273913 */     GIR_EraseRootFromParent_Done,
     /* 1273914 */   // Label 18333: @1273914
     /* 1273914 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1273998), // Rule ID 8530 //
     /* 1273919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1273939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1273975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273997 */     // GIR_Coverage, 8530,
     /* 1273997 */     GIR_EraseRootFromParent_Done,
     /* 1273998 */   // Label 18334: @1273998
     /* 1273998 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1274082), // Rule ID 8531 //
     /* 1274003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1274020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1274023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1274059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274081 */     // GIR_Coverage, 8531,
     /* 1274081 */     GIR_EraseRootFromParent_Done,
     /* 1274082 */   // Label 18335: @1274082
     /* 1274082 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1274166), // Rule ID 8534 //
     /* 1274087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1274104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1274107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1274143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274165 */     // GIR_Coverage, 8534,
     /* 1274165 */     GIR_EraseRootFromParent_Done,
     /* 1274166 */   // Label 18336: @1274166
     /* 1274166 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1274250), // Rule ID 8535 //
     /* 1274171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1274188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1274191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1274227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274249 */     // GIR_Coverage, 8535,
     /* 1274249 */     GIR_EraseRootFromParent_Done,
     /* 1274250 */   // Label 18337: @1274250
     /* 1274250 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1274334), // Rule ID 8538 //
     /* 1274255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1274272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1274275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1274311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274333 */     // GIR_Coverage, 8538,
     /* 1274333 */     GIR_EraseRootFromParent_Done,
     /* 1274334 */   // Label 18338: @1274334
     /* 1274334 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1274418), // Rule ID 8539 //
     /* 1274339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1274356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1274359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1274395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274417 */     // GIR_Coverage, 8539,
     /* 1274417 */     GIR_EraseRootFromParent_Done,
     /* 1274418 */   // Label 18339: @1274418
     /* 1274418 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1274502), // Rule ID 8542 //
     /* 1274423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1274440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1274443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1274479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274501 */     // GIR_Coverage, 8542,
     /* 1274501 */     GIR_EraseRootFromParent_Done,
     /* 1274502 */   // Label 18340: @1274502
     /* 1274502 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1274586), // Rule ID 8543 //
     /* 1274507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1274524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1274527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274560 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1274563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274585 */     // GIR_Coverage, 8543,
     /* 1274585 */     GIR_EraseRootFromParent_Done,
     /* 1274586 */   // Label 18341: @1274586
     /* 1274586 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1274670), // Rule ID 8546 //
     /* 1274591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1274602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1274605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1274608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1274611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1274614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274644 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1274647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274669 */     // GIR_Coverage, 8546,
     /* 1274669 */     GIR_EraseRootFromParent_Done,
     /* 1274670 */   // Label 18342: @1274670
     /* 1274670 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1274754), // Rule ID 8547 //
     /* 1274675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1274686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1274689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1274692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1274695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1274698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274728 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1274731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274753 */     // GIR_Coverage, 8547,
     /* 1274753 */     GIR_EraseRootFromParent_Done,
     /* 1274754 */   // Label 18343: @1274754
     /* 1274754 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1274838), // Rule ID 8550 //
     /* 1274759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1274776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1274779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1274815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274837 */     // GIR_Coverage, 8550,
     /* 1274837 */     GIR_EraseRootFromParent_Done,
     /* 1274838 */   // Label 18344: @1274838
     /* 1274838 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1274922), // Rule ID 8551 //
     /* 1274843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1274860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1274863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1274899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274921 */     // GIR_Coverage, 8551,
     /* 1274921 */     GIR_EraseRootFromParent_Done,
     /* 1274922 */   // Label 18345: @1274922
     /* 1274922 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1275006), // Rule ID 8554 //
     /* 1274927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1274947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1274983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275005 */     // GIR_Coverage, 8554,
     /* 1275005 */     GIR_EraseRootFromParent_Done,
     /* 1275006 */   // Label 18346: @1275006
     /* 1275006 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1275090), // Rule ID 8555 //
     /* 1275011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1275022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1275025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1275028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1275031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1275034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275064 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1275067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275089 */     // GIR_Coverage, 8555,
     /* 1275089 */     GIR_EraseRootFromParent_Done,
     /* 1275090 */   // Label 18347: @1275090
     /* 1275090 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1275174), // Rule ID 8558 //
     /* 1275095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1275106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1275109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1275112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1275115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1275118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1275151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275173 */     // GIR_Coverage, 8558,
     /* 1275173 */     GIR_EraseRootFromParent_Done,
     /* 1275174 */   // Label 18348: @1275174
     /* 1275174 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1275258), // Rule ID 8559 //
     /* 1275179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1275190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1275193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1275196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1275199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1275202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275232 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1275235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275257 */     // GIR_Coverage, 8559,
     /* 1275257 */     GIR_EraseRootFromParent_Done,
     /* 1275258 */   // Label 18349: @1275258
     /* 1275258 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1275342), // Rule ID 8562 //
     /* 1275263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1275280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1275283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1275319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275341 */     // GIR_Coverage, 8562,
     /* 1275341 */     GIR_EraseRootFromParent_Done,
     /* 1275342 */   // Label 18350: @1275342
     /* 1275342 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1275426), // Rule ID 8563 //
     /* 1275347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1275364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1275367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1275403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275425 */     // GIR_Coverage, 8563,
     /* 1275425 */     GIR_EraseRootFromParent_Done,
     /* 1275426 */   // Label 18351: @1275426
     /* 1275426 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1275510), // Rule ID 8566 //
     /* 1275431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1275448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1275451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1275487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275509 */     // GIR_Coverage, 8566,
     /* 1275509 */     GIR_EraseRootFromParent_Done,
     /* 1275510 */   // Label 18352: @1275510
     /* 1275510 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1275594), // Rule ID 8567 //
     /* 1275515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1275532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1275535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275568 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1275571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275593 */     // GIR_Coverage, 8567,
     /* 1275593 */     GIR_EraseRootFromParent_Done,
     /* 1275594 */   // Label 18353: @1275594
     /* 1275594 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1275678), // Rule ID 8570 //
     /* 1275599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1275610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1275613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1275616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1275619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1275622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1275655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275677 */     // GIR_Coverage, 8570,
     /* 1275677 */     GIR_EraseRootFromParent_Done,
     /* 1275678 */   // Label 18354: @1275678
     /* 1275678 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1275762), // Rule ID 8571 //
     /* 1275683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1275694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1275697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1275700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1275703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1275706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1275739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275761 */     // GIR_Coverage, 8571,
     /* 1275761 */     GIR_EraseRootFromParent_Done,
     /* 1275762 */   // Label 18355: @1275762
     /* 1275762 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1275846), // Rule ID 8574 //
     /* 1275767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1275784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1275787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1275823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275845 */     // GIR_Coverage, 8574,
     /* 1275845 */     GIR_EraseRootFromParent_Done,
     /* 1275846 */   // Label 18356: @1275846
     /* 1275846 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1275930), // Rule ID 8575 //
     /* 1275851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1275868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1275871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1275907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275929 */     // GIR_Coverage, 8575,
     /* 1275929 */     GIR_EraseRootFromParent_Done,
     /* 1275930 */   // Label 18357: @1275930
     /* 1275930 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1276014), // Rule ID 8578 //
     /* 1275935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1275955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275988 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1275991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276013 */     // GIR_Coverage, 8578,
     /* 1276013 */     GIR_EraseRootFromParent_Done,
     /* 1276014 */   // Label 18358: @1276014
     /* 1276014 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1276098), // Rule ID 8579 //
     /* 1276019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1276036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1276039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276072 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1276075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276097 */     // GIR_Coverage, 8579,
     /* 1276097 */     GIR_EraseRootFromParent_Done,
     /* 1276098 */   // Label 18359: @1276098
     /* 1276098 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1276182), // Rule ID 8582 //
     /* 1276103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1276120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1276123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276181 */     // GIR_Coverage, 8582,
     /* 1276181 */     GIR_EraseRootFromParent_Done,
     /* 1276182 */   // Label 18360: @1276182
     /* 1276182 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1276266), // Rule ID 8583 //
     /* 1276187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1276204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1276207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276265 */     // GIR_Coverage, 8583,
     /* 1276265 */     GIR_EraseRootFromParent_Done,
     /* 1276266 */   // Label 18361: @1276266
     /* 1276266 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1276350), // Rule ID 8586 //
     /* 1276271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1276288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276324 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1276327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276349 */     // GIR_Coverage, 8586,
     /* 1276349 */     GIR_EraseRootFromParent_Done,
     /* 1276350 */   // Label 18362: @1276350
     /* 1276350 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1276434), // Rule ID 8587 //
     /* 1276355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1276372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1276411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276433 */     // GIR_Coverage, 8587,
     /* 1276433 */     GIR_EraseRootFromParent_Done,
     /* 1276434 */   // Label 18363: @1276434
     /* 1276434 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1276518), // Rule ID 8590 //
     /* 1276439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1276456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1276495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276517 */     // GIR_Coverage, 8590,
     /* 1276517 */     GIR_EraseRootFromParent_Done,
     /* 1276518 */   // Label 18364: @1276518
     /* 1276518 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1276602), // Rule ID 8591 //
     /* 1276523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1276540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276576 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1276579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276601 */     // GIR_Coverage, 8591,
     /* 1276601 */     GIR_EraseRootFromParent_Done,
     /* 1276602 */   // Label 18365: @1276602
     /* 1276602 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1276686), // Rule ID 8594 //
     /* 1276607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1276624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1276663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276685 */     // GIR_Coverage, 8594,
     /* 1276685 */     GIR_EraseRootFromParent_Done,
     /* 1276686 */   // Label 18366: @1276686
     /* 1276686 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1276770), // Rule ID 8595 //
     /* 1276691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1276708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1276747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276769 */     // GIR_Coverage, 8595,
     /* 1276769 */     GIR_EraseRootFromParent_Done,
     /* 1276770 */   // Label 18367: @1276770
     /* 1276770 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1276854), // Rule ID 8598 //
     /* 1276775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1276792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276828 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1276831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276853 */     // GIR_Coverage, 8598,
     /* 1276853 */     GIR_EraseRootFromParent_Done,
     /* 1276854 */   // Label 18368: @1276854
     /* 1276854 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1276938), // Rule ID 8599 //
     /* 1276859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1276876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1276879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276912 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1276915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276937 */     // GIR_Coverage, 8599,
     /* 1276937 */     GIR_EraseRootFromParent_Done,
     /* 1276938 */   // Label 18369: @1276938
     /* 1276938 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1277022), // Rule ID 8602 //
     /* 1276943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1276963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1276985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1276999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277021 */     // GIR_Coverage, 8602,
     /* 1277021 */     GIR_EraseRootFromParent_Done,
     /* 1277022 */   // Label 18370: @1277022
     /* 1277022 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1277106), // Rule ID 8603 //
     /* 1277027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1277038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1277041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1277044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1277050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277080 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1277083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277105 */     // GIR_Coverage, 8603,
     /* 1277105 */     GIR_EraseRootFromParent_Done,
     /* 1277106 */   // Label 18371: @1277106
     /* 1277106 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1277190), // Rule ID 8606 //
     /* 1277111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1277128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1277167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277189 */     // GIR_Coverage, 8606,
     /* 1277189 */     GIR_EraseRootFromParent_Done,
     /* 1277190 */   // Label 18372: @1277190
     /* 1277190 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1277274), // Rule ID 8607 //
     /* 1277195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1277212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1277251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277273 */     // GIR_Coverage, 8607,
     /* 1277273 */     GIR_EraseRootFromParent_Done,
     /* 1277274 */   // Label 18373: @1277274
     /* 1277274 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1277358), // Rule ID 8610 //
     /* 1277279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1277296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277357 */     // GIR_Coverage, 8610,
     /* 1277357 */     GIR_EraseRootFromParent_Done,
     /* 1277358 */   // Label 18374: @1277358
     /* 1277358 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1277442), // Rule ID 8611 //
     /* 1277363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1277380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277441 */     // GIR_Coverage, 8611,
     /* 1277441 */     GIR_EraseRootFromParent_Done,
     /* 1277442 */   // Label 18375: @1277442
     /* 1277442 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1277526), // Rule ID 8614 //
     /* 1277447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1277464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277525 */     // GIR_Coverage, 8614,
     /* 1277525 */     GIR_EraseRootFromParent_Done,
     /* 1277526 */   // Label 18376: @1277526
     /* 1277526 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1277610), // Rule ID 8615 //
     /* 1277531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1277548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277609 */     // GIR_Coverage, 8615,
     /* 1277609 */     GIR_EraseRootFromParent_Done,
     /* 1277610 */   // Label 18377: @1277610
     /* 1277610 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1277694), // Rule ID 8618 //
     /* 1277615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1277626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1277629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1277632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1277638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277693 */     // GIR_Coverage, 8618,
     /* 1277693 */     GIR_EraseRootFromParent_Done,
     /* 1277694 */   // Label 18378: @1277694
     /* 1277694 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1277778), // Rule ID 8619 //
     /* 1277699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1277710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1277713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1277716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1277722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277777 */     // GIR_Coverage, 8619,
     /* 1277777 */     GIR_EraseRootFromParent_Done,
     /* 1277778 */   // Label 18379: @1277778
     /* 1277778 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1277862), // Rule ID 8622 //
     /* 1277783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1277786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1277800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277836 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1277857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277861 */     // GIR_Coverage, 8622,
     /* 1277861 */     GIR_EraseRootFromParent_Done,
     /* 1277862 */   // Label 18380: @1277862
     /* 1277862 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1277946), // Rule ID 8623 //
     /* 1277867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1277870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1277884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1277887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1277923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1277941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277945 */     // GIR_Coverage, 8623,
     /* 1277945 */     GIR_EraseRootFromParent_Done,
     /* 1277946 */   // Label 18381: @1277946
     /* 1277946 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1278030), // Rule ID 8626 //
     /* 1277951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1277971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1277993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278004 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1278007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278029 */     // GIR_Coverage, 8626,
     /* 1278029 */     GIR_EraseRootFromParent_Done,
     /* 1278030 */   // Label 18382: @1278030
     /* 1278030 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1278114), // Rule ID 8627 //
     /* 1278035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1278052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1278091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278113 */     // GIR_Coverage, 8627,
     /* 1278113 */     GIR_EraseRootFromParent_Done,
     /* 1278114 */   // Label 18383: @1278114
     /* 1278114 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1278198), // Rule ID 8630 //
     /* 1278119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1278136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278172 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1278175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278197 */     // GIR_Coverage, 8630,
     /* 1278197 */     GIR_EraseRootFromParent_Done,
     /* 1278198 */   // Label 18384: @1278198
     /* 1278198 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1278282), // Rule ID 8631 //
     /* 1278203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1278220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278256 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1278259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278281 */     // GIR_Coverage, 8631,
     /* 1278281 */     GIR_EraseRootFromParent_Done,
     /* 1278282 */   // Label 18385: @1278282
     /* 1278282 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1278366), // Rule ID 8634 //
     /* 1278287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1278298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1278301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1278304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1278310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278340 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1278343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278365 */     // GIR_Coverage, 8634,
     /* 1278365 */     GIR_EraseRootFromParent_Done,
     /* 1278366 */   // Label 18386: @1278366
     /* 1278366 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1278450), // Rule ID 8635 //
     /* 1278371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1278382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1278385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1278388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1278394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278424 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1278427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278449 */     // GIR_Coverage, 8635,
     /* 1278449 */     GIR_EraseRootFromParent_Done,
     /* 1278450 */   // Label 18387: @1278450
     /* 1278450 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1278534), // Rule ID 8638 //
     /* 1278455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1278472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1278511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278533 */     // GIR_Coverage, 8638,
     /* 1278533 */     GIR_EraseRootFromParent_Done,
     /* 1278534 */   // Label 18388: @1278534
     /* 1278534 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1278618), // Rule ID 8639 //
     /* 1278539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1278556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1278595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278617 */     // GIR_Coverage, 8639,
     /* 1278617 */     GIR_EraseRootFromParent_Done,
     /* 1278618 */   // Label 18389: @1278618
     /* 1278618 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1278702), // Rule ID 8642 //
     /* 1278623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1278640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1278679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278701 */     // GIR_Coverage, 8642,
     /* 1278701 */     GIR_EraseRootFromParent_Done,
     /* 1278702 */   // Label 18390: @1278702
     /* 1278702 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1278786), // Rule ID 8643 //
     /* 1278707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1278724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278760 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1278763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278785 */     // GIR_Coverage, 8643,
     /* 1278785 */     GIR_EraseRootFromParent_Done,
     /* 1278786 */   // Label 18391: @1278786
     /* 1278786 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1278870), // Rule ID 8646 //
     /* 1278791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1278808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278844 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1278847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278869 */     // GIR_Coverage, 8646,
     /* 1278869 */     GIR_EraseRootFromParent_Done,
     /* 1278870 */   // Label 18392: @1278870
     /* 1278870 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1278954), // Rule ID 8647 //
     /* 1278875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1278892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1278931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278953 */     // GIR_Coverage, 8647,
     /* 1278953 */     GIR_EraseRootFromParent_Done,
     /* 1278954 */   // Label 18393: @1278954
     /* 1278954 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1279038), // Rule ID 8650 //
     /* 1278959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1279015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279037 */     // GIR_Coverage, 8650,
     /* 1279037 */     GIR_EraseRootFromParent_Done,
     /* 1279038 */   // Label 18394: @1279038
     /* 1279038 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1279122), // Rule ID 8651 //
     /* 1279043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1279060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1279081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1279099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279121 */     // GIR_Coverage, 8651,
     /* 1279121 */     GIR_EraseRootFromParent_Done,
     /* 1279122 */   // Label 18395: @1279122
     /* 1279122 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1279206), // Rule ID 8654 //
     /* 1279127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1279144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1279183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279205 */     // GIR_Coverage, 8654,
     /* 1279205 */     GIR_EraseRootFromParent_Done,
     /* 1279206 */   // Label 18396: @1279206
     /* 1279206 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1279290), // Rule ID 8655 //
     /* 1279211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1279228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1279267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279289 */     // GIR_Coverage, 8655,
     /* 1279289 */     GIR_EraseRootFromParent_Done,
     /* 1279290 */   // Label 18397: @1279290
     /* 1279290 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1279374), // Rule ID 8658 //
     /* 1279295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1279306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1279309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1279312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1279318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1279351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279373 */     // GIR_Coverage, 8658,
     /* 1279373 */     GIR_EraseRootFromParent_Done,
     /* 1279374 */   // Label 18398: @1279374
     /* 1279374 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1279458), // Rule ID 8659 //
     /* 1279379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1279390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1279393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1279396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1279402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1279435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279457 */     // GIR_Coverage, 8659,
     /* 1279457 */     GIR_EraseRootFromParent_Done,
     /* 1279458 */   // Label 18399: @1279458
     /* 1279458 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1279542), // Rule ID 8662 //
     /* 1279463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1279466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1279480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1279501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1279519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279541 */     // GIR_Coverage, 8662,
     /* 1279541 */     GIR_EraseRootFromParent_Done,
     /* 1279542 */   // Label 18400: @1279542
     /* 1279542 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1279626), // Rule ID 8663 //
     /* 1279547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1279550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1279564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1279585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1279603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279625 */     // GIR_Coverage, 8663,
     /* 1279625 */     GIR_EraseRootFromParent_Done,
     /* 1279626 */   // Label 18401: @1279626
     /* 1279626 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1279710), // Rule ID 8666 //
     /* 1279631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1279634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1279648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1279687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279709 */     // GIR_Coverage, 8666,
     /* 1279709 */     GIR_EraseRootFromParent_Done,
     /* 1279710 */   // Label 18402: @1279710
     /* 1279710 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1279794), // Rule ID 8667 //
     /* 1279715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1279718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1279732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1279771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279793 */     // GIR_Coverage, 8667,
     /* 1279793 */     GIR_EraseRootFromParent_Done,
     /* 1279794 */   // Label 18403: @1279794
     /* 1279794 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1279878), // Rule ID 8670 //
     /* 1279799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1279802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1279816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1279855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279877 */     // GIR_Coverage, 8670,
     /* 1279877 */     GIR_EraseRootFromParent_Done,
     /* 1279878 */   // Label 18404: @1279878
     /* 1279878 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1279962), // Rule ID 8671 //
     /* 1279883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1279886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1279900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1279939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279961 */     // GIR_Coverage, 8671,
     /* 1279961 */     GIR_EraseRootFromParent_Done,
     /* 1279962 */   // Label 18405: @1279962
     /* 1279962 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1280046), // Rule ID 8674 //
     /* 1279967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1279987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1280023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280045 */     // GIR_Coverage, 8674,
     /* 1280045 */     GIR_EraseRootFromParent_Done,
     /* 1280046 */   // Label 18406: @1280046
     /* 1280046 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1280130), // Rule ID 8675 //
     /* 1280051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1280068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1280071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280104 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1280107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280129 */     // GIR_Coverage, 8675,
     /* 1280129 */     GIR_EraseRootFromParent_Done,
     /* 1280130 */   // Label 18407: @1280130
     /* 1280130 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1280214), // Rule ID 8678 //
     /* 1280135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1280152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1280155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1280191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280213 */     // GIR_Coverage, 8678,
     /* 1280213 */     GIR_EraseRootFromParent_Done,
     /* 1280214 */   // Label 18408: @1280214
     /* 1280214 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1280298), // Rule ID 8679 //
     /* 1280219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1280236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1280239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280272 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1280275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280297 */     // GIR_Coverage, 8679,
     /* 1280297 */     GIR_EraseRootFromParent_Done,
     /* 1280298 */   // Label 18409: @1280298
     /* 1280298 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1280382), // Rule ID 8682 //
     /* 1280303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1280320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1280323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280381 */     // GIR_Coverage, 8682,
     /* 1280381 */     GIR_EraseRootFromParent_Done,
     /* 1280382 */   // Label 18410: @1280382
     /* 1280382 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1280466), // Rule ID 8683 //
     /* 1280387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1280404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1280407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280465 */     // GIR_Coverage, 8683,
     /* 1280465 */     GIR_EraseRootFromParent_Done,
     /* 1280466 */   // Label 18411: @1280466
     /* 1280466 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1280550), // Rule ID 8686 //
     /* 1280471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1280488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1280491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280524 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1280527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280549 */     // GIR_Coverage, 8686,
     /* 1280549 */     GIR_EraseRootFromParent_Done,
     /* 1280550 */   // Label 18412: @1280550
     /* 1280550 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1280634), // Rule ID 8687 //
     /* 1280555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1280572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1280575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1280611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280633 */     // GIR_Coverage, 8687,
     /* 1280633 */     GIR_EraseRootFromParent_Done,
     /* 1280634 */   // Label 18413: @1280634
     /* 1280634 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1280718), // Rule ID 8690 //
     /* 1280639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1280656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1280659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280717 */     // GIR_Coverage, 8690,
     /* 1280717 */     GIR_EraseRootFromParent_Done,
     /* 1280718 */   // Label 18414: @1280718
     /* 1280718 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1280802), // Rule ID 8691 //
     /* 1280723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1280740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1280743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280801 */     // GIR_Coverage, 8691,
     /* 1280801 */     GIR_EraseRootFromParent_Done,
     /* 1280802 */   // Label 18415: @1280802
     /* 1280802 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1280886), // Rule ID 8694 //
     /* 1280807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1280824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1280827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280885 */     // GIR_Coverage, 8694,
     /* 1280885 */     GIR_EraseRootFromParent_Done,
     /* 1280886 */   // Label 18416: @1280886
     /* 1280886 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1280970), // Rule ID 8695 //
     /* 1280891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1280908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1280911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1280947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280969 */     // GIR_Coverage, 8695,
     /* 1280969 */     GIR_EraseRootFromParent_Done,
     /* 1280970 */   // Label 18417: @1280970
     /* 1280970 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1281054), // Rule ID 8698 //
     /* 1280975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1280995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281053 */     // GIR_Coverage, 8698,
     /* 1281053 */     GIR_EraseRootFromParent_Done,
     /* 1281054 */   // Label 18418: @1281054
     /* 1281054 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1281138), // Rule ID 8699 //
     /* 1281059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1281076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1281079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281137 */     // GIR_Coverage, 8699,
     /* 1281137 */     GIR_EraseRootFromParent_Done,
     /* 1281138 */   // Label 18419: @1281138
     /* 1281138 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1281222), // Rule ID 8702 //
     /* 1281143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1281160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281221 */     // GIR_Coverage, 8702,
     /* 1281221 */     GIR_EraseRootFromParent_Done,
     /* 1281222 */   // Label 18420: @1281222
     /* 1281222 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1281306), // Rule ID 8703 //
     /* 1281227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1281244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1281247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281305 */     // GIR_Coverage, 8703,
     /* 1281305 */     GIR_EraseRootFromParent_Done,
     /* 1281306 */   // Label 18421: @1281306
     /* 1281306 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1281390), // Rule ID 8706 //
     /* 1281311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1281328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1281331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281389 */     // GIR_Coverage, 8706,
     /* 1281389 */     GIR_EraseRootFromParent_Done,
     /* 1281390 */   // Label 18422: @1281390
     /* 1281390 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1281474), // Rule ID 8707 //
     /* 1281395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1281412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1281415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281473 */     // GIR_Coverage, 8707,
     /* 1281473 */     GIR_EraseRootFromParent_Done,
     /* 1281474 */   // Label 18423: @1281474
     /* 1281474 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1281558), // Rule ID 8710 //
     /* 1281479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1281490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1281493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1281496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1281499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1281502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281557 */     // GIR_Coverage, 8710,
     /* 1281557 */     GIR_EraseRootFromParent_Done,
     /* 1281558 */   // Label 18424: @1281558
     /* 1281558 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1281642), // Rule ID 8711 //
     /* 1281563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1281574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1281577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1281580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1281583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1281586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1281619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281641 */     // GIR_Coverage, 8711,
     /* 1281641 */     GIR_EraseRootFromParent_Done,
     /* 1281642 */   // Label 18425: @1281642
     /* 1281642 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1281726), // Rule ID 8714 //
     /* 1281647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1281664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1281667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1281703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281725 */     // GIR_Coverage, 8714,
     /* 1281725 */     GIR_EraseRootFromParent_Done,
     /* 1281726 */   // Label 18426: @1281726
     /* 1281726 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1281810), // Rule ID 8715 //
     /* 1281731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1281748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1281751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1281787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281809 */     // GIR_Coverage, 8715,
     /* 1281809 */     GIR_EraseRootFromParent_Done,
     /* 1281810 */   // Label 18427: @1281810
     /* 1281810 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1281894), // Rule ID 8718 //
     /* 1281815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1281832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1281835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281868 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1281871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281893 */     // GIR_Coverage, 8718,
     /* 1281893 */     GIR_EraseRootFromParent_Done,
     /* 1281894 */   // Label 18428: @1281894
     /* 1281894 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1281978), // Rule ID 8719 //
     /* 1281899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1281916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1281919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281952 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1281955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281977 */     // GIR_Coverage, 8719,
     /* 1281977 */     GIR_EraseRootFromParent_Done,
     /* 1281978 */   // Label 18429: @1281978
     /* 1281978 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1282062), // Rule ID 8722 //
     /* 1281983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1282000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1282003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1282006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282036 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1282039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282061 */     // GIR_Coverage, 8722,
     /* 1282061 */     GIR_EraseRootFromParent_Done,
     /* 1282062 */   // Label 18430: @1282062
     /* 1282062 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1282146), // Rule ID 8723 //
     /* 1282067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1282078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1282081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1282084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1282087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1282090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282120 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1282123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282145 */     // GIR_Coverage, 8723,
     /* 1282145 */     GIR_EraseRootFromParent_Done,
     /* 1282146 */   // Label 18431: @1282146
     /* 1282146 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1282230), // Rule ID 8726 //
     /* 1282151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1282168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1282171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1282207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282229 */     // GIR_Coverage, 8726,
     /* 1282229 */     GIR_EraseRootFromParent_Done,
     /* 1282230 */   // Label 18432: @1282230
     /* 1282230 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1282314), // Rule ID 8727 //
     /* 1282235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1282252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1282255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1282291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282313 */     // GIR_Coverage, 8727,
     /* 1282313 */     GIR_EraseRootFromParent_Done,
     /* 1282314 */   // Label 18433: @1282314
     /* 1282314 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1282398), // Rule ID 8730 //
     /* 1282319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1282336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1282339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282372 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1282375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282397 */     // GIR_Coverage, 8730,
     /* 1282397 */     GIR_EraseRootFromParent_Done,
     /* 1282398 */   // Label 18434: @1282398
     /* 1282398 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1282482), // Rule ID 8731 //
     /* 1282403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1282420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1282423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282456 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1282459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282481 */     // GIR_Coverage, 8731,
     /* 1282481 */     GIR_EraseRootFromParent_Done,
     /* 1282482 */   // Label 18435: @1282482
     /* 1282482 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1282566), // Rule ID 8734 //
     /* 1282487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1282498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1282501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1282504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1282507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1282510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1282543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282565 */     // GIR_Coverage, 8734,
     /* 1282565 */     GIR_EraseRootFromParent_Done,
     /* 1282566 */   // Label 18436: @1282566
     /* 1282566 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1282650), // Rule ID 8735 //
     /* 1282571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1282582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1282585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1282588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1282591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1282594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1282627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282649 */     // GIR_Coverage, 8735,
     /* 1282649 */     GIR_EraseRootFromParent_Done,
     /* 1282650 */   // Label 18437: @1282650
     /* 1282650 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1282734), // Rule ID 8738 //
     /* 1282655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1282672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1282675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1282711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282733 */     // GIR_Coverage, 8738,
     /* 1282733 */     GIR_EraseRootFromParent_Done,
     /* 1282734 */   // Label 18438: @1282734
     /* 1282734 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1282818), // Rule ID 8739 //
     /* 1282739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1282756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1282759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1282795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282817 */     // GIR_Coverage, 8739,
     /* 1282817 */     GIR_EraseRootFromParent_Done,
     /* 1282818 */   // Label 18439: @1282818
     /* 1282818 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1282902), // Rule ID 8742 //
     /* 1282823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1282840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1282843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1282879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282901 */     // GIR_Coverage, 8742,
     /* 1282901 */     GIR_EraseRootFromParent_Done,
     /* 1282902 */   // Label 18440: @1282902
     /* 1282902 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1282986), // Rule ID 8743 //
     /* 1282907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1282924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1282927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282960 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1282963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282985 */     // GIR_Coverage, 8743,
     /* 1282985 */     GIR_EraseRootFromParent_Done,
     /* 1282986 */   // Label 18441: @1282986
     /* 1282986 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1283070), // Rule ID 8746 //
     /* 1282991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1283008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1283011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1283014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1283047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283069 */     // GIR_Coverage, 8746,
     /* 1283069 */     GIR_EraseRootFromParent_Done,
     /* 1283070 */   // Label 18442: @1283070
     /* 1283070 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1283154), // Rule ID 8747 //
     /* 1283075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1283092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1283095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1283098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1283131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283153 */     // GIR_Coverage, 8747,
     /* 1283153 */     GIR_EraseRootFromParent_Done,
     /* 1283154 */   // Label 18443: @1283154
     /* 1283154 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1283238), // Rule ID 8750 //
     /* 1283159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1283176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1283179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1283215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283237 */     // GIR_Coverage, 8750,
     /* 1283237 */     GIR_EraseRootFromParent_Done,
     /* 1283238 */   // Label 18444: @1283238
     /* 1283238 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1283322), // Rule ID 8751 //
     /* 1283243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1283260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1283263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1283299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283321 */     // GIR_Coverage, 8751,
     /* 1283321 */     GIR_EraseRootFromParent_Done,
     /* 1283322 */   // Label 18445: @1283322
     /* 1283322 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1283406), // Rule ID 8754 //
     /* 1283327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1283344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1283347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1283365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1283369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1283383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283405 */     // GIR_Coverage, 8754,
     /* 1283405 */     GIR_EraseRootFromParent_Done,
     /* 1283406 */   // Label 18446: @1283406
     /* 1283406 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1283490), // Rule ID 8755 //
     /* 1283411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1283428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1283431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1283449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1283453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283464 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1283467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283489 */     // GIR_Coverage, 8755,
     /* 1283489 */     GIR_EraseRootFromParent_Done,
     /* 1283490 */   // Label 18447: @1283490
     /* 1283490 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1283574), // Rule ID 8758 //
     /* 1283495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1283512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1283515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1283551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283573 */     // GIR_Coverage, 8758,
     /* 1283573 */     GIR_EraseRootFromParent_Done,
     /* 1283574 */   // Label 18448: @1283574
     /* 1283574 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1283658), // Rule ID 8759 //
     /* 1283579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1283596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1283599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1283621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1283635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283657 */     // GIR_Coverage, 8759,
     /* 1283657 */     GIR_EraseRootFromParent_Done,
     /* 1283658 */   // Label 18449: @1283658
     /* 1283658 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1283742), // Rule ID 8762 //
     /* 1283663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1283680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1283719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283741 */     // GIR_Coverage, 8762,
     /* 1283741 */     GIR_EraseRootFromParent_Done,
     /* 1283742 */   // Label 18450: @1283742
     /* 1283742 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1283826), // Rule ID 8763 //
     /* 1283747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1283764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1283803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283825 */     // GIR_Coverage, 8763,
     /* 1283825 */     GIR_EraseRootFromParent_Done,
     /* 1283826 */   // Label 18451: @1283826
     /* 1283826 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1283910), // Rule ID 8766 //
     /* 1283831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1283848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1283851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1283887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283909 */     // GIR_Coverage, 8766,
     /* 1283909 */     GIR_EraseRootFromParent_Done,
     /* 1283910 */   // Label 18452: @1283910
     /* 1283910 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1283994), // Rule ID 8767 //
     /* 1283915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1283932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1283935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1283957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1283971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283993 */     // GIR_Coverage, 8767,
     /* 1283993 */     GIR_EraseRootFromParent_Done,
     /* 1283994 */   // Label 18453: @1283994
     /* 1283994 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1284078), // Rule ID 8770 //
     /* 1283999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1284016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284077 */     // GIR_Coverage, 8770,
     /* 1284077 */     GIR_EraseRootFromParent_Done,
     /* 1284078 */   // Label 18454: @1284078
     /* 1284078 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1284162), // Rule ID 8771 //
     /* 1284083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1284100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284161 */     // GIR_Coverage, 8771,
     /* 1284161 */     GIR_EraseRootFromParent_Done,
     /* 1284162 */   // Label 18455: @1284162
     /* 1284162 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1284246), // Rule ID 8774 //
     /* 1284167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1284184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1284223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284245 */     // GIR_Coverage, 8774,
     /* 1284245 */     GIR_EraseRootFromParent_Done,
     /* 1284246 */   // Label 18456: @1284246
     /* 1284246 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1284330), // Rule ID 8775 //
     /* 1284251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1284268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1284307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284329 */     // GIR_Coverage, 8775,
     /* 1284329 */     GIR_EraseRootFromParent_Done,
     /* 1284330 */   // Label 18457: @1284330
     /* 1284330 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1284414), // Rule ID 8778 //
     /* 1284335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1284352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284388 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284413 */     // GIR_Coverage, 8778,
     /* 1284413 */     GIR_EraseRootFromParent_Done,
     /* 1284414 */   // Label 18458: @1284414
     /* 1284414 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1284498), // Rule ID 8779 //
     /* 1284419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1284436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284497 */     // GIR_Coverage, 8779,
     /* 1284497 */     GIR_EraseRootFromParent_Done,
     /* 1284498 */   // Label 18459: @1284498
     /* 1284498 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1284582), // Rule ID 8782 //
     /* 1284503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1284520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284556 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284581 */     // GIR_Coverage, 8782,
     /* 1284581 */     GIR_EraseRootFromParent_Done,
     /* 1284582 */   // Label 18460: @1284582
     /* 1284582 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1284666), // Rule ID 8783 //
     /* 1284587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1284604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1284643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284665 */     // GIR_Coverage, 8783,
     /* 1284665 */     GIR_EraseRootFromParent_Done,
     /* 1284666 */   // Label 18461: @1284666
     /* 1284666 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1284750), // Rule ID 8786 //
     /* 1284671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1284688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1284727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284749 */     // GIR_Coverage, 8786,
     /* 1284749 */     GIR_EraseRootFromParent_Done,
     /* 1284750 */   // Label 18462: @1284750
     /* 1284750 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1284834), // Rule ID 8787 //
     /* 1284755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1284772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1284811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284833 */     // GIR_Coverage, 8787,
     /* 1284833 */     GIR_EraseRootFromParent_Done,
     /* 1284834 */   // Label 18463: @1284834
     /* 1284834 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1284918), // Rule ID 8790 //
     /* 1284839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1284856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1284859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1284895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284917 */     // GIR_Coverage, 8790,
     /* 1284917 */     GIR_EraseRootFromParent_Done,
     /* 1284918 */   // Label 18464: @1284918
     /* 1284918 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1285002), // Rule ID 8791 //
     /* 1284923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1284940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1284943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1284965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1284979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285001 */     // GIR_Coverage, 8791,
     /* 1285001 */     GIR_EraseRootFromParent_Done,
     /* 1285002 */   // Label 18465: @1285002
     /* 1285002 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1285086), // Rule ID 8794 //
     /* 1285007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1285024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1285063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285085 */     // GIR_Coverage, 8794,
     /* 1285085 */     GIR_EraseRootFromParent_Done,
     /* 1285086 */   // Label 18466: @1285086
     /* 1285086 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1285170), // Rule ID 8795 //
     /* 1285091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1285108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285144 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1285147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285169 */     // GIR_Coverage, 8795,
     /* 1285169 */     GIR_EraseRootFromParent_Done,
     /* 1285170 */   // Label 18467: @1285170
     /* 1285170 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1285254), // Rule ID 8798 //
     /* 1285175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1285186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1285189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1285192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1285198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1285231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285253 */     // GIR_Coverage, 8798,
     /* 1285253 */     GIR_EraseRootFromParent_Done,
     /* 1285254 */   // Label 18468: @1285254
     /* 1285254 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1285338), // Rule ID 8799 //
     /* 1285259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1285270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1285273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1285276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1285282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1285315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285337 */     // GIR_Coverage, 8799,
     /* 1285337 */     GIR_EraseRootFromParent_Done,
     /* 1285338 */   // Label 18469: @1285338
     /* 1285338 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1285422), // Rule ID 8802 //
     /* 1285343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1285360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1285399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285421 */     // GIR_Coverage, 8802,
     /* 1285421 */     GIR_EraseRootFromParent_Done,
     /* 1285422 */   // Label 18470: @1285422
     /* 1285422 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1285506), // Rule ID 8803 //
     /* 1285427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1285444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1285483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285505 */     // GIR_Coverage, 8803,
     /* 1285505 */     GIR_EraseRootFromParent_Done,
     /* 1285506 */   // Label 18471: @1285506
     /* 1285506 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1285590), // Rule ID 8806 //
     /* 1285511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1285528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285564 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1285567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285589 */     // GIR_Coverage, 8806,
     /* 1285589 */     GIR_EraseRootFromParent_Done,
     /* 1285590 */   // Label 18472: @1285590
     /* 1285590 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1285674), // Rule ID 8807 //
     /* 1285595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1285612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285648 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1285651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285673 */     // GIR_Coverage, 8807,
     /* 1285673 */     GIR_EraseRootFromParent_Done,
     /* 1285674 */   // Label 18473: @1285674
     /* 1285674 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1285758), // Rule ID 8810 //
     /* 1285679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1285690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1285693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1285696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1285702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285732 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1285735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285757 */     // GIR_Coverage, 8810,
     /* 1285757 */     GIR_EraseRootFromParent_Done,
     /* 1285758 */   // Label 18474: @1285758
     /* 1285758 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1285842), // Rule ID 8811 //
     /* 1285763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1285774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1285777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1285780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1285786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285816 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1285819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285841 */     // GIR_Coverage, 8811,
     /* 1285841 */     GIR_EraseRootFromParent_Done,
     /* 1285842 */   // Label 18475: @1285842
     /* 1285842 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1285926), // Rule ID 8814 //
     /* 1285847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1285864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1285903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285925 */     // GIR_Coverage, 8814,
     /* 1285925 */     GIR_EraseRootFromParent_Done,
     /* 1285926 */   // Label 18476: @1285926
     /* 1285926 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1286010), // Rule ID 8815 //
     /* 1285931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1285948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1285951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1285987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286009 */     // GIR_Coverage, 8815,
     /* 1286009 */     GIR_EraseRootFromParent_Done,
     /* 1286010 */   // Label 18477: @1286010
     /* 1286010 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1286094), // Rule ID 8818 //
     /* 1286015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1286032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286068 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1286071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286093 */     // GIR_Coverage, 8818,
     /* 1286093 */     GIR_EraseRootFromParent_Done,
     /* 1286094 */   // Label 18478: @1286094
     /* 1286094 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1286178), // Rule ID 8819 //
     /* 1286099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1286116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286152 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1286155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286177 */     // GIR_Coverage, 8819,
     /* 1286177 */     GIR_EraseRootFromParent_Done,
     /* 1286178 */   // Label 18479: @1286178
     /* 1286178 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1286262), // Rule ID 8822 //
     /* 1286183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1286194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1286197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1286200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1286206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286236 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1286239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286261 */     // GIR_Coverage, 8822,
     /* 1286261 */     GIR_EraseRootFromParent_Done,
     /* 1286262 */   // Label 18480: @1286262
     /* 1286262 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1286346), // Rule ID 8823 //
     /* 1286267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1286278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1286281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1286284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1286290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286320 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1286323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286345 */     // GIR_Coverage, 8823,
     /* 1286345 */     GIR_EraseRootFromParent_Done,
     /* 1286346 */   // Label 18481: @1286346
     /* 1286346 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1286430), // Rule ID 8826 //
     /* 1286351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1286368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1286407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286429 */     // GIR_Coverage, 8826,
     /* 1286429 */     GIR_EraseRootFromParent_Done,
     /* 1286430 */   // Label 18482: @1286430
     /* 1286430 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1286514), // Rule ID 8827 //
     /* 1286435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1286452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1286491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286513 */     // GIR_Coverage, 8827,
     /* 1286513 */     GIR_EraseRootFromParent_Done,
     /* 1286514 */   // Label 18483: @1286514
     /* 1286514 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1286598), // Rule ID 8830 //
     /* 1286519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1286536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1286575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286597 */     // GIR_Coverage, 8830,
     /* 1286597 */     GIR_EraseRootFromParent_Done,
     /* 1286598 */   // Label 18484: @1286598
     /* 1286598 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1286682), // Rule ID 8831 //
     /* 1286603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1286620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1286659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286681 */     // GIR_Coverage, 8831,
     /* 1286681 */     GIR_EraseRootFromParent_Done,
     /* 1286682 */   // Label 18485: @1286682
     /* 1286682 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1286766), // Rule ID 8834 //
     /* 1286687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1286704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1286743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286765 */     // GIR_Coverage, 8834,
     /* 1286765 */     GIR_EraseRootFromParent_Done,
     /* 1286766 */   // Label 18486: @1286766
     /* 1286766 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1286850), // Rule ID 8835 //
     /* 1286771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1286788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286824 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1286827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286849 */     // GIR_Coverage, 8835,
     /* 1286849 */     GIR_EraseRootFromParent_Done,
     /* 1286850 */   // Label 18487: @1286850
     /* 1286850 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1286934), // Rule ID 8838 //
     /* 1286855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1286872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286908 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1286911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286933 */     // GIR_Coverage, 8838,
     /* 1286933 */     GIR_EraseRootFromParent_Done,
     /* 1286934 */   // Label 18488: @1286934
     /* 1286934 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1287018), // Rule ID 8839 //
     /* 1286939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1286956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286992 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1286995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287017 */     // GIR_Coverage, 8839,
     /* 1287017 */     GIR_EraseRootFromParent_Done,
     /* 1287018 */   // Label 18489: @1287018
     /* 1287018 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1287102), // Rule ID 8842 //
     /* 1287023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1287040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287101 */     // GIR_Coverage, 8842,
     /* 1287101 */     GIR_EraseRootFromParent_Done,
     /* 1287102 */   // Label 18490: @1287102
     /* 1287102 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1287186), // Rule ID 8843 //
     /* 1287107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1287124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287185 */     // GIR_Coverage, 8843,
     /* 1287185 */     GIR_EraseRootFromParent_Done,
     /* 1287186 */   // Label 18491: @1287186
     /* 1287186 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1287270), // Rule ID 8846 //
     /* 1287191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1287208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1287229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1287247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287269 */     // GIR_Coverage, 8846,
     /* 1287269 */     GIR_EraseRootFromParent_Done,
     /* 1287270 */   // Label 18492: @1287270
     /* 1287270 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1287354), // Rule ID 8847 //
     /* 1287275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1287292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1287313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1287331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287353 */     // GIR_Coverage, 8847,
     /* 1287353 */     GIR_EraseRootFromParent_Done,
     /* 1287354 */   // Label 18493: @1287354
     /* 1287354 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1287438), // Rule ID 8938 //
     /* 1287359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1287376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1287379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1287415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287437 */     // GIR_Coverage, 8938,
     /* 1287437 */     GIR_EraseRootFromParent_Done,
     /* 1287438 */   // Label 18494: @1287438
     /* 1287438 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1287522), // Rule ID 8939 //
     /* 1287443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1287460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1287463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1287499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287521 */     // GIR_Coverage, 8939,
     /* 1287521 */     GIR_EraseRootFromParent_Done,
     /* 1287522 */   // Label 18495: @1287522
     /* 1287522 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1287606), // Rule ID 8942 //
     /* 1287527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1287544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1287547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1287583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287605 */     // GIR_Coverage, 8942,
     /* 1287605 */     GIR_EraseRootFromParent_Done,
     /* 1287606 */   // Label 18496: @1287606
     /* 1287606 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1287690), // Rule ID 8943 //
     /* 1287611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1287628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1287631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287664 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1287667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287689 */     // GIR_Coverage, 8943,
     /* 1287689 */     GIR_EraseRootFromParent_Done,
     /* 1287690 */   // Label 18497: @1287690
     /* 1287690 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1287774), // Rule ID 8946 //
     /* 1287695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1287712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1287715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1287751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287773 */     // GIR_Coverage, 8946,
     /* 1287773 */     GIR_EraseRootFromParent_Done,
     /* 1287774 */   // Label 18498: @1287774
     /* 1287774 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1287858), // Rule ID 8947 //
     /* 1287779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1287796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1287799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1287835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287857 */     // GIR_Coverage, 8947,
     /* 1287857 */     GIR_EraseRootFromParent_Done,
     /* 1287858 */   // Label 18499: @1287858
     /* 1287858 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1287942), // Rule ID 8950 //
     /* 1287863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1287880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1287883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287916 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1287919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287941 */     // GIR_Coverage, 8950,
     /* 1287941 */     GIR_EraseRootFromParent_Done,
     /* 1287942 */   // Label 18500: @1287942
     /* 1287942 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1288026), // Rule ID 8951 //
     /* 1287947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1287964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1287967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1288003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288025 */     // GIR_Coverage, 8951,
     /* 1288025 */     GIR_EraseRootFromParent_Done,
     /* 1288026 */   // Label 18501: @1288026
     /* 1288026 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1288110), // Rule ID 8954 //
     /* 1288031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1288048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1288051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288084 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1288087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288109 */     // GIR_Coverage, 8954,
     /* 1288109 */     GIR_EraseRootFromParent_Done,
     /* 1288110 */   // Label 18502: @1288110
     /* 1288110 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1288194), // Rule ID 8955 //
     /* 1288115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1288132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1288135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1288171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288193 */     // GIR_Coverage, 8955,
     /* 1288193 */     GIR_EraseRootFromParent_Done,
     /* 1288194 */   // Label 18503: @1288194
     /* 1288194 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1288278), // Rule ID 8958 //
     /* 1288199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1288216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1288219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1288255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288277 */     // GIR_Coverage, 8958,
     /* 1288277 */     GIR_EraseRootFromParent_Done,
     /* 1288278 */   // Label 18504: @1288278
     /* 1288278 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1288362), // Rule ID 8959 //
     /* 1288283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1288300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1288303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288336 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1288339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288361 */     // GIR_Coverage, 8959,
     /* 1288361 */     GIR_EraseRootFromParent_Done,
     /* 1288362 */   // Label 18505: @1288362
     /* 1288362 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1288446), // Rule ID 8962 //
     /* 1288367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1288384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288445 */     // GIR_Coverage, 8962,
     /* 1288445 */     GIR_EraseRootFromParent_Done,
     /* 1288446 */   // Label 18506: @1288446
     /* 1288446 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1288530), // Rule ID 8963 //
     /* 1288451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1288468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1288471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288529 */     // GIR_Coverage, 8963,
     /* 1288529 */     GIR_EraseRootFromParent_Done,
     /* 1288530 */   // Label 18507: @1288530
     /* 1288530 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1288614), // Rule ID 8966 //
     /* 1288535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1288552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288613 */     // GIR_Coverage, 8966,
     /* 1288613 */     GIR_EraseRootFromParent_Done,
     /* 1288614 */   // Label 18508: @1288614
     /* 1288614 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1288698), // Rule ID 8967 //
     /* 1288619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1288636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1288639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288697 */     // GIR_Coverage, 8967,
     /* 1288697 */     GIR_EraseRootFromParent_Done,
     /* 1288698 */   // Label 18509: @1288698
     /* 1288698 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1288782), // Rule ID 8970 //
     /* 1288703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1288720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1288723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288781 */     // GIR_Coverage, 8970,
     /* 1288781 */     GIR_EraseRootFromParent_Done,
     /* 1288782 */   // Label 18510: @1288782
     /* 1288782 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1288866), // Rule ID 8971 //
     /* 1288787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1288804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1288807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288865 */     // GIR_Coverage, 8971,
     /* 1288865 */     GIR_EraseRootFromParent_Done,
     /* 1288866 */   // Label 18511: @1288866
     /* 1288866 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1288950), // Rule ID 8974 //
     /* 1288871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1288874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1288888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1288891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1288927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288949 */     // GIR_Coverage, 8974,
     /* 1288949 */     GIR_EraseRootFromParent_Done,
     /* 1288950 */   // Label 18512: @1288950
     /* 1288950 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1289034), // Rule ID 8975 //
     /* 1288955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1288958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1288972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1288975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1289011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289033 */     // GIR_Coverage, 8975,
     /* 1289033 */     GIR_EraseRootFromParent_Done,
     /* 1289034 */   // Label 18513: @1289034
     /* 1289034 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1289118), // Rule ID 8978 //
     /* 1289039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1289056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1289059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1289095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289117 */     // GIR_Coverage, 8978,
     /* 1289117 */     GIR_EraseRootFromParent_Done,
     /* 1289118 */   // Label 18514: @1289118
     /* 1289118 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1289202), // Rule ID 8979 //
     /* 1289123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1289140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1289143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1289179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289201 */     // GIR_Coverage, 8979,
     /* 1289201 */     GIR_EraseRootFromParent_Done,
     /* 1289202 */   // Label 18515: @1289202
     /* 1289202 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1289286), // Rule ID 8982 //
     /* 1289207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1289224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1289227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1289263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289285 */     // GIR_Coverage, 8982,
     /* 1289285 */     GIR_EraseRootFromParent_Done,
     /* 1289286 */   // Label 18516: @1289286
     /* 1289286 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1289370), // Rule ID 8983 //
     /* 1289291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1289308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1289311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289344 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1289347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289369 */     // GIR_Coverage, 8983,
     /* 1289369 */     GIR_EraseRootFromParent_Done,
     /* 1289370 */   // Label 18517: @1289370
     /* 1289370 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1289454), // Rule ID 8986 //
     /* 1289375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1289386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1289389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1289392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1289395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1289398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289428 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1289431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289453 */     // GIR_Coverage, 8986,
     /* 1289453 */     GIR_EraseRootFromParent_Done,
     /* 1289454 */   // Label 18518: @1289454
     /* 1289454 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1289538), // Rule ID 8987 //
     /* 1289459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1289470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1289473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1289476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1289479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1289482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289512 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1289515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289537 */     // GIR_Coverage, 8987,
     /* 1289537 */     GIR_EraseRootFromParent_Done,
     /* 1289538 */   // Label 18519: @1289538
     /* 1289538 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1289622), // Rule ID 8990 //
     /* 1289543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1289560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1289563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1289599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289621 */     // GIR_Coverage, 8990,
     /* 1289621 */     GIR_EraseRootFromParent_Done,
     /* 1289622 */   // Label 18520: @1289622
     /* 1289622 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1289706), // Rule ID 8991 //
     /* 1289627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1289644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1289647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1289683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289705 */     // GIR_Coverage, 8991,
     /* 1289705 */     GIR_EraseRootFromParent_Done,
     /* 1289706 */   // Label 18521: @1289706
     /* 1289706 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1289790), // Rule ID 8994 //
     /* 1289711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1289728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1289731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1289767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289789 */     // GIR_Coverage, 8994,
     /* 1289789 */     GIR_EraseRootFromParent_Done,
     /* 1289790 */   // Label 18522: @1289790
     /* 1289790 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1289874), // Rule ID 8995 //
     /* 1289795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1289812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1289815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1289851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289873 */     // GIR_Coverage, 8995,
     /* 1289873 */     GIR_EraseRootFromParent_Done,
     /* 1289874 */   // Label 18523: @1289874
     /* 1289874 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1289958), // Rule ID 8998 //
     /* 1289879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1289896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1289899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289932 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1289935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289957 */     // GIR_Coverage, 8998,
     /* 1289957 */     GIR_EraseRootFromParent_Done,
     /* 1289958 */   // Label 18524: @1289958
     /* 1289958 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1290042), // Rule ID 8999 //
     /* 1289963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1289980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1289983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290016 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1290019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290041 */     // GIR_Coverage, 8999,
     /* 1290041 */     GIR_EraseRootFromParent_Done,
     /* 1290042 */   // Label 18525: @1290042
     /* 1290042 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1290126), // Rule ID 9002 //
     /* 1290047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1290064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1290067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1290103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290125 */     // GIR_Coverage, 9002,
     /* 1290125 */     GIR_EraseRootFromParent_Done,
     /* 1290126 */   // Label 18526: @1290126
     /* 1290126 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1290210), // Rule ID 9003 //
     /* 1290131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1290148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1290151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1290187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290209 */     // GIR_Coverage, 9003,
     /* 1290209 */     GIR_EraseRootFromParent_Done,
     /* 1290210 */   // Label 18527: @1290210
     /* 1290210 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1290294), // Rule ID 9006 //
     /* 1290215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1290232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1290235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290268 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1290271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290293 */     // GIR_Coverage, 9006,
     /* 1290293 */     GIR_EraseRootFromParent_Done,
     /* 1290294 */   // Label 18528: @1290294
     /* 1290294 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1290378), // Rule ID 9007 //
     /* 1290299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1290316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1290319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1290355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290377 */     // GIR_Coverage, 9007,
     /* 1290377 */     GIR_EraseRootFromParent_Done,
     /* 1290378 */   // Label 18529: @1290378
     /* 1290378 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1290462), // Rule ID 9010 //
     /* 1290383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1290394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1290397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1290400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1290403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1290406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290436 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1290439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290461 */     // GIR_Coverage, 9010,
     /* 1290461 */     GIR_EraseRootFromParent_Done,
     /* 1290462 */   // Label 18530: @1290462
     /* 1290462 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1290546), // Rule ID 9011 //
     /* 1290467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1290478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1290481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1290484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1290487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1290490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290520 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1290523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290545 */     // GIR_Coverage, 9011,
     /* 1290545 */     GIR_EraseRootFromParent_Done,
     /* 1290546 */   // Label 18531: @1290546
     /* 1290546 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1290630), // Rule ID 9014 //
     /* 1290551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1290554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1290568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1290571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1290607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290629 */     // GIR_Coverage, 9014,
     /* 1290629 */     GIR_EraseRootFromParent_Done,
     /* 1290630 */   // Label 18532: @1290630
     /* 1290630 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1290714), // Rule ID 9015 //
     /* 1290635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1290652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1290655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1290691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290713 */     // GIR_Coverage, 9015,
     /* 1290713 */     GIR_EraseRootFromParent_Done,
     /* 1290714 */   // Label 18533: @1290714
     /* 1290714 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1290798), // Rule ID 9018 //
     /* 1290719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1290722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1290736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1290739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1290775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290797 */     // GIR_Coverage, 9018,
     /* 1290797 */     GIR_EraseRootFromParent_Done,
     /* 1290798 */   // Label 18534: @1290798
     /* 1290798 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1290882), // Rule ID 9019 //
     /* 1290803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1290820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1290823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290856 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1290859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290881 */     // GIR_Coverage, 9019,
     /* 1290881 */     GIR_EraseRootFromParent_Done,
     /* 1290882 */   // Label 18535: @1290882
     /* 1290882 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1290966), // Rule ID 9022 //
     /* 1290887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1290890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1290907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1290943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290965 */     // GIR_Coverage, 9022,
     /* 1290965 */     GIR_EraseRootFromParent_Done,
     /* 1290966 */   // Label 18536: @1290966
     /* 1290966 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1291050), // Rule ID 9023 //
     /* 1290971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1290991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1291027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291049 */     // GIR_Coverage, 9023,
     /* 1291049 */     GIR_EraseRootFromParent_Done,
     /* 1291050 */   // Label 18537: @1291050
     /* 1291050 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1291134), // Rule ID 9026 //
     /* 1291055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1291072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1291111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291133 */     // GIR_Coverage, 9026,
     /* 1291133 */     GIR_EraseRootFromParent_Done,
     /* 1291134 */   // Label 18538: @1291134
     /* 1291134 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1291218), // Rule ID 9027 //
     /* 1291139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1291156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1291195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291217 */     // GIR_Coverage, 9027,
     /* 1291217 */     GIR_EraseRootFromParent_Done,
     /* 1291218 */   // Label 18539: @1291218
     /* 1291218 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1291302), // Rule ID 9030 //
     /* 1291223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1291240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1291279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291301 */     // GIR_Coverage, 9030,
     /* 1291301 */     GIR_EraseRootFromParent_Done,
     /* 1291302 */   // Label 18540: @1291302
     /* 1291302 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1291386), // Rule ID 9031 //
     /* 1291307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1291324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1291363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291385 */     // GIR_Coverage, 9031,
     /* 1291385 */     GIR_EraseRootFromParent_Done,
     /* 1291386 */   // Label 18541: @1291386
     /* 1291386 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1291470), // Rule ID 9034 //
     /* 1291391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1291408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1291447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291469 */     // GIR_Coverage, 9034,
     /* 1291469 */     GIR_EraseRootFromParent_Done,
     /* 1291470 */   // Label 18542: @1291470
     /* 1291470 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1291554), // Rule ID 9035 //
     /* 1291475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1291492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1291531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291553 */     // GIR_Coverage, 9035,
     /* 1291553 */     GIR_EraseRootFromParent_Done,
     /* 1291554 */   // Label 18543: @1291554
     /* 1291554 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1291638), // Rule ID 9038 //
     /* 1291559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1291576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1291615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291637 */     // GIR_Coverage, 9038,
     /* 1291637 */     GIR_EraseRootFromParent_Done,
     /* 1291638 */   // Label 18544: @1291638
     /* 1291638 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1291722), // Rule ID 9039 //
     /* 1291643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1291660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1291699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291721 */     // GIR_Coverage, 9039,
     /* 1291721 */     GIR_EraseRootFromParent_Done,
     /* 1291722 */   // Label 18545: @1291722
     /* 1291722 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1291806), // Rule ID 9042 //
     /* 1291727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1291744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1291783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291805 */     // GIR_Coverage, 9042,
     /* 1291805 */     GIR_EraseRootFromParent_Done,
     /* 1291806 */   // Label 18546: @1291806
     /* 1291806 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1291890), // Rule ID 9043 //
     /* 1291811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1291828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1291867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291889 */     // GIR_Coverage, 9043,
     /* 1291889 */     GIR_EraseRootFromParent_Done,
     /* 1291890 */   // Label 18547: @1291890
     /* 1291890 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1291974), // Rule ID 9046 //
     /* 1291895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291948 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1291951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291973 */     // GIR_Coverage, 9046,
     /* 1291973 */     GIR_EraseRootFromParent_Done,
     /* 1291974 */   // Label 18548: @1291974
     /* 1291974 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1292058), // Rule ID 9047 //
     /* 1291979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1292002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292032 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1292035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292057 */     // GIR_Coverage, 9047,
     /* 1292057 */     GIR_EraseRootFromParent_Done,
     /* 1292058 */   // Label 18549: @1292058
     /* 1292058 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1292142), // Rule ID 9050 //
     /* 1292063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1292080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292141 */     // GIR_Coverage, 9050,
     /* 1292141 */     GIR_EraseRootFromParent_Done,
     /* 1292142 */   // Label 18550: @1292142
     /* 1292142 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1292226), // Rule ID 9051 //
     /* 1292147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1292164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292200 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292225 */     // GIR_Coverage, 9051,
     /* 1292225 */     GIR_EraseRootFromParent_Done,
     /* 1292226 */   // Label 18551: @1292226
     /* 1292226 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1292310), // Rule ID 9054 //
     /* 1292231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1292248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292309 */     // GIR_Coverage, 9054,
     /* 1292309 */     GIR_EraseRootFromParent_Done,
     /* 1292310 */   // Label 18552: @1292310
     /* 1292310 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1292394), // Rule ID 9055 //
     /* 1292315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1292332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292393 */     // GIR_Coverage, 9055,
     /* 1292393 */     GIR_EraseRootFromParent_Done,
     /* 1292394 */   // Label 18553: @1292394
     /* 1292394 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1292478), // Rule ID 9058 //
     /* 1292399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1292416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292477 */     // GIR_Coverage, 9058,
     /* 1292477 */     GIR_EraseRootFromParent_Done,
     /* 1292478 */   // Label 18554: @1292478
     /* 1292478 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1292562), // Rule ID 9059 //
     /* 1292483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1292500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292561 */     // GIR_Coverage, 9059,
     /* 1292561 */     GIR_EraseRootFromParent_Done,
     /* 1292562 */   // Label 18555: @1292562
     /* 1292562 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1292646), // Rule ID 9062 //
     /* 1292567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1292578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1292581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1292584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1292590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292645 */     // GIR_Coverage, 9062,
     /* 1292645 */     GIR_EraseRootFromParent_Done,
     /* 1292646 */   // Label 18556: @1292646
     /* 1292646 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1292730), // Rule ID 9063 //
     /* 1292651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1292654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1292662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1292665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1292668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1292674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1292707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292729 */     // GIR_Coverage, 9063,
     /* 1292729 */     GIR_EraseRootFromParent_Done,
     /* 1292730 */   // Label 18557: @1292730
     /* 1292730 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1292814), // Rule ID 9066 //
     /* 1292735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1292752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1292791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292813 */     // GIR_Coverage, 9066,
     /* 1292813 */     GIR_EraseRootFromParent_Done,
     /* 1292814 */   // Label 18558: @1292814
     /* 1292814 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1292898), // Rule ID 9067 //
     /* 1292819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1292836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1292875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292897 */     // GIR_Coverage, 9067,
     /* 1292897 */     GIR_EraseRootFromParent_Done,
     /* 1292898 */   // Label 18559: @1292898
     /* 1292898 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1292982), // Rule ID 9070 //
     /* 1292903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1292920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292956 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1292959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292981 */     // GIR_Coverage, 9070,
     /* 1292981 */     GIR_EraseRootFromParent_Done,
     /* 1292982 */   // Label 18560: @1292982
     /* 1292982 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1293066), // Rule ID 9071 //
     /* 1292987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1293001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1293004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1293010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293040 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1293043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293065 */     // GIR_Coverage, 9071,
     /* 1293065 */     GIR_EraseRootFromParent_Done,
     /* 1293066 */   // Label 18561: @1293066
     /* 1293066 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1293150), // Rule ID 9074 //
     /* 1293071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1293082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1293085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1293088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1293094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293124 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1293127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293149 */     // GIR_Coverage, 9074,
     /* 1293149 */     GIR_EraseRootFromParent_Done,
     /* 1293150 */   // Label 18562: @1293150
     /* 1293150 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1293234), // Rule ID 9075 //
     /* 1293155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1293166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1293169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1293172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1293178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293208 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1293211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293233 */     // GIR_Coverage, 9075,
     /* 1293233 */     GIR_EraseRootFromParent_Done,
     /* 1293234 */   // Label 18563: @1293234
     /* 1293234 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1293318), // Rule ID 9078 //
     /* 1293239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1293256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1293295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293317 */     // GIR_Coverage, 9078,
     /* 1293317 */     GIR_EraseRootFromParent_Done,
     /* 1293318 */   // Label 18564: @1293318
     /* 1293318 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1293402), // Rule ID 9079 //
     /* 1293323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1293340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1293379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293401 */     // GIR_Coverage, 9079,
     /* 1293401 */     GIR_EraseRootFromParent_Done,
     /* 1293402 */   // Label 18565: @1293402
     /* 1293402 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1293486), // Rule ID 9082 //
     /* 1293407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1293424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1293463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293485 */     // GIR_Coverage, 9082,
     /* 1293485 */     GIR_EraseRootFromParent_Done,
     /* 1293486 */   // Label 18566: @1293486
     /* 1293486 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1293570), // Rule ID 9083 //
     /* 1293491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1293508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293544 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1293547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293569 */     // GIR_Coverage, 9083,
     /* 1293569 */     GIR_EraseRootFromParent_Done,
     /* 1293570 */   // Label 18567: @1293570
     /* 1293570 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1293654), // Rule ID 9086 //
     /* 1293575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1293586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1293589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1293592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1293598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1293631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293653 */     // GIR_Coverage, 9086,
     /* 1293653 */     GIR_EraseRootFromParent_Done,
     /* 1293654 */   // Label 18568: @1293654
     /* 1293654 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1293738), // Rule ID 9087 //
     /* 1293659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1293670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1293673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1293676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1293682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293712 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1293715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293737 */     // GIR_Coverage, 9087,
     /* 1293737 */     GIR_EraseRootFromParent_Done,
     /* 1293738 */   // Label 18569: @1293738
     /* 1293738 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1293822), // Rule ID 9090 //
     /* 1293743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1293760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1293799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293821 */     // GIR_Coverage, 9090,
     /* 1293821 */     GIR_EraseRootFromParent_Done,
     /* 1293822 */   // Label 18570: @1293822
     /* 1293822 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1293906), // Rule ID 9091 //
     /* 1293827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1293844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1293883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293905 */     // GIR_Coverage, 9091,
     /* 1293905 */     GIR_EraseRootFromParent_Done,
     /* 1293906 */   // Label 18571: @1293906
     /* 1293906 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1293990), // Rule ID 9094 //
     /* 1293911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1293928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1293967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293989 */     // GIR_Coverage, 9094,
     /* 1293989 */     GIR_EraseRootFromParent_Done,
     /* 1293990 */   // Label 18572: @1293990
     /* 1293990 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1294074), // Rule ID 9095 //
     /* 1293995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1294012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1294033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1294051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294073 */     // GIR_Coverage, 9095,
     /* 1294073 */     GIR_EraseRootFromParent_Done,
     /* 1294074 */   // Label 18573: @1294074
     /* 1294074 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1294158), // Rule ID 9098 //
     /* 1294079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1294090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1294093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1294096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1294102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1294117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1294135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294157 */     // GIR_Coverage, 9098,
     /* 1294157 */     GIR_EraseRootFromParent_Done,
     /* 1294158 */   // Label 18574: @1294158
     /* 1294158 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1294242), // Rule ID 9099 //
     /* 1294163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1294174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1294177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1294180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1294186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1294201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1294219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294241 */     // GIR_Coverage, 9099,
     /* 1294241 */     GIR_EraseRootFromParent_Done,
     /* 1294242 */   // Label 18575: @1294242
     /* 1294242 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1294326), // Rule ID 9102 //
     /* 1294247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1294264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1294285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1294303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294325 */     // GIR_Coverage, 9102,
     /* 1294325 */     GIR_EraseRootFromParent_Done,
     /* 1294326 */   // Label 18576: @1294326
     /* 1294326 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1294410), // Rule ID 9103 //
     /* 1294331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1294348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1294369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1294387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294409 */     // GIR_Coverage, 9103,
     /* 1294409 */     GIR_EraseRootFromParent_Done,
     /* 1294410 */   // Label 18577: @1294410
     /* 1294410 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1294494), // Rule ID 9106 //
     /* 1294415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1294432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1294453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1294471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294493 */     // GIR_Coverage, 9106,
     /* 1294493 */     GIR_EraseRootFromParent_Done,
     /* 1294494 */   // Label 18578: @1294494
     /* 1294494 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1294578), // Rule ID 9107 //
     /* 1294499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1294516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1294537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1294555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294577 */     // GIR_Coverage, 9107,
     /* 1294577 */     GIR_EraseRootFromParent_Done,
     /* 1294578 */   // Label 18579: @1294578
     /* 1294578 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1294662), // Rule ID 9110 //
     /* 1294583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1294600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1294621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1294639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294661 */     // GIR_Coverage, 9110,
     /* 1294661 */     GIR_EraseRootFromParent_Done,
     /* 1294662 */   // Label 18580: @1294662
     /* 1294662 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1294746), // Rule ID 9111 //
     /* 1294667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1294684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1294705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1294723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294745 */     // GIR_Coverage, 9111,
     /* 1294745 */     GIR_EraseRootFromParent_Done,
     /* 1294746 */   // Label 18581: @1294746
     /* 1294746 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1294830), // Rule ID 9202 //
     /* 1294751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1294759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1294768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294804 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1294807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294829 */     // GIR_Coverage, 9202,
     /* 1294829 */     GIR_EraseRootFromParent_Done,
     /* 1294830 */   // Label 18582: @1294830
     /* 1294830 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1294914), // Rule ID 9203 //
     /* 1294835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1294843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1294852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294888 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1294891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294913 */     // GIR_Coverage, 9203,
     /* 1294913 */     GIR_EraseRootFromParent_Done,
     /* 1294914 */   // Label 18583: @1294914
     /* 1294914 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1294998), // Rule ID 9206 //
     /* 1294919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1294927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1294936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1294975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294997 */     // GIR_Coverage, 9206,
     /* 1294997 */     GIR_EraseRootFromParent_Done,
     /* 1294998 */   // Label 18584: @1294998
     /* 1294998 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1295082), // Rule ID 9207 //
     /* 1295003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1295020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1295059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295081 */     // GIR_Coverage, 9207,
     /* 1295081 */     GIR_EraseRootFromParent_Done,
     /* 1295082 */   // Label 18585: @1295082
     /* 1295082 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1295166), // Rule ID 9210 //
     /* 1295087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1295104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295165 */     // GIR_Coverage, 9210,
     /* 1295165 */     GIR_EraseRootFromParent_Done,
     /* 1295166 */   // Label 18586: @1295166
     /* 1295166 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1295250), // Rule ID 9211 //
     /* 1295171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1295188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295249 */     // GIR_Coverage, 9211,
     /* 1295249 */     GIR_EraseRootFromParent_Done,
     /* 1295250 */   // Label 18587: @1295250
     /* 1295250 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1295334), // Rule ID 9214 //
     /* 1295255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1295272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295308 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1295311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295333 */     // GIR_Coverage, 9214,
     /* 1295333 */     GIR_EraseRootFromParent_Done,
     /* 1295334 */   // Label 18588: @1295334
     /* 1295334 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1295418), // Rule ID 9215 //
     /* 1295339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1295356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1295395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295417 */     // GIR_Coverage, 9215,
     /* 1295417 */     GIR_EraseRootFromParent_Done,
     /* 1295418 */   // Label 18589: @1295418
     /* 1295418 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1295502), // Rule ID 9218 //
     /* 1295423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1295440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295501 */     // GIR_Coverage, 9218,
     /* 1295501 */     GIR_EraseRootFromParent_Done,
     /* 1295502 */   // Label 18590: @1295502
     /* 1295502 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1295586), // Rule ID 9219 //
     /* 1295507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1295524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295560 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295585 */     // GIR_Coverage, 9219,
     /* 1295585 */     GIR_EraseRootFromParent_Done,
     /* 1295586 */   // Label 18591: @1295586
     /* 1295586 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1295670), // Rule ID 9222 //
     /* 1295591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1295608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295669 */     // GIR_Coverage, 9222,
     /* 1295669 */     GIR_EraseRootFromParent_Done,
     /* 1295670 */   // Label 18592: @1295670
     /* 1295670 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1295754), // Rule ID 9223 //
     /* 1295675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1295692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1295731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295753 */     // GIR_Coverage, 9223,
     /* 1295753 */     GIR_EraseRootFromParent_Done,
     /* 1295754 */   // Label 18593: @1295754
     /* 1295754 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1295838), // Rule ID 9226 //
     /* 1295759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1295776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1295815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295837 */     // GIR_Coverage, 9226,
     /* 1295837 */     GIR_EraseRootFromParent_Done,
     /* 1295838 */   // Label 18594: @1295838
     /* 1295838 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1295922), // Rule ID 9227 //
     /* 1295843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1295860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1295899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295921 */     // GIR_Coverage, 9227,
     /* 1295921 */     GIR_EraseRootFromParent_Done,
     /* 1295922 */   // Label 18595: @1295922
     /* 1295922 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1296006), // Rule ID 9230 //
     /* 1295927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1295935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1295944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1295983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296005 */     // GIR_Coverage, 9230,
     /* 1296005 */     GIR_EraseRootFromParent_Done,
     /* 1296006 */   // Label 18596: @1296006
     /* 1296006 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1296090), // Rule ID 9231 //
     /* 1296011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1296028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296064 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1296067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296089 */     // GIR_Coverage, 9231,
     /* 1296089 */     GIR_EraseRootFromParent_Done,
     /* 1296090 */   // Label 18597: @1296090
     /* 1296090 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1296174), // Rule ID 9234 //
     /* 1296095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1296112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1296151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296173 */     // GIR_Coverage, 9234,
     /* 1296173 */     GIR_EraseRootFromParent_Done,
     /* 1296174 */   // Label 18598: @1296174
     /* 1296174 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1296258), // Rule ID 9235 //
     /* 1296179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1296196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296232 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1296235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296257 */     // GIR_Coverage, 9235,
     /* 1296257 */     GIR_EraseRootFromParent_Done,
     /* 1296258 */   // Label 18599: @1296258
     /* 1296258 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1296342), // Rule ID 9238 //
     /* 1296263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1296274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1296277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1296280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1296319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296341 */     // GIR_Coverage, 9238,
     /* 1296341 */     GIR_EraseRootFromParent_Done,
     /* 1296342 */   // Label 18600: @1296342
     /* 1296342 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1296426), // Rule ID 9239 //
     /* 1296347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1296358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1296361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1296364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1296370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1296403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296425 */     // GIR_Coverage, 9239,
     /* 1296425 */     GIR_EraseRootFromParent_Done,
     /* 1296426 */   // Label 18601: @1296426
     /* 1296426 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1296510), // Rule ID 9242 //
     /* 1296431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1296448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1296487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296509 */     // GIR_Coverage, 9242,
     /* 1296509 */     GIR_EraseRootFromParent_Done,
     /* 1296510 */   // Label 18602: @1296510
     /* 1296510 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1296594), // Rule ID 9243 //
     /* 1296515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1296532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1296571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296593 */     // GIR_Coverage, 9243,
     /* 1296593 */     GIR_EraseRootFromParent_Done,
     /* 1296594 */   // Label 18603: @1296594
     /* 1296594 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1296678), // Rule ID 9246 //
     /* 1296599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1296616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296652 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1296655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296677 */     // GIR_Coverage, 9246,
     /* 1296677 */     GIR_EraseRootFromParent_Done,
     /* 1296678 */   // Label 18604: @1296678
     /* 1296678 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1296762), // Rule ID 9247 //
     /* 1296683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1296700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296736 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1296739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296761 */     // GIR_Coverage, 9247,
     /* 1296761 */     GIR_EraseRootFromParent_Done,
     /* 1296762 */   // Label 18605: @1296762
     /* 1296762 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1296846), // Rule ID 9250 //
     /* 1296767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1296778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1296781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1296784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1296790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296820 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1296823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296845 */     // GIR_Coverage, 9250,
     /* 1296845 */     GIR_EraseRootFromParent_Done,
     /* 1296846 */   // Label 18606: @1296846
     /* 1296846 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1296930), // Rule ID 9251 //
     /* 1296851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1296862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1296865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1296868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1296874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296904 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1296907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296929 */     // GIR_Coverage, 9251,
     /* 1296929 */     GIR_EraseRootFromParent_Done,
     /* 1296930 */   // Label 18607: @1296930
     /* 1296930 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1297014), // Rule ID 9254 //
     /* 1296935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1296952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1296991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297013 */     // GIR_Coverage, 9254,
     /* 1297013 */     GIR_EraseRootFromParent_Done,
     /* 1297014 */   // Label 18608: @1297014
     /* 1297014 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1297098), // Rule ID 9255 //
     /* 1297019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1297036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1297075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297097 */     // GIR_Coverage, 9255,
     /* 1297097 */     GIR_EraseRootFromParent_Done,
     /* 1297098 */   // Label 18609: @1297098
     /* 1297098 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1297182), // Rule ID 9258 //
     /* 1297103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1297120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1297159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297181 */     // GIR_Coverage, 9258,
     /* 1297181 */     GIR_EraseRootFromParent_Done,
     /* 1297182 */   // Label 18610: @1297182
     /* 1297182 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1297266), // Rule ID 9259 //
     /* 1297187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1297204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1297243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297265 */     // GIR_Coverage, 9259,
     /* 1297265 */     GIR_EraseRootFromParent_Done,
     /* 1297266 */   // Label 18611: @1297266
     /* 1297266 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1297350), // Rule ID 9262 //
     /* 1297271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1297282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1297285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1297288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1297294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297324 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1297327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297349 */     // GIR_Coverage, 9262,
     /* 1297349 */     GIR_EraseRootFromParent_Done,
     /* 1297350 */   // Label 18612: @1297350
     /* 1297350 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1297434), // Rule ID 9263 //
     /* 1297355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1297366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1297369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1297372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1297378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297408 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1297411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297433 */     // GIR_Coverage, 9263,
     /* 1297433 */     GIR_EraseRootFromParent_Done,
     /* 1297434 */   // Label 18613: @1297434
     /* 1297434 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1297518), // Rule ID 9266 //
     /* 1297439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1297456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1297495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297517 */     // GIR_Coverage, 9266,
     /* 1297517 */     GIR_EraseRootFromParent_Done,
     /* 1297518 */   // Label 18614: @1297518
     /* 1297518 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1297602), // Rule ID 9267 //
     /* 1297523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1297540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1297579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297601 */     // GIR_Coverage, 9267,
     /* 1297601 */     GIR_EraseRootFromParent_Done,
     /* 1297602 */   // Label 18615: @1297602
     /* 1297602 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1297686), // Rule ID 9270 //
     /* 1297607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1297624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1297663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297685 */     // GIR_Coverage, 9270,
     /* 1297685 */     GIR_EraseRootFromParent_Done,
     /* 1297686 */   // Label 18616: @1297686
     /* 1297686 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1297770), // Rule ID 9271 //
     /* 1297691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1297708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1297747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297769 */     // GIR_Coverage, 9271,
     /* 1297769 */     GIR_EraseRootFromParent_Done,
     /* 1297770 */   // Label 18617: @1297770
     /* 1297770 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1297854), // Rule ID 9274 //
     /* 1297775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1297792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1297831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297853 */     // GIR_Coverage, 9274,
     /* 1297853 */     GIR_EraseRootFromParent_Done,
     /* 1297854 */   // Label 18618: @1297854
     /* 1297854 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1297938), // Rule ID 9275 //
     /* 1297859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1297876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1297915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297937 */     // GIR_Coverage, 9275,
     /* 1297937 */     GIR_EraseRootFromParent_Done,
     /* 1297938 */   // Label 18619: @1297938
     /* 1297938 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1298022), // Rule ID 9278 //
     /* 1297943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1297960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1297999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298021 */     // GIR_Coverage, 9278,
     /* 1298021 */     GIR_EraseRootFromParent_Done,
     /* 1298022 */   // Label 18620: @1298022
     /* 1298022 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1298106), // Rule ID 9279 //
     /* 1298027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1298044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298080 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1298083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298105 */     // GIR_Coverage, 9279,
     /* 1298105 */     GIR_EraseRootFromParent_Done,
     /* 1298106 */   // Label 18621: @1298106
     /* 1298106 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1298190), // Rule ID 9282 //
     /* 1298111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1298128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298189 */     // GIR_Coverage, 9282,
     /* 1298189 */     GIR_EraseRootFromParent_Done,
     /* 1298190 */   // Label 18622: @1298190
     /* 1298190 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1298274), // Rule ID 9283 //
     /* 1298195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1298212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298273 */     // GIR_Coverage, 9283,
     /* 1298273 */     GIR_EraseRootFromParent_Done,
     /* 1298274 */   // Label 18623: @1298274
     /* 1298274 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1298358), // Rule ID 9286 //
     /* 1298279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1298296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1298335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298357 */     // GIR_Coverage, 9286,
     /* 1298357 */     GIR_EraseRootFromParent_Done,
     /* 1298358 */   // Label 18624: @1298358
     /* 1298358 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1298442), // Rule ID 9287 //
     /* 1298363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1298380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1298401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1298419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298441 */     // GIR_Coverage, 9287,
     /* 1298441 */     GIR_EraseRootFromParent_Done,
     /* 1298442 */   // Label 18625: @1298442
     /* 1298442 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1298526), // Rule ID 9378 //
     /* 1298447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1298464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1298503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298525 */     // GIR_Coverage, 9378,
     /* 1298525 */     GIR_EraseRootFromParent_Done,
     /* 1298526 */   // Label 18626: @1298526
     /* 1298526 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1298610), // Rule ID 9379 //
     /* 1298531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1298548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1298587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298609 */     // GIR_Coverage, 9379,
     /* 1298609 */     GIR_EraseRootFromParent_Done,
     /* 1298610 */   // Label 18627: @1298610
     /* 1298610 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1298694), // Rule ID 9382 //
     /* 1298615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1298632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1298671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298693 */     // GIR_Coverage, 9382,
     /* 1298693 */     GIR_EraseRootFromParent_Done,
     /* 1298694 */   // Label 18628: @1298694
     /* 1298694 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1298778), // Rule ID 9383 //
     /* 1298699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1298716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1298755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298777 */     // GIR_Coverage, 9383,
     /* 1298777 */     GIR_EraseRootFromParent_Done,
     /* 1298778 */   // Label 18629: @1298778
     /* 1298778 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1298862), // Rule ID 9386 //
     /* 1298783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1298800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1298839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298861 */     // GIR_Coverage, 9386,
     /* 1298861 */     GIR_EraseRootFromParent_Done,
     /* 1298862 */   // Label 18630: @1298862
     /* 1298862 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1298946), // Rule ID 9387 //
     /* 1298867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1298884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1298923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298945 */     // GIR_Coverage, 9387,
     /* 1298945 */     GIR_EraseRootFromParent_Done,
     /* 1298946 */   // Label 18631: @1298946
     /* 1298946 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1299030), // Rule ID 9390 //
     /* 1298951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1298959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1299007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299029 */     // GIR_Coverage, 9390,
     /* 1299029 */     GIR_EraseRootFromParent_Done,
     /* 1299030 */   // Label 18632: @1299030
     /* 1299030 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1299114), // Rule ID 9391 //
     /* 1299035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1299052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1299091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299113 */     // GIR_Coverage, 9391,
     /* 1299113 */     GIR_EraseRootFromParent_Done,
     /* 1299114 */   // Label 18633: @1299114
     /* 1299114 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1299198), // Rule ID 9394 //
     /* 1299119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1299130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1299133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1299136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1299175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299197 */     // GIR_Coverage, 9394,
     /* 1299197 */     GIR_EraseRootFromParent_Done,
     /* 1299198 */   // Label 18634: @1299198
     /* 1299198 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1299282), // Rule ID 9395 //
     /* 1299203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1299214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1299217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1299220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1299259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299281 */     // GIR_Coverage, 9395,
     /* 1299281 */     GIR_EraseRootFromParent_Done,
     /* 1299282 */   // Label 18635: @1299282
     /* 1299282 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1299366), // Rule ID 9398 //
     /* 1299287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1299304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1299343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299365 */     // GIR_Coverage, 9398,
     /* 1299365 */     GIR_EraseRootFromParent_Done,
     /* 1299366 */   // Label 18636: @1299366
     /* 1299366 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1299450), // Rule ID 9399 //
     /* 1299371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1299388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1299427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299449 */     // GIR_Coverage, 9399,
     /* 1299449 */     GIR_EraseRootFromParent_Done,
     /* 1299450 */   // Label 18637: @1299450
     /* 1299450 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1299534), // Rule ID 9402 //
     /* 1299455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1299472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299533 */     // GIR_Coverage, 9402,
     /* 1299533 */     GIR_EraseRootFromParent_Done,
     /* 1299534 */   // Label 18638: @1299534
     /* 1299534 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1299618), // Rule ID 9403 //
     /* 1299539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1299556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299617 */     // GIR_Coverage, 9403,
     /* 1299617 */     GIR_EraseRootFromParent_Done,
     /* 1299618 */   // Label 18639: @1299618
     /* 1299618 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1299702), // Rule ID 9406 //
     /* 1299623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1299640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299676 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299701 */     // GIR_Coverage, 9406,
     /* 1299701 */     GIR_EraseRootFromParent_Done,
     /* 1299702 */   // Label 18640: @1299702
     /* 1299702 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1299786), // Rule ID 9407 //
     /* 1299707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1299724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299785 */     // GIR_Coverage, 9407,
     /* 1299785 */     GIR_EraseRootFromParent_Done,
     /* 1299786 */   // Label 18641: @1299786
     /* 1299786 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1299870), // Rule ID 9410 //
     /* 1299791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1299802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1299805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1299808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299844 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299869 */     // GIR_Coverage, 9410,
     /* 1299869 */     GIR_EraseRootFromParent_Done,
     /* 1299870 */   // Label 18642: @1299870
     /* 1299870 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1299954), // Rule ID 9411 //
     /* 1299875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1299886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1299889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1299892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1299931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299953 */     // GIR_Coverage, 9411,
     /* 1299953 */     GIR_EraseRootFromParent_Done,
     /* 1299954 */   // Label 18643: @1299954
     /* 1299954 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1300038), // Rule ID 9414 //
     /* 1299959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1299962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1299967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1300015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300037 */     // GIR_Coverage, 9414,
     /* 1300037 */     GIR_EraseRootFromParent_Done,
     /* 1300038 */   // Label 18644: @1300038
     /* 1300038 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1300122), // Rule ID 9415 //
     /* 1300043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1300060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1300099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300121 */     // GIR_Coverage, 9415,
     /* 1300121 */     GIR_EraseRootFromParent_Done,
     /* 1300122 */   // Label 18645: @1300122
     /* 1300122 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1300206), // Rule ID 9418 //
     /* 1300127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1300144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1300183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300205 */     // GIR_Coverage, 9418,
     /* 1300205 */     GIR_EraseRootFromParent_Done,
     /* 1300206 */   // Label 18646: @1300206
     /* 1300206 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1300290), // Rule ID 9419 //
     /* 1300211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1300228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300264 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1300267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300289 */     // GIR_Coverage, 9419,
     /* 1300289 */     GIR_EraseRootFromParent_Done,
     /* 1300290 */   // Label 18647: @1300290
     /* 1300290 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1300374), // Rule ID 9422 //
     /* 1300295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1300312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300348 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1300351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300373 */     // GIR_Coverage, 9422,
     /* 1300373 */     GIR_EraseRootFromParent_Done,
     /* 1300374 */   // Label 18648: @1300374
     /* 1300374 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1300458), // Rule ID 9423 //
     /* 1300379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1300396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300432 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1300435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300457 */     // GIR_Coverage, 9423,
     /* 1300457 */     GIR_EraseRootFromParent_Done,
     /* 1300458 */   // Label 18649: @1300458
     /* 1300458 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1300542), // Rule ID 9426 //
     /* 1300463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1300474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1300477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1300480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1300486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300516 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1300519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300541 */     // GIR_Coverage, 9426,
     /* 1300541 */     GIR_EraseRootFromParent_Done,
     /* 1300542 */   // Label 18650: @1300542
     /* 1300542 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1300626), // Rule ID 9427 //
     /* 1300547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1300558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1300561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1300564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1300570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300600 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1300603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300625 */     // GIR_Coverage, 9427,
     /* 1300625 */     GIR_EraseRootFromParent_Done,
     /* 1300626 */   // Label 18651: @1300626
     /* 1300626 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1300710), // Rule ID 9430 //
     /* 1300631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1300648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1300687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300709 */     // GIR_Coverage, 9430,
     /* 1300709 */     GIR_EraseRootFromParent_Done,
     /* 1300710 */   // Label 18652: @1300710
     /* 1300710 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1300794), // Rule ID 9431 //
     /* 1300715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1300732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1300771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300793 */     // GIR_Coverage, 9431,
     /* 1300793 */     GIR_EraseRootFromParent_Done,
     /* 1300794 */   // Label 18653: @1300794
     /* 1300794 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1300878), // Rule ID 9434 //
     /* 1300799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1300816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300852 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1300855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300877 */     // GIR_Coverage, 9434,
     /* 1300877 */     GIR_EraseRootFromParent_Done,
     /* 1300878 */   // Label 18654: @1300878
     /* 1300878 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1300962), // Rule ID 9435 //
     /* 1300883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1300900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300936 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1300939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300961 */     // GIR_Coverage, 9435,
     /* 1300961 */     GIR_EraseRootFromParent_Done,
     /* 1300962 */   // Label 18655: @1300962
     /* 1300962 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1301046), // Rule ID 9438 //
     /* 1300967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301020 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1301023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301045 */     // GIR_Coverage, 9438,
     /* 1301045 */     GIR_EraseRootFromParent_Done,
     /* 1301046 */   // Label 18656: @1301046
     /* 1301046 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1301130), // Rule ID 9439 //
     /* 1301051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1301062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1301065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1301068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1301074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301104 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1301107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301129 */     // GIR_Coverage, 9439,
     /* 1301129 */     GIR_EraseRootFromParent_Done,
     /* 1301130 */   // Label 18657: @1301130
     /* 1301130 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1301214), // Rule ID 9442 //
     /* 1301135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1301152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1301173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1301191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301213 */     // GIR_Coverage, 9442,
     /* 1301213 */     GIR_EraseRootFromParent_Done,
     /* 1301214 */   // Label 18658: @1301214
     /* 1301214 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1301298), // Rule ID 9443 //
     /* 1301219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1301236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1301257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1301275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301297 */     // GIR_Coverage, 9443,
     /* 1301297 */     GIR_EraseRootFromParent_Done,
     /* 1301298 */   // Label 18659: @1301298
     /* 1301298 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1301382), // Rule ID 9446 //
     /* 1301303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1301320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301356 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1301359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301381 */     // GIR_Coverage, 9446,
     /* 1301381 */     GIR_EraseRootFromParent_Done,
     /* 1301382 */   // Label 18660: @1301382
     /* 1301382 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1301466), // Rule ID 9447 //
     /* 1301387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1301404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1301443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301465 */     // GIR_Coverage, 9447,
     /* 1301465 */     GIR_EraseRootFromParent_Done,
     /* 1301466 */   // Label 18661: @1301466
     /* 1301466 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1301550), // Rule ID 9450 //
     /* 1301471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1301482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1301485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1301488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1301494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1301527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301549 */     // GIR_Coverage, 9450,
     /* 1301549 */     GIR_EraseRootFromParent_Done,
     /* 1301550 */   // Label 18662: @1301550
     /* 1301550 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1301634), // Rule ID 9451 //
     /* 1301555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1301566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1301569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1301572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1301578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1301611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301633 */     // GIR_Coverage, 9451,
     /* 1301633 */     GIR_EraseRootFromParent_Done,
     /* 1301634 */   // Label 18663: @1301634
     /* 1301634 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1301718), // Rule ID 9454 //
     /* 1301639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1301642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1301656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1301677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1301695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301717 */     // GIR_Coverage, 9454,
     /* 1301717 */     GIR_EraseRootFromParent_Done,
     /* 1301718 */   // Label 18664: @1301718
     /* 1301718 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1301802), // Rule ID 9455 //
     /* 1301723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1301740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1301761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1301779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301801 */     // GIR_Coverage, 9455,
     /* 1301801 */     GIR_EraseRootFromParent_Done,
     /* 1301802 */   // Label 18665: @1301802
     /* 1301802 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1301886), // Rule ID 9458 //
     /* 1301807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1301810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1301824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1301863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301885 */     // GIR_Coverage, 9458,
     /* 1301885 */     GIR_EraseRootFromParent_Done,
     /* 1301886 */   // Label 18666: @1301886
     /* 1301886 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1301970), // Rule ID 9459 //
     /* 1301891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1301908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1301947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301969 */     // GIR_Coverage, 9459,
     /* 1301969 */     GIR_EraseRootFromParent_Done,
     /* 1301970 */   // Label 18667: @1301970
     /* 1301970 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1302054), // Rule ID 9462 //
     /* 1301975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1301978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302053 */     // GIR_Coverage, 9462,
     /* 1302053 */     GIR_EraseRootFromParent_Done,
     /* 1302054 */   // Label 18668: @1302054
     /* 1302054 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1302138), // Rule ID 9463 //
     /* 1302059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1302076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302137 */     // GIR_Coverage, 9463,
     /* 1302137 */     GIR_EraseRootFromParent_Done,
     /* 1302138 */   // Label 18669: @1302138
     /* 1302138 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1302222), // Rule ID 9554 //
     /* 1302143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1302160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1302163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1302199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302221 */     // GIR_Coverage, 9554,
     /* 1302221 */     GIR_EraseRootFromParent_Done,
     /* 1302222 */   // Label 18670: @1302222
     /* 1302222 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1302306), // Rule ID 9555 //
     /* 1302227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1302244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1302247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1302283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302305 */     // GIR_Coverage, 9555,
     /* 1302305 */     GIR_EraseRootFromParent_Done,
     /* 1302306 */   // Label 18671: @1302306
     /* 1302306 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1302390), // Rule ID 9558 //
     /* 1302311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1302328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1302331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302389 */     // GIR_Coverage, 9558,
     /* 1302389 */     GIR_EraseRootFromParent_Done,
     /* 1302390 */   // Label 18672: @1302390
     /* 1302390 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1302474), // Rule ID 9559 //
     /* 1302395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1302412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1302415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302473 */     // GIR_Coverage, 9559,
     /* 1302473 */     GIR_EraseRootFromParent_Done,
     /* 1302474 */   // Label 18673: @1302474
     /* 1302474 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1302558), // Rule ID 9562 //
     /* 1302479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1302496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1302499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1302535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302557 */     // GIR_Coverage, 9562,
     /* 1302557 */     GIR_EraseRootFromParent_Done,
     /* 1302558 */   // Label 18674: @1302558
     /* 1302558 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1302642), // Rule ID 9563 //
     /* 1302563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1302580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1302583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302616 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1302619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302641 */     // GIR_Coverage, 9563,
     /* 1302641 */     GIR_EraseRootFromParent_Done,
     /* 1302642 */   // Label 18675: @1302642
     /* 1302642 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1302726), // Rule ID 9566 //
     /* 1302647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1302664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1302667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302725 */     // GIR_Coverage, 9566,
     /* 1302725 */     GIR_EraseRootFromParent_Done,
     /* 1302726 */   // Label 18676: @1302726
     /* 1302726 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1302810), // Rule ID 9567 //
     /* 1302731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1302748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1302751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302809 */     // GIR_Coverage, 9567,
     /* 1302809 */     GIR_EraseRootFromParent_Done,
     /* 1302810 */   // Label 18677: @1302810
     /* 1302810 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1302894), // Rule ID 9570 //
     /* 1302815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1302835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302893 */     // GIR_Coverage, 9570,
     /* 1302893 */     GIR_EraseRootFromParent_Done,
     /* 1302894 */   // Label 18678: @1302894
     /* 1302894 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1302978), // Rule ID 9571 //
     /* 1302899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1302919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1302955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302977 */     // GIR_Coverage, 9571,
     /* 1302977 */     GIR_EraseRootFromParent_Done,
     /* 1302978 */   // Label 18679: @1302978
     /* 1302978 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1303062), // Rule ID 9574 //
     /* 1302983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1302991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1303000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1303003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303061 */     // GIR_Coverage, 9574,
     /* 1303061 */     GIR_EraseRootFromParent_Done,
     /* 1303062 */   // Label 18680: @1303062
     /* 1303062 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1303146), // Rule ID 9575 //
     /* 1303067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1303084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1303087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303145 */     // GIR_Coverage, 9575,
     /* 1303145 */     GIR_EraseRootFromParent_Done,
     /* 1303146 */   // Label 18681: @1303146
     /* 1303146 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1303230), // Rule ID 9578 //
     /* 1303151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1303168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1303171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303229 */     // GIR_Coverage, 9578,
     /* 1303229 */     GIR_EraseRootFromParent_Done,
     /* 1303230 */   // Label 18682: @1303230
     /* 1303230 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1303314), // Rule ID 9579 //
     /* 1303235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1303252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1303255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303313 */     // GIR_Coverage, 9579,
     /* 1303313 */     GIR_EraseRootFromParent_Done,
     /* 1303314 */   // Label 18683: @1303314
     /* 1303314 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1303398), // Rule ID 9582 //
     /* 1303319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1303336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1303339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303397 */     // GIR_Coverage, 9582,
     /* 1303397 */     GIR_EraseRootFromParent_Done,
     /* 1303398 */   // Label 18684: @1303398
     /* 1303398 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1303482), // Rule ID 9583 //
     /* 1303403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1303420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1303423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303481 */     // GIR_Coverage, 9583,
     /* 1303481 */     GIR_EraseRootFromParent_Done,
     /* 1303482 */   // Label 18685: @1303482
     /* 1303482 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1303566), // Rule ID 9586 //
     /* 1303487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1303490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1303498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1303501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1303504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1303507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1303510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303540 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1303561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303565 */     // GIR_Coverage, 9586,
     /* 1303565 */     GIR_EraseRootFromParent_Done,
     /* 1303566 */   // Label 18686: @1303566
     /* 1303566 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1303650), // Rule ID 9587 //
     /* 1303571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1303574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1303582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1303585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1303588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1303591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1303594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1303627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1303645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303649 */     // GIR_Coverage, 9587,
     /* 1303649 */     GIR_EraseRootFromParent_Done,
     /* 1303650 */   // Label 18687: @1303650
     /* 1303650 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1303734), // Rule ID 9590 //
     /* 1303655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1303672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1303675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303708 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1303711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303733 */     // GIR_Coverage, 9590,
     /* 1303733 */     GIR_EraseRootFromParent_Done,
     /* 1303734 */   // Label 18688: @1303734
     /* 1303734 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1303818), // Rule ID 9591 //
     /* 1303739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1303756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1303759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303792 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1303795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303817 */     // GIR_Coverage, 9591,
     /* 1303817 */     GIR_EraseRootFromParent_Done,
     /* 1303818 */   // Label 18689: @1303818
     /* 1303818 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1303902), // Rule ID 9594 //
     /* 1303823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1303843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303876 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1303879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303901 */     // GIR_Coverage, 9594,
     /* 1303901 */     GIR_EraseRootFromParent_Done,
     /* 1303902 */   // Label 18690: @1303902
     /* 1303902 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1303986), // Rule ID 9595 //
     /* 1303907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1303927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1303963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303985 */     // GIR_Coverage, 9595,
     /* 1303985 */     GIR_EraseRootFromParent_Done,
     /* 1303986 */   // Label 18691: @1303986
     /* 1303986 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1304070), // Rule ID 9598 //
     /* 1303991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1303999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1304002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1304005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1304008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1304011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1304014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304044 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1304047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304069 */     // GIR_Coverage, 9598,
     /* 1304069 */     GIR_EraseRootFromParent_Done,
     /* 1304070 */   // Label 18692: @1304070
     /* 1304070 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1304154), // Rule ID 9599 //
     /* 1304075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1304086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1304089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1304092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1304095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1304098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304128 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1304131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304153 */     // GIR_Coverage, 9599,
     /* 1304153 */     GIR_EraseRootFromParent_Done,
     /* 1304154 */   // Label 18693: @1304154
     /* 1304154 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1304238), // Rule ID 9602 //
     /* 1304159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1304176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1304179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1304215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304237 */     // GIR_Coverage, 9602,
     /* 1304237 */     GIR_EraseRootFromParent_Done,
     /* 1304238 */   // Label 18694: @1304238
     /* 1304238 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1304322), // Rule ID 9603 //
     /* 1304243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1304260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1304263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1304299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304321 */     // GIR_Coverage, 9603,
     /* 1304321 */     GIR_EraseRootFromParent_Done,
     /* 1304322 */   // Label 18695: @1304322
     /* 1304322 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1304406), // Rule ID 9606 //
     /* 1304327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1304344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1304347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1304383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304405 */     // GIR_Coverage, 9606,
     /* 1304405 */     GIR_EraseRootFromParent_Done,
     /* 1304406 */   // Label 18696: @1304406
     /* 1304406 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1304490), // Rule ID 9607 //
     /* 1304411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1304428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1304431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1304467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304489 */     // GIR_Coverage, 9607,
     /* 1304489 */     GIR_EraseRootFromParent_Done,
     /* 1304490 */   // Label 18697: @1304490
     /* 1304490 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1304574), // Rule ID 9610 //
     /* 1304495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1304506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1304509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1304512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1304515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1304518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304548 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1304551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304573 */     // GIR_Coverage, 9610,
     /* 1304573 */     GIR_EraseRootFromParent_Done,
     /* 1304574 */   // Label 18698: @1304574
     /* 1304574 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1304658), // Rule ID 9611 //
     /* 1304579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1304590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1304593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1304596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1304599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1304602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304632 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1304635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304657 */     // GIR_Coverage, 9611,
     /* 1304657 */     GIR_EraseRootFromParent_Done,
     /* 1304658 */   // Label 18699: @1304658
     /* 1304658 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1304742), // Rule ID 9614 //
     /* 1304663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1304683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1304719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304741 */     // GIR_Coverage, 9614,
     /* 1304741 */     GIR_EraseRootFromParent_Done,
     /* 1304742 */   // Label 18700: @1304742
     /* 1304742 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1304826), // Rule ID 9615 //
     /* 1304747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1304767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1304803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304825 */     // GIR_Coverage, 9615,
     /* 1304825 */     GIR_EraseRootFromParent_Done,
     /* 1304826 */   // Label 18701: @1304826
     /* 1304826 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1304910), // Rule ID 9618 //
     /* 1304831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1304851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304884 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1304887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304909 */     // GIR_Coverage, 9618,
     /* 1304909 */     GIR_EraseRootFromParent_Done,
     /* 1304910 */   // Label 18702: @1304910
     /* 1304910 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1304994), // Rule ID 9619 //
     /* 1304915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1304935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1304971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304993 */     // GIR_Coverage, 9619,
     /* 1304993 */     GIR_EraseRootFromParent_Done,
     /* 1304994 */   // Label 18703: @1304994
     /* 1304994 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1305078), // Rule ID 9622 //
     /* 1304999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1305016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1305019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1305022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305052 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1305055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305077 */     // GIR_Coverage, 9622,
     /* 1305077 */     GIR_EraseRootFromParent_Done,
     /* 1305078 */   // Label 18704: @1305078
     /* 1305078 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1305162), // Rule ID 9623 //
     /* 1305083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1305100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1305103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1305106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305136 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1305139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305161 */     // GIR_Coverage, 9623,
     /* 1305161 */     GIR_EraseRootFromParent_Done,
     /* 1305162 */   // Label 18705: @1305162
     /* 1305162 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1305246), // Rule ID 9626 //
     /* 1305167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1305170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1305184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1305187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305220 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1305223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305245 */     // GIR_Coverage, 9626,
     /* 1305245 */     GIR_EraseRootFromParent_Done,
     /* 1305246 */   // Label 18706: @1305246
     /* 1305246 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1305330), // Rule ID 9627 //
     /* 1305251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1305254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1305268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1305271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1305307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305329 */     // GIR_Coverage, 9627,
     /* 1305329 */     GIR_EraseRootFromParent_Done,
     /* 1305330 */   // Label 18707: @1305330
     /* 1305330 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1305414), // Rule ID 9630 //
     /* 1305335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1305338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1305352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1305355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1305373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1305377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1305391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305413 */     // GIR_Coverage, 9630,
     /* 1305413 */     GIR_EraseRootFromParent_Done,
     /* 1305414 */   // Label 18708: @1305414
     /* 1305414 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1305498), // Rule ID 9631 //
     /* 1305419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1305422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1305436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1305439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1305457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1305461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305472 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1305475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305497 */     // GIR_Coverage, 9631,
     /* 1305497 */     GIR_EraseRootFromParent_Done,
     /* 1305498 */   // Label 18709: @1305498
     /* 1305498 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1305582), // Rule ID 9634 //
     /* 1305503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1305506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1305520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1305523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1305559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305581 */     // GIR_Coverage, 9634,
     /* 1305581 */     GIR_EraseRootFromParent_Done,
     /* 1305582 */   // Label 18710: @1305582
     /* 1305582 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1305666), // Rule ID 9635 //
     /* 1305587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1305590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1305604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1305607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1305629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1305643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305665 */     // GIR_Coverage, 9635,
     /* 1305665 */     GIR_EraseRootFromParent_Done,
     /* 1305666 */   // Label 18711: @1305666
     /* 1305666 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1305750), // Rule ID 9638 //
     /* 1305671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1305688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1305691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1305727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305749 */     // GIR_Coverage, 9638,
     /* 1305749 */     GIR_EraseRootFromParent_Done,
     /* 1305750 */   // Label 18712: @1305750
     /* 1305750 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1305834), // Rule ID 9639 //
     /* 1305755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1305772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1305775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1305811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305833 */     // GIR_Coverage, 9639,
     /* 1305833 */     GIR_EraseRootFromParent_Done,
     /* 1305834 */   // Label 18713: @1305834
     /* 1305834 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1305918), // Rule ID 9642 //
     /* 1305839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1305856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1305859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1305895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305917 */     // GIR_Coverage, 9642,
     /* 1305917 */     GIR_EraseRootFromParent_Done,
     /* 1305918 */   // Label 18714: @1305918
     /* 1305918 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1306002), // Rule ID 9643 //
     /* 1305923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1305931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1305940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1305943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1305979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306001 */     // GIR_Coverage, 9643,
     /* 1306001 */     GIR_EraseRootFromParent_Done,
     /* 1306002 */   // Label 18715: @1306002
     /* 1306002 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1306086), // Rule ID 9646 //
     /* 1306007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1306024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1306027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306085 */     // GIR_Coverage, 9646,
     /* 1306085 */     GIR_EraseRootFromParent_Done,
     /* 1306086 */   // Label 18716: @1306086
     /* 1306086 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1306170), // Rule ID 9647 //
     /* 1306091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1306108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1306111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306169 */     // GIR_Coverage, 9647,
     /* 1306169 */     GIR_EraseRootFromParent_Done,
     /* 1306170 */   // Label 18717: @1306170
     /* 1306170 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1306254), // Rule ID 9650 //
     /* 1306175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1306192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1306195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1306231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306253 */     // GIR_Coverage, 9650,
     /* 1306253 */     GIR_EraseRootFromParent_Done,
     /* 1306254 */   // Label 18718: @1306254
     /* 1306254 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1306338), // Rule ID 9651 //
     /* 1306259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1306276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1306279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1306315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306337 */     // GIR_Coverage, 9651,
     /* 1306337 */     GIR_EraseRootFromParent_Done,
     /* 1306338 */   // Label 18719: @1306338
     /* 1306338 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1306422), // Rule ID 9654 //
     /* 1306343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1306360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1306363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306421 */     // GIR_Coverage, 9654,
     /* 1306421 */     GIR_EraseRootFromParent_Done,
     /* 1306422 */   // Label 18720: @1306422
     /* 1306422 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1306506), // Rule ID 9655 //
     /* 1306427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1306444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1306447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306505 */     // GIR_Coverage, 9655,
     /* 1306505 */     GIR_EraseRootFromParent_Done,
     /* 1306506 */   // Label 18721: @1306506
     /* 1306506 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1306590), // Rule ID 9658 //
     /* 1306511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1306528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1306531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306589 */     // GIR_Coverage, 9658,
     /* 1306589 */     GIR_EraseRootFromParent_Done,
     /* 1306590 */   // Label 18722: @1306590
     /* 1306590 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1306674), // Rule ID 9659 //
     /* 1306595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1306612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1306615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1306651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306673 */     // GIR_Coverage, 9659,
     /* 1306673 */     GIR_EraseRootFromParent_Done,
     /* 1306674 */   // Label 18723: @1306674
     /* 1306674 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1306758), // Rule ID 9662 //
     /* 1306679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1306696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1306699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306732 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1306735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306757 */     // GIR_Coverage, 9662,
     /* 1306757 */     GIR_EraseRootFromParent_Done,
     /* 1306758 */   // Label 18724: @1306758
     /* 1306758 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1306842), // Rule ID 9663 //
     /* 1306763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1306780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1306783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1306819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306841 */     // GIR_Coverage, 9663,
     /* 1306841 */     GIR_EraseRootFromParent_Done,
     /* 1306842 */   // Label 18725: @1306842
     /* 1306842 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1306926), // Rule ID 9666 //
     /* 1306847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1306864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1306867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1306903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306925 */     // GIR_Coverage, 9666,
     /* 1306925 */     GIR_EraseRootFromParent_Done,
     /* 1306926 */   // Label 18726: @1306926
     /* 1306926 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1307010), // Rule ID 9667 //
     /* 1306931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1306939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1306948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1306951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1306987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307009 */     // GIR_Coverage, 9667,
     /* 1307009 */     GIR_EraseRootFromParent_Done,
     /* 1307010 */   // Label 18727: @1307010
     /* 1307010 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1307094), // Rule ID 9670 //
     /* 1307015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1307032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1307035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1307071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307093 */     // GIR_Coverage, 9670,
     /* 1307093 */     GIR_EraseRootFromParent_Done,
     /* 1307094 */   // Label 18728: @1307094
     /* 1307094 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1307178), // Rule ID 9671 //
     /* 1307099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1307116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1307119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307152 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1307155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307177 */     // GIR_Coverage, 9671,
     /* 1307177 */     GIR_EraseRootFromParent_Done,
     /* 1307178 */   // Label 18729: @1307178
     /* 1307178 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1307262), // Rule ID 9674 //
     /* 1307183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1307194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1307197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1307200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1307203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1307206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307236 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1307239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307261 */     // GIR_Coverage, 9674,
     /* 1307261 */     GIR_EraseRootFromParent_Done,
     /* 1307262 */   // Label 18730: @1307262
     /* 1307262 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1307346), // Rule ID 9675 //
     /* 1307267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1307278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1307281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1307284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1307287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1307290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1307323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307345 */     // GIR_Coverage, 9675,
     /* 1307345 */     GIR_EraseRootFromParent_Done,
     /* 1307346 */   // Label 18731: @1307346
     /* 1307346 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1307430), // Rule ID 9678 //
     /* 1307351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1307368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1307371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1307407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307429 */     // GIR_Coverage, 9678,
     /* 1307429 */     GIR_EraseRootFromParent_Done,
     /* 1307430 */   // Label 18732: @1307430
     /* 1307430 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1307514), // Rule ID 9679 //
     /* 1307435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1307452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1307455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1307491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307513 */     // GIR_Coverage, 9679,
     /* 1307513 */     GIR_EraseRootFromParent_Done,
     /* 1307514 */   // Label 18733: @1307514
     /* 1307514 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1307598), // Rule ID 9682 //
     /* 1307519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1307536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1307539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307572 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1307575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307597 */     // GIR_Coverage, 9682,
     /* 1307597 */     GIR_EraseRootFromParent_Done,
     /* 1307598 */   // Label 18734: @1307598
     /* 1307598 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1307682), // Rule ID 9683 //
     /* 1307603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1307620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1307623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307656 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1307659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307681 */     // GIR_Coverage, 9683,
     /* 1307681 */     GIR_EraseRootFromParent_Done,
     /* 1307682 */   // Label 18735: @1307682
     /* 1307682 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1307766), // Rule ID 9686 //
     /* 1307687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1307698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1307701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1307704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1307707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1307710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307740 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1307743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307765 */     // GIR_Coverage, 9686,
     /* 1307765 */     GIR_EraseRootFromParent_Done,
     /* 1307766 */   // Label 18736: @1307766
     /* 1307766 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1307850), // Rule ID 9687 //
     /* 1307771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1307782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1307785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1307788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1307791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1307794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307824 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1307827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307849 */     // GIR_Coverage, 9687,
     /* 1307849 */     GIR_EraseRootFromParent_Done,
     /* 1307850 */   // Label 18737: @1307850
     /* 1307850 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1307934), // Rule ID 9690 //
     /* 1307855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1307872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1307875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1307911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307933 */     // GIR_Coverage, 9690,
     /* 1307933 */     GIR_EraseRootFromParent_Done,
     /* 1307934 */   // Label 18738: @1307934
     /* 1307934 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1308018), // Rule ID 9691 //
     /* 1307939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1307956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1307959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1307995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308017 */     // GIR_Coverage, 9691,
     /* 1308017 */     GIR_EraseRootFromParent_Done,
     /* 1308018 */   // Label 18739: @1308018
     /* 1308018 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1308102), // Rule ID 9694 //
     /* 1308023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1308040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1308043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308076 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1308079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308101 */     // GIR_Coverage, 9694,
     /* 1308101 */     GIR_EraseRootFromParent_Done,
     /* 1308102 */   // Label 18740: @1308102
     /* 1308102 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1308186), // Rule ID 9695 //
     /* 1308107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1308124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1308127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308160 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1308163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308185 */     // GIR_Coverage, 9695,
     /* 1308185 */     GIR_EraseRootFromParent_Done,
     /* 1308186 */   // Label 18741: @1308186
     /* 1308186 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1308270), // Rule ID 9698 //
     /* 1308191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1308202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1308205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1308208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1308211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1308214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308244 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1308247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308269 */     // GIR_Coverage, 9698,
     /* 1308269 */     GIR_EraseRootFromParent_Done,
     /* 1308270 */   // Label 18742: @1308270
     /* 1308270 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1308354), // Rule ID 9699 //
     /* 1308275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1308286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1308289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1308292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1308295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1308298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308328 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1308331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308353 */     // GIR_Coverage, 9699,
     /* 1308353 */     GIR_EraseRootFromParent_Done,
     /* 1308354 */   // Label 18743: @1308354
     /* 1308354 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1308438), // Rule ID 9702 //
     /* 1308359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1308376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1308379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1308415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308437 */     // GIR_Coverage, 9702,
     /* 1308437 */     GIR_EraseRootFromParent_Done,
     /* 1308438 */   // Label 18744: @1308438
     /* 1308438 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1308522), // Rule ID 9703 //
     /* 1308443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1308460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1308463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1308499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308521 */     // GIR_Coverage, 9703,
     /* 1308521 */     GIR_EraseRootFromParent_Done,
     /* 1308522 */   // Label 18745: @1308522
     /* 1308522 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1308606), // Rule ID 9706 //
     /* 1308527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1308544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1308547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1308583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308605 */     // GIR_Coverage, 9706,
     /* 1308605 */     GIR_EraseRootFromParent_Done,
     /* 1308606 */   // Label 18746: @1308606
     /* 1308606 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1308690), // Rule ID 9707 //
     /* 1308611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1308628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1308631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1308667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308689 */     // GIR_Coverage, 9707,
     /* 1308689 */     GIR_EraseRootFromParent_Done,
     /* 1308690 */   // Label 18747: @1308690
     /* 1308690 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1308774), // Rule ID 9710 //
     /* 1308695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1308712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1308715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308748 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1308751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308773 */     // GIR_Coverage, 9710,
     /* 1308773 */     GIR_EraseRootFromParent_Done,
     /* 1308774 */   // Label 18748: @1308774
     /* 1308774 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1308858), // Rule ID 9711 //
     /* 1308779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1308796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1308799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1308835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308857 */     // GIR_Coverage, 9711,
     /* 1308857 */     GIR_EraseRootFromParent_Done,
     /* 1308858 */   // Label 18749: @1308858
     /* 1308858 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1308942), // Rule ID 9714 //
     /* 1308863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1308880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1308883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1308919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308941 */     // GIR_Coverage, 9714,
     /* 1308941 */     GIR_EraseRootFromParent_Done,
     /* 1308942 */   // Label 18750: @1308942
     /* 1308942 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1309026), // Rule ID 9715 //
     /* 1308947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1308964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1308967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1309003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309025 */     // GIR_Coverage, 9715,
     /* 1309025 */     GIR_EraseRootFromParent_Done,
     /* 1309026 */   // Label 18751: @1309026
     /* 1309026 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1309110), // Rule ID 9718 //
     /* 1309031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1309048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1309051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309109 */     // GIR_Coverage, 9718,
     /* 1309109 */     GIR_EraseRootFromParent_Done,
     /* 1309110 */   // Label 18752: @1309110
     /* 1309110 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1309194), // Rule ID 9719 //
     /* 1309115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1309132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1309135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309193 */     // GIR_Coverage, 9719,
     /* 1309193 */     GIR_EraseRootFromParent_Done,
     /* 1309194 */   // Label 18753: @1309194
     /* 1309194 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1309278), // Rule ID 9722 //
     /* 1309199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1309216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1309219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1309255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309277 */     // GIR_Coverage, 9722,
     /* 1309277 */     GIR_EraseRootFromParent_Done,
     /* 1309278 */   // Label 18754: @1309278
     /* 1309278 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1309362), // Rule ID 9723 //
     /* 1309283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1309300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1309303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1309339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309361 */     // GIR_Coverage, 9723,
     /* 1309361 */     GIR_EraseRootFromParent_Done,
     /* 1309362 */   // Label 18755: @1309362
     /* 1309362 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1309446), // Rule ID 9726 //
     /* 1309367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1309384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1309387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1309423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309445 */     // GIR_Coverage, 9726,
     /* 1309445 */     GIR_EraseRootFromParent_Done,
     /* 1309446 */   // Label 18756: @1309446
     /* 1309446 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1309530), // Rule ID 9727 //
     /* 1309451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1309468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1309471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1309507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309529 */     // GIR_Coverage, 9727,
     /* 1309529 */     GIR_EraseRootFromParent_Done,
     /* 1309530 */   // Label 18757: @1309530
     /* 1309530 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1309614), // Rule ID 9730 //
     /* 1309535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1309552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1309555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309588 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1309591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309613 */     // GIR_Coverage, 9730,
     /* 1309613 */     GIR_EraseRootFromParent_Done,
     /* 1309614 */   // Label 18758: @1309614
     /* 1309614 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1309698), // Rule ID 9731 //
     /* 1309619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1309636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1309639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1309675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309697 */     // GIR_Coverage, 9731,
     /* 1309697 */     GIR_EraseRootFromParent_Done,
     /* 1309698 */   // Label 18759: @1309698
     /* 1309698 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1309782), // Rule ID 9734 //
     /* 1309703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1309720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1309723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1309759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309781 */     // GIR_Coverage, 9734,
     /* 1309781 */     GIR_EraseRootFromParent_Done,
     /* 1309782 */   // Label 18760: @1309782
     /* 1309782 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1309866), // Rule ID 9735 //
     /* 1309787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1309804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1309807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1309843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309865 */     // GIR_Coverage, 9735,
     /* 1309865 */     GIR_EraseRootFromParent_Done,
     /* 1309866 */   // Label 18761: @1309866
     /* 1309866 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1309950), // Rule ID 9738 //
     /* 1309871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1309888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1309891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1309927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309949 */     // GIR_Coverage, 9738,
     /* 1309949 */     GIR_EraseRootFromParent_Done,
     /* 1309950 */   // Label 18762: @1309950
     /* 1309950 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1310034), // Rule ID 9739 //
     /* 1309955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1309963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1309972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1309975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1310011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310033 */     // GIR_Coverage, 9739,
     /* 1310033 */     GIR_EraseRootFromParent_Done,
     /* 1310034 */   // Label 18763: @1310034
     /* 1310034 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1310118), // Rule ID 9742 //
     /* 1310039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1310056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1310059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310092 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1310095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310117 */     // GIR_Coverage, 9742,
     /* 1310117 */     GIR_EraseRootFromParent_Done,
     /* 1310118 */   // Label 18764: @1310118
     /* 1310118 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1310202), // Rule ID 9743 //
     /* 1310123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1310140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1310143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310176 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1310179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310201 */     // GIR_Coverage, 9743,
     /* 1310201 */     GIR_EraseRootFromParent_Done,
     /* 1310202 */   // Label 18765: @1310202
     /* 1310202 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1310286), // Rule ID 9746 //
     /* 1310207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1310224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1310227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1310263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310285 */     // GIR_Coverage, 9746,
     /* 1310285 */     GIR_EraseRootFromParent_Done,
     /* 1310286 */   // Label 18766: @1310286
     /* 1310286 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1310370), // Rule ID 9747 //
     /* 1310291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1310308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1310311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1310347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310369 */     // GIR_Coverage, 9747,
     /* 1310369 */     GIR_EraseRootFromParent_Done,
     /* 1310370 */   // Label 18767: @1310370
     /* 1310370 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1310454), // Rule ID 9750 //
     /* 1310375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1310392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1310395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310453 */     // GIR_Coverage, 9750,
     /* 1310453 */     GIR_EraseRootFromParent_Done,
     /* 1310454 */   // Label 18768: @1310454
     /* 1310454 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1310538), // Rule ID 9751 //
     /* 1310459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1310476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1310479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310537 */     // GIR_Coverage, 9751,
     /* 1310537 */     GIR_EraseRootFromParent_Done,
     /* 1310538 */   // Label 18769: @1310538
     /* 1310538 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1310622), // Rule ID 9754 //
     /* 1310543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1310560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1310563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310621 */     // GIR_Coverage, 9754,
     /* 1310621 */     GIR_EraseRootFromParent_Done,
     /* 1310622 */   // Label 18770: @1310622
     /* 1310622 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1310706), // Rule ID 9755 //
     /* 1310627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1310644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1310647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310705 */     // GIR_Coverage, 9755,
     /* 1310705 */     GIR_EraseRootFromParent_Done,
     /* 1310706 */   // Label 18771: @1310706
     /* 1310706 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1310790), // Rule ID 9758 //
     /* 1310711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1310728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1310731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310789 */     // GIR_Coverage, 9758,
     /* 1310789 */     GIR_EraseRootFromParent_Done,
     /* 1310790 */   // Label 18772: @1310790
     /* 1310790 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1310874), // Rule ID 9759 //
     /* 1310795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1310812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1310815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310873 */     // GIR_Coverage, 9759,
     /* 1310873 */     GIR_EraseRootFromParent_Done,
     /* 1310874 */   // Label 18773: @1310874
     /* 1310874 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1310958), // Rule ID 9762 //
     /* 1310879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1310882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1310896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1310899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310932 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1310935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310957 */     // GIR_Coverage, 9762,
     /* 1310957 */     GIR_EraseRootFromParent_Done,
     /* 1310958 */   // Label 18774: @1310958
     /* 1310958 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1311042), // Rule ID 9763 //
     /* 1310963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1310966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1310971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1310980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1310983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311016 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1311019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311041 */     // GIR_Coverage, 9763,
     /* 1311041 */     GIR_EraseRootFromParent_Done,
     /* 1311042 */   // Label 18775: @1311042
     /* 1311042 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1311126), // Rule ID 9766 //
     /* 1311047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1311064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1311067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1311103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311125 */     // GIR_Coverage, 9766,
     /* 1311125 */     GIR_EraseRootFromParent_Done,
     /* 1311126 */   // Label 18776: @1311126
     /* 1311126 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1311210), // Rule ID 9767 //
     /* 1311131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1311148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1311151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1311187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311209 */     // GIR_Coverage, 9767,
     /* 1311209 */     GIR_EraseRootFromParent_Done,
     /* 1311210 */   // Label 18777: @1311210
     /* 1311210 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1311294), // Rule ID 9770 //
     /* 1311215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1311232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1311235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311268 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1311271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311293 */     // GIR_Coverage, 9770,
     /* 1311293 */     GIR_EraseRootFromParent_Done,
     /* 1311294 */   // Label 18778: @1311294
     /* 1311294 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1311378), // Rule ID 9771 //
     /* 1311299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1311316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1311319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311352 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1311355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311377 */     // GIR_Coverage, 9771,
     /* 1311377 */     GIR_EraseRootFromParent_Done,
     /* 1311378 */   // Label 18779: @1311378
     /* 1311378 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1311462), // Rule ID 9774 //
     /* 1311383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1311394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1311397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1311400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1311403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1311406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311436 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1311439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311461 */     // GIR_Coverage, 9774,
     /* 1311461 */     GIR_EraseRootFromParent_Done,
     /* 1311462 */   // Label 18780: @1311462
     /* 1311462 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1311546), // Rule ID 9775 //
     /* 1311467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1311478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1311481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1311484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1311487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1311490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311520 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1311523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311545 */     // GIR_Coverage, 9775,
     /* 1311545 */     GIR_EraseRootFromParent_Done,
     /* 1311546 */   // Label 18781: @1311546
     /* 1311546 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1311630), // Rule ID 9778 //
     /* 1311551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1311568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1311571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311604 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1311607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311629 */     // GIR_Coverage, 9778,
     /* 1311629 */     GIR_EraseRootFromParent_Done,
     /* 1311630 */   // Label 18782: @1311630
     /* 1311630 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1311714), // Rule ID 9779 //
     /* 1311635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1311652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1311655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311688 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1311691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311713 */     // GIR_Coverage, 9779,
     /* 1311713 */     GIR_EraseRootFromParent_Done,
     /* 1311714 */   // Label 18783: @1311714
     /* 1311714 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1311798), // Rule ID 9782 //
     /* 1311719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1311739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1311775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311797 */     // GIR_Coverage, 9782,
     /* 1311797 */     GIR_EraseRootFromParent_Done,
     /* 1311798 */   // Label 18784: @1311798
     /* 1311798 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1311882), // Rule ID 9783 //
     /* 1311803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1311823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1311859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311881 */     // GIR_Coverage, 9783,
     /* 1311881 */     GIR_EraseRootFromParent_Done,
     /* 1311882 */   // Label 18785: @1311882
     /* 1311882 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1311966), // Rule ID 9786 //
     /* 1311887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1311904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1311907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311940 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1311943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311965 */     // GIR_Coverage, 9786,
     /* 1311965 */     GIR_EraseRootFromParent_Done,
     /* 1311966 */   // Label 18786: @1311966
     /* 1311966 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1312050), // Rule ID 9787 //
     /* 1311971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1311988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1311991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312024 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1312027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312049 */     // GIR_Coverage, 9787,
     /* 1312049 */     GIR_EraseRootFromParent_Done,
     /* 1312050 */   // Label 18787: @1312050
     /* 1312050 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1312134), // Rule ID 9790 //
     /* 1312055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1312072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1312075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312108 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1312111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312133 */     // GIR_Coverage, 9790,
     /* 1312133 */     GIR_EraseRootFromParent_Done,
     /* 1312134 */   // Label 18788: @1312134
     /* 1312134 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1312218), // Rule ID 9791 //
     /* 1312139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1312156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1312159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312192 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1312195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312217 */     // GIR_Coverage, 9791,
     /* 1312217 */     GIR_EraseRootFromParent_Done,
     /* 1312218 */   // Label 18789: @1312218
     /* 1312218 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1312302), // Rule ID 9794 //
     /* 1312223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1312240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1312243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1312279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312301 */     // GIR_Coverage, 9794,
     /* 1312301 */     GIR_EraseRootFromParent_Done,
     /* 1312302 */   // Label 18790: @1312302
     /* 1312302 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1312386), // Rule ID 9795 //
     /* 1312307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1312324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1312327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1312363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312385 */     // GIR_Coverage, 9795,
     /* 1312385 */     GIR_EraseRootFromParent_Done,
     /* 1312386 */   // Label 18791: @1312386
     /* 1312386 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1312470), // Rule ID 9798 //
     /* 1312391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1312402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1312405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1312408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1312411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1312414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1312447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312469 */     // GIR_Coverage, 9798,
     /* 1312469 */     GIR_EraseRootFromParent_Done,
     /* 1312470 */   // Label 18792: @1312470
     /* 1312470 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1312554), // Rule ID 9799 //
     /* 1312475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1312486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1312489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1312492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1312495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1312498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1312531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312553 */     // GIR_Coverage, 9799,
     /* 1312553 */     GIR_EraseRootFromParent_Done,
     /* 1312554 */   // Label 18793: @1312554
     /* 1312554 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1312638), // Rule ID 9802 //
     /* 1312559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1312562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1312576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1312579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1312615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312637 */     // GIR_Coverage, 9802,
     /* 1312637 */     GIR_EraseRootFromParent_Done,
     /* 1312638 */   // Label 18794: @1312638
     /* 1312638 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1312722), // Rule ID 9803 //
     /* 1312643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1312646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1312660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1312663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1312699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312721 */     // GIR_Coverage, 9803,
     /* 1312721 */     GIR_EraseRootFromParent_Done,
     /* 1312722 */   // Label 18795: @1312722
     /* 1312722 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1312806), // Rule ID 9806 //
     /* 1312727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1312730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1312744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1312747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312780 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1312783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312805 */     // GIR_Coverage, 9806,
     /* 1312805 */     GIR_EraseRootFromParent_Done,
     /* 1312806 */   // Label 18796: @1312806
     /* 1312806 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1312890), // Rule ID 9807 //
     /* 1312811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1312814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1312828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1312831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1312867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312889 */     // GIR_Coverage, 9807,
     /* 1312889 */     GIR_EraseRootFromParent_Done,
     /* 1312890 */   // Label 18797: @1312890
     /* 1312890 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1312974), // Rule ID 9810 //
     /* 1312895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1312898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1312951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312973 */     // GIR_Coverage, 9810,
     /* 1312973 */     GIR_EraseRootFromParent_Done,
     /* 1312974 */   // Label 18798: @1312974
     /* 1312974 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1313058), // Rule ID 9811 //
     /* 1312979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1312982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1313035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313057 */     // GIR_Coverage, 9811,
     /* 1313057 */     GIR_EraseRootFromParent_Done,
     /* 1313058 */   // Label 18799: @1313058
     /* 1313058 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1313142), // Rule ID 9814 //
     /* 1313063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1313080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1313083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1313119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313141 */     // GIR_Coverage, 9814,
     /* 1313141 */     GIR_EraseRootFromParent_Done,
     /* 1313142 */   // Label 18800: @1313142
     /* 1313142 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1313226), // Rule ID 9815 //
     /* 1313147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1313164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1313167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1313203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313225 */     // GIR_Coverage, 9815,
     /* 1313225 */     GIR_EraseRootFromParent_Done,
     /* 1313226 */   // Label 18801: @1313226
     /* 1313226 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1313310), // Rule ID 9818 //
     /* 1313231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1313248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1313251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1313287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313309 */     // GIR_Coverage, 9818,
     /* 1313309 */     GIR_EraseRootFromParent_Done,
     /* 1313310 */   // Label 18802: @1313310
     /* 1313310 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1313394), // Rule ID 9819 //
     /* 1313315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1313332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1313335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1313371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313393 */     // GIR_Coverage, 9819,
     /* 1313393 */     GIR_EraseRootFromParent_Done,
     /* 1313394 */   // Label 18803: @1313394
     /* 1313394 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1313478), // Rule ID 9822 //
     /* 1313399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1313416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1313419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1313455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313477 */     // GIR_Coverage, 9822,
     /* 1313477 */     GIR_EraseRootFromParent_Done,
     /* 1313478 */   // Label 18804: @1313478
     /* 1313478 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1313562), // Rule ID 9823 //
     /* 1313483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1313494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1313497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1313500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1313503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1313539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313561 */     // GIR_Coverage, 9823,
     /* 1313561 */     GIR_EraseRootFromParent_Done,
     /* 1313562 */   // Label 18805: @1313562
     /* 1313562 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1313646), // Rule ID 9826 //
     /* 1313567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1313584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1313587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1313623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313645 */     // GIR_Coverage, 9826,
     /* 1313645 */     GIR_EraseRootFromParent_Done,
     /* 1313646 */   // Label 18806: @1313646
     /* 1313646 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1313730), // Rule ID 9827 //
     /* 1313651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1313668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1313671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1313707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313729 */     // GIR_Coverage, 9827,
     /* 1313729 */     GIR_EraseRootFromParent_Done,
     /* 1313730 */   // Label 18807: @1313730
     /* 1313730 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1313814), // Rule ID 9830 //
     /* 1313735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1313755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1313791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313813 */     // GIR_Coverage, 9830,
     /* 1313813 */     GIR_EraseRootFromParent_Done,
     /* 1313814 */   // Label 18808: @1313814
     /* 1313814 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1313898), // Rule ID 9831 //
     /* 1313819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1313839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1313875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313897 */     // GIR_Coverage, 9831,
     /* 1313897 */     GIR_EraseRootFromParent_Done,
     /* 1313898 */   // Label 18809: @1313898
     /* 1313898 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1313982), // Rule ID 9834 //
     /* 1313903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1313920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1313923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1313959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313981 */     // GIR_Coverage, 9834,
     /* 1313981 */     GIR_EraseRootFromParent_Done,
     /* 1313982 */   // Label 18810: @1313982
     /* 1313982 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1314066), // Rule ID 9835 //
     /* 1313987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1313995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1314001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1314004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1314007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1314010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1314043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314065 */     // GIR_Coverage, 9835,
     /* 1314065 */     GIR_EraseRootFromParent_Done,
     /* 1314066 */   // Label 18811: @1314066
     /* 1314066 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1314150), // Rule ID 9838 //
     /* 1314071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1314088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1314091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314149 */     // GIR_Coverage, 9838,
     /* 1314149 */     GIR_EraseRootFromParent_Done,
     /* 1314150 */   // Label 18812: @1314150
     /* 1314150 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1314234), // Rule ID 9839 //
     /* 1314155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1314172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1314175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314233 */     // GIR_Coverage, 9839,
     /* 1314233 */     GIR_EraseRootFromParent_Done,
     /* 1314234 */   // Label 18813: @1314234
     /* 1314234 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1314318), // Rule ID 9842 //
     /* 1314239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1314256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1314259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314317 */     // GIR_Coverage, 9842,
     /* 1314317 */     GIR_EraseRootFromParent_Done,
     /* 1314318 */   // Label 18814: @1314318
     /* 1314318 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1314402), // Rule ID 9843 //
     /* 1314323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1314340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1314343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314401 */     // GIR_Coverage, 9843,
     /* 1314401 */     GIR_EraseRootFromParent_Done,
     /* 1314402 */   // Label 18815: @1314402
     /* 1314402 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1314486), // Rule ID 9846 //
     /* 1314407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1314424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1314427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314485 */     // GIR_Coverage, 9846,
     /* 1314485 */     GIR_EraseRootFromParent_Done,
     /* 1314486 */   // Label 18816: @1314486
     /* 1314486 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1314570), // Rule ID 9847 //
     /* 1314491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1314508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1314511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314569 */     // GIR_Coverage, 9847,
     /* 1314569 */     GIR_EraseRootFromParent_Done,
     /* 1314570 */   // Label 18817: @1314570
     /* 1314570 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1314654), // Rule ID 9850 //
     /* 1314575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1314586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1314589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1314592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1314595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1314598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314653 */     // GIR_Coverage, 9850,
     /* 1314653 */     GIR_EraseRootFromParent_Done,
     /* 1314654 */   // Label 18818: @1314654
     /* 1314654 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1314738), // Rule ID 9851 //
     /* 1314659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1314662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1314670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1314673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1314676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1314679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1314682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1314715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314737 */     // GIR_Coverage, 9851,
     /* 1314737 */     GIR_EraseRootFromParent_Done,
     /* 1314738 */   // Label 18819: @1314738
     /* 1314738 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1314822), // Rule ID 9854 //
     /* 1314743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1314760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1314763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1314799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314821 */     // GIR_Coverage, 9854,
     /* 1314821 */     GIR_EraseRootFromParent_Done,
     /* 1314822 */   // Label 18820: @1314822
     /* 1314822 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1314906), // Rule ID 9855 //
     /* 1314827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1314844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1314847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1314883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314905 */     // GIR_Coverage, 9855,
     /* 1314905 */     GIR_EraseRootFromParent_Done,
     /* 1314906 */   // Label 18821: @1314906
     /* 1314906 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1314990), // Rule ID 9858 //
     /* 1314911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1314919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1314928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1314931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314964 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1314967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314989 */     // GIR_Coverage, 9858,
     /* 1314989 */     GIR_EraseRootFromParent_Done,
     /* 1314990 */   // Label 18822: @1314990
     /* 1314990 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1315074), // Rule ID 9859 //
     /* 1314995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1315006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1315009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1315012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1315015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1315018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1315051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315073 */     // GIR_Coverage, 9859,
     /* 1315073 */     GIR_EraseRootFromParent_Done,
     /* 1315074 */   // Label 18823: @1315074
     /* 1315074 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1315158), // Rule ID 9862 //
     /* 1315079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1315090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1315093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1315096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1315099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1315102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315132 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1315135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315157 */     // GIR_Coverage, 9862,
     /* 1315157 */     GIR_EraseRootFromParent_Done,
     /* 1315158 */   // Label 18824: @1315158
     /* 1315158 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1315242), // Rule ID 9863 //
     /* 1315163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1315174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1315177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1315180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1315183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1315186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315216 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1315219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315241 */     // GIR_Coverage, 9863,
     /* 1315241 */     GIR_EraseRootFromParent_Done,
     /* 1315242 */   // Label 18825: @1315242
     /* 1315242 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1315326), // Rule ID 9866 //
     /* 1315247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1315264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1315267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1315303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315325 */     // GIR_Coverage, 9866,
     /* 1315325 */     GIR_EraseRootFromParent_Done,
     /* 1315326 */   // Label 18826: @1315326
     /* 1315326 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1315410), // Rule ID 9867 //
     /* 1315331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1315348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1315351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1315387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315409 */     // GIR_Coverage, 9867,
     /* 1315409 */     GIR_EraseRootFromParent_Done,
     /* 1315410 */   // Label 18827: @1315410
     /* 1315410 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1315494), // Rule ID 9870 //
     /* 1315415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1315432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1315435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1315471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315493 */     // GIR_Coverage, 9870,
     /* 1315493 */     GIR_EraseRootFromParent_Done,
     /* 1315494 */   // Label 18828: @1315494
     /* 1315494 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1315578), // Rule ID 9871 //
     /* 1315499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1315510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1315513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1315516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1315519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1315555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315577 */     // GIR_Coverage, 9871,
     /* 1315577 */     GIR_EraseRootFromParent_Done,
     /* 1315578 */   // Label 18829: @1315578
     /* 1315578 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1315662), // Rule ID 9874 //
     /* 1315583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1315594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1315597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1315600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1315603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1315606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315636 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1315639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315661 */     // GIR_Coverage, 9874,
     /* 1315661 */     GIR_EraseRootFromParent_Done,
     /* 1315662 */   // Label 18830: @1315662
     /* 1315662 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1315746), // Rule ID 9875 //
     /* 1315667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1315678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1315681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1315684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1315687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1315690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315720 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1315723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315745 */     // GIR_Coverage, 9875,
     /* 1315745 */     GIR_EraseRootFromParent_Done,
     /* 1315746 */   // Label 18831: @1315746
     /* 1315746 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1315830), // Rule ID 9878 //
     /* 1315751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1315768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1315771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1315807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315829 */     // GIR_Coverage, 9878,
     /* 1315829 */     GIR_EraseRootFromParent_Done,
     /* 1315830 */   // Label 18832: @1315830
     /* 1315830 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1315914), // Rule ID 9879 //
     /* 1315835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1315852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1315855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1315891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315913 */     // GIR_Coverage, 9879,
     /* 1315913 */     GIR_EraseRootFromParent_Done,
     /* 1315914 */   // Label 18833: @1315914
     /* 1315914 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1315998), // Rule ID 9882 //
     /* 1315919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1315939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1315975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315997 */     // GIR_Coverage, 9882,
     /* 1315997 */     GIR_EraseRootFromParent_Done,
     /* 1315998 */   // Label 18834: @1315998
     /* 1315998 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1316082), // Rule ID 9883 //
     /* 1316003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1316020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1316023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1316059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316081 */     // GIR_Coverage, 9883,
     /* 1316081 */     GIR_EraseRootFromParent_Done,
     /* 1316082 */   // Label 18835: @1316082
     /* 1316082 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1316166), // Rule ID 9886 //
     /* 1316087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1316098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1316101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1316104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1316107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1316110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1316143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316165 */     // GIR_Coverage, 9886,
     /* 1316165 */     GIR_EraseRootFromParent_Done,
     /* 1316166 */   // Label 18836: @1316166
     /* 1316166 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1316250), // Rule ID 9887 //
     /* 1316171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1316182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1316185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1316188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1316191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1316194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1316227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316249 */     // GIR_Coverage, 9887,
     /* 1316249 */     GIR_EraseRootFromParent_Done,
     /* 1316250 */   // Label 18837: @1316250
     /* 1316250 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1316334), // Rule ID 9890 //
     /* 1316255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1316272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1316275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1316311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316333 */     // GIR_Coverage, 9890,
     /* 1316333 */     GIR_EraseRootFromParent_Done,
     /* 1316334 */   // Label 18838: @1316334
     /* 1316334 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1316418), // Rule ID 9891 //
     /* 1316339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1316342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1316356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1316359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1316381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1316395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316417 */     // GIR_Coverage, 9891,
     /* 1316417 */     GIR_EraseRootFromParent_Done,
     /* 1316418 */   // Label 18839: @1316418
     /* 1316418 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1316502), // Rule ID 9894 //
     /* 1316423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1316440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1316443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316476 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1316479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316501 */     // GIR_Coverage, 9894,
     /* 1316501 */     GIR_EraseRootFromParent_Done,
     /* 1316502 */   // Label 18840: @1316502
     /* 1316502 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1316586), // Rule ID 9895 //
     /* 1316507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1316510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1316524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1316527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1316549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1316563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316585 */     // GIR_Coverage, 9895,
     /* 1316585 */     GIR_EraseRootFromParent_Done,
     /* 1316586 */   // Label 18841: @1316586
     /* 1316586 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1316670), // Rule ID 9898 //
     /* 1316591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1316608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1316611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1316647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316669 */     // GIR_Coverage, 9898,
     /* 1316669 */     GIR_EraseRootFromParent_Done,
     /* 1316670 */   // Label 18842: @1316670
     /* 1316670 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1316754), // Rule ID 9899 //
     /* 1316675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1316678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1316692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1316695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1316717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1316731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316753 */     // GIR_Coverage, 9899,
     /* 1316753 */     GIR_EraseRootFromParent_Done,
     /* 1316754 */   // Label 18843: @1316754
     /* 1316754 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1316835), // Rule ID 13840 //
     /* 1316759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1316770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1316773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1316776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1316779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1316815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316834 */     // GIR_Coverage, 13840,
     /* 1316834 */     GIR_EraseRootFromParent_Done,
     /* 1316835 */   // Label 18844: @1316835
     /* 1316835 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1316916), // Rule ID 13841 //
     /* 1316840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1316851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1316854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1316857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1316860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1316893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1316896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316915 */     // GIR_Coverage, 13841,
     /* 1316915 */     GIR_EraseRootFromParent_Done,
     /* 1316916 */   // Label 18845: @1316916
     /* 1316916 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1316997), // Rule ID 13842 //
     /* 1316921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1316932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1316935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1316938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1316941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316974 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1316977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316996 */     // GIR_Coverage, 13842,
     /* 1316996 */     GIR_EraseRootFromParent_Done,
     /* 1316997 */   // Label 18846: @1316997
     /* 1316997 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1317078), // Rule ID 13843 //
     /* 1317002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1317013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1317016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1317019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1317022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317055 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1317058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317077 */     // GIR_Coverage, 13843,
     /* 1317077 */     GIR_EraseRootFromParent_Done,
     /* 1317078 */   // Label 18847: @1317078
     /* 1317078 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1317159), // Rule ID 13844 //
     /* 1317083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1317094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1317097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1317100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1317103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317136 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1317136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317158 */     // GIR_Coverage, 13844,
     /* 1317158 */     GIR_EraseRootFromParent_Done,
     /* 1317159 */   // Label 18848: @1317159
     /* 1317159 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1317240), // Rule ID 13845 //
     /* 1317164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1317175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1317178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1317181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1317184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317217 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317239 */     // GIR_Coverage, 13845,
     /* 1317239 */     GIR_EraseRootFromParent_Done,
     /* 1317240 */   // Label 18849: @1317240
     /* 1317240 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1317321), // Rule ID 13846 //
     /* 1317245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1317256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1317259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1317262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1317265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317298 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1317298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1317301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317320 */     // GIR_Coverage, 13846,
     /* 1317320 */     GIR_EraseRootFromParent_Done,
     /* 1317321 */   // Label 18850: @1317321
     /* 1317321 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1317402), // Rule ID 13847 //
     /* 1317326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1317337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1317340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1317343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1317346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317379 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1317379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1317382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317401 */     // GIR_Coverage, 13847,
     /* 1317401 */     GIR_EraseRootFromParent_Done,
     /* 1317402 */   // Label 18851: @1317402
     /* 1317402 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1317483), // Rule ID 13848 //
     /* 1317407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1317418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1317421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1317424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1317427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1317460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317482 */     // GIR_Coverage, 13848,
     /* 1317482 */     GIR_EraseRootFromParent_Done,
     /* 1317483 */   // Label 18852: @1317483
     /* 1317483 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1317564), // Rule ID 13849 //
     /* 1317488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1317499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1317502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1317505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1317508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317541 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1317541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317563 */     // GIR_Coverage, 13849,
     /* 1317563 */     GIR_EraseRootFromParent_Done,
     /* 1317564 */   // Label 18853: @1317564
     /* 1317564 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1317645), // Rule ID 13850 //
     /* 1317569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1317580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1317583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1317586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1317589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1317622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317644 */     // GIR_Coverage, 13850,
     /* 1317644 */     GIR_EraseRootFromParent_Done,
     /* 1317645 */   // Label 18854: @1317645
     /* 1317645 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1317726), // Rule ID 13851 //
     /* 1317650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1317661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1317664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1317667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1317670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1317703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1317706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317725 */     // GIR_Coverage, 13851,
     /* 1317725 */     GIR_EraseRootFromParent_Done,
     /* 1317726 */   // Label 18855: @1317726
     /* 1317726 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1317807), // Rule ID 13852 //
     /* 1317731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1317742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1317745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1317748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1317751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1317784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1317787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317806 */     // GIR_Coverage, 13852,
     /* 1317806 */     GIR_EraseRootFromParent_Done,
     /* 1317807 */   // Label 18856: @1317807
     /* 1317807 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1317888), // Rule ID 13853 //
     /* 1317812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1317823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1317826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1317829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1317832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317865 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1317868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317887 */     // GIR_Coverage, 13853,
     /* 1317887 */     GIR_EraseRootFromParent_Done,
     /* 1317888 */   // Label 18857: @1317888
     /* 1317888 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1317969), // Rule ID 13854 //
     /* 1317893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1317913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1317946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1317949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317968 */     // GIR_Coverage, 13854,
     /* 1317968 */     GIR_EraseRootFromParent_Done,
     /* 1317969 */   // Label 18858: @1317969
     /* 1317969 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1318050), // Rule ID 13855 //
     /* 1317974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1317994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1318027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1318030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318049 */     // GIR_Coverage, 13855,
     /* 1318049 */     GIR_EraseRootFromParent_Done,
     /* 1318050 */   // Label 18859: @1318050
     /* 1318050 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1318131), // Rule ID 13856 //
     /* 1318055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1318066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1318069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1318072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1318075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1318108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1318111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318130 */     // GIR_Coverage, 13856,
     /* 1318130 */     GIR_EraseRootFromParent_Done,
     /* 1318131 */   // Label 18860: @1318131
     /* 1318131 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1318212), // Rule ID 13857 //
     /* 1318136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1318147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1318150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1318153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1318156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318189 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1318189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1318192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318211 */     // GIR_Coverage, 13857,
     /* 1318211 */     GIR_EraseRootFromParent_Done,
     /* 1318212 */   // Label 18861: @1318212
     /* 1318212 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1318293), // Rule ID 13858 //
     /* 1318217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1318228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1318231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1318234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1318237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1318240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1318270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1318273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318292 */     // GIR_Coverage, 13858,
     /* 1318292 */     GIR_EraseRootFromParent_Done,
     /* 1318293 */   // Label 18862: @1318293
     /* 1318293 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1318374), // Rule ID 13859 //
     /* 1318298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1318309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1318312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1318315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1318318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1318321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1318328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1318351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1318354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318373 */     // GIR_Coverage, 13859,
     /* 1318373 */     GIR_EraseRootFromParent_Done,
     /* 1318374 */   // Label 18863: @1318374
     /* 1318374 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1318455), // Rule ID 13860 //
     /* 1318379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1318390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1318393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1318396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1318399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1318432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1318435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318454 */     // GIR_Coverage, 13860,
     /* 1318454 */     GIR_EraseRootFromParent_Done,
     /* 1318455 */   // Label 18864: @1318455
     /* 1318455 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1318536), // Rule ID 13861 //
     /* 1318460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1318471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1318474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1318477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1318480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1318513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1318516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318535 */     // GIR_Coverage, 13861,
     /* 1318535 */     GIR_EraseRootFromParent_Done,
     /* 1318536 */   // Label 18865: @1318536
     /* 1318536 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1318617), // Rule ID 13862 //
     /* 1318541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1318552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1318555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1318558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1318561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1318594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1318597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318616 */     // GIR_Coverage, 13862,
     /* 1318616 */     GIR_EraseRootFromParent_Done,
     /* 1318617 */   // Label 18866: @1318617
     /* 1318617 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1318698), // Rule ID 13863 //
     /* 1318622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1318633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1318636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1318639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1318642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318675 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1318675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1318678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318697 */     // GIR_Coverage, 13863,
     /* 1318697 */     GIR_EraseRootFromParent_Done,
     /* 1318698 */   // Label 18867: @1318698
     /* 1318698 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1318779), // Rule ID 13864 //
     /* 1318703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1318714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1318717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1318720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1318723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1318726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1318756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1318759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318778 */     // GIR_Coverage, 13864,
     /* 1318778 */     GIR_EraseRootFromParent_Done,
     /* 1318779 */   // Label 18868: @1318779
     /* 1318779 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1318860), // Rule ID 13865 //
     /* 1318784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1318795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1318798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1318801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1318804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1318807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318837 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1318837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1318840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318859 */     // GIR_Coverage, 13865,
     /* 1318859 */     GIR_EraseRootFromParent_Done,
     /* 1318860 */   // Label 18869: @1318860
     /* 1318860 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1318941), // Rule ID 13866 //
     /* 1318865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1318876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1318879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1318885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1318918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1318921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318940 */     // GIR_Coverage, 13866,
     /* 1318940 */     GIR_EraseRootFromParent_Done,
     /* 1318941 */   // Label 18870: @1318941
     /* 1318941 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1319022), // Rule ID 13867 //
     /* 1318946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1318957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1318960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1318966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1318999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1319002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319021 */     // GIR_Coverage, 13867,
     /* 1319021 */     GIR_EraseRootFromParent_Done,
     /* 1319022 */   // Label 18871: @1319022
     /* 1319022 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1319103), // Rule ID 13868 //
     /* 1319027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1319038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1319041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1319044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1319047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1319050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1319083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319102 */     // GIR_Coverage, 13868,
     /* 1319102 */     GIR_EraseRootFromParent_Done,
     /* 1319103 */   // Label 18872: @1319103
     /* 1319103 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1319184), // Rule ID 13869 //
     /* 1319108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1319119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1319122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1319125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1319128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1319131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319161 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1319164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319183 */     // GIR_Coverage, 13869,
     /* 1319183 */     GIR_EraseRootFromParent_Done,
     /* 1319184 */   // Label 18873: @1319184
     /* 1319184 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1319265), // Rule ID 13870 //
     /* 1319189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1319200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1319203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1319206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1319209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1319212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319242 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1319245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319264 */     // GIR_Coverage, 13870,
     /* 1319264 */     GIR_EraseRootFromParent_Done,
     /* 1319265 */   // Label 18874: @1319265
     /* 1319265 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1319346), // Rule ID 13871 //
     /* 1319270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1319281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1319284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1319287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1319290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1319293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319323 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1319326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319345 */     // GIR_Coverage, 13871,
     /* 1319345 */     GIR_EraseRootFromParent_Done,
     /* 1319346 */   // Label 18875: @1319346
     /* 1319346 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1319427), // Rule ID 13872 //
     /* 1319351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1319362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1319365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1319368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1319371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1319404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1319407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319426 */     // GIR_Coverage, 13872,
     /* 1319426 */     GIR_EraseRootFromParent_Done,
     /* 1319427 */   // Label 18876: @1319427
     /* 1319427 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1319508), // Rule ID 13873 //
     /* 1319432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1319443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1319446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1319449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1319452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1319488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319507 */     // GIR_Coverage, 13873,
     /* 1319507 */     GIR_EraseRootFromParent_Done,
     /* 1319508 */   // Label 18877: @1319508
     /* 1319508 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1319589), // Rule ID 13874 //
     /* 1319513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1319524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1319527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1319530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1319533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1319566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1319569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319588 */     // GIR_Coverage, 13874,
     /* 1319588 */     GIR_EraseRootFromParent_Done,
     /* 1319589 */   // Label 18878: @1319589
     /* 1319589 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1319670), // Rule ID 13875 //
     /* 1319594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1319605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1319608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1319611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1319614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319647 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1319650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319669 */     // GIR_Coverage, 13875,
     /* 1319669 */     GIR_EraseRootFromParent_Done,
     /* 1319670 */   // Label 18879: @1319670
     /* 1319670 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1319751), // Rule ID 13876 //
     /* 1319675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1319686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1319689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1319692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1319695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1319698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1319728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1319731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319750 */     // GIR_Coverage, 13876,
     /* 1319750 */     GIR_EraseRootFromParent_Done,
     /* 1319751 */   // Label 18880: @1319751
     /* 1319751 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1319832), // Rule ID 13877 //
     /* 1319756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1319767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1319770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1319773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1319776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1319779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319809 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1319812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319831 */     // GIR_Coverage, 13877,
     /* 1319831 */     GIR_EraseRootFromParent_Done,
     /* 1319832 */   // Label 18881: @1319832
     /* 1319832 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1319913), // Rule ID 13878 //
     /* 1319837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1319848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1319851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1319857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1319890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1319893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319912 */     // GIR_Coverage, 13878,
     /* 1319912 */     GIR_EraseRootFromParent_Done,
     /* 1319913 */   // Label 18882: @1319913
     /* 1319913 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1319994), // Rule ID 13879 //
     /* 1319918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1319929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1319932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1319938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1319971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1319974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319993 */     // GIR_Coverage, 13879,
     /* 1319993 */     GIR_EraseRootFromParent_Done,
     /* 1319994 */   // Label 18883: @1319994
     /* 1319994 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1320075), // Rule ID 13880 //
     /* 1319999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1320010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1320013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1320016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1320019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320074 */     // GIR_Coverage, 13880,
     /* 1320074 */     GIR_EraseRootFromParent_Done,
     /* 1320075 */   // Label 18884: @1320075
     /* 1320075 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1320156), // Rule ID 13881 //
     /* 1320080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1320091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1320094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1320097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1320100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320133 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1320133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320155 */     // GIR_Coverage, 13881,
     /* 1320155 */     GIR_EraseRootFromParent_Done,
     /* 1320156 */   // Label 18885: @1320156
     /* 1320156 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1320237), // Rule ID 13882 //
     /* 1320161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1320172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1320175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1320178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1320181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1320191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1320217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320236 */     // GIR_Coverage, 13882,
     /* 1320236 */     GIR_EraseRootFromParent_Done,
     /* 1320237 */   // Label 18886: @1320237
     /* 1320237 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1320318), // Rule ID 13883 //
     /* 1320242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1320253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1320256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1320259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1320262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1320272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320295 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1320295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1320298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320317 */     // GIR_Coverage, 13883,
     /* 1320317 */     GIR_EraseRootFromParent_Done,
     /* 1320318 */   // Label 18887: @1320318
     /* 1320318 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1320399), // Rule ID 13884 //
     /* 1320323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1320334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1320337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1320340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1320379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320398 */     // GIR_Coverage, 13884,
     /* 1320398 */     GIR_EraseRootFromParent_Done,
     /* 1320399 */   // Label 18888: @1320399
     /* 1320399 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1320480), // Rule ID 13885 //
     /* 1320404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1320415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1320418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1320421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320457 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1320460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320479 */     // GIR_Coverage, 13885,
     /* 1320479 */     GIR_EraseRootFromParent_Done,
     /* 1320480 */   // Label 18889: @1320480
     /* 1320480 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1320561), // Rule ID 13886 //
     /* 1320485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1320496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1320499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1320502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1320541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320560 */     // GIR_Coverage, 13886,
     /* 1320560 */     GIR_EraseRootFromParent_Done,
     /* 1320561 */   // Label 18890: @1320561
     /* 1320561 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1320642), // Rule ID 13887 //
     /* 1320566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1320577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1320580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1320583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320619 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1320622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320641 */     // GIR_Coverage, 13887,
     /* 1320641 */     GIR_EraseRootFromParent_Done,
     /* 1320642 */   // Label 18891: @1320642
     /* 1320642 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1320723), // Rule ID 13888 //
     /* 1320647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1320658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1320661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1320664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1320703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320722 */     // GIR_Coverage, 13888,
     /* 1320722 */     GIR_EraseRootFromParent_Done,
     /* 1320723 */   // Label 18892: @1320723
     /* 1320723 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1320804), // Rule ID 13889 //
     /* 1320728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1320739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1320742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1320745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320781 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1320784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320803 */     // GIR_Coverage, 13889,
     /* 1320803 */     GIR_EraseRootFromParent_Done,
     /* 1320804 */   // Label 18893: @1320804
     /* 1320804 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1320885), // Rule ID 13890 //
     /* 1320809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1320820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1320823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1320826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1320865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320884 */     // GIR_Coverage, 13890,
     /* 1320884 */     GIR_EraseRootFromParent_Done,
     /* 1320885 */   // Label 18894: @1320885
     /* 1320885 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1320966), // Rule ID 13891 //
     /* 1320890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1320901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1320904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1320907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1320910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1320932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320943 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1320946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320965 */     // GIR_Coverage, 13891,
     /* 1320965 */     GIR_EraseRootFromParent_Done,
     /* 1320966 */   // Label 18895: @1320966
     /* 1320966 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1321047), // Rule ID 13892 //
     /* 1320971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1320982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1320985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1320988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1320991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321024 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1321027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321046 */     // GIR_Coverage, 13892,
     /* 1321046 */     GIR_EraseRootFromParent_Done,
     /* 1321047 */   // Label 18896: @1321047
     /* 1321047 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1321128), // Rule ID 13893 //
     /* 1321052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1321063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1321066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1321069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1321075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321105 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1321108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321127 */     // GIR_Coverage, 13893,
     /* 1321127 */     GIR_EraseRootFromParent_Done,
     /* 1321128 */   // Label 18897: @1321128
     /* 1321128 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1321209), // Rule ID 13894 //
     /* 1321133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1321144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1321147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1321150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1321189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321208 */     // GIR_Coverage, 13894,
     /* 1321208 */     GIR_EraseRootFromParent_Done,
     /* 1321209 */   // Label 18898: @1321209
     /* 1321209 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1321290), // Rule ID 13895 //
     /* 1321214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1321225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1321228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1321231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321267 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1321270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321289 */     // GIR_Coverage, 13895,
     /* 1321289 */     GIR_EraseRootFromParent_Done,
     /* 1321290 */   // Label 18899: @1321290
     /* 1321290 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1321371), // Rule ID 13896 //
     /* 1321295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1321306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1321309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1321312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321370 */     // GIR_Coverage, 13896,
     /* 1321370 */     GIR_EraseRootFromParent_Done,
     /* 1321371 */   // Label 18900: @1321371
     /* 1321371 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1321452), // Rule ID 13897 //
     /* 1321376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1321387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1321390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1321393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321429 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321451 */     // GIR_Coverage, 13897,
     /* 1321451 */     GIR_EraseRootFromParent_Done,
     /* 1321452 */   // Label 18901: @1321452
     /* 1321452 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1321533), // Rule ID 13898 //
     /* 1321457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1321468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1321471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1321474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321510 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321532 */     // GIR_Coverage, 13898,
     /* 1321532 */     GIR_EraseRootFromParent_Done,
     /* 1321533 */   // Label 18902: @1321533
     /* 1321533 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1321614), // Rule ID 13899 //
     /* 1321538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1321549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1321552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1321555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321591 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321613 */     // GIR_Coverage, 13899,
     /* 1321613 */     GIR_EraseRootFromParent_Done,
     /* 1321614 */   // Label 18903: @1321614
     /* 1321614 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1321695), // Rule ID 13900 //
     /* 1321619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1321630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1321633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1321636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1321642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321694 */     // GIR_Coverage, 13900,
     /* 1321694 */     GIR_EraseRootFromParent_Done,
     /* 1321695 */   // Label 18904: @1321695
     /* 1321695 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1321776), // Rule ID 13901 //
     /* 1321700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1321711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1321714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1321717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1321723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321753 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321775 */     // GIR_Coverage, 13901,
     /* 1321775 */     GIR_EraseRootFromParent_Done,
     /* 1321776 */   // Label 18905: @1321776
     /* 1321776 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1321857), // Rule ID 13902 //
     /* 1321781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1321784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1321792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1321795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1321798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1321834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321856 */     // GIR_Coverage, 13902,
     /* 1321856 */     GIR_EraseRootFromParent_Done,
     /* 1321857 */   // Label 18906: @1321857
     /* 1321857 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1321938), // Rule ID 13903 //
     /* 1321862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1321865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1321873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1321876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1321879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1321882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1321885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1321892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321915 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1321915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1321918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321937 */     // GIR_Coverage, 13903,
     /* 1321937 */     GIR_EraseRootFromParent_Done,
     /* 1321938 */   // Label 18907: @1321938
     /* 1321938 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1322019), // Rule ID 13904 //
     /* 1321943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1321954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1321957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1321960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1321963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1321985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1321996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1321999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322018 */     // GIR_Coverage, 13904,
     /* 1322018 */     GIR_EraseRootFromParent_Done,
     /* 1322019 */   // Label 18908: @1322019
     /* 1322019 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1322100), // Rule ID 13905 //
     /* 1322024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1322035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1322038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1322041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1322080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322099 */     // GIR_Coverage, 13905,
     /* 1322099 */     GIR_EraseRootFromParent_Done,
     /* 1322100 */   // Label 18909: @1322100
     /* 1322100 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1322181), // Rule ID 13906 //
     /* 1322105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1322116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1322119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1322122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1322128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1322161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322180 */     // GIR_Coverage, 13906,
     /* 1322180 */     GIR_EraseRootFromParent_Done,
     /* 1322181 */   // Label 18910: @1322181
     /* 1322181 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1322262), // Rule ID 13907 //
     /* 1322186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1322197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1322200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1322203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1322209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322239 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1322242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322261 */     // GIR_Coverage, 13907,
     /* 1322261 */     GIR_EraseRootFromParent_Done,
     /* 1322262 */   // Label 18911: @1322262
     /* 1322262 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1322343), // Rule ID 13908 //
     /* 1322267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1322278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1322281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1322284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1322290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1322323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322342 */     // GIR_Coverage, 13908,
     /* 1322342 */     GIR_EraseRootFromParent_Done,
     /* 1322343 */   // Label 18912: @1322343
     /* 1322343 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1322424), // Rule ID 13909 //
     /* 1322348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1322359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1322362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1322365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1322371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322401 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1322404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322423 */     // GIR_Coverage, 13909,
     /* 1322423 */     GIR_EraseRootFromParent_Done,
     /* 1322424 */   // Label 18913: @1322424
     /* 1322424 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1322505), // Rule ID 13910 //
     /* 1322429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1322440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1322443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1322446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1322482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1322485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322504 */     // GIR_Coverage, 13910,
     /* 1322504 */     GIR_EraseRootFromParent_Done,
     /* 1322505 */   // Label 18914: @1322505
     /* 1322505 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1322586), // Rule ID 13911 //
     /* 1322510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1322521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1322524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1322527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1322563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1322566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322585 */     // GIR_Coverage, 13911,
     /* 1322585 */     GIR_EraseRootFromParent_Done,
     /* 1322586 */   // Label 18915: @1322586
     /* 1322586 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1322667), // Rule ID 13912 //
     /* 1322591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1322602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1322605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1322608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1322644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1322647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322666 */     // GIR_Coverage, 13912,
     /* 1322666 */     GIR_EraseRootFromParent_Done,
     /* 1322667 */   // Label 18916: @1322667
     /* 1322667 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1322748), // Rule ID 13913 //
     /* 1322672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1322683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1322686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1322689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322725 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1322725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1322728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322747 */     // GIR_Coverage, 13913,
     /* 1322747 */     GIR_EraseRootFromParent_Done,
     /* 1322748 */   // Label 18917: @1322748
     /* 1322748 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1322829), // Rule ID 13914 //
     /* 1322753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1322764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1322767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1322770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1322776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1322806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1322809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322828 */     // GIR_Coverage, 13914,
     /* 1322828 */     GIR_EraseRootFromParent_Done,
     /* 1322829 */   // Label 18918: @1322829
     /* 1322829 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1322910), // Rule ID 13915 //
     /* 1322834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1322845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1322848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1322851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1322857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322887 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1322887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1322890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322909 */     // GIR_Coverage, 13915,
     /* 1322909 */     GIR_EraseRootFromParent_Done,
     /* 1322910 */   // Label 18919: @1322910
     /* 1322910 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1322991), // Rule ID 13916 //
     /* 1322915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1322926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1322929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1322932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1322968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1322971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322990 */     // GIR_Coverage, 13916,
     /* 1322990 */     GIR_EraseRootFromParent_Done,
     /* 1322991 */   // Label 18920: @1322991
     /* 1322991 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1323072), // Rule ID 13917 //
     /* 1322996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1323007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1323010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1323013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1323026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1323052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323071 */     // GIR_Coverage, 13917,
     /* 1323071 */     GIR_EraseRootFromParent_Done,
     /* 1323072 */   // Label 18921: @1323072
     /* 1323072 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1323153), // Rule ID 13918 //
     /* 1323077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1323088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1323091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1323094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1323107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1323133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323152 */     // GIR_Coverage, 13918,
     /* 1323152 */     GIR_EraseRootFromParent_Done,
     /* 1323153 */   // Label 18922: @1323153
     /* 1323153 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1323234), // Rule ID 13919 //
     /* 1323158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1323169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1323172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1323175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1323188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1323214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323233 */     // GIR_Coverage, 13919,
     /* 1323233 */     GIR_EraseRootFromParent_Done,
     /* 1323234 */   // Label 18923: @1323234
     /* 1323234 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1323315), // Rule ID 13920 //
     /* 1323239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1323250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1323253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1323256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1323262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1323269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1323295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323314 */     // GIR_Coverage, 13920,
     /* 1323314 */     GIR_EraseRootFromParent_Done,
     /* 1323315 */   // Label 18924: @1323315
     /* 1323315 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1323396), // Rule ID 13921 //
     /* 1323320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1323331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1323334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1323337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1323343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1323350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323373 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1323376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323395 */     // GIR_Coverage, 13921,
     /* 1323395 */     GIR_EraseRootFromParent_Done,
     /* 1323396 */   // Label 18925: @1323396
     /* 1323396 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1323477), // Rule ID 13922 //
     /* 1323401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1323404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1323412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1323415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1323418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1323431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1323454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1323457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323476 */     // GIR_Coverage, 13922,
     /* 1323476 */     GIR_EraseRootFromParent_Done,
     /* 1323477 */   // Label 18926: @1323477
     /* 1323477 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1323558), // Rule ID 13923 //
     /* 1323482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1323485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1323493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1323496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1323499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1323512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1323535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1323538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323557 */     // GIR_Coverage, 13923,
     /* 1323557 */     GIR_EraseRootFromParent_Done,
     /* 1323558 */   // Label 18927: @1323558
     /* 1323558 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1323639), // Rule ID 13924 //
     /* 1323563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1323566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1323574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1323577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1323580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1323593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1323616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1323619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323638 */     // GIR_Coverage, 13924,
     /* 1323638 */     GIR_EraseRootFromParent_Done,
     /* 1323639 */   // Label 18928: @1323639
     /* 1323639 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1323720), // Rule ID 13925 //
     /* 1323644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1323647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1323655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1323658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1323661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1323674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323697 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1323697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1323700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323719 */     // GIR_Coverage, 13925,
     /* 1323719 */     GIR_EraseRootFromParent_Done,
     /* 1323720 */   // Label 18929: @1323720
     /* 1323720 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1323801), // Rule ID 13926 //
     /* 1323725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1323728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1323736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1323739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1323742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1323755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1323778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1323781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323800 */     // GIR_Coverage, 13926,
     /* 1323800 */     GIR_EraseRootFromParent_Done,
     /* 1323801 */   // Label 18930: @1323801
     /* 1323801 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1323882), // Rule ID 13927 //
     /* 1323806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1323809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1323817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1323820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1323823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1323836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323859 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1323859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1323862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323881 */     // GIR_Coverage, 13927,
     /* 1323881 */     GIR_EraseRootFromParent_Done,
     /* 1323882 */   // Label 18931: @1323882
     /* 1323882 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1323966), // Rule ID 19766 //
     /* 1323887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1323890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1323898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1323901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1323907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1323943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323965 */     // GIR_Coverage, 19766,
     /* 1323965 */     GIR_EraseRootFromParent_Done,
     /* 1323966 */   // Label 18932: @1323966
     /* 1323966 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1324050), // Rule ID 19767 //
     /* 1323971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1323974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1323982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1323985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1323991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1324027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324049 */     // GIR_Coverage, 19767,
     /* 1324049 */     GIR_EraseRootFromParent_Done,
     /* 1324050 */   // Label 18933: @1324050
     /* 1324050 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1324134), // Rule ID 19770 //
     /* 1324055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1324058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1324072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1324075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1324111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324133 */     // GIR_Coverage, 19770,
     /* 1324133 */     GIR_EraseRootFromParent_Done,
     /* 1324134 */   // Label 18934: @1324134
     /* 1324134 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1324218), // Rule ID 19771 //
     /* 1324139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1324142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1324156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1324159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1324195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324217 */     // GIR_Coverage, 19771,
     /* 1324217 */     GIR_EraseRootFromParent_Done,
     /* 1324218 */   // Label 18935: @1324218
     /* 1324218 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1324302), // Rule ID 19774 //
     /* 1324223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1324226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1324240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1324243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1324279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324301 */     // GIR_Coverage, 19774,
     /* 1324301 */     GIR_EraseRootFromParent_Done,
     /* 1324302 */   // Label 18936: @1324302
     /* 1324302 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1324386), // Rule ID 19775 //
     /* 1324307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1324310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1324324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1324327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1324363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324385 */     // GIR_Coverage, 19775,
     /* 1324385 */     GIR_EraseRootFromParent_Done,
     /* 1324386 */   // Label 18937: @1324386
     /* 1324386 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1324470), // Rule ID 19778 //
     /* 1324391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1324394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1324402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1324405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1324411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324469 */     // GIR_Coverage, 19778,
     /* 1324469 */     GIR_EraseRootFromParent_Done,
     /* 1324470 */   // Label 18938: @1324470
     /* 1324470 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1324554), // Rule ID 19779 //
     /* 1324475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1324478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1324486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1324489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1324492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1324495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324553 */     // GIR_Coverage, 19779,
     /* 1324553 */     GIR_EraseRootFromParent_Done,
     /* 1324554 */   // Label 18939: @1324554
     /* 1324554 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1324638), // Rule ID 19782 //
     /* 1324559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1324562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1324579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324637 */     // GIR_Coverage, 19782,
     /* 1324637 */     GIR_EraseRootFromParent_Done,
     /* 1324638 */   // Label 18940: @1324638
     /* 1324638 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1324722), // Rule ID 19783 //
     /* 1324643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1324646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1324660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1324663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324721 */     // GIR_Coverage, 19783,
     /* 1324721 */     GIR_EraseRootFromParent_Done,
     /* 1324722 */   // Label 18941: @1324722
     /* 1324722 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1324806), // Rule ID 19786 //
     /* 1324727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1324730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1324747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324805 */     // GIR_Coverage, 19786,
     /* 1324805 */     GIR_EraseRootFromParent_Done,
     /* 1324806 */   // Label 18942: @1324806
     /* 1324806 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1324890), // Rule ID 19787 //
     /* 1324811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1324814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1324831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1324867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324889 */     // GIR_Coverage, 19787,
     /* 1324889 */     GIR_EraseRootFromParent_Done,
     /* 1324890 */   // Label 18943: @1324890
     /* 1324890 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1324974), // Rule ID 19790 //
     /* 1324895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1324898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1324906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1324909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1324915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1324951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324973 */     // GIR_Coverage, 19790,
     /* 1324973 */     GIR_EraseRootFromParent_Done,
     /* 1324974 */   // Label 18944: @1324974
     /* 1324974 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1325058), // Rule ID 19791 //
     /* 1324979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1324982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1324990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1324993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1324999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1325035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325057 */     // GIR_Coverage, 19791,
     /* 1325057 */     GIR_EraseRootFromParent_Done,
     /* 1325058 */   // Label 18945: @1325058
     /* 1325058 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1325142), // Rule ID 19794 //
     /* 1325063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1325119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325141 */     // GIR_Coverage, 19794,
     /* 1325141 */     GIR_EraseRootFromParent_Done,
     /* 1325142 */   // Label 18946: @1325142
     /* 1325142 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1325226), // Rule ID 19795 //
     /* 1325147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1325150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1325203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325225 */     // GIR_Coverage, 19795,
     /* 1325225 */     GIR_EraseRootFromParent_Done,
     /* 1325226 */   // Label 18947: @1325226
     /* 1325226 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1325310), // Rule ID 19798 //
     /* 1325231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1325242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1325245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1325251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325284 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1325287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325309 */     // GIR_Coverage, 19798,
     /* 1325309 */     GIR_EraseRootFromParent_Done,
     /* 1325310 */   // Label 18948: @1325310
     /* 1325310 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1325394), // Rule ID 19799 //
     /* 1325315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1325318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1325326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1325329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1325335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325368 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1325371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325393 */     // GIR_Coverage, 19799,
     /* 1325393 */     GIR_EraseRootFromParent_Done,
     /* 1325394 */   // Label 18949: @1325394
     /* 1325394 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1325478), // Rule ID 19802 //
     /* 1325399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1325402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1325410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1325413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1325419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1325455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325477 */     // GIR_Coverage, 19802,
     /* 1325477 */     GIR_EraseRootFromParent_Done,
     /* 1325478 */   // Label 18950: @1325478
     /* 1325478 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1325562), // Rule ID 19803 //
     /* 1325483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1325486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1325494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1325497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1325503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1325539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325561 */     // GIR_Coverage, 19803,
     /* 1325561 */     GIR_EraseRootFromParent_Done,
     /* 1325562 */   // Label 18951: @1325562
     /* 1325562 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1325646), // Rule ID 19806 //
     /* 1325567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1325570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1325578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1325581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1325587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1325623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325645 */     // GIR_Coverage, 19806,
     /* 1325645 */     GIR_EraseRootFromParent_Done,
     /* 1325646 */   // Label 18952: @1325646
     /* 1325646 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1325730), // Rule ID 19807 //
     /* 1325651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1325654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1325662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1325665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1325671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325704 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1325707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325729 */     // GIR_Coverage, 19807,
     /* 1325729 */     GIR_EraseRootFromParent_Done,
     /* 1325730 */   // Label 18953: @1325730
     /* 1325730 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1325814), // Rule ID 19810 //
     /* 1325735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1325738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1325755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1325791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325813 */     // GIR_Coverage, 19810,
     /* 1325813 */     GIR_EraseRootFromParent_Done,
     /* 1325814 */   // Label 18954: @1325814
     /* 1325814 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1325898), // Rule ID 19811 //
     /* 1325819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1325822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1325839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1325875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325897 */     // GIR_Coverage, 19811,
     /* 1325897 */     GIR_EraseRootFromParent_Done,
     /* 1325898 */   // Label 18955: @1325898
     /* 1325898 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1325982), // Rule ID 19814 //
     /* 1325903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1325906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1325914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1325917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1325923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1325959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325981 */     // GIR_Coverage, 19814,
     /* 1325981 */     GIR_EraseRootFromParent_Done,
     /* 1325982 */   // Label 18956: @1325982
     /* 1325982 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1326066), // Rule ID 19815 //
     /* 1325987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1325990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1325995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1325998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1326007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1326043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326065 */     // GIR_Coverage, 19815,
     /* 1326065 */     GIR_EraseRootFromParent_Done,
     /* 1326066 */   // Label 18957: @1326066
     /* 1326066 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1326150), // Rule ID 19818 //
     /* 1326071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1326127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326149 */     // GIR_Coverage, 19818,
     /* 1326149 */     GIR_EraseRootFromParent_Done,
     /* 1326150 */   // Label 18958: @1326150
     /* 1326150 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1326234), // Rule ID 19819 //
     /* 1326155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1326158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1326211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326233 */     // GIR_Coverage, 19819,
     /* 1326233 */     GIR_EraseRootFromParent_Done,
     /* 1326234 */   // Label 18959: @1326234
     /* 1326234 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1326318), // Rule ID 19822 //
     /* 1326239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1326250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1326253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1326259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1326295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326317 */     // GIR_Coverage, 19822,
     /* 1326317 */     GIR_EraseRootFromParent_Done,
     /* 1326318 */   // Label 18960: @1326318
     /* 1326318 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1326402), // Rule ID 19823 //
     /* 1326323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1326326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1326334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1326337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1326343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1326379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326401 */     // GIR_Coverage, 19823,
     /* 1326401 */     GIR_EraseRootFromParent_Done,
     /* 1326402 */   // Label 18961: @1326402
     /* 1326402 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1326486), // Rule ID 19826 //
     /* 1326407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1326427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1326449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326460 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1326463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326485 */     // GIR_Coverage, 19826,
     /* 1326485 */     GIR_EraseRootFromParent_Done,
     /* 1326486 */   // Label 18962: @1326486
     /* 1326486 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1326570), // Rule ID 19827 //
     /* 1326491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1326511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1326533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1326547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326569 */     // GIR_Coverage, 19827,
     /* 1326569 */     GIR_EraseRootFromParent_Done,
     /* 1326570 */   // Label 18963: @1326570
     /* 1326570 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1326654), // Rule ID 19830 //
     /* 1326575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1326595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1326617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326628 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1326631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326653 */     // GIR_Coverage, 19830,
     /* 1326653 */     GIR_EraseRootFromParent_Done,
     /* 1326654 */   // Label 18964: @1326654
     /* 1326654 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1326738), // Rule ID 19831 //
     /* 1326659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1326679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1326701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1326715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326737 */     // GIR_Coverage, 19831,
     /* 1326737 */     GIR_EraseRootFromParent_Done,
     /* 1326738 */   // Label 18965: @1326738
     /* 1326738 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1326822), // Rule ID 19834 //
     /* 1326743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1326785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1326799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326821 */     // GIR_Coverage, 19834,
     /* 1326821 */     GIR_EraseRootFromParent_Done,
     /* 1326822 */   // Label 18966: @1326822
     /* 1326822 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1326906), // Rule ID 19835 //
     /* 1326827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1326869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326880 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1326883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326905 */     // GIR_Coverage, 19835,
     /* 1326905 */     GIR_EraseRootFromParent_Done,
     /* 1326906 */   // Label 18967: @1326906
     /* 1326906 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1326990), // Rule ID 19838 //
     /* 1326911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1326928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1326931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1326953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1326967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326989 */     // GIR_Coverage, 19838,
     /* 1326989 */     GIR_EraseRootFromParent_Done,
     /* 1326990 */   // Label 18968: @1326990
     /* 1326990 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1327074), // Rule ID 19839 //
     /* 1326995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327048 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1327051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327073 */     // GIR_Coverage, 19839,
     /* 1327073 */     GIR_EraseRootFromParent_Done,
     /* 1327074 */   // Label 18969: @1327074
     /* 1327074 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1327158), // Rule ID 19842 //
     /* 1327079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1327135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327157 */     // GIR_Coverage, 19842,
     /* 1327157 */     GIR_EraseRootFromParent_Done,
     /* 1327158 */   // Label 18970: @1327158
     /* 1327158 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1327242), // Rule ID 19843 //
     /* 1327163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1327219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327241 */     // GIR_Coverage, 19843,
     /* 1327241 */     GIR_EraseRootFromParent_Done,
     /* 1327242 */   // Label 18971: @1327242
     /* 1327242 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1327326), // Rule ID 19846 //
     /* 1327247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1327250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1327289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327300 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1327303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327325 */     // GIR_Coverage, 19846,
     /* 1327325 */     GIR_EraseRootFromParent_Done,
     /* 1327326 */   // Label 18972: @1327326
     /* 1327326 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1327410), // Rule ID 19847 //
     /* 1327331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1327373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1327387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327409 */     // GIR_Coverage, 19847,
     /* 1327409 */     GIR_EraseRootFromParent_Done,
     /* 1327410 */   // Label 18973: @1327410
     /* 1327410 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1327494), // Rule ID 19850 //
     /* 1327415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1327471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327493 */     // GIR_Coverage, 19850,
     /* 1327493 */     GIR_EraseRootFromParent_Done,
     /* 1327494 */   // Label 18974: @1327494
     /* 1327494 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1327578), // Rule ID 19851 //
     /* 1327499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1327555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327577 */     // GIR_Coverage, 19851,
     /* 1327577 */     GIR_EraseRootFromParent_Done,
     /* 1327578 */   // Label 18975: @1327578
     /* 1327578 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1327662), // Rule ID 19854 //
     /* 1327583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1327639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327661 */     // GIR_Coverage, 19854,
     /* 1327661 */     GIR_EraseRootFromParent_Done,
     /* 1327662 */   // Label 18976: @1327662
     /* 1327662 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1327746), // Rule ID 19855 //
     /* 1327667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327720 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1327723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327745 */     // GIR_Coverage, 19855,
     /* 1327745 */     GIR_EraseRootFromParent_Done,
     /* 1327746 */   // Label 18977: @1327746
     /* 1327746 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1327830), // Rule ID 19858 //
     /* 1327751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327804 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1327807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327829 */     // GIR_Coverage, 19858,
     /* 1327829 */     GIR_EraseRootFromParent_Done,
     /* 1327830 */   // Label 18978: @1327830
     /* 1327830 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1327914), // Rule ID 19859 //
     /* 1327835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327888 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1327891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327913 */     // GIR_Coverage, 19859,
     /* 1327913 */     GIR_EraseRootFromParent_Done,
     /* 1327914 */   // Label 18979: @1327914
     /* 1327914 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1327998), // Rule ID 19862 //
     /* 1327919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1327936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1327975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327997 */     // GIR_Coverage, 19862,
     /* 1327997 */     GIR_EraseRootFromParent_Done,
     /* 1327998 */   // Label 18980: @1327998
     /* 1327998 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1328082), // Rule ID 19863 //
     /* 1328003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328056 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1328059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328081 */     // GIR_Coverage, 19863,
     /* 1328081 */     GIR_EraseRootFromParent_Done,
     /* 1328082 */   // Label 18981: @1328082
     /* 1328082 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1328166), // Rule ID 19866 //
     /* 1328087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1328143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328165 */     // GIR_Coverage, 19866,
     /* 1328165 */     GIR_EraseRootFromParent_Done,
     /* 1328166 */   // Label 18982: @1328166
     /* 1328166 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1328250), // Rule ID 19867 //
     /* 1328171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1328227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328249 */     // GIR_Coverage, 19867,
     /* 1328249 */     GIR_EraseRootFromParent_Done,
     /* 1328250 */   // Label 18983: @1328250
     /* 1328250 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1328334), // Rule ID 19870 //
     /* 1328255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1328311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328333 */     // GIR_Coverage, 19870,
     /* 1328333 */     GIR_EraseRootFromParent_Done,
     /* 1328334 */   // Label 18984: @1328334
     /* 1328334 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1328418), // Rule ID 19871 //
     /* 1328339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1328395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328417 */     // GIR_Coverage, 19871,
     /* 1328417 */     GIR_EraseRootFromParent_Done,
     /* 1328418 */   // Label 18985: @1328418
     /* 1328418 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1328502), // Rule ID 19874 //
     /* 1328423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1328479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328501 */     // GIR_Coverage, 19874,
     /* 1328501 */     GIR_EraseRootFromParent_Done,
     /* 1328502 */   // Label 18986: @1328502
     /* 1328502 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1328586), // Rule ID 19875 //
     /* 1328507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328560 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1328563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328585 */     // GIR_Coverage, 19875,
     /* 1328585 */     GIR_EraseRootFromParent_Done,
     /* 1328586 */   // Label 18987: @1328586
     /* 1328586 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1328670), // Rule ID 19878 //
     /* 1328591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1328647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328669 */     // GIR_Coverage, 19878,
     /* 1328669 */     GIR_EraseRootFromParent_Done,
     /* 1328670 */   // Label 18988: @1328670
     /* 1328670 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1328754), // Rule ID 19879 //
     /* 1328675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1328731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328753 */     // GIR_Coverage, 19879,
     /* 1328753 */     GIR_EraseRootFromParent_Done,
     /* 1328754 */   // Label 18989: @1328754
     /* 1328754 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1328838), // Rule ID 19882 //
     /* 1328759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1328815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328837 */     // GIR_Coverage, 19882,
     /* 1328837 */     GIR_EraseRootFromParent_Done,
     /* 1328838 */   // Label 18990: @1328838
     /* 1328838 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1328922), // Rule ID 19883 //
     /* 1328843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1328899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328921 */     // GIR_Coverage, 19883,
     /* 1328921 */     GIR_EraseRootFromParent_Done,
     /* 1328922 */   // Label 18991: @1328922
     /* 1328922 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1329006), // Rule ID 19886 //
     /* 1328927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1328947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328980 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1328983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329005 */     // GIR_Coverage, 19886,
     /* 1329005 */     GIR_EraseRootFromParent_Done,
     /* 1329006 */   // Label 18992: @1329006
     /* 1329006 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1329090), // Rule ID 19887 //
     /* 1329011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1329031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1329067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329089 */     // GIR_Coverage, 19887,
     /* 1329089 */     GIR_EraseRootFromParent_Done,
     /* 1329090 */   // Label 18993: @1329090
     /* 1329090 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1329174), // Rule ID 19890 //
     /* 1329095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1329115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329148 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1329151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329173 */     // GIR_Coverage, 19890,
     /* 1329173 */     GIR_EraseRootFromParent_Done,
     /* 1329174 */   // Label 18994: @1329174
     /* 1329174 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1329258), // Rule ID 19891 //
     /* 1329179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1329199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329232 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1329235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329257 */     // GIR_Coverage, 19891,
     /* 1329257 */     GIR_EraseRootFromParent_Done,
     /* 1329258 */   // Label 18995: @1329258
     /* 1329258 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1329342), // Rule ID 19894 //
     /* 1329263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1329283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1329319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329341 */     // GIR_Coverage, 19894,
     /* 1329341 */     GIR_EraseRootFromParent_Done,
     /* 1329342 */   // Label 18996: @1329342
     /* 1329342 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1329426), // Rule ID 19895 //
     /* 1329347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1329367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1329403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329425 */     // GIR_Coverage, 19895,
     /* 1329425 */     GIR_EraseRootFromParent_Done,
     /* 1329426 */   // Label 18997: @1329426
     /* 1329426 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1329510), // Rule ID 19898 //
     /* 1329431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1329451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329509 */     // GIR_Coverage, 19898,
     /* 1329509 */     GIR_EraseRootFromParent_Done,
     /* 1329510 */   // Label 18998: @1329510
     /* 1329510 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1329594), // Rule ID 19899 //
     /* 1329515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1329535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329593 */     // GIR_Coverage, 19899,
     /* 1329593 */     GIR_EraseRootFromParent_Done,
     /* 1329594 */   // Label 18999: @1329594
     /* 1329594 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1329678), // Rule ID 19902 //
     /* 1329599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1329619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329677 */     // GIR_Coverage, 19902,
     /* 1329677 */     GIR_EraseRootFromParent_Done,
     /* 1329678 */   // Label 19000: @1329678
     /* 1329678 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1329762), // Rule ID 19903 //
     /* 1329683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1329703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329736 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329761 */     // GIR_Coverage, 19903,
     /* 1329761 */     GIR_EraseRootFromParent_Done,
     /* 1329762 */   // Label 19001: @1329762
     /* 1329762 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1329846), // Rule ID 19906 //
     /* 1329767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1329787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329845 */     // GIR_Coverage, 19906,
     /* 1329845 */     GIR_EraseRootFromParent_Done,
     /* 1329846 */   // Label 19002: @1329846
     /* 1329846 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1329930), // Rule ID 19907 //
     /* 1329851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1329871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329904 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1329907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329929 */     // GIR_Coverage, 19907,
     /* 1329929 */     GIR_EraseRootFromParent_Done,
     /* 1329930 */   // Label 19003: @1329930
     /* 1329930 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1330014), // Rule ID 19910 //
     /* 1329935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1329955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1329991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330013 */     // GIR_Coverage, 19910,
     /* 1330013 */     GIR_EraseRootFromParent_Done,
     /* 1330014 */   // Label 19004: @1330014
     /* 1330014 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1330098), // Rule ID 19911 //
     /* 1330019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1330039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1330075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330097 */     // GIR_Coverage, 19911,
     /* 1330097 */     GIR_EraseRootFromParent_Done,
     /* 1330098 */   // Label 19005: @1330098
     /* 1330098 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1330182), // Rule ID 19914 //
     /* 1330103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1330123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1330159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330181 */     // GIR_Coverage, 19914,
     /* 1330181 */     GIR_EraseRootFromParent_Done,
     /* 1330182 */   // Label 19006: @1330182
     /* 1330182 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1330266), // Rule ID 19915 //
     /* 1330187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1330207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1330243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330265 */     // GIR_Coverage, 19915,
     /* 1330265 */     GIR_EraseRootFromParent_Done,
     /* 1330266 */   // Label 19007: @1330266
     /* 1330266 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1330350), // Rule ID 19918 //
     /* 1330271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1330291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330324 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1330327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330349 */     // GIR_Coverage, 19918,
     /* 1330349 */     GIR_EraseRootFromParent_Done,
     /* 1330350 */   // Label 19008: @1330350
     /* 1330350 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1330434), // Rule ID 19919 //
     /* 1330355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1330375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330408 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1330411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330433 */     // GIR_Coverage, 19919,
     /* 1330433 */     GIR_EraseRootFromParent_Done,
     /* 1330434 */   // Label 19009: @1330434
     /* 1330434 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1330518), // Rule ID 19922 //
     /* 1330439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1330459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1330495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330517 */     // GIR_Coverage, 19922,
     /* 1330517 */     GIR_EraseRootFromParent_Done,
     /* 1330518 */   // Label 19010: @1330518
     /* 1330518 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1330602), // Rule ID 19923 //
     /* 1330523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1330543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1330579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330601 */     // GIR_Coverage, 19923,
     /* 1330601 */     GIR_EraseRootFromParent_Done,
     /* 1330602 */   // Label 19011: @1330602
     /* 1330602 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1330686), // Rule ID 19926 //
     /* 1330607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1330627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1330663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330685 */     // GIR_Coverage, 19926,
     /* 1330685 */     GIR_EraseRootFromParent_Done,
     /* 1330686 */   // Label 19012: @1330686
     /* 1330686 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1330770), // Rule ID 19927 //
     /* 1330691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1330711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1330747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330769 */     // GIR_Coverage, 19927,
     /* 1330769 */     GIR_EraseRootFromParent_Done,
     /* 1330770 */   // Label 19013: @1330770
     /* 1330770 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1330854), // Rule ID 19930 //
     /* 1330775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1330795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1330831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330853 */     // GIR_Coverage, 19930,
     /* 1330853 */     GIR_EraseRootFromParent_Done,
     /* 1330854 */   // Label 19014: @1330854
     /* 1330854 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1330938), // Rule ID 19931 //
     /* 1330859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1330879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1330915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330937 */     // GIR_Coverage, 19931,
     /* 1330937 */     GIR_EraseRootFromParent_Done,
     /* 1330938 */   // Label 19015: @1330938
     /* 1330938 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1331022), // Rule ID 19934 //
     /* 1330943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1330951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1330960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1330963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330996 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1330999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331021 */     // GIR_Coverage, 19934,
     /* 1331021 */     GIR_EraseRootFromParent_Done,
     /* 1331022 */   // Label 19016: @1331022
     /* 1331022 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1331106), // Rule ID 19935 //
     /* 1331027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1331047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331080 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1331083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331105 */     // GIR_Coverage, 19935,
     /* 1331105 */     GIR_EraseRootFromParent_Done,
     /* 1331106 */   // Label 19017: @1331106
     /* 1331106 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1331190), // Rule ID 19938 //
     /* 1331111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1331131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1331167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331189 */     // GIR_Coverage, 19938,
     /* 1331189 */     GIR_EraseRootFromParent_Done,
     /* 1331190 */   // Label 19018: @1331190
     /* 1331190 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1331274), // Rule ID 19939 //
     /* 1331195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1331215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1331251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331273 */     // GIR_Coverage, 19939,
     /* 1331273 */     GIR_EraseRootFromParent_Done,
     /* 1331274 */   // Label 19019: @1331274
     /* 1331274 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1331358), // Rule ID 19942 //
     /* 1331279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1331299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1331335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331357 */     // GIR_Coverage, 19942,
     /* 1331357 */     GIR_EraseRootFromParent_Done,
     /* 1331358 */   // Label 19020: @1331358
     /* 1331358 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1331442), // Rule ID 19943 //
     /* 1331363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1331383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1331419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331441 */     // GIR_Coverage, 19943,
     /* 1331441 */     GIR_EraseRootFromParent_Done,
     /* 1331442 */   // Label 19021: @1331442
     /* 1331442 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1331526), // Rule ID 19946 //
     /* 1331447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1331467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1331489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1331503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331525 */     // GIR_Coverage, 19946,
     /* 1331525 */     GIR_EraseRootFromParent_Done,
     /* 1331526 */   // Label 19022: @1331526
     /* 1331526 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1331610), // Rule ID 19947 //
     /* 1331531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1331551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1331573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1331587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331609 */     // GIR_Coverage, 19947,
     /* 1331609 */     GIR_EraseRootFromParent_Done,
     /* 1331610 */   // Label 19023: @1331610
     /* 1331610 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1331694), // Rule ID 19950 //
     /* 1331615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1331635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1331657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331668 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1331671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331693 */     // GIR_Coverage, 19950,
     /* 1331693 */     GIR_EraseRootFromParent_Done,
     /* 1331694 */   // Label 19024: @1331694
     /* 1331694 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1331778), // Rule ID 19951 //
     /* 1331699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1331719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1331741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1331755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331777 */     // GIR_Coverage, 19951,
     /* 1331777 */     GIR_EraseRootFromParent_Done,
     /* 1331778 */   // Label 19025: @1331778
     /* 1331778 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1331862), // Rule ID 19954 //
     /* 1331783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1331825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331836 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1331839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331861 */     // GIR_Coverage, 19954,
     /* 1331861 */     GIR_EraseRootFromParent_Done,
     /* 1331862 */   // Label 19026: @1331862
     /* 1331862 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1331946), // Rule ID 19955 //
     /* 1331867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1331887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1331909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1331923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331945 */     // GIR_Coverage, 19955,
     /* 1331945 */     GIR_EraseRootFromParent_Done,
     /* 1331946 */   // Label 19027: @1331946
     /* 1331946 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1332030), // Rule ID 19958 //
     /* 1331951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1331968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1331971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1331993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1332007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332029 */     // GIR_Coverage, 19958,
     /* 1332029 */     GIR_EraseRootFromParent_Done,
     /* 1332030 */   // Label 19028: @1332030
     /* 1332030 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1332114), // Rule ID 19959 //
     /* 1332035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1332091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332113 */     // GIR_Coverage, 19959,
     /* 1332113 */     GIR_EraseRootFromParent_Done,
     /* 1332114 */   // Label 19029: @1332114
     /* 1332114 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1332198), // Rule ID 19962 //
     /* 1332119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332172 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1332175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332197 */     // GIR_Coverage, 19962,
     /* 1332197 */     GIR_EraseRootFromParent_Done,
     /* 1332198 */   // Label 19030: @1332198
     /* 1332198 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1332282), // Rule ID 19963 //
     /* 1332203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1332259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332281 */     // GIR_Coverage, 19963,
     /* 1332281 */     GIR_EraseRootFromParent_Done,
     /* 1332282 */   // Label 19031: @1332282
     /* 1332282 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1332366), // Rule ID 19966 //
     /* 1332287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1332329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1332343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332365 */     // GIR_Coverage, 19966,
     /* 1332365 */     GIR_EraseRootFromParent_Done,
     /* 1332366 */   // Label 19032: @1332366
     /* 1332366 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1332450), // Rule ID 19967 //
     /* 1332371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1332413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332424 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1332427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332449 */     // GIR_Coverage, 19967,
     /* 1332449 */     GIR_EraseRootFromParent_Done,
     /* 1332450 */   // Label 19033: @1332450
     /* 1332450 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1332534), // Rule ID 19970 //
     /* 1332455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1332511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332533 */     // GIR_Coverage, 19970,
     /* 1332533 */     GIR_EraseRootFromParent_Done,
     /* 1332534 */   // Label 19034: @1332534
     /* 1332534 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1332618), // Rule ID 19971 //
     /* 1332539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332592 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1332595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332617 */     // GIR_Coverage, 19971,
     /* 1332617 */     GIR_EraseRootFromParent_Done,
     /* 1332618 */   // Label 19035: @1332618
     /* 1332618 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1332702), // Rule ID 19974 //
     /* 1332623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1332679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332701 */     // GIR_Coverage, 19974,
     /* 1332701 */     GIR_EraseRootFromParent_Done,
     /* 1332702 */   // Label 19036: @1332702
     /* 1332702 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1332786), // Rule ID 19975 //
     /* 1332707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332760 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1332763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332785 */     // GIR_Coverage, 19975,
     /* 1332785 */     GIR_EraseRootFromParent_Done,
     /* 1332786 */   // Label 19037: @1332786
     /* 1332786 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1332870), // Rule ID 19978 //
     /* 1332791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332844 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1332847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332869 */     // GIR_Coverage, 19978,
     /* 1332869 */     GIR_EraseRootFromParent_Done,
     /* 1332870 */   // Label 19038: @1332870
     /* 1332870 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1332954), // Rule ID 19979 //
     /* 1332875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332928 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1332931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332953 */     // GIR_Coverage, 19979,
     /* 1332953 */     GIR_EraseRootFromParent_Done,
     /* 1332954 */   // Label 19039: @1332954
     /* 1332954 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1333038), // Rule ID 19982 //
     /* 1332959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1332976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1333015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333037 */     // GIR_Coverage, 19982,
     /* 1333037 */     GIR_EraseRootFromParent_Done,
     /* 1333038 */   // Label 19040: @1333038
     /* 1333038 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1333122), // Rule ID 19983 //
     /* 1333043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1333099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333121 */     // GIR_Coverage, 19983,
     /* 1333121 */     GIR_EraseRootFromParent_Done,
     /* 1333122 */   // Label 19041: @1333122
     /* 1333122 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1333206), // Rule ID 19986 //
     /* 1333127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1333183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333205 */     // GIR_Coverage, 19986,
     /* 1333205 */     GIR_EraseRootFromParent_Done,
     /* 1333206 */   // Label 19042: @1333206
     /* 1333206 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1333290), // Rule ID 19987 //
     /* 1333211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1333267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333289 */     // GIR_Coverage, 19987,
     /* 1333289 */     GIR_EraseRootFromParent_Done,
     /* 1333290 */   // Label 19043: @1333290
     /* 1333290 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1333374), // Rule ID 19990 //
     /* 1333295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1333351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333373 */     // GIR_Coverage, 19990,
     /* 1333373 */     GIR_EraseRootFromParent_Done,
     /* 1333374 */   // Label 19044: @1333374
     /* 1333374 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1333458), // Rule ID 19991 //
     /* 1333379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1333435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333457 */     // GIR_Coverage, 19991,
     /* 1333457 */     GIR_EraseRootFromParent_Done,
     /* 1333458 */   // Label 19045: @1333458
     /* 1333458 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1333542), // Rule ID 19994 //
     /* 1333463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333516 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1333519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333541 */     // GIR_Coverage, 19994,
     /* 1333541 */     GIR_EraseRootFromParent_Done,
     /* 1333542 */   // Label 19046: @1333542
     /* 1333542 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1333626), // Rule ID 19995 //
     /* 1333547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1333603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333625 */     // GIR_Coverage, 19995,
     /* 1333625 */     GIR_EraseRootFromParent_Done,
     /* 1333626 */   // Label 19047: @1333626
     /* 1333626 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1333710), // Rule ID 19998 //
     /* 1333631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1333687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333709 */     // GIR_Coverage, 19998,
     /* 1333709 */     GIR_EraseRootFromParent_Done,
     /* 1333710 */   // Label 19048: @1333710
     /* 1333710 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1333794), // Rule ID 19999 //
     /* 1333715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333768 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1333771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333793 */     // GIR_Coverage, 19999,
     /* 1333793 */     GIR_EraseRootFromParent_Done,
     /* 1333794 */   // Label 19049: @1333794
     /* 1333794 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1333878), // Rule ID 20002 //
     /* 1333799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1333855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333877 */     // GIR_Coverage, 20002,
     /* 1333877 */     GIR_EraseRootFromParent_Done,
     /* 1333878 */   // Label 19050: @1333878
     /* 1333878 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1333962), // Rule ID 20003 //
     /* 1333883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1333939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333961 */     // GIR_Coverage, 20003,
     /* 1333961 */     GIR_EraseRootFromParent_Done,
     /* 1333962 */   // Label 19051: @1333962
     /* 1333962 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1334046), // Rule ID 20006 //
     /* 1333967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1333984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1333987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1334023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334045 */     // GIR_Coverage, 20006,
     /* 1334045 */     GIR_EraseRootFromParent_Done,
     /* 1334046 */   // Label 19052: @1334046
     /* 1334046 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1334130), // Rule ID 20007 //
     /* 1334051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1334071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334104 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1334107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334129 */     // GIR_Coverage, 20007,
     /* 1334129 */     GIR_EraseRootFromParent_Done,
     /* 1334130 */   // Label 19053: @1334130
     /* 1334130 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1334214), // Rule ID 20010 //
     /* 1334135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1334155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1334191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334213 */     // GIR_Coverage, 20010,
     /* 1334213 */     GIR_EraseRootFromParent_Done,
     /* 1334214 */   // Label 19054: @1334214
     /* 1334214 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1334298), // Rule ID 20011 //
     /* 1334219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1334239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334272 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1334275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334297 */     // GIR_Coverage, 20011,
     /* 1334297 */     GIR_EraseRootFromParent_Done,
     /* 1334298 */   // Label 19055: @1334298
     /* 1334298 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1334382), // Rule ID 20014 //
     /* 1334303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1334323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1334359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334381 */     // GIR_Coverage, 20014,
     /* 1334381 */     GIR_EraseRootFromParent_Done,
     /* 1334382 */   // Label 19056: @1334382
     /* 1334382 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1334466), // Rule ID 20015 //
     /* 1334387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1334407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334440 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1334443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334465 */     // GIR_Coverage, 20015,
     /* 1334465 */     GIR_EraseRootFromParent_Done,
     /* 1334466 */   // Label 19057: @1334466
     /* 1334466 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1334550), // Rule ID 20018 //
     /* 1334471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1334491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334549 */     // GIR_Coverage, 20018,
     /* 1334549 */     GIR_EraseRootFromParent_Done,
     /* 1334550 */   // Label 19058: @1334550
     /* 1334550 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1334634), // Rule ID 20019 //
     /* 1334555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1334575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334633 */     // GIR_Coverage, 20019,
     /* 1334633 */     GIR_EraseRootFromParent_Done,
     /* 1334634 */   // Label 19059: @1334634
     /* 1334634 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1334718), // Rule ID 20022 //
     /* 1334639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1334659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334717 */     // GIR_Coverage, 20022,
     /* 1334717 */     GIR_EraseRootFromParent_Done,
     /* 1334718 */   // Label 19060: @1334718
     /* 1334718 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1334802), // Rule ID 20023 //
     /* 1334723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1334743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334801 */     // GIR_Coverage, 20023,
     /* 1334801 */     GIR_EraseRootFromParent_Done,
     /* 1334802 */   // Label 19061: @1334802
     /* 1334802 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1334886), // Rule ID 20026 //
     /* 1334807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1334827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334885 */     // GIR_Coverage, 20026,
     /* 1334885 */     GIR_EraseRootFromParent_Done,
     /* 1334886 */   // Label 19062: @1334886
     /* 1334886 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1334970), // Rule ID 20027 //
     /* 1334891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1334911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1334947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334969 */     // GIR_Coverage, 20027,
     /* 1334969 */     GIR_EraseRootFromParent_Done,
     /* 1334970 */   // Label 19063: @1334970
     /* 1334970 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1335054), // Rule ID 20030 //
     /* 1334975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1334995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1335031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335053 */     // GIR_Coverage, 20030,
     /* 1335053 */     GIR_EraseRootFromParent_Done,
     /* 1335054 */   // Label 19064: @1335054
     /* 1335054 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1335138), // Rule ID 20031 //
     /* 1335059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1335079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335112 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1335115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335137 */     // GIR_Coverage, 20031,
     /* 1335137 */     GIR_EraseRootFromParent_Done,
     /* 1335138 */   // Label 19065: @1335138
     /* 1335138 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1335222), // Rule ID 20034 //
     /* 1335143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1335163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1335199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335221 */     // GIR_Coverage, 20034,
     /* 1335221 */     GIR_EraseRootFromParent_Done,
     /* 1335222 */   // Label 19066: @1335222
     /* 1335222 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1335306), // Rule ID 20035 //
     /* 1335227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1335247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335280 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1335283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335305 */     // GIR_Coverage, 20035,
     /* 1335305 */     GIR_EraseRootFromParent_Done,
     /* 1335306 */   // Label 19067: @1335306
     /* 1335306 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1335390), // Rule ID 20038 //
     /* 1335311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1335331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1335367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335389 */     // GIR_Coverage, 20038,
     /* 1335389 */     GIR_EraseRootFromParent_Done,
     /* 1335390 */   // Label 19068: @1335390
     /* 1335390 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1335474), // Rule ID 20039 //
     /* 1335395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1335415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335448 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1335451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335473 */     // GIR_Coverage, 20039,
     /* 1335473 */     GIR_EraseRootFromParent_Done,
     /* 1335474 */   // Label 19069: @1335474
     /* 1335474 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1335558), // Rule ID 20042 //
     /* 1335479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1335499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335532 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1335535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335557 */     // GIR_Coverage, 20042,
     /* 1335557 */     GIR_EraseRootFromParent_Done,
     /* 1335558 */   // Label 19070: @1335558
     /* 1335558 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1335642), // Rule ID 20043 //
     /* 1335563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1335583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1335619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335641 */     // GIR_Coverage, 20043,
     /* 1335641 */     GIR_EraseRootFromParent_Done,
     /* 1335642 */   // Label 19071: @1335642
     /* 1335642 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1335726), // Rule ID 20046 //
     /* 1335647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1335667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1335703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335725 */     // GIR_Coverage, 20046,
     /* 1335725 */     GIR_EraseRootFromParent_Done,
     /* 1335726 */   // Label 19072: @1335726
     /* 1335726 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1335810), // Rule ID 20047 //
     /* 1335731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1335751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1335787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335809 */     // GIR_Coverage, 20047,
     /* 1335809 */     GIR_EraseRootFromParent_Done,
     /* 1335810 */   // Label 19073: @1335810
     /* 1335810 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1335894), // Rule ID 20050 //
     /* 1335815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1335835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1335871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335893 */     // GIR_Coverage, 20050,
     /* 1335893 */     GIR_EraseRootFromParent_Done,
     /* 1335894 */   // Label 19074: @1335894
     /* 1335894 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1335978), // Rule ID 20051 //
     /* 1335899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1335919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1335955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335977 */     // GIR_Coverage, 20051,
     /* 1335977 */     GIR_EraseRootFromParent_Done,
     /* 1335978 */   // Label 19075: @1335978
     /* 1335978 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1336062), // Rule ID 20054 //
     /* 1335983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1335991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1336003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1336039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336061 */     // GIR_Coverage, 20054,
     /* 1336061 */     GIR_EraseRootFromParent_Done,
     /* 1336062 */   // Label 19076: @1336062
     /* 1336062 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1336146), // Rule ID 20055 //
     /* 1336067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1336087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1336123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336145 */     // GIR_Coverage, 20055,
     /* 1336145 */     GIR_EraseRootFromParent_Done,
     /* 1336146 */   // Label 19077: @1336146
     /* 1336146 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1336230), // Rule ID 20058 //
     /* 1336151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1336171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1336207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336229 */     // GIR_Coverage, 20058,
     /* 1336229 */     GIR_EraseRootFromParent_Done,
     /* 1336230 */   // Label 19078: @1336230
     /* 1336230 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1336314), // Rule ID 20059 //
     /* 1336235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1336255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1336291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336313 */     // GIR_Coverage, 20059,
     /* 1336313 */     GIR_EraseRootFromParent_Done,
     /* 1336314 */   // Label 19079: @1336314
     /* 1336314 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1336398), // Rule ID 20062 //
     /* 1336319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1336339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1336375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336397 */     // GIR_Coverage, 20062,
     /* 1336397 */     GIR_EraseRootFromParent_Done,
     /* 1336398 */   // Label 19080: @1336398
     /* 1336398 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1336482), // Rule ID 20063 //
     /* 1336403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1336423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1336459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336481 */     // GIR_Coverage, 20063,
     /* 1336481 */     GIR_EraseRootFromParent_Done,
     /* 1336482 */   // Label 19081: @1336482
     /* 1336482 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1336566), // Rule ID 20066 //
     /* 1336487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1336507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1336529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336540 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1336543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336565 */     // GIR_Coverage, 20066,
     /* 1336565 */     GIR_EraseRootFromParent_Done,
     /* 1336566 */   // Label 19082: @1336566
     /* 1336566 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1336650), // Rule ID 20067 //
     /* 1336571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1336591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1336613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1336627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336649 */     // GIR_Coverage, 20067,
     /* 1336649 */     GIR_EraseRootFromParent_Done,
     /* 1336650 */   // Label 19083: @1336650
     /* 1336650 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1336734), // Rule ID 20070 //
     /* 1336655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1336675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1336697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1336711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336733 */     // GIR_Coverage, 20070,
     /* 1336733 */     GIR_EraseRootFromParent_Done,
     /* 1336734 */   // Label 19084: @1336734
     /* 1336734 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1336818), // Rule ID 20071 //
     /* 1336739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1336759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1336781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1336795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336817 */     // GIR_Coverage, 20071,
     /* 1336817 */     GIR_EraseRootFromParent_Done,
     /* 1336818 */   // Label 19085: @1336818
     /* 1336818 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1336902), // Rule ID 20074 //
     /* 1336823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1336879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336901 */     // GIR_Coverage, 20074,
     /* 1336901 */     GIR_EraseRootFromParent_Done,
     /* 1336902 */   // Label 19086: @1336902
     /* 1336902 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1336986), // Rule ID 20075 //
     /* 1336907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1336927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1336949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1336963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336985 */     // GIR_Coverage, 20075,
     /* 1336985 */     GIR_EraseRootFromParent_Done,
     /* 1336986 */   // Label 19087: @1336986
     /* 1336986 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1337070), // Rule ID 20078 //
     /* 1336991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337044 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1337047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337069 */     // GIR_Coverage, 20078,
     /* 1337069 */     GIR_EraseRootFromParent_Done,
     /* 1337070 */   // Label 19088: @1337070
     /* 1337070 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1337154), // Rule ID 20079 //
     /* 1337075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337128 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1337131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337153 */     // GIR_Coverage, 20079,
     /* 1337153 */     GIR_EraseRootFromParent_Done,
     /* 1337154 */   // Label 19089: @1337154
     /* 1337154 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1337238), // Rule ID 20082 //
     /* 1337159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1337215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337237 */     // GIR_Coverage, 20082,
     /* 1337237 */     GIR_EraseRootFromParent_Done,
     /* 1337238 */   // Label 19090: @1337238
     /* 1337238 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1337322), // Rule ID 20083 //
     /* 1337243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1337299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337321 */     // GIR_Coverage, 20083,
     /* 1337321 */     GIR_EraseRootFromParent_Done,
     /* 1337322 */   // Label 19091: @1337322
     /* 1337322 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1337406), // Rule ID 20086 //
     /* 1337327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1337369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1337383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337405 */     // GIR_Coverage, 20086,
     /* 1337405 */     GIR_EraseRootFromParent_Done,
     /* 1337406 */   // Label 19092: @1337406
     /* 1337406 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1337490), // Rule ID 20087 //
     /* 1337411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1337431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1337453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337464 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1337467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337489 */     // GIR_Coverage, 20087,
     /* 1337489 */     GIR_EraseRootFromParent_Done,
     /* 1337490 */   // Label 19093: @1337490
     /* 1337490 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1337574), // Rule ID 20090 //
     /* 1337495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1337551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337573 */     // GIR_Coverage, 20090,
     /* 1337573 */     GIR_EraseRootFromParent_Done,
     /* 1337574 */   // Label 19094: @1337574
     /* 1337574 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1337658), // Rule ID 20091 //
     /* 1337579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1337635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337657 */     // GIR_Coverage, 20091,
     /* 1337657 */     GIR_EraseRootFromParent_Done,
     /* 1337658 */   // Label 19095: @1337658
     /* 1337658 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1337742), // Rule ID 20094 //
     /* 1337663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1337719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337741 */     // GIR_Coverage, 20094,
     /* 1337741 */     GIR_EraseRootFromParent_Done,
     /* 1337742 */   // Label 19096: @1337742
     /* 1337742 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1337826), // Rule ID 20095 //
     /* 1337747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1337803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337825 */     // GIR_Coverage, 20095,
     /* 1337825 */     GIR_EraseRootFromParent_Done,
     /* 1337826 */   // Label 19097: @1337826
     /* 1337826 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1337910), // Rule ID 20098 //
     /* 1337831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337884 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1337887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337909 */     // GIR_Coverage, 20098,
     /* 1337909 */     GIR_EraseRootFromParent_Done,
     /* 1337910 */   // Label 19098: @1337910
     /* 1337910 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1337994), // Rule ID 20099 //
     /* 1337915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337968 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1337971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337993 */     // GIR_Coverage, 20099,
     /* 1337993 */     GIR_EraseRootFromParent_Done,
     /* 1337994 */   // Label 19099: @1337994
     /* 1337994 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1338078), // Rule ID 20102 //
     /* 1337999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1338055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338077 */     // GIR_Coverage, 20102,
     /* 1338077 */     GIR_EraseRootFromParent_Done,
     /* 1338078 */   // Label 19100: @1338078
     /* 1338078 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1338162), // Rule ID 20103 //
     /* 1338083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1338139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338161 */     // GIR_Coverage, 20103,
     /* 1338161 */     GIR_EraseRootFromParent_Done,
     /* 1338162 */   // Label 19101: @1338162
     /* 1338162 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1338246), // Rule ID 20106 //
     /* 1338167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1338223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338245 */     // GIR_Coverage, 20106,
     /* 1338245 */     GIR_EraseRootFromParent_Done,
     /* 1338246 */   // Label 19102: @1338246
     /* 1338246 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1338330), // Rule ID 20107 //
     /* 1338251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1338307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338329 */     // GIR_Coverage, 20107,
     /* 1338329 */     GIR_EraseRootFromParent_Done,
     /* 1338330 */   // Label 19103: @1338330
     /* 1338330 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1338414), // Rule ID 20110 //
     /* 1338335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1338391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338413 */     // GIR_Coverage, 20110,
     /* 1338413 */     GIR_EraseRootFromParent_Done,
     /* 1338414 */   // Label 19104: @1338414
     /* 1338414 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1338498), // Rule ID 20111 //
     /* 1338419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1338475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338497 */     // GIR_Coverage, 20111,
     /* 1338497 */     GIR_EraseRootFromParent_Done,
     /* 1338498 */   // Label 19105: @1338498
     /* 1338498 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1338582), // Rule ID 20114 //
     /* 1338503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1338559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338581 */     // GIR_Coverage, 20114,
     /* 1338581 */     GIR_EraseRootFromParent_Done,
     /* 1338582 */   // Label 19106: @1338582
     /* 1338582 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1338666), // Rule ID 20115 //
     /* 1338587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1338643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338665 */     // GIR_Coverage, 20115,
     /* 1338665 */     GIR_EraseRootFromParent_Done,
     /* 1338666 */   // Label 19107: @1338666
     /* 1338666 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1338750), // Rule ID 20118 //
     /* 1338671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1338727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338749 */     // GIR_Coverage, 20118,
     /* 1338749 */     GIR_EraseRootFromParent_Done,
     /* 1338750 */   // Label 19108: @1338750
     /* 1338750 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1338834), // Rule ID 20119 //
     /* 1338755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1338811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338833 */     // GIR_Coverage, 20119,
     /* 1338833 */     GIR_EraseRootFromParent_Done,
     /* 1338834 */   // Label 19109: @1338834
     /* 1338834 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1338918), // Rule ID 20122 //
     /* 1338839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1338895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338917 */     // GIR_Coverage, 20122,
     /* 1338917 */     GIR_EraseRootFromParent_Done,
     /* 1338918 */   // Label 19110: @1338918
     /* 1338918 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1339002), // Rule ID 20123 //
     /* 1338923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1338979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339001 */     // GIR_Coverage, 20123,
     /* 1339001 */     GIR_EraseRootFromParent_Done,
     /* 1339002 */   // Label 19111: @1339002
     /* 1339002 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1339086), // Rule ID 20126 //
     /* 1339007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1339027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1339063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339085 */     // GIR_Coverage, 20126,
     /* 1339085 */     GIR_EraseRootFromParent_Done,
     /* 1339086 */   // Label 19112: @1339086
     /* 1339086 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1339170), // Rule ID 20127 //
     /* 1339091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1339111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1339147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339169 */     // GIR_Coverage, 20127,
     /* 1339169 */     GIR_EraseRootFromParent_Done,
     /* 1339170 */   // Label 19113: @1339170
     /* 1339170 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1339254), // Rule ID 20130 //
     /* 1339175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1339195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1339231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339253 */     // GIR_Coverage, 20130,
     /* 1339253 */     GIR_EraseRootFromParent_Done,
     /* 1339254 */   // Label 19114: @1339254
     /* 1339254 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1339338), // Rule ID 20131 //
     /* 1339259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1339279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1339315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339337 */     // GIR_Coverage, 20131,
     /* 1339337 */     GIR_EraseRootFromParent_Done,
     /* 1339338 */   // Label 19115: @1339338
     /* 1339338 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1339422), // Rule ID 20134 //
     /* 1339343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1339363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339396 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1339399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339421 */     // GIR_Coverage, 20134,
     /* 1339421 */     GIR_EraseRootFromParent_Done,
     /* 1339422 */   // Label 19116: @1339422
     /* 1339422 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1339506), // Rule ID 20135 //
     /* 1339427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1339447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1339483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339505 */     // GIR_Coverage, 20135,
     /* 1339505 */     GIR_EraseRootFromParent_Done,
     /* 1339506 */   // Label 19117: @1339506
     /* 1339506 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1339590), // Rule ID 20138 //
     /* 1339511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1339531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339564 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339589 */     // GIR_Coverage, 20138,
     /* 1339589 */     GIR_EraseRootFromParent_Done,
     /* 1339590 */   // Label 19118: @1339590
     /* 1339590 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1339674), // Rule ID 20139 //
     /* 1339595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1339615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339648 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339673 */     // GIR_Coverage, 20139,
     /* 1339673 */     GIR_EraseRootFromParent_Done,
     /* 1339674 */   // Label 19119: @1339674
     /* 1339674 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1339758), // Rule ID 20142 //
     /* 1339679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1339699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339757 */     // GIR_Coverage, 20142,
     /* 1339757 */     GIR_EraseRootFromParent_Done,
     /* 1339758 */   // Label 19120: @1339758
     /* 1339758 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1339842), // Rule ID 20143 //
     /* 1339763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1339783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339841 */     // GIR_Coverage, 20143,
     /* 1339841 */     GIR_EraseRootFromParent_Done,
     /* 1339842 */   // Label 19121: @1339842
     /* 1339842 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1339926), // Rule ID 20146 //
     /* 1339847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1339867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339925 */     // GIR_Coverage, 20146,
     /* 1339925 */     GIR_EraseRootFromParent_Done,
     /* 1339926 */   // Label 19122: @1339926
     /* 1339926 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1340010), // Rule ID 20147 //
     /* 1339931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1339951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339984 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1339987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340009 */     // GIR_Coverage, 20147,
     /* 1340009 */     GIR_EraseRootFromParent_Done,
     /* 1340010 */   // Label 19123: @1340010
     /* 1340010 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1340094), // Rule ID 20150 //
     /* 1340015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1340035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1340071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340093 */     // GIR_Coverage, 20150,
     /* 1340093 */     GIR_EraseRootFromParent_Done,
     /* 1340094 */   // Label 19124: @1340094
     /* 1340094 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1340178), // Rule ID 20151 //
     /* 1340099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1340119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1340155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340177 */     // GIR_Coverage, 20151,
     /* 1340177 */     GIR_EraseRootFromParent_Done,
     /* 1340178 */   // Label 19125: @1340178
     /* 1340178 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1340262), // Rule ID 20154 //
     /* 1340183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1340203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1340239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340261 */     // GIR_Coverage, 20154,
     /* 1340261 */     GIR_EraseRootFromParent_Done,
     /* 1340262 */   // Label 19126: @1340262
     /* 1340262 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1340346), // Rule ID 20155 //
     /* 1340267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1340287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1340323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340345 */     // GIR_Coverage, 20155,
     /* 1340345 */     GIR_EraseRootFromParent_Done,
     /* 1340346 */   // Label 19127: @1340346
     /* 1340346 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1340430), // Rule ID 20158 //
     /* 1340351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1340371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340404 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1340407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340429 */     // GIR_Coverage, 20158,
     /* 1340429 */     GIR_EraseRootFromParent_Done,
     /* 1340430 */   // Label 19128: @1340430
     /* 1340430 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1340514), // Rule ID 20159 //
     /* 1340435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1340455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1340491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340513 */     // GIR_Coverage, 20159,
     /* 1340513 */     GIR_EraseRootFromParent_Done,
     /* 1340514 */   // Label 19129: @1340514
     /* 1340514 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1340598), // Rule ID 20162 //
     /* 1340519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1340539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1340575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340597 */     // GIR_Coverage, 20162,
     /* 1340597 */     GIR_EraseRootFromParent_Done,
     /* 1340598 */   // Label 19130: @1340598
     /* 1340598 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1340682), // Rule ID 20163 //
     /* 1340603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1340623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1340659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340681 */     // GIR_Coverage, 20163,
     /* 1340681 */     GIR_EraseRootFromParent_Done,
     /* 1340682 */   // Label 19131: @1340682
     /* 1340682 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1340766), // Rule ID 20166 //
     /* 1340687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1340707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1340743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340765 */     // GIR_Coverage, 20166,
     /* 1340765 */     GIR_EraseRootFromParent_Done,
     /* 1340766 */   // Label 19132: @1340766
     /* 1340766 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1340850), // Rule ID 20167 //
     /* 1340771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1340791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1340827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340849 */     // GIR_Coverage, 20167,
     /* 1340849 */     GIR_EraseRootFromParent_Done,
     /* 1340850 */   // Label 19133: @1340850
     /* 1340850 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1340934), // Rule ID 20170 //
     /* 1340855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1340875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340908 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1340911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340933 */     // GIR_Coverage, 20170,
     /* 1340933 */     GIR_EraseRootFromParent_Done,
     /* 1340934 */   // Label 19134: @1340934
     /* 1340934 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1341018), // Rule ID 20171 //
     /* 1340939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1340947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1340959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1340995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341017 */     // GIR_Coverage, 20171,
     /* 1341017 */     GIR_EraseRootFromParent_Done,
     /* 1341018 */   // Label 19135: @1341018
     /* 1341018 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1341102), // Rule ID 20174 //
     /* 1341023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1341043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1341079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341101 */     // GIR_Coverage, 20174,
     /* 1341101 */     GIR_EraseRootFromParent_Done,
     /* 1341102 */   // Label 19136: @1341102
     /* 1341102 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1341186), // Rule ID 20175 //
     /* 1341107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1341127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1341163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341185 */     // GIR_Coverage, 20175,
     /* 1341185 */     GIR_EraseRootFromParent_Done,
     /* 1341186 */   // Label 19137: @1341186
     /* 1341186 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1341270), // Rule ID 20178 //
     /* 1341191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1341211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1341247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341269 */     // GIR_Coverage, 20178,
     /* 1341269 */     GIR_EraseRootFromParent_Done,
     /* 1341270 */   // Label 19138: @1341270
     /* 1341270 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1341354), // Rule ID 20179 //
     /* 1341275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1341295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1341331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341353 */     // GIR_Coverage, 20179,
     /* 1341353 */     GIR_EraseRootFromParent_Done,
     /* 1341354 */   // Label 19139: @1341354
     /* 1341354 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1341438), // Rule ID 20182 //
     /* 1341359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1341379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1341415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341437 */     // GIR_Coverage, 20182,
     /* 1341437 */     GIR_EraseRootFromParent_Done,
     /* 1341438 */   // Label 19140: @1341438
     /* 1341438 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1341522), // Rule ID 20183 //
     /* 1341443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1341463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1341499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341521 */     // GIR_Coverage, 20183,
     /* 1341521 */     GIR_EraseRootFromParent_Done,
     /* 1341522 */   // Label 19141: @1341522
     /* 1341522 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1341606), // Rule ID 20186 //
     /* 1341527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1341583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341605 */     // GIR_Coverage, 20186,
     /* 1341605 */     GIR_EraseRootFromParent_Done,
     /* 1341606 */   // Label 19142: @1341606
     /* 1341606 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1341690), // Rule ID 20187 //
     /* 1341611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1341667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341689 */     // GIR_Coverage, 20187,
     /* 1341689 */     GIR_EraseRootFromParent_Done,
     /* 1341690 */   // Label 19143: @1341690
     /* 1341690 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1341774), // Rule ID 20190 //
     /* 1341695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1341751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341773 */     // GIR_Coverage, 20190,
     /* 1341773 */     GIR_EraseRootFromParent_Done,
     /* 1341774 */   // Label 19144: @1341774
     /* 1341774 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1341858), // Rule ID 20191 //
     /* 1341779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1341835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341857 */     // GIR_Coverage, 20191,
     /* 1341857 */     GIR_EraseRootFromParent_Done,
     /* 1341858 */   // Label 19145: @1341858
     /* 1341858 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1341942), // Rule ID 20194 //
     /* 1341863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341916 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1341919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341941 */     // GIR_Coverage, 20194,
     /* 1341941 */     GIR_EraseRootFromParent_Done,
     /* 1341942 */   // Label 19146: @1341942
     /* 1341942 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1342026), // Rule ID 20195 //
     /* 1341947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1342003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342025 */     // GIR_Coverage, 20195,
     /* 1342025 */     GIR_EraseRootFromParent_Done,
     /* 1342026 */   // Label 19147: @1342026
     /* 1342026 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1342110), // Rule ID 20198 //
     /* 1342031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1342087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342109 */     // GIR_Coverage, 20198,
     /* 1342109 */     GIR_EraseRootFromParent_Done,
     /* 1342110 */   // Label 19148: @1342110
     /* 1342110 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1342194), // Rule ID 20199 //
     /* 1342115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342168 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1342171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342193 */     // GIR_Coverage, 20199,
     /* 1342193 */     GIR_EraseRootFromParent_Done,
     /* 1342194 */   // Label 19149: @1342194
     /* 1342194 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1342278), // Rule ID 20202 //
     /* 1342199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1342255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342277 */     // GIR_Coverage, 20202,
     /* 1342277 */     GIR_EraseRootFromParent_Done,
     /* 1342278 */   // Label 19150: @1342278
     /* 1342278 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1342362), // Rule ID 20203 //
     /* 1342283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1342339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342361 */     // GIR_Coverage, 20203,
     /* 1342361 */     GIR_EraseRootFromParent_Done,
     /* 1342362 */   // Label 19151: @1342362
     /* 1342362 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1342446), // Rule ID 20206 //
     /* 1342367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1342409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1342423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342445 */     // GIR_Coverage, 20206,
     /* 1342445 */     GIR_EraseRootFromParent_Done,
     /* 1342446 */   // Label 19152: @1342446
     /* 1342446 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1342530), // Rule ID 20207 //
     /* 1342451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1342493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1342507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342529 */     // GIR_Coverage, 20207,
     /* 1342529 */     GIR_EraseRootFromParent_Done,
     /* 1342530 */   // Label 19153: @1342530
     /* 1342530 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1342614), // Rule ID 20210 //
     /* 1342535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1342591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342613 */     // GIR_Coverage, 20210,
     /* 1342613 */     GIR_EraseRootFromParent_Done,
     /* 1342614 */   // Label 19154: @1342614
     /* 1342614 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1342698), // Rule ID 20211 //
     /* 1342619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1342675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342697 */     // GIR_Coverage, 20211,
     /* 1342697 */     GIR_EraseRootFromParent_Done,
     /* 1342698 */   // Label 19155: @1342698
     /* 1342698 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1342782), // Rule ID 20214 //
     /* 1342703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342756 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1342759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342781 */     // GIR_Coverage, 20214,
     /* 1342781 */     GIR_EraseRootFromParent_Done,
     /* 1342782 */   // Label 19156: @1342782
     /* 1342782 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1342866), // Rule ID 20215 //
     /* 1342787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1342843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342865 */     // GIR_Coverage, 20215,
     /* 1342865 */     GIR_EraseRootFromParent_Done,
     /* 1342866 */   // Label 19157: @1342866
     /* 1342866 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1342950), // Rule ID 20218 //
     /* 1342871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342924 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1342927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342949 */     // GIR_Coverage, 20218,
     /* 1342949 */     GIR_EraseRootFromParent_Done,
     /* 1342950 */   // Label 19158: @1342950
     /* 1342950 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1343034), // Rule ID 20219 //
     /* 1342955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343008 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1343011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343033 */     // GIR_Coverage, 20219,
     /* 1343033 */     GIR_EraseRootFromParent_Done,
     /* 1343034 */   // Label 19159: @1343034
     /* 1343034 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1343118), // Rule ID 20222 //
     /* 1343039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1343095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343117 */     // GIR_Coverage, 20222,
     /* 1343117 */     GIR_EraseRootFromParent_Done,
     /* 1343118 */   // Label 19160: @1343118
     /* 1343118 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1343202), // Rule ID 20223 //
     /* 1343123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1343179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343201 */     // GIR_Coverage, 20223,
     /* 1343201 */     GIR_EraseRootFromParent_Done,
     /* 1343202 */   // Label 19161: @1343202
     /* 1343202 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1343286), // Rule ID 20226 //
     /* 1343207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1343263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343285 */     // GIR_Coverage, 20226,
     /* 1343285 */     GIR_EraseRootFromParent_Done,
     /* 1343286 */   // Label 19162: @1343286
     /* 1343286 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1343370), // Rule ID 20227 //
     /* 1343291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343344 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1343347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343369 */     // GIR_Coverage, 20227,
     /* 1343369 */     GIR_EraseRootFromParent_Done,
     /* 1343370 */   // Label 19163: @1343370
     /* 1343370 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1343454), // Rule ID 20230 //
     /* 1343375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1343431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343453 */     // GIR_Coverage, 20230,
     /* 1343453 */     GIR_EraseRootFromParent_Done,
     /* 1343454 */   // Label 19164: @1343454
     /* 1343454 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1343538), // Rule ID 20231 //
     /* 1343459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343512 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1343515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343537 */     // GIR_Coverage, 20231,
     /* 1343537 */     GIR_EraseRootFromParent_Done,
     /* 1343538 */   // Label 19165: @1343538
     /* 1343538 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1343622), // Rule ID 20234 //
     /* 1343543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1343599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343621 */     // GIR_Coverage, 20234,
     /* 1343621 */     GIR_EraseRootFromParent_Done,
     /* 1343622 */   // Label 19166: @1343622
     /* 1343622 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1343706), // Rule ID 20235 //
     /* 1343627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1343683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343705 */     // GIR_Coverage, 20235,
     /* 1343705 */     GIR_EraseRootFromParent_Done,
     /* 1343706 */   // Label 19167: @1343706
     /* 1343706 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1343790), // Rule ID 20238 //
     /* 1343711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1343767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343789 */     // GIR_Coverage, 20238,
     /* 1343789 */     GIR_EraseRootFromParent_Done,
     /* 1343790 */   // Label 19168: @1343790
     /* 1343790 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1343874), // Rule ID 20239 //
     /* 1343795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1343851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343873 */     // GIR_Coverage, 20239,
     /* 1343873 */     GIR_EraseRootFromParent_Done,
     /* 1343874 */   // Label 19169: @1343874
     /* 1343874 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1343958), // Rule ID 20242 //
     /* 1343879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1343935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343957 */     // GIR_Coverage, 20242,
     /* 1343957 */     GIR_EraseRootFromParent_Done,
     /* 1343958 */   // Label 19170: @1343958
     /* 1343958 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1344042), // Rule ID 20243 //
     /* 1343963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344016 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1344019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344041 */     // GIR_Coverage, 20243,
     /* 1344041 */     GIR_EraseRootFromParent_Done,
     /* 1344042 */   // Label 19171: @1344042
     /* 1344042 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1344126), // Rule ID 20246 //
     /* 1344047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1344103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344125 */     // GIR_Coverage, 20246,
     /* 1344125 */     GIR_EraseRootFromParent_Done,
     /* 1344126 */   // Label 19172: @1344126
     /* 1344126 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1344210), // Rule ID 20247 //
     /* 1344131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1344187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344209 */     // GIR_Coverage, 20247,
     /* 1344209 */     GIR_EraseRootFromParent_Done,
     /* 1344210 */   // Label 19173: @1344210
     /* 1344210 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1344294), // Rule ID 20250 //
     /* 1344215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1344271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344293 */     // GIR_Coverage, 20250,
     /* 1344293 */     GIR_EraseRootFromParent_Done,
     /* 1344294 */   // Label 19174: @1344294
     /* 1344294 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1344378), // Rule ID 20251 //
     /* 1344299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1344355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344377 */     // GIR_Coverage, 20251,
     /* 1344377 */     GIR_EraseRootFromParent_Done,
     /* 1344378 */   // Label 19175: @1344378
     /* 1344378 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1344462), // Rule ID 20254 //
     /* 1344383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1344439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344461 */     // GIR_Coverage, 20254,
     /* 1344461 */     GIR_EraseRootFromParent_Done,
     /* 1344462 */   // Label 19176: @1344462
     /* 1344462 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1344546), // Rule ID 20255 //
     /* 1344467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1344523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344545 */     // GIR_Coverage, 20255,
     /* 1344545 */     GIR_EraseRootFromParent_Done,
     /* 1344546 */   // Label 19177: @1344546
     /* 1344546 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1344630), // Rule ID 20258 //
     /* 1344551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344604 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1344607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344629 */     // GIR_Coverage, 20258,
     /* 1344629 */     GIR_EraseRootFromParent_Done,
     /* 1344630 */   // Label 19178: @1344630
     /* 1344630 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1344714), // Rule ID 20259 //
     /* 1344635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344688 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1344691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344713 */     // GIR_Coverage, 20259,
     /* 1344713 */     GIR_EraseRootFromParent_Done,
     /* 1344714 */   // Label 19179: @1344714
     /* 1344714 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1344798), // Rule ID 20262 //
     /* 1344719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1344775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344797 */     // GIR_Coverage, 20262,
     /* 1344797 */     GIR_EraseRootFromParent_Done,
     /* 1344798 */   // Label 19180: @1344798
     /* 1344798 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1344882), // Rule ID 20263 //
     /* 1344803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1344859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344881 */     // GIR_Coverage, 20263,
     /* 1344881 */     GIR_EraseRootFromParent_Done,
     /* 1344882 */   // Label 19181: @1344882
     /* 1344882 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1344966), // Rule ID 20266 //
     /* 1344887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1344943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344965 */     // GIR_Coverage, 20266,
     /* 1344965 */     GIR_EraseRootFromParent_Done,
     /* 1344966 */   // Label 19182: @1344966
     /* 1344966 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1345050), // Rule ID 20267 //
     /* 1344971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1345027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345049 */     // GIR_Coverage, 20267,
     /* 1345049 */     GIR_EraseRootFromParent_Done,
     /* 1345050 */   // Label 19183: @1345050
     /* 1345050 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1345134), // Rule ID 20270 //
     /* 1345055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1345111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345133 */     // GIR_Coverage, 20270,
     /* 1345133 */     GIR_EraseRootFromParent_Done,
     /* 1345134 */   // Label 19184: @1345134
     /* 1345134 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1345218), // Rule ID 20271 //
     /* 1345139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1345195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345217 */     // GIR_Coverage, 20271,
     /* 1345217 */     GIR_EraseRootFromParent_Done,
     /* 1345218 */   // Label 19185: @1345218
     /* 1345218 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1345302), // Rule ID 20274 //
     /* 1345223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1345279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345301 */     // GIR_Coverage, 20274,
     /* 1345301 */     GIR_EraseRootFromParent_Done,
     /* 1345302 */   // Label 19186: @1345302
     /* 1345302 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1345386), // Rule ID 20275 //
     /* 1345307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1345363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345385 */     // GIR_Coverage, 20275,
     /* 1345385 */     GIR_EraseRootFromParent_Done,
     /* 1345386 */   // Label 19187: @1345386
     /* 1345386 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1345470), // Rule ID 20278 //
     /* 1345391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345444 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1345447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345469 */     // GIR_Coverage, 20278,
     /* 1345469 */     GIR_EraseRootFromParent_Done,
     /* 1345470 */   // Label 19188: @1345470
     /* 1345470 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1345554), // Rule ID 20279 //
     /* 1345475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345528 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1345531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345553 */     // GIR_Coverage, 20279,
     /* 1345553 */     GIR_EraseRootFromParent_Done,
     /* 1345554 */   // Label 19189: @1345554
     /* 1345554 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1345638), // Rule ID 20282 //
     /* 1345559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1345615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345637 */     // GIR_Coverage, 20282,
     /* 1345637 */     GIR_EraseRootFromParent_Done,
     /* 1345638 */   // Label 19190: @1345638
     /* 1345638 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1345722), // Rule ID 20283 //
     /* 1345643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1345699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345721 */     // GIR_Coverage, 20283,
     /* 1345721 */     GIR_EraseRootFromParent_Done,
     /* 1345722 */   // Label 19191: @1345722
     /* 1345722 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1345806), // Rule ID 20286 //
     /* 1345727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1345783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345805 */     // GIR_Coverage, 20286,
     /* 1345805 */     GIR_EraseRootFromParent_Done,
     /* 1345806 */   // Label 19192: @1345806
     /* 1345806 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1345890), // Rule ID 20287 //
     /* 1345811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1345867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345889 */     // GIR_Coverage, 20287,
     /* 1345889 */     GIR_EraseRootFromParent_Done,
     /* 1345890 */   // Label 19193: @1345890
     /* 1345890 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1345974), // Rule ID 20290 //
     /* 1345895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1345951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345973 */     // GIR_Coverage, 20290,
     /* 1345973 */     GIR_EraseRootFromParent_Done,
     /* 1345974 */   // Label 19194: @1345974
     /* 1345974 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1346058), // Rule ID 20291 //
     /* 1345979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346032 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1346035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346057 */     // GIR_Coverage, 20291,
     /* 1346057 */     GIR_EraseRootFromParent_Done,
     /* 1346058 */   // Label 19195: @1346058
     /* 1346058 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1346142), // Rule ID 20294 //
     /* 1346063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1346119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346141 */     // GIR_Coverage, 20294,
     /* 1346141 */     GIR_EraseRootFromParent_Done,
     /* 1346142 */   // Label 19196: @1346142
     /* 1346142 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1346226), // Rule ID 20295 //
     /* 1346147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1346203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346225 */     // GIR_Coverage, 20295,
     /* 1346225 */     GIR_EraseRootFromParent_Done,
     /* 1346226 */   // Label 19197: @1346226
     /* 1346226 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1346310), // Rule ID 20298 //
     /* 1346231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346284 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1346287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346309 */     // GIR_Coverage, 20298,
     /* 1346309 */     GIR_EraseRootFromParent_Done,
     /* 1346310 */   // Label 19198: @1346310
     /* 1346310 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1346394), // Rule ID 20299 //
     /* 1346315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1346371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346393 */     // GIR_Coverage, 20299,
     /* 1346393 */     GIR_EraseRootFromParent_Done,
     /* 1346394 */   // Label 19199: @1346394
     /* 1346394 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1346478), // Rule ID 20302 //
     /* 1346399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1346455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346477 */     // GIR_Coverage, 20302,
     /* 1346477 */     GIR_EraseRootFromParent_Done,
     /* 1346478 */   // Label 19200: @1346478
     /* 1346478 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1346562), // Rule ID 20303 //
     /* 1346483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346536 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1346539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346561 */     // GIR_Coverage, 20303,
     /* 1346561 */     GIR_EraseRootFromParent_Done,
     /* 1346562 */   // Label 19201: @1346562
     /* 1346562 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1346646), // Rule ID 20306 //
     /* 1346567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1346623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346645 */     // GIR_Coverage, 20306,
     /* 1346645 */     GIR_EraseRootFromParent_Done,
     /* 1346646 */   // Label 19202: @1346646
     /* 1346646 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1346730), // Rule ID 20307 //
     /* 1346651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346704 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1346707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346729 */     // GIR_Coverage, 20307,
     /* 1346729 */     GIR_EraseRootFromParent_Done,
     /* 1346730 */   // Label 19203: @1346730
     /* 1346730 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1346814), // Rule ID 20310 //
     /* 1346735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1346791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346813 */     // GIR_Coverage, 20310,
     /* 1346813 */     GIR_EraseRootFromParent_Done,
     /* 1346814 */   // Label 19204: @1346814
     /* 1346814 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1346898), // Rule ID 20311 //
     /* 1346819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1346875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346897 */     // GIR_Coverage, 20311,
     /* 1346897 */     GIR_EraseRootFromParent_Done,
     /* 1346898 */   // Label 19205: @1346898
     /* 1346898 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1346982), // Rule ID 20314 //
     /* 1346903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1346920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1346959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346981 */     // GIR_Coverage, 20314,
     /* 1346981 */     GIR_EraseRootFromParent_Done,
     /* 1346982 */   // Label 19206: @1346982
     /* 1346982 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1347066), // Rule ID 20315 //
     /* 1346987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1346995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1347043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347065 */     // GIR_Coverage, 20315,
     /* 1347065 */     GIR_EraseRootFromParent_Done,
     /* 1347066 */   // Label 19207: @1347066
     /* 1347066 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1347150), // Rule ID 20318 //
     /* 1347071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1347127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347149 */     // GIR_Coverage, 20318,
     /* 1347149 */     GIR_EraseRootFromParent_Done,
     /* 1347150 */   // Label 19208: @1347150
     /* 1347150 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1347234), // Rule ID 20319 //
     /* 1347155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1347211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347233 */     // GIR_Coverage, 20319,
     /* 1347233 */     GIR_EraseRootFromParent_Done,
     /* 1347234 */   // Label 19209: @1347234
     /* 1347234 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1347318), // Rule ID 20322 //
     /* 1347239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1347295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347317 */     // GIR_Coverage, 20322,
     /* 1347317 */     GIR_EraseRootFromParent_Done,
     /* 1347318 */   // Label 19210: @1347318
     /* 1347318 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1347402), // Rule ID 20323 //
     /* 1347323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1347379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347401 */     // GIR_Coverage, 20323,
     /* 1347401 */     GIR_EraseRootFromParent_Done,
     /* 1347402 */   // Label 19211: @1347402
     /* 1347402 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1347486), // Rule ID 20326 //
     /* 1347407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347460 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1347463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347485 */     // GIR_Coverage, 20326,
     /* 1347485 */     GIR_EraseRootFromParent_Done,
     /* 1347486 */   // Label 19212: @1347486
     /* 1347486 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1347570), // Rule ID 20327 //
     /* 1347491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1347547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347569 */     // GIR_Coverage, 20327,
     /* 1347569 */     GIR_EraseRootFromParent_Done,
     /* 1347570 */   // Label 19213: @1347570
     /* 1347570 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1347654), // Rule ID 20330 //
     /* 1347575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1347631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347653 */     // GIR_Coverage, 20330,
     /* 1347653 */     GIR_EraseRootFromParent_Done,
     /* 1347654 */   // Label 19214: @1347654
     /* 1347654 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1347738), // Rule ID 20331 //
     /* 1347659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347712 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1347715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347737 */     // GIR_Coverage, 20331,
     /* 1347737 */     GIR_EraseRootFromParent_Done,
     /* 1347738 */   // Label 19215: @1347738
     /* 1347738 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1347822), // Rule ID 20334 //
     /* 1347743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1347799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347821 */     // GIR_Coverage, 20334,
     /* 1347821 */     GIR_EraseRootFromParent_Done,
     /* 1347822 */   // Label 19216: @1347822
     /* 1347822 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1347906), // Rule ID 20335 //
     /* 1347827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1347883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347905 */     // GIR_Coverage, 20335,
     /* 1347905 */     GIR_EraseRootFromParent_Done,
     /* 1347906 */   // Label 19217: @1347906
     /* 1347906 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1347990), // Rule ID 20338 //
     /* 1347911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1347922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1347925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347964 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1347967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347989 */     // GIR_Coverage, 20338,
     /* 1347989 */     GIR_EraseRootFromParent_Done,
     /* 1347990 */   // Label 19218: @1347990
     /* 1347990 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1348074), // Rule ID 20339 //
     /* 1347995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1348051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348073 */     // GIR_Coverage, 20339,
     /* 1348073 */     GIR_EraseRootFromParent_Done,
     /* 1348074 */   // Label 19219: @1348074
     /* 1348074 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1348158), // Rule ID 20342 //
     /* 1348079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1348135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348157 */     // GIR_Coverage, 20342,
     /* 1348157 */     GIR_EraseRootFromParent_Done,
     /* 1348158 */   // Label 19220: @1348158
     /* 1348158 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1348242), // Rule ID 20343 //
     /* 1348163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1348219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348241 */     // GIR_Coverage, 20343,
     /* 1348241 */     GIR_EraseRootFromParent_Done,
     /* 1348242 */   // Label 19221: @1348242
     /* 1348242 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1348326), // Rule ID 20346 //
     /* 1348247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1348303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348325 */     // GIR_Coverage, 20346,
     /* 1348325 */     GIR_EraseRootFromParent_Done,
     /* 1348326 */   // Label 19222: @1348326
     /* 1348326 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1348410), // Rule ID 20347 //
     /* 1348331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1348387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348409 */     // GIR_Coverage, 20347,
     /* 1348409 */     GIR_EraseRootFromParent_Done,
     /* 1348410 */   // Label 19223: @1348410
     /* 1348410 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1348494), // Rule ID 20350 //
     /* 1348415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1348471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348493 */     // GIR_Coverage, 20350,
     /* 1348493 */     GIR_EraseRootFromParent_Done,
     /* 1348494 */   // Label 19224: @1348494
     /* 1348494 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1348578), // Rule ID 20351 //
     /* 1348499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1348555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348577 */     // GIR_Coverage, 20351,
     /* 1348577 */     GIR_EraseRootFromParent_Done,
     /* 1348578 */   // Label 19225: @1348578
     /* 1348578 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1348662), // Rule ID 20354 //
     /* 1348583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1348639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348661 */     // GIR_Coverage, 20354,
     /* 1348661 */     GIR_EraseRootFromParent_Done,
     /* 1348662 */   // Label 19226: @1348662
     /* 1348662 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1348746), // Rule ID 20355 //
     /* 1348667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1348723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348745 */     // GIR_Coverage, 20355,
     /* 1348745 */     GIR_EraseRootFromParent_Done,
     /* 1348746 */   // Label 19227: @1348746
     /* 1348746 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1348830), // Rule ID 20358 //
     /* 1348751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348804 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1348807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348829 */     // GIR_Coverage, 20358,
     /* 1348829 */     GIR_EraseRootFromParent_Done,
     /* 1348830 */   // Label 19228: @1348830
     /* 1348830 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1348914), // Rule ID 20359 //
     /* 1348835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1348891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348913 */     // GIR_Coverage, 20359,
     /* 1348913 */     GIR_EraseRootFromParent_Done,
     /* 1348914 */   // Label 19229: @1348914
     /* 1348914 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1348998), // Rule ID 20362 //
     /* 1348919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1348975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348997 */     // GIR_Coverage, 20362,
     /* 1348997 */     GIR_EraseRootFromParent_Done,
     /* 1348998 */   // Label 19230: @1348998
     /* 1348998 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1349082), // Rule ID 20363 //
     /* 1349003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1349059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349081 */     // GIR_Coverage, 20363,
     /* 1349081 */     GIR_EraseRootFromParent_Done,
     /* 1349082 */   // Label 19231: @1349082
     /* 1349082 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1349166), // Rule ID 20366 //
     /* 1349087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1349107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1349143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349165 */     // GIR_Coverage, 20366,
     /* 1349165 */     GIR_EraseRootFromParent_Done,
     /* 1349166 */   // Label 19232: @1349166
     /* 1349166 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1349250), // Rule ID 20367 //
     /* 1349171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1349191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349224 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1349227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349249 */     // GIR_Coverage, 20367,
     /* 1349249 */     GIR_EraseRootFromParent_Done,
     /* 1349250 */   // Label 19233: @1349250
     /* 1349250 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1349334), // Rule ID 20370 //
     /* 1349255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1349275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1349311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349333 */     // GIR_Coverage, 20370,
     /* 1349333 */     GIR_EraseRootFromParent_Done,
     /* 1349334 */   // Label 19234: @1349334
     /* 1349334 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1349418), // Rule ID 20371 //
     /* 1349339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1349359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349392 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1349395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349417 */     // GIR_Coverage, 20371,
     /* 1349417 */     GIR_EraseRootFromParent_Done,
     /* 1349418 */   // Label 19235: @1349418
     /* 1349418 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1349502), // Rule ID 20374 //
     /* 1349423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1349443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1349479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349501 */     // GIR_Coverage, 20374,
     /* 1349501 */     GIR_EraseRootFromParent_Done,
     /* 1349502 */   // Label 19236: @1349502
     /* 1349502 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1349586), // Rule ID 20375 //
     /* 1349507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1349527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1349563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349585 */     // GIR_Coverage, 20375,
     /* 1349585 */     GIR_EraseRootFromParent_Done,
     /* 1349586 */   // Label 19237: @1349586
     /* 1349586 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1349670), // Rule ID 20378 //
     /* 1349591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1349611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1349647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349669 */     // GIR_Coverage, 20378,
     /* 1349669 */     GIR_EraseRootFromParent_Done,
     /* 1349670 */   // Label 19238: @1349670
     /* 1349670 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1349754), // Rule ID 20379 //
     /* 1349675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1349695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1349731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349753 */     // GIR_Coverage, 20379,
     /* 1349753 */     GIR_EraseRootFromParent_Done,
     /* 1349754 */   // Label 19239: @1349754
     /* 1349754 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1349838), // Rule ID 20382 //
     /* 1349759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1349779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1349815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349837 */     // GIR_Coverage, 20382,
     /* 1349837 */     GIR_EraseRootFromParent_Done,
     /* 1349838 */   // Label 19240: @1349838
     /* 1349838 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1349922), // Rule ID 20383 //
     /* 1349843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1349863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349896 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1349899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349921 */     // GIR_Coverage, 20383,
     /* 1349921 */     GIR_EraseRootFromParent_Done,
     /* 1349922 */   // Label 19241: @1349922
     /* 1349922 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1350006), // Rule ID 20386 //
     /* 1349927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1349935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1349944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1349947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349980 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1349983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350005 */     // GIR_Coverage, 20386,
     /* 1350005 */     GIR_EraseRootFromParent_Done,
     /* 1350006 */   // Label 19242: @1350006
     /* 1350006 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1350090), // Rule ID 20387 //
     /* 1350011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1350022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1350025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1350028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1350031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1350067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350089 */     // GIR_Coverage, 20387,
     /* 1350089 */     GIR_EraseRootFromParent_Done,
     /* 1350090 */   // Label 19243: @1350090
     /* 1350090 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1350174), // Rule ID 20390 //
     /* 1350095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1350115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1350151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350173 */     // GIR_Coverage, 20390,
     /* 1350173 */     GIR_EraseRootFromParent_Done,
     /* 1350174 */   // Label 19244: @1350174
     /* 1350174 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1350258), // Rule ID 20391 //
     /* 1350179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1350196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1350199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1350235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350257 */     // GIR_Coverage, 20391,
     /* 1350257 */     GIR_EraseRootFromParent_Done,
     /* 1350258 */   // Label 19245: @1350258
     /* 1350258 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1350342), // Rule ID 20394 //
     /* 1350263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1350283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350316 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1350319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350341 */     // GIR_Coverage, 20394,
     /* 1350341 */     GIR_EraseRootFromParent_Done,
     /* 1350342 */   // Label 19246: @1350342
     /* 1350342 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1350426), // Rule ID 20395 //
     /* 1350347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1350367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1350403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350425 */     // GIR_Coverage, 20395,
     /* 1350425 */     GIR_EraseRootFromParent_Done,
     /* 1350426 */   // Label 19247: @1350426
     /* 1350426 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1350510), // Rule ID 20398 //
     /* 1350431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1350451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350484 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1350487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350509 */     // GIR_Coverage, 20398,
     /* 1350509 */     GIR_EraseRootFromParent_Done,
     /* 1350510 */   // Label 19248: @1350510
     /* 1350510 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1350594), // Rule ID 20399 //
     /* 1350515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1350535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350568 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1350571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350593 */     // GIR_Coverage, 20399,
     /* 1350593 */     GIR_EraseRootFromParent_Done,
     /* 1350594 */   // Label 19249: @1350594
     /* 1350594 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1350678), // Rule ID 20402 //
     /* 1350599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1350619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1350655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350677 */     // GIR_Coverage, 20402,
     /* 1350677 */     GIR_EraseRootFromParent_Done,
     /* 1350678 */   // Label 19250: @1350678
     /* 1350678 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1350762), // Rule ID 20403 //
     /* 1350683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1350703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1350739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350761 */     // GIR_Coverage, 20403,
     /* 1350761 */     GIR_EraseRootFromParent_Done,
     /* 1350762 */   // Label 19251: @1350762
     /* 1350762 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1350846), // Rule ID 20406 //
     /* 1350767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1350787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1350823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350845 */     // GIR_Coverage, 20406,
     /* 1350845 */     GIR_EraseRootFromParent_Done,
     /* 1350846 */   // Label 19252: @1350846
     /* 1350846 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1350930), // Rule ID 20407 //
     /* 1350851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1350871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1350907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350929 */     // GIR_Coverage, 20407,
     /* 1350929 */     GIR_EraseRootFromParent_Done,
     /* 1350930 */   // Label 19253: @1350930
     /* 1350930 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1351014), // Rule ID 20410 //
     /* 1350935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1350943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1350952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1350955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350988 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1350991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1350997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1350999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351013 */     // GIR_Coverage, 20410,
     /* 1351013 */     GIR_EraseRootFromParent_Done,
     /* 1351014 */   // Label 19254: @1351014
     /* 1351014 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1351098), // Rule ID 20411 //
     /* 1351019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1351030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1351033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1351036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1351039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1351042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1351075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351097 */     // GIR_Coverage, 20411,
     /* 1351097 */     GIR_EraseRootFromParent_Done,
     /* 1351098 */   // Label 19255: @1351098
     /* 1351098 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1351182), // Rule ID 20414 //
     /* 1351103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1351123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1351159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351181 */     // GIR_Coverage, 20414,
     /* 1351181 */     GIR_EraseRootFromParent_Done,
     /* 1351182 */   // Label 19256: @1351182
     /* 1351182 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1351266), // Rule ID 20415 //
     /* 1351187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1351204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1351207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351240 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1351243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351265 */     // GIR_Coverage, 20415,
     /* 1351265 */     GIR_EraseRootFromParent_Done,
     /* 1351266 */   // Label 19257: @1351266
     /* 1351266 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1351350), // Rule ID 20418 //
     /* 1351271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1351291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1351327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351349 */     // GIR_Coverage, 20418,
     /* 1351349 */     GIR_EraseRootFromParent_Done,
     /* 1351350 */   // Label 19258: @1351350
     /* 1351350 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1351434), // Rule ID 20419 //
     /* 1351355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1351375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1351411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351433 */     // GIR_Coverage, 20419,
     /* 1351433 */     GIR_EraseRootFromParent_Done,
     /* 1351434 */   // Label 19259: @1351434
     /* 1351434 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1351518), // Rule ID 20422 //
     /* 1351439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1351459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351492 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1351495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351517 */     // GIR_Coverage, 20422,
     /* 1351517 */     GIR_EraseRootFromParent_Done,
     /* 1351518 */   // Label 19260: @1351518
     /* 1351518 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1351602), // Rule ID 20423 //
     /* 1351523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1351543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1351579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351601 */     // GIR_Coverage, 20423,
     /* 1351601 */     GIR_EraseRootFromParent_Done,
     /* 1351602 */   // Label 19261: @1351602
     /* 1351602 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1351686), // Rule ID 20426 //
     /* 1351607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1351663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351685 */     // GIR_Coverage, 20426,
     /* 1351685 */     GIR_EraseRootFromParent_Done,
     /* 1351686 */   // Label 19262: @1351686
     /* 1351686 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1351770), // Rule ID 20427 //
     /* 1351691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1351747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351769 */     // GIR_Coverage, 20427,
     /* 1351769 */     GIR_EraseRootFromParent_Done,
     /* 1351770 */   // Label 19263: @1351770
     /* 1351770 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1351854), // Rule ID 20430 //
     /* 1351775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1351831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351853 */     // GIR_Coverage, 20430,
     /* 1351853 */     GIR_EraseRootFromParent_Done,
     /* 1351854 */   // Label 19264: @1351854
     /* 1351854 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1351938), // Rule ID 20431 //
     /* 1351859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1351915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351937 */     // GIR_Coverage, 20431,
     /* 1351937 */     GIR_EraseRootFromParent_Done,
     /* 1351938 */   // Label 19265: @1351938
     /* 1351938 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1352022), // Rule ID 20434 //
     /* 1351943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1351960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1351963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351996 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1351999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352021 */     // GIR_Coverage, 20434,
     /* 1352021 */     GIR_EraseRootFromParent_Done,
     /* 1352022 */   // Label 19266: @1352022
     /* 1352022 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1352106), // Rule ID 20435 //
     /* 1352027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1352044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1352047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1352083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352105 */     // GIR_Coverage, 20435,
     /* 1352105 */     GIR_EraseRootFromParent_Done,
     /* 1352106 */   // Label 19267: @1352106
     /* 1352106 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1352190), // Rule ID 20438 //
     /* 1352111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352189 */     // GIR_Coverage, 20438,
     /* 1352189 */     GIR_EraseRootFromParent_Done,
     /* 1352190 */   // Label 19268: @1352190
     /* 1352190 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1352274), // Rule ID 20439 //
     /* 1352195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1352212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1352215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352273 */     // GIR_Coverage, 20439,
     /* 1352273 */     GIR_EraseRootFromParent_Done,
     /* 1352274 */   // Label 19269: @1352274
     /* 1352274 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1352358), // Rule ID 20442 //
     /* 1352279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352332 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352357 */     // GIR_Coverage, 20442,
     /* 1352357 */     GIR_EraseRootFromParent_Done,
     /* 1352358 */   // Label 19270: @1352358
     /* 1352358 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1352442), // Rule ID 20443 //
     /* 1352363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352416 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352441 */     // GIR_Coverage, 20443,
     /* 1352441 */     GIR_EraseRootFromParent_Done,
     /* 1352442 */   // Label 19271: @1352442
     /* 1352442 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1352526), // Rule ID 20446 //
     /* 1352447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352525 */     // GIR_Coverage, 20446,
     /* 1352525 */     GIR_EraseRootFromParent_Done,
     /* 1352526 */   // Label 19272: @1352526
     /* 1352526 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1352610), // Rule ID 20447 //
     /* 1352531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1352587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352609 */     // GIR_Coverage, 20447,
     /* 1352609 */     GIR_EraseRootFromParent_Done,
     /* 1352610 */   // Label 19273: @1352610
     /* 1352610 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1352694), // Rule ID 20450 //
     /* 1352615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352668 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1352671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352693 */     // GIR_Coverage, 20450,
     /* 1352693 */     GIR_EraseRootFromParent_Done,
     /* 1352694 */   // Label 19274: @1352694
     /* 1352694 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1352778), // Rule ID 20451 //
     /* 1352699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1352755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352777 */     // GIR_Coverage, 20451,
     /* 1352777 */     GIR_EraseRootFromParent_Done,
     /* 1352778 */   // Label 19275: @1352778
     /* 1352778 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1352862), // Rule ID 20454 //
     /* 1352783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352836 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1352839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352861 */     // GIR_Coverage, 20454,
     /* 1352861 */     GIR_EraseRootFromParent_Done,
     /* 1352862 */   // Label 19276: @1352862
     /* 1352862 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1352946), // Rule ID 20455 //
     /* 1352867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1352923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352945 */     // GIR_Coverage, 20455,
     /* 1352945 */     GIR_EraseRootFromParent_Done,
     /* 1352946 */   // Label 19277: @1352946
     /* 1352946 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1353030), // Rule ID 20458 //
     /* 1352951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1352959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1352962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1352965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353004 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1353007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353029 */     // GIR_Coverage, 20458,
     /* 1353029 */     GIR_EraseRootFromParent_Done,
     /* 1353030 */   // Label 19278: @1353030
     /* 1353030 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1353114), // Rule ID 20459 //
     /* 1353035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1353046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1353049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1353052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1353055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1353058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353088 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1353091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353113 */     // GIR_Coverage, 20459,
     /* 1353113 */     GIR_EraseRootFromParent_Done,
     /* 1353114 */   // Label 19279: @1353114
     /* 1353114 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1353198), // Rule ID 20462 //
     /* 1353119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1353175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353197 */     // GIR_Coverage, 20462,
     /* 1353197 */     GIR_EraseRootFromParent_Done,
     /* 1353198 */   // Label 19280: @1353198
     /* 1353198 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1353282), // Rule ID 20463 //
     /* 1353203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1353220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1353223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1353259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353281 */     // GIR_Coverage, 20463,
     /* 1353281 */     GIR_EraseRootFromParent_Done,
     /* 1353282 */   // Label 19281: @1353282
     /* 1353282 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1353366), // Rule ID 20466 //
     /* 1353287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1353343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353365 */     // GIR_Coverage, 20466,
     /* 1353365 */     GIR_EraseRootFromParent_Done,
     /* 1353366 */   // Label 19282: @1353366
     /* 1353366 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1353450), // Rule ID 20467 //
     /* 1353371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353424 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1353427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353449 */     // GIR_Coverage, 20467,
     /* 1353449 */     GIR_EraseRootFromParent_Done,
     /* 1353450 */   // Label 19283: @1353450
     /* 1353450 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1353534), // Rule ID 20470 //
     /* 1353455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353508 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1353511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353533 */     // GIR_Coverage, 20470,
     /* 1353533 */     GIR_EraseRootFromParent_Done,
     /* 1353534 */   // Label 19284: @1353534
     /* 1353534 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1353618), // Rule ID 20471 //
     /* 1353539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353592 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1353595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353617 */     // GIR_Coverage, 20471,
     /* 1353617 */     GIR_EraseRootFromParent_Done,
     /* 1353618 */   // Label 19285: @1353618
     /* 1353618 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1353702), // Rule ID 20474 //
     /* 1353623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353676 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1353679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353701 */     // GIR_Coverage, 20474,
     /* 1353701 */     GIR_EraseRootFromParent_Done,
     /* 1353702 */   // Label 19286: @1353702
     /* 1353702 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1353786), // Rule ID 20475 //
     /* 1353707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1353763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353785 */     // GIR_Coverage, 20475,
     /* 1353785 */     GIR_EraseRootFromParent_Done,
     /* 1353786 */   // Label 19287: @1353786
     /* 1353786 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1353870), // Rule ID 20478 //
     /* 1353791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1353847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353869 */     // GIR_Coverage, 20478,
     /* 1353869 */     GIR_EraseRootFromParent_Done,
     /* 1353870 */   // Label 19288: @1353870
     /* 1353870 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1353954), // Rule ID 20479 //
     /* 1353875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1353931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353953 */     // GIR_Coverage, 20479,
     /* 1353953 */     GIR_EraseRootFromParent_Done,
     /* 1353954 */   // Label 19289: @1353954
     /* 1353954 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1354038), // Rule ID 20482 //
     /* 1353959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1353976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1353979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1354015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354037 */     // GIR_Coverage, 20482,
     /* 1354037 */     GIR_EraseRootFromParent_Done,
     /* 1354038 */   // Label 19290: @1354038
     /* 1354038 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1354122), // Rule ID 20483 //
     /* 1354043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1354099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354121 */     // GIR_Coverage, 20483,
     /* 1354121 */     GIR_EraseRootFromParent_Done,
     /* 1354122 */   // Label 19291: @1354122
     /* 1354122 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1354203), // Rule ID 20540 //
     /* 1354127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1354130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1354138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1354141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354180 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1354180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1354183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354202 */     // GIR_Coverage, 20540,
     /* 1354202 */     GIR_EraseRootFromParent_Done,
     /* 1354203 */   // Label 19292: @1354203
     /* 1354203 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1354284), // Rule ID 20541 //
     /* 1354208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1354211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1354219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1354222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1354228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354261 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1354261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1354264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354283 */     // GIR_Coverage, 20541,
     /* 1354283 */     GIR_EraseRootFromParent_Done,
     /* 1354284 */   // Label 19293: @1354284
     /* 1354284 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1354365), // Rule ID 20542 //
     /* 1354289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1354300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1354303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354342 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1354342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1354345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354364 */     // GIR_Coverage, 20542,
     /* 1354364 */     GIR_EraseRootFromParent_Done,
     /* 1354365 */   // Label 19294: @1354365
     /* 1354365 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1354446), // Rule ID 20543 //
     /* 1354370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1354381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1354384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354423 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1354423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1354426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354445 */     // GIR_Coverage, 20543,
     /* 1354445 */     GIR_EraseRootFromParent_Done,
     /* 1354446 */   // Label 19295: @1354446
     /* 1354446 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1354527), // Rule ID 20544 //
     /* 1354451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1354454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1354462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1354465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354504 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1354504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1354507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354526 */     // GIR_Coverage, 20544,
     /* 1354526 */     GIR_EraseRootFromParent_Done,
     /* 1354527 */   // Label 19296: @1354527
     /* 1354527 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1354608), // Rule ID 20545 //
     /* 1354532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1354535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1354543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1354546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354585 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1354585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1354588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354607 */     // GIR_Coverage, 20545,
     /* 1354607 */     GIR_EraseRootFromParent_Done,
     /* 1354608 */   // Label 19297: @1354608
     /* 1354608 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1354689), // Rule ID 20546 //
     /* 1354613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1354624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1354627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354666 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1354666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1354669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354688 */     // GIR_Coverage, 20546,
     /* 1354688 */     GIR_EraseRootFromParent_Done,
     /* 1354689 */   // Label 19298: @1354689
     /* 1354689 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1354770), // Rule ID 20547 //
     /* 1354694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1354705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1354708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1354714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1354736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354747 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1354747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1354750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354769 */     // GIR_Coverage, 20547,
     /* 1354769 */     GIR_EraseRootFromParent_Done,
     /* 1354770 */   // Label 19299: @1354770
     /* 1354770 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1354851), // Rule ID 20548 //
     /* 1354775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1354786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1354789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354828 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1354828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1354831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354850 */     // GIR_Coverage, 20548,
     /* 1354850 */     GIR_EraseRootFromParent_Done,
     /* 1354851 */   // Label 19300: @1354851
     /* 1354851 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1354932), // Rule ID 20549 //
     /* 1354856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1354867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1354870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354909 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1354909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1354912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354931 */     // GIR_Coverage, 20549,
     /* 1354931 */     GIR_EraseRootFromParent_Done,
     /* 1354932 */   // Label 19301: @1354932
     /* 1354932 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1355013), // Rule ID 20550 //
     /* 1354937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1354948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1354951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1354957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1354979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354990 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1354990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1354993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355012 */     // GIR_Coverage, 20550,
     /* 1355012 */     GIR_EraseRootFromParent_Done,
     /* 1355013 */   // Label 19302: @1355013
     /* 1355013 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1355094), // Rule ID 20551 //
     /* 1355018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1355029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1355032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1355035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1355060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355071 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1355071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1355074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355093 */     // GIR_Coverage, 20551,
     /* 1355093 */     GIR_EraseRootFromParent_Done,
     /* 1355094 */   // Label 19303: @1355094
     /* 1355094 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1355175), // Rule ID 20552 //
     /* 1355099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1355102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355152 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1355152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355174 */     // GIR_Coverage, 20552,
     /* 1355174 */     GIR_EraseRootFromParent_Done,
     /* 1355175 */   // Label 19304: @1355175
     /* 1355175 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1355256), // Rule ID 20553 //
     /* 1355180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1355183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355233 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1355233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355255 */     // GIR_Coverage, 20553,
     /* 1355255 */     GIR_EraseRootFromParent_Done,
     /* 1355256 */   // Label 19305: @1355256
     /* 1355256 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1355337), // Rule ID 20554 //
     /* 1355261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1355281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1355303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1355314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1355317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355336 */     // GIR_Coverage, 20554,
     /* 1355336 */     GIR_EraseRootFromParent_Done,
     /* 1355337 */   // Label 19306: @1355337
     /* 1355337 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1355418), // Rule ID 20555 //
     /* 1355342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1355362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1355384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355395 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1355395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1355398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355417 */     // GIR_Coverage, 20555,
     /* 1355417 */     GIR_EraseRootFromParent_Done,
     /* 1355418 */   // Label 19307: @1355418
     /* 1355418 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1355499), // Rule ID 20556 //
     /* 1355423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1355476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355498 */     // GIR_Coverage, 20556,
     /* 1355498 */     GIR_EraseRootFromParent_Done,
     /* 1355499 */   // Label 19308: @1355499
     /* 1355499 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1355580), // Rule ID 20557 //
     /* 1355504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355557 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1355557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355579 */     // GIR_Coverage, 20557,
     /* 1355579 */     GIR_EraseRootFromParent_Done,
     /* 1355580 */   // Label 19309: @1355580
     /* 1355580 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1355661), // Rule ID 20558 //
     /* 1355585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1355627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355638 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1355638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1355641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355660 */     // GIR_Coverage, 20558,
     /* 1355660 */     GIR_EraseRootFromParent_Done,
     /* 1355661 */   // Label 19310: @1355661
     /* 1355661 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1355742), // Rule ID 20559 //
     /* 1355666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1355686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1355708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355719 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1355719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1355722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355741 */     // GIR_Coverage, 20559,
     /* 1355741 */     GIR_EraseRootFromParent_Done,
     /* 1355742 */   // Label 19311: @1355742
     /* 1355742 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1355823), // Rule ID 20560 //
     /* 1355747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1355758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1355761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1355800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355822 */     // GIR_Coverage, 20560,
     /* 1355822 */     GIR_EraseRootFromParent_Done,
     /* 1355823 */   // Label 19312: @1355823
     /* 1355823 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1355904), // Rule ID 20561 //
     /* 1355828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1355836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1355839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1355842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355881 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1355881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1355884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355903 */     // GIR_Coverage, 20561,
     /* 1355903 */     GIR_EraseRootFromParent_Done,
     /* 1355904 */   // Label 19313: @1355904
     /* 1355904 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1355985), // Rule ID 20562 //
     /* 1355909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1355920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1355923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1355929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1355951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355962 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1355962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1355965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355984 */     // GIR_Coverage, 20562,
     /* 1355984 */     GIR_EraseRootFromParent_Done,
     /* 1355985 */   // Label 19314: @1355985
     /* 1355985 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1356066), // Rule ID 20563 //
     /* 1355990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1355998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1356001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1356004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1356007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1356010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1356032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356043 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1356043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1356046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356065 */     // GIR_Coverage, 20563,
     /* 1356065 */     GIR_EraseRootFromParent_Done,
     /* 1356066 */   // Label 19315: @1356066
     /* 1356066 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1356147), // Rule ID 20564 //
     /* 1356071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1356082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1356085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1356091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1356127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356146 */     // GIR_Coverage, 20564,
     /* 1356146 */     GIR_EraseRootFromParent_Done,
     /* 1356147 */   // Label 19316: @1356147
     /* 1356147 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1356228), // Rule ID 20565 //
     /* 1356152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1356163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1356166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1356172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1356208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356227 */     // GIR_Coverage, 20565,
     /* 1356227 */     GIR_EraseRootFromParent_Done,
     /* 1356228 */   // Label 19317: @1356228
     /* 1356228 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1356309), // Rule ID 20566 //
     /* 1356233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1356244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1356247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1356289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356308 */     // GIR_Coverage, 20566,
     /* 1356308 */     GIR_EraseRootFromParent_Done,
     /* 1356309 */   // Label 19318: @1356309
     /* 1356309 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1356390), // Rule ID 20567 //
     /* 1356314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1356325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1356328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1356344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356367 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1356370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356389 */     // GIR_Coverage, 20567,
     /* 1356389 */     GIR_EraseRootFromParent_Done,
     /* 1356390 */   // Label 19319: @1356390
     /* 1356390 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1356471), // Rule ID 20568 //
     /* 1356395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1356406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1356409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1356415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356448 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1356451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356470 */     // GIR_Coverage, 20568,
     /* 1356470 */     GIR_EraseRootFromParent_Done,
     /* 1356471 */   // Label 19320: @1356471
     /* 1356471 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1356552), // Rule ID 20569 //
     /* 1356476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1356487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1356490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1356496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356529 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1356532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356551 */     // GIR_Coverage, 20569,
     /* 1356551 */     GIR_EraseRootFromParent_Done,
     /* 1356552 */   // Label 19321: @1356552
     /* 1356552 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1356633), // Rule ID 20570 //
     /* 1356557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1356568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1356571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1356613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356632 */     // GIR_Coverage, 20570,
     /* 1356632 */     GIR_EraseRootFromParent_Done,
     /* 1356633 */   // Label 19322: @1356633
     /* 1356633 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1356714), // Rule ID 20571 //
     /* 1356638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1356649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1356652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1356668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356691 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1356694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356713 */     // GIR_Coverage, 20571,
     /* 1356713 */     GIR_EraseRootFromParent_Done,
     /* 1356714 */   // Label 19323: @1356714
     /* 1356714 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1356795), // Rule ID 20572 //
     /* 1356719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1356730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1356733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1356739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356772 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1356775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356794 */     // GIR_Coverage, 20572,
     /* 1356794 */     GIR_EraseRootFromParent_Done,
     /* 1356795 */   // Label 19324: @1356795
     /* 1356795 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1356876), // Rule ID 20573 //
     /* 1356800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1356811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1356814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1356820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356853 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1356856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356875 */     // GIR_Coverage, 20573,
     /* 1356875 */     GIR_EraseRootFromParent_Done,
     /* 1356876 */   // Label 19325: @1356876
     /* 1356876 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1356957), // Rule ID 20574 //
     /* 1356881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1356892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1356895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356934 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1356937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356956 */     // GIR_Coverage, 20574,
     /* 1356956 */     GIR_EraseRootFromParent_Done,
     /* 1356957 */   // Label 19326: @1356957
     /* 1356957 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1357038), // Rule ID 20575 //
     /* 1356962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1356973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1356976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1356979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1356992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357015 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1357018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357037 */     // GIR_Coverage, 20575,
     /* 1357037 */     GIR_EraseRootFromParent_Done,
     /* 1357038 */   // Label 19327: @1357038
     /* 1357038 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1357119), // Rule ID 20576 //
     /* 1357043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1357054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1357057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1357063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1357073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1357099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357118 */     // GIR_Coverage, 20576,
     /* 1357118 */     GIR_EraseRootFromParent_Done,
     /* 1357119 */   // Label 19328: @1357119
     /* 1357119 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1357200), // Rule ID 20577 //
     /* 1357124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1357135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1357138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1357144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1357154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357177 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1357180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357199 */     // GIR_Coverage, 20577,
     /* 1357199 */     GIR_EraseRootFromParent_Done,
     /* 1357200 */   // Label 19329: @1357200
     /* 1357200 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1357281), // Rule ID 20578 //
     /* 1357205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1357216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1357219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1357235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357258 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1357261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357280 */     // GIR_Coverage, 20578,
     /* 1357280 */     GIR_EraseRootFromParent_Done,
     /* 1357281 */   // Label 19330: @1357281
     /* 1357281 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1357362), // Rule ID 20579 //
     /* 1357286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1357297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1357300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1357316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1357342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357361 */     // GIR_Coverage, 20579,
     /* 1357361 */     GIR_EraseRootFromParent_Done,
     /* 1357362 */   // Label 19331: @1357362
     /* 1357362 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1357443), // Rule ID 20580 //
     /* 1357367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1357378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1357381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1357387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1357397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357420 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1357423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357442 */     // GIR_Coverage, 20580,
     /* 1357442 */     GIR_EraseRootFromParent_Done,
     /* 1357443 */   // Label 19332: @1357443
     /* 1357443 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1357524), // Rule ID 20581 //
     /* 1357448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1357459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1357462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1357468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1357478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357501 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1357504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357523 */     // GIR_Coverage, 20581,
     /* 1357523 */     GIR_EraseRootFromParent_Done,
     /* 1357524 */   // Label 19333: @1357524
     /* 1357524 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1357605), // Rule ID 20582 //
     /* 1357529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1357540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1357543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1357559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1357585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357604 */     // GIR_Coverage, 20582,
     /* 1357604 */     GIR_EraseRootFromParent_Done,
     /* 1357605 */   // Label 19334: @1357605
     /* 1357605 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1357686), // Rule ID 20583 //
     /* 1357610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1357621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1357624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1357640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357663 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1357666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357685 */     // GIR_Coverage, 20583,
     /* 1357685 */     GIR_EraseRootFromParent_Done,
     /* 1357686 */   // Label 19335: @1357686
     /* 1357686 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1357767), // Rule ID 20584 //
     /* 1357691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1357702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1357705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1357711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1357747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357766 */     // GIR_Coverage, 20584,
     /* 1357766 */     GIR_EraseRootFromParent_Done,
     /* 1357767 */   // Label 19336: @1357767
     /* 1357767 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1357848), // Rule ID 20585 //
     /* 1357772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1357783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1357786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1357792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357825 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1357828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357847 */     // GIR_Coverage, 20585,
     /* 1357847 */     GIR_EraseRootFromParent_Done,
     /* 1357848 */   // Label 19337: @1357848
     /* 1357848 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1357929), // Rule ID 20586 //
     /* 1357853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1357864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1357867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357906 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1357909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357928 */     // GIR_Coverage, 20586,
     /* 1357928 */     GIR_EraseRootFromParent_Done,
     /* 1357929 */   // Label 19338: @1357929
     /* 1357929 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1358010), // Rule ID 20587 //
     /* 1357934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1357945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1357948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1357964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357987 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1357990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1358008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358009 */     // GIR_Coverage, 20587,
     /* 1358009 */     GIR_EraseRootFromParent_Done,
     /* 1358010 */   // Label 19339: @1358010
     /* 1358010 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1358091), // Rule ID 20588 //
     /* 1358015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1358026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1358029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1358032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1358035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358090 */     // GIR_Coverage, 20588,
     /* 1358090 */     GIR_EraseRootFromParent_Done,
     /* 1358091 */   // Label 19340: @1358091
     /* 1358091 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1358172), // Rule ID 20589 //
     /* 1358096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1358107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1358110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1358113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1358116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358149 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11358:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358171 */     // GIR_Coverage, 20589,
     /* 1358171 */     GIR_EraseRootFromParent_Done,
     /* 1358172 */   // Label 19341: @1358172
     /* 1358172 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1358253), // Rule ID 20590 //
     /* 1358177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1358188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1358191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1358194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358230 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1358233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358252 */     // GIR_Coverage, 20590,
     /* 1358252 */     GIR_EraseRootFromParent_Done,
     /* 1358253 */   // Label 19342: @1358253
     /* 1358253 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1358334), // Rule ID 20591 //
     /* 1358258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1358269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1358272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1358275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1358314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358333 */     // GIR_Coverage, 20591,
     /* 1358333 */     GIR_EraseRootFromParent_Done,
     /* 1358334 */   // Label 19343: @1358334
     /* 1358334 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1358415), // Rule ID 20592 //
     /* 1358339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1358350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1358353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1358356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1358359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358392 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358414 */     // GIR_Coverage, 20592,
     /* 1358414 */     GIR_EraseRootFromParent_Done,
     /* 1358415 */   // Label 19344: @1358415
     /* 1358415 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1358496), // Rule ID 20593 //
     /* 1358420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1358431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1358434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1358437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1358440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358473 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11358:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358495 */     // GIR_Coverage, 20593,
     /* 1358495 */     GIR_EraseRootFromParent_Done,
     /* 1358496 */   // Label 19345: @1358496
     /* 1358496 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1358577), // Rule ID 20594 //
     /* 1358501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1358512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1358515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1358518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358554 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1358557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358576 */     // GIR_Coverage, 20594,
     /* 1358576 */     GIR_EraseRootFromParent_Done,
     /* 1358577 */   // Label 19346: @1358577
     /* 1358577 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1358658), // Rule ID 20595 //
     /* 1358582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1358593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1358596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1358599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358635 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1358638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358657 */     // GIR_Coverage, 20595,
     /* 1358657 */     GIR_EraseRootFromParent_Done,
     /* 1358658 */   // Label 19347: @1358658
     /* 1358658 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1358739), // Rule ID 20596 //
     /* 1358663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1358674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1358677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1358683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358716 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1358719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358738 */     // GIR_Coverage, 20596,
     /* 1358738 */     GIR_EraseRootFromParent_Done,
     /* 1358739 */   // Label 19348: @1358739
     /* 1358739 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1358820), // Rule ID 20597 //
     /* 1358744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1358755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1358758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1358764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358797 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11358:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1358800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358819 */     // GIR_Coverage, 20597,
     /* 1358819 */     GIR_EraseRootFromParent_Done,
     /* 1358820 */   // Label 19349: @1358820
     /* 1358820 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1358901), // Rule ID 20598 //
     /* 1358825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1358836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1358839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358878 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1358881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358900 */     // GIR_Coverage, 20598,
     /* 1358900 */     GIR_EraseRootFromParent_Done,
     /* 1358901 */   // Label 19350: @1358901
     /* 1358901 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1358982), // Rule ID 20599 //
     /* 1358906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1358917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1358920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358959 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1358962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358981 */     // GIR_Coverage, 20599,
     /* 1358981 */     GIR_EraseRootFromParent_Done,
     /* 1358982 */   // Label 19351: @1358982
     /* 1358982 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1359066), // Rule ID 21980 //
     /* 1358987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1358995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1359004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1359043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359065 */     // GIR_Coverage, 21980,
     /* 1359065 */     GIR_EraseRootFromParent_Done,
     /* 1359066 */   // Label 19352: @1359066
     /* 1359066 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1359150), // Rule ID 21981 //
     /* 1359071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1359088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1359127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359149 */     // GIR_Coverage, 21981,
     /* 1359149 */     GIR_EraseRootFromParent_Done,
     /* 1359150 */   // Label 19353: @1359150
     /* 1359150 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1359234), // Rule ID 21984 //
     /* 1359155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1359172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1359211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359233 */     // GIR_Coverage, 21984,
     /* 1359233 */     GIR_EraseRootFromParent_Done,
     /* 1359234 */   // Label 19354: @1359234
     /* 1359234 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1359318), // Rule ID 21985 //
     /* 1359239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1359256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359292 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1359295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359317 */     // GIR_Coverage, 21985,
     /* 1359317 */     GIR_EraseRootFromParent_Done,
     /* 1359318 */   // Label 19355: @1359318
     /* 1359318 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1359402), // Rule ID 21988 //
     /* 1359323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1359340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1359379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359401 */     // GIR_Coverage, 21988,
     /* 1359401 */     GIR_EraseRootFromParent_Done,
     /* 1359402 */   // Label 19356: @1359402
     /* 1359402 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1359486), // Rule ID 21989 //
     /* 1359407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1359424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1359463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359485 */     // GIR_Coverage, 21989,
     /* 1359485 */     GIR_EraseRootFromParent_Done,
     /* 1359486 */   // Label 19357: @1359486
     /* 1359486 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1359570), // Rule ID 21992 //
     /* 1359491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1359508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1359547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359569 */     // GIR_Coverage, 21992,
     /* 1359569 */     GIR_EraseRootFromParent_Done,
     /* 1359570 */   // Label 19358: @1359570
     /* 1359570 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1359654), // Rule ID 21993 //
     /* 1359575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1359592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1359631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359653 */     // GIR_Coverage, 21993,
     /* 1359653 */     GIR_EraseRootFromParent_Done,
     /* 1359654 */   // Label 19359: @1359654
     /* 1359654 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1359738), // Rule ID 21996 //
     /* 1359659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1359676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1359715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359737 */     // GIR_Coverage, 21996,
     /* 1359737 */     GIR_EraseRootFromParent_Done,
     /* 1359738 */   // Label 19360: @1359738
     /* 1359738 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1359822), // Rule ID 21997 //
     /* 1359743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1359760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1359799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359821 */     // GIR_Coverage, 21997,
     /* 1359821 */     GIR_EraseRootFromParent_Done,
     /* 1359822 */   // Label 19361: @1359822
     /* 1359822 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1359906), // Rule ID 22000 //
     /* 1359827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1359844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1359883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359905 */     // GIR_Coverage, 22000,
     /* 1359905 */     GIR_EraseRootFromParent_Done,
     /* 1359906 */   // Label 19362: @1359906
     /* 1359906 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1359990), // Rule ID 22001 //
     /* 1359911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1359919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1359928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1359967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359989 */     // GIR_Coverage, 22001,
     /* 1359989 */     GIR_EraseRootFromParent_Done,
     /* 1359990 */   // Label 19363: @1359990
     /* 1359990 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1360074), // Rule ID 22004 //
     /* 1359995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1360012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1360051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360073 */     // GIR_Coverage, 22004,
     /* 1360073 */     GIR_EraseRootFromParent_Done,
     /* 1360074 */   // Label 19364: @1360074
     /* 1360074 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1360158), // Rule ID 22005 //
     /* 1360079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1360096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1360135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360157 */     // GIR_Coverage, 22005,
     /* 1360157 */     GIR_EraseRootFromParent_Done,
     /* 1360158 */   // Label 19365: @1360158
     /* 1360158 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1360242), // Rule ID 22008 //
     /* 1360163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1360174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1360177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1360180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1360183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1360219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360241 */     // GIR_Coverage, 22008,
     /* 1360241 */     GIR_EraseRootFromParent_Done,
     /* 1360242 */   // Label 19366: @1360242
     /* 1360242 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1360326), // Rule ID 22009 //
     /* 1360247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1360258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1360261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1360264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1360267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1360303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360325 */     // GIR_Coverage, 22009,
     /* 1360325 */     GIR_EraseRootFromParent_Done,
     /* 1360326 */   // Label 19367: @1360326
     /* 1360326 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1360410), // Rule ID 22012 //
     /* 1360331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1360334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1360342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1360345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1360348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1360351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1360387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360409 */     // GIR_Coverage, 22012,
     /* 1360409 */     GIR_EraseRootFromParent_Done,
     /* 1360410 */   // Label 19368: @1360410
     /* 1360410 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1360494), // Rule ID 22013 //
     /* 1360415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1360418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1360426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1360429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1360432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1360435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1360438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360468 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1360471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360493 */     // GIR_Coverage, 22013,
     /* 1360493 */     GIR_EraseRootFromParent_Done,
     /* 1360494 */   // Label 19369: @1360494
     /* 1360494 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1360578), // Rule ID 22016 //
     /* 1360499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1360516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1360555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360577 */     // GIR_Coverage, 22016,
     /* 1360577 */     GIR_EraseRootFromParent_Done,
     /* 1360578 */   // Label 19370: @1360578
     /* 1360578 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1360662), // Rule ID 22017 //
     /* 1360583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1360600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360636 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1360639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360661 */     // GIR_Coverage, 22017,
     /* 1360661 */     GIR_EraseRootFromParent_Done,
     /* 1360662 */   // Label 19371: @1360662
     /* 1360662 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1360746), // Rule ID 22020 //
     /* 1360667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1360684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1360723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360745 */     // GIR_Coverage, 22020,
     /* 1360745 */     GIR_EraseRootFromParent_Done,
     /* 1360746 */   // Label 19372: @1360746
     /* 1360746 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1360830), // Rule ID 22021 //
     /* 1360751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1360768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1360807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360829 */     // GIR_Coverage, 22021,
     /* 1360829 */     GIR_EraseRootFromParent_Done,
     /* 1360830 */   // Label 19373: @1360830
     /* 1360830 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1360914), // Rule ID 22024 //
     /* 1360835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1360852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1360858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1360891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360913 */     // GIR_Coverage, 22024,
     /* 1360913 */     GIR_EraseRootFromParent_Done,
     /* 1360914 */   // Label 19374: @1360914
     /* 1360914 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1360998), // Rule ID 22025 //
     /* 1360919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1360927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1360936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1360942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360972 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1360975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360997 */     // GIR_Coverage, 22025,
     /* 1360997 */     GIR_EraseRootFromParent_Done,
     /* 1360998 */   // Label 19375: @1360998
     /* 1360998 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1361082), // Rule ID 22028 //
     /* 1361003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1361020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1361059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361081 */     // GIR_Coverage, 22028,
     /* 1361081 */     GIR_EraseRootFromParent_Done,
     /* 1361082 */   // Label 19376: @1361082
     /* 1361082 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1361166), // Rule ID 22029 //
     /* 1361087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1361104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1361143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361165 */     // GIR_Coverage, 22029,
     /* 1361165 */     GIR_EraseRootFromParent_Done,
     /* 1361166 */   // Label 19377: @1361166
     /* 1361166 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1361250), // Rule ID 22032 //
     /* 1361171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1361188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1361227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361249 */     // GIR_Coverage, 22032,
     /* 1361249 */     GIR_EraseRootFromParent_Done,
     /* 1361250 */   // Label 19378: @1361250
     /* 1361250 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1361334), // Rule ID 22033 //
     /* 1361255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1361272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1361311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361333 */     // GIR_Coverage, 22033,
     /* 1361333 */     GIR_EraseRootFromParent_Done,
     /* 1361334 */   // Label 19379: @1361334
     /* 1361334 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1361418), // Rule ID 22036 //
     /* 1361339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1361356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1361362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1361395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361417 */     // GIR_Coverage, 22036,
     /* 1361417 */     GIR_EraseRootFromParent_Done,
     /* 1361418 */   // Label 19380: @1361418
     /* 1361418 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1361502), // Rule ID 22037 //
     /* 1361423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1361440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1361446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1361479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361501 */     // GIR_Coverage, 22037,
     /* 1361501 */     GIR_EraseRootFromParent_Done,
     /* 1361502 */   // Label 19381: @1361502
     /* 1361502 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1361586), // Rule ID 22040 //
     /* 1361507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1361524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1361563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361585 */     // GIR_Coverage, 22040,
     /* 1361585 */     GIR_EraseRootFromParent_Done,
     /* 1361586 */   // Label 19382: @1361586
     /* 1361586 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1361670), // Rule ID 22041 //
     /* 1361591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1361608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1361647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361669 */     // GIR_Coverage, 22041,
     /* 1361669 */     GIR_EraseRootFromParent_Done,
     /* 1361670 */   // Label 19383: @1361670
     /* 1361670 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1361754), // Rule ID 22044 //
     /* 1361675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1361692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1361731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361753 */     // GIR_Coverage, 22044,
     /* 1361753 */     GIR_EraseRootFromParent_Done,
     /* 1361754 */   // Label 19384: @1361754
     /* 1361754 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1361838), // Rule ID 22045 //
     /* 1361759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1361776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1361815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361837 */     // GIR_Coverage, 22045,
     /* 1361837 */     GIR_EraseRootFromParent_Done,
     /* 1361838 */   // Label 19385: @1361838
     /* 1361838 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1361922), // Rule ID 22048 //
     /* 1361843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1361860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1361899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361921 */     // GIR_Coverage, 22048,
     /* 1361921 */     GIR_EraseRootFromParent_Done,
     /* 1361922 */   // Label 19386: @1361922
     /* 1361922 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1362006), // Rule ID 22049 //
     /* 1361927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1361944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1361983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362005 */     // GIR_Coverage, 22049,
     /* 1362005 */     GIR_EraseRootFromParent_Done,
     /* 1362006 */   // Label 19387: @1362006
     /* 1362006 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1362090), // Rule ID 22052 //
     /* 1362011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1362014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1362028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1362067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362089 */     // GIR_Coverage, 22052,
     /* 1362089 */     GIR_EraseRootFromParent_Done,
     /* 1362090 */   // Label 19388: @1362090
     /* 1362090 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1362174), // Rule ID 22053 //
     /* 1362095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1362098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1362112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1362151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362173 */     // GIR_Coverage, 22053,
     /* 1362173 */     GIR_EraseRootFromParent_Done,
     /* 1362174 */   // Label 19389: @1362174
     /* 1362174 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1362258), // Rule ID 22056 //
     /* 1362179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1362182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1362196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1362235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362257 */     // GIR_Coverage, 22056,
     /* 1362257 */     GIR_EraseRootFromParent_Done,
     /* 1362258 */   // Label 19390: @1362258
     /* 1362258 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1362342), // Rule ID 22057 //
     /* 1362263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1362266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1362280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1362319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362341 */     // GIR_Coverage, 22057,
     /* 1362341 */     GIR_EraseRootFromParent_Done,
     /* 1362342 */   // Label 19391: @1362342
     /* 1362342 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1362426), // Rule ID 22060 //
     /* 1362347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1362350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1362364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1362403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362425 */     // GIR_Coverage, 22060,
     /* 1362425 */     GIR_EraseRootFromParent_Done,
     /* 1362426 */   // Label 19392: @1362426
     /* 1362426 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1362510), // Rule ID 22061 //
     /* 1362431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1362434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1362448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1362469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1362487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362509 */     // GIR_Coverage, 22061,
     /* 1362509 */     GIR_EraseRootFromParent_Done,
     /* 1362510 */   // Label 19393: @1362510
     /* 1362510 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1362594), // Rule ID 22064 //
     /* 1362515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1362532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1362571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362593 */     // GIR_Coverage, 22064,
     /* 1362593 */     GIR_EraseRootFromParent_Done,
     /* 1362594 */   // Label 19394: @1362594
     /* 1362594 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1362678), // Rule ID 22065 //
     /* 1362599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1362616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1362655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362677 */     // GIR_Coverage, 22065,
     /* 1362677 */     GIR_EraseRootFromParent_Done,
     /* 1362678 */   // Label 19395: @1362678
     /* 1362678 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1362762), // Rule ID 22068 //
     /* 1362683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1362700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362736 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1362739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362761 */     // GIR_Coverage, 22068,
     /* 1362761 */     GIR_EraseRootFromParent_Done,
     /* 1362762 */   // Label 19396: @1362762
     /* 1362762 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1362846), // Rule ID 22069 //
     /* 1362767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1362784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1362823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362845 */     // GIR_Coverage, 22069,
     /* 1362845 */     GIR_EraseRootFromParent_Done,
     /* 1362846 */   // Label 19397: @1362846
     /* 1362846 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1362930), // Rule ID 22072 //
     /* 1362851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1362868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1362907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362929 */     // GIR_Coverage, 22072,
     /* 1362929 */     GIR_EraseRootFromParent_Done,
     /* 1362930 */   // Label 19398: @1362930
     /* 1362930 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1363014), // Rule ID 22073 //
     /* 1362935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1362943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1362952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362988 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1362991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363013 */     // GIR_Coverage, 22073,
     /* 1363013 */     GIR_EraseRootFromParent_Done,
     /* 1363014 */   // Label 19399: @1363014
     /* 1363014 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1363098), // Rule ID 22076 //
     /* 1363019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1363036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1363075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363097 */     // GIR_Coverage, 22076,
     /* 1363097 */     GIR_EraseRootFromParent_Done,
     /* 1363098 */   // Label 19400: @1363098
     /* 1363098 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1363182), // Rule ID 22077 //
     /* 1363103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1363120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1363159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363181 */     // GIR_Coverage, 22077,
     /* 1363181 */     GIR_EraseRootFromParent_Done,
     /* 1363182 */   // Label 19401: @1363182
     /* 1363182 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1363266), // Rule ID 22080 //
     /* 1363187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1363204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1363243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363265 */     // GIR_Coverage, 22080,
     /* 1363265 */     GIR_EraseRootFromParent_Done,
     /* 1363266 */   // Label 19402: @1363266
     /* 1363266 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1363350), // Rule ID 22081 //
     /* 1363271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1363288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1363327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363349 */     // GIR_Coverage, 22081,
     /* 1363349 */     GIR_EraseRootFromParent_Done,
     /* 1363350 */   // Label 19403: @1363350
     /* 1363350 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1363434), // Rule ID 22084 //
     /* 1363355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1363372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1363411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363433 */     // GIR_Coverage, 22084,
     /* 1363433 */     GIR_EraseRootFromParent_Done,
     /* 1363434 */   // Label 19404: @1363434
     /* 1363434 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1363518), // Rule ID 22085 //
     /* 1363439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1363456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1363495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363517 */     // GIR_Coverage, 22085,
     /* 1363517 */     GIR_EraseRootFromParent_Done,
     /* 1363518 */   // Label 19405: @1363518
     /* 1363518 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1363602), // Rule ID 22088 //
     /* 1363523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1363540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1363579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363601 */     // GIR_Coverage, 22088,
     /* 1363601 */     GIR_EraseRootFromParent_Done,
     /* 1363602 */   // Label 19406: @1363602
     /* 1363602 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1363686), // Rule ID 22089 //
     /* 1363607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1363624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1363663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363685 */     // GIR_Coverage, 22089,
     /* 1363685 */     GIR_EraseRootFromParent_Done,
     /* 1363686 */   // Label 19407: @1363686
     /* 1363686 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1363770), // Rule ID 22092 //
     /* 1363691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1363708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1363747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363769 */     // GIR_Coverage, 22092,
     /* 1363769 */     GIR_EraseRootFromParent_Done,
     /* 1363770 */   // Label 19408: @1363770
     /* 1363770 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1363854), // Rule ID 22093 //
     /* 1363775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1363792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1363831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363853 */     // GIR_Coverage, 22093,
     /* 1363853 */     GIR_EraseRootFromParent_Done,
     /* 1363854 */   // Label 19409: @1363854
     /* 1363854 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1363938), // Rule ID 22096 //
     /* 1363859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1363876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1363915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363937 */     // GIR_Coverage, 22096,
     /* 1363937 */     GIR_EraseRootFromParent_Done,
     /* 1363938 */   // Label 19410: @1363938
     /* 1363938 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1364022), // Rule ID 22097 //
     /* 1363943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1363951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1363960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1363999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364021 */     // GIR_Coverage, 22097,
     /* 1364021 */     GIR_EraseRootFromParent_Done,
     /* 1364022 */   // Label 19411: @1364022
     /* 1364022 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1364106), // Rule ID 22100 //
     /* 1364027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1364044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1364083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364105 */     // GIR_Coverage, 22100,
     /* 1364105 */     GIR_EraseRootFromParent_Done,
     /* 1364106 */   // Label 19412: @1364106
     /* 1364106 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1364190), // Rule ID 22101 //
     /* 1364111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1364128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1364167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364189 */     // GIR_Coverage, 22101,
     /* 1364189 */     GIR_EraseRootFromParent_Done,
     /* 1364190 */   // Label 19413: @1364190
     /* 1364190 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1364274), // Rule ID 22104 //
     /* 1364195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1364212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364248 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1364251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364273 */     // GIR_Coverage, 22104,
     /* 1364273 */     GIR_EraseRootFromParent_Done,
     /* 1364274 */   // Label 19414: @1364274
     /* 1364274 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1364358), // Rule ID 22105 //
     /* 1364279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1364296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1364335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364357 */     // GIR_Coverage, 22105,
     /* 1364357 */     GIR_EraseRootFromParent_Done,
     /* 1364358 */   // Label 19415: @1364358
     /* 1364358 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1364442), // Rule ID 22108 //
     /* 1364363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1364380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364416 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1364419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364441 */     // GIR_Coverage, 22108,
     /* 1364441 */     GIR_EraseRootFromParent_Done,
     /* 1364442 */   // Label 19416: @1364442
     /* 1364442 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1364526), // Rule ID 22109 //
     /* 1364447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1364464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364500 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1364503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364525 */     // GIR_Coverage, 22109,
     /* 1364525 */     GIR_EraseRootFromParent_Done,
     /* 1364526 */   // Label 19417: @1364526
     /* 1364526 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1364610), // Rule ID 22112 //
     /* 1364531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1364548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1364554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364584 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1364587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364609 */     // GIR_Coverage, 22112,
     /* 1364609 */     GIR_EraseRootFromParent_Done,
     /* 1364610 */   // Label 19418: @1364610
     /* 1364610 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1364694), // Rule ID 22113 //
     /* 1364615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1364632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1364638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1364671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364693 */     // GIR_Coverage, 22113,
     /* 1364693 */     GIR_EraseRootFromParent_Done,
     /* 1364694 */   // Label 19419: @1364694
     /* 1364694 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1364778), // Rule ID 22116 //
     /* 1364699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1364716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1364755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364777 */     // GIR_Coverage, 22116,
     /* 1364777 */     GIR_EraseRootFromParent_Done,
     /* 1364778 */   // Label 19420: @1364778
     /* 1364778 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1364862), // Rule ID 22117 //
     /* 1364783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1364800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1364839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364861 */     // GIR_Coverage, 22117,
     /* 1364861 */     GIR_EraseRootFromParent_Done,
     /* 1364862 */   // Label 19421: @1364862
     /* 1364862 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1364946), // Rule ID 22120 //
     /* 1364867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1364884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1364923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364945 */     // GIR_Coverage, 22120,
     /* 1364945 */     GIR_EraseRootFromParent_Done,
     /* 1364946 */   // Label 19422: @1364946
     /* 1364946 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1365030), // Rule ID 22121 //
     /* 1364951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1364968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1365007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365029 */     // GIR_Coverage, 22121,
     /* 1365029 */     GIR_EraseRootFromParent_Done,
     /* 1365030 */   // Label 19423: @1365030
     /* 1365030 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1365114), // Rule ID 22124 //
     /* 1365035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1365052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1365058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1365091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365113 */     // GIR_Coverage, 22124,
     /* 1365113 */     GIR_EraseRootFromParent_Done,
     /* 1365114 */   // Label 19424: @1365114
     /* 1365114 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1365198), // Rule ID 22125 //
     /* 1365119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1365136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1365142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1365175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365197 */     // GIR_Coverage, 22125,
     /* 1365197 */     GIR_EraseRootFromParent_Done,
     /* 1365198 */   // Label 19425: @1365198
     /* 1365198 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1365282), // Rule ID 22128 //
     /* 1365203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1365220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1365259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365281 */     // GIR_Coverage, 22128,
     /* 1365281 */     GIR_EraseRootFromParent_Done,
     /* 1365282 */   // Label 19426: @1365282
     /* 1365282 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1365366), // Rule ID 22129 //
     /* 1365287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1365304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1365343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365365 */     // GIR_Coverage, 22129,
     /* 1365365 */     GIR_EraseRootFromParent_Done,
     /* 1365366 */   // Label 19427: @1365366
     /* 1365366 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1365450), // Rule ID 22132 //
     /* 1365371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1365388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1365427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365449 */     // GIR_Coverage, 22132,
     /* 1365449 */     GIR_EraseRootFromParent_Done,
     /* 1365450 */   // Label 19428: @1365450
     /* 1365450 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1365534), // Rule ID 22133 //
     /* 1365455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1365472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1365511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365533 */     // GIR_Coverage, 22133,
     /* 1365533 */     GIR_EraseRootFromParent_Done,
     /* 1365534 */   // Label 19429: @1365534
     /* 1365534 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1365618), // Rule ID 22136 //
     /* 1365539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1365556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1365562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1365595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365617 */     // GIR_Coverage, 22136,
     /* 1365617 */     GIR_EraseRootFromParent_Done,
     /* 1365618 */   // Label 19430: @1365618
     /* 1365618 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1365702), // Rule ID 22137 //
     /* 1365623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1365640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1365646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1365679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365701 */     // GIR_Coverage, 22137,
     /* 1365701 */     GIR_EraseRootFromParent_Done,
     /* 1365702 */   // Label 19431: @1365702
     /* 1365702 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1365786), // Rule ID 22140 //
     /* 1365707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1365724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1365763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365785 */     // GIR_Coverage, 22140,
     /* 1365785 */     GIR_EraseRootFromParent_Done,
     /* 1365786 */   // Label 19432: @1365786
     /* 1365786 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1365870), // Rule ID 22141 //
     /* 1365791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1365808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1365847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365869 */     // GIR_Coverage, 22141,
     /* 1365869 */     GIR_EraseRootFromParent_Done,
     /* 1365870 */   // Label 19433: @1365870
     /* 1365870 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1365954), // Rule ID 22144 //
     /* 1365875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1365892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1365931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365953 */     // GIR_Coverage, 22144,
     /* 1365953 */     GIR_EraseRootFromParent_Done,
     /* 1365954 */   // Label 19434: @1365954
     /* 1365954 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1366038), // Rule ID 22145 //
     /* 1365959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1365976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1366015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366037 */     // GIR_Coverage, 22145,
     /* 1366037 */     GIR_EraseRootFromParent_Done,
     /* 1366038 */   // Label 19435: @1366038
     /* 1366038 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1366122), // Rule ID 22148 //
     /* 1366043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1366060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366096 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1366099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366121 */     // GIR_Coverage, 22148,
     /* 1366121 */     GIR_EraseRootFromParent_Done,
     /* 1366122 */   // Label 19436: @1366122
     /* 1366122 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1366206), // Rule ID 22149 //
     /* 1366127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1366144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1366183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366205 */     // GIR_Coverage, 22149,
     /* 1366205 */     GIR_EraseRootFromParent_Done,
     /* 1366206 */   // Label 19437: @1366206
     /* 1366206 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1366290), // Rule ID 22152 //
     /* 1366211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1366228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1366267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366289 */     // GIR_Coverage, 22152,
     /* 1366289 */     GIR_EraseRootFromParent_Done,
     /* 1366290 */   // Label 19438: @1366290
     /* 1366290 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1366374), // Rule ID 22153 //
     /* 1366295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1366312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1366351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366373 */     // GIR_Coverage, 22153,
     /* 1366373 */     GIR_EraseRootFromParent_Done,
     /* 1366374 */   // Label 19439: @1366374
     /* 1366374 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1366458), // Rule ID 22156 //
     /* 1366379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1366396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1366435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366457 */     // GIR_Coverage, 22156,
     /* 1366457 */     GIR_EraseRootFromParent_Done,
     /* 1366458 */   // Label 19440: @1366458
     /* 1366458 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1366542), // Rule ID 22157 //
     /* 1366463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1366480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1366519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366541 */     // GIR_Coverage, 22157,
     /* 1366541 */     GIR_EraseRootFromParent_Done,
     /* 1366542 */   // Label 19441: @1366542
     /* 1366542 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1366626), // Rule ID 22160 //
     /* 1366547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1366564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1366603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366625 */     // GIR_Coverage, 22160,
     /* 1366625 */     GIR_EraseRootFromParent_Done,
     /* 1366626 */   // Label 19442: @1366626
     /* 1366626 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1366710), // Rule ID 22161 //
     /* 1366631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1366648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1366687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366709 */     // GIR_Coverage, 22161,
     /* 1366709 */     GIR_EraseRootFromParent_Done,
     /* 1366710 */   // Label 19443: @1366710
     /* 1366710 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1366794), // Rule ID 22164 //
     /* 1366715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1366732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1366771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366793 */     // GIR_Coverage, 22164,
     /* 1366793 */     GIR_EraseRootFromParent_Done,
     /* 1366794 */   // Label 19444: @1366794
     /* 1366794 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1366878), // Rule ID 22165 //
     /* 1366799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1366816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1366855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366877 */     // GIR_Coverage, 22165,
     /* 1366877 */     GIR_EraseRootFromParent_Done,
     /* 1366878 */   // Label 19445: @1366878
     /* 1366878 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1366962), // Rule ID 22168 //
     /* 1366883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1366900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1366939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366961 */     // GIR_Coverage, 22168,
     /* 1366961 */     GIR_EraseRootFromParent_Done,
     /* 1366962 */   // Label 19446: @1366962
     /* 1366962 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1367046), // Rule ID 22169 //
     /* 1366967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1366975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1366984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1367023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367045 */     // GIR_Coverage, 22169,
     /* 1367045 */     GIR_EraseRootFromParent_Done,
     /* 1367046 */   // Label 19447: @1367046
     /* 1367046 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1367130), // Rule ID 22172 //
     /* 1367051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1367068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1367107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367129 */     // GIR_Coverage, 22172,
     /* 1367129 */     GIR_EraseRootFromParent_Done,
     /* 1367130 */   // Label 19448: @1367130
     /* 1367130 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1367214), // Rule ID 22173 //
     /* 1367135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1367152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1367191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367213 */     // GIR_Coverage, 22173,
     /* 1367213 */     GIR_EraseRootFromParent_Done,
     /* 1367214 */   // Label 19449: @1367214
     /* 1367214 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1367298), // Rule ID 22176 //
     /* 1367219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1367236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367272 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1367275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367297 */     // GIR_Coverage, 22176,
     /* 1367297 */     GIR_EraseRootFromParent_Done,
     /* 1367298 */   // Label 19450: @1367298
     /* 1367298 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1367382), // Rule ID 22177 //
     /* 1367303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1367320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1367359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367381 */     // GIR_Coverage, 22177,
     /* 1367381 */     GIR_EraseRootFromParent_Done,
     /* 1367382 */   // Label 19451: @1367382
     /* 1367382 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1367466), // Rule ID 22180 //
     /* 1367387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1367404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1367443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367465 */     // GIR_Coverage, 22180,
     /* 1367465 */     GIR_EraseRootFromParent_Done,
     /* 1367466 */   // Label 19452: @1367466
     /* 1367466 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1367550), // Rule ID 22181 //
     /* 1367471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1367488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1367527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367549 */     // GIR_Coverage, 22181,
     /* 1367549 */     GIR_EraseRootFromParent_Done,
     /* 1367550 */   // Label 19453: @1367550
     /* 1367550 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1367634), // Rule ID 22184 //
     /* 1367555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1367572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1367611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367633 */     // GIR_Coverage, 22184,
     /* 1367633 */     GIR_EraseRootFromParent_Done,
     /* 1367634 */   // Label 19454: @1367634
     /* 1367634 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1367718), // Rule ID 22185 //
     /* 1367639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1367656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1367695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367717 */     // GIR_Coverage, 22185,
     /* 1367717 */     GIR_EraseRootFromParent_Done,
     /* 1367718 */   // Label 19455: @1367718
     /* 1367718 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1367802), // Rule ID 22188 //
     /* 1367723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1367740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1367779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367801 */     // GIR_Coverage, 22188,
     /* 1367801 */     GIR_EraseRootFromParent_Done,
     /* 1367802 */   // Label 19456: @1367802
     /* 1367802 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1367886), // Rule ID 22189 //
     /* 1367807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1367810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1367824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1367863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367885 */     // GIR_Coverage, 22189,
     /* 1367885 */     GIR_EraseRootFromParent_Done,
     /* 1367886 */   // Label 19457: @1367886
     /* 1367886 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1367970), // Rule ID 22192 //
     /* 1367891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1367908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1367947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367969 */     // GIR_Coverage, 22192,
     /* 1367969 */     GIR_EraseRootFromParent_Done,
     /* 1367970 */   // Label 19458: @1367970
     /* 1367970 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1368054), // Rule ID 22193 //
     /* 1367975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1367983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1367992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1368031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368053 */     // GIR_Coverage, 22193,
     /* 1368053 */     GIR_EraseRootFromParent_Done,
     /* 1368054 */   // Label 19459: @1368054
     /* 1368054 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1368138), // Rule ID 22196 //
     /* 1368059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1368076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1368115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368137 */     // GIR_Coverage, 22196,
     /* 1368137 */     GIR_EraseRootFromParent_Done,
     /* 1368138 */   // Label 19460: @1368138
     /* 1368138 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1368222), // Rule ID 22197 //
     /* 1368143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1368160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1368199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368221 */     // GIR_Coverage, 22197,
     /* 1368221 */     GIR_EraseRootFromParent_Done,
     /* 1368222 */   // Label 19461: @1368222
     /* 1368222 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1368306), // Rule ID 22200 //
     /* 1368227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1368244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1368250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368280 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1368283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368305 */     // GIR_Coverage, 22200,
     /* 1368305 */     GIR_EraseRootFromParent_Done,
     /* 1368306 */   // Label 19462: @1368306
     /* 1368306 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1368390), // Rule ID 22201 //
     /* 1368311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1368328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1368334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368364 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1368367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368389 */     // GIR_Coverage, 22201,
     /* 1368389 */     GIR_EraseRootFromParent_Done,
     /* 1368390 */   // Label 19463: @1368390
     /* 1368390 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1368474), // Rule ID 22204 //
     /* 1368395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1368412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1368451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368473 */     // GIR_Coverage, 22204,
     /* 1368473 */     GIR_EraseRootFromParent_Done,
     /* 1368474 */   // Label 19464: @1368474
     /* 1368474 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1368558), // Rule ID 22205 //
     /* 1368479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1368496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1368535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368557 */     // GIR_Coverage, 22205,
     /* 1368557 */     GIR_EraseRootFromParent_Done,
     /* 1368558 */   // Label 19465: @1368558
     /* 1368558 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1368642), // Rule ID 22208 //
     /* 1368563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1368580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1368619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368641 */     // GIR_Coverage, 22208,
     /* 1368641 */     GIR_EraseRootFromParent_Done,
     /* 1368642 */   // Label 19466: @1368642
     /* 1368642 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1368726), // Rule ID 22209 //
     /* 1368647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1368664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1368703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368725 */     // GIR_Coverage, 22209,
     /* 1368725 */     GIR_EraseRootFromParent_Done,
     /* 1368726 */   // Label 19467: @1368726
     /* 1368726 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1368810), // Rule ID 22212 //
     /* 1368731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1368748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1368787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368809 */     // GIR_Coverage, 22212,
     /* 1368809 */     GIR_EraseRootFromParent_Done,
     /* 1368810 */   // Label 19468: @1368810
     /* 1368810 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1368894), // Rule ID 22213 //
     /* 1368815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1368832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1368871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368893 */     // GIR_Coverage, 22213,
     /* 1368893 */     GIR_EraseRootFromParent_Done,
     /* 1368894 */   // Label 19469: @1368894
     /* 1368894 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1368978), // Rule ID 22216 //
     /* 1368899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1368916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1368955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368977 */     // GIR_Coverage, 22216,
     /* 1368977 */     GIR_EraseRootFromParent_Done,
     /* 1368978 */   // Label 19470: @1368978
     /* 1368978 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1369062), // Rule ID 22217 //
     /* 1368983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1369000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1369039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369061 */     // GIR_Coverage, 22217,
     /* 1369061 */     GIR_EraseRootFromParent_Done,
     /* 1369062 */   // Label 19471: @1369062
     /* 1369062 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1369146), // Rule ID 22220 //
     /* 1369067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1369084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1369123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369145 */     // GIR_Coverage, 22220,
     /* 1369145 */     GIR_EraseRootFromParent_Done,
     /* 1369146 */   // Label 19472: @1369146
     /* 1369146 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1369230), // Rule ID 22221 //
     /* 1369151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1369168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1369207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369229 */     // GIR_Coverage, 22221,
     /* 1369229 */     GIR_EraseRootFromParent_Done,
     /* 1369230 */   // Label 19473: @1369230
     /* 1369230 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1369314), // Rule ID 22224 //
     /* 1369235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1369252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1369258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1369291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369313 */     // GIR_Coverage, 22224,
     /* 1369313 */     GIR_EraseRootFromParent_Done,
     /* 1369314 */   // Label 19474: @1369314
     /* 1369314 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1369398), // Rule ID 22225 //
     /* 1369319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1369336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1369342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1369375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369397 */     // GIR_Coverage, 22225,
     /* 1369397 */     GIR_EraseRootFromParent_Done,
     /* 1369398 */   // Label 19475: @1369398
     /* 1369398 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1369482), // Rule ID 22228 //
     /* 1369403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1369420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1369459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369481 */     // GIR_Coverage, 22228,
     /* 1369481 */     GIR_EraseRootFromParent_Done,
     /* 1369482 */   // Label 19476: @1369482
     /* 1369482 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1369566), // Rule ID 22229 //
     /* 1369487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1369504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1369525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1369543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369565 */     // GIR_Coverage, 22229,
     /* 1369565 */     GIR_EraseRootFromParent_Done,
     /* 1369566 */   // Label 19477: @1369566
     /* 1369566 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1369650), // Rule ID 22232 //
     /* 1369571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1369588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1369627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369649 */     // GIR_Coverage, 22232,
     /* 1369649 */     GIR_EraseRootFromParent_Done,
     /* 1369650 */   // Label 19478: @1369650
     /* 1369650 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1369734), // Rule ID 22233 //
     /* 1369655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1369672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1369711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369733 */     // GIR_Coverage, 22233,
     /* 1369733 */     GIR_EraseRootFromParent_Done,
     /* 1369734 */   // Label 19479: @1369734
     /* 1369734 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1369818), // Rule ID 22236 //
     /* 1369739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1369756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1369795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369817 */     // GIR_Coverage, 22236,
     /* 1369817 */     GIR_EraseRootFromParent_Done,
     /* 1369818 */   // Label 19480: @1369818
     /* 1369818 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1369902), // Rule ID 22237 //
     /* 1369823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1369840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1369879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369901 */     // GIR_Coverage, 22237,
     /* 1369901 */     GIR_EraseRootFromParent_Done,
     /* 1369902 */   // Label 19481: @1369902
     /* 1369902 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1369986), // Rule ID 22240 //
     /* 1369907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1369915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1369924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1369963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369985 */     // GIR_Coverage, 22240,
     /* 1369985 */     GIR_EraseRootFromParent_Done,
     /* 1369986 */   // Label 19482: @1369986
     /* 1369986 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1370070), // Rule ID 22241 //
     /* 1369991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1369999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1370008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1370047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370069 */     // GIR_Coverage, 22241,
     /* 1370069 */     GIR_EraseRootFromParent_Done,
     /* 1370070 */   // Label 19483: @1370070
     /* 1370070 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1370154), // Rule ID 22244 //
     /* 1370075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1370092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1370131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370153 */     // GIR_Coverage, 22244,
     /* 1370153 */     GIR_EraseRootFromParent_Done,
     /* 1370154 */   // Label 19484: @1370154
     /* 1370154 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1370238), // Rule ID 22245 //
     /* 1370159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1370176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1370215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370237 */     // GIR_Coverage, 22245,
     /* 1370237 */     GIR_EraseRootFromParent_Done,
     /* 1370238 */   // Label 19485: @1370238
     /* 1370238 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1370322), // Rule ID 22248 //
     /* 1370243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1370260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1370299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370321 */     // GIR_Coverage, 22248,
     /* 1370321 */     GIR_EraseRootFromParent_Done,
     /* 1370322 */   // Label 19486: @1370322
     /* 1370322 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1370406), // Rule ID 22249 //
     /* 1370327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1370344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1370383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370405 */     // GIR_Coverage, 22249,
     /* 1370405 */     GIR_EraseRootFromParent_Done,
     /* 1370406 */   // Label 19487: @1370406
     /* 1370406 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1370490), // Rule ID 22252 //
     /* 1370411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1370428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1370467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370489 */     // GIR_Coverage, 22252,
     /* 1370489 */     GIR_EraseRootFromParent_Done,
     /* 1370490 */   // Label 19488: @1370490
     /* 1370490 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1370574), // Rule ID 22253 //
     /* 1370495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1370512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1370551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370573 */     // GIR_Coverage, 22253,
     /* 1370573 */     GIR_EraseRootFromParent_Done,
     /* 1370574 */   // Label 19489: @1370574
     /* 1370574 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1370658), // Rule ID 22256 //
     /* 1370579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1370596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1370635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370657 */     // GIR_Coverage, 22256,
     /* 1370657 */     GIR_EraseRootFromParent_Done,
     /* 1370658 */   // Label 19490: @1370658
     /* 1370658 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1370742), // Rule ID 22257 //
     /* 1370663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1370680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1370719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370741 */     // GIR_Coverage, 22257,
     /* 1370741 */     GIR_EraseRootFromParent_Done,
     /* 1370742 */   // Label 19491: @1370742
     /* 1370742 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1370826), // Rule ID 22260 //
     /* 1370747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1370764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1370803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370825 */     // GIR_Coverage, 22260,
     /* 1370825 */     GIR_EraseRootFromParent_Done,
     /* 1370826 */   // Label 19492: @1370826
     /* 1370826 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1370910), // Rule ID 22261 //
     /* 1370831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1370848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1370887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370909 */     // GIR_Coverage, 22261,
     /* 1370909 */     GIR_EraseRootFromParent_Done,
     /* 1370910 */   // Label 19493: @1370910
     /* 1370910 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1370994), // Rule ID 22264 //
     /* 1370915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1370923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1370932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1370971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370993 */     // GIR_Coverage, 22264,
     /* 1370993 */     GIR_EraseRootFromParent_Done,
     /* 1370994 */   // Label 19494: @1370994
     /* 1370994 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1371078), // Rule ID 22265 //
     /* 1370999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1371016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1371055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371077 */     // GIR_Coverage, 22265,
     /* 1371077 */     GIR_EraseRootFromParent_Done,
     /* 1371078 */   // Label 19495: @1371078
     /* 1371078 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1371162), // Rule ID 22268 //
     /* 1371083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1371100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371136 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1371139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371161 */     // GIR_Coverage, 22268,
     /* 1371161 */     GIR_EraseRootFromParent_Done,
     /* 1371162 */   // Label 19496: @1371162
     /* 1371162 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1371246), // Rule ID 22269 //
     /* 1371167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1371184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1371223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371245 */     // GIR_Coverage, 22269,
     /* 1371245 */     GIR_EraseRootFromParent_Done,
     /* 1371246 */   // Label 19497: @1371246
     /* 1371246 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1371330), // Rule ID 22272 //
     /* 1371251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1371268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1371307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371329 */     // GIR_Coverage, 22272,
     /* 1371329 */     GIR_EraseRootFromParent_Done,
     /* 1371330 */   // Label 19498: @1371330
     /* 1371330 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1371414), // Rule ID 22273 //
     /* 1371335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1371352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1371391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371413 */     // GIR_Coverage, 22273,
     /* 1371413 */     GIR_EraseRootFromParent_Done,
     /* 1371414 */   // Label 19499: @1371414
     /* 1371414 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1371498), // Rule ID 22276 //
     /* 1371419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1371436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1371442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1371475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371497 */     // GIR_Coverage, 22276,
     /* 1371497 */     GIR_EraseRootFromParent_Done,
     /* 1371498 */   // Label 19500: @1371498
     /* 1371498 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1371582), // Rule ID 22277 //
     /* 1371503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1371520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1371526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1371559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371581 */     // GIR_Coverage, 22277,
     /* 1371581 */     GIR_EraseRootFromParent_Done,
     /* 1371582 */   // Label 19501: @1371582
     /* 1371582 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1371666), // Rule ID 22280 //
     /* 1371587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1371604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1371643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371665 */     // GIR_Coverage, 22280,
     /* 1371665 */     GIR_EraseRootFromParent_Done,
     /* 1371666 */   // Label 19502: @1371666
     /* 1371666 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1371750), // Rule ID 22281 //
     /* 1371671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1371688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1371727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371749 */     // GIR_Coverage, 22281,
     /* 1371749 */     GIR_EraseRootFromParent_Done,
     /* 1371750 */   // Label 19503: @1371750
     /* 1371750 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1371834), // Rule ID 22284 //
     /* 1371755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1371772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1371811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371833 */     // GIR_Coverage, 22284,
     /* 1371833 */     GIR_EraseRootFromParent_Done,
     /* 1371834 */   // Label 19504: @1371834
     /* 1371834 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1371918), // Rule ID 22285 //
     /* 1371839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1371856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1371895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371917 */     // GIR_Coverage, 22285,
     /* 1371917 */     GIR_EraseRootFromParent_Done,
     /* 1371918 */   // Label 19505: @1371918
     /* 1371918 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1372002), // Rule ID 22288 //
     /* 1371923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1371931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1371940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1371946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371976 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1371979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372001 */     // GIR_Coverage, 22288,
     /* 1372001 */     GIR_EraseRootFromParent_Done,
     /* 1372002 */   // Label 19506: @1372002
     /* 1372002 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1372086), // Rule ID 22289 //
     /* 1372007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1372024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1372030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1372063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372085 */     // GIR_Coverage, 22289,
     /* 1372085 */     GIR_EraseRootFromParent_Done,
     /* 1372086 */   // Label 19507: @1372086
     /* 1372086 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1372170), // Rule ID 22292 //
     /* 1372091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1372108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1372147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372169 */     // GIR_Coverage, 22292,
     /* 1372169 */     GIR_EraseRootFromParent_Done,
     /* 1372170 */   // Label 19508: @1372170
     /* 1372170 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1372254), // Rule ID 22293 //
     /* 1372175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1372192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1372231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372253 */     // GIR_Coverage, 22293,
     /* 1372253 */     GIR_EraseRootFromParent_Done,
     /* 1372254 */   // Label 19509: @1372254
     /* 1372254 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1372338), // Rule ID 22296 //
     /* 1372259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1372276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1372315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372337 */     // GIR_Coverage, 22296,
     /* 1372337 */     GIR_EraseRootFromParent_Done,
     /* 1372338 */   // Label 19510: @1372338
     /* 1372338 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1372422), // Rule ID 22297 //
     /* 1372343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1372360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1372399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372421 */     // GIR_Coverage, 22297,
     /* 1372421 */     GIR_EraseRootFromParent_Done,
     /* 1372422 */   // Label 19511: @1372422
     /* 1372422 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1372506), // Rule ID 22300 //
     /* 1372427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1372444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1372450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1372483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372505 */     // GIR_Coverage, 22300,
     /* 1372505 */     GIR_EraseRootFromParent_Done,
     /* 1372506 */   // Label 19512: @1372506
     /* 1372506 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1372590), // Rule ID 22301 //
     /* 1372511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1372528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1372534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1372567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372589 */     // GIR_Coverage, 22301,
     /* 1372589 */     GIR_EraseRootFromParent_Done,
     /* 1372590 */   // Label 19513: @1372590
     /* 1372590 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1372674), // Rule ID 22304 //
     /* 1372595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1372612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1372651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372673 */     // GIR_Coverage, 22304,
     /* 1372673 */     GIR_EraseRootFromParent_Done,
     /* 1372674 */   // Label 19514: @1372674
     /* 1372674 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1372758), // Rule ID 22305 //
     /* 1372679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1372696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1372735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372757 */     // GIR_Coverage, 22305,
     /* 1372757 */     GIR_EraseRootFromParent_Done,
     /* 1372758 */   // Label 19515: @1372758
     /* 1372758 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1372842), // Rule ID 22308 //
     /* 1372763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1372780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1372819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372841 */     // GIR_Coverage, 22308,
     /* 1372841 */     GIR_EraseRootFromParent_Done,
     /* 1372842 */   // Label 19516: @1372842
     /* 1372842 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1372926), // Rule ID 22309 //
     /* 1372847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1372864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1372903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372925 */     // GIR_Coverage, 22309,
     /* 1372925 */     GIR_EraseRootFromParent_Done,
     /* 1372926 */   // Label 19517: @1372926
     /* 1372926 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1373010), // Rule ID 22312 //
     /* 1372931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1372948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1372987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373009 */     // GIR_Coverage, 22312,
     /* 1373009 */     GIR_EraseRootFromParent_Done,
     /* 1373010 */   // Label 19518: @1373010
     /* 1373010 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1373094), // Rule ID 22313 //
     /* 1373015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1373032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1373053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1373071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373093 */     // GIR_Coverage, 22313,
     /* 1373093 */     GIR_EraseRootFromParent_Done,
     /* 1373094 */   // Label 19519: @1373094
     /* 1373094 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1373178), // Rule ID 22316 //
     /* 1373099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1373116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1373155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373177 */     // GIR_Coverage, 22316,
     /* 1373177 */     GIR_EraseRootFromParent_Done,
     /* 1373178 */   // Label 19520: @1373178
     /* 1373178 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1373262), // Rule ID 22317 //
     /* 1373183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1373200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373236 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1373239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373261 */     // GIR_Coverage, 22317,
     /* 1373261 */     GIR_EraseRootFromParent_Done,
     /* 1373262 */   // Label 19521: @1373262
     /* 1373262 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1373346), // Rule ID 22320 //
     /* 1373267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1373284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1373305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1373323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373345 */     // GIR_Coverage, 22320,
     /* 1373345 */     GIR_EraseRootFromParent_Done,
     /* 1373346 */   // Label 19522: @1373346
     /* 1373346 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1373430), // Rule ID 22321 //
     /* 1373351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1373368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1373389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1373407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373429 */     // GIR_Coverage, 22321,
     /* 1373429 */     GIR_EraseRootFromParent_Done,
     /* 1373430 */   // Label 19523: @1373430
     /* 1373430 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1373514), // Rule ID 22324 //
     /* 1373435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1373452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1373473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1373491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373513 */     // GIR_Coverage, 22324,
     /* 1373513 */     GIR_EraseRootFromParent_Done,
     /* 1373514 */   // Label 19524: @1373514
     /* 1373514 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1373598), // Rule ID 22325 //
     /* 1373519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1373536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1373557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1373575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373597 */     // GIR_Coverage, 22325,
     /* 1373597 */     GIR_EraseRootFromParent_Done,
     /* 1373598 */   // Label 19525: @1373598
     /* 1373598 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1373682), // Rule ID 22328 //
     /* 1373603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1373611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1373620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373656 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1373659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373681 */     // GIR_Coverage, 22328,
     /* 1373681 */     GIR_EraseRootFromParent_Done,
     /* 1373682 */   // Label 19526: @1373682
     /* 1373682 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1373766), // Rule ID 22329 //
     /* 1373687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1373695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1373704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1373743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373765 */     // GIR_Coverage, 22329,
     /* 1373765 */     GIR_EraseRootFromParent_Done,
     /* 1373766 */   // Label 19527: @1373766
     /* 1373766 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1373850), // Rule ID 22332 //
     /* 1373771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1373779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1373788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1373827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373849 */     // GIR_Coverage, 22332,
     /* 1373849 */     GIR_EraseRootFromParent_Done,
     /* 1373850 */   // Label 19528: @1373850
     /* 1373850 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1373934), // Rule ID 22333 //
     /* 1373855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1373863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1373872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1373911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373933 */     // GIR_Coverage, 22333,
     /* 1373933 */     GIR_EraseRootFromParent_Done,
     /* 1373934 */   // Label 19529: @1373934
     /* 1373934 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1374018), // Rule ID 22336 //
     /* 1373939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1373947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1373956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1373995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374017 */     // GIR_Coverage, 22336,
     /* 1374017 */     GIR_EraseRootFromParent_Done,
     /* 1374018 */   // Label 19530: @1374018
     /* 1374018 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1374102), // Rule ID 22337 //
     /* 1374023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1374040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1374079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374101 */     // GIR_Coverage, 22337,
     /* 1374101 */     GIR_EraseRootFromParent_Done,
     /* 1374102 */   // Label 19531: @1374102
     /* 1374102 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1374186), // Rule ID 22340 //
     /* 1374107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1374124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1374163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374185 */     // GIR_Coverage, 22340,
     /* 1374185 */     GIR_EraseRootFromParent_Done,
     /* 1374186 */   // Label 19532: @1374186
     /* 1374186 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1374270), // Rule ID 22341 //
     /* 1374191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1374208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1374247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374269 */     // GIR_Coverage, 22341,
     /* 1374269 */     GIR_EraseRootFromParent_Done,
     /* 1374270 */   // Label 19533: @1374270
     /* 1374270 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1374354), // Rule ID 22344 //
     /* 1374275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1374292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374328 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1374331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374353 */     // GIR_Coverage, 22344,
     /* 1374353 */     GIR_EraseRootFromParent_Done,
     /* 1374354 */   // Label 19534: @1374354
     /* 1374354 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1374438), // Rule ID 22345 //
     /* 1374359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1374376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1374415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374437 */     // GIR_Coverage, 22345,
     /* 1374437 */     GIR_EraseRootFromParent_Done,
     /* 1374438 */   // Label 19535: @1374438
     /* 1374438 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1374522), // Rule ID 22348 //
     /* 1374443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1374460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1374499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374521 */     // GIR_Coverage, 22348,
     /* 1374521 */     GIR_EraseRootFromParent_Done,
     /* 1374522 */   // Label 19536: @1374522
     /* 1374522 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1374606), // Rule ID 22349 //
     /* 1374527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1374544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1374583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374605 */     // GIR_Coverage, 22349,
     /* 1374605 */     GIR_EraseRootFromParent_Done,
     /* 1374606 */   // Label 19537: @1374606
     /* 1374606 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1374690), // Rule ID 22352 //
     /* 1374611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1374628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1374667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374689 */     // GIR_Coverage, 22352,
     /* 1374689 */     GIR_EraseRootFromParent_Done,
     /* 1374690 */   // Label 19538: @1374690
     /* 1374690 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1374774), // Rule ID 22353 //
     /* 1374695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1374712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374748 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1374751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374773 */     // GIR_Coverage, 22353,
     /* 1374773 */     GIR_EraseRootFromParent_Done,
     /* 1374774 */   // Label 19539: @1374774
     /* 1374774 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1374858), // Rule ID 22356 //
     /* 1374779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1374796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1374835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374857 */     // GIR_Coverage, 22356,
     /* 1374857 */     GIR_EraseRootFromParent_Done,
     /* 1374858 */   // Label 19540: @1374858
     /* 1374858 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1374942), // Rule ID 22357 //
     /* 1374863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1374880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1374919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374941 */     // GIR_Coverage, 22357,
     /* 1374941 */     GIR_EraseRootFromParent_Done,
     /* 1374942 */   // Label 19541: @1374942
     /* 1374942 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1375026), // Rule ID 22360 //
     /* 1374947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1374955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1374964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1375003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375025 */     // GIR_Coverage, 22360,
     /* 1375025 */     GIR_EraseRootFromParent_Done,
     /* 1375026 */   // Label 19542: @1375026
     /* 1375026 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1375110), // Rule ID 22361 //
     /* 1375031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1375048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1375087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375109 */     // GIR_Coverage, 22361,
     /* 1375109 */     GIR_EraseRootFromParent_Done,
     /* 1375110 */   // Label 19543: @1375110
     /* 1375110 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1375194), // Rule ID 22364 //
     /* 1375115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1375132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1375171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375193 */     // GIR_Coverage, 22364,
     /* 1375193 */     GIR_EraseRootFromParent_Done,
     /* 1375194 */   // Label 19544: @1375194
     /* 1375194 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1375278), // Rule ID 22365 //
     /* 1375199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1375216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1375255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375277 */     // GIR_Coverage, 22365,
     /* 1375277 */     GIR_EraseRootFromParent_Done,
     /* 1375278 */   // Label 19545: @1375278
     /* 1375278 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1375362), // Rule ID 22368 //
     /* 1375283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1375300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1375339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375361 */     // GIR_Coverage, 22368,
     /* 1375361 */     GIR_EraseRootFromParent_Done,
     /* 1375362 */   // Label 19546: @1375362
     /* 1375362 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1375446), // Rule ID 22369 //
     /* 1375367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1375384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1375423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375445 */     // GIR_Coverage, 22369,
     /* 1375445 */     GIR_EraseRootFromParent_Done,
     /* 1375446 */   // Label 19547: @1375446
     /* 1375446 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1375530), // Rule ID 22372 //
     /* 1375451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1375468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1375507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375529 */     // GIR_Coverage, 22372,
     /* 1375529 */     GIR_EraseRootFromParent_Done,
     /* 1375530 */   // Label 19548: @1375530
     /* 1375530 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1375614), // Rule ID 22373 //
     /* 1375535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1375552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375588 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1375591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375613 */     // GIR_Coverage, 22373,
     /* 1375613 */     GIR_EraseRootFromParent_Done,
     /* 1375614 */   // Label 19549: @1375614
     /* 1375614 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1375698), // Rule ID 22376 //
     /* 1375619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1375636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1375642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1375675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375697 */     // GIR_Coverage, 22376,
     /* 1375697 */     GIR_EraseRootFromParent_Done,
     /* 1375698 */   // Label 19550: @1375698
     /* 1375698 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1375782), // Rule ID 22377 //
     /* 1375703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1375720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1375726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1375759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375781 */     // GIR_Coverage, 22377,
     /* 1375781 */     GIR_EraseRootFromParent_Done,
     /* 1375782 */   // Label 19551: @1375782
     /* 1375782 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1375866), // Rule ID 22380 //
     /* 1375787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1375804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1375843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375865 */     // GIR_Coverage, 22380,
     /* 1375865 */     GIR_EraseRootFromParent_Done,
     /* 1375866 */   // Label 19552: @1375866
     /* 1375866 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1375950), // Rule ID 22381 //
     /* 1375871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1375888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1375927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375949 */     // GIR_Coverage, 22381,
     /* 1375949 */     GIR_EraseRootFromParent_Done,
     /* 1375950 */   // Label 19553: @1375950
     /* 1375950 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1376034), // Rule ID 22384 //
     /* 1375955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1375972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1376011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376033 */     // GIR_Coverage, 22384,
     /* 1376033 */     GIR_EraseRootFromParent_Done,
     /* 1376034 */   // Label 19554: @1376034
     /* 1376034 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1376118), // Rule ID 22385 //
     /* 1376039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1376056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1376062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376092 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1376095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376117 */     // GIR_Coverage, 22385,
     /* 1376117 */     GIR_EraseRootFromParent_Done,
     /* 1376118 */   // Label 19555: @1376118
     /* 1376118 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1376202), // Rule ID 22388 //
     /* 1376123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1376140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1376146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1376179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376201 */     // GIR_Coverage, 22388,
     /* 1376201 */     GIR_EraseRootFromParent_Done,
     /* 1376202 */   // Label 19556: @1376202
     /* 1376202 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1376286), // Rule ID 22389 //
     /* 1376207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1376224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1376230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1376263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376285 */     // GIR_Coverage, 22389,
     /* 1376285 */     GIR_EraseRootFromParent_Done,
     /* 1376286 */   // Label 19557: @1376286
     /* 1376286 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1376370), // Rule ID 22392 //
     /* 1376291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1376308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1376347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376369 */     // GIR_Coverage, 22392,
     /* 1376369 */     GIR_EraseRootFromParent_Done,
     /* 1376370 */   // Label 19558: @1376370
     /* 1376370 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1376454), // Rule ID 22393 //
     /* 1376375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1376392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1376431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376453 */     // GIR_Coverage, 22393,
     /* 1376453 */     GIR_EraseRootFromParent_Done,
     /* 1376454 */   // Label 19559: @1376454
     /* 1376454 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1376538), // Rule ID 22396 //
     /* 1376459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1376476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376512 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1376515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376537 */     // GIR_Coverage, 22396,
     /* 1376537 */     GIR_EraseRootFromParent_Done,
     /* 1376538 */   // Label 19560: @1376538
     /* 1376538 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1376622), // Rule ID 22397 //
     /* 1376543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1376560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1376599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376621 */     // GIR_Coverage, 22397,
     /* 1376621 */     GIR_EraseRootFromParent_Done,
     /* 1376622 */   // Label 19561: @1376622
     /* 1376622 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1376706), // Rule ID 22400 //
     /* 1376627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1376644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1376650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1376683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376705 */     // GIR_Coverage, 22400,
     /* 1376705 */     GIR_EraseRootFromParent_Done,
     /* 1376706 */   // Label 19562: @1376706
     /* 1376706 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1376790), // Rule ID 22401 //
     /* 1376711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1376728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1376734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1376767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376789 */     // GIR_Coverage, 22401,
     /* 1376789 */     GIR_EraseRootFromParent_Done,
     /* 1376790 */   // Label 19563: @1376790
     /* 1376790 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1376874), // Rule ID 22404 //
     /* 1376795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1376812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1376851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376873 */     // GIR_Coverage, 22404,
     /* 1376873 */     GIR_EraseRootFromParent_Done,
     /* 1376874 */   // Label 19564: @1376874
     /* 1376874 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1376958), // Rule ID 22405 //
     /* 1376879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1376896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1376935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376957 */     // GIR_Coverage, 22405,
     /* 1376957 */     GIR_EraseRootFromParent_Done,
     /* 1376958 */   // Label 19565: @1376958
     /* 1376958 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1377042), // Rule ID 22408 //
     /* 1376963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1376980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1377019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377041 */     // GIR_Coverage, 22408,
     /* 1377041 */     GIR_EraseRootFromParent_Done,
     /* 1377042 */   // Label 19566: @1377042
     /* 1377042 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1377126), // Rule ID 22409 //
     /* 1377047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1377064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1377103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377125 */     // GIR_Coverage, 22409,
     /* 1377125 */     GIR_EraseRootFromParent_Done,
     /* 1377126 */   // Label 19567: @1377126
     /* 1377126 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1377210), // Rule ID 22412 //
     /* 1377131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1377148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1377187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377209 */     // GIR_Coverage, 22412,
     /* 1377209 */     GIR_EraseRootFromParent_Done,
     /* 1377210 */   // Label 19568: @1377210
     /* 1377210 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1377294), // Rule ID 22413 //
     /* 1377215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1377232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1377271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377293 */     // GIR_Coverage, 22413,
     /* 1377293 */     GIR_EraseRootFromParent_Done,
     /* 1377294 */   // Label 19569: @1377294
     /* 1377294 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1377378), // Rule ID 22416 //
     /* 1377299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1377316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1377355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377377 */     // GIR_Coverage, 22416,
     /* 1377377 */     GIR_EraseRootFromParent_Done,
     /* 1377378 */   // Label 19570: @1377378
     /* 1377378 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1377462), // Rule ID 22417 //
     /* 1377383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1377400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1377439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377461 */     // GIR_Coverage, 22417,
     /* 1377461 */     GIR_EraseRootFromParent_Done,
     /* 1377462 */   // Label 19571: @1377462
     /* 1377462 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1377546), // Rule ID 22420 //
     /* 1377467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1377484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1377523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377545 */     // GIR_Coverage, 22420,
     /* 1377545 */     GIR_EraseRootFromParent_Done,
     /* 1377546 */   // Label 19572: @1377546
     /* 1377546 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1377630), // Rule ID 22421 //
     /* 1377551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1377568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1377607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377629 */     // GIR_Coverage, 22421,
     /* 1377629 */     GIR_EraseRootFromParent_Done,
     /* 1377630 */   // Label 19573: @1377630
     /* 1377630 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1377714), // Rule ID 22424 //
     /* 1377635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1377652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1377691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377713 */     // GIR_Coverage, 22424,
     /* 1377713 */     GIR_EraseRootFromParent_Done,
     /* 1377714 */   // Label 19574: @1377714
     /* 1377714 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1377798), // Rule ID 22425 //
     /* 1377719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1377736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1377775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377797 */     // GIR_Coverage, 22425,
     /* 1377797 */     GIR_EraseRootFromParent_Done,
     /* 1377798 */   // Label 19575: @1377798
     /* 1377798 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1377882), // Rule ID 22428 //
     /* 1377803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1377820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377856 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1377859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377881 */     // GIR_Coverage, 22428,
     /* 1377881 */     GIR_EraseRootFromParent_Done,
     /* 1377882 */   // Label 19576: @1377882
     /* 1377882 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1377966), // Rule ID 22429 //
     /* 1377887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1377904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1377943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377965 */     // GIR_Coverage, 22429,
     /* 1377965 */     GIR_EraseRootFromParent_Done,
     /* 1377966 */   // Label 19577: @1377966
     /* 1377966 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1378050), // Rule ID 22432 //
     /* 1377971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1377979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1378027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378049 */     // GIR_Coverage, 22432,
     /* 1378049 */     GIR_EraseRootFromParent_Done,
     /* 1378050 */   // Label 19578: @1378050
     /* 1378050 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1378134), // Rule ID 22433 //
     /* 1378055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1378072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1378078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1378111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378133 */     // GIR_Coverage, 22433,
     /* 1378133 */     GIR_EraseRootFromParent_Done,
     /* 1378134 */   // Label 19579: @1378134
     /* 1378134 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1378218), // Rule ID 22436 //
     /* 1378139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1378156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1378195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378217 */     // GIR_Coverage, 22436,
     /* 1378217 */     GIR_EraseRootFromParent_Done,
     /* 1378218 */   // Label 19580: @1378218
     /* 1378218 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1378302), // Rule ID 22437 //
     /* 1378223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1378240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1378279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378301 */     // GIR_Coverage, 22437,
     /* 1378301 */     GIR_EraseRootFromParent_Done,
     /* 1378302 */   // Label 19581: @1378302
     /* 1378302 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1378386), // Rule ID 22440 //
     /* 1378307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1378324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1378363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378385 */     // GIR_Coverage, 22440,
     /* 1378385 */     GIR_EraseRootFromParent_Done,
     /* 1378386 */   // Label 19582: @1378386
     /* 1378386 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1378470), // Rule ID 22441 //
     /* 1378391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1378408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1378447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378469 */     // GIR_Coverage, 22441,
     /* 1378469 */     GIR_EraseRootFromParent_Done,
     /* 1378470 */   // Label 19583: @1378470
     /* 1378470 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1378554), // Rule ID 22444 //
     /* 1378475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1378492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1378531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378553 */     // GIR_Coverage, 22444,
     /* 1378553 */     GIR_EraseRootFromParent_Done,
     /* 1378554 */   // Label 19584: @1378554
     /* 1378554 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1378638), // Rule ID 22445 //
     /* 1378559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1378576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1378615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378637 */     // GIR_Coverage, 22445,
     /* 1378637 */     GIR_EraseRootFromParent_Done,
     /* 1378638 */   // Label 19585: @1378638
     /* 1378638 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1378722), // Rule ID 22448 //
     /* 1378643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1378660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1378666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1378699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378721 */     // GIR_Coverage, 22448,
     /* 1378721 */     GIR_EraseRootFromParent_Done,
     /* 1378722 */   // Label 19586: @1378722
     /* 1378722 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1378806), // Rule ID 22449 //
     /* 1378727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1378744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1378750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1378783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378805 */     // GIR_Coverage, 22449,
     /* 1378805 */     GIR_EraseRootFromParent_Done,
     /* 1378806 */   // Label 19587: @1378806
     /* 1378806 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1378890), // Rule ID 22452 //
     /* 1378811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1378814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1378822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1378825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1378828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1378831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1378867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1378885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378889 */     // GIR_Coverage, 22452,
     /* 1378889 */     GIR_EraseRootFromParent_Done,
     /* 1378890 */   // Label 19588: @1378890
     /* 1378890 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1378974), // Rule ID 22453 //
     /* 1378895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1378898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1378906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1378909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1378912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1378915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1378951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1378969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378973 */     // GIR_Coverage, 22453,
     /* 1378973 */     GIR_EraseRootFromParent_Done,
     /* 1378974 */   // Label 19589: @1378974
     /* 1378974 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1379058), // Rule ID 22456 //
     /* 1378979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1378987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1379035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379057 */     // GIR_Coverage, 22456,
     /* 1379057 */     GIR_EraseRootFromParent_Done,
     /* 1379058 */   // Label 19590: @1379058
     /* 1379058 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1379142), // Rule ID 22457 //
     /* 1379063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1379080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379116 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1379119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379141 */     // GIR_Coverage, 22457,
     /* 1379141 */     GIR_EraseRootFromParent_Done,
     /* 1379142 */   // Label 19591: @1379142
     /* 1379142 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1379226), // Rule ID 22460 //
     /* 1379147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1379164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1379203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379225 */     // GIR_Coverage, 22460,
     /* 1379225 */     GIR_EraseRootFromParent_Done,
     /* 1379226 */   // Label 19592: @1379226
     /* 1379226 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1379310), // Rule ID 22461 //
     /* 1379231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1379248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1379287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379309 */     // GIR_Coverage, 22461,
     /* 1379309 */     GIR_EraseRootFromParent_Done,
     /* 1379310 */   // Label 19593: @1379310
     /* 1379310 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1379394), // Rule ID 22464 //
     /* 1379315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1379332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1379338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1379371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379393 */     // GIR_Coverage, 22464,
     /* 1379393 */     GIR_EraseRootFromParent_Done,
     /* 1379394 */   // Label 19594: @1379394
     /* 1379394 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1379478), // Rule ID 22465 //
     /* 1379399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1379416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1379422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1379455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379477 */     // GIR_Coverage, 22465,
     /* 1379477 */     GIR_EraseRootFromParent_Done,
     /* 1379478 */   // Label 19595: @1379478
     /* 1379478 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1379562), // Rule ID 22468 //
     /* 1379483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1379500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1379539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379561 */     // GIR_Coverage, 22468,
     /* 1379561 */     GIR_EraseRootFromParent_Done,
     /* 1379562 */   // Label 19596: @1379562
     /* 1379562 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1379646), // Rule ID 22469 //
     /* 1379567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1379584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1379623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379645 */     // GIR_Coverage, 22469,
     /* 1379645 */     GIR_EraseRootFromParent_Done,
     /* 1379646 */   // Label 19597: @1379646
     /* 1379646 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1379730), // Rule ID 22472 //
     /* 1379651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1379668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1379707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379729 */     // GIR_Coverage, 22472,
     /* 1379729 */     GIR_EraseRootFromParent_Done,
     /* 1379730 */   // Label 19598: @1379730
     /* 1379730 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1379814), // Rule ID 22473 //
     /* 1379735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1379752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1379791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379813 */     // GIR_Coverage, 22473,
     /* 1379813 */     GIR_EraseRootFromParent_Done,
     /* 1379814 */   // Label 19599: @1379814
     /* 1379814 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1379898), // Rule ID 22476 //
     /* 1379819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1379875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379897 */     // GIR_Coverage, 22476,
     /* 1379897 */     GIR_EraseRootFromParent_Done,
     /* 1379898 */   // Label 19600: @1379898
     /* 1379898 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1379982), // Rule ID 22477 //
     /* 1379903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1379959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379981 */     // GIR_Coverage, 22477,
     /* 1379981 */     GIR_EraseRootFromParent_Done,
     /* 1379982 */   // Label 19601: @1379982
     /* 1379982 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1380066), // Rule ID 22480 //
     /* 1379987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1380004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1380025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1380043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380065 */     // GIR_Coverage, 22480,
     /* 1380065 */     GIR_EraseRootFromParent_Done,
     /* 1380066 */   // Label 19602: @1380066
     /* 1380066 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1380150), // Rule ID 22481 //
     /* 1380071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1380088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1380109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1380127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380149 */     // GIR_Coverage, 22481,
     /* 1380149 */     GIR_EraseRootFromParent_Done,
     /* 1380150 */   // Label 19603: @1380150
     /* 1380150 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1380234), // Rule ID 22484 //
     /* 1380155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1380172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1380211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380233 */     // GIR_Coverage, 22484,
     /* 1380233 */     GIR_EraseRootFromParent_Done,
     /* 1380234 */   // Label 19604: @1380234
     /* 1380234 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1380318), // Rule ID 22485 //
     /* 1380239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1380256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1380295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380317 */     // GIR_Coverage, 22485,
     /* 1380317 */     GIR_EraseRootFromParent_Done,
     /* 1380318 */   // Label 19605: @1380318
     /* 1380318 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1380402), // Rule ID 22488 //
     /* 1380323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1380340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1380346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1380379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380401 */     // GIR_Coverage, 22488,
     /* 1380401 */     GIR_EraseRootFromParent_Done,
     /* 1380402 */   // Label 19606: @1380402
     /* 1380402 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1380486), // Rule ID 22489 //
     /* 1380407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1380424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1380430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1380463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380485 */     // GIR_Coverage, 22489,
     /* 1380485 */     GIR_EraseRootFromParent_Done,
     /* 1380486 */   // Label 19607: @1380486
     /* 1380486 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1380570), // Rule ID 22492 //
     /* 1380491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1380508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1380529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1380547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380569 */     // GIR_Coverage, 22492,
     /* 1380569 */     GIR_EraseRootFromParent_Done,
     /* 1380570 */   // Label 19608: @1380570
     /* 1380570 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1380654), // Rule ID 22493 //
     /* 1380575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1380592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1380613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1380631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380653 */     // GIR_Coverage, 22493,
     /* 1380653 */     GIR_EraseRootFromParent_Done,
     /* 1380654 */   // Label 19609: @1380654
     /* 1380654 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1380738), // Rule ID 22496 //
     /* 1380659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1380715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380737 */     // GIR_Coverage, 22496,
     /* 1380737 */     GIR_EraseRootFromParent_Done,
     /* 1380738 */   // Label 19610: @1380738
     /* 1380738 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1380822), // Rule ID 22497 //
     /* 1380743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1380799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380821 */     // GIR_Coverage, 22497,
     /* 1380821 */     GIR_EraseRootFromParent_Done,
     /* 1380822 */   // Label 19611: @1380822
     /* 1380822 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1380906), // Rule ID 22500 //
     /* 1380827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380880 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1380883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380905 */     // GIR_Coverage, 22500,
     /* 1380905 */     GIR_EraseRootFromParent_Done,
     /* 1380906 */   // Label 19612: @1380906
     /* 1380906 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1380990), // Rule ID 22501 //
     /* 1380911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1380967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380989 */     // GIR_Coverage, 22501,
     /* 1380989 */     GIR_EraseRootFromParent_Done,
     /* 1380990 */   // Label 19613: @1380990
     /* 1380990 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1381074), // Rule ID 22504 //
     /* 1380995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1381012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1381051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381073 */     // GIR_Coverage, 22504,
     /* 1381073 */     GIR_EraseRootFromParent_Done,
     /* 1381074 */   // Label 19614: @1381074
     /* 1381074 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1381158), // Rule ID 22505 //
     /* 1381079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1381096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1381135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381157 */     // GIR_Coverage, 22505,
     /* 1381157 */     GIR_EraseRootFromParent_Done,
     /* 1381158 */   // Label 19615: @1381158
     /* 1381158 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1381242), // Rule ID 22508 //
     /* 1381163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1381180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1381219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381241 */     // GIR_Coverage, 22508,
     /* 1381241 */     GIR_EraseRootFromParent_Done,
     /* 1381242 */   // Label 19616: @1381242
     /* 1381242 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1381326), // Rule ID 22509 //
     /* 1381247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1381264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1381303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381325 */     // GIR_Coverage, 22509,
     /* 1381325 */     GIR_EraseRootFromParent_Done,
     /* 1381326 */   // Label 19617: @1381326
     /* 1381326 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1381410), // Rule ID 22512 //
     /* 1381331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1381348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1381387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381409 */     // GIR_Coverage, 22512,
     /* 1381409 */     GIR_EraseRootFromParent_Done,
     /* 1381410 */   // Label 19618: @1381410
     /* 1381410 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1381494), // Rule ID 22513 //
     /* 1381415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1381432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381468 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1381471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381493 */     // GIR_Coverage, 22513,
     /* 1381493 */     GIR_EraseRootFromParent_Done,
     /* 1381494 */   // Label 19619: @1381494
     /* 1381494 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1381578), // Rule ID 22516 //
     /* 1381499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1381516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1381555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381577 */     // GIR_Coverage, 22516,
     /* 1381577 */     GIR_EraseRootFromParent_Done,
     /* 1381578 */   // Label 19620: @1381578
     /* 1381578 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1381662), // Rule ID 22517 //
     /* 1381583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1381600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1381639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381661 */     // GIR_Coverage, 22517,
     /* 1381661 */     GIR_EraseRootFromParent_Done,
     /* 1381662 */   // Label 19621: @1381662
     /* 1381662 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1381746), // Rule ID 22520 //
     /* 1381667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1381684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1381723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381745 */     // GIR_Coverage, 22520,
     /* 1381745 */     GIR_EraseRootFromParent_Done,
     /* 1381746 */   // Label 19622: @1381746
     /* 1381746 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1381830), // Rule ID 22521 //
     /* 1381751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1381768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1381807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381829 */     // GIR_Coverage, 22521,
     /* 1381829 */     GIR_EraseRootFromParent_Done,
     /* 1381830 */   // Label 19623: @1381830
     /* 1381830 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1381914), // Rule ID 22524 //
     /* 1381835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1381852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1381891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381913 */     // GIR_Coverage, 22524,
     /* 1381913 */     GIR_EraseRootFromParent_Done,
     /* 1381914 */   // Label 19624: @1381914
     /* 1381914 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1381998), // Rule ID 22525 //
     /* 1381919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1381927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1381936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1381975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381997 */     // GIR_Coverage, 22525,
     /* 1381997 */     GIR_EraseRootFromParent_Done,
     /* 1381998 */   // Label 19625: @1381998
     /* 1381998 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1382082), // Rule ID 22528 //
     /* 1382003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1382020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382056 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1382059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382081 */     // GIR_Coverage, 22528,
     /* 1382081 */     GIR_EraseRootFromParent_Done,
     /* 1382082 */   // Label 19626: @1382082
     /* 1382082 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1382166), // Rule ID 22529 //
     /* 1382087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1382104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1382143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382165 */     // GIR_Coverage, 22529,
     /* 1382165 */     GIR_EraseRootFromParent_Done,
     /* 1382166 */   // Label 19627: @1382166
     /* 1382166 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1382250), // Rule ID 22532 //
     /* 1382171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1382188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1382227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382249 */     // GIR_Coverage, 22532,
     /* 1382249 */     GIR_EraseRootFromParent_Done,
     /* 1382250 */   // Label 19628: @1382250
     /* 1382250 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1382334), // Rule ID 22533 //
     /* 1382255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1382272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1382311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382333 */     // GIR_Coverage, 22533,
     /* 1382333 */     GIR_EraseRootFromParent_Done,
     /* 1382334 */   // Label 19629: @1382334
     /* 1382334 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1382418), // Rule ID 22536 //
     /* 1382339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1382356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1382395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382417 */     // GIR_Coverage, 22536,
     /* 1382417 */     GIR_EraseRootFromParent_Done,
     /* 1382418 */   // Label 19630: @1382418
     /* 1382418 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1382502), // Rule ID 22537 //
     /* 1382423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1382440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1382479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382501 */     // GIR_Coverage, 22537,
     /* 1382501 */     GIR_EraseRootFromParent_Done,
     /* 1382502 */   // Label 19631: @1382502
     /* 1382502 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1382586), // Rule ID 22540 //
     /* 1382507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1382524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1382530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1382563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382585 */     // GIR_Coverage, 22540,
     /* 1382585 */     GIR_EraseRootFromParent_Done,
     /* 1382586 */   // Label 19632: @1382586
     /* 1382586 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1382670), // Rule ID 22541 //
     /* 1382591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1382608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1382614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1382647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382669 */     // GIR_Coverage, 22541,
     /* 1382669 */     GIR_EraseRootFromParent_Done,
     /* 1382670 */   // Label 19633: @1382670
     /* 1382670 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1382754), // Rule ID 22544 //
     /* 1382675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1382692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1382731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382753 */     // GIR_Coverage, 22544,
     /* 1382753 */     GIR_EraseRootFromParent_Done,
     /* 1382754 */   // Label 19634: @1382754
     /* 1382754 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1382838), // Rule ID 22545 //
     /* 1382759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1382776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1382815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382837 */     // GIR_Coverage, 22545,
     /* 1382837 */     GIR_EraseRootFromParent_Done,
     /* 1382838 */   // Label 19635: @1382838
     /* 1382838 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1382922), // Rule ID 22548 //
     /* 1382843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1382860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1382899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382921 */     // GIR_Coverage, 22548,
     /* 1382921 */     GIR_EraseRootFromParent_Done,
     /* 1382922 */   // Label 19636: @1382922
     /* 1382922 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1383006), // Rule ID 22549 //
     /* 1382927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1382935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1382944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1382983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383005 */     // GIR_Coverage, 22549,
     /* 1383005 */     GIR_EraseRootFromParent_Done,
     /* 1383006 */   // Label 19637: @1383006
     /* 1383006 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1383090), // Rule ID 22552 //
     /* 1383011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1383028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1383034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1383067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383089 */     // GIR_Coverage, 22552,
     /* 1383089 */     GIR_EraseRootFromParent_Done,
     /* 1383090 */   // Label 19638: @1383090
     /* 1383090 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1383174), // Rule ID 22553 //
     /* 1383095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1383112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1383118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1383151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383173 */     // GIR_Coverage, 22553,
     /* 1383173 */     GIR_EraseRootFromParent_Done,
     /* 1383174 */   // Label 19639: @1383174
     /* 1383174 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1383258), // Rule ID 22556 //
     /* 1383179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1383196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1383235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383257 */     // GIR_Coverage, 22556,
     /* 1383257 */     GIR_EraseRootFromParent_Done,
     /* 1383258 */   // Label 19640: @1383258
     /* 1383258 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1383342), // Rule ID 22557 //
     /* 1383263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1383280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1383319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383341 */     // GIR_Coverage, 22557,
     /* 1383341 */     GIR_EraseRootFromParent_Done,
     /* 1383342 */   // Label 19641: @1383342
     /* 1383342 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1383426), // Rule ID 22560 //
     /* 1383347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1383364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1383403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383425 */     // GIR_Coverage, 22560,
     /* 1383425 */     GIR_EraseRootFromParent_Done,
     /* 1383426 */   // Label 19642: @1383426
     /* 1383426 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1383510), // Rule ID 22561 //
     /* 1383431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1383448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1383487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383509 */     // GIR_Coverage, 22561,
     /* 1383509 */     GIR_EraseRootFromParent_Done,
     /* 1383510 */   // Label 19643: @1383510
     /* 1383510 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1383594), // Rule ID 22564 //
     /* 1383515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1383532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1383538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1383571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383593 */     // GIR_Coverage, 22564,
     /* 1383593 */     GIR_EraseRootFromParent_Done,
     /* 1383594 */   // Label 19644: @1383594
     /* 1383594 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1383678), // Rule ID 22565 //
     /* 1383599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1383616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1383622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1383655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383677 */     // GIR_Coverage, 22565,
     /* 1383677 */     GIR_EraseRootFromParent_Done,
     /* 1383678 */   // Label 19645: @1383678
     /* 1383678 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1383762), // Rule ID 22568 //
     /* 1383683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1383700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1383739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383761 */     // GIR_Coverage, 22568,
     /* 1383761 */     GIR_EraseRootFromParent_Done,
     /* 1383762 */   // Label 19646: @1383762
     /* 1383762 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1383846), // Rule ID 22569 //
     /* 1383767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1383784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1383823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383845 */     // GIR_Coverage, 22569,
     /* 1383845 */     GIR_EraseRootFromParent_Done,
     /* 1383846 */   // Label 19647: @1383846
     /* 1383846 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1383930), // Rule ID 22572 //
     /* 1383851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1383868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1383907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383929 */     // GIR_Coverage, 22572,
     /* 1383929 */     GIR_EraseRootFromParent_Done,
     /* 1383930 */   // Label 19648: @1383930
     /* 1383930 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1384014), // Rule ID 22573 //
     /* 1383935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1383952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1383991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384013 */     // GIR_Coverage, 22573,
     /* 1384013 */     GIR_EraseRootFromParent_Done,
     /* 1384014 */   // Label 19649: @1384014
     /* 1384014 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1384098), // Rule ID 22576 //
     /* 1384019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1384036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1384075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384097 */     // GIR_Coverage, 22576,
     /* 1384097 */     GIR_EraseRootFromParent_Done,
     /* 1384098 */   // Label 19650: @1384098
     /* 1384098 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1384182), // Rule ID 22577 //
     /* 1384103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1384120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1384159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384181 */     // GIR_Coverage, 22577,
     /* 1384181 */     GIR_EraseRootFromParent_Done,
     /* 1384182 */   // Label 19651: @1384182
     /* 1384182 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1384266), // Rule ID 22580 //
     /* 1384187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1384204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1384243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384265 */     // GIR_Coverage, 22580,
     /* 1384265 */     GIR_EraseRootFromParent_Done,
     /* 1384266 */   // Label 19652: @1384266
     /* 1384266 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1384350), // Rule ID 22581 //
     /* 1384271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1384288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1384327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384349 */     // GIR_Coverage, 22581,
     /* 1384349 */     GIR_EraseRootFromParent_Done,
     /* 1384350 */   // Label 19653: @1384350
     /* 1384350 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1384434), // Rule ID 22584 //
     /* 1384355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1384372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1384411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384433 */     // GIR_Coverage, 22584,
     /* 1384433 */     GIR_EraseRootFromParent_Done,
     /* 1384434 */   // Label 19654: @1384434
     /* 1384434 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1384518), // Rule ID 22585 //
     /* 1384439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1384456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1384477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1384495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384517 */     // GIR_Coverage, 22585,
     /* 1384517 */     GIR_EraseRootFromParent_Done,
     /* 1384518 */   // Label 19655: @1384518
     /* 1384518 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1384602), // Rule ID 22588 //
     /* 1384523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1384540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1384579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384601 */     // GIR_Coverage, 22588,
     /* 1384601 */     GIR_EraseRootFromParent_Done,
     /* 1384602 */   // Label 19656: @1384602
     /* 1384602 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1384686), // Rule ID 22589 //
     /* 1384607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1384624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1384645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1384663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384685 */     // GIR_Coverage, 22589,
     /* 1384685 */     GIR_EraseRootFromParent_Done,
     /* 1384686 */   // Label 19657: @1384686
     /* 1384686 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1384770), // Rule ID 22592 //
     /* 1384691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1384699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1384708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1384747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384769 */     // GIR_Coverage, 22592,
     /* 1384769 */     GIR_EraseRootFromParent_Done,
     /* 1384770 */   // Label 19658: @1384770
     /* 1384770 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1384854), // Rule ID 22593 //
     /* 1384775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1384783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1384792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1384831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384853 */     // GIR_Coverage, 22593,
     /* 1384853 */     GIR_EraseRootFromParent_Done,
     /* 1384854 */   // Label 19659: @1384854
     /* 1384854 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1384938), // Rule ID 22596 //
     /* 1384859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1384867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1384876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1384915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384937 */     // GIR_Coverage, 22596,
     /* 1384937 */     GIR_EraseRootFromParent_Done,
     /* 1384938 */   // Label 19660: @1384938
     /* 1384938 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1385022), // Rule ID 22597 //
     /* 1384943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1384951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1384960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1384999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385021 */     // GIR_Coverage, 22597,
     /* 1385021 */     GIR_EraseRootFromParent_Done,
     /* 1385022 */   // Label 19661: @1385022
     /* 1385022 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1385106), // Rule ID 22600 //
     /* 1385027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1385044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385080 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1385083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385105 */     // GIR_Coverage, 22600,
     /* 1385105 */     GIR_EraseRootFromParent_Done,
     /* 1385106 */   // Label 19662: @1385106
     /* 1385106 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1385190), // Rule ID 22601 //
     /* 1385111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1385128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1385167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385189 */     // GIR_Coverage, 22601,
     /* 1385189 */     GIR_EraseRootFromParent_Done,
     /* 1385190 */   // Label 19663: @1385190
     /* 1385190 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1385274), // Rule ID 22604 //
     /* 1385195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1385212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1385251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385273 */     // GIR_Coverage, 22604,
     /* 1385273 */     GIR_EraseRootFromParent_Done,
     /* 1385274 */   // Label 19664: @1385274
     /* 1385274 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1385358), // Rule ID 22605 //
     /* 1385279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1385296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385332 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1385335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385357 */     // GIR_Coverage, 22605,
     /* 1385357 */     GIR_EraseRootFromParent_Done,
     /* 1385358 */   // Label 19665: @1385358
     /* 1385358 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1385442), // Rule ID 22608 //
     /* 1385363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1385380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1385419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385441 */     // GIR_Coverage, 22608,
     /* 1385441 */     GIR_EraseRootFromParent_Done,
     /* 1385442 */   // Label 19666: @1385442
     /* 1385442 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1385526), // Rule ID 22609 //
     /* 1385447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1385464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1385503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385525 */     // GIR_Coverage, 22609,
     /* 1385525 */     GIR_EraseRootFromParent_Done,
     /* 1385526 */   // Label 19667: @1385526
     /* 1385526 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1385610), // Rule ID 22612 //
     /* 1385531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1385548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1385587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385609 */     // GIR_Coverage, 22612,
     /* 1385609 */     GIR_EraseRootFromParent_Done,
     /* 1385610 */   // Label 19668: @1385610
     /* 1385610 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1385694), // Rule ID 22613 //
     /* 1385615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1385632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1385638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1385671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385693 */     // GIR_Coverage, 22613,
     /* 1385693 */     GIR_EraseRootFromParent_Done,
     /* 1385694 */   // Label 19669: @1385694
     /* 1385694 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1385778), // Rule ID 22616 //
     /* 1385699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1385716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1385755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385777 */     // GIR_Coverage, 22616,
     /* 1385777 */     GIR_EraseRootFromParent_Done,
     /* 1385778 */   // Label 19670: @1385778
     /* 1385778 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1385862), // Rule ID 22617 //
     /* 1385783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1385800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1385839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385861 */     // GIR_Coverage, 22617,
     /* 1385861 */     GIR_EraseRootFromParent_Done,
     /* 1385862 */   // Label 19671: @1385862
     /* 1385862 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1385946), // Rule ID 22620 //
     /* 1385867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1385884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1385923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385945 */     // GIR_Coverage, 22620,
     /* 1385945 */     GIR_EraseRootFromParent_Done,
     /* 1385946 */   // Label 19672: @1385946
     /* 1385946 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1386030), // Rule ID 22621 //
     /* 1385951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1385959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1385968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386004 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1386007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386029 */     // GIR_Coverage, 22621,
     /* 1386029 */     GIR_EraseRootFromParent_Done,
     /* 1386030 */   // Label 19673: @1386030
     /* 1386030 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1386114), // Rule ID 22624 //
     /* 1386035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1386052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386088 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1386091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386113 */     // GIR_Coverage, 22624,
     /* 1386113 */     GIR_EraseRootFromParent_Done,
     /* 1386114 */   // Label 19674: @1386114
     /* 1386114 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1386198), // Rule ID 22625 //
     /* 1386119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1386136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1386175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386197 */     // GIR_Coverage, 22625,
     /* 1386197 */     GIR_EraseRootFromParent_Done,
     /* 1386198 */   // Label 19675: @1386198
     /* 1386198 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1386282), // Rule ID 22628 //
     /* 1386203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1386220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1386259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386281 */     // GIR_Coverage, 22628,
     /* 1386281 */     GIR_EraseRootFromParent_Done,
     /* 1386282 */   // Label 19676: @1386282
     /* 1386282 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1386366), // Rule ID 22629 //
     /* 1386287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1386304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1386343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386365 */     // GIR_Coverage, 22629,
     /* 1386365 */     GIR_EraseRootFromParent_Done,
     /* 1386366 */   // Label 19677: @1386366
     /* 1386366 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1386450), // Rule ID 22632 //
     /* 1386371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1386388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1386427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386449 */     // GIR_Coverage, 22632,
     /* 1386449 */     GIR_EraseRootFromParent_Done,
     /* 1386450 */   // Label 19678: @1386450
     /* 1386450 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1386534), // Rule ID 22633 //
     /* 1386455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1386472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1386511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386533 */     // GIR_Coverage, 22633,
     /* 1386533 */     GIR_EraseRootFromParent_Done,
     /* 1386534 */   // Label 19679: @1386534
     /* 1386534 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1386618), // Rule ID 22636 //
     /* 1386539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1386556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1386595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386617 */     // GIR_Coverage, 22636,
     /* 1386617 */     GIR_EraseRootFromParent_Done,
     /* 1386618 */   // Label 19680: @1386618
     /* 1386618 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1386702), // Rule ID 22637 //
     /* 1386623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1386640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1386679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386701 */     // GIR_Coverage, 22637,
     /* 1386701 */     GIR_EraseRootFromParent_Done,
     /* 1386702 */   // Label 19681: @1386702
     /* 1386702 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1386786), // Rule ID 22640 //
     /* 1386707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1386724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1386730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1386763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386785 */     // GIR_Coverage, 22640,
     /* 1386785 */     GIR_EraseRootFromParent_Done,
     /* 1386786 */   // Label 19682: @1386786
     /* 1386786 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1386870), // Rule ID 22641 //
     /* 1386791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1386808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1386814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1386847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386869 */     // GIR_Coverage, 22641,
     /* 1386869 */     GIR_EraseRootFromParent_Done,
     /* 1386870 */   // Label 19683: @1386870
     /* 1386870 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1386954), // Rule ID 22644 //
     /* 1386875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1386892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1386931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386953 */     // GIR_Coverage, 22644,
     /* 1386953 */     GIR_EraseRootFromParent_Done,
     /* 1386954 */   // Label 19684: @1386954
     /* 1386954 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1387038), // Rule ID 22645 //
     /* 1386959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1386970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1386973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1386976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1386979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387012 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1387015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387037 */     // GIR_Coverage, 22645,
     /* 1387037 */     GIR_EraseRootFromParent_Done,
     /* 1387038 */   // Label 19685: @1387038
     /* 1387038 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1387122), // Rule ID 22648 //
     /* 1387043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1387060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1387066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1387099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387121 */     // GIR_Coverage, 22648,
     /* 1387121 */     GIR_EraseRootFromParent_Done,
     /* 1387122 */   // Label 19686: @1387122
     /* 1387122 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1387206), // Rule ID 22649 //
     /* 1387127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1387144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1387150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1387183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387205 */     // GIR_Coverage, 22649,
     /* 1387205 */     GIR_EraseRootFromParent_Done,
     /* 1387206 */   // Label 19687: @1387206
     /* 1387206 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1387290), // Rule ID 22652 //
     /* 1387211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1387228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1387234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1387267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387289 */     // GIR_Coverage, 22652,
     /* 1387289 */     GIR_EraseRootFromParent_Done,
     /* 1387290 */   // Label 19688: @1387290
     /* 1387290 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1387374), // Rule ID 22653 //
     /* 1387295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1387312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1387318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1387351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387373 */     // GIR_Coverage, 22653,
     /* 1387373 */     GIR_EraseRootFromParent_Done,
     /* 1387374 */   // Label 19689: @1387374
     /* 1387374 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1387458), // Rule ID 22656 //
     /* 1387379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1387396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1387417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1387435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387457 */     // GIR_Coverage, 22656,
     /* 1387457 */     GIR_EraseRootFromParent_Done,
     /* 1387458 */   // Label 19690: @1387458
     /* 1387458 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1387542), // Rule ID 22657 //
     /* 1387463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1387480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1387501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1387519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387541 */     // GIR_Coverage, 22657,
     /* 1387541 */     GIR_EraseRootFromParent_Done,
     /* 1387542 */   // Label 19691: @1387542
     /* 1387542 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1387626), // Rule ID 22660 //
     /* 1387547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1387564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1387603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387625 */     // GIR_Coverage, 22660,
     /* 1387625 */     GIR_EraseRootFromParent_Done,
     /* 1387626 */   // Label 19692: @1387626
     /* 1387626 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1387710), // Rule ID 22661 //
     /* 1387631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1387648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1387669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1387687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387709 */     // GIR_Coverage, 22661,
     /* 1387709 */     GIR_EraseRootFromParent_Done,
     /* 1387710 */   // Label 19693: @1387710
     /* 1387710 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1387794), // Rule ID 22664 //
     /* 1387715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1387732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1387738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1387771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387793 */     // GIR_Coverage, 22664,
     /* 1387793 */     GIR_EraseRootFromParent_Done,
     /* 1387794 */   // Label 19694: @1387794
     /* 1387794 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1387878), // Rule ID 22665 //
     /* 1387799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1387816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1387822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1387855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387877 */     // GIR_Coverage, 22665,
     /* 1387877 */     GIR_EraseRootFromParent_Done,
     /* 1387878 */   // Label 19695: @1387878
     /* 1387878 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1387962), // Rule ID 22668 //
     /* 1387883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1387886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1387900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1387921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1387939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1387957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387961 */     // GIR_Coverage, 22668,
     /* 1387961 */     GIR_EraseRootFromParent_Done,
     /* 1387962 */   // Label 19696: @1387962
     /* 1387962 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1388046), // Rule ID 22669 //
     /* 1387967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1387970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1387984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1388023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388045 */     // GIR_Coverage, 22669,
     /* 1388045 */     GIR_EraseRootFromParent_Done,
     /* 1388046 */   // Label 19697: @1388046
     /* 1388046 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1388130), // Rule ID 22672 //
     /* 1388051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1388068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1388107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388129 */     // GIR_Coverage, 22672,
     /* 1388129 */     GIR_EraseRootFromParent_Done,
     /* 1388130 */   // Label 19698: @1388130
     /* 1388130 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1388214), // Rule ID 22673 //
     /* 1388135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1388152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1388191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388213 */     // GIR_Coverage, 22673,
     /* 1388213 */     GIR_EraseRootFromParent_Done,
     /* 1388214 */   // Label 19699: @1388214
     /* 1388214 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1388298), // Rule ID 22676 //
     /* 1388219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1388236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1388275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388297 */     // GIR_Coverage, 22676,
     /* 1388297 */     GIR_EraseRootFromParent_Done,
     /* 1388298 */   // Label 19700: @1388298
     /* 1388298 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1388382), // Rule ID 22677 //
     /* 1388303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1388320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1388359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388381 */     // GIR_Coverage, 22677,
     /* 1388381 */     GIR_EraseRootFromParent_Done,
     /* 1388382 */   // Label 19701: @1388382
     /* 1388382 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1388466), // Rule ID 22680 //
     /* 1388387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1388404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1388443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388465 */     // GIR_Coverage, 22680,
     /* 1388465 */     GIR_EraseRootFromParent_Done,
     /* 1388466 */   // Label 19702: @1388466
     /* 1388466 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1388550), // Rule ID 22681 //
     /* 1388471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1388488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1388527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388549 */     // GIR_Coverage, 22681,
     /* 1388549 */     GIR_EraseRootFromParent_Done,
     /* 1388550 */   // Label 19703: @1388550
     /* 1388550 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1388634), // Rule ID 22684 //
     /* 1388555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1388572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1388611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388633 */     // GIR_Coverage, 22684,
     /* 1388633 */     GIR_EraseRootFromParent_Done,
     /* 1388634 */   // Label 19704: @1388634
     /* 1388634 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1388718), // Rule ID 22685 //
     /* 1388639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1388656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1388695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388717 */     // GIR_Coverage, 22685,
     /* 1388717 */     GIR_EraseRootFromParent_Done,
     /* 1388718 */   // Label 19705: @1388718
     /* 1388718 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1388802), // Rule ID 22688 //
     /* 1388723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1388740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1388779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388801 */     // GIR_Coverage, 22688,
     /* 1388801 */     GIR_EraseRootFromParent_Done,
     /* 1388802 */   // Label 19706: @1388802
     /* 1388802 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1388886), // Rule ID 22689 //
     /* 1388807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1388824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1388863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388885 */     // GIR_Coverage, 22689,
     /* 1388885 */     GIR_EraseRootFromParent_Done,
     /* 1388886 */   // Label 19707: @1388886
     /* 1388886 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1388970), // Rule ID 22692 //
     /* 1388891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1388908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1388947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388969 */     // GIR_Coverage, 22692,
     /* 1388969 */     GIR_EraseRootFromParent_Done,
     /* 1388970 */   // Label 19708: @1388970
     /* 1388970 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1389054), // Rule ID 22693 //
     /* 1388975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1388983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1388992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1389031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389053 */     // GIR_Coverage, 22693,
     /* 1389053 */     GIR_EraseRootFromParent_Done,
     /* 1389054 */   // Label 19709: @1389054
     /* 1389054 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1389138), // Rule ID 22696 //
     /* 1389059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1389076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1389082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1389115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389137 */     // GIR_Coverage, 22696,
     /* 1389137 */     GIR_EraseRootFromParent_Done,
     /* 1389138 */   // Label 19710: @1389138
     /* 1389138 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1389222), // Rule ID 22697 //
     /* 1389143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1389160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1389166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1389199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389221 */     // GIR_Coverage, 22697,
     /* 1389221 */     GIR_EraseRootFromParent_Done,
     /* 1389222 */   // Label 19711: @1389222
     /* 1389222 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1389306), // Rule ID 22700 //
     /* 1389227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1389244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1389250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1389283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389305 */     // GIR_Coverage, 22700,
     /* 1389305 */     GIR_EraseRootFromParent_Done,
     /* 1389306 */   // Label 19712: @1389306
     /* 1389306 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1389390), // Rule ID 22701 //
     /* 1389311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1389328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1389334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389364 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1389367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389389 */     // GIR_Coverage, 22701,
     /* 1389389 */     GIR_EraseRootFromParent_Done,
     /* 1389390 */   // Label 19713: @1389390
     /* 1389390 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1389474), // Rule ID 22704 //
     /* 1389395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1389412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1389451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389473 */     // GIR_Coverage, 22704,
     /* 1389473 */     GIR_EraseRootFromParent_Done,
     /* 1389474 */   // Label 19714: @1389474
     /* 1389474 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1389558), // Rule ID 22705 //
     /* 1389479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1389496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1389535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389557 */     // GIR_Coverage, 22705,
     /* 1389557 */     GIR_EraseRootFromParent_Done,
     /* 1389558 */   // Label 19715: @1389558
     /* 1389558 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1389642), // Rule ID 22708 //
     /* 1389563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1389580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1389619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389641 */     // GIR_Coverage, 22708,
     /* 1389641 */     GIR_EraseRootFromParent_Done,
     /* 1389642 */   // Label 19716: @1389642
     /* 1389642 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1389726), // Rule ID 22709 //
     /* 1389647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1389664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1389703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389725 */     // GIR_Coverage, 22709,
     /* 1389725 */     GIR_EraseRootFromParent_Done,
     /* 1389726 */   // Label 19717: @1389726
     /* 1389726 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1389810), // Rule ID 22712 //
     /* 1389731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1389748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1389754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1389787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389809 */     // GIR_Coverage, 22712,
     /* 1389809 */     GIR_EraseRootFromParent_Done,
     /* 1389810 */   // Label 19718: @1389810
     /* 1389810 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1389894), // Rule ID 22713 //
     /* 1389815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1389832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1389838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389868 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1389871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389893 */     // GIR_Coverage, 22713,
     /* 1389893 */     GIR_EraseRootFromParent_Done,
     /* 1389894 */   // Label 19719: @1389894
     /* 1389894 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1389978), // Rule ID 22716 //
     /* 1389899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1389916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1389955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389977 */     // GIR_Coverage, 22716,
     /* 1389977 */     GIR_EraseRootFromParent_Done,
     /* 1389978 */   // Label 19720: @1389978
     /* 1389978 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1390062), // Rule ID 22717 //
     /* 1389983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1389991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1390000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390036 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1390039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390061 */     // GIR_Coverage, 22717,
     /* 1390061 */     GIR_EraseRootFromParent_Done,
     /* 1390062 */   // Label 19721: @1390062
     /* 1390062 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1390146), // Rule ID 22720 //
     /* 1390067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1390084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1390123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390145 */     // GIR_Coverage, 22720,
     /* 1390145 */     GIR_EraseRootFromParent_Done,
     /* 1390146 */   // Label 19722: @1390146
     /* 1390146 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1390230), // Rule ID 22721 //
     /* 1390151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1390168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1390207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390229 */     // GIR_Coverage, 22721,
     /* 1390229 */     GIR_EraseRootFromParent_Done,
     /* 1390230 */   // Label 19723: @1390230
     /* 1390230 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1390314), // Rule ID 22724 //
     /* 1390235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1390252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1390258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1390291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390313 */     // GIR_Coverage, 22724,
     /* 1390313 */     GIR_EraseRootFromParent_Done,
     /* 1390314 */   // Label 19724: @1390314
     /* 1390314 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1390398), // Rule ID 22725 //
     /* 1390319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1390336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1390342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1390375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390397 */     // GIR_Coverage, 22725,
     /* 1390397 */     GIR_EraseRootFromParent_Done,
     /* 1390398 */   // Label 19725: @1390398
     /* 1390398 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1390482), // Rule ID 22728 //
     /* 1390403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1390420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1390459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390481 */     // GIR_Coverage, 22728,
     /* 1390481 */     GIR_EraseRootFromParent_Done,
     /* 1390482 */   // Label 19726: @1390482
     /* 1390482 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1390566), // Rule ID 22729 //
     /* 1390487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1390504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1390543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390565 */     // GIR_Coverage, 22729,
     /* 1390565 */     GIR_EraseRootFromParent_Done,
     /* 1390566 */   // Label 19727: @1390566
     /* 1390566 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1390650), // Rule ID 22732 //
     /* 1390571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1390588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1390627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390649 */     // GIR_Coverage, 22732,
     /* 1390649 */     GIR_EraseRootFromParent_Done,
     /* 1390650 */   // Label 19728: @1390650
     /* 1390650 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1390734), // Rule ID 22733 //
     /* 1390655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1390672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1390711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390733 */     // GIR_Coverage, 22733,
     /* 1390733 */     GIR_EraseRootFromParent_Done,
     /* 1390734 */   // Label 19729: @1390734
     /* 1390734 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1390818), // Rule ID 22736 //
     /* 1390739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1390756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1390795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390817 */     // GIR_Coverage, 22736,
     /* 1390817 */     GIR_EraseRootFromParent_Done,
     /* 1390818 */   // Label 19730: @1390818
     /* 1390818 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1390902), // Rule ID 22737 //
     /* 1390823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1390840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1390846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1390879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390901 */     // GIR_Coverage, 22737,
     /* 1390901 */     GIR_EraseRootFromParent_Done,
     /* 1390902 */   // Label 19731: @1390902
     /* 1390902 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1390986), // Rule ID 22740 //
     /* 1390907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1390924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1390963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390985 */     // GIR_Coverage, 22740,
     /* 1390985 */     GIR_EraseRootFromParent_Done,
     /* 1390986 */   // Label 19732: @1390986
     /* 1390986 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1391070), // Rule ID 22741 //
     /* 1390991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1391008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1391047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391069 */     // GIR_Coverage, 22741,
     /* 1391069 */     GIR_EraseRootFromParent_Done,
     /* 1391070 */   // Label 19733: @1391070
     /* 1391070 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1391154), // Rule ID 22744 //
     /* 1391075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1391131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391153 */     // GIR_Coverage, 22744,
     /* 1391153 */     GIR_EraseRootFromParent_Done,
     /* 1391154 */   // Label 19734: @1391154
     /* 1391154 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1391238), // Rule ID 22745 //
     /* 1391159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1391215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391237 */     // GIR_Coverage, 22745,
     /* 1391237 */     GIR_EraseRootFromParent_Done,
     /* 1391238 */   // Label 19735: @1391238
     /* 1391238 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1391322), // Rule ID 22748 //
     /* 1391243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1391260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1391299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391321 */     // GIR_Coverage, 22748,
     /* 1391321 */     GIR_EraseRootFromParent_Done,
     /* 1391322 */   // Label 19736: @1391322
     /* 1391322 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1391406), // Rule ID 22749 //
     /* 1391327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1391344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391380 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1391383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391405 */     // GIR_Coverage, 22749,
     /* 1391405 */     GIR_EraseRootFromParent_Done,
     /* 1391406 */   // Label 19737: @1391406
     /* 1391406 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1391490), // Rule ID 22752 //
     /* 1391411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1391467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391489 */     // GIR_Coverage, 22752,
     /* 1391489 */     GIR_EraseRootFromParent_Done,
     /* 1391490 */   // Label 19738: @1391490
     /* 1391490 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1391574), // Rule ID 22753 //
     /* 1391495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1391512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1391551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391573 */     // GIR_Coverage, 22753,
     /* 1391573 */     GIR_EraseRootFromParent_Done,
     /* 1391574 */   // Label 19739: @1391574
     /* 1391574 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1391658), // Rule ID 22756 //
     /* 1391579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1391635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391657 */     // GIR_Coverage, 22756,
     /* 1391657 */     GIR_EraseRootFromParent_Done,
     /* 1391658 */   // Label 19740: @1391658
     /* 1391658 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1391742), // Rule ID 22757 //
     /* 1391663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1391680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1391719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391741 */     // GIR_Coverage, 22757,
     /* 1391741 */     GIR_EraseRootFromParent_Done,
     /* 1391742 */   // Label 19741: @1391742
     /* 1391742 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1391826), // Rule ID 22760 //
     /* 1391747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1391803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391825 */     // GIR_Coverage, 22760,
     /* 1391825 */     GIR_EraseRootFromParent_Done,
     /* 1391826 */   // Label 19742: @1391826
     /* 1391826 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1391910), // Rule ID 22761 //
     /* 1391831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391884 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1391887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391909 */     // GIR_Coverage, 22761,
     /* 1391909 */     GIR_EraseRootFromParent_Done,
     /* 1391910 */   // Label 19743: @1391910
     /* 1391910 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1391994), // Rule ID 22764 //
     /* 1391915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1391923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1391971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391993 */     // GIR_Coverage, 22764,
     /* 1391993 */     GIR_EraseRootFromParent_Done,
     /* 1391994 */   // Label 19744: @1391994
     /* 1391994 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1392078), // Rule ID 22765 //
     /* 1391999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1392016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1392055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392077 */     // GIR_Coverage, 22765,
     /* 1392077 */     GIR_EraseRootFromParent_Done,
     /* 1392078 */   // Label 19745: @1392078
     /* 1392078 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1392162), // Rule ID 22768 //
     /* 1392083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1392139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392161 */     // GIR_Coverage, 22768,
     /* 1392161 */     GIR_EraseRootFromParent_Done,
     /* 1392162 */   // Label 19746: @1392162
     /* 1392162 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1392246), // Rule ID 22769 //
     /* 1392167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1392223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392245 */     // GIR_Coverage, 22769,
     /* 1392245 */     GIR_EraseRootFromParent_Done,
     /* 1392246 */   // Label 19747: @1392246
     /* 1392246 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1392330), // Rule ID 22772 //
     /* 1392251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1392268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1392307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392329 */     // GIR_Coverage, 22772,
     /* 1392329 */     GIR_EraseRootFromParent_Done,
     /* 1392330 */   // Label 19748: @1392330
     /* 1392330 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1392414), // Rule ID 22773 //
     /* 1392335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1392352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392388 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1392391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392413 */     // GIR_Coverage, 22773,
     /* 1392413 */     GIR_EraseRootFromParent_Done,
     /* 1392414 */   // Label 19749: @1392414
     /* 1392414 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1392498), // Rule ID 22776 //
     /* 1392419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1392475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392497 */     // GIR_Coverage, 22776,
     /* 1392497 */     GIR_EraseRootFromParent_Done,
     /* 1392498 */   // Label 19750: @1392498
     /* 1392498 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1392582), // Rule ID 22777 //
     /* 1392503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1392520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392556 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1392559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392581 */     // GIR_Coverage, 22777,
     /* 1392581 */     GIR_EraseRootFromParent_Done,
     /* 1392582 */   // Label 19751: @1392582
     /* 1392582 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1392666), // Rule ID 22780 //
     /* 1392587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1392643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392665 */     // GIR_Coverage, 22780,
     /* 1392665 */     GIR_EraseRootFromParent_Done,
     /* 1392666 */   // Label 19752: @1392666
     /* 1392666 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1392750), // Rule ID 22781 //
     /* 1392671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1392688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1392727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392749 */     // GIR_Coverage, 22781,
     /* 1392749 */     GIR_EraseRootFromParent_Done,
     /* 1392750 */   // Label 19753: @1392750
     /* 1392750 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1392834), // Rule ID 22784 //
     /* 1392755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1392811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392833 */     // GIR_Coverage, 22784,
     /* 1392833 */     GIR_EraseRootFromParent_Done,
     /* 1392834 */   // Label 19754: @1392834
     /* 1392834 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1392918), // Rule ID 22785 //
     /* 1392839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1392895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392917 */     // GIR_Coverage, 22785,
     /* 1392917 */     GIR_EraseRootFromParent_Done,
     /* 1392918 */   // Label 19755: @1392918
     /* 1392918 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1393002), // Rule ID 22788 //
     /* 1392923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1392931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1392979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393001 */     // GIR_Coverage, 22788,
     /* 1393001 */     GIR_EraseRootFromParent_Done,
     /* 1393002 */   // Label 19756: @1393002
     /* 1393002 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1393086), // Rule ID 22789 //
     /* 1393007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1393024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1393063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393085 */     // GIR_Coverage, 22789,
     /* 1393085 */     GIR_EraseRootFromParent_Done,
     /* 1393086 */   // Label 19757: @1393086
     /* 1393086 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1393170), // Rule ID 22792 //
     /* 1393091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1393108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1393147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393169 */     // GIR_Coverage, 22792,
     /* 1393169 */     GIR_EraseRootFromParent_Done,
     /* 1393170 */   // Label 19758: @1393170
     /* 1393170 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1393254), // Rule ID 22793 //
     /* 1393175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1393192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1393231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393253 */     // GIR_Coverage, 22793,
     /* 1393253 */     GIR_EraseRootFromParent_Done,
     /* 1393254 */   // Label 19759: @1393254
     /* 1393254 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1393338), // Rule ID 22796 //
     /* 1393259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1393276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1393282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1393315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393337 */     // GIR_Coverage, 22796,
     /* 1393337 */     GIR_EraseRootFromParent_Done,
     /* 1393338 */   // Label 19760: @1393338
     /* 1393338 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1393422), // Rule ID 22797 //
     /* 1393343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1393360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1393366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393396 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1393399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393421 */     // GIR_Coverage, 22797,
     /* 1393421 */     GIR_EraseRootFromParent_Done,
     /* 1393422 */   // Label 19761: @1393422
     /* 1393422 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1393506), // Rule ID 22800 //
     /* 1393427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1393483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393505 */     // GIR_Coverage, 22800,
     /* 1393505 */     GIR_EraseRootFromParent_Done,
     /* 1393506 */   // Label 19762: @1393506
     /* 1393506 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1393590), // Rule ID 22801 //
     /* 1393511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1393567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393589 */     // GIR_Coverage, 22801,
     /* 1393589 */     GIR_EraseRootFromParent_Done,
     /* 1393590 */   // Label 19763: @1393590
     /* 1393590 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1393674), // Rule ID 22804 //
     /* 1393595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1393651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393673 */     // GIR_Coverage, 22804,
     /* 1393673 */     GIR_EraseRootFromParent_Done,
     /* 1393674 */   // Label 19764: @1393674
     /* 1393674 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1393758), // Rule ID 22805 //
     /* 1393679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1393735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393757 */     // GIR_Coverage, 22805,
     /* 1393757 */     GIR_EraseRootFromParent_Done,
     /* 1393758 */   // Label 19765: @1393758
     /* 1393758 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1393842), // Rule ID 22808 //
     /* 1393763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1393819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393841 */     // GIR_Coverage, 22808,
     /* 1393841 */     GIR_EraseRootFromParent_Done,
     /* 1393842 */   // Label 19766: @1393842
     /* 1393842 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1393926), // Rule ID 22809 //
     /* 1393847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1393903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393925 */     // GIR_Coverage, 22809,
     /* 1393925 */     GIR_EraseRootFromParent_Done,
     /* 1393926 */   // Label 19767: @1393926
     /* 1393926 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1394010), // Rule ID 22812 //
     /* 1393931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1393987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394009 */     // GIR_Coverage, 22812,
     /* 1394009 */     GIR_EraseRootFromParent_Done,
     /* 1394010 */   // Label 19768: @1394010
     /* 1394010 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1394094), // Rule ID 22813 //
     /* 1394015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1394032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1394071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394093 */     // GIR_Coverage, 22813,
     /* 1394093 */     GIR_EraseRootFromParent_Done,
     /* 1394094 */   // Label 19769: @1394094
     /* 1394094 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1394178), // Rule ID 22816 //
     /* 1394099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1394116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1394155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394177 */     // GIR_Coverage, 22816,
     /* 1394177 */     GIR_EraseRootFromParent_Done,
     /* 1394178 */   // Label 19770: @1394178
     /* 1394178 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1394262), // Rule ID 22817 //
     /* 1394183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1394200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394236 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1394239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394261 */     // GIR_Coverage, 22817,
     /* 1394261 */     GIR_EraseRootFromParent_Done,
     /* 1394262 */   // Label 19771: @1394262
     /* 1394262 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1394346), // Rule ID 22820 //
     /* 1394267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1394323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394345 */     // GIR_Coverage, 22820,
     /* 1394345 */     GIR_EraseRootFromParent_Done,
     /* 1394346 */   // Label 19772: @1394346
     /* 1394346 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1394430), // Rule ID 22821 //
     /* 1394351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1394407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394429 */     // GIR_Coverage, 22821,
     /* 1394429 */     GIR_EraseRootFromParent_Done,
     /* 1394430 */   // Label 19773: @1394430
     /* 1394430 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1394514), // Rule ID 22940 //
     /* 1394435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1394438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1394491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394513 */     // GIR_Coverage, 22940,
     /* 1394513 */     GIR_EraseRootFromParent_Done,
     /* 1394514 */   // Label 19774: @1394514
     /* 1394514 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1394598), // Rule ID 22941 //
     /* 1394519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1394522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394572 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1394575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394597 */     // GIR_Coverage, 22941,
     /* 1394597 */     GIR_EraseRootFromParent_Done,
     /* 1394598 */   // Label 19775: @1394598
     /* 1394598 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1394682), // Rule ID 22944 //
     /* 1394603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1394606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394656 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1394659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394681 */     // GIR_Coverage, 22944,
     /* 1394681 */     GIR_EraseRootFromParent_Done,
     /* 1394682 */   // Label 19776: @1394682
     /* 1394682 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1394766), // Rule ID 22945 //
     /* 1394687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1394690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394740 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1394743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394765 */     // GIR_Coverage, 22945,
     /* 1394765 */     GIR_EraseRootFromParent_Done,
     /* 1394766 */   // Label 19777: @1394766
     /* 1394766 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1394850), // Rule ID 22948 //
     /* 1394771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1394774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1394827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394849 */     // GIR_Coverage, 22948,
     /* 1394849 */     GIR_EraseRootFromParent_Done,
     /* 1394850 */   // Label 19778: @1394850
     /* 1394850 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1394934), // Rule ID 22949 //
     /* 1394855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1394858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1394911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394933 */     // GIR_Coverage, 22949,
     /* 1394933 */     GIR_EraseRootFromParent_Done,
     /* 1394934 */   // Label 19779: @1394934
     /* 1394934 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1395018), // Rule ID 22952 //
     /* 1394939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1394942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1394947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394992 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1394995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395017 */     // GIR_Coverage, 22952,
     /* 1395017 */     GIR_EraseRootFromParent_Done,
     /* 1395018 */   // Label 19780: @1395018
     /* 1395018 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1395102), // Rule ID 22953 //
     /* 1395023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1395026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1395040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1395079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395101 */     // GIR_Coverage, 22953,
     /* 1395101 */     GIR_EraseRootFromParent_Done,
     /* 1395102 */   // Label 19781: @1395102
     /* 1395102 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1395186), // Rule ID 22956 //
     /* 1395107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1395110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395160 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1395163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395185 */     // GIR_Coverage, 22956,
     /* 1395185 */     GIR_EraseRootFromParent_Done,
     /* 1395186 */   // Label 19782: @1395186
     /* 1395186 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1395270), // Rule ID 22957 //
     /* 1395191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1395194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1395247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395269 */     // GIR_Coverage, 22957,
     /* 1395269 */     GIR_EraseRootFromParent_Done,
     /* 1395270 */   // Label 19783: @1395270
     /* 1395270 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1395354), // Rule ID 22960 //
     /* 1395275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1395278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1395292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1395331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1395349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395353 */     // GIR_Coverage, 22960,
     /* 1395353 */     GIR_EraseRootFromParent_Done,
     /* 1395354 */   // Label 19784: @1395354
     /* 1395354 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1395438), // Rule ID 22961 //
     /* 1395359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1395362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1395376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395412 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1395415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1395433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395437 */     // GIR_Coverage, 22961,
     /* 1395437 */     GIR_EraseRootFromParent_Done,
     /* 1395438 */   // Label 19785: @1395438
     /* 1395438 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1395522), // Rule ID 22964 //
     /* 1395443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1395446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1395499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395521 */     // GIR_Coverage, 22964,
     /* 1395521 */     GIR_EraseRootFromParent_Done,
     /* 1395522 */   // Label 19786: @1395522
     /* 1395522 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1395606), // Rule ID 22965 //
     /* 1395527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1395530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395580 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1395583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395605 */     // GIR_Coverage, 22965,
     /* 1395605 */     GIR_EraseRootFromParent_Done,
     /* 1395606 */   // Label 19787: @1395606
     /* 1395606 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1395690), // Rule ID 22968 //
     /* 1395611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1395614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1395667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395689 */     // GIR_Coverage, 22968,
     /* 1395689 */     GIR_EraseRootFromParent_Done,
     /* 1395690 */   // Label 19788: @1395690
     /* 1395690 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1395774), // Rule ID 22969 //
     /* 1395695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1395698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395748 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1395751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395773 */     // GIR_Coverage, 22969,
     /* 1395773 */     GIR_EraseRootFromParent_Done,
     /* 1395774 */   // Label 19789: @1395774
     /* 1395774 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1395858), // Rule ID 22972 //
     /* 1395779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1395782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1395796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1395835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395857 */     // GIR_Coverage, 22972,
     /* 1395857 */     GIR_EraseRootFromParent_Done,
     /* 1395858 */   // Label 19790: @1395858
     /* 1395858 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1395942), // Rule ID 22973 //
     /* 1395863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1395866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1395880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1395919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395941 */     // GIR_Coverage, 22973,
     /* 1395941 */     GIR_EraseRootFromParent_Done,
     /* 1395942 */   // Label 19791: @1395942
     /* 1395942 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1396026), // Rule ID 22976 //
     /* 1395947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1395950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1395955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1395964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396000 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1396003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396025 */     // GIR_Coverage, 22976,
     /* 1396025 */     GIR_EraseRootFromParent_Done,
     /* 1396026 */   // Label 19792: @1396026
     /* 1396026 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1396110), // Rule ID 22977 //
     /* 1396031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1396034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1396087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396109 */     // GIR_Coverage, 22977,
     /* 1396109 */     GIR_EraseRootFromParent_Done,
     /* 1396110 */   // Label 19793: @1396110
     /* 1396110 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1396194), // Rule ID 22980 //
     /* 1396115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1396118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396168 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1396171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396193 */     // GIR_Coverage, 22980,
     /* 1396193 */     GIR_EraseRootFromParent_Done,
     /* 1396194 */   // Label 19794: @1396194
     /* 1396194 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1396278), // Rule ID 22981 //
     /* 1396199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1396202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1396255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396277 */     // GIR_Coverage, 22981,
     /* 1396277 */     GIR_EraseRootFromParent_Done,
     /* 1396278 */   // Label 19795: @1396278
     /* 1396278 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1396362), // Rule ID 22984 //
     /* 1396283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1396286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1396339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396361 */     // GIR_Coverage, 22984,
     /* 1396361 */     GIR_EraseRootFromParent_Done,
     /* 1396362 */   // Label 19796: @1396362
     /* 1396362 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1396446), // Rule ID 22985 //
     /* 1396367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1396370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1396423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396445 */     // GIR_Coverage, 22985,
     /* 1396445 */     GIR_EraseRootFromParent_Done,
     /* 1396446 */   // Label 19797: @1396446
     /* 1396446 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1396530), // Rule ID 22988 //
     /* 1396451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1396454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1396468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396504 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1396507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396529 */     // GIR_Coverage, 22988,
     /* 1396529 */     GIR_EraseRootFromParent_Done,
     /* 1396530 */   // Label 19798: @1396530
     /* 1396530 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1396614), // Rule ID 22989 //
     /* 1396535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1396538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1396552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396588 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1396591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396613 */     // GIR_Coverage, 22989,
     /* 1396613 */     GIR_EraseRootFromParent_Done,
     /* 1396614 */   // Label 19799: @1396614
     /* 1396614 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1396698), // Rule ID 22992 //
     /* 1396619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1396622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1396636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396672 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1396675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396697 */     // GIR_Coverage, 22992,
     /* 1396697 */     GIR_EraseRootFromParent_Done,
     /* 1396698 */   // Label 19800: @1396698
     /* 1396698 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1396782), // Rule ID 22993 //
     /* 1396703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1396706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1396720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396756 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1396759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396781 */     // GIR_Coverage, 22993,
     /* 1396781 */     GIR_EraseRootFromParent_Done,
     /* 1396782 */   // Label 19801: @1396782
     /* 1396782 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1396866), // Rule ID 22996 //
     /* 1396787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1396790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1396804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396840 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1396843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396865 */     // GIR_Coverage, 22996,
     /* 1396865 */     GIR_EraseRootFromParent_Done,
     /* 1396866 */   // Label 19802: @1396866
     /* 1396866 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1396950), // Rule ID 22997 //
     /* 1396871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1396874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1396888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1396927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396949 */     // GIR_Coverage, 22997,
     /* 1396949 */     GIR_EraseRootFromParent_Done,
     /* 1396950 */   // Label 19803: @1396950
     /* 1396950 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1397034), // Rule ID 23000 //
     /* 1396955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1396958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1396963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1397011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397033 */     // GIR_Coverage, 23000,
     /* 1397033 */     GIR_EraseRootFromParent_Done,
     /* 1397034 */   // Label 19804: @1397034
     /* 1397034 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1397118), // Rule ID 23001 //
     /* 1397039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1397056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397092 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1397095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397117 */     // GIR_Coverage, 23001,
     /* 1397117 */     GIR_EraseRootFromParent_Done,
     /* 1397118 */   // Label 19805: @1397118
     /* 1397118 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1397202), // Rule ID 23004 //
     /* 1397123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397176 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1397179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397201 */     // GIR_Coverage, 23004,
     /* 1397201 */     GIR_EraseRootFromParent_Done,
     /* 1397202 */   // Label 19806: @1397202
     /* 1397202 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1397286), // Rule ID 23005 //
     /* 1397207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1397224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397260 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1397263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397285 */     // GIR_Coverage, 23005,
     /* 1397285 */     GIR_EraseRootFromParent_Done,
     /* 1397286 */   // Label 19807: @1397286
     /* 1397286 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1397370), // Rule ID 23008 //
     /* 1397291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1397347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397369 */     // GIR_Coverage, 23008,
     /* 1397369 */     GIR_EraseRootFromParent_Done,
     /* 1397370 */   // Label 19808: @1397370
     /* 1397370 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1397454), // Rule ID 23009 //
     /* 1397375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397428 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1397431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397453 */     // GIR_Coverage, 23009,
     /* 1397453 */     GIR_EraseRootFromParent_Done,
     /* 1397454 */   // Label 19809: @1397454
     /* 1397454 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1397538), // Rule ID 23012 //
     /* 1397459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397512 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1397515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397537 */     // GIR_Coverage, 23012,
     /* 1397537 */     GIR_EraseRootFromParent_Done,
     /* 1397538 */   // Label 19810: @1397538
     /* 1397538 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1397622), // Rule ID 23013 //
     /* 1397543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1397599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397621 */     // GIR_Coverage, 23013,
     /* 1397621 */     GIR_EraseRootFromParent_Done,
     /* 1397622 */   // Label 19811: @1397622
     /* 1397622 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1397706), // Rule ID 23016 //
     /* 1397627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397680 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1397683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397705 */     // GIR_Coverage, 23016,
     /* 1397705 */     GIR_EraseRootFromParent_Done,
     /* 1397706 */   // Label 19812: @1397706
     /* 1397706 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1397790), // Rule ID 23017 //
     /* 1397711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1397767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397789 */     // GIR_Coverage, 23017,
     /* 1397789 */     GIR_EraseRootFromParent_Done,
     /* 1397790 */   // Label 19813: @1397790
     /* 1397790 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1397874), // Rule ID 23020 //
     /* 1397795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1397798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397848 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1397851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397873 */     // GIR_Coverage, 23020,
     /* 1397873 */     GIR_EraseRootFromParent_Done,
     /* 1397874 */   // Label 19814: @1397874
     /* 1397874 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1397958), // Rule ID 23021 //
     /* 1397879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1397882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397932 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1397935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397957 */     // GIR_Coverage, 23021,
     /* 1397957 */     GIR_EraseRootFromParent_Done,
     /* 1397958 */   // Label 19815: @1397958
     /* 1397958 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1398042), // Rule ID 23024 //
     /* 1397963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1397971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398016 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1398019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398041 */     // GIR_Coverage, 23024,
     /* 1398041 */     GIR_EraseRootFromParent_Done,
     /* 1398042 */   // Label 19816: @1398042
     /* 1398042 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1398126), // Rule ID 23025 //
     /* 1398047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1398064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398100 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1398103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398125 */     // GIR_Coverage, 23025,
     /* 1398125 */     GIR_EraseRootFromParent_Done,
     /* 1398126 */   // Label 19817: @1398126
     /* 1398126 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1398210), // Rule ID 23028 //
     /* 1398131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1398187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398209 */     // GIR_Coverage, 23028,
     /* 1398209 */     GIR_EraseRootFromParent_Done,
     /* 1398210 */   // Label 19818: @1398210
     /* 1398210 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1398294), // Rule ID 23029 //
     /* 1398215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1398232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398268 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1398271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398293 */     // GIR_Coverage, 23029,
     /* 1398293 */     GIR_EraseRootFromParent_Done,
     /* 1398294 */   // Label 19819: @1398294
     /* 1398294 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1398378), // Rule ID 23032 //
     /* 1398299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1398355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398377 */     // GIR_Coverage, 23032,
     /* 1398377 */     GIR_EraseRootFromParent_Done,
     /* 1398378 */   // Label 19820: @1398378
     /* 1398378 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1398462), // Rule ID 23033 //
     /* 1398383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398436 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1398439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398461 */     // GIR_Coverage, 23033,
     /* 1398461 */     GIR_EraseRootFromParent_Done,
     /* 1398462 */   // Label 19821: @1398462
     /* 1398462 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1398546), // Rule ID 23036 //
     /* 1398467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398520 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1398523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398545 */     // GIR_Coverage, 23036,
     /* 1398545 */     GIR_EraseRootFromParent_Done,
     /* 1398546 */   // Label 19822: @1398546
     /* 1398546 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1398630), // Rule ID 23037 //
     /* 1398551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1398607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398629 */     // GIR_Coverage, 23037,
     /* 1398629 */     GIR_EraseRootFromParent_Done,
     /* 1398630 */   // Label 19823: @1398630
     /* 1398630 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1398714), // Rule ID 23040 //
     /* 1398635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398688 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1398691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398713 */     // GIR_Coverage, 23040,
     /* 1398713 */     GIR_EraseRootFromParent_Done,
     /* 1398714 */   // Label 19824: @1398714
     /* 1398714 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1398798), // Rule ID 23041 //
     /* 1398719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398772 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1398775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398797 */     // GIR_Coverage, 23041,
     /* 1398797 */     GIR_EraseRootFromParent_Done,
     /* 1398798 */   // Label 19825: @1398798
     /* 1398798 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1398882), // Rule ID 23044 //
     /* 1398803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1398859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398881 */     // GIR_Coverage, 23044,
     /* 1398881 */     GIR_EraseRootFromParent_Done,
     /* 1398882 */   // Label 19826: @1398882
     /* 1398882 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1398966), // Rule ID 23045 //
     /* 1398887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1398943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398965 */     // GIR_Coverage, 23045,
     /* 1398965 */     GIR_EraseRootFromParent_Done,
     /* 1398966 */   // Label 19827: @1398966
     /* 1398966 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1399050), // Rule ID 23048 //
     /* 1398971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1398974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1398979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1399027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399049 */     // GIR_Coverage, 23048,
     /* 1399049 */     GIR_EraseRootFromParent_Done,
     /* 1399050 */   // Label 19828: @1399050
     /* 1399050 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1399134), // Rule ID 23049 //
     /* 1399055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1399072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1399093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399108 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1399111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399133 */     // GIR_Coverage, 23049,
     /* 1399133 */     GIR_EraseRootFromParent_Done,
     /* 1399134 */   // Label 19829: @1399134
     /* 1399134 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1399218), // Rule ID 23052 //
     /* 1399139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399192 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1399195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399217 */     // GIR_Coverage, 23052,
     /* 1399217 */     GIR_EraseRootFromParent_Done,
     /* 1399218 */   // Label 19830: @1399218
     /* 1399218 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1399302), // Rule ID 23053 //
     /* 1399223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1399240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1399261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1399279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399301 */     // GIR_Coverage, 23053,
     /* 1399301 */     GIR_EraseRootFromParent_Done,
     /* 1399302 */   // Label 19831: @1399302
     /* 1399302 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1399386), // Rule ID 23056 //
     /* 1399307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399360 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1399363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399385 */     // GIR_Coverage, 23056,
     /* 1399385 */     GIR_EraseRootFromParent_Done,
     /* 1399386 */   // Label 19832: @1399386
     /* 1399386 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1399470), // Rule ID 23057 //
     /* 1399391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1399447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399469 */     // GIR_Coverage, 23057,
     /* 1399469 */     GIR_EraseRootFromParent_Done,
     /* 1399470 */   // Label 19833: @1399470
     /* 1399470 */   GIM_Reject,
     /* 1399471 */ // Label 13853: @1399471
     /* 1399471 */ GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(2008628),
     /* 1399476 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1399479 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1399565), // Rule ID 7350 //
     /* 1399484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1399495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1399498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1399501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399530 */     // MIs[0] policy
     /* 1399530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1399543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399564 */     // GIR_Coverage, 7350,
     /* 1399564 */     GIR_EraseRootFromParent_Done,
     /* 1399565 */   // Label 19835: @1399565
     /* 1399565 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1399651), // Rule ID 7351 //
     /* 1399570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1399581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1399584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1399587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399616 */     // MIs[0] policy
     /* 1399616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1399629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399650 */     // GIR_Coverage, 7351,
     /* 1399650 */     GIR_EraseRootFromParent_Done,
     /* 1399651 */   // Label 19836: @1399651
     /* 1399651 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1399737), // Rule ID 7354 //
     /* 1399656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1399667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1399670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1399673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399702 */     // MIs[0] policy
     /* 1399702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1399715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399736 */     // GIR_Coverage, 7354,
     /* 1399736 */     GIR_EraseRootFromParent_Done,
     /* 1399737 */   // Label 19837: @1399737
     /* 1399737 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1399823), // Rule ID 7355 //
     /* 1399742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1399753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1399756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1399759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399788 */     // MIs[0] policy
     /* 1399788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1399801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399822 */     // GIR_Coverage, 7355,
     /* 1399822 */     GIR_EraseRootFromParent_Done,
     /* 1399823 */   // Label 19838: @1399823
     /* 1399823 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1399909), // Rule ID 7358 //
     /* 1399828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1399831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1399839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1399842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1399845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1399848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399874 */     // MIs[0] policy
     /* 1399874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1399887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399908 */     // GIR_Coverage, 7358,
     /* 1399908 */     GIR_EraseRootFromParent_Done,
     /* 1399909 */   // Label 19839: @1399909
     /* 1399909 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1399995), // Rule ID 7359 //
     /* 1399914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1399917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1399922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1399925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1399928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1399931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1399934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1399956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399960 */     // MIs[0] policy
     /* 1399960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1399973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1399991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399994 */     // GIR_Coverage, 7359,
     /* 1399994 */     GIR_EraseRootFromParent_Done,
     /* 1399995 */   // Label 19840: @1399995
     /* 1399995 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1400081), // Rule ID 7362 //
     /* 1400000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400046 */     // MIs[0] policy
     /* 1400046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1400059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400080 */     // GIR_Coverage, 7362,
     /* 1400080 */     GIR_EraseRootFromParent_Done,
     /* 1400081 */   // Label 19841: @1400081
     /* 1400081 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1400167), // Rule ID 7363 //
     /* 1400086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1400097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1400100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1400103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400132 */     // MIs[0] policy
     /* 1400132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1400145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400166 */     // GIR_Coverage, 7363,
     /* 1400166 */     GIR_EraseRootFromParent_Done,
     /* 1400167 */   // Label 19842: @1400167
     /* 1400167 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1400253), // Rule ID 7366 //
     /* 1400172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1400183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1400186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1400189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400218 */     // MIs[0] policy
     /* 1400218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1400231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400252 */     // GIR_Coverage, 7366,
     /* 1400252 */     GIR_EraseRootFromParent_Done,
     /* 1400253 */   // Label 19843: @1400253
     /* 1400253 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1400339), // Rule ID 7367 //
     /* 1400258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1400269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1400272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1400275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400304 */     // MIs[0] policy
     /* 1400304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1400317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400338 */     // GIR_Coverage, 7367,
     /* 1400338 */     GIR_EraseRootFromParent_Done,
     /* 1400339 */   // Label 19844: @1400339
     /* 1400339 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1400425), // Rule ID 7370 //
     /* 1400344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1400355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1400358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400390 */     // MIs[0] policy
     /* 1400390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1400403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400424 */     // GIR_Coverage, 7370,
     /* 1400424 */     GIR_EraseRootFromParent_Done,
     /* 1400425 */   // Label 19845: @1400425
     /* 1400425 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1400511), // Rule ID 7371 //
     /* 1400430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1400441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1400444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1400447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400476 */     // MIs[0] policy
     /* 1400476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1400489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400510 */     // GIR_Coverage, 7371,
     /* 1400510 */     GIR_EraseRootFromParent_Done,
     /* 1400511 */   // Label 19846: @1400511
     /* 1400511 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1400597), // Rule ID 7374 //
     /* 1400516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1400527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1400530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1400533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400562 */     // MIs[0] policy
     /* 1400562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1400575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1400593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400596 */     // GIR_Coverage, 7374,
     /* 1400596 */     GIR_EraseRootFromParent_Done,
     /* 1400597 */   // Label 19847: @1400597
     /* 1400597 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1400683), // Rule ID 7375 //
     /* 1400602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1400613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1400616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1400619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400648 */     // MIs[0] policy
     /* 1400648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1400661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1400679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400682 */     // GIR_Coverage, 7375,
     /* 1400682 */     GIR_EraseRootFromParent_Done,
     /* 1400683 */   // Label 19848: @1400683
     /* 1400683 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1400769), // Rule ID 7378 //
     /* 1400688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400734 */     // MIs[0] policy
     /* 1400734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1400747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400768 */     // GIR_Coverage, 7378,
     /* 1400768 */     GIR_EraseRootFromParent_Done,
     /* 1400769 */   // Label 19849: @1400769
     /* 1400769 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1400855), // Rule ID 7379 //
     /* 1400774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1400791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400820 */     // MIs[0] policy
     /* 1400820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1400833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400854 */     // GIR_Coverage, 7379,
     /* 1400854 */     GIR_EraseRootFromParent_Done,
     /* 1400855 */   // Label 19850: @1400855
     /* 1400855 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1400941), // Rule ID 7382 //
     /* 1400860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1400863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1400880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400906 */     // MIs[0] policy
     /* 1400906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1400919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400940 */     // GIR_Coverage, 7382,
     /* 1400940 */     GIR_EraseRootFromParent_Done,
     /* 1400941 */   // Label 19851: @1400941
     /* 1400941 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1401027), // Rule ID 7383 //
     /* 1400946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1400949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1400954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1400963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1400966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1400969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1400988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400992 */     // MIs[0] policy
     /* 1400992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1401005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401026 */     // GIR_Coverage, 7383,
     /* 1401026 */     GIR_EraseRootFromParent_Done,
     /* 1401027 */   // Label 19852: @1401027
     /* 1401027 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1401113), // Rule ID 7386 //
     /* 1401032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1401035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401078 */     // MIs[0] policy
     /* 1401078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1401091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401112 */     // GIR_Coverage, 7386,
     /* 1401112 */     GIR_EraseRootFromParent_Done,
     /* 1401113 */   // Label 19853: @1401113
     /* 1401113 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1401199), // Rule ID 7387 //
     /* 1401118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1401121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1401135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401164 */     // MIs[0] policy
     /* 1401164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1401177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401198 */     // GIR_Coverage, 7387,
     /* 1401198 */     GIR_EraseRootFromParent_Done,
     /* 1401199 */   // Label 19854: @1401199
     /* 1401199 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1401285), // Rule ID 7390 //
     /* 1401204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1401215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1401218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1401221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401250 */     // MIs[0] policy
     /* 1401250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1401263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401284 */     // GIR_Coverage, 7390,
     /* 1401284 */     GIR_EraseRootFromParent_Done,
     /* 1401285 */   // Label 19855: @1401285
     /* 1401285 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1401371), // Rule ID 7391 //
     /* 1401290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1401301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1401304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1401307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401336 */     // MIs[0] policy
     /* 1401336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1401349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401370 */     // GIR_Coverage, 7391,
     /* 1401370 */     GIR_EraseRootFromParent_Done,
     /* 1401371 */   // Label 19856: @1401371
     /* 1401371 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1401457), // Rule ID 7394 //
     /* 1401376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1401387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1401390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1401393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1401406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401422 */     // MIs[0] policy
     /* 1401422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1401435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401456 */     // GIR_Coverage, 7394,
     /* 1401456 */     GIR_EraseRootFromParent_Done,
     /* 1401457 */   // Label 19857: @1401457
     /* 1401457 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1401543), // Rule ID 7395 //
     /* 1401462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1401473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1401476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1401479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1401485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1401492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401508 */     // MIs[0] policy
     /* 1401508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1401521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401542 */     // GIR_Coverage, 7395,
     /* 1401542 */     GIR_EraseRootFromParent_Done,
     /* 1401543 */   // Label 19858: @1401543
     /* 1401543 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1401629), // Rule ID 7398 //
     /* 1401548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1401559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1401562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1401565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1401571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1401578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401594 */     // MIs[0] policy
     /* 1401594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1401607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401628 */     // GIR_Coverage, 7398,
     /* 1401628 */     GIR_EraseRootFromParent_Done,
     /* 1401629 */   // Label 19859: @1401629
     /* 1401629 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1401715), // Rule ID 7399 //
     /* 1401634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1401645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1401648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1401651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1401657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1401664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401680 */     // MIs[0] policy
     /* 1401680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1401693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401714 */     // GIR_Coverage, 7399,
     /* 1401714 */     GIR_EraseRootFromParent_Done,
     /* 1401715 */   // Label 19860: @1401715
     /* 1401715 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1401801), // Rule ID 7402 //
     /* 1401720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1401731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1401734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1401737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401766 */     // MIs[0] policy
     /* 1401766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1401779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401800 */     // GIR_Coverage, 7402,
     /* 1401800 */     GIR_EraseRootFromParent_Done,
     /* 1401801 */   // Label 19861: @1401801
     /* 1401801 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1401887), // Rule ID 7403 //
     /* 1401806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1401817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1401820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1401823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401852 */     // MIs[0] policy
     /* 1401852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1401865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401886 */     // GIR_Coverage, 7403,
     /* 1401886 */     GIR_EraseRootFromParent_Done,
     /* 1401887 */   // Label 19862: @1401887
     /* 1401887 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1401973), // Rule ID 7406 //
     /* 1401892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1401903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1401906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1401909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1401922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401938 */     // MIs[0] policy
     /* 1401938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1401951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401972 */     // GIR_Coverage, 7406,
     /* 1401972 */     GIR_EraseRootFromParent_Done,
     /* 1401973 */   // Label 19863: @1401973
     /* 1401973 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1402059), // Rule ID 7407 //
     /* 1401978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1401989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1401992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1401995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1402001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402024 */     // MIs[0] policy
     /* 1402024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1402037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402058 */     // GIR_Coverage, 7407,
     /* 1402058 */     GIR_EraseRootFromParent_Done,
     /* 1402059 */   // Label 19864: @1402059
     /* 1402059 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1402145), // Rule ID 7410 //
     /* 1402064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1402075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1402078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1402081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1402087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1402094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402110 */     // MIs[0] policy
     /* 1402110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1402123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402144 */     // GIR_Coverage, 7410,
     /* 1402144 */     GIR_EraseRootFromParent_Done,
     /* 1402145 */   // Label 19865: @1402145
     /* 1402145 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1402231), // Rule ID 7411 //
     /* 1402150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1402161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1402164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1402167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1402173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1402180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402196 */     // MIs[0] policy
     /* 1402196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1402209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402230 */     // GIR_Coverage, 7411,
     /* 1402230 */     GIR_EraseRootFromParent_Done,
     /* 1402231 */   // Label 19866: @1402231
     /* 1402231 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1402317), // Rule ID 7414 //
     /* 1402236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1402247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1402250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402282 */     // MIs[0] policy
     /* 1402282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1402295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402316 */     // GIR_Coverage, 7414,
     /* 1402316 */     GIR_EraseRootFromParent_Done,
     /* 1402317 */   // Label 19867: @1402317
     /* 1402317 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1402403), // Rule ID 7415 //
     /* 1402322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1402333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1402336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1402339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402368 */     // MIs[0] policy
     /* 1402368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1402381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402402 */     // GIR_Coverage, 7415,
     /* 1402402 */     GIR_EraseRootFromParent_Done,
     /* 1402403 */   // Label 19868: @1402403
     /* 1402403 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1402489), // Rule ID 7418 //
     /* 1402408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1402419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1402422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402454 */     // MIs[0] policy
     /* 1402454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1402467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402488 */     // GIR_Coverage, 7418,
     /* 1402488 */     GIR_EraseRootFromParent_Done,
     /* 1402489 */   // Label 19869: @1402489
     /* 1402489 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1402575), // Rule ID 7419 //
     /* 1402494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1402505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1402508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1402511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402540 */     // MIs[0] policy
     /* 1402540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1402553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402574 */     // GIR_Coverage, 7419,
     /* 1402574 */     GIR_EraseRootFromParent_Done,
     /* 1402575 */   // Label 19870: @1402575
     /* 1402575 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1402661), // Rule ID 7422 //
     /* 1402580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1402591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1402594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1402603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1402610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402626 */     // MIs[0] policy
     /* 1402626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1402639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402660 */     // GIR_Coverage, 7422,
     /* 1402660 */     GIR_EraseRootFromParent_Done,
     /* 1402661 */   // Label 19871: @1402661
     /* 1402661 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1402747), // Rule ID 7423 //
     /* 1402666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1402677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1402680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1402683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1402689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1402696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402712 */     // MIs[0] policy
     /* 1402712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1402725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402746 */     // GIR_Coverage, 7423,
     /* 1402746 */     GIR_EraseRootFromParent_Done,
     /* 1402747 */   // Label 19872: @1402747
     /* 1402747 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1402833), // Rule ID 7426 //
     /* 1402752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1402755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1402763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1402766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402798 */     // MIs[0] policy
     /* 1402798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1402811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402832 */     // GIR_Coverage, 7426,
     /* 1402832 */     GIR_EraseRootFromParent_Done,
     /* 1402833 */   // Label 19873: @1402833
     /* 1402833 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1402919), // Rule ID 7427 //
     /* 1402838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1402841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1402849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1402852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1402855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402884 */     // MIs[0] policy
     /* 1402884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1402897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402918 */     // GIR_Coverage, 7427,
     /* 1402918 */     GIR_EraseRootFromParent_Done,
     /* 1402919 */   // Label 19874: @1402919
     /* 1402919 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1403005), // Rule ID 7430 //
     /* 1402924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1402927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1402935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1402938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1402941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402970 */     // MIs[0] policy
     /* 1402970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1402983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403004 */     // GIR_Coverage, 7430,
     /* 1403004 */     GIR_EraseRootFromParent_Done,
     /* 1403005 */   // Label 19875: @1403005
     /* 1403005 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1403091), // Rule ID 7431 //
     /* 1403010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1403021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1403024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1403027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403056 */     // MIs[0] policy
     /* 1403056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1403069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403090 */     // GIR_Coverage, 7431,
     /* 1403090 */     GIR_EraseRootFromParent_Done,
     /* 1403091 */   // Label 19876: @1403091
     /* 1403091 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1403177), // Rule ID 7434 //
     /* 1403096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1403099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1403107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1403110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1403113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403142 */     // MIs[0] policy
     /* 1403142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403176 */     // GIR_Coverage, 7434,
     /* 1403176 */     GIR_EraseRootFromParent_Done,
     /* 1403177 */   // Label 19877: @1403177
     /* 1403177 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1403263), // Rule ID 7435 //
     /* 1403182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1403193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1403196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1403199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403228 */     // MIs[0] policy
     /* 1403228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403262 */     // GIR_Coverage, 7435,
     /* 1403262 */     GIR_EraseRootFromParent_Done,
     /* 1403263 */   // Label 19878: @1403263
     /* 1403263 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1403351), // Rule ID 2740 //
     /* 1403268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1403271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1403279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1403282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1403285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1403288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403307 */     // MIs[0] Operand 5
     /* 1403307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403318 */     // MIs[0] policy
     /* 1403318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1403331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403350 */     // GIR_Coverage, 2740,
     /* 1403350 */     GIR_EraseRootFromParent_Done,
     /* 1403351 */   // Label 19879: @1403351
     /* 1403351 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1403439), // Rule ID 2741 //
     /* 1403356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1403359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1403367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1403370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1403373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1403376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403395 */     // MIs[0] Operand 5
     /* 1403395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403406 */     // MIs[0] policy
     /* 1403406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1403419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403438 */     // GIR_Coverage, 2741,
     /* 1403438 */     GIR_EraseRootFromParent_Done,
     /* 1403439 */   // Label 19880: @1403439
     /* 1403439 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1403527), // Rule ID 20632 //
     /* 1403444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1403447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1403455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1403458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1403461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1403464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403483 */     // MIs[0] Operand 5
     /* 1403483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403494 */     // MIs[0] policy
     /* 1403494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1403507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403526 */     // GIR_Coverage, 20632,
     /* 1403526 */     GIR_EraseRootFromParent_Done,
     /* 1403527 */   // Label 19881: @1403527
     /* 1403527 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1403615), // Rule ID 20633 //
     /* 1403532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1403535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1403543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1403546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1403549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1403552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403571 */     // MIs[0] Operand 5
     /* 1403571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403582 */     // MIs[0] policy
     /* 1403582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1403595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403614 */     // GIR_Coverage, 20633,
     /* 1403614 */     GIR_EraseRootFromParent_Done,
     /* 1403615 */   // Label 19882: @1403615
     /* 1403615 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1403703), // Rule ID 20636 //
     /* 1403620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1403623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1403640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403659 */     // MIs[0] Operand 5
     /* 1403659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403670 */     // MIs[0] policy
     /* 1403670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1403683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403702 */     // GIR_Coverage, 20636,
     /* 1403702 */     GIR_EraseRootFromParent_Done,
     /* 1403703 */   // Label 19883: @1403703
     /* 1403703 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1403791), // Rule ID 20637 //
     /* 1403708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1403711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1403719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1403722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1403725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1403728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403747 */     // MIs[0] Operand 5
     /* 1403747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403758 */     // MIs[0] policy
     /* 1403758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1403771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403790 */     // GIR_Coverage, 20637,
     /* 1403790 */     GIR_EraseRootFromParent_Done,
     /* 1403791 */   // Label 19884: @1403791
     /* 1403791 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1403879), // Rule ID 20640 //
     /* 1403796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1403799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403835 */     // MIs[0] Operand 5
     /* 1403835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403846 */     // MIs[0] policy
     /* 1403846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403856 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1403859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403878 */     // GIR_Coverage, 20640,
     /* 1403878 */     GIR_EraseRootFromParent_Done,
     /* 1403879 */   // Label 19885: @1403879
     /* 1403879 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1403967), // Rule ID 20641 //
     /* 1403884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1403887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403923 */     // MIs[0] Operand 5
     /* 1403923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403934 */     // MIs[0] policy
     /* 1403934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1403947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403966 */     // GIR_Coverage, 20641,
     /* 1403966 */     GIR_EraseRootFromParent_Done,
     /* 1403967 */   // Label 19886: @1403967
     /* 1403967 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1404055), // Rule ID 20644 //
     /* 1403972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1403975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1403980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1403992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404011 */     // MIs[0] Operand 5
     /* 1404011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404022 */     // MIs[0] policy
     /* 1404022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1404035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404054 */     // GIR_Coverage, 20644,
     /* 1404054 */     GIR_EraseRootFromParent_Done,
     /* 1404055 */   // Label 19887: @1404055
     /* 1404055 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1404143), // Rule ID 20645 //
     /* 1404060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1404063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1404077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1404080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404099 */     // MIs[0] Operand 5
     /* 1404099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404110 */     // MIs[0] policy
     /* 1404110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1404123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404142 */     // GIR_Coverage, 20645,
     /* 1404142 */     GIR_EraseRootFromParent_Done,
     /* 1404143 */   // Label 19888: @1404143
     /* 1404143 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1404231), // Rule ID 20648 //
     /* 1404148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1404151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1404159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1404162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1404165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1404168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404187 */     // MIs[0] Operand 5
     /* 1404187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404198 */     // MIs[0] policy
     /* 1404198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1404211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404230 */     // GIR_Coverage, 20648,
     /* 1404230 */     GIR_EraseRootFromParent_Done,
     /* 1404231 */   // Label 19889: @1404231
     /* 1404231 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1404319), // Rule ID 20649 //
     /* 1404236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1404239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1404247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1404250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1404253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1404256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404275 */     // MIs[0] Operand 5
     /* 1404275 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404286 */     // MIs[0] policy
     /* 1404286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1404299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404318 */     // GIR_Coverage, 20649,
     /* 1404318 */     GIR_EraseRootFromParent_Done,
     /* 1404319 */   // Label 19890: @1404319
     /* 1404319 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1404407), // Rule ID 20652 //
     /* 1404324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404363 */     // MIs[0] Operand 5
     /* 1404363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404374 */     // MIs[0] policy
     /* 1404374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1404387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404406 */     // GIR_Coverage, 20652,
     /* 1404406 */     GIR_EraseRootFromParent_Done,
     /* 1404407 */   // Label 19891: @1404407
     /* 1404407 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1404495), // Rule ID 20653 //
     /* 1404412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404451 */     // MIs[0] Operand 5
     /* 1404451 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404462 */     // MIs[0] policy
     /* 1404462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1404475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404494 */     // GIR_Coverage, 20653,
     /* 1404494 */     GIR_EraseRootFromParent_Done,
     /* 1404495 */   // Label 19892: @1404495
     /* 1404495 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1404583), // Rule ID 20656 //
     /* 1404500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1404520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404539 */     // MIs[0] Operand 5
     /* 1404539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404550 */     // MIs[0] policy
     /* 1404550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1404563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404582 */     // GIR_Coverage, 20656,
     /* 1404582 */     GIR_EraseRootFromParent_Done,
     /* 1404583 */   // Label 19893: @1404583
     /* 1404583 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1404671), // Rule ID 20657 //
     /* 1404588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1404608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404627 */     // MIs[0] Operand 5
     /* 1404627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404638 */     // MIs[0] policy
     /* 1404638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404648 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1404651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404670 */     // GIR_Coverage, 20657,
     /* 1404670 */     GIR_EraseRootFromParent_Done,
     /* 1404671 */   // Label 19894: @1404671
     /* 1404671 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1404759), // Rule ID 20660 //
     /* 1404676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1404696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404715 */     // MIs[0] Operand 5
     /* 1404715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404726 */     // MIs[0] policy
     /* 1404726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1404739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404758 */     // GIR_Coverage, 20660,
     /* 1404758 */     GIR_EraseRootFromParent_Done,
     /* 1404759 */   // Label 19895: @1404759
     /* 1404759 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1404847), // Rule ID 20661 //
     /* 1404764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1404784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404803 */     // MIs[0] Operand 5
     /* 1404803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404814 */     // MIs[0] policy
     /* 1404814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1404827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404846 */     // GIR_Coverage, 20661,
     /* 1404846 */     GIR_EraseRootFromParent_Done,
     /* 1404847 */   // Label 19896: @1404847
     /* 1404847 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1404935), // Rule ID 20664 //
     /* 1404852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1404855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1404872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404891 */     // MIs[0] Operand 5
     /* 1404891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404902 */     // MIs[0] policy
     /* 1404902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1404915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404934 */     // GIR_Coverage, 20664,
     /* 1404934 */     GIR_EraseRootFromParent_Done,
     /* 1404935 */   // Label 19897: @1404935
     /* 1404935 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1405023), // Rule ID 20665 //
     /* 1404940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1404943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1404948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1404960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404979 */     // MIs[0] Operand 5
     /* 1404979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404990 */     // MIs[0] policy
     /* 1404990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1405003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405022 */     // GIR_Coverage, 20665,
     /* 1405022 */     GIR_EraseRootFromParent_Done,
     /* 1405023 */   // Label 19898: @1405023
     /* 1405023 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1405111), // Rule ID 20668 //
     /* 1405028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1405031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405067 */     // MIs[0] Operand 5
     /* 1405067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405078 */     // MIs[0] policy
     /* 1405078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1405091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405110 */     // GIR_Coverage, 20668,
     /* 1405110 */     GIR_EraseRootFromParent_Done,
     /* 1405111 */   // Label 19899: @1405111
     /* 1405111 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1405199), // Rule ID 20669 //
     /* 1405116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1405119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1405127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1405130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405155 */     // MIs[0] Operand 5
     /* 1405155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405166 */     // MIs[0] policy
     /* 1405166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1405179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405198 */     // GIR_Coverage, 20669,
     /* 1405198 */     GIR_EraseRootFromParent_Done,
     /* 1405199 */   // Label 19900: @1405199
     /* 1405199 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1405287), // Rule ID 20672 //
     /* 1405204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1405207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1405224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405243 */     // MIs[0] Operand 5
     /* 1405243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405254 */     // MIs[0] policy
     /* 1405254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1405267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405286 */     // GIR_Coverage, 20672,
     /* 1405286 */     GIR_EraseRootFromParent_Done,
     /* 1405287 */   // Label 19901: @1405287
     /* 1405287 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1405375), // Rule ID 20673 //
     /* 1405292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1405295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1405303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1405309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1405312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405331 */     // MIs[0] Operand 5
     /* 1405331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405342 */     // MIs[0] policy
     /* 1405342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1405355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405374 */     // GIR_Coverage, 20673,
     /* 1405374 */     GIR_EraseRootFromParent_Done,
     /* 1405375 */   // Label 19902: @1405375
     /* 1405375 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1405463), // Rule ID 20676 //
     /* 1405380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1405383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405419 */     // MIs[0] Operand 5
     /* 1405419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405430 */     // MIs[0] policy
     /* 1405430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1405443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405462 */     // GIR_Coverage, 20676,
     /* 1405462 */     GIR_EraseRootFromParent_Done,
     /* 1405463 */   // Label 19903: @1405463
     /* 1405463 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1405551), // Rule ID 20677 //
     /* 1405468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1405471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405507 */     // MIs[0] Operand 5
     /* 1405507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405518 */     // MIs[0] policy
     /* 1405518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1405531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405550 */     // GIR_Coverage, 20677,
     /* 1405550 */     GIR_EraseRootFromParent_Done,
     /* 1405551 */   // Label 19904: @1405551
     /* 1405551 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1405639), // Rule ID 20680 //
     /* 1405556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1405559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1405576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405595 */     // MIs[0] Operand 5
     /* 1405595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405606 */     // MIs[0] policy
     /* 1405606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1405619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405638 */     // GIR_Coverage, 20680,
     /* 1405638 */     GIR_EraseRootFromParent_Done,
     /* 1405639 */   // Label 19905: @1405639
     /* 1405639 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1405727), // Rule ID 20681 //
     /* 1405644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1405647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1405664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405683 */     // MIs[0] Operand 5
     /* 1405683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405694 */     // MIs[0] policy
     /* 1405694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1405707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405726 */     // GIR_Coverage, 20681,
     /* 1405726 */     GIR_EraseRootFromParent_Done,
     /* 1405727 */   // Label 19906: @1405727
     /* 1405727 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1405815), // Rule ID 20684 //
     /* 1405732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1405735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405771 */     // MIs[0] Operand 5
     /* 1405771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405782 */     // MIs[0] policy
     /* 1405782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405792 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1405795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405814 */     // GIR_Coverage, 20684,
     /* 1405814 */     GIR_EraseRootFromParent_Done,
     /* 1405815 */   // Label 19907: @1405815
     /* 1405815 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1405903), // Rule ID 20685 //
     /* 1405820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1405823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405859 */     // MIs[0] Operand 5
     /* 1405859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405870 */     // MIs[0] policy
     /* 1405870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1405883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405902 */     // GIR_Coverage, 20685,
     /* 1405902 */     GIR_EraseRootFromParent_Done,
     /* 1405903 */   // Label 19908: @1405903
     /* 1405903 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1405991), // Rule ID 20688 //
     /* 1405908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1405916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405947 */     // MIs[0] Operand 5
     /* 1405947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405958 */     // MIs[0] policy
     /* 1405958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1405971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405990 */     // GIR_Coverage, 20688,
     /* 1405990 */     GIR_EraseRootFromParent_Done,
     /* 1405991 */   // Label 19909: @1405991
     /* 1405991 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1406079), // Rule ID 20689 //
     /* 1405996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1406007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1406010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1406013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406035 */     // MIs[0] Operand 5
     /* 1406035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406046 */     // MIs[0] policy
     /* 1406046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1406059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406078 */     // GIR_Coverage, 20689,
     /* 1406078 */     GIR_EraseRootFromParent_Done,
     /* 1406079 */   // Label 19910: @1406079
     /* 1406079 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1406167), // Rule ID 20692 //
     /* 1406084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406123 */     // MIs[0] Operand 5
     /* 1406123 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406134 */     // MIs[0] policy
     /* 1406134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1406147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406166 */     // GIR_Coverage, 20692,
     /* 1406166 */     GIR_EraseRootFromParent_Done,
     /* 1406167 */   // Label 19911: @1406167
     /* 1406167 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1406255), // Rule ID 20693 //
     /* 1406172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1406183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1406186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406211 */     // MIs[0] Operand 5
     /* 1406211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406222 */     // MIs[0] policy
     /* 1406222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1406235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406254 */     // GIR_Coverage, 20693,
     /* 1406254 */     GIR_EraseRootFromParent_Done,
     /* 1406255 */   // Label 19912: @1406255
     /* 1406255 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1406343), // Rule ID 20696 //
     /* 1406260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406299 */     // MIs[0] Operand 5
     /* 1406299 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406310 */     // MIs[0] policy
     /* 1406310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1406323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406342 */     // GIR_Coverage, 20696,
     /* 1406342 */     GIR_EraseRootFromParent_Done,
     /* 1406343 */   // Label 19913: @1406343
     /* 1406343 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1406431), // Rule ID 20697 //
     /* 1406348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1406359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1406362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406387 */     // MIs[0] Operand 5
     /* 1406387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406398 */     // MIs[0] policy
     /* 1406398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1406411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406430 */     // GIR_Coverage, 20697,
     /* 1406430 */     GIR_EraseRootFromParent_Done,
     /* 1406431 */   // Label 19914: @1406431
     /* 1406431 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1406519), // Rule ID 20700 //
     /* 1406436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406475 */     // MIs[0] Operand 5
     /* 1406475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406486 */     // MIs[0] policy
     /* 1406486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406518 */     // GIR_Coverage, 20700,
     /* 1406518 */     GIR_EraseRootFromParent_Done,
     /* 1406519 */   // Label 19915: @1406519
     /* 1406519 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1406607), // Rule ID 20701 //
     /* 1406524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406563 */     // MIs[0] Operand 5
     /* 1406563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406574 */     // MIs[0] policy
     /* 1406574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406606 */     // GIR_Coverage, 20701,
     /* 1406606 */     GIR_EraseRootFromParent_Done,
     /* 1406607 */   // Label 19916: @1406607
     /* 1406607 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1406695), // Rule ID 20704 //
     /* 1406612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406651 */     // MIs[0] Operand 5
     /* 1406651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406662 */     // MIs[0] policy
     /* 1406662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406694 */     // GIR_Coverage, 20704,
     /* 1406694 */     GIR_EraseRootFromParent_Done,
     /* 1406695 */   // Label 19917: @1406695
     /* 1406695 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1406783), // Rule ID 20705 //
     /* 1406700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406739 */     // MIs[0] Operand 5
     /* 1406739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406750 */     // MIs[0] policy
     /* 1406750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406782 */     // GIR_Coverage, 20705,
     /* 1406782 */     GIR_EraseRootFromParent_Done,
     /* 1406783 */   // Label 19918: @1406783
     /* 1406783 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1406871), // Rule ID 20708 //
     /* 1406788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1406791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406827 */     // MIs[0] Operand 5
     /* 1406827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406838 */     // MIs[0] policy
     /* 1406838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406870 */     // GIR_Coverage, 20708,
     /* 1406870 */     GIR_EraseRootFromParent_Done,
     /* 1406871 */   // Label 19919: @1406871
     /* 1406871 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1406959), // Rule ID 20709 //
     /* 1406876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1406879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406915 */     // MIs[0] Operand 5
     /* 1406915 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406926 */     // MIs[0] policy
     /* 1406926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406936 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1406939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406958 */     // GIR_Coverage, 20709,
     /* 1406958 */     GIR_EraseRootFromParent_Done,
     /* 1406959 */   // Label 19920: @1406959
     /* 1406959 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1407047), // Rule ID 20712 //
     /* 1406964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1406972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407003 */     // MIs[0] Operand 5
     /* 1407003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407014 */     // MIs[0] policy
     /* 1407014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1407027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407046 */     // GIR_Coverage, 20712,
     /* 1407046 */     GIR_EraseRootFromParent_Done,
     /* 1407047 */   // Label 19921: @1407047
     /* 1407047 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1407135), // Rule ID 20713 //
     /* 1407052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1407063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1407066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407091 */     // MIs[0] Operand 5
     /* 1407091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407102 */     // MIs[0] policy
     /* 1407102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1407115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407134 */     // GIR_Coverage, 20713,
     /* 1407134 */     GIR_EraseRootFromParent_Done,
     /* 1407135 */   // Label 19922: @1407135
     /* 1407135 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1407223), // Rule ID 20716 //
     /* 1407140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407179 */     // MIs[0] Operand 5
     /* 1407179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407190 */     // MIs[0] policy
     /* 1407190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1407203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407222 */     // GIR_Coverage, 20716,
     /* 1407222 */     GIR_EraseRootFromParent_Done,
     /* 1407223 */   // Label 19923: @1407223
     /* 1407223 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1407311), // Rule ID 20717 //
     /* 1407228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1407239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1407242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1407245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407267 */     // MIs[0] Operand 5
     /* 1407267 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407278 */     // MIs[0] policy
     /* 1407278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1407291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407310 */     // GIR_Coverage, 20717,
     /* 1407310 */     GIR_EraseRootFromParent_Done,
     /* 1407311 */   // Label 19924: @1407311
     /* 1407311 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1407399), // Rule ID 20720 //
     /* 1407316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407355 */     // MIs[0] Operand 5
     /* 1407355 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407366 */     // MIs[0] policy
     /* 1407366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1407379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407398 */     // GIR_Coverage, 20720,
     /* 1407398 */     GIR_EraseRootFromParent_Done,
     /* 1407399 */   // Label 19925: @1407399
     /* 1407399 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1407487), // Rule ID 20721 //
     /* 1407404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407443 */     // MIs[0] Operand 5
     /* 1407443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407454 */     // MIs[0] policy
     /* 1407454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407464 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1407467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407486 */     // GIR_Coverage, 20721,
     /* 1407486 */     GIR_EraseRootFromParent_Done,
     /* 1407487 */   // Label 19926: @1407487
     /* 1407487 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1407575), // Rule ID 20724 //
     /* 1407492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407531 */     // MIs[0] Operand 5
     /* 1407531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407542 */     // MIs[0] policy
     /* 1407542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1407555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407574 */     // GIR_Coverage, 20724,
     /* 1407574 */     GIR_EraseRootFromParent_Done,
     /* 1407575 */   // Label 19927: @1407575
     /* 1407575 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1407663), // Rule ID 20725 //
     /* 1407580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407619 */     // MIs[0] Operand 5
     /* 1407619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407630 */     // MIs[0] policy
     /* 1407630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1407643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407662 */     // GIR_Coverage, 20725,
     /* 1407662 */     GIR_EraseRootFromParent_Done,
     /* 1407663 */   // Label 19928: @1407663
     /* 1407663 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1407751), // Rule ID 20728 //
     /* 1407668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407707 */     // MIs[0] Operand 5
     /* 1407707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407718 */     // MIs[0] policy
     /* 1407718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407728 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1407731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407750 */     // GIR_Coverage, 20728,
     /* 1407750 */     GIR_EraseRootFromParent_Done,
     /* 1407751 */   // Label 19929: @1407751
     /* 1407751 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1407839), // Rule ID 20729 //
     /* 1407756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407795 */     // MIs[0] Operand 5
     /* 1407795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407806 */     // MIs[0] policy
     /* 1407806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1407819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407838 */     // GIR_Coverage, 20729,
     /* 1407838 */     GIR_EraseRootFromParent_Done,
     /* 1407839 */   // Label 19930: @1407839
     /* 1407839 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1407927), // Rule ID 20732 //
     /* 1407844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407883 */     // MIs[0] Operand 5
     /* 1407883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407894 */     // MIs[0] policy
     /* 1407894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1407907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407926 */     // GIR_Coverage, 20732,
     /* 1407926 */     GIR_EraseRootFromParent_Done,
     /* 1407927 */   // Label 19931: @1407927
     /* 1407927 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1408015), // Rule ID 20733 //
     /* 1407932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1407940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407971 */     // MIs[0] Operand 5
     /* 1407971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407982 */     // MIs[0] policy
     /* 1407982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1407995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408014 */     // GIR_Coverage, 20733,
     /* 1408014 */     GIR_EraseRootFromParent_Done,
     /* 1408015 */   // Label 19932: @1408015
     /* 1408015 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1408103), // Rule ID 20736 //
     /* 1408020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408059 */     // MIs[0] Operand 5
     /* 1408059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408070 */     // MIs[0] policy
     /* 1408070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1408083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408102 */     // GIR_Coverage, 20736,
     /* 1408102 */     GIR_EraseRootFromParent_Done,
     /* 1408103 */   // Label 19933: @1408103
     /* 1408103 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1408191), // Rule ID 20737 //
     /* 1408108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1408119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1408122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1408125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408147 */     // MIs[0] Operand 5
     /* 1408147 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408158 */     // MIs[0] policy
     /* 1408158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408168 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1408171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408190 */     // GIR_Coverage, 20737,
     /* 1408190 */     GIR_EraseRootFromParent_Done,
     /* 1408191 */   // Label 19934: @1408191
     /* 1408191 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1408279), // Rule ID 20740 //
     /* 1408196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408235 */     // MIs[0] Operand 5
     /* 1408235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408246 */     // MIs[0] policy
     /* 1408246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1408259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408278 */     // GIR_Coverage, 20740,
     /* 1408278 */     GIR_EraseRootFromParent_Done,
     /* 1408279 */   // Label 19935: @1408279
     /* 1408279 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1408367), // Rule ID 20741 //
     /* 1408284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1408295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1408298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1408301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408323 */     // MIs[0] Operand 5
     /* 1408323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408334 */     // MIs[0] policy
     /* 1408334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1408347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408366 */     // GIR_Coverage, 20741,
     /* 1408366 */     GIR_EraseRootFromParent_Done,
     /* 1408367 */   // Label 19936: @1408367
     /* 1408367 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1408455), // Rule ID 20744 //
     /* 1408372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1408375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408411 */     // MIs[0] Operand 5
     /* 1408411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408422 */     // MIs[0] policy
     /* 1408422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1408435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408454 */     // GIR_Coverage, 20744,
     /* 1408454 */     GIR_EraseRootFromParent_Done,
     /* 1408455 */   // Label 19937: @1408455
     /* 1408455 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1408543), // Rule ID 20745 //
     /* 1408460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408499 */     // MIs[0] Operand 5
     /* 1408499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408510 */     // MIs[0] policy
     /* 1408510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1408523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408542 */     // GIR_Coverage, 20745,
     /* 1408542 */     GIR_EraseRootFromParent_Done,
     /* 1408543 */   // Label 19938: @1408543
     /* 1408543 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1408631), // Rule ID 21104 //
     /* 1408548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408587 */     // MIs[0] Operand 5
     /* 1408587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408598 */     // MIs[0] policy
     /* 1408598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408608 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408630 */     // GIR_Coverage, 21104,
     /* 1408630 */     GIR_EraseRootFromParent_Done,
     /* 1408631 */   // Label 19939: @1408631
     /* 1408631 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1408719), // Rule ID 21105 //
     /* 1408636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408675 */     // MIs[0] Operand 5
     /* 1408675 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408686 */     // MIs[0] policy
     /* 1408686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408718 */     // GIR_Coverage, 21105,
     /* 1408718 */     GIR_EraseRootFromParent_Done,
     /* 1408719 */   // Label 19940: @1408719
     /* 1408719 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1408807), // Rule ID 21108 //
     /* 1408724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408763 */     // MIs[0] Operand 5
     /* 1408763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408774 */     // MIs[0] policy
     /* 1408774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408806 */     // GIR_Coverage, 21108,
     /* 1408806 */     GIR_EraseRootFromParent_Done,
     /* 1408807 */   // Label 19941: @1408807
     /* 1408807 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1408895), // Rule ID 21109 //
     /* 1408812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408851 */     // MIs[0] Operand 5
     /* 1408851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408862 */     // MIs[0] policy
     /* 1408862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408894 */     // GIR_Coverage, 21109,
     /* 1408894 */     GIR_EraseRootFromParent_Done,
     /* 1408895 */   // Label 19942: @1408895
     /* 1408895 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1408983), // Rule ID 21112 //
     /* 1408900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1408911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1408914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1408917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408939 */     // MIs[0] Operand 5
     /* 1408939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408950 */     // MIs[0] policy
     /* 1408950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408982 */     // GIR_Coverage, 21112,
     /* 1408982 */     GIR_EraseRootFromParent_Done,
     /* 1408983 */   // Label 19943: @1408983
     /* 1408983 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1409071), // Rule ID 21113 //
     /* 1408988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1408996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1408999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1409005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409027 */     // MIs[0] Operand 5
     /* 1409027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409038 */     // MIs[0] policy
     /* 1409038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409070 */     // GIR_Coverage, 21113,
     /* 1409070 */     GIR_EraseRootFromParent_Done,
     /* 1409071 */   // Label 19944: @1409071
     /* 1409071 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1409159), // Rule ID 21116 //
     /* 1409076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409115 */     // MIs[0] Operand 5
     /* 1409115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409126 */     // MIs[0] policy
     /* 1409126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409158 */     // GIR_Coverage, 21116,
     /* 1409158 */     GIR_EraseRootFromParent_Done,
     /* 1409159 */   // Label 19945: @1409159
     /* 1409159 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1409247), // Rule ID 21117 //
     /* 1409164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409203 */     // MIs[0] Operand 5
     /* 1409203 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409214 */     // MIs[0] policy
     /* 1409214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409246 */     // GIR_Coverage, 21117,
     /* 1409246 */     GIR_EraseRootFromParent_Done,
     /* 1409247 */   // Label 19946: @1409247
     /* 1409247 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1409335), // Rule ID 21120 //
     /* 1409252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1409263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1409266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409291 */     // MIs[0] Operand 5
     /* 1409291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409302 */     // MIs[0] policy
     /* 1409302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409334 */     // GIR_Coverage, 21120,
     /* 1409334 */     GIR_EraseRootFromParent_Done,
     /* 1409335 */   // Label 19947: @1409335
     /* 1409335 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1409423), // Rule ID 21121 //
     /* 1409340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1409351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1409354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409379 */     // MIs[0] Operand 5
     /* 1409379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409390 */     // MIs[0] policy
     /* 1409390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409422 */     // GIR_Coverage, 21121,
     /* 1409422 */     GIR_EraseRootFromParent_Done,
     /* 1409423 */   // Label 19948: @1409423
     /* 1409423 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1409511), // Rule ID 21124 //
     /* 1409428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1409431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409467 */     // MIs[0] Operand 5
     /* 1409467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409478 */     // MIs[0] policy
     /* 1409478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409510 */     // GIR_Coverage, 21124,
     /* 1409510 */     GIR_EraseRootFromParent_Done,
     /* 1409511 */   // Label 19949: @1409511
     /* 1409511 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1409599), // Rule ID 21125 //
     /* 1409516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1409519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1409533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409555 */     // MIs[0] Operand 5
     /* 1409555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409566 */     // MIs[0] policy
     /* 1409566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1409579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409598 */     // GIR_Coverage, 21125,
     /* 1409598 */     GIR_EraseRootFromParent_Done,
     /* 1409599 */   // Label 19950: @1409599
     /* 1409599 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1409687), // Rule ID 21128 //
     /* 1409604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1409607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1409615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1409618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409643 */     // MIs[0] Operand 5
     /* 1409643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409654 */     // MIs[0] policy
     /* 1409654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409664 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409686 */     // GIR_Coverage, 21128,
     /* 1409686 */     GIR_EraseRootFromParent_Done,
     /* 1409687 */   // Label 19951: @1409687
     /* 1409687 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1409775), // Rule ID 21129 //
     /* 1409692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1409695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1409703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1409706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1409709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409731 */     // MIs[0] Operand 5
     /* 1409731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409742 */     // MIs[0] policy
     /* 1409742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409774 */     // GIR_Coverage, 21129,
     /* 1409774 */     GIR_EraseRootFromParent_Done,
     /* 1409775 */   // Label 19952: @1409775
     /* 1409775 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1409863), // Rule ID 21132 //
     /* 1409780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1409783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1409791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1409794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409819 */     // MIs[0] Operand 5
     /* 1409819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409830 */     // MIs[0] policy
     /* 1409830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409862 */     // GIR_Coverage, 21132,
     /* 1409862 */     GIR_EraseRootFromParent_Done,
     /* 1409863 */   // Label 19953: @1409863
     /* 1409863 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1409951), // Rule ID 21133 //
     /* 1409868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1409871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1409879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1409882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409907 */     // MIs[0] Operand 5
     /* 1409907 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409918 */     // MIs[0] policy
     /* 1409918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409928 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409950 */     // GIR_Coverage, 21133,
     /* 1409950 */     GIR_EraseRootFromParent_Done,
     /* 1409951 */   // Label 19954: @1409951
     /* 1409951 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1410039), // Rule ID 21136 //
     /* 1409956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1409959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1409964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1409967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1409970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1409973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409995 */     // MIs[0] Operand 5
     /* 1409995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410006 */     // MIs[0] policy
     /* 1410006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410038 */     // GIR_Coverage, 21136,
     /* 1410038 */     GIR_EraseRootFromParent_Done,
     /* 1410039 */   // Label 19955: @1410039
     /* 1410039 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1410127), // Rule ID 21137 //
     /* 1410044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1410047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410083 */     // MIs[0] Operand 5
     /* 1410083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410094 */     // MIs[0] policy
     /* 1410094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410126 */     // GIR_Coverage, 21137,
     /* 1410126 */     GIR_EraseRootFromParent_Done,
     /* 1410127 */   // Label 19956: @1410127
     /* 1410127 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1410215), // Rule ID 21140 //
     /* 1410132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410171 */     // MIs[0] Operand 5
     /* 1410171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410182 */     // MIs[0] policy
     /* 1410182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1410195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410214 */     // GIR_Coverage, 21140,
     /* 1410214 */     GIR_EraseRootFromParent_Done,
     /* 1410215 */   // Label 19957: @1410215
     /* 1410215 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1410303), // Rule ID 21141 //
     /* 1410220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410259 */     // MIs[0] Operand 5
     /* 1410259 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410270 */     // MIs[0] policy
     /* 1410270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1410283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410302 */     // GIR_Coverage, 21141,
     /* 1410302 */     GIR_EraseRootFromParent_Done,
     /* 1410303 */   // Label 19958: @1410303
     /* 1410303 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1410391), // Rule ID 21144 //
     /* 1410308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410347 */     // MIs[0] Operand 5
     /* 1410347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410358 */     // MIs[0] policy
     /* 1410358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1410371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410390 */     // GIR_Coverage, 21144,
     /* 1410390 */     GIR_EraseRootFromParent_Done,
     /* 1410391 */   // Label 19959: @1410391
     /* 1410391 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1410479), // Rule ID 21145 //
     /* 1410396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410435 */     // MIs[0] Operand 5
     /* 1410435 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410446 */     // MIs[0] policy
     /* 1410446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1410459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410478 */     // GIR_Coverage, 21145,
     /* 1410478 */     GIR_EraseRootFromParent_Done,
     /* 1410479 */   // Label 19960: @1410479
     /* 1410479 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1410567), // Rule ID 21148 //
     /* 1410484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1410501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410523 */     // MIs[0] Operand 5
     /* 1410523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410534 */     // MIs[0] policy
     /* 1410534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1410547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410566 */     // GIR_Coverage, 21148,
     /* 1410566 */     GIR_EraseRootFromParent_Done,
     /* 1410567 */   // Label 19961: @1410567
     /* 1410567 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1410655), // Rule ID 21149 //
     /* 1410572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1410583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1410586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1410589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410611 */     // MIs[0] Operand 5
     /* 1410611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410622 */     // MIs[0] policy
     /* 1410622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1410635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410654 */     // GIR_Coverage, 21149,
     /* 1410654 */     GIR_EraseRootFromParent_Done,
     /* 1410655 */   // Label 19962: @1410655
     /* 1410655 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1410743), // Rule ID 21152 //
     /* 1410660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410699 */     // MIs[0] Operand 5
     /* 1410699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410710 */     // MIs[0] policy
     /* 1410710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410720 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1410723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410742 */     // GIR_Coverage, 21152,
     /* 1410742 */     GIR_EraseRootFromParent_Done,
     /* 1410743 */   // Label 19963: @1410743
     /* 1410743 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1410831), // Rule ID 21153 //
     /* 1410748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410787 */     // MIs[0] Operand 5
     /* 1410787 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410798 */     // MIs[0] policy
     /* 1410798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410808 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1410811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410830 */     // GIR_Coverage, 21153,
     /* 1410830 */     GIR_EraseRootFromParent_Done,
     /* 1410831 */   // Label 19964: @1410831
     /* 1410831 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1410919), // Rule ID 21156 //
     /* 1410836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410875 */     // MIs[0] Operand 5
     /* 1410875 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410886 */     // MIs[0] policy
     /* 1410886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1410899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410918 */     // GIR_Coverage, 21156,
     /* 1410918 */     GIR_EraseRootFromParent_Done,
     /* 1410919 */   // Label 19965: @1410919
     /* 1410919 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1411007), // Rule ID 21157 //
     /* 1410924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1410932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410963 */     // MIs[0] Operand 5
     /* 1410963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410974 */     // MIs[0] policy
     /* 1410974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1410987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411006 */     // GIR_Coverage, 21157,
     /* 1411006 */     GIR_EraseRootFromParent_Done,
     /* 1411007 */   // Label 19966: @1411007
     /* 1411007 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1411095), // Rule ID 21160 //
     /* 1411012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411051 */     // MIs[0] Operand 5
     /* 1411051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411062 */     // MIs[0] policy
     /* 1411062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1411075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411094 */     // GIR_Coverage, 21160,
     /* 1411094 */     GIR_EraseRootFromParent_Done,
     /* 1411095 */   // Label 19967: @1411095
     /* 1411095 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1411183), // Rule ID 21161 //
     /* 1411100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411139 */     // MIs[0] Operand 5
     /* 1411139 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411150 */     // MIs[0] policy
     /* 1411150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1411163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411182 */     // GIR_Coverage, 21161,
     /* 1411182 */     GIR_EraseRootFromParent_Done,
     /* 1411183 */   // Label 19968: @1411183
     /* 1411183 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1411271), // Rule ID 21164 //
     /* 1411188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411227 */     // MIs[0] Operand 5
     /* 1411227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411238 */     // MIs[0] policy
     /* 1411238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1411251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411270 */     // GIR_Coverage, 21164,
     /* 1411270 */     GIR_EraseRootFromParent_Done,
     /* 1411271 */   // Label 19969: @1411271
     /* 1411271 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1411359), // Rule ID 21165 //
     /* 1411276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411315 */     // MIs[0] Operand 5
     /* 1411315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411326 */     // MIs[0] policy
     /* 1411326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1411339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411358 */     // GIR_Coverage, 21165,
     /* 1411358 */     GIR_EraseRootFromParent_Done,
     /* 1411359 */   // Label 19970: @1411359
     /* 1411359 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1411447), // Rule ID 21168 //
     /* 1411364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1411375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1411378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1411381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411403 */     // MIs[0] Operand 5
     /* 1411403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411414 */     // MIs[0] policy
     /* 1411414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1411427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411446 */     // GIR_Coverage, 21168,
     /* 1411446 */     GIR_EraseRootFromParent_Done,
     /* 1411447 */   // Label 19971: @1411447
     /* 1411447 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1411535), // Rule ID 21169 //
     /* 1411452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1411463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1411466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1411469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411491 */     // MIs[0] Operand 5
     /* 1411491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411502 */     // MIs[0] policy
     /* 1411502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1411515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411534 */     // GIR_Coverage, 21169,
     /* 1411534 */     GIR_EraseRootFromParent_Done,
     /* 1411535 */   // Label 19972: @1411535
     /* 1411535 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1411623), // Rule ID 21172 //
     /* 1411540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411579 */     // MIs[0] Operand 5
     /* 1411579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411590 */     // MIs[0] policy
     /* 1411590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411600 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1411603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411622 */     // GIR_Coverage, 21172,
     /* 1411622 */     GIR_EraseRootFromParent_Done,
     /* 1411623 */   // Label 19973: @1411623
     /* 1411623 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1411711), // Rule ID 21173 //
     /* 1411628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1411636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1411639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1411642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411667 */     // MIs[0] Operand 5
     /* 1411667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411678 */     // MIs[0] policy
     /* 1411678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1411691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411710 */     // GIR_Coverage, 21173,
     /* 1411710 */     GIR_EraseRootFromParent_Done,
     /* 1411711 */   // Label 19974: @1411711
     /* 1411711 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1411799), // Rule ID 21476 //
     /* 1411716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1411724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1411727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1411730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411755 */     // MIs[0] Operand 5
     /* 1411755 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411766 */     // MIs[0] policy
     /* 1411766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1411779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1411795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411798 */     // GIR_Coverage, 21476,
     /* 1411798 */     GIR_EraseRootFromParent_Done,
     /* 1411799 */   // Label 19975: @1411799
     /* 1411799 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1411887), // Rule ID 21477 //
     /* 1411804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1411812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1411815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1411818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1411821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411843 */     // MIs[0] Operand 5
     /* 1411843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411854 */     // MIs[0] policy
     /* 1411854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1411867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1411883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411886 */     // GIR_Coverage, 21477,
     /* 1411886 */     GIR_EraseRootFromParent_Done,
     /* 1411887 */   // Label 19976: @1411887
     /* 1411887 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1411975), // Rule ID 21480 //
     /* 1411892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1411900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1411903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1411906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411931 */     // MIs[0] Operand 5
     /* 1411931 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411942 */     // MIs[0] policy
     /* 1411942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1411955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1411971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411974 */     // GIR_Coverage, 21480,
     /* 1411974 */     GIR_EraseRootFromParent_Done,
     /* 1411975 */   // Label 19977: @1411975
     /* 1411975 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1412063), // Rule ID 21481 //
     /* 1411980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1411988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1411991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1411994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412019 */     // MIs[0] Operand 5
     /* 1412019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412030 */     // MIs[0] policy
     /* 1412030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412040 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1412043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412062 */     // GIR_Coverage, 21481,
     /* 1412062 */     GIR_EraseRootFromParent_Done,
     /* 1412063 */   // Label 19978: @1412063
     /* 1412063 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1412151), // Rule ID 21484 //
     /* 1412068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1412079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1412082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412107 */     // MIs[0] Operand 5
     /* 1412107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412118 */     // MIs[0] policy
     /* 1412118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1412131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412150 */     // GIR_Coverage, 21484,
     /* 1412150 */     GIR_EraseRootFromParent_Done,
     /* 1412151 */   // Label 19979: @1412151
     /* 1412151 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1412239), // Rule ID 21485 //
     /* 1412156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1412167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1412170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412195 */     // MIs[0] Operand 5
     /* 1412195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412206 */     // MIs[0] policy
     /* 1412206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1412219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412238 */     // GIR_Coverage, 21485,
     /* 1412238 */     GIR_EraseRootFromParent_Done,
     /* 1412239 */   // Label 19980: @1412239
     /* 1412239 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1412327), // Rule ID 21488 //
     /* 1412244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1412255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1412258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1412261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412283 */     // MIs[0] Operand 5
     /* 1412283 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412294 */     // MIs[0] policy
     /* 1412294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412304 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1412307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412326 */     // GIR_Coverage, 21488,
     /* 1412326 */     GIR_EraseRootFromParent_Done,
     /* 1412327 */   // Label 19981: @1412327
     /* 1412327 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1412415), // Rule ID 21489 //
     /* 1412332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1412343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1412346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1412349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412371 */     // MIs[0] Operand 5
     /* 1412371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412382 */     // MIs[0] policy
     /* 1412382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1412395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412414 */     // GIR_Coverage, 21489,
     /* 1412414 */     GIR_EraseRootFromParent_Done,
     /* 1412415 */   // Label 19982: @1412415
     /* 1412415 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1412503), // Rule ID 21492 //
     /* 1412420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1412431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1412434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1412437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1412440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412459 */     // MIs[0] Operand 5
     /* 1412459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412470 */     // MIs[0] policy
     /* 1412470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1412483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412502 */     // GIR_Coverage, 21492,
     /* 1412502 */     GIR_EraseRootFromParent_Done,
     /* 1412503 */   // Label 19983: @1412503
     /* 1412503 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1412591), // Rule ID 21493 //
     /* 1412508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1412519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1412522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1412525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1412528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412547 */     // MIs[0] Operand 5
     /* 1412547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412558 */     // MIs[0] policy
     /* 1412558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1412571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412590 */     // GIR_Coverage, 21493,
     /* 1412590 */     GIR_EraseRootFromParent_Done,
     /* 1412591 */   // Label 19984: @1412591
     /* 1412591 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1412679), // Rule ID 21496 //
     /* 1412596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1412607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1412610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1412613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1412616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412635 */     // MIs[0] Operand 5
     /* 1412635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412646 */     // MIs[0] policy
     /* 1412646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1412659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412678 */     // GIR_Coverage, 21496,
     /* 1412678 */     GIR_EraseRootFromParent_Done,
     /* 1412679 */   // Label 19985: @1412679
     /* 1412679 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1412767), // Rule ID 21497 //
     /* 1412684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1412695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1412698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1412701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1412704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412723 */     // MIs[0] Operand 5
     /* 1412723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412734 */     // MIs[0] policy
     /* 1412734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1412747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412766 */     // GIR_Coverage, 21497,
     /* 1412766 */     GIR_EraseRootFromParent_Done,
     /* 1412767 */   // Label 19986: @1412767
     /* 1412767 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1412855), // Rule ID 21500 //
     /* 1412772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1412775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1412783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1412786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412811 */     // MIs[0] Operand 5
     /* 1412811 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412822 */     // MIs[0] policy
     /* 1412822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1412835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412854 */     // GIR_Coverage, 21500,
     /* 1412854 */     GIR_EraseRootFromParent_Done,
     /* 1412855 */   // Label 19987: @1412855
     /* 1412855 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1412943), // Rule ID 21501 //
     /* 1412860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1412863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1412871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1412874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1412877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412899 */     // MIs[0] Operand 5
     /* 1412899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412910 */     // MIs[0] policy
     /* 1412910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1412923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412942 */     // GIR_Coverage, 21501,
     /* 1412942 */     GIR_EraseRootFromParent_Done,
     /* 1412943 */   // Label 19988: @1412943
     /* 1412943 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1413031), // Rule ID 21504 //
     /* 1412948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1412951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1412956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1412959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1412962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1412965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412987 */     // MIs[0] Operand 5
     /* 1412987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412998 */     // MIs[0] policy
     /* 1412998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413008 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1413011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413030 */     // GIR_Coverage, 21504,
     /* 1413030 */     GIR_EraseRootFromParent_Done,
     /* 1413031 */   // Label 19989: @1413031
     /* 1413031 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1413119), // Rule ID 21505 //
     /* 1413036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1413047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1413050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413075 */     // MIs[0] Operand 5
     /* 1413075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413086 */     // MIs[0] policy
     /* 1413086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1413099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413118 */     // GIR_Coverage, 21505,
     /* 1413118 */     GIR_EraseRootFromParent_Done,
     /* 1413119 */   // Label 19990: @1413119
     /* 1413119 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1413207), // Rule ID 21508 //
     /* 1413124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1413135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1413138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413163 */     // MIs[0] Operand 5
     /* 1413163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413174 */     // MIs[0] policy
     /* 1413174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1413187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413206 */     // GIR_Coverage, 21508,
     /* 1413206 */     GIR_EraseRootFromParent_Done,
     /* 1413207 */   // Label 19991: @1413207
     /* 1413207 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1413295), // Rule ID 21509 //
     /* 1413212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1413223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1413226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413251 */     // MIs[0] Operand 5
     /* 1413251 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413262 */     // MIs[0] policy
     /* 1413262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413272 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1413275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413294 */     // GIR_Coverage, 21509,
     /* 1413294 */     GIR_EraseRootFromParent_Done,
     /* 1413295 */   // Label 19992: @1413295
     /* 1413295 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1413383), // Rule ID 21512 //
     /* 1413300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1413311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1413314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413339 */     // MIs[0] Operand 5
     /* 1413339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413350 */     // MIs[0] policy
     /* 1413350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413360 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1413363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413382 */     // GIR_Coverage, 21512,
     /* 1413382 */     GIR_EraseRootFromParent_Done,
     /* 1413383 */   // Label 19993: @1413383
     /* 1413383 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1413471), // Rule ID 21513 //
     /* 1413388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1413399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1413402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413427 */     // MIs[0] Operand 5
     /* 1413427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413438 */     // MIs[0] policy
     /* 1413438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1413451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413470 */     // GIR_Coverage, 21513,
     /* 1413470 */     GIR_EraseRootFromParent_Done,
     /* 1413471 */   // Label 19994: @1413471
     /* 1413471 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1413559), // Rule ID 21516 //
     /* 1413476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1413479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1413487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1413490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1413493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413515 */     // MIs[0] Operand 5
     /* 1413515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413526 */     // MIs[0] policy
     /* 1413526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1413539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413558 */     // GIR_Coverage, 21516,
     /* 1413558 */     GIR_EraseRootFromParent_Done,
     /* 1413559 */   // Label 19995: @1413559
     /* 1413559 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1413647), // Rule ID 21517 //
     /* 1413564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1413567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1413575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1413578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1413581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413603 */     // MIs[0] Operand 5
     /* 1413603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413614 */     // MIs[0] policy
     /* 1413614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1413627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413646 */     // GIR_Coverage, 21517,
     /* 1413646 */     GIR_EraseRootFromParent_Done,
     /* 1413647 */   // Label 19996: @1413647
     /* 1413647 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1413735), // Rule ID 21520 //
     /* 1413652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1413655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1413669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413691 */     // MIs[0] Operand 5
     /* 1413691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413702 */     // MIs[0] policy
     /* 1413702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1413715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413734 */     // GIR_Coverage, 21520,
     /* 1413734 */     GIR_EraseRootFromParent_Done,
     /* 1413735 */   // Label 19997: @1413735
     /* 1413735 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1413823), // Rule ID 21521 //
     /* 1413740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1413743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1413757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413779 */     // MIs[0] Operand 5
     /* 1413779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413790 */     // MIs[0] policy
     /* 1413790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1413803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413822 */     // GIR_Coverage, 21521,
     /* 1413822 */     GIR_EraseRootFromParent_Done,
     /* 1413823 */   // Label 19998: @1413823
     /* 1413823 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1413911), // Rule ID 21524 //
     /* 1413828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1413831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1413845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413867 */     // MIs[0] Operand 5
     /* 1413867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413878 */     // MIs[0] policy
     /* 1413878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1413891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413910 */     // GIR_Coverage, 21524,
     /* 1413910 */     GIR_EraseRootFromParent_Done,
     /* 1413911 */   // Label 19999: @1413911
     /* 1413911 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1413999), // Rule ID 21525 //
     /* 1413916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1413919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1413927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1413930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1413933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413955 */     // MIs[0] Operand 5
     /* 1413955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413966 */     // MIs[0] policy
     /* 1413966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413976 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1413979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413998 */     // GIR_Coverage, 21525,
     /* 1413998 */     GIR_EraseRootFromParent_Done,
     /* 1413999 */   // Label 20000: @1413999
     /* 1413999 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1414087), // Rule ID 21528 //
     /* 1414004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1414007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1414015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1414018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1414021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414043 */     // MIs[0] Operand 5
     /* 1414043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414054 */     // MIs[0] policy
     /* 1414054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414086 */     // GIR_Coverage, 21528,
     /* 1414086 */     GIR_EraseRootFromParent_Done,
     /* 1414087 */   // Label 20001: @1414087
     /* 1414087 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1414175), // Rule ID 21529 //
     /* 1414092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1414095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1414103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1414106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1414109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414131 */     // MIs[0] Operand 5
     /* 1414131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414142 */     // MIs[0] policy
     /* 1414142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414174 */     // GIR_Coverage, 21529,
     /* 1414174 */     GIR_EraseRootFromParent_Done,
     /* 1414175 */   // Label 20002: @1414175
     /* 1414175 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1414263), // Rule ID 21532 //
     /* 1414180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1414183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1414191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1414194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1414197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414219 */     // MIs[0] Operand 5
     /* 1414219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414230 */     // MIs[0] policy
     /* 1414230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414262 */     // GIR_Coverage, 21532,
     /* 1414262 */     GIR_EraseRootFromParent_Done,
     /* 1414263 */   // Label 20003: @1414263
     /* 1414263 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1414351), // Rule ID 21533 //
     /* 1414268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1414271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1414279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1414282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1414285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414307 */     // MIs[0] Operand 5
     /* 1414307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414318 */     // MIs[0] policy
     /* 1414318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414350 */     // GIR_Coverage, 21533,
     /* 1414350 */     GIR_EraseRootFromParent_Done,
     /* 1414351 */   // Label 20004: @1414351
     /* 1414351 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1414439), // Rule ID 21536 //
     /* 1414356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414395 */     // MIs[0] Operand 5
     /* 1414395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414406 */     // MIs[0] policy
     /* 1414406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1414419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414438 */     // GIR_Coverage, 21536,
     /* 1414438 */     GIR_EraseRootFromParent_Done,
     /* 1414439 */   // Label 20005: @1414439
     /* 1414439 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1414527), // Rule ID 21537 //
     /* 1414444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414483 */     // MIs[0] Operand 5
     /* 1414483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414494 */     // MIs[0] policy
     /* 1414494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1414507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414526 */     // GIR_Coverage, 21537,
     /* 1414526 */     GIR_EraseRootFromParent_Done,
     /* 1414527 */   // Label 20006: @1414527
     /* 1414527 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1414615), // Rule ID 21540 //
     /* 1414532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414571 */     // MIs[0] Operand 5
     /* 1414571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414582 */     // MIs[0] policy
     /* 1414582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1414595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414614 */     // GIR_Coverage, 21540,
     /* 1414614 */     GIR_EraseRootFromParent_Done,
     /* 1414615 */   // Label 20007: @1414615
     /* 1414615 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1414703), // Rule ID 21541 //
     /* 1414620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414659 */     // MIs[0] Operand 5
     /* 1414659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414670 */     // MIs[0] policy
     /* 1414670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1414683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414702 */     // GIR_Coverage, 21541,
     /* 1414702 */     GIR_EraseRootFromParent_Done,
     /* 1414703 */   // Label 20008: @1414703
     /* 1414703 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1414791), // Rule ID 21544 //
     /* 1414708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414747 */     // MIs[0] Operand 5
     /* 1414747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414758 */     // MIs[0] policy
     /* 1414758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1414771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414790 */     // GIR_Coverage, 21544,
     /* 1414790 */     GIR_EraseRootFromParent_Done,
     /* 1414791 */   // Label 20009: @1414791
     /* 1414791 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1414879), // Rule ID 21545 //
     /* 1414796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414835 */     // MIs[0] Operand 5
     /* 1414835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414846 */     // MIs[0] policy
     /* 1414846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1414859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414878 */     // GIR_Coverage, 21545,
     /* 1414878 */     GIR_EraseRootFromParent_Done,
     /* 1414879 */   // Label 20010: @1414879
     /* 1414879 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1414967), // Rule ID 21548 //
     /* 1414884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414923 */     // MIs[0] Operand 5
     /* 1414923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414934 */     // MIs[0] policy
     /* 1414934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1414947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414966 */     // GIR_Coverage, 21548,
     /* 1414966 */     GIR_EraseRootFromParent_Done,
     /* 1414967 */   // Label 20011: @1414967
     /* 1414967 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1415055), // Rule ID 21549 //
     /* 1414972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1414980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415011 */     // MIs[0] Operand 5
     /* 1415011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415022 */     // MIs[0] policy
     /* 1415022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1415035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415054 */     // GIR_Coverage, 21549,
     /* 1415054 */     GIR_EraseRootFromParent_Done,
     /* 1415055 */   // Label 20012: @1415055
     /* 1415055 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1415143), // Rule ID 21552 //
     /* 1415060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415099 */     // MIs[0] Operand 5
     /* 1415099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415110 */     // MIs[0] policy
     /* 1415110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1415123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415142 */     // GIR_Coverage, 21552,
     /* 1415142 */     GIR_EraseRootFromParent_Done,
     /* 1415143 */   // Label 20013: @1415143
     /* 1415143 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1415231), // Rule ID 21553 //
     /* 1415148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1415159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1415162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415187 */     // MIs[0] Operand 5
     /* 1415187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415198 */     // MIs[0] policy
     /* 1415198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1415211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415230 */     // GIR_Coverage, 21553,
     /* 1415230 */     GIR_EraseRootFromParent_Done,
     /* 1415231 */   // Label 20014: @1415231
     /* 1415231 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1415319), // Rule ID 21556 //
     /* 1415236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1415239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415275 */     // MIs[0] Operand 5
     /* 1415275 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415286 */     // MIs[0] policy
     /* 1415286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415296 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1415299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415318 */     // GIR_Coverage, 21556,
     /* 1415318 */     GIR_EraseRootFromParent_Done,
     /* 1415319 */   // Label 20015: @1415319
     /* 1415319 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1415407), // Rule ID 21557 //
     /* 1415324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1415327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1415335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1415338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1415344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415363 */     // MIs[0] Operand 5
     /* 1415363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415374 */     // MIs[0] policy
     /* 1415374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1415387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415406 */     // GIR_Coverage, 21557,
     /* 1415406 */     GIR_EraseRootFromParent_Done,
     /* 1415407 */   // Label 20016: @1415407
     /* 1415407 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1415495), // Rule ID 21560 //
     /* 1415412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415451 */     // MIs[0] Operand 5
     /* 1415451 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415462 */     // MIs[0] policy
     /* 1415462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1415475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415494 */     // GIR_Coverage, 21560,
     /* 1415494 */     GIR_EraseRootFromParent_Done,
     /* 1415495 */   // Label 20017: @1415495
     /* 1415495 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1415583), // Rule ID 21561 //
     /* 1415500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415539 */     // MIs[0] Operand 5
     /* 1415539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415550 */     // MIs[0] policy
     /* 1415550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1415563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415582 */     // GIR_Coverage, 21561,
     /* 1415582 */     GIR_EraseRootFromParent_Done,
     /* 1415583 */   // Label 20018: @1415583
     /* 1415583 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1415671), // Rule ID 21564 //
     /* 1415588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415627 */     // MIs[0] Operand 5
     /* 1415627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415638 */     // MIs[0] policy
     /* 1415638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1415651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415670 */     // GIR_Coverage, 21564,
     /* 1415670 */     GIR_EraseRootFromParent_Done,
     /* 1415671 */   // Label 20019: @1415671
     /* 1415671 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1415759), // Rule ID 21565 //
     /* 1415676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415715 */     // MIs[0] Operand 5
     /* 1415715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415726 */     // MIs[0] policy
     /* 1415726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1415739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415758 */     // GIR_Coverage, 21565,
     /* 1415758 */     GIR_EraseRootFromParent_Done,
     /* 1415759 */   // Label 20020: @1415759
     /* 1415759 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1415847), // Rule ID 21568 //
     /* 1415764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415803 */     // MIs[0] Operand 5
     /* 1415803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415814 */     // MIs[0] policy
     /* 1415814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1415827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415846 */     // GIR_Coverage, 21568,
     /* 1415846 */     GIR_EraseRootFromParent_Done,
     /* 1415847 */   // Label 20021: @1415847
     /* 1415847 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1415935), // Rule ID 21569 //
     /* 1415852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415891 */     // MIs[0] Operand 5
     /* 1415891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415902 */     // MIs[0] policy
     /* 1415902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1415915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415934 */     // GIR_Coverage, 21569,
     /* 1415934 */     GIR_EraseRootFromParent_Done,
     /* 1415935 */   // Label 20022: @1415935
     /* 1415935 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1416023), // Rule ID 21572 //
     /* 1415940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1415948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1415957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415979 */     // MIs[0] Operand 5
     /* 1415979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415990 */     // MIs[0] policy
     /* 1415990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1416003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416022 */     // GIR_Coverage, 21572,
     /* 1416022 */     GIR_EraseRootFromParent_Done,
     /* 1416023 */   // Label 20023: @1416023
     /* 1416023 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1416111), // Rule ID 21573 //
     /* 1416028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1416039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1416042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416067 */     // MIs[0] Operand 5
     /* 1416067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416078 */     // MIs[0] policy
     /* 1416078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1416091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416110 */     // GIR_Coverage, 21573,
     /* 1416110 */     GIR_EraseRootFromParent_Done,
     /* 1416111 */   // Label 20024: @1416111
     /* 1416111 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1416199), // Rule ID 21576 //
     /* 1416116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1416119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416155 */     // MIs[0] Operand 5
     /* 1416155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416166 */     // MIs[0] policy
     /* 1416166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1416179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416198 */     // GIR_Coverage, 21576,
     /* 1416198 */     GIR_EraseRootFromParent_Done,
     /* 1416199 */   // Label 20025: @1416199
     /* 1416199 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1416287), // Rule ID 21577 //
     /* 1416204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1416207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1416215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1416218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1416224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416243 */     // MIs[0] Operand 5
     /* 1416243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416254 */     // MIs[0] policy
     /* 1416254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1416267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1416283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416286 */     // GIR_Coverage, 21577,
     /* 1416286 */     GIR_EraseRootFromParent_Done,
     /* 1416287 */   // Label 20026: @1416287
     /* 1416287 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1416375), // Rule ID 21580 //
     /* 1416292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416331 */     // MIs[0] Operand 5
     /* 1416331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416342 */     // MIs[0] policy
     /* 1416342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1416355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416374 */     // GIR_Coverage, 21580,
     /* 1416374 */     GIR_EraseRootFromParent_Done,
     /* 1416375 */   // Label 20027: @1416375
     /* 1416375 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1416463), // Rule ID 21581 //
     /* 1416380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1416391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1416394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1416397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416419 */     // MIs[0] Operand 5
     /* 1416419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416430 */     // MIs[0] policy
     /* 1416430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1416443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416462 */     // GIR_Coverage, 21581,
     /* 1416462 */     GIR_EraseRootFromParent_Done,
     /* 1416463 */   // Label 20028: @1416463
     /* 1416463 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1416551), // Rule ID 21584 //
     /* 1416468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416507 */     // MIs[0] Operand 5
     /* 1416507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416518 */     // MIs[0] policy
     /* 1416518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1416531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416550 */     // GIR_Coverage, 21584,
     /* 1416550 */     GIR_EraseRootFromParent_Done,
     /* 1416551 */   // Label 20029: @1416551
     /* 1416551 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1416639), // Rule ID 21585 //
     /* 1416556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416595 */     // MIs[0] Operand 5
     /* 1416595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416606 */     // MIs[0] policy
     /* 1416606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1416619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416638 */     // GIR_Coverage, 21585,
     /* 1416638 */     GIR_EraseRootFromParent_Done,
     /* 1416639 */   // Label 20030: @1416639
     /* 1416639 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1416727), // Rule ID 21588 //
     /* 1416644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416683 */     // MIs[0] Operand 5
     /* 1416683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416694 */     // MIs[0] policy
     /* 1416694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1416707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416726 */     // GIR_Coverage, 21588,
     /* 1416726 */     GIR_EraseRootFromParent_Done,
     /* 1416727 */   // Label 20031: @1416727
     /* 1416727 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1416815), // Rule ID 21589 //
     /* 1416732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416771 */     // MIs[0] Operand 5
     /* 1416771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416782 */     // MIs[0] policy
     /* 1416782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416792 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1416795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416814 */     // GIR_Coverage, 21589,
     /* 1416814 */     GIR_EraseRootFromParent_Done,
     /* 1416815 */   // Label 20032: @1416815
     /* 1416815 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1416903), // Rule ID 21592 //
     /* 1416820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416859 */     // MIs[0] Operand 5
     /* 1416859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416870 */     // MIs[0] policy
     /* 1416870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1416883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416902 */     // GIR_Coverage, 21592,
     /* 1416902 */     GIR_EraseRootFromParent_Done,
     /* 1416903 */   // Label 20033: @1416903
     /* 1416903 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1416991), // Rule ID 21593 //
     /* 1416908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416947 */     // MIs[0] Operand 5
     /* 1416947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416958 */     // MIs[0] policy
     /* 1416958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1416971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416990 */     // GIR_Coverage, 21593,
     /* 1416990 */     GIR_EraseRootFromParent_Done,
     /* 1416991 */   // Label 20034: @1416991
     /* 1416991 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1417090), // Rule ID 2790 //
     /* 1416996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1416999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1417013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417046 */     // MIs[1] Operand 1
     /* 1417046 */     // No operand predicates
     /* 1417046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417050 */     // MIs[0] policy
     /* 1417050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417062 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1417065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417071 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417089 */     // GIR_Coverage, 2790,
     /* 1417089 */     GIR_EraseRootFromParent_Done,
     /* 1417090 */   // Label 20035: @1417090
     /* 1417090 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1417189), // Rule ID 2791 //
     /* 1417095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1417112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417145 */     // MIs[1] Operand 1
     /* 1417145 */     // No operand predicates
     /* 1417145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417149 */     // MIs[0] policy
     /* 1417149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417161 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1417164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417170 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417188 */     // GIR_Coverage, 2791,
     /* 1417188 */     GIR_EraseRootFromParent_Done,
     /* 1417189 */   // Label 20036: @1417189
     /* 1417189 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1417288), // Rule ID 2798 //
     /* 1417194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1417211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417244 */     // MIs[1] Operand 1
     /* 1417244 */     // No operand predicates
     /* 1417244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417248 */     // MIs[0] policy
     /* 1417248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417260 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417269 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417287 */     // GIR_Coverage, 2798,
     /* 1417287 */     GIR_EraseRootFromParent_Done,
     /* 1417288 */   // Label 20037: @1417288
     /* 1417288 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1417387), // Rule ID 2799 //
     /* 1417293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1417310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417343 */     // MIs[1] Operand 1
     /* 1417343 */     // No operand predicates
     /* 1417343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417347 */     // MIs[0] policy
     /* 1417347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417359 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417368 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417386 */     // GIR_Coverage, 2799,
     /* 1417386 */     GIR_EraseRootFromParent_Done,
     /* 1417387 */   // Label 20038: @1417387
     /* 1417387 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1417486), // Rule ID 2806 //
     /* 1417392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1417409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1417415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417442 */     // MIs[1] Operand 1
     /* 1417442 */     // No operand predicates
     /* 1417442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417446 */     // MIs[0] policy
     /* 1417446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417467 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417485 */     // GIR_Coverage, 2806,
     /* 1417485 */     GIR_EraseRootFromParent_Done,
     /* 1417486 */   // Label 20039: @1417486
     /* 1417486 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1417585), // Rule ID 2807 //
     /* 1417491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1417508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1417514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417541 */     // MIs[1] Operand 1
     /* 1417541 */     // No operand predicates
     /* 1417541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417545 */     // MIs[0] policy
     /* 1417545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417557 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417566 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417584 */     // GIR_Coverage, 2807,
     /* 1417584 */     GIR_EraseRootFromParent_Done,
     /* 1417585 */   // Label 20040: @1417585
     /* 1417585 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1417684), // Rule ID 2814 //
     /* 1417590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417640 */     // MIs[1] Operand 1
     /* 1417640 */     // No operand predicates
     /* 1417640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417644 */     // MIs[0] policy
     /* 1417644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417683 */     // GIR_Coverage, 2814,
     /* 1417683 */     GIR_EraseRootFromParent_Done,
     /* 1417684 */   // Label 20041: @1417684
     /* 1417684 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1417783), // Rule ID 2815 //
     /* 1417689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417739 */     // MIs[1] Operand 1
     /* 1417739 */     // No operand predicates
     /* 1417739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417743 */     // MIs[0] policy
     /* 1417743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417755 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417764 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417782 */     // GIR_Coverage, 2815,
     /* 1417782 */     GIR_EraseRootFromParent_Done,
     /* 1417783 */   // Label 20042: @1417783
     /* 1417783 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1417882), // Rule ID 2822 //
     /* 1417788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417838 */     // MIs[1] Operand 1
     /* 1417838 */     // No operand predicates
     /* 1417838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417842 */     // MIs[0] policy
     /* 1417842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417863 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417881 */     // GIR_Coverage, 2822,
     /* 1417881 */     GIR_EraseRootFromParent_Done,
     /* 1417882 */   // Label 20043: @1417882
     /* 1417882 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1417981), // Rule ID 2823 //
     /* 1417887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1417937 */     // MIs[1] Operand 1
     /* 1417937 */     // No operand predicates
     /* 1417937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417941 */     // MIs[0] policy
     /* 1417941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417953 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417962 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1417967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417980 */     // GIR_Coverage, 2823,
     /* 1417980 */     GIR_EraseRootFromParent_Done,
     /* 1417981 */   // Label 20044: @1417981
     /* 1417981 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1418080), // Rule ID 2830 //
     /* 1417986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1417994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1417997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418036 */     // MIs[1] Operand 1
     /* 1418036 */     // No operand predicates
     /* 1418036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418040 */     // MIs[0] policy
     /* 1418040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1418055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418061 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418079 */     // GIR_Coverage, 2830,
     /* 1418079 */     GIR_EraseRootFromParent_Done,
     /* 1418080 */   // Label 20045: @1418080
     /* 1418080 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1418179), // Rule ID 2831 //
     /* 1418085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418135 */     // MIs[1] Operand 1
     /* 1418135 */     // No operand predicates
     /* 1418135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418139 */     // MIs[0] policy
     /* 1418139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1418154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418160 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418178 */     // GIR_Coverage, 2831,
     /* 1418178 */     GIR_EraseRootFromParent_Done,
     /* 1418179 */   // Label 20046: @1418179
     /* 1418179 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1418278), // Rule ID 2838 //
     /* 1418184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1418201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1418207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418234 */     // MIs[1] Operand 1
     /* 1418234 */     // No operand predicates
     /* 1418234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418238 */     // MIs[0] policy
     /* 1418238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418259 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418277 */     // GIR_Coverage, 2838,
     /* 1418277 */     GIR_EraseRootFromParent_Done,
     /* 1418278 */   // Label 20047: @1418278
     /* 1418278 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1418377), // Rule ID 2839 //
     /* 1418283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1418300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1418306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418333 */     // MIs[1] Operand 1
     /* 1418333 */     // No operand predicates
     /* 1418333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418337 */     // MIs[0] policy
     /* 1418337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418349 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418358 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418376 */     // GIR_Coverage, 2839,
     /* 1418376 */     GIR_EraseRootFromParent_Done,
     /* 1418377 */   // Label 20048: @1418377
     /* 1418377 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1418476), // Rule ID 2846 //
     /* 1418382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1418405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418432 */     // MIs[1] Operand 1
     /* 1418432 */     // No operand predicates
     /* 1418432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418436 */     // MIs[0] policy
     /* 1418436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418457 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418475 */     // GIR_Coverage, 2846,
     /* 1418475 */     GIR_EraseRootFromParent_Done,
     /* 1418476 */   // Label 20049: @1418476
     /* 1418476 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1418575), // Rule ID 2847 //
     /* 1418481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1418504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418531 */     // MIs[1] Operand 1
     /* 1418531 */     // No operand predicates
     /* 1418531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418535 */     // MIs[0] policy
     /* 1418535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418547 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418556 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418574 */     // GIR_Coverage, 2847,
     /* 1418574 */     GIR_EraseRootFromParent_Done,
     /* 1418575 */   // Label 20050: @1418575
     /* 1418575 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1418674), // Rule ID 2854 //
     /* 1418580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1418603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418630 */     // MIs[1] Operand 1
     /* 1418630 */     // No operand predicates
     /* 1418630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418634 */     // MIs[0] policy
     /* 1418634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418655 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418673 */     // GIR_Coverage, 2854,
     /* 1418673 */     GIR_EraseRootFromParent_Done,
     /* 1418674 */   // Label 20051: @1418674
     /* 1418674 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1418773), // Rule ID 2855 //
     /* 1418679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1418702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418729 */     // MIs[1] Operand 1
     /* 1418729 */     // No operand predicates
     /* 1418729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418733 */     // MIs[0] policy
     /* 1418733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418754 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418772 */     // GIR_Coverage, 2855,
     /* 1418772 */     GIR_EraseRootFromParent_Done,
     /* 1418773 */   // Label 20052: @1418773
     /* 1418773 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1418872), // Rule ID 2862 //
     /* 1418778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1418781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1418789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1418792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418828 */     // MIs[1] Operand 1
     /* 1418828 */     // No operand predicates
     /* 1418828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418832 */     // MIs[0] policy
     /* 1418832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418853 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418871 */     // GIR_Coverage, 2862,
     /* 1418871 */     GIR_EraseRootFromParent_Done,
     /* 1418872 */   // Label 20053: @1418872
     /* 1418872 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1418971), // Rule ID 2863 //
     /* 1418877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1418880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1418888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1418891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1418927 */     // MIs[1] Operand 1
     /* 1418927 */     // No operand predicates
     /* 1418927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418931 */     // MIs[0] policy
     /* 1418931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418943 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418952 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1418957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418970 */     // GIR_Coverage, 2863,
     /* 1418970 */     GIR_EraseRootFromParent_Done,
     /* 1418971 */   // Label 20054: @1418971
     /* 1418971 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1419070), // Rule ID 2870 //
     /* 1418976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1418984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1418987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1418990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1418993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1418999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419026 */     // MIs[1] Operand 1
     /* 1419026 */     // No operand predicates
     /* 1419026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419030 */     // MIs[0] policy
     /* 1419030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419051 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419069 */     // GIR_Coverage, 2870,
     /* 1419069 */     GIR_EraseRootFromParent_Done,
     /* 1419070 */   // Label 20055: @1419070
     /* 1419070 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1419169), // Rule ID 2871 //
     /* 1419075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1419086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1419089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1419092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419125 */     // MIs[1] Operand 1
     /* 1419125 */     // No operand predicates
     /* 1419125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419129 */     // MIs[0] policy
     /* 1419129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419141 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419150 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419168 */     // GIR_Coverage, 2871,
     /* 1419168 */     GIR_EraseRootFromParent_Done,
     /* 1419169 */   // Label 20056: @1419169
     /* 1419169 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1419268), // Rule ID 2878 //
     /* 1419174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1419185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1419188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1419191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419224 */     // MIs[1] Operand 1
     /* 1419224 */     // No operand predicates
     /* 1419224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419228 */     // MIs[0] policy
     /* 1419228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419249 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419267 */     // GIR_Coverage, 2878,
     /* 1419267 */     GIR_EraseRootFromParent_Done,
     /* 1419268 */   // Label 20057: @1419268
     /* 1419268 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1419367), // Rule ID 2879 //
     /* 1419273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1419284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1419287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1419290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419323 */     // MIs[1] Operand 1
     /* 1419323 */     // No operand predicates
     /* 1419323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419327 */     // MIs[0] policy
     /* 1419327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419339 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419348 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419366 */     // GIR_Coverage, 2879,
     /* 1419366 */     GIR_EraseRootFromParent_Done,
     /* 1419367 */   // Label 20058: @1419367
     /* 1419367 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1419466), // Rule ID 2886 //
     /* 1419372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1419383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1419386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1419389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1419395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419422 */     // MIs[1] Operand 1
     /* 1419422 */     // No operand predicates
     /* 1419422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419426 */     // MIs[0] policy
     /* 1419426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419438 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1419441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419447 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419465 */     // GIR_Coverage, 2886,
     /* 1419465 */     GIR_EraseRootFromParent_Done,
     /* 1419466 */   // Label 20059: @1419466
     /* 1419466 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1419565), // Rule ID 2887 //
     /* 1419471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1419482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1419485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1419488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1419494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419521 */     // MIs[1] Operand 1
     /* 1419521 */     // No operand predicates
     /* 1419521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419525 */     // MIs[0] policy
     /* 1419525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419537 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1419540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419546 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419564 */     // GIR_Coverage, 2887,
     /* 1419564 */     GIR_EraseRootFromParent_Done,
     /* 1419565 */   // Label 20060: @1419565
     /* 1419565 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1419664), // Rule ID 2894 //
     /* 1419570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1419587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1419593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419620 */     // MIs[1] Operand 1
     /* 1419620 */     // No operand predicates
     /* 1419620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419624 */     // MIs[0] policy
     /* 1419624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419645 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419663 */     // GIR_Coverage, 2894,
     /* 1419663 */     GIR_EraseRootFromParent_Done,
     /* 1419664 */   // Label 20061: @1419664
     /* 1419664 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1419763), // Rule ID 2895 //
     /* 1419669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1419686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1419692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419719 */     // MIs[1] Operand 1
     /* 1419719 */     // No operand predicates
     /* 1419719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419723 */     // MIs[0] policy
     /* 1419723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419735 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419744 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419762 */     // GIR_Coverage, 2895,
     /* 1419762 */     GIR_EraseRootFromParent_Done,
     /* 1419763 */   // Label 20062: @1419763
     /* 1419763 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1419862), // Rule ID 2902 //
     /* 1419768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1419785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419818 */     // MIs[1] Operand 1
     /* 1419818 */     // No operand predicates
     /* 1419818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419822 */     // MIs[0] policy
     /* 1419822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419843 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419861 */     // GIR_Coverage, 2902,
     /* 1419861 */     GIR_EraseRootFromParent_Done,
     /* 1419862 */   // Label 20063: @1419862
     /* 1419862 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1419961), // Rule ID 2903 //
     /* 1419867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1419884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419917 */     // MIs[1] Operand 1
     /* 1419917 */     // No operand predicates
     /* 1419917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419921 */     // MIs[0] policy
     /* 1419921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419942 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419960 */     // GIR_Coverage, 2903,
     /* 1419960 */     GIR_EraseRootFromParent_Done,
     /* 1419961 */   // Label 20064: @1419961
     /* 1419961 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1420060), // Rule ID 2910 //
     /* 1419966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1419977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1419980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1419983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420016 */     // MIs[1] Operand 1
     /* 1420016 */     // No operand predicates
     /* 1420016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420020 */     // MIs[0] policy
     /* 1420020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420032 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420041 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420059 */     // GIR_Coverage, 2910,
     /* 1420059 */     GIR_EraseRootFromParent_Done,
     /* 1420060 */   // Label 20065: @1420060
     /* 1420060 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1420159), // Rule ID 2911 //
     /* 1420065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1420076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1420079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1420082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1420088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420115 */     // MIs[1] Operand 1
     /* 1420115 */     // No operand predicates
     /* 1420115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420119 */     // MIs[0] policy
     /* 1420119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420131 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420140 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420158 */     // GIR_Coverage, 2911,
     /* 1420158 */     GIR_EraseRootFromParent_Done,
     /* 1420159 */   // Label 20066: @1420159
     /* 1420159 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1420258), // Rule ID 2918 //
     /* 1420164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1420181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420214 */     // MIs[1] Operand 1
     /* 1420214 */     // No operand predicates
     /* 1420214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420218 */     // MIs[0] policy
     /* 1420218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420239 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420257 */     // GIR_Coverage, 2918,
     /* 1420257 */     GIR_EraseRootFromParent_Done,
     /* 1420258 */   // Label 20067: @1420258
     /* 1420258 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1420357), // Rule ID 2919 //
     /* 1420263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1420280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420313 */     // MIs[1] Operand 1
     /* 1420313 */     // No operand predicates
     /* 1420313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420317 */     // MIs[0] policy
     /* 1420317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420338 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420356 */     // GIR_Coverage, 2919,
     /* 1420356 */     GIR_EraseRootFromParent_Done,
     /* 1420357 */   // Label 20068: @1420357
     /* 1420357 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1420456), // Rule ID 2926 //
     /* 1420362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1420379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420412 */     // MIs[1] Operand 1
     /* 1420412 */     // No operand predicates
     /* 1420412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420416 */     // MIs[0] policy
     /* 1420416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1420431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420437 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420455 */     // GIR_Coverage, 2926,
     /* 1420455 */     GIR_EraseRootFromParent_Done,
     /* 1420456 */   // Label 20069: @1420456
     /* 1420456 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1420555), // Rule ID 2927 //
     /* 1420461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1420478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420511 */     // MIs[1] Operand 1
     /* 1420511 */     // No operand predicates
     /* 1420511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420515 */     // MIs[0] policy
     /* 1420515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1420530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420536 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420554 */     // GIR_Coverage, 2927,
     /* 1420554 */     GIR_EraseRootFromParent_Done,
     /* 1420555 */   // Label 20070: @1420555
     /* 1420555 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1420654), // Rule ID 2934 //
     /* 1420560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1420571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1420574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1420577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1420583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420610 */     // MIs[1] Operand 1
     /* 1420610 */     // No operand predicates
     /* 1420610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420614 */     // MIs[0] policy
     /* 1420614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420635 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420653 */     // GIR_Coverage, 2934,
     /* 1420653 */     GIR_EraseRootFromParent_Done,
     /* 1420654 */   // Label 20071: @1420654
     /* 1420654 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1420753), // Rule ID 2935 //
     /* 1420659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1420670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1420673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1420676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1420682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420709 */     // MIs[1] Operand 1
     /* 1420709 */     // No operand predicates
     /* 1420709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420713 */     // MIs[0] policy
     /* 1420713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420734 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420752 */     // GIR_Coverage, 2935,
     /* 1420752 */     GIR_EraseRootFromParent_Done,
     /* 1420753 */   // Label 20072: @1420753
     /* 1420753 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1420852), // Rule ID 2942 //
     /* 1420758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1420761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1420775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420808 */     // MIs[1] Operand 1
     /* 1420808 */     // No operand predicates
     /* 1420808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420812 */     // MIs[0] policy
     /* 1420812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420833 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420851 */     // GIR_Coverage, 2942,
     /* 1420851 */     GIR_EraseRootFromParent_Done,
     /* 1420852 */   // Label 20073: @1420852
     /* 1420852 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1420951), // Rule ID 2943 //
     /* 1420857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1420860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1420874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420907 */     // MIs[1] Operand 1
     /* 1420907 */     // No operand predicates
     /* 1420907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420911 */     // MIs[0] policy
     /* 1420911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420932 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420950 */     // GIR_Coverage, 2943,
     /* 1420950 */     GIR_EraseRootFromParent_Done,
     /* 1420951 */   // Label 20074: @1420951
     /* 1420951 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1421050), // Rule ID 2950 //
     /* 1420956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1420959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1420967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1420970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1420973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421006 */     // MIs[1] Operand 1
     /* 1421006 */     // No operand predicates
     /* 1421006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421010 */     // MIs[0] policy
     /* 1421010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421031 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421049 */     // GIR_Coverage, 2950,
     /* 1421049 */     GIR_EraseRootFromParent_Done,
     /* 1421050 */   // Label 20075: @1421050
     /* 1421050 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1421149), // Rule ID 2951 //
     /* 1421055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1421066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1421069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1421072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421105 */     // MIs[1] Operand 1
     /* 1421105 */     // No operand predicates
     /* 1421105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421109 */     // MIs[0] policy
     /* 1421109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421121 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421130 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421148 */     // GIR_Coverage, 2951,
     /* 1421148 */     GIR_EraseRootFromParent_Done,
     /* 1421149 */   // Label 20076: @1421149
     /* 1421149 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1421248), // Rule ID 2958 //
     /* 1421154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1421165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1421168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1421171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421204 */     // MIs[1] Operand 1
     /* 1421204 */     // No operand predicates
     /* 1421204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421208 */     // MIs[0] policy
     /* 1421208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421229 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421247 */     // GIR_Coverage, 2958,
     /* 1421247 */     GIR_EraseRootFromParent_Done,
     /* 1421248 */   // Label 20077: @1421248
     /* 1421248 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1421347), // Rule ID 2959 //
     /* 1421253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1421264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1421267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1421270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421303 */     // MIs[1] Operand 1
     /* 1421303 */     // No operand predicates
     /* 1421303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421307 */     // MIs[0] policy
     /* 1421307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421319 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421328 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421346 */     // GIR_Coverage, 2959,
     /* 1421346 */     GIR_EraseRootFromParent_Done,
     /* 1421347 */   // Label 20078: @1421347
     /* 1421347 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1421444), // Rule ID 3142 //
     /* 1421352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1421363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1421366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1421369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421402 */     // MIs[1] Operand 1
     /* 1421402 */     // No operand predicates
     /* 1421402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421406 */     // MIs[0] policy
     /* 1421406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421418 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1421421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421443 */     // GIR_Coverage, 3142,
     /* 1421443 */     GIR_EraseRootFromParent_Done,
     /* 1421444 */   // Label 20079: @1421444
     /* 1421444 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1421541), // Rule ID 3143 //
     /* 1421449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1421460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1421463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1421466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421499 */     // MIs[1] Operand 1
     /* 1421499 */     // No operand predicates
     /* 1421499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421503 */     // MIs[0] policy
     /* 1421503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421515 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1421518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421540 */     // GIR_Coverage, 3143,
     /* 1421540 */     GIR_EraseRootFromParent_Done,
     /* 1421541 */   // Label 20080: @1421541
     /* 1421541 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1421638), // Rule ID 3146 //
     /* 1421546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1421557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1421560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1421563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421596 */     // MIs[1] Operand 1
     /* 1421596 */     // No operand predicates
     /* 1421596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421600 */     // MIs[0] policy
     /* 1421600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1421615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421637 */     // GIR_Coverage, 3146,
     /* 1421637 */     GIR_EraseRootFromParent_Done,
     /* 1421638 */   // Label 20081: @1421638
     /* 1421638 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1421735), // Rule ID 3147 //
     /* 1421643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1421654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1421657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1421660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421693 */     // MIs[1] Operand 1
     /* 1421693 */     // No operand predicates
     /* 1421693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421697 */     // MIs[0] policy
     /* 1421697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1421712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421734 */     // GIR_Coverage, 3147,
     /* 1421734 */     GIR_EraseRootFromParent_Done,
     /* 1421735 */   // Label 20082: @1421735
     /* 1421735 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1421832), // Rule ID 3150 //
     /* 1421740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1421751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1421754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1421757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421790 */     // MIs[1] Operand 1
     /* 1421790 */     // No operand predicates
     /* 1421790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421794 */     // MIs[0] policy
     /* 1421794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421806 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1421809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421831 */     // GIR_Coverage, 3150,
     /* 1421831 */     GIR_EraseRootFromParent_Done,
     /* 1421832 */   // Label 20083: @1421832
     /* 1421832 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1421929), // Rule ID 3151 //
     /* 1421837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1421848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1421851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1421854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421887 */     // MIs[1] Operand 1
     /* 1421887 */     // No operand predicates
     /* 1421887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421891 */     // MIs[0] policy
     /* 1421891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421903 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1421906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421928 */     // GIR_Coverage, 3151,
     /* 1421928 */     GIR_EraseRootFromParent_Done,
     /* 1421929 */   // Label 20084: @1421929
     /* 1421929 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1422026), // Rule ID 3154 //
     /* 1421934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1421945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1421948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1421951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421984 */     // MIs[1] Operand 1
     /* 1421984 */     // No operand predicates
     /* 1421984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421988 */     // MIs[0] policy
     /* 1421988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1422003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422025 */     // GIR_Coverage, 3154,
     /* 1422025 */     GIR_EraseRootFromParent_Done,
     /* 1422026 */   // Label 20085: @1422026
     /* 1422026 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1422123), // Rule ID 3155 //
     /* 1422031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1422042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1422045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1422048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1422054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422081 */     // MIs[1] Operand 1
     /* 1422081 */     // No operand predicates
     /* 1422081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422085 */     // MIs[0] policy
     /* 1422085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422097 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1422100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422122 */     // GIR_Coverage, 3155,
     /* 1422122 */     GIR_EraseRootFromParent_Done,
     /* 1422123 */   // Label 20086: @1422123
     /* 1422123 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1422220), // Rule ID 3158 //
     /* 1422128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1422139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1422142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1422145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422178 */     // MIs[1] Operand 1
     /* 1422178 */     // No operand predicates
     /* 1422178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422182 */     // MIs[0] policy
     /* 1422182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1422197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422219 */     // GIR_Coverage, 3158,
     /* 1422219 */     GIR_EraseRootFromParent_Done,
     /* 1422220 */   // Label 20087: @1422220
     /* 1422220 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1422317), // Rule ID 3159 //
     /* 1422225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1422236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1422239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1422242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422275 */     // MIs[1] Operand 1
     /* 1422275 */     // No operand predicates
     /* 1422275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422279 */     // MIs[0] policy
     /* 1422279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422291 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1422294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422316 */     // GIR_Coverage, 3159,
     /* 1422316 */     GIR_EraseRootFromParent_Done,
     /* 1422317 */   // Label 20088: @1422317
     /* 1422317 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1422414), // Rule ID 3162 //
     /* 1422322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1422339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1422345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422372 */     // MIs[1] Operand 1
     /* 1422372 */     // No operand predicates
     /* 1422372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422376 */     // MIs[0] policy
     /* 1422376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422388 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1422391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422413 */     // GIR_Coverage, 3162,
     /* 1422413 */     GIR_EraseRootFromParent_Done,
     /* 1422414 */   // Label 20089: @1422414
     /* 1422414 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1422511), // Rule ID 3163 //
     /* 1422419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1422436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1422442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422469 */     // MIs[1] Operand 1
     /* 1422469 */     // No operand predicates
     /* 1422469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422473 */     // MIs[0] policy
     /* 1422473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422485 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1422488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422510 */     // GIR_Coverage, 3163,
     /* 1422510 */     GIR_EraseRootFromParent_Done,
     /* 1422511 */   // Label 20090: @1422511
     /* 1422511 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1422608), // Rule ID 3166 //
     /* 1422516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1422527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1422530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1422533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422566 */     // MIs[1] Operand 1
     /* 1422566 */     // No operand predicates
     /* 1422566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422570 */     // MIs[0] policy
     /* 1422570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1422585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422607 */     // GIR_Coverage, 3166,
     /* 1422607 */     GIR_EraseRootFromParent_Done,
     /* 1422608 */   // Label 20091: @1422608
     /* 1422608 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1422705), // Rule ID 3167 //
     /* 1422613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1422624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1422627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1422630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422663 */     // MIs[1] Operand 1
     /* 1422663 */     // No operand predicates
     /* 1422663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422667 */     // MIs[0] policy
     /* 1422667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422679 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1422682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422704 */     // GIR_Coverage, 3167,
     /* 1422704 */     GIR_EraseRootFromParent_Done,
     /* 1422705 */   // Label 20092: @1422705
     /* 1422705 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1422802), // Rule ID 3170 //
     /* 1422710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1422721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1422724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1422727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422760 */     // MIs[1] Operand 1
     /* 1422760 */     // No operand predicates
     /* 1422760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422764 */     // MIs[0] policy
     /* 1422764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1422779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422801 */     // GIR_Coverage, 3170,
     /* 1422801 */     GIR_EraseRootFromParent_Done,
     /* 1422802 */   // Label 20093: @1422802
     /* 1422802 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1422899), // Rule ID 3171 //
     /* 1422807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1422818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1422821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1422824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422857 */     // MIs[1] Operand 1
     /* 1422857 */     // No operand predicates
     /* 1422857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422861 */     // MIs[0] policy
     /* 1422861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422873 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1422876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422898 */     // GIR_Coverage, 3171,
     /* 1422898 */     GIR_EraseRootFromParent_Done,
     /* 1422899 */   // Label 20094: @1422899
     /* 1422899 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1422996), // Rule ID 3174 //
     /* 1422904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1422912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1422915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1422918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1422921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422954 */     // MIs[1] Operand 1
     /* 1422954 */     // No operand predicates
     /* 1422954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422958 */     // MIs[0] policy
     /* 1422958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1422973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422995 */     // GIR_Coverage, 3174,
     /* 1422995 */     GIR_EraseRootFromParent_Done,
     /* 1422996 */   // Label 20095: @1422996
     /* 1422996 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1423093), // Rule ID 3175 //
     /* 1423001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1423012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1423015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1423018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423051 */     // MIs[1] Operand 1
     /* 1423051 */     // No operand predicates
     /* 1423051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423055 */     // MIs[0] policy
     /* 1423055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1423070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423092 */     // GIR_Coverage, 3175,
     /* 1423092 */     GIR_EraseRootFromParent_Done,
     /* 1423093 */   // Label 20096: @1423093
     /* 1423093 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1423190), // Rule ID 3178 //
     /* 1423098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1423115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423148 */     // MIs[1] Operand 1
     /* 1423148 */     // No operand predicates
     /* 1423148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423152 */     // MIs[0] policy
     /* 1423152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1423167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423189 */     // GIR_Coverage, 3178,
     /* 1423189 */     GIR_EraseRootFromParent_Done,
     /* 1423190 */   // Label 20097: @1423190
     /* 1423190 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1423287), // Rule ID 3179 //
     /* 1423195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1423212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423245 */     // MIs[1] Operand 1
     /* 1423245 */     // No operand predicates
     /* 1423245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423249 */     // MIs[0] policy
     /* 1423249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423261 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1423264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423286 */     // GIR_Coverage, 3179,
     /* 1423286 */     GIR_EraseRootFromParent_Done,
     /* 1423287 */   // Label 20098: @1423287
     /* 1423287 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1423384), // Rule ID 3182 //
     /* 1423292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1423303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1423306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1423309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423342 */     // MIs[1] Operand 1
     /* 1423342 */     // No operand predicates
     /* 1423342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423346 */     // MIs[0] policy
     /* 1423346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423383 */     // GIR_Coverage, 3182,
     /* 1423383 */     GIR_EraseRootFromParent_Done,
     /* 1423384 */   // Label 20099: @1423384
     /* 1423384 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1423481), // Rule ID 3183 //
     /* 1423389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1423400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1423403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1423406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423439 */     // MIs[1] Operand 1
     /* 1423439 */     // No operand predicates
     /* 1423439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423443 */     // MIs[0] policy
     /* 1423443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423455 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423480 */     // GIR_Coverage, 3183,
     /* 1423480 */     GIR_EraseRootFromParent_Done,
     /* 1423481 */   // Label 20100: @1423481
     /* 1423481 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1423578), // Rule ID 3186 //
     /* 1423486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1423497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1423500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1423503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1423509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423536 */     // MIs[1] Operand 1
     /* 1423536 */     // No operand predicates
     /* 1423536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423540 */     // MIs[0] policy
     /* 1423540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423577 */     // GIR_Coverage, 3186,
     /* 1423577 */     GIR_EraseRootFromParent_Done,
     /* 1423578 */   // Label 20101: @1423578
     /* 1423578 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1423675), // Rule ID 3187 //
     /* 1423583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1423594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1423597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1423600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1423606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423633 */     // MIs[1] Operand 1
     /* 1423633 */     // No operand predicates
     /* 1423633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423637 */     // MIs[0] policy
     /* 1423637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423649 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423674 */     // GIR_Coverage, 3187,
     /* 1423674 */     GIR_EraseRootFromParent_Done,
     /* 1423675 */   // Label 20102: @1423675
     /* 1423675 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1423772), // Rule ID 3190 //
     /* 1423680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1423691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1423694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1423697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1423703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423730 */     // MIs[1] Operand 1
     /* 1423730 */     // No operand predicates
     /* 1423730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423734 */     // MIs[0] policy
     /* 1423734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423771 */     // GIR_Coverage, 3190,
     /* 1423771 */     GIR_EraseRootFromParent_Done,
     /* 1423772 */   // Label 20103: @1423772
     /* 1423772 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1423869), // Rule ID 3191 //
     /* 1423777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1423788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1423791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1423794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1423800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423827 */     // MIs[1] Operand 1
     /* 1423827 */     // No operand predicates
     /* 1423827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423831 */     // MIs[0] policy
     /* 1423831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423843 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423868 */     // GIR_Coverage, 3191,
     /* 1423868 */     GIR_EraseRootFromParent_Done,
     /* 1423869 */   // Label 20104: @1423869
     /* 1423869 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1423966), // Rule ID 3194 //
     /* 1423874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1423885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1423888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1423891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423924 */     // MIs[1] Operand 1
     /* 1423924 */     // No operand predicates
     /* 1423924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423928 */     // MIs[0] policy
     /* 1423928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423965 */     // GIR_Coverage, 3194,
     /* 1423965 */     GIR_EraseRootFromParent_Done,
     /* 1423966 */   // Label 20105: @1423966
     /* 1423966 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1424063), // Rule ID 3195 //
     /* 1423971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1423982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1423985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1423988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424021 */     // MIs[1] Operand 1
     /* 1424021 */     // No operand predicates
     /* 1424021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424025 */     // MIs[0] policy
     /* 1424025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1424040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424062 */     // GIR_Coverage, 3195,
     /* 1424062 */     GIR_EraseRootFromParent_Done,
     /* 1424063 */   // Label 20106: @1424063
     /* 1424063 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1424160), // Rule ID 3198 //
     /* 1424068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1424079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1424082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1424085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424118 */     // MIs[1] Operand 1
     /* 1424118 */     // No operand predicates
     /* 1424118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424122 */     // MIs[0] policy
     /* 1424122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1424137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424159 */     // GIR_Coverage, 3198,
     /* 1424159 */     GIR_EraseRootFromParent_Done,
     /* 1424160 */   // Label 20107: @1424160
     /* 1424160 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1424257), // Rule ID 3199 //
     /* 1424165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1424176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1424179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1424182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424215 */     // MIs[1] Operand 1
     /* 1424215 */     // No operand predicates
     /* 1424215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424219 */     // MIs[0] policy
     /* 1424219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424231 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1424234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424256 */     // GIR_Coverage, 3199,
     /* 1424256 */     GIR_EraseRootFromParent_Done,
     /* 1424257 */   // Label 20108: @1424257
     /* 1424257 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1424354), // Rule ID 3202 //
     /* 1424262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1424279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1424285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424312 */     // MIs[1] Operand 1
     /* 1424312 */     // No operand predicates
     /* 1424312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424316 */     // MIs[0] policy
     /* 1424316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424328 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1424331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424353 */     // GIR_Coverage, 3202,
     /* 1424353 */     GIR_EraseRootFromParent_Done,
     /* 1424354 */   // Label 20109: @1424354
     /* 1424354 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1424451), // Rule ID 3203 //
     /* 1424359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1424376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1424382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424409 */     // MIs[1] Operand 1
     /* 1424409 */     // No operand predicates
     /* 1424409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424413 */     // MIs[0] policy
     /* 1424413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424425 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1424428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424450 */     // GIR_Coverage, 3203,
     /* 1424450 */     GIR_EraseRootFromParent_Done,
     /* 1424451 */   // Label 20110: @1424451
     /* 1424451 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1424548), // Rule ID 3206 //
     /* 1424456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1424473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424506 */     // MIs[1] Operand 1
     /* 1424506 */     // No operand predicates
     /* 1424506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424510 */     // MIs[0] policy
     /* 1424510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1424525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424547 */     // GIR_Coverage, 3206,
     /* 1424547 */     GIR_EraseRootFromParent_Done,
     /* 1424548 */   // Label 20111: @1424548
     /* 1424548 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1424645), // Rule ID 3207 //
     /* 1424553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1424570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424603 */     // MIs[1] Operand 1
     /* 1424603 */     // No operand predicates
     /* 1424603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424607 */     // MIs[0] policy
     /* 1424607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1424622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424644 */     // GIR_Coverage, 3207,
     /* 1424644 */     GIR_EraseRootFromParent_Done,
     /* 1424645 */   // Label 20112: @1424645
     /* 1424645 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1424742), // Rule ID 3210 //
     /* 1424650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1424667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424700 */     // MIs[1] Operand 1
     /* 1424700 */     // No operand predicates
     /* 1424700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424704 */     // MIs[0] policy
     /* 1424704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1424719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424741 */     // GIR_Coverage, 3210,
     /* 1424741 */     GIR_EraseRootFromParent_Done,
     /* 1424742 */   // Label 20113: @1424742
     /* 1424742 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1424839), // Rule ID 3211 //
     /* 1424747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1424764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424797 */     // MIs[1] Operand 1
     /* 1424797 */     // No operand predicates
     /* 1424797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424801 */     // MIs[0] policy
     /* 1424801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424813 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1424816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424838 */     // GIR_Coverage, 3211,
     /* 1424838 */     GIR_EraseRootFromParent_Done,
     /* 1424839 */   // Label 20114: @1424839
     /* 1424839 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1424936), // Rule ID 3214 //
     /* 1424844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1424861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424894 */     // MIs[1] Operand 1
     /* 1424894 */     // No operand predicates
     /* 1424894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424898 */     // MIs[0] policy
     /* 1424898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1424913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424935 */     // GIR_Coverage, 3214,
     /* 1424935 */     GIR_EraseRootFromParent_Done,
     /* 1424936 */   // Label 20115: @1424936
     /* 1424936 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1425033), // Rule ID 3215 //
     /* 1424941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1424958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424991 */     // MIs[1] Operand 1
     /* 1424991 */     // No operand predicates
     /* 1424991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424995 */     // MIs[0] policy
     /* 1424995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425007 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425032 */     // GIR_Coverage, 3215,
     /* 1425032 */     GIR_EraseRootFromParent_Done,
     /* 1425033 */   // Label 20116: @1425033
     /* 1425033 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1425130), // Rule ID 3218 //
     /* 1425038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1425049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1425052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1425055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425088 */     // MIs[1] Operand 1
     /* 1425088 */     // No operand predicates
     /* 1425088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425092 */     // MIs[0] policy
     /* 1425092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425129 */     // GIR_Coverage, 3218,
     /* 1425129 */     GIR_EraseRootFromParent_Done,
     /* 1425130 */   // Label 20117: @1425130
     /* 1425130 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1425227), // Rule ID 3219 //
     /* 1425135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1425146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1425149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1425152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425185 */     // MIs[1] Operand 1
     /* 1425185 */     // No operand predicates
     /* 1425185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425189 */     // MIs[0] policy
     /* 1425189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425226 */     // GIR_Coverage, 3219,
     /* 1425226 */     GIR_EraseRootFromParent_Done,
     /* 1425227 */   // Label 20118: @1425227
     /* 1425227 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1425324), // Rule ID 3222 //
     /* 1425232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1425249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425282 */     // MIs[1] Operand 1
     /* 1425282 */     // No operand predicates
     /* 1425282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425286 */     // MIs[0] policy
     /* 1425286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425298 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425323 */     // GIR_Coverage, 3222,
     /* 1425323 */     GIR_EraseRootFromParent_Done,
     /* 1425324 */   // Label 20119: @1425324
     /* 1425324 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1425421), // Rule ID 3223 //
     /* 1425329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1425346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425379 */     // MIs[1] Operand 1
     /* 1425379 */     // No operand predicates
     /* 1425379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425383 */     // MIs[0] policy
     /* 1425383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425395 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425420 */     // GIR_Coverage, 3223,
     /* 1425420 */     GIR_EraseRootFromParent_Done,
     /* 1425421 */   // Label 20120: @1425421
     /* 1425421 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1425518), // Rule ID 3226 //
     /* 1425426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1425443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425476 */     // MIs[1] Operand 1
     /* 1425476 */     // No operand predicates
     /* 1425476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425480 */     // MIs[0] policy
     /* 1425480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425517 */     // GIR_Coverage, 3226,
     /* 1425517 */     GIR_EraseRootFromParent_Done,
     /* 1425518 */   // Label 20121: @1425518
     /* 1425518 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1425615), // Rule ID 3227 //
     /* 1425523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1425540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425573 */     // MIs[1] Operand 1
     /* 1425573 */     // No operand predicates
     /* 1425573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425577 */     // MIs[0] policy
     /* 1425577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425614 */     // GIR_Coverage, 3227,
     /* 1425614 */     GIR_EraseRootFromParent_Done,
     /* 1425615 */   // Label 20122: @1425615
     /* 1425615 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1425712), // Rule ID 3494 //
     /* 1425620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1425631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1425634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1425637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425670 */     // MIs[1] Operand 1
     /* 1425670 */     // No operand predicates
     /* 1425670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425674 */     // MIs[0] policy
     /* 1425674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1425689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425711 */     // GIR_Coverage, 3494,
     /* 1425711 */     GIR_EraseRootFromParent_Done,
     /* 1425712 */   // Label 20123: @1425712
     /* 1425712 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1425809), // Rule ID 3495 //
     /* 1425717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1425728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1425731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1425734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425767 */     // MIs[1] Operand 1
     /* 1425767 */     // No operand predicates
     /* 1425767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425771 */     // MIs[0] policy
     /* 1425771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425783 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1425786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425808 */     // GIR_Coverage, 3495,
     /* 1425808 */     GIR_EraseRootFromParent_Done,
     /* 1425809 */   // Label 20124: @1425809
     /* 1425809 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1425906), // Rule ID 3498 //
     /* 1425814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1425825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1425828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1425831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425864 */     // MIs[1] Operand 1
     /* 1425864 */     // No operand predicates
     /* 1425864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425868 */     // MIs[0] policy
     /* 1425868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1425883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425905 */     // GIR_Coverage, 3498,
     /* 1425905 */     GIR_EraseRootFromParent_Done,
     /* 1425906 */   // Label 20125: @1425906
     /* 1425906 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1426003), // Rule ID 3499 //
     /* 1425911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1425922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1425925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1425928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425961 */     // MIs[1] Operand 1
     /* 1425961 */     // No operand predicates
     /* 1425961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425965 */     // MIs[0] policy
     /* 1425965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1425980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426002 */     // GIR_Coverage, 3499,
     /* 1426002 */     GIR_EraseRootFromParent_Done,
     /* 1426003 */   // Label 20126: @1426003
     /* 1426003 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1426100), // Rule ID 3502 //
     /* 1426008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1426019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1426022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1426025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426058 */     // MIs[1] Operand 1
     /* 1426058 */     // No operand predicates
     /* 1426058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426062 */     // MIs[0] policy
     /* 1426062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426074 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426099 */     // GIR_Coverage, 3502,
     /* 1426099 */     GIR_EraseRootFromParent_Done,
     /* 1426100 */   // Label 20127: @1426100
     /* 1426100 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1426197), // Rule ID 3503 //
     /* 1426105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1426116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1426119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1426122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426155 */     // MIs[1] Operand 1
     /* 1426155 */     // No operand predicates
     /* 1426155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426159 */     // MIs[0] policy
     /* 1426159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426171 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426196 */     // GIR_Coverage, 3503,
     /* 1426196 */     GIR_EraseRootFromParent_Done,
     /* 1426197 */   // Label 20128: @1426197
     /* 1426197 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1426294), // Rule ID 3506 //
     /* 1426202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1426213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1426216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1426219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426252 */     // MIs[1] Operand 1
     /* 1426252 */     // No operand predicates
     /* 1426252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426256 */     // MIs[0] policy
     /* 1426256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1426271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426293 */     // GIR_Coverage, 3506,
     /* 1426293 */     GIR_EraseRootFromParent_Done,
     /* 1426294 */   // Label 20129: @1426294
     /* 1426294 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1426391), // Rule ID 3507 //
     /* 1426299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1426310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1426313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1426316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426349 */     // MIs[1] Operand 1
     /* 1426349 */     // No operand predicates
     /* 1426349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426353 */     // MIs[0] policy
     /* 1426353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426365 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1426368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426390 */     // GIR_Coverage, 3507,
     /* 1426390 */     GIR_EraseRootFromParent_Done,
     /* 1426391 */   // Label 20130: @1426391
     /* 1426391 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1426488), // Rule ID 3510 //
     /* 1426396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1426407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1426410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1426413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426446 */     // MIs[1] Operand 1
     /* 1426446 */     // No operand predicates
     /* 1426446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426450 */     // MIs[0] policy
     /* 1426450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426487 */     // GIR_Coverage, 3510,
     /* 1426487 */     GIR_EraseRootFromParent_Done,
     /* 1426488 */   // Label 20131: @1426488
     /* 1426488 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1426585), // Rule ID 3511 //
     /* 1426493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1426504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1426507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1426510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426543 */     // MIs[1] Operand 1
     /* 1426543 */     // No operand predicates
     /* 1426543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426547 */     // MIs[0] policy
     /* 1426547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426559 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426584 */     // GIR_Coverage, 3511,
     /* 1426584 */     GIR_EraseRootFromParent_Done,
     /* 1426585 */   // Label 20132: @1426585
     /* 1426585 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1426682), // Rule ID 3514 //
     /* 1426590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1426601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1426604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1426607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426640 */     // MIs[1] Operand 1
     /* 1426640 */     // No operand predicates
     /* 1426640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426644 */     // MIs[0] policy
     /* 1426644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426681 */     // GIR_Coverage, 3514,
     /* 1426681 */     GIR_EraseRootFromParent_Done,
     /* 1426682 */   // Label 20133: @1426682
     /* 1426682 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1426779), // Rule ID 3515 //
     /* 1426687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1426698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1426701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1426704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426737 */     // MIs[1] Operand 1
     /* 1426737 */     // No operand predicates
     /* 1426737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426741 */     // MIs[0] policy
     /* 1426741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426753 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1426756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426778 */     // GIR_Coverage, 3515,
     /* 1426778 */     GIR_EraseRootFromParent_Done,
     /* 1426779 */   // Label 20134: @1426779
     /* 1426779 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1426876), // Rule ID 3518 //
     /* 1426784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1426795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1426798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1426801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426834 */     // MIs[1] Operand 1
     /* 1426834 */     // No operand predicates
     /* 1426834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426838 */     // MIs[0] policy
     /* 1426838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1426853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426875 */     // GIR_Coverage, 3518,
     /* 1426875 */     GIR_EraseRootFromParent_Done,
     /* 1426876 */   // Label 20135: @1426876
     /* 1426876 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1426973), // Rule ID 3519 //
     /* 1426881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1426892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1426895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1426898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426931 */     // MIs[1] Operand 1
     /* 1426931 */     // No operand predicates
     /* 1426931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426935 */     // MIs[0] policy
     /* 1426935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426947 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1426950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426972 */     // GIR_Coverage, 3519,
     /* 1426972 */     GIR_EraseRootFromParent_Done,
     /* 1426973 */   // Label 20136: @1426973
     /* 1426973 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1427070), // Rule ID 3522 //
     /* 1426978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1426986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1426989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1426992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1426995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427028 */     // MIs[1] Operand 1
     /* 1427028 */     // No operand predicates
     /* 1427028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427032 */     // MIs[0] policy
     /* 1427032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427069 */     // GIR_Coverage, 3522,
     /* 1427069 */     GIR_EraseRootFromParent_Done,
     /* 1427070 */   // Label 20137: @1427070
     /* 1427070 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1427167), // Rule ID 3523 //
     /* 1427075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1427086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1427089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1427092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427125 */     // MIs[1] Operand 1
     /* 1427125 */     // No operand predicates
     /* 1427125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427129 */     // MIs[0] policy
     /* 1427129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427166 */     // GIR_Coverage, 3523,
     /* 1427166 */     GIR_EraseRootFromParent_Done,
     /* 1427167 */   // Label 20138: @1427167
     /* 1427167 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1427264), // Rule ID 3526 //
     /* 1427172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1427183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1427186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1427189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427222 */     // MIs[1] Operand 1
     /* 1427222 */     // No operand predicates
     /* 1427222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427226 */     // MIs[0] policy
     /* 1427226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427263 */     // GIR_Coverage, 3526,
     /* 1427263 */     GIR_EraseRootFromParent_Done,
     /* 1427264 */   // Label 20139: @1427264
     /* 1427264 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1427361), // Rule ID 3527 //
     /* 1427269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1427280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1427283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1427286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427319 */     // MIs[1] Operand 1
     /* 1427319 */     // No operand predicates
     /* 1427319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427323 */     // MIs[0] policy
     /* 1427323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427335 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427360 */     // GIR_Coverage, 3527,
     /* 1427360 */     GIR_EraseRootFromParent_Done,
     /* 1427361 */   // Label 20140: @1427361
     /* 1427361 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1427458), // Rule ID 3530 //
     /* 1427366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1427377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1427380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1427383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427416 */     // MIs[1] Operand 1
     /* 1427416 */     // No operand predicates
     /* 1427416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427420 */     // MIs[0] policy
     /* 1427420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427457 */     // GIR_Coverage, 3530,
     /* 1427457 */     GIR_EraseRootFromParent_Done,
     /* 1427458 */   // Label 20141: @1427458
     /* 1427458 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1427555), // Rule ID 3531 //
     /* 1427463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1427474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1427477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1427480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427513 */     // MIs[1] Operand 1
     /* 1427513 */     // No operand predicates
     /* 1427513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427517 */     // MIs[0] policy
     /* 1427517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427529 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1427532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427554 */     // GIR_Coverage, 3531,
     /* 1427554 */     GIR_EraseRootFromParent_Done,
     /* 1427555 */   // Label 20142: @1427555
     /* 1427555 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1427652), // Rule ID 3534 //
     /* 1427560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1427571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1427574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1427577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427610 */     // MIs[1] Operand 1
     /* 1427610 */     // No operand predicates
     /* 1427610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427614 */     // MIs[0] policy
     /* 1427614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1427629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427651 */     // GIR_Coverage, 3534,
     /* 1427651 */     GIR_EraseRootFromParent_Done,
     /* 1427652 */   // Label 20143: @1427652
     /* 1427652 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1427749), // Rule ID 3535 //
     /* 1427657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1427668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1427671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1427674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427707 */     // MIs[1] Operand 1
     /* 1427707 */     // No operand predicates
     /* 1427707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427711 */     // MIs[0] policy
     /* 1427711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1427726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427748 */     // GIR_Coverage, 3535,
     /* 1427748 */     GIR_EraseRootFromParent_Done,
     /* 1427749 */   // Label 20144: @1427749
     /* 1427749 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1427846), // Rule ID 3538 //
     /* 1427754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1427765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1427768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1427771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427804 */     // MIs[1] Operand 1
     /* 1427804 */     // No operand predicates
     /* 1427804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427808 */     // MIs[0] policy
     /* 1427808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427820 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1427823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427845 */     // GIR_Coverage, 3538,
     /* 1427845 */     GIR_EraseRootFromParent_Done,
     /* 1427846 */   // Label 20145: @1427846
     /* 1427846 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1427943), // Rule ID 3539 //
     /* 1427851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1427862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1427865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1427868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427901 */     // MIs[1] Operand 1
     /* 1427901 */     // No operand predicates
     /* 1427901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427905 */     // MIs[0] policy
     /* 1427905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427917 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1427920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427942 */     // GIR_Coverage, 3539,
     /* 1427942 */     GIR_EraseRootFromParent_Done,
     /* 1427943 */   // Label 20146: @1427943
     /* 1427943 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1428040), // Rule ID 3542 //
     /* 1427948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1427959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1427962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1427965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1427971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427998 */     // MIs[1] Operand 1
     /* 1427998 */     // No operand predicates
     /* 1427998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428002 */     // MIs[0] policy
     /* 1428002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1428017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428039 */     // GIR_Coverage, 3542,
     /* 1428039 */     GIR_EraseRootFromParent_Done,
     /* 1428040 */   // Label 20147: @1428040
     /* 1428040 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1428137), // Rule ID 3543 //
     /* 1428045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1428056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1428059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1428062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1428068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428095 */     // MIs[1] Operand 1
     /* 1428095 */     // No operand predicates
     /* 1428095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428099 */     // MIs[0] policy
     /* 1428099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428111 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1428114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428136 */     // GIR_Coverage, 3543,
     /* 1428136 */     GIR_EraseRootFromParent_Done,
     /* 1428137 */   // Label 20148: @1428137
     /* 1428137 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1428234), // Rule ID 3546 //
     /* 1428142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1428153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1428156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1428159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428192 */     // MIs[1] Operand 1
     /* 1428192 */     // No operand predicates
     /* 1428192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428196 */     // MIs[0] policy
     /* 1428196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1428211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428233 */     // GIR_Coverage, 3546,
     /* 1428233 */     GIR_EraseRootFromParent_Done,
     /* 1428234 */   // Label 20149: @1428234
     /* 1428234 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1428331), // Rule ID 3547 //
     /* 1428239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1428250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1428253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1428256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428289 */     // MIs[1] Operand 1
     /* 1428289 */     // No operand predicates
     /* 1428289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428293 */     // MIs[0] policy
     /* 1428293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428305 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1428308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428330 */     // GIR_Coverage, 3547,
     /* 1428330 */     GIR_EraseRootFromParent_Done,
     /* 1428331 */   // Label 20150: @1428331
     /* 1428331 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1428428), // Rule ID 3550 //
     /* 1428336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1428347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1428350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1428353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1428359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428386 */     // MIs[1] Operand 1
     /* 1428386 */     // No operand predicates
     /* 1428386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428390 */     // MIs[0] policy
     /* 1428390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1428405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428427 */     // GIR_Coverage, 3550,
     /* 1428427 */     GIR_EraseRootFromParent_Done,
     /* 1428428 */   // Label 20151: @1428428
     /* 1428428 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1428525), // Rule ID 3551 //
     /* 1428433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1428444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1428447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1428450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1428456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428483 */     // MIs[1] Operand 1
     /* 1428483 */     // No operand predicates
     /* 1428483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428487 */     // MIs[0] policy
     /* 1428487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428499 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1428502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428524 */     // GIR_Coverage, 3551,
     /* 1428524 */     GIR_EraseRootFromParent_Done,
     /* 1428525 */   // Label 20152: @1428525
     /* 1428525 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1428622), // Rule ID 3554 //
     /* 1428530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1428541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1428544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1428547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1428553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428580 */     // MIs[1] Operand 1
     /* 1428580 */     // No operand predicates
     /* 1428580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428584 */     // MIs[0] policy
     /* 1428584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1428599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428621 */     // GIR_Coverage, 3554,
     /* 1428621 */     GIR_EraseRootFromParent_Done,
     /* 1428622 */   // Label 20153: @1428622
     /* 1428622 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1428719), // Rule ID 3555 //
     /* 1428627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1428638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1428641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1428644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1428650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428677 */     // MIs[1] Operand 1
     /* 1428677 */     // No operand predicates
     /* 1428677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428681 */     // MIs[0] policy
     /* 1428681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428693 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1428696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428718 */     // GIR_Coverage, 3555,
     /* 1428718 */     GIR_EraseRootFromParent_Done,
     /* 1428719 */   // Label 20154: @1428719
     /* 1428719 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1428816), // Rule ID 3558 //
     /* 1428724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1428735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1428738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1428741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428774 */     // MIs[1] Operand 1
     /* 1428774 */     // No operand predicates
     /* 1428774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428778 */     // MIs[0] policy
     /* 1428778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1428793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428815 */     // GIR_Coverage, 3558,
     /* 1428815 */     GIR_EraseRootFromParent_Done,
     /* 1428816 */   // Label 20155: @1428816
     /* 1428816 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1428913), // Rule ID 3559 //
     /* 1428821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1428832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1428835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1428838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428871 */     // MIs[1] Operand 1
     /* 1428871 */     // No operand predicates
     /* 1428871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428875 */     // MIs[0] policy
     /* 1428875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1428890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428912 */     // GIR_Coverage, 3559,
     /* 1428912 */     GIR_EraseRootFromParent_Done,
     /* 1428913 */   // Label 20156: @1428913
     /* 1428913 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1429010), // Rule ID 3562 //
     /* 1428918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1428929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1428932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1428935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428968 */     // MIs[1] Operand 1
     /* 1428968 */     // No operand predicates
     /* 1428968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428972 */     // MIs[0] policy
     /* 1428972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1428987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429009 */     // GIR_Coverage, 3562,
     /* 1429009 */     GIR_EraseRootFromParent_Done,
     /* 1429010 */   // Label 20157: @1429010
     /* 1429010 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1429107), // Rule ID 3563 //
     /* 1429015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1429026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1429029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1429032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429065 */     // MIs[1] Operand 1
     /* 1429065 */     // No operand predicates
     /* 1429065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429069 */     // MIs[0] policy
     /* 1429069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429081 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1429084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429106 */     // GIR_Coverage, 3563,
     /* 1429106 */     GIR_EraseRootFromParent_Done,
     /* 1429107 */   // Label 20158: @1429107
     /* 1429107 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1429204), // Rule ID 3566 //
     /* 1429112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1429129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429162 */     // MIs[1] Operand 1
     /* 1429162 */     // No operand predicates
     /* 1429162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429166 */     // MIs[0] policy
     /* 1429166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1429181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429203 */     // GIR_Coverage, 3566,
     /* 1429203 */     GIR_EraseRootFromParent_Done,
     /* 1429204 */   // Label 20159: @1429204
     /* 1429204 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1429301), // Rule ID 3567 //
     /* 1429209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1429226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429259 */     // MIs[1] Operand 1
     /* 1429259 */     // No operand predicates
     /* 1429259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429263 */     // MIs[0] policy
     /* 1429263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429275 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1429278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429300 */     // GIR_Coverage, 3567,
     /* 1429300 */     GIR_EraseRootFromParent_Done,
     /* 1429301 */   // Label 20160: @1429301
     /* 1429301 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1429398), // Rule ID 3570 //
     /* 1429306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1429317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1429320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1429323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429356 */     // MIs[1] Operand 1
     /* 1429356 */     // No operand predicates
     /* 1429356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429360 */     // MIs[0] policy
     /* 1429360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429397 */     // GIR_Coverage, 3570,
     /* 1429397 */     GIR_EraseRootFromParent_Done,
     /* 1429398 */   // Label 20161: @1429398
     /* 1429398 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1429495), // Rule ID 3571 //
     /* 1429403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1429414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1429417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1429420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429453 */     // MIs[1] Operand 1
     /* 1429453 */     // No operand predicates
     /* 1429453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429457 */     // MIs[0] policy
     /* 1429457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429494 */     // GIR_Coverage, 3571,
     /* 1429494 */     GIR_EraseRootFromParent_Done,
     /* 1429495 */   // Label 20162: @1429495
     /* 1429495 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1429592), // Rule ID 3574 //
     /* 1429500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1429511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1429514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1429517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429550 */     // MIs[1] Operand 1
     /* 1429550 */     // No operand predicates
     /* 1429550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429554 */     // MIs[0] policy
     /* 1429554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1429569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429591 */     // GIR_Coverage, 3574,
     /* 1429591 */     GIR_EraseRootFromParent_Done,
     /* 1429592 */   // Label 20163: @1429592
     /* 1429592 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1429689), // Rule ID 3575 //
     /* 1429597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1429608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1429611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1429614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429647 */     // MIs[1] Operand 1
     /* 1429647 */     // No operand predicates
     /* 1429647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429651 */     // MIs[0] policy
     /* 1429651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429663 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1429666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429688 */     // GIR_Coverage, 3575,
     /* 1429688 */     GIR_EraseRootFromParent_Done,
     /* 1429689 */   // Label 20164: @1429689
     /* 1429689 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1429786), // Rule ID 3578 //
     /* 1429694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1429705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1429708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1429711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429744 */     // MIs[1] Operand 1
     /* 1429744 */     // No operand predicates
     /* 1429744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429748 */     // MIs[0] policy
     /* 1429748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1429763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429785 */     // GIR_Coverage, 3578,
     /* 1429785 */     GIR_EraseRootFromParent_Done,
     /* 1429786 */   // Label 20165: @1429786
     /* 1429786 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1429883), // Rule ID 3579 //
     /* 1429791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1429802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1429805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1429808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429841 */     // MIs[1] Operand 1
     /* 1429841 */     // No operand predicates
     /* 1429841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429845 */     // MIs[0] policy
     /* 1429845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429857 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1429860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429882 */     // GIR_Coverage, 3579,
     /* 1429882 */     GIR_EraseRootFromParent_Done,
     /* 1429883 */   // Label 20166: @1429883
     /* 1429883 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1429980), // Rule ID 5942 //
     /* 1429888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1429899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1429902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1429905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429938 */     // MIs[1] Operand 1
     /* 1429938 */     // No operand predicates
     /* 1429938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429942 */     // MIs[0] policy
     /* 1429942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1429957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429979 */     // GIR_Coverage, 5942,
     /* 1429979 */     GIR_EraseRootFromParent_Done,
     /* 1429980 */   // Label 20167: @1429980
     /* 1429980 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1430077), // Rule ID 5943 //
     /* 1429985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1429996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1429999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1430002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430035 */     // MIs[1] Operand 1
     /* 1430035 */     // No operand predicates
     /* 1430035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430039 */     // MIs[0] policy
     /* 1430039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430051 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1430054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430076 */     // GIR_Coverage, 5943,
     /* 1430076 */     GIR_EraseRootFromParent_Done,
     /* 1430077 */   // Label 20168: @1430077
     /* 1430077 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1430174), // Rule ID 5946 //
     /* 1430082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1430093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1430096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1430099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430132 */     // MIs[1] Operand 1
     /* 1430132 */     // No operand predicates
     /* 1430132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430136 */     // MIs[0] policy
     /* 1430136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430148 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1430151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430173 */     // GIR_Coverage, 5946,
     /* 1430173 */     GIR_EraseRootFromParent_Done,
     /* 1430174 */   // Label 20169: @1430174
     /* 1430174 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1430271), // Rule ID 5947 //
     /* 1430179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1430190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1430193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1430196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430229 */     // MIs[1] Operand 1
     /* 1430229 */     // No operand predicates
     /* 1430229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430233 */     // MIs[0] policy
     /* 1430233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430245 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1430248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430270 */     // GIR_Coverage, 5947,
     /* 1430270 */     GIR_EraseRootFromParent_Done,
     /* 1430271 */   // Label 20170: @1430271
     /* 1430271 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1430368), // Rule ID 5950 //
     /* 1430276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1430287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1430290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1430293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430326 */     // MIs[1] Operand 1
     /* 1430326 */     // No operand predicates
     /* 1430326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430330 */     // MIs[0] policy
     /* 1430330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430342 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1430345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430367 */     // GIR_Coverage, 5950,
     /* 1430367 */     GIR_EraseRootFromParent_Done,
     /* 1430368 */   // Label 20171: @1430368
     /* 1430368 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1430465), // Rule ID 5951 //
     /* 1430373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1430384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1430387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1430390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430423 */     // MIs[1] Operand 1
     /* 1430423 */     // No operand predicates
     /* 1430423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430427 */     // MIs[0] policy
     /* 1430427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1430442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430464 */     // GIR_Coverage, 5951,
     /* 1430464 */     GIR_EraseRootFromParent_Done,
     /* 1430465 */   // Label 20172: @1430465
     /* 1430465 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1430562), // Rule ID 5954 //
     /* 1430470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430520 */     // MIs[1] Operand 1
     /* 1430520 */     // No operand predicates
     /* 1430520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430524 */     // MIs[0] policy
     /* 1430524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430536 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1430539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430561 */     // GIR_Coverage, 5954,
     /* 1430561 */     GIR_EraseRootFromParent_Done,
     /* 1430562 */   // Label 20173: @1430562
     /* 1430562 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1430659), // Rule ID 5955 //
     /* 1430567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430617 */     // MIs[1] Operand 1
     /* 1430617 */     // No operand predicates
     /* 1430617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430621 */     // MIs[0] policy
     /* 1430621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430633 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1430636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430658 */     // GIR_Coverage, 5955,
     /* 1430658 */     GIR_EraseRootFromParent_Done,
     /* 1430659 */   // Label 20174: @1430659
     /* 1430659 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1430756), // Rule ID 5958 //
     /* 1430664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430714 */     // MIs[1] Operand 1
     /* 1430714 */     // No operand predicates
     /* 1430714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430718 */     // MIs[0] policy
     /* 1430718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1430733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430755 */     // GIR_Coverage, 5958,
     /* 1430755 */     GIR_EraseRootFromParent_Done,
     /* 1430756 */   // Label 20175: @1430756
     /* 1430756 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1430853), // Rule ID 5959 //
     /* 1430761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430811 */     // MIs[1] Operand 1
     /* 1430811 */     // No operand predicates
     /* 1430811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430815 */     // MIs[0] policy
     /* 1430815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1430830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430852 */     // GIR_Coverage, 5959,
     /* 1430852 */     GIR_EraseRootFromParent_Done,
     /* 1430853 */   // Label 20176: @1430853
     /* 1430853 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1430950), // Rule ID 5962 //
     /* 1430858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430908 */     // MIs[1] Operand 1
     /* 1430908 */     // No operand predicates
     /* 1430908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430912 */     // MIs[0] policy
     /* 1430912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1430927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430949 */     // GIR_Coverage, 5962,
     /* 1430949 */     GIR_EraseRootFromParent_Done,
     /* 1430950 */   // Label 20177: @1430950
     /* 1430950 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1431047), // Rule ID 5963 //
     /* 1430955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1430963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431005 */     // MIs[1] Operand 1
     /* 1431005 */     // No operand predicates
     /* 1431005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431009 */     // MIs[0] policy
     /* 1431009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431021 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1431024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431046 */     // GIR_Coverage, 5963,
     /* 1431046 */     GIR_EraseRootFromParent_Done,
     /* 1431047 */   // Label 20178: @1431047
     /* 1431047 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1431144), // Rule ID 5966 //
     /* 1431052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1431063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1431066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1431069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431102 */     // MIs[1] Operand 1
     /* 1431102 */     // No operand predicates
     /* 1431102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431106 */     // MIs[0] policy
     /* 1431106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431143 */     // GIR_Coverage, 5966,
     /* 1431143 */     GIR_EraseRootFromParent_Done,
     /* 1431144 */   // Label 20179: @1431144
     /* 1431144 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1431241), // Rule ID 5967 //
     /* 1431149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1431160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1431163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1431166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431199 */     // MIs[1] Operand 1
     /* 1431199 */     // No operand predicates
     /* 1431199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431203 */     // MIs[0] policy
     /* 1431203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431240 */     // GIR_Coverage, 5967,
     /* 1431240 */     GIR_EraseRootFromParent_Done,
     /* 1431241 */   // Label 20180: @1431241
     /* 1431241 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1431338), // Rule ID 5970 //
     /* 1431246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1431257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1431260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1431263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431296 */     // MIs[1] Operand 1
     /* 1431296 */     // No operand predicates
     /* 1431296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431300 */     // MIs[0] policy
     /* 1431300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431337 */     // GIR_Coverage, 5970,
     /* 1431337 */     GIR_EraseRootFromParent_Done,
     /* 1431338 */   // Label 20181: @1431338
     /* 1431338 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1431435), // Rule ID 5971 //
     /* 1431343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1431354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1431357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1431360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431393 */     // MIs[1] Operand 1
     /* 1431393 */     // No operand predicates
     /* 1431393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431397 */     // MIs[0] policy
     /* 1431397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431434 */     // GIR_Coverage, 5971,
     /* 1431434 */     GIR_EraseRootFromParent_Done,
     /* 1431435 */   // Label 20182: @1431435
     /* 1431435 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1431532), // Rule ID 5974 //
     /* 1431440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431490 */     // MIs[1] Operand 1
     /* 1431490 */     // No operand predicates
     /* 1431490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431494 */     // MIs[0] policy
     /* 1431494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431531 */     // GIR_Coverage, 5974,
     /* 1431531 */     GIR_EraseRootFromParent_Done,
     /* 1431532 */   // Label 20183: @1431532
     /* 1431532 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1431629), // Rule ID 5975 //
     /* 1431537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431587 */     // MIs[1] Operand 1
     /* 1431587 */     // No operand predicates
     /* 1431587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431591 */     // MIs[0] policy
     /* 1431591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431603 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431628 */     // GIR_Coverage, 5975,
     /* 1431628 */     GIR_EraseRootFromParent_Done,
     /* 1431629 */   // Label 20184: @1431629
     /* 1431629 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1431726), // Rule ID 5978 //
     /* 1431634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431684 */     // MIs[1] Operand 1
     /* 1431684 */     // No operand predicates
     /* 1431684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431688 */     // MIs[0] policy
     /* 1431688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431725 */     // GIR_Coverage, 5978,
     /* 1431725 */     GIR_EraseRootFromParent_Done,
     /* 1431726 */   // Label 20185: @1431726
     /* 1431726 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1431823), // Rule ID 5979 //
     /* 1431731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431781 */     // MIs[1] Operand 1
     /* 1431781 */     // No operand predicates
     /* 1431781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431785 */     // MIs[0] policy
     /* 1431785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431797 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1431800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431822 */     // GIR_Coverage, 5979,
     /* 1431822 */     GIR_EraseRootFromParent_Done,
     /* 1431823 */   // Label 20186: @1431823
     /* 1431823 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1431920), // Rule ID 5982 //
     /* 1431828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1431839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1431842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1431845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431874 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431878 */     // MIs[1] Operand 1
     /* 1431878 */     // No operand predicates
     /* 1431878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431882 */     // MIs[0] policy
     /* 1431882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1431897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431916 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431919 */     // GIR_Coverage, 5982,
     /* 1431919 */     GIR_EraseRootFromParent_Done,
     /* 1431920 */   // Label 20187: @1431920
     /* 1431920 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1432017), // Rule ID 5983 //
     /* 1431925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1431933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1431936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1431939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1431942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431975 */     // MIs[1] Operand 1
     /* 1431975 */     // No operand predicates
     /* 1431975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431979 */     // MIs[0] policy
     /* 1431979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1431994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432016 */     // GIR_Coverage, 5983,
     /* 1432016 */     GIR_EraseRootFromParent_Done,
     /* 1432017 */   // Label 20188: @1432017
     /* 1432017 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1432114), // Rule ID 5986 //
     /* 1432022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1432033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1432036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1432039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432072 */     // MIs[1] Operand 1
     /* 1432072 */     // No operand predicates
     /* 1432072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432076 */     // MIs[0] policy
     /* 1432076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432088 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1432091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432113 */     // GIR_Coverage, 5986,
     /* 1432113 */     GIR_EraseRootFromParent_Done,
     /* 1432114 */   // Label 20189: @1432114
     /* 1432114 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1432211), // Rule ID 5987 //
     /* 1432119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1432130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1432133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1432136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432169 */     // MIs[1] Operand 1
     /* 1432169 */     // No operand predicates
     /* 1432169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432173 */     // MIs[0] policy
     /* 1432173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432185 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1432188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432210 */     // GIR_Coverage, 5987,
     /* 1432210 */     GIR_EraseRootFromParent_Done,
     /* 1432211 */   // Label 20190: @1432211
     /* 1432211 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1432308), // Rule ID 5990 //
     /* 1432216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1432227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1432230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1432233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1432239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432266 */     // MIs[1] Operand 1
     /* 1432266 */     // No operand predicates
     /* 1432266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432270 */     // MIs[0] policy
     /* 1432270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1432285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432307 */     // GIR_Coverage, 5990,
     /* 1432307 */     GIR_EraseRootFromParent_Done,
     /* 1432308 */   // Label 20191: @1432308
     /* 1432308 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1432405), // Rule ID 5991 //
     /* 1432313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1432324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1432327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1432330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1432336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432363 */     // MIs[1] Operand 1
     /* 1432363 */     // No operand predicates
     /* 1432363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432367 */     // MIs[0] policy
     /* 1432367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432379 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1432382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432404 */     // GIR_Coverage, 5991,
     /* 1432404 */     GIR_EraseRootFromParent_Done,
     /* 1432405 */   // Label 20192: @1432405
     /* 1432405 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1432502), // Rule ID 5994 //
     /* 1432410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1432421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1432424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1432427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432460 */     // MIs[1] Operand 1
     /* 1432460 */     // No operand predicates
     /* 1432460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432464 */     // MIs[0] policy
     /* 1432464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1432479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432501 */     // GIR_Coverage, 5994,
     /* 1432501 */     GIR_EraseRootFromParent_Done,
     /* 1432502 */   // Label 20193: @1432502
     /* 1432502 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1432599), // Rule ID 5995 //
     /* 1432507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1432518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1432521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1432524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432557 */     // MIs[1] Operand 1
     /* 1432557 */     // No operand predicates
     /* 1432557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432561 */     // MIs[0] policy
     /* 1432561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1432576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432598 */     // GIR_Coverage, 5995,
     /* 1432598 */     GIR_EraseRootFromParent_Done,
     /* 1432599 */   // Label 20194: @1432599
     /* 1432599 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1432696), // Rule ID 5998 //
     /* 1432604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1432615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1432618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1432621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1432627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432654 */     // MIs[1] Operand 1
     /* 1432654 */     // No operand predicates
     /* 1432654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432658 */     // MIs[0] policy
     /* 1432658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1432673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432695 */     // GIR_Coverage, 5998,
     /* 1432695 */     GIR_EraseRootFromParent_Done,
     /* 1432696 */   // Label 20195: @1432696
     /* 1432696 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1432793), // Rule ID 5999 //
     /* 1432701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1432712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1432715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1432718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1432724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432751 */     // MIs[1] Operand 1
     /* 1432751 */     // No operand predicates
     /* 1432751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432755 */     // MIs[0] policy
     /* 1432755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1432770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432792 */     // GIR_Coverage, 5999,
     /* 1432792 */     GIR_EraseRootFromParent_Done,
     /* 1432793 */   // Label 20196: @1432793
     /* 1432793 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1432890), // Rule ID 6002 //
     /* 1432798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1432809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1432812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1432815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432848 */     // MIs[1] Operand 1
     /* 1432848 */     // No operand predicates
     /* 1432848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432852 */     // MIs[0] policy
     /* 1432852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1432867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432889 */     // GIR_Coverage, 6002,
     /* 1432889 */     GIR_EraseRootFromParent_Done,
     /* 1432890 */   // Label 20197: @1432890
     /* 1432890 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1432987), // Rule ID 6003 //
     /* 1432895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1432906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1432909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1432912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432945 */     // MIs[1] Operand 1
     /* 1432945 */     // No operand predicates
     /* 1432945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432949 */     // MIs[0] policy
     /* 1432949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1432964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432986 */     // GIR_Coverage, 6003,
     /* 1432986 */     GIR_EraseRootFromParent_Done,
     /* 1432987 */   // Label 20198: @1432987
     /* 1432987 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1433084), // Rule ID 6006 //
     /* 1432992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1433003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1433006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1433009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433042 */     // MIs[1] Operand 1
     /* 1433042 */     // No operand predicates
     /* 1433042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433046 */     // MIs[0] policy
     /* 1433046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1433061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433083 */     // GIR_Coverage, 6006,
     /* 1433083 */     GIR_EraseRootFromParent_Done,
     /* 1433084 */   // Label 20199: @1433084
     /* 1433084 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1433181), // Rule ID 6007 //
     /* 1433089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1433100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1433103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1433106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433139 */     // MIs[1] Operand 1
     /* 1433139 */     // No operand predicates
     /* 1433139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433143 */     // MIs[0] policy
     /* 1433143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1433158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433180 */     // GIR_Coverage, 6007,
     /* 1433180 */     GIR_EraseRootFromParent_Done,
     /* 1433181 */   // Label 20200: @1433181
     /* 1433181 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1433278), // Rule ID 6010 //
     /* 1433186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1433197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1433200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1433203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433236 */     // MIs[1] Operand 1
     /* 1433236 */     // No operand predicates
     /* 1433236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433240 */     // MIs[0] policy
     /* 1433240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1433255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433277 */     // GIR_Coverage, 6010,
     /* 1433277 */     GIR_EraseRootFromParent_Done,
     /* 1433278 */   // Label 20201: @1433278
     /* 1433278 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1433375), // Rule ID 6011 //
     /* 1433283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1433294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1433297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1433300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433333 */     // MIs[1] Operand 1
     /* 1433333 */     // No operand predicates
     /* 1433333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433337 */     // MIs[0] policy
     /* 1433337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1433352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433374 */     // GIR_Coverage, 6011,
     /* 1433374 */     GIR_EraseRootFromParent_Done,
     /* 1433375 */   // Label 20202: @1433375
     /* 1433375 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1433472), // Rule ID 6014 //
     /* 1433380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1433391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1433394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1433397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433430 */     // MIs[1] Operand 1
     /* 1433430 */     // No operand predicates
     /* 1433430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433434 */     // MIs[0] policy
     /* 1433434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1433449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433471 */     // GIR_Coverage, 6014,
     /* 1433471 */     GIR_EraseRootFromParent_Done,
     /* 1433472 */   // Label 20203: @1433472
     /* 1433472 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1433569), // Rule ID 6015 //
     /* 1433477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1433488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1433491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1433494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433527 */     // MIs[1] Operand 1
     /* 1433527 */     // No operand predicates
     /* 1433527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433531 */     // MIs[0] policy
     /* 1433531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433543 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1433546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433568 */     // GIR_Coverage, 6015,
     /* 1433568 */     GIR_EraseRootFromParent_Done,
     /* 1433569 */   // Label 20204: @1433569
     /* 1433569 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1433666), // Rule ID 6018 //
     /* 1433574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1433585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1433588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1433591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433624 */     // MIs[1] Operand 1
     /* 1433624 */     // No operand predicates
     /* 1433624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433628 */     // MIs[0] policy
     /* 1433628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433640 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1433643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433665 */     // GIR_Coverage, 6018,
     /* 1433665 */     GIR_EraseRootFromParent_Done,
     /* 1433666 */   // Label 20205: @1433666
     /* 1433666 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1433763), // Rule ID 6019 //
     /* 1433671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1433682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1433685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1433688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433721 */     // MIs[1] Operand 1
     /* 1433721 */     // No operand predicates
     /* 1433721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433725 */     // MIs[0] policy
     /* 1433725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1433740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433762 */     // GIR_Coverage, 6019,
     /* 1433762 */     GIR_EraseRootFromParent_Done,
     /* 1433763 */   // Label 20206: @1433763
     /* 1433763 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1433860), // Rule ID 6022 //
     /* 1433768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1433779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1433782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1433785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433818 */     // MIs[1] Operand 1
     /* 1433818 */     // No operand predicates
     /* 1433818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433822 */     // MIs[0] policy
     /* 1433822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1433837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433859 */     // GIR_Coverage, 6022,
     /* 1433859 */     GIR_EraseRootFromParent_Done,
     /* 1433860 */   // Label 20207: @1433860
     /* 1433860 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1433957), // Rule ID 6023 //
     /* 1433865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1433876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1433879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1433882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433915 */     // MIs[1] Operand 1
     /* 1433915 */     // No operand predicates
     /* 1433915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433919 */     // MIs[0] policy
     /* 1433919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433931 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1433934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433956 */     // GIR_Coverage, 6023,
     /* 1433956 */     GIR_EraseRootFromParent_Done,
     /* 1433957 */   // Label 20208: @1433957
     /* 1433957 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1434054), // Rule ID 6026 //
     /* 1433962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1433973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1433976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1433979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434012 */     // MIs[1] Operand 1
     /* 1434012 */     // No operand predicates
     /* 1434012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434016 */     // MIs[0] policy
     /* 1434016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434053 */     // GIR_Coverage, 6026,
     /* 1434053 */     GIR_EraseRootFromParent_Done,
     /* 1434054 */   // Label 20209: @1434054
     /* 1434054 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1434151), // Rule ID 6027 //
     /* 1434059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1434062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1434070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1434073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1434076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434109 */     // MIs[1] Operand 1
     /* 1434109 */     // No operand predicates
     /* 1434109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434113 */     // MIs[0] policy
     /* 1434113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434125 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434150 */     // GIR_Coverage, 6027,
     /* 1434150 */     GIR_EraseRootFromParent_Done,
     /* 1434151 */   // Label 20210: @1434151
     /* 1434151 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1434248), // Rule ID 6206 //
     /* 1434156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1434167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1434170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1434173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434206 */     // MIs[1] Operand 1
     /* 1434206 */     // No operand predicates
     /* 1434206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434210 */     // MIs[0] policy
     /* 1434210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1434225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434247 */     // GIR_Coverage, 6206,
     /* 1434247 */     GIR_EraseRootFromParent_Done,
     /* 1434248 */   // Label 20211: @1434248
     /* 1434248 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1434345), // Rule ID 6207 //
     /* 1434253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1434264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1434267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1434270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434303 */     // MIs[1] Operand 1
     /* 1434303 */     // No operand predicates
     /* 1434303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434307 */     // MIs[0] policy
     /* 1434307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1434322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434344 */     // GIR_Coverage, 6207,
     /* 1434344 */     GIR_EraseRootFromParent_Done,
     /* 1434345 */   // Label 20212: @1434345
     /* 1434345 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1434442), // Rule ID 6210 //
     /* 1434350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1434361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1434364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1434367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434400 */     // MIs[1] Operand 1
     /* 1434400 */     // No operand predicates
     /* 1434400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434404 */     // MIs[0] policy
     /* 1434404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1434419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434441 */     // GIR_Coverage, 6210,
     /* 1434441 */     GIR_EraseRootFromParent_Done,
     /* 1434442 */   // Label 20213: @1434442
     /* 1434442 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1434539), // Rule ID 6211 //
     /* 1434447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1434458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1434461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1434464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434497 */     // MIs[1] Operand 1
     /* 1434497 */     // No operand predicates
     /* 1434497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434501 */     // MIs[0] policy
     /* 1434501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434513 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1434516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434538 */     // GIR_Coverage, 6211,
     /* 1434538 */     GIR_EraseRootFromParent_Done,
     /* 1434539 */   // Label 20214: @1434539
     /* 1434539 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1434636), // Rule ID 6214 //
     /* 1434544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1434555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1434558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1434561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434594 */     // MIs[1] Operand 1
     /* 1434594 */     // No operand predicates
     /* 1434594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434598 */     // MIs[0] policy
     /* 1434598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434610 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1434613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434635 */     // GIR_Coverage, 6214,
     /* 1434635 */     GIR_EraseRootFromParent_Done,
     /* 1434636 */   // Label 20215: @1434636
     /* 1434636 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1434733), // Rule ID 6215 //
     /* 1434641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1434652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1434655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1434658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434691 */     // MIs[1] Operand 1
     /* 1434691 */     // No operand predicates
     /* 1434691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434695 */     // MIs[0] policy
     /* 1434695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434707 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1434710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434732 */     // GIR_Coverage, 6215,
     /* 1434732 */     GIR_EraseRootFromParent_Done,
     /* 1434733 */   // Label 20216: @1434733
     /* 1434733 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1434830), // Rule ID 6218 //
     /* 1434738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1434749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1434752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1434755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434788 */     // MIs[1] Operand 1
     /* 1434788 */     // No operand predicates
     /* 1434788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434792 */     // MIs[0] policy
     /* 1434792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1434807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434829 */     // GIR_Coverage, 6218,
     /* 1434829 */     GIR_EraseRootFromParent_Done,
     /* 1434830 */   // Label 20217: @1434830
     /* 1434830 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1434927), // Rule ID 6219 //
     /* 1434835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1434846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1434849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1434852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434885 */     // MIs[1] Operand 1
     /* 1434885 */     // No operand predicates
     /* 1434885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434889 */     // MIs[0] policy
     /* 1434889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434901 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1434904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434926 */     // GIR_Coverage, 6219,
     /* 1434926 */     GIR_EraseRootFromParent_Done,
     /* 1434927 */   // Label 20218: @1434927
     /* 1434927 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1435024), // Rule ID 6222 //
     /* 1434932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1434940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1434943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1434946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1434949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434982 */     // MIs[1] Operand 1
     /* 1434982 */     // No operand predicates
     /* 1434982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434986 */     // MIs[0] policy
     /* 1434986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1435001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435023 */     // GIR_Coverage, 6222,
     /* 1435023 */     GIR_EraseRootFromParent_Done,
     /* 1435024 */   // Label 20219: @1435024
     /* 1435024 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1435121), // Rule ID 6223 //
     /* 1435029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1435040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1435043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1435046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435079 */     // MIs[1] Operand 1
     /* 1435079 */     // No operand predicates
     /* 1435079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435083 */     // MIs[0] policy
     /* 1435083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435095 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1435098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435120 */     // GIR_Coverage, 6223,
     /* 1435120 */     GIR_EraseRootFromParent_Done,
     /* 1435121 */   // Label 20220: @1435121
     /* 1435121 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1435218), // Rule ID 6226 //
     /* 1435126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435176 */     // MIs[1] Operand 1
     /* 1435176 */     // No operand predicates
     /* 1435176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435180 */     // MIs[0] policy
     /* 1435180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1435195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435217 */     // GIR_Coverage, 6226,
     /* 1435217 */     GIR_EraseRootFromParent_Done,
     /* 1435218 */   // Label 20221: @1435218
     /* 1435218 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1435315), // Rule ID 6227 //
     /* 1435223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435273 */     // MIs[1] Operand 1
     /* 1435273 */     // No operand predicates
     /* 1435273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435277 */     // MIs[0] policy
     /* 1435277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1435292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435314 */     // GIR_Coverage, 6227,
     /* 1435314 */     GIR_EraseRootFromParent_Done,
     /* 1435315 */   // Label 20222: @1435315
     /* 1435315 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1435412), // Rule ID 6230 //
     /* 1435320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1435331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1435334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1435337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435370 */     // MIs[1] Operand 1
     /* 1435370 */     // No operand predicates
     /* 1435370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435374 */     // MIs[0] policy
     /* 1435374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435411 */     // GIR_Coverage, 6230,
     /* 1435411 */     GIR_EraseRootFromParent_Done,
     /* 1435412 */   // Label 20223: @1435412
     /* 1435412 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1435509), // Rule ID 6231 //
     /* 1435417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1435428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1435431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1435434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435467 */     // MIs[1] Operand 1
     /* 1435467 */     // No operand predicates
     /* 1435467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435471 */     // MIs[0] policy
     /* 1435471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435483 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435508 */     // GIR_Coverage, 6231,
     /* 1435508 */     GIR_EraseRootFromParent_Done,
     /* 1435509 */   // Label 20224: @1435509
     /* 1435509 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1435606), // Rule ID 6234 //
     /* 1435514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435564 */     // MIs[1] Operand 1
     /* 1435564 */     // No operand predicates
     /* 1435564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435568 */     // MIs[0] policy
     /* 1435568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435605 */     // GIR_Coverage, 6234,
     /* 1435605 */     GIR_EraseRootFromParent_Done,
     /* 1435606 */   // Label 20225: @1435606
     /* 1435606 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1435703), // Rule ID 6235 //
     /* 1435611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435661 */     // MIs[1] Operand 1
     /* 1435661 */     // No operand predicates
     /* 1435661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435665 */     // MIs[0] policy
     /* 1435665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435702 */     // GIR_Coverage, 6235,
     /* 1435702 */     GIR_EraseRootFromParent_Done,
     /* 1435703 */   // Label 20226: @1435703
     /* 1435703 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1435800), // Rule ID 6238 //
     /* 1435708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1435719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1435722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1435725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435758 */     // MIs[1] Operand 1
     /* 1435758 */     // No operand predicates
     /* 1435758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435762 */     // MIs[0] policy
     /* 1435762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435799 */     // GIR_Coverage, 6238,
     /* 1435799 */     GIR_EraseRootFromParent_Done,
     /* 1435800 */   // Label 20227: @1435800
     /* 1435800 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1435897), // Rule ID 6239 //
     /* 1435805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1435816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1435819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1435822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435855 */     // MIs[1] Operand 1
     /* 1435855 */     // No operand predicates
     /* 1435855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435859 */     // MIs[0] policy
     /* 1435859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435896 */     // GIR_Coverage, 6239,
     /* 1435896 */     GIR_EraseRootFromParent_Done,
     /* 1435897 */   // Label 20228: @1435897
     /* 1435897 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1435994), // Rule ID 6242 //
     /* 1435902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1435910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1435913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1435916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1435919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435952 */     // MIs[1] Operand 1
     /* 1435952 */     // No operand predicates
     /* 1435952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435956 */     // MIs[0] policy
     /* 1435956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1435971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435993 */     // GIR_Coverage, 6242,
     /* 1435993 */     GIR_EraseRootFromParent_Done,
     /* 1435994 */   // Label 20229: @1435994
     /* 1435994 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1436091), // Rule ID 6243 //
     /* 1435999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1436010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1436013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1436016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436049 */     // MIs[1] Operand 1
     /* 1436049 */     // No operand predicates
     /* 1436049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436053 */     // MIs[0] policy
     /* 1436053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1436068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436090 */     // GIR_Coverage, 6243,
     /* 1436090 */     GIR_EraseRootFromParent_Done,
     /* 1436091 */   // Label 20230: @1436091
     /* 1436091 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1436188), // Rule ID 6246 //
     /* 1436096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1436107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1436110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1436113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436146 */     // MIs[1] Operand 1
     /* 1436146 */     // No operand predicates
     /* 1436146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436150 */     // MIs[0] policy
     /* 1436150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1436165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436187 */     // GIR_Coverage, 6246,
     /* 1436187 */     GIR_EraseRootFromParent_Done,
     /* 1436188 */   // Label 20231: @1436188
     /* 1436188 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1436285), // Rule ID 6247 //
     /* 1436193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1436204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1436207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1436210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436243 */     // MIs[1] Operand 1
     /* 1436243 */     // No operand predicates
     /* 1436243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436247 */     // MIs[0] policy
     /* 1436247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1436262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436284 */     // GIR_Coverage, 6247,
     /* 1436284 */     GIR_EraseRootFromParent_Done,
     /* 1436285 */   // Label 20232: @1436285
     /* 1436285 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1436382), // Rule ID 6250 //
     /* 1436290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1436301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1436304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1436307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1436313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436340 */     // MIs[1] Operand 1
     /* 1436340 */     // No operand predicates
     /* 1436340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436344 */     // MIs[0] policy
     /* 1436344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1436359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436381 */     // GIR_Coverage, 6250,
     /* 1436381 */     GIR_EraseRootFromParent_Done,
     /* 1436382 */   // Label 20233: @1436382
     /* 1436382 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1436479), // Rule ID 6251 //
     /* 1436387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1436398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1436401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1436404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1436410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436437 */     // MIs[1] Operand 1
     /* 1436437 */     // No operand predicates
     /* 1436437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436441 */     // MIs[0] policy
     /* 1436441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436453 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1436456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436478 */     // GIR_Coverage, 6251,
     /* 1436478 */     GIR_EraseRootFromParent_Done,
     /* 1436479 */   // Label 20234: @1436479
     /* 1436479 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1436576), // Rule ID 6254 //
     /* 1436484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1436495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1436498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1436501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1436507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436534 */     // MIs[1] Operand 1
     /* 1436534 */     // No operand predicates
     /* 1436534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436538 */     // MIs[0] policy
     /* 1436538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1436553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436575 */     // GIR_Coverage, 6254,
     /* 1436575 */     GIR_EraseRootFromParent_Done,
     /* 1436576 */   // Label 20235: @1436576
     /* 1436576 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1436673), // Rule ID 6255 //
     /* 1436581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1436592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1436595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1436598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1436604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436631 */     // MIs[1] Operand 1
     /* 1436631 */     // No operand predicates
     /* 1436631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436635 */     // MIs[0] policy
     /* 1436635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436647 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1436650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436672 */     // GIR_Coverage, 6255,
     /* 1436672 */     GIR_EraseRootFromParent_Done,
     /* 1436673 */   // Label 20236: @1436673
     /* 1436673 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1436770), // Rule ID 6258 //
     /* 1436678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436728 */     // MIs[1] Operand 1
     /* 1436728 */     // No operand predicates
     /* 1436728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436732 */     // MIs[0] policy
     /* 1436732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1436747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436769 */     // GIR_Coverage, 6258,
     /* 1436769 */     GIR_EraseRootFromParent_Done,
     /* 1436770 */   // Label 20237: @1436770
     /* 1436770 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1436867), // Rule ID 6259 //
     /* 1436775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436825 */     // MIs[1] Operand 1
     /* 1436825 */     // No operand predicates
     /* 1436825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436829 */     // MIs[0] policy
     /* 1436829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1436844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436866 */     // GIR_Coverage, 6259,
     /* 1436866 */     GIR_EraseRootFromParent_Done,
     /* 1436867 */   // Label 20238: @1436867
     /* 1436867 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1436964), // Rule ID 6262 //
     /* 1436872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436922 */     // MIs[1] Operand 1
     /* 1436922 */     // No operand predicates
     /* 1436922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436926 */     // MIs[0] policy
     /* 1436926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1436941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436963 */     // GIR_Coverage, 6262,
     /* 1436963 */     GIR_EraseRootFromParent_Done,
     /* 1436964 */   // Label 20239: @1436964
     /* 1436964 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1437061), // Rule ID 6263 //
     /* 1436969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437019 */     // MIs[1] Operand 1
     /* 1437019 */     // No operand predicates
     /* 1437019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437023 */     // MIs[0] policy
     /* 1437023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437035 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1437038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437060 */     // GIR_Coverage, 6263,
     /* 1437060 */     GIR_EraseRootFromParent_Done,
     /* 1437061 */   // Label 20240: @1437061
     /* 1437061 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1437158), // Rule ID 6266 //
     /* 1437066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1437077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1437080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1437083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1437089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437116 */     // MIs[1] Operand 1
     /* 1437116 */     // No operand predicates
     /* 1437116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437120 */     // MIs[0] policy
     /* 1437120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437132 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1437135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437157 */     // GIR_Coverage, 6266,
     /* 1437157 */     GIR_EraseRootFromParent_Done,
     /* 1437158 */   // Label 20241: @1437158
     /* 1437158 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1437255), // Rule ID 6267 //
     /* 1437163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1437174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1437177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1437180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1437186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437213 */     // MIs[1] Operand 1
     /* 1437213 */     // No operand predicates
     /* 1437213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437217 */     // MIs[0] policy
     /* 1437217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437229 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1437232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437254 */     // GIR_Coverage, 6267,
     /* 1437254 */     GIR_EraseRootFromParent_Done,
     /* 1437255 */   // Label 20242: @1437255
     /* 1437255 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1437352), // Rule ID 6270 //
     /* 1437260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1437271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1437274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1437277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437310 */     // MIs[1] Operand 1
     /* 1437310 */     // No operand predicates
     /* 1437310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437314 */     // MIs[0] policy
     /* 1437314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1437329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437351 */     // GIR_Coverage, 6270,
     /* 1437351 */     GIR_EraseRootFromParent_Done,
     /* 1437352 */   // Label 20243: @1437352
     /* 1437352 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1437449), // Rule ID 6271 //
     /* 1437357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1437368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1437371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1437374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437407 */     // MIs[1] Operand 1
     /* 1437407 */     // No operand predicates
     /* 1437407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437411 */     // MIs[0] policy
     /* 1437411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1437426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437448 */     // GIR_Coverage, 6271,
     /* 1437448 */     GIR_EraseRootFromParent_Done,
     /* 1437449 */   // Label 20244: @1437449
     /* 1437449 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1437546), // Rule ID 6274 //
     /* 1437454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1437484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437504 */     // MIs[1] Operand 1
     /* 1437504 */     // No operand predicates
     /* 1437504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437508 */     // MIs[0] policy
     /* 1437508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1437523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437545 */     // GIR_Coverage, 6274,
     /* 1437545 */     GIR_EraseRootFromParent_Done,
     /* 1437546 */   // Label 20245: @1437546
     /* 1437546 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1437643), // Rule ID 6275 //
     /* 1437551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1437581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437601 */     // MIs[1] Operand 1
     /* 1437601 */     // No operand predicates
     /* 1437601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437605 */     // MIs[0] policy
     /* 1437605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437617 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1437620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437642 */     // GIR_Coverage, 6275,
     /* 1437642 */     GIR_EraseRootFromParent_Done,
     /* 1437643 */   // Label 20246: @1437643
     /* 1437643 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1437740), // Rule ID 6278 //
     /* 1437648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1437671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437698 */     // MIs[1] Operand 1
     /* 1437698 */     // No operand predicates
     /* 1437698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437702 */     // MIs[0] policy
     /* 1437702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437714 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1437717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437739 */     // GIR_Coverage, 6278,
     /* 1437739 */     GIR_EraseRootFromParent_Done,
     /* 1437740 */   // Label 20247: @1437740
     /* 1437740 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1437837), // Rule ID 6279 //
     /* 1437745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1437768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437795 */     // MIs[1] Operand 1
     /* 1437795 */     // No operand predicates
     /* 1437795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437799 */     // MIs[0] policy
     /* 1437799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1437814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437836 */     // GIR_Coverage, 6279,
     /* 1437836 */     GIR_EraseRootFromParent_Done,
     /* 1437837 */   // Label 20248: @1437837
     /* 1437837 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1437934), // Rule ID 6282 //
     /* 1437842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1437845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437892 */     // MIs[1] Operand 1
     /* 1437892 */     // No operand predicates
     /* 1437892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437896 */     // MIs[0] policy
     /* 1437896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1437911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437933 */     // GIR_Coverage, 6282,
     /* 1437933 */     GIR_EraseRootFromParent_Done,
     /* 1437934 */   // Label 20249: @1437934
     /* 1437934 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1438031), // Rule ID 6283 //
     /* 1437939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1437942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437989 */     // MIs[1] Operand 1
     /* 1437989 */     // No operand predicates
     /* 1437989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437993 */     // MIs[0] policy
     /* 1437993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438030 */     // GIR_Coverage, 6283,
     /* 1438030 */     GIR_EraseRootFromParent_Done,
     /* 1438031 */   // Label 20250: @1438031
     /* 1438031 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1438128), // Rule ID 6286 //
     /* 1438036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1438047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1438050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1438053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438086 */     // MIs[1] Operand 1
     /* 1438086 */     // No operand predicates
     /* 1438086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438090 */     // MIs[0] policy
     /* 1438090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438127 */     // GIR_Coverage, 6286,
     /* 1438127 */     GIR_EraseRootFromParent_Done,
     /* 1438128 */   // Label 20251: @1438128
     /* 1438128 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1438225), // Rule ID 6287 //
     /* 1438133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1438144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1438147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1438150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438183 */     // MIs[1] Operand 1
     /* 1438183 */     // No operand predicates
     /* 1438183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438187 */     // MIs[0] policy
     /* 1438187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438224 */     // GIR_Coverage, 6287,
     /* 1438224 */     GIR_EraseRootFromParent_Done,
     /* 1438225 */   // Label 20252: @1438225
     /* 1438225 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1438322), // Rule ID 6290 //
     /* 1438230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1438241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1438244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1438247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438280 */     // MIs[1] Operand 1
     /* 1438280 */     // No operand predicates
     /* 1438280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438284 */     // MIs[0] policy
     /* 1438284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438321 */     // GIR_Coverage, 6290,
     /* 1438321 */     GIR_EraseRootFromParent_Done,
     /* 1438322 */   // Label 20253: @1438322
     /* 1438322 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1438419), // Rule ID 6291 //
     /* 1438327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1438338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1438341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1438344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438377 */     // MIs[1] Operand 1
     /* 1438377 */     // No operand predicates
     /* 1438377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438381 */     // MIs[0] policy
     /* 1438381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438393 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438418 */     // GIR_Coverage, 6291,
     /* 1438418 */     GIR_EraseRootFromParent_Done,
     /* 1438419 */   // Label 20254: @1438419
     /* 1438419 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1438516), // Rule ID 6470 //
     /* 1438424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1438435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1438438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1438441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438474 */     // MIs[1] Operand 1
     /* 1438474 */     // No operand predicates
     /* 1438474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438478 */     // MIs[0] policy
     /* 1438478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1438493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438515 */     // GIR_Coverage, 6470,
     /* 1438515 */     GIR_EraseRootFromParent_Done,
     /* 1438516 */   // Label 20255: @1438516
     /* 1438516 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1438613), // Rule ID 6471 //
     /* 1438521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1438532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1438535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1438538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438571 */     // MIs[1] Operand 1
     /* 1438571 */     // No operand predicates
     /* 1438571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438575 */     // MIs[0] policy
     /* 1438575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438587 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1438590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438612 */     // GIR_Coverage, 6471,
     /* 1438612 */     GIR_EraseRootFromParent_Done,
     /* 1438613 */   // Label 20256: @1438613
     /* 1438613 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1438710), // Rule ID 6474 //
     /* 1438618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1438629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1438632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1438635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438668 */     // MIs[1] Operand 1
     /* 1438668 */     // No operand predicates
     /* 1438668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438672 */     // MIs[0] policy
     /* 1438672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1438687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438709 */     // GIR_Coverage, 6474,
     /* 1438709 */     GIR_EraseRootFromParent_Done,
     /* 1438710 */   // Label 20257: @1438710
     /* 1438710 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1438807), // Rule ID 6475 //
     /* 1438715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1438726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1438729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1438732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438765 */     // MIs[1] Operand 1
     /* 1438765 */     // No operand predicates
     /* 1438765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438769 */     // MIs[0] policy
     /* 1438769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438781 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1438784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438806 */     // GIR_Coverage, 6475,
     /* 1438806 */     GIR_EraseRootFromParent_Done,
     /* 1438807 */   // Label 20258: @1438807
     /* 1438807 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1438904), // Rule ID 6478 //
     /* 1438812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1438823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1438826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1438829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438862 */     // MIs[1] Operand 1
     /* 1438862 */     // No operand predicates
     /* 1438862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438866 */     // MIs[0] policy
     /* 1438866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1438881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438903 */     // GIR_Coverage, 6478,
     /* 1438903 */     GIR_EraseRootFromParent_Done,
     /* 1438904 */   // Label 20259: @1438904
     /* 1438904 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1439001), // Rule ID 6479 //
     /* 1438909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1438920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1438923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1438926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438959 */     // MIs[1] Operand 1
     /* 1438959 */     // No operand predicates
     /* 1438959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438963 */     // MIs[0] policy
     /* 1438963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438975 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1438978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439000 */     // GIR_Coverage, 6479,
     /* 1439000 */     GIR_EraseRootFromParent_Done,
     /* 1439001 */   // Label 20260: @1439001
     /* 1439001 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1439098), // Rule ID 6482 //
     /* 1439006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1439017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1439020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1439023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439056 */     // MIs[1] Operand 1
     /* 1439056 */     // No operand predicates
     /* 1439056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439060 */     // MIs[0] policy
     /* 1439060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1439075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439097 */     // GIR_Coverage, 6482,
     /* 1439097 */     GIR_EraseRootFromParent_Done,
     /* 1439098 */   // Label 20261: @1439098
     /* 1439098 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1439195), // Rule ID 6483 //
     /* 1439103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1439114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1439117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1439120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439153 */     // MIs[1] Operand 1
     /* 1439153 */     // No operand predicates
     /* 1439153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439157 */     // MIs[0] policy
     /* 1439157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1439172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439194 */     // GIR_Coverage, 6483,
     /* 1439194 */     GIR_EraseRootFromParent_Done,
     /* 1439195 */   // Label 20262: @1439195
     /* 1439195 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1439292), // Rule ID 6486 //
     /* 1439200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1439211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1439214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1439217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439250 */     // MIs[1] Operand 1
     /* 1439250 */     // No operand predicates
     /* 1439250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439254 */     // MIs[0] policy
     /* 1439254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1439269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439291 */     // GIR_Coverage, 6486,
     /* 1439291 */     GIR_EraseRootFromParent_Done,
     /* 1439292 */   // Label 20263: @1439292
     /* 1439292 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1439389), // Rule ID 6487 //
     /* 1439297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1439308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1439311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1439314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439347 */     // MIs[1] Operand 1
     /* 1439347 */     // No operand predicates
     /* 1439347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439351 */     // MIs[0] policy
     /* 1439351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439363 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1439366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439388 */     // GIR_Coverage, 6487,
     /* 1439388 */     GIR_EraseRootFromParent_Done,
     /* 1439389 */   // Label 20264: @1439389
     /* 1439389 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1439486), // Rule ID 6490 //
     /* 1439394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1439405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1439408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1439411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439444 */     // MIs[1] Operand 1
     /* 1439444 */     // No operand predicates
     /* 1439444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439448 */     // MIs[0] policy
     /* 1439448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439460 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1439463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439485 */     // GIR_Coverage, 6490,
     /* 1439485 */     GIR_EraseRootFromParent_Done,
     /* 1439486 */   // Label 20265: @1439486
     /* 1439486 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1439583), // Rule ID 6491 //
     /* 1439491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1439502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1439505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1439508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439541 */     // MIs[1] Operand 1
     /* 1439541 */     // No operand predicates
     /* 1439541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439545 */     // MIs[0] policy
     /* 1439545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439557 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1439560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439582 */     // GIR_Coverage, 6491,
     /* 1439582 */     GIR_EraseRootFromParent_Done,
     /* 1439583 */   // Label 20266: @1439583
     /* 1439583 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1439680), // Rule ID 6494 //
     /* 1439588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1439599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1439602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1439605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439638 */     // MIs[1] Operand 1
     /* 1439638 */     // No operand predicates
     /* 1439638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439642 */     // MIs[0] policy
     /* 1439642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1439657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439679 */     // GIR_Coverage, 6494,
     /* 1439679 */     GIR_EraseRootFromParent_Done,
     /* 1439680 */   // Label 20267: @1439680
     /* 1439680 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1439777), // Rule ID 6495 //
     /* 1439685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1439696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1439699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1439702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439735 */     // MIs[1] Operand 1
     /* 1439735 */     // No operand predicates
     /* 1439735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439739 */     // MIs[0] policy
     /* 1439739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439751 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1439754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439776 */     // GIR_Coverage, 6495,
     /* 1439776 */     GIR_EraseRootFromParent_Done,
     /* 1439777 */   // Label 20268: @1439777
     /* 1439777 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1439874), // Rule ID 6498 //
     /* 1439782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1439793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1439796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1439799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439832 */     // MIs[1] Operand 1
     /* 1439832 */     // No operand predicates
     /* 1439832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439836 */     // MIs[0] policy
     /* 1439836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1439851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439873 */     // GIR_Coverage, 6498,
     /* 1439873 */     GIR_EraseRootFromParent_Done,
     /* 1439874 */   // Label 20269: @1439874
     /* 1439874 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1439971), // Rule ID 6499 //
     /* 1439879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1439890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1439893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1439896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439929 */     // MIs[1] Operand 1
     /* 1439929 */     // No operand predicates
     /* 1439929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439933 */     // MIs[0] policy
     /* 1439933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439945 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1439948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439970 */     // GIR_Coverage, 6499,
     /* 1439970 */     GIR_EraseRootFromParent_Done,
     /* 1439971 */   // Label 20270: @1439971
     /* 1439971 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1440068), // Rule ID 6502 //
     /* 1439976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1439984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1439987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1439990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1439993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440026 */     // MIs[1] Operand 1
     /* 1440026 */     // No operand predicates
     /* 1440026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440030 */     // MIs[0] policy
     /* 1440030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1440045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440067 */     // GIR_Coverage, 6502,
     /* 1440067 */     GIR_EraseRootFromParent_Done,
     /* 1440068 */   // Label 20271: @1440068
     /* 1440068 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1440165), // Rule ID 6503 //
     /* 1440073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1440084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1440087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1440090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440123 */     // MIs[1] Operand 1
     /* 1440123 */     // No operand predicates
     /* 1440123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440127 */     // MIs[0] policy
     /* 1440127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440139 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1440142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440164 */     // GIR_Coverage, 6503,
     /* 1440164 */     GIR_EraseRootFromParent_Done,
     /* 1440165 */   // Label 20272: @1440165
     /* 1440165 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1440262), // Rule ID 6506 //
     /* 1440170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1440181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1440184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1440187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440220 */     // MIs[1] Operand 1
     /* 1440220 */     // No operand predicates
     /* 1440220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440224 */     // MIs[0] policy
     /* 1440224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440236 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1440239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440261 */     // GIR_Coverage, 6506,
     /* 1440261 */     GIR_EraseRootFromParent_Done,
     /* 1440262 */   // Label 20273: @1440262
     /* 1440262 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1440359), // Rule ID 6507 //
     /* 1440267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1440278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1440281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1440284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440317 */     // MIs[1] Operand 1
     /* 1440317 */     // No operand predicates
     /* 1440317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440321 */     // MIs[0] policy
     /* 1440321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440333 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1440336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440358 */     // GIR_Coverage, 6507,
     /* 1440358 */     GIR_EraseRootFromParent_Done,
     /* 1440359 */   // Label 20274: @1440359
     /* 1440359 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1440456), // Rule ID 6510 //
     /* 1440364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1440375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1440378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1440381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440414 */     // MIs[1] Operand 1
     /* 1440414 */     // No operand predicates
     /* 1440414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440418 */     // MIs[0] policy
     /* 1440418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1440433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440455 */     // GIR_Coverage, 6510,
     /* 1440455 */     GIR_EraseRootFromParent_Done,
     /* 1440456 */   // Label 20275: @1440456
     /* 1440456 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1440553), // Rule ID 6511 //
     /* 1440461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1440472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1440475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1440478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440511 */     // MIs[1] Operand 1
     /* 1440511 */     // No operand predicates
     /* 1440511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440515 */     // MIs[0] policy
     /* 1440515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1440530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440552 */     // GIR_Coverage, 6511,
     /* 1440552 */     GIR_EraseRootFromParent_Done,
     /* 1440553 */   // Label 20276: @1440553
     /* 1440553 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1440650), // Rule ID 6514 //
     /* 1440558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1440569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1440572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1440575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1440581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440608 */     // MIs[1] Operand 1
     /* 1440608 */     // No operand predicates
     /* 1440608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440612 */     // MIs[0] policy
     /* 1440612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1440627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440649 */     // GIR_Coverage, 6514,
     /* 1440649 */     GIR_EraseRootFromParent_Done,
     /* 1440650 */   // Label 20277: @1440650
     /* 1440650 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1440747), // Rule ID 6515 //
     /* 1440655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1440666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1440669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1440672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1440678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440705 */     // MIs[1] Operand 1
     /* 1440705 */     // No operand predicates
     /* 1440705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440709 */     // MIs[0] policy
     /* 1440709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1440724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440746 */     // GIR_Coverage, 6515,
     /* 1440746 */     GIR_EraseRootFromParent_Done,
     /* 1440747 */   // Label 20278: @1440747
     /* 1440747 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1440844), // Rule ID 6518 //
     /* 1440752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1440763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1440766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1440769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1440775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440802 */     // MIs[1] Operand 1
     /* 1440802 */     // No operand predicates
     /* 1440802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440806 */     // MIs[0] policy
     /* 1440806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1440821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440843 */     // GIR_Coverage, 6518,
     /* 1440843 */     GIR_EraseRootFromParent_Done,
     /* 1440844 */   // Label 20279: @1440844
     /* 1440844 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1440941), // Rule ID 6519 //
     /* 1440849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1440860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1440863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1440866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1440872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440899 */     // MIs[1] Operand 1
     /* 1440899 */     // No operand predicates
     /* 1440899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440903 */     // MIs[0] policy
     /* 1440903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440915 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1440918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440940 */     // GIR_Coverage, 6519,
     /* 1440940 */     GIR_EraseRootFromParent_Done,
     /* 1440941 */   // Label 20280: @1440941
     /* 1440941 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1441038), // Rule ID 6522 //
     /* 1440946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1440957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1440960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1440963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440996 */     // MIs[1] Operand 1
     /* 1440996 */     // No operand predicates
     /* 1440996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441000 */     // MIs[0] policy
     /* 1441000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1441015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441037 */     // GIR_Coverage, 6522,
     /* 1441037 */     GIR_EraseRootFromParent_Done,
     /* 1441038 */   // Label 20281: @1441038
     /* 1441038 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1441135), // Rule ID 6523 //
     /* 1441043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1441054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1441057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1441060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1441073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441093 */     // MIs[1] Operand 1
     /* 1441093 */     // No operand predicates
     /* 1441093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441097 */     // MIs[0] policy
     /* 1441097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1441112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441134 */     // GIR_Coverage, 6523,
     /* 1441134 */     GIR_EraseRootFromParent_Done,
     /* 1441135 */   // Label 20282: @1441135
     /* 1441135 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1441232), // Rule ID 6526 //
     /* 1441140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1441151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1441154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1441157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441190 */     // MIs[1] Operand 1
     /* 1441190 */     // No operand predicates
     /* 1441190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441194 */     // MIs[0] policy
     /* 1441194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1441209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441231 */     // GIR_Coverage, 6526,
     /* 1441231 */     GIR_EraseRootFromParent_Done,
     /* 1441232 */   // Label 20283: @1441232
     /* 1441232 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1441329), // Rule ID 6527 //
     /* 1441237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1441248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1441251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1441254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441287 */     // MIs[1] Operand 1
     /* 1441287 */     // No operand predicates
     /* 1441287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441291 */     // MIs[0] policy
     /* 1441291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441303 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1441306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441328 */     // GIR_Coverage, 6527,
     /* 1441328 */     GIR_EraseRootFromParent_Done,
     /* 1441329 */   // Label 20284: @1441329
     /* 1441329 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1441426), // Rule ID 6530 //
     /* 1441334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1441345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1441348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1441351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1441357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441384 */     // MIs[1] Operand 1
     /* 1441384 */     // No operand predicates
     /* 1441384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441388 */     // MIs[0] policy
     /* 1441388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1441403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441425 */     // GIR_Coverage, 6530,
     /* 1441425 */     GIR_EraseRootFromParent_Done,
     /* 1441426 */   // Label 20285: @1441426
     /* 1441426 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1441523), // Rule ID 6531 //
     /* 1441431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1441442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1441445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1441448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1441454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441481 */     // MIs[1] Operand 1
     /* 1441481 */     // No operand predicates
     /* 1441481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441485 */     // MIs[0] policy
     /* 1441485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441497 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1441500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441522 */     // GIR_Coverage, 6531,
     /* 1441522 */     GIR_EraseRootFromParent_Done,
     /* 1441523 */   // Label 20286: @1441523
     /* 1441523 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1441620), // Rule ID 6534 //
     /* 1441528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1441539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1441542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1441558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441578 */     // MIs[1] Operand 1
     /* 1441578 */     // No operand predicates
     /* 1441578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441582 */     // MIs[0] policy
     /* 1441582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1441597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441619 */     // GIR_Coverage, 6534,
     /* 1441619 */     GIR_EraseRootFromParent_Done,
     /* 1441620 */   // Label 20287: @1441620
     /* 1441620 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1441717), // Rule ID 6535 //
     /* 1441625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1441636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1441639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1441655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441675 */     // MIs[1] Operand 1
     /* 1441675 */     // No operand predicates
     /* 1441675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441679 */     // MIs[0] policy
     /* 1441679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1441694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441716 */     // GIR_Coverage, 6535,
     /* 1441716 */     GIR_EraseRootFromParent_Done,
     /* 1441717 */   // Label 20288: @1441717
     /* 1441717 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1441814), // Rule ID 6538 //
     /* 1441722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1441733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1441736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441772 */     // MIs[1] Operand 1
     /* 1441772 */     // No operand predicates
     /* 1441772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441776 */     // MIs[0] policy
     /* 1441776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1441791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441813 */     // GIR_Coverage, 6538,
     /* 1441813 */     GIR_EraseRootFromParent_Done,
     /* 1441814 */   // Label 20289: @1441814
     /* 1441814 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1441911), // Rule ID 6539 //
     /* 1441819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1441830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1441833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441869 */     // MIs[1] Operand 1
     /* 1441869 */     // No operand predicates
     /* 1441869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441873 */     // MIs[0] policy
     /* 1441873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441885 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1441888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441910 */     // GIR_Coverage, 6539,
     /* 1441910 */     GIR_EraseRootFromParent_Done,
     /* 1441911 */   // Label 20290: @1441911
     /* 1441911 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1442008), // Rule ID 6542 //
     /* 1441916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1441927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1441930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1441933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441966 */     // MIs[1] Operand 1
     /* 1441966 */     // No operand predicates
     /* 1441966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441970 */     // MIs[0] policy
     /* 1441970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1441985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442007 */     // GIR_Coverage, 6542,
     /* 1442007 */     GIR_EraseRootFromParent_Done,
     /* 1442008 */   // Label 20291: @1442008
     /* 1442008 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1442105), // Rule ID 6543 //
     /* 1442013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1442024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1442027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1442030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442063 */     // MIs[1] Operand 1
     /* 1442063 */     // No operand predicates
     /* 1442063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442067 */     // MIs[0] policy
     /* 1442067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442079 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1442082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442104 */     // GIR_Coverage, 6543,
     /* 1442104 */     GIR_EraseRootFromParent_Done,
     /* 1442105 */   // Label 20292: @1442105
     /* 1442105 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1442202), // Rule ID 6546 //
     /* 1442110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1442127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442160 */     // MIs[1] Operand 1
     /* 1442160 */     // No operand predicates
     /* 1442160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442164 */     // MIs[0] policy
     /* 1442164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442201 */     // GIR_Coverage, 6546,
     /* 1442201 */     GIR_EraseRootFromParent_Done,
     /* 1442202 */   // Label 20293: @1442202
     /* 1442202 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1442299), // Rule ID 6547 //
     /* 1442207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1442224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442257 */     // MIs[1] Operand 1
     /* 1442257 */     // No operand predicates
     /* 1442257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442261 */     // MIs[0] policy
     /* 1442261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442298 */     // GIR_Coverage, 6547,
     /* 1442298 */     GIR_EraseRootFromParent_Done,
     /* 1442299 */   // Label 20294: @1442299
     /* 1442299 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1442396), // Rule ID 6550 //
     /* 1442304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1442321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442354 */     // MIs[1] Operand 1
     /* 1442354 */     // No operand predicates
     /* 1442354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442358 */     // MIs[0] policy
     /* 1442358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442395 */     // GIR_Coverage, 6550,
     /* 1442395 */     GIR_EraseRootFromParent_Done,
     /* 1442396 */   // Label 20295: @1442396
     /* 1442396 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1442493), // Rule ID 6551 //
     /* 1442401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1442418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442451 */     // MIs[1] Operand 1
     /* 1442451 */     // No operand predicates
     /* 1442451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442455 */     // MIs[0] policy
     /* 1442455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442467 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442492 */     // GIR_Coverage, 6551,
     /* 1442492 */     GIR_EraseRootFromParent_Done,
     /* 1442493 */   // Label 20296: @1442493
     /* 1442493 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1442590), // Rule ID 6554 //
     /* 1442498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1442509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1442512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1442515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442548 */     // MIs[1] Operand 1
     /* 1442548 */     // No operand predicates
     /* 1442548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442552 */     // MIs[0] policy
     /* 1442552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1442567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442589 */     // GIR_Coverage, 6554,
     /* 1442589 */     GIR_EraseRootFromParent_Done,
     /* 1442590 */   // Label 20297: @1442590
     /* 1442590 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1442687), // Rule ID 6555 //
     /* 1442595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1442606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1442609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1442612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442645 */     // MIs[1] Operand 1
     /* 1442645 */     // No operand predicates
     /* 1442645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442649 */     // MIs[0] policy
     /* 1442649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1442664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442686 */     // GIR_Coverage, 6555,
     /* 1442686 */     GIR_EraseRootFromParent_Done,
     /* 1442687 */   // Label 20298: @1442687
     /* 1442687 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1442784), // Rule ID 6734 //
     /* 1442692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1442703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1442706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1442709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442742 */     // MIs[1] Operand 1
     /* 1442742 */     // No operand predicates
     /* 1442742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442746 */     // MIs[0] policy
     /* 1442746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1442761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442783 */     // GIR_Coverage, 6734,
     /* 1442783 */     GIR_EraseRootFromParent_Done,
     /* 1442784 */   // Label 20299: @1442784
     /* 1442784 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1442881), // Rule ID 6735 //
     /* 1442789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1442800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1442803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1442806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442839 */     // MIs[1] Operand 1
     /* 1442839 */     // No operand predicates
     /* 1442839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442843 */     // MIs[0] policy
     /* 1442843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442855 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1442858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442880 */     // GIR_Coverage, 6735,
     /* 1442880 */     GIR_EraseRootFromParent_Done,
     /* 1442881 */   // Label 20300: @1442881
     /* 1442881 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1442978), // Rule ID 6738 //
     /* 1442886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1442897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1442900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1442903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442936 */     // MIs[1] Operand 1
     /* 1442936 */     // No operand predicates
     /* 1442936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442940 */     // MIs[0] policy
     /* 1442940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1442955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442977 */     // GIR_Coverage, 6738,
     /* 1442977 */     GIR_EraseRootFromParent_Done,
     /* 1442978 */   // Label 20301: @1442978
     /* 1442978 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1443075), // Rule ID 6739 //
     /* 1442983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1442994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1442997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1443000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443033 */     // MIs[1] Operand 1
     /* 1443033 */     // No operand predicates
     /* 1443033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443037 */     // MIs[0] policy
     /* 1443037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1443052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443074 */     // GIR_Coverage, 6739,
     /* 1443074 */     GIR_EraseRootFromParent_Done,
     /* 1443075 */   // Label 20302: @1443075
     /* 1443075 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1443172), // Rule ID 6742 //
     /* 1443080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1443091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1443094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1443097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443130 */     // MIs[1] Operand 1
     /* 1443130 */     // No operand predicates
     /* 1443130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443134 */     // MIs[0] policy
     /* 1443134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443146 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443171 */     // GIR_Coverage, 6742,
     /* 1443171 */     GIR_EraseRootFromParent_Done,
     /* 1443172 */   // Label 20303: @1443172
     /* 1443172 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1443269), // Rule ID 6743 //
     /* 1443177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1443188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1443191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1443194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443227 */     // MIs[1] Operand 1
     /* 1443227 */     // No operand predicates
     /* 1443227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443231 */     // MIs[0] policy
     /* 1443231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443268 */     // GIR_Coverage, 6743,
     /* 1443268 */     GIR_EraseRootFromParent_Done,
     /* 1443269 */   // Label 20304: @1443269
     /* 1443269 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1443366), // Rule ID 6746 //
     /* 1443274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1443285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1443288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443324 */     // MIs[1] Operand 1
     /* 1443324 */     // No operand predicates
     /* 1443324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443328 */     // MIs[0] policy
     /* 1443328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443340 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1443343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443365 */     // GIR_Coverage, 6746,
     /* 1443365 */     GIR_EraseRootFromParent_Done,
     /* 1443366 */   // Label 20305: @1443366
     /* 1443366 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1443463), // Rule ID 6747 //
     /* 1443371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1443382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1443385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443421 */     // MIs[1] Operand 1
     /* 1443421 */     // No operand predicates
     /* 1443421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443425 */     // MIs[0] policy
     /* 1443425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1443440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443462 */     // GIR_Coverage, 6747,
     /* 1443462 */     GIR_EraseRootFromParent_Done,
     /* 1443463 */   // Label 20306: @1443463
     /* 1443463 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1443560), // Rule ID 6750 //
     /* 1443468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1443479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1443482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443518 */     // MIs[1] Operand 1
     /* 1443518 */     // No operand predicates
     /* 1443518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443522 */     // MIs[0] policy
     /* 1443522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443559 */     // GIR_Coverage, 6750,
     /* 1443559 */     GIR_EraseRootFromParent_Done,
     /* 1443560 */   // Label 20307: @1443560
     /* 1443560 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1443657), // Rule ID 6751 //
     /* 1443565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1443576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1443579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443615 */     // MIs[1] Operand 1
     /* 1443615 */     // No operand predicates
     /* 1443615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443619 */     // MIs[0] policy
     /* 1443619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443631 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443656 */     // GIR_Coverage, 6751,
     /* 1443656 */     GIR_EraseRootFromParent_Done,
     /* 1443657 */   // Label 20308: @1443657
     /* 1443657 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1443754), // Rule ID 6754 //
     /* 1443662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1443679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443712 */     // MIs[1] Operand 1
     /* 1443712 */     // No operand predicates
     /* 1443712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443716 */     // MIs[0] policy
     /* 1443716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443753 */     // GIR_Coverage, 6754,
     /* 1443753 */     GIR_EraseRootFromParent_Done,
     /* 1443754 */   // Label 20309: @1443754
     /* 1443754 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1443851), // Rule ID 6755 //
     /* 1443759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1443776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443809 */     // MIs[1] Operand 1
     /* 1443809 */     // No operand predicates
     /* 1443809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443813 */     // MIs[0] policy
     /* 1443813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443825 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1443828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443850 */     // GIR_Coverage, 6755,
     /* 1443850 */     GIR_EraseRootFromParent_Done,
     /* 1443851 */   // Label 20310: @1443851
     /* 1443851 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1443948), // Rule ID 6758 //
     /* 1443856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1443867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1443870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1443873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443906 */     // MIs[1] Operand 1
     /* 1443906 */     // No operand predicates
     /* 1443906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443910 */     // MIs[0] policy
     /* 1443910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1443925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443947 */     // GIR_Coverage, 6758,
     /* 1443947 */     GIR_EraseRootFromParent_Done,
     /* 1443948 */   // Label 20311: @1443948
     /* 1443948 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1444045), // Rule ID 6759 //
     /* 1443953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1443961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1443964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1443967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1443970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444003 */     // MIs[1] Operand 1
     /* 1444003 */     // No operand predicates
     /* 1444003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444007 */     // MIs[0] policy
     /* 1444007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444044 */     // GIR_Coverage, 6759,
     /* 1444044 */     GIR_EraseRootFromParent_Done,
     /* 1444045 */   // Label 20312: @1444045
     /* 1444045 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1444142), // Rule ID 6762 //
     /* 1444050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1444061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1444064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1444067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444100 */     // MIs[1] Operand 1
     /* 1444100 */     // No operand predicates
     /* 1444100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444104 */     // MIs[0] policy
     /* 1444104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444141 */     // GIR_Coverage, 6762,
     /* 1444141 */     GIR_EraseRootFromParent_Done,
     /* 1444142 */   // Label 20313: @1444142
     /* 1444142 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1444239), // Rule ID 6763 //
     /* 1444147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1444158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1444161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1444164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444197 */     // MIs[1] Operand 1
     /* 1444197 */     // No operand predicates
     /* 1444197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444201 */     // MIs[0] policy
     /* 1444201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444213 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444238 */     // GIR_Coverage, 6763,
     /* 1444238 */     GIR_EraseRootFromParent_Done,
     /* 1444239 */   // Label 20314: @1444239
     /* 1444239 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1444336), // Rule ID 6766 //
     /* 1444244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444294 */     // MIs[1] Operand 1
     /* 1444294 */     // No operand predicates
     /* 1444294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444298 */     // MIs[0] policy
     /* 1444298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444335 */     // GIR_Coverage, 6766,
     /* 1444335 */     GIR_EraseRootFromParent_Done,
     /* 1444336 */   // Label 20315: @1444336
     /* 1444336 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1444433), // Rule ID 6767 //
     /* 1444341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444391 */     // MIs[1] Operand 1
     /* 1444391 */     // No operand predicates
     /* 1444391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444395 */     // MIs[0] policy
     /* 1444395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444407 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444432 */     // GIR_Coverage, 6767,
     /* 1444432 */     GIR_EraseRootFromParent_Done,
     /* 1444433 */   // Label 20316: @1444433
     /* 1444433 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1444530), // Rule ID 6770 //
     /* 1444438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1444455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444488 */     // MIs[1] Operand 1
     /* 1444488 */     // No operand predicates
     /* 1444488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444492 */     // MIs[0] policy
     /* 1444492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444529 */     // GIR_Coverage, 6770,
     /* 1444529 */     GIR_EraseRootFromParent_Done,
     /* 1444530 */   // Label 20317: @1444530
     /* 1444530 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1444627), // Rule ID 6771 //
     /* 1444535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1444552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444585 */     // MIs[1] Operand 1
     /* 1444585 */     // No operand predicates
     /* 1444585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444589 */     // MIs[0] policy
     /* 1444589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444601 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1444604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444626 */     // GIR_Coverage, 6771,
     /* 1444626 */     GIR_EraseRootFromParent_Done,
     /* 1444627 */   // Label 20318: @1444627
     /* 1444627 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1444724), // Rule ID 6774 //
     /* 1444632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1444643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1444646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1444649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444682 */     // MIs[1] Operand 1
     /* 1444682 */     // No operand predicates
     /* 1444682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444686 */     // MIs[0] policy
     /* 1444686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1444701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444723 */     // GIR_Coverage, 6774,
     /* 1444723 */     GIR_EraseRootFromParent_Done,
     /* 1444724 */   // Label 20319: @1444724
     /* 1444724 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1444821), // Rule ID 6775 //
     /* 1444729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1444740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1444743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1444746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444779 */     // MIs[1] Operand 1
     /* 1444779 */     // No operand predicates
     /* 1444779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444783 */     // MIs[0] policy
     /* 1444783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1444798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444820 */     // GIR_Coverage, 6775,
     /* 1444820 */     GIR_EraseRootFromParent_Done,
     /* 1444821 */   // Label 20320: @1444821
     /* 1444821 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1444918), // Rule ID 6778 //
     /* 1444826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1444837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1444840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1444843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444876 */     // MIs[1] Operand 1
     /* 1444876 */     // No operand predicates
     /* 1444876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444880 */     // MIs[0] policy
     /* 1444880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444892 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1444895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444917 */     // GIR_Coverage, 6778,
     /* 1444917 */     GIR_EraseRootFromParent_Done,
     /* 1444918 */   // Label 20321: @1444918
     /* 1444918 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1445015), // Rule ID 6779 //
     /* 1444923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1444934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1444937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1444940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444973 */     // MIs[1] Operand 1
     /* 1444973 */     // No operand predicates
     /* 1444973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444977 */     // MIs[0] policy
     /* 1444977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444989 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1444992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445014 */     // GIR_Coverage, 6779,
     /* 1445014 */     GIR_EraseRootFromParent_Done,
     /* 1445015 */   // Label 20322: @1445015
     /* 1445015 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1445112), // Rule ID 6782 //
     /* 1445020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1445031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1445034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1445037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1445043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445070 */     // MIs[1] Operand 1
     /* 1445070 */     // No operand predicates
     /* 1445070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445074 */     // MIs[0] policy
     /* 1445074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445086 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1445089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445111 */     // GIR_Coverage, 6782,
     /* 1445111 */     GIR_EraseRootFromParent_Done,
     /* 1445112 */   // Label 20323: @1445112
     /* 1445112 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1445209), // Rule ID 6783 //
     /* 1445117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1445128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1445131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1445134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1445140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445167 */     // MIs[1] Operand 1
     /* 1445167 */     // No operand predicates
     /* 1445167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445171 */     // MIs[0] policy
     /* 1445171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445183 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1445186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445208 */     // GIR_Coverage, 6783,
     /* 1445208 */     GIR_EraseRootFromParent_Done,
     /* 1445209 */   // Label 20324: @1445209
     /* 1445209 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1445306), // Rule ID 6786 //
     /* 1445214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1445225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1445228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1445231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445264 */     // MIs[1] Operand 1
     /* 1445264 */     // No operand predicates
     /* 1445264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445268 */     // MIs[0] policy
     /* 1445268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1445283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445305 */     // GIR_Coverage, 6786,
     /* 1445305 */     GIR_EraseRootFromParent_Done,
     /* 1445306 */   // Label 20325: @1445306
     /* 1445306 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1445403), // Rule ID 6787 //
     /* 1445311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1445322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1445325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1445328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445361 */     // MIs[1] Operand 1
     /* 1445361 */     // No operand predicates
     /* 1445361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445365 */     // MIs[0] policy
     /* 1445365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1445380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445402 */     // GIR_Coverage, 6787,
     /* 1445402 */     GIR_EraseRootFromParent_Done,
     /* 1445403 */   // Label 20326: @1445403
     /* 1445403 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1445500), // Rule ID 6790 //
     /* 1445408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1445419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1445422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1445425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1445431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445458 */     // MIs[1] Operand 1
     /* 1445458 */     // No operand predicates
     /* 1445458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445462 */     // MIs[0] policy
     /* 1445462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1445477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445499 */     // GIR_Coverage, 6790,
     /* 1445499 */     GIR_EraseRootFromParent_Done,
     /* 1445500 */   // Label 20327: @1445500
     /* 1445500 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1445597), // Rule ID 6791 //
     /* 1445505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1445516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1445519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1445522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1445528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445555 */     // MIs[1] Operand 1
     /* 1445555 */     // No operand predicates
     /* 1445555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445559 */     // MIs[0] policy
     /* 1445559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1445574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445596 */     // GIR_Coverage, 6791,
     /* 1445596 */     GIR_EraseRootFromParent_Done,
     /* 1445597 */   // Label 20328: @1445597
     /* 1445597 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1445694), // Rule ID 6794 //
     /* 1445602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1445613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1445616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1445619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1445625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445652 */     // MIs[1] Operand 1
     /* 1445652 */     // No operand predicates
     /* 1445652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445656 */     // MIs[0] policy
     /* 1445656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1445671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445693 */     // GIR_Coverage, 6794,
     /* 1445693 */     GIR_EraseRootFromParent_Done,
     /* 1445694 */   // Label 20329: @1445694
     /* 1445694 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1445791), // Rule ID 6795 //
     /* 1445699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1445710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1445713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1445716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1445722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445749 */     // MIs[1] Operand 1
     /* 1445749 */     // No operand predicates
     /* 1445749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445753 */     // MIs[0] policy
     /* 1445753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445765 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1445768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445790 */     // GIR_Coverage, 6795,
     /* 1445790 */     GIR_EraseRootFromParent_Done,
     /* 1445791 */   // Label 20330: @1445791
     /* 1445791 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1445888), // Rule ID 6798 //
     /* 1445796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1445813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445846 */     // MIs[1] Operand 1
     /* 1445846 */     // No operand predicates
     /* 1445846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445850 */     // MIs[0] policy
     /* 1445850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1445865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445887 */     // GIR_Coverage, 6798,
     /* 1445887 */     GIR_EraseRootFromParent_Done,
     /* 1445888 */   // Label 20331: @1445888
     /* 1445888 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1445985), // Rule ID 6799 //
     /* 1445893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1445910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445943 */     // MIs[1] Operand 1
     /* 1445943 */     // No operand predicates
     /* 1445943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445947 */     // MIs[0] policy
     /* 1445947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1445962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445984 */     // GIR_Coverage, 6799,
     /* 1445984 */     GIR_EraseRootFromParent_Done,
     /* 1445985 */   // Label 20332: @1445985
     /* 1445985 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1446082), // Rule ID 6802 //
     /* 1445990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1446001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1446004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1446007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446040 */     // MIs[1] Operand 1
     /* 1446040 */     // No operand predicates
     /* 1446040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446044 */     // MIs[0] policy
     /* 1446044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1446059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446081 */     // GIR_Coverage, 6802,
     /* 1446081 */     GIR_EraseRootFromParent_Done,
     /* 1446082 */   // Label 20333: @1446082
     /* 1446082 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1446179), // Rule ID 6803 //
     /* 1446087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1446098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1446101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1446104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446137 */     // MIs[1] Operand 1
     /* 1446137 */     // No operand predicates
     /* 1446137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446141 */     // MIs[0] policy
     /* 1446141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446153 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1446156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446178 */     // GIR_Coverage, 6803,
     /* 1446178 */     GIR_EraseRootFromParent_Done,
     /* 1446179 */   // Label 20334: @1446179
     /* 1446179 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1446276), // Rule ID 6806 //
     /* 1446184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1446201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446234 */     // MIs[1] Operand 1
     /* 1446234 */     // No operand predicates
     /* 1446234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446238 */     // MIs[0] policy
     /* 1446238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1446253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446275 */     // GIR_Coverage, 6806,
     /* 1446275 */     GIR_EraseRootFromParent_Done,
     /* 1446276 */   // Label 20335: @1446276
     /* 1446276 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1446373), // Rule ID 6807 //
     /* 1446281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1446298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446331 */     // MIs[1] Operand 1
     /* 1446331 */     // No operand predicates
     /* 1446331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446335 */     // MIs[0] policy
     /* 1446335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446347 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1446350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446372 */     // GIR_Coverage, 6807,
     /* 1446372 */     GIR_EraseRootFromParent_Done,
     /* 1446373 */   // Label 20336: @1446373
     /* 1446373 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1446470), // Rule ID 6810 //
     /* 1446378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1446389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1446392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1446395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446428 */     // MIs[1] Operand 1
     /* 1446428 */     // No operand predicates
     /* 1446428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446432 */     // MIs[0] policy
     /* 1446432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1446447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446469 */     // GIR_Coverage, 6810,
     /* 1446469 */     GIR_EraseRootFromParent_Done,
     /* 1446470 */   // Label 20337: @1446470
     /* 1446470 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1446567), // Rule ID 6811 //
     /* 1446475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1446486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1446489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1446492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446525 */     // MIs[1] Operand 1
     /* 1446525 */     // No operand predicates
     /* 1446525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446529 */     // MIs[0] policy
     /* 1446529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1446544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446566 */     // GIR_Coverage, 6811,
     /* 1446566 */     GIR_EraseRootFromParent_Done,
     /* 1446567 */   // Label 20338: @1446567
     /* 1446567 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1446664), // Rule ID 6814 //
     /* 1446572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1446583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1446586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1446589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446622 */     // MIs[1] Operand 1
     /* 1446622 */     // No operand predicates
     /* 1446622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446626 */     // MIs[0] policy
     /* 1446626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446638 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1446641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446663 */     // GIR_Coverage, 6814,
     /* 1446663 */     GIR_EraseRootFromParent_Done,
     /* 1446664 */   // Label 20339: @1446664
     /* 1446664 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1446761), // Rule ID 6815 //
     /* 1446669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1446680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1446683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1446686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446719 */     // MIs[1] Operand 1
     /* 1446719 */     // No operand predicates
     /* 1446719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446723 */     // MIs[0] policy
     /* 1446723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446735 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1446738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446760 */     // GIR_Coverage, 6815,
     /* 1446760 */     GIR_EraseRootFromParent_Done,
     /* 1446761 */   // Label 20340: @1446761
     /* 1446761 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1446858), // Rule ID 6818 //
     /* 1446766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1446783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446816 */     // MIs[1] Operand 1
     /* 1446816 */     // No operand predicates
     /* 1446816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446820 */     // MIs[0] policy
     /* 1446820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446832 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1446835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446857 */     // GIR_Coverage, 6818,
     /* 1446857 */     GIR_EraseRootFromParent_Done,
     /* 1446858 */   // Label 20341: @1446858
     /* 1446858 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1446955), // Rule ID 6819 //
     /* 1446863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1446880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446913 */     // MIs[1] Operand 1
     /* 1446913 */     // No operand predicates
     /* 1446913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446917 */     // MIs[0] policy
     /* 1446917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446929 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1446932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446954 */     // GIR_Coverage, 6819,
     /* 1446954 */     GIR_EraseRootFromParent_Done,
     /* 1446955 */   // Label 20342: @1446955
     /* 1446955 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1447052), // Rule ID 6998 //
     /* 1446960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1446971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1446974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1446977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447010 */     // MIs[1] Operand 1
     /* 1447010 */     // No operand predicates
     /* 1447010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447014 */     // MIs[0] policy
     /* 1447014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447026 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1447029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447051 */     // GIR_Coverage, 6998,
     /* 1447051 */     GIR_EraseRootFromParent_Done,
     /* 1447052 */   // Label 20343: @1447052
     /* 1447052 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1447149), // Rule ID 6999 //
     /* 1447057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1447068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1447071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1447074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447107 */     // MIs[1] Operand 1
     /* 1447107 */     // No operand predicates
     /* 1447107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447111 */     // MIs[0] policy
     /* 1447111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447123 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1447126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447148 */     // GIR_Coverage, 6999,
     /* 1447148 */     GIR_EraseRootFromParent_Done,
     /* 1447149 */   // Label 20344: @1447149
     /* 1447149 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1447246), // Rule ID 7002 //
     /* 1447154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1447165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1447168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1447171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447204 */     // MIs[1] Operand 1
     /* 1447204 */     // No operand predicates
     /* 1447204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447208 */     // MIs[0] policy
     /* 1447208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447220 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1447223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447245 */     // GIR_Coverage, 7002,
     /* 1447245 */     GIR_EraseRootFromParent_Done,
     /* 1447246 */   // Label 20345: @1447246
     /* 1447246 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1447343), // Rule ID 7003 //
     /* 1447251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1447262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1447265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1447268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447301 */     // MIs[1] Operand 1
     /* 1447301 */     // No operand predicates
     /* 1447301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447305 */     // MIs[0] policy
     /* 1447305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447317 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1447320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447342 */     // GIR_Coverage, 7003,
     /* 1447342 */     GIR_EraseRootFromParent_Done,
     /* 1447343 */   // Label 20346: @1447343
     /* 1447343 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1447440), // Rule ID 7006 //
     /* 1447348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1447359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1447362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1447365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447398 */     // MIs[1] Operand 1
     /* 1447398 */     // No operand predicates
     /* 1447398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447402 */     // MIs[0] policy
     /* 1447402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1447417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447439 */     // GIR_Coverage, 7006,
     /* 1447439 */     GIR_EraseRootFromParent_Done,
     /* 1447440 */   // Label 20347: @1447440
     /* 1447440 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1447537), // Rule ID 7007 //
     /* 1447445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1447456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1447459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1447462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447495 */     // MIs[1] Operand 1
     /* 1447495 */     // No operand predicates
     /* 1447495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447499 */     // MIs[0] policy
     /* 1447499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447511 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1447514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447536 */     // GIR_Coverage, 7007,
     /* 1447536 */     GIR_EraseRootFromParent_Done,
     /* 1447537 */   // Label 20348: @1447537
     /* 1447537 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1447634), // Rule ID 7010 //
     /* 1447542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1447553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1447556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1447559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447592 */     // MIs[1] Operand 1
     /* 1447592 */     // No operand predicates
     /* 1447592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447596 */     // MIs[0] policy
     /* 1447596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1447611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447633 */     // GIR_Coverage, 7010,
     /* 1447633 */     GIR_EraseRootFromParent_Done,
     /* 1447634 */   // Label 20349: @1447634
     /* 1447634 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1447731), // Rule ID 7011 //
     /* 1447639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1447650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1447653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1447656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447689 */     // MIs[1] Operand 1
     /* 1447689 */     // No operand predicates
     /* 1447689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447693 */     // MIs[0] policy
     /* 1447693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447705 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1447708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447730 */     // GIR_Coverage, 7011,
     /* 1447730 */     GIR_EraseRootFromParent_Done,
     /* 1447731 */   // Label 20350: @1447731
     /* 1447731 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1447828), // Rule ID 7014 //
     /* 1447736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1447747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1447750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1447753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447786 */     // MIs[1] Operand 1
     /* 1447786 */     // No operand predicates
     /* 1447786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447790 */     // MIs[0] policy
     /* 1447790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1447805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447827 */     // GIR_Coverage, 7014,
     /* 1447827 */     GIR_EraseRootFromParent_Done,
     /* 1447828 */   // Label 20351: @1447828
     /* 1447828 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1447925), // Rule ID 7015 //
     /* 1447833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1447844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1447847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1447850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447883 */     // MIs[1] Operand 1
     /* 1447883 */     // No operand predicates
     /* 1447883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447887 */     // MIs[0] policy
     /* 1447887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1447902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447924 */     // GIR_Coverage, 7015,
     /* 1447924 */     GIR_EraseRootFromParent_Done,
     /* 1447925 */   // Label 20352: @1447925
     /* 1447925 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1448022), // Rule ID 7018 //
     /* 1447930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1447938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1447941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1447944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1447947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447980 */     // MIs[1] Operand 1
     /* 1447980 */     // No operand predicates
     /* 1447980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447984 */     // MIs[0] policy
     /* 1447984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1447999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448021 */     // GIR_Coverage, 7018,
     /* 1448021 */     GIR_EraseRootFromParent_Done,
     /* 1448022 */   // Label 20353: @1448022
     /* 1448022 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1448119), // Rule ID 7019 //
     /* 1448027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1448038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1448041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1448044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448077 */     // MIs[1] Operand 1
     /* 1448077 */     // No operand predicates
     /* 1448077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448081 */     // MIs[0] policy
     /* 1448081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1448096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448118 */     // GIR_Coverage, 7019,
     /* 1448118 */     GIR_EraseRootFromParent_Done,
     /* 1448119 */   // Label 20354: @1448119
     /* 1448119 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1448216), // Rule ID 7022 //
     /* 1448124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1448135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1448138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1448141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448174 */     // MIs[1] Operand 1
     /* 1448174 */     // No operand predicates
     /* 1448174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448178 */     // MIs[0] policy
     /* 1448178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448215 */     // GIR_Coverage, 7022,
     /* 1448215 */     GIR_EraseRootFromParent_Done,
     /* 1448216 */   // Label 20355: @1448216
     /* 1448216 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1448313), // Rule ID 7023 //
     /* 1448221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1448232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1448235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1448238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448271 */     // MIs[1] Operand 1
     /* 1448271 */     // No operand predicates
     /* 1448271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448275 */     // MIs[0] policy
     /* 1448275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448287 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448312 */     // GIR_Coverage, 7023,
     /* 1448312 */     GIR_EraseRootFromParent_Done,
     /* 1448313 */   // Label 20356: @1448313
     /* 1448313 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1448410), // Rule ID 7026 //
     /* 1448318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1448329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1448332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1448335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448368 */     // MIs[1] Operand 1
     /* 1448368 */     // No operand predicates
     /* 1448368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448372 */     // MIs[0] policy
     /* 1448372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448409 */     // GIR_Coverage, 7026,
     /* 1448409 */     GIR_EraseRootFromParent_Done,
     /* 1448410 */   // Label 20357: @1448410
     /* 1448410 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1448507), // Rule ID 7027 //
     /* 1448415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1448426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1448429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1448432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448465 */     // MIs[1] Operand 1
     /* 1448465 */     // No operand predicates
     /* 1448465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448469 */     // MIs[0] policy
     /* 1448469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448481 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448506 */     // GIR_Coverage, 7027,
     /* 1448506 */     GIR_EraseRootFromParent_Done,
     /* 1448507 */   // Label 20358: @1448507
     /* 1448507 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1448604), // Rule ID 7030 //
     /* 1448512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1448523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1448526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1448529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448562 */     // MIs[1] Operand 1
     /* 1448562 */     // No operand predicates
     /* 1448562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448566 */     // MIs[0] policy
     /* 1448566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448603 */     // GIR_Coverage, 7030,
     /* 1448603 */     GIR_EraseRootFromParent_Done,
     /* 1448604 */   // Label 20359: @1448604
     /* 1448604 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1448701), // Rule ID 7031 //
     /* 1448609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1448620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1448623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1448626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448659 */     // MIs[1] Operand 1
     /* 1448659 */     // No operand predicates
     /* 1448659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448663 */     // MIs[0] policy
     /* 1448663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448700 */     // GIR_Coverage, 7031,
     /* 1448700 */     GIR_EraseRootFromParent_Done,
     /* 1448701 */   // Label 20360: @1448701
     /* 1448701 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1448798), // Rule ID 7034 //
     /* 1448706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1448723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448756 */     // MIs[1] Operand 1
     /* 1448756 */     // No operand predicates
     /* 1448756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448760 */     // MIs[0] policy
     /* 1448760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448797 */     // GIR_Coverage, 7034,
     /* 1448797 */     GIR_EraseRootFromParent_Done,
     /* 1448798 */   // Label 20361: @1448798
     /* 1448798 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1448895), // Rule ID 7035 //
     /* 1448803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1448820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448853 */     // MIs[1] Operand 1
     /* 1448853 */     // No operand predicates
     /* 1448853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448857 */     // MIs[0] policy
     /* 1448857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1448872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448894 */     // GIR_Coverage, 7035,
     /* 1448894 */     GIR_EraseRootFromParent_Done,
     /* 1448895 */   // Label 20362: @1448895
     /* 1448895 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1448992), // Rule ID 7038 //
     /* 1448900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1448908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1448911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1448914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1448917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448950 */     // MIs[1] Operand 1
     /* 1448950 */     // No operand predicates
     /* 1448950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448954 */     // MIs[0] policy
     /* 1448954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448966 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1448969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448991 */     // GIR_Coverage, 7038,
     /* 1448991 */     GIR_EraseRootFromParent_Done,
     /* 1448992 */   // Label 20363: @1448992
     /* 1448992 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1449089), // Rule ID 7039 //
     /* 1448997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1449008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1449011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1449014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449047 */     // MIs[1] Operand 1
     /* 1449047 */     // No operand predicates
     /* 1449047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449051 */     // MIs[0] policy
     /* 1449051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449063 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1449066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449088 */     // GIR_Coverage, 7039,
     /* 1449088 */     GIR_EraseRootFromParent_Done,
     /* 1449089 */   // Label 20364: @1449089
     /* 1449089 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1449186), // Rule ID 7042 //
     /* 1449094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1449105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1449108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1449111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449144 */     // MIs[1] Operand 1
     /* 1449144 */     // No operand predicates
     /* 1449144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449148 */     // MIs[0] policy
     /* 1449148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1449163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449185 */     // GIR_Coverage, 7042,
     /* 1449185 */     GIR_EraseRootFromParent_Done,
     /* 1449186 */   // Label 20365: @1449186
     /* 1449186 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1449283), // Rule ID 7043 //
     /* 1449191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1449202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1449205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1449208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449241 */     // MIs[1] Operand 1
     /* 1449241 */     // No operand predicates
     /* 1449241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449245 */     // MIs[0] policy
     /* 1449245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449257 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1449260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449282 */     // GIR_Coverage, 7043,
     /* 1449282 */     GIR_EraseRootFromParent_Done,
     /* 1449283 */   // Label 20366: @1449283
     /* 1449283 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1449380), // Rule ID 7046 //
     /* 1449288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1449299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1449302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1449305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1449311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449338 */     // MIs[1] Operand 1
     /* 1449338 */     // No operand predicates
     /* 1449338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449342 */     // MIs[0] policy
     /* 1449342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449354 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1449357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449379 */     // GIR_Coverage, 7046,
     /* 1449379 */     GIR_EraseRootFromParent_Done,
     /* 1449380 */   // Label 20367: @1449380
     /* 1449380 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1449477), // Rule ID 7047 //
     /* 1449385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1449396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1449399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1449402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1449408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449435 */     // MIs[1] Operand 1
     /* 1449435 */     // No operand predicates
     /* 1449435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449439 */     // MIs[0] policy
     /* 1449439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449451 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1449454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449476 */     // GIR_Coverage, 7047,
     /* 1449476 */     GIR_EraseRootFromParent_Done,
     /* 1449477 */   // Label 20368: @1449477
     /* 1449477 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1449574), // Rule ID 7050 //
     /* 1449482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1449493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1449496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449532 */     // MIs[1] Operand 1
     /* 1449532 */     // No operand predicates
     /* 1449532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449536 */     // MIs[0] policy
     /* 1449536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1449551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449573 */     // GIR_Coverage, 7050,
     /* 1449573 */     GIR_EraseRootFromParent_Done,
     /* 1449574 */   // Label 20369: @1449574
     /* 1449574 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1449671), // Rule ID 7051 //
     /* 1449579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1449590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1449593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449629 */     // MIs[1] Operand 1
     /* 1449629 */     // No operand predicates
     /* 1449629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449633 */     // MIs[0] policy
     /* 1449633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449645 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1449648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449670 */     // GIR_Coverage, 7051,
     /* 1449670 */     GIR_EraseRootFromParent_Done,
     /* 1449671 */   // Label 20370: @1449671
     /* 1449671 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1449768), // Rule ID 7054 //
     /* 1449676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1449687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1449690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449726 */     // MIs[1] Operand 1
     /* 1449726 */     // No operand predicates
     /* 1449726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449730 */     // MIs[0] policy
     /* 1449730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1449745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449767 */     // GIR_Coverage, 7054,
     /* 1449767 */     GIR_EraseRootFromParent_Done,
     /* 1449768 */   // Label 20371: @1449768
     /* 1449768 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1449865), // Rule ID 7055 //
     /* 1449773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1449784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1449787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449823 */     // MIs[1] Operand 1
     /* 1449823 */     // No operand predicates
     /* 1449823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449827 */     // MIs[0] policy
     /* 1449827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449839 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1449842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449864 */     // GIR_Coverage, 7055,
     /* 1449864 */     GIR_EraseRootFromParent_Done,
     /* 1449865 */   // Label 20372: @1449865
     /* 1449865 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1449962), // Rule ID 7058 //
     /* 1449870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1449881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1449884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1449887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449920 */     // MIs[1] Operand 1
     /* 1449920 */     // No operand predicates
     /* 1449920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449924 */     // MIs[0] policy
     /* 1449924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1449939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449961 */     // GIR_Coverage, 7058,
     /* 1449961 */     GIR_EraseRootFromParent_Done,
     /* 1449962 */   // Label 20373: @1449962
     /* 1449962 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1450059), // Rule ID 7059 //
     /* 1449967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1449978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1449981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1449984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450017 */     // MIs[1] Operand 1
     /* 1450017 */     // No operand predicates
     /* 1450017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450021 */     // MIs[0] policy
     /* 1450021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450033 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1450036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450058 */     // GIR_Coverage, 7059,
     /* 1450058 */     GIR_EraseRootFromParent_Done,
     /* 1450059 */   // Label 20374: @1450059
     /* 1450059 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1450156), // Rule ID 7062 //
     /* 1450064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1450075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1450078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1450081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450114 */     // MIs[1] Operand 1
     /* 1450114 */     // No operand predicates
     /* 1450114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450118 */     // MIs[0] policy
     /* 1450118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1450133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450155 */     // GIR_Coverage, 7062,
     /* 1450155 */     GIR_EraseRootFromParent_Done,
     /* 1450156 */   // Label 20375: @1450156
     /* 1450156 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1450253), // Rule ID 7063 //
     /* 1450161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1450172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1450175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1450178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450211 */     // MIs[1] Operand 1
     /* 1450211 */     // No operand predicates
     /* 1450211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450215 */     // MIs[0] policy
     /* 1450215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1450230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450252 */     // GIR_Coverage, 7063,
     /* 1450252 */     GIR_EraseRootFromParent_Done,
     /* 1450253 */   // Label 20376: @1450253
     /* 1450253 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1450350), // Rule ID 7066 //
     /* 1450258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1450269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1450272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450308 */     // MIs[1] Operand 1
     /* 1450308 */     // No operand predicates
     /* 1450308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450312 */     // MIs[0] policy
     /* 1450312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1450327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450349 */     // GIR_Coverage, 7066,
     /* 1450349 */     GIR_EraseRootFromParent_Done,
     /* 1450350 */   // Label 20377: @1450350
     /* 1450350 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1450447), // Rule ID 7067 //
     /* 1450355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1450366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1450369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450405 */     // MIs[1] Operand 1
     /* 1450405 */     // No operand predicates
     /* 1450405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450409 */     // MIs[0] policy
     /* 1450409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1450424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450446 */     // GIR_Coverage, 7067,
     /* 1450446 */     GIR_EraseRootFromParent_Done,
     /* 1450447 */   // Label 20378: @1450447
     /* 1450447 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1450544), // Rule ID 7070 //
     /* 1450452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1450463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1450466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1450469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1450482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450502 */     // MIs[1] Operand 1
     /* 1450502 */     // No operand predicates
     /* 1450502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450506 */     // MIs[0] policy
     /* 1450506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1450521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450543 */     // GIR_Coverage, 7070,
     /* 1450543 */     GIR_EraseRootFromParent_Done,
     /* 1450544 */   // Label 20379: @1450544
     /* 1450544 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1450641), // Rule ID 7071 //
     /* 1450549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1450560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1450563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1450566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1450579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450599 */     // MIs[1] Operand 1
     /* 1450599 */     // No operand predicates
     /* 1450599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450603 */     // MIs[0] policy
     /* 1450603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1450618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450640 */     // GIR_Coverage, 7071,
     /* 1450640 */     GIR_EraseRootFromParent_Done,
     /* 1450641 */   // Label 20380: @1450641
     /* 1450641 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1450738), // Rule ID 7074 //
     /* 1450646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1450663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450696 */     // MIs[1] Operand 1
     /* 1450696 */     // No operand predicates
     /* 1450696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450700 */     // MIs[0] policy
     /* 1450700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1450715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450737 */     // GIR_Coverage, 7074,
     /* 1450737 */     GIR_EraseRootFromParent_Done,
     /* 1450738 */   // Label 20381: @1450738
     /* 1450738 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1450835), // Rule ID 7075 //
     /* 1450743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1450746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1450760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450793 */     // MIs[1] Operand 1
     /* 1450793 */     // No operand predicates
     /* 1450793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450797 */     // MIs[0] policy
     /* 1450797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1450812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450834 */     // GIR_Coverage, 7075,
     /* 1450834 */     GIR_EraseRootFromParent_Done,
     /* 1450835 */   // Label 20382: @1450835
     /* 1450835 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1450932), // Rule ID 7078 //
     /* 1450840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1450857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450890 */     // MIs[1] Operand 1
     /* 1450890 */     // No operand predicates
     /* 1450890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450894 */     // MIs[0] policy
     /* 1450894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1450909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450931 */     // GIR_Coverage, 7078,
     /* 1450931 */     GIR_EraseRootFromParent_Done,
     /* 1450932 */   // Label 20383: @1450932
     /* 1450932 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1451029), // Rule ID 7079 //
     /* 1450937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1450940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1450954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450987 */     // MIs[1] Operand 1
     /* 1450987 */     // No operand predicates
     /* 1450987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450991 */     // MIs[0] policy
     /* 1450991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451003 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451028 */     // GIR_Coverage, 7079,
     /* 1451028 */     GIR_EraseRootFromParent_Done,
     /* 1451029 */   // Label 20384: @1451029
     /* 1451029 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1451126), // Rule ID 7082 //
     /* 1451034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1451037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1451045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1451048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1451051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451084 */     // MIs[1] Operand 1
     /* 1451084 */     // No operand predicates
     /* 1451084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451088 */     // MIs[0] policy
     /* 1451088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451125 */     // GIR_Coverage, 7082,
     /* 1451125 */     GIR_EraseRootFromParent_Done,
     /* 1451126 */   // Label 20385: @1451126
     /* 1451126 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1451223), // Rule ID 7083 //
     /* 1451131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1451142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1451145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1451148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451181 */     // MIs[1] Operand 1
     /* 1451181 */     // No operand predicates
     /* 1451181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451185 */     // MIs[0] policy
     /* 1451185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451197 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451222 */     // GIR_Coverage, 7083,
     /* 1451222 */     GIR_EraseRootFromParent_Done,
     /* 1451223 */   // Label 20386: @1451223
     /* 1451223 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1451320), // Rule ID 7262 //
     /* 1451228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1451239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1451242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1451245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451278 */     // MIs[1] Operand 1
     /* 1451278 */     // No operand predicates
     /* 1451278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451282 */     // MIs[0] policy
     /* 1451282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1451297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451319 */     // GIR_Coverage, 7262,
     /* 1451319 */     GIR_EraseRootFromParent_Done,
     /* 1451320 */   // Label 20387: @1451320
     /* 1451320 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1451417), // Rule ID 7263 //
     /* 1451325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1451336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1451339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1451342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451375 */     // MIs[1] Operand 1
     /* 1451375 */     // No operand predicates
     /* 1451375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451379 */     // MIs[0] policy
     /* 1451379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451391 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1451394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451416 */     // GIR_Coverage, 7263,
     /* 1451416 */     GIR_EraseRootFromParent_Done,
     /* 1451417 */   // Label 20388: @1451417
     /* 1451417 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1451514), // Rule ID 7266 //
     /* 1451422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1451433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1451436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1451439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451472 */     // MIs[1] Operand 1
     /* 1451472 */     // No operand predicates
     /* 1451472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451476 */     // MIs[0] policy
     /* 1451476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451488 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1451491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451513 */     // GIR_Coverage, 7266,
     /* 1451513 */     GIR_EraseRootFromParent_Done,
     /* 1451514 */   // Label 20389: @1451514
     /* 1451514 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1451611), // Rule ID 7267 //
     /* 1451519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1451530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1451533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1451536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451569 */     // MIs[1] Operand 1
     /* 1451569 */     // No operand predicates
     /* 1451569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451573 */     // MIs[0] policy
     /* 1451573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451585 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1451588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451610 */     // GIR_Coverage, 7267,
     /* 1451610 */     GIR_EraseRootFromParent_Done,
     /* 1451611 */   // Label 20390: @1451611
     /* 1451611 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1451708), // Rule ID 7270 //
     /* 1451616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1451627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1451630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1451633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451666 */     // MIs[1] Operand 1
     /* 1451666 */     // No operand predicates
     /* 1451666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451670 */     // MIs[0] policy
     /* 1451670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451682 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1451685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451707 */     // GIR_Coverage, 7270,
     /* 1451707 */     GIR_EraseRootFromParent_Done,
     /* 1451708 */   // Label 20391: @1451708
     /* 1451708 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1451805), // Rule ID 7271 //
     /* 1451713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1451724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1451727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1451730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451763 */     // MIs[1] Operand 1
     /* 1451763 */     // No operand predicates
     /* 1451763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451767 */     // MIs[0] policy
     /* 1451767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451779 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1451782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451804 */     // GIR_Coverage, 7271,
     /* 1451804 */     GIR_EraseRootFromParent_Done,
     /* 1451805 */   // Label 20392: @1451805
     /* 1451805 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1451902), // Rule ID 7274 //
     /* 1451810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1451821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1451824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1451827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451860 */     // MIs[1] Operand 1
     /* 1451860 */     // No operand predicates
     /* 1451860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451864 */     // MIs[0] policy
     /* 1451864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451876 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1451879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451901 */     // GIR_Coverage, 7274,
     /* 1451901 */     GIR_EraseRootFromParent_Done,
     /* 1451902 */   // Label 20393: @1451902
     /* 1451902 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1451999), // Rule ID 7275 //
     /* 1451907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1451918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1451921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1451924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451957 */     // MIs[1] Operand 1
     /* 1451957 */     // No operand predicates
     /* 1451957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451961 */     // MIs[0] policy
     /* 1451961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451973 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1451976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451998 */     // GIR_Coverage, 7275,
     /* 1451998 */     GIR_EraseRootFromParent_Done,
     /* 1451999 */   // Label 20394: @1451999
     /* 1451999 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1452096), // Rule ID 7278 //
     /* 1452004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1452021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452054 */     // MIs[1] Operand 1
     /* 1452054 */     // No operand predicates
     /* 1452054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452058 */     // MIs[0] policy
     /* 1452058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1452073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452095 */     // GIR_Coverage, 7278,
     /* 1452095 */     GIR_EraseRootFromParent_Done,
     /* 1452096 */   // Label 20395: @1452096
     /* 1452096 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1452193), // Rule ID 7279 //
     /* 1452101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1452118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452151 */     // MIs[1] Operand 1
     /* 1452151 */     // No operand predicates
     /* 1452151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452155 */     // MIs[0] policy
     /* 1452155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452167 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1452170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452192 */     // GIR_Coverage, 7279,
     /* 1452192 */     GIR_EraseRootFromParent_Done,
     /* 1452193 */   // Label 20396: @1452193
     /* 1452193 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1452290), // Rule ID 7282 //
     /* 1452198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1452209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1452212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1452221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452248 */     // MIs[1] Operand 1
     /* 1452248 */     // No operand predicates
     /* 1452248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452252 */     // MIs[0] policy
     /* 1452252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1452267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452289 */     // GIR_Coverage, 7282,
     /* 1452289 */     GIR_EraseRootFromParent_Done,
     /* 1452290 */   // Label 20397: @1452290
     /* 1452290 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1452387), // Rule ID 7283 //
     /* 1452295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1452306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1452309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1452318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452345 */     // MIs[1] Operand 1
     /* 1452345 */     // No operand predicates
     /* 1452345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452349 */     // MIs[0] policy
     /* 1452349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452361 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1452364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452386 */     // GIR_Coverage, 7283,
     /* 1452386 */     GIR_EraseRootFromParent_Done,
     /* 1452387 */   // Label 20398: @1452387
     /* 1452387 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1452484), // Rule ID 7286 //
     /* 1452392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1452403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1452406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1452409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452442 */     // MIs[1] Operand 1
     /* 1452442 */     // No operand predicates
     /* 1452442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452446 */     // MIs[0] policy
     /* 1452446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452483 */     // GIR_Coverage, 7286,
     /* 1452483 */     GIR_EraseRootFromParent_Done,
     /* 1452484 */   // Label 20399: @1452484
     /* 1452484 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1452581), // Rule ID 7287 //
     /* 1452489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1452500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1452503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1452506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452539 */     // MIs[1] Operand 1
     /* 1452539 */     // No operand predicates
     /* 1452539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452543 */     // MIs[0] policy
     /* 1452543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452555 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452580 */     // GIR_Coverage, 7287,
     /* 1452580 */     GIR_EraseRootFromParent_Done,
     /* 1452581 */   // Label 20400: @1452581
     /* 1452581 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1452678), // Rule ID 7290 //
     /* 1452586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1452603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452636 */     // MIs[1] Operand 1
     /* 1452636 */     // No operand predicates
     /* 1452636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452640 */     // MIs[0] policy
     /* 1452640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452677 */     // GIR_Coverage, 7290,
     /* 1452677 */     GIR_EraseRootFromParent_Done,
     /* 1452678 */   // Label 20401: @1452678
     /* 1452678 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1452775), // Rule ID 7291 //
     /* 1452683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1452700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452733 */     // MIs[1] Operand 1
     /* 1452733 */     // No operand predicates
     /* 1452733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452737 */     // MIs[0] policy
     /* 1452737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452749 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452774 */     // GIR_Coverage, 7291,
     /* 1452774 */     GIR_EraseRootFromParent_Done,
     /* 1452775 */   // Label 20402: @1452775
     /* 1452775 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1452872), // Rule ID 7294 //
     /* 1452780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1452791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1452794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452830 */     // MIs[1] Operand 1
     /* 1452830 */     // No operand predicates
     /* 1452830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452834 */     // MIs[0] policy
     /* 1452834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452871 */     // GIR_Coverage, 7294,
     /* 1452871 */     GIR_EraseRootFromParent_Done,
     /* 1452872 */   // Label 20403: @1452872
     /* 1452872 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1452969), // Rule ID 7295 //
     /* 1452877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1452888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1452891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452927 */     // MIs[1] Operand 1
     /* 1452927 */     // No operand predicates
     /* 1452927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452931 */     // MIs[0] policy
     /* 1452931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1452946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452968 */     // GIR_Coverage, 7295,
     /* 1452968 */     GIR_EraseRootFromParent_Done,
     /* 1452969 */   // Label 20404: @1452969
     /* 1452969 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1453066), // Rule ID 7298 //
     /* 1452974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1452982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1452985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1452988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1452991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1452997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453024 */     // MIs[1] Operand 1
     /* 1453024 */     // No operand predicates
     /* 1453024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453028 */     // MIs[0] policy
     /* 1453028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1453043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453065 */     // GIR_Coverage, 7298,
     /* 1453065 */     GIR_EraseRootFromParent_Done,
     /* 1453066 */   // Label 20405: @1453066
     /* 1453066 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1453163), // Rule ID 7299 //
     /* 1453071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1453082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1453085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1453088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453121 */     // MIs[1] Operand 1
     /* 1453121 */     // No operand predicates
     /* 1453121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453125 */     // MIs[0] policy
     /* 1453125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453137 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1453140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453162 */     // GIR_Coverage, 7299,
     /* 1453162 */     GIR_EraseRootFromParent_Done,
     /* 1453163 */   // Label 20406: @1453163
     /* 1453163 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1453260), // Rule ID 7302 //
     /* 1453168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1453179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1453182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1453185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453218 */     // MIs[1] Operand 1
     /* 1453218 */     // No operand predicates
     /* 1453218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453222 */     // MIs[0] policy
     /* 1453222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453234 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1453237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453259 */     // GIR_Coverage, 7302,
     /* 1453259 */     GIR_EraseRootFromParent_Done,
     /* 1453260 */   // Label 20407: @1453260
     /* 1453260 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1453357), // Rule ID 7303 //
     /* 1453265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1453276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1453279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1453282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453315 */     // MIs[1] Operand 1
     /* 1453315 */     // No operand predicates
     /* 1453315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453319 */     // MIs[0] policy
     /* 1453319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1453334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453356 */     // GIR_Coverage, 7303,
     /* 1453356 */     GIR_EraseRootFromParent_Done,
     /* 1453357 */   // Label 20408: @1453357
     /* 1453357 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1453454), // Rule ID 7306 //
     /* 1453362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1453373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1453376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1453379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1453385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453412 */     // MIs[1] Operand 1
     /* 1453412 */     // No operand predicates
     /* 1453412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453416 */     // MIs[0] policy
     /* 1453416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1453431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453453 */     // GIR_Coverage, 7306,
     /* 1453453 */     GIR_EraseRootFromParent_Done,
     /* 1453454 */   // Label 20409: @1453454
     /* 1453454 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1453551), // Rule ID 7307 //
     /* 1453459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1453470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1453473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1453476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1453482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453509 */     // MIs[1] Operand 1
     /* 1453509 */     // No operand predicates
     /* 1453509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453513 */     // MIs[0] policy
     /* 1453513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453525 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1453528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453550 */     // GIR_Coverage, 7307,
     /* 1453550 */     GIR_EraseRootFromParent_Done,
     /* 1453551 */   // Label 20410: @1453551
     /* 1453551 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1453648), // Rule ID 7310 //
     /* 1453556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1453567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1453570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1453573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1453579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453606 */     // MIs[1] Operand 1
     /* 1453606 */     // No operand predicates
     /* 1453606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453610 */     // MIs[0] policy
     /* 1453610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453622 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1453625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453647 */     // GIR_Coverage, 7310,
     /* 1453647 */     GIR_EraseRootFromParent_Done,
     /* 1453648 */   // Label 20411: @1453648
     /* 1453648 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1453745), // Rule ID 7311 //
     /* 1453653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1453664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1453667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1453670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1453676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453703 */     // MIs[1] Operand 1
     /* 1453703 */     // No operand predicates
     /* 1453703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453707 */     // MIs[0] policy
     /* 1453707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1453722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453744 */     // GIR_Coverage, 7311,
     /* 1453744 */     GIR_EraseRootFromParent_Done,
     /* 1453745 */   // Label 20412: @1453745
     /* 1453745 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1453842), // Rule ID 7314 //
     /* 1453750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1453761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1453764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1453767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453800 */     // MIs[1] Operand 1
     /* 1453800 */     // No operand predicates
     /* 1453800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453804 */     // MIs[0] policy
     /* 1453804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1453819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453841 */     // GIR_Coverage, 7314,
     /* 1453841 */     GIR_EraseRootFromParent_Done,
     /* 1453842 */   // Label 20413: @1453842
     /* 1453842 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1453939), // Rule ID 7315 //
     /* 1453847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1453858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1453861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1453864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453897 */     // MIs[1] Operand 1
     /* 1453897 */     // No operand predicates
     /* 1453897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453901 */     // MIs[0] policy
     /* 1453901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1453916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453938 */     // GIR_Coverage, 7315,
     /* 1453938 */     GIR_EraseRootFromParent_Done,
     /* 1453939 */   // Label 20414: @1453939
     /* 1453939 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1454036), // Rule ID 7318 //
     /* 1453944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1453955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1453958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1453961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453994 */     // MIs[1] Operand 1
     /* 1453994 */     // No operand predicates
     /* 1453994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453998 */     // MIs[0] policy
     /* 1453998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1454013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454035 */     // GIR_Coverage, 7318,
     /* 1454035 */     GIR_EraseRootFromParent_Done,
     /* 1454036 */   // Label 20415: @1454036
     /* 1454036 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1454133), // Rule ID 7319 //
     /* 1454041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1454052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1454055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1454058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1454064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1454071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454091 */     // MIs[1] Operand 1
     /* 1454091 */     // No operand predicates
     /* 1454091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454095 */     // MIs[0] policy
     /* 1454095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454107 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1454110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454132 */     // GIR_Coverage, 7319,
     /* 1454132 */     GIR_EraseRootFromParent_Done,
     /* 1454133 */   // Label 20416: @1454133
     /* 1454133 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1454230), // Rule ID 7322 //
     /* 1454138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1454149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1454152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1454155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1454161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454188 */     // MIs[1] Operand 1
     /* 1454188 */     // No operand predicates
     /* 1454188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454192 */     // MIs[0] policy
     /* 1454192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454204 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1454207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454229 */     // GIR_Coverage, 7322,
     /* 1454229 */     GIR_EraseRootFromParent_Done,
     /* 1454230 */   // Label 20417: @1454230
     /* 1454230 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1454327), // Rule ID 7323 //
     /* 1454235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1454246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1454249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1454252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1454258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454285 */     // MIs[1] Operand 1
     /* 1454285 */     // No operand predicates
     /* 1454285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454289 */     // MIs[0] policy
     /* 1454289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454301 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1454304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454326 */     // GIR_Coverage, 7323,
     /* 1454326 */     GIR_EraseRootFromParent_Done,
     /* 1454327 */   // Label 20418: @1454327
     /* 1454327 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1454424), // Rule ID 7326 //
     /* 1454332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1454343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1454346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1454349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454382 */     // MIs[1] Operand 1
     /* 1454382 */     // No operand predicates
     /* 1454382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454386 */     // MIs[0] policy
     /* 1454386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1454401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454423 */     // GIR_Coverage, 7326,
     /* 1454423 */     GIR_EraseRootFromParent_Done,
     /* 1454424 */   // Label 20419: @1454424
     /* 1454424 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1454521), // Rule ID 7327 //
     /* 1454429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1454440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1454443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1454446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454479 */     // MIs[1] Operand 1
     /* 1454479 */     // No operand predicates
     /* 1454479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454483 */     // MIs[0] policy
     /* 1454483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1454498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454520 */     // GIR_Coverage, 7327,
     /* 1454520 */     GIR_EraseRootFromParent_Done,
     /* 1454521 */   // Label 20420: @1454521
     /* 1454521 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1454618), // Rule ID 7330 //
     /* 1454526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1454537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1454540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1454543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1454556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454576 */     // MIs[1] Operand 1
     /* 1454576 */     // No operand predicates
     /* 1454576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454580 */     // MIs[0] policy
     /* 1454580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1454595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454617 */     // GIR_Coverage, 7330,
     /* 1454617 */     GIR_EraseRootFromParent_Done,
     /* 1454618 */   // Label 20421: @1454618
     /* 1454618 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1454715), // Rule ID 7331 //
     /* 1454623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1454634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1454637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1454640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1454653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454673 */     // MIs[1] Operand 1
     /* 1454673 */     // No operand predicates
     /* 1454673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454677 */     // MIs[0] policy
     /* 1454677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1454692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454714 */     // GIR_Coverage, 7331,
     /* 1454714 */     GIR_EraseRootFromParent_Done,
     /* 1454715 */   // Label 20422: @1454715
     /* 1454715 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1454812), // Rule ID 7334 //
     /* 1454720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1454731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1454734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1454737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1454743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454770 */     // MIs[1] Operand 1
     /* 1454770 */     // No operand predicates
     /* 1454770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454774 */     // MIs[0] policy
     /* 1454774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1454789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454811 */     // GIR_Coverage, 7334,
     /* 1454811 */     GIR_EraseRootFromParent_Done,
     /* 1454812 */   // Label 20423: @1454812
     /* 1454812 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1454909), // Rule ID 7335 //
     /* 1454817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1454828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1454831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1454834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1454840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1454847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1454855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454867 */     // MIs[1] Operand 1
     /* 1454867 */     // No operand predicates
     /* 1454867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454871 */     // MIs[0] policy
     /* 1454871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454883 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1454886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454908 */     // GIR_Coverage, 7335,
     /* 1454908 */     GIR_EraseRootFromParent_Done,
     /* 1454909 */   // Label 20424: @1454909
     /* 1454909 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1455006), // Rule ID 7338 //
     /* 1454914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1454917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1454925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1454928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1454931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454964 */     // MIs[1] Operand 1
     /* 1454964 */     // No operand predicates
     /* 1454964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454968 */     // MIs[0] policy
     /* 1454968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1454983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455005 */     // GIR_Coverage, 7338,
     /* 1455005 */     GIR_EraseRootFromParent_Done,
     /* 1455006 */   // Label 20425: @1455006
     /* 1455006 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1455103), // Rule ID 7339 //
     /* 1455011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1455022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1455025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1455028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455061 */     // MIs[1] Operand 1
     /* 1455061 */     // No operand predicates
     /* 1455061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455065 */     // MIs[0] policy
     /* 1455065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455102 */     // GIR_Coverage, 7339,
     /* 1455102 */     GIR_EraseRootFromParent_Done,
     /* 1455103 */   // Label 20426: @1455103
     /* 1455103 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1455200), // Rule ID 7342 //
     /* 1455108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1455119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1455122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1455125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455158 */     // MIs[1] Operand 1
     /* 1455158 */     // No operand predicates
     /* 1455158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455162 */     // MIs[0] policy
     /* 1455162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455199 */     // GIR_Coverage, 7342,
     /* 1455199 */     GIR_EraseRootFromParent_Done,
     /* 1455200 */   // Label 20427: @1455200
     /* 1455200 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1455297), // Rule ID 7343 //
     /* 1455205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1455216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1455219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1455222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455255 */     // MIs[1] Operand 1
     /* 1455255 */     // No operand predicates
     /* 1455255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455259 */     // MIs[0] policy
     /* 1455259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455296 */     // GIR_Coverage, 7343,
     /* 1455296 */     GIR_EraseRootFromParent_Done,
     /* 1455297 */   // Label 20428: @1455297
     /* 1455297 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1455394), // Rule ID 7346 //
     /* 1455302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1455313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1455316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1455319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455352 */     // MIs[1] Operand 1
     /* 1455352 */     // No operand predicates
     /* 1455352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455356 */     // MIs[0] policy
     /* 1455356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455393 */     // GIR_Coverage, 7346,
     /* 1455393 */     GIR_EraseRootFromParent_Done,
     /* 1455394 */   // Label 20429: @1455394
     /* 1455394 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1455491), // Rule ID 7347 //
     /* 1455399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1455410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1455413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1455416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455449 */     // MIs[1] Operand 1
     /* 1455449 */     // No operand predicates
     /* 1455449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455453 */     // MIs[0] policy
     /* 1455453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455465 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455490 */     // GIR_Coverage, 7347,
     /* 1455490 */     GIR_EraseRootFromParent_Done,
     /* 1455491 */   // Label 20430: @1455491
     /* 1455491 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1455588), // Rule ID 7558 //
     /* 1455496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1455507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1455510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1455513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455546 */     // MIs[1] Operand 1
     /* 1455546 */     // No operand predicates
     /* 1455546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455550 */     // MIs[0] policy
     /* 1455550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455562 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1455565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455587 */     // GIR_Coverage, 7558,
     /* 1455587 */     GIR_EraseRootFromParent_Done,
     /* 1455588 */   // Label 20431: @1455588
     /* 1455588 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1455685), // Rule ID 7559 //
     /* 1455593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1455604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1455607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1455610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455643 */     // MIs[1] Operand 1
     /* 1455643 */     // No operand predicates
     /* 1455643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455647 */     // MIs[0] policy
     /* 1455647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455659 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1455662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455684 */     // GIR_Coverage, 7559,
     /* 1455684 */     GIR_EraseRootFromParent_Done,
     /* 1455685 */   // Label 20432: @1455685
     /* 1455685 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1455782), // Rule ID 7562 //
     /* 1455690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1455701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1455704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1455707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455740 */     // MIs[1] Operand 1
     /* 1455740 */     // No operand predicates
     /* 1455740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455744 */     // MIs[0] policy
     /* 1455744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455756 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1455759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455781 */     // GIR_Coverage, 7562,
     /* 1455781 */     GIR_EraseRootFromParent_Done,
     /* 1455782 */   // Label 20433: @1455782
     /* 1455782 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1455879), // Rule ID 7563 //
     /* 1455787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1455798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1455801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1455804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455837 */     // MIs[1] Operand 1
     /* 1455837 */     // No operand predicates
     /* 1455837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455841 */     // MIs[0] policy
     /* 1455841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1455856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455878 */     // GIR_Coverage, 7563,
     /* 1455878 */     GIR_EraseRootFromParent_Done,
     /* 1455879 */   // Label 20434: @1455879
     /* 1455879 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1455976), // Rule ID 7566 //
     /* 1455884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1455895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1455898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455934 */     // MIs[1] Operand 1
     /* 1455934 */     // No operand predicates
     /* 1455934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455938 */     // MIs[0] policy
     /* 1455938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1455953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455975 */     // GIR_Coverage, 7566,
     /* 1455975 */     GIR_EraseRootFromParent_Done,
     /* 1455976 */   // Label 20435: @1455976
     /* 1455976 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1456073), // Rule ID 7567 //
     /* 1455981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1455989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1455992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1455995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1455998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456031 */     // MIs[1] Operand 1
     /* 1456031 */     // No operand predicates
     /* 1456031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456035 */     // MIs[0] policy
     /* 1456035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456047 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1456050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456072 */     // GIR_Coverage, 7567,
     /* 1456072 */     GIR_EraseRootFromParent_Done,
     /* 1456073 */   // Label 20436: @1456073
     /* 1456073 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1456170), // Rule ID 7570 //
     /* 1456078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1456089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1456092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456128 */     // MIs[1] Operand 1
     /* 1456128 */     // No operand predicates
     /* 1456128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456132 */     // MIs[0] policy
     /* 1456132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1456147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456169 */     // GIR_Coverage, 7570,
     /* 1456169 */     GIR_EraseRootFromParent_Done,
     /* 1456170 */   // Label 20437: @1456170
     /* 1456170 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1456267), // Rule ID 7571 //
     /* 1456175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1456186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1456189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456225 */     // MIs[1] Operand 1
     /* 1456225 */     // No operand predicates
     /* 1456225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456229 */     // MIs[0] policy
     /* 1456229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456241 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1456244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456266 */     // GIR_Coverage, 7571,
     /* 1456266 */     GIR_EraseRootFromParent_Done,
     /* 1456267 */   // Label 20438: @1456267
     /* 1456267 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1456364), // Rule ID 7574 //
     /* 1456272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1456283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1456286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456322 */     // MIs[1] Operand 1
     /* 1456322 */     // No operand predicates
     /* 1456322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456326 */     // MIs[0] policy
     /* 1456326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456338 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1456341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456363 */     // GIR_Coverage, 7574,
     /* 1456363 */     GIR_EraseRootFromParent_Done,
     /* 1456364 */   // Label 20439: @1456364
     /* 1456364 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1456461), // Rule ID 7575 //
     /* 1456369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1456380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1456383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456419 */     // MIs[1] Operand 1
     /* 1456419 */     // No operand predicates
     /* 1456419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456423 */     // MIs[0] policy
     /* 1456423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456435 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1456438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456460 */     // GIR_Coverage, 7575,
     /* 1456460 */     GIR_EraseRootFromParent_Done,
     /* 1456461 */   // Label 20440: @1456461
     /* 1456461 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1456558), // Rule ID 7578 //
     /* 1456466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456516 */     // MIs[1] Operand 1
     /* 1456516 */     // No operand predicates
     /* 1456516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456520 */     // MIs[0] policy
     /* 1456520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1456535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456557 */     // GIR_Coverage, 7578,
     /* 1456557 */     GIR_EraseRootFromParent_Done,
     /* 1456558 */   // Label 20441: @1456558
     /* 1456558 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1456655), // Rule ID 7579 //
     /* 1456563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1456574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1456577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456613 */     // MIs[1] Operand 1
     /* 1456613 */     // No operand predicates
     /* 1456613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456617 */     // MIs[0] policy
     /* 1456617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456629 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1456632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1456651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456654 */     // GIR_Coverage, 7579,
     /* 1456654 */     GIR_EraseRootFromParent_Done,
     /* 1456655 */   // Label 20442: @1456655
     /* 1456655 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1456752), // Rule ID 7582 //
     /* 1456660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1456671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1456674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1456677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1456683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456710 */     // MIs[1] Operand 1
     /* 1456710 */     // No operand predicates
     /* 1456710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456714 */     // MIs[0] policy
     /* 1456714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456726 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1456729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456751 */     // GIR_Coverage, 7582,
     /* 1456751 */     GIR_EraseRootFromParent_Done,
     /* 1456752 */   // Label 20443: @1456752
     /* 1456752 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1456849), // Rule ID 7583 //
     /* 1456757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1456768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1456771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1456774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1456780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456807 */     // MIs[1] Operand 1
     /* 1456807 */     // No operand predicates
     /* 1456807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456811 */     // MIs[0] policy
     /* 1456811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456823 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1456826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456848 */     // GIR_Coverage, 7583,
     /* 1456848 */     GIR_EraseRootFromParent_Done,
     /* 1456849 */   // Label 20444: @1456849
     /* 1456849 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1456946), // Rule ID 7586 //
     /* 1456854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1456865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1456868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1456871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456904 */     // MIs[1] Operand 1
     /* 1456904 */     // No operand predicates
     /* 1456904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456908 */     // MIs[0] policy
     /* 1456908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1456923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456945 */     // GIR_Coverage, 7586,
     /* 1456945 */     GIR_EraseRootFromParent_Done,
     /* 1456946 */   // Label 20445: @1456946
     /* 1456946 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1457043), // Rule ID 7587 //
     /* 1456951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1456959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1456962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1456965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1456968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457001 */     // MIs[1] Operand 1
     /* 1457001 */     // No operand predicates
     /* 1457001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457005 */     // MIs[0] policy
     /* 1457005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457017 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1457020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457042 */     // GIR_Coverage, 7587,
     /* 1457042 */     GIR_EraseRootFromParent_Done,
     /* 1457043 */   // Label 20446: @1457043
     /* 1457043 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1457140), // Rule ID 7590 //
     /* 1457048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1457059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1457062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457098 */     // MIs[1] Operand 1
     /* 1457098 */     // No operand predicates
     /* 1457098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457102 */     // MIs[0] policy
     /* 1457102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1457117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457139 */     // GIR_Coverage, 7590,
     /* 1457139 */     GIR_EraseRootFromParent_Done,
     /* 1457140 */   // Label 20447: @1457140
     /* 1457140 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1457237), // Rule ID 7591 //
     /* 1457145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1457156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1457159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1457162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457195 */     // MIs[1] Operand 1
     /* 1457195 */     // No operand predicates
     /* 1457195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457199 */     // MIs[0] policy
     /* 1457199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457211 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1457214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457236 */     // GIR_Coverage, 7591,
     /* 1457236 */     GIR_EraseRootFromParent_Done,
     /* 1457237 */   // Label 20448: @1457237
     /* 1457237 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1457334), // Rule ID 7594 //
     /* 1457242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1457253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1457256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457292 */     // MIs[1] Operand 1
     /* 1457292 */     // No operand predicates
     /* 1457292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457296 */     // MIs[0] policy
     /* 1457296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1457311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457333 */     // GIR_Coverage, 7594,
     /* 1457333 */     GIR_EraseRootFromParent_Done,
     /* 1457334 */   // Label 20449: @1457334
     /* 1457334 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1457431), // Rule ID 7595 //
     /* 1457339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1457350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1457353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1457356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457389 */     // MIs[1] Operand 1
     /* 1457389 */     // No operand predicates
     /* 1457389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457393 */     // MIs[0] policy
     /* 1457393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457405 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1457408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457430 */     // GIR_Coverage, 7595,
     /* 1457430 */     GIR_EraseRootFromParent_Done,
     /* 1457431 */   // Label 20450: @1457431
     /* 1457431 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1457528), // Rule ID 7598 //
     /* 1457436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1457447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1457450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457486 */     // MIs[1] Operand 1
     /* 1457486 */     // No operand predicates
     /* 1457486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457490 */     // MIs[0] policy
     /* 1457490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1457505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457527 */     // GIR_Coverage, 7598,
     /* 1457527 */     GIR_EraseRootFromParent_Done,
     /* 1457528 */   // Label 20451: @1457528
     /* 1457528 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1457625), // Rule ID 7599 //
     /* 1457533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1457544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1457547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457583 */     // MIs[1] Operand 1
     /* 1457583 */     // No operand predicates
     /* 1457583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457587 */     // MIs[0] policy
     /* 1457587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1457602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457624 */     // GIR_Coverage, 7599,
     /* 1457624 */     GIR_EraseRootFromParent_Done,
     /* 1457625 */   // Label 20452: @1457625
     /* 1457625 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1457722), // Rule ID 7602 //
     /* 1457630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1457633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1457641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1457644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1457647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457680 */     // MIs[1] Operand 1
     /* 1457680 */     // No operand predicates
     /* 1457680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457684 */     // MIs[0] policy
     /* 1457684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1457699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457721 */     // GIR_Coverage, 7602,
     /* 1457721 */     GIR_EraseRootFromParent_Done,
     /* 1457722 */   // Label 20453: @1457722
     /* 1457722 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1457819), // Rule ID 7603 //
     /* 1457727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1457730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1457738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1457741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1457744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457777 */     // MIs[1] Operand 1
     /* 1457777 */     // No operand predicates
     /* 1457777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457781 */     // MIs[0] policy
     /* 1457781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457793 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1457796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457818 */     // GIR_Coverage, 7603,
     /* 1457818 */     GIR_EraseRootFromParent_Done,
     /* 1457819 */   // Label 20454: @1457819
     /* 1457819 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1457916), // Rule ID 7606 //
     /* 1457824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1457827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1457835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1457838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457874 */     // MIs[1] Operand 1
     /* 1457874 */     // No operand predicates
     /* 1457874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457878 */     // MIs[0] policy
     /* 1457878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457890 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1457893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457915 */     // GIR_Coverage, 7606,
     /* 1457915 */     GIR_EraseRootFromParent_Done,
     /* 1457916 */   // Label 20455: @1457916
     /* 1457916 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1458013), // Rule ID 7607 //
     /* 1457921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1457924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1457932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1457935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457971 */     // MIs[1] Operand 1
     /* 1457971 */     // No operand predicates
     /* 1457971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457975 */     // MIs[0] policy
     /* 1457975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457987 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1457990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458012 */     // GIR_Coverage, 7607,
     /* 1458012 */     GIR_EraseRootFromParent_Done,
     /* 1458013 */   // Label 20456: @1458013
     /* 1458013 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1458110), // Rule ID 7610 //
     /* 1458018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1458021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1458029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1458032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1458035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458068 */     // MIs[1] Operand 1
     /* 1458068 */     // No operand predicates
     /* 1458068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458072 */     // MIs[0] policy
     /* 1458072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458109 */     // GIR_Coverage, 7610,
     /* 1458109 */     GIR_EraseRootFromParent_Done,
     /* 1458110 */   // Label 20457: @1458110
     /* 1458110 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1458207), // Rule ID 7611 //
     /* 1458115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1458118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1458126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1458129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1458132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458165 */     // MIs[1] Operand 1
     /* 1458165 */     // No operand predicates
     /* 1458165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458169 */     // MIs[0] policy
     /* 1458169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458206 */     // GIR_Coverage, 7611,
     /* 1458206 */     GIR_EraseRootFromParent_Done,
     /* 1458207 */   // Label 20458: @1458207
     /* 1458207 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1458304), // Rule ID 7614 //
     /* 1458212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1458215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1458223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1458226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458262 */     // MIs[1] Operand 1
     /* 1458262 */     // No operand predicates
     /* 1458262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458266 */     // MIs[0] policy
     /* 1458266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458303 */     // GIR_Coverage, 7614,
     /* 1458303 */     GIR_EraseRootFromParent_Done,
     /* 1458304 */   // Label 20459: @1458304
     /* 1458304 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1458401), // Rule ID 7615 //
     /* 1458309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1458312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1458320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1458323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1458326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458359 */     // MIs[1] Operand 1
     /* 1458359 */     // No operand predicates
     /* 1458359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458363 */     // MIs[0] policy
     /* 1458363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458375 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458400 */     // GIR_Coverage, 7615,
     /* 1458400 */     GIR_EraseRootFromParent_Done,
     /* 1458401 */   // Label 20460: @1458401
     /* 1458401 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1458498), // Rule ID 7738 //
     /* 1458406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458456 */     // MIs[1] Operand 1
     /* 1458456 */     // No operand predicates
     /* 1458456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458460 */     // MIs[0] policy
     /* 1458460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458472 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1458475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458497 */     // GIR_Coverage, 7738,
     /* 1458497 */     GIR_EraseRootFromParent_Done,
     /* 1458498 */   // Label 20461: @1458498
     /* 1458498 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1458595), // Rule ID 7739 //
     /* 1458503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1458514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1458517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1458520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458553 */     // MIs[1] Operand 1
     /* 1458553 */     // No operand predicates
     /* 1458553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458557 */     // MIs[0] policy
     /* 1458557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458569 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1458572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458594 */     // GIR_Coverage, 7739,
     /* 1458594 */     GIR_EraseRootFromParent_Done,
     /* 1458595 */   // Label 20462: @1458595
     /* 1458595 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1458692), // Rule ID 7742 //
     /* 1458600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458650 */     // MIs[1] Operand 1
     /* 1458650 */     // No operand predicates
     /* 1458650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458654 */     // MIs[0] policy
     /* 1458654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1458669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458691 */     // GIR_Coverage, 7742,
     /* 1458691 */     GIR_EraseRootFromParent_Done,
     /* 1458692 */   // Label 20463: @1458692
     /* 1458692 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1458789), // Rule ID 7743 //
     /* 1458697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458747 */     // MIs[1] Operand 1
     /* 1458747 */     // No operand predicates
     /* 1458747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458751 */     // MIs[0] policy
     /* 1458751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458763 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1458766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458788 */     // GIR_Coverage, 7743,
     /* 1458788 */     GIR_EraseRootFromParent_Done,
     /* 1458789 */   // Label 20464: @1458789
     /* 1458789 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1458886), // Rule ID 7746 //
     /* 1458794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458844 */     // MIs[1] Operand 1
     /* 1458844 */     // No operand predicates
     /* 1458844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458848 */     // MIs[0] policy
     /* 1458848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1458863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458885 */     // GIR_Coverage, 7746,
     /* 1458885 */     GIR_EraseRootFromParent_Done,
     /* 1458886 */   // Label 20465: @1458886
     /* 1458886 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1458983), // Rule ID 7747 //
     /* 1458891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458941 */     // MIs[1] Operand 1
     /* 1458941 */     // No operand predicates
     /* 1458941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458945 */     // MIs[0] policy
     /* 1458945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458957 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1458960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458982 */     // GIR_Coverage, 7747,
     /* 1458982 */     GIR_EraseRootFromParent_Done,
     /* 1458983 */   // Label 20466: @1458983
     /* 1458983 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1459080), // Rule ID 7750 //
     /* 1458988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1458996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1459002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459038 */     // MIs[1] Operand 1
     /* 1459038 */     // No operand predicates
     /* 1459038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459042 */     // MIs[0] policy
     /* 1459042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1459057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459079 */     // GIR_Coverage, 7750,
     /* 1459079 */     GIR_EraseRootFromParent_Done,
     /* 1459080 */   // Label 20467: @1459080
     /* 1459080 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1459177), // Rule ID 7751 //
     /* 1459085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1459096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1459099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459135 */     // MIs[1] Operand 1
     /* 1459135 */     // No operand predicates
     /* 1459135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459139 */     // MIs[0] policy
     /* 1459139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459151 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1459154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459176 */     // GIR_Coverage, 7751,
     /* 1459176 */     GIR_EraseRootFromParent_Done,
     /* 1459177 */   // Label 20468: @1459177
     /* 1459177 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1459274), // Rule ID 7754 //
     /* 1459182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459232 */     // MIs[1] Operand 1
     /* 1459232 */     // No operand predicates
     /* 1459232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459236 */     // MIs[0] policy
     /* 1459236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1459251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459273 */     // GIR_Coverage, 7754,
     /* 1459273 */     GIR_EraseRootFromParent_Done,
     /* 1459274 */   // Label 20469: @1459274
     /* 1459274 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1459371), // Rule ID 7755 //
     /* 1459279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459329 */     // MIs[1] Operand 1
     /* 1459329 */     // No operand predicates
     /* 1459329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459333 */     // MIs[0] policy
     /* 1459333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1459348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459370 */     // GIR_Coverage, 7755,
     /* 1459370 */     GIR_EraseRootFromParent_Done,
     /* 1459371 */   // Label 20470: @1459371
     /* 1459371 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1459468), // Rule ID 7758 //
     /* 1459376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459426 */     // MIs[1] Operand 1
     /* 1459426 */     // No operand predicates
     /* 1459426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459430 */     // MIs[0] policy
     /* 1459430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1459445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459467 */     // GIR_Coverage, 7758,
     /* 1459467 */     GIR_EraseRootFromParent_Done,
     /* 1459468 */   // Label 20471: @1459468
     /* 1459468 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1459565), // Rule ID 7759 //
     /* 1459473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459523 */     // MIs[1] Operand 1
     /* 1459523 */     // No operand predicates
     /* 1459523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459527 */     // MIs[0] policy
     /* 1459527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459539 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1459542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459564 */     // GIR_Coverage, 7759,
     /* 1459564 */     GIR_EraseRootFromParent_Done,
     /* 1459565 */   // Label 20472: @1459565
     /* 1459565 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1459662), // Rule ID 7762 //
     /* 1459570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459620 */     // MIs[1] Operand 1
     /* 1459620 */     // No operand predicates
     /* 1459620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459624 */     // MIs[0] policy
     /* 1459624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1459639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459661 */     // GIR_Coverage, 7762,
     /* 1459661 */     GIR_EraseRootFromParent_Done,
     /* 1459662 */   // Label 20473: @1459662
     /* 1459662 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1459759), // Rule ID 7763 //
     /* 1459667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459717 */     // MIs[1] Operand 1
     /* 1459717 */     // No operand predicates
     /* 1459717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459721 */     // MIs[0] policy
     /* 1459721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459733 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1459736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459758 */     // GIR_Coverage, 7763,
     /* 1459758 */     GIR_EraseRootFromParent_Done,
     /* 1459759 */   // Label 20474: @1459759
     /* 1459759 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1459856), // Rule ID 7766 //
     /* 1459764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459814 */     // MIs[1] Operand 1
     /* 1459814 */     // No operand predicates
     /* 1459814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459818 */     // MIs[0] policy
     /* 1459818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1459833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459855 */     // GIR_Coverage, 7766,
     /* 1459855 */     GIR_EraseRootFromParent_Done,
     /* 1459856 */   // Label 20475: @1459856
     /* 1459856 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1459953), // Rule ID 7767 //
     /* 1459861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459911 */     // MIs[1] Operand 1
     /* 1459911 */     // No operand predicates
     /* 1459911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459915 */     // MIs[0] policy
     /* 1459915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1459930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459952 */     // GIR_Coverage, 7767,
     /* 1459952 */     GIR_EraseRootFromParent_Done,
     /* 1459953 */   // Label 20476: @1459953
     /* 1459953 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1460050), // Rule ID 7770 //
     /* 1459958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1459966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460008 */     // MIs[1] Operand 1
     /* 1460008 */     // No operand predicates
     /* 1460008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460012 */     // MIs[0] policy
     /* 1460012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1460027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460049 */     // GIR_Coverage, 7770,
     /* 1460049 */     GIR_EraseRootFromParent_Done,
     /* 1460050 */   // Label 20477: @1460050
     /* 1460050 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1460147), // Rule ID 7771 //
     /* 1460055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1460066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1460069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460105 */     // MIs[1] Operand 1
     /* 1460105 */     // No operand predicates
     /* 1460105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460109 */     // MIs[0] policy
     /* 1460109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460121 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1460124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460146 */     // GIR_Coverage, 7771,
     /* 1460146 */     GIR_EraseRootFromParent_Done,
     /* 1460147 */   // Label 20478: @1460147
     /* 1460147 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1460244), // Rule ID 7774 //
     /* 1460152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460202 */     // MIs[1] Operand 1
     /* 1460202 */     // No operand predicates
     /* 1460202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460206 */     // MIs[0] policy
     /* 1460206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1460221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460243 */     // GIR_Coverage, 7774,
     /* 1460243 */     GIR_EraseRootFromParent_Done,
     /* 1460244 */   // Label 20479: @1460244
     /* 1460244 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1460341), // Rule ID 7775 //
     /* 1460249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1460260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1460263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460299 */     // MIs[1] Operand 1
     /* 1460299 */     // No operand predicates
     /* 1460299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460303 */     // MIs[0] policy
     /* 1460303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1460318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460340 */     // GIR_Coverage, 7775,
     /* 1460340 */     GIR_EraseRootFromParent_Done,
     /* 1460341 */   // Label 20480: @1460341
     /* 1460341 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1460438), // Rule ID 7778 //
     /* 1460346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460396 */     // MIs[1] Operand 1
     /* 1460396 */     // No operand predicates
     /* 1460396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460400 */     // MIs[0] policy
     /* 1460400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460412 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1460415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460437 */     // GIR_Coverage, 7778,
     /* 1460437 */     GIR_EraseRootFromParent_Done,
     /* 1460438 */   // Label 20481: @1460438
     /* 1460438 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1460535), // Rule ID 7779 //
     /* 1460443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1460454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1460457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460493 */     // MIs[1] Operand 1
     /* 1460493 */     // No operand predicates
     /* 1460493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460497 */     // MIs[0] policy
     /* 1460497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1460512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460534 */     // GIR_Coverage, 7779,
     /* 1460534 */     GIR_EraseRootFromParent_Done,
     /* 1460535 */   // Label 20482: @1460535
     /* 1460535 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1460632), // Rule ID 7782 //
     /* 1460540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460590 */     // MIs[1] Operand 1
     /* 1460590 */     // No operand predicates
     /* 1460590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460594 */     // MIs[0] policy
     /* 1460594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1460609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460631 */     // GIR_Coverage, 7782,
     /* 1460631 */     GIR_EraseRootFromParent_Done,
     /* 1460632 */   // Label 20483: @1460632
     /* 1460632 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1460729), // Rule ID 7783 //
     /* 1460637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1460648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1460651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1460654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460687 */     // MIs[1] Operand 1
     /* 1460687 */     // No operand predicates
     /* 1460687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460691 */     // MIs[0] policy
     /* 1460691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460703 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1460706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460728 */     // GIR_Coverage, 7783,
     /* 1460728 */     GIR_EraseRootFromParent_Done,
     /* 1460729 */   // Label 20484: @1460729
     /* 1460729 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1460826), // Rule ID 7786 //
     /* 1460734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460784 */     // MIs[1] Operand 1
     /* 1460784 */     // No operand predicates
     /* 1460784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460788 */     // MIs[0] policy
     /* 1460788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1460803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460825 */     // GIR_Coverage, 7786,
     /* 1460825 */     GIR_EraseRootFromParent_Done,
     /* 1460826 */   // Label 20485: @1460826
     /* 1460826 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1460923), // Rule ID 7787 //
     /* 1460831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460881 */     // MIs[1] Operand 1
     /* 1460881 */     // No operand predicates
     /* 1460881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460885 */     // MIs[0] policy
     /* 1460885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460897 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1460900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460922 */     // GIR_Coverage, 7787,
     /* 1460922 */     GIR_EraseRootFromParent_Done,
     /* 1460923 */   // Label 20486: @1460923
     /* 1460923 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1461020), // Rule ID 7790 //
     /* 1460928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460978 */     // MIs[1] Operand 1
     /* 1460978 */     // No operand predicates
     /* 1460978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460982 */     // MIs[0] policy
     /* 1460982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460994 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1460997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461019 */     // GIR_Coverage, 7790,
     /* 1461019 */     GIR_EraseRootFromParent_Done,
     /* 1461020 */   // Label 20487: @1461020
     /* 1461020 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1461117), // Rule ID 7791 //
     /* 1461025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1461028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1461036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1461039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461075 */     // MIs[1] Operand 1
     /* 1461075 */     // No operand predicates
     /* 1461075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461079 */     // MIs[0] policy
     /* 1461079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461116 */     // GIR_Coverage, 7791,
     /* 1461116 */     GIR_EraseRootFromParent_Done,
     /* 1461117 */   // Label 20488: @1461117
     /* 1461117 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1461214), // Rule ID 7794 //
     /* 1461122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1461125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1461133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1461136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461172 */     // MIs[1] Operand 1
     /* 1461172 */     // No operand predicates
     /* 1461172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461176 */     // MIs[0] policy
     /* 1461176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461188 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461213 */     // GIR_Coverage, 7794,
     /* 1461213 */     GIR_EraseRootFromParent_Done,
     /* 1461214 */   // Label 20489: @1461214
     /* 1461214 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1461311), // Rule ID 7795 //
     /* 1461219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1461222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1461230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1461233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461269 */     // MIs[1] Operand 1
     /* 1461269 */     // No operand predicates
     /* 1461269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461273 */     // MIs[0] policy
     /* 1461273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461285 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1461307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461310 */     // GIR_Coverage, 7795,
     /* 1461310 */     GIR_EraseRootFromParent_Done,
     /* 1461311 */   // Label 20490: @1461311
     /* 1461311 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1461411), // Rule ID 14224 //
     /* 1461316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1461333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461366 */     // MIs[1] Operand 1
     /* 1461366 */     // No operand predicates
     /* 1461366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461370 */     // MIs[0] policy
     /* 1461370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1461385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461410 */     // GIR_Coverage, 14224,
     /* 1461410 */     GIR_EraseRootFromParent_Done,
     /* 1461411 */   // Label 20491: @1461411
     /* 1461411 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1461511), // Rule ID 14225 //
     /* 1461416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1461433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461466 */     // MIs[1] Operand 1
     /* 1461466 */     // No operand predicates
     /* 1461466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461470 */     // MIs[0] policy
     /* 1461470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461482 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1461485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461510 */     // GIR_Coverage, 14225,
     /* 1461510 */     GIR_EraseRootFromParent_Done,
     /* 1461511 */   // Label 20492: @1461511
     /* 1461511 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1461611), // Rule ID 14228 //
     /* 1461516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1461533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461566 */     // MIs[1] Operand 1
     /* 1461566 */     // No operand predicates
     /* 1461566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461570 */     // MIs[0] policy
     /* 1461570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1461585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461610 */     // GIR_Coverage, 14228,
     /* 1461610 */     GIR_EraseRootFromParent_Done,
     /* 1461611 */   // Label 20493: @1461611
     /* 1461611 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1461711), // Rule ID 14229 //
     /* 1461616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1461633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461666 */     // MIs[1] Operand 1
     /* 1461666 */     // No operand predicates
     /* 1461666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461670 */     // MIs[0] policy
     /* 1461670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1461685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461710 */     // GIR_Coverage, 14229,
     /* 1461710 */     GIR_EraseRootFromParent_Done,
     /* 1461711 */   // Label 20494: @1461711
     /* 1461711 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1461811), // Rule ID 14232 //
     /* 1461716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1461733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461766 */     // MIs[1] Operand 1
     /* 1461766 */     // No operand predicates
     /* 1461766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461770 */     // MIs[0] policy
     /* 1461770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1461785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461810 */     // GIR_Coverage, 14232,
     /* 1461810 */     GIR_EraseRootFromParent_Done,
     /* 1461811 */   // Label 20495: @1461811
     /* 1461811 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1461911), // Rule ID 14233 //
     /* 1461816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1461833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461866 */     // MIs[1] Operand 1
     /* 1461866 */     // No operand predicates
     /* 1461866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461870 */     // MIs[0] policy
     /* 1461870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1461885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461910 */     // GIR_Coverage, 14233,
     /* 1461910 */     GIR_EraseRootFromParent_Done,
     /* 1461911 */   // Label 20496: @1461911
     /* 1461911 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1462011), // Rule ID 14236 //
     /* 1461916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461966 */     // MIs[1] Operand 1
     /* 1461966 */     // No operand predicates
     /* 1461966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461970 */     // MIs[0] policy
     /* 1461970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1461985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462010 */     // GIR_Coverage, 14236,
     /* 1462010 */     GIR_EraseRootFromParent_Done,
     /* 1462011 */   // Label 20497: @1462011
     /* 1462011 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1462111), // Rule ID 14237 //
     /* 1462016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1462033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462066 */     // MIs[1] Operand 1
     /* 1462066 */     // No operand predicates
     /* 1462066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462070 */     // MIs[0] policy
     /* 1462070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462082 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1462085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462110 */     // GIR_Coverage, 14237,
     /* 1462110 */     GIR_EraseRootFromParent_Done,
     /* 1462111 */   // Label 20498: @1462111
     /* 1462111 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1462211), // Rule ID 14240 //
     /* 1462116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1462133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462166 */     // MIs[1] Operand 1
     /* 1462166 */     // No operand predicates
     /* 1462166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462170 */     // MIs[0] policy
     /* 1462170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462182 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1462185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462210 */     // GIR_Coverage, 14240,
     /* 1462210 */     GIR_EraseRootFromParent_Done,
     /* 1462211 */   // Label 20499: @1462211
     /* 1462211 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1462311), // Rule ID 14241 //
     /* 1462216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1462233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462266 */     // MIs[1] Operand 1
     /* 1462266 */     // No operand predicates
     /* 1462266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462270 */     // MIs[0] policy
     /* 1462270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1462285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462310 */     // GIR_Coverage, 14241,
     /* 1462310 */     GIR_EraseRootFromParent_Done,
     /* 1462311 */   // Label 20500: @1462311
     /* 1462311 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1462411), // Rule ID 14244 //
     /* 1462316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462366 */     // MIs[1] Operand 1
     /* 1462366 */     // No operand predicates
     /* 1462366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462370 */     // MIs[0] policy
     /* 1462370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1462385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462410 */     // GIR_Coverage, 14244,
     /* 1462410 */     GIR_EraseRootFromParent_Done,
     /* 1462411 */   // Label 20501: @1462411
     /* 1462411 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1462511), // Rule ID 14245 //
     /* 1462416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462466 */     // MIs[1] Operand 1
     /* 1462466 */     // No operand predicates
     /* 1462466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462470 */     // MIs[0] policy
     /* 1462470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462482 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1462485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462510 */     // GIR_Coverage, 14245,
     /* 1462510 */     GIR_EraseRootFromParent_Done,
     /* 1462511 */   // Label 20502: @1462511
     /* 1462511 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1462611), // Rule ID 14248 //
     /* 1462516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1462533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462566 */     // MIs[1] Operand 1
     /* 1462566 */     // No operand predicates
     /* 1462566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462570 */     // MIs[0] policy
     /* 1462570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1462585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462610 */     // GIR_Coverage, 14248,
     /* 1462610 */     GIR_EraseRootFromParent_Done,
     /* 1462611 */   // Label 20503: @1462611
     /* 1462611 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1462711), // Rule ID 14249 //
     /* 1462616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1462633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462666 */     // MIs[1] Operand 1
     /* 1462666 */     // No operand predicates
     /* 1462666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462670 */     // MIs[0] policy
     /* 1462670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1462685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462710 */     // GIR_Coverage, 14249,
     /* 1462710 */     GIR_EraseRootFromParent_Done,
     /* 1462711 */   // Label 20504: @1462711
     /* 1462711 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1462811), // Rule ID 14252 //
     /* 1462716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462766 */     // MIs[1] Operand 1
     /* 1462766 */     // No operand predicates
     /* 1462766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462770 */     // MIs[0] policy
     /* 1462770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1462785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462810 */     // GIR_Coverage, 14252,
     /* 1462810 */     GIR_EraseRootFromParent_Done,
     /* 1462811 */   // Label 20505: @1462811
     /* 1462811 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1462911), // Rule ID 14253 //
     /* 1462816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462866 */     // MIs[1] Operand 1
     /* 1462866 */     // No operand predicates
     /* 1462866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462870 */     // MIs[0] policy
     /* 1462870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1462885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462910 */     // GIR_Coverage, 14253,
     /* 1462910 */     GIR_EraseRootFromParent_Done,
     /* 1462911 */   // Label 20506: @1462911
     /* 1462911 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1463011), // Rule ID 14256 //
     /* 1462916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1462924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462966 */     // MIs[1] Operand 1
     /* 1462966 */     // No operand predicates
     /* 1462966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462970 */     // MIs[0] policy
     /* 1462970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462982 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1462985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463010 */     // GIR_Coverage, 14256,
     /* 1463010 */     GIR_EraseRootFromParent_Done,
     /* 1463011 */   // Label 20507: @1463011
     /* 1463011 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1463111), // Rule ID 14257 //
     /* 1463016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1463033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463066 */     // MIs[1] Operand 1
     /* 1463066 */     // No operand predicates
     /* 1463066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463070 */     // MIs[0] policy
     /* 1463070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1463085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463110 */     // GIR_Coverage, 14257,
     /* 1463110 */     GIR_EraseRootFromParent_Done,
     /* 1463111 */   // Label 20508: @1463111
     /* 1463111 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1463211), // Rule ID 14260 //
     /* 1463116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1463119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1463127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1463130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463166 */     // MIs[1] Operand 1
     /* 1463166 */     // No operand predicates
     /* 1463166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463170 */     // MIs[0] policy
     /* 1463170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1463185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463210 */     // GIR_Coverage, 14260,
     /* 1463210 */     GIR_EraseRootFromParent_Done,
     /* 1463211 */   // Label 20509: @1463211
     /* 1463211 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1463311), // Rule ID 14261 //
     /* 1463216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1463219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1463227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1463230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463266 */     // MIs[1] Operand 1
     /* 1463266 */     // No operand predicates
     /* 1463266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463270 */     // MIs[0] policy
     /* 1463270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1463285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463310 */     // GIR_Coverage, 14261,
     /* 1463310 */     GIR_EraseRootFromParent_Done,
     /* 1463311 */   // Label 20510: @1463311
     /* 1463311 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1463411), // Rule ID 14264 //
     /* 1463316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1463327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1463330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1463333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463366 */     // MIs[1] Operand 1
     /* 1463366 */     // No operand predicates
     /* 1463366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463370 */     // MIs[0] policy
     /* 1463370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1463385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463410 */     // GIR_Coverage, 14264,
     /* 1463410 */     GIR_EraseRootFromParent_Done,
     /* 1463411 */   // Label 20511: @1463411
     /* 1463411 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1463511), // Rule ID 14265 //
     /* 1463416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1463427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1463430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1463433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463466 */     // MIs[1] Operand 1
     /* 1463466 */     // No operand predicates
     /* 1463466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463470 */     // MIs[0] policy
     /* 1463470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1463485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463510 */     // GIR_Coverage, 14265,
     /* 1463510 */     GIR_EraseRootFromParent_Done,
     /* 1463511 */   // Label 20512: @1463511
     /* 1463511 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1463611), // Rule ID 14268 //
     /* 1463516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1463527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1463530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1463533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1463539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463566 */     // MIs[1] Operand 1
     /* 1463566 */     // No operand predicates
     /* 1463566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463570 */     // MIs[0] policy
     /* 1463570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463582 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1463585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463610 */     // GIR_Coverage, 14268,
     /* 1463610 */     GIR_EraseRootFromParent_Done,
     /* 1463611 */   // Label 20513: @1463611
     /* 1463611 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1463711), // Rule ID 14269 //
     /* 1463616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1463627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1463630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1463633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1463639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463666 */     // MIs[1] Operand 1
     /* 1463666 */     // No operand predicates
     /* 1463666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463670 */     // MIs[0] policy
     /* 1463670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463682 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1463685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463710 */     // GIR_Coverage, 14269,
     /* 1463710 */     GIR_EraseRootFromParent_Done,
     /* 1463711 */   // Label 20514: @1463711
     /* 1463711 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1463811), // Rule ID 14272 //
     /* 1463716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1463727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1463730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1463733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1463739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463766 */     // MIs[1] Operand 1
     /* 1463766 */     // No operand predicates
     /* 1463766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463770 */     // MIs[0] policy
     /* 1463770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463782 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1463785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463810 */     // GIR_Coverage, 14272,
     /* 1463810 */     GIR_EraseRootFromParent_Done,
     /* 1463811 */   // Label 20515: @1463811
     /* 1463811 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1463911), // Rule ID 14273 //
     /* 1463816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1463827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1463830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1463833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1463839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463866 */     // MIs[1] Operand 1
     /* 1463866 */     // No operand predicates
     /* 1463866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463870 */     // MIs[0] policy
     /* 1463870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463882 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1463885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463910 */     // GIR_Coverage, 14273,
     /* 1463910 */     GIR_EraseRootFromParent_Done,
     /* 1463911 */   // Label 20516: @1463911
     /* 1463911 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1464011), // Rule ID 14276 //
     /* 1463916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1463927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1463930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1463933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463966 */     // MIs[1] Operand 1
     /* 1463966 */     // No operand predicates
     /* 1463966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463970 */     // MIs[0] policy
     /* 1463970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1463985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464010 */     // GIR_Coverage, 14276,
     /* 1464010 */     GIR_EraseRootFromParent_Done,
     /* 1464011 */   // Label 20517: @1464011
     /* 1464011 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1464111), // Rule ID 14277 //
     /* 1464016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1464027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1464030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1464033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464066 */     // MIs[1] Operand 1
     /* 1464066 */     // No operand predicates
     /* 1464066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464070 */     // MIs[0] policy
     /* 1464070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1464085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464110 */     // GIR_Coverage, 14277,
     /* 1464110 */     GIR_EraseRootFromParent_Done,
     /* 1464111 */   // Label 20518: @1464111
     /* 1464111 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1464211), // Rule ID 14280 //
     /* 1464116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1464127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1464130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1464133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464166 */     // MIs[1] Operand 1
     /* 1464166 */     // No operand predicates
     /* 1464166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464170 */     // MIs[0] policy
     /* 1464170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1464185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464210 */     // GIR_Coverage, 14280,
     /* 1464210 */     GIR_EraseRootFromParent_Done,
     /* 1464211 */   // Label 20519: @1464211
     /* 1464211 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1464311), // Rule ID 14281 //
     /* 1464216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1464227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1464230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1464233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464266 */     // MIs[1] Operand 1
     /* 1464266 */     // No operand predicates
     /* 1464266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464270 */     // MIs[0] policy
     /* 1464270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464282 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1464285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464310 */     // GIR_Coverage, 14281,
     /* 1464310 */     GIR_EraseRootFromParent_Done,
     /* 1464311 */   // Label 20520: @1464311
     /* 1464311 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1464411), // Rule ID 14284 //
     /* 1464316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1464327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1464330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1464333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1464339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464366 */     // MIs[1] Operand 1
     /* 1464366 */     // No operand predicates
     /* 1464366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464370 */     // MIs[0] policy
     /* 1464370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464382 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1464385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464410 */     // GIR_Coverage, 14284,
     /* 1464410 */     GIR_EraseRootFromParent_Done,
     /* 1464411 */   // Label 20521: @1464411
     /* 1464411 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1464511), // Rule ID 14285 //
     /* 1464416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1464427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1464430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1464433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1464439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464466 */     // MIs[1] Operand 1
     /* 1464466 */     // No operand predicates
     /* 1464466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464470 */     // MIs[0] policy
     /* 1464470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1464485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464510 */     // GIR_Coverage, 14285,
     /* 1464510 */     GIR_EraseRootFromParent_Done,
     /* 1464511 */   // Label 20522: @1464511
     /* 1464511 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1464611), // Rule ID 14288 //
     /* 1464516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1464533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464566 */     // MIs[1] Operand 1
     /* 1464566 */     // No operand predicates
     /* 1464566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464570 */     // MIs[0] policy
     /* 1464570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1464585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464610 */     // GIR_Coverage, 14288,
     /* 1464610 */     GIR_EraseRootFromParent_Done,
     /* 1464611 */   // Label 20523: @1464611
     /* 1464611 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1464711), // Rule ID 14289 //
     /* 1464616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1464633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464666 */     // MIs[1] Operand 1
     /* 1464666 */     // No operand predicates
     /* 1464666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464670 */     // MIs[0] policy
     /* 1464670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1464685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464710 */     // GIR_Coverage, 14289,
     /* 1464710 */     GIR_EraseRootFromParent_Done,
     /* 1464711 */   // Label 20524: @1464711
     /* 1464711 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1464811), // Rule ID 14292 //
     /* 1464716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1464733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464766 */     // MIs[1] Operand 1
     /* 1464766 */     // No operand predicates
     /* 1464766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464770 */     // MIs[0] policy
     /* 1464770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1464785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464810 */     // GIR_Coverage, 14292,
     /* 1464810 */     GIR_EraseRootFromParent_Done,
     /* 1464811 */   // Label 20525: @1464811
     /* 1464811 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1464911), // Rule ID 14293 //
     /* 1464816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1464833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464866 */     // MIs[1] Operand 1
     /* 1464866 */     // No operand predicates
     /* 1464866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464870 */     // MIs[0] policy
     /* 1464870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1464885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464910 */     // GIR_Coverage, 14293,
     /* 1464910 */     GIR_EraseRootFromParent_Done,
     /* 1464911 */   // Label 20526: @1464911
     /* 1464911 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1465011), // Rule ID 14296 //
     /* 1464916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1464927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1464930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1464933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464966 */     // MIs[1] Operand 1
     /* 1464966 */     // No operand predicates
     /* 1464966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464970 */     // MIs[0] policy
     /* 1464970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1464985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465010 */     // GIR_Coverage, 14296,
     /* 1465010 */     GIR_EraseRootFromParent_Done,
     /* 1465011 */   // Label 20527: @1465011
     /* 1465011 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1465111), // Rule ID 14297 //
     /* 1465016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1465027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1465030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1465033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465066 */     // MIs[1] Operand 1
     /* 1465066 */     // No operand predicates
     /* 1465066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465070 */     // MIs[0] policy
     /* 1465070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1465085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465110 */     // GIR_Coverage, 14297,
     /* 1465110 */     GIR_EraseRootFromParent_Done,
     /* 1465111 */   // Label 20528: @1465111
     /* 1465111 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1465211), // Rule ID 14300 //
     /* 1465116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1465127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1465130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1465133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465166 */     // MIs[1] Operand 1
     /* 1465166 */     // No operand predicates
     /* 1465166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465170 */     // MIs[0] policy
     /* 1465170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465210 */     // GIR_Coverage, 14300,
     /* 1465210 */     GIR_EraseRootFromParent_Done,
     /* 1465211 */   // Label 20529: @1465211
     /* 1465211 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1465311), // Rule ID 14301 //
     /* 1465216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1465227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1465230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1465233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465266 */     // MIs[1] Operand 1
     /* 1465266 */     // No operand predicates
     /* 1465266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465270 */     // MIs[0] policy
     /* 1465270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465310 */     // GIR_Coverage, 14301,
     /* 1465310 */     GIR_EraseRootFromParent_Done,
     /* 1465311 */   // Label 20530: @1465311
     /* 1465311 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1465411), // Rule ID 14304 //
     /* 1465316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1465327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1465330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1465333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465366 */     // MIs[1] Operand 1
     /* 1465366 */     // No operand predicates
     /* 1465366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465370 */     // MIs[0] policy
     /* 1465370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465410 */     // GIR_Coverage, 14304,
     /* 1465410 */     GIR_EraseRootFromParent_Done,
     /* 1465411 */   // Label 20531: @1465411
     /* 1465411 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1465511), // Rule ID 14305 //
     /* 1465416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1465427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1465430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1465433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465466 */     // MIs[1] Operand 1
     /* 1465466 */     // No operand predicates
     /* 1465466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465470 */     // MIs[0] policy
     /* 1465470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465510 */     // GIR_Coverage, 14305,
     /* 1465510 */     GIR_EraseRootFromParent_Done,
     /* 1465511 */   // Label 20532: @1465511
     /* 1465511 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1465611), // Rule ID 14308 //
     /* 1465516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1465527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1465530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1465533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465566 */     // MIs[1] Operand 1
     /* 1465566 */     // No operand predicates
     /* 1465566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465570 */     // MIs[0] policy
     /* 1465570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1465585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465610 */     // GIR_Coverage, 14308,
     /* 1465610 */     GIR_EraseRootFromParent_Done,
     /* 1465611 */   // Label 20533: @1465611
     /* 1465611 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1465711), // Rule ID 14309 //
     /* 1465616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1465627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1465630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1465633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465666 */     // MIs[1] Operand 1
     /* 1465666 */     // No operand predicates
     /* 1465666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465670 */     // MIs[0] policy
     /* 1465670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1465685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465710 */     // GIR_Coverage, 14309,
     /* 1465710 */     GIR_EraseRootFromParent_Done,
     /* 1465711 */   // Label 20534: @1465711
     /* 1465711 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1465811), // Rule ID 14488 //
     /* 1465716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1465727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1465730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1465733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465766 */     // MIs[1] Operand 1
     /* 1465766 */     // No operand predicates
     /* 1465766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465770 */     // MIs[0] policy
     /* 1465770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465782 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1465785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465810 */     // GIR_Coverage, 14488,
     /* 1465810 */     GIR_EraseRootFromParent_Done,
     /* 1465811 */   // Label 20535: @1465811
     /* 1465811 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1465911), // Rule ID 14489 //
     /* 1465816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1465827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1465830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1465833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465866 */     // MIs[1] Operand 1
     /* 1465866 */     // No operand predicates
     /* 1465866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465870 */     // MIs[0] policy
     /* 1465870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1465885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465910 */     // GIR_Coverage, 14489,
     /* 1465910 */     GIR_EraseRootFromParent_Done,
     /* 1465911 */   // Label 20536: @1465911
     /* 1465911 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1466011), // Rule ID 14492 //
     /* 1465916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1465927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1465930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1465933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465966 */     // MIs[1] Operand 1
     /* 1465966 */     // No operand predicates
     /* 1465966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465970 */     // MIs[0] policy
     /* 1465970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465982 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1465985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466010 */     // GIR_Coverage, 14492,
     /* 1466010 */     GIR_EraseRootFromParent_Done,
     /* 1466011 */   // Label 20537: @1466011
     /* 1466011 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1466111), // Rule ID 14493 //
     /* 1466016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1466027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1466030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1466033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466066 */     // MIs[1] Operand 1
     /* 1466066 */     // No operand predicates
     /* 1466066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466070 */     // MIs[0] policy
     /* 1466070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1466085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466110 */     // GIR_Coverage, 14493,
     /* 1466110 */     GIR_EraseRootFromParent_Done,
     /* 1466111 */   // Label 20538: @1466111
     /* 1466111 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1466211), // Rule ID 14496 //
     /* 1466116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1466127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1466130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1466133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466166 */     // MIs[1] Operand 1
     /* 1466166 */     // No operand predicates
     /* 1466166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466170 */     // MIs[0] policy
     /* 1466170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466182 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466210 */     // GIR_Coverage, 14496,
     /* 1466210 */     GIR_EraseRootFromParent_Done,
     /* 1466211 */   // Label 20539: @1466211
     /* 1466211 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1466311), // Rule ID 14497 //
     /* 1466216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1466227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1466230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1466233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466266 */     // MIs[1] Operand 1
     /* 1466266 */     // No operand predicates
     /* 1466266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466270 */     // MIs[0] policy
     /* 1466270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466282 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466310 */     // GIR_Coverage, 14497,
     /* 1466310 */     GIR_EraseRootFromParent_Done,
     /* 1466311 */   // Label 20540: @1466311
     /* 1466311 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1466411), // Rule ID 14500 //
     /* 1466316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1466327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1466330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466366 */     // MIs[1] Operand 1
     /* 1466366 */     // No operand predicates
     /* 1466366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466370 */     // MIs[0] policy
     /* 1466370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466382 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1466385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466410 */     // GIR_Coverage, 14500,
     /* 1466410 */     GIR_EraseRootFromParent_Done,
     /* 1466411 */   // Label 20541: @1466411
     /* 1466411 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1466511), // Rule ID 14501 //
     /* 1466416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1466427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1466430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466466 */     // MIs[1] Operand 1
     /* 1466466 */     // No operand predicates
     /* 1466466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466470 */     // MIs[0] policy
     /* 1466470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1466485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466510 */     // GIR_Coverage, 14501,
     /* 1466510 */     GIR_EraseRootFromParent_Done,
     /* 1466511 */   // Label 20542: @1466511
     /* 1466511 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1466611), // Rule ID 14504 //
     /* 1466516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1466527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1466530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466566 */     // MIs[1] Operand 1
     /* 1466566 */     // No operand predicates
     /* 1466566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466570 */     // MIs[0] policy
     /* 1466570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466610 */     // GIR_Coverage, 14504,
     /* 1466610 */     GIR_EraseRootFromParent_Done,
     /* 1466611 */   // Label 20543: @1466611
     /* 1466611 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1466711), // Rule ID 14505 //
     /* 1466616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1466627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1466630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466666 */     // MIs[1] Operand 1
     /* 1466666 */     // No operand predicates
     /* 1466666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466670 */     // MIs[0] policy
     /* 1466670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466682 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466710 */     // GIR_Coverage, 14505,
     /* 1466710 */     GIR_EraseRootFromParent_Done,
     /* 1466711 */   // Label 20544: @1466711
     /* 1466711 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1466811), // Rule ID 14508 //
     /* 1466716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1466733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466766 */     // MIs[1] Operand 1
     /* 1466766 */     // No operand predicates
     /* 1466766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466770 */     // MIs[0] policy
     /* 1466770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466810 */     // GIR_Coverage, 14508,
     /* 1466810 */     GIR_EraseRootFromParent_Done,
     /* 1466811 */   // Label 20545: @1466811
     /* 1466811 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1466911), // Rule ID 14509 //
     /* 1466816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1466833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466866 */     // MIs[1] Operand 1
     /* 1466866 */     // No operand predicates
     /* 1466866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466870 */     // MIs[0] policy
     /* 1466870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1466885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466910 */     // GIR_Coverage, 14509,
     /* 1466910 */     GIR_EraseRootFromParent_Done,
     /* 1466911 */   // Label 20546: @1466911
     /* 1466911 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1467011), // Rule ID 14512 //
     /* 1466916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1466924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1466927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1466930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1466933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466966 */     // MIs[1] Operand 1
     /* 1466966 */     // No operand predicates
     /* 1466966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466970 */     // MIs[0] policy
     /* 1466970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1466985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467010 */     // GIR_Coverage, 14512,
     /* 1467010 */     GIR_EraseRootFromParent_Done,
     /* 1467011 */   // Label 20547: @1467011
     /* 1467011 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1467111), // Rule ID 14513 //
     /* 1467016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1467027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1467030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1467033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467066 */     // MIs[1] Operand 1
     /* 1467066 */     // No operand predicates
     /* 1467066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467070 */     // MIs[0] policy
     /* 1467070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467110 */     // GIR_Coverage, 14513,
     /* 1467110 */     GIR_EraseRootFromParent_Done,
     /* 1467111 */   // Label 20548: @1467111
     /* 1467111 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1467211), // Rule ID 14516 //
     /* 1467116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1467127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1467130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1467133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467166 */     // MIs[1] Operand 1
     /* 1467166 */     // No operand predicates
     /* 1467166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467170 */     // MIs[0] policy
     /* 1467170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467210 */     // GIR_Coverage, 14516,
     /* 1467210 */     GIR_EraseRootFromParent_Done,
     /* 1467211 */   // Label 20549: @1467211
     /* 1467211 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1467311), // Rule ID 14517 //
     /* 1467216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1467227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1467230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1467233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467266 */     // MIs[1] Operand 1
     /* 1467266 */     // No operand predicates
     /* 1467266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467270 */     // MIs[0] policy
     /* 1467270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467310 */     // GIR_Coverage, 14517,
     /* 1467310 */     GIR_EraseRootFromParent_Done,
     /* 1467311 */   // Label 20550: @1467311
     /* 1467311 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1467411), // Rule ID 14520 //
     /* 1467316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1467327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1467330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467366 */     // MIs[1] Operand 1
     /* 1467366 */     // No operand predicates
     /* 1467366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467370 */     // MIs[0] policy
     /* 1467370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467410 */     // GIR_Coverage, 14520,
     /* 1467410 */     GIR_EraseRootFromParent_Done,
     /* 1467411 */   // Label 20551: @1467411
     /* 1467411 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1467511), // Rule ID 14521 //
     /* 1467416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1467427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1467430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467466 */     // MIs[1] Operand 1
     /* 1467466 */     // No operand predicates
     /* 1467466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467470 */     // MIs[0] policy
     /* 1467470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467510 */     // GIR_Coverage, 14521,
     /* 1467510 */     GIR_EraseRootFromParent_Done,
     /* 1467511 */   // Label 20552: @1467511
     /* 1467511 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1467611), // Rule ID 14524 //
     /* 1467516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1467533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467566 */     // MIs[1] Operand 1
     /* 1467566 */     // No operand predicates
     /* 1467566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467570 */     // MIs[0] policy
     /* 1467570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467610 */     // GIR_Coverage, 14524,
     /* 1467610 */     GIR_EraseRootFromParent_Done,
     /* 1467611 */   // Label 20553: @1467611
     /* 1467611 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1467711), // Rule ID 14525 //
     /* 1467616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1467633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467666 */     // MIs[1] Operand 1
     /* 1467666 */     // No operand predicates
     /* 1467666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467670 */     // MIs[0] policy
     /* 1467670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1467685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467710 */     // GIR_Coverage, 14525,
     /* 1467710 */     GIR_EraseRootFromParent_Done,
     /* 1467711 */   // Label 20554: @1467711
     /* 1467711 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1467811), // Rule ID 14528 //
     /* 1467716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1467727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1467730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1467733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467766 */     // MIs[1] Operand 1
     /* 1467766 */     // No operand predicates
     /* 1467766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467770 */     // MIs[0] policy
     /* 1467770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1467785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467810 */     // GIR_Coverage, 14528,
     /* 1467810 */     GIR_EraseRootFromParent_Done,
     /* 1467811 */   // Label 20555: @1467811
     /* 1467811 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1467911), // Rule ID 14529 //
     /* 1467816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1467827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1467830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1467833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467866 */     // MIs[1] Operand 1
     /* 1467866 */     // No operand predicates
     /* 1467866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467870 */     // MIs[0] policy
     /* 1467870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1467885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467910 */     // GIR_Coverage, 14529,
     /* 1467910 */     GIR_EraseRootFromParent_Done,
     /* 1467911 */   // Label 20556: @1467911
     /* 1467911 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1468011), // Rule ID 14532 //
     /* 1467916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1467927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1467930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1467933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467966 */     // MIs[1] Operand 1
     /* 1467966 */     // No operand predicates
     /* 1467966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467970 */     // MIs[0] policy
     /* 1467970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467982 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1467985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468010 */     // GIR_Coverage, 14532,
     /* 1468010 */     GIR_EraseRootFromParent_Done,
     /* 1468011 */   // Label 20557: @1468011
     /* 1468011 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1468111), // Rule ID 14533 //
     /* 1468016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1468027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1468030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1468033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468066 */     // MIs[1] Operand 1
     /* 1468066 */     // No operand predicates
     /* 1468066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468070 */     // MIs[0] policy
     /* 1468070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468082 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1468085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468110 */     // GIR_Coverage, 14533,
     /* 1468110 */     GIR_EraseRootFromParent_Done,
     /* 1468111 */   // Label 20558: @1468111
     /* 1468111 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1468211), // Rule ID 14536 //
     /* 1468116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1468127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1468130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1468133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1468139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468166 */     // MIs[1] Operand 1
     /* 1468166 */     // No operand predicates
     /* 1468166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468170 */     // MIs[0] policy
     /* 1468170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468182 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1468185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468210 */     // GIR_Coverage, 14536,
     /* 1468210 */     GIR_EraseRootFromParent_Done,
     /* 1468211 */   // Label 20559: @1468211
     /* 1468211 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1468311), // Rule ID 14537 //
     /* 1468216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1468227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1468230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1468233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1468239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468266 */     // MIs[1] Operand 1
     /* 1468266 */     // No operand predicates
     /* 1468266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468270 */     // MIs[0] policy
     /* 1468270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1468285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468310 */     // GIR_Coverage, 14537,
     /* 1468310 */     GIR_EraseRootFromParent_Done,
     /* 1468311 */   // Label 20560: @1468311
     /* 1468311 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1468411), // Rule ID 14540 //
     /* 1468316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1468327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1468330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468366 */     // MIs[1] Operand 1
     /* 1468366 */     // No operand predicates
     /* 1468366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468370 */     // MIs[0] policy
     /* 1468370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1468385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468410 */     // GIR_Coverage, 14540,
     /* 1468410 */     GIR_EraseRootFromParent_Done,
     /* 1468411 */   // Label 20561: @1468411
     /* 1468411 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1468511), // Rule ID 14541 //
     /* 1468416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1468427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1468430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468466 */     // MIs[1] Operand 1
     /* 1468466 */     // No operand predicates
     /* 1468466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468470 */     // MIs[0] policy
     /* 1468470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1468485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468510 */     // GIR_Coverage, 14541,
     /* 1468510 */     GIR_EraseRootFromParent_Done,
     /* 1468511 */   // Label 20562: @1468511
     /* 1468511 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1468611), // Rule ID 14544 //
     /* 1468516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1468527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1468530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1468539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468566 */     // MIs[1] Operand 1
     /* 1468566 */     // No operand predicates
     /* 1468566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468570 */     // MIs[0] policy
     /* 1468570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1468585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468610 */     // GIR_Coverage, 14544,
     /* 1468610 */     GIR_EraseRootFromParent_Done,
     /* 1468611 */   // Label 20563: @1468611
     /* 1468611 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1468711), // Rule ID 14545 //
     /* 1468616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1468627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1468630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1468639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468666 */     // MIs[1] Operand 1
     /* 1468666 */     // No operand predicates
     /* 1468666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468670 */     // MIs[0] policy
     /* 1468670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1468685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468710 */     // GIR_Coverage, 14545,
     /* 1468710 */     GIR_EraseRootFromParent_Done,
     /* 1468711 */   // Label 20564: @1468711
     /* 1468711 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1468811), // Rule ID 14548 //
     /* 1468716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1468727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1468730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1468733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468766 */     // MIs[1] Operand 1
     /* 1468766 */     // No operand predicates
     /* 1468766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468770 */     // MIs[0] policy
     /* 1468770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1468785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468810 */     // GIR_Coverage, 14548,
     /* 1468810 */     GIR_EraseRootFromParent_Done,
     /* 1468811 */   // Label 20565: @1468811
     /* 1468811 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1468911), // Rule ID 14549 //
     /* 1468816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1468827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1468830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1468833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468866 */     // MIs[1] Operand 1
     /* 1468866 */     // No operand predicates
     /* 1468866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468870 */     // MIs[0] policy
     /* 1468870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468882 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1468885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468910 */     // GIR_Coverage, 14549,
     /* 1468910 */     GIR_EraseRootFromParent_Done,
     /* 1468911 */   // Label 20566: @1468911
     /* 1468911 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1469011), // Rule ID 14552 //
     /* 1468916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1468927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1468930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1468933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468966 */     // MIs[1] Operand 1
     /* 1468966 */     // No operand predicates
     /* 1468966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468970 */     // MIs[0] policy
     /* 1468970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1468985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469010 */     // GIR_Coverage, 14552,
     /* 1469010 */     GIR_EraseRootFromParent_Done,
     /* 1469011 */   // Label 20567: @1469011
     /* 1469011 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1469111), // Rule ID 14553 //
     /* 1469016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1469027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1469030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1469033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469066 */     // MIs[1] Operand 1
     /* 1469066 */     // No operand predicates
     /* 1469066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469070 */     // MIs[0] policy
     /* 1469070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1469085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469110 */     // GIR_Coverage, 14553,
     /* 1469110 */     GIR_EraseRootFromParent_Done,
     /* 1469111 */   // Label 20568: @1469111
     /* 1469111 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1469211), // Rule ID 14556 //
     /* 1469116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1469127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1469130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469166 */     // MIs[1] Operand 1
     /* 1469166 */     // No operand predicates
     /* 1469166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469170 */     // MIs[0] policy
     /* 1469170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469182 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1469185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469210 */     // GIR_Coverage, 14556,
     /* 1469210 */     GIR_EraseRootFromParent_Done,
     /* 1469211 */   // Label 20569: @1469211
     /* 1469211 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1469311), // Rule ID 14557 //
     /* 1469216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1469227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1469230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469266 */     // MIs[1] Operand 1
     /* 1469266 */     // No operand predicates
     /* 1469266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469270 */     // MIs[0] policy
     /* 1469270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1469285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469304 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469310 */     // GIR_Coverage, 14557,
     /* 1469310 */     GIR_EraseRootFromParent_Done,
     /* 1469311 */   // Label 20570: @1469311
     /* 1469311 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1469411), // Rule ID 14560 //
     /* 1469316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1469327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1469330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1469333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469366 */     // MIs[1] Operand 1
     /* 1469366 */     // No operand predicates
     /* 1469366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469370 */     // MIs[0] policy
     /* 1469370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469382 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1469385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469410 */     // GIR_Coverage, 14560,
     /* 1469410 */     GIR_EraseRootFromParent_Done,
     /* 1469411 */   // Label 20571: @1469411
     /* 1469411 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1469511), // Rule ID 14561 //
     /* 1469416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1469427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1469430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1469433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469466 */     // MIs[1] Operand 1
     /* 1469466 */     // No operand predicates
     /* 1469466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469470 */     // MIs[0] policy
     /* 1469470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1469485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469510 */     // GIR_Coverage, 14561,
     /* 1469510 */     GIR_EraseRootFromParent_Done,
     /* 1469511 */   // Label 20572: @1469511
     /* 1469511 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1469611), // Rule ID 14564 //
     /* 1469516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1469527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1469530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1469533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469566 */     // MIs[1] Operand 1
     /* 1469566 */     // No operand predicates
     /* 1469566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469570 */     // MIs[0] policy
     /* 1469570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1469585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469610 */     // GIR_Coverage, 14564,
     /* 1469610 */     GIR_EraseRootFromParent_Done,
     /* 1469611 */   // Label 20573: @1469611
     /* 1469611 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1469711), // Rule ID 14565 //
     /* 1469616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1469627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1469630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1469633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469666 */     // MIs[1] Operand 1
     /* 1469666 */     // No operand predicates
     /* 1469666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469670 */     // MIs[0] policy
     /* 1469670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469682 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1469685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469710 */     // GIR_Coverage, 14565,
     /* 1469710 */     GIR_EraseRootFromParent_Done,
     /* 1469711 */   // Label 20574: @1469711
     /* 1469711 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1469811), // Rule ID 14568 //
     /* 1469716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1469733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469766 */     // MIs[1] Operand 1
     /* 1469766 */     // No operand predicates
     /* 1469766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469770 */     // MIs[0] policy
     /* 1469770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1469785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469810 */     // GIR_Coverage, 14568,
     /* 1469810 */     GIR_EraseRootFromParent_Done,
     /* 1469811 */   // Label 20575: @1469811
     /* 1469811 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1469911), // Rule ID 14569 //
     /* 1469816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1469833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469866 */     // MIs[1] Operand 1
     /* 1469866 */     // No operand predicates
     /* 1469866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469870 */     // MIs[0] policy
     /* 1469870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1469885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469910 */     // GIR_Coverage, 14569,
     /* 1469910 */     GIR_EraseRootFromParent_Done,
     /* 1469911 */   // Label 20576: @1469911
     /* 1469911 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1470011), // Rule ID 14572 //
     /* 1469916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1469927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1469930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1469933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469966 */     // MIs[1] Operand 1
     /* 1469966 */     // No operand predicates
     /* 1469966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469970 */     // MIs[0] policy
     /* 1469970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469982 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1469985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470010 */     // GIR_Coverage, 14572,
     /* 1470010 */     GIR_EraseRootFromParent_Done,
     /* 1470011 */   // Label 20577: @1470011
     /* 1470011 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1470111), // Rule ID 14573 //
     /* 1470016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1470019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1470027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1470030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1470033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470066 */     // MIs[1] Operand 1
     /* 1470066 */     // No operand predicates
     /* 1470066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470070 */     // MIs[0] policy
     /* 1470070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470110 */     // GIR_Coverage, 14573,
     /* 1470110 */     GIR_EraseRootFromParent_Done,
     /* 1470111 */   // Label 20578: @1470111
     /* 1470111 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1470208), // Rule ID 23692 //
     /* 1470116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1470127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1470130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1470133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470166 */     // MIs[1] Operand 1
     /* 1470166 */     // No operand predicates
     /* 1470166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470170 */     // MIs[0] policy
     /* 1470170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1470185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470207 */     // GIR_Coverage, 23692,
     /* 1470207 */     GIR_EraseRootFromParent_Done,
     /* 1470208 */   // Label 20579: @1470208
     /* 1470208 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1470305), // Rule ID 23693 //
     /* 1470213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1470224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1470227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1470230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470263 */     // MIs[1] Operand 1
     /* 1470263 */     // No operand predicates
     /* 1470263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470267 */     // MIs[0] policy
     /* 1470267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470279 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1470282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470304 */     // GIR_Coverage, 23693,
     /* 1470304 */     GIR_EraseRootFromParent_Done,
     /* 1470305 */   // Label 20580: @1470305
     /* 1470305 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1470402), // Rule ID 23696 //
     /* 1470310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1470321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1470324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1470327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470360 */     // MIs[1] Operand 1
     /* 1470360 */     // No operand predicates
     /* 1470360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470364 */     // MIs[0] policy
     /* 1470364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1470379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470401 */     // GIR_Coverage, 23696,
     /* 1470401 */     GIR_EraseRootFromParent_Done,
     /* 1470402 */   // Label 20581: @1470402
     /* 1470402 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1470499), // Rule ID 23697 //
     /* 1470407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1470418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1470421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1470424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470457 */     // MIs[1] Operand 1
     /* 1470457 */     // No operand predicates
     /* 1470457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470461 */     // MIs[0] policy
     /* 1470461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1470476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470498 */     // GIR_Coverage, 23697,
     /* 1470498 */     GIR_EraseRootFromParent_Done,
     /* 1470499 */   // Label 20582: @1470499
     /* 1470499 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1470596), // Rule ID 23700 //
     /* 1470504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1470515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1470518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1470521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470554 */     // MIs[1] Operand 1
     /* 1470554 */     // No operand predicates
     /* 1470554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470558 */     // MIs[0] policy
     /* 1470558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1470573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470595 */     // GIR_Coverage, 23700,
     /* 1470595 */     GIR_EraseRootFromParent_Done,
     /* 1470596 */   // Label 20583: @1470596
     /* 1470596 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1470693), // Rule ID 23701 //
     /* 1470601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1470612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1470615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1470618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470651 */     // MIs[1] Operand 1
     /* 1470651 */     // No operand predicates
     /* 1470651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470655 */     // MIs[0] policy
     /* 1470655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470667 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1470670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470692 */     // GIR_Coverage, 23701,
     /* 1470692 */     GIR_EraseRootFromParent_Done,
     /* 1470693 */   // Label 20584: @1470693
     /* 1470693 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1470790), // Rule ID 23704 //
     /* 1470698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1470715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470748 */     // MIs[1] Operand 1
     /* 1470748 */     // No operand predicates
     /* 1470748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470752 */     // MIs[0] policy
     /* 1470752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1470767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470789 */     // GIR_Coverage, 23704,
     /* 1470789 */     GIR_EraseRootFromParent_Done,
     /* 1470790 */   // Label 20585: @1470790
     /* 1470790 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1470887), // Rule ID 23705 //
     /* 1470795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1470812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470845 */     // MIs[1] Operand 1
     /* 1470845 */     // No operand predicates
     /* 1470845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470849 */     // MIs[0] policy
     /* 1470849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470861 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1470864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470886 */     // GIR_Coverage, 23705,
     /* 1470886 */     GIR_EraseRootFromParent_Done,
     /* 1470887 */   // Label 20586: @1470887
     /* 1470887 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1470984), // Rule ID 23708 //
     /* 1470892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1470903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1470906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1470909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470942 */     // MIs[1] Operand 1
     /* 1470942 */     // No operand predicates
     /* 1470942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470946 */     // MIs[0] policy
     /* 1470946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1470961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470983 */     // GIR_Coverage, 23708,
     /* 1470983 */     GIR_EraseRootFromParent_Done,
     /* 1470984 */   // Label 20587: @1470984
     /* 1470984 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1471081), // Rule ID 23709 //
     /* 1470989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1470997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1471000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1471003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1471006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471039 */     // MIs[1] Operand 1
     /* 1471039 */     // No operand predicates
     /* 1471039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471043 */     // MIs[0] policy
     /* 1471043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471055 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1471058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471080 */     // GIR_Coverage, 23709,
     /* 1471080 */     GIR_EraseRootFromParent_Done,
     /* 1471081 */   // Label 20588: @1471081
     /* 1471081 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1471178), // Rule ID 23712 //
     /* 1471086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1471103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471136 */     // MIs[1] Operand 1
     /* 1471136 */     // No operand predicates
     /* 1471136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471140 */     // MIs[0] policy
     /* 1471140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1471155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471177 */     // GIR_Coverage, 23712,
     /* 1471177 */     GIR_EraseRootFromParent_Done,
     /* 1471178 */   // Label 20589: @1471178
     /* 1471178 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1471275), // Rule ID 23713 //
     /* 1471183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1471200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471233 */     // MIs[1] Operand 1
     /* 1471233 */     // No operand predicates
     /* 1471233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471237 */     // MIs[0] policy
     /* 1471237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1471252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471274 */     // GIR_Coverage, 23713,
     /* 1471274 */     GIR_EraseRootFromParent_Done,
     /* 1471275 */   // Label 20590: @1471275
     /* 1471275 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1471372), // Rule ID 23716 //
     /* 1471280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1471291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1471294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1471297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471330 */     // MIs[1] Operand 1
     /* 1471330 */     // No operand predicates
     /* 1471330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471334 */     // MIs[0] policy
     /* 1471334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471371 */     // GIR_Coverage, 23716,
     /* 1471371 */     GIR_EraseRootFromParent_Done,
     /* 1471372 */   // Label 20591: @1471372
     /* 1471372 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1471469), // Rule ID 23717 //
     /* 1471377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1471388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1471391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1471394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471427 */     // MIs[1] Operand 1
     /* 1471427 */     // No operand predicates
     /* 1471427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471431 */     // MIs[0] policy
     /* 1471431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471443 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471468 */     // GIR_Coverage, 23717,
     /* 1471468 */     GIR_EraseRootFromParent_Done,
     /* 1471469 */   // Label 20592: @1471469
     /* 1471469 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1471566), // Rule ID 23720 //
     /* 1471474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1471485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1471488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1471491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471524 */     // MIs[1] Operand 1
     /* 1471524 */     // No operand predicates
     /* 1471524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471528 */     // MIs[0] policy
     /* 1471528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471565 */     // GIR_Coverage, 23720,
     /* 1471565 */     GIR_EraseRootFromParent_Done,
     /* 1471566 */   // Label 20593: @1471566
     /* 1471566 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1471663), // Rule ID 23721 //
     /* 1471571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1471582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1471585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1471588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471621 */     // MIs[1] Operand 1
     /* 1471621 */     // No operand predicates
     /* 1471621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471625 */     // MIs[0] policy
     /* 1471625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471637 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471662 */     // GIR_Coverage, 23721,
     /* 1471662 */     GIR_EraseRootFromParent_Done,
     /* 1471663 */   // Label 20594: @1471663
     /* 1471663 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1471760), // Rule ID 23724 //
     /* 1471668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1471685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471718 */     // MIs[1] Operand 1
     /* 1471718 */     // No operand predicates
     /* 1471718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471722 */     // MIs[0] policy
     /* 1471722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471759 */     // GIR_Coverage, 23724,
     /* 1471759 */     GIR_EraseRootFromParent_Done,
     /* 1471760 */   // Label 20595: @1471760
     /* 1471760 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1471857), // Rule ID 23725 //
     /* 1471765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1471782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471815 */     // MIs[1] Operand 1
     /* 1471815 */     // No operand predicates
     /* 1471815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471819 */     // MIs[0] policy
     /* 1471819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471831 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471856 */     // GIR_Coverage, 23725,
     /* 1471856 */     GIR_EraseRootFromParent_Done,
     /* 1471857 */   // Label 20596: @1471857
     /* 1471857 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1471954), // Rule ID 23728 //
     /* 1471862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1471873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1471876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471912 */     // MIs[1] Operand 1
     /* 1471912 */     // No operand predicates
     /* 1471912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471916 */     // MIs[0] policy
     /* 1471916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1471931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471953 */     // GIR_Coverage, 23728,
     /* 1471953 */     GIR_EraseRootFromParent_Done,
     /* 1471954 */   // Label 20597: @1471954
     /* 1471954 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1472051), // Rule ID 23729 //
     /* 1471959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1471967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1471970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1471973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472009 */     // MIs[1] Operand 1
     /* 1472009 */     // No operand predicates
     /* 1472009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472013 */     // MIs[0] policy
     /* 1472013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1472028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472050 */     // GIR_Coverage, 23729,
     /* 1472050 */     GIR_EraseRootFromParent_Done,
     /* 1472051 */   // Label 20598: @1472051
     /* 1472051 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1472148), // Rule ID 23732 //
     /* 1472056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1472067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1472070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1472073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472106 */     // MIs[1] Operand 1
     /* 1472106 */     // No operand predicates
     /* 1472106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472110 */     // MIs[0] policy
     /* 1472110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1472125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472147 */     // GIR_Coverage, 23732,
     /* 1472147 */     GIR_EraseRootFromParent_Done,
     /* 1472148 */   // Label 20599: @1472148
     /* 1472148 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1472245), // Rule ID 23733 //
     /* 1472153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1472164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1472167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1472170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472203 */     // MIs[1] Operand 1
     /* 1472203 */     // No operand predicates
     /* 1472203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472207 */     // MIs[0] policy
     /* 1472207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1472222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472244 */     // GIR_Coverage, 23733,
     /* 1472244 */     GIR_EraseRootFromParent_Done,
     /* 1472245 */   // Label 20600: @1472245
     /* 1472245 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1472342), // Rule ID 23736 //
     /* 1472250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1472267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1472273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472300 */     // MIs[1] Operand 1
     /* 1472300 */     // No operand predicates
     /* 1472300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472304 */     // MIs[0] policy
     /* 1472304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1472319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472341 */     // GIR_Coverage, 23736,
     /* 1472341 */     GIR_EraseRootFromParent_Done,
     /* 1472342 */   // Label 20601: @1472342
     /* 1472342 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1472439), // Rule ID 23737 //
     /* 1472347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1472364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1472370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472397 */     // MIs[1] Operand 1
     /* 1472397 */     // No operand predicates
     /* 1472397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472401 */     // MIs[0] policy
     /* 1472401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472413 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1472416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472438 */     // GIR_Coverage, 23737,
     /* 1472438 */     GIR_EraseRootFromParent_Done,
     /* 1472439 */   // Label 20602: @1472439
     /* 1472439 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1472536), // Rule ID 23740 //
     /* 1472444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1472455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1472458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1472461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1472467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472494 */     // MIs[1] Operand 1
     /* 1472494 */     // No operand predicates
     /* 1472494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472498 */     // MIs[0] policy
     /* 1472498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472510 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1472513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472535 */     // GIR_Coverage, 23740,
     /* 1472535 */     GIR_EraseRootFromParent_Done,
     /* 1472536 */   // Label 20603: @1472536
     /* 1472536 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1472633), // Rule ID 23741 //
     /* 1472541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1472552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1472555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1472558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1472564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472591 */     // MIs[1] Operand 1
     /* 1472591 */     // No operand predicates
     /* 1472591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472595 */     // MIs[0] policy
     /* 1472595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472607 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1472610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472632 */     // GIR_Coverage, 23741,
     /* 1472632 */     GIR_EraseRootFromParent_Done,
     /* 1472633 */   // Label 20604: @1472633
     /* 1472633 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1472730), // Rule ID 23744 //
     /* 1472638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1472649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1472652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472688 */     // MIs[1] Operand 1
     /* 1472688 */     // No operand predicates
     /* 1472688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472692 */     // MIs[0] policy
     /* 1472692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1472707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472729 */     // GIR_Coverage, 23744,
     /* 1472729 */     GIR_EraseRootFromParent_Done,
     /* 1472730 */   // Label 20605: @1472730
     /* 1472730 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1472827), // Rule ID 23745 //
     /* 1472735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1472746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1472749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472785 */     // MIs[1] Operand 1
     /* 1472785 */     // No operand predicates
     /* 1472785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472789 */     // MIs[0] policy
     /* 1472789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1472804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472826 */     // GIR_Coverage, 23745,
     /* 1472826 */     GIR_EraseRootFromParent_Done,
     /* 1472827 */   // Label 20606: @1472827
     /* 1472827 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1472924), // Rule ID 23748 //
     /* 1472832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1472843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1472846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472882 */     // MIs[1] Operand 1
     /* 1472882 */     // No operand predicates
     /* 1472882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472886 */     // MIs[0] policy
     /* 1472886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1472901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472923 */     // GIR_Coverage, 23748,
     /* 1472923 */     GIR_EraseRootFromParent_Done,
     /* 1472924 */   // Label 20607: @1472924
     /* 1472924 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1473021), // Rule ID 23749 //
     /* 1472929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1472940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1472943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472979 */     // MIs[1] Operand 1
     /* 1472979 */     // No operand predicates
     /* 1472979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472983 */     // MIs[0] policy
     /* 1472983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472995 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1472998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473020 */     // GIR_Coverage, 23749,
     /* 1473020 */     GIR_EraseRootFromParent_Done,
     /* 1473021 */   // Label 20608: @1473021
     /* 1473021 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1473118), // Rule ID 23752 //
     /* 1473026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1473037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1473040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1473043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1473049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473076 */     // MIs[1] Operand 1
     /* 1473076 */     // No operand predicates
     /* 1473076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473080 */     // MIs[0] policy
     /* 1473080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1473095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473117 */     // GIR_Coverage, 23752,
     /* 1473117 */     GIR_EraseRootFromParent_Done,
     /* 1473118 */   // Label 20609: @1473118
     /* 1473118 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1473215), // Rule ID 23753 //
     /* 1473123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1473134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1473137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1473140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1473146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473173 */     // MIs[1] Operand 1
     /* 1473173 */     // No operand predicates
     /* 1473173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473177 */     // MIs[0] policy
     /* 1473177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473189 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1473192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473214 */     // GIR_Coverage, 23753,
     /* 1473214 */     GIR_EraseRootFromParent_Done,
     /* 1473215 */   // Label 20610: @1473215
     /* 1473215 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1473312), // Rule ID 23756 //
     /* 1473220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1473231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1473234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473270 */     // MIs[1] Operand 1
     /* 1473270 */     // No operand predicates
     /* 1473270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473274 */     // MIs[0] policy
     /* 1473274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1473289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473311 */     // GIR_Coverage, 23756,
     /* 1473311 */     GIR_EraseRootFromParent_Done,
     /* 1473312 */   // Label 20611: @1473312
     /* 1473312 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1473409), // Rule ID 23757 //
     /* 1473317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1473328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1473331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473367 */     // MIs[1] Operand 1
     /* 1473367 */     // No operand predicates
     /* 1473367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473371 */     // MIs[0] policy
     /* 1473371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1473386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473408 */     // GIR_Coverage, 23757,
     /* 1473408 */     GIR_EraseRootFromParent_Done,
     /* 1473409 */   // Label 20612: @1473409
     /* 1473409 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1473506), // Rule ID 23760 //
     /* 1473414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1473425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1473428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473464 */     // MIs[1] Operand 1
     /* 1473464 */     // No operand predicates
     /* 1473464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473468 */     // MIs[0] policy
     /* 1473468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1473483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473505 */     // GIR_Coverage, 23760,
     /* 1473505 */     GIR_EraseRootFromParent_Done,
     /* 1473506 */   // Label 20613: @1473506
     /* 1473506 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1473603), // Rule ID 23761 //
     /* 1473511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1473522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1473525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473561 */     // MIs[1] Operand 1
     /* 1473561 */     // No operand predicates
     /* 1473561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473565 */     // MIs[0] policy
     /* 1473565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1473580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473602 */     // GIR_Coverage, 23761,
     /* 1473602 */     GIR_EraseRootFromParent_Done,
     /* 1473603 */   // Label 20614: @1473603
     /* 1473603 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1473700), // Rule ID 23764 //
     /* 1473608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1473619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1473622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473658 */     // MIs[1] Operand 1
     /* 1473658 */     // No operand predicates
     /* 1473658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473662 */     // MIs[0] policy
     /* 1473662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1473677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473699 */     // GIR_Coverage, 23764,
     /* 1473699 */     GIR_EraseRootFromParent_Done,
     /* 1473700 */   // Label 20615: @1473700
     /* 1473700 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1473797), // Rule ID 23765 //
     /* 1473705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1473716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1473719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473755 */     // MIs[1] Operand 1
     /* 1473755 */     // No operand predicates
     /* 1473755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473759 */     // MIs[0] policy
     /* 1473759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473771 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1473774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473796 */     // GIR_Coverage, 23765,
     /* 1473796 */     GIR_EraseRootFromParent_Done,
     /* 1473797 */   // Label 20616: @1473797
     /* 1473797 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1473894), // Rule ID 23768 //
     /* 1473802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1473805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1473813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1473816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473852 */     // MIs[1] Operand 1
     /* 1473852 */     // No operand predicates
     /* 1473852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473856 */     // MIs[0] policy
     /* 1473856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1473871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473893 */     // GIR_Coverage, 23768,
     /* 1473893 */     GIR_EraseRootFromParent_Done,
     /* 1473894 */   // Label 20617: @1473894
     /* 1473894 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1473991), // Rule ID 23769 //
     /* 1473899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1473902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1473910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1473913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473949 */     // MIs[1] Operand 1
     /* 1473949 */     // No operand predicates
     /* 1473949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473953 */     // MIs[0] policy
     /* 1473953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473965 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1473968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473990 */     // GIR_Coverage, 23769,
     /* 1473990 */     GIR_EraseRootFromParent_Done,
     /* 1473991 */   // Label 20618: @1473991
     /* 1473991 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1474088), // Rule ID 23772 //
     /* 1473996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1473999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1474007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1474010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1474013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474046 */     // MIs[1] Operand 1
     /* 1474046 */     // No operand predicates
     /* 1474046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474050 */     // MIs[0] policy
     /* 1474050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474087 */     // GIR_Coverage, 23772,
     /* 1474087 */     GIR_EraseRootFromParent_Done,
     /* 1474088 */   // Label 20619: @1474088
     /* 1474088 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1474185), // Rule ID 23773 //
     /* 1474093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1474104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1474107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1474110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474143 */     // MIs[1] Operand 1
     /* 1474143 */     // No operand predicates
     /* 1474143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474147 */     // MIs[0] policy
     /* 1474147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474184 */     // GIR_Coverage, 23773,
     /* 1474184 */     GIR_EraseRootFromParent_Done,
     /* 1474185 */   // Label 20620: @1474185
     /* 1474185 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1474282), // Rule ID 23776 //
     /* 1474190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1474201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1474204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474240 */     // MIs[1] Operand 1
     /* 1474240 */     // No operand predicates
     /* 1474240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474244 */     // MIs[0] policy
     /* 1474244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474281 */     // GIR_Coverage, 23776,
     /* 1474281 */     GIR_EraseRootFromParent_Done,
     /* 1474282 */   // Label 20621: @1474282
     /* 1474282 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1474379), // Rule ID 23777 //
     /* 1474287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1474298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1474301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474337 */     // MIs[1] Operand 1
     /* 1474337 */     // No operand predicates
     /* 1474337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474341 */     // MIs[0] policy
     /* 1474341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474353 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474378 */     // GIR_Coverage, 23777,
     /* 1474378 */     GIR_EraseRootFromParent_Done,
     /* 1474379 */   // Label 20622: @1474379
     /* 1474379 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1474476), // Rule ID 23868 //
     /* 1474384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1474395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1474398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1474401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474434 */     // MIs[1] Operand 1
     /* 1474434 */     // No operand predicates
     /* 1474434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474438 */     // MIs[0] policy
     /* 1474438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1474453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474475 */     // GIR_Coverage, 23868,
     /* 1474475 */     GIR_EraseRootFromParent_Done,
     /* 1474476 */   // Label 20623: @1474476
     /* 1474476 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1474573), // Rule ID 23869 //
     /* 1474481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1474492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1474495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1474498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474531 */     // MIs[1] Operand 1
     /* 1474531 */     // No operand predicates
     /* 1474531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474535 */     // MIs[0] policy
     /* 1474535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474547 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1474550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474572 */     // GIR_Coverage, 23869,
     /* 1474572 */     GIR_EraseRootFromParent_Done,
     /* 1474573 */   // Label 20624: @1474573
     /* 1474573 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1474670), // Rule ID 23872 //
     /* 1474578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1474589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1474592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1474595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474628 */     // MIs[1] Operand 1
     /* 1474628 */     // No operand predicates
     /* 1474628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474632 */     // MIs[0] policy
     /* 1474632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474644 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1474647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474669 */     // GIR_Coverage, 23872,
     /* 1474669 */     GIR_EraseRootFromParent_Done,
     /* 1474670 */   // Label 20625: @1474670
     /* 1474670 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1474767), // Rule ID 23873 //
     /* 1474675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1474686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1474689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1474692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474725 */     // MIs[1] Operand 1
     /* 1474725 */     // No operand predicates
     /* 1474725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474729 */     // MIs[0] policy
     /* 1474729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474741 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1474744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474766 */     // GIR_Coverage, 23873,
     /* 1474766 */     GIR_EraseRootFromParent_Done,
     /* 1474767 */   // Label 20626: @1474767
     /* 1474767 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1474864), // Rule ID 23876 //
     /* 1474772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1474783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1474786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1474789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474822 */     // MIs[1] Operand 1
     /* 1474822 */     // No operand predicates
     /* 1474822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474826 */     // MIs[0] policy
     /* 1474826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474838 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1474841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474863 */     // GIR_Coverage, 23876,
     /* 1474863 */     GIR_EraseRootFromParent_Done,
     /* 1474864 */   // Label 20627: @1474864
     /* 1474864 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1474961), // Rule ID 23877 //
     /* 1474869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1474880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1474883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1474886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474919 */     // MIs[1] Operand 1
     /* 1474919 */     // No operand predicates
     /* 1474919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474923 */     // MIs[0] policy
     /* 1474923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474935 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1474938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474960 */     // GIR_Coverage, 23877,
     /* 1474960 */     GIR_EraseRootFromParent_Done,
     /* 1474961 */   // Label 20628: @1474961
     /* 1474961 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1475058), // Rule ID 23880 //
     /* 1474966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1474977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1474980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1474983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475016 */     // MIs[1] Operand 1
     /* 1475016 */     // No operand predicates
     /* 1475016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475020 */     // MIs[0] policy
     /* 1475020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1475035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475057 */     // GIR_Coverage, 23880,
     /* 1475057 */     GIR_EraseRootFromParent_Done,
     /* 1475058 */   // Label 20629: @1475058
     /* 1475058 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1475155), // Rule ID 23881 //
     /* 1475063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1475074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1475077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1475080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1475086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475113 */     // MIs[1] Operand 1
     /* 1475113 */     // No operand predicates
     /* 1475113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475117 */     // MIs[0] policy
     /* 1475117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475129 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1475132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475154 */     // GIR_Coverage, 23881,
     /* 1475154 */     GIR_EraseRootFromParent_Done,
     /* 1475155 */   // Label 20630: @1475155
     /* 1475155 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1475252), // Rule ID 23884 //
     /* 1475160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1475171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1475174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1475177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475210 */     // MIs[1] Operand 1
     /* 1475210 */     // No operand predicates
     /* 1475210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475214 */     // MIs[0] policy
     /* 1475214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1475229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475251 */     // GIR_Coverage, 23884,
     /* 1475251 */     GIR_EraseRootFromParent_Done,
     /* 1475252 */   // Label 20631: @1475252
     /* 1475252 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1475349), // Rule ID 23885 //
     /* 1475257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1475268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1475271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1475274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475307 */     // MIs[1] Operand 1
     /* 1475307 */     // No operand predicates
     /* 1475307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475311 */     // MIs[0] policy
     /* 1475311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475323 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1475326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475348 */     // GIR_Coverage, 23885,
     /* 1475348 */     GIR_EraseRootFromParent_Done,
     /* 1475349 */   // Label 20632: @1475349
     /* 1475349 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1475446), // Rule ID 23888 //
     /* 1475354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1475365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1475368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1475371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1475377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475404 */     // MIs[1] Operand 1
     /* 1475404 */     // No operand predicates
     /* 1475404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475408 */     // MIs[0] policy
     /* 1475408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1475423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475445 */     // GIR_Coverage, 23888,
     /* 1475445 */     GIR_EraseRootFromParent_Done,
     /* 1475446 */   // Label 20633: @1475446
     /* 1475446 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1475543), // Rule ID 23889 //
     /* 1475451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1475462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1475465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1475468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1475474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475501 */     // MIs[1] Operand 1
     /* 1475501 */     // No operand predicates
     /* 1475501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475505 */     // MIs[0] policy
     /* 1475505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475517 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1475520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475542 */     // GIR_Coverage, 23889,
     /* 1475542 */     GIR_EraseRootFromParent_Done,
     /* 1475543 */   // Label 20634: @1475543
     /* 1475543 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1475640), // Rule ID 23892 //
     /* 1475548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1475559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1475562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1475565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475598 */     // MIs[1] Operand 1
     /* 1475598 */     // No operand predicates
     /* 1475598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475602 */     // MIs[0] policy
     /* 1475602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1475617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475639 */     // GIR_Coverage, 23892,
     /* 1475639 */     GIR_EraseRootFromParent_Done,
     /* 1475640 */   // Label 20635: @1475640
     /* 1475640 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1475737), // Rule ID 23893 //
     /* 1475645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1475656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1475659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1475662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475695 */     // MIs[1] Operand 1
     /* 1475695 */     // No operand predicates
     /* 1475695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475699 */     // MIs[0] policy
     /* 1475699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475711 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1475714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1475733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475736 */     // GIR_Coverage, 23893,
     /* 1475736 */     GIR_EraseRootFromParent_Done,
     /* 1475737 */   // Label 20636: @1475737
     /* 1475737 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1475834), // Rule ID 23896 //
     /* 1475742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1475753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1475756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1475759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475792 */     // MIs[1] Operand 1
     /* 1475792 */     // No operand predicates
     /* 1475792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475796 */     // MIs[0] policy
     /* 1475796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1475811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475833 */     // GIR_Coverage, 23896,
     /* 1475833 */     GIR_EraseRootFromParent_Done,
     /* 1475834 */   // Label 20637: @1475834
     /* 1475834 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1475931), // Rule ID 23897 //
     /* 1475839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1475850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1475853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1475856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475889 */     // MIs[1] Operand 1
     /* 1475889 */     // No operand predicates
     /* 1475889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475893 */     // MIs[0] policy
     /* 1475893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475905 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1475908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475930 */     // GIR_Coverage, 23897,
     /* 1475930 */     GIR_EraseRootFromParent_Done,
     /* 1475931 */   // Label 20638: @1475931
     /* 1475931 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1476028), // Rule ID 23900 //
     /* 1475936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1475944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1475947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1475950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1475953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475986 */     // MIs[1] Operand 1
     /* 1475986 */     // No operand predicates
     /* 1475986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475990 */     // MIs[0] policy
     /* 1475990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1476005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476027 */     // GIR_Coverage, 23900,
     /* 1476027 */     GIR_EraseRootFromParent_Done,
     /* 1476028 */   // Label 20639: @1476028
     /* 1476028 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1476125), // Rule ID 23901 //
     /* 1476033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1476044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1476047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1476050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476083 */     // MIs[1] Operand 1
     /* 1476083 */     // No operand predicates
     /* 1476083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476087 */     // MIs[0] policy
     /* 1476087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476099 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1476102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476124 */     // GIR_Coverage, 23901,
     /* 1476124 */     GIR_EraseRootFromParent_Done,
     /* 1476125 */   // Label 20640: @1476125
     /* 1476125 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1476222), // Rule ID 23904 //
     /* 1476130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1476141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1476144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1476147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476180 */     // MIs[1] Operand 1
     /* 1476180 */     // No operand predicates
     /* 1476180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476184 */     // MIs[0] policy
     /* 1476184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1476199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476221 */     // GIR_Coverage, 23904,
     /* 1476221 */     GIR_EraseRootFromParent_Done,
     /* 1476222 */   // Label 20641: @1476222
     /* 1476222 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1476319), // Rule ID 23905 //
     /* 1476227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1476238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1476241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1476244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476277 */     // MIs[1] Operand 1
     /* 1476277 */     // No operand predicates
     /* 1476277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476281 */     // MIs[0] policy
     /* 1476281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1476296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476318 */     // GIR_Coverage, 23905,
     /* 1476318 */     GIR_EraseRootFromParent_Done,
     /* 1476319 */   // Label 20642: @1476319
     /* 1476319 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1476416), // Rule ID 23908 //
     /* 1476324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1476335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1476338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1476341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476374 */     // MIs[1] Operand 1
     /* 1476374 */     // No operand predicates
     /* 1476374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476378 */     // MIs[0] policy
     /* 1476378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1476393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476415 */     // GIR_Coverage, 23908,
     /* 1476415 */     GIR_EraseRootFromParent_Done,
     /* 1476416 */   // Label 20643: @1476416
     /* 1476416 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1476513), // Rule ID 23909 //
     /* 1476421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1476432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1476435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1476438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476471 */     // MIs[1] Operand 1
     /* 1476471 */     // No operand predicates
     /* 1476471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476475 */     // MIs[0] policy
     /* 1476475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476487 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1476490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476512 */     // GIR_Coverage, 23909,
     /* 1476512 */     GIR_EraseRootFromParent_Done,
     /* 1476513 */   // Label 20644: @1476513
     /* 1476513 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1476610), // Rule ID 23912 //
     /* 1476518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1476529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1476532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1476535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1476541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476568 */     // MIs[1] Operand 1
     /* 1476568 */     // No operand predicates
     /* 1476568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476572 */     // MIs[0] policy
     /* 1476572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1476587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476609 */     // GIR_Coverage, 23912,
     /* 1476609 */     GIR_EraseRootFromParent_Done,
     /* 1476610 */   // Label 20645: @1476610
     /* 1476610 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1476707), // Rule ID 23913 //
     /* 1476615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1476626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1476629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1476632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1476638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476665 */     // MIs[1] Operand 1
     /* 1476665 */     // No operand predicates
     /* 1476665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476669 */     // MIs[0] policy
     /* 1476669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476681 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1476684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476706 */     // GIR_Coverage, 23913,
     /* 1476706 */     GIR_EraseRootFromParent_Done,
     /* 1476707 */   // Label 20646: @1476707
     /* 1476707 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1476804), // Rule ID 23916 //
     /* 1476712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1476723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1476726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1476729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1476735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476762 */     // MIs[1] Operand 1
     /* 1476762 */     // No operand predicates
     /* 1476762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476766 */     // MIs[0] policy
     /* 1476766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476778 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1476781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476803 */     // GIR_Coverage, 23916,
     /* 1476803 */     GIR_EraseRootFromParent_Done,
     /* 1476804 */   // Label 20647: @1476804
     /* 1476804 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1476901), // Rule ID 23917 //
     /* 1476809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1476820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1476823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1476826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1476832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476859 */     // MIs[1] Operand 1
     /* 1476859 */     // No operand predicates
     /* 1476859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476863 */     // MIs[0] policy
     /* 1476863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476875 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1476878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476900 */     // GIR_Coverage, 23917,
     /* 1476900 */     GIR_EraseRootFromParent_Done,
     /* 1476901 */   // Label 20648: @1476901
     /* 1476901 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1476998), // Rule ID 23920 //
     /* 1476906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1476917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1476920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1476923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476956 */     // MIs[1] Operand 1
     /* 1476956 */     // No operand predicates
     /* 1476956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476960 */     // MIs[0] policy
     /* 1476960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1476975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476997 */     // GIR_Coverage, 23920,
     /* 1476997 */     GIR_EraseRootFromParent_Done,
     /* 1476998 */   // Label 20649: @1476998
     /* 1476998 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1477095), // Rule ID 23921 //
     /* 1477003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1477014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1477017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1477020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477053 */     // MIs[1] Operand 1
     /* 1477053 */     // No operand predicates
     /* 1477053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477057 */     // MIs[0] policy
     /* 1477057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1477072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477094 */     // GIR_Coverage, 23921,
     /* 1477094 */     GIR_EraseRootFromParent_Done,
     /* 1477095 */   // Label 20650: @1477095
     /* 1477095 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1477192), // Rule ID 23924 //
     /* 1477100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1477111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1477114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1477117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1477123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477150 */     // MIs[1] Operand 1
     /* 1477150 */     // No operand predicates
     /* 1477150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477154 */     // MIs[0] policy
     /* 1477154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1477169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477191 */     // GIR_Coverage, 23924,
     /* 1477191 */     GIR_EraseRootFromParent_Done,
     /* 1477192 */   // Label 20651: @1477192
     /* 1477192 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1477289), // Rule ID 23925 //
     /* 1477197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1477208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1477211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1477214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1477220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477247 */     // MIs[1] Operand 1
     /* 1477247 */     // No operand predicates
     /* 1477247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477251 */     // MIs[0] policy
     /* 1477251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477263 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1477266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477288 */     // GIR_Coverage, 23925,
     /* 1477288 */     GIR_EraseRootFromParent_Done,
     /* 1477289 */   // Label 20652: @1477289
     /* 1477289 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1477386), // Rule ID 23928 //
     /* 1477294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1477305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1477308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1477311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1477317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477344 */     // MIs[1] Operand 1
     /* 1477344 */     // No operand predicates
     /* 1477344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477348 */     // MIs[0] policy
     /* 1477348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1477363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477385 */     // GIR_Coverage, 23928,
     /* 1477385 */     GIR_EraseRootFromParent_Done,
     /* 1477386 */   // Label 20653: @1477386
     /* 1477386 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1477483), // Rule ID 23929 //
     /* 1477391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1477402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1477405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1477408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1477414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477441 */     // MIs[1] Operand 1
     /* 1477441 */     // No operand predicates
     /* 1477441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477445 */     // MIs[0] policy
     /* 1477445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477457 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1477460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477482 */     // GIR_Coverage, 23929,
     /* 1477482 */     GIR_EraseRootFromParent_Done,
     /* 1477483 */   // Label 20654: @1477483
     /* 1477483 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1477580), // Rule ID 23932 //
     /* 1477488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1477505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477538 */     // MIs[1] Operand 1
     /* 1477538 */     // No operand predicates
     /* 1477538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477542 */     // MIs[0] policy
     /* 1477542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1477557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477579 */     // GIR_Coverage, 23932,
     /* 1477579 */     GIR_EraseRootFromParent_Done,
     /* 1477580 */   // Label 20655: @1477580
     /* 1477580 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1477677), // Rule ID 23933 //
     /* 1477585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1477596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1477599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1477602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1477615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1477623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477635 */     // MIs[1] Operand 1
     /* 1477635 */     // No operand predicates
     /* 1477635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477639 */     // MIs[0] policy
     /* 1477639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477651 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1477654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477676 */     // GIR_Coverage, 23933,
     /* 1477676 */     GIR_EraseRootFromParent_Done,
     /* 1477677 */   // Label 20656: @1477677
     /* 1477677 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1477774), // Rule ID 23936 //
     /* 1477682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1477699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477732 */     // MIs[1] Operand 1
     /* 1477732 */     // No operand predicates
     /* 1477732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477736 */     // MIs[0] policy
     /* 1477736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1477751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477773 */     // GIR_Coverage, 23936,
     /* 1477773 */     GIR_EraseRootFromParent_Done,
     /* 1477774 */   // Label 20657: @1477774
     /* 1477774 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1477871), // Rule ID 23937 //
     /* 1477779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1477790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1477793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1477796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1477809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1477817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477829 */     // MIs[1] Operand 1
     /* 1477829 */     // No operand predicates
     /* 1477829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477833 */     // MIs[0] policy
     /* 1477833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477845 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1477848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477870 */     // GIR_Coverage, 23937,
     /* 1477870 */     GIR_EraseRootFromParent_Done,
     /* 1477871 */   // Label 20658: @1477871
     /* 1477871 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1477968), // Rule ID 23940 //
     /* 1477876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1477887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1477890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1477893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1477899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477926 */     // MIs[1] Operand 1
     /* 1477926 */     // No operand predicates
     /* 1477926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477930 */     // MIs[0] policy
     /* 1477930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1477945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477967 */     // GIR_Coverage, 23940,
     /* 1477967 */     GIR_EraseRootFromParent_Done,
     /* 1477968 */   // Label 20659: @1477968
     /* 1477968 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1478065), // Rule ID 23941 //
     /* 1477973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1477984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1477987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1477990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1477996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478023 */     // MIs[1] Operand 1
     /* 1478023 */     // No operand predicates
     /* 1478023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478027 */     // MIs[0] policy
     /* 1478027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478039 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1478042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478064 */     // GIR_Coverage, 23941,
     /* 1478064 */     GIR_EraseRootFromParent_Done,
     /* 1478065 */   // Label 20660: @1478065
     /* 1478065 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1478162), // Rule ID 23944 //
     /* 1478070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1478081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1478084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1478087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478120 */     // MIs[1] Operand 1
     /* 1478120 */     // No operand predicates
     /* 1478120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478124 */     // MIs[0] policy
     /* 1478124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478161 */     // GIR_Coverage, 23944,
     /* 1478161 */     GIR_EraseRootFromParent_Done,
     /* 1478162 */   // Label 20661: @1478162
     /* 1478162 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1478259), // Rule ID 23945 //
     /* 1478167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1478178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1478181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1478184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478217 */     // MIs[1] Operand 1
     /* 1478217 */     // No operand predicates
     /* 1478217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478221 */     // MIs[0] policy
     /* 1478221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478258 */     // GIR_Coverage, 23945,
     /* 1478258 */     GIR_EraseRootFromParent_Done,
     /* 1478259 */   // Label 20662: @1478259
     /* 1478259 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1478356), // Rule ID 23948 //
     /* 1478264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1478275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1478278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1478281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478314 */     // MIs[1] Operand 1
     /* 1478314 */     // No operand predicates
     /* 1478314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478318 */     // MIs[0] policy
     /* 1478318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478355 */     // GIR_Coverage, 23948,
     /* 1478355 */     GIR_EraseRootFromParent_Done,
     /* 1478356 */   // Label 20663: @1478356
     /* 1478356 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1478453), // Rule ID 23949 //
     /* 1478361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1478372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1478375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1478378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478411 */     // MIs[1] Operand 1
     /* 1478411 */     // No operand predicates
     /* 1478411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478415 */     // MIs[0] policy
     /* 1478415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478452 */     // GIR_Coverage, 23949,
     /* 1478452 */     GIR_EraseRootFromParent_Done,
     /* 1478453 */   // Label 20664: @1478453
     /* 1478453 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1478550), // Rule ID 23952 //
     /* 1478458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1478469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1478472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1478475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478508 */     // MIs[1] Operand 1
     /* 1478508 */     // No operand predicates
     /* 1478508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478512 */     // MIs[0] policy
     /* 1478512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1478527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478549 */     // GIR_Coverage, 23952,
     /* 1478549 */     GIR_EraseRootFromParent_Done,
     /* 1478550 */   // Label 20665: @1478550
     /* 1478550 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1478647), // Rule ID 23953 //
     /* 1478555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1478566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1478569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1478572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478605 */     // MIs[1] Operand 1
     /* 1478605 */     // No operand predicates
     /* 1478605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478609 */     // MIs[0] policy
     /* 1478609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478621 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1478624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478646 */     // GIR_Coverage, 23953,
     /* 1478646 */     GIR_EraseRootFromParent_Done,
     /* 1478647 */   // Label 20666: @1478647
     /* 1478647 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1478744), // Rule ID 24192 //
     /* 1478652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1478655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1478669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478702 */     // MIs[1] Operand 1
     /* 1478702 */     // No operand predicates
     /* 1478702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478706 */     // MIs[0] policy
     /* 1478706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478718 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1478721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478743 */     // GIR_Coverage, 24192,
     /* 1478743 */     GIR_EraseRootFromParent_Done,
     /* 1478744 */   // Label 20667: @1478744
     /* 1478744 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1478841), // Rule ID 24193 //
     /* 1478749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1478752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1478760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1478763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1478766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478799 */     // MIs[1] Operand 1
     /* 1478799 */     // No operand predicates
     /* 1478799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478803 */     // MIs[0] policy
     /* 1478803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478815 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1478818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478840 */     // GIR_Coverage, 24193,
     /* 1478840 */     GIR_EraseRootFromParent_Done,
     /* 1478841 */   // Label 20668: @1478841
     /* 1478841 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1478938), // Rule ID 24196 //
     /* 1478846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1478849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1478857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1478860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1478863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478896 */     // MIs[1] Operand 1
     /* 1478896 */     // No operand predicates
     /* 1478896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478900 */     // MIs[0] policy
     /* 1478900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478912 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1478915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478937 */     // GIR_Coverage, 24196,
     /* 1478937 */     GIR_EraseRootFromParent_Done,
     /* 1478938 */   // Label 20669: @1478938
     /* 1478938 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1479035), // Rule ID 24197 //
     /* 1478943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1478946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1478951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1478954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1478957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1478960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478993 */     // MIs[1] Operand 1
     /* 1478993 */     // No operand predicates
     /* 1478993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478997 */     // MIs[0] policy
     /* 1478997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479009 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1479012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479034 */     // GIR_Coverage, 24197,
     /* 1479034 */     GIR_EraseRootFromParent_Done,
     /* 1479035 */   // Label 20670: @1479035
     /* 1479035 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1479132), // Rule ID 24200 //
     /* 1479040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1479043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1479051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1479054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1479057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479090 */     // MIs[1] Operand 1
     /* 1479090 */     // No operand predicates
     /* 1479090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479094 */     // MIs[0] policy
     /* 1479094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479106 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1479109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479131 */     // GIR_Coverage, 24200,
     /* 1479131 */     GIR_EraseRootFromParent_Done,
     /* 1479132 */   // Label 20671: @1479132
     /* 1479132 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1479229), // Rule ID 24201 //
     /* 1479137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1479140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1479148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1479151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1479154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479187 */     // MIs[1] Operand 1
     /* 1479187 */     // No operand predicates
     /* 1479187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479191 */     // MIs[0] policy
     /* 1479191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479203 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1479206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479228 */     // GIR_Coverage, 24201,
     /* 1479228 */     GIR_EraseRootFromParent_Done,
     /* 1479229 */   // Label 20672: @1479229
     /* 1479229 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1479326), // Rule ID 24204 //
     /* 1479234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1479237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1479245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1479248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1479251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479284 */     // MIs[1] Operand 1
     /* 1479284 */     // No operand predicates
     /* 1479284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479288 */     // MIs[0] policy
     /* 1479288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479325 */     // GIR_Coverage, 24204,
     /* 1479325 */     GIR_EraseRootFromParent_Done,
     /* 1479326 */   // Label 20673: @1479326
     /* 1479326 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1479423), // Rule ID 24205 //
     /* 1479331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1479334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1479342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1479345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1479348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479381 */     // MIs[1] Operand 1
     /* 1479381 */     // No operand predicates
     /* 1479381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479385 */     // MIs[0] policy
     /* 1479385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479397 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479422 */     // GIR_Coverage, 24205,
     /* 1479422 */     GIR_EraseRootFromParent_Done,
     /* 1479423 */   // Label 20674: @1479423
     /* 1479423 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1479520), // Rule ID 24208 //
     /* 1479428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1479431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1479439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1479442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1479445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479478 */     // MIs[1] Operand 1
     /* 1479478 */     // No operand predicates
     /* 1479478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479482 */     // MIs[0] policy
     /* 1479482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479519 */     // GIR_Coverage, 24208,
     /* 1479519 */     GIR_EraseRootFromParent_Done,
     /* 1479520 */   // Label 20675: @1479520
     /* 1479520 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1479617), // Rule ID 24209 //
     /* 1479525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1479528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1479536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1479539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1479542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479575 */     // MIs[1] Operand 1
     /* 1479575 */     // No operand predicates
     /* 1479575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479579 */     // MIs[0] policy
     /* 1479579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479591 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479616 */     // GIR_Coverage, 24209,
     /* 1479616 */     GIR_EraseRootFromParent_Done,
     /* 1479617 */   // Label 20676: @1479617
     /* 1479617 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1479714), // Rule ID 24212 //
     /* 1479622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1479625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1479633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1479636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1479639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479672 */     // MIs[1] Operand 1
     /* 1479672 */     // No operand predicates
     /* 1479672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479676 */     // MIs[0] policy
     /* 1479676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479688 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479713 */     // GIR_Coverage, 24212,
     /* 1479713 */     GIR_EraseRootFromParent_Done,
     /* 1479714 */   // Label 20677: @1479714
     /* 1479714 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1479811), // Rule ID 24213 //
     /* 1479719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1479722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1479730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1479733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1479736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1479742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1479749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1479757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479769 */     // MIs[1] Operand 1
     /* 1479769 */     // No operand predicates
     /* 1479769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479773 */     // MIs[0] policy
     /* 1479773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479785 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1479788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479810 */     // GIR_Coverage, 24213,
     /* 1479810 */     GIR_EraseRootFromParent_Done,
     /* 1479811 */   // Label 20678: @1479811
     /* 1479811 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1479908), // Rule ID 24216 //
     /* 1479816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1479819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479866 */     // MIs[1] Operand 1
     /* 1479866 */     // No operand predicates
     /* 1479866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479870 */     // MIs[0] policy
     /* 1479870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1479885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479907 */     // GIR_Coverage, 24216,
     /* 1479907 */     GIR_EraseRootFromParent_Done,
     /* 1479908 */   // Label 20679: @1479908
     /* 1479908 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1480005), // Rule ID 24217 //
     /* 1479913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1479916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1479921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479963 */     // MIs[1] Operand 1
     /* 1479963 */     // No operand predicates
     /* 1479963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479967 */     // MIs[0] policy
     /* 1479967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1479982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480004 */     // GIR_Coverage, 24217,
     /* 1480004 */     GIR_EraseRootFromParent_Done,
     /* 1480005 */   // Label 20680: @1480005
     /* 1480005 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1480102), // Rule ID 24220 //
     /* 1480010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1480013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1480021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1480024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1480027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480060 */     // MIs[1] Operand 1
     /* 1480060 */     // No operand predicates
     /* 1480060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480064 */     // MIs[0] policy
     /* 1480064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480076 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480101 */     // GIR_Coverage, 24220,
     /* 1480101 */     GIR_EraseRootFromParent_Done,
     /* 1480102 */   // Label 20681: @1480102
     /* 1480102 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1480199), // Rule ID 24221 //
     /* 1480107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1480110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1480118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1480121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1480124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480157 */     // MIs[1] Operand 1
     /* 1480157 */     // No operand predicates
     /* 1480157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480161 */     // MIs[0] policy
     /* 1480161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480173 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480198 */     // GIR_Coverage, 24221,
     /* 1480198 */     GIR_EraseRootFromParent_Done,
     /* 1480199 */   // Label 20682: @1480199
     /* 1480199 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1480296), // Rule ID 24224 //
     /* 1480204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1480207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480254 */     // MIs[1] Operand 1
     /* 1480254 */     // No operand predicates
     /* 1480254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480258 */     // MIs[0] policy
     /* 1480258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480295 */     // GIR_Coverage, 24224,
     /* 1480295 */     GIR_EraseRootFromParent_Done,
     /* 1480296 */   // Label 20683: @1480296
     /* 1480296 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1480393), // Rule ID 24225 //
     /* 1480301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1480304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1480312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1480315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1480318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1480324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480351 */     // MIs[1] Operand 1
     /* 1480351 */     // No operand predicates
     /* 1480351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480355 */     // MIs[0] policy
     /* 1480355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480367 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480392 */     // GIR_Coverage, 24225,
     /* 1480392 */     GIR_EraseRootFromParent_Done,
     /* 1480393 */   // Label 20684: @1480393
     /* 1480393 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1480490), // Rule ID 24228 //
     /* 1480398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1480401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480448 */     // MIs[1] Operand 1
     /* 1480448 */     // No operand predicates
     /* 1480448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480452 */     // MIs[0] policy
     /* 1480452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1480467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480489 */     // GIR_Coverage, 24228,
     /* 1480489 */     GIR_EraseRootFromParent_Done,
     /* 1480490 */   // Label 20685: @1480490
     /* 1480490 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1480587), // Rule ID 24229 //
     /* 1480495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1480498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1480506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1480509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1480512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480545 */     // MIs[1] Operand 1
     /* 1480545 */     // No operand predicates
     /* 1480545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480549 */     // MIs[0] policy
     /* 1480549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480561 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1480564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480586 */     // GIR_Coverage, 24229,
     /* 1480586 */     GIR_EraseRootFromParent_Done,
     /* 1480587 */   // Label 20686: @1480587
     /* 1480587 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1480684), // Rule ID 24232 //
     /* 1480592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1480595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480642 */     // MIs[1] Operand 1
     /* 1480642 */     // No operand predicates
     /* 1480642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480646 */     // MIs[0] policy
     /* 1480646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480658 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480683 */     // GIR_Coverage, 24232,
     /* 1480683 */     GIR_EraseRootFromParent_Done,
     /* 1480684 */   // Label 20687: @1480684
     /* 1480684 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1480781), // Rule ID 24233 //
     /* 1480689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1480692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480739 */     // MIs[1] Operand 1
     /* 1480739 */     // No operand predicates
     /* 1480739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480743 */     // MIs[0] policy
     /* 1480743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480755 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1480758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480780 */     // GIR_Coverage, 24233,
     /* 1480780 */     GIR_EraseRootFromParent_Done,
     /* 1480781 */   // Label 20688: @1480781
     /* 1480781 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1480878), // Rule ID 24236 //
     /* 1480786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1480789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480836 */     // MIs[1] Operand 1
     /* 1480836 */     // No operand predicates
     /* 1480836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480840 */     // MIs[0] policy
     /* 1480840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480877 */     // GIR_Coverage, 24236,
     /* 1480877 */     GIR_EraseRootFromParent_Done,
     /* 1480878 */   // Label 20689: @1480878
     /* 1480878 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1480975), // Rule ID 24237 //
     /* 1480883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1480886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480933 */     // MIs[1] Operand 1
     /* 1480933 */     // No operand predicates
     /* 1480933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480937 */     // MIs[0] policy
     /* 1480937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480949 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1480952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480974 */     // GIR_Coverage, 24237,
     /* 1480974 */     GIR_EraseRootFromParent_Done,
     /* 1480975 */   // Label 20690: @1480975
     /* 1480975 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1481072), // Rule ID 24240 //
     /* 1480980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1480983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1481010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481030 */     // MIs[1] Operand 1
     /* 1481030 */     // No operand predicates
     /* 1481030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481034 */     // MIs[0] policy
     /* 1481034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481046 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1481049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481071 */     // GIR_Coverage, 24240,
     /* 1481071 */     GIR_EraseRootFromParent_Done,
     /* 1481072 */   // Label 20691: @1481072
     /* 1481072 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1481169), // Rule ID 24241 //
     /* 1481077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1481080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1481088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1481091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1481094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1481107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1481115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481127 */     // MIs[1] Operand 1
     /* 1481127 */     // No operand predicates
     /* 1481127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481131 */     // MIs[0] policy
     /* 1481131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481143 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1481146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481168 */     // GIR_Coverage, 24241,
     /* 1481168 */     GIR_EraseRootFromParent_Done,
     /* 1481169 */   // Label 20692: @1481169
     /* 1481169 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1481266), // Rule ID 24244 //
     /* 1481174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1481177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1481185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1481188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1481191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481224 */     // MIs[1] Operand 1
     /* 1481224 */     // No operand predicates
     /* 1481224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481228 */     // MIs[0] policy
     /* 1481228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481240 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1481243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481265 */     // GIR_Coverage, 24244,
     /* 1481265 */     GIR_EraseRootFromParent_Done,
     /* 1481266 */   // Label 20693: @1481266
     /* 1481266 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1481363), // Rule ID 24245 //
     /* 1481271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1481274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1481282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1481285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1481288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1481301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1481309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481321 */     // MIs[1] Operand 1
     /* 1481321 */     // No operand predicates
     /* 1481321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481325 */     // MIs[0] policy
     /* 1481325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481337 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1481340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481362 */     // GIR_Coverage, 24245,
     /* 1481362 */     GIR_EraseRootFromParent_Done,
     /* 1481363 */   // Label 20694: @1481363
     /* 1481363 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1481460), // Rule ID 24248 //
     /* 1481368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1481371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481418 */     // MIs[1] Operand 1
     /* 1481418 */     // No operand predicates
     /* 1481418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481422 */     // MIs[0] policy
     /* 1481422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1481437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481459 */     // GIR_Coverage, 24248,
     /* 1481459 */     GIR_EraseRootFromParent_Done,
     /* 1481460 */   // Label 20695: @1481460
     /* 1481460 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1481557), // Rule ID 24249 //
     /* 1481465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1481468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1481476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1481479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1481482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1481495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1481503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481515 */     // MIs[1] Operand 1
     /* 1481515 */     // No operand predicates
     /* 1481515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481519 */     // MIs[0] policy
     /* 1481519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481531 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1481534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481556 */     // GIR_Coverage, 24249,
     /* 1481556 */     GIR_EraseRootFromParent_Done,
     /* 1481557 */   // Label 20696: @1481557
     /* 1481557 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1481654), // Rule ID 24312 //
     /* 1481562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1481565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481612 */     // MIs[1] Operand 1
     /* 1481612 */     // No operand predicates
     /* 1481612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481616 */     // MIs[0] policy
     /* 1481616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481628 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1481631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481653 */     // GIR_Coverage, 24312,
     /* 1481653 */     GIR_EraseRootFromParent_Done,
     /* 1481654 */   // Label 20697: @1481654
     /* 1481654 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1481751), // Rule ID 24313 //
     /* 1481659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1481662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1481670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1481673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481709 */     // MIs[1] Operand 1
     /* 1481709 */     // No operand predicates
     /* 1481709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481713 */     // MIs[0] policy
     /* 1481713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481725 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1481728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481750 */     // GIR_Coverage, 24313,
     /* 1481750 */     GIR_EraseRootFromParent_Done,
     /* 1481751 */   // Label 20698: @1481751
     /* 1481751 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1481848), // Rule ID 24316 //
     /* 1481756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1481759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481806 */     // MIs[1] Operand 1
     /* 1481806 */     // No operand predicates
     /* 1481806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481810 */     // MIs[0] policy
     /* 1481810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481822 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481847 */     // GIR_Coverage, 24316,
     /* 1481847 */     GIR_EraseRootFromParent_Done,
     /* 1481848 */   // Label 20699: @1481848
     /* 1481848 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1481945), // Rule ID 24317 //
     /* 1481853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1481856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481903 */     // MIs[1] Operand 1
     /* 1481903 */     // No operand predicates
     /* 1481903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481907 */     // MIs[0] policy
     /* 1481907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481919 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1481922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481944 */     // GIR_Coverage, 24317,
     /* 1481944 */     GIR_EraseRootFromParent_Done,
     /* 1481945 */   // Label 20700: @1481945
     /* 1481945 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1482042), // Rule ID 24320 //
     /* 1481950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1481953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1481958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482000 */     // MIs[1] Operand 1
     /* 1482000 */     // No operand predicates
     /* 1482000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482004 */     // MIs[0] policy
     /* 1482004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482016 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1482019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482041 */     // GIR_Coverage, 24320,
     /* 1482041 */     GIR_EraseRootFromParent_Done,
     /* 1482042 */   // Label 20701: @1482042
     /* 1482042 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1482139), // Rule ID 24321 //
     /* 1482047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1482050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1482058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1482061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1482064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482097 */     // MIs[1] Operand 1
     /* 1482097 */     // No operand predicates
     /* 1482097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482101 */     // MIs[0] policy
     /* 1482101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482113 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1482116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482138 */     // GIR_Coverage, 24321,
     /* 1482138 */     GIR_EraseRootFromParent_Done,
     /* 1482139 */   // Label 20702: @1482139
     /* 1482139 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1482236), // Rule ID 24324 //
     /* 1482144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1482147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1482155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1482158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1482161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482194 */     // MIs[1] Operand 1
     /* 1482194 */     // No operand predicates
     /* 1482194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482198 */     // MIs[0] policy
     /* 1482198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482210 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482235 */     // GIR_Coverage, 24324,
     /* 1482235 */     GIR_EraseRootFromParent_Done,
     /* 1482236 */   // Label 20703: @1482236
     /* 1482236 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1482333), // Rule ID 24325 //
     /* 1482241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1482244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1482252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1482255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1482258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482291 */     // MIs[1] Operand 1
     /* 1482291 */     // No operand predicates
     /* 1482291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482295 */     // MIs[0] policy
     /* 1482295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482307 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482332 */     // GIR_Coverage, 24325,
     /* 1482332 */     GIR_EraseRootFromParent_Done,
     /* 1482333 */   // Label 20704: @1482333
     /* 1482333 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1482430), // Rule ID 24328 //
     /* 1482338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1482341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482388 */     // MIs[1] Operand 1
     /* 1482388 */     // No operand predicates
     /* 1482388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482392 */     // MIs[0] policy
     /* 1482392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482429 */     // GIR_Coverage, 24328,
     /* 1482429 */     GIR_EraseRootFromParent_Done,
     /* 1482430 */   // Label 20705: @1482430
     /* 1482430 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1482527), // Rule ID 24329 //
     /* 1482435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1482438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1482446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1482449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1482452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1482458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482485 */     // MIs[1] Operand 1
     /* 1482485 */     // No operand predicates
     /* 1482485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482489 */     // MIs[0] policy
     /* 1482489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482501 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482526 */     // GIR_Coverage, 24329,
     /* 1482526 */     GIR_EraseRootFromParent_Done,
     /* 1482527 */   // Label 20706: @1482527
     /* 1482527 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1482624), // Rule ID 24332 //
     /* 1482532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1482535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482582 */     // MIs[1] Operand 1
     /* 1482582 */     // No operand predicates
     /* 1482582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482586 */     // MIs[0] policy
     /* 1482586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482623 */     // GIR_Coverage, 24332,
     /* 1482623 */     GIR_EraseRootFromParent_Done,
     /* 1482624 */   // Label 20707: @1482624
     /* 1482624 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1482721), // Rule ID 24333 //
     /* 1482629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1482632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1482640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1482643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1482646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1482652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1482659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482679 */     // MIs[1] Operand 1
     /* 1482679 */     // No operand predicates
     /* 1482679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482683 */     // MIs[0] policy
     /* 1482683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482695 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1482698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482720 */     // GIR_Coverage, 24333,
     /* 1482720 */     GIR_EraseRootFromParent_Done,
     /* 1482721 */   // Label 20708: @1482721
     /* 1482721 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1482818), // Rule ID 24336 //
     /* 1482726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1482729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482776 */     // MIs[1] Operand 1
     /* 1482776 */     // No operand predicates
     /* 1482776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482780 */     // MIs[0] policy
     /* 1482780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482792 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1482795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482817 */     // GIR_Coverage, 24336,
     /* 1482817 */     GIR_EraseRootFromParent_Done,
     /* 1482818 */   // Label 20709: @1482818
     /* 1482818 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1482915), // Rule ID 24337 //
     /* 1482823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1482826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482873 */     // MIs[1] Operand 1
     /* 1482873 */     // No operand predicates
     /* 1482873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482877 */     // MIs[0] policy
     /* 1482877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482889 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1482892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482914 */     // GIR_Coverage, 24337,
     /* 1482914 */     GIR_EraseRootFromParent_Done,
     /* 1482915 */   // Label 20710: @1482915
     /* 1482915 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1483012), // Rule ID 24340 //
     /* 1482920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1482923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1482928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482970 */     // MIs[1] Operand 1
     /* 1482970 */     // No operand predicates
     /* 1482970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482974 */     // MIs[0] policy
     /* 1482974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482986 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1482989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483011 */     // GIR_Coverage, 24340,
     /* 1483011 */     GIR_EraseRootFromParent_Done,
     /* 1483012 */   // Label 20711: @1483012
     /* 1483012 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1483109), // Rule ID 24341 //
     /* 1483017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1483020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1483028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1483031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1483034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483067 */     // MIs[1] Operand 1
     /* 1483067 */     // No operand predicates
     /* 1483067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483071 */     // MIs[0] policy
     /* 1483071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483083 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483108 */     // GIR_Coverage, 24341,
     /* 1483108 */     GIR_EraseRootFromParent_Done,
     /* 1483109 */   // Label 20712: @1483109
     /* 1483109 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1483206), // Rule ID 24344 //
     /* 1483114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1483117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483164 */     // MIs[1] Operand 1
     /* 1483164 */     // No operand predicates
     /* 1483164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483168 */     // MIs[0] policy
     /* 1483168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483180 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483205 */     // GIR_Coverage, 24344,
     /* 1483205 */     GIR_EraseRootFromParent_Done,
     /* 1483206 */   // Label 20713: @1483206
     /* 1483206 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1483303), // Rule ID 24345 //
     /* 1483211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1483214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483261 */     // MIs[1] Operand 1
     /* 1483261 */     // No operand predicates
     /* 1483261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483265 */     // MIs[0] policy
     /* 1483265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483277 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483302 */     // GIR_Coverage, 24345,
     /* 1483302 */     GIR_EraseRootFromParent_Done,
     /* 1483303 */   // Label 20714: @1483303
     /* 1483303 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1483400), // Rule ID 24348 //
     /* 1483308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1483311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483358 */     // MIs[1] Operand 1
     /* 1483358 */     // No operand predicates
     /* 1483358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483362 */     // MIs[0] policy
     /* 1483362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483374 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483399 */     // GIR_Coverage, 24348,
     /* 1483399 */     GIR_EraseRootFromParent_Done,
     /* 1483400 */   // Label 20715: @1483400
     /* 1483400 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1483497), // Rule ID 24349 //
     /* 1483405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1483408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483455 */     // MIs[1] Operand 1
     /* 1483455 */     // No operand predicates
     /* 1483455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483459 */     // MIs[0] policy
     /* 1483459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483471 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483496 */     // GIR_Coverage, 24349,
     /* 1483496 */     GIR_EraseRootFromParent_Done,
     /* 1483497 */   // Label 20716: @1483497
     /* 1483497 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1483594), // Rule ID 24352 //
     /* 1483502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1483505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483552 */     // MIs[1] Operand 1
     /* 1483552 */     // No operand predicates
     /* 1483552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483556 */     // MIs[0] policy
     /* 1483556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483568 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483593 */     // GIR_Coverage, 24352,
     /* 1483593 */     GIR_EraseRootFromParent_Done,
     /* 1483594 */   // Label 20717: @1483594
     /* 1483594 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1483691), // Rule ID 24353 //
     /* 1483599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1483602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483649 */     // MIs[1] Operand 1
     /* 1483649 */     // No operand predicates
     /* 1483649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483653 */     // MIs[0] policy
     /* 1483653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483665 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1483668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483690 */     // GIR_Coverage, 24353,
     /* 1483690 */     GIR_EraseRootFromParent_Done,
     /* 1483691 */   // Label 20718: @1483691
     /* 1483691 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1483788), // Rule ID 24356 //
     /* 1483696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1483699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483746 */     // MIs[1] Operand 1
     /* 1483746 */     // No operand predicates
     /* 1483746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483750 */     // MIs[0] policy
     /* 1483750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483762 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483787 */     // GIR_Coverage, 24356,
     /* 1483787 */     GIR_EraseRootFromParent_Done,
     /* 1483788 */   // Label 20719: @1483788
     /* 1483788 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1483885), // Rule ID 24357 //
     /* 1483793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1483796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483843 */     // MIs[1] Operand 1
     /* 1483843 */     // No operand predicates
     /* 1483843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483847 */     // MIs[0] policy
     /* 1483847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483859 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1483862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483884 */     // GIR_Coverage, 24357,
     /* 1483884 */     GIR_EraseRootFromParent_Done,
     /* 1483885 */   // Label 20720: @1483885
     /* 1483885 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1483982), // Rule ID 24360 //
     /* 1483890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1483893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483940 */     // MIs[1] Operand 1
     /* 1483940 */     // No operand predicates
     /* 1483940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483944 */     // MIs[0] policy
     /* 1483944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1483959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483981 */     // GIR_Coverage, 24360,
     /* 1483981 */     GIR_EraseRootFromParent_Done,
     /* 1483982 */   // Label 20721: @1483982
     /* 1483982 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1484079), // Rule ID 24361 //
     /* 1483987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1483990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1484001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1484004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484037 */     // MIs[1] Operand 1
     /* 1484037 */     // No operand predicates
     /* 1484037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484041 */     // MIs[0] policy
     /* 1484041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484053 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1484056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484078 */     // GIR_Coverage, 24361,
     /* 1484078 */     GIR_EraseRootFromParent_Done,
     /* 1484079 */   // Label 20722: @1484079
     /* 1484079 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1484176), // Rule ID 24364 //
     /* 1484084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1484087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484134 */     // MIs[1] Operand 1
     /* 1484134 */     // No operand predicates
     /* 1484134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484138 */     // MIs[0] policy
     /* 1484138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484150 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1484153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484175 */     // GIR_Coverage, 24364,
     /* 1484175 */     GIR_EraseRootFromParent_Done,
     /* 1484176 */   // Label 20723: @1484176
     /* 1484176 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1484273), // Rule ID 24365 //
     /* 1484181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1484184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484231 */     // MIs[1] Operand 1
     /* 1484231 */     // No operand predicates
     /* 1484231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484235 */     // MIs[0] policy
     /* 1484235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484247 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1484250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484272 */     // GIR_Coverage, 24365,
     /* 1484272 */     GIR_EraseRootFromParent_Done,
     /* 1484273 */   // Label 20724: @1484273
     /* 1484273 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1484370), // Rule ID 24368 //
     /* 1484278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1484281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484328 */     // MIs[1] Operand 1
     /* 1484328 */     // No operand predicates
     /* 1484328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484332 */     // MIs[0] policy
     /* 1484332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484369 */     // GIR_Coverage, 24368,
     /* 1484369 */     GIR_EraseRootFromParent_Done,
     /* 1484370 */   // Label 20725: @1484370
     /* 1484370 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1484467), // Rule ID 24369 //
     /* 1484375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1484378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484425 */     // MIs[1] Operand 1
     /* 1484425 */     // No operand predicates
     /* 1484425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484429 */     // MIs[0] policy
     /* 1484429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484441 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1484444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484466 */     // GIR_Coverage, 24369,
     /* 1484466 */     GIR_EraseRootFromParent_Done,
     /* 1484467 */   // Label 20726: @1484467
     /* 1484467 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1484564), // Rule ID 24668 //
     /* 1484472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1484483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1484486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1484489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484522 */     // MIs[1] Operand 1
     /* 1484522 */     // No operand predicates
     /* 1484522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484526 */     // MIs[0] policy
     /* 1484526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484538 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1484541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484563 */     // GIR_Coverage, 24668,
     /* 1484563 */     GIR_EraseRootFromParent_Done,
     /* 1484564 */   // Label 20727: @1484564
     /* 1484564 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1484661), // Rule ID 24669 //
     /* 1484569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1484580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1484583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1484586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484619 */     // MIs[1] Operand 1
     /* 1484619 */     // No operand predicates
     /* 1484619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484623 */     // MIs[0] policy
     /* 1484623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484635 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1484638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484660 */     // GIR_Coverage, 24669,
     /* 1484660 */     GIR_EraseRootFromParent_Done,
     /* 1484661 */   // Label 20728: @1484661
     /* 1484661 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1484758), // Rule ID 24672 //
     /* 1484666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1484677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1484680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1484683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484716 */     // MIs[1] Operand 1
     /* 1484716 */     // No operand predicates
     /* 1484716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484720 */     // MIs[0] policy
     /* 1484720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484732 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1484735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484757 */     // GIR_Coverage, 24672,
     /* 1484757 */     GIR_EraseRootFromParent_Done,
     /* 1484758 */   // Label 20729: @1484758
     /* 1484758 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1484855), // Rule ID 24673 //
     /* 1484763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1484774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1484777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1484780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484813 */     // MIs[1] Operand 1
     /* 1484813 */     // No operand predicates
     /* 1484813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484817 */     // MIs[0] policy
     /* 1484817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484829 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1484832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484854 */     // GIR_Coverage, 24673,
     /* 1484854 */     GIR_EraseRootFromParent_Done,
     /* 1484855 */   // Label 20730: @1484855
     /* 1484855 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1484952), // Rule ID 24676 //
     /* 1484860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1484863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1484871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1484874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1484877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484910 */     // MIs[1] Operand 1
     /* 1484910 */     // No operand predicates
     /* 1484910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484914 */     // MIs[0] policy
     /* 1484914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484926 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1484929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1484948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484951 */     // GIR_Coverage, 24676,
     /* 1484951 */     GIR_EraseRootFromParent_Done,
     /* 1484952 */   // Label 20731: @1484952
     /* 1484952 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1485049), // Rule ID 24677 //
     /* 1484957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1484960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1484968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1484971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1484974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485007 */     // MIs[1] Operand 1
     /* 1485007 */     // No operand predicates
     /* 1485007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485011 */     // MIs[0] policy
     /* 1485011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485023 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1485026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1485045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485048 */     // GIR_Coverage, 24677,
     /* 1485048 */     GIR_EraseRootFromParent_Done,
     /* 1485049 */   // Label 20732: @1485049
     /* 1485049 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1485146), // Rule ID 24680 //
     /* 1485054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1485065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1485068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1485071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485104 */     // MIs[1] Operand 1
     /* 1485104 */     // No operand predicates
     /* 1485104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485108 */     // MIs[0] policy
     /* 1485108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1485123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485145 */     // GIR_Coverage, 24680,
     /* 1485145 */     GIR_EraseRootFromParent_Done,
     /* 1485146 */   // Label 20733: @1485146
     /* 1485146 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1485243), // Rule ID 24681 //
     /* 1485151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1485162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1485165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1485168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485201 */     // MIs[1] Operand 1
     /* 1485201 */     // No operand predicates
     /* 1485201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485205 */     // MIs[0] policy
     /* 1485205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485217 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1485220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485242 */     // GIR_Coverage, 24681,
     /* 1485242 */     GIR_EraseRootFromParent_Done,
     /* 1485243 */   // Label 20734: @1485243
     /* 1485243 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1485340), // Rule ID 24684 //
     /* 1485248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1485259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1485262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1485265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485298 */     // MIs[1] Operand 1
     /* 1485298 */     // No operand predicates
     /* 1485298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485302 */     // MIs[0] policy
     /* 1485302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1485317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485339 */     // GIR_Coverage, 24684,
     /* 1485339 */     GIR_EraseRootFromParent_Done,
     /* 1485340 */   // Label 20735: @1485340
     /* 1485340 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1485437), // Rule ID 24685 //
     /* 1485345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1485356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1485359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1485362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485395 */     // MIs[1] Operand 1
     /* 1485395 */     // No operand predicates
     /* 1485395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485399 */     // MIs[0] policy
     /* 1485399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1485414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485436 */     // GIR_Coverage, 24685,
     /* 1485436 */     GIR_EraseRootFromParent_Done,
     /* 1485437 */   // Label 20736: @1485437
     /* 1485437 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1485534), // Rule ID 24688 //
     /* 1485442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1485453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1485456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1485459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485492 */     // MIs[1] Operand 1
     /* 1485492 */     // No operand predicates
     /* 1485492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485496 */     // MIs[0] policy
     /* 1485496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1485511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485533 */     // GIR_Coverage, 24688,
     /* 1485533 */     GIR_EraseRootFromParent_Done,
     /* 1485534 */   // Label 20737: @1485534
     /* 1485534 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1485631), // Rule ID 24689 //
     /* 1485539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1485550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1485553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1485556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1485562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485589 */     // MIs[1] Operand 1
     /* 1485589 */     // No operand predicates
     /* 1485589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485593 */     // MIs[0] policy
     /* 1485593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485605 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1485608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485630 */     // GIR_Coverage, 24689,
     /* 1485630 */     GIR_EraseRootFromParent_Done,
     /* 1485631 */   // Label 20738: @1485631
     /* 1485631 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1485728), // Rule ID 24692 //
     /* 1485636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1485647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1485650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1485653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485686 */     // MIs[1] Operand 1
     /* 1485686 */     // No operand predicates
     /* 1485686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485690 */     // MIs[0] policy
     /* 1485690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1485705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1485724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485727 */     // GIR_Coverage, 24692,
     /* 1485727 */     GIR_EraseRootFromParent_Done,
     /* 1485728 */   // Label 20739: @1485728
     /* 1485728 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1485825), // Rule ID 24693 //
     /* 1485733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1485744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1485747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1485750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485783 */     // MIs[1] Operand 1
     /* 1485783 */     // No operand predicates
     /* 1485783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485787 */     // MIs[0] policy
     /* 1485787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1485802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1485821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485824 */     // GIR_Coverage, 24693,
     /* 1485824 */     GIR_EraseRootFromParent_Done,
     /* 1485825 */   // Label 20740: @1485825
     /* 1485825 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1485922), // Rule ID 24696 //
     /* 1485830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1485833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1485841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1485844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1485847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485880 */     // MIs[1] Operand 1
     /* 1485880 */     // No operand predicates
     /* 1485880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485884 */     // MIs[0] policy
     /* 1485884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1485899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485921 */     // GIR_Coverage, 24696,
     /* 1485921 */     GIR_EraseRootFromParent_Done,
     /* 1485922 */   // Label 20741: @1485922
     /* 1485922 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1486019), // Rule ID 24697 //
     /* 1485927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1485930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1485938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1485941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1485944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1485957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1485965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485977 */     // MIs[1] Operand 1
     /* 1485977 */     // No operand predicates
     /* 1485977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485981 */     // MIs[0] policy
     /* 1485981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485993 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1485996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486018 */     // GIR_Coverage, 24697,
     /* 1486018 */     GIR_EraseRootFromParent_Done,
     /* 1486019 */   // Label 20742: @1486019
     /* 1486019 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1486116), // Rule ID 24700 //
     /* 1486024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1486035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1486038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1486041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486074 */     // MIs[1] Operand 1
     /* 1486074 */     // No operand predicates
     /* 1486074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486078 */     // MIs[0] policy
     /* 1486078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486115 */     // GIR_Coverage, 24700,
     /* 1486115 */     GIR_EraseRootFromParent_Done,
     /* 1486116 */   // Label 20743: @1486116
     /* 1486116 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1486213), // Rule ID 24701 //
     /* 1486121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1486132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1486135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1486138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486171 */     // MIs[1] Operand 1
     /* 1486171 */     // No operand predicates
     /* 1486171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486175 */     // MIs[0] policy
     /* 1486175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486187 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486212 */     // GIR_Coverage, 24701,
     /* 1486212 */     GIR_EraseRootFromParent_Done,
     /* 1486213 */   // Label 20744: @1486213
     /* 1486213 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1486310), // Rule ID 24704 //
     /* 1486218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1486221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1486229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1486232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1486235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486268 */     // MIs[1] Operand 1
     /* 1486268 */     // No operand predicates
     /* 1486268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486272 */     // MIs[0] policy
     /* 1486272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486309 */     // GIR_Coverage, 24704,
     /* 1486309 */     GIR_EraseRootFromParent_Done,
     /* 1486310 */   // Label 20745: @1486310
     /* 1486310 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1486407), // Rule ID 24705 //
     /* 1486315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1486318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1486326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1486329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1486332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486365 */     // MIs[1] Operand 1
     /* 1486365 */     // No operand predicates
     /* 1486365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486369 */     // MIs[0] policy
     /* 1486369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486381 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486406 */     // GIR_Coverage, 24705,
     /* 1486406 */     GIR_EraseRootFromParent_Done,
     /* 1486407 */   // Label 20746: @1486407
     /* 1486407 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1486504), // Rule ID 24708 //
     /* 1486412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1486423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1486426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1486429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486462 */     // MIs[1] Operand 1
     /* 1486462 */     // No operand predicates
     /* 1486462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486466 */     // MIs[0] policy
     /* 1486466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1486481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486503 */     // GIR_Coverage, 24708,
     /* 1486503 */     GIR_EraseRootFromParent_Done,
     /* 1486504 */   // Label 20747: @1486504
     /* 1486504 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1486601), // Rule ID 24709 //
     /* 1486509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1486520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1486523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1486526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486559 */     // MIs[1] Operand 1
     /* 1486559 */     // No operand predicates
     /* 1486559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486563 */     // MIs[0] policy
     /* 1486563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486575 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1486578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486600 */     // GIR_Coverage, 24709,
     /* 1486600 */     GIR_EraseRootFromParent_Done,
     /* 1486601 */   // Label 20748: @1486601
     /* 1486601 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1486698), // Rule ID 24712 //
     /* 1486606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1486617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1486620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1486623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1486629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486656 */     // MIs[1] Operand 1
     /* 1486656 */     // No operand predicates
     /* 1486656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486660 */     // MIs[0] policy
     /* 1486660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1486675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486697 */     // GIR_Coverage, 24712,
     /* 1486697 */     GIR_EraseRootFromParent_Done,
     /* 1486698 */   // Label 20749: @1486698
     /* 1486698 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1486795), // Rule ID 24713 //
     /* 1486703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1486714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1486717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1486720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1486726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486753 */     // MIs[1] Operand 1
     /* 1486753 */     // No operand predicates
     /* 1486753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486757 */     // MIs[0] policy
     /* 1486757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486769 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1486772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486794 */     // GIR_Coverage, 24713,
     /* 1486794 */     GIR_EraseRootFromParent_Done,
     /* 1486795 */   // Label 20750: @1486795
     /* 1486795 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1486892), // Rule ID 24716 //
     /* 1486800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1486811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1486814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1486817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1486823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486850 */     // MIs[1] Operand 1
     /* 1486850 */     // No operand predicates
     /* 1486850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486854 */     // MIs[0] policy
     /* 1486854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486866 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1486869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486891 */     // GIR_Coverage, 24716,
     /* 1486891 */     GIR_EraseRootFromParent_Done,
     /* 1486892 */   // Label 20751: @1486892
     /* 1486892 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1486989), // Rule ID 24717 //
     /* 1486897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1486908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1486911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1486914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1486920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486947 */     // MIs[1] Operand 1
     /* 1486947 */     // No operand predicates
     /* 1486947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486951 */     // MIs[0] policy
     /* 1486951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486963 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1486966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486988 */     // GIR_Coverage, 24717,
     /* 1486988 */     GIR_EraseRootFromParent_Done,
     /* 1486989 */   // Label 20752: @1486989
     /* 1486989 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1487086), // Rule ID 24720 //
     /* 1486994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1487005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1487008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1487011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487044 */     // MIs[1] Operand 1
     /* 1487044 */     // No operand predicates
     /* 1487044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487048 */     // MIs[0] policy
     /* 1487048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1487063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487085 */     // GIR_Coverage, 24720,
     /* 1487085 */     GIR_EraseRootFromParent_Done,
     /* 1487086 */   // Label 20753: @1487086
     /* 1487086 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1487183), // Rule ID 24721 //
     /* 1487091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1487102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1487105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1487108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487141 */     // MIs[1] Operand 1
     /* 1487141 */     // No operand predicates
     /* 1487141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487145 */     // MIs[0] policy
     /* 1487145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487157 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1487160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487182 */     // GIR_Coverage, 24721,
     /* 1487182 */     GIR_EraseRootFromParent_Done,
     /* 1487183 */   // Label 20754: @1487183
     /* 1487183 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1487280), // Rule ID 24724 //
     /* 1487188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1487199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1487202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1487205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487238 */     // MIs[1] Operand 1
     /* 1487238 */     // No operand predicates
     /* 1487238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487242 */     // MIs[0] policy
     /* 1487242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1487257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487279 */     // GIR_Coverage, 24724,
     /* 1487279 */     GIR_EraseRootFromParent_Done,
     /* 1487280 */   // Label 20755: @1487280
     /* 1487280 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1487377), // Rule ID 24725 //
     /* 1487285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1487296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1487299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1487302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487335 */     // MIs[1] Operand 1
     /* 1487335 */     // No operand predicates
     /* 1487335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487339 */     // MIs[0] policy
     /* 1487339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487351 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1487354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487376 */     // GIR_Coverage, 24725,
     /* 1487376 */     GIR_EraseRootFromParent_Done,
     /* 1487377 */   // Label 20756: @1487377
     /* 1487377 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1487474), // Rule ID 24728 //
     /* 1487382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1487399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487432 */     // MIs[1] Operand 1
     /* 1487432 */     // No operand predicates
     /* 1487432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487436 */     // MIs[0] policy
     /* 1487436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487448 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1487451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487473 */     // GIR_Coverage, 24728,
     /* 1487473 */     GIR_EraseRootFromParent_Done,
     /* 1487474 */   // Label 20757: @1487474
     /* 1487474 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1487571), // Rule ID 24729 //
     /* 1487479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1487496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487529 */     // MIs[1] Operand 1
     /* 1487529 */     // No operand predicates
     /* 1487529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487533 */     // MIs[0] policy
     /* 1487533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487545 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1487548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487570 */     // GIR_Coverage, 24729,
     /* 1487570 */     GIR_EraseRootFromParent_Done,
     /* 1487571 */   // Label 20758: @1487571
     /* 1487571 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1487668), // Rule ID 24732 //
     /* 1487576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1487587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1487590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1487593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487626 */     // MIs[1] Operand 1
     /* 1487626 */     // No operand predicates
     /* 1487626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487630 */     // MIs[0] policy
     /* 1487630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1487645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487667 */     // GIR_Coverage, 24732,
     /* 1487667 */     GIR_EraseRootFromParent_Done,
     /* 1487668 */   // Label 20759: @1487668
     /* 1487668 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1487765), // Rule ID 24733 //
     /* 1487673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1487684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1487687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1487690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487723 */     // MIs[1] Operand 1
     /* 1487723 */     // No operand predicates
     /* 1487723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487727 */     // MIs[0] policy
     /* 1487727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1487742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487764 */     // GIR_Coverage, 24733,
     /* 1487764 */     GIR_EraseRootFromParent_Done,
     /* 1487765 */   // Label 20760: @1487765
     /* 1487765 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1487862), // Rule ID 24736 //
     /* 1487770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1487781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1487784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1487787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487820 */     // MIs[1] Operand 1
     /* 1487820 */     // No operand predicates
     /* 1487820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487824 */     // MIs[0] policy
     /* 1487824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1487839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487861 */     // GIR_Coverage, 24736,
     /* 1487861 */     GIR_EraseRootFromParent_Done,
     /* 1487862 */   // Label 20761: @1487862
     /* 1487862 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1487959), // Rule ID 24737 //
     /* 1487867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1487878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1487881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1487884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487917 */     // MIs[1] Operand 1
     /* 1487917 */     // No operand predicates
     /* 1487917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487921 */     // MIs[0] policy
     /* 1487921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1487936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487958 */     // GIR_Coverage, 24737,
     /* 1487958 */     GIR_EraseRootFromParent_Done,
     /* 1487959 */   // Label 20762: @1487959
     /* 1487959 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1488056), // Rule ID 24740 //
     /* 1487964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1487975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1487978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1487981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488014 */     // MIs[1] Operand 1
     /* 1488014 */     // No operand predicates
     /* 1488014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488018 */     // MIs[0] policy
     /* 1488018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1488033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488055 */     // GIR_Coverage, 24740,
     /* 1488055 */     GIR_EraseRootFromParent_Done,
     /* 1488056 */   // Label 20763: @1488056
     /* 1488056 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1488153), // Rule ID 24741 //
     /* 1488061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1488072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1488075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1488078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488111 */     // MIs[1] Operand 1
     /* 1488111 */     // No operand predicates
     /* 1488111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488115 */     // MIs[0] policy
     /* 1488115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1488130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488152 */     // GIR_Coverage, 24741,
     /* 1488152 */     GIR_EraseRootFromParent_Done,
     /* 1488153 */   // Label 20764: @1488153
     /* 1488153 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1488250), // Rule ID 24744 //
     /* 1488158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1488169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1488172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1488175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488208 */     // MIs[1] Operand 1
     /* 1488208 */     // No operand predicates
     /* 1488208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488212 */     // MIs[0] policy
     /* 1488212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488246 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488249 */     // GIR_Coverage, 24744,
     /* 1488249 */     GIR_EraseRootFromParent_Done,
     /* 1488250 */   // Label 20765: @1488250
     /* 1488250 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1488347), // Rule ID 24745 //
     /* 1488255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1488258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1488266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1488269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1488272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488305 */     // MIs[1] Operand 1
     /* 1488305 */     // No operand predicates
     /* 1488305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488309 */     // MIs[0] policy
     /* 1488309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488346 */     // GIR_Coverage, 24745,
     /* 1488346 */     GIR_EraseRootFromParent_Done,
     /* 1488347 */   // Label 20766: @1488347
     /* 1488347 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1488444), // Rule ID 24748 //
     /* 1488352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1488363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1488366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1488369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488402 */     // MIs[1] Operand 1
     /* 1488402 */     // No operand predicates
     /* 1488402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488406 */     // MIs[0] policy
     /* 1488406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1488421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488440 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488443 */     // GIR_Coverage, 24748,
     /* 1488443 */     GIR_EraseRootFromParent_Done,
     /* 1488444 */   // Label 20767: @1488444
     /* 1488444 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1488541), // Rule ID 24749 //
     /* 1488449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1488452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1488460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1488463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1488466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488499 */     // MIs[1] Operand 1
     /* 1488499 */     // No operand predicates
     /* 1488499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488503 */     // MIs[0] policy
     /* 1488503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1488518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488540 */     // GIR_Coverage, 24749,
     /* 1488540 */     GIR_EraseRootFromParent_Done,
     /* 1488541 */   // Label 20768: @1488541
     /* 1488541 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1488638), // Rule ID 24752 //
     /* 1488546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1488557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1488560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1488563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488596 */     // MIs[1] Operand 1
     /* 1488596 */     // No operand predicates
     /* 1488596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488600 */     // MIs[0] policy
     /* 1488600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488612 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1488615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488634 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488637 */     // GIR_Coverage, 24752,
     /* 1488637 */     GIR_EraseRootFromParent_Done,
     /* 1488638 */   // Label 20769: @1488638
     /* 1488638 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1488735), // Rule ID 24753 //
     /* 1488643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1488646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1488654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1488657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1488660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488693 */     // MIs[1] Operand 1
     /* 1488693 */     // No operand predicates
     /* 1488693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488697 */     // MIs[0] policy
     /* 1488697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1488712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488734 */     // GIR_Coverage, 24753,
     /* 1488734 */     GIR_EraseRootFromParent_Done,
     /* 1488735 */   // Label 20770: @1488735
     /* 1488735 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1488832), // Rule ID 24912 //
     /* 1488740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1488743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488790 */     // MIs[1] Operand 1
     /* 1488790 */     // No operand predicates
     /* 1488790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488794 */     // MIs[0] policy
     /* 1488794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488806 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488831 */     // GIR_Coverage, 24912,
     /* 1488831 */     GIR_EraseRootFromParent_Done,
     /* 1488832 */   // Label 20771: @1488832
     /* 1488832 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1488929), // Rule ID 24913 //
     /* 1488837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1488840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1488854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488887 */     // MIs[1] Operand 1
     /* 1488887 */     // No operand predicates
     /* 1488887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488891 */     // MIs[0] policy
     /* 1488891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488903 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1488906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488928 */     // GIR_Coverage, 24913,
     /* 1488928 */     GIR_EraseRootFromParent_Done,
     /* 1488929 */   // Label 20772: @1488929
     /* 1488929 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1489026), // Rule ID 24916 //
     /* 1488934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1488937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488984 */     // MIs[1] Operand 1
     /* 1488984 */     // No operand predicates
     /* 1488984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488988 */     // MIs[0] policy
     /* 1488988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489000 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489025 */     // GIR_Coverage, 24916,
     /* 1489025 */     GIR_EraseRootFromParent_Done,
     /* 1489026 */   // Label 20773: @1489026
     /* 1489026 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1489123), // Rule ID 24917 //
     /* 1489031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1489042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1489045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1489048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489081 */     // MIs[1] Operand 1
     /* 1489081 */     // No operand predicates
     /* 1489081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489085 */     // MIs[0] policy
     /* 1489085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489097 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489122 */     // GIR_Coverage, 24917,
     /* 1489122 */     GIR_EraseRootFromParent_Done,
     /* 1489123 */   // Label 20774: @1489123
     /* 1489123 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1489220), // Rule ID 24920 //
     /* 1489128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1489131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1489145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489178 */     // MIs[1] Operand 1
     /* 1489178 */     // No operand predicates
     /* 1489178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489182 */     // MIs[0] policy
     /* 1489182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489194 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489219 */     // GIR_Coverage, 24920,
     /* 1489219 */     GIR_EraseRootFromParent_Done,
     /* 1489220 */   // Label 20775: @1489220
     /* 1489220 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1489317), // Rule ID 24921 //
     /* 1489225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1489228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1489242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489275 */     // MIs[1] Operand 1
     /* 1489275 */     // No operand predicates
     /* 1489275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489279 */     // MIs[0] policy
     /* 1489279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489291 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1489294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489316 */     // GIR_Coverage, 24921,
     /* 1489316 */     GIR_EraseRootFromParent_Done,
     /* 1489317 */   // Label 20776: @1489317
     /* 1489317 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1489414), // Rule ID 24924 //
     /* 1489322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489372 */     // MIs[1] Operand 1
     /* 1489372 */     // No operand predicates
     /* 1489372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489376 */     // MIs[0] policy
     /* 1489376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489413 */     // GIR_Coverage, 24924,
     /* 1489413 */     GIR_EraseRootFromParent_Done,
     /* 1489414 */   // Label 20777: @1489414
     /* 1489414 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1489511), // Rule ID 24925 //
     /* 1489419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489469 */     // MIs[1] Operand 1
     /* 1489469 */     // No operand predicates
     /* 1489469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489473 */     // MIs[0] policy
     /* 1489473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489485 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489510 */     // GIR_Coverage, 24925,
     /* 1489510 */     GIR_EraseRootFromParent_Done,
     /* 1489511 */   // Label 20778: @1489511
     /* 1489511 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1489608), // Rule ID 24928 //
     /* 1489516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1489533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489566 */     // MIs[1] Operand 1
     /* 1489566 */     // No operand predicates
     /* 1489566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489570 */     // MIs[0] policy
     /* 1489570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489607 */     // GIR_Coverage, 24928,
     /* 1489607 */     GIR_EraseRootFromParent_Done,
     /* 1489608 */   // Label 20779: @1489608
     /* 1489608 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1489705), // Rule ID 24929 //
     /* 1489613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1489630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489663 */     // MIs[1] Operand 1
     /* 1489663 */     // No operand predicates
     /* 1489663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489667 */     // MIs[0] policy
     /* 1489667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489679 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489704 */     // GIR_Coverage, 24929,
     /* 1489704 */     GIR_EraseRootFromParent_Done,
     /* 1489705 */   // Label 20780: @1489705
     /* 1489705 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1489802), // Rule ID 24932 //
     /* 1489710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1489713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1489727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489760 */     // MIs[1] Operand 1
     /* 1489760 */     // No operand predicates
     /* 1489760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489764 */     // MIs[0] policy
     /* 1489764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489776 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489801 */     // GIR_Coverage, 24932,
     /* 1489801 */     GIR_EraseRootFromParent_Done,
     /* 1489802 */   // Label 20781: @1489802
     /* 1489802 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1489899), // Rule ID 24933 //
     /* 1489807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1489810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1489824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489857 */     // MIs[1] Operand 1
     /* 1489857 */     // No operand predicates
     /* 1489857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489861 */     // MIs[0] policy
     /* 1489861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489873 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489898 */     // GIR_Coverage, 24933,
     /* 1489898 */     GIR_EraseRootFromParent_Done,
     /* 1489899 */   // Label 20782: @1489899
     /* 1489899 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1489996), // Rule ID 24936 //
     /* 1489904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1489907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1489915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1489918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1489921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489954 */     // MIs[1] Operand 1
     /* 1489954 */     // No operand predicates
     /* 1489954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489958 */     // MIs[0] policy
     /* 1489958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489970 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1489992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489995 */     // GIR_Coverage, 24936,
     /* 1489995 */     GIR_EraseRootFromParent_Done,
     /* 1489996 */   // Label 20783: @1489996
     /* 1489996 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1490093), // Rule ID 24937 //
     /* 1490001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490051 */     // MIs[1] Operand 1
     /* 1490051 */     // No operand predicates
     /* 1490051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490055 */     // MIs[0] policy
     /* 1490055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490067 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490092 */     // GIR_Coverage, 24937,
     /* 1490092 */     GIR_EraseRootFromParent_Done,
     /* 1490093 */   // Label 20784: @1490093
     /* 1490093 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1490190), // Rule ID 24940 //
     /* 1490098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1490101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490148 */     // MIs[1] Operand 1
     /* 1490148 */     // No operand predicates
     /* 1490148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490152 */     // MIs[0] policy
     /* 1490152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490164 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490189 */     // GIR_Coverage, 24940,
     /* 1490189 */     GIR_EraseRootFromParent_Done,
     /* 1490190 */   // Label 20785: @1490190
     /* 1490190 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1490287), // Rule ID 24941 //
     /* 1490195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490245 */     // MIs[1] Operand 1
     /* 1490245 */     // No operand predicates
     /* 1490245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490249 */     // MIs[0] policy
     /* 1490249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490261 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490286 */     // GIR_Coverage, 24941,
     /* 1490286 */     GIR_EraseRootFromParent_Done,
     /* 1490287 */   // Label 20786: @1490287
     /* 1490287 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1490384), // Rule ID 24944 //
     /* 1490292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1490295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490342 */     // MIs[1] Operand 1
     /* 1490342 */     // No operand predicates
     /* 1490342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490346 */     // MIs[0] policy
     /* 1490346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490358 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490383 */     // GIR_Coverage, 24944,
     /* 1490383 */     GIR_EraseRootFromParent_Done,
     /* 1490384 */   // Label 20787: @1490384
     /* 1490384 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1490481), // Rule ID 24945 //
     /* 1490389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1490392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490439 */     // MIs[1] Operand 1
     /* 1490439 */     // No operand predicates
     /* 1490439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490443 */     // MIs[0] policy
     /* 1490443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490455 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490480 */     // GIR_Coverage, 24945,
     /* 1490480 */     GIR_EraseRootFromParent_Done,
     /* 1490481 */   // Label 20788: @1490481
     /* 1490481 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1490578), // Rule ID 24996 //
     /* 1490486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1490489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1490500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1490503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490536 */     // MIs[1] Operand 1
     /* 1490536 */     // No operand predicates
     /* 1490536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490540 */     // MIs[0] policy
     /* 1490540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490552 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1490555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490577 */     // GIR_Coverage, 24996,
     /* 1490577 */     GIR_EraseRootFromParent_Done,
     /* 1490578 */   // Label 20789: @1490578
     /* 1490578 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1490675), // Rule ID 24997 //
     /* 1490583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1490586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1490597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1490600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490633 */     // MIs[1] Operand 1
     /* 1490633 */     // No operand predicates
     /* 1490633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490637 */     // MIs[0] policy
     /* 1490637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490649 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1490652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490674 */     // GIR_Coverage, 24997,
     /* 1490674 */     GIR_EraseRootFromParent_Done,
     /* 1490675 */   // Label 20790: @1490675
     /* 1490675 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1490772), // Rule ID 25000 //
     /* 1490680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1490683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1490691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1490694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1490697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490730 */     // MIs[1] Operand 1
     /* 1490730 */     // No operand predicates
     /* 1490730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490734 */     // MIs[0] policy
     /* 1490734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1490749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490771 */     // GIR_Coverage, 25000,
     /* 1490771 */     GIR_EraseRootFromParent_Done,
     /* 1490772 */   // Label 20791: @1490772
     /* 1490772 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1490869), // Rule ID 25001 //
     /* 1490777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1490780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1490788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1490791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1490794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490827 */     // MIs[1] Operand 1
     /* 1490827 */     // No operand predicates
     /* 1490827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490831 */     // MIs[0] policy
     /* 1490831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490843 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1490846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490868 */     // GIR_Coverage, 25001,
     /* 1490868 */     GIR_EraseRootFromParent_Done,
     /* 1490869 */   // Label 20792: @1490869
     /* 1490869 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1490966), // Rule ID 25004 //
     /* 1490874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1490877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1490885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1490888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1490891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490924 */     // MIs[1] Operand 1
     /* 1490924 */     // No operand predicates
     /* 1490924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490928 */     // MIs[0] policy
     /* 1490928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490940 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1490943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490965 */     // GIR_Coverage, 25004,
     /* 1490965 */     GIR_EraseRootFromParent_Done,
     /* 1490966 */   // Label 20793: @1490966
     /* 1490966 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1491063), // Rule ID 25005 //
     /* 1490971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1490974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1490982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1490985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1490988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491021 */     // MIs[1] Operand 1
     /* 1491021 */     // No operand predicates
     /* 1491021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491025 */     // MIs[0] policy
     /* 1491025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491037 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491062 */     // GIR_Coverage, 25005,
     /* 1491062 */     GIR_EraseRootFromParent_Done,
     /* 1491063 */   // Label 20794: @1491063
     /* 1491063 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1491160), // Rule ID 25008 //
     /* 1491068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1491071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1491079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1491082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1491085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491118 */     // MIs[1] Operand 1
     /* 1491118 */     // No operand predicates
     /* 1491118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491122 */     // MIs[0] policy
     /* 1491122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491134 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1491137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491156 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491159 */     // GIR_Coverage, 25008,
     /* 1491159 */     GIR_EraseRootFromParent_Done,
     /* 1491160 */   // Label 20795: @1491160
     /* 1491160 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1491257), // Rule ID 25009 //
     /* 1491165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1491176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1491179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1491182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1491195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1491203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491215 */     // MIs[1] Operand 1
     /* 1491215 */     // No operand predicates
     /* 1491215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491219 */     // MIs[0] policy
     /* 1491219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491231 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1491234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491256 */     // GIR_Coverage, 25009,
     /* 1491256 */     GIR_EraseRootFromParent_Done,
     /* 1491257 */   // Label 20796: @1491257
     /* 1491257 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1491354), // Rule ID 25012 //
     /* 1491262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1491265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1491273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1491276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1491279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1491285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491312 */     // MIs[1] Operand 1
     /* 1491312 */     // No operand predicates
     /* 1491312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491316 */     // MIs[0] policy
     /* 1491316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491328 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491350 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491353 */     // GIR_Coverage, 25012,
     /* 1491353 */     GIR_EraseRootFromParent_Done,
     /* 1491354 */   // Label 20797: @1491354
     /* 1491354 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1491451), // Rule ID 25013 //
     /* 1491359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1491370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1491373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1491376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1491382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1491389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1491397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491409 */     // MIs[1] Operand 1
     /* 1491409 */     // No operand predicates
     /* 1491409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491413 */     // MIs[0] policy
     /* 1491413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1491428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491450 */     // GIR_Coverage, 25013,
     /* 1491450 */     GIR_EraseRootFromParent_Done,
     /* 1491451 */   // Label 20798: @1491451
     /* 1491451 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1491548), // Rule ID 25016 //
     /* 1491456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1491459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1491467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1491470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1491473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491506 */     // MIs[1] Operand 1
     /* 1491506 */     // No operand predicates
     /* 1491506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491510 */     // MIs[0] policy
     /* 1491510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491522 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491544 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491547 */     // GIR_Coverage, 25016,
     /* 1491547 */     GIR_EraseRootFromParent_Done,
     /* 1491548 */   // Label 20799: @1491548
     /* 1491548 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1491645), // Rule ID 25017 //
     /* 1491553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1491564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1491567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1491570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1491576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1491583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1491591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491603 */     // MIs[1] Operand 1
     /* 1491603 */     // No operand predicates
     /* 1491603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491607 */     // MIs[0] policy
     /* 1491607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491619 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1491622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491644 */     // GIR_Coverage, 25017,
     /* 1491644 */     GIR_EraseRootFromParent_Done,
     /* 1491645 */   // Label 20800: @1491645
     /* 1491645 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1491742), // Rule ID 61028 //
     /* 1491650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1491653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1491658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1491667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491700 */     // MIs[1] Operand 1
     /* 1491700 */     // No operand predicates
     /* 1491700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491704 */     // MIs[0] policy
     /* 1491704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1491719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491741 */     // GIR_Coverage, 61028,
     /* 1491741 */     GIR_EraseRootFromParent_Done,
     /* 1491742 */   // Label 20801: @1491742
     /* 1491742 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1491839), // Rule ID 61029 //
     /* 1491747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1491750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1491755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1491764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491797 */     // MIs[1] Operand 1
     /* 1491797 */     // No operand predicates
     /* 1491797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491801 */     // MIs[0] policy
     /* 1491801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491813 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1491816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491838 */     // GIR_Coverage, 61029,
     /* 1491838 */     GIR_EraseRootFromParent_Done,
     /* 1491839 */   // Label 20802: @1491839
     /* 1491839 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1491936), // Rule ID 61036 //
     /* 1491844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1491847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1491852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1491861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491894 */     // MIs[1] Operand 1
     /* 1491894 */     // No operand predicates
     /* 1491894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491898 */     // MIs[0] policy
     /* 1491898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491910 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1491913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491935 */     // GIR_Coverage, 61036,
     /* 1491935 */     GIR_EraseRootFromParent_Done,
     /* 1491936 */   // Label 20803: @1491936
     /* 1491936 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1492033), // Rule ID 61037 //
     /* 1491941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1491944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1491949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1491958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491991 */     // MIs[1] Operand 1
     /* 1491991 */     // No operand predicates
     /* 1491991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491995 */     // MIs[0] policy
     /* 1491995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492007 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1492010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492032 */     // GIR_Coverage, 61037,
     /* 1492032 */     GIR_EraseRootFromParent_Done,
     /* 1492033 */   // Label 20804: @1492033
     /* 1492033 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1492130), // Rule ID 61044 //
     /* 1492038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1492041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1492055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492088 */     // MIs[1] Operand 1
     /* 1492088 */     // No operand predicates
     /* 1492088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492092 */     // MIs[0] policy
     /* 1492092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1492107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492126 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492129 */     // GIR_Coverage, 61044,
     /* 1492129 */     GIR_EraseRootFromParent_Done,
     /* 1492130 */   // Label 20805: @1492130
     /* 1492130 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1492227), // Rule ID 61045 //
     /* 1492135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1492138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1492146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1492149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1492152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492185 */     // MIs[1] Operand 1
     /* 1492185 */     // No operand predicates
     /* 1492185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492189 */     // MIs[0] policy
     /* 1492189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492201 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1492204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492226 */     // GIR_Coverage, 61045,
     /* 1492226 */     GIR_EraseRootFromParent_Done,
     /* 1492227 */   // Label 20806: @1492227
     /* 1492227 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1492324), // Rule ID 61052 //
     /* 1492232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1492235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1492249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492282 */     // MIs[1] Operand 1
     /* 1492282 */     // No operand predicates
     /* 1492282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492286 */     // MIs[0] policy
     /* 1492286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1492301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492323 */     // GIR_Coverage, 61052,
     /* 1492323 */     GIR_EraseRootFromParent_Done,
     /* 1492324 */   // Label 20807: @1492324
     /* 1492324 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1492421), // Rule ID 61053 //
     /* 1492329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1492332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1492346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492379 */     // MIs[1] Operand 1
     /* 1492379 */     // No operand predicates
     /* 1492379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492383 */     // MIs[0] policy
     /* 1492383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1492398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492420 */     // GIR_Coverage, 61053,
     /* 1492420 */     GIR_EraseRootFromParent_Done,
     /* 1492421 */   // Label 20808: @1492421
     /* 1492421 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1492518), // Rule ID 61060 //
     /* 1492426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1492429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492476 */     // MIs[1] Operand 1
     /* 1492476 */     // No operand predicates
     /* 1492476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492480 */     // MIs[0] policy
     /* 1492480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1492495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492517 */     // GIR_Coverage, 61060,
     /* 1492517 */     GIR_EraseRootFromParent_Done,
     /* 1492518 */   // Label 20809: @1492518
     /* 1492518 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1492615), // Rule ID 61061 //
     /* 1492523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1492526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492573 */     // MIs[1] Operand 1
     /* 1492573 */     // No operand predicates
     /* 1492573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492577 */     // MIs[0] policy
     /* 1492577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492589 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1492592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492614 */     // GIR_Coverage, 61061,
     /* 1492614 */     GIR_EraseRootFromParent_Done,
     /* 1492615 */   // Label 20810: @1492615
     /* 1492615 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1492712), // Rule ID 61068 //
     /* 1492620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1492623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492670 */     // MIs[1] Operand 1
     /* 1492670 */     // No operand predicates
     /* 1492670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492674 */     // MIs[0] policy
     /* 1492674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1492689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492711 */     // GIR_Coverage, 61068,
     /* 1492711 */     GIR_EraseRootFromParent_Done,
     /* 1492712 */   // Label 20811: @1492712
     /* 1492712 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1492809), // Rule ID 61069 //
     /* 1492717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1492720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492767 */     // MIs[1] Operand 1
     /* 1492767 */     // No operand predicates
     /* 1492767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492771 */     // MIs[0] policy
     /* 1492771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492783 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1492786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492808 */     // GIR_Coverage, 61069,
     /* 1492808 */     GIR_EraseRootFromParent_Done,
     /* 1492809 */   // Label 20812: @1492809
     /* 1492809 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1492906), // Rule ID 61076 //
     /* 1492814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1492817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1492825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1492828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1492831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492864 */     // MIs[1] Operand 1
     /* 1492864 */     // No operand predicates
     /* 1492864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492868 */     // MIs[0] policy
     /* 1492868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1492883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492905 */     // GIR_Coverage, 61076,
     /* 1492905 */     GIR_EraseRootFromParent_Done,
     /* 1492906 */   // Label 20813: @1492906
     /* 1492906 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1493003), // Rule ID 61077 //
     /* 1492911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1492914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1492919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1492922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1492925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1492928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492961 */     // MIs[1] Operand 1
     /* 1492961 */     // No operand predicates
     /* 1492961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492965 */     // MIs[0] policy
     /* 1492965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1492980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493002 */     // GIR_Coverage, 61077,
     /* 1493002 */     GIR_EraseRootFromParent_Done,
     /* 1493003 */   // Label 20814: @1493003
     /* 1493003 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1493100), // Rule ID 61084 //
     /* 1493008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1493019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1493022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1493025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493058 */     // MIs[1] Operand 1
     /* 1493058 */     // No operand predicates
     /* 1493058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493062 */     // MIs[0] policy
     /* 1493062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1493077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493099 */     // GIR_Coverage, 61084,
     /* 1493099 */     GIR_EraseRootFromParent_Done,
     /* 1493100 */   // Label 20815: @1493100
     /* 1493100 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1493197), // Rule ID 61085 //
     /* 1493105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1493116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1493119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1493122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493155 */     // MIs[1] Operand 1
     /* 1493155 */     // No operand predicates
     /* 1493155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493159 */     // MIs[0] policy
     /* 1493159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1493174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493196 */     // GIR_Coverage, 61085,
     /* 1493196 */     GIR_EraseRootFromParent_Done,
     /* 1493197 */   // Label 20816: @1493197
     /* 1493197 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1493294), // Rule ID 61092 //
     /* 1493202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1493219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493252 */     // MIs[1] Operand 1
     /* 1493252 */     // No operand predicates
     /* 1493252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493256 */     // MIs[0] policy
     /* 1493256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1493271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493293 */     // GIR_Coverage, 61092,
     /* 1493293 */     GIR_EraseRootFromParent_Done,
     /* 1493294 */   // Label 20817: @1493294
     /* 1493294 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1493391), // Rule ID 61093 //
     /* 1493299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1493316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493349 */     // MIs[1] Operand 1
     /* 1493349 */     // No operand predicates
     /* 1493349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493353 */     // MIs[0] policy
     /* 1493353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1493368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493390 */     // GIR_Coverage, 61093,
     /* 1493390 */     GIR_EraseRootFromParent_Done,
     /* 1493391 */   // Label 20818: @1493391
     /* 1493391 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1493488), // Rule ID 61100 //
     /* 1493396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1493413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493446 */     // MIs[1] Operand 1
     /* 1493446 */     // No operand predicates
     /* 1493446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493450 */     // MIs[0] policy
     /* 1493450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1493465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493487 */     // GIR_Coverage, 61100,
     /* 1493487 */     GIR_EraseRootFromParent_Done,
     /* 1493488 */   // Label 20819: @1493488
     /* 1493488 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1493585), // Rule ID 61101 //
     /* 1493493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1493510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493543 */     // MIs[1] Operand 1
     /* 1493543 */     // No operand predicates
     /* 1493543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493547 */     // MIs[0] policy
     /* 1493547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1493562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493584 */     // GIR_Coverage, 61101,
     /* 1493584 */     GIR_EraseRootFromParent_Done,
     /* 1493585 */   // Label 20820: @1493585
     /* 1493585 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1493682), // Rule ID 61108 //
     /* 1493590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1493607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493640 */     // MIs[1] Operand 1
     /* 1493640 */     // No operand predicates
     /* 1493640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493644 */     // MIs[0] policy
     /* 1493644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1493659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493681 */     // GIR_Coverage, 61108,
     /* 1493681 */     GIR_EraseRootFromParent_Done,
     /* 1493682 */   // Label 20821: @1493682
     /* 1493682 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1493779), // Rule ID 61109 //
     /* 1493687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1493704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493737 */     // MIs[1] Operand 1
     /* 1493737 */     // No operand predicates
     /* 1493737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493741 */     // MIs[0] policy
     /* 1493741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493753 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1493756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493778 */     // GIR_Coverage, 61109,
     /* 1493778 */     GIR_EraseRootFromParent_Done,
     /* 1493779 */   // Label 20822: @1493779
     /* 1493779 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1493876), // Rule ID 61116 //
     /* 1493784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1493795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1493798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1493801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493834 */     // MIs[1] Operand 1
     /* 1493834 */     // No operand predicates
     /* 1493834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493838 */     // MIs[0] policy
     /* 1493838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1493853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493875 */     // GIR_Coverage, 61116,
     /* 1493875 */     GIR_EraseRootFromParent_Done,
     /* 1493876 */   // Label 20823: @1493876
     /* 1493876 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1493973), // Rule ID 61117 //
     /* 1493881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1493892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1493895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1493898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493931 */     // MIs[1] Operand 1
     /* 1493931 */     // No operand predicates
     /* 1493931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493935 */     // MIs[0] policy
     /* 1493935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493947 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1493950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493972 */     // GIR_Coverage, 61117,
     /* 1493972 */     GIR_EraseRootFromParent_Done,
     /* 1493973 */   // Label 20824: @1493973
     /* 1493973 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1494070), // Rule ID 61124 //
     /* 1493978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1493995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494028 */     // MIs[1] Operand 1
     /* 1494028 */     // No operand predicates
     /* 1494028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494032 */     // MIs[0] policy
     /* 1494032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494069 */     // GIR_Coverage, 61124,
     /* 1494069 */     GIR_EraseRootFromParent_Done,
     /* 1494070 */   // Label 20825: @1494070
     /* 1494070 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1494167), // Rule ID 61125 //
     /* 1494075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1494086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1494089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1494092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494125 */     // MIs[1] Operand 1
     /* 1494125 */     // No operand predicates
     /* 1494125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494129 */     // MIs[0] policy
     /* 1494129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494166 */     // GIR_Coverage, 61125,
     /* 1494166 */     GIR_EraseRootFromParent_Done,
     /* 1494167 */   // Label 20826: @1494167
     /* 1494167 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1494264), // Rule ID 61132 //
     /* 1494172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1494189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494222 */     // MIs[1] Operand 1
     /* 1494222 */     // No operand predicates
     /* 1494222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494226 */     // MIs[0] policy
     /* 1494226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494263 */     // GIR_Coverage, 61132,
     /* 1494263 */     GIR_EraseRootFromParent_Done,
     /* 1494264 */   // Label 20827: @1494264
     /* 1494264 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1494361), // Rule ID 61133 //
     /* 1494269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1494286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494319 */     // MIs[1] Operand 1
     /* 1494319 */     // No operand predicates
     /* 1494319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494323 */     // MIs[0] policy
     /* 1494323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494335 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494360 */     // GIR_Coverage, 61133,
     /* 1494360 */     GIR_EraseRootFromParent_Done,
     /* 1494361 */   // Label 20828: @1494361
     /* 1494361 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1494458), // Rule ID 61140 //
     /* 1494366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1494383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494416 */     // MIs[1] Operand 1
     /* 1494416 */     // No operand predicates
     /* 1494416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494420 */     // MIs[0] policy
     /* 1494420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1494435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494457 */     // GIR_Coverage, 61140,
     /* 1494457 */     GIR_EraseRootFromParent_Done,
     /* 1494458 */   // Label 20829: @1494458
     /* 1494458 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1494555), // Rule ID 61141 //
     /* 1494463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1494480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494513 */     // MIs[1] Operand 1
     /* 1494513 */     // No operand predicates
     /* 1494513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494517 */     // MIs[0] policy
     /* 1494517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494529 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1494532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1494551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494554 */     // GIR_Coverage, 61141,
     /* 1494554 */     GIR_EraseRootFromParent_Done,
     /* 1494555 */   // Label 20830: @1494555
     /* 1494555 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1494652), // Rule ID 61996 //
     /* 1494560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1494563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1494571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1494574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494610 */     // MIs[1] Operand 1
     /* 1494610 */     // No operand predicates
     /* 1494610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494614 */     // MIs[0] policy
     /* 1494614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1494629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494651 */     // GIR_Coverage, 61996,
     /* 1494651 */     GIR_EraseRootFromParent_Done,
     /* 1494652 */   // Label 20831: @1494652
     /* 1494652 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1494749), // Rule ID 61997 //
     /* 1494657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1494660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1494668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1494671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1494674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494707 */     // MIs[1] Operand 1
     /* 1494707 */     // No operand predicates
     /* 1494707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494711 */     // MIs[0] policy
     /* 1494711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494723 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1494726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494748 */     // GIR_Coverage, 61997,
     /* 1494748 */     GIR_EraseRootFromParent_Done,
     /* 1494749 */   // Label 20832: @1494749
     /* 1494749 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1494846), // Rule ID 62000 //
     /* 1494754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1494757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1494765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1494768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494804 */     // MIs[1] Operand 1
     /* 1494804 */     // No operand predicates
     /* 1494804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494808 */     // MIs[0] policy
     /* 1494808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1494823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494842 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494845 */     // GIR_Coverage, 62000,
     /* 1494845 */     GIR_EraseRootFromParent_Done,
     /* 1494846 */   // Label 20833: @1494846
     /* 1494846 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1494943), // Rule ID 62001 //
     /* 1494851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1494854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1494862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1494865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494901 */     // MIs[1] Operand 1
     /* 1494901 */     // No operand predicates
     /* 1494901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494905 */     // MIs[0] policy
     /* 1494905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494917 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1494920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494942 */     // GIR_Coverage, 62001,
     /* 1494942 */     GIR_EraseRootFromParent_Done,
     /* 1494943 */   // Label 20834: @1494943
     /* 1494943 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1495040), // Rule ID 62004 //
     /* 1494948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1494951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1494959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1494962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494998 */     // MIs[1] Operand 1
     /* 1494998 */     // No operand predicates
     /* 1494998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495002 */     // MIs[0] policy
     /* 1495002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495014 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495036 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495039 */     // GIR_Coverage, 62004,
     /* 1495039 */     GIR_EraseRootFromParent_Done,
     /* 1495040 */   // Label 20835: @1495040
     /* 1495040 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1495137), // Rule ID 62005 //
     /* 1495045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1495048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1495056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1495059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1495062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495095 */     // MIs[1] Operand 1
     /* 1495095 */     // No operand predicates
     /* 1495095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495099 */     // MIs[0] policy
     /* 1495099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495111 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495136 */     // GIR_Coverage, 62005,
     /* 1495136 */     GIR_EraseRootFromParent_Done,
     /* 1495137 */   // Label 20836: @1495137
     /* 1495137 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1495234), // Rule ID 62008 //
     /* 1495142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1495145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1495153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1495156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495192 */     // MIs[1] Operand 1
     /* 1495192 */     // No operand predicates
     /* 1495192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495196 */     // MIs[0] policy
     /* 1495196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1495211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495230 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495233 */     // GIR_Coverage, 62008,
     /* 1495233 */     GIR_EraseRootFromParent_Done,
     /* 1495234 */   // Label 20837: @1495234
     /* 1495234 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1495331), // Rule ID 62009 //
     /* 1495239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1495242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1495250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1495253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495289 */     // MIs[1] Operand 1
     /* 1495289 */     // No operand predicates
     /* 1495289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495293 */     // MIs[0] policy
     /* 1495293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495305 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1495308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495330 */     // GIR_Coverage, 62009,
     /* 1495330 */     GIR_EraseRootFromParent_Done,
     /* 1495331 */   // Label 20838: @1495331
     /* 1495331 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1495428), // Rule ID 62012 //
     /* 1495336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1495339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1495347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1495350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495386 */     // MIs[1] Operand 1
     /* 1495386 */     // No operand predicates
     /* 1495386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495390 */     // MIs[0] policy
     /* 1495390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495402 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495424 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495427 */     // GIR_Coverage, 62012,
     /* 1495427 */     GIR_EraseRootFromParent_Done,
     /* 1495428 */   // Label 20839: @1495428
     /* 1495428 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1495525), // Rule ID 62013 //
     /* 1495433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1495436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1495444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1495447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495483 */     // MIs[1] Operand 1
     /* 1495483 */     // No operand predicates
     /* 1495483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495487 */     // MIs[0] policy
     /* 1495487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495524 */     // GIR_Coverage, 62013,
     /* 1495524 */     GIR_EraseRootFromParent_Done,
     /* 1495525 */   // Label 20840: @1495525
     /* 1495525 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1495622), // Rule ID 62016 //
     /* 1495530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1495533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1495547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495580 */     // MIs[1] Operand 1
     /* 1495580 */     // No operand predicates
     /* 1495580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495584 */     // MIs[0] policy
     /* 1495584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495618 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495621 */     // GIR_Coverage, 62016,
     /* 1495621 */     GIR_EraseRootFromParent_Done,
     /* 1495622 */   // Label 20841: @1495622
     /* 1495622 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1495719), // Rule ID 62017 //
     /* 1495627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1495630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1495644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495677 */     // MIs[1] Operand 1
     /* 1495677 */     // No operand predicates
     /* 1495677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495681 */     // MIs[0] policy
     /* 1495681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1495696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495718 */     // GIR_Coverage, 62017,
     /* 1495718 */     GIR_EraseRootFromParent_Done,
     /* 1495719 */   // Label 20842: @1495719
     /* 1495719 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1495816), // Rule ID 62020 //
     /* 1495724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1495727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1495735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1495738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1495741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495770 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495774 */     // MIs[1] Operand 1
     /* 1495774 */     // No operand predicates
     /* 1495774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495778 */     // MIs[0] policy
     /* 1495778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495790 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1495793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495812 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495815 */     // GIR_Coverage, 62020,
     /* 1495815 */     GIR_EraseRootFromParent_Done,
     /* 1495816 */   // Label 20843: @1495816
     /* 1495816 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1495913), // Rule ID 62021 //
     /* 1495821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1495824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1495832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1495835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1495838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495871 */     // MIs[1] Operand 1
     /* 1495871 */     // No operand predicates
     /* 1495871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495875 */     // MIs[0] policy
     /* 1495875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495887 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1495890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495912 */     // GIR_Coverage, 62021,
     /* 1495912 */     GIR_EraseRootFromParent_Done,
     /* 1495913 */   // Label 20844: @1495913
     /* 1495913 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1496010), // Rule ID 62024 //
     /* 1495918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1495921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1495926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1495929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1495932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1495968 */     // MIs[1] Operand 1
     /* 1495968 */     // No operand predicates
     /* 1495968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495972 */     // MIs[0] policy
     /* 1495972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1495987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496009 */     // GIR_Coverage, 62024,
     /* 1496009 */     GIR_EraseRootFromParent_Done,
     /* 1496010 */   // Label 20845: @1496010
     /* 1496010 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1496107), // Rule ID 62025 //
     /* 1496015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1496026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1496029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1496032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496065 */     // MIs[1] Operand 1
     /* 1496065 */     // No operand predicates
     /* 1496065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496069 */     // MIs[0] policy
     /* 1496069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496081 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1496084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496106 */     // GIR_Coverage, 62025,
     /* 1496106 */     GIR_EraseRootFromParent_Done,
     /* 1496107 */   // Label 20846: @1496107
     /* 1496107 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1496204), // Rule ID 62028 //
     /* 1496112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1496123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1496126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496162 */     // MIs[1] Operand 1
     /* 1496162 */     // No operand predicates
     /* 1496162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496166 */     // MIs[0] policy
     /* 1496166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1496181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496203 */     // GIR_Coverage, 62028,
     /* 1496203 */     GIR_EraseRootFromParent_Done,
     /* 1496204 */   // Label 20847: @1496204
     /* 1496204 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1496301), // Rule ID 62029 //
     /* 1496209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1496220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1496223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496259 */     // MIs[1] Operand 1
     /* 1496259 */     // No operand predicates
     /* 1496259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496263 */     // MIs[0] policy
     /* 1496263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1496278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496300 */     // GIR_Coverage, 62029,
     /* 1496300 */     GIR_EraseRootFromParent_Done,
     /* 1496301 */   // Label 20848: @1496301
     /* 1496301 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1496398), // Rule ID 62032 //
     /* 1496306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1496323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496356 */     // MIs[1] Operand 1
     /* 1496356 */     // No operand predicates
     /* 1496356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496360 */     // MIs[0] policy
     /* 1496360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1496375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496397 */     // GIR_Coverage, 62032,
     /* 1496397 */     GIR_EraseRootFromParent_Done,
     /* 1496398 */   // Label 20849: @1496398
     /* 1496398 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1496495), // Rule ID 62033 //
     /* 1496403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1496420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496453 */     // MIs[1] Operand 1
     /* 1496453 */     // No operand predicates
     /* 1496453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496457 */     // MIs[0] policy
     /* 1496457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496469 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1496472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496494 */     // GIR_Coverage, 62033,
     /* 1496494 */     GIR_EraseRootFromParent_Done,
     /* 1496495 */   // Label 20850: @1496495
     /* 1496495 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1496592), // Rule ID 62036 //
     /* 1496500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1496511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1496514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1496517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496550 */     // MIs[1] Operand 1
     /* 1496550 */     // No operand predicates
     /* 1496550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496554 */     // MIs[0] policy
     /* 1496554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1496569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496591 */     // GIR_Coverage, 62036,
     /* 1496591 */     GIR_EraseRootFromParent_Done,
     /* 1496592 */   // Label 20851: @1496592
     /* 1496592 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1496689), // Rule ID 62037 //
     /* 1496597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1496608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1496611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1496614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1496620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496647 */     // MIs[1] Operand 1
     /* 1496647 */     // No operand predicates
     /* 1496647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496651 */     // MIs[0] policy
     /* 1496651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496663 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1496666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496688 */     // GIR_Coverage, 62037,
     /* 1496688 */     GIR_EraseRootFromParent_Done,
     /* 1496689 */   // Label 20852: @1496689
     /* 1496689 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1496786), // Rule ID 62040 //
     /* 1496694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1496705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1496708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1496711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1496717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496744 */     // MIs[1] Operand 1
     /* 1496744 */     // No operand predicates
     /* 1496744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496748 */     // MIs[0] policy
     /* 1496748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496760 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1496763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496785 */     // GIR_Coverage, 62040,
     /* 1496785 */     GIR_EraseRootFromParent_Done,
     /* 1496786 */   // Label 20853: @1496786
     /* 1496786 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1496883), // Rule ID 62041 //
     /* 1496791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1496802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1496805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1496808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1496814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496841 */     // MIs[1] Operand 1
     /* 1496841 */     // No operand predicates
     /* 1496841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496845 */     // MIs[0] policy
     /* 1496845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496857 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1496860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496882 */     // GIR_Coverage, 62041,
     /* 1496882 */     GIR_EraseRootFromParent_Done,
     /* 1496883 */   // Label 20854: @1496883
     /* 1496883 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1496980), // Rule ID 62044 //
     /* 1496888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1496899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1496902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1496905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1496911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496934 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496938 */     // MIs[1] Operand 1
     /* 1496938 */     // No operand predicates
     /* 1496938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496942 */     // MIs[0] policy
     /* 1496942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496954 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1496957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496979 */     // GIR_Coverage, 62044,
     /* 1496979 */     GIR_EraseRootFromParent_Done,
     /* 1496980 */   // Label 20855: @1496980
     /* 1496980 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1497077), // Rule ID 62045 //
     /* 1496985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1496996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1496999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1497002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1497008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497035 */     // MIs[1] Operand 1
     /* 1497035 */     // No operand predicates
     /* 1497035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497039 */     // MIs[0] policy
     /* 1497039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497051 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1497054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497076 */     // GIR_Coverage, 62045,
     /* 1497076 */     GIR_EraseRootFromParent_Done,
     /* 1497077 */   // Label 20856: @1497077
     /* 1497077 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1497174), // Rule ID 62048 //
     /* 1497082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1497093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1497096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1497099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497132 */     // MIs[1] Operand 1
     /* 1497132 */     // No operand predicates
     /* 1497132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497136 */     // MIs[0] policy
     /* 1497136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1497151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497173 */     // GIR_Coverage, 62048,
     /* 1497173 */     GIR_EraseRootFromParent_Done,
     /* 1497174 */   // Label 20857: @1497174
     /* 1497174 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1497271), // Rule ID 62049 //
     /* 1497179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1497190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1497193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1497196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497229 */     // MIs[1] Operand 1
     /* 1497229 */     // No operand predicates
     /* 1497229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497233 */     // MIs[0] policy
     /* 1497233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1497248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497270 */     // GIR_Coverage, 62049,
     /* 1497270 */     GIR_EraseRootFromParent_Done,
     /* 1497271 */   // Label 20858: @1497271
     /* 1497271 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1497368), // Rule ID 62052 //
     /* 1497276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1497287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1497290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1497293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1497299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497326 */     // MIs[1] Operand 1
     /* 1497326 */     // No operand predicates
     /* 1497326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497330 */     // MIs[0] policy
     /* 1497330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497342 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1497345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497367 */     // GIR_Coverage, 62052,
     /* 1497367 */     GIR_EraseRootFromParent_Done,
     /* 1497368 */   // Label 20859: @1497368
     /* 1497368 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1497465), // Rule ID 62053 //
     /* 1497373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1497384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1497387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1497390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1497396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497423 */     // MIs[1] Operand 1
     /* 1497423 */     // No operand predicates
     /* 1497423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497427 */     // MIs[0] policy
     /* 1497427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497439 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1497442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497464 */     // GIR_Coverage, 62053,
     /* 1497464 */     GIR_EraseRootFromParent_Done,
     /* 1497465 */   // Label 20860: @1497465
     /* 1497465 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1497562), // Rule ID 62056 //
     /* 1497470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1497481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1497484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1497487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1497493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497520 */     // MIs[1] Operand 1
     /* 1497520 */     // No operand predicates
     /* 1497520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497524 */     // MIs[0] policy
     /* 1497524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497536 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1497539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497561 */     // GIR_Coverage, 62056,
     /* 1497561 */     GIR_EraseRootFromParent_Done,
     /* 1497562 */   // Label 20861: @1497562
     /* 1497562 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1497659), // Rule ID 62057 //
     /* 1497567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1497578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1497581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1497584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1497590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1497597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497617 */     // MIs[1] Operand 1
     /* 1497617 */     // No operand predicates
     /* 1497617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497621 */     // MIs[0] policy
     /* 1497621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497633 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1497636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497658 */     // GIR_Coverage, 62057,
     /* 1497658 */     GIR_EraseRootFromParent_Done,
     /* 1497659 */   // Label 20862: @1497659
     /* 1497659 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1497756), // Rule ID 62060 //
     /* 1497664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1497675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1497678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1497681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497714 */     // MIs[1] Operand 1
     /* 1497714 */     // No operand predicates
     /* 1497714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497718 */     // MIs[0] policy
     /* 1497718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1497733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497755 */     // GIR_Coverage, 62060,
     /* 1497755 */     GIR_EraseRootFromParent_Done,
     /* 1497756 */   // Label 20863: @1497756
     /* 1497756 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1497853), // Rule ID 62061 //
     /* 1497761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1497772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1497775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1497778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1497791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1497799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497811 */     // MIs[1] Operand 1
     /* 1497811 */     // No operand predicates
     /* 1497811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497815 */     // MIs[0] policy
     /* 1497815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1497830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497852 */     // GIR_Coverage, 62061,
     /* 1497852 */     GIR_EraseRootFromParent_Done,
     /* 1497853 */   // Label 20864: @1497853
     /* 1497853 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1497950), // Rule ID 62064 //
     /* 1497858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1497869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1497872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497908 */     // MIs[1] Operand 1
     /* 1497908 */     // No operand predicates
     /* 1497908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497912 */     // MIs[0] policy
     /* 1497912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1497927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497949 */     // GIR_Coverage, 62064,
     /* 1497949 */     GIR_EraseRootFromParent_Done,
     /* 1497950 */   // Label 20865: @1497950
     /* 1497950 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1498047), // Rule ID 62065 //
     /* 1497955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1497966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1497969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1497972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1497985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498005 */     // MIs[1] Operand 1
     /* 1498005 */     // No operand predicates
     /* 1498005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498009 */     // MIs[0] policy
     /* 1498009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498021 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1498024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498046 */     // GIR_Coverage, 62065,
     /* 1498046 */     GIR_EraseRootFromParent_Done,
     /* 1498047 */   // Label 20866: @1498047
     /* 1498047 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1498144), // Rule ID 62068 //
     /* 1498052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1498063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1498066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1498069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498102 */     // MIs[1] Operand 1
     /* 1498102 */     // No operand predicates
     /* 1498102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498106 */     // MIs[0] policy
     /* 1498106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1498121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498143 */     // GIR_Coverage, 62068,
     /* 1498143 */     GIR_EraseRootFromParent_Done,
     /* 1498144 */   // Label 20867: @1498144
     /* 1498144 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1498241), // Rule ID 62069 //
     /* 1498149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1498160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1498163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1498166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498199 */     // MIs[1] Operand 1
     /* 1498199 */     // No operand predicates
     /* 1498199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498203 */     // MIs[0] policy
     /* 1498203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498215 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1498218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498240 */     // GIR_Coverage, 62069,
     /* 1498240 */     GIR_EraseRootFromParent_Done,
     /* 1498241 */   // Label 20868: @1498241
     /* 1498241 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1498338), // Rule ID 62072 //
     /* 1498246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1498257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1498260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1498263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498296 */     // MIs[1] Operand 1
     /* 1498296 */     // No operand predicates
     /* 1498296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498300 */     // MIs[0] policy
     /* 1498300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498334 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498337 */     // GIR_Coverage, 62072,
     /* 1498337 */     GIR_EraseRootFromParent_Done,
     /* 1498338 */   // Label 20869: @1498338
     /* 1498338 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1498435), // Rule ID 62073 //
     /* 1498343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1498354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1498357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1498360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498393 */     // MIs[1] Operand 1
     /* 1498393 */     // No operand predicates
     /* 1498393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498397 */     // MIs[0] policy
     /* 1498397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498434 */     // GIR_Coverage, 62073,
     /* 1498434 */     GIR_EraseRootFromParent_Done,
     /* 1498435 */   // Label 20870: @1498435
     /* 1498435 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1498532), // Rule ID 62076 //
     /* 1498440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1498451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1498454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1498457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498490 */     // MIs[1] Operand 1
     /* 1498490 */     // No operand predicates
     /* 1498490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498494 */     // MIs[0] policy
     /* 1498494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1498509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498528 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498531 */     // GIR_Coverage, 62076,
     /* 1498531 */     GIR_EraseRootFromParent_Done,
     /* 1498532 */   // Label 20871: @1498532
     /* 1498532 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1498629), // Rule ID 62077 //
     /* 1498537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1498548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1498551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1498554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498587 */     // MIs[1] Operand 1
     /* 1498587 */     // No operand predicates
     /* 1498587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498591 */     // MIs[0] policy
     /* 1498591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498603 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1498606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498628 */     // GIR_Coverage, 62077,
     /* 1498628 */     GIR_EraseRootFromParent_Done,
     /* 1498629 */   // Label 20872: @1498629
     /* 1498629 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1498726), // Rule ID 62080 //
     /* 1498634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1498645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1498648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1498651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498684 */     // MIs[1] Operand 1
     /* 1498684 */     // No operand predicates
     /* 1498684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498688 */     // MIs[0] policy
     /* 1498688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1498703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498722 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498725 */     // GIR_Coverage, 62080,
     /* 1498725 */     GIR_EraseRootFromParent_Done,
     /* 1498726 */   // Label 20873: @1498726
     /* 1498726 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1498823), // Rule ID 62081 //
     /* 1498731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1498742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1498745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1498748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1498761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498781 */     // MIs[1] Operand 1
     /* 1498781 */     // No operand predicates
     /* 1498781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498785 */     // MIs[0] policy
     /* 1498785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498797 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1498800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498822 */     // GIR_Coverage, 62081,
     /* 1498822 */     GIR_EraseRootFromParent_Done,
     /* 1498823 */   // Label 20874: @1498823
     /* 1498823 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1498905), // Rule ID 2700 //
     /* 1498828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1498831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1498836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1498839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1498842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1498845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1498848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498867 */     // MIs[0] round
     /* 1498867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498870 */     // MIs[0] policy
     /* 1498870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498880 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1498883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1498889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1498891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498904 */     // GIR_Coverage, 2700,
     /* 1498904 */     GIR_EraseRootFromParent_Done,
     /* 1498905 */   // Label 20875: @1498905
     /* 1498905 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1498987), // Rule ID 2701 //
     /* 1498910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1498913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1498918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1498921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1498924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1498927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1498930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498949 */     // MIs[0] round
     /* 1498949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498952 */     // MIs[0] policy
     /* 1498952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498962 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1498965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1498971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1498973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498986 */     // GIR_Coverage, 2701,
     /* 1498986 */     GIR_EraseRootFromParent_Done,
     /* 1498987 */   // Label 20876: @1498987
     /* 1498987 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1499069), // Rule ID 2736 //
     /* 1498992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1498995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1499000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1499012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499031 */     // MIs[0] round
     /* 1499031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499034 */     // MIs[0] policy
     /* 1499034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1499047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1499053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1499055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499068 */     // GIR_Coverage, 2736,
     /* 1499068 */     GIR_EraseRootFromParent_Done,
     /* 1499069 */   // Label 20877: @1499069
     /* 1499069 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1499151), // Rule ID 2737 //
     /* 1499074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1499077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1499082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1499094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1499101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499113 */     // MIs[0] round
     /* 1499113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499116 */     // MIs[0] policy
     /* 1499116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499126 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1499129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1499135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1499137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499150 */     // GIR_Coverage, 2737,
     /* 1499150 */     GIR_EraseRootFromParent_Done,
     /* 1499151 */   // Label 20878: @1499151
     /* 1499151 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1499233), // Rule ID 2768 //
     /* 1499156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1499159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1499176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499195 */     // MIs[0] round
     /* 1499195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499198 */     // MIs[0] policy
     /* 1499198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499208 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1499211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499232 */     // GIR_Coverage, 2768,
     /* 1499232 */     GIR_EraseRootFromParent_Done,
     /* 1499233 */   // Label 20879: @1499233
     /* 1499233 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1499315), // Rule ID 2769 //
     /* 1499238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1499241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1499258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499277 */     // MIs[0] round
     /* 1499277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499280 */     // MIs[0] policy
     /* 1499280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499290 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1499293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499314 */     // GIR_Coverage, 2769,
     /* 1499314 */     GIR_EraseRootFromParent_Done,
     /* 1499315 */   // Label 20880: @1499315
     /* 1499315 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1499397), // Rule ID 17748 //
     /* 1499320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1499323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1499331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1499334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1499340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499359 */     // MIs[0] round
     /* 1499359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499362 */     // MIs[0] policy
     /* 1499362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499372 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1499375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499396 */     // GIR_Coverage, 17748,
     /* 1499396 */     GIR_EraseRootFromParent_Done,
     /* 1499397 */   // Label 20881: @1499397
     /* 1499397 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1499479), // Rule ID 17749 //
     /* 1499402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1499405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1499413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1499416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1499422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499441 */     // MIs[0] round
     /* 1499441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499444 */     // MIs[0] policy
     /* 1499444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499454 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1499457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499478 */     // GIR_Coverage, 17749,
     /* 1499478 */     GIR_EraseRootFromParent_Done,
     /* 1499479 */   // Label 20882: @1499479
     /* 1499479 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1499561), // Rule ID 17752 //
     /* 1499484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1499487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1499495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1499498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1499501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1499504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499523 */     // MIs[0] round
     /* 1499523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499526 */     // MIs[0] policy
     /* 1499526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499536 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1499539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499560 */     // GIR_Coverage, 17752,
     /* 1499560 */     GIR_EraseRootFromParent_Done,
     /* 1499561 */   // Label 20883: @1499561
     /* 1499561 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1499643), // Rule ID 17753 //
     /* 1499566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1499569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1499577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1499580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1499583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1499586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499605 */     // MIs[0] round
     /* 1499605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499608 */     // MIs[0] policy
     /* 1499608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499618 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1499621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499642 */     // GIR_Coverage, 17753,
     /* 1499642 */     GIR_EraseRootFromParent_Done,
     /* 1499643 */   // Label 20884: @1499643
     /* 1499643 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1499725), // Rule ID 17756 //
     /* 1499648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1499651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1499659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1499662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1499665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1499668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499687 */     // MIs[0] round
     /* 1499687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499690 */     // MIs[0] policy
     /* 1499690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1499703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499724 */     // GIR_Coverage, 17756,
     /* 1499724 */     GIR_EraseRootFromParent_Done,
     /* 1499725 */   // Label 20885: @1499725
     /* 1499725 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1499807), // Rule ID 17757 //
     /* 1499730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1499733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1499741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1499744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1499747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1499750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499769 */     // MIs[0] round
     /* 1499769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499772 */     // MIs[0] policy
     /* 1499772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499782 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1499785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499806 */     // GIR_Coverage, 17757,
     /* 1499806 */     GIR_EraseRootFromParent_Done,
     /* 1499807 */   // Label 20886: @1499807
     /* 1499807 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1499889), // Rule ID 17760 //
     /* 1499812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1499815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1499823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1499826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1499829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1499832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499851 */     // MIs[0] round
     /* 1499851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499854 */     // MIs[0] policy
     /* 1499854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499864 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1499867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499888 */     // GIR_Coverage, 17760,
     /* 1499888 */     GIR_EraseRootFromParent_Done,
     /* 1499889 */   // Label 20887: @1499889
     /* 1499889 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1499971), // Rule ID 17761 //
     /* 1499894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1499897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1499905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1499908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1499911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1499914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499933 */     // MIs[0] round
     /* 1499933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499936 */     // MIs[0] policy
     /* 1499936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499946 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1499949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499970 */     // GIR_Coverage, 17761,
     /* 1499970 */     GIR_EraseRootFromParent_Done,
     /* 1499971 */   // Label 20888: @1499971
     /* 1499971 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1500053), // Rule ID 17764 //
     /* 1499976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1499979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1499987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1499990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1499993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1499996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500015 */     // MIs[0] round
     /* 1500015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500018 */     // MIs[0] policy
     /* 1500018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1500031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500052 */     // GIR_Coverage, 17764,
     /* 1500052 */     GIR_EraseRootFromParent_Done,
     /* 1500053 */   // Label 20889: @1500053
     /* 1500053 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1500135), // Rule ID 17765 //
     /* 1500058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1500061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1500069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1500072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1500075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1500078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500097 */     // MIs[0] round
     /* 1500097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500100 */     // MIs[0] policy
     /* 1500100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500110 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1500113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500134 */     // GIR_Coverage, 17765,
     /* 1500134 */     GIR_EraseRootFromParent_Done,
     /* 1500135 */   // Label 20890: @1500135
     /* 1500135 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1500217), // Rule ID 17768 //
     /* 1500140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1500151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1500154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1500157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1500160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500179 */     // MIs[0] round
     /* 1500179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500182 */     // MIs[0] policy
     /* 1500182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500192 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1500195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500216 */     // GIR_Coverage, 17768,
     /* 1500216 */     GIR_EraseRootFromParent_Done,
     /* 1500217 */   // Label 20891: @1500217
     /* 1500217 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1500299), // Rule ID 17769 //
     /* 1500222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1500233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1500236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1500239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1500242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500261 */     // MIs[0] round
     /* 1500261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500264 */     // MIs[0] policy
     /* 1500264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1500277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500298 */     // GIR_Coverage, 17769,
     /* 1500298 */     GIR_EraseRootFromParent_Done,
     /* 1500299 */   // Label 20892: @1500299
     /* 1500299 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1500381), // Rule ID 17772 //
     /* 1500304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1500324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500343 */     // MIs[0] round
     /* 1500343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500346 */     // MIs[0] policy
     /* 1500346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500356 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1500359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500380 */     // GIR_Coverage, 17772,
     /* 1500380 */     GIR_EraseRootFromParent_Done,
     /* 1500381 */   // Label 20893: @1500381
     /* 1500381 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1500463), // Rule ID 17773 //
     /* 1500386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1500406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500425 */     // MIs[0] round
     /* 1500425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500428 */     // MIs[0] policy
     /* 1500428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500438 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1500441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500462 */     // GIR_Coverage, 17773,
     /* 1500462 */     GIR_EraseRootFromParent_Done,
     /* 1500463 */   // Label 20894: @1500463
     /* 1500463 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1500545), // Rule ID 17776 //
     /* 1500468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1500488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500507 */     // MIs[0] round
     /* 1500507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500510 */     // MIs[0] policy
     /* 1500510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500520 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1500523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500544 */     // GIR_Coverage, 17776,
     /* 1500544 */     GIR_EraseRootFromParent_Done,
     /* 1500545 */   // Label 20895: @1500545
     /* 1500545 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1500627), // Rule ID 17777 //
     /* 1500550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1500561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1500564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1500567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1500570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500589 */     // MIs[0] round
     /* 1500589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500592 */     // MIs[0] policy
     /* 1500592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1500605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500626 */     // GIR_Coverage, 17777,
     /* 1500626 */     GIR_EraseRootFromParent_Done,
     /* 1500627 */   // Label 20896: @1500627
     /* 1500627 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1500709), // Rule ID 17780 //
     /* 1500632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1500635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1500652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500671 */     // MIs[0] round
     /* 1500671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500674 */     // MIs[0] policy
     /* 1500674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500684 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1500687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500708 */     // GIR_Coverage, 17780,
     /* 1500708 */     GIR_EraseRootFromParent_Done,
     /* 1500709 */   // Label 20897: @1500709
     /* 1500709 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1500791), // Rule ID 17781 //
     /* 1500714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1500717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1500734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500753 */     // MIs[0] round
     /* 1500753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500756 */     // MIs[0] policy
     /* 1500756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500766 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1500769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500790 */     // GIR_Coverage, 17781,
     /* 1500790 */     GIR_EraseRootFromParent_Done,
     /* 1500791 */   // Label 20898: @1500791
     /* 1500791 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1500873), // Rule ID 17784 //
     /* 1500796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1500799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1500816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500835 */     // MIs[0] round
     /* 1500835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500838 */     // MIs[0] policy
     /* 1500838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500848 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1500851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500872 */     // GIR_Coverage, 17784,
     /* 1500872 */     GIR_EraseRootFromParent_Done,
     /* 1500873 */   // Label 20899: @1500873
     /* 1500873 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1500955), // Rule ID 17785 //
     /* 1500878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1500881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1500898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500917 */     // MIs[0] round
     /* 1500917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500920 */     // MIs[0] policy
     /* 1500920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1500933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500954 */     // GIR_Coverage, 17785,
     /* 1500954 */     GIR_EraseRootFromParent_Done,
     /* 1500955 */   // Label 20900: @1500955
     /* 1500955 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1501037), // Rule ID 17788 //
     /* 1500960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1500963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1500968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1500980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500999 */     // MIs[0] round
     /* 1500999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501002 */     // MIs[0] policy
     /* 1501002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1501015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501036 */     // GIR_Coverage, 17788,
     /* 1501036 */     GIR_EraseRootFromParent_Done,
     /* 1501037 */   // Label 20901: @1501037
     /* 1501037 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1501119), // Rule ID 17789 //
     /* 1501042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1501053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1501056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1501059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1501062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501081 */     // MIs[0] round
     /* 1501081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501084 */     // MIs[0] policy
     /* 1501084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501094 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1501097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501118 */     // GIR_Coverage, 17789,
     /* 1501118 */     GIR_EraseRootFromParent_Done,
     /* 1501119 */   // Label 20902: @1501119
     /* 1501119 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1501201), // Rule ID 17792 //
     /* 1501124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1501127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1501144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501163 */     // MIs[0] round
     /* 1501163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501166 */     // MIs[0] policy
     /* 1501166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1501179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501200 */     // GIR_Coverage, 17792,
     /* 1501200 */     GIR_EraseRootFromParent_Done,
     /* 1501201 */   // Label 20903: @1501201
     /* 1501201 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1501283), // Rule ID 17793 //
     /* 1501206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1501209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1501226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501245 */     // MIs[0] round
     /* 1501245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501248 */     // MIs[0] policy
     /* 1501248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501258 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1501261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501282 */     // GIR_Coverage, 17793,
     /* 1501282 */     GIR_EraseRootFromParent_Done,
     /* 1501283 */   // Label 20904: @1501283
     /* 1501283 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1501365), // Rule ID 17796 //
     /* 1501288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1501291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1501308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501327 */     // MIs[0] round
     /* 1501327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501330 */     // MIs[0] policy
     /* 1501330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501340 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1501343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501364 */     // GIR_Coverage, 17796,
     /* 1501364 */     GIR_EraseRootFromParent_Done,
     /* 1501365 */   // Label 20905: @1501365
     /* 1501365 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1501447), // Rule ID 17797 //
     /* 1501370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1501373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1501390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501409 */     // MIs[0] round
     /* 1501409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501412 */     // MIs[0] policy
     /* 1501412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1501425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501446 */     // GIR_Coverage, 17797,
     /* 1501446 */     GIR_EraseRootFromParent_Done,
     /* 1501447 */   // Label 20906: @1501447
     /* 1501447 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1501529), // Rule ID 17800 //
     /* 1501452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1501455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1501472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501491 */     // MIs[0] round
     /* 1501491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501494 */     // MIs[0] policy
     /* 1501494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501504 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1501507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501528 */     // GIR_Coverage, 17800,
     /* 1501528 */     GIR_EraseRootFromParent_Done,
     /* 1501529 */   // Label 20907: @1501529
     /* 1501529 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1501611), // Rule ID 17801 //
     /* 1501534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1501537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1501545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1501548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1501551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1501554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501573 */     // MIs[0] round
     /* 1501573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501576 */     // MIs[0] policy
     /* 1501576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1501589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501610 */     // GIR_Coverage, 17801,
     /* 1501610 */     GIR_EraseRootFromParent_Done,
     /* 1501611 */   // Label 20908: @1501611
     /* 1501611 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1501693), // Rule ID 17804 //
     /* 1501616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1501633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1501651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501655 */     // MIs[0] round
     /* 1501655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501658 */     // MIs[0] policy
     /* 1501658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501668 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1501671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501692 */     // GIR_Coverage, 17804,
     /* 1501692 */     GIR_EraseRootFromParent_Done,
     /* 1501693 */   // Label 20909: @1501693
     /* 1501693 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1501775), // Rule ID 17805 //
     /* 1501698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1501715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1501733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501737 */     // MIs[0] round
     /* 1501737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501740 */     // MIs[0] policy
     /* 1501740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501750 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1501753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501774 */     // GIR_Coverage, 17805,
     /* 1501774 */     GIR_EraseRootFromParent_Done,
     /* 1501775 */   // Label 20910: @1501775
     /* 1501775 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1501857), // Rule ID 17808 //
     /* 1501780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1501797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1501815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501819 */     // MIs[0] round
     /* 1501819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501822 */     // MIs[0] policy
     /* 1501822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501832 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1501835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501856 */     // GIR_Coverage, 17808,
     /* 1501856 */     GIR_EraseRootFromParent_Done,
     /* 1501857 */   // Label 20911: @1501857
     /* 1501857 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1501939), // Rule ID 17809 //
     /* 1501862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1501879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1501897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501901 */     // MIs[0] round
     /* 1501901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501904 */     // MIs[0] policy
     /* 1501904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501914 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1501917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501938 */     // GIR_Coverage, 17809,
     /* 1501938 */     GIR_EraseRootFromParent_Done,
     /* 1501939 */   // Label 20912: @1501939
     /* 1501939 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1502021), // Rule ID 17812 //
     /* 1501944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1501961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1501979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501983 */     // MIs[0] round
     /* 1501983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501986 */     // MIs[0] policy
     /* 1501986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1501999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502020 */     // GIR_Coverage, 17812,
     /* 1502020 */     GIR_EraseRootFromParent_Done,
     /* 1502021 */   // Label 20913: @1502021
     /* 1502021 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1502103), // Rule ID 17813 //
     /* 1502026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502065 */     // MIs[0] round
     /* 1502065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502068 */     // MIs[0] policy
     /* 1502068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1502081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502102 */     // GIR_Coverage, 17813,
     /* 1502102 */     GIR_EraseRootFromParent_Done,
     /* 1502103 */   // Label 20914: @1502103
     /* 1502103 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1502185), // Rule ID 17816 //
     /* 1502108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502147 */     // MIs[0] round
     /* 1502147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502150 */     // MIs[0] policy
     /* 1502150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1502163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502184 */     // GIR_Coverage, 17816,
     /* 1502184 */     GIR_EraseRootFromParent_Done,
     /* 1502185 */   // Label 20915: @1502185
     /* 1502185 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1502267), // Rule ID 17817 //
     /* 1502190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502229 */     // MIs[0] round
     /* 1502229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502232 */     // MIs[0] policy
     /* 1502232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1502245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502266 */     // GIR_Coverage, 17817,
     /* 1502266 */     GIR_EraseRootFromParent_Done,
     /* 1502267 */   // Label 20916: @1502267
     /* 1502267 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1502349), // Rule ID 17820 //
     /* 1502272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502311 */     // MIs[0] round
     /* 1502311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502314 */     // MIs[0] policy
     /* 1502314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502324 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1502327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502348 */     // GIR_Coverage, 17820,
     /* 1502348 */     GIR_EraseRootFromParent_Done,
     /* 1502349 */   // Label 20917: @1502349
     /* 1502349 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1502431), // Rule ID 17821 //
     /* 1502354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502393 */     // MIs[0] round
     /* 1502393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502396 */     // MIs[0] policy
     /* 1502396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502406 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1502409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502430 */     // GIR_Coverage, 17821,
     /* 1502430 */     GIR_EraseRootFromParent_Done,
     /* 1502431 */   // Label 20918: @1502431
     /* 1502431 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1502513), // Rule ID 17824 //
     /* 1502436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1502453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1502471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502475 */     // MIs[0] round
     /* 1502475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502478 */     // MIs[0] policy
     /* 1502478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1502491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502512 */     // GIR_Coverage, 17824,
     /* 1502512 */     GIR_EraseRootFromParent_Done,
     /* 1502513 */   // Label 20919: @1502513
     /* 1502513 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1502595), // Rule ID 17825 //
     /* 1502518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1502535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1502553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502557 */     // MIs[0] round
     /* 1502557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502560 */     // MIs[0] policy
     /* 1502560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1502573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502594 */     // GIR_Coverage, 17825,
     /* 1502594 */     GIR_EraseRootFromParent_Done,
     /* 1502595 */   // Label 20920: @1502595
     /* 1502595 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1502677), // Rule ID 17828 //
     /* 1502600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502639 */     // MIs[0] round
     /* 1502639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502642 */     // MIs[0] policy
     /* 1502642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1502655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502676 */     // GIR_Coverage, 17828,
     /* 1502676 */     GIR_EraseRootFromParent_Done,
     /* 1502677 */   // Label 20921: @1502677
     /* 1502677 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1502759), // Rule ID 17829 //
     /* 1502682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502721 */     // MIs[0] round
     /* 1502721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502724 */     // MIs[0] policy
     /* 1502724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502734 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1502737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502758 */     // GIR_Coverage, 17829,
     /* 1502758 */     GIR_EraseRootFromParent_Done,
     /* 1502759 */   // Label 20922: @1502759
     /* 1502759 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1502841), // Rule ID 17832 //
     /* 1502764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502803 */     // MIs[0] round
     /* 1502803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502806 */     // MIs[0] policy
     /* 1502806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502816 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1502819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502840 */     // GIR_Coverage, 17832,
     /* 1502840 */     GIR_EraseRootFromParent_Done,
     /* 1502841 */   // Label 20923: @1502841
     /* 1502841 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1502923), // Rule ID 17833 //
     /* 1502846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502885 */     // MIs[0] round
     /* 1502885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502888 */     // MIs[0] policy
     /* 1502888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502898 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1502901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502922 */     // GIR_Coverage, 17833,
     /* 1502922 */     GIR_EraseRootFromParent_Done,
     /* 1502923 */   // Label 20924: @1502923
     /* 1502923 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1503005), // Rule ID 17836 //
     /* 1502928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502967 */     // MIs[0] round
     /* 1502967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502970 */     // MIs[0] policy
     /* 1502970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502980 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1502983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503004 */     // GIR_Coverage, 17836,
     /* 1503004 */     GIR_EraseRootFromParent_Done,
     /* 1503005 */   // Label 20925: @1503005
     /* 1503005 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1503087), // Rule ID 17837 //
     /* 1503010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503049 */     // MIs[0] round
     /* 1503049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503052 */     // MIs[0] policy
     /* 1503052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1503065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503086 */     // GIR_Coverage, 17837,
     /* 1503086 */     GIR_EraseRootFromParent_Done,
     /* 1503087 */   // Label 20926: @1503087
     /* 1503087 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1503169), // Rule ID 17840 //
     /* 1503092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503131 */     // MIs[0] round
     /* 1503131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503134 */     // MIs[0] policy
     /* 1503134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1503147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503168 */     // GIR_Coverage, 17840,
     /* 1503168 */     GIR_EraseRootFromParent_Done,
     /* 1503169 */   // Label 20927: @1503169
     /* 1503169 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1503251), // Rule ID 17841 //
     /* 1503174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503213 */     // MIs[0] round
     /* 1503213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503216 */     // MIs[0] policy
     /* 1503216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503226 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1503229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503250 */     // GIR_Coverage, 17841,
     /* 1503250 */     GIR_EraseRootFromParent_Done,
     /* 1503251 */   // Label 20928: @1503251
     /* 1503251 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1503333), // Rule ID 17844 //
     /* 1503256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503295 */     // MIs[0] round
     /* 1503295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503298 */     // MIs[0] policy
     /* 1503298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1503311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503332 */     // GIR_Coverage, 17844,
     /* 1503332 */     GIR_EraseRootFromParent_Done,
     /* 1503333 */   // Label 20929: @1503333
     /* 1503333 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1503415), // Rule ID 17845 //
     /* 1503338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503377 */     // MIs[0] round
     /* 1503377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503380 */     // MIs[0] policy
     /* 1503380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503390 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1503393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503414 */     // GIR_Coverage, 17845,
     /* 1503414 */     GIR_EraseRootFromParent_Done,
     /* 1503415 */   // Label 20930: @1503415
     /* 1503415 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1503497), // Rule ID 17848 //
     /* 1503420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503459 */     // MIs[0] round
     /* 1503459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503462 */     // MIs[0] policy
     /* 1503462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503472 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1503475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503496 */     // GIR_Coverage, 17848,
     /* 1503496 */     GIR_EraseRootFromParent_Done,
     /* 1503497 */   // Label 20931: @1503497
     /* 1503497 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1503579), // Rule ID 17849 //
     /* 1503502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503541 */     // MIs[0] round
     /* 1503541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503544 */     // MIs[0] policy
     /* 1503544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503554 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1503557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503578 */     // GIR_Coverage, 17849,
     /* 1503578 */     GIR_EraseRootFromParent_Done,
     /* 1503579 */   // Label 20932: @1503579
     /* 1503579 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1503661), // Rule ID 17852 //
     /* 1503584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503623 */     // MIs[0] round
     /* 1503623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503626 */     // MIs[0] policy
     /* 1503626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1503639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503660 */     // GIR_Coverage, 17852,
     /* 1503660 */     GIR_EraseRootFromParent_Done,
     /* 1503661 */   // Label 20933: @1503661
     /* 1503661 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1503743), // Rule ID 17853 //
     /* 1503666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503705 */     // MIs[0] round
     /* 1503705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503708 */     // MIs[0] policy
     /* 1503708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503718 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1503721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503742 */     // GIR_Coverage, 17853,
     /* 1503742 */     GIR_EraseRootFromParent_Done,
     /* 1503743 */   // Label 20934: @1503743
     /* 1503743 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1503825), // Rule ID 17856 //
     /* 1503748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503787 */     // MIs[0] round
     /* 1503787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503790 */     // MIs[0] policy
     /* 1503790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503800 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1503803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503824 */     // GIR_Coverage, 17856,
     /* 1503824 */     GIR_EraseRootFromParent_Done,
     /* 1503825 */   // Label 20935: @1503825
     /* 1503825 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1503907), // Rule ID 17857 //
     /* 1503830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503869 */     // MIs[0] round
     /* 1503869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503872 */     // MIs[0] policy
     /* 1503872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503882 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1503885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503906 */     // GIR_Coverage, 17857,
     /* 1503906 */     GIR_EraseRootFromParent_Done,
     /* 1503907 */   // Label 20936: @1503907
     /* 1503907 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1503989), // Rule ID 17860 //
     /* 1503912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503951 */     // MIs[0] round
     /* 1503951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503954 */     // MIs[0] policy
     /* 1503954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1503967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503988 */     // GIR_Coverage, 17860,
     /* 1503988 */     GIR_EraseRootFromParent_Done,
     /* 1503989 */   // Label 20937: @1503989
     /* 1503989 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1504071), // Rule ID 17861 //
     /* 1503994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504033 */     // MIs[0] round
     /* 1504033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504036 */     // MIs[0] policy
     /* 1504036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1504049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504070 */     // GIR_Coverage, 17861,
     /* 1504070 */     GIR_EraseRootFromParent_Done,
     /* 1504071 */   // Label 20938: @1504071
     /* 1504071 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1504153), // Rule ID 17864 //
     /* 1504076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504115 */     // MIs[0] round
     /* 1504115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504118 */     // MIs[0] policy
     /* 1504118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504128 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1504131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504152 */     // GIR_Coverage, 17864,
     /* 1504152 */     GIR_EraseRootFromParent_Done,
     /* 1504153 */   // Label 20939: @1504153
     /* 1504153 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1504235), // Rule ID 17865 //
     /* 1504158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504197 */     // MIs[0] round
     /* 1504197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504200 */     // MIs[0] policy
     /* 1504200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1504213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504234 */     // GIR_Coverage, 17865,
     /* 1504234 */     GIR_EraseRootFromParent_Done,
     /* 1504235 */   // Label 20940: @1504235
     /* 1504235 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1504317), // Rule ID 17868 //
     /* 1504240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504279 */     // MIs[0] round
     /* 1504279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504282 */     // MIs[0] policy
     /* 1504282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504292 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1504295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504316 */     // GIR_Coverage, 17868,
     /* 1504316 */     GIR_EraseRootFromParent_Done,
     /* 1504317 */   // Label 20941: @1504317
     /* 1504317 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1504399), // Rule ID 17869 //
     /* 1504322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504361 */     // MIs[0] round
     /* 1504361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504364 */     // MIs[0] policy
     /* 1504364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1504377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504398 */     // GIR_Coverage, 17869,
     /* 1504398 */     GIR_EraseRootFromParent_Done,
     /* 1504399 */   // Label 20942: @1504399
     /* 1504399 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1504481), // Rule ID 17872 //
     /* 1504404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1504421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504443 */     // MIs[0] round
     /* 1504443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504446 */     // MIs[0] policy
     /* 1504446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504456 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1504459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504480 */     // GIR_Coverage, 17872,
     /* 1504480 */     GIR_EraseRootFromParent_Done,
     /* 1504481 */   // Label 20943: @1504481
     /* 1504481 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1504563), // Rule ID 17873 //
     /* 1504486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1504503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504525 */     // MIs[0] round
     /* 1504525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504528 */     // MIs[0] policy
     /* 1504528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504538 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1504541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504562 */     // GIR_Coverage, 17873,
     /* 1504562 */     GIR_EraseRootFromParent_Done,
     /* 1504563 */   // Label 20944: @1504563
     /* 1504563 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1504645), // Rule ID 17876 //
     /* 1504568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1504585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504607 */     // MIs[0] round
     /* 1504607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504610 */     // MIs[0] policy
     /* 1504610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1504623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504644 */     // GIR_Coverage, 17876,
     /* 1504644 */     GIR_EraseRootFromParent_Done,
     /* 1504645 */   // Label 20945: @1504645
     /* 1504645 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1504727), // Rule ID 17877 //
     /* 1504650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1504667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504689 */     // MIs[0] round
     /* 1504689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504692 */     // MIs[0] policy
     /* 1504692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1504705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504726 */     // GIR_Coverage, 17877,
     /* 1504726 */     GIR_EraseRootFromParent_Done,
     /* 1504727 */   // Label 20946: @1504727
     /* 1504727 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1504809), // Rule ID 17880 //
     /* 1504732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1504749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504771 */     // MIs[0] round
     /* 1504771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504774 */     // MIs[0] policy
     /* 1504774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1504787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504808 */     // GIR_Coverage, 17880,
     /* 1504808 */     GIR_EraseRootFromParent_Done,
     /* 1504809 */   // Label 20947: @1504809
     /* 1504809 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1504891), // Rule ID 17881 //
     /* 1504814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1504831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504853 */     // MIs[0] round
     /* 1504853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504856 */     // MIs[0] policy
     /* 1504856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504866 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1504869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504890 */     // GIR_Coverage, 17881,
     /* 1504890 */     GIR_EraseRootFromParent_Done,
     /* 1504891 */   // Label 20948: @1504891
     /* 1504891 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1504973), // Rule ID 17884 //
     /* 1504896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1504913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504935 */     // MIs[0] round
     /* 1504935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504938 */     // MIs[0] policy
     /* 1504938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1504951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504972 */     // GIR_Coverage, 17884,
     /* 1504972 */     GIR_EraseRootFromParent_Done,
     /* 1504973 */   // Label 20949: @1504973
     /* 1504973 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1505055), // Rule ID 17885 //
     /* 1504978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1504995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505017 */     // MIs[0] round
     /* 1505017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505020 */     // MIs[0] policy
     /* 1505020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505030 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1505033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505054 */     // GIR_Coverage, 17885,
     /* 1505054 */     GIR_EraseRootFromParent_Done,
     /* 1505055 */   // Label 20950: @1505055
     /* 1505055 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1505137), // Rule ID 17888 //
     /* 1505060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1505077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505099 */     // MIs[0] round
     /* 1505099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505102 */     // MIs[0] policy
     /* 1505102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505112 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1505115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505136 */     // GIR_Coverage, 17888,
     /* 1505136 */     GIR_EraseRootFromParent_Done,
     /* 1505137 */   // Label 20951: @1505137
     /* 1505137 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1505219), // Rule ID 17889 //
     /* 1505142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1505159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505181 */     // MIs[0] round
     /* 1505181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505184 */     // MIs[0] policy
     /* 1505184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505194 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1505197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505218 */     // GIR_Coverage, 17889,
     /* 1505218 */     GIR_EraseRootFromParent_Done,
     /* 1505219 */   // Label 20952: @1505219
     /* 1505219 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1505301), // Rule ID 17892 //
     /* 1505224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1505241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505263 */     // MIs[0] round
     /* 1505263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505266 */     // MIs[0] policy
     /* 1505266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505276 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1505279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505300 */     // GIR_Coverage, 17892,
     /* 1505300 */     GIR_EraseRootFromParent_Done,
     /* 1505301 */   // Label 20953: @1505301
     /* 1505301 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1505383), // Rule ID 17893 //
     /* 1505306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1505323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505345 */     // MIs[0] round
     /* 1505345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505348 */     // MIs[0] policy
     /* 1505348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1505361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505382 */     // GIR_Coverage, 17893,
     /* 1505382 */     GIR_EraseRootFromParent_Done,
     /* 1505383 */   // Label 20954: @1505383
     /* 1505383 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1505465), // Rule ID 17896 //
     /* 1505388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1505405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505427 */     // MIs[0] round
     /* 1505427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505430 */     // MIs[0] policy
     /* 1505430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505440 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1505443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505464 */     // GIR_Coverage, 17896,
     /* 1505464 */     GIR_EraseRootFromParent_Done,
     /* 1505465 */   // Label 20955: @1505465
     /* 1505465 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1505547), // Rule ID 17897 //
     /* 1505470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1505487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505509 */     // MIs[0] round
     /* 1505509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505512 */     // MIs[0] policy
     /* 1505512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505522 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1505525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505546 */     // GIR_Coverage, 17897,
     /* 1505546 */     GIR_EraseRootFromParent_Done,
     /* 1505547 */   // Label 20956: @1505547
     /* 1505547 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1505629), // Rule ID 17900 //
     /* 1505552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1505569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505591 */     // MIs[0] round
     /* 1505591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505594 */     // MIs[0] policy
     /* 1505594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1505607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505628 */     // GIR_Coverage, 17900,
     /* 1505628 */     GIR_EraseRootFromParent_Done,
     /* 1505629 */   // Label 20957: @1505629
     /* 1505629 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1505711), // Rule ID 17901 //
     /* 1505634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1505651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505673 */     // MIs[0] round
     /* 1505673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505676 */     // MIs[0] policy
     /* 1505676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505686 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1505689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505710 */     // GIR_Coverage, 17901,
     /* 1505710 */     GIR_EraseRootFromParent_Done,
     /* 1505711 */   // Label 20958: @1505711
     /* 1505711 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1505793), // Rule ID 17904 //
     /* 1505716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1505733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505755 */     // MIs[0] round
     /* 1505755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505758 */     // MIs[0] policy
     /* 1505758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1505771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505792 */     // GIR_Coverage, 17904,
     /* 1505792 */     GIR_EraseRootFromParent_Done,
     /* 1505793 */   // Label 20959: @1505793
     /* 1505793 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1505875), // Rule ID 17905 //
     /* 1505798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1505815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505837 */     // MIs[0] round
     /* 1505837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505840 */     // MIs[0] policy
     /* 1505840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1505853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505874 */     // GIR_Coverage, 17905,
     /* 1505874 */     GIR_EraseRootFromParent_Done,
     /* 1505875 */   // Label 20960: @1505875
     /* 1505875 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1505957), // Rule ID 17908 //
     /* 1505880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1505897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505919 */     // MIs[0] round
     /* 1505919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505922 */     // MIs[0] policy
     /* 1505922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505932 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1505935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505956 */     // GIR_Coverage, 17908,
     /* 1505956 */     GIR_EraseRootFromParent_Done,
     /* 1505957 */   // Label 20961: @1505957
     /* 1505957 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1506039), // Rule ID 17909 //
     /* 1505962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1505970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1505979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506001 */     // MIs[0] round
     /* 1506001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506004 */     // MIs[0] policy
     /* 1506004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506014 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1506017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506038 */     // GIR_Coverage, 17909,
     /* 1506038 */     GIR_EraseRootFromParent_Done,
     /* 1506039 */   // Label 20962: @1506039
     /* 1506039 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1506121), // Rule ID 17912 //
     /* 1506044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1506061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506083 */     // MIs[0] round
     /* 1506083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506086 */     // MIs[0] policy
     /* 1506086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506096 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1506099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506120 */     // GIR_Coverage, 17912,
     /* 1506120 */     GIR_EraseRootFromParent_Done,
     /* 1506121 */   // Label 20963: @1506121
     /* 1506121 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1506203), // Rule ID 17913 //
     /* 1506126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1506143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506165 */     // MIs[0] round
     /* 1506165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506168 */     // MIs[0] policy
     /* 1506168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506178 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1506181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506202 */     // GIR_Coverage, 17913,
     /* 1506202 */     GIR_EraseRootFromParent_Done,
     /* 1506203 */   // Label 20964: @1506203
     /* 1506203 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1506285), // Rule ID 17916 //
     /* 1506208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1506225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506247 */     // MIs[0] round
     /* 1506247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506250 */     // MIs[0] policy
     /* 1506250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506260 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1506263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506284 */     // GIR_Coverage, 17916,
     /* 1506284 */     GIR_EraseRootFromParent_Done,
     /* 1506285 */   // Label 20965: @1506285
     /* 1506285 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1506367), // Rule ID 17917 //
     /* 1506290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1506307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506329 */     // MIs[0] round
     /* 1506329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506332 */     // MIs[0] policy
     /* 1506332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1506345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506366 */     // GIR_Coverage, 17917,
     /* 1506366 */     GIR_EraseRootFromParent_Done,
     /* 1506367 */   // Label 20966: @1506367
     /* 1506367 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1506449), // Rule ID 17920 //
     /* 1506372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1506389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506411 */     // MIs[0] round
     /* 1506411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506414 */     // MIs[0] policy
     /* 1506414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1506427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506448 */     // GIR_Coverage, 17920,
     /* 1506448 */     GIR_EraseRootFromParent_Done,
     /* 1506449 */   // Label 20967: @1506449
     /* 1506449 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1506531), // Rule ID 17921 //
     /* 1506454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1506471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506493 */     // MIs[0] round
     /* 1506493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506496 */     // MIs[0] policy
     /* 1506496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1506509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506530 */     // GIR_Coverage, 17921,
     /* 1506530 */     GIR_EraseRootFromParent_Done,
     /* 1506531 */   // Label 20968: @1506531
     /* 1506531 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1506613), // Rule ID 17924 //
     /* 1506536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1506553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1506571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506575 */     // MIs[0] round
     /* 1506575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506578 */     // MIs[0] policy
     /* 1506578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1506591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506612 */     // GIR_Coverage, 17924,
     /* 1506612 */     GIR_EraseRootFromParent_Done,
     /* 1506613 */   // Label 20969: @1506613
     /* 1506613 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1506695), // Rule ID 17925 //
     /* 1506618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1506635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1506653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506657 */     // MIs[0] round
     /* 1506657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506660 */     // MIs[0] policy
     /* 1506660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506670 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1506673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506694 */     // GIR_Coverage, 17925,
     /* 1506694 */     GIR_EraseRootFromParent_Done,
     /* 1506695 */   // Label 20970: @1506695
     /* 1506695 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1506777), // Rule ID 17928 //
     /* 1506700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1506717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1506735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506739 */     // MIs[0] round
     /* 1506739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506742 */     // MIs[0] policy
     /* 1506742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1506755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506776 */     // GIR_Coverage, 17928,
     /* 1506776 */     GIR_EraseRootFromParent_Done,
     /* 1506777 */   // Label 20971: @1506777
     /* 1506777 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1506859), // Rule ID 17929 //
     /* 1506782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1506799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1506817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506821 */     // MIs[0] round
     /* 1506821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506824 */     // MIs[0] policy
     /* 1506824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506834 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1506837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506858 */     // GIR_Coverage, 17929,
     /* 1506858 */     GIR_EraseRootFromParent_Done,
     /* 1506859 */   // Label 20972: @1506859
     /* 1506859 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1506941), // Rule ID 17932 //
     /* 1506864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506903 */     // MIs[0] round
     /* 1506903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506906 */     // MIs[0] policy
     /* 1506906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506916 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1506919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506940 */     // GIR_Coverage, 17932,
     /* 1506940 */     GIR_EraseRootFromParent_Done,
     /* 1506941 */   // Label 20973: @1506941
     /* 1506941 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1507023), // Rule ID 17933 //
     /* 1506946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1506963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1506981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506985 */     // MIs[0] round
     /* 1506985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506988 */     // MIs[0] policy
     /* 1506988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1507001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507022 */     // GIR_Coverage, 17933,
     /* 1507022 */     GIR_EraseRootFromParent_Done,
     /* 1507023 */   // Label 20974: @1507023
     /* 1507023 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1507105), // Rule ID 17936 //
     /* 1507028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507067 */     // MIs[0] round
     /* 1507067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507070 */     // MIs[0] policy
     /* 1507070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1507083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507104 */     // GIR_Coverage, 17936,
     /* 1507104 */     GIR_EraseRootFromParent_Done,
     /* 1507105 */   // Label 20975: @1507105
     /* 1507105 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1507187), // Rule ID 17937 //
     /* 1507110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507149 */     // MIs[0] round
     /* 1507149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507152 */     // MIs[0] policy
     /* 1507152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507162 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1507165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507186 */     // GIR_Coverage, 17937,
     /* 1507186 */     GIR_EraseRootFromParent_Done,
     /* 1507187 */   // Label 20976: @1507187
     /* 1507187 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1507269), // Rule ID 17940 //
     /* 1507192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507231 */     // MIs[0] round
     /* 1507231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507234 */     // MIs[0] policy
     /* 1507234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1507247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507268 */     // GIR_Coverage, 17940,
     /* 1507268 */     GIR_EraseRootFromParent_Done,
     /* 1507269 */   // Label 20977: @1507269
     /* 1507269 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1507351), // Rule ID 17941 //
     /* 1507274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507313 */     // MIs[0] round
     /* 1507313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507316 */     // MIs[0] policy
     /* 1507316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507326 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1507329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507350 */     // GIR_Coverage, 17941,
     /* 1507350 */     GIR_EraseRootFromParent_Done,
     /* 1507351 */   // Label 20978: @1507351
     /* 1507351 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1507433), // Rule ID 17944 //
     /* 1507356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1507373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1507391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507395 */     // MIs[0] round
     /* 1507395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507398 */     // MIs[0] policy
     /* 1507398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1507411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507432 */     // GIR_Coverage, 17944,
     /* 1507432 */     GIR_EraseRootFromParent_Done,
     /* 1507433 */   // Label 20979: @1507433
     /* 1507433 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1507515), // Rule ID 17945 //
     /* 1507438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1507455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1507473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507477 */     // MIs[0] round
     /* 1507477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507480 */     // MIs[0] policy
     /* 1507480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1507493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507514 */     // GIR_Coverage, 17945,
     /* 1507514 */     GIR_EraseRootFromParent_Done,
     /* 1507515 */   // Label 20980: @1507515
     /* 1507515 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1507597), // Rule ID 17948 //
     /* 1507520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507559 */     // MIs[0] round
     /* 1507559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507562 */     // MIs[0] policy
     /* 1507562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507572 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1507575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507596 */     // GIR_Coverage, 17948,
     /* 1507596 */     GIR_EraseRootFromParent_Done,
     /* 1507597 */   // Label 20981: @1507597
     /* 1507597 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1507679), // Rule ID 17949 //
     /* 1507602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507641 */     // MIs[0] round
     /* 1507641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507644 */     // MIs[0] policy
     /* 1507644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507654 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1507657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507678 */     // GIR_Coverage, 17949,
     /* 1507678 */     GIR_EraseRootFromParent_Done,
     /* 1507679 */   // Label 20982: @1507679
     /* 1507679 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1507761), // Rule ID 17952 //
     /* 1507684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507723 */     // MIs[0] round
     /* 1507723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507726 */     // MIs[0] policy
     /* 1507726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507736 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1507739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507760 */     // GIR_Coverage, 17952,
     /* 1507760 */     GIR_EraseRootFromParent_Done,
     /* 1507761 */   // Label 20983: @1507761
     /* 1507761 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1507843), // Rule ID 17953 //
     /* 1507766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507805 */     // MIs[0] round
     /* 1507805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507808 */     // MIs[0] policy
     /* 1507808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507818 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1507821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507842 */     // GIR_Coverage, 17953,
     /* 1507842 */     GIR_EraseRootFromParent_Done,
     /* 1507843 */   // Label 20984: @1507843
     /* 1507843 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1507925), // Rule ID 17956 //
     /* 1507848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507887 */     // MIs[0] round
     /* 1507887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507890 */     // MIs[0] policy
     /* 1507890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507900 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1507903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507924 */     // GIR_Coverage, 17956,
     /* 1507924 */     GIR_EraseRootFromParent_Done,
     /* 1507925 */   // Label 20985: @1507925
     /* 1507925 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1508007), // Rule ID 17957 //
     /* 1507930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507969 */     // MIs[0] round
     /* 1507969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507972 */     // MIs[0] policy
     /* 1507972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1507985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508006 */     // GIR_Coverage, 17957,
     /* 1508006 */     GIR_EraseRootFromParent_Done,
     /* 1508007 */   // Label 20986: @1508007
     /* 1508007 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1508089), // Rule ID 17960 //
     /* 1508012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508051 */     // MIs[0] round
     /* 1508051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508054 */     // MIs[0] policy
     /* 1508054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508064 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1508067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508088 */     // GIR_Coverage, 17960,
     /* 1508088 */     GIR_EraseRootFromParent_Done,
     /* 1508089 */   // Label 20987: @1508089
     /* 1508089 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1508171), // Rule ID 17961 //
     /* 1508094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508133 */     // MIs[0] round
     /* 1508133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508136 */     // MIs[0] policy
     /* 1508136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1508149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508170 */     // GIR_Coverage, 17961,
     /* 1508170 */     GIR_EraseRootFromParent_Done,
     /* 1508171 */   // Label 20988: @1508171
     /* 1508171 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1508253), // Rule ID 17964 //
     /* 1508176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508215 */     // MIs[0] round
     /* 1508215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508218 */     // MIs[0] policy
     /* 1508218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508228 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1508231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508252 */     // GIR_Coverage, 17964,
     /* 1508252 */     GIR_EraseRootFromParent_Done,
     /* 1508253 */   // Label 20989: @1508253
     /* 1508253 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1508335), // Rule ID 17965 //
     /* 1508258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508297 */     // MIs[0] round
     /* 1508297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508300 */     // MIs[0] policy
     /* 1508300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508310 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1508313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508334 */     // GIR_Coverage, 17965,
     /* 1508334 */     GIR_EraseRootFromParent_Done,
     /* 1508335 */   // Label 20990: @1508335
     /* 1508335 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1508417), // Rule ID 17968 //
     /* 1508340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508379 */     // MIs[0] round
     /* 1508379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508382 */     // MIs[0] policy
     /* 1508382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1508395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508416 */     // GIR_Coverage, 17968,
     /* 1508416 */     GIR_EraseRootFromParent_Done,
     /* 1508417 */   // Label 20991: @1508417
     /* 1508417 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1508499), // Rule ID 17969 //
     /* 1508422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508461 */     // MIs[0] round
     /* 1508461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508464 */     // MIs[0] policy
     /* 1508464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508474 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1508477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508498 */     // GIR_Coverage, 17969,
     /* 1508498 */     GIR_EraseRootFromParent_Done,
     /* 1508499 */   // Label 20992: @1508499
     /* 1508499 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1508581), // Rule ID 17972 //
     /* 1508504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508543 */     // MIs[0] round
     /* 1508543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508546 */     // MIs[0] policy
     /* 1508546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1508559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508580 */     // GIR_Coverage, 17972,
     /* 1508580 */     GIR_EraseRootFromParent_Done,
     /* 1508581 */   // Label 20993: @1508581
     /* 1508581 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1508663), // Rule ID 17973 //
     /* 1508586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508625 */     // MIs[0] round
     /* 1508625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508628 */     // MIs[0] policy
     /* 1508628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1508641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508662 */     // GIR_Coverage, 17973,
     /* 1508662 */     GIR_EraseRootFromParent_Done,
     /* 1508663 */   // Label 20994: @1508663
     /* 1508663 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1508745), // Rule ID 17976 //
     /* 1508668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508707 */     // MIs[0] round
     /* 1508707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508710 */     // MIs[0] policy
     /* 1508710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508720 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1508723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508744 */     // GIR_Coverage, 17976,
     /* 1508744 */     GIR_EraseRootFromParent_Done,
     /* 1508745 */   // Label 20995: @1508745
     /* 1508745 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1508827), // Rule ID 17977 //
     /* 1508750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508789 */     // MIs[0] round
     /* 1508789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508792 */     // MIs[0] policy
     /* 1508792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508802 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1508805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508826 */     // GIR_Coverage, 17977,
     /* 1508826 */     GIR_EraseRootFromParent_Done,
     /* 1508827 */   // Label 20996: @1508827
     /* 1508827 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1508909), // Rule ID 17980 //
     /* 1508832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508871 */     // MIs[0] round
     /* 1508871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508874 */     // MIs[0] policy
     /* 1508874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1508887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508908 */     // GIR_Coverage, 17980,
     /* 1508908 */     GIR_EraseRootFromParent_Done,
     /* 1508909 */   // Label 20997: @1508909
     /* 1508909 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1508991), // Rule ID 17981 //
     /* 1508914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508953 */     // MIs[0] round
     /* 1508953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508956 */     // MIs[0] policy
     /* 1508956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1508969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508990 */     // GIR_Coverage, 17981,
     /* 1508990 */     GIR_EraseRootFromParent_Done,
     /* 1508991 */   // Label 20998: @1508991
     /* 1508991 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1509073), // Rule ID 17984 //
     /* 1508996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1509013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509035 */     // MIs[0] round
     /* 1509035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509038 */     // MIs[0] policy
     /* 1509038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509048 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1509051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509072 */     // GIR_Coverage, 17984,
     /* 1509072 */     GIR_EraseRootFromParent_Done,
     /* 1509073 */   // Label 20999: @1509073
     /* 1509073 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1509155), // Rule ID 17985 //
     /* 1509078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1509095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509117 */     // MIs[0] round
     /* 1509117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509120 */     // MIs[0] policy
     /* 1509120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509130 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1509133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509154 */     // GIR_Coverage, 17985,
     /* 1509154 */     GIR_EraseRootFromParent_Done,
     /* 1509155 */   // Label 21000: @1509155
     /* 1509155 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1509237), // Rule ID 17988 //
     /* 1509160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1509177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509199 */     // MIs[0] round
     /* 1509199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509202 */     // MIs[0] policy
     /* 1509202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509212 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1509215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509236 */     // GIR_Coverage, 17988,
     /* 1509236 */     GIR_EraseRootFromParent_Done,
     /* 1509237 */   // Label 21001: @1509237
     /* 1509237 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1509319), // Rule ID 17989 //
     /* 1509242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1509259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509281 */     // MIs[0] round
     /* 1509281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509284 */     // MIs[0] policy
     /* 1509284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509294 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1509297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509318 */     // GIR_Coverage, 17989,
     /* 1509318 */     GIR_EraseRootFromParent_Done,
     /* 1509319 */   // Label 21002: @1509319
     /* 1509319 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1509401), // Rule ID 17992 //
     /* 1509324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1509341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509363 */     // MIs[0] round
     /* 1509363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509366 */     // MIs[0] policy
     /* 1509366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509376 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1509379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509400 */     // GIR_Coverage, 17992,
     /* 1509400 */     GIR_EraseRootFromParent_Done,
     /* 1509401 */   // Label 21003: @1509401
     /* 1509401 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1509483), // Rule ID 17993 //
     /* 1509406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1509423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509445 */     // MIs[0] round
     /* 1509445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509448 */     // MIs[0] policy
     /* 1509448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509458 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1509461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509482 */     // GIR_Coverage, 17993,
     /* 1509482 */     GIR_EraseRootFromParent_Done,
     /* 1509483 */   // Label 21004: @1509483
     /* 1509483 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1509565), // Rule ID 17996 //
     /* 1509488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1509505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509527 */     // MIs[0] round
     /* 1509527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509530 */     // MIs[0] policy
     /* 1509530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509540 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1509543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509564 */     // GIR_Coverage, 17996,
     /* 1509564 */     GIR_EraseRootFromParent_Done,
     /* 1509565 */   // Label 21005: @1509565
     /* 1509565 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1509647), // Rule ID 17997 //
     /* 1509570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1509587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509609 */     // MIs[0] round
     /* 1509609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509612 */     // MIs[0] policy
     /* 1509612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1509625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509646 */     // GIR_Coverage, 17997,
     /* 1509646 */     GIR_EraseRootFromParent_Done,
     /* 1509647 */   // Label 21006: @1509647
     /* 1509647 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1509729), // Rule ID 18000 //
     /* 1509652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1509669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509691 */     // MIs[0] round
     /* 1509691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509694 */     // MIs[0] policy
     /* 1509694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1509707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509728 */     // GIR_Coverage, 18000,
     /* 1509728 */     GIR_EraseRootFromParent_Done,
     /* 1509729 */   // Label 21007: @1509729
     /* 1509729 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1509811), // Rule ID 18001 //
     /* 1509734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1509751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509773 */     // MIs[0] round
     /* 1509773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509776 */     // MIs[0] policy
     /* 1509776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509786 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1509789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509810 */     // GIR_Coverage, 18001,
     /* 1509810 */     GIR_EraseRootFromParent_Done,
     /* 1509811 */   // Label 21008: @1509811
     /* 1509811 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1509893), // Rule ID 18004 //
     /* 1509816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1509833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509855 */     // MIs[0] round
     /* 1509855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509858 */     // MIs[0] policy
     /* 1509858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1509871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509892 */     // GIR_Coverage, 18004,
     /* 1509892 */     GIR_EraseRootFromParent_Done,
     /* 1509893 */   // Label 21009: @1509893
     /* 1509893 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1509975), // Rule ID 18005 //
     /* 1509898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1509915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509937 */     // MIs[0] round
     /* 1509937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509940 */     // MIs[0] policy
     /* 1509940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509950 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1509953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509974 */     // GIR_Coverage, 18005,
     /* 1509974 */     GIR_EraseRootFromParent_Done,
     /* 1509975 */   // Label 21010: @1509975
     /* 1509975 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1510057), // Rule ID 18008 //
     /* 1509980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1509991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1509994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1509997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510019 */     // MIs[0] round
     /* 1510019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510022 */     // MIs[0] policy
     /* 1510022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1510035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510056 */     // GIR_Coverage, 18008,
     /* 1510056 */     GIR_EraseRootFromParent_Done,
     /* 1510057 */   // Label 21011: @1510057
     /* 1510057 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1510139), // Rule ID 18009 //
     /* 1510062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1510079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510101 */     // MIs[0] round
     /* 1510101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510104 */     // MIs[0] policy
     /* 1510104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1510117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510138 */     // GIR_Coverage, 18009,
     /* 1510138 */     GIR_EraseRootFromParent_Done,
     /* 1510139 */   // Label 21012: @1510139
     /* 1510139 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1510221), // Rule ID 18012 //
     /* 1510144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510183 */     // MIs[0] round
     /* 1510183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510186 */     // MIs[0] policy
     /* 1510186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510196 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1510199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510220 */     // GIR_Coverage, 18012,
     /* 1510220 */     GIR_EraseRootFromParent_Done,
     /* 1510221 */   // Label 21013: @1510221
     /* 1510221 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1510303), // Rule ID 18013 //
     /* 1510226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510265 */     // MIs[0] round
     /* 1510265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510268 */     // MIs[0] policy
     /* 1510268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510278 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1510281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510302 */     // GIR_Coverage, 18013,
     /* 1510302 */     GIR_EraseRootFromParent_Done,
     /* 1510303 */   // Label 21014: @1510303
     /* 1510303 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1510385), // Rule ID 18016 //
     /* 1510308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510347 */     // MIs[0] round
     /* 1510347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510350 */     // MIs[0] policy
     /* 1510350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510360 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1510363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510384 */     // GIR_Coverage, 18016,
     /* 1510384 */     GIR_EraseRootFromParent_Done,
     /* 1510385 */   // Label 21015: @1510385
     /* 1510385 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1510467), // Rule ID 18017 //
     /* 1510390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510429 */     // MIs[0] round
     /* 1510429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510432 */     // MIs[0] policy
     /* 1510432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510442 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1510445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510466 */     // GIR_Coverage, 18017,
     /* 1510466 */     GIR_EraseRootFromParent_Done,
     /* 1510467 */   // Label 21016: @1510467
     /* 1510467 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1510549), // Rule ID 18020 //
     /* 1510472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1510489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510511 */     // MIs[0] round
     /* 1510511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510514 */     // MIs[0] policy
     /* 1510514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1510527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510548 */     // GIR_Coverage, 18020,
     /* 1510548 */     GIR_EraseRootFromParent_Done,
     /* 1510549 */   // Label 21017: @1510549
     /* 1510549 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1510631), // Rule ID 18021 //
     /* 1510554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1510571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510593 */     // MIs[0] round
     /* 1510593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510596 */     // MIs[0] policy
     /* 1510596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1510609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510630 */     // GIR_Coverage, 18021,
     /* 1510630 */     GIR_EraseRootFromParent_Done,
     /* 1510631 */   // Label 21018: @1510631
     /* 1510631 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1510713), // Rule ID 18024 //
     /* 1510636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1510653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510675 */     // MIs[0] round
     /* 1510675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510678 */     // MIs[0] policy
     /* 1510678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510688 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1510691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510712 */     // GIR_Coverage, 18024,
     /* 1510712 */     GIR_EraseRootFromParent_Done,
     /* 1510713 */   // Label 21019: @1510713
     /* 1510713 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1510795), // Rule ID 18025 //
     /* 1510718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1510735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510757 */     // MIs[0] round
     /* 1510757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510760 */     // MIs[0] policy
     /* 1510760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1510773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510794 */     // GIR_Coverage, 18025,
     /* 1510794 */     GIR_EraseRootFromParent_Done,
     /* 1510795 */   // Label 21020: @1510795
     /* 1510795 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1510877), // Rule ID 18028 //
     /* 1510800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1510817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510839 */     // MIs[0] round
     /* 1510839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510842 */     // MIs[0] policy
     /* 1510842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510852 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1510855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510876 */     // GIR_Coverage, 18028,
     /* 1510876 */     GIR_EraseRootFromParent_Done,
     /* 1510877 */   // Label 21021: @1510877
     /* 1510877 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1510959), // Rule ID 18029 //
     /* 1510882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1510899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510921 */     // MIs[0] round
     /* 1510921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510924 */     // MIs[0] policy
     /* 1510924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1510937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510958 */     // GIR_Coverage, 18029,
     /* 1510958 */     GIR_EraseRootFromParent_Done,
     /* 1510959 */   // Label 21022: @1510959
     /* 1510959 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1511041), // Rule ID 18032 //
     /* 1510964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1510972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1510975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1510978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1510981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1510984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511003 */     // MIs[0] round
     /* 1511003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511006 */     // MIs[0] policy
     /* 1511006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511016 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1511019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511040 */     // GIR_Coverage, 18032,
     /* 1511040 */     GIR_EraseRootFromParent_Done,
     /* 1511041 */   // Label 21023: @1511041
     /* 1511041 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1511123), // Rule ID 18033 //
     /* 1511046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1511063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511085 */     // MIs[0] round
     /* 1511085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511088 */     // MIs[0] policy
     /* 1511088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1511101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511122 */     // GIR_Coverage, 18033,
     /* 1511122 */     GIR_EraseRootFromParent_Done,
     /* 1511123 */   // Label 21024: @1511123
     /* 1511123 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1511205), // Rule ID 18036 //
     /* 1511128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511167 */     // MIs[0] round
     /* 1511167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511170 */     // MIs[0] policy
     /* 1511170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1511183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511204 */     // GIR_Coverage, 18036,
     /* 1511204 */     GIR_EraseRootFromParent_Done,
     /* 1511205 */   // Label 21025: @1511205
     /* 1511205 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1511287), // Rule ID 18037 //
     /* 1511210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511249 */     // MIs[0] round
     /* 1511249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511252 */     // MIs[0] policy
     /* 1511252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1511265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511286 */     // GIR_Coverage, 18037,
     /* 1511286 */     GIR_EraseRootFromParent_Done,
     /* 1511287 */   // Label 21026: @1511287
     /* 1511287 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1511369), // Rule ID 18040 //
     /* 1511292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511331 */     // MIs[0] round
     /* 1511331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511334 */     // MIs[0] policy
     /* 1511334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1511347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511368 */     // GIR_Coverage, 18040,
     /* 1511368 */     GIR_EraseRootFromParent_Done,
     /* 1511369 */   // Label 21027: @1511369
     /* 1511369 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1511451), // Rule ID 18041 //
     /* 1511374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511413 */     // MIs[0] round
     /* 1511413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511416 */     // MIs[0] policy
     /* 1511416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1511429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511450 */     // GIR_Coverage, 18041,
     /* 1511450 */     GIR_EraseRootFromParent_Done,
     /* 1511451 */   // Label 21028: @1511451
     /* 1511451 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1511533), // Rule ID 18044 //
     /* 1511456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1511473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1511491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511495 */     // MIs[0] round
     /* 1511495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511498 */     // MIs[0] policy
     /* 1511498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511508 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1511511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511532 */     // GIR_Coverage, 18044,
     /* 1511532 */     GIR_EraseRootFromParent_Done,
     /* 1511533 */   // Label 21029: @1511533
     /* 1511533 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1511615), // Rule ID 18045 //
     /* 1511538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1511555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1511573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511577 */     // MIs[0] round
     /* 1511577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511580 */     // MIs[0] policy
     /* 1511580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511590 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1511593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511614 */     // GIR_Coverage, 18045,
     /* 1511614 */     GIR_EraseRootFromParent_Done,
     /* 1511615 */   // Label 21030: @1511615
     /* 1511615 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1511697), // Rule ID 18048 //
     /* 1511620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1511637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1511655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511659 */     // MIs[0] round
     /* 1511659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511662 */     // MIs[0] policy
     /* 1511662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1511675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511696 */     // GIR_Coverage, 18048,
     /* 1511696 */     GIR_EraseRootFromParent_Done,
     /* 1511697 */   // Label 21031: @1511697
     /* 1511697 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1511779), // Rule ID 18049 //
     /* 1511702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1511719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1511737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511741 */     // MIs[0] round
     /* 1511741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511744 */     // MIs[0] policy
     /* 1511744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511754 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1511757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511778 */     // GIR_Coverage, 18049,
     /* 1511778 */     GIR_EraseRootFromParent_Done,
     /* 1511779 */   // Label 21032: @1511779
     /* 1511779 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1511861), // Rule ID 18052 //
     /* 1511784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511823 */     // MIs[0] round
     /* 1511823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511826 */     // MIs[0] policy
     /* 1511826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1511839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511860 */     // GIR_Coverage, 18052,
     /* 1511860 */     GIR_EraseRootFromParent_Done,
     /* 1511861 */   // Label 21033: @1511861
     /* 1511861 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1511943), // Rule ID 18053 //
     /* 1511866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1511883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1511901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511905 */     // MIs[0] round
     /* 1511905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511908 */     // MIs[0] policy
     /* 1511908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511918 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1511921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511942 */     // GIR_Coverage, 18053,
     /* 1511942 */     GIR_EraseRootFromParent_Done,
     /* 1511943 */   // Label 21034: @1511943
     /* 1511943 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1512025), // Rule ID 18056 //
     /* 1511948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1511959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1511962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1511965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1511968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1511983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511987 */     // MIs[0] round
     /* 1511987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511990 */     // MIs[0] policy
     /* 1511990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1512003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512024 */     // GIR_Coverage, 18056,
     /* 1512024 */     GIR_EraseRootFromParent_Done,
     /* 1512025 */   // Label 21035: @1512025
     /* 1512025 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1512107), // Rule ID 18057 //
     /* 1512030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512069 */     // MIs[0] round
     /* 1512069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512072 */     // MIs[0] policy
     /* 1512072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512082 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11153:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1512085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512106 */     // GIR_Coverage, 18057,
     /* 1512106 */     GIR_EraseRootFromParent_Done,
     /* 1512107 */   // Label 21036: @1512107
     /* 1512107 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1512189), // Rule ID 18060 //
     /* 1512112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512151 */     // MIs[0] round
     /* 1512151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512154 */     // MIs[0] policy
     /* 1512154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1512167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512188 */     // GIR_Coverage, 18060,
     /* 1512188 */     GIR_EraseRootFromParent_Done,
     /* 1512189 */   // Label 21037: @1512189
     /* 1512189 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1512271), // Rule ID 18061 //
     /* 1512194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512233 */     // MIs[0] round
     /* 1512233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512236 */     // MIs[0] policy
     /* 1512236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512246 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1512249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512270 */     // GIR_Coverage, 18061,
     /* 1512270 */     GIR_EraseRootFromParent_Done,
     /* 1512271 */   // Label 21038: @1512271
     /* 1512271 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1512353), // Rule ID 18064 //
     /* 1512276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1512293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1512311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512315 */     // MIs[0] round
     /* 1512315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512318 */     // MIs[0] policy
     /* 1512318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1512331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512352 */     // GIR_Coverage, 18064,
     /* 1512352 */     GIR_EraseRootFromParent_Done,
     /* 1512353 */   // Label 21039: @1512353
     /* 1512353 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1512435), // Rule ID 18065 //
     /* 1512358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1512375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1512393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512397 */     // MIs[0] round
     /* 1512397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512400 */     // MIs[0] policy
     /* 1512400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1512413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512434 */     // GIR_Coverage, 18065,
     /* 1512434 */     GIR_EraseRootFromParent_Done,
     /* 1512435 */   // Label 21040: @1512435
     /* 1512435 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1512517), // Rule ID 18068 //
     /* 1512440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512479 */     // MIs[0] round
     /* 1512479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512482 */     // MIs[0] policy
     /* 1512482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512492 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1512495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512516 */     // GIR_Coverage, 18068,
     /* 1512516 */     GIR_EraseRootFromParent_Done,
     /* 1512517 */   // Label 21041: @1512517
     /* 1512517 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1512599), // Rule ID 18069 //
     /* 1512522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512561 */     // MIs[0] round
     /* 1512561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512564 */     // MIs[0] policy
     /* 1512564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1512577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512598 */     // GIR_Coverage, 18069,
     /* 1512598 */     GIR_EraseRootFromParent_Done,
     /* 1512599 */   // Label 21042: @1512599
     /* 1512599 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1512681), // Rule ID 18072 //
     /* 1512604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512643 */     // MIs[0] round
     /* 1512643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512646 */     // MIs[0] policy
     /* 1512646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512656 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1512659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512680 */     // GIR_Coverage, 18072,
     /* 1512680 */     GIR_EraseRootFromParent_Done,
     /* 1512681 */   // Label 21043: @1512681
     /* 1512681 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1512763), // Rule ID 18073 //
     /* 1512686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512725 */     // MIs[0] round
     /* 1512725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512728 */     // MIs[0] policy
     /* 1512728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512738 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1512741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512762 */     // GIR_Coverage, 18073,
     /* 1512762 */     GIR_EraseRootFromParent_Done,
     /* 1512763 */   // Label 21044: @1512763
     /* 1512763 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1512845), // Rule ID 18076 //
     /* 1512768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512807 */     // MIs[0] round
     /* 1512807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512810 */     // MIs[0] policy
     /* 1512810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512820 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1512823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512844 */     // GIR_Coverage, 18076,
     /* 1512844 */     GIR_EraseRootFromParent_Done,
     /* 1512845 */   // Label 21045: @1512845
     /* 1512845 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1512927), // Rule ID 18077 //
     /* 1512850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512889 */     // MIs[0] round
     /* 1512889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512892 */     // MIs[0] policy
     /* 1512892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512902 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1512905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512926 */     // GIR_Coverage, 18077,
     /* 1512926 */     GIR_EraseRootFromParent_Done,
     /* 1512927 */   // Label 21046: @1512927
     /* 1512927 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1513009), // Rule ID 18080 //
     /* 1512932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1512943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1512946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1512952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512971 */     // MIs[0] round
     /* 1512971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512974 */     // MIs[0] policy
     /* 1512974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1512987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513008 */     // GIR_Coverage, 18080,
     /* 1513008 */     GIR_EraseRootFromParent_Done,
     /* 1513009 */   // Label 21047: @1513009
     /* 1513009 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1513091), // Rule ID 18081 //
     /* 1513014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513053 */     // MIs[0] round
     /* 1513053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513056 */     // MIs[0] policy
     /* 1513056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1513069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513090 */     // GIR_Coverage, 18081,
     /* 1513090 */     GIR_EraseRootFromParent_Done,
     /* 1513091 */   // Label 21048: @1513091
     /* 1513091 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1513173), // Rule ID 18084 //
     /* 1513096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513135 */     // MIs[0] round
     /* 1513135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513138 */     // MIs[0] policy
     /* 1513138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1513151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513172 */     // GIR_Coverage, 18084,
     /* 1513172 */     GIR_EraseRootFromParent_Done,
     /* 1513173 */   // Label 21049: @1513173
     /* 1513173 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1513255), // Rule ID 18085 //
     /* 1513178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513217 */     // MIs[0] round
     /* 1513217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513220 */     // MIs[0] policy
     /* 1513220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1513233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513254 */     // GIR_Coverage, 18085,
     /* 1513254 */     GIR_EraseRootFromParent_Done,
     /* 1513255 */   // Label 21050: @1513255
     /* 1513255 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1513337), // Rule ID 18088 //
     /* 1513260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513299 */     // MIs[0] round
     /* 1513299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513302 */     // MIs[0] policy
     /* 1513302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1513315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513336 */     // GIR_Coverage, 18088,
     /* 1513336 */     GIR_EraseRootFromParent_Done,
     /* 1513337 */   // Label 21051: @1513337
     /* 1513337 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1513419), // Rule ID 18089 //
     /* 1513342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513381 */     // MIs[0] round
     /* 1513381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513384 */     // MIs[0] policy
     /* 1513384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513394 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1513397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513418 */     // GIR_Coverage, 18089,
     /* 1513418 */     GIR_EraseRootFromParent_Done,
     /* 1513419 */   // Label 21052: @1513419
     /* 1513419 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1513501), // Rule ID 18092 //
     /* 1513424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513463 */     // MIs[0] round
     /* 1513463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513466 */     // MIs[0] policy
     /* 1513466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1513479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513500 */     // GIR_Coverage, 18092,
     /* 1513500 */     GIR_EraseRootFromParent_Done,
     /* 1513501 */   // Label 21053: @1513501
     /* 1513501 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1513583), // Rule ID 18093 //
     /* 1513506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513545 */     // MIs[0] round
     /* 1513545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513548 */     // MIs[0] policy
     /* 1513548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1513561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513582 */     // GIR_Coverage, 18093,
     /* 1513582 */     GIR_EraseRootFromParent_Done,
     /* 1513583 */   // Label 21054: @1513583
     /* 1513583 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1513665), // Rule ID 18096 //
     /* 1513588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513627 */     // MIs[0] round
     /* 1513627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513630 */     // MIs[0] policy
     /* 1513630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513640 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1513643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513664 */     // GIR_Coverage, 18096,
     /* 1513664 */     GIR_EraseRootFromParent_Done,
     /* 1513665 */   // Label 21055: @1513665
     /* 1513665 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1513747), // Rule ID 18097 //
     /* 1513670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513709 */     // MIs[0] round
     /* 1513709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513712 */     // MIs[0] policy
     /* 1513712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513722 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1513725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513746 */     // GIR_Coverage, 18097,
     /* 1513746 */     GIR_EraseRootFromParent_Done,
     /* 1513747 */   // Label 21056: @1513747
     /* 1513747 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1513829), // Rule ID 18100 //
     /* 1513752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513791 */     // MIs[0] round
     /* 1513791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513794 */     // MIs[0] policy
     /* 1513794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1513807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513828 */     // GIR_Coverage, 18100,
     /* 1513828 */     GIR_EraseRootFromParent_Done,
     /* 1513829 */   // Label 21057: @1513829
     /* 1513829 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1513911), // Rule ID 18101 //
     /* 1513834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1513851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1513869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513873 */     // MIs[0] round
     /* 1513873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513876 */     // MIs[0] policy
     /* 1513876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513886 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1513889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513910 */     // GIR_Coverage, 18101,
     /* 1513910 */     GIR_EraseRootFromParent_Done,
     /* 1513911 */   // Label 21058: @1513911
     /* 1513911 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1513993), // Rule ID 18104 //
     /* 1513916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1513927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1513930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1513933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1513936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513955 */     // MIs[0] round
     /* 1513955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513958 */     // MIs[0] policy
     /* 1513958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513968 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1513971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513992 */     // GIR_Coverage, 18104,
     /* 1513992 */     GIR_EraseRootFromParent_Done,
     /* 1513993 */   // Label 21059: @1513993
     /* 1513993 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1514075), // Rule ID 18105 //
     /* 1513998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1514015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514037 */     // MIs[0] round
     /* 1514037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514040 */     // MIs[0] policy
     /* 1514040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1514053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514074 */     // GIR_Coverage, 18105,
     /* 1514074 */     GIR_EraseRootFromParent_Done,
     /* 1514075 */   // Label 21060: @1514075
     /* 1514075 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1514157), // Rule ID 18108 //
     /* 1514080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1514097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514119 */     // MIs[0] round
     /* 1514119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514122 */     // MIs[0] policy
     /* 1514122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1514135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514156 */     // GIR_Coverage, 18108,
     /* 1514156 */     GIR_EraseRootFromParent_Done,
     /* 1514157 */   // Label 21061: @1514157
     /* 1514157 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1514239), // Rule ID 18109 //
     /* 1514162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1514179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514201 */     // MIs[0] round
     /* 1514201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514204 */     // MIs[0] policy
     /* 1514204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514214 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1514217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514238 */     // GIR_Coverage, 18109,
     /* 1514238 */     GIR_EraseRootFromParent_Done,
     /* 1514239 */   // Label 21062: @1514239
     /* 1514239 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1514321), // Rule ID 18112 //
     /* 1514244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1514261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514283 */     // MIs[0] round
     /* 1514283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514286 */     // MIs[0] policy
     /* 1514286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514296 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1514299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514320 */     // GIR_Coverage, 18112,
     /* 1514320 */     GIR_EraseRootFromParent_Done,
     /* 1514321 */   // Label 21063: @1514321
     /* 1514321 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1514403), // Rule ID 18113 //
     /* 1514326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1514343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514365 */     // MIs[0] round
     /* 1514365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514368 */     // MIs[0] policy
     /* 1514368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514378 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1514381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514402 */     // GIR_Coverage, 18113,
     /* 1514402 */     GIR_EraseRootFromParent_Done,
     /* 1514403 */   // Label 21064: @1514403
     /* 1514403 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1514485), // Rule ID 18116 //
     /* 1514408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1514425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514447 */     // MIs[0] round
     /* 1514447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514450 */     // MIs[0] policy
     /* 1514450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1514463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514484 */     // GIR_Coverage, 18116,
     /* 1514484 */     GIR_EraseRootFromParent_Done,
     /* 1514485 */   // Label 21065: @1514485
     /* 1514485 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1514567), // Rule ID 18117 //
     /* 1514490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1514507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514529 */     // MIs[0] round
     /* 1514529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514532 */     // MIs[0] policy
     /* 1514532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1514545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514566 */     // GIR_Coverage, 18117,
     /* 1514566 */     GIR_EraseRootFromParent_Done,
     /* 1514567 */   // Label 21066: @1514567
     /* 1514567 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1514649), // Rule ID 18120 //
     /* 1514572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1514589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514611 */     // MIs[0] round
     /* 1514611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514614 */     // MIs[0] policy
     /* 1514614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1514627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514648 */     // GIR_Coverage, 18120,
     /* 1514648 */     GIR_EraseRootFromParent_Done,
     /* 1514649 */   // Label 21067: @1514649
     /* 1514649 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1514731), // Rule ID 18121 //
     /* 1514654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1514671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514693 */     // MIs[0] round
     /* 1514693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514696 */     // MIs[0] policy
     /* 1514696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514706 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1514709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514730 */     // GIR_Coverage, 18121,
     /* 1514730 */     GIR_EraseRootFromParent_Done,
     /* 1514731 */   // Label 21068: @1514731
     /* 1514731 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1514813), // Rule ID 18124 //
     /* 1514736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1514753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514775 */     // MIs[0] round
     /* 1514775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514778 */     // MIs[0] policy
     /* 1514778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514788 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1514791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514812 */     // GIR_Coverage, 18124,
     /* 1514812 */     GIR_EraseRootFromParent_Done,
     /* 1514813 */   // Label 21069: @1514813
     /* 1514813 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1514895), // Rule ID 18125 //
     /* 1514818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1514835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514857 */     // MIs[0] round
     /* 1514857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514860 */     // MIs[0] policy
     /* 1514860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1514873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514894 */     // GIR_Coverage, 18125,
     /* 1514894 */     GIR_EraseRootFromParent_Done,
     /* 1514895 */   // Label 21070: @1514895
     /* 1514895 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1514977), // Rule ID 18128 //
     /* 1514900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1514917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1514920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514939 */     // MIs[0] round
     /* 1514939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514942 */     // MIs[0] policy
     /* 1514942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514952 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1514955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514976 */     // GIR_Coverage, 18128,
     /* 1514976 */     GIR_EraseRootFromParent_Done,
     /* 1514977 */   // Label 21071: @1514977
     /* 1514977 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1515059), // Rule ID 18129 //
     /* 1514982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1514999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515021 */     // MIs[0] round
     /* 1515021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515024 */     // MIs[0] policy
     /* 1515024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515034 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1515037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515058 */     // GIR_Coverage, 18129,
     /* 1515058 */     GIR_EraseRootFromParent_Done,
     /* 1515059 */   // Label 21072: @1515059
     /* 1515059 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1515141), // Rule ID 18132 //
     /* 1515064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1515081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515103 */     // MIs[0] round
     /* 1515103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515106 */     // MIs[0] policy
     /* 1515106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1515119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515140 */     // GIR_Coverage, 18132,
     /* 1515140 */     GIR_EraseRootFromParent_Done,
     /* 1515141 */   // Label 21073: @1515141
     /* 1515141 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1515223), // Rule ID 18133 //
     /* 1515146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1515163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515185 */     // MIs[0] round
     /* 1515185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515188 */     // MIs[0] policy
     /* 1515188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515198 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1515201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515222 */     // GIR_Coverage, 18133,
     /* 1515222 */     GIR_EraseRootFromParent_Done,
     /* 1515223 */   // Label 21074: @1515223
     /* 1515223 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1515305), // Rule ID 18136 //
     /* 1515228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1515245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515267 */     // MIs[0] round
     /* 1515267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515270 */     // MIs[0] policy
     /* 1515270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515280 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1515283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515304 */     // GIR_Coverage, 18136,
     /* 1515304 */     GIR_EraseRootFromParent_Done,
     /* 1515305 */   // Label 21075: @1515305
     /* 1515305 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1515387), // Rule ID 18137 //
     /* 1515310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1515327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515349 */     // MIs[0] round
     /* 1515349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515352 */     // MIs[0] policy
     /* 1515352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515362 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1515365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515386 */     // GIR_Coverage, 18137,
     /* 1515386 */     GIR_EraseRootFromParent_Done,
     /* 1515387 */   // Label 21076: @1515387
     /* 1515387 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1515469), // Rule ID 18140 //
     /* 1515392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1515409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515431 */     // MIs[0] round
     /* 1515431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515434 */     // MIs[0] policy
     /* 1515434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1515447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515468 */     // GIR_Coverage, 18140,
     /* 1515468 */     GIR_EraseRootFromParent_Done,
     /* 1515469 */   // Label 21077: @1515469
     /* 1515469 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1515551), // Rule ID 18141 //
     /* 1515474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1515491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515513 */     // MIs[0] round
     /* 1515513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515516 */     // MIs[0] policy
     /* 1515516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515526 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1515529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515550 */     // GIR_Coverage, 18141,
     /* 1515550 */     GIR_EraseRootFromParent_Done,
     /* 1515551 */   // Label 21078: @1515551
     /* 1515551 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1515633), // Rule ID 18144 //
     /* 1515556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1515573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515595 */     // MIs[0] round
     /* 1515595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515598 */     // MIs[0] policy
     /* 1515598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515608 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1515611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515632 */     // GIR_Coverage, 18144,
     /* 1515632 */     GIR_EraseRootFromParent_Done,
     /* 1515633 */   // Label 21079: @1515633
     /* 1515633 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1515715), // Rule ID 18145 //
     /* 1515638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1515655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515677 */     // MIs[0] round
     /* 1515677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515680 */     // MIs[0] policy
     /* 1515680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1515693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515714 */     // GIR_Coverage, 18145,
     /* 1515714 */     GIR_EraseRootFromParent_Done,
     /* 1515715 */   // Label 21080: @1515715
     /* 1515715 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1515797), // Rule ID 18148 //
     /* 1515720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1515737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515759 */     // MIs[0] round
     /* 1515759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515762 */     // MIs[0] policy
     /* 1515762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515772 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1515775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515796 */     // GIR_Coverage, 18148,
     /* 1515796 */     GIR_EraseRootFromParent_Done,
     /* 1515797 */   // Label 21081: @1515797
     /* 1515797 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1515879), // Rule ID 18149 //
     /* 1515802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1515819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515841 */     // MIs[0] round
     /* 1515841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515844 */     // MIs[0] policy
     /* 1515844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515854 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1515857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515878 */     // GIR_Coverage, 18149,
     /* 1515878 */     GIR_EraseRootFromParent_Done,
     /* 1515879 */   // Label 21082: @1515879
     /* 1515879 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1515961), // Rule ID 18152 //
     /* 1515884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1515901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515923 */     // MIs[0] round
     /* 1515923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515926 */     // MIs[0] policy
     /* 1515926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1515939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515960 */     // GIR_Coverage, 18152,
     /* 1515960 */     GIR_EraseRootFromParent_Done,
     /* 1515961 */   // Label 21083: @1515961
     /* 1515961 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1516043), // Rule ID 18153 //
     /* 1515966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1515974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1515983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516005 */     // MIs[0] round
     /* 1516005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516008 */     // MIs[0] policy
     /* 1516008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516018 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1516021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516042 */     // GIR_Coverage, 18153,
     /* 1516042 */     GIR_EraseRootFromParent_Done,
     /* 1516043 */   // Label 21084: @1516043
     /* 1516043 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1516125), // Rule ID 18156 //
     /* 1516048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1516065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516087 */     // MIs[0] round
     /* 1516087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516090 */     // MIs[0] policy
     /* 1516090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1516103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516124 */     // GIR_Coverage, 18156,
     /* 1516124 */     GIR_EraseRootFromParent_Done,
     /* 1516125 */   // Label 21085: @1516125
     /* 1516125 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1516207), // Rule ID 18157 //
     /* 1516130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1516147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516169 */     // MIs[0] round
     /* 1516169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516172 */     // MIs[0] policy
     /* 1516172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516182 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1516185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516206 */     // GIR_Coverage, 18157,
     /* 1516206 */     GIR_EraseRootFromParent_Done,
     /* 1516207 */   // Label 21086: @1516207
     /* 1516207 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1516289), // Rule ID 18160 //
     /* 1516212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1516229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516251 */     // MIs[0] round
     /* 1516251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516254 */     // MIs[0] policy
     /* 1516254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516264 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1516267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516288 */     // GIR_Coverage, 18160,
     /* 1516288 */     GIR_EraseRootFromParent_Done,
     /* 1516289 */   // Label 21087: @1516289
     /* 1516289 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1516371), // Rule ID 18161 //
     /* 1516294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1516311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516333 */     // MIs[0] round
     /* 1516333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516336 */     // MIs[0] policy
     /* 1516336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516346 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1516349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516370 */     // GIR_Coverage, 18161,
     /* 1516370 */     GIR_EraseRootFromParent_Done,
     /* 1516371 */   // Label 21088: @1516371
     /* 1516371 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1516453), // Rule ID 18164 //
     /* 1516376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516415 */     // MIs[0] round
     /* 1516415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516418 */     // MIs[0] policy
     /* 1516418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516428 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1516431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516452 */     // GIR_Coverage, 18164,
     /* 1516452 */     GIR_EraseRootFromParent_Done,
     /* 1516453 */   // Label 21089: @1516453
     /* 1516453 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1516535), // Rule ID 18165 //
     /* 1516458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516497 */     // MIs[0] round
     /* 1516497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516500 */     // MIs[0] policy
     /* 1516500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516510 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1516513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516534 */     // GIR_Coverage, 18165,
     /* 1516534 */     GIR_EraseRootFromParent_Done,
     /* 1516535 */   // Label 21090: @1516535
     /* 1516535 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1516617), // Rule ID 18168 //
     /* 1516540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516579 */     // MIs[0] round
     /* 1516579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516582 */     // MIs[0] policy
     /* 1516582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1516595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516616 */     // GIR_Coverage, 18168,
     /* 1516616 */     GIR_EraseRootFromParent_Done,
     /* 1516617 */   // Label 21091: @1516617
     /* 1516617 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1516699), // Rule ID 18169 //
     /* 1516622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516661 */     // MIs[0] round
     /* 1516661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516664 */     // MIs[0] policy
     /* 1516664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516674 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1516677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516698 */     // GIR_Coverage, 18169,
     /* 1516698 */     GIR_EraseRootFromParent_Done,
     /* 1516699 */   // Label 21092: @1516699
     /* 1516699 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1516781), // Rule ID 18172 //
     /* 1516704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1516721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1516739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516743 */     // MIs[0] round
     /* 1516743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516746 */     // MIs[0] policy
     /* 1516746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516756 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1516759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516780 */     // GIR_Coverage, 18172,
     /* 1516780 */     GIR_EraseRootFromParent_Done,
     /* 1516781 */   // Label 21093: @1516781
     /* 1516781 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1516863), // Rule ID 18173 //
     /* 1516786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1516803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1516821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516825 */     // MIs[0] round
     /* 1516825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516828 */     // MIs[0] policy
     /* 1516828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516838 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1516841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516862 */     // GIR_Coverage, 18173,
     /* 1516862 */     GIR_EraseRootFromParent_Done,
     /* 1516863 */   // Label 21094: @1516863
     /* 1516863 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1516945), // Rule ID 18176 //
     /* 1516868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516907 */     // MIs[0] round
     /* 1516907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516910 */     // MIs[0] policy
     /* 1516910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516920 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1516923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516944 */     // GIR_Coverage, 18176,
     /* 1516944 */     GIR_EraseRootFromParent_Done,
     /* 1516945 */   // Label 21095: @1516945
     /* 1516945 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1517027), // Rule ID 18177 //
     /* 1516950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516989 */     // MIs[0] round
     /* 1516989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516992 */     // MIs[0] policy
     /* 1516992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1517005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517026 */     // GIR_Coverage, 18177,
     /* 1517026 */     GIR_EraseRootFromParent_Done,
     /* 1517027 */   // Label 21096: @1517027
     /* 1517027 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1517109), // Rule ID 18180 //
     /* 1517032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517071 */     // MIs[0] round
     /* 1517071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517074 */     // MIs[0] policy
     /* 1517074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1517087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517108 */     // GIR_Coverage, 18180,
     /* 1517108 */     GIR_EraseRootFromParent_Done,
     /* 1517109 */   // Label 21097: @1517109
     /* 1517109 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1517191), // Rule ID 18181 //
     /* 1517114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517153 */     // MIs[0] round
     /* 1517153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517156 */     // MIs[0] policy
     /* 1517156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517166 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1517169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517190 */     // GIR_Coverage, 18181,
     /* 1517190 */     GIR_EraseRootFromParent_Done,
     /* 1517191 */   // Label 21098: @1517191
     /* 1517191 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1517273), // Rule ID 18184 //
     /* 1517196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1517213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1517231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517235 */     // MIs[0] round
     /* 1517235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517238 */     // MIs[0] policy
     /* 1517238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1517251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517272 */     // GIR_Coverage, 18184,
     /* 1517272 */     GIR_EraseRootFromParent_Done,
     /* 1517273 */   // Label 21099: @1517273
     /* 1517273 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1517355), // Rule ID 18185 //
     /* 1517278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1517295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1517313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517317 */     // MIs[0] round
     /* 1517317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517320 */     // MIs[0] policy
     /* 1517320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1517333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517354 */     // GIR_Coverage, 18185,
     /* 1517354 */     GIR_EraseRootFromParent_Done,
     /* 1517355 */   // Label 21100: @1517355
     /* 1517355 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1517437), // Rule ID 18188 //
     /* 1517360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517399 */     // MIs[0] round
     /* 1517399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517402 */     // MIs[0] policy
     /* 1517402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1517415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517436 */     // GIR_Coverage, 18188,
     /* 1517436 */     GIR_EraseRootFromParent_Done,
     /* 1517437 */   // Label 21101: @1517437
     /* 1517437 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1517519), // Rule ID 18189 //
     /* 1517442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517481 */     // MIs[0] round
     /* 1517481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517484 */     // MIs[0] policy
     /* 1517484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517494 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1517497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517518 */     // GIR_Coverage, 18189,
     /* 1517518 */     GIR_EraseRootFromParent_Done,
     /* 1517519 */   // Label 21102: @1517519
     /* 1517519 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1517601), // Rule ID 18192 //
     /* 1517524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517563 */     // MIs[0] round
     /* 1517563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517566 */     // MIs[0] policy
     /* 1517566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517576 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1517579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517600 */     // GIR_Coverage, 18192,
     /* 1517600 */     GIR_EraseRootFromParent_Done,
     /* 1517601 */   // Label 21103: @1517601
     /* 1517601 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1517683), // Rule ID 18193 //
     /* 1517606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517645 */     // MIs[0] round
     /* 1517645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517648 */     // MIs[0] policy
     /* 1517648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517658 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1517661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517682 */     // GIR_Coverage, 18193,
     /* 1517682 */     GIR_EraseRootFromParent_Done,
     /* 1517683 */   // Label 21104: @1517683
     /* 1517683 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1517765), // Rule ID 18196 //
     /* 1517688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517727 */     // MIs[0] round
     /* 1517727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517730 */     // MIs[0] policy
     /* 1517730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517740 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1517743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517764 */     // GIR_Coverage, 18196,
     /* 1517764 */     GIR_EraseRootFromParent_Done,
     /* 1517765 */   // Label 21105: @1517765
     /* 1517765 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1517847), // Rule ID 18197 //
     /* 1517770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517809 */     // MIs[0] round
     /* 1517809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517812 */     // MIs[0] policy
     /* 1517812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1517825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517846 */     // GIR_Coverage, 18197,
     /* 1517846 */     GIR_EraseRootFromParent_Done,
     /* 1517847 */   // Label 21106: @1517847
     /* 1517847 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1517929), // Rule ID 18200 //
     /* 1517852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517891 */     // MIs[0] round
     /* 1517891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517894 */     // MIs[0] policy
     /* 1517894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1517907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517928 */     // GIR_Coverage, 18200,
     /* 1517928 */     GIR_EraseRootFromParent_Done,
     /* 1517929 */   // Label 21107: @1517929
     /* 1517929 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1518011), // Rule ID 18201 //
     /* 1517934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517973 */     // MIs[0] round
     /* 1517973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517976 */     // MIs[0] policy
     /* 1517976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1517989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518010 */     // GIR_Coverage, 18201,
     /* 1518010 */     GIR_EraseRootFromParent_Done,
     /* 1518011 */   // Label 21108: @1518011
     /* 1518011 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1518093), // Rule ID 18204 //
     /* 1518016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518055 */     // MIs[0] round
     /* 1518055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518058 */     // MIs[0] policy
     /* 1518058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1518071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518092 */     // GIR_Coverage, 18204,
     /* 1518092 */     GIR_EraseRootFromParent_Done,
     /* 1518093 */   // Label 21109: @1518093
     /* 1518093 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1518175), // Rule ID 18205 //
     /* 1518098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518137 */     // MIs[0] round
     /* 1518137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518140 */     // MIs[0] policy
     /* 1518140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1518153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518174 */     // GIR_Coverage, 18205,
     /* 1518174 */     GIR_EraseRootFromParent_Done,
     /* 1518175 */   // Label 21110: @1518175
     /* 1518175 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1518257), // Rule ID 18208 //
     /* 1518180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518219 */     // MIs[0] round
     /* 1518219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518222 */     // MIs[0] policy
     /* 1518222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518232 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1518235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518256 */     // GIR_Coverage, 18208,
     /* 1518256 */     GIR_EraseRootFromParent_Done,
     /* 1518257 */   // Label 21111: @1518257
     /* 1518257 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1518339), // Rule ID 18209 //
     /* 1518262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518301 */     // MIs[0] round
     /* 1518301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518304 */     // MIs[0] policy
     /* 1518304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518314 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1518317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518338 */     // GIR_Coverage, 18209,
     /* 1518338 */     GIR_EraseRootFromParent_Done,
     /* 1518339 */   // Label 21112: @1518339
     /* 1518339 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1518421), // Rule ID 18212 //
     /* 1518344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518383 */     // MIs[0] round
     /* 1518383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518386 */     // MIs[0] policy
     /* 1518386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1518399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518420 */     // GIR_Coverage, 18212,
     /* 1518420 */     GIR_EraseRootFromParent_Done,
     /* 1518421 */   // Label 21113: @1518421
     /* 1518421 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1518503), // Rule ID 18213 //
     /* 1518426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518465 */     // MIs[0] round
     /* 1518465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518468 */     // MIs[0] policy
     /* 1518468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518478 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1518481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518502 */     // GIR_Coverage, 18213,
     /* 1518502 */     GIR_EraseRootFromParent_Done,
     /* 1518503 */   // Label 21114: @1518503
     /* 1518503 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1518585), // Rule ID 18216 //
     /* 1518508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518547 */     // MIs[0] round
     /* 1518547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518550 */     // MIs[0] policy
     /* 1518550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518560 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1518563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518584 */     // GIR_Coverage, 18216,
     /* 1518584 */     GIR_EraseRootFromParent_Done,
     /* 1518585 */   // Label 21115: @1518585
     /* 1518585 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1518667), // Rule ID 18217 //
     /* 1518590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518629 */     // MIs[0] round
     /* 1518629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518632 */     // MIs[0] policy
     /* 1518632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518642 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1518645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518666 */     // GIR_Coverage, 18217,
     /* 1518666 */     GIR_EraseRootFromParent_Done,
     /* 1518667 */   // Label 21116: @1518667
     /* 1518667 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1518749), // Rule ID 18220 //
     /* 1518672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518711 */     // MIs[0] round
     /* 1518711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518714 */     // MIs[0] policy
     /* 1518714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1518727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518748 */     // GIR_Coverage, 18220,
     /* 1518748 */     GIR_EraseRootFromParent_Done,
     /* 1518749 */   // Label 21117: @1518749
     /* 1518749 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1518831), // Rule ID 18221 //
     /* 1518754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518793 */     // MIs[0] round
     /* 1518793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518796 */     // MIs[0] policy
     /* 1518796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518806 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1518809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518830 */     // GIR_Coverage, 18221,
     /* 1518830 */     GIR_EraseRootFromParent_Done,
     /* 1518831 */   // Label 21118: @1518831
     /* 1518831 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1518913), // Rule ID 18224 //
     /* 1518836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1518853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518875 */     // MIs[0] round
     /* 1518875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518878 */     // MIs[0] policy
     /* 1518878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1518891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518912 */     // GIR_Coverage, 18224,
     /* 1518912 */     GIR_EraseRootFromParent_Done,
     /* 1518913 */   // Label 21119: @1518913
     /* 1518913 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1518995), // Rule ID 18225 //
     /* 1518918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1518935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518957 */     // MIs[0] round
     /* 1518957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518960 */     // MIs[0] policy
     /* 1518960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518970 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1518973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518994 */     // GIR_Coverage, 18225,
     /* 1518994 */     GIR_EraseRootFromParent_Done,
     /* 1518995 */   // Label 21120: @1518995
     /* 1518995 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1519077), // Rule ID 18228 //
     /* 1519000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1519017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519039 */     // MIs[0] round
     /* 1519039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519042 */     // MIs[0] policy
     /* 1519042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1519055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519076 */     // GIR_Coverage, 18228,
     /* 1519076 */     GIR_EraseRootFromParent_Done,
     /* 1519077 */   // Label 21121: @1519077
     /* 1519077 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1519159), // Rule ID 18229 //
     /* 1519082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1519099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519121 */     // MIs[0] round
     /* 1519121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519124 */     // MIs[0] policy
     /* 1519124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1519137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519158 */     // GIR_Coverage, 18229,
     /* 1519158 */     GIR_EraseRootFromParent_Done,
     /* 1519159 */   // Label 21122: @1519159
     /* 1519159 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1519241), // Rule ID 18232 //
     /* 1519164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1519181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519203 */     // MIs[0] round
     /* 1519203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519206 */     // MIs[0] policy
     /* 1519206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1519219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519240 */     // GIR_Coverage, 18232,
     /* 1519240 */     GIR_EraseRootFromParent_Done,
     /* 1519241 */   // Label 21123: @1519241
     /* 1519241 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1519323), // Rule ID 18233 //
     /* 1519246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1519263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519285 */     // MIs[0] round
     /* 1519285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519288 */     // MIs[0] policy
     /* 1519288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519298 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1519301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519322 */     // GIR_Coverage, 18233,
     /* 1519322 */     GIR_EraseRootFromParent_Done,
     /* 1519323 */   // Label 21124: @1519323
     /* 1519323 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1519405), // Rule ID 18236 //
     /* 1519328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1519345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519367 */     // MIs[0] round
     /* 1519367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519370 */     // MIs[0] policy
     /* 1519370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1519383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519404 */     // GIR_Coverage, 18236,
     /* 1519404 */     GIR_EraseRootFromParent_Done,
     /* 1519405 */   // Label 21125: @1519405
     /* 1519405 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1519487), // Rule ID 18237 //
     /* 1519410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1519427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519449 */     // MIs[0] round
     /* 1519449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519452 */     // MIs[0] policy
     /* 1519452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1519465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519486 */     // GIR_Coverage, 18237,
     /* 1519486 */     GIR_EraseRootFromParent_Done,
     /* 1519487 */   // Label 21126: @1519487
     /* 1519487 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1519569), // Rule ID 18240 //
     /* 1519492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1519509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519531 */     // MIs[0] round
     /* 1519531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519534 */     // MIs[0] policy
     /* 1519534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1519547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519568 */     // GIR_Coverage, 18240,
     /* 1519568 */     GIR_EraseRootFromParent_Done,
     /* 1519569 */   // Label 21127: @1519569
     /* 1519569 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1519651), // Rule ID 18241 //
     /* 1519574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1519591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519613 */     // MIs[0] round
     /* 1519613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519616 */     // MIs[0] policy
     /* 1519616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519626 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1519629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519650 */     // GIR_Coverage, 18241,
     /* 1519650 */     GIR_EraseRootFromParent_Done,
     /* 1519651 */   // Label 21128: @1519651
     /* 1519651 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1519733), // Rule ID 18244 //
     /* 1519656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1519673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519695 */     // MIs[0] round
     /* 1519695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519698 */     // MIs[0] policy
     /* 1519698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1519711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519732 */     // GIR_Coverage, 18244,
     /* 1519732 */     GIR_EraseRootFromParent_Done,
     /* 1519733 */   // Label 21129: @1519733
     /* 1519733 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1519815), // Rule ID 18245 //
     /* 1519738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1519755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519777 */     // MIs[0] round
     /* 1519777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519780 */     // MIs[0] policy
     /* 1519780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519790 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1519793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519814 */     // GIR_Coverage, 18245,
     /* 1519814 */     GIR_EraseRootFromParent_Done,
     /* 1519815 */   // Label 21130: @1519815
     /* 1519815 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1519897), // Rule ID 18248 //
     /* 1519820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1519837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519859 */     // MIs[0] round
     /* 1519859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519862 */     // MIs[0] policy
     /* 1519862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1519875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519896 */     // GIR_Coverage, 18248,
     /* 1519896 */     GIR_EraseRootFromParent_Done,
     /* 1519897 */   // Label 21131: @1519897
     /* 1519897 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1519979), // Rule ID 18249 //
     /* 1519902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1519919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519941 */     // MIs[0] round
     /* 1519941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519944 */     // MIs[0] policy
     /* 1519944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1519957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519978 */     // GIR_Coverage, 18249,
     /* 1519978 */     GIR_EraseRootFromParent_Done,
     /* 1519979 */   // Label 21132: @1519979
     /* 1519979 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1520061), // Rule ID 18252 //
     /* 1519984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1519995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1519998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1520001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520023 */     // MIs[0] round
     /* 1520023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520026 */     // MIs[0] policy
     /* 1520026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1520039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520060 */     // GIR_Coverage, 18252,
     /* 1520060 */     GIR_EraseRootFromParent_Done,
     /* 1520061 */   // Label 21133: @1520061
     /* 1520061 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1520143), // Rule ID 18253 //
     /* 1520066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1520083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520105 */     // MIs[0] round
     /* 1520105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520108 */     // MIs[0] policy
     /* 1520108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520118 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1520121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520142 */     // GIR_Coverage, 18253,
     /* 1520142 */     GIR_EraseRootFromParent_Done,
     /* 1520143 */   // Label 21134: @1520143
     /* 1520143 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1520225), // Rule ID 18256 //
     /* 1520148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1520165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520187 */     // MIs[0] round
     /* 1520187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520190 */     // MIs[0] policy
     /* 1520190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1520203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520224 */     // GIR_Coverage, 18256,
     /* 1520224 */     GIR_EraseRootFromParent_Done,
     /* 1520225 */   // Label 21135: @1520225
     /* 1520225 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1520307), // Rule ID 18257 //
     /* 1520230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1520247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520269 */     // MIs[0] round
     /* 1520269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520272 */     // MIs[0] policy
     /* 1520272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1520285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520306 */     // GIR_Coverage, 18257,
     /* 1520306 */     GIR_EraseRootFromParent_Done,
     /* 1520307 */   // Label 21136: @1520307
     /* 1520307 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1520389), // Rule ID 18260 //
     /* 1520312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1520329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520351 */     // MIs[0] round
     /* 1520351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520354 */     // MIs[0] policy
     /* 1520354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1520367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520388 */     // GIR_Coverage, 18260,
     /* 1520388 */     GIR_EraseRootFromParent_Done,
     /* 1520389 */   // Label 21137: @1520389
     /* 1520389 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1520471), // Rule ID 18261 //
     /* 1520394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1520411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520433 */     // MIs[0] round
     /* 1520433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520436 */     // MIs[0] policy
     /* 1520436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1520449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520470 */     // GIR_Coverage, 18261,
     /* 1520470 */     GIR_EraseRootFromParent_Done,
     /* 1520471 */   // Label 21138: @1520471
     /* 1520471 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1520553), // Rule ID 18264 //
     /* 1520476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1520493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520515 */     // MIs[0] round
     /* 1520515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520518 */     // MIs[0] policy
     /* 1520518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1520531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520552 */     // GIR_Coverage, 18264,
     /* 1520552 */     GIR_EraseRootFromParent_Done,
     /* 1520553 */   // Label 21139: @1520553
     /* 1520553 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1520635), // Rule ID 18265 //
     /* 1520558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1520575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520597 */     // MIs[0] round
     /* 1520597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520600 */     // MIs[0] policy
     /* 1520600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520610 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1520613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520634 */     // GIR_Coverage, 18265,
     /* 1520634 */     GIR_EraseRootFromParent_Done,
     /* 1520635 */   // Label 21140: @1520635
     /* 1520635 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1520717), // Rule ID 18268 //
     /* 1520640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1520657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520679 */     // MIs[0] round
     /* 1520679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520682 */     // MIs[0] policy
     /* 1520682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1520695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520716 */     // GIR_Coverage, 18268,
     /* 1520716 */     GIR_EraseRootFromParent_Done,
     /* 1520717 */   // Label 21141: @1520717
     /* 1520717 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1520799), // Rule ID 18269 //
     /* 1520722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1520739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520761 */     // MIs[0] round
     /* 1520761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520764 */     // MIs[0] policy
     /* 1520764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1520777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520798 */     // GIR_Coverage, 18269,
     /* 1520798 */     GIR_EraseRootFromParent_Done,
     /* 1520799 */   // Label 21142: @1520799
     /* 1520799 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1520881), // Rule ID 18272 //
     /* 1520804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1520821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520843 */     // MIs[0] round
     /* 1520843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520846 */     // MIs[0] policy
     /* 1520846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1520859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520880 */     // GIR_Coverage, 18272,
     /* 1520880 */     GIR_EraseRootFromParent_Done,
     /* 1520881 */   // Label 21143: @1520881
     /* 1520881 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1520963), // Rule ID 18273 //
     /* 1520886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1520903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520925 */     // MIs[0] round
     /* 1520925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520928 */     // MIs[0] policy
     /* 1520928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1520941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520962 */     // GIR_Coverage, 18273,
     /* 1520962 */     GIR_EraseRootFromParent_Done,
     /* 1520963 */   // Label 21144: @1520963
     /* 1520963 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1521045), // Rule ID 18276 //
     /* 1520968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1520976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1520979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1520982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1520985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1520988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521007 */     // MIs[0] round
     /* 1521007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521010 */     // MIs[0] policy
     /* 1521010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1521023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521044 */     // GIR_Coverage, 18276,
     /* 1521044 */     GIR_EraseRootFromParent_Done,
     /* 1521045 */   // Label 21145: @1521045
     /* 1521045 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1521127), // Rule ID 18277 //
     /* 1521050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1521067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521089 */     // MIs[0] round
     /* 1521089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521092 */     // MIs[0] policy
     /* 1521092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1521105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521126 */     // GIR_Coverage, 18277,
     /* 1521126 */     GIR_EraseRootFromParent_Done,
     /* 1521127 */   // Label 21146: @1521127
     /* 1521127 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1521209), // Rule ID 18280 //
     /* 1521132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1521149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521171 */     // MIs[0] round
     /* 1521171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521174 */     // MIs[0] policy
     /* 1521174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1521187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521208 */     // GIR_Coverage, 18280,
     /* 1521208 */     GIR_EraseRootFromParent_Done,
     /* 1521209 */   // Label 21147: @1521209
     /* 1521209 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1521291), // Rule ID 18281 //
     /* 1521214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1521231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521253 */     // MIs[0] round
     /* 1521253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521256 */     // MIs[0] policy
     /* 1521256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1521269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521290 */     // GIR_Coverage, 18281,
     /* 1521290 */     GIR_EraseRootFromParent_Done,
     /* 1521291 */   // Label 21148: @1521291
     /* 1521291 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1521373), // Rule ID 18284 //
     /* 1521296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521335 */     // MIs[0] round
     /* 1521335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521338 */     // MIs[0] policy
     /* 1521338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521348 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1521351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521372 */     // GIR_Coverage, 18284,
     /* 1521372 */     GIR_EraseRootFromParent_Done,
     /* 1521373 */   // Label 21149: @1521373
     /* 1521373 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1521455), // Rule ID 18285 //
     /* 1521378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521417 */     // MIs[0] round
     /* 1521417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521420 */     // MIs[0] policy
     /* 1521420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521430 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1521433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521454 */     // GIR_Coverage, 18285,
     /* 1521454 */     GIR_EraseRootFromParent_Done,
     /* 1521455 */   // Label 21150: @1521455
     /* 1521455 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1521537), // Rule ID 18288 //
     /* 1521460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521499 */     // MIs[0] round
     /* 1521499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521502 */     // MIs[0] policy
     /* 1521502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521512 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1521515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521536 */     // GIR_Coverage, 18288,
     /* 1521536 */     GIR_EraseRootFromParent_Done,
     /* 1521537 */   // Label 21151: @1521537
     /* 1521537 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1521619), // Rule ID 18289 //
     /* 1521542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521581 */     // MIs[0] round
     /* 1521581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521584 */     // MIs[0] policy
     /* 1521584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521594 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1521597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521618 */     // GIR_Coverage, 18289,
     /* 1521618 */     GIR_EraseRootFromParent_Done,
     /* 1521619 */   // Label 21152: @1521619
     /* 1521619 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1521701), // Rule ID 18292 //
     /* 1521624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1521641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1521659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521663 */     // MIs[0] round
     /* 1521663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521666 */     // MIs[0] policy
     /* 1521666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1521679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521700 */     // GIR_Coverage, 18292,
     /* 1521700 */     GIR_EraseRootFromParent_Done,
     /* 1521701 */   // Label 21153: @1521701
     /* 1521701 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1521783), // Rule ID 18293 //
     /* 1521706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1521723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1521741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521745 */     // MIs[0] round
     /* 1521745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521748 */     // MIs[0] policy
     /* 1521748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1521761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521782 */     // GIR_Coverage, 18293,
     /* 1521782 */     GIR_EraseRootFromParent_Done,
     /* 1521783 */   // Label 21154: @1521783
     /* 1521783 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1521865), // Rule ID 18296 //
     /* 1521788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521827 */     // MIs[0] round
     /* 1521827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521830 */     // MIs[0] policy
     /* 1521830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1521843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521864 */     // GIR_Coverage, 18296,
     /* 1521864 */     GIR_EraseRootFromParent_Done,
     /* 1521865 */   // Label 21155: @1521865
     /* 1521865 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1521947), // Rule ID 18297 //
     /* 1521870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521909 */     // MIs[0] round
     /* 1521909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521912 */     // MIs[0] policy
     /* 1521912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1521925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521946 */     // GIR_Coverage, 18297,
     /* 1521946 */     GIR_EraseRootFromParent_Done,
     /* 1521947 */   // Label 21156: @1521947
     /* 1521947 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1522029), // Rule ID 18300 //
     /* 1521952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1521963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1521966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1521969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1521972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1521987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521991 */     // MIs[0] round
     /* 1521991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521994 */     // MIs[0] policy
     /* 1521994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1522007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522028 */     // GIR_Coverage, 18300,
     /* 1522028 */     GIR_EraseRootFromParent_Done,
     /* 1522029 */   // Label 21157: @1522029
     /* 1522029 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1522111), // Rule ID 18301 //
     /* 1522034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522073 */     // MIs[0] round
     /* 1522073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522076 */     // MIs[0] policy
     /* 1522076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522086 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1522089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522110 */     // GIR_Coverage, 18301,
     /* 1522110 */     GIR_EraseRootFromParent_Done,
     /* 1522111 */   // Label 21158: @1522111
     /* 1522111 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1522193), // Rule ID 18304 //
     /* 1522116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1522133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1522151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522155 */     // MIs[0] round
     /* 1522155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522158 */     // MIs[0] policy
     /* 1522158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1522171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522192 */     // GIR_Coverage, 18304,
     /* 1522192 */     GIR_EraseRootFromParent_Done,
     /* 1522193 */   // Label 21159: @1522193
     /* 1522193 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1522275), // Rule ID 18305 //
     /* 1522198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1522215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1522233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522237 */     // MIs[0] round
     /* 1522237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522240 */     // MIs[0] policy
     /* 1522240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1522253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522274 */     // GIR_Coverage, 18305,
     /* 1522274 */     GIR_EraseRootFromParent_Done,
     /* 1522275 */   // Label 21160: @1522275
     /* 1522275 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1522357), // Rule ID 18308 //
     /* 1522280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522319 */     // MIs[0] round
     /* 1522319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522322 */     // MIs[0] policy
     /* 1522322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1522335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522356 */     // GIR_Coverage, 18308,
     /* 1522356 */     GIR_EraseRootFromParent_Done,
     /* 1522357 */   // Label 21161: @1522357
     /* 1522357 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1522439), // Rule ID 18309 //
     /* 1522362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522401 */     // MIs[0] round
     /* 1522401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522404 */     // MIs[0] policy
     /* 1522404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1522417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522438 */     // GIR_Coverage, 18309,
     /* 1522438 */     GIR_EraseRootFromParent_Done,
     /* 1522439 */   // Label 21162: @1522439
     /* 1522439 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1522521), // Rule ID 18312 //
     /* 1522444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522483 */     // MIs[0] round
     /* 1522483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522486 */     // MIs[0] policy
     /* 1522486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1522499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522520 */     // GIR_Coverage, 18312,
     /* 1522520 */     GIR_EraseRootFromParent_Done,
     /* 1522521 */   // Label 21163: @1522521
     /* 1522521 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1522603), // Rule ID 18313 //
     /* 1522526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522565 */     // MIs[0] round
     /* 1522565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522568 */     // MIs[0] policy
     /* 1522568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1522581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522602 */     // GIR_Coverage, 18313,
     /* 1522602 */     GIR_EraseRootFromParent_Done,
     /* 1522603 */   // Label 21164: @1522603
     /* 1522603 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1522685), // Rule ID 18316 //
     /* 1522608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522647 */     // MIs[0] round
     /* 1522647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522650 */     // MIs[0] policy
     /* 1522650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1522663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522684 */     // GIR_Coverage, 18316,
     /* 1522684 */     GIR_EraseRootFromParent_Done,
     /* 1522685 */   // Label 21165: @1522685
     /* 1522685 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1522767), // Rule ID 18317 //
     /* 1522690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522729 */     // MIs[0] round
     /* 1522729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522732 */     // MIs[0] policy
     /* 1522732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1522745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522766 */     // GIR_Coverage, 18317,
     /* 1522766 */     GIR_EraseRootFromParent_Done,
     /* 1522767 */   // Label 21166: @1522767
     /* 1522767 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1522849), // Rule ID 18320 //
     /* 1522772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522811 */     // MIs[0] round
     /* 1522811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522814 */     // MIs[0] policy
     /* 1522814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1522827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522848 */     // GIR_Coverage, 18320,
     /* 1522848 */     GIR_EraseRootFromParent_Done,
     /* 1522849 */   // Label 21167: @1522849
     /* 1522849 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1522931), // Rule ID 18321 //
     /* 1522854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522893 */     // MIs[0] round
     /* 1522893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522896 */     // MIs[0] policy
     /* 1522896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1522909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522930 */     // GIR_Coverage, 18321,
     /* 1522930 */     GIR_EraseRootFromParent_Done,
     /* 1522931 */   // Label 21168: @1522931
     /* 1522931 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1523013), // Rule ID 18324 //
     /* 1522936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1522947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1522950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1522956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522975 */     // MIs[0] round
     /* 1522975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522978 */     // MIs[0] policy
     /* 1522978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1522991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523012 */     // GIR_Coverage, 18324,
     /* 1523012 */     GIR_EraseRootFromParent_Done,
     /* 1523013 */   // Label 21169: @1523013
     /* 1523013 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1523095), // Rule ID 18325 //
     /* 1523018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523057 */     // MIs[0] round
     /* 1523057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523060 */     // MIs[0] policy
     /* 1523060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1523073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523094 */     // GIR_Coverage, 18325,
     /* 1523094 */     GIR_EraseRootFromParent_Done,
     /* 1523095 */   // Label 21170: @1523095
     /* 1523095 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1523177), // Rule ID 18328 //
     /* 1523100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523139 */     // MIs[0] round
     /* 1523139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523142 */     // MIs[0] policy
     /* 1523142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1523155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523176 */     // GIR_Coverage, 18328,
     /* 1523176 */     GIR_EraseRootFromParent_Done,
     /* 1523177 */   // Label 21171: @1523177
     /* 1523177 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1523259), // Rule ID 18329 //
     /* 1523182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523221 */     // MIs[0] round
     /* 1523221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523224 */     // MIs[0] policy
     /* 1523224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523234 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1523237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523258 */     // GIR_Coverage, 18329,
     /* 1523258 */     GIR_EraseRootFromParent_Done,
     /* 1523259 */   // Label 21172: @1523259
     /* 1523259 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1523341), // Rule ID 18332 //
     /* 1523264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523303 */     // MIs[0] round
     /* 1523303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523306 */     // MIs[0] policy
     /* 1523306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1523319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523340 */     // GIR_Coverage, 18332,
     /* 1523340 */     GIR_EraseRootFromParent_Done,
     /* 1523341 */   // Label 21173: @1523341
     /* 1523341 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1523423), // Rule ID 18333 //
     /* 1523346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523385 */     // MIs[0] round
     /* 1523385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523388 */     // MIs[0] policy
     /* 1523388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1523401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523422 */     // GIR_Coverage, 18333,
     /* 1523422 */     GIR_EraseRootFromParent_Done,
     /* 1523423 */   // Label 21174: @1523423
     /* 1523423 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1523505), // Rule ID 18336 //
     /* 1523428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523467 */     // MIs[0] round
     /* 1523467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523470 */     // MIs[0] policy
     /* 1523470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523480 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1523483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523504 */     // GIR_Coverage, 18336,
     /* 1523504 */     GIR_EraseRootFromParent_Done,
     /* 1523505 */   // Label 21175: @1523505
     /* 1523505 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1523587), // Rule ID 18337 //
     /* 1523510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523549 */     // MIs[0] round
     /* 1523549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523552 */     // MIs[0] policy
     /* 1523552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523562 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1523565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523586 */     // GIR_Coverage, 18337,
     /* 1523586 */     GIR_EraseRootFromParent_Done,
     /* 1523587 */   // Label 21176: @1523587
     /* 1523587 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1523669), // Rule ID 18340 //
     /* 1523592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523631 */     // MIs[0] round
     /* 1523631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523634 */     // MIs[0] policy
     /* 1523634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1523647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523668 */     // GIR_Coverage, 18340,
     /* 1523668 */     GIR_EraseRootFromParent_Done,
     /* 1523669 */   // Label 21177: @1523669
     /* 1523669 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1523751), // Rule ID 18341 //
     /* 1523674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523713 */     // MIs[0] round
     /* 1523713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523716 */     // MIs[0] policy
     /* 1523716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523726 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1523729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523750 */     // GIR_Coverage, 18341,
     /* 1523750 */     GIR_EraseRootFromParent_Done,
     /* 1523751 */   // Label 21178: @1523751
     /* 1523751 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1523833), // Rule ID 18344 //
     /* 1523756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1523773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523795 */     // MIs[0] round
     /* 1523795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523798 */     // MIs[0] policy
     /* 1523798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1523811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523832 */     // GIR_Coverage, 18344,
     /* 1523832 */     GIR_EraseRootFromParent_Done,
     /* 1523833 */   // Label 21179: @1523833
     /* 1523833 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1523915), // Rule ID 18345 //
     /* 1523838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1523855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523877 */     // MIs[0] round
     /* 1523877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523880 */     // MIs[0] policy
     /* 1523880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523890 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1523893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523914 */     // GIR_Coverage, 18345,
     /* 1523914 */     GIR_EraseRootFromParent_Done,
     /* 1523915 */   // Label 21180: @1523915
     /* 1523915 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1523997), // Rule ID 18348 //
     /* 1523920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1523931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1523934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1523937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523959 */     // MIs[0] round
     /* 1523959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523962 */     // MIs[0] policy
     /* 1523962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1523975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523996 */     // GIR_Coverage, 18348,
     /* 1523996 */     GIR_EraseRootFromParent_Done,
     /* 1523997 */   // Label 21181: @1523997
     /* 1523997 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1524079), // Rule ID 18349 //
     /* 1524002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1524019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524041 */     // MIs[0] round
     /* 1524041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524044 */     // MIs[0] policy
     /* 1524044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524054 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1524057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524078 */     // GIR_Coverage, 18349,
     /* 1524078 */     GIR_EraseRootFromParent_Done,
     /* 1524079 */   // Label 21182: @1524079
     /* 1524079 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1524161), // Rule ID 18352 //
     /* 1524084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1524101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524123 */     // MIs[0] round
     /* 1524123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524126 */     // MIs[0] policy
     /* 1524126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1524139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524160 */     // GIR_Coverage, 18352,
     /* 1524160 */     GIR_EraseRootFromParent_Done,
     /* 1524161 */   // Label 21183: @1524161
     /* 1524161 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1524243), // Rule ID 18353 //
     /* 1524166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1524183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524205 */     // MIs[0] round
     /* 1524205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524208 */     // MIs[0] policy
     /* 1524208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524218 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1524221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524242 */     // GIR_Coverage, 18353,
     /* 1524242 */     GIR_EraseRootFromParent_Done,
     /* 1524243 */   // Label 21184: @1524243
     /* 1524243 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1524325), // Rule ID 18356 //
     /* 1524248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1524265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524287 */     // MIs[0] round
     /* 1524287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524290 */     // MIs[0] policy
     /* 1524290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1524303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524324 */     // GIR_Coverage, 18356,
     /* 1524324 */     GIR_EraseRootFromParent_Done,
     /* 1524325 */   // Label 21185: @1524325
     /* 1524325 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1524407), // Rule ID 18357 //
     /* 1524330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1524347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524369 */     // MIs[0] round
     /* 1524369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524372 */     // MIs[0] policy
     /* 1524372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1524385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524406 */     // GIR_Coverage, 18357,
     /* 1524406 */     GIR_EraseRootFromParent_Done,
     /* 1524407 */   // Label 21186: @1524407
     /* 1524407 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1524489), // Rule ID 18360 //
     /* 1524412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1524429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524451 */     // MIs[0] round
     /* 1524451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524454 */     // MIs[0] policy
     /* 1524454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1524467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524488 */     // GIR_Coverage, 18360,
     /* 1524488 */     GIR_EraseRootFromParent_Done,
     /* 1524489 */   // Label 21187: @1524489
     /* 1524489 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1524571), // Rule ID 18361 //
     /* 1524494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1524511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524533 */     // MIs[0] round
     /* 1524533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524536 */     // MIs[0] policy
     /* 1524536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524546 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1524549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524570 */     // GIR_Coverage, 18361,
     /* 1524570 */     GIR_EraseRootFromParent_Done,
     /* 1524571 */   // Label 21188: @1524571
     /* 1524571 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1524653), // Rule ID 18364 //
     /* 1524576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1524593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524615 */     // MIs[0] round
     /* 1524615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524618 */     // MIs[0] policy
     /* 1524618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524628 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1524631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524652 */     // GIR_Coverage, 18364,
     /* 1524652 */     GIR_EraseRootFromParent_Done,
     /* 1524653 */   // Label 21189: @1524653
     /* 1524653 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1524735), // Rule ID 18365 //
     /* 1524658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1524675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524697 */     // MIs[0] round
     /* 1524697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524700 */     // MIs[0] policy
     /* 1524700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524710 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1524713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524734 */     // GIR_Coverage, 18365,
     /* 1524734 */     GIR_EraseRootFromParent_Done,
     /* 1524735 */   // Label 21190: @1524735
     /* 1524735 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1524817), // Rule ID 18368 //
     /* 1524740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1524757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524779 */     // MIs[0] round
     /* 1524779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524782 */     // MIs[0] policy
     /* 1524782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524792 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1524795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524816 */     // GIR_Coverage, 18368,
     /* 1524816 */     GIR_EraseRootFromParent_Done,
     /* 1524817 */   // Label 21191: @1524817
     /* 1524817 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1524899), // Rule ID 18369 //
     /* 1524822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1524839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524861 */     // MIs[0] round
     /* 1524861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524864 */     // MIs[0] policy
     /* 1524864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524874 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1524877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524898 */     // GIR_Coverage, 18369,
     /* 1524898 */     GIR_EraseRootFromParent_Done,
     /* 1524899 */   // Label 21192: @1524899
     /* 1524899 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1524981), // Rule ID 18372 //
     /* 1524904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1524918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1524921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1524924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524943 */     // MIs[0] round
     /* 1524943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524946 */     // MIs[0] policy
     /* 1524946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524956 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1524959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524980 */     // GIR_Coverage, 18372,
     /* 1524980 */     GIR_EraseRootFromParent_Done,
     /* 1524981 */   // Label 21193: @1524981
     /* 1524981 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1525063), // Rule ID 18373 //
     /* 1524986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1525003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525025 */     // MIs[0] round
     /* 1525025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525028 */     // MIs[0] policy
     /* 1525028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525038 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1525041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525062 */     // GIR_Coverage, 18373,
     /* 1525062 */     GIR_EraseRootFromParent_Done,
     /* 1525063 */   // Label 21194: @1525063
     /* 1525063 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1525145), // Rule ID 18376 //
     /* 1525068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1525085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525107 */     // MIs[0] round
     /* 1525107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525110 */     // MIs[0] policy
     /* 1525110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525120 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1525123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525144 */     // GIR_Coverage, 18376,
     /* 1525144 */     GIR_EraseRootFromParent_Done,
     /* 1525145 */   // Label 21195: @1525145
     /* 1525145 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1525227), // Rule ID 18377 //
     /* 1525150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1525167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525189 */     // MIs[0] round
     /* 1525189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525192 */     // MIs[0] policy
     /* 1525192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525202 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1525205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525226 */     // GIR_Coverage, 18377,
     /* 1525226 */     GIR_EraseRootFromParent_Done,
     /* 1525227 */   // Label 21196: @1525227
     /* 1525227 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1525309), // Rule ID 18380 //
     /* 1525232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1525249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525271 */     // MIs[0] round
     /* 1525271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525274 */     // MIs[0] policy
     /* 1525274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1525287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525308 */     // GIR_Coverage, 18380,
     /* 1525308 */     GIR_EraseRootFromParent_Done,
     /* 1525309 */   // Label 21197: @1525309
     /* 1525309 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1525391), // Rule ID 18381 //
     /* 1525314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1525331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525353 */     // MIs[0] round
     /* 1525353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525356 */     // MIs[0] policy
     /* 1525356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525366 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1525369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525390 */     // GIR_Coverage, 18381,
     /* 1525390 */     GIR_EraseRootFromParent_Done,
     /* 1525391 */   // Label 21198: @1525391
     /* 1525391 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1525473), // Rule ID 18384 //
     /* 1525396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1525413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525435 */     // MIs[0] round
     /* 1525435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525438 */     // MIs[0] policy
     /* 1525438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525448 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1525451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525472 */     // GIR_Coverage, 18384,
     /* 1525472 */     GIR_EraseRootFromParent_Done,
     /* 1525473 */   // Label 21199: @1525473
     /* 1525473 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1525555), // Rule ID 18385 //
     /* 1525478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1525495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525517 */     // MIs[0] round
     /* 1525517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525520 */     // MIs[0] policy
     /* 1525520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1525533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525554 */     // GIR_Coverage, 18385,
     /* 1525554 */     GIR_EraseRootFromParent_Done,
     /* 1525555 */   // Label 21200: @1525555
     /* 1525555 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1525637), // Rule ID 18388 //
     /* 1525560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1525577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525599 */     // MIs[0] round
     /* 1525599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525602 */     // MIs[0] policy
     /* 1525602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1525615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525636 */     // GIR_Coverage, 18388,
     /* 1525636 */     GIR_EraseRootFromParent_Done,
     /* 1525637 */   // Label 21201: @1525637
     /* 1525637 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1525719), // Rule ID 18389 //
     /* 1525642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1525659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525681 */     // MIs[0] round
     /* 1525681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525684 */     // MIs[0] policy
     /* 1525684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1525697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525718 */     // GIR_Coverage, 18389,
     /* 1525718 */     GIR_EraseRootFromParent_Done,
     /* 1525719 */   // Label 21202: @1525719
     /* 1525719 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1525801), // Rule ID 18392 //
     /* 1525724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1525741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525763 */     // MIs[0] round
     /* 1525763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525766 */     // MIs[0] policy
     /* 1525766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1525779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525800 */     // GIR_Coverage, 18392,
     /* 1525800 */     GIR_EraseRootFromParent_Done,
     /* 1525801 */   // Label 21203: @1525801
     /* 1525801 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1525883), // Rule ID 18393 //
     /* 1525806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1525823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525845 */     // MIs[0] round
     /* 1525845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525848 */     // MIs[0] policy
     /* 1525848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1525861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525882 */     // GIR_Coverage, 18393,
     /* 1525882 */     GIR_EraseRootFromParent_Done,
     /* 1525883 */   // Label 21204: @1525883
     /* 1525883 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1525965), // Rule ID 18396 //
     /* 1525888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1525905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525927 */     // MIs[0] round
     /* 1525927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525930 */     // MIs[0] policy
     /* 1525930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525940 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1525943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525964 */     // GIR_Coverage, 18396,
     /* 1525964 */     GIR_EraseRootFromParent_Done,
     /* 1525965 */   // Label 21205: @1525965
     /* 1525965 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1526047), // Rule ID 18397 //
     /* 1525970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1525987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526009 */     // MIs[0] round
     /* 1526009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526012 */     // MIs[0] policy
     /* 1526012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526022 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1526025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526046 */     // GIR_Coverage, 18397,
     /* 1526046 */     GIR_EraseRootFromParent_Done,
     /* 1526047 */   // Label 21206: @1526047
     /* 1526047 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1526129), // Rule ID 18400 //
     /* 1526052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1526069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526091 */     // MIs[0] round
     /* 1526091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526094 */     // MIs[0] policy
     /* 1526094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1526107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526128 */     // GIR_Coverage, 18400,
     /* 1526128 */     GIR_EraseRootFromParent_Done,
     /* 1526129 */   // Label 21207: @1526129
     /* 1526129 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1526211), // Rule ID 18401 //
     /* 1526134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1526151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526173 */     // MIs[0] round
     /* 1526173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526176 */     // MIs[0] policy
     /* 1526176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526186 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1526189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526210 */     // GIR_Coverage, 18401,
     /* 1526210 */     GIR_EraseRootFromParent_Done,
     /* 1526211 */   // Label 21208: @1526211
     /* 1526211 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1526293), // Rule ID 18404 //
     /* 1526216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526255 */     // MIs[0] round
     /* 1526255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526258 */     // MIs[0] policy
     /* 1526258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526268 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1526271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526292 */     // GIR_Coverage, 18404,
     /* 1526292 */     GIR_EraseRootFromParent_Done,
     /* 1526293 */   // Label 21209: @1526293
     /* 1526293 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1526375), // Rule ID 18405 //
     /* 1526298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526337 */     // MIs[0] round
     /* 1526337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526340 */     // MIs[0] policy
     /* 1526340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526350 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1526353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526374 */     // GIR_Coverage, 18405,
     /* 1526374 */     GIR_EraseRootFromParent_Done,
     /* 1526375 */   // Label 21210: @1526375
     /* 1526375 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1526457), // Rule ID 18408 //
     /* 1526380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526419 */     // MIs[0] round
     /* 1526419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526422 */     // MIs[0] policy
     /* 1526422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1526435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526456 */     // GIR_Coverage, 18408,
     /* 1526456 */     GIR_EraseRootFromParent_Done,
     /* 1526457 */   // Label 21211: @1526457
     /* 1526457 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1526539), // Rule ID 18409 //
     /* 1526462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526501 */     // MIs[0] round
     /* 1526501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526504 */     // MIs[0] policy
     /* 1526504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526514 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1526517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526538 */     // GIR_Coverage, 18409,
     /* 1526538 */     GIR_EraseRootFromParent_Done,
     /* 1526539 */   // Label 21212: @1526539
     /* 1526539 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1526621), // Rule ID 18412 //
     /* 1526544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1526561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1526579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526583 */     // MIs[0] round
     /* 1526583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526586 */     // MIs[0] policy
     /* 1526586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1526599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526620 */     // GIR_Coverage, 18412,
     /* 1526620 */     GIR_EraseRootFromParent_Done,
     /* 1526621 */   // Label 21213: @1526621
     /* 1526621 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1526703), // Rule ID 18413 //
     /* 1526626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1526643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1526661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526665 */     // MIs[0] round
     /* 1526665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526668 */     // MIs[0] policy
     /* 1526668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526678 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1526681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526702 */     // GIR_Coverage, 18413,
     /* 1526702 */     GIR_EraseRootFromParent_Done,
     /* 1526703 */   // Label 21214: @1526703
     /* 1526703 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1526785), // Rule ID 18416 //
     /* 1526708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526747 */     // MIs[0] round
     /* 1526747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526750 */     // MIs[0] policy
     /* 1526750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526760 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1526763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526784 */     // GIR_Coverage, 18416,
     /* 1526784 */     GIR_EraseRootFromParent_Done,
     /* 1526785 */   // Label 21215: @1526785
     /* 1526785 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1526867), // Rule ID 18417 //
     /* 1526790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526829 */     // MIs[0] round
     /* 1526829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526832 */     // MIs[0] policy
     /* 1526832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526842 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1526845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526866 */     // GIR_Coverage, 18417,
     /* 1526866 */     GIR_EraseRootFromParent_Done,
     /* 1526867 */   // Label 21216: @1526867
     /* 1526867 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1526949), // Rule ID 18420 //
     /* 1526872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1526889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1526907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526911 */     // MIs[0] round
     /* 1526911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526914 */     // MIs[0] policy
     /* 1526914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526924 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1526927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526948 */     // GIR_Coverage, 18420,
     /* 1526948 */     GIR_EraseRootFromParent_Done,
     /* 1526949 */   // Label 21217: @1526949
     /* 1526949 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1527031), // Rule ID 18421 //
     /* 1526954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1526971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1526989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526993 */     // MIs[0] round
     /* 1526993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526996 */     // MIs[0] policy
     /* 1526996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527006 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1527009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527030 */     // GIR_Coverage, 18421,
     /* 1527030 */     GIR_EraseRootFromParent_Done,
     /* 1527031 */   // Label 21218: @1527031
     /* 1527031 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1527113), // Rule ID 18424 //
     /* 1527036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1527053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1527071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527075 */     // MIs[0] round
     /* 1527075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527078 */     // MIs[0] policy
     /* 1527078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527088 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1527091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527112 */     // GIR_Coverage, 18424,
     /* 1527112 */     GIR_EraseRootFromParent_Done,
     /* 1527113 */   // Label 21219: @1527113
     /* 1527113 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1527195), // Rule ID 18425 //
     /* 1527118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1527135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1527153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527157 */     // MIs[0] round
     /* 1527157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527160 */     // MIs[0] policy
     /* 1527160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1527173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527194 */     // GIR_Coverage, 18425,
     /* 1527194 */     GIR_EraseRootFromParent_Done,
     /* 1527195 */   // Label 21220: @1527195
     /* 1527195 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1527277), // Rule ID 18428 //
     /* 1527200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527239 */     // MIs[0] round
     /* 1527239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527242 */     // MIs[0] policy
     /* 1527242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527252 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1527255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527276 */     // GIR_Coverage, 18428,
     /* 1527276 */     GIR_EraseRootFromParent_Done,
     /* 1527277 */   // Label 21221: @1527277
     /* 1527277 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1527359), // Rule ID 18429 //
     /* 1527282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527321 */     // MIs[0] round
     /* 1527321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527324 */     // MIs[0] policy
     /* 1527324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527334 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1527337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527358 */     // GIR_Coverage, 18429,
     /* 1527358 */     GIR_EraseRootFromParent_Done,
     /* 1527359 */   // Label 21222: @1527359
     /* 1527359 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1527441), // Rule ID 18432 //
     /* 1527364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527403 */     // MIs[0] round
     /* 1527403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527406 */     // MIs[0] policy
     /* 1527406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527416 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1527419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527440 */     // GIR_Coverage, 18432,
     /* 1527440 */     GIR_EraseRootFromParent_Done,
     /* 1527441 */   // Label 21223: @1527441
     /* 1527441 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1527523), // Rule ID 18433 //
     /* 1527446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527485 */     // MIs[0] round
     /* 1527485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527488 */     // MIs[0] policy
     /* 1527488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527498 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1527501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527522 */     // GIR_Coverage, 18433,
     /* 1527522 */     GIR_EraseRootFromParent_Done,
     /* 1527523 */   // Label 21224: @1527523
     /* 1527523 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1527605), // Rule ID 18436 //
     /* 1527528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527567 */     // MIs[0] round
     /* 1527567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527570 */     // MIs[0] policy
     /* 1527570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527580 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1527583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527604 */     // GIR_Coverage, 18436,
     /* 1527604 */     GIR_EraseRootFromParent_Done,
     /* 1527605 */   // Label 21225: @1527605
     /* 1527605 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1527687), // Rule ID 18437 //
     /* 1527610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527649 */     // MIs[0] round
     /* 1527649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527652 */     // MIs[0] policy
     /* 1527652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527662 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1527665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527686 */     // GIR_Coverage, 18437,
     /* 1527686 */     GIR_EraseRootFromParent_Done,
     /* 1527687 */   // Label 21226: @1527687
     /* 1527687 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1527769), // Rule ID 18440 //
     /* 1527692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527731 */     // MIs[0] round
     /* 1527731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527734 */     // MIs[0] policy
     /* 1527734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1527747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527768 */     // GIR_Coverage, 18440,
     /* 1527768 */     GIR_EraseRootFromParent_Done,
     /* 1527769 */   // Label 21227: @1527769
     /* 1527769 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1527851), // Rule ID 18441 //
     /* 1527774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527813 */     // MIs[0] round
     /* 1527813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527816 */     // MIs[0] policy
     /* 1527816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527826 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1527829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527850 */     // GIR_Coverage, 18441,
     /* 1527850 */     GIR_EraseRootFromParent_Done,
     /* 1527851 */   // Label 21228: @1527851
     /* 1527851 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1527933), // Rule ID 18444 //
     /* 1527856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527895 */     // MIs[0] round
     /* 1527895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527898 */     // MIs[0] policy
     /* 1527898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527908 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1527911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527932 */     // GIR_Coverage, 18444,
     /* 1527932 */     GIR_EraseRootFromParent_Done,
     /* 1527933 */   // Label 21229: @1527933
     /* 1527933 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1528015), // Rule ID 18445 //
     /* 1527938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527977 */     // MIs[0] round
     /* 1527977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527980 */     // MIs[0] policy
     /* 1527980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527990 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1527993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528014 */     // GIR_Coverage, 18445,
     /* 1528014 */     GIR_EraseRootFromParent_Done,
     /* 1528015 */   // Label 21230: @1528015
     /* 1528015 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1528097), // Rule ID 18448 //
     /* 1528020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528059 */     // MIs[0] round
     /* 1528059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528062 */     // MIs[0] policy
     /* 1528062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528072 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1528075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528096 */     // GIR_Coverage, 18448,
     /* 1528096 */     GIR_EraseRootFromParent_Done,
     /* 1528097 */   // Label 21231: @1528097
     /* 1528097 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1528179), // Rule ID 18449 //
     /* 1528102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528141 */     // MIs[0] round
     /* 1528141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528144 */     // MIs[0] policy
     /* 1528144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528154 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1528157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528178 */     // GIR_Coverage, 18449,
     /* 1528178 */     GIR_EraseRootFromParent_Done,
     /* 1528179 */   // Label 21232: @1528179
     /* 1528179 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1528261), // Rule ID 18452 //
     /* 1528184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528223 */     // MIs[0] round
     /* 1528223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528226 */     // MIs[0] policy
     /* 1528226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1528239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528260 */     // GIR_Coverage, 18452,
     /* 1528260 */     GIR_EraseRootFromParent_Done,
     /* 1528261 */   // Label 21233: @1528261
     /* 1528261 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1528343), // Rule ID 18453 //
     /* 1528266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528305 */     // MIs[0] round
     /* 1528305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528308 */     // MIs[0] policy
     /* 1528308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528318 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1528321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528342 */     // GIR_Coverage, 18453,
     /* 1528342 */     GIR_EraseRootFromParent_Done,
     /* 1528343 */   // Label 21234: @1528343
     /* 1528343 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1528425), // Rule ID 18456 //
     /* 1528348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528387 */     // MIs[0] round
     /* 1528387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528390 */     // MIs[0] policy
     /* 1528390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528400 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1528403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528424 */     // GIR_Coverage, 18456,
     /* 1528424 */     GIR_EraseRootFromParent_Done,
     /* 1528425 */   // Label 21235: @1528425
     /* 1528425 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1528507), // Rule ID 18457 //
     /* 1528430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528469 */     // MIs[0] round
     /* 1528469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528472 */     // MIs[0] policy
     /* 1528472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528482 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1528485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528506 */     // GIR_Coverage, 18457,
     /* 1528506 */     GIR_EraseRootFromParent_Done,
     /* 1528507 */   // Label 21236: @1528507
     /* 1528507 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1528589), // Rule ID 18460 //
     /* 1528512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528551 */     // MIs[0] round
     /* 1528551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528554 */     // MIs[0] policy
     /* 1528554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528564 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1528567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528588 */     // GIR_Coverage, 18460,
     /* 1528588 */     GIR_EraseRootFromParent_Done,
     /* 1528589 */   // Label 21237: @1528589
     /* 1528589 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1528671), // Rule ID 18461 //
     /* 1528594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528633 */     // MIs[0] round
     /* 1528633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528636 */     // MIs[0] policy
     /* 1528636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528646 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1528649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528670 */     // GIR_Coverage, 18461,
     /* 1528670 */     GIR_EraseRootFromParent_Done,
     /* 1528671 */   // Label 21238: @1528671
     /* 1528671 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1528753), // Rule ID 18464 //
     /* 1528676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1528693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528715 */     // MIs[0] round
     /* 1528715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528718 */     // MIs[0] policy
     /* 1528718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528728 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1528731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528752 */     // GIR_Coverage, 18464,
     /* 1528752 */     GIR_EraseRootFromParent_Done,
     /* 1528753 */   // Label 21239: @1528753
     /* 1528753 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1528835), // Rule ID 18465 //
     /* 1528758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1528775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528797 */     // MIs[0] round
     /* 1528797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528800 */     // MIs[0] policy
     /* 1528800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528810 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1528813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528834 */     // GIR_Coverage, 18465,
     /* 1528834 */     GIR_EraseRootFromParent_Done,
     /* 1528835 */   // Label 21240: @1528835
     /* 1528835 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1528917), // Rule ID 18468 //
     /* 1528840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1528857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528879 */     // MIs[0] round
     /* 1528879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528882 */     // MIs[0] policy
     /* 1528882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528892 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1528895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528916 */     // GIR_Coverage, 18468,
     /* 1528916 */     GIR_EraseRootFromParent_Done,
     /* 1528917 */   // Label 21241: @1528917
     /* 1528917 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1528999), // Rule ID 18469 //
     /* 1528922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1528939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528961 */     // MIs[0] round
     /* 1528961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528964 */     // MIs[0] policy
     /* 1528964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528974 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1528977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528998 */     // GIR_Coverage, 18469,
     /* 1528998 */     GIR_EraseRootFromParent_Done,
     /* 1528999 */   // Label 21242: @1528999
     /* 1528999 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1529081), // Rule ID 18472 //
     /* 1529004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529043 */     // MIs[0] round
     /* 1529043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529046 */     // MIs[0] policy
     /* 1529046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1529059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529080 */     // GIR_Coverage, 18472,
     /* 1529080 */     GIR_EraseRootFromParent_Done,
     /* 1529081 */   // Label 21243: @1529081
     /* 1529081 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1529163), // Rule ID 18473 //
     /* 1529086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529125 */     // MIs[0] round
     /* 1529125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529128 */     // MIs[0] policy
     /* 1529128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529138 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1529141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529162 */     // GIR_Coverage, 18473,
     /* 1529162 */     GIR_EraseRootFromParent_Done,
     /* 1529163 */   // Label 21244: @1529163
     /* 1529163 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1529245), // Rule ID 18476 //
     /* 1529168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1529185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529207 */     // MIs[0] round
     /* 1529207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529210 */     // MIs[0] policy
     /* 1529210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529220 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1529223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529244 */     // GIR_Coverage, 18476,
     /* 1529244 */     GIR_EraseRootFromParent_Done,
     /* 1529245 */   // Label 21245: @1529245
     /* 1529245 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1529327), // Rule ID 18477 //
     /* 1529250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1529267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529289 */     // MIs[0] round
     /* 1529289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529292 */     // MIs[0] policy
     /* 1529292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529302 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1529305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529326 */     // GIR_Coverage, 18477,
     /* 1529326 */     GIR_EraseRootFromParent_Done,
     /* 1529327 */   // Label 21246: @1529327
     /* 1529327 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1529409), // Rule ID 18480 //
     /* 1529332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529371 */     // MIs[0] round
     /* 1529371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529374 */     // MIs[0] policy
     /* 1529374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1529387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529408 */     // GIR_Coverage, 18480,
     /* 1529408 */     GIR_EraseRootFromParent_Done,
     /* 1529409 */   // Label 21247: @1529409
     /* 1529409 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1529491), // Rule ID 18481 //
     /* 1529414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529453 */     // MIs[0] round
     /* 1529453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529456 */     // MIs[0] policy
     /* 1529456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529466 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1529469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529490 */     // GIR_Coverage, 18481,
     /* 1529490 */     GIR_EraseRootFromParent_Done,
     /* 1529491 */   // Label 21248: @1529491
     /* 1529491 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1529573), // Rule ID 18484 //
     /* 1529496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1529513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529535 */     // MIs[0] round
     /* 1529535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529538 */     // MIs[0] policy
     /* 1529538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529548 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1529551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529572 */     // GIR_Coverage, 18484,
     /* 1529572 */     GIR_EraseRootFromParent_Done,
     /* 1529573 */   // Label 21249: @1529573
     /* 1529573 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1529655), // Rule ID 18485 //
     /* 1529578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1529595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529617 */     // MIs[0] round
     /* 1529617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529620 */     // MIs[0] policy
     /* 1529620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529630 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1529633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529654 */     // GIR_Coverage, 18485,
     /* 1529654 */     GIR_EraseRootFromParent_Done,
     /* 1529655 */   // Label 21250: @1529655
     /* 1529655 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1529737), // Rule ID 18488 //
     /* 1529660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1529677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529699 */     // MIs[0] round
     /* 1529699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529702 */     // MIs[0] policy
     /* 1529702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529712 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1529715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529736 */     // GIR_Coverage, 18488,
     /* 1529736 */     GIR_EraseRootFromParent_Done,
     /* 1529737 */   // Label 21251: @1529737
     /* 1529737 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1529819), // Rule ID 18489 //
     /* 1529742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1529759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529781 */     // MIs[0] round
     /* 1529781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529784 */     // MIs[0] policy
     /* 1529784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529794 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1529797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529818 */     // GIR_Coverage, 18489,
     /* 1529818 */     GIR_EraseRootFromParent_Done,
     /* 1529819 */   // Label 21252: @1529819
     /* 1529819 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1529901), // Rule ID 18492 //
     /* 1529824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1529841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529863 */     // MIs[0] round
     /* 1529863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529866 */     // MIs[0] policy
     /* 1529866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529876 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1529879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529900 */     // GIR_Coverage, 18492,
     /* 1529900 */     GIR_EraseRootFromParent_Done,
     /* 1529901 */   // Label 21253: @1529901
     /* 1529901 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1529983), // Rule ID 18493 //
     /* 1529906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1529923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529945 */     // MIs[0] round
     /* 1529945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529948 */     // MIs[0] policy
     /* 1529948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529958 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1529961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529982 */     // GIR_Coverage, 18493,
     /* 1529982 */     GIR_EraseRootFromParent_Done,
     /* 1529983 */   // Label 21254: @1529983
     /* 1529983 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1530065), // Rule ID 18496 //
     /* 1529988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1529999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1530005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530027 */     // MIs[0] round
     /* 1530027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530030 */     // MIs[0] policy
     /* 1530030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530040 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1530043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530064 */     // GIR_Coverage, 18496,
     /* 1530064 */     GIR_EraseRootFromParent_Done,
     /* 1530065 */   // Label 21255: @1530065
     /* 1530065 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1530147), // Rule ID 18497 //
     /* 1530070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1530087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530109 */     // MIs[0] round
     /* 1530109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530112 */     // MIs[0] policy
     /* 1530112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530122 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1530125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530146 */     // GIR_Coverage, 18497,
     /* 1530146 */     GIR_EraseRootFromParent_Done,
     /* 1530147 */   // Label 21256: @1530147
     /* 1530147 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1530229), // Rule ID 18500 //
     /* 1530152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1530169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530191 */     // MIs[0] round
     /* 1530191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530194 */     // MIs[0] policy
     /* 1530194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530204 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1530207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530228 */     // GIR_Coverage, 18500,
     /* 1530228 */     GIR_EraseRootFromParent_Done,
     /* 1530229 */   // Label 21257: @1530229
     /* 1530229 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1530311), // Rule ID 18501 //
     /* 1530234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1530251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530273 */     // MIs[0] round
     /* 1530273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530276 */     // MIs[0] policy
     /* 1530276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530286 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1530289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530310 */     // GIR_Coverage, 18501,
     /* 1530310 */     GIR_EraseRootFromParent_Done,
     /* 1530311 */   // Label 21258: @1530311
     /* 1530311 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1530393), // Rule ID 18504 //
     /* 1530316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1530333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530355 */     // MIs[0] round
     /* 1530355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530358 */     // MIs[0] policy
     /* 1530358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530368 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1530371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530392 */     // GIR_Coverage, 18504,
     /* 1530392 */     GIR_EraseRootFromParent_Done,
     /* 1530393 */   // Label 21259: @1530393
     /* 1530393 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1530475), // Rule ID 18505 //
     /* 1530398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1530415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530437 */     // MIs[0] round
     /* 1530437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530440 */     // MIs[0] policy
     /* 1530440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530450 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1530453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530474 */     // GIR_Coverage, 18505,
     /* 1530474 */     GIR_EraseRootFromParent_Done,
     /* 1530475 */   // Label 21260: @1530475
     /* 1530475 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1530557), // Rule ID 18508 //
     /* 1530480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1530497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530519 */     // MIs[0] round
     /* 1530519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530522 */     // MIs[0] policy
     /* 1530522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530532 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1530535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530556 */     // GIR_Coverage, 18508,
     /* 1530556 */     GIR_EraseRootFromParent_Done,
     /* 1530557 */   // Label 21261: @1530557
     /* 1530557 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1530639), // Rule ID 18509 //
     /* 1530562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1530579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530601 */     // MIs[0] round
     /* 1530601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530604 */     // MIs[0] policy
     /* 1530604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530614 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1530617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530638 */     // GIR_Coverage, 18509,
     /* 1530638 */     GIR_EraseRootFromParent_Done,
     /* 1530639 */   // Label 21262: @1530639
     /* 1530639 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1530721), // Rule ID 18512 //
     /* 1530644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1530661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530683 */     // MIs[0] round
     /* 1530683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530686 */     // MIs[0] policy
     /* 1530686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530696 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1530699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530720 */     // GIR_Coverage, 18512,
     /* 1530720 */     GIR_EraseRootFromParent_Done,
     /* 1530721 */   // Label 21263: @1530721
     /* 1530721 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1530803), // Rule ID 18513 //
     /* 1530726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1530743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530765 */     // MIs[0] round
     /* 1530765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530768 */     // MIs[0] policy
     /* 1530768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530778 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1530781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530802 */     // GIR_Coverage, 18513,
     /* 1530802 */     GIR_EraseRootFromParent_Done,
     /* 1530803 */   // Label 21264: @1530803
     /* 1530803 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1530885), // Rule ID 18516 //
     /* 1530808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1530825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530847 */     // MIs[0] round
     /* 1530847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530850 */     // MIs[0] policy
     /* 1530850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530860 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1530863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530884 */     // GIR_Coverage, 18516,
     /* 1530884 */     GIR_EraseRootFromParent_Done,
     /* 1530885 */   // Label 21265: @1530885
     /* 1530885 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1530967), // Rule ID 18517 //
     /* 1530890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1530907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530929 */     // MIs[0] round
     /* 1530929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530932 */     // MIs[0] policy
     /* 1530932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530942 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1530945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530966 */     // GIR_Coverage, 18517,
     /* 1530966 */     GIR_EraseRootFromParent_Done,
     /* 1530967 */   // Label 21266: @1530967
     /* 1530967 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1531049), // Rule ID 18520 //
     /* 1530972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1530983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1530986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1530989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1530992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531011 */     // MIs[0] round
     /* 1531011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531014 */     // MIs[0] policy
     /* 1531014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531024 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1531027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531048 */     // GIR_Coverage, 18520,
     /* 1531048 */     GIR_EraseRootFromParent_Done,
     /* 1531049 */   // Label 21267: @1531049
     /* 1531049 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1531131), // Rule ID 18521 //
     /* 1531054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1531071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531093 */     // MIs[0] round
     /* 1531093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531096 */     // MIs[0] policy
     /* 1531096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531106 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1531109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531130 */     // GIR_Coverage, 18521,
     /* 1531130 */     GIR_EraseRootFromParent_Done,
     /* 1531131 */   // Label 21268: @1531131
     /* 1531131 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1531213), // Rule ID 18524 //
     /* 1531136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531175 */     // MIs[0] round
     /* 1531175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531178 */     // MIs[0] policy
     /* 1531178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531188 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1531191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531212 */     // GIR_Coverage, 18524,
     /* 1531212 */     GIR_EraseRootFromParent_Done,
     /* 1531213 */   // Label 21269: @1531213
     /* 1531213 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1531295), // Rule ID 18525 //
     /* 1531218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531257 */     // MIs[0] round
     /* 1531257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531260 */     // MIs[0] policy
     /* 1531260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531270 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1531273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531294 */     // GIR_Coverage, 18525,
     /* 1531294 */     GIR_EraseRootFromParent_Done,
     /* 1531295 */   // Label 21270: @1531295
     /* 1531295 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1531377), // Rule ID 18528 //
     /* 1531300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531339 */     // MIs[0] round
     /* 1531339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531342 */     // MIs[0] policy
     /* 1531342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531352 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1531355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531376 */     // GIR_Coverage, 18528,
     /* 1531376 */     GIR_EraseRootFromParent_Done,
     /* 1531377 */   // Label 21271: @1531377
     /* 1531377 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1531459), // Rule ID 18529 //
     /* 1531382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531421 */     // MIs[0] round
     /* 1531421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531424 */     // MIs[0] policy
     /* 1531424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531434 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1531437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531458 */     // GIR_Coverage, 18529,
     /* 1531458 */     GIR_EraseRootFromParent_Done,
     /* 1531459 */   // Label 21272: @1531459
     /* 1531459 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1531541), // Rule ID 18532 //
     /* 1531464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1531481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1531499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531503 */     // MIs[0] round
     /* 1531503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531506 */     // MIs[0] policy
     /* 1531506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1531519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531540 */     // GIR_Coverage, 18532,
     /* 1531540 */     GIR_EraseRootFromParent_Done,
     /* 1531541 */   // Label 21273: @1531541
     /* 1531541 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1531623), // Rule ID 18533 //
     /* 1531546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1531563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1531581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531585 */     // MIs[0] round
     /* 1531585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531588 */     // MIs[0] policy
     /* 1531588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531598 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1531601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531622 */     // GIR_Coverage, 18533,
     /* 1531622 */     GIR_EraseRootFromParent_Done,
     /* 1531623 */   // Label 21274: @1531623
     /* 1531623 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1531705), // Rule ID 18536 //
     /* 1531628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531667 */     // MIs[0] round
     /* 1531667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531670 */     // MIs[0] policy
     /* 1531670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531680 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1531683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531704 */     // GIR_Coverage, 18536,
     /* 1531704 */     GIR_EraseRootFromParent_Done,
     /* 1531705 */   // Label 21275: @1531705
     /* 1531705 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1531787), // Rule ID 18537 //
     /* 1531710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531749 */     // MIs[0] round
     /* 1531749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531752 */     // MIs[0] policy
     /* 1531752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531762 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1531765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531786 */     // GIR_Coverage, 18537,
     /* 1531786 */     GIR_EraseRootFromParent_Done,
     /* 1531787 */   // Label 21276: @1531787
     /* 1531787 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1531869), // Rule ID 18540 //
     /* 1531792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1531809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1531827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531831 */     // MIs[0] round
     /* 1531831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531834 */     // MIs[0] policy
     /* 1531834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531844 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1531847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531868 */     // GIR_Coverage, 18540,
     /* 1531868 */     GIR_EraseRootFromParent_Done,
     /* 1531869 */   // Label 21277: @1531869
     /* 1531869 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1531951), // Rule ID 18541 //
     /* 1531874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1531891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1531909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531913 */     // MIs[0] round
     /* 1531913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531916 */     // MIs[0] policy
     /* 1531916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531926 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1531929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531950 */     // GIR_Coverage, 18541,
     /* 1531950 */     GIR_EraseRootFromParent_Done,
     /* 1531951 */   // Label 21278: @1531951
     /* 1531951 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1532033), // Rule ID 18544 //
     /* 1531956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1531973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1531976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1531991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531995 */     // MIs[0] round
     /* 1531995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531998 */     // MIs[0] policy
     /* 1531998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1532011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532032 */     // GIR_Coverage, 18544,
     /* 1532032 */     GIR_EraseRootFromParent_Done,
     /* 1532033 */   // Label 21279: @1532033
     /* 1532033 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1532115), // Rule ID 18545 //
     /* 1532038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1532055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1532073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532077 */     // MIs[0] round
     /* 1532077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532080 */     // MIs[0] policy
     /* 1532080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1532093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532114 */     // GIR_Coverage, 18545,
     /* 1532114 */     GIR_EraseRootFromParent_Done,
     /* 1532115 */   // Label 21280: @1532115
     /* 1532115 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1532197), // Rule ID 18548 //
     /* 1532120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532159 */     // MIs[0] round
     /* 1532159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532162 */     // MIs[0] policy
     /* 1532162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532172 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1532175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532196 */     // GIR_Coverage, 18548,
     /* 1532196 */     GIR_EraseRootFromParent_Done,
     /* 1532197 */   // Label 21281: @1532197
     /* 1532197 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1532279), // Rule ID 18549 //
     /* 1532202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532241 */     // MIs[0] round
     /* 1532241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532244 */     // MIs[0] policy
     /* 1532244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1532257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532278 */     // GIR_Coverage, 18549,
     /* 1532278 */     GIR_EraseRootFromParent_Done,
     /* 1532279 */   // Label 21282: @1532279
     /* 1532279 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1532361), // Rule ID 18552 //
     /* 1532284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532323 */     // MIs[0] round
     /* 1532323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532326 */     // MIs[0] policy
     /* 1532326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532336 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1532339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532360 */     // GIR_Coverage, 18552,
     /* 1532360 */     GIR_EraseRootFromParent_Done,
     /* 1532361 */   // Label 21283: @1532361
     /* 1532361 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1532443), // Rule ID 18553 //
     /* 1532366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532405 */     // MIs[0] round
     /* 1532405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532408 */     // MIs[0] policy
     /* 1532408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532418 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1532421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532442 */     // GIR_Coverage, 18553,
     /* 1532442 */     GIR_EraseRootFromParent_Done,
     /* 1532443 */   // Label 21284: @1532443
     /* 1532443 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1532525), // Rule ID 18556 //
     /* 1532448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532487 */     // MIs[0] round
     /* 1532487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532490 */     // MIs[0] policy
     /* 1532490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532500 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1532503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532524 */     // GIR_Coverage, 18556,
     /* 1532524 */     GIR_EraseRootFromParent_Done,
     /* 1532525 */   // Label 21285: @1532525
     /* 1532525 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1532607), // Rule ID 18557 //
     /* 1532530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532569 */     // MIs[0] round
     /* 1532569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532572 */     // MIs[0] policy
     /* 1532572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532582 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1532585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532606 */     // GIR_Coverage, 18557,
     /* 1532606 */     GIR_EraseRootFromParent_Done,
     /* 1532607 */   // Label 21286: @1532607
     /* 1532607 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1532689), // Rule ID 18560 //
     /* 1532612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532651 */     // MIs[0] round
     /* 1532651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532654 */     // MIs[0] policy
     /* 1532654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532664 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1532667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532688 */     // GIR_Coverage, 18560,
     /* 1532688 */     GIR_EraseRootFromParent_Done,
     /* 1532689 */   // Label 21287: @1532689
     /* 1532689 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1532771), // Rule ID 18561 //
     /* 1532694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532733 */     // MIs[0] round
     /* 1532733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532736 */     // MIs[0] policy
     /* 1532736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532746 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1532749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532770 */     // GIR_Coverage, 18561,
     /* 1532770 */     GIR_EraseRootFromParent_Done,
     /* 1532771 */   // Label 21288: @1532771
     /* 1532771 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1532853), // Rule ID 18564 //
     /* 1532776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532815 */     // MIs[0] round
     /* 1532815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532818 */     // MIs[0] policy
     /* 1532818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532828 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1532831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532852 */     // GIR_Coverage, 18564,
     /* 1532852 */     GIR_EraseRootFromParent_Done,
     /* 1532853 */   // Label 21289: @1532853
     /* 1532853 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1532935), // Rule ID 18565 //
     /* 1532858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532897 */     // MIs[0] round
     /* 1532897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532900 */     // MIs[0] policy
     /* 1532900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532910 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1532913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532934 */     // GIR_Coverage, 18565,
     /* 1532934 */     GIR_EraseRootFromParent_Done,
     /* 1532935 */   // Label 21290: @1532935
     /* 1532935 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1533017), // Rule ID 18568 //
     /* 1532940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1532951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1532954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1532960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532979 */     // MIs[0] round
     /* 1532979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532982 */     // MIs[0] policy
     /* 1532982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532992 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1532995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533016 */     // GIR_Coverage, 18568,
     /* 1533016 */     GIR_EraseRootFromParent_Done,
     /* 1533017 */   // Label 21291: @1533017
     /* 1533017 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1533099), // Rule ID 18569 //
     /* 1533022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533061 */     // MIs[0] round
     /* 1533061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533064 */     // MIs[0] policy
     /* 1533064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533074 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1533077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533098 */     // GIR_Coverage, 18569,
     /* 1533098 */     GIR_EraseRootFromParent_Done,
     /* 1533099 */   // Label 21292: @1533099
     /* 1533099 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1533181), // Rule ID 18572 //
     /* 1533104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533143 */     // MIs[0] round
     /* 1533143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533146 */     // MIs[0] policy
     /* 1533146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1533159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533180 */     // GIR_Coverage, 18572,
     /* 1533180 */     GIR_EraseRootFromParent_Done,
     /* 1533181 */   // Label 21293: @1533181
     /* 1533181 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1533263), // Rule ID 18573 //
     /* 1533186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533225 */     // MIs[0] round
     /* 1533225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533228 */     // MIs[0] policy
     /* 1533228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1533241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533262 */     // GIR_Coverage, 18573,
     /* 1533262 */     GIR_EraseRootFromParent_Done,
     /* 1533263 */   // Label 21294: @1533263
     /* 1533263 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1533345), // Rule ID 18576 //
     /* 1533268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533307 */     // MIs[0] round
     /* 1533307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533310 */     // MIs[0] policy
     /* 1533310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533320 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1533323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533344 */     // GIR_Coverage, 18576,
     /* 1533344 */     GIR_EraseRootFromParent_Done,
     /* 1533345 */   // Label 21295: @1533345
     /* 1533345 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1533427), // Rule ID 18577 //
     /* 1533350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533389 */     // MIs[0] round
     /* 1533389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533392 */     // MIs[0] policy
     /* 1533392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533402 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1533405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533426 */     // GIR_Coverage, 18577,
     /* 1533426 */     GIR_EraseRootFromParent_Done,
     /* 1533427 */   // Label 21296: @1533427
     /* 1533427 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1533509), // Rule ID 18580 //
     /* 1533432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533471 */     // MIs[0] round
     /* 1533471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533474 */     // MIs[0] policy
     /* 1533474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533484 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1533487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533508 */     // GIR_Coverage, 18580,
     /* 1533508 */     GIR_EraseRootFromParent_Done,
     /* 1533509 */   // Label 21297: @1533509
     /* 1533509 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1533591), // Rule ID 18581 //
     /* 1533514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533553 */     // MIs[0] round
     /* 1533553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533556 */     // MIs[0] policy
     /* 1533556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533566 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1533569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533590 */     // GIR_Coverage, 18581,
     /* 1533590 */     GIR_EraseRootFromParent_Done,
     /* 1533591 */   // Label 21298: @1533591
     /* 1533591 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1533673), // Rule ID 18584 //
     /* 1533596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1533613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533635 */     // MIs[0] round
     /* 1533635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533638 */     // MIs[0] policy
     /* 1533638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533648 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1533651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533672 */     // GIR_Coverage, 18584,
     /* 1533672 */     GIR_EraseRootFromParent_Done,
     /* 1533673 */   // Label 21299: @1533673
     /* 1533673 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1533755), // Rule ID 18585 //
     /* 1533678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1533695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533717 */     // MIs[0] round
     /* 1533717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533720 */     // MIs[0] policy
     /* 1533720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533730 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1533733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533754 */     // GIR_Coverage, 18585,
     /* 1533754 */     GIR_EraseRootFromParent_Done,
     /* 1533755 */   // Label 21300: @1533755
     /* 1533755 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1533837), // Rule ID 18588 //
     /* 1533760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1533777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533799 */     // MIs[0] round
     /* 1533799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533802 */     // MIs[0] policy
     /* 1533802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533812 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1533815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533836 */     // GIR_Coverage, 18588,
     /* 1533836 */     GIR_EraseRootFromParent_Done,
     /* 1533837 */   // Label 21301: @1533837
     /* 1533837 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1533919), // Rule ID 18589 //
     /* 1533842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1533859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533881 */     // MIs[0] round
     /* 1533881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533884 */     // MIs[0] policy
     /* 1533884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533894 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1533897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533918 */     // GIR_Coverage, 18589,
     /* 1533918 */     GIR_EraseRootFromParent_Done,
     /* 1533919 */   // Label 21302: @1533919
     /* 1533919 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1534001), // Rule ID 18592 //
     /* 1533924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1533941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1533944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533963 */     // MIs[0] round
     /* 1533963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533966 */     // MIs[0] policy
     /* 1533966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533976 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1533979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534000 */     // GIR_Coverage, 18592,
     /* 1534000 */     GIR_EraseRootFromParent_Done,
     /* 1534001 */   // Label 21303: @1534001
     /* 1534001 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1534083), // Rule ID 18593 //
     /* 1534006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1534023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1534026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534045 */     // MIs[0] round
     /* 1534045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534048 */     // MIs[0] policy
     /* 1534048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534058 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1534061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534082 */     // GIR_Coverage, 18593,
     /* 1534082 */     GIR_EraseRootFromParent_Done,
     /* 1534083 */   // Label 21304: @1534083
     /* 1534083 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1534165), // Rule ID 18596 //
     /* 1534088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1534105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534127 */     // MIs[0] round
     /* 1534127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534130 */     // MIs[0] policy
     /* 1534130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534140 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1534143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534164 */     // GIR_Coverage, 18596,
     /* 1534164 */     GIR_EraseRootFromParent_Done,
     /* 1534165 */   // Label 21305: @1534165
     /* 1534165 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1534247), // Rule ID 18597 //
     /* 1534170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1534181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1534184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1534187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534209 */     // MIs[0] round
     /* 1534209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534212 */     // MIs[0] policy
     /* 1534212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1534225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534246 */     // GIR_Coverage, 18597,
     /* 1534246 */     GIR_EraseRootFromParent_Done,
     /* 1534247 */   // Label 21306: @1534247
     /* 1534247 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1534329), // Rule ID 18600 //
     /* 1534252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1534269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534291 */     // MIs[0] round
     /* 1534291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534294 */     // MIs[0] policy
     /* 1534294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1534307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534328 */     // GIR_Coverage, 18600,
     /* 1534328 */     GIR_EraseRootFromParent_Done,
     /* 1534329 */   // Label 21307: @1534329
     /* 1534329 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1534411), // Rule ID 18601 //
     /* 1534334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1534351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534373 */     // MIs[0] round
     /* 1534373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534376 */     // MIs[0] policy
     /* 1534376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1534389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534410 */     // GIR_Coverage, 18601,
     /* 1534410 */     GIR_EraseRootFromParent_Done,
     /* 1534411 */   // Label 21308: @1534411
     /* 1534411 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1534493), // Rule ID 18604 //
     /* 1534416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1534433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534455 */     // MIs[0] round
     /* 1534455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534458 */     // MIs[0] policy
     /* 1534458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534468 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1534471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534492 */     // GIR_Coverage, 18604,
     /* 1534492 */     GIR_EraseRootFromParent_Done,
     /* 1534493 */   // Label 21309: @1534493
     /* 1534493 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1534575), // Rule ID 18605 //
     /* 1534498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1534515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534537 */     // MIs[0] round
     /* 1534537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534540 */     // MIs[0] policy
     /* 1534540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1534553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534574 */     // GIR_Coverage, 18605,
     /* 1534574 */     GIR_EraseRootFromParent_Done,
     /* 1534575 */   // Label 21310: @1534575
     /* 1534575 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1534657), // Rule ID 18608 //
     /* 1534580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1534597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534619 */     // MIs[0] round
     /* 1534619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534622 */     // MIs[0] policy
     /* 1534622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534632 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1534635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534656 */     // GIR_Coverage, 18608,
     /* 1534656 */     GIR_EraseRootFromParent_Done,
     /* 1534657 */   // Label 21311: @1534657
     /* 1534657 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1534739), // Rule ID 18609 //
     /* 1534662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1534679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534701 */     // MIs[0] round
     /* 1534701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534704 */     // MIs[0] policy
     /* 1534704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534714 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1534717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534738 */     // GIR_Coverage, 18609,
     /* 1534738 */     GIR_EraseRootFromParent_Done,
     /* 1534739 */   // Label 21312: @1534739
     /* 1534739 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1534821), // Rule ID 18612 //
     /* 1534744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1534761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534783 */     // MIs[0] round
     /* 1534783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534786 */     // MIs[0] policy
     /* 1534786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534796 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1534799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534820 */     // GIR_Coverage, 18612,
     /* 1534820 */     GIR_EraseRootFromParent_Done,
     /* 1534821 */   // Label 21313: @1534821
     /* 1534821 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1534903), // Rule ID 18613 //
     /* 1534826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1534843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534865 */     // MIs[0] round
     /* 1534865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534868 */     // MIs[0] policy
     /* 1534868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534878 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1534881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534902 */     // GIR_Coverage, 18613,
     /* 1534902 */     GIR_EraseRootFromParent_Done,
     /* 1534903 */   // Label 21314: @1534903
     /* 1534903 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1534985), // Rule ID 18616 //
     /* 1534908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1534919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1534922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1534925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1534928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534947 */     // MIs[0] round
     /* 1534947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534950 */     // MIs[0] policy
     /* 1534950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534960 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1534963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534984 */     // GIR_Coverage, 18616,
     /* 1534984 */     GIR_EraseRootFromParent_Done,
     /* 1534985 */   // Label 21315: @1534985
     /* 1534985 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1535067), // Rule ID 18617 //
     /* 1534990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1535001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1535004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1535007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1535010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535029 */     // MIs[0] round
     /* 1535029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535032 */     // MIs[0] policy
     /* 1535032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535042 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1535045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535066 */     // GIR_Coverage, 18617,
     /* 1535066 */     GIR_EraseRootFromParent_Done,
     /* 1535067 */   // Label 21316: @1535067
     /* 1535067 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1535149), // Rule ID 18620 //
     /* 1535072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1535089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535111 */     // MIs[0] round
     /* 1535111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535114 */     // MIs[0] policy
     /* 1535114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1535127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535148 */     // GIR_Coverage, 18620,
     /* 1535148 */     GIR_EraseRootFromParent_Done,
     /* 1535149 */   // Label 21317: @1535149
     /* 1535149 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1535231), // Rule ID 18621 //
     /* 1535154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1535171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535193 */     // MIs[0] round
     /* 1535193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535196 */     // MIs[0] policy
     /* 1535196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535206 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1535209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535230 */     // GIR_Coverage, 18621,
     /* 1535230 */     GIR_EraseRootFromParent_Done,
     /* 1535231 */   // Label 21318: @1535231
     /* 1535231 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1535313), // Rule ID 18624 //
     /* 1535236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1535253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535275 */     // MIs[0] round
     /* 1535275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535278 */     // MIs[0] policy
     /* 1535278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535288 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1535291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535312 */     // GIR_Coverage, 18624,
     /* 1535312 */     GIR_EraseRootFromParent_Done,
     /* 1535313 */   // Label 21319: @1535313
     /* 1535313 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1535395), // Rule ID 18625 //
     /* 1535318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1535335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535357 */     // MIs[0] round
     /* 1535357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535360 */     // MIs[0] policy
     /* 1535360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535370 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1535373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535394 */     // GIR_Coverage, 18625,
     /* 1535394 */     GIR_EraseRootFromParent_Done,
     /* 1535395 */   // Label 21320: @1535395
     /* 1535395 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1535477), // Rule ID 18628 //
     /* 1535400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1535417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535439 */     // MIs[0] round
     /* 1535439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535442 */     // MIs[0] policy
     /* 1535442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535452 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1535455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535476 */     // GIR_Coverage, 18628,
     /* 1535476 */     GIR_EraseRootFromParent_Done,
     /* 1535477 */   // Label 21321: @1535477
     /* 1535477 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1535559), // Rule ID 18629 //
     /* 1535482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1535499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535521 */     // MIs[0] round
     /* 1535521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535524 */     // MIs[0] policy
     /* 1535524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1535537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535558 */     // GIR_Coverage, 18629,
     /* 1535558 */     GIR_EraseRootFromParent_Done,
     /* 1535559 */   // Label 21322: @1535559
     /* 1535559 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1535641), // Rule ID 18632 //
     /* 1535564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1535581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535603 */     // MIs[0] round
     /* 1535603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535606 */     // MIs[0] policy
     /* 1535606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535616 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1535619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535640 */     // GIR_Coverage, 18632,
     /* 1535640 */     GIR_EraseRootFromParent_Done,
     /* 1535641 */   // Label 21323: @1535641
     /* 1535641 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1535723), // Rule ID 18633 //
     /* 1535646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1535663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535685 */     // MIs[0] round
     /* 1535685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535688 */     // MIs[0] policy
     /* 1535688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535698 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1535701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535722 */     // GIR_Coverage, 18633,
     /* 1535722 */     GIR_EraseRootFromParent_Done,
     /* 1535723 */   // Label 21324: @1535723
     /* 1535723 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1535805), // Rule ID 18636 //
     /* 1535728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1535745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535767 */     // MIs[0] round
     /* 1535767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535770 */     // MIs[0] policy
     /* 1535770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535780 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1535783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535804 */     // GIR_Coverage, 18636,
     /* 1535804 */     GIR_EraseRootFromParent_Done,
     /* 1535805 */   // Label 21325: @1535805
     /* 1535805 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1535887), // Rule ID 18637 //
     /* 1535810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1535827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535849 */     // MIs[0] round
     /* 1535849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535852 */     // MIs[0] policy
     /* 1535852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535862 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1535865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535886 */     // GIR_Coverage, 18637,
     /* 1535886 */     GIR_EraseRootFromParent_Done,
     /* 1535887 */   // Label 21326: @1535887
     /* 1535887 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1535969), // Rule ID 18640 //
     /* 1535892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1535909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535931 */     // MIs[0] round
     /* 1535931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535934 */     // MIs[0] policy
     /* 1535934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535944 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1535947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535968 */     // GIR_Coverage, 18640,
     /* 1535968 */     GIR_EraseRootFromParent_Done,
     /* 1535969 */   // Label 21327: @1535969
     /* 1535969 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1536051), // Rule ID 18641 //
     /* 1535974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1535991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536013 */     // MIs[0] round
     /* 1536013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536016 */     // MIs[0] policy
     /* 1536016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536026 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1536029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536050 */     // GIR_Coverage, 18641,
     /* 1536050 */     GIR_EraseRootFromParent_Done,
     /* 1536051 */   // Label 21328: @1536051
     /* 1536051 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1536133), // Rule ID 18644 //
     /* 1536056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536095 */     // MIs[0] round
     /* 1536095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536098 */     // MIs[0] policy
     /* 1536098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536108 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1536111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536132 */     // GIR_Coverage, 18644,
     /* 1536132 */     GIR_EraseRootFromParent_Done,
     /* 1536133 */   // Label 21329: @1536133
     /* 1536133 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1536215), // Rule ID 18645 //
     /* 1536138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1536149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1536152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1536158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536177 */     // MIs[0] round
     /* 1536177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536180 */     // MIs[0] policy
     /* 1536180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536190 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1536193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536214 */     // GIR_Coverage, 18645,
     /* 1536214 */     GIR_EraseRootFromParent_Done,
     /* 1536215 */   // Label 21330: @1536215
     /* 1536215 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1536297), // Rule ID 18648 //
     /* 1536220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536259 */     // MIs[0] round
     /* 1536259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536262 */     // MIs[0] policy
     /* 1536262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536272 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1536275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536296 */     // GIR_Coverage, 18648,
     /* 1536296 */     GIR_EraseRootFromParent_Done,
     /* 1536297 */   // Label 21331: @1536297
     /* 1536297 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1536379), // Rule ID 18649 //
     /* 1536302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536341 */     // MIs[0] round
     /* 1536341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536344 */     // MIs[0] policy
     /* 1536344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536354 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1536357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536378 */     // GIR_Coverage, 18649,
     /* 1536378 */     GIR_EraseRootFromParent_Done,
     /* 1536379 */   // Label 21332: @1536379
     /* 1536379 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1536461), // Rule ID 18652 //
     /* 1536384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536423 */     // MIs[0] round
     /* 1536423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536426 */     // MIs[0] policy
     /* 1536426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536436 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1536439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536460 */     // GIR_Coverage, 18652,
     /* 1536460 */     GIR_EraseRootFromParent_Done,
     /* 1536461 */   // Label 21333: @1536461
     /* 1536461 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1536543), // Rule ID 18653 //
     /* 1536466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536505 */     // MIs[0] round
     /* 1536505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536508 */     // MIs[0] policy
     /* 1536508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536518 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1536521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536542 */     // GIR_Coverage, 18653,
     /* 1536542 */     GIR_EraseRootFromParent_Done,
     /* 1536543 */   // Label 21334: @1536543
     /* 1536543 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1536625), // Rule ID 18656 //
     /* 1536548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536587 */     // MIs[0] round
     /* 1536587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536590 */     // MIs[0] policy
     /* 1536590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536600 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1536603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536624 */     // GIR_Coverage, 18656,
     /* 1536624 */     GIR_EraseRootFromParent_Done,
     /* 1536625 */   // Label 21335: @1536625
     /* 1536625 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1536707), // Rule ID 18657 //
     /* 1536630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536669 */     // MIs[0] round
     /* 1536669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536672 */     // MIs[0] policy
     /* 1536672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536682 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1536685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536706 */     // GIR_Coverage, 18657,
     /* 1536706 */     GIR_EraseRootFromParent_Done,
     /* 1536707 */   // Label 21336: @1536707
     /* 1536707 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1536789), // Rule ID 18660 //
     /* 1536712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536751 */     // MIs[0] round
     /* 1536751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536754 */     // MIs[0] policy
     /* 1536754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1536767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536788 */     // GIR_Coverage, 18660,
     /* 1536788 */     GIR_EraseRootFromParent_Done,
     /* 1536789 */   // Label 21337: @1536789
     /* 1536789 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1536871), // Rule ID 18661 //
     /* 1536794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536833 */     // MIs[0] round
     /* 1536833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536836 */     // MIs[0] policy
     /* 1536836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536846 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1536849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536870 */     // GIR_Coverage, 18661,
     /* 1536870 */     GIR_EraseRootFromParent_Done,
     /* 1536871 */   // Label 21338: @1536871
     /* 1536871 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1536953), // Rule ID 18664 //
     /* 1536876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536915 */     // MIs[0] round
     /* 1536915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536918 */     // MIs[0] policy
     /* 1536918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536928 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1536931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536952 */     // GIR_Coverage, 18664,
     /* 1536952 */     GIR_EraseRootFromParent_Done,
     /* 1536953 */   // Label 21339: @1536953
     /* 1536953 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1537035), // Rule ID 18665 //
     /* 1536958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1536975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1536993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536997 */     // MIs[0] round
     /* 1536997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537000 */     // MIs[0] policy
     /* 1537000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537010 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1537013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537034 */     // GIR_Coverage, 18665,
     /* 1537034 */     GIR_EraseRootFromParent_Done,
     /* 1537035 */   // Label 21340: @1537035
     /* 1537035 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1537117), // Rule ID 18668 //
     /* 1537040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537079 */     // MIs[0] round
     /* 1537079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537082 */     // MIs[0] policy
     /* 1537082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537092 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1537095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537116 */     // GIR_Coverage, 18668,
     /* 1537116 */     GIR_EraseRootFromParent_Done,
     /* 1537117 */   // Label 21341: @1537117
     /* 1537117 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1537199), // Rule ID 18669 //
     /* 1537122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1537133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1537136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537161 */     // MIs[0] round
     /* 1537161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537164 */     // MIs[0] policy
     /* 1537164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537174 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1537177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537198 */     // GIR_Coverage, 18669,
     /* 1537198 */     GIR_EraseRootFromParent_Done,
     /* 1537199 */   // Label 21342: @1537199
     /* 1537199 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1537281), // Rule ID 18672 //
     /* 1537204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537243 */     // MIs[0] round
     /* 1537243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537246 */     // MIs[0] policy
     /* 1537246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537256 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1537259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537280 */     // GIR_Coverage, 18672,
     /* 1537280 */     GIR_EraseRootFromParent_Done,
     /* 1537281 */   // Label 21343: @1537281
     /* 1537281 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1537363), // Rule ID 18673 //
     /* 1537286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537325 */     // MIs[0] round
     /* 1537325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537328 */     // MIs[0] policy
     /* 1537328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537338 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1537341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537362 */     // GIR_Coverage, 18673,
     /* 1537362 */     GIR_EraseRootFromParent_Done,
     /* 1537363 */   // Label 21344: @1537363
     /* 1537363 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1537445), // Rule ID 18676 //
     /* 1537368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537407 */     // MIs[0] round
     /* 1537407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537410 */     // MIs[0] policy
     /* 1537410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537420 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1537423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537444 */     // GIR_Coverage, 18676,
     /* 1537444 */     GIR_EraseRootFromParent_Done,
     /* 1537445 */   // Label 21345: @1537445
     /* 1537445 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1537527), // Rule ID 18677 //
     /* 1537450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1537467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1537485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537489 */     // MIs[0] round
     /* 1537489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537492 */     // MIs[0] policy
     /* 1537492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537502 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1537505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537526 */     // GIR_Coverage, 18677,
     /* 1537526 */     GIR_EraseRootFromParent_Done,
     /* 1537527 */   // Label 21346: @1537527
     /* 1537527 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1537609), // Rule ID 18680 //
     /* 1537532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537571 */     // MIs[0] round
     /* 1537571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537574 */     // MIs[0] policy
     /* 1537574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537584 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1537587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537608 */     // GIR_Coverage, 18680,
     /* 1537608 */     GIR_EraseRootFromParent_Done,
     /* 1537609 */   // Label 21347: @1537609
     /* 1537609 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1537691), // Rule ID 18681 //
     /* 1537614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537653 */     // MIs[0] round
     /* 1537653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537656 */     // MIs[0] policy
     /* 1537656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537666 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1537669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537690 */     // GIR_Coverage, 18681,
     /* 1537690 */     GIR_EraseRootFromParent_Done,
     /* 1537691 */   // Label 21348: @1537691
     /* 1537691 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1537773), // Rule ID 18684 //
     /* 1537696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537735 */     // MIs[0] round
     /* 1537735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537738 */     // MIs[0] policy
     /* 1537738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537748 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1537751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537772 */     // GIR_Coverage, 18684,
     /* 1537772 */     GIR_EraseRootFromParent_Done,
     /* 1537773 */   // Label 21349: @1537773
     /* 1537773 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1537855), // Rule ID 18685 //
     /* 1537778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537817 */     // MIs[0] round
     /* 1537817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537820 */     // MIs[0] policy
     /* 1537820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537830 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1537833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537854 */     // GIR_Coverage, 18685,
     /* 1537854 */     GIR_EraseRootFromParent_Done,
     /* 1537855 */   // Label 21350: @1537855
     /* 1537855 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1537937), // Rule ID 18688 //
     /* 1537860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537899 */     // MIs[0] round
     /* 1537899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537902 */     // MIs[0] policy
     /* 1537902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537912 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1537915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537936 */     // GIR_Coverage, 18688,
     /* 1537936 */     GIR_EraseRootFromParent_Done,
     /* 1537937 */   // Label 21351: @1537937
     /* 1537937 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1538019), // Rule ID 18689 //
     /* 1537942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537981 */     // MIs[0] round
     /* 1537981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537984 */     // MIs[0] policy
     /* 1537984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537994 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1537997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538018 */     // GIR_Coverage, 18689,
     /* 1538018 */     GIR_EraseRootFromParent_Done,
     /* 1538019 */   // Label 21352: @1538019
     /* 1538019 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1538101), // Rule ID 18692 //
     /* 1538024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538063 */     // MIs[0] round
     /* 1538063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538066 */     // MIs[0] policy
     /* 1538066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1538079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538100 */     // GIR_Coverage, 18692,
     /* 1538100 */     GIR_EraseRootFromParent_Done,
     /* 1538101 */   // Label 21353: @1538101
     /* 1538101 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1538183), // Rule ID 18693 //
     /* 1538106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1538126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538145 */     // MIs[0] round
     /* 1538145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538148 */     // MIs[0] policy
     /* 1538148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1538161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538182 */     // GIR_Coverage, 18693,
     /* 1538182 */     GIR_EraseRootFromParent_Done,
     /* 1538183 */   // Label 21354: @1538183
     /* 1538183 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1538265), // Rule ID 18696 //
     /* 1538188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538227 */     // MIs[0] round
     /* 1538227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538230 */     // MIs[0] policy
     /* 1538230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538240 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1538243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538264 */     // GIR_Coverage, 18696,
     /* 1538264 */     GIR_EraseRootFromParent_Done,
     /* 1538265 */   // Label 21355: @1538265
     /* 1538265 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1538347), // Rule ID 18697 //
     /* 1538270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538309 */     // MIs[0] round
     /* 1538309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538312 */     // MIs[0] policy
     /* 1538312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538322 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1538325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538346 */     // GIR_Coverage, 18697,
     /* 1538346 */     GIR_EraseRootFromParent_Done,
     /* 1538347 */   // Label 21356: @1538347
     /* 1538347 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1538429), // Rule ID 18700 //
     /* 1538352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538391 */     // MIs[0] round
     /* 1538391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538394 */     // MIs[0] policy
     /* 1538394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538404 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1538407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538428 */     // GIR_Coverage, 18700,
     /* 1538428 */     GIR_EraseRootFromParent_Done,
     /* 1538429 */   // Label 21357: @1538429
     /* 1538429 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1538511), // Rule ID 18701 //
     /* 1538434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1538451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1538469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538473 */     // MIs[0] round
     /* 1538473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538476 */     // MIs[0] policy
     /* 1538476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538486 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1538489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538510 */     // GIR_Coverage, 18701,
     /* 1538510 */     GIR_EraseRootFromParent_Done,
     /* 1538511 */   // Label 21358: @1538511
     /* 1538511 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1538593), // Rule ID 18704 //
     /* 1538516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1538533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538555 */     // MIs[0] round
     /* 1538555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538558 */     // MIs[0] policy
     /* 1538558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538568 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1538571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538592 */     // GIR_Coverage, 18704,
     /* 1538592 */     GIR_EraseRootFromParent_Done,
     /* 1538593 */   // Label 21359: @1538593
     /* 1538593 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1538675), // Rule ID 18705 //
     /* 1538598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1538601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1538615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538637 */     // MIs[0] round
     /* 1538637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538640 */     // MIs[0] policy
     /* 1538640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538650 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1538653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538674 */     // GIR_Coverage, 18705,
     /* 1538674 */     GIR_EraseRootFromParent_Done,
     /* 1538675 */   // Label 21360: @1538675
     /* 1538675 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1538757), // Rule ID 18708 //
     /* 1538680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1538697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538719 */     // MIs[0] round
     /* 1538719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538722 */     // MIs[0] policy
     /* 1538722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538732 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1538735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538756 */     // GIR_Coverage, 18708,
     /* 1538756 */     GIR_EraseRootFromParent_Done,
     /* 1538757 */   // Label 21361: @1538757
     /* 1538757 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1538839), // Rule ID 18709 //
     /* 1538762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1538765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1538779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538801 */     // MIs[0] round
     /* 1538801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538804 */     // MIs[0] policy
     /* 1538804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1538817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538838 */     // GIR_Coverage, 18709,
     /* 1538838 */     GIR_EraseRootFromParent_Done,
     /* 1538839 */   // Label 21362: @1538839
     /* 1538839 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1538921), // Rule ID 18712 //
     /* 1538844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1538861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538883 */     // MIs[0] round
     /* 1538883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538886 */     // MIs[0] policy
     /* 1538886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538896 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1538899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538920 */     // GIR_Coverage, 18712,
     /* 1538920 */     GIR_EraseRootFromParent_Done,
     /* 1538921 */   // Label 21363: @1538921
     /* 1538921 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1539003), // Rule ID 18713 //
     /* 1538926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1538929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1538934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1538943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538965 */     // MIs[0] round
     /* 1538965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538968 */     // MIs[0] policy
     /* 1538968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538978 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1538981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539002 */     // GIR_Coverage, 18713,
     /* 1539002 */     GIR_EraseRootFromParent_Done,
     /* 1539003 */   // Label 21364: @1539003
     /* 1539003 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1539085), // Rule ID 18716 //
     /* 1539008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1539011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1539025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539047 */     // MIs[0] round
     /* 1539047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539050 */     // MIs[0] policy
     /* 1539050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539060 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1539063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539084 */     // GIR_Coverage, 18716,
     /* 1539084 */     GIR_EraseRootFromParent_Done,
     /* 1539085 */   // Label 21365: @1539085
     /* 1539085 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1539167), // Rule ID 18717 //
     /* 1539090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1539093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1539107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539129 */     // MIs[0] round
     /* 1539129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539132 */     // MIs[0] policy
     /* 1539132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1539145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539166 */     // GIR_Coverage, 18717,
     /* 1539166 */     GIR_EraseRootFromParent_Done,
     /* 1539167 */   // Label 21366: @1539167
     /* 1539167 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1539249), // Rule ID 18720 //
     /* 1539172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1539175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1539189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539211 */     // MIs[0] round
     /* 1539211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539214 */     // MIs[0] policy
     /* 1539214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539224 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1539227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539248 */     // GIR_Coverage, 18720,
     /* 1539248 */     GIR_EraseRootFromParent_Done,
     /* 1539249 */   // Label 21367: @1539249
     /* 1539249 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1539331), // Rule ID 18721 //
     /* 1539254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1539257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1539271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539293 */     // MIs[0] round
     /* 1539293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539296 */     // MIs[0] policy
     /* 1539296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539306 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1539309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539330 */     // GIR_Coverage, 18721,
     /* 1539330 */     GIR_EraseRootFromParent_Done,
     /* 1539331 */   // Label 21368: @1539331
     /* 1539331 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1539413), // Rule ID 18724 //
     /* 1539336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1539353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539375 */     // MIs[0] round
     /* 1539375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539378 */     // MIs[0] policy
     /* 1539378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539388 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1539391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539412 */     // GIR_Coverage, 18724,
     /* 1539412 */     GIR_EraseRootFromParent_Done,
     /* 1539413 */   // Label 21369: @1539413
     /* 1539413 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1539495), // Rule ID 18725 //
     /* 1539418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1539435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539457 */     // MIs[0] round
     /* 1539457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539460 */     // MIs[0] policy
     /* 1539460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539470 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1539473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539494 */     // GIR_Coverage, 18725,
     /* 1539494 */     GIR_EraseRootFromParent_Done,
     /* 1539495 */   // Label 21370: @1539495
     /* 1539495 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1539577), // Rule ID 18728 //
     /* 1539500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1539517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539539 */     // MIs[0] round
     /* 1539539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539542 */     // MIs[0] policy
     /* 1539542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1539555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539576 */     // GIR_Coverage, 18728,
     /* 1539576 */     GIR_EraseRootFromParent_Done,
     /* 1539577 */   // Label 21371: @1539577
     /* 1539577 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1539659), // Rule ID 18729 //
     /* 1539582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1539599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539621 */     // MIs[0] round
     /* 1539621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539624 */     // MIs[0] policy
     /* 1539624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1539637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539658 */     // GIR_Coverage, 18729,
     /* 1539658 */     GIR_EraseRootFromParent_Done,
     /* 1539659 */   // Label 21372: @1539659
     /* 1539659 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1539741), // Rule ID 18732 //
     /* 1539664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1539681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539703 */     // MIs[0] round
     /* 1539703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539706 */     // MIs[0] policy
     /* 1539706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539716 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1539719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539740 */     // GIR_Coverage, 18732,
     /* 1539740 */     GIR_EraseRootFromParent_Done,
     /* 1539741 */   // Label 21373: @1539741
     /* 1539741 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1539823), // Rule ID 18733 //
     /* 1539746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1539763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539785 */     // MIs[0] round
     /* 1539785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539788 */     // MIs[0] policy
     /* 1539788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539798 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1539801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539822 */     // GIR_Coverage, 18733,
     /* 1539822 */     GIR_EraseRootFromParent_Done,
     /* 1539823 */   // Label 21374: @1539823
     /* 1539823 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1539905), // Rule ID 18736 //
     /* 1539828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1539845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539867 */     // MIs[0] round
     /* 1539867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539870 */     // MIs[0] policy
     /* 1539870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539880 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1539883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539904 */     // GIR_Coverage, 18736,
     /* 1539904 */     GIR_EraseRootFromParent_Done,
     /* 1539905 */   // Label 21375: @1539905
     /* 1539905 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1539987), // Rule ID 18737 //
     /* 1539910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1539918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1539927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539949 */     // MIs[0] round
     /* 1539949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539952 */     // MIs[0] policy
     /* 1539952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539962 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1539965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539986 */     // GIR_Coverage, 18737,
     /* 1539986 */     GIR_EraseRootFromParent_Done,
     /* 1539987 */   // Label 21376: @1539987
     /* 1539987 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1540069), // Rule ID 18740 //
     /* 1539992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1539995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540031 */     // MIs[0] round
     /* 1540031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540034 */     // MIs[0] policy
     /* 1540034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1540047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540068 */     // GIR_Coverage, 18740,
     /* 1540068 */     GIR_EraseRootFromParent_Done,
     /* 1540069 */   // Label 21377: @1540069
     /* 1540069 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1540151), // Rule ID 18741 //
     /* 1540074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540113 */     // MIs[0] round
     /* 1540113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540116 */     // MIs[0] policy
     /* 1540116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540126 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1540129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540150 */     // GIR_Coverage, 18741,
     /* 1540150 */     GIR_EraseRootFromParent_Done,
     /* 1540151 */   // Label 21378: @1540151
     /* 1540151 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1540233), // Rule ID 18744 //
     /* 1540156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540195 */     // MIs[0] round
     /* 1540195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540198 */     // MIs[0] policy
     /* 1540198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540208 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1540211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540232 */     // GIR_Coverage, 18744,
     /* 1540232 */     GIR_EraseRootFromParent_Done,
     /* 1540233 */   // Label 21379: @1540233
     /* 1540233 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1540315), // Rule ID 18745 //
     /* 1540238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540277 */     // MIs[0] round
     /* 1540277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540280 */     // MIs[0] policy
     /* 1540280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1540293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540314 */     // GIR_Coverage, 18745,
     /* 1540314 */     GIR_EraseRootFromParent_Done,
     /* 1540315 */   // Label 21380: @1540315
     /* 1540315 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1540397), // Rule ID 18748 //
     /* 1540320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540359 */     // MIs[0] round
     /* 1540359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540362 */     // MIs[0] policy
     /* 1540362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540372 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1540375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540396 */     // GIR_Coverage, 18748,
     /* 1540396 */     GIR_EraseRootFromParent_Done,
     /* 1540397 */   // Label 21381: @1540397
     /* 1540397 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1540479), // Rule ID 18749 //
     /* 1540402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540441 */     // MIs[0] round
     /* 1540441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540444 */     // MIs[0] policy
     /* 1540444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540454 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1540457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540478 */     // GIR_Coverage, 18749,
     /* 1540478 */     GIR_EraseRootFromParent_Done,
     /* 1540479 */   // Label 21382: @1540479
     /* 1540479 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1540561), // Rule ID 18752 //
     /* 1540484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540523 */     // MIs[0] round
     /* 1540523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540526 */     // MIs[0] policy
     /* 1540526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540536 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1540539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540560 */     // GIR_Coverage, 18752,
     /* 1540560 */     GIR_EraseRootFromParent_Done,
     /* 1540561 */   // Label 21383: @1540561
     /* 1540561 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1540643), // Rule ID 18753 //
     /* 1540566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540605 */     // MIs[0] round
     /* 1540605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540608 */     // MIs[0] policy
     /* 1540608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540618 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1540621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540642 */     // GIR_Coverage, 18753,
     /* 1540642 */     GIR_EraseRootFromParent_Done,
     /* 1540643 */   // Label 21384: @1540643
     /* 1540643 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1540725), // Rule ID 18756 //
     /* 1540648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540687 */     // MIs[0] round
     /* 1540687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540690 */     // MIs[0] policy
     /* 1540690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1540703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540724 */     // GIR_Coverage, 18756,
     /* 1540724 */     GIR_EraseRootFromParent_Done,
     /* 1540725 */   // Label 21385: @1540725
     /* 1540725 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1540807), // Rule ID 18757 //
     /* 1540730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1540747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1540765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540769 */     // MIs[0] round
     /* 1540769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540772 */     // MIs[0] policy
     /* 1540772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540782 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1540785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540806 */     // GIR_Coverage, 18757,
     /* 1540806 */     GIR_EraseRootFromParent_Done,
     /* 1540807 */   // Label 21386: @1540807
     /* 1540807 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1540889), // Rule ID 18760 //
     /* 1540812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1540815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540851 */     // MIs[0] round
     /* 1540851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540854 */     // MIs[0] policy
     /* 1540854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1540867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540888 */     // GIR_Coverage, 18760,
     /* 1540888 */     GIR_EraseRootFromParent_Done,
     /* 1540889 */   // Label 21387: @1540889
     /* 1540889 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1540971), // Rule ID 18761 //
     /* 1540894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1540897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540933 */     // MIs[0] round
     /* 1540933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540936 */     // MIs[0] policy
     /* 1540936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1540949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540970 */     // GIR_Coverage, 18761,
     /* 1540970 */     GIR_EraseRootFromParent_Done,
     /* 1540971 */   // Label 21388: @1540971
     /* 1540971 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1541053), // Rule ID 18764 //
     /* 1540976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1540979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1540996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541015 */     // MIs[0] round
     /* 1541015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541018 */     // MIs[0] policy
     /* 1541018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541028 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1541031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541052 */     // GIR_Coverage, 18764,
     /* 1541052 */     GIR_EraseRootFromParent_Done,
     /* 1541053 */   // Label 21389: @1541053
     /* 1541053 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1541135), // Rule ID 18765 //
     /* 1541058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1541075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541097 */     // MIs[0] round
     /* 1541097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541100 */     // MIs[0] policy
     /* 1541100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541110 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1541113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541134 */     // GIR_Coverage, 18765,
     /* 1541134 */     GIR_EraseRootFromParent_Done,
     /* 1541135 */   // Label 21390: @1541135
     /* 1541135 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1541217), // Rule ID 18768 //
     /* 1541140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1541157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541179 */     // MIs[0] round
     /* 1541179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541182 */     // MIs[0] policy
     /* 1541182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541192 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1541195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541216 */     // GIR_Coverage, 18768,
     /* 1541216 */     GIR_EraseRootFromParent_Done,
     /* 1541217 */   // Label 21391: @1541217
     /* 1541217 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1541299), // Rule ID 18769 //
     /* 1541222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1541239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541261 */     // MIs[0] round
     /* 1541261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541264 */     // MIs[0] policy
     /* 1541264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541274 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1541277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541298 */     // GIR_Coverage, 18769,
     /* 1541298 */     GIR_EraseRootFromParent_Done,
     /* 1541299 */   // Label 21392: @1541299
     /* 1541299 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1541381), // Rule ID 18772 //
     /* 1541304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1541321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541343 */     // MIs[0] round
     /* 1541343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541346 */     // MIs[0] policy
     /* 1541346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541356 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1541359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541380 */     // GIR_Coverage, 18772,
     /* 1541380 */     GIR_EraseRootFromParent_Done,
     /* 1541381 */   // Label 21393: @1541381
     /* 1541381 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1541463), // Rule ID 18773 //
     /* 1541386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1541403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1541421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541425 */     // MIs[0] round
     /* 1541425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541428 */     // MIs[0] policy
     /* 1541428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541438 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1541441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541462 */     // GIR_Coverage, 18773,
     /* 1541462 */     GIR_EraseRootFromParent_Done,
     /* 1541463 */   // Label 21394: @1541463
     /* 1541463 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1541545), // Rule ID 18776 //
     /* 1541468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541507 */     // MIs[0] round
     /* 1541507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541510 */     // MIs[0] policy
     /* 1541510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541520 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1541523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541544 */     // GIR_Coverage, 18776,
     /* 1541544 */     GIR_EraseRootFromParent_Done,
     /* 1541545 */   // Label 21395: @1541545
     /* 1541545 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1541627), // Rule ID 18777 //
     /* 1541550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1541567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541589 */     // MIs[0] round
     /* 1541589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541592 */     // MIs[0] policy
     /* 1541592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541602 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1541605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541626 */     // GIR_Coverage, 18777,
     /* 1541626 */     GIR_EraseRootFromParent_Done,
     /* 1541627 */   // Label 21396: @1541627
     /* 1541627 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1541709), // Rule ID 18780 //
     /* 1541632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541671 */     // MIs[0] round
     /* 1541671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541674 */     // MIs[0] policy
     /* 1541674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1541687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541708 */     // GIR_Coverage, 18780,
     /* 1541708 */     GIR_EraseRootFromParent_Done,
     /* 1541709 */   // Label 21397: @1541709
     /* 1541709 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1541791), // Rule ID 18781 //
     /* 1541714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541753 */     // MIs[0] round
     /* 1541753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541756 */     // MIs[0] policy
     /* 1541756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1541769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541790 */     // GIR_Coverage, 18781,
     /* 1541790 */     GIR_EraseRootFromParent_Done,
     /* 1541791 */   // Label 21398: @1541791
     /* 1541791 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1541873), // Rule ID 18784 //
     /* 1541796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541835 */     // MIs[0] round
     /* 1541835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541838 */     // MIs[0] policy
     /* 1541838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541848 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1541851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541872 */     // GIR_Coverage, 18784,
     /* 1541872 */     GIR_EraseRootFromParent_Done,
     /* 1541873 */   // Label 21399: @1541873
     /* 1541873 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1541955), // Rule ID 18785 //
     /* 1541878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541917 */     // MIs[0] round
     /* 1541917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541920 */     // MIs[0] policy
     /* 1541920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1541933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541954 */     // GIR_Coverage, 18785,
     /* 1541954 */     GIR_EraseRootFromParent_Done,
     /* 1541955 */   // Label 21400: @1541955
     /* 1541955 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1542037), // Rule ID 18788 //
     /* 1541960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1541968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541999 */     // MIs[0] round
     /* 1541999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542002 */     // MIs[0] policy
     /* 1542002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1542015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542036 */     // GIR_Coverage, 18788,
     /* 1542036 */     GIR_EraseRootFromParent_Done,
     /* 1542037 */   // Label 21401: @1542037
     /* 1542037 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1542119), // Rule ID 18789 //
     /* 1542042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1542059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542081 */     // MIs[0] round
     /* 1542081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542084 */     // MIs[0] policy
     /* 1542084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542094 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1542097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542118 */     // GIR_Coverage, 18789,
     /* 1542118 */     GIR_EraseRootFromParent_Done,
     /* 1542119 */   // Label 21402: @1542119
     /* 1542119 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1542201), // Rule ID 18792 //
     /* 1542124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1542141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542163 */     // MIs[0] round
     /* 1542163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542166 */     // MIs[0] policy
     /* 1542166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542176 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1542179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542200 */     // GIR_Coverage, 18792,
     /* 1542200 */     GIR_EraseRootFromParent_Done,
     /* 1542201 */   // Label 21403: @1542201
     /* 1542201 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1542283), // Rule ID 18793 //
     /* 1542206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1542223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542245 */     // MIs[0] round
     /* 1542245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542248 */     // MIs[0] policy
     /* 1542248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542258 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1542261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542282 */     // GIR_Coverage, 18793,
     /* 1542282 */     GIR_EraseRootFromParent_Done,
     /* 1542283 */   // Label 21404: @1542283
     /* 1542283 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1542365), // Rule ID 18796 //
     /* 1542288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542327 */     // MIs[0] round
     /* 1542327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542330 */     // MIs[0] policy
     /* 1542330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542340 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1542343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542364 */     // GIR_Coverage, 18796,
     /* 1542364 */     GIR_EraseRootFromParent_Done,
     /* 1542365 */   // Label 21405: @1542365
     /* 1542365 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1542447), // Rule ID 18797 //
     /* 1542370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1542387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542409 */     // MIs[0] round
     /* 1542409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542412 */     // MIs[0] policy
     /* 1542412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542422 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1542425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542446 */     // GIR_Coverage, 18797,
     /* 1542446 */     GIR_EraseRootFromParent_Done,
     /* 1542447 */   // Label 21406: @1542447
     /* 1542447 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1542529), // Rule ID 18800 //
     /* 1542452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542491 */     // MIs[0] round
     /* 1542491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542494 */     // MIs[0] policy
     /* 1542494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1542507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542528 */     // GIR_Coverage, 18800,
     /* 1542528 */     GIR_EraseRootFromParent_Done,
     /* 1542529 */   // Label 21407: @1542529
     /* 1542529 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1542611), // Rule ID 18801 //
     /* 1542534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1542551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542573 */     // MIs[0] round
     /* 1542573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542576 */     // MIs[0] policy
     /* 1542576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542586 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1542589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542610 */     // GIR_Coverage, 18801,
     /* 1542610 */     GIR_EraseRootFromParent_Done,
     /* 1542611 */   // Label 21408: @1542611
     /* 1542611 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1542693), // Rule ID 18804 //
     /* 1542616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542655 */     // MIs[0] round
     /* 1542655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542658 */     // MIs[0] policy
     /* 1542658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1542671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542692 */     // GIR_Coverage, 18804,
     /* 1542692 */     GIR_EraseRootFromParent_Done,
     /* 1542693 */   // Label 21409: @1542693
     /* 1542693 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1542775), // Rule ID 18805 //
     /* 1542698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1542715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542737 */     // MIs[0] round
     /* 1542737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542740 */     // MIs[0] policy
     /* 1542740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1542753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542774 */     // GIR_Coverage, 18805,
     /* 1542774 */     GIR_EraseRootFromParent_Done,
     /* 1542775 */   // Label 21410: @1542775
     /* 1542775 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1542857), // Rule ID 18808 //
     /* 1542780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542819 */     // MIs[0] round
     /* 1542819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542822 */     // MIs[0] policy
     /* 1542822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1542835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542856 */     // GIR_Coverage, 18808,
     /* 1542856 */     GIR_EraseRootFromParent_Done,
     /* 1542857 */   // Label 21411: @1542857
     /* 1542857 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1542939), // Rule ID 18809 //
     /* 1542862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542901 */     // MIs[0] round
     /* 1542901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542904 */     // MIs[0] policy
     /* 1542904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542914 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1542917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542938 */     // GIR_Coverage, 18809,
     /* 1542938 */     GIR_EraseRootFromParent_Done,
     /* 1542939 */   // Label 21412: @1542939
     /* 1542939 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1543021), // Rule ID 18812 //
     /* 1542944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1542952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542983 */     // MIs[0] round
     /* 1542983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542986 */     // MIs[0] policy
     /* 1542986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542996 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1542999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543020 */     // GIR_Coverage, 18812,
     /* 1543020 */     GIR_EraseRootFromParent_Done,
     /* 1543021 */   // Label 21413: @1543021
     /* 1543021 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1543103), // Rule ID 18813 //
     /* 1543026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543065 */     // MIs[0] round
     /* 1543065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543068 */     // MIs[0] policy
     /* 1543068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1543081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543102 */     // GIR_Coverage, 18813,
     /* 1543102 */     GIR_EraseRootFromParent_Done,
     /* 1543103 */   // Label 21414: @1543103
     /* 1543103 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1543185), // Rule ID 18816 //
     /* 1543108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543147 */     // MIs[0] round
     /* 1543147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543150 */     // MIs[0] policy
     /* 1543150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543160 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1543163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543184 */     // GIR_Coverage, 18816,
     /* 1543184 */     GIR_EraseRootFromParent_Done,
     /* 1543185 */   // Label 21415: @1543185
     /* 1543185 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1543267), // Rule ID 18817 //
     /* 1543190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543229 */     // MIs[0] round
     /* 1543229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543232 */     // MIs[0] policy
     /* 1543232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543242 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1543245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543266 */     // GIR_Coverage, 18817,
     /* 1543266 */     GIR_EraseRootFromParent_Done,
     /* 1543267 */   // Label 21416: @1543267
     /* 1543267 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1543349), // Rule ID 18820 //
     /* 1543272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543311 */     // MIs[0] round
     /* 1543311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543314 */     // MIs[0] policy
     /* 1543314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1543327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543348 */     // GIR_Coverage, 18820,
     /* 1543348 */     GIR_EraseRootFromParent_Done,
     /* 1543349 */   // Label 21417: @1543349
     /* 1543349 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1543431), // Rule ID 18821 //
     /* 1543354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543393 */     // MIs[0] round
     /* 1543393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543396 */     // MIs[0] policy
     /* 1543396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1543409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543430 */     // GIR_Coverage, 18821,
     /* 1543430 */     GIR_EraseRootFromParent_Done,
     /* 1543431 */   // Label 21418: @1543431
     /* 1543431 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1543513), // Rule ID 18824 //
     /* 1543436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543475 */     // MIs[0] round
     /* 1543475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543478 */     // MIs[0] policy
     /* 1543478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543488 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1543491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543512 */     // GIR_Coverage, 18824,
     /* 1543512 */     GIR_EraseRootFromParent_Done,
     /* 1543513 */   // Label 21419: @1543513
     /* 1543513 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1543595), // Rule ID 18825 //
     /* 1543518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543557 */     // MIs[0] round
     /* 1543557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543560 */     // MIs[0] policy
     /* 1543560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1543573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543594 */     // GIR_Coverage, 18825,
     /* 1543594 */     GIR_EraseRootFromParent_Done,
     /* 1543595 */   // Label 21420: @1543595
     /* 1543595 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1543677), // Rule ID 18828 //
     /* 1543600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543639 */     // MIs[0] round
     /* 1543639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543642 */     // MIs[0] policy
     /* 1543642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543652 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1543655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543676 */     // GIR_Coverage, 18828,
     /* 1543676 */     GIR_EraseRootFromParent_Done,
     /* 1543677 */   // Label 21421: @1543677
     /* 1543677 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1543759), // Rule ID 18829 //
     /* 1543682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1543699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1543717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543721 */     // MIs[0] round
     /* 1543721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543724 */     // MIs[0] policy
     /* 1543724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1543737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543758 */     // GIR_Coverage, 18829,
     /* 1543758 */     GIR_EraseRootFromParent_Done,
     /* 1543759 */   // Label 21422: @1543759
     /* 1543759 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1543841), // Rule ID 18832 //
     /* 1543764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543803 */     // MIs[0] round
     /* 1543803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543806 */     // MIs[0] policy
     /* 1543806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1543819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543840 */     // GIR_Coverage, 18832,
     /* 1543840 */     GIR_EraseRootFromParent_Done,
     /* 1543841 */   // Label 21423: @1543841
     /* 1543841 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1543923), // Rule ID 18833 //
     /* 1543846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543885 */     // MIs[0] round
     /* 1543885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543888 */     // MIs[0] policy
     /* 1543888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1543901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543922 */     // GIR_Coverage, 18833,
     /* 1543922 */     GIR_EraseRootFromParent_Done,
     /* 1543923 */   // Label 21424: @1543923
     /* 1543923 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1544005), // Rule ID 18836 //
     /* 1543928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543967 */     // MIs[0] round
     /* 1543967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543970 */     // MIs[0] policy
     /* 1543970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543980 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1543983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544004 */     // GIR_Coverage, 18836,
     /* 1544004 */     GIR_EraseRootFromParent_Done,
     /* 1544005 */   // Label 21425: @1544005
     /* 1544005 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1544087), // Rule ID 18837 //
     /* 1544010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544049 */     // MIs[0] round
     /* 1544049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544052 */     // MIs[0] policy
     /* 1544052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1544065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544086 */     // GIR_Coverage, 18837,
     /* 1544086 */     GIR_EraseRootFromParent_Done,
     /* 1544087 */   // Label 21426: @1544087
     /* 1544087 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1544169), // Rule ID 18840 //
     /* 1544092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544131 */     // MIs[0] round
     /* 1544131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544134 */     // MIs[0] policy
     /* 1544134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1544147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544168 */     // GIR_Coverage, 18840,
     /* 1544168 */     GIR_EraseRootFromParent_Done,
     /* 1544169 */   // Label 21427: @1544169
     /* 1544169 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1544251), // Rule ID 18841 //
     /* 1544174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544213 */     // MIs[0] round
     /* 1544213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544216 */     // MIs[0] policy
     /* 1544216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544226 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1544229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544250 */     // GIR_Coverage, 18841,
     /* 1544250 */     GIR_EraseRootFromParent_Done,
     /* 1544251 */   // Label 21428: @1544251
     /* 1544251 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1544333), // Rule ID 18844 //
     /* 1544256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544295 */     // MIs[0] round
     /* 1544295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544298 */     // MIs[0] policy
     /* 1544298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544308 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1544311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544332 */     // GIR_Coverage, 18844,
     /* 1544332 */     GIR_EraseRootFromParent_Done,
     /* 1544333 */   // Label 21429: @1544333
     /* 1544333 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1544415), // Rule ID 18845 //
     /* 1544338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1544355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1544373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544377 */     // MIs[0] round
     /* 1544377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544380 */     // MIs[0] policy
     /* 1544380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544390 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1544393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544414 */     // GIR_Coverage, 18845,
     /* 1544414 */     GIR_EraseRootFromParent_Done,
     /* 1544415 */   // Label 21430: @1544415
     /* 1544415 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1544497), // Rule ID 18848 //
     /* 1544420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544459 */     // MIs[0] round
     /* 1544459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544462 */     // MIs[0] policy
     /* 1544462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544472 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1544475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544496 */     // GIR_Coverage, 18848,
     /* 1544496 */     GIR_EraseRootFromParent_Done,
     /* 1544497 */   // Label 21431: @1544497
     /* 1544497 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1544579), // Rule ID 18849 //
     /* 1544502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1544519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544541 */     // MIs[0] round
     /* 1544541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544544 */     // MIs[0] policy
     /* 1544544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544554 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1544557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544578 */     // GIR_Coverage, 18849,
     /* 1544578 */     GIR_EraseRootFromParent_Done,
     /* 1544579 */   // Label 21432: @1544579
     /* 1544579 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1544661), // Rule ID 18852 //
     /* 1544584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544623 */     // MIs[0] round
     /* 1544623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544626 */     // MIs[0] policy
     /* 1544626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544636 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1544639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544660 */     // GIR_Coverage, 18852,
     /* 1544660 */     GIR_EraseRootFromParent_Done,
     /* 1544661 */   // Label 21433: @1544661
     /* 1544661 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1544743), // Rule ID 18853 //
     /* 1544666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1544683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544705 */     // MIs[0] round
     /* 1544705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544708 */     // MIs[0] policy
     /* 1544708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544718 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1544721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544742 */     // GIR_Coverage, 18853,
     /* 1544742 */     GIR_EraseRootFromParent_Done,
     /* 1544743 */   // Label 21434: @1544743
     /* 1544743 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1544825), // Rule ID 18856 //
     /* 1544748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544787 */     // MIs[0] round
     /* 1544787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544790 */     // MIs[0] policy
     /* 1544790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544800 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1544803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544824 */     // GIR_Coverage, 18856,
     /* 1544824 */     GIR_EraseRootFromParent_Done,
     /* 1544825 */   // Label 21435: @1544825
     /* 1544825 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1544907), // Rule ID 18857 //
     /* 1544830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544869 */     // MIs[0] round
     /* 1544869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544872 */     // MIs[0] policy
     /* 1544872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1544885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544906 */     // GIR_Coverage, 18857,
     /* 1544906 */     GIR_EraseRootFromParent_Done,
     /* 1544907 */   // Label 21436: @1544907
     /* 1544907 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1544989), // Rule ID 18860 //
     /* 1544912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1544920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544951 */     // MIs[0] round
     /* 1544951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544954 */     // MIs[0] policy
     /* 1544954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544964 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1544967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544988 */     // GIR_Coverage, 18860,
     /* 1544988 */     GIR_EraseRootFromParent_Done,
     /* 1544989 */   // Label 21437: @1544989
     /* 1544989 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1545071), // Rule ID 18861 //
     /* 1544994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1545011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545033 */     // MIs[0] round
     /* 1545033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545036 */     // MIs[0] policy
     /* 1545036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545046 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1545049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545070 */     // GIR_Coverage, 18861,
     /* 1545070 */     GIR_EraseRootFromParent_Done,
     /* 1545071 */   // Label 21438: @1545071
     /* 1545071 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1545153), // Rule ID 18864 //
     /* 1545076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545115 */     // MIs[0] round
     /* 1545115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545118 */     // MIs[0] policy
     /* 1545118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545128 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1545131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545152 */     // GIR_Coverage, 18864,
     /* 1545152 */     GIR_EraseRootFromParent_Done,
     /* 1545153 */   // Label 21439: @1545153
     /* 1545153 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1545235), // Rule ID 18865 //
     /* 1545158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1545175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545197 */     // MIs[0] round
     /* 1545197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545200 */     // MIs[0] policy
     /* 1545200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545210 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1545213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545234 */     // GIR_Coverage, 18865,
     /* 1545234 */     GIR_EraseRootFromParent_Done,
     /* 1545235 */   // Label 21440: @1545235
     /* 1545235 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1545317), // Rule ID 18868 //
     /* 1545240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545279 */     // MIs[0] round
     /* 1545279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545282 */     // MIs[0] policy
     /* 1545282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545292 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1545295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545316 */     // GIR_Coverage, 18868,
     /* 1545316 */     GIR_EraseRootFromParent_Done,
     /* 1545317 */   // Label 21441: @1545317
     /* 1545317 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1545399), // Rule ID 18869 //
     /* 1545322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1545339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545361 */     // MIs[0] round
     /* 1545361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545364 */     // MIs[0] policy
     /* 1545364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1545377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545398 */     // GIR_Coverage, 18869,
     /* 1545398 */     GIR_EraseRootFromParent_Done,
     /* 1545399 */   // Label 21442: @1545399
     /* 1545399 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1545481), // Rule ID 18872 //
     /* 1545404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545443 */     // MIs[0] round
     /* 1545443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545446 */     // MIs[0] policy
     /* 1545446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545456 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1545459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545480 */     // GIR_Coverage, 18872,
     /* 1545480 */     GIR_EraseRootFromParent_Done,
     /* 1545481 */   // Label 21443: @1545481
     /* 1545481 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1545563), // Rule ID 18873 //
     /* 1545486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1545503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545525 */     // MIs[0] round
     /* 1545525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545528 */     // MIs[0] policy
     /* 1545528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545538 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1545541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545562 */     // GIR_Coverage, 18873,
     /* 1545562 */     GIR_EraseRootFromParent_Done,
     /* 1545563 */   // Label 21444: @1545563
     /* 1545563 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1545645), // Rule ID 18876 //
     /* 1545568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545607 */     // MIs[0] round
     /* 1545607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545610 */     // MIs[0] policy
     /* 1545610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545620 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1545623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545644 */     // GIR_Coverage, 18876,
     /* 1545644 */     GIR_EraseRootFromParent_Done,
     /* 1545645 */   // Label 21445: @1545645
     /* 1545645 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1545727), // Rule ID 18877 //
     /* 1545650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1545667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545689 */     // MIs[0] round
     /* 1545689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545692 */     // MIs[0] policy
     /* 1545692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1545705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545726 */     // GIR_Coverage, 18877,
     /* 1545726 */     GIR_EraseRootFromParent_Done,
     /* 1545727 */   // Label 21446: @1545727
     /* 1545727 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1545809), // Rule ID 18880 //
     /* 1545732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545771 */     // MIs[0] round
     /* 1545771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545774 */     // MIs[0] policy
     /* 1545774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1545787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545808 */     // GIR_Coverage, 18880,
     /* 1545808 */     GIR_EraseRootFromParent_Done,
     /* 1545809 */   // Label 21447: @1545809
     /* 1545809 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1545891), // Rule ID 18881 //
     /* 1545814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545853 */     // MIs[0] round
     /* 1545853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545856 */     // MIs[0] policy
     /* 1545856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545866 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1545869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545890 */     // GIR_Coverage, 18881,
     /* 1545890 */     GIR_EraseRootFromParent_Done,
     /* 1545891 */   // Label 21448: @1545891
     /* 1545891 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1545973), // Rule ID 18884 //
     /* 1545896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545935 */     // MIs[0] round
     /* 1545935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545938 */     // MIs[0] policy
     /* 1545938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545948 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1545951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545972 */     // GIR_Coverage, 18884,
     /* 1545972 */     GIR_EraseRootFromParent_Done,
     /* 1545973 */   // Label 21449: @1545973
     /* 1545973 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1546055), // Rule ID 18885 //
     /* 1545978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1545986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546017 */     // MIs[0] round
     /* 1546017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546020 */     // MIs[0] policy
     /* 1546020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546030 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1546033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546054 */     // GIR_Coverage, 18885,
     /* 1546054 */     GIR_EraseRootFromParent_Done,
     /* 1546055 */   // Label 21450: @1546055
     /* 1546055 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1546137), // Rule ID 18888 //
     /* 1546060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546099 */     // MIs[0] round
     /* 1546099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546102 */     // MIs[0] policy
     /* 1546102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1546115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546136 */     // GIR_Coverage, 18888,
     /* 1546136 */     GIR_EraseRootFromParent_Done,
     /* 1546137 */   // Label 21451: @1546137
     /* 1546137 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1546219), // Rule ID 18889 //
     /* 1546142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546181 */     // MIs[0] round
     /* 1546181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546184 */     // MIs[0] policy
     /* 1546184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546194 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1546197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546218 */     // GIR_Coverage, 18889,
     /* 1546218 */     GIR_EraseRootFromParent_Done,
     /* 1546219 */   // Label 21452: @1546219
     /* 1546219 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1546301), // Rule ID 18892 //
     /* 1546224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546263 */     // MIs[0] round
     /* 1546263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546266 */     // MIs[0] policy
     /* 1546266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546276 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1546279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546300 */     // GIR_Coverage, 18892,
     /* 1546300 */     GIR_EraseRootFromParent_Done,
     /* 1546301 */   // Label 21453: @1546301
     /* 1546301 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1546383), // Rule ID 18893 //
     /* 1546306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1546326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546345 */     // MIs[0] round
     /* 1546345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546348 */     // MIs[0] policy
     /* 1546348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1546361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546382 */     // GIR_Coverage, 18893,
     /* 1546382 */     GIR_EraseRootFromParent_Done,
     /* 1546383 */   // Label 21454: @1546383
     /* 1546383 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1546465), // Rule ID 18896 //
     /* 1546388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546427 */     // MIs[0] round
     /* 1546427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546430 */     // MIs[0] policy
     /* 1546430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546440 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1546443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546464 */     // GIR_Coverage, 18896,
     /* 1546464 */     GIR_EraseRootFromParent_Done,
     /* 1546465 */   // Label 21455: @1546465
     /* 1546465 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1546547), // Rule ID 18897 //
     /* 1546470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1546481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1546484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1546490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546509 */     // MIs[0] round
     /* 1546509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546512 */     // MIs[0] policy
     /* 1546512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1546525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546546 */     // GIR_Coverage, 18897,
     /* 1546546 */     GIR_EraseRootFromParent_Done,
     /* 1546547 */   // Label 21456: @1546547
     /* 1546547 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1546629), // Rule ID 18900 //
     /* 1546552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546591 */     // MIs[0] round
     /* 1546591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546594 */     // MIs[0] policy
     /* 1546594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546604 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1546607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546628 */     // GIR_Coverage, 18900,
     /* 1546628 */     GIR_EraseRootFromParent_Done,
     /* 1546629 */   // Label 21457: @1546629
     /* 1546629 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1546711), // Rule ID 18901 //
     /* 1546634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1546645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1546648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1546651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1546654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1546669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546673 */     // MIs[0] round
     /* 1546673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546676 */     // MIs[0] policy
     /* 1546676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546686 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1546689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546710 */     // GIR_Coverage, 18901,
     /* 1546710 */     GIR_EraseRootFromParent_Done,
     /* 1546711 */   // Label 21458: @1546711
     /* 1546711 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1546793), // Rule ID 18904 //
     /* 1546716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546755 */     // MIs[0] round
     /* 1546755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546758 */     // MIs[0] policy
     /* 1546758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546768 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1546771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546792 */     // GIR_Coverage, 18904,
     /* 1546792 */     GIR_EraseRootFromParent_Done,
     /* 1546793 */   // Label 21459: @1546793
     /* 1546793 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1546875), // Rule ID 18905 //
     /* 1546798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546837 */     // MIs[0] round
     /* 1546837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546840 */     // MIs[0] policy
     /* 1546840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546850 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1546853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546874 */     // GIR_Coverage, 18905,
     /* 1546874 */     GIR_EraseRootFromParent_Done,
     /* 1546875 */   // Label 21460: @1546875
     /* 1546875 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1546957), // Rule ID 18908 //
     /* 1546880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546919 */     // MIs[0] round
     /* 1546919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546922 */     // MIs[0] policy
     /* 1546922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546932 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1546935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546956 */     // GIR_Coverage, 18908,
     /* 1546956 */     GIR_EraseRootFromParent_Done,
     /* 1546957 */   // Label 21461: @1546957
     /* 1546957 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1547039), // Rule ID 18909 //
     /* 1546962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547001 */     // MIs[0] round
     /* 1547001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547004 */     // MIs[0] policy
     /* 1547004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1547017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547038 */     // GIR_Coverage, 18909,
     /* 1547038 */     GIR_EraseRootFromParent_Done,
     /* 1547039 */   // Label 21462: @1547039
     /* 1547039 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1547121), // Rule ID 18912 //
     /* 1547044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547083 */     // MIs[0] round
     /* 1547083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547086 */     // MIs[0] policy
     /* 1547086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547096 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1547099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547120 */     // GIR_Coverage, 18912,
     /* 1547120 */     GIR_EraseRootFromParent_Done,
     /* 1547121 */   // Label 21463: @1547121
     /* 1547121 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1547203), // Rule ID 18913 //
     /* 1547126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547165 */     // MIs[0] round
     /* 1547165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547168 */     // MIs[0] policy
     /* 1547168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547178 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1547181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547202 */     // GIR_Coverage, 18913,
     /* 1547202 */     GIR_EraseRootFromParent_Done,
     /* 1547203 */   // Label 21464: @1547203
     /* 1547203 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1547285), // Rule ID 18916 //
     /* 1547208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547247 */     // MIs[0] round
     /* 1547247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547250 */     // MIs[0] policy
     /* 1547250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547260 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1547263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547284 */     // GIR_Coverage, 18916,
     /* 1547284 */     GIR_EraseRootFromParent_Done,
     /* 1547285 */   // Label 21465: @1547285
     /* 1547285 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1547367), // Rule ID 18917 //
     /* 1547290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1547307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1547325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547329 */     // MIs[0] round
     /* 1547329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547332 */     // MIs[0] policy
     /* 1547332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1547345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547366 */     // GIR_Coverage, 18917,
     /* 1547366 */     GIR_EraseRootFromParent_Done,
     /* 1547367 */   // Label 21466: @1547367
     /* 1547367 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1547449), // Rule ID 18920 //
     /* 1547372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547411 */     // MIs[0] round
     /* 1547411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547414 */     // MIs[0] policy
     /* 1547414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1547427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547448 */     // GIR_Coverage, 18920,
     /* 1547448 */     GIR_EraseRootFromParent_Done,
     /* 1547449 */   // Label 21467: @1547449
     /* 1547449 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1547531), // Rule ID 18921 //
     /* 1547454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1547465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1547468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1547471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1547474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547493 */     // MIs[0] round
     /* 1547493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547496 */     // MIs[0] policy
     /* 1547496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547506 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1547509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547530 */     // GIR_Coverage, 18921,
     /* 1547530 */     GIR_EraseRootFromParent_Done,
     /* 1547531 */   // Label 21468: @1547531
     /* 1547531 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1547613), // Rule ID 18924 //
     /* 1547536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547575 */     // MIs[0] round
     /* 1547575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547578 */     // MIs[0] policy
     /* 1547578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547588 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1547591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547612 */     // GIR_Coverage, 18924,
     /* 1547612 */     GIR_EraseRootFromParent_Done,
     /* 1547613 */   // Label 21469: @1547613
     /* 1547613 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1547695), // Rule ID 18925 //
     /* 1547618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1547629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1547632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1547635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1547638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547657 */     // MIs[0] round
     /* 1547657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547660 */     // MIs[0] policy
     /* 1547660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547670 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1547673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547694 */     // GIR_Coverage, 18925,
     /* 1547694 */     GIR_EraseRootFromParent_Done,
     /* 1547695 */   // Label 21470: @1547695
     /* 1547695 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1547777), // Rule ID 18928 //
     /* 1547700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547739 */     // MIs[0] round
     /* 1547739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547742 */     // MIs[0] policy
     /* 1547742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1547755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547776 */     // GIR_Coverage, 18928,
     /* 1547776 */     GIR_EraseRootFromParent_Done,
     /* 1547777 */   // Label 21471: @1547777
     /* 1547777 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1547859), // Rule ID 18929 //
     /* 1547782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547821 */     // MIs[0] round
     /* 1547821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547824 */     // MIs[0] policy
     /* 1547824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547834 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1547837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547858 */     // GIR_Coverage, 18929,
     /* 1547858 */     GIR_EraseRootFromParent_Done,
     /* 1547859 */   // Label 21472: @1547859
     /* 1547859 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1547941), // Rule ID 18932 //
     /* 1547864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547903 */     // MIs[0] round
     /* 1547903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547906 */     // MIs[0] policy
     /* 1547906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1547919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547940 */     // GIR_Coverage, 18932,
     /* 1547940 */     GIR_EraseRootFromParent_Done,
     /* 1547941 */   // Label 21473: @1547941
     /* 1547941 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1548023), // Rule ID 18933 //
     /* 1547946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1547954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547985 */     // MIs[0] round
     /* 1547985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547988 */     // MIs[0] policy
     /* 1547988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547998 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1548001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548022 */     // GIR_Coverage, 18933,
     /* 1548022 */     GIR_EraseRootFromParent_Done,
     /* 1548023 */   // Label 21474: @1548023
     /* 1548023 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1548105), // Rule ID 18936 //
     /* 1548028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548067 */     // MIs[0] round
     /* 1548067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548070 */     // MIs[0] policy
     /* 1548070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548080 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1548083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548104 */     // GIR_Coverage, 18936,
     /* 1548104 */     GIR_EraseRootFromParent_Done,
     /* 1548105 */   // Label 21475: @1548105
     /* 1548105 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1548187), // Rule ID 18937 //
     /* 1548110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1548127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548149 */     // MIs[0] round
     /* 1548149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548152 */     // MIs[0] policy
     /* 1548152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548162 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1548165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548186 */     // GIR_Coverage, 18937,
     /* 1548186 */     GIR_EraseRootFromParent_Done,
     /* 1548187 */   // Label 21476: @1548187
     /* 1548187 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1548269), // Rule ID 18940 //
     /* 1548192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548231 */     // MIs[0] round
     /* 1548231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548234 */     // MIs[0] policy
     /* 1548234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1548247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548268 */     // GIR_Coverage, 18940,
     /* 1548268 */     GIR_EraseRootFromParent_Done,
     /* 1548269 */   // Label 21477: @1548269
     /* 1548269 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1548351), // Rule ID 18941 //
     /* 1548274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548313 */     // MIs[0] round
     /* 1548313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548316 */     // MIs[0] policy
     /* 1548316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548326 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1548329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548350 */     // GIR_Coverage, 18941,
     /* 1548350 */     GIR_EraseRootFromParent_Done,
     /* 1548351 */   // Label 21478: @1548351
     /* 1548351 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1548433), // Rule ID 18944 //
     /* 1548356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548395 */     // MIs[0] round
     /* 1548395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548398 */     // MIs[0] policy
     /* 1548398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548408 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1548411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548432 */     // GIR_Coverage, 18944,
     /* 1548432 */     GIR_EraseRootFromParent_Done,
     /* 1548433 */   // Label 21479: @1548433
     /* 1548433 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1548515), // Rule ID 18945 //
     /* 1548438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1548449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1548452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1548458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548477 */     // MIs[0] round
     /* 1548477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548480 */     // MIs[0] policy
     /* 1548480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548490 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1548493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548514 */     // GIR_Coverage, 18945,
     /* 1548514 */     GIR_EraseRootFromParent_Done,
     /* 1548515 */   // Label 21480: @1548515
     /* 1548515 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1548597), // Rule ID 18948 //
     /* 1548520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548559 */     // MIs[0] round
     /* 1548559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548562 */     // MIs[0] policy
     /* 1548562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548572 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1548575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548596 */     // GIR_Coverage, 18948,
     /* 1548596 */     GIR_EraseRootFromParent_Done,
     /* 1548597 */   // Label 21481: @1548597
     /* 1548597 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1548679), // Rule ID 18949 //
     /* 1548602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1548619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1548622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548641 */     // MIs[0] round
     /* 1548641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548644 */     // MIs[0] policy
     /* 1548644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548654 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1548657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548678 */     // GIR_Coverage, 18949,
     /* 1548678 */     GIR_EraseRootFromParent_Done,
     /* 1548679 */   // Label 21482: @1548679
     /* 1548679 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1548761), // Rule ID 18952 //
     /* 1548684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548723 */     // MIs[0] round
     /* 1548723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548726 */     // MIs[0] policy
     /* 1548726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548736 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1548739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548760 */     // GIR_Coverage, 18952,
     /* 1548760 */     GIR_EraseRootFromParent_Done,
     /* 1548761 */   // Label 21483: @1548761
     /* 1548761 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1548843), // Rule ID 18953 //
     /* 1548766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548805 */     // MIs[0] round
     /* 1548805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548808 */     // MIs[0] policy
     /* 1548808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548818 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1548821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548842 */     // GIR_Coverage, 18953,
     /* 1548842 */     GIR_EraseRootFromParent_Done,
     /* 1548843 */   // Label 21484: @1548843
     /* 1548843 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1548925), // Rule ID 18956 //
     /* 1548848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548887 */     // MIs[0] round
     /* 1548887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548890 */     // MIs[0] policy
     /* 1548890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548900 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1548903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548924 */     // GIR_Coverage, 18956,
     /* 1548924 */     GIR_EraseRootFromParent_Done,
     /* 1548925 */   // Label 21485: @1548925
     /* 1548925 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1549007), // Rule ID 18957 //
     /* 1548930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1548938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548969 */     // MIs[0] round
     /* 1548969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548972 */     // MIs[0] policy
     /* 1548972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548982 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1548985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549006 */     // GIR_Coverage, 18957,
     /* 1549006 */     GIR_EraseRootFromParent_Done,
     /* 1549007 */   // Label 21486: @1549007
     /* 1549007 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1549089), // Rule ID 18960 //
     /* 1549012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549051 */     // MIs[0] round
     /* 1549051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549054 */     // MIs[0] policy
     /* 1549054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1549067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549088 */     // GIR_Coverage, 18960,
     /* 1549088 */     GIR_EraseRootFromParent_Done,
     /* 1549089 */   // Label 21487: @1549089
     /* 1549089 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1549171), // Rule ID 18961 //
     /* 1549094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549133 */     // MIs[0] round
     /* 1549133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549136 */     // MIs[0] policy
     /* 1549136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549146 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1549149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549170 */     // GIR_Coverage, 18961,
     /* 1549170 */     GIR_EraseRootFromParent_Done,
     /* 1549171 */   // Label 21488: @1549171
     /* 1549171 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1549253), // Rule ID 18964 //
     /* 1549176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549215 */     // MIs[0] round
     /* 1549215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549218 */     // MIs[0] policy
     /* 1549218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1549231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549252 */     // GIR_Coverage, 18964,
     /* 1549252 */     GIR_EraseRootFromParent_Done,
     /* 1549253 */   // Label 21489: @1549253
     /* 1549253 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1549335), // Rule ID 18965 //
     /* 1549258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549297 */     // MIs[0] round
     /* 1549297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549300 */     // MIs[0] policy
     /* 1549300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1549313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549334 */     // GIR_Coverage, 18965,
     /* 1549334 */     GIR_EraseRootFromParent_Done,
     /* 1549335 */   // Label 21490: @1549335
     /* 1549335 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1549417), // Rule ID 18968 //
     /* 1549340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549379 */     // MIs[0] round
     /* 1549379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549382 */     // MIs[0] policy
     /* 1549382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549392 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1549395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549416 */     // GIR_Coverage, 18968,
     /* 1549416 */     GIR_EraseRootFromParent_Done,
     /* 1549417 */   // Label 21491: @1549417
     /* 1549417 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1549499), // Rule ID 18969 //
     /* 1549422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1549442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549461 */     // MIs[0] round
     /* 1549461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549464 */     // MIs[0] policy
     /* 1549464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549474 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1549477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549498 */     // GIR_Coverage, 18969,
     /* 1549498 */     GIR_EraseRootFromParent_Done,
     /* 1549499 */   // Label 21492: @1549499
     /* 1549499 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1549581), // Rule ID 18972 //
     /* 1549504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549543 */     // MIs[0] round
     /* 1549543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549546 */     // MIs[0] policy
     /* 1549546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549556 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1549559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549580 */     // GIR_Coverage, 18972,
     /* 1549580 */     GIR_EraseRootFromParent_Done,
     /* 1549581 */   // Label 21493: @1549581
     /* 1549581 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1549663), // Rule ID 18973 //
     /* 1549586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1549597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1549600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1549603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1549606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1549621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549625 */     // MIs[0] round
     /* 1549625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549628 */     // MIs[0] policy
     /* 1549628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549638 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1549641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549662 */     // GIR_Coverage, 18973,
     /* 1549662 */     GIR_EraseRootFromParent_Done,
     /* 1549663 */   // Label 21494: @1549663
     /* 1549663 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1549745), // Rule ID 18976 //
     /* 1549668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549707 */     // MIs[0] round
     /* 1549707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549710 */     // MIs[0] policy
     /* 1549710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549720 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1549723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549744 */     // GIR_Coverage, 18976,
     /* 1549744 */     GIR_EraseRootFromParent_Done,
     /* 1549745 */   // Label 21495: @1549745
     /* 1549745 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1549827), // Rule ID 18977 //
     /* 1549750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549789 */     // MIs[0] round
     /* 1549789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549792 */     // MIs[0] policy
     /* 1549792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1549805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549826 */     // GIR_Coverage, 18977,
     /* 1549826 */     GIR_EraseRootFromParent_Done,
     /* 1549827 */   // Label 21496: @1549827
     /* 1549827 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1549909), // Rule ID 18980 //
     /* 1549832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549871 */     // MIs[0] round
     /* 1549871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549874 */     // MIs[0] policy
     /* 1549874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1549887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549908 */     // GIR_Coverage, 18980,
     /* 1549908 */     GIR_EraseRootFromParent_Done,
     /* 1549909 */   // Label 21497: @1549909
     /* 1549909 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1549991), // Rule ID 18981 //
     /* 1549914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549953 */     // MIs[0] round
     /* 1549953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549956 */     // MIs[0] policy
     /* 1549956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549966 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1549969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549990 */     // GIR_Coverage, 18981,
     /* 1549990 */     GIR_EraseRootFromParent_Done,
     /* 1549991 */   // Label 21498: @1549991
     /* 1549991 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1550073), // Rule ID 18984 //
     /* 1549996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550035 */     // MIs[0] round
     /* 1550035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550038 */     // MIs[0] policy
     /* 1550038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1550051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550072 */     // GIR_Coverage, 18984,
     /* 1550072 */     GIR_EraseRootFromParent_Done,
     /* 1550073 */   // Label 21499: @1550073
     /* 1550073 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1550155), // Rule ID 18985 //
     /* 1550078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550117 */     // MIs[0] round
     /* 1550117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550120 */     // MIs[0] policy
     /* 1550120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1550133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550154 */     // GIR_Coverage, 18985,
     /* 1550154 */     GIR_EraseRootFromParent_Done,
     /* 1550155 */   // Label 21500: @1550155
     /* 1550155 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1550237), // Rule ID 18988 //
     /* 1550160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550199 */     // MIs[0] round
     /* 1550199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550202 */     // MIs[0] policy
     /* 1550202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550212 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1550215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550236 */     // GIR_Coverage, 18988,
     /* 1550236 */     GIR_EraseRootFromParent_Done,
     /* 1550237 */   // Label 21501: @1550237
     /* 1550237 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1550319), // Rule ID 18989 //
     /* 1550242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1550259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1550277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550281 */     // MIs[0] round
     /* 1550281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550284 */     // MIs[0] policy
     /* 1550284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1550297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550318 */     // GIR_Coverage, 18989,
     /* 1550318 */     GIR_EraseRootFromParent_Done,
     /* 1550319 */   // Label 21502: @1550319
     /* 1550319 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1550401), // Rule ID 18994 //
     /* 1550324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1550327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550363 */     // MIs[0] round
     /* 1550363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550366 */     // MIs[0] policy
     /* 1550366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550376 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1550379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550400 */     // GIR_Coverage, 18994,
     /* 1550400 */     GIR_EraseRootFromParent_Done,
     /* 1550401 */   // Label 21503: @1550401
     /* 1550401 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1550483), // Rule ID 18995 //
     /* 1550406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1550409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550445 */     // MIs[0] round
     /* 1550445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550448 */     // MIs[0] policy
     /* 1550448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1550461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550482 */     // GIR_Coverage, 18995,
     /* 1550482 */     GIR_EraseRootFromParent_Done,
     /* 1550483 */   // Label 21504: @1550483
     /* 1550483 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1550565), // Rule ID 18998 //
     /* 1550488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1550491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1550508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550527 */     // MIs[0] round
     /* 1550527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550530 */     // MIs[0] policy
     /* 1550530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550540 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1550543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550564 */     // GIR_Coverage, 18998,
     /* 1550564 */     GIR_EraseRootFromParent_Done,
     /* 1550565 */   // Label 21505: @1550565
     /* 1550565 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1550647), // Rule ID 18999 //
     /* 1550570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1550573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1550590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550609 */     // MIs[0] round
     /* 1550609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550612 */     // MIs[0] policy
     /* 1550612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1550625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550646 */     // GIR_Coverage, 18999,
     /* 1550646 */     GIR_EraseRootFromParent_Done,
     /* 1550647 */   // Label 21506: @1550647
     /* 1550647 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1550729), // Rule ID 19002 //
     /* 1550652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1550655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1550663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1550666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1550672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550691 */     // MIs[0] round
     /* 1550691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550694 */     // MIs[0] policy
     /* 1550694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550704 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1550707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550728 */     // GIR_Coverage, 19002,
     /* 1550728 */     GIR_EraseRootFromParent_Done,
     /* 1550729 */   // Label 21507: @1550729
     /* 1550729 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1550811), // Rule ID 19003 //
     /* 1550734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1550737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1550745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1550748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1550754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550773 */     // MIs[0] round
     /* 1550773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550776 */     // MIs[0] policy
     /* 1550776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550786 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1550789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550810 */     // GIR_Coverage, 19003,
     /* 1550810 */     GIR_EraseRootFromParent_Done,
     /* 1550811 */   // Label 21508: @1550811
     /* 1550811 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1550893), // Rule ID 19006 //
     /* 1550816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1550819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550855 */     // MIs[0] round
     /* 1550855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550858 */     // MIs[0] policy
     /* 1550858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1550871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550892 */     // GIR_Coverage, 19006,
     /* 1550892 */     GIR_EraseRootFromParent_Done,
     /* 1550893 */   // Label 21509: @1550893
     /* 1550893 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1550975), // Rule ID 19007 //
     /* 1550898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1550901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1550909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1550912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550937 */     // MIs[0] round
     /* 1550937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550940 */     // MIs[0] policy
     /* 1550940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1550953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550974 */     // GIR_Coverage, 19007,
     /* 1550974 */     GIR_EraseRootFromParent_Done,
     /* 1550975 */   // Label 21510: @1550975
     /* 1550975 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1551057), // Rule ID 19010 //
     /* 1550980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1550983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1550988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1550997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1551000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551019 */     // MIs[0] round
     /* 1551019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551022 */     // MIs[0] policy
     /* 1551022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1551035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1551053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551056 */     // GIR_Coverage, 19010,
     /* 1551056 */     GIR_EraseRootFromParent_Done,
     /* 1551057 */   // Label 21511: @1551057
     /* 1551057 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1551139), // Rule ID 19011 //
     /* 1551062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1551065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1551079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1551082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551101 */     // MIs[0] round
     /* 1551101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551104 */     // MIs[0] policy
     /* 1551104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551114 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1551117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1551135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551138 */     // GIR_Coverage, 19011,
     /* 1551138 */     GIR_EraseRootFromParent_Done,
     /* 1551139 */   // Label 21512: @1551139
     /* 1551139 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1551221), // Rule ID 19014 //
     /* 1551144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1551147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1551155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1551158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551183 */     // MIs[0] round
     /* 1551183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551186 */     // MIs[0] policy
     /* 1551186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1551199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551220 */     // GIR_Coverage, 19014,
     /* 1551220 */     GIR_EraseRootFromParent_Done,
     /* 1551221 */   // Label 21513: @1551221
     /* 1551221 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1551303), // Rule ID 19015 //
     /* 1551226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1551229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1551237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1551240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551265 */     // MIs[0] round
     /* 1551265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551268 */     // MIs[0] policy
     /* 1551268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1551281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551302 */     // GIR_Coverage, 19015,
     /* 1551302 */     GIR_EraseRootFromParent_Done,
     /* 1551303 */   // Label 21514: @1551303
     /* 1551303 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1551385), // Rule ID 19018 //
     /* 1551308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1551311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1551319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1551322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1551328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551347 */     // MIs[0] round
     /* 1551347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551350 */     // MIs[0] policy
     /* 1551350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551360 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1551363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551384 */     // GIR_Coverage, 19018,
     /* 1551384 */     GIR_EraseRootFromParent_Done,
     /* 1551385 */   // Label 21515: @1551385
     /* 1551385 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1551467), // Rule ID 19019 //
     /* 1551390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1551393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1551401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1551404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1551410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551429 */     // MIs[0] round
     /* 1551429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551432 */     // MIs[0] policy
     /* 1551432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551442 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1551445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551466 */     // GIR_Coverage, 19019,
     /* 1551466 */     GIR_EraseRootFromParent_Done,
     /* 1551467 */   // Label 21516: @1551467
     /* 1551467 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1551549), // Rule ID 19022 //
     /* 1551472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1551475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1551492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551511 */     // MIs[0] round
     /* 1551511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551514 */     // MIs[0] policy
     /* 1551514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551524 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1551527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551548 */     // GIR_Coverage, 19022,
     /* 1551548 */     GIR_EraseRootFromParent_Done,
     /* 1551549 */   // Label 21517: @1551549
     /* 1551549 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1551631), // Rule ID 19023 //
     /* 1551554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1551557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1551574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551593 */     // MIs[0] round
     /* 1551593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551596 */     // MIs[0] policy
     /* 1551596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551606 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1551609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551630 */     // GIR_Coverage, 19023,
     /* 1551630 */     GIR_EraseRootFromParent_Done,
     /* 1551631 */   // Label 21518: @1551631
     /* 1551631 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1551713), // Rule ID 19026 //
     /* 1551636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1551639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1551656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551675 */     // MIs[0] round
     /* 1551675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551678 */     // MIs[0] policy
     /* 1551678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551688 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1551691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551712 */     // GIR_Coverage, 19026,
     /* 1551712 */     GIR_EraseRootFromParent_Done,
     /* 1551713 */   // Label 21519: @1551713
     /* 1551713 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1551795), // Rule ID 19027 //
     /* 1551718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1551721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1551735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1551738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551757 */     // MIs[0] round
     /* 1551757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551760 */     // MIs[0] policy
     /* 1551760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551770 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1551773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551794 */     // GIR_Coverage, 19027,
     /* 1551794 */     GIR_EraseRootFromParent_Done,
     /* 1551795 */   // Label 21520: @1551795
     /* 1551795 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1551877), // Rule ID 19030 //
     /* 1551800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1551803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551839 */     // MIs[0] round
     /* 1551839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551842 */     // MIs[0] policy
     /* 1551842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551852 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1551855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551876 */     // GIR_Coverage, 19030,
     /* 1551876 */     GIR_EraseRootFromParent_Done,
     /* 1551877 */   // Label 21521: @1551877
     /* 1551877 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1551959), // Rule ID 19031 //
     /* 1551882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1551885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551921 */     // MIs[0] round
     /* 1551921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551924 */     // MIs[0] policy
     /* 1551924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551934 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1551937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551958 */     // GIR_Coverage, 19031,
     /* 1551958 */     GIR_EraseRootFromParent_Done,
     /* 1551959 */   // Label 21522: @1551959
     /* 1551959 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1552041), // Rule ID 19034 //
     /* 1551964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1551967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1551972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1551981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1551984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552003 */     // MIs[0] round
     /* 1552003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552006 */     // MIs[0] policy
     /* 1552006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552016 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1552019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552040 */     // GIR_Coverage, 19034,
     /* 1552040 */     GIR_EraseRootFromParent_Done,
     /* 1552041 */   // Label 21523: @1552041
     /* 1552041 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1552123), // Rule ID 19035 //
     /* 1552046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1552049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1552063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1552066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552085 */     // MIs[0] round
     /* 1552085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552088 */     // MIs[0] policy
     /* 1552088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552098 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1552101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552122 */     // GIR_Coverage, 19035,
     /* 1552122 */     GIR_EraseRootFromParent_Done,
     /* 1552123 */   // Label 21524: @1552123
     /* 1552123 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1552205), // Rule ID 19038 //
     /* 1552128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1552131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552167 */     // MIs[0] round
     /* 1552167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552170 */     // MIs[0] policy
     /* 1552170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552180 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1552183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552204 */     // GIR_Coverage, 19038,
     /* 1552204 */     GIR_EraseRootFromParent_Done,
     /* 1552205 */   // Label 21525: @1552205
     /* 1552205 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1552287), // Rule ID 19039 //
     /* 1552210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1552213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552249 */     // MIs[0] round
     /* 1552249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552252 */     // MIs[0] policy
     /* 1552252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1552265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552286 */     // GIR_Coverage, 19039,
     /* 1552286 */     GIR_EraseRootFromParent_Done,
     /* 1552287 */   // Label 21526: @1552287
     /* 1552287 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1552369), // Rule ID 19042 //
     /* 1552292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1552295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552331 */     // MIs[0] round
     /* 1552331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552334 */     // MIs[0] policy
     /* 1552334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552344 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1552347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552368 */     // GIR_Coverage, 19042,
     /* 1552368 */     GIR_EraseRootFromParent_Done,
     /* 1552369 */   // Label 21527: @1552369
     /* 1552369 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1552451), // Rule ID 19043 //
     /* 1552374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1552377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552413 */     // MIs[0] round
     /* 1552413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552416 */     // MIs[0] policy
     /* 1552416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552426 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1552429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552450 */     // GIR_Coverage, 19043,
     /* 1552450 */     GIR_EraseRootFromParent_Done,
     /* 1552451 */   // Label 21528: @1552451
     /* 1552451 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1552533), // Rule ID 19046 //
     /* 1552456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1552459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552495 */     // MIs[0] round
     /* 1552495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552498 */     // MIs[0] policy
     /* 1552498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552508 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1552511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552532 */     // GIR_Coverage, 19046,
     /* 1552532 */     GIR_EraseRootFromParent_Done,
     /* 1552533 */   // Label 21529: @1552533
     /* 1552533 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1552615), // Rule ID 19047 //
     /* 1552538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1552541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552577 */     // MIs[0] round
     /* 1552577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552580 */     // MIs[0] policy
     /* 1552580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1552593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552614 */     // GIR_Coverage, 19047,
     /* 1552614 */     GIR_EraseRootFromParent_Done,
     /* 1552615 */   // Label 21530: @1552615
     /* 1552615 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1552697), // Rule ID 19106 //
     /* 1552620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1552628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1552631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1552634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1552637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552659 */     // MIs[0] round
     /* 1552659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552662 */     // MIs[0] policy
     /* 1552662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552672 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1552675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552696 */     // GIR_Coverage, 19106,
     /* 1552696 */     GIR_EraseRootFromParent_Done,
     /* 1552697 */   // Label 21531: @1552697
     /* 1552697 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1552779), // Rule ID 19107 //
     /* 1552702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1552710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1552713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1552716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1552719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552741 */     // MIs[0] round
     /* 1552741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552744 */     // MIs[0] policy
     /* 1552744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1552757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552778 */     // GIR_Coverage, 19107,
     /* 1552778 */     GIR_EraseRootFromParent_Done,
     /* 1552779 */   // Label 21532: @1552779
     /* 1552779 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1552861), // Rule ID 19110 //
     /* 1552784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1552792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552823 */     // MIs[0] round
     /* 1552823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552826 */     // MIs[0] policy
     /* 1552826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552836 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1552839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552860 */     // GIR_Coverage, 19110,
     /* 1552860 */     GIR_EraseRootFromParent_Done,
     /* 1552861 */   // Label 21533: @1552861
     /* 1552861 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1552943), // Rule ID 19111 //
     /* 1552866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1552874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552905 */     // MIs[0] round
     /* 1552905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552908 */     // MIs[0] policy
     /* 1552908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552918 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1552921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552942 */     // GIR_Coverage, 19111,
     /* 1552942 */     GIR_EraseRootFromParent_Done,
     /* 1552943 */   // Label 21534: @1552943
     /* 1552943 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1553025), // Rule ID 19114 //
     /* 1552948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1552951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1552956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1552965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552987 */     // MIs[0] round
     /* 1552987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552990 */     // MIs[0] policy
     /* 1552990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553000 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1553003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553024 */     // GIR_Coverage, 19114,
     /* 1553024 */     GIR_EraseRootFromParent_Done,
     /* 1553025 */   // Label 21535: @1553025
     /* 1553025 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1553107), // Rule ID 19115 //
     /* 1553030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553069 */     // MIs[0] round
     /* 1553069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553072 */     // MIs[0] policy
     /* 1553072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553082 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1553085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553106 */     // GIR_Coverage, 19115,
     /* 1553106 */     GIR_EraseRootFromParent_Done,
     /* 1553107 */   // Label 21536: @1553107
     /* 1553107 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1553189), // Rule ID 19118 //
     /* 1553112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553151 */     // MIs[0] round
     /* 1553151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553154 */     // MIs[0] policy
     /* 1553154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553164 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1553167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553188 */     // GIR_Coverage, 19118,
     /* 1553188 */     GIR_EraseRootFromParent_Done,
     /* 1553189 */   // Label 21537: @1553189
     /* 1553189 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1553271), // Rule ID 19119 //
     /* 1553194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553233 */     // MIs[0] round
     /* 1553233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553236 */     // MIs[0] policy
     /* 1553236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553246 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1553249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553270 */     // GIR_Coverage, 19119,
     /* 1553270 */     GIR_EraseRootFromParent_Done,
     /* 1553271 */   // Label 21538: @1553271
     /* 1553271 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1553353), // Rule ID 19122 //
     /* 1553276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553315 */     // MIs[0] round
     /* 1553315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553318 */     // MIs[0] policy
     /* 1553318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553328 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1553331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553352 */     // GIR_Coverage, 19122,
     /* 1553352 */     GIR_EraseRootFromParent_Done,
     /* 1553353 */   // Label 21539: @1553353
     /* 1553353 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1553435), // Rule ID 19123 //
     /* 1553358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553397 */     // MIs[0] round
     /* 1553397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553400 */     // MIs[0] policy
     /* 1553400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1553413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553434 */     // GIR_Coverage, 19123,
     /* 1553434 */     GIR_EraseRootFromParent_Done,
     /* 1553435 */   // Label 21540: @1553435
     /* 1553435 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1553517), // Rule ID 19126 //
     /* 1553440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1553443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553479 */     // MIs[0] round
     /* 1553479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553482 */     // MIs[0] policy
     /* 1553482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553492 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1553495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553516 */     // GIR_Coverage, 19126,
     /* 1553516 */     GIR_EraseRootFromParent_Done,
     /* 1553517 */   // Label 21541: @1553517
     /* 1553517 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1553599), // Rule ID 19127 //
     /* 1553522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1553525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553561 */     // MIs[0] round
     /* 1553561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553564 */     // MIs[0] policy
     /* 1553564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1553577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553598 */     // GIR_Coverage, 19127,
     /* 1553598 */     GIR_EraseRootFromParent_Done,
     /* 1553599 */   // Label 21542: @1553599
     /* 1553599 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1553681), // Rule ID 19130 //
     /* 1553604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553643 */     // MIs[0] round
     /* 1553643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553646 */     // MIs[0] policy
     /* 1553646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1553659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553680 */     // GIR_Coverage, 19130,
     /* 1553680 */     GIR_EraseRootFromParent_Done,
     /* 1553681 */   // Label 21543: @1553681
     /* 1553681 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1553763), // Rule ID 19131 //
     /* 1553686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553725 */     // MIs[0] round
     /* 1553725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553728 */     // MIs[0] policy
     /* 1553728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553738 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1553741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553762 */     // GIR_Coverage, 19131,
     /* 1553762 */     GIR_EraseRootFromParent_Done,
     /* 1553763 */   // Label 21544: @1553763
     /* 1553763 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1553845), // Rule ID 19134 //
     /* 1553768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553807 */     // MIs[0] round
     /* 1553807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553810 */     // MIs[0] policy
     /* 1553810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553820 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1553823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553844 */     // GIR_Coverage, 19134,
     /* 1553844 */     GIR_EraseRootFromParent_Done,
     /* 1553845 */   // Label 21545: @1553845
     /* 1553845 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1553927), // Rule ID 19135 //
     /* 1553850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553889 */     // MIs[0] round
     /* 1553889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553892 */     // MIs[0] policy
     /* 1553892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1553905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553926 */     // GIR_Coverage, 19135,
     /* 1553926 */     GIR_EraseRootFromParent_Done,
     /* 1553927 */   // Label 21546: @1553927
     /* 1553927 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1554009), // Rule ID 19138 //
     /* 1553932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1553940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1553943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1553946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1553949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1553952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1553959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553971 */     // MIs[0] round
     /* 1553971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553974 */     // MIs[0] policy
     /* 1553974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553984 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1553987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554008 */     // GIR_Coverage, 19138,
     /* 1554008 */     GIR_EraseRootFromParent_Done,
     /* 1554009 */   // Label 21547: @1554009
     /* 1554009 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1554091), // Rule ID 19139 //
     /* 1554014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554053 */     // MIs[0] round
     /* 1554053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554056 */     // MIs[0] policy
     /* 1554056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554066 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1554069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554090 */     // GIR_Coverage, 19139,
     /* 1554090 */     GIR_EraseRootFromParent_Done,
     /* 1554091 */   // Label 21548: @1554091
     /* 1554091 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1554173), // Rule ID 19142 //
     /* 1554096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554135 */     // MIs[0] round
     /* 1554135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554138 */     // MIs[0] policy
     /* 1554138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554148 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1554151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554172 */     // GIR_Coverage, 19142,
     /* 1554172 */     GIR_EraseRootFromParent_Done,
     /* 1554173 */   // Label 21549: @1554173
     /* 1554173 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1554255), // Rule ID 19143 //
     /* 1554178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554217 */     // MIs[0] round
     /* 1554217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554220 */     // MIs[0] policy
     /* 1554220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554230 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1554233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554254 */     // GIR_Coverage, 19143,
     /* 1554254 */     GIR_EraseRootFromParent_Done,
     /* 1554255 */   // Label 21550: @1554255
     /* 1554255 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1554337), // Rule ID 19146 //
     /* 1554260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554299 */     // MIs[0] round
     /* 1554299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554302 */     // MIs[0] policy
     /* 1554302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554312 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1554315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554336 */     // GIR_Coverage, 19146,
     /* 1554336 */     GIR_EraseRootFromParent_Done,
     /* 1554337 */   // Label 21551: @1554337
     /* 1554337 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1554419), // Rule ID 19147 //
     /* 1554342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554381 */     // MIs[0] round
     /* 1554381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554384 */     // MIs[0] policy
     /* 1554384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554394 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1554397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554418 */     // GIR_Coverage, 19147,
     /* 1554418 */     GIR_EraseRootFromParent_Done,
     /* 1554419 */   // Label 21552: @1554419
     /* 1554419 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1554501), // Rule ID 19150 //
     /* 1554424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554463 */     // MIs[0] round
     /* 1554463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554466 */     // MIs[0] policy
     /* 1554466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554476 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1554479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554500 */     // GIR_Coverage, 19150,
     /* 1554500 */     GIR_EraseRootFromParent_Done,
     /* 1554501 */   // Label 21553: @1554501
     /* 1554501 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1554583), // Rule ID 19151 //
     /* 1554506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554545 */     // MIs[0] round
     /* 1554545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554548 */     // MIs[0] policy
     /* 1554548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554558 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1554561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554582 */     // GIR_Coverage, 19151,
     /* 1554582 */     GIR_EraseRootFromParent_Done,
     /* 1554583 */   // Label 21554: @1554583
     /* 1554583 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1554665), // Rule ID 19154 //
     /* 1554588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554627 */     // MIs[0] round
     /* 1554627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554630 */     // MIs[0] policy
     /* 1554630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554640 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1554643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554664 */     // GIR_Coverage, 19154,
     /* 1554664 */     GIR_EraseRootFromParent_Done,
     /* 1554665 */   // Label 21555: @1554665
     /* 1554665 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1554747), // Rule ID 19155 //
     /* 1554670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554709 */     // MIs[0] round
     /* 1554709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554712 */     // MIs[0] policy
     /* 1554712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1554725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554746 */     // GIR_Coverage, 19155,
     /* 1554746 */     GIR_EraseRootFromParent_Done,
     /* 1554747 */   // Label 21556: @1554747
     /* 1554747 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1554829), // Rule ID 19158 //
     /* 1554752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554791 */     // MIs[0] round
     /* 1554791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554794 */     // MIs[0] policy
     /* 1554794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554804 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1554807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554828 */     // GIR_Coverage, 19158,
     /* 1554828 */     GIR_EraseRootFromParent_Done,
     /* 1554829 */   // Label 21557: @1554829
     /* 1554829 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1554911), // Rule ID 19159 //
     /* 1554834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554873 */     // MIs[0] round
     /* 1554873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554876 */     // MIs[0] policy
     /* 1554876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554886 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1554889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554910 */     // GIR_Coverage, 19159,
     /* 1554910 */     GIR_EraseRootFromParent_Done,
     /* 1554911 */   // Label 21558: @1554911
     /* 1554911 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1554993), // Rule ID 19162 //
     /* 1554916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1554933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554955 */     // MIs[0] round
     /* 1554955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554958 */     // MIs[0] policy
     /* 1554958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554968 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1554971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554992 */     // GIR_Coverage, 19162,
     /* 1554992 */     GIR_EraseRootFromParent_Done,
     /* 1554993 */   // Label 21559: @1554993
     /* 1554993 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1555075), // Rule ID 19163 //
     /* 1554998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555037 */     // MIs[0] round
     /* 1555037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555040 */     // MIs[0] policy
     /* 1555040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1555053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555074 */     // GIR_Coverage, 19163,
     /* 1555074 */     GIR_EraseRootFromParent_Done,
     /* 1555075 */   // Label 21560: @1555075
     /* 1555075 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1555157), // Rule ID 20748 //
     /* 1555080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555119 */     // MIs[0] round
     /* 1555119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555122 */     // MIs[0] policy
     /* 1555122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1555135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555156 */     // GIR_Coverage, 20748,
     /* 1555156 */     GIR_EraseRootFromParent_Done,
     /* 1555157 */   // Label 21561: @1555157
     /* 1555157 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1555239), // Rule ID 20749 //
     /* 1555162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1555165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555201 */     // MIs[0] round
     /* 1555201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555204 */     // MIs[0] policy
     /* 1555204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1555217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555238 */     // GIR_Coverage, 20749,
     /* 1555238 */     GIR_EraseRootFromParent_Done,
     /* 1555239 */   // Label 21562: @1555239
     /* 1555239 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1555321), // Rule ID 20752 //
     /* 1555244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1555247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555283 */     // MIs[0] round
     /* 1555283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555286 */     // MIs[0] policy
     /* 1555286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1555299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555320 */     // GIR_Coverage, 20752,
     /* 1555320 */     GIR_EraseRootFromParent_Done,
     /* 1555321 */   // Label 21563: @1555321
     /* 1555321 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1555403), // Rule ID 20753 //
     /* 1555326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1555329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555365 */     // MIs[0] round
     /* 1555365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555368 */     // MIs[0] policy
     /* 1555368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1555381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555402 */     // GIR_Coverage, 20753,
     /* 1555402 */     GIR_EraseRootFromParent_Done,
     /* 1555403 */   // Label 21564: @1555403
     /* 1555403 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1555485), // Rule ID 20756 //
     /* 1555408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555447 */     // MIs[0] round
     /* 1555447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555450 */     // MIs[0] policy
     /* 1555450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555484 */     // GIR_Coverage, 20756,
     /* 1555484 */     GIR_EraseRootFromParent_Done,
     /* 1555485 */   // Label 21565: @1555485
     /* 1555485 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1555567), // Rule ID 20757 //
     /* 1555490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1555493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555529 */     // MIs[0] round
     /* 1555529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555532 */     // MIs[0] policy
     /* 1555532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555566 */     // GIR_Coverage, 20757,
     /* 1555566 */     GIR_EraseRootFromParent_Done,
     /* 1555567 */   // Label 21566: @1555567
     /* 1555567 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1555649), // Rule ID 20760 //
     /* 1555572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1555575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555611 */     // MIs[0] round
     /* 1555611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555614 */     // MIs[0] policy
     /* 1555614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555648 */     // GIR_Coverage, 20760,
     /* 1555648 */     GIR_EraseRootFromParent_Done,
     /* 1555649 */   // Label 21567: @1555649
     /* 1555649 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1555731), // Rule ID 20761 //
     /* 1555654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1555657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555693 */     // MIs[0] round
     /* 1555693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555696 */     // MIs[0] policy
     /* 1555696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555730 */     // GIR_Coverage, 20761,
     /* 1555730 */     GIR_EraseRootFromParent_Done,
     /* 1555731 */   // Label 21568: @1555731
     /* 1555731 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1555813), // Rule ID 20764 //
     /* 1555736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1555739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555775 */     // MIs[0] round
     /* 1555775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555778 */     // MIs[0] policy
     /* 1555778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555812 */     // GIR_Coverage, 20764,
     /* 1555812 */     GIR_EraseRootFromParent_Done,
     /* 1555813 */   // Label 21569: @1555813
     /* 1555813 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1555895), // Rule ID 20765 //
     /* 1555818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1555821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555857 */     // MIs[0] round
     /* 1555857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555860 */     // MIs[0] policy
     /* 1555860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555870 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1555873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555894 */     // GIR_Coverage, 20765,
     /* 1555894 */     GIR_EraseRootFromParent_Done,
     /* 1555895 */   // Label 21570: @1555895
     /* 1555895 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1555977), // Rule ID 20768 //
     /* 1555900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555939 */     // MIs[0] round
     /* 1555939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555942 */     // MIs[0] policy
     /* 1555942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1555955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555976 */     // GIR_Coverage, 20768,
     /* 1555976 */     GIR_EraseRootFromParent_Done,
     /* 1555977 */   // Label 21571: @1555977
     /* 1555977 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1556059), // Rule ID 20769 //
     /* 1555982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1555985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1555990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556021 */     // MIs[0] round
     /* 1556021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556024 */     // MIs[0] policy
     /* 1556024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1556037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556058 */     // GIR_Coverage, 20769,
     /* 1556058 */     GIR_EraseRootFromParent_Done,
     /* 1556059 */   // Label 21572: @1556059
     /* 1556059 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1556141), // Rule ID 20772 //
     /* 1556064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1556067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556103 */     // MIs[0] round
     /* 1556103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556106 */     // MIs[0] policy
     /* 1556106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1556119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556140 */     // GIR_Coverage, 20772,
     /* 1556140 */     GIR_EraseRootFromParent_Done,
     /* 1556141 */   // Label 21573: @1556141
     /* 1556141 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1556223), // Rule ID 20773 //
     /* 1556146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556185 */     // MIs[0] round
     /* 1556185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556188 */     // MIs[0] policy
     /* 1556188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556198 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1556201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556222 */     // GIR_Coverage, 20773,
     /* 1556222 */     GIR_EraseRootFromParent_Done,
     /* 1556223 */   // Label 21574: @1556223
     /* 1556223 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1556305), // Rule ID 20776 //
     /* 1556228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1556231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556267 */     // MIs[0] round
     /* 1556267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556270 */     // MIs[0] policy
     /* 1556270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556280 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1556283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556304 */     // GIR_Coverage, 20776,
     /* 1556304 */     GIR_EraseRootFromParent_Done,
     /* 1556305 */   // Label 21575: @1556305
     /* 1556305 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1556387), // Rule ID 20777 //
     /* 1556310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556349 */     // MIs[0] round
     /* 1556349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556352 */     // MIs[0] policy
     /* 1556352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556362 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1556365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556386 */     // GIR_Coverage, 20777,
     /* 1556386 */     GIR_EraseRootFromParent_Done,
     /* 1556387 */   // Label 21576: @1556387
     /* 1556387 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1556469), // Rule ID 20780 //
     /* 1556392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1556395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556431 */     // MIs[0] round
     /* 1556431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556434 */     // MIs[0] policy
     /* 1556434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1556447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556468 */     // GIR_Coverage, 20780,
     /* 1556468 */     GIR_EraseRootFromParent_Done,
     /* 1556469 */   // Label 21577: @1556469
     /* 1556469 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1556551), // Rule ID 20781 //
     /* 1556474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1556477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556513 */     // MIs[0] round
     /* 1556513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556516 */     // MIs[0] policy
     /* 1556516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1556529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556550 */     // GIR_Coverage, 20781,
     /* 1556550 */     GIR_EraseRootFromParent_Done,
     /* 1556551 */   // Label 21578: @1556551
     /* 1556551 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1556633), // Rule ID 20784 //
     /* 1556556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1556559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556595 */     // MIs[0] round
     /* 1556595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556598 */     // MIs[0] policy
     /* 1556598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1556611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556632 */     // GIR_Coverage, 20784,
     /* 1556632 */     GIR_EraseRootFromParent_Done,
     /* 1556633 */   // Label 21579: @1556633
     /* 1556633 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1556715), // Rule ID 20785 //
     /* 1556638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1556641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556677 */     // MIs[0] round
     /* 1556677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556680 */     // MIs[0] policy
     /* 1556680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1556693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556714 */     // GIR_Coverage, 20785,
     /* 1556714 */     GIR_EraseRootFromParent_Done,
     /* 1556715 */   // Label 21580: @1556715
     /* 1556715 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1556797), // Rule ID 20788 //
     /* 1556720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1556723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556759 */     // MIs[0] round
     /* 1556759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556762 */     // MIs[0] policy
     /* 1556762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556772 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1556775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556796 */     // GIR_Coverage, 20788,
     /* 1556796 */     GIR_EraseRootFromParent_Done,
     /* 1556797 */   // Label 21581: @1556797
     /* 1556797 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1556879), // Rule ID 20789 //
     /* 1556802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1556805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556841 */     // MIs[0] round
     /* 1556841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556844 */     // MIs[0] policy
     /* 1556844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1556857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556878 */     // GIR_Coverage, 20789,
     /* 1556878 */     GIR_EraseRootFromParent_Done,
     /* 1556879 */   // Label 21582: @1556879
     /* 1556879 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1556961), // Rule ID 20792 //
     /* 1556884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1556887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556923 */     // MIs[0] round
     /* 1556923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556926 */     // MIs[0] policy
     /* 1556926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1556939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556960 */     // GIR_Coverage, 20792,
     /* 1556960 */     GIR_EraseRootFromParent_Done,
     /* 1556961 */   // Label 21583: @1556961
     /* 1556961 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1557043), // Rule ID 20793 //
     /* 1556966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1556969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1556974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557005 */     // MIs[0] round
     /* 1557005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557008 */     // MIs[0] policy
     /* 1557008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1557021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557042 */     // GIR_Coverage, 20793,
     /* 1557042 */     GIR_EraseRootFromParent_Done,
     /* 1557043 */   // Label 21584: @1557043
     /* 1557043 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1557125), // Rule ID 20796 //
     /* 1557048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557087 */     // MIs[0] round
     /* 1557087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557090 */     // MIs[0] policy
     /* 1557090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557100 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1557103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557124 */     // GIR_Coverage, 20796,
     /* 1557124 */     GIR_EraseRootFromParent_Done,
     /* 1557125 */   // Label 21585: @1557125
     /* 1557125 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1557207), // Rule ID 20797 //
     /* 1557130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1557133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557169 */     // MIs[0] round
     /* 1557169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557172 */     // MIs[0] policy
     /* 1557172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1557185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557206 */     // GIR_Coverage, 20797,
     /* 1557206 */     GIR_EraseRootFromParent_Done,
     /* 1557207 */   // Label 21586: @1557207
     /* 1557207 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1557289), // Rule ID 20800 //
     /* 1557212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557251 */     // MIs[0] round
     /* 1557251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557254 */     // MIs[0] policy
     /* 1557254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1557267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557288 */     // GIR_Coverage, 20800,
     /* 1557288 */     GIR_EraseRootFromParent_Done,
     /* 1557289 */   // Label 21587: @1557289
     /* 1557289 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1557371), // Rule ID 20801 //
     /* 1557294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1557297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557333 */     // MIs[0] round
     /* 1557333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557336 */     // MIs[0] policy
     /* 1557336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1557349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557370 */     // GIR_Coverage, 20801,
     /* 1557370 */     GIR_EraseRootFromParent_Done,
     /* 1557371 */   // Label 21588: @1557371
     /* 1557371 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1557453), // Rule ID 20804 //
     /* 1557376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1557387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1557390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1557393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557415 */     // MIs[0] round
     /* 1557415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557418 */     // MIs[0] policy
     /* 1557418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557428 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1557431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557452 */     // GIR_Coverage, 20804,
     /* 1557452 */     GIR_EraseRootFromParent_Done,
     /* 1557453 */   // Label 21589: @1557453
     /* 1557453 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1557535), // Rule ID 20805 //
     /* 1557458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1557469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1557472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1557475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557497 */     // MIs[0] round
     /* 1557497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557500 */     // MIs[0] policy
     /* 1557500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1557513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557534 */     // GIR_Coverage, 20805,
     /* 1557534 */     GIR_EraseRootFromParent_Done,
     /* 1557535 */   // Label 21590: @1557535
     /* 1557535 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1557617), // Rule ID 20808 //
     /* 1557540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557579 */     // MIs[0] round
     /* 1557579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557582 */     // MIs[0] policy
     /* 1557582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1557595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557616 */     // GIR_Coverage, 20808,
     /* 1557616 */     GIR_EraseRootFromParent_Done,
     /* 1557617 */   // Label 21591: @1557617
     /* 1557617 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1557699), // Rule ID 20809 //
     /* 1557622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557661 */     // MIs[0] round
     /* 1557661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557664 */     // MIs[0] policy
     /* 1557664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1557677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557698 */     // GIR_Coverage, 20809,
     /* 1557698 */     GIR_EraseRootFromParent_Done,
     /* 1557699 */   // Label 21592: @1557699
     /* 1557699 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1557781), // Rule ID 20812 //
     /* 1557704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557743 */     // MIs[0] round
     /* 1557743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557746 */     // MIs[0] policy
     /* 1557746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1557759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557780 */     // GIR_Coverage, 20812,
     /* 1557780 */     GIR_EraseRootFromParent_Done,
     /* 1557781 */   // Label 21593: @1557781
     /* 1557781 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1557863), // Rule ID 20813 //
     /* 1557786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557825 */     // MIs[0] round
     /* 1557825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557828 */     // MIs[0] policy
     /* 1557828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1557841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557862 */     // GIR_Coverage, 20813,
     /* 1557862 */     GIR_EraseRootFromParent_Done,
     /* 1557863 */   // Label 21594: @1557863
     /* 1557863 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1557945), // Rule ID 20816 //
     /* 1557868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557907 */     // MIs[0] round
     /* 1557907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557910 */     // MIs[0] policy
     /* 1557910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1557923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557944 */     // GIR_Coverage, 20816,
     /* 1557944 */     GIR_EraseRootFromParent_Done,
     /* 1557945 */   // Label 21595: @1557945
     /* 1557945 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1558027), // Rule ID 20817 //
     /* 1557950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1557958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557989 */     // MIs[0] round
     /* 1557989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557992 */     // MIs[0] policy
     /* 1557992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1558005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558026 */     // GIR_Coverage, 20817,
     /* 1558026 */     GIR_EraseRootFromParent_Done,
     /* 1558027 */   // Label 21596: @1558027
     /* 1558027 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1558109), // Rule ID 20820 //
     /* 1558032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558071 */     // MIs[0] round
     /* 1558071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558074 */     // MIs[0] policy
     /* 1558074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1558087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558108 */     // GIR_Coverage, 20820,
     /* 1558108 */     GIR_EraseRootFromParent_Done,
     /* 1558109 */   // Label 21597: @1558109
     /* 1558109 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1558191), // Rule ID 20821 //
     /* 1558114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558153 */     // MIs[0] round
     /* 1558153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558156 */     // MIs[0] policy
     /* 1558156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1558169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558190 */     // GIR_Coverage, 20821,
     /* 1558190 */     GIR_EraseRootFromParent_Done,
     /* 1558191 */   // Label 21598: @1558191
     /* 1558191 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1558273), // Rule ID 20824 //
     /* 1558196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1558199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558235 */     // MIs[0] round
     /* 1558235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558238 */     // MIs[0] policy
     /* 1558238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1558251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558272 */     // GIR_Coverage, 20824,
     /* 1558272 */     GIR_EraseRootFromParent_Done,
     /* 1558273 */   // Label 21599: @1558273
     /* 1558273 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1558355), // Rule ID 20825 //
     /* 1558278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558317 */     // MIs[0] round
     /* 1558317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558320 */     // MIs[0] policy
     /* 1558320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1558333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558354 */     // GIR_Coverage, 20825,
     /* 1558354 */     GIR_EraseRootFromParent_Done,
     /* 1558355 */   // Label 21600: @1558355
     /* 1558355 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1558437), // Rule ID 20828 //
     /* 1558360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558399 */     // MIs[0] round
     /* 1558399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558402 */     // MIs[0] policy
     /* 1558402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1558415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558436 */     // GIR_Coverage, 20828,
     /* 1558436 */     GIR_EraseRootFromParent_Done,
     /* 1558437 */   // Label 21601: @1558437
     /* 1558437 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1558519), // Rule ID 20829 //
     /* 1558442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558481 */     // MIs[0] round
     /* 1558481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558484 */     // MIs[0] policy
     /* 1558484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1558497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558518 */     // GIR_Coverage, 20829,
     /* 1558518 */     GIR_EraseRootFromParent_Done,
     /* 1558519 */   // Label 21602: @1558519
     /* 1558519 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1558601), // Rule ID 20832 //
     /* 1558524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558563 */     // MIs[0] round
     /* 1558563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558566 */     // MIs[0] policy
     /* 1558566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1558579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558600 */     // GIR_Coverage, 20832,
     /* 1558600 */     GIR_EraseRootFromParent_Done,
     /* 1558601 */   // Label 21603: @1558601
     /* 1558601 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1558683), // Rule ID 20833 //
     /* 1558606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558645 */     // MIs[0] round
     /* 1558645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558648 */     // MIs[0] policy
     /* 1558648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1558661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558682 */     // GIR_Coverage, 20833,
     /* 1558682 */     GIR_EraseRootFromParent_Done,
     /* 1558683 */   // Label 21604: @1558683
     /* 1558683 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1558765), // Rule ID 20836 //
     /* 1558688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558727 */     // MIs[0] round
     /* 1558727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558730 */     // MIs[0] policy
     /* 1558730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1558743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558764 */     // GIR_Coverage, 20836,
     /* 1558764 */     GIR_EraseRootFromParent_Done,
     /* 1558765 */   // Label 21605: @1558765
     /* 1558765 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1558847), // Rule ID 20837 //
     /* 1558770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558809 */     // MIs[0] round
     /* 1558809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558812 */     // MIs[0] policy
     /* 1558812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558822 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1558825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558846 */     // GIR_Coverage, 20837,
     /* 1558846 */     GIR_EraseRootFromParent_Done,
     /* 1558847 */   // Label 21606: @1558847
     /* 1558847 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1558929), // Rule ID 20840 //
     /* 1558852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558891 */     // MIs[0] round
     /* 1558891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558894 */     // MIs[0] policy
     /* 1558894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1558907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558928 */     // GIR_Coverage, 20840,
     /* 1558928 */     GIR_EraseRootFromParent_Done,
     /* 1558929 */   // Label 21607: @1558929
     /* 1558929 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1559011), // Rule ID 20841 //
     /* 1558934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1558942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558973 */     // MIs[0] round
     /* 1558973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558976 */     // MIs[0] policy
     /* 1558976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1558989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559010 */     // GIR_Coverage, 20841,
     /* 1559010 */     GIR_EraseRootFromParent_Done,
     /* 1559011 */   // Label 21608: @1559011
     /* 1559011 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1559093), // Rule ID 20844 //
     /* 1559016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559055 */     // MIs[0] round
     /* 1559055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559058 */     // MIs[0] policy
     /* 1559058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559068 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1559071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559092 */     // GIR_Coverage, 20844,
     /* 1559092 */     GIR_EraseRootFromParent_Done,
     /* 1559093 */   // Label 21609: @1559093
     /* 1559093 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1559175), // Rule ID 20845 //
     /* 1559098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559137 */     // MIs[0] round
     /* 1559137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559140 */     // MIs[0] policy
     /* 1559140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1559153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559174 */     // GIR_Coverage, 20845,
     /* 1559174 */     GIR_EraseRootFromParent_Done,
     /* 1559175 */   // Label 21610: @1559175
     /* 1559175 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1559257), // Rule ID 20848 //
     /* 1559180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559219 */     // MIs[0] round
     /* 1559219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559222 */     // MIs[0] policy
     /* 1559222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1559235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559256 */     // GIR_Coverage, 20848,
     /* 1559256 */     GIR_EraseRootFromParent_Done,
     /* 1559257 */   // Label 21611: @1559257
     /* 1559257 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1559339), // Rule ID 20849 //
     /* 1559262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559301 */     // MIs[0] round
     /* 1559301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559304 */     // MIs[0] policy
     /* 1559304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559314 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1559317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559338 */     // GIR_Coverage, 20849,
     /* 1559338 */     GIR_EraseRootFromParent_Done,
     /* 1559339 */   // Label 21612: @1559339
     /* 1559339 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1559421), // Rule ID 20852 //
     /* 1559344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559383 */     // MIs[0] round
     /* 1559383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559386 */     // MIs[0] policy
     /* 1559386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1559399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559420 */     // GIR_Coverage, 20852,
     /* 1559420 */     GIR_EraseRootFromParent_Done,
     /* 1559421 */   // Label 21613: @1559421
     /* 1559421 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1559503), // Rule ID 20853 //
     /* 1559426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559465 */     // MIs[0] round
     /* 1559465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559468 */     // MIs[0] policy
     /* 1559468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1559481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559502 */     // GIR_Coverage, 20853,
     /* 1559502 */     GIR_EraseRootFromParent_Done,
     /* 1559503 */   // Label 21614: @1559503
     /* 1559503 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1559585), // Rule ID 20856 //
     /* 1559508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559547 */     // MIs[0] round
     /* 1559547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559550 */     // MIs[0] policy
     /* 1559550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559560 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1559563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559584 */     // GIR_Coverage, 20856,
     /* 1559584 */     GIR_EraseRootFromParent_Done,
     /* 1559585 */   // Label 21615: @1559585
     /* 1559585 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1559667), // Rule ID 20857 //
     /* 1559590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559629 */     // MIs[0] round
     /* 1559629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559632 */     // MIs[0] policy
     /* 1559632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1559645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559666 */     // GIR_Coverage, 20857,
     /* 1559666 */     GIR_EraseRootFromParent_Done,
     /* 1559667 */   // Label 21616: @1559667
     /* 1559667 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1559749), // Rule ID 20860 //
     /* 1559672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559711 */     // MIs[0] round
     /* 1559711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559714 */     // MIs[0] policy
     /* 1559714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1559727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559748 */     // GIR_Coverage, 20860,
     /* 1559748 */     GIR_EraseRootFromParent_Done,
     /* 1559749 */   // Label 21617: @1559749
     /* 1559749 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1559831), // Rule ID 20861 //
     /* 1559754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559793 */     // MIs[0] round
     /* 1559793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559796 */     // MIs[0] policy
     /* 1559796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1559809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559830 */     // GIR_Coverage, 20861,
     /* 1559830 */     GIR_EraseRootFromParent_Done,
     /* 1559831 */   // Label 21618: @1559831
     /* 1559831 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1559913), // Rule ID 20984 //
     /* 1559836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1559844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559875 */     // MIs[0] round
     /* 1559875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559878 */     // MIs[0] policy
     /* 1559878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559888 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1559891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559912 */     // GIR_Coverage, 20984,
     /* 1559912 */     GIR_EraseRootFromParent_Done,
     /* 1559913 */   // Label 21619: @1559913
     /* 1559913 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1559995), // Rule ID 20985 //
     /* 1559918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1559926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559957 */     // MIs[0] round
     /* 1559957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559960 */     // MIs[0] policy
     /* 1559960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559970 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1559973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559994 */     // GIR_Coverage, 20985,
     /* 1559994 */     GIR_EraseRootFromParent_Done,
     /* 1559995 */   // Label 21620: @1559995
     /* 1559995 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1560077), // Rule ID 20988 //
     /* 1560000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560039 */     // MIs[0] round
     /* 1560039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560042 */     // MIs[0] policy
     /* 1560042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1560055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560076 */     // GIR_Coverage, 20988,
     /* 1560076 */     GIR_EraseRootFromParent_Done,
     /* 1560077 */   // Label 21621: @1560077
     /* 1560077 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1560159), // Rule ID 20989 //
     /* 1560082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1560093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1560096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560121 */     // MIs[0] round
     /* 1560121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560124 */     // MIs[0] policy
     /* 1560124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560134 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1560137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560158 */     // GIR_Coverage, 20989,
     /* 1560158 */     GIR_EraseRootFromParent_Done,
     /* 1560159 */   // Label 21622: @1560159
     /* 1560159 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1560241), // Rule ID 20992 //
     /* 1560164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560203 */     // MIs[0] round
     /* 1560203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560206 */     // MIs[0] policy
     /* 1560206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1560219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560240 */     // GIR_Coverage, 20992,
     /* 1560240 */     GIR_EraseRootFromParent_Done,
     /* 1560241 */   // Label 21623: @1560241
     /* 1560241 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1560323), // Rule ID 20993 //
     /* 1560246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560285 */     // MIs[0] round
     /* 1560285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560288 */     // MIs[0] policy
     /* 1560288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560298 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1560301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560322 */     // GIR_Coverage, 20993,
     /* 1560322 */     GIR_EraseRootFromParent_Done,
     /* 1560323 */   // Label 21624: @1560323
     /* 1560323 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1560405), // Rule ID 20996 //
     /* 1560328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560367 */     // MIs[0] round
     /* 1560367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560370 */     // MIs[0] policy
     /* 1560370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1560383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560404 */     // GIR_Coverage, 20996,
     /* 1560404 */     GIR_EraseRootFromParent_Done,
     /* 1560405 */   // Label 21625: @1560405
     /* 1560405 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1560487), // Rule ID 20997 //
     /* 1560410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560449 */     // MIs[0] round
     /* 1560449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560452 */     // MIs[0] policy
     /* 1560452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1560465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560486 */     // GIR_Coverage, 20997,
     /* 1560486 */     GIR_EraseRootFromParent_Done,
     /* 1560487 */   // Label 21626: @1560487
     /* 1560487 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1560569), // Rule ID 21000 //
     /* 1560492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560531 */     // MIs[0] round
     /* 1560531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560534 */     // MIs[0] policy
     /* 1560534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1560547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560568 */     // GIR_Coverage, 21000,
     /* 1560568 */     GIR_EraseRootFromParent_Done,
     /* 1560569 */   // Label 21627: @1560569
     /* 1560569 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1560651), // Rule ID 21001 //
     /* 1560574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560613 */     // MIs[0] round
     /* 1560613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560616 */     // MIs[0] policy
     /* 1560616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560626 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1560629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560650 */     // GIR_Coverage, 21001,
     /* 1560650 */     GIR_EraseRootFromParent_Done,
     /* 1560651 */   // Label 21628: @1560651
     /* 1560651 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1560733), // Rule ID 21004 //
     /* 1560656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560695 */     // MIs[0] round
     /* 1560695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560698 */     // MIs[0] policy
     /* 1560698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1560711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560732 */     // GIR_Coverage, 21004,
     /* 1560732 */     GIR_EraseRootFromParent_Done,
     /* 1560733 */   // Label 21629: @1560733
     /* 1560733 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1560815), // Rule ID 21005 //
     /* 1560738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560777 */     // MIs[0] round
     /* 1560777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560780 */     // MIs[0] policy
     /* 1560780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560790 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1560793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560814 */     // GIR_Coverage, 21005,
     /* 1560814 */     GIR_EraseRootFromParent_Done,
     /* 1560815 */   // Label 21630: @1560815
     /* 1560815 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1560897), // Rule ID 21008 //
     /* 1560820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560859 */     // MIs[0] round
     /* 1560859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560862 */     // MIs[0] policy
     /* 1560862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1560875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560896 */     // GIR_Coverage, 21008,
     /* 1560896 */     GIR_EraseRootFromParent_Done,
     /* 1560897 */   // Label 21631: @1560897
     /* 1560897 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1560979), // Rule ID 21009 //
     /* 1560902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560941 */     // MIs[0] round
     /* 1560941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560944 */     // MIs[0] policy
     /* 1560944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1560957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560978 */     // GIR_Coverage, 21009,
     /* 1560978 */     GIR_EraseRootFromParent_Done,
     /* 1560979 */   // Label 21632: @1560979
     /* 1560979 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1561061), // Rule ID 21012 //
     /* 1560984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1560992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1560995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1560998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561023 */     // MIs[0] round
     /* 1561023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561026 */     // MIs[0] policy
     /* 1561026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1561039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561060 */     // GIR_Coverage, 21012,
     /* 1561060 */     GIR_EraseRootFromParent_Done,
     /* 1561061 */   // Label 21633: @1561061
     /* 1561061 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1561143), // Rule ID 21013 //
     /* 1561066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1561077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1561080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561105 */     // MIs[0] round
     /* 1561105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561108 */     // MIs[0] policy
     /* 1561108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561118 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1561121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561142 */     // GIR_Coverage, 21013,
     /* 1561142 */     GIR_EraseRootFromParent_Done,
     /* 1561143 */   // Label 21634: @1561143
     /* 1561143 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1561225), // Rule ID 21016 //
     /* 1561148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561187 */     // MIs[0] round
     /* 1561187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561190 */     // MIs[0] policy
     /* 1561190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561200 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1561203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561224 */     // GIR_Coverage, 21016,
     /* 1561224 */     GIR_EraseRootFromParent_Done,
     /* 1561225 */   // Label 21635: @1561225
     /* 1561225 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1561307), // Rule ID 21017 //
     /* 1561230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561269 */     // MIs[0] round
     /* 1561269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561272 */     // MIs[0] policy
     /* 1561272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561282 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1561285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561306 */     // GIR_Coverage, 21017,
     /* 1561306 */     GIR_EraseRootFromParent_Done,
     /* 1561307 */   // Label 21636: @1561307
     /* 1561307 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1561389), // Rule ID 21020 //
     /* 1561312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561351 */     // MIs[0] round
     /* 1561351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561354 */     // MIs[0] policy
     /* 1561354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1561367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561388 */     // GIR_Coverage, 21020,
     /* 1561388 */     GIR_EraseRootFromParent_Done,
     /* 1561389 */   // Label 21637: @1561389
     /* 1561389 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1561471), // Rule ID 21021 //
     /* 1561394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561433 */     // MIs[0] round
     /* 1561433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561436 */     // MIs[0] policy
     /* 1561436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561446 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1561449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561470 */     // GIR_Coverage, 21021,
     /* 1561470 */     GIR_EraseRootFromParent_Done,
     /* 1561471 */   // Label 21638: @1561471
     /* 1561471 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1561553), // Rule ID 21024 //
     /* 1561476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561515 */     // MIs[0] round
     /* 1561515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561518 */     // MIs[0] policy
     /* 1561518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1561531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561552 */     // GIR_Coverage, 21024,
     /* 1561552 */     GIR_EraseRootFromParent_Done,
     /* 1561553 */   // Label 21639: @1561553
     /* 1561553 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1561635), // Rule ID 21025 //
     /* 1561558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561597 */     // MIs[0] round
     /* 1561597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561600 */     // MIs[0] policy
     /* 1561600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561610 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1561613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561634 */     // GIR_Coverage, 21025,
     /* 1561634 */     GIR_EraseRootFromParent_Done,
     /* 1561635 */   // Label 21640: @1561635
     /* 1561635 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1561717), // Rule ID 21028 //
     /* 1561640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561679 */     // MIs[0] round
     /* 1561679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561682 */     // MIs[0] policy
     /* 1561682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561692 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1561695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561716 */     // GIR_Coverage, 21028,
     /* 1561716 */     GIR_EraseRootFromParent_Done,
     /* 1561717 */   // Label 21641: @1561717
     /* 1561717 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1561799), // Rule ID 21029 //
     /* 1561722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561761 */     // MIs[0] round
     /* 1561761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561764 */     // MIs[0] policy
     /* 1561764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561774 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1561777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561798 */     // GIR_Coverage, 21029,
     /* 1561798 */     GIR_EraseRootFromParent_Done,
     /* 1561799 */   // Label 21642: @1561799
     /* 1561799 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1561881), // Rule ID 21032 //
     /* 1561804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561843 */     // MIs[0] round
     /* 1561843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561846 */     // MIs[0] policy
     /* 1561846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1561859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561880 */     // GIR_Coverage, 21032,
     /* 1561880 */     GIR_EraseRootFromParent_Done,
     /* 1561881 */   // Label 21643: @1561881
     /* 1561881 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1561963), // Rule ID 21033 //
     /* 1561886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561925 */     // MIs[0] round
     /* 1561925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561928 */     // MIs[0] policy
     /* 1561928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1561941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561962 */     // GIR_Coverage, 21033,
     /* 1561962 */     GIR_EraseRootFromParent_Done,
     /* 1561963 */   // Label 21644: @1561963
     /* 1561963 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1562045), // Rule ID 21036 //
     /* 1561968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1561976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1561985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562007 */     // MIs[0] round
     /* 1562007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562010 */     // MIs[0] policy
     /* 1562010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1562023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562044 */     // GIR_Coverage, 21036,
     /* 1562044 */     GIR_EraseRootFromParent_Done,
     /* 1562045 */   // Label 21645: @1562045
     /* 1562045 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1562127), // Rule ID 21037 //
     /* 1562050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1562061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1562064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1562067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562089 */     // MIs[0] round
     /* 1562089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562092 */     // MIs[0] policy
     /* 1562092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1562105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562126 */     // GIR_Coverage, 21037,
     /* 1562126 */     GIR_EraseRootFromParent_Done,
     /* 1562127 */   // Label 21646: @1562127
     /* 1562127 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1562209), // Rule ID 21040 //
     /* 1562132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562171 */     // MIs[0] round
     /* 1562171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562174 */     // MIs[0] policy
     /* 1562174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1562187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562208 */     // GIR_Coverage, 21040,
     /* 1562208 */     GIR_EraseRootFromParent_Done,
     /* 1562209 */   // Label 21647: @1562209
     /* 1562209 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1562291), // Rule ID 21041 //
     /* 1562214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1562225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562253 */     // MIs[0] round
     /* 1562253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562256 */     // MIs[0] policy
     /* 1562256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1562269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562290 */     // GIR_Coverage, 21041,
     /* 1562290 */     GIR_EraseRootFromParent_Done,
     /* 1562291 */   // Label 21648: @1562291
     /* 1562291 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1562373), // Rule ID 21044 //
     /* 1562296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562335 */     // MIs[0] round
     /* 1562335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562338 */     // MIs[0] policy
     /* 1562338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562348 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1562351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562372 */     // GIR_Coverage, 21044,
     /* 1562372 */     GIR_EraseRootFromParent_Done,
     /* 1562373 */   // Label 21649: @1562373
     /* 1562373 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1562455), // Rule ID 21045 //
     /* 1562378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562417 */     // MIs[0] round
     /* 1562417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562420 */     // MIs[0] policy
     /* 1562420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562430 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1562433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562454 */     // GIR_Coverage, 21045,
     /* 1562454 */     GIR_EraseRootFromParent_Done,
     /* 1562455 */   // Label 21650: @1562455
     /* 1562455 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1562537), // Rule ID 21048 //
     /* 1562460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562499 */     // MIs[0] round
     /* 1562499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562502 */     // MIs[0] policy
     /* 1562502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562512 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1562515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562536 */     // GIR_Coverage, 21048,
     /* 1562536 */     GIR_EraseRootFromParent_Done,
     /* 1562537 */   // Label 21651: @1562537
     /* 1562537 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1562619), // Rule ID 21049 //
     /* 1562542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562581 */     // MIs[0] round
     /* 1562581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562584 */     // MIs[0] policy
     /* 1562584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562594 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1562597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562618 */     // GIR_Coverage, 21049,
     /* 1562618 */     GIR_EraseRootFromParent_Done,
     /* 1562619 */   // Label 21652: @1562619
     /* 1562619 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1562701), // Rule ID 21052 //
     /* 1562624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562663 */     // MIs[0] round
     /* 1562663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562666 */     // MIs[0] policy
     /* 1562666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562676 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1562679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562700 */     // GIR_Coverage, 21052,
     /* 1562700 */     GIR_EraseRootFromParent_Done,
     /* 1562701 */   // Label 21653: @1562701
     /* 1562701 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1562783), // Rule ID 21053 //
     /* 1562706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562745 */     // MIs[0] round
     /* 1562745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562748 */     // MIs[0] policy
     /* 1562748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1562761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562782 */     // GIR_Coverage, 21053,
     /* 1562782 */     GIR_EraseRootFromParent_Done,
     /* 1562783 */   // Label 21654: @1562783
     /* 1562783 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1562865), // Rule ID 21056 //
     /* 1562788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562827 */     // MIs[0] round
     /* 1562827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562830 */     // MIs[0] policy
     /* 1562830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1562843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562864 */     // GIR_Coverage, 21056,
     /* 1562864 */     GIR_EraseRootFromParent_Done,
     /* 1562865 */   // Label 21655: @1562865
     /* 1562865 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1562947), // Rule ID 21057 //
     /* 1562870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562909 */     // MIs[0] round
     /* 1562909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562912 */     // MIs[0] policy
     /* 1562912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1562925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562946 */     // GIR_Coverage, 21057,
     /* 1562946 */     GIR_EraseRootFromParent_Done,
     /* 1562947 */   // Label 21656: @1562947
     /* 1562947 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1563029), // Rule ID 21060 //
     /* 1562952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1562960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562991 */     // MIs[0] round
     /* 1562991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562994 */     // MIs[0] policy
     /* 1562994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563004 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1563007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563028 */     // GIR_Coverage, 21060,
     /* 1563028 */     GIR_EraseRootFromParent_Done,
     /* 1563029 */   // Label 21657: @1563029
     /* 1563029 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1563111), // Rule ID 21061 //
     /* 1563034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1563045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1563048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1563051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563073 */     // MIs[0] round
     /* 1563073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563076 */     // MIs[0] policy
     /* 1563076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563086 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1563089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563110 */     // GIR_Coverage, 21061,
     /* 1563110 */     GIR_EraseRootFromParent_Done,
     /* 1563111 */   // Label 21658: @1563111
     /* 1563111 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1563193), // Rule ID 21064 //
     /* 1563116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1563119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563155 */     // MIs[0] round
     /* 1563155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563158 */     // MIs[0] policy
     /* 1563158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1563171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563192 */     // GIR_Coverage, 21064,
     /* 1563192 */     GIR_EraseRootFromParent_Done,
     /* 1563193 */   // Label 21659: @1563193
     /* 1563193 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1563275), // Rule ID 21065 //
     /* 1563198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1563201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1563209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1563212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1563215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563237 */     // MIs[0] round
     /* 1563237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563240 */     // MIs[0] policy
     /* 1563240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1563253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563274 */     // GIR_Coverage, 21065,
     /* 1563274 */     GIR_EraseRootFromParent_Done,
     /* 1563275 */   // Label 21660: @1563275
     /* 1563275 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1563357), // Rule ID 21068 //
     /* 1563280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563319 */     // MIs[0] round
     /* 1563319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563322 */     // MIs[0] policy
     /* 1563322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563332 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1563335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563356 */     // GIR_Coverage, 21068,
     /* 1563356 */     GIR_EraseRootFromParent_Done,
     /* 1563357 */   // Label 21661: @1563357
     /* 1563357 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1563439), // Rule ID 21069 //
     /* 1563362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563401 */     // MIs[0] round
     /* 1563401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563404 */     // MIs[0] policy
     /* 1563404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1563417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563438 */     // GIR_Coverage, 21069,
     /* 1563438 */     GIR_EraseRootFromParent_Done,
     /* 1563439 */   // Label 21662: @1563439
     /* 1563439 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1563521), // Rule ID 21072 //
     /* 1563444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563483 */     // MIs[0] round
     /* 1563483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563486 */     // MIs[0] policy
     /* 1563486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563496 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1563499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563520 */     // GIR_Coverage, 21072,
     /* 1563520 */     GIR_EraseRootFromParent_Done,
     /* 1563521 */   // Label 21663: @1563521
     /* 1563521 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1563603), // Rule ID 21073 //
     /* 1563526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563565 */     // MIs[0] round
     /* 1563565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563568 */     // MIs[0] policy
     /* 1563568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563578 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1563581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563602 */     // GIR_Coverage, 21073,
     /* 1563602 */     GIR_EraseRootFromParent_Done,
     /* 1563603 */   // Label 21664: @1563603
     /* 1563603 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1563685), // Rule ID 21076 //
     /* 1563608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563647 */     // MIs[0] round
     /* 1563647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563650 */     // MIs[0] policy
     /* 1563650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1563663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563684 */     // GIR_Coverage, 21076,
     /* 1563684 */     GIR_EraseRootFromParent_Done,
     /* 1563685 */   // Label 21665: @1563685
     /* 1563685 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1563767), // Rule ID 21077 //
     /* 1563690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563729 */     // MIs[0] round
     /* 1563729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563732 */     // MIs[0] policy
     /* 1563732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1563745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563766 */     // GIR_Coverage, 21077,
     /* 1563766 */     GIR_EraseRootFromParent_Done,
     /* 1563767 */   // Label 21666: @1563767
     /* 1563767 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1563849), // Rule ID 21080 //
     /* 1563772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563811 */     // MIs[0] round
     /* 1563811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563814 */     // MIs[0] policy
     /* 1563814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1563827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563848 */     // GIR_Coverage, 21080,
     /* 1563848 */     GIR_EraseRootFromParent_Done,
     /* 1563849 */   // Label 21667: @1563849
     /* 1563849 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1563931), // Rule ID 21081 //
     /* 1563854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563893 */     // MIs[0] round
     /* 1563893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563896 */     // MIs[0] policy
     /* 1563896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1563909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563930 */     // GIR_Coverage, 21081,
     /* 1563930 */     GIR_EraseRootFromParent_Done,
     /* 1563931 */   // Label 21668: @1563931
     /* 1563931 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1564013), // Rule ID 21084 //
     /* 1563936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1563944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563975 */     // MIs[0] round
     /* 1563975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563978 */     // MIs[0] policy
     /* 1563978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1563991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564012 */     // GIR_Coverage, 21084,
     /* 1564012 */     GIR_EraseRootFromParent_Done,
     /* 1564013 */   // Label 21669: @1564013
     /* 1564013 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1564095), // Rule ID 21085 //
     /* 1564018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1564029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1564032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564057 */     // MIs[0] round
     /* 1564057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564060 */     // MIs[0] policy
     /* 1564060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564070 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1564073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564094 */     // GIR_Coverage, 21085,
     /* 1564094 */     GIR_EraseRootFromParent_Done,
     /* 1564095 */   // Label 21670: @1564095
     /* 1564095 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1564177), // Rule ID 21088 //
     /* 1564100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564139 */     // MIs[0] round
     /* 1564139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564142 */     // MIs[0] policy
     /* 1564142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1564155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564176 */     // GIR_Coverage, 21088,
     /* 1564176 */     GIR_EraseRootFromParent_Done,
     /* 1564177 */   // Label 21671: @1564177
     /* 1564177 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1564259), // Rule ID 21089 //
     /* 1564182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1564193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1564196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1564199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564221 */     // MIs[0] round
     /* 1564221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564224 */     // MIs[0] policy
     /* 1564224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564234 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1564237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564258 */     // GIR_Coverage, 21089,
     /* 1564258 */     GIR_EraseRootFromParent_Done,
     /* 1564259 */   // Label 21672: @1564259
     /* 1564259 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1564341), // Rule ID 21092 //
     /* 1564264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564303 */     // MIs[0] round
     /* 1564303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564306 */     // MIs[0] policy
     /* 1564306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564316 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1564319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564340 */     // GIR_Coverage, 21092,
     /* 1564340 */     GIR_EraseRootFromParent_Done,
     /* 1564341 */   // Label 21673: @1564341
     /* 1564341 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1564423), // Rule ID 21093 //
     /* 1564346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564385 */     // MIs[0] round
     /* 1564385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564388 */     // MIs[0] policy
     /* 1564388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1564401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564422 */     // GIR_Coverage, 21093,
     /* 1564422 */     GIR_EraseRootFromParent_Done,
     /* 1564423 */   // Label 21674: @1564423
     /* 1564423 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1564505), // Rule ID 21096 //
     /* 1564428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564467 */     // MIs[0] round
     /* 1564467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564470 */     // MIs[0] policy
     /* 1564470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564480 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1564483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564504 */     // GIR_Coverage, 21096,
     /* 1564504 */     GIR_EraseRootFromParent_Done,
     /* 1564505 */   // Label 21675: @1564505
     /* 1564505 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1564587), // Rule ID 21097 //
     /* 1564510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564549 */     // MIs[0] round
     /* 1564549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564552 */     // MIs[0] policy
     /* 1564552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564562 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1564565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564586 */     // GIR_Coverage, 21097,
     /* 1564586 */     GIR_EraseRootFromParent_Done,
     /* 1564587 */   // Label 21676: @1564587
     /* 1564587 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1564669), // Rule ID 21100 //
     /* 1564592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564631 */     // MIs[0] round
     /* 1564631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564634 */     // MIs[0] policy
     /* 1564634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1564647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564668 */     // GIR_Coverage, 21100,
     /* 1564668 */     GIR_EraseRootFromParent_Done,
     /* 1564669 */   // Label 21677: @1564669
     /* 1564669 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1564751), // Rule ID 21101 //
     /* 1564674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564713 */     // MIs[0] round
     /* 1564713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564716 */     // MIs[0] policy
     /* 1564716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564726 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1564729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564750 */     // GIR_Coverage, 21101,
     /* 1564750 */     GIR_EraseRootFromParent_Done,
     /* 1564751 */   // Label 21678: @1564751
     /* 1564751 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1564833), // Rule ID 21176 //
     /* 1564756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1564764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564795 */     // MIs[0] round
     /* 1564795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564798 */     // MIs[0] policy
     /* 1564798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1564811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564832 */     // GIR_Coverage, 21176,
     /* 1564832 */     GIR_EraseRootFromParent_Done,
     /* 1564833 */   // Label 21679: @1564833
     /* 1564833 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1564915), // Rule ID 21177 //
     /* 1564838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1564846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564877 */     // MIs[0] round
     /* 1564877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564880 */     // MIs[0] policy
     /* 1564880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1564893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564914 */     // GIR_Coverage, 21177,
     /* 1564914 */     GIR_EraseRootFromParent_Done,
     /* 1564915 */   // Label 21680: @1564915
     /* 1564915 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1564997), // Rule ID 21180 //
     /* 1564920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1564928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1564931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1564934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564959 */     // MIs[0] round
     /* 1564959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564962 */     // MIs[0] policy
     /* 1564962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1564975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564996 */     // GIR_Coverage, 21180,
     /* 1564996 */     GIR_EraseRootFromParent_Done,
     /* 1564997 */   // Label 21681: @1564997
     /* 1564997 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1565079), // Rule ID 21181 //
     /* 1565002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565041 */     // MIs[0] round
     /* 1565041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565044 */     // MIs[0] policy
     /* 1565044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1565057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565078 */     // GIR_Coverage, 21181,
     /* 1565078 */     GIR_EraseRootFromParent_Done,
     /* 1565079 */   // Label 21682: @1565079
     /* 1565079 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1565161), // Rule ID 21184 //
     /* 1565084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1565095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1565098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565123 */     // MIs[0] round
     /* 1565123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565126 */     // MIs[0] policy
     /* 1565126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1565139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565160 */     // GIR_Coverage, 21184,
     /* 1565160 */     GIR_EraseRootFromParent_Done,
     /* 1565161 */   // Label 21683: @1565161
     /* 1565161 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1565243), // Rule ID 21185 //
     /* 1565166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1565177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1565180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565205 */     // MIs[0] round
     /* 1565205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565208 */     // MIs[0] policy
     /* 1565208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1565221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565242 */     // GIR_Coverage, 21185,
     /* 1565242 */     GIR_EraseRootFromParent_Done,
     /* 1565243 */   // Label 21684: @1565243
     /* 1565243 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1565325), // Rule ID 21188 //
     /* 1565248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565287 */     // MIs[0] round
     /* 1565287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565290 */     // MIs[0] policy
     /* 1565290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1565303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565324 */     // GIR_Coverage, 21188,
     /* 1565324 */     GIR_EraseRootFromParent_Done,
     /* 1565325 */   // Label 21685: @1565325
     /* 1565325 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1565407), // Rule ID 21189 //
     /* 1565330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565369 */     // MIs[0] round
     /* 1565369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565372 */     // MIs[0] policy
     /* 1565372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1565385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565406 */     // GIR_Coverage, 21189,
     /* 1565406 */     GIR_EraseRootFromParent_Done,
     /* 1565407 */   // Label 21686: @1565407
     /* 1565407 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1565489), // Rule ID 21192 //
     /* 1565412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1565423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1565426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565451 */     // MIs[0] round
     /* 1565451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565454 */     // MIs[0] policy
     /* 1565454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1565467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565488 */     // GIR_Coverage, 21192,
     /* 1565488 */     GIR_EraseRootFromParent_Done,
     /* 1565489 */   // Label 21687: @1565489
     /* 1565489 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1565571), // Rule ID 21193 //
     /* 1565494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1565505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1565508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565533 */     // MIs[0] round
     /* 1565533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565536 */     // MIs[0] policy
     /* 1565536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1565549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565570 */     // GIR_Coverage, 21193,
     /* 1565570 */     GIR_EraseRootFromParent_Done,
     /* 1565571 */   // Label 21688: @1565571
     /* 1565571 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1565653), // Rule ID 21196 //
     /* 1565576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1565579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565615 */     // MIs[0] round
     /* 1565615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565618 */     // MIs[0] policy
     /* 1565618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1565631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565652 */     // GIR_Coverage, 21196,
     /* 1565652 */     GIR_EraseRootFromParent_Done,
     /* 1565653 */   // Label 21689: @1565653
     /* 1565653 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1565735), // Rule ID 21197 //
     /* 1565658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1565661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1565675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565697 */     // MIs[0] round
     /* 1565697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565700 */     // MIs[0] policy
     /* 1565700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565710 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1565713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565734 */     // GIR_Coverage, 21197,
     /* 1565734 */     GIR_EraseRootFromParent_Done,
     /* 1565735 */   // Label 21690: @1565735
     /* 1565735 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1565817), // Rule ID 21200 //
     /* 1565740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1565743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1565751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1565754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565779 */     // MIs[0] round
     /* 1565779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565782 */     // MIs[0] policy
     /* 1565782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1565795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565816 */     // GIR_Coverage, 21200,
     /* 1565816 */     GIR_EraseRootFromParent_Done,
     /* 1565817 */   // Label 21691: @1565817
     /* 1565817 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1565899), // Rule ID 21201 //
     /* 1565822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1565825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1565833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1565836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565861 */     // MIs[0] round
     /* 1565861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565864 */     // MIs[0] policy
     /* 1565864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1565877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565898 */     // GIR_Coverage, 21201,
     /* 1565898 */     GIR_EraseRootFromParent_Done,
     /* 1565899 */   // Label 21692: @1565899
     /* 1565899 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1565981), // Rule ID 21204 //
     /* 1565904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1565907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1565915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1565918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1565921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565943 */     // MIs[0] round
     /* 1565943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565946 */     // MIs[0] policy
     /* 1565946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1565959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565980 */     // GIR_Coverage, 21204,
     /* 1565980 */     GIR_EraseRootFromParent_Done,
     /* 1565981 */   // Label 21693: @1565981
     /* 1565981 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1566063), // Rule ID 21205 //
     /* 1565986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1565989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1565994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1565997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1566000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566025 */     // MIs[0] round
     /* 1566025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566028 */     // MIs[0] policy
     /* 1566028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1566041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566062 */     // GIR_Coverage, 21205,
     /* 1566062 */     GIR_EraseRootFromParent_Done,
     /* 1566063 */   // Label 21694: @1566063
     /* 1566063 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1566145), // Rule ID 21208 //
     /* 1566068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1566071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1566076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566107 */     // MIs[0] round
     /* 1566107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566110 */     // MIs[0] policy
     /* 1566110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1566123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566144 */     // GIR_Coverage, 21208,
     /* 1566144 */     GIR_EraseRootFromParent_Done,
     /* 1566145 */   // Label 21695: @1566145
     /* 1566145 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1566227), // Rule ID 21209 //
     /* 1566150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1566153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1566158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566189 */     // MIs[0] round
     /* 1566189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566192 */     // MIs[0] policy
     /* 1566192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1566205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566226 */     // GIR_Coverage, 21209,
     /* 1566226 */     GIR_EraseRootFromParent_Done,
     /* 1566227 */   // Label 21696: @1566227
     /* 1566227 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1566309), // Rule ID 21212 //
     /* 1566232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1566243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1566246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1566249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566271 */     // MIs[0] round
     /* 1566271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566274 */     // MIs[0] policy
     /* 1566274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1566287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566308 */     // GIR_Coverage, 21212,
     /* 1566308 */     GIR_EraseRootFromParent_Done,
     /* 1566309 */   // Label 21697: @1566309
     /* 1566309 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1566391), // Rule ID 21213 //
     /* 1566314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1566325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1566328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1566331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566353 */     // MIs[0] round
     /* 1566353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566356 */     // MIs[0] policy
     /* 1566356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1566369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566390 */     // GIR_Coverage, 21213,
     /* 1566390 */     GIR_EraseRootFromParent_Done,
     /* 1566391 */   // Label 21698: @1566391
     /* 1566391 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1566473), // Rule ID 21216 //
     /* 1566396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1566407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1566410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1566413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566435 */     // MIs[0] round
     /* 1566435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566438 */     // MIs[0] policy
     /* 1566438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1566451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566472 */     // GIR_Coverage, 21216,
     /* 1566472 */     GIR_EraseRootFromParent_Done,
     /* 1566473 */   // Label 21699: @1566473
     /* 1566473 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1566555), // Rule ID 21217 //
     /* 1566478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1566489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1566492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1566495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566517 */     // MIs[0] round
     /* 1566517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566520 */     // MIs[0] policy
     /* 1566520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1566533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566554 */     // GIR_Coverage, 21217,
     /* 1566554 */     GIR_EraseRootFromParent_Done,
     /* 1566555 */   // Label 21700: @1566555
     /* 1566555 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1566637), // Rule ID 21220 //
     /* 1566560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566599 */     // MIs[0] round
     /* 1566599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566602 */     // MIs[0] policy
     /* 1566602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1566615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566636 */     // GIR_Coverage, 21220,
     /* 1566636 */     GIR_EraseRootFromParent_Done,
     /* 1566637 */   // Label 21701: @1566637
     /* 1566637 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1566719), // Rule ID 21221 //
     /* 1566642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566681 */     // MIs[0] round
     /* 1566681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566684 */     // MIs[0] policy
     /* 1566684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1566697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566718 */     // GIR_Coverage, 21221,
     /* 1566718 */     GIR_EraseRootFromParent_Done,
     /* 1566719 */   // Label 21702: @1566719
     /* 1566719 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1566801), // Rule ID 21224 //
     /* 1566724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566763 */     // MIs[0] round
     /* 1566763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566766 */     // MIs[0] policy
     /* 1566766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1566779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566800 */     // GIR_Coverage, 21224,
     /* 1566800 */     GIR_EraseRootFromParent_Done,
     /* 1566801 */   // Label 21703: @1566801
     /* 1566801 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1566883), // Rule ID 21225 //
     /* 1566806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566845 */     // MIs[0] round
     /* 1566845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566848 */     // MIs[0] policy
     /* 1566848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1566861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566882 */     // GIR_Coverage, 21225,
     /* 1566882 */     GIR_EraseRootFromParent_Done,
     /* 1566883 */   // Label 21704: @1566883
     /* 1566883 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1566965), // Rule ID 21228 //
     /* 1566888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566927 */     // MIs[0] round
     /* 1566927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566930 */     // MIs[0] policy
     /* 1566930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1566943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566964 */     // GIR_Coverage, 21228,
     /* 1566964 */     GIR_EraseRootFromParent_Done,
     /* 1566965 */   // Label 21705: @1566965
     /* 1566965 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1567047), // Rule ID 21229 //
     /* 1566970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1566978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567009 */     // MIs[0] round
     /* 1567009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567012 */     // MIs[0] policy
     /* 1567012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1567025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567046 */     // GIR_Coverage, 21229,
     /* 1567046 */     GIR_EraseRootFromParent_Done,
     /* 1567047 */   // Label 21706: @1567047
     /* 1567047 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1567129), // Rule ID 21232 //
     /* 1567052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567091 */     // MIs[0] round
     /* 1567091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567094 */     // MIs[0] policy
     /* 1567094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1567107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567128 */     // GIR_Coverage, 21232,
     /* 1567128 */     GIR_EraseRootFromParent_Done,
     /* 1567129 */   // Label 21707: @1567129
     /* 1567129 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1567211), // Rule ID 21233 //
     /* 1567134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567173 */     // MIs[0] round
     /* 1567173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567176 */     // MIs[0] policy
     /* 1567176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1567189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567210 */     // GIR_Coverage, 21233,
     /* 1567210 */     GIR_EraseRootFromParent_Done,
     /* 1567211 */   // Label 21708: @1567211
     /* 1567211 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1567293), // Rule ID 21236 //
     /* 1567216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1567233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567255 */     // MIs[0] round
     /* 1567255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567258 */     // MIs[0] policy
     /* 1567258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1567271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567292 */     // GIR_Coverage, 21236,
     /* 1567292 */     GIR_EraseRootFromParent_Done,
     /* 1567293 */   // Label 21709: @1567293
     /* 1567293 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1567375), // Rule ID 21237 //
     /* 1567298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1567315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567337 */     // MIs[0] round
     /* 1567337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567340 */     // MIs[0] policy
     /* 1567340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1567353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567374 */     // GIR_Coverage, 21237,
     /* 1567374 */     GIR_EraseRootFromParent_Done,
     /* 1567375 */   // Label 21710: @1567375
     /* 1567375 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1567457), // Rule ID 21240 //
     /* 1567380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567419 */     // MIs[0] round
     /* 1567419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567422 */     // MIs[0] policy
     /* 1567422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1567435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567456 */     // GIR_Coverage, 21240,
     /* 1567456 */     GIR_EraseRootFromParent_Done,
     /* 1567457 */   // Label 21711: @1567457
     /* 1567457 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1567539), // Rule ID 21241 //
     /* 1567462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1567473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1567476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567501 */     // MIs[0] round
     /* 1567501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567504 */     // MIs[0] policy
     /* 1567504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567514 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1567517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567538 */     // GIR_Coverage, 21241,
     /* 1567538 */     GIR_EraseRootFromParent_Done,
     /* 1567539 */   // Label 21712: @1567539
     /* 1567539 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1567621), // Rule ID 21244 //
     /* 1567544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567583 */     // MIs[0] round
     /* 1567583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567586 */     // MIs[0] policy
     /* 1567586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1567599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567620 */     // GIR_Coverage, 21244,
     /* 1567620 */     GIR_EraseRootFromParent_Done,
     /* 1567621 */   // Label 21713: @1567621
     /* 1567621 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1567703), // Rule ID 21245 //
     /* 1567626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1567634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1567637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1567640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567665 */     // MIs[0] round
     /* 1567665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567668 */     // MIs[0] policy
     /* 1567668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11233:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1567681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567702 */     // GIR_Coverage, 21245,
     /* 1567702 */     GIR_EraseRootFromParent_Done,
     /* 1567703 */   // Label 21714: @1567703
     /* 1567703 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1567785), // Rule ID 21596 //
     /* 1567708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1567716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1567719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1567722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567747 */     // MIs[0] round
     /* 1567747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567750 */     // MIs[0] policy
     /* 1567750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1567763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1567781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567784 */     // GIR_Coverage, 21596,
     /* 1567784 */     GIR_EraseRootFromParent_Done,
     /* 1567785 */   // Label 21715: @1567785
     /* 1567785 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1567867), // Rule ID 21597 //
     /* 1567790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1567798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1567801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1567804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567829 */     // MIs[0] round
     /* 1567829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567832 */     // MIs[0] policy
     /* 1567832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1567845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1567863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567866 */     // GIR_Coverage, 21597,
     /* 1567866 */     GIR_EraseRootFromParent_Done,
     /* 1567867 */   // Label 21716: @1567867
     /* 1567867 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1567949), // Rule ID 21600 //
     /* 1567872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1567880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1567883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1567886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567911 */     // MIs[0] round
     /* 1567911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567914 */     // MIs[0] policy
     /* 1567914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1567927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1567945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567948 */     // GIR_Coverage, 21600,
     /* 1567948 */     GIR_EraseRootFromParent_Done,
     /* 1567949 */   // Label 21717: @1567949
     /* 1567949 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1568031), // Rule ID 21601 //
     /* 1567954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1567962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1567965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1567968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567993 */     // MIs[0] round
     /* 1567993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567996 */     // MIs[0] policy
     /* 1567996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568006 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1568009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568030 */     // GIR_Coverage, 21601,
     /* 1568030 */     GIR_EraseRootFromParent_Done,
     /* 1568031 */   // Label 21718: @1568031
     /* 1568031 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1568113), // Rule ID 21604 //
     /* 1568036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1568047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1568050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568075 */     // MIs[0] round
     /* 1568075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568078 */     // MIs[0] policy
     /* 1568078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568088 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1568091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568112 */     // GIR_Coverage, 21604,
     /* 1568112 */     GIR_EraseRootFromParent_Done,
     /* 1568113 */   // Label 21719: @1568113
     /* 1568113 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1568195), // Rule ID 21605 //
     /* 1568118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1568129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1568132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568157 */     // MIs[0] round
     /* 1568157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568160 */     // MIs[0] policy
     /* 1568160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568170 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1568173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568194 */     // GIR_Coverage, 21605,
     /* 1568194 */     GIR_EraseRootFromParent_Done,
     /* 1568195 */   // Label 21720: @1568195
     /* 1568195 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1568277), // Rule ID 21608 //
     /* 1568200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1568211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1568214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568239 */     // MIs[0] round
     /* 1568239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568242 */     // MIs[0] policy
     /* 1568242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1568255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568276 */     // GIR_Coverage, 21608,
     /* 1568276 */     GIR_EraseRootFromParent_Done,
     /* 1568277 */   // Label 21721: @1568277
     /* 1568277 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1568359), // Rule ID 21609 //
     /* 1568282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1568293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1568296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568321 */     // MIs[0] round
     /* 1568321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568324 */     // MIs[0] policy
     /* 1568324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1568337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568358 */     // GIR_Coverage, 21609,
     /* 1568358 */     GIR_EraseRootFromParent_Done,
     /* 1568359 */   // Label 21722: @1568359
     /* 1568359 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1568441), // Rule ID 21612 //
     /* 1568364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1568375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1568378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568403 */     // MIs[0] round
     /* 1568403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568406 */     // MIs[0] policy
     /* 1568406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1568419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568440 */     // GIR_Coverage, 21612,
     /* 1568440 */     GIR_EraseRootFromParent_Done,
     /* 1568441 */   // Label 21723: @1568441
     /* 1568441 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1568523), // Rule ID 21613 //
     /* 1568446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1568457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1568460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1568463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568485 */     // MIs[0] round
     /* 1568485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568488 */     // MIs[0] policy
     /* 1568488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568498 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1568501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568522 */     // GIR_Coverage, 21613,
     /* 1568522 */     GIR_EraseRootFromParent_Done,
     /* 1568523 */   // Label 21724: @1568523
     /* 1568523 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1568605), // Rule ID 21616 //
     /* 1568528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1568539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1568542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1568545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1568548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568567 */     // MIs[0] round
     /* 1568567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568570 */     // MIs[0] policy
     /* 1568570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568580 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1568583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568604 */     // GIR_Coverage, 21616,
     /* 1568604 */     GIR_EraseRootFromParent_Done,
     /* 1568605 */   // Label 21725: @1568605
     /* 1568605 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1568687), // Rule ID 21617 //
     /* 1568610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1568621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1568624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1568627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1568630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568649 */     // MIs[0] round
     /* 1568649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568652 */     // MIs[0] policy
     /* 1568652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1568665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1568683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568686 */     // GIR_Coverage, 21617,
     /* 1568686 */     GIR_EraseRootFromParent_Done,
     /* 1568687 */   // Label 21726: @1568687
     /* 1568687 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1568769), // Rule ID 21620 //
     /* 1568692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1568695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568731 */     // MIs[0] round
     /* 1568731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568734 */     // MIs[0] policy
     /* 1568734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1568747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568768 */     // GIR_Coverage, 21620,
     /* 1568768 */     GIR_EraseRootFromParent_Done,
     /* 1568769 */   // Label 21727: @1568769
     /* 1568769 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1568851), // Rule ID 21621 //
     /* 1568774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1568777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568813 */     // MIs[0] round
     /* 1568813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568816 */     // MIs[0] policy
     /* 1568816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1568829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568850 */     // GIR_Coverage, 21621,
     /* 1568850 */     GIR_EraseRootFromParent_Done,
     /* 1568851 */   // Label 21728: @1568851
     /* 1568851 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1568933), // Rule ID 21624 //
     /* 1568856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1568859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568895 */     // MIs[0] round
     /* 1568895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568898 */     // MIs[0] policy
     /* 1568898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568908 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1568911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568932 */     // GIR_Coverage, 21624,
     /* 1568932 */     GIR_EraseRootFromParent_Done,
     /* 1568933 */   // Label 21729: @1568933
     /* 1568933 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1569015), // Rule ID 21625 //
     /* 1568938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1568941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1568946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568977 */     // MIs[0] round
     /* 1568977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568980 */     // MIs[0] policy
     /* 1568980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1568993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569014 */     // GIR_Coverage, 21625,
     /* 1569014 */     GIR_EraseRootFromParent_Done,
     /* 1569015 */   // Label 21730: @1569015
     /* 1569015 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1569097), // Rule ID 21628 //
     /* 1569020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1569023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1569031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1569034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569059 */     // MIs[0] round
     /* 1569059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569062 */     // MIs[0] policy
     /* 1569062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1569075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569096 */     // GIR_Coverage, 21628,
     /* 1569096 */     GIR_EraseRootFromParent_Done,
     /* 1569097 */   // Label 21731: @1569097
     /* 1569097 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1569179), // Rule ID 21629 //
     /* 1569102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1569105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1569113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1569116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569141 */     // MIs[0] round
     /* 1569141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569144 */     // MIs[0] policy
     /* 1569144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1569157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569178 */     // GIR_Coverage, 21629,
     /* 1569178 */     GIR_EraseRootFromParent_Done,
     /* 1569179 */   // Label 21732: @1569179
     /* 1569179 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1569261), // Rule ID 21632 //
     /* 1569184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1569187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1569195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1569198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569223 */     // MIs[0] round
     /* 1569223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569226 */     // MIs[0] policy
     /* 1569226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1569239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569260 */     // GIR_Coverage, 21632,
     /* 1569260 */     GIR_EraseRootFromParent_Done,
     /* 1569261 */   // Label 21733: @1569261
     /* 1569261 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1569343), // Rule ID 21633 //
     /* 1569266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1569269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1569277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1569280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569305 */     // MIs[0] round
     /* 1569305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569308 */     // MIs[0] policy
     /* 1569308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1569321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569342 */     // GIR_Coverage, 21633,
     /* 1569342 */     GIR_EraseRootFromParent_Done,
     /* 1569343 */   // Label 21734: @1569343
     /* 1569343 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1569425), // Rule ID 21636 //
     /* 1569348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1569351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1569359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1569362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1569365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569387 */     // MIs[0] round
     /* 1569387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569390 */     // MIs[0] policy
     /* 1569390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1569403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569424 */     // GIR_Coverage, 21636,
     /* 1569424 */     GIR_EraseRootFromParent_Done,
     /* 1569425 */   // Label 21735: @1569425
     /* 1569425 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1569507), // Rule ID 21637 //
     /* 1569430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1569433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1569441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1569444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1569447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569469 */     // MIs[0] round
     /* 1569469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569472 */     // MIs[0] policy
     /* 1569472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1569485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569506 */     // GIR_Coverage, 21637,
     /* 1569506 */     GIR_EraseRootFromParent_Done,
     /* 1569507 */   // Label 21736: @1569507
     /* 1569507 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1569589), // Rule ID 21640 //
     /* 1569512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1569515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569551 */     // MIs[0] round
     /* 1569551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569554 */     // MIs[0] policy
     /* 1569554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1569567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569588 */     // GIR_Coverage, 21640,
     /* 1569588 */     GIR_EraseRootFromParent_Done,
     /* 1569589 */   // Label 21737: @1569589
     /* 1569589 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1569671), // Rule ID 21641 //
     /* 1569594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1569597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569633 */     // MIs[0] round
     /* 1569633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569636 */     // MIs[0] policy
     /* 1569636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1569649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569670 */     // GIR_Coverage, 21641,
     /* 1569670 */     GIR_EraseRootFromParent_Done,
     /* 1569671 */   // Label 21738: @1569671
     /* 1569671 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1569753), // Rule ID 21644 //
     /* 1569676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1569679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1569693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569715 */     // MIs[0] round
     /* 1569715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569718 */     // MIs[0] policy
     /* 1569718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1569731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569752 */     // GIR_Coverage, 21644,
     /* 1569752 */     GIR_EraseRootFromParent_Done,
     /* 1569753 */   // Label 21739: @1569753
     /* 1569753 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1569835), // Rule ID 21645 //
     /* 1569758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1569761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1569775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569797 */     // MIs[0] round
     /* 1569797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569800 */     // MIs[0] policy
     /* 1569800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1569813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569834 */     // GIR_Coverage, 21645,
     /* 1569834 */     GIR_EraseRootFromParent_Done,
     /* 1569835 */   // Label 21740: @1569835
     /* 1569835 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1569917), // Rule ID 21648 //
     /* 1569840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1569843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1569857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569879 */     // MIs[0] round
     /* 1569879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569882 */     // MIs[0] policy
     /* 1569882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1569895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569916 */     // GIR_Coverage, 21648,
     /* 1569916 */     GIR_EraseRootFromParent_Done,
     /* 1569917 */   // Label 21741: @1569917
     /* 1569917 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1569999), // Rule ID 21649 //
     /* 1569922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1569925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1569939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569961 */     // MIs[0] round
     /* 1569961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569964 */     // MIs[0] policy
     /* 1569964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1569977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569998 */     // GIR_Coverage, 21649,
     /* 1569998 */     GIR_EraseRootFromParent_Done,
     /* 1569999 */   // Label 21742: @1569999
     /* 1569999 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1570081), // Rule ID 21652 //
     /* 1570004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1570007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1570021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570043 */     // MIs[0] round
     /* 1570043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570046 */     // MIs[0] policy
     /* 1570046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570080 */     // GIR_Coverage, 21652,
     /* 1570080 */     GIR_EraseRootFromParent_Done,
     /* 1570081 */   // Label 21743: @1570081
     /* 1570081 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1570163), // Rule ID 21653 //
     /* 1570086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1570089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1570097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1570100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1570103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570125 */     // MIs[0] round
     /* 1570125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570128 */     // MIs[0] policy
     /* 1570128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570162 */     // GIR_Coverage, 21653,
     /* 1570162 */     GIR_EraseRootFromParent_Done,
     /* 1570163 */   // Label 21744: @1570163
     /* 1570163 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1570245), // Rule ID 21656 //
     /* 1570168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570207 */     // MIs[0] round
     /* 1570207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570210 */     // MIs[0] policy
     /* 1570210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570220 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1570223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570244 */     // GIR_Coverage, 21656,
     /* 1570244 */     GIR_EraseRootFromParent_Done,
     /* 1570245 */   // Label 21745: @1570245
     /* 1570245 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1570327), // Rule ID 21657 //
     /* 1570250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570289 */     // MIs[0] round
     /* 1570289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570292 */     // MIs[0] policy
     /* 1570292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1570305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570326 */     // GIR_Coverage, 21657,
     /* 1570326 */     GIR_EraseRootFromParent_Done,
     /* 1570327 */   // Label 21746: @1570327
     /* 1570327 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1570409), // Rule ID 21660 //
     /* 1570332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570371 */     // MIs[0] round
     /* 1570371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570374 */     // MIs[0] policy
     /* 1570374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1570387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570408 */     // GIR_Coverage, 21660,
     /* 1570408 */     GIR_EraseRootFromParent_Done,
     /* 1570409 */   // Label 21747: @1570409
     /* 1570409 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1570491), // Rule ID 21661 //
     /* 1570414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570453 */     // MIs[0] round
     /* 1570453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570456 */     // MIs[0] policy
     /* 1570456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1570469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570490 */     // GIR_Coverage, 21661,
     /* 1570490 */     GIR_EraseRootFromParent_Done,
     /* 1570491 */   // Label 21748: @1570491
     /* 1570491 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1570573), // Rule ID 21664 //
     /* 1570496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570535 */     // MIs[0] round
     /* 1570535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570538 */     // MIs[0] policy
     /* 1570538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570548 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1570551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570572 */     // GIR_Coverage, 21664,
     /* 1570572 */     GIR_EraseRootFromParent_Done,
     /* 1570573 */   // Label 21749: @1570573
     /* 1570573 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1570655), // Rule ID 21665 //
     /* 1570578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570617 */     // MIs[0] round
     /* 1570617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570620 */     // MIs[0] policy
     /* 1570620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570630 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1570633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570654 */     // GIR_Coverage, 21665,
     /* 1570654 */     GIR_EraseRootFromParent_Done,
     /* 1570655 */   // Label 21750: @1570655
     /* 1570655 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1570737), // Rule ID 21668 //
     /* 1570660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570699 */     // MIs[0] round
     /* 1570699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570702 */     // MIs[0] policy
     /* 1570702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1570715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570736 */     // GIR_Coverage, 21668,
     /* 1570736 */     GIR_EraseRootFromParent_Done,
     /* 1570737 */   // Label 21751: @1570737
     /* 1570737 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1570819), // Rule ID 21669 //
     /* 1570742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570781 */     // MIs[0] round
     /* 1570781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570784 */     // MIs[0] policy
     /* 1570784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1570797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570818 */     // GIR_Coverage, 21669,
     /* 1570818 */     GIR_EraseRootFromParent_Done,
     /* 1570819 */   // Label 21752: @1570819
     /* 1570819 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1570901), // Rule ID 21672 //
     /* 1570824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570863 */     // MIs[0] round
     /* 1570863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570866 */     // MIs[0] policy
     /* 1570866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1570879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570900 */     // GIR_Coverage, 21672,
     /* 1570900 */     GIR_EraseRootFromParent_Done,
     /* 1570901 */   // Label 21753: @1570901
     /* 1570901 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1570983), // Rule ID 21673 //
     /* 1570906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570945 */     // MIs[0] round
     /* 1570945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570948 */     // MIs[0] policy
     /* 1570948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1570961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570982 */     // GIR_Coverage, 21673,
     /* 1570982 */     GIR_EraseRootFromParent_Done,
     /* 1570983 */   // Label 21754: @1570983
     /* 1570983 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1571065), // Rule ID 21676 //
     /* 1570988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1570996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1570999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571027 */     // MIs[0] round
     /* 1571027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571030 */     // MIs[0] policy
     /* 1571030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571040 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1571043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571064 */     // GIR_Coverage, 21676,
     /* 1571064 */     GIR_EraseRootFromParent_Done,
     /* 1571065 */   // Label 21755: @1571065
     /* 1571065 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1571147), // Rule ID 21677 //
     /* 1571070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1571073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1571081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1571084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1571087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1571090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571109 */     // MIs[0] round
     /* 1571109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571112 */     // MIs[0] policy
     /* 1571112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1571125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1571143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571146 */     // GIR_Coverage, 21677,
     /* 1571146 */     GIR_EraseRootFromParent_Done,
     /* 1571147 */   // Label 21756: @1571147
     /* 1571147 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1571229), // Rule ID 21680 //
     /* 1571152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571191 */     // MIs[0] round
     /* 1571191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571194 */     // MIs[0] policy
     /* 1571194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571204 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1571207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571228 */     // GIR_Coverage, 21680,
     /* 1571228 */     GIR_EraseRootFromParent_Done,
     /* 1571229 */   // Label 21757: @1571229
     /* 1571229 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1571311), // Rule ID 21681 //
     /* 1571234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571273 */     // MIs[0] round
     /* 1571273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571276 */     // MIs[0] policy
     /* 1571276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1571289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571310 */     // GIR_Coverage, 21681,
     /* 1571310 */     GIR_EraseRootFromParent_Done,
     /* 1571311 */   // Label 21758: @1571311
     /* 1571311 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1571393), // Rule ID 21684 //
     /* 1571316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571355 */     // MIs[0] round
     /* 1571355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571358 */     // MIs[0] policy
     /* 1571358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1571371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571392 */     // GIR_Coverage, 21684,
     /* 1571392 */     GIR_EraseRootFromParent_Done,
     /* 1571393 */   // Label 21759: @1571393
     /* 1571393 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1571475), // Rule ID 21685 //
     /* 1571398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571437 */     // MIs[0] round
     /* 1571437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571440 */     // MIs[0] policy
     /* 1571440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1571453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571474 */     // GIR_Coverage, 21685,
     /* 1571474 */     GIR_EraseRootFromParent_Done,
     /* 1571475 */   // Label 21760: @1571475
     /* 1571475 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1571557), // Rule ID 21688 //
     /* 1571480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571519 */     // MIs[0] round
     /* 1571519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571522 */     // MIs[0] policy
     /* 1571522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1571535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571556 */     // GIR_Coverage, 21688,
     /* 1571556 */     GIR_EraseRootFromParent_Done,
     /* 1571557 */   // Label 21761: @1571557
     /* 1571557 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1571639), // Rule ID 21689 //
     /* 1571562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571601 */     // MIs[0] round
     /* 1571601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571604 */     // MIs[0] policy
     /* 1571604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1571617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571638 */     // GIR_Coverage, 21689,
     /* 1571638 */     GIR_EraseRootFromParent_Done,
     /* 1571639 */   // Label 21762: @1571639
     /* 1571639 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1571721), // Rule ID 21692 //
     /* 1571644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571683 */     // MIs[0] round
     /* 1571683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571686 */     // MIs[0] policy
     /* 1571686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1571699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571720 */     // GIR_Coverage, 21692,
     /* 1571720 */     GIR_EraseRootFromParent_Done,
     /* 1571721 */   // Label 21763: @1571721
     /* 1571721 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1571803), // Rule ID 21693 //
     /* 1571726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571765 */     // MIs[0] round
     /* 1571765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571768 */     // MIs[0] policy
     /* 1571768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1571781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571802 */     // GIR_Coverage, 21693,
     /* 1571802 */     GIR_EraseRootFromParent_Done,
     /* 1571803 */   // Label 21764: @1571803
     /* 1571803 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1571885), // Rule ID 21696 //
     /* 1571808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571847 */     // MIs[0] round
     /* 1571847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571850 */     // MIs[0] policy
     /* 1571850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571860 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1571863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571884 */     // GIR_Coverage, 21696,
     /* 1571884 */     GIR_EraseRootFromParent_Done,
     /* 1571885 */   // Label 21765: @1571885
     /* 1571885 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1571967), // Rule ID 21697 //
     /* 1571890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571929 */     // MIs[0] round
     /* 1571929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571932 */     // MIs[0] policy
     /* 1571932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1571945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571966 */     // GIR_Coverage, 21697,
     /* 1571966 */     GIR_EraseRootFromParent_Done,
     /* 1571967 */   // Label 21766: @1571967
     /* 1571967 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1572049), // Rule ID 21700 //
     /* 1571972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1571975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1571980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572011 */     // MIs[0] round
     /* 1572011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572014 */     // MIs[0] policy
     /* 1572014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572048 */     // GIR_Coverage, 21700,
     /* 1572048 */     GIR_EraseRootFromParent_Done,
     /* 1572049 */   // Label 21767: @1572049
     /* 1572049 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1572131), // Rule ID 21701 //
     /* 1572054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1572065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1572068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1572071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572093 */     // MIs[0] round
     /* 1572093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572096 */     // MIs[0] policy
     /* 1572096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572130 */     // GIR_Coverage, 21701,
     /* 1572130 */     GIR_EraseRootFromParent_Done,
     /* 1572131 */   // Label 21768: @1572131
     /* 1572131 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1572213), // Rule ID 21704 //
     /* 1572136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572175 */     // MIs[0] round
     /* 1572175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572178 */     // MIs[0] policy
     /* 1572178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1572191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572212 */     // GIR_Coverage, 21704,
     /* 1572212 */     GIR_EraseRootFromParent_Done,
     /* 1572213 */   // Label 21769: @1572213
     /* 1572213 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1572295), // Rule ID 21705 //
     /* 1572218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572257 */     // MIs[0] round
     /* 1572257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572260 */     // MIs[0] policy
     /* 1572260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1572273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572294 */     // GIR_Coverage, 21705,
     /* 1572294 */     GIR_EraseRootFromParent_Done,
     /* 1572295 */   // Label 21770: @1572295
     /* 1572295 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1572377), // Rule ID 21708 //
     /* 1572300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572339 */     // MIs[0] round
     /* 1572339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572342 */     // MIs[0] policy
     /* 1572342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1572355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572376 */     // GIR_Coverage, 21708,
     /* 1572376 */     GIR_EraseRootFromParent_Done,
     /* 1572377 */   // Label 21771: @1572377
     /* 1572377 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1572459), // Rule ID 21709 //
     /* 1572382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572421 */     // MIs[0] round
     /* 1572421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572424 */     // MIs[0] policy
     /* 1572424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1572437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572458 */     // GIR_Coverage, 21709,
     /* 1572458 */     GIR_EraseRootFromParent_Done,
     /* 1572459 */   // Label 21772: @1572459
     /* 1572459 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1572541), // Rule ID 21712 //
     /* 1572464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572503 */     // MIs[0] round
     /* 1572503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572506 */     // MIs[0] policy
     /* 1572506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1572519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572540 */     // GIR_Coverage, 21712,
     /* 1572540 */     GIR_EraseRootFromParent_Done,
     /* 1572541 */   // Label 21773: @1572541
     /* 1572541 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1572623), // Rule ID 21713 //
     /* 1572546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572585 */     // MIs[0] round
     /* 1572585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572588 */     // MIs[0] policy
     /* 1572588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1572601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572622 */     // GIR_Coverage, 21713,
     /* 1572622 */     GIR_EraseRootFromParent_Done,
     /* 1572623 */   // Label 21774: @1572623
     /* 1572623 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1572705), // Rule ID 21836 //
     /* 1572628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1572636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1572645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572667 */     // MIs[0] round
     /* 1572667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572670 */     // MIs[0] policy
     /* 1572670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572680 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1572683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572704 */     // GIR_Coverage, 21836,
     /* 1572704 */     GIR_EraseRootFromParent_Done,
     /* 1572705 */   // Label 21775: @1572705
     /* 1572705 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1572787), // Rule ID 21837 //
     /* 1572710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1572718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1572727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572749 */     // MIs[0] round
     /* 1572749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572752 */     // MIs[0] policy
     /* 1572752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572762 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1572765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572786 */     // GIR_Coverage, 21837,
     /* 1572786 */     GIR_EraseRootFromParent_Done,
     /* 1572787 */   // Label 21776: @1572787
     /* 1572787 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1572869), // Rule ID 21840 //
     /* 1572792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1572800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1572809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572831 */     // MIs[0] round
     /* 1572831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572834 */     // MIs[0] policy
     /* 1572834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572844 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1572847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572868 */     // GIR_Coverage, 21840,
     /* 1572868 */     GIR_EraseRootFromParent_Done,
     /* 1572869 */   // Label 21777: @1572869
     /* 1572869 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1572951), // Rule ID 21841 //
     /* 1572874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1572882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1572891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572913 */     // MIs[0] round
     /* 1572913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572916 */     // MIs[0] policy
     /* 1572916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572926 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1572929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572950 */     // GIR_Coverage, 21841,
     /* 1572950 */     GIR_EraseRootFromParent_Done,
     /* 1572951 */   // Label 21778: @1572951
     /* 1572951 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1573033), // Rule ID 21844 //
     /* 1572956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1572964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1572967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1572970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1572973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572995 */     // MIs[0] round
     /* 1572995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572998 */     // MIs[0] policy
     /* 1572998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1573011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573032 */     // GIR_Coverage, 21844,
     /* 1573032 */     GIR_EraseRootFromParent_Done,
     /* 1573033 */   // Label 21779: @1573033
     /* 1573033 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1573115), // Rule ID 21845 //
     /* 1573038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573077 */     // MIs[0] round
     /* 1573077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573080 */     // MIs[0] policy
     /* 1573080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1573093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573114 */     // GIR_Coverage, 21845,
     /* 1573114 */     GIR_EraseRootFromParent_Done,
     /* 1573115 */   // Label 21780: @1573115
     /* 1573115 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1573197), // Rule ID 21848 //
     /* 1573120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573159 */     // MIs[0] round
     /* 1573159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573162 */     // MIs[0] policy
     /* 1573162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573172 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1573175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573196 */     // GIR_Coverage, 21848,
     /* 1573196 */     GIR_EraseRootFromParent_Done,
     /* 1573197 */   // Label 21781: @1573197
     /* 1573197 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1573279), // Rule ID 21849 //
     /* 1573202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573241 */     // MIs[0] round
     /* 1573241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573244 */     // MIs[0] policy
     /* 1573244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1573257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573278 */     // GIR_Coverage, 21849,
     /* 1573278 */     GIR_EraseRootFromParent_Done,
     /* 1573279 */   // Label 21782: @1573279
     /* 1573279 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1573361), // Rule ID 21852 //
     /* 1573284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1573295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1573298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1573301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573323 */     // MIs[0] round
     /* 1573323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573326 */     // MIs[0] policy
     /* 1573326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573336 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1573339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573360 */     // GIR_Coverage, 21852,
     /* 1573360 */     GIR_EraseRootFromParent_Done,
     /* 1573361 */   // Label 21783: @1573361
     /* 1573361 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1573443), // Rule ID 21853 //
     /* 1573366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1573377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1573380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1573383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573405 */     // MIs[0] round
     /* 1573405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573408 */     // MIs[0] policy
     /* 1573408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573418 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1573421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573442 */     // GIR_Coverage, 21853,
     /* 1573442 */     GIR_EraseRootFromParent_Done,
     /* 1573443 */   // Label 21784: @1573443
     /* 1573443 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1573525), // Rule ID 21856 //
     /* 1573448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1573459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1573462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1573465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573487 */     // MIs[0] round
     /* 1573487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573490 */     // MIs[0] policy
     /* 1573490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573500 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1573503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573524 */     // GIR_Coverage, 21856,
     /* 1573524 */     GIR_EraseRootFromParent_Done,
     /* 1573525 */   // Label 21785: @1573525
     /* 1573525 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1573607), // Rule ID 21857 //
     /* 1573530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1573541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1573544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1573547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573569 */     // MIs[0] round
     /* 1573569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573572 */     // MIs[0] policy
     /* 1573572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573582 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1573585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573606 */     // GIR_Coverage, 21857,
     /* 1573606 */     GIR_EraseRootFromParent_Done,
     /* 1573607 */   // Label 21786: @1573607
     /* 1573607 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1573689), // Rule ID 21860 //
     /* 1573612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1573629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573651 */     // MIs[0] round
     /* 1573651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573654 */     // MIs[0] policy
     /* 1573654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573664 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1573667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573688 */     // GIR_Coverage, 21860,
     /* 1573688 */     GIR_EraseRootFromParent_Done,
     /* 1573689 */   // Label 21787: @1573689
     /* 1573689 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1573771), // Rule ID 21861 //
     /* 1573694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1573711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573733 */     // MIs[0] round
     /* 1573733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573736 */     // MIs[0] policy
     /* 1573736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573746 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1573749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573770 */     // GIR_Coverage, 21861,
     /* 1573770 */     GIR_EraseRootFromParent_Done,
     /* 1573771 */   // Label 21788: @1573771
     /* 1573771 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1573853), // Rule ID 21864 //
     /* 1573776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1573787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1573790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1573793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573815 */     // MIs[0] round
     /* 1573815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573818 */     // MIs[0] policy
     /* 1573818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573828 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1573831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573852 */     // GIR_Coverage, 21864,
     /* 1573852 */     GIR_EraseRootFromParent_Done,
     /* 1573853 */   // Label 21789: @1573853
     /* 1573853 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1573935), // Rule ID 21865 //
     /* 1573858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1573861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1573869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1573872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1573875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573897 */     // MIs[0] round
     /* 1573897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573900 */     // MIs[0] policy
     /* 1573900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1573913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1573931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573934 */     // GIR_Coverage, 21865,
     /* 1573934 */     GIR_EraseRootFromParent_Done,
     /* 1573935 */   // Label 21790: @1573935
     /* 1573935 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1574017), // Rule ID 21868 //
     /* 1573940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1573943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1573948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1573951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1573954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1573957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573979 */     // MIs[0] round
     /* 1573979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573982 */     // MIs[0] policy
     /* 1573982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573992 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1573995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574016 */     // GIR_Coverage, 21868,
     /* 1574016 */     GIR_EraseRootFromParent_Done,
     /* 1574017 */   // Label 21791: @1574017
     /* 1574017 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1574099), // Rule ID 21869 //
     /* 1574022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1574025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1574030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1574039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574061 */     // MIs[0] round
     /* 1574061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574064 */     // MIs[0] policy
     /* 1574064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574074 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1574077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574098 */     // GIR_Coverage, 21869,
     /* 1574098 */     GIR_EraseRootFromParent_Done,
     /* 1574099 */   // Label 21792: @1574099
     /* 1574099 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1574181), // Rule ID 21872 //
     /* 1574104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574143 */     // MIs[0] round
     /* 1574143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574146 */     // MIs[0] policy
     /* 1574146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574156 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1574159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574180 */     // GIR_Coverage, 21872,
     /* 1574180 */     GIR_EraseRootFromParent_Done,
     /* 1574181 */   // Label 21793: @1574181
     /* 1574181 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1574263), // Rule ID 21873 //
     /* 1574186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574225 */     // MIs[0] round
     /* 1574225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574228 */     // MIs[0] policy
     /* 1574228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574238 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1574241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574262 */     // GIR_Coverage, 21873,
     /* 1574262 */     GIR_EraseRootFromParent_Done,
     /* 1574263 */   // Label 21794: @1574263
     /* 1574263 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1574345), // Rule ID 21876 //
     /* 1574268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574307 */     // MIs[0] round
     /* 1574307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574310 */     // MIs[0] policy
     /* 1574310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574320 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1574323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574344 */     // GIR_Coverage, 21876,
     /* 1574344 */     GIR_EraseRootFromParent_Done,
     /* 1574345 */   // Label 21795: @1574345
     /* 1574345 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1574427), // Rule ID 21877 //
     /* 1574350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1574361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1574364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1574367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574389 */     // MIs[0] round
     /* 1574389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574392 */     // MIs[0] policy
     /* 1574392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574402 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1574405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574426 */     // GIR_Coverage, 21877,
     /* 1574426 */     GIR_EraseRootFromParent_Done,
     /* 1574427 */   // Label 21796: @1574427
     /* 1574427 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1574509), // Rule ID 21880 //
     /* 1574432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574471 */     // MIs[0] round
     /* 1574471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574474 */     // MIs[0] policy
     /* 1574474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574484 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1574487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574508 */     // GIR_Coverage, 21880,
     /* 1574508 */     GIR_EraseRootFromParent_Done,
     /* 1574509 */   // Label 21797: @1574509
     /* 1574509 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1574591), // Rule ID 21881 //
     /* 1574514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1574525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1574528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1574531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574553 */     // MIs[0] round
     /* 1574553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574556 */     // MIs[0] policy
     /* 1574556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574566 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1574569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574590 */     // GIR_Coverage, 21881,
     /* 1574590 */     GIR_EraseRootFromParent_Done,
     /* 1574591 */   // Label 21798: @1574591
     /* 1574591 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1574673), // Rule ID 21884 //
     /* 1574596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574635 */     // MIs[0] round
     /* 1574635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574638 */     // MIs[0] policy
     /* 1574638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1574651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574672 */     // GIR_Coverage, 21884,
     /* 1574672 */     GIR_EraseRootFromParent_Done,
     /* 1574673 */   // Label 21799: @1574673
     /* 1574673 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1574755), // Rule ID 21885 //
     /* 1574678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1574689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1574692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1574695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574717 */     // MIs[0] round
     /* 1574717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574720 */     // MIs[0] policy
     /* 1574720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1574733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574754 */     // GIR_Coverage, 21885,
     /* 1574754 */     GIR_EraseRootFromParent_Done,
     /* 1574755 */   // Label 21800: @1574755
     /* 1574755 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1574837), // Rule ID 21888 //
     /* 1574760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574799 */     // MIs[0] round
     /* 1574799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574802 */     // MIs[0] policy
     /* 1574802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574812 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1574815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574836 */     // GIR_Coverage, 21888,
     /* 1574836 */     GIR_EraseRootFromParent_Done,
     /* 1574837 */   // Label 21801: @1574837
     /* 1574837 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1574919), // Rule ID 21889 //
     /* 1574842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574881 */     // MIs[0] round
     /* 1574881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574884 */     // MIs[0] policy
     /* 1574884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574894 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1574897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574918 */     // GIR_Coverage, 21889,
     /* 1574918 */     GIR_EraseRootFromParent_Done,
     /* 1574919 */   // Label 21802: @1574919
     /* 1574919 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1575001), // Rule ID 21892 //
     /* 1574924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1574927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1574932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574963 */     // MIs[0] round
     /* 1574963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574966 */     // MIs[0] policy
     /* 1574966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574976 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1574979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575000 */     // GIR_Coverage, 21892,
     /* 1575000 */     GIR_EraseRootFromParent_Done,
     /* 1575001 */   // Label 21803: @1575001
     /* 1575001 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1575083), // Rule ID 21893 //
     /* 1575006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575045 */     // MIs[0] round
     /* 1575045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575048 */     // MIs[0] policy
     /* 1575048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575058 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1575061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575082 */     // GIR_Coverage, 21893,
     /* 1575082 */     GIR_EraseRootFromParent_Done,
     /* 1575083 */   // Label 21804: @1575083
     /* 1575083 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1575165), // Rule ID 21896 //
     /* 1575088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575127 */     // MIs[0] round
     /* 1575127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575130 */     // MIs[0] policy
     /* 1575130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1575143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575164 */     // GIR_Coverage, 21896,
     /* 1575164 */     GIR_EraseRootFromParent_Done,
     /* 1575165 */   // Label 21805: @1575165
     /* 1575165 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1575247), // Rule ID 21897 //
     /* 1575170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575209 */     // MIs[0] round
     /* 1575209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575212 */     // MIs[0] policy
     /* 1575212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575222 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1575225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575246 */     // GIR_Coverage, 21897,
     /* 1575246 */     GIR_EraseRootFromParent_Done,
     /* 1575247 */   // Label 21806: @1575247
     /* 1575247 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1575329), // Rule ID 21900 //
     /* 1575252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575291 */     // MIs[0] round
     /* 1575291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575294 */     // MIs[0] policy
     /* 1575294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1575307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575328 */     // GIR_Coverage, 21900,
     /* 1575328 */     GIR_EraseRootFromParent_Done,
     /* 1575329 */   // Label 21807: @1575329
     /* 1575329 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1575411), // Rule ID 21901 //
     /* 1575334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575373 */     // MIs[0] round
     /* 1575373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575376 */     // MIs[0] policy
     /* 1575376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575386 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1575389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575410 */     // GIR_Coverage, 21901,
     /* 1575410 */     GIR_EraseRootFromParent_Done,
     /* 1575411 */   // Label 21808: @1575411
     /* 1575411 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1575493), // Rule ID 21904 //
     /* 1575416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575455 */     // MIs[0] round
     /* 1575455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575458 */     // MIs[0] policy
     /* 1575458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1575471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575492 */     // GIR_Coverage, 21904,
     /* 1575492 */     GIR_EraseRootFromParent_Done,
     /* 1575493 */   // Label 21809: @1575493
     /* 1575493 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1575575), // Rule ID 21905 //
     /* 1575498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1575506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1575509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1575512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1575515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575537 */     // MIs[0] round
     /* 1575537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575540 */     // MIs[0] policy
     /* 1575540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575550 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1575553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575574 */     // GIR_Coverage, 21905,
     /* 1575574 */     GIR_EraseRootFromParent_Done,
     /* 1575575 */   // Label 21810: @1575575
     /* 1575575 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1575657), // Rule ID 21908 //
     /* 1575580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1575583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575619 */     // MIs[0] round
     /* 1575619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575622 */     // MIs[0] policy
     /* 1575622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575632 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1575635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575656 */     // GIR_Coverage, 21908,
     /* 1575656 */     GIR_EraseRootFromParent_Done,
     /* 1575657 */   // Label 21811: @1575657
     /* 1575657 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1575739), // Rule ID 21909 //
     /* 1575662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1575665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575701 */     // MIs[0] round
     /* 1575701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575704 */     // MIs[0] policy
     /* 1575704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575714 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1575717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575738 */     // GIR_Coverage, 21909,
     /* 1575738 */     GIR_EraseRootFromParent_Done,
     /* 1575739 */   // Label 21812: @1575739
     /* 1575739 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1575821), // Rule ID 21912 //
     /* 1575744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1575747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575783 */     // MIs[0] round
     /* 1575783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575786 */     // MIs[0] policy
     /* 1575786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1575799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575820 */     // GIR_Coverage, 21912,
     /* 1575820 */     GIR_EraseRootFromParent_Done,
     /* 1575821 */   // Label 21813: @1575821
     /* 1575821 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1575903), // Rule ID 21913 //
     /* 1575826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1575829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575865 */     // MIs[0] round
     /* 1575865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575868 */     // MIs[0] policy
     /* 1575868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575878 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1575881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575902 */     // GIR_Coverage, 21913,
     /* 1575902 */     GIR_EraseRootFromParent_Done,
     /* 1575903 */   // Label 21814: @1575903
     /* 1575903 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1575985), // Rule ID 21916 //
     /* 1575908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1575911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1575919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1575922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1575925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575947 */     // MIs[0] round
     /* 1575947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575950 */     // MIs[0] policy
     /* 1575950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575960 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1575963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575984 */     // GIR_Coverage, 21916,
     /* 1575984 */     GIR_EraseRootFromParent_Done,
     /* 1575985 */   // Label 21815: @1575985
     /* 1575985 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1576067), // Rule ID 21917 //
     /* 1575990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1575993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1575998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576029 */     // MIs[0] round
     /* 1576029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576032 */     // MIs[0] policy
     /* 1576032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576042 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1576045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576066 */     // GIR_Coverage, 21917,
     /* 1576066 */     GIR_EraseRootFromParent_Done,
     /* 1576067 */   // Label 21816: @1576067
     /* 1576067 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1576149), // Rule ID 21920 //
     /* 1576072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1576075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576111 */     // MIs[0] round
     /* 1576111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576114 */     // MIs[0] policy
     /* 1576114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576124 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1576127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576148 */     // GIR_Coverage, 21920,
     /* 1576148 */     GIR_EraseRootFromParent_Done,
     /* 1576149 */   // Label 21817: @1576149
     /* 1576149 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1576231), // Rule ID 21921 //
     /* 1576154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1576157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576193 */     // MIs[0] round
     /* 1576193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576196 */     // MIs[0] policy
     /* 1576196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576206 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1576209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576230 */     // GIR_Coverage, 21921,
     /* 1576230 */     GIR_EraseRootFromParent_Done,
     /* 1576231 */   // Label 21818: @1576231
     /* 1576231 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1576313), // Rule ID 21924 //
     /* 1576236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1576239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576275 */     // MIs[0] round
     /* 1576275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576278 */     // MIs[0] policy
     /* 1576278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576288 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1576291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576312 */     // GIR_Coverage, 21924,
     /* 1576312 */     GIR_EraseRootFromParent_Done,
     /* 1576313 */   // Label 21819: @1576313
     /* 1576313 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1576395), // Rule ID 21925 //
     /* 1576318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1576321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576357 */     // MIs[0] round
     /* 1576357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576360 */     // MIs[0] policy
     /* 1576360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576370 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1576373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576394 */     // GIR_Coverage, 21925,
     /* 1576394 */     GIR_EraseRootFromParent_Done,
     /* 1576395 */   // Label 21820: @1576395
     /* 1576395 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1576477), // Rule ID 21928 //
     /* 1576400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1576403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576439 */     // MIs[0] round
     /* 1576439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576442 */     // MIs[0] policy
     /* 1576442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576452 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1576455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576476 */     // GIR_Coverage, 21928,
     /* 1576476 */     GIR_EraseRootFromParent_Done,
     /* 1576477 */   // Label 21821: @1576477
     /* 1576477 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1576559), // Rule ID 21929 //
     /* 1576482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1576485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576521 */     // MIs[0] round
     /* 1576521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576524 */     // MIs[0] policy
     /* 1576524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576534 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1576537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576558 */     // GIR_Coverage, 21929,
     /* 1576558 */     GIR_EraseRootFromParent_Done,
     /* 1576559 */   // Label 21822: @1576559
     /* 1576559 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1576641), // Rule ID 21932 //
     /* 1576564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1576567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576603 */     // MIs[0] round
     /* 1576603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576606 */     // MIs[0] policy
     /* 1576606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1576619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576640 */     // GIR_Coverage, 21932,
     /* 1576640 */     GIR_EraseRootFromParent_Done,
     /* 1576641 */   // Label 21823: @1576641
     /* 1576641 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1576723), // Rule ID 21933 //
     /* 1576646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1576649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576685 */     // MIs[0] round
     /* 1576685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576688 */     // MIs[0] policy
     /* 1576688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576698 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1576701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576722 */     // GIR_Coverage, 21933,
     /* 1576722 */     GIR_EraseRootFromParent_Done,
     /* 1576723 */   // Label 21824: @1576723
     /* 1576723 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1576805), // Rule ID 21936 //
     /* 1576728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1576731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576767 */     // MIs[0] round
     /* 1576767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576770 */     // MIs[0] policy
     /* 1576770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576780 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1576783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576804 */     // GIR_Coverage, 21936,
     /* 1576804 */     GIR_EraseRootFromParent_Done,
     /* 1576805 */   // Label 21825: @1576805
     /* 1576805 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1576887), // Rule ID 21937 //
     /* 1576810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1576813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576849 */     // MIs[0] round
     /* 1576849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576852 */     // MIs[0] policy
     /* 1576852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576862 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1576865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576886 */     // GIR_Coverage, 21937,
     /* 1576886 */     GIR_EraseRootFromParent_Done,
     /* 1576887 */   // Label 21826: @1576887
     /* 1576887 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1576969), // Rule ID 21940 //
     /* 1576892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1576895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1576903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1576906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576931 */     // MIs[0] round
     /* 1576931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576934 */     // MIs[0] policy
     /* 1576934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576944 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1576947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576968 */     // GIR_Coverage, 21940,
     /* 1576968 */     GIR_EraseRootFromParent_Done,
     /* 1576969 */   // Label 21827: @1576969
     /* 1576969 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1577051), // Rule ID 21941 //
     /* 1576974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1576977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1576982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1576985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1576988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1576991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1576994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577013 */     // MIs[0] round
     /* 1577013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577016 */     // MIs[0] policy
     /* 1577016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577026 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1577029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577050 */     // GIR_Coverage, 21941,
     /* 1577050 */     GIR_EraseRootFromParent_Done,
     /* 1577051 */   // Label 21828: @1577051
     /* 1577051 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1577133), // Rule ID 2750 //
     /* 1577056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1577073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577087 */     // MIs[0] passthru
     /* 1577087 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577100 */     // MIs[0] policy
     /* 1577100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1577113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577132 */     // GIR_Coverage, 2750,
     /* 1577132 */     GIR_EraseRootFromParent_Done,
     /* 1577133 */   // Label 21829: @1577133
     /* 1577133 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1577215), // Rule ID 2751 //
     /* 1577138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1577155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577169 */     // MIs[0] passthru
     /* 1577169 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577182 */     // MIs[0] policy
     /* 1577182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577192 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1577195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577214 */     // GIR_Coverage, 2751,
     /* 1577214 */     GIR_EraseRootFromParent_Done,
     /* 1577215 */   // Label 21830: @1577215
     /* 1577215 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1577297), // Rule ID 4066 //
     /* 1577220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1577237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577251 */     // MIs[0] passthru
     /* 1577251 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577264 */     // MIs[0] policy
     /* 1577264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577274 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1577277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577296 */     // GIR_Coverage, 4066,
     /* 1577296 */     GIR_EraseRootFromParent_Done,
     /* 1577297 */   // Label 21831: @1577297
     /* 1577297 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1577379), // Rule ID 4067 //
     /* 1577302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1577319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577333 */     // MIs[0] passthru
     /* 1577333 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577346 */     // MIs[0] policy
     /* 1577346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577356 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1577359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577378 */     // GIR_Coverage, 4067,
     /* 1577378 */     GIR_EraseRootFromParent_Done,
     /* 1577379 */   // Label 21832: @1577379
     /* 1577379 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1577461), // Rule ID 4076 //
     /* 1577384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1577401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1577404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577415 */     // MIs[0] passthru
     /* 1577415 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577428 */     // MIs[0] policy
     /* 1577428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1577441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577460 */     // GIR_Coverage, 4076,
     /* 1577460 */     GIR_EraseRootFromParent_Done,
     /* 1577461 */   // Label 21833: @1577461
     /* 1577461 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1577543), // Rule ID 4077 //
     /* 1577466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1577483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1577486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577497 */     // MIs[0] passthru
     /* 1577497 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577510 */     // MIs[0] policy
     /* 1577510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1577523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577542 */     // GIR_Coverage, 4077,
     /* 1577542 */     GIR_EraseRootFromParent_Done,
     /* 1577543 */   // Label 21834: @1577543
     /* 1577543 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1577625), // Rule ID 4086 //
     /* 1577548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1577565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577579 */     // MIs[0] passthru
     /* 1577579 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577592 */     // MIs[0] policy
     /* 1577592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1577605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577624 */     // GIR_Coverage, 4086,
     /* 1577624 */     GIR_EraseRootFromParent_Done,
     /* 1577625 */   // Label 21835: @1577625
     /* 1577625 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1577707), // Rule ID 4087 //
     /* 1577630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1577641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1577644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1577647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577661 */     // MIs[0] passthru
     /* 1577661 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577674 */     // MIs[0] policy
     /* 1577674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1577687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577706 */     // GIR_Coverage, 4087,
     /* 1577706 */     GIR_EraseRootFromParent_Done,
     /* 1577707 */   // Label 21836: @1577707
     /* 1577707 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1577789), // Rule ID 4096 //
     /* 1577712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1577729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1577732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577743 */     // MIs[0] passthru
     /* 1577743 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577756 */     // MIs[0] policy
     /* 1577756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1577769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577788 */     // GIR_Coverage, 4096,
     /* 1577788 */     GIR_EraseRootFromParent_Done,
     /* 1577789 */   // Label 21837: @1577789
     /* 1577789 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1577871), // Rule ID 4097 //
     /* 1577794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1577811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1577814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577825 */     // MIs[0] passthru
     /* 1577825 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577838 */     // MIs[0] policy
     /* 1577838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1577851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577870 */     // GIR_Coverage, 4097,
     /* 1577870 */     GIR_EraseRootFromParent_Done,
     /* 1577871 */   // Label 21838: @1577871
     /* 1577871 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1577953), // Rule ID 4106 //
     /* 1577876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1577887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1577890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1577893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1577896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577907 */     // MIs[0] passthru
     /* 1577907 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577920 */     // MIs[0] policy
     /* 1577920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577930 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1577933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577952 */     // GIR_Coverage, 4106,
     /* 1577952 */     GIR_EraseRootFromParent_Done,
     /* 1577953 */   // Label 21839: @1577953
     /* 1577953 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1578035), // Rule ID 4107 //
     /* 1577958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1577966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1577969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1577972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1577975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1577978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577989 */     // MIs[0] passthru
     /* 1577989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578002 */     // MIs[0] policy
     /* 1578002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578012 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1578015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578034 */     // GIR_Coverage, 4107,
     /* 1578034 */     GIR_EraseRootFromParent_Done,
     /* 1578035 */   // Label 21840: @1578035
     /* 1578035 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1578117), // Rule ID 4116 //
     /* 1578040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1578057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578071 */     // MIs[0] passthru
     /* 1578071 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578084 */     // MIs[0] policy
     /* 1578084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1578097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578116 */     // GIR_Coverage, 4116,
     /* 1578116 */     GIR_EraseRootFromParent_Done,
     /* 1578117 */   // Label 21841: @1578117
     /* 1578117 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1578199), // Rule ID 4117 //
     /* 1578122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1578139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578153 */     // MIs[0] passthru
     /* 1578153 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578166 */     // MIs[0] policy
     /* 1578166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578176 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1578179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578198 */     // GIR_Coverage, 4117,
     /* 1578198 */     GIR_EraseRootFromParent_Done,
     /* 1578199 */   // Label 21842: @1578199
     /* 1578199 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1578281), // Rule ID 4126 //
     /* 1578204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1578221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578235 */     // MIs[0] passthru
     /* 1578235 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578248 */     // MIs[0] policy
     /* 1578248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1578261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578280 */     // GIR_Coverage, 4126,
     /* 1578280 */     GIR_EraseRootFromParent_Done,
     /* 1578281 */   // Label 21843: @1578281
     /* 1578281 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1578363), // Rule ID 4127 //
     /* 1578286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1578303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578317 */     // MIs[0] passthru
     /* 1578317 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578330 */     // MIs[0] policy
     /* 1578330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1578343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578362 */     // GIR_Coverage, 4127,
     /* 1578362 */     GIR_EraseRootFromParent_Done,
     /* 1578363 */   // Label 21844: @1578363
     /* 1578363 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1578445), // Rule ID 4136 //
     /* 1578368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1578385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578399 */     // MIs[0] passthru
     /* 1578399 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578412 */     // MIs[0] policy
     /* 1578412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1578425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578444 */     // GIR_Coverage, 4136,
     /* 1578444 */     GIR_EraseRootFromParent_Done,
     /* 1578445 */   // Label 21845: @1578445
     /* 1578445 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1578527), // Rule ID 4137 //
     /* 1578450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1578467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578481 */     // MIs[0] passthru
     /* 1578481 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578494 */     // MIs[0] policy
     /* 1578494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1578507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578526 */     // GIR_Coverage, 4137,
     /* 1578526 */     GIR_EraseRootFromParent_Done,
     /* 1578527 */   // Label 21846: @1578527
     /* 1578527 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1578609), // Rule ID 4146 //
     /* 1578532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1578549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578563 */     // MIs[0] passthru
     /* 1578563 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578576 */     // MIs[0] policy
     /* 1578576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1578589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578608 */     // GIR_Coverage, 4146,
     /* 1578608 */     GIR_EraseRootFromParent_Done,
     /* 1578609 */   // Label 21847: @1578609
     /* 1578609 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1578691), // Rule ID 4147 //
     /* 1578614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1578625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1578628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1578631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578645 */     // MIs[0] passthru
     /* 1578645 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578658 */     // MIs[0] policy
     /* 1578658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1578671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578690 */     // GIR_Coverage, 4147,
     /* 1578690 */     GIR_EraseRootFromParent_Done,
     /* 1578691 */   // Label 21848: @1578691
     /* 1578691 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1578773), // Rule ID 4156 //
     /* 1578696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1578707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1578710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1578713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578727 */     // MIs[0] passthru
     /* 1578727 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578740 */     // MIs[0] policy
     /* 1578740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1578753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578772 */     // GIR_Coverage, 4156,
     /* 1578772 */     GIR_EraseRootFromParent_Done,
     /* 1578773 */   // Label 21849: @1578773
     /* 1578773 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1578855), // Rule ID 4157 //
     /* 1578778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1578789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1578792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1578795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578809 */     // MIs[0] passthru
     /* 1578809 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578822 */     // MIs[0] policy
     /* 1578822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578832 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1578835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578854 */     // GIR_Coverage, 4157,
     /* 1578854 */     GIR_EraseRootFromParent_Done,
     /* 1578855 */   // Label 21850: @1578855
     /* 1578855 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1578937), // Rule ID 4166 //
     /* 1578860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1578863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1578871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1578874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1578877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578891 */     // MIs[0] passthru
     /* 1578891 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578904 */     // MIs[0] policy
     /* 1578904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1578917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578936 */     // GIR_Coverage, 4166,
     /* 1578936 */     GIR_EraseRootFromParent_Done,
     /* 1578937 */   // Label 21851: @1578937
     /* 1578937 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1579019), // Rule ID 4167 //
     /* 1578942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1578945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1578950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1578953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1578956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1578959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578973 */     // MIs[0] passthru
     /* 1578973 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578986 */     // MIs[0] policy
     /* 1578986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1578999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579018 */     // GIR_Coverage, 4167,
     /* 1579018 */     GIR_EraseRootFromParent_Done,
     /* 1579019 */   // Label 21852: @1579019
     /* 1579019 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1579101), // Rule ID 4176 //
     /* 1579024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1579035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1579038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1579041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579055 */     // MIs[0] passthru
     /* 1579055 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579068 */     // MIs[0] policy
     /* 1579068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579100 */     // GIR_Coverage, 4176,
     /* 1579100 */     GIR_EraseRootFromParent_Done,
     /* 1579101 */   // Label 21853: @1579101
     /* 1579101 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1579183), // Rule ID 4177 //
     /* 1579106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1579117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1579120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1579123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579137 */     // MIs[0] passthru
     /* 1579137 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579150 */     // MIs[0] policy
     /* 1579150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579182 */     // GIR_Coverage, 4177,
     /* 1579182 */     GIR_EraseRootFromParent_Done,
     /* 1579183 */   // Label 21854: @1579183
     /* 1579183 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1579265), // Rule ID 4186 //
     /* 1579188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1579199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1579202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1579205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579219 */     // MIs[0] passthru
     /* 1579219 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579232 */     // MIs[0] policy
     /* 1579232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579242 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1579245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579264 */     // GIR_Coverage, 4186,
     /* 1579264 */     GIR_EraseRootFromParent_Done,
     /* 1579265 */   // Label 21855: @1579265
     /* 1579265 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1579347), // Rule ID 4187 //
     /* 1579270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1579281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1579284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1579287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579301 */     // MIs[0] passthru
     /* 1579301 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579314 */     // MIs[0] policy
     /* 1579314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1579327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579346 */     // GIR_Coverage, 4187,
     /* 1579346 */     GIR_EraseRootFromParent_Done,
     /* 1579347 */   // Label 21856: @1579347
     /* 1579347 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1579429), // Rule ID 4196 //
     /* 1579352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1579363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1579366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1579369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579383 */     // MIs[0] passthru
     /* 1579383 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579396 */     // MIs[0] policy
     /* 1579396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1579409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579428 */     // GIR_Coverage, 4196,
     /* 1579428 */     GIR_EraseRootFromParent_Done,
     /* 1579429 */   // Label 21857: @1579429
     /* 1579429 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1579511), // Rule ID 4197 //
     /* 1579434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1579445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1579448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1579451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579465 */     // MIs[0] passthru
     /* 1579465 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579478 */     // MIs[0] policy
     /* 1579478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579488 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1579491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579510 */     // GIR_Coverage, 4197,
     /* 1579510 */     GIR_EraseRootFromParent_Done,
     /* 1579511 */   // Label 21858: @1579511
     /* 1579511 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1579593), // Rule ID 4266 //
     /* 1579516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579547 */     // MIs[0] passthru
     /* 1579547 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579560 */     // MIs[0] policy
     /* 1579560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579570 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1579573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579592 */     // GIR_Coverage, 4266,
     /* 1579592 */     GIR_EraseRootFromParent_Done,
     /* 1579593 */   // Label 21859: @1579593
     /* 1579593 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1579675), // Rule ID 4267 //
     /* 1579598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579629 */     // MIs[0] passthru
     /* 1579629 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579642 */     // MIs[0] policy
     /* 1579642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1579655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579674 */     // GIR_Coverage, 4267,
     /* 1579674 */     GIR_EraseRootFromParent_Done,
     /* 1579675 */   // Label 21860: @1579675
     /* 1579675 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1579757), // Rule ID 4276 //
     /* 1579680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579711 */     // MIs[0] passthru
     /* 1579711 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579724 */     // MIs[0] policy
     /* 1579724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1579737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579756 */     // GIR_Coverage, 4276,
     /* 1579756 */     GIR_EraseRootFromParent_Done,
     /* 1579757 */   // Label 21861: @1579757
     /* 1579757 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1579839), // Rule ID 4277 //
     /* 1579762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579793 */     // MIs[0] passthru
     /* 1579793 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579806 */     // MIs[0] policy
     /* 1579806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1579819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579838 */     // GIR_Coverage, 4277,
     /* 1579838 */     GIR_EraseRootFromParent_Done,
     /* 1579839 */   // Label 21862: @1579839
     /* 1579839 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1579921), // Rule ID 4286 //
     /* 1579844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579875 */     // MIs[0] passthru
     /* 1579875 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579888 */     // MIs[0] policy
     /* 1579888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1579901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579920 */     // GIR_Coverage, 4286,
     /* 1579920 */     GIR_EraseRootFromParent_Done,
     /* 1579921 */   // Label 21863: @1579921
     /* 1579921 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1580003), // Rule ID 4287 //
     /* 1579926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1579934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579957 */     // MIs[0] passthru
     /* 1579957 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579970 */     // MIs[0] policy
     /* 1579970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1579983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580002 */     // GIR_Coverage, 4287,
     /* 1580002 */     GIR_EraseRootFromParent_Done,
     /* 1580003 */   // Label 21864: @1580003
     /* 1580003 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1580085), // Rule ID 4296 //
     /* 1580008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580039 */     // MIs[0] passthru
     /* 1580039 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580052 */     // MIs[0] policy
     /* 1580052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1580065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580084 */     // GIR_Coverage, 4296,
     /* 1580084 */     GIR_EraseRootFromParent_Done,
     /* 1580085 */   // Label 21865: @1580085
     /* 1580085 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1580167), // Rule ID 4297 //
     /* 1580090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580121 */     // MIs[0] passthru
     /* 1580121 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580134 */     // MIs[0] policy
     /* 1580134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1580147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580166 */     // GIR_Coverage, 4297,
     /* 1580166 */     GIR_EraseRootFromParent_Done,
     /* 1580167 */   // Label 21866: @1580167
     /* 1580167 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1580249), // Rule ID 4306 //
     /* 1580172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580203 */     // MIs[0] passthru
     /* 1580203 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580216 */     // MIs[0] policy
     /* 1580216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1580229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580248 */     // GIR_Coverage, 4306,
     /* 1580248 */     GIR_EraseRootFromParent_Done,
     /* 1580249 */   // Label 21867: @1580249
     /* 1580249 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1580331), // Rule ID 4307 //
     /* 1580254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580285 */     // MIs[0] passthru
     /* 1580285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580298 */     // MIs[0] policy
     /* 1580298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580308 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1580311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580330 */     // GIR_Coverage, 4307,
     /* 1580330 */     GIR_EraseRootFromParent_Done,
     /* 1580331 */   // Label 21868: @1580331
     /* 1580331 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1580413), // Rule ID 4316 //
     /* 1580336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580367 */     // MIs[0] passthru
     /* 1580367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580380 */     // MIs[0] policy
     /* 1580380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1580393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580412 */     // GIR_Coverage, 4316,
     /* 1580412 */     GIR_EraseRootFromParent_Done,
     /* 1580413 */   // Label 21869: @1580413
     /* 1580413 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1580495), // Rule ID 4317 //
     /* 1580418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580449 */     // MIs[0] passthru
     /* 1580449 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580462 */     // MIs[0] policy
     /* 1580462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1580475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580494 */     // GIR_Coverage, 4317,
     /* 1580494 */     GIR_EraseRootFromParent_Done,
     /* 1580495 */   // Label 21870: @1580495
     /* 1580495 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1580577), // Rule ID 4326 //
     /* 1580500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580531 */     // MIs[0] passthru
     /* 1580531 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580544 */     // MIs[0] policy
     /* 1580544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1580557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580576 */     // GIR_Coverage, 4326,
     /* 1580576 */     GIR_EraseRootFromParent_Done,
     /* 1580577 */   // Label 21871: @1580577
     /* 1580577 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1580659), // Rule ID 4327 //
     /* 1580582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580613 */     // MIs[0] passthru
     /* 1580613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580626 */     // MIs[0] policy
     /* 1580626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1580639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580658 */     // GIR_Coverage, 4327,
     /* 1580658 */     GIR_EraseRootFromParent_Done,
     /* 1580659 */   // Label 21872: @1580659
     /* 1580659 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1580741), // Rule ID 4336 //
     /* 1580664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580695 */     // MIs[0] passthru
     /* 1580695 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580708 */     // MIs[0] policy
     /* 1580708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1580721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580740 */     // GIR_Coverage, 4336,
     /* 1580740 */     GIR_EraseRootFromParent_Done,
     /* 1580741 */   // Label 21873: @1580741
     /* 1580741 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1580823), // Rule ID 4337 //
     /* 1580746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580777 */     // MIs[0] passthru
     /* 1580777 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580790 */     // MIs[0] policy
     /* 1580790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1580803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580822 */     // GIR_Coverage, 4337,
     /* 1580822 */     GIR_EraseRootFromParent_Done,
     /* 1580823 */   // Label 21874: @1580823
     /* 1580823 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1580905), // Rule ID 4346 //
     /* 1580828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580859 */     // MIs[0] passthru
     /* 1580859 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580872 */     // MIs[0] policy
     /* 1580872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1580885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580904 */     // GIR_Coverage, 4346,
     /* 1580904 */     GIR_EraseRootFromParent_Done,
     /* 1580905 */   // Label 21875: @1580905
     /* 1580905 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1580987), // Rule ID 4347 //
     /* 1580910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1580918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580941 */     // MIs[0] passthru
     /* 1580941 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580954 */     // MIs[0] policy
     /* 1580954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1580967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580986 */     // GIR_Coverage, 4347,
     /* 1580986 */     GIR_EraseRootFromParent_Done,
     /* 1580987 */   // Label 21876: @1580987
     /* 1580987 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1581069), // Rule ID 4356 //
     /* 1580992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581023 */     // MIs[0] passthru
     /* 1581023 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581036 */     // MIs[0] policy
     /* 1581036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1581049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581068 */     // GIR_Coverage, 4356,
     /* 1581068 */     GIR_EraseRootFromParent_Done,
     /* 1581069 */   // Label 21877: @1581069
     /* 1581069 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1581151), // Rule ID 4357 //
     /* 1581074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581105 */     // MIs[0] passthru
     /* 1581105 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581118 */     // MIs[0] policy
     /* 1581118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1581131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581150 */     // GIR_Coverage, 4357,
     /* 1581150 */     GIR_EraseRootFromParent_Done,
     /* 1581151 */   // Label 21878: @1581151
     /* 1581151 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1581233), // Rule ID 4366 //
     /* 1581156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581187 */     // MIs[0] passthru
     /* 1581187 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581200 */     // MIs[0] policy
     /* 1581200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1581213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581232 */     // GIR_Coverage, 4366,
     /* 1581232 */     GIR_EraseRootFromParent_Done,
     /* 1581233 */   // Label 21879: @1581233
     /* 1581233 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1581315), // Rule ID 4367 //
     /* 1581238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581269 */     // MIs[0] passthru
     /* 1581269 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581282 */     // MIs[0] policy
     /* 1581282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1581295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581314 */     // GIR_Coverage, 4367,
     /* 1581314 */     GIR_EraseRootFromParent_Done,
     /* 1581315 */   // Label 21880: @1581315
     /* 1581315 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1581397), // Rule ID 4376 //
     /* 1581320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581351 */     // MIs[0] passthru
     /* 1581351 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581364 */     // MIs[0] policy
     /* 1581364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1581377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581396 */     // GIR_Coverage, 4376,
     /* 1581396 */     GIR_EraseRootFromParent_Done,
     /* 1581397 */   // Label 21881: @1581397
     /* 1581397 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1581479), // Rule ID 4377 //
     /* 1581402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581433 */     // MIs[0] passthru
     /* 1581433 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581446 */     // MIs[0] policy
     /* 1581446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1581459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581478 */     // GIR_Coverage, 4377,
     /* 1581478 */     GIR_EraseRootFromParent_Done,
     /* 1581479 */   // Label 21882: @1581479
     /* 1581479 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1581561), // Rule ID 4386 //
     /* 1581484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581515 */     // MIs[0] passthru
     /* 1581515 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581528 */     // MIs[0] policy
     /* 1581528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1581541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581560 */     // GIR_Coverage, 4386,
     /* 1581560 */     GIR_EraseRootFromParent_Done,
     /* 1581561 */   // Label 21883: @1581561
     /* 1581561 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1581643), // Rule ID 4387 //
     /* 1581566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581597 */     // MIs[0] passthru
     /* 1581597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581610 */     // MIs[0] policy
     /* 1581610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1581623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581642 */     // GIR_Coverage, 4387,
     /* 1581642 */     GIR_EraseRootFromParent_Done,
     /* 1581643 */   // Label 21884: @1581643
     /* 1581643 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1581725), // Rule ID 4396 //
     /* 1581648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581679 */     // MIs[0] passthru
     /* 1581679 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581692 */     // MIs[0] policy
     /* 1581692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1581705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581724 */     // GIR_Coverage, 4396,
     /* 1581724 */     GIR_EraseRootFromParent_Done,
     /* 1581725 */   // Label 21885: @1581725
     /* 1581725 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1581807), // Rule ID 4397 //
     /* 1581730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581761 */     // MIs[0] passthru
     /* 1581761 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581774 */     // MIs[0] policy
     /* 1581774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1581787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581806 */     // GIR_Coverage, 4397,
     /* 1581806 */     GIR_EraseRootFromParent_Done,
     /* 1581807 */   // Label 21886: @1581807
     /* 1581807 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1581889), // Rule ID 4406 //
     /* 1581812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581843 */     // MIs[0] passthru
     /* 1581843 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581856 */     // MIs[0] policy
     /* 1581856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1581869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581888 */     // GIR_Coverage, 4406,
     /* 1581888 */     GIR_EraseRootFromParent_Done,
     /* 1581889 */   // Label 21887: @1581889
     /* 1581889 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1581971), // Rule ID 4407 //
     /* 1581894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581925 */     // MIs[0] passthru
     /* 1581925 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581938 */     // MIs[0] policy
     /* 1581938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581948 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1581951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581970 */     // GIR_Coverage, 4407,
     /* 1581970 */     GIR_EraseRootFromParent_Done,
     /* 1581971 */   // Label 21888: @1581971
     /* 1581971 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1582053), // Rule ID 4476 //
     /* 1581976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1581984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1581987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1581990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1581993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582007 */     // MIs[0] passthru
     /* 1582007 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582020 */     // MIs[0] policy
     /* 1582020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1582033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582052 */     // GIR_Coverage, 4476,
     /* 1582052 */     GIR_EraseRootFromParent_Done,
     /* 1582053 */   // Label 21889: @1582053
     /* 1582053 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1582135), // Rule ID 4477 //
     /* 1582058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582089 */     // MIs[0] passthru
     /* 1582089 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582102 */     // MIs[0] policy
     /* 1582102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1582115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582134 */     // GIR_Coverage, 4477,
     /* 1582134 */     GIR_EraseRootFromParent_Done,
     /* 1582135 */   // Label 21890: @1582135
     /* 1582135 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1582217), // Rule ID 4486 //
     /* 1582140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582171 */     // MIs[0] passthru
     /* 1582171 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582184 */     // MIs[0] policy
     /* 1582184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1582197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582216 */     // GIR_Coverage, 4486,
     /* 1582216 */     GIR_EraseRootFromParent_Done,
     /* 1582217 */   // Label 21891: @1582217
     /* 1582217 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1582299), // Rule ID 4487 //
     /* 1582222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582253 */     // MIs[0] passthru
     /* 1582253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582266 */     // MIs[0] policy
     /* 1582266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1582279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582298 */     // GIR_Coverage, 4487,
     /* 1582298 */     GIR_EraseRootFromParent_Done,
     /* 1582299 */   // Label 21892: @1582299
     /* 1582299 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1582381), // Rule ID 4496 //
     /* 1582304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582335 */     // MIs[0] passthru
     /* 1582335 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582348 */     // MIs[0] policy
     /* 1582348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1582361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582380 */     // GIR_Coverage, 4496,
     /* 1582380 */     GIR_EraseRootFromParent_Done,
     /* 1582381 */   // Label 21893: @1582381
     /* 1582381 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1582463), // Rule ID 4497 //
     /* 1582386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582417 */     // MIs[0] passthru
     /* 1582417 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582430 */     // MIs[0] policy
     /* 1582430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582440 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1582443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582462 */     // GIR_Coverage, 4497,
     /* 1582462 */     GIR_EraseRootFromParent_Done,
     /* 1582463 */   // Label 21894: @1582463
     /* 1582463 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1582545), // Rule ID 4506 //
     /* 1582468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582499 */     // MIs[0] passthru
     /* 1582499 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582512 */     // MIs[0] policy
     /* 1582512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1582525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582544 */     // GIR_Coverage, 4506,
     /* 1582544 */     GIR_EraseRootFromParent_Done,
     /* 1582545 */   // Label 21895: @1582545
     /* 1582545 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1582627), // Rule ID 4507 //
     /* 1582550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582581 */     // MIs[0] passthru
     /* 1582581 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582594 */     // MIs[0] policy
     /* 1582594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1582607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582626 */     // GIR_Coverage, 4507,
     /* 1582626 */     GIR_EraseRootFromParent_Done,
     /* 1582627 */   // Label 21896: @1582627
     /* 1582627 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1582709), // Rule ID 4516 //
     /* 1582632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582663 */     // MIs[0] passthru
     /* 1582663 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582676 */     // MIs[0] policy
     /* 1582676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582686 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1582689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582708 */     // GIR_Coverage, 4516,
     /* 1582708 */     GIR_EraseRootFromParent_Done,
     /* 1582709 */   // Label 21897: @1582709
     /* 1582709 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1582791), // Rule ID 4517 //
     /* 1582714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582745 */     // MIs[0] passthru
     /* 1582745 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582758 */     // MIs[0] policy
     /* 1582758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582768 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1582771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582790 */     // GIR_Coverage, 4517,
     /* 1582790 */     GIR_EraseRootFromParent_Done,
     /* 1582791 */   // Label 21898: @1582791
     /* 1582791 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1582873), // Rule ID 4526 //
     /* 1582796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582827 */     // MIs[0] passthru
     /* 1582827 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582840 */     // MIs[0] policy
     /* 1582840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1582853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582872 */     // GIR_Coverage, 4526,
     /* 1582872 */     GIR_EraseRootFromParent_Done,
     /* 1582873 */   // Label 21899: @1582873
     /* 1582873 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1582955), // Rule ID 4527 //
     /* 1582878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582909 */     // MIs[0] passthru
     /* 1582909 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582922 */     // MIs[0] policy
     /* 1582922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1582935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582954 */     // GIR_Coverage, 4527,
     /* 1582954 */     GIR_EraseRootFromParent_Done,
     /* 1582955 */   // Label 21900: @1582955
     /* 1582955 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1583037), // Rule ID 4536 //
     /* 1582960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1582968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1582971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1582974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1582977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582991 */     // MIs[0] passthru
     /* 1582991 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583004 */     // MIs[0] policy
     /* 1583004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1583017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583036 */     // GIR_Coverage, 4536,
     /* 1583036 */     GIR_EraseRootFromParent_Done,
     /* 1583037 */   // Label 21901: @1583037
     /* 1583037 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1583119), // Rule ID 4537 //
     /* 1583042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583073 */     // MIs[0] passthru
     /* 1583073 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583086 */     // MIs[0] policy
     /* 1583086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1583099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583118 */     // GIR_Coverage, 4537,
     /* 1583118 */     GIR_EraseRootFromParent_Done,
     /* 1583119 */   // Label 21902: @1583119
     /* 1583119 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1583201), // Rule ID 4546 //
     /* 1583124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583155 */     // MIs[0] passthru
     /* 1583155 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583168 */     // MIs[0] policy
     /* 1583168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1583181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583200 */     // GIR_Coverage, 4546,
     /* 1583200 */     GIR_EraseRootFromParent_Done,
     /* 1583201 */   // Label 21903: @1583201
     /* 1583201 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1583283), // Rule ID 4547 //
     /* 1583206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1583217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1583220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583237 */     // MIs[0] passthru
     /* 1583237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583250 */     // MIs[0] policy
     /* 1583250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1583263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583282 */     // GIR_Coverage, 4547,
     /* 1583282 */     GIR_EraseRootFromParent_Done,
     /* 1583283 */   // Label 21904: @1583283
     /* 1583283 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1583365), // Rule ID 4556 //
     /* 1583288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583319 */     // MIs[0] passthru
     /* 1583319 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583332 */     // MIs[0] policy
     /* 1583332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1583345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583364 */     // GIR_Coverage, 4556,
     /* 1583364 */     GIR_EraseRootFromParent_Done,
     /* 1583365 */   // Label 21905: @1583365
     /* 1583365 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1583447), // Rule ID 4557 //
     /* 1583370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583401 */     // MIs[0] passthru
     /* 1583401 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583414 */     // MIs[0] policy
     /* 1583414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1583427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583446 */     // GIR_Coverage, 4557,
     /* 1583446 */     GIR_EraseRootFromParent_Done,
     /* 1583447 */   // Label 21906: @1583447
     /* 1583447 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1583529), // Rule ID 4566 //
     /* 1583452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583483 */     // MIs[0] passthru
     /* 1583483 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583496 */     // MIs[0] policy
     /* 1583496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1583509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583528 */     // GIR_Coverage, 4566,
     /* 1583528 */     GIR_EraseRootFromParent_Done,
     /* 1583529 */   // Label 21907: @1583529
     /* 1583529 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1583611), // Rule ID 4567 //
     /* 1583534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583565 */     // MIs[0] passthru
     /* 1583565 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583578 */     // MIs[0] policy
     /* 1583578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1583591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583610 */     // GIR_Coverage, 4567,
     /* 1583610 */     GIR_EraseRootFromParent_Done,
     /* 1583611 */   // Label 21908: @1583611
     /* 1583611 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1583693), // Rule ID 4576 //
     /* 1583616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583647 */     // MIs[0] passthru
     /* 1583647 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583660 */     // MIs[0] policy
     /* 1583660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583670 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1583673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583692 */     // GIR_Coverage, 4576,
     /* 1583692 */     GIR_EraseRootFromParent_Done,
     /* 1583693 */   // Label 21909: @1583693
     /* 1583693 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1583775), // Rule ID 4577 //
     /* 1583698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583729 */     // MIs[0] passthru
     /* 1583729 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583742 */     // MIs[0] policy
     /* 1583742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1583755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583774 */     // GIR_Coverage, 4577,
     /* 1583774 */     GIR_EraseRootFromParent_Done,
     /* 1583775 */   // Label 21910: @1583775
     /* 1583775 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1583857), // Rule ID 4586 //
     /* 1583780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583811 */     // MIs[0] passthru
     /* 1583811 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583824 */     // MIs[0] policy
     /* 1583824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1583837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583856 */     // GIR_Coverage, 4586,
     /* 1583856 */     GIR_EraseRootFromParent_Done,
     /* 1583857 */   // Label 21911: @1583857
     /* 1583857 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1583939), // Rule ID 4587 //
     /* 1583862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583893 */     // MIs[0] passthru
     /* 1583893 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583906 */     // MIs[0] policy
     /* 1583906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1583919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583938 */     // GIR_Coverage, 4587,
     /* 1583938 */     GIR_EraseRootFromParent_Done,
     /* 1583939 */   // Label 21912: @1583939
     /* 1583939 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1584021), // Rule ID 4596 //
     /* 1583944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1583952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1583955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1583958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1583961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583975 */     // MIs[0] passthru
     /* 1583975 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583988 */     // MIs[0] policy
     /* 1583988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584020 */     // GIR_Coverage, 4596,
     /* 1584020 */     GIR_EraseRootFromParent_Done,
     /* 1584021 */   // Label 21913: @1584021
     /* 1584021 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1584103), // Rule ID 4597 //
     /* 1584026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1584037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1584040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584057 */     // MIs[0] passthru
     /* 1584057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584070 */     // MIs[0] policy
     /* 1584070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584102 */     // GIR_Coverage, 4597,
     /* 1584102 */     GIR_EraseRootFromParent_Done,
     /* 1584103 */   // Label 21914: @1584103
     /* 1584103 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1584185), // Rule ID 4606 //
     /* 1584108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584139 */     // MIs[0] passthru
     /* 1584139 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584152 */     // MIs[0] policy
     /* 1584152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1584165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584184 */     // GIR_Coverage, 4606,
     /* 1584184 */     GIR_EraseRootFromParent_Done,
     /* 1584185 */   // Label 21915: @1584185
     /* 1584185 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1584267), // Rule ID 4607 //
     /* 1584190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1584201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1584204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1584207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584221 */     // MIs[0] passthru
     /* 1584221 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584234 */     // MIs[0] policy
     /* 1584234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1584247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584266 */     // GIR_Coverage, 4607,
     /* 1584266 */     GIR_EraseRootFromParent_Done,
     /* 1584267 */   // Label 21916: @1584267
     /* 1584267 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1584349), // Rule ID 4616 //
     /* 1584272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584303 */     // MIs[0] passthru
     /* 1584303 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584316 */     // MIs[0] policy
     /* 1584316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1584329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584348 */     // GIR_Coverage, 4616,
     /* 1584348 */     GIR_EraseRootFromParent_Done,
     /* 1584349 */   // Label 21917: @1584349
     /* 1584349 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1584431), // Rule ID 4617 //
     /* 1584354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584385 */     // MIs[0] passthru
     /* 1584385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584398 */     // MIs[0] policy
     /* 1584398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1584411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584430 */     // GIR_Coverage, 4617,
     /* 1584430 */     GIR_EraseRootFromParent_Done,
     /* 1584431 */   // Label 21918: @1584431
     /* 1584431 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1584513), // Rule ID 4686 //
     /* 1584436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584467 */     // MIs[0] passthru
     /* 1584467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584480 */     // MIs[0] policy
     /* 1584480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1584493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584512 */     // GIR_Coverage, 4686,
     /* 1584512 */     GIR_EraseRootFromParent_Done,
     /* 1584513 */   // Label 21919: @1584513
     /* 1584513 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1584595), // Rule ID 4687 //
     /* 1584518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584549 */     // MIs[0] passthru
     /* 1584549 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584562 */     // MIs[0] policy
     /* 1584562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584572 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1584575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584594 */     // GIR_Coverage, 4687,
     /* 1584594 */     GIR_EraseRootFromParent_Done,
     /* 1584595 */   // Label 21920: @1584595
     /* 1584595 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1584677), // Rule ID 4696 //
     /* 1584600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584631 */     // MIs[0] passthru
     /* 1584631 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584644 */     // MIs[0] policy
     /* 1584644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1584657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584676 */     // GIR_Coverage, 4696,
     /* 1584676 */     GIR_EraseRootFromParent_Done,
     /* 1584677 */   // Label 21921: @1584677
     /* 1584677 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1584759), // Rule ID 4697 //
     /* 1584682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584713 */     // MIs[0] passthru
     /* 1584713 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584726 */     // MIs[0] policy
     /* 1584726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584736 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1584739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584758 */     // GIR_Coverage, 4697,
     /* 1584758 */     GIR_EraseRootFromParent_Done,
     /* 1584759 */   // Label 21922: @1584759
     /* 1584759 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1584841), // Rule ID 4706 //
     /* 1584764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584795 */     // MIs[0] passthru
     /* 1584795 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584808 */     // MIs[0] policy
     /* 1584808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1584821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584840 */     // GIR_Coverage, 4706,
     /* 1584840 */     GIR_EraseRootFromParent_Done,
     /* 1584841 */   // Label 21923: @1584841
     /* 1584841 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1584923), // Rule ID 4707 //
     /* 1584846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584877 */     // MIs[0] passthru
     /* 1584877 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584890 */     // MIs[0] policy
     /* 1584890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1584903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584922 */     // GIR_Coverage, 4707,
     /* 1584922 */     GIR_EraseRootFromParent_Done,
     /* 1584923 */   // Label 21924: @1584923
     /* 1584923 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1585005), // Rule ID 4716 //
     /* 1584928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1584936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1584939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1584942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584959 */     // MIs[0] passthru
     /* 1584959 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584972 */     // MIs[0] policy
     /* 1584972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1584985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585004 */     // GIR_Coverage, 4716,
     /* 1585004 */     GIR_EraseRootFromParent_Done,
     /* 1585005 */   // Label 21925: @1585005
     /* 1585005 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1585087), // Rule ID 4717 //
     /* 1585010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1585027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585041 */     // MIs[0] passthru
     /* 1585041 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585054 */     // MIs[0] policy
     /* 1585054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1585067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585086 */     // GIR_Coverage, 4717,
     /* 1585086 */     GIR_EraseRootFromParent_Done,
     /* 1585087 */   // Label 21926: @1585087
     /* 1585087 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1585169), // Rule ID 4726 //
     /* 1585092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585123 */     // MIs[0] passthru
     /* 1585123 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585136 */     // MIs[0] policy
     /* 1585136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1585149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585168 */     // GIR_Coverage, 4726,
     /* 1585168 */     GIR_EraseRootFromParent_Done,
     /* 1585169 */   // Label 21927: @1585169
     /* 1585169 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1585251), // Rule ID 4727 //
     /* 1585174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1585191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585205 */     // MIs[0] passthru
     /* 1585205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585218 */     // MIs[0] policy
     /* 1585218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1585231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585250 */     // GIR_Coverage, 4727,
     /* 1585250 */     GIR_EraseRootFromParent_Done,
     /* 1585251 */   // Label 21928: @1585251
     /* 1585251 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1585333), // Rule ID 4736 //
     /* 1585256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585287 */     // MIs[0] passthru
     /* 1585287 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585300 */     // MIs[0] policy
     /* 1585300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585310 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1585313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585332 */     // GIR_Coverage, 4736,
     /* 1585332 */     GIR_EraseRootFromParent_Done,
     /* 1585333 */   // Label 21929: @1585333
     /* 1585333 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1585415), // Rule ID 4737 //
     /* 1585338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585369 */     // MIs[0] passthru
     /* 1585369 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585382 */     // MIs[0] policy
     /* 1585382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1585395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585414 */     // GIR_Coverage, 4737,
     /* 1585414 */     GIR_EraseRootFromParent_Done,
     /* 1585415 */   // Label 21930: @1585415
     /* 1585415 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1585497), // Rule ID 4746 //
     /* 1585420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585451 */     // MIs[0] passthru
     /* 1585451 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585464 */     // MIs[0] policy
     /* 1585464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1585477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585496 */     // GIR_Coverage, 4746,
     /* 1585496 */     GIR_EraseRootFromParent_Done,
     /* 1585497 */   // Label 21931: @1585497
     /* 1585497 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1585579), // Rule ID 4747 //
     /* 1585502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585533 */     // MIs[0] passthru
     /* 1585533 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585546 */     // MIs[0] policy
     /* 1585546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585556 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1585559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585578 */     // GIR_Coverage, 4747,
     /* 1585578 */     GIR_EraseRootFromParent_Done,
     /* 1585579 */   // Label 21932: @1585579
     /* 1585579 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1585661), // Rule ID 4756 //
     /* 1585584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585615 */     // MIs[0] passthru
     /* 1585615 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585628 */     // MIs[0] policy
     /* 1585628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1585641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585660 */     // GIR_Coverage, 4756,
     /* 1585660 */     GIR_EraseRootFromParent_Done,
     /* 1585661 */   // Label 21933: @1585661
     /* 1585661 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1585743), // Rule ID 4757 //
     /* 1585666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585697 */     // MIs[0] passthru
     /* 1585697 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585710 */     // MIs[0] policy
     /* 1585710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1585723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585742 */     // GIR_Coverage, 4757,
     /* 1585742 */     GIR_EraseRootFromParent_Done,
     /* 1585743 */   // Label 21934: @1585743
     /* 1585743 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1585825), // Rule ID 4766 //
     /* 1585748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585779 */     // MIs[0] passthru
     /* 1585779 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585792 */     // MIs[0] policy
     /* 1585792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1585805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585824 */     // GIR_Coverage, 4766,
     /* 1585824 */     GIR_EraseRootFromParent_Done,
     /* 1585825 */   // Label 21935: @1585825
     /* 1585825 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1585907), // Rule ID 4767 //
     /* 1585830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585861 */     // MIs[0] passthru
     /* 1585861 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585874 */     // MIs[0] policy
     /* 1585874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1585887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585906 */     // GIR_Coverage, 4767,
     /* 1585906 */     GIR_EraseRootFromParent_Done,
     /* 1585907 */   // Label 21936: @1585907
     /* 1585907 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1585989), // Rule ID 4776 //
     /* 1585912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1585920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585943 */     // MIs[0] passthru
     /* 1585943 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585956 */     // MIs[0] policy
     /* 1585956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1585969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585988 */     // GIR_Coverage, 4776,
     /* 1585988 */     GIR_EraseRootFromParent_Done,
     /* 1585989 */   // Label 21937: @1585989
     /* 1585989 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1586071), // Rule ID 4777 //
     /* 1585994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1586011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586025 */     // MIs[0] passthru
     /* 1586025 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586038 */     // MIs[0] policy
     /* 1586038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1586051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586070 */     // GIR_Coverage, 4777,
     /* 1586070 */     GIR_EraseRootFromParent_Done,
     /* 1586071 */   // Label 21938: @1586071
     /* 1586071 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1586153), // Rule ID 4786 //
     /* 1586076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586107 */     // MIs[0] passthru
     /* 1586107 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586120 */     // MIs[0] policy
     /* 1586120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1586133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586152 */     // GIR_Coverage, 4786,
     /* 1586152 */     GIR_EraseRootFromParent_Done,
     /* 1586153 */   // Label 21939: @1586153
     /* 1586153 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1586235), // Rule ID 4787 //
     /* 1586158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1586175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586189 */     // MIs[0] passthru
     /* 1586189 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586202 */     // MIs[0] policy
     /* 1586202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586212 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1586215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586234 */     // GIR_Coverage, 4787,
     /* 1586234 */     GIR_EraseRootFromParent_Done,
     /* 1586235 */   // Label 21940: @1586235
     /* 1586235 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1586317), // Rule ID 4796 //
     /* 1586240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586271 */     // MIs[0] passthru
     /* 1586271 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586284 */     // MIs[0] policy
     /* 1586284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1586297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586316 */     // GIR_Coverage, 4796,
     /* 1586316 */     GIR_EraseRootFromParent_Done,
     /* 1586317 */   // Label 21941: @1586317
     /* 1586317 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1586399), // Rule ID 4797 //
     /* 1586322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586353 */     // MIs[0] passthru
     /* 1586353 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586366 */     // MIs[0] policy
     /* 1586366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586376 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1586379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586398 */     // GIR_Coverage, 4797,
     /* 1586398 */     GIR_EraseRootFromParent_Done,
     /* 1586399 */   // Label 21942: @1586399
     /* 1586399 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1586481), // Rule ID 4806 //
     /* 1586404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586435 */     // MIs[0] passthru
     /* 1586435 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586448 */     // MIs[0] policy
     /* 1586448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1586461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586480 */     // GIR_Coverage, 4806,
     /* 1586480 */     GIR_EraseRootFromParent_Done,
     /* 1586481 */   // Label 21943: @1586481
     /* 1586481 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1586563), // Rule ID 4807 //
     /* 1586486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586517 */     // MIs[0] passthru
     /* 1586517 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586530 */     // MIs[0] policy
     /* 1586530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1586543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586562 */     // GIR_Coverage, 4807,
     /* 1586562 */     GIR_EraseRootFromParent_Done,
     /* 1586563 */   // Label 21944: @1586563
     /* 1586563 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1586645), // Rule ID 4816 //
     /* 1586568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586599 */     // MIs[0] passthru
     /* 1586599 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586612 */     // MIs[0] policy
     /* 1586612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1586625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586644 */     // GIR_Coverage, 4816,
     /* 1586644 */     GIR_EraseRootFromParent_Done,
     /* 1586645 */   // Label 21945: @1586645
     /* 1586645 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1586727), // Rule ID 4817 //
     /* 1586650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586681 */     // MIs[0] passthru
     /* 1586681 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586694 */     // MIs[0] policy
     /* 1586694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1586707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586726 */     // GIR_Coverage, 4817,
     /* 1586726 */     GIR_EraseRootFromParent_Done,
     /* 1586727 */   // Label 21946: @1586727
     /* 1586727 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1586809), // Rule ID 4826 //
     /* 1586732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586763 */     // MIs[0] passthru
     /* 1586763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586776 */     // MIs[0] policy
     /* 1586776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586786 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1586789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586808 */     // GIR_Coverage, 4826,
     /* 1586808 */     GIR_EraseRootFromParent_Done,
     /* 1586809 */   // Label 21947: @1586809
     /* 1586809 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1586891), // Rule ID 4827 //
     /* 1586814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586845 */     // MIs[0] passthru
     /* 1586845 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586858 */     // MIs[0] policy
     /* 1586858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1586871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586890 */     // GIR_Coverage, 4827,
     /* 1586890 */     GIR_EraseRootFromParent_Done,
     /* 1586891 */   // Label 21948: @1586891
     /* 1586891 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1586977), // Rule ID 2714 //
     /* 1586896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1586904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1586907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1586910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1586913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1586916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586942 */     // MIs[0] policy
     /* 1586942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1586955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586976 */     // GIR_Coverage, 2714,
     /* 1586976 */     GIR_EraseRootFromParent_Done,
     /* 1586977 */   // Label 21949: @1586977
     /* 1586977 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1587063), // Rule ID 2715 //
     /* 1586982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1586990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1586993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1586996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1586999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587028 */     // MIs[0] policy
     /* 1587028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587038 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1587041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587062 */     // GIR_Coverage, 2715,
     /* 1587062 */     GIR_EraseRootFromParent_Done,
     /* 1587063 */   // Label 21950: @1587063
     /* 1587063 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1587149), // Rule ID 2752 //
     /* 1587068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1587076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587114 */     // MIs[0] policy
     /* 1587114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1587127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587148 */     // GIR_Coverage, 2752,
     /* 1587148 */     GIR_EraseRootFromParent_Done,
     /* 1587149 */   // Label 21951: @1587149
     /* 1587149 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1587235), // Rule ID 2753 //
     /* 1587154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1587162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587200 */     // MIs[0] policy
     /* 1587200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1587213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587234 */     // GIR_Coverage, 2753,
     /* 1587234 */     GIR_EraseRootFromParent_Done,
     /* 1587235 */   // Label 21952: @1587235
     /* 1587235 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1587321), // Rule ID 2766 //
     /* 1587240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1587248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1587251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1587254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1587257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587286 */     // MIs[0] policy
     /* 1587286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1587299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1587303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587320 */     // GIR_Coverage, 2766,
     /* 1587320 */     GIR_EraseRootFromParent_Done,
     /* 1587321 */   // Label 21953: @1587321
     /* 1587321 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1587407), // Rule ID 2767 //
     /* 1587326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1587334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1587337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1587340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1587343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587372 */     // MIs[0] policy
     /* 1587372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1587385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1587389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587406 */     // GIR_Coverage, 2767,
     /* 1587406 */     GIR_EraseRootFromParent_Done,
     /* 1587407 */   // Label 21954: @1587407
     /* 1587407 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1587493), // Rule ID 2786 //
     /* 1587412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1587423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1587426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1587429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587458 */     // MIs[0] policy
     /* 1587458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587468 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1587471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587492 */     // GIR_Coverage, 2786,
     /* 1587492 */     GIR_EraseRootFromParent_Done,
     /* 1587493 */   // Label 21955: @1587493
     /* 1587493 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1587579), // Rule ID 2787 //
     /* 1587498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1587509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1587512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1587515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1587518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587544 */     // MIs[0] policy
     /* 1587544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587554 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1587557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587578 */     // GIR_Coverage, 2787,
     /* 1587578 */     GIR_EraseRootFromParent_Done,
     /* 1587579 */   // Label 21956: @1587579
     /* 1587579 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1587665), // Rule ID 2794 //
     /* 1587584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1587595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1587598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1587601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587630 */     // MIs[0] policy
     /* 1587630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587640 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1587643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587664 */     // GIR_Coverage, 2794,
     /* 1587664 */     GIR_EraseRootFromParent_Done,
     /* 1587665 */   // Label 21957: @1587665
     /* 1587665 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1587751), // Rule ID 2795 //
     /* 1587670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1587681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1587684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1587687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1587690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587716 */     // MIs[0] policy
     /* 1587716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587726 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1587729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587750 */     // GIR_Coverage, 2795,
     /* 1587750 */     GIR_EraseRootFromParent_Done,
     /* 1587751 */   // Label 21958: @1587751
     /* 1587751 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1587837), // Rule ID 2802 //
     /* 1587756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587802 */     // MIs[0] policy
     /* 1587802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587812 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1587815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587836 */     // GIR_Coverage, 2802,
     /* 1587836 */     GIR_EraseRootFromParent_Done,
     /* 1587837 */   // Label 21959: @1587837
     /* 1587837 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1587923), // Rule ID 2803 //
     /* 1587842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587888 */     // MIs[0] policy
     /* 1587888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587898 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1587901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587922 */     // GIR_Coverage, 2803,
     /* 1587922 */     GIR_EraseRootFromParent_Done,
     /* 1587923 */   // Label 21960: @1587923
     /* 1587923 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1588009), // Rule ID 2810 //
     /* 1587928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1587936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587974 */     // MIs[0] policy
     /* 1587974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1587987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1587993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1587995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588008 */     // GIR_Coverage, 2810,
     /* 1588008 */     GIR_EraseRootFromParent_Done,
     /* 1588009 */   // Label 21961: @1588009
     /* 1588009 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1588095), // Rule ID 2811 //
     /* 1588014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1588025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1588028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1588031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1588034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588060 */     // MIs[0] policy
     /* 1588060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588070 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1588073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588094 */     // GIR_Coverage, 2811,
     /* 1588094 */     GIR_EraseRootFromParent_Done,
     /* 1588095 */   // Label 21962: @1588095
     /* 1588095 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1588181), // Rule ID 2818 //
     /* 1588100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1588111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1588114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1588117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588146 */     // MIs[0] policy
     /* 1588146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1588159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588180 */     // GIR_Coverage, 2818,
     /* 1588180 */     GIR_EraseRootFromParent_Done,
     /* 1588181 */   // Label 21963: @1588181
     /* 1588181 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1588267), // Rule ID 2819 //
     /* 1588186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1588197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1588200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1588203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1588206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588232 */     // MIs[0] policy
     /* 1588232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588242 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1588245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588266 */     // GIR_Coverage, 2819,
     /* 1588266 */     GIR_EraseRootFromParent_Done,
     /* 1588267 */   // Label 21964: @1588267
     /* 1588267 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1588353), // Rule ID 2826 //
     /* 1588272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1588289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588318 */     // MIs[0] policy
     /* 1588318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1588331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588352 */     // GIR_Coverage, 2826,
     /* 1588352 */     GIR_EraseRootFromParent_Done,
     /* 1588353 */   // Label 21965: @1588353
     /* 1588353 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1588439), // Rule ID 2827 //
     /* 1588358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1588369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1588372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1588375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588404 */     // MIs[0] policy
     /* 1588404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1588417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588438 */     // GIR_Coverage, 2827,
     /* 1588438 */     GIR_EraseRootFromParent_Done,
     /* 1588439 */   // Label 21966: @1588439
     /* 1588439 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1588525), // Rule ID 2834 //
     /* 1588444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1588455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1588458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1588461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1588464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588490 */     // MIs[0] policy
     /* 1588490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588500 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588524 */     // GIR_Coverage, 2834,
     /* 1588524 */     GIR_EraseRootFromParent_Done,
     /* 1588525 */   // Label 21967: @1588525
     /* 1588525 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1588611), // Rule ID 2835 //
     /* 1588530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1588541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1588544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1588547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1588550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588576 */     // MIs[0] policy
     /* 1588576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588586 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588610 */     // GIR_Coverage, 2835,
     /* 1588610 */     GIR_EraseRootFromParent_Done,
     /* 1588611 */   // Label 21968: @1588611
     /* 1588611 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1588697), // Rule ID 2842 //
     /* 1588616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1588633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588662 */     // MIs[0] policy
     /* 1588662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588696 */     // GIR_Coverage, 2842,
     /* 1588696 */     GIR_EraseRootFromParent_Done,
     /* 1588697 */   // Label 21969: @1588697
     /* 1588697 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1588783), // Rule ID 2843 //
     /* 1588702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1588713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1588716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1588719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588748 */     // MIs[0] policy
     /* 1588748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588782 */     // GIR_Coverage, 2843,
     /* 1588782 */     GIR_EraseRootFromParent_Done,
     /* 1588783 */   // Label 21970: @1588783
     /* 1588783 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1588869), // Rule ID 2850 //
     /* 1588788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588834 */     // MIs[0] policy
     /* 1588834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588868 */     // GIR_Coverage, 2850,
     /* 1588868 */     GIR_EraseRootFromParent_Done,
     /* 1588869 */   // Label 21971: @1588869
     /* 1588869 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1588955), // Rule ID 2851 //
     /* 1588874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588920 */     // MIs[0] policy
     /* 1588920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1588933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1588939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1588941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588954 */     // GIR_Coverage, 2851,
     /* 1588954 */     GIR_EraseRootFromParent_Done,
     /* 1588955 */   // Label 21972: @1588955
     /* 1588955 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1589041), // Rule ID 2858 //
     /* 1588960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1588963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1588968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1588977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1588980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589006 */     // MIs[0] policy
     /* 1589006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1589019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1589037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589040 */     // GIR_Coverage, 2858,
     /* 1589040 */     GIR_EraseRootFromParent_Done,
     /* 1589041 */   // Label 21973: @1589041
     /* 1589041 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1589127), // Rule ID 2859 //
     /* 1589046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1589049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1589057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1589060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1589063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1589066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589092 */     // MIs[0] policy
     /* 1589092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1589105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1589123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589126 */     // GIR_Coverage, 2859,
     /* 1589126 */     GIR_EraseRootFromParent_Done,
     /* 1589127 */   // Label 21974: @1589127
     /* 1589127 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1589213), // Rule ID 2866 //
     /* 1589132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1589143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1589146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1589149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1589152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589178 */     // MIs[0] policy
     /* 1589178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1589191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589212 */     // GIR_Coverage, 2866,
     /* 1589212 */     GIR_EraseRootFromParent_Done,
     /* 1589213 */   // Label 21975: @1589213
     /* 1589213 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1589299), // Rule ID 2867 //
     /* 1589218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1589229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1589232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1589235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1589238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589264 */     // MIs[0] policy
     /* 1589264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1589277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589298 */     // GIR_Coverage, 2867,
     /* 1589298 */     GIR_EraseRootFromParent_Done,
     /* 1589299 */   // Label 21976: @1589299
     /* 1589299 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1589385), // Rule ID 2874 //
     /* 1589304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1589315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1589318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1589321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1589324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589350 */     // MIs[0] policy
     /* 1589350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1589363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589384 */     // GIR_Coverage, 2874,
     /* 1589384 */     GIR_EraseRootFromParent_Done,
     /* 1589385 */   // Label 21977: @1589385
     /* 1589385 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1589471), // Rule ID 2875 //
     /* 1589390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1589401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1589404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1589407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1589410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589436 */     // MIs[0] policy
     /* 1589436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1589449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589470 */     // GIR_Coverage, 2875,
     /* 1589470 */     GIR_EraseRootFromParent_Done,
     /* 1589471 */   // Label 21978: @1589471
     /* 1589471 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1589557), // Rule ID 2882 //
     /* 1589476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1589487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1589490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1589493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1589496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1589499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589522 */     // MIs[0] policy
     /* 1589522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589532 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1589535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589556 */     // GIR_Coverage, 2882,
     /* 1589556 */     GIR_EraseRootFromParent_Done,
     /* 1589557 */   // Label 21979: @1589557
     /* 1589557 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1589643), // Rule ID 2883 //
     /* 1589562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1589573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1589576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1589579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1589582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1589585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589608 */     // MIs[0] policy
     /* 1589608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589618 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1589621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589642 */     // GIR_Coverage, 2883,
     /* 1589642 */     GIR_EraseRootFromParent_Done,
     /* 1589643 */   // Label 21980: @1589643
     /* 1589643 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1589729), // Rule ID 2890 //
     /* 1589648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1589659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1589662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1589665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1589668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589694 */     // MIs[0] policy
     /* 1589694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1589707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589728 */     // GIR_Coverage, 2890,
     /* 1589728 */     GIR_EraseRootFromParent_Done,
     /* 1589729 */   // Label 21981: @1589729
     /* 1589729 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1589815), // Rule ID 2891 //
     /* 1589734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1589745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1589748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1589751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1589754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589780 */     // MIs[0] policy
     /* 1589780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1589793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589814 */     // GIR_Coverage, 2891,
     /* 1589814 */     GIR_EraseRootFromParent_Done,
     /* 1589815 */   // Label 21982: @1589815
     /* 1589815 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1589901), // Rule ID 2898 //
     /* 1589820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589866 */     // MIs[0] policy
     /* 1589866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1589879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589900 */     // GIR_Coverage, 2898,
     /* 1589900 */     GIR_EraseRootFromParent_Done,
     /* 1589901 */   // Label 21983: @1589901
     /* 1589901 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1589987), // Rule ID 2899 //
     /* 1589906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589952 */     // MIs[0] policy
     /* 1589952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589962 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1589965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589986 */     // GIR_Coverage, 2899,
     /* 1589986 */     GIR_EraseRootFromParent_Done,
     /* 1589987 */   // Label 21984: @1589987
     /* 1589987 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1590073), // Rule ID 2906 //
     /* 1589992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1590003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1590006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1590009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1590012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1590015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590038 */     // MIs[0] policy
     /* 1590038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590048 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1590051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590072 */     // GIR_Coverage, 2906,
     /* 1590072 */     GIR_EraseRootFromParent_Done,
     /* 1590073 */   // Label 21985: @1590073
     /* 1590073 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1590159), // Rule ID 2907 //
     /* 1590078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1590089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1590092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1590095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1590098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1590101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590124 */     // MIs[0] policy
     /* 1590124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1590137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590158 */     // GIR_Coverage, 2907,
     /* 1590158 */     GIR_EraseRootFromParent_Done,
     /* 1590159 */   // Label 21986: @1590159
     /* 1590159 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1590245), // Rule ID 2914 //
     /* 1590164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1590175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1590178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1590181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1590184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590210 */     // MIs[0] policy
     /* 1590210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1590223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590244 */     // GIR_Coverage, 2914,
     /* 1590244 */     GIR_EraseRootFromParent_Done,
     /* 1590245 */   // Label 21987: @1590245
     /* 1590245 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1590331), // Rule ID 2915 //
     /* 1590250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1590261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1590264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1590267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1590270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590296 */     // MIs[0] policy
     /* 1590296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1590309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590330 */     // GIR_Coverage, 2915,
     /* 1590330 */     GIR_EraseRootFromParent_Done,
     /* 1590331 */   // Label 21988: @1590331
     /* 1590331 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1590417), // Rule ID 2922 //
     /* 1590336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1590347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1590350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1590353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1590356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590382 */     // MIs[0] policy
     /* 1590382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590392 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1590395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590416 */     // GIR_Coverage, 2922,
     /* 1590416 */     GIR_EraseRootFromParent_Done,
     /* 1590417 */   // Label 21989: @1590417
     /* 1590417 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1590503), // Rule ID 2923 //
     /* 1590422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1590433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1590436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1590439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1590442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590468 */     // MIs[0] policy
     /* 1590468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1590481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590502 */     // GIR_Coverage, 2923,
     /* 1590502 */     GIR_EraseRootFromParent_Done,
     /* 1590503 */   // Label 21990: @1590503
     /* 1590503 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1590589), // Rule ID 2930 //
     /* 1590508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1590519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1590522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1590525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1590528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1590531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590554 */     // MIs[0] policy
     /* 1590554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590564 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1590567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590588 */     // GIR_Coverage, 2930,
     /* 1590588 */     GIR_EraseRootFromParent_Done,
     /* 1590589 */   // Label 21991: @1590589
     /* 1590589 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1590675), // Rule ID 2931 //
     /* 1590594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1590605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1590608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1590611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1590614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1590617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590640 */     // MIs[0] policy
     /* 1590640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1590653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590674 */     // GIR_Coverage, 2931,
     /* 1590674 */     GIR_EraseRootFromParent_Done,
     /* 1590675 */   // Label 21992: @1590675
     /* 1590675 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1590761), // Rule ID 2938 //
     /* 1590680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1590697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1590700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590726 */     // MIs[0] policy
     /* 1590726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1590739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590760 */     // GIR_Coverage, 2938,
     /* 1590760 */     GIR_EraseRootFromParent_Done,
     /* 1590761 */   // Label 21993: @1590761
     /* 1590761 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1590847), // Rule ID 2939 //
     /* 1590766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1590783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1590786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590812 */     // MIs[0] policy
     /* 1590812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1590825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590846 */     // GIR_Coverage, 2939,
     /* 1590846 */     GIR_EraseRootFromParent_Done,
     /* 1590847 */   // Label 21994: @1590847
     /* 1590847 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1590933), // Rule ID 2946 //
     /* 1590852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1590872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590898 */     // MIs[0] policy
     /* 1590898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590908 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1590911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590932 */     // GIR_Coverage, 2946,
     /* 1590932 */     GIR_EraseRootFromParent_Done,
     /* 1590933 */   // Label 21995: @1590933
     /* 1590933 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1591019), // Rule ID 2947 //
     /* 1590938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1590958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590984 */     // MIs[0] policy
     /* 1590984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1590997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591018 */     // GIR_Coverage, 2947,
     /* 1591018 */     GIR_EraseRootFromParent_Done,
     /* 1591019 */   // Label 21996: @1591019
     /* 1591019 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1591105), // Rule ID 2954 //
     /* 1591024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1591027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1591035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1591038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1591041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1591044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591070 */     // MIs[0] policy
     /* 1591070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591104 */     // GIR_Coverage, 2954,
     /* 1591104 */     GIR_EraseRootFromParent_Done,
     /* 1591105 */   // Label 21997: @1591105
     /* 1591105 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1591191), // Rule ID 2955 //
     /* 1591110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1591113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1591121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1591124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1591127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1591130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591156 */     // MIs[0] policy
     /* 1591156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591166 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591190 */     // GIR_Coverage, 2955,
     /* 1591190 */     GIR_EraseRootFromParent_Done,
     /* 1591191 */   // Label 21998: @1591191
     /* 1591191 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1591277), // Rule ID 2970 //
     /* 1591196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1591207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1591210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1591213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1591216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591242 */     // MIs[0] policy
     /* 1591242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1591255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591276 */     // GIR_Coverage, 2970,
     /* 1591276 */     GIR_EraseRootFromParent_Done,
     /* 1591277 */   // Label 21999: @1591277
     /* 1591277 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1591363), // Rule ID 2971 //
     /* 1591282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1591293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1591296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1591299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1591302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591328 */     // MIs[0] policy
     /* 1591328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1591341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591362 */     // GIR_Coverage, 2971,
     /* 1591362 */     GIR_EraseRootFromParent_Done,
     /* 1591363 */   // Label 22000: @1591363
     /* 1591363 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1591449), // Rule ID 2974 //
     /* 1591368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1591379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1591382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1591385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1591388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591414 */     // MIs[0] policy
     /* 1591414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1591427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591448 */     // GIR_Coverage, 2974,
     /* 1591448 */     GIR_EraseRootFromParent_Done,
     /* 1591449 */   // Label 22001: @1591449
     /* 1591449 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1591535), // Rule ID 2975 //
     /* 1591454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1591465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1591468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1591471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1591474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591500 */     // MIs[0] policy
     /* 1591500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1591513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591534 */     // GIR_Coverage, 2975,
     /* 1591534 */     GIR_EraseRootFromParent_Done,
     /* 1591535 */   // Label 22002: @1591535
     /* 1591535 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1591621), // Rule ID 2978 //
     /* 1591540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1591551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1591554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1591557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591586 */     // MIs[0] policy
     /* 1591586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1591599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591620 */     // GIR_Coverage, 2978,
     /* 1591620 */     GIR_EraseRootFromParent_Done,
     /* 1591621 */   // Label 22003: @1591621
     /* 1591621 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1591707), // Rule ID 2979 //
     /* 1591626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1591637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1591640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1591643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1591646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591672 */     // MIs[0] policy
     /* 1591672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1591685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591706 */     // GIR_Coverage, 2979,
     /* 1591706 */     GIR_EraseRootFromParent_Done,
     /* 1591707 */   // Label 22004: @1591707
     /* 1591707 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1591793), // Rule ID 2982 //
     /* 1591712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591758 */     // MIs[0] policy
     /* 1591758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1591771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591792 */     // GIR_Coverage, 2982,
     /* 1591792 */     GIR_EraseRootFromParent_Done,
     /* 1591793 */   // Label 22005: @1591793
     /* 1591793 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1591879), // Rule ID 2983 //
     /* 1591798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1591818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591844 */     // MIs[0] policy
     /* 1591844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1591857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591878 */     // GIR_Coverage, 2983,
     /* 1591878 */     GIR_EraseRootFromParent_Done,
     /* 1591879 */   // Label 22006: @1591879
     /* 1591879 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1591965), // Rule ID 2986 //
     /* 1591884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591930 */     // MIs[0] policy
     /* 1591930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1591943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591964 */     // GIR_Coverage, 2986,
     /* 1591964 */     GIR_EraseRootFromParent_Done,
     /* 1591965 */   // Label 22007: @1591965
     /* 1591965 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1592051), // Rule ID 2987 //
     /* 1591970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1591990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592016 */     // MIs[0] policy
     /* 1592016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1592029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592050 */     // GIR_Coverage, 2987,
     /* 1592050 */     GIR_EraseRootFromParent_Done,
     /* 1592051 */   // Label 22008: @1592051
     /* 1592051 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1592137), // Rule ID 2990 //
     /* 1592056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1592067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1592070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1592073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1592076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592102 */     // MIs[0] policy
     /* 1592102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592136 */     // GIR_Coverage, 2990,
     /* 1592136 */     GIR_EraseRootFromParent_Done,
     /* 1592137 */   // Label 22009: @1592137
     /* 1592137 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1592223), // Rule ID 2991 //
     /* 1592142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1592153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1592156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1592159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1592162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592188 */     // MIs[0] policy
     /* 1592188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592222 */     // GIR_Coverage, 2991,
     /* 1592222 */     GIR_EraseRootFromParent_Done,
     /* 1592223 */   // Label 22010: @1592223
     /* 1592223 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1592309), // Rule ID 2994 //
     /* 1592228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1592239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1592242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1592245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1592248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592274 */     // MIs[0] policy
     /* 1592274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592308 */     // GIR_Coverage, 2994,
     /* 1592308 */     GIR_EraseRootFromParent_Done,
     /* 1592309 */   // Label 22011: @1592309
     /* 1592309 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1592395), // Rule ID 2995 //
     /* 1592314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1592325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1592328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1592331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1592334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592360 */     // MIs[0] policy
     /* 1592360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592394 */     // GIR_Coverage, 2995,
     /* 1592394 */     GIR_EraseRootFromParent_Done,
     /* 1592395 */   // Label 22012: @1592395
     /* 1592395 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1592481), // Rule ID 2998 //
     /* 1592400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1592411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1592414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1592417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592446 */     // MIs[0] policy
     /* 1592446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592480 */     // GIR_Coverage, 2998,
     /* 1592480 */     GIR_EraseRootFromParent_Done,
     /* 1592481 */   // Label 22013: @1592481
     /* 1592481 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1592567), // Rule ID 2999 //
     /* 1592486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1592497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1592500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1592503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1592506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592532 */     // MIs[0] policy
     /* 1592532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592566 */     // GIR_Coverage, 2999,
     /* 1592566 */     GIR_EraseRootFromParent_Done,
     /* 1592567 */   // Label 22014: @1592567
     /* 1592567 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1592653), // Rule ID 3002 //
     /* 1592572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1592575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1592592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592618 */     // MIs[0] policy
     /* 1592618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592652 */     // GIR_Coverage, 3002,
     /* 1592652 */     GIR_EraseRootFromParent_Done,
     /* 1592653 */   // Label 22015: @1592653
     /* 1592653 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1592739), // Rule ID 3003 //
     /* 1592658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1592661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1592678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592704 */     // MIs[0] policy
     /* 1592704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1592717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592738 */     // GIR_Coverage, 3003,
     /* 1592738 */     GIR_EraseRootFromParent_Done,
     /* 1592739 */   // Label 22016: @1592739
     /* 1592739 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1592825), // Rule ID 3006 //
     /* 1592744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1592764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592790 */     // MIs[0] policy
     /* 1592790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1592803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592824 */     // GIR_Coverage, 3006,
     /* 1592824 */     GIR_EraseRootFromParent_Done,
     /* 1592825 */   // Label 22017: @1592825
     /* 1592825 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1592911), // Rule ID 3007 //
     /* 1592830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1592850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592876 */     // MIs[0] policy
     /* 1592876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1592889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592910 */     // GIR_Coverage, 3007,
     /* 1592910 */     GIR_EraseRootFromParent_Done,
     /* 1592911 */   // Label 22018: @1592911
     /* 1592911 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1592997), // Rule ID 3010 //
     /* 1592916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1592936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592962 */     // MIs[0] policy
     /* 1592962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1592975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592996 */     // GIR_Coverage, 3010,
     /* 1592996 */     GIR_EraseRootFromParent_Done,
     /* 1592997 */   // Label 22019: @1592997
     /* 1592997 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1593083), // Rule ID 3011 //
     /* 1593002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1593013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1593016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1593019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1593022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593048 */     // MIs[0] policy
     /* 1593048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1593061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593082 */     // GIR_Coverage, 3011,
     /* 1593082 */     GIR_EraseRootFromParent_Done,
     /* 1593083 */   // Label 22020: @1593083
     /* 1593083 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1593169), // Rule ID 3014 //
     /* 1593088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1593099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1593102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1593105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1593108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1593111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593134 */     // MIs[0] policy
     /* 1593134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1593147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593168 */     // GIR_Coverage, 3014,
     /* 1593168 */     GIR_EraseRootFromParent_Done,
     /* 1593169 */   // Label 22021: @1593169
     /* 1593169 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1593255), // Rule ID 3015 //
     /* 1593174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1593185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1593188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1593191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1593194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1593197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593220 */     // MIs[0] policy
     /* 1593220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1593233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593254 */     // GIR_Coverage, 3015,
     /* 1593254 */     GIR_EraseRootFromParent_Done,
     /* 1593255 */   // Label 22022: @1593255
     /* 1593255 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1593341), // Rule ID 3018 //
     /* 1593260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1593271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1593274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1593277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1593280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593306 */     // MIs[0] policy
     /* 1593306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1593319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593340 */     // GIR_Coverage, 3018,
     /* 1593340 */     GIR_EraseRootFromParent_Done,
     /* 1593341 */   // Label 22023: @1593341
     /* 1593341 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1593427), // Rule ID 3019 //
     /* 1593346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1593357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1593360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1593363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1593366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593392 */     // MIs[0] policy
     /* 1593392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1593405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593426 */     // GIR_Coverage, 3019,
     /* 1593426 */     GIR_EraseRootFromParent_Done,
     /* 1593427 */   // Label 22024: @1593427
     /* 1593427 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1593513), // Rule ID 3022 //
     /* 1593432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1593443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1593446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1593449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1593452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593478 */     // MIs[0] policy
     /* 1593478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1593491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593512 */     // GIR_Coverage, 3022,
     /* 1593512 */     GIR_EraseRootFromParent_Done,
     /* 1593513 */   // Label 22025: @1593513
     /* 1593513 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1593599), // Rule ID 3023 //
     /* 1593518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1593529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1593532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1593535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1593538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593564 */     // MIs[0] policy
     /* 1593564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1593577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593598 */     // GIR_Coverage, 3023,
     /* 1593598 */     GIR_EraseRootFromParent_Done,
     /* 1593599 */   // Label 22026: @1593599
     /* 1593599 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1593685), // Rule ID 3026 //
     /* 1593604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1593624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593650 */     // MIs[0] policy
     /* 1593650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1593663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593684 */     // GIR_Coverage, 3026,
     /* 1593684 */     GIR_EraseRootFromParent_Done,
     /* 1593685 */   // Label 22027: @1593685
     /* 1593685 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1593771), // Rule ID 3027 //
     /* 1593690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1593710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593736 */     // MIs[0] policy
     /* 1593736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1593749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593770 */     // GIR_Coverage, 3027,
     /* 1593770 */     GIR_EraseRootFromParent_Done,
     /* 1593771 */   // Label 22028: @1593771
     /* 1593771 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1593857), // Rule ID 3030 //
     /* 1593776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1593796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593822 */     // MIs[0] policy
     /* 1593822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1593835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593856 */     // GIR_Coverage, 3030,
     /* 1593856 */     GIR_EraseRootFromParent_Done,
     /* 1593857 */   // Label 22029: @1593857
     /* 1593857 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1593943), // Rule ID 3031 //
     /* 1593862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1593882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593908 */     // MIs[0] policy
     /* 1593908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1593921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593942 */     // GIR_Coverage, 3031,
     /* 1593942 */     GIR_EraseRootFromParent_Done,
     /* 1593943 */   // Label 22030: @1593943
     /* 1593943 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1594029), // Rule ID 3034 //
     /* 1593948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1593968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593994 */     // MIs[0] policy
     /* 1593994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1594007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594028 */     // GIR_Coverage, 3034,
     /* 1594028 */     GIR_EraseRootFromParent_Done,
     /* 1594029 */   // Label 22031: @1594029
     /* 1594029 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1594115), // Rule ID 3035 //
     /* 1594034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1594045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1594048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1594051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1594054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594080 */     // MIs[0] policy
     /* 1594080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1594093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594114 */     // GIR_Coverage, 3035,
     /* 1594114 */     GIR_EraseRootFromParent_Done,
     /* 1594115 */   // Label 22032: @1594115
     /* 1594115 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1594201), // Rule ID 3038 //
     /* 1594120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1594131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1594134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1594137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1594140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1594143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594166 */     // MIs[0] policy
     /* 1594166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1594179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594200 */     // GIR_Coverage, 3038,
     /* 1594200 */     GIR_EraseRootFromParent_Done,
     /* 1594201 */   // Label 22033: @1594201
     /* 1594201 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1594287), // Rule ID 3039 //
     /* 1594206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1594217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1594220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1594223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1594226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1594229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594252 */     // MIs[0] policy
     /* 1594252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1594265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594286 */     // GIR_Coverage, 3039,
     /* 1594286 */     GIR_EraseRootFromParent_Done,
     /* 1594287 */   // Label 22034: @1594287
     /* 1594287 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1594373), // Rule ID 3042 //
     /* 1594292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1594303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1594306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1594309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1594312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1594322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594338 */     // MIs[0] policy
     /* 1594338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1594351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594372 */     // GIR_Coverage, 3042,
     /* 1594372 */     GIR_EraseRootFromParent_Done,
     /* 1594373 */   // Label 22035: @1594373
     /* 1594373 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1594459), // Rule ID 3043 //
     /* 1594378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1594389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1594392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1594395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1594398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1594408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1594420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594424 */     // MIs[0] policy
     /* 1594424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1594437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594458 */     // GIR_Coverage, 3043,
     /* 1594458 */     GIR_EraseRootFromParent_Done,
     /* 1594459 */   // Label 22036: @1594459
     /* 1594459 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1594545), // Rule ID 3046 //
     /* 1594464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1594475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1594478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1594481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1594484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594510 */     // MIs[0] policy
     /* 1594510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1594523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594544 */     // GIR_Coverage, 3046,
     /* 1594544 */     GIR_EraseRootFromParent_Done,
     /* 1594545 */   // Label 22037: @1594545
     /* 1594545 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1594631), // Rule ID 3047 //
     /* 1594550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1594561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1594564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1594567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1594570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594596 */     // MIs[0] policy
     /* 1594596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1594609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594630 */     // GIR_Coverage, 3047,
     /* 1594630 */     GIR_EraseRootFromParent_Done,
     /* 1594631 */   // Label 22038: @1594631
     /* 1594631 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1594717), // Rule ID 3050 //
     /* 1594636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1594656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594682 */     // MIs[0] policy
     /* 1594682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1594695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594716 */     // GIR_Coverage, 3050,
     /* 1594716 */     GIR_EraseRootFromParent_Done,
     /* 1594717 */   // Label 22039: @1594717
     /* 1594717 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1594803), // Rule ID 3051 //
     /* 1594722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1594742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594768 */     // MIs[0] policy
     /* 1594768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1594781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594802 */     // GIR_Coverage, 3051,
     /* 1594802 */     GIR_EraseRootFromParent_Done,
     /* 1594803 */   // Label 22040: @1594803
     /* 1594803 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1594889), // Rule ID 3054 //
     /* 1594808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594854 */     // MIs[0] policy
     /* 1594854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1594867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594888 */     // GIR_Coverage, 3054,
     /* 1594888 */     GIR_EraseRootFromParent_Done,
     /* 1594889 */   // Label 22041: @1594889
     /* 1594889 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1594975), // Rule ID 3055 //
     /* 1594894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594940 */     // MIs[0] policy
     /* 1594940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1594953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594974 */     // GIR_Coverage, 3055,
     /* 1594974 */     GIR_EraseRootFromParent_Done,
     /* 1594975 */   // Label 22042: @1594975
     /* 1594975 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1595061), // Rule ID 3058 //
     /* 1594980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595026 */     // MIs[0] policy
     /* 1595026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1595039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595060 */     // GIR_Coverage, 3058,
     /* 1595060 */     GIR_EraseRootFromParent_Done,
     /* 1595061 */   // Label 22043: @1595061
     /* 1595061 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1595147), // Rule ID 3059 //
     /* 1595066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1595077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1595080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1595083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595112 */     // MIs[0] policy
     /* 1595112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1595125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595146 */     // GIR_Coverage, 3059,
     /* 1595146 */     GIR_EraseRootFromParent_Done,
     /* 1595147 */   // Label 22044: @1595147
     /* 1595147 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1595233), // Rule ID 3062 //
     /* 1595152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1595163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1595166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1595169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595198 */     // MIs[0] policy
     /* 1595198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595232 */     // GIR_Coverage, 3062,
     /* 1595232 */     GIR_EraseRootFromParent_Done,
     /* 1595233 */   // Label 22045: @1595233
     /* 1595233 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1595319), // Rule ID 3063 //
     /* 1595238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1595249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1595252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1595255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595284 */     // MIs[0] policy
     /* 1595284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595318 */     // GIR_Coverage, 3063,
     /* 1595318 */     GIR_EraseRootFromParent_Done,
     /* 1595319 */   // Label 22046: @1595319
     /* 1595319 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1595405), // Rule ID 3066 //
     /* 1595324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1595335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1595338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1595341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595370 */     // MIs[0] policy
     /* 1595370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1595383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595404 */     // GIR_Coverage, 3066,
     /* 1595404 */     GIR_EraseRootFromParent_Done,
     /* 1595405 */   // Label 22047: @1595405
     /* 1595405 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1595491), // Rule ID 3067 //
     /* 1595410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1595421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1595424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1595427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595456 */     // MIs[0] policy
     /* 1595456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1595469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595490 */     // GIR_Coverage, 3067,
     /* 1595490 */     GIR_EraseRootFromParent_Done,
     /* 1595491 */   // Label 22048: @1595491
     /* 1595491 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1595577), // Rule ID 3070 //
     /* 1595496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1595507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1595510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1595513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595542 */     // MIs[0] policy
     /* 1595542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595576 */     // GIR_Coverage, 3070,
     /* 1595576 */     GIR_EraseRootFromParent_Done,
     /* 1595577 */   // Label 22049: @1595577
     /* 1595577 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1595663), // Rule ID 3071 //
     /* 1595582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1595593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1595596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1595599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595628 */     // MIs[0] policy
     /* 1595628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595662 */     // GIR_Coverage, 3071,
     /* 1595662 */     GIR_EraseRootFromParent_Done,
     /* 1595663 */   // Label 22050: @1595663
     /* 1595663 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1595749), // Rule ID 3074 //
     /* 1595668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595714 */     // MIs[0] policy
     /* 1595714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595748 */     // GIR_Coverage, 3074,
     /* 1595748 */     GIR_EraseRootFromParent_Done,
     /* 1595749 */   // Label 22051: @1595749
     /* 1595749 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1595835), // Rule ID 3075 //
     /* 1595754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595800 */     // MIs[0] policy
     /* 1595800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1595813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595834 */     // GIR_Coverage, 3075,
     /* 1595834 */     GIR_EraseRootFromParent_Done,
     /* 1595835 */   // Label 22052: @1595835
     /* 1595835 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1595921), // Rule ID 3078 //
     /* 1595840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1595860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595886 */     // MIs[0] policy
     /* 1595886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1595899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595920 */     // GIR_Coverage, 3078,
     /* 1595920 */     GIR_EraseRootFromParent_Done,
     /* 1595921 */   // Label 22053: @1595921
     /* 1595921 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1596007), // Rule ID 3079 //
     /* 1595926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1595946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1595968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595972 */     // MIs[0] policy
     /* 1595972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1595985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596006 */     // GIR_Coverage, 3079,
     /* 1596006 */     GIR_EraseRootFromParent_Done,
     /* 1596007 */   // Label 22054: @1596007
     /* 1596007 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1596093), // Rule ID 3082 //
     /* 1596012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1596023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1596026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1596029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596058 */     // MIs[0] policy
     /* 1596058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596092 */     // GIR_Coverage, 3082,
     /* 1596092 */     GIR_EraseRootFromParent_Done,
     /* 1596093 */   // Label 22055: @1596093
     /* 1596093 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1596179), // Rule ID 3083 //
     /* 1596098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1596109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1596112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1596115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596144 */     // MIs[0] policy
     /* 1596144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596178 */     // GIR_Coverage, 3083,
     /* 1596178 */     GIR_EraseRootFromParent_Done,
     /* 1596179 */   // Label 22056: @1596179
     /* 1596179 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1596265), // Rule ID 3086 //
     /* 1596184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1596195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1596198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1596201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596230 */     // MIs[0] policy
     /* 1596230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596264 */     // GIR_Coverage, 3086,
     /* 1596264 */     GIR_EraseRootFromParent_Done,
     /* 1596265 */   // Label 22057: @1596265
     /* 1596265 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1596351), // Rule ID 3087 //
     /* 1596270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1596281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1596284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1596287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596316 */     // MIs[0] policy
     /* 1596316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596350 */     // GIR_Coverage, 3087,
     /* 1596350 */     GIR_EraseRootFromParent_Done,
     /* 1596351 */   // Label 22058: @1596351
     /* 1596351 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1596437), // Rule ID 3090 //
     /* 1596356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1596367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1596370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1596373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1596379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596402 */     // MIs[0] policy
     /* 1596402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596436 */     // GIR_Coverage, 3090,
     /* 1596436 */     GIR_EraseRootFromParent_Done,
     /* 1596437 */   // Label 22059: @1596437
     /* 1596437 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1596523), // Rule ID 3091 //
     /* 1596442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1596453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1596456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1596459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1596465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1596472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1596480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596488 */     // MIs[0] policy
     /* 1596488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1596501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596522 */     // GIR_Coverage, 3091,
     /* 1596522 */     GIR_EraseRootFromParent_Done,
     /* 1596523 */   // Label 22060: @1596523
     /* 1596523 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1596609), // Rule ID 3094 //
     /* 1596528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1596539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1596542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1596545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596574 */     // MIs[0] policy
     /* 1596574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1596587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596608 */     // GIR_Coverage, 3094,
     /* 1596608 */     GIR_EraseRootFromParent_Done,
     /* 1596609 */   // Label 22061: @1596609
     /* 1596609 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1596695), // Rule ID 3095 //
     /* 1596614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1596625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1596628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1596631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596660 */     // MIs[0] policy
     /* 1596660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1596673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596694 */     // GIR_Coverage, 3095,
     /* 1596694 */     GIR_EraseRootFromParent_Done,
     /* 1596695 */   // Label 22062: @1596695
     /* 1596695 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1596781), // Rule ID 3098 //
     /* 1596700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596746 */     // MIs[0] policy
     /* 1596746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596756 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1596759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596780 */     // GIR_Coverage, 3098,
     /* 1596780 */     GIR_EraseRootFromParent_Done,
     /* 1596781 */   // Label 22063: @1596781
     /* 1596781 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1596867), // Rule ID 3099 //
     /* 1596786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596832 */     // MIs[0] policy
     /* 1596832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1596845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596866 */     // GIR_Coverage, 3099,
     /* 1596866 */     GIR_EraseRootFromParent_Done,
     /* 1596867 */   // Label 22064: @1596867
     /* 1596867 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1596953), // Rule ID 3102 //
     /* 1596872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1596892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1596914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596918 */     // MIs[0] policy
     /* 1596918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1596931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596952 */     // GIR_Coverage, 3102,
     /* 1596952 */     GIR_EraseRootFromParent_Done,
     /* 1596953 */   // Label 22065: @1596953
     /* 1596953 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1597039), // Rule ID 3103 //
     /* 1596958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1596978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597004 */     // MIs[0] policy
     /* 1597004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1597017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597038 */     // GIR_Coverage, 3103,
     /* 1597038 */     GIR_EraseRootFromParent_Done,
     /* 1597039 */   // Label 22066: @1597039
     /* 1597039 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1597125), // Rule ID 3106 //
     /* 1597044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1597055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1597058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1597061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597090 */     // MIs[0] policy
     /* 1597090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1597103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597124 */     // GIR_Coverage, 3106,
     /* 1597124 */     GIR_EraseRootFromParent_Done,
     /* 1597125 */   // Label 22067: @1597125
     /* 1597125 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1597211), // Rule ID 3107 //
     /* 1597130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1597141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1597144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1597147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597176 */     // MIs[0] policy
     /* 1597176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1597189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597210 */     // GIR_Coverage, 3107,
     /* 1597210 */     GIR_EraseRootFromParent_Done,
     /* 1597211 */   // Label 22068: @1597211
     /* 1597211 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1597297), // Rule ID 3110 //
     /* 1597216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1597227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1597230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1597233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597262 */     // MIs[0] policy
     /* 1597262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1597275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597296 */     // GIR_Coverage, 3110,
     /* 1597296 */     GIR_EraseRootFromParent_Done,
     /* 1597297 */   // Label 22069: @1597297
     /* 1597297 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1597383), // Rule ID 3111 //
     /* 1597302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1597313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1597316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1597319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597348 */     // MIs[0] policy
     /* 1597348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1597361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597382 */     // GIR_Coverage, 3111,
     /* 1597382 */     GIR_EraseRootFromParent_Done,
     /* 1597383 */   // Label 22070: @1597383
     /* 1597383 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1597469), // Rule ID 3114 //
     /* 1597388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1597399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1597402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1597405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1597411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597434 */     // MIs[0] policy
     /* 1597434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597444 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1597447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597468 */     // GIR_Coverage, 3114,
     /* 1597468 */     GIR_EraseRootFromParent_Done,
     /* 1597469 */   // Label 22071: @1597469
     /* 1597469 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1597555), // Rule ID 3115 //
     /* 1597474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1597485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1597488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1597491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1597497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597520 */     // MIs[0] policy
     /* 1597520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1597533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597554 */     // GIR_Coverage, 3115,
     /* 1597554 */     GIR_EraseRootFromParent_Done,
     /* 1597555 */   // Label 22072: @1597555
     /* 1597555 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1597641), // Rule ID 3118 //
     /* 1597560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597606 */     // MIs[0] policy
     /* 1597606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1597619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597640 */     // GIR_Coverage, 3118,
     /* 1597640 */     GIR_EraseRootFromParent_Done,
     /* 1597641 */   // Label 22073: @1597641
     /* 1597641 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1597727), // Rule ID 3119 //
     /* 1597646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597692 */     // MIs[0] policy
     /* 1597692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1597705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597726 */     // GIR_Coverage, 3119,
     /* 1597726 */     GIR_EraseRootFromParent_Done,
     /* 1597727 */   // Label 22074: @1597727
     /* 1597727 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1597813), // Rule ID 3122 //
     /* 1597732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597778 */     // MIs[0] policy
     /* 1597778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1597791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597812 */     // GIR_Coverage, 3122,
     /* 1597812 */     GIR_EraseRootFromParent_Done,
     /* 1597813 */   // Label 22075: @1597813
     /* 1597813 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1597899), // Rule ID 3123 //
     /* 1597818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597864 */     // MIs[0] policy
     /* 1597864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1597877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597898 */     // GIR_Coverage, 3123,
     /* 1597898 */     GIR_EraseRootFromParent_Done,
     /* 1597899 */   // Label 22076: @1597899
     /* 1597899 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1597985), // Rule ID 3126 //
     /* 1597904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1597915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1597918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1597921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597950 */     // MIs[0] policy
     /* 1597950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1597963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597984 */     // GIR_Coverage, 3126,
     /* 1597984 */     GIR_EraseRootFromParent_Done,
     /* 1597985 */   // Label 22077: @1597985
     /* 1597985 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1598071), // Rule ID 3127 //
     /* 1597990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1598001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1598004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1598007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1598020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598036 */     // MIs[0] policy
     /* 1598036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1598049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598070 */     // GIR_Coverage, 3127,
     /* 1598070 */     GIR_EraseRootFromParent_Done,
     /* 1598071 */   // Label 22078: @1598071
     /* 1598071 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1598157), // Rule ID 3130 //
     /* 1598076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1598087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1598090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1598093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598122 */     // MIs[0] policy
     /* 1598122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598156 */     // GIR_Coverage, 3130,
     /* 1598156 */     GIR_EraseRootFromParent_Done,
     /* 1598157 */   // Label 22079: @1598157
     /* 1598157 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1598243), // Rule ID 3131 //
     /* 1598162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1598173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1598176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1598179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598208 */     // MIs[0] policy
     /* 1598208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598242 */     // GIR_Coverage, 3131,
     /* 1598242 */     GIR_EraseRootFromParent_Done,
     /* 1598243 */   // Label 22080: @1598243
     /* 1598243 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1598329), // Rule ID 3134 //
     /* 1598248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1598259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1598262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1598265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1598278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598294 */     // MIs[0] policy
     /* 1598294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1598307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598328 */     // GIR_Coverage, 3134,
     /* 1598328 */     GIR_EraseRootFromParent_Done,
     /* 1598329 */   // Label 22081: @1598329
     /* 1598329 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1598415), // Rule ID 3135 //
     /* 1598334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1598345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1598348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1598351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1598364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598380 */     // MIs[0] policy
     /* 1598380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1598393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598414 */     // GIR_Coverage, 3135,
     /* 1598414 */     GIR_EraseRootFromParent_Done,
     /* 1598415 */   // Label 22082: @1598415
     /* 1598415 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1598501), // Rule ID 3138 //
     /* 1598420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1598431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1598434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1598437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1598450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598466 */     // MIs[0] policy
     /* 1598466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1598479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598500 */     // GIR_Coverage, 3138,
     /* 1598500 */     GIR_EraseRootFromParent_Done,
     /* 1598501 */   // Label 22083: @1598501
     /* 1598501 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1598587), // Rule ID 3139 //
     /* 1598506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1598517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1598520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1598523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1598536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1598544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598552 */     // MIs[0] policy
     /* 1598552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1598565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598586 */     // GIR_Coverage, 3139,
     /* 1598586 */     GIR_EraseRootFromParent_Done,
     /* 1598587 */   // Label 22084: @1598587
     /* 1598587 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1598673), // Rule ID 3230 //
     /* 1598592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1598609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1598612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598638 */     // MIs[0] policy
     /* 1598638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598648 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1598651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598672 */     // GIR_Coverage, 3230,
     /* 1598672 */     GIR_EraseRootFromParent_Done,
     /* 1598673 */   // Label 22085: @1598673
     /* 1598673 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1598759), // Rule ID 3231 //
     /* 1598678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1598695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1598698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598724 */     // MIs[0] policy
     /* 1598724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598734 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1598737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598758 */     // GIR_Coverage, 3231,
     /* 1598758 */     GIR_EraseRootFromParent_Done,
     /* 1598759 */   // Label 22086: @1598759
     /* 1598759 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1598845), // Rule ID 3234 //
     /* 1598764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1598781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1598784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598810 */     // MIs[0] policy
     /* 1598810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598820 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1598823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598844 */     // GIR_Coverage, 3234,
     /* 1598844 */     GIR_EraseRootFromParent_Done,
     /* 1598845 */   // Label 22087: @1598845
     /* 1598845 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1598931), // Rule ID 3235 //
     /* 1598850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1598867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1598870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598896 */     // MIs[0] policy
     /* 1598896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1598909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598930 */     // GIR_Coverage, 3235,
     /* 1598930 */     GIR_EraseRootFromParent_Done,
     /* 1598931 */   // Label 22088: @1598931
     /* 1598931 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1599017), // Rule ID 3238 //
     /* 1598936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1598947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1598950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1598953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1598956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598982 */     // MIs[0] policy
     /* 1598982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598992 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1598995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599016 */     // GIR_Coverage, 3238,
     /* 1599016 */     GIR_EraseRootFromParent_Done,
     /* 1599017 */   // Label 22089: @1599017
     /* 1599017 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1599103), // Rule ID 3239 //
     /* 1599022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1599033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1599036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1599039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1599042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599068 */     // MIs[0] policy
     /* 1599068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599078 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1599081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599102 */     // GIR_Coverage, 3239,
     /* 1599102 */     GIR_EraseRootFromParent_Done,
     /* 1599103 */   // Label 22090: @1599103
     /* 1599103 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1599189), // Rule ID 3242 //
     /* 1599108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1599119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1599122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1599125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1599128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599154 */     // MIs[0] policy
     /* 1599154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599164 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1599167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599188 */     // GIR_Coverage, 3242,
     /* 1599188 */     GIR_EraseRootFromParent_Done,
     /* 1599189 */   // Label 22091: @1599189
     /* 1599189 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1599275), // Rule ID 3243 //
     /* 1599194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1599205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1599208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1599211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1599214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599240 */     // MIs[0] policy
     /* 1599240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1599253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599274 */     // GIR_Coverage, 3243,
     /* 1599274 */     GIR_EraseRootFromParent_Done,
     /* 1599275 */   // Label 22092: @1599275
     /* 1599275 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1599361), // Rule ID 3246 //
     /* 1599280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1599291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1599294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1599297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1599300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599326 */     // MIs[0] policy
     /* 1599326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599336 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1599339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599360 */     // GIR_Coverage, 3246,
     /* 1599360 */     GIR_EraseRootFromParent_Done,
     /* 1599361 */   // Label 22093: @1599361
     /* 1599361 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1599447), // Rule ID 3247 //
     /* 1599366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1599377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1599380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1599383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1599386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599412 */     // MIs[0] policy
     /* 1599412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599422 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1599425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599446 */     // GIR_Coverage, 3247,
     /* 1599446 */     GIR_EraseRootFromParent_Done,
     /* 1599447 */   // Label 22094: @1599447
     /* 1599447 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1599533), // Rule ID 3250 //
     /* 1599452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1599463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1599466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1599469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1599472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599498 */     // MIs[0] policy
     /* 1599498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1599511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599532 */     // GIR_Coverage, 3250,
     /* 1599532 */     GIR_EraseRootFromParent_Done,
     /* 1599533 */   // Label 22095: @1599533
     /* 1599533 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1599619), // Rule ID 3251 //
     /* 1599538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1599549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1599552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1599555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1599558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599584 */     // MIs[0] policy
     /* 1599584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1599597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599618 */     // GIR_Coverage, 3251,
     /* 1599618 */     GIR_EraseRootFromParent_Done,
     /* 1599619 */   // Label 22096: @1599619
     /* 1599619 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1599705), // Rule ID 3254 //
     /* 1599624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1599635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1599638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1599641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1599644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599670 */     // MIs[0] policy
     /* 1599670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1599683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599704 */     // GIR_Coverage, 3254,
     /* 1599704 */     GIR_EraseRootFromParent_Done,
     /* 1599705 */   // Label 22097: @1599705
     /* 1599705 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1599791), // Rule ID 3255 //
     /* 1599710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1599721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1599724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1599727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1599730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599756 */     // MIs[0] policy
     /* 1599756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1599769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599790 */     // GIR_Coverage, 3255,
     /* 1599790 */     GIR_EraseRootFromParent_Done,
     /* 1599791 */   // Label 22098: @1599791
     /* 1599791 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1599877), // Rule ID 3258 //
     /* 1599796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1599813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1599816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599842 */     // MIs[0] policy
     /* 1599842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1599855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599876 */     // GIR_Coverage, 3258,
     /* 1599876 */     GIR_EraseRootFromParent_Done,
     /* 1599877 */   // Label 22099: @1599877
     /* 1599877 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1599963), // Rule ID 3259 //
     /* 1599882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1599899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1599902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599928 */     // MIs[0] policy
     /* 1599928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1599941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599962 */     // GIR_Coverage, 3259,
     /* 1599962 */     GIR_EraseRootFromParent_Done,
     /* 1599963 */   // Label 22100: @1599963
     /* 1599963 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1600049), // Rule ID 3262 //
     /* 1599968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1599979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1599982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1599985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1599988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600014 */     // MIs[0] policy
     /* 1600014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1600027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600048 */     // GIR_Coverage, 3262,
     /* 1600048 */     GIR_EraseRootFromParent_Done,
     /* 1600049 */   // Label 22101: @1600049
     /* 1600049 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1600135), // Rule ID 3263 //
     /* 1600054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1600065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1600068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1600071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1600074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600100 */     // MIs[0] policy
     /* 1600100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1600113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600134 */     // GIR_Coverage, 3263,
     /* 1600134 */     GIR_EraseRootFromParent_Done,
     /* 1600135 */   // Label 22102: @1600135
     /* 1600135 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1600221), // Rule ID 3266 //
     /* 1600140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1600151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1600154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1600157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1600160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600186 */     // MIs[0] policy
     /* 1600186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600196 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1600199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600220 */     // GIR_Coverage, 3266,
     /* 1600220 */     GIR_EraseRootFromParent_Done,
     /* 1600221 */   // Label 22103: @1600221
     /* 1600221 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1600307), // Rule ID 3267 //
     /* 1600226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1600237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1600240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1600243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1600246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600272 */     // MIs[0] policy
     /* 1600272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1600285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600306 */     // GIR_Coverage, 3267,
     /* 1600306 */     GIR_EraseRootFromParent_Done,
     /* 1600307 */   // Label 22104: @1600307
     /* 1600307 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1600393), // Rule ID 3270 //
     /* 1600312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1600323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1600326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1600329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1600332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600358 */     // MIs[0] policy
     /* 1600358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600368 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1600371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600392 */     // GIR_Coverage, 3270,
     /* 1600392 */     GIR_EraseRootFromParent_Done,
     /* 1600393 */   // Label 22105: @1600393
     /* 1600393 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1600479), // Rule ID 3271 //
     /* 1600398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1600409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1600412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1600415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1600418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600444 */     // MIs[0] policy
     /* 1600444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600454 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1600457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600478 */     // GIR_Coverage, 3271,
     /* 1600478 */     GIR_EraseRootFromParent_Done,
     /* 1600479 */   // Label 22106: @1600479
     /* 1600479 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1600565), // Rule ID 3274 //
     /* 1600484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1600495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1600498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1600501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1600504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600530 */     // MIs[0] policy
     /* 1600530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1600543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600564 */     // GIR_Coverage, 3274,
     /* 1600564 */     GIR_EraseRootFromParent_Done,
     /* 1600565 */   // Label 22107: @1600565
     /* 1600565 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1600651), // Rule ID 3275 //
     /* 1600570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1600581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1600584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1600587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1600590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600616 */     // MIs[0] policy
     /* 1600616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1600629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600650 */     // GIR_Coverage, 3275,
     /* 1600650 */     GIR_EraseRootFromParent_Done,
     /* 1600651 */   // Label 22108: @1600651
     /* 1600651 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1600737), // Rule ID 3278 //
     /* 1600656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1600667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1600670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1600673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1600676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1600679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600702 */     // MIs[0] policy
     /* 1600702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600712 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1600715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600736 */     // GIR_Coverage, 3278,
     /* 1600736 */     GIR_EraseRootFromParent_Done,
     /* 1600737 */   // Label 22109: @1600737
     /* 1600737 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1600823), // Rule ID 3279 //
     /* 1600742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1600753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1600756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1600759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1600762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1600765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600788 */     // MIs[0] policy
     /* 1600788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1600801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600822 */     // GIR_Coverage, 3279,
     /* 1600822 */     GIR_EraseRootFromParent_Done,
     /* 1600823 */   // Label 22110: @1600823
     /* 1600823 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1600909), // Rule ID 3282 //
     /* 1600828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1600839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1600842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1600845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1600848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600874 */     // MIs[0] policy
     /* 1600874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1600887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600908 */     // GIR_Coverage, 3282,
     /* 1600908 */     GIR_EraseRootFromParent_Done,
     /* 1600909 */   // Label 22111: @1600909
     /* 1600909 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1600995), // Rule ID 3283 //
     /* 1600914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1600925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1600928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1600931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1600934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600960 */     // MIs[0] policy
     /* 1600960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1600973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600994 */     // GIR_Coverage, 3283,
     /* 1600994 */     GIR_EraseRootFromParent_Done,
     /* 1600995 */   // Label 22112: @1600995
     /* 1600995 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1601081), // Rule ID 3286 //
     /* 1601000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1601011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1601014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1601017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1601020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601046 */     // MIs[0] policy
     /* 1601046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1601059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601080 */     // GIR_Coverage, 3286,
     /* 1601080 */     GIR_EraseRootFromParent_Done,
     /* 1601081 */   // Label 22113: @1601081
     /* 1601081 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1601167), // Rule ID 3287 //
     /* 1601086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1601097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1601100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1601103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1601106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601132 */     // MIs[0] policy
     /* 1601132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1601145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601166 */     // GIR_Coverage, 3287,
     /* 1601166 */     GIR_EraseRootFromParent_Done,
     /* 1601167 */   // Label 22114: @1601167
     /* 1601167 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1601253), // Rule ID 3290 //
     /* 1601172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1601183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1601186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1601189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1601192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1601195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601218 */     // MIs[0] policy
     /* 1601218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1601231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601252 */     // GIR_Coverage, 3290,
     /* 1601252 */     GIR_EraseRootFromParent_Done,
     /* 1601253 */   // Label 22115: @1601253
     /* 1601253 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1601339), // Rule ID 3291 //
     /* 1601258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1601269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1601272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1601275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1601278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1601281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601304 */     // MIs[0] policy
     /* 1601304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1601317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601338 */     // GIR_Coverage, 3291,
     /* 1601338 */     GIR_EraseRootFromParent_Done,
     /* 1601339 */   // Label 22116: @1601339
     /* 1601339 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1601425), // Rule ID 3294 //
     /* 1601344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1601355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1601358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1601361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1601364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601390 */     // MIs[0] policy
     /* 1601390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1601403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601424 */     // GIR_Coverage, 3294,
     /* 1601424 */     GIR_EraseRootFromParent_Done,
     /* 1601425 */   // Label 22117: @1601425
     /* 1601425 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1601511), // Rule ID 3295 //
     /* 1601430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1601441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1601444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1601447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1601450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601476 */     // MIs[0] policy
     /* 1601476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1601489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601510 */     // GIR_Coverage, 3295,
     /* 1601510 */     GIR_EraseRootFromParent_Done,
     /* 1601511 */   // Label 22118: @1601511
     /* 1601511 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1601597), // Rule ID 3298 //
     /* 1601516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1601527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1601530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1601533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1601536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601562 */     // MIs[0] policy
     /* 1601562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1601575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601596 */     // GIR_Coverage, 3298,
     /* 1601596 */     GIR_EraseRootFromParent_Done,
     /* 1601597 */   // Label 22119: @1601597
     /* 1601597 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1601683), // Rule ID 3299 //
     /* 1601602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1601613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1601616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1601619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1601622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601648 */     // MIs[0] policy
     /* 1601648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1601661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601682 */     // GIR_Coverage, 3299,
     /* 1601682 */     GIR_EraseRootFromParent_Done,
     /* 1601683 */   // Label 22120: @1601683
     /* 1601683 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1601769), // Rule ID 3302 //
     /* 1601688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1601699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1601702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1601705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1601708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601734 */     // MIs[0] policy
     /* 1601734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1601747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601768 */     // GIR_Coverage, 3302,
     /* 1601768 */     GIR_EraseRootFromParent_Done,
     /* 1601769 */   // Label 22121: @1601769
     /* 1601769 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1601855), // Rule ID 3303 //
     /* 1601774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1601785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1601788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1601791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1601794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601820 */     // MIs[0] policy
     /* 1601820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1601833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601854 */     // GIR_Coverage, 3303,
     /* 1601854 */     GIR_EraseRootFromParent_Done,
     /* 1601855 */   // Label 22122: @1601855
     /* 1601855 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1601941), // Rule ID 3306 //
     /* 1601860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1601871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1601874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1601877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1601880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601906 */     // MIs[0] policy
     /* 1601906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1601919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601940 */     // GIR_Coverage, 3306,
     /* 1601940 */     GIR_EraseRootFromParent_Done,
     /* 1601941 */   // Label 22123: @1601941
     /* 1601941 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1602027), // Rule ID 3307 //
     /* 1601946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1601957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1601960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1601963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1601966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601992 */     // MIs[0] policy
     /* 1601992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1602005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602026 */     // GIR_Coverage, 3307,
     /* 1602026 */     GIR_EraseRootFromParent_Done,
     /* 1602027 */   // Label 22124: @1602027
     /* 1602027 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1602113), // Rule ID 3310 //
     /* 1602032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1602043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1602046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1602049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1602052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602078 */     // MIs[0] policy
     /* 1602078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602088 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602112 */     // GIR_Coverage, 3310,
     /* 1602112 */     GIR_EraseRootFromParent_Done,
     /* 1602113 */   // Label 22125: @1602113
     /* 1602113 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1602199), // Rule ID 3311 //
     /* 1602118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1602129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1602132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1602135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1602138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602164 */     // MIs[0] policy
     /* 1602164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602198 */     // GIR_Coverage, 3311,
     /* 1602198 */     GIR_EraseRootFromParent_Done,
     /* 1602199 */   // Label 22126: @1602199
     /* 1602199 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1602285), // Rule ID 3314 //
     /* 1602204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1602215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1602218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1602221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1602224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1602234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602250 */     // MIs[0] policy
     /* 1602250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602260 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1602263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602284 */     // GIR_Coverage, 3314,
     /* 1602284 */     GIR_EraseRootFromParent_Done,
     /* 1602285 */   // Label 22127: @1602285
     /* 1602285 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1602371), // Rule ID 3315 //
     /* 1602290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1602301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1602304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1602307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1602310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1602320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602336 */     // MIs[0] policy
     /* 1602336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602346 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1602349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602370 */     // GIR_Coverage, 3315,
     /* 1602370 */     GIR_EraseRootFromParent_Done,
     /* 1602371 */   // Label 22128: @1602371
     /* 1602371 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1602457), // Rule ID 3318 //
     /* 1602376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1602387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1602390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1602393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602422 */     // MIs[0] policy
     /* 1602422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1602435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602456 */     // GIR_Coverage, 3318,
     /* 1602456 */     GIR_EraseRootFromParent_Done,
     /* 1602457 */   // Label 22129: @1602457
     /* 1602457 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1602543), // Rule ID 3319 //
     /* 1602462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1602473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1602476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1602479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602508 */     // MIs[0] policy
     /* 1602508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1602521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602542 */     // GIR_Coverage, 3319,
     /* 1602542 */     GIR_EraseRootFromParent_Done,
     /* 1602543 */   // Label 22130: @1602543
     /* 1602543 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1602629), // Rule ID 3322 //
     /* 1602548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1602559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1602562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1602565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602594 */     // MIs[0] policy
     /* 1602594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602604 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1602607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602628 */     // GIR_Coverage, 3322,
     /* 1602628 */     GIR_EraseRootFromParent_Done,
     /* 1602629 */   // Label 22131: @1602629
     /* 1602629 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1602715), // Rule ID 3323 //
     /* 1602634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1602645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1602648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1602651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602680 */     // MIs[0] policy
     /* 1602680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1602693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602714 */     // GIR_Coverage, 3323,
     /* 1602714 */     GIR_EraseRootFromParent_Done,
     /* 1602715 */   // Label 22132: @1602715
     /* 1602715 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1602801), // Rule ID 3326 //
     /* 1602720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1602731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1602734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1602737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602766 */     // MIs[0] policy
     /* 1602766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1602779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602800 */     // GIR_Coverage, 3326,
     /* 1602800 */     GIR_EraseRootFromParent_Done,
     /* 1602801 */   // Label 22133: @1602801
     /* 1602801 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1602887), // Rule ID 3327 //
     /* 1602806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1602817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1602820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1602823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602852 */     // MIs[0] policy
     /* 1602852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602862 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1602865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602886 */     // GIR_Coverage, 3327,
     /* 1602886 */     GIR_EraseRootFromParent_Done,
     /* 1602887 */   // Label 22134: @1602887
     /* 1602887 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1602973), // Rule ID 3330 //
     /* 1602892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1602903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1602906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1602909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602938 */     // MIs[0] policy
     /* 1602938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1602951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602972 */     // GIR_Coverage, 3330,
     /* 1602972 */     GIR_EraseRootFromParent_Done,
     /* 1602973 */   // Label 22135: @1602973
     /* 1602973 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1603059), // Rule ID 3331 //
     /* 1602978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1602989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1602992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1602995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603024 */     // MIs[0] policy
     /* 1603024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1603037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603058 */     // GIR_Coverage, 3331,
     /* 1603058 */     GIR_EraseRootFromParent_Done,
     /* 1603059 */   // Label 22136: @1603059
     /* 1603059 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1603145), // Rule ID 3334 //
     /* 1603064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1603075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1603078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1603081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603110 */     // MIs[0] policy
     /* 1603110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1603123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603144 */     // GIR_Coverage, 3334,
     /* 1603144 */     GIR_EraseRootFromParent_Done,
     /* 1603145 */   // Label 22137: @1603145
     /* 1603145 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1603231), // Rule ID 3335 //
     /* 1603150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1603161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1603164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1603167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603196 */     // MIs[0] policy
     /* 1603196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1603209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603230 */     // GIR_Coverage, 3335,
     /* 1603230 */     GIR_EraseRootFromParent_Done,
     /* 1603231 */   // Label 22138: @1603231
     /* 1603231 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1603317), // Rule ID 3338 //
     /* 1603236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1603247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1603250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1603253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603282 */     // MIs[0] policy
     /* 1603282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1603295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603316 */     // GIR_Coverage, 3338,
     /* 1603316 */     GIR_EraseRootFromParent_Done,
     /* 1603317 */   // Label 22139: @1603317
     /* 1603317 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1603403), // Rule ID 3339 //
     /* 1603322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1603333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1603336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1603339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603368 */     // MIs[0] policy
     /* 1603368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1603381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603402 */     // GIR_Coverage, 3339,
     /* 1603402 */     GIR_EraseRootFromParent_Done,
     /* 1603403 */   // Label 22140: @1603403
     /* 1603403 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1603489), // Rule ID 3342 //
     /* 1603408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1603419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1603422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1603425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603454 */     // MIs[0] policy
     /* 1603454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603488 */     // GIR_Coverage, 3342,
     /* 1603488 */     GIR_EraseRootFromParent_Done,
     /* 1603489 */   // Label 22141: @1603489
     /* 1603489 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1603575), // Rule ID 3343 //
     /* 1603494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1603505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1603508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1603511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603540 */     // MIs[0] policy
     /* 1603540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603574 */     // GIR_Coverage, 3343,
     /* 1603574 */     GIR_EraseRootFromParent_Done,
     /* 1603575 */   // Label 22142: @1603575
     /* 1603575 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1603661), // Rule ID 3346 //
     /* 1603580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1603591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1603594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603626 */     // MIs[0] policy
     /* 1603626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603660 */     // GIR_Coverage, 3346,
     /* 1603660 */     GIR_EraseRootFromParent_Done,
     /* 1603661 */   // Label 22143: @1603661
     /* 1603661 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1603747), // Rule ID 3347 //
     /* 1603666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1603677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1603680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603712 */     // MIs[0] policy
     /* 1603712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603746 */     // GIR_Coverage, 3347,
     /* 1603746 */     GIR_EraseRootFromParent_Done,
     /* 1603747 */   // Label 22144: @1603747
     /* 1603747 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1603833), // Rule ID 3350 //
     /* 1603752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1603763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1603766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1603769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603798 */     // MIs[0] policy
     /* 1603798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603832 */     // GIR_Coverage, 3350,
     /* 1603832 */     GIR_EraseRootFromParent_Done,
     /* 1603833 */   // Label 22145: @1603833
     /* 1603833 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1603919), // Rule ID 3351 //
     /* 1603838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1603849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1603852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1603855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603884 */     // MIs[0] policy
     /* 1603884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603918 */     // GIR_Coverage, 3351,
     /* 1603918 */     GIR_EraseRootFromParent_Done,
     /* 1603919 */   // Label 22146: @1603919
     /* 1603919 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1604005), // Rule ID 3354 //
     /* 1603924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1603927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1603935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1603938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1603941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603970 */     // MIs[0] policy
     /* 1603970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1603983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604004 */     // GIR_Coverage, 3354,
     /* 1604004 */     GIR_EraseRootFromParent_Done,
     /* 1604005 */   // Label 22147: @1604005
     /* 1604005 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1604091), // Rule ID 3355 //
     /* 1604010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1604021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1604024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1604027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604056 */     // MIs[0] policy
     /* 1604056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1604069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604090 */     // GIR_Coverage, 3355,
     /* 1604090 */     GIR_EraseRootFromParent_Done,
     /* 1604091 */   // Label 22148: @1604091
     /* 1604091 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1604177), // Rule ID 3358 //
     /* 1604096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1604107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1604110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1604113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604142 */     // MIs[0] policy
     /* 1604142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1604155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604176 */     // GIR_Coverage, 3358,
     /* 1604176 */     GIR_EraseRootFromParent_Done,
     /* 1604177 */   // Label 22149: @1604177
     /* 1604177 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1604263), // Rule ID 3359 //
     /* 1604182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1604193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1604196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1604199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604228 */     // MIs[0] policy
     /* 1604228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604238 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1604241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604262 */     // GIR_Coverage, 3359,
     /* 1604262 */     GIR_EraseRootFromParent_Done,
     /* 1604263 */   // Label 22150: @1604263
     /* 1604263 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1604349), // Rule ID 3362 //
     /* 1604268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1604279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1604282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1604285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604314 */     // MIs[0] policy
     /* 1604314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604324 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1604327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604348 */     // GIR_Coverage, 3362,
     /* 1604348 */     GIR_EraseRootFromParent_Done,
     /* 1604349 */   // Label 22151: @1604349
     /* 1604349 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1604435), // Rule ID 3363 //
     /* 1604354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1604365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1604368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1604371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604400 */     // MIs[0] policy
     /* 1604400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1604413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604434 */     // GIR_Coverage, 3363,
     /* 1604434 */     GIR_EraseRootFromParent_Done,
     /* 1604435 */   // Label 22152: @1604435
     /* 1604435 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1604521), // Rule ID 3366 //
     /* 1604440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1604451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1604454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1604457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1604463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604486 */     // MIs[0] policy
     /* 1604486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604496 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1604499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604520 */     // GIR_Coverage, 3366,
     /* 1604520 */     GIR_EraseRootFromParent_Done,
     /* 1604521 */   // Label 22153: @1604521
     /* 1604521 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1604607), // Rule ID 3367 //
     /* 1604526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1604537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1604540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1604543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1604549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604572 */     // MIs[0] policy
     /* 1604572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604582 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1604585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604606 */     // GIR_Coverage, 3367,
     /* 1604606 */     GIR_EraseRootFromParent_Done,
     /* 1604607 */   // Label 22154: @1604607
     /* 1604607 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1604693), // Rule ID 3370 //
     /* 1604612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1604623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1604626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1604629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604658 */     // MIs[0] policy
     /* 1604658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1604671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604692 */     // GIR_Coverage, 3370,
     /* 1604692 */     GIR_EraseRootFromParent_Done,
     /* 1604693 */   // Label 22155: @1604693
     /* 1604693 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1604779), // Rule ID 3371 //
     /* 1604698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1604709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1604712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1604715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604744 */     // MIs[0] policy
     /* 1604744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1604757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604778 */     // GIR_Coverage, 3371,
     /* 1604778 */     GIR_EraseRootFromParent_Done,
     /* 1604779 */   // Label 22156: @1604779
     /* 1604779 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1604865), // Rule ID 3374 //
     /* 1604784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1604795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1604798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604830 */     // MIs[0] policy
     /* 1604830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1604843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604864 */     // GIR_Coverage, 3374,
     /* 1604864 */     GIR_EraseRootFromParent_Done,
     /* 1604865 */   // Label 22157: @1604865
     /* 1604865 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1604951), // Rule ID 3375 //
     /* 1604870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1604881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1604884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604916 */     // MIs[0] policy
     /* 1604916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1604929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604950 */     // GIR_Coverage, 3375,
     /* 1604950 */     GIR_EraseRootFromParent_Done,
     /* 1604951 */   // Label 22158: @1604951
     /* 1604951 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1605037), // Rule ID 3378 //
     /* 1604956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1604967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1604970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1604973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605002 */     // MIs[0] policy
     /* 1605002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605012 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1605015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605036 */     // GIR_Coverage, 3378,
     /* 1605036 */     GIR_EraseRootFromParent_Done,
     /* 1605037 */   // Label 22159: @1605037
     /* 1605037 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1605123), // Rule ID 3379 //
     /* 1605042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1605053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1605056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1605059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1605065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605088 */     // MIs[0] policy
     /* 1605088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1605101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605122 */     // GIR_Coverage, 3379,
     /* 1605122 */     GIR_EraseRootFromParent_Done,
     /* 1605123 */   // Label 22160: @1605123
     /* 1605123 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1605209), // Rule ID 3382 //
     /* 1605128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1605139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1605142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1605145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605174 */     // MIs[0] policy
     /* 1605174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1605187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605208 */     // GIR_Coverage, 3382,
     /* 1605208 */     GIR_EraseRootFromParent_Done,
     /* 1605209 */   // Label 22161: @1605209
     /* 1605209 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1605295), // Rule ID 3383 //
     /* 1605214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1605225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1605228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1605231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605260 */     // MIs[0] policy
     /* 1605260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1605273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605294 */     // GIR_Coverage, 3383,
     /* 1605294 */     GIR_EraseRootFromParent_Done,
     /* 1605295 */   // Label 22162: @1605295
     /* 1605295 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1605381), // Rule ID 3386 //
     /* 1605300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1605311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1605314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1605317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605346 */     // MIs[0] policy
     /* 1605346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1605359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605380 */     // GIR_Coverage, 3386,
     /* 1605380 */     GIR_EraseRootFromParent_Done,
     /* 1605381 */   // Label 22163: @1605381
     /* 1605381 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1605467), // Rule ID 3387 //
     /* 1605386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1605397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1605400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1605403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605432 */     // MIs[0] policy
     /* 1605432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1605445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605466 */     // GIR_Coverage, 3387,
     /* 1605466 */     GIR_EraseRootFromParent_Done,
     /* 1605467 */   // Label 22164: @1605467
     /* 1605467 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1605553), // Rule ID 3390 //
     /* 1605472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1605483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1605486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1605489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1605495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605518 */     // MIs[0] policy
     /* 1605518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1605531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605552 */     // GIR_Coverage, 3390,
     /* 1605552 */     GIR_EraseRootFromParent_Done,
     /* 1605553 */   // Label 22165: @1605553
     /* 1605553 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1605639), // Rule ID 3391 //
     /* 1605558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1605569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1605572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1605575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1605581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605604 */     // MIs[0] policy
     /* 1605604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1605617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605638 */     // GIR_Coverage, 3391,
     /* 1605638 */     GIR_EraseRootFromParent_Done,
     /* 1605639 */   // Label 22166: @1605639
     /* 1605639 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1605725), // Rule ID 3394 //
     /* 1605644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1605655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1605658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605690 */     // MIs[0] policy
     /* 1605690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1605703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605724 */     // GIR_Coverage, 3394,
     /* 1605724 */     GIR_EraseRootFromParent_Done,
     /* 1605725 */   // Label 22167: @1605725
     /* 1605725 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1605811), // Rule ID 3395 //
     /* 1605730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1605741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1605744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605776 */     // MIs[0] policy
     /* 1605776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1605789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605810 */     // GIR_Coverage, 3395,
     /* 1605810 */     GIR_EraseRootFromParent_Done,
     /* 1605811 */   // Label 22168: @1605811
     /* 1605811 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1605897), // Rule ID 3398 //
     /* 1605816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1605827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1605830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605862 */     // MIs[0] policy
     /* 1605862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1605875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605896 */     // GIR_Coverage, 3398,
     /* 1605896 */     GIR_EraseRootFromParent_Done,
     /* 1605897 */   // Label 22169: @1605897
     /* 1605897 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1605983), // Rule ID 3399 //
     /* 1605902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1605913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1605916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605948 */     // MIs[0] policy
     /* 1605948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605958 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1605961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605982 */     // GIR_Coverage, 3399,
     /* 1605982 */     GIR_EraseRootFromParent_Done,
     /* 1605983 */   // Label 22170: @1605983
     /* 1605983 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1606069), // Rule ID 3402 //
     /* 1605988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1605999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1606002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1606005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606034 */     // MIs[0] policy
     /* 1606034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606044 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606068 */     // GIR_Coverage, 3402,
     /* 1606068 */     GIR_EraseRootFromParent_Done,
     /* 1606069 */   // Label 22171: @1606069
     /* 1606069 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1606155), // Rule ID 3403 //
     /* 1606074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1606085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1606088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1606091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606120 */     // MIs[0] policy
     /* 1606120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606154 */     // GIR_Coverage, 3403,
     /* 1606154 */     GIR_EraseRootFromParent_Done,
     /* 1606155 */   // Label 22172: @1606155
     /* 1606155 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1606241), // Rule ID 3406 //
     /* 1606160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1606171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1606174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1606177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606206 */     // MIs[0] policy
     /* 1606206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606216 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1606219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606240 */     // GIR_Coverage, 3406,
     /* 1606240 */     GIR_EraseRootFromParent_Done,
     /* 1606241 */   // Label 22173: @1606241
     /* 1606241 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1606327), // Rule ID 3407 //
     /* 1606246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1606257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1606260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1606263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606292 */     // MIs[0] policy
     /* 1606292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606302 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1606305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606326 */     // GIR_Coverage, 3407,
     /* 1606326 */     GIR_EraseRootFromParent_Done,
     /* 1606327 */   // Label 22174: @1606327
     /* 1606327 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1606413), // Rule ID 3410 //
     /* 1606332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1606343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1606346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1606349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606378 */     // MIs[0] policy
     /* 1606378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1606391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606412 */     // GIR_Coverage, 3410,
     /* 1606412 */     GIR_EraseRootFromParent_Done,
     /* 1606413 */   // Label 22175: @1606413
     /* 1606413 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1606499), // Rule ID 3411 //
     /* 1606418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1606429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1606432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1606435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606464 */     // MIs[0] policy
     /* 1606464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606474 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1606477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606498 */     // GIR_Coverage, 3411,
     /* 1606498 */     GIR_EraseRootFromParent_Done,
     /* 1606499 */   // Label 22176: @1606499
     /* 1606499 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1606585), // Rule ID 3414 //
     /* 1606504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1606515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1606518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1606521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606550 */     // MIs[0] policy
     /* 1606550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1606563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606584 */     // GIR_Coverage, 3414,
     /* 1606584 */     GIR_EraseRootFromParent_Done,
     /* 1606585 */   // Label 22177: @1606585
     /* 1606585 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1606671), // Rule ID 3415 //
     /* 1606590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1606601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1606604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1606607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606636 */     // MIs[0] policy
     /* 1606636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1606649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606670 */     // GIR_Coverage, 3415,
     /* 1606670 */     GIR_EraseRootFromParent_Done,
     /* 1606671 */   // Label 22178: @1606671
     /* 1606671 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1606757), // Rule ID 3418 //
     /* 1606676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1606687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1606690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1606693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606722 */     // MIs[0] policy
     /* 1606722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606732 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1606735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606756 */     // GIR_Coverage, 3418,
     /* 1606756 */     GIR_EraseRootFromParent_Done,
     /* 1606757 */   // Label 22179: @1606757
     /* 1606757 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1606843), // Rule ID 3419 //
     /* 1606762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1606773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1606776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1606779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606808 */     // MIs[0] policy
     /* 1606808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1606821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606842 */     // GIR_Coverage, 3419,
     /* 1606842 */     GIR_EraseRootFromParent_Done,
     /* 1606843 */   // Label 22180: @1606843
     /* 1606843 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1606929), // Rule ID 3422 //
     /* 1606848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1606859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1606862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606894 */     // MIs[0] policy
     /* 1606894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1606907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606928 */     // GIR_Coverage, 3422,
     /* 1606928 */     GIR_EraseRootFromParent_Done,
     /* 1606929 */   // Label 22181: @1606929
     /* 1606929 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1607015), // Rule ID 3423 //
     /* 1606934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1606942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1606945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1606948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606980 */     // MIs[0] policy
     /* 1606980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1606993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607014 */     // GIR_Coverage, 3423,
     /* 1607014 */     GIR_EraseRootFromParent_Done,
     /* 1607015 */   // Label 22182: @1607015
     /* 1607015 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1607101), // Rule ID 3426 //
     /* 1607020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1607031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1607034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607066 */     // MIs[0] policy
     /* 1607066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607076 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1607079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607100 */     // GIR_Coverage, 3426,
     /* 1607100 */     GIR_EraseRootFromParent_Done,
     /* 1607101 */   // Label 22183: @1607101
     /* 1607101 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1607187), // Rule ID 3427 //
     /* 1607106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1607117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1607120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607152 */     // MIs[0] policy
     /* 1607152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607162 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1607165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607186 */     // GIR_Coverage, 3427,
     /* 1607186 */     GIR_EraseRootFromParent_Done,
     /* 1607187 */   // Label 22184: @1607187
     /* 1607187 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1607273), // Rule ID 3430 //
     /* 1607192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1607203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1607206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1607209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607238 */     // MIs[0] policy
     /* 1607238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607248 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607272 */     // GIR_Coverage, 3430,
     /* 1607272 */     GIR_EraseRootFromParent_Done,
     /* 1607273 */   // Label 22185: @1607273
     /* 1607273 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1607359), // Rule ID 3431 //
     /* 1607278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1607289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1607292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1607295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607324 */     // MIs[0] policy
     /* 1607324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607334 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607358 */     // GIR_Coverage, 3431,
     /* 1607358 */     GIR_EraseRootFromParent_Done,
     /* 1607359 */   // Label 22186: @1607359
     /* 1607359 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1607445), // Rule ID 3434 //
     /* 1607364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1607375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1607378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1607381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607410 */     // MIs[0] policy
     /* 1607410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607420 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607444 */     // GIR_Coverage, 3434,
     /* 1607444 */     GIR_EraseRootFromParent_Done,
     /* 1607445 */   // Label 22187: @1607445
     /* 1607445 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1607531), // Rule ID 3435 //
     /* 1607450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1607461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1607464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1607467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607496 */     // MIs[0] policy
     /* 1607496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607530 */     // GIR_Coverage, 3435,
     /* 1607530 */     GIR_EraseRootFromParent_Done,
     /* 1607531 */   // Label 22188: @1607531
     /* 1607531 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1607617), // Rule ID 3438 //
     /* 1607536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1607547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1607550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607582 */     // MIs[0] policy
     /* 1607582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607616 */     // GIR_Coverage, 3438,
     /* 1607616 */     GIR_EraseRootFromParent_Done,
     /* 1607617 */   // Label 22189: @1607617
     /* 1607617 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1607703), // Rule ID 3439 //
     /* 1607622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1607633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1607636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607668 */     // MIs[0] policy
     /* 1607668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607702 */     // GIR_Coverage, 3439,
     /* 1607702 */     GIR_EraseRootFromParent_Done,
     /* 1607703 */   // Label 22190: @1607703
     /* 1607703 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1607789), // Rule ID 3442 //
     /* 1607708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1607711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1607719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1607722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1607725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607754 */     // MIs[0] policy
     /* 1607754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1607785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607788 */     // GIR_Coverage, 3442,
     /* 1607788 */     GIR_EraseRootFromParent_Done,
     /* 1607789 */   // Label 22191: @1607789
     /* 1607789 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1607875), // Rule ID 3443 //
     /* 1607794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1607797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1607805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1607808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1607811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607840 */     // MIs[0] policy
     /* 1607840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1607853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1607871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607874 */     // GIR_Coverage, 3443,
     /* 1607874 */     GIR_EraseRootFromParent_Done,
     /* 1607875 */   // Label 22192: @1607875
     /* 1607875 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1607961), // Rule ID 3446 //
     /* 1607880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1607891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1607894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1607897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607926 */     // MIs[0] policy
     /* 1607926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1607939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1607957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607960 */     // GIR_Coverage, 3446,
     /* 1607960 */     GIR_EraseRootFromParent_Done,
     /* 1607961 */   // Label 22193: @1607961
     /* 1607961 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1608047), // Rule ID 3447 //
     /* 1607966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1607974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1607977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1607980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1607983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608012 */     // MIs[0] policy
     /* 1608012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1608025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608046 */     // GIR_Coverage, 3447,
     /* 1608046 */     GIR_EraseRootFromParent_Done,
     /* 1608047 */   // Label 22194: @1608047
     /* 1608047 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1608133), // Rule ID 3450 //
     /* 1608052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1608063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1608066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1608069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1608075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608098 */     // MIs[0] policy
     /* 1608098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608108 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1608111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608132 */     // GIR_Coverage, 3450,
     /* 1608132 */     GIR_EraseRootFromParent_Done,
     /* 1608133 */   // Label 22195: @1608133
     /* 1608133 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1608219), // Rule ID 3451 //
     /* 1608138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1608149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1608152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1608155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1608161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608184 */     // MIs[0] policy
     /* 1608184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1608197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608218 */     // GIR_Coverage, 3451,
     /* 1608218 */     GIR_EraseRootFromParent_Done,
     /* 1608219 */   // Label 22196: @1608219
     /* 1608219 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1608305), // Rule ID 3454 //
     /* 1608224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1608235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1608238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1608241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1608247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608270 */     // MIs[0] policy
     /* 1608270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608280 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1608283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608304 */     // GIR_Coverage, 3454,
     /* 1608304 */     GIR_EraseRootFromParent_Done,
     /* 1608305 */   // Label 22197: @1608305
     /* 1608305 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1608391), // Rule ID 3455 //
     /* 1608310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1608321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1608324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1608327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1608333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608356 */     // MIs[0] policy
     /* 1608356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608366 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1608369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608390 */     // GIR_Coverage, 3455,
     /* 1608390 */     GIR_EraseRootFromParent_Done,
     /* 1608391 */   // Label 22198: @1608391
     /* 1608391 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1608477), // Rule ID 3458 //
     /* 1608396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1608407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1608410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1608413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608442 */     // MIs[0] policy
     /* 1608442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1608455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608476 */     // GIR_Coverage, 3458,
     /* 1608476 */     GIR_EraseRootFromParent_Done,
     /* 1608477 */   // Label 22199: @1608477
     /* 1608477 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1608563), // Rule ID 3459 //
     /* 1608482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1608493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1608496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1608499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608528 */     // MIs[0] policy
     /* 1608528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1608541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608562 */     // GIR_Coverage, 3459,
     /* 1608562 */     GIR_EraseRootFromParent_Done,
     /* 1608563 */   // Label 22200: @1608563
     /* 1608563 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1608649), // Rule ID 3462 //
     /* 1608568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1608579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1608582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1608585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608614 */     // MIs[0] policy
     /* 1608614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1608627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608648 */     // GIR_Coverage, 3462,
     /* 1608648 */     GIR_EraseRootFromParent_Done,
     /* 1608649 */   // Label 22201: @1608649
     /* 1608649 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1608735), // Rule ID 3463 //
     /* 1608654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1608665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1608668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1608671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608700 */     // MIs[0] policy
     /* 1608700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1608713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608734 */     // GIR_Coverage, 3463,
     /* 1608734 */     GIR_EraseRootFromParent_Done,
     /* 1608735 */   // Label 22202: @1608735
     /* 1608735 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1608821), // Rule ID 3466 //
     /* 1608740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1608751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1608754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1608757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1608763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608786 */     // MIs[0] policy
     /* 1608786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608796 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1608799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608820 */     // GIR_Coverage, 3466,
     /* 1608820 */     GIR_EraseRootFromParent_Done,
     /* 1608821 */   // Label 22203: @1608821
     /* 1608821 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1608907), // Rule ID 3467 //
     /* 1608826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1608837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1608840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1608843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1608849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608872 */     // MIs[0] policy
     /* 1608872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608882 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1608885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608906 */     // GIR_Coverage, 3467,
     /* 1608906 */     GIR_EraseRootFromParent_Done,
     /* 1608907 */   // Label 22204: @1608907
     /* 1608907 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1608993), // Rule ID 3470 //
     /* 1608912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1608923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1608926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1608929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608958 */     // MIs[0] policy
     /* 1608958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1608971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608992 */     // GIR_Coverage, 3470,
     /* 1608992 */     GIR_EraseRootFromParent_Done,
     /* 1608993 */   // Label 22205: @1608993
     /* 1608993 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1609079), // Rule ID 3471 //
     /* 1608998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1609009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1609012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1609015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1609028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609044 */     // MIs[0] policy
     /* 1609044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1609057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609078 */     // GIR_Coverage, 3471,
     /* 1609078 */     GIR_EraseRootFromParent_Done,
     /* 1609079 */   // Label 22206: @1609079
     /* 1609079 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1609165), // Rule ID 3474 //
     /* 1609084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1609095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1609098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1609101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609130 */     // MIs[0] policy
     /* 1609130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1609143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609164 */     // GIR_Coverage, 3474,
     /* 1609164 */     GIR_EraseRootFromParent_Done,
     /* 1609165 */   // Label 22207: @1609165
     /* 1609165 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1609251), // Rule ID 3475 //
     /* 1609170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1609181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1609184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1609187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609216 */     // MIs[0] policy
     /* 1609216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1609229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609250 */     // GIR_Coverage, 3475,
     /* 1609250 */     GIR_EraseRootFromParent_Done,
     /* 1609251 */   // Label 22208: @1609251
     /* 1609251 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1609337), // Rule ID 3478 //
     /* 1609256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1609267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1609270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1609273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1609279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609302 */     // MIs[0] policy
     /* 1609302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609312 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1609315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609336 */     // GIR_Coverage, 3478,
     /* 1609336 */     GIR_EraseRootFromParent_Done,
     /* 1609337 */   // Label 22209: @1609337
     /* 1609337 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1609423), // Rule ID 3479 //
     /* 1609342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1609353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1609356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1609359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1609365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609388 */     // MIs[0] policy
     /* 1609388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1609401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609422 */     // GIR_Coverage, 3479,
     /* 1609422 */     GIR_EraseRootFromParent_Done,
     /* 1609423 */   // Label 22210: @1609423
     /* 1609423 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1609509), // Rule ID 3482 //
     /* 1609428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1609431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1609439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1609442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1609445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1609458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609474 */     // MIs[0] policy
     /* 1609474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1609487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609508 */     // GIR_Coverage, 3482,
     /* 1609508 */     GIR_EraseRootFromParent_Done,
     /* 1609509 */   // Label 22211: @1609509
     /* 1609509 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1609595), // Rule ID 3483 //
     /* 1609514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1609517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1609525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1609528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1609531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1609544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609560 */     // MIs[0] policy
     /* 1609560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1609573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609594 */     // GIR_Coverage, 3483,
     /* 1609594 */     GIR_EraseRootFromParent_Done,
     /* 1609595 */   // Label 22212: @1609595
     /* 1609595 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1609681), // Rule ID 3486 //
     /* 1609600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1609603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1609611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1609614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1609617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609646 */     // MIs[0] policy
     /* 1609646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609656 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1609659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609680 */     // GIR_Coverage, 3486,
     /* 1609680 */     GIR_EraseRootFromParent_Done,
     /* 1609681 */   // Label 22213: @1609681
     /* 1609681 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1609767), // Rule ID 3487 //
     /* 1609686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1609689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1609697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1609700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1609703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609732 */     // MIs[0] policy
     /* 1609732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1609745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609766 */     // GIR_Coverage, 3487,
     /* 1609766 */     GIR_EraseRootFromParent_Done,
     /* 1609767 */   // Label 22214: @1609767
     /* 1609767 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1609853), // Rule ID 3490 //
     /* 1609772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1609775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1609783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1609786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1609789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609818 */     // MIs[0] policy
     /* 1609818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609828 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1609831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609852 */     // GIR_Coverage, 3490,
     /* 1609852 */     GIR_EraseRootFromParent_Done,
     /* 1609853 */   // Label 22215: @1609853
     /* 1609853 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1609939), // Rule ID 3491 //
     /* 1609858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1609861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1609869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1609872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1609875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609904 */     // MIs[0] policy
     /* 1609904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609914 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1609917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1609935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609938 */     // GIR_Coverage, 3491,
     /* 1609938 */     GIR_EraseRootFromParent_Done,
     /* 1609939 */   // Label 22216: @1609939
     /* 1609939 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1610025), // Rule ID 3582 //
     /* 1609944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1609961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1609964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609990 */     // MIs[0] policy
     /* 1609990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1610003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610024 */     // GIR_Coverage, 3582,
     /* 1610024 */     GIR_EraseRootFromParent_Done,
     /* 1610025 */   // Label 22217: @1610025
     /* 1610025 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1610111), // Rule ID 3583 //
     /* 1610030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1610041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1610044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1610047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1610050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610076 */     // MIs[0] policy
     /* 1610076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1610089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610110 */     // GIR_Coverage, 3583,
     /* 1610110 */     GIR_EraseRootFromParent_Done,
     /* 1610111 */   // Label 22218: @1610111
     /* 1610111 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1610197), // Rule ID 3586 //
     /* 1610116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1610127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1610130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1610133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1610136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610162 */     // MIs[0] policy
     /* 1610162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1610175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610196 */     // GIR_Coverage, 3586,
     /* 1610196 */     GIR_EraseRootFromParent_Done,
     /* 1610197 */   // Label 22219: @1610197
     /* 1610197 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1610283), // Rule ID 3587 //
     /* 1610202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1610213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1610216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1610219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1610222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610248 */     // MIs[0] policy
     /* 1610248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1610261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610282 */     // GIR_Coverage, 3587,
     /* 1610282 */     GIR_EraseRootFromParent_Done,
     /* 1610283 */   // Label 22220: @1610283
     /* 1610283 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1610369), // Rule ID 3590 //
     /* 1610288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1610305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1610308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610334 */     // MIs[0] policy
     /* 1610334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1610347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610368 */     // GIR_Coverage, 3590,
     /* 1610368 */     GIR_EraseRootFromParent_Done,
     /* 1610369 */   // Label 22221: @1610369
     /* 1610369 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1610455), // Rule ID 3591 //
     /* 1610374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1610385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1610388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1610391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1610394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610420 */     // MIs[0] policy
     /* 1610420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1610433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610454 */     // GIR_Coverage, 3591,
     /* 1610454 */     GIR_EraseRootFromParent_Done,
     /* 1610455 */   // Label 22222: @1610455
     /* 1610455 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1610541), // Rule ID 3594 //
     /* 1610460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1610477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1610480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610506 */     // MIs[0] policy
     /* 1610506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1610519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610540 */     // GIR_Coverage, 3594,
     /* 1610540 */     GIR_EraseRootFromParent_Done,
     /* 1610541 */   // Label 22223: @1610541
     /* 1610541 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1610627), // Rule ID 3595 //
     /* 1610546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1610563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1610566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610592 */     // MIs[0] policy
     /* 1610592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1610605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610626 */     // GIR_Coverage, 3595,
     /* 1610626 */     GIR_EraseRootFromParent_Done,
     /* 1610627 */   // Label 22224: @1610627
     /* 1610627 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1610713), // Rule ID 3598 //
     /* 1610632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1610652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610678 */     // MIs[0] policy
     /* 1610678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1610691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610712 */     // GIR_Coverage, 3598,
     /* 1610712 */     GIR_EraseRootFromParent_Done,
     /* 1610713 */   // Label 22225: @1610713
     /* 1610713 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1610799), // Rule ID 3599 //
     /* 1610718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1610738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610764 */     // MIs[0] policy
     /* 1610764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1610777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610798 */     // GIR_Coverage, 3599,
     /* 1610798 */     GIR_EraseRootFromParent_Done,
     /* 1610799 */   // Label 22226: @1610799
     /* 1610799 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1610885), // Rule ID 3602 //
     /* 1610804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1610815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1610818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1610824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610850 */     // MIs[0] policy
     /* 1610850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1610863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610884 */     // GIR_Coverage, 3602,
     /* 1610884 */     GIR_EraseRootFromParent_Done,
     /* 1610885 */   // Label 22227: @1610885
     /* 1610885 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1610971), // Rule ID 3603 //
     /* 1610890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1610901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1610904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1610910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610936 */     // MIs[0] policy
     /* 1610936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1610949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610970 */     // GIR_Coverage, 3603,
     /* 1610970 */     GIR_EraseRootFromParent_Done,
     /* 1610971 */   // Label 22228: @1610971
     /* 1610971 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1611057), // Rule ID 3606 //
     /* 1610976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1610987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1610990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1610993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1610996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611022 */     // MIs[0] policy
     /* 1611022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611032 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1611035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611056 */     // GIR_Coverage, 3606,
     /* 1611056 */     GIR_EraseRootFromParent_Done,
     /* 1611057 */   // Label 22229: @1611057
     /* 1611057 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1611143), // Rule ID 3607 //
     /* 1611062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1611073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1611076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1611079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1611082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1611085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611108 */     // MIs[0] policy
     /* 1611108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611118 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1611121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611142 */     // GIR_Coverage, 3607,
     /* 1611142 */     GIR_EraseRootFromParent_Done,
     /* 1611143 */   // Label 22230: @1611143
     /* 1611143 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1611229), // Rule ID 3610 //
     /* 1611148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1611159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1611162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1611165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1611168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611194 */     // MIs[0] policy
     /* 1611194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1611207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611228 */     // GIR_Coverage, 3610,
     /* 1611228 */     GIR_EraseRootFromParent_Done,
     /* 1611229 */   // Label 22231: @1611229
     /* 1611229 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1611315), // Rule ID 3611 //
     /* 1611234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1611245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1611248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1611251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1611254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611280 */     // MIs[0] policy
     /* 1611280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611290 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1611293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611314 */     // GIR_Coverage, 3611,
     /* 1611314 */     GIR_EraseRootFromParent_Done,
     /* 1611315 */   // Label 22232: @1611315
     /* 1611315 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1611401), // Rule ID 3614 //
     /* 1611320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1611337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1611340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611366 */     // MIs[0] policy
     /* 1611366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1611379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611400 */     // GIR_Coverage, 3614,
     /* 1611400 */     GIR_EraseRootFromParent_Done,
     /* 1611401 */   // Label 22233: @1611401
     /* 1611401 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1611487), // Rule ID 3615 //
     /* 1611406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1611423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1611426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611452 */     // MIs[0] policy
     /* 1611452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611462 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1611465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611486 */     // GIR_Coverage, 3615,
     /* 1611486 */     GIR_EraseRootFromParent_Done,
     /* 1611487 */   // Label 22234: @1611487
     /* 1611487 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1611573), // Rule ID 3618 //
     /* 1611492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1611512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611538 */     // MIs[0] policy
     /* 1611538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1611551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611572 */     // GIR_Coverage, 3618,
     /* 1611572 */     GIR_EraseRootFromParent_Done,
     /* 1611573 */   // Label 22235: @1611573
     /* 1611573 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1611659), // Rule ID 3619 //
     /* 1611578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1611595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1611598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611624 */     // MIs[0] policy
     /* 1611624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611634 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1611637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611658 */     // GIR_Coverage, 3619,
     /* 1611658 */     GIR_EraseRootFromParent_Done,
     /* 1611659 */   // Label 22236: @1611659
     /* 1611659 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1611745), // Rule ID 3622 //
     /* 1611664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1611684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611710 */     // MIs[0] policy
     /* 1611710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1611723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611744 */     // GIR_Coverage, 3622,
     /* 1611744 */     GIR_EraseRootFromParent_Done,
     /* 1611745 */   // Label 22237: @1611745
     /* 1611745 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1611831), // Rule ID 3623 //
     /* 1611750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1611767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1611770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611796 */     // MIs[0] policy
     /* 1611796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611806 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1611809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611830 */     // GIR_Coverage, 3623,
     /* 1611830 */     GIR_EraseRootFromParent_Done,
     /* 1611831 */   // Label 22238: @1611831
     /* 1611831 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1611917), // Rule ID 3626 //
     /* 1611836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1611839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1611847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1611850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1611853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1611856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1611859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611882 */     // MIs[0] policy
     /* 1611882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1611895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611916 */     // GIR_Coverage, 3626,
     /* 1611916 */     GIR_EraseRootFromParent_Done,
     /* 1611917 */   // Label 22239: @1611917
     /* 1611917 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1612003), // Rule ID 3627 //
     /* 1611922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1611925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1611930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1611933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1611936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1611939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1611942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1611945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611968 */     // MIs[0] policy
     /* 1611968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1611981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612002 */     // GIR_Coverage, 3627,
     /* 1612002 */     GIR_EraseRootFromParent_Done,
     /* 1612003 */   // Label 22240: @1612003
     /* 1612003 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1612089), // Rule ID 3630 //
     /* 1612008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1612025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1612028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612054 */     // MIs[0] policy
     /* 1612054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612088 */     // GIR_Coverage, 3630,
     /* 1612088 */     GIR_EraseRootFromParent_Done,
     /* 1612089 */   // Label 22241: @1612089
     /* 1612089 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1612175), // Rule ID 3631 //
     /* 1612094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1612097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1612111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1612114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612140 */     // MIs[0] policy
     /* 1612140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612174 */     // GIR_Coverage, 3631,
     /* 1612174 */     GIR_EraseRootFromParent_Done,
     /* 1612175 */   // Label 22242: @1612175
     /* 1612175 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1612261), // Rule ID 3634 //
     /* 1612180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1612197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1612200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612226 */     // MIs[0] policy
     /* 1612226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1612239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612260 */     // GIR_Coverage, 3634,
     /* 1612260 */     GIR_EraseRootFromParent_Done,
     /* 1612261 */   // Label 22243: @1612261
     /* 1612261 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1612347), // Rule ID 3635 //
     /* 1612266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1612269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1612280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1612283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1612286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612312 */     // MIs[0] policy
     /* 1612312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1612325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612346 */     // GIR_Coverage, 3635,
     /* 1612346 */     GIR_EraseRootFromParent_Done,
     /* 1612347 */   // Label 22244: @1612347
     /* 1612347 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1612433), // Rule ID 3638 //
     /* 1612352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1612369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1612372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612398 */     // MIs[0] policy
     /* 1612398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1612411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612432 */     // GIR_Coverage, 3638,
     /* 1612432 */     GIR_EraseRootFromParent_Done,
     /* 1612433 */   // Label 22245: @1612433
     /* 1612433 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1612519), // Rule ID 3639 //
     /* 1612438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1612441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1612455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1612458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612484 */     // MIs[0] policy
     /* 1612484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1612497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612518 */     // GIR_Coverage, 3639,
     /* 1612518 */     GIR_EraseRootFromParent_Done,
     /* 1612519 */   // Label 22246: @1612519
     /* 1612519 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1612605), // Rule ID 3642 //
     /* 1612524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612570 */     // MIs[0] policy
     /* 1612570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1612583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612604 */     // GIR_Coverage, 3642,
     /* 1612604 */     GIR_EraseRootFromParent_Done,
     /* 1612605 */   // Label 22247: @1612605
     /* 1612605 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1612691), // Rule ID 3643 //
     /* 1612610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612656 */     // MIs[0] policy
     /* 1612656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1612669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612690 */     // GIR_Coverage, 3643,
     /* 1612690 */     GIR_EraseRootFromParent_Done,
     /* 1612691 */   // Label 22248: @1612691
     /* 1612691 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1612777), // Rule ID 3646 //
     /* 1612696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612742 */     // MIs[0] policy
     /* 1612742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1612755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612776 */     // GIR_Coverage, 3646,
     /* 1612776 */     GIR_EraseRootFromParent_Done,
     /* 1612777 */   // Label 22249: @1612777
     /* 1612777 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1612863), // Rule ID 3647 //
     /* 1612782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612828 */     // MIs[0] policy
     /* 1612828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1612841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612862 */     // GIR_Coverage, 3647,
     /* 1612862 */     GIR_EraseRootFromParent_Done,
     /* 1612863 */   // Label 22250: @1612863
     /* 1612863 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1612949), // Rule ID 3650 //
     /* 1612868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612914 */     // MIs[0] policy
     /* 1612914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1612927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612948 */     // GIR_Coverage, 3650,
     /* 1612948 */     GIR_EraseRootFromParent_Done,
     /* 1612949 */   // Label 22251: @1612949
     /* 1612949 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1613035), // Rule ID 3651 //
     /* 1612954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613000 */     // MIs[0] policy
     /* 1613000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1613013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613034 */     // GIR_Coverage, 3651,
     /* 1613034 */     GIR_EraseRootFromParent_Done,
     /* 1613035 */   // Label 22252: @1613035
     /* 1613035 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1613121), // Rule ID 3654 //
     /* 1613040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613086 */     // MIs[0] policy
     /* 1613086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1613099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613120 */     // GIR_Coverage, 3654,
     /* 1613120 */     GIR_EraseRootFromParent_Done,
     /* 1613121 */   // Label 22253: @1613121
     /* 1613121 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1613207), // Rule ID 3655 //
     /* 1613126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613172 */     // MIs[0] policy
     /* 1613172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1613185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613206 */     // GIR_Coverage, 3655,
     /* 1613206 */     GIR_EraseRootFromParent_Done,
     /* 1613207 */   // Label 22254: @1613207
     /* 1613207 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1613293), // Rule ID 3658 //
     /* 1613212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613258 */     // MIs[0] policy
     /* 1613258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1613271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613292 */     // GIR_Coverage, 3658,
     /* 1613292 */     GIR_EraseRootFromParent_Done,
     /* 1613293 */   // Label 22255: @1613293
     /* 1613293 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1613379), // Rule ID 3659 //
     /* 1613298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1613309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1613312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1613315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613344 */     // MIs[0] policy
     /* 1613344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613354 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1613357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613378 */     // GIR_Coverage, 3659,
     /* 1613378 */     GIR_EraseRootFromParent_Done,
     /* 1613379 */   // Label 22256: @1613379
     /* 1613379 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1613465), // Rule ID 3662 //
     /* 1613384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613430 */     // MIs[0] policy
     /* 1613430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1613443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613464 */     // GIR_Coverage, 3662,
     /* 1613464 */     GIR_EraseRootFromParent_Done,
     /* 1613465 */   // Label 22257: @1613465
     /* 1613465 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1613551), // Rule ID 3663 //
     /* 1613470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613516 */     // MIs[0] policy
     /* 1613516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1613529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613550 */     // GIR_Coverage, 3663,
     /* 1613550 */     GIR_EraseRootFromParent_Done,
     /* 1613551 */   // Label 22258: @1613551
     /* 1613551 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1613637), // Rule ID 3666 //
     /* 1613556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613602 */     // MIs[0] policy
     /* 1613602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1613615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613636 */     // GIR_Coverage, 3666,
     /* 1613636 */     GIR_EraseRootFromParent_Done,
     /* 1613637 */   // Label 22259: @1613637
     /* 1613637 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1613723), // Rule ID 3667 //
     /* 1613642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613688 */     // MIs[0] policy
     /* 1613688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1613701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613722 */     // GIR_Coverage, 3667,
     /* 1613722 */     GIR_EraseRootFromParent_Done,
     /* 1613723 */   // Label 22260: @1613723
     /* 1613723 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1613809), // Rule ID 3670 //
     /* 1613728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613774 */     // MIs[0] policy
     /* 1613774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1613787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613808 */     // GIR_Coverage, 3670,
     /* 1613808 */     GIR_EraseRootFromParent_Done,
     /* 1613809 */   // Label 22261: @1613809
     /* 1613809 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1613895), // Rule ID 3671 //
     /* 1613814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613860 */     // MIs[0] policy
     /* 1613860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1613873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613894 */     // GIR_Coverage, 3671,
     /* 1613894 */     GIR_EraseRootFromParent_Done,
     /* 1613895 */   // Label 22262: @1613895
     /* 1613895 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1613981), // Rule ID 3674 //
     /* 1613900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1613914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613946 */     // MIs[0] policy
     /* 1613946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1613959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613980 */     // GIR_Coverage, 3674,
     /* 1613980 */     GIR_EraseRootFromParent_Done,
     /* 1613981 */   // Label 22263: @1613981
     /* 1613981 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1614067), // Rule ID 3675 //
     /* 1613986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614032 */     // MIs[0] policy
     /* 1614032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1614045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614066 */     // GIR_Coverage, 3675,
     /* 1614066 */     GIR_EraseRootFromParent_Done,
     /* 1614067 */   // Label 22264: @1614067
     /* 1614067 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1614153), // Rule ID 3678 //
     /* 1614072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614118 */     // MIs[0] policy
     /* 1614118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1614131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614152 */     // GIR_Coverage, 3678,
     /* 1614152 */     GIR_EraseRootFromParent_Done,
     /* 1614153 */   // Label 22265: @1614153
     /* 1614153 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1614239), // Rule ID 3679 //
     /* 1614158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614204 */     // MIs[0] policy
     /* 1614204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1614217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614238 */     // GIR_Coverage, 3679,
     /* 1614238 */     GIR_EraseRootFromParent_Done,
     /* 1614239 */   // Label 22266: @1614239
     /* 1614239 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1614325), // Rule ID 3682 //
     /* 1614244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614290 */     // MIs[0] policy
     /* 1614290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1614303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614324 */     // GIR_Coverage, 3682,
     /* 1614324 */     GIR_EraseRootFromParent_Done,
     /* 1614325 */   // Label 22267: @1614325
     /* 1614325 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1614411), // Rule ID 3683 //
     /* 1614330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1614341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1614344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614376 */     // MIs[0] policy
     /* 1614376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614386 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1614389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614410 */     // GIR_Coverage, 3683,
     /* 1614410 */     GIR_EraseRootFromParent_Done,
     /* 1614411 */   // Label 22268: @1614411
     /* 1614411 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1614497), // Rule ID 3686 //
     /* 1614416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614462 */     // MIs[0] policy
     /* 1614462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1614475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614496 */     // GIR_Coverage, 3686,
     /* 1614496 */     GIR_EraseRootFromParent_Done,
     /* 1614497 */   // Label 22269: @1614497
     /* 1614497 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1614583), // Rule ID 3687 //
     /* 1614502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614548 */     // MIs[0] policy
     /* 1614548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1614561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614582 */     // GIR_Coverage, 3687,
     /* 1614582 */     GIR_EraseRootFromParent_Done,
     /* 1614583 */   // Label 22270: @1614583
     /* 1614583 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1614669), // Rule ID 3690 //
     /* 1614588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614634 */     // MIs[0] policy
     /* 1614634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1614647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614668 */     // GIR_Coverage, 3690,
     /* 1614668 */     GIR_EraseRootFromParent_Done,
     /* 1614669 */   // Label 22271: @1614669
     /* 1614669 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1614755), // Rule ID 3691 //
     /* 1614674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614720 */     // MIs[0] policy
     /* 1614720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1614733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614754 */     // GIR_Coverage, 3691,
     /* 1614754 */     GIR_EraseRootFromParent_Done,
     /* 1614755 */   // Label 22272: @1614755
     /* 1614755 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1614841), // Rule ID 3694 //
     /* 1614760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614806 */     // MIs[0] policy
     /* 1614806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614816 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1614819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614840 */     // GIR_Coverage, 3694,
     /* 1614840 */     GIR_EraseRootFromParent_Done,
     /* 1614841 */   // Label 22273: @1614841
     /* 1614841 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1614927), // Rule ID 3695 //
     /* 1614846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614892 */     // MIs[0] policy
     /* 1614892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1614905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614926 */     // GIR_Coverage, 3695,
     /* 1614926 */     GIR_EraseRootFromParent_Done,
     /* 1614927 */   // Label 22274: @1614927
     /* 1614927 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1615013), // Rule ID 3698 //
     /* 1614932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1614943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1614946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1614949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614978 */     // MIs[0] policy
     /* 1614978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614988 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1614991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615012 */     // GIR_Coverage, 3698,
     /* 1615012 */     GIR_EraseRootFromParent_Done,
     /* 1615013 */   // Label 22275: @1615013
     /* 1615013 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1615099), // Rule ID 3699 //
     /* 1615018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615064 */     // MIs[0] policy
     /* 1615064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615074 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1615077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615098 */     // GIR_Coverage, 3699,
     /* 1615098 */     GIR_EraseRootFromParent_Done,
     /* 1615099 */   // Label 22276: @1615099
     /* 1615099 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1615185), // Rule ID 3702 //
     /* 1615104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1615124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615150 */     // MIs[0] policy
     /* 1615150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1615163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615184 */     // GIR_Coverage, 3702,
     /* 1615184 */     GIR_EraseRootFromParent_Done,
     /* 1615185 */   // Label 22277: @1615185
     /* 1615185 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1615271), // Rule ID 3703 //
     /* 1615190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1615210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615236 */     // MIs[0] policy
     /* 1615236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615246 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1615249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615270 */     // GIR_Coverage, 3703,
     /* 1615270 */     GIR_EraseRootFromParent_Done,
     /* 1615271 */   // Label 22278: @1615271
     /* 1615271 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1615357), // Rule ID 3706 //
     /* 1615276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1615296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615322 */     // MIs[0] policy
     /* 1615322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1615335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615356 */     // GIR_Coverage, 3706,
     /* 1615356 */     GIR_EraseRootFromParent_Done,
     /* 1615357 */   // Label 22279: @1615357
     /* 1615357 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1615443), // Rule ID 3707 //
     /* 1615362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1615382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615408 */     // MIs[0] policy
     /* 1615408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615418 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1615421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615442 */     // GIR_Coverage, 3707,
     /* 1615442 */     GIR_EraseRootFromParent_Done,
     /* 1615443 */   // Label 22280: @1615443
     /* 1615443 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1615529), // Rule ID 3710 //
     /* 1615448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1615468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615494 */     // MIs[0] policy
     /* 1615494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1615507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615528 */     // GIR_Coverage, 3710,
     /* 1615528 */     GIR_EraseRootFromParent_Done,
     /* 1615529 */   // Label 22281: @1615529
     /* 1615529 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1615615), // Rule ID 3711 //
     /* 1615534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1615554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615580 */     // MIs[0] policy
     /* 1615580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1615593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615614 */     // GIR_Coverage, 3711,
     /* 1615614 */     GIR_EraseRootFromParent_Done,
     /* 1615615 */   // Label 22282: @1615615
     /* 1615615 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1615701), // Rule ID 3714 //
     /* 1615620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1615640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615666 */     // MIs[0] policy
     /* 1615666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1615679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615700 */     // GIR_Coverage, 3714,
     /* 1615700 */     GIR_EraseRootFromParent_Done,
     /* 1615701 */   // Label 22283: @1615701
     /* 1615701 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1615787), // Rule ID 3715 //
     /* 1615706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1615726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615752 */     // MIs[0] policy
     /* 1615752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1615765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615786 */     // GIR_Coverage, 3715,
     /* 1615786 */     GIR_EraseRootFromParent_Done,
     /* 1615787 */   // Label 22284: @1615787
     /* 1615787 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1615873), // Rule ID 3718 //
     /* 1615792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1615812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615838 */     // MIs[0] policy
     /* 1615838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1615851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615872 */     // GIR_Coverage, 3718,
     /* 1615872 */     GIR_EraseRootFromParent_Done,
     /* 1615873 */   // Label 22285: @1615873
     /* 1615873 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1615959), // Rule ID 3719 //
     /* 1615878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1615898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615924 */     // MIs[0] policy
     /* 1615924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1615937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615958 */     // GIR_Coverage, 3719,
     /* 1615958 */     GIR_EraseRootFromParent_Done,
     /* 1615959 */   // Label 22286: @1615959
     /* 1615959 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1616045), // Rule ID 3722 //
     /* 1615964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1615981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1615984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616010 */     // MIs[0] policy
     /* 1616010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1616023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616044 */     // GIR_Coverage, 3722,
     /* 1616044 */     GIR_EraseRootFromParent_Done,
     /* 1616045 */   // Label 22287: @1616045
     /* 1616045 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1616131), // Rule ID 3723 //
     /* 1616050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1616070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616096 */     // MIs[0] policy
     /* 1616096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1616109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616130 */     // GIR_Coverage, 3723,
     /* 1616130 */     GIR_EraseRootFromParent_Done,
     /* 1616131 */   // Label 22288: @1616131
     /* 1616131 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1616217), // Rule ID 3726 //
     /* 1616136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1616156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616182 */     // MIs[0] policy
     /* 1616182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1616195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616216 */     // GIR_Coverage, 3726,
     /* 1616216 */     GIR_EraseRootFromParent_Done,
     /* 1616217 */   // Label 22289: @1616217
     /* 1616217 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1616303), // Rule ID 3727 //
     /* 1616222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1616242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616268 */     // MIs[0] policy
     /* 1616268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1616281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616302 */     // GIR_Coverage, 3727,
     /* 1616302 */     GIR_EraseRootFromParent_Done,
     /* 1616303 */   // Label 22290: @1616303
     /* 1616303 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1616389), // Rule ID 3730 //
     /* 1616308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1616328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616354 */     // MIs[0] policy
     /* 1616354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1616367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616388 */     // GIR_Coverage, 3730,
     /* 1616388 */     GIR_EraseRootFromParent_Done,
     /* 1616389 */   // Label 22291: @1616389
     /* 1616389 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1616475), // Rule ID 3731 //
     /* 1616394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1616414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616440 */     // MIs[0] policy
     /* 1616440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1616453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616474 */     // GIR_Coverage, 3731,
     /* 1616474 */     GIR_EraseRootFromParent_Done,
     /* 1616475 */   // Label 22292: @1616475
     /* 1616475 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1616561), // Rule ID 3734 //
     /* 1616480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1616500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616526 */     // MIs[0] policy
     /* 1616526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1616539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616560 */     // GIR_Coverage, 3734,
     /* 1616560 */     GIR_EraseRootFromParent_Done,
     /* 1616561 */   // Label 22293: @1616561
     /* 1616561 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1616647), // Rule ID 3735 //
     /* 1616566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1616586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616612 */     // MIs[0] policy
     /* 1616612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1616625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616646 */     // GIR_Coverage, 3735,
     /* 1616646 */     GIR_EraseRootFromParent_Done,
     /* 1616647 */   // Label 22294: @1616647
     /* 1616647 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1616733), // Rule ID 3738 //
     /* 1616652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1616672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616698 */     // MIs[0] policy
     /* 1616698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616708 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1616711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616732 */     // GIR_Coverage, 3738,
     /* 1616732 */     GIR_EraseRootFromParent_Done,
     /* 1616733 */   // Label 22295: @1616733
     /* 1616733 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1616819), // Rule ID 3739 //
     /* 1616738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1616758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616784 */     // MIs[0] policy
     /* 1616784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1616797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616818 */     // GIR_Coverage, 3739,
     /* 1616818 */     GIR_EraseRootFromParent_Done,
     /* 1616819 */   // Label 22296: @1616819
     /* 1616819 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1616905), // Rule ID 3742 //
     /* 1616824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1616844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616870 */     // MIs[0] policy
     /* 1616870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1616883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616904 */     // GIR_Coverage, 3742,
     /* 1616904 */     GIR_EraseRootFromParent_Done,
     /* 1616905 */   // Label 22297: @1616905
     /* 1616905 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1616991), // Rule ID 3743 //
     /* 1616910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1616918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1616930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616956 */     // MIs[0] policy
     /* 1616956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1616969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616990 */     // GIR_Coverage, 3743,
     /* 1616990 */     GIR_EraseRootFromParent_Done,
     /* 1616991 */   // Label 22298: @1616991
     /* 1616991 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1617077), // Rule ID 3746 //
     /* 1616996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617042 */     // MIs[0] policy
     /* 1617042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617076 */     // GIR_Coverage, 3746,
     /* 1617076 */     GIR_EraseRootFromParent_Done,
     /* 1617077 */   // Label 22299: @1617077
     /* 1617077 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1617163), // Rule ID 3747 //
     /* 1617082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617128 */     // MIs[0] policy
     /* 1617128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617162 */     // GIR_Coverage, 3747,
     /* 1617162 */     GIR_EraseRootFromParent_Done,
     /* 1617163 */   // Label 22300: @1617163
     /* 1617163 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1617249), // Rule ID 3750 //
     /* 1617168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1617188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617214 */     // MIs[0] policy
     /* 1617214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1617227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617248 */     // GIR_Coverage, 3750,
     /* 1617248 */     GIR_EraseRootFromParent_Done,
     /* 1617249 */   // Label 22301: @1617249
     /* 1617249 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1617335), // Rule ID 3751 //
     /* 1617254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1617274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617300 */     // MIs[0] policy
     /* 1617300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1617313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617334 */     // GIR_Coverage, 3751,
     /* 1617334 */     GIR_EraseRootFromParent_Done,
     /* 1617335 */   // Label 22302: @1617335
     /* 1617335 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1617421), // Rule ID 3754 //
     /* 1617340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1617360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617386 */     // MIs[0] policy
     /* 1617386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1617399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617420 */     // GIR_Coverage, 3754,
     /* 1617420 */     GIR_EraseRootFromParent_Done,
     /* 1617421 */   // Label 22303: @1617421
     /* 1617421 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1617507), // Rule ID 3755 //
     /* 1617426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1617446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617472 */     // MIs[0] policy
     /* 1617472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1617485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617506 */     // GIR_Coverage, 3755,
     /* 1617506 */     GIR_EraseRootFromParent_Done,
     /* 1617507 */   // Label 22304: @1617507
     /* 1617507 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1617593), // Rule ID 3758 //
     /* 1617512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1617532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617558 */     // MIs[0] policy
     /* 1617558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617568 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1617571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617592 */     // GIR_Coverage, 3758,
     /* 1617592 */     GIR_EraseRootFromParent_Done,
     /* 1617593 */   // Label 22305: @1617593
     /* 1617593 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1617679), // Rule ID 3759 //
     /* 1617598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1617618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617644 */     // MIs[0] policy
     /* 1617644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617654 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1617657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617678 */     // GIR_Coverage, 3759,
     /* 1617678 */     GIR_EraseRootFromParent_Done,
     /* 1617679 */   // Label 22306: @1617679
     /* 1617679 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1617765), // Rule ID 3762 //
     /* 1617684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617730 */     // MIs[0] policy
     /* 1617730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1617743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617764 */     // GIR_Coverage, 3762,
     /* 1617764 */     GIR_EraseRootFromParent_Done,
     /* 1617765 */   // Label 22307: @1617765
     /* 1617765 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1617851), // Rule ID 3763 //
     /* 1617770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617816 */     // MIs[0] policy
     /* 1617816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1617829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617850 */     // GIR_Coverage, 3763,
     /* 1617850 */     GIR_EraseRootFromParent_Done,
     /* 1617851 */   // Label 22308: @1617851
     /* 1617851 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1617937), // Rule ID 3766 //
     /* 1617856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617902 */     // MIs[0] policy
     /* 1617902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1617915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617936 */     // GIR_Coverage, 3766,
     /* 1617936 */     GIR_EraseRootFromParent_Done,
     /* 1617937 */   // Label 22309: @1617937
     /* 1617937 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1618023), // Rule ID 3767 //
     /* 1617942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617988 */     // MIs[0] policy
     /* 1617988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1618001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618022 */     // GIR_Coverage, 3767,
     /* 1618022 */     GIR_EraseRootFromParent_Done,
     /* 1618023 */   // Label 22310: @1618023
     /* 1618023 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1618109), // Rule ID 3770 //
     /* 1618028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618074 */     // MIs[0] policy
     /* 1618074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1618087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618108 */     // GIR_Coverage, 3770,
     /* 1618108 */     GIR_EraseRootFromParent_Done,
     /* 1618109 */   // Label 22311: @1618109
     /* 1618109 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1618195), // Rule ID 3771 //
     /* 1618114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618160 */     // MIs[0] policy
     /* 1618160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11611:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1618173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618194 */     // GIR_Coverage, 3771,
     /* 1618194 */     GIR_EraseRootFromParent_Done,
     /* 1618195 */   // Label 22312: @1618195
     /* 1618195 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1618281), // Rule ID 3774 //
     /* 1618200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618246 */     // MIs[0] policy
     /* 1618246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1618259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618280 */     // GIR_Coverage, 3774,
     /* 1618280 */     GIR_EraseRootFromParent_Done,
     /* 1618281 */   // Label 22313: @1618281
     /* 1618281 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1618367), // Rule ID 3775 //
     /* 1618286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1618297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1618300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1618303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618332 */     // MIs[0] policy
     /* 1618332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1618345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618366 */     // GIR_Coverage, 3775,
     /* 1618366 */     GIR_EraseRootFromParent_Done,
     /* 1618367 */   // Label 22314: @1618367
     /* 1618367 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1618453), // Rule ID 3778 //
     /* 1618372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618418 */     // MIs[0] policy
     /* 1618418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618428 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1618431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618452 */     // GIR_Coverage, 3778,
     /* 1618452 */     GIR_EraseRootFromParent_Done,
     /* 1618453 */   // Label 22315: @1618453
     /* 1618453 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1618539), // Rule ID 3779 //
     /* 1618458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618504 */     // MIs[0] policy
     /* 1618504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1618517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618538 */     // GIR_Coverage, 3779,
     /* 1618538 */     GIR_EraseRootFromParent_Done,
     /* 1618539 */   // Label 22316: @1618539
     /* 1618539 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1618625), // Rule ID 3782 //
     /* 1618544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618590 */     // MIs[0] policy
     /* 1618590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1618603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618624 */     // GIR_Coverage, 3782,
     /* 1618624 */     GIR_EraseRootFromParent_Done,
     /* 1618625 */   // Label 22317: @1618625
     /* 1618625 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1618711), // Rule ID 3783 //
     /* 1618630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618676 */     // MIs[0] policy
     /* 1618676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1618689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618710 */     // GIR_Coverage, 3783,
     /* 1618710 */     GIR_EraseRootFromParent_Done,
     /* 1618711 */   // Label 22318: @1618711
     /* 1618711 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1618797), // Rule ID 3786 //
     /* 1618716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618762 */     // MIs[0] policy
     /* 1618762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618772 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1618775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618796 */     // GIR_Coverage, 3786,
     /* 1618796 */     GIR_EraseRootFromParent_Done,
     /* 1618797 */   // Label 22319: @1618797
     /* 1618797 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1618883), // Rule ID 3787 //
     /* 1618802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618848 */     // MIs[0] policy
     /* 1618848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1618861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618882 */     // GIR_Coverage, 3787,
     /* 1618882 */     GIR_EraseRootFromParent_Done,
     /* 1618883 */   // Label 22320: @1618883
     /* 1618883 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1618969), // Rule ID 3790 //
     /* 1618888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618934 */     // MIs[0] policy
     /* 1618934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1618947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618968 */     // GIR_Coverage, 3790,
     /* 1618968 */     GIR_EraseRootFromParent_Done,
     /* 1618969 */   // Label 22321: @1618969
     /* 1618969 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1619055), // Rule ID 3791 //
     /* 1618974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619020 */     // MIs[0] policy
     /* 1619020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11611:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1619033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619054 */     // GIR_Coverage, 3791,
     /* 1619054 */     GIR_EraseRootFromParent_Done,
     /* 1619055 */   // Label 22322: @1619055
     /* 1619055 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1619141), // Rule ID 3794 //
     /* 1619060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619106 */     // MIs[0] policy
     /* 1619106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1619119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619140 */     // GIR_Coverage, 3794,
     /* 1619140 */     GIR_EraseRootFromParent_Done,
     /* 1619141 */   // Label 22323: @1619141
     /* 1619141 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1619227), // Rule ID 3795 //
     /* 1619146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619192 */     // MIs[0] policy
     /* 1619192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1619205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619226 */     // GIR_Coverage, 3795,
     /* 1619226 */     GIR_EraseRootFromParent_Done,
     /* 1619227 */   // Label 22324: @1619227
     /* 1619227 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1619313), // Rule ID 3798 //
     /* 1619232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619278 */     // MIs[0] policy
     /* 1619278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619288 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1619291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619312 */     // GIR_Coverage, 3798,
     /* 1619312 */     GIR_EraseRootFromParent_Done,
     /* 1619313 */   // Label 22325: @1619313
     /* 1619313 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1619399), // Rule ID 3799 //
     /* 1619318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1619329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1619332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1619335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619364 */     // MIs[0] policy
     /* 1619364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1619377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619398 */     // GIR_Coverage, 3799,
     /* 1619398 */     GIR_EraseRootFromParent_Done,
     /* 1619399 */   // Label 22326: @1619399
     /* 1619399 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1619485), // Rule ID 3802 //
     /* 1619404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619450 */     // MIs[0] policy
     /* 1619450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1619463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619484 */     // GIR_Coverage, 3802,
     /* 1619484 */     GIR_EraseRootFromParent_Done,
     /* 1619485 */   // Label 22327: @1619485
     /* 1619485 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1619571), // Rule ID 3803 //
     /* 1619490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619536 */     // MIs[0] policy
     /* 1619536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1619549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619570 */     // GIR_Coverage, 3803,
     /* 1619570 */     GIR_EraseRootFromParent_Done,
     /* 1619571 */   // Label 22328: @1619571
     /* 1619571 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1619657), // Rule ID 3806 //
     /* 1619576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619622 */     // MIs[0] policy
     /* 1619622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1619635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619656 */     // GIR_Coverage, 3806,
     /* 1619656 */     GIR_EraseRootFromParent_Done,
     /* 1619657 */   // Label 22329: @1619657
     /* 1619657 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1619743), // Rule ID 3807 //
     /* 1619662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619708 */     // MIs[0] policy
     /* 1619708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11611:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1619721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619742 */     // GIR_Coverage, 3807,
     /* 1619742 */     GIR_EraseRootFromParent_Done,
     /* 1619743 */   // Label 22330: @1619743
     /* 1619743 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1619829), // Rule ID 3810 //
     /* 1619748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619794 */     // MIs[0] policy
     /* 1619794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1619807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619828 */     // GIR_Coverage, 3810,
     /* 1619828 */     GIR_EraseRootFromParent_Done,
     /* 1619829 */   // Label 22331: @1619829
     /* 1619829 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1619915), // Rule ID 3811 //
     /* 1619834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619880 */     // MIs[0] policy
     /* 1619880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11611:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1619893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619914 */     // GIR_Coverage, 3811,
     /* 1619914 */     GIR_EraseRootFromParent_Done,
     /* 1619915 */   // Label 22332: @1619915
     /* 1619915 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1620001), // Rule ID 3814 //
     /* 1619920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1619937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619966 */     // MIs[0] policy
     /* 1619966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619976 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1619979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620000 */     // GIR_Coverage, 3814,
     /* 1620000 */     GIR_EraseRootFromParent_Done,
     /* 1620001 */   // Label 22333: @1620001
     /* 1620001 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1620087), // Rule ID 3815 //
     /* 1620006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620052 */     // MIs[0] policy
     /* 1620052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620062 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11611:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1620065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620086 */     // GIR_Coverage, 3815,
     /* 1620086 */     GIR_EraseRootFromParent_Done,
     /* 1620087 */   // Label 22334: @1620087
     /* 1620087 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1620173), // Rule ID 3818 //
     /* 1620092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620138 */     // MIs[0] policy
     /* 1620138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620172 */     // GIR_Coverage, 3818,
     /* 1620172 */     GIR_EraseRootFromParent_Done,
     /* 1620173 */   // Label 22335: @1620173
     /* 1620173 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1620259), // Rule ID 3819 //
     /* 1620178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620224 */     // MIs[0] policy
     /* 1620224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11611:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620258 */     // GIR_Coverage, 3819,
     /* 1620258 */     GIR_EraseRootFromParent_Done,
     /* 1620259 */   // Label 22336: @1620259
     /* 1620259 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1620345), // Rule ID 3822 //
     /* 1620264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1620284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620310 */     // MIs[0] policy
     /* 1620310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1620323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620344 */     // GIR_Coverage, 3822,
     /* 1620344 */     GIR_EraseRootFromParent_Done,
     /* 1620345 */   // Label 22337: @1620345
     /* 1620345 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1620431), // Rule ID 3823 //
     /* 1620350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1620370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620396 */     // MIs[0] policy
     /* 1620396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1620409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620430 */     // GIR_Coverage, 3823,
     /* 1620430 */     GIR_EraseRootFromParent_Done,
     /* 1620431 */   // Label 22338: @1620431
     /* 1620431 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1620517), // Rule ID 3826 //
     /* 1620436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1620456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620482 */     // MIs[0] policy
     /* 1620482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1620495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620516 */     // GIR_Coverage, 3826,
     /* 1620516 */     GIR_EraseRootFromParent_Done,
     /* 1620517 */   // Label 22339: @1620517
     /* 1620517 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1620603), // Rule ID 3827 //
     /* 1620522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1620542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620568 */     // MIs[0] policy
     /* 1620568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1620581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620602 */     // GIR_Coverage, 3827,
     /* 1620602 */     GIR_EraseRootFromParent_Done,
     /* 1620603 */   // Label 22340: @1620603
     /* 1620603 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1620689), // Rule ID 3830 //
     /* 1620608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1620628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620654 */     // MIs[0] policy
     /* 1620654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1620667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620688 */     // GIR_Coverage, 3830,
     /* 1620688 */     GIR_EraseRootFromParent_Done,
     /* 1620689 */   // Label 22341: @1620689
     /* 1620689 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1620775), // Rule ID 3831 //
     /* 1620694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1620714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620740 */     // MIs[0] policy
     /* 1620740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1620753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620774 */     // GIR_Coverage, 3831,
     /* 1620774 */     GIR_EraseRootFromParent_Done,
     /* 1620775 */   // Label 22342: @1620775
     /* 1620775 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1620861), // Rule ID 3834 //
     /* 1620780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1620800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620826 */     // MIs[0] policy
     /* 1620826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1620839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620860 */     // GIR_Coverage, 3834,
     /* 1620860 */     GIR_EraseRootFromParent_Done,
     /* 1620861 */   // Label 22343: @1620861
     /* 1620861 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1620947), // Rule ID 3835 //
     /* 1620866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1620886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620912 */     // MIs[0] policy
     /* 1620912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1620925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620946 */     // GIR_Coverage, 3835,
     /* 1620946 */     GIR_EraseRootFromParent_Done,
     /* 1620947 */   // Label 22344: @1620947
     /* 1620947 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1621033), // Rule ID 3838 //
     /* 1620952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1620963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1620966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1620969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1620972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620998 */     // MIs[0] policy
     /* 1620998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1621011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621032 */     // GIR_Coverage, 3838,
     /* 1621032 */     GIR_EraseRootFromParent_Done,
     /* 1621033 */   // Label 22345: @1621033
     /* 1621033 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1621119), // Rule ID 3839 //
     /* 1621038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1621058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621084 */     // MIs[0] policy
     /* 1621084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1621097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621118 */     // GIR_Coverage, 3839,
     /* 1621118 */     GIR_EraseRootFromParent_Done,
     /* 1621119 */   // Label 22346: @1621119
     /* 1621119 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1621205), // Rule ID 3842 //
     /* 1621124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1621144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621170 */     // MIs[0] policy
     /* 1621170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1621183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621204 */     // GIR_Coverage, 3842,
     /* 1621204 */     GIR_EraseRootFromParent_Done,
     /* 1621205 */   // Label 22347: @1621205
     /* 1621205 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1621291), // Rule ID 3843 //
     /* 1621210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1621230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621256 */     // MIs[0] policy
     /* 1621256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1621269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621290 */     // GIR_Coverage, 3843,
     /* 1621290 */     GIR_EraseRootFromParent_Done,
     /* 1621291 */   // Label 22348: @1621291
     /* 1621291 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1621377), // Rule ID 3846 //
     /* 1621296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1621316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621342 */     // MIs[0] policy
     /* 1621342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1621355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621376 */     // GIR_Coverage, 3846,
     /* 1621376 */     GIR_EraseRootFromParent_Done,
     /* 1621377 */   // Label 22349: @1621377
     /* 1621377 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1621463), // Rule ID 3847 //
     /* 1621382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1621402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621428 */     // MIs[0] policy
     /* 1621428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1621441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621462 */     // GIR_Coverage, 3847,
     /* 1621462 */     GIR_EraseRootFromParent_Done,
     /* 1621463 */   // Label 22350: @1621463
     /* 1621463 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1621549), // Rule ID 3850 //
     /* 1621468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1621488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621514 */     // MIs[0] policy
     /* 1621514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1621527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621548 */     // GIR_Coverage, 3850,
     /* 1621548 */     GIR_EraseRootFromParent_Done,
     /* 1621549 */   // Label 22351: @1621549
     /* 1621549 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1621635), // Rule ID 3851 //
     /* 1621554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1621574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621600 */     // MIs[0] policy
     /* 1621600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1621613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621634 */     // GIR_Coverage, 3851,
     /* 1621634 */     GIR_EraseRootFromParent_Done,
     /* 1621635 */   // Label 22352: @1621635
     /* 1621635 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1621721), // Rule ID 3854 //
     /* 1621640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1621660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621686 */     // MIs[0] policy
     /* 1621686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1621699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621720 */     // GIR_Coverage, 3854,
     /* 1621720 */     GIR_EraseRootFromParent_Done,
     /* 1621721 */   // Label 22353: @1621721
     /* 1621721 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1621807), // Rule ID 3855 //
     /* 1621726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1621746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621772 */     // MIs[0] policy
     /* 1621772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1621785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621806 */     // GIR_Coverage, 3855,
     /* 1621806 */     GIR_EraseRootFromParent_Done,
     /* 1621807 */   // Label 22354: @1621807
     /* 1621807 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1621893), // Rule ID 3858 //
     /* 1621812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1621832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621858 */     // MIs[0] policy
     /* 1621858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1621871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621892 */     // GIR_Coverage, 3858,
     /* 1621892 */     GIR_EraseRootFromParent_Done,
     /* 1621893 */   // Label 22355: @1621893
     /* 1621893 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1621979), // Rule ID 3859 //
     /* 1621898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1621918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621944 */     // MIs[0] policy
     /* 1621944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1621957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621978 */     // GIR_Coverage, 3859,
     /* 1621978 */     GIR_EraseRootFromParent_Done,
     /* 1621979 */   // Label 22356: @1621979
     /* 1621979 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1622065), // Rule ID 3862 //
     /* 1621984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1621992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1621995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1621998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1622004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622030 */     // MIs[0] policy
     /* 1622030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1622043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622064 */     // GIR_Coverage, 3862,
     /* 1622064 */     GIR_EraseRootFromParent_Done,
     /* 1622065 */   // Label 22357: @1622065
     /* 1622065 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1622151), // Rule ID 3863 //
     /* 1622070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1622090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622116 */     // MIs[0] policy
     /* 1622116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1622129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622150 */     // GIR_Coverage, 3863,
     /* 1622150 */     GIR_EraseRootFromParent_Done,
     /* 1622151 */   // Label 22358: @1622151
     /* 1622151 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1622237), // Rule ID 3866 //
     /* 1622156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1622176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622202 */     // MIs[0] policy
     /* 1622202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622236 */     // GIR_Coverage, 3866,
     /* 1622236 */     GIR_EraseRootFromParent_Done,
     /* 1622237 */   // Label 22359: @1622237
     /* 1622237 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1622323), // Rule ID 3867 //
     /* 1622242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1622262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622288 */     // MIs[0] policy
     /* 1622288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622322 */     // GIR_Coverage, 3867,
     /* 1622322 */     GIR_EraseRootFromParent_Done,
     /* 1622323 */   // Label 22360: @1622323
     /* 1622323 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1622409), // Rule ID 3870 //
     /* 1622328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1622348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622374 */     // MIs[0] policy
     /* 1622374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1622387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622408 */     // GIR_Coverage, 3870,
     /* 1622408 */     GIR_EraseRootFromParent_Done,
     /* 1622409 */   // Label 22361: @1622409
     /* 1622409 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1622495), // Rule ID 3871 //
     /* 1622414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1622434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622460 */     // MIs[0] policy
     /* 1622460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1622473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622494 */     // GIR_Coverage, 3871,
     /* 1622494 */     GIR_EraseRootFromParent_Done,
     /* 1622495 */   // Label 22362: @1622495
     /* 1622495 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1622581), // Rule ID 3874 //
     /* 1622500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1622520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622546 */     // MIs[0] policy
     /* 1622546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1622559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622580 */     // GIR_Coverage, 3874,
     /* 1622580 */     GIR_EraseRootFromParent_Done,
     /* 1622581 */   // Label 22363: @1622581
     /* 1622581 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1622667), // Rule ID 3875 //
     /* 1622586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1622606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622632 */     // MIs[0] policy
     /* 1622632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1622645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622666 */     // GIR_Coverage, 3875,
     /* 1622666 */     GIR_EraseRootFromParent_Done,
     /* 1622667 */   // Label 22364: @1622667
     /* 1622667 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1622753), // Rule ID 3878 //
     /* 1622672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1622692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622718 */     // MIs[0] policy
     /* 1622718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1622731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622752 */     // GIR_Coverage, 3878,
     /* 1622752 */     GIR_EraseRootFromParent_Done,
     /* 1622753 */   // Label 22365: @1622753
     /* 1622753 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1622839), // Rule ID 3879 //
     /* 1622758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1622778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622804 */     // MIs[0] policy
     /* 1622804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1622817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622838 */     // GIR_Coverage, 3879,
     /* 1622838 */     GIR_EraseRootFromParent_Done,
     /* 1622839 */   // Label 22366: @1622839
     /* 1622839 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1622925), // Rule ID 3882 //
     /* 1622844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622890 */     // MIs[0] policy
     /* 1622890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1622903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622924 */     // GIR_Coverage, 3882,
     /* 1622924 */     GIR_EraseRootFromParent_Done,
     /* 1622925 */   // Label 22367: @1622925
     /* 1622925 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1623011), // Rule ID 3883 //
     /* 1622930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622976 */     // MIs[0] policy
     /* 1622976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622986 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1622989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623010 */     // GIR_Coverage, 3883,
     /* 1623010 */     GIR_EraseRootFromParent_Done,
     /* 1623011 */   // Label 22368: @1623011
     /* 1623011 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1623097), // Rule ID 3886 //
     /* 1623016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623062 */     // MIs[0] policy
     /* 1623062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1623075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623096 */     // GIR_Coverage, 3886,
     /* 1623096 */     GIR_EraseRootFromParent_Done,
     /* 1623097 */   // Label 22369: @1623097
     /* 1623097 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1623183), // Rule ID 3887 //
     /* 1623102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623148 */     // MIs[0] policy
     /* 1623148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1623161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623182 */     // GIR_Coverage, 3887,
     /* 1623182 */     GIR_EraseRootFromParent_Done,
     /* 1623183 */   // Label 22370: @1623183
     /* 1623183 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1623269), // Rule ID 3890 //
     /* 1623188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623234 */     // MIs[0] policy
     /* 1623234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1623247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623268 */     // GIR_Coverage, 3890,
     /* 1623268 */     GIR_EraseRootFromParent_Done,
     /* 1623269 */   // Label 22371: @1623269
     /* 1623269 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1623355), // Rule ID 3891 //
     /* 1623274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1623285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1623288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1623291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623320 */     // MIs[0] policy
     /* 1623320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1623333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623354 */     // GIR_Coverage, 3891,
     /* 1623354 */     GIR_EraseRootFromParent_Done,
     /* 1623355 */   // Label 22372: @1623355
     /* 1623355 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1623441), // Rule ID 3894 //
     /* 1623360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623406 */     // MIs[0] policy
     /* 1623406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1623419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623440 */     // GIR_Coverage, 3894,
     /* 1623440 */     GIR_EraseRootFromParent_Done,
     /* 1623441 */   // Label 22373: @1623441
     /* 1623441 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1623527), // Rule ID 3895 //
     /* 1623446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623492 */     // MIs[0] policy
     /* 1623492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1623505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623526 */     // GIR_Coverage, 3895,
     /* 1623526 */     GIR_EraseRootFromParent_Done,
     /* 1623527 */   // Label 22374: @1623527
     /* 1623527 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1623613), // Rule ID 3898 //
     /* 1623532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623578 */     // MIs[0] policy
     /* 1623578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1623591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623612 */     // GIR_Coverage, 3898,
     /* 1623612 */     GIR_EraseRootFromParent_Done,
     /* 1623613 */   // Label 22375: @1623613
     /* 1623613 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1623699), // Rule ID 3899 //
     /* 1623618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623664 */     // MIs[0] policy
     /* 1623664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1623677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623698 */     // GIR_Coverage, 3899,
     /* 1623698 */     GIR_EraseRootFromParent_Done,
     /* 1623699 */   // Label 22376: @1623699
     /* 1623699 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1623785), // Rule ID 3902 //
     /* 1623704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623750 */     // MIs[0] policy
     /* 1623750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623760 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1623763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623784 */     // GIR_Coverage, 3902,
     /* 1623784 */     GIR_EraseRootFromParent_Done,
     /* 1623785 */   // Label 22377: @1623785
     /* 1623785 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1623871), // Rule ID 3903 //
     /* 1623790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623836 */     // MIs[0] policy
     /* 1623836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623846 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1623849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623870 */     // GIR_Coverage, 3903,
     /* 1623870 */     GIR_EraseRootFromParent_Done,
     /* 1623871 */   // Label 22378: @1623871
     /* 1623871 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1623957), // Rule ID 3906 //
     /* 1623876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623922 */     // MIs[0] policy
     /* 1623922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1623935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623956 */     // GIR_Coverage, 3906,
     /* 1623956 */     GIR_EraseRootFromParent_Done,
     /* 1623957 */   // Label 22379: @1623957
     /* 1623957 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1624043), // Rule ID 3907 //
     /* 1623962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624008 */     // MIs[0] policy
     /* 1624008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1624021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624042 */     // GIR_Coverage, 3907,
     /* 1624042 */     GIR_EraseRootFromParent_Done,
     /* 1624043 */   // Label 22380: @1624043
     /* 1624043 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1624129), // Rule ID 3910 //
     /* 1624048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624094 */     // MIs[0] policy
     /* 1624094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1624107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624128 */     // GIR_Coverage, 3910,
     /* 1624128 */     GIR_EraseRootFromParent_Done,
     /* 1624129 */   // Label 22381: @1624129
     /* 1624129 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1624215), // Rule ID 3911 //
     /* 1624134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624180 */     // MIs[0] policy
     /* 1624180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1624193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624214 */     // GIR_Coverage, 3911,
     /* 1624214 */     GIR_EraseRootFromParent_Done,
     /* 1624215 */   // Label 22382: @1624215
     /* 1624215 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1624301), // Rule ID 3914 //
     /* 1624220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624266 */     // MIs[0] policy
     /* 1624266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1624279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624300 */     // GIR_Coverage, 3914,
     /* 1624300 */     GIR_EraseRootFromParent_Done,
     /* 1624301 */   // Label 22383: @1624301
     /* 1624301 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1624387), // Rule ID 3915 //
     /* 1624306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1624317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1624320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1624323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624352 */     // MIs[0] policy
     /* 1624352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1624365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624386 */     // GIR_Coverage, 3915,
     /* 1624386 */     GIR_EraseRootFromParent_Done,
     /* 1624387 */   // Label 22384: @1624387
     /* 1624387 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1624473), // Rule ID 3918 //
     /* 1624392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624438 */     // MIs[0] policy
     /* 1624438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1624451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624472 */     // GIR_Coverage, 3918,
     /* 1624472 */     GIR_EraseRootFromParent_Done,
     /* 1624473 */   // Label 22385: @1624473
     /* 1624473 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1624559), // Rule ID 3919 //
     /* 1624478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624524 */     // MIs[0] policy
     /* 1624524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1624537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624558 */     // GIR_Coverage, 3919,
     /* 1624558 */     GIR_EraseRootFromParent_Done,
     /* 1624559 */   // Label 22386: @1624559
     /* 1624559 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1624645), // Rule ID 3922 //
     /* 1624564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624610 */     // MIs[0] policy
     /* 1624610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1624623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624644 */     // GIR_Coverage, 3922,
     /* 1624644 */     GIR_EraseRootFromParent_Done,
     /* 1624645 */   // Label 22387: @1624645
     /* 1624645 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1624731), // Rule ID 3923 //
     /* 1624650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624696 */     // MIs[0] policy
     /* 1624696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1624709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624730 */     // GIR_Coverage, 3923,
     /* 1624730 */     GIR_EraseRootFromParent_Done,
     /* 1624731 */   // Label 22388: @1624731
     /* 1624731 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1624817), // Rule ID 3926 //
     /* 1624736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624782 */     // MIs[0] policy
     /* 1624782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1624795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624816 */     // GIR_Coverage, 3926,
     /* 1624816 */     GIR_EraseRootFromParent_Done,
     /* 1624817 */   // Label 22389: @1624817
     /* 1624817 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1624903), // Rule ID 3927 //
     /* 1624822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624868 */     // MIs[0] policy
     /* 1624868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1624881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624902 */     // GIR_Coverage, 3927,
     /* 1624902 */     GIR_EraseRootFromParent_Done,
     /* 1624903 */   // Label 22390: @1624903
     /* 1624903 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1624989), // Rule ID 3930 //
     /* 1624908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1624919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1624922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1624925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624954 */     // MIs[0] policy
     /* 1624954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1624967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624988 */     // GIR_Coverage, 3930,
     /* 1624988 */     GIR_EraseRootFromParent_Done,
     /* 1624989 */   // Label 22391: @1624989
     /* 1624989 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1625075), // Rule ID 3931 //
     /* 1624994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625040 */     // MIs[0] policy
     /* 1625040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1625053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625074 */     // GIR_Coverage, 3931,
     /* 1625074 */     GIR_EraseRootFromParent_Done,
     /* 1625075 */   // Label 22392: @1625075
     /* 1625075 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1625161), // Rule ID 3934 //
     /* 1625080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625126 */     // MIs[0] policy
     /* 1625126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625160 */     // GIR_Coverage, 3934,
     /* 1625160 */     GIR_EraseRootFromParent_Done,
     /* 1625161 */   // Label 22393: @1625161
     /* 1625161 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1625247), // Rule ID 3935 //
     /* 1625166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625212 */     // MIs[0] policy
     /* 1625212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625246 */     // GIR_Coverage, 3935,
     /* 1625246 */     GIR_EraseRootFromParent_Done,
     /* 1625247 */   // Label 22394: @1625247
     /* 1625247 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1625333), // Rule ID 3938 //
     /* 1625252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625298 */     // MIs[0] policy
     /* 1625298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625308 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1625311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625332 */     // GIR_Coverage, 3938,
     /* 1625332 */     GIR_EraseRootFromParent_Done,
     /* 1625333 */   // Label 22395: @1625333
     /* 1625333 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1625419), // Rule ID 3939 //
     /* 1625338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625384 */     // MIs[0] policy
     /* 1625384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1625397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625418 */     // GIR_Coverage, 3939,
     /* 1625418 */     GIR_EraseRootFromParent_Done,
     /* 1625419 */   // Label 22396: @1625419
     /* 1625419 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1625505), // Rule ID 3942 //
     /* 1625424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1625444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625470 */     // MIs[0] policy
     /* 1625470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1625483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625504 */     // GIR_Coverage, 3942,
     /* 1625504 */     GIR_EraseRootFromParent_Done,
     /* 1625505 */   // Label 22397: @1625505
     /* 1625505 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1625591), // Rule ID 3943 //
     /* 1625510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1625530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625556 */     // MIs[0] policy
     /* 1625556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1625569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625590 */     // GIR_Coverage, 3943,
     /* 1625590 */     GIR_EraseRootFromParent_Done,
     /* 1625591 */   // Label 22398: @1625591
     /* 1625591 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1625677), // Rule ID 3946 //
     /* 1625596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1625616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625642 */     // MIs[0] policy
     /* 1625642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1625655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625676 */     // GIR_Coverage, 3946,
     /* 1625676 */     GIR_EraseRootFromParent_Done,
     /* 1625677 */   // Label 22399: @1625677
     /* 1625677 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1625763), // Rule ID 3947 //
     /* 1625682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1625702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625728 */     // MIs[0] policy
     /* 1625728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1625741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625762 */     // GIR_Coverage, 3947,
     /* 1625762 */     GIR_EraseRootFromParent_Done,
     /* 1625763 */   // Label 22400: @1625763
     /* 1625763 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1625849), // Rule ID 3950 //
     /* 1625768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1625788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625814 */     // MIs[0] policy
     /* 1625814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1625827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625848 */     // GIR_Coverage, 3950,
     /* 1625848 */     GIR_EraseRootFromParent_Done,
     /* 1625849 */   // Label 22401: @1625849
     /* 1625849 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1625935), // Rule ID 3951 //
     /* 1625854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1625874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625900 */     // MIs[0] policy
     /* 1625900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1625913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625934 */     // GIR_Coverage, 3951,
     /* 1625934 */     GIR_EraseRootFromParent_Done,
     /* 1625935 */   // Label 22402: @1625935
     /* 1625935 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1626021), // Rule ID 3954 //
     /* 1625940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1625957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1625960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625986 */     // MIs[0] policy
     /* 1625986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1625999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626020 */     // GIR_Coverage, 3954,
     /* 1626020 */     GIR_EraseRootFromParent_Done,
     /* 1626021 */   // Label 22403: @1626021
     /* 1626021 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1626107), // Rule ID 3955 //
     /* 1626026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1626043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1626046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626072 */     // MIs[0] policy
     /* 1626072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626082 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1626085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626106 */     // GIR_Coverage, 3955,
     /* 1626106 */     GIR_EraseRootFromParent_Done,
     /* 1626107 */   // Label 22404: @1626107
     /* 1626107 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1626193), // Rule ID 3958 //
     /* 1626112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1626132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626158 */     // MIs[0] policy
     /* 1626158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1626171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626192 */     // GIR_Coverage, 3958,
     /* 1626192 */     GIR_EraseRootFromParent_Done,
     /* 1626193 */   // Label 22405: @1626193
     /* 1626193 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1626279), // Rule ID 3959 //
     /* 1626198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1626215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1626218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626244 */     // MIs[0] policy
     /* 1626244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1626257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626278 */     // GIR_Coverage, 3959,
     /* 1626278 */     GIR_EraseRootFromParent_Done,
     /* 1626279 */   // Label 22406: @1626279
     /* 1626279 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1626365), // Rule ID 3962 //
     /* 1626284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1626304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626330 */     // MIs[0] policy
     /* 1626330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626340 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1626343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626364 */     // GIR_Coverage, 3962,
     /* 1626364 */     GIR_EraseRootFromParent_Done,
     /* 1626365 */   // Label 22407: @1626365
     /* 1626365 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1626451), // Rule ID 3963 //
     /* 1626370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1626390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626416 */     // MIs[0] policy
     /* 1626416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626426 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1626429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626450 */     // GIR_Coverage, 3963,
     /* 1626450 */     GIR_EraseRootFromParent_Done,
     /* 1626451 */   // Label 22408: @1626451
     /* 1626451 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1626537), // Rule ID 3966 //
     /* 1626456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1626476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626502 */     // MIs[0] policy
     /* 1626502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626512 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1626515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626536 */     // GIR_Coverage, 3966,
     /* 1626536 */     GIR_EraseRootFromParent_Done,
     /* 1626537 */   // Label 22409: @1626537
     /* 1626537 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1626623), // Rule ID 3967 //
     /* 1626542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1626562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626588 */     // MIs[0] policy
     /* 1626588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1626601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626622 */     // GIR_Coverage, 3967,
     /* 1626622 */     GIR_EraseRootFromParent_Done,
     /* 1626623 */   // Label 22410: @1626623
     /* 1626623 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1626709), // Rule ID 3970 //
     /* 1626628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1626648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626674 */     // MIs[0] policy
     /* 1626674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1626687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626708 */     // GIR_Coverage, 3970,
     /* 1626708 */     GIR_EraseRootFromParent_Done,
     /* 1626709 */   // Label 22411: @1626709
     /* 1626709 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1626795), // Rule ID 3971 //
     /* 1626714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1626734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626760 */     // MIs[0] policy
     /* 1626760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1626773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626794 */     // GIR_Coverage, 3971,
     /* 1626794 */     GIR_EraseRootFromParent_Done,
     /* 1626795 */   // Label 22412: @1626795
     /* 1626795 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1626881), // Rule ID 3974 //
     /* 1626800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1626820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626846 */     // MIs[0] policy
     /* 1626846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1626859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626880 */     // GIR_Coverage, 3974,
     /* 1626880 */     GIR_EraseRootFromParent_Done,
     /* 1626881 */   // Label 22413: @1626881
     /* 1626881 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1626967), // Rule ID 3975 //
     /* 1626886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1626906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626932 */     // MIs[0] policy
     /* 1626932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1626945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626966 */     // GIR_Coverage, 3975,
     /* 1626966 */     GIR_EraseRootFromParent_Done,
     /* 1626967 */   // Label 22414: @1626967
     /* 1626967 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1627053), // Rule ID 3978 //
     /* 1626972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1626992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627018 */     // MIs[0] policy
     /* 1627018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1627031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627052 */     // GIR_Coverage, 3978,
     /* 1627052 */     GIR_EraseRootFromParent_Done,
     /* 1627053 */   // Label 22415: @1627053
     /* 1627053 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1627139), // Rule ID 3979 //
     /* 1627058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1627075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1627078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627104 */     // MIs[0] policy
     /* 1627104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1627117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627138 */     // GIR_Coverage, 3979,
     /* 1627138 */     GIR_EraseRootFromParent_Done,
     /* 1627139 */   // Label 22416: @1627139
     /* 1627139 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1627225), // Rule ID 3982 //
     /* 1627144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1627164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627190 */     // MIs[0] policy
     /* 1627190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1627203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627224 */     // GIR_Coverage, 3982,
     /* 1627224 */     GIR_EraseRootFromParent_Done,
     /* 1627225 */   // Label 22417: @1627225
     /* 1627225 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1627311), // Rule ID 3983 //
     /* 1627230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1627247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1627250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627276 */     // MIs[0] policy
     /* 1627276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1627289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627310 */     // GIR_Coverage, 3983,
     /* 1627310 */     GIR_EraseRootFromParent_Done,
     /* 1627311 */   // Label 22418: @1627311
     /* 1627311 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1627397), // Rule ID 3986 //
     /* 1627316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1627336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627362 */     // MIs[0] policy
     /* 1627362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1627375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627396 */     // GIR_Coverage, 3986,
     /* 1627396 */     GIR_EraseRootFromParent_Done,
     /* 1627397 */   // Label 22419: @1627397
     /* 1627397 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1627483), // Rule ID 3987 //
     /* 1627402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1627422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627448 */     // MIs[0] policy
     /* 1627448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1627461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627482 */     // GIR_Coverage, 3987,
     /* 1627482 */     GIR_EraseRootFromParent_Done,
     /* 1627483 */   // Label 22420: @1627483
     /* 1627483 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1627569), // Rule ID 3990 //
     /* 1627488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1627508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627534 */     // MIs[0] policy
     /* 1627534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1627547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627568 */     // GIR_Coverage, 3990,
     /* 1627568 */     GIR_EraseRootFromParent_Done,
     /* 1627569 */   // Label 22421: @1627569
     /* 1627569 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1627655), // Rule ID 3991 //
     /* 1627574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1627594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627620 */     // MIs[0] policy
     /* 1627620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1627633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627654 */     // GIR_Coverage, 3991,
     /* 1627654 */     GIR_EraseRootFromParent_Done,
     /* 1627655 */   // Label 22422: @1627655
     /* 1627655 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1627741), // Rule ID 3994 //
     /* 1627660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1627680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627706 */     // MIs[0] policy
     /* 1627706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1627719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627740 */     // GIR_Coverage, 3994,
     /* 1627740 */     GIR_EraseRootFromParent_Done,
     /* 1627741 */   // Label 22423: @1627741
     /* 1627741 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1627827), // Rule ID 3995 //
     /* 1627746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1627766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627792 */     // MIs[0] policy
     /* 1627792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1627805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627826 */     // GIR_Coverage, 3995,
     /* 1627826 */     GIR_EraseRootFromParent_Done,
     /* 1627827 */   // Label 22424: @1627827
     /* 1627827 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1627913), // Rule ID 3998 //
     /* 1627832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1627852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627878 */     // MIs[0] policy
     /* 1627878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1627891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627912 */     // GIR_Coverage, 3998,
     /* 1627912 */     GIR_EraseRootFromParent_Done,
     /* 1627913 */   // Label 22425: @1627913
     /* 1627913 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1627999), // Rule ID 3999 //
     /* 1627918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1627938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627964 */     // MIs[0] policy
     /* 1627964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1627977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627998 */     // GIR_Coverage, 3999,
     /* 1627998 */     GIR_EraseRootFromParent_Done,
     /* 1627999 */   // Label 22426: @1627999
     /* 1627999 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1628085), // Rule ID 4002 //
     /* 1628004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628050 */     // MIs[0] policy
     /* 1628050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1628063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628084 */     // GIR_Coverage, 4002,
     /* 1628084 */     GIR_EraseRootFromParent_Done,
     /* 1628085 */   // Label 22427: @1628085
     /* 1628085 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1628171), // Rule ID 4003 //
     /* 1628090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1628107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628136 */     // MIs[0] policy
     /* 1628136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1628149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628170 */     // GIR_Coverage, 4003,
     /* 1628170 */     GIR_EraseRootFromParent_Done,
     /* 1628171 */   // Label 22428: @1628171
     /* 1628171 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1628257), // Rule ID 4006 //
     /* 1628176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628222 */     // MIs[0] policy
     /* 1628222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1628235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628256 */     // GIR_Coverage, 4006,
     /* 1628256 */     GIR_EraseRootFromParent_Done,
     /* 1628257 */   // Label 22429: @1628257
     /* 1628257 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1628343), // Rule ID 4007 //
     /* 1628262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1628279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628308 */     // MIs[0] policy
     /* 1628308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1628321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628342 */     // GIR_Coverage, 4007,
     /* 1628342 */     GIR_EraseRootFromParent_Done,
     /* 1628343 */   // Label 22430: @1628343
     /* 1628343 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1628429), // Rule ID 4010 //
     /* 1628348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628394 */     // MIs[0] policy
     /* 1628394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1628407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628428 */     // GIR_Coverage, 4010,
     /* 1628428 */     GIR_EraseRootFromParent_Done,
     /* 1628429 */   // Label 22431: @1628429
     /* 1628429 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1628515), // Rule ID 4011 //
     /* 1628434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628480 */     // MIs[0] policy
     /* 1628480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1628493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628514 */     // GIR_Coverage, 4011,
     /* 1628514 */     GIR_EraseRootFromParent_Done,
     /* 1628515 */   // Label 22432: @1628515
     /* 1628515 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1628601), // Rule ID 4014 //
     /* 1628520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628566 */     // MIs[0] policy
     /* 1628566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1628579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628600 */     // GIR_Coverage, 4014,
     /* 1628600 */     GIR_EraseRootFromParent_Done,
     /* 1628601 */   // Label 22433: @1628601
     /* 1628601 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1628687), // Rule ID 4015 //
     /* 1628606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628652 */     // MIs[0] policy
     /* 1628652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1628665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628686 */     // GIR_Coverage, 4015,
     /* 1628686 */     GIR_EraseRootFromParent_Done,
     /* 1628687 */   // Label 22434: @1628687
     /* 1628687 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1628773), // Rule ID 4018 //
     /* 1628692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628738 */     // MIs[0] policy
     /* 1628738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1628751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628772 */     // GIR_Coverage, 4018,
     /* 1628772 */     GIR_EraseRootFromParent_Done,
     /* 1628773 */   // Label 22435: @1628773
     /* 1628773 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1628859), // Rule ID 4019 //
     /* 1628778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628824 */     // MIs[0] policy
     /* 1628824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1628837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628858 */     // GIR_Coverage, 4019,
     /* 1628858 */     GIR_EraseRootFromParent_Done,
     /* 1628859 */   // Label 22436: @1628859
     /* 1628859 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1628945), // Rule ID 4022 //
     /* 1628864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628910 */     // MIs[0] policy
     /* 1628910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628920 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1628923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628944 */     // GIR_Coverage, 4022,
     /* 1628944 */     GIR_EraseRootFromParent_Done,
     /* 1628945 */   // Label 22437: @1628945
     /* 1628945 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1629031), // Rule ID 4023 //
     /* 1628950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628996 */     // MIs[0] policy
     /* 1628996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1629009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629030 */     // GIR_Coverage, 4023,
     /* 1629030 */     GIR_EraseRootFromParent_Done,
     /* 1629031 */   // Label 22438: @1629031
     /* 1629031 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1629117), // Rule ID 4026 //
     /* 1629036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629082 */     // MIs[0] policy
     /* 1629082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1629095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629116 */     // GIR_Coverage, 4026,
     /* 1629116 */     GIR_EraseRootFromParent_Done,
     /* 1629117 */   // Label 22439: @1629117
     /* 1629117 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1629203), // Rule ID 4027 //
     /* 1629122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1629139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629168 */     // MIs[0] policy
     /* 1629168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1629181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629202 */     // GIR_Coverage, 4027,
     /* 1629202 */     GIR_EraseRootFromParent_Done,
     /* 1629203 */   // Label 22440: @1629203
     /* 1629203 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1629289), // Rule ID 4030 //
     /* 1629208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629254 */     // MIs[0] policy
     /* 1629254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1629267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629288 */     // GIR_Coverage, 4030,
     /* 1629288 */     GIR_EraseRootFromParent_Done,
     /* 1629289 */   // Label 22441: @1629289
     /* 1629289 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1629375), // Rule ID 4031 //
     /* 1629294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1629311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629340 */     // MIs[0] policy
     /* 1629340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1629353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629374 */     // GIR_Coverage, 4031,
     /* 1629374 */     GIR_EraseRootFromParent_Done,
     /* 1629375 */   // Label 22442: @1629375
     /* 1629375 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1629461), // Rule ID 4034 //
     /* 1629380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629426 */     // MIs[0] policy
     /* 1629426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1629439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629460 */     // GIR_Coverage, 4034,
     /* 1629460 */     GIR_EraseRootFromParent_Done,
     /* 1629461 */   // Label 22443: @1629461
     /* 1629461 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1629547), // Rule ID 4035 //
     /* 1629466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629512 */     // MIs[0] policy
     /* 1629512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1629525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629546 */     // GIR_Coverage, 4035,
     /* 1629546 */     GIR_EraseRootFromParent_Done,
     /* 1629547 */   // Label 22444: @1629547
     /* 1629547 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1629633), // Rule ID 4038 //
     /* 1629552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629598 */     // MIs[0] policy
     /* 1629598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1629611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629632 */     // GIR_Coverage, 4038,
     /* 1629632 */     GIR_EraseRootFromParent_Done,
     /* 1629633 */   // Label 22445: @1629633
     /* 1629633 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1629719), // Rule ID 4039 //
     /* 1629638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629684 */     // MIs[0] policy
     /* 1629684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1629697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629718 */     // GIR_Coverage, 4039,
     /* 1629718 */     GIR_EraseRootFromParent_Done,
     /* 1629719 */   // Label 22446: @1629719
     /* 1629719 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1629805), // Rule ID 4042 //
     /* 1629724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629770 */     // MIs[0] policy
     /* 1629770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629780 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1629783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629804 */     // GIR_Coverage, 4042,
     /* 1629804 */     GIR_EraseRootFromParent_Done,
     /* 1629805 */   // Label 22447: @1629805
     /* 1629805 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1629891), // Rule ID 4043 //
     /* 1629810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629856 */     // MIs[0] policy
     /* 1629856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629866 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1629869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629890 */     // GIR_Coverage, 4043,
     /* 1629890 */     GIR_EraseRootFromParent_Done,
     /* 1629891 */   // Label 22448: @1629891
     /* 1629891 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1629977), // Rule ID 4046 //
     /* 1629896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629942 */     // MIs[0] policy
     /* 1629942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1629955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629976 */     // GIR_Coverage, 4046,
     /* 1629976 */     GIR_EraseRootFromParent_Done,
     /* 1629977 */   // Label 22449: @1629977
     /* 1629977 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1630063), // Rule ID 4047 //
     /* 1629982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630028 */     // MIs[0] policy
     /* 1630028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1630041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630062 */     // GIR_Coverage, 4047,
     /* 1630062 */     GIR_EraseRootFromParent_Done,
     /* 1630063 */   // Label 22450: @1630063
     /* 1630063 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1630149), // Rule ID 4050 //
     /* 1630068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630114 */     // MIs[0] policy
     /* 1630114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630148 */     // GIR_Coverage, 4050,
     /* 1630148 */     GIR_EraseRootFromParent_Done,
     /* 1630149 */   // Label 22451: @1630149
     /* 1630149 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1630235), // Rule ID 4051 //
     /* 1630154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1630171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630200 */     // MIs[0] policy
     /* 1630200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630234 */     // GIR_Coverage, 4051,
     /* 1630234 */     GIR_EraseRootFromParent_Done,
     /* 1630235 */   // Label 22452: @1630235
     /* 1630235 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1630321), // Rule ID 4054 //
     /* 1630240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630286 */     // MIs[0] policy
     /* 1630286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1630299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630320 */     // GIR_Coverage, 4054,
     /* 1630320 */     GIR_EraseRootFromParent_Done,
     /* 1630321 */   // Label 22453: @1630321
     /* 1630321 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1630407), // Rule ID 4055 //
     /* 1630326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630372 */     // MIs[0] policy
     /* 1630372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1630385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630406 */     // GIR_Coverage, 4055,
     /* 1630406 */     GIR_EraseRootFromParent_Done,
     /* 1630407 */   // Label 22454: @1630407
     /* 1630407 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1630493), // Rule ID 4058 //
     /* 1630412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630458 */     // MIs[0] policy
     /* 1630458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1630471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630492 */     // GIR_Coverage, 4058,
     /* 1630492 */     GIR_EraseRootFromParent_Done,
     /* 1630493 */   // Label 22455: @1630493
     /* 1630493 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1630579), // Rule ID 4059 //
     /* 1630498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630544 */     // MIs[0] policy
     /* 1630544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1630557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630578 */     // GIR_Coverage, 4059,
     /* 1630578 */     GIR_EraseRootFromParent_Done,
     /* 1630579 */   // Label 22456: @1630579
     /* 1630579 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1630665), // Rule ID 4068 //
     /* 1630584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1630601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1630604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630630 */     // MIs[0] policy
     /* 1630630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1630643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630664 */     // GIR_Coverage, 4068,
     /* 1630664 */     GIR_EraseRootFromParent_Done,
     /* 1630665 */   // Label 22457: @1630665
     /* 1630665 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1630751), // Rule ID 4069 //
     /* 1630670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1630687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1630690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630716 */     // MIs[0] policy
     /* 1630716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1630729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630750 */     // GIR_Coverage, 4069,
     /* 1630750 */     GIR_EraseRootFromParent_Done,
     /* 1630751 */   // Label 22458: @1630751
     /* 1630751 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1630837), // Rule ID 4078 //
     /* 1630756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1630773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1630776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630802 */     // MIs[0] policy
     /* 1630802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1630815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630836 */     // GIR_Coverage, 4078,
     /* 1630836 */     GIR_EraseRootFromParent_Done,
     /* 1630837 */   // Label 22459: @1630837
     /* 1630837 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1630923), // Rule ID 4079 //
     /* 1630842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1630859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1630862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630888 */     // MIs[0] policy
     /* 1630888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1630901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630922 */     // GIR_Coverage, 4079,
     /* 1630922 */     GIR_EraseRootFromParent_Done,
     /* 1630923 */   // Label 22460: @1630923
     /* 1630923 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1631009), // Rule ID 4088 //
     /* 1630928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1630939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1630942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1630945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1630948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630974 */     // MIs[0] policy
     /* 1630974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1630987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631008 */     // GIR_Coverage, 4088,
     /* 1631008 */     GIR_EraseRootFromParent_Done,
     /* 1631009 */   // Label 22461: @1631009
     /* 1631009 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1631095), // Rule ID 4089 //
     /* 1631014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1631034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631060 */     // MIs[0] policy
     /* 1631060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1631073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631094 */     // GIR_Coverage, 4089,
     /* 1631094 */     GIR_EraseRootFromParent_Done,
     /* 1631095 */   // Label 22462: @1631095
     /* 1631095 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1631181), // Rule ID 4098 //
     /* 1631100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1631117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1631120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631146 */     // MIs[0] policy
     /* 1631146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1631159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631180 */     // GIR_Coverage, 4098,
     /* 1631180 */     GIR_EraseRootFromParent_Done,
     /* 1631181 */   // Label 22463: @1631181
     /* 1631181 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1631267), // Rule ID 4099 //
     /* 1631186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1631203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1631206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631232 */     // MIs[0] policy
     /* 1631232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631242 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1631245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631266 */     // GIR_Coverage, 4099,
     /* 1631266 */     GIR_EraseRootFromParent_Done,
     /* 1631267 */   // Label 22464: @1631267
     /* 1631267 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1631353), // Rule ID 4108 //
     /* 1631272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1631289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1631292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631318 */     // MIs[0] policy
     /* 1631318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631328 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1631331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631352 */     // GIR_Coverage, 4108,
     /* 1631352 */     GIR_EraseRootFromParent_Done,
     /* 1631353 */   // Label 22465: @1631353
     /* 1631353 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1631439), // Rule ID 4109 //
     /* 1631358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1631375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1631378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631404 */     // MIs[0] policy
     /* 1631404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1631417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631438 */     // GIR_Coverage, 4109,
     /* 1631438 */     GIR_EraseRootFromParent_Done,
     /* 1631439 */   // Label 22466: @1631439
     /* 1631439 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1631525), // Rule ID 4118 //
     /* 1631444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1631461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1631464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631490 */     // MIs[0] policy
     /* 1631490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1631503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631524 */     // GIR_Coverage, 4118,
     /* 1631524 */     GIR_EraseRootFromParent_Done,
     /* 1631525 */   // Label 22467: @1631525
     /* 1631525 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1631611), // Rule ID 4119 //
     /* 1631530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1631547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1631550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631576 */     // MIs[0] policy
     /* 1631576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1631589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631610 */     // GIR_Coverage, 4119,
     /* 1631610 */     GIR_EraseRootFromParent_Done,
     /* 1631611 */   // Label 22468: @1631611
     /* 1631611 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1631697), // Rule ID 4128 //
     /* 1631616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1631633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1631636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631662 */     // MIs[0] policy
     /* 1631662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1631675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631696 */     // GIR_Coverage, 4128,
     /* 1631696 */     GIR_EraseRootFromParent_Done,
     /* 1631697 */   // Label 22469: @1631697
     /* 1631697 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1631783), // Rule ID 4129 //
     /* 1631702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1631719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1631722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631748 */     // MIs[0] policy
     /* 1631748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1631761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631782 */     // GIR_Coverage, 4129,
     /* 1631782 */     GIR_EraseRootFromParent_Done,
     /* 1631783 */   // Label 22470: @1631783
     /* 1631783 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1631869), // Rule ID 4138 //
     /* 1631788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1631805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1631808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631834 */     // MIs[0] policy
     /* 1631834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1631847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631868 */     // GIR_Coverage, 4138,
     /* 1631868 */     GIR_EraseRootFromParent_Done,
     /* 1631869 */   // Label 22471: @1631869
     /* 1631869 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1631955), // Rule ID 4139 //
     /* 1631874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1631891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1631894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631920 */     // MIs[0] policy
     /* 1631920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1631933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631954 */     // GIR_Coverage, 4139,
     /* 1631954 */     GIR_EraseRootFromParent_Done,
     /* 1631955 */   // Label 22472: @1631955
     /* 1631955 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1632041), // Rule ID 4148 //
     /* 1631960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1631971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1631974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1631977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1631980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632006 */     // MIs[0] policy
     /* 1632006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1632019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632040 */     // GIR_Coverage, 4148,
     /* 1632040 */     GIR_EraseRootFromParent_Done,
     /* 1632041 */   // Label 22473: @1632041
     /* 1632041 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1632127), // Rule ID 4149 //
     /* 1632046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1632066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632092 */     // MIs[0] policy
     /* 1632092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1632105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632126 */     // GIR_Coverage, 4149,
     /* 1632126 */     GIR_EraseRootFromParent_Done,
     /* 1632127 */   // Label 22474: @1632127
     /* 1632127 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1632213), // Rule ID 4158 //
     /* 1632132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1632149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1632152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632178 */     // MIs[0] policy
     /* 1632178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1632191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632212 */     // GIR_Coverage, 4158,
     /* 1632212 */     GIR_EraseRootFromParent_Done,
     /* 1632213 */   // Label 22475: @1632213
     /* 1632213 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1632299), // Rule ID 4159 //
     /* 1632218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1632235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1632238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632264 */     // MIs[0] policy
     /* 1632264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1632277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632298 */     // GIR_Coverage, 4159,
     /* 1632298 */     GIR_EraseRootFromParent_Done,
     /* 1632299 */   // Label 22476: @1632299
     /* 1632299 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1632385), // Rule ID 4168 //
     /* 1632304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1632321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1632324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632350 */     // MIs[0] policy
     /* 1632350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1632363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632384 */     // GIR_Coverage, 4168,
     /* 1632384 */     GIR_EraseRootFromParent_Done,
     /* 1632385 */   // Label 22477: @1632385
     /* 1632385 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1632471), // Rule ID 4169 //
     /* 1632390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1632407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1632410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632436 */     // MIs[0] policy
     /* 1632436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1632449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632470 */     // GIR_Coverage, 4169,
     /* 1632470 */     GIR_EraseRootFromParent_Done,
     /* 1632471 */   // Label 22478: @1632471
     /* 1632471 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1632557), // Rule ID 4178 //
     /* 1632476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1632493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1632496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632522 */     // MIs[0] policy
     /* 1632522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1632535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632556 */     // GIR_Coverage, 4178,
     /* 1632556 */     GIR_EraseRootFromParent_Done,
     /* 1632557 */   // Label 22479: @1632557
     /* 1632557 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1632643), // Rule ID 4179 //
     /* 1632562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1632579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1632582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632608 */     // MIs[0] policy
     /* 1632608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1632621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632642 */     // GIR_Coverage, 4179,
     /* 1632642 */     GIR_EraseRootFromParent_Done,
     /* 1632643 */   // Label 22480: @1632643
     /* 1632643 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1632729), // Rule ID 4188 //
     /* 1632648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1632665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1632668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632694 */     // MIs[0] policy
     /* 1632694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1632707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632728 */     // GIR_Coverage, 4188,
     /* 1632728 */     GIR_EraseRootFromParent_Done,
     /* 1632729 */   // Label 22481: @1632729
     /* 1632729 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1632815), // Rule ID 4189 //
     /* 1632734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1632751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1632754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632780 */     // MIs[0] policy
     /* 1632780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1632793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632814 */     // GIR_Coverage, 4189,
     /* 1632814 */     GIR_EraseRootFromParent_Done,
     /* 1632815 */   // Label 22482: @1632815
     /* 1632815 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1632901), // Rule ID 4198 //
     /* 1632820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1632837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1632840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632866 */     // MIs[0] policy
     /* 1632866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632876 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1632879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632900 */     // GIR_Coverage, 4198,
     /* 1632900 */     GIR_EraseRootFromParent_Done,
     /* 1632901 */   // Label 22483: @1632901
     /* 1632901 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1632987), // Rule ID 4199 //
     /* 1632906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1632923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1632926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632952 */     // MIs[0] policy
     /* 1632952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1632965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632986 */     // GIR_Coverage, 4199,
     /* 1632986 */     GIR_EraseRootFromParent_Done,
     /* 1632987 */   // Label 22484: @1632987
     /* 1632987 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1633073), // Rule ID 4202 //
     /* 1632992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1633003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1633006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1633009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633038 */     // MIs[0] policy
     /* 1633038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633048 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1633051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633072 */     // GIR_Coverage, 4202,
     /* 1633072 */     GIR_EraseRootFromParent_Done,
     /* 1633073 */   // Label 22485: @1633073
     /* 1633073 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1633159), // Rule ID 4203 //
     /* 1633078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1633089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1633092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1633095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633124 */     // MIs[0] policy
     /* 1633124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1633137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633158 */     // GIR_Coverage, 4203,
     /* 1633158 */     GIR_EraseRootFromParent_Done,
     /* 1633159 */   // Label 22486: @1633159
     /* 1633159 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1633245), // Rule ID 4206 //
     /* 1633164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633210 */     // MIs[0] policy
     /* 1633210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633220 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1633223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633244 */     // GIR_Coverage, 4206,
     /* 1633244 */     GIR_EraseRootFromParent_Done,
     /* 1633245 */   // Label 22487: @1633245
     /* 1633245 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1633331), // Rule ID 4207 //
     /* 1633250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633296 */     // MIs[0] policy
     /* 1633296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1633309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633330 */     // GIR_Coverage, 4207,
     /* 1633330 */     GIR_EraseRootFromParent_Done,
     /* 1633331 */   // Label 22488: @1633331
     /* 1633331 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1633417), // Rule ID 4210 //
     /* 1633336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633382 */     // MIs[0] policy
     /* 1633382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1633395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633416 */     // GIR_Coverage, 4210,
     /* 1633416 */     GIR_EraseRootFromParent_Done,
     /* 1633417 */   // Label 22489: @1633417
     /* 1633417 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1633503), // Rule ID 4211 //
     /* 1633422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633468 */     // MIs[0] policy
     /* 1633468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1633481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633502 */     // GIR_Coverage, 4211,
     /* 1633502 */     GIR_EraseRootFromParent_Done,
     /* 1633503 */   // Label 22490: @1633503
     /* 1633503 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1633589), // Rule ID 4214 //
     /* 1633508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633554 */     // MIs[0] policy
     /* 1633554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1633567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633588 */     // GIR_Coverage, 4214,
     /* 1633588 */     GIR_EraseRootFromParent_Done,
     /* 1633589 */   // Label 22491: @1633589
     /* 1633589 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1633675), // Rule ID 4215 //
     /* 1633594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633640 */     // MIs[0] policy
     /* 1633640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1633653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633674 */     // GIR_Coverage, 4215,
     /* 1633674 */     GIR_EraseRootFromParent_Done,
     /* 1633675 */   // Label 22492: @1633675
     /* 1633675 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1633761), // Rule ID 4218 //
     /* 1633680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633726 */     // MIs[0] policy
     /* 1633726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1633739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633760 */     // GIR_Coverage, 4218,
     /* 1633760 */     GIR_EraseRootFromParent_Done,
     /* 1633761 */   // Label 22493: @1633761
     /* 1633761 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1633847), // Rule ID 4219 //
     /* 1633766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633812 */     // MIs[0] policy
     /* 1633812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1633825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633846 */     // GIR_Coverage, 4219,
     /* 1633846 */     GIR_EraseRootFromParent_Done,
     /* 1633847 */   // Label 22494: @1633847
     /* 1633847 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1633933), // Rule ID 4222 //
     /* 1633852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633898 */     // MIs[0] policy
     /* 1633898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1633911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633932 */     // GIR_Coverage, 4222,
     /* 1633932 */     GIR_EraseRootFromParent_Done,
     /* 1633933 */   // Label 22495: @1633933
     /* 1633933 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1634019), // Rule ID 4223 //
     /* 1633938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633984 */     // MIs[0] policy
     /* 1633984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1633997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634018 */     // GIR_Coverage, 4223,
     /* 1634018 */     GIR_EraseRootFromParent_Done,
     /* 1634019 */   // Label 22496: @1634019
     /* 1634019 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1634105), // Rule ID 4226 //
     /* 1634024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634070 */     // MIs[0] policy
     /* 1634070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634080 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1634083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634104 */     // GIR_Coverage, 4226,
     /* 1634104 */     GIR_EraseRootFromParent_Done,
     /* 1634105 */   // Label 22497: @1634105
     /* 1634105 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1634191), // Rule ID 4227 //
     /* 1634110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634156 */     // MIs[0] policy
     /* 1634156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1634169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634190 */     // GIR_Coverage, 4227,
     /* 1634190 */     GIR_EraseRootFromParent_Done,
     /* 1634191 */   // Label 22498: @1634191
     /* 1634191 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1634277), // Rule ID 4230 //
     /* 1634196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634242 */     // MIs[0] policy
     /* 1634242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1634255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634276 */     // GIR_Coverage, 4230,
     /* 1634276 */     GIR_EraseRootFromParent_Done,
     /* 1634277 */   // Label 22499: @1634277
     /* 1634277 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1634363), // Rule ID 4231 //
     /* 1634282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1634293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1634296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1634299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634328 */     // MIs[0] policy
     /* 1634328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1634341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634362 */     // GIR_Coverage, 4231,
     /* 1634362 */     GIR_EraseRootFromParent_Done,
     /* 1634363 */   // Label 22500: @1634363
     /* 1634363 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1634449), // Rule ID 4234 //
     /* 1634368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634414 */     // MIs[0] policy
     /* 1634414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1634427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634448 */     // GIR_Coverage, 4234,
     /* 1634448 */     GIR_EraseRootFromParent_Done,
     /* 1634449 */   // Label 22501: @1634449
     /* 1634449 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1634535), // Rule ID 4235 //
     /* 1634454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634500 */     // MIs[0] policy
     /* 1634500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1634513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634534 */     // GIR_Coverage, 4235,
     /* 1634534 */     GIR_EraseRootFromParent_Done,
     /* 1634535 */   // Label 22502: @1634535
     /* 1634535 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1634621), // Rule ID 4238 //
     /* 1634540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634586 */     // MIs[0] policy
     /* 1634586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1634599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634620 */     // GIR_Coverage, 4238,
     /* 1634620 */     GIR_EraseRootFromParent_Done,
     /* 1634621 */   // Label 22503: @1634621
     /* 1634621 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1634707), // Rule ID 4239 //
     /* 1634626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634672 */     // MIs[0] policy
     /* 1634672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1634685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634706 */     // GIR_Coverage, 4239,
     /* 1634706 */     GIR_EraseRootFromParent_Done,
     /* 1634707 */   // Label 22504: @1634707
     /* 1634707 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1634793), // Rule ID 4242 //
     /* 1634712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634758 */     // MIs[0] policy
     /* 1634758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1634771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634792 */     // GIR_Coverage, 4242,
     /* 1634792 */     GIR_EraseRootFromParent_Done,
     /* 1634793 */   // Label 22505: @1634793
     /* 1634793 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1634879), // Rule ID 4243 //
     /* 1634798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634844 */     // MIs[0] policy
     /* 1634844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1634857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634878 */     // GIR_Coverage, 4243,
     /* 1634878 */     GIR_EraseRootFromParent_Done,
     /* 1634879 */   // Label 22506: @1634879
     /* 1634879 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1634965), // Rule ID 4246 //
     /* 1634884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634930 */     // MIs[0] policy
     /* 1634930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1634943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634964 */     // GIR_Coverage, 4246,
     /* 1634964 */     GIR_EraseRootFromParent_Done,
     /* 1634965 */   // Label 22507: @1634965
     /* 1634965 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1635051), // Rule ID 4247 //
     /* 1634970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635016 */     // MIs[0] policy
     /* 1635016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1635029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635050 */     // GIR_Coverage, 4247,
     /* 1635050 */     GIR_EraseRootFromParent_Done,
     /* 1635051 */   // Label 22508: @1635051
     /* 1635051 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1635137), // Rule ID 4250 //
     /* 1635056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635102 */     // MIs[0] policy
     /* 1635102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635136 */     // GIR_Coverage, 4250,
     /* 1635136 */     GIR_EraseRootFromParent_Done,
     /* 1635137 */   // Label 22509: @1635137
     /* 1635137 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1635223), // Rule ID 4251 //
     /* 1635142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635188 */     // MIs[0] policy
     /* 1635188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635222 */     // GIR_Coverage, 4251,
     /* 1635222 */     GIR_EraseRootFromParent_Done,
     /* 1635223 */   // Label 22510: @1635223
     /* 1635223 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1635309), // Rule ID 4254 //
     /* 1635228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635274 */     // MIs[0] policy
     /* 1635274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1635287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635308 */     // GIR_Coverage, 4254,
     /* 1635308 */     GIR_EraseRootFromParent_Done,
     /* 1635309 */   // Label 22511: @1635309
     /* 1635309 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1635395), // Rule ID 4255 //
     /* 1635314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1635325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1635328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1635331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635360 */     // MIs[0] policy
     /* 1635360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1635373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635394 */     // GIR_Coverage, 4255,
     /* 1635394 */     GIR_EraseRootFromParent_Done,
     /* 1635395 */   // Label 22512: @1635395
     /* 1635395 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1635481), // Rule ID 4258 //
     /* 1635400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635446 */     // MIs[0] policy
     /* 1635446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1635459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635480 */     // GIR_Coverage, 4258,
     /* 1635480 */     GIR_EraseRootFromParent_Done,
     /* 1635481 */   // Label 22513: @1635481
     /* 1635481 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1635567), // Rule ID 4259 //
     /* 1635486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635532 */     // MIs[0] policy
     /* 1635532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1635545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635566 */     // GIR_Coverage, 4259,
     /* 1635566 */     GIR_EraseRootFromParent_Done,
     /* 1635567 */   // Label 22514: @1635567
     /* 1635567 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1635653), // Rule ID 4268 //
     /* 1635572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1635592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635618 */     // MIs[0] policy
     /* 1635618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635628 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1635631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635652 */     // GIR_Coverage, 4268,
     /* 1635652 */     GIR_EraseRootFromParent_Done,
     /* 1635653 */   // Label 22515: @1635653
     /* 1635653 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1635739), // Rule ID 4269 //
     /* 1635658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1635678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635704 */     // MIs[0] policy
     /* 1635704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1635717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635738 */     // GIR_Coverage, 4269,
     /* 1635738 */     GIR_EraseRootFromParent_Done,
     /* 1635739 */   // Label 22516: @1635739
     /* 1635739 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1635825), // Rule ID 4278 //
     /* 1635744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1635764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635790 */     // MIs[0] policy
     /* 1635790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1635803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635824 */     // GIR_Coverage, 4278,
     /* 1635824 */     GIR_EraseRootFromParent_Done,
     /* 1635825 */   // Label 22517: @1635825
     /* 1635825 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1635911), // Rule ID 4279 //
     /* 1635830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1635850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635876 */     // MIs[0] policy
     /* 1635876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1635889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635910 */     // GIR_Coverage, 4279,
     /* 1635910 */     GIR_EraseRootFromParent_Done,
     /* 1635911 */   // Label 22518: @1635911
     /* 1635911 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1635997), // Rule ID 4288 //
     /* 1635916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1635927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1635930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1635936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635962 */     // MIs[0] policy
     /* 1635962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1635975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635996 */     // GIR_Coverage, 4288,
     /* 1635996 */     GIR_EraseRootFromParent_Done,
     /* 1635997 */   // Label 22519: @1635997
     /* 1635997 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1636083), // Rule ID 4289 //
     /* 1636002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1636022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636048 */     // MIs[0] policy
     /* 1636048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1636061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636082 */     // GIR_Coverage, 4289,
     /* 1636082 */     GIR_EraseRootFromParent_Done,
     /* 1636083 */   // Label 22520: @1636083
     /* 1636083 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1636169), // Rule ID 4298 //
     /* 1636088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1636108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636134 */     // MIs[0] policy
     /* 1636134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1636147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636168 */     // GIR_Coverage, 4298,
     /* 1636168 */     GIR_EraseRootFromParent_Done,
     /* 1636169 */   // Label 22521: @1636169
     /* 1636169 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1636255), // Rule ID 4299 //
     /* 1636174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1636194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636220 */     // MIs[0] policy
     /* 1636220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1636233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636254 */     // GIR_Coverage, 4299,
     /* 1636254 */     GIR_EraseRootFromParent_Done,
     /* 1636255 */   // Label 22522: @1636255
     /* 1636255 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1636341), // Rule ID 4308 //
     /* 1636260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1636280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636306 */     // MIs[0] policy
     /* 1636306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1636319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636340 */     // GIR_Coverage, 4308,
     /* 1636340 */     GIR_EraseRootFromParent_Done,
     /* 1636341 */   // Label 22523: @1636341
     /* 1636341 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1636427), // Rule ID 4309 //
     /* 1636346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1636366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636392 */     // MIs[0] policy
     /* 1636392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1636405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636426 */     // GIR_Coverage, 4309,
     /* 1636426 */     GIR_EraseRootFromParent_Done,
     /* 1636427 */   // Label 22524: @1636427
     /* 1636427 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1636513), // Rule ID 4318 //
     /* 1636432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1636452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636478 */     // MIs[0] policy
     /* 1636478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1636491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636512 */     // GIR_Coverage, 4318,
     /* 1636512 */     GIR_EraseRootFromParent_Done,
     /* 1636513 */   // Label 22525: @1636513
     /* 1636513 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1636599), // Rule ID 4319 //
     /* 1636518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1636538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636564 */     // MIs[0] policy
     /* 1636564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1636577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636598 */     // GIR_Coverage, 4319,
     /* 1636598 */     GIR_EraseRootFromParent_Done,
     /* 1636599 */   // Label 22526: @1636599
     /* 1636599 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1636685), // Rule ID 4328 //
     /* 1636604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1636624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636650 */     // MIs[0] policy
     /* 1636650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636660 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1636663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636684 */     // GIR_Coverage, 4328,
     /* 1636684 */     GIR_EraseRootFromParent_Done,
     /* 1636685 */   // Label 22527: @1636685
     /* 1636685 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1636771), // Rule ID 4329 //
     /* 1636690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1636710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636736 */     // MIs[0] policy
     /* 1636736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1636749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636770 */     // GIR_Coverage, 4329,
     /* 1636770 */     GIR_EraseRootFromParent_Done,
     /* 1636771 */   // Label 22528: @1636771
     /* 1636771 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1636857), // Rule ID 4338 //
     /* 1636776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1636796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636822 */     // MIs[0] policy
     /* 1636822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1636835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636856 */     // GIR_Coverage, 4338,
     /* 1636856 */     GIR_EraseRootFromParent_Done,
     /* 1636857 */   // Label 22529: @1636857
     /* 1636857 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1636943), // Rule ID 4339 //
     /* 1636862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1636882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636908 */     // MIs[0] policy
     /* 1636908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1636921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636942 */     // GIR_Coverage, 4339,
     /* 1636942 */     GIR_EraseRootFromParent_Done,
     /* 1636943 */   // Label 22530: @1636943
     /* 1636943 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1637029), // Rule ID 4348 //
     /* 1636948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1636959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1636962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1636968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636994 */     // MIs[0] policy
     /* 1636994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1637007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637028 */     // GIR_Coverage, 4348,
     /* 1637028 */     GIR_EraseRootFromParent_Done,
     /* 1637029 */   // Label 22531: @1637029
     /* 1637029 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1637115), // Rule ID 4349 //
     /* 1637034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1637054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637080 */     // MIs[0] policy
     /* 1637080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1637093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637114 */     // GIR_Coverage, 4349,
     /* 1637114 */     GIR_EraseRootFromParent_Done,
     /* 1637115 */   // Label 22532: @1637115
     /* 1637115 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1637201), // Rule ID 4358 //
     /* 1637120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1637140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637166 */     // MIs[0] policy
     /* 1637166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637176 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1637179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637200 */     // GIR_Coverage, 4358,
     /* 1637200 */     GIR_EraseRootFromParent_Done,
     /* 1637201 */   // Label 22533: @1637201
     /* 1637201 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1637287), // Rule ID 4359 //
     /* 1637206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1637226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637252 */     // MIs[0] policy
     /* 1637252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1637265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637286 */     // GIR_Coverage, 4359,
     /* 1637286 */     GIR_EraseRootFromParent_Done,
     /* 1637287 */   // Label 22534: @1637287
     /* 1637287 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1637373), // Rule ID 4368 //
     /* 1637292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1637312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637338 */     // MIs[0] policy
     /* 1637338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1637351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637372 */     // GIR_Coverage, 4368,
     /* 1637372 */     GIR_EraseRootFromParent_Done,
     /* 1637373 */   // Label 22535: @1637373
     /* 1637373 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1637459), // Rule ID 4369 //
     /* 1637378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1637398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637424 */     // MIs[0] policy
     /* 1637424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1637437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637458 */     // GIR_Coverage, 4369,
     /* 1637458 */     GIR_EraseRootFromParent_Done,
     /* 1637459 */   // Label 22536: @1637459
     /* 1637459 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1637545), // Rule ID 4378 //
     /* 1637464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1637484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637510 */     // MIs[0] policy
     /* 1637510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1637523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637544 */     // GIR_Coverage, 4378,
     /* 1637544 */     GIR_EraseRootFromParent_Done,
     /* 1637545 */   // Label 22537: @1637545
     /* 1637545 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1637631), // Rule ID 4379 //
     /* 1637550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1637570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637596 */     // MIs[0] policy
     /* 1637596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1637609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637630 */     // GIR_Coverage, 4379,
     /* 1637630 */     GIR_EraseRootFromParent_Done,
     /* 1637631 */   // Label 22538: @1637631
     /* 1637631 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1637717), // Rule ID 4388 //
     /* 1637636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1637656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637682 */     // MIs[0] policy
     /* 1637682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1637695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637716 */     // GIR_Coverage, 4388,
     /* 1637716 */     GIR_EraseRootFromParent_Done,
     /* 1637717 */   // Label 22539: @1637717
     /* 1637717 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1637803), // Rule ID 4389 //
     /* 1637722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1637742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637768 */     // MIs[0] policy
     /* 1637768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1637781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637802 */     // GIR_Coverage, 4389,
     /* 1637802 */     GIR_EraseRootFromParent_Done,
     /* 1637803 */   // Label 22540: @1637803
     /* 1637803 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1637889), // Rule ID 4398 //
     /* 1637808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1637828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637854 */     // MIs[0] policy
     /* 1637854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1637867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637888 */     // GIR_Coverage, 4398,
     /* 1637888 */     GIR_EraseRootFromParent_Done,
     /* 1637889 */   // Label 22541: @1637889
     /* 1637889 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1637975), // Rule ID 4399 //
     /* 1637894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1637914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637940 */     // MIs[0] policy
     /* 1637940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1637953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637974 */     // GIR_Coverage, 4399,
     /* 1637974 */     GIR_EraseRootFromParent_Done,
     /* 1637975 */   // Label 22542: @1637975
     /* 1637975 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1638061), // Rule ID 4408 //
     /* 1637980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1637991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1637994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1637997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1638000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638026 */     // MIs[0] policy
     /* 1638026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638060 */     // GIR_Coverage, 4408,
     /* 1638060 */     GIR_EraseRootFromParent_Done,
     /* 1638061 */   // Label 22543: @1638061
     /* 1638061 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1638147), // Rule ID 4409 //
     /* 1638066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1638086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638112 */     // MIs[0] policy
     /* 1638112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638146 */     // GIR_Coverage, 4409,
     /* 1638146 */     GIR_EraseRootFromParent_Done,
     /* 1638147 */   // Label 22544: @1638147
     /* 1638147 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1638233), // Rule ID 4412 //
     /* 1638152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638198 */     // MIs[0] policy
     /* 1638198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1638211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638232 */     // GIR_Coverage, 4412,
     /* 1638232 */     GIR_EraseRootFromParent_Done,
     /* 1638233 */   // Label 22545: @1638233
     /* 1638233 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1638319), // Rule ID 4413 //
     /* 1638238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638284 */     // MIs[0] policy
     /* 1638284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1638297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638318 */     // GIR_Coverage, 4413,
     /* 1638318 */     GIR_EraseRootFromParent_Done,
     /* 1638319 */   // Label 22546: @1638319
     /* 1638319 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1638405), // Rule ID 4416 //
     /* 1638324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638370 */     // MIs[0] policy
     /* 1638370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638380 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1638383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638404 */     // GIR_Coverage, 4416,
     /* 1638404 */     GIR_EraseRootFromParent_Done,
     /* 1638405 */   // Label 22547: @1638405
     /* 1638405 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1638491), // Rule ID 4417 //
     /* 1638410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638456 */     // MIs[0] policy
     /* 1638456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1638469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638490 */     // GIR_Coverage, 4417,
     /* 1638490 */     GIR_EraseRootFromParent_Done,
     /* 1638491 */   // Label 22548: @1638491
     /* 1638491 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1638577), // Rule ID 4420 //
     /* 1638496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638542 */     // MIs[0] policy
     /* 1638542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1638555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638576 */     // GIR_Coverage, 4420,
     /* 1638576 */     GIR_EraseRootFromParent_Done,
     /* 1638577 */   // Label 22549: @1638577
     /* 1638577 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1638663), // Rule ID 4421 //
     /* 1638582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638628 */     // MIs[0] policy
     /* 1638628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11613:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1638641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638662 */     // GIR_Coverage, 4421,
     /* 1638662 */     GIR_EraseRootFromParent_Done,
     /* 1638663 */   // Label 22550: @1638663
     /* 1638663 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1638749), // Rule ID 4424 //
     /* 1638668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638714 */     // MIs[0] policy
     /* 1638714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1638727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638748 */     // GIR_Coverage, 4424,
     /* 1638748 */     GIR_EraseRootFromParent_Done,
     /* 1638749 */   // Label 22551: @1638749
     /* 1638749 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1638835), // Rule ID 4425 //
     /* 1638754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638800 */     // MIs[0] policy
     /* 1638800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1638813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638834 */     // GIR_Coverage, 4425,
     /* 1638834 */     GIR_EraseRootFromParent_Done,
     /* 1638835 */   // Label 22552: @1638835
     /* 1638835 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1638921), // Rule ID 4428 //
     /* 1638840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638886 */     // MIs[0] policy
     /* 1638886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1638899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638920 */     // GIR_Coverage, 4428,
     /* 1638920 */     GIR_EraseRootFromParent_Done,
     /* 1638921 */   // Label 22553: @1638921
     /* 1638921 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1639007), // Rule ID 4429 //
     /* 1638926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1638946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1638968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638972 */     // MIs[0] policy
     /* 1638972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638982 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1638985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639006 */     // GIR_Coverage, 4429,
     /* 1639006 */     GIR_EraseRootFromParent_Done,
     /* 1639007 */   // Label 22554: @1639007
     /* 1639007 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1639093), // Rule ID 4432 //
     /* 1639012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639058 */     // MIs[0] policy
     /* 1639058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639068 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1639071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639092 */     // GIR_Coverage, 4432,
     /* 1639092 */     GIR_EraseRootFromParent_Done,
     /* 1639093 */   // Label 22555: @1639093
     /* 1639093 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1639179), // Rule ID 4433 //
     /* 1639098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639144 */     // MIs[0] policy
     /* 1639144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1639157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639178 */     // GIR_Coverage, 4433,
     /* 1639178 */     GIR_EraseRootFromParent_Done,
     /* 1639179 */   // Label 22556: @1639179
     /* 1639179 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1639265), // Rule ID 4436 //
     /* 1639184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639230 */     // MIs[0] policy
     /* 1639230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1639243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639264 */     // GIR_Coverage, 4436,
     /* 1639264 */     GIR_EraseRootFromParent_Done,
     /* 1639265 */   // Label 22557: @1639265
     /* 1639265 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1639351), // Rule ID 4437 //
     /* 1639270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1639281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1639284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1639287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639316 */     // MIs[0] policy
     /* 1639316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1639329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639350 */     // GIR_Coverage, 4437,
     /* 1639350 */     GIR_EraseRootFromParent_Done,
     /* 1639351 */   // Label 22558: @1639351
     /* 1639351 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1639437), // Rule ID 4440 //
     /* 1639356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639402 */     // MIs[0] policy
     /* 1639402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1639415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639436 */     // GIR_Coverage, 4440,
     /* 1639436 */     GIR_EraseRootFromParent_Done,
     /* 1639437 */   // Label 22559: @1639437
     /* 1639437 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1639523), // Rule ID 4441 //
     /* 1639442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639488 */     // MIs[0] policy
     /* 1639488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11613:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1639501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639522 */     // GIR_Coverage, 4441,
     /* 1639522 */     GIR_EraseRootFromParent_Done,
     /* 1639523 */   // Label 22560: @1639523
     /* 1639523 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1639609), // Rule ID 4444 //
     /* 1639528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639574 */     // MIs[0] policy
     /* 1639574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1639587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639608 */     // GIR_Coverage, 4444,
     /* 1639608 */     GIR_EraseRootFromParent_Done,
     /* 1639609 */   // Label 22561: @1639609
     /* 1639609 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1639695), // Rule ID 4445 //
     /* 1639614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639660 */     // MIs[0] policy
     /* 1639660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1639673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639694 */     // GIR_Coverage, 4445,
     /* 1639694 */     GIR_EraseRootFromParent_Done,
     /* 1639695 */   // Label 22562: @1639695
     /* 1639695 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1639781), // Rule ID 4448 //
     /* 1639700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639746 */     // MIs[0] policy
     /* 1639746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1639759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639780 */     // GIR_Coverage, 4448,
     /* 1639780 */     GIR_EraseRootFromParent_Done,
     /* 1639781 */   // Label 22563: @1639781
     /* 1639781 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1639867), // Rule ID 4449 //
     /* 1639786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639832 */     // MIs[0] policy
     /* 1639832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1639845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639866 */     // GIR_Coverage, 4449,
     /* 1639866 */     GIR_EraseRootFromParent_Done,
     /* 1639867 */   // Label 22564: @1639867
     /* 1639867 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1639953), // Rule ID 4452 //
     /* 1639872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639918 */     // MIs[0] policy
     /* 1639918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639928 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1639931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639952 */     // GIR_Coverage, 4452,
     /* 1639952 */     GIR_EraseRootFromParent_Done,
     /* 1639953 */   // Label 22565: @1639953
     /* 1639953 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1640039), // Rule ID 4453 //
     /* 1639958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640004 */     // MIs[0] policy
     /* 1640004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1640017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640038 */     // GIR_Coverage, 4453,
     /* 1640038 */     GIR_EraseRootFromParent_Done,
     /* 1640039 */   // Label 22566: @1640039
     /* 1640039 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1640125), // Rule ID 4456 //
     /* 1640044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640090 */     // MIs[0] policy
     /* 1640090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640124 */     // GIR_Coverage, 4456,
     /* 1640124 */     GIR_EraseRootFromParent_Done,
     /* 1640125 */   // Label 22567: @1640125
     /* 1640125 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1640211), // Rule ID 4457 //
     /* 1640130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640176 */     // MIs[0] policy
     /* 1640176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11613:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640210 */     // GIR_Coverage, 4457,
     /* 1640210 */     GIR_EraseRootFromParent_Done,
     /* 1640211 */   // Label 22568: @1640211
     /* 1640211 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1640297), // Rule ID 4460 //
     /* 1640216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640262 */     // MIs[0] policy
     /* 1640262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1640275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640296 */     // GIR_Coverage, 4460,
     /* 1640296 */     GIR_EraseRootFromParent_Done,
     /* 1640297 */   // Label 22569: @1640297
     /* 1640297 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1640383), // Rule ID 4461 //
     /* 1640302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1640313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1640316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1640319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640348 */     // MIs[0] policy
     /* 1640348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11613:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1640361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640382 */     // GIR_Coverage, 4461,
     /* 1640382 */     GIR_EraseRootFromParent_Done,
     /* 1640383 */   // Label 22570: @1640383
     /* 1640383 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1640469), // Rule ID 4464 //
     /* 1640388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640434 */     // MIs[0] policy
     /* 1640434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1640447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640468 */     // GIR_Coverage, 4464,
     /* 1640468 */     GIR_EraseRootFromParent_Done,
     /* 1640469 */   // Label 22571: @1640469
     /* 1640469 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1640555), // Rule ID 4465 //
     /* 1640474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640520 */     // MIs[0] policy
     /* 1640520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11613:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1640533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640554 */     // GIR_Coverage, 4465,
     /* 1640554 */     GIR_EraseRootFromParent_Done,
     /* 1640555 */   // Label 22572: @1640555
     /* 1640555 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1640641), // Rule ID 4468 //
     /* 1640560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640606 */     // MIs[0] policy
     /* 1640606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640616 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1640619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640640 */     // GIR_Coverage, 4468,
     /* 1640640 */     GIR_EraseRootFromParent_Done,
     /* 1640641 */   // Label 22573: @1640641
     /* 1640641 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1640727), // Rule ID 4469 //
     /* 1640646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640692 */     // MIs[0] policy
     /* 1640692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11613:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1640705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640726 */     // GIR_Coverage, 4469,
     /* 1640726 */     GIR_EraseRootFromParent_Done,
     /* 1640727 */   // Label 22574: @1640727
     /* 1640727 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1640813), // Rule ID 4478 //
     /* 1640732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1640752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640778 */     // MIs[0] policy
     /* 1640778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640788 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1640791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640812 */     // GIR_Coverage, 4478,
     /* 1640812 */     GIR_EraseRootFromParent_Done,
     /* 1640813 */   // Label 22575: @1640813
     /* 1640813 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1640899), // Rule ID 4479 //
     /* 1640818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1640838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640864 */     // MIs[0] policy
     /* 1640864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1640877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640898 */     // GIR_Coverage, 4479,
     /* 1640898 */     GIR_EraseRootFromParent_Done,
     /* 1640899 */   // Label 22576: @1640899
     /* 1640899 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1640985), // Rule ID 4488 //
     /* 1640904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1640915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1640918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1640921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1640924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640950 */     // MIs[0] policy
     /* 1640950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1640963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640984 */     // GIR_Coverage, 4488,
     /* 1640984 */     GIR_EraseRootFromParent_Done,
     /* 1640985 */   // Label 22577: @1640985
     /* 1640985 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1641071), // Rule ID 4489 //
     /* 1640990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1641010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641036 */     // MIs[0] policy
     /* 1641036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641046 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1641049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641070 */     // GIR_Coverage, 4489,
     /* 1641070 */     GIR_EraseRootFromParent_Done,
     /* 1641071 */   // Label 22578: @1641071
     /* 1641071 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1641157), // Rule ID 4498 //
     /* 1641076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1641096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641122 */     // MIs[0] policy
     /* 1641122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1641135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641156 */     // GIR_Coverage, 4498,
     /* 1641156 */     GIR_EraseRootFromParent_Done,
     /* 1641157 */   // Label 22579: @1641157
     /* 1641157 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1641243), // Rule ID 4499 //
     /* 1641162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1641182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641208 */     // MIs[0] policy
     /* 1641208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1641221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641242 */     // GIR_Coverage, 4499,
     /* 1641242 */     GIR_EraseRootFromParent_Done,
     /* 1641243 */   // Label 22580: @1641243
     /* 1641243 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1641329), // Rule ID 4508 //
     /* 1641248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1641268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641294 */     // MIs[0] policy
     /* 1641294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1641307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641328 */     // GIR_Coverage, 4508,
     /* 1641328 */     GIR_EraseRootFromParent_Done,
     /* 1641329 */   // Label 22581: @1641329
     /* 1641329 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1641415), // Rule ID 4509 //
     /* 1641334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1641345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1641354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641380 */     // MIs[0] policy
     /* 1641380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1641393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641414 */     // GIR_Coverage, 4509,
     /* 1641414 */     GIR_EraseRootFromParent_Done,
     /* 1641415 */   // Label 22582: @1641415
     /* 1641415 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1641501), // Rule ID 4518 //
     /* 1641420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1641440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641466 */     // MIs[0] policy
     /* 1641466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1641479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641500 */     // GIR_Coverage, 4518,
     /* 1641500 */     GIR_EraseRootFromParent_Done,
     /* 1641501 */   // Label 22583: @1641501
     /* 1641501 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1641587), // Rule ID 4519 //
     /* 1641506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1641526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641552 */     // MIs[0] policy
     /* 1641552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641562 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1641565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641586 */     // GIR_Coverage, 4519,
     /* 1641586 */     GIR_EraseRootFromParent_Done,
     /* 1641587 */   // Label 22584: @1641587
     /* 1641587 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1641673), // Rule ID 4528 //
     /* 1641592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1641612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641638 */     // MIs[0] policy
     /* 1641638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1641651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641672 */     // GIR_Coverage, 4528,
     /* 1641672 */     GIR_EraseRootFromParent_Done,
     /* 1641673 */   // Label 22585: @1641673
     /* 1641673 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1641759), // Rule ID 4529 //
     /* 1641678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1641698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641724 */     // MIs[0] policy
     /* 1641724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641734 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1641737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641758 */     // GIR_Coverage, 4529,
     /* 1641758 */     GIR_EraseRootFromParent_Done,
     /* 1641759 */   // Label 22586: @1641759
     /* 1641759 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1641845), // Rule ID 4538 //
     /* 1641764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1641784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641810 */     // MIs[0] policy
     /* 1641810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1641823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641844 */     // GIR_Coverage, 4538,
     /* 1641844 */     GIR_EraseRootFromParent_Done,
     /* 1641845 */   // Label 22587: @1641845
     /* 1641845 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1641931), // Rule ID 4539 //
     /* 1641850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1641870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641896 */     // MIs[0] policy
     /* 1641896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1641909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641930 */     // GIR_Coverage, 4539,
     /* 1641930 */     GIR_EraseRootFromParent_Done,
     /* 1641931 */   // Label 22588: @1641931
     /* 1641931 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1642017), // Rule ID 4548 //
     /* 1641936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1641947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1641950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1641953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1641956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641982 */     // MIs[0] policy
     /* 1641982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1641995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642016 */     // GIR_Coverage, 4548,
     /* 1642016 */     GIR_EraseRootFromParent_Done,
     /* 1642017 */   // Label 22589: @1642017
     /* 1642017 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1642103), // Rule ID 4549 //
     /* 1642022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1642042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642068 */     // MIs[0] policy
     /* 1642068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1642081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642102 */     // GIR_Coverage, 4549,
     /* 1642102 */     GIR_EraseRootFromParent_Done,
     /* 1642103 */   // Label 22590: @1642103
     /* 1642103 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1642189), // Rule ID 4558 //
     /* 1642108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1642128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642154 */     // MIs[0] policy
     /* 1642154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1642167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642188 */     // GIR_Coverage, 4558,
     /* 1642188 */     GIR_EraseRootFromParent_Done,
     /* 1642189 */   // Label 22591: @1642189
     /* 1642189 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1642275), // Rule ID 4559 //
     /* 1642194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1642214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642240 */     // MIs[0] policy
     /* 1642240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1642253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642274 */     // GIR_Coverage, 4559,
     /* 1642274 */     GIR_EraseRootFromParent_Done,
     /* 1642275 */   // Label 22592: @1642275
     /* 1642275 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1642361), // Rule ID 4568 //
     /* 1642280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1642300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642326 */     // MIs[0] policy
     /* 1642326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642336 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1642339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642360 */     // GIR_Coverage, 4568,
     /* 1642360 */     GIR_EraseRootFromParent_Done,
     /* 1642361 */   // Label 22593: @1642361
     /* 1642361 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1642447), // Rule ID 4569 //
     /* 1642366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1642386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642412 */     // MIs[0] policy
     /* 1642412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1642425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642446 */     // GIR_Coverage, 4569,
     /* 1642446 */     GIR_EraseRootFromParent_Done,
     /* 1642447 */   // Label 22594: @1642447
     /* 1642447 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1642533), // Rule ID 4578 //
     /* 1642452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1642472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642498 */     // MIs[0] policy
     /* 1642498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1642511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642532 */     // GIR_Coverage, 4578,
     /* 1642532 */     GIR_EraseRootFromParent_Done,
     /* 1642533 */   // Label 22595: @1642533
     /* 1642533 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1642619), // Rule ID 4579 //
     /* 1642538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1642558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642584 */     // MIs[0] policy
     /* 1642584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1642597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642618 */     // GIR_Coverage, 4579,
     /* 1642618 */     GIR_EraseRootFromParent_Done,
     /* 1642619 */   // Label 22596: @1642619
     /* 1642619 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1642705), // Rule ID 4588 //
     /* 1642624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1642644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642670 */     // MIs[0] policy
     /* 1642670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1642683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642704 */     // GIR_Coverage, 4588,
     /* 1642704 */     GIR_EraseRootFromParent_Done,
     /* 1642705 */   // Label 22597: @1642705
     /* 1642705 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1642791), // Rule ID 4589 //
     /* 1642710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1642730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642756 */     // MIs[0] policy
     /* 1642756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1642769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642790 */     // GIR_Coverage, 4589,
     /* 1642790 */     GIR_EraseRootFromParent_Done,
     /* 1642791 */   // Label 22598: @1642791
     /* 1642791 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1642877), // Rule ID 4598 //
     /* 1642796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1642816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642842 */     // MIs[0] policy
     /* 1642842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1642855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642876 */     // GIR_Coverage, 4598,
     /* 1642876 */     GIR_EraseRootFromParent_Done,
     /* 1642877 */   // Label 22599: @1642877
     /* 1642877 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1642963), // Rule ID 4599 //
     /* 1642882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1642902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642928 */     // MIs[0] policy
     /* 1642928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1642941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642962 */     // GIR_Coverage, 4599,
     /* 1642962 */     GIR_EraseRootFromParent_Done,
     /* 1642963 */   // Label 22600: @1642963
     /* 1642963 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1643049), // Rule ID 4608 //
     /* 1642968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1642988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643014 */     // MIs[0] policy
     /* 1643014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643048 */     // GIR_Coverage, 4608,
     /* 1643048 */     GIR_EraseRootFromParent_Done,
     /* 1643049 */   // Label 22601: @1643049
     /* 1643049 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1643135), // Rule ID 4609 //
     /* 1643054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1643074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643100 */     // MIs[0] policy
     /* 1643100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643110 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643134 */     // GIR_Coverage, 4609,
     /* 1643134 */     GIR_EraseRootFromParent_Done,
     /* 1643135 */   // Label 22602: @1643135
     /* 1643135 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1643221), // Rule ID 4618 //
     /* 1643140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1643160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643186 */     // MIs[0] policy
     /* 1643186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643220 */     // GIR_Coverage, 4618,
     /* 1643220 */     GIR_EraseRootFromParent_Done,
     /* 1643221 */   // Label 22603: @1643221
     /* 1643221 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1643307), // Rule ID 4619 //
     /* 1643226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1643246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643272 */     // MIs[0] policy
     /* 1643272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643306 */     // GIR_Coverage, 4619,
     /* 1643306 */     GIR_EraseRootFromParent_Done,
     /* 1643307 */   // Label 22604: @1643307
     /* 1643307 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1643393), // Rule ID 4622 //
     /* 1643312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643358 */     // MIs[0] policy
     /* 1643358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1643371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643392 */     // GIR_Coverage, 4622,
     /* 1643392 */     GIR_EraseRootFromParent_Done,
     /* 1643393 */   // Label 22605: @1643393
     /* 1643393 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1643479), // Rule ID 4623 //
     /* 1643398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643444 */     // MIs[0] policy
     /* 1643444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1643457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643478 */     // GIR_Coverage, 4623,
     /* 1643478 */     GIR_EraseRootFromParent_Done,
     /* 1643479 */   // Label 22606: @1643479
     /* 1643479 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1643565), // Rule ID 4626 //
     /* 1643484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643530 */     // MIs[0] policy
     /* 1643530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1643543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643564 */     // GIR_Coverage, 4626,
     /* 1643564 */     GIR_EraseRootFromParent_Done,
     /* 1643565 */   // Label 22607: @1643565
     /* 1643565 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1643651), // Rule ID 4627 //
     /* 1643570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643616 */     // MIs[0] policy
     /* 1643616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1643629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643650 */     // GIR_Coverage, 4627,
     /* 1643650 */     GIR_EraseRootFromParent_Done,
     /* 1643651 */   // Label 22608: @1643651
     /* 1643651 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1643737), // Rule ID 4630 //
     /* 1643656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643702 */     // MIs[0] policy
     /* 1643702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1643715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643736 */     // GIR_Coverage, 4630,
     /* 1643736 */     GIR_EraseRootFromParent_Done,
     /* 1643737 */   // Label 22609: @1643737
     /* 1643737 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1643823), // Rule ID 4631 //
     /* 1643742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643788 */     // MIs[0] policy
     /* 1643788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1643801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643822 */     // GIR_Coverage, 4631,
     /* 1643822 */     GIR_EraseRootFromParent_Done,
     /* 1643823 */   // Label 22610: @1643823
     /* 1643823 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1643909), // Rule ID 4634 //
     /* 1643828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1643848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643874 */     // MIs[0] policy
     /* 1643874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1643887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643908 */     // GIR_Coverage, 4634,
     /* 1643908 */     GIR_EraseRootFromParent_Done,
     /* 1643909 */   // Label 22611: @1643909
     /* 1643909 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1643995), // Rule ID 4635 //
     /* 1643914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1643934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1643956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643960 */     // MIs[0] policy
     /* 1643960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1643973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643994 */     // GIR_Coverage, 4635,
     /* 1643994 */     GIR_EraseRootFromParent_Done,
     /* 1643995 */   // Label 22612: @1643995
     /* 1643995 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1644081), // Rule ID 4638 //
     /* 1644000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644046 */     // MIs[0] policy
     /* 1644046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1644059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644080 */     // GIR_Coverage, 4638,
     /* 1644080 */     GIR_EraseRootFromParent_Done,
     /* 1644081 */   // Label 22613: @1644081
     /* 1644081 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1644167), // Rule ID 4639 //
     /* 1644086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644132 */     // MIs[0] policy
     /* 1644132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1644145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644166 */     // GIR_Coverage, 4639,
     /* 1644166 */     GIR_EraseRootFromParent_Done,
     /* 1644167 */   // Label 22614: @1644167
     /* 1644167 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1644253), // Rule ID 4642 //
     /* 1644172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644218 */     // MIs[0] policy
     /* 1644218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1644231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644252 */     // GIR_Coverage, 4642,
     /* 1644252 */     GIR_EraseRootFromParent_Done,
     /* 1644253 */   // Label 22615: @1644253
     /* 1644253 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1644339), // Rule ID 4643 //
     /* 1644258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1644281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644304 */     // MIs[0] policy
     /* 1644304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644314 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1644317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644338 */     // GIR_Coverage, 4643,
     /* 1644338 */     GIR_EraseRootFromParent_Done,
     /* 1644339 */   // Label 22616: @1644339
     /* 1644339 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1644425), // Rule ID 4646 //
     /* 1644344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644390 */     // MIs[0] policy
     /* 1644390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1644403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644424 */     // GIR_Coverage, 4646,
     /* 1644424 */     GIR_EraseRootFromParent_Done,
     /* 1644425 */   // Label 22617: @1644425
     /* 1644425 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1644511), // Rule ID 4647 //
     /* 1644430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644476 */     // MIs[0] policy
     /* 1644476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1644489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644510 */     // GIR_Coverage, 4647,
     /* 1644510 */     GIR_EraseRootFromParent_Done,
     /* 1644511 */   // Label 22618: @1644511
     /* 1644511 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1644597), // Rule ID 4650 //
     /* 1644516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644562 */     // MIs[0] policy
     /* 1644562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1644575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644596 */     // GIR_Coverage, 4650,
     /* 1644596 */     GIR_EraseRootFromParent_Done,
     /* 1644597 */   // Label 22619: @1644597
     /* 1644597 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1644683), // Rule ID 4651 //
     /* 1644602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644648 */     // MIs[0] policy
     /* 1644648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1644661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644682 */     // GIR_Coverage, 4651,
     /* 1644682 */     GIR_EraseRootFromParent_Done,
     /* 1644683 */   // Label 22620: @1644683
     /* 1644683 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1644769), // Rule ID 4654 //
     /* 1644688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644734 */     // MIs[0] policy
     /* 1644734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1644747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644768 */     // GIR_Coverage, 4654,
     /* 1644768 */     GIR_EraseRootFromParent_Done,
     /* 1644769 */   // Label 22621: @1644769
     /* 1644769 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1644855), // Rule ID 4655 //
     /* 1644774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644820 */     // MIs[0] policy
     /* 1644820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1644833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644854 */     // GIR_Coverage, 4655,
     /* 1644854 */     GIR_EraseRootFromParent_Done,
     /* 1644855 */   // Label 22622: @1644855
     /* 1644855 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1644941), // Rule ID 4658 //
     /* 1644860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644906 */     // MIs[0] policy
     /* 1644906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1644919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644940 */     // GIR_Coverage, 4658,
     /* 1644940 */     GIR_EraseRootFromParent_Done,
     /* 1644941 */   // Label 22623: @1644941
     /* 1644941 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1645027), // Rule ID 4659 //
     /* 1644946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644992 */     // MIs[0] policy
     /* 1644992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1645005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645026 */     // GIR_Coverage, 4659,
     /* 1645026 */     GIR_EraseRootFromParent_Done,
     /* 1645027 */   // Label 22624: @1645027
     /* 1645027 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1645113), // Rule ID 4662 //
     /* 1645032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645078 */     // MIs[0] policy
     /* 1645078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1645091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645112 */     // GIR_Coverage, 4662,
     /* 1645112 */     GIR_EraseRootFromParent_Done,
     /* 1645113 */   // Label 22625: @1645113
     /* 1645113 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1645199), // Rule ID 4663 //
     /* 1645118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645164 */     // MIs[0] policy
     /* 1645164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1645177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645198 */     // GIR_Coverage, 4663,
     /* 1645198 */     GIR_EraseRootFromParent_Done,
     /* 1645199 */   // Label 22626: @1645199
     /* 1645199 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1645285), // Rule ID 4666 //
     /* 1645204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645250 */     // MIs[0] policy
     /* 1645250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1645263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645284 */     // GIR_Coverage, 4666,
     /* 1645284 */     GIR_EraseRootFromParent_Done,
     /* 1645285 */   // Label 22627: @1645285
     /* 1645285 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1645371), // Rule ID 4667 //
     /* 1645290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1645301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1645304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1645307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645336 */     // MIs[0] policy
     /* 1645336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645346 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1645349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645370 */     // GIR_Coverage, 4667,
     /* 1645370 */     GIR_EraseRootFromParent_Done,
     /* 1645371 */   // Label 22628: @1645371
     /* 1645371 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1645457), // Rule ID 4670 //
     /* 1645376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645422 */     // MIs[0] policy
     /* 1645422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1645435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645456 */     // GIR_Coverage, 4670,
     /* 1645456 */     GIR_EraseRootFromParent_Done,
     /* 1645457 */   // Label 22629: @1645457
     /* 1645457 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1645543), // Rule ID 4671 //
     /* 1645462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645508 */     // MIs[0] policy
     /* 1645508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1645521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645542 */     // GIR_Coverage, 4671,
     /* 1645542 */     GIR_EraseRootFromParent_Done,
     /* 1645543 */   // Label 22630: @1645543
     /* 1645543 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1645629), // Rule ID 4674 //
     /* 1645548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645594 */     // MIs[0] policy
     /* 1645594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1645607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645628 */     // GIR_Coverage, 4674,
     /* 1645628 */     GIR_EraseRootFromParent_Done,
     /* 1645629 */   // Label 22631: @1645629
     /* 1645629 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1645715), // Rule ID 4675 //
     /* 1645634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645680 */     // MIs[0] policy
     /* 1645680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1645693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645714 */     // GIR_Coverage, 4675,
     /* 1645714 */     GIR_EraseRootFromParent_Done,
     /* 1645715 */   // Label 22632: @1645715
     /* 1645715 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1645801), // Rule ID 4678 //
     /* 1645720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645766 */     // MIs[0] policy
     /* 1645766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1645779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645800 */     // GIR_Coverage, 4678,
     /* 1645800 */     GIR_EraseRootFromParent_Done,
     /* 1645801 */   // Label 22633: @1645801
     /* 1645801 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1645887), // Rule ID 4679 //
     /* 1645806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645852 */     // MIs[0] policy
     /* 1645852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1645865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645886 */     // GIR_Coverage, 4679,
     /* 1645886 */     GIR_EraseRootFromParent_Done,
     /* 1645887 */   // Label 22634: @1645887
     /* 1645887 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1645973), // Rule ID 4688 //
     /* 1645892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1645912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645938 */     // MIs[0] policy
     /* 1645938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1645951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645972 */     // GIR_Coverage, 4688,
     /* 1645972 */     GIR_EraseRootFromParent_Done,
     /* 1645973 */   // Label 22635: @1645973
     /* 1645973 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1646059), // Rule ID 4689 //
     /* 1645978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1645998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646024 */     // MIs[0] policy
     /* 1646024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1646037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646058 */     // GIR_Coverage, 4689,
     /* 1646058 */     GIR_EraseRootFromParent_Done,
     /* 1646059 */   // Label 22636: @1646059
     /* 1646059 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1646145), // Rule ID 4698 //
     /* 1646064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646110 */     // MIs[0] policy
     /* 1646110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1646123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646144 */     // GIR_Coverage, 4698,
     /* 1646144 */     GIR_EraseRootFromParent_Done,
     /* 1646145 */   // Label 22637: @1646145
     /* 1646145 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1646231), // Rule ID 4699 //
     /* 1646150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1646161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1646164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1646167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646196 */     // MIs[0] policy
     /* 1646196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1646209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646230 */     // GIR_Coverage, 4699,
     /* 1646230 */     GIR_EraseRootFromParent_Done,
     /* 1646231 */   // Label 22638: @1646231
     /* 1646231 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1646317), // Rule ID 4708 //
     /* 1646236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1646256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646282 */     // MIs[0] policy
     /* 1646282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1646295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646316 */     // GIR_Coverage, 4708,
     /* 1646316 */     GIR_EraseRootFromParent_Done,
     /* 1646317 */   // Label 22639: @1646317
     /* 1646317 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1646403), // Rule ID 4709 //
     /* 1646322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1646333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1646336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1646339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1646342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646368 */     // MIs[0] policy
     /* 1646368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1646381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646402 */     // GIR_Coverage, 4709,
     /* 1646402 */     GIR_EraseRootFromParent_Done,
     /* 1646403 */   // Label 22640: @1646403
     /* 1646403 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1646489), // Rule ID 4718 //
     /* 1646408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1646428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646454 */     // MIs[0] policy
     /* 1646454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1646467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646488 */     // GIR_Coverage, 4718,
     /* 1646488 */     GIR_EraseRootFromParent_Done,
     /* 1646489 */   // Label 22641: @1646489
     /* 1646489 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1646575), // Rule ID 4719 //
     /* 1646494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1646514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646540 */     // MIs[0] policy
     /* 1646540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1646553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646574 */     // GIR_Coverage, 4719,
     /* 1646574 */     GIR_EraseRootFromParent_Done,
     /* 1646575 */   // Label 22642: @1646575
     /* 1646575 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1646661), // Rule ID 4728 //
     /* 1646580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1646600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646626 */     // MIs[0] policy
     /* 1646626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1646639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646660 */     // GIR_Coverage, 4728,
     /* 1646660 */     GIR_EraseRootFromParent_Done,
     /* 1646661 */   // Label 22643: @1646661
     /* 1646661 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1646747), // Rule ID 4729 //
     /* 1646666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1646686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646712 */     // MIs[0] policy
     /* 1646712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1646725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646746 */     // GIR_Coverage, 4729,
     /* 1646746 */     GIR_EraseRootFromParent_Done,
     /* 1646747 */   // Label 22644: @1646747
     /* 1646747 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1646833), // Rule ID 4738 //
     /* 1646752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1646772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646798 */     // MIs[0] policy
     /* 1646798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646808 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1646811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646832 */     // GIR_Coverage, 4738,
     /* 1646832 */     GIR_EraseRootFromParent_Done,
     /* 1646833 */   // Label 22645: @1646833
     /* 1646833 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1646919), // Rule ID 4739 //
     /* 1646838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1646858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646884 */     // MIs[0] policy
     /* 1646884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1646897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646918 */     // GIR_Coverage, 4739,
     /* 1646918 */     GIR_EraseRootFromParent_Done,
     /* 1646919 */   // Label 22646: @1646919
     /* 1646919 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1647005), // Rule ID 4748 //
     /* 1646924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1646935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1646938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1646941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1646944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646970 */     // MIs[0] policy
     /* 1646970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1646983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647004 */     // GIR_Coverage, 4748,
     /* 1647004 */     GIR_EraseRootFromParent_Done,
     /* 1647005 */   // Label 22647: @1647005
     /* 1647005 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1647091), // Rule ID 4749 //
     /* 1647010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647056 */     // MIs[0] policy
     /* 1647056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1647069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647090 */     // GIR_Coverage, 4749,
     /* 1647090 */     GIR_EraseRootFromParent_Done,
     /* 1647091 */   // Label 22648: @1647091
     /* 1647091 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1647177), // Rule ID 4758 //
     /* 1647096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647142 */     // MIs[0] policy
     /* 1647142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1647155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647176 */     // GIR_Coverage, 4758,
     /* 1647176 */     GIR_EraseRootFromParent_Done,
     /* 1647177 */   // Label 22649: @1647177
     /* 1647177 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1647263), // Rule ID 4759 //
     /* 1647182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1647193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1647196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1647199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647228 */     // MIs[0] policy
     /* 1647228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1647241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647262 */     // GIR_Coverage, 4759,
     /* 1647262 */     GIR_EraseRootFromParent_Done,
     /* 1647263 */   // Label 22650: @1647263
     /* 1647263 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1647349), // Rule ID 4768 //
     /* 1647268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1647288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647314 */     // MIs[0] policy
     /* 1647314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1647327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647348 */     // GIR_Coverage, 4768,
     /* 1647348 */     GIR_EraseRootFromParent_Done,
     /* 1647349 */   // Label 22651: @1647349
     /* 1647349 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1647435), // Rule ID 4769 //
     /* 1647354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1647374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647400 */     // MIs[0] policy
     /* 1647400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1647413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647434 */     // GIR_Coverage, 4769,
     /* 1647434 */     GIR_EraseRootFromParent_Done,
     /* 1647435 */   // Label 22652: @1647435
     /* 1647435 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1647521), // Rule ID 4778 //
     /* 1647440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1647460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647486 */     // MIs[0] policy
     /* 1647486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1647499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647520 */     // GIR_Coverage, 4778,
     /* 1647520 */     GIR_EraseRootFromParent_Done,
     /* 1647521 */   // Label 22653: @1647521
     /* 1647521 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1647607), // Rule ID 4779 //
     /* 1647526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1647546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647572 */     // MIs[0] policy
     /* 1647572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1647585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647606 */     // GIR_Coverage, 4779,
     /* 1647606 */     GIR_EraseRootFromParent_Done,
     /* 1647607 */   // Label 22654: @1647607
     /* 1647607 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1647693), // Rule ID 4788 //
     /* 1647612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1647632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647658 */     // MIs[0] policy
     /* 1647658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1647671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647692 */     // GIR_Coverage, 4788,
     /* 1647692 */     GIR_EraseRootFromParent_Done,
     /* 1647693 */   // Label 22655: @1647693
     /* 1647693 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1647779), // Rule ID 4789 //
     /* 1647698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1647718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647744 */     // MIs[0] policy
     /* 1647744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1647757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647778 */     // GIR_Coverage, 4789,
     /* 1647778 */     GIR_EraseRootFromParent_Done,
     /* 1647779 */   // Label 22656: @1647779
     /* 1647779 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1647865), // Rule ID 4798 //
     /* 1647784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647830 */     // MIs[0] policy
     /* 1647830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1647843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647864 */     // GIR_Coverage, 4798,
     /* 1647864 */     GIR_EraseRootFromParent_Done,
     /* 1647865 */   // Label 22657: @1647865
     /* 1647865 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1647951), // Rule ID 4799 //
     /* 1647870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647916 */     // MIs[0] policy
     /* 1647916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1647929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647950 */     // GIR_Coverage, 4799,
     /* 1647950 */     GIR_EraseRootFromParent_Done,
     /* 1647951 */   // Label 22658: @1647951
     /* 1647951 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1648037), // Rule ID 4808 //
     /* 1647956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1647964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1647967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1647970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1647973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1647976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648002 */     // MIs[0] policy
     /* 1648002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648036 */     // GIR_Coverage, 4808,
     /* 1648036 */     GIR_EraseRootFromParent_Done,
     /* 1648037 */   // Label 22659: @1648037
     /* 1648037 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1648123), // Rule ID 4809 //
     /* 1648042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1648053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1648056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1648059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1648062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648088 */     // MIs[0] policy
     /* 1648088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648122 */     // GIR_Coverage, 4809,
     /* 1648122 */     GIR_EraseRootFromParent_Done,
     /* 1648123 */   // Label 22660: @1648123
     /* 1648123 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1648209), // Rule ID 4818 //
     /* 1648128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1648148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648174 */     // MIs[0] policy
     /* 1648174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648208 */     // GIR_Coverage, 4818,
     /* 1648208 */     GIR_EraseRootFromParent_Done,
     /* 1648209 */   // Label 22661: @1648209
     /* 1648209 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1648295), // Rule ID 4819 //
     /* 1648214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1648225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1648228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1648231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1648234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648260 */     // MIs[0] policy
     /* 1648260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648294 */     // GIR_Coverage, 4819,
     /* 1648294 */     GIR_EraseRootFromParent_Done,
     /* 1648295 */   // Label 22662: @1648295
     /* 1648295 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1648381), // Rule ID 4828 //
     /* 1648300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1648303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1648320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648346 */     // MIs[0] policy
     /* 1648346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648356 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1648359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648380 */     // GIR_Coverage, 4828,
     /* 1648380 */     GIR_EraseRootFromParent_Done,
     /* 1648381 */   // Label 22663: @1648381
     /* 1648381 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1648467), // Rule ID 4829 //
     /* 1648386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1648406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648432 */     // MIs[0] policy
     /* 1648432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1648445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648466 */     // GIR_Coverage, 4829,
     /* 1648466 */     GIR_EraseRootFromParent_Done,
     /* 1648467 */   // Label 22664: @1648467
     /* 1648467 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1648553), // Rule ID 4832 //
     /* 1648472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648518 */     // MIs[0] policy
     /* 1648518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1648531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648552 */     // GIR_Coverage, 4832,
     /* 1648552 */     GIR_EraseRootFromParent_Done,
     /* 1648553 */   // Label 22665: @1648553
     /* 1648553 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1648639), // Rule ID 4833 //
     /* 1648558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648604 */     // MIs[0] policy
     /* 1648604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1648617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648638 */     // GIR_Coverage, 4833,
     /* 1648638 */     GIR_EraseRootFromParent_Done,
     /* 1648639 */   // Label 22666: @1648639
     /* 1648639 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1648725), // Rule ID 4836 //
     /* 1648644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648690 */     // MIs[0] policy
     /* 1648690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1648703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648724 */     // GIR_Coverage, 4836,
     /* 1648724 */     GIR_EraseRootFromParent_Done,
     /* 1648725 */   // Label 22667: @1648725
     /* 1648725 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1648811), // Rule ID 4837 //
     /* 1648730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648776 */     // MIs[0] policy
     /* 1648776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1648789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648810 */     // GIR_Coverage, 4837,
     /* 1648810 */     GIR_EraseRootFromParent_Done,
     /* 1648811 */   // Label 22668: @1648811
     /* 1648811 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1648897), // Rule ID 4840 //
     /* 1648816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1648836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648862 */     // MIs[0] policy
     /* 1648862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1648875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648896 */     // GIR_Coverage, 4840,
     /* 1648896 */     GIR_EraseRootFromParent_Done,
     /* 1648897 */   // Label 22669: @1648897
     /* 1648897 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1648983), // Rule ID 4841 //
     /* 1648902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648948 */     // MIs[0] policy
     /* 1648948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1648961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648982 */     // GIR_Coverage, 4841,
     /* 1648982 */     GIR_EraseRootFromParent_Done,
     /* 1648983 */   // Label 22670: @1648983
     /* 1648983 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1649069), // Rule ID 4844 //
     /* 1648988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649034 */     // MIs[0] policy
     /* 1649034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1649047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649068 */     // GIR_Coverage, 4844,
     /* 1649068 */     GIR_EraseRootFromParent_Done,
     /* 1649069 */   // Label 22671: @1649069
     /* 1649069 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1649155), // Rule ID 4845 //
     /* 1649074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649120 */     // MIs[0] policy
     /* 1649120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1649133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649154 */     // GIR_Coverage, 4845,
     /* 1649154 */     GIR_EraseRootFromParent_Done,
     /* 1649155 */   // Label 22672: @1649155
     /* 1649155 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1649241), // Rule ID 4848 //
     /* 1649160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649206 */     // MIs[0] policy
     /* 1649206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1649219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649240 */     // GIR_Coverage, 4848,
     /* 1649240 */     GIR_EraseRootFromParent_Done,
     /* 1649241 */   // Label 22673: @1649241
     /* 1649241 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1649327), // Rule ID 4849 //
     /* 1649246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649292 */     // MIs[0] policy
     /* 1649292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1649305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649326 */     // GIR_Coverage, 4849,
     /* 1649326 */     GIR_EraseRootFromParent_Done,
     /* 1649327 */   // Label 22674: @1649327
     /* 1649327 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1649413), // Rule ID 4852 //
     /* 1649332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649378 */     // MIs[0] policy
     /* 1649378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1649391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649412 */     // GIR_Coverage, 4852,
     /* 1649412 */     GIR_EraseRootFromParent_Done,
     /* 1649413 */   // Label 22675: @1649413
     /* 1649413 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1649499), // Rule ID 4853 //
     /* 1649418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649464 */     // MIs[0] policy
     /* 1649464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1649477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649498 */     // GIR_Coverage, 4853,
     /* 1649498 */     GIR_EraseRootFromParent_Done,
     /* 1649499 */   // Label 22676: @1649499
     /* 1649499 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1649585), // Rule ID 4856 //
     /* 1649504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649550 */     // MIs[0] policy
     /* 1649550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1649563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649584 */     // GIR_Coverage, 4856,
     /* 1649584 */     GIR_EraseRootFromParent_Done,
     /* 1649585 */   // Label 22677: @1649585
     /* 1649585 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1649671), // Rule ID 4857 //
     /* 1649590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649636 */     // MIs[0] policy
     /* 1649636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1649649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649670 */     // GIR_Coverage, 4857,
     /* 1649670 */     GIR_EraseRootFromParent_Done,
     /* 1649671 */   // Label 22678: @1649671
     /* 1649671 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1649757), // Rule ID 4860 //
     /* 1649676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649722 */     // MIs[0] policy
     /* 1649722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1649735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649756 */     // GIR_Coverage, 4860,
     /* 1649756 */     GIR_EraseRootFromParent_Done,
     /* 1649757 */   // Label 22679: @1649757
     /* 1649757 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1649843), // Rule ID 4861 //
     /* 1649762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649808 */     // MIs[0] policy
     /* 1649808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1649821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649842 */     // GIR_Coverage, 4861,
     /* 1649842 */     GIR_EraseRootFromParent_Done,
     /* 1649843 */   // Label 22680: @1649843
     /* 1649843 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1649929), // Rule ID 4864 //
     /* 1649848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1649868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649894 */     // MIs[0] policy
     /* 1649894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1649907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649928 */     // GIR_Coverage, 4864,
     /* 1649928 */     GIR_EraseRootFromParent_Done,
     /* 1649929 */   // Label 22681: @1649929
     /* 1649929 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1650015), // Rule ID 4865 //
     /* 1649934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1649954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1649976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649980 */     // MIs[0] policy
     /* 1649980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1649993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650014 */     // GIR_Coverage, 4865,
     /* 1650014 */     GIR_EraseRootFromParent_Done,
     /* 1650015 */   // Label 22682: @1650015
     /* 1650015 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1650101), // Rule ID 4868 //
     /* 1650020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650066 */     // MIs[0] policy
     /* 1650066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1650079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650100 */     // GIR_Coverage, 4868,
     /* 1650100 */     GIR_EraseRootFromParent_Done,
     /* 1650101 */   // Label 22683: @1650101
     /* 1650101 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1650187), // Rule ID 4869 //
     /* 1650106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1650117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1650120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1650123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650152 */     // MIs[0] policy
     /* 1650152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1650165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650186 */     // GIR_Coverage, 4869,
     /* 1650186 */     GIR_EraseRootFromParent_Done,
     /* 1650187 */   // Label 22684: @1650187
     /* 1650187 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1650273), // Rule ID 4872 //
     /* 1650192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650238 */     // MIs[0] policy
     /* 1650238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1650251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650272 */     // GIR_Coverage, 4872,
     /* 1650272 */     GIR_EraseRootFromParent_Done,
     /* 1650273 */   // Label 22685: @1650273
     /* 1650273 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1650359), // Rule ID 4873 //
     /* 1650278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1650289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1650292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1650295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1650301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650324 */     // MIs[0] policy
     /* 1650324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1650337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650358 */     // GIR_Coverage, 4873,
     /* 1650358 */     GIR_EraseRootFromParent_Done,
     /* 1650359 */   // Label 22686: @1650359
     /* 1650359 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1650445), // Rule ID 4876 //
     /* 1650364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650410 */     // MIs[0] policy
     /* 1650410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1650423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650444 */     // GIR_Coverage, 4876,
     /* 1650444 */     GIR_EraseRootFromParent_Done,
     /* 1650445 */   // Label 22687: @1650445
     /* 1650445 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1650531), // Rule ID 4877 //
     /* 1650450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650496 */     // MIs[0] policy
     /* 1650496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1650509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650530 */     // GIR_Coverage, 4877,
     /* 1650530 */     GIR_EraseRootFromParent_Done,
     /* 1650531 */   // Label 22688: @1650531
     /* 1650531 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1650617), // Rule ID 4880 //
     /* 1650536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650582 */     // MIs[0] policy
     /* 1650582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1650595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650616 */     // GIR_Coverage, 4880,
     /* 1650616 */     GIR_EraseRootFromParent_Done,
     /* 1650617 */   // Label 22689: @1650617
     /* 1650617 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1650703), // Rule ID 4881 //
     /* 1650622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650668 */     // MIs[0] policy
     /* 1650668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1650681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650702 */     // GIR_Coverage, 4881,
     /* 1650702 */     GIR_EraseRootFromParent_Done,
     /* 1650703 */   // Label 22690: @1650703
     /* 1650703 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1650789), // Rule ID 4884 //
     /* 1650708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650754 */     // MIs[0] policy
     /* 1650754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1650767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650788 */     // GIR_Coverage, 4884,
     /* 1650788 */     GIR_EraseRootFromParent_Done,
     /* 1650789 */   // Label 22691: @1650789
     /* 1650789 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1650875), // Rule ID 4885 //
     /* 1650794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650840 */     // MIs[0] policy
     /* 1650840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1650853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650874 */     // GIR_Coverage, 4885,
     /* 1650874 */     GIR_EraseRootFromParent_Done,
     /* 1650875 */   // Label 22692: @1650875
     /* 1650875 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1650961), // Rule ID 4888 //
     /* 1650880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650926 */     // MIs[0] policy
     /* 1650926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1650939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650960 */     // GIR_Coverage, 4888,
     /* 1650960 */     GIR_EraseRootFromParent_Done,
     /* 1650961 */   // Label 22693: @1650961
     /* 1650961 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1651047), // Rule ID 4889 //
     /* 1650966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651012 */     // MIs[0] policy
     /* 1651012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1651025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651046 */     // GIR_Coverage, 4889,
     /* 1651046 */     GIR_EraseRootFromParent_Done,
     /* 1651047 */   // Label 22694: @1651047
     /* 1651047 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1651133), // Rule ID 5766 //
     /* 1651052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1651063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1651066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1651069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1651072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651098 */     // MIs[0] policy
     /* 1651098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651108 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1651111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651132 */     // GIR_Coverage, 5766,
     /* 1651132 */     GIR_EraseRootFromParent_Done,
     /* 1651133 */   // Label 22695: @1651133
     /* 1651133 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1651219), // Rule ID 5767 //
     /* 1651138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1651149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1651152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1651155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1651158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651184 */     // MIs[0] policy
     /* 1651184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651194 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1651197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651218 */     // GIR_Coverage, 5767,
     /* 1651218 */     GIR_EraseRootFromParent_Done,
     /* 1651219 */   // Label 22696: @1651219
     /* 1651219 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1651305), // Rule ID 5770 //
     /* 1651224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1651235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1651238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1651241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1651244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651270 */     // MIs[0] policy
     /* 1651270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1651283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651304 */     // GIR_Coverage, 5770,
     /* 1651304 */     GIR_EraseRootFromParent_Done,
     /* 1651305 */   // Label 22697: @1651305
     /* 1651305 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1651391), // Rule ID 5771 //
     /* 1651310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1651321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1651324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1651327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1651330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651356 */     // MIs[0] policy
     /* 1651356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1651369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651390 */     // GIR_Coverage, 5771,
     /* 1651390 */     GIR_EraseRootFromParent_Done,
     /* 1651391 */   // Label 22698: @1651391
     /* 1651391 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1651477), // Rule ID 5774 //
     /* 1651396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1651407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1651410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1651413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1651416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651442 */     // MIs[0] policy
     /* 1651442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1651455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651476 */     // GIR_Coverage, 5774,
     /* 1651476 */     GIR_EraseRootFromParent_Done,
     /* 1651477 */   // Label 22699: @1651477
     /* 1651477 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1651563), // Rule ID 5775 //
     /* 1651482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1651493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1651496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1651499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1651502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651528 */     // MIs[0] policy
     /* 1651528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1651541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651562 */     // GIR_Coverage, 5775,
     /* 1651562 */     GIR_EraseRootFromParent_Done,
     /* 1651563 */   // Label 22700: @1651563
     /* 1651563 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1651649), // Rule ID 5778 //
     /* 1651568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1651588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651614 */     // MIs[0] policy
     /* 1651614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1651627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651648 */     // GIR_Coverage, 5778,
     /* 1651648 */     GIR_EraseRootFromParent_Done,
     /* 1651649 */   // Label 22701: @1651649
     /* 1651649 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1651735), // Rule ID 5779 //
     /* 1651654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1651674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651700 */     // MIs[0] policy
     /* 1651700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1651713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651734 */     // GIR_Coverage, 5779,
     /* 1651734 */     GIR_EraseRootFromParent_Done,
     /* 1651735 */   // Label 22702: @1651735
     /* 1651735 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1651821), // Rule ID 5782 //
     /* 1651740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1651760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651786 */     // MIs[0] policy
     /* 1651786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1651799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651820 */     // GIR_Coverage, 5782,
     /* 1651820 */     GIR_EraseRootFromParent_Done,
     /* 1651821 */   // Label 22703: @1651821
     /* 1651821 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1651907), // Rule ID 5783 //
     /* 1651826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1651846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651872 */     // MIs[0] policy
     /* 1651872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1651885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651906 */     // GIR_Coverage, 5783,
     /* 1651906 */     GIR_EraseRootFromParent_Done,
     /* 1651907 */   // Label 22704: @1651907
     /* 1651907 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1651993), // Rule ID 5786 //
     /* 1651912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1651932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651958 */     // MIs[0] policy
     /* 1651958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1651971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651992 */     // GIR_Coverage, 5786,
     /* 1651992 */     GIR_EraseRootFromParent_Done,
     /* 1651993 */   // Label 22705: @1651993
     /* 1651993 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1652079), // Rule ID 5787 //
     /* 1651998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1652009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1652012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1652015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1652018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652044 */     // MIs[0] policy
     /* 1652044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1652057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652078 */     // GIR_Coverage, 5787,
     /* 1652078 */     GIR_EraseRootFromParent_Done,
     /* 1652079 */   // Label 22706: @1652079
     /* 1652079 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1652165), // Rule ID 5790 //
     /* 1652084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1652095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1652098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1652101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1652104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652130 */     // MIs[0] policy
     /* 1652130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652164 */     // GIR_Coverage, 5790,
     /* 1652164 */     GIR_EraseRootFromParent_Done,
     /* 1652165 */   // Label 22707: @1652165
     /* 1652165 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1652251), // Rule ID 5791 //
     /* 1652170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1652181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1652184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1652187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1652190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652216 */     // MIs[0] policy
     /* 1652216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652250 */     // GIR_Coverage, 5791,
     /* 1652250 */     GIR_EraseRootFromParent_Done,
     /* 1652251 */   // Label 22708: @1652251
     /* 1652251 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1652337), // Rule ID 5794 //
     /* 1652256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1652267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1652270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1652273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1652276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652302 */     // MIs[0] policy
     /* 1652302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652336 */     // GIR_Coverage, 5794,
     /* 1652336 */     GIR_EraseRootFromParent_Done,
     /* 1652337 */   // Label 22709: @1652337
     /* 1652337 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1652423), // Rule ID 5795 //
     /* 1652342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1652353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1652356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1652359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1652362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652388 */     // MIs[0] policy
     /* 1652388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652422 */     // GIR_Coverage, 5795,
     /* 1652422 */     GIR_EraseRootFromParent_Done,
     /* 1652423 */   // Label 22710: @1652423
     /* 1652423 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1652509), // Rule ID 5798 //
     /* 1652428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1652448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652474 */     // MIs[0] policy
     /* 1652474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652508 */     // GIR_Coverage, 5798,
     /* 1652508 */     GIR_EraseRootFromParent_Done,
     /* 1652509 */   // Label 22711: @1652509
     /* 1652509 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1652595), // Rule ID 5799 //
     /* 1652514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1652534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652560 */     // MIs[0] policy
     /* 1652560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652594 */     // GIR_Coverage, 5799,
     /* 1652594 */     GIR_EraseRootFromParent_Done,
     /* 1652595 */   // Label 22712: @1652595
     /* 1652595 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1652681), // Rule ID 5802 //
     /* 1652600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1652603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1652620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652646 */     // MIs[0] policy
     /* 1652646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652656 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1652677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652680 */     // GIR_Coverage, 5802,
     /* 1652680 */     GIR_EraseRootFromParent_Done,
     /* 1652681 */   // Label 22713: @1652681
     /* 1652681 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1652767), // Rule ID 5803 //
     /* 1652686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1652689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1652706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652732 */     // MIs[0] policy
     /* 1652732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1652745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1652763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652766 */     // GIR_Coverage, 5803,
     /* 1652766 */     GIR_EraseRootFromParent_Done,
     /* 1652767 */   // Label 22714: @1652767
     /* 1652767 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1652853), // Rule ID 5806 //
     /* 1652772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1652783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1652786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1652789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1652792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652818 */     // MIs[0] policy
     /* 1652818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1652831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652852 */     // GIR_Coverage, 5806,
     /* 1652852 */     GIR_EraseRootFromParent_Done,
     /* 1652853 */   // Label 22715: @1652853
     /* 1652853 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1652939), // Rule ID 5807 //
     /* 1652858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1652869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1652872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1652875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1652878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652904 */     // MIs[0] policy
     /* 1652904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1652917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652938 */     // GIR_Coverage, 5807,
     /* 1652938 */     GIR_EraseRootFromParent_Done,
     /* 1652939 */   // Label 22716: @1652939
     /* 1652939 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1653025), // Rule ID 5810 //
     /* 1652944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1652955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1652958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1652961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1652964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652990 */     // MIs[0] policy
     /* 1652990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1653003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653024 */     // GIR_Coverage, 5810,
     /* 1653024 */     GIR_EraseRootFromParent_Done,
     /* 1653025 */   // Label 22717: @1653025
     /* 1653025 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1653111), // Rule ID 5811 //
     /* 1653030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1653041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1653044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1653047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1653050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1653053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653076 */     // MIs[0] policy
     /* 1653076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1653089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653110 */     // GIR_Coverage, 5811,
     /* 1653110 */     GIR_EraseRootFromParent_Done,
     /* 1653111 */   // Label 22718: @1653111
     /* 1653111 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1653197), // Rule ID 5814 //
     /* 1653116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1653127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1653130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1653133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1653136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1653139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653162 */     // MIs[0] policy
     /* 1653162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1653175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653196 */     // GIR_Coverage, 5814,
     /* 1653196 */     GIR_EraseRootFromParent_Done,
     /* 1653197 */   // Label 22719: @1653197
     /* 1653197 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1653283), // Rule ID 5815 //
     /* 1653202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1653213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1653216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1653219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1653222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1653225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653248 */     // MIs[0] policy
     /* 1653248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1653261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653282 */     // GIR_Coverage, 5815,
     /* 1653282 */     GIR_EraseRootFromParent_Done,
     /* 1653283 */   // Label 22720: @1653283
     /* 1653283 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1653369), // Rule ID 5818 //
     /* 1653288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1653299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1653302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1653305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1653308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653334 */     // MIs[0] policy
     /* 1653334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1653347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653368 */     // GIR_Coverage, 5818,
     /* 1653368 */     GIR_EraseRootFromParent_Done,
     /* 1653369 */   // Label 22721: @1653369
     /* 1653369 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1653455), // Rule ID 5819 //
     /* 1653374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1653385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1653388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1653391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1653394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653420 */     // MIs[0] policy
     /* 1653420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1653433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653454 */     // GIR_Coverage, 5819,
     /* 1653454 */     GIR_EraseRootFromParent_Done,
     /* 1653455 */   // Label 22722: @1653455
     /* 1653455 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1653541), // Rule ID 5822 //
     /* 1653460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1653471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1653474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1653477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1653480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653506 */     // MIs[0] policy
     /* 1653506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1653519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653540 */     // GIR_Coverage, 5822,
     /* 1653540 */     GIR_EraseRootFromParent_Done,
     /* 1653541 */   // Label 22723: @1653541
     /* 1653541 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1653627), // Rule ID 5823 //
     /* 1653546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1653557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1653560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1653563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1653566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653592 */     // MIs[0] policy
     /* 1653592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1653605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653626 */     // GIR_Coverage, 5823,
     /* 1653626 */     GIR_EraseRootFromParent_Done,
     /* 1653627 */   // Label 22724: @1653627
     /* 1653627 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1653713), // Rule ID 5826 //
     /* 1653632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1653643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1653646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1653649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1653652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1653655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653678 */     // MIs[0] policy
     /* 1653678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653688 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1653691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653712 */     // GIR_Coverage, 5826,
     /* 1653712 */     GIR_EraseRootFromParent_Done,
     /* 1653713 */   // Label 22725: @1653713
     /* 1653713 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1653799), // Rule ID 5827 //
     /* 1653718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1653729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1653732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1653735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1653738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1653741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653764 */     // MIs[0] policy
     /* 1653764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1653777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653798 */     // GIR_Coverage, 5827,
     /* 1653798 */     GIR_EraseRootFromParent_Done,
     /* 1653799 */   // Label 22726: @1653799
     /* 1653799 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1653885), // Rule ID 5830 //
     /* 1653804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1653824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653850 */     // MIs[0] policy
     /* 1653850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1653863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653884 */     // GIR_Coverage, 5830,
     /* 1653884 */     GIR_EraseRootFromParent_Done,
     /* 1653885 */   // Label 22727: @1653885
     /* 1653885 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1653971), // Rule ID 5831 //
     /* 1653890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1653910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653936 */     // MIs[0] policy
     /* 1653936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1653949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653970 */     // GIR_Coverage, 5831,
     /* 1653970 */     GIR_EraseRootFromParent_Done,
     /* 1653971 */   // Label 22728: @1653971
     /* 1653971 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1654057), // Rule ID 5834 //
     /* 1653976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1653987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1653990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1653993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1653996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654022 */     // MIs[0] policy
     /* 1654022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1654035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654056 */     // GIR_Coverage, 5834,
     /* 1654056 */     GIR_EraseRootFromParent_Done,
     /* 1654057 */   // Label 22729: @1654057
     /* 1654057 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1654143), // Rule ID 5835 //
     /* 1654062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1654073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1654076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1654079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1654082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654108 */     // MIs[0] policy
     /* 1654108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1654121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654142 */     // GIR_Coverage, 5835,
     /* 1654142 */     GIR_EraseRootFromParent_Done,
     /* 1654143 */   // Label 22730: @1654143
     /* 1654143 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1654229), // Rule ID 5838 //
     /* 1654148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1654159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1654162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1654165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1654168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654194 */     // MIs[0] policy
     /* 1654194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1654207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654228 */     // GIR_Coverage, 5838,
     /* 1654228 */     GIR_EraseRootFromParent_Done,
     /* 1654229 */   // Label 22731: @1654229
     /* 1654229 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1654315), // Rule ID 5839 //
     /* 1654234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1654245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1654248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1654251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1654254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1654257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654280 */     // MIs[0] policy
     /* 1654280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1654293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654314 */     // GIR_Coverage, 5839,
     /* 1654314 */     GIR_EraseRootFromParent_Done,
     /* 1654315 */   // Label 22732: @1654315
     /* 1654315 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1654401), // Rule ID 5842 //
     /* 1654320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1654331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1654334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1654337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1654340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654366 */     // MIs[0] policy
     /* 1654366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1654379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654400 */     // GIR_Coverage, 5842,
     /* 1654400 */     GIR_EraseRootFromParent_Done,
     /* 1654401 */   // Label 22733: @1654401
     /* 1654401 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1654487), // Rule ID 5843 //
     /* 1654406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1654417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1654420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1654423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1654426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1654436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1654448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654452 */     // MIs[0] policy
     /* 1654452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1654465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654486 */     // GIR_Coverage, 5843,
     /* 1654486 */     GIR_EraseRootFromParent_Done,
     /* 1654487 */   // Label 22734: @1654487
     /* 1654487 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1654573), // Rule ID 5846 //
     /* 1654492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1654503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1654506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1654509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1654512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654538 */     // MIs[0] policy
     /* 1654538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1654551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654572 */     // GIR_Coverage, 5846,
     /* 1654572 */     GIR_EraseRootFromParent_Done,
     /* 1654573 */   // Label 22735: @1654573
     /* 1654573 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1654659), // Rule ID 5847 //
     /* 1654578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1654589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1654592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1654595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1654598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654624 */     // MIs[0] policy
     /* 1654624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1654637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654658 */     // GIR_Coverage, 5847,
     /* 1654658 */     GIR_EraseRootFromParent_Done,
     /* 1654659 */   // Label 22736: @1654659
     /* 1654659 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1654745), // Rule ID 5850 //
     /* 1654664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1654684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654710 */     // MIs[0] policy
     /* 1654710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1654723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654744 */     // GIR_Coverage, 5850,
     /* 1654744 */     GIR_EraseRootFromParent_Done,
     /* 1654745 */   // Label 22737: @1654745
     /* 1654745 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1654831), // Rule ID 5851 //
     /* 1654750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1654770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654796 */     // MIs[0] policy
     /* 1654796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1654809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654830 */     // GIR_Coverage, 5851,
     /* 1654830 */     GIR_EraseRootFromParent_Done,
     /* 1654831 */   // Label 22738: @1654831
     /* 1654831 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1654917), // Rule ID 5854 //
     /* 1654836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1654847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1654850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1654853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1654856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654882 */     // MIs[0] policy
     /* 1654882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1654895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654916 */     // GIR_Coverage, 5854,
     /* 1654916 */     GIR_EraseRootFromParent_Done,
     /* 1654917 */   // Label 22739: @1654917
     /* 1654917 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1655003), // Rule ID 5855 //
     /* 1654922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1654933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1654936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1654939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1654942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654968 */     // MIs[0] policy
     /* 1654968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1654981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655002 */     // GIR_Coverage, 5855,
     /* 1655002 */     GIR_EraseRootFromParent_Done,
     /* 1655003 */   // Label 22740: @1655003
     /* 1655003 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1655089), // Rule ID 5858 //
     /* 1655008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1655019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1655022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1655025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655054 */     // MIs[0] policy
     /* 1655054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1655067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655088 */     // GIR_Coverage, 5858,
     /* 1655088 */     GIR_EraseRootFromParent_Done,
     /* 1655089 */   // Label 22741: @1655089
     /* 1655089 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1655175), // Rule ID 5859 //
     /* 1655094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1655105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1655108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1655111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655140 */     // MIs[0] policy
     /* 1655140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1655153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655174 */     // GIR_Coverage, 5859,
     /* 1655174 */     GIR_EraseRootFromParent_Done,
     /* 1655175 */   // Label 22742: @1655175
     /* 1655175 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1655261), // Rule ID 5862 //
     /* 1655180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1655191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1655194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1655197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655226 */     // MIs[0] policy
     /* 1655226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655260 */     // GIR_Coverage, 5862,
     /* 1655260 */     GIR_EraseRootFromParent_Done,
     /* 1655261 */   // Label 22743: @1655261
     /* 1655261 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1655347), // Rule ID 5863 //
     /* 1655266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1655277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1655280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1655283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655312 */     // MIs[0] policy
     /* 1655312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655346 */     // GIR_Coverage, 5863,
     /* 1655346 */     GIR_EraseRootFromParent_Done,
     /* 1655347 */   // Label 22744: @1655347
     /* 1655347 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1655433), // Rule ID 5866 //
     /* 1655352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1655363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1655366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1655369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655398 */     // MIs[0] policy
     /* 1655398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1655411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655432 */     // GIR_Coverage, 5866,
     /* 1655432 */     GIR_EraseRootFromParent_Done,
     /* 1655433 */   // Label 22745: @1655433
     /* 1655433 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1655519), // Rule ID 5867 //
     /* 1655438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1655449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1655452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1655455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655484 */     // MIs[0] policy
     /* 1655484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1655497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655518 */     // GIR_Coverage, 5867,
     /* 1655518 */     GIR_EraseRootFromParent_Done,
     /* 1655519 */   // Label 22746: @1655519
     /* 1655519 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1655605), // Rule ID 5870 //
     /* 1655524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1655535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1655538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1655541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655570 */     // MIs[0] policy
     /* 1655570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655604 */     // GIR_Coverage, 5870,
     /* 1655604 */     GIR_EraseRootFromParent_Done,
     /* 1655605 */   // Label 22747: @1655605
     /* 1655605 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1655691), // Rule ID 5871 //
     /* 1655610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1655621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1655624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1655627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655656 */     // MIs[0] policy
     /* 1655656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655690 */     // GIR_Coverage, 5871,
     /* 1655690 */     GIR_EraseRootFromParent_Done,
     /* 1655691 */   // Label 22748: @1655691
     /* 1655691 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1655777), // Rule ID 5874 //
     /* 1655696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655742 */     // MIs[0] policy
     /* 1655742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655776 */     // GIR_Coverage, 5874,
     /* 1655776 */     GIR_EraseRootFromParent_Done,
     /* 1655777 */   // Label 22749: @1655777
     /* 1655777 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1655863), // Rule ID 5875 //
     /* 1655782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655828 */     // MIs[0] policy
     /* 1655828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1655841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655862 */     // GIR_Coverage, 5875,
     /* 1655862 */     GIR_EraseRootFromParent_Done,
     /* 1655863 */   // Label 22750: @1655863
     /* 1655863 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1655949), // Rule ID 5878 //
     /* 1655868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1655879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1655882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1655885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1655888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655914 */     // MIs[0] policy
     /* 1655914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1655927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655948 */     // GIR_Coverage, 5878,
     /* 1655948 */     GIR_EraseRootFromParent_Done,
     /* 1655949 */   // Label 22751: @1655949
     /* 1655949 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1656035), // Rule ID 5879 //
     /* 1655954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1655965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1655968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1655971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1655974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1655996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656000 */     // MIs[0] policy
     /* 1656000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656034 */     // GIR_Coverage, 5879,
     /* 1656034 */     GIR_EraseRootFromParent_Done,
     /* 1656035 */   // Label 22752: @1656035
     /* 1656035 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1656121), // Rule ID 5882 //
     /* 1656040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1656051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1656054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1656057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656086 */     // MIs[0] policy
     /* 1656086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656120 */     // GIR_Coverage, 5882,
     /* 1656120 */     GIR_EraseRootFromParent_Done,
     /* 1656121 */   // Label 22753: @1656121
     /* 1656121 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1656207), // Rule ID 5883 //
     /* 1656126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1656137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1656140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1656143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656172 */     // MIs[0] policy
     /* 1656172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656206 */     // GIR_Coverage, 5883,
     /* 1656206 */     GIR_EraseRootFromParent_Done,
     /* 1656207 */   // Label 22754: @1656207
     /* 1656207 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1656293), // Rule ID 5886 //
     /* 1656212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1656223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1656226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1656229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656258 */     // MIs[0] policy
     /* 1656258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656292 */     // GIR_Coverage, 5886,
     /* 1656292 */     GIR_EraseRootFromParent_Done,
     /* 1656293 */   // Label 22755: @1656293
     /* 1656293 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1656379), // Rule ID 5887 //
     /* 1656298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1656309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1656312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1656315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656344 */     // MIs[0] policy
     /* 1656344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656378 */     // GIR_Coverage, 5887,
     /* 1656378 */     GIR_EraseRootFromParent_Done,
     /* 1656379 */   // Label 22756: @1656379
     /* 1656379 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1656465), // Rule ID 5890 //
     /* 1656384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1656395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1656398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1656401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656430 */     // MIs[0] policy
     /* 1656430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656464 */     // GIR_Coverage, 5890,
     /* 1656464 */     GIR_EraseRootFromParent_Done,
     /* 1656465 */   // Label 22757: @1656465
     /* 1656465 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1656551), // Rule ID 5891 //
     /* 1656470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1656481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1656484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1656487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1656493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1656500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1656508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656516 */     // MIs[0] policy
     /* 1656516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1656529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656550 */     // GIR_Coverage, 5891,
     /* 1656550 */     GIR_EraseRootFromParent_Done,
     /* 1656551 */   // Label 22758: @1656551
     /* 1656551 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1656637), // Rule ID 5894 //
     /* 1656556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1656567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1656570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1656573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656602 */     // MIs[0] policy
     /* 1656602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1656615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656636 */     // GIR_Coverage, 5894,
     /* 1656636 */     GIR_EraseRootFromParent_Done,
     /* 1656637 */   // Label 22759: @1656637
     /* 1656637 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1656723), // Rule ID 5895 //
     /* 1656642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1656653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1656656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1656659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656688 */     // MIs[0] policy
     /* 1656688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1656701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656722 */     // GIR_Coverage, 5895,
     /* 1656722 */     GIR_EraseRootFromParent_Done,
     /* 1656723 */   // Label 22760: @1656723
     /* 1656723 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1656809), // Rule ID 5898 //
     /* 1656728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1656739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1656742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1656745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656774 */     // MIs[0] policy
     /* 1656774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1656787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656808 */     // GIR_Coverage, 5898,
     /* 1656808 */     GIR_EraseRootFromParent_Done,
     /* 1656809 */   // Label 22761: @1656809
     /* 1656809 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1656895), // Rule ID 5899 //
     /* 1656814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1656825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1656828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1656831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1656834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656860 */     // MIs[0] policy
     /* 1656860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1656873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656894 */     // GIR_Coverage, 5899,
     /* 1656894 */     GIR_EraseRootFromParent_Done,
     /* 1656895 */   // Label 22762: @1656895
     /* 1656895 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1656981), // Rule ID 5902 //
     /* 1656900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1656911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1656914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1656917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1656920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1656923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1656942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656946 */     // MIs[0] policy
     /* 1656946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1656959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656980 */     // GIR_Coverage, 5902,
     /* 1656980 */     GIR_EraseRootFromParent_Done,
     /* 1656981 */   // Label 22763: @1656981
     /* 1656981 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1657067), // Rule ID 5903 //
     /* 1656986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1656997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1657000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1657003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1657009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657032 */     // MIs[0] policy
     /* 1657032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1657045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657066 */     // GIR_Coverage, 5903,
     /* 1657066 */     GIR_EraseRootFromParent_Done,
     /* 1657067 */   // Label 22764: @1657067
     /* 1657067 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1657153), // Rule ID 5906 //
     /* 1657072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1657083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1657086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1657089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657118 */     // MIs[0] policy
     /* 1657118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1657131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657152 */     // GIR_Coverage, 5906,
     /* 1657152 */     GIR_EraseRootFromParent_Done,
     /* 1657153 */   // Label 22765: @1657153
     /* 1657153 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1657239), // Rule ID 5907 //
     /* 1657158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1657169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1657172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1657175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657204 */     // MIs[0] policy
     /* 1657204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1657217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657238 */     // GIR_Coverage, 5907,
     /* 1657238 */     GIR_EraseRootFromParent_Done,
     /* 1657239 */   // Label 22766: @1657239
     /* 1657239 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1657325), // Rule ID 5910 //
     /* 1657244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1657255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1657258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1657261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657290 */     // MIs[0] policy
     /* 1657290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1657303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657324 */     // GIR_Coverage, 5910,
     /* 1657324 */     GIR_EraseRootFromParent_Done,
     /* 1657325 */   // Label 22767: @1657325
     /* 1657325 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1657411), // Rule ID 5911 //
     /* 1657330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1657341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1657344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1657347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657376 */     // MIs[0] policy
     /* 1657376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1657389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657410 */     // GIR_Coverage, 5911,
     /* 1657410 */     GIR_EraseRootFromParent_Done,
     /* 1657411 */   // Label 22768: @1657411
     /* 1657411 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1657497), // Rule ID 5914 //
     /* 1657416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1657427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1657430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1657433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1657439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657462 */     // MIs[0] policy
     /* 1657462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1657475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657496 */     // GIR_Coverage, 5914,
     /* 1657496 */     GIR_EraseRootFromParent_Done,
     /* 1657497 */   // Label 22769: @1657497
     /* 1657497 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1657583), // Rule ID 5915 //
     /* 1657502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1657513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1657516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1657519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1657525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657548 */     // MIs[0] policy
     /* 1657548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1657561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657582 */     // GIR_Coverage, 5915,
     /* 1657582 */     GIR_EraseRootFromParent_Done,
     /* 1657583 */   // Label 22770: @1657583
     /* 1657583 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1657669), // Rule ID 5918 //
     /* 1657588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1657599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1657602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1657605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657634 */     // MIs[0] policy
     /* 1657634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1657647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657668 */     // GIR_Coverage, 5918,
     /* 1657668 */     GIR_EraseRootFromParent_Done,
     /* 1657669 */   // Label 22771: @1657669
     /* 1657669 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1657755), // Rule ID 5919 //
     /* 1657674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1657685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1657688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1657691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657720 */     // MIs[0] policy
     /* 1657720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1657733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657754 */     // GIR_Coverage, 5919,
     /* 1657754 */     GIR_EraseRootFromParent_Done,
     /* 1657755 */   // Label 22772: @1657755
     /* 1657755 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1657841), // Rule ID 5922 //
     /* 1657760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1657771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1657774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1657777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657806 */     // MIs[0] policy
     /* 1657806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1657819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657840 */     // GIR_Coverage, 5922,
     /* 1657840 */     GIR_EraseRootFromParent_Done,
     /* 1657841 */   // Label 22773: @1657841
     /* 1657841 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1657927), // Rule ID 5923 //
     /* 1657846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1657857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1657860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1657863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657892 */     // MIs[0] policy
     /* 1657892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1657905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657926 */     // GIR_Coverage, 5923,
     /* 1657926 */     GIR_EraseRootFromParent_Done,
     /* 1657927 */   // Label 22774: @1657927
     /* 1657927 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1658013), // Rule ID 5926 //
     /* 1657932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1657943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1657946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1657949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657978 */     // MIs[0] policy
     /* 1657978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1657991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658012 */     // GIR_Coverage, 5926,
     /* 1658012 */     GIR_EraseRootFromParent_Done,
     /* 1658013 */   // Label 22775: @1658013
     /* 1658013 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1658099), // Rule ID 5927 //
     /* 1658018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1658029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1658032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1658035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658064 */     // MIs[0] policy
     /* 1658064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1658077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658098 */     // GIR_Coverage, 5927,
     /* 1658098 */     GIR_EraseRootFromParent_Done,
     /* 1658099 */   // Label 22776: @1658099
     /* 1658099 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1658185), // Rule ID 5930 //
     /* 1658104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1658115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1658118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1658121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658150 */     // MIs[0] policy
     /* 1658150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658184 */     // GIR_Coverage, 5930,
     /* 1658184 */     GIR_EraseRootFromParent_Done,
     /* 1658185 */   // Label 22777: @1658185
     /* 1658185 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1658271), // Rule ID 5931 //
     /* 1658190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1658201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1658204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1658207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658236 */     // MIs[0] policy
     /* 1658236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658270 */     // GIR_Coverage, 5931,
     /* 1658270 */     GIR_EraseRootFromParent_Done,
     /* 1658271 */   // Label 22778: @1658271
     /* 1658271 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1658357), // Rule ID 5934 //
     /* 1658276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1658287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1658290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1658293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658322 */     // MIs[0] policy
     /* 1658322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1658335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658356 */     // GIR_Coverage, 5934,
     /* 1658356 */     GIR_EraseRootFromParent_Done,
     /* 1658357 */   // Label 22779: @1658357
     /* 1658357 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1658443), // Rule ID 5935 //
     /* 1658362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1658373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1658376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1658379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658408 */     // MIs[0] policy
     /* 1658408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1658421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658442 */     // GIR_Coverage, 5935,
     /* 1658442 */     GIR_EraseRootFromParent_Done,
     /* 1658443 */   // Label 22780: @1658443
     /* 1658443 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1658529), // Rule ID 5938 //
     /* 1658448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1658459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1658462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1658465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658494 */     // MIs[0] policy
     /* 1658494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1658507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658528 */     // GIR_Coverage, 5938,
     /* 1658528 */     GIR_EraseRootFromParent_Done,
     /* 1658529 */   // Label 22781: @1658529
     /* 1658529 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1658615), // Rule ID 5939 //
     /* 1658534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1658545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1658548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1658551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1658564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658580 */     // MIs[0] policy
     /* 1658580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1658593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658614 */     // GIR_Coverage, 5939,
     /* 1658614 */     GIR_EraseRootFromParent_Done,
     /* 1658615 */   // Label 22782: @1658615
     /* 1658615 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1658701), // Rule ID 6030 //
     /* 1658620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1658640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658666 */     // MIs[0] policy
     /* 1658666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1658679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658700 */     // GIR_Coverage, 6030,
     /* 1658700 */     GIR_EraseRootFromParent_Done,
     /* 1658701 */   // Label 22783: @1658701
     /* 1658701 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1658787), // Rule ID 6031 //
     /* 1658706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1658726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658752 */     // MIs[0] policy
     /* 1658752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1658765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658786 */     // GIR_Coverage, 6031,
     /* 1658786 */     GIR_EraseRootFromParent_Done,
     /* 1658787 */   // Label 22784: @1658787
     /* 1658787 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1658873), // Rule ID 6034 //
     /* 1658792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1658803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1658806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1658809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1658812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658838 */     // MIs[0] policy
     /* 1658838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1658851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658872 */     // GIR_Coverage, 6034,
     /* 1658872 */     GIR_EraseRootFromParent_Done,
     /* 1658873 */   // Label 22785: @1658873
     /* 1658873 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1658959), // Rule ID 6035 //
     /* 1658878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1658889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1658892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1658895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1658898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658924 */     // MIs[0] policy
     /* 1658924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1658937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658958 */     // GIR_Coverage, 6035,
     /* 1658958 */     GIR_EraseRootFromParent_Done,
     /* 1658959 */   // Label 22786: @1658959
     /* 1658959 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1659045), // Rule ID 6038 //
     /* 1658964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1658975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1658978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1658981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1658984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659010 */     // MIs[0] policy
     /* 1659010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659044 */     // GIR_Coverage, 6038,
     /* 1659044 */     GIR_EraseRootFromParent_Done,
     /* 1659045 */   // Label 22787: @1659045
     /* 1659045 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1659131), // Rule ID 6039 //
     /* 1659050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1659061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1659064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1659067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1659070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659096 */     // MIs[0] policy
     /* 1659096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659130 */     // GIR_Coverage, 6039,
     /* 1659130 */     GIR_EraseRootFromParent_Done,
     /* 1659131 */   // Label 22788: @1659131
     /* 1659131 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1659217), // Rule ID 6042 //
     /* 1659136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1659147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1659150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1659153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1659156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659182 */     // MIs[0] policy
     /* 1659182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659192 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1659195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659216 */     // GIR_Coverage, 6042,
     /* 1659216 */     GIR_EraseRootFromParent_Done,
     /* 1659217 */   // Label 22789: @1659217
     /* 1659217 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1659303), // Rule ID 6043 //
     /* 1659222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1659233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1659236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1659239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1659242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659268 */     // MIs[0] policy
     /* 1659268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1659281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659302 */     // GIR_Coverage, 6043,
     /* 1659302 */     GIR_EraseRootFromParent_Done,
     /* 1659303 */   // Label 22790: @1659303
     /* 1659303 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1659389), // Rule ID 6046 //
     /* 1659308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1659319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1659322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1659325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1659328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659354 */     // MIs[0] policy
     /* 1659354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659388 */     // GIR_Coverage, 6046,
     /* 1659388 */     GIR_EraseRootFromParent_Done,
     /* 1659389 */   // Label 22791: @1659389
     /* 1659389 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1659475), // Rule ID 6047 //
     /* 1659394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1659405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1659408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1659411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1659414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659440 */     // MIs[0] policy
     /* 1659440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659474 */     // GIR_Coverage, 6047,
     /* 1659474 */     GIR_EraseRootFromParent_Done,
     /* 1659475 */   // Label 22792: @1659475
     /* 1659475 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1659561), // Rule ID 6050 //
     /* 1659480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1659491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1659494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1659497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1659500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659526 */     // MIs[0] policy
     /* 1659526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659560 */     // GIR_Coverage, 6050,
     /* 1659560 */     GIR_EraseRootFromParent_Done,
     /* 1659561 */   // Label 22793: @1659561
     /* 1659561 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1659647), // Rule ID 6051 //
     /* 1659566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1659577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1659580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1659583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1659586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659612 */     // MIs[0] policy
     /* 1659612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1659625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659646 */     // GIR_Coverage, 6051,
     /* 1659646 */     GIR_EraseRootFromParent_Done,
     /* 1659647 */   // Label 22794: @1659647
     /* 1659647 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1659733), // Rule ID 6054 //
     /* 1659652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1659672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659698 */     // MIs[0] policy
     /* 1659698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1659711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659732 */     // GIR_Coverage, 6054,
     /* 1659732 */     GIR_EraseRootFromParent_Done,
     /* 1659733 */   // Label 22795: @1659733
     /* 1659733 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1659819), // Rule ID 6055 //
     /* 1659738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1659758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659784 */     // MIs[0] policy
     /* 1659784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1659797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659818 */     // GIR_Coverage, 6055,
     /* 1659818 */     GIR_EraseRootFromParent_Done,
     /* 1659819 */   // Label 22796: @1659819
     /* 1659819 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1659905), // Rule ID 6058 //
     /* 1659824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1659835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1659838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1659841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1659844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659870 */     // MIs[0] policy
     /* 1659870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1659883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659904 */     // GIR_Coverage, 6058,
     /* 1659904 */     GIR_EraseRootFromParent_Done,
     /* 1659905 */   // Label 22797: @1659905
     /* 1659905 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1659991), // Rule ID 6059 //
     /* 1659910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1659921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1659924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1659927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1659930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659956 */     // MIs[0] policy
     /* 1659956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1659969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659990 */     // GIR_Coverage, 6059,
     /* 1659990 */     GIR_EraseRootFromParent_Done,
     /* 1659991 */   // Label 22798: @1659991
     /* 1659991 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1660077), // Rule ID 6062 //
     /* 1659996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1660007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1660010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1660013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1660016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660042 */     // MIs[0] policy
     /* 1660042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1660055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660076 */     // GIR_Coverage, 6062,
     /* 1660076 */     GIR_EraseRootFromParent_Done,
     /* 1660077 */   // Label 22799: @1660077
     /* 1660077 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1660163), // Rule ID 6063 //
     /* 1660082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1660093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1660096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1660099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1660102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660128 */     // MIs[0] policy
     /* 1660128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1660141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660162 */     // GIR_Coverage, 6063,
     /* 1660162 */     GIR_EraseRootFromParent_Done,
     /* 1660163 */   // Label 22800: @1660163
     /* 1660163 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1660249), // Rule ID 6066 //
     /* 1660168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1660179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1660182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1660185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1660188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660214 */     // MIs[0] policy
     /* 1660214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1660227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660248 */     // GIR_Coverage, 6066,
     /* 1660248 */     GIR_EraseRootFromParent_Done,
     /* 1660249 */   // Label 22801: @1660249
     /* 1660249 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1660335), // Rule ID 6067 //
     /* 1660254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1660265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1660268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1660271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1660274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660300 */     // MIs[0] policy
     /* 1660300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1660313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660334 */     // GIR_Coverage, 6067,
     /* 1660334 */     GIR_EraseRootFromParent_Done,
     /* 1660335 */   // Label 22802: @1660335
     /* 1660335 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1660421), // Rule ID 6070 //
     /* 1660340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1660351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1660354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1660357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1660360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660386 */     // MIs[0] policy
     /* 1660386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1660399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660420 */     // GIR_Coverage, 6070,
     /* 1660420 */     GIR_EraseRootFromParent_Done,
     /* 1660421 */   // Label 22803: @1660421
     /* 1660421 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1660507), // Rule ID 6071 //
     /* 1660426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1660437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1660440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1660443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1660446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660472 */     // MIs[0] policy
     /* 1660472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1660485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660506 */     // GIR_Coverage, 6071,
     /* 1660506 */     GIR_EraseRootFromParent_Done,
     /* 1660507 */   // Label 22804: @1660507
     /* 1660507 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1660593), // Rule ID 6074 //
     /* 1660512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1660523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1660526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1660529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1660532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660558 */     // MIs[0] policy
     /* 1660558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1660571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660592 */     // GIR_Coverage, 6074,
     /* 1660592 */     GIR_EraseRootFromParent_Done,
     /* 1660593 */   // Label 22805: @1660593
     /* 1660593 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1660679), // Rule ID 6075 //
     /* 1660598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1660609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1660612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1660615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1660618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660644 */     // MIs[0] policy
     /* 1660644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660654 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1660657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660678 */     // GIR_Coverage, 6075,
     /* 1660678 */     GIR_EraseRootFromParent_Done,
     /* 1660679 */   // Label 22806: @1660679
     /* 1660679 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1660765), // Rule ID 6078 //
     /* 1660684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1660704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660730 */     // MIs[0] policy
     /* 1660730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1660743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660764 */     // GIR_Coverage, 6078,
     /* 1660764 */     GIR_EraseRootFromParent_Done,
     /* 1660765 */   // Label 22807: @1660765
     /* 1660765 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1660851), // Rule ID 6079 //
     /* 1660770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1660790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660816 */     // MIs[0] policy
     /* 1660816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1660829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660850 */     // GIR_Coverage, 6079,
     /* 1660850 */     GIR_EraseRootFromParent_Done,
     /* 1660851 */   // Label 22808: @1660851
     /* 1660851 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1660937), // Rule ID 6082 //
     /* 1660856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1660876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660902 */     // MIs[0] policy
     /* 1660902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1660915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660936 */     // GIR_Coverage, 6082,
     /* 1660936 */     GIR_EraseRootFromParent_Done,
     /* 1660937 */   // Label 22809: @1660937
     /* 1660937 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1661023), // Rule ID 6083 //
     /* 1660942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1660962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660988 */     // MIs[0] policy
     /* 1660988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1661001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661022 */     // GIR_Coverage, 6083,
     /* 1661022 */     GIR_EraseRootFromParent_Done,
     /* 1661023 */   // Label 22810: @1661023
     /* 1661023 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1661109), // Rule ID 6086 //
     /* 1661028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1661039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1661042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1661045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1661048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661074 */     // MIs[0] policy
     /* 1661074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1661087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661108 */     // GIR_Coverage, 6086,
     /* 1661108 */     GIR_EraseRootFromParent_Done,
     /* 1661109 */   // Label 22811: @1661109
     /* 1661109 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1661195), // Rule ID 6087 //
     /* 1661114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1661125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1661128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1661131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1661134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661160 */     // MIs[0] policy
     /* 1661160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1661173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661194 */     // GIR_Coverage, 6087,
     /* 1661194 */     GIR_EraseRootFromParent_Done,
     /* 1661195 */   // Label 22812: @1661195
     /* 1661195 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1661281), // Rule ID 6090 //
     /* 1661200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1661211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1661214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1661217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1661220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1661223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661246 */     // MIs[0] policy
     /* 1661246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1661259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661280 */     // GIR_Coverage, 6090,
     /* 1661280 */     GIR_EraseRootFromParent_Done,
     /* 1661281 */   // Label 22813: @1661281
     /* 1661281 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1661367), // Rule ID 6091 //
     /* 1661286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1661297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1661300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1661303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1661306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1661309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661332 */     // MIs[0] policy
     /* 1661332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1661345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661366 */     // GIR_Coverage, 6091,
     /* 1661366 */     GIR_EraseRootFromParent_Done,
     /* 1661367 */   // Label 22814: @1661367
     /* 1661367 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1661453), // Rule ID 6094 //
     /* 1661372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1661383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1661386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1661389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1661392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661418 */     // MIs[0] policy
     /* 1661418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1661431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661452 */     // GIR_Coverage, 6094,
     /* 1661452 */     GIR_EraseRootFromParent_Done,
     /* 1661453 */   // Label 22815: @1661453
     /* 1661453 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1661539), // Rule ID 6095 //
     /* 1661458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1661469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1661472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1661475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1661478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661504 */     // MIs[0] policy
     /* 1661504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1661517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661538 */     // GIR_Coverage, 6095,
     /* 1661538 */     GIR_EraseRootFromParent_Done,
     /* 1661539 */   // Label 22816: @1661539
     /* 1661539 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1661625), // Rule ID 6098 //
     /* 1661544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1661555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1661558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1661561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1661564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661590 */     // MIs[0] policy
     /* 1661590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1661603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661624 */     // GIR_Coverage, 6098,
     /* 1661624 */     GIR_EraseRootFromParent_Done,
     /* 1661625 */   // Label 22817: @1661625
     /* 1661625 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1661711), // Rule ID 6099 //
     /* 1661630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1661641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1661644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1661647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1661650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661676 */     // MIs[0] policy
     /* 1661676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1661689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661710 */     // GIR_Coverage, 6099,
     /* 1661710 */     GIR_EraseRootFromParent_Done,
     /* 1661711 */   // Label 22818: @1661711
     /* 1661711 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1661797), // Rule ID 6102 //
     /* 1661716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1661736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661762 */     // MIs[0] policy
     /* 1661762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661772 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1661775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661796 */     // GIR_Coverage, 6102,
     /* 1661796 */     GIR_EraseRootFromParent_Done,
     /* 1661797 */   // Label 22819: @1661797
     /* 1661797 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1661883), // Rule ID 6103 //
     /* 1661802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1661822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661848 */     // MIs[0] policy
     /* 1661848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1661861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661882 */     // GIR_Coverage, 6103,
     /* 1661882 */     GIR_EraseRootFromParent_Done,
     /* 1661883 */   // Label 22820: @1661883
     /* 1661883 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1661969), // Rule ID 6106 //
     /* 1661888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1661899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1661902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1661905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1661908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661934 */     // MIs[0] policy
     /* 1661934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1661947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661968 */     // GIR_Coverage, 6106,
     /* 1661968 */     GIR_EraseRootFromParent_Done,
     /* 1661969 */   // Label 22821: @1661969
     /* 1661969 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1662055), // Rule ID 6107 //
     /* 1661974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1661985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1661988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1661991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1661994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662020 */     // MIs[0] policy
     /* 1662020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1662033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662054 */     // GIR_Coverage, 6107,
     /* 1662054 */     GIR_EraseRootFromParent_Done,
     /* 1662055 */   // Label 22822: @1662055
     /* 1662055 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1662141), // Rule ID 6110 //
     /* 1662060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1662071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1662074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1662077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1662080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662106 */     // MIs[0] policy
     /* 1662106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662140 */     // GIR_Coverage, 6110,
     /* 1662140 */     GIR_EraseRootFromParent_Done,
     /* 1662141 */   // Label 22823: @1662141
     /* 1662141 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1662227), // Rule ID 6111 //
     /* 1662146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1662157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1662160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1662163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1662166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662192 */     // MIs[0] policy
     /* 1662192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662226 */     // GIR_Coverage, 6111,
     /* 1662226 */     GIR_EraseRootFromParent_Done,
     /* 1662227 */   // Label 22824: @1662227
     /* 1662227 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1662313), // Rule ID 6114 //
     /* 1662232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1662243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1662246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1662249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1662252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1662262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662278 */     // MIs[0] policy
     /* 1662278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662288 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1662291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662312 */     // GIR_Coverage, 6114,
     /* 1662312 */     GIR_EraseRootFromParent_Done,
     /* 1662313 */   // Label 22825: @1662313
     /* 1662313 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1662399), // Rule ID 6115 //
     /* 1662318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1662329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1662332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1662335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1662338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1662348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662364 */     // MIs[0] policy
     /* 1662364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1662377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662398 */     // GIR_Coverage, 6115,
     /* 1662398 */     GIR_EraseRootFromParent_Done,
     /* 1662399 */   // Label 22826: @1662399
     /* 1662399 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1662485), // Rule ID 6118 //
     /* 1662404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1662415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1662418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1662421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662450 */     // MIs[0] policy
     /* 1662450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1662463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662484 */     // GIR_Coverage, 6118,
     /* 1662484 */     GIR_EraseRootFromParent_Done,
     /* 1662485 */   // Label 22827: @1662485
     /* 1662485 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1662571), // Rule ID 6119 //
     /* 1662490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1662501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1662504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1662507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662536 */     // MIs[0] policy
     /* 1662536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1662549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662570 */     // GIR_Coverage, 6119,
     /* 1662570 */     GIR_EraseRootFromParent_Done,
     /* 1662571 */   // Label 22828: @1662571
     /* 1662571 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1662657), // Rule ID 6122 //
     /* 1662576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662622 */     // MIs[0] policy
     /* 1662622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1662635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662656 */     // GIR_Coverage, 6122,
     /* 1662656 */     GIR_EraseRootFromParent_Done,
     /* 1662657 */   // Label 22829: @1662657
     /* 1662657 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1662743), // Rule ID 6123 //
     /* 1662662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662708 */     // MIs[0] policy
     /* 1662708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1662721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662742 */     // GIR_Coverage, 6123,
     /* 1662742 */     GIR_EraseRootFromParent_Done,
     /* 1662743 */   // Label 22830: @1662743
     /* 1662743 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1662829), // Rule ID 6126 //
     /* 1662748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662794 */     // MIs[0] policy
     /* 1662794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1662807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662828 */     // GIR_Coverage, 6126,
     /* 1662828 */     GIR_EraseRootFromParent_Done,
     /* 1662829 */   // Label 22831: @1662829
     /* 1662829 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1662915), // Rule ID 6127 //
     /* 1662834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1662854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662880 */     // MIs[0] policy
     /* 1662880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1662893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662914 */     // GIR_Coverage, 6127,
     /* 1662914 */     GIR_EraseRootFromParent_Done,
     /* 1662915 */   // Label 22832: @1662915
     /* 1662915 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1663001), // Rule ID 6130 //
     /* 1662920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1662931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1662934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1662937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1662940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1662962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662966 */     // MIs[0] policy
     /* 1662966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1662979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663000 */     // GIR_Coverage, 6130,
     /* 1663000 */     GIR_EraseRootFromParent_Done,
     /* 1663001 */   // Label 22833: @1663001
     /* 1663001 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1663087), // Rule ID 6131 //
     /* 1663006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1663017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1663020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1663023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663052 */     // MIs[0] policy
     /* 1663052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1663065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663086 */     // GIR_Coverage, 6131,
     /* 1663086 */     GIR_EraseRootFromParent_Done,
     /* 1663087 */   // Label 22834: @1663087
     /* 1663087 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1663173), // Rule ID 6134 //
     /* 1663092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1663103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1663106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1663109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663138 */     // MIs[0] policy
     /* 1663138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1663151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663172 */     // GIR_Coverage, 6134,
     /* 1663172 */     GIR_EraseRootFromParent_Done,
     /* 1663173 */   // Label 22835: @1663173
     /* 1663173 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1663259), // Rule ID 6135 //
     /* 1663178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1663189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1663192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1663195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663224 */     // MIs[0] policy
     /* 1663224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1663237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663258 */     // GIR_Coverage, 6135,
     /* 1663258 */     GIR_EraseRootFromParent_Done,
     /* 1663259 */   // Label 22836: @1663259
     /* 1663259 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1663345), // Rule ID 6138 //
     /* 1663264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1663275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1663278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1663281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663310 */     // MIs[0] policy
     /* 1663310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1663323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663344 */     // GIR_Coverage, 6138,
     /* 1663344 */     GIR_EraseRootFromParent_Done,
     /* 1663345 */   // Label 22837: @1663345
     /* 1663345 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1663431), // Rule ID 6139 //
     /* 1663350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1663361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1663364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1663367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663396 */     // MIs[0] policy
     /* 1663396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1663409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663430 */     // GIR_Coverage, 6139,
     /* 1663430 */     GIR_EraseRootFromParent_Done,
     /* 1663431 */   // Label 22838: @1663431
     /* 1663431 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1663517), // Rule ID 6142 //
     /* 1663436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1663447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1663450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1663453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663482 */     // MIs[0] policy
     /* 1663482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663492 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663516 */     // GIR_Coverage, 6142,
     /* 1663516 */     GIR_EraseRootFromParent_Done,
     /* 1663517 */   // Label 22839: @1663517
     /* 1663517 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1663603), // Rule ID 6143 //
     /* 1663522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1663533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1663536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1663539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663568 */     // MIs[0] policy
     /* 1663568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663602 */     // GIR_Coverage, 6143,
     /* 1663602 */     GIR_EraseRootFromParent_Done,
     /* 1663603 */   // Label 22840: @1663603
     /* 1663603 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1663689), // Rule ID 6146 //
     /* 1663608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663654 */     // MIs[0] policy
     /* 1663654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663688 */     // GIR_Coverage, 6146,
     /* 1663688 */     GIR_EraseRootFromParent_Done,
     /* 1663689 */   // Label 22841: @1663689
     /* 1663689 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1663775), // Rule ID 6147 //
     /* 1663694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663740 */     // MIs[0] policy
     /* 1663740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663774 */     // GIR_Coverage, 6147,
     /* 1663774 */     GIR_EraseRootFromParent_Done,
     /* 1663775 */   // Label 22842: @1663775
     /* 1663775 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1663861), // Rule ID 6150 //
     /* 1663780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663826 */     // MIs[0] policy
     /* 1663826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663860 */     // GIR_Coverage, 6150,
     /* 1663860 */     GIR_EraseRootFromParent_Done,
     /* 1663861 */   // Label 22843: @1663861
     /* 1663861 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1663947), // Rule ID 6151 //
     /* 1663866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1663886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663912 */     // MIs[0] policy
     /* 1663912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1663925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663946 */     // GIR_Coverage, 6151,
     /* 1663946 */     GIR_EraseRootFromParent_Done,
     /* 1663947 */   // Label 22844: @1663947
     /* 1663947 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1664033), // Rule ID 6154 //
     /* 1663952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1663955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1663963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1663966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1663969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1663972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1663994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663998 */     // MIs[0] policy
     /* 1663998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1664011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664032 */     // GIR_Coverage, 6154,
     /* 1664032 */     GIR_EraseRootFromParent_Done,
     /* 1664033 */   // Label 22845: @1664033
     /* 1664033 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1664119), // Rule ID 6155 //
     /* 1664038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1664049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1664052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1664055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664084 */     // MIs[0] policy
     /* 1664084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1664097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664118 */     // GIR_Coverage, 6155,
     /* 1664118 */     GIR_EraseRootFromParent_Done,
     /* 1664119 */   // Label 22846: @1664119
     /* 1664119 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1664205), // Rule ID 6158 //
     /* 1664124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1664135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1664138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1664141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664170 */     // MIs[0] policy
     /* 1664170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1664183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664204 */     // GIR_Coverage, 6158,
     /* 1664204 */     GIR_EraseRootFromParent_Done,
     /* 1664205 */   // Label 22847: @1664205
     /* 1664205 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1664291), // Rule ID 6159 //
     /* 1664210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1664221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1664224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1664227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664256 */     // MIs[0] policy
     /* 1664256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1664269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664290 */     // GIR_Coverage, 6159,
     /* 1664290 */     GIR_EraseRootFromParent_Done,
     /* 1664291 */   // Label 22848: @1664291
     /* 1664291 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1664377), // Rule ID 6162 //
     /* 1664296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1664307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1664310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1664313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664342 */     // MIs[0] policy
     /* 1664342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1664355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664376 */     // GIR_Coverage, 6162,
     /* 1664376 */     GIR_EraseRootFromParent_Done,
     /* 1664377 */   // Label 22849: @1664377
     /* 1664377 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1664463), // Rule ID 6163 //
     /* 1664382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1664393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1664396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1664399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664428 */     // MIs[0] policy
     /* 1664428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1664441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664462 */     // GIR_Coverage, 6163,
     /* 1664462 */     GIR_EraseRootFromParent_Done,
     /* 1664463 */   // Label 22850: @1664463
     /* 1664463 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1664549), // Rule ID 6166 //
     /* 1664468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1664479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1664482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1664485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1664491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664514 */     // MIs[0] policy
     /* 1664514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664524 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1664527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664548 */     // GIR_Coverage, 6166,
     /* 1664548 */     GIR_EraseRootFromParent_Done,
     /* 1664549 */   // Label 22851: @1664549
     /* 1664549 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1664635), // Rule ID 6167 //
     /* 1664554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1664565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1664568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1664571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1664577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664600 */     // MIs[0] policy
     /* 1664600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1664613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664634 */     // GIR_Coverage, 6167,
     /* 1664634 */     GIR_EraseRootFromParent_Done,
     /* 1664635 */   // Label 22852: @1664635
     /* 1664635 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1664721), // Rule ID 6170 //
     /* 1664640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1664651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1664654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1664657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664686 */     // MIs[0] policy
     /* 1664686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1664699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664720 */     // GIR_Coverage, 6170,
     /* 1664720 */     GIR_EraseRootFromParent_Done,
     /* 1664721 */   // Label 22853: @1664721
     /* 1664721 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1664807), // Rule ID 6171 //
     /* 1664726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1664737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1664740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1664743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664772 */     // MIs[0] policy
     /* 1664772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1664785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664806 */     // GIR_Coverage, 6171,
     /* 1664806 */     GIR_EraseRootFromParent_Done,
     /* 1664807 */   // Label 22854: @1664807
     /* 1664807 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1664893), // Rule ID 6174 //
     /* 1664812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664858 */     // MIs[0] policy
     /* 1664858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1664871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664892 */     // GIR_Coverage, 6174,
     /* 1664892 */     GIR_EraseRootFromParent_Done,
     /* 1664893 */   // Label 22855: @1664893
     /* 1664893 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1664979), // Rule ID 6175 //
     /* 1664898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664944 */     // MIs[0] policy
     /* 1664944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1664957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664978 */     // GIR_Coverage, 6175,
     /* 1664978 */     GIR_EraseRootFromParent_Done,
     /* 1664979 */   // Label 22856: @1664979
     /* 1664979 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1665065), // Rule ID 6178 //
     /* 1664984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1665001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1665007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665030 */     // MIs[0] policy
     /* 1665030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1665043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665064 */     // GIR_Coverage, 6178,
     /* 1665064 */     GIR_EraseRootFromParent_Done,
     /* 1665065 */   // Label 22857: @1665065
     /* 1665065 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1665151), // Rule ID 6179 //
     /* 1665070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1665081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1665084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1665087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1665093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665116 */     // MIs[0] policy
     /* 1665116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1665129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665150 */     // GIR_Coverage, 6179,
     /* 1665150 */     GIR_EraseRootFromParent_Done,
     /* 1665151 */   // Label 22858: @1665151
     /* 1665151 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1665237), // Rule ID 6182 //
     /* 1665156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1665167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1665170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1665173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665202 */     // MIs[0] policy
     /* 1665202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1665215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665236 */     // GIR_Coverage, 6182,
     /* 1665236 */     GIR_EraseRootFromParent_Done,
     /* 1665237 */   // Label 22859: @1665237
     /* 1665237 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1665323), // Rule ID 6183 //
     /* 1665242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1665253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1665256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1665259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665288 */     // MIs[0] policy
     /* 1665288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1665301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665322 */     // GIR_Coverage, 6183,
     /* 1665322 */     GIR_EraseRootFromParent_Done,
     /* 1665323 */   // Label 22860: @1665323
     /* 1665323 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1665409), // Rule ID 6186 //
     /* 1665328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1665339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1665342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1665345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665374 */     // MIs[0] policy
     /* 1665374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1665387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665408 */     // GIR_Coverage, 6186,
     /* 1665408 */     GIR_EraseRootFromParent_Done,
     /* 1665409 */   // Label 22861: @1665409
     /* 1665409 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1665495), // Rule ID 6187 //
     /* 1665414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1665425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1665428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1665431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665460 */     // MIs[0] policy
     /* 1665460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1665473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665494 */     // GIR_Coverage, 6187,
     /* 1665494 */     GIR_EraseRootFromParent_Done,
     /* 1665495 */   // Label 22862: @1665495
     /* 1665495 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1665581), // Rule ID 6190 //
     /* 1665500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1665511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1665514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1665517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1665523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665546 */     // MIs[0] policy
     /* 1665546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1665559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665580 */     // GIR_Coverage, 6190,
     /* 1665580 */     GIR_EraseRootFromParent_Done,
     /* 1665581 */   // Label 22863: @1665581
     /* 1665581 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1665667), // Rule ID 6191 //
     /* 1665586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1665597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1665600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1665603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1665609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665632 */     // MIs[0] policy
     /* 1665632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1665645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665666 */     // GIR_Coverage, 6191,
     /* 1665666 */     GIR_EraseRootFromParent_Done,
     /* 1665667 */   // Label 22864: @1665667
     /* 1665667 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1665753), // Rule ID 6194 //
     /* 1665672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1665675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665718 */     // MIs[0] policy
     /* 1665718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1665731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665752 */     // GIR_Coverage, 6194,
     /* 1665752 */     GIR_EraseRootFromParent_Done,
     /* 1665753 */   // Label 22865: @1665753
     /* 1665753 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1665839), // Rule ID 6195 //
     /* 1665758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665804 */     // MIs[0] policy
     /* 1665804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1665817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665838 */     // GIR_Coverage, 6195,
     /* 1665838 */     GIR_EraseRootFromParent_Done,
     /* 1665839 */   // Label 22866: @1665839
     /* 1665839 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1665925), // Rule ID 6198 //
     /* 1665844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1665847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665890 */     // MIs[0] policy
     /* 1665890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665900 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1665903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665924 */     // GIR_Coverage, 6198,
     /* 1665924 */     GIR_EraseRootFromParent_Done,
     /* 1665925 */   // Label 22867: @1665925
     /* 1665925 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1666011), // Rule ID 6199 //
     /* 1665930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665976 */     // MIs[0] policy
     /* 1665976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1665989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666010 */     // GIR_Coverage, 6199,
     /* 1666010 */     GIR_EraseRootFromParent_Done,
     /* 1666011 */   // Label 22868: @1666011
     /* 1666011 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1666097), // Rule ID 6202 //
     /* 1666016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666062 */     // MIs[0] policy
     /* 1666062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666072 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666096 */     // GIR_Coverage, 6202,
     /* 1666096 */     GIR_EraseRootFromParent_Done,
     /* 1666097 */   // Label 22869: @1666097
     /* 1666097 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1666183), // Rule ID 6203 //
     /* 1666102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1666113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1666116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1666119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666148 */     // MIs[0] policy
     /* 1666148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666182 */     // GIR_Coverage, 6203,
     /* 1666182 */     GIR_EraseRootFromParent_Done,
     /* 1666183 */   // Label 22870: @1666183
     /* 1666183 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1666269), // Rule ID 6294 //
     /* 1666188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1666199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1666202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1666205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1666208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666234 */     // MIs[0] policy
     /* 1666234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1666247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666268 */     // GIR_Coverage, 6294,
     /* 1666268 */     GIR_EraseRootFromParent_Done,
     /* 1666269 */   // Label 22871: @1666269
     /* 1666269 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1666355), // Rule ID 6295 //
     /* 1666274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1666285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1666288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1666291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1666294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666320 */     // MIs[0] policy
     /* 1666320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1666333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666354 */     // GIR_Coverage, 6295,
     /* 1666354 */     GIR_EraseRootFromParent_Done,
     /* 1666355 */   // Label 22872: @1666355
     /* 1666355 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1666441), // Rule ID 6298 //
     /* 1666360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1666371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1666374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1666377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1666380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666406 */     // MIs[0] policy
     /* 1666406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1666419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666440 */     // GIR_Coverage, 6298,
     /* 1666440 */     GIR_EraseRootFromParent_Done,
     /* 1666441 */   // Label 22873: @1666441
     /* 1666441 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1666527), // Rule ID 6299 //
     /* 1666446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1666457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1666460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1666463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1666466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666492 */     // MIs[0] policy
     /* 1666492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1666505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666526 */     // GIR_Coverage, 6299,
     /* 1666526 */     GIR_EraseRootFromParent_Done,
     /* 1666527 */   // Label 22874: @1666527
     /* 1666527 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1666613), // Rule ID 6302 //
     /* 1666532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1666543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1666546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1666549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1666552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666578 */     // MIs[0] policy
     /* 1666578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666588 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1666591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666612 */     // GIR_Coverage, 6302,
     /* 1666612 */     GIR_EraseRootFromParent_Done,
     /* 1666613 */   // Label 22875: @1666613
     /* 1666613 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1666699), // Rule ID 6303 //
     /* 1666618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1666629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1666632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1666635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1666638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666664 */     // MIs[0] policy
     /* 1666664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1666677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666698 */     // GIR_Coverage, 6303,
     /* 1666698 */     GIR_EraseRootFromParent_Done,
     /* 1666699 */   // Label 22876: @1666699
     /* 1666699 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1666785), // Rule ID 6306 //
     /* 1666704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1666715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1666718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1666721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1666724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666750 */     // MIs[0] policy
     /* 1666750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1666763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666784 */     // GIR_Coverage, 6306,
     /* 1666784 */     GIR_EraseRootFromParent_Done,
     /* 1666785 */   // Label 22877: @1666785
     /* 1666785 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1666871), // Rule ID 6307 //
     /* 1666790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1666801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1666804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1666807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1666810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666836 */     // MIs[0] policy
     /* 1666836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1666849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666870 */     // GIR_Coverage, 6307,
     /* 1666870 */     GIR_EraseRootFromParent_Done,
     /* 1666871 */   // Label 22878: @1666871
     /* 1666871 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1666957), // Rule ID 6310 //
     /* 1666876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1666887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1666890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1666893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1666896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666922 */     // MIs[0] policy
     /* 1666922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1666935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666956 */     // GIR_Coverage, 6310,
     /* 1666956 */     GIR_EraseRootFromParent_Done,
     /* 1666957 */   // Label 22879: @1666957
     /* 1666957 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1667043), // Rule ID 6311 //
     /* 1666962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1666973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1666976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1666979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1666982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667008 */     // MIs[0] policy
     /* 1667008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1667021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667042 */     // GIR_Coverage, 6311,
     /* 1667042 */     GIR_EraseRootFromParent_Done,
     /* 1667043 */   // Label 22880: @1667043
     /* 1667043 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1667129), // Rule ID 6314 //
     /* 1667048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1667059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1667062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1667065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1667068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667094 */     // MIs[0] policy
     /* 1667094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1667107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667128 */     // GIR_Coverage, 6314,
     /* 1667128 */     GIR_EraseRootFromParent_Done,
     /* 1667129 */   // Label 22881: @1667129
     /* 1667129 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1667215), // Rule ID 6315 //
     /* 1667134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1667145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1667148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1667151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1667154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667180 */     // MIs[0] policy
     /* 1667180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1667193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667214 */     // GIR_Coverage, 6315,
     /* 1667214 */     GIR_EraseRootFromParent_Done,
     /* 1667215 */   // Label 22882: @1667215
     /* 1667215 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1667301), // Rule ID 6318 //
     /* 1667220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1667231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1667234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1667237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1667240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667266 */     // MIs[0] policy
     /* 1667266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667300 */     // GIR_Coverage, 6318,
     /* 1667300 */     GIR_EraseRootFromParent_Done,
     /* 1667301 */   // Label 22883: @1667301
     /* 1667301 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1667387), // Rule ID 6319 //
     /* 1667306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1667317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1667320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1667323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1667326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667352 */     // MIs[0] policy
     /* 1667352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667386 */     // GIR_Coverage, 6319,
     /* 1667386 */     GIR_EraseRootFromParent_Done,
     /* 1667387 */   // Label 22884: @1667387
     /* 1667387 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1667473), // Rule ID 6322 //
     /* 1667392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1667403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1667406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1667409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1667412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667438 */     // MIs[0] policy
     /* 1667438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667472 */     // GIR_Coverage, 6322,
     /* 1667472 */     GIR_EraseRootFromParent_Done,
     /* 1667473 */   // Label 22885: @1667473
     /* 1667473 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1667559), // Rule ID 6323 //
     /* 1667478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1667489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1667492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1667495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1667498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667524 */     // MIs[0] policy
     /* 1667524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667558 */     // GIR_Coverage, 6323,
     /* 1667558 */     GIR_EraseRootFromParent_Done,
     /* 1667559 */   // Label 22886: @1667559
     /* 1667559 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1667645), // Rule ID 6326 //
     /* 1667564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1667575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1667578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1667581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1667584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667610 */     // MIs[0] policy
     /* 1667610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667644 */     // GIR_Coverage, 6326,
     /* 1667644 */     GIR_EraseRootFromParent_Done,
     /* 1667645 */   // Label 22887: @1667645
     /* 1667645 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1667731), // Rule ID 6327 //
     /* 1667650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1667661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1667664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1667667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1667670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667696 */     // MIs[0] policy
     /* 1667696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667730 */     // GIR_Coverage, 6327,
     /* 1667730 */     GIR_EraseRootFromParent_Done,
     /* 1667731 */   // Label 22888: @1667731
     /* 1667731 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1667817), // Rule ID 6330 //
     /* 1667736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1667739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1667756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667782 */     // MIs[0] policy
     /* 1667782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667816 */     // GIR_Coverage, 6330,
     /* 1667816 */     GIR_EraseRootFromParent_Done,
     /* 1667817 */   // Label 22889: @1667817
     /* 1667817 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1667903), // Rule ID 6331 //
     /* 1667822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1667825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1667842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667868 */     // MIs[0] policy
     /* 1667868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1667881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667902 */     // GIR_Coverage, 6331,
     /* 1667902 */     GIR_EraseRootFromParent_Done,
     /* 1667903 */   // Label 22890: @1667903
     /* 1667903 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1667989), // Rule ID 6334 //
     /* 1667908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1667919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1667922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1667925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1667928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667954 */     // MIs[0] policy
     /* 1667954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1667967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667988 */     // GIR_Coverage, 6334,
     /* 1667988 */     GIR_EraseRootFromParent_Done,
     /* 1667989 */   // Label 22891: @1667989
     /* 1667989 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1668075), // Rule ID 6335 //
     /* 1667994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1668005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1668008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1668011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1668014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668040 */     // MIs[0] policy
     /* 1668040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1668053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668074 */     // GIR_Coverage, 6335,
     /* 1668074 */     GIR_EraseRootFromParent_Done,
     /* 1668075 */   // Label 22892: @1668075
     /* 1668075 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1668161), // Rule ID 6338 //
     /* 1668080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1668091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1668094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1668097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1668100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668126 */     // MIs[0] policy
     /* 1668126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1668139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668160 */     // GIR_Coverage, 6338,
     /* 1668160 */     GIR_EraseRootFromParent_Done,
     /* 1668161 */   // Label 22893: @1668161
     /* 1668161 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1668247), // Rule ID 6339 //
     /* 1668166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1668177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1668180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1668183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1668186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668212 */     // MIs[0] policy
     /* 1668212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1668225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668246 */     // GIR_Coverage, 6339,
     /* 1668246 */     GIR_EraseRootFromParent_Done,
     /* 1668247 */   // Label 22894: @1668247
     /* 1668247 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1668333), // Rule ID 6342 //
     /* 1668252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1668263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1668266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1668269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1668272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1668275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668298 */     // MIs[0] policy
     /* 1668298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1668311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668332 */     // GIR_Coverage, 6342,
     /* 1668332 */     GIR_EraseRootFromParent_Done,
     /* 1668333 */   // Label 22895: @1668333
     /* 1668333 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1668419), // Rule ID 6343 //
     /* 1668338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1668349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1668352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1668355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1668358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1668361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668384 */     // MIs[0] policy
     /* 1668384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1668397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668418 */     // GIR_Coverage, 6343,
     /* 1668418 */     GIR_EraseRootFromParent_Done,
     /* 1668419 */   // Label 22896: @1668419
     /* 1668419 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1668505), // Rule ID 6346 //
     /* 1668424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1668435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1668438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1668441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1668444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668470 */     // MIs[0] policy
     /* 1668470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1668483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668504 */     // GIR_Coverage, 6346,
     /* 1668504 */     GIR_EraseRootFromParent_Done,
     /* 1668505 */   // Label 22897: @1668505
     /* 1668505 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1668591), // Rule ID 6347 //
     /* 1668510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1668521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1668524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1668527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1668530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668556 */     // MIs[0] policy
     /* 1668556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1668569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668590 */     // GIR_Coverage, 6347,
     /* 1668590 */     GIR_EraseRootFromParent_Done,
     /* 1668591 */   // Label 22898: @1668591
     /* 1668591 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1668677), // Rule ID 6350 //
     /* 1668596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1668607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1668610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1668613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1668616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668642 */     // MIs[0] policy
     /* 1668642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1668655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668676 */     // GIR_Coverage, 6350,
     /* 1668676 */     GIR_EraseRootFromParent_Done,
     /* 1668677 */   // Label 22899: @1668677
     /* 1668677 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1668763), // Rule ID 6351 //
     /* 1668682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1668693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1668696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1668699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1668702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668728 */     // MIs[0] policy
     /* 1668728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1668741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668762 */     // GIR_Coverage, 6351,
     /* 1668762 */     GIR_EraseRootFromParent_Done,
     /* 1668763 */   // Label 22900: @1668763
     /* 1668763 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1668849), // Rule ID 6354 //
     /* 1668768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1668779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1668782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1668785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1668788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668814 */     // MIs[0] policy
     /* 1668814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1668827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668848 */     // GIR_Coverage, 6354,
     /* 1668848 */     GIR_EraseRootFromParent_Done,
     /* 1668849 */   // Label 22901: @1668849
     /* 1668849 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1668935), // Rule ID 6355 //
     /* 1668854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1668865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1668868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1668871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1668874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668900 */     // MIs[0] policy
     /* 1668900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1668913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668934 */     // GIR_Coverage, 6355,
     /* 1668934 */     GIR_EraseRootFromParent_Done,
     /* 1668935 */   // Label 22902: @1668935
     /* 1668935 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1669021), // Rule ID 6358 //
     /* 1668940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1668951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1668954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1668957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1668960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668986 */     // MIs[0] policy
     /* 1668986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1668999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669020 */     // GIR_Coverage, 6358,
     /* 1669020 */     GIR_EraseRootFromParent_Done,
     /* 1669021 */   // Label 22903: @1669021
     /* 1669021 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1669107), // Rule ID 6359 //
     /* 1669026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1669037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1669040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1669043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1669046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1669056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669072 */     // MIs[0] policy
     /* 1669072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1669085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669106 */     // GIR_Coverage, 6359,
     /* 1669106 */     GIR_EraseRootFromParent_Done,
     /* 1669107 */   // Label 22904: @1669107
     /* 1669107 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1669193), // Rule ID 6362 //
     /* 1669112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1669123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1669126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1669129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1669132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669158 */     // MIs[0] policy
     /* 1669158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1669171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669192 */     // GIR_Coverage, 6362,
     /* 1669192 */     GIR_EraseRootFromParent_Done,
     /* 1669193 */   // Label 22905: @1669193
     /* 1669193 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1669279), // Rule ID 6363 //
     /* 1669198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1669209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1669212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1669215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1669218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669244 */     // MIs[0] policy
     /* 1669244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1669257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669278 */     // GIR_Coverage, 6363,
     /* 1669278 */     GIR_EraseRootFromParent_Done,
     /* 1669279 */   // Label 22906: @1669279
     /* 1669279 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1669365), // Rule ID 6366 //
     /* 1669284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1669295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1669298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1669301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1669304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1669307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669330 */     // MIs[0] policy
     /* 1669330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1669343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669364 */     // GIR_Coverage, 6366,
     /* 1669364 */     GIR_EraseRootFromParent_Done,
     /* 1669365 */   // Label 22907: @1669365
     /* 1669365 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1669451), // Rule ID 6367 //
     /* 1669370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1669381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1669384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1669387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1669390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1669393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669416 */     // MIs[0] policy
     /* 1669416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1669429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669450 */     // GIR_Coverage, 6367,
     /* 1669450 */     GIR_EraseRootFromParent_Done,
     /* 1669451 */   // Label 22908: @1669451
     /* 1669451 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1669537), // Rule ID 6370 //
     /* 1669456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1669467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1669470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1669473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1669476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1669486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669502 */     // MIs[0] policy
     /* 1669502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1669515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669536 */     // GIR_Coverage, 6370,
     /* 1669536 */     GIR_EraseRootFromParent_Done,
     /* 1669537 */   // Label 22909: @1669537
     /* 1669537 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1669623), // Rule ID 6371 //
     /* 1669542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1669545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1669553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1669556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1669559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1669562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1669572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669588 */     // MIs[0] policy
     /* 1669588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1669601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669622 */     // GIR_Coverage, 6371,
     /* 1669622 */     GIR_EraseRootFromParent_Done,
     /* 1669623 */   // Label 22910: @1669623
     /* 1669623 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1669709), // Rule ID 6374 //
     /* 1669628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1669639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1669642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1669645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1669648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669674 */     // MIs[0] policy
     /* 1669674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1669687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669708 */     // GIR_Coverage, 6374,
     /* 1669708 */     GIR_EraseRootFromParent_Done,
     /* 1669709 */   // Label 22911: @1669709
     /* 1669709 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1669795), // Rule ID 6375 //
     /* 1669714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1669717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1669725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1669728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1669731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1669734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669760 */     // MIs[0] policy
     /* 1669760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1669773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669794 */     // GIR_Coverage, 6375,
     /* 1669794 */     GIR_EraseRootFromParent_Done,
     /* 1669795 */   // Label 22912: @1669795
     /* 1669795 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1669881), // Rule ID 6378 //
     /* 1669800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1669811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1669814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1669817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1669820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669846 */     // MIs[0] policy
     /* 1669846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1669859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669880 */     // GIR_Coverage, 6378,
     /* 1669880 */     GIR_EraseRootFromParent_Done,
     /* 1669881 */   // Label 22913: @1669881
     /* 1669881 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1669967), // Rule ID 6379 //
     /* 1669886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1669889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1669897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1669900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1669903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1669906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669932 */     // MIs[0] policy
     /* 1669932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1669945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669966 */     // GIR_Coverage, 6379,
     /* 1669966 */     GIR_EraseRootFromParent_Done,
     /* 1669967 */   // Label 22914: @1669967
     /* 1669967 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1670053), // Rule ID 6382 //
     /* 1669972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1669983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1669986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1669989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670018 */     // MIs[0] policy
     /* 1670018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1670031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670052 */     // GIR_Coverage, 6382,
     /* 1670052 */     GIR_EraseRootFromParent_Done,
     /* 1670053 */   // Label 22915: @1670053
     /* 1670053 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1670139), // Rule ID 6383 //
     /* 1670058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1670069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1670072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1670075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670104 */     // MIs[0] policy
     /* 1670104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1670117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670138 */     // GIR_Coverage, 6383,
     /* 1670138 */     GIR_EraseRootFromParent_Done,
     /* 1670139 */   // Label 22916: @1670139
     /* 1670139 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1670225), // Rule ID 6386 //
     /* 1670144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1670155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1670158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1670161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670190 */     // MIs[0] policy
     /* 1670190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1670203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670224 */     // GIR_Coverage, 6386,
     /* 1670224 */     GIR_EraseRootFromParent_Done,
     /* 1670225 */   // Label 22917: @1670225
     /* 1670225 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1670311), // Rule ID 6387 //
     /* 1670230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1670241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1670244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1670247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670276 */     // MIs[0] policy
     /* 1670276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1670289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670310 */     // GIR_Coverage, 6387,
     /* 1670310 */     GIR_EraseRootFromParent_Done,
     /* 1670311 */   // Label 22918: @1670311
     /* 1670311 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1670397), // Rule ID 6390 //
     /* 1670316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1670327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1670330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1670333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670362 */     // MIs[0] policy
     /* 1670362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670396 */     // GIR_Coverage, 6390,
     /* 1670396 */     GIR_EraseRootFromParent_Done,
     /* 1670397 */   // Label 22919: @1670397
     /* 1670397 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1670483), // Rule ID 6391 //
     /* 1670402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1670413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1670416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1670419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670448 */     // MIs[0] policy
     /* 1670448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670482 */     // GIR_Coverage, 6391,
     /* 1670482 */     GIR_EraseRootFromParent_Done,
     /* 1670483 */   // Label 22920: @1670483
     /* 1670483 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1670569), // Rule ID 6394 //
     /* 1670488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1670499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1670502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1670505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670534 */     // MIs[0] policy
     /* 1670534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1670547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670568 */     // GIR_Coverage, 6394,
     /* 1670568 */     GIR_EraseRootFromParent_Done,
     /* 1670569 */   // Label 22921: @1670569
     /* 1670569 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1670655), // Rule ID 6395 //
     /* 1670574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1670585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1670588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1670591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670620 */     // MIs[0] policy
     /* 1670620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1670633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670654 */     // GIR_Coverage, 6395,
     /* 1670654 */     GIR_EraseRootFromParent_Done,
     /* 1670655 */   // Label 22922: @1670655
     /* 1670655 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1670741), // Rule ID 6398 //
     /* 1670660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1670671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1670674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1670677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670706 */     // MIs[0] policy
     /* 1670706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670740 */     // GIR_Coverage, 6398,
     /* 1670740 */     GIR_EraseRootFromParent_Done,
     /* 1670741 */   // Label 22923: @1670741
     /* 1670741 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1670827), // Rule ID 6399 //
     /* 1670746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1670757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1670760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1670763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670792 */     // MIs[0] policy
     /* 1670792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670826 */     // GIR_Coverage, 6399,
     /* 1670826 */     GIR_EraseRootFromParent_Done,
     /* 1670827 */   // Label 22924: @1670827
     /* 1670827 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1670913), // Rule ID 6402 //
     /* 1670832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1670843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1670846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1670849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1670852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670878 */     // MIs[0] policy
     /* 1670878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670912 */     // GIR_Coverage, 6402,
     /* 1670912 */     GIR_EraseRootFromParent_Done,
     /* 1670913 */   // Label 22925: @1670913
     /* 1670913 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1670999), // Rule ID 6403 //
     /* 1670918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1670929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1670932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1670935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1670938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1670960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670964 */     // MIs[0] policy
     /* 1670964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1670977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670998 */     // GIR_Coverage, 6403,
     /* 1670998 */     GIR_EraseRootFromParent_Done,
     /* 1670999 */   // Label 22926: @1670999
     /* 1670999 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1671085), // Rule ID 6406 //
     /* 1671004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1671015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1671018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1671021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671050 */     // MIs[0] policy
     /* 1671050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671084 */     // GIR_Coverage, 6406,
     /* 1671084 */     GIR_EraseRootFromParent_Done,
     /* 1671085 */   // Label 22927: @1671085
     /* 1671085 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1671171), // Rule ID 6407 //
     /* 1671090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1671101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1671104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1671107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671136 */     // MIs[0] policy
     /* 1671136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11615:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671170 */     // GIR_Coverage, 6407,
     /* 1671170 */     GIR_EraseRootFromParent_Done,
     /* 1671171 */   // Label 22928: @1671171
     /* 1671171 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1671257), // Rule ID 6410 //
     /* 1671176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1671187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1671190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1671193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671222 */     // MIs[0] policy
     /* 1671222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671256 */     // GIR_Coverage, 6410,
     /* 1671256 */     GIR_EraseRootFromParent_Done,
     /* 1671257 */   // Label 22929: @1671257
     /* 1671257 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1671343), // Rule ID 6411 //
     /* 1671262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1671273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1671276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1671279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671308 */     // MIs[0] policy
     /* 1671308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11615:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671342 */     // GIR_Coverage, 6411,
     /* 1671342 */     GIR_EraseRootFromParent_Done,
     /* 1671343 */   // Label 22930: @1671343
     /* 1671343 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1671429), // Rule ID 6414 //
     /* 1671348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1671359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1671362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1671365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671394 */     // MIs[0] policy
     /* 1671394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671428 */     // GIR_Coverage, 6414,
     /* 1671428 */     GIR_EraseRootFromParent_Done,
     /* 1671429 */   // Label 22931: @1671429
     /* 1671429 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1671515), // Rule ID 6415 //
     /* 1671434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1671445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1671448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1671451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671480 */     // MIs[0] policy
     /* 1671480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11615:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671514 */     // GIR_Coverage, 6415,
     /* 1671514 */     GIR_EraseRootFromParent_Done,
     /* 1671515 */   // Label 22932: @1671515
     /* 1671515 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1671601), // Rule ID 6418 //
     /* 1671520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1671531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1671534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1671537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1671543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671566 */     // MIs[0] policy
     /* 1671566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671600 */     // GIR_Coverage, 6418,
     /* 1671600 */     GIR_EraseRootFromParent_Done,
     /* 1671601 */   // Label 22933: @1671601
     /* 1671601 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1671687), // Rule ID 6419 //
     /* 1671606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1671617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1671620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1671623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1671629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671652 */     // MIs[0] policy
     /* 1671652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11615:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1671665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671686 */     // GIR_Coverage, 6419,
     /* 1671686 */     GIR_EraseRootFromParent_Done,
     /* 1671687 */   // Label 22934: @1671687
     /* 1671687 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1671773), // Rule ID 6422 //
     /* 1671692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1671703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1671706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1671709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671738 */     // MIs[0] policy
     /* 1671738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1671751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671772 */     // GIR_Coverage, 6422,
     /* 1671772 */     GIR_EraseRootFromParent_Done,
     /* 1671773 */   // Label 22935: @1671773
     /* 1671773 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1671859), // Rule ID 6423 //
     /* 1671778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1671789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1671792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1671795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671824 */     // MIs[0] policy
     /* 1671824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1671837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671858 */     // GIR_Coverage, 6423,
     /* 1671858 */     GIR_EraseRootFromParent_Done,
     /* 1671859 */   // Label 22936: @1671859
     /* 1671859 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1671945), // Rule ID 6426 //
     /* 1671864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1671875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1671878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1671881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1671884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671910 */     // MIs[0] policy
     /* 1671910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1671923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671944 */     // GIR_Coverage, 6426,
     /* 1671944 */     GIR_EraseRootFromParent_Done,
     /* 1671945 */   // Label 22937: @1671945
     /* 1671945 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1672031), // Rule ID 6427 //
     /* 1671950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1671961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1671964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1671967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1671970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1671992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671996 */     // MIs[0] policy
     /* 1671996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1672009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672030 */     // GIR_Coverage, 6427,
     /* 1672030 */     GIR_EraseRootFromParent_Done,
     /* 1672031 */   // Label 22938: @1672031
     /* 1672031 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1672117), // Rule ID 6430 //
     /* 1672036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1672047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1672050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1672053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1672059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672082 */     // MIs[0] policy
     /* 1672082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1672095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672116 */     // GIR_Coverage, 6430,
     /* 1672116 */     GIR_EraseRootFromParent_Done,
     /* 1672117 */   // Label 22939: @1672117
     /* 1672117 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1672203), // Rule ID 6431 //
     /* 1672122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1672133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1672136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1672139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1672145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672168 */     // MIs[0] policy
     /* 1672168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1672181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672202 */     // GIR_Coverage, 6431,
     /* 1672202 */     GIR_EraseRootFromParent_Done,
     /* 1672203 */   // Label 22940: @1672203
     /* 1672203 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1672289), // Rule ID 6434 //
     /* 1672208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1672219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1672222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1672225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672254 */     // MIs[0] policy
     /* 1672254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1672267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672288 */     // GIR_Coverage, 6434,
     /* 1672288 */     GIR_EraseRootFromParent_Done,
     /* 1672289 */   // Label 22941: @1672289
     /* 1672289 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1672375), // Rule ID 6435 //
     /* 1672294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1672305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1672308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1672311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672340 */     // MIs[0] policy
     /* 1672340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1672353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672374 */     // GIR_Coverage, 6435,
     /* 1672374 */     GIR_EraseRootFromParent_Done,
     /* 1672375 */   // Label 22942: @1672375
     /* 1672375 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1672461), // Rule ID 6438 //
     /* 1672380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1672391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1672394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1672397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672426 */     // MIs[0] policy
     /* 1672426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1672439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672460 */     // GIR_Coverage, 6438,
     /* 1672460 */     GIR_EraseRootFromParent_Done,
     /* 1672461 */   // Label 22943: @1672461
     /* 1672461 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1672547), // Rule ID 6439 //
     /* 1672466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1672477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1672480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1672483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672512 */     // MIs[0] policy
     /* 1672512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1672525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672546 */     // GIR_Coverage, 6439,
     /* 1672546 */     GIR_EraseRootFromParent_Done,
     /* 1672547 */   // Label 22944: @1672547
     /* 1672547 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1672633), // Rule ID 6442 //
     /* 1672552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1672563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1672566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1672569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1672575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672598 */     // MIs[0] policy
     /* 1672598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1672611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672632 */     // GIR_Coverage, 6442,
     /* 1672632 */     GIR_EraseRootFromParent_Done,
     /* 1672633 */   // Label 22945: @1672633
     /* 1672633 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1672719), // Rule ID 6443 //
     /* 1672638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1672649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1672652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1672655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1672661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672684 */     // MIs[0] policy
     /* 1672684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1672697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672718 */     // GIR_Coverage, 6443,
     /* 1672718 */     GIR_EraseRootFromParent_Done,
     /* 1672719 */   // Label 22946: @1672719
     /* 1672719 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1672805), // Rule ID 6446 //
     /* 1672724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1672735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1672738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1672741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672770 */     // MIs[0] policy
     /* 1672770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1672783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672804 */     // GIR_Coverage, 6446,
     /* 1672804 */     GIR_EraseRootFromParent_Done,
     /* 1672805 */   // Label 22947: @1672805
     /* 1672805 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1672891), // Rule ID 6447 //
     /* 1672810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1672821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1672824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1672827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672856 */     // MIs[0] policy
     /* 1672856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1672869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672890 */     // GIR_Coverage, 6447,
     /* 1672890 */     GIR_EraseRootFromParent_Done,
     /* 1672891 */   // Label 22948: @1672891
     /* 1672891 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1672977), // Rule ID 6450 //
     /* 1672896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672942 */     // MIs[0] policy
     /* 1672942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1672955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672976 */     // GIR_Coverage, 6450,
     /* 1672976 */     GIR_EraseRootFromParent_Done,
     /* 1672977 */   // Label 22949: @1672977
     /* 1672977 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1673063), // Rule ID 6451 //
     /* 1672982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1673012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673028 */     // MIs[0] policy
     /* 1673028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1673041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673062 */     // GIR_Coverage, 6451,
     /* 1673062 */     GIR_EraseRootFromParent_Done,
     /* 1673063 */   // Label 22950: @1673063
     /* 1673063 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1673149), // Rule ID 6454 //
     /* 1673068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1673079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1673082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1673085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1673091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673114 */     // MIs[0] policy
     /* 1673114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1673127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673148 */     // GIR_Coverage, 6454,
     /* 1673148 */     GIR_EraseRootFromParent_Done,
     /* 1673149 */   // Label 22951: @1673149
     /* 1673149 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1673235), // Rule ID 6455 //
     /* 1673154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1673165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1673168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1673171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1673177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673200 */     // MIs[0] policy
     /* 1673200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1673213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673234 */     // GIR_Coverage, 6455,
     /* 1673234 */     GIR_EraseRootFromParent_Done,
     /* 1673235 */   // Label 22952: @1673235
     /* 1673235 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1673321), // Rule ID 6458 //
     /* 1673240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1673251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1673254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1673257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1673270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673286 */     // MIs[0] policy
     /* 1673286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1673299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673320 */     // GIR_Coverage, 6458,
     /* 1673320 */     GIR_EraseRootFromParent_Done,
     /* 1673321 */   // Label 22953: @1673321
     /* 1673321 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1673407), // Rule ID 6459 //
     /* 1673326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1673337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1673340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1673343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1673356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673372 */     // MIs[0] policy
     /* 1673372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11615:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1673385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673406 */     // GIR_Coverage, 6459,
     /* 1673406 */     GIR_EraseRootFromParent_Done,
     /* 1673407 */   // Label 22954: @1673407
     /* 1673407 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1673493), // Rule ID 6462 //
     /* 1673412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1673423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1673426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1673429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1673442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673458 */     // MIs[0] policy
     /* 1673458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1673471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673492 */     // GIR_Coverage, 6462,
     /* 1673492 */     GIR_EraseRootFromParent_Done,
     /* 1673493 */   // Label 22955: @1673493
     /* 1673493 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1673579), // Rule ID 6463 //
     /* 1673498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1673509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1673512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1673515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1673528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1673536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673544 */     // MIs[0] policy
     /* 1673544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11615:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1673557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673578 */     // GIR_Coverage, 6463,
     /* 1673578 */     GIR_EraseRootFromParent_Done,
     /* 1673579 */   // Label 22956: @1673579
     /* 1673579 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1673665), // Rule ID 6466 //
     /* 1673584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1673595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1673598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1673601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673630 */     // MIs[0] policy
     /* 1673630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1673643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673664 */     // GIR_Coverage, 6466,
     /* 1673664 */     GIR_EraseRootFromParent_Done,
     /* 1673665 */   // Label 22957: @1673665
     /* 1673665 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1673751), // Rule ID 6467 //
     /* 1673670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1673681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1673684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1673687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673716 */     // MIs[0] policy
     /* 1673716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11615:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1673729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673750 */     // GIR_Coverage, 6467,
     /* 1673750 */     GIR_EraseRootFromParent_Done,
     /* 1673751 */   // Label 22958: @1673751
     /* 1673751 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1673837), // Rule ID 6558 //
     /* 1673756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1673767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1673770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1673773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1673776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673802 */     // MIs[0] policy
     /* 1673802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1673815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673836 */     // GIR_Coverage, 6558,
     /* 1673836 */     GIR_EraseRootFromParent_Done,
     /* 1673837 */   // Label 22959: @1673837
     /* 1673837 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1673923), // Rule ID 6559 //
     /* 1673842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1673853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1673856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1673859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1673862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673888 */     // MIs[0] policy
     /* 1673888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1673901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673922 */     // GIR_Coverage, 6559,
     /* 1673922 */     GIR_EraseRootFromParent_Done,
     /* 1673923 */   // Label 22960: @1673923
     /* 1673923 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1674009), // Rule ID 6562 //
     /* 1673928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1673939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1673942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1673945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1673948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673974 */     // MIs[0] policy
     /* 1673974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1673987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674008 */     // GIR_Coverage, 6562,
     /* 1674008 */     GIR_EraseRootFromParent_Done,
     /* 1674009 */   // Label 22961: @1674009
     /* 1674009 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1674095), // Rule ID 6563 //
     /* 1674014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1674025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1674028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1674031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1674034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674060 */     // MIs[0] policy
     /* 1674060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1674073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674094 */     // GIR_Coverage, 6563,
     /* 1674094 */     GIR_EraseRootFromParent_Done,
     /* 1674095 */   // Label 22962: @1674095
     /* 1674095 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1674181), // Rule ID 6566 //
     /* 1674100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1674111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1674114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1674117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1674120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674146 */     // MIs[0] policy
     /* 1674146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674180 */     // GIR_Coverage, 6566,
     /* 1674180 */     GIR_EraseRootFromParent_Done,
     /* 1674181 */   // Label 22963: @1674181
     /* 1674181 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1674267), // Rule ID 6567 //
     /* 1674186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1674197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1674200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1674203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1674206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674232 */     // MIs[0] policy
     /* 1674232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674242 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674266 */     // GIR_Coverage, 6567,
     /* 1674266 */     GIR_EraseRootFromParent_Done,
     /* 1674267 */   // Label 22964: @1674267
     /* 1674267 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1674353), // Rule ID 6570 //
     /* 1674272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1674283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1674286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1674289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1674292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674318 */     // MIs[0] policy
     /* 1674318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1674331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674352 */     // GIR_Coverage, 6570,
     /* 1674352 */     GIR_EraseRootFromParent_Done,
     /* 1674353 */   // Label 22965: @1674353
     /* 1674353 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1674439), // Rule ID 6571 //
     /* 1674358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1674369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1674372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1674375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1674378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674404 */     // MIs[0] policy
     /* 1674404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1674417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674438 */     // GIR_Coverage, 6571,
     /* 1674438 */     GIR_EraseRootFromParent_Done,
     /* 1674439 */   // Label 22966: @1674439
     /* 1674439 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1674525), // Rule ID 6574 //
     /* 1674444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1674455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1674458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1674461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1674464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674490 */     // MIs[0] policy
     /* 1674490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674524 */     // GIR_Coverage, 6574,
     /* 1674524 */     GIR_EraseRootFromParent_Done,
     /* 1674525 */   // Label 22967: @1674525
     /* 1674525 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1674611), // Rule ID 6575 //
     /* 1674530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1674541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1674544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1674547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1674550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674576 */     // MIs[0] policy
     /* 1674576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674610 */     // GIR_Coverage, 6575,
     /* 1674610 */     GIR_EraseRootFromParent_Done,
     /* 1674611 */   // Label 22968: @1674611
     /* 1674611 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1674697), // Rule ID 6578 //
     /* 1674616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1674627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1674630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1674633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1674636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674662 */     // MIs[0] policy
     /* 1674662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674696 */     // GIR_Coverage, 6578,
     /* 1674696 */     GIR_EraseRootFromParent_Done,
     /* 1674697 */   // Label 22969: @1674697
     /* 1674697 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1674783), // Rule ID 6579 //
     /* 1674702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1674713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1674716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1674719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1674722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674748 */     // MIs[0] policy
     /* 1674748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1674761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674782 */     // GIR_Coverage, 6579,
     /* 1674782 */     GIR_EraseRootFromParent_Done,
     /* 1674783 */   // Label 22970: @1674783
     /* 1674783 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1674869), // Rule ID 6582 //
     /* 1674788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1674799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1674802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1674805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1674808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674834 */     // MIs[0] policy
     /* 1674834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1674847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674868 */     // GIR_Coverage, 6582,
     /* 1674868 */     GIR_EraseRootFromParent_Done,
     /* 1674869 */   // Label 22971: @1674869
     /* 1674869 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1674955), // Rule ID 6583 //
     /* 1674874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1674885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1674888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1674891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1674894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674920 */     // MIs[0] policy
     /* 1674920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1674933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674954 */     // GIR_Coverage, 6583,
     /* 1674954 */     GIR_EraseRootFromParent_Done,
     /* 1674955 */   // Label 22972: @1674955
     /* 1674955 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1675041), // Rule ID 6586 //
     /* 1674960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1674971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1674974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1674977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1674980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675006 */     // MIs[0] policy
     /* 1675006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675040 */     // GIR_Coverage, 6586,
     /* 1675040 */     GIR_EraseRootFromParent_Done,
     /* 1675041 */   // Label 22973: @1675041
     /* 1675041 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1675127), // Rule ID 6587 //
     /* 1675046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1675057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1675060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1675063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1675066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1675076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675092 */     // MIs[0] policy
     /* 1675092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675126 */     // GIR_Coverage, 6587,
     /* 1675126 */     GIR_EraseRootFromParent_Done,
     /* 1675127 */   // Label 22974: @1675127
     /* 1675127 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1675213), // Rule ID 6590 //
     /* 1675132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1675143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1675146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1675149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1675152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1675162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675178 */     // MIs[0] policy
     /* 1675178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675212 */     // GIR_Coverage, 6590,
     /* 1675212 */     GIR_EraseRootFromParent_Done,
     /* 1675213 */   // Label 22975: @1675213
     /* 1675213 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1675299), // Rule ID 6591 //
     /* 1675218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1675229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1675232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1675235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1675238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1675248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675264 */     // MIs[0] policy
     /* 1675264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675298 */     // GIR_Coverage, 6591,
     /* 1675298 */     GIR_EraseRootFromParent_Done,
     /* 1675299 */   // Label 22976: @1675299
     /* 1675299 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1675385), // Rule ID 6594 //
     /* 1675304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1675315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1675318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1675321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1675324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1675327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1675334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675350 */     // MIs[0] policy
     /* 1675350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675384 */     // GIR_Coverage, 6594,
     /* 1675384 */     GIR_EraseRootFromParent_Done,
     /* 1675385 */   // Label 22977: @1675385
     /* 1675385 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1675471), // Rule ID 6595 //
     /* 1675390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1675401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1675404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1675407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1675410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1675413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1675420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1675432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675436 */     // MIs[0] policy
     /* 1675436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1675449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675470 */     // GIR_Coverage, 6595,
     /* 1675470 */     GIR_EraseRootFromParent_Done,
     /* 1675471 */   // Label 22978: @1675471
     /* 1675471 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1675557), // Rule ID 6598 //
     /* 1675476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1675487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1675490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1675493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1675496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675522 */     // MIs[0] policy
     /* 1675522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1675535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675556 */     // GIR_Coverage, 6598,
     /* 1675556 */     GIR_EraseRootFromParent_Done,
     /* 1675557 */   // Label 22979: @1675557
     /* 1675557 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1675643), // Rule ID 6599 //
     /* 1675562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1675573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1675576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1675579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1675582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675608 */     // MIs[0] policy
     /* 1675608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1675621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675642 */     // GIR_Coverage, 6599,
     /* 1675642 */     GIR_EraseRootFromParent_Done,
     /* 1675643 */   // Label 22980: @1675643
     /* 1675643 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1675729), // Rule ID 6602 //
     /* 1675648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1675659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1675662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1675665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1675668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675694 */     // MIs[0] policy
     /* 1675694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1675707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675728 */     // GIR_Coverage, 6602,
     /* 1675728 */     GIR_EraseRootFromParent_Done,
     /* 1675729 */   // Label 22981: @1675729
     /* 1675729 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1675815), // Rule ID 6603 //
     /* 1675734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1675745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1675748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1675751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1675754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675780 */     // MIs[0] policy
     /* 1675780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1675793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675814 */     // GIR_Coverage, 6603,
     /* 1675814 */     GIR_EraseRootFromParent_Done,
     /* 1675815 */   // Label 22982: @1675815
     /* 1675815 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1675901), // Rule ID 6606 //
     /* 1675820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1675831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1675834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1675837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1675840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1675843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675866 */     // MIs[0] policy
     /* 1675866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1675879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675900 */     // GIR_Coverage, 6606,
     /* 1675900 */     GIR_EraseRootFromParent_Done,
     /* 1675901 */   // Label 22983: @1675901
     /* 1675901 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1675987), // Rule ID 6607 //
     /* 1675906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1675917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1675920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1675923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1675926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1675929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675952 */     // MIs[0] policy
     /* 1675952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675962 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1675965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675986 */     // GIR_Coverage, 6607,
     /* 1675986 */     GIR_EraseRootFromParent_Done,
     /* 1675987 */   // Label 22984: @1675987
     /* 1675987 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1676073), // Rule ID 6610 //
     /* 1675992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1676003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1676006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1676009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1676012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676038 */     // MIs[0] policy
     /* 1676038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1676051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676072 */     // GIR_Coverage, 6610,
     /* 1676072 */     GIR_EraseRootFromParent_Done,
     /* 1676073 */   // Label 22985: @1676073
     /* 1676073 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1676159), // Rule ID 6611 //
     /* 1676078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1676089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1676092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1676095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1676098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676124 */     // MIs[0] policy
     /* 1676124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1676137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676158 */     // GIR_Coverage, 6611,
     /* 1676158 */     GIR_EraseRootFromParent_Done,
     /* 1676159 */   // Label 22986: @1676159
     /* 1676159 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1676245), // Rule ID 6614 //
     /* 1676164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1676175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1676178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1676181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1676184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676210 */     // MIs[0] policy
     /* 1676210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1676223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676244 */     // GIR_Coverage, 6614,
     /* 1676244 */     GIR_EraseRootFromParent_Done,
     /* 1676245 */   // Label 22987: @1676245
     /* 1676245 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1676331), // Rule ID 6615 //
     /* 1676250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1676261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1676264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1676267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1676270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676296 */     // MIs[0] policy
     /* 1676296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1676309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676330 */     // GIR_Coverage, 6615,
     /* 1676330 */     GIR_EraseRootFromParent_Done,
     /* 1676331 */   // Label 22988: @1676331
     /* 1676331 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1676417), // Rule ID 6618 //
     /* 1676336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1676347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1676350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1676353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1676356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1676359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676382 */     // MIs[0] policy
     /* 1676382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1676395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676416 */     // GIR_Coverage, 6618,
     /* 1676416 */     GIR_EraseRootFromParent_Done,
     /* 1676417 */   // Label 22989: @1676417
     /* 1676417 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1676503), // Rule ID 6619 //
     /* 1676422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1676433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1676436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1676439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1676442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1676445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676468 */     // MIs[0] policy
     /* 1676468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1676481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676502 */     // GIR_Coverage, 6619,
     /* 1676502 */     GIR_EraseRootFromParent_Done,
     /* 1676503 */   // Label 22990: @1676503
     /* 1676503 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1676589), // Rule ID 6622 //
     /* 1676508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1676519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1676522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1676525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1676528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676554 */     // MIs[0] policy
     /* 1676554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1676567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676588 */     // GIR_Coverage, 6622,
     /* 1676588 */     GIR_EraseRootFromParent_Done,
     /* 1676589 */   // Label 22991: @1676589
     /* 1676589 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1676675), // Rule ID 6623 //
     /* 1676594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1676605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1676608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1676611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1676614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676640 */     // MIs[0] policy
     /* 1676640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1676653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676674 */     // GIR_Coverage, 6623,
     /* 1676674 */     GIR_EraseRootFromParent_Done,
     /* 1676675 */   // Label 22992: @1676675
     /* 1676675 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1676761), // Rule ID 6626 //
     /* 1676680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1676691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1676694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1676697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1676700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676726 */     // MIs[0] policy
     /* 1676726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1676739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676760 */     // GIR_Coverage, 6626,
     /* 1676760 */     GIR_EraseRootFromParent_Done,
     /* 1676761 */   // Label 22993: @1676761
     /* 1676761 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1676847), // Rule ID 6627 //
     /* 1676766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1676777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1676780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1676783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1676786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676812 */     // MIs[0] policy
     /* 1676812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1676825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676846 */     // GIR_Coverage, 6627,
     /* 1676846 */     GIR_EraseRootFromParent_Done,
     /* 1676847 */   // Label 22994: @1676847
     /* 1676847 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1676933), // Rule ID 6630 //
     /* 1676852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1676863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1676866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1676869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1676872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676898 */     // MIs[0] policy
     /* 1676898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1676911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676932 */     // GIR_Coverage, 6630,
     /* 1676932 */     GIR_EraseRootFromParent_Done,
     /* 1676933 */   // Label 22995: @1676933
     /* 1676933 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1677019), // Rule ID 6631 //
     /* 1676938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1676949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1676952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1676955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1676958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676984 */     // MIs[0] policy
     /* 1676984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1676997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677018 */     // GIR_Coverage, 6631,
     /* 1677018 */     GIR_EraseRootFromParent_Done,
     /* 1677019 */   // Label 22996: @1677019
     /* 1677019 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1677105), // Rule ID 6634 //
     /* 1677024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1677035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1677038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1677041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1677044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677070 */     // MIs[0] policy
     /* 1677070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677104 */     // GIR_Coverage, 6634,
     /* 1677104 */     GIR_EraseRootFromParent_Done,
     /* 1677105 */   // Label 22997: @1677105
     /* 1677105 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1677191), // Rule ID 6635 //
     /* 1677110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1677121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1677124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1677127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1677130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677156 */     // MIs[0] policy
     /* 1677156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677190 */     // GIR_Coverage, 6635,
     /* 1677190 */     GIR_EraseRootFromParent_Done,
     /* 1677191 */   // Label 22998: @1677191
     /* 1677191 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1677277), // Rule ID 6638 //
     /* 1677196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1677207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1677210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1677213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1677216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677242 */     // MIs[0] policy
     /* 1677242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1677255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677276 */     // GIR_Coverage, 6638,
     /* 1677276 */     GIR_EraseRootFromParent_Done,
     /* 1677277 */   // Label 22999: @1677277
     /* 1677277 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1677363), // Rule ID 6639 //
     /* 1677282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1677293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1677296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1677299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1677302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677328 */     // MIs[0] policy
     /* 1677328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1677341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677362 */     // GIR_Coverage, 6639,
     /* 1677362 */     GIR_EraseRootFromParent_Done,
     /* 1677363 */   // Label 23000: @1677363
     /* 1677363 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1677449), // Rule ID 6642 //
     /* 1677368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1677379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1677382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1677385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1677388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1677398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677414 */     // MIs[0] policy
     /* 1677414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1677427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677448 */     // GIR_Coverage, 6642,
     /* 1677448 */     GIR_EraseRootFromParent_Done,
     /* 1677449 */   // Label 23001: @1677449
     /* 1677449 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1677535), // Rule ID 6643 //
     /* 1677454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1677465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1677468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1677471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1677474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1677484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1677496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677500 */     // MIs[0] policy
     /* 1677500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1677513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677534 */     // GIR_Coverage, 6643,
     /* 1677534 */     GIR_EraseRootFromParent_Done,
     /* 1677535 */   // Label 23002: @1677535
     /* 1677535 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1677621), // Rule ID 6646 //
     /* 1677540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1677551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1677554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1677557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677586 */     // MIs[0] policy
     /* 1677586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1677599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677620 */     // GIR_Coverage, 6646,
     /* 1677620 */     GIR_EraseRootFromParent_Done,
     /* 1677621 */   // Label 23003: @1677621
     /* 1677621 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1677707), // Rule ID 6647 //
     /* 1677626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1677637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1677640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1677643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677672 */     // MIs[0] policy
     /* 1677672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1677685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677706 */     // GIR_Coverage, 6647,
     /* 1677706 */     GIR_EraseRootFromParent_Done,
     /* 1677707 */   // Label 23004: @1677707
     /* 1677707 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1677793), // Rule ID 6650 //
     /* 1677712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1677723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1677726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1677729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677758 */     // MIs[0] policy
     /* 1677758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1677771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677792 */     // GIR_Coverage, 6650,
     /* 1677792 */     GIR_EraseRootFromParent_Done,
     /* 1677793 */   // Label 23005: @1677793
     /* 1677793 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1677879), // Rule ID 6651 //
     /* 1677798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1677809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1677812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1677815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677844 */     // MIs[0] policy
     /* 1677844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1677857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677878 */     // GIR_Coverage, 6651,
     /* 1677878 */     GIR_EraseRootFromParent_Done,
     /* 1677879 */   // Label 23006: @1677879
     /* 1677879 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1677965), // Rule ID 6654 //
     /* 1677884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1677904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1677926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677930 */     // MIs[0] policy
     /* 1677930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1677943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677964 */     // GIR_Coverage, 6654,
     /* 1677964 */     GIR_EraseRootFromParent_Done,
     /* 1677965 */   // Label 23007: @1677965
     /* 1677965 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1678051), // Rule ID 6655 //
     /* 1677970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1677990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678016 */     // MIs[0] policy
     /* 1678016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1678029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678050 */     // GIR_Coverage, 6655,
     /* 1678050 */     GIR_EraseRootFromParent_Done,
     /* 1678051 */   // Label 23008: @1678051
     /* 1678051 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1678137), // Rule ID 6658 //
     /* 1678056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1678067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1678070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1678073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678102 */     // MIs[0] policy
     /* 1678102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1678115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678136 */     // GIR_Coverage, 6658,
     /* 1678136 */     GIR_EraseRootFromParent_Done,
     /* 1678137 */   // Label 23009: @1678137
     /* 1678137 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1678223), // Rule ID 6659 //
     /* 1678142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1678153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1678156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1678159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678188 */     // MIs[0] policy
     /* 1678188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1678201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678222 */     // GIR_Coverage, 6659,
     /* 1678222 */     GIR_EraseRootFromParent_Done,
     /* 1678223 */   // Label 23010: @1678223
     /* 1678223 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1678309), // Rule ID 6662 //
     /* 1678228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1678239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1678242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1678245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678274 */     // MIs[0] policy
     /* 1678274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1678287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678308 */     // GIR_Coverage, 6662,
     /* 1678308 */     GIR_EraseRootFromParent_Done,
     /* 1678309 */   // Label 23011: @1678309
     /* 1678309 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1678395), // Rule ID 6663 //
     /* 1678314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1678325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1678328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1678331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678360 */     // MIs[0] policy
     /* 1678360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1678373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678394 */     // GIR_Coverage, 6663,
     /* 1678394 */     GIR_EraseRootFromParent_Done,
     /* 1678395 */   // Label 23012: @1678395
     /* 1678395 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1678481), // Rule ID 6666 //
     /* 1678400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1678411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1678414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1678417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678446 */     // MIs[0] policy
     /* 1678446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1678459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678480 */     // GIR_Coverage, 6666,
     /* 1678480 */     GIR_EraseRootFromParent_Done,
     /* 1678481 */   // Label 23013: @1678481
     /* 1678481 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1678567), // Rule ID 6667 //
     /* 1678486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1678497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1678500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1678503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678532 */     // MIs[0] policy
     /* 1678532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1678545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678566 */     // GIR_Coverage, 6667,
     /* 1678566 */     GIR_EraseRootFromParent_Done,
     /* 1678567 */   // Label 23014: @1678567
     /* 1678567 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1678653), // Rule ID 6670 //
     /* 1678572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1678583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1678586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1678589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678618 */     // MIs[0] policy
     /* 1678618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1678631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678652 */     // GIR_Coverage, 6670,
     /* 1678652 */     GIR_EraseRootFromParent_Done,
     /* 1678653 */   // Label 23015: @1678653
     /* 1678653 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1678739), // Rule ID 6671 //
     /* 1678658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1678669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1678672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1678675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678704 */     // MIs[0] policy
     /* 1678704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1678717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678738 */     // GIR_Coverage, 6671,
     /* 1678738 */     GIR_EraseRootFromParent_Done,
     /* 1678739 */   // Label 23016: @1678739
     /* 1678739 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1678825), // Rule ID 6674 //
     /* 1678744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1678755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1678758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1678761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678790 */     // MIs[0] policy
     /* 1678790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1678803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678824 */     // GIR_Coverage, 6674,
     /* 1678824 */     GIR_EraseRootFromParent_Done,
     /* 1678825 */   // Label 23017: @1678825
     /* 1678825 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1678911), // Rule ID 6675 //
     /* 1678830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1678841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1678844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1678847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1678850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678876 */     // MIs[0] policy
     /* 1678876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1678889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678910 */     // GIR_Coverage, 6675,
     /* 1678910 */     GIR_EraseRootFromParent_Done,
     /* 1678911 */   // Label 23018: @1678911
     /* 1678911 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1678997), // Rule ID 6678 //
     /* 1678916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1678927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1678930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1678933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1678936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1678958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678962 */     // MIs[0] policy
     /* 1678962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1678975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678996 */     // GIR_Coverage, 6678,
     /* 1678996 */     GIR_EraseRootFromParent_Done,
     /* 1678997 */   // Label 23019: @1678997
     /* 1678997 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1679083), // Rule ID 6679 //
     /* 1679002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1679013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1679016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1679019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679048 */     // MIs[0] policy
     /* 1679048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1679061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679082 */     // GIR_Coverage, 6679,
     /* 1679082 */     GIR_EraseRootFromParent_Done,
     /* 1679083 */   // Label 23020: @1679083
     /* 1679083 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1679169), // Rule ID 6682 //
     /* 1679088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1679099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1679102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1679105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679134 */     // MIs[0] policy
     /* 1679134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1679147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679168 */     // GIR_Coverage, 6682,
     /* 1679168 */     GIR_EraseRootFromParent_Done,
     /* 1679169 */   // Label 23021: @1679169
     /* 1679169 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1679255), // Rule ID 6683 //
     /* 1679174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1679185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1679188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1679191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679220 */     // MIs[0] policy
     /* 1679220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1679233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679254 */     // GIR_Coverage, 6683,
     /* 1679254 */     GIR_EraseRootFromParent_Done,
     /* 1679255 */   // Label 23022: @1679255
     /* 1679255 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1679341), // Rule ID 6686 //
     /* 1679260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1679271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1679274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1679277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679306 */     // MIs[0] policy
     /* 1679306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1679319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679340 */     // GIR_Coverage, 6686,
     /* 1679340 */     GIR_EraseRootFromParent_Done,
     /* 1679341 */   // Label 23023: @1679341
     /* 1679341 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1679427), // Rule ID 6687 //
     /* 1679346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1679357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1679360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1679363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679392 */     // MIs[0] policy
     /* 1679392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1679405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679426 */     // GIR_Coverage, 6687,
     /* 1679426 */     GIR_EraseRootFromParent_Done,
     /* 1679427 */   // Label 23024: @1679427
     /* 1679427 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1679513), // Rule ID 6690 //
     /* 1679432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1679443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1679446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1679449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679478 */     // MIs[0] policy
     /* 1679478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1679491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679512 */     // GIR_Coverage, 6690,
     /* 1679512 */     GIR_EraseRootFromParent_Done,
     /* 1679513 */   // Label 23025: @1679513
     /* 1679513 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1679599), // Rule ID 6691 //
     /* 1679518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1679529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1679532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1679535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679564 */     // MIs[0] policy
     /* 1679564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1679577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679598 */     // GIR_Coverage, 6691,
     /* 1679598 */     GIR_EraseRootFromParent_Done,
     /* 1679599 */   // Label 23026: @1679599
     /* 1679599 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1679685), // Rule ID 6694 //
     /* 1679604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1679615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1679618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1679621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1679627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679650 */     // MIs[0] policy
     /* 1679650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1679663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679684 */     // GIR_Coverage, 6694,
     /* 1679684 */     GIR_EraseRootFromParent_Done,
     /* 1679685 */   // Label 23027: @1679685
     /* 1679685 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1679771), // Rule ID 6695 //
     /* 1679690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1679701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1679704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1679707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1679713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679736 */     // MIs[0] policy
     /* 1679736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1679749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679770 */     // GIR_Coverage, 6695,
     /* 1679770 */     GIR_EraseRootFromParent_Done,
     /* 1679771 */   // Label 23028: @1679771
     /* 1679771 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1679857), // Rule ID 6698 //
     /* 1679776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1679787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1679790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1679793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679822 */     // MIs[0] policy
     /* 1679822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1679835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679856 */     // GIR_Coverage, 6698,
     /* 1679856 */     GIR_EraseRootFromParent_Done,
     /* 1679857 */   // Label 23029: @1679857
     /* 1679857 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1679943), // Rule ID 6699 //
     /* 1679862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1679873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1679876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1679879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679908 */     // MIs[0] policy
     /* 1679908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1679921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679942 */     // GIR_Coverage, 6699,
     /* 1679942 */     GIR_EraseRootFromParent_Done,
     /* 1679943 */   // Label 23030: @1679943
     /* 1679943 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1680029), // Rule ID 6702 //
     /* 1679948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1679959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1679962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1679965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679994 */     // MIs[0] policy
     /* 1679994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1680007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680028 */     // GIR_Coverage, 6702,
     /* 1680028 */     GIR_EraseRootFromParent_Done,
     /* 1680029 */   // Label 23031: @1680029
     /* 1680029 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1680115), // Rule ID 6703 //
     /* 1680034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1680045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1680048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1680051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1680057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680080 */     // MIs[0] policy
     /* 1680080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1680093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680114 */     // GIR_Coverage, 6703,
     /* 1680114 */     GIR_EraseRootFromParent_Done,
     /* 1680115 */   // Label 23032: @1680115
     /* 1680115 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1680201), // Rule ID 6706 //
     /* 1680120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1680131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1680134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1680137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1680143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680166 */     // MIs[0] policy
     /* 1680166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1680179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680200 */     // GIR_Coverage, 6706,
     /* 1680200 */     GIR_EraseRootFromParent_Done,
     /* 1680201 */   // Label 23033: @1680201
     /* 1680201 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1680287), // Rule ID 6707 //
     /* 1680206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1680217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1680220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1680223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1680229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680252 */     // MIs[0] policy
     /* 1680252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1680265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680286 */     // GIR_Coverage, 6707,
     /* 1680286 */     GIR_EraseRootFromParent_Done,
     /* 1680287 */   // Label 23034: @1680287
     /* 1680287 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1680373), // Rule ID 6710 //
     /* 1680292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1680303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1680306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1680309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680338 */     // MIs[0] policy
     /* 1680338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1680351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680372 */     // GIR_Coverage, 6710,
     /* 1680372 */     GIR_EraseRootFromParent_Done,
     /* 1680373 */   // Label 23035: @1680373
     /* 1680373 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1680459), // Rule ID 6711 //
     /* 1680378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1680389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1680392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1680395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680424 */     // MIs[0] policy
     /* 1680424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1680437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680458 */     // GIR_Coverage, 6711,
     /* 1680458 */     GIR_EraseRootFromParent_Done,
     /* 1680459 */   // Label 23036: @1680459
     /* 1680459 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1680545), // Rule ID 6714 //
     /* 1680464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1680475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1680478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1680481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680510 */     // MIs[0] policy
     /* 1680510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1680523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680544 */     // GIR_Coverage, 6714,
     /* 1680544 */     GIR_EraseRootFromParent_Done,
     /* 1680545 */   // Label 23037: @1680545
     /* 1680545 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1680631), // Rule ID 6715 //
     /* 1680550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1680561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1680564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1680567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680596 */     // MIs[0] policy
     /* 1680596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1680609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680630 */     // GIR_Coverage, 6715,
     /* 1680630 */     GIR_EraseRootFromParent_Done,
     /* 1680631 */   // Label 23038: @1680631
     /* 1680631 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1680717), // Rule ID 6718 //
     /* 1680636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1680647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1680650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1680653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1680659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680682 */     // MIs[0] policy
     /* 1680682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1680695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680716 */     // GIR_Coverage, 6718,
     /* 1680716 */     GIR_EraseRootFromParent_Done,
     /* 1680717 */   // Label 23039: @1680717
     /* 1680717 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1680803), // Rule ID 6719 //
     /* 1680722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1680733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1680736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1680739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1680745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680768 */     // MIs[0] policy
     /* 1680768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1680781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680802 */     // GIR_Coverage, 6719,
     /* 1680802 */     GIR_EraseRootFromParent_Done,
     /* 1680803 */   // Label 23040: @1680803
     /* 1680803 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1680889), // Rule ID 6722 //
     /* 1680808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1680819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1680822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1680825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680854 */     // MIs[0] policy
     /* 1680854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1680867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680888 */     // GIR_Coverage, 6722,
     /* 1680888 */     GIR_EraseRootFromParent_Done,
     /* 1680889 */   // Label 23041: @1680889
     /* 1680889 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1680975), // Rule ID 6723 //
     /* 1680894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1680905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1680908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1680911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680940 */     // MIs[0] policy
     /* 1680940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1680953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680974 */     // GIR_Coverage, 6723,
     /* 1680974 */     GIR_EraseRootFromParent_Done,
     /* 1680975 */   // Label 23042: @1680975
     /* 1680975 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1681061), // Rule ID 6726 //
     /* 1680980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681026 */     // MIs[0] policy
     /* 1681026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681060 */     // GIR_Coverage, 6726,
     /* 1681060 */     GIR_EraseRootFromParent_Done,
     /* 1681061 */   // Label 23043: @1681061
     /* 1681061 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1681147), // Rule ID 6727 //
     /* 1681066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1681077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1681080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1681083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681112 */     // MIs[0] policy
     /* 1681112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681146 */     // GIR_Coverage, 6727,
     /* 1681146 */     GIR_EraseRootFromParent_Done,
     /* 1681147 */   // Label 23044: @1681147
     /* 1681147 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1681233), // Rule ID 6730 //
     /* 1681152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1681163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1681166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1681169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681198 */     // MIs[0] policy
     /* 1681198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681232 */     // GIR_Coverage, 6730,
     /* 1681232 */     GIR_EraseRootFromParent_Done,
     /* 1681233 */   // Label 23045: @1681233
     /* 1681233 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1681319), // Rule ID 6731 //
     /* 1681238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1681249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1681252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1681255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681284 */     // MIs[0] policy
     /* 1681284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681318 */     // GIR_Coverage, 6731,
     /* 1681318 */     GIR_EraseRootFromParent_Done,
     /* 1681319 */   // Label 23046: @1681319
     /* 1681319 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1681405), // Rule ID 6822 //
     /* 1681324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1681335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1681338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1681341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1681344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681370 */     // MIs[0] policy
     /* 1681370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1681383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681404 */     // GIR_Coverage, 6822,
     /* 1681404 */     GIR_EraseRootFromParent_Done,
     /* 1681405 */   // Label 23047: @1681405
     /* 1681405 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1681491), // Rule ID 6823 //
     /* 1681410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1681421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1681424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1681427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1681430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681456 */     // MIs[0] policy
     /* 1681456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1681469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681490 */     // GIR_Coverage, 6823,
     /* 1681490 */     GIR_EraseRootFromParent_Done,
     /* 1681491 */   // Label 23048: @1681491
     /* 1681491 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1681577), // Rule ID 6826 //
     /* 1681496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1681507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1681510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1681513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1681516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681542 */     // MIs[0] policy
     /* 1681542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1681555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681576 */     // GIR_Coverage, 6826,
     /* 1681576 */     GIR_EraseRootFromParent_Done,
     /* 1681577 */   // Label 23049: @1681577
     /* 1681577 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1681663), // Rule ID 6827 //
     /* 1681582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1681593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1681596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1681599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1681602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681628 */     // MIs[0] policy
     /* 1681628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681638 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1681641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681662 */     // GIR_Coverage, 6827,
     /* 1681662 */     GIR_EraseRootFromParent_Done,
     /* 1681663 */   // Label 23050: @1681663
     /* 1681663 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1681749), // Rule ID 6830 //
     /* 1681668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1681679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1681682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1681685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1681688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681714 */     // MIs[0] policy
     /* 1681714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1681727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681748 */     // GIR_Coverage, 6830,
     /* 1681748 */     GIR_EraseRootFromParent_Done,
     /* 1681749 */   // Label 23051: @1681749
     /* 1681749 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1681835), // Rule ID 6831 //
     /* 1681754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1681765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1681768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1681771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1681774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681800 */     // MIs[0] policy
     /* 1681800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1681813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681834 */     // GIR_Coverage, 6831,
     /* 1681834 */     GIR_EraseRootFromParent_Done,
     /* 1681835 */   // Label 23052: @1681835
     /* 1681835 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1681921), // Rule ID 6834 //
     /* 1681840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1681851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1681854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1681857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1681860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681886 */     // MIs[0] policy
     /* 1681886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1681899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681920 */     // GIR_Coverage, 6834,
     /* 1681920 */     GIR_EraseRootFromParent_Done,
     /* 1681921 */   // Label 23053: @1681921
     /* 1681921 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1682007), // Rule ID 6835 //
     /* 1681926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1681937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1681940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1681943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1681946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681972 */     // MIs[0] policy
     /* 1681972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1681985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682006 */     // GIR_Coverage, 6835,
     /* 1682006 */     GIR_EraseRootFromParent_Done,
     /* 1682007 */   // Label 23054: @1682007
     /* 1682007 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1682093), // Rule ID 6838 //
     /* 1682012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1682023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1682026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1682029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1682032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682058 */     // MIs[0] policy
     /* 1682058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1682071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682092 */     // GIR_Coverage, 6838,
     /* 1682092 */     GIR_EraseRootFromParent_Done,
     /* 1682093 */   // Label 23055: @1682093
     /* 1682093 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1682179), // Rule ID 6839 //
     /* 1682098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1682109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1682112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1682115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1682118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682144 */     // MIs[0] policy
     /* 1682144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1682157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682178 */     // GIR_Coverage, 6839,
     /* 1682178 */     GIR_EraseRootFromParent_Done,
     /* 1682179 */   // Label 23056: @1682179
     /* 1682179 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1682265), // Rule ID 6842 //
     /* 1682184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1682195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1682198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1682201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1682204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682230 */     // MIs[0] policy
     /* 1682230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1682243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682264 */     // GIR_Coverage, 6842,
     /* 1682264 */     GIR_EraseRootFromParent_Done,
     /* 1682265 */   // Label 23057: @1682265
     /* 1682265 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1682351), // Rule ID 6843 //
     /* 1682270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1682281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1682284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1682287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1682290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682316 */     // MIs[0] policy
     /* 1682316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1682329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682350 */     // GIR_Coverage, 6843,
     /* 1682350 */     GIR_EraseRootFromParent_Done,
     /* 1682351 */   // Label 23058: @1682351
     /* 1682351 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1682437), // Rule ID 6846 //
     /* 1682356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1682367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1682370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1682373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1682376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682402 */     // MIs[0] policy
     /* 1682402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682436 */     // GIR_Coverage, 6846,
     /* 1682436 */     GIR_EraseRootFromParent_Done,
     /* 1682437 */   // Label 23059: @1682437
     /* 1682437 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1682523), // Rule ID 6847 //
     /* 1682442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1682453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1682456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1682459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1682462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682488 */     // MIs[0] policy
     /* 1682488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682522 */     // GIR_Coverage, 6847,
     /* 1682522 */     GIR_EraseRootFromParent_Done,
     /* 1682523 */   // Label 23060: @1682523
     /* 1682523 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1682609), // Rule ID 6850 //
     /* 1682528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1682539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1682542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1682545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1682548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682574 */     // MIs[0] policy
     /* 1682574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682608 */     // GIR_Coverage, 6850,
     /* 1682608 */     GIR_EraseRootFromParent_Done,
     /* 1682609 */   // Label 23061: @1682609
     /* 1682609 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1682695), // Rule ID 6851 //
     /* 1682614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1682625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1682628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1682631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1682634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682660 */     // MIs[0] policy
     /* 1682660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682694 */     // GIR_Coverage, 6851,
     /* 1682694 */     GIR_EraseRootFromParent_Done,
     /* 1682695 */   // Label 23062: @1682695
     /* 1682695 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1682781), // Rule ID 6854 //
     /* 1682700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1682711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1682714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1682717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1682720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682746 */     // MIs[0] policy
     /* 1682746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682780 */     // GIR_Coverage, 6854,
     /* 1682780 */     GIR_EraseRootFromParent_Done,
     /* 1682781 */   // Label 23063: @1682781
     /* 1682781 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1682867), // Rule ID 6855 //
     /* 1682786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1682797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1682800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1682803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1682806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682832 */     // MIs[0] policy
     /* 1682832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682866 */     // GIR_Coverage, 6855,
     /* 1682866 */     GIR_EraseRootFromParent_Done,
     /* 1682867 */   // Label 23064: @1682867
     /* 1682867 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1682953), // Rule ID 6858 //
     /* 1682872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1682875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1682883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1682892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682918 */     // MIs[0] policy
     /* 1682918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1682931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1682949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682952 */     // GIR_Coverage, 6858,
     /* 1682952 */     GIR_EraseRootFromParent_Done,
     /* 1682953 */   // Label 23065: @1682953
     /* 1682953 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1683039), // Rule ID 6859 //
     /* 1682958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1682961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1682969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1682978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683004 */     // MIs[0] policy
     /* 1683004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1683017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683038 */     // GIR_Coverage, 6859,
     /* 1683038 */     GIR_EraseRootFromParent_Done,
     /* 1683039 */   // Label 23066: @1683039
     /* 1683039 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1683125), // Rule ID 6862 //
     /* 1683044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1683055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1683058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1683061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1683064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683090 */     // MIs[0] policy
     /* 1683090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1683103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683124 */     // GIR_Coverage, 6862,
     /* 1683124 */     GIR_EraseRootFromParent_Done,
     /* 1683125 */   // Label 23067: @1683125
     /* 1683125 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1683211), // Rule ID 6863 //
     /* 1683130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1683141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1683144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1683147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1683150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683176 */     // MIs[0] policy
     /* 1683176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1683189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683210 */     // GIR_Coverage, 6863,
     /* 1683210 */     GIR_EraseRootFromParent_Done,
     /* 1683211 */   // Label 23068: @1683211
     /* 1683211 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1683297), // Rule ID 6866 //
     /* 1683216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1683227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1683230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1683233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1683236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683262 */     // MIs[0] policy
     /* 1683262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1683275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683296 */     // GIR_Coverage, 6866,
     /* 1683296 */     GIR_EraseRootFromParent_Done,
     /* 1683297 */   // Label 23069: @1683297
     /* 1683297 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1683383), // Rule ID 6867 //
     /* 1683302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1683313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1683316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1683319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1683322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683348 */     // MIs[0] policy
     /* 1683348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1683361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683382 */     // GIR_Coverage, 6867,
     /* 1683382 */     GIR_EraseRootFromParent_Done,
     /* 1683383 */   // Label 23070: @1683383
     /* 1683383 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1683469), // Rule ID 6870 //
     /* 1683388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1683399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1683402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1683405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1683408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1683411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683434 */     // MIs[0] policy
     /* 1683434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1683447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683468 */     // GIR_Coverage, 6870,
     /* 1683468 */     GIR_EraseRootFromParent_Done,
     /* 1683469 */   // Label 23071: @1683469
     /* 1683469 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1683555), // Rule ID 6871 //
     /* 1683474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1683485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1683488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1683491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1683494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1683497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683520 */     // MIs[0] policy
     /* 1683520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1683533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683554 */     // GIR_Coverage, 6871,
     /* 1683554 */     GIR_EraseRootFromParent_Done,
     /* 1683555 */   // Label 23072: @1683555
     /* 1683555 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1683641), // Rule ID 6874 //
     /* 1683560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1683571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1683574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1683577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1683580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683606 */     // MIs[0] policy
     /* 1683606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1683619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683640 */     // GIR_Coverage, 6874,
     /* 1683640 */     GIR_EraseRootFromParent_Done,
     /* 1683641 */   // Label 23073: @1683641
     /* 1683641 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1683727), // Rule ID 6875 //
     /* 1683646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1683657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1683660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1683663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1683666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683692 */     // MIs[0] policy
     /* 1683692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1683705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683726 */     // GIR_Coverage, 6875,
     /* 1683726 */     GIR_EraseRootFromParent_Done,
     /* 1683727 */   // Label 23074: @1683727
     /* 1683727 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1683813), // Rule ID 6878 //
     /* 1683732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1683743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1683746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1683749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1683752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683778 */     // MIs[0] policy
     /* 1683778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1683791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683812 */     // GIR_Coverage, 6878,
     /* 1683812 */     GIR_EraseRootFromParent_Done,
     /* 1683813 */   // Label 23075: @1683813
     /* 1683813 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1683899), // Rule ID 6879 //
     /* 1683818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1683829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1683832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1683835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1683838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683864 */     // MIs[0] policy
     /* 1683864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1683877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683898 */     // GIR_Coverage, 6879,
     /* 1683898 */     GIR_EraseRootFromParent_Done,
     /* 1683899 */   // Label 23076: @1683899
     /* 1683899 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1683985), // Rule ID 6882 //
     /* 1683904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1683915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1683918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1683921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1683924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683950 */     // MIs[0] policy
     /* 1683950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1683963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683984 */     // GIR_Coverage, 6882,
     /* 1683984 */     GIR_EraseRootFromParent_Done,
     /* 1683985 */   // Label 23077: @1683985
     /* 1683985 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1684071), // Rule ID 6883 //
     /* 1683990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1684001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1684004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1684007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1684010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1684013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684036 */     // MIs[0] policy
     /* 1684036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1684049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684070 */     // GIR_Coverage, 6883,
     /* 1684070 */     GIR_EraseRootFromParent_Done,
     /* 1684071 */   // Label 23078: @1684071
     /* 1684071 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1684157), // Rule ID 6886 //
     /* 1684076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1684087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1684090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1684093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1684096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684122 */     // MIs[0] policy
     /* 1684122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1684135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684156 */     // GIR_Coverage, 6886,
     /* 1684156 */     GIR_EraseRootFromParent_Done,
     /* 1684157 */   // Label 23079: @1684157
     /* 1684157 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1684243), // Rule ID 6887 //
     /* 1684162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1684173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1684176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1684179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1684182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684208 */     // MIs[0] policy
     /* 1684208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1684221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684242 */     // GIR_Coverage, 6887,
     /* 1684242 */     GIR_EraseRootFromParent_Done,
     /* 1684243 */   // Label 23080: @1684243
     /* 1684243 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1684329), // Rule ID 6890 //
     /* 1684248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1684259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1684262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1684265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1684268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684294 */     // MIs[0] policy
     /* 1684294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1684307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684328 */     // GIR_Coverage, 6890,
     /* 1684328 */     GIR_EraseRootFromParent_Done,
     /* 1684329 */   // Label 23081: @1684329
     /* 1684329 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1684415), // Rule ID 6891 //
     /* 1684334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1684345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1684348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1684351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1684354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684380 */     // MIs[0] policy
     /* 1684380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1684393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684414 */     // GIR_Coverage, 6891,
     /* 1684414 */     GIR_EraseRootFromParent_Done,
     /* 1684415 */   // Label 23082: @1684415
     /* 1684415 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1684501), // Rule ID 6894 //
     /* 1684420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1684431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1684434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1684437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1684440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1684443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684466 */     // MIs[0] policy
     /* 1684466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1684479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684500 */     // GIR_Coverage, 6894,
     /* 1684500 */     GIR_EraseRootFromParent_Done,
     /* 1684501 */   // Label 23083: @1684501
     /* 1684501 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1684587), // Rule ID 6895 //
     /* 1684506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1684517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1684520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1684523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1684526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1684529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684552 */     // MIs[0] policy
     /* 1684552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1684565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684586 */     // GIR_Coverage, 6895,
     /* 1684586 */     GIR_EraseRootFromParent_Done,
     /* 1684587 */   // Label 23084: @1684587
     /* 1684587 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1684673), // Rule ID 6898 //
     /* 1684592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1684603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1684606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1684609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1684612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684638 */     // MIs[0] policy
     /* 1684638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1684651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684672 */     // GIR_Coverage, 6898,
     /* 1684672 */     GIR_EraseRootFromParent_Done,
     /* 1684673 */   // Label 23085: @1684673
     /* 1684673 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1684759), // Rule ID 6899 //
     /* 1684678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1684689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1684692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1684695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1684698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684724 */     // MIs[0] policy
     /* 1684724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1684737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684758 */     // GIR_Coverage, 6899,
     /* 1684758 */     GIR_EraseRootFromParent_Done,
     /* 1684759 */   // Label 23086: @1684759
     /* 1684759 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1684845), // Rule ID 6902 //
     /* 1684764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1684775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1684778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1684781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1684784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684810 */     // MIs[0] policy
     /* 1684810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1684823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684844 */     // GIR_Coverage, 6902,
     /* 1684844 */     GIR_EraseRootFromParent_Done,
     /* 1684845 */   // Label 23087: @1684845
     /* 1684845 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1684931), // Rule ID 6903 //
     /* 1684850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1684861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1684864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1684867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1684870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684896 */     // MIs[0] policy
     /* 1684896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1684909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684930 */     // GIR_Coverage, 6903,
     /* 1684930 */     GIR_EraseRootFromParent_Done,
     /* 1684931 */   // Label 23088: @1684931
     /* 1684931 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1685017), // Rule ID 6906 //
     /* 1684936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1684947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1684950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1684953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1684956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684982 */     // MIs[0] policy
     /* 1684982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1684995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685016 */     // GIR_Coverage, 6906,
     /* 1685016 */     GIR_EraseRootFromParent_Done,
     /* 1685017 */   // Label 23089: @1685017
     /* 1685017 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1685103), // Rule ID 6907 //
     /* 1685022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1685033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1685036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1685039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1685042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685068 */     // MIs[0] policy
     /* 1685068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1685081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685102 */     // GIR_Coverage, 6907,
     /* 1685102 */     GIR_EraseRootFromParent_Done,
     /* 1685103 */   // Label 23090: @1685103
     /* 1685103 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1685189), // Rule ID 6910 //
     /* 1685108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1685119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1685122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1685125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685154 */     // MIs[0] policy
     /* 1685154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1685167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685188 */     // GIR_Coverage, 6910,
     /* 1685188 */     GIR_EraseRootFromParent_Done,
     /* 1685189 */   // Label 23091: @1685189
     /* 1685189 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1685275), // Rule ID 6911 //
     /* 1685194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1685205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1685208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1685211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685240 */     // MIs[0] policy
     /* 1685240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1685253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685274 */     // GIR_Coverage, 6911,
     /* 1685274 */     GIR_EraseRootFromParent_Done,
     /* 1685275 */   // Label 23092: @1685275
     /* 1685275 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1685361), // Rule ID 6914 //
     /* 1685280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1685291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1685294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1685297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685326 */     // MIs[0] policy
     /* 1685326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1685339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685360 */     // GIR_Coverage, 6914,
     /* 1685360 */     GIR_EraseRootFromParent_Done,
     /* 1685361 */   // Label 23093: @1685361
     /* 1685361 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1685447), // Rule ID 6915 //
     /* 1685366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1685377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1685380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1685383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685412 */     // MIs[0] policy
     /* 1685412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685422 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1685425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685446 */     // GIR_Coverage, 6915,
     /* 1685446 */     GIR_EraseRootFromParent_Done,
     /* 1685447 */   // Label 23094: @1685447
     /* 1685447 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1685533), // Rule ID 6918 //
     /* 1685452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1685463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1685466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1685469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685498 */     // MIs[0] policy
     /* 1685498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1685511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685532 */     // GIR_Coverage, 6918,
     /* 1685532 */     GIR_EraseRootFromParent_Done,
     /* 1685533 */   // Label 23095: @1685533
     /* 1685533 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1685619), // Rule ID 6919 //
     /* 1685538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1685549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1685552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1685555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685584 */     // MIs[0] policy
     /* 1685584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685594 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1685597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685618 */     // GIR_Coverage, 6919,
     /* 1685618 */     GIR_EraseRootFromParent_Done,
     /* 1685619 */   // Label 23096: @1685619
     /* 1685619 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1685705), // Rule ID 6922 //
     /* 1685624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1685635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1685638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1685641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685670 */     // MIs[0] policy
     /* 1685670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1685683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685704 */     // GIR_Coverage, 6922,
     /* 1685704 */     GIR_EraseRootFromParent_Done,
     /* 1685705 */   // Label 23097: @1685705
     /* 1685705 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1685791), // Rule ID 6923 //
     /* 1685710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1685721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1685724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1685727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685756 */     // MIs[0] policy
     /* 1685756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1685769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685790 */     // GIR_Coverage, 6923,
     /* 1685790 */     GIR_EraseRootFromParent_Done,
     /* 1685791 */   // Label 23098: @1685791
     /* 1685791 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1685877), // Rule ID 6926 //
     /* 1685796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1685807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1685810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1685813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685842 */     // MIs[0] policy
     /* 1685842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1685855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685876 */     // GIR_Coverage, 6926,
     /* 1685876 */     GIR_EraseRootFromParent_Done,
     /* 1685877 */   // Label 23099: @1685877
     /* 1685877 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1685963), // Rule ID 6927 //
     /* 1685882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1685893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1685896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1685899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1685902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1685924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685928 */     // MIs[0] policy
     /* 1685928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1685941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685962 */     // GIR_Coverage, 6927,
     /* 1685962 */     GIR_EraseRootFromParent_Done,
     /* 1685963 */   // Label 23100: @1685963
     /* 1685963 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1686049), // Rule ID 6930 //
     /* 1685968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1685979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1685982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1685985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1685988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686014 */     // MIs[0] policy
     /* 1686014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1686027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686048 */     // GIR_Coverage, 6930,
     /* 1686048 */     GIR_EraseRootFromParent_Done,
     /* 1686049 */   // Label 23101: @1686049
     /* 1686049 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1686135), // Rule ID 6931 //
     /* 1686054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1686065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1686068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1686071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1686077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686100 */     // MIs[0] policy
     /* 1686100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1686113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686134 */     // GIR_Coverage, 6931,
     /* 1686134 */     GIR_EraseRootFromParent_Done,
     /* 1686135 */   // Label 23102: @1686135
     /* 1686135 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1686221), // Rule ID 6934 //
     /* 1686140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1686151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1686154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1686157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686186 */     // MIs[0] policy
     /* 1686186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686220 */     // GIR_Coverage, 6934,
     /* 1686220 */     GIR_EraseRootFromParent_Done,
     /* 1686221 */   // Label 23103: @1686221
     /* 1686221 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1686307), // Rule ID 6935 //
     /* 1686226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1686237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1686240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1686243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686272 */     // MIs[0] policy
     /* 1686272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686306 */     // GIR_Coverage, 6935,
     /* 1686306 */     GIR_EraseRootFromParent_Done,
     /* 1686307 */   // Label 23104: @1686307
     /* 1686307 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1686393), // Rule ID 6938 //
     /* 1686312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1686323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1686326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1686329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686358 */     // MIs[0] policy
     /* 1686358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686392 */     // GIR_Coverage, 6938,
     /* 1686392 */     GIR_EraseRootFromParent_Done,
     /* 1686393 */   // Label 23105: @1686393
     /* 1686393 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1686479), // Rule ID 6939 //
     /* 1686398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1686409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1686412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1686415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686444 */     // MIs[0] policy
     /* 1686444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686478 */     // GIR_Coverage, 6939,
     /* 1686478 */     GIR_EraseRootFromParent_Done,
     /* 1686479 */   // Label 23106: @1686479
     /* 1686479 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1686565), // Rule ID 6942 //
     /* 1686484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1686495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1686498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1686501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686530 */     // MIs[0] policy
     /* 1686530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686564 */     // GIR_Coverage, 6942,
     /* 1686564 */     GIR_EraseRootFromParent_Done,
     /* 1686565 */   // Label 23107: @1686565
     /* 1686565 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1686651), // Rule ID 6943 //
     /* 1686570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1686581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1686584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1686587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686616 */     // MIs[0] policy
     /* 1686616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686650 */     // GIR_Coverage, 6943,
     /* 1686650 */     GIR_EraseRootFromParent_Done,
     /* 1686651 */   // Label 23108: @1686651
     /* 1686651 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1686737), // Rule ID 6946 //
     /* 1686656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1686659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1686667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1686670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1686673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1686679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686702 */     // MIs[0] policy
     /* 1686702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686736 */     // GIR_Coverage, 6946,
     /* 1686736 */     GIR_EraseRootFromParent_Done,
     /* 1686737 */   // Label 23109: @1686737
     /* 1686737 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1686823), // Rule ID 6947 //
     /* 1686742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1686745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1686753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1686756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1686759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1686765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686788 */     // MIs[0] policy
     /* 1686788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1686801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686822 */     // GIR_Coverage, 6947,
     /* 1686822 */     GIR_EraseRootFromParent_Done,
     /* 1686823 */   // Label 23110: @1686823
     /* 1686823 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1686909), // Rule ID 6950 //
     /* 1686828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1686839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1686842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1686845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1686848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686874 */     // MIs[0] policy
     /* 1686874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1686887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686908 */     // GIR_Coverage, 6950,
     /* 1686908 */     GIR_EraseRootFromParent_Done,
     /* 1686909 */   // Label 23111: @1686909
     /* 1686909 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1686995), // Rule ID 6951 //
     /* 1686914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1686925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1686928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1686931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1686934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1686956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686960 */     // MIs[0] policy
     /* 1686960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1686973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686994 */     // GIR_Coverage, 6951,
     /* 1686994 */     GIR_EraseRootFromParent_Done,
     /* 1686995 */   // Label 23112: @1686995
     /* 1686995 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1687081), // Rule ID 6954 //
     /* 1687000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1687011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1687014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1687017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687046 */     // MIs[0] policy
     /* 1687046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1687059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687080 */     // GIR_Coverage, 6954,
     /* 1687080 */     GIR_EraseRootFromParent_Done,
     /* 1687081 */   // Label 23113: @1687081
     /* 1687081 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1687167), // Rule ID 6955 //
     /* 1687086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1687097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1687100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1687103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687132 */     // MIs[0] policy
     /* 1687132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1687145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687166 */     // GIR_Coverage, 6955,
     /* 1687166 */     GIR_EraseRootFromParent_Done,
     /* 1687167 */   // Label 23114: @1687167
     /* 1687167 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1687253), // Rule ID 6958 //
     /* 1687172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1687183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1687186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1687189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1687195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687218 */     // MIs[0] policy
     /* 1687218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1687231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687252 */     // GIR_Coverage, 6958,
     /* 1687252 */     GIR_EraseRootFromParent_Done,
     /* 1687253 */   // Label 23115: @1687253
     /* 1687253 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1687339), // Rule ID 6959 //
     /* 1687258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1687269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1687272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1687275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1687281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687304 */     // MIs[0] policy
     /* 1687304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1687317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687338 */     // GIR_Coverage, 6959,
     /* 1687338 */     GIR_EraseRootFromParent_Done,
     /* 1687339 */   // Label 23116: @1687339
     /* 1687339 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1687425), // Rule ID 6962 //
     /* 1687344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1687355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1687358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1687361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687390 */     // MIs[0] policy
     /* 1687390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1687403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687424 */     // GIR_Coverage, 6962,
     /* 1687424 */     GIR_EraseRootFromParent_Done,
     /* 1687425 */   // Label 23117: @1687425
     /* 1687425 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1687511), // Rule ID 6963 //
     /* 1687430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1687441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1687444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1687447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687476 */     // MIs[0] policy
     /* 1687476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1687489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687510 */     // GIR_Coverage, 6963,
     /* 1687510 */     GIR_EraseRootFromParent_Done,
     /* 1687511 */   // Label 23118: @1687511
     /* 1687511 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1687597), // Rule ID 6966 //
     /* 1687516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1687527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1687530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1687533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687562 */     // MIs[0] policy
     /* 1687562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1687575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687596 */     // GIR_Coverage, 6966,
     /* 1687596 */     GIR_EraseRootFromParent_Done,
     /* 1687597 */   // Label 23119: @1687597
     /* 1687597 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1687683), // Rule ID 6967 //
     /* 1687602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1687613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1687616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1687619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687648 */     // MIs[0] policy
     /* 1687648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1687661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687682 */     // GIR_Coverage, 6967,
     /* 1687682 */     GIR_EraseRootFromParent_Done,
     /* 1687683 */   // Label 23120: @1687683
     /* 1687683 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1687769), // Rule ID 6970 //
     /* 1687688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1687699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1687702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1687705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687734 */     // MIs[0] policy
     /* 1687734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1687747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687768 */     // GIR_Coverage, 6970,
     /* 1687768 */     GIR_EraseRootFromParent_Done,
     /* 1687769 */   // Label 23121: @1687769
     /* 1687769 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1687855), // Rule ID 6971 //
     /* 1687774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1687785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1687788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1687791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687820 */     // MIs[0] policy
     /* 1687820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687830 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1687833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687854 */     // GIR_Coverage, 6971,
     /* 1687854 */     GIR_EraseRootFromParent_Done,
     /* 1687855 */   // Label 23122: @1687855
     /* 1687855 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1687941), // Rule ID 6974 //
     /* 1687860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1687871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1687874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1687877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687906 */     // MIs[0] policy
     /* 1687906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1687919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687940 */     // GIR_Coverage, 6974,
     /* 1687940 */     GIR_EraseRootFromParent_Done,
     /* 1687941 */   // Label 23123: @1687941
     /* 1687941 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1688027), // Rule ID 6975 //
     /* 1687946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1687957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1687960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1687963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687992 */     // MIs[0] policy
     /* 1687992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1688005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688026 */     // GIR_Coverage, 6975,
     /* 1688026 */     GIR_EraseRootFromParent_Done,
     /* 1688027 */   // Label 23124: @1688027
     /* 1688027 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1688113), // Rule ID 6978 //
     /* 1688032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1688043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1688046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1688049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688078 */     // MIs[0] policy
     /* 1688078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1688091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688112 */     // GIR_Coverage, 6978,
     /* 1688112 */     GIR_EraseRootFromParent_Done,
     /* 1688113 */   // Label 23125: @1688113
     /* 1688113 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1688199), // Rule ID 6979 //
     /* 1688118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1688129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1688132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1688135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688164 */     // MIs[0] policy
     /* 1688164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1688177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688198 */     // GIR_Coverage, 6979,
     /* 1688198 */     GIR_EraseRootFromParent_Done,
     /* 1688199 */   // Label 23126: @1688199
     /* 1688199 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1688285), // Rule ID 6982 //
     /* 1688204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1688215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1688218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1688221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1688227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688250 */     // MIs[0] policy
     /* 1688250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1688263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688284 */     // GIR_Coverage, 6982,
     /* 1688284 */     GIR_EraseRootFromParent_Done,
     /* 1688285 */   // Label 23127: @1688285
     /* 1688285 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1688371), // Rule ID 6983 //
     /* 1688290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1688301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1688304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1688307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1688313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688336 */     // MIs[0] policy
     /* 1688336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1688349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688370 */     // GIR_Coverage, 6983,
     /* 1688370 */     GIR_EraseRootFromParent_Done,
     /* 1688371 */   // Label 23128: @1688371
     /* 1688371 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1688457), // Rule ID 6986 //
     /* 1688376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1688387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1688390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1688393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1688406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1688410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1688414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688422 */     // MIs[0] policy
     /* 1688422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1688435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688456 */     // GIR_Coverage, 6986,
     /* 1688456 */     GIR_EraseRootFromParent_Done,
     /* 1688457 */   // Label 23129: @1688457
     /* 1688457 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1688543), // Rule ID 6987 //
     /* 1688462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1688473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1688476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1688479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1688492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1688496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1688500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688508 */     // MIs[0] policy
     /* 1688508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1688521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688542 */     // GIR_Coverage, 6987,
     /* 1688542 */     GIR_EraseRootFromParent_Done,
     /* 1688543 */   // Label 23130: @1688543
     /* 1688543 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1688629), // Rule ID 6990 //
     /* 1688548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1688559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1688562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1688565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688594 */     // MIs[0] policy
     /* 1688594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1688607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688628 */     // GIR_Coverage, 6990,
     /* 1688628 */     GIR_EraseRootFromParent_Done,
     /* 1688629 */   // Label 23131: @1688629
     /* 1688629 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1688715), // Rule ID 6991 //
     /* 1688634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1688645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1688648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1688651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688680 */     // MIs[0] policy
     /* 1688680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1688693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688714 */     // GIR_Coverage, 6991,
     /* 1688714 */     GIR_EraseRootFromParent_Done,
     /* 1688715 */   // Label 23132: @1688715
     /* 1688715 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1688801), // Rule ID 6994 //
     /* 1688720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1688731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1688734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1688737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688766 */     // MIs[0] policy
     /* 1688766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1688779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688800 */     // GIR_Coverage, 6994,
     /* 1688800 */     GIR_EraseRootFromParent_Done,
     /* 1688801 */   // Label 23133: @1688801
     /* 1688801 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1688887), // Rule ID 6995 //
     /* 1688806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1688817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1688820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1688823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688852 */     // MIs[0] policy
     /* 1688852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1688865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688886 */     // GIR_Coverage, 6995,
     /* 1688886 */     GIR_EraseRootFromParent_Done,
     /* 1688887 */   // Label 23134: @1688887
     /* 1688887 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1688973), // Rule ID 7086 //
     /* 1688892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1688912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688938 */     // MIs[0] policy
     /* 1688938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1688951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688972 */     // GIR_Coverage, 7086,
     /* 1688972 */     GIR_EraseRootFromParent_Done,
     /* 1688973 */   // Label 23135: @1688973
     /* 1688973 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1689059), // Rule ID 7087 //
     /* 1688978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1688998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689024 */     // MIs[0] policy
     /* 1689024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1689037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689058 */     // GIR_Coverage, 7087,
     /* 1689058 */     GIR_EraseRootFromParent_Done,
     /* 1689059 */   // Label 23136: @1689059
     /* 1689059 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1689145), // Rule ID 7090 //
     /* 1689064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1689075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1689078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1689081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1689084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689110 */     // MIs[0] policy
     /* 1689110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689120 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1689123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689144 */     // GIR_Coverage, 7090,
     /* 1689144 */     GIR_EraseRootFromParent_Done,
     /* 1689145 */   // Label 23137: @1689145
     /* 1689145 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1689231), // Rule ID 7091 //
     /* 1689150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1689161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1689164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1689167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1689170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689196 */     // MIs[0] policy
     /* 1689196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689206 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1689209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689230 */     // GIR_Coverage, 7091,
     /* 1689230 */     GIR_EraseRootFromParent_Done,
     /* 1689231 */   // Label 23138: @1689231
     /* 1689231 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1689317), // Rule ID 7094 //
     /* 1689236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1689247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1689250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1689253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1689256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689282 */     // MIs[0] policy
     /* 1689282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689292 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689316 */     // GIR_Coverage, 7094,
     /* 1689316 */     GIR_EraseRootFromParent_Done,
     /* 1689317 */   // Label 23139: @1689317
     /* 1689317 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1689403), // Rule ID 7095 //
     /* 1689322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1689333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1689336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1689339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1689342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689368 */     // MIs[0] policy
     /* 1689368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689378 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689402 */     // GIR_Coverage, 7095,
     /* 1689402 */     GIR_EraseRootFromParent_Done,
     /* 1689403 */   // Label 23140: @1689403
     /* 1689403 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1689489), // Rule ID 7098 //
     /* 1689408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1689419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1689422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1689425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1689428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689454 */     // MIs[0] policy
     /* 1689454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1689467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689488 */     // GIR_Coverage, 7098,
     /* 1689488 */     GIR_EraseRootFromParent_Done,
     /* 1689489 */   // Label 23141: @1689489
     /* 1689489 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1689575), // Rule ID 7099 //
     /* 1689494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1689505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1689508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1689511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1689514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689540 */     // MIs[0] policy
     /* 1689540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1689553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689574 */     // GIR_Coverage, 7099,
     /* 1689574 */     GIR_EraseRootFromParent_Done,
     /* 1689575 */   // Label 23142: @1689575
     /* 1689575 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1689661), // Rule ID 7102 //
     /* 1689580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1689591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1689594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1689597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1689600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689626 */     // MIs[0] policy
     /* 1689626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689660 */     // GIR_Coverage, 7102,
     /* 1689660 */     GIR_EraseRootFromParent_Done,
     /* 1689661 */   // Label 23143: @1689661
     /* 1689661 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1689747), // Rule ID 7103 //
     /* 1689666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1689677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1689680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1689683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1689686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689712 */     // MIs[0] policy
     /* 1689712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689722 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689746 */     // GIR_Coverage, 7103,
     /* 1689746 */     GIR_EraseRootFromParent_Done,
     /* 1689747 */   // Label 23144: @1689747
     /* 1689747 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1689833), // Rule ID 7106 //
     /* 1689752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1689763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1689766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1689769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1689772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689798 */     // MIs[0] policy
     /* 1689798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689832 */     // GIR_Coverage, 7106,
     /* 1689832 */     GIR_EraseRootFromParent_Done,
     /* 1689833 */   // Label 23145: @1689833
     /* 1689833 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1689919), // Rule ID 7107 //
     /* 1689838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1689849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1689852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1689855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1689858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689884 */     // MIs[0] policy
     /* 1689884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1689897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689918 */     // GIR_Coverage, 7107,
     /* 1689918 */     GIR_EraseRootFromParent_Done,
     /* 1689919 */   // Label 23146: @1689919
     /* 1689919 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1690005), // Rule ID 7110 //
     /* 1689924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1689935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1689938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1689941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1689944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689970 */     // MIs[0] policy
     /* 1689970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1689983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690004 */     // GIR_Coverage, 7110,
     /* 1690004 */     GIR_EraseRootFromParent_Done,
     /* 1690005 */   // Label 23147: @1690005
     /* 1690005 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1690091), // Rule ID 7111 //
     /* 1690010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1690021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1690024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1690027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1690030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690056 */     // MIs[0] policy
     /* 1690056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690090 */     // GIR_Coverage, 7111,
     /* 1690090 */     GIR_EraseRootFromParent_Done,
     /* 1690091 */   // Label 23148: @1690091
     /* 1690091 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1690177), // Rule ID 7114 //
     /* 1690096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1690107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1690110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1690113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1690116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690142 */     // MIs[0] policy
     /* 1690142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690176 */     // GIR_Coverage, 7114,
     /* 1690176 */     GIR_EraseRootFromParent_Done,
     /* 1690177 */   // Label 23149: @1690177
     /* 1690177 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1690263), // Rule ID 7115 //
     /* 1690182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1690193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1690196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1690199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1690202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690228 */     // MIs[0] policy
     /* 1690228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690262 */     // GIR_Coverage, 7115,
     /* 1690262 */     GIR_EraseRootFromParent_Done,
     /* 1690263 */   // Label 23150: @1690263
     /* 1690263 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1690349), // Rule ID 7118 //
     /* 1690268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1690279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1690282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1690285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1690288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690314 */     // MIs[0] policy
     /* 1690314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690348 */     // GIR_Coverage, 7118,
     /* 1690348 */     GIR_EraseRootFromParent_Done,
     /* 1690349 */   // Label 23151: @1690349
     /* 1690349 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1690435), // Rule ID 7119 //
     /* 1690354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1690365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1690368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1690371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1690374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690400 */     // MIs[0] policy
     /* 1690400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690434 */     // GIR_Coverage, 7119,
     /* 1690434 */     GIR_EraseRootFromParent_Done,
     /* 1690435 */   // Label 23152: @1690435
     /* 1690435 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1690521), // Rule ID 7122 //
     /* 1690440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1690451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1690454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1690457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1690460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1690463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690486 */     // MIs[0] policy
     /* 1690486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690520 */     // GIR_Coverage, 7122,
     /* 1690520 */     GIR_EraseRootFromParent_Done,
     /* 1690521 */   // Label 23153: @1690521
     /* 1690521 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1690607), // Rule ID 7123 //
     /* 1690526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1690537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1690540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1690543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1690546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1690549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1690556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1690568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690572 */     // MIs[0] policy
     /* 1690572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1690585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690606 */     // GIR_Coverage, 7123,
     /* 1690606 */     GIR_EraseRootFromParent_Done,
     /* 1690607 */   // Label 23154: @1690607
     /* 1690607 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1690693), // Rule ID 7126 //
     /* 1690612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1690623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1690626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1690629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1690632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690658 */     // MIs[0] policy
     /* 1690658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1690671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690692 */     // GIR_Coverage, 7126,
     /* 1690692 */     GIR_EraseRootFromParent_Done,
     /* 1690693 */   // Label 23155: @1690693
     /* 1690693 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1690779), // Rule ID 7127 //
     /* 1690698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1690709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1690712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1690715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1690718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690744 */     // MIs[0] policy
     /* 1690744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1690757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690778 */     // GIR_Coverage, 7127,
     /* 1690778 */     GIR_EraseRootFromParent_Done,
     /* 1690779 */   // Label 23156: @1690779
     /* 1690779 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1690865), // Rule ID 7130 //
     /* 1690784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1690795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1690798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1690801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1690804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690830 */     // MIs[0] policy
     /* 1690830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1690843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690864 */     // GIR_Coverage, 7130,
     /* 1690864 */     GIR_EraseRootFromParent_Done,
     /* 1690865 */   // Label 23157: @1690865
     /* 1690865 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1690951), // Rule ID 7131 //
     /* 1690870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1690881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1690884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1690887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1690890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690916 */     // MIs[0] policy
     /* 1690916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690926 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1690929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690950 */     // GIR_Coverage, 7131,
     /* 1690950 */     GIR_EraseRootFromParent_Done,
     /* 1690951 */   // Label 23158: @1690951
     /* 1690951 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1691037), // Rule ID 7134 //
     /* 1690956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1690967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1690970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1690973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1690976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1690979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691002 */     // MIs[0] policy
     /* 1691002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1691015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691036 */     // GIR_Coverage, 7134,
     /* 1691036 */     GIR_EraseRootFromParent_Done,
     /* 1691037 */   // Label 23159: @1691037
     /* 1691037 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1691123), // Rule ID 7135 //
     /* 1691042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1691053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1691056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1691059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1691062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1691065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691088 */     // MIs[0] policy
     /* 1691088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691098 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1691101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691122 */     // GIR_Coverage, 7135,
     /* 1691122 */     GIR_EraseRootFromParent_Done,
     /* 1691123 */   // Label 23160: @1691123
     /* 1691123 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1691209), // Rule ID 7138 //
     /* 1691128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1691139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1691142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1691145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1691148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691174 */     // MIs[0] policy
     /* 1691174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1691187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691208 */     // GIR_Coverage, 7138,
     /* 1691208 */     GIR_EraseRootFromParent_Done,
     /* 1691209 */   // Label 23161: @1691209
     /* 1691209 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1691295), // Rule ID 7139 //
     /* 1691214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1691225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1691228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1691231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1691234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691260 */     // MIs[0] policy
     /* 1691260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1691273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691294 */     // GIR_Coverage, 7139,
     /* 1691294 */     GIR_EraseRootFromParent_Done,
     /* 1691295 */   // Label 23162: @1691295
     /* 1691295 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1691381), // Rule ID 7142 //
     /* 1691300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1691311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1691314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1691317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1691320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691346 */     // MIs[0] policy
     /* 1691346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1691359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691380 */     // GIR_Coverage, 7142,
     /* 1691380 */     GIR_EraseRootFromParent_Done,
     /* 1691381 */   // Label 23163: @1691381
     /* 1691381 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1691467), // Rule ID 7143 //
     /* 1691386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1691397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1691400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1691403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1691406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691432 */     // MIs[0] policy
     /* 1691432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1691445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691466 */     // GIR_Coverage, 7143,
     /* 1691466 */     GIR_EraseRootFromParent_Done,
     /* 1691467 */   // Label 23164: @1691467
     /* 1691467 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1691553), // Rule ID 7146 //
     /* 1691472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1691483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1691486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1691489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1691492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1691495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691518 */     // MIs[0] policy
     /* 1691518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1691531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691552 */     // GIR_Coverage, 7146,
     /* 1691552 */     GIR_EraseRootFromParent_Done,
     /* 1691553 */   // Label 23165: @1691553
     /* 1691553 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1691639), // Rule ID 7147 //
     /* 1691558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1691569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1691572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1691575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1691578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1691581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691604 */     // MIs[0] policy
     /* 1691604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1691617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691638 */     // GIR_Coverage, 7147,
     /* 1691638 */     GIR_EraseRootFromParent_Done,
     /* 1691639 */   // Label 23166: @1691639
     /* 1691639 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1691725), // Rule ID 7150 //
     /* 1691644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1691655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1691658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1691661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1691664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691690 */     // MIs[0] policy
     /* 1691690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1691703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691724 */     // GIR_Coverage, 7150,
     /* 1691724 */     GIR_EraseRootFromParent_Done,
     /* 1691725 */   // Label 23167: @1691725
     /* 1691725 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1691811), // Rule ID 7151 //
     /* 1691730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1691741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1691744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1691747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1691750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691776 */     // MIs[0] policy
     /* 1691776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1691789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691810 */     // GIR_Coverage, 7151,
     /* 1691810 */     GIR_EraseRootFromParent_Done,
     /* 1691811 */   // Label 23168: @1691811
     /* 1691811 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1691897), // Rule ID 7154 //
     /* 1691816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1691827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1691830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1691833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1691836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691862 */     // MIs[0] policy
     /* 1691862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1691875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691896 */     // GIR_Coverage, 7154,
     /* 1691896 */     GIR_EraseRootFromParent_Done,
     /* 1691897 */   // Label 23169: @1691897
     /* 1691897 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1691983), // Rule ID 7155 //
     /* 1691902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1691913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1691916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1691919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1691922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691948 */     // MIs[0] policy
     /* 1691948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1691961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691982 */     // GIR_Coverage, 7155,
     /* 1691982 */     GIR_EraseRootFromParent_Done,
     /* 1691983 */   // Label 23170: @1691983
     /* 1691983 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1692069), // Rule ID 7158 //
     /* 1691988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1692002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1692005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1692008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1692018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692034 */     // MIs[0] policy
     /* 1692034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1692047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692068 */     // GIR_Coverage, 7158,
     /* 1692068 */     GIR_EraseRootFromParent_Done,
     /* 1692069 */   // Label 23171: @1692069
     /* 1692069 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1692155), // Rule ID 7159 //
     /* 1692074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1692085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1692088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1692091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1692094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1692104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692120 */     // MIs[0] policy
     /* 1692120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1692133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692154 */     // GIR_Coverage, 7159,
     /* 1692154 */     GIR_EraseRootFromParent_Done,
     /* 1692155 */   // Label 23172: @1692155
     /* 1692155 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1692241), // Rule ID 7162 //
     /* 1692160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1692171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1692174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1692177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1692180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692206 */     // MIs[0] policy
     /* 1692206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1692219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692240 */     // GIR_Coverage, 7162,
     /* 1692240 */     GIR_EraseRootFromParent_Done,
     /* 1692241 */   // Label 23173: @1692241
     /* 1692241 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1692327), // Rule ID 7163 //
     /* 1692246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1692257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1692260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1692263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1692266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692292 */     // MIs[0] policy
     /* 1692292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1692305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692326 */     // GIR_Coverage, 7163,
     /* 1692326 */     GIR_EraseRootFromParent_Done,
     /* 1692327 */   // Label 23174: @1692327
     /* 1692327 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1692413), // Rule ID 7166 //
     /* 1692332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1692343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1692346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1692349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1692352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1692362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692378 */     // MIs[0] policy
     /* 1692378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1692391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692412 */     // GIR_Coverage, 7166,
     /* 1692412 */     GIR_EraseRootFromParent_Done,
     /* 1692413 */   // Label 23175: @1692413
     /* 1692413 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1692499), // Rule ID 7167 //
     /* 1692418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1692429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1692432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1692435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1692438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1692448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692464 */     // MIs[0] policy
     /* 1692464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1692477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692498 */     // GIR_Coverage, 7167,
     /* 1692498 */     GIR_EraseRootFromParent_Done,
     /* 1692499 */   // Label 23176: @1692499
     /* 1692499 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1692585), // Rule ID 7170 //
     /* 1692504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1692515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1692518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1692521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1692524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1692534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692550 */     // MIs[0] policy
     /* 1692550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1692563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692584 */     // GIR_Coverage, 7170,
     /* 1692584 */     GIR_EraseRootFromParent_Done,
     /* 1692585 */   // Label 23177: @1692585
     /* 1692585 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1692671), // Rule ID 7171 //
     /* 1692590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1692601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1692604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1692607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1692610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1692620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692636 */     // MIs[0] policy
     /* 1692636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1692649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692670 */     // GIR_Coverage, 7171,
     /* 1692670 */     GIR_EraseRootFromParent_Done,
     /* 1692671 */   // Label 23178: @1692671
     /* 1692671 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1692757), // Rule ID 7174 //
     /* 1692676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1692687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1692690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1692693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692722 */     // MIs[0] policy
     /* 1692722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1692735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692756 */     // GIR_Coverage, 7174,
     /* 1692756 */     GIR_EraseRootFromParent_Done,
     /* 1692757 */   // Label 23179: @1692757
     /* 1692757 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1692843), // Rule ID 7175 //
     /* 1692762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1692773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1692776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1692779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692808 */     // MIs[0] policy
     /* 1692808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1692821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692842 */     // GIR_Coverage, 7175,
     /* 1692842 */     GIR_EraseRootFromParent_Done,
     /* 1692843 */   // Label 23180: @1692843
     /* 1692843 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1692929), // Rule ID 7178 //
     /* 1692848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1692859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1692862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1692865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1692868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692894 */     // MIs[0] policy
     /* 1692894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692904 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1692907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692928 */     // GIR_Coverage, 7178,
     /* 1692928 */     GIR_EraseRootFromParent_Done,
     /* 1692929 */   // Label 23181: @1692929
     /* 1692929 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1693015), // Rule ID 7179 //
     /* 1692934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1692945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1692948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1692951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692980 */     // MIs[0] policy
     /* 1692980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1692993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693014 */     // GIR_Coverage, 7179,
     /* 1693014 */     GIR_EraseRootFromParent_Done,
     /* 1693015 */   // Label 23182: @1693015
     /* 1693015 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1693101), // Rule ID 7182 //
     /* 1693020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1693031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1693034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1693037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693066 */     // MIs[0] policy
     /* 1693066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693076 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693100 */     // GIR_Coverage, 7182,
     /* 1693100 */     GIR_EraseRootFromParent_Done,
     /* 1693101 */   // Label 23183: @1693101
     /* 1693101 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1693187), // Rule ID 7183 //
     /* 1693106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1693117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1693120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1693123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693152 */     // MIs[0] policy
     /* 1693152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693186 */     // GIR_Coverage, 7183,
     /* 1693186 */     GIR_EraseRootFromParent_Done,
     /* 1693187 */   // Label 23184: @1693187
     /* 1693187 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1693273), // Rule ID 7186 //
     /* 1693192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1693203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1693206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1693209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693238 */     // MIs[0] policy
     /* 1693238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1693251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693272 */     // GIR_Coverage, 7186,
     /* 1693272 */     GIR_EraseRootFromParent_Done,
     /* 1693273 */   // Label 23185: @1693273
     /* 1693273 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1693359), // Rule ID 7187 //
     /* 1693278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1693289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1693292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1693295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693324 */     // MIs[0] policy
     /* 1693324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1693337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693358 */     // GIR_Coverage, 7187,
     /* 1693358 */     GIR_EraseRootFromParent_Done,
     /* 1693359 */   // Label 23186: @1693359
     /* 1693359 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1693445), // Rule ID 7190 //
     /* 1693364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1693375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1693378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1693381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693410 */     // MIs[0] policy
     /* 1693410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693444 */     // GIR_Coverage, 7190,
     /* 1693444 */     GIR_EraseRootFromParent_Done,
     /* 1693445 */   // Label 23187: @1693445
     /* 1693445 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1693531), // Rule ID 7191 //
     /* 1693450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1693461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1693464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1693467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693496 */     // MIs[0] policy
     /* 1693496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693530 */     // GIR_Coverage, 7191,
     /* 1693530 */     GIR_EraseRootFromParent_Done,
     /* 1693531 */   // Label 23188: @1693531
     /* 1693531 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1693617), // Rule ID 7194 //
     /* 1693536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1693547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1693550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1693553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693582 */     // MIs[0] policy
     /* 1693582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693616 */     // GIR_Coverage, 7194,
     /* 1693616 */     GIR_EraseRootFromParent_Done,
     /* 1693617 */   // Label 23189: @1693617
     /* 1693617 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1693703), // Rule ID 7195 //
     /* 1693622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1693633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1693636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1693639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693668 */     // MIs[0] policy
     /* 1693668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1693681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693702 */     // GIR_Coverage, 7195,
     /* 1693702 */     GIR_EraseRootFromParent_Done,
     /* 1693703 */   // Label 23190: @1693703
     /* 1693703 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1693789), // Rule ID 7198 //
     /* 1693708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1693719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1693722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1693725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693754 */     // MIs[0] policy
     /* 1693754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1693767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693788 */     // GIR_Coverage, 7198,
     /* 1693788 */     GIR_EraseRootFromParent_Done,
     /* 1693789 */   // Label 23191: @1693789
     /* 1693789 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1693875), // Rule ID 7199 //
     /* 1693794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1693805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1693808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1693811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693840 */     // MIs[0] policy
     /* 1693840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1693853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693874 */     // GIR_Coverage, 7199,
     /* 1693874 */     GIR_EraseRootFromParent_Done,
     /* 1693875 */   // Label 23192: @1693875
     /* 1693875 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1693961), // Rule ID 7202 //
     /* 1693880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1693897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1693900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1693922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693926 */     // MIs[0] policy
     /* 1693926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1693939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693960 */     // GIR_Coverage, 7202,
     /* 1693960 */     GIR_EraseRootFromParent_Done,
     /* 1693961 */   // Label 23193: @1693961
     /* 1693961 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1694047), // Rule ID 7203 //
     /* 1693966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1693983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1693986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694012 */     // MIs[0] policy
     /* 1694012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1694025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694046 */     // GIR_Coverage, 7203,
     /* 1694046 */     GIR_EraseRootFromParent_Done,
     /* 1694047 */   // Label 23194: @1694047
     /* 1694047 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1694133), // Rule ID 7206 //
     /* 1694052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1694063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1694066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1694069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694098 */     // MIs[0] policy
     /* 1694098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1694111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694132 */     // GIR_Coverage, 7206,
     /* 1694132 */     GIR_EraseRootFromParent_Done,
     /* 1694133 */   // Label 23195: @1694133
     /* 1694133 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1694219), // Rule ID 7207 //
     /* 1694138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1694149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1694152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1694155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694184 */     // MIs[0] policy
     /* 1694184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1694197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694218 */     // GIR_Coverage, 7207,
     /* 1694218 */     GIR_EraseRootFromParent_Done,
     /* 1694219 */   // Label 23196: @1694219
     /* 1694219 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1694305), // Rule ID 7210 //
     /* 1694224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1694235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1694238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1694241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694270 */     // MIs[0] policy
     /* 1694270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1694283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694304 */     // GIR_Coverage, 7210,
     /* 1694304 */     GIR_EraseRootFromParent_Done,
     /* 1694305 */   // Label 23197: @1694305
     /* 1694305 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1694391), // Rule ID 7211 //
     /* 1694310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1694321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1694324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1694327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694356 */     // MIs[0] policy
     /* 1694356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1694369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694390 */     // GIR_Coverage, 7211,
     /* 1694390 */     GIR_EraseRootFromParent_Done,
     /* 1694391 */   // Label 23198: @1694391
     /* 1694391 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1694477), // Rule ID 7214 //
     /* 1694396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1694407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1694410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1694413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694442 */     // MIs[0] policy
     /* 1694442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1694455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694476 */     // GIR_Coverage, 7214,
     /* 1694476 */     GIR_EraseRootFromParent_Done,
     /* 1694477 */   // Label 23199: @1694477
     /* 1694477 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1694563), // Rule ID 7215 //
     /* 1694482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1694493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1694496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1694499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694528 */     // MIs[0] policy
     /* 1694528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1694541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694562 */     // GIR_Coverage, 7215,
     /* 1694562 */     GIR_EraseRootFromParent_Done,
     /* 1694563 */   // Label 23200: @1694563
     /* 1694563 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1694649), // Rule ID 7218 //
     /* 1694568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1694579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1694582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1694585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694614 */     // MIs[0] policy
     /* 1694614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1694627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694648 */     // GIR_Coverage, 7218,
     /* 1694648 */     GIR_EraseRootFromParent_Done,
     /* 1694649 */   // Label 23201: @1694649
     /* 1694649 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1694735), // Rule ID 7219 //
     /* 1694654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1694665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1694668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1694671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1694677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694700 */     // MIs[0] policy
     /* 1694700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1694713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694734 */     // GIR_Coverage, 7219,
     /* 1694734 */     GIR_EraseRootFromParent_Done,
     /* 1694735 */   // Label 23202: @1694735
     /* 1694735 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1694821), // Rule ID 7222 //
     /* 1694740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1694751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1694754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1694757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1694763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694786 */     // MIs[0] policy
     /* 1694786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1694799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694820 */     // GIR_Coverage, 7222,
     /* 1694820 */     GIR_EraseRootFromParent_Done,
     /* 1694821 */   // Label 23203: @1694821
     /* 1694821 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1694907), // Rule ID 7223 //
     /* 1694826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1694837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1694840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1694843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1694849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694872 */     // MIs[0] policy
     /* 1694872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694882 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1694885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694906 */     // GIR_Coverage, 7223,
     /* 1694906 */     GIR_EraseRootFromParent_Done,
     /* 1694907 */   // Label 23204: @1694907
     /* 1694907 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1694993), // Rule ID 7226 //
     /* 1694912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1694923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1694926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1694929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694958 */     // MIs[0] policy
     /* 1694958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1694971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1694989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694992 */     // GIR_Coverage, 7226,
     /* 1694992 */     GIR_EraseRootFromParent_Done,
     /* 1694993 */   // Label 23205: @1694993
     /* 1694993 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1695079), // Rule ID 7227 //
     /* 1694998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1695009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1695012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1695015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695044 */     // MIs[0] policy
     /* 1695044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1695057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695078 */     // GIR_Coverage, 7227,
     /* 1695078 */     GIR_EraseRootFromParent_Done,
     /* 1695079 */   // Label 23206: @1695079
     /* 1695079 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1695165), // Rule ID 7230 //
     /* 1695084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1695095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1695098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1695101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695130 */     // MIs[0] policy
     /* 1695130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1695143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695164 */     // GIR_Coverage, 7230,
     /* 1695164 */     GIR_EraseRootFromParent_Done,
     /* 1695165 */   // Label 23207: @1695165
     /* 1695165 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1695251), // Rule ID 7231 //
     /* 1695170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1695181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1695184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1695187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695216 */     // MIs[0] policy
     /* 1695216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1695229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695250 */     // GIR_Coverage, 7231,
     /* 1695250 */     GIR_EraseRootFromParent_Done,
     /* 1695251 */   // Label 23208: @1695251
     /* 1695251 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1695337), // Rule ID 7234 //
     /* 1695256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1695267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1695270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1695273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1695279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695302 */     // MIs[0] policy
     /* 1695302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1695315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695336 */     // GIR_Coverage, 7234,
     /* 1695336 */     GIR_EraseRootFromParent_Done,
     /* 1695337 */   // Label 23209: @1695337
     /* 1695337 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1695423), // Rule ID 7235 //
     /* 1695342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1695353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1695356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1695359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1695365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695388 */     // MIs[0] policy
     /* 1695388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1695401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695422 */     // GIR_Coverage, 7235,
     /* 1695422 */     GIR_EraseRootFromParent_Done,
     /* 1695423 */   // Label 23210: @1695423
     /* 1695423 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1695509), // Rule ID 7238 //
     /* 1695428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1695439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1695442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1695445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695474 */     // MIs[0] policy
     /* 1695474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1695487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695508 */     // GIR_Coverage, 7238,
     /* 1695508 */     GIR_EraseRootFromParent_Done,
     /* 1695509 */   // Label 23211: @1695509
     /* 1695509 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1695595), // Rule ID 7239 //
     /* 1695514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1695525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1695528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1695531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695560 */     // MIs[0] policy
     /* 1695560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1695573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695594 */     // GIR_Coverage, 7239,
     /* 1695594 */     GIR_EraseRootFromParent_Done,
     /* 1695595 */   // Label 23212: @1695595
     /* 1695595 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1695681), // Rule ID 7242 //
     /* 1695600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1695611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1695614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1695617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695646 */     // MIs[0] policy
     /* 1695646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1695659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695680 */     // GIR_Coverage, 7242,
     /* 1695680 */     GIR_EraseRootFromParent_Done,
     /* 1695681 */   // Label 23213: @1695681
     /* 1695681 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1695767), // Rule ID 7243 //
     /* 1695686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1695697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1695700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1695703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695732 */     // MIs[0] policy
     /* 1695732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1695745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695766 */     // GIR_Coverage, 7243,
     /* 1695766 */     GIR_EraseRootFromParent_Done,
     /* 1695767 */   // Label 23214: @1695767
     /* 1695767 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1695853), // Rule ID 7246 //
     /* 1695772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1695783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1695786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1695789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695818 */     // MIs[0] policy
     /* 1695818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1695831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695852 */     // GIR_Coverage, 7246,
     /* 1695852 */     GIR_EraseRootFromParent_Done,
     /* 1695853 */   // Label 23215: @1695853
     /* 1695853 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1695939), // Rule ID 7247 //
     /* 1695858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1695869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1695872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1695875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1695888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695904 */     // MIs[0] policy
     /* 1695904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1695917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695938 */     // GIR_Coverage, 7247,
     /* 1695938 */     GIR_EraseRootFromParent_Done,
     /* 1695939 */   // Label 23216: @1695939
     /* 1695939 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1696025), // Rule ID 7250 //
     /* 1695944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1695947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1695955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1695958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1695961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695990 */     // MIs[0] policy
     /* 1695990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696024 */     // GIR_Coverage, 7250,
     /* 1696024 */     GIR_EraseRootFromParent_Done,
     /* 1696025 */   // Label 23217: @1696025
     /* 1696025 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1696111), // Rule ID 7251 //
     /* 1696030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1696041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1696044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1696047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696076 */     // MIs[0] policy
     /* 1696076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696110 */     // GIR_Coverage, 7251,
     /* 1696110 */     GIR_EraseRootFromParent_Done,
     /* 1696111 */   // Label 23218: @1696111
     /* 1696111 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1696197), // Rule ID 7254 //
     /* 1696116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1696127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1696130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1696133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696162 */     // MIs[0] policy
     /* 1696162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696172 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696196 */     // GIR_Coverage, 7254,
     /* 1696196 */     GIR_EraseRootFromParent_Done,
     /* 1696197 */   // Label 23219: @1696197
     /* 1696197 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1696283), // Rule ID 7255 //
     /* 1696202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1696213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1696216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1696219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696248 */     // MIs[0] policy
     /* 1696248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696282 */     // GIR_Coverage, 7255,
     /* 1696282 */     GIR_EraseRootFromParent_Done,
     /* 1696283 */   // Label 23220: @1696283
     /* 1696283 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1696369), // Rule ID 7258 //
     /* 1696288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1696299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1696302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1696305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1696318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696334 */     // MIs[0] policy
     /* 1696334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1696347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696368 */     // GIR_Coverage, 7258,
     /* 1696368 */     GIR_EraseRootFromParent_Done,
     /* 1696369 */   // Label 23221: @1696369
     /* 1696369 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1696455), // Rule ID 7259 //
     /* 1696374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1696385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1696388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1696391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1696404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696420 */     // MIs[0] policy
     /* 1696420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1696433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696454 */     // GIR_Coverage, 7259,
     /* 1696454 */     GIR_EraseRootFromParent_Done,
     /* 1696455 */   // Label 23222: @1696455
     /* 1696455 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1696541), // Rule ID 7438 //
     /* 1696460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1696471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1696474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1696477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1696480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696506 */     // MIs[0] policy
     /* 1696506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1696519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696540 */     // GIR_Coverage, 7438,
     /* 1696540 */     GIR_EraseRootFromParent_Done,
     /* 1696541 */   // Label 23223: @1696541
     /* 1696541 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1696627), // Rule ID 7439 //
     /* 1696546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1696557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1696560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1696563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1696566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696592 */     // MIs[0] policy
     /* 1696592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1696605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696626 */     // GIR_Coverage, 7439,
     /* 1696626 */     GIR_EraseRootFromParent_Done,
     /* 1696627 */   // Label 23224: @1696627
     /* 1696627 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1696713), // Rule ID 7442 //
     /* 1696632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1696643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1696646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1696652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696678 */     // MIs[0] policy
     /* 1696678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1696691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696712 */     // GIR_Coverage, 7442,
     /* 1696712 */     GIR_EraseRootFromParent_Done,
     /* 1696713 */   // Label 23225: @1696713
     /* 1696713 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1696799), // Rule ID 7443 //
     /* 1696718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1696729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1696732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1696735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1696738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696764 */     // MIs[0] policy
     /* 1696764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1696777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696798 */     // GIR_Coverage, 7443,
     /* 1696798 */     GIR_EraseRootFromParent_Done,
     /* 1696799 */   // Label 23226: @1696799
     /* 1696799 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1696885), // Rule ID 7446 //
     /* 1696804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1696815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1696818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1696824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696850 */     // MIs[0] policy
     /* 1696850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1696863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696884 */     // GIR_Coverage, 7446,
     /* 1696884 */     GIR_EraseRootFromParent_Done,
     /* 1696885 */   // Label 23227: @1696885
     /* 1696885 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1696971), // Rule ID 7447 //
     /* 1696890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1696901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1696904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1696910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696936 */     // MIs[0] policy
     /* 1696936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696946 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1696949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696970 */     // GIR_Coverage, 7447,
     /* 1696970 */     GIR_EraseRootFromParent_Done,
     /* 1696971 */   // Label 23228: @1696971
     /* 1696971 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1697057), // Rule ID 7450 //
     /* 1696976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1696993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1696996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697022 */     // MIs[0] policy
     /* 1697022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1697035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697056 */     // GIR_Coverage, 7450,
     /* 1697056 */     GIR_EraseRootFromParent_Done,
     /* 1697057 */   // Label 23229: @1697057
     /* 1697057 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1697143), // Rule ID 7451 //
     /* 1697062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1697073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1697076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1697082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697108 */     // MIs[0] policy
     /* 1697108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1697121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697142 */     // GIR_Coverage, 7451,
     /* 1697142 */     GIR_EraseRootFromParent_Done,
     /* 1697143 */   // Label 23230: @1697143
     /* 1697143 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1697229), // Rule ID 7454 //
     /* 1697148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1697168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697194 */     // MIs[0] policy
     /* 1697194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1697207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697228 */     // GIR_Coverage, 7454,
     /* 1697228 */     GIR_EraseRootFromParent_Done,
     /* 1697229 */   // Label 23231: @1697229
     /* 1697229 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1697315), // Rule ID 7455 //
     /* 1697234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1697254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697280 */     // MIs[0] policy
     /* 1697280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1697293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697314 */     // GIR_Coverage, 7455,
     /* 1697314 */     GIR_EraseRootFromParent_Done,
     /* 1697315 */   // Label 23232: @1697315
     /* 1697315 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1697401), // Rule ID 7458 //
     /* 1697320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1697340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697366 */     // MIs[0] policy
     /* 1697366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1697379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697400 */     // GIR_Coverage, 7458,
     /* 1697400 */     GIR_EraseRootFromParent_Done,
     /* 1697401 */   // Label 23233: @1697401
     /* 1697401 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1697487), // Rule ID 7459 //
     /* 1697406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1697417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1697420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1697426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697452 */     // MIs[0] policy
     /* 1697452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1697465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697486 */     // GIR_Coverage, 7459,
     /* 1697486 */     GIR_EraseRootFromParent_Done,
     /* 1697487 */   // Label 23234: @1697487
     /* 1697487 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1697573), // Rule ID 7462 //
     /* 1697492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1697503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1697506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1697509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1697512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697538 */     // MIs[0] policy
     /* 1697538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1697551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697572 */     // GIR_Coverage, 7462,
     /* 1697572 */     GIR_EraseRootFromParent_Done,
     /* 1697573 */   // Label 23235: @1697573
     /* 1697573 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1697659), // Rule ID 7463 //
     /* 1697578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1697589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1697592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1697595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1697598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697624 */     // MIs[0] policy
     /* 1697624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697634 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1697637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697658 */     // GIR_Coverage, 7463,
     /* 1697658 */     GIR_EraseRootFromParent_Done,
     /* 1697659 */   // Label 23236: @1697659
     /* 1697659 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1697745), // Rule ID 7466 //
     /* 1697664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1697675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1697678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1697681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1697684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1697687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697710 */     // MIs[0] policy
     /* 1697710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1697723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697744 */     // GIR_Coverage, 7466,
     /* 1697744 */     GIR_EraseRootFromParent_Done,
     /* 1697745 */   // Label 23237: @1697745
     /* 1697745 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1697831), // Rule ID 7467 //
     /* 1697750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1697761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1697764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1697767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1697770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1697773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697796 */     // MIs[0] policy
     /* 1697796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697806 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1697809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697830 */     // GIR_Coverage, 7467,
     /* 1697830 */     GIR_EraseRootFromParent_Done,
     /* 1697831 */   // Label 23238: @1697831
     /* 1697831 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1697917), // Rule ID 7470 //
     /* 1697836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1697847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1697850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1697856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697882 */     // MIs[0] policy
     /* 1697882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1697895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697916 */     // GIR_Coverage, 7470,
     /* 1697916 */     GIR_EraseRootFromParent_Done,
     /* 1697917 */   // Label 23239: @1697917
     /* 1697917 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1698003), // Rule ID 7471 //
     /* 1697922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1697933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1697936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1697942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697968 */     // MIs[0] policy
     /* 1697968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1697981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698002 */     // GIR_Coverage, 7471,
     /* 1698002 */     GIR_EraseRootFromParent_Done,
     /* 1698003 */   // Label 23240: @1698003
     /* 1698003 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1698089), // Rule ID 7474 //
     /* 1698008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1698019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1698022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1698028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698054 */     // MIs[0] policy
     /* 1698054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1698067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698088 */     // GIR_Coverage, 7474,
     /* 1698088 */     GIR_EraseRootFromParent_Done,
     /* 1698089 */   // Label 23241: @1698089
     /* 1698089 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1698175), // Rule ID 7475 //
     /* 1698094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1698105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1698108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1698114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698140 */     // MIs[0] policy
     /* 1698140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1698153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698174 */     // GIR_Coverage, 7475,
     /* 1698174 */     GIR_EraseRootFromParent_Done,
     /* 1698175 */   // Label 23242: @1698175
     /* 1698175 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1698261), // Rule ID 7478 //
     /* 1698180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1698191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1698194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1698200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698226 */     // MIs[0] policy
     /* 1698226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1698239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698260 */     // GIR_Coverage, 7478,
     /* 1698260 */     GIR_EraseRootFromParent_Done,
     /* 1698261 */   // Label 23243: @1698261
     /* 1698261 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1698347), // Rule ID 7479 //
     /* 1698266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1698277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1698280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1698286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698312 */     // MIs[0] policy
     /* 1698312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1698325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698346 */     // GIR_Coverage, 7479,
     /* 1698346 */     GIR_EraseRootFromParent_Done,
     /* 1698347 */   // Label 23244: @1698347
     /* 1698347 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1698433), // Rule ID 7482 //
     /* 1698352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1698355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1698363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1698366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1698369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1698372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698398 */     // MIs[0] policy
     /* 1698398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1698411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698432 */     // GIR_Coverage, 7482,
     /* 1698432 */     GIR_EraseRootFromParent_Done,
     /* 1698433 */   // Label 23245: @1698433
     /* 1698433 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1698519), // Rule ID 7483 //
     /* 1698438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1698441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1698449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1698452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1698455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1698458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698484 */     // MIs[0] policy
     /* 1698484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1698497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698518 */     // GIR_Coverage, 7483,
     /* 1698518 */     GIR_EraseRootFromParent_Done,
     /* 1698519 */   // Label 23246: @1698519
     /* 1698519 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1698605), // Rule ID 7486 //
     /* 1698524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1698527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1698535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1698538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1698544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698570 */     // MIs[0] policy
     /* 1698570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1698583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698604 */     // GIR_Coverage, 7486,
     /* 1698604 */     GIR_EraseRootFromParent_Done,
     /* 1698605 */   // Label 23247: @1698605
     /* 1698605 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1698691), // Rule ID 7487 //
     /* 1698610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1698613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1698621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1698624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1698630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698656 */     // MIs[0] policy
     /* 1698656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1698669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698690 */     // GIR_Coverage, 7487,
     /* 1698690 */     GIR_EraseRootFromParent_Done,
     /* 1698691 */   // Label 23248: @1698691
     /* 1698691 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1698777), // Rule ID 7490 //
     /* 1698696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1698699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1698716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698742 */     // MIs[0] policy
     /* 1698742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1698755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698776 */     // GIR_Coverage, 7490,
     /* 1698776 */     GIR_EraseRootFromParent_Done,
     /* 1698777 */   // Label 23249: @1698777
     /* 1698777 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1698863), // Rule ID 7491 //
     /* 1698782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1698785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1698793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1698796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1698802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698828 */     // MIs[0] policy
     /* 1698828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1698841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698862 */     // GIR_Coverage, 7491,
     /* 1698862 */     GIR_EraseRootFromParent_Done,
     /* 1698863 */   // Label 23250: @1698863
     /* 1698863 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1698949), // Rule ID 7494 //
     /* 1698868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1698871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1698888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698914 */     // MIs[0] policy
     /* 1698914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1698927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698948 */     // GIR_Coverage, 7494,
     /* 1698948 */     GIR_EraseRootFromParent_Done,
     /* 1698949 */   // Label 23251: @1698949
     /* 1698949 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1699035), // Rule ID 7495 //
     /* 1698954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1698957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1698965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1698968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1698974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699000 */     // MIs[0] policy
     /* 1699000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1699013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699034 */     // GIR_Coverage, 7495,
     /* 1699034 */     GIR_EraseRootFromParent_Done,
     /* 1699035 */   // Label 23252: @1699035
     /* 1699035 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1699121), // Rule ID 7498 //
     /* 1699040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699086 */     // MIs[0] policy
     /* 1699086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1699099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699120 */     // GIR_Coverage, 7498,
     /* 1699120 */     GIR_EraseRootFromParent_Done,
     /* 1699121 */   // Label 23253: @1699121
     /* 1699121 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1699207), // Rule ID 7499 //
     /* 1699126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699172 */     // MIs[0] policy
     /* 1699172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1699185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699206 */     // GIR_Coverage, 7499,
     /* 1699206 */     GIR_EraseRootFromParent_Done,
     /* 1699207 */   // Label 23254: @1699207
     /* 1699207 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1699293), // Rule ID 7502 //
     /* 1699212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699258 */     // MIs[0] policy
     /* 1699258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1699271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699292 */     // GIR_Coverage, 7502,
     /* 1699292 */     GIR_EraseRootFromParent_Done,
     /* 1699293 */   // Label 23255: @1699293
     /* 1699293 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1699379), // Rule ID 7503 //
     /* 1699298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1699309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1699312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1699315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699344 */     // MIs[0] policy
     /* 1699344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1699357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699378 */     // GIR_Coverage, 7503,
     /* 1699378 */     GIR_EraseRootFromParent_Done,
     /* 1699379 */   // Label 23256: @1699379
     /* 1699379 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1699465), // Rule ID 7506 //
     /* 1699384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699430 */     // MIs[0] policy
     /* 1699430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1699443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699464 */     // GIR_Coverage, 7506,
     /* 1699464 */     GIR_EraseRootFromParent_Done,
     /* 1699465 */   // Label 23257: @1699465
     /* 1699465 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1699551), // Rule ID 7507 //
     /* 1699470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699516 */     // MIs[0] policy
     /* 1699516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1699529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699550 */     // GIR_Coverage, 7507,
     /* 1699550 */     GIR_EraseRootFromParent_Done,
     /* 1699551 */   // Label 23258: @1699551
     /* 1699551 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1699637), // Rule ID 7510 //
     /* 1699556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699602 */     // MIs[0] policy
     /* 1699602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1699615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699636 */     // GIR_Coverage, 7510,
     /* 1699636 */     GIR_EraseRootFromParent_Done,
     /* 1699637 */   // Label 23259: @1699637
     /* 1699637 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1699723), // Rule ID 7511 //
     /* 1699642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699688 */     // MIs[0] policy
     /* 1699688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1699701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699722 */     // GIR_Coverage, 7511,
     /* 1699722 */     GIR_EraseRootFromParent_Done,
     /* 1699723 */   // Label 23260: @1699723
     /* 1699723 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1699809), // Rule ID 7514 //
     /* 1699728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699774 */     // MIs[0] policy
     /* 1699774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1699787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699808 */     // GIR_Coverage, 7514,
     /* 1699808 */     GIR_EraseRootFromParent_Done,
     /* 1699809 */   // Label 23261: @1699809
     /* 1699809 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1699895), // Rule ID 7515 //
     /* 1699814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699860 */     // MIs[0] policy
     /* 1699860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1699873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699894 */     // GIR_Coverage, 7515,
     /* 1699894 */     GIR_EraseRootFromParent_Done,
     /* 1699895 */   // Label 23262: @1699895
     /* 1699895 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1699981), // Rule ID 7518 //
     /* 1699900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1699914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1699917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1699923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699946 */     // MIs[0] policy
     /* 1699946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1699959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699980 */     // GIR_Coverage, 7518,
     /* 1699980 */     GIR_EraseRootFromParent_Done,
     /* 1699981 */   // Label 23263: @1699981
     /* 1699981 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1700067), // Rule ID 7519 //
     /* 1699986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700032 */     // MIs[0] policy
     /* 1700032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700042 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1700045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700066 */     // GIR_Coverage, 7519,
     /* 1700066 */     GIR_EraseRootFromParent_Done,
     /* 1700067 */   // Label 23264: @1700067
     /* 1700067 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1700153), // Rule ID 7522 //
     /* 1700072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700118 */     // MIs[0] policy
     /* 1700118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1700131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700152 */     // GIR_Coverage, 7522,
     /* 1700152 */     GIR_EraseRootFromParent_Done,
     /* 1700153 */   // Label 23265: @1700153
     /* 1700153 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1700239), // Rule ID 7523 //
     /* 1700158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700204 */     // MIs[0] policy
     /* 1700204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1700217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700238 */     // GIR_Coverage, 7523,
     /* 1700238 */     GIR_EraseRootFromParent_Done,
     /* 1700239 */   // Label 23266: @1700239
     /* 1700239 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1700325), // Rule ID 7526 //
     /* 1700244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700290 */     // MIs[0] policy
     /* 1700290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1700303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700324 */     // GIR_Coverage, 7526,
     /* 1700324 */     GIR_EraseRootFromParent_Done,
     /* 1700325 */   // Label 23267: @1700325
     /* 1700325 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1700411), // Rule ID 7527 //
     /* 1700330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1700341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1700344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700376 */     // MIs[0] policy
     /* 1700376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1700389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700410 */     // GIR_Coverage, 7527,
     /* 1700410 */     GIR_EraseRootFromParent_Done,
     /* 1700411 */   // Label 23268: @1700411
     /* 1700411 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1700497), // Rule ID 7530 //
     /* 1700416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700462 */     // MIs[0] policy
     /* 1700462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1700475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700496 */     // GIR_Coverage, 7530,
     /* 1700496 */     GIR_EraseRootFromParent_Done,
     /* 1700497 */   // Label 23269: @1700497
     /* 1700497 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1700583), // Rule ID 7531 //
     /* 1700502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700548 */     // MIs[0] policy
     /* 1700548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1700561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700582 */     // GIR_Coverage, 7531,
     /* 1700582 */     GIR_EraseRootFromParent_Done,
     /* 1700583 */   // Label 23270: @1700583
     /* 1700583 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1700669), // Rule ID 7534 //
     /* 1700588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700634 */     // MIs[0] policy
     /* 1700634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1700647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700668 */     // GIR_Coverage, 7534,
     /* 1700668 */     GIR_EraseRootFromParent_Done,
     /* 1700669 */   // Label 23271: @1700669
     /* 1700669 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1700755), // Rule ID 7535 //
     /* 1700674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700720 */     // MIs[0] policy
     /* 1700720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1700733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700754 */     // GIR_Coverage, 7535,
     /* 1700754 */     GIR_EraseRootFromParent_Done,
     /* 1700755 */   // Label 23272: @1700755
     /* 1700755 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1700841), // Rule ID 7538 //
     /* 1700760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700806 */     // MIs[0] policy
     /* 1700806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1700819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700840 */     // GIR_Coverage, 7538,
     /* 1700840 */     GIR_EraseRootFromParent_Done,
     /* 1700841 */   // Label 23273: @1700841
     /* 1700841 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1700927), // Rule ID 7539 //
     /* 1700846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700892 */     // MIs[0] policy
     /* 1700892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1700905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700926 */     // GIR_Coverage, 7539,
     /* 1700926 */     GIR_EraseRootFromParent_Done,
     /* 1700927 */   // Label 23274: @1700927
     /* 1700927 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1701013), // Rule ID 7542 //
     /* 1700932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700978 */     // MIs[0] policy
     /* 1700978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700988 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1700991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701012 */     // GIR_Coverage, 7542,
     /* 1701012 */     GIR_EraseRootFromParent_Done,
     /* 1701013 */   // Label 23275: @1701013
     /* 1701013 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1701099), // Rule ID 7543 //
     /* 1701018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701064 */     // MIs[0] policy
     /* 1701064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1701077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701098 */     // GIR_Coverage, 7543,
     /* 1701098 */     GIR_EraseRootFromParent_Done,
     /* 1701099 */   // Label 23276: @1701099
     /* 1701099 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1701185), // Rule ID 7546 //
     /* 1701104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701150 */     // MIs[0] policy
     /* 1701150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701184 */     // GIR_Coverage, 7546,
     /* 1701184 */     GIR_EraseRootFromParent_Done,
     /* 1701185 */   // Label 23277: @1701185
     /* 1701185 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1701271), // Rule ID 7547 //
     /* 1701190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701236 */     // MIs[0] policy
     /* 1701236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701270 */     // GIR_Coverage, 7547,
     /* 1701270 */     GIR_EraseRootFromParent_Done,
     /* 1701271 */   // Label 23278: @1701271
     /* 1701271 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1701357), // Rule ID 7550 //
     /* 1701276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701322 */     // MIs[0] policy
     /* 1701322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1701335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701356 */     // GIR_Coverage, 7550,
     /* 1701356 */     GIR_EraseRootFromParent_Done,
     /* 1701357 */   // Label 23279: @1701357
     /* 1701357 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1701443), // Rule ID 7551 //
     /* 1701362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701408 */     // MIs[0] policy
     /* 1701408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1701421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701442 */     // GIR_Coverage, 7551,
     /* 1701442 */     GIR_EraseRootFromParent_Done,
     /* 1701443 */   // Label 23280: @1701443
     /* 1701443 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1701529), // Rule ID 7554 //
     /* 1701448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701494 */     // MIs[0] policy
     /* 1701494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701504 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1701507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701528 */     // GIR_Coverage, 7554,
     /* 1701528 */     GIR_EraseRootFromParent_Done,
     /* 1701529 */   // Label 23281: @1701529
     /* 1701529 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1701615), // Rule ID 7555 //
     /* 1701534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701580 */     // MIs[0] policy
     /* 1701580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1701593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701614 */     // GIR_Coverage, 7555,
     /* 1701614 */     GIR_EraseRootFromParent_Done,
     /* 1701615 */   // Label 23282: @1701615
     /* 1701615 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1701701), // Rule ID 7618 //
     /* 1701620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1701640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701666 */     // MIs[0] policy
     /* 1701666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1701679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701700 */     // GIR_Coverage, 7618,
     /* 1701700 */     GIR_EraseRootFromParent_Done,
     /* 1701701 */   // Label 23283: @1701701
     /* 1701701 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1701787), // Rule ID 7619 //
     /* 1701706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1701726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701752 */     // MIs[0] policy
     /* 1701752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1701765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701786 */     // GIR_Coverage, 7619,
     /* 1701786 */     GIR_EraseRootFromParent_Done,
     /* 1701787 */   // Label 23284: @1701787
     /* 1701787 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1701873), // Rule ID 7622 //
     /* 1701792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1701812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701838 */     // MIs[0] policy
     /* 1701838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1701851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701872 */     // GIR_Coverage, 7622,
     /* 1701872 */     GIR_EraseRootFromParent_Done,
     /* 1701873 */   // Label 23285: @1701873
     /* 1701873 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1701959), // Rule ID 7623 //
     /* 1701878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1701898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701924 */     // MIs[0] policy
     /* 1701924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1701937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701958 */     // GIR_Coverage, 7623,
     /* 1701958 */     GIR_EraseRootFromParent_Done,
     /* 1701959 */   // Label 23286: @1701959
     /* 1701959 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1702045), // Rule ID 7626 //
     /* 1701964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1701975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1701978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1701981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1701984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702010 */     // MIs[0] policy
     /* 1702010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1702023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702044 */     // GIR_Coverage, 7626,
     /* 1702044 */     GIR_EraseRootFromParent_Done,
     /* 1702045 */   // Label 23287: @1702045
     /* 1702045 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1702131), // Rule ID 7627 //
     /* 1702050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1702067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1702070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702096 */     // MIs[0] policy
     /* 1702096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1702109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702130 */     // GIR_Coverage, 7627,
     /* 1702130 */     GIR_EraseRootFromParent_Done,
     /* 1702131 */   // Label 23288: @1702131
     /* 1702131 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1702217), // Rule ID 7630 //
     /* 1702136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1702156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702182 */     // MIs[0] policy
     /* 1702182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1702195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702216 */     // GIR_Coverage, 7630,
     /* 1702216 */     GIR_EraseRootFromParent_Done,
     /* 1702217 */   // Label 23289: @1702217
     /* 1702217 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1702303), // Rule ID 7631 //
     /* 1702222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1702233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1702236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1702239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1702242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702268 */     // MIs[0] policy
     /* 1702268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1702281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702302 */     // GIR_Coverage, 7631,
     /* 1702302 */     GIR_EraseRootFromParent_Done,
     /* 1702303 */   // Label 23290: @1702303
     /* 1702303 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1702389), // Rule ID 7634 //
     /* 1702308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1702328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702354 */     // MIs[0] policy
     /* 1702354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1702367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702388 */     // GIR_Coverage, 7634,
     /* 1702388 */     GIR_EraseRootFromParent_Done,
     /* 1702389 */   // Label 23291: @1702389
     /* 1702389 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1702475), // Rule ID 7635 //
     /* 1702394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1702414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702440 */     // MIs[0] policy
     /* 1702440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1702453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702474 */     // GIR_Coverage, 7635,
     /* 1702474 */     GIR_EraseRootFromParent_Done,
     /* 1702475 */   // Label 23292: @1702475
     /* 1702475 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1702561), // Rule ID 7638 //
     /* 1702480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1702500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702526 */     // MIs[0] policy
     /* 1702526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702536 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1702539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702560 */     // GIR_Coverage, 7638,
     /* 1702560 */     GIR_EraseRootFromParent_Done,
     /* 1702561 */   // Label 23293: @1702561
     /* 1702561 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1702647), // Rule ID 7639 //
     /* 1702566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1702586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702612 */     // MIs[0] policy
     /* 1702612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702622 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1702625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702646 */     // GIR_Coverage, 7639,
     /* 1702646 */     GIR_EraseRootFromParent_Done,
     /* 1702647 */   // Label 23294: @1702647
     /* 1702647 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1702733), // Rule ID 7642 //
     /* 1702652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1702672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702698 */     // MIs[0] policy
     /* 1702698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1702711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702732 */     // GIR_Coverage, 7642,
     /* 1702732 */     GIR_EraseRootFromParent_Done,
     /* 1702733 */   // Label 23295: @1702733
     /* 1702733 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1702819), // Rule ID 7643 //
     /* 1702738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1702758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702784 */     // MIs[0] policy
     /* 1702784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1702797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702818 */     // GIR_Coverage, 7643,
     /* 1702818 */     GIR_EraseRootFromParent_Done,
     /* 1702819 */   // Label 23296: @1702819
     /* 1702819 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1702905), // Rule ID 7646 //
     /* 1702824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1702844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702870 */     // MIs[0] policy
     /* 1702870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1702883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702904 */     // GIR_Coverage, 7646,
     /* 1702904 */     GIR_EraseRootFromParent_Done,
     /* 1702905 */   // Label 23297: @1702905
     /* 1702905 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1702991), // Rule ID 7647 //
     /* 1702910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1702930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702956 */     // MIs[0] policy
     /* 1702956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1702969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702990 */     // GIR_Coverage, 7647,
     /* 1702990 */     GIR_EraseRootFromParent_Done,
     /* 1702991 */   // Label 23298: @1702991
     /* 1702991 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1703077), // Rule ID 7650 //
     /* 1702996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1703016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703042 */     // MIs[0] policy
     /* 1703042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1703055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703076 */     // GIR_Coverage, 7650,
     /* 1703076 */     GIR_EraseRootFromParent_Done,
     /* 1703077 */   // Label 23299: @1703077
     /* 1703077 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1703163), // Rule ID 7651 //
     /* 1703082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1703099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1703102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703128 */     // MIs[0] policy
     /* 1703128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1703141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703162 */     // GIR_Coverage, 7651,
     /* 1703162 */     GIR_EraseRootFromParent_Done,
     /* 1703163 */   // Label 23300: @1703163
     /* 1703163 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1703249), // Rule ID 7654 //
     /* 1703168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1703188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703214 */     // MIs[0] policy
     /* 1703214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1703227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703248 */     // GIR_Coverage, 7654,
     /* 1703248 */     GIR_EraseRootFromParent_Done,
     /* 1703249 */   // Label 23301: @1703249
     /* 1703249 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1703335), // Rule ID 7655 //
     /* 1703254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1703265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1703268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1703271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1703274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703300 */     // MIs[0] policy
     /* 1703300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1703313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703334 */     // GIR_Coverage, 7655,
     /* 1703334 */     GIR_EraseRootFromParent_Done,
     /* 1703335 */   // Label 23302: @1703335
     /* 1703335 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1703421), // Rule ID 7658 //
     /* 1703340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1703360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703386 */     // MIs[0] policy
     /* 1703386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1703399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703420 */     // GIR_Coverage, 7658,
     /* 1703420 */     GIR_EraseRootFromParent_Done,
     /* 1703421 */   // Label 23303: @1703421
     /* 1703421 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1703507), // Rule ID 7659 //
     /* 1703426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1703446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703472 */     // MIs[0] policy
     /* 1703472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1703485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703506 */     // GIR_Coverage, 7659,
     /* 1703506 */     GIR_EraseRootFromParent_Done,
     /* 1703507 */   // Label 23304: @1703507
     /* 1703507 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1703593), // Rule ID 7662 //
     /* 1703512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1703532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703558 */     // MIs[0] policy
     /* 1703558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1703571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703592 */     // GIR_Coverage, 7662,
     /* 1703592 */     GIR_EraseRootFromParent_Done,
     /* 1703593 */   // Label 23305: @1703593
     /* 1703593 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1703679), // Rule ID 7663 //
     /* 1703598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1703618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703644 */     // MIs[0] policy
     /* 1703644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1703657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703678 */     // GIR_Coverage, 7663,
     /* 1703678 */     GIR_EraseRootFromParent_Done,
     /* 1703679 */   // Label 23306: @1703679
     /* 1703679 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1703765), // Rule ID 7666 //
     /* 1703684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1703704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703730 */     // MIs[0] policy
     /* 1703730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1703743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703764 */     // GIR_Coverage, 7666,
     /* 1703764 */     GIR_EraseRootFromParent_Done,
     /* 1703765 */   // Label 23307: @1703765
     /* 1703765 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1703851), // Rule ID 7667 //
     /* 1703770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1703790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703816 */     // MIs[0] policy
     /* 1703816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1703829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703850 */     // GIR_Coverage, 7667,
     /* 1703850 */     GIR_EraseRootFromParent_Done,
     /* 1703851 */   // Label 23308: @1703851
     /* 1703851 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1703937), // Rule ID 7670 //
     /* 1703856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1703876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703902 */     // MIs[0] policy
     /* 1703902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1703915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703936 */     // GIR_Coverage, 7670,
     /* 1703936 */     GIR_EraseRootFromParent_Done,
     /* 1703937 */   // Label 23309: @1703937
     /* 1703937 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1704023), // Rule ID 7671 //
     /* 1703942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1703962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703988 */     // MIs[0] policy
     /* 1703988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1704001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704022 */     // GIR_Coverage, 7671,
     /* 1704022 */     GIR_EraseRootFromParent_Done,
     /* 1704023 */   // Label 23310: @1704023
     /* 1704023 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1704109), // Rule ID 7674 //
     /* 1704028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1704031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1704048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704074 */     // MIs[0] policy
     /* 1704074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704108 */     // GIR_Coverage, 7674,
     /* 1704108 */     GIR_EraseRootFromParent_Done,
     /* 1704109 */   // Label 23311: @1704109
     /* 1704109 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1704195), // Rule ID 7675 //
     /* 1704114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1704117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1704125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1704128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1704131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1704134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704160 */     // MIs[0] policy
     /* 1704160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704170 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1704191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704194 */     // GIR_Coverage, 7675,
     /* 1704194 */     GIR_EraseRootFromParent_Done,
     /* 1704195 */   // Label 23312: @1704195
     /* 1704195 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1704281), // Rule ID 7678 //
     /* 1704200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704246 */     // MIs[0] policy
     /* 1704246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704256 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1704259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704280 */     // GIR_Coverage, 7678,
     /* 1704280 */     GIR_EraseRootFromParent_Done,
     /* 1704281 */   // Label 23313: @1704281
     /* 1704281 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1704367), // Rule ID 7679 //
     /* 1704286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1704297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1704300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1704303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704332 */     // MIs[0] policy
     /* 1704332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1704345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704366 */     // GIR_Coverage, 7679,
     /* 1704366 */     GIR_EraseRootFromParent_Done,
     /* 1704367 */   // Label 23314: @1704367
     /* 1704367 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1704453), // Rule ID 7682 //
     /* 1704372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704418 */     // MIs[0] policy
     /* 1704418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704428 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1704431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704452 */     // GIR_Coverage, 7682,
     /* 1704452 */     GIR_EraseRootFromParent_Done,
     /* 1704453 */   // Label 23315: @1704453
     /* 1704453 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1704539), // Rule ID 7683 //
     /* 1704458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704504 */     // MIs[0] policy
     /* 1704504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1704517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704538 */     // GIR_Coverage, 7683,
     /* 1704538 */     GIR_EraseRootFromParent_Done,
     /* 1704539 */   // Label 23316: @1704539
     /* 1704539 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1704625), // Rule ID 7686 //
     /* 1704544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704590 */     // MIs[0] policy
     /* 1704590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704600 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1704603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704624 */     // GIR_Coverage, 7686,
     /* 1704624 */     GIR_EraseRootFromParent_Done,
     /* 1704625 */   // Label 23317: @1704625
     /* 1704625 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1704711), // Rule ID 7687 //
     /* 1704630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704676 */     // MIs[0] policy
     /* 1704676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1704689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704710 */     // GIR_Coverage, 7687,
     /* 1704710 */     GIR_EraseRootFromParent_Done,
     /* 1704711 */   // Label 23318: @1704711
     /* 1704711 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1704797), // Rule ID 7690 //
     /* 1704716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704762 */     // MIs[0] policy
     /* 1704762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1704775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704796 */     // GIR_Coverage, 7690,
     /* 1704796 */     GIR_EraseRootFromParent_Done,
     /* 1704797 */   // Label 23319: @1704797
     /* 1704797 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1704883), // Rule ID 7691 //
     /* 1704802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704848 */     // MIs[0] policy
     /* 1704848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1704861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704882 */     // GIR_Coverage, 7691,
     /* 1704882 */     GIR_EraseRootFromParent_Done,
     /* 1704883 */   // Label 23320: @1704883
     /* 1704883 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1704969), // Rule ID 7694 //
     /* 1704888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1704908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1704930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704934 */     // MIs[0] policy
     /* 1704934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1704947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704968 */     // GIR_Coverage, 7694,
     /* 1704968 */     GIR_EraseRootFromParent_Done,
     /* 1704969 */   // Label 23321: @1704969
     /* 1704969 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1705055), // Rule ID 7695 //
     /* 1704974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1704994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705020 */     // MIs[0] policy
     /* 1705020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1705033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705054 */     // GIR_Coverage, 7695,
     /* 1705054 */     GIR_EraseRootFromParent_Done,
     /* 1705055 */   // Label 23322: @1705055
     /* 1705055 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1705141), // Rule ID 7698 //
     /* 1705060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705106 */     // MIs[0] policy
     /* 1705106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705116 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1705119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705140 */     // GIR_Coverage, 7698,
     /* 1705140 */     GIR_EraseRootFromParent_Done,
     /* 1705141 */   // Label 23323: @1705141
     /* 1705141 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1705227), // Rule ID 7699 //
     /* 1705146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1705157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1705160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705192 */     // MIs[0] policy
     /* 1705192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1705205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1705223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705226 */     // GIR_Coverage, 7699,
     /* 1705226 */     GIR_EraseRootFromParent_Done,
     /* 1705227 */   // Label 23324: @1705227
     /* 1705227 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1705313), // Rule ID 7702 //
     /* 1705232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705278 */     // MIs[0] policy
     /* 1705278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705288 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1705291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705312 */     // GIR_Coverage, 7702,
     /* 1705312 */     GIR_EraseRootFromParent_Done,
     /* 1705313 */   // Label 23325: @1705313
     /* 1705313 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1705399), // Rule ID 7703 //
     /* 1705318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1705329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1705332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1705335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705364 */     // MIs[0] policy
     /* 1705364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1705377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705398 */     // GIR_Coverage, 7703,
     /* 1705398 */     GIR_EraseRootFromParent_Done,
     /* 1705399 */   // Label 23326: @1705399
     /* 1705399 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1705485), // Rule ID 7706 //
     /* 1705404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705450 */     // MIs[0] policy
     /* 1705450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1705463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705484 */     // GIR_Coverage, 7706,
     /* 1705484 */     GIR_EraseRootFromParent_Done,
     /* 1705485 */   // Label 23327: @1705485
     /* 1705485 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1705571), // Rule ID 7707 //
     /* 1705490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705536 */     // MIs[0] policy
     /* 1705536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1705549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705570 */     // GIR_Coverage, 7707,
     /* 1705570 */     GIR_EraseRootFromParent_Done,
     /* 1705571 */   // Label 23328: @1705571
     /* 1705571 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1705657), // Rule ID 7710 //
     /* 1705576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705622 */     // MIs[0] policy
     /* 1705622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1705635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705656 */     // GIR_Coverage, 7710,
     /* 1705656 */     GIR_EraseRootFromParent_Done,
     /* 1705657 */   // Label 23329: @1705657
     /* 1705657 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1705743), // Rule ID 7711 //
     /* 1705662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705708 */     // MIs[0] policy
     /* 1705708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1705721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705742 */     // GIR_Coverage, 7711,
     /* 1705742 */     GIR_EraseRootFromParent_Done,
     /* 1705743 */   // Label 23330: @1705743
     /* 1705743 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1705829), // Rule ID 7714 //
     /* 1705748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705794 */     // MIs[0] policy
     /* 1705794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1705807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705828 */     // GIR_Coverage, 7714,
     /* 1705828 */     GIR_EraseRootFromParent_Done,
     /* 1705829 */   // Label 23331: @1705829
     /* 1705829 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1705915), // Rule ID 7715 //
     /* 1705834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1705854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705880 */     // MIs[0] policy
     /* 1705880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1705893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705914 */     // GIR_Coverage, 7715,
     /* 1705914 */     GIR_EraseRootFromParent_Done,
     /* 1705915 */   // Label 23332: @1705915
     /* 1705915 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1706001), // Rule ID 7718 //
     /* 1705920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1705940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1705962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705966 */     // MIs[0] policy
     /* 1705966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1705979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706000 */     // GIR_Coverage, 7718,
     /* 1706000 */     GIR_EraseRootFromParent_Done,
     /* 1706001 */   // Label 23333: @1706001
     /* 1706001 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1706087), // Rule ID 7719 //
     /* 1706006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1706017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1706020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1706023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1706029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706052 */     // MIs[0] policy
     /* 1706052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1706065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706086 */     // GIR_Coverage, 7719,
     /* 1706086 */     GIR_EraseRootFromParent_Done,
     /* 1706087 */   // Label 23334: @1706087
     /* 1706087 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1706173), // Rule ID 7722 //
     /* 1706092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706138 */     // MIs[0] policy
     /* 1706138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706172 */     // GIR_Coverage, 7722,
     /* 1706172 */     GIR_EraseRootFromParent_Done,
     /* 1706173 */   // Label 23335: @1706173
     /* 1706173 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1706259), // Rule ID 7723 //
     /* 1706178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1706189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1706192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1706195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706224 */     // MIs[0] policy
     /* 1706224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706258 */     // GIR_Coverage, 7723,
     /* 1706258 */     GIR_EraseRootFromParent_Done,
     /* 1706259 */   // Label 23336: @1706259
     /* 1706259 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1706345), // Rule ID 7726 //
     /* 1706264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706310 */     // MIs[0] policy
     /* 1706310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1706323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706344 */     // GIR_Coverage, 7726,
     /* 1706344 */     GIR_EraseRootFromParent_Done,
     /* 1706345 */   // Label 23337: @1706345
     /* 1706345 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1706431), // Rule ID 7727 //
     /* 1706350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706396 */     // MIs[0] policy
     /* 1706396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1706409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706430 */     // GIR_Coverage, 7727,
     /* 1706430 */     GIR_EraseRootFromParent_Done,
     /* 1706431 */   // Label 23338: @1706431
     /* 1706431 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1706517), // Rule ID 7730 //
     /* 1706436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706482 */     // MIs[0] policy
     /* 1706482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1706495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706516 */     // GIR_Coverage, 7730,
     /* 1706516 */     GIR_EraseRootFromParent_Done,
     /* 1706517 */   // Label 23339: @1706517
     /* 1706517 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1706603), // Rule ID 7731 //
     /* 1706522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706568 */     // MIs[0] policy
     /* 1706568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11431:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1706581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706602 */     // GIR_Coverage, 7731,
     /* 1706602 */     GIR_EraseRootFromParent_Done,
     /* 1706603 */   // Label 23340: @1706603
     /* 1706603 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1706689), // Rule ID 7734 //
     /* 1706608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706654 */     // MIs[0] policy
     /* 1706654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1706667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706688 */     // GIR_Coverage, 7734,
     /* 1706688 */     GIR_EraseRootFromParent_Done,
     /* 1706689 */   // Label 23341: @1706689
     /* 1706689 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1706775), // Rule ID 7735 //
     /* 1706694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706740 */     // MIs[0] policy
     /* 1706740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11431:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1706753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706774 */     // GIR_Coverage, 7735,
     /* 1706774 */     GIR_EraseRootFromParent_Done,
     /* 1706775 */   // Label 23342: @1706775
     /* 1706775 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1706861), // Rule ID 10250 //
     /* 1706780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1706797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1706800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706826 */     // MIs[0] policy
     /* 1706826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1706839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706860 */     // GIR_Coverage, 10250,
     /* 1706860 */     GIR_EraseRootFromParent_Done,
     /* 1706861 */   // Label 23343: @1706861
     /* 1706861 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1706947), // Rule ID 10251 //
     /* 1706866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1706883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1706886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706912 */     // MIs[0] policy
     /* 1706912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1706925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706946 */     // GIR_Coverage, 10251,
     /* 1706946 */     GIR_EraseRootFromParent_Done,
     /* 1706947 */   // Label 23344: @1706947
     /* 1706947 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1707033), // Rule ID 10254 //
     /* 1706952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1706969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1706972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706998 */     // MIs[0] policy
     /* 1706998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1707011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707032 */     // GIR_Coverage, 10254,
     /* 1707032 */     GIR_EraseRootFromParent_Done,
     /* 1707033 */   // Label 23345: @1707033
     /* 1707033 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1707119), // Rule ID 10255 //
     /* 1707038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1707049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1707052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1707055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1707058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707084 */     // MIs[0] policy
     /* 1707084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1707097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707118 */     // GIR_Coverage, 10255,
     /* 1707118 */     GIR_EraseRootFromParent_Done,
     /* 1707119 */   // Label 23346: @1707119
     /* 1707119 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1707205), // Rule ID 10258 //
     /* 1707124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1707141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1707144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707170 */     // MIs[0] policy
     /* 1707170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707204 */     // GIR_Coverage, 10258,
     /* 1707204 */     GIR_EraseRootFromParent_Done,
     /* 1707205 */   // Label 23347: @1707205
     /* 1707205 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1707291), // Rule ID 10259 //
     /* 1707210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1707221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1707224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1707227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1707230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707256 */     // MIs[0] policy
     /* 1707256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707290 */     // GIR_Coverage, 10259,
     /* 1707290 */     GIR_EraseRootFromParent_Done,
     /* 1707291 */   // Label 23348: @1707291
     /* 1707291 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1707377), // Rule ID 10262 //
     /* 1707296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1707316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707342 */     // MIs[0] policy
     /* 1707342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1707355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707376 */     // GIR_Coverage, 10262,
     /* 1707376 */     GIR_EraseRootFromParent_Done,
     /* 1707377 */   // Label 23349: @1707377
     /* 1707377 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1707463), // Rule ID 10263 //
     /* 1707382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1707399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1707402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707428 */     // MIs[0] policy
     /* 1707428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1707441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707462 */     // GIR_Coverage, 10263,
     /* 1707462 */     GIR_EraseRootFromParent_Done,
     /* 1707463 */   // Label 23350: @1707463
     /* 1707463 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1707549), // Rule ID 10266 //
     /* 1707468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1707488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707514 */     // MIs[0] policy
     /* 1707514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707548 */     // GIR_Coverage, 10266,
     /* 1707548 */     GIR_EraseRootFromParent_Done,
     /* 1707549 */   // Label 23351: @1707549
     /* 1707549 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1707635), // Rule ID 10267 //
     /* 1707554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1707574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707600 */     // MIs[0] policy
     /* 1707600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707634 */     // GIR_Coverage, 10267,
     /* 1707634 */     GIR_EraseRootFromParent_Done,
     /* 1707635 */   // Label 23352: @1707635
     /* 1707635 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1707721), // Rule ID 10270 //
     /* 1707640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1707660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707686 */     // MIs[0] policy
     /* 1707686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707720 */     // GIR_Coverage, 10270,
     /* 1707720 */     GIR_EraseRootFromParent_Done,
     /* 1707721 */   // Label 23353: @1707721
     /* 1707721 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1707807), // Rule ID 10271 //
     /* 1707726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1707746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707772 */     // MIs[0] policy
     /* 1707772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1707785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707806 */     // GIR_Coverage, 10271,
     /* 1707806 */     GIR_EraseRootFromParent_Done,
     /* 1707807 */   // Label 23354: @1707807
     /* 1707807 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1707893), // Rule ID 10274 //
     /* 1707812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1707832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707858 */     // MIs[0] policy
     /* 1707858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1707871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707892 */     // GIR_Coverage, 10274,
     /* 1707892 */     GIR_EraseRootFromParent_Done,
     /* 1707893 */   // Label 23355: @1707893
     /* 1707893 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1707979), // Rule ID 10275 //
     /* 1707898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1707918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707944 */     // MIs[0] policy
     /* 1707944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1707957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707978 */     // GIR_Coverage, 10275,
     /* 1707978 */     GIR_EraseRootFromParent_Done,
     /* 1707979 */   // Label 23356: @1707979
     /* 1707979 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1708065), // Rule ID 10278 //
     /* 1707984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1708004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708030 */     // MIs[0] policy
     /* 1708030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708064 */     // GIR_Coverage, 10278,
     /* 1708064 */     GIR_EraseRootFromParent_Done,
     /* 1708065 */   // Label 23357: @1708065
     /* 1708065 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1708151), // Rule ID 10279 //
     /* 1708070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1708081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1708084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1708087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1708090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708116 */     // MIs[0] policy
     /* 1708116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708150 */     // GIR_Coverage, 10279,
     /* 1708150 */     GIR_EraseRootFromParent_Done,
     /* 1708151 */   // Label 23358: @1708151
     /* 1708151 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1708237), // Rule ID 10282 //
     /* 1708156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1708176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708202 */     // MIs[0] policy
     /* 1708202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708236 */     // GIR_Coverage, 10282,
     /* 1708236 */     GIR_EraseRootFromParent_Done,
     /* 1708237 */   // Label 23359: @1708237
     /* 1708237 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1708323), // Rule ID 10283 //
     /* 1708242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1708259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1708262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708288 */     // MIs[0] policy
     /* 1708288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708322 */     // GIR_Coverage, 10283,
     /* 1708322 */     GIR_EraseRootFromParent_Done,
     /* 1708323 */   // Label 23360: @1708323
     /* 1708323 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1708409), // Rule ID 10286 //
     /* 1708328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1708331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1708339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1708342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1708348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708374 */     // MIs[0] policy
     /* 1708374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1708405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708408 */     // GIR_Coverage, 10286,
     /* 1708408 */     GIR_EraseRootFromParent_Done,
     /* 1708409 */   // Label 23361: @1708409
     /* 1708409 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1708495), // Rule ID 10287 //
     /* 1708414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1708417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1708425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1708428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1708434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708460 */     // MIs[0] policy
     /* 1708460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1708473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1708491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708494 */     // GIR_Coverage, 10287,
     /* 1708494 */     GIR_EraseRootFromParent_Done,
     /* 1708495 */   // Label 23362: @1708495
     /* 1708495 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1708581), // Rule ID 10290 //
     /* 1708500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1708511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1708514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1708517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1708520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708546 */     // MIs[0] policy
     /* 1708546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1708559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708580 */     // GIR_Coverage, 10290,
     /* 1708580 */     GIR_EraseRootFromParent_Done,
     /* 1708581 */   // Label 23363: @1708581
     /* 1708581 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1708667), // Rule ID 10291 //
     /* 1708586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1708597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1708600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1708603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1708606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708632 */     // MIs[0] policy
     /* 1708632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1708645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708666 */     // GIR_Coverage, 10291,
     /* 1708666 */     GIR_EraseRootFromParent_Done,
     /* 1708667 */   // Label 23364: @1708667
     /* 1708667 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1708753), // Rule ID 10294 //
     /* 1708672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1708689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1708692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708718 */     // MIs[0] policy
     /* 1708718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708728 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1708731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708752 */     // GIR_Coverage, 10294,
     /* 1708752 */     GIR_EraseRootFromParent_Done,
     /* 1708753 */   // Label 23365: @1708753
     /* 1708753 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1708839), // Rule ID 10295 //
     /* 1708758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1708775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1708778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708804 */     // MIs[0] policy
     /* 1708804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1708817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708838 */     // GIR_Coverage, 10295,
     /* 1708838 */     GIR_EraseRootFromParent_Done,
     /* 1708839 */   // Label 23366: @1708839
     /* 1708839 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1708925), // Rule ID 10298 //
     /* 1708844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1708855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1708858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1708861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1708864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1708867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708890 */     // MIs[0] policy
     /* 1708890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708900 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1708903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708924 */     // GIR_Coverage, 10298,
     /* 1708924 */     GIR_EraseRootFromParent_Done,
     /* 1708925 */   // Label 23367: @1708925
     /* 1708925 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1709011), // Rule ID 10299 //
     /* 1708930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1708941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1708944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1708947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1708950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1708953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708976 */     // MIs[0] policy
     /* 1708976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1708989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709010 */     // GIR_Coverage, 10299,
     /* 1709010 */     GIR_EraseRootFromParent_Done,
     /* 1709011 */   // Label 23368: @1709011
     /* 1709011 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1709097), // Rule ID 10302 //
     /* 1709016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1709027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1709030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1709033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1709036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709062 */     // MIs[0] policy
     /* 1709062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1709075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709096 */     // GIR_Coverage, 10302,
     /* 1709096 */     GIR_EraseRootFromParent_Done,
     /* 1709097 */   // Label 23369: @1709097
     /* 1709097 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1709183), // Rule ID 10303 //
     /* 1709102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1709113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1709116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1709119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1709122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709148 */     // MIs[0] policy
     /* 1709148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1709161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709182 */     // GIR_Coverage, 10303,
     /* 1709182 */     GIR_EraseRootFromParent_Done,
     /* 1709183 */   // Label 23370: @1709183
     /* 1709183 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1709269), // Rule ID 10306 //
     /* 1709188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1709199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1709202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1709205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1709208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709234 */     // MIs[0] policy
     /* 1709234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1709247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709268 */     // GIR_Coverage, 10306,
     /* 1709268 */     GIR_EraseRootFromParent_Done,
     /* 1709269 */   // Label 23371: @1709269
     /* 1709269 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1709355), // Rule ID 10307 //
     /* 1709274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1709285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1709288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1709291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1709294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709320 */     // MIs[0] policy
     /* 1709320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709330 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1709333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709354 */     // GIR_Coverage, 10307,
     /* 1709354 */     GIR_EraseRootFromParent_Done,
     /* 1709355 */   // Label 23372: @1709355
     /* 1709355 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1709441), // Rule ID 10310 //
     /* 1709360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1709371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1709374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1709377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1709380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1709383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709406 */     // MIs[0] policy
     /* 1709406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1709419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709440 */     // GIR_Coverage, 10310,
     /* 1709440 */     GIR_EraseRootFromParent_Done,
     /* 1709441 */   // Label 23373: @1709441
     /* 1709441 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1709527), // Rule ID 10311 //
     /* 1709446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1709457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1709460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1709463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1709466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1709469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709492 */     // MIs[0] policy
     /* 1709492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1709505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709526 */     // GIR_Coverage, 10311,
     /* 1709526 */     GIR_EraseRootFromParent_Done,
     /* 1709527 */   // Label 23374: @1709527
     /* 1709527 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1709613), // Rule ID 10314 //
     /* 1709532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1709552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709578 */     // MIs[0] policy
     /* 1709578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1709591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709612 */     // GIR_Coverage, 10314,
     /* 1709612 */     GIR_EraseRootFromParent_Done,
     /* 1709613 */   // Label 23375: @1709613
     /* 1709613 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1709699), // Rule ID 10315 //
     /* 1709618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1709638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709664 */     // MIs[0] policy
     /* 1709664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1709677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709698 */     // GIR_Coverage, 10315,
     /* 1709698 */     GIR_EraseRootFromParent_Done,
     /* 1709699 */   // Label 23376: @1709699
     /* 1709699 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1709785), // Rule ID 10318 //
     /* 1709704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1709724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709750 */     // MIs[0] policy
     /* 1709750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1709763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709784 */     // GIR_Coverage, 10318,
     /* 1709784 */     GIR_EraseRootFromParent_Done,
     /* 1709785 */   // Label 23377: @1709785
     /* 1709785 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1709871), // Rule ID 10319 //
     /* 1709790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1709810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709836 */     // MIs[0] policy
     /* 1709836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1709849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709870 */     // GIR_Coverage, 10319,
     /* 1709870 */     GIR_EraseRootFromParent_Done,
     /* 1709871 */   // Label 23378: @1709871
     /* 1709871 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1709957), // Rule ID 10322 //
     /* 1709876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1709887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1709890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1709896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709922 */     // MIs[0] policy
     /* 1709922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1709935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709956 */     // GIR_Coverage, 10322,
     /* 1709956 */     GIR_EraseRootFromParent_Done,
     /* 1709957 */   // Label 23379: @1709957
     /* 1709957 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1710043), // Rule ID 10323 //
     /* 1709962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1709973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1709976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1709982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710008 */     // MIs[0] policy
     /* 1710008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1710021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710042 */     // GIR_Coverage, 10323,
     /* 1710042 */     GIR_EraseRootFromParent_Done,
     /* 1710043 */   // Label 23380: @1710043
     /* 1710043 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1710129), // Rule ID 10326 //
     /* 1710048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1710051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1710059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1710062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1710065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1710068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710094 */     // MIs[0] policy
     /* 1710094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710128 */     // GIR_Coverage, 10326,
     /* 1710128 */     GIR_EraseRootFromParent_Done,
     /* 1710129 */   // Label 23381: @1710129
     /* 1710129 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1710215), // Rule ID 10327 //
     /* 1710134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1710137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1710145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1710148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1710151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1710154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710180 */     // MIs[0] policy
     /* 1710180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710214 */     // GIR_Coverage, 10327,
     /* 1710214 */     GIR_EraseRootFromParent_Done,
     /* 1710215 */   // Label 23382: @1710215
     /* 1710215 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1710301), // Rule ID 10330 //
     /* 1710220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1710223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1710231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1710234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1710237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1710240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710266 */     // MIs[0] policy
     /* 1710266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1710279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710300 */     // GIR_Coverage, 10330,
     /* 1710300 */     GIR_EraseRootFromParent_Done,
     /* 1710301 */   // Label 23383: @1710301
     /* 1710301 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1710387), // Rule ID 10331 //
     /* 1710306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1710309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1710317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1710320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1710323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1710326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710352 */     // MIs[0] policy
     /* 1710352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1710365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710386 */     // GIR_Coverage, 10331,
     /* 1710386 */     GIR_EraseRootFromParent_Done,
     /* 1710387 */   // Label 23384: @1710387
     /* 1710387 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1710473), // Rule ID 10334 //
     /* 1710392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1710395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1710403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1710406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1710409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1710412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1710422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710438 */     // MIs[0] policy
     /* 1710438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1710451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710472 */     // GIR_Coverage, 10334,
     /* 1710472 */     GIR_EraseRootFromParent_Done,
     /* 1710473 */   // Label 23385: @1710473
     /* 1710473 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1710559), // Rule ID 10335 //
     /* 1710478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1710481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1710489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1710492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1710495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1710498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1710508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1710520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710524 */     // MIs[0] policy
     /* 1710524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1710537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710558 */     // GIR_Coverage, 10335,
     /* 1710558 */     GIR_EraseRootFromParent_Done,
     /* 1710559 */   // Label 23386: @1710559
     /* 1710559 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1710645), // Rule ID 10338 //
     /* 1710564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1710581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710610 */     // MIs[0] policy
     /* 1710610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710620 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1710623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710644 */     // GIR_Coverage, 10338,
     /* 1710644 */     GIR_EraseRootFromParent_Done,
     /* 1710645 */   // Label 23387: @1710645
     /* 1710645 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1710731), // Rule ID 10339 //
     /* 1710650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1710667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710696 */     // MIs[0] policy
     /* 1710696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1710709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710730 */     // GIR_Coverage, 10339,
     /* 1710730 */     GIR_EraseRootFromParent_Done,
     /* 1710731 */   // Label 23388: @1710731
     /* 1710731 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1710817), // Rule ID 10342 //
     /* 1710736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1710753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710782 */     // MIs[0] policy
     /* 1710782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1710795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710816 */     // GIR_Coverage, 10342,
     /* 1710816 */     GIR_EraseRootFromParent_Done,
     /* 1710817 */   // Label 23389: @1710817
     /* 1710817 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1710903), // Rule ID 10343 //
     /* 1710822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1710839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1710842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710868 */     // MIs[0] policy
     /* 1710868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1710881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710902 */     // GIR_Coverage, 10343,
     /* 1710902 */     GIR_EraseRootFromParent_Done,
     /* 1710903 */   // Label 23390: @1710903
     /* 1710903 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1710989), // Rule ID 10346 //
     /* 1710908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1710919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1710922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1710925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1710928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1710950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710954 */     // MIs[0] policy
     /* 1710954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1710967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710988 */     // GIR_Coverage, 10346,
     /* 1710988 */     GIR_EraseRootFromParent_Done,
     /* 1710989 */   // Label 23391: @1710989
     /* 1710989 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1711075), // Rule ID 10347 //
     /* 1710994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1711005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1711008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1711011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711040 */     // MIs[0] policy
     /* 1711040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1711053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711074 */     // GIR_Coverage, 10347,
     /* 1711074 */     GIR_EraseRootFromParent_Done,
     /* 1711075 */   // Label 23392: @1711075
     /* 1711075 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1711161), // Rule ID 10350 //
     /* 1711080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1711091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1711094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1711097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711126 */     // MIs[0] policy
     /* 1711126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1711139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711160 */     // GIR_Coverage, 10350,
     /* 1711160 */     GIR_EraseRootFromParent_Done,
     /* 1711161 */   // Label 23393: @1711161
     /* 1711161 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1711247), // Rule ID 10351 //
     /* 1711166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1711177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1711180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1711183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711212 */     // MIs[0] policy
     /* 1711212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1711225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711246 */     // GIR_Coverage, 10351,
     /* 1711246 */     GIR_EraseRootFromParent_Done,
     /* 1711247 */   // Label 23394: @1711247
     /* 1711247 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1711333), // Rule ID 10354 //
     /* 1711252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1711263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1711266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1711269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711298 */     // MIs[0] policy
     /* 1711298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1711311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711332 */     // GIR_Coverage, 10354,
     /* 1711332 */     GIR_EraseRootFromParent_Done,
     /* 1711333 */   // Label 23395: @1711333
     /* 1711333 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1711419), // Rule ID 10355 //
     /* 1711338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1711349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1711352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1711355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711384 */     // MIs[0] policy
     /* 1711384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1711397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711418 */     // GIR_Coverage, 10355,
     /* 1711418 */     GIR_EraseRootFromParent_Done,
     /* 1711419 */   // Label 23396: @1711419
     /* 1711419 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1711505), // Rule ID 10358 //
     /* 1711424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1711435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1711438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711470 */     // MIs[0] policy
     /* 1711470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1711483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711504 */     // GIR_Coverage, 10358,
     /* 1711504 */     GIR_EraseRootFromParent_Done,
     /* 1711505 */   // Label 23397: @1711505
     /* 1711505 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1711591), // Rule ID 10359 //
     /* 1711510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1711521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1711524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1711527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711556 */     // MIs[0] policy
     /* 1711556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1711569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711590 */     // GIR_Coverage, 10359,
     /* 1711590 */     GIR_EraseRootFromParent_Done,
     /* 1711591 */   // Label 23398: @1711591
     /* 1711591 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1711677), // Rule ID 10362 //
     /* 1711596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1711607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1711610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1711613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711642 */     // MIs[0] policy
     /* 1711642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1711655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711676 */     // GIR_Coverage, 10362,
     /* 1711676 */     GIR_EraseRootFromParent_Done,
     /* 1711677 */   // Label 23399: @1711677
     /* 1711677 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1711763), // Rule ID 10363 //
     /* 1711682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1711693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1711696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1711699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711728 */     // MIs[0] policy
     /* 1711728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1711741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711762 */     // GIR_Coverage, 10363,
     /* 1711762 */     GIR_EraseRootFromParent_Done,
     /* 1711763 */   // Label 23400: @1711763
     /* 1711763 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1711849), // Rule ID 10366 //
     /* 1711768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711814 */     // MIs[0] policy
     /* 1711814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1711827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711848 */     // GIR_Coverage, 10366,
     /* 1711848 */     GIR_EraseRootFromParent_Done,
     /* 1711849 */   // Label 23401: @1711849
     /* 1711849 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1711935), // Rule ID 10367 //
     /* 1711854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1711874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711900 */     // MIs[0] policy
     /* 1711900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1711913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711934 */     // GIR_Coverage, 10367,
     /* 1711934 */     GIR_EraseRootFromParent_Done,
     /* 1711935 */   // Label 23402: @1711935
     /* 1711935 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1712021), // Rule ID 10370 //
     /* 1711940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1711951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1711954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1711960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1711982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711986 */     // MIs[0] policy
     /* 1711986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1711999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712020 */     // GIR_Coverage, 10370,
     /* 1712020 */     GIR_EraseRootFromParent_Done,
     /* 1712021 */   // Label 23403: @1712021
     /* 1712021 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1712107), // Rule ID 10371 //
     /* 1712026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1712037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1712040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1712043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712072 */     // MIs[0] policy
     /* 1712072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1712085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712106 */     // GIR_Coverage, 10371,
     /* 1712106 */     GIR_EraseRootFromParent_Done,
     /* 1712107 */   // Label 23404: @1712107
     /* 1712107 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1712193), // Rule ID 10374 //
     /* 1712112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1712123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1712126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1712129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712158 */     // MIs[0] policy
     /* 1712158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1712171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712192 */     // GIR_Coverage, 10374,
     /* 1712192 */     GIR_EraseRootFromParent_Done,
     /* 1712193 */   // Label 23405: @1712193
     /* 1712193 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1712279), // Rule ID 10375 //
     /* 1712198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1712209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1712212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1712215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712244 */     // MIs[0] policy
     /* 1712244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1712257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712278 */     // GIR_Coverage, 10375,
     /* 1712278 */     GIR_EraseRootFromParent_Done,
     /* 1712279 */   // Label 23406: @1712279
     /* 1712279 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1712365), // Rule ID 10378 //
     /* 1712284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1712295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1712298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1712301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712330 */     // MIs[0] policy
     /* 1712330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1712343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712364 */     // GIR_Coverage, 10378,
     /* 1712364 */     GIR_EraseRootFromParent_Done,
     /* 1712365 */   // Label 23407: @1712365
     /* 1712365 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1712451), // Rule ID 10379 //
     /* 1712370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1712381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1712384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1712387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712416 */     // MIs[0] policy
     /* 1712416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1712429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712450 */     // GIR_Coverage, 10379,
     /* 1712450 */     GIR_EraseRootFromParent_Done,
     /* 1712451 */   // Label 23408: @1712451
     /* 1712451 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1712537), // Rule ID 10382 //
     /* 1712456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1712467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1712470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1712473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712502 */     // MIs[0] policy
     /* 1712502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712512 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1712515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712536 */     // GIR_Coverage, 10382,
     /* 1712536 */     GIR_EraseRootFromParent_Done,
     /* 1712537 */   // Label 23409: @1712537
     /* 1712537 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1712623), // Rule ID 10383 //
     /* 1712542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1712553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1712556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1712559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712588 */     // MIs[0] policy
     /* 1712588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1712601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712622 */     // GIR_Coverage, 10383,
     /* 1712622 */     GIR_EraseRootFromParent_Done,
     /* 1712623 */   // Label 23410: @1712623
     /* 1712623 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1712709), // Rule ID 10386 //
     /* 1712628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1712639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1712642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1712645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1712651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712674 */     // MIs[0] policy
     /* 1712674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1712687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712708 */     // GIR_Coverage, 10386,
     /* 1712708 */     GIR_EraseRootFromParent_Done,
     /* 1712709 */   // Label 23411: @1712709
     /* 1712709 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1712795), // Rule ID 10387 //
     /* 1712714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1712725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1712728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1712731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1712737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712760 */     // MIs[0] policy
     /* 1712760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1712773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712794 */     // GIR_Coverage, 10387,
     /* 1712794 */     GIR_EraseRootFromParent_Done,
     /* 1712795 */   // Label 23412: @1712795
     /* 1712795 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1712881), // Rule ID 10390 //
     /* 1712800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1712817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712846 */     // MIs[0] policy
     /* 1712846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1712859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712880 */     // GIR_Coverage, 10390,
     /* 1712880 */     GIR_EraseRootFromParent_Done,
     /* 1712881 */   // Label 23413: @1712881
     /* 1712881 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1712967), // Rule ID 10391 //
     /* 1712886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1712903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712932 */     // MIs[0] policy
     /* 1712932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1712945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712966 */     // GIR_Coverage, 10391,
     /* 1712966 */     GIR_EraseRootFromParent_Done,
     /* 1712967 */   // Label 23414: @1712967
     /* 1712967 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1713053), // Rule ID 10394 //
     /* 1712972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1712989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713018 */     // MIs[0] policy
     /* 1713018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1713031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713052 */     // GIR_Coverage, 10394,
     /* 1713052 */     GIR_EraseRootFromParent_Done,
     /* 1713053 */   // Label 23415: @1713053
     /* 1713053 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1713139), // Rule ID 10395 //
     /* 1713058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1713069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1713072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1713075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713104 */     // MIs[0] policy
     /* 1713104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1713117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713138 */     // GIR_Coverage, 10395,
     /* 1713138 */     GIR_EraseRootFromParent_Done,
     /* 1713139 */   // Label 23416: @1713139
     /* 1713139 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1713225), // Rule ID 10398 //
     /* 1713144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1713155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1713158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1713161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1713167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713190 */     // MIs[0] policy
     /* 1713190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1713203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713224 */     // GIR_Coverage, 10398,
     /* 1713224 */     GIR_EraseRootFromParent_Done,
     /* 1713225 */   // Label 23417: @1713225
     /* 1713225 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1713311), // Rule ID 10399 //
     /* 1713230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1713241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1713244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1713247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1713253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713276 */     // MIs[0] policy
     /* 1713276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1713289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713310 */     // GIR_Coverage, 10399,
     /* 1713310 */     GIR_EraseRootFromParent_Done,
     /* 1713311 */   // Label 23418: @1713311
     /* 1713311 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1713397), // Rule ID 10402 //
     /* 1713316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1713327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1713330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1713333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713362 */     // MIs[0] policy
     /* 1713362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1713375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713396 */     // GIR_Coverage, 10402,
     /* 1713396 */     GIR_EraseRootFromParent_Done,
     /* 1713397 */   // Label 23419: @1713397
     /* 1713397 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1713483), // Rule ID 10403 //
     /* 1713402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1713413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1713416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1713419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713448 */     // MIs[0] policy
     /* 1713448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1713461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713482 */     // GIR_Coverage, 10403,
     /* 1713482 */     GIR_EraseRootFromParent_Done,
     /* 1713483 */   // Label 23420: @1713483
     /* 1713483 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1713569), // Rule ID 10406 //
     /* 1713488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1713499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1713502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1713505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713534 */     // MIs[0] policy
     /* 1713534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1713547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713568 */     // GIR_Coverage, 10406,
     /* 1713568 */     GIR_EraseRootFromParent_Done,
     /* 1713569 */   // Label 23421: @1713569
     /* 1713569 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1713655), // Rule ID 10407 //
     /* 1713574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1713585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1713588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1713591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713620 */     // MIs[0] policy
     /* 1713620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1713633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713654 */     // GIR_Coverage, 10407,
     /* 1713654 */     GIR_EraseRootFromParent_Done,
     /* 1713655 */   // Label 23422: @1713655
     /* 1713655 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1713741), // Rule ID 10410 //
     /* 1713660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1713671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1713674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1713677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713706 */     // MIs[0] policy
     /* 1713706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713716 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1713719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713740 */     // GIR_Coverage, 10410,
     /* 1713740 */     GIR_EraseRootFromParent_Done,
     /* 1713741 */   // Label 23423: @1713741
     /* 1713741 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1713827), // Rule ID 10411 //
     /* 1713746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1713757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1713760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1713763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713792 */     // MIs[0] policy
     /* 1713792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1713805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713826 */     // GIR_Coverage, 10411,
     /* 1713826 */     GIR_EraseRootFromParent_Done,
     /* 1713827 */   // Label 23424: @1713827
     /* 1713827 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1713913), // Rule ID 10414 //
     /* 1713832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1713843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1713846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1713849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713878 */     // MIs[0] policy
     /* 1713878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1713891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713912 */     // GIR_Coverage, 10414,
     /* 1713912 */     GIR_EraseRootFromParent_Done,
     /* 1713913 */   // Label 23425: @1713913
     /* 1713913 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1713999), // Rule ID 10415 //
     /* 1713918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1713929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1713932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1713935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713964 */     // MIs[0] policy
     /* 1713964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11374:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1713977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713998 */     // GIR_Coverage, 10415,
     /* 1713998 */     GIR_EraseRootFromParent_Done,
     /* 1713999 */   // Label 23426: @1713999
     /* 1713999 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1714085), // Rule ID 10418 //
     /* 1714004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1714015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1714018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1714021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714050 */     // MIs[0] policy
     /* 1714050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714084 */     // GIR_Coverage, 10418,
     /* 1714084 */     GIR_EraseRootFromParent_Done,
     /* 1714085 */   // Label 23427: @1714085
     /* 1714085 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1714171), // Rule ID 10419 //
     /* 1714090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1714101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1714104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1714107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714136 */     // MIs[0] policy
     /* 1714136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11374:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714170 */     // GIR_Coverage, 10419,
     /* 1714170 */     GIR_EraseRootFromParent_Done,
     /* 1714171 */   // Label 23428: @1714171
     /* 1714171 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1714257), // Rule ID 10422 //
     /* 1714176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1714187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1714190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1714193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714222 */     // MIs[0] policy
     /* 1714222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1714235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714256 */     // GIR_Coverage, 10422,
     /* 1714256 */     GIR_EraseRootFromParent_Done,
     /* 1714257 */   // Label 23429: @1714257
     /* 1714257 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1714343), // Rule ID 10423 //
     /* 1714262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1714273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1714276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1714279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714308 */     // MIs[0] policy
     /* 1714308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11374:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1714321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714342 */     // GIR_Coverage, 10423,
     /* 1714342 */     GIR_EraseRootFromParent_Done,
     /* 1714343 */   // Label 23430: @1714343
     /* 1714343 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1714429), // Rule ID 10426 //
     /* 1714348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1714359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1714362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1714365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1714368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714394 */     // MIs[0] policy
     /* 1714394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714404 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1714407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714428 */     // GIR_Coverage, 10426,
     /* 1714428 */     GIR_EraseRootFromParent_Done,
     /* 1714429 */   // Label 23431: @1714429
     /* 1714429 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1714515), // Rule ID 10427 //
     /* 1714434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1714445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1714448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1714451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1714454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714480 */     // MIs[0] policy
     /* 1714480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1714493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714514 */     // GIR_Coverage, 10427,
     /* 1714514 */     GIR_EraseRootFromParent_Done,
     /* 1714515 */   // Label 23432: @1714515
     /* 1714515 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1714601), // Rule ID 10430 //
     /* 1714520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1714531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1714534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1714537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1714540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714566 */     // MIs[0] policy
     /* 1714566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1714579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714600 */     // GIR_Coverage, 10430,
     /* 1714600 */     GIR_EraseRootFromParent_Done,
     /* 1714601 */   // Label 23433: @1714601
     /* 1714601 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1714687), // Rule ID 10431 //
     /* 1714606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1714617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1714620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1714623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1714626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714652 */     // MIs[0] policy
     /* 1714652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1714665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714686 */     // GIR_Coverage, 10431,
     /* 1714686 */     GIR_EraseRootFromParent_Done,
     /* 1714687 */   // Label 23434: @1714687
     /* 1714687 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1714773), // Rule ID 10434 //
     /* 1714692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1714703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1714706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1714709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1714712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714738 */     // MIs[0] policy
     /* 1714738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714748 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1714751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714772 */     // GIR_Coverage, 10434,
     /* 1714772 */     GIR_EraseRootFromParent_Done,
     /* 1714773 */   // Label 23435: @1714773
     /* 1714773 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1714859), // Rule ID 10435 //
     /* 1714778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1714789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1714792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1714795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1714798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714824 */     // MIs[0] policy
     /* 1714824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1714837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714858 */     // GIR_Coverage, 10435,
     /* 1714858 */     GIR_EraseRootFromParent_Done,
     /* 1714859 */   // Label 23436: @1714859
     /* 1714859 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1714945), // Rule ID 10438 //
     /* 1714864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1714875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1714878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1714881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1714884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714910 */     // MIs[0] policy
     /* 1714910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1714923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714944 */     // GIR_Coverage, 10438,
     /* 1714944 */     GIR_EraseRootFromParent_Done,
     /* 1714945 */   // Label 23437: @1714945
     /* 1714945 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1715031), // Rule ID 10439 //
     /* 1714950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1714961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1714964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1714967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1714970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714996 */     // MIs[0] policy
     /* 1714996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1715009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715030 */     // GIR_Coverage, 10439,
     /* 1715030 */     GIR_EraseRootFromParent_Done,
     /* 1715031 */   // Label 23438: @1715031
     /* 1715031 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1715117), // Rule ID 10442 //
     /* 1715036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1715047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1715050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1715053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1715056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715082 */     // MIs[0] policy
     /* 1715082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1715095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715116 */     // GIR_Coverage, 10442,
     /* 1715116 */     GIR_EraseRootFromParent_Done,
     /* 1715117 */   // Label 23439: @1715117
     /* 1715117 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1715203), // Rule ID 10443 //
     /* 1715122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1715133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1715136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1715139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1715142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715168 */     // MIs[0] policy
     /* 1715168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715178 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1715181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715202 */     // GIR_Coverage, 10443,
     /* 1715202 */     GIR_EraseRootFromParent_Done,
     /* 1715203 */   // Label 23440: @1715203
     /* 1715203 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1715289), // Rule ID 10446 //
     /* 1715208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1715219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1715222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1715225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1715228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715254 */     // MIs[0] policy
     /* 1715254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1715267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715288 */     // GIR_Coverage, 10446,
     /* 1715288 */     GIR_EraseRootFromParent_Done,
     /* 1715289 */   // Label 23441: @1715289
     /* 1715289 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1715375), // Rule ID 10447 //
     /* 1715294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1715305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1715308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1715311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1715314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715340 */     // MIs[0] policy
     /* 1715340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1715353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715374 */     // GIR_Coverage, 10447,
     /* 1715374 */     GIR_EraseRootFromParent_Done,
     /* 1715375 */   // Label 23442: @1715375
     /* 1715375 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1715461), // Rule ID 10450 //
     /* 1715380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1715391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1715394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1715397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1715400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715426 */     // MIs[0] policy
     /* 1715426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715460 */     // GIR_Coverage, 10450,
     /* 1715460 */     GIR_EraseRootFromParent_Done,
     /* 1715461 */   // Label 23443: @1715461
     /* 1715461 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1715547), // Rule ID 10451 //
     /* 1715466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1715477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1715480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1715483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1715486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715512 */     // MIs[0] policy
     /* 1715512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715546 */     // GIR_Coverage, 10451,
     /* 1715546 */     GIR_EraseRootFromParent_Done,
     /* 1715547 */   // Label 23444: @1715547
     /* 1715547 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1715633), // Rule ID 10454 //
     /* 1715552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1715563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1715566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1715572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715598 */     // MIs[0] policy
     /* 1715598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715632 */     // GIR_Coverage, 10454,
     /* 1715632 */     GIR_EraseRootFromParent_Done,
     /* 1715633 */   // Label 23445: @1715633
     /* 1715633 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1715719), // Rule ID 10455 //
     /* 1715638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1715649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1715652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1715658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715684 */     // MIs[0] policy
     /* 1715684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715718 */     // GIR_Coverage, 10455,
     /* 1715718 */     GIR_EraseRootFromParent_Done,
     /* 1715719 */   // Label 23446: @1715719
     /* 1715719 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1715805), // Rule ID 10458 //
     /* 1715724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1715735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1715738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1715741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1715744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715770 */     // MIs[0] policy
     /* 1715770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715804 */     // GIR_Coverage, 10458,
     /* 1715804 */     GIR_EraseRootFromParent_Done,
     /* 1715805 */   // Label 23447: @1715805
     /* 1715805 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1715891), // Rule ID 10459 //
     /* 1715810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1715821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1715824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1715827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1715830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715856 */     // MIs[0] policy
     /* 1715856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715890 */     // GIR_Coverage, 10459,
     /* 1715890 */     GIR_EraseRootFromParent_Done,
     /* 1715891 */   // Label 23448: @1715891
     /* 1715891 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1715977), // Rule ID 10462 //
     /* 1715896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1715899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1715907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1715910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1715913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1715916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715942 */     // MIs[0] policy
     /* 1715942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1715955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1715973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715976 */     // GIR_Coverage, 10462,
     /* 1715976 */     GIR_EraseRootFromParent_Done,
     /* 1715977 */   // Label 23449: @1715977
     /* 1715977 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1716063), // Rule ID 10463 //
     /* 1715982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1715985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1715993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1715996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1715999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1716002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716028 */     // MIs[0] policy
     /* 1716028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1716041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716062 */     // GIR_Coverage, 10463,
     /* 1716062 */     GIR_EraseRootFromParent_Done,
     /* 1716063 */   // Label 23450: @1716063
     /* 1716063 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1716149), // Rule ID 10466 //
     /* 1716068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1716079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1716082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1716085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1716088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716114 */     // MIs[0] policy
     /* 1716114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1716127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716148 */     // GIR_Coverage, 10466,
     /* 1716148 */     GIR_EraseRootFromParent_Done,
     /* 1716149 */   // Label 23451: @1716149
     /* 1716149 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1716235), // Rule ID 10467 //
     /* 1716154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1716165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1716168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1716171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1716174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716200 */     // MIs[0] policy
     /* 1716200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1716213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716234 */     // GIR_Coverage, 10467,
     /* 1716234 */     GIR_EraseRootFromParent_Done,
     /* 1716235 */   // Label 23452: @1716235
     /* 1716235 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1716321), // Rule ID 10470 //
     /* 1716240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1716251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1716254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1716257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1716260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716286 */     // MIs[0] policy
     /* 1716286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716296 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1716299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716320 */     // GIR_Coverage, 10470,
     /* 1716320 */     GIR_EraseRootFromParent_Done,
     /* 1716321 */   // Label 23453: @1716321
     /* 1716321 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1716407), // Rule ID 10471 //
     /* 1716326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1716337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1716340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1716343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1716346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716372 */     // MIs[0] policy
     /* 1716372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716382 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1716385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716406 */     // GIR_Coverage, 10471,
     /* 1716406 */     GIR_EraseRootFromParent_Done,
     /* 1716407 */   // Label 23454: @1716407
     /* 1716407 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1716493), // Rule ID 10474 //
     /* 1716412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1716423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1716426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1716429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1716432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1716435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716458 */     // MIs[0] policy
     /* 1716458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1716471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716492 */     // GIR_Coverage, 10474,
     /* 1716492 */     GIR_EraseRootFromParent_Done,
     /* 1716493 */   // Label 23455: @1716493
     /* 1716493 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1716579), // Rule ID 10475 //
     /* 1716498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1716509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1716512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1716515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1716518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1716521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716544 */     // MIs[0] policy
     /* 1716544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1716557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716578 */     // GIR_Coverage, 10475,
     /* 1716578 */     GIR_EraseRootFromParent_Done,
     /* 1716579 */   // Label 23456: @1716579
     /* 1716579 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1716665), // Rule ID 10478 //
     /* 1716584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1716595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1716598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1716601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1716604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716630 */     // MIs[0] policy
     /* 1716630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1716643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716664 */     // GIR_Coverage, 10478,
     /* 1716664 */     GIR_EraseRootFromParent_Done,
     /* 1716665 */   // Label 23457: @1716665
     /* 1716665 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1716751), // Rule ID 10479 //
     /* 1716670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1716681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1716684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1716687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1716690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716716 */     // MIs[0] policy
     /* 1716716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1716729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716750 */     // GIR_Coverage, 10479,
     /* 1716750 */     GIR_EraseRootFromParent_Done,
     /* 1716751 */   // Label 23458: @1716751
     /* 1716751 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1716837), // Rule ID 10482 //
     /* 1716756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1716767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1716770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1716773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1716776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716802 */     // MIs[0] policy
     /* 1716802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1716815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716836 */     // GIR_Coverage, 10482,
     /* 1716836 */     GIR_EraseRootFromParent_Done,
     /* 1716837 */   // Label 23459: @1716837
     /* 1716837 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1716923), // Rule ID 10483 //
     /* 1716842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1716853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1716856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1716859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1716862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716888 */     // MIs[0] policy
     /* 1716888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1716901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716922 */     // GIR_Coverage, 10483,
     /* 1716922 */     GIR_EraseRootFromParent_Done,
     /* 1716923 */   // Label 23460: @1716923
     /* 1716923 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1717009), // Rule ID 10486 //
     /* 1716928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1716939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1716942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1716945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1716948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716974 */     // MIs[0] policy
     /* 1716974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1716987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717008 */     // GIR_Coverage, 10486,
     /* 1717008 */     GIR_EraseRootFromParent_Done,
     /* 1717009 */   // Label 23461: @1717009
     /* 1717009 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1717095), // Rule ID 10487 //
     /* 1717014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1717025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1717028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1717031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1717034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1717037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717060 */     // MIs[0] policy
     /* 1717060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1717073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717094 */     // GIR_Coverage, 10487,
     /* 1717094 */     GIR_EraseRootFromParent_Done,
     /* 1717095 */   // Label 23462: @1717095
     /* 1717095 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1717181), // Rule ID 10490 //
     /* 1717100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1717111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1717114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1717117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1717120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717146 */     // MIs[0] policy
     /* 1717146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1717159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717180 */     // GIR_Coverage, 10490,
     /* 1717180 */     GIR_EraseRootFromParent_Done,
     /* 1717181 */   // Label 23463: @1717181
     /* 1717181 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1717267), // Rule ID 10491 //
     /* 1717186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1717197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1717200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1717203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1717206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717232 */     // MIs[0] policy
     /* 1717232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1717245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717266 */     // GIR_Coverage, 10491,
     /* 1717266 */     GIR_EraseRootFromParent_Done,
     /* 1717267 */   // Label 23464: @1717267
     /* 1717267 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1717353), // Rule ID 10494 //
     /* 1717272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1717283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1717286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1717289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1717292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717318 */     // MIs[0] policy
     /* 1717318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1717331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717352 */     // GIR_Coverage, 10494,
     /* 1717352 */     GIR_EraseRootFromParent_Done,
     /* 1717353 */   // Label 23465: @1717353
     /* 1717353 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1717439), // Rule ID 10495 //
     /* 1717358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1717369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1717372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1717375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1717378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717404 */     // MIs[0] policy
     /* 1717404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1717417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717438 */     // GIR_Coverage, 10495,
     /* 1717438 */     GIR_EraseRootFromParent_Done,
     /* 1717439 */   // Label 23466: @1717439
     /* 1717439 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1717525), // Rule ID 10498 //
     /* 1717444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1717455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1717458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1717461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1717464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717490 */     // MIs[0] policy
     /* 1717490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1717503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717524 */     // GIR_Coverage, 10498,
     /* 1717524 */     GIR_EraseRootFromParent_Done,
     /* 1717525 */   // Label 23467: @1717525
     /* 1717525 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1717611), // Rule ID 10499 //
     /* 1717530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1717541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1717544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1717547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1717550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1717553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717576 */     // MIs[0] policy
     /* 1717576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1717589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717610 */     // GIR_Coverage, 10499,
     /* 1717610 */     GIR_EraseRootFromParent_Done,
     /* 1717611 */   // Label 23468: @1717611
     /* 1717611 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1717697), // Rule ID 10502 //
     /* 1717616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1717627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1717630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1717633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1717636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717662 */     // MIs[0] policy
     /* 1717662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1717675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717696 */     // GIR_Coverage, 10502,
     /* 1717696 */     GIR_EraseRootFromParent_Done,
     /* 1717697 */   // Label 23469: @1717697
     /* 1717697 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1717783), // Rule ID 10503 //
     /* 1717702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1717705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1717713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1717716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1717719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1717722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717748 */     // MIs[0] policy
     /* 1717748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1717761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717782 */     // GIR_Coverage, 10503,
     /* 1717782 */     GIR_EraseRootFromParent_Done,
     /* 1717783 */   // Label 23470: @1717783
     /* 1717783 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1717869), // Rule ID 10506 //
     /* 1717788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1717799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1717802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1717805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1717808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717834 */     // MIs[0] policy
     /* 1717834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1717847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717868 */     // GIR_Coverage, 10506,
     /* 1717868 */     GIR_EraseRootFromParent_Done,
     /* 1717869 */   // Label 23471: @1717869
     /* 1717869 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1717955), // Rule ID 10507 //
     /* 1717874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1717877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1717885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1717888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1717891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1717894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717920 */     // MIs[0] policy
     /* 1717920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1717933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717954 */     // GIR_Coverage, 10507,
     /* 1717954 */     GIR_EraseRootFromParent_Done,
     /* 1717955 */   // Label 23472: @1717955
     /* 1717955 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1718041), // Rule ID 10510 //
     /* 1717960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1717971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1717974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1717977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1717980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718006 */     // MIs[0] policy
     /* 1718006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718040 */     // GIR_Coverage, 10510,
     /* 1718040 */     GIR_EraseRootFromParent_Done,
     /* 1718041 */   // Label 23473: @1718041
     /* 1718041 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1718127), // Rule ID 10511 //
     /* 1718046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1718057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1718060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1718063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1718066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718092 */     // MIs[0] policy
     /* 1718092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718126 */     // GIR_Coverage, 10511,
     /* 1718126 */     GIR_EraseRootFromParent_Done,
     /* 1718127 */   // Label 23474: @1718127
     /* 1718127 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1718213), // Rule ID 10514 //
     /* 1718132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1718143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1718146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1718149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718178 */     // MIs[0] policy
     /* 1718178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1718191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718212 */     // GIR_Coverage, 10514,
     /* 1718212 */     GIR_EraseRootFromParent_Done,
     /* 1718213 */   // Label 23475: @1718213
     /* 1718213 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1718299), // Rule ID 10515 //
     /* 1718218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1718229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1718232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1718235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718264 */     // MIs[0] policy
     /* 1718264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1718277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718298 */     // GIR_Coverage, 10515,
     /* 1718298 */     GIR_EraseRootFromParent_Done,
     /* 1718299 */   // Label 23476: @1718299
     /* 1718299 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1718385), // Rule ID 10518 //
     /* 1718304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1718315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1718318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1718321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718350 */     // MIs[0] policy
     /* 1718350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1718363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718384 */     // GIR_Coverage, 10518,
     /* 1718384 */     GIR_EraseRootFromParent_Done,
     /* 1718385 */   // Label 23477: @1718385
     /* 1718385 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1718471), // Rule ID 10519 //
     /* 1718390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1718401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1718404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1718407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718436 */     // MIs[0] policy
     /* 1718436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1718449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718470 */     // GIR_Coverage, 10519,
     /* 1718470 */     GIR_EraseRootFromParent_Done,
     /* 1718471 */   // Label 23478: @1718471
     /* 1718471 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1718557), // Rule ID 10522 //
     /* 1718476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1718487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1718490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1718493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718522 */     // MIs[0] policy
     /* 1718522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1718535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718556 */     // GIR_Coverage, 10522,
     /* 1718556 */     GIR_EraseRootFromParent_Done,
     /* 1718557 */   // Label 23479: @1718557
     /* 1718557 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1718643), // Rule ID 10523 //
     /* 1718562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1718573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1718576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1718579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718608 */     // MIs[0] policy
     /* 1718608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1718621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718642 */     // GIR_Coverage, 10523,
     /* 1718642 */     GIR_EraseRootFromParent_Done,
     /* 1718643 */   // Label 23480: @1718643
     /* 1718643 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1718729), // Rule ID 10526 //
     /* 1718648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1718659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1718662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1718665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718694 */     // MIs[0] policy
     /* 1718694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1718707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718728 */     // GIR_Coverage, 10526,
     /* 1718728 */     GIR_EraseRootFromParent_Done,
     /* 1718729 */   // Label 23481: @1718729
     /* 1718729 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1718815), // Rule ID 10527 //
     /* 1718734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1718745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1718748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1718751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718780 */     // MIs[0] policy
     /* 1718780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1718793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718814 */     // GIR_Coverage, 10527,
     /* 1718814 */     GIR_EraseRootFromParent_Done,
     /* 1718815 */   // Label 23482: @1718815
     /* 1718815 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1718901), // Rule ID 10530 //
     /* 1718820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1718831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1718834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1718837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1718840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718866 */     // MIs[0] policy
     /* 1718866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1718879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718900 */     // GIR_Coverage, 10530,
     /* 1718900 */     GIR_EraseRootFromParent_Done,
     /* 1718901 */   // Label 23483: @1718901
     /* 1718901 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1718987), // Rule ID 10531 //
     /* 1718906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1718917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1718920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1718923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1718926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1718948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718952 */     // MIs[0] policy
     /* 1718952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1718965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718986 */     // GIR_Coverage, 10531,
     /* 1718986 */     GIR_EraseRootFromParent_Done,
     /* 1718987 */   // Label 23484: @1718987
     /* 1718987 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1719073), // Rule ID 10534 //
     /* 1718992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1719003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1719006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1719009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719038 */     // MIs[0] policy
     /* 1719038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1719051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719072 */     // GIR_Coverage, 10534,
     /* 1719072 */     GIR_EraseRootFromParent_Done,
     /* 1719073 */   // Label 23485: @1719073
     /* 1719073 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1719159), // Rule ID 10535 //
     /* 1719078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1719089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1719092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1719095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719124 */     // MIs[0] policy
     /* 1719124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1719137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719158 */     // GIR_Coverage, 10535,
     /* 1719158 */     GIR_EraseRootFromParent_Done,
     /* 1719159 */   // Label 23486: @1719159
     /* 1719159 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1719245), // Rule ID 10538 //
     /* 1719164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1719175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1719178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1719181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719210 */     // MIs[0] policy
     /* 1719210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719244 */     // GIR_Coverage, 10538,
     /* 1719244 */     GIR_EraseRootFromParent_Done,
     /* 1719245 */   // Label 23487: @1719245
     /* 1719245 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1719331), // Rule ID 10539 //
     /* 1719250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1719261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1719264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1719267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719296 */     // MIs[0] policy
     /* 1719296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719330 */     // GIR_Coverage, 10539,
     /* 1719330 */     GIR_EraseRootFromParent_Done,
     /* 1719331 */   // Label 23488: @1719331
     /* 1719331 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1719417), // Rule ID 10542 //
     /* 1719336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1719347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1719350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1719353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719382 */     // MIs[0] policy
     /* 1719382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719416 */     // GIR_Coverage, 10542,
     /* 1719416 */     GIR_EraseRootFromParent_Done,
     /* 1719417 */   // Label 23489: @1719417
     /* 1719417 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1719503), // Rule ID 10543 //
     /* 1719422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1719433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1719436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1719439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719468 */     // MIs[0] policy
     /* 1719468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719502 */     // GIR_Coverage, 10543,
     /* 1719502 */     GIR_EraseRootFromParent_Done,
     /* 1719503 */   // Label 23490: @1719503
     /* 1719503 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1719589), // Rule ID 10546 //
     /* 1719508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1719519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1719522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1719525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719554 */     // MIs[0] policy
     /* 1719554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719588 */     // GIR_Coverage, 10546,
     /* 1719588 */     GIR_EraseRootFromParent_Done,
     /* 1719589 */   // Label 23491: @1719589
     /* 1719589 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1719675), // Rule ID 10547 //
     /* 1719594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1719605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1719608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1719611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719640 */     // MIs[0] policy
     /* 1719640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719674 */     // GIR_Coverage, 10547,
     /* 1719674 */     GIR_EraseRootFromParent_Done,
     /* 1719675 */   // Label 23492: @1719675
     /* 1719675 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1719761), // Rule ID 10550 //
     /* 1719680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1719683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1719691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1719694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1719697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719726 */     // MIs[0] policy
     /* 1719726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719760 */     // GIR_Coverage, 10550,
     /* 1719760 */     GIR_EraseRootFromParent_Done,
     /* 1719761 */   // Label 23493: @1719761
     /* 1719761 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1719847), // Rule ID 10551 //
     /* 1719766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1719769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1719777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1719780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1719783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719812 */     // MIs[0] policy
     /* 1719812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1719825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719846 */     // GIR_Coverage, 10551,
     /* 1719846 */     GIR_EraseRootFromParent_Done,
     /* 1719847 */   // Label 23494: @1719847
     /* 1719847 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1719933), // Rule ID 10554 //
     /* 1719852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1719863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1719866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1719869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1719872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719898 */     // MIs[0] policy
     /* 1719898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1719911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719932 */     // GIR_Coverage, 10554,
     /* 1719932 */     GIR_EraseRootFromParent_Done,
     /* 1719933 */   // Label 23495: @1719933
     /* 1719933 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1720019), // Rule ID 10555 //
     /* 1719938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1719949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1719952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1719955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1719958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1719980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719984 */     // MIs[0] policy
     /* 1719984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1719997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720018 */     // GIR_Coverage, 10555,
     /* 1720018 */     GIR_EraseRootFromParent_Done,
     /* 1720019 */   // Label 23496: @1720019
     /* 1720019 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1720105), // Rule ID 10558 //
     /* 1720024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1720035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1720038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1720041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720070 */     // MIs[0] policy
     /* 1720070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1720083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720104 */     // GIR_Coverage, 10558,
     /* 1720104 */     GIR_EraseRootFromParent_Done,
     /* 1720105 */   // Label 23497: @1720105
     /* 1720105 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1720191), // Rule ID 10559 //
     /* 1720110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1720121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1720124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1720127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720156 */     // MIs[0] policy
     /* 1720156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1720169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720190 */     // GIR_Coverage, 10559,
     /* 1720190 */     GIR_EraseRootFromParent_Done,
     /* 1720191 */   // Label 23498: @1720191
     /* 1720191 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1720277), // Rule ID 10562 //
     /* 1720196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1720207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1720210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1720213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1720219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720242 */     // MIs[0] policy
     /* 1720242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1720255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720276 */     // GIR_Coverage, 10562,
     /* 1720276 */     GIR_EraseRootFromParent_Done,
     /* 1720277 */   // Label 23499: @1720277
     /* 1720277 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1720363), // Rule ID 10563 //
     /* 1720282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1720293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1720296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1720299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1720305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720328 */     // MIs[0] policy
     /* 1720328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1720341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720362 */     // GIR_Coverage, 10563,
     /* 1720362 */     GIR_EraseRootFromParent_Done,
     /* 1720363 */   // Label 23500: @1720363
     /* 1720363 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1720449), // Rule ID 10566 //
     /* 1720368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1720379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1720382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1720385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720414 */     // MIs[0] policy
     /* 1720414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1720427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720448 */     // GIR_Coverage, 10566,
     /* 1720448 */     GIR_EraseRootFromParent_Done,
     /* 1720449 */   // Label 23501: @1720449
     /* 1720449 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1720535), // Rule ID 10567 //
     /* 1720454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1720465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1720468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1720471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720500 */     // MIs[0] policy
     /* 1720500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1720513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720534 */     // GIR_Coverage, 10567,
     /* 1720534 */     GIR_EraseRootFromParent_Done,
     /* 1720535 */   // Label 23502: @1720535
     /* 1720535 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1720621), // Rule ID 10570 //
     /* 1720540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1720551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1720554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1720557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720586 */     // MIs[0] policy
     /* 1720586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1720599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720620 */     // GIR_Coverage, 10570,
     /* 1720620 */     GIR_EraseRootFromParent_Done,
     /* 1720621 */   // Label 23503: @1720621
     /* 1720621 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1720707), // Rule ID 10571 //
     /* 1720626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1720637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1720640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1720643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720672 */     // MIs[0] policy
     /* 1720672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1720685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720706 */     // GIR_Coverage, 10571,
     /* 1720706 */     GIR_EraseRootFromParent_Done,
     /* 1720707 */   // Label 23504: @1720707
     /* 1720707 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1720793), // Rule ID 10574 //
     /* 1720712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1720723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1720726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1720729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720758 */     // MIs[0] policy
     /* 1720758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1720771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720792 */     // GIR_Coverage, 10574,
     /* 1720792 */     GIR_EraseRootFromParent_Done,
     /* 1720793 */   // Label 23505: @1720793
     /* 1720793 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1720879), // Rule ID 10575 //
     /* 1720798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1720809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1720812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1720815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720844 */     // MIs[0] policy
     /* 1720844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1720857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720878 */     // GIR_Coverage, 10575,
     /* 1720878 */     GIR_EraseRootFromParent_Done,
     /* 1720879 */   // Label 23506: @1720879
     /* 1720879 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1720965), // Rule ID 10578 //
     /* 1720884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1720895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1720898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1720901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720930 */     // MIs[0] policy
     /* 1720930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1720943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720964 */     // GIR_Coverage, 10578,
     /* 1720964 */     GIR_EraseRootFromParent_Done,
     /* 1720965 */   // Label 23507: @1720965
     /* 1720965 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1721051), // Rule ID 10579 //
     /* 1720970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1720981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1720984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1720987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721016 */     // MIs[0] policy
     /* 1721016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1721029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721050 */     // GIR_Coverage, 10579,
     /* 1721050 */     GIR_EraseRootFromParent_Done,
     /* 1721051 */   // Label 23508: @1721051
     /* 1721051 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1721137), // Rule ID 10582 //
     /* 1721056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1721067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1721070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1721073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721102 */     // MIs[0] policy
     /* 1721102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1721115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721136 */     // GIR_Coverage, 10582,
     /* 1721136 */     GIR_EraseRootFromParent_Done,
     /* 1721137 */   // Label 23509: @1721137
     /* 1721137 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1721223), // Rule ID 10583 //
     /* 1721142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1721153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1721156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1721159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721188 */     // MIs[0] policy
     /* 1721188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1721201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721222 */     // GIR_Coverage, 10583,
     /* 1721222 */     GIR_EraseRootFromParent_Done,
     /* 1721223 */   // Label 23510: @1721223
     /* 1721223 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1721309), // Rule ID 10586 //
     /* 1721228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1721239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1721242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1721245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1721251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721274 */     // MIs[0] policy
     /* 1721274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1721287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721308 */     // GIR_Coverage, 10586,
     /* 1721308 */     GIR_EraseRootFromParent_Done,
     /* 1721309 */   // Label 23511: @1721309
     /* 1721309 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1721395), // Rule ID 10587 //
     /* 1721314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1721325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1721328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1721331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1721337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721360 */     // MIs[0] policy
     /* 1721360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1721373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721394 */     // GIR_Coverage, 10587,
     /* 1721394 */     GIR_EraseRootFromParent_Done,
     /* 1721395 */   // Label 23512: @1721395
     /* 1721395 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1721481), // Rule ID 10590 //
     /* 1721400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1721411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1721414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1721417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721446 */     // MIs[0] policy
     /* 1721446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1721459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721480 */     // GIR_Coverage, 10590,
     /* 1721480 */     GIR_EraseRootFromParent_Done,
     /* 1721481 */   // Label 23513: @1721481
     /* 1721481 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1721567), // Rule ID 10591 //
     /* 1721486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1721497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1721500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1721503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1721516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1721524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721532 */     // MIs[0] policy
     /* 1721532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1721545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721566 */     // GIR_Coverage, 10591,
     /* 1721566 */     GIR_EraseRootFromParent_Done,
     /* 1721567 */   // Label 23514: @1721567
     /* 1721567 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1721653), // Rule ID 10594 //
     /* 1721572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1721589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721618 */     // MIs[0] policy
     /* 1721618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1721631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721652 */     // GIR_Coverage, 10594,
     /* 1721652 */     GIR_EraseRootFromParent_Done,
     /* 1721653 */   // Label 23515: @1721653
     /* 1721653 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1721739), // Rule ID 10595 //
     /* 1721658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1721675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721704 */     // MIs[0] policy
     /* 1721704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1721717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721738 */     // GIR_Coverage, 10595,
     /* 1721738 */     GIR_EraseRootFromParent_Done,
     /* 1721739 */   // Label 23516: @1721739
     /* 1721739 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1721825), // Rule ID 10598 //
     /* 1721744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1721755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1721758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1721761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721790 */     // MIs[0] policy
     /* 1721790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1721803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721824 */     // GIR_Coverage, 10598,
     /* 1721824 */     GIR_EraseRootFromParent_Done,
     /* 1721825 */   // Label 23517: @1721825
     /* 1721825 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1721911), // Rule ID 10599 //
     /* 1721830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1721841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1721844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1721847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721876 */     // MIs[0] policy
     /* 1721876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1721889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721910 */     // GIR_Coverage, 10599,
     /* 1721910 */     GIR_EraseRootFromParent_Done,
     /* 1721911 */   // Label 23518: @1721911
     /* 1721911 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1721997), // Rule ID 10602 //
     /* 1721916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1721927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1721930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1721933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1721936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721962 */     // MIs[0] policy
     /* 1721962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721972 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1721975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721996 */     // GIR_Coverage, 10602,
     /* 1721996 */     GIR_EraseRootFromParent_Done,
     /* 1721997 */   // Label 23519: @1721997
     /* 1721997 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1722083), // Rule ID 10603 //
     /* 1722002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1722013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1722016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1722019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1722022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722048 */     // MIs[0] policy
     /* 1722048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1722061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722082 */     // GIR_Coverage, 10603,
     /* 1722082 */     GIR_EraseRootFromParent_Done,
     /* 1722083 */   // Label 23520: @1722083
     /* 1722083 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1722169), // Rule ID 10606 //
     /* 1722088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1722099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1722102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1722105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1722108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722134 */     // MIs[0] policy
     /* 1722134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1722147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722168 */     // GIR_Coverage, 10606,
     /* 1722168 */     GIR_EraseRootFromParent_Done,
     /* 1722169 */   // Label 23521: @1722169
     /* 1722169 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1722255), // Rule ID 10607 //
     /* 1722174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1722185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1722188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1722191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1722194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722220 */     // MIs[0] policy
     /* 1722220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722230 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1722233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722254 */     // GIR_Coverage, 10607,
     /* 1722254 */     GIR_EraseRootFromParent_Done,
     /* 1722255 */   // Label 23522: @1722255
     /* 1722255 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1722341), // Rule ID 10610 //
     /* 1722260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1722271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1722274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1722277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1722280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722306 */     // MIs[0] policy
     /* 1722306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722316 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722340 */     // GIR_Coverage, 10610,
     /* 1722340 */     GIR_EraseRootFromParent_Done,
     /* 1722341 */   // Label 23523: @1722341
     /* 1722341 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1722427), // Rule ID 10611 //
     /* 1722346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1722357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1722360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1722363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1722366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722392 */     // MIs[0] policy
     /* 1722392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722402 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722426 */     // GIR_Coverage, 10611,
     /* 1722426 */     GIR_EraseRootFromParent_Done,
     /* 1722427 */   // Label 23524: @1722427
     /* 1722427 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1722513), // Rule ID 10614 //
     /* 1722432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1722443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1722446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1722449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1722452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722478 */     // MIs[0] policy
     /* 1722478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722488 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1722491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722512 */     // GIR_Coverage, 10614,
     /* 1722512 */     GIR_EraseRootFromParent_Done,
     /* 1722513 */   // Label 23525: @1722513
     /* 1722513 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1722599), // Rule ID 10615 //
     /* 1722518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1722529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1722532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1722535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1722538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722564 */     // MIs[0] policy
     /* 1722564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1722577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722598 */     // GIR_Coverage, 10615,
     /* 1722598 */     GIR_EraseRootFromParent_Done,
     /* 1722599 */   // Label 23526: @1722599
     /* 1722599 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1722685), // Rule ID 10618 //
     /* 1722604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1722615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1722618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1722621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1722624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722650 */     // MIs[0] policy
     /* 1722650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722684 */     // GIR_Coverage, 10618,
     /* 1722684 */     GIR_EraseRootFromParent_Done,
     /* 1722685 */   // Label 23527: @1722685
     /* 1722685 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1722771), // Rule ID 10619 //
     /* 1722690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1722701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1722704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1722707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1722710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722736 */     // MIs[0] policy
     /* 1722736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722770 */     // GIR_Coverage, 10619,
     /* 1722770 */     GIR_EraseRootFromParent_Done,
     /* 1722771 */   // Label 23528: @1722771
     /* 1722771 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1722857), // Rule ID 10622 //
     /* 1722776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1722787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1722790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1722793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1722796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722822 */     // MIs[0] policy
     /* 1722822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722856 */     // GIR_Coverage, 10622,
     /* 1722856 */     GIR_EraseRootFromParent_Done,
     /* 1722857 */   // Label 23529: @1722857
     /* 1722857 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1722943), // Rule ID 10623 //
     /* 1722862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1722873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1722876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1722879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1722882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722908 */     // MIs[0] policy
     /* 1722908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1722921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722942 */     // GIR_Coverage, 10623,
     /* 1722942 */     GIR_EraseRootFromParent_Done,
     /* 1722943 */   // Label 23530: @1722943
     /* 1722943 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1723029), // Rule ID 10626 //
     /* 1722948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1722959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1722962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1722965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1722968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722994 */     // MIs[0] policy
     /* 1722994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723028 */     // GIR_Coverage, 10626,
     /* 1723028 */     GIR_EraseRootFromParent_Done,
     /* 1723029 */   // Label 23531: @1723029
     /* 1723029 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1723115), // Rule ID 10627 //
     /* 1723034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1723045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1723048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1723051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1723054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723080 */     // MIs[0] policy
     /* 1723080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723114 */     // GIR_Coverage, 10627,
     /* 1723114 */     GIR_EraseRootFromParent_Done,
     /* 1723115 */   // Label 23532: @1723115
     /* 1723115 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1723201), // Rule ID 10630 //
     /* 1723120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1723131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1723134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1723137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1723140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723166 */     // MIs[0] policy
     /* 1723166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723200 */     // GIR_Coverage, 10630,
     /* 1723200 */     GIR_EraseRootFromParent_Done,
     /* 1723201 */   // Label 23533: @1723201
     /* 1723201 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1723287), // Rule ID 10631 //
     /* 1723206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1723217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1723220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1723223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1723226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723252 */     // MIs[0] policy
     /* 1723252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723286 */     // GIR_Coverage, 10631,
     /* 1723286 */     GIR_EraseRootFromParent_Done,
     /* 1723287 */   // Label 23534: @1723287
     /* 1723287 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1723373), // Rule ID 10634 //
     /* 1723292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1723303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1723306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1723309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1723312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723338 */     // MIs[0] policy
     /* 1723338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723372 */     // GIR_Coverage, 10634,
     /* 1723372 */     GIR_EraseRootFromParent_Done,
     /* 1723373 */   // Label 23535: @1723373
     /* 1723373 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1723459), // Rule ID 10635 //
     /* 1723378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1723389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1723392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1723395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1723398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723424 */     // MIs[0] policy
     /* 1723424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723458 */     // GIR_Coverage, 10635,
     /* 1723458 */     GIR_EraseRootFromParent_Done,
     /* 1723459 */   // Label 23536: @1723459
     /* 1723459 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1723545), // Rule ID 10638 //
     /* 1723464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1723475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1723478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1723481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1723484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723510 */     // MIs[0] policy
     /* 1723510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723544 */     // GIR_Coverage, 10638,
     /* 1723544 */     GIR_EraseRootFromParent_Done,
     /* 1723545 */   // Label 23537: @1723545
     /* 1723545 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1723631), // Rule ID 10639 //
     /* 1723550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1723561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1723564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1723567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1723570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723596 */     // MIs[0] policy
     /* 1723596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1723609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723630 */     // GIR_Coverage, 10639,
     /* 1723630 */     GIR_EraseRootFromParent_Done,
     /* 1723631 */   // Label 23538: @1723631
     /* 1723631 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1723717), // Rule ID 10642 //
     /* 1723636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1723647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1723650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1723653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1723656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723682 */     // MIs[0] policy
     /* 1723682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1723695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723716 */     // GIR_Coverage, 10642,
     /* 1723716 */     GIR_EraseRootFromParent_Done,
     /* 1723717 */   // Label 23539: @1723717
     /* 1723717 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1723803), // Rule ID 10643 //
     /* 1723722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1723733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1723736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1723739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1723742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723768 */     // MIs[0] policy
     /* 1723768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1723781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723802 */     // GIR_Coverage, 10643,
     /* 1723802 */     GIR_EraseRootFromParent_Done,
     /* 1723803 */   // Label 23540: @1723803
     /* 1723803 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1723889), // Rule ID 10646 //
     /* 1723808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1723819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1723822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1723825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1723828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723854 */     // MIs[0] policy
     /* 1723854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1723867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723888 */     // GIR_Coverage, 10646,
     /* 1723888 */     GIR_EraseRootFromParent_Done,
     /* 1723889 */   // Label 23541: @1723889
     /* 1723889 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1723975), // Rule ID 10647 //
     /* 1723894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1723905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1723908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1723911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1723914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723940 */     // MIs[0] policy
     /* 1723940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723950 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1723953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723974 */     // GIR_Coverage, 10647,
     /* 1723974 */     GIR_EraseRootFromParent_Done,
     /* 1723975 */   // Label 23542: @1723975
     /* 1723975 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1724061), // Rule ID 10650 //
     /* 1723980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1723991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1723994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1723997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1724000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1724003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724026 */     // MIs[0] policy
     /* 1724026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1724039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724060 */     // GIR_Coverage, 10650,
     /* 1724060 */     GIR_EraseRootFromParent_Done,
     /* 1724061 */   // Label 23543: @1724061
     /* 1724061 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1724147), // Rule ID 10651 //
     /* 1724066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1724077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1724080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1724083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1724086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1724089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724112 */     // MIs[0] policy
     /* 1724112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1724125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724146 */     // GIR_Coverage, 10651,
     /* 1724146 */     GIR_EraseRootFromParent_Done,
     /* 1724147 */   // Label 23544: @1724147
     /* 1724147 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1724233), // Rule ID 10654 //
     /* 1724152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1724163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1724166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1724169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1724172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724198 */     // MIs[0] policy
     /* 1724198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1724211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724232 */     // GIR_Coverage, 10654,
     /* 1724232 */     GIR_EraseRootFromParent_Done,
     /* 1724233 */   // Label 23545: @1724233
     /* 1724233 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1724319), // Rule ID 10655 //
     /* 1724238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1724249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1724252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1724255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1724258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724284 */     // MIs[0] policy
     /* 1724284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1724297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724318 */     // GIR_Coverage, 10655,
     /* 1724318 */     GIR_EraseRootFromParent_Done,
     /* 1724319 */   // Label 23546: @1724319
     /* 1724319 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1724405), // Rule ID 10658 //
     /* 1724324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1724335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1724338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1724341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1724344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724370 */     // MIs[0] policy
     /* 1724370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1724383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724404 */     // GIR_Coverage, 10658,
     /* 1724404 */     GIR_EraseRootFromParent_Done,
     /* 1724405 */   // Label 23547: @1724405
     /* 1724405 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1724491), // Rule ID 10659 //
     /* 1724410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1724421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1724424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1724427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1724430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724456 */     // MIs[0] policy
     /* 1724456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1724469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724490 */     // GIR_Coverage, 10659,
     /* 1724490 */     GIR_EraseRootFromParent_Done,
     /* 1724491 */   // Label 23548: @1724491
     /* 1724491 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1724577), // Rule ID 10662 //
     /* 1724496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1724507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1724510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1724513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1724516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724542 */     // MIs[0] policy
     /* 1724542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1724555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724576 */     // GIR_Coverage, 10662,
     /* 1724576 */     GIR_EraseRootFromParent_Done,
     /* 1724577 */   // Label 23549: @1724577
     /* 1724577 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1724663), // Rule ID 10663 //
     /* 1724582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1724593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1724596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1724599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1724602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724628 */     // MIs[0] policy
     /* 1724628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1724641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724662 */     // GIR_Coverage, 10663,
     /* 1724662 */     GIR_EraseRootFromParent_Done,
     /* 1724663 */   // Label 23550: @1724663
     /* 1724663 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1724749), // Rule ID 10666 //
     /* 1724668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1724679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1724682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1724685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1724688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724714 */     // MIs[0] policy
     /* 1724714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1724727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724748 */     // GIR_Coverage, 10666,
     /* 1724748 */     GIR_EraseRootFromParent_Done,
     /* 1724749 */   // Label 23551: @1724749
     /* 1724749 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1724835), // Rule ID 10667 //
     /* 1724754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1724765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1724768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1724771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1724774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724800 */     // MIs[0] policy
     /* 1724800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1724813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724834 */     // GIR_Coverage, 10667,
     /* 1724834 */     GIR_EraseRootFromParent_Done,
     /* 1724835 */   // Label 23552: @1724835
     /* 1724835 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1724921), // Rule ID 10670 //
     /* 1724840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1724851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1724854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1724857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1724860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724886 */     // MIs[0] policy
     /* 1724886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1724899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724920 */     // GIR_Coverage, 10670,
     /* 1724920 */     GIR_EraseRootFromParent_Done,
     /* 1724921 */   // Label 23553: @1724921
     /* 1724921 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1725007), // Rule ID 10671 //
     /* 1724926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1724937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1724940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1724943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1724946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724972 */     // MIs[0] policy
     /* 1724972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1724985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725006 */     // GIR_Coverage, 10671,
     /* 1725006 */     GIR_EraseRootFromParent_Done,
     /* 1725007 */   // Label 23554: @1725007
     /* 1725007 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1725093), // Rule ID 10674 //
     /* 1725012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1725023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1725026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1725029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1725032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725058 */     // MIs[0] policy
     /* 1725058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1725071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725092 */     // GIR_Coverage, 10674,
     /* 1725092 */     GIR_EraseRootFromParent_Done,
     /* 1725093 */   // Label 23555: @1725093
     /* 1725093 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1725179), // Rule ID 10675 //
     /* 1725098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1725109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1725112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1725115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1725118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725144 */     // MIs[0] policy
     /* 1725144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1725157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725178 */     // GIR_Coverage, 10675,
     /* 1725178 */     GIR_EraseRootFromParent_Done,
     /* 1725179 */   // Label 23556: @1725179
     /* 1725179 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1725265), // Rule ID 10678 //
     /* 1725184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1725195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1725198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1725201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1725204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725230 */     // MIs[0] policy
     /* 1725230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1725243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725264 */     // GIR_Coverage, 10678,
     /* 1725264 */     GIR_EraseRootFromParent_Done,
     /* 1725265 */   // Label 23557: @1725265
     /* 1725265 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1725351), // Rule ID 10679 //
     /* 1725270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1725281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1725284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1725287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1725290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725316 */     // MIs[0] policy
     /* 1725316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1725329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725350 */     // GIR_Coverage, 10679,
     /* 1725350 */     GIR_EraseRootFromParent_Done,
     /* 1725351 */   // Label 23558: @1725351
     /* 1725351 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1725437), // Rule ID 10682 //
     /* 1725356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1725367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1725370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1725373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1725376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725402 */     // MIs[0] policy
     /* 1725402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1725415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725436 */     // GIR_Coverage, 10682,
     /* 1725436 */     GIR_EraseRootFromParent_Done,
     /* 1725437 */   // Label 23559: @1725437
     /* 1725437 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1725523), // Rule ID 10683 //
     /* 1725442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1725453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1725456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1725459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1725462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1725472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1725484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725488 */     // MIs[0] policy
     /* 1725488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1725501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725522 */     // GIR_Coverage, 10683,
     /* 1725522 */     GIR_EraseRootFromParent_Done,
     /* 1725523 */   // Label 23560: @1725523
     /* 1725523 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1725609), // Rule ID 10686 //
     /* 1725528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1725539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1725542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1725545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1725548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725574 */     // MIs[0] policy
     /* 1725574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1725587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725608 */     // GIR_Coverage, 10686,
     /* 1725608 */     GIR_EraseRootFromParent_Done,
     /* 1725609 */   // Label 23561: @1725609
     /* 1725609 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1725695), // Rule ID 10687 //
     /* 1725614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1725625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1725628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1725631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1725634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725660 */     // MIs[0] policy
     /* 1725660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1725673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725694 */     // GIR_Coverage, 10687,
     /* 1725694 */     GIR_EraseRootFromParent_Done,
     /* 1725695 */   // Label 23562: @1725695
     /* 1725695 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1725781), // Rule ID 10690 //
     /* 1725700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1725711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1725714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1725717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725746 */     // MIs[0] policy
     /* 1725746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1725759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725780 */     // GIR_Coverage, 10690,
     /* 1725780 */     GIR_EraseRootFromParent_Done,
     /* 1725781 */   // Label 23563: @1725781
     /* 1725781 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1725867), // Rule ID 10691 //
     /* 1725786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1725797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1725800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1725803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725832 */     // MIs[0] policy
     /* 1725832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1725845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725866 */     // GIR_Coverage, 10691,
     /* 1725866 */     GIR_EraseRootFromParent_Done,
     /* 1725867 */   // Label 23564: @1725867
     /* 1725867 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1725953), // Rule ID 10694 //
     /* 1725872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1725883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1725886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1725889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1725892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725918 */     // MIs[0] policy
     /* 1725918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725928 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1725931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725952 */     // GIR_Coverage, 10694,
     /* 1725952 */     GIR_EraseRootFromParent_Done,
     /* 1725953 */   // Label 23565: @1725953
     /* 1725953 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1726039), // Rule ID 10695 //
     /* 1725958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1725969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1725972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1725975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726004 */     // MIs[0] policy
     /* 1726004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1726017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726038 */     // GIR_Coverage, 10695,
     /* 1726038 */     GIR_EraseRootFromParent_Done,
     /* 1726039 */   // Label 23566: @1726039
     /* 1726039 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1726125), // Rule ID 10698 //
     /* 1726044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1726055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1726058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1726061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726090 */     // MIs[0] policy
     /* 1726090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726124 */     // GIR_Coverage, 10698,
     /* 1726124 */     GIR_EraseRootFromParent_Done,
     /* 1726125 */   // Label 23567: @1726125
     /* 1726125 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1726211), // Rule ID 10699 //
     /* 1726130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1726141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1726144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1726147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726176 */     // MIs[0] policy
     /* 1726176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726210 */     // GIR_Coverage, 10699,
     /* 1726210 */     GIR_EraseRootFromParent_Done,
     /* 1726211 */   // Label 23568: @1726211
     /* 1726211 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1726297), // Rule ID 10702 //
     /* 1726216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1726227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1726230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1726233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726262 */     // MIs[0] policy
     /* 1726262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1726275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726296 */     // GIR_Coverage, 10702,
     /* 1726296 */     GIR_EraseRootFromParent_Done,
     /* 1726297 */   // Label 23569: @1726297
     /* 1726297 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1726383), // Rule ID 10703 //
     /* 1726302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1726313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1726316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1726319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726348 */     // MIs[0] policy
     /* 1726348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1726361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726382 */     // GIR_Coverage, 10703,
     /* 1726382 */     GIR_EraseRootFromParent_Done,
     /* 1726383 */   // Label 23570: @1726383
     /* 1726383 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1726469), // Rule ID 10706 //
     /* 1726388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1726399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1726402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1726405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726434 */     // MIs[0] policy
     /* 1726434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726468 */     // GIR_Coverage, 10706,
     /* 1726468 */     GIR_EraseRootFromParent_Done,
     /* 1726469 */   // Label 23571: @1726469
     /* 1726469 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1726555), // Rule ID 10707 //
     /* 1726474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1726485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1726488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1726491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726520 */     // MIs[0] policy
     /* 1726520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726554 */     // GIR_Coverage, 10707,
     /* 1726554 */     GIR_EraseRootFromParent_Done,
     /* 1726555 */   // Label 23572: @1726555
     /* 1726555 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1726641), // Rule ID 10710 //
     /* 1726560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1726577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726606 */     // MIs[0] policy
     /* 1726606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726640 */     // GIR_Coverage, 10710,
     /* 1726640 */     GIR_EraseRootFromParent_Done,
     /* 1726641 */   // Label 23573: @1726641
     /* 1726641 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1726727), // Rule ID 10711 //
     /* 1726646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1726663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726692 */     // MIs[0] policy
     /* 1726692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1726705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726726 */     // GIR_Coverage, 10711,
     /* 1726726 */     GIR_EraseRootFromParent_Done,
     /* 1726727 */   // Label 23574: @1726727
     /* 1726727 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1726813), // Rule ID 10714 //
     /* 1726732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1726743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1726746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1726749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726778 */     // MIs[0] policy
     /* 1726778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1726791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726812 */     // GIR_Coverage, 10714,
     /* 1726812 */     GIR_EraseRootFromParent_Done,
     /* 1726813 */   // Label 23575: @1726813
     /* 1726813 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1726899), // Rule ID 10715 //
     /* 1726818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1726829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1726832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1726835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1726838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726864 */     // MIs[0] policy
     /* 1726864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1726877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726898 */     // GIR_Coverage, 10715,
     /* 1726898 */     GIR_EraseRootFromParent_Done,
     /* 1726899 */   // Label 23576: @1726899
     /* 1726899 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1726985), // Rule ID 10718 //
     /* 1726904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1726915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1726918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1726921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1726924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1726946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726950 */     // MIs[0] policy
     /* 1726950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1726963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726984 */     // GIR_Coverage, 10718,
     /* 1726984 */     GIR_EraseRootFromParent_Done,
     /* 1726985 */   // Label 23577: @1726985
     /* 1726985 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1727071), // Rule ID 10719 //
     /* 1726990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1727001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1727004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1727007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727036 */     // MIs[0] policy
     /* 1727036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1727049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727070 */     // GIR_Coverage, 10719,
     /* 1727070 */     GIR_EraseRootFromParent_Done,
     /* 1727071 */   // Label 23578: @1727071
     /* 1727071 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1727157), // Rule ID 10722 //
     /* 1727076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1727087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1727090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1727093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727122 */     // MIs[0] policy
     /* 1727122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1727135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727156 */     // GIR_Coverage, 10722,
     /* 1727156 */     GIR_EraseRootFromParent_Done,
     /* 1727157 */   // Label 23579: @1727157
     /* 1727157 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1727243), // Rule ID 10723 //
     /* 1727162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1727173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1727176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1727179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727208 */     // MIs[0] policy
     /* 1727208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1727221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727242 */     // GIR_Coverage, 10723,
     /* 1727242 */     GIR_EraseRootFromParent_Done,
     /* 1727243 */   // Label 23580: @1727243
     /* 1727243 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1727329), // Rule ID 10726 //
     /* 1727248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1727259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1727262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1727265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727294 */     // MIs[0] policy
     /* 1727294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1727307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727328 */     // GIR_Coverage, 10726,
     /* 1727328 */     GIR_EraseRootFromParent_Done,
     /* 1727329 */   // Label 23581: @1727329
     /* 1727329 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1727415), // Rule ID 10727 //
     /* 1727334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1727345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1727348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1727351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727380 */     // MIs[0] policy
     /* 1727380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1727393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727414 */     // GIR_Coverage, 10727,
     /* 1727414 */     GIR_EraseRootFromParent_Done,
     /* 1727415 */   // Label 23582: @1727415
     /* 1727415 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1727501), // Rule ID 10730 //
     /* 1727420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1727431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1727434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1727437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727466 */     // MIs[0] policy
     /* 1727466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1727479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727500 */     // GIR_Coverage, 10730,
     /* 1727500 */     GIR_EraseRootFromParent_Done,
     /* 1727501 */   // Label 23583: @1727501
     /* 1727501 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1727587), // Rule ID 10731 //
     /* 1727506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1727517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1727520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1727523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727552 */     // MIs[0] policy
     /* 1727552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1727565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727586 */     // GIR_Coverage, 10731,
     /* 1727586 */     GIR_EraseRootFromParent_Done,
     /* 1727587 */   // Label 23584: @1727587
     /* 1727587 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1727673), // Rule ID 10734 //
     /* 1727592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1727603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1727606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1727609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727638 */     // MIs[0] policy
     /* 1727638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727648 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1727651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727672 */     // GIR_Coverage, 10734,
     /* 1727672 */     GIR_EraseRootFromParent_Done,
     /* 1727673 */   // Label 23585: @1727673
     /* 1727673 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1727759), // Rule ID 10735 //
     /* 1727678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1727689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1727692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1727695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727724 */     // MIs[0] policy
     /* 1727724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1727737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727758 */     // GIR_Coverage, 10735,
     /* 1727758 */     GIR_EraseRootFromParent_Done,
     /* 1727759 */   // Label 23586: @1727759
     /* 1727759 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1727845), // Rule ID 10738 //
     /* 1727764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1727775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1727778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1727781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1727787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727810 */     // MIs[0] policy
     /* 1727810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727820 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1727823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727844 */     // GIR_Coverage, 10738,
     /* 1727844 */     GIR_EraseRootFromParent_Done,
     /* 1727845 */   // Label 23587: @1727845
     /* 1727845 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1727931), // Rule ID 10739 //
     /* 1727850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1727861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1727864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1727867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1727870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1727873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727896 */     // MIs[0] policy
     /* 1727896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1727909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727930 */     // GIR_Coverage, 10739,
     /* 1727930 */     GIR_EraseRootFromParent_Done,
     /* 1727931 */   // Label 23588: @1727931
     /* 1727931 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1728017), // Rule ID 10742 //
     /* 1727936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1727947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1727950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1727953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727982 */     // MIs[0] policy
     /* 1727982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727992 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1727995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728016 */     // GIR_Coverage, 10742,
     /* 1728016 */     GIR_EraseRootFromParent_Done,
     /* 1728017 */   // Label 23589: @1728017
     /* 1728017 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1728103), // Rule ID 10743 //
     /* 1728022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1728033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1728036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1728039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728068 */     // MIs[0] policy
     /* 1728068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1728081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728102 */     // GIR_Coverage, 10743,
     /* 1728102 */     GIR_EraseRootFromParent_Done,
     /* 1728103 */   // Label 23590: @1728103
     /* 1728103 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1728189), // Rule ID 10746 //
     /* 1728108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1728119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1728122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1728125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728154 */     // MIs[0] policy
     /* 1728154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1728167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728188 */     // GIR_Coverage, 10746,
     /* 1728188 */     GIR_EraseRootFromParent_Done,
     /* 1728189 */   // Label 23591: @1728189
     /* 1728189 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1728275), // Rule ID 10747 //
     /* 1728194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1728205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1728208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1728211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728240 */     // MIs[0] policy
     /* 1728240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728250 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1728253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728274 */     // GIR_Coverage, 10747,
     /* 1728274 */     GIR_EraseRootFromParent_Done,
     /* 1728275 */   // Label 23592: @1728275
     /* 1728275 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1728361), // Rule ID 10750 //
     /* 1728280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1728291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1728294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1728297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1728303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728326 */     // MIs[0] policy
     /* 1728326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1728339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728360 */     // GIR_Coverage, 10750,
     /* 1728360 */     GIR_EraseRootFromParent_Done,
     /* 1728361 */   // Label 23593: @1728361
     /* 1728361 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1728447), // Rule ID 10751 //
     /* 1728366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1728377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1728380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1728383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1728389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728412 */     // MIs[0] policy
     /* 1728412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1728425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728446 */     // GIR_Coverage, 10751,
     /* 1728446 */     GIR_EraseRootFromParent_Done,
     /* 1728447 */   // Label 23594: @1728447
     /* 1728447 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1728533), // Rule ID 10754 //
     /* 1728452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1728463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1728466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1728469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728498 */     // MIs[0] policy
     /* 1728498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1728511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728532 */     // GIR_Coverage, 10754,
     /* 1728532 */     GIR_EraseRootFromParent_Done,
     /* 1728533 */   // Label 23595: @1728533
     /* 1728533 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1728619), // Rule ID 10755 //
     /* 1728538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1728549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1728552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1728555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728584 */     // MIs[0] policy
     /* 1728584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1728597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728618 */     // GIR_Coverage, 10755,
     /* 1728618 */     GIR_EraseRootFromParent_Done,
     /* 1728619 */   // Label 23596: @1728619
     /* 1728619 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1728705), // Rule ID 10758 //
     /* 1728624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1728635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1728638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1728641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728670 */     // MIs[0] policy
     /* 1728670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1728683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728704 */     // GIR_Coverage, 10758,
     /* 1728704 */     GIR_EraseRootFromParent_Done,
     /* 1728705 */   // Label 23597: @1728705
     /* 1728705 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1728791), // Rule ID 10759 //
     /* 1728710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1728721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1728724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1728727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728756 */     // MIs[0] policy
     /* 1728756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1728769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728790 */     // GIR_Coverage, 10759,
     /* 1728790 */     GIR_EraseRootFromParent_Done,
     /* 1728791 */   // Label 23598: @1728791
     /* 1728791 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1728877), // Rule ID 10762 //
     /* 1728796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1728807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1728810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1728813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728842 */     // MIs[0] policy
     /* 1728842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1728855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728876 */     // GIR_Coverage, 10762,
     /* 1728876 */     GIR_EraseRootFromParent_Done,
     /* 1728877 */   // Label 23599: @1728877
     /* 1728877 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1728963), // Rule ID 10763 //
     /* 1728882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1728893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1728896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1728899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728928 */     // MIs[0] policy
     /* 1728928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1728941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728962 */     // GIR_Coverage, 10763,
     /* 1728962 */     GIR_EraseRootFromParent_Done,
     /* 1728963 */   // Label 23600: @1728963
     /* 1728963 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1729049), // Rule ID 10766 //
     /* 1728968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1728979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1728982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1728985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729014 */     // MIs[0] policy
     /* 1729014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729048 */     // GIR_Coverage, 10766,
     /* 1729048 */     GIR_EraseRootFromParent_Done,
     /* 1729049 */   // Label 23601: @1729049
     /* 1729049 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1729135), // Rule ID 10767 //
     /* 1729054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1729065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1729068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1729071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729100 */     // MIs[0] policy
     /* 1729100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11356:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729134 */     // GIR_Coverage, 10767,
     /* 1729134 */     GIR_EraseRootFromParent_Done,
     /* 1729135 */   // Label 23602: @1729135
     /* 1729135 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1729221), // Rule ID 10770 //
     /* 1729140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1729151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1729154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1729157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729186 */     // MIs[0] policy
     /* 1729186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729220 */     // GIR_Coverage, 10770,
     /* 1729220 */     GIR_EraseRootFromParent_Done,
     /* 1729221 */   // Label 23603: @1729221
     /* 1729221 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1729307), // Rule ID 10771 //
     /* 1729226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1729237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1729240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1729243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729272 */     // MIs[0] policy
     /* 1729272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11356:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729306 */     // GIR_Coverage, 10771,
     /* 1729306 */     GIR_EraseRootFromParent_Done,
     /* 1729307 */   // Label 23604: @1729307
     /* 1729307 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1729393), // Rule ID 10774 //
     /* 1729312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1729323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1729326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1729329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729358 */     // MIs[0] policy
     /* 1729358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1729371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729392 */     // GIR_Coverage, 10774,
     /* 1729392 */     GIR_EraseRootFromParent_Done,
     /* 1729393 */   // Label 23605: @1729393
     /* 1729393 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1729479), // Rule ID 10775 //
     /* 1729398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1729409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1729412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1729415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1729428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1729436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729444 */     // MIs[0] policy
     /* 1729444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11356:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1729457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729478 */     // GIR_Coverage, 10775,
     /* 1729478 */     GIR_EraseRootFromParent_Done,
     /* 1729479 */   // Label 23606: @1729479
     /* 1729479 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1729565), // Rule ID 10778 //
     /* 1729484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1729495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1729498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1729501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1729504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729530 */     // MIs[0] policy
     /* 1729530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1729543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729564 */     // GIR_Coverage, 10778,
     /* 1729564 */     GIR_EraseRootFromParent_Done,
     /* 1729565 */   // Label 23607: @1729565
     /* 1729565 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1729651), // Rule ID 10779 //
     /* 1729570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1729581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1729584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1729587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1729590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729616 */     // MIs[0] policy
     /* 1729616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1729629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729650 */     // GIR_Coverage, 10779,
     /* 1729650 */     GIR_EraseRootFromParent_Done,
     /* 1729651 */   // Label 23608: @1729651
     /* 1729651 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1729737), // Rule ID 10782 //
     /* 1729656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1729667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1729670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1729673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1729676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729702 */     // MIs[0] policy
     /* 1729702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1729715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729736 */     // GIR_Coverage, 10782,
     /* 1729736 */     GIR_EraseRootFromParent_Done,
     /* 1729737 */   // Label 23609: @1729737
     /* 1729737 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1729823), // Rule ID 10783 //
     /* 1729742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1729753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1729756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1729759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1729762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729788 */     // MIs[0] policy
     /* 1729788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1729801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729822 */     // GIR_Coverage, 10783,
     /* 1729822 */     GIR_EraseRootFromParent_Done,
     /* 1729823 */   // Label 23610: @1729823
     /* 1729823 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1729909), // Rule ID 10786 //
     /* 1729828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1729839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1729842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1729845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1729848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729874 */     // MIs[0] policy
     /* 1729874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1729887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729908 */     // GIR_Coverage, 10786,
     /* 1729908 */     GIR_EraseRootFromParent_Done,
     /* 1729909 */   // Label 23611: @1729909
     /* 1729909 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1729995), // Rule ID 10787 //
     /* 1729914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1729925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1729928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1729931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1729934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729960 */     // MIs[0] policy
     /* 1729960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1729973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729994 */     // GIR_Coverage, 10787,
     /* 1729994 */     GIR_EraseRootFromParent_Done,
     /* 1729995 */   // Label 23612: @1729995
     /* 1729995 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1730081), // Rule ID 10790 //
     /* 1730000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1730011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1730014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1730017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1730020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730046 */     // MIs[0] policy
     /* 1730046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1730059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730080 */     // GIR_Coverage, 10790,
     /* 1730080 */     GIR_EraseRootFromParent_Done,
     /* 1730081 */   // Label 23613: @1730081
     /* 1730081 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1730167), // Rule ID 10791 //
     /* 1730086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1730097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1730100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1730103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1730106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730132 */     // MIs[0] policy
     /* 1730132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1730145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730166 */     // GIR_Coverage, 10791,
     /* 1730166 */     GIR_EraseRootFromParent_Done,
     /* 1730167 */   // Label 23614: @1730167
     /* 1730167 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1730253), // Rule ID 10794 //
     /* 1730172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1730183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1730186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1730189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1730192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730218 */     // MIs[0] policy
     /* 1730218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1730231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730252 */     // GIR_Coverage, 10794,
     /* 1730252 */     GIR_EraseRootFromParent_Done,
     /* 1730253 */   // Label 23615: @1730253
     /* 1730253 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1730339), // Rule ID 10795 //
     /* 1730258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1730269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1730272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1730275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1730278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730304 */     // MIs[0] policy
     /* 1730304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1730317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730338 */     // GIR_Coverage, 10795,
     /* 1730338 */     GIR_EraseRootFromParent_Done,
     /* 1730339 */   // Label 23616: @1730339
     /* 1730339 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1730425), // Rule ID 10798 //
     /* 1730344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1730355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1730358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1730361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1730364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730390 */     // MIs[0] policy
     /* 1730390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1730403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730424 */     // GIR_Coverage, 10798,
     /* 1730424 */     GIR_EraseRootFromParent_Done,
     /* 1730425 */   // Label 23617: @1730425
     /* 1730425 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1730511), // Rule ID 10799 //
     /* 1730430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1730441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1730444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1730447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1730450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730476 */     // MIs[0] policy
     /* 1730476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1730489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730510 */     // GIR_Coverage, 10799,
     /* 1730510 */     GIR_EraseRootFromParent_Done,
     /* 1730511 */   // Label 23618: @1730511
     /* 1730511 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1730597), // Rule ID 10802 //
     /* 1730516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1730527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1730530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1730533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1730536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730562 */     // MIs[0] policy
     /* 1730562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1730575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730596 */     // GIR_Coverage, 10802,
     /* 1730596 */     GIR_EraseRootFromParent_Done,
     /* 1730597 */   // Label 23619: @1730597
     /* 1730597 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1730683), // Rule ID 10803 //
     /* 1730602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1730613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1730616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1730619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1730622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730648 */     // MIs[0] policy
     /* 1730648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1730661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730682 */     // GIR_Coverage, 10803,
     /* 1730682 */     GIR_EraseRootFromParent_Done,
     /* 1730683 */   // Label 23620: @1730683
     /* 1730683 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1730769), // Rule ID 10806 //
     /* 1730688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1730699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1730702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1730705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1730708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730734 */     // MIs[0] policy
     /* 1730734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1730747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730768 */     // GIR_Coverage, 10806,
     /* 1730768 */     GIR_EraseRootFromParent_Done,
     /* 1730769 */   // Label 23621: @1730769
     /* 1730769 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1730855), // Rule ID 10807 //
     /* 1730774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1730785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1730788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1730791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1730794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730820 */     // MIs[0] policy
     /* 1730820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1730833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730854 */     // GIR_Coverage, 10807,
     /* 1730854 */     GIR_EraseRootFromParent_Done,
     /* 1730855 */   // Label 23622: @1730855
     /* 1730855 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1730941), // Rule ID 10810 //
     /* 1730860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1730871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1730874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1730877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1730880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730906 */     // MIs[0] policy
     /* 1730906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1730919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730940 */     // GIR_Coverage, 10810,
     /* 1730940 */     GIR_EraseRootFromParent_Done,
     /* 1730941 */   // Label 23623: @1730941
     /* 1730941 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1731027), // Rule ID 10811 //
     /* 1730946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1730957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1730960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1730963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1730966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730992 */     // MIs[0] policy
     /* 1730992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1731005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731026 */     // GIR_Coverage, 10811,
     /* 1731026 */     GIR_EraseRootFromParent_Done,
     /* 1731027 */   // Label 23624: @1731027
     /* 1731027 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1731113), // Rule ID 10814 //
     /* 1731032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1731043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1731046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1731049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1731052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731078 */     // MIs[0] policy
     /* 1731078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1731091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731112 */     // GIR_Coverage, 10814,
     /* 1731112 */     GIR_EraseRootFromParent_Done,
     /* 1731113 */   // Label 23625: @1731113
     /* 1731113 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1731199), // Rule ID 10815 //
     /* 1731118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1731129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1731132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1731135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1731138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731164 */     // MIs[0] policy
     /* 1731164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1731177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731198 */     // GIR_Coverage, 10815,
     /* 1731198 */     GIR_EraseRootFromParent_Done,
     /* 1731199 */   // Label 23626: @1731199
     /* 1731199 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1731285), // Rule ID 10818 //
     /* 1731204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1731215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1731218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1731221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1731224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731250 */     // MIs[0] policy
     /* 1731250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1731263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731284 */     // GIR_Coverage, 10818,
     /* 1731284 */     GIR_EraseRootFromParent_Done,
     /* 1731285 */   // Label 23627: @1731285
     /* 1731285 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1731371), // Rule ID 10819 //
     /* 1731290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1731301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1731304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1731307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1731310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731336 */     // MIs[0] policy
     /* 1731336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1731349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731370 */     // GIR_Coverage, 10819,
     /* 1731370 */     GIR_EraseRootFromParent_Done,
     /* 1731371 */   // Label 23628: @1731371
     /* 1731371 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1731457), // Rule ID 10822 //
     /* 1731376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1731387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1731390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1731393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1731396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731422 */     // MIs[0] policy
     /* 1731422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1731435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731456 */     // GIR_Coverage, 10822,
     /* 1731456 */     GIR_EraseRootFromParent_Done,
     /* 1731457 */   // Label 23629: @1731457
     /* 1731457 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1731543), // Rule ID 10823 //
     /* 1731462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1731473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1731476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1731479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1731482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731508 */     // MIs[0] policy
     /* 1731508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1731521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731542 */     // GIR_Coverage, 10823,
     /* 1731542 */     GIR_EraseRootFromParent_Done,
     /* 1731543 */   // Label 23630: @1731543
     /* 1731543 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1731629), // Rule ID 10826 //
     /* 1731548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1731559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1731562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1731565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1731568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731594 */     // MIs[0] policy
     /* 1731594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1731607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731628 */     // GIR_Coverage, 10826,
     /* 1731628 */     GIR_EraseRootFromParent_Done,
     /* 1731629 */   // Label 23631: @1731629
     /* 1731629 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1731715), // Rule ID 10827 //
     /* 1731634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1731645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1731648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1731651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1731654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731680 */     // MIs[0] policy
     /* 1731680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1731693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731714 */     // GIR_Coverage, 10827,
     /* 1731714 */     GIR_EraseRootFromParent_Done,
     /* 1731715 */   // Label 23632: @1731715
     /* 1731715 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1731801), // Rule ID 10830 //
     /* 1731720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1731731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1731734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1731737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1731740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731766 */     // MIs[0] policy
     /* 1731766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1731779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731800 */     // GIR_Coverage, 10830,
     /* 1731800 */     GIR_EraseRootFromParent_Done,
     /* 1731801 */   // Label 23633: @1731801
     /* 1731801 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1731887), // Rule ID 10831 //
     /* 1731806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1731817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1731820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1731823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1731826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731852 */     // MIs[0] policy
     /* 1731852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1731865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731886 */     // GIR_Coverage, 10831,
     /* 1731886 */     GIR_EraseRootFromParent_Done,
     /* 1731887 */   // Label 23634: @1731887
     /* 1731887 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1731973), // Rule ID 10834 //
     /* 1731892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1731903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1731906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1731909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1731912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731938 */     // MIs[0] policy
     /* 1731938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1731951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731972 */     // GIR_Coverage, 10834,
     /* 1731972 */     GIR_EraseRootFromParent_Done,
     /* 1731973 */   // Label 23635: @1731973
     /* 1731973 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1732059), // Rule ID 10835 //
     /* 1731978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1731989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1731992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1731995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1731998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732024 */     // MIs[0] policy
     /* 1732024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1732037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732058 */     // GIR_Coverage, 10835,
     /* 1732058 */     GIR_EraseRootFromParent_Done,
     /* 1732059 */   // Label 23636: @1732059
     /* 1732059 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1732145), // Rule ID 10838 //
     /* 1732064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1732075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1732078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1732081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1732084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1732087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732110 */     // MIs[0] policy
     /* 1732110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1732123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732144 */     // GIR_Coverage, 10838,
     /* 1732144 */     GIR_EraseRootFromParent_Done,
     /* 1732145 */   // Label 23637: @1732145
     /* 1732145 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1732231), // Rule ID 10839 //
     /* 1732150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1732161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1732164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1732167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1732170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1732173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732196 */     // MIs[0] policy
     /* 1732196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1732209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732230 */     // GIR_Coverage, 10839,
     /* 1732230 */     GIR_EraseRootFromParent_Done,
     /* 1732231 */   // Label 23638: @1732231
     /* 1732231 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1732317), // Rule ID 10842 //
     /* 1732236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1732247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1732250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1732253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1732256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732282 */     // MIs[0] policy
     /* 1732282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1732295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732316 */     // GIR_Coverage, 10842,
     /* 1732316 */     GIR_EraseRootFromParent_Done,
     /* 1732317 */   // Label 23639: @1732317
     /* 1732317 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1732403), // Rule ID 10843 //
     /* 1732322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1732333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1732336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1732339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1732342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732368 */     // MIs[0] policy
     /* 1732368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1732381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732402 */     // GIR_Coverage, 10843,
     /* 1732402 */     GIR_EraseRootFromParent_Done,
     /* 1732403 */   // Label 23640: @1732403
     /* 1732403 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1732489), // Rule ID 10846 //
     /* 1732408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1732419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1732422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1732425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1732428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732454 */     // MIs[0] policy
     /* 1732454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1732467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732488 */     // GIR_Coverage, 10846,
     /* 1732488 */     GIR_EraseRootFromParent_Done,
     /* 1732489 */   // Label 23641: @1732489
     /* 1732489 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1732575), // Rule ID 10847 //
     /* 1732494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1732505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1732508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1732511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1732514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732540 */     // MIs[0] policy
     /* 1732540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1732553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732574 */     // GIR_Coverage, 10847,
     /* 1732574 */     GIR_EraseRootFromParent_Done,
     /* 1732575 */   // Label 23642: @1732575
     /* 1732575 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1732661), // Rule ID 10850 //
     /* 1732580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1732597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1732600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732626 */     // MIs[0] policy
     /* 1732626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1732639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732660 */     // GIR_Coverage, 10850,
     /* 1732660 */     GIR_EraseRootFromParent_Done,
     /* 1732661 */   // Label 23643: @1732661
     /* 1732661 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1732747), // Rule ID 10851 //
     /* 1732666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1732683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1732686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732712 */     // MIs[0] policy
     /* 1732712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1732725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732746 */     // GIR_Coverage, 10851,
     /* 1732746 */     GIR_EraseRootFromParent_Done,
     /* 1732747 */   // Label 23644: @1732747
     /* 1732747 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1732833), // Rule ID 10854 //
     /* 1732752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1732763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1732766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1732769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1732772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732798 */     // MIs[0] policy
     /* 1732798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1732811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732832 */     // GIR_Coverage, 10854,
     /* 1732832 */     GIR_EraseRootFromParent_Done,
     /* 1732833 */   // Label 23645: @1732833
     /* 1732833 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1732919), // Rule ID 10855 //
     /* 1732838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1732849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1732852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1732855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1732858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732884 */     // MIs[0] policy
     /* 1732884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1732897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732918 */     // GIR_Coverage, 10855,
     /* 1732918 */     GIR_EraseRootFromParent_Done,
     /* 1732919 */   // Label 23646: @1732919
     /* 1732919 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1733005), // Rule ID 10858 //
     /* 1732924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1732935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1732938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1732941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1732944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732970 */     // MIs[0] policy
     /* 1732970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1732983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733004 */     // GIR_Coverage, 10858,
     /* 1733004 */     GIR_EraseRootFromParent_Done,
     /* 1733005 */   // Label 23647: @1733005
     /* 1733005 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1733091), // Rule ID 10859 //
     /* 1733010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1733021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1733024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1733027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1733030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733056 */     // MIs[0] policy
     /* 1733056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1733069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733090 */     // GIR_Coverage, 10859,
     /* 1733090 */     GIR_EraseRootFromParent_Done,
     /* 1733091 */   // Label 23648: @1733091
     /* 1733091 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1733177), // Rule ID 10862 //
     /* 1733096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1733107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1733110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1733113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1733116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733142 */     // MIs[0] policy
     /* 1733142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733176 */     // GIR_Coverage, 10862,
     /* 1733176 */     GIR_EraseRootFromParent_Done,
     /* 1733177 */   // Label 23649: @1733177
     /* 1733177 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1733263), // Rule ID 10863 //
     /* 1733182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1733193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1733196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1733199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1733202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733228 */     // MIs[0] policy
     /* 1733228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733262 */     // GIR_Coverage, 10863,
     /* 1733262 */     GIR_EraseRootFromParent_Done,
     /* 1733263 */   // Label 23650: @1733263
     /* 1733263 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1733349), // Rule ID 10866 //
     /* 1733268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1733279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1733282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1733285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733314 */     // MIs[0] policy
     /* 1733314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733324 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1733327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733348 */     // GIR_Coverage, 10866,
     /* 1733348 */     GIR_EraseRootFromParent_Done,
     /* 1733349 */   // Label 23651: @1733349
     /* 1733349 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1733435), // Rule ID 10867 //
     /* 1733354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1733365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1733368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1733371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733400 */     // MIs[0] policy
     /* 1733400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1733413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733434 */     // GIR_Coverage, 10867,
     /* 1733434 */     GIR_EraseRootFromParent_Done,
     /* 1733435 */   // Label 23652: @1733435
     /* 1733435 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1733521), // Rule ID 10870 //
     /* 1733440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1733451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1733454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1733457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733486 */     // MIs[0] policy
     /* 1733486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1733499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733520 */     // GIR_Coverage, 10870,
     /* 1733520 */     GIR_EraseRootFromParent_Done,
     /* 1733521 */   // Label 23653: @1733521
     /* 1733521 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1733607), // Rule ID 10871 //
     /* 1733526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1733537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1733540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1733543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733572 */     // MIs[0] policy
     /* 1733572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1733585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733606 */     // GIR_Coverage, 10871,
     /* 1733606 */     GIR_EraseRootFromParent_Done,
     /* 1733607 */   // Label 23654: @1733607
     /* 1733607 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1733693), // Rule ID 10874 //
     /* 1733612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1733623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1733626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1733629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733658 */     // MIs[0] policy
     /* 1733658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1733671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733692 */     // GIR_Coverage, 10874,
     /* 1733692 */     GIR_EraseRootFromParent_Done,
     /* 1733693 */   // Label 23655: @1733693
     /* 1733693 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1733779), // Rule ID 10875 //
     /* 1733698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1733709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1733712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1733715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733744 */     // MIs[0] policy
     /* 1733744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1733757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733778 */     // GIR_Coverage, 10875,
     /* 1733778 */     GIR_EraseRootFromParent_Done,
     /* 1733779 */   // Label 23656: @1733779
     /* 1733779 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1733865), // Rule ID 10878 //
     /* 1733784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1733795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1733798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1733801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733830 */     // MIs[0] policy
     /* 1733830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733840 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1733843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733864 */     // GIR_Coverage, 10878,
     /* 1733864 */     GIR_EraseRootFromParent_Done,
     /* 1733865 */   // Label 23657: @1733865
     /* 1733865 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1733951), // Rule ID 10879 //
     /* 1733870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1733881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1733884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1733887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1733890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733916 */     // MIs[0] policy
     /* 1733916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1733929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733950 */     // GIR_Coverage, 10879,
     /* 1733950 */     GIR_EraseRootFromParent_Done,
     /* 1733951 */   // Label 23658: @1733951
     /* 1733951 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1734037), // Rule ID 10882 //
     /* 1733956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1733967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1733970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1733973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1733976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1733998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734002 */     // MIs[0] policy
     /* 1734002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1734015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734036 */     // GIR_Coverage, 10882,
     /* 1734036 */     GIR_EraseRootFromParent_Done,
     /* 1734037 */   // Label 23659: @1734037
     /* 1734037 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1734123), // Rule ID 10883 //
     /* 1734042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1734053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1734056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1734059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734088 */     // MIs[0] policy
     /* 1734088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1734101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734122 */     // GIR_Coverage, 10883,
     /* 1734122 */     GIR_EraseRootFromParent_Done,
     /* 1734123 */   // Label 23660: @1734123
     /* 1734123 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1734209), // Rule ID 10886 //
     /* 1734128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1734139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1734142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1734145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734174 */     // MIs[0] policy
     /* 1734174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1734187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734208 */     // GIR_Coverage, 10886,
     /* 1734208 */     GIR_EraseRootFromParent_Done,
     /* 1734209 */   // Label 23661: @1734209
     /* 1734209 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1734295), // Rule ID 10887 //
     /* 1734214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1734225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1734228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1734231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734260 */     // MIs[0] policy
     /* 1734260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1734273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734294 */     // GIR_Coverage, 10887,
     /* 1734294 */     GIR_EraseRootFromParent_Done,
     /* 1734295 */   // Label 23662: @1734295
     /* 1734295 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1734381), // Rule ID 10890 //
     /* 1734300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1734311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1734314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1734317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734346 */     // MIs[0] policy
     /* 1734346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734380 */     // GIR_Coverage, 10890,
     /* 1734380 */     GIR_EraseRootFromParent_Done,
     /* 1734381 */   // Label 23663: @1734381
     /* 1734381 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1734467), // Rule ID 10891 //
     /* 1734386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1734397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1734400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1734403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734432 */     // MIs[0] policy
     /* 1734432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734466 */     // GIR_Coverage, 10891,
     /* 1734466 */     GIR_EraseRootFromParent_Done,
     /* 1734467 */   // Label 23664: @1734467
     /* 1734467 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1734553), // Rule ID 10894 //
     /* 1734472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1734483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1734486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1734489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734518 */     // MIs[0] policy
     /* 1734518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734552 */     // GIR_Coverage, 10894,
     /* 1734552 */     GIR_EraseRootFromParent_Done,
     /* 1734553 */   // Label 23665: @1734553
     /* 1734553 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1734639), // Rule ID 10895 //
     /* 1734558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1734569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1734572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1734575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734604 */     // MIs[0] policy
     /* 1734604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734638 */     // GIR_Coverage, 10895,
     /* 1734638 */     GIR_EraseRootFromParent_Done,
     /* 1734639 */   // Label 23666: @1734639
     /* 1734639 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1734725), // Rule ID 10898 //
     /* 1734644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1734655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1734658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1734661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734690 */     // MIs[0] policy
     /* 1734690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734724 */     // GIR_Coverage, 10898,
     /* 1734724 */     GIR_EraseRootFromParent_Done,
     /* 1734725 */   // Label 23667: @1734725
     /* 1734725 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1734811), // Rule ID 10899 //
     /* 1734730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1734741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1734744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1734747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734776 */     // MIs[0] policy
     /* 1734776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734810 */     // GIR_Coverage, 10899,
     /* 1734810 */     GIR_EraseRootFromParent_Done,
     /* 1734811 */   // Label 23668: @1734811
     /* 1734811 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1734897), // Rule ID 10902 //
     /* 1734816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1734819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1734827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1734830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1734833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1734836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734862 */     // MIs[0] policy
     /* 1734862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1734893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734896 */     // GIR_Coverage, 10902,
     /* 1734896 */     GIR_EraseRootFromParent_Done,
     /* 1734897 */   // Label 23669: @1734897
     /* 1734897 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1734983), // Rule ID 10903 //
     /* 1734902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1734905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1734913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1734916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1734919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1734922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1734944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734948 */     // MIs[0] policy
     /* 1734948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1734961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1734979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734982 */     // GIR_Coverage, 10903,
     /* 1734982 */     GIR_EraseRootFromParent_Done,
     /* 1734983 */   // Label 23670: @1734983
     /* 1734983 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1735069), // Rule ID 10906 //
     /* 1734988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1734999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1735002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1735005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735034 */     // MIs[0] policy
     /* 1735034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1735047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735068 */     // GIR_Coverage, 10906,
     /* 1735068 */     GIR_EraseRootFromParent_Done,
     /* 1735069 */   // Label 23671: @1735069
     /* 1735069 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1735155), // Rule ID 10907 //
     /* 1735074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1735085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1735088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1735091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735120 */     // MIs[0] policy
     /* 1735120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1735133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735154 */     // GIR_Coverage, 10907,
     /* 1735154 */     GIR_EraseRootFromParent_Done,
     /* 1735155 */   // Label 23672: @1735155
     /* 1735155 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1735241), // Rule ID 10910 //
     /* 1735160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1735171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1735174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1735177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735206 */     // MIs[0] policy
     /* 1735206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1735219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735240 */     // GIR_Coverage, 10910,
     /* 1735240 */     GIR_EraseRootFromParent_Done,
     /* 1735241 */   // Label 23673: @1735241
     /* 1735241 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1735327), // Rule ID 10911 //
     /* 1735246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1735257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1735260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1735263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735292 */     // MIs[0] policy
     /* 1735292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1735305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735326 */     // GIR_Coverage, 10911,
     /* 1735326 */     GIR_EraseRootFromParent_Done,
     /* 1735327 */   // Label 23674: @1735327
     /* 1735327 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1735413), // Rule ID 10914 //
     /* 1735332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1735343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1735346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1735349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1735355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735378 */     // MIs[0] policy
     /* 1735378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735388 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1735391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735412 */     // GIR_Coverage, 10914,
     /* 1735412 */     GIR_EraseRootFromParent_Done,
     /* 1735413 */   // Label 23675: @1735413
     /* 1735413 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1735499), // Rule ID 10915 //
     /* 1735418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1735429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1735432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1735435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1735441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735464 */     // MIs[0] policy
     /* 1735464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1735477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735498 */     // GIR_Coverage, 10915,
     /* 1735498 */     GIR_EraseRootFromParent_Done,
     /* 1735499 */   // Label 23676: @1735499
     /* 1735499 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1735585), // Rule ID 10918 //
     /* 1735504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1735515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1735518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1735521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735550 */     // MIs[0] policy
     /* 1735550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1735563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735584 */     // GIR_Coverage, 10918,
     /* 1735584 */     GIR_EraseRootFromParent_Done,
     /* 1735585 */   // Label 23677: @1735585
     /* 1735585 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1735671), // Rule ID 10919 //
     /* 1735590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1735601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1735604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1735607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735636 */     // MIs[0] policy
     /* 1735636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1735649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735670 */     // GIR_Coverage, 10919,
     /* 1735670 */     GIR_EraseRootFromParent_Done,
     /* 1735671 */   // Label 23678: @1735671
     /* 1735671 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1735757), // Rule ID 10922 //
     /* 1735676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1735687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1735690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1735693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735722 */     // MIs[0] policy
     /* 1735722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735732 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1735735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735756 */     // GIR_Coverage, 10922,
     /* 1735756 */     GIR_EraseRootFromParent_Done,
     /* 1735757 */   // Label 23679: @1735757
     /* 1735757 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1735843), // Rule ID 10923 //
     /* 1735762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1735773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1735776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1735779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735808 */     // MIs[0] policy
     /* 1735808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1735821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735842 */     // GIR_Coverage, 10923,
     /* 1735842 */     GIR_EraseRootFromParent_Done,
     /* 1735843 */   // Label 23680: @1735843
     /* 1735843 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1735929), // Rule ID 10926 //
     /* 1735848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1735859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1735862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1735865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735894 */     // MIs[0] policy
     /* 1735894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735904 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1735907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735928 */     // GIR_Coverage, 10926,
     /* 1735928 */     GIR_EraseRootFromParent_Done,
     /* 1735929 */   // Label 23681: @1735929
     /* 1735929 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1736015), // Rule ID 10927 //
     /* 1735934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1735945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1735948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1735951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735980 */     // MIs[0] policy
     /* 1735980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1735993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736014 */     // GIR_Coverage, 10927,
     /* 1736014 */     GIR_EraseRootFromParent_Done,
     /* 1736015 */   // Label 23682: @1736015
     /* 1736015 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1736101), // Rule ID 10930 //
     /* 1736020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1736031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1736034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1736037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736066 */     // MIs[0] policy
     /* 1736066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1736079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736100 */     // GIR_Coverage, 10930,
     /* 1736100 */     GIR_EraseRootFromParent_Done,
     /* 1736101 */   // Label 23683: @1736101
     /* 1736101 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1736187), // Rule ID 10931 //
     /* 1736106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1736117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1736120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1736123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736152 */     // MIs[0] policy
     /* 1736152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1736165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736186 */     // GIR_Coverage, 10931,
     /* 1736186 */     GIR_EraseRootFromParent_Done,
     /* 1736187 */   // Label 23684: @1736187
     /* 1736187 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1736273), // Rule ID 10934 //
     /* 1736192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1736203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1736206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1736209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736238 */     // MIs[0] policy
     /* 1736238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1736251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736272 */     // GIR_Coverage, 10934,
     /* 1736272 */     GIR_EraseRootFromParent_Done,
     /* 1736273 */   // Label 23685: @1736273
     /* 1736273 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1736359), // Rule ID 10935 //
     /* 1736278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1736289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1736292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1736295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736324 */     // MIs[0] policy
     /* 1736324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1736337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736358 */     // GIR_Coverage, 10935,
     /* 1736358 */     GIR_EraseRootFromParent_Done,
     /* 1736359 */   // Label 23686: @1736359
     /* 1736359 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1736445), // Rule ID 10938 //
     /* 1736364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1736375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1736378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1736381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736410 */     // MIs[0] policy
     /* 1736410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1736423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736444 */     // GIR_Coverage, 10938,
     /* 1736444 */     GIR_EraseRootFromParent_Done,
     /* 1736445 */   // Label 23687: @1736445
     /* 1736445 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1736531), // Rule ID 10939 //
     /* 1736450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1736461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1736464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1736467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1736473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736496 */     // MIs[0] policy
     /* 1736496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1736509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736530 */     // GIR_Coverage, 10939,
     /* 1736530 */     GIR_EraseRootFromParent_Done,
     /* 1736531 */   // Label 23688: @1736531
     /* 1736531 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1736617), // Rule ID 10942 //
     /* 1736536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1736547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1736550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1736553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736582 */     // MIs[0] policy
     /* 1736582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1736595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736616 */     // GIR_Coverage, 10942,
     /* 1736616 */     GIR_EraseRootFromParent_Done,
     /* 1736617 */   // Label 23689: @1736617
     /* 1736617 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1736703), // Rule ID 10943 //
     /* 1736622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1736633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1736636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1736639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736668 */     // MIs[0] policy
     /* 1736668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11354:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1736681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736702 */     // GIR_Coverage, 10943,
     /* 1736702 */     GIR_EraseRootFromParent_Done,
     /* 1736703 */   // Label 23690: @1736703
     /* 1736703 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1736789), // Rule ID 10946 //
     /* 1736708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1736719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1736722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1736725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736754 */     // MIs[0] policy
     /* 1736754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1736767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736788 */     // GIR_Coverage, 10946,
     /* 1736788 */     GIR_EraseRootFromParent_Done,
     /* 1736789 */   // Label 23691: @1736789
     /* 1736789 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1736875), // Rule ID 10947 //
     /* 1736794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1736805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1736808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1736811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736840 */     // MIs[0] policy
     /* 1736840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11354:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1736853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736874 */     // GIR_Coverage, 10947,
     /* 1736874 */     GIR_EraseRootFromParent_Done,
     /* 1736875 */   // Label 23692: @1736875
     /* 1736875 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1736961), // Rule ID 10950 //
     /* 1736880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1736891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1736894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1736897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736926 */     // MIs[0] policy
     /* 1736926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1736939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736960 */     // GIR_Coverage, 10950,
     /* 1736960 */     GIR_EraseRootFromParent_Done,
     /* 1736961 */   // Label 23693: @1736961
     /* 1736961 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1737047), // Rule ID 10951 //
     /* 1736966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1736977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1736980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1736983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737012 */     // MIs[0] policy
     /* 1737012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11354:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1737025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737046 */     // GIR_Coverage, 10951,
     /* 1737046 */     GIR_EraseRootFromParent_Done,
     /* 1737047 */   // Label 23694: @1737047
     /* 1737047 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1737133), // Rule ID 10954 //
     /* 1737052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1737063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1737066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1737069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1737072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737098 */     // MIs[0] policy
     /* 1737098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737108 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1737111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737132 */     // GIR_Coverage, 10954,
     /* 1737132 */     GIR_EraseRootFromParent_Done,
     /* 1737133 */   // Label 23695: @1737133
     /* 1737133 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1737219), // Rule ID 10955 //
     /* 1737138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1737149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1737152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1737155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1737158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737184 */     // MIs[0] policy
     /* 1737184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737194 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1737197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737218 */     // GIR_Coverage, 10955,
     /* 1737218 */     GIR_EraseRootFromParent_Done,
     /* 1737219 */   // Label 23696: @1737219
     /* 1737219 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1737305), // Rule ID 10958 //
     /* 1737224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1737235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1737238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1737241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1737244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737270 */     // MIs[0] policy
     /* 1737270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1737283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737304 */     // GIR_Coverage, 10958,
     /* 1737304 */     GIR_EraseRootFromParent_Done,
     /* 1737305 */   // Label 23697: @1737305
     /* 1737305 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1737391), // Rule ID 10959 //
     /* 1737310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1737321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1737324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1737327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1737330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737356 */     // MIs[0] policy
     /* 1737356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1737369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737390 */     // GIR_Coverage, 10959,
     /* 1737390 */     GIR_EraseRootFromParent_Done,
     /* 1737391 */   // Label 23698: @1737391
     /* 1737391 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1737477), // Rule ID 10962 //
     /* 1737396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1737407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1737410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1737413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1737416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737442 */     // MIs[0] policy
     /* 1737442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1737455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737476 */     // GIR_Coverage, 10962,
     /* 1737476 */     GIR_EraseRootFromParent_Done,
     /* 1737477 */   // Label 23699: @1737477
     /* 1737477 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1737563), // Rule ID 10963 //
     /* 1737482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1737493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1737496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1737499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1737502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737528 */     // MIs[0] policy
     /* 1737528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1737541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737562 */     // GIR_Coverage, 10963,
     /* 1737562 */     GIR_EraseRootFromParent_Done,
     /* 1737563 */   // Label 23700: @1737563
     /* 1737563 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1737649), // Rule ID 10966 //
     /* 1737568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1737588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737614 */     // MIs[0] policy
     /* 1737614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1737627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737648 */     // GIR_Coverage, 10966,
     /* 1737648 */     GIR_EraseRootFromParent_Done,
     /* 1737649 */   // Label 23701: @1737649
     /* 1737649 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1737735), // Rule ID 10967 //
     /* 1737654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1737674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737700 */     // MIs[0] policy
     /* 1737700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1737713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737734 */     // GIR_Coverage, 10967,
     /* 1737734 */     GIR_EraseRootFromParent_Done,
     /* 1737735 */   // Label 23702: @1737735
     /* 1737735 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1737821), // Rule ID 10970 //
     /* 1737740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1737751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1737754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1737757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1737760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737786 */     // MIs[0] policy
     /* 1737786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1737799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737820 */     // GIR_Coverage, 10970,
     /* 1737820 */     GIR_EraseRootFromParent_Done,
     /* 1737821 */   // Label 23703: @1737821
     /* 1737821 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1737907), // Rule ID 10971 //
     /* 1737826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1737837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1737840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1737843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1737846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737872 */     // MIs[0] policy
     /* 1737872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1737885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737906 */     // GIR_Coverage, 10971,
     /* 1737906 */     GIR_EraseRootFromParent_Done,
     /* 1737907 */   // Label 23704: @1737907
     /* 1737907 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1737993), // Rule ID 10974 //
     /* 1737912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1737923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1737926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1737929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1737932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737958 */     // MIs[0] policy
     /* 1737958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1737971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737992 */     // GIR_Coverage, 10974,
     /* 1737992 */     GIR_EraseRootFromParent_Done,
     /* 1737993 */   // Label 23705: @1737993
     /* 1737993 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1738079), // Rule ID 10975 //
     /* 1737998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1738009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1738012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1738015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1738018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738044 */     // MIs[0] policy
     /* 1738044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1738057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738078 */     // GIR_Coverage, 10975,
     /* 1738078 */     GIR_EraseRootFromParent_Done,
     /* 1738079 */   // Label 23706: @1738079
     /* 1738079 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1738165), // Rule ID 10978 //
     /* 1738084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1738095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1738098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1738101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1738104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738130 */     // MIs[0] policy
     /* 1738130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738164 */     // GIR_Coverage, 10978,
     /* 1738164 */     GIR_EraseRootFromParent_Done,
     /* 1738165 */   // Label 23707: @1738165
     /* 1738165 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1738251), // Rule ID 10979 //
     /* 1738170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1738181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1738184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1738187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1738190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738216 */     // MIs[0] policy
     /* 1738216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738250 */     // GIR_Coverage, 10979,
     /* 1738250 */     GIR_EraseRootFromParent_Done,
     /* 1738251 */   // Label 23708: @1738251
     /* 1738251 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1738337), // Rule ID 10982 //
     /* 1738256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1738267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1738270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1738273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1738276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738302 */     // MIs[0] policy
     /* 1738302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738336 */     // GIR_Coverage, 10982,
     /* 1738336 */     GIR_EraseRootFromParent_Done,
     /* 1738337 */   // Label 23709: @1738337
     /* 1738337 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1738423), // Rule ID 10983 //
     /* 1738342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1738353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1738356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1738359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1738362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738388 */     // MIs[0] policy
     /* 1738388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738422 */     // GIR_Coverage, 10983,
     /* 1738422 */     GIR_EraseRootFromParent_Done,
     /* 1738423 */   // Label 23710: @1738423
     /* 1738423 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1738509), // Rule ID 10986 //
     /* 1738428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1738439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1738442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1738445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1738448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738474 */     // MIs[0] policy
     /* 1738474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738508 */     // GIR_Coverage, 10986,
     /* 1738508 */     GIR_EraseRootFromParent_Done,
     /* 1738509 */   // Label 23711: @1738509
     /* 1738509 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1738595), // Rule ID 10987 //
     /* 1738514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1738525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1738528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1738531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1738534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738560 */     // MIs[0] policy
     /* 1738560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738594 */     // GIR_Coverage, 10987,
     /* 1738594 */     GIR_EraseRootFromParent_Done,
     /* 1738595 */   // Label 23712: @1738595
     /* 1738595 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1738681), // Rule ID 10990 //
     /* 1738600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1738611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1738614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1738617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1738620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738646 */     // MIs[0] policy
     /* 1738646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738656 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738680 */     // GIR_Coverage, 10990,
     /* 1738680 */     GIR_EraseRootFromParent_Done,
     /* 1738681 */   // Label 23713: @1738681
     /* 1738681 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1738767), // Rule ID 10991 //
     /* 1738686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1738689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1738697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1738700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1738703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1738706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738732 */     // MIs[0] policy
     /* 1738732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1738745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738766 */     // GIR_Coverage, 10991,
     /* 1738766 */     GIR_EraseRootFromParent_Done,
     /* 1738767 */   // Label 23714: @1738767
     /* 1738767 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1738853), // Rule ID 10994 //
     /* 1738772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1738783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1738786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1738789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1738792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738818 */     // MIs[0] policy
     /* 1738818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1738831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738852 */     // GIR_Coverage, 10994,
     /* 1738852 */     GIR_EraseRootFromParent_Done,
     /* 1738853 */   // Label 23715: @1738853
     /* 1738853 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1738939), // Rule ID 10995 //
     /* 1738858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1738869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1738872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1738875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1738878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738904 */     // MIs[0] policy
     /* 1738904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1738917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738938 */     // GIR_Coverage, 10995,
     /* 1738938 */     GIR_EraseRootFromParent_Done,
     /* 1738939 */   // Label 23716: @1738939
     /* 1738939 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1739025), // Rule ID 10998 //
     /* 1738944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1738955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1738958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1738961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1738964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738990 */     // MIs[0] policy
     /* 1738990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1739003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739024 */     // GIR_Coverage, 10998,
     /* 1739024 */     GIR_EraseRootFromParent_Done,
     /* 1739025 */   // Label 23717: @1739025
     /* 1739025 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1739111), // Rule ID 10999 //
     /* 1739030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1739041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1739044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1739047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1739050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739076 */     // MIs[0] policy
     /* 1739076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1739089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739110 */     // GIR_Coverage, 10999,
     /* 1739110 */     GIR_EraseRootFromParent_Done,
     /* 1739111 */   // Label 23718: @1739111
     /* 1739111 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1739197), // Rule ID 11002 //
     /* 1739116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1739127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1739130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1739133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1739136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1739139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739162 */     // MIs[0] policy
     /* 1739162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1739175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739196 */     // GIR_Coverage, 11002,
     /* 1739196 */     GIR_EraseRootFromParent_Done,
     /* 1739197 */   // Label 23719: @1739197
     /* 1739197 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1739283), // Rule ID 11003 //
     /* 1739202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1739213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1739216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1739219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1739222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1739225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739248 */     // MIs[0] policy
     /* 1739248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1739261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739282 */     // GIR_Coverage, 11003,
     /* 1739282 */     GIR_EraseRootFromParent_Done,
     /* 1739283 */   // Label 23720: @1739283
     /* 1739283 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1739369), // Rule ID 11006 //
     /* 1739288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1739299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1739302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1739305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1739308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739334 */     // MIs[0] policy
     /* 1739334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1739347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739368 */     // GIR_Coverage, 11006,
     /* 1739368 */     GIR_EraseRootFromParent_Done,
     /* 1739369 */   // Label 23721: @1739369
     /* 1739369 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1739455), // Rule ID 11007 //
     /* 1739374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1739385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1739388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1739391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1739394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739420 */     // MIs[0] policy
     /* 1739420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1739433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739454 */     // GIR_Coverage, 11007,
     /* 1739454 */     GIR_EraseRootFromParent_Done,
     /* 1739455 */   // Label 23722: @1739455
     /* 1739455 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1739541), // Rule ID 11010 //
     /* 1739460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1739471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1739474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1739477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1739480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739506 */     // MIs[0] policy
     /* 1739506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1739519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739540 */     // GIR_Coverage, 11010,
     /* 1739540 */     GIR_EraseRootFromParent_Done,
     /* 1739541 */   // Label 23723: @1739541
     /* 1739541 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1739627), // Rule ID 11011 //
     /* 1739546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1739557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1739560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1739563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1739566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739592 */     // MIs[0] policy
     /* 1739592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1739605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739626 */     // GIR_Coverage, 11011,
     /* 1739626 */     GIR_EraseRootFromParent_Done,
     /* 1739627 */   // Label 23724: @1739627
     /* 1739627 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1739713), // Rule ID 11014 //
     /* 1739632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1739643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1739646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1739649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1739652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739678 */     // MIs[0] policy
     /* 1739678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739688 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1739691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739712 */     // GIR_Coverage, 11014,
     /* 1739712 */     GIR_EraseRootFromParent_Done,
     /* 1739713 */   // Label 23725: @1739713
     /* 1739713 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1739799), // Rule ID 11015 //
     /* 1739718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1739729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1739732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1739735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1739738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739764 */     // MIs[0] policy
     /* 1739764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1739777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739798 */     // GIR_Coverage, 11015,
     /* 1739798 */     GIR_EraseRootFromParent_Done,
     /* 1739799 */   // Label 23726: @1739799
     /* 1739799 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1739885), // Rule ID 11018 //
     /* 1739804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1739815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1739818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1739821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1739824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739850 */     // MIs[0] policy
     /* 1739850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1739863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739884 */     // GIR_Coverage, 11018,
     /* 1739884 */     GIR_EraseRootFromParent_Done,
     /* 1739885 */   // Label 23727: @1739885
     /* 1739885 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1739971), // Rule ID 11019 //
     /* 1739890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1739901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1739904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1739907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1739910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739936 */     // MIs[0] policy
     /* 1739936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1739949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739970 */     // GIR_Coverage, 11019,
     /* 1739970 */     GIR_EraseRootFromParent_Done,
     /* 1739971 */   // Label 23728: @1739971
     /* 1739971 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1740057), // Rule ID 11022 //
     /* 1739976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1739987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1739990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1739993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1739996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740022 */     // MIs[0] policy
     /* 1740022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1740035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740056 */     // GIR_Coverage, 11022,
     /* 1740056 */     GIR_EraseRootFromParent_Done,
     /* 1740057 */   // Label 23729: @1740057
     /* 1740057 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1740143), // Rule ID 11023 //
     /* 1740062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1740073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1740076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1740079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1740082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740108 */     // MIs[0] policy
     /* 1740108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1740121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740142 */     // GIR_Coverage, 11023,
     /* 1740142 */     GIR_EraseRootFromParent_Done,
     /* 1740143 */   // Label 23730: @1740143
     /* 1740143 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1740229), // Rule ID 11026 //
     /* 1740148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1740159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1740162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1740165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1740168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1740171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740194 */     // MIs[0] policy
     /* 1740194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1740207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740228 */     // GIR_Coverage, 11026,
     /* 1740228 */     GIR_EraseRootFromParent_Done,
     /* 1740229 */   // Label 23731: @1740229
     /* 1740229 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1740315), // Rule ID 11027 //
     /* 1740234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1740245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1740248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1740251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1740254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1740257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740280 */     // MIs[0] policy
     /* 1740280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1740293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740314 */     // GIR_Coverage, 11027,
     /* 1740314 */     GIR_EraseRootFromParent_Done,
     /* 1740315 */   // Label 23732: @1740315
     /* 1740315 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1740401), // Rule ID 11030 //
     /* 1740320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1740331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1740334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1740337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1740340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740366 */     // MIs[0] policy
     /* 1740366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1740379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740400 */     // GIR_Coverage, 11030,
     /* 1740400 */     GIR_EraseRootFromParent_Done,
     /* 1740401 */   // Label 23733: @1740401
     /* 1740401 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1740487), // Rule ID 11031 //
     /* 1740406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1740417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1740420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1740423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1740426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1740436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1740448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740452 */     // MIs[0] policy
     /* 1740452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1740465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740486 */     // GIR_Coverage, 11031,
     /* 1740486 */     GIR_EraseRootFromParent_Done,
     /* 1740487 */   // Label 23734: @1740487
     /* 1740487 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1740573), // Rule ID 11034 //
     /* 1740492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1740503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1740506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1740509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1740512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740538 */     // MIs[0] policy
     /* 1740538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1740551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740572 */     // GIR_Coverage, 11034,
     /* 1740572 */     GIR_EraseRootFromParent_Done,
     /* 1740573 */   // Label 23735: @1740573
     /* 1740573 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1740659), // Rule ID 11035 //
     /* 1740578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1740589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1740592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1740595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1740598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740624 */     // MIs[0] policy
     /* 1740624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1740637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740658 */     // GIR_Coverage, 11035,
     /* 1740658 */     GIR_EraseRootFromParent_Done,
     /* 1740659 */   // Label 23736: @1740659
     /* 1740659 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1740745), // Rule ID 11038 //
     /* 1740664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1740675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1740678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1740681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1740684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740710 */     // MIs[0] policy
     /* 1740710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1740723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740744 */     // GIR_Coverage, 11038,
     /* 1740744 */     GIR_EraseRootFromParent_Done,
     /* 1740745 */   // Label 23737: @1740745
     /* 1740745 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1740831), // Rule ID 11039 //
     /* 1740750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1740761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1740764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1740767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1740770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740796 */     // MIs[0] policy
     /* 1740796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1740809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740830 */     // GIR_Coverage, 11039,
     /* 1740830 */     GIR_EraseRootFromParent_Done,
     /* 1740831 */   // Label 23738: @1740831
     /* 1740831 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1740917), // Rule ID 11042 //
     /* 1740836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1740847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1740850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1740853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740882 */     // MIs[0] policy
     /* 1740882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1740895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740916 */     // GIR_Coverage, 11042,
     /* 1740916 */     GIR_EraseRootFromParent_Done,
     /* 1740917 */   // Label 23739: @1740917
     /* 1740917 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1741003), // Rule ID 11043 //
     /* 1740922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1740933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1740936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1740939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740968 */     // MIs[0] policy
     /* 1740968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1740981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741002 */     // GIR_Coverage, 11043,
     /* 1741002 */     GIR_EraseRootFromParent_Done,
     /* 1741003 */   // Label 23740: @1741003
     /* 1741003 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1741089), // Rule ID 11046 //
     /* 1741008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1741019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1741022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1741025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741054 */     // MIs[0] policy
     /* 1741054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1741067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741088 */     // GIR_Coverage, 11046,
     /* 1741088 */     GIR_EraseRootFromParent_Done,
     /* 1741089 */   // Label 23741: @1741089
     /* 1741089 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1741175), // Rule ID 11047 //
     /* 1741094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1741105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1741108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1741111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741140 */     // MIs[0] policy
     /* 1741140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1741153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741174 */     // GIR_Coverage, 11047,
     /* 1741174 */     GIR_EraseRootFromParent_Done,
     /* 1741175 */   // Label 23742: @1741175
     /* 1741175 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1741261), // Rule ID 11050 //
     /* 1741180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1741191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1741194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1741197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741226 */     // MIs[0] policy
     /* 1741226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741260 */     // GIR_Coverage, 11050,
     /* 1741260 */     GIR_EraseRootFromParent_Done,
     /* 1741261 */   // Label 23743: @1741261
     /* 1741261 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1741347), // Rule ID 11051 //
     /* 1741266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1741277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1741280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1741283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741312 */     // MIs[0] policy
     /* 1741312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741346 */     // GIR_Coverage, 11051,
     /* 1741346 */     GIR_EraseRootFromParent_Done,
     /* 1741347 */   // Label 23744: @1741347
     /* 1741347 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1741433), // Rule ID 11054 //
     /* 1741352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1741363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1741366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1741369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741398 */     // MIs[0] policy
     /* 1741398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1741411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741432 */     // GIR_Coverage, 11054,
     /* 1741432 */     GIR_EraseRootFromParent_Done,
     /* 1741433 */   // Label 23745: @1741433
     /* 1741433 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1741519), // Rule ID 11055 //
     /* 1741438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1741449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1741452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1741455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741484 */     // MIs[0] policy
     /* 1741484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1741497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741518 */     // GIR_Coverage, 11055,
     /* 1741518 */     GIR_EraseRootFromParent_Done,
     /* 1741519 */   // Label 23746: @1741519
     /* 1741519 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1741605), // Rule ID 11058 //
     /* 1741524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1741535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1741538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1741541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741570 */     // MIs[0] policy
     /* 1741570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741604 */     // GIR_Coverage, 11058,
     /* 1741604 */     GIR_EraseRootFromParent_Done,
     /* 1741605 */   // Label 23747: @1741605
     /* 1741605 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1741691), // Rule ID 11059 //
     /* 1741610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1741621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1741624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1741627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741656 */     // MIs[0] policy
     /* 1741656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741690 */     // GIR_Coverage, 11059,
     /* 1741690 */     GIR_EraseRootFromParent_Done,
     /* 1741691 */   // Label 23748: @1741691
     /* 1741691 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1741777), // Rule ID 11062 //
     /* 1741696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1741707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1741710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1741713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741742 */     // MIs[0] policy
     /* 1741742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741776 */     // GIR_Coverage, 11062,
     /* 1741776 */     GIR_EraseRootFromParent_Done,
     /* 1741777 */   // Label 23749: @1741777
     /* 1741777 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1741863), // Rule ID 11063 //
     /* 1741782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1741793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1741796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1741799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741828 */     // MIs[0] policy
     /* 1741828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1741841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741862 */     // GIR_Coverage, 11063,
     /* 1741862 */     GIR_EraseRootFromParent_Done,
     /* 1741863 */   // Label 23750: @1741863
     /* 1741863 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1741949), // Rule ID 11066 //
     /* 1741868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1741879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1741882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1741885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1741888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741914 */     // MIs[0] policy
     /* 1741914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1741927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741948 */     // GIR_Coverage, 11066,
     /* 1741948 */     GIR_EraseRootFromParent_Done,
     /* 1741949 */   // Label 23751: @1741949
     /* 1741949 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1742035), // Rule ID 11067 //
     /* 1741954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1741965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1741968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1741971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1741974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1741996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742000 */     // MIs[0] policy
     /* 1742000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742034 */     // GIR_Coverage, 11067,
     /* 1742034 */     GIR_EraseRootFromParent_Done,
     /* 1742035 */   // Label 23752: @1742035
     /* 1742035 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1742121), // Rule ID 11070 //
     /* 1742040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1742051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1742054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1742057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742086 */     // MIs[0] policy
     /* 1742086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742120 */     // GIR_Coverage, 11070,
     /* 1742120 */     GIR_EraseRootFromParent_Done,
     /* 1742121 */   // Label 23753: @1742121
     /* 1742121 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1742207), // Rule ID 11071 //
     /* 1742126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1742137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1742140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1742143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742172 */     // MIs[0] policy
     /* 1742172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742206 */     // GIR_Coverage, 11071,
     /* 1742206 */     GIR_EraseRootFromParent_Done,
     /* 1742207 */   // Label 23754: @1742207
     /* 1742207 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1742293), // Rule ID 11074 //
     /* 1742212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1742223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1742226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1742229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742258 */     // MIs[0] policy
     /* 1742258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742292 */     // GIR_Coverage, 11074,
     /* 1742292 */     GIR_EraseRootFromParent_Done,
     /* 1742293 */   // Label 23755: @1742293
     /* 1742293 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1742379), // Rule ID 11075 //
     /* 1742298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1742309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1742312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1742315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742344 */     // MIs[0] policy
     /* 1742344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742378 */     // GIR_Coverage, 11075,
     /* 1742378 */     GIR_EraseRootFromParent_Done,
     /* 1742379 */   // Label 23756: @1742379
     /* 1742379 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1742465), // Rule ID 11078 //
     /* 1742384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1742395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1742398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1742401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742430 */     // MIs[0] policy
     /* 1742430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742464 */     // GIR_Coverage, 11078,
     /* 1742464 */     GIR_EraseRootFromParent_Done,
     /* 1742465 */   // Label 23757: @1742465
     /* 1742465 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1742551), // Rule ID 11079 //
     /* 1742470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1742481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1742484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1742487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1742493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1742500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1742508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742516 */     // MIs[0] policy
     /* 1742516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1742529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742550 */     // GIR_Coverage, 11079,
     /* 1742550 */     GIR_EraseRootFromParent_Done,
     /* 1742551 */   // Label 23758: @1742551
     /* 1742551 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1742637), // Rule ID 11082 //
     /* 1742556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1742567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1742570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1742573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742602 */     // MIs[0] policy
     /* 1742602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1742615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742636 */     // GIR_Coverage, 11082,
     /* 1742636 */     GIR_EraseRootFromParent_Done,
     /* 1742637 */   // Label 23759: @1742637
     /* 1742637 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1742723), // Rule ID 11083 //
     /* 1742642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1742653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1742656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1742659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742688 */     // MIs[0] policy
     /* 1742688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1742701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742722 */     // GIR_Coverage, 11083,
     /* 1742722 */     GIR_EraseRootFromParent_Done,
     /* 1742723 */   // Label 23760: @1742723
     /* 1742723 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1742809), // Rule ID 11086 //
     /* 1742728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1742739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1742742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1742745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742774 */     // MIs[0] policy
     /* 1742774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1742787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742808 */     // GIR_Coverage, 11086,
     /* 1742808 */     GIR_EraseRootFromParent_Done,
     /* 1742809 */   // Label 23761: @1742809
     /* 1742809 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1742895), // Rule ID 11087 //
     /* 1742814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1742825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1742828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1742831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1742834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742860 */     // MIs[0] policy
     /* 1742860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1742873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742894 */     // GIR_Coverage, 11087,
     /* 1742894 */     GIR_EraseRootFromParent_Done,
     /* 1742895 */   // Label 23762: @1742895
     /* 1742895 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1742981), // Rule ID 11090 //
     /* 1742900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1742911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1742914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1742917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1742920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1742923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1742942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742946 */     // MIs[0] policy
     /* 1742946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1742959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742980 */     // GIR_Coverage, 11090,
     /* 1742980 */     GIR_EraseRootFromParent_Done,
     /* 1742981 */   // Label 23763: @1742981
     /* 1742981 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1743067), // Rule ID 11091 //
     /* 1742986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1742997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1743000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1743003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1743009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743032 */     // MIs[0] policy
     /* 1743032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1743045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743066 */     // GIR_Coverage, 11091,
     /* 1743066 */     GIR_EraseRootFromParent_Done,
     /* 1743067 */   // Label 23764: @1743067
     /* 1743067 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1743153), // Rule ID 11094 //
     /* 1743072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1743083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1743086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1743089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743118 */     // MIs[0] policy
     /* 1743118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1743131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743152 */     // GIR_Coverage, 11094,
     /* 1743152 */     GIR_EraseRootFromParent_Done,
     /* 1743153 */   // Label 23765: @1743153
     /* 1743153 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1743239), // Rule ID 11095 //
     /* 1743158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1743169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1743172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1743175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743204 */     // MIs[0] policy
     /* 1743204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1743217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743238 */     // GIR_Coverage, 11095,
     /* 1743238 */     GIR_EraseRootFromParent_Done,
     /* 1743239 */   // Label 23766: @1743239
     /* 1743239 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1743325), // Rule ID 11098 //
     /* 1743244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1743255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1743258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1743261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743290 */     // MIs[0] policy
     /* 1743290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1743303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743324 */     // GIR_Coverage, 11098,
     /* 1743324 */     GIR_EraseRootFromParent_Done,
     /* 1743325 */   // Label 23767: @1743325
     /* 1743325 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1743411), // Rule ID 11099 //
     /* 1743330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1743341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1743344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1743347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743376 */     // MIs[0] policy
     /* 1743376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1743389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743410 */     // GIR_Coverage, 11099,
     /* 1743410 */     GIR_EraseRootFromParent_Done,
     /* 1743411 */   // Label 23768: @1743411
     /* 1743411 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1743497), // Rule ID 11102 //
     /* 1743416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1743427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1743430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1743433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743462 */     // MIs[0] policy
     /* 1743462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1743475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743496 */     // GIR_Coverage, 11102,
     /* 1743496 */     GIR_EraseRootFromParent_Done,
     /* 1743497 */   // Label 23769: @1743497
     /* 1743497 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1743583), // Rule ID 11103 //
     /* 1743502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1743513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1743516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1743519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1743525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743548 */     // MIs[0] policy
     /* 1743548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1743561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743582 */     // GIR_Coverage, 11103,
     /* 1743582 */     GIR_EraseRootFromParent_Done,
     /* 1743583 */   // Label 23770: @1743583
     /* 1743583 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1743669), // Rule ID 11106 //
     /* 1743588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1743599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1743602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1743605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743634 */     // MIs[0] policy
     /* 1743634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1743647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743668 */     // GIR_Coverage, 11106,
     /* 1743668 */     GIR_EraseRootFromParent_Done,
     /* 1743669 */   // Label 23771: @1743669
     /* 1743669 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1743755), // Rule ID 11107 //
     /* 1743674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1743685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1743688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1743691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1743704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1743712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743720 */     // MIs[0] policy
     /* 1743720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1743733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743754 */     // GIR_Coverage, 11107,
     /* 1743754 */     GIR_EraseRootFromParent_Done,
     /* 1743755 */   // Label 23772: @1743755
     /* 1743755 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1743841), // Rule ID 11110 //
     /* 1743760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1743771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1743774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1743777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743806 */     // MIs[0] policy
     /* 1743806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1743819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743840 */     // GIR_Coverage, 11110,
     /* 1743840 */     GIR_EraseRootFromParent_Done,
     /* 1743841 */   // Label 23773: @1743841
     /* 1743841 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1743927), // Rule ID 11111 //
     /* 1743846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1743857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1743860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1743863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743892 */     // MIs[0] policy
     /* 1743892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1743905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743926 */     // GIR_Coverage, 11111,
     /* 1743926 */     GIR_EraseRootFromParent_Done,
     /* 1743927 */   // Label 23774: @1743927
     /* 1743927 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1744013), // Rule ID 11114 //
     /* 1743932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1743943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1743946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1743949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743978 */     // MIs[0] policy
     /* 1743978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1743991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744012 */     // GIR_Coverage, 11114,
     /* 1744012 */     GIR_EraseRootFromParent_Done,
     /* 1744013 */   // Label 23775: @1744013
     /* 1744013 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1744099), // Rule ID 11115 //
     /* 1744018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1744029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1744032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1744035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744064 */     // MIs[0] policy
     /* 1744064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1744077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744098 */     // GIR_Coverage, 11115,
     /* 1744098 */     GIR_EraseRootFromParent_Done,
     /* 1744099 */   // Label 23776: @1744099
     /* 1744099 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1744185), // Rule ID 11118 //
     /* 1744104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1744115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1744118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1744121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744150 */     // MIs[0] policy
     /* 1744150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744184 */     // GIR_Coverage, 11118,
     /* 1744184 */     GIR_EraseRootFromParent_Done,
     /* 1744185 */   // Label 23777: @1744185
     /* 1744185 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1744271), // Rule ID 11119 //
     /* 1744190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1744201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1744204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1744207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744236 */     // MIs[0] policy
     /* 1744236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744270 */     // GIR_Coverage, 11119,
     /* 1744270 */     GIR_EraseRootFromParent_Done,
     /* 1744271 */   // Label 23778: @1744271
     /* 1744271 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1744357), // Rule ID 11122 //
     /* 1744276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1744287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1744290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1744293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744322 */     // MIs[0] policy
     /* 1744322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1744335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744356 */     // GIR_Coverage, 11122,
     /* 1744356 */     GIR_EraseRootFromParent_Done,
     /* 1744357 */   // Label 23779: @1744357
     /* 1744357 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1744443), // Rule ID 11123 //
     /* 1744362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1744373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1744376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1744379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744408 */     // MIs[0] policy
     /* 1744408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1744421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744442 */     // GIR_Coverage, 11123,
     /* 1744442 */     GIR_EraseRootFromParent_Done,
     /* 1744443 */   // Label 23780: @1744443
     /* 1744443 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1744529), // Rule ID 11126 //
     /* 1744448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1744459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1744462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1744465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744494 */     // MIs[0] policy
     /* 1744494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1744507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744528 */     // GIR_Coverage, 11126,
     /* 1744528 */     GIR_EraseRootFromParent_Done,
     /* 1744529 */   // Label 23781: @1744529
     /* 1744529 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1744615), // Rule ID 11127 //
     /* 1744534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1744545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1744548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1744551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1744564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1744572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744580 */     // MIs[0] policy
     /* 1744580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1744593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744614 */     // GIR_Coverage, 11127,
     /* 1744614 */     GIR_EraseRootFromParent_Done,
     /* 1744615 */   // Label 23782: @1744615
     /* 1744615 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1744701), // Rule ID 11130 //
     /* 1744620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1744631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1744634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1744637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1744640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744666 */     // MIs[0] policy
     /* 1744666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1744679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744700 */     // GIR_Coverage, 11130,
     /* 1744700 */     GIR_EraseRootFromParent_Done,
     /* 1744701 */   // Label 23783: @1744701
     /* 1744701 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1744787), // Rule ID 11131 //
     /* 1744706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1744717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1744720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1744723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1744726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744752 */     // MIs[0] policy
     /* 1744752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1744765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744786 */     // GIR_Coverage, 11131,
     /* 1744786 */     GIR_EraseRootFromParent_Done,
     /* 1744787 */   // Label 23784: @1744787
     /* 1744787 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1744873), // Rule ID 11134 //
     /* 1744792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1744803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1744806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1744809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1744812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744838 */     // MIs[0] policy
     /* 1744838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1744851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744872 */     // GIR_Coverage, 11134,
     /* 1744872 */     GIR_EraseRootFromParent_Done,
     /* 1744873 */   // Label 23785: @1744873
     /* 1744873 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1744959), // Rule ID 11135 //
     /* 1744878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1744889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1744892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1744895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1744898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744924 */     // MIs[0] policy
     /* 1744924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1744937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744958 */     // GIR_Coverage, 11135,
     /* 1744958 */     GIR_EraseRootFromParent_Done,
     /* 1744959 */   // Label 23786: @1744959
     /* 1744959 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1745045), // Rule ID 11138 //
     /* 1744964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1744975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1744978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1744981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1744984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745010 */     // MIs[0] policy
     /* 1745010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745044 */     // GIR_Coverage, 11138,
     /* 1745044 */     GIR_EraseRootFromParent_Done,
     /* 1745045 */   // Label 23787: @1745045
     /* 1745045 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1745131), // Rule ID 11139 //
     /* 1745050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1745061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1745064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1745067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1745070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745096 */     // MIs[0] policy
     /* 1745096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745130 */     // GIR_Coverage, 11139,
     /* 1745130 */     GIR_EraseRootFromParent_Done,
     /* 1745131 */   // Label 23788: @1745131
     /* 1745131 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1745217), // Rule ID 11142 //
     /* 1745136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1745147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1745150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1745153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1745156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745182 */     // MIs[0] policy
     /* 1745182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745192 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1745195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745216 */     // GIR_Coverage, 11142,
     /* 1745216 */     GIR_EraseRootFromParent_Done,
     /* 1745217 */   // Label 23789: @1745217
     /* 1745217 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1745303), // Rule ID 11143 //
     /* 1745222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1745233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1745236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1745239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1745242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745268 */     // MIs[0] policy
     /* 1745268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1745281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745302 */     // GIR_Coverage, 11143,
     /* 1745302 */     GIR_EraseRootFromParent_Done,
     /* 1745303 */   // Label 23790: @1745303
     /* 1745303 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1745389), // Rule ID 11146 //
     /* 1745308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1745319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1745322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1745325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1745328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745354 */     // MIs[0] policy
     /* 1745354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745388 */     // GIR_Coverage, 11146,
     /* 1745388 */     GIR_EraseRootFromParent_Done,
     /* 1745389 */   // Label 23791: @1745389
     /* 1745389 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1745475), // Rule ID 11147 //
     /* 1745394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1745405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1745408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1745411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1745414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1745417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745440 */     // MIs[0] policy
     /* 1745440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745474 */     // GIR_Coverage, 11147,
     /* 1745474 */     GIR_EraseRootFromParent_Done,
     /* 1745475 */   // Label 23792: @1745475
     /* 1745475 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1745561), // Rule ID 11150 //
     /* 1745480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1745491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1745494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1745497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1745500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745526 */     // MIs[0] policy
     /* 1745526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745560 */     // GIR_Coverage, 11150,
     /* 1745560 */     GIR_EraseRootFromParent_Done,
     /* 1745561 */   // Label 23793: @1745561
     /* 1745561 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1745647), // Rule ID 11151 //
     /* 1745566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1745577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1745580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1745583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1745586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1745589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745612 */     // MIs[0] policy
     /* 1745612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1745625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745646 */     // GIR_Coverage, 11151,
     /* 1745646 */     GIR_EraseRootFromParent_Done,
     /* 1745647 */   // Label 23794: @1745647
     /* 1745647 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1745733), // Rule ID 11154 //
     /* 1745652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1745663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1745666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1745669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1745672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745698 */     // MIs[0] policy
     /* 1745698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1745711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745732 */     // GIR_Coverage, 11154,
     /* 1745732 */     GIR_EraseRootFromParent_Done,
     /* 1745733 */   // Label 23795: @1745733
     /* 1745733 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1745819), // Rule ID 11155 //
     /* 1745738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1745749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1745752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1745755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1745758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745784 */     // MIs[0] policy
     /* 1745784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1745797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745818 */     // GIR_Coverage, 11155,
     /* 1745818 */     GIR_EraseRootFromParent_Done,
     /* 1745819 */   // Label 23796: @1745819
     /* 1745819 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1745905), // Rule ID 11158 //
     /* 1745824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1745835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1745838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1745841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1745844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745870 */     // MIs[0] policy
     /* 1745870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1745883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745904 */     // GIR_Coverage, 11158,
     /* 1745904 */     GIR_EraseRootFromParent_Done,
     /* 1745905 */   // Label 23797: @1745905
     /* 1745905 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1745991), // Rule ID 11159 //
     /* 1745910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1745921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1745924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1745927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1745930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1745940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1745952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745956 */     // MIs[0] policy
     /* 1745956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1745969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745990 */     // GIR_Coverage, 11159,
     /* 1745990 */     GIR_EraseRootFromParent_Done,
     /* 1745991 */   // Label 23798: @1745991
     /* 1745991 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1746077), // Rule ID 11162 //
     /* 1745996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1746007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1746010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1746013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1746016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746042 */     // MIs[0] policy
     /* 1746042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1746055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746076 */     // GIR_Coverage, 11162,
     /* 1746076 */     GIR_EraseRootFromParent_Done,
     /* 1746077 */   // Label 23799: @1746077
     /* 1746077 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1746163), // Rule ID 11163 //
     /* 1746082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1746093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1746096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1746099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1746102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746128 */     // MIs[0] policy
     /* 1746128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1746141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746162 */     // GIR_Coverage, 11163,
     /* 1746162 */     GIR_EraseRootFromParent_Done,
     /* 1746163 */   // Label 23800: @1746163
     /* 1746163 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1746249), // Rule ID 11166 //
     /* 1746168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1746179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1746182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1746185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1746188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746214 */     // MIs[0] policy
     /* 1746214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1746227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746248 */     // GIR_Coverage, 11166,
     /* 1746248 */     GIR_EraseRootFromParent_Done,
     /* 1746249 */   // Label 23801: @1746249
     /* 1746249 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1746335), // Rule ID 11167 //
     /* 1746254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1746265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1746268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1746271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1746274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746300 */     // MIs[0] policy
     /* 1746300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1746313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746334 */     // GIR_Coverage, 11167,
     /* 1746334 */     GIR_EraseRootFromParent_Done,
     /* 1746335 */   // Label 23802: @1746335
     /* 1746335 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1746421), // Rule ID 11170 //
     /* 1746340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1746351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1746354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1746357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1746360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746386 */     // MIs[0] policy
     /* 1746386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1746399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746420 */     // GIR_Coverage, 11170,
     /* 1746420 */     GIR_EraseRootFromParent_Done,
     /* 1746421 */   // Label 23803: @1746421
     /* 1746421 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1746507), // Rule ID 11171 //
     /* 1746426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1746437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1746440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1746443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1746446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1746449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746472 */     // MIs[0] policy
     /* 1746472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746482 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1746485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746506 */     // GIR_Coverage, 11171,
     /* 1746506 */     GIR_EraseRootFromParent_Done,
     /* 1746507 */   // Label 23804: @1746507
     /* 1746507 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1746593), // Rule ID 11174 //
     /* 1746512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1746523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1746526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1746529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1746532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1746535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746558 */     // MIs[0] policy
     /* 1746558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746568 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1746571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746592 */     // GIR_Coverage, 11174,
     /* 1746592 */     GIR_EraseRootFromParent_Done,
     /* 1746593 */   // Label 23805: @1746593
     /* 1746593 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1746679), // Rule ID 11175 //
     /* 1746598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1746609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1746612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1746615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1746618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1746621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746644 */     // MIs[0] policy
     /* 1746644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746654 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1746657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746678 */     // GIR_Coverage, 11175,
     /* 1746678 */     GIR_EraseRootFromParent_Done,
     /* 1746679 */   // Label 23806: @1746679
     /* 1746679 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1746765), // Rule ID 11178 //
     /* 1746684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1746695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1746698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1746701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1746704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746730 */     // MIs[0] policy
     /* 1746730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1746743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746764 */     // GIR_Coverage, 11178,
     /* 1746764 */     GIR_EraseRootFromParent_Done,
     /* 1746765 */   // Label 23807: @1746765
     /* 1746765 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1746851), // Rule ID 11179 //
     /* 1746770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1746781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1746784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1746787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1746790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746816 */     // MIs[0] policy
     /* 1746816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1746829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746850 */     // GIR_Coverage, 11179,
     /* 1746850 */     GIR_EraseRootFromParent_Done,
     /* 1746851 */   // Label 23808: @1746851
     /* 1746851 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1746937), // Rule ID 11182 //
     /* 1746856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1746867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1746870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1746876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746902 */     // MIs[0] policy
     /* 1746902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1746915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1746933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746936 */     // GIR_Coverage, 11182,
     /* 1746936 */     GIR_EraseRootFromParent_Done,
     /* 1746937 */   // Label 23809: @1746937
     /* 1746937 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1747023), // Rule ID 11183 //
     /* 1746942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1746953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1746956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1746959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1746962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746988 */     // MIs[0] policy
     /* 1746988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1747001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747022 */     // GIR_Coverage, 11183,
     /* 1747022 */     GIR_EraseRootFromParent_Done,
     /* 1747023 */   // Label 23810: @1747023
     /* 1747023 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1747109), // Rule ID 11186 //
     /* 1747028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1747039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1747042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1747045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1747048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1747051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747074 */     // MIs[0] policy
     /* 1747074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1747087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747108 */     // GIR_Coverage, 11186,
     /* 1747108 */     GIR_EraseRootFromParent_Done,
     /* 1747109 */   // Label 23811: @1747109
     /* 1747109 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1747195), // Rule ID 11187 //
     /* 1747114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1747125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1747128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1747131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1747134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1747137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747160 */     // MIs[0] policy
     /* 1747160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1747173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747194 */     // GIR_Coverage, 11187,
     /* 1747194 */     GIR_EraseRootFromParent_Done,
     /* 1747195 */   // Label 23812: @1747195
     /* 1747195 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1747281), // Rule ID 11190 //
     /* 1747200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1747211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1747214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1747217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1747220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1747230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747246 */     // MIs[0] policy
     /* 1747246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1747259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747280 */     // GIR_Coverage, 11190,
     /* 1747280 */     GIR_EraseRootFromParent_Done,
     /* 1747281 */   // Label 23813: @1747281
     /* 1747281 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1747367), // Rule ID 11191 //
     /* 1747286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1747297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1747300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1747303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1747306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1747316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1747328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747332 */     // MIs[0] policy
     /* 1747332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1747345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747366 */     // GIR_Coverage, 11191,
     /* 1747366 */     GIR_EraseRootFromParent_Done,
     /* 1747367 */   // Label 23814: @1747367
     /* 1747367 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1747453), // Rule ID 11194 //
     /* 1747372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1747383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1747386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1747389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1747392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747418 */     // MIs[0] policy
     /* 1747418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1747431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747452 */     // GIR_Coverage, 11194,
     /* 1747452 */     GIR_EraseRootFromParent_Done,
     /* 1747453 */   // Label 23815: @1747453
     /* 1747453 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1747539), // Rule ID 11195 //
     /* 1747458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1747469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1747472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1747475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1747478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1747488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1747500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747504 */     // MIs[0] policy
     /* 1747504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1747517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747538 */     // GIR_Coverage, 11195,
     /* 1747538 */     GIR_EraseRootFromParent_Done,
     /* 1747539 */   // Label 23816: @1747539
     /* 1747539 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1747625), // Rule ID 11198 //
     /* 1747544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1747555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1747558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1747561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1747564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1747567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747590 */     // MIs[0] policy
     /* 1747590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1747603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747624 */     // GIR_Coverage, 11198,
     /* 1747624 */     GIR_EraseRootFromParent_Done,
     /* 1747625 */   // Label 23817: @1747625
     /* 1747625 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1747711), // Rule ID 11199 //
     /* 1747630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1747641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1747644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1747647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1747650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1747653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1747660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1747672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747676 */     // MIs[0] policy
     /* 1747676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1747689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747710 */     // GIR_Coverage, 11199,
     /* 1747710 */     GIR_EraseRootFromParent_Done,
     /* 1747711 */   // Label 23818: @1747711
     /* 1747711 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1747797), // Rule ID 11202 //
     /* 1747716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747762 */     // MIs[0] policy
     /* 1747762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1747775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747796 */     // GIR_Coverage, 11202,
     /* 1747796 */     GIR_EraseRootFromParent_Done,
     /* 1747797 */   // Label 23819: @1747797
     /* 1747797 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1747883), // Rule ID 11203 //
     /* 1747802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1747813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1747816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1747819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747848 */     // MIs[0] policy
     /* 1747848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747858 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1747861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747882 */     // GIR_Coverage, 11203,
     /* 1747882 */     GIR_EraseRootFromParent_Done,
     /* 1747883 */   // Label 23820: @1747883
     /* 1747883 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1747969), // Rule ID 11206 //
     /* 1747888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1747908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1747930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747934 */     // MIs[0] policy
     /* 1747934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747944 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1747947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747968 */     // GIR_Coverage, 11206,
     /* 1747968 */     GIR_EraseRootFromParent_Done,
     /* 1747969 */   // Label 23821: @1747969
     /* 1747969 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1748055), // Rule ID 11207 //
     /* 1747974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1747994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748020 */     // MIs[0] policy
     /* 1748020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1748033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748054 */     // GIR_Coverage, 11207,
     /* 1748054 */     GIR_EraseRootFromParent_Done,
     /* 1748055 */   // Label 23822: @1748055
     /* 1748055 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1748141), // Rule ID 11210 //
     /* 1748060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1748071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1748074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1748077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748106 */     // MIs[0] policy
     /* 1748106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748116 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748140 */     // GIR_Coverage, 11210,
     /* 1748140 */     GIR_EraseRootFromParent_Done,
     /* 1748141 */   // Label 23823: @1748141
     /* 1748141 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1748227), // Rule ID 11211 //
     /* 1748146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1748157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1748160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1748163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748192 */     // MIs[0] policy
     /* 1748192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748202 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748226 */     // GIR_Coverage, 11211,
     /* 1748226 */     GIR_EraseRootFromParent_Done,
     /* 1748227 */   // Label 23824: @1748227
     /* 1748227 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1748313), // Rule ID 11214 //
     /* 1748232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1748243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1748246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1748249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748278 */     // MIs[0] policy
     /* 1748278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748288 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1748291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748312 */     // GIR_Coverage, 11214,
     /* 1748312 */     GIR_EraseRootFromParent_Done,
     /* 1748313 */   // Label 23825: @1748313
     /* 1748313 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1748399), // Rule ID 11215 //
     /* 1748318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1748329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1748332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1748335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748364 */     // MIs[0] policy
     /* 1748364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1748377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748398 */     // GIR_Coverage, 11215,
     /* 1748398 */     GIR_EraseRootFromParent_Done,
     /* 1748399 */   // Label 23826: @1748399
     /* 1748399 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1748485), // Rule ID 11218 //
     /* 1748404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748450 */     // MIs[0] policy
     /* 1748450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748484 */     // GIR_Coverage, 11218,
     /* 1748484 */     GIR_EraseRootFromParent_Done,
     /* 1748485 */   // Label 23827: @1748485
     /* 1748485 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1748571), // Rule ID 11219 //
     /* 1748490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1748501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1748504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1748507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748536 */     // MIs[0] policy
     /* 1748536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748570 */     // GIR_Coverage, 11219,
     /* 1748570 */     GIR_EraseRootFromParent_Done,
     /* 1748571 */   // Label 23828: @1748571
     /* 1748571 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1748657), // Rule ID 11222 //
     /* 1748576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748622 */     // MIs[0] policy
     /* 1748622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748656 */     // GIR_Coverage, 11222,
     /* 1748656 */     GIR_EraseRootFromParent_Done,
     /* 1748657 */   // Label 23829: @1748657
     /* 1748657 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1748743), // Rule ID 11223 //
     /* 1748662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1748673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1748676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1748679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1748685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748708 */     // MIs[0] policy
     /* 1748708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1748721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748742 */     // GIR_Coverage, 11223,
     /* 1748742 */     GIR_EraseRootFromParent_Done,
     /* 1748743 */   // Label 23830: @1748743
     /* 1748743 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1748829), // Rule ID 11226 //
     /* 1748748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748794 */     // MIs[0] policy
     /* 1748794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1748807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748828 */     // GIR_Coverage, 11226,
     /* 1748828 */     GIR_EraseRootFromParent_Done,
     /* 1748829 */   // Label 23831: @1748829
     /* 1748829 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1748915), // Rule ID 11227 //
     /* 1748834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1748845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1748848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1748851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1748854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748880 */     // MIs[0] policy
     /* 1748880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1748893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748914 */     // GIR_Coverage, 11227,
     /* 1748914 */     GIR_EraseRootFromParent_Done,
     /* 1748915 */   // Label 23832: @1748915
     /* 1748915 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1749001), // Rule ID 11230 //
     /* 1748920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1748940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1748962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748966 */     // MIs[0] policy
     /* 1748966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1748979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749000 */     // GIR_Coverage, 11230,
     /* 1749000 */     GIR_EraseRootFromParent_Done,
     /* 1749001 */   // Label 23833: @1749001
     /* 1749001 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1749087), // Rule ID 11231 //
     /* 1749006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1749017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1749020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1749023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749052 */     // MIs[0] policy
     /* 1749052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1749065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749086 */     // GIR_Coverage, 11231,
     /* 1749086 */     GIR_EraseRootFromParent_Done,
     /* 1749087 */   // Label 23834: @1749087
     /* 1749087 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1749173), // Rule ID 11234 //
     /* 1749092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1749103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1749106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1749109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749138 */     // MIs[0] policy
     /* 1749138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1749151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749172 */     // GIR_Coverage, 11234,
     /* 1749172 */     GIR_EraseRootFromParent_Done,
     /* 1749173 */   // Label 23835: @1749173
     /* 1749173 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1749259), // Rule ID 11235 //
     /* 1749178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1749189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1749192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1749195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749224 */     // MIs[0] policy
     /* 1749224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1749237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749258 */     // GIR_Coverage, 11235,
     /* 1749258 */     GIR_EraseRootFromParent_Done,
     /* 1749259 */   // Label 23836: @1749259
     /* 1749259 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1749345), // Rule ID 11238 //
     /* 1749264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1749275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1749278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1749281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749310 */     // MIs[0] policy
     /* 1749310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1749323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749344 */     // GIR_Coverage, 11238,
     /* 1749344 */     GIR_EraseRootFromParent_Done,
     /* 1749345 */   // Label 23837: @1749345
     /* 1749345 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1749431), // Rule ID 11239 //
     /* 1749350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1749361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1749364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1749367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749396 */     // MIs[0] policy
     /* 1749396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749406 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1749409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749430 */     // GIR_Coverage, 11239,
     /* 1749430 */     GIR_EraseRootFromParent_Done,
     /* 1749431 */   // Label 23838: @1749431
     /* 1749431 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1749517), // Rule ID 11242 //
     /* 1749436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749482 */     // MIs[0] policy
     /* 1749482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749492 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1749495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749516 */     // GIR_Coverage, 11242,
     /* 1749516 */     GIR_EraseRootFromParent_Done,
     /* 1749517 */   // Label 23839: @1749517
     /* 1749517 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1749603), // Rule ID 11243 //
     /* 1749522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1749533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1749536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1749539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749568 */     // MIs[0] policy
     /* 1749568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749578 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1749581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749602 */     // GIR_Coverage, 11243,
     /* 1749602 */     GIR_EraseRootFromParent_Done,
     /* 1749603 */   // Label 23840: @1749603
     /* 1749603 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1749689), // Rule ID 11246 //
     /* 1749608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749654 */     // MIs[0] policy
     /* 1749654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1749667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749688 */     // GIR_Coverage, 11246,
     /* 1749688 */     GIR_EraseRootFromParent_Done,
     /* 1749689 */   // Label 23841: @1749689
     /* 1749689 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1749775), // Rule ID 11247 //
     /* 1749694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1749705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1749708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1749711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1749717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749740 */     // MIs[0] policy
     /* 1749740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749750 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1749753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749774 */     // GIR_Coverage, 11247,
     /* 1749774 */     GIR_EraseRootFromParent_Done,
     /* 1749775 */   // Label 23842: @1749775
     /* 1749775 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1749861), // Rule ID 11250 //
     /* 1749780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749826 */     // MIs[0] policy
     /* 1749826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1749839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749860 */     // GIR_Coverage, 11250,
     /* 1749860 */     GIR_EraseRootFromParent_Done,
     /* 1749861 */   // Label 23843: @1749861
     /* 1749861 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1749947), // Rule ID 11251 //
     /* 1749866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749912 */     // MIs[0] policy
     /* 1749912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1749925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749946 */     // GIR_Coverage, 11251,
     /* 1749946 */     GIR_EraseRootFromParent_Done,
     /* 1749947 */   // Label 23844: @1749947
     /* 1749947 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1750033), // Rule ID 11254 //
     /* 1749952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749998 */     // MIs[0] policy
     /* 1749998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1750011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750032 */     // GIR_Coverage, 11254,
     /* 1750032 */     GIR_EraseRootFromParent_Done,
     /* 1750033 */   // Label 23845: @1750033
     /* 1750033 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1750119), // Rule ID 11255 //
     /* 1750038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1750049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1750052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1750055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750084 */     // MIs[0] policy
     /* 1750084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1750097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750118 */     // GIR_Coverage, 11255,
     /* 1750118 */     GIR_EraseRootFromParent_Done,
     /* 1750119 */   // Label 23846: @1750119
     /* 1750119 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1750205), // Rule ID 11258 //
     /* 1750124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1750135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1750138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1750141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1750147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750170 */     // MIs[0] policy
     /* 1750170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1750183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750204 */     // GIR_Coverage, 11258,
     /* 1750204 */     GIR_EraseRootFromParent_Done,
     /* 1750205 */   // Label 23847: @1750205
     /* 1750205 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1750291), // Rule ID 11259 //
     /* 1750210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1750221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1750224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1750227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1750233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750256 */     // MIs[0] policy
     /* 1750256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1750269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750290 */     // GIR_Coverage, 11259,
     /* 1750290 */     GIR_EraseRootFromParent_Done,
     /* 1750291 */   // Label 23848: @1750291
     /* 1750291 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1750377), // Rule ID 11262 //
     /* 1750296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1750307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1750310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1750313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750342 */     // MIs[0] policy
     /* 1750342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1750355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750376 */     // GIR_Coverage, 11262,
     /* 1750376 */     GIR_EraseRootFromParent_Done,
     /* 1750377 */   // Label 23849: @1750377
     /* 1750377 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1750463), // Rule ID 11263 //
     /* 1750382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1750393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1750396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1750399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1750412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1750420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750428 */     // MIs[0] policy
     /* 1750428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1750441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750462 */     // GIR_Coverage, 11263,
     /* 1750462 */     GIR_EraseRootFromParent_Done,
     /* 1750463 */   // Label 23850: @1750463
     /* 1750463 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1750549), // Rule ID 11266 //
     /* 1750468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750514 */     // MIs[0] policy
     /* 1750514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1750527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750548 */     // GIR_Coverage, 11266,
     /* 1750548 */     GIR_EraseRootFromParent_Done,
     /* 1750549 */   // Label 23851: @1750549
     /* 1750549 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1750635), // Rule ID 11267 //
     /* 1750554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1750565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1750568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1750571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1750584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1750592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750600 */     // MIs[0] policy
     /* 1750600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750610 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1750613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750634 */     // GIR_Coverage, 11267,
     /* 1750634 */     GIR_EraseRootFromParent_Done,
     /* 1750635 */   // Label 23852: @1750635
     /* 1750635 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1750721), // Rule ID 11270 //
     /* 1750640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750686 */     // MIs[0] policy
     /* 1750686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750696 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1750699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750720 */     // GIR_Coverage, 11270,
     /* 1750720 */     GIR_EraseRootFromParent_Done,
     /* 1750721 */   // Label 23853: @1750721
     /* 1750721 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1750807), // Rule ID 11271 //
     /* 1750726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1750737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1750740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1750743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1750749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1750756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1750764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750772 */     // MIs[0] policy
     /* 1750772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1750785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750806 */     // GIR_Coverage, 11271,
     /* 1750806 */     GIR_EraseRootFromParent_Done,
     /* 1750807 */   // Label 23854: @1750807
     /* 1750807 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1750893), // Rule ID 11274 //
     /* 1750812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750858 */     // MIs[0] policy
     /* 1750858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1750871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750892 */     // GIR_Coverage, 11274,
     /* 1750892 */     GIR_EraseRootFromParent_Done,
     /* 1750893 */   // Label 23855: @1750893
     /* 1750893 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1750979), // Rule ID 11275 //
     /* 1750898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1750918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750944 */     // MIs[0] policy
     /* 1750944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1750957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750978 */     // GIR_Coverage, 11275,
     /* 1750978 */     GIR_EraseRootFromParent_Done,
     /* 1750979 */   // Label 23856: @1750979
     /* 1750979 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1751065), // Rule ID 11278 //
     /* 1750984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1751001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1751004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751030 */     // MIs[0] policy
     /* 1751030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751040 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1751043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751064 */     // GIR_Coverage, 11278,
     /* 1751064 */     GIR_EraseRootFromParent_Done,
     /* 1751065 */   // Label 23857: @1751065
     /* 1751065 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1751151), // Rule ID 11279 //
     /* 1751070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1751081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1751084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1751087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1751090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751116 */     // MIs[0] policy
     /* 1751116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1751129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751150 */     // GIR_Coverage, 11279,
     /* 1751150 */     GIR_EraseRootFromParent_Done,
     /* 1751151 */   // Label 23858: @1751151
     /* 1751151 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1751237), // Rule ID 11282 //
     /* 1751156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1751167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1751170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1751173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1751176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751202 */     // MIs[0] policy
     /* 1751202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751236 */     // GIR_Coverage, 11282,
     /* 1751236 */     GIR_EraseRootFromParent_Done,
     /* 1751237 */   // Label 23859: @1751237
     /* 1751237 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1751323), // Rule ID 11283 //
     /* 1751242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1751253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1751256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1751259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1751262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751288 */     // MIs[0] policy
     /* 1751288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751322 */     // GIR_Coverage, 11283,
     /* 1751322 */     GIR_EraseRootFromParent_Done,
     /* 1751323 */   // Label 23860: @1751323
     /* 1751323 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1751409), // Rule ID 11286 //
     /* 1751328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751374 */     // MIs[0] policy
     /* 1751374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751384 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1751387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751408 */     // GIR_Coverage, 11286,
     /* 1751408 */     GIR_EraseRootFromParent_Done,
     /* 1751409 */   // Label 23861: @1751409
     /* 1751409 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1751495), // Rule ID 11287 //
     /* 1751414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1751425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1751428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1751431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1751434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751460 */     // MIs[0] policy
     /* 1751460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1751473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751494 */     // GIR_Coverage, 11287,
     /* 1751494 */     GIR_EraseRootFromParent_Done,
     /* 1751495 */   // Label 23862: @1751495
     /* 1751495 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1751581), // Rule ID 11290 //
     /* 1751500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751546 */     // MIs[0] policy
     /* 1751546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751580 */     // GIR_Coverage, 11290,
     /* 1751580 */     GIR_EraseRootFromParent_Done,
     /* 1751581 */   // Label 23863: @1751581
     /* 1751581 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1751667), // Rule ID 11291 //
     /* 1751586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1751597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1751600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1751603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1751606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751632 */     // MIs[0] policy
     /* 1751632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751666 */     // GIR_Coverage, 11291,
     /* 1751666 */     GIR_EraseRootFromParent_Done,
     /* 1751667 */   // Label 23864: @1751667
     /* 1751667 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1751753), // Rule ID 11294 //
     /* 1751672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1751692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751718 */     // MIs[0] policy
     /* 1751718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751752 */     // GIR_Coverage, 11294,
     /* 1751752 */     GIR_EraseRootFromParent_Done,
     /* 1751753 */   // Label 23865: @1751753
     /* 1751753 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1751839), // Rule ID 11295 //
     /* 1751758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1751769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1751772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1751775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1751778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1751781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751804 */     // MIs[0] policy
     /* 1751804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1751817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751838 */     // GIR_Coverage, 11295,
     /* 1751838 */     GIR_EraseRootFromParent_Done,
     /* 1751839 */   // Label 23866: @1751839
     /* 1751839 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1751925), // Rule ID 11298 //
     /* 1751844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1751864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751890 */     // MIs[0] policy
     /* 1751890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1751903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751924 */     // GIR_Coverage, 11298,
     /* 1751924 */     GIR_EraseRootFromParent_Done,
     /* 1751925 */   // Label 23867: @1751925
     /* 1751925 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1752011), // Rule ID 11299 //
     /* 1751930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1751950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751976 */     // MIs[0] policy
     /* 1751976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1751989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752010 */     // GIR_Coverage, 11299,
     /* 1752010 */     GIR_EraseRootFromParent_Done,
     /* 1752011 */   // Label 23868: @1752011
     /* 1752011 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1752097), // Rule ID 11302 //
     /* 1752016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1752027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1752030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1752033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1752036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752062 */     // MIs[0] policy
     /* 1752062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1752075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752096 */     // GIR_Coverage, 11302,
     /* 1752096 */     GIR_EraseRootFromParent_Done,
     /* 1752097 */   // Label 23869: @1752097
     /* 1752097 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1752183), // Rule ID 11303 //
     /* 1752102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1752113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1752116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1752119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1752122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752148 */     // MIs[0] policy
     /* 1752148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1752161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752182 */     // GIR_Coverage, 11303,
     /* 1752182 */     GIR_EraseRootFromParent_Done,
     /* 1752183 */   // Label 23870: @1752183
     /* 1752183 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1752269), // Rule ID 11306 //
     /* 1752188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1752199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1752202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752234 */     // MIs[0] policy
     /* 1752234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1752247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752268 */     // GIR_Coverage, 11306,
     /* 1752268 */     GIR_EraseRootFromParent_Done,
     /* 1752269 */   // Label 23871: @1752269
     /* 1752269 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1752355), // Rule ID 11307 //
     /* 1752274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1752285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1752288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1752291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1752294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752320 */     // MIs[0] policy
     /* 1752320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1752333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752354 */     // GIR_Coverage, 11307,
     /* 1752354 */     GIR_EraseRootFromParent_Done,
     /* 1752355 */   // Label 23872: @1752355
     /* 1752355 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1752441), // Rule ID 11310 //
     /* 1752360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1752380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752406 */     // MIs[0] policy
     /* 1752406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1752419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752440 */     // GIR_Coverage, 11310,
     /* 1752440 */     GIR_EraseRootFromParent_Done,
     /* 1752441 */   // Label 23873: @1752441
     /* 1752441 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1752527), // Rule ID 11311 //
     /* 1752446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1752457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1752460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1752463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1752466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752492 */     // MIs[0] policy
     /* 1752492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1752505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752526 */     // GIR_Coverage, 11311,
     /* 1752526 */     GIR_EraseRootFromParent_Done,
     /* 1752527 */   // Label 23874: @1752527
     /* 1752527 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1752613), // Rule ID 11314 //
     /* 1752532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1752552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752578 */     // MIs[0] policy
     /* 1752578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752588 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1752591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752612 */     // GIR_Coverage, 11314,
     /* 1752612 */     GIR_EraseRootFromParent_Done,
     /* 1752613 */   // Label 23875: @1752613
     /* 1752613 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1752699), // Rule ID 11315 //
     /* 1752618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1752629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1752632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1752635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1752638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752664 */     // MIs[0] policy
     /* 1752664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1752677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752698 */     // GIR_Coverage, 11315,
     /* 1752698 */     GIR_EraseRootFromParent_Done,
     /* 1752699 */   // Label 23876: @1752699
     /* 1752699 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1752785), // Rule ID 11318 //
     /* 1752704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1752724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752750 */     // MIs[0] policy
     /* 1752750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752760 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1752763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752784 */     // GIR_Coverage, 11318,
     /* 1752784 */     GIR_EraseRootFromParent_Done,
     /* 1752785 */   // Label 23877: @1752785
     /* 1752785 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1752871), // Rule ID 11319 //
     /* 1752790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1752801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1752804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1752807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1752810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1752813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752836 */     // MIs[0] policy
     /* 1752836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1752849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752870 */     // GIR_Coverage, 11319,
     /* 1752870 */     GIR_EraseRootFromParent_Done,
     /* 1752871 */   // Label 23878: @1752871
     /* 1752871 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1752957), // Rule ID 11322 //
     /* 1752876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1752896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752922 */     // MIs[0] policy
     /* 1752922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1752935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752956 */     // GIR_Coverage, 11322,
     /* 1752956 */     GIR_EraseRootFromParent_Done,
     /* 1752957 */   // Label 23879: @1752957
     /* 1752957 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1753043), // Rule ID 11323 //
     /* 1752962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1752982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753008 */     // MIs[0] policy
     /* 1753008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1753021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753042 */     // GIR_Coverage, 11323,
     /* 1753042 */     GIR_EraseRootFromParent_Done,
     /* 1753043 */   // Label 23880: @1753043
     /* 1753043 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1753129), // Rule ID 11326 //
     /* 1753048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1753059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1753062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1753065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1753068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753094 */     // MIs[0] policy
     /* 1753094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1753107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753128 */     // GIR_Coverage, 11326,
     /* 1753128 */     GIR_EraseRootFromParent_Done,
     /* 1753129 */   // Label 23881: @1753129
     /* 1753129 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1753215), // Rule ID 11327 //
     /* 1753134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1753145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1753148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1753151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1753154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753180 */     // MIs[0] policy
     /* 1753180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1753193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753214 */     // GIR_Coverage, 11327,
     /* 1753214 */     GIR_EraseRootFromParent_Done,
     /* 1753215 */   // Label 23882: @1753215
     /* 1753215 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1753301), // Rule ID 11330 //
     /* 1753220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1753237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1753240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753266 */     // MIs[0] policy
     /* 1753266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1753279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753300 */     // GIR_Coverage, 11330,
     /* 1753300 */     GIR_EraseRootFromParent_Done,
     /* 1753301 */   // Label 23883: @1753301
     /* 1753301 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1753387), // Rule ID 11331 //
     /* 1753306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1753317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1753320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1753323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1753326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1753329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753352 */     // MIs[0] policy
     /* 1753352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753362 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1753365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753386 */     // GIR_Coverage, 11331,
     /* 1753386 */     GIR_EraseRootFromParent_Done,
     /* 1753387 */   // Label 23884: @1753387
     /* 1753387 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1753473), // Rule ID 11334 //
     /* 1753392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1753412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753438 */     // MIs[0] policy
     /* 1753438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1753451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753472 */     // GIR_Coverage, 11334,
     /* 1753472 */     GIR_EraseRootFromParent_Done,
     /* 1753473 */   // Label 23885: @1753473
     /* 1753473 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1753559), // Rule ID 11335 //
     /* 1753478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1753489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1753492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1753495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1753498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1753508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1753520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753524 */     // MIs[0] policy
     /* 1753524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1753537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753558 */     // GIR_Coverage, 11335,
     /* 1753558 */     GIR_EraseRootFromParent_Done,
     /* 1753559 */   // Label 23886: @1753559
     /* 1753559 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1753645), // Rule ID 11338 //
     /* 1753564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1753584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753610 */     // MIs[0] policy
     /* 1753610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753620 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1753623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753644 */     // GIR_Coverage, 11338,
     /* 1753644 */     GIR_EraseRootFromParent_Done,
     /* 1753645 */   // Label 23887: @1753645
     /* 1753645 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1753731), // Rule ID 11339 //
     /* 1753650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1753661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1753664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1753667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1753670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1753680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1753692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753696 */     // MIs[0] policy
     /* 1753696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1753709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753730 */     // GIR_Coverage, 11339,
     /* 1753730 */     GIR_EraseRootFromParent_Done,
     /* 1753731 */   // Label 23888: @1753731
     /* 1753731 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1753817), // Rule ID 11342 //
     /* 1753736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1753756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753782 */     // MIs[0] policy
     /* 1753782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753792 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1753795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753816 */     // GIR_Coverage, 11342,
     /* 1753816 */     GIR_EraseRootFromParent_Done,
     /* 1753817 */   // Label 23889: @1753817
     /* 1753817 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1753903), // Rule ID 11343 //
     /* 1753822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1753833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1753836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1753839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1753842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1753845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1753852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1753864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753868 */     // MIs[0] policy
     /* 1753868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1753881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753902 */     // GIR_Coverage, 11343,
     /* 1753902 */     GIR_EraseRootFromParent_Done,
     /* 1753903 */   // Label 23890: @1753903
     /* 1753903 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1753989), // Rule ID 11346 //
     /* 1753908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1753928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753954 */     // MIs[0] policy
     /* 1753954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753964 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1753967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753988 */     // GIR_Coverage, 11346,
     /* 1753988 */     GIR_EraseRootFromParent_Done,
     /* 1753989 */   // Label 23891: @1753989
     /* 1753989 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1754075), // Rule ID 11347 //
     /* 1753994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1754005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1754008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1754011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754040 */     // MIs[0] policy
     /* 1754040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1754053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754074 */     // GIR_Coverage, 11347,
     /* 1754074 */     GIR_EraseRootFromParent_Done,
     /* 1754075 */   // Label 23892: @1754075
     /* 1754075 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1754161), // Rule ID 11350 //
     /* 1754080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1754091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1754094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1754097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754126 */     // MIs[0] policy
     /* 1754126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754136 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1754139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754160 */     // GIR_Coverage, 11350,
     /* 1754160 */     GIR_EraseRootFromParent_Done,
     /* 1754161 */   // Label 23893: @1754161
     /* 1754161 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1754247), // Rule ID 11351 //
     /* 1754166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1754177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1754180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1754183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754212 */     // MIs[0] policy
     /* 1754212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754222 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1754225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754246 */     // GIR_Coverage, 11351,
     /* 1754246 */     GIR_EraseRootFromParent_Done,
     /* 1754247 */   // Label 23894: @1754247
     /* 1754247 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1754333), // Rule ID 11354 //
     /* 1754252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1754263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1754266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1754269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754298 */     // MIs[0] policy
     /* 1754298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754308 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754332 */     // GIR_Coverage, 11354,
     /* 1754332 */     GIR_EraseRootFromParent_Done,
     /* 1754333 */   // Label 23895: @1754333
     /* 1754333 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1754419), // Rule ID 11355 //
     /* 1754338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1754349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1754352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1754355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754384 */     // MIs[0] policy
     /* 1754384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754394 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754418 */     // GIR_Coverage, 11355,
     /* 1754418 */     GIR_EraseRootFromParent_Done,
     /* 1754419 */   // Label 23896: @1754419
     /* 1754419 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1754505), // Rule ID 11358 //
     /* 1754424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754470 */     // MIs[0] policy
     /* 1754470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1754483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754504 */     // GIR_Coverage, 11358,
     /* 1754504 */     GIR_EraseRootFromParent_Done,
     /* 1754505 */   // Label 23897: @1754505
     /* 1754505 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1754591), // Rule ID 11359 //
     /* 1754510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1754521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1754524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1754527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754556 */     // MIs[0] policy
     /* 1754556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754566 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1754569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754590 */     // GIR_Coverage, 11359,
     /* 1754590 */     GIR_EraseRootFromParent_Done,
     /* 1754591 */   // Label 23898: @1754591
     /* 1754591 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1754677), // Rule ID 11362 //
     /* 1754596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754642 */     // MIs[0] policy
     /* 1754642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754676 */     // GIR_Coverage, 11362,
     /* 1754676 */     GIR_EraseRootFromParent_Done,
     /* 1754677 */   // Label 23899: @1754677
     /* 1754677 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1754763), // Rule ID 11363 //
     /* 1754682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1754693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1754696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1754699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754728 */     // MIs[0] policy
     /* 1754728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754762 */     // GIR_Coverage, 11363,
     /* 1754762 */     GIR_EraseRootFromParent_Done,
     /* 1754763 */   // Label 23900: @1754763
     /* 1754763 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1754849), // Rule ID 11366 //
     /* 1754768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754814 */     // MIs[0] policy
     /* 1754814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754848 */     // GIR_Coverage, 11366,
     /* 1754848 */     GIR_EraseRootFromParent_Done,
     /* 1754849 */   // Label 23901: @1754849
     /* 1754849 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1754935), // Rule ID 11367 //
     /* 1754854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1754874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754900 */     // MIs[0] policy
     /* 1754900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754910 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1754913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754934 */     // GIR_Coverage, 11367,
     /* 1754934 */     GIR_EraseRootFromParent_Done,
     /* 1754935 */   // Label 23902: @1754935
     /* 1754935 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1755021), // Rule ID 11370 //
     /* 1754940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1754960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1754982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754986 */     // MIs[0] policy
     /* 1754986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1754999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755020 */     // GIR_Coverage, 11370,
     /* 1755020 */     GIR_EraseRootFromParent_Done,
     /* 1755021 */   // Label 23903: @1755021
     /* 1755021 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1755107), // Rule ID 11371 //
     /* 1755026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1755037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1755040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1755043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755072 */     // MIs[0] policy
     /* 1755072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755082 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1755085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755106 */     // GIR_Coverage, 11371,
     /* 1755106 */     GIR_EraseRootFromParent_Done,
     /* 1755107 */   // Label 23904: @1755107
     /* 1755107 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1755193), // Rule ID 11374 //
     /* 1755112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1755129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755158 */     // MIs[0] policy
     /* 1755158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1755171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755192 */     // GIR_Coverage, 11374,
     /* 1755192 */     GIR_EraseRootFromParent_Done,
     /* 1755193 */   // Label 23905: @1755193
     /* 1755193 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1755279), // Rule ID 11375 //
     /* 1755198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1755209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1755212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1755215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755244 */     // MIs[0] policy
     /* 1755244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1755257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755278 */     // GIR_Coverage, 11375,
     /* 1755278 */     GIR_EraseRootFromParent_Done,
     /* 1755279 */   // Label 23906: @1755279
     /* 1755279 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1755365), // Rule ID 11378 //
     /* 1755284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1755295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1755298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1755301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755330 */     // MIs[0] policy
     /* 1755330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1755343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755364 */     // GIR_Coverage, 11378,
     /* 1755364 */     GIR_EraseRootFromParent_Done,
     /* 1755365 */   // Label 23907: @1755365
     /* 1755365 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1755451), // Rule ID 11379 //
     /* 1755370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1755381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1755384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1755387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755416 */     // MIs[0] policy
     /* 1755416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1755429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755450 */     // GIR_Coverage, 11379,
     /* 1755450 */     GIR_EraseRootFromParent_Done,
     /* 1755451 */   // Label 23908: @1755451
     /* 1755451 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1755537), // Rule ID 11382 //
     /* 1755456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755502 */     // MIs[0] policy
     /* 1755502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1755515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755536 */     // GIR_Coverage, 11382,
     /* 1755536 */     GIR_EraseRootFromParent_Done,
     /* 1755537 */   // Label 23909: @1755537
     /* 1755537 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1755623), // Rule ID 11383 //
     /* 1755542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1755553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1755556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1755559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755588 */     // MIs[0] policy
     /* 1755588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1755601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755622 */     // GIR_Coverage, 11383,
     /* 1755622 */     GIR_EraseRootFromParent_Done,
     /* 1755623 */   // Label 23910: @1755623
     /* 1755623 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1755709), // Rule ID 11386 //
     /* 1755628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755674 */     // MIs[0] policy
     /* 1755674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755684 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1755687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755708 */     // GIR_Coverage, 11386,
     /* 1755708 */     GIR_EraseRootFromParent_Done,
     /* 1755709 */   // Label 23911: @1755709
     /* 1755709 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1755795), // Rule ID 11387 //
     /* 1755714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1755725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1755728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1755731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755760 */     // MIs[0] policy
     /* 1755760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755770 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1755773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755794 */     // GIR_Coverage, 11387,
     /* 1755794 */     GIR_EraseRootFromParent_Done,
     /* 1755795 */   // Label 23912: @1755795
     /* 1755795 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1755881), // Rule ID 11390 //
     /* 1755800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755846 */     // MIs[0] policy
     /* 1755846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1755859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755880 */     // GIR_Coverage, 11390,
     /* 1755880 */     GIR_EraseRootFromParent_Done,
     /* 1755881 */   // Label 23913: @1755881
     /* 1755881 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1755967), // Rule ID 11391 //
     /* 1755886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755932 */     // MIs[0] policy
     /* 1755932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755942 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1755945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755966 */     // GIR_Coverage, 11391,
     /* 1755966 */     GIR_EraseRootFromParent_Done,
     /* 1755967 */   // Label 23914: @1755967
     /* 1755967 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1756053), // Rule ID 11394 //
     /* 1755972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756018 */     // MIs[0] policy
     /* 1756018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1756031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756052 */     // GIR_Coverage, 11394,
     /* 1756052 */     GIR_EraseRootFromParent_Done,
     /* 1756053 */   // Label 23915: @1756053
     /* 1756053 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1756139), // Rule ID 11395 //
     /* 1756058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1756069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1756072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1756075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756104 */     // MIs[0] policy
     /* 1756104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1756117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756138 */     // GIR_Coverage, 11395,
     /* 1756138 */     GIR_EraseRootFromParent_Done,
     /* 1756139 */   // Label 23916: @1756139
     /* 1756139 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1756225), // Rule ID 11398 //
     /* 1756144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1756155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1756158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1756161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756190 */     // MIs[0] policy
     /* 1756190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756200 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1756203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756224 */     // GIR_Coverage, 11398,
     /* 1756224 */     GIR_EraseRootFromParent_Done,
     /* 1756225 */   // Label 23917: @1756225
     /* 1756225 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1756311), // Rule ID 11399 //
     /* 1756230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1756241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1756244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1756247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756276 */     // MIs[0] policy
     /* 1756276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1756289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756310 */     // GIR_Coverage, 11399,
     /* 1756310 */     GIR_EraseRootFromParent_Done,
     /* 1756311 */   // Label 23918: @1756311
     /* 1756311 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1756397), // Rule ID 11402 //
     /* 1756316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756362 */     // MIs[0] policy
     /* 1756362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756372 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1756375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756396 */     // GIR_Coverage, 11402,
     /* 1756396 */     GIR_EraseRootFromParent_Done,
     /* 1756397 */   // Label 23919: @1756397
     /* 1756397 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1756483), // Rule ID 11403 //
     /* 1756402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1756413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1756416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1756419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1756425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756448 */     // MIs[0] policy
     /* 1756448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1756461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756482 */     // GIR_Coverage, 11403,
     /* 1756482 */     GIR_EraseRootFromParent_Done,
     /* 1756483 */   // Label 23920: @1756483
     /* 1756483 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1756569), // Rule ID 11406 //
     /* 1756488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756534 */     // MIs[0] policy
     /* 1756534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1756547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756568 */     // GIR_Coverage, 11406,
     /* 1756568 */     GIR_EraseRootFromParent_Done,
     /* 1756569 */   // Label 23921: @1756569
     /* 1756569 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1756655), // Rule ID 11407 //
     /* 1756574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1756585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1756588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1756591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1756604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1756612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756620 */     // MIs[0] policy
     /* 1756620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1756633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756654 */     // GIR_Coverage, 11407,
     /* 1756654 */     GIR_EraseRootFromParent_Done,
     /* 1756655 */   // Label 23922: @1756655
     /* 1756655 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1756741), // Rule ID 11410 //
     /* 1756660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756706 */     // MIs[0] policy
     /* 1756706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1756719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756740 */     // GIR_Coverage, 11410,
     /* 1756740 */     GIR_EraseRootFromParent_Done,
     /* 1756741 */   // Label 23923: @1756741
     /* 1756741 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1756827), // Rule ID 11411 //
     /* 1756746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1756757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1756760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1756763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1756776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1756784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756792 */     // MIs[0] policy
     /* 1756792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1756805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756826 */     // GIR_Coverage, 11411,
     /* 1756826 */     GIR_EraseRootFromParent_Done,
     /* 1756827 */   // Label 23924: @1756827
     /* 1756827 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1756913), // Rule ID 11414 //
     /* 1756832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756878 */     // MIs[0] policy
     /* 1756878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1756891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756912 */     // GIR_Coverage, 11414,
     /* 1756912 */     GIR_EraseRootFromParent_Done,
     /* 1756913 */   // Label 23925: @1756913
     /* 1756913 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1756999), // Rule ID 11415 //
     /* 1756918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756964 */     // MIs[0] policy
     /* 1756964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1756977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756998 */     // GIR_Coverage, 11415,
     /* 1756998 */     GIR_EraseRootFromParent_Done,
     /* 1756999 */   // Label 23926: @1756999
     /* 1756999 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1757085), // Rule ID 11418 //
     /* 1757004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1757015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1757018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1757021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1757024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757050 */     // MIs[0] policy
     /* 1757050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1757063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757084 */     // GIR_Coverage, 11418,
     /* 1757084 */     GIR_EraseRootFromParent_Done,
     /* 1757085 */   // Label 23927: @1757085
     /* 1757085 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1757171), // Rule ID 11419 //
     /* 1757090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1757101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1757104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1757107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1757110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757136 */     // MIs[0] policy
     /* 1757136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757146 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1757149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757170 */     // GIR_Coverage, 11419,
     /* 1757170 */     GIR_EraseRootFromParent_Done,
     /* 1757171 */   // Label 23928: @1757171
     /* 1757171 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1757257), // Rule ID 11422 //
     /* 1757176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1757187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1757190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1757193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1757196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757222 */     // MIs[0] policy
     /* 1757222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1757235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757256 */     // GIR_Coverage, 11422,
     /* 1757256 */     GIR_EraseRootFromParent_Done,
     /* 1757257 */   // Label 23929: @1757257
     /* 1757257 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1757343), // Rule ID 11423 //
     /* 1757262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1757273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1757276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1757279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1757282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757308 */     // MIs[0] policy
     /* 1757308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1757321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757342 */     // GIR_Coverage, 11423,
     /* 1757342 */     GIR_EraseRootFromParent_Done,
     /* 1757343 */   // Label 23930: @1757343
     /* 1757343 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1757429), // Rule ID 11426 //
     /* 1757348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1757368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757394 */     // MIs[0] policy
     /* 1757394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1757407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757428 */     // GIR_Coverage, 11426,
     /* 1757428 */     GIR_EraseRootFromParent_Done,
     /* 1757429 */   // Label 23931: @1757429
     /* 1757429 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1757515), // Rule ID 11427 //
     /* 1757434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1757445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1757448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1757451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1757454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757480 */     // MIs[0] policy
     /* 1757480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1757493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757514 */     // GIR_Coverage, 11427,
     /* 1757514 */     GIR_EraseRootFromParent_Done,
     /* 1757515 */   // Label 23932: @1757515
     /* 1757515 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1757601), // Rule ID 11430 //
     /* 1757520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1757540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757566 */     // MIs[0] policy
     /* 1757566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1757579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757600 */     // GIR_Coverage, 11430,
     /* 1757600 */     GIR_EraseRootFromParent_Done,
     /* 1757601 */   // Label 23933: @1757601
     /* 1757601 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1757687), // Rule ID 11431 //
     /* 1757606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1757617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1757620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1757623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1757626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757652 */     // MIs[0] policy
     /* 1757652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1757665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757686 */     // GIR_Coverage, 11431,
     /* 1757686 */     GIR_EraseRootFromParent_Done,
     /* 1757687 */   // Label 23934: @1757687
     /* 1757687 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1757773), // Rule ID 11434 //
     /* 1757692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1757712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757738 */     // MIs[0] policy
     /* 1757738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757748 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1757751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757772 */     // GIR_Coverage, 11434,
     /* 1757772 */     GIR_EraseRootFromParent_Done,
     /* 1757773 */   // Label 23935: @1757773
     /* 1757773 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1757859), // Rule ID 11435 //
     /* 1757778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1757789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1757792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1757795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1757798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757824 */     // MIs[0] policy
     /* 1757824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1757837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757858 */     // GIR_Coverage, 11435,
     /* 1757858 */     GIR_EraseRootFromParent_Done,
     /* 1757859 */   // Label 23936: @1757859
     /* 1757859 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1757945), // Rule ID 11438 //
     /* 1757864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757910 */     // MIs[0] policy
     /* 1757910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1757923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757944 */     // GIR_Coverage, 11438,
     /* 1757944 */     GIR_EraseRootFromParent_Done,
     /* 1757945 */   // Label 23937: @1757945
     /* 1757945 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1758031), // Rule ID 11439 //
     /* 1757950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1757970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757996 */     // MIs[0] policy
     /* 1757996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1758009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758030 */     // GIR_Coverage, 11439,
     /* 1758030 */     GIR_EraseRootFromParent_Done,
     /* 1758031 */   // Label 23938: @1758031
     /* 1758031 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1758117), // Rule ID 11442 //
     /* 1758036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1758047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1758050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1758053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1758056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758082 */     // MIs[0] policy
     /* 1758082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758116 */     // GIR_Coverage, 11442,
     /* 1758116 */     GIR_EraseRootFromParent_Done,
     /* 1758117 */   // Label 23939: @1758117
     /* 1758117 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1758203), // Rule ID 11443 //
     /* 1758122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1758133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1758136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1758139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1758142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758168 */     // MIs[0] policy
     /* 1758168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758178 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758202 */     // GIR_Coverage, 11443,
     /* 1758202 */     GIR_EraseRootFromParent_Done,
     /* 1758203 */   // Label 23940: @1758203
     /* 1758203 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1758289), // Rule ID 11446 //
     /* 1758208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1758225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1758228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758254 */     // MIs[0] policy
     /* 1758254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758288 */     // GIR_Coverage, 11446,
     /* 1758288 */     GIR_EraseRootFromParent_Done,
     /* 1758289 */   // Label 23941: @1758289
     /* 1758289 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1758375), // Rule ID 11447 //
     /* 1758294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1758305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1758308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1758311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1758314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758340 */     // MIs[0] policy
     /* 1758340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758374 */     // GIR_Coverage, 11447,
     /* 1758374 */     GIR_EraseRootFromParent_Done,
     /* 1758375 */   // Label 23942: @1758375
     /* 1758375 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1758461), // Rule ID 11450 //
     /* 1758380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1758400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758426 */     // MIs[0] policy
     /* 1758426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758460 */     // GIR_Coverage, 11450,
     /* 1758460 */     GIR_EraseRootFromParent_Done,
     /* 1758461 */   // Label 23943: @1758461
     /* 1758461 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1758547), // Rule ID 11451 //
     /* 1758466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1758477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1758480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1758483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1758486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1758489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758512 */     // MIs[0] policy
     /* 1758512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1758525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758546 */     // GIR_Coverage, 11451,
     /* 1758546 */     GIR_EraseRootFromParent_Done,
     /* 1758547 */   // Label 23944: @1758547
     /* 1758547 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1758633), // Rule ID 11454 //
     /* 1758552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758598 */     // MIs[0] policy
     /* 1758598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1758611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758632 */     // GIR_Coverage, 11454,
     /* 1758632 */     GIR_EraseRootFromParent_Done,
     /* 1758633 */   // Label 23945: @1758633
     /* 1758633 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1758719), // Rule ID 11455 //
     /* 1758638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1758649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1758652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1758655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1758658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758684 */     // MIs[0] policy
     /* 1758684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1758697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758718 */     // GIR_Coverage, 11455,
     /* 1758718 */     GIR_EraseRootFromParent_Done,
     /* 1758719 */   // Label 23946: @1758719
     /* 1758719 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1758805), // Rule ID 11458 //
     /* 1758724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758770 */     // MIs[0] policy
     /* 1758770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758780 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1758783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758804 */     // GIR_Coverage, 11458,
     /* 1758804 */     GIR_EraseRootFromParent_Done,
     /* 1758805 */   // Label 23947: @1758805
     /* 1758805 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1758891), // Rule ID 11459 //
     /* 1758810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1758821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1758824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1758827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1758830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758856 */     // MIs[0] policy
     /* 1758856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758866 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1758869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758890 */     // GIR_Coverage, 11459,
     /* 1758890 */     GIR_EraseRootFromParent_Done,
     /* 1758891 */   // Label 23948: @1758891
     /* 1758891 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1758977), // Rule ID 11462 //
     /* 1758896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1758916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758942 */     // MIs[0] policy
     /* 1758942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1758955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758976 */     // GIR_Coverage, 11462,
     /* 1758976 */     GIR_EraseRootFromParent_Done,
     /* 1758977 */   // Label 23949: @1758977
     /* 1758977 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1759063), // Rule ID 11463 //
     /* 1758982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1759002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1759005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759028 */     // MIs[0] policy
     /* 1759028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759038 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1759041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759062 */     // GIR_Coverage, 11463,
     /* 1759062 */     GIR_EraseRootFromParent_Done,
     /* 1759063 */   // Label 23950: @1759063
     /* 1759063 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1759149), // Rule ID 11466 //
     /* 1759068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1759079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1759082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1759085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1759088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759114 */     // MIs[0] policy
     /* 1759114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1759127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759148 */     // GIR_Coverage, 11466,
     /* 1759148 */     GIR_EraseRootFromParent_Done,
     /* 1759149 */   // Label 23951: @1759149
     /* 1759149 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1759235), // Rule ID 11467 //
     /* 1759154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1759165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1759168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1759171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1759174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759200 */     // MIs[0] policy
     /* 1759200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1759213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759234 */     // GIR_Coverage, 11467,
     /* 1759234 */     GIR_EraseRootFromParent_Done,
     /* 1759235 */   // Label 23952: @1759235
     /* 1759235 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1759321), // Rule ID 11470 //
     /* 1759240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1759251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1759254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1759257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759286 */     // MIs[0] policy
     /* 1759286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1759299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759320 */     // GIR_Coverage, 11470,
     /* 1759320 */     GIR_EraseRootFromParent_Done,
     /* 1759321 */   // Label 23953: @1759321
     /* 1759321 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1759407), // Rule ID 11471 //
     /* 1759326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1759337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1759340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1759343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1759346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759372 */     // MIs[0] policy
     /* 1759372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1759385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759406 */     // GIR_Coverage, 11471,
     /* 1759406 */     GIR_EraseRootFromParent_Done,
     /* 1759407 */   // Label 23954: @1759407
     /* 1759407 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1759493), // Rule ID 11474 //
     /* 1759412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1759432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759458 */     // MIs[0] policy
     /* 1759458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759468 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1759471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759492 */     // GIR_Coverage, 11474,
     /* 1759492 */     GIR_EraseRootFromParent_Done,
     /* 1759493 */   // Label 23955: @1759493
     /* 1759493 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1759579), // Rule ID 11475 //
     /* 1759498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1759509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1759512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1759515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1759518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1759521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759544 */     // MIs[0] policy
     /* 1759544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759554 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1759557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759578 */     // GIR_Coverage, 11475,
     /* 1759578 */     GIR_EraseRootFromParent_Done,
     /* 1759579 */   // Label 23956: @1759579
     /* 1759579 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1759665), // Rule ID 11478 //
     /* 1759584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1759604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759630 */     // MIs[0] policy
     /* 1759630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1759643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759664 */     // GIR_Coverage, 11478,
     /* 1759664 */     GIR_EraseRootFromParent_Done,
     /* 1759665 */   // Label 23957: @1759665
     /* 1759665 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1759751), // Rule ID 11479 //
     /* 1759670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1759681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1759684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1759687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1759690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759716 */     // MIs[0] policy
     /* 1759716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1759729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759750 */     // GIR_Coverage, 11479,
     /* 1759750 */     GIR_EraseRootFromParent_Done,
     /* 1759751 */   // Label 23958: @1759751
     /* 1759751 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1759837), // Rule ID 11482 //
     /* 1759756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1759776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759802 */     // MIs[0] policy
     /* 1759802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759812 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1759815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759836 */     // GIR_Coverage, 11482,
     /* 1759836 */     GIR_EraseRootFromParent_Done,
     /* 1759837 */   // Label 23959: @1759837
     /* 1759837 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1759923), // Rule ID 11483 //
     /* 1759842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1759853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1759856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1759859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1759862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759888 */     // MIs[0] policy
     /* 1759888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1759901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759922 */     // GIR_Coverage, 11483,
     /* 1759922 */     GIR_EraseRootFromParent_Done,
     /* 1759923 */   // Label 23960: @1759923
     /* 1759923 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1760009), // Rule ID 11486 //
     /* 1759928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1759948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759974 */     // MIs[0] policy
     /* 1759974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1759987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760008 */     // GIR_Coverage, 11486,
     /* 1760008 */     GIR_EraseRootFromParent_Done,
     /* 1760009 */   // Label 23961: @1760009
     /* 1760009 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1760095), // Rule ID 11487 //
     /* 1760014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1760025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1760028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1760031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1760034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1760037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760060 */     // MIs[0] policy
     /* 1760060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1760073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760094 */     // GIR_Coverage, 11487,
     /* 1760094 */     GIR_EraseRootFromParent_Done,
     /* 1760095 */   // Label 23962: @1760095
     /* 1760095 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1760181), // Rule ID 11490 //
     /* 1760100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1760111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1760114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1760117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760146 */     // MIs[0] policy
     /* 1760146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1760159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760180 */     // GIR_Coverage, 11490,
     /* 1760180 */     GIR_EraseRootFromParent_Done,
     /* 1760181 */   // Label 23963: @1760181
     /* 1760181 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1760267), // Rule ID 11491 //
     /* 1760186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1760197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1760200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1760203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760232 */     // MIs[0] policy
     /* 1760232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760242 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1760245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760266 */     // GIR_Coverage, 11491,
     /* 1760266 */     GIR_EraseRootFromParent_Done,
     /* 1760267 */   // Label 23964: @1760267
     /* 1760267 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1760353), // Rule ID 11494 //
     /* 1760272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1760283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1760286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1760289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760318 */     // MIs[0] policy
     /* 1760318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760328 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1760331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760352 */     // GIR_Coverage, 11494,
     /* 1760352 */     GIR_EraseRootFromParent_Done,
     /* 1760353 */   // Label 23965: @1760353
     /* 1760353 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1760439), // Rule ID 11495 //
     /* 1760358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1760369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1760372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1760375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760404 */     // MIs[0] policy
     /* 1760404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1760417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760438 */     // GIR_Coverage, 11495,
     /* 1760438 */     GIR_EraseRootFromParent_Done,
     /* 1760439 */   // Label 23966: @1760439
     /* 1760439 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1760525), // Rule ID 11498 //
     /* 1760444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760490 */     // MIs[0] policy
     /* 1760490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1760503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760524 */     // GIR_Coverage, 11498,
     /* 1760524 */     GIR_EraseRootFromParent_Done,
     /* 1760525 */   // Label 23967: @1760525
     /* 1760525 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1760611), // Rule ID 11499 //
     /* 1760530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1760541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1760544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1760547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760576 */     // MIs[0] policy
     /* 1760576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1760589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760610 */     // GIR_Coverage, 11499,
     /* 1760610 */     GIR_EraseRootFromParent_Done,
     /* 1760611 */   // Label 23968: @1760611
     /* 1760611 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1760697), // Rule ID 11502 //
     /* 1760616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760662 */     // MIs[0] policy
     /* 1760662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1760675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760696 */     // GIR_Coverage, 11502,
     /* 1760696 */     GIR_EraseRootFromParent_Done,
     /* 1760697 */   // Label 23969: @1760697
     /* 1760697 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1760783), // Rule ID 11503 //
     /* 1760702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1760713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1760716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1760719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760748 */     // MIs[0] policy
     /* 1760748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1760761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760782 */     // GIR_Coverage, 11503,
     /* 1760782 */     GIR_EraseRootFromParent_Done,
     /* 1760783 */   // Label 23970: @1760783
     /* 1760783 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1760869), // Rule ID 11506 //
     /* 1760788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760834 */     // MIs[0] policy
     /* 1760834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1760847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760868 */     // GIR_Coverage, 11506,
     /* 1760868 */     GIR_EraseRootFromParent_Done,
     /* 1760869 */   // Label 23971: @1760869
     /* 1760869 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1760955), // Rule ID 11507 //
     /* 1760874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760920 */     // MIs[0] policy
     /* 1760920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1760933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760954 */     // GIR_Coverage, 11507,
     /* 1760954 */     GIR_EraseRootFromParent_Done,
     /* 1760955 */   // Label 23972: @1760955
     /* 1760955 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1761041), // Rule ID 11510 //
     /* 1760960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761006 */     // MIs[0] policy
     /* 1761006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1761019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761040 */     // GIR_Coverage, 11510,
     /* 1761040 */     GIR_EraseRootFromParent_Done,
     /* 1761041 */   // Label 23973: @1761041
     /* 1761041 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1761127), // Rule ID 11511 //
     /* 1761046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1761057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1761060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1761063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761092 */     // MIs[0] policy
     /* 1761092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1761105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761126 */     // GIR_Coverage, 11511,
     /* 1761126 */     GIR_EraseRootFromParent_Done,
     /* 1761127 */   // Label 23974: @1761127
     /* 1761127 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1761213), // Rule ID 11514 //
     /* 1761132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1761143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1761146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1761149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761178 */     // MIs[0] policy
     /* 1761178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761212 */     // GIR_Coverage, 11514,
     /* 1761212 */     GIR_EraseRootFromParent_Done,
     /* 1761213 */   // Label 23975: @1761213
     /* 1761213 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1761299), // Rule ID 11515 //
     /* 1761218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1761229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1761232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1761235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761264 */     // MIs[0] policy
     /* 1761264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761298 */     // GIR_Coverage, 11515,
     /* 1761298 */     GIR_EraseRootFromParent_Done,
     /* 1761299 */   // Label 23976: @1761299
     /* 1761299 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1761385), // Rule ID 11518 //
     /* 1761304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761350 */     // MIs[0] policy
     /* 1761350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761384 */     // GIR_Coverage, 11518,
     /* 1761384 */     GIR_EraseRootFromParent_Done,
     /* 1761385 */   // Label 23977: @1761385
     /* 1761385 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1761471), // Rule ID 11519 //
     /* 1761390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1761401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1761404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1761407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761436 */     // MIs[0] policy
     /* 1761436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761470 */     // GIR_Coverage, 11519,
     /* 1761470 */     GIR_EraseRootFromParent_Done,
     /* 1761471 */   // Label 23978: @1761471
     /* 1761471 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1761557), // Rule ID 11522 //
     /* 1761476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761522 */     // MIs[0] policy
     /* 1761522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761556 */     // GIR_Coverage, 11522,
     /* 1761556 */     GIR_EraseRootFromParent_Done,
     /* 1761557 */   // Label 23979: @1761557
     /* 1761557 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1761643), // Rule ID 11523 //
     /* 1761562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1761573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1761576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1761579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761608 */     // MIs[0] policy
     /* 1761608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1761621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761642 */     // GIR_Coverage, 11523,
     /* 1761642 */     GIR_EraseRootFromParent_Done,
     /* 1761643 */   // Label 23980: @1761643
     /* 1761643 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1761729), // Rule ID 11526 //
     /* 1761648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761694 */     // MIs[0] policy
     /* 1761694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1761707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761728 */     // GIR_Coverage, 11526,
     /* 1761728 */     GIR_EraseRootFromParent_Done,
     /* 1761729 */   // Label 23981: @1761729
     /* 1761729 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1761815), // Rule ID 11527 //
     /* 1761734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1761745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1761748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1761751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761780 */     // MIs[0] policy
     /* 1761780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1761793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761814 */     // GIR_Coverage, 11527,
     /* 1761814 */     GIR_EraseRootFromParent_Done,
     /* 1761815 */   // Label 23982: @1761815
     /* 1761815 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1761901), // Rule ID 11530 //
     /* 1761820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761866 */     // MIs[0] policy
     /* 1761866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1761879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761900 */     // GIR_Coverage, 11530,
     /* 1761900 */     GIR_EraseRootFromParent_Done,
     /* 1761901 */   // Label 23983: @1761901
     /* 1761901 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1761987), // Rule ID 11531 //
     /* 1761906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761952 */     // MIs[0] policy
     /* 1761952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761962 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1761965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761986 */     // GIR_Coverage, 11531,
     /* 1761986 */     GIR_EraseRootFromParent_Done,
     /* 1761987 */   // Label 23984: @1761987
     /* 1761987 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1762073), // Rule ID 11534 //
     /* 1761992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1762003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1762006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1762009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1762015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762038 */     // MIs[0] policy
     /* 1762038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762072 */     // GIR_Coverage, 11534,
     /* 1762072 */     GIR_EraseRootFromParent_Done,
     /* 1762073 */   // Label 23985: @1762073
     /* 1762073 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1762159), // Rule ID 11535 //
     /* 1762078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1762089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1762092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1762095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1762101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762124 */     // MIs[0] policy
     /* 1762124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762158 */     // GIR_Coverage, 11535,
     /* 1762158 */     GIR_EraseRootFromParent_Done,
     /* 1762159 */   // Label 23986: @1762159
     /* 1762159 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1762245), // Rule ID 11538 //
     /* 1762164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1762175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1762178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1762181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762210 */     // MIs[0] policy
     /* 1762210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762244 */     // GIR_Coverage, 11538,
     /* 1762244 */     GIR_EraseRootFromParent_Done,
     /* 1762245 */   // Label 23987: @1762245
     /* 1762245 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1762331), // Rule ID 11539 //
     /* 1762250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1762261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1762264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1762267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762296 */     // MIs[0] policy
     /* 1762296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762330 */     // GIR_Coverage, 11539,
     /* 1762330 */     GIR_EraseRootFromParent_Done,
     /* 1762331 */   // Label 23988: @1762331
     /* 1762331 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1762417), // Rule ID 11542 //
     /* 1762336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762382 */     // MIs[0] policy
     /* 1762382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762416 */     // GIR_Coverage, 11542,
     /* 1762416 */     GIR_EraseRootFromParent_Done,
     /* 1762417 */   // Label 23989: @1762417
     /* 1762417 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1762503), // Rule ID 11543 //
     /* 1762422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1762433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1762436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1762439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762468 */     // MIs[0] policy
     /* 1762468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762502 */     // GIR_Coverage, 11543,
     /* 1762502 */     GIR_EraseRootFromParent_Done,
     /* 1762503 */   // Label 23990: @1762503
     /* 1762503 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1762589), // Rule ID 11546 //
     /* 1762508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762554 */     // MIs[0] policy
     /* 1762554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762588 */     // GIR_Coverage, 11546,
     /* 1762588 */     GIR_EraseRootFromParent_Done,
     /* 1762589 */   // Label 23991: @1762589
     /* 1762589 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1762675), // Rule ID 11547 //
     /* 1762594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1762605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1762608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1762611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1762617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762640 */     // MIs[0] policy
     /* 1762640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762674 */     // GIR_Coverage, 11547,
     /* 1762674 */     GIR_EraseRootFromParent_Done,
     /* 1762675 */   // Label 23992: @1762675
     /* 1762675 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1762761), // Rule ID 11550 //
     /* 1762680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762726 */     // MIs[0] policy
     /* 1762726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762760 */     // GIR_Coverage, 11550,
     /* 1762760 */     GIR_EraseRootFromParent_Done,
     /* 1762761 */   // Label 23993: @1762761
     /* 1762761 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1762847), // Rule ID 11551 //
     /* 1762766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1762777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1762780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1762783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762812 */     // MIs[0] policy
     /* 1762812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762846 */     // GIR_Coverage, 11551,
     /* 1762846 */     GIR_EraseRootFromParent_Done,
     /* 1762847 */   // Label 23994: @1762847
     /* 1762847 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1762933), // Rule ID 11554 //
     /* 1762852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762898 */     // MIs[0] policy
     /* 1762898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762932 */     // GIR_Coverage, 11554,
     /* 1762932 */     GIR_EraseRootFromParent_Done,
     /* 1762933 */   // Label 23995: @1762933
     /* 1762933 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1763019), // Rule ID 11555 //
     /* 1762938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762984 */     // MIs[0] policy
     /* 1762984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763018 */     // GIR_Coverage, 11555,
     /* 1763018 */     GIR_EraseRootFromParent_Done,
     /* 1763019 */   // Label 23996: @1763019
     /* 1763019 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1763105), // Rule ID 11558 //
     /* 1763024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1763035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1763038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1763041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1763054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763070 */     // MIs[0] policy
     /* 1763070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1763083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763104 */     // GIR_Coverage, 11558,
     /* 1763104 */     GIR_EraseRootFromParent_Done,
     /* 1763105 */   // Label 23997: @1763105
     /* 1763105 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1763191), // Rule ID 11559 //
     /* 1763110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1763121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1763124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1763127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1763140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763156 */     // MIs[0] policy
     /* 1763156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1763169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763190 */     // GIR_Coverage, 11559,
     /* 1763190 */     GIR_EraseRootFromParent_Done,
     /* 1763191 */   // Label 23998: @1763191
     /* 1763191 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1763277), // Rule ID 11562 //
     /* 1763196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1763199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1763207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1763210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1763213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1763216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763242 */     // MIs[0] policy
     /* 1763242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1763255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763276 */     // GIR_Coverage, 11562,
     /* 1763276 */     GIR_EraseRootFromParent_Done,
     /* 1763277 */   // Label 23999: @1763277
     /* 1763277 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1763363), // Rule ID 11563 //
     /* 1763282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1763285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1763293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1763296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1763299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1763302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763328 */     // MIs[0] policy
     /* 1763328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1763341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763362 */     // GIR_Coverage, 11563,
     /* 1763362 */     GIR_EraseRootFromParent_Done,
     /* 1763363 */   // Label 24000: @1763363
     /* 1763363 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1763449), // Rule ID 11566 //
     /* 1763368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1763371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1763379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1763382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1763385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1763388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1763398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763414 */     // MIs[0] policy
     /* 1763414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1763427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763448 */     // GIR_Coverage, 11566,
     /* 1763448 */     GIR_EraseRootFromParent_Done,
     /* 1763449 */   // Label 24001: @1763449
     /* 1763449 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1763535), // Rule ID 11567 //
     /* 1763454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1763457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1763465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1763468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1763471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1763474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1763484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763500 */     // MIs[0] policy
     /* 1763500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1763513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763534 */     // GIR_Coverage, 11567,
     /* 1763534 */     GIR_EraseRootFromParent_Done,
     /* 1763535 */   // Label 24002: @1763535
     /* 1763535 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1763621), // Rule ID 11570 //
     /* 1763540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1763543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1763551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1763554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1763557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1763560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1763570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763586 */     // MIs[0] policy
     /* 1763586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1763599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763620 */     // GIR_Coverage, 11570,
     /* 1763620 */     GIR_EraseRootFromParent_Done,
     /* 1763621 */   // Label 24003: @1763621
     /* 1763621 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1763707), // Rule ID 11571 //
     /* 1763626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1763629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1763637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1763640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1763643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1763646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1763656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1763668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763672 */     // MIs[0] policy
     /* 1763672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1763685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763706 */     // GIR_Coverage, 11571,
     /* 1763706 */     GIR_EraseRootFromParent_Done,
     /* 1763707 */   // Label 24004: @1763707
     /* 1763707 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1763793), // Rule ID 11574 //
     /* 1763712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1763715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1763723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1763726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1763729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1763732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1763742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763758 */     // MIs[0] policy
     /* 1763758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1763771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763792 */     // GIR_Coverage, 11574,
     /* 1763792 */     GIR_EraseRootFromParent_Done,
     /* 1763793 */   // Label 24005: @1763793
     /* 1763793 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1763879), // Rule ID 11575 //
     /* 1763798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1763801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1763809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1763812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1763815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1763818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1763828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1763840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763844 */     // MIs[0] policy
     /* 1763844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1763857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763878 */     // GIR_Coverage, 11575,
     /* 1763878 */     GIR_EraseRootFromParent_Done,
     /* 1763879 */   // Label 24006: @1763879
     /* 1763879 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1763965), // Rule ID 11578 //
     /* 1763884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1763887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1763895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1763898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1763901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763930 */     // MIs[0] policy
     /* 1763930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1763943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1763961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763964 */     // GIR_Coverage, 11578,
     /* 1763964 */     GIR_EraseRootFromParent_Done,
     /* 1763965 */   // Label 24007: @1763965
     /* 1763965 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1764051), // Rule ID 11579 //
     /* 1763970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1763973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1763978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1763981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1763984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1763987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764016 */     // MIs[0] policy
     /* 1764016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1764029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764050 */     // GIR_Coverage, 11579,
     /* 1764050 */     GIR_EraseRootFromParent_Done,
     /* 1764051 */   // Label 24008: @1764051
     /* 1764051 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1764137), // Rule ID 11582 //
     /* 1764056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1764067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1764070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1764073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764102 */     // MIs[0] policy
     /* 1764102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1764115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764136 */     // GIR_Coverage, 11582,
     /* 1764136 */     GIR_EraseRootFromParent_Done,
     /* 1764137 */   // Label 24009: @1764137
     /* 1764137 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1764223), // Rule ID 11583 //
     /* 1764142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1764145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1764153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1764156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1764159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764188 */     // MIs[0] policy
     /* 1764188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1764201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764222 */     // GIR_Coverage, 11583,
     /* 1764222 */     GIR_EraseRootFromParent_Done,
     /* 1764223 */   // Label 24010: @1764223
     /* 1764223 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1764309), // Rule ID 11586 //
     /* 1764228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1764239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1764242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1764245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764274 */     // MIs[0] policy
     /* 1764274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1764287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764308 */     // GIR_Coverage, 11586,
     /* 1764308 */     GIR_EraseRootFromParent_Done,
     /* 1764309 */   // Label 24011: @1764309
     /* 1764309 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1764395), // Rule ID 11587 //
     /* 1764314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1764317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1764325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1764328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1764331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764360 */     // MIs[0] policy
     /* 1764360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1764373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764394 */     // GIR_Coverage, 11587,
     /* 1764394 */     GIR_EraseRootFromParent_Done,
     /* 1764395 */   // Label 24012: @1764395
     /* 1764395 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1764481), // Rule ID 11590 //
     /* 1764400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1764411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1764414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1764417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764446 */     // MIs[0] policy
     /* 1764446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1764459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764480 */     // GIR_Coverage, 11590,
     /* 1764480 */     GIR_EraseRootFromParent_Done,
     /* 1764481 */   // Label 24013: @1764481
     /* 1764481 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1764567), // Rule ID 11591 //
     /* 1764486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1764489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1764494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1764497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1764500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1764503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764532 */     // MIs[0] policy
     /* 1764532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1764545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764566 */     // GIR_Coverage, 11591,
     /* 1764566 */     GIR_EraseRootFromParent_Done,
     /* 1764567 */   // Label 24014: @1764567
     /* 1764567 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1764653), // Rule ID 11594 //
     /* 1764572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1764580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764618 */     // MIs[0] policy
     /* 1764618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1764631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764652 */     // GIR_Coverage, 11594,
     /* 1764652 */     GIR_EraseRootFromParent_Done,
     /* 1764653 */   // Label 24015: @1764653
     /* 1764653 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1764739), // Rule ID 11595 //
     /* 1764658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1764661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1764666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764704 */     // MIs[0] policy
     /* 1764704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1764717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764738 */     // GIR_Coverage, 11595,
     /* 1764738 */     GIR_EraseRootFromParent_Done,
     /* 1764739 */   // Label 24016: @1764739
     /* 1764739 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1764825), // Rule ID 11598 //
     /* 1764744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1764752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1764755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1764758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1764761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1764764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764790 */     // MIs[0] policy
     /* 1764790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1764803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764824 */     // GIR_Coverage, 11598,
     /* 1764824 */     GIR_EraseRootFromParent_Done,
     /* 1764825 */   // Label 24017: @1764825
     /* 1764825 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1764911), // Rule ID 11599 //
     /* 1764830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1764833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1764838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1764841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1764844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1764847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1764850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764876 */     // MIs[0] policy
     /* 1764876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1764889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764910 */     // GIR_Coverage, 11599,
     /* 1764910 */     GIR_EraseRootFromParent_Done,
     /* 1764911 */   // Label 24018: @1764911
     /* 1764911 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1764997), // Rule ID 11602 //
     /* 1764916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1764919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1764924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1764927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1764930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1764933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1764936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764962 */     // MIs[0] policy
     /* 1764962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1764975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764996 */     // GIR_Coverage, 11602,
     /* 1764996 */     GIR_EraseRootFromParent_Done,
     /* 1764997 */   // Label 24019: @1764997
     /* 1764997 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1765083), // Rule ID 11603 //
     /* 1765002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1765022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765048 */     // MIs[0] policy
     /* 1765048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765058 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1765061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765082 */     // GIR_Coverage, 11603,
     /* 1765082 */     GIR_EraseRootFromParent_Done,
     /* 1765083 */   // Label 24020: @1765083
     /* 1765083 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1765169), // Rule ID 11606 //
     /* 1765088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1765108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765134 */     // MIs[0] policy
     /* 1765134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765144 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1765147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765168 */     // GIR_Coverage, 11606,
     /* 1765168 */     GIR_EraseRootFromParent_Done,
     /* 1765169 */   // Label 24021: @1765169
     /* 1765169 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1765255), // Rule ID 11607 //
     /* 1765174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1765194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765220 */     // MIs[0] policy
     /* 1765220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1765233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765254 */     // GIR_Coverage, 11607,
     /* 1765254 */     GIR_EraseRootFromParent_Done,
     /* 1765255 */   // Label 24022: @1765255
     /* 1765255 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1765341), // Rule ID 11610 //
     /* 1765260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765306 */     // MIs[0] policy
     /* 1765306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1765319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765340 */     // GIR_Coverage, 11610,
     /* 1765340 */     GIR_EraseRootFromParent_Done,
     /* 1765341 */   // Label 24023: @1765341
     /* 1765341 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1765427), // Rule ID 11611 //
     /* 1765346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765392 */     // MIs[0] policy
     /* 1765392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1765405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765426 */     // GIR_Coverage, 11611,
     /* 1765426 */     GIR_EraseRootFromParent_Done,
     /* 1765427 */   // Label 24024: @1765427
     /* 1765427 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1765513), // Rule ID 11614 //
     /* 1765432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765478 */     // MIs[0] policy
     /* 1765478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1765491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765512 */     // GIR_Coverage, 11614,
     /* 1765512 */     GIR_EraseRootFromParent_Done,
     /* 1765513 */   // Label 24025: @1765513
     /* 1765513 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1765599), // Rule ID 11615 //
     /* 1765518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765564 */     // MIs[0] policy
     /* 1765564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1765577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765598 */     // GIR_Coverage, 11615,
     /* 1765598 */     GIR_EraseRootFromParent_Done,
     /* 1765599 */   // Label 24026: @1765599
     /* 1765599 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1765685), // Rule ID 11618 //
     /* 1765604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765650 */     // MIs[0] policy
     /* 1765650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765660 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1765663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765684 */     // GIR_Coverage, 11618,
     /* 1765684 */     GIR_EraseRootFromParent_Done,
     /* 1765685 */   // Label 24027: @1765685
     /* 1765685 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1765771), // Rule ID 11619 //
     /* 1765690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765736 */     // MIs[0] policy
     /* 1765736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765746 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1765749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765770 */     // GIR_Coverage, 11619,
     /* 1765770 */     GIR_EraseRootFromParent_Done,
     /* 1765771 */   // Label 24028: @1765771
     /* 1765771 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1765857), // Rule ID 11622 //
     /* 1765776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765822 */     // MIs[0] policy
     /* 1765822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765832 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1765835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765856 */     // GIR_Coverage, 11622,
     /* 1765856 */     GIR_EraseRootFromParent_Done,
     /* 1765857 */   // Label 24029: @1765857
     /* 1765857 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1765943), // Rule ID 11623 //
     /* 1765862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1765870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765908 */     // MIs[0] policy
     /* 1765908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765918 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1765921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765942 */     // GIR_Coverage, 11623,
     /* 1765942 */     GIR_EraseRootFromParent_Done,
     /* 1765943 */   // Label 24030: @1765943
     /* 1765943 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1766029), // Rule ID 11626 //
     /* 1765948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765994 */     // MIs[0] policy
     /* 1765994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1766007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766028 */     // GIR_Coverage, 11626,
     /* 1766028 */     GIR_EraseRootFromParent_Done,
     /* 1766029 */   // Label 24031: @1766029
     /* 1766029 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1766115), // Rule ID 11627 //
     /* 1766034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766080 */     // MIs[0] policy
     /* 1766080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1766093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766114 */     // GIR_Coverage, 11627,
     /* 1766114 */     GIR_EraseRootFromParent_Done,
     /* 1766115 */   // Label 24032: @1766115
     /* 1766115 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1766201), // Rule ID 11630 //
     /* 1766120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766166 */     // MIs[0] policy
     /* 1766166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1766179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766200 */     // GIR_Coverage, 11630,
     /* 1766200 */     GIR_EraseRootFromParent_Done,
     /* 1766201 */   // Label 24033: @1766201
     /* 1766201 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1766287), // Rule ID 11631 //
     /* 1766206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766252 */     // MIs[0] policy
     /* 1766252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1766265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766286 */     // GIR_Coverage, 11631,
     /* 1766286 */     GIR_EraseRootFromParent_Done,
     /* 1766287 */   // Label 24034: @1766287
     /* 1766287 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1766373), // Rule ID 11634 //
     /* 1766292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766338 */     // MIs[0] policy
     /* 1766338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1766351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766372 */     // GIR_Coverage, 11634,
     /* 1766372 */     GIR_EraseRootFromParent_Done,
     /* 1766373 */   // Label 24035: @1766373
     /* 1766373 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1766459), // Rule ID 11635 //
     /* 1766378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766424 */     // MIs[0] policy
     /* 1766424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766434 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1766437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766458 */     // GIR_Coverage, 11635,
     /* 1766458 */     GIR_EraseRootFromParent_Done,
     /* 1766459 */   // Label 24036: @1766459
     /* 1766459 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1766545), // Rule ID 11638 //
     /* 1766464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766510 */     // MIs[0] policy
     /* 1766510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1766523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766544 */     // GIR_Coverage, 11638,
     /* 1766544 */     GIR_EraseRootFromParent_Done,
     /* 1766545 */   // Label 24037: @1766545
     /* 1766545 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1766631), // Rule ID 11639 //
     /* 1766550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766596 */     // MIs[0] policy
     /* 1766596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766606 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1766609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766630 */     // GIR_Coverage, 11639,
     /* 1766630 */     GIR_EraseRootFromParent_Done,
     /* 1766631 */   // Label 24038: @1766631
     /* 1766631 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1766717), // Rule ID 11642 //
     /* 1766636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766682 */     // MIs[0] policy
     /* 1766682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1766695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766716 */     // GIR_Coverage, 11642,
     /* 1766716 */     GIR_EraseRootFromParent_Done,
     /* 1766717 */   // Label 24039: @1766717
     /* 1766717 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1766803), // Rule ID 11643 //
     /* 1766722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766768 */     // MIs[0] policy
     /* 1766768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1766781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766802 */     // GIR_Coverage, 11643,
     /* 1766802 */     GIR_EraseRootFromParent_Done,
     /* 1766803 */   // Label 24040: @1766803
     /* 1766803 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1766889), // Rule ID 11646 //
     /* 1766808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766854 */     // MIs[0] policy
     /* 1766854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1766867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766888 */     // GIR_Coverage, 11646,
     /* 1766888 */     GIR_EraseRootFromParent_Done,
     /* 1766889 */   // Label 24041: @1766889
     /* 1766889 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1766975), // Rule ID 11647 //
     /* 1766894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766940 */     // MIs[0] policy
     /* 1766940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11413:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1766953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766974 */     // GIR_Coverage, 11647,
     /* 1766974 */     GIR_EraseRootFromParent_Done,
     /* 1766975 */   // Label 24042: @1766975
     /* 1766975 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1767061), // Rule ID 11650 //
     /* 1766980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1766988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767026 */     // MIs[0] policy
     /* 1767026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1767039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767060 */     // GIR_Coverage, 11650,
     /* 1767060 */     GIR_EraseRootFromParent_Done,
     /* 1767061 */   // Label 24043: @1767061
     /* 1767061 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1767147), // Rule ID 11651 //
     /* 1767066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767112 */     // MIs[0] policy
     /* 1767112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11413:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1767125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767146 */     // GIR_Coverage, 11651,
     /* 1767146 */     GIR_EraseRootFromParent_Done,
     /* 1767147 */   // Label 24044: @1767147
     /* 1767147 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1767233), // Rule ID 11654 //
     /* 1767152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767198 */     // MIs[0] policy
     /* 1767198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1767211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767232 */     // GIR_Coverage, 11654,
     /* 1767232 */     GIR_EraseRootFromParent_Done,
     /* 1767233 */   // Label 24045: @1767233
     /* 1767233 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1767319), // Rule ID 11655 //
     /* 1767238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1767246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767284 */     // MIs[0] policy
     /* 1767284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11413:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1767297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767318 */     // GIR_Coverage, 11655,
     /* 1767318 */     GIR_EraseRootFromParent_Done,
     /* 1767319 */   // Label 24046: @1767319
     /* 1767319 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1767405), // Rule ID 11658 //
     /* 1767324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1767335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1767338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1767341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1767344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767370 */     // MIs[0] policy
     /* 1767370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1767383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767404 */     // GIR_Coverage, 11658,
     /* 1767404 */     GIR_EraseRootFromParent_Done,
     /* 1767405 */   // Label 24047: @1767405
     /* 1767405 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1767491), // Rule ID 11659 //
     /* 1767410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1767421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1767424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1767427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1767430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767456 */     // MIs[0] policy
     /* 1767456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1767469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767490 */     // GIR_Coverage, 11659,
     /* 1767490 */     GIR_EraseRootFromParent_Done,
     /* 1767491 */   // Label 24048: @1767491
     /* 1767491 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1767577), // Rule ID 11662 //
     /* 1767496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1767507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1767510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1767513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1767516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767542 */     // MIs[0] policy
     /* 1767542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1767555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767576 */     // GIR_Coverage, 11662,
     /* 1767576 */     GIR_EraseRootFromParent_Done,
     /* 1767577 */   // Label 24049: @1767577
     /* 1767577 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1767663), // Rule ID 11663 //
     /* 1767582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1767593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1767596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1767599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1767602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767628 */     // MIs[0] policy
     /* 1767628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767638 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1767641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767662 */     // GIR_Coverage, 11663,
     /* 1767662 */     GIR_EraseRootFromParent_Done,
     /* 1767663 */   // Label 24050: @1767663
     /* 1767663 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1767749), // Rule ID 11666 //
     /* 1767668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1767688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767714 */     // MIs[0] policy
     /* 1767714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1767727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767748 */     // GIR_Coverage, 11666,
     /* 1767748 */     GIR_EraseRootFromParent_Done,
     /* 1767749 */   // Label 24051: @1767749
     /* 1767749 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1767835), // Rule ID 11667 //
     /* 1767754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1767774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767800 */     // MIs[0] policy
     /* 1767800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1767813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767834 */     // GIR_Coverage, 11667,
     /* 1767834 */     GIR_EraseRootFromParent_Done,
     /* 1767835 */   // Label 24052: @1767835
     /* 1767835 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1767921), // Rule ID 11670 //
     /* 1767840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1767860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767886 */     // MIs[0] policy
     /* 1767886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1767899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767920 */     // GIR_Coverage, 11670,
     /* 1767920 */     GIR_EraseRootFromParent_Done,
     /* 1767921 */   // Label 24053: @1767921
     /* 1767921 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1768007), // Rule ID 11671 //
     /* 1767926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1767946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767972 */     // MIs[0] policy
     /* 1767972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1767985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768006 */     // GIR_Coverage, 11671,
     /* 1768006 */     GIR_EraseRootFromParent_Done,
     /* 1768007 */   // Label 24054: @1768007
     /* 1768007 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1768093), // Rule ID 11674 //
     /* 1768012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1768023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1768026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1768029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1768032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768058 */     // MIs[0] policy
     /* 1768058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1768071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768092 */     // GIR_Coverage, 11674,
     /* 1768092 */     GIR_EraseRootFromParent_Done,
     /* 1768093 */   // Label 24055: @1768093
     /* 1768093 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1768179), // Rule ID 11675 //
     /* 1768098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1768109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1768112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1768115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1768118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768144 */     // MIs[0] policy
     /* 1768144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1768157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768178 */     // GIR_Coverage, 11675,
     /* 1768178 */     GIR_EraseRootFromParent_Done,
     /* 1768179 */   // Label 24056: @1768179
     /* 1768179 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1768265), // Rule ID 11678 //
     /* 1768184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1768195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1768198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1768201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1768204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768230 */     // MIs[0] policy
     /* 1768230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1768243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768264 */     // GIR_Coverage, 11678,
     /* 1768264 */     GIR_EraseRootFromParent_Done,
     /* 1768265 */   // Label 24057: @1768265
     /* 1768265 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1768351), // Rule ID 11679 //
     /* 1768270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1768281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1768284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1768287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1768290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768316 */     // MIs[0] policy
     /* 1768316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1768329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768350 */     // GIR_Coverage, 11679,
     /* 1768350 */     GIR_EraseRootFromParent_Done,
     /* 1768351 */   // Label 24058: @1768351
     /* 1768351 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1768437), // Rule ID 11682 //
     /* 1768356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1768367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1768370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1768373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1768376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768402 */     // MIs[0] policy
     /* 1768402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1768415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768436 */     // GIR_Coverage, 11682,
     /* 1768436 */     GIR_EraseRootFromParent_Done,
     /* 1768437 */   // Label 24059: @1768437
     /* 1768437 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1768523), // Rule ID 11683 //
     /* 1768442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1768453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1768456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1768459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1768462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768488 */     // MIs[0] policy
     /* 1768488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1768501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768522 */     // GIR_Coverage, 11683,
     /* 1768522 */     GIR_EraseRootFromParent_Done,
     /* 1768523 */   // Label 24060: @1768523
     /* 1768523 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1768609), // Rule ID 11686 //
     /* 1768528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1768539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1768542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1768545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1768548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768574 */     // MIs[0] policy
     /* 1768574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1768587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768608 */     // GIR_Coverage, 11686,
     /* 1768608 */     GIR_EraseRootFromParent_Done,
     /* 1768609 */   // Label 24061: @1768609
     /* 1768609 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1768695), // Rule ID 11687 //
     /* 1768614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1768625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1768628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1768631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1768634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768660 */     // MIs[0] policy
     /* 1768660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1768673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768694 */     // GIR_Coverage, 11687,
     /* 1768694 */     GIR_EraseRootFromParent_Done,
     /* 1768695 */   // Label 24062: @1768695
     /* 1768695 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1768781), // Rule ID 11690 //
     /* 1768700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1768720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768746 */     // MIs[0] policy
     /* 1768746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1768759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768780 */     // GIR_Coverage, 11690,
     /* 1768780 */     GIR_EraseRootFromParent_Done,
     /* 1768781 */   // Label 24063: @1768781
     /* 1768781 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1768867), // Rule ID 11691 //
     /* 1768786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1768806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768832 */     // MIs[0] policy
     /* 1768832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1768845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768866 */     // GIR_Coverage, 11691,
     /* 1768866 */     GIR_EraseRootFromParent_Done,
     /* 1768867 */   // Label 24064: @1768867
     /* 1768867 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1768953), // Rule ID 11694 //
     /* 1768872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1768875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768918 */     // MIs[0] policy
     /* 1768918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1768931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768952 */     // GIR_Coverage, 11694,
     /* 1768952 */     GIR_EraseRootFromParent_Done,
     /* 1768953 */   // Label 24065: @1768953
     /* 1768953 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1769039), // Rule ID 11695 //
     /* 1768958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1768961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769004 */     // MIs[0] policy
     /* 1769004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1769017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769038 */     // GIR_Coverage, 11695,
     /* 1769038 */     GIR_EraseRootFromParent_Done,
     /* 1769039 */   // Label 24066: @1769039
     /* 1769039 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1769125), // Rule ID 11698 //
     /* 1769044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1769055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1769058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1769061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1769064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769090 */     // MIs[0] policy
     /* 1769090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1769103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769124 */     // GIR_Coverage, 11698,
     /* 1769124 */     GIR_EraseRootFromParent_Done,
     /* 1769125 */   // Label 24067: @1769125
     /* 1769125 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1769211), // Rule ID 11699 //
     /* 1769130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1769141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1769144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1769147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1769150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769176 */     // MIs[0] policy
     /* 1769176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1769189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769210 */     // GIR_Coverage, 11699,
     /* 1769210 */     GIR_EraseRootFromParent_Done,
     /* 1769211 */   // Label 24068: @1769211
     /* 1769211 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1769297), // Rule ID 11702 //
     /* 1769216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1769227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1769230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1769233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1769236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769262 */     // MIs[0] policy
     /* 1769262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1769275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769296 */     // GIR_Coverage, 11702,
     /* 1769296 */     GIR_EraseRootFromParent_Done,
     /* 1769297 */   // Label 24069: @1769297
     /* 1769297 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1769383), // Rule ID 11703 //
     /* 1769302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1769313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1769316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1769319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1769322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769348 */     // MIs[0] policy
     /* 1769348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1769361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769382 */     // GIR_Coverage, 11703,
     /* 1769382 */     GIR_EraseRootFromParent_Done,
     /* 1769383 */   // Label 24070: @1769383
     /* 1769383 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1769469), // Rule ID 11706 //
     /* 1769388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1769399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1769402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1769405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1769408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1769411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769434 */     // MIs[0] policy
     /* 1769434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1769447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769468 */     // GIR_Coverage, 11706,
     /* 1769468 */     GIR_EraseRootFromParent_Done,
     /* 1769469 */   // Label 24071: @1769469
     /* 1769469 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1769555), // Rule ID 11707 //
     /* 1769474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1769485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1769488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1769491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1769494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1769497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769520 */     // MIs[0] policy
     /* 1769520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1769533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769554 */     // GIR_Coverage, 11707,
     /* 1769554 */     GIR_EraseRootFromParent_Done,
     /* 1769555 */   // Label 24072: @1769555
     /* 1769555 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1769641), // Rule ID 11710 //
     /* 1769560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1769580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769606 */     // MIs[0] policy
     /* 1769606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1769619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769640 */     // GIR_Coverage, 11710,
     /* 1769640 */     GIR_EraseRootFromParent_Done,
     /* 1769641 */   // Label 24073: @1769641
     /* 1769641 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1769727), // Rule ID 11711 //
     /* 1769646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1769666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769692 */     // MIs[0] policy
     /* 1769692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1769705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769726 */     // GIR_Coverage, 11711,
     /* 1769726 */     GIR_EraseRootFromParent_Done,
     /* 1769727 */   // Label 24074: @1769727
     /* 1769727 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1769813), // Rule ID 11714 //
     /* 1769732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1769752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769778 */     // MIs[0] policy
     /* 1769778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1769791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769812 */     // GIR_Coverage, 11714,
     /* 1769812 */     GIR_EraseRootFromParent_Done,
     /* 1769813 */   // Label 24075: @1769813
     /* 1769813 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1769899), // Rule ID 11715 //
     /* 1769818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1769838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769864 */     // MIs[0] policy
     /* 1769864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1769877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769898 */     // GIR_Coverage, 11715,
     /* 1769898 */     GIR_EraseRootFromParent_Done,
     /* 1769899 */   // Label 24076: @1769899
     /* 1769899 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1769985), // Rule ID 11718 //
     /* 1769904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1769915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1769918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1769921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1769924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769950 */     // MIs[0] policy
     /* 1769950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1769963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769984 */     // GIR_Coverage, 11718,
     /* 1769984 */     GIR_EraseRootFromParent_Done,
     /* 1769985 */   // Label 24077: @1769985
     /* 1769985 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1770071), // Rule ID 11719 //
     /* 1769990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1770001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1770004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1770007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1770010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1770013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770036 */     // MIs[0] policy
     /* 1770036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1770049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770070 */     // GIR_Coverage, 11719,
     /* 1770070 */     GIR_EraseRootFromParent_Done,
     /* 1770071 */   // Label 24078: @1770071
     /* 1770071 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1770157), // Rule ID 11722 //
     /* 1770076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1770087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1770090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1770093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1770096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770122 */     // MIs[0] policy
     /* 1770122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1770135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770156 */     // GIR_Coverage, 11722,
     /* 1770156 */     GIR_EraseRootFromParent_Done,
     /* 1770157 */   // Label 24079: @1770157
     /* 1770157 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1770243), // Rule ID 11723 //
     /* 1770162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1770173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1770176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1770179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1770182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770208 */     // MIs[0] policy
     /* 1770208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1770221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770242 */     // GIR_Coverage, 11723,
     /* 1770242 */     GIR_EraseRootFromParent_Done,
     /* 1770243 */   // Label 24080: @1770243
     /* 1770243 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1770329), // Rule ID 11726 //
     /* 1770248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1770259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1770262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1770265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1770268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770294 */     // MIs[0] policy
     /* 1770294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1770307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770328 */     // GIR_Coverage, 11726,
     /* 1770328 */     GIR_EraseRootFromParent_Done,
     /* 1770329 */   // Label 24081: @1770329
     /* 1770329 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1770415), // Rule ID 11727 //
     /* 1770334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1770345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1770348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1770351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1770354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770380 */     // MIs[0] policy
     /* 1770380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1770393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770414 */     // GIR_Coverage, 11727,
     /* 1770414 */     GIR_EraseRootFromParent_Done,
     /* 1770415 */   // Label 24082: @1770415
     /* 1770415 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1770501), // Rule ID 11730 //
     /* 1770420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1770431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1770434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1770437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1770440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1770443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770466 */     // MIs[0] policy
     /* 1770466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1770479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770500 */     // GIR_Coverage, 11730,
     /* 1770500 */     GIR_EraseRootFromParent_Done,
     /* 1770501 */   // Label 24083: @1770501
     /* 1770501 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1770587), // Rule ID 11731 //
     /* 1770506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1770517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1770520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1770523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1770526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1770529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770552 */     // MIs[0] policy
     /* 1770552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1770565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770586 */     // GIR_Coverage, 11731,
     /* 1770586 */     GIR_EraseRootFromParent_Done,
     /* 1770587 */   // Label 24084: @1770587
     /* 1770587 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1770673), // Rule ID 11734 //
     /* 1770592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1770612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770638 */     // MIs[0] policy
     /* 1770638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1770651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770672 */     // GIR_Coverage, 11734,
     /* 1770672 */     GIR_EraseRootFromParent_Done,
     /* 1770673 */   // Label 24085: @1770673
     /* 1770673 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1770759), // Rule ID 11735 //
     /* 1770678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1770698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770724 */     // MIs[0] policy
     /* 1770724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1770737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770758 */     // GIR_Coverage, 11735,
     /* 1770758 */     GIR_EraseRootFromParent_Done,
     /* 1770759 */   // Label 24086: @1770759
     /* 1770759 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1770845), // Rule ID 11738 //
     /* 1770764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1770784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770810 */     // MIs[0] policy
     /* 1770810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1770823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770844 */     // GIR_Coverage, 11738,
     /* 1770844 */     GIR_EraseRootFromParent_Done,
     /* 1770845 */   // Label 24087: @1770845
     /* 1770845 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1770931), // Rule ID 11739 //
     /* 1770850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1770870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770896 */     // MIs[0] policy
     /* 1770896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1770909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770930 */     // GIR_Coverage, 11739,
     /* 1770930 */     GIR_EraseRootFromParent_Done,
     /* 1770931 */   // Label 24088: @1770931
     /* 1770931 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1771017), // Rule ID 11742 //
     /* 1770936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1770956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770982 */     // MIs[0] policy
     /* 1770982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1770995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771016 */     // GIR_Coverage, 11742,
     /* 1771016 */     GIR_EraseRootFromParent_Done,
     /* 1771017 */   // Label 24089: @1771017
     /* 1771017 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1771103), // Rule ID 11743 //
     /* 1771022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1771025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1771033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1771036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1771039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1771042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771068 */     // MIs[0] policy
     /* 1771068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1771081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771102 */     // GIR_Coverage, 11743,
     /* 1771102 */     GIR_EraseRootFromParent_Done,
     /* 1771103 */   // Label 24090: @1771103
     /* 1771103 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1771189), // Rule ID 11746 //
     /* 1771108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1771119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1771122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1771125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771154 */     // MIs[0] policy
     /* 1771154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1771167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771188 */     // GIR_Coverage, 11746,
     /* 1771188 */     GIR_EraseRootFromParent_Done,
     /* 1771189 */   // Label 24091: @1771189
     /* 1771189 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1771275), // Rule ID 11747 //
     /* 1771194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1771205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1771208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1771211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771240 */     // MIs[0] policy
     /* 1771240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1771253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771274 */     // GIR_Coverage, 11747,
     /* 1771274 */     GIR_EraseRootFromParent_Done,
     /* 1771275 */   // Label 24092: @1771275
     /* 1771275 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1771361), // Rule ID 11750 //
     /* 1771280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1771291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1771294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1771297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771326 */     // MIs[0] policy
     /* 1771326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1771339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771360 */     // GIR_Coverage, 11750,
     /* 1771360 */     GIR_EraseRootFromParent_Done,
     /* 1771361 */   // Label 24093: @1771361
     /* 1771361 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1771447), // Rule ID 11751 //
     /* 1771366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1771377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1771380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1771383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771412 */     // MIs[0] policy
     /* 1771412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771422 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1771425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771446 */     // GIR_Coverage, 11751,
     /* 1771446 */     GIR_EraseRootFromParent_Done,
     /* 1771447 */   // Label 24094: @1771447
     /* 1771447 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1771533), // Rule ID 11754 //
     /* 1771452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1771463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1771466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1771469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771498 */     // MIs[0] policy
     /* 1771498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1771511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771532 */     // GIR_Coverage, 11754,
     /* 1771532 */     GIR_EraseRootFromParent_Done,
     /* 1771533 */   // Label 24095: @1771533
     /* 1771533 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1771619), // Rule ID 11755 //
     /* 1771538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1771549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1771552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1771555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771584 */     // MIs[0] policy
     /* 1771584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771594 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1771597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771618 */     // GIR_Coverage, 11755,
     /* 1771618 */     GIR_EraseRootFromParent_Done,
     /* 1771619 */   // Label 24096: @1771619
     /* 1771619 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1771705), // Rule ID 11758 //
     /* 1771624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771670 */     // MIs[0] policy
     /* 1771670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1771683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771704 */     // GIR_Coverage, 11758,
     /* 1771704 */     GIR_EraseRootFromParent_Done,
     /* 1771705 */   // Label 24097: @1771705
     /* 1771705 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1771791), // Rule ID 11759 //
     /* 1771710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771756 */     // MIs[0] policy
     /* 1771756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1771769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771790 */     // GIR_Coverage, 11759,
     /* 1771790 */     GIR_EraseRootFromParent_Done,
     /* 1771791 */   // Label 24098: @1771791
     /* 1771791 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1771877), // Rule ID 11762 //
     /* 1771796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771842 */     // MIs[0] policy
     /* 1771842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1771855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771876 */     // GIR_Coverage, 11762,
     /* 1771876 */     GIR_EraseRootFromParent_Done,
     /* 1771877 */   // Label 24099: @1771877
     /* 1771877 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1771963), // Rule ID 11763 //
     /* 1771882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1771902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1771924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771928 */     // MIs[0] policy
     /* 1771928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1771941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771962 */     // GIR_Coverage, 11763,
     /* 1771962 */     GIR_EraseRootFromParent_Done,
     /* 1771963 */   // Label 24100: @1771963
     /* 1771963 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1772049), // Rule ID 11766 //
     /* 1771968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1771979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1771982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1771985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1771988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772014 */     // MIs[0] policy
     /* 1772014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1772027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772048 */     // GIR_Coverage, 11766,
     /* 1772048 */     GIR_EraseRootFromParent_Done,
     /* 1772049 */   // Label 24101: @1772049
     /* 1772049 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1772135), // Rule ID 11767 //
     /* 1772054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1772065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1772068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1772071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772100 */     // MIs[0] policy
     /* 1772100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1772113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772134 */     // GIR_Coverage, 11767,
     /* 1772134 */     GIR_EraseRootFromParent_Done,
     /* 1772135 */   // Label 24102: @1772135
     /* 1772135 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1772221), // Rule ID 11770 //
     /* 1772140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1772151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1772154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1772157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772186 */     // MIs[0] policy
     /* 1772186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1772199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772220 */     // GIR_Coverage, 11770,
     /* 1772220 */     GIR_EraseRootFromParent_Done,
     /* 1772221 */   // Label 24103: @1772221
     /* 1772221 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1772307), // Rule ID 11771 //
     /* 1772226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1772237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1772240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1772243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772272 */     // MIs[0] policy
     /* 1772272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11123:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1772285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772306 */     // GIR_Coverage, 11771,
     /* 1772306 */     GIR_EraseRootFromParent_Done,
     /* 1772307 */   // Label 24104: @1772307
     /* 1772307 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1772393), // Rule ID 11774 //
     /* 1772312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1772323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1772326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1772329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772358 */     // MIs[0] policy
     /* 1772358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1772371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772392 */     // GIR_Coverage, 11774,
     /* 1772392 */     GIR_EraseRootFromParent_Done,
     /* 1772393 */   // Label 24105: @1772393
     /* 1772393 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1772479), // Rule ID 11775 //
     /* 1772398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1772409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1772412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1772415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772444 */     // MIs[0] policy
     /* 1772444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1772457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772478 */     // GIR_Coverage, 11775,
     /* 1772478 */     GIR_EraseRootFromParent_Done,
     /* 1772479 */   // Label 24106: @1772479
     /* 1772479 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1772565), // Rule ID 11778 //
     /* 1772484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1772495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1772498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1772501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772530 */     // MIs[0] policy
     /* 1772530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1772543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772564 */     // GIR_Coverage, 11778,
     /* 1772564 */     GIR_EraseRootFromParent_Done,
     /* 1772565 */   // Label 24107: @1772565
     /* 1772565 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1772651), // Rule ID 11779 //
     /* 1772570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1772581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1772584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1772587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772616 */     // MIs[0] policy
     /* 1772616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1772629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772650 */     // GIR_Coverage, 11779,
     /* 1772650 */     GIR_EraseRootFromParent_Done,
     /* 1772651 */   // Label 24108: @1772651
     /* 1772651 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1772737), // Rule ID 11782 //
     /* 1772656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1772659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772702 */     // MIs[0] policy
     /* 1772702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1772715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772736 */     // GIR_Coverage, 11782,
     /* 1772736 */     GIR_EraseRootFromParent_Done,
     /* 1772737 */   // Label 24109: @1772737
     /* 1772737 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1772823), // Rule ID 11783 //
     /* 1772742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1772745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772788 */     // MIs[0] policy
     /* 1772788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1772801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772822 */     // GIR_Coverage, 11783,
     /* 1772822 */     GIR_EraseRootFromParent_Done,
     /* 1772823 */   // Label 24110: @1772823
     /* 1772823 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1772909), // Rule ID 11786 //
     /* 1772828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1772848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772874 */     // MIs[0] policy
     /* 1772874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1772887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772908 */     // GIR_Coverage, 11786,
     /* 1772908 */     GIR_EraseRootFromParent_Done,
     /* 1772909 */   // Label 24111: @1772909
     /* 1772909 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1772995), // Rule ID 11787 //
     /* 1772914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1772934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1772956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772960 */     // MIs[0] policy
     /* 1772960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1772973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772994 */     // GIR_Coverage, 11787,
     /* 1772994 */     GIR_EraseRootFromParent_Done,
     /* 1772995 */   // Label 24112: @1772995
     /* 1772995 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1773081), // Rule ID 11790 //
     /* 1773000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1773011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1773014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1773017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773046 */     // MIs[0] policy
     /* 1773046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1773059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773080 */     // GIR_Coverage, 11790,
     /* 1773080 */     GIR_EraseRootFromParent_Done,
     /* 1773081 */   // Label 24113: @1773081
     /* 1773081 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1773167), // Rule ID 11791 //
     /* 1773086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1773097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1773100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1773103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773132 */     // MIs[0] policy
     /* 1773132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1773145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773166 */     // GIR_Coverage, 11791,
     /* 1773166 */     GIR_EraseRootFromParent_Done,
     /* 1773167 */   // Label 24114: @1773167
     /* 1773167 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1773253), // Rule ID 11794 //
     /* 1773172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1773183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1773186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1773189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1773195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773218 */     // MIs[0] policy
     /* 1773218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1773231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773252 */     // GIR_Coverage, 11794,
     /* 1773252 */     GIR_EraseRootFromParent_Done,
     /* 1773253 */   // Label 24115: @1773253
     /* 1773253 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1773339), // Rule ID 11795 //
     /* 1773258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1773269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1773272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1773275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1773281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773304 */     // MIs[0] policy
     /* 1773304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1773317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773338 */     // GIR_Coverage, 11795,
     /* 1773338 */     GIR_EraseRootFromParent_Done,
     /* 1773339 */   // Label 24116: @1773339
     /* 1773339 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1773425), // Rule ID 11798 //
     /* 1773344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1773355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1773358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1773361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773390 */     // MIs[0] policy
     /* 1773390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1773403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773424 */     // GIR_Coverage, 11798,
     /* 1773424 */     GIR_EraseRootFromParent_Done,
     /* 1773425 */   // Label 24117: @1773425
     /* 1773425 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1773511), // Rule ID 11799 //
     /* 1773430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1773441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1773444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1773447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773476 */     // MIs[0] policy
     /* 1773476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1773489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773510 */     // GIR_Coverage, 11799,
     /* 1773510 */     GIR_EraseRootFromParent_Done,
     /* 1773511 */   // Label 24118: @1773511
     /* 1773511 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1773597), // Rule ID 11802 //
     /* 1773516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1773527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1773530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1773533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773562 */     // MIs[0] policy
     /* 1773562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1773575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773596 */     // GIR_Coverage, 11802,
     /* 1773596 */     GIR_EraseRootFromParent_Done,
     /* 1773597 */   // Label 24119: @1773597
     /* 1773597 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1773683), // Rule ID 11803 //
     /* 1773602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1773613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1773616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1773619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773648 */     // MIs[0] policy
     /* 1773648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1773661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773682 */     // GIR_Coverage, 11803,
     /* 1773682 */     GIR_EraseRootFromParent_Done,
     /* 1773683 */   // Label 24120: @1773683
     /* 1773683 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1773769), // Rule ID 11806 //
     /* 1773688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773734 */     // MIs[0] policy
     /* 1773734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1773747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773768 */     // GIR_Coverage, 11806,
     /* 1773768 */     GIR_EraseRootFromParent_Done,
     /* 1773769 */   // Label 24121: @1773769
     /* 1773769 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1773855), // Rule ID 11807 //
     /* 1773774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773820 */     // MIs[0] policy
     /* 1773820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773830 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1773833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773854 */     // GIR_Coverage, 11807,
     /* 1773854 */     GIR_EraseRootFromParent_Done,
     /* 1773855 */   // Label 24122: @1773855
     /* 1773855 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1773941), // Rule ID 11810 //
     /* 1773860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773906 */     // MIs[0] policy
     /* 1773906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1773919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773940 */     // GIR_Coverage, 11810,
     /* 1773940 */     GIR_EraseRootFromParent_Done,
     /* 1773941 */   // Label 24123: @1773941
     /* 1773941 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1774027), // Rule ID 11811 //
     /* 1773946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773992 */     // MIs[0] policy
     /* 1773992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1774005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774026 */     // GIR_Coverage, 11811,
     /* 1774026 */     GIR_EraseRootFromParent_Done,
     /* 1774027 */   // Label 24124: @1774027
     /* 1774027 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1774113), // Rule ID 11814 //
     /* 1774032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1774043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1774046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1774049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774078 */     // MIs[0] policy
     /* 1774078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1774091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774112 */     // GIR_Coverage, 11814,
     /* 1774112 */     GIR_EraseRootFromParent_Done,
     /* 1774113 */   // Label 24125: @1774113
     /* 1774113 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1774199), // Rule ID 11815 //
     /* 1774118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1774129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1774132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1774135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774164 */     // MIs[0] policy
     /* 1774164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1774177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774198 */     // GIR_Coverage, 11815,
     /* 1774198 */     GIR_EraseRootFromParent_Done,
     /* 1774199 */   // Label 24126: @1774199
     /* 1774199 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1774285), // Rule ID 11818 //
     /* 1774204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1774215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1774218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1774221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1774227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774250 */     // MIs[0] policy
     /* 1774250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1774263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774284 */     // GIR_Coverage, 11818,
     /* 1774284 */     GIR_EraseRootFromParent_Done,
     /* 1774285 */   // Label 24127: @1774285
     /* 1774285 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1774371), // Rule ID 11819 //
     /* 1774290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1774301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1774304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1774307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1774313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774336 */     // MIs[0] policy
     /* 1774336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1774349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774370 */     // GIR_Coverage, 11819,
     /* 1774370 */     GIR_EraseRootFromParent_Done,
     /* 1774371 */   // Label 24128: @1774371
     /* 1774371 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1774457), // Rule ID 11822 //
     /* 1774376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1774387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1774390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1774393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1774406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774422 */     // MIs[0] policy
     /* 1774422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1774435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774456 */     // GIR_Coverage, 11822,
     /* 1774456 */     GIR_EraseRootFromParent_Done,
     /* 1774457 */   // Label 24129: @1774457
     /* 1774457 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1774543), // Rule ID 11823 //
     /* 1774462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1774473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1774476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1774479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1774492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1774500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774508 */     // MIs[0] policy
     /* 1774508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1774521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774542 */     // GIR_Coverage, 11823,
     /* 1774542 */     GIR_EraseRootFromParent_Done,
     /* 1774543 */   // Label 24130: @1774543
     /* 1774543 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1774629), // Rule ID 11826 //
     /* 1774548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1774559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1774562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1774565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774594 */     // MIs[0] policy
     /* 1774594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1774607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774628 */     // GIR_Coverage, 11826,
     /* 1774628 */     GIR_EraseRootFromParent_Done,
     /* 1774629 */   // Label 24131: @1774629
     /* 1774629 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1774715), // Rule ID 11827 //
     /* 1774634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1774645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1774648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1774651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774680 */     // MIs[0] policy
     /* 1774680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1774693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774714 */     // GIR_Coverage, 11827,
     /* 1774714 */     GIR_EraseRootFromParent_Done,
     /* 1774715 */   // Label 24132: @1774715
     /* 1774715 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1774801), // Rule ID 11830 //
     /* 1774720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774766 */     // MIs[0] policy
     /* 1774766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1774779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774800 */     // GIR_Coverage, 11830,
     /* 1774800 */     GIR_EraseRootFromParent_Done,
     /* 1774801 */   // Label 24133: @1774801
     /* 1774801 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1774887), // Rule ID 11831 //
     /* 1774806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774852 */     // MIs[0] policy
     /* 1774852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1774865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774886 */     // GIR_Coverage, 11831,
     /* 1774886 */     GIR_EraseRootFromParent_Done,
     /* 1774887 */   // Label 24134: @1774887
     /* 1774887 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1774973), // Rule ID 11834 //
     /* 1774892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1774912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774938 */     // MIs[0] policy
     /* 1774938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1774951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774972 */     // GIR_Coverage, 11834,
     /* 1774972 */     GIR_EraseRootFromParent_Done,
     /* 1774973 */   // Label 24135: @1774973
     /* 1774973 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1775059), // Rule ID 11835 //
     /* 1774978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1774998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775024 */     // MIs[0] policy
     /* 1775024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1775037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775058 */     // GIR_Coverage, 11835,
     /* 1775058 */     GIR_EraseRootFromParent_Done,
     /* 1775059 */   // Label 24136: @1775059
     /* 1775059 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1775145), // Rule ID 11838 //
     /* 1775064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1775075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1775078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1775081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1775084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775110 */     // MIs[0] policy
     /* 1775110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775120 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1775123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775144 */     // GIR_Coverage, 11838,
     /* 1775144 */     GIR_EraseRootFromParent_Done,
     /* 1775145 */   // Label 24137: @1775145
     /* 1775145 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1775231), // Rule ID 11839 //
     /* 1775150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1775161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1775164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1775167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1775170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775196 */     // MIs[0] policy
     /* 1775196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775206 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1775209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775230 */     // GIR_Coverage, 11839,
     /* 1775230 */     GIR_EraseRootFromParent_Done,
     /* 1775231 */   // Label 24138: @1775231
     /* 1775231 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1775317), // Rule ID 11842 //
     /* 1775236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1775247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1775250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1775253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1775256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775282 */     // MIs[0] policy
     /* 1775282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775292 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1775295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775316 */     // GIR_Coverage, 11842,
     /* 1775316 */     GIR_EraseRootFromParent_Done,
     /* 1775317 */   // Label 24139: @1775317
     /* 1775317 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1775403), // Rule ID 11843 //
     /* 1775322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1775333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1775336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1775339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1775342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775368 */     // MIs[0] policy
     /* 1775368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775378 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1775381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775402 */     // GIR_Coverage, 11843,
     /* 1775402 */     GIR_EraseRootFromParent_Done,
     /* 1775403 */   // Label 24140: @1775403
     /* 1775403 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1775489), // Rule ID 11846 //
     /* 1775408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1775419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1775422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1775425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1775428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775454 */     // MIs[0] policy
     /* 1775454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1775467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775488 */     // GIR_Coverage, 11846,
     /* 1775488 */     GIR_EraseRootFromParent_Done,
     /* 1775489 */   // Label 24141: @1775489
     /* 1775489 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1775575), // Rule ID 11847 //
     /* 1775494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1775505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1775508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1775511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1775514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775540 */     // MIs[0] policy
     /* 1775540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1775553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775574 */     // GIR_Coverage, 11847,
     /* 1775574 */     GIR_EraseRootFromParent_Done,
     /* 1775575 */   // Label 24142: @1775575
     /* 1775575 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1775661), // Rule ID 11850 //
     /* 1775580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1775600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775626 */     // MIs[0] policy
     /* 1775626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1775639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775660 */     // GIR_Coverage, 11850,
     /* 1775660 */     GIR_EraseRootFromParent_Done,
     /* 1775661 */   // Label 24143: @1775661
     /* 1775661 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1775747), // Rule ID 11851 //
     /* 1775666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1775686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775712 */     // MIs[0] policy
     /* 1775712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775722 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1775725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775746 */     // GIR_Coverage, 11851,
     /* 1775746 */     GIR_EraseRootFromParent_Done,
     /* 1775747 */   // Label 24144: @1775747
     /* 1775747 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1775833), // Rule ID 11854 //
     /* 1775752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1775772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775798 */     // MIs[0] policy
     /* 1775798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1775811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775832 */     // GIR_Coverage, 11854,
     /* 1775832 */     GIR_EraseRootFromParent_Done,
     /* 1775833 */   // Label 24145: @1775833
     /* 1775833 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1775919), // Rule ID 11855 //
     /* 1775838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1775858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775884 */     // MIs[0] policy
     /* 1775884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1775897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775918 */     // GIR_Coverage, 11855,
     /* 1775918 */     GIR_EraseRootFromParent_Done,
     /* 1775919 */   // Label 24146: @1775919
     /* 1775919 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1776005), // Rule ID 11858 //
     /* 1775924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1775935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1775938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1775941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1775944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775970 */     // MIs[0] policy
     /* 1775970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1775983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776004 */     // GIR_Coverage, 11858,
     /* 1776004 */     GIR_EraseRootFromParent_Done,
     /* 1776005 */   // Label 24147: @1776005
     /* 1776005 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1776091), // Rule ID 11859 //
     /* 1776010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1776021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1776024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1776027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1776030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776056 */     // MIs[0] policy
     /* 1776056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1776069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776090 */     // GIR_Coverage, 11859,
     /* 1776090 */     GIR_EraseRootFromParent_Done,
     /* 1776091 */   // Label 24148: @1776091
     /* 1776091 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1776177), // Rule ID 11862 //
     /* 1776096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1776107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1776110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1776113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1776116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776142 */     // MIs[0] policy
     /* 1776142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1776155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776176 */     // GIR_Coverage, 11862,
     /* 1776176 */     GIR_EraseRootFromParent_Done,
     /* 1776177 */   // Label 24149: @1776177
     /* 1776177 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1776263), // Rule ID 11863 //
     /* 1776182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1776193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1776196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1776199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1776202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776228 */     // MIs[0] policy
     /* 1776228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1776241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776262 */     // GIR_Coverage, 11863,
     /* 1776262 */     GIR_EraseRootFromParent_Done,
     /* 1776263 */   // Label 24150: @1776263
     /* 1776263 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1776349), // Rule ID 11866 //
     /* 1776268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1776279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1776282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1776285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1776288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776314 */     // MIs[0] policy
     /* 1776314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1776327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776348 */     // GIR_Coverage, 11866,
     /* 1776348 */     GIR_EraseRootFromParent_Done,
     /* 1776349 */   // Label 24151: @1776349
     /* 1776349 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1776435), // Rule ID 11867 //
     /* 1776354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1776365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1776368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1776371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1776374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776400 */     // MIs[0] policy
     /* 1776400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1776413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776434 */     // GIR_Coverage, 11867,
     /* 1776434 */     GIR_EraseRootFromParent_Done,
     /* 1776435 */   // Label 24152: @1776435
     /* 1776435 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1776521), // Rule ID 11870 //
     /* 1776440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1776451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1776454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1776457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1776460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1776463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776486 */     // MIs[0] policy
     /* 1776486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1776499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776520 */     // GIR_Coverage, 11870,
     /* 1776520 */     GIR_EraseRootFromParent_Done,
     /* 1776521 */   // Label 24153: @1776521
     /* 1776521 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1776607), // Rule ID 11871 //
     /* 1776526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1776537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1776540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1776543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1776546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1776549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1776556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1776568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776572 */     // MIs[0] policy
     /* 1776572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1776585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776606 */     // GIR_Coverage, 11871,
     /* 1776606 */     GIR_EraseRootFromParent_Done,
     /* 1776607 */   // Label 24154: @1776607
     /* 1776607 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1776693), // Rule ID 11874 //
     /* 1776612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1776632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776658 */     // MIs[0] policy
     /* 1776658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1776671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776692 */     // GIR_Coverage, 11874,
     /* 1776692 */     GIR_EraseRootFromParent_Done,
     /* 1776693 */   // Label 24155: @1776693
     /* 1776693 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1776779), // Rule ID 11875 //
     /* 1776698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1776718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776744 */     // MIs[0] policy
     /* 1776744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1776757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776778 */     // GIR_Coverage, 11875,
     /* 1776778 */     GIR_EraseRootFromParent_Done,
     /* 1776779 */   // Label 24156: @1776779
     /* 1776779 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1776865), // Rule ID 11878 //
     /* 1776784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1776804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776830 */     // MIs[0] policy
     /* 1776830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1776843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776864 */     // GIR_Coverage, 11878,
     /* 1776864 */     GIR_EraseRootFromParent_Done,
     /* 1776865 */   // Label 24157: @1776865
     /* 1776865 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1776951), // Rule ID 11879 //
     /* 1776870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1776890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776916 */     // MIs[0] policy
     /* 1776916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776926 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1776929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776950 */     // GIR_Coverage, 11879,
     /* 1776950 */     GIR_EraseRootFromParent_Done,
     /* 1776951 */   // Label 24158: @1776951
     /* 1776951 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1777037), // Rule ID 11882 //
     /* 1776956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1776967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1776970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1776973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1776976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1776979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777002 */     // MIs[0] policy
     /* 1777002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1777015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777036 */     // GIR_Coverage, 11882,
     /* 1777036 */     GIR_EraseRootFromParent_Done,
     /* 1777037 */   // Label 24159: @1777037
     /* 1777037 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1777123), // Rule ID 11883 //
     /* 1777042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1777053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1777056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1777059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1777062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1777065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777088 */     // MIs[0] policy
     /* 1777088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777098 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1777101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777122 */     // GIR_Coverage, 11883,
     /* 1777122 */     GIR_EraseRootFromParent_Done,
     /* 1777123 */   // Label 24160: @1777123
     /* 1777123 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1777209), // Rule ID 11886 //
     /* 1777128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1777139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1777142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1777145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1777148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777174 */     // MIs[0] policy
     /* 1777174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1777187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777208 */     // GIR_Coverage, 11886,
     /* 1777208 */     GIR_EraseRootFromParent_Done,
     /* 1777209 */   // Label 24161: @1777209
     /* 1777209 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1777295), // Rule ID 11887 //
     /* 1777214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1777225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1777228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1777231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1777234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777260 */     // MIs[0] policy
     /* 1777260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1777273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777294 */     // GIR_Coverage, 11887,
     /* 1777294 */     GIR_EraseRootFromParent_Done,
     /* 1777295 */   // Label 24162: @1777295
     /* 1777295 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1777381), // Rule ID 11890 //
     /* 1777300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1777311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1777314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1777317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1777320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777346 */     // MIs[0] policy
     /* 1777346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1777359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777380 */     // GIR_Coverage, 11890,
     /* 1777380 */     GIR_EraseRootFromParent_Done,
     /* 1777381 */   // Label 24163: @1777381
     /* 1777381 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1777467), // Rule ID 11891 //
     /* 1777386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1777397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1777400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1777403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1777406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777432 */     // MIs[0] policy
     /* 1777432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1777445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777466 */     // GIR_Coverage, 11891,
     /* 1777466 */     GIR_EraseRootFromParent_Done,
     /* 1777467 */   // Label 24164: @1777467
     /* 1777467 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1777553), // Rule ID 11894 //
     /* 1777472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1777483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1777486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1777489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1777492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1777495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777518 */     // MIs[0] policy
     /* 1777518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1777531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777552 */     // GIR_Coverage, 11894,
     /* 1777552 */     GIR_EraseRootFromParent_Done,
     /* 1777553 */   // Label 24165: @1777553
     /* 1777553 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1777639), // Rule ID 11895 //
     /* 1777558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1777569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1777572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1777575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1777578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1777581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777604 */     // MIs[0] policy
     /* 1777604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1777617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777638 */     // GIR_Coverage, 11895,
     /* 1777638 */     GIR_EraseRootFromParent_Done,
     /* 1777639 */   // Label 24166: @1777639
     /* 1777639 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1777725), // Rule ID 11898 //
     /* 1777644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1777664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777690 */     // MIs[0] policy
     /* 1777690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1777703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777724 */     // GIR_Coverage, 11898,
     /* 1777724 */     GIR_EraseRootFromParent_Done,
     /* 1777725 */   // Label 24167: @1777725
     /* 1777725 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1777811), // Rule ID 11899 //
     /* 1777730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1777750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777776 */     // MIs[0] policy
     /* 1777776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1777789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777810 */     // GIR_Coverage, 11899,
     /* 1777810 */     GIR_EraseRootFromParent_Done,
     /* 1777811 */   // Label 24168: @1777811
     /* 1777811 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1777897), // Rule ID 11902 //
     /* 1777816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1777836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777862 */     // MIs[0] policy
     /* 1777862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1777875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777896 */     // GIR_Coverage, 11902,
     /* 1777896 */     GIR_EraseRootFromParent_Done,
     /* 1777897 */   // Label 24169: @1777897
     /* 1777897 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1777983), // Rule ID 11903 //
     /* 1777902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1777922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777948 */     // MIs[0] policy
     /* 1777948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1777961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777982 */     // GIR_Coverage, 11903,
     /* 1777982 */     GIR_EraseRootFromParent_Done,
     /* 1777983 */   // Label 24170: @1777983
     /* 1777983 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1778069), // Rule ID 11906 //
     /* 1777988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1778002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1778005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1778008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778034 */     // MIs[0] policy
     /* 1778034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1778047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778068 */     // GIR_Coverage, 11906,
     /* 1778068 */     GIR_EraseRootFromParent_Done,
     /* 1778069 */   // Label 24171: @1778069
     /* 1778069 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1778155), // Rule ID 11907 //
     /* 1778074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1778085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1778088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1778091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1778094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778120 */     // MIs[0] policy
     /* 1778120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1778133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778154 */     // GIR_Coverage, 11907,
     /* 1778154 */     GIR_EraseRootFromParent_Done,
     /* 1778155 */   // Label 24172: @1778155
     /* 1778155 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1778241), // Rule ID 11910 //
     /* 1778160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1778171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1778174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1778177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1778180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778206 */     // MIs[0] policy
     /* 1778206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1778219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778240 */     // GIR_Coverage, 11910,
     /* 1778240 */     GIR_EraseRootFromParent_Done,
     /* 1778241 */   // Label 24173: @1778241
     /* 1778241 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1778327), // Rule ID 11911 //
     /* 1778246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1778257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1778260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1778263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1778266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778292 */     // MIs[0] policy
     /* 1778292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1778305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778326 */     // GIR_Coverage, 11911,
     /* 1778326 */     GIR_EraseRootFromParent_Done,
     /* 1778327 */   // Label 24174: @1778327
     /* 1778327 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1778413), // Rule ID 11914 //
     /* 1778332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1778343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1778346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1778349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1778352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1778362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778378 */     // MIs[0] policy
     /* 1778378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1778391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778412 */     // GIR_Coverage, 11914,
     /* 1778412 */     GIR_EraseRootFromParent_Done,
     /* 1778413 */   // Label 24175: @1778413
     /* 1778413 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1778499), // Rule ID 11915 //
     /* 1778418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1778429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1778432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1778435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1778438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1778448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1778460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778464 */     // MIs[0] policy
     /* 1778464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1778477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778498 */     // GIR_Coverage, 11915,
     /* 1778498 */     GIR_EraseRootFromParent_Done,
     /* 1778499 */   // Label 24176: @1778499
     /* 1778499 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1778585), // Rule ID 11918 //
     /* 1778504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1778515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1778518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1778521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1778524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778550 */     // MIs[0] policy
     /* 1778550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1778563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778584 */     // GIR_Coverage, 11918,
     /* 1778584 */     GIR_EraseRootFromParent_Done,
     /* 1778585 */   // Label 24177: @1778585
     /* 1778585 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1778671), // Rule ID 11919 //
     /* 1778590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1778601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1778604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1778607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1778610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778636 */     // MIs[0] policy
     /* 1778636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1778649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778670 */     // GIR_Coverage, 11919,
     /* 1778670 */     GIR_EraseRootFromParent_Done,
     /* 1778671 */   // Label 24178: @1778671
     /* 1778671 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1778757), // Rule ID 11922 //
     /* 1778676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778722 */     // MIs[0] policy
     /* 1778722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1778735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778756 */     // GIR_Coverage, 11922,
     /* 1778756 */     GIR_EraseRootFromParent_Done,
     /* 1778757 */   // Label 24179: @1778757
     /* 1778757 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1778843), // Rule ID 11923 //
     /* 1778762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778808 */     // MIs[0] policy
     /* 1778808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1778821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778842 */     // GIR_Coverage, 11923,
     /* 1778842 */     GIR_EraseRootFromParent_Done,
     /* 1778843 */   // Label 24180: @1778843
     /* 1778843 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1778929), // Rule ID 11926 //
     /* 1778848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1778868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778894 */     // MIs[0] policy
     /* 1778894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778904 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1778907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778928 */     // GIR_Coverage, 11926,
     /* 1778928 */     GIR_EraseRootFromParent_Done,
     /* 1778929 */   // Label 24181: @1778929
     /* 1778929 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1779015), // Rule ID 11927 //
     /* 1778934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778980 */     // MIs[0] policy
     /* 1778980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1778993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779014 */     // GIR_Coverage, 11927,
     /* 1779014 */     GIR_EraseRootFromParent_Done,
     /* 1779015 */   // Label 24182: @1779015
     /* 1779015 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1779101), // Rule ID 11930 //
     /* 1779020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1779031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1779034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1779037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779066 */     // MIs[0] policy
     /* 1779066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779076 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1779079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779100 */     // GIR_Coverage, 11930,
     /* 1779100 */     GIR_EraseRootFromParent_Done,
     /* 1779101 */   // Label 24183: @1779101
     /* 1779101 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1779187), // Rule ID 11931 //
     /* 1779106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1779117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1779120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1779123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779152 */     // MIs[0] policy
     /* 1779152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1779165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779186 */     // GIR_Coverage, 11931,
     /* 1779186 */     GIR_EraseRootFromParent_Done,
     /* 1779187 */   // Label 24184: @1779187
     /* 1779187 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1779273), // Rule ID 11934 //
     /* 1779192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1779203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1779206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1779209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779238 */     // MIs[0] policy
     /* 1779238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1779251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779272 */     // GIR_Coverage, 11934,
     /* 1779272 */     GIR_EraseRootFromParent_Done,
     /* 1779273 */   // Label 24185: @1779273
     /* 1779273 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1779359), // Rule ID 11935 //
     /* 1779278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1779289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1779292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1779295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779324 */     // MIs[0] policy
     /* 1779324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1779337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779358 */     // GIR_Coverage, 11935,
     /* 1779358 */     GIR_EraseRootFromParent_Done,
     /* 1779359 */   // Label 24186: @1779359
     /* 1779359 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1779445), // Rule ID 11938 //
     /* 1779364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1779375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1779378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1779381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779410 */     // MIs[0] policy
     /* 1779410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1779423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779444 */     // GIR_Coverage, 11938,
     /* 1779444 */     GIR_EraseRootFromParent_Done,
     /* 1779445 */   // Label 24187: @1779445
     /* 1779445 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1779531), // Rule ID 11939 //
     /* 1779450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1779461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1779464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1779467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779496 */     // MIs[0] policy
     /* 1779496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1779509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779530 */     // GIR_Coverage, 11939,
     /* 1779530 */     GIR_EraseRootFromParent_Done,
     /* 1779531 */   // Label 24188: @1779531
     /* 1779531 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1779617), // Rule ID 11942 //
     /* 1779536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1779547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1779550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1779553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779582 */     // MIs[0] policy
     /* 1779582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1779595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779616 */     // GIR_Coverage, 11942,
     /* 1779616 */     GIR_EraseRootFromParent_Done,
     /* 1779617 */   // Label 24189: @1779617
     /* 1779617 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1779703), // Rule ID 11943 //
     /* 1779622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1779633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1779636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1779639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779668 */     // MIs[0] policy
     /* 1779668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1779681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779702 */     // GIR_Coverage, 11943,
     /* 1779702 */     GIR_EraseRootFromParent_Done,
     /* 1779703 */   // Label 24190: @1779703
     /* 1779703 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1779789), // Rule ID 11946 //
     /* 1779708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779754 */     // MIs[0] policy
     /* 1779754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1779767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779788 */     // GIR_Coverage, 11946,
     /* 1779788 */     GIR_EraseRootFromParent_Done,
     /* 1779789 */   // Label 24191: @1779789
     /* 1779789 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1779875), // Rule ID 11947 //
     /* 1779794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779840 */     // MIs[0] policy
     /* 1779840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11121:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1779853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779874 */     // GIR_Coverage, 11947,
     /* 1779874 */     GIR_EraseRootFromParent_Done,
     /* 1779875 */   // Label 24192: @1779875
     /* 1779875 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1779961), // Rule ID 11950 //
     /* 1779880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1779891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1779894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1779897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1779900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1779922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779926 */     // MIs[0] policy
     /* 1779926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1779939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779960 */     // GIR_Coverage, 11950,
     /* 1779960 */     GIR_EraseRootFromParent_Done,
     /* 1779961 */   // Label 24193: @1779961
     /* 1779961 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1780047), // Rule ID 11951 //
     /* 1779966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1779977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1779980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1779983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1779986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780012 */     // MIs[0] policy
     /* 1780012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1780025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780046 */     // GIR_Coverage, 11951,
     /* 1780046 */     GIR_EraseRootFromParent_Done,
     /* 1780047 */   // Label 24194: @1780047
     /* 1780047 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1780133), // Rule ID 11954 //
     /* 1780052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1780063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1780066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1780069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780098 */     // MIs[0] policy
     /* 1780098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1780111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780132 */     // GIR_Coverage, 11954,
     /* 1780132 */     GIR_EraseRootFromParent_Done,
     /* 1780133 */   // Label 24195: @1780133
     /* 1780133 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1780219), // Rule ID 11955 //
     /* 1780138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1780149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1780152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1780155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780184 */     // MIs[0] policy
     /* 1780184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1780197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780218 */     // GIR_Coverage, 11955,
     /* 1780218 */     GIR_EraseRootFromParent_Done,
     /* 1780219 */   // Label 24196: @1780219
     /* 1780219 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1780305), // Rule ID 11958 //
     /* 1780224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1780235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1780238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1780241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780270 */     // MIs[0] policy
     /* 1780270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1780283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780304 */     // GIR_Coverage, 11958,
     /* 1780304 */     GIR_EraseRootFromParent_Done,
     /* 1780305 */   // Label 24197: @1780305
     /* 1780305 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1780391), // Rule ID 11959 //
     /* 1780310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1780321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1780324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1780327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780356 */     // MIs[0] policy
     /* 1780356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1780369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780390 */     // GIR_Coverage, 11959,
     /* 1780390 */     GIR_EraseRootFromParent_Done,
     /* 1780391 */   // Label 24198: @1780391
     /* 1780391 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1780477), // Rule ID 11962 //
     /* 1780396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1780407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1780410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1780413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780442 */     // MIs[0] policy
     /* 1780442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1780455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780476 */     // GIR_Coverage, 11962,
     /* 1780476 */     GIR_EraseRootFromParent_Done,
     /* 1780477 */   // Label 24199: @1780477
     /* 1780477 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1780563), // Rule ID 11963 //
     /* 1780482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1780493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1780496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1780499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780528 */     // MIs[0] policy
     /* 1780528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1780541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780562 */     // GIR_Coverage, 11963,
     /* 1780562 */     GIR_EraseRootFromParent_Done,
     /* 1780563 */   // Label 24200: @1780563
     /* 1780563 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1780649), // Rule ID 11966 //
     /* 1780568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780614 */     // MIs[0] policy
     /* 1780614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1780627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780648 */     // GIR_Coverage, 11966,
     /* 1780648 */     GIR_EraseRootFromParent_Done,
     /* 1780649 */   // Label 24201: @1780649
     /* 1780649 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1780735), // Rule ID 11967 //
     /* 1780654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780700 */     // MIs[0] policy
     /* 1780700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1780713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780734 */     // GIR_Coverage, 11967,
     /* 1780734 */     GIR_EraseRootFromParent_Done,
     /* 1780735 */   // Label 24202: @1780735
     /* 1780735 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1780821), // Rule ID 11970 //
     /* 1780740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780786 */     // MIs[0] policy
     /* 1780786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1780799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780820 */     // GIR_Coverage, 11970,
     /* 1780820 */     GIR_EraseRootFromParent_Done,
     /* 1780821 */   // Label 24203: @1780821
     /* 1780821 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1780907), // Rule ID 11971 //
     /* 1780826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1780846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780872 */     // MIs[0] policy
     /* 1780872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780882 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1780885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780906 */     // GIR_Coverage, 11971,
     /* 1780906 */     GIR_EraseRootFromParent_Done,
     /* 1780907 */   // Label 24204: @1780907
     /* 1780907 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1780993), // Rule ID 11974 //
     /* 1780912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1780923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1780926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1780929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780958 */     // MIs[0] policy
     /* 1780958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1780971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780992 */     // GIR_Coverage, 11974,
     /* 1780992 */     GIR_EraseRootFromParent_Done,
     /* 1780993 */   // Label 24205: @1780993
     /* 1780993 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1781079), // Rule ID 11975 //
     /* 1780998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1781009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1781012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1781015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781044 */     // MIs[0] policy
     /* 1781044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1781057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781078 */     // GIR_Coverage, 11975,
     /* 1781078 */     GIR_EraseRootFromParent_Done,
     /* 1781079 */   // Label 24206: @1781079
     /* 1781079 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1781165), // Rule ID 11978 //
     /* 1781084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1781095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1781098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1781101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781130 */     // MIs[0] policy
     /* 1781130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1781143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781164 */     // GIR_Coverage, 11978,
     /* 1781164 */     GIR_EraseRootFromParent_Done,
     /* 1781165 */   // Label 24207: @1781165
     /* 1781165 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1781251), // Rule ID 11979 //
     /* 1781170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1781181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1781184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1781187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781216 */     // MIs[0] policy
     /* 1781216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1781229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781250 */     // GIR_Coverage, 11979,
     /* 1781250 */     GIR_EraseRootFromParent_Done,
     /* 1781251 */   // Label 24208: @1781251
     /* 1781251 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1781337), // Rule ID 11982 //
     /* 1781256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1781267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1781270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1781273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1781279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781302 */     // MIs[0] policy
     /* 1781302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1781315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781336 */     // GIR_Coverage, 11982,
     /* 1781336 */     GIR_EraseRootFromParent_Done,
     /* 1781337 */   // Label 24209: @1781337
     /* 1781337 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1781423), // Rule ID 11983 //
     /* 1781342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1781353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1781356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1781359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1781365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781388 */     // MIs[0] policy
     /* 1781388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1781401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781422 */     // GIR_Coverage, 11983,
     /* 1781422 */     GIR_EraseRootFromParent_Done,
     /* 1781423 */   // Label 24210: @1781423
     /* 1781423 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1781509), // Rule ID 11986 //
     /* 1781428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1781439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1781442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1781445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781474 */     // MIs[0] policy
     /* 1781474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1781487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781508 */     // GIR_Coverage, 11986,
     /* 1781508 */     GIR_EraseRootFromParent_Done,
     /* 1781509 */   // Label 24211: @1781509
     /* 1781509 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1781595), // Rule ID 11987 //
     /* 1781514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1781525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1781528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1781531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781560 */     // MIs[0] policy
     /* 1781560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1781573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781594 */     // GIR_Coverage, 11987,
     /* 1781594 */     GIR_EraseRootFromParent_Done,
     /* 1781595 */   // Label 24212: @1781595
     /* 1781595 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1781681), // Rule ID 11990 //
     /* 1781600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781646 */     // MIs[0] policy
     /* 1781646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1781659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781680 */     // GIR_Coverage, 11990,
     /* 1781680 */     GIR_EraseRootFromParent_Done,
     /* 1781681 */   // Label 24213: @1781681
     /* 1781681 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1781767), // Rule ID 11991 //
     /* 1781686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781732 */     // MIs[0] policy
     /* 1781732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1781745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781766 */     // GIR_Coverage, 11991,
     /* 1781766 */     GIR_EraseRootFromParent_Done,
     /* 1781767 */   // Label 24214: @1781767
     /* 1781767 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1781853), // Rule ID 11994 //
     /* 1781772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781818 */     // MIs[0] policy
     /* 1781818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1781831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781852 */     // GIR_Coverage, 11994,
     /* 1781852 */     GIR_EraseRootFromParent_Done,
     /* 1781853 */   // Label 24215: @1781853
     /* 1781853 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1781939), // Rule ID 11995 //
     /* 1781858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781904 */     // MIs[0] policy
     /* 1781904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1781917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781938 */     // GIR_Coverage, 11995,
     /* 1781938 */     GIR_EraseRootFromParent_Done,
     /* 1781939 */   // Label 24216: @1781939
     /* 1781939 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1782025), // Rule ID 11998 //
     /* 1781944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1781955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1781958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1781961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781990 */     // MIs[0] policy
     /* 1781990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1782003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782024 */     // GIR_Coverage, 11998,
     /* 1782024 */     GIR_EraseRootFromParent_Done,
     /* 1782025 */   // Label 24217: @1782025
     /* 1782025 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1782111), // Rule ID 11999 //
     /* 1782030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1782041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1782044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1782047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782076 */     // MIs[0] policy
     /* 1782076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1782089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782110 */     // GIR_Coverage, 11999,
     /* 1782110 */     GIR_EraseRootFromParent_Done,
     /* 1782111 */   // Label 24218: @1782111
     /* 1782111 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1782197), // Rule ID 12002 //
     /* 1782116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1782127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1782130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1782133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782162 */     // MIs[0] policy
     /* 1782162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782172 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1782175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782196 */     // GIR_Coverage, 12002,
     /* 1782196 */     GIR_EraseRootFromParent_Done,
     /* 1782197 */   // Label 24219: @1782197
     /* 1782197 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1782283), // Rule ID 12003 //
     /* 1782202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1782213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1782216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1782219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782248 */     // MIs[0] policy
     /* 1782248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1782261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782282 */     // GIR_Coverage, 12003,
     /* 1782282 */     GIR_EraseRootFromParent_Done,
     /* 1782283 */   // Label 24220: @1782283
     /* 1782283 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1782369), // Rule ID 12006 //
     /* 1782288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1782299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1782302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1782305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1782318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782334 */     // MIs[0] policy
     /* 1782334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1782347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782368 */     // GIR_Coverage, 12006,
     /* 1782368 */     GIR_EraseRootFromParent_Done,
     /* 1782369 */   // Label 24221: @1782369
     /* 1782369 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1782455), // Rule ID 12007 //
     /* 1782374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1782385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1782388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1782391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1782404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1782412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782420 */     // MIs[0] policy
     /* 1782420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1782433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782454 */     // GIR_Coverage, 12007,
     /* 1782454 */     GIR_EraseRootFromParent_Done,
     /* 1782455 */   // Label 24222: @1782455
     /* 1782455 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1782541), // Rule ID 12010 //
     /* 1782460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1782471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1782474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1782477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1782480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782506 */     // MIs[0] policy
     /* 1782506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1782519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782540 */     // GIR_Coverage, 12010,
     /* 1782540 */     GIR_EraseRootFromParent_Done,
     /* 1782541 */   // Label 24223: @1782541
     /* 1782541 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1782627), // Rule ID 12011 //
     /* 1782546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1782557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1782560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1782563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1782566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782592 */     // MIs[0] policy
     /* 1782592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1782605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782626 */     // GIR_Coverage, 12011,
     /* 1782626 */     GIR_EraseRootFromParent_Done,
     /* 1782627 */   // Label 24224: @1782627
     /* 1782627 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1782713), // Rule ID 12014 //
     /* 1782632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1782652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782678 */     // MIs[0] policy
     /* 1782678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1782691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782712 */     // GIR_Coverage, 12014,
     /* 1782712 */     GIR_EraseRootFromParent_Done,
     /* 1782713 */   // Label 24225: @1782713
     /* 1782713 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1782799), // Rule ID 12015 //
     /* 1782718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1782738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782764 */     // MIs[0] policy
     /* 1782764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1782777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782798 */     // GIR_Coverage, 12015,
     /* 1782798 */     GIR_EraseRootFromParent_Done,
     /* 1782799 */   // Label 24226: @1782799
     /* 1782799 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1782885), // Rule ID 12018 //
     /* 1782804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1782815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1782818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1782821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1782824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782850 */     // MIs[0] policy
     /* 1782850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1782863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782884 */     // GIR_Coverage, 12018,
     /* 1782884 */     GIR_EraseRootFromParent_Done,
     /* 1782885 */   // Label 24227: @1782885
     /* 1782885 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1782971), // Rule ID 12019 //
     /* 1782890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1782901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1782904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1782907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1782910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782936 */     // MIs[0] policy
     /* 1782936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782946 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1782949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782970 */     // GIR_Coverage, 12019,
     /* 1782970 */     GIR_EraseRootFromParent_Done,
     /* 1782971 */   // Label 24228: @1782971
     /* 1782971 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1783057), // Rule ID 12022 //
     /* 1782976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1782987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1782990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1782993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1782996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783022 */     // MIs[0] policy
     /* 1783022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1783035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783056 */     // GIR_Coverage, 12022,
     /* 1783056 */     GIR_EraseRootFromParent_Done,
     /* 1783057 */   // Label 24229: @1783057
     /* 1783057 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1783143), // Rule ID 12023 //
     /* 1783062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1783073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1783076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1783079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1783082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783108 */     // MIs[0] policy
     /* 1783108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1783121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783142 */     // GIR_Coverage, 12023,
     /* 1783142 */     GIR_EraseRootFromParent_Done,
     /* 1783143 */   // Label 24230: @1783143
     /* 1783143 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1783229), // Rule ID 12026 //
     /* 1783148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1783159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1783162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1783165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1783168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783194 */     // MIs[0] policy
     /* 1783194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1783207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783228 */     // GIR_Coverage, 12026,
     /* 1783228 */     GIR_EraseRootFromParent_Done,
     /* 1783229 */   // Label 24231: @1783229
     /* 1783229 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1783315), // Rule ID 12027 //
     /* 1783234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1783245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1783248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1783251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1783254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783280 */     // MIs[0] policy
     /* 1783280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1783293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783314 */     // GIR_Coverage, 12027,
     /* 1783314 */     GIR_EraseRootFromParent_Done,
     /* 1783315 */   // Label 24232: @1783315
     /* 1783315 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1783401), // Rule ID 12030 //
     /* 1783320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1783331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1783334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1783337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1783340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783366 */     // MIs[0] policy
     /* 1783366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1783379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783400 */     // GIR_Coverage, 12030,
     /* 1783400 */     GIR_EraseRootFromParent_Done,
     /* 1783401 */   // Label 24233: @1783401
     /* 1783401 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1783487), // Rule ID 12031 //
     /* 1783406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1783417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1783420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1783423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1783426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783452 */     // MIs[0] policy
     /* 1783452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1783465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783486 */     // GIR_Coverage, 12031,
     /* 1783486 */     GIR_EraseRootFromParent_Done,
     /* 1783487 */   // Label 24234: @1783487
     /* 1783487 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1783573), // Rule ID 12034 //
     /* 1783492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1783503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1783506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1783509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1783512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783538 */     // MIs[0] policy
     /* 1783538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1783551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783572 */     // GIR_Coverage, 12034,
     /* 1783572 */     GIR_EraseRootFromParent_Done,
     /* 1783573 */   // Label 24235: @1783573
     /* 1783573 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1783659), // Rule ID 12035 //
     /* 1783578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1783589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1783592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1783595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1783598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783624 */     // MIs[0] policy
     /* 1783624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1783637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783658 */     // GIR_Coverage, 12035,
     /* 1783658 */     GIR_EraseRootFromParent_Done,
     /* 1783659 */   // Label 24236: @1783659
     /* 1783659 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1783745), // Rule ID 12038 //
     /* 1783664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1783684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783710 */     // MIs[0] policy
     /* 1783710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1783723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783744 */     // GIR_Coverage, 12038,
     /* 1783744 */     GIR_EraseRootFromParent_Done,
     /* 1783745 */   // Label 24237: @1783745
     /* 1783745 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1783831), // Rule ID 12039 //
     /* 1783750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1783770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783796 */     // MIs[0] policy
     /* 1783796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1783809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783830 */     // GIR_Coverage, 12039,
     /* 1783830 */     GIR_EraseRootFromParent_Done,
     /* 1783831 */   // Label 24238: @1783831
     /* 1783831 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1783917), // Rule ID 12042 //
     /* 1783836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1783847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1783850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1783853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1783856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783882 */     // MIs[0] policy
     /* 1783882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1783895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783916 */     // GIR_Coverage, 12042,
     /* 1783916 */     GIR_EraseRootFromParent_Done,
     /* 1783917 */   // Label 24239: @1783917
     /* 1783917 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1784003), // Rule ID 12043 //
     /* 1783922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1783933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1783936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1783939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1783942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783968 */     // MIs[0] policy
     /* 1783968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1783981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784002 */     // GIR_Coverage, 12043,
     /* 1784002 */     GIR_EraseRootFromParent_Done,
     /* 1784003 */   // Label 24240: @1784003
     /* 1784003 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1784089), // Rule ID 12046 //
     /* 1784008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1784019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1784022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1784025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1784028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784054 */     // MIs[0] policy
     /* 1784054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1784067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784088 */     // GIR_Coverage, 12046,
     /* 1784088 */     GIR_EraseRootFromParent_Done,
     /* 1784089 */   // Label 24241: @1784089
     /* 1784089 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1784175), // Rule ID 12047 //
     /* 1784094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1784105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1784108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1784111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1784114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784140 */     // MIs[0] policy
     /* 1784140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1784153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784174 */     // GIR_Coverage, 12047,
     /* 1784174 */     GIR_EraseRootFromParent_Done,
     /* 1784175 */   // Label 24242: @1784175
     /* 1784175 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1784261), // Rule ID 12050 //
     /* 1784180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1784191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1784194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1784197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1784200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784226 */     // MIs[0] policy
     /* 1784226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1784239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784260 */     // GIR_Coverage, 12050,
     /* 1784260 */     GIR_EraseRootFromParent_Done,
     /* 1784261 */   // Label 24243: @1784261
     /* 1784261 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1784347), // Rule ID 12051 //
     /* 1784266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1784277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1784280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1784283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1784286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784312 */     // MIs[0] policy
     /* 1784312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1784325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784346 */     // GIR_Coverage, 12051,
     /* 1784346 */     GIR_EraseRootFromParent_Done,
     /* 1784347 */   // Label 24244: @1784347
     /* 1784347 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1784433), // Rule ID 12054 //
     /* 1784352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1784363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1784366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1784369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1784372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784398 */     // MIs[0] policy
     /* 1784398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1784411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784432 */     // GIR_Coverage, 12054,
     /* 1784432 */     GIR_EraseRootFromParent_Done,
     /* 1784433 */   // Label 24245: @1784433
     /* 1784433 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1784519), // Rule ID 12055 //
     /* 1784438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1784449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1784452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1784455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1784458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784484 */     // MIs[0] policy
     /* 1784484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1784497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784518 */     // GIR_Coverage, 12055,
     /* 1784518 */     GIR_EraseRootFromParent_Done,
     /* 1784519 */   // Label 24246: @1784519
     /* 1784519 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1784605), // Rule ID 12058 //
     /* 1784524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1784535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1784538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1784541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1784544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1784547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784570 */     // MIs[0] policy
     /* 1784570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784580 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1784583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784604 */     // GIR_Coverage, 12058,
     /* 1784604 */     GIR_EraseRootFromParent_Done,
     /* 1784605 */   // Label 24247: @1784605
     /* 1784605 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1784691), // Rule ID 12059 //
     /* 1784610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1784621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1784624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1784627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1784630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1784633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784656 */     // MIs[0] policy
     /* 1784656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1784669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784690 */     // GIR_Coverage, 12059,
     /* 1784690 */     GIR_EraseRootFromParent_Done,
     /* 1784691 */   // Label 24248: @1784691
     /* 1784691 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1784777), // Rule ID 12062 //
     /* 1784696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1784716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784742 */     // MIs[0] policy
     /* 1784742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1784755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784776 */     // GIR_Coverage, 12062,
     /* 1784776 */     GIR_EraseRootFromParent_Done,
     /* 1784777 */   // Label 24249: @1784777
     /* 1784777 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1784863), // Rule ID 12063 //
     /* 1784782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1784802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784828 */     // MIs[0] policy
     /* 1784828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1784841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784862 */     // GIR_Coverage, 12063,
     /* 1784862 */     GIR_EraseRootFromParent_Done,
     /* 1784863 */   // Label 24250: @1784863
     /* 1784863 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1784949), // Rule ID 12066 //
     /* 1784868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1784879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1784882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1784885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1784888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784914 */     // MIs[0] policy
     /* 1784914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1784927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784948 */     // GIR_Coverage, 12066,
     /* 1784948 */     GIR_EraseRootFromParent_Done,
     /* 1784949 */   // Label 24251: @1784949
     /* 1784949 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1785035), // Rule ID 12067 //
     /* 1784954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1784965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1784968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1784971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1784974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785000 */     // MIs[0] policy
     /* 1785000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1785013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785034 */     // GIR_Coverage, 12067,
     /* 1785034 */     GIR_EraseRootFromParent_Done,
     /* 1785035 */   // Label 24252: @1785035
     /* 1785035 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1785121), // Rule ID 12070 //
     /* 1785040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1785051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1785054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1785057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1785060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1785063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785086 */     // MIs[0] policy
     /* 1785086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1785099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785120 */     // GIR_Coverage, 12070,
     /* 1785120 */     GIR_EraseRootFromParent_Done,
     /* 1785121 */   // Label 24253: @1785121
     /* 1785121 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1785207), // Rule ID 12071 //
     /* 1785126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1785137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1785140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1785143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1785146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1785149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785172 */     // MIs[0] policy
     /* 1785172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1785185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785206 */     // GIR_Coverage, 12071,
     /* 1785206 */     GIR_EraseRootFromParent_Done,
     /* 1785207 */   // Label 24254: @1785207
     /* 1785207 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1785293), // Rule ID 12074 //
     /* 1785212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1785223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1785226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1785229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1785232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785258 */     // MIs[0] policy
     /* 1785258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1785271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785292 */     // GIR_Coverage, 12074,
     /* 1785292 */     GIR_EraseRootFromParent_Done,
     /* 1785293 */   // Label 24255: @1785293
     /* 1785293 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1785379), // Rule ID 12075 //
     /* 1785298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1785309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1785312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1785315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1785318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785344 */     // MIs[0] policy
     /* 1785344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1785357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785378 */     // GIR_Coverage, 12075,
     /* 1785378 */     GIR_EraseRootFromParent_Done,
     /* 1785379 */   // Label 24256: @1785379
     /* 1785379 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1785465), // Rule ID 12078 //
     /* 1785384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1785395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1785398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1785401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1785404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785430 */     // MIs[0] policy
     /* 1785430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1785443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785464 */     // GIR_Coverage, 12078,
     /* 1785464 */     GIR_EraseRootFromParent_Done,
     /* 1785465 */   // Label 24257: @1785465
     /* 1785465 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1785551), // Rule ID 12079 //
     /* 1785470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1785481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1785484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1785487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1785490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785516 */     // MIs[0] policy
     /* 1785516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1785529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785550 */     // GIR_Coverage, 12079,
     /* 1785550 */     GIR_EraseRootFromParent_Done,
     /* 1785551 */   // Label 24258: @1785551
     /* 1785551 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1785637), // Rule ID 12082 //
     /* 1785556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1785567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1785576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785602 */     // MIs[0] policy
     /* 1785602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1785615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785636 */     // GIR_Coverage, 12082,
     /* 1785636 */     GIR_EraseRootFromParent_Done,
     /* 1785637 */   // Label 24259: @1785637
     /* 1785637 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1785723), // Rule ID 12083 //
     /* 1785642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1785653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1785662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785688 */     // MIs[0] policy
     /* 1785688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1785701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785722 */     // GIR_Coverage, 12083,
     /* 1785722 */     GIR_EraseRootFromParent_Done,
     /* 1785723 */   // Label 24260: @1785723
     /* 1785723 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1785809), // Rule ID 12086 //
     /* 1785728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1785739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1785742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1785745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1785748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785774 */     // MIs[0] policy
     /* 1785774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1785787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785808 */     // GIR_Coverage, 12086,
     /* 1785808 */     GIR_EraseRootFromParent_Done,
     /* 1785809 */   // Label 24261: @1785809
     /* 1785809 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1785895), // Rule ID 12087 //
     /* 1785814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1785825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1785828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1785831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1785834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785860 */     // MIs[0] policy
     /* 1785860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1785873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785894 */     // GIR_Coverage, 12087,
     /* 1785894 */     GIR_EraseRootFromParent_Done,
     /* 1785895 */   // Label 24262: @1785895
     /* 1785895 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1785981), // Rule ID 12090 //
     /* 1785900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1785911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1785914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1785917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1785920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785946 */     // MIs[0] policy
     /* 1785946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1785959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785980 */     // GIR_Coverage, 12090,
     /* 1785980 */     GIR_EraseRootFromParent_Done,
     /* 1785981 */   // Label 24263: @1785981
     /* 1785981 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1786067), // Rule ID 12091 //
     /* 1785986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1785997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1786000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1786003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1786006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786032 */     // MIs[0] policy
     /* 1786032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786042 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1786045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786066 */     // GIR_Coverage, 12091,
     /* 1786066 */     GIR_EraseRootFromParent_Done,
     /* 1786067 */   // Label 24264: @1786067
     /* 1786067 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1786153), // Rule ID 12094 //
     /* 1786072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1786083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1786086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1786089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1786092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786118 */     // MIs[0] policy
     /* 1786118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786128 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1786131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786152 */     // GIR_Coverage, 12094,
     /* 1786152 */     GIR_EraseRootFromParent_Done,
     /* 1786153 */   // Label 24265: @1786153
     /* 1786153 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1786239), // Rule ID 12095 //
     /* 1786158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1786169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1786172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1786175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1786178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786204 */     // MIs[0] policy
     /* 1786204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1786217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786238 */     // GIR_Coverage, 12095,
     /* 1786238 */     GIR_EraseRootFromParent_Done,
     /* 1786239 */   // Label 24266: @1786239
     /* 1786239 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1786325), // Rule ID 12098 //
     /* 1786244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1786255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1786258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1786261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786290 */     // MIs[0] policy
     /* 1786290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786300 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1786303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786324 */     // GIR_Coverage, 12098,
     /* 1786324 */     GIR_EraseRootFromParent_Done,
     /* 1786325 */   // Label 24267: @1786325
     /* 1786325 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1786411), // Rule ID 12099 //
     /* 1786330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1786341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1786344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1786347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786376 */     // MIs[0] policy
     /* 1786376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1786389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786410 */     // GIR_Coverage, 12099,
     /* 1786410 */     GIR_EraseRootFromParent_Done,
     /* 1786411 */   // Label 24268: @1786411
     /* 1786411 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1786497), // Rule ID 12102 //
     /* 1786416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1786427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1786430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1786433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786462 */     // MIs[0] policy
     /* 1786462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786472 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1786475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786496 */     // GIR_Coverage, 12102,
     /* 1786496 */     GIR_EraseRootFromParent_Done,
     /* 1786497 */   // Label 24269: @1786497
     /* 1786497 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1786583), // Rule ID 12103 //
     /* 1786502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1786513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1786516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1786519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786548 */     // MIs[0] policy
     /* 1786548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786558 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1786561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786582 */     // GIR_Coverage, 12103,
     /* 1786582 */     GIR_EraseRootFromParent_Done,
     /* 1786583 */   // Label 24270: @1786583
     /* 1786583 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1786669), // Rule ID 12106 //
     /* 1786588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786634 */     // MIs[0] policy
     /* 1786634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786644 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1786647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786668 */     // GIR_Coverage, 12106,
     /* 1786668 */     GIR_EraseRootFromParent_Done,
     /* 1786669 */   // Label 24271: @1786669
     /* 1786669 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1786755), // Rule ID 12107 //
     /* 1786674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786720 */     // MIs[0] policy
     /* 1786720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786730 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1786733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786754 */     // GIR_Coverage, 12107,
     /* 1786754 */     GIR_EraseRootFromParent_Done,
     /* 1786755 */   // Label 24272: @1786755
     /* 1786755 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1786841), // Rule ID 12110 //
     /* 1786760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1786771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1786774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1786777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786806 */     // MIs[0] policy
     /* 1786806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1786819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786840 */     // GIR_Coverage, 12110,
     /* 1786840 */     GIR_EraseRootFromParent_Done,
     /* 1786841 */   // Label 24273: @1786841
     /* 1786841 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1786927), // Rule ID 12111 //
     /* 1786846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1786857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1786860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1786863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1786866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786892 */     // MIs[0] policy
     /* 1786892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1786905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786926 */     // GIR_Coverage, 12111,
     /* 1786926 */     GIR_EraseRootFromParent_Done,
     /* 1786927 */   // Label 24274: @1786927
     /* 1786927 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1787013), // Rule ID 12114 //
     /* 1786932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1786943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1786946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1786949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1786952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1786974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786978 */     // MIs[0] policy
     /* 1786978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786988 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1786991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787012 */     // GIR_Coverage, 12114,
     /* 1787012 */     GIR_EraseRootFromParent_Done,
     /* 1787013 */   // Label 24275: @1787013
     /* 1787013 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1787099), // Rule ID 12115 //
     /* 1787018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1787029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1787032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1787035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787064 */     // MIs[0] policy
     /* 1787064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1787077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787098 */     // GIR_Coverage, 12115,
     /* 1787098 */     GIR_EraseRootFromParent_Done,
     /* 1787099 */   // Label 24276: @1787099
     /* 1787099 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1787185), // Rule ID 12118 //
     /* 1787104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1787115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1787118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1787121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787150 */     // MIs[0] policy
     /* 1787150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787160 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1787163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787184 */     // GIR_Coverage, 12118,
     /* 1787184 */     GIR_EraseRootFromParent_Done,
     /* 1787185 */   // Label 24277: @1787185
     /* 1787185 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1787271), // Rule ID 12119 //
     /* 1787190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1787201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1787204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1787207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787236 */     // MIs[0] policy
     /* 1787236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1787249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787270 */     // GIR_Coverage, 12119,
     /* 1787270 */     GIR_EraseRootFromParent_Done,
     /* 1787271 */   // Label 24278: @1787271
     /* 1787271 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1787357), // Rule ID 12122 //
     /* 1787276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1787287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1787290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1787293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787322 */     // MIs[0] policy
     /* 1787322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1787335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787356 */     // GIR_Coverage, 12122,
     /* 1787356 */     GIR_EraseRootFromParent_Done,
     /* 1787357 */   // Label 24279: @1787357
     /* 1787357 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1787443), // Rule ID 12123 //
     /* 1787362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1787373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1787376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1787379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787408 */     // MIs[0] policy
     /* 1787408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787418 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1787421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787442 */     // GIR_Coverage, 12123,
     /* 1787442 */     GIR_EraseRootFromParent_Done,
     /* 1787443 */   // Label 24280: @1787443
     /* 1787443 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1787529), // Rule ID 12126 //
     /* 1787448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1787459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1787462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1787465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787494 */     // MIs[0] policy
     /* 1787494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1787507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787528 */     // GIR_Coverage, 12126,
     /* 1787528 */     GIR_EraseRootFromParent_Done,
     /* 1787529 */   // Label 24281: @1787529
     /* 1787529 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1787615), // Rule ID 12127 //
     /* 1787534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1787545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1787548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1787551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787580 */     // MIs[0] policy
     /* 1787580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1787593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787614 */     // GIR_Coverage, 12127,
     /* 1787614 */     GIR_EraseRootFromParent_Done,
     /* 1787615 */   // Label 24282: @1787615
     /* 1787615 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1787701), // Rule ID 12130 //
     /* 1787620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1787631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1787634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1787637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787666 */     // MIs[0] policy
     /* 1787666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1787679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787700 */     // GIR_Coverage, 12130,
     /* 1787700 */     GIR_EraseRootFromParent_Done,
     /* 1787701 */   // Label 24283: @1787701
     /* 1787701 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1787787), // Rule ID 12131 //
     /* 1787706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1787717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1787720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1787723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787752 */     // MIs[0] policy
     /* 1787752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1787765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787786 */     // GIR_Coverage, 12131,
     /* 1787786 */     GIR_EraseRootFromParent_Done,
     /* 1787787 */   // Label 24284: @1787787
     /* 1787787 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1787873), // Rule ID 12134 //
     /* 1787792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1787795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1787803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1787806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1787809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787838 */     // MIs[0] policy
     /* 1787838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1787851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1787869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787872 */     // GIR_Coverage, 12134,
     /* 1787872 */     GIR_EraseRootFromParent_Done,
     /* 1787873 */   // Label 24285: @1787873
     /* 1787873 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1787959), // Rule ID 12135 //
     /* 1787878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1787881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1787889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1787892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1787895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1787898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1787920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787924 */     // MIs[0] policy
     /* 1787924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1787937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1787955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787958 */     // GIR_Coverage, 12135,
     /* 1787958 */     GIR_EraseRootFromParent_Done,
     /* 1787959 */   // Label 24286: @1787959
     /* 1787959 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1788045), // Rule ID 12138 //
     /* 1787964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1787975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1787978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1787981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1787984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788010 */     // MIs[0] policy
     /* 1788010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788020 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1788023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788044 */     // GIR_Coverage, 12138,
     /* 1788044 */     GIR_EraseRootFromParent_Done,
     /* 1788045 */   // Label 24287: @1788045
     /* 1788045 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1788131), // Rule ID 12139 //
     /* 1788050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1788061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1788064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1788067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788096 */     // MIs[0] policy
     /* 1788096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1788109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788130 */     // GIR_Coverage, 12139,
     /* 1788130 */     GIR_EraseRootFromParent_Done,
     /* 1788131 */   // Label 24288: @1788131
     /* 1788131 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1788217), // Rule ID 12142 //
     /* 1788136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1788147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1788150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1788153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788182 */     // MIs[0] policy
     /* 1788182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1788195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788216 */     // GIR_Coverage, 12142,
     /* 1788216 */     GIR_EraseRootFromParent_Done,
     /* 1788217 */   // Label 24289: @1788217
     /* 1788217 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1788303), // Rule ID 12143 //
     /* 1788222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1788233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1788236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1788239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788268 */     // MIs[0] policy
     /* 1788268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788278 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1788281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788302 */     // GIR_Coverage, 12143,
     /* 1788302 */     GIR_EraseRootFromParent_Done,
     /* 1788303 */   // Label 24290: @1788303
     /* 1788303 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1788389), // Rule ID 12146 //
     /* 1788308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1788319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1788322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1788325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1788331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788354 */     // MIs[0] policy
     /* 1788354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788364 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1788367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788388 */     // GIR_Coverage, 12146,
     /* 1788388 */     GIR_EraseRootFromParent_Done,
     /* 1788389 */   // Label 24291: @1788389
     /* 1788389 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1788475), // Rule ID 12147 //
     /* 1788394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1788405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1788408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1788411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1788417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788440 */     // MIs[0] policy
     /* 1788440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788450 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1788453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788474 */     // GIR_Coverage, 12147,
     /* 1788474 */     GIR_EraseRootFromParent_Done,
     /* 1788475 */   // Label 24292: @1788475
     /* 1788475 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1788561), // Rule ID 12150 //
     /* 1788480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1788491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1788494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1788497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788526 */     // MIs[0] policy
     /* 1788526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788536 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1788539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788560 */     // GIR_Coverage, 12150,
     /* 1788560 */     GIR_EraseRootFromParent_Done,
     /* 1788561 */   // Label 24293: @1788561
     /* 1788561 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1788647), // Rule ID 12151 //
     /* 1788566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1788577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1788580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1788583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788612 */     // MIs[0] policy
     /* 1788612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788622 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1788625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788646 */     // GIR_Coverage, 12151,
     /* 1788646 */     GIR_EraseRootFromParent_Done,
     /* 1788647 */   // Label 24294: @1788647
     /* 1788647 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1788733), // Rule ID 12154 //
     /* 1788652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1788663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1788666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1788669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788698 */     // MIs[0] policy
     /* 1788698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1788711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788732 */     // GIR_Coverage, 12154,
     /* 1788732 */     GIR_EraseRootFromParent_Done,
     /* 1788733 */   // Label 24295: @1788733
     /* 1788733 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1788819), // Rule ID 12155 //
     /* 1788738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1788749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1788752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1788755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788784 */     // MIs[0] policy
     /* 1788784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1788797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788818 */     // GIR_Coverage, 12155,
     /* 1788818 */     GIR_EraseRootFromParent_Done,
     /* 1788819 */   // Label 24296: @1788819
     /* 1788819 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1788905), // Rule ID 12158 //
     /* 1788824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1788835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1788838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1788841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788870 */     // MIs[0] policy
     /* 1788870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788880 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1788883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788904 */     // GIR_Coverage, 12158,
     /* 1788904 */     GIR_EraseRootFromParent_Done,
     /* 1788905 */   // Label 24297: @1788905
     /* 1788905 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1788991), // Rule ID 12159 //
     /* 1788910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1788921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1788924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1788927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788956 */     // MIs[0] policy
     /* 1788956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788966 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1788969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788990 */     // GIR_Coverage, 12159,
     /* 1788990 */     GIR_EraseRootFromParent_Done,
     /* 1788991 */   // Label 24298: @1788991
     /* 1788991 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1789077), // Rule ID 12162 //
     /* 1788996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1789007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1789010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1789013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789042 */     // MIs[0] policy
     /* 1789042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1789055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789076 */     // GIR_Coverage, 12162,
     /* 1789076 */     GIR_EraseRootFromParent_Done,
     /* 1789077 */   // Label 24299: @1789077
     /* 1789077 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1789163), // Rule ID 12163 //
     /* 1789082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1789093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1789096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1789099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789128 */     // MIs[0] policy
     /* 1789128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1789141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789162 */     // GIR_Coverage, 12163,
     /* 1789162 */     GIR_EraseRootFromParent_Done,
     /* 1789163 */   // Label 24300: @1789163
     /* 1789163 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1789249), // Rule ID 12166 //
     /* 1789168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1789179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1789182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1789185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789214 */     // MIs[0] policy
     /* 1789214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1789227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789248 */     // GIR_Coverage, 12166,
     /* 1789248 */     GIR_EraseRootFromParent_Done,
     /* 1789249 */   // Label 24301: @1789249
     /* 1789249 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1789335), // Rule ID 12167 //
     /* 1789254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1789265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1789268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1789271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789300 */     // MIs[0] policy
     /* 1789300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1789313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789334 */     // GIR_Coverage, 12167,
     /* 1789334 */     GIR_EraseRootFromParent_Done,
     /* 1789335 */   // Label 24302: @1789335
     /* 1789335 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1789421), // Rule ID 12170 //
     /* 1789340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1789351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1789354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1789357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789386 */     // MIs[0] policy
     /* 1789386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1789399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789420 */     // GIR_Coverage, 12170,
     /* 1789420 */     GIR_EraseRootFromParent_Done,
     /* 1789421 */   // Label 24303: @1789421
     /* 1789421 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1789507), // Rule ID 12171 //
     /* 1789426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1789437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1789440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1789443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1789449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789472 */     // MIs[0] policy
     /* 1789472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1789485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789506 */     // GIR_Coverage, 12171,
     /* 1789506 */     GIR_EraseRootFromParent_Done,
     /* 1789507 */   // Label 24304: @1789507
     /* 1789507 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1789593), // Rule ID 12174 //
     /* 1789512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1789523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1789526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1789529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789558 */     // MIs[0] policy
     /* 1789558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1789571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789592 */     // GIR_Coverage, 12174,
     /* 1789592 */     GIR_EraseRootFromParent_Done,
     /* 1789593 */   // Label 24305: @1789593
     /* 1789593 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1789679), // Rule ID 12175 //
     /* 1789598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1789609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1789612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1789615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789644 */     // MIs[0] policy
     /* 1789644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1789657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789678 */     // GIR_Coverage, 12175,
     /* 1789678 */     GIR_EraseRootFromParent_Done,
     /* 1789679 */   // Label 24306: @1789679
     /* 1789679 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1789765), // Rule ID 12178 //
     /* 1789684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1789695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1789698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1789701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789730 */     // MIs[0] policy
     /* 1789730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1789743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789764 */     // GIR_Coverage, 12178,
     /* 1789764 */     GIR_EraseRootFromParent_Done,
     /* 1789765 */   // Label 24307: @1789765
     /* 1789765 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1789851), // Rule ID 12179 //
     /* 1789770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1789781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1789784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1789787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789816 */     // MIs[0] policy
     /* 1789816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1789829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789850 */     // GIR_Coverage, 12179,
     /* 1789850 */     GIR_EraseRootFromParent_Done,
     /* 1789851 */   // Label 24308: @1789851
     /* 1789851 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1789937), // Rule ID 12182 //
     /* 1789856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1789867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1789870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1789873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789902 */     // MIs[0] policy
     /* 1789902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1789915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789936 */     // GIR_Coverage, 12182,
     /* 1789936 */     GIR_EraseRootFromParent_Done,
     /* 1789937 */   // Label 24309: @1789937
     /* 1789937 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1790023), // Rule ID 12183 //
     /* 1789942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1789953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1789956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1789959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789988 */     // MIs[0] policy
     /* 1789988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789998 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1790001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790022 */     // GIR_Coverage, 12183,
     /* 1790022 */     GIR_EraseRootFromParent_Done,
     /* 1790023 */   // Label 24310: @1790023
     /* 1790023 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1790109), // Rule ID 12186 //
     /* 1790028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1790039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1790042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1790045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1790048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790074 */     // MIs[0] policy
     /* 1790074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1790087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790108 */     // GIR_Coverage, 12186,
     /* 1790108 */     GIR_EraseRootFromParent_Done,
     /* 1790109 */   // Label 24311: @1790109
     /* 1790109 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1790195), // Rule ID 12187 //
     /* 1790114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1790125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1790128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1790131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1790134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790160 */     // MIs[0] policy
     /* 1790160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790170 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1790173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790194 */     // GIR_Coverage, 12187,
     /* 1790194 */     GIR_EraseRootFromParent_Done,
     /* 1790195 */   // Label 24312: @1790195
     /* 1790195 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1790281), // Rule ID 12190 //
     /* 1790200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1790211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1790214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1790217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1790220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790246 */     // MIs[0] policy
     /* 1790246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790256 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1790259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790280 */     // GIR_Coverage, 12190,
     /* 1790280 */     GIR_EraseRootFromParent_Done,
     /* 1790281 */   // Label 24313: @1790281
     /* 1790281 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1790367), // Rule ID 12191 //
     /* 1790286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1790297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1790300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1790303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1790306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790332 */     // MIs[0] policy
     /* 1790332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790342 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1790345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790366 */     // GIR_Coverage, 12191,
     /* 1790366 */     GIR_EraseRootFromParent_Done,
     /* 1790367 */   // Label 24314: @1790367
     /* 1790367 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1790453), // Rule ID 12194 //
     /* 1790372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1790383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1790386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1790389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1790392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790418 */     // MIs[0] policy
     /* 1790418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790428 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1790431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790452 */     // GIR_Coverage, 12194,
     /* 1790452 */     GIR_EraseRootFromParent_Done,
     /* 1790453 */   // Label 24315: @1790453
     /* 1790453 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1790539), // Rule ID 12195 //
     /* 1790458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1790469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1790472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1790475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1790478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790504 */     // MIs[0] policy
     /* 1790504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790514 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1790517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790538 */     // GIR_Coverage, 12195,
     /* 1790538 */     GIR_EraseRootFromParent_Done,
     /* 1790539 */   // Label 24316: @1790539
     /* 1790539 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1790625), // Rule ID 12198 //
     /* 1790544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1790555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1790558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1790561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1790564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790590 */     // MIs[0] policy
     /* 1790590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790600 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1790603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790624 */     // GIR_Coverage, 12198,
     /* 1790624 */     GIR_EraseRootFromParent_Done,
     /* 1790625 */   // Label 24317: @1790625
     /* 1790625 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1790711), // Rule ID 12199 //
     /* 1790630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1790641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1790644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1790647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1790650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790676 */     // MIs[0] policy
     /* 1790676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1790689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790710 */     // GIR_Coverage, 12199,
     /* 1790710 */     GIR_EraseRootFromParent_Done,
     /* 1790711 */   // Label 24318: @1790711
     /* 1790711 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1790797), // Rule ID 12202 //
     /* 1790716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1790727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1790730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1790733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1790736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790762 */     // MIs[0] policy
     /* 1790762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1790775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790796 */     // GIR_Coverage, 12202,
     /* 1790796 */     GIR_EraseRootFromParent_Done,
     /* 1790797 */   // Label 24319: @1790797
     /* 1790797 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1790883), // Rule ID 12203 //
     /* 1790802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1790813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1790816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1790819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1790822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790848 */     // MIs[0] policy
     /* 1790848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790858 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1790861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790882 */     // GIR_Coverage, 12203,
     /* 1790882 */     GIR_EraseRootFromParent_Done,
     /* 1790883 */   // Label 24320: @1790883
     /* 1790883 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1790969), // Rule ID 12206 //
     /* 1790888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1790899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1790902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1790905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1790908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790934 */     // MIs[0] policy
     /* 1790934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1790947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790968 */     // GIR_Coverage, 12206,
     /* 1790968 */     GIR_EraseRootFromParent_Done,
     /* 1790969 */   // Label 24321: @1790969
     /* 1790969 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1791055), // Rule ID 12207 //
     /* 1790974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1790985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1790988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1790991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1790994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791020 */     // MIs[0] policy
     /* 1791020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1791033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791054 */     // GIR_Coverage, 12207,
     /* 1791054 */     GIR_EraseRootFromParent_Done,
     /* 1791055 */   // Label 24322: @1791055
     /* 1791055 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1791141), // Rule ID 12210 //
     /* 1791060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1791071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1791074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1791077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1791080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791106 */     // MIs[0] policy
     /* 1791106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791116 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1791119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791140 */     // GIR_Coverage, 12210,
     /* 1791140 */     GIR_EraseRootFromParent_Done,
     /* 1791141 */   // Label 24323: @1791141
     /* 1791141 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1791227), // Rule ID 12211 //
     /* 1791146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1791157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1791160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1791163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1791166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791192 */     // MIs[0] policy
     /* 1791192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1791205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791226 */     // GIR_Coverage, 12211,
     /* 1791226 */     GIR_EraseRootFromParent_Done,
     /* 1791227 */   // Label 24324: @1791227
     /* 1791227 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1791313), // Rule ID 12214 //
     /* 1791232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1791243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1791246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1791249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1791252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791278 */     // MIs[0] policy
     /* 1791278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1791291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791312 */     // GIR_Coverage, 12214,
     /* 1791312 */     GIR_EraseRootFromParent_Done,
     /* 1791313 */   // Label 24325: @1791313
     /* 1791313 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1791399), // Rule ID 12215 //
     /* 1791318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1791329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1791332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1791335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1791338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791364 */     // MIs[0] policy
     /* 1791364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1791377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791398 */     // GIR_Coverage, 12215,
     /* 1791398 */     GIR_EraseRootFromParent_Done,
     /* 1791399 */   // Label 24326: @1791399
     /* 1791399 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1791485), // Rule ID 12218 //
     /* 1791404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1791415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1791418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1791421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1791424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791450 */     // MIs[0] policy
     /* 1791450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1791463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791484 */     // GIR_Coverage, 12218,
     /* 1791484 */     GIR_EraseRootFromParent_Done,
     /* 1791485 */   // Label 24327: @1791485
     /* 1791485 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1791571), // Rule ID 12219 //
     /* 1791490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1791501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1791504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1791507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1791510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791536 */     // MIs[0] policy
     /* 1791536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1791549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791570 */     // GIR_Coverage, 12219,
     /* 1791570 */     GIR_EraseRootFromParent_Done,
     /* 1791571 */   // Label 24328: @1791571
     /* 1791571 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1791657), // Rule ID 12222 //
     /* 1791576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1791587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1791590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1791593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1791596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791622 */     // MIs[0] policy
     /* 1791622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1791635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791656 */     // GIR_Coverage, 12222,
     /* 1791656 */     GIR_EraseRootFromParent_Done,
     /* 1791657 */   // Label 24329: @1791657
     /* 1791657 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1791743), // Rule ID 12223 //
     /* 1791662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1791665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1791673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1791676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1791679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1791682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791708 */     // MIs[0] policy
     /* 1791708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1791721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791742 */     // GIR_Coverage, 12223,
     /* 1791742 */     GIR_EraseRootFromParent_Done,
     /* 1791743 */   // Label 24330: @1791743
     /* 1791743 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1791829), // Rule ID 12226 //
     /* 1791748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1791759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1791762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1791765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1791768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791794 */     // MIs[0] policy
     /* 1791794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791804 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1791807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791828 */     // GIR_Coverage, 12226,
     /* 1791828 */     GIR_EraseRootFromParent_Done,
     /* 1791829 */   // Label 24331: @1791829
     /* 1791829 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1791915), // Rule ID 12227 //
     /* 1791834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1791845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1791848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1791851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1791854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791880 */     // MIs[0] policy
     /* 1791880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791890 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1791893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791914 */     // GIR_Coverage, 12227,
     /* 1791914 */     GIR_EraseRootFromParent_Done,
     /* 1791915 */   // Label 24332: @1791915
     /* 1791915 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1792001), // Rule ID 12230 //
     /* 1791920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1791931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1791934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1791937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1791940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791966 */     // MIs[0] policy
     /* 1791966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791976 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1791979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792000 */     // GIR_Coverage, 12230,
     /* 1792000 */     GIR_EraseRootFromParent_Done,
     /* 1792001 */   // Label 24333: @1792001
     /* 1792001 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1792087), // Rule ID 12231 //
     /* 1792006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1792017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1792020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1792023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1792026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792052 */     // MIs[0] policy
     /* 1792052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792062 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1792065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792086 */     // GIR_Coverage, 12231,
     /* 1792086 */     GIR_EraseRootFromParent_Done,
     /* 1792087 */   // Label 24334: @1792087
     /* 1792087 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1792173), // Rule ID 12234 //
     /* 1792092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1792103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1792106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1792109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1792112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1792115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792138 */     // MIs[0] policy
     /* 1792138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792148 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1792151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792172 */     // GIR_Coverage, 12234,
     /* 1792172 */     GIR_EraseRootFromParent_Done,
     /* 1792173 */   // Label 24335: @1792173
     /* 1792173 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1792259), // Rule ID 12235 //
     /* 1792178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1792189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1792192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1792195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1792198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1792201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792224 */     // MIs[0] policy
     /* 1792224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792234 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1792237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792258 */     // GIR_Coverage, 12235,
     /* 1792258 */     GIR_EraseRootFromParent_Done,
     /* 1792259 */   // Label 24336: @1792259
     /* 1792259 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1792345), // Rule ID 12238 //
     /* 1792264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1792275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1792278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1792281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1792284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792310 */     // MIs[0] policy
     /* 1792310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1792323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792344 */     // GIR_Coverage, 12238,
     /* 1792344 */     GIR_EraseRootFromParent_Done,
     /* 1792345 */   // Label 24337: @1792345
     /* 1792345 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1792431), // Rule ID 12239 //
     /* 1792350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1792361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1792364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1792367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1792370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792396 */     // MIs[0] policy
     /* 1792396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792406 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1792409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792430 */     // GIR_Coverage, 12239,
     /* 1792430 */     GIR_EraseRootFromParent_Done,
     /* 1792431 */   // Label 24338: @1792431
     /* 1792431 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1792517), // Rule ID 12242 //
     /* 1792436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1792447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1792450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1792453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1792456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792482 */     // MIs[0] policy
     /* 1792482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1792495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792516 */     // GIR_Coverage, 12242,
     /* 1792516 */     GIR_EraseRootFromParent_Done,
     /* 1792517 */   // Label 24339: @1792517
     /* 1792517 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1792603), // Rule ID 12243 //
     /* 1792522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1792533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1792536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1792539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1792542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792568 */     // MIs[0] policy
     /* 1792568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792578 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1792581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792602 */     // GIR_Coverage, 12243,
     /* 1792602 */     GIR_EraseRootFromParent_Done,
     /* 1792603 */   // Label 24340: @1792603
     /* 1792603 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1792689), // Rule ID 12246 //
     /* 1792608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1792619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1792622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1792625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1792628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792654 */     // MIs[0] policy
     /* 1792654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792664 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1792667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792688 */     // GIR_Coverage, 12246,
     /* 1792688 */     GIR_EraseRootFromParent_Done,
     /* 1792689 */   // Label 24341: @1792689
     /* 1792689 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1792775), // Rule ID 12247 //
     /* 1792694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1792705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1792708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1792711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1792714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792740 */     // MIs[0] policy
     /* 1792740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1792753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792774 */     // GIR_Coverage, 12247,
     /* 1792774 */     GIR_EraseRootFromParent_Done,
     /* 1792775 */   // Label 24342: @1792775
     /* 1792775 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1792861), // Rule ID 12250 //
     /* 1792780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1792791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1792794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1792797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1792800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792826 */     // MIs[0] policy
     /* 1792826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1792839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792860 */     // GIR_Coverage, 12250,
     /* 1792860 */     GIR_EraseRootFromParent_Done,
     /* 1792861 */   // Label 24343: @1792861
     /* 1792861 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1792947), // Rule ID 12251 //
     /* 1792866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1792877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1792880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1792883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1792886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792912 */     // MIs[0] policy
     /* 1792912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1792925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792946 */     // GIR_Coverage, 12251,
     /* 1792946 */     GIR_EraseRootFromParent_Done,
     /* 1792947 */   // Label 24344: @1792947
     /* 1792947 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1793033), // Rule ID 12254 //
     /* 1792952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1792963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1792966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1792969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1792972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792998 */     // MIs[0] policy
     /* 1792998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1793011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793032 */     // GIR_Coverage, 12254,
     /* 1793032 */     GIR_EraseRootFromParent_Done,
     /* 1793033 */   // Label 24345: @1793033
     /* 1793033 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1793119), // Rule ID 12255 //
     /* 1793038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1793049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1793052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1793055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1793058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793084 */     // MIs[0] policy
     /* 1793084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1793097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793118 */     // GIR_Coverage, 12255,
     /* 1793118 */     GIR_EraseRootFromParent_Done,
     /* 1793119 */   // Label 24346: @1793119
     /* 1793119 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1793205), // Rule ID 12258 //
     /* 1793124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1793135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1793138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1793141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1793144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793170 */     // MIs[0] policy
     /* 1793170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1793183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793204 */     // GIR_Coverage, 12258,
     /* 1793204 */     GIR_EraseRootFromParent_Done,
     /* 1793205 */   // Label 24347: @1793205
     /* 1793205 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1793291), // Rule ID 12259 //
     /* 1793210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1793221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1793224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1793227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1793230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793256 */     // MIs[0] policy
     /* 1793256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1793269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793290 */     // GIR_Coverage, 12259,
     /* 1793290 */     GIR_EraseRootFromParent_Done,
     /* 1793291 */   // Label 24348: @1793291
     /* 1793291 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1793377), // Rule ID 12262 //
     /* 1793296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1793307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1793310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1793313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1793316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793342 */     // MIs[0] policy
     /* 1793342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1793355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793376 */     // GIR_Coverage, 12262,
     /* 1793376 */     GIR_EraseRootFromParent_Done,
     /* 1793377 */   // Label 24349: @1793377
     /* 1793377 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1793463), // Rule ID 12263 //
     /* 1793382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1793393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1793396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1793399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1793402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793428 */     // MIs[0] policy
     /* 1793428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1793441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793462 */     // GIR_Coverage, 12263,
     /* 1793462 */     GIR_EraseRootFromParent_Done,
     /* 1793463 */   // Label 24350: @1793463
     /* 1793463 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1793549), // Rule ID 12266 //
     /* 1793468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1793479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1793482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1793485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1793488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793514 */     // MIs[0] policy
     /* 1793514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793524 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1793527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793548 */     // GIR_Coverage, 12266,
     /* 1793548 */     GIR_EraseRootFromParent_Done,
     /* 1793549 */   // Label 24351: @1793549
     /* 1793549 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1793635), // Rule ID 12267 //
     /* 1793554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1793565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1793568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1793571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1793574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793600 */     // MIs[0] policy
     /* 1793600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793610 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1793613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793634 */     // GIR_Coverage, 12267,
     /* 1793634 */     GIR_EraseRootFromParent_Done,
     /* 1793635 */   // Label 24352: @1793635
     /* 1793635 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1793721), // Rule ID 12270 //
     /* 1793640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1793651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1793654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1793657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1793660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793686 */     // MIs[0] policy
     /* 1793686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793696 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1793699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793720 */     // GIR_Coverage, 12270,
     /* 1793720 */     GIR_EraseRootFromParent_Done,
     /* 1793721 */   // Label 24353: @1793721
     /* 1793721 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1793807), // Rule ID 12271 //
     /* 1793726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1793737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1793740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1793743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1793746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793772 */     // MIs[0] policy
     /* 1793772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793782 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1793785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793806 */     // GIR_Coverage, 12271,
     /* 1793806 */     GIR_EraseRootFromParent_Done,
     /* 1793807 */   // Label 24354: @1793807
     /* 1793807 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1793893), // Rule ID 12274 //
     /* 1793812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1793823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1793826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1793829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793858 */     // MIs[0] policy
     /* 1793858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1793871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793892 */     // GIR_Coverage, 12274,
     /* 1793892 */     GIR_EraseRootFromParent_Done,
     /* 1793893 */   // Label 24355: @1793893
     /* 1793893 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1793979), // Rule ID 12275 //
     /* 1793898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1793909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1793912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1793915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793944 */     // MIs[0] policy
     /* 1793944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1793957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793978 */     // GIR_Coverage, 12275,
     /* 1793978 */     GIR_EraseRootFromParent_Done,
     /* 1793979 */   // Label 24356: @1793979
     /* 1793979 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1794065), // Rule ID 12278 //
     /* 1793984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1793995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1793998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1794001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794030 */     // MIs[0] policy
     /* 1794030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794040 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1794043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794064 */     // GIR_Coverage, 12278,
     /* 1794064 */     GIR_EraseRootFromParent_Done,
     /* 1794065 */   // Label 24357: @1794065
     /* 1794065 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1794151), // Rule ID 12279 //
     /* 1794070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1794081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1794084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1794087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794116 */     // MIs[0] policy
     /* 1794116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1794129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794150 */     // GIR_Coverage, 12279,
     /* 1794150 */     GIR_EraseRootFromParent_Done,
     /* 1794151 */   // Label 24358: @1794151
     /* 1794151 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1794237), // Rule ID 12282 //
     /* 1794156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1794167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1794170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1794173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794202 */     // MIs[0] policy
     /* 1794202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1794215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794236 */     // GIR_Coverage, 12282,
     /* 1794236 */     GIR_EraseRootFromParent_Done,
     /* 1794237 */   // Label 24359: @1794237
     /* 1794237 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1794323), // Rule ID 12283 //
     /* 1794242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1794253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1794256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1794259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794288 */     // MIs[0] policy
     /* 1794288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794298 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1794301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794322 */     // GIR_Coverage, 12283,
     /* 1794322 */     GIR_EraseRootFromParent_Done,
     /* 1794323 */   // Label 24360: @1794323
     /* 1794323 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1794409), // Rule ID 12286 //
     /* 1794328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1794339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1794342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794374 */     // MIs[0] policy
     /* 1794374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794384 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1794387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794408 */     // GIR_Coverage, 12286,
     /* 1794408 */     GIR_EraseRootFromParent_Done,
     /* 1794409 */   // Label 24361: @1794409
     /* 1794409 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1794495), // Rule ID 12287 //
     /* 1794414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1794425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1794428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794460 */     // MIs[0] policy
     /* 1794460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1794473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794494 */     // GIR_Coverage, 12287,
     /* 1794494 */     GIR_EraseRootFromParent_Done,
     /* 1794495 */   // Label 24362: @1794495
     /* 1794495 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1794581), // Rule ID 12290 //
     /* 1794500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1794511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1794514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794546 */     // MIs[0] policy
     /* 1794546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1794559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794580 */     // GIR_Coverage, 12290,
     /* 1794580 */     GIR_EraseRootFromParent_Done,
     /* 1794581 */   // Label 24363: @1794581
     /* 1794581 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1794667), // Rule ID 12291 //
     /* 1794586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1794597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1794600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794632 */     // MIs[0] policy
     /* 1794632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1794645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794666 */     // GIR_Coverage, 12291,
     /* 1794666 */     GIR_EraseRootFromParent_Done,
     /* 1794667 */   // Label 24364: @1794667
     /* 1794667 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1794753), // Rule ID 12294 //
     /* 1794672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1794689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794718 */     // MIs[0] policy
     /* 1794718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1794731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794752 */     // GIR_Coverage, 12294,
     /* 1794752 */     GIR_EraseRootFromParent_Done,
     /* 1794753 */   // Label 24365: @1794753
     /* 1794753 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1794839), // Rule ID 12295 //
     /* 1794758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1794775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794804 */     // MIs[0] policy
     /* 1794804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1794817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1794835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794838 */     // GIR_Coverage, 12295,
     /* 1794838 */     GIR_EraseRootFromParent_Done,
     /* 1794839 */   // Label 24366: @1794839
     /* 1794839 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1794925), // Rule ID 12298 //
     /* 1794844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1794855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1794858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1794861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1794864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794890 */     // MIs[0] policy
     /* 1794890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1794903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794924 */     // GIR_Coverage, 12298,
     /* 1794924 */     GIR_EraseRootFromParent_Done,
     /* 1794925 */   // Label 24367: @1794925
     /* 1794925 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1795011), // Rule ID 12299 //
     /* 1794930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1794941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1794944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1794947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1794950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1794972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794976 */     // MIs[0] policy
     /* 1794976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1794989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795010 */     // GIR_Coverage, 12299,
     /* 1795010 */     GIR_EraseRootFromParent_Done,
     /* 1795011 */   // Label 24368: @1795011
     /* 1795011 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1795097), // Rule ID 12302 //
     /* 1795016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1795027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1795030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1795033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795062 */     // MIs[0] policy
     /* 1795062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1795075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795096 */     // GIR_Coverage, 12302,
     /* 1795096 */     GIR_EraseRootFromParent_Done,
     /* 1795097 */   // Label 24369: @1795097
     /* 1795097 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1795183), // Rule ID 12303 //
     /* 1795102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1795113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1795116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1795119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795148 */     // MIs[0] policy
     /* 1795148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1795161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795182 */     // GIR_Coverage, 12303,
     /* 1795182 */     GIR_EraseRootFromParent_Done,
     /* 1795183 */   // Label 24370: @1795183
     /* 1795183 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1795269), // Rule ID 12306 //
     /* 1795188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1795199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1795202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795234 */     // MIs[0] policy
     /* 1795234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1795247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795268 */     // GIR_Coverage, 12306,
     /* 1795268 */     GIR_EraseRootFromParent_Done,
     /* 1795269 */   // Label 24371: @1795269
     /* 1795269 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1795355), // Rule ID 12307 //
     /* 1795274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1795285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1795288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795320 */     // MIs[0] policy
     /* 1795320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1795333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795354 */     // GIR_Coverage, 12307,
     /* 1795354 */     GIR_EraseRootFromParent_Done,
     /* 1795355 */   // Label 24372: @1795355
     /* 1795355 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1795441), // Rule ID 12310 //
     /* 1795360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1795377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795406 */     // MIs[0] policy
     /* 1795406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1795419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795440 */     // GIR_Coverage, 12310,
     /* 1795440 */     GIR_EraseRootFromParent_Done,
     /* 1795441 */   // Label 24373: @1795441
     /* 1795441 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1795527), // Rule ID 12311 //
     /* 1795446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1795463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795492 */     // MIs[0] policy
     /* 1795492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1795505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795526 */     // GIR_Coverage, 12311,
     /* 1795526 */     GIR_EraseRootFromParent_Done,
     /* 1795527 */   // Label 24374: @1795527
     /* 1795527 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1795613), // Rule ID 12314 //
     /* 1795532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1795543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1795546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1795549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795578 */     // MIs[0] policy
     /* 1795578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1795591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795612 */     // GIR_Coverage, 12314,
     /* 1795612 */     GIR_EraseRootFromParent_Done,
     /* 1795613 */   // Label 24375: @1795613
     /* 1795613 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1795699), // Rule ID 12315 //
     /* 1795618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1795629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1795632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1795635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795664 */     // MIs[0] policy
     /* 1795664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1795677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795698 */     // GIR_Coverage, 12315,
     /* 1795698 */     GIR_EraseRootFromParent_Done,
     /* 1795699 */   // Label 24376: @1795699
     /* 1795699 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1795785), // Rule ID 12318 //
     /* 1795704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1795715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1795718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1795721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795750 */     // MIs[0] policy
     /* 1795750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795760 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1795763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795784 */     // GIR_Coverage, 12318,
     /* 1795784 */     GIR_EraseRootFromParent_Done,
     /* 1795785 */   // Label 24377: @1795785
     /* 1795785 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1795871), // Rule ID 12319 //
     /* 1795790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1795801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1795804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1795807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1795813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795836 */     // MIs[0] policy
     /* 1795836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1795849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795870 */     // GIR_Coverage, 12319,
     /* 1795870 */     GIR_EraseRootFromParent_Done,
     /* 1795871 */   // Label 24378: @1795871
     /* 1795871 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1795957), // Rule ID 12322 //
     /* 1795876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1795887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1795890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1795893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1795899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795922 */     // MIs[0] policy
     /* 1795922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795932 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1795935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795956 */     // GIR_Coverage, 12322,
     /* 1795956 */     GIR_EraseRootFromParent_Done,
     /* 1795957 */   // Label 24379: @1795957
     /* 1795957 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1796043), // Rule ID 12323 //
     /* 1795962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1795973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1795976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1795979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1795985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796008 */     // MIs[0] policy
     /* 1796008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796018 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1796021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796042 */     // GIR_Coverage, 12323,
     /* 1796042 */     GIR_EraseRootFromParent_Done,
     /* 1796043 */   // Label 24380: @1796043
     /* 1796043 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1796129), // Rule ID 12326 //
     /* 1796048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1796059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1796062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1796065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796094 */     // MIs[0] policy
     /* 1796094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1796107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796128 */     // GIR_Coverage, 12326,
     /* 1796128 */     GIR_EraseRootFromParent_Done,
     /* 1796129 */   // Label 24381: @1796129
     /* 1796129 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1796215), // Rule ID 12327 //
     /* 1796134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1796145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1796148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1796151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796180 */     // MIs[0] policy
     /* 1796180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1796193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796214 */     // GIR_Coverage, 12327,
     /* 1796214 */     GIR_EraseRootFromParent_Done,
     /* 1796215 */   // Label 24382: @1796215
     /* 1796215 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1796301), // Rule ID 12330 //
     /* 1796220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1796231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1796234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1796237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796266 */     // MIs[0] policy
     /* 1796266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1796279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796300 */     // GIR_Coverage, 12330,
     /* 1796300 */     GIR_EraseRootFromParent_Done,
     /* 1796301 */   // Label 24383: @1796301
     /* 1796301 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1796387), // Rule ID 12331 //
     /* 1796306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1796317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1796320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1796323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796352 */     // MIs[0] policy
     /* 1796352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796362 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1796365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796386 */     // GIR_Coverage, 12331,
     /* 1796386 */     GIR_EraseRootFromParent_Done,
     /* 1796387 */   // Label 24384: @1796387
     /* 1796387 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1796473), // Rule ID 12334 //
     /* 1796392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1796403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1796406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1796409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1796415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796438 */     // MIs[0] policy
     /* 1796438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796448 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1796451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796472 */     // GIR_Coverage, 12334,
     /* 1796472 */     GIR_EraseRootFromParent_Done,
     /* 1796473 */   // Label 24385: @1796473
     /* 1796473 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1796559), // Rule ID 12335 //
     /* 1796478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1796489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1796492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1796495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1796501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796524 */     // MIs[0] policy
     /* 1796524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1796537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796558 */     // GIR_Coverage, 12335,
     /* 1796558 */     GIR_EraseRootFromParent_Done,
     /* 1796559 */   // Label 24386: @1796559
     /* 1796559 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1796645), // Rule ID 12338 //
     /* 1796564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1796575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1796578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1796581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796610 */     // MIs[0] policy
     /* 1796610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1796623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796644 */     // GIR_Coverage, 12338,
     /* 1796644 */     GIR_EraseRootFromParent_Done,
     /* 1796645 */   // Label 24387: @1796645
     /* 1796645 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1796731), // Rule ID 12339 //
     /* 1796650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1796661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1796664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1796667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796696 */     // MIs[0] policy
     /* 1796696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1796709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796730 */     // GIR_Coverage, 12339,
     /* 1796730 */     GIR_EraseRootFromParent_Done,
     /* 1796731 */   // Label 24388: @1796731
     /* 1796731 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1796817), // Rule ID 12342 //
     /* 1796736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1796747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1796750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1796753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796782 */     // MIs[0] policy
     /* 1796782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796792 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1796795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796816 */     // GIR_Coverage, 12342,
     /* 1796816 */     GIR_EraseRootFromParent_Done,
     /* 1796817 */   // Label 24389: @1796817
     /* 1796817 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1796903), // Rule ID 12343 //
     /* 1796822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1796833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1796836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1796839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796868 */     // MIs[0] policy
     /* 1796868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1796881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796902 */     // GIR_Coverage, 12343,
     /* 1796902 */     GIR_EraseRootFromParent_Done,
     /* 1796903 */   // Label 24390: @1796903
     /* 1796903 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1796989), // Rule ID 12346 //
     /* 1796908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1796919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1796922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1796925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796954 */     // MIs[0] policy
     /* 1796954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1796967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796988 */     // GIR_Coverage, 12346,
     /* 1796988 */     GIR_EraseRootFromParent_Done,
     /* 1796989 */   // Label 24391: @1796989
     /* 1796989 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1797075), // Rule ID 12347 //
     /* 1796994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1797005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1797008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1797011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1797024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797040 */     // MIs[0] policy
     /* 1797040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1797053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797074 */     // GIR_Coverage, 12347,
     /* 1797074 */     GIR_EraseRootFromParent_Done,
     /* 1797075 */   // Label 24392: @1797075
     /* 1797075 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1797161), // Rule ID 12350 //
     /* 1797080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1797091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1797094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1797097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797126 */     // MIs[0] policy
     /* 1797126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1797139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797160 */     // GIR_Coverage, 12350,
     /* 1797160 */     GIR_EraseRootFromParent_Done,
     /* 1797161 */   // Label 24393: @1797161
     /* 1797161 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1797247), // Rule ID 12351 //
     /* 1797166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1797177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1797180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1797183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797212 */     // MIs[0] policy
     /* 1797212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1797225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797246 */     // GIR_Coverage, 12351,
     /* 1797246 */     GIR_EraseRootFromParent_Done,
     /* 1797247 */   // Label 24394: @1797247
     /* 1797247 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1797333), // Rule ID 12354 //
     /* 1797252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1797263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1797266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1797269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797298 */     // MIs[0] policy
     /* 1797298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1797311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797332 */     // GIR_Coverage, 12354,
     /* 1797332 */     GIR_EraseRootFromParent_Done,
     /* 1797333 */   // Label 24395: @1797333
     /* 1797333 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1797419), // Rule ID 12355 //
     /* 1797338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1797349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1797352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1797355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797384 */     // MIs[0] policy
     /* 1797384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1797397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797418 */     // GIR_Coverage, 12355,
     /* 1797418 */     GIR_EraseRootFromParent_Done,
     /* 1797419 */   // Label 24396: @1797419
     /* 1797419 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1797505), // Rule ID 12358 //
     /* 1797424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1797435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1797438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1797441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1797454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797470 */     // MIs[0] policy
     /* 1797470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1797483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797504 */     // GIR_Coverage, 12358,
     /* 1797504 */     GIR_EraseRootFromParent_Done,
     /* 1797505 */   // Label 24397: @1797505
     /* 1797505 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1797591), // Rule ID 12359 //
     /* 1797510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1797521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1797524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1797527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1797540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797556 */     // MIs[0] policy
     /* 1797556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1797569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797590 */     // GIR_Coverage, 12359,
     /* 1797590 */     GIR_EraseRootFromParent_Done,
     /* 1797591 */   // Label 24398: @1797591
     /* 1797591 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1797677), // Rule ID 12362 //
     /* 1797596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1797613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1797616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797642 */     // MIs[0] policy
     /* 1797642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1797655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797676 */     // GIR_Coverage, 12362,
     /* 1797676 */     GIR_EraseRootFromParent_Done,
     /* 1797677 */   // Label 24399: @1797677
     /* 1797677 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1797763), // Rule ID 12363 //
     /* 1797682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1797693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1797696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1797699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1797702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797728 */     // MIs[0] policy
     /* 1797728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797738 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1797741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797762 */     // GIR_Coverage, 12363,
     /* 1797762 */     GIR_EraseRootFromParent_Done,
     /* 1797763 */   // Label 24400: @1797763
     /* 1797763 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1797849), // Rule ID 12366 //
     /* 1797768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1797785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1797788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797814 */     // MIs[0] policy
     /* 1797814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1797827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797848 */     // GIR_Coverage, 12366,
     /* 1797848 */     GIR_EraseRootFromParent_Done,
     /* 1797849 */   // Label 24401: @1797849
     /* 1797849 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1797935), // Rule ID 12367 //
     /* 1797854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1797865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1797868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1797871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1797874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797900 */     // MIs[0] policy
     /* 1797900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797910 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1797913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797934 */     // GIR_Coverage, 12367,
     /* 1797934 */     GIR_EraseRootFromParent_Done,
     /* 1797935 */   // Label 24402: @1797935
     /* 1797935 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1798021), // Rule ID 12370 //
     /* 1797940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1797957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1797960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797986 */     // MIs[0] policy
     /* 1797986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1797999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798020 */     // GIR_Coverage, 12370,
     /* 1798020 */     GIR_EraseRootFromParent_Done,
     /* 1798021 */   // Label 24403: @1798021
     /* 1798021 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1798107), // Rule ID 12371 //
     /* 1798026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1798037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1798040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1798043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1798046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798072 */     // MIs[0] policy
     /* 1798072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1798085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798106 */     // GIR_Coverage, 12371,
     /* 1798106 */     GIR_EraseRootFromParent_Done,
     /* 1798107 */   // Label 24404: @1798107
     /* 1798107 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1798193), // Rule ID 12374 //
     /* 1798112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1798129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1798132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798158 */     // MIs[0] policy
     /* 1798158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1798171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798192 */     // GIR_Coverage, 12374,
     /* 1798192 */     GIR_EraseRootFromParent_Done,
     /* 1798193 */   // Label 24405: @1798193
     /* 1798193 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1798279), // Rule ID 12375 //
     /* 1798198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1798215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1798218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798244 */     // MIs[0] policy
     /* 1798244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1798257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798278 */     // GIR_Coverage, 12375,
     /* 1798278 */     GIR_EraseRootFromParent_Done,
     /* 1798279 */   // Label 24406: @1798279
     /* 1798279 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1798365), // Rule ID 12378 //
     /* 1798284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1798304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798330 */     // MIs[0] policy
     /* 1798330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1798343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798364 */     // GIR_Coverage, 12378,
     /* 1798364 */     GIR_EraseRootFromParent_Done,
     /* 1798365 */   // Label 24407: @1798365
     /* 1798365 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1798451), // Rule ID 12379 //
     /* 1798370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1798387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1798390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798416 */     // MIs[0] policy
     /* 1798416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1798429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798450 */     // GIR_Coverage, 12379,
     /* 1798450 */     GIR_EraseRootFromParent_Done,
     /* 1798451 */   // Label 24408: @1798451
     /* 1798451 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1798537), // Rule ID 12382 //
     /* 1798456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1798476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798502 */     // MIs[0] policy
     /* 1798502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1798515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798536 */     // GIR_Coverage, 12382,
     /* 1798536 */     GIR_EraseRootFromParent_Done,
     /* 1798537 */   // Label 24409: @1798537
     /* 1798537 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1798623), // Rule ID 12383 //
     /* 1798542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1798562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798588 */     // MIs[0] policy
     /* 1798588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1798601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798622 */     // GIR_Coverage, 12383,
     /* 1798622 */     GIR_EraseRootFromParent_Done,
     /* 1798623 */   // Label 24410: @1798623
     /* 1798623 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1798709), // Rule ID 12386 //
     /* 1798628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1798639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1798642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1798645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1798648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798674 */     // MIs[0] policy
     /* 1798674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1798687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798708 */     // GIR_Coverage, 12386,
     /* 1798708 */     GIR_EraseRootFromParent_Done,
     /* 1798709 */   // Label 24411: @1798709
     /* 1798709 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1798795), // Rule ID 12387 //
     /* 1798714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1798725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1798728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1798731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1798734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798760 */     // MIs[0] policy
     /* 1798760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1798773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798794 */     // GIR_Coverage, 12387,
     /* 1798794 */     GIR_EraseRootFromParent_Done,
     /* 1798795 */   // Label 24412: @1798795
     /* 1798795 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1798881), // Rule ID 12390 //
     /* 1798800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1798811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1798814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1798817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1798820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798846 */     // MIs[0] policy
     /* 1798846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1798859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798880 */     // GIR_Coverage, 12390,
     /* 1798880 */     GIR_EraseRootFromParent_Done,
     /* 1798881 */   // Label 24413: @1798881
     /* 1798881 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1798967), // Rule ID 12391 //
     /* 1798886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1798897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1798900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1798903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1798906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798932 */     // MIs[0] policy
     /* 1798932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1798945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798966 */     // GIR_Coverage, 12391,
     /* 1798966 */     GIR_EraseRootFromParent_Done,
     /* 1798967 */   // Label 24414: @1798967
     /* 1798967 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1799053), // Rule ID 12394 //
     /* 1798972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1798989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1798992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799018 */     // MIs[0] policy
     /* 1799018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1799031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799052 */     // GIR_Coverage, 12394,
     /* 1799052 */     GIR_EraseRootFromParent_Done,
     /* 1799053 */   // Label 24415: @1799053
     /* 1799053 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1799139), // Rule ID 12395 //
     /* 1799058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1799075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1799078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799104 */     // MIs[0] policy
     /* 1799104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1799117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799138 */     // GIR_Coverage, 12395,
     /* 1799138 */     GIR_EraseRootFromParent_Done,
     /* 1799139 */   // Label 24416: @1799139
     /* 1799139 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1799225), // Rule ID 12398 //
     /* 1799144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1799161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1799164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799190 */     // MIs[0] policy
     /* 1799190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1799203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799224 */     // GIR_Coverage, 12398,
     /* 1799224 */     GIR_EraseRootFromParent_Done,
     /* 1799225 */   // Label 24417: @1799225
     /* 1799225 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1799311), // Rule ID 12399 //
     /* 1799230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1799247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1799250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799276 */     // MIs[0] policy
     /* 1799276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1799289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799310 */     // GIR_Coverage, 12399,
     /* 1799310 */     GIR_EraseRootFromParent_Done,
     /* 1799311 */   // Label 24418: @1799311
     /* 1799311 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1799397), // Rule ID 12402 //
     /* 1799316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1799333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1799336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799362 */     // MIs[0] policy
     /* 1799362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1799375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799396 */     // GIR_Coverage, 12402,
     /* 1799396 */     GIR_EraseRootFromParent_Done,
     /* 1799397 */   // Label 24419: @1799397
     /* 1799397 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1799483), // Rule ID 12403 //
     /* 1799402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1799419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1799422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799448 */     // MIs[0] policy
     /* 1799448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1799461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799482 */     // GIR_Coverage, 12403,
     /* 1799482 */     GIR_EraseRootFromParent_Done,
     /* 1799483 */   // Label 24420: @1799483
     /* 1799483 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1799569), // Rule ID 12406 //
     /* 1799488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1799491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1799499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1799502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1799505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1799508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799534 */     // MIs[0] policy
     /* 1799534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1799547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799568 */     // GIR_Coverage, 12406,
     /* 1799568 */     GIR_EraseRootFromParent_Done,
     /* 1799569 */   // Label 24421: @1799569
     /* 1799569 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1799655), // Rule ID 12407 //
     /* 1799574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1799577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1799585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1799588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1799591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1799594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799620 */     // MIs[0] policy
     /* 1799620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1799633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799654 */     // GIR_Coverage, 12407,
     /* 1799654 */     GIR_EraseRootFromParent_Done,
     /* 1799655 */   // Label 24422: @1799655
     /* 1799655 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1799741), // Rule ID 12410 //
     /* 1799660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1799663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1799677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1799680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799706 */     // MIs[0] policy
     /* 1799706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1799719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799740 */     // GIR_Coverage, 12410,
     /* 1799740 */     GIR_EraseRootFromParent_Done,
     /* 1799741 */   // Label 24423: @1799741
     /* 1799741 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1799827), // Rule ID 12411 //
     /* 1799746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1799749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1799763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1799766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799792 */     // MIs[0] policy
     /* 1799792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1799805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799826 */     // GIR_Coverage, 12411,
     /* 1799826 */     GIR_EraseRootFromParent_Done,
     /* 1799827 */   // Label 24424: @1799827
     /* 1799827 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1799913), // Rule ID 12414 //
     /* 1799832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1799835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1799852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799878 */     // MIs[0] policy
     /* 1799878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1799891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799912 */     // GIR_Coverage, 12414,
     /* 1799912 */     GIR_EraseRootFromParent_Done,
     /* 1799913 */   // Label 24425: @1799913
     /* 1799913 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1799999), // Rule ID 12415 //
     /* 1799918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1799921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1799935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1799938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799964 */     // MIs[0] policy
     /* 1799964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1799977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799998 */     // GIR_Coverage, 12415,
     /* 1799998 */     GIR_EraseRootFromParent_Done,
     /* 1799999 */   // Label 24426: @1799999
     /* 1799999 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1800085), // Rule ID 12418 //
     /* 1800004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1800007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1800021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1800024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800050 */     // MIs[0] policy
     /* 1800050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800084 */     // GIR_Coverage, 12418,
     /* 1800084 */     GIR_EraseRootFromParent_Done,
     /* 1800085 */   // Label 24427: @1800085
     /* 1800085 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1800171), // Rule ID 12419 //
     /* 1800090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1800093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1800107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1800110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800136 */     // MIs[0] policy
     /* 1800136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800170 */     // GIR_Coverage, 12419,
     /* 1800170 */     GIR_EraseRootFromParent_Done,
     /* 1800171 */   // Label 24428: @1800171
     /* 1800171 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1800257), // Rule ID 12422 //
     /* 1800176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800222 */     // MIs[0] policy
     /* 1800222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800232 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1800235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800256 */     // GIR_Coverage, 12422,
     /* 1800256 */     GIR_EraseRootFromParent_Done,
     /* 1800257 */   // Label 24429: @1800257
     /* 1800257 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1800343), // Rule ID 12423 //
     /* 1800262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1800279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800308 */     // MIs[0] policy
     /* 1800308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1800321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800342 */     // GIR_Coverage, 12423,
     /* 1800342 */     GIR_EraseRootFromParent_Done,
     /* 1800343 */   // Label 24430: @1800343
     /* 1800343 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1800429), // Rule ID 12426 //
     /* 1800348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800394 */     // MIs[0] policy
     /* 1800394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1800407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800428 */     // GIR_Coverage, 12426,
     /* 1800428 */     GIR_EraseRootFromParent_Done,
     /* 1800429 */   // Label 24431: @1800429
     /* 1800429 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1800515), // Rule ID 12427 //
     /* 1800434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800480 */     // MIs[0] policy
     /* 1800480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1800493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800514 */     // GIR_Coverage, 12427,
     /* 1800514 */     GIR_EraseRootFromParent_Done,
     /* 1800515 */   // Label 24432: @1800515
     /* 1800515 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1800601), // Rule ID 12430 //
     /* 1800520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800566 */     // MIs[0] policy
     /* 1800566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1800579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800600 */     // GIR_Coverage, 12430,
     /* 1800600 */     GIR_EraseRootFromParent_Done,
     /* 1800601 */   // Label 24433: @1800601
     /* 1800601 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1800687), // Rule ID 12431 //
     /* 1800606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800652 */     // MIs[0] policy
     /* 1800652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1800665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800686 */     // GIR_Coverage, 12431,
     /* 1800686 */     GIR_EraseRootFromParent_Done,
     /* 1800687 */   // Label 24434: @1800687
     /* 1800687 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1800773), // Rule ID 12434 //
     /* 1800692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800738 */     // MIs[0] policy
     /* 1800738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1800751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800772 */     // GIR_Coverage, 12434,
     /* 1800772 */     GIR_EraseRootFromParent_Done,
     /* 1800773 */   // Label 24435: @1800773
     /* 1800773 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1800859), // Rule ID 12435 //
     /* 1800778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800824 */     // MIs[0] policy
     /* 1800824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1800837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800858 */     // GIR_Coverage, 12435,
     /* 1800858 */     GIR_EraseRootFromParent_Done,
     /* 1800859 */   // Label 24436: @1800859
     /* 1800859 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1800945), // Rule ID 12438 //
     /* 1800864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1800884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800910 */     // MIs[0] policy
     /* 1800910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1800923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800944 */     // GIR_Coverage, 12438,
     /* 1800944 */     GIR_EraseRootFromParent_Done,
     /* 1800945 */   // Label 24437: @1800945
     /* 1800945 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1801031), // Rule ID 12439 //
     /* 1800950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1800970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1800992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800996 */     // MIs[0] policy
     /* 1800996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801006 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1801009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801030 */     // GIR_Coverage, 12439,
     /* 1801030 */     GIR_EraseRootFromParent_Done,
     /* 1801031 */   // Label 24438: @1801031
     /* 1801031 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1801117), // Rule ID 12442 //
     /* 1801036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801082 */     // MIs[0] policy
     /* 1801082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1801095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801116 */     // GIR_Coverage, 12442,
     /* 1801116 */     GIR_EraseRootFromParent_Done,
     /* 1801117 */   // Label 24439: @1801117
     /* 1801117 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1801203), // Rule ID 12443 //
     /* 1801122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801168 */     // MIs[0] policy
     /* 1801168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1801181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801202 */     // GIR_Coverage, 12443,
     /* 1801202 */     GIR_EraseRootFromParent_Done,
     /* 1801203 */   // Label 24440: @1801203
     /* 1801203 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1801289), // Rule ID 12446 //
     /* 1801208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801254 */     // MIs[0] policy
     /* 1801254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1801267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801288 */     // GIR_Coverage, 12446,
     /* 1801288 */     GIR_EraseRootFromParent_Done,
     /* 1801289 */   // Label 24441: @1801289
     /* 1801289 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1801375), // Rule ID 12447 //
     /* 1801294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1801305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1801308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1801311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801340 */     // MIs[0] policy
     /* 1801340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1801353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801374 */     // GIR_Coverage, 12447,
     /* 1801374 */     GIR_EraseRootFromParent_Done,
     /* 1801375 */   // Label 24442: @1801375
     /* 1801375 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1801461), // Rule ID 12450 //
     /* 1801380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801426 */     // MIs[0] policy
     /* 1801426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1801439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801460 */     // GIR_Coverage, 12450,
     /* 1801460 */     GIR_EraseRootFromParent_Done,
     /* 1801461 */   // Label 24443: @1801461
     /* 1801461 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1801547), // Rule ID 12451 //
     /* 1801466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801512 */     // MIs[0] policy
     /* 1801512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1801525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801546 */     // GIR_Coverage, 12451,
     /* 1801546 */     GIR_EraseRootFromParent_Done,
     /* 1801547 */   // Label 24444: @1801547
     /* 1801547 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1801633), // Rule ID 12454 //
     /* 1801552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801598 */     // MIs[0] policy
     /* 1801598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1801611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801632 */     // GIR_Coverage, 12454,
     /* 1801632 */     GIR_EraseRootFromParent_Done,
     /* 1801633 */   // Label 24445: @1801633
     /* 1801633 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1801719), // Rule ID 12455 //
     /* 1801638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801684 */     // MIs[0] policy
     /* 1801684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1801697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801718 */     // GIR_Coverage, 12455,
     /* 1801718 */     GIR_EraseRootFromParent_Done,
     /* 1801719 */   // Label 24446: @1801719
     /* 1801719 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1801805), // Rule ID 12458 //
     /* 1801724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801770 */     // MIs[0] policy
     /* 1801770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1801783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801804 */     // GIR_Coverage, 12458,
     /* 1801804 */     GIR_EraseRootFromParent_Done,
     /* 1801805 */   // Label 24447: @1801805
     /* 1801805 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1801891), // Rule ID 12459 //
     /* 1801810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801856 */     // MIs[0] policy
     /* 1801856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1801869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801890 */     // GIR_Coverage, 12459,
     /* 1801890 */     GIR_EraseRootFromParent_Done,
     /* 1801891 */   // Label 24448: @1801891
     /* 1801891 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1801977), // Rule ID 12462 //
     /* 1801896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801942 */     // MIs[0] policy
     /* 1801942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1801955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801976 */     // GIR_Coverage, 12462,
     /* 1801976 */     GIR_EraseRootFromParent_Done,
     /* 1801977 */   // Label 24449: @1801977
     /* 1801977 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1802063), // Rule ID 12463 //
     /* 1801982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802028 */     // MIs[0] policy
     /* 1802028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1802041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802062 */     // GIR_Coverage, 12463,
     /* 1802062 */     GIR_EraseRootFromParent_Done,
     /* 1802063 */   // Label 24450: @1802063
     /* 1802063 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1802149), // Rule ID 12466 //
     /* 1802068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802114 */     // MIs[0] policy
     /* 1802114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802148 */     // GIR_Coverage, 12466,
     /* 1802148 */     GIR_EraseRootFromParent_Done,
     /* 1802149 */   // Label 24451: @1802149
     /* 1802149 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1802235), // Rule ID 12467 //
     /* 1802154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802200 */     // MIs[0] policy
     /* 1802200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802234 */     // GIR_Coverage, 12467,
     /* 1802234 */     GIR_EraseRootFromParent_Done,
     /* 1802235 */   // Label 24452: @1802235
     /* 1802235 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1802321), // Rule ID 12470 //
     /* 1802240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802286 */     // MIs[0] policy
     /* 1802286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1802299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802320 */     // GIR_Coverage, 12470,
     /* 1802320 */     GIR_EraseRootFromParent_Done,
     /* 1802321 */   // Label 24453: @1802321
     /* 1802321 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1802407), // Rule ID 12471 //
     /* 1802326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1802337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1802340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1802343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802372 */     // MIs[0] policy
     /* 1802372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11595:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1802385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802406 */     // GIR_Coverage, 12471,
     /* 1802406 */     GIR_EraseRootFromParent_Done,
     /* 1802407 */   // Label 24454: @1802407
     /* 1802407 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1802493), // Rule ID 12474 //
     /* 1802412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802458 */     // MIs[0] policy
     /* 1802458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1802471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802492 */     // GIR_Coverage, 12474,
     /* 1802492 */     GIR_EraseRootFromParent_Done,
     /* 1802493 */   // Label 24455: @1802493
     /* 1802493 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1802579), // Rule ID 12475 //
     /* 1802498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802544 */     // MIs[0] policy
     /* 1802544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11595:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1802557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802578 */     // GIR_Coverage, 12475,
     /* 1802578 */     GIR_EraseRootFromParent_Done,
     /* 1802579 */   // Label 24456: @1802579
     /* 1802579 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1802665), // Rule ID 12478 //
     /* 1802584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802630 */     // MIs[0] policy
     /* 1802630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1802643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802664 */     // GIR_Coverage, 12478,
     /* 1802664 */     GIR_EraseRootFromParent_Done,
     /* 1802665 */   // Label 24457: @1802665
     /* 1802665 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1802751), // Rule ID 12479 //
     /* 1802670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802716 */     // MIs[0] policy
     /* 1802716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11595:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1802729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802750 */     // GIR_Coverage, 12479,
     /* 1802750 */     GIR_EraseRootFromParent_Done,
     /* 1802751 */   // Label 24458: @1802751
     /* 1802751 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1802837), // Rule ID 12482 //
     /* 1802756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1802776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802802 */     // MIs[0] policy
     /* 1802802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1802815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802836 */     // GIR_Coverage, 12482,
     /* 1802836 */     GIR_EraseRootFromParent_Done,
     /* 1802837 */   // Label 24459: @1802837
     /* 1802837 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1802923), // Rule ID 12483 //
     /* 1802842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1802862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802888 */     // MIs[0] policy
     /* 1802888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1802901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802922 */     // GIR_Coverage, 12483,
     /* 1802922 */     GIR_EraseRootFromParent_Done,
     /* 1802923 */   // Label 24460: @1802923
     /* 1802923 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1803009), // Rule ID 12486 //
     /* 1802928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1802945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1802948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802974 */     // MIs[0] policy
     /* 1802974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1802987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803008 */     // GIR_Coverage, 12486,
     /* 1803008 */     GIR_EraseRootFromParent_Done,
     /* 1803009 */   // Label 24461: @1803009
     /* 1803009 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1803095), // Rule ID 12487 //
     /* 1803014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1803034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803060 */     // MIs[0] policy
     /* 1803060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1803073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803094 */     // GIR_Coverage, 12487,
     /* 1803094 */     GIR_EraseRootFromParent_Done,
     /* 1803095 */   // Label 24462: @1803095
     /* 1803095 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1803181), // Rule ID 12490 //
     /* 1803100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1803120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803146 */     // MIs[0] policy
     /* 1803146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1803159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803180 */     // GIR_Coverage, 12490,
     /* 1803180 */     GIR_EraseRootFromParent_Done,
     /* 1803181 */   // Label 24463: @1803181
     /* 1803181 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1803267), // Rule ID 12491 //
     /* 1803186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1803206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803232 */     // MIs[0] policy
     /* 1803232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1803245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803266 */     // GIR_Coverage, 12491,
     /* 1803266 */     GIR_EraseRootFromParent_Done,
     /* 1803267 */   // Label 24464: @1803267
     /* 1803267 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1803353), // Rule ID 12494 //
     /* 1803272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1803292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803318 */     // MIs[0] policy
     /* 1803318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1803331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803352 */     // GIR_Coverage, 12494,
     /* 1803352 */     GIR_EraseRootFromParent_Done,
     /* 1803353 */   // Label 24465: @1803353
     /* 1803353 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1803439), // Rule ID 12495 //
     /* 1803358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1803378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803404 */     // MIs[0] policy
     /* 1803404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1803417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803438 */     // GIR_Coverage, 12495,
     /* 1803438 */     GIR_EraseRootFromParent_Done,
     /* 1803439 */   // Label 24466: @1803439
     /* 1803439 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1803525), // Rule ID 12498 //
     /* 1803444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1803464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803490 */     // MIs[0] policy
     /* 1803490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1803503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803524 */     // GIR_Coverage, 12498,
     /* 1803524 */     GIR_EraseRootFromParent_Done,
     /* 1803525 */   // Label 24467: @1803525
     /* 1803525 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1803611), // Rule ID 12499 //
     /* 1803530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1803550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803576 */     // MIs[0] policy
     /* 1803576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1803589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803610 */     // GIR_Coverage, 12499,
     /* 1803610 */     GIR_EraseRootFromParent_Done,
     /* 1803611 */   // Label 24468: @1803611
     /* 1803611 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1803697), // Rule ID 12502 //
     /* 1803616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1803636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803662 */     // MIs[0] policy
     /* 1803662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803672 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1803675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803696 */     // GIR_Coverage, 12502,
     /* 1803696 */     GIR_EraseRootFromParent_Done,
     /* 1803697 */   // Label 24469: @1803697
     /* 1803697 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1803783), // Rule ID 12503 //
     /* 1803702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1803722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803748 */     // MIs[0] policy
     /* 1803748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1803761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803782 */     // GIR_Coverage, 12503,
     /* 1803782 */     GIR_EraseRootFromParent_Done,
     /* 1803783 */   // Label 24470: @1803783
     /* 1803783 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1803869), // Rule ID 12506 //
     /* 1803788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1803808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803834 */     // MIs[0] policy
     /* 1803834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1803847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803868 */     // GIR_Coverage, 12506,
     /* 1803868 */     GIR_EraseRootFromParent_Done,
     /* 1803869 */   // Label 24471: @1803869
     /* 1803869 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1803955), // Rule ID 12507 //
     /* 1803874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1803894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803920 */     // MIs[0] policy
     /* 1803920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1803933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803954 */     // GIR_Coverage, 12507,
     /* 1803954 */     GIR_EraseRootFromParent_Done,
     /* 1803955 */   // Label 24472: @1803955
     /* 1803955 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1804041), // Rule ID 12510 //
     /* 1803960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1803971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1803974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1803977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1803980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804006 */     // MIs[0] policy
     /* 1804006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1804019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804040 */     // GIR_Coverage, 12510,
     /* 1804040 */     GIR_EraseRootFromParent_Done,
     /* 1804041 */   // Label 24473: @1804041
     /* 1804041 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1804127), // Rule ID 12511 //
     /* 1804046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804092 */     // MIs[0] policy
     /* 1804092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1804105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804126 */     // GIR_Coverage, 12511,
     /* 1804126 */     GIR_EraseRootFromParent_Done,
     /* 1804127 */   // Label 24474: @1804127
     /* 1804127 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1804213), // Rule ID 12514 //
     /* 1804132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1804152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804178 */     // MIs[0] policy
     /* 1804178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1804191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804212 */     // GIR_Coverage, 12514,
     /* 1804212 */     GIR_EraseRootFromParent_Done,
     /* 1804213 */   // Label 24475: @1804213
     /* 1804213 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1804299), // Rule ID 12515 //
     /* 1804218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1804238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804264 */     // MIs[0] policy
     /* 1804264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1804277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804298 */     // GIR_Coverage, 12515,
     /* 1804298 */     GIR_EraseRootFromParent_Done,
     /* 1804299 */   // Label 24476: @1804299
     /* 1804299 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1804385), // Rule ID 12518 //
     /* 1804304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1804324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804350 */     // MIs[0] policy
     /* 1804350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1804363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804384 */     // GIR_Coverage, 12518,
     /* 1804384 */     GIR_EraseRootFromParent_Done,
     /* 1804385 */   // Label 24477: @1804385
     /* 1804385 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1804471), // Rule ID 12519 //
     /* 1804390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1804410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804436 */     // MIs[0] policy
     /* 1804436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1804449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804470 */     // GIR_Coverage, 12519,
     /* 1804470 */     GIR_EraseRootFromParent_Done,
     /* 1804471 */   // Label 24478: @1804471
     /* 1804471 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1804557), // Rule ID 12522 //
     /* 1804476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1804496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804522 */     // MIs[0] policy
     /* 1804522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1804535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804556 */     // GIR_Coverage, 12522,
     /* 1804556 */     GIR_EraseRootFromParent_Done,
     /* 1804557 */   // Label 24479: @1804557
     /* 1804557 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1804643), // Rule ID 12523 //
     /* 1804562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1804582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804608 */     // MIs[0] policy
     /* 1804608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1804621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804642 */     // GIR_Coverage, 12523,
     /* 1804642 */     GIR_EraseRootFromParent_Done,
     /* 1804643 */   // Label 24480: @1804643
     /* 1804643 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1804729), // Rule ID 12526 //
     /* 1804648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1804668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804694 */     // MIs[0] policy
     /* 1804694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1804707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804728 */     // GIR_Coverage, 12526,
     /* 1804728 */     GIR_EraseRootFromParent_Done,
     /* 1804729 */   // Label 24481: @1804729
     /* 1804729 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1804815), // Rule ID 12527 //
     /* 1804734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1804754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804780 */     // MIs[0] policy
     /* 1804780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1804793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804814 */     // GIR_Coverage, 12527,
     /* 1804814 */     GIR_EraseRootFromParent_Done,
     /* 1804815 */   // Label 24482: @1804815
     /* 1804815 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1804901), // Rule ID 12530 //
     /* 1804820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1804840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804866 */     // MIs[0] policy
     /* 1804866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1804879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804900 */     // GIR_Coverage, 12530,
     /* 1804900 */     GIR_EraseRootFromParent_Done,
     /* 1804901 */   // Label 24483: @1804901
     /* 1804901 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1804987), // Rule ID 12531 //
     /* 1804906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1804926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804952 */     // MIs[0] policy
     /* 1804952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1804965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804986 */     // GIR_Coverage, 12531,
     /* 1804986 */     GIR_EraseRootFromParent_Done,
     /* 1804987 */   // Label 24484: @1804987
     /* 1804987 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1805073), // Rule ID 12534 //
     /* 1804992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1805012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805038 */     // MIs[0] policy
     /* 1805038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805072 */     // GIR_Coverage, 12534,
     /* 1805072 */     GIR_EraseRootFromParent_Done,
     /* 1805073 */   // Label 24485: @1805073
     /* 1805073 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1805159), // Rule ID 12535 //
     /* 1805078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1805098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805124 */     // MIs[0] policy
     /* 1805124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805158 */     // GIR_Coverage, 12535,
     /* 1805158 */     GIR_EraseRootFromParent_Done,
     /* 1805159 */   // Label 24486: @1805159
     /* 1805159 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1805245), // Rule ID 12538 //
     /* 1805164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1805184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805210 */     // MIs[0] policy
     /* 1805210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1805223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805244 */     // GIR_Coverage, 12538,
     /* 1805244 */     GIR_EraseRootFromParent_Done,
     /* 1805245 */   // Label 24487: @1805245
     /* 1805245 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1805331), // Rule ID 12539 //
     /* 1805250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1805270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805296 */     // MIs[0] policy
     /* 1805296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1805309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805330 */     // GIR_Coverage, 12539,
     /* 1805330 */     GIR_EraseRootFromParent_Done,
     /* 1805331 */   // Label 24488: @1805331
     /* 1805331 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1805417), // Rule ID 12542 //
     /* 1805336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805382 */     // MIs[0] policy
     /* 1805382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1805395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805416 */     // GIR_Coverage, 12542,
     /* 1805416 */     GIR_EraseRootFromParent_Done,
     /* 1805417 */   // Label 24489: @1805417
     /* 1805417 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1805503), // Rule ID 12543 //
     /* 1805422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805468 */     // MIs[0] policy
     /* 1805468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1805481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805502 */     // GIR_Coverage, 12543,
     /* 1805502 */     GIR_EraseRootFromParent_Done,
     /* 1805503 */   // Label 24490: @1805503
     /* 1805503 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1805589), // Rule ID 12546 //
     /* 1805508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805554 */     // MIs[0] policy
     /* 1805554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1805567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805588 */     // GIR_Coverage, 12546,
     /* 1805588 */     GIR_EraseRootFromParent_Done,
     /* 1805589 */   // Label 24491: @1805589
     /* 1805589 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1805675), // Rule ID 12547 //
     /* 1805594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805640 */     // MIs[0] policy
     /* 1805640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1805653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805674 */     // GIR_Coverage, 12547,
     /* 1805674 */     GIR_EraseRootFromParent_Done,
     /* 1805675 */   // Label 24492: @1805675
     /* 1805675 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1805761), // Rule ID 12550 //
     /* 1805680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805726 */     // MIs[0] policy
     /* 1805726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1805739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805760 */     // GIR_Coverage, 12550,
     /* 1805760 */     GIR_EraseRootFromParent_Done,
     /* 1805761 */   // Label 24493: @1805761
     /* 1805761 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1805847), // Rule ID 12551 //
     /* 1805766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805812 */     // MIs[0] policy
     /* 1805812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1805825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805846 */     // GIR_Coverage, 12551,
     /* 1805846 */     GIR_EraseRootFromParent_Done,
     /* 1805847 */   // Label 24494: @1805847
     /* 1805847 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1805933), // Rule ID 12554 //
     /* 1805852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1805872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805898 */     // MIs[0] policy
     /* 1805898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1805911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805932 */     // GIR_Coverage, 12554,
     /* 1805932 */     GIR_EraseRootFromParent_Done,
     /* 1805933 */   // Label 24495: @1805933
     /* 1805933 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1806019), // Rule ID 12555 //
     /* 1805938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1805958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1805980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805984 */     // MIs[0] policy
     /* 1805984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1805997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806018 */     // GIR_Coverage, 12555,
     /* 1806018 */     GIR_EraseRootFromParent_Done,
     /* 1806019 */   // Label 24496: @1806019
     /* 1806019 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1806105), // Rule ID 12558 //
     /* 1806024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806070 */     // MIs[0] policy
     /* 1806070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1806083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806104 */     // GIR_Coverage, 12558,
     /* 1806104 */     GIR_EraseRootFromParent_Done,
     /* 1806105 */   // Label 24497: @1806105
     /* 1806105 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1806191), // Rule ID 12559 //
     /* 1806110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806156 */     // MIs[0] policy
     /* 1806156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1806169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806190 */     // GIR_Coverage, 12559,
     /* 1806190 */     GIR_EraseRootFromParent_Done,
     /* 1806191 */   // Label 24498: @1806191
     /* 1806191 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1806277), // Rule ID 12562 //
     /* 1806196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806242 */     // MIs[0] policy
     /* 1806242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1806255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806276 */     // GIR_Coverage, 12562,
     /* 1806276 */     GIR_EraseRootFromParent_Done,
     /* 1806277 */   // Label 24499: @1806277
     /* 1806277 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1806363), // Rule ID 12563 //
     /* 1806282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1806293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1806296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1806299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1806305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806328 */     // MIs[0] policy
     /* 1806328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1806341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806362 */     // GIR_Coverage, 12563,
     /* 1806362 */     GIR_EraseRootFromParent_Done,
     /* 1806363 */   // Label 24500: @1806363
     /* 1806363 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1806449), // Rule ID 12566 //
     /* 1806368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806414 */     // MIs[0] policy
     /* 1806414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1806427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806448 */     // GIR_Coverage, 12566,
     /* 1806448 */     GIR_EraseRootFromParent_Done,
     /* 1806449 */   // Label 24501: @1806449
     /* 1806449 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1806535), // Rule ID 12567 //
     /* 1806454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806500 */     // MIs[0] policy
     /* 1806500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1806513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806534 */     // GIR_Coverage, 12567,
     /* 1806534 */     GIR_EraseRootFromParent_Done,
     /* 1806535 */   // Label 24502: @1806535
     /* 1806535 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1806621), // Rule ID 12570 //
     /* 1806540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806586 */     // MIs[0] policy
     /* 1806586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1806599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806620 */     // GIR_Coverage, 12570,
     /* 1806620 */     GIR_EraseRootFromParent_Done,
     /* 1806621 */   // Label 24503: @1806621
     /* 1806621 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1806707), // Rule ID 12571 //
     /* 1806626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806672 */     // MIs[0] policy
     /* 1806672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1806685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806706 */     // GIR_Coverage, 12571,
     /* 1806706 */     GIR_EraseRootFromParent_Done,
     /* 1806707 */   // Label 24504: @1806707
     /* 1806707 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1806793), // Rule ID 12574 //
     /* 1806712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806758 */     // MIs[0] policy
     /* 1806758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1806771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806792 */     // GIR_Coverage, 12574,
     /* 1806792 */     GIR_EraseRootFromParent_Done,
     /* 1806793 */   // Label 24505: @1806793
     /* 1806793 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1806879), // Rule ID 12575 //
     /* 1806798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806844 */     // MIs[0] policy
     /* 1806844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1806857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806878 */     // GIR_Coverage, 12575,
     /* 1806878 */     GIR_EraseRootFromParent_Done,
     /* 1806879 */   // Label 24506: @1806879
     /* 1806879 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1806965), // Rule ID 12578 //
     /* 1806884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806930 */     // MIs[0] policy
     /* 1806930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1806943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806964 */     // GIR_Coverage, 12578,
     /* 1806964 */     GIR_EraseRootFromParent_Done,
     /* 1806965 */   // Label 24507: @1806965
     /* 1806965 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1807051), // Rule ID 12579 //
     /* 1806970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807016 */     // MIs[0] policy
     /* 1807016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1807029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807050 */     // GIR_Coverage, 12579,
     /* 1807050 */     GIR_EraseRootFromParent_Done,
     /* 1807051 */   // Label 24508: @1807051
     /* 1807051 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1807137), // Rule ID 12582 //
     /* 1807056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807102 */     // MIs[0] policy
     /* 1807102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1807115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807136 */     // GIR_Coverage, 12582,
     /* 1807136 */     GIR_EraseRootFromParent_Done,
     /* 1807137 */   // Label 24509: @1807137
     /* 1807137 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1807223), // Rule ID 12583 //
     /* 1807142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807188 */     // MIs[0] policy
     /* 1807188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1807201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807222 */     // GIR_Coverage, 12583,
     /* 1807222 */     GIR_EraseRootFromParent_Done,
     /* 1807223 */   // Label 24510: @1807223
     /* 1807223 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1807309), // Rule ID 12586 //
     /* 1807228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807274 */     // MIs[0] policy
     /* 1807274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1807287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807308 */     // GIR_Coverage, 12586,
     /* 1807308 */     GIR_EraseRootFromParent_Done,
     /* 1807309 */   // Label 24511: @1807309
     /* 1807309 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1807395), // Rule ID 12587 //
     /* 1807314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1807325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1807328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1807331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807360 */     // MIs[0] policy
     /* 1807360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1807373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807394 */     // GIR_Coverage, 12587,
     /* 1807394 */     GIR_EraseRootFromParent_Done,
     /* 1807395 */   // Label 24512: @1807395
     /* 1807395 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1807481), // Rule ID 12590 //
     /* 1807400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807446 */     // MIs[0] policy
     /* 1807446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1807459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807480 */     // GIR_Coverage, 12590,
     /* 1807480 */     GIR_EraseRootFromParent_Done,
     /* 1807481 */   // Label 24513: @1807481
     /* 1807481 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1807567), // Rule ID 12591 //
     /* 1807486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807532 */     // MIs[0] policy
     /* 1807532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1807545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807566 */     // GIR_Coverage, 12591,
     /* 1807566 */     GIR_EraseRootFromParent_Done,
     /* 1807567 */   // Label 24514: @1807567
     /* 1807567 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1807653), // Rule ID 12594 //
     /* 1807572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807618 */     // MIs[0] policy
     /* 1807618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1807631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807652 */     // GIR_Coverage, 12594,
     /* 1807652 */     GIR_EraseRootFromParent_Done,
     /* 1807653 */   // Label 24515: @1807653
     /* 1807653 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1807739), // Rule ID 12595 //
     /* 1807658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807704 */     // MIs[0] policy
     /* 1807704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1807717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807738 */     // GIR_Coverage, 12595,
     /* 1807738 */     GIR_EraseRootFromParent_Done,
     /* 1807739 */   // Label 24516: @1807739
     /* 1807739 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1807825), // Rule ID 12598 //
     /* 1807744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807790 */     // MIs[0] policy
     /* 1807790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1807803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807824 */     // GIR_Coverage, 12598,
     /* 1807824 */     GIR_EraseRootFromParent_Done,
     /* 1807825 */   // Label 24517: @1807825
     /* 1807825 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1807911), // Rule ID 12599 //
     /* 1807830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807876 */     // MIs[0] policy
     /* 1807876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1807889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807910 */     // GIR_Coverage, 12599,
     /* 1807910 */     GIR_EraseRootFromParent_Done,
     /* 1807911 */   // Label 24518: @1807911
     /* 1807911 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1807997), // Rule ID 12602 //
     /* 1807916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1807933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1807936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807962 */     // MIs[0] policy
     /* 1807962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1807975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807996 */     // GIR_Coverage, 12602,
     /* 1807996 */     GIR_EraseRootFromParent_Done,
     /* 1807997 */   // Label 24519: @1807997
     /* 1807997 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1808083), // Rule ID 12603 //
     /* 1808002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1808013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1808016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1808019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1808022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808048 */     // MIs[0] policy
     /* 1808048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1808061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808082 */     // GIR_Coverage, 12603,
     /* 1808082 */     GIR_EraseRootFromParent_Done,
     /* 1808083 */   // Label 24520: @1808083
     /* 1808083 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1808169), // Rule ID 12606 //
     /* 1808088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1808108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808134 */     // MIs[0] policy
     /* 1808134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1808147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808168 */     // GIR_Coverage, 12606,
     /* 1808168 */     GIR_EraseRootFromParent_Done,
     /* 1808169 */   // Label 24521: @1808169
     /* 1808169 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1808255), // Rule ID 12607 //
     /* 1808174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1808185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1808188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1808194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808220 */     // MIs[0] policy
     /* 1808220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1808233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808254 */     // GIR_Coverage, 12607,
     /* 1808254 */     GIR_EraseRootFromParent_Done,
     /* 1808255 */   // Label 24522: @1808255
     /* 1808255 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1808341), // Rule ID 12610 //
     /* 1808260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1808280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808306 */     // MIs[0] policy
     /* 1808306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1808319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808340 */     // GIR_Coverage, 12610,
     /* 1808340 */     GIR_EraseRootFromParent_Done,
     /* 1808341 */   // Label 24523: @1808341
     /* 1808341 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1808427), // Rule ID 12611 //
     /* 1808346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1808366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808392 */     // MIs[0] policy
     /* 1808392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1808405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808426 */     // GIR_Coverage, 12611,
     /* 1808426 */     GIR_EraseRootFromParent_Done,
     /* 1808427 */   // Label 24524: @1808427
     /* 1808427 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1808513), // Rule ID 12614 //
     /* 1808432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1808452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808478 */     // MIs[0] policy
     /* 1808478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1808491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808512 */     // GIR_Coverage, 12614,
     /* 1808512 */     GIR_EraseRootFromParent_Done,
     /* 1808513 */   // Label 24525: @1808513
     /* 1808513 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1808599), // Rule ID 12615 //
     /* 1808518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1808538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808564 */     // MIs[0] policy
     /* 1808564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1808577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808598 */     // GIR_Coverage, 12615,
     /* 1808598 */     GIR_EraseRootFromParent_Done,
     /* 1808599 */   // Label 24526: @1808599
     /* 1808599 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1808685), // Rule ID 12618 //
     /* 1808604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1808624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808650 */     // MIs[0] policy
     /* 1808650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1808663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808684 */     // GIR_Coverage, 12618,
     /* 1808684 */     GIR_EraseRootFromParent_Done,
     /* 1808685 */   // Label 24527: @1808685
     /* 1808685 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1808771), // Rule ID 12619 //
     /* 1808690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1808710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808736 */     // MIs[0] policy
     /* 1808736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1808749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808770 */     // GIR_Coverage, 12619,
     /* 1808770 */     GIR_EraseRootFromParent_Done,
     /* 1808771 */   // Label 24528: @1808771
     /* 1808771 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1808857), // Rule ID 12622 //
     /* 1808776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1808796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808822 */     // MIs[0] policy
     /* 1808822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1808835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808856 */     // GIR_Coverage, 12622,
     /* 1808856 */     GIR_EraseRootFromParent_Done,
     /* 1808857 */   // Label 24529: @1808857
     /* 1808857 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1808943), // Rule ID 12623 //
     /* 1808862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1808882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808908 */     // MIs[0] policy
     /* 1808908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1808921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808942 */     // GIR_Coverage, 12623,
     /* 1808942 */     GIR_EraseRootFromParent_Done,
     /* 1808943 */   // Label 24530: @1808943
     /* 1808943 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1809029), // Rule ID 12626 //
     /* 1808948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1808959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1808962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1808965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1808968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808994 */     // MIs[0] policy
     /* 1808994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1809007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809028 */     // GIR_Coverage, 12626,
     /* 1809028 */     GIR_EraseRootFromParent_Done,
     /* 1809029 */   // Label 24531: @1809029
     /* 1809029 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1809115), // Rule ID 12627 //
     /* 1809034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809080 */     // MIs[0] policy
     /* 1809080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1809093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809114 */     // GIR_Coverage, 12627,
     /* 1809114 */     GIR_EraseRootFromParent_Done,
     /* 1809115 */   // Label 24532: @1809115
     /* 1809115 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1809201), // Rule ID 12630 //
     /* 1809120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1809140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809166 */     // MIs[0] policy
     /* 1809166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1809179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809200 */     // GIR_Coverage, 12630,
     /* 1809200 */     GIR_EraseRootFromParent_Done,
     /* 1809201 */   // Label 24533: @1809201
     /* 1809201 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1809287), // Rule ID 12631 //
     /* 1809206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1809226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809252 */     // MIs[0] policy
     /* 1809252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1809265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809286 */     // GIR_Coverage, 12631,
     /* 1809286 */     GIR_EraseRootFromParent_Done,
     /* 1809287 */   // Label 24534: @1809287
     /* 1809287 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1809373), // Rule ID 12634 //
     /* 1809292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1809312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809338 */     // MIs[0] policy
     /* 1809338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1809351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809372 */     // GIR_Coverage, 12634,
     /* 1809372 */     GIR_EraseRootFromParent_Done,
     /* 1809373 */   // Label 24535: @1809373
     /* 1809373 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1809459), // Rule ID 12635 //
     /* 1809378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1809398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809424 */     // MIs[0] policy
     /* 1809424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1809437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809458 */     // GIR_Coverage, 12635,
     /* 1809458 */     GIR_EraseRootFromParent_Done,
     /* 1809459 */   // Label 24536: @1809459
     /* 1809459 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1809545), // Rule ID 12638 //
     /* 1809464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1809484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809510 */     // MIs[0] policy
     /* 1809510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1809523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809544 */     // GIR_Coverage, 12638,
     /* 1809544 */     GIR_EraseRootFromParent_Done,
     /* 1809545 */   // Label 24537: @1809545
     /* 1809545 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1809631), // Rule ID 12639 //
     /* 1809550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1809570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809596 */     // MIs[0] policy
     /* 1809596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1809609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809630 */     // GIR_Coverage, 12639,
     /* 1809630 */     GIR_EraseRootFromParent_Done,
     /* 1809631 */   // Label 24538: @1809631
     /* 1809631 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1809717), // Rule ID 12642 //
     /* 1809636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1809656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809682 */     // MIs[0] policy
     /* 1809682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1809695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809716 */     // GIR_Coverage, 12642,
     /* 1809716 */     GIR_EraseRootFromParent_Done,
     /* 1809717 */   // Label 24539: @1809717
     /* 1809717 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1809803), // Rule ID 12643 //
     /* 1809722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1809742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809768 */     // MIs[0] policy
     /* 1809768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1809781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809802 */     // GIR_Coverage, 12643,
     /* 1809802 */     GIR_EraseRootFromParent_Done,
     /* 1809803 */   // Label 24540: @1809803
     /* 1809803 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1809889), // Rule ID 12646 //
     /* 1809808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1809828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809854 */     // MIs[0] policy
     /* 1809854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1809867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809888 */     // GIR_Coverage, 12646,
     /* 1809888 */     GIR_EraseRootFromParent_Done,
     /* 1809889 */   // Label 24541: @1809889
     /* 1809889 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1809975), // Rule ID 12647 //
     /* 1809894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1809914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809940 */     // MIs[0] policy
     /* 1809940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1809953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809974 */     // GIR_Coverage, 12647,
     /* 1809974 */     GIR_EraseRootFromParent_Done,
     /* 1809975 */   // Label 24542: @1809975
     /* 1809975 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1810061), // Rule ID 12650 //
     /* 1809980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1809988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810026 */     // MIs[0] policy
     /* 1810026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810060 */     // GIR_Coverage, 12650,
     /* 1810060 */     GIR_EraseRootFromParent_Done,
     /* 1810061 */   // Label 24543: @1810061
     /* 1810061 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1810147), // Rule ID 12651 //
     /* 1810066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1810077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1810080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810112 */     // MIs[0] policy
     /* 1810112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810146 */     // GIR_Coverage, 12651,
     /* 1810146 */     GIR_EraseRootFromParent_Done,
     /* 1810147 */   // Label 24544: @1810147
     /* 1810147 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1810233), // Rule ID 12654 //
     /* 1810152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1810172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810198 */     // MIs[0] policy
     /* 1810198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810232 */     // GIR_Coverage, 12654,
     /* 1810232 */     GIR_EraseRootFromParent_Done,
     /* 1810233 */   // Label 24545: @1810233
     /* 1810233 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1810319), // Rule ID 12655 //
     /* 1810238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1810249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1810252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1810255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1810258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810284 */     // MIs[0] policy
     /* 1810284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810318 */     // GIR_Coverage, 12655,
     /* 1810318 */     GIR_EraseRootFromParent_Done,
     /* 1810319 */   // Label 24546: @1810319
     /* 1810319 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1810405), // Rule ID 12658 //
     /* 1810324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1810327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1810344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810370 */     // MIs[0] policy
     /* 1810370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810380 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1810383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810404 */     // GIR_Coverage, 12658,
     /* 1810404 */     GIR_EraseRootFromParent_Done,
     /* 1810405 */   // Label 24547: @1810405
     /* 1810405 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1810491), // Rule ID 12659 //
     /* 1810410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1810430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810456 */     // MIs[0] policy
     /* 1810456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1810469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810490 */     // GIR_Coverage, 12659,
     /* 1810490 */     GIR_EraseRootFromParent_Done,
     /* 1810491 */   // Label 24548: @1810491
     /* 1810491 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1810577), // Rule ID 12662 //
     /* 1810496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810542 */     // MIs[0] policy
     /* 1810542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1810555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810576 */     // GIR_Coverage, 12662,
     /* 1810576 */     GIR_EraseRootFromParent_Done,
     /* 1810577 */   // Label 24549: @1810577
     /* 1810577 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1810663), // Rule ID 12663 //
     /* 1810582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810628 */     // MIs[0] policy
     /* 1810628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1810641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810662 */     // GIR_Coverage, 12663,
     /* 1810662 */     GIR_EraseRootFromParent_Done,
     /* 1810663 */   // Label 24550: @1810663
     /* 1810663 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1810749), // Rule ID 12666 //
     /* 1810668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810714 */     // MIs[0] policy
     /* 1810714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810724 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1810727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810748 */     // GIR_Coverage, 12666,
     /* 1810748 */     GIR_EraseRootFromParent_Done,
     /* 1810749 */   // Label 24551: @1810749
     /* 1810749 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1810835), // Rule ID 12667 //
     /* 1810754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810800 */     // MIs[0] policy
     /* 1810800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1810813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810834 */     // GIR_Coverage, 12667,
     /* 1810834 */     GIR_EraseRootFromParent_Done,
     /* 1810835 */   // Label 24552: @1810835
     /* 1810835 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1810921), // Rule ID 12670 //
     /* 1810840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1810860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810886 */     // MIs[0] policy
     /* 1810886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1810899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810920 */     // GIR_Coverage, 12670,
     /* 1810920 */     GIR_EraseRootFromParent_Done,
     /* 1810921 */   // Label 24553: @1810921
     /* 1810921 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1811007), // Rule ID 12671 //
     /* 1810926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810972 */     // MIs[0] policy
     /* 1810972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1810985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811006 */     // GIR_Coverage, 12671,
     /* 1811006 */     GIR_EraseRootFromParent_Done,
     /* 1811007 */   // Label 24554: @1811007
     /* 1811007 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1811093), // Rule ID 12674 //
     /* 1811012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811058 */     // MIs[0] policy
     /* 1811058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1811071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811092 */     // GIR_Coverage, 12674,
     /* 1811092 */     GIR_EraseRootFromParent_Done,
     /* 1811093 */   // Label 24555: @1811093
     /* 1811093 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1811179), // Rule ID 12675 //
     /* 1811098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1811109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1811112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1811115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811144 */     // MIs[0] policy
     /* 1811144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1811157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811178 */     // GIR_Coverage, 12675,
     /* 1811178 */     GIR_EraseRootFromParent_Done,
     /* 1811179 */   // Label 24556: @1811179
     /* 1811179 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1811265), // Rule ID 12678 //
     /* 1811184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811230 */     // MIs[0] policy
     /* 1811230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1811243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811264 */     // GIR_Coverage, 12678,
     /* 1811264 */     GIR_EraseRootFromParent_Done,
     /* 1811265 */   // Label 24557: @1811265
     /* 1811265 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1811351), // Rule ID 12679 //
     /* 1811270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1811287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811316 */     // MIs[0] policy
     /* 1811316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1811329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811350 */     // GIR_Coverage, 12679,
     /* 1811350 */     GIR_EraseRootFromParent_Done,
     /* 1811351 */   // Label 24558: @1811351
     /* 1811351 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1811437), // Rule ID 12682 //
     /* 1811356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811402 */     // MIs[0] policy
     /* 1811402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1811415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811436 */     // GIR_Coverage, 12682,
     /* 1811436 */     GIR_EraseRootFromParent_Done,
     /* 1811437 */   // Label 24559: @1811437
     /* 1811437 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1811523), // Rule ID 12683 //
     /* 1811442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811488 */     // MIs[0] policy
     /* 1811488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1811501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811522 */     // GIR_Coverage, 12683,
     /* 1811522 */     GIR_EraseRootFromParent_Done,
     /* 1811523 */   // Label 24560: @1811523
     /* 1811523 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1811609), // Rule ID 12686 //
     /* 1811528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811574 */     // MIs[0] policy
     /* 1811574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1811587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811608 */     // GIR_Coverage, 12686,
     /* 1811608 */     GIR_EraseRootFromParent_Done,
     /* 1811609 */   // Label 24561: @1811609
     /* 1811609 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1811695), // Rule ID 12687 //
     /* 1811614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811660 */     // MIs[0] policy
     /* 1811660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1811673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811694 */     // GIR_Coverage, 12687,
     /* 1811694 */     GIR_EraseRootFromParent_Done,
     /* 1811695 */   // Label 24562: @1811695
     /* 1811695 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1811781), // Rule ID 12690 //
     /* 1811700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811746 */     // MIs[0] policy
     /* 1811746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1811759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811780 */     // GIR_Coverage, 12690,
     /* 1811780 */     GIR_EraseRootFromParent_Done,
     /* 1811781 */   // Label 24563: @1811781
     /* 1811781 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1811867), // Rule ID 12691 //
     /* 1811786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811832 */     // MIs[0] policy
     /* 1811832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1811845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811866 */     // GIR_Coverage, 12691,
     /* 1811866 */     GIR_EraseRootFromParent_Done,
     /* 1811867 */   // Label 24564: @1811867
     /* 1811867 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1811953), // Rule ID 12694 //
     /* 1811872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1811892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1811914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811918 */     // MIs[0] policy
     /* 1811918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1811931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811952 */     // GIR_Coverage, 12694,
     /* 1811952 */     GIR_EraseRootFromParent_Done,
     /* 1811953 */   // Label 24565: @1811953
     /* 1811953 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1812039), // Rule ID 12695 //
     /* 1811958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1811978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812004 */     // MIs[0] policy
     /* 1812004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1812017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812038 */     // GIR_Coverage, 12695,
     /* 1812038 */     GIR_EraseRootFromParent_Done,
     /* 1812039 */   // Label 24566: @1812039
     /* 1812039 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1812125), // Rule ID 12698 //
     /* 1812044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812090 */     // MIs[0] policy
     /* 1812090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1812103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812124 */     // GIR_Coverage, 12698,
     /* 1812124 */     GIR_EraseRootFromParent_Done,
     /* 1812125 */   // Label 24567: @1812125
     /* 1812125 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1812211), // Rule ID 12699 //
     /* 1812130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1812141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1812144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1812147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812176 */     // MIs[0] policy
     /* 1812176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1812189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812210 */     // GIR_Coverage, 12699,
     /* 1812210 */     GIR_EraseRootFromParent_Done,
     /* 1812211 */   // Label 24568: @1812211
     /* 1812211 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1812297), // Rule ID 12702 //
     /* 1812216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812262 */     // MIs[0] policy
     /* 1812262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1812275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812296 */     // GIR_Coverage, 12702,
     /* 1812296 */     GIR_EraseRootFromParent_Done,
     /* 1812297 */   // Label 24569: @1812297
     /* 1812297 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1812383), // Rule ID 12703 //
     /* 1812302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1812313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1812316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1812319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1812325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812348 */     // MIs[0] policy
     /* 1812348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1812361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812382 */     // GIR_Coverage, 12703,
     /* 1812382 */     GIR_EraseRootFromParent_Done,
     /* 1812383 */   // Label 24570: @1812383
     /* 1812383 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1812469), // Rule ID 12706 //
     /* 1812388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812434 */     // MIs[0] policy
     /* 1812434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1812447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812468 */     // GIR_Coverage, 12706,
     /* 1812468 */     GIR_EraseRootFromParent_Done,
     /* 1812469 */   // Label 24571: @1812469
     /* 1812469 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1812555), // Rule ID 12707 //
     /* 1812474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812520 */     // MIs[0] policy
     /* 1812520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1812533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812554 */     // GIR_Coverage, 12707,
     /* 1812554 */     GIR_EraseRootFromParent_Done,
     /* 1812555 */   // Label 24572: @1812555
     /* 1812555 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1812641), // Rule ID 12710 //
     /* 1812560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812606 */     // MIs[0] policy
     /* 1812606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1812619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812640 */     // GIR_Coverage, 12710,
     /* 1812640 */     GIR_EraseRootFromParent_Done,
     /* 1812641 */   // Label 24573: @1812641
     /* 1812641 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1812727), // Rule ID 12711 //
     /* 1812646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812692 */     // MIs[0] policy
     /* 1812692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1812705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812726 */     // GIR_Coverage, 12711,
     /* 1812726 */     GIR_EraseRootFromParent_Done,
     /* 1812727 */   // Label 24574: @1812727
     /* 1812727 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1812813), // Rule ID 12714 //
     /* 1812732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812778 */     // MIs[0] policy
     /* 1812778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1812791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812812 */     // GIR_Coverage, 12714,
     /* 1812812 */     GIR_EraseRootFromParent_Done,
     /* 1812813 */   // Label 24575: @1812813
     /* 1812813 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1812899), // Rule ID 12715 //
     /* 1812818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812864 */     // MIs[0] policy
     /* 1812864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1812877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812898 */     // GIR_Coverage, 12715,
     /* 1812898 */     GIR_EraseRootFromParent_Done,
     /* 1812899 */   // Label 24576: @1812899
     /* 1812899 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1812985), // Rule ID 12718 //
     /* 1812904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1812921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812950 */     // MIs[0] policy
     /* 1812950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1812963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812984 */     // GIR_Coverage, 12718,
     /* 1812984 */     GIR_EraseRootFromParent_Done,
     /* 1812985 */   // Label 24577: @1812985
     /* 1812985 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1813071), // Rule ID 12719 //
     /* 1812990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1813001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1813004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1813007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813036 */     // MIs[0] policy
     /* 1813036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1813049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813070 */     // GIR_Coverage, 12719,
     /* 1813070 */     GIR_EraseRootFromParent_Done,
     /* 1813071 */   // Label 24578: @1813071
     /* 1813071 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1813157), // Rule ID 12722 //
     /* 1813076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1813087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1813090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1813096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813122 */     // MIs[0] policy
     /* 1813122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813132 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1813135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813156 */     // GIR_Coverage, 12722,
     /* 1813156 */     GIR_EraseRootFromParent_Done,
     /* 1813157 */   // Label 24579: @1813157
     /* 1813157 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1813243), // Rule ID 12723 //
     /* 1813162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1813173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1813176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1813182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813208 */     // MIs[0] policy
     /* 1813208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1813221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813242 */     // GIR_Coverage, 12723,
     /* 1813242 */     GIR_EraseRootFromParent_Done,
     /* 1813243 */   // Label 24580: @1813243
     /* 1813243 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1813329), // Rule ID 12726 //
     /* 1813248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1813259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1813262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1813268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813294 */     // MIs[0] policy
     /* 1813294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813304 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813328 */     // GIR_Coverage, 12726,
     /* 1813328 */     GIR_EraseRootFromParent_Done,
     /* 1813329 */   // Label 24581: @1813329
     /* 1813329 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1813415), // Rule ID 12727 //
     /* 1813334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1813345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1813348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1813354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813380 */     // MIs[0] policy
     /* 1813380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813414 */     // GIR_Coverage, 12727,
     /* 1813414 */     GIR_EraseRootFromParent_Done,
     /* 1813415 */   // Label 24582: @1813415
     /* 1813415 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1813501), // Rule ID 12730 //
     /* 1813420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1813440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813466 */     // MIs[0] policy
     /* 1813466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1813479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813500 */     // GIR_Coverage, 12730,
     /* 1813500 */     GIR_EraseRootFromParent_Done,
     /* 1813501 */   // Label 24583: @1813501
     /* 1813501 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1813587), // Rule ID 12731 //
     /* 1813506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1813517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1813520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1813526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813552 */     // MIs[0] policy
     /* 1813552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1813565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813586 */     // GIR_Coverage, 12731,
     /* 1813586 */     GIR_EraseRootFromParent_Done,
     /* 1813587 */   // Label 24584: @1813587
     /* 1813587 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1813673), // Rule ID 12734 //
     /* 1813592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1813609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1813612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813638 */     // MIs[0] policy
     /* 1813638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813672 */     // GIR_Coverage, 12734,
     /* 1813672 */     GIR_EraseRootFromParent_Done,
     /* 1813673 */   // Label 24585: @1813673
     /* 1813673 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1813759), // Rule ID 12735 //
     /* 1813678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1813695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1813698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813724 */     // MIs[0] policy
     /* 1813724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813758 */     // GIR_Coverage, 12735,
     /* 1813758 */     GIR_EraseRootFromParent_Done,
     /* 1813759 */   // Label 24586: @1813759
     /* 1813759 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1813845), // Rule ID 12738 //
     /* 1813764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1813781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1813784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813810 */     // MIs[0] policy
     /* 1813810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813844 */     // GIR_Coverage, 12738,
     /* 1813844 */     GIR_EraseRootFromParent_Done,
     /* 1813845 */   // Label 24587: @1813845
     /* 1813845 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1813931), // Rule ID 12739 //
     /* 1813850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1813867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1813870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813896 */     // MIs[0] policy
     /* 1813896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1813909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813930 */     // GIR_Coverage, 12739,
     /* 1813930 */     GIR_EraseRootFromParent_Done,
     /* 1813931 */   // Label 24588: @1813931
     /* 1813931 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1814017), // Rule ID 12742 //
     /* 1813936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1813947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1813950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1813956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813982 */     // MIs[0] policy
     /* 1813982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1813995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814016 */     // GIR_Coverage, 12742,
     /* 1814016 */     GIR_EraseRootFromParent_Done,
     /* 1814017 */   // Label 24589: @1814017
     /* 1814017 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1814103), // Rule ID 12743 //
     /* 1814022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1814033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1814036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1814039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1814042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814068 */     // MIs[0] policy
     /* 1814068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814102 */     // GIR_Coverage, 12743,
     /* 1814102 */     GIR_EraseRootFromParent_Done,
     /* 1814103 */   // Label 24590: @1814103
     /* 1814103 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1814189), // Rule ID 12746 //
     /* 1814108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1814119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1814122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1814128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814154 */     // MIs[0] policy
     /* 1814154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814188 */     // GIR_Coverage, 12746,
     /* 1814188 */     GIR_EraseRootFromParent_Done,
     /* 1814189 */   // Label 24591: @1814189
     /* 1814189 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1814275), // Rule ID 12747 //
     /* 1814194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1814205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1814208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1814214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814240 */     // MIs[0] policy
     /* 1814240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814274 */     // GIR_Coverage, 12747,
     /* 1814274 */     GIR_EraseRootFromParent_Done,
     /* 1814275 */   // Label 24592: @1814275
     /* 1814275 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1814361), // Rule ID 12750 //
     /* 1814280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1814300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814326 */     // MIs[0] policy
     /* 1814326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814360 */     // GIR_Coverage, 12750,
     /* 1814360 */     GIR_EraseRootFromParent_Done,
     /* 1814361 */   // Label 24593: @1814361
     /* 1814361 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1814447), // Rule ID 12751 //
     /* 1814366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1814386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814412 */     // MIs[0] policy
     /* 1814412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814446 */     // GIR_Coverage, 12751,
     /* 1814446 */     GIR_EraseRootFromParent_Done,
     /* 1814447 */   // Label 24594: @1814447
     /* 1814447 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1814533), // Rule ID 12754 //
     /* 1814452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1814455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1814469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1814472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814498 */     // MIs[0] policy
     /* 1814498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814532 */     // GIR_Coverage, 12754,
     /* 1814532 */     GIR_EraseRootFromParent_Done,
     /* 1814533 */   // Label 24595: @1814533
     /* 1814533 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1814619), // Rule ID 12755 //
     /* 1814538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1814541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1814555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1814558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814584 */     // MIs[0] policy
     /* 1814584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1814597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814618 */     // GIR_Coverage, 12755,
     /* 1814618 */     GIR_EraseRootFromParent_Done,
     /* 1814619 */   // Label 24596: @1814619
     /* 1814619 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1814705), // Rule ID 12758 //
     /* 1814624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1814635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1814638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1814641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814670 */     // MIs[0] policy
     /* 1814670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1814683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814704 */     // GIR_Coverage, 12758,
     /* 1814704 */     GIR_EraseRootFromParent_Done,
     /* 1814705 */   // Label 24597: @1814705
     /* 1814705 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1814791), // Rule ID 12759 //
     /* 1814710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1814721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1814724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1814727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814756 */     // MIs[0] policy
     /* 1814756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1814769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814790 */     // GIR_Coverage, 12759,
     /* 1814790 */     GIR_EraseRootFromParent_Done,
     /* 1814791 */   // Label 24598: @1814791
     /* 1814791 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1814877), // Rule ID 12762 //
     /* 1814796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1814807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1814810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814842 */     // MIs[0] policy
     /* 1814842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1814855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814876 */     // GIR_Coverage, 12762,
     /* 1814876 */     GIR_EraseRootFromParent_Done,
     /* 1814877 */   // Label 24599: @1814877
     /* 1814877 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1814963), // Rule ID 12763 //
     /* 1814882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1814893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1814896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1814899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814928 */     // MIs[0] policy
     /* 1814928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1814941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814962 */     // GIR_Coverage, 12763,
     /* 1814962 */     GIR_EraseRootFromParent_Done,
     /* 1814963 */   // Label 24600: @1814963
     /* 1814963 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1815049), // Rule ID 12766 //
     /* 1814968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1814979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1814982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1814985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1814988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1814991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815014 */     // MIs[0] policy
     /* 1815014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1815027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815048 */     // GIR_Coverage, 12766,
     /* 1815048 */     GIR_EraseRootFromParent_Done,
     /* 1815049 */   // Label 24601: @1815049
     /* 1815049 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1815135), // Rule ID 12767 //
     /* 1815054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1815065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1815068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1815071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1815074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1815077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815100 */     // MIs[0] policy
     /* 1815100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815110 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1815113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815134 */     // GIR_Coverage, 12767,
     /* 1815134 */     GIR_EraseRootFromParent_Done,
     /* 1815135 */   // Label 24602: @1815135
     /* 1815135 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1815221), // Rule ID 12770 //
     /* 1815140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1815151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1815154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1815157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1815160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815186 */     // MIs[0] policy
     /* 1815186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1815199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815220 */     // GIR_Coverage, 12770,
     /* 1815220 */     GIR_EraseRootFromParent_Done,
     /* 1815221 */   // Label 24603: @1815221
     /* 1815221 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1815307), // Rule ID 12771 //
     /* 1815226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1815237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1815240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1815243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1815246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815272 */     // MIs[0] policy
     /* 1815272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1815285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815306 */     // GIR_Coverage, 12771,
     /* 1815306 */     GIR_EraseRootFromParent_Done,
     /* 1815307 */   // Label 24604: @1815307
     /* 1815307 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1815393), // Rule ID 12774 //
     /* 1815312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1815323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1815326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1815332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815358 */     // MIs[0] policy
     /* 1815358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1815371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815392 */     // GIR_Coverage, 12774,
     /* 1815392 */     GIR_EraseRootFromParent_Done,
     /* 1815393 */   // Label 24605: @1815393
     /* 1815393 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1815479), // Rule ID 12775 //
     /* 1815398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1815409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1815412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1815415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1815418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815444 */     // MIs[0] policy
     /* 1815444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1815457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815478 */     // GIR_Coverage, 12775,
     /* 1815478 */     GIR_EraseRootFromParent_Done,
     /* 1815479 */   // Label 24606: @1815479
     /* 1815479 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1815565), // Rule ID 12778 //
     /* 1815484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1815495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1815498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1815501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1815504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1815507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815530 */     // MIs[0] policy
     /* 1815530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1815543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815564 */     // GIR_Coverage, 12778,
     /* 1815564 */     GIR_EraseRootFromParent_Done,
     /* 1815565 */   // Label 24607: @1815565
     /* 1815565 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1815651), // Rule ID 12779 //
     /* 1815570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1815581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1815584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1815587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1815590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1815593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815616 */     // MIs[0] policy
     /* 1815616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1815629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815650 */     // GIR_Coverage, 12779,
     /* 1815650 */     GIR_EraseRootFromParent_Done,
     /* 1815651 */   // Label 24608: @1815651
     /* 1815651 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1815737), // Rule ID 12782 //
     /* 1815656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1815676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815702 */     // MIs[0] policy
     /* 1815702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1815715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815736 */     // GIR_Coverage, 12782,
     /* 1815736 */     GIR_EraseRootFromParent_Done,
     /* 1815737 */   // Label 24609: @1815737
     /* 1815737 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1815823), // Rule ID 12783 //
     /* 1815742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1815762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815788 */     // MIs[0] policy
     /* 1815788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1815801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815822 */     // GIR_Coverage, 12783,
     /* 1815822 */     GIR_EraseRootFromParent_Done,
     /* 1815823 */   // Label 24610: @1815823
     /* 1815823 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1815909), // Rule ID 12786 //
     /* 1815828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1815848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815874 */     // MIs[0] policy
     /* 1815874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1815887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815908 */     // GIR_Coverage, 12786,
     /* 1815908 */     GIR_EraseRootFromParent_Done,
     /* 1815909 */   // Label 24611: @1815909
     /* 1815909 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1815995), // Rule ID 12787 //
     /* 1815914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1815934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815960 */     // MIs[0] policy
     /* 1815960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1815973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815994 */     // GIR_Coverage, 12787,
     /* 1815994 */     GIR_EraseRootFromParent_Done,
     /* 1815995 */   // Label 24612: @1815995
     /* 1815995 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1816081), // Rule ID 12790 //
     /* 1816000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1816011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1816014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1816017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1816020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816046 */     // MIs[0] policy
     /* 1816046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1816059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816080 */     // GIR_Coverage, 12790,
     /* 1816080 */     GIR_EraseRootFromParent_Done,
     /* 1816081 */   // Label 24613: @1816081
     /* 1816081 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1816167), // Rule ID 12791 //
     /* 1816086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1816097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1816100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1816103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1816106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816132 */     // MIs[0] policy
     /* 1816132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1816145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816166 */     // GIR_Coverage, 12791,
     /* 1816166 */     GIR_EraseRootFromParent_Done,
     /* 1816167 */   // Label 24614: @1816167
     /* 1816167 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1816253), // Rule ID 12794 //
     /* 1816172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1816175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1816183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1816186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1816189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1816192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816218 */     // MIs[0] policy
     /* 1816218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1816231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816252 */     // GIR_Coverage, 12794,
     /* 1816252 */     GIR_EraseRootFromParent_Done,
     /* 1816253 */   // Label 24615: @1816253
     /* 1816253 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1816339), // Rule ID 12795 //
     /* 1816258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1816269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1816272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1816275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1816278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816304 */     // MIs[0] policy
     /* 1816304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1816317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816338 */     // GIR_Coverage, 12795,
     /* 1816338 */     GIR_EraseRootFromParent_Done,
     /* 1816339 */   // Label 24616: @1816339
     /* 1816339 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1816425), // Rule ID 12798 //
     /* 1816344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1816347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1816355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1816358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1816361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1816364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816390 */     // MIs[0] policy
     /* 1816390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1816403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816424 */     // GIR_Coverage, 12798,
     /* 1816424 */     GIR_EraseRootFromParent_Done,
     /* 1816425 */   // Label 24617: @1816425
     /* 1816425 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1816511), // Rule ID 12799 //
     /* 1816430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1816441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1816444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1816447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1816450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1816460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1816472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816476 */     // MIs[0] policy
     /* 1816476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1816489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816510 */     // GIR_Coverage, 12799,
     /* 1816510 */     GIR_EraseRootFromParent_Done,
     /* 1816511 */   // Label 24618: @1816511
     /* 1816511 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1816597), // Rule ID 12802 //
     /* 1816516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1816519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1816527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1816530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1816533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1816536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816562 */     // MIs[0] policy
     /* 1816562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1816575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816596 */     // GIR_Coverage, 12802,
     /* 1816596 */     GIR_EraseRootFromParent_Done,
     /* 1816597 */   // Label 24619: @1816597
     /* 1816597 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1816683), // Rule ID 12803 //
     /* 1816602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1816613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1816616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1816619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1816622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816648 */     // MIs[0] policy
     /* 1816648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1816661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816682 */     // GIR_Coverage, 12803,
     /* 1816682 */     GIR_EraseRootFromParent_Done,
     /* 1816683 */   // Label 24620: @1816683
     /* 1816683 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1816769), // Rule ID 12806 //
     /* 1816688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1816699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1816702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1816705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1816708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816734 */     // MIs[0] policy
     /* 1816734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1816747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816768 */     // GIR_Coverage, 12806,
     /* 1816768 */     GIR_EraseRootFromParent_Done,
     /* 1816769 */   // Label 24621: @1816769
     /* 1816769 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1816855), // Rule ID 12807 //
     /* 1816774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1816785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1816788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1816791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1816794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816820 */     // MIs[0] policy
     /* 1816820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1816833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816854 */     // GIR_Coverage, 12807,
     /* 1816854 */     GIR_EraseRootFromParent_Done,
     /* 1816855 */   // Label 24622: @1816855
     /* 1816855 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1816941), // Rule ID 12810 //
     /* 1816860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1816871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1816874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1816877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1816880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816906 */     // MIs[0] policy
     /* 1816906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1816919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816940 */     // GIR_Coverage, 12810,
     /* 1816940 */     GIR_EraseRootFromParent_Done,
     /* 1816941 */   // Label 24623: @1816941
     /* 1816941 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1817027), // Rule ID 12811 //
     /* 1816946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1816957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1816960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1816963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1816966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816992 */     // MIs[0] policy
     /* 1816992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1817005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817026 */     // GIR_Coverage, 12811,
     /* 1817026 */     GIR_EraseRootFromParent_Done,
     /* 1817027 */   // Label 24624: @1817027
     /* 1817027 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1817113), // Rule ID 12814 //
     /* 1817032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1817043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1817046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1817052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817078 */     // MIs[0] policy
     /* 1817078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817088 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817112 */     // GIR_Coverage, 12814,
     /* 1817112 */     GIR_EraseRootFromParent_Done,
     /* 1817113 */   // Label 24625: @1817113
     /* 1817113 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1817199), // Rule ID 12815 //
     /* 1817118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1817129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1817132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1817138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817164 */     // MIs[0] policy
     /* 1817164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817198 */     // GIR_Coverage, 12815,
     /* 1817198 */     GIR_EraseRootFromParent_Done,
     /* 1817199 */   // Label 24626: @1817199
     /* 1817199 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1817285), // Rule ID 12818 //
     /* 1817204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1817215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1817218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1817224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817250 */     // MIs[0] policy
     /* 1817250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1817263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817284 */     // GIR_Coverage, 12818,
     /* 1817284 */     GIR_EraseRootFromParent_Done,
     /* 1817285 */   // Label 24627: @1817285
     /* 1817285 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1817371), // Rule ID 12819 //
     /* 1817290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1817301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1817304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1817310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817336 */     // MIs[0] policy
     /* 1817336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1817349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817370 */     // GIR_Coverage, 12819,
     /* 1817370 */     GIR_EraseRootFromParent_Done,
     /* 1817371 */   // Label 24628: @1817371
     /* 1817371 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1817457), // Rule ID 12822 //
     /* 1817376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1817387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1817390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1817396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817422 */     // MIs[0] policy
     /* 1817422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817432 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817456 */     // GIR_Coverage, 12822,
     /* 1817456 */     GIR_EraseRootFromParent_Done,
     /* 1817457 */   // Label 24629: @1817457
     /* 1817457 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1817543), // Rule ID 12823 //
     /* 1817462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1817473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1817476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1817482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817508 */     // MIs[0] policy
     /* 1817508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817542 */     // GIR_Coverage, 12823,
     /* 1817542 */     GIR_EraseRootFromParent_Done,
     /* 1817543 */   // Label 24630: @1817543
     /* 1817543 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1817629), // Rule ID 12826 //
     /* 1817548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1817568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817594 */     // MIs[0] policy
     /* 1817594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817628 */     // GIR_Coverage, 12826,
     /* 1817628 */     GIR_EraseRootFromParent_Done,
     /* 1817629 */   // Label 24631: @1817629
     /* 1817629 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1817715), // Rule ID 12827 //
     /* 1817634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1817654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817680 */     // MIs[0] policy
     /* 1817680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1817693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817714 */     // GIR_Coverage, 12827,
     /* 1817714 */     GIR_EraseRootFromParent_Done,
     /* 1817715 */   // Label 24632: @1817715
     /* 1817715 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1817801), // Rule ID 12830 //
     /* 1817720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1817731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1817734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1817740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817766 */     // MIs[0] policy
     /* 1817766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1817779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817800 */     // GIR_Coverage, 12830,
     /* 1817800 */     GIR_EraseRootFromParent_Done,
     /* 1817801 */   // Label 24633: @1817801
     /* 1817801 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1817887), // Rule ID 12831 //
     /* 1817806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1817817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1817820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1817826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817852 */     // MIs[0] policy
     /* 1817852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1817865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817886 */     // GIR_Coverage, 12831,
     /* 1817886 */     GIR_EraseRootFromParent_Done,
     /* 1817887 */   // Label 24634: @1817887
     /* 1817887 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1817973), // Rule ID 12834 //
     /* 1817892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1817903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1817906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1817909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1817912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1817930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817938 */     // MIs[0] policy
     /* 1817938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1817951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817972 */     // GIR_Coverage, 12834,
     /* 1817972 */     GIR_EraseRootFromParent_Done,
     /* 1817973 */   // Label 24635: @1817973
     /* 1817973 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1818059), // Rule ID 12835 //
     /* 1817978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1817989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1817992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1817995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1817998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818024 */     // MIs[0] policy
     /* 1818024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1818037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818058 */     // GIR_Coverage, 12835,
     /* 1818058 */     GIR_EraseRootFromParent_Done,
     /* 1818059 */   // Label 24636: @1818059
     /* 1818059 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1818145), // Rule ID 12838 //
     /* 1818064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1818075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1818078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1818084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818110 */     // MIs[0] policy
     /* 1818110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1818123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818144 */     // GIR_Coverage, 12838,
     /* 1818144 */     GIR_EraseRootFromParent_Done,
     /* 1818145 */   // Label 24637: @1818145
     /* 1818145 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1818231), // Rule ID 12839 //
     /* 1818150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1818161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1818164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1818167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1818170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818196 */     // MIs[0] policy
     /* 1818196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1818209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818230 */     // GIR_Coverage, 12839,
     /* 1818230 */     GIR_EraseRootFromParent_Done,
     /* 1818231 */   // Label 24638: @1818231
     /* 1818231 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1818317), // Rule ID 12842 //
     /* 1818236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1818256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818282 */     // MIs[0] policy
     /* 1818282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1818295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818316 */     // GIR_Coverage, 12842,
     /* 1818316 */     GIR_EraseRootFromParent_Done,
     /* 1818317 */   // Label 24639: @1818317
     /* 1818317 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1818403), // Rule ID 12843 //
     /* 1818322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1818333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1818336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1818339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1818342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818368 */     // MIs[0] policy
     /* 1818368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1818381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818402 */     // GIR_Coverage, 12843,
     /* 1818402 */     GIR_EraseRootFromParent_Done,
     /* 1818403 */   // Label 24640: @1818403
     /* 1818403 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1818489), // Rule ID 12846 //
     /* 1818408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1818419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1818422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1818428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818454 */     // MIs[0] policy
     /* 1818454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1818467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818488 */     // GIR_Coverage, 12846,
     /* 1818488 */     GIR_EraseRootFromParent_Done,
     /* 1818489 */   // Label 24641: @1818489
     /* 1818489 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1818575), // Rule ID 12847 //
     /* 1818494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1818505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1818508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1818511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1818514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818540 */     // MIs[0] policy
     /* 1818540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1818553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818574 */     // GIR_Coverage, 12847,
     /* 1818574 */     GIR_EraseRootFromParent_Done,
     /* 1818575 */   // Label 24642: @1818575
     /* 1818575 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1818661), // Rule ID 12850 //
     /* 1818580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1818591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1818594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1818600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818626 */     // MIs[0] policy
     /* 1818626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1818639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818660 */     // GIR_Coverage, 12850,
     /* 1818660 */     GIR_EraseRootFromParent_Done,
     /* 1818661 */   // Label 24643: @1818661
     /* 1818661 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1818747), // Rule ID 12851 //
     /* 1818666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1818677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1818680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1818683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1818686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818712 */     // MIs[0] policy
     /* 1818712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818722 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1818725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818746 */     // GIR_Coverage, 12851,
     /* 1818746 */     GIR_EraseRootFromParent_Done,
     /* 1818747 */   // Label 24644: @1818747
     /* 1818747 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1818833), // Rule ID 12854 //
     /* 1818752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1818763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1818766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1818772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1818775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818798 */     // MIs[0] policy
     /* 1818798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818808 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1818811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818832 */     // GIR_Coverage, 12854,
     /* 1818832 */     GIR_EraseRootFromParent_Done,
     /* 1818833 */   // Label 24645: @1818833
     /* 1818833 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1818919), // Rule ID 12855 //
     /* 1818838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1818849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1818852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1818855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1818858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1818861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818884 */     // MIs[0] policy
     /* 1818884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1818897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818918 */     // GIR_Coverage, 12855,
     /* 1818918 */     GIR_EraseRootFromParent_Done,
     /* 1818919 */   // Label 24646: @1818919
     /* 1818919 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1819005), // Rule ID 12858 //
     /* 1818924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1818935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1818938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1818944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818970 */     // MIs[0] policy
     /* 1818970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1818983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819004 */     // GIR_Coverage, 12858,
     /* 1819004 */     GIR_EraseRootFromParent_Done,
     /* 1819005 */   // Label 24647: @1819005
     /* 1819005 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1819091), // Rule ID 12859 //
     /* 1819010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1819021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1819024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1819030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819056 */     // MIs[0] policy
     /* 1819056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1819069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819090 */     // GIR_Coverage, 12859,
     /* 1819090 */     GIR_EraseRootFromParent_Done,
     /* 1819091 */   // Label 24648: @1819091
     /* 1819091 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1819177), // Rule ID 12862 //
     /* 1819096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1819107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1819110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1819116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819142 */     // MIs[0] policy
     /* 1819142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1819155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819176 */     // GIR_Coverage, 12862,
     /* 1819176 */     GIR_EraseRootFromParent_Done,
     /* 1819177 */   // Label 24649: @1819177
     /* 1819177 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1819263), // Rule ID 12863 //
     /* 1819182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1819193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1819196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1819202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819228 */     // MIs[0] policy
     /* 1819228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819238 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1819241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819262 */     // GIR_Coverage, 12863,
     /* 1819262 */     GIR_EraseRootFromParent_Done,
     /* 1819263 */   // Label 24650: @1819263
     /* 1819263 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1819349), // Rule ID 12866 //
     /* 1819268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1819279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1819282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1819288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1819291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819314 */     // MIs[0] policy
     /* 1819314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819324 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1819327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819348 */     // GIR_Coverage, 12866,
     /* 1819348 */     GIR_EraseRootFromParent_Done,
     /* 1819349 */   // Label 24651: @1819349
     /* 1819349 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1819435), // Rule ID 12867 //
     /* 1819354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1819365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1819368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1819374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1819377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819400 */     // MIs[0] policy
     /* 1819400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1819413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819434 */     // GIR_Coverage, 12867,
     /* 1819434 */     GIR_EraseRootFromParent_Done,
     /* 1819435 */   // Label 24652: @1819435
     /* 1819435 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1819521), // Rule ID 12870 //
     /* 1819440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1819451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1819454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1819460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819486 */     // MIs[0] policy
     /* 1819486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1819499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819520 */     // GIR_Coverage, 12870,
     /* 1819520 */     GIR_EraseRootFromParent_Done,
     /* 1819521 */   // Label 24653: @1819521
     /* 1819521 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1819607), // Rule ID 12871 //
     /* 1819526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1819537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1819540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1819546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819572 */     // MIs[0] policy
     /* 1819572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1819585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819606 */     // GIR_Coverage, 12871,
     /* 1819606 */     GIR_EraseRootFromParent_Done,
     /* 1819607 */   // Label 24654: @1819607
     /* 1819607 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1819693), // Rule ID 12874 //
     /* 1819612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1819632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819658 */     // MIs[0] policy
     /* 1819658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1819671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819692 */     // GIR_Coverage, 12874,
     /* 1819692 */     GIR_EraseRootFromParent_Done,
     /* 1819693 */   // Label 24655: @1819693
     /* 1819693 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1819779), // Rule ID 12875 //
     /* 1819698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1819718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819744 */     // MIs[0] policy
     /* 1819744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1819757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819778 */     // GIR_Coverage, 12875,
     /* 1819778 */     GIR_EraseRootFromParent_Done,
     /* 1819779 */   // Label 24656: @1819779
     /* 1819779 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1819865), // Rule ID 12878 //
     /* 1819784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1819804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819830 */     // MIs[0] policy
     /* 1819830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819840 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1819843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819864 */     // GIR_Coverage, 12878,
     /* 1819864 */     GIR_EraseRootFromParent_Done,
     /* 1819865 */   // Label 24657: @1819865
     /* 1819865 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1819951), // Rule ID 12879 //
     /* 1819870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1819890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819916 */     // MIs[0] policy
     /* 1819916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1819929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819950 */     // GIR_Coverage, 12879,
     /* 1819950 */     GIR_EraseRootFromParent_Done,
     /* 1819951 */   // Label 24658: @1819951
     /* 1819951 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1820037), // Rule ID 12882 //
     /* 1819956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1819967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1819970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1819976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820002 */     // MIs[0] policy
     /* 1820002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820036 */     // GIR_Coverage, 12882,
     /* 1820036 */     GIR_EraseRootFromParent_Done,
     /* 1820037 */   // Label 24659: @1820037
     /* 1820037 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1820123), // Rule ID 12883 //
     /* 1820042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1820053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1820056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1820062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820088 */     // MIs[0] policy
     /* 1820088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820122 */     // GIR_Coverage, 12883,
     /* 1820122 */     GIR_EraseRootFromParent_Done,
     /* 1820123 */   // Label 24660: @1820123
     /* 1820123 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1820209), // Rule ID 12886 //
     /* 1820128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1820139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1820142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1820148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820174 */     // MIs[0] policy
     /* 1820174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820208 */     // GIR_Coverage, 12886,
     /* 1820208 */     GIR_EraseRootFromParent_Done,
     /* 1820209 */   // Label 24661: @1820209
     /* 1820209 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1820295), // Rule ID 12887 //
     /* 1820214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1820225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1820228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1820234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820260 */     // MIs[0] policy
     /* 1820260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820294 */     // GIR_Coverage, 12887,
     /* 1820294 */     GIR_EraseRootFromParent_Done,
     /* 1820295 */   // Label 24662: @1820295
     /* 1820295 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1820381), // Rule ID 12890 //
     /* 1820300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1820311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1820314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1820320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1820330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820346 */     // MIs[0] policy
     /* 1820346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820356 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1820359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820380 */     // GIR_Coverage, 12890,
     /* 1820380 */     GIR_EraseRootFromParent_Done,
     /* 1820381 */   // Label 24663: @1820381
     /* 1820381 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1820467), // Rule ID 12891 //
     /* 1820386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1820397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1820400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1820406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1820416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1820428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820432 */     // MIs[0] policy
     /* 1820432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1820445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820466 */     // GIR_Coverage, 12891,
     /* 1820466 */     GIR_EraseRootFromParent_Done,
     /* 1820467 */   // Label 24664: @1820467
     /* 1820467 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1820553), // Rule ID 12894 //
     /* 1820472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1820483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1820486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1820489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1820492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820518 */     // MIs[0] policy
     /* 1820518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820528 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1820531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820552 */     // GIR_Coverage, 12894,
     /* 1820552 */     GIR_EraseRootFromParent_Done,
     /* 1820553 */   // Label 24665: @1820553
     /* 1820553 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1820639), // Rule ID 12895 //
     /* 1820558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1820569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1820572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1820575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1820578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820604 */     // MIs[0] policy
     /* 1820604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1820617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820638 */     // GIR_Coverage, 12895,
     /* 1820638 */     GIR_EraseRootFromParent_Done,
     /* 1820639 */   // Label 24666: @1820639
     /* 1820639 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1820725), // Rule ID 12898 //
     /* 1820644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1820661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1820664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820690 */     // MIs[0] policy
     /* 1820690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1820703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820724 */     // GIR_Coverage, 12898,
     /* 1820724 */     GIR_EraseRootFromParent_Done,
     /* 1820725 */   // Label 24667: @1820725
     /* 1820725 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1820811), // Rule ID 12899 //
     /* 1820730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1820747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1820750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820776 */     // MIs[0] policy
     /* 1820776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1820789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820810 */     // GIR_Coverage, 12899,
     /* 1820810 */     GIR_EraseRootFromParent_Done,
     /* 1820811 */   // Label 24668: @1820811
     /* 1820811 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1820897), // Rule ID 12902 //
     /* 1820816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1820833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1820836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820862 */     // MIs[0] policy
     /* 1820862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820872 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1820875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820896 */     // GIR_Coverage, 12902,
     /* 1820896 */     GIR_EraseRootFromParent_Done,
     /* 1820897 */   // Label 24669: @1820897
     /* 1820897 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1820983), // Rule ID 12903 //
     /* 1820902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1820919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1820922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820948 */     // MIs[0] policy
     /* 1820948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1820961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820982 */     // GIR_Coverage, 12903,
     /* 1820982 */     GIR_EraseRootFromParent_Done,
     /* 1820983 */   // Label 24670: @1820983
     /* 1820983 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1821069), // Rule ID 12906 //
     /* 1820988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1821002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1821005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1821008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821034 */     // MIs[0] policy
     /* 1821034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1821047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821068 */     // GIR_Coverage, 12906,
     /* 1821068 */     GIR_EraseRootFromParent_Done,
     /* 1821069 */   // Label 24671: @1821069
     /* 1821069 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1821155), // Rule ID 12907 //
     /* 1821074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1821085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1821088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1821091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1821094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821120 */     // MIs[0] policy
     /* 1821120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1821133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821154 */     // GIR_Coverage, 12907,
     /* 1821154 */     GIR_EraseRootFromParent_Done,
     /* 1821155 */   // Label 24672: @1821155
     /* 1821155 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1821241), // Rule ID 12910 //
     /* 1821160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1821171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1821174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1821177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1821180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821206 */     // MIs[0] policy
     /* 1821206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1821219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821240 */     // GIR_Coverage, 12910,
     /* 1821240 */     GIR_EraseRootFromParent_Done,
     /* 1821241 */   // Label 24673: @1821241
     /* 1821241 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1821327), // Rule ID 12911 //
     /* 1821246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1821257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1821260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1821263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1821266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821292 */     // MIs[0] policy
     /* 1821292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1821305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821326 */     // GIR_Coverage, 12911,
     /* 1821326 */     GIR_EraseRootFromParent_Done,
     /* 1821327 */   // Label 24674: @1821327
     /* 1821327 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1821413), // Rule ID 12914 //
     /* 1821332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1821343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1821346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1821349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1821352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821378 */     // MIs[0] policy
     /* 1821378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821388 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1821391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821412 */     // GIR_Coverage, 12914,
     /* 1821412 */     GIR_EraseRootFromParent_Done,
     /* 1821413 */   // Label 24675: @1821413
     /* 1821413 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1821499), // Rule ID 12915 //
     /* 1821418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1821429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1821432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1821435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1821438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821464 */     // MIs[0] policy
     /* 1821464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1821477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821498 */     // GIR_Coverage, 12915,
     /* 1821498 */     GIR_EraseRootFromParent_Done,
     /* 1821499 */   // Label 24676: @1821499
     /* 1821499 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1821585), // Rule ID 12918 //
     /* 1821504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1821515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1821518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1821521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1821524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821550 */     // MIs[0] policy
     /* 1821550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821584 */     // GIR_Coverage, 12918,
     /* 1821584 */     GIR_EraseRootFromParent_Done,
     /* 1821585 */   // Label 24677: @1821585
     /* 1821585 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1821671), // Rule ID 12919 //
     /* 1821590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1821601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1821604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1821607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1821610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821636 */     // MIs[0] policy
     /* 1821636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821670 */     // GIR_Coverage, 12919,
     /* 1821670 */     GIR_EraseRootFromParent_Done,
     /* 1821671 */   // Label 24678: @1821671
     /* 1821671 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1821757), // Rule ID 12922 //
     /* 1821676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1821693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1821696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821722 */     // MIs[0] policy
     /* 1821722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821756 */     // GIR_Coverage, 12922,
     /* 1821756 */     GIR_EraseRootFromParent_Done,
     /* 1821757 */   // Label 24679: @1821757
     /* 1821757 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1821843), // Rule ID 12923 //
     /* 1821762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1821779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1821782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821808 */     // MIs[0] policy
     /* 1821808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821842 */     // GIR_Coverage, 12923,
     /* 1821842 */     GIR_EraseRootFromParent_Done,
     /* 1821843 */   // Label 24680: @1821843
     /* 1821843 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1821929), // Rule ID 12926 //
     /* 1821848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1821865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1821868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821894 */     // MIs[0] policy
     /* 1821894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821928 */     // GIR_Coverage, 12926,
     /* 1821928 */     GIR_EraseRootFromParent_Done,
     /* 1821929 */   // Label 24681: @1821929
     /* 1821929 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1822015), // Rule ID 12927 //
     /* 1821934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1821951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1821954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821980 */     // MIs[0] policy
     /* 1821980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1821993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822014 */     // GIR_Coverage, 12927,
     /* 1822014 */     GIR_EraseRootFromParent_Done,
     /* 1822015 */   // Label 24682: @1822015
     /* 1822015 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1822101), // Rule ID 12930 //
     /* 1822020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1822031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1822034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1822037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1822040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822066 */     // MIs[0] policy
     /* 1822066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1822079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822100 */     // GIR_Coverage, 12930,
     /* 1822100 */     GIR_EraseRootFromParent_Done,
     /* 1822101 */   // Label 24683: @1822101
     /* 1822101 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1822187), // Rule ID 12931 //
     /* 1822106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1822117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1822120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1822123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1822126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822152 */     // MIs[0] policy
     /* 1822152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1822165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822186 */     // GIR_Coverage, 12931,
     /* 1822186 */     GIR_EraseRootFromParent_Done,
     /* 1822187 */   // Label 24684: @1822187
     /* 1822187 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1822273), // Rule ID 12934 //
     /* 1822192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1822203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1822206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1822209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1822212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822238 */     // MIs[0] policy
     /* 1822238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1822251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822272 */     // GIR_Coverage, 12934,
     /* 1822272 */     GIR_EraseRootFromParent_Done,
     /* 1822273 */   // Label 24685: @1822273
     /* 1822273 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1822359), // Rule ID 12935 //
     /* 1822278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1822289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1822292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1822295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1822298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822324 */     // MIs[0] policy
     /* 1822324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1822337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822358 */     // GIR_Coverage, 12935,
     /* 1822358 */     GIR_EraseRootFromParent_Done,
     /* 1822359 */   // Label 24686: @1822359
     /* 1822359 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1822445), // Rule ID 12938 //
     /* 1822364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1822375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1822378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1822381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1822384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822410 */     // MIs[0] policy
     /* 1822410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1822423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822444 */     // GIR_Coverage, 12938,
     /* 1822444 */     GIR_EraseRootFromParent_Done,
     /* 1822445 */   // Label 24687: @1822445
     /* 1822445 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1822531), // Rule ID 12939 //
     /* 1822450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1822461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1822464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1822467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1822470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822496 */     // MIs[0] policy
     /* 1822496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1822509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822530 */     // GIR_Coverage, 12939,
     /* 1822530 */     GIR_EraseRootFromParent_Done,
     /* 1822531 */   // Label 24688: @1822531
     /* 1822531 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1822617), // Rule ID 12942 //
     /* 1822536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1822547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1822550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1822553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1822556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1822559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822582 */     // MIs[0] policy
     /* 1822582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822592 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1822595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822616 */     // GIR_Coverage, 12942,
     /* 1822616 */     GIR_EraseRootFromParent_Done,
     /* 1822617 */   // Label 24689: @1822617
     /* 1822617 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1822703), // Rule ID 12943 //
     /* 1822622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1822633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1822636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1822639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1822642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1822645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822668 */     // MIs[0] policy
     /* 1822668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1822681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822702 */     // GIR_Coverage, 12943,
     /* 1822702 */     GIR_EraseRootFromParent_Done,
     /* 1822703 */   // Label 24690: @1822703
     /* 1822703 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1822789), // Rule ID 12946 //
     /* 1822708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1822725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1822728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822754 */     // MIs[0] policy
     /* 1822754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1822767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822788 */     // GIR_Coverage, 12946,
     /* 1822788 */     GIR_EraseRootFromParent_Done,
     /* 1822789 */   // Label 24691: @1822789
     /* 1822789 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1822875), // Rule ID 12947 //
     /* 1822794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1822811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1822814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822840 */     // MIs[0] policy
     /* 1822840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1822853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822874 */     // GIR_Coverage, 12947,
     /* 1822874 */     GIR_EraseRootFromParent_Done,
     /* 1822875 */   // Label 24692: @1822875
     /* 1822875 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1822961), // Rule ID 12950 //
     /* 1822880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1822897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1822900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822926 */     // MIs[0] policy
     /* 1822926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1822939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822960 */     // GIR_Coverage, 12950,
     /* 1822960 */     GIR_EraseRootFromParent_Done,
     /* 1822961 */   // Label 24693: @1822961
     /* 1822961 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1823047), // Rule ID 12951 //
     /* 1822966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1822983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1822986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823012 */     // MIs[0] policy
     /* 1823012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1823025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823046 */     // GIR_Coverage, 12951,
     /* 1823046 */     GIR_EraseRootFromParent_Done,
     /* 1823047 */   // Label 24694: @1823047
     /* 1823047 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1823133), // Rule ID 12954 //
     /* 1823052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1823063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1823066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1823069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1823072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1823075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823098 */     // MIs[0] policy
     /* 1823098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1823111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823132 */     // GIR_Coverage, 12954,
     /* 1823132 */     GIR_EraseRootFromParent_Done,
     /* 1823133 */   // Label 24695: @1823133
     /* 1823133 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1823219), // Rule ID 12955 //
     /* 1823138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1823149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1823152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1823155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1823158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1823161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823184 */     // MIs[0] policy
     /* 1823184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1823197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823218 */     // GIR_Coverage, 12955,
     /* 1823218 */     GIR_EraseRootFromParent_Done,
     /* 1823219 */   // Label 24696: @1823219
     /* 1823219 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1823305), // Rule ID 12958 //
     /* 1823224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1823235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1823238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1823241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1823244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823270 */     // MIs[0] policy
     /* 1823270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1823283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823304 */     // GIR_Coverage, 12958,
     /* 1823304 */     GIR_EraseRootFromParent_Done,
     /* 1823305 */   // Label 24697: @1823305
     /* 1823305 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1823391), // Rule ID 12959 //
     /* 1823310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1823321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1823324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1823327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1823330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823356 */     // MIs[0] policy
     /* 1823356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1823369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823390 */     // GIR_Coverage, 12959,
     /* 1823390 */     GIR_EraseRootFromParent_Done,
     /* 1823391 */   // Label 24698: @1823391
     /* 1823391 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1823477), // Rule ID 12962 //
     /* 1823396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1823407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1823410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1823413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1823416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823442 */     // MIs[0] policy
     /* 1823442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1823455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823476 */     // GIR_Coverage, 12962,
     /* 1823476 */     GIR_EraseRootFromParent_Done,
     /* 1823477 */   // Label 24699: @1823477
     /* 1823477 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1823563), // Rule ID 12963 //
     /* 1823482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1823493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1823496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1823499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1823502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823528 */     // MIs[0] policy
     /* 1823528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1823541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823562 */     // GIR_Coverage, 12963,
     /* 1823562 */     GIR_EraseRootFromParent_Done,
     /* 1823563 */   // Label 24700: @1823563
     /* 1823563 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1823649), // Rule ID 12966 //
     /* 1823568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1823585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1823588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823614 */     // MIs[0] policy
     /* 1823614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1823627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823648 */     // GIR_Coverage, 12966,
     /* 1823648 */     GIR_EraseRootFromParent_Done,
     /* 1823649 */   // Label 24701: @1823649
     /* 1823649 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1823735), // Rule ID 12967 //
     /* 1823654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1823671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1823674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823700 */     // MIs[0] policy
     /* 1823700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1823713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823734 */     // GIR_Coverage, 12967,
     /* 1823734 */     GIR_EraseRootFromParent_Done,
     /* 1823735 */   // Label 24702: @1823735
     /* 1823735 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1823821), // Rule ID 12970 //
     /* 1823740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1823757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1823760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823786 */     // MIs[0] policy
     /* 1823786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1823799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823820 */     // GIR_Coverage, 12970,
     /* 1823820 */     GIR_EraseRootFromParent_Done,
     /* 1823821 */   // Label 24703: @1823821
     /* 1823821 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1823907), // Rule ID 12971 //
     /* 1823826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1823843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1823846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823872 */     // MIs[0] policy
     /* 1823872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1823885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823906 */     // GIR_Coverage, 12971,
     /* 1823906 */     GIR_EraseRootFromParent_Done,
     /* 1823907 */   // Label 24704: @1823907
     /* 1823907 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1823993), // Rule ID 12974 //
     /* 1823912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1823923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1823926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1823929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1823932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823958 */     // MIs[0] policy
     /* 1823958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1823971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823992 */     // GIR_Coverage, 12974,
     /* 1823992 */     GIR_EraseRootFromParent_Done,
     /* 1823993 */   // Label 24705: @1823993
     /* 1823993 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1824079), // Rule ID 12975 //
     /* 1823998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1824009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1824012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1824015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1824018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824044 */     // MIs[0] policy
     /* 1824044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1824057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824078 */     // GIR_Coverage, 12975,
     /* 1824078 */     GIR_EraseRootFromParent_Done,
     /* 1824079 */   // Label 24706: @1824079
     /* 1824079 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1824165), // Rule ID 12978 //
     /* 1824084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1824095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1824098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1824101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1824104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824130 */     // MIs[0] policy
     /* 1824130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824164 */     // GIR_Coverage, 12978,
     /* 1824164 */     GIR_EraseRootFromParent_Done,
     /* 1824165 */   // Label 24707: @1824165
     /* 1824165 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1824251), // Rule ID 12979 //
     /* 1824170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1824181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1824184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1824187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1824190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824216 */     // MIs[0] policy
     /* 1824216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824250 */     // GIR_Coverage, 12979,
     /* 1824250 */     GIR_EraseRootFromParent_Done,
     /* 1824251 */   // Label 24708: @1824251
     /* 1824251 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1824337), // Rule ID 12982 //
     /* 1824256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1824267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1824270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1824276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824302 */     // MIs[0] policy
     /* 1824302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824312 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1824315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824336 */     // GIR_Coverage, 12982,
     /* 1824336 */     GIR_EraseRootFromParent_Done,
     /* 1824337 */   // Label 24709: @1824337
     /* 1824337 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1824423), // Rule ID 12983 //
     /* 1824342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1824353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1824356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1824362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824388 */     // MIs[0] policy
     /* 1824388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1824401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824422 */     // GIR_Coverage, 12983,
     /* 1824422 */     GIR_EraseRootFromParent_Done,
     /* 1824423 */   // Label 24710: @1824423
     /* 1824423 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1824509), // Rule ID 12986 //
     /* 1824428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1824439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1824442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1824448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824474 */     // MIs[0] policy
     /* 1824474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1824487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824508 */     // GIR_Coverage, 12986,
     /* 1824508 */     GIR_EraseRootFromParent_Done,
     /* 1824509 */   // Label 24711: @1824509
     /* 1824509 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1824595), // Rule ID 12987 //
     /* 1824514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1824525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1824528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1824534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824560 */     // MIs[0] policy
     /* 1824560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1824573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824594 */     // GIR_Coverage, 12987,
     /* 1824594 */     GIR_EraseRootFromParent_Done,
     /* 1824595 */   // Label 24712: @1824595
     /* 1824595 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1824681), // Rule ID 12990 //
     /* 1824600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1824620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824646 */     // MIs[0] policy
     /* 1824646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824656 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1824659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824680 */     // GIR_Coverage, 12990,
     /* 1824680 */     GIR_EraseRootFromParent_Done,
     /* 1824681 */   // Label 24713: @1824681
     /* 1824681 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1824767), // Rule ID 12991 //
     /* 1824686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1824706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824732 */     // MIs[0] policy
     /* 1824732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1824745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824766 */     // GIR_Coverage, 12991,
     /* 1824766 */     GIR_EraseRootFromParent_Done,
     /* 1824767 */   // Label 24714: @1824767
     /* 1824767 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1824853), // Rule ID 12994 //
     /* 1824772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1824792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824818 */     // MIs[0] policy
     /* 1824818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824828 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1824831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824852 */     // GIR_Coverage, 12994,
     /* 1824852 */     GIR_EraseRootFromParent_Done,
     /* 1824853 */   // Label 24715: @1824853
     /* 1824853 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1824939), // Rule ID 12995 //
     /* 1824858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1824875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1824878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824904 */     // MIs[0] policy
     /* 1824904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1824917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824938 */     // GIR_Coverage, 12995,
     /* 1824938 */     GIR_EraseRootFromParent_Done,
     /* 1824939 */   // Label 24716: @1824939
     /* 1824939 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1825025), // Rule ID 12998 //
     /* 1824944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1824955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1824958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1824961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1824964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1824982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824990 */     // MIs[0] policy
     /* 1824990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1825003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825024 */     // GIR_Coverage, 12998,
     /* 1825024 */     GIR_EraseRootFromParent_Done,
     /* 1825025 */   // Label 24717: @1825025
     /* 1825025 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1825111), // Rule ID 12999 //
     /* 1825030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1825041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1825044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1825050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825076 */     // MIs[0] policy
     /* 1825076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1825089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825110 */     // GIR_Coverage, 12999,
     /* 1825110 */     GIR_EraseRootFromParent_Done,
     /* 1825111 */   // Label 24718: @1825111
     /* 1825111 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1825197), // Rule ID 13002 //
     /* 1825116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1825127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1825130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1825136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825162 */     // MIs[0] policy
     /* 1825162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1825175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825196 */     // GIR_Coverage, 13002,
     /* 1825196 */     GIR_EraseRootFromParent_Done,
     /* 1825197 */   // Label 24719: @1825197
     /* 1825197 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1825283), // Rule ID 13003 //
     /* 1825202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1825213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1825216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1825222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825248 */     // MIs[0] policy
     /* 1825248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1825261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825282 */     // GIR_Coverage, 13003,
     /* 1825282 */     GIR_EraseRootFromParent_Done,
     /* 1825283 */   // Label 24720: @1825283
     /* 1825283 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1825369), // Rule ID 13006 //
     /* 1825288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1825299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1825302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1825308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825334 */     // MIs[0] policy
     /* 1825334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825368 */     // GIR_Coverage, 13006,
     /* 1825368 */     GIR_EraseRootFromParent_Done,
     /* 1825369 */   // Label 24721: @1825369
     /* 1825369 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1825455), // Rule ID 13007 //
     /* 1825374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1825385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1825388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1825394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825420 */     // MIs[0] policy
     /* 1825420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825454 */     // GIR_Coverage, 13007,
     /* 1825454 */     GIR_EraseRootFromParent_Done,
     /* 1825455 */   // Label 24722: @1825455
     /* 1825455 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1825541), // Rule ID 13010 //
     /* 1825460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1825471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1825474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1825480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825506 */     // MIs[0] policy
     /* 1825506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825540 */     // GIR_Coverage, 13010,
     /* 1825540 */     GIR_EraseRootFromParent_Done,
     /* 1825541 */   // Label 24723: @1825541
     /* 1825541 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1825627), // Rule ID 13011 //
     /* 1825546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1825557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1825560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1825566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825592 */     // MIs[0] policy
     /* 1825592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825626 */     // GIR_Coverage, 13011,
     /* 1825626 */     GIR_EraseRootFromParent_Done,
     /* 1825627 */   // Label 24724: @1825627
     /* 1825627 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1825713), // Rule ID 13014 //
     /* 1825632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1825652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825678 */     // MIs[0] policy
     /* 1825678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825712 */     // GIR_Coverage, 13014,
     /* 1825712 */     GIR_EraseRootFromParent_Done,
     /* 1825713 */   // Label 24725: @1825713
     /* 1825713 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1825799), // Rule ID 13015 //
     /* 1825718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1825738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825764 */     // MIs[0] policy
     /* 1825764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825798 */     // GIR_Coverage, 13015,
     /* 1825798 */     GIR_EraseRootFromParent_Done,
     /* 1825799 */   // Label 24726: @1825799
     /* 1825799 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1825885), // Rule ID 13018 //
     /* 1825804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1825807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1825824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825850 */     // MIs[0] policy
     /* 1825850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825884 */     // GIR_Coverage, 13018,
     /* 1825884 */     GIR_EraseRootFromParent_Done,
     /* 1825885 */   // Label 24727: @1825885
     /* 1825885 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1825971), // Rule ID 13019 //
     /* 1825890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1825893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1825907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1825910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1825928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825936 */     // MIs[0] policy
     /* 1825936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1825949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825970 */     // GIR_Coverage, 13019,
     /* 1825970 */     GIR_EraseRootFromParent_Done,
     /* 1825971 */   // Label 24728: @1825971
     /* 1825971 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1826057), // Rule ID 13022 //
     /* 1825976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1825987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1825993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1825996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826022 */     // MIs[0] policy
     /* 1826022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1826035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826056 */     // GIR_Coverage, 13022,
     /* 1826056 */     GIR_EraseRootFromParent_Done,
     /* 1826057 */   // Label 24729: @1826057
     /* 1826057 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1826143), // Rule ID 13023 //
     /* 1826062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1826073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1826076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1826082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826108 */     // MIs[0] policy
     /* 1826108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1826121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826142 */     // GIR_Coverage, 13023,
     /* 1826142 */     GIR_EraseRootFromParent_Done,
     /* 1826143 */   // Label 24730: @1826143
     /* 1826143 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1826229), // Rule ID 13026 //
     /* 1826148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1826159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1826162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1826168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826194 */     // MIs[0] policy
     /* 1826194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1826207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826228 */     // GIR_Coverage, 13026,
     /* 1826228 */     GIR_EraseRootFromParent_Done,
     /* 1826229 */   // Label 24731: @1826229
     /* 1826229 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1826315), // Rule ID 13027 //
     /* 1826234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1826245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1826248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1826254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826280 */     // MIs[0] policy
     /* 1826280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1826293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826314 */     // GIR_Coverage, 13027,
     /* 1826314 */     GIR_EraseRootFromParent_Done,
     /* 1826315 */   // Label 24732: @1826315
     /* 1826315 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1826401), // Rule ID 13030 //
     /* 1826320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1826331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1826334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1826340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1826343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826366 */     // MIs[0] policy
     /* 1826366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826376 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1826379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826400 */     // GIR_Coverage, 13030,
     /* 1826400 */     GIR_EraseRootFromParent_Done,
     /* 1826401 */   // Label 24733: @1826401
     /* 1826401 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1826487), // Rule ID 13031 //
     /* 1826406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1826417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1826420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1826426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1826429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826452 */     // MIs[0] policy
     /* 1826452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1826465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826486 */     // GIR_Coverage, 13031,
     /* 1826486 */     GIR_EraseRootFromParent_Done,
     /* 1826487 */   // Label 24734: @1826487
     /* 1826487 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1826573), // Rule ID 13034 //
     /* 1826492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1826503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1826506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1826512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826538 */     // MIs[0] policy
     /* 1826538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1826551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826572 */     // GIR_Coverage, 13034,
     /* 1826572 */     GIR_EraseRootFromParent_Done,
     /* 1826573 */   // Label 24735: @1826573
     /* 1826573 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1826659), // Rule ID 13035 //
     /* 1826578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1826589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1826592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1826598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826624 */     // MIs[0] policy
     /* 1826624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1826637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826658 */     // GIR_Coverage, 13035,
     /* 1826658 */     GIR_EraseRootFromParent_Done,
     /* 1826659 */   // Label 24736: @1826659
     /* 1826659 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1826745), // Rule ID 13038 //
     /* 1826664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1826684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826710 */     // MIs[0] policy
     /* 1826710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1826723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826744 */     // GIR_Coverage, 13038,
     /* 1826744 */     GIR_EraseRootFromParent_Done,
     /* 1826745 */   // Label 24737: @1826745
     /* 1826745 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1826831), // Rule ID 13039 //
     /* 1826750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1826770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826796 */     // MIs[0] policy
     /* 1826796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1826809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826830 */     // GIR_Coverage, 13039,
     /* 1826830 */     GIR_EraseRootFromParent_Done,
     /* 1826831 */   // Label 24738: @1826831
     /* 1826831 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1826917), // Rule ID 13042 //
     /* 1826836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1826856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826882 */     // MIs[0] policy
     /* 1826882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826892 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1826895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826916 */     // GIR_Coverage, 13042,
     /* 1826916 */     GIR_EraseRootFromParent_Done,
     /* 1826917 */   // Label 24739: @1826917
     /* 1826917 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1827003), // Rule ID 13043 //
     /* 1826922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1826942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826968 */     // MIs[0] policy
     /* 1826968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1826981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827002 */     // GIR_Coverage, 13043,
     /* 1827002 */     GIR_EraseRootFromParent_Done,
     /* 1827003 */   // Label 24740: @1827003
     /* 1827003 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1827089), // Rule ID 13046 //
     /* 1827008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1827019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1827022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1827028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827054 */     // MIs[0] policy
     /* 1827054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1827067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827088 */     // GIR_Coverage, 13046,
     /* 1827088 */     GIR_EraseRootFromParent_Done,
     /* 1827089 */   // Label 24741: @1827089
     /* 1827089 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1827175), // Rule ID 13047 //
     /* 1827094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1827105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1827108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1827114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827140 */     // MIs[0] policy
     /* 1827140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1827153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827174 */     // GIR_Coverage, 13047,
     /* 1827174 */     GIR_EraseRootFromParent_Done,
     /* 1827175 */   // Label 24742: @1827175
     /* 1827175 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1827261), // Rule ID 13050 //
     /* 1827180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1827191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1827194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1827200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827226 */     // MIs[0] policy
     /* 1827226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1827239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827260 */     // GIR_Coverage, 13050,
     /* 1827260 */     GIR_EraseRootFromParent_Done,
     /* 1827261 */   // Label 24743: @1827261
     /* 1827261 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1827347), // Rule ID 13051 //
     /* 1827266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1827277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1827280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1827286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827312 */     // MIs[0] policy
     /* 1827312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1827325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827346 */     // GIR_Coverage, 13051,
     /* 1827346 */     GIR_EraseRootFromParent_Done,
     /* 1827347 */   // Label 24744: @1827347
     /* 1827347 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1827433), // Rule ID 13054 //
     /* 1827352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1827363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1827366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1827372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1827375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827398 */     // MIs[0] policy
     /* 1827398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1827411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827432 */     // GIR_Coverage, 13054,
     /* 1827432 */     GIR_EraseRootFromParent_Done,
     /* 1827433 */   // Label 24745: @1827433
     /* 1827433 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1827519), // Rule ID 13055 //
     /* 1827438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1827449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1827452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1827458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1827461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827484 */     // MIs[0] policy
     /* 1827484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1827497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827518 */     // GIR_Coverage, 13055,
     /* 1827518 */     GIR_EraseRootFromParent_Done,
     /* 1827519 */   // Label 24746: @1827519
     /* 1827519 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1827605), // Rule ID 13058 //
     /* 1827524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1827535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1827538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1827544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827570 */     // MIs[0] policy
     /* 1827570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1827583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827604 */     // GIR_Coverage, 13058,
     /* 1827604 */     GIR_EraseRootFromParent_Done,
     /* 1827605 */   // Label 24747: @1827605
     /* 1827605 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1827691), // Rule ID 13059 //
     /* 1827610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1827621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1827624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1827630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827656 */     // MIs[0] policy
     /* 1827656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11429:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1827669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827690 */     // GIR_Coverage, 13059,
     /* 1827690 */     GIR_EraseRootFromParent_Done,
     /* 1827691 */   // Label 24748: @1827691
     /* 1827691 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1827777), // Rule ID 13062 //
     /* 1827696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1827716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827742 */     // MIs[0] policy
     /* 1827742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1827755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827776 */     // GIR_Coverage, 13062,
     /* 1827776 */     GIR_EraseRootFromParent_Done,
     /* 1827777 */   // Label 24749: @1827777
     /* 1827777 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1827863), // Rule ID 13063 //
     /* 1827782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1827802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827828 */     // MIs[0] policy
     /* 1827828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11429:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1827841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827862 */     // GIR_Coverage, 13063,
     /* 1827862 */     GIR_EraseRootFromParent_Done,
     /* 1827863 */   // Label 24750: @1827863
     /* 1827863 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1827949), // Rule ID 13066 //
     /* 1827868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1827888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827914 */     // MIs[0] policy
     /* 1827914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1827927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827948 */     // GIR_Coverage, 13066,
     /* 1827948 */     GIR_EraseRootFromParent_Done,
     /* 1827949 */   // Label 24751: @1827949
     /* 1827949 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1828035), // Rule ID 13067 //
     /* 1827954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1827974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828000 */     // MIs[0] policy
     /* 1828000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11429:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1828013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828034 */     // GIR_Coverage, 13067,
     /* 1828034 */     GIR_EraseRootFromParent_Done,
     /* 1828035 */   // Label 24752: @1828035
     /* 1828035 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1828121), // Rule ID 13070 //
     /* 1828040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1828051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1828054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1828057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1828060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828086 */     // MIs[0] policy
     /* 1828086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1828099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828120 */     // GIR_Coverage, 13070,
     /* 1828120 */     GIR_EraseRootFromParent_Done,
     /* 1828121 */   // Label 24753: @1828121
     /* 1828121 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1828207), // Rule ID 13071 //
     /* 1828126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1828137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1828140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1828143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1828146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828172 */     // MIs[0] policy
     /* 1828172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1828185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828206 */     // GIR_Coverage, 13071,
     /* 1828206 */     GIR_EraseRootFromParent_Done,
     /* 1828207 */   // Label 24754: @1828207
     /* 1828207 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1828293), // Rule ID 13074 //
     /* 1828212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1828223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1828226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1828229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1828232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828258 */     // MIs[0] policy
     /* 1828258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1828271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828292 */     // GIR_Coverage, 13074,
     /* 1828292 */     GIR_EraseRootFromParent_Done,
     /* 1828293 */   // Label 24755: @1828293
     /* 1828293 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1828379), // Rule ID 13075 //
     /* 1828298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1828309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1828312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1828315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1828318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828344 */     // MIs[0] policy
     /* 1828344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1828357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828378 */     // GIR_Coverage, 13075,
     /* 1828378 */     GIR_EraseRootFromParent_Done,
     /* 1828379 */   // Label 24756: @1828379
     /* 1828379 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1828465), // Rule ID 13078 //
     /* 1828384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1828395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1828398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1828401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1828404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828430 */     // MIs[0] policy
     /* 1828430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1828443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828464 */     // GIR_Coverage, 13078,
     /* 1828464 */     GIR_EraseRootFromParent_Done,
     /* 1828465 */   // Label 24757: @1828465
     /* 1828465 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1828551), // Rule ID 13079 //
     /* 1828470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1828481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1828484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1828487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1828490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828516 */     // MIs[0] policy
     /* 1828516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1828529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828550 */     // GIR_Coverage, 13079,
     /* 1828550 */     GIR_EraseRootFromParent_Done,
     /* 1828551 */   // Label 24758: @1828551
     /* 1828551 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1828637), // Rule ID 13082 //
     /* 1828556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1828567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1828573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1828576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828602 */     // MIs[0] policy
     /* 1828602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828612 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1828615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828636 */     // GIR_Coverage, 13082,
     /* 1828636 */     GIR_EraseRootFromParent_Done,
     /* 1828637 */   // Label 24759: @1828637
     /* 1828637 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1828723), // Rule ID 13083 //
     /* 1828642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1828653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1828659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1828662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828688 */     // MIs[0] policy
     /* 1828688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1828701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828722 */     // GIR_Coverage, 13083,
     /* 1828722 */     GIR_EraseRootFromParent_Done,
     /* 1828723 */   // Label 24760: @1828723
     /* 1828723 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1828809), // Rule ID 13086 //
     /* 1828728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1828745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1828748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828774 */     // MIs[0] policy
     /* 1828774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1828787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828808 */     // GIR_Coverage, 13086,
     /* 1828808 */     GIR_EraseRootFromParent_Done,
     /* 1828809 */   // Label 24761: @1828809
     /* 1828809 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1828895), // Rule ID 13087 //
     /* 1828814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1828831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1828834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828860 */     // MIs[0] policy
     /* 1828860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1828873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828894 */     // GIR_Coverage, 13087,
     /* 1828894 */     GIR_EraseRootFromParent_Done,
     /* 1828895 */   // Label 24762: @1828895
     /* 1828895 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1828981), // Rule ID 13090 //
     /* 1828900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1828914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1828917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1828920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828946 */     // MIs[0] policy
     /* 1828946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828956 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1828959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828980 */     // GIR_Coverage, 13090,
     /* 1828980 */     GIR_EraseRootFromParent_Done,
     /* 1828981 */   // Label 24763: @1828981
     /* 1828981 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1829067), // Rule ID 13091 //
     /* 1828986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1829000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1829003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1829006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829032 */     // MIs[0] policy
     /* 1829032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1829045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829066 */     // GIR_Coverage, 13091,
     /* 1829066 */     GIR_EraseRootFromParent_Done,
     /* 1829067 */   // Label 24764: @1829067
     /* 1829067 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1829153), // Rule ID 13094 //
     /* 1829072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1829083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1829086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1829089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1829092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829118 */     // MIs[0] policy
     /* 1829118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829152 */     // GIR_Coverage, 13094,
     /* 1829152 */     GIR_EraseRootFromParent_Done,
     /* 1829153 */   // Label 24765: @1829153
     /* 1829153 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1829239), // Rule ID 13095 //
     /* 1829158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1829169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1829172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1829175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1829178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829204 */     // MIs[0] policy
     /* 1829204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829238 */     // GIR_Coverage, 13095,
     /* 1829238 */     GIR_EraseRootFromParent_Done,
     /* 1829239 */   // Label 24766: @1829239
     /* 1829239 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1829325), // Rule ID 13098 //
     /* 1829244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1829255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1829258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1829261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1829264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829290 */     // MIs[0] policy
     /* 1829290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829324 */     // GIR_Coverage, 13098,
     /* 1829324 */     GIR_EraseRootFromParent_Done,
     /* 1829325 */   // Label 24767: @1829325
     /* 1829325 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1829411), // Rule ID 13099 //
     /* 1829330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1829341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1829344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1829347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1829350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829376 */     // MIs[0] policy
     /* 1829376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829410 */     // GIR_Coverage, 13099,
     /* 1829410 */     GIR_EraseRootFromParent_Done,
     /* 1829411 */   // Label 24768: @1829411
     /* 1829411 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1829497), // Rule ID 13102 //
     /* 1829416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1829427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1829430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1829433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1829436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829462 */     // MIs[0] policy
     /* 1829462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829496 */     // GIR_Coverage, 13102,
     /* 1829496 */     GIR_EraseRootFromParent_Done,
     /* 1829497 */   // Label 24769: @1829497
     /* 1829497 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1829583), // Rule ID 13103 //
     /* 1829502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1829513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1829516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1829519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1829522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829548 */     // MIs[0] policy
     /* 1829548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829582 */     // GIR_Coverage, 13103,
     /* 1829582 */     GIR_EraseRootFromParent_Done,
     /* 1829583 */   // Label 24770: @1829583
     /* 1829583 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1829669), // Rule ID 13106 //
     /* 1829588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1829605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1829608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829634 */     // MIs[0] policy
     /* 1829634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829668 */     // GIR_Coverage, 13106,
     /* 1829668 */     GIR_EraseRootFromParent_Done,
     /* 1829669 */   // Label 24771: @1829669
     /* 1829669 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1829755), // Rule ID 13107 //
     /* 1829674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1829691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1829694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829720 */     // MIs[0] policy
     /* 1829720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1829733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829754 */     // GIR_Coverage, 13107,
     /* 1829754 */     GIR_EraseRootFromParent_Done,
     /* 1829755 */   // Label 24772: @1829755
     /* 1829755 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1829841), // Rule ID 13110 //
     /* 1829760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1829777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1829780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829806 */     // MIs[0] policy
     /* 1829806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829816 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1829819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829840 */     // GIR_Coverage, 13110,
     /* 1829840 */     GIR_EraseRootFromParent_Done,
     /* 1829841 */   // Label 24773: @1829841
     /* 1829841 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1829927), // Rule ID 13111 //
     /* 1829846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1829863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1829866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829892 */     // MIs[0] policy
     /* 1829892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1829905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829926 */     // GIR_Coverage, 13111,
     /* 1829926 */     GIR_EraseRootFromParent_Done,
     /* 1829927 */   // Label 24774: @1829927
     /* 1829927 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1830013), // Rule ID 13114 //
     /* 1829932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1829943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1829946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1829949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1829952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829978 */     // MIs[0] policy
     /* 1829978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829988 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1829991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830012 */     // GIR_Coverage, 13114,
     /* 1830012 */     GIR_EraseRootFromParent_Done,
     /* 1830013 */   // Label 24775: @1830013
     /* 1830013 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1830099), // Rule ID 13115 //
     /* 1830018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1830029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1830032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1830035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1830038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830064 */     // MIs[0] policy
     /* 1830064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1830077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830098 */     // GIR_Coverage, 13115,
     /* 1830098 */     GIR_EraseRootFromParent_Done,
     /* 1830099 */   // Label 24776: @1830099
     /* 1830099 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1830185), // Rule ID 13118 //
     /* 1830104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1830115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1830118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1830121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1830124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1830127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830150 */     // MIs[0] policy
     /* 1830150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830160 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1830163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830184 */     // GIR_Coverage, 13118,
     /* 1830184 */     GIR_EraseRootFromParent_Done,
     /* 1830185 */   // Label 24777: @1830185
     /* 1830185 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1830271), // Rule ID 13119 //
     /* 1830190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1830201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1830204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1830207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1830210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1830213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830236 */     // MIs[0] policy
     /* 1830236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1830249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830270 */     // GIR_Coverage, 13119,
     /* 1830270 */     GIR_EraseRootFromParent_Done,
     /* 1830271 */   // Label 24778: @1830271
     /* 1830271 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1830357), // Rule ID 13122 //
     /* 1830276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1830287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1830290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1830293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1830296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830322 */     // MIs[0] policy
     /* 1830322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1830335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830356 */     // GIR_Coverage, 13122,
     /* 1830356 */     GIR_EraseRootFromParent_Done,
     /* 1830357 */   // Label 24779: @1830357
     /* 1830357 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1830443), // Rule ID 13123 //
     /* 1830362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1830373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1830376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1830379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1830382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830408 */     // MIs[0] policy
     /* 1830408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1830421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830442 */     // GIR_Coverage, 13123,
     /* 1830442 */     GIR_EraseRootFromParent_Done,
     /* 1830443 */   // Label 24780: @1830443
     /* 1830443 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1830529), // Rule ID 13126 //
     /* 1830448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1830459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1830462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1830465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1830468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830494 */     // MIs[0] policy
     /* 1830494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1830507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830528 */     // GIR_Coverage, 13126,
     /* 1830528 */     GIR_EraseRootFromParent_Done,
     /* 1830529 */   // Label 24781: @1830529
     /* 1830529 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1830615), // Rule ID 13127 //
     /* 1830534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1830545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1830548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1830551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1830554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830580 */     // MIs[0] policy
     /* 1830580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1830593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830614 */     // GIR_Coverage, 13127,
     /* 1830614 */     GIR_EraseRootFromParent_Done,
     /* 1830615 */   // Label 24782: @1830615
     /* 1830615 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1830701), // Rule ID 13130 //
     /* 1830620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1830637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1830640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830666 */     // MIs[0] policy
     /* 1830666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1830679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830700 */     // GIR_Coverage, 13130,
     /* 1830700 */     GIR_EraseRootFromParent_Done,
     /* 1830701 */   // Label 24783: @1830701
     /* 1830701 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1830787), // Rule ID 13131 //
     /* 1830706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1830723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1830726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830752 */     // MIs[0] policy
     /* 1830752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1830765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830786 */     // GIR_Coverage, 13131,
     /* 1830786 */     GIR_EraseRootFromParent_Done,
     /* 1830787 */   // Label 24784: @1830787
     /* 1830787 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1830873), // Rule ID 13134 //
     /* 1830792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1830809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1830812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830838 */     // MIs[0] policy
     /* 1830838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1830851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830872 */     // GIR_Coverage, 13134,
     /* 1830872 */     GIR_EraseRootFromParent_Done,
     /* 1830873 */   // Label 24785: @1830873
     /* 1830873 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1830959), // Rule ID 13135 //
     /* 1830878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1830895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1830898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830924 */     // MIs[0] policy
     /* 1830924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1830937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830958 */     // GIR_Coverage, 13135,
     /* 1830958 */     GIR_EraseRootFromParent_Done,
     /* 1830959 */   // Label 24786: @1830959
     /* 1830959 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1831045), // Rule ID 13138 //
     /* 1830964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1830975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1830978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1830981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1830984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831010 */     // MIs[0] policy
     /* 1831010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1831023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831044 */     // GIR_Coverage, 13138,
     /* 1831044 */     GIR_EraseRootFromParent_Done,
     /* 1831045 */   // Label 24787: @1831045
     /* 1831045 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1831131), // Rule ID 13139 //
     /* 1831050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1831061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1831064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1831067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1831070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831096 */     // MIs[0] policy
     /* 1831096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1831109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831130 */     // GIR_Coverage, 13139,
     /* 1831130 */     GIR_EraseRootFromParent_Done,
     /* 1831131 */   // Label 24788: @1831131
     /* 1831131 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1831217), // Rule ID 13142 //
     /* 1831136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1831147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1831150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1831153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1831156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1831159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831182 */     // MIs[0] policy
     /* 1831182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831192 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1831195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831216 */     // GIR_Coverage, 13142,
     /* 1831216 */     GIR_EraseRootFromParent_Done,
     /* 1831217 */   // Label 24789: @1831217
     /* 1831217 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1831303), // Rule ID 13143 //
     /* 1831222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1831233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1831236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1831239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1831242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1831245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831268 */     // MIs[0] policy
     /* 1831268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1831281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831302 */     // GIR_Coverage, 13143,
     /* 1831302 */     GIR_EraseRootFromParent_Done,
     /* 1831303 */   // Label 24790: @1831303
     /* 1831303 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1831389), // Rule ID 13146 //
     /* 1831308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1831319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1831322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1831325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1831328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1831338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831354 */     // MIs[0] policy
     /* 1831354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1831367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831388 */     // GIR_Coverage, 13146,
     /* 1831388 */     GIR_EraseRootFromParent_Done,
     /* 1831389 */   // Label 24791: @1831389
     /* 1831389 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1831475), // Rule ID 13147 //
     /* 1831394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1831405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1831408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1831411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1831414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1831424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1831436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831440 */     // MIs[0] policy
     /* 1831440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1831453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831474 */     // GIR_Coverage, 13147,
     /* 1831474 */     GIR_EraseRootFromParent_Done,
     /* 1831475 */   // Label 24792: @1831475
     /* 1831475 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1831561), // Rule ID 13150 //
     /* 1831480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1831491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1831494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1831497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1831500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831526 */     // MIs[0] policy
     /* 1831526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1831539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831560 */     // GIR_Coverage, 13150,
     /* 1831560 */     GIR_EraseRootFromParent_Done,
     /* 1831561 */   // Label 24793: @1831561
     /* 1831561 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1831647), // Rule ID 13151 //
     /* 1831566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1831577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1831580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1831583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1831586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831612 */     // MIs[0] policy
     /* 1831612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1831625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831646 */     // GIR_Coverage, 13151,
     /* 1831646 */     GIR_EraseRootFromParent_Done,
     /* 1831647 */   // Label 24794: @1831647
     /* 1831647 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1831733), // Rule ID 13154 //
     /* 1831652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1831669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1831672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831698 */     // MIs[0] policy
     /* 1831698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1831711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831732 */     // GIR_Coverage, 13154,
     /* 1831732 */     GIR_EraseRootFromParent_Done,
     /* 1831733 */   // Label 24795: @1831733
     /* 1831733 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1831819), // Rule ID 13155 //
     /* 1831738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1831755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1831758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831784 */     // MIs[0] policy
     /* 1831784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1831797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831818 */     // GIR_Coverage, 13155,
     /* 1831818 */     GIR_EraseRootFromParent_Done,
     /* 1831819 */   // Label 24796: @1831819
     /* 1831819 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1831905), // Rule ID 13158 //
     /* 1831824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1831844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831870 */     // MIs[0] policy
     /* 1831870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831880 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1831883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831904 */     // GIR_Coverage, 13158,
     /* 1831904 */     GIR_EraseRootFromParent_Done,
     /* 1831905 */   // Label 24797: @1831905
     /* 1831905 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1831991), // Rule ID 13159 //
     /* 1831910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1831930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831956 */     // MIs[0] policy
     /* 1831956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1831969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831990 */     // GIR_Coverage, 13159,
     /* 1831990 */     GIR_EraseRootFromParent_Done,
     /* 1831991 */   // Label 24798: @1831991
     /* 1831991 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1832077), // Rule ID 13162 //
     /* 1831996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1832007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1832010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1832016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832042 */     // MIs[0] policy
     /* 1832042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832052 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1832055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832076 */     // GIR_Coverage, 13162,
     /* 1832076 */     GIR_EraseRootFromParent_Done,
     /* 1832077 */   // Label 24799: @1832077
     /* 1832077 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1832163), // Rule ID 13163 //
     /* 1832082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1832093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1832096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1832102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832128 */     // MIs[0] policy
     /* 1832128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1832141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832162 */     // GIR_Coverage, 13163,
     /* 1832162 */     GIR_EraseRootFromParent_Done,
     /* 1832163 */   // Label 24800: @1832163
     /* 1832163 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1832249), // Rule ID 13166 //
     /* 1832168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1832179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1832182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1832188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832214 */     // MIs[0] policy
     /* 1832214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832248 */     // GIR_Coverage, 13166,
     /* 1832248 */     GIR_EraseRootFromParent_Done,
     /* 1832249 */   // Label 24801: @1832249
     /* 1832249 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1832335), // Rule ID 13167 //
     /* 1832254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1832265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1832268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1832274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832300 */     // MIs[0] policy
     /* 1832300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832334 */     // GIR_Coverage, 13167,
     /* 1832334 */     GIR_EraseRootFromParent_Done,
     /* 1832335 */   // Label 24802: @1832335
     /* 1832335 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1832421), // Rule ID 13170 //
     /* 1832340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1832351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1832354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1832360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832386 */     // MIs[0] policy
     /* 1832386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832396 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1832399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832420 */     // GIR_Coverage, 13170,
     /* 1832420 */     GIR_EraseRootFromParent_Done,
     /* 1832421 */   // Label 24803: @1832421
     /* 1832421 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1832507), // Rule ID 13171 //
     /* 1832426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1832437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1832440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1832446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832472 */     // MIs[0] policy
     /* 1832472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1832485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832506 */     // GIR_Coverage, 13171,
     /* 1832506 */     GIR_EraseRootFromParent_Done,
     /* 1832507 */   // Label 24804: @1832507
     /* 1832507 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1832593), // Rule ID 13174 //
     /* 1832512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1832523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1832526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1832532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832558 */     // MIs[0] policy
     /* 1832558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832592 */     // GIR_Coverage, 13174,
     /* 1832592 */     GIR_EraseRootFromParent_Done,
     /* 1832593 */   // Label 24805: @1832593
     /* 1832593 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1832679), // Rule ID 13175 //
     /* 1832598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1832609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1832612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1832618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832644 */     // MIs[0] policy
     /* 1832644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832678 */     // GIR_Coverage, 13175,
     /* 1832678 */     GIR_EraseRootFromParent_Done,
     /* 1832679 */   // Label 24806: @1832679
     /* 1832679 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1832765), // Rule ID 13178 //
     /* 1832684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1832704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832730 */     // MIs[0] policy
     /* 1832730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832764 */     // GIR_Coverage, 13178,
     /* 1832764 */     GIR_EraseRootFromParent_Done,
     /* 1832765 */   // Label 24807: @1832765
     /* 1832765 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1832851), // Rule ID 13179 //
     /* 1832770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1832790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832816 */     // MIs[0] policy
     /* 1832816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1832829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832850 */     // GIR_Coverage, 13179,
     /* 1832850 */     GIR_EraseRootFromParent_Done,
     /* 1832851 */   // Label 24808: @1832851
     /* 1832851 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1832937), // Rule ID 13182 //
     /* 1832856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1832873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1832876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832902 */     // MIs[0] policy
     /* 1832902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1832915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832936 */     // GIR_Coverage, 13182,
     /* 1832936 */     GIR_EraseRootFromParent_Done,
     /* 1832937 */   // Label 24809: @1832937
     /* 1832937 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1833023), // Rule ID 13183 //
     /* 1832942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1832959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1832962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1832980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832988 */     // MIs[0] policy
     /* 1832988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833022 */     // GIR_Coverage, 13183,
     /* 1833022 */     GIR_EraseRootFromParent_Done,
     /* 1833023 */   // Label 24810: @1833023
     /* 1833023 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1833109), // Rule ID 13186 //
     /* 1833028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1833039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1833042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1833048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833074 */     // MIs[0] policy
     /* 1833074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833084 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833108 */     // GIR_Coverage, 13186,
     /* 1833108 */     GIR_EraseRootFromParent_Done,
     /* 1833109 */   // Label 24811: @1833109
     /* 1833109 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1833195), // Rule ID 13187 //
     /* 1833114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1833125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1833128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1833134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833160 */     // MIs[0] policy
     /* 1833160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833194 */     // GIR_Coverage, 13187,
     /* 1833194 */     GIR_EraseRootFromParent_Done,
     /* 1833195 */   // Label 24812: @1833195
     /* 1833195 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1833281), // Rule ID 13190 //
     /* 1833200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1833211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1833214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1833220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833246 */     // MIs[0] policy
     /* 1833246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833280 */     // GIR_Coverage, 13190,
     /* 1833280 */     GIR_EraseRootFromParent_Done,
     /* 1833281 */   // Label 24813: @1833281
     /* 1833281 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1833367), // Rule ID 13191 //
     /* 1833286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1833297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1833300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1833306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833332 */     // MIs[0] policy
     /* 1833332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833366 */     // GIR_Coverage, 13191,
     /* 1833366 */     GIR_EraseRootFromParent_Done,
     /* 1833367 */   // Label 24814: @1833367
     /* 1833367 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1833453), // Rule ID 13194 //
     /* 1833372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1833383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1833386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1833392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1833395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833418 */     // MIs[0] policy
     /* 1833418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833428 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833452 */     // GIR_Coverage, 13194,
     /* 1833452 */     GIR_EraseRootFromParent_Done,
     /* 1833453 */   // Label 24815: @1833453
     /* 1833453 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1833539), // Rule ID 13195 //
     /* 1833458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1833469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1833472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1833478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1833481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1833488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1833500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833504 */     // MIs[0] policy
     /* 1833504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1833517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833538 */     // GIR_Coverage, 13195,
     /* 1833538 */     GIR_EraseRootFromParent_Done,
     /* 1833539 */   // Label 24816: @1833539
     /* 1833539 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1833625), // Rule ID 13198 //
     /* 1833544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1833555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1833558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1833564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833590 */     // MIs[0] policy
     /* 1833590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1833603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833624 */     // GIR_Coverage, 13198,
     /* 1833624 */     GIR_EraseRootFromParent_Done,
     /* 1833625 */   // Label 24817: @1833625
     /* 1833625 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1833711), // Rule ID 13199 //
     /* 1833630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1833641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1833644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1833650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833676 */     // MIs[0] policy
     /* 1833676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1833689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833710 */     // GIR_Coverage, 13199,
     /* 1833710 */     GIR_EraseRootFromParent_Done,
     /* 1833711 */   // Label 24818: @1833711
     /* 1833711 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1833797), // Rule ID 13202 //
     /* 1833716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1833736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833762 */     // MIs[0] policy
     /* 1833762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833772 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1833775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833796 */     // GIR_Coverage, 13202,
     /* 1833796 */     GIR_EraseRootFromParent_Done,
     /* 1833797 */   // Label 24819: @1833797
     /* 1833797 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1833883), // Rule ID 13203 //
     /* 1833802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1833822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833848 */     // MIs[0] policy
     /* 1833848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1833861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833882 */     // GIR_Coverage, 13203,
     /* 1833882 */     GIR_EraseRootFromParent_Done,
     /* 1833883 */   // Label 24820: @1833883
     /* 1833883 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1833969), // Rule ID 13206 //
     /* 1833888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1833905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1833908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1833926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833934 */     // MIs[0] policy
     /* 1833934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1833947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833968 */     // GIR_Coverage, 13206,
     /* 1833968 */     GIR_EraseRootFromParent_Done,
     /* 1833969 */   // Label 24821: @1833969
     /* 1833969 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1834055), // Rule ID 13207 //
     /* 1833974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1833991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1833994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834020 */     // MIs[0] policy
     /* 1834020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1834033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834054 */     // GIR_Coverage, 13207,
     /* 1834054 */     GIR_EraseRootFromParent_Done,
     /* 1834055 */   // Label 24822: @1834055
     /* 1834055 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1834141), // Rule ID 13210 //
     /* 1834060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1834071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1834074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1834080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834106 */     // MIs[0] policy
     /* 1834106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1834119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834140 */     // GIR_Coverage, 13210,
     /* 1834140 */     GIR_EraseRootFromParent_Done,
     /* 1834141 */   // Label 24823: @1834141
     /* 1834141 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1834227), // Rule ID 13211 //
     /* 1834146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1834157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1834160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1834166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834192 */     // MIs[0] policy
     /* 1834192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1834205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834226 */     // GIR_Coverage, 13211,
     /* 1834226 */     GIR_EraseRootFromParent_Done,
     /* 1834227 */   // Label 24824: @1834227
     /* 1834227 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1834313), // Rule ID 13214 //
     /* 1834232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1834243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1834246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1834252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834278 */     // MIs[0] policy
     /* 1834278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834288 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1834291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834312 */     // GIR_Coverage, 13214,
     /* 1834312 */     GIR_EraseRootFromParent_Done,
     /* 1834313 */   // Label 24825: @1834313
     /* 1834313 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1834399), // Rule ID 13215 //
     /* 1834318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1834329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1834332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1834338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834364 */     // MIs[0] policy
     /* 1834364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1834377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834398 */     // GIR_Coverage, 13215,
     /* 1834398 */     GIR_EraseRootFromParent_Done,
     /* 1834399 */   // Label 24826: @1834399
     /* 1834399 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1834485), // Rule ID 13218 //
     /* 1834404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1834415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1834418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1834424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1834427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834450 */     // MIs[0] policy
     /* 1834450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834460 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1834463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834484 */     // GIR_Coverage, 13218,
     /* 1834484 */     GIR_EraseRootFromParent_Done,
     /* 1834485 */   // Label 24827: @1834485
     /* 1834485 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1834571), // Rule ID 13219 //
     /* 1834490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1834501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1834504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1834510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1834513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834536 */     // MIs[0] policy
     /* 1834536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1834549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834570 */     // GIR_Coverage, 13219,
     /* 1834570 */     GIR_EraseRootFromParent_Done,
     /* 1834571 */   // Label 24828: @1834571
     /* 1834571 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1834657), // Rule ID 13222 //
     /* 1834576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1834596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834622 */     // MIs[0] policy
     /* 1834622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1834635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834656 */     // GIR_Coverage, 13222,
     /* 1834656 */     GIR_EraseRootFromParent_Done,
     /* 1834657 */   // Label 24829: @1834657
     /* 1834657 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1834743), // Rule ID 13223 //
     /* 1834662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1834682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834708 */     // MIs[0] policy
     /* 1834708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1834721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834742 */     // GIR_Coverage, 13223,
     /* 1834742 */     GIR_EraseRootFromParent_Done,
     /* 1834743 */   // Label 24830: @1834743
     /* 1834743 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1834829), // Rule ID 13226 //
     /* 1834748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1834768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834794 */     // MIs[0] policy
     /* 1834794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834804 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1834807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834828 */     // GIR_Coverage, 13226,
     /* 1834828 */     GIR_EraseRootFromParent_Done,
     /* 1834829 */   // Label 24831: @1834829
     /* 1834829 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1834915), // Rule ID 13227 //
     /* 1834834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1834854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834880 */     // MIs[0] policy
     /* 1834880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1834893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834914 */     // GIR_Coverage, 13227,
     /* 1834914 */     GIR_EraseRootFromParent_Done,
     /* 1834915 */   // Label 24832: @1834915
     /* 1834915 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1835001), // Rule ID 13230 //
     /* 1834920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1834931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1834934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1834940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834966 */     // MIs[0] policy
     /* 1834966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834976 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1834979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835000 */     // GIR_Coverage, 13230,
     /* 1835000 */     GIR_EraseRootFromParent_Done,
     /* 1835001 */   // Label 24833: @1835001
     /* 1835001 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1835087), // Rule ID 13231 //
     /* 1835006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1835017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1835020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1835026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1835036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835052 */     // MIs[0] policy
     /* 1835052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1835065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835086 */     // GIR_Coverage, 13231,
     /* 1835086 */     GIR_EraseRootFromParent_Done,
     /* 1835087 */   // Label 24834: @1835087
     /* 1835087 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1835173), // Rule ID 13234 //
     /* 1835092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1835103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1835106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1835112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835138 */     // MIs[0] policy
     /* 1835138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835172 */     // GIR_Coverage, 13234,
     /* 1835172 */     GIR_EraseRootFromParent_Done,
     /* 1835173 */   // Label 24835: @1835173
     /* 1835173 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1835259), // Rule ID 13235 //
     /* 1835178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1835189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1835192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1835198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835224 */     // MIs[0] policy
     /* 1835224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835258 */     // GIR_Coverage, 13235,
     /* 1835258 */     GIR_EraseRootFromParent_Done,
     /* 1835259 */   // Label 24836: @1835259
     /* 1835259 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1835345), // Rule ID 13238 //
     /* 1835264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1835275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1835278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1835284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1835294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835310 */     // MIs[0] policy
     /* 1835310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1835323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835344 */     // GIR_Coverage, 13238,
     /* 1835344 */     GIR_EraseRootFromParent_Done,
     /* 1835345 */   // Label 24837: @1835345
     /* 1835345 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1835431), // Rule ID 13239 //
     /* 1835350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1835361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1835364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1835370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1835380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835396 */     // MIs[0] policy
     /* 1835396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1835409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835430 */     // GIR_Coverage, 13239,
     /* 1835430 */     GIR_EraseRootFromParent_Done,
     /* 1835431 */   // Label 24838: @1835431
     /* 1835431 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1835517), // Rule ID 13242 //
     /* 1835436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1835447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1835450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1835456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1835466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835482 */     // MIs[0] policy
     /* 1835482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1835495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835516 */     // GIR_Coverage, 13242,
     /* 1835516 */     GIR_EraseRootFromParent_Done,
     /* 1835517 */   // Label 24839: @1835517
     /* 1835517 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1835603), // Rule ID 13243 //
     /* 1835522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1835533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1835536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1835542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1835552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1835564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835568 */     // MIs[0] policy
     /* 1835568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1835581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835602 */     // GIR_Coverage, 13243,
     /* 1835602 */     GIR_EraseRootFromParent_Done,
     /* 1835603 */   // Label 24840: @1835603
     /* 1835603 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1835689), // Rule ID 13246 //
     /* 1835608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1835619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1835622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1835625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1835628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835654 */     // MIs[0] policy
     /* 1835654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835664 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1835667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835688 */     // GIR_Coverage, 13246,
     /* 1835688 */     GIR_EraseRootFromParent_Done,
     /* 1835689 */   // Label 24841: @1835689
     /* 1835689 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1835775), // Rule ID 13247 //
     /* 1835694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1835705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1835708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1835711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1835714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835740 */     // MIs[0] policy
     /* 1835740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1835753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835774 */     // GIR_Coverage, 13247,
     /* 1835774 */     GIR_EraseRootFromParent_Done,
     /* 1835775 */   // Label 24842: @1835775
     /* 1835775 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1835861), // Rule ID 13250 //
     /* 1835780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1835791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1835794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1835797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1835800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835826 */     // MIs[0] policy
     /* 1835826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1835839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835860 */     // GIR_Coverage, 13250,
     /* 1835860 */     GIR_EraseRootFromParent_Done,
     /* 1835861 */   // Label 24843: @1835861
     /* 1835861 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1835947), // Rule ID 13251 //
     /* 1835866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1835877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1835880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1835883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1835886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835912 */     // MIs[0] policy
     /* 1835912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835922 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1835925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835946 */     // GIR_Coverage, 13251,
     /* 1835946 */     GIR_EraseRootFromParent_Done,
     /* 1835947 */   // Label 24844: @1835947
     /* 1835947 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1836033), // Rule ID 13254 //
     /* 1835952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1835963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1835966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1835969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1835972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835998 */     // MIs[0] policy
     /* 1835998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836008 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836032 */     // GIR_Coverage, 13254,
     /* 1836032 */     GIR_EraseRootFromParent_Done,
     /* 1836033 */   // Label 24845: @1836033
     /* 1836033 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1836119), // Rule ID 13255 //
     /* 1836038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1836049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1836052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1836055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1836058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836084 */     // MIs[0] policy
     /* 1836084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836118 */     // GIR_Coverage, 13255,
     /* 1836118 */     GIR_EraseRootFromParent_Done,
     /* 1836119 */   // Label 24846: @1836119
     /* 1836119 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1836205), // Rule ID 13258 //
     /* 1836124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1836135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1836138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1836141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1836144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836170 */     // MIs[0] policy
     /* 1836170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836180 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1836183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836204 */     // GIR_Coverage, 13258,
     /* 1836204 */     GIR_EraseRootFromParent_Done,
     /* 1836205 */   // Label 24847: @1836205
     /* 1836205 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1836291), // Rule ID 13259 //
     /* 1836210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1836221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1836224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1836227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1836230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836256 */     // MIs[0] policy
     /* 1836256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1836269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836290 */     // GIR_Coverage, 13259,
     /* 1836290 */     GIR_EraseRootFromParent_Done,
     /* 1836291 */   // Label 24848: @1836291
     /* 1836291 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1836377), // Rule ID 13262 //
     /* 1836296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1836307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1836310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1836313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1836316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836342 */     // MIs[0] policy
     /* 1836342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836376 */     // GIR_Coverage, 13262,
     /* 1836376 */     GIR_EraseRootFromParent_Done,
     /* 1836377 */   // Label 24849: @1836377
     /* 1836377 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1836463), // Rule ID 13263 //
     /* 1836382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1836393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1836396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1836399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1836402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836428 */     // MIs[0] policy
     /* 1836428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836462 */     // GIR_Coverage, 13263,
     /* 1836462 */     GIR_EraseRootFromParent_Done,
     /* 1836463 */   // Label 24850: @1836463
     /* 1836463 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1836549), // Rule ID 13266 //
     /* 1836468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1836479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1836482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1836485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1836488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836514 */     // MIs[0] policy
     /* 1836514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836548 */     // GIR_Coverage, 13266,
     /* 1836548 */     GIR_EraseRootFromParent_Done,
     /* 1836549 */   // Label 24851: @1836549
     /* 1836549 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1836635), // Rule ID 13267 //
     /* 1836554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1836565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1836568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1836571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1836574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836600 */     // MIs[0] policy
     /* 1836600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836610 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1836613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836634 */     // GIR_Coverage, 13267,
     /* 1836634 */     GIR_EraseRootFromParent_Done,
     /* 1836635 */   // Label 24852: @1836635
     /* 1836635 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1836721), // Rule ID 13270 //
     /* 1836640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1836651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1836654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1836657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1836660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836686 */     // MIs[0] policy
     /* 1836686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1836699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836720 */     // GIR_Coverage, 13270,
     /* 1836720 */     GIR_EraseRootFromParent_Done,
     /* 1836721 */   // Label 24853: @1836721
     /* 1836721 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1836807), // Rule ID 13271 //
     /* 1836726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1836737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1836740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1836743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1836746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836772 */     // MIs[0] policy
     /* 1836772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1836785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836806 */     // GIR_Coverage, 13271,
     /* 1836806 */     GIR_EraseRootFromParent_Done,
     /* 1836807 */   // Label 24854: @1836807
     /* 1836807 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1836893), // Rule ID 13274 //
     /* 1836812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1836823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1836826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1836829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1836832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836858 */     // MIs[0] policy
     /* 1836858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1836871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836892 */     // GIR_Coverage, 13274,
     /* 1836892 */     GIR_EraseRootFromParent_Done,
     /* 1836893 */   // Label 24855: @1836893
     /* 1836893 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1836979), // Rule ID 13275 //
     /* 1836898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1836909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1836912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1836915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1836918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836944 */     // MIs[0] policy
     /* 1836944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1836957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836978 */     // GIR_Coverage, 13275,
     /* 1836978 */     GIR_EraseRootFromParent_Done,
     /* 1836979 */   // Label 24856: @1836979
     /* 1836979 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1837065), // Rule ID 13278 //
     /* 1836984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1836995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1837001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1837004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837030 */     // MIs[0] policy
     /* 1837030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1837043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837064 */     // GIR_Coverage, 13278,
     /* 1837064 */     GIR_EraseRootFromParent_Done,
     /* 1837065 */   // Label 24857: @1837065
     /* 1837065 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1837151), // Rule ID 13279 //
     /* 1837070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1837081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1837084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1837087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1837090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837116 */     // MIs[0] policy
     /* 1837116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1837129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837150 */     // GIR_Coverage, 13279,
     /* 1837150 */     GIR_EraseRootFromParent_Done,
     /* 1837151 */   // Label 24858: @1837151
     /* 1837151 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1837237), // Rule ID 13282 //
     /* 1837156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1837167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1837170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1837173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1837176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837202 */     // MIs[0] policy
     /* 1837202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1837215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837236 */     // GIR_Coverage, 13282,
     /* 1837236 */     GIR_EraseRootFromParent_Done,
     /* 1837237 */   // Label 24859: @1837237
     /* 1837237 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1837323), // Rule ID 13283 //
     /* 1837242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1837253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1837256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1837259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1837262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837288 */     // MIs[0] policy
     /* 1837288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1837301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837322 */     // GIR_Coverage, 13283,
     /* 1837322 */     GIR_EraseRootFromParent_Done,
     /* 1837323 */   // Label 24860: @1837323
     /* 1837323 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1837409), // Rule ID 13286 //
     /* 1837328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1837339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1837342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1837345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1837348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837374 */     // MIs[0] policy
     /* 1837374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1837387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837408 */     // GIR_Coverage, 13286,
     /* 1837408 */     GIR_EraseRootFromParent_Done,
     /* 1837409 */   // Label 24861: @1837409
     /* 1837409 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1837495), // Rule ID 13287 //
     /* 1837414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1837425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1837428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1837431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1837434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837460 */     // MIs[0] policy
     /* 1837460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1837473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837494 */     // GIR_Coverage, 13287,
     /* 1837494 */     GIR_EraseRootFromParent_Done,
     /* 1837495 */   // Label 24862: @1837495
     /* 1837495 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1837581), // Rule ID 13290 //
     /* 1837500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1837511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1837514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1837517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1837520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837546 */     // MIs[0] policy
     /* 1837546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837556 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1837559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837580 */     // GIR_Coverage, 13290,
     /* 1837580 */     GIR_EraseRootFromParent_Done,
     /* 1837581 */   // Label 24863: @1837581
     /* 1837581 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1837667), // Rule ID 13291 //
     /* 1837586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1837597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1837600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1837603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1837606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837632 */     // MIs[0] policy
     /* 1837632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837642 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1837645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837666 */     // GIR_Coverage, 13291,
     /* 1837666 */     GIR_EraseRootFromParent_Done,
     /* 1837667 */   // Label 24864: @1837667
     /* 1837667 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1837753), // Rule ID 13294 //
     /* 1837672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1837683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1837686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1837689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1837692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1837695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837718 */     // MIs[0] policy
     /* 1837718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837728 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1837731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837752 */     // GIR_Coverage, 13294,
     /* 1837752 */     GIR_EraseRootFromParent_Done,
     /* 1837753 */   // Label 24865: @1837753
     /* 1837753 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1837839), // Rule ID 13295 //
     /* 1837758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1837769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1837772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1837775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1837778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1837781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837804 */     // MIs[0] policy
     /* 1837804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1837817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837838 */     // GIR_Coverage, 13295,
     /* 1837838 */     GIR_EraseRootFromParent_Done,
     /* 1837839 */   // Label 24866: @1837839
     /* 1837839 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1837925), // Rule ID 13298 //
     /* 1837844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1837855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1837858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1837861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1837864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837890 */     // MIs[0] policy
     /* 1837890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1837903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837924 */     // GIR_Coverage, 13298,
     /* 1837924 */     GIR_EraseRootFromParent_Done,
     /* 1837925 */   // Label 24867: @1837925
     /* 1837925 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1838011), // Rule ID 13299 //
     /* 1837930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1837941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1837944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1837947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1837950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837976 */     // MIs[0] policy
     /* 1837976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1837989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838010 */     // GIR_Coverage, 13299,
     /* 1838010 */     GIR_EraseRootFromParent_Done,
     /* 1838011 */   // Label 24868: @1838011
     /* 1838011 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1838097), // Rule ID 13302 //
     /* 1838016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1838027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1838030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1838033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1838036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838062 */     // MIs[0] policy
     /* 1838062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838072 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1838075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838096 */     // GIR_Coverage, 13302,
     /* 1838096 */     GIR_EraseRootFromParent_Done,
     /* 1838097 */   // Label 24869: @1838097
     /* 1838097 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1838183), // Rule ID 13303 //
     /* 1838102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1838113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1838116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1838119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1838122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838148 */     // MIs[0] policy
     /* 1838148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1838161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838182 */     // GIR_Coverage, 13303,
     /* 1838182 */     GIR_EraseRootFromParent_Done,
     /* 1838183 */   // Label 24870: @1838183
     /* 1838183 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1838269), // Rule ID 13306 //
     /* 1838188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1838199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1838202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1838205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1838208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1838211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838234 */     // MIs[0] policy
     /* 1838234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1838247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838268 */     // GIR_Coverage, 13306,
     /* 1838268 */     GIR_EraseRootFromParent_Done,
     /* 1838269 */   // Label 24871: @1838269
     /* 1838269 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1838355), // Rule ID 13307 //
     /* 1838274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1838285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1838288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1838291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1838294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1838297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838320 */     // MIs[0] policy
     /* 1838320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1838333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838354 */     // GIR_Coverage, 13307,
     /* 1838354 */     GIR_EraseRootFromParent_Done,
     /* 1838355 */   // Label 24872: @1838355
     /* 1838355 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1838441), // Rule ID 13310 //
     /* 1838360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1838371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1838374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1838377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1838380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838406 */     // MIs[0] policy
     /* 1838406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1838419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838440 */     // GIR_Coverage, 13310,
     /* 1838440 */     GIR_EraseRootFromParent_Done,
     /* 1838441 */   // Label 24873: @1838441
     /* 1838441 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1838527), // Rule ID 13311 //
     /* 1838446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1838457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1838460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1838463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1838466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838492 */     // MIs[0] policy
     /* 1838492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1838505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838526 */     // GIR_Coverage, 13311,
     /* 1838526 */     GIR_EraseRootFromParent_Done,
     /* 1838527 */   // Label 24874: @1838527
     /* 1838527 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1838613), // Rule ID 13314 //
     /* 1838532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1838543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1838546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1838549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1838552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838578 */     // MIs[0] policy
     /* 1838578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1838591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838612 */     // GIR_Coverage, 13314,
     /* 1838612 */     GIR_EraseRootFromParent_Done,
     /* 1838613 */   // Label 24875: @1838613
     /* 1838613 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1838699), // Rule ID 13315 //
     /* 1838618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1838629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1838632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1838635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1838638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838664 */     // MIs[0] policy
     /* 1838664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1838677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838698 */     // GIR_Coverage, 13315,
     /* 1838698 */     GIR_EraseRootFromParent_Done,
     /* 1838699 */   // Label 24876: @1838699
     /* 1838699 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1838785), // Rule ID 13318 //
     /* 1838704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1838715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1838718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1838721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1838724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838750 */     // MIs[0] policy
     /* 1838750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1838763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838784 */     // GIR_Coverage, 13318,
     /* 1838784 */     GIR_EraseRootFromParent_Done,
     /* 1838785 */   // Label 24877: @1838785
     /* 1838785 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1838871), // Rule ID 13319 //
     /* 1838790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1838801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1838804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1838807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1838810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838836 */     // MIs[0] policy
     /* 1838836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1838849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838870 */     // GIR_Coverage, 13319,
     /* 1838870 */     GIR_EraseRootFromParent_Done,
     /* 1838871 */   // Label 24878: @1838871
     /* 1838871 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1838957), // Rule ID 13322 //
     /* 1838876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1838887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1838890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1838893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1838896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838922 */     // MIs[0] policy
     /* 1838922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1838935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838956 */     // GIR_Coverage, 13322,
     /* 1838956 */     GIR_EraseRootFromParent_Done,
     /* 1838957 */   // Label 24879: @1838957
     /* 1838957 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1839043), // Rule ID 13323 //
     /* 1838962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1838973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1838976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1838979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1838982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839008 */     // MIs[0] policy
     /* 1839008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1839021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839042 */     // GIR_Coverage, 13323,
     /* 1839042 */     GIR_EraseRootFromParent_Done,
     /* 1839043 */   // Label 24880: @1839043
     /* 1839043 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1839129), // Rule ID 13326 //
     /* 1839048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1839059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1839062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1839065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1839068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839094 */     // MIs[0] policy
     /* 1839094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839104 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839128 */     // GIR_Coverage, 13326,
     /* 1839128 */     GIR_EraseRootFromParent_Done,
     /* 1839129 */   // Label 24881: @1839129
     /* 1839129 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1839215), // Rule ID 13327 //
     /* 1839134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1839145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1839148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1839151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1839154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839180 */     // MIs[0] policy
     /* 1839180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839214 */     // GIR_Coverage, 13327,
     /* 1839214 */     GIR_EraseRootFromParent_Done,
     /* 1839215 */   // Label 24882: @1839215
     /* 1839215 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1839301), // Rule ID 13330 //
     /* 1839220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1839231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1839234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1839237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1839240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839266 */     // MIs[0] policy
     /* 1839266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1839279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839300 */     // GIR_Coverage, 13330,
     /* 1839300 */     GIR_EraseRootFromParent_Done,
     /* 1839301 */   // Label 24883: @1839301
     /* 1839301 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1839387), // Rule ID 13331 //
     /* 1839306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1839317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1839320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1839323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1839326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839352 */     // MIs[0] policy
     /* 1839352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839362 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1839365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839386 */     // GIR_Coverage, 13331,
     /* 1839386 */     GIR_EraseRootFromParent_Done,
     /* 1839387 */   // Label 24884: @1839387
     /* 1839387 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1839473), // Rule ID 13334 //
     /* 1839392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1839403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1839406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1839412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839438 */     // MIs[0] policy
     /* 1839438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839448 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1839451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839472 */     // GIR_Coverage, 13334,
     /* 1839472 */     GIR_EraseRootFromParent_Done,
     /* 1839473 */   // Label 24885: @1839473
     /* 1839473 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1839559), // Rule ID 13335 //
     /* 1839478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1839489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1839492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1839498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839524 */     // MIs[0] policy
     /* 1839524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1839537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839558 */     // GIR_Coverage, 13335,
     /* 1839558 */     GIR_EraseRootFromParent_Done,
     /* 1839559 */   // Label 24886: @1839559
     /* 1839559 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1839645), // Rule ID 13338 //
     /* 1839564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1839575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1839578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1839584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839610 */     // MIs[0] policy
     /* 1839610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1839623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839644 */     // GIR_Coverage, 13338,
     /* 1839644 */     GIR_EraseRootFromParent_Done,
     /* 1839645 */   // Label 24887: @1839645
     /* 1839645 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1839731), // Rule ID 13339 //
     /* 1839650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1839661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1839664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1839670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839696 */     // MIs[0] policy
     /* 1839696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839706 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1839709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839730 */     // GIR_Coverage, 13339,
     /* 1839730 */     GIR_EraseRootFromParent_Done,
     /* 1839731 */   // Label 24888: @1839731
     /* 1839731 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1839817), // Rule ID 13342 //
     /* 1839736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1839747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1839750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1839756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839782 */     // MIs[0] policy
     /* 1839782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1839795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839816 */     // GIR_Coverage, 13342,
     /* 1839816 */     GIR_EraseRootFromParent_Done,
     /* 1839817 */   // Label 24889: @1839817
     /* 1839817 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1839903), // Rule ID 13343 //
     /* 1839822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1839833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1839836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1839839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1839842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839868 */     // MIs[0] policy
     /* 1839868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1839881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839902 */     // GIR_Coverage, 13343,
     /* 1839902 */     GIR_EraseRootFromParent_Done,
     /* 1839903 */   // Label 24890: @1839903
     /* 1839903 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1839989), // Rule ID 13346 //
     /* 1839908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1839919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1839922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1839925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1839928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1839946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839954 */     // MIs[0] policy
     /* 1839954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1839967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839988 */     // GIR_Coverage, 13346,
     /* 1839988 */     GIR_EraseRootFromParent_Done,
     /* 1839989 */   // Label 24891: @1839989
     /* 1839989 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1840075), // Rule ID 13347 //
     /* 1839994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1840005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1840008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1840014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840040 */     // MIs[0] policy
     /* 1840040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1840053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840074 */     // GIR_Coverage, 13347,
     /* 1840074 */     GIR_EraseRootFromParent_Done,
     /* 1840075 */   // Label 24892: @1840075
     /* 1840075 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1840161), // Rule ID 13350 //
     /* 1840080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1840091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1840094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1840100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840126 */     // MIs[0] policy
     /* 1840126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1840139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840160 */     // GIR_Coverage, 13350,
     /* 1840160 */     GIR_EraseRootFromParent_Done,
     /* 1840161 */   // Label 24893: @1840161
     /* 1840161 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1840247), // Rule ID 13351 //
     /* 1840166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1840177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1840180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1840186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840212 */     // MIs[0] policy
     /* 1840212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1840225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840246 */     // GIR_Coverage, 13351,
     /* 1840246 */     GIR_EraseRootFromParent_Done,
     /* 1840247 */   // Label 24894: @1840247
     /* 1840247 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1840333), // Rule ID 13354 //
     /* 1840252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1840263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1840266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1840272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840298 */     // MIs[0] policy
     /* 1840298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1840311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840332 */     // GIR_Coverage, 13354,
     /* 1840332 */     GIR_EraseRootFromParent_Done,
     /* 1840333 */   // Label 24895: @1840333
     /* 1840333 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1840419), // Rule ID 13355 //
     /* 1840338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1840349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1840352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1840358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840384 */     // MIs[0] policy
     /* 1840384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1840397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840418 */     // GIR_Coverage, 13355,
     /* 1840418 */     GIR_EraseRootFromParent_Done,
     /* 1840419 */   // Label 24896: @1840419
     /* 1840419 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1840505), // Rule ID 13358 //
     /* 1840424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1840435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1840438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1840444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840470 */     // MIs[0] policy
     /* 1840470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840504 */     // GIR_Coverage, 13358,
     /* 1840504 */     GIR_EraseRootFromParent_Done,
     /* 1840505 */   // Label 24897: @1840505
     /* 1840505 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1840591), // Rule ID 13359 //
     /* 1840510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1840521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1840524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1840530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840556 */     // MIs[0] policy
     /* 1840556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840590 */     // GIR_Coverage, 13359,
     /* 1840590 */     GIR_EraseRootFromParent_Done,
     /* 1840591 */   // Label 24898: @1840591
     /* 1840591 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1840677), // Rule ID 13362 //
     /* 1840596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1840607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1840610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1840616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840642 */     // MIs[0] policy
     /* 1840642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840676 */     // GIR_Coverage, 13362,
     /* 1840676 */     GIR_EraseRootFromParent_Done,
     /* 1840677 */   // Label 24899: @1840677
     /* 1840677 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1840763), // Rule ID 13363 //
     /* 1840682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1840693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1840696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1840702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840728 */     // MIs[0] policy
     /* 1840728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840762 */     // GIR_Coverage, 13363,
     /* 1840762 */     GIR_EraseRootFromParent_Done,
     /* 1840763 */   // Label 24900: @1840763
     /* 1840763 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1840849), // Rule ID 13366 //
     /* 1840768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1840779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1840782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1840788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840814 */     // MIs[0] policy
     /* 1840814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840848 */     // GIR_Coverage, 13366,
     /* 1840848 */     GIR_EraseRootFromParent_Done,
     /* 1840849 */   // Label 24901: @1840849
     /* 1840849 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1840935), // Rule ID 13367 //
     /* 1840854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1840865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1840868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1840871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1840874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840900 */     // MIs[0] policy
     /* 1840900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840934 */     // GIR_Coverage, 13367,
     /* 1840934 */     GIR_EraseRootFromParent_Done,
     /* 1840935 */   // Label 24902: @1840935
     /* 1840935 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1841021), // Rule ID 13370 //
     /* 1840940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1840943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1840951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1840954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1840957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1840960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1840978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840986 */     // MIs[0] policy
     /* 1840986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1840999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841020 */     // GIR_Coverage, 13370,
     /* 1841020 */     GIR_EraseRootFromParent_Done,
     /* 1841021 */   // Label 24903: @1841021
     /* 1841021 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1841107), // Rule ID 13371 //
     /* 1841026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1841037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1841040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1841046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841072 */     // MIs[0] policy
     /* 1841072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1841085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841106 */     // GIR_Coverage, 13371,
     /* 1841106 */     GIR_EraseRootFromParent_Done,
     /* 1841107 */   // Label 24904: @1841107
     /* 1841107 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1841193), // Rule ID 13374 //
     /* 1841112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1841123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1841126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1841132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841158 */     // MIs[0] policy
     /* 1841158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1841171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841192 */     // GIR_Coverage, 13374,
     /* 1841192 */     GIR_EraseRootFromParent_Done,
     /* 1841193 */   // Label 24905: @1841193
     /* 1841193 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1841279), // Rule ID 13375 //
     /* 1841198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1841209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1841212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1841218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841244 */     // MIs[0] policy
     /* 1841244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841254 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1841257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841278 */     // GIR_Coverage, 13375,
     /* 1841278 */     GIR_EraseRootFromParent_Done,
     /* 1841279 */   // Label 24906: @1841279
     /* 1841279 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1841365), // Rule ID 13378 //
     /* 1841284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1841295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1841298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1841304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841330 */     // MIs[0] policy
     /* 1841330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1841343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841364 */     // GIR_Coverage, 13378,
     /* 1841364 */     GIR_EraseRootFromParent_Done,
     /* 1841365 */   // Label 24907: @1841365
     /* 1841365 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1841451), // Rule ID 13379 //
     /* 1841370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1841381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1841384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1841390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841416 */     // MIs[0] policy
     /* 1841416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1841429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841450 */     // GIR_Coverage, 13379,
     /* 1841450 */     GIR_EraseRootFromParent_Done,
     /* 1841451 */   // Label 24908: @1841451
     /* 1841451 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1841537), // Rule ID 13382 //
     /* 1841456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1841467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1841470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1841476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1841479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841502 */     // MIs[0] policy
     /* 1841502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841512 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1841515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841536 */     // GIR_Coverage, 13382,
     /* 1841536 */     GIR_EraseRootFromParent_Done,
     /* 1841537 */   // Label 24909: @1841537
     /* 1841537 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1841623), // Rule ID 13383 //
     /* 1841542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1841553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1841556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1841562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1841565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841588 */     // MIs[0] policy
     /* 1841588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841598 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1841601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841622 */     // GIR_Coverage, 13383,
     /* 1841622 */     GIR_EraseRootFromParent_Done,
     /* 1841623 */   // Label 24910: @1841623
     /* 1841623 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1841709), // Rule ID 13386 //
     /* 1841628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1841639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1841642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1841648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841674 */     // MIs[0] policy
     /* 1841674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1841687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841708 */     // GIR_Coverage, 13386,
     /* 1841708 */     GIR_EraseRootFromParent_Done,
     /* 1841709 */   // Label 24911: @1841709
     /* 1841709 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1841795), // Rule ID 13387 //
     /* 1841714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1841725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1841728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1841734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841760 */     // MIs[0] policy
     /* 1841760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1841773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841794 */     // GIR_Coverage, 13387,
     /* 1841794 */     GIR_EraseRootFromParent_Done,
     /* 1841795 */   // Label 24912: @1841795
     /* 1841795 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1841881), // Rule ID 13390 //
     /* 1841800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1841811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1841814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1841820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841846 */     // MIs[0] policy
     /* 1841846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841856 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1841859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841880 */     // GIR_Coverage, 13390,
     /* 1841880 */     GIR_EraseRootFromParent_Done,
     /* 1841881 */   // Label 24913: @1841881
     /* 1841881 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1841967), // Rule ID 13391 //
     /* 1841886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1841897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1841900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1841906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841932 */     // MIs[0] policy
     /* 1841932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1841945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1841963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841966 */     // GIR_Coverage, 13391,
     /* 1841966 */     GIR_EraseRootFromParent_Done,
     /* 1841967 */   // Label 24914: @1841967
     /* 1841967 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1842053), // Rule ID 13394 //
     /* 1841972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1841983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1841986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1841992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1841995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842018 */     // MIs[0] policy
     /* 1842018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1842031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842052 */     // GIR_Coverage, 13394,
     /* 1842052 */     GIR_EraseRootFromParent_Done,
     /* 1842053 */   // Label 24915: @1842053
     /* 1842053 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1842139), // Rule ID 13395 //
     /* 1842058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1842069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1842072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1842078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1842081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842104 */     // MIs[0] policy
     /* 1842104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1842117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842138 */     // GIR_Coverage, 13395,
     /* 1842138 */     GIR_EraseRootFromParent_Done,
     /* 1842139 */   // Label 24916: @1842139
     /* 1842139 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1842225), // Rule ID 13398 //
     /* 1842144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1842155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1842158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1842164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842190 */     // MIs[0] policy
     /* 1842190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1842203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842224 */     // GIR_Coverage, 13398,
     /* 1842224 */     GIR_EraseRootFromParent_Done,
     /* 1842225 */   // Label 24917: @1842225
     /* 1842225 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1842311), // Rule ID 13399 //
     /* 1842230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1842241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1842244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1842250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842276 */     // MIs[0] policy
     /* 1842276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1842289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842310 */     // GIR_Coverage, 13399,
     /* 1842310 */     GIR_EraseRootFromParent_Done,
     /* 1842311 */   // Label 24918: @1842311
     /* 1842311 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1842397), // Rule ID 13402 //
     /* 1842316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1842327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1842330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1842336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842362 */     // MIs[0] policy
     /* 1842362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1842375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842396 */     // GIR_Coverage, 13402,
     /* 1842396 */     GIR_EraseRootFromParent_Done,
     /* 1842397 */   // Label 24919: @1842397
     /* 1842397 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1842483), // Rule ID 13403 //
     /* 1842402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1842413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1842416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1842422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842448 */     // MIs[0] policy
     /* 1842448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1842461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842482 */     // GIR_Coverage, 13403,
     /* 1842482 */     GIR_EraseRootFromParent_Done,
     /* 1842483 */   // Label 24920: @1842483
     /* 1842483 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1842569), // Rule ID 13406 //
     /* 1842488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1842499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1842502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1842508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842534 */     // MIs[0] policy
     /* 1842534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1842547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842568 */     // GIR_Coverage, 13406,
     /* 1842568 */     GIR_EraseRootFromParent_Done,
     /* 1842569 */   // Label 24921: @1842569
     /* 1842569 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1842655), // Rule ID 13407 //
     /* 1842574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1842585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1842588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1842594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842620 */     // MIs[0] policy
     /* 1842620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1842633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842654 */     // GIR_Coverage, 13407,
     /* 1842654 */     GIR_EraseRootFromParent_Done,
     /* 1842655 */   // Label 24922: @1842655
     /* 1842655 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1842741), // Rule ID 13410 //
     /* 1842660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1842663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1842671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1842674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1842680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842706 */     // MIs[0] policy
     /* 1842706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1842719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842740 */     // GIR_Coverage, 13410,
     /* 1842740 */     GIR_EraseRootFromParent_Done,
     /* 1842741 */   // Label 24923: @1842741
     /* 1842741 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1842827), // Rule ID 13411 //
     /* 1842746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1842749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1842757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1842760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1842766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842792 */     // MIs[0] policy
     /* 1842792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1842805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842826 */     // GIR_Coverage, 13411,
     /* 1842826 */     GIR_EraseRootFromParent_Done,
     /* 1842827 */   // Label 24924: @1842827
     /* 1842827 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1842913), // Rule ID 13414 //
     /* 1842832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1842835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1842843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1842846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1842852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842878 */     // MIs[0] policy
     /* 1842878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842888 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1842891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842912 */     // GIR_Coverage, 13414,
     /* 1842912 */     GIR_EraseRootFromParent_Done,
     /* 1842913 */   // Label 24925: @1842913
     /* 1842913 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1842999), // Rule ID 13415 //
     /* 1842918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1842921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1842929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1842932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1842938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842964 */     // MIs[0] policy
     /* 1842964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1842977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1842995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842998 */     // GIR_Coverage, 13415,
     /* 1842998 */     GIR_EraseRootFromParent_Done,
     /* 1842999 */   // Label 24926: @1842999
     /* 1842999 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1843085), // Rule ID 13418 //
     /* 1843004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1843015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1843018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1843024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843050 */     // MIs[0] policy
     /* 1843050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843084 */     // GIR_Coverage, 13418,
     /* 1843084 */     GIR_EraseRootFromParent_Done,
     /* 1843085 */   // Label 24927: @1843085
     /* 1843085 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1843171), // Rule ID 13419 //
     /* 1843090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1843101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1843104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1843110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843136 */     // MIs[0] policy
     /* 1843136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843170 */     // GIR_Coverage, 13419,
     /* 1843170 */     GIR_EraseRootFromParent_Done,
     /* 1843171 */   // Label 24928: @1843171
     /* 1843171 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1843257), // Rule ID 13422 //
     /* 1843176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1843187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1843190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1843193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1843196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843222 */     // MIs[0] policy
     /* 1843222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843232 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1843235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843256 */     // GIR_Coverage, 13422,
     /* 1843256 */     GIR_EraseRootFromParent_Done,
     /* 1843257 */   // Label 24929: @1843257
     /* 1843257 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1843343), // Rule ID 13423 //
     /* 1843262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1843273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1843276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1843279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1843282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843308 */     // MIs[0] policy
     /* 1843308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1843321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843342 */     // GIR_Coverage, 13423,
     /* 1843342 */     GIR_EraseRootFromParent_Done,
     /* 1843343 */   // Label 24930: @1843343
     /* 1843343 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1843429), // Rule ID 13426 //
     /* 1843348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1843359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1843362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1843365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1843368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843394 */     // MIs[0] policy
     /* 1843394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1843407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843428 */     // GIR_Coverage, 13426,
     /* 1843428 */     GIR_EraseRootFromParent_Done,
     /* 1843429 */   // Label 24931: @1843429
     /* 1843429 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1843515), // Rule ID 13427 //
     /* 1843434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1843445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1843448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1843451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1843454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843480 */     // MIs[0] policy
     /* 1843480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1843493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843514 */     // GIR_Coverage, 13427,
     /* 1843514 */     GIR_EraseRootFromParent_Done,
     /* 1843515 */   // Label 24932: @1843515
     /* 1843515 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1843601), // Rule ID 13430 //
     /* 1843520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1843537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1843540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843566 */     // MIs[0] policy
     /* 1843566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1843579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843600 */     // GIR_Coverage, 13430,
     /* 1843600 */     GIR_EraseRootFromParent_Done,
     /* 1843601 */   // Label 24933: @1843601
     /* 1843601 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1843687), // Rule ID 13431 //
     /* 1843606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1843617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1843620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1843623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1843626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843652 */     // MIs[0] policy
     /* 1843652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1843665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843686 */     // GIR_Coverage, 13431,
     /* 1843686 */     GIR_EraseRootFromParent_Done,
     /* 1843687 */   // Label 24934: @1843687
     /* 1843687 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1843773), // Rule ID 13434 //
     /* 1843692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1843709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843738 */     // MIs[0] policy
     /* 1843738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1843751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843772 */     // GIR_Coverage, 13434,
     /* 1843772 */     GIR_EraseRootFromParent_Done,
     /* 1843773 */   // Label 24935: @1843773
     /* 1843773 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1843859), // Rule ID 13435 //
     /* 1843778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1843795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1843798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843824 */     // MIs[0] policy
     /* 1843824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1843837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843858 */     // GIR_Coverage, 13435,
     /* 1843858 */     GIR_EraseRootFromParent_Done,
     /* 1843859 */   // Label 24936: @1843859
     /* 1843859 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1843945), // Rule ID 13438 //
     /* 1843864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1843875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1843878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1843881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843910 */     // MIs[0] policy
     /* 1843910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1843923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843944 */     // GIR_Coverage, 13438,
     /* 1843944 */     GIR_EraseRootFromParent_Done,
     /* 1843945 */   // Label 24937: @1843945
     /* 1843945 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1844031), // Rule ID 13439 //
     /* 1843950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1843961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1843964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1843967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843996 */     // MIs[0] policy
     /* 1843996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844006 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1844009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844030 */     // GIR_Coverage, 13439,
     /* 1844030 */     GIR_EraseRootFromParent_Done,
     /* 1844031 */   // Label 24938: @1844031
     /* 1844031 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1844117), // Rule ID 13442 //
     /* 1844036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1844053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844082 */     // MIs[0] policy
     /* 1844082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1844095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844116 */     // GIR_Coverage, 13442,
     /* 1844116 */     GIR_EraseRootFromParent_Done,
     /* 1844117 */   // Label 24939: @1844117
     /* 1844117 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1844203), // Rule ID 13443 //
     /* 1844122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1844139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844168 */     // MIs[0] policy
     /* 1844168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1844181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844202 */     // GIR_Coverage, 13443,
     /* 1844202 */     GIR_EraseRootFromParent_Done,
     /* 1844203 */   // Label 24940: @1844203
     /* 1844203 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1844289), // Rule ID 13446 //
     /* 1844208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1844219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1844222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1844225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1844228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1844231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844254 */     // MIs[0] policy
     /* 1844254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1844267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844288 */     // GIR_Coverage, 13446,
     /* 1844288 */     GIR_EraseRootFromParent_Done,
     /* 1844289 */   // Label 24941: @1844289
     /* 1844289 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1844375), // Rule ID 13447 //
     /* 1844294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1844305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1844308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1844311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1844314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1844317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844340 */     // MIs[0] policy
     /* 1844340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1844353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844374 */     // GIR_Coverage, 13447,
     /* 1844374 */     GIR_EraseRootFromParent_Done,
     /* 1844375 */   // Label 24942: @1844375
     /* 1844375 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1844461), // Rule ID 13450 //
     /* 1844380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1844391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1844394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1844397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1844400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844426 */     // MIs[0] policy
     /* 1844426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1844439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844460 */     // GIR_Coverage, 13450,
     /* 1844460 */     GIR_EraseRootFromParent_Done,
     /* 1844461 */   // Label 24943: @1844461
     /* 1844461 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1844547), // Rule ID 13451 //
     /* 1844466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1844477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1844480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1844483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1844486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844512 */     // MIs[0] policy
     /* 1844512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1844525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844546 */     // GIR_Coverage, 13451,
     /* 1844546 */     GIR_EraseRootFromParent_Done,
     /* 1844547 */   // Label 24944: @1844547
     /* 1844547 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1844633), // Rule ID 13454 //
     /* 1844552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1844569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1844572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844598 */     // MIs[0] policy
     /* 1844598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1844611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844632 */     // GIR_Coverage, 13454,
     /* 1844632 */     GIR_EraseRootFromParent_Done,
     /* 1844633 */   // Label 24945: @1844633
     /* 1844633 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1844719), // Rule ID 13455 //
     /* 1844638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1844655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1844658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844684 */     // MIs[0] policy
     /* 1844684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1844697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844718 */     // GIR_Coverage, 13455,
     /* 1844718 */     GIR_EraseRootFromParent_Done,
     /* 1844719 */   // Label 24946: @1844719
     /* 1844719 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1844805), // Rule ID 13458 //
     /* 1844724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1844741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844770 */     // MIs[0] policy
     /* 1844770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1844783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844804 */     // GIR_Coverage, 13458,
     /* 1844804 */     GIR_EraseRootFromParent_Done,
     /* 1844805 */   // Label 24947: @1844805
     /* 1844805 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1844891), // Rule ID 13459 //
     /* 1844810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1844827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1844830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844856 */     // MIs[0] policy
     /* 1844856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1844869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844890 */     // GIR_Coverage, 13459,
     /* 1844890 */     GIR_EraseRootFromParent_Done,
     /* 1844891 */   // Label 24948: @1844891
     /* 1844891 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1844977), // Rule ID 13462 //
     /* 1844896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844942 */     // MIs[0] policy
     /* 1844942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1844955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844976 */     // GIR_Coverage, 13462,
     /* 1844976 */     GIR_EraseRootFromParent_Done,
     /* 1844977 */   // Label 24949: @1844977
     /* 1844977 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1845063), // Rule ID 13463 //
     /* 1844982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1844990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1844999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1845002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845028 */     // MIs[0] policy
     /* 1845028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1845041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845062 */     // GIR_Coverage, 13463,
     /* 1845062 */     GIR_EraseRootFromParent_Done,
     /* 1845063 */   // Label 24950: @1845063
     /* 1845063 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1845149), // Rule ID 13466 //
     /* 1845068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1845071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1845079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1845082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1845085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1845088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845114 */     // MIs[0] policy
     /* 1845114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845148 */     // GIR_Coverage, 13466,
     /* 1845148 */     GIR_EraseRootFromParent_Done,
     /* 1845149 */   // Label 24951: @1845149
     /* 1845149 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1845235), // Rule ID 13467 //
     /* 1845154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1845157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1845165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1845168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1845171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1845174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845200 */     // MIs[0] policy
     /* 1845200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845234 */     // GIR_Coverage, 13467,
     /* 1845234 */     GIR_EraseRootFromParent_Done,
     /* 1845235 */   // Label 24952: @1845235
     /* 1845235 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1845321), // Rule ID 13470 //
     /* 1845240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1845243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1845257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1845260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845286 */     // MIs[0] policy
     /* 1845286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1845299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845320 */     // GIR_Coverage, 13470,
     /* 1845320 */     GIR_EraseRootFromParent_Done,
     /* 1845321 */   // Label 24953: @1845321
     /* 1845321 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1845407), // Rule ID 13471 //
     /* 1845326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1845329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1845337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1845340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1845343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1845346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845372 */     // MIs[0] policy
     /* 1845372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1845385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845406 */     // GIR_Coverage, 13471,
     /* 1845406 */     GIR_EraseRootFromParent_Done,
     /* 1845407 */   // Label 24954: @1845407
     /* 1845407 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1845493), // Rule ID 13474 //
     /* 1845412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1845415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1845429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1845432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845458 */     // MIs[0] policy
     /* 1845458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1845471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845492 */     // GIR_Coverage, 13474,
     /* 1845492 */     GIR_EraseRootFromParent_Done,
     /* 1845493 */   // Label 24955: @1845493
     /* 1845493 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1845579), // Rule ID 13475 //
     /* 1845498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1845501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1845515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1845518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845544 */     // MIs[0] policy
     /* 1845544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1845557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845578 */     // GIR_Coverage, 13475,
     /* 1845578 */     GIR_EraseRootFromParent_Done,
     /* 1845579 */   // Label 24956: @1845579
     /* 1845579 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1845665), // Rule ID 13478 //
     /* 1845584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1845587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1845601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845630 */     // MIs[0] policy
     /* 1845630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1845643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845664 */     // GIR_Coverage, 13478,
     /* 1845664 */     GIR_EraseRootFromParent_Done,
     /* 1845665 */   // Label 24957: @1845665
     /* 1845665 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1845751), // Rule ID 13479 //
     /* 1845670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1845673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1845687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1845690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845716 */     // MIs[0] policy
     /* 1845716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1845729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845750 */     // GIR_Coverage, 13479,
     /* 1845750 */     GIR_EraseRootFromParent_Done,
     /* 1845751 */   // Label 24958: @1845751
     /* 1845751 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1845837), // Rule ID 13482 //
     /* 1845756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845802 */     // MIs[0] policy
     /* 1845802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1845815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845836 */     // GIR_Coverage, 13482,
     /* 1845836 */     GIR_EraseRootFromParent_Done,
     /* 1845837 */   // Label 24959: @1845837
     /* 1845837 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1845923), // Rule ID 13483 //
     /* 1845842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845888 */     // MIs[0] policy
     /* 1845888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1845901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845922 */     // GIR_Coverage, 13483,
     /* 1845922 */     GIR_EraseRootFromParent_Done,
     /* 1845923 */   // Label 24960: @1845923
     /* 1845923 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1846009), // Rule ID 13486 //
     /* 1845928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1845939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1845942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845974 */     // MIs[0] policy
     /* 1845974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1845987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846008 */     // GIR_Coverage, 13486,
     /* 1846008 */     GIR_EraseRootFromParent_Done,
     /* 1846009 */   // Label 24961: @1846009
     /* 1846009 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1846095), // Rule ID 13487 //
     /* 1846014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846060 */     // MIs[0] policy
     /* 1846060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1846073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846094 */     // GIR_Coverage, 13487,
     /* 1846094 */     GIR_EraseRootFromParent_Done,
     /* 1846095 */   // Label 24962: @1846095
     /* 1846095 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1846181), // Rule ID 13490 //
     /* 1846100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846146 */     // MIs[0] policy
     /* 1846146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846156 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1846159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846180 */     // GIR_Coverage, 13490,
     /* 1846180 */     GIR_EraseRootFromParent_Done,
     /* 1846181 */   // Label 24963: @1846181
     /* 1846181 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1846267), // Rule ID 13491 //
     /* 1846186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846232 */     // MIs[0] policy
     /* 1846232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1846245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846266 */     // GIR_Coverage, 13491,
     /* 1846266 */     GIR_EraseRootFromParent_Done,
     /* 1846267 */   // Label 24964: @1846267
     /* 1846267 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1846353), // Rule ID 13494 //
     /* 1846272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846318 */     // MIs[0] policy
     /* 1846318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1846331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846352 */     // GIR_Coverage, 13494,
     /* 1846352 */     GIR_EraseRootFromParent_Done,
     /* 1846353 */   // Label 24965: @1846353
     /* 1846353 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1846439), // Rule ID 13495 //
     /* 1846358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846404 */     // MIs[0] policy
     /* 1846404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1846417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846438 */     // GIR_Coverage, 13495,
     /* 1846438 */     GIR_EraseRootFromParent_Done,
     /* 1846439 */   // Label 24966: @1846439
     /* 1846439 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1846525), // Rule ID 13498 //
     /* 1846444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846490 */     // MIs[0] policy
     /* 1846490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1846503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846524 */     // GIR_Coverage, 13498,
     /* 1846524 */     GIR_EraseRootFromParent_Done,
     /* 1846525 */   // Label 24967: @1846525
     /* 1846525 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1846611), // Rule ID 13499 //
     /* 1846530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846576 */     // MIs[0] policy
     /* 1846576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1846589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846610 */     // GIR_Coverage, 13499,
     /* 1846610 */     GIR_EraseRootFromParent_Done,
     /* 1846611 */   // Label 24968: @1846611
     /* 1846611 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1846697), // Rule ID 13502 //
     /* 1846616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846662 */     // MIs[0] policy
     /* 1846662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846672 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1846675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846696 */     // GIR_Coverage, 13502,
     /* 1846696 */     GIR_EraseRootFromParent_Done,
     /* 1846697 */   // Label 24969: @1846697
     /* 1846697 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1846783), // Rule ID 13503 //
     /* 1846702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846748 */     // MIs[0] policy
     /* 1846748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1846761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846782 */     // GIR_Coverage, 13503,
     /* 1846782 */     GIR_EraseRootFromParent_Done,
     /* 1846783 */   // Label 24970: @1846783
     /* 1846783 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1846869), // Rule ID 13506 //
     /* 1846788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846834 */     // MIs[0] policy
     /* 1846834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1846847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846868 */     // GIR_Coverage, 13506,
     /* 1846868 */     GIR_EraseRootFromParent_Done,
     /* 1846869 */   // Label 24971: @1846869
     /* 1846869 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1846955), // Rule ID 13507 //
     /* 1846874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846920 */     // MIs[0] policy
     /* 1846920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1846933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846954 */     // GIR_Coverage, 13507,
     /* 1846954 */     GIR_EraseRootFromParent_Done,
     /* 1846955 */   // Label 24972: @1846955
     /* 1846955 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1847041), // Rule ID 13510 //
     /* 1846960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847006 */     // MIs[0] policy
     /* 1847006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1847019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847040 */     // GIR_Coverage, 13510,
     /* 1847040 */     GIR_EraseRootFromParent_Done,
     /* 1847041 */   // Label 24973: @1847041
     /* 1847041 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1847127), // Rule ID 13511 //
     /* 1847046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847092 */     // MIs[0] policy
     /* 1847092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1847105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847126 */     // GIR_Coverage, 13511,
     /* 1847126 */     GIR_EraseRootFromParent_Done,
     /* 1847127 */   // Label 24974: @1847127
     /* 1847127 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1847213), // Rule ID 13514 //
     /* 1847132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847178 */     // MIs[0] policy
     /* 1847178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1847191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847212 */     // GIR_Coverage, 13514,
     /* 1847212 */     GIR_EraseRootFromParent_Done,
     /* 1847213 */   // Label 24975: @1847213
     /* 1847213 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1847299), // Rule ID 13515 //
     /* 1847218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847264 */     // MIs[0] policy
     /* 1847264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1847277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847298 */     // GIR_Coverage, 13515,
     /* 1847298 */     GIR_EraseRootFromParent_Done,
     /* 1847299 */   // Label 24976: @1847299
     /* 1847299 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1847385), // Rule ID 13518 //
     /* 1847304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847350 */     // MIs[0] policy
     /* 1847350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1847363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847384 */     // GIR_Coverage, 13518,
     /* 1847384 */     GIR_EraseRootFromParent_Done,
     /* 1847385 */   // Label 24977: @1847385
     /* 1847385 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1847471), // Rule ID 13519 //
     /* 1847390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847436 */     // MIs[0] policy
     /* 1847436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1847449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847470 */     // GIR_Coverage, 13519,
     /* 1847470 */     GIR_EraseRootFromParent_Done,
     /* 1847471 */   // Label 24978: @1847471
     /* 1847471 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1847557), // Rule ID 13522 //
     /* 1847476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847522 */     // MIs[0] policy
     /* 1847522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1847535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847556 */     // GIR_Coverage, 13522,
     /* 1847556 */     GIR_EraseRootFromParent_Done,
     /* 1847557 */   // Label 24979: @1847557
     /* 1847557 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1847643), // Rule ID 13523 //
     /* 1847562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847608 */     // MIs[0] policy
     /* 1847608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1847621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847642 */     // GIR_Coverage, 13523,
     /* 1847642 */     GIR_EraseRootFromParent_Done,
     /* 1847643 */   // Label 24980: @1847643
     /* 1847643 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1847729), // Rule ID 13526 //
     /* 1847648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847694 */     // MIs[0] policy
     /* 1847694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1847707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847728 */     // GIR_Coverage, 13526,
     /* 1847728 */     GIR_EraseRootFromParent_Done,
     /* 1847729 */   // Label 24981: @1847729
     /* 1847729 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1847815), // Rule ID 13527 //
     /* 1847734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847780 */     // MIs[0] policy
     /* 1847780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1847793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847814 */     // GIR_Coverage, 13527,
     /* 1847814 */     GIR_EraseRootFromParent_Done,
     /* 1847815 */   // Label 24982: @1847815
     /* 1847815 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1847901), // Rule ID 13530 //
     /* 1847820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847866 */     // MIs[0] policy
     /* 1847866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1847879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847900 */     // GIR_Coverage, 13530,
     /* 1847900 */     GIR_EraseRootFromParent_Done,
     /* 1847901 */   // Label 24983: @1847901
     /* 1847901 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1847987), // Rule ID 13531 //
     /* 1847906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847952 */     // MIs[0] policy
     /* 1847952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1847965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847986 */     // GIR_Coverage, 13531,
     /* 1847986 */     GIR_EraseRootFromParent_Done,
     /* 1847987 */   // Label 24984: @1847987
     /* 1847987 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1848073), // Rule ID 13534 //
     /* 1847992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848038 */     // MIs[0] policy
     /* 1848038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848072 */     // GIR_Coverage, 13534,
     /* 1848072 */     GIR_EraseRootFromParent_Done,
     /* 1848073 */   // Label 24985: @1848073
     /* 1848073 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1848159), // Rule ID 13535 //
     /* 1848078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848124 */     // MIs[0] policy
     /* 1848124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848158 */     // GIR_Coverage, 13535,
     /* 1848158 */     GIR_EraseRootFromParent_Done,
     /* 1848159 */   // Label 24986: @1848159
     /* 1848159 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1848245), // Rule ID 13538 //
     /* 1848164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848210 */     // MIs[0] policy
     /* 1848210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1848223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848244 */     // GIR_Coverage, 13538,
     /* 1848244 */     GIR_EraseRootFromParent_Done,
     /* 1848245 */   // Label 24987: @1848245
     /* 1848245 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1848331), // Rule ID 13539 //
     /* 1848250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848296 */     // MIs[0] policy
     /* 1848296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1848309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848330 */     // GIR_Coverage, 13539,
     /* 1848330 */     GIR_EraseRootFromParent_Done,
     /* 1848331 */   // Label 24988: @1848331
     /* 1848331 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1848417), // Rule ID 13542 //
     /* 1848336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1848353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848382 */     // MIs[0] policy
     /* 1848382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1848395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848416 */     // GIR_Coverage, 13542,
     /* 1848416 */     GIR_EraseRootFromParent_Done,
     /* 1848417 */   // Label 24989: @1848417
     /* 1848417 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1848503), // Rule ID 13543 //
     /* 1848422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1848439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848468 */     // MIs[0] policy
     /* 1848468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1848481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848502 */     // GIR_Coverage, 13543,
     /* 1848502 */     GIR_EraseRootFromParent_Done,
     /* 1848503 */   // Label 24990: @1848503
     /* 1848503 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1848589), // Rule ID 13546 //
     /* 1848508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1848525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848554 */     // MIs[0] policy
     /* 1848554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1848567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848588 */     // GIR_Coverage, 13546,
     /* 1848588 */     GIR_EraseRootFromParent_Done,
     /* 1848589 */   // Label 24991: @1848589
     /* 1848589 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1848675), // Rule ID 13547 //
     /* 1848594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1848611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848640 */     // MIs[0] policy
     /* 1848640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1848653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848674 */     // GIR_Coverage, 13547,
     /* 1848674 */     GIR_EraseRootFromParent_Done,
     /* 1848675 */   // Label 24992: @1848675
     /* 1848675 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1848761), // Rule ID 13550 //
     /* 1848680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1848697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848726 */     // MIs[0] policy
     /* 1848726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1848739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848760 */     // GIR_Coverage, 13550,
     /* 1848760 */     GIR_EraseRootFromParent_Done,
     /* 1848761 */   // Label 24993: @1848761
     /* 1848761 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1848847), // Rule ID 13551 //
     /* 1848766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1848783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848812 */     // MIs[0] policy
     /* 1848812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1848825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848846 */     // GIR_Coverage, 13551,
     /* 1848846 */     GIR_EraseRootFromParent_Done,
     /* 1848847 */   // Label 24994: @1848847
     /* 1848847 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1848933), // Rule ID 13554 //
     /* 1848852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1848869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848898 */     // MIs[0] policy
     /* 1848898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1848911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848932 */     // GIR_Coverage, 13554,
     /* 1848932 */     GIR_EraseRootFromParent_Done,
     /* 1848933 */   // Label 24995: @1848933
     /* 1848933 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1849019), // Rule ID 13555 //
     /* 1848938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1848955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848984 */     // MIs[0] policy
     /* 1848984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1848997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849018 */     // GIR_Coverage, 13555,
     /* 1849018 */     GIR_EraseRootFromParent_Done,
     /* 1849019 */   // Label 24996: @1849019
     /* 1849019 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1849105), // Rule ID 13558 //
     /* 1849024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1849041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849070 */     // MIs[0] policy
     /* 1849070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1849083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849104 */     // GIR_Coverage, 13558,
     /* 1849104 */     GIR_EraseRootFromParent_Done,
     /* 1849105 */   // Label 24997: @1849105
     /* 1849105 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1849191), // Rule ID 13559 //
     /* 1849110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1849127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849156 */     // MIs[0] policy
     /* 1849156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1849169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849190 */     // GIR_Coverage, 13559,
     /* 1849190 */     GIR_EraseRootFromParent_Done,
     /* 1849191 */   // Label 24998: @1849191
     /* 1849191 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1849277), // Rule ID 13562 //
     /* 1849196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1849213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849242 */     // MIs[0] policy
     /* 1849242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1849255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849276 */     // GIR_Coverage, 13562,
     /* 1849276 */     GIR_EraseRootFromParent_Done,
     /* 1849277 */   // Label 24999: @1849277
     /* 1849277 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1849363), // Rule ID 13563 //
     /* 1849282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1849293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1849296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1849299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1849302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1849305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849328 */     // MIs[0] policy
     /* 1849328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849338 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1849341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849362 */     // GIR_Coverage, 13563,
     /* 1849362 */     GIR_EraseRootFromParent_Done,
     /* 1849363 */   // Label 25000: @1849363
     /* 1849363 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1849449), // Rule ID 13566 //
     /* 1849368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1849385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849414 */     // MIs[0] policy
     /* 1849414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1849427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849448 */     // GIR_Coverage, 13566,
     /* 1849448 */     GIR_EraseRootFromParent_Done,
     /* 1849449 */   // Label 25001: @1849449
     /* 1849449 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1849535), // Rule ID 13567 //
     /* 1849454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1849471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849500 */     // MIs[0] policy
     /* 1849500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849510 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1849513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849534 */     // GIR_Coverage, 13567,
     /* 1849534 */     GIR_EraseRootFromParent_Done,
     /* 1849535 */   // Label 25002: @1849535
     /* 1849535 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1849621), // Rule ID 13570 //
     /* 1849540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1849557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849586 */     // MIs[0] policy
     /* 1849586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1849599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849620 */     // GIR_Coverage, 13570,
     /* 1849620 */     GIR_EraseRootFromParent_Done,
     /* 1849621 */   // Label 25003: @1849621
     /* 1849621 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1849707), // Rule ID 13571 //
     /* 1849626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1849643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849672 */     // MIs[0] policy
     /* 1849672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1849685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849706 */     // GIR_Coverage, 13571,
     /* 1849706 */     GIR_EraseRootFromParent_Done,
     /* 1849707 */   // Label 25004: @1849707
     /* 1849707 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1849793), // Rule ID 13574 //
     /* 1849712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1849729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849758 */     // MIs[0] policy
     /* 1849758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1849771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849792 */     // GIR_Coverage, 13574,
     /* 1849792 */     GIR_EraseRootFromParent_Done,
     /* 1849793 */   // Label 25005: @1849793
     /* 1849793 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1849879), // Rule ID 13575 //
     /* 1849798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1849815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849844 */     // MIs[0] policy
     /* 1849844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1849857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849878 */     // GIR_Coverage, 13575,
     /* 1849878 */     GIR_EraseRootFromParent_Done,
     /* 1849879 */   // Label 25006: @1849879
     /* 1849879 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1849965), // Rule ID 13578 //
     /* 1849884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1849901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849930 */     // MIs[0] policy
     /* 1849930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1849943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849964 */     // GIR_Coverage, 13578,
     /* 1849964 */     GIR_EraseRootFromParent_Done,
     /* 1849965 */   // Label 25007: @1849965
     /* 1849965 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1850051), // Rule ID 13579 //
     /* 1849970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1849987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850016 */     // MIs[0] policy
     /* 1850016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1850029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850050 */     // GIR_Coverage, 13579,
     /* 1850050 */     GIR_EraseRootFromParent_Done,
     /* 1850051 */   // Label 25008: @1850051
     /* 1850051 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1850137), // Rule ID 13582 //
     /* 1850056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1850073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850102 */     // MIs[0] policy
     /* 1850102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1850115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850136 */     // GIR_Coverage, 13582,
     /* 1850136 */     GIR_EraseRootFromParent_Done,
     /* 1850137 */   // Label 25009: @1850137
     /* 1850137 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1850223), // Rule ID 13583 //
     /* 1850142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1850159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850188 */     // MIs[0] policy
     /* 1850188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1850201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850222 */     // GIR_Coverage, 13583,
     /* 1850222 */     GIR_EraseRootFromParent_Done,
     /* 1850223 */   // Label 25010: @1850223
     /* 1850223 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1850309), // Rule ID 13586 //
     /* 1850228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1850245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850274 */     // MIs[0] policy
     /* 1850274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1850287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850308 */     // GIR_Coverage, 13586,
     /* 1850308 */     GIR_EraseRootFromParent_Done,
     /* 1850309 */   // Label 25011: @1850309
     /* 1850309 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1850395), // Rule ID 13587 //
     /* 1850314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1850325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1850328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1850331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1850334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850360 */     // MIs[0] policy
     /* 1850360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850370 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1850373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850394 */     // GIR_Coverage, 13587,
     /* 1850394 */     GIR_EraseRootFromParent_Done,
     /* 1850395 */   // Label 25012: @1850395
     /* 1850395 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1850481), // Rule ID 13590 //
     /* 1850400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1850417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850446 */     // MIs[0] policy
     /* 1850446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1850459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850480 */     // GIR_Coverage, 13590,
     /* 1850480 */     GIR_EraseRootFromParent_Done,
     /* 1850481 */   // Label 25013: @1850481
     /* 1850481 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1850567), // Rule ID 13591 //
     /* 1850486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1850503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850532 */     // MIs[0] policy
     /* 1850532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1850545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850566 */     // GIR_Coverage, 13591,
     /* 1850566 */     GIR_EraseRootFromParent_Done,
     /* 1850567 */   // Label 25014: @1850567
     /* 1850567 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1850653), // Rule ID 13594 //
     /* 1850572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1850589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850618 */     // MIs[0] policy
     /* 1850618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1850631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850652 */     // GIR_Coverage, 13594,
     /* 1850652 */     GIR_EraseRootFromParent_Done,
     /* 1850653 */   // Label 25015: @1850653
     /* 1850653 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1850739), // Rule ID 13595 //
     /* 1850658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1850675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850704 */     // MIs[0] policy
     /* 1850704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1850717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850738 */     // GIR_Coverage, 13595,
     /* 1850738 */     GIR_EraseRootFromParent_Done,
     /* 1850739 */   // Label 25016: @1850739
     /* 1850739 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1850825), // Rule ID 13598 //
     /* 1850744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1850761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850790 */     // MIs[0] policy
     /* 1850790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1850803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850824 */     // GIR_Coverage, 13598,
     /* 1850824 */     GIR_EraseRootFromParent_Done,
     /* 1850825 */   // Label 25017: @1850825
     /* 1850825 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1850911), // Rule ID 13599 //
     /* 1850830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1850847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850876 */     // MIs[0] policy
     /* 1850876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1850889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850910 */     // GIR_Coverage, 13599,
     /* 1850910 */     GIR_EraseRootFromParent_Done,
     /* 1850911 */   // Label 25018: @1850911
     /* 1850911 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1850997), // Rule ID 13602 //
     /* 1850916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1850927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1850930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1850936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850962 */     // MIs[0] policy
     /* 1850962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1850975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850996 */     // GIR_Coverage, 13602,
     /* 1850996 */     GIR_EraseRootFromParent_Done,
     /* 1850997 */   // Label 25019: @1850997
     /* 1850997 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1851083), // Rule ID 13603 //
     /* 1851002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851048 */     // MIs[0] policy
     /* 1851048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1851061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851082 */     // GIR_Coverage, 13603,
     /* 1851082 */     GIR_EraseRootFromParent_Done,
     /* 1851083 */   // Label 25020: @1851083
     /* 1851083 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1851169), // Rule ID 13606 //
     /* 1851088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851134 */     // MIs[0] policy
     /* 1851134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1851147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851168 */     // GIR_Coverage, 13606,
     /* 1851168 */     GIR_EraseRootFromParent_Done,
     /* 1851169 */   // Label 25021: @1851169
     /* 1851169 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1851255), // Rule ID 13607 //
     /* 1851174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851220 */     // MIs[0] policy
     /* 1851220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1851233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851254 */     // GIR_Coverage, 13607,
     /* 1851254 */     GIR_EraseRootFromParent_Done,
     /* 1851255 */   // Label 25022: @1851255
     /* 1851255 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1851341), // Rule ID 13610 //
     /* 1851260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851306 */     // MIs[0] policy
     /* 1851306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1851319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851340 */     // GIR_Coverage, 13610,
     /* 1851340 */     GIR_EraseRootFromParent_Done,
     /* 1851341 */   // Label 25023: @1851341
     /* 1851341 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1851427), // Rule ID 13611 //
     /* 1851346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851392 */     // MIs[0] policy
     /* 1851392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1851405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851426 */     // GIR_Coverage, 13611,
     /* 1851426 */     GIR_EraseRootFromParent_Done,
     /* 1851427 */   // Label 25024: @1851427
     /* 1851427 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1851513), // Rule ID 13614 //
     /* 1851432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851478 */     // MIs[0] policy
     /* 1851478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1851491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851512 */     // GIR_Coverage, 13614,
     /* 1851512 */     GIR_EraseRootFromParent_Done,
     /* 1851513 */   // Label 25025: @1851513
     /* 1851513 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1851599), // Rule ID 13615 //
     /* 1851518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851564 */     // MIs[0] policy
     /* 1851564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1851577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851598 */     // GIR_Coverage, 13615,
     /* 1851598 */     GIR_EraseRootFromParent_Done,
     /* 1851599 */   // Label 25026: @1851599
     /* 1851599 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1851685), // Rule ID 13618 //
     /* 1851604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851650 */     // MIs[0] policy
     /* 1851650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1851663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851684 */     // GIR_Coverage, 13618,
     /* 1851684 */     GIR_EraseRootFromParent_Done,
     /* 1851685 */   // Label 25027: @1851685
     /* 1851685 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1851771), // Rule ID 13619 //
     /* 1851690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851736 */     // MIs[0] policy
     /* 1851736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1851749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851770 */     // GIR_Coverage, 13619,
     /* 1851770 */     GIR_EraseRootFromParent_Done,
     /* 1851771 */   // Label 25028: @1851771
     /* 1851771 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1851857), // Rule ID 13622 //
     /* 1851776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851822 */     // MIs[0] policy
     /* 1851822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1851835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851856 */     // GIR_Coverage, 13622,
     /* 1851856 */     GIR_EraseRootFromParent_Done,
     /* 1851857 */   // Label 25029: @1851857
     /* 1851857 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1851943), // Rule ID 13623 //
     /* 1851862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851908 */     // MIs[0] policy
     /* 1851908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851918 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1851921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851942 */     // GIR_Coverage, 13623,
     /* 1851942 */     GIR_EraseRootFromParent_Done,
     /* 1851943 */   // Label 25030: @1851943
     /* 1851943 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1852029), // Rule ID 13626 //
     /* 1851948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1851959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1851962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1851968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851994 */     // MIs[0] policy
     /* 1851994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1852007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852028 */     // GIR_Coverage, 13626,
     /* 1852028 */     GIR_EraseRootFromParent_Done,
     /* 1852029 */   // Label 25031: @1852029
     /* 1852029 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1852115), // Rule ID 13627 //
     /* 1852034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852080 */     // MIs[0] policy
     /* 1852080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1852093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852114 */     // GIR_Coverage, 13627,
     /* 1852114 */     GIR_EraseRootFromParent_Done,
     /* 1852115 */   // Label 25032: @1852115
     /* 1852115 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1852201), // Rule ID 13630 //
     /* 1852120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852166 */     // MIs[0] policy
     /* 1852166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1852179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852200 */     // GIR_Coverage, 13630,
     /* 1852200 */     GIR_EraseRootFromParent_Done,
     /* 1852201 */   // Label 25033: @1852201
     /* 1852201 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1852287), // Rule ID 13631 //
     /* 1852206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852252 */     // MIs[0] policy
     /* 1852252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1852265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852286 */     // GIR_Coverage, 13631,
     /* 1852286 */     GIR_EraseRootFromParent_Done,
     /* 1852287 */   // Label 25034: @1852287
     /* 1852287 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1852373), // Rule ID 13634 //
     /* 1852292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852338 */     // MIs[0] policy
     /* 1852338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1852351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852372 */     // GIR_Coverage, 13634,
     /* 1852372 */     GIR_EraseRootFromParent_Done,
     /* 1852373 */   // Label 25035: @1852373
     /* 1852373 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1852459), // Rule ID 13635 //
     /* 1852378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852424 */     // MIs[0] policy
     /* 1852424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1852437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852458 */     // GIR_Coverage, 13635,
     /* 1852458 */     GIR_EraseRootFromParent_Done,
     /* 1852459 */   // Label 25036: @1852459
     /* 1852459 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1852545), // Rule ID 13638 //
     /* 1852464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852510 */     // MIs[0] policy
     /* 1852510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1852523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852544 */     // GIR_Coverage, 13638,
     /* 1852544 */     GIR_EraseRootFromParent_Done,
     /* 1852545 */   // Label 25037: @1852545
     /* 1852545 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1852631), // Rule ID 13639 //
     /* 1852550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852596 */     // MIs[0] policy
     /* 1852596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1852609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852630 */     // GIR_Coverage, 13639,
     /* 1852630 */     GIR_EraseRootFromParent_Done,
     /* 1852631 */   // Label 25038: @1852631
     /* 1852631 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1852717), // Rule ID 13642 //
     /* 1852636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852682 */     // MIs[0] policy
     /* 1852682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1852695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852716 */     // GIR_Coverage, 13642,
     /* 1852716 */     GIR_EraseRootFromParent_Done,
     /* 1852717 */   // Label 25039: @1852717
     /* 1852717 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1852803), // Rule ID 13643 //
     /* 1852722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852768 */     // MIs[0] policy
     /* 1852768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1852781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852802 */     // GIR_Coverage, 13643,
     /* 1852802 */     GIR_EraseRootFromParent_Done,
     /* 1852803 */   // Label 25040: @1852803
     /* 1852803 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1852889), // Rule ID 13646 //
     /* 1852808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852854 */     // MIs[0] policy
     /* 1852854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1852867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852888 */     // GIR_Coverage, 13646,
     /* 1852888 */     GIR_EraseRootFromParent_Done,
     /* 1852889 */   // Label 25041: @1852889
     /* 1852889 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1852975), // Rule ID 13647 //
     /* 1852894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852940 */     // MIs[0] policy
     /* 1852940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1852953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852974 */     // GIR_Coverage, 13647,
     /* 1852974 */     GIR_EraseRootFromParent_Done,
     /* 1852975 */   // Label 25042: @1852975
     /* 1852975 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1853061), // Rule ID 13650 //
     /* 1852980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853026 */     // MIs[0] policy
     /* 1853026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853060 */     // GIR_Coverage, 13650,
     /* 1853060 */     GIR_EraseRootFromParent_Done,
     /* 1853061 */   // Label 25043: @1853061
     /* 1853061 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1853147), // Rule ID 13651 //
     /* 1853066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853112 */     // MIs[0] policy
     /* 1853112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853146 */     // GIR_Coverage, 13651,
     /* 1853146 */     GIR_EraseRootFromParent_Done,
     /* 1853147 */   // Label 25044: @1853147
     /* 1853147 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1853233), // Rule ID 13654 //
     /* 1853152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853198 */     // MIs[0] policy
     /* 1853198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853232 */     // GIR_Coverage, 13654,
     /* 1853232 */     GIR_EraseRootFromParent_Done,
     /* 1853233 */   // Label 25045: @1853233
     /* 1853233 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1853319), // Rule ID 13655 //
     /* 1853238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853284 */     // MIs[0] policy
     /* 1853284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853318 */     // GIR_Coverage, 13655,
     /* 1853318 */     GIR_EraseRootFromParent_Done,
     /* 1853319 */   // Label 25046: @1853319
     /* 1853319 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1853405), // Rule ID 13658 //
     /* 1853324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853370 */     // MIs[0] policy
     /* 1853370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853380 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1853383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853404 */     // GIR_Coverage, 13658,
     /* 1853404 */     GIR_EraseRootFromParent_Done,
     /* 1853405 */   // Label 25047: @1853405
     /* 1853405 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1853491), // Rule ID 13659 //
     /* 1853410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853456 */     // MIs[0] policy
     /* 1853456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1853469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853490 */     // GIR_Coverage, 13659,
     /* 1853490 */     GIR_EraseRootFromParent_Done,
     /* 1853491 */   // Label 25048: @1853491
     /* 1853491 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1853577), // Rule ID 13662 //
     /* 1853496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1853513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853542 */     // MIs[0] policy
     /* 1853542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1853555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853576 */     // GIR_Coverage, 13662,
     /* 1853576 */     GIR_EraseRootFromParent_Done,
     /* 1853577 */   // Label 25049: @1853577
     /* 1853577 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1853663), // Rule ID 13663 //
     /* 1853582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1853599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853628 */     // MIs[0] policy
     /* 1853628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1853641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853662 */     // GIR_Coverage, 13663,
     /* 1853662 */     GIR_EraseRootFromParent_Done,
     /* 1853663 */   // Label 25050: @1853663
     /* 1853663 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1853749), // Rule ID 13666 //
     /* 1853668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1853685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853714 */     // MIs[0] policy
     /* 1853714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853724 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1853727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853748 */     // GIR_Coverage, 13666,
     /* 1853748 */     GIR_EraseRootFromParent_Done,
     /* 1853749 */   // Label 25051: @1853749
     /* 1853749 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1853835), // Rule ID 13667 //
     /* 1853754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1853771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853800 */     // MIs[0] policy
     /* 1853800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1853813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853834 */     // GIR_Coverage, 13667,
     /* 1853834 */     GIR_EraseRootFromParent_Done,
     /* 1853835 */   // Label 25052: @1853835
     /* 1853835 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1853921), // Rule ID 13670 //
     /* 1853840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1853857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853886 */     // MIs[0] policy
     /* 1853886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1853899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853920 */     // GIR_Coverage, 13670,
     /* 1853920 */     GIR_EraseRootFromParent_Done,
     /* 1853921 */   // Label 25053: @1853921
     /* 1853921 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1854007), // Rule ID 13671 //
     /* 1853926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1853943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853972 */     // MIs[0] policy
     /* 1853972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853982 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1853985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854006 */     // GIR_Coverage, 13671,
     /* 1854006 */     GIR_EraseRootFromParent_Done,
     /* 1854007 */   // Label 25054: @1854007
     /* 1854007 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1854093), // Rule ID 13674 //
     /* 1854012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1854029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854058 */     // MIs[0] policy
     /* 1854058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1854071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854092 */     // GIR_Coverage, 13674,
     /* 1854092 */     GIR_EraseRootFromParent_Done,
     /* 1854093 */   // Label 25055: @1854093
     /* 1854093 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1854179), // Rule ID 13675 //
     /* 1854098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1854115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854144 */     // MIs[0] policy
     /* 1854144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1854157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854178 */     // GIR_Coverage, 13675,
     /* 1854178 */     GIR_EraseRootFromParent_Done,
     /* 1854179 */   // Label 25056: @1854179
     /* 1854179 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1854265), // Rule ID 13678 //
     /* 1854184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1854201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854230 */     // MIs[0] policy
     /* 1854230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1854243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854264 */     // GIR_Coverage, 13678,
     /* 1854264 */     GIR_EraseRootFromParent_Done,
     /* 1854265 */   // Label 25057: @1854265
     /* 1854265 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1854351), // Rule ID 13679 //
     /* 1854270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1854281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1854284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1854287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1854290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854316 */     // MIs[0] policy
     /* 1854316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854326 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1854329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854350 */     // GIR_Coverage, 13679,
     /* 1854350 */     GIR_EraseRootFromParent_Done,
     /* 1854351 */   // Label 25058: @1854351
     /* 1854351 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1854437), // Rule ID 13682 //
     /* 1854356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1854373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854402 */     // MIs[0] policy
     /* 1854402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1854415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854436 */     // GIR_Coverage, 13682,
     /* 1854436 */     GIR_EraseRootFromParent_Done,
     /* 1854437 */   // Label 25059: @1854437
     /* 1854437 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1854523), // Rule ID 13683 //
     /* 1854442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1854459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854488 */     // MIs[0] policy
     /* 1854488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1854501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854522 */     // GIR_Coverage, 13683,
     /* 1854522 */     GIR_EraseRootFromParent_Done,
     /* 1854523 */   // Label 25060: @1854523
     /* 1854523 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1854609), // Rule ID 13686 //
     /* 1854528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1854545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854574 */     // MIs[0] policy
     /* 1854574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1854587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854608 */     // GIR_Coverage, 13686,
     /* 1854608 */     GIR_EraseRootFromParent_Done,
     /* 1854609 */   // Label 25061: @1854609
     /* 1854609 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1854695), // Rule ID 13687 //
     /* 1854614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1854631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854660 */     // MIs[0] policy
     /* 1854660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1854673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854694 */     // GIR_Coverage, 13687,
     /* 1854694 */     GIR_EraseRootFromParent_Done,
     /* 1854695 */   // Label 25062: @1854695
     /* 1854695 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1854781), // Rule ID 13690 //
     /* 1854700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1854717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854746 */     // MIs[0] policy
     /* 1854746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1854759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854780 */     // GIR_Coverage, 13690,
     /* 1854780 */     GIR_EraseRootFromParent_Done,
     /* 1854781 */   // Label 25063: @1854781
     /* 1854781 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1854867), // Rule ID 13691 //
     /* 1854786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1854803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854832 */     // MIs[0] policy
     /* 1854832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1854845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854866 */     // GIR_Coverage, 13691,
     /* 1854866 */     GIR_EraseRootFromParent_Done,
     /* 1854867 */   // Label 25064: @1854867
     /* 1854867 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1854953), // Rule ID 13694 //
     /* 1854872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1854889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854918 */     // MIs[0] policy
     /* 1854918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1854931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854952 */     // GIR_Coverage, 13694,
     /* 1854952 */     GIR_EraseRootFromParent_Done,
     /* 1854953 */   // Label 25065: @1854953
     /* 1854953 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1855039), // Rule ID 13695 //
     /* 1854958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1854975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855004 */     // MIs[0] policy
     /* 1855004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1855017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855038 */     // GIR_Coverage, 13695,
     /* 1855038 */     GIR_EraseRootFromParent_Done,
     /* 1855039 */   // Label 25066: @1855039
     /* 1855039 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1855125), // Rule ID 13698 //
     /* 1855044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1855061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855090 */     // MIs[0] policy
     /* 1855090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1855103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855124 */     // GIR_Coverage, 13698,
     /* 1855124 */     GIR_EraseRootFromParent_Done,
     /* 1855125 */   // Label 25067: @1855125
     /* 1855125 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1855211), // Rule ID 13699 //
     /* 1855130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1855147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855176 */     // MIs[0] policy
     /* 1855176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1855189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855210 */     // GIR_Coverage, 13699,
     /* 1855210 */     GIR_EraseRootFromParent_Done,
     /* 1855211 */   // Label 25068: @1855211
     /* 1855211 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1855297), // Rule ID 13702 //
     /* 1855216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1855233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855262 */     // MIs[0] policy
     /* 1855262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1855275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855296 */     // GIR_Coverage, 13702,
     /* 1855296 */     GIR_EraseRootFromParent_Done,
     /* 1855297 */   // Label 25069: @1855297
     /* 1855297 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1855383), // Rule ID 13703 //
     /* 1855302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1855313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1855316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1855319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1855322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855348 */     // MIs[0] policy
     /* 1855348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1855361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855382 */     // GIR_Coverage, 13703,
     /* 1855382 */     GIR_EraseRootFromParent_Done,
     /* 1855383 */   // Label 25070: @1855383
     /* 1855383 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1855469), // Rule ID 13706 //
     /* 1855388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1855405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855434 */     // MIs[0] policy
     /* 1855434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1855447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855468 */     // GIR_Coverage, 13706,
     /* 1855468 */     GIR_EraseRootFromParent_Done,
     /* 1855469 */   // Label 25071: @1855469
     /* 1855469 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1855555), // Rule ID 13707 //
     /* 1855474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1855491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855520 */     // MIs[0] policy
     /* 1855520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1855533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855554 */     // GIR_Coverage, 13707,
     /* 1855554 */     GIR_EraseRootFromParent_Done,
     /* 1855555 */   // Label 25072: @1855555
     /* 1855555 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1855641), // Rule ID 13710 //
     /* 1855560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1855577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855606 */     // MIs[0] policy
     /* 1855606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1855619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855640 */     // GIR_Coverage, 13710,
     /* 1855640 */     GIR_EraseRootFromParent_Done,
     /* 1855641 */   // Label 25073: @1855641
     /* 1855641 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1855727), // Rule ID 13711 //
     /* 1855646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1855663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855692 */     // MIs[0] policy
     /* 1855692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1855705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855726 */     // GIR_Coverage, 13711,
     /* 1855726 */     GIR_EraseRootFromParent_Done,
     /* 1855727 */   // Label 25074: @1855727
     /* 1855727 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1855813), // Rule ID 13714 //
     /* 1855732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1855749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855778 */     // MIs[0] policy
     /* 1855778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1855791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855812 */     // GIR_Coverage, 13714,
     /* 1855812 */     GIR_EraseRootFromParent_Done,
     /* 1855813 */   // Label 25075: @1855813
     /* 1855813 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1855899), // Rule ID 13715 //
     /* 1855818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1855835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855864 */     // MIs[0] policy
     /* 1855864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1855877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855898 */     // GIR_Coverage, 13715,
     /* 1855898 */     GIR_EraseRootFromParent_Done,
     /* 1855899 */   // Label 25076: @1855899
     /* 1855899 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1855985), // Rule ID 13718 //
     /* 1855904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1855915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1855918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1855921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1855924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855950 */     // MIs[0] policy
     /* 1855950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1855963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855984 */     // GIR_Coverage, 13718,
     /* 1855984 */     GIR_EraseRootFromParent_Done,
     /* 1855985 */   // Label 25077: @1855985
     /* 1855985 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1856071), // Rule ID 13719 //
     /* 1855990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1856007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856036 */     // MIs[0] policy
     /* 1856036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856046 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1856049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856070 */     // GIR_Coverage, 13719,
     /* 1856070 */     GIR_EraseRootFromParent_Done,
     /* 1856071 */   // Label 25078: @1856071
     /* 1856071 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1856157), // Rule ID 13722 //
     /* 1856076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856122 */     // MIs[0] policy
     /* 1856122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1856135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856156 */     // GIR_Coverage, 13722,
     /* 1856156 */     GIR_EraseRootFromParent_Done,
     /* 1856157 */   // Label 25079: @1856157
     /* 1856157 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1856243), // Rule ID 13723 //
     /* 1856162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1856173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1856176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856208 */     // MIs[0] policy
     /* 1856208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1856221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856242 */     // GIR_Coverage, 13723,
     /* 1856242 */     GIR_EraseRootFromParent_Done,
     /* 1856243 */   // Label 25080: @1856243
     /* 1856243 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1856329), // Rule ID 13726 //
     /* 1856248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856294 */     // MIs[0] policy
     /* 1856294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1856307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856328 */     // GIR_Coverage, 13726,
     /* 1856328 */     GIR_EraseRootFromParent_Done,
     /* 1856329 */   // Label 25081: @1856329
     /* 1856329 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1856415), // Rule ID 13727 //
     /* 1856334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1856345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856380 */     // MIs[0] policy
     /* 1856380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1856393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856414 */     // GIR_Coverage, 13727,
     /* 1856414 */     GIR_EraseRootFromParent_Done,
     /* 1856415 */   // Label 25082: @1856415
     /* 1856415 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1856501), // Rule ID 13730 //
     /* 1856420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856466 */     // MIs[0] policy
     /* 1856466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1856479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856500 */     // GIR_Coverage, 13730,
     /* 1856500 */     GIR_EraseRootFromParent_Done,
     /* 1856501 */   // Label 25083: @1856501
     /* 1856501 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1856587), // Rule ID 13731 //
     /* 1856506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856552 */     // MIs[0] policy
     /* 1856552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1856565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856586 */     // GIR_Coverage, 13731,
     /* 1856586 */     GIR_EraseRootFromParent_Done,
     /* 1856587 */   // Label 25084: @1856587
     /* 1856587 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1856673), // Rule ID 13734 //
     /* 1856592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856638 */     // MIs[0] policy
     /* 1856638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1856651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856672 */     // GIR_Coverage, 13734,
     /* 1856672 */     GIR_EraseRootFromParent_Done,
     /* 1856673 */   // Label 25085: @1856673
     /* 1856673 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1856759), // Rule ID 13735 //
     /* 1856678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856724 */     // MIs[0] policy
     /* 1856724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1856737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856758 */     // GIR_Coverage, 13735,
     /* 1856758 */     GIR_EraseRootFromParent_Done,
     /* 1856759 */   // Label 25086: @1856759
     /* 1856759 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1856845), // Rule ID 13738 //
     /* 1856764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856810 */     // MIs[0] policy
     /* 1856810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1856823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856844 */     // GIR_Coverage, 13738,
     /* 1856844 */     GIR_EraseRootFromParent_Done,
     /* 1856845 */   // Label 25087: @1856845
     /* 1856845 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1856931), // Rule ID 13739 //
     /* 1856850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856896 */     // MIs[0] policy
     /* 1856896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1856909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856930 */     // GIR_Coverage, 13739,
     /* 1856930 */     GIR_EraseRootFromParent_Done,
     /* 1856931 */   // Label 25088: @1856931
     /* 1856931 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1857017), // Rule ID 13742 //
     /* 1856936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1856947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1856950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1856956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1856959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856982 */     // MIs[0] policy
     /* 1856982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856992 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1856995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857016 */     // GIR_Coverage, 13742,
     /* 1857016 */     GIR_EraseRootFromParent_Done,
     /* 1857017 */   // Label 25089: @1857017
     /* 1857017 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1857103), // Rule ID 13743 //
     /* 1857022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1857033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1857036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1857042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1857045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857068 */     // MIs[0] policy
     /* 1857068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857078 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1857081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857102 */     // GIR_Coverage, 13743,
     /* 1857102 */     GIR_EraseRootFromParent_Done,
     /* 1857103 */   // Label 25090: @1857103
     /* 1857103 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1857189), // Rule ID 13746 //
     /* 1857108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857154 */     // MIs[0] policy
     /* 1857154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1857167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857188 */     // GIR_Coverage, 13746,
     /* 1857188 */     GIR_EraseRootFromParent_Done,
     /* 1857189 */   // Label 25091: @1857189
     /* 1857189 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1857275), // Rule ID 13747 //
     /* 1857194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857240 */     // MIs[0] policy
     /* 1857240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1857253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857274 */     // GIR_Coverage, 13747,
     /* 1857274 */     GIR_EraseRootFromParent_Done,
     /* 1857275 */   // Label 25092: @1857275
     /* 1857275 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1857361), // Rule ID 13750 //
     /* 1857280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857326 */     // MIs[0] policy
     /* 1857326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1857339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857360 */     // GIR_Coverage, 13750,
     /* 1857360 */     GIR_EraseRootFromParent_Done,
     /* 1857361 */   // Label 25093: @1857361
     /* 1857361 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1857447), // Rule ID 13751 //
     /* 1857366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857412 */     // MIs[0] policy
     /* 1857412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1857425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857446 */     // GIR_Coverage, 13751,
     /* 1857446 */     GIR_EraseRootFromParent_Done,
     /* 1857447 */   // Label 25094: @1857447
     /* 1857447 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1857533), // Rule ID 13754 //
     /* 1857452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857498 */     // MIs[0] policy
     /* 1857498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1857511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857532 */     // GIR_Coverage, 13754,
     /* 1857532 */     GIR_EraseRootFromParent_Done,
     /* 1857533 */   // Label 25095: @1857533
     /* 1857533 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1857619), // Rule ID 13755 //
     /* 1857538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857584 */     // MIs[0] policy
     /* 1857584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1857597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857618 */     // GIR_Coverage, 13755,
     /* 1857618 */     GIR_EraseRootFromParent_Done,
     /* 1857619 */   // Label 25096: @1857619
     /* 1857619 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1857705), // Rule ID 13758 //
     /* 1857624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857670 */     // MIs[0] policy
     /* 1857670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1857683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857704 */     // GIR_Coverage, 13758,
     /* 1857704 */     GIR_EraseRootFromParent_Done,
     /* 1857705 */   // Label 25097: @1857705
     /* 1857705 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1857791), // Rule ID 13759 //
     /* 1857710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857756 */     // MIs[0] policy
     /* 1857756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1857769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857790 */     // GIR_Coverage, 13759,
     /* 1857790 */     GIR_EraseRootFromParent_Done,
     /* 1857791 */   // Label 25098: @1857791
     /* 1857791 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1857877), // Rule ID 13762 //
     /* 1857796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857842 */     // MIs[0] policy
     /* 1857842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1857855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857876 */     // GIR_Coverage, 13762,
     /* 1857876 */     GIR_EraseRootFromParent_Done,
     /* 1857877 */   // Label 25099: @1857877
     /* 1857877 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1857963), // Rule ID 13763 //
     /* 1857882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1857899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1857920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857928 */     // MIs[0] policy
     /* 1857928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1857941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857962 */     // GIR_Coverage, 13763,
     /* 1857962 */     GIR_EraseRootFromParent_Done,
     /* 1857963 */   // Label 25100: @1857963
     /* 1857963 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1858049), // Rule ID 13766 //
     /* 1857968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1857985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858014 */     // MIs[0] policy
     /* 1858014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858048 */     // GIR_Coverage, 13766,
     /* 1858048 */     GIR_EraseRootFromParent_Done,
     /* 1858049 */   // Label 25101: @1858049
     /* 1858049 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1858135), // Rule ID 13767 //
     /* 1858054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1858074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858100 */     // MIs[0] policy
     /* 1858100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858134 */     // GIR_Coverage, 13767,
     /* 1858134 */     GIR_EraseRootFromParent_Done,
     /* 1858135 */   // Label 25102: @1858135
     /* 1858135 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1858221), // Rule ID 13770 //
     /* 1858140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858186 */     // MIs[0] policy
     /* 1858186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858220 */     // GIR_Coverage, 13770,
     /* 1858220 */     GIR_EraseRootFromParent_Done,
     /* 1858221 */   // Label 25103: @1858221
     /* 1858221 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1858307), // Rule ID 13771 //
     /* 1858226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1858237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1858240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858272 */     // MIs[0] policy
     /* 1858272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858306 */     // GIR_Coverage, 13771,
     /* 1858306 */     GIR_EraseRootFromParent_Done,
     /* 1858307 */   // Label 25104: @1858307
     /* 1858307 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1858393), // Rule ID 13774 //
     /* 1858312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858358 */     // MIs[0] policy
     /* 1858358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1858371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858392 */     // GIR_Coverage, 13774,
     /* 1858392 */     GIR_EraseRootFromParent_Done,
     /* 1858393 */   // Label 25105: @1858393
     /* 1858393 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1858479), // Rule ID 13775 //
     /* 1858398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858444 */     // MIs[0] policy
     /* 1858444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1858457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858478 */     // GIR_Coverage, 13775,
     /* 1858478 */     GIR_EraseRootFromParent_Done,
     /* 1858479 */   // Label 25106: @1858479
     /* 1858479 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1858565), // Rule ID 13778 //
     /* 1858484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858530 */     // MIs[0] policy
     /* 1858530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1858543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858564 */     // GIR_Coverage, 13778,
     /* 1858564 */     GIR_EraseRootFromParent_Done,
     /* 1858565 */   // Label 25107: @1858565
     /* 1858565 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1858651), // Rule ID 13779 //
     /* 1858570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858616 */     // MIs[0] policy
     /* 1858616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1858629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858650 */     // GIR_Coverage, 13779,
     /* 1858650 */     GIR_EraseRootFromParent_Done,
     /* 1858651 */   // Label 25108: @1858651
     /* 1858651 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1858737), // Rule ID 13782 //
     /* 1858656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1858664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858702 */     // MIs[0] policy
     /* 1858702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1858715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858736 */     // GIR_Coverage, 13782,
     /* 1858736 */     GIR_EraseRootFromParent_Done,
     /* 1858737 */   // Label 25109: @1858737
     /* 1858737 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1858823), // Rule ID 13783 //
     /* 1858742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1858750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858788 */     // MIs[0] policy
     /* 1858788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1858801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858822 */     // GIR_Coverage, 13783,
     /* 1858822 */     GIR_EraseRootFromParent_Done,
     /* 1858823 */   // Label 25110: @1858823
     /* 1858823 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1858909), // Rule ID 13786 //
     /* 1858828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1858836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858874 */     // MIs[0] policy
     /* 1858874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1858887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858908 */     // GIR_Coverage, 13786,
     /* 1858908 */     GIR_EraseRootFromParent_Done,
     /* 1858909 */   // Label 25111: @1858909
     /* 1858909 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1858995), // Rule ID 13787 //
     /* 1858914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1858922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858960 */     // MIs[0] policy
     /* 1858960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1858973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858994 */     // GIR_Coverage, 13787,
     /* 1858994 */     GIR_EraseRootFromParent_Done,
     /* 1858995 */   // Label 25112: @1858995
     /* 1858995 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1859081), // Rule ID 13790 //
     /* 1859000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859046 */     // MIs[0] policy
     /* 1859046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1859059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859080 */     // GIR_Coverage, 13790,
     /* 1859080 */     GIR_EraseRootFromParent_Done,
     /* 1859081 */   // Label 25113: @1859081
     /* 1859081 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1859167), // Rule ID 13791 //
     /* 1859086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1859097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1859100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1859106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859132 */     // MIs[0] policy
     /* 1859132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1859145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859166 */     // GIR_Coverage, 13791,
     /* 1859166 */     GIR_EraseRootFromParent_Done,
     /* 1859167 */   // Label 25114: @1859167
     /* 1859167 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1859253), // Rule ID 13794 //
     /* 1859172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859218 */     // MIs[0] policy
     /* 1859218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1859231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859252 */     // GIR_Coverage, 13794,
     /* 1859252 */     GIR_EraseRootFromParent_Done,
     /* 1859253 */   // Label 25115: @1859253
     /* 1859253 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1859339), // Rule ID 13795 //
     /* 1859258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1859278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859304 */     // MIs[0] policy
     /* 1859304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1859317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859338 */     // GIR_Coverage, 13795,
     /* 1859338 */     GIR_EraseRootFromParent_Done,
     /* 1859339 */   // Label 25116: @1859339
     /* 1859339 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1859425), // Rule ID 13798 //
     /* 1859344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859390 */     // MIs[0] policy
     /* 1859390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1859403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859424 */     // GIR_Coverage, 13798,
     /* 1859424 */     GIR_EraseRootFromParent_Done,
     /* 1859425 */   // Label 25117: @1859425
     /* 1859425 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1859511), // Rule ID 13799 //
     /* 1859430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859476 */     // MIs[0] policy
     /* 1859476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1859489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859510 */     // GIR_Coverage, 13799,
     /* 1859510 */     GIR_EraseRootFromParent_Done,
     /* 1859511 */   // Label 25118: @1859511
     /* 1859511 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1859597), // Rule ID 13802 //
     /* 1859516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859562 */     // MIs[0] policy
     /* 1859562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1859575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859596 */     // GIR_Coverage, 13802,
     /* 1859596 */     GIR_EraseRootFromParent_Done,
     /* 1859597 */   // Label 25119: @1859597
     /* 1859597 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1859683), // Rule ID 13803 //
     /* 1859602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859648 */     // MIs[0] policy
     /* 1859648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1859661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859682 */     // GIR_Coverage, 13803,
     /* 1859682 */     GIR_EraseRootFromParent_Done,
     /* 1859683 */   // Label 25120: @1859683
     /* 1859683 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1859769), // Rule ID 13806 //
     /* 1859688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859734 */     // MIs[0] policy
     /* 1859734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1859747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859768 */     // GIR_Coverage, 13806,
     /* 1859768 */     GIR_EraseRootFromParent_Done,
     /* 1859769 */   // Label 25121: @1859769
     /* 1859769 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1859855), // Rule ID 13807 //
     /* 1859774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859820 */     // MIs[0] policy
     /* 1859820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1859833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859854 */     // GIR_Coverage, 13807,
     /* 1859854 */     GIR_EraseRootFromParent_Done,
     /* 1859855 */   // Label 25122: @1859855
     /* 1859855 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1859941), // Rule ID 13810 //
     /* 1859860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859906 */     // MIs[0] policy
     /* 1859906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1859919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859940 */     // GIR_Coverage, 13810,
     /* 1859940 */     GIR_EraseRootFromParent_Done,
     /* 1859941 */   // Label 25123: @1859941
     /* 1859941 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1860027), // Rule ID 13811 //
     /* 1859946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1859954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859992 */     // MIs[0] policy
     /* 1859992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1860005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860026 */     // GIR_Coverage, 13811,
     /* 1860026 */     GIR_EraseRootFromParent_Done,
     /* 1860027 */   // Label 25124: @1860027
     /* 1860027 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1860113), // Rule ID 13814 //
     /* 1860032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860078 */     // MIs[0] policy
     /* 1860078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1860091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860112 */     // GIR_Coverage, 13814,
     /* 1860112 */     GIR_EraseRootFromParent_Done,
     /* 1860113 */   // Label 25125: @1860113
     /* 1860113 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1860199), // Rule ID 13815 //
     /* 1860118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1860129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1860132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1860138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860164 */     // MIs[0] policy
     /* 1860164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1860177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860198 */     // GIR_Coverage, 13815,
     /* 1860198 */     GIR_EraseRootFromParent_Done,
     /* 1860199 */   // Label 25126: @1860199
     /* 1860199 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1860285), // Rule ID 13818 //
     /* 1860204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860250 */     // MIs[0] policy
     /* 1860250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1860263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860284 */     // GIR_Coverage, 13818,
     /* 1860284 */     GIR_EraseRootFromParent_Done,
     /* 1860285 */   // Label 25127: @1860285
     /* 1860285 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1860371), // Rule ID 13819 //
     /* 1860290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1860310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860336 */     // MIs[0] policy
     /* 1860336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1860349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860370 */     // GIR_Coverage, 13819,
     /* 1860370 */     GIR_EraseRootFromParent_Done,
     /* 1860371 */   // Label 25128: @1860371
     /* 1860371 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1860457), // Rule ID 13822 //
     /* 1860376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860422 */     // MIs[0] policy
     /* 1860422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1860435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860456 */     // GIR_Coverage, 13822,
     /* 1860456 */     GIR_EraseRootFromParent_Done,
     /* 1860457 */   // Label 25129: @1860457
     /* 1860457 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1860543), // Rule ID 13823 //
     /* 1860462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860508 */     // MIs[0] policy
     /* 1860508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1860521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860542 */     // GIR_Coverage, 13823,
     /* 1860542 */     GIR_EraseRootFromParent_Done,
     /* 1860543 */   // Label 25130: @1860543
     /* 1860543 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1860629), // Rule ID 13826 //
     /* 1860548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860594 */     // MIs[0] policy
     /* 1860594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1860607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860628 */     // GIR_Coverage, 13826,
     /* 1860628 */     GIR_EraseRootFromParent_Done,
     /* 1860629 */   // Label 25131: @1860629
     /* 1860629 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1860715), // Rule ID 13827 //
     /* 1860634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860680 */     // MIs[0] policy
     /* 1860680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1860693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860714 */     // GIR_Coverage, 13827,
     /* 1860714 */     GIR_EraseRootFromParent_Done,
     /* 1860715 */   // Label 25132: @1860715
     /* 1860715 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1860801), // Rule ID 13830 //
     /* 1860720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860766 */     // MIs[0] policy
     /* 1860766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1860779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860800 */     // GIR_Coverage, 13830,
     /* 1860800 */     GIR_EraseRootFromParent_Done,
     /* 1860801 */   // Label 25133: @1860801
     /* 1860801 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1860887), // Rule ID 13831 //
     /* 1860806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860852 */     // MIs[0] policy
     /* 1860852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11593:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1860865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860886 */     // GIR_Coverage, 13831,
     /* 1860886 */     GIR_EraseRootFromParent_Done,
     /* 1860887 */   // Label 25134: @1860887
     /* 1860887 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1860973), // Rule ID 13834 //
     /* 1860892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860938 */     // MIs[0] policy
     /* 1860938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1860951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860972 */     // GIR_Coverage, 13834,
     /* 1860972 */     GIR_EraseRootFromParent_Done,
     /* 1860973 */   // Label 25135: @1860973
     /* 1860973 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1861059), // Rule ID 13835 //
     /* 1860978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861024 */     // MIs[0] policy
     /* 1861024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11593:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1861037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861058 */     // GIR_Coverage, 13835,
     /* 1861058 */     GIR_EraseRootFromParent_Done,
     /* 1861059 */   // Label 25136: @1861059
     /* 1861059 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1861145), // Rule ID 13838 //
     /* 1861064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1861067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861110 */     // MIs[0] policy
     /* 1861110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861144 */     // GIR_Coverage, 13838,
     /* 1861144 */     GIR_EraseRootFromParent_Done,
     /* 1861145 */   // Label 25137: @1861145
     /* 1861145 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1861231), // Rule ID 13839 //
     /* 1861150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1861153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1861161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1861164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1861170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861196 */     // MIs[0] policy
     /* 1861196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11593:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861230 */     // GIR_Coverage, 13839,
     /* 1861230 */     GIR_EraseRootFromParent_Done,
     /* 1861231 */   // Label 25138: @1861231
     /* 1861231 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1861320), // Rule ID 14048 //
     /* 1861236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1861247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1861250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1861253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861282 */     // MIs[0] policy
     /* 1861282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1861295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861319 */     // GIR_Coverage, 14048,
     /* 1861319 */     GIR_EraseRootFromParent_Done,
     /* 1861320 */   // Label 25139: @1861320
     /* 1861320 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1861409), // Rule ID 14049 //
     /* 1861325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1861336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1861339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1861342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1861345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861371 */     // MIs[0] policy
     /* 1861371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861381 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1861384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861408 */     // GIR_Coverage, 14049,
     /* 1861408 */     GIR_EraseRootFromParent_Done,
     /* 1861409 */   // Label 25140: @1861409
     /* 1861409 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1861498), // Rule ID 14052 //
     /* 1861414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1861425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1861428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1861431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861460 */     // MIs[0] policy
     /* 1861460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861470 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1861473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861497 */     // GIR_Coverage, 14052,
     /* 1861497 */     GIR_EraseRootFromParent_Done,
     /* 1861498 */   // Label 25141: @1861498
     /* 1861498 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1861587), // Rule ID 14053 //
     /* 1861503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1861514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1861517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1861520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861549 */     // MIs[0] policy
     /* 1861549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861559 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1861562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861586 */     // GIR_Coverage, 14053,
     /* 1861586 */     GIR_EraseRootFromParent_Done,
     /* 1861587 */   // Label 25142: @1861587
     /* 1861587 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1861676), // Rule ID 14056 //
     /* 1861592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1861603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1861606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1861609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861638 */     // MIs[0] policy
     /* 1861638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1861651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861675 */     // GIR_Coverage, 14056,
     /* 1861675 */     GIR_EraseRootFromParent_Done,
     /* 1861676 */   // Label 25143: @1861676
     /* 1861676 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1861765), // Rule ID 14057 //
     /* 1861681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1861692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1861695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1861698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861727 */     // MIs[0] policy
     /* 1861727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861737 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1861740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861764 */     // GIR_Coverage, 14057,
     /* 1861764 */     GIR_EraseRootFromParent_Done,
     /* 1861765 */   // Label 25144: @1861765
     /* 1861765 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1861854), // Rule ID 14060 //
     /* 1861770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1861787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1861790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861816 */     // MIs[0] policy
     /* 1861816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1861829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861853 */     // GIR_Coverage, 14060,
     /* 1861853 */     GIR_EraseRootFromParent_Done,
     /* 1861854 */   // Label 25145: @1861854
     /* 1861854 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1861943), // Rule ID 14061 //
     /* 1861859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1861876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1861879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861905 */     // MIs[0] policy
     /* 1861905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861915 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1861918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861942 */     // GIR_Coverage, 14061,
     /* 1861942 */     GIR_EraseRootFromParent_Done,
     /* 1861943 */   // Label 25146: @1861943
     /* 1861943 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1862032), // Rule ID 14064 //
     /* 1861948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1861965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1861968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861994 */     // MIs[0] policy
     /* 1861994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862004 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1862007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862031 */     // GIR_Coverage, 14064,
     /* 1862031 */     GIR_EraseRootFromParent_Done,
     /* 1862032 */   // Label 25147: @1862032
     /* 1862032 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1862121), // Rule ID 14065 //
     /* 1862037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1862048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1862051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1862054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862083 */     // MIs[0] policy
     /* 1862083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1862096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862120 */     // GIR_Coverage, 14065,
     /* 1862120 */     GIR_EraseRootFromParent_Done,
     /* 1862121 */   // Label 25148: @1862121
     /* 1862121 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1862210), // Rule ID 14068 //
     /* 1862126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1862143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862172 */     // MIs[0] policy
     /* 1862172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1862185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862209 */     // GIR_Coverage, 14068,
     /* 1862209 */     GIR_EraseRootFromParent_Done,
     /* 1862210 */   // Label 25149: @1862210
     /* 1862210 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1862299), // Rule ID 14069 //
     /* 1862215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1862232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862261 */     // MIs[0] policy
     /* 1862261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862271 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1862274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862298 */     // GIR_Coverage, 14069,
     /* 1862298 */     GIR_EraseRootFromParent_Done,
     /* 1862299 */   // Label 25150: @1862299
     /* 1862299 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1862388), // Rule ID 14072 //
     /* 1862304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1862315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1862318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1862321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1862324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862350 */     // MIs[0] policy
     /* 1862350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862387 */     // GIR_Coverage, 14072,
     /* 1862387 */     GIR_EraseRootFromParent_Done,
     /* 1862388 */   // Label 25151: @1862388
     /* 1862388 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1862477), // Rule ID 14073 //
     /* 1862393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1862404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1862407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1862410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1862413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862439 */     // MIs[0] policy
     /* 1862439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862476 */     // GIR_Coverage, 14073,
     /* 1862476 */     GIR_EraseRootFromParent_Done,
     /* 1862477 */   // Label 25152: @1862477
     /* 1862477 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1862566), // Rule ID 14076 //
     /* 1862482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862528 */     // MIs[0] policy
     /* 1862528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862565 */     // GIR_Coverage, 14076,
     /* 1862565 */     GIR_EraseRootFromParent_Done,
     /* 1862566 */   // Label 25153: @1862566
     /* 1862566 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1862655), // Rule ID 14077 //
     /* 1862571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862617 */     // MIs[0] policy
     /* 1862617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862627 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862648 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862654 */     // GIR_Coverage, 14077,
     /* 1862654 */     GIR_EraseRootFromParent_Done,
     /* 1862655 */   // Label 25154: @1862655
     /* 1862655 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1862744), // Rule ID 14080 //
     /* 1862660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1862680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862706 */     // MIs[0] policy
     /* 1862706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862743 */     // GIR_Coverage, 14080,
     /* 1862743 */     GIR_EraseRootFromParent_Done,
     /* 1862744 */   // Label 25155: @1862744
     /* 1862744 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1862833), // Rule ID 14081 //
     /* 1862749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1862769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862795 */     // MIs[0] policy
     /* 1862795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862805 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862832 */     // GIR_Coverage, 14081,
     /* 1862832 */     GIR_EraseRootFromParent_Done,
     /* 1862833 */   // Label 25156: @1862833
     /* 1862833 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1862922), // Rule ID 14084 //
     /* 1862838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1862841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1862858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862884 */     // MIs[0] policy
     /* 1862884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1862915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862921 */     // GIR_Coverage, 14084,
     /* 1862921 */     GIR_EraseRootFromParent_Done,
     /* 1862922 */   // Label 25157: @1862922
     /* 1862922 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1863011), // Rule ID 14085 //
     /* 1862927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1862930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1862947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862973 */     // MIs[0] policy
     /* 1862973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862983 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1862986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1863004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863010 */     // GIR_Coverage, 14085,
     /* 1863010 */     GIR_EraseRootFromParent_Done,
     /* 1863011 */   // Label 25158: @1863011
     /* 1863011 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1863100), // Rule ID 14088 //
     /* 1863016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1863027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1863030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1863033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1863036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863062 */     // MIs[0] policy
     /* 1863062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1863075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863099 */     // GIR_Coverage, 14088,
     /* 1863099 */     GIR_EraseRootFromParent_Done,
     /* 1863100 */   // Label 25159: @1863100
     /* 1863100 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1863189), // Rule ID 14089 //
     /* 1863105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1863116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1863119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1863122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1863125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863151 */     // MIs[0] policy
     /* 1863151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1863164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863188 */     // GIR_Coverage, 14089,
     /* 1863188 */     GIR_EraseRootFromParent_Done,
     /* 1863189 */   // Label 25160: @1863189
     /* 1863189 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1863278), // Rule ID 14092 //
     /* 1863194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1863205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1863208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1863211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1863214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863240 */     // MIs[0] policy
     /* 1863240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863250 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1863253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863277 */     // GIR_Coverage, 14092,
     /* 1863277 */     GIR_EraseRootFromParent_Done,
     /* 1863278 */   // Label 25161: @1863278
     /* 1863278 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1863367), // Rule ID 14093 //
     /* 1863283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1863294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1863297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1863300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1863303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863329 */     // MIs[0] policy
     /* 1863329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863339 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1863342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863366 */     // GIR_Coverage, 14093,
     /* 1863366 */     GIR_EraseRootFromParent_Done,
     /* 1863367 */   // Label 25162: @1863367
     /* 1863367 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1863456), // Rule ID 14096 //
     /* 1863372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1863383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1863386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1863389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1863392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1863395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863418 */     // MIs[0] policy
     /* 1863418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863428 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1863431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863455 */     // GIR_Coverage, 14096,
     /* 1863455 */     GIR_EraseRootFromParent_Done,
     /* 1863456 */   // Label 25163: @1863456
     /* 1863456 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1863545), // Rule ID 14097 //
     /* 1863461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1863472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1863475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1863478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1863481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1863484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863507 */     // MIs[0] policy
     /* 1863507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863517 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1863520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863544 */     // GIR_Coverage, 14097,
     /* 1863544 */     GIR_EraseRootFromParent_Done,
     /* 1863545 */   // Label 25164: @1863545
     /* 1863545 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1863634), // Rule ID 14100 //
     /* 1863550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1863561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1863564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1863567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863596 */     // MIs[0] policy
     /* 1863596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863606 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1863609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863633 */     // GIR_Coverage, 14100,
     /* 1863633 */     GIR_EraseRootFromParent_Done,
     /* 1863634 */   // Label 25165: @1863634
     /* 1863634 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1863723), // Rule ID 14101 //
     /* 1863639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1863650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1863653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1863656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1863659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863685 */     // MIs[0] policy
     /* 1863685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863695 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1863698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863722 */     // GIR_Coverage, 14101,
     /* 1863722 */     GIR_EraseRootFromParent_Done,
     /* 1863723 */   // Label 25166: @1863723
     /* 1863723 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1863812), // Rule ID 14104 //
     /* 1863728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863774 */     // MIs[0] policy
     /* 1863774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1863787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863811 */     // GIR_Coverage, 14104,
     /* 1863811 */     GIR_EraseRootFromParent_Done,
     /* 1863812 */   // Label 25167: @1863812
     /* 1863812 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1863901), // Rule ID 14105 //
     /* 1863817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1863837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863863 */     // MIs[0] policy
     /* 1863863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863873 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1863876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863900 */     // GIR_Coverage, 14105,
     /* 1863900 */     GIR_EraseRootFromParent_Done,
     /* 1863901 */   // Label 25168: @1863901
     /* 1863901 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1863990), // Rule ID 14108 //
     /* 1863906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1863923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1863926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863952 */     // MIs[0] policy
     /* 1863952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863962 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1863965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863989 */     // GIR_Coverage, 14108,
     /* 1863989 */     GIR_EraseRootFromParent_Done,
     /* 1863990 */   // Label 25169: @1863990
     /* 1863990 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1864079), // Rule ID 14109 //
     /* 1863995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1864006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1864009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1864012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1864015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1864018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864041 */     // MIs[0] policy
     /* 1864041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864051 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1864054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864078 */     // GIR_Coverage, 14109,
     /* 1864078 */     GIR_EraseRootFromParent_Done,
     /* 1864079 */   // Label 25170: @1864079
     /* 1864079 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1864168), // Rule ID 14112 //
     /* 1864084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1864095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1864098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1864101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1864104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864130 */     // MIs[0] policy
     /* 1864130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1864143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864167 */     // GIR_Coverage, 14112,
     /* 1864167 */     GIR_EraseRootFromParent_Done,
     /* 1864168 */   // Label 25171: @1864168
     /* 1864168 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1864257), // Rule ID 14113 //
     /* 1864173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1864184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1864187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1864190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1864193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864219 */     // MIs[0] policy
     /* 1864219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1864232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864256 */     // GIR_Coverage, 14113,
     /* 1864256 */     GIR_EraseRootFromParent_Done,
     /* 1864257 */   // Label 25172: @1864257
     /* 1864257 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1864346), // Rule ID 14116 //
     /* 1864262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1864273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1864276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1864279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1864282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864308 */     // MIs[0] policy
     /* 1864308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1864321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864345 */     // GIR_Coverage, 14116,
     /* 1864345 */     GIR_EraseRootFromParent_Done,
     /* 1864346 */   // Label 25173: @1864346
     /* 1864346 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1864435), // Rule ID 14117 //
     /* 1864351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1864362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1864365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1864368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1864371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864397 */     // MIs[0] policy
     /* 1864397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864407 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1864410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864434 */     // GIR_Coverage, 14117,
     /* 1864434 */     GIR_EraseRootFromParent_Done,
     /* 1864435 */   // Label 25174: @1864435
     /* 1864435 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1864524), // Rule ID 14120 //
     /* 1864440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1864451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1864454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1864457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1864460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1864463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864486 */     // MIs[0] policy
     /* 1864486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1864499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864523 */     // GIR_Coverage, 14120,
     /* 1864523 */     GIR_EraseRootFromParent_Done,
     /* 1864524 */   // Label 25175: @1864524
     /* 1864524 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1864613), // Rule ID 14121 //
     /* 1864529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1864540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1864543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1864546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1864549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1864552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864575 */     // MIs[0] policy
     /* 1864575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864585 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1864588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864612 */     // GIR_Coverage, 14121,
     /* 1864612 */     GIR_EraseRootFromParent_Done,
     /* 1864613 */   // Label 25176: @1864613
     /* 1864613 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1864702), // Rule ID 14124 //
     /* 1864618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1864638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864664 */     // MIs[0] policy
     /* 1864664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1864677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864701 */     // GIR_Coverage, 14124,
     /* 1864701 */     GIR_EraseRootFromParent_Done,
     /* 1864702 */   // Label 25177: @1864702
     /* 1864702 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1864791), // Rule ID 14125 //
     /* 1864707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1864710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1864727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864753 */     // MIs[0] policy
     /* 1864753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1864766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864790 */     // GIR_Coverage, 14125,
     /* 1864790 */     GIR_EraseRootFromParent_Done,
     /* 1864791 */   // Label 25178: @1864791
     /* 1864791 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1864880), // Rule ID 14128 //
     /* 1864796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1864816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864842 */     // MIs[0] policy
     /* 1864842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1864855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864879 */     // GIR_Coverage, 14128,
     /* 1864879 */     GIR_EraseRootFromParent_Done,
     /* 1864880 */   // Label 25179: @1864880
     /* 1864880 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1864969), // Rule ID 14129 //
     /* 1864885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1864888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1864905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864931 */     // MIs[0] policy
     /* 1864931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1864944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864962 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864968 */     // GIR_Coverage, 14129,
     /* 1864968 */     GIR_EraseRootFromParent_Done,
     /* 1864969 */   // Label 25180: @1864969
     /* 1864969 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1865058), // Rule ID 14132 //
     /* 1864974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1864991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1864994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865020 */     // MIs[0] policy
     /* 1865020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865057 */     // GIR_Coverage, 14132,
     /* 1865057 */     GIR_EraseRootFromParent_Done,
     /* 1865058 */   // Label 25181: @1865058
     /* 1865058 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1865147), // Rule ID 14133 //
     /* 1865063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1865066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1865074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1865077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1865080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1865083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865109 */     // MIs[0] policy
     /* 1865109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865119 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865140 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865146 */     // GIR_Coverage, 14133,
     /* 1865146 */     GIR_EraseRootFromParent_Done,
     /* 1865147 */   // Label 25182: @1865147
     /* 1865147 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1865236), // Rule ID 14136 //
     /* 1865152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1865163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1865166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1865169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1865172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865198 */     // MIs[0] policy
     /* 1865198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1865211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865235 */     // GIR_Coverage, 14136,
     /* 1865235 */     GIR_EraseRootFromParent_Done,
     /* 1865236 */   // Label 25183: @1865236
     /* 1865236 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1865325), // Rule ID 14137 //
     /* 1865241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1865252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1865255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1865258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1865261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865287 */     // MIs[0] policy
     /* 1865287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865297 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1865300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865324 */     // GIR_Coverage, 14137,
     /* 1865324 */     GIR_EraseRootFromParent_Done,
     /* 1865325 */   // Label 25184: @1865325
     /* 1865325 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1865414), // Rule ID 14140 //
     /* 1865330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1865341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1865344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1865347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1865350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865376 */     // MIs[0] policy
     /* 1865376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865386 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1865389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865413 */     // GIR_Coverage, 14140,
     /* 1865413 */     GIR_EraseRootFromParent_Done,
     /* 1865414 */   // Label 25185: @1865414
     /* 1865414 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1865503), // Rule ID 14141 //
     /* 1865419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1865430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1865433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1865436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1865439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865465 */     // MIs[0] policy
     /* 1865465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1865478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865502 */     // GIR_Coverage, 14141,
     /* 1865502 */     GIR_EraseRootFromParent_Done,
     /* 1865503 */   // Label 25186: @1865503
     /* 1865503 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1865592), // Rule ID 14144 //
     /* 1865508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1865519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1865522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1865525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1865528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865554 */     // MIs[0] policy
     /* 1865554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865564 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1865567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865591 */     // GIR_Coverage, 14144,
     /* 1865591 */     GIR_EraseRootFromParent_Done,
     /* 1865592 */   // Label 25187: @1865592
     /* 1865592 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1865681), // Rule ID 14145 //
     /* 1865597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1865608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1865611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1865614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1865617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865643 */     // MIs[0] policy
     /* 1865643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865653 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1865656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865680 */     // GIR_Coverage, 14145,
     /* 1865680 */     GIR_EraseRootFromParent_Done,
     /* 1865681 */   // Label 25188: @1865681
     /* 1865681 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1865770), // Rule ID 14148 //
     /* 1865686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1865697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1865700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1865706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865732 */     // MIs[0] policy
     /* 1865732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1865745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865769 */     // GIR_Coverage, 14148,
     /* 1865769 */     GIR_EraseRootFromParent_Done,
     /* 1865770 */   // Label 25189: @1865770
     /* 1865770 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1865859), // Rule ID 14149 //
     /* 1865775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1865786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1865789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1865795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865821 */     // MIs[0] policy
     /* 1865821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865831 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1865834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865858 */     // GIR_Coverage, 14149,
     /* 1865858 */     GIR_EraseRootFromParent_Done,
     /* 1865859 */   // Label 25190: @1865859
     /* 1865859 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1865948), // Rule ID 14152 //
     /* 1865864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1865875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1865878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1865884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865910 */     // MIs[0] policy
     /* 1865910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865920 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1865923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865947 */     // GIR_Coverage, 14152,
     /* 1865947 */     GIR_EraseRootFromParent_Done,
     /* 1865948 */   // Label 25191: @1865948
     /* 1865948 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1866037), // Rule ID 14153 //
     /* 1865953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1865964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1865967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1865973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1865995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865999 */     // MIs[0] policy
     /* 1865999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866009 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1866012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866036 */     // GIR_Coverage, 14153,
     /* 1866036 */     GIR_EraseRootFromParent_Done,
     /* 1866037 */   // Label 25192: @1866037
     /* 1866037 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1866126), // Rule ID 14156 //
     /* 1866042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1866053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1866056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1866059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866088 */     // MIs[0] policy
     /* 1866088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866098 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1866101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866125 */     // GIR_Coverage, 14156,
     /* 1866125 */     GIR_EraseRootFromParent_Done,
     /* 1866126 */   // Label 25193: @1866126
     /* 1866126 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1866215), // Rule ID 14157 //
     /* 1866131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1866142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1866145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1866148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1866151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866177 */     // MIs[0] policy
     /* 1866177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866187 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1866190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866214 */     // GIR_Coverage, 14157,
     /* 1866214 */     GIR_EraseRootFromParent_Done,
     /* 1866215 */   // Label 25194: @1866215
     /* 1866215 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1866304), // Rule ID 14160 //
     /* 1866220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1866231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1866234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1866237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866266 */     // MIs[0] policy
     /* 1866266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866303 */     // GIR_Coverage, 14160,
     /* 1866303 */     GIR_EraseRootFromParent_Done,
     /* 1866304 */   // Label 25195: @1866304
     /* 1866304 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1866393), // Rule ID 14161 //
     /* 1866309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1866320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1866323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1866326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1866329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866355 */     // MIs[0] policy
     /* 1866355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866365 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866392 */     // GIR_Coverage, 14161,
     /* 1866392 */     GIR_EraseRootFromParent_Done,
     /* 1866393 */   // Label 25196: @1866393
     /* 1866393 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1866482), // Rule ID 14164 //
     /* 1866398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1866409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1866412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1866415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866444 */     // MIs[0] policy
     /* 1866444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866481 */     // GIR_Coverage, 14164,
     /* 1866481 */     GIR_EraseRootFromParent_Done,
     /* 1866482 */   // Label 25197: @1866482
     /* 1866482 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1866571), // Rule ID 14165 //
     /* 1866487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1866498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1866501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1866504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1866507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866533 */     // MIs[0] policy
     /* 1866533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866543 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866570 */     // GIR_Coverage, 14165,
     /* 1866570 */     GIR_EraseRootFromParent_Done,
     /* 1866571 */   // Label 25198: @1866571
     /* 1866571 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1866660), // Rule ID 14168 //
     /* 1866576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1866587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1866590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866622 */     // MIs[0] policy
     /* 1866622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866659 */     // GIR_Coverage, 14168,
     /* 1866659 */     GIR_EraseRootFromParent_Done,
     /* 1866660 */   // Label 25199: @1866660
     /* 1866660 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1866749), // Rule ID 14169 //
     /* 1866665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1866676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1866679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1866685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866711 */     // MIs[0] policy
     /* 1866711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866721 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866748 */     // GIR_Coverage, 14169,
     /* 1866748 */     GIR_EraseRootFromParent_Done,
     /* 1866749 */   // Label 25200: @1866749
     /* 1866749 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1866838), // Rule ID 14172 //
     /* 1866754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1866757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1866771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866800 */     // MIs[0] policy
     /* 1866800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866837 */     // GIR_Coverage, 14172,
     /* 1866837 */     GIR_EraseRootFromParent_Done,
     /* 1866838 */   // Label 25201: @1866838
     /* 1866838 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1866927), // Rule ID 14173 //
     /* 1866843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1866846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1866860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1866863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866889 */     // MIs[0] policy
     /* 1866889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1866902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866926 */     // GIR_Coverage, 14173,
     /* 1866926 */     GIR_EraseRootFromParent_Done,
     /* 1866927 */   // Label 25202: @1866927
     /* 1866927 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1867016), // Rule ID 14176 //
     /* 1866932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1866943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1866946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1866949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1866952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1866974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866978 */     // MIs[0] policy
     /* 1866978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1866991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867015 */     // GIR_Coverage, 14176,
     /* 1867015 */     GIR_EraseRootFromParent_Done,
     /* 1867016 */   // Label 25203: @1867016
     /* 1867016 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1867105), // Rule ID 14177 //
     /* 1867021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1867032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1867035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1867038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867067 */     // MIs[0] policy
     /* 1867067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1867080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867104 */     // GIR_Coverage, 14177,
     /* 1867104 */     GIR_EraseRootFromParent_Done,
     /* 1867105 */   // Label 25204: @1867105
     /* 1867105 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1867194), // Rule ID 14180 //
     /* 1867110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1867121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1867124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1867127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867156 */     // MIs[0] policy
     /* 1867156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1867169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867193 */     // GIR_Coverage, 14180,
     /* 1867193 */     GIR_EraseRootFromParent_Done,
     /* 1867194 */   // Label 25205: @1867194
     /* 1867194 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1867283), // Rule ID 14181 //
     /* 1867199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1867210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1867213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1867216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867245 */     // MIs[0] policy
     /* 1867245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867255 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1867258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867282 */     // GIR_Coverage, 14181,
     /* 1867282 */     GIR_EraseRootFromParent_Done,
     /* 1867283 */   // Label 25206: @1867283
     /* 1867283 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1867372), // Rule ID 14184 //
     /* 1867288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1867299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1867302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1867305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1867311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867334 */     // MIs[0] policy
     /* 1867334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1867347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867371 */     // GIR_Coverage, 14184,
     /* 1867371 */     GIR_EraseRootFromParent_Done,
     /* 1867372 */   // Label 25207: @1867372
     /* 1867372 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1867461), // Rule ID 14185 //
     /* 1867377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1867388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1867391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1867394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1867400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867423 */     // MIs[0] policy
     /* 1867423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867433 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1867436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867454 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867460 */     // GIR_Coverage, 14185,
     /* 1867460 */     GIR_EraseRootFromParent_Done,
     /* 1867461 */   // Label 25208: @1867461
     /* 1867461 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1867550), // Rule ID 14188 //
     /* 1867466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1867483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867512 */     // MIs[0] policy
     /* 1867512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1867525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867549 */     // GIR_Coverage, 14188,
     /* 1867549 */     GIR_EraseRootFromParent_Done,
     /* 1867550 */   // Label 25209: @1867550
     /* 1867550 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1867639), // Rule ID 14189 //
     /* 1867555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1867572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867601 */     // MIs[0] policy
     /* 1867601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1867614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867638 */     // GIR_Coverage, 14189,
     /* 1867638 */     GIR_EraseRootFromParent_Done,
     /* 1867639 */   // Label 25210: @1867639
     /* 1867639 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1867728), // Rule ID 14192 //
     /* 1867644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1867661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867690 */     // MIs[0] policy
     /* 1867690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867700 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1867703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867727 */     // GIR_Coverage, 14192,
     /* 1867727 */     GIR_EraseRootFromParent_Done,
     /* 1867728 */   // Label 25211: @1867728
     /* 1867728 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1867817), // Rule ID 14193 //
     /* 1867733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1867750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867779 */     // MIs[0] policy
     /* 1867779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1867792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867816 */     // GIR_Coverage, 14193,
     /* 1867816 */     GIR_EraseRootFromParent_Done,
     /* 1867817 */   // Label 25212: @1867817
     /* 1867817 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1867906), // Rule ID 14196 //
     /* 1867822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1867833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1867836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1867839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867868 */     // MIs[0] policy
     /* 1867868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1867881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867905 */     // GIR_Coverage, 14196,
     /* 1867905 */     GIR_EraseRootFromParent_Done,
     /* 1867906 */   // Label 25213: @1867906
     /* 1867906 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1867995), // Rule ID 14197 //
     /* 1867911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1867922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1867925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1867928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867957 */     // MIs[0] policy
     /* 1867957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867967 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1867970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867994 */     // GIR_Coverage, 14197,
     /* 1867994 */     GIR_EraseRootFromParent_Done,
     /* 1867995 */   // Label 25214: @1867995
     /* 1867995 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1868084), // Rule ID 14200 //
     /* 1868000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1868011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1868014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1868017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868046 */     // MIs[0] policy
     /* 1868046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1868059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868083 */     // GIR_Coverage, 14200,
     /* 1868083 */     GIR_EraseRootFromParent_Done,
     /* 1868084 */   // Label 25215: @1868084
     /* 1868084 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1868173), // Rule ID 14201 //
     /* 1868089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1868100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1868103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1868106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868135 */     // MIs[0] policy
     /* 1868135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1868148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868172 */     // GIR_Coverage, 14201,
     /* 1868172 */     GIR_EraseRootFromParent_Done,
     /* 1868173 */   // Label 25216: @1868173
     /* 1868173 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1868262), // Rule ID 14204 //
     /* 1868178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1868189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1868192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1868195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868224 */     // MIs[0] policy
     /* 1868224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1868237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868261 */     // GIR_Coverage, 14204,
     /* 1868261 */     GIR_EraseRootFromParent_Done,
     /* 1868262 */   // Label 25217: @1868262
     /* 1868262 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1868351), // Rule ID 14205 //
     /* 1868267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1868278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1868281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1868284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868313 */     // MIs[0] policy
     /* 1868313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868323 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1868326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868350 */     // GIR_Coverage, 14205,
     /* 1868350 */     GIR_EraseRootFromParent_Done,
     /* 1868351 */   // Label 25218: @1868351
     /* 1868351 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1868440), // Rule ID 14208 //
     /* 1868356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1868367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1868370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1868373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1868379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868402 */     // MIs[0] policy
     /* 1868402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1868415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868435 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868439 */     // GIR_Coverage, 14208,
     /* 1868439 */     GIR_EraseRootFromParent_Done,
     /* 1868440 */   // Label 25219: @1868440
     /* 1868440 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1868529), // Rule ID 14209 //
     /* 1868445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1868456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1868459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1868462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1868468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868491 */     // MIs[0] policy
     /* 1868491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868501 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1868504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868528 */     // GIR_Coverage, 14209,
     /* 1868528 */     GIR_EraseRootFromParent_Done,
     /* 1868529 */   // Label 25220: @1868529
     /* 1868529 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1868618), // Rule ID 14212 //
     /* 1868534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1868545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1868548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1868551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868580 */     // MIs[0] policy
     /* 1868580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1868593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868617 */     // GIR_Coverage, 14212,
     /* 1868617 */     GIR_EraseRootFromParent_Done,
     /* 1868618 */   // Label 25221: @1868618
     /* 1868618 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1868707), // Rule ID 14213 //
     /* 1868623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1868634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1868637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1868640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868669 */     // MIs[0] policy
     /* 1868669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1868682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868706 */     // GIR_Coverage, 14213,
     /* 1868706 */     GIR_EraseRootFromParent_Done,
     /* 1868707 */   // Label 25222: @1868707
     /* 1868707 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1868796), // Rule ID 14216 //
     /* 1868712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1868723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1868726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1868729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868758 */     // MIs[0] policy
     /* 1868758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1868771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868795 */     // GIR_Coverage, 14216,
     /* 1868795 */     GIR_EraseRootFromParent_Done,
     /* 1868796 */   // Label 25223: @1868796
     /* 1868796 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1868885), // Rule ID 14217 //
     /* 1868801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1868812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1868815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1868818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868847 */     // MIs[0] policy
     /* 1868847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868857 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1868860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868884 */     // GIR_Coverage, 14217,
     /* 1868884 */     GIR_EraseRootFromParent_Done,
     /* 1868885 */   // Label 25224: @1868885
     /* 1868885 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1868974), // Rule ID 14220 //
     /* 1868890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1868901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1868904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1868907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868936 */     // MIs[0] policy
     /* 1868936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1868949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868973 */     // GIR_Coverage, 14220,
     /* 1868973 */     GIR_EraseRootFromParent_Done,
     /* 1868974 */   // Label 25225: @1868974
     /* 1868974 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1869063), // Rule ID 14221 //
     /* 1868979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1868990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1868993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1868996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869025 */     // MIs[0] policy
     /* 1869025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869035 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1869038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869062 */     // GIR_Coverage, 14221,
     /* 1869062 */     GIR_EraseRootFromParent_Done,
     /* 1869063 */   // Label 25226: @1869063
     /* 1869063 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1869152), // Rule ID 14312 //
     /* 1869068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1869079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1869082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1869085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1869088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869114 */     // MIs[0] policy
     /* 1869114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1869127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869151 */     // GIR_Coverage, 14312,
     /* 1869151 */     GIR_EraseRootFromParent_Done,
     /* 1869152 */   // Label 25227: @1869152
     /* 1869152 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1869241), // Rule ID 14313 //
     /* 1869157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1869168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1869171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1869174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1869177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869203 */     // MIs[0] policy
     /* 1869203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869213 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1869216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869240 */     // GIR_Coverage, 14313,
     /* 1869240 */     GIR_EraseRootFromParent_Done,
     /* 1869241 */   // Label 25228: @1869241
     /* 1869241 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1869330), // Rule ID 14316 //
     /* 1869246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1869257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1869260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1869263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1869266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869292 */     // MIs[0] policy
     /* 1869292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1869305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869329 */     // GIR_Coverage, 14316,
     /* 1869329 */     GIR_EraseRootFromParent_Done,
     /* 1869330 */   // Label 25229: @1869330
     /* 1869330 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1869419), // Rule ID 14317 //
     /* 1869335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1869346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1869349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1869352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1869355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869381 */     // MIs[0] policy
     /* 1869381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869391 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1869394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869418 */     // GIR_Coverage, 14317,
     /* 1869418 */     GIR_EraseRootFromParent_Done,
     /* 1869419 */   // Label 25230: @1869419
     /* 1869419 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1869508), // Rule ID 14320 //
     /* 1869424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1869435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1869438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1869441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1869444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869470 */     // MIs[0] policy
     /* 1869470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1869483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869507 */     // GIR_Coverage, 14320,
     /* 1869507 */     GIR_EraseRootFromParent_Done,
     /* 1869508 */   // Label 25231: @1869508
     /* 1869508 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1869597), // Rule ID 14321 //
     /* 1869513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1869524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1869527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1869530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1869533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869559 */     // MIs[0] policy
     /* 1869559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869569 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1869572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869596 */     // GIR_Coverage, 14321,
     /* 1869596 */     GIR_EraseRootFromParent_Done,
     /* 1869597 */   // Label 25232: @1869597
     /* 1869597 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1869686), // Rule ID 14324 //
     /* 1869602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1869613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1869616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1869619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1869622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869648 */     // MIs[0] policy
     /* 1869648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869658 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1869661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869685 */     // GIR_Coverage, 14324,
     /* 1869685 */     GIR_EraseRootFromParent_Done,
     /* 1869686 */   // Label 25233: @1869686
     /* 1869686 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1869775), // Rule ID 14325 //
     /* 1869691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1869702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1869705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1869708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1869711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869737 */     // MIs[0] policy
     /* 1869737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869747 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1869750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869768 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869774 */     // GIR_Coverage, 14325,
     /* 1869774 */     GIR_EraseRootFromParent_Done,
     /* 1869775 */   // Label 25234: @1869775
     /* 1869775 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1869864), // Rule ID 14328 //
     /* 1869780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1869791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1869794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1869797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1869800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869826 */     // MIs[0] policy
     /* 1869826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1869839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869863 */     // GIR_Coverage, 14328,
     /* 1869863 */     GIR_EraseRootFromParent_Done,
     /* 1869864 */   // Label 25235: @1869864
     /* 1869864 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1869953), // Rule ID 14329 //
     /* 1869869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1869880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1869883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1869886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1869889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869915 */     // MIs[0] policy
     /* 1869915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869925 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1869928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869946 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869952 */     // GIR_Coverage, 14329,
     /* 1869952 */     GIR_EraseRootFromParent_Done,
     /* 1869953 */   // Label 25236: @1869953
     /* 1869953 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1870042), // Rule ID 14332 //
     /* 1869958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1869969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1869972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1869975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1869978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870004 */     // MIs[0] policy
     /* 1870004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1870017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870041 */     // GIR_Coverage, 14332,
     /* 1870041 */     GIR_EraseRootFromParent_Done,
     /* 1870042 */   // Label 25237: @1870042
     /* 1870042 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1870131), // Rule ID 14333 //
     /* 1870047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1870058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1870061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1870064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1870067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870093 */     // MIs[0] policy
     /* 1870093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870103 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1870106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870130 */     // GIR_Coverage, 14333,
     /* 1870130 */     GIR_EraseRootFromParent_Done,
     /* 1870131 */   // Label 25238: @1870131
     /* 1870131 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1870220), // Rule ID 14336 //
     /* 1870136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1870147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1870150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1870153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1870156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870182 */     // MIs[0] policy
     /* 1870182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870219 */     // GIR_Coverage, 14336,
     /* 1870219 */     GIR_EraseRootFromParent_Done,
     /* 1870220 */   // Label 25239: @1870220
     /* 1870220 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1870309), // Rule ID 14337 //
     /* 1870225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1870236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1870239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1870242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1870245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870271 */     // MIs[0] policy
     /* 1870271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870281 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870308 */     // GIR_Coverage, 14337,
     /* 1870308 */     GIR_EraseRootFromParent_Done,
     /* 1870309 */   // Label 25240: @1870309
     /* 1870309 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1870398), // Rule ID 14340 //
     /* 1870314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1870325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1870328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1870331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1870334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870360 */     // MIs[0] policy
     /* 1870360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870397 */     // GIR_Coverage, 14340,
     /* 1870397 */     GIR_EraseRootFromParent_Done,
     /* 1870398 */   // Label 25241: @1870398
     /* 1870398 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1870487), // Rule ID 14341 //
     /* 1870403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1870414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1870417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1870420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1870423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870449 */     // MIs[0] policy
     /* 1870449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870459 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870486 */     // GIR_Coverage, 14341,
     /* 1870486 */     GIR_EraseRootFromParent_Done,
     /* 1870487 */   // Label 25242: @1870487
     /* 1870487 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1870576), // Rule ID 14344 //
     /* 1870492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1870503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1870506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1870509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1870512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870538 */     // MIs[0] policy
     /* 1870538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870575 */     // GIR_Coverage, 14344,
     /* 1870575 */     GIR_EraseRootFromParent_Done,
     /* 1870576 */   // Label 25243: @1870576
     /* 1870576 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1870665), // Rule ID 14345 //
     /* 1870581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1870592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1870595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1870598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1870601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870627 */     // MIs[0] policy
     /* 1870627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870637 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870664 */     // GIR_Coverage, 14345,
     /* 1870664 */     GIR_EraseRootFromParent_Done,
     /* 1870665 */   // Label 25244: @1870665
     /* 1870665 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1870754), // Rule ID 14348 //
     /* 1870670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1870690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870716 */     // MIs[0] policy
     /* 1870716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870753 */     // GIR_Coverage, 14348,
     /* 1870753 */     GIR_EraseRootFromParent_Done,
     /* 1870754 */   // Label 25245: @1870754
     /* 1870754 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1870843), // Rule ID 14349 //
     /* 1870759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1870779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870805 */     // MIs[0] policy
     /* 1870805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870815 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1870818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870842 */     // GIR_Coverage, 14349,
     /* 1870842 */     GIR_EraseRootFromParent_Done,
     /* 1870843 */   // Label 25246: @1870843
     /* 1870843 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1870932), // Rule ID 14352 //
     /* 1870848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1870859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1870862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1870865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1870868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870894 */     // MIs[0] policy
     /* 1870894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1870907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870931 */     // GIR_Coverage, 14352,
     /* 1870931 */     GIR_EraseRootFromParent_Done,
     /* 1870932 */   // Label 25247: @1870932
     /* 1870932 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1871021), // Rule ID 14353 //
     /* 1870937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1870948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1870951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1870954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1870957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870983 */     // MIs[0] policy
     /* 1870983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1870996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871020 */     // GIR_Coverage, 14353,
     /* 1871020 */     GIR_EraseRootFromParent_Done,
     /* 1871021 */   // Label 25248: @1871021
     /* 1871021 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1871110), // Rule ID 14356 //
     /* 1871026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1871037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1871040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1871043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1871046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871072 */     // MIs[0] policy
     /* 1871072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871082 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1871085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871109 */     // GIR_Coverage, 14356,
     /* 1871109 */     GIR_EraseRootFromParent_Done,
     /* 1871110 */   // Label 25249: @1871110
     /* 1871110 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1871199), // Rule ID 14357 //
     /* 1871115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1871126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1871129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1871132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1871135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871161 */     // MIs[0] policy
     /* 1871161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1871174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871198 */     // GIR_Coverage, 14357,
     /* 1871198 */     GIR_EraseRootFromParent_Done,
     /* 1871199 */   // Label 25250: @1871199
     /* 1871199 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1871288), // Rule ID 14360 //
     /* 1871204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1871215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1871218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1871221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1871224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1871227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871250 */     // MIs[0] policy
     /* 1871250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1871263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871287 */     // GIR_Coverage, 14360,
     /* 1871287 */     GIR_EraseRootFromParent_Done,
     /* 1871288 */   // Label 25251: @1871288
     /* 1871288 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1871377), // Rule ID 14361 //
     /* 1871293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1871304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1871307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1871310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1871313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1871316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871339 */     // MIs[0] policy
     /* 1871339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871349 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1871352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871376 */     // GIR_Coverage, 14361,
     /* 1871376 */     GIR_EraseRootFromParent_Done,
     /* 1871377 */   // Label 25252: @1871377
     /* 1871377 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1871466), // Rule ID 14364 //
     /* 1871382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1871393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1871396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1871399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1871402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871428 */     // MIs[0] policy
     /* 1871428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1871441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871465 */     // GIR_Coverage, 14364,
     /* 1871465 */     GIR_EraseRootFromParent_Done,
     /* 1871466 */   // Label 25253: @1871466
     /* 1871466 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1871555), // Rule ID 14365 //
     /* 1871471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1871482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1871485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1871488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1871491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871517 */     // MIs[0] policy
     /* 1871517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871527 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1871530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871554 */     // GIR_Coverage, 14365,
     /* 1871554 */     GIR_EraseRootFromParent_Done,
     /* 1871555 */   // Label 25254: @1871555
     /* 1871555 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1871644), // Rule ID 14368 //
     /* 1871560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1871571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1871574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1871577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1871580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871606 */     // MIs[0] policy
     /* 1871606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1871619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871643 */     // GIR_Coverage, 14368,
     /* 1871643 */     GIR_EraseRootFromParent_Done,
     /* 1871644 */   // Label 25255: @1871644
     /* 1871644 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1871733), // Rule ID 14369 //
     /* 1871649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1871660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1871663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1871666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1871669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871695 */     // MIs[0] policy
     /* 1871695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871705 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1871708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871732 */     // GIR_Coverage, 14369,
     /* 1871732 */     GIR_EraseRootFromParent_Done,
     /* 1871733 */   // Label 25256: @1871733
     /* 1871733 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1871822), // Rule ID 14372 //
     /* 1871738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1871749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1871752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1871755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1871758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871784 */     // MIs[0] policy
     /* 1871784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1871797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871821 */     // GIR_Coverage, 14372,
     /* 1871821 */     GIR_EraseRootFromParent_Done,
     /* 1871822 */   // Label 25257: @1871822
     /* 1871822 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1871911), // Rule ID 14373 //
     /* 1871827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1871838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1871841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1871844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1871847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871873 */     // MIs[0] policy
     /* 1871873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871883 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1871886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871910 */     // GIR_Coverage, 14373,
     /* 1871910 */     GIR_EraseRootFromParent_Done,
     /* 1871911 */   // Label 25258: @1871911
     /* 1871911 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1872000), // Rule ID 14376 //
     /* 1871916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1871927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1871930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1871933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1871936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871962 */     // MIs[0] policy
     /* 1871962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1871975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871999 */     // GIR_Coverage, 14376,
     /* 1871999 */     GIR_EraseRootFromParent_Done,
     /* 1872000 */   // Label 25259: @1872000
     /* 1872000 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1872089), // Rule ID 14377 //
     /* 1872005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1872016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1872019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1872022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1872025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872051 */     // MIs[0] policy
     /* 1872051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1872064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872088 */     // GIR_Coverage, 14377,
     /* 1872088 */     GIR_EraseRootFromParent_Done,
     /* 1872089 */   // Label 25260: @1872089
     /* 1872089 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1872178), // Rule ID 14380 //
     /* 1872094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1872105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1872108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1872111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1872114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872140 */     // MIs[0] policy
     /* 1872140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1872153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872177 */     // GIR_Coverage, 14380,
     /* 1872177 */     GIR_EraseRootFromParent_Done,
     /* 1872178 */   // Label 25261: @1872178
     /* 1872178 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1872267), // Rule ID 14381 //
     /* 1872183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1872194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1872197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1872200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1872203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872229 */     // MIs[0] policy
     /* 1872229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872239 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1872242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872260 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872266 */     // GIR_Coverage, 14381,
     /* 1872266 */     GIR_EraseRootFromParent_Done,
     /* 1872267 */   // Label 25262: @1872267
     /* 1872267 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1872356), // Rule ID 14384 //
     /* 1872272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1872283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1872286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1872289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1872292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1872295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872318 */     // MIs[0] policy
     /* 1872318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1872331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872355 */     // GIR_Coverage, 14384,
     /* 1872355 */     GIR_EraseRootFromParent_Done,
     /* 1872356 */   // Label 25263: @1872356
     /* 1872356 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1872445), // Rule ID 14385 //
     /* 1872361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1872372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1872375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1872378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1872381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1872384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872407 */     // MIs[0] policy
     /* 1872407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872417 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1872420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872444 */     // GIR_Coverage, 14385,
     /* 1872444 */     GIR_EraseRootFromParent_Done,
     /* 1872445 */   // Label 25264: @1872445
     /* 1872445 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1872534), // Rule ID 14388 //
     /* 1872450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1872461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1872464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1872467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1872470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872496 */     // MIs[0] policy
     /* 1872496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1872509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872533 */     // GIR_Coverage, 14388,
     /* 1872533 */     GIR_EraseRootFromParent_Done,
     /* 1872534 */   // Label 25265: @1872534
     /* 1872534 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1872623), // Rule ID 14389 //
     /* 1872539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1872550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1872553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1872556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1872559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872585 */     // MIs[0] policy
     /* 1872585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872595 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1872598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872622 */     // GIR_Coverage, 14389,
     /* 1872622 */     GIR_EraseRootFromParent_Done,
     /* 1872623 */   // Label 25266: @1872623
     /* 1872623 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1872712), // Rule ID 14392 //
     /* 1872628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1872648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872674 */     // MIs[0] policy
     /* 1872674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1872687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872711 */     // GIR_Coverage, 14392,
     /* 1872711 */     GIR_EraseRootFromParent_Done,
     /* 1872712 */   // Label 25267: @1872712
     /* 1872712 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1872801), // Rule ID 14393 //
     /* 1872717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1872737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872763 */     // MIs[0] policy
     /* 1872763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872773 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1872776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872800 */     // GIR_Coverage, 14393,
     /* 1872800 */     GIR_EraseRootFromParent_Done,
     /* 1872801 */   // Label 25268: @1872801
     /* 1872801 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1872890), // Rule ID 14396 //
     /* 1872806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1872826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872852 */     // MIs[0] policy
     /* 1872852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1872865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872889 */     // GIR_Coverage, 14396,
     /* 1872889 */     GIR_EraseRootFromParent_Done,
     /* 1872890 */   // Label 25269: @1872890
     /* 1872890 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1872979), // Rule ID 14397 //
     /* 1872895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1872915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872941 */     // MIs[0] policy
     /* 1872941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872951 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1872954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872978 */     // GIR_Coverage, 14397,
     /* 1872978 */     GIR_EraseRootFromParent_Done,
     /* 1872979 */   // Label 25270: @1872979
     /* 1872979 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1873068), // Rule ID 14400 //
     /* 1872984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1872995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1872998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1873001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873030 */     // MIs[0] policy
     /* 1873030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873040 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1873043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873067 */     // GIR_Coverage, 14400,
     /* 1873067 */     GIR_EraseRootFromParent_Done,
     /* 1873068 */   // Label 25271: @1873068
     /* 1873068 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1873157), // Rule ID 14401 //
     /* 1873073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1873084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1873087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1873090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873119 */     // MIs[0] policy
     /* 1873119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873129 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1873132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873156 */     // GIR_Coverage, 14401,
     /* 1873156 */     GIR_EraseRootFromParent_Done,
     /* 1873157 */   // Label 25272: @1873157
     /* 1873157 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1873246), // Rule ID 14404 //
     /* 1873162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1873173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1873176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1873179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873208 */     // MIs[0] policy
     /* 1873208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1873221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873245 */     // GIR_Coverage, 14404,
     /* 1873245 */     GIR_EraseRootFromParent_Done,
     /* 1873246 */   // Label 25273: @1873246
     /* 1873246 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1873335), // Rule ID 14405 //
     /* 1873251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1873262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1873265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1873268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873297 */     // MIs[0] policy
     /* 1873297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873307 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1873310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873334 */     // GIR_Coverage, 14405,
     /* 1873334 */     GIR_EraseRootFromParent_Done,
     /* 1873335 */   // Label 25274: @1873335
     /* 1873335 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1873424), // Rule ID 14408 //
     /* 1873340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1873351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1873354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1873357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873386 */     // MIs[0] policy
     /* 1873386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1873399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873423 */     // GIR_Coverage, 14408,
     /* 1873423 */     GIR_EraseRootFromParent_Done,
     /* 1873424 */   // Label 25275: @1873424
     /* 1873424 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1873513), // Rule ID 14409 //
     /* 1873429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1873440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1873443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1873446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873475 */     // MIs[0] policy
     /* 1873475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873485 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1873488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873512 */     // GIR_Coverage, 14409,
     /* 1873512 */     GIR_EraseRootFromParent_Done,
     /* 1873513 */   // Label 25276: @1873513
     /* 1873513 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1873602), // Rule ID 14412 //
     /* 1873518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1873529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1873532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1873535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873564 */     // MIs[0] policy
     /* 1873564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1873577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873601 */     // GIR_Coverage, 14412,
     /* 1873601 */     GIR_EraseRootFromParent_Done,
     /* 1873602 */   // Label 25277: @1873602
     /* 1873602 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1873691), // Rule ID 14413 //
     /* 1873607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1873618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1873621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1873624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873653 */     // MIs[0] policy
     /* 1873653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873663 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1873666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873690 */     // GIR_Coverage, 14413,
     /* 1873690 */     GIR_EraseRootFromParent_Done,
     /* 1873691 */   // Label 25278: @1873691
     /* 1873691 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1873780), // Rule ID 14416 //
     /* 1873696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873742 */     // MIs[0] policy
     /* 1873742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1873755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873779 */     // GIR_Coverage, 14416,
     /* 1873779 */     GIR_EraseRootFromParent_Done,
     /* 1873780 */   // Label 25279: @1873780
     /* 1873780 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1873869), // Rule ID 14417 //
     /* 1873785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873831 */     // MIs[0] policy
     /* 1873831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873841 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1873844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873868 */     // GIR_Coverage, 14417,
     /* 1873868 */     GIR_EraseRootFromParent_Done,
     /* 1873869 */   // Label 25280: @1873869
     /* 1873869 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1873958), // Rule ID 14420 //
     /* 1873874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1873894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1873916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873920 */     // MIs[0] policy
     /* 1873920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1873933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873957 */     // GIR_Coverage, 14420,
     /* 1873957 */     GIR_EraseRootFromParent_Done,
     /* 1873958 */   // Label 25281: @1873958
     /* 1873958 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1874047), // Rule ID 14421 //
     /* 1873963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1873983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874009 */     // MIs[0] policy
     /* 1874009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1874022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874046 */     // GIR_Coverage, 14421,
     /* 1874046 */     GIR_EraseRootFromParent_Done,
     /* 1874047 */   // Label 25282: @1874047
     /* 1874047 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1874136), // Rule ID 14424 //
     /* 1874052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1874063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1874066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1874069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874098 */     // MIs[0] policy
     /* 1874098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874108 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874135 */     // GIR_Coverage, 14424,
     /* 1874135 */     GIR_EraseRootFromParent_Done,
     /* 1874136 */   // Label 25283: @1874136
     /* 1874136 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1874225), // Rule ID 14425 //
     /* 1874141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1874152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1874155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1874158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874187 */     // MIs[0] policy
     /* 1874187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874197 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874224 */     // GIR_Coverage, 14425,
     /* 1874224 */     GIR_EraseRootFromParent_Done,
     /* 1874225 */   // Label 25284: @1874225
     /* 1874225 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1874314), // Rule ID 14428 //
     /* 1874230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1874241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1874244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1874247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874276 */     // MIs[0] policy
     /* 1874276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874286 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874313 */     // GIR_Coverage, 14428,
     /* 1874313 */     GIR_EraseRootFromParent_Done,
     /* 1874314 */   // Label 25285: @1874314
     /* 1874314 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1874403), // Rule ID 14429 //
     /* 1874319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1874330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1874333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1874336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874365 */     // MIs[0] policy
     /* 1874365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874402 */     // GIR_Coverage, 14429,
     /* 1874402 */     GIR_EraseRootFromParent_Done,
     /* 1874403 */   // Label 25286: @1874403
     /* 1874403 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1874492), // Rule ID 14432 //
     /* 1874408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1874419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1874422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1874425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874454 */     // MIs[0] policy
     /* 1874454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874491 */     // GIR_Coverage, 14432,
     /* 1874491 */     GIR_EraseRootFromParent_Done,
     /* 1874492 */   // Label 25287: @1874492
     /* 1874492 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1874581), // Rule ID 14433 //
     /* 1874497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1874508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1874511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1874514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874543 */     // MIs[0] policy
     /* 1874543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874553 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874574 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874580 */     // GIR_Coverage, 14433,
     /* 1874580 */     GIR_EraseRootFromParent_Done,
     /* 1874581 */   // Label 25288: @1874581
     /* 1874581 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1874670), // Rule ID 14436 //
     /* 1874586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1874597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1874600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1874603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1874609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874632 */     // MIs[0] policy
     /* 1874632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874669 */     // GIR_Coverage, 14436,
     /* 1874669 */     GIR_EraseRootFromParent_Done,
     /* 1874670 */   // Label 25289: @1874670
     /* 1874670 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1874759), // Rule ID 14437 //
     /* 1874675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1874686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1874689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1874692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1874698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874721 */     // MIs[0] policy
     /* 1874721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874731 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1874734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874758 */     // GIR_Coverage, 14437,
     /* 1874758 */     GIR_EraseRootFromParent_Done,
     /* 1874759 */   // Label 25290: @1874759
     /* 1874759 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1874848), // Rule ID 14440 //
     /* 1874764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874810 */     // MIs[0] policy
     /* 1874810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874820 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1874823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874847 */     // GIR_Coverage, 14440,
     /* 1874847 */     GIR_EraseRootFromParent_Done,
     /* 1874848 */   // Label 25291: @1874848
     /* 1874848 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1874937), // Rule ID 14441 //
     /* 1874853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1874873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874899 */     // MIs[0] policy
     /* 1874899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874909 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1874912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874936 */     // GIR_Coverage, 14441,
     /* 1874936 */     GIR_EraseRootFromParent_Done,
     /* 1874937 */   // Label 25292: @1874937
     /* 1874937 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1875026), // Rule ID 14444 //
     /* 1874942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1874953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1874956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1874959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1874962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1874984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874988 */     // MIs[0] policy
     /* 1874988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874998 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1875001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875025 */     // GIR_Coverage, 14444,
     /* 1875025 */     GIR_EraseRootFromParent_Done,
     /* 1875026 */   // Label 25293: @1875026
     /* 1875026 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1875115), // Rule ID 14445 //
     /* 1875031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1875042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1875045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1875048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875077 */     // MIs[0] policy
     /* 1875077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875087 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1875090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875114 */     // GIR_Coverage, 14445,
     /* 1875114 */     GIR_EraseRootFromParent_Done,
     /* 1875115 */   // Label 25294: @1875115
     /* 1875115 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1875204), // Rule ID 14448 //
     /* 1875120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1875131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1875134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1875137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1875143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875166 */     // MIs[0] policy
     /* 1875166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1875179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875203 */     // GIR_Coverage, 14448,
     /* 1875203 */     GIR_EraseRootFromParent_Done,
     /* 1875204 */   // Label 25295: @1875204
     /* 1875204 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1875293), // Rule ID 14449 //
     /* 1875209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1875220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1875223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1875226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1875232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875255 */     // MIs[0] policy
     /* 1875255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875265 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1875268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875292 */     // GIR_Coverage, 14449,
     /* 1875292 */     GIR_EraseRootFromParent_Done,
     /* 1875293 */   // Label 25296: @1875293
     /* 1875293 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1875382), // Rule ID 14452 //
     /* 1875298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1875309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1875312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1875315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875344 */     // MIs[0] policy
     /* 1875344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875354 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1875357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875381 */     // GIR_Coverage, 14452,
     /* 1875381 */     GIR_EraseRootFromParent_Done,
     /* 1875382 */   // Label 25297: @1875382
     /* 1875382 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1875471), // Rule ID 14453 //
     /* 1875387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1875398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1875401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1875404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875433 */     // MIs[0] policy
     /* 1875433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1875446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875470 */     // GIR_Coverage, 14453,
     /* 1875470 */     GIR_EraseRootFromParent_Done,
     /* 1875471 */   // Label 25298: @1875471
     /* 1875471 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1875560), // Rule ID 14456 //
     /* 1875476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1875487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1875490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1875493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875522 */     // MIs[0] policy
     /* 1875522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875532 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1875535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875559 */     // GIR_Coverage, 14456,
     /* 1875559 */     GIR_EraseRootFromParent_Done,
     /* 1875560 */   // Label 25299: @1875560
     /* 1875560 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1875649), // Rule ID 14457 //
     /* 1875565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1875576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1875579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1875582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875611 */     // MIs[0] policy
     /* 1875611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1875624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875648 */     // GIR_Coverage, 14457,
     /* 1875648 */     GIR_EraseRootFromParent_Done,
     /* 1875649 */   // Label 25300: @1875649
     /* 1875649 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1875738), // Rule ID 14460 //
     /* 1875654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875700 */     // MIs[0] policy
     /* 1875700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875710 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1875713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875737 */     // GIR_Coverage, 14460,
     /* 1875737 */     GIR_EraseRootFromParent_Done,
     /* 1875738 */   // Label 25301: @1875738
     /* 1875738 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1875827), // Rule ID 14461 //
     /* 1875743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875789 */     // MIs[0] policy
     /* 1875789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1875802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875826 */     // GIR_Coverage, 14461,
     /* 1875826 */     GIR_EraseRootFromParent_Done,
     /* 1875827 */   // Label 25302: @1875827
     /* 1875827 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1875916), // Rule ID 14464 //
     /* 1875832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875878 */     // MIs[0] policy
     /* 1875878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1875891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875915 */     // GIR_Coverage, 14464,
     /* 1875915 */     GIR_EraseRootFromParent_Done,
     /* 1875916 */   // Label 25303: @1875916
     /* 1875916 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1876005), // Rule ID 14465 //
     /* 1875921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875967 */     // MIs[0] policy
     /* 1875967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1875980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876004 */     // GIR_Coverage, 14465,
     /* 1876004 */     GIR_EraseRootFromParent_Done,
     /* 1876005 */   // Label 25304: @1876005
     /* 1876005 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1876094), // Rule ID 14468 //
     /* 1876010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1876021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1876024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1876027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876056 */     // MIs[0] policy
     /* 1876056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1876069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876093 */     // GIR_Coverage, 14468,
     /* 1876093 */     GIR_EraseRootFromParent_Done,
     /* 1876094 */   // Label 25305: @1876094
     /* 1876094 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1876183), // Rule ID 14469 //
     /* 1876099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1876110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1876113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1876116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876145 */     // MIs[0] policy
     /* 1876145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876155 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1876158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876182 */     // GIR_Coverage, 14469,
     /* 1876182 */     GIR_EraseRootFromParent_Done,
     /* 1876183 */   // Label 25306: @1876183
     /* 1876183 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1876272), // Rule ID 14472 //
     /* 1876188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1876199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1876202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1876205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1876211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876234 */     // MIs[0] policy
     /* 1876234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1876247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876271 */     // GIR_Coverage, 14472,
     /* 1876271 */     GIR_EraseRootFromParent_Done,
     /* 1876272 */   // Label 25307: @1876272
     /* 1876272 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1876361), // Rule ID 14473 //
     /* 1876277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1876288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1876291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1876294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1876300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876323 */     // MIs[0] policy
     /* 1876323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876333 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1876336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876360 */     // GIR_Coverage, 14473,
     /* 1876360 */     GIR_EraseRootFromParent_Done,
     /* 1876361 */   // Label 25308: @1876361
     /* 1876361 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1876450), // Rule ID 14476 //
     /* 1876366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1876377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1876380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1876383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1876396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876412 */     // MIs[0] policy
     /* 1876412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1876425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876449 */     // GIR_Coverage, 14476,
     /* 1876449 */     GIR_EraseRootFromParent_Done,
     /* 1876450 */   // Label 25309: @1876450
     /* 1876450 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1876539), // Rule ID 14477 //
     /* 1876455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1876466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1876469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1876472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1876485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876501 */     // MIs[0] policy
     /* 1876501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1876514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876538 */     // GIR_Coverage, 14477,
     /* 1876538 */     GIR_EraseRootFromParent_Done,
     /* 1876539 */   // Label 25310: @1876539
     /* 1876539 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1876628), // Rule ID 14480 //
     /* 1876544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1876555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1876558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1876561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876590 */     // MIs[0] policy
     /* 1876590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1876603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876627 */     // GIR_Coverage, 14480,
     /* 1876627 */     GIR_EraseRootFromParent_Done,
     /* 1876628 */   // Label 25311: @1876628
     /* 1876628 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1876717), // Rule ID 14481 //
     /* 1876633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1876644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1876647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1876650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876679 */     // MIs[0] policy
     /* 1876679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876689 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1876692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876716 */     // GIR_Coverage, 14481,
     /* 1876716 */     GIR_EraseRootFromParent_Done,
     /* 1876717 */   // Label 25312: @1876717
     /* 1876717 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1876806), // Rule ID 14484 //
     /* 1876722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876768 */     // MIs[0] policy
     /* 1876768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1876781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876805 */     // GIR_Coverage, 14484,
     /* 1876805 */     GIR_EraseRootFromParent_Done,
     /* 1876806 */   // Label 25313: @1876806
     /* 1876806 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1876895), // Rule ID 14485 //
     /* 1876811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876857 */     // MIs[0] policy
     /* 1876857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876867 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1876870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876894 */     // GIR_Coverage, 14485,
     /* 1876894 */     GIR_EraseRootFromParent_Done,
     /* 1876895 */   // Label 25314: @1876895
     /* 1876895 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1876984), // Rule ID 14576 //
     /* 1876900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1876911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1876914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1876917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1876920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876946 */     // MIs[0] policy
     /* 1876946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1876959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876983 */     // GIR_Coverage, 14576,
     /* 1876983 */     GIR_EraseRootFromParent_Done,
     /* 1876984 */   // Label 25315: @1876984
     /* 1876984 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1877073), // Rule ID 14577 //
     /* 1876989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1877000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1877003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1877006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1877009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877035 */     // MIs[0] policy
     /* 1877035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877045 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1877048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877066 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877072 */     // GIR_Coverage, 14577,
     /* 1877072 */     GIR_EraseRootFromParent_Done,
     /* 1877073 */   // Label 25316: @1877073
     /* 1877073 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1877162), // Rule ID 14580 //
     /* 1877078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1877089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1877092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1877095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1877098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877124 */     // MIs[0] policy
     /* 1877124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1877137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877161 */     // GIR_Coverage, 14580,
     /* 1877161 */     GIR_EraseRootFromParent_Done,
     /* 1877162 */   // Label 25317: @1877162
     /* 1877162 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1877251), // Rule ID 14581 //
     /* 1877167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1877178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1877181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1877184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1877187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877213 */     // MIs[0] policy
     /* 1877213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877223 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1877226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877244 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877250 */     // GIR_Coverage, 14581,
     /* 1877250 */     GIR_EraseRootFromParent_Done,
     /* 1877251 */   // Label 25318: @1877251
     /* 1877251 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1877340), // Rule ID 14584 //
     /* 1877256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1877267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1877270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1877273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1877276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877302 */     // MIs[0] policy
     /* 1877302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877312 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877339 */     // GIR_Coverage, 14584,
     /* 1877339 */     GIR_EraseRootFromParent_Done,
     /* 1877340 */   // Label 25319: @1877340
     /* 1877340 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1877429), // Rule ID 14585 //
     /* 1877345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1877356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1877359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1877362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1877365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877391 */     // MIs[0] policy
     /* 1877391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877401 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877428 */     // GIR_Coverage, 14585,
     /* 1877428 */     GIR_EraseRootFromParent_Done,
     /* 1877429 */   // Label 25320: @1877429
     /* 1877429 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1877518), // Rule ID 14588 //
     /* 1877434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1877445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1877448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1877451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1877454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877480 */     // MIs[0] policy
     /* 1877480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1877493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877517 */     // GIR_Coverage, 14588,
     /* 1877517 */     GIR_EraseRootFromParent_Done,
     /* 1877518 */   // Label 25321: @1877518
     /* 1877518 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1877607), // Rule ID 14589 //
     /* 1877523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1877534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1877537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1877540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1877543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877569 */     // MIs[0] policy
     /* 1877569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1877582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877606 */     // GIR_Coverage, 14589,
     /* 1877606 */     GIR_EraseRootFromParent_Done,
     /* 1877607 */   // Label 25322: @1877607
     /* 1877607 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1877696), // Rule ID 14592 //
     /* 1877612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1877623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1877626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1877629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1877632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877658 */     // MIs[0] policy
     /* 1877658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877695 */     // GIR_Coverage, 14592,
     /* 1877695 */     GIR_EraseRootFromParent_Done,
     /* 1877696 */   // Label 25323: @1877696
     /* 1877696 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1877785), // Rule ID 14593 //
     /* 1877701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1877712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1877715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1877718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1877721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877747 */     // MIs[0] policy
     /* 1877747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877757 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877784 */     // GIR_Coverage, 14593,
     /* 1877784 */     GIR_EraseRootFromParent_Done,
     /* 1877785 */   // Label 25324: @1877785
     /* 1877785 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1877874), // Rule ID 14596 //
     /* 1877790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1877810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877836 */     // MIs[0] policy
     /* 1877836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877873 */     // GIR_Coverage, 14596,
     /* 1877873 */     GIR_EraseRootFromParent_Done,
     /* 1877874 */   // Label 25325: @1877874
     /* 1877874 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1877963), // Rule ID 14597 //
     /* 1877879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1877899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877925 */     // MIs[0] policy
     /* 1877925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877935 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1877938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877962 */     // GIR_Coverage, 14597,
     /* 1877962 */     GIR_EraseRootFromParent_Done,
     /* 1877963 */   // Label 25326: @1877963
     /* 1877963 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1878052), // Rule ID 14600 //
     /* 1877968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1877979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1877982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1877985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1877988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878014 */     // MIs[0] policy
     /* 1878014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878051 */     // GIR_Coverage, 14600,
     /* 1878051 */     GIR_EraseRootFromParent_Done,
     /* 1878052 */   // Label 25327: @1878052
     /* 1878052 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1878141), // Rule ID 14601 //
     /* 1878057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1878068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1878071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1878074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1878077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878103 */     // MIs[0] policy
     /* 1878103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878113 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878140 */     // GIR_Coverage, 14601,
     /* 1878140 */     GIR_EraseRootFromParent_Done,
     /* 1878141 */   // Label 25328: @1878141
     /* 1878141 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1878230), // Rule ID 14604 //
     /* 1878146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1878157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1878160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1878163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1878166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878192 */     // MIs[0] policy
     /* 1878192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878229 */     // GIR_Coverage, 14604,
     /* 1878229 */     GIR_EraseRootFromParent_Done,
     /* 1878230 */   // Label 25329: @1878230
     /* 1878230 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1878319), // Rule ID 14605 //
     /* 1878235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1878246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1878249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1878252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1878255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878281 */     // MIs[0] policy
     /* 1878281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878318 */     // GIR_Coverage, 14605,
     /* 1878318 */     GIR_EraseRootFromParent_Done,
     /* 1878319 */   // Label 25330: @1878319
     /* 1878319 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1878408), // Rule ID 14608 //
     /* 1878324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1878335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1878338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1878341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1878344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878370 */     // MIs[0] policy
     /* 1878370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878407 */     // GIR_Coverage, 14608,
     /* 1878407 */     GIR_EraseRootFromParent_Done,
     /* 1878408 */   // Label 25331: @1878408
     /* 1878408 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1878497), // Rule ID 14609 //
     /* 1878413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1878424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1878427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1878430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1878433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878459 */     // MIs[0] policy
     /* 1878459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878469 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878496 */     // GIR_Coverage, 14609,
     /* 1878496 */     GIR_EraseRootFromParent_Done,
     /* 1878497 */   // Label 25332: @1878497
     /* 1878497 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1878586), // Rule ID 14612 //
     /* 1878502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1878513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1878516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1878519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1878522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1878525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878548 */     // MIs[0] policy
     /* 1878548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878585 */     // GIR_Coverage, 14612,
     /* 1878585 */     GIR_EraseRootFromParent_Done,
     /* 1878586 */   // Label 25333: @1878586
     /* 1878586 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1878675), // Rule ID 14613 //
     /* 1878591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1878602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1878605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1878608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1878611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1878614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878637 */     // MIs[0] policy
     /* 1878637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878647 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1878650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878674 */     // GIR_Coverage, 14613,
     /* 1878674 */     GIR_EraseRootFromParent_Done,
     /* 1878675 */   // Label 25334: @1878675
     /* 1878675 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1878764), // Rule ID 14616 //
     /* 1878680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1878691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1878694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1878697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1878700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878726 */     // MIs[0] policy
     /* 1878726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1878739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878763 */     // GIR_Coverage, 14616,
     /* 1878763 */     GIR_EraseRootFromParent_Done,
     /* 1878764 */   // Label 25335: @1878764
     /* 1878764 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1878853), // Rule ID 14617 //
     /* 1878769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1878780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1878783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1878786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1878789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878815 */     // MIs[0] policy
     /* 1878815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1878828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878852 */     // GIR_Coverage, 14617,
     /* 1878852 */     GIR_EraseRootFromParent_Done,
     /* 1878853 */   // Label 25336: @1878853
     /* 1878853 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1878942), // Rule ID 14620 //
     /* 1878858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1878878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878904 */     // MIs[0] policy
     /* 1878904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1878917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878941 */     // GIR_Coverage, 14620,
     /* 1878941 */     GIR_EraseRootFromParent_Done,
     /* 1878942 */   // Label 25337: @1878942
     /* 1878942 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1879031), // Rule ID 14621 //
     /* 1878947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1878967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878993 */     // MIs[0] policy
     /* 1878993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879003 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1879006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879030 */     // GIR_Coverage, 14621,
     /* 1879030 */     GIR_EraseRootFromParent_Done,
     /* 1879031 */   // Label 25338: @1879031
     /* 1879031 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1879120), // Rule ID 14624 //
     /* 1879036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1879047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1879050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1879053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1879056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1879059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879082 */     // MIs[0] policy
     /* 1879082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1879095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879119 */     // GIR_Coverage, 14624,
     /* 1879119 */     GIR_EraseRootFromParent_Done,
     /* 1879120 */   // Label 25339: @1879120
     /* 1879120 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1879209), // Rule ID 14625 //
     /* 1879125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1879136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1879139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1879142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1879145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1879148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879171 */     // MIs[0] policy
     /* 1879171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879181 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1879184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879208 */     // GIR_Coverage, 14625,
     /* 1879208 */     GIR_EraseRootFromParent_Done,
     /* 1879209 */   // Label 25340: @1879209
     /* 1879209 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1879298), // Rule ID 14628 //
     /* 1879214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1879225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1879228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1879231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1879234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879260 */     // MIs[0] policy
     /* 1879260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1879273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879297 */     // GIR_Coverage, 14628,
     /* 1879297 */     GIR_EraseRootFromParent_Done,
     /* 1879298 */   // Label 25341: @1879298
     /* 1879298 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1879387), // Rule ID 14629 //
     /* 1879303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1879314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1879317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1879320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1879323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879349 */     // MIs[0] policy
     /* 1879349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1879362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879380 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879386 */     // GIR_Coverage, 14629,
     /* 1879386 */     GIR_EraseRootFromParent_Done,
     /* 1879387 */   // Label 25342: @1879387
     /* 1879387 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1879476), // Rule ID 14632 //
     /* 1879392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1879403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1879406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1879409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1879412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879438 */     // MIs[0] policy
     /* 1879438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879448 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1879451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879475 */     // GIR_Coverage, 14632,
     /* 1879475 */     GIR_EraseRootFromParent_Done,
     /* 1879476 */   // Label 25343: @1879476
     /* 1879476 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1879565), // Rule ID 14633 //
     /* 1879481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1879492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1879495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1879498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1879501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879527 */     // MIs[0] policy
     /* 1879527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1879540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879558 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879564 */     // GIR_Coverage, 14633,
     /* 1879564 */     GIR_EraseRootFromParent_Done,
     /* 1879565 */   // Label 25344: @1879565
     /* 1879565 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1879654), // Rule ID 14636 //
     /* 1879570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1879581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1879584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1879587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1879590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1879593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879616 */     // MIs[0] policy
     /* 1879616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1879629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879653 */     // GIR_Coverage, 14636,
     /* 1879653 */     GIR_EraseRootFromParent_Done,
     /* 1879654 */   // Label 25345: @1879654
     /* 1879654 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1879743), // Rule ID 14637 //
     /* 1879659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1879670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1879673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1879676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1879679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1879682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879705 */     // MIs[0] policy
     /* 1879705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879715 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1879718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879742 */     // GIR_Coverage, 14637,
     /* 1879742 */     GIR_EraseRootFromParent_Done,
     /* 1879743 */   // Label 25346: @1879743
     /* 1879743 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1879832), // Rule ID 14640 //
     /* 1879748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1879759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1879762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1879765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1879768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879794 */     // MIs[0] policy
     /* 1879794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1879807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879831 */     // GIR_Coverage, 14640,
     /* 1879831 */     GIR_EraseRootFromParent_Done,
     /* 1879832 */   // Label 25347: @1879832
     /* 1879832 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1879921), // Rule ID 14641 //
     /* 1879837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1879848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1879851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1879854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1879857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879883 */     // MIs[0] policy
     /* 1879883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1879896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879920 */     // GIR_Coverage, 14641,
     /* 1879920 */     GIR_EraseRootFromParent_Done,
     /* 1879921 */   // Label 25348: @1879921
     /* 1879921 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1880010), // Rule ID 14644 //
     /* 1879926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1879937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1879940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1879943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1879946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879972 */     // MIs[0] policy
     /* 1879972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1879985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880009 */     // GIR_Coverage, 14644,
     /* 1880009 */     GIR_EraseRootFromParent_Done,
     /* 1880010 */   // Label 25349: @1880010
     /* 1880010 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1880099), // Rule ID 14645 //
     /* 1880015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1880026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1880029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1880032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1880035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1880045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880061 */     // MIs[0] policy
     /* 1880061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880071 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1880074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880098 */     // GIR_Coverage, 14645,
     /* 1880098 */     GIR_EraseRootFromParent_Done,
     /* 1880099 */   // Label 25350: @1880099
     /* 1880099 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1880188), // Rule ID 14648 //
     /* 1880104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1880115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1880118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1880121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1880124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880150 */     // MIs[0] policy
     /* 1880150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1880163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880187 */     // GIR_Coverage, 14648,
     /* 1880187 */     GIR_EraseRootFromParent_Done,
     /* 1880188 */   // Label 25351: @1880188
     /* 1880188 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1880277), // Rule ID 14649 //
     /* 1880193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1880204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1880207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1880210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1880213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880239 */     // MIs[0] policy
     /* 1880239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1880252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880276 */     // GIR_Coverage, 14649,
     /* 1880276 */     GIR_EraseRootFromParent_Done,
     /* 1880277 */   // Label 25352: @1880277
     /* 1880277 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1880366), // Rule ID 14652 //
     /* 1880282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1880293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1880296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1880299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1880302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880328 */     // MIs[0] policy
     /* 1880328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1880341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880365 */     // GIR_Coverage, 14652,
     /* 1880365 */     GIR_EraseRootFromParent_Done,
     /* 1880366 */   // Label 25353: @1880366
     /* 1880366 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1880455), // Rule ID 14653 //
     /* 1880371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1880382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1880385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1880388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1880391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880417 */     // MIs[0] policy
     /* 1880417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1880430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880454 */     // GIR_Coverage, 14653,
     /* 1880454 */     GIR_EraseRootFromParent_Done,
     /* 1880455 */   // Label 25354: @1880455
     /* 1880455 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1880544), // Rule ID 14656 //
     /* 1880460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1880471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1880474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1880477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1880480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1880490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880506 */     // MIs[0] policy
     /* 1880506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1880519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880543 */     // GIR_Coverage, 14656,
     /* 1880543 */     GIR_EraseRootFromParent_Done,
     /* 1880544 */   // Label 25355: @1880544
     /* 1880544 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1880633), // Rule ID 14657 //
     /* 1880549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1880560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1880563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1880566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1880569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1880579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880595 */     // MIs[0] policy
     /* 1880595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880605 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1880608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880632 */     // GIR_Coverage, 14657,
     /* 1880632 */     GIR_EraseRootFromParent_Done,
     /* 1880633 */   // Label 25356: @1880633
     /* 1880633 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1880722), // Rule ID 14660 //
     /* 1880638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1880649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1880652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1880655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1880658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880684 */     // MIs[0] policy
     /* 1880684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1880697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880721 */     // GIR_Coverage, 14660,
     /* 1880721 */     GIR_EraseRootFromParent_Done,
     /* 1880722 */   // Label 25357: @1880722
     /* 1880722 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1880811), // Rule ID 14661 //
     /* 1880727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1880738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1880741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1880744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1880747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880773 */     // MIs[0] policy
     /* 1880773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880783 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1880786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880810 */     // GIR_Coverage, 14661,
     /* 1880810 */     GIR_EraseRootFromParent_Done,
     /* 1880811 */   // Label 25358: @1880811
     /* 1880811 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1880900), // Rule ID 14664 //
     /* 1880816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1880827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1880830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880862 */     // MIs[0] policy
     /* 1880862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880872 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1880875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880899 */     // GIR_Coverage, 14664,
     /* 1880899 */     GIR_EraseRootFromParent_Done,
     /* 1880900 */   // Label 25359: @1880900
     /* 1880900 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1880989), // Rule ID 14665 //
     /* 1880905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1880916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1880919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880951 */     // MIs[0] policy
     /* 1880951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880961 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1880964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880988 */     // GIR_Coverage, 14665,
     /* 1880988 */     GIR_EraseRootFromParent_Done,
     /* 1880989 */   // Label 25360: @1880989
     /* 1880989 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1881078), // Rule ID 14668 //
     /* 1880994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1881005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1881008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1881011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881040 */     // MIs[0] policy
     /* 1881040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881050 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1881053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881077 */     // GIR_Coverage, 14668,
     /* 1881077 */     GIR_EraseRootFromParent_Done,
     /* 1881078 */   // Label 25361: @1881078
     /* 1881078 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1881167), // Rule ID 14669 //
     /* 1881083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1881094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1881097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1881100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881129 */     // MIs[0] policy
     /* 1881129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1881142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881166 */     // GIR_Coverage, 14669,
     /* 1881166 */     GIR_EraseRootFromParent_Done,
     /* 1881167 */   // Label 25362: @1881167
     /* 1881167 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1881256), // Rule ID 14672 //
     /* 1881172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1881183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1881186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1881189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881218 */     // MIs[0] policy
     /* 1881218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881228 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881255 */     // GIR_Coverage, 14672,
     /* 1881255 */     GIR_EraseRootFromParent_Done,
     /* 1881256 */   // Label 25363: @1881256
     /* 1881256 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1881345), // Rule ID 14673 //
     /* 1881261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1881272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1881275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1881278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881307 */     // MIs[0] policy
     /* 1881307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881317 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881344 */     // GIR_Coverage, 14673,
     /* 1881344 */     GIR_EraseRootFromParent_Done,
     /* 1881345 */   // Label 25364: @1881345
     /* 1881345 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1881434), // Rule ID 14676 //
     /* 1881350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1881361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1881364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1881367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881396 */     // MIs[0] policy
     /* 1881396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1881409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881433 */     // GIR_Coverage, 14676,
     /* 1881433 */     GIR_EraseRootFromParent_Done,
     /* 1881434 */   // Label 25365: @1881434
     /* 1881434 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1881523), // Rule ID 14677 //
     /* 1881439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1881450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1881453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1881456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881485 */     // MIs[0] policy
     /* 1881485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881495 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1881498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881522 */     // GIR_Coverage, 14677,
     /* 1881522 */     GIR_EraseRootFromParent_Done,
     /* 1881523 */   // Label 25366: @1881523
     /* 1881523 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1881612), // Rule ID 14680 //
     /* 1881528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1881539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1881542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1881545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881574 */     // MIs[0] policy
     /* 1881574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881611 */     // GIR_Coverage, 14680,
     /* 1881611 */     GIR_EraseRootFromParent_Done,
     /* 1881612 */   // Label 25367: @1881612
     /* 1881612 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1881701), // Rule ID 14681 //
     /* 1881617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1881628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1881631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1881634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881663 */     // MIs[0] policy
     /* 1881663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881673 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881700 */     // GIR_Coverage, 14681,
     /* 1881700 */     GIR_EraseRootFromParent_Done,
     /* 1881701 */   // Label 25368: @1881701
     /* 1881701 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1881790), // Rule ID 14684 //
     /* 1881706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1881717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1881720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1881723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881752 */     // MIs[0] policy
     /* 1881752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881789 */     // GIR_Coverage, 14684,
     /* 1881789 */     GIR_EraseRootFromParent_Done,
     /* 1881790 */   // Label 25369: @1881790
     /* 1881790 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1881879), // Rule ID 14685 //
     /* 1881795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1881806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1881809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1881812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881841 */     // MIs[0] policy
     /* 1881841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1881854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881872 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881878 */     // GIR_Coverage, 14685,
     /* 1881878 */     GIR_EraseRootFromParent_Done,
     /* 1881879 */   // Label 25370: @1881879
     /* 1881879 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1881968), // Rule ID 14688 //
     /* 1881884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1881904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1881926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881930 */     // MIs[0] policy
     /* 1881930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1881943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881967 */     // GIR_Coverage, 14688,
     /* 1881967 */     GIR_EraseRootFromParent_Done,
     /* 1881968 */   // Label 25371: @1881968
     /* 1881968 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1882057), // Rule ID 14689 //
     /* 1881973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1881993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882019 */     // MIs[0] policy
     /* 1882019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882029 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11559:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882056 */     // GIR_Coverage, 14689,
     /* 1882056 */     GIR_EraseRootFromParent_Done,
     /* 1882057 */   // Label 25372: @1882057
     /* 1882057 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1882146), // Rule ID 14692 //
     /* 1882062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1882073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1882076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1882079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882108 */     // MIs[0] policy
     /* 1882108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882145 */     // GIR_Coverage, 14692,
     /* 1882145 */     GIR_EraseRootFromParent_Done,
     /* 1882146 */   // Label 25373: @1882146
     /* 1882146 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1882235), // Rule ID 14693 //
     /* 1882151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1882162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1882165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1882168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882197 */     // MIs[0] policy
     /* 1882197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882207 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11559:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882234 */     // GIR_Coverage, 14693,
     /* 1882234 */     GIR_EraseRootFromParent_Done,
     /* 1882235 */   // Label 25374: @1882235
     /* 1882235 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1882324), // Rule ID 14696 //
     /* 1882240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1882251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1882254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1882257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882286 */     // MIs[0] policy
     /* 1882286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882323 */     // GIR_Coverage, 14696,
     /* 1882323 */     GIR_EraseRootFromParent_Done,
     /* 1882324 */   // Label 25375: @1882324
     /* 1882324 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1882413), // Rule ID 14697 //
     /* 1882329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1882340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1882343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1882346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882375 */     // MIs[0] policy
     /* 1882375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882385 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882412 */     // GIR_Coverage, 14697,
     /* 1882412 */     GIR_EraseRootFromParent_Done,
     /* 1882413 */   // Label 25376: @1882413
     /* 1882413 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1882502), // Rule ID 14700 //
     /* 1882418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1882429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1882432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1882435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1882441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882464 */     // MIs[0] policy
     /* 1882464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882501 */     // GIR_Coverage, 14700,
     /* 1882501 */     GIR_EraseRootFromParent_Done,
     /* 1882502 */   // Label 25377: @1882502
     /* 1882502 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1882591), // Rule ID 14701 //
     /* 1882507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1882518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1882521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1882524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1882530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882553 */     // MIs[0] policy
     /* 1882553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882563 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1882566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882590 */     // GIR_Coverage, 14701,
     /* 1882590 */     GIR_EraseRootFromParent_Done,
     /* 1882591 */   // Label 25378: @1882591
     /* 1882591 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1882680), // Rule ID 14704 //
     /* 1882596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1882607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1882610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1882613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882642 */     // MIs[0] policy
     /* 1882642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1882655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882679 */     // GIR_Coverage, 14704,
     /* 1882679 */     GIR_EraseRootFromParent_Done,
     /* 1882680 */   // Label 25379: @1882680
     /* 1882680 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1882769), // Rule ID 14705 //
     /* 1882685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1882696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1882699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1882702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882731 */     // MIs[0] policy
     /* 1882731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882741 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1882744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882768 */     // GIR_Coverage, 14705,
     /* 1882768 */     GIR_EraseRootFromParent_Done,
     /* 1882769 */   // Label 25380: @1882769
     /* 1882769 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1882858), // Rule ID 14708 //
     /* 1882774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1882785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1882788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1882791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882820 */     // MIs[0] policy
     /* 1882820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1882833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882857 */     // GIR_Coverage, 14708,
     /* 1882857 */     GIR_EraseRootFromParent_Done,
     /* 1882858 */   // Label 25381: @1882858
     /* 1882858 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1882947), // Rule ID 14709 //
     /* 1882863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1882874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1882877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1882880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1882883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882909 */     // MIs[0] policy
     /* 1882909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882919 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1882922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882946 */     // GIR_Coverage, 14709,
     /* 1882946 */     GIR_EraseRootFromParent_Done,
     /* 1882947 */   // Label 25382: @1882947
     /* 1882947 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1883036), // Rule ID 14712 //
     /* 1882952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1882963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1882966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1882969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1882972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1882975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1882994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882998 */     // MIs[0] policy
     /* 1882998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883008 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1883011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883035 */     // GIR_Coverage, 14712,
     /* 1883035 */     GIR_EraseRootFromParent_Done,
     /* 1883036 */   // Label 25383: @1883036
     /* 1883036 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1883125), // Rule ID 14713 //
     /* 1883041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1883052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1883055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1883058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1883064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883087 */     // MIs[0] policy
     /* 1883087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883097 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1883100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883124 */     // GIR_Coverage, 14713,
     /* 1883124 */     GIR_EraseRootFromParent_Done,
     /* 1883125 */   // Label 25384: @1883125
     /* 1883125 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1883214), // Rule ID 14716 //
     /* 1883130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1883141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1883144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1883147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883176 */     // MIs[0] policy
     /* 1883176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1883189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883213 */     // GIR_Coverage, 14716,
     /* 1883213 */     GIR_EraseRootFromParent_Done,
     /* 1883214 */   // Label 25385: @1883214
     /* 1883214 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1883303), // Rule ID 14717 //
     /* 1883219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1883230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1883233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1883236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883265 */     // MIs[0] policy
     /* 1883265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1883278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883302 */     // GIR_Coverage, 14717,
     /* 1883302 */     GIR_EraseRootFromParent_Done,
     /* 1883303 */   // Label 25386: @1883303
     /* 1883303 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1883392), // Rule ID 14720 //
     /* 1883308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1883319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1883322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1883325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883354 */     // MIs[0] policy
     /* 1883354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883364 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1883367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883391 */     // GIR_Coverage, 14720,
     /* 1883391 */     GIR_EraseRootFromParent_Done,
     /* 1883392 */   // Label 25387: @1883392
     /* 1883392 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1883481), // Rule ID 14721 //
     /* 1883397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1883408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1883411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1883414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883443 */     // MIs[0] policy
     /* 1883443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883453 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1883456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883480 */     // GIR_Coverage, 14721,
     /* 1883480 */     GIR_EraseRootFromParent_Done,
     /* 1883481 */   // Label 25388: @1883481
     /* 1883481 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1883570), // Rule ID 14724 //
     /* 1883486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1883497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1883500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1883503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1883509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883532 */     // MIs[0] policy
     /* 1883532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1883545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883569 */     // GIR_Coverage, 14724,
     /* 1883569 */     GIR_EraseRootFromParent_Done,
     /* 1883570 */   // Label 25389: @1883570
     /* 1883570 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1883659), // Rule ID 14725 //
     /* 1883575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1883586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1883589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1883592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1883598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883621 */     // MIs[0] policy
     /* 1883621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883631 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1883634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883658 */     // GIR_Coverage, 14725,
     /* 1883658 */     GIR_EraseRootFromParent_Done,
     /* 1883659 */   // Label 25390: @1883659
     /* 1883659 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1883748), // Rule ID 14728 //
     /* 1883664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1883675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1883678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1883681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883710 */     // MIs[0] policy
     /* 1883710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1883723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883747 */     // GIR_Coverage, 14728,
     /* 1883747 */     GIR_EraseRootFromParent_Done,
     /* 1883748 */   // Label 25391: @1883748
     /* 1883748 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1883837), // Rule ID 14729 //
     /* 1883753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1883764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1883767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1883770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883799 */     // MIs[0] policy
     /* 1883799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1883812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883836 */     // GIR_Coverage, 14729,
     /* 1883836 */     GIR_EraseRootFromParent_Done,
     /* 1883837 */   // Label 25392: @1883837
     /* 1883837 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1883926), // Rule ID 14732 //
     /* 1883842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1883853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1883856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1883859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883888 */     // MIs[0] policy
     /* 1883888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1883901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883925 */     // GIR_Coverage, 14732,
     /* 1883925 */     GIR_EraseRootFromParent_Done,
     /* 1883926 */   // Label 25393: @1883926
     /* 1883926 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1884015), // Rule ID 14733 //
     /* 1883931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1883942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1883945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1883948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883977 */     // MIs[0] policy
     /* 1883977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883987 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1883990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884014 */     // GIR_Coverage, 14733,
     /* 1884014 */     GIR_EraseRootFromParent_Done,
     /* 1884015 */   // Label 25394: @1884015
     /* 1884015 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1884104), // Rule ID 14736 //
     /* 1884020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1884031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1884034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1884037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884066 */     // MIs[0] policy
     /* 1884066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1884079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884103 */     // GIR_Coverage, 14736,
     /* 1884103 */     GIR_EraseRootFromParent_Done,
     /* 1884104 */   // Label 25395: @1884104
     /* 1884104 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1884193), // Rule ID 14737 //
     /* 1884109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1884120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1884123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1884126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884155 */     // MIs[0] policy
     /* 1884155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884165 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1884168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884192 */     // GIR_Coverage, 14737,
     /* 1884192 */     GIR_EraseRootFromParent_Done,
     /* 1884193 */   // Label 25396: @1884193
     /* 1884193 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1884282), // Rule ID 14740 //
     /* 1884198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1884209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1884212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1884215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884244 */     // MIs[0] policy
     /* 1884244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884254 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884281 */     // GIR_Coverage, 14740,
     /* 1884281 */     GIR_EraseRootFromParent_Done,
     /* 1884282 */   // Label 25397: @1884282
     /* 1884282 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1884371), // Rule ID 14741 //
     /* 1884287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1884298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1884301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1884304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884333 */     // MIs[0] policy
     /* 1884333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884370 */     // GIR_Coverage, 14741,
     /* 1884370 */     GIR_EraseRootFromParent_Done,
     /* 1884371 */   // Label 25398: @1884371
     /* 1884371 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1884460), // Rule ID 14744 //
     /* 1884376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1884387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1884390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1884393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1884406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884422 */     // MIs[0] policy
     /* 1884422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1884435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884459 */     // GIR_Coverage, 14744,
     /* 1884459 */     GIR_EraseRootFromParent_Done,
     /* 1884460 */   // Label 25399: @1884460
     /* 1884460 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1884549), // Rule ID 14745 //
     /* 1884465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1884476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1884479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1884482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1884495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884511 */     // MIs[0] policy
     /* 1884511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884521 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1884524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884548 */     // GIR_Coverage, 14745,
     /* 1884548 */     GIR_EraseRootFromParent_Done,
     /* 1884549 */   // Label 25400: @1884549
     /* 1884549 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1884638), // Rule ID 14748 //
     /* 1884554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1884565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1884568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1884571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884600 */     // MIs[0] policy
     /* 1884600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1884613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884637 */     // GIR_Coverage, 14748,
     /* 1884637 */     GIR_EraseRootFromParent_Done,
     /* 1884638 */   // Label 25401: @1884638
     /* 1884638 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1884727), // Rule ID 14749 //
     /* 1884643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1884654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1884657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1884660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884689 */     // MIs[0] policy
     /* 1884689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1884702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884726 */     // GIR_Coverage, 14749,
     /* 1884726 */     GIR_EraseRootFromParent_Done,
     /* 1884727 */   // Label 25402: @1884727
     /* 1884727 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1884816), // Rule ID 14752 //
     /* 1884732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1884743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1884746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1884749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1884752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884778 */     // MIs[0] policy
     /* 1884778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1884791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884815 */     // GIR_Coverage, 14752,
     /* 1884815 */     GIR_EraseRootFromParent_Done,
     /* 1884816 */   // Label 25403: @1884816
     /* 1884816 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1884905), // Rule ID 14753 //
     /* 1884821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1884832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1884835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1884838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1884841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884867 */     // MIs[0] policy
     /* 1884867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884877 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1884880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884904 */     // GIR_Coverage, 14753,
     /* 1884904 */     GIR_EraseRootFromParent_Done,
     /* 1884905 */   // Label 25404: @1884905
     /* 1884905 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1884994), // Rule ID 14756 //
     /* 1884910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1884921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1884924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1884927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1884930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884956 */     // MIs[0] policy
     /* 1884956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1884969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884993 */     // GIR_Coverage, 14756,
     /* 1884993 */     GIR_EraseRootFromParent_Done,
     /* 1884994 */   // Label 25405: @1884994
     /* 1884994 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1885083), // Rule ID 14757 //
     /* 1884999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1885010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1885013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1885016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1885019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885045 */     // MIs[0] policy
     /* 1885045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885055 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1885058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885082 */     // GIR_Coverage, 14757,
     /* 1885082 */     GIR_EraseRootFromParent_Done,
     /* 1885083 */   // Label 25406: @1885083
     /* 1885083 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1885172), // Rule ID 14760 //
     /* 1885088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1885099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1885102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1885105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1885108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885134 */     // MIs[0] policy
     /* 1885134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885171 */     // GIR_Coverage, 14760,
     /* 1885171 */     GIR_EraseRootFromParent_Done,
     /* 1885172 */   // Label 25407: @1885172
     /* 1885172 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1885261), // Rule ID 14761 //
     /* 1885177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1885188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1885191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1885194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1885197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885223 */     // MIs[0] policy
     /* 1885223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885233 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885260 */     // GIR_Coverage, 14761,
     /* 1885260 */     GIR_EraseRootFromParent_Done,
     /* 1885261 */   // Label 25408: @1885261
     /* 1885261 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1885350), // Rule ID 14764 //
     /* 1885266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1885277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1885280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1885283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1885286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885312 */     // MIs[0] policy
     /* 1885312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1885325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885349 */     // GIR_Coverage, 14764,
     /* 1885349 */     GIR_EraseRootFromParent_Done,
     /* 1885350 */   // Label 25409: @1885350
     /* 1885350 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1885439), // Rule ID 14765 //
     /* 1885355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1885366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1885369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1885372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1885375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885401 */     // MIs[0] policy
     /* 1885401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885411 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1885414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885438 */     // GIR_Coverage, 14765,
     /* 1885438 */     GIR_EraseRootFromParent_Done,
     /* 1885439 */   // Label 25410: @1885439
     /* 1885439 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1885528), // Rule ID 14768 //
     /* 1885444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1885455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1885458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1885461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1885464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885490 */     // MIs[0] policy
     /* 1885490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885527 */     // GIR_Coverage, 14768,
     /* 1885527 */     GIR_EraseRootFromParent_Done,
     /* 1885528 */   // Label 25411: @1885528
     /* 1885528 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1885617), // Rule ID 14769 //
     /* 1885533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1885544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1885547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1885550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1885553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885579 */     // MIs[0] policy
     /* 1885579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885589 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885616 */     // GIR_Coverage, 14769,
     /* 1885616 */     GIR_EraseRootFromParent_Done,
     /* 1885617 */   // Label 25412: @1885617
     /* 1885617 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1885706), // Rule ID 14772 //
     /* 1885622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1885633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1885636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1885639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1885642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885668 */     // MIs[0] policy
     /* 1885668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885705 */     // GIR_Coverage, 14772,
     /* 1885705 */     GIR_EraseRootFromParent_Done,
     /* 1885706 */   // Label 25413: @1885706
     /* 1885706 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1885795), // Rule ID 14773 //
     /* 1885711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1885722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1885725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1885728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1885731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885757 */     // MIs[0] policy
     /* 1885757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885767 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1885770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885794 */     // GIR_Coverage, 14773,
     /* 1885794 */     GIR_EraseRootFromParent_Done,
     /* 1885795 */   // Label 25414: @1885795
     /* 1885795 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1885884), // Rule ID 14776 //
     /* 1885800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1885811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1885814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1885817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1885820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885846 */     // MIs[0] policy
     /* 1885846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1885859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885883 */     // GIR_Coverage, 14776,
     /* 1885883 */     GIR_EraseRootFromParent_Done,
     /* 1885884 */   // Label 25415: @1885884
     /* 1885884 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1885973), // Rule ID 14777 //
     /* 1885889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1885900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1885903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1885906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1885909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885935 */     // MIs[0] policy
     /* 1885935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885945 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1885948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885972 */     // GIR_Coverage, 14777,
     /* 1885972 */     GIR_EraseRootFromParent_Done,
     /* 1885973 */   // Label 25416: @1885973
     /* 1885973 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1886062), // Rule ID 14780 //
     /* 1885978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1885989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1885992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1885995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1885998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886024 */     // MIs[0] policy
     /* 1886024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886061 */     // GIR_Coverage, 14780,
     /* 1886061 */     GIR_EraseRootFromParent_Done,
     /* 1886062 */   // Label 25417: @1886062
     /* 1886062 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1886151), // Rule ID 14781 //
     /* 1886067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1886078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1886081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1886084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1886087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886113 */     // MIs[0] policy
     /* 1886113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886123 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886150 */     // GIR_Coverage, 14781,
     /* 1886150 */     GIR_EraseRootFromParent_Done,
     /* 1886151 */   // Label 25418: @1886151
     /* 1886151 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1886240), // Rule ID 14784 //
     /* 1886156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1886167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1886170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1886173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1886176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886202 */     // MIs[0] policy
     /* 1886202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886239 */     // GIR_Coverage, 14784,
     /* 1886239 */     GIR_EraseRootFromParent_Done,
     /* 1886240 */   // Label 25419: @1886240
     /* 1886240 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1886329), // Rule ID 14785 //
     /* 1886245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1886256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1886259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1886262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1886265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886291 */     // MIs[0] policy
     /* 1886291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886328 */     // GIR_Coverage, 14785,
     /* 1886328 */     GIR_EraseRootFromParent_Done,
     /* 1886329 */   // Label 25420: @1886329
     /* 1886329 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1886418), // Rule ID 14788 //
     /* 1886334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1886345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1886348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1886351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1886354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1886357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886380 */     // MIs[0] policy
     /* 1886380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886417 */     // GIR_Coverage, 14788,
     /* 1886417 */     GIR_EraseRootFromParent_Done,
     /* 1886418 */   // Label 25421: @1886418
     /* 1886418 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1886507), // Rule ID 14789 //
     /* 1886423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1886434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1886437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1886440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1886443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1886446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886469 */     // MIs[0] policy
     /* 1886469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886479 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1886482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886506 */     // GIR_Coverage, 14789,
     /* 1886506 */     GIR_EraseRootFromParent_Done,
     /* 1886507 */   // Label 25422: @1886507
     /* 1886507 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1886596), // Rule ID 14792 //
     /* 1886512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1886523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1886526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1886529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1886532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886558 */     // MIs[0] policy
     /* 1886558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1886571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886595 */     // GIR_Coverage, 14792,
     /* 1886595 */     GIR_EraseRootFromParent_Done,
     /* 1886596 */   // Label 25423: @1886596
     /* 1886596 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1886685), // Rule ID 14793 //
     /* 1886601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1886612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1886615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1886618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1886621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886647 */     // MIs[0] policy
     /* 1886647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886657 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1886660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886684 */     // GIR_Coverage, 14793,
     /* 1886684 */     GIR_EraseRootFromParent_Done,
     /* 1886685 */   // Label 25424: @1886685
     /* 1886685 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1886774), // Rule ID 14796 //
     /* 1886690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1886701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1886704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1886707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1886710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886736 */     // MIs[0] policy
     /* 1886736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1886749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886773 */     // GIR_Coverage, 14796,
     /* 1886773 */     GIR_EraseRootFromParent_Done,
     /* 1886774 */   // Label 25425: @1886774
     /* 1886774 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1886863), // Rule ID 14797 //
     /* 1886779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1886790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1886793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1886796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1886799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886825 */     // MIs[0] policy
     /* 1886825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886835 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1886838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886862 */     // GIR_Coverage, 14797,
     /* 1886862 */     GIR_EraseRootFromParent_Done,
     /* 1886863 */   // Label 25426: @1886863
     /* 1886863 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1886952), // Rule ID 14800 //
     /* 1886868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1886879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1886882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1886885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1886888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1886891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886914 */     // MIs[0] policy
     /* 1886914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1886927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886951 */     // GIR_Coverage, 14800,
     /* 1886951 */     GIR_EraseRootFromParent_Done,
     /* 1886952 */   // Label 25427: @1886952
     /* 1886952 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1887041), // Rule ID 14801 //
     /* 1886957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1886968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1886971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1886974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1886977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1886980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887003 */     // MIs[0] policy
     /* 1887003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887013 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1887016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887040 */     // GIR_Coverage, 14801,
     /* 1887040 */     GIR_EraseRootFromParent_Done,
     /* 1887041 */   // Label 25428: @1887041
     /* 1887041 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1887130), // Rule ID 14804 //
     /* 1887046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1887057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1887060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1887063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1887066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887092 */     // MIs[0] policy
     /* 1887092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1887105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887129 */     // GIR_Coverage, 14804,
     /* 1887129 */     GIR_EraseRootFromParent_Done,
     /* 1887130 */   // Label 25429: @1887130
     /* 1887130 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1887219), // Rule ID 14805 //
     /* 1887135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1887146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1887149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1887152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1887155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887181 */     // MIs[0] policy
     /* 1887181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1887194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887218 */     // GIR_Coverage, 14805,
     /* 1887218 */     GIR_EraseRootFromParent_Done,
     /* 1887219 */   // Label 25430: @1887219
     /* 1887219 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1887308), // Rule ID 14808 //
     /* 1887224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1887235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1887238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1887241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1887244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1887247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887270 */     // MIs[0] policy
     /* 1887270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1887283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887307 */     // GIR_Coverage, 14808,
     /* 1887307 */     GIR_EraseRootFromParent_Done,
     /* 1887308 */   // Label 25431: @1887308
     /* 1887308 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1887397), // Rule ID 14809 //
     /* 1887313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1887324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1887327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1887330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1887333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1887336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887359 */     // MIs[0] policy
     /* 1887359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887369 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1887372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887396 */     // GIR_Coverage, 14809,
     /* 1887396 */     GIR_EraseRootFromParent_Done,
     /* 1887397 */   // Label 25432: @1887397
     /* 1887397 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1887486), // Rule ID 14812 //
     /* 1887402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1887413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1887416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1887419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1887422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1887425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887448 */     // MIs[0] policy
     /* 1887448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887458 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1887461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887485 */     // GIR_Coverage, 14812,
     /* 1887485 */     GIR_EraseRootFromParent_Done,
     /* 1887486 */   // Label 25433: @1887486
     /* 1887486 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1887575), // Rule ID 14813 //
     /* 1887491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1887502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1887505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1887508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1887511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1887514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887537 */     // MIs[0] policy
     /* 1887537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887547 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1887550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887574 */     // GIR_Coverage, 14813,
     /* 1887574 */     GIR_EraseRootFromParent_Done,
     /* 1887575 */   // Label 25434: @1887575
     /* 1887575 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1887664), // Rule ID 14816 //
     /* 1887580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1887591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1887594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1887597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1887600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887626 */     // MIs[0] policy
     /* 1887626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1887639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887663 */     // GIR_Coverage, 14816,
     /* 1887663 */     GIR_EraseRootFromParent_Done,
     /* 1887664 */   // Label 25435: @1887664
     /* 1887664 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1887753), // Rule ID 14817 //
     /* 1887669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1887680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1887683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1887686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1887689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887715 */     // MIs[0] policy
     /* 1887715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1887728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887752 */     // GIR_Coverage, 14817,
     /* 1887752 */     GIR_EraseRootFromParent_Done,
     /* 1887753 */   // Label 25436: @1887753
     /* 1887753 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1887842), // Rule ID 14820 //
     /* 1887758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1887769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1887772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1887775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1887778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887804 */     // MIs[0] policy
     /* 1887804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887814 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1887817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887841 */     // GIR_Coverage, 14820,
     /* 1887841 */     GIR_EraseRootFromParent_Done,
     /* 1887842 */   // Label 25437: @1887842
     /* 1887842 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1887931), // Rule ID 14821 //
     /* 1887847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1887858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1887861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1887864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1887867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887893 */     // MIs[0] policy
     /* 1887893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887903 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1887906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887930 */     // GIR_Coverage, 14821,
     /* 1887930 */     GIR_EraseRootFromParent_Done,
     /* 1887931 */   // Label 25438: @1887931
     /* 1887931 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1888020), // Rule ID 14824 //
     /* 1887936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1887947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1887950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1887953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1887956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1887959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887982 */     // MIs[0] policy
     /* 1887982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1887995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888019 */     // GIR_Coverage, 14824,
     /* 1888019 */     GIR_EraseRootFromParent_Done,
     /* 1888020 */   // Label 25439: @1888020
     /* 1888020 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1888109), // Rule ID 14825 //
     /* 1888025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1888036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1888039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1888042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1888045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1888055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888071 */     // MIs[0] policy
     /* 1888071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888081 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1888084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888108 */     // GIR_Coverage, 14825,
     /* 1888108 */     GIR_EraseRootFromParent_Done,
     /* 1888109 */   // Label 25440: @1888109
     /* 1888109 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1888198), // Rule ID 14828 //
     /* 1888114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1888125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1888128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1888131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1888134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888160 */     // MIs[0] policy
     /* 1888160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888197 */     // GIR_Coverage, 14828,
     /* 1888197 */     GIR_EraseRootFromParent_Done,
     /* 1888198 */   // Label 25441: @1888198
     /* 1888198 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1888287), // Rule ID 14829 //
     /* 1888203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1888214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1888217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1888220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1888223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888249 */     // MIs[0] policy
     /* 1888249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888286 */     // GIR_Coverage, 14829,
     /* 1888286 */     GIR_EraseRootFromParent_Done,
     /* 1888287 */   // Label 25442: @1888287
     /* 1888287 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1888376), // Rule ID 14832 //
     /* 1888292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1888303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1888306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1888309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1888312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888338 */     // MIs[0] policy
     /* 1888338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888348 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1888351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888375 */     // GIR_Coverage, 14832,
     /* 1888375 */     GIR_EraseRootFromParent_Done,
     /* 1888376 */   // Label 25443: @1888376
     /* 1888376 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1888465), // Rule ID 14833 //
     /* 1888381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1888392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1888395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1888398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1888401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888427 */     // MIs[0] policy
     /* 1888427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888437 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1888440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888464 */     // GIR_Coverage, 14833,
     /* 1888464 */     GIR_EraseRootFromParent_Done,
     /* 1888465 */   // Label 25444: @1888465
     /* 1888465 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1888554), // Rule ID 14836 //
     /* 1888470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1888481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1888484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1888487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1888490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1888500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888516 */     // MIs[0] policy
     /* 1888516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888526 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1888529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888553 */     // GIR_Coverage, 14836,
     /* 1888553 */     GIR_EraseRootFromParent_Done,
     /* 1888554 */   // Label 25445: @1888554
     /* 1888554 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1888643), // Rule ID 14837 //
     /* 1888559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1888570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1888573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1888576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1888579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1888589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888605 */     // MIs[0] policy
     /* 1888605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888615 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1888618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888642 */     // GIR_Coverage, 14837,
     /* 1888642 */     GIR_EraseRootFromParent_Done,
     /* 1888643 */   // Label 25446: @1888643
     /* 1888643 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1888732), // Rule ID 14840 //
     /* 1888648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1888659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1888662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1888665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888694 */     // MIs[0] policy
     /* 1888694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1888707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888731 */     // GIR_Coverage, 14840,
     /* 1888731 */     GIR_EraseRootFromParent_Done,
     /* 1888732 */   // Label 25447: @1888732
     /* 1888732 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1888821), // Rule ID 14841 //
     /* 1888737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1888748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1888751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1888754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888783 */     // MIs[0] policy
     /* 1888783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888793 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1888796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888820 */     // GIR_Coverage, 14841,
     /* 1888820 */     GIR_EraseRootFromParent_Done,
     /* 1888821 */   // Label 25448: @1888821
     /* 1888821 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1888910), // Rule ID 14844 //
     /* 1888826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1888837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1888840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1888843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888872 */     // MIs[0] policy
     /* 1888872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888882 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1888885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888909 */     // GIR_Coverage, 14844,
     /* 1888909 */     GIR_EraseRootFromParent_Done,
     /* 1888910 */   // Label 25449: @1888910
     /* 1888910 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1888999), // Rule ID 14845 //
     /* 1888915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1888926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1888929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1888932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888961 */     // MIs[0] policy
     /* 1888961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888971 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1888974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888998 */     // GIR_Coverage, 14845,
     /* 1888998 */     GIR_EraseRootFromParent_Done,
     /* 1888999 */   // Label 25450: @1888999
     /* 1888999 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1889088), // Rule ID 14848 //
     /* 1889004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1889015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1889018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1889021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889050 */     // MIs[0] policy
     /* 1889050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889087 */     // GIR_Coverage, 14848,
     /* 1889087 */     GIR_EraseRootFromParent_Done,
     /* 1889088 */   // Label 25451: @1889088
     /* 1889088 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1889177), // Rule ID 14849 //
     /* 1889093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1889104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1889107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1889110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889139 */     // MIs[0] policy
     /* 1889139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889149 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889176 */     // GIR_Coverage, 14849,
     /* 1889176 */     GIR_EraseRootFromParent_Done,
     /* 1889177 */   // Label 25452: @1889177
     /* 1889177 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1889266), // Rule ID 14852 //
     /* 1889182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1889193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1889196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1889199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889228 */     // MIs[0] policy
     /* 1889228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889238 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1889241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889265 */     // GIR_Coverage, 14852,
     /* 1889265 */     GIR_EraseRootFromParent_Done,
     /* 1889266 */   // Label 25453: @1889266
     /* 1889266 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1889355), // Rule ID 14853 //
     /* 1889271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1889282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1889285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1889288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889317 */     // MIs[0] policy
     /* 1889317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889327 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1889330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889354 */     // GIR_Coverage, 14853,
     /* 1889354 */     GIR_EraseRootFromParent_Done,
     /* 1889355 */   // Label 25454: @1889355
     /* 1889355 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1889444), // Rule ID 14856 //
     /* 1889360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1889371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1889374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1889377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1889383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889406 */     // MIs[0] policy
     /* 1889406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889443 */     // GIR_Coverage, 14856,
     /* 1889443 */     GIR_EraseRootFromParent_Done,
     /* 1889444 */   // Label 25455: @1889444
     /* 1889444 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1889533), // Rule ID 14857 //
     /* 1889449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1889460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1889463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1889466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1889472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889495 */     // MIs[0] policy
     /* 1889495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889505 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889532 */     // GIR_Coverage, 14857,
     /* 1889532 */     GIR_EraseRootFromParent_Done,
     /* 1889533 */   // Label 25456: @1889533
     /* 1889533 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1889622), // Rule ID 14860 //
     /* 1889538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1889549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1889552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1889555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889584 */     // MIs[0] policy
     /* 1889584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889621 */     // GIR_Coverage, 14860,
     /* 1889621 */     GIR_EraseRootFromParent_Done,
     /* 1889622 */   // Label 25457: @1889622
     /* 1889622 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1889711), // Rule ID 14861 //
     /* 1889627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1889638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1889641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1889644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889673 */     // MIs[0] policy
     /* 1889673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1889686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889710 */     // GIR_Coverage, 14861,
     /* 1889710 */     GIR_EraseRootFromParent_Done,
     /* 1889711 */   // Label 25458: @1889711
     /* 1889711 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1889800), // Rule ID 14864 //
     /* 1889716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1889727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1889730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1889733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889762 */     // MIs[0] policy
     /* 1889762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1889775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889799 */     // GIR_Coverage, 14864,
     /* 1889799 */     GIR_EraseRootFromParent_Done,
     /* 1889800 */   // Label 25459: @1889800
     /* 1889800 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1889889), // Rule ID 14865 //
     /* 1889805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1889816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1889819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1889822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1889825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889851 */     // MIs[0] policy
     /* 1889851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889861 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11557:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1889864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889888 */     // GIR_Coverage, 14865,
     /* 1889888 */     GIR_EraseRootFromParent_Done,
     /* 1889889 */   // Label 25460: @1889889
     /* 1889889 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1889978), // Rule ID 14868 //
     /* 1889894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1889905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1889908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1889911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1889914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1889936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889940 */     // MIs[0] policy
     /* 1889940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1889953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889977 */     // GIR_Coverage, 14868,
     /* 1889977 */     GIR_EraseRootFromParent_Done,
     /* 1889978 */   // Label 25461: @1889978
     /* 1889978 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1890067), // Rule ID 14869 //
     /* 1889983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1889994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1889997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1890000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890029 */     // MIs[0] policy
     /* 1890029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890039 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11557:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1890042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890066 */     // GIR_Coverage, 14869,
     /* 1890066 */     GIR_EraseRootFromParent_Done,
     /* 1890067 */   // Label 25462: @1890067
     /* 1890067 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1890156), // Rule ID 14872 //
     /* 1890072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1890083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1890086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1890089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890118 */     // MIs[0] policy
     /* 1890118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1890131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890155 */     // GIR_Coverage, 14872,
     /* 1890155 */     GIR_EraseRootFromParent_Done,
     /* 1890156 */   // Label 25463: @1890156
     /* 1890156 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1890245), // Rule ID 14873 //
     /* 1890161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1890172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1890175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1890178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890207 */     // MIs[0] policy
     /* 1890207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1890220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890244 */     // GIR_Coverage, 14873,
     /* 1890244 */     GIR_EraseRootFromParent_Done,
     /* 1890245 */   // Label 25464: @1890245
     /* 1890245 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1890334), // Rule ID 14876 //
     /* 1890250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1890261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1890264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1890267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890296 */     // MIs[0] policy
     /* 1890296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1890309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890333 */     // GIR_Coverage, 14876,
     /* 1890333 */     GIR_EraseRootFromParent_Done,
     /* 1890334 */   // Label 25465: @1890334
     /* 1890334 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1890423), // Rule ID 14877 //
     /* 1890339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1890350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1890353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1890356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890385 */     // MIs[0] policy
     /* 1890385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1890398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890422 */     // GIR_Coverage, 14877,
     /* 1890422 */     GIR_EraseRootFromParent_Done,
     /* 1890423 */   // Label 25466: @1890423
     /* 1890423 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1890512), // Rule ID 14880 //
     /* 1890428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1890439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1890442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1890445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890474 */     // MIs[0] policy
     /* 1890474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1890487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890511 */     // GIR_Coverage, 14880,
     /* 1890511 */     GIR_EraseRootFromParent_Done,
     /* 1890512 */   // Label 25467: @1890512
     /* 1890512 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1890601), // Rule ID 14881 //
     /* 1890517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1890528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1890531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1890534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890563 */     // MIs[0] policy
     /* 1890563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1890576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890600 */     // GIR_Coverage, 14881,
     /* 1890600 */     GIR_EraseRootFromParent_Done,
     /* 1890601 */   // Label 25468: @1890601
     /* 1890601 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1890690), // Rule ID 14884 //
     /* 1890606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1890617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1890620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1890623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890652 */     // MIs[0] policy
     /* 1890652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1890665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890689 */     // GIR_Coverage, 14884,
     /* 1890689 */     GIR_EraseRootFromParent_Done,
     /* 1890690 */   // Label 25469: @1890690
     /* 1890690 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1890779), // Rule ID 14885 //
     /* 1890695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1890706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1890709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1890712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1890718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890741 */     // MIs[0] policy
     /* 1890741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1890754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890778 */     // GIR_Coverage, 14885,
     /* 1890778 */     GIR_EraseRootFromParent_Done,
     /* 1890779 */   // Label 25470: @1890779
     /* 1890779 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1890868), // Rule ID 14888 //
     /* 1890784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1890795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1890798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1890801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1890807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890830 */     // MIs[0] policy
     /* 1890830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890840 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1890843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890867 */     // GIR_Coverage, 14888,
     /* 1890867 */     GIR_EraseRootFromParent_Done,
     /* 1890868 */   // Label 25471: @1890868
     /* 1890868 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1890957), // Rule ID 14889 //
     /* 1890873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1890884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1890887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1890890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1890896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890919 */     // MIs[0] policy
     /* 1890919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890929 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1890932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890956 */     // GIR_Coverage, 14889,
     /* 1890956 */     GIR_EraseRootFromParent_Done,
     /* 1890957 */   // Label 25472: @1890957
     /* 1890957 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1891046), // Rule ID 14892 //
     /* 1890962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1890973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1890976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1890979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891008 */     // MIs[0] policy
     /* 1891008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1891021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891045 */     // GIR_Coverage, 14892,
     /* 1891045 */     GIR_EraseRootFromParent_Done,
     /* 1891046 */   // Label 25473: @1891046
     /* 1891046 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1891135), // Rule ID 14893 //
     /* 1891051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1891062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1891065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1891068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1891081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891097 */     // MIs[0] policy
     /* 1891097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1891110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891134 */     // GIR_Coverage, 14893,
     /* 1891134 */     GIR_EraseRootFromParent_Done,
     /* 1891135 */   // Label 25474: @1891135
     /* 1891135 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1891224), // Rule ID 14896 //
     /* 1891140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1891151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1891154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1891157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1891163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891186 */     // MIs[0] policy
     /* 1891186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1891199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891223 */     // GIR_Coverage, 14896,
     /* 1891223 */     GIR_EraseRootFromParent_Done,
     /* 1891224 */   // Label 25475: @1891224
     /* 1891224 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1891313), // Rule ID 14897 //
     /* 1891229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1891240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1891243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1891246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1891252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891275 */     // MIs[0] policy
     /* 1891275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891285 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1891288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891312 */     // GIR_Coverage, 14897,
     /* 1891312 */     GIR_EraseRootFromParent_Done,
     /* 1891313 */   // Label 25476: @1891313
     /* 1891313 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1891402), // Rule ID 14900 //
     /* 1891318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1891329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1891332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1891335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1891341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891364 */     // MIs[0] policy
     /* 1891364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891374 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1891377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891401 */     // GIR_Coverage, 14900,
     /* 1891401 */     GIR_EraseRootFromParent_Done,
     /* 1891402 */   // Label 25477: @1891402
     /* 1891402 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1891491), // Rule ID 14901 //
     /* 1891407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1891418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1891421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1891424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1891430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891453 */     // MIs[0] policy
     /* 1891453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891463 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1891466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891490 */     // GIR_Coverage, 14901,
     /* 1891490 */     GIR_EraseRootFromParent_Done,
     /* 1891491 */   // Label 25478: @1891491
     /* 1891491 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1891580), // Rule ID 14904 //
     /* 1891496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1891507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1891510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1891513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1891526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891542 */     // MIs[0] policy
     /* 1891542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1891555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891579 */     // GIR_Coverage, 14904,
     /* 1891579 */     GIR_EraseRootFromParent_Done,
     /* 1891580 */   // Label 25479: @1891580
     /* 1891580 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1891669), // Rule ID 14905 //
     /* 1891585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1891596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1891599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1891602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1891615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891631 */     // MIs[0] policy
     /* 1891631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1891644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891668 */     // GIR_Coverage, 14905,
     /* 1891668 */     GIR_EraseRootFromParent_Done,
     /* 1891669 */   // Label 25480: @1891669
     /* 1891669 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1891758), // Rule ID 14908 //
     /* 1891674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1891685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1891688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1891691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891720 */     // MIs[0] policy
     /* 1891720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891730 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1891733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891757 */     // GIR_Coverage, 14908,
     /* 1891757 */     GIR_EraseRootFromParent_Done,
     /* 1891758 */   // Label 25481: @1891758
     /* 1891758 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1891847), // Rule ID 14909 //
     /* 1891763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1891774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1891777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1891780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1891793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1891801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891809 */     // MIs[0] policy
     /* 1891809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1891822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891846 */     // GIR_Coverage, 14909,
     /* 1891846 */     GIR_EraseRootFromParent_Done,
     /* 1891847 */   // Label 25482: @1891847
     /* 1891847 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1891936), // Rule ID 14912 //
     /* 1891852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1891863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1891866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1891869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1891875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891898 */     // MIs[0] policy
     /* 1891898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1891911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891935 */     // GIR_Coverage, 14912,
     /* 1891935 */     GIR_EraseRootFromParent_Done,
     /* 1891936 */   // Label 25483: @1891936
     /* 1891936 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1892025), // Rule ID 14913 //
     /* 1891941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1891952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1891955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1891958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1891964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1891971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1891979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891987 */     // MIs[0] policy
     /* 1891987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891997 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1892000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892024 */     // GIR_Coverage, 14913,
     /* 1892024 */     GIR_EraseRootFromParent_Done,
     /* 1892025 */   // Label 25484: @1892025
     /* 1892025 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1892114), // Rule ID 14916 //
     /* 1892030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1892041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1892044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1892047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892076 */     // MIs[0] policy
     /* 1892076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892113 */     // GIR_Coverage, 14916,
     /* 1892113 */     GIR_EraseRootFromParent_Done,
     /* 1892114 */   // Label 25485: @1892114
     /* 1892114 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1892203), // Rule ID 14917 //
     /* 1892119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1892130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1892133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1892136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892165 */     // MIs[0] policy
     /* 1892165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892175 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892202 */     // GIR_Coverage, 14917,
     /* 1892202 */     GIR_EraseRootFromParent_Done,
     /* 1892203 */   // Label 25486: @1892203
     /* 1892203 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1892292), // Rule ID 14920 //
     /* 1892208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1892219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1892222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1892225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892254 */     // MIs[0] policy
     /* 1892254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1892267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892291 */     // GIR_Coverage, 14920,
     /* 1892291 */     GIR_EraseRootFromParent_Done,
     /* 1892292 */   // Label 25487: @1892292
     /* 1892292 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1892381), // Rule ID 14921 //
     /* 1892297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1892308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1892311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1892314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892343 */     // MIs[0] policy
     /* 1892343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892353 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1892356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892380 */     // GIR_Coverage, 14921,
     /* 1892380 */     GIR_EraseRootFromParent_Done,
     /* 1892381 */   // Label 25488: @1892381
     /* 1892381 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1892470), // Rule ID 14924 //
     /* 1892386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1892397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1892400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1892403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892432 */     // MIs[0] policy
     /* 1892432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1892445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892469 */     // GIR_Coverage, 14924,
     /* 1892469 */     GIR_EraseRootFromParent_Done,
     /* 1892470 */   // Label 25489: @1892470
     /* 1892470 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1892559), // Rule ID 14925 //
     /* 1892475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1892486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1892489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1892492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892521 */     // MIs[0] policy
     /* 1892521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892531 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1892534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892558 */     // GIR_Coverage, 14925,
     /* 1892558 */     GIR_EraseRootFromParent_Done,
     /* 1892559 */   // Label 25490: @1892559
     /* 1892559 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1892645), // Rule ID 19166 //
     /* 1892564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1892567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1892575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1892578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1892581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1892584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892610 */     // MIs[0] policy
     /* 1892610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892620 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1892623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892644 */     // GIR_Coverage, 19166,
     /* 1892644 */     GIR_EraseRootFromParent_Done,
     /* 1892645 */   // Label 25491: @1892645
     /* 1892645 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1892731), // Rule ID 19167 //
     /* 1892650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1892653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1892661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1892664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1892667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1892670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892696 */     // MIs[0] policy
     /* 1892696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892706 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1892709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892730 */     // GIR_Coverage, 19167,
     /* 1892730 */     GIR_EraseRootFromParent_Done,
     /* 1892731 */   // Label 25492: @1892731
     /* 1892731 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1892817), // Rule ID 19170 //
     /* 1892736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1892739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1892756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892782 */     // MIs[0] policy
     /* 1892782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892792 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1892795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892816 */     // GIR_Coverage, 19170,
     /* 1892816 */     GIR_EraseRootFromParent_Done,
     /* 1892817 */   // Label 25493: @1892817
     /* 1892817 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1892903), // Rule ID 19171 //
     /* 1892822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1892825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1892833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1892836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1892839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1892842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892868 */     // MIs[0] policy
     /* 1892868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892878 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1892881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892902 */     // GIR_Coverage, 19171,
     /* 1892902 */     GIR_EraseRootFromParent_Done,
     /* 1892903 */   // Label 25494: @1892903
     /* 1892903 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1892989), // Rule ID 19174 //
     /* 1892908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1892911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1892919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1892922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1892925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1892928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892954 */     // MIs[0] policy
     /* 1892954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892964 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1892967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892988 */     // GIR_Coverage, 19174,
     /* 1892988 */     GIR_EraseRootFromParent_Done,
     /* 1892989 */   // Label 25495: @1892989
     /* 1892989 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1893075), // Rule ID 19175 //
     /* 1892994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1892997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1893005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1893008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1893011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1893014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893040 */     // MIs[0] policy
     /* 1893040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1893053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893074 */     // GIR_Coverage, 19175,
     /* 1893074 */     GIR_EraseRootFromParent_Done,
     /* 1893075 */   // Label 25496: @1893075
     /* 1893075 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1893161), // Rule ID 19178 //
     /* 1893080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1893091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1893094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1893097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1893100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893126 */     // MIs[0] policy
     /* 1893126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893136 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1893139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893160 */     // GIR_Coverage, 19178,
     /* 1893160 */     GIR_EraseRootFromParent_Done,
     /* 1893161 */   // Label 25497: @1893161
     /* 1893161 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1893247), // Rule ID 19179 //
     /* 1893166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1893177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1893180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1893183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1893186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893212 */     // MIs[0] policy
     /* 1893212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893222 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1893225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893246 */     // GIR_Coverage, 19179,
     /* 1893246 */     GIR_EraseRootFromParent_Done,
     /* 1893247 */   // Label 25498: @1893247
     /* 1893247 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1893333), // Rule ID 19182 //
     /* 1893252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1893255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1893263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1893266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1893269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1893272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1893275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893298 */     // MIs[0] policy
     /* 1893298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1893311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893332 */     // GIR_Coverage, 19182,
     /* 1893332 */     GIR_EraseRootFromParent_Done,
     /* 1893333 */   // Label 25499: @1893333
     /* 1893333 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1893419), // Rule ID 19183 //
     /* 1893338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1893341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1893349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1893352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1893355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1893358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1893361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893384 */     // MIs[0] policy
     /* 1893384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893394 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1893397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893418 */     // GIR_Coverage, 19183,
     /* 1893418 */     GIR_EraseRootFromParent_Done,
     /* 1893419 */   // Label 25500: @1893419
     /* 1893419 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1893505), // Rule ID 19186 //
     /* 1893424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1893427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1893435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1893438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1893441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1893444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893470 */     // MIs[0] policy
     /* 1893470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893480 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1893483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893504 */     // GIR_Coverage, 19186,
     /* 1893504 */     GIR_EraseRootFromParent_Done,
     /* 1893505 */   // Label 25501: @1893505
     /* 1893505 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1893591), // Rule ID 19187 //
     /* 1893510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1893513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1893521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1893524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1893527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1893530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893556 */     // MIs[0] policy
     /* 1893556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893566 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1893569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893590 */     // GIR_Coverage, 19187,
     /* 1893590 */     GIR_EraseRootFromParent_Done,
     /* 1893591 */   // Label 25502: @1893591
     /* 1893591 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1893677), // Rule ID 19190 //
     /* 1893596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1893616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893642 */     // MIs[0] policy
     /* 1893642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1893655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893676 */     // GIR_Coverage, 19190,
     /* 1893676 */     GIR_EraseRootFromParent_Done,
     /* 1893677 */   // Label 25503: @1893677
     /* 1893677 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1893763), // Rule ID 19191 //
     /* 1893682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1893702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893728 */     // MIs[0] policy
     /* 1893728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893738 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1893741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893762 */     // GIR_Coverage, 19191,
     /* 1893762 */     GIR_EraseRootFromParent_Done,
     /* 1893763 */   // Label 25504: @1893763
     /* 1893763 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1893849), // Rule ID 19194 //
     /* 1893768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1893788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893814 */     // MIs[0] policy
     /* 1893814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1893827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893848 */     // GIR_Coverage, 19194,
     /* 1893848 */     GIR_EraseRootFromParent_Done,
     /* 1893849 */   // Label 25505: @1893849
     /* 1893849 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1893935), // Rule ID 19195 //
     /* 1893854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1893874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893900 */     // MIs[0] policy
     /* 1893900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893910 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1893913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893934 */     // GIR_Coverage, 19195,
     /* 1893934 */     GIR_EraseRootFromParent_Done,
     /* 1893935 */   // Label 25506: @1893935
     /* 1893935 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1894021), // Rule ID 19198 //
     /* 1893940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1893960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893986 */     // MIs[0] policy
     /* 1893986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893996 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1893999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894020 */     // GIR_Coverage, 19198,
     /* 1894020 */     GIR_EraseRootFromParent_Done,
     /* 1894021 */   // Label 25507: @1894021
     /* 1894021 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1894107), // Rule ID 19199 //
     /* 1894026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1894046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894072 */     // MIs[0] policy
     /* 1894072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894082 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1894085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894106 */     // GIR_Coverage, 19199,
     /* 1894106 */     GIR_EraseRootFromParent_Done,
     /* 1894107 */   // Label 25508: @1894107
     /* 1894107 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1894193), // Rule ID 19202 //
     /* 1894112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1894115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1894132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894158 */     // MIs[0] policy
     /* 1894158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894168 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1894171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894192 */     // GIR_Coverage, 19202,
     /* 1894192 */     GIR_EraseRootFromParent_Done,
     /* 1894193 */   // Label 25509: @1894193
     /* 1894193 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1894279), // Rule ID 19203 //
     /* 1894198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1894201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1894218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894244 */     // MIs[0] policy
     /* 1894244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894254 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1894257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894278 */     // GIR_Coverage, 19203,
     /* 1894278 */     GIR_EraseRootFromParent_Done,
     /* 1894279 */   // Label 25510: @1894279
     /* 1894279 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1894365), // Rule ID 19206 //
     /* 1894284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1894287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1894304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894330 */     // MIs[0] policy
     /* 1894330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894340 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1894343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894364 */     // GIR_Coverage, 19206,
     /* 1894364 */     GIR_EraseRootFromParent_Done,
     /* 1894365 */   // Label 25511: @1894365
     /* 1894365 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1894451), // Rule ID 19207 //
     /* 1894370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1894373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1894390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894416 */     // MIs[0] policy
     /* 1894416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894426 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1894429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894450 */     // GIR_Coverage, 19207,
     /* 1894450 */     GIR_EraseRootFromParent_Done,
     /* 1894451 */   // Label 25512: @1894451
     /* 1894451 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1894537), // Rule ID 19210 //
     /* 1894456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1894459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1894476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894502 */     // MIs[0] policy
     /* 1894502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894512 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1894515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894536 */     // GIR_Coverage, 19210,
     /* 1894536 */     GIR_EraseRootFromParent_Done,
     /* 1894537 */   // Label 25513: @1894537
     /* 1894537 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1894623), // Rule ID 19211 //
     /* 1894542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1894545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1894562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894588 */     // MIs[0] policy
     /* 1894588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894598 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1894601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894622 */     // GIR_Coverage, 19211,
     /* 1894622 */     GIR_EraseRootFromParent_Done,
     /* 1894623 */   // Label 25514: @1894623
     /* 1894623 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1894709), // Rule ID 19214 //
     /* 1894628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1894631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1894648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894674 */     // MIs[0] policy
     /* 1894674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894684 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1894687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894708 */     // GIR_Coverage, 19214,
     /* 1894708 */     GIR_EraseRootFromParent_Done,
     /* 1894709 */   // Label 25515: @1894709
     /* 1894709 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1894795), // Rule ID 19215 //
     /* 1894714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1894717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1894734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894760 */     // MIs[0] policy
     /* 1894760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894770 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1894773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894794 */     // GIR_Coverage, 19215,
     /* 1894794 */     GIR_EraseRootFromParent_Done,
     /* 1894795 */   // Label 25516: @1894795
     /* 1894795 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1894881), // Rule ID 19218 //
     /* 1894800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1894803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1894820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894846 */     // MIs[0] policy
     /* 1894846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894856 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1894859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894880 */     // GIR_Coverage, 19218,
     /* 1894880 */     GIR_EraseRootFromParent_Done,
     /* 1894881 */   // Label 25517: @1894881
     /* 1894881 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1894967), // Rule ID 19219 //
     /* 1894886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1894889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1894906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894932 */     // MIs[0] policy
     /* 1894932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894942 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1894945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894966 */     // GIR_Coverage, 19219,
     /* 1894966 */     GIR_EraseRootFromParent_Done,
     /* 1894967 */   // Label 25518: @1894967
     /* 1894967 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1895053), // Rule ID 19222 //
     /* 1894972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1894975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1894992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895018 */     // MIs[0] policy
     /* 1895018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895028 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1895031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895052 */     // GIR_Coverage, 19222,
     /* 1895052 */     GIR_EraseRootFromParent_Done,
     /* 1895053 */   // Label 25519: @1895053
     /* 1895053 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1895139), // Rule ID 19223 //
     /* 1895058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1895078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895104 */     // MIs[0] policy
     /* 1895104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895114 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1895117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895138 */     // GIR_Coverage, 19223,
     /* 1895138 */     GIR_EraseRootFromParent_Done,
     /* 1895139 */   // Label 25520: @1895139
     /* 1895139 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1895225), // Rule ID 19226 //
     /* 1895144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895190 */     // MIs[0] policy
     /* 1895190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895200 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1895203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895224 */     // GIR_Coverage, 19226,
     /* 1895224 */     GIR_EraseRootFromParent_Done,
     /* 1895225 */   // Label 25521: @1895225
     /* 1895225 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1895311), // Rule ID 19227 //
     /* 1895230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895276 */     // MIs[0] policy
     /* 1895276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895286 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1895289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895310 */     // GIR_Coverage, 19227,
     /* 1895310 */     GIR_EraseRootFromParent_Done,
     /* 1895311 */   // Label 25522: @1895311
     /* 1895311 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1895397), // Rule ID 19230 //
     /* 1895316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895362 */     // MIs[0] policy
     /* 1895362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895372 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1895375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895396 */     // GIR_Coverage, 19230,
     /* 1895396 */     GIR_EraseRootFromParent_Done,
     /* 1895397 */   // Label 25523: @1895397
     /* 1895397 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1895483), // Rule ID 19231 //
     /* 1895402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895448 */     // MIs[0] policy
     /* 1895448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1895461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895482 */     // GIR_Coverage, 19231,
     /* 1895482 */     GIR_EraseRootFromParent_Done,
     /* 1895483 */   // Label 25524: @1895483
     /* 1895483 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1895569), // Rule ID 19234 //
     /* 1895488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1895530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895534 */     // MIs[0] policy
     /* 1895534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1895547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895568 */     // GIR_Coverage, 19234,
     /* 1895568 */     GIR_EraseRootFromParent_Done,
     /* 1895569 */   // Label 25525: @1895569
     /* 1895569 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1895655), // Rule ID 19235 //
     /* 1895574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1895616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895620 */     // MIs[0] policy
     /* 1895620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895630 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1895633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895654 */     // GIR_Coverage, 19235,
     /* 1895654 */     GIR_EraseRootFromParent_Done,
     /* 1895655 */   // Label 25526: @1895655
     /* 1895655 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1895741), // Rule ID 19238 //
     /* 1895660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895706 */     // MIs[0] policy
     /* 1895706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895716 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1895719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895740 */     // GIR_Coverage, 19238,
     /* 1895740 */     GIR_EraseRootFromParent_Done,
     /* 1895741 */   // Label 25527: @1895741
     /* 1895741 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1895827), // Rule ID 19239 //
     /* 1895746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895792 */     // MIs[0] policy
     /* 1895792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895802 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11152:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1895805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895826 */     // GIR_Coverage, 19239,
     /* 1895826 */     GIR_EraseRootFromParent_Done,
     /* 1895827 */   // Label 25528: @1895827
     /* 1895827 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1895913), // Rule ID 19242 //
     /* 1895832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1895874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895878 */     // MIs[0] policy
     /* 1895878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895888 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1895891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895912 */     // GIR_Coverage, 19242,
     /* 1895912 */     GIR_EraseRootFromParent_Done,
     /* 1895913 */   // Label 25529: @1895913
     /* 1895913 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1895999), // Rule ID 19243 //
     /* 1895918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1895938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1895960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895964 */     // MIs[0] policy
     /* 1895964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1895977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895998 */     // GIR_Coverage, 19243,
     /* 1895998 */     GIR_EraseRootFromParent_Done,
     /* 1895999 */   // Label 25530: @1895999
     /* 1895999 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1896085), // Rule ID 19246 //
     /* 1896004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1896046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896050 */     // MIs[0] policy
     /* 1896050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896060 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1896063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896084 */     // GIR_Coverage, 19246,
     /* 1896084 */     GIR_EraseRootFromParent_Done,
     /* 1896085 */   // Label 25531: @1896085
     /* 1896085 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1896171), // Rule ID 19247 //
     /* 1896090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1896132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896136 */     // MIs[0] policy
     /* 1896136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896146 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1896149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896170 */     // GIR_Coverage, 19247,
     /* 1896170 */     GIR_EraseRootFromParent_Done,
     /* 1896171 */   // Label 25532: @1896171
     /* 1896171 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1896257), // Rule ID 19250 //
     /* 1896176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896222 */     // MIs[0] policy
     /* 1896222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1896235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896256 */     // GIR_Coverage, 19250,
     /* 1896256 */     GIR_EraseRootFromParent_Done,
     /* 1896257 */   // Label 25533: @1896257
     /* 1896257 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1896343), // Rule ID 19251 //
     /* 1896262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1896279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896308 */     // MIs[0] policy
     /* 1896308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896318 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1896321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896342 */     // GIR_Coverage, 19251,
     /* 1896342 */     GIR_EraseRootFromParent_Done,
     /* 1896343 */   // Label 25534: @1896343
     /* 1896343 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1896429), // Rule ID 19254 //
     /* 1896348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896394 */     // MIs[0] policy
     /* 1896394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896404 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1896407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896428 */     // GIR_Coverage, 19254,
     /* 1896428 */     GIR_EraseRootFromParent_Done,
     /* 1896429 */   // Label 25535: @1896429
     /* 1896429 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1896515), // Rule ID 19255 //
     /* 1896434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896480 */     // MIs[0] policy
     /* 1896480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896490 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1896493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896514 */     // GIR_Coverage, 19255,
     /* 1896514 */     GIR_EraseRootFromParent_Done,
     /* 1896515 */   // Label 25536: @1896515
     /* 1896515 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1896601), // Rule ID 19258 //
     /* 1896520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896566 */     // MIs[0] policy
     /* 1896566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896576 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1896579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896600 */     // GIR_Coverage, 19258,
     /* 1896600 */     GIR_EraseRootFromParent_Done,
     /* 1896601 */   // Label 25537: @1896601
     /* 1896601 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1896687), // Rule ID 19259 //
     /* 1896606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896652 */     // MIs[0] policy
     /* 1896652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896662 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1896665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896686 */     // GIR_Coverage, 19259,
     /* 1896686 */     GIR_EraseRootFromParent_Done,
     /* 1896687 */   // Label 25538: @1896687
     /* 1896687 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1896773), // Rule ID 19262 //
     /* 1896692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896738 */     // MIs[0] policy
     /* 1896738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1896751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896772 */     // GIR_Coverage, 19262,
     /* 1896772 */     GIR_EraseRootFromParent_Done,
     /* 1896773 */   // Label 25539: @1896773
     /* 1896773 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1896859), // Rule ID 19263 //
     /* 1896778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896824 */     // MIs[0] policy
     /* 1896824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896834 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1896837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896858 */     // GIR_Coverage, 19263,
     /* 1896858 */     GIR_EraseRootFromParent_Done,
     /* 1896859 */   // Label 25540: @1896859
     /* 1896859 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1896945), // Rule ID 19266 //
     /* 1896864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896910 */     // MIs[0] policy
     /* 1896910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896920 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1896923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896944 */     // GIR_Coverage, 19266,
     /* 1896944 */     GIR_EraseRootFromParent_Done,
     /* 1896945 */   // Label 25541: @1896945
     /* 1896945 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1897031), // Rule ID 19267 //
     /* 1896950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896996 */     // MIs[0] policy
     /* 1896996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897006 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1897009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897030 */     // GIR_Coverage, 19267,
     /* 1897030 */     GIR_EraseRootFromParent_Done,
     /* 1897031 */   // Label 25542: @1897031
     /* 1897031 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1897117), // Rule ID 19270 //
     /* 1897036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897082 */     // MIs[0] policy
     /* 1897082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1897095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897116 */     // GIR_Coverage, 19270,
     /* 1897116 */     GIR_EraseRootFromParent_Done,
     /* 1897117 */   // Label 25543: @1897117
     /* 1897117 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1897203), // Rule ID 19271 //
     /* 1897122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897168 */     // MIs[0] policy
     /* 1897168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897178 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1897181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897202 */     // GIR_Coverage, 19271,
     /* 1897202 */     GIR_EraseRootFromParent_Done,
     /* 1897203 */   // Label 25544: @1897203
     /* 1897203 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1897289), // Rule ID 19274 //
     /* 1897208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897254 */     // MIs[0] policy
     /* 1897254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1897267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897288 */     // GIR_Coverage, 19274,
     /* 1897288 */     GIR_EraseRootFromParent_Done,
     /* 1897289 */   // Label 25545: @1897289
     /* 1897289 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1897375), // Rule ID 19275 //
     /* 1897294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1897305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1897308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1897311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897340 */     // MIs[0] policy
     /* 1897340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1897353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897374 */     // GIR_Coverage, 19275,
     /* 1897374 */     GIR_EraseRootFromParent_Done,
     /* 1897375 */   // Label 25546: @1897375
     /* 1897375 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1897461), // Rule ID 19278 //
     /* 1897380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897426 */     // MIs[0] policy
     /* 1897426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897436 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1897439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897460 */     // GIR_Coverage, 19278,
     /* 1897460 */     GIR_EraseRootFromParent_Done,
     /* 1897461 */   // Label 25547: @1897461
     /* 1897461 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1897547), // Rule ID 19279 //
     /* 1897466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897512 */     // MIs[0] policy
     /* 1897512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897522 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1897525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897546 */     // GIR_Coverage, 19279,
     /* 1897546 */     GIR_EraseRootFromParent_Done,
     /* 1897547 */   // Label 25548: @1897547
     /* 1897547 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1897633), // Rule ID 19282 //
     /* 1897552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897598 */     // MIs[0] policy
     /* 1897598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897608 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1897611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897632 */     // GIR_Coverage, 19282,
     /* 1897632 */     GIR_EraseRootFromParent_Done,
     /* 1897633 */   // Label 25549: @1897633
     /* 1897633 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1897719), // Rule ID 19283 //
     /* 1897638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1897658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1897680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897684 */     // MIs[0] policy
     /* 1897684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1897697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897718 */     // GIR_Coverage, 19283,
     /* 1897718 */     GIR_EraseRootFromParent_Done,
     /* 1897719 */   // Label 25550: @1897719
     /* 1897719 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1897805), // Rule ID 19286 //
     /* 1897724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1897744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897770 */     // MIs[0] policy
     /* 1897770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897780 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1897783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897804 */     // GIR_Coverage, 19286,
     /* 1897804 */     GIR_EraseRootFromParent_Done,
     /* 1897805 */   // Label 25551: @1897805
     /* 1897805 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1897891), // Rule ID 19287 //
     /* 1897810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1897830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897856 */     // MIs[0] policy
     /* 1897856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897866 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1897869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897890 */     // GIR_Coverage, 19287,
     /* 1897890 */     GIR_EraseRootFromParent_Done,
     /* 1897891 */   // Label 25552: @1897891
     /* 1897891 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1897977), // Rule ID 19290 //
     /* 1897896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1897916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897942 */     // MIs[0] policy
     /* 1897942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897952 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1897955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897976 */     // GIR_Coverage, 19290,
     /* 1897976 */     GIR_EraseRootFromParent_Done,
     /* 1897977 */   // Label 25553: @1897977
     /* 1897977 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1898063), // Rule ID 19291 //
     /* 1897982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1898002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898028 */     // MIs[0] policy
     /* 1898028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898038 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1898041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898062 */     // GIR_Coverage, 19291,
     /* 1898062 */     GIR_EraseRootFromParent_Done,
     /* 1898063 */   // Label 25554: @1898063
     /* 1898063 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1898149), // Rule ID 19294 //
     /* 1898068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1898088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898114 */     // MIs[0] policy
     /* 1898114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898124 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1898127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898148 */     // GIR_Coverage, 19294,
     /* 1898148 */     GIR_EraseRootFromParent_Done,
     /* 1898149 */   // Label 25555: @1898149
     /* 1898149 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1898235), // Rule ID 19295 //
     /* 1898154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1898174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898200 */     // MIs[0] policy
     /* 1898200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1898213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898234 */     // GIR_Coverage, 19295,
     /* 1898234 */     GIR_EraseRootFromParent_Done,
     /* 1898235 */   // Label 25556: @1898235
     /* 1898235 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1898321), // Rule ID 19298 //
     /* 1898240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1898260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898286 */     // MIs[0] policy
     /* 1898286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898296 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1898299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898320 */     // GIR_Coverage, 19298,
     /* 1898320 */     GIR_EraseRootFromParent_Done,
     /* 1898321 */   // Label 25557: @1898321
     /* 1898321 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1898407), // Rule ID 19299 //
     /* 1898326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1898337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1898340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1898343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1898346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898372 */     // MIs[0] policy
     /* 1898372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1898385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898406 */     // GIR_Coverage, 19299,
     /* 1898406 */     GIR_EraseRootFromParent_Done,
     /* 1898407 */   // Label 25558: @1898407
     /* 1898407 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1898493), // Rule ID 19302 //
     /* 1898412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1898432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898458 */     // MIs[0] policy
     /* 1898458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1898471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898492 */     // GIR_Coverage, 19302,
     /* 1898492 */     GIR_EraseRootFromParent_Done,
     /* 1898493 */   // Label 25559: @1898493
     /* 1898493 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1898579), // Rule ID 19303 //
     /* 1898498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1898518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898544 */     // MIs[0] policy
     /* 1898544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898554 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1898557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898578 */     // GIR_Coverage, 19303,
     /* 1898578 */     GIR_EraseRootFromParent_Done,
     /* 1898579 */   // Label 25560: @1898579
     /* 1898579 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1898665), // Rule ID 19306 //
     /* 1898584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1898604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898630 */     // MIs[0] policy
     /* 1898630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1898643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898664 */     // GIR_Coverage, 19306,
     /* 1898664 */     GIR_EraseRootFromParent_Done,
     /* 1898665 */   // Label 25561: @1898665
     /* 1898665 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1898751), // Rule ID 19307 //
     /* 1898670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1898690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898716 */     // MIs[0] policy
     /* 1898716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898726 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1898729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898750 */     // GIR_Coverage, 19307,
     /* 1898750 */     GIR_EraseRootFromParent_Done,
     /* 1898751 */   // Label 25562: @1898751
     /* 1898751 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1898837), // Rule ID 19310 //
     /* 1898756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1898776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898802 */     // MIs[0] policy
     /* 1898802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898812 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1898815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898836 */     // GIR_Coverage, 19310,
     /* 1898836 */     GIR_EraseRootFromParent_Done,
     /* 1898837 */   // Label 25563: @1898837
     /* 1898837 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1898923), // Rule ID 19311 //
     /* 1898842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1898862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898888 */     // MIs[0] policy
     /* 1898888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898898 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1898901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898922 */     // GIR_Coverage, 19311,
     /* 1898922 */     GIR_EraseRootFromParent_Done,
     /* 1898923 */   // Label 25564: @1898923
     /* 1898923 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1899009), // Rule ID 19314 //
     /* 1898928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1898939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1898942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1898945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1898948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898974 */     // MIs[0] policy
     /* 1898974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1898987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899008 */     // GIR_Coverage, 19314,
     /* 1899008 */     GIR_EraseRootFromParent_Done,
     /* 1899009 */   // Label 25565: @1899009
     /* 1899009 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1899095), // Rule ID 19315 //
     /* 1899014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1899034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899060 */     // MIs[0] policy
     /* 1899060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899070 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1899073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899094 */     // GIR_Coverage, 19315,
     /* 1899094 */     GIR_EraseRootFromParent_Done,
     /* 1899095 */   // Label 25566: @1899095
     /* 1899095 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1899181), // Rule ID 19318 //
     /* 1899100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1899120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899146 */     // MIs[0] policy
     /* 1899146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899156 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1899159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899180 */     // GIR_Coverage, 19318,
     /* 1899180 */     GIR_EraseRootFromParent_Done,
     /* 1899181 */   // Label 25567: @1899181
     /* 1899181 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1899267), // Rule ID 19319 //
     /* 1899186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1899206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899232 */     // MIs[0] policy
     /* 1899232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899242 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1899245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899266 */     // GIR_Coverage, 19319,
     /* 1899266 */     GIR_EraseRootFromParent_Done,
     /* 1899267 */   // Label 25568: @1899267
     /* 1899267 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1899353), // Rule ID 19322 //
     /* 1899272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1899292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899318 */     // MIs[0] policy
     /* 1899318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899328 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1899331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899352 */     // GIR_Coverage, 19322,
     /* 1899352 */     GIR_EraseRootFromParent_Done,
     /* 1899353 */   // Label 25569: @1899353
     /* 1899353 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1899439), // Rule ID 19323 //
     /* 1899358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1899378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899404 */     // MIs[0] policy
     /* 1899404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1899417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899438 */     // GIR_Coverage, 19323,
     /* 1899438 */     GIR_EraseRootFromParent_Done,
     /* 1899439 */   // Label 25570: @1899439
     /* 1899439 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1899525), // Rule ID 19326 //
     /* 1899444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1899464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899490 */     // MIs[0] policy
     /* 1899490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899500 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1899503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899524 */     // GIR_Coverage, 19326,
     /* 1899524 */     GIR_EraseRootFromParent_Done,
     /* 1899525 */   // Label 25571: @1899525
     /* 1899525 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1899611), // Rule ID 19327 //
     /* 1899530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1899550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899576 */     // MIs[0] policy
     /* 1899576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899586 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1899589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899610 */     // GIR_Coverage, 19327,
     /* 1899610 */     GIR_EraseRootFromParent_Done,
     /* 1899611 */   // Label 25572: @1899611
     /* 1899611 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1899697), // Rule ID 19330 //
     /* 1899616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1899636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899662 */     // MIs[0] policy
     /* 1899662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899672 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1899675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899696 */     // GIR_Coverage, 19330,
     /* 1899696 */     GIR_EraseRootFromParent_Done,
     /* 1899697 */   // Label 25573: @1899697
     /* 1899697 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1899783), // Rule ID 19331 //
     /* 1899702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1899722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899748 */     // MIs[0] policy
     /* 1899748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899758 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1899761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899782 */     // GIR_Coverage, 19331,
     /* 1899782 */     GIR_EraseRootFromParent_Done,
     /* 1899783 */   // Label 25574: @1899783
     /* 1899783 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1899869), // Rule ID 19334 //
     /* 1899788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1899808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899834 */     // MIs[0] policy
     /* 1899834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899844 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1899847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899868 */     // GIR_Coverage, 19334,
     /* 1899868 */     GIR_EraseRootFromParent_Done,
     /* 1899869 */   // Label 25575: @1899869
     /* 1899869 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1899955), // Rule ID 19335 //
     /* 1899874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1899894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899920 */     // MIs[0] policy
     /* 1899920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1899933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899954 */     // GIR_Coverage, 19335,
     /* 1899954 */     GIR_EraseRootFromParent_Done,
     /* 1899955 */   // Label 25576: @1899955
     /* 1899955 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1900041), // Rule ID 19338 //
     /* 1899960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1899971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1899974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1899977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1899980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900006 */     // MIs[0] policy
     /* 1900006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900016 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1900019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900040 */     // GIR_Coverage, 19338,
     /* 1900040 */     GIR_EraseRootFromParent_Done,
     /* 1900041 */   // Label 25577: @1900041
     /* 1900041 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1900127), // Rule ID 19339 //
     /* 1900046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1900066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900092 */     // MIs[0] policy
     /* 1900092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900102 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1900105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900126 */     // GIR_Coverage, 19339,
     /* 1900126 */     GIR_EraseRootFromParent_Done,
     /* 1900127 */   // Label 25578: @1900127
     /* 1900127 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1900213), // Rule ID 19342 //
     /* 1900132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1900152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900178 */     // MIs[0] policy
     /* 1900178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900188 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1900191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900212 */     // GIR_Coverage, 19342,
     /* 1900212 */     GIR_EraseRootFromParent_Done,
     /* 1900213 */   // Label 25579: @1900213
     /* 1900213 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1900299), // Rule ID 19343 //
     /* 1900218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1900238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900264 */     // MIs[0] policy
     /* 1900264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900274 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1900277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900298 */     // GIR_Coverage, 19343,
     /* 1900298 */     GIR_EraseRootFromParent_Done,
     /* 1900299 */   // Label 25580: @1900299
     /* 1900299 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1900385), // Rule ID 19346 //
     /* 1900304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900350 */     // MIs[0] policy
     /* 1900350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900360 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1900363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900384 */     // GIR_Coverage, 19346,
     /* 1900384 */     GIR_EraseRootFromParent_Done,
     /* 1900385 */   // Label 25581: @1900385
     /* 1900385 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1900471), // Rule ID 19347 //
     /* 1900390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900436 */     // MIs[0] policy
     /* 1900436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900446 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1900449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900470 */     // GIR_Coverage, 19347,
     /* 1900470 */     GIR_EraseRootFromParent_Done,
     /* 1900471 */   // Label 25582: @1900471
     /* 1900471 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1900557), // Rule ID 19350 //
     /* 1900476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900522 */     // MIs[0] policy
     /* 1900522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900532 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1900535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900556 */     // GIR_Coverage, 19350,
     /* 1900556 */     GIR_EraseRootFromParent_Done,
     /* 1900557 */   // Label 25583: @1900557
     /* 1900557 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1900643), // Rule ID 19351 //
     /* 1900562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900608 */     // MIs[0] policy
     /* 1900608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1900621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900642 */     // GIR_Coverage, 19351,
     /* 1900642 */     GIR_EraseRootFromParent_Done,
     /* 1900643 */   // Label 25584: @1900643
     /* 1900643 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1900729), // Rule ID 19354 //
     /* 1900648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1900668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1900690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900694 */     // MIs[0] policy
     /* 1900694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1900707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900728 */     // GIR_Coverage, 19354,
     /* 1900728 */     GIR_EraseRootFromParent_Done,
     /* 1900729 */   // Label 25585: @1900729
     /* 1900729 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1900815), // Rule ID 19355 //
     /* 1900734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1900754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1900776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900780 */     // MIs[0] policy
     /* 1900780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1900793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900814 */     // GIR_Coverage, 19355,
     /* 1900814 */     GIR_EraseRootFromParent_Done,
     /* 1900815 */   // Label 25586: @1900815
     /* 1900815 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1900901), // Rule ID 19358 //
     /* 1900820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900866 */     // MIs[0] policy
     /* 1900866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900876 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1900879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900900 */     // GIR_Coverage, 19358,
     /* 1900900 */     GIR_EraseRootFromParent_Done,
     /* 1900901 */   // Label 25587: @1900901
     /* 1900901 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1900987), // Rule ID 19359 //
     /* 1900906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1900926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1900948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900952 */     // MIs[0] policy
     /* 1900952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1900965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900986 */     // GIR_Coverage, 19359,
     /* 1900986 */     GIR_EraseRootFromParent_Done,
     /* 1900987 */   // Label 25588: @1900987
     /* 1900987 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1901073), // Rule ID 19362 //
     /* 1900992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901038 */     // MIs[0] policy
     /* 1901038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901048 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1901051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901072 */     // GIR_Coverage, 19362,
     /* 1901072 */     GIR_EraseRootFromParent_Done,
     /* 1901073 */   // Label 25589: @1901073
     /* 1901073 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1901159), // Rule ID 19363 //
     /* 1901078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901124 */     // MIs[0] policy
     /* 1901124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901134 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1901137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901158 */     // GIR_Coverage, 19363,
     /* 1901158 */     GIR_EraseRootFromParent_Done,
     /* 1901159 */   // Label 25590: @1901159
     /* 1901159 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1901245), // Rule ID 19366 //
     /* 1901164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1901167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1901184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1901206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901210 */     // MIs[0] policy
     /* 1901210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901220 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1901223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901244 */     // GIR_Coverage, 19366,
     /* 1901244 */     GIR_EraseRootFromParent_Done,
     /* 1901245 */   // Label 25591: @1901245
     /* 1901245 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1901331), // Rule ID 19367 //
     /* 1901250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1901253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1901270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1901292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901296 */     // MIs[0] policy
     /* 1901296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901306 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1901309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901330 */     // GIR_Coverage, 19367,
     /* 1901330 */     GIR_EraseRootFromParent_Done,
     /* 1901331 */   // Label 25592: @1901331
     /* 1901331 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1901417), // Rule ID 19370 //
     /* 1901336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901382 */     // MIs[0] policy
     /* 1901382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901392 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1901395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901416 */     // GIR_Coverage, 19370,
     /* 1901416 */     GIR_EraseRootFromParent_Done,
     /* 1901417 */   // Label 25593: @1901417
     /* 1901417 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1901503), // Rule ID 19371 //
     /* 1901422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901468 */     // MIs[0] policy
     /* 1901468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901478 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1901481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901502 */     // GIR_Coverage, 19371,
     /* 1901502 */     GIR_EraseRootFromParent_Done,
     /* 1901503 */   // Label 25594: @1901503
     /* 1901503 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1901589), // Rule ID 19374 //
     /* 1901508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901554 */     // MIs[0] policy
     /* 1901554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901564 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1901567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901588 */     // GIR_Coverage, 19374,
     /* 1901588 */     GIR_EraseRootFromParent_Done,
     /* 1901589 */   // Label 25595: @1901589
     /* 1901589 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1901675), // Rule ID 19375 //
     /* 1901594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901640 */     // MIs[0] policy
     /* 1901640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901650 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1901653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901674 */     // GIR_Coverage, 19375,
     /* 1901674 */     GIR_EraseRootFromParent_Done,
     /* 1901675 */   // Label 25596: @1901675
     /* 1901675 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1901761), // Rule ID 19378 //
     /* 1901680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901726 */     // MIs[0] policy
     /* 1901726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901736 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1901739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901760 */     // GIR_Coverage, 19378,
     /* 1901760 */     GIR_EraseRootFromParent_Done,
     /* 1901761 */   // Label 25597: @1901761
     /* 1901761 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1901847), // Rule ID 19379 //
     /* 1901766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901812 */     // MIs[0] policy
     /* 1901812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901822 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1901825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901846 */     // GIR_Coverage, 19379,
     /* 1901846 */     GIR_EraseRootFromParent_Done,
     /* 1901847 */   // Label 25598: @1901847
     /* 1901847 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1901933), // Rule ID 19382 //
     /* 1901852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901898 */     // MIs[0] policy
     /* 1901898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1901911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901932 */     // GIR_Coverage, 19382,
     /* 1901932 */     GIR_EraseRootFromParent_Done,
     /* 1901933 */   // Label 25599: @1901933
     /* 1901933 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1902019), // Rule ID 19383 //
     /* 1901938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901984 */     // MIs[0] policy
     /* 1901984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1901997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902018 */     // GIR_Coverage, 19383,
     /* 1902018 */     GIR_EraseRootFromParent_Done,
     /* 1902019 */   // Label 25600: @1902019
     /* 1902019 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1902105), // Rule ID 19386 //
     /* 1902024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902070 */     // MIs[0] policy
     /* 1902070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902080 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1902083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902104 */     // GIR_Coverage, 19386,
     /* 1902104 */     GIR_EraseRootFromParent_Done,
     /* 1902105 */   // Label 25601: @1902105
     /* 1902105 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1902191), // Rule ID 19387 //
     /* 1902110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902156 */     // MIs[0] policy
     /* 1902156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902166 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1902169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902190 */     // GIR_Coverage, 19387,
     /* 1902190 */     GIR_EraseRootFromParent_Done,
     /* 1902191 */   // Label 25602: @1902191
     /* 1902191 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1902277), // Rule ID 19390 //
     /* 1902196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902242 */     // MIs[0] policy
     /* 1902242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902252 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1902255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902276 */     // GIR_Coverage, 19390,
     /* 1902276 */     GIR_EraseRootFromParent_Done,
     /* 1902277 */   // Label 25603: @1902277
     /* 1902277 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1902363), // Rule ID 19391 //
     /* 1902282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1902293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1902296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1902299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902328 */     // MIs[0] policy
     /* 1902328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1902341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902362 */     // GIR_Coverage, 19391,
     /* 1902362 */     GIR_EraseRootFromParent_Done,
     /* 1902363 */   // Label 25604: @1902363
     /* 1902363 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1902449), // Rule ID 19394 //
     /* 1902368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902414 */     // MIs[0] policy
     /* 1902414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1902427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902448 */     // GIR_Coverage, 19394,
     /* 1902448 */     GIR_EraseRootFromParent_Done,
     /* 1902449 */   // Label 25605: @1902449
     /* 1902449 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1902535), // Rule ID 19395 //
     /* 1902454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902500 */     // MIs[0] policy
     /* 1902500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1902513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902534 */     // GIR_Coverage, 19395,
     /* 1902534 */     GIR_EraseRootFromParent_Done,
     /* 1902535 */   // Label 25606: @1902535
     /* 1902535 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1902621), // Rule ID 19398 //
     /* 1902540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902586 */     // MIs[0] policy
     /* 1902586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902596 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1902599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902620 */     // GIR_Coverage, 19398,
     /* 1902620 */     GIR_EraseRootFromParent_Done,
     /* 1902621 */   // Label 25607: @1902621
     /* 1902621 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1902707), // Rule ID 19399 //
     /* 1902626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902672 */     // MIs[0] policy
     /* 1902672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902682 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1902685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902706 */     // GIR_Coverage, 19399,
     /* 1902706 */     GIR_EraseRootFromParent_Done,
     /* 1902707 */   // Label 25608: @1902707
     /* 1902707 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1902793), // Rule ID 19402 //
     /* 1902712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902758 */     // MIs[0] policy
     /* 1902758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902768 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1902771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902792 */     // GIR_Coverage, 19402,
     /* 1902792 */     GIR_EraseRootFromParent_Done,
     /* 1902793 */   // Label 25609: @1902793
     /* 1902793 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1902879), // Rule ID 19403 //
     /* 1902798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902844 */     // MIs[0] policy
     /* 1902844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902854 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1902857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902878 */     // GIR_Coverage, 19403,
     /* 1902878 */     GIR_EraseRootFromParent_Done,
     /* 1902879 */   // Label 25610: @1902879
     /* 1902879 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1902965), // Rule ID 19406 //
     /* 1902884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1902904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902930 */     // MIs[0] policy
     /* 1902930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902940 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1902943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902964 */     // GIR_Coverage, 19406,
     /* 1902964 */     GIR_EraseRootFromParent_Done,
     /* 1902965 */   // Label 25611: @1902965
     /* 1902965 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1903051), // Rule ID 19407 //
     /* 1902970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1902990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903016 */     // MIs[0] policy
     /* 1903016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903026 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1903029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903050 */     // GIR_Coverage, 19407,
     /* 1903050 */     GIR_EraseRootFromParent_Done,
     /* 1903051 */   // Label 25612: @1903051
     /* 1903051 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1903137), // Rule ID 19410 //
     /* 1903056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1903076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903102 */     // MIs[0] policy
     /* 1903102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903112 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1903115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903136 */     // GIR_Coverage, 19410,
     /* 1903136 */     GIR_EraseRootFromParent_Done,
     /* 1903137 */   // Label 25613: @1903137
     /* 1903137 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1903223), // Rule ID 19411 //
     /* 1903142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1903162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903188 */     // MIs[0] policy
     /* 1903188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903198 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1903201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903222 */     // GIR_Coverage, 19411,
     /* 1903222 */     GIR_EraseRootFromParent_Done,
     /* 1903223 */   // Label 25614: @1903223
     /* 1903223 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1903309), // Rule ID 19414 //
     /* 1903228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1903248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903274 */     // MIs[0] policy
     /* 1903274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903284 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1903287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903308 */     // GIR_Coverage, 19414,
     /* 1903308 */     GIR_EraseRootFromParent_Done,
     /* 1903309 */   // Label 25615: @1903309
     /* 1903309 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1903395), // Rule ID 19415 //
     /* 1903314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1903325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1903328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1903331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1903334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903360 */     // MIs[0] policy
     /* 1903360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1903373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903394 */     // GIR_Coverage, 19415,
     /* 1903394 */     GIR_EraseRootFromParent_Done,
     /* 1903395 */   // Label 25616: @1903395
     /* 1903395 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1903481), // Rule ID 19418 //
     /* 1903400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1903420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903446 */     // MIs[0] policy
     /* 1903446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1903459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903480 */     // GIR_Coverage, 19418,
     /* 1903480 */     GIR_EraseRootFromParent_Done,
     /* 1903481 */   // Label 25617: @1903481
     /* 1903481 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1903567), // Rule ID 19419 //
     /* 1903486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1903506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903532 */     // MIs[0] policy
     /* 1903532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1903545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903566 */     // GIR_Coverage, 19419,
     /* 1903566 */     GIR_EraseRootFromParent_Done,
     /* 1903567 */   // Label 25618: @1903567
     /* 1903567 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1903653), // Rule ID 19422 //
     /* 1903572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1903592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903618 */     // MIs[0] policy
     /* 1903618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903628 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1903631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903652 */     // GIR_Coverage, 19422,
     /* 1903652 */     GIR_EraseRootFromParent_Done,
     /* 1903653 */   // Label 25619: @1903653
     /* 1903653 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1903739), // Rule ID 19423 //
     /* 1903658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1903678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903704 */     // MIs[0] policy
     /* 1903704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1903717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903738 */     // GIR_Coverage, 19423,
     /* 1903738 */     GIR_EraseRootFromParent_Done,
     /* 1903739 */   // Label 25620: @1903739
     /* 1903739 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1903825), // Rule ID 19426 //
     /* 1903744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903790 */     // MIs[0] policy
     /* 1903790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1903803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903824 */     // GIR_Coverage, 19426,
     /* 1903824 */     GIR_EraseRootFromParent_Done,
     /* 1903825 */   // Label 25621: @1903825
     /* 1903825 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1903911), // Rule ID 19427 //
     /* 1903830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1903850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903876 */     // MIs[0] policy
     /* 1903876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1903889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903910 */     // GIR_Coverage, 19427,
     /* 1903910 */     GIR_EraseRootFromParent_Done,
     /* 1903911 */   // Label 25622: @1903911
     /* 1903911 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1903997), // Rule ID 19430 //
     /* 1903916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1903927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1903930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1903933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1903936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903962 */     // MIs[0] policy
     /* 1903962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903972 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1903975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903996 */     // GIR_Coverage, 19430,
     /* 1903996 */     GIR_EraseRootFromParent_Done,
     /* 1903997 */   // Label 25623: @1903997
     /* 1903997 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1904083), // Rule ID 19431 //
     /* 1904002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1904022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904048 */     // MIs[0] policy
     /* 1904048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904058 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1904061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904082 */     // GIR_Coverage, 19431,
     /* 1904082 */     GIR_EraseRootFromParent_Done,
     /* 1904083 */   // Label 25624: @1904083
     /* 1904083 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1904169), // Rule ID 19434 //
     /* 1904088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1904108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904134 */     // MIs[0] policy
     /* 1904134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1904147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904168 */     // GIR_Coverage, 19434,
     /* 1904168 */     GIR_EraseRootFromParent_Done,
     /* 1904169 */   // Label 25625: @1904169
     /* 1904169 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1904255), // Rule ID 19435 //
     /* 1904174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1904194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904220 */     // MIs[0] policy
     /* 1904220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904230 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1904233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904254 */     // GIR_Coverage, 19435,
     /* 1904254 */     GIR_EraseRootFromParent_Done,
     /* 1904255 */   // Label 25626: @1904255
     /* 1904255 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1904341), // Rule ID 19438 //
     /* 1904260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1904280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904306 */     // MIs[0] policy
     /* 1904306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904316 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1904319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904340 */     // GIR_Coverage, 19438,
     /* 1904340 */     GIR_EraseRootFromParent_Done,
     /* 1904341 */   // Label 25627: @1904341
     /* 1904341 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1904427), // Rule ID 19439 //
     /* 1904346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1904366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904392 */     // MIs[0] policy
     /* 1904392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904402 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1904405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904426 */     // GIR_Coverage, 19439,
     /* 1904426 */     GIR_EraseRootFromParent_Done,
     /* 1904427 */   // Label 25628: @1904427
     /* 1904427 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1904513), // Rule ID 19442 //
     /* 1904432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1904452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904478 */     // MIs[0] policy
     /* 1904478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904488 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1904491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904512 */     // GIR_Coverage, 19442,
     /* 1904512 */     GIR_EraseRootFromParent_Done,
     /* 1904513 */   // Label 25629: @1904513
     /* 1904513 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1904599), // Rule ID 19443 //
     /* 1904518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1904538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904564 */     // MIs[0] policy
     /* 1904564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904574 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1904577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904598 */     // GIR_Coverage, 19443,
     /* 1904598 */     GIR_EraseRootFromParent_Done,
     /* 1904599 */   // Label 25630: @1904599
     /* 1904599 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1904685), // Rule ID 19446 //
     /* 1904604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1904624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904650 */     // MIs[0] policy
     /* 1904650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1904663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904684 */     // GIR_Coverage, 19446,
     /* 1904684 */     GIR_EraseRootFromParent_Done,
     /* 1904685 */   // Label 25631: @1904685
     /* 1904685 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1904771), // Rule ID 19447 //
     /* 1904690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1904710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904736 */     // MIs[0] policy
     /* 1904736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904746 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1904749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904770 */     // GIR_Coverage, 19447,
     /* 1904770 */     GIR_EraseRootFromParent_Done,
     /* 1904771 */   // Label 25632: @1904771
     /* 1904771 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1904857), // Rule ID 19450 //
     /* 1904776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1904796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904822 */     // MIs[0] policy
     /* 1904822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904832 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1904835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904856 */     // GIR_Coverage, 19450,
     /* 1904856 */     GIR_EraseRootFromParent_Done,
     /* 1904857 */   // Label 25633: @1904857
     /* 1904857 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1904943), // Rule ID 19451 //
     /* 1904862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1904882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904908 */     // MIs[0] policy
     /* 1904908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904918 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1904921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904942 */     // GIR_Coverage, 19451,
     /* 1904942 */     GIR_EraseRootFromParent_Done,
     /* 1904943 */   // Label 25634: @1904943
     /* 1904943 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1905029), // Rule ID 19454 //
     /* 1904948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1904956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1904959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1904962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1904965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1904968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904994 */     // MIs[0] policy
     /* 1904994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1905007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905028 */     // GIR_Coverage, 19454,
     /* 1905028 */     GIR_EraseRootFromParent_Done,
     /* 1905029 */   // Label 25635: @1905029
     /* 1905029 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1905115), // Rule ID 19455 //
     /* 1905034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1905054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905080 */     // MIs[0] policy
     /* 1905080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1905093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905114 */     // GIR_Coverage, 19455,
     /* 1905114 */     GIR_EraseRootFromParent_Done,
     /* 1905115 */   // Label 25636: @1905115
     /* 1905115 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1905201), // Rule ID 19458 //
     /* 1905120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1905140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905166 */     // MIs[0] policy
     /* 1905166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905176 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1905179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905200 */     // GIR_Coverage, 19458,
     /* 1905200 */     GIR_EraseRootFromParent_Done,
     /* 1905201 */   // Label 25637: @1905201
     /* 1905201 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1905287), // Rule ID 19459 //
     /* 1905206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1905226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905252 */     // MIs[0] policy
     /* 1905252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905262 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1905265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905286 */     // GIR_Coverage, 19459,
     /* 1905286 */     GIR_EraseRootFromParent_Done,
     /* 1905287 */   // Label 25638: @1905287
     /* 1905287 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1905373), // Rule ID 19462 //
     /* 1905292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1905312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905338 */     // MIs[0] policy
     /* 1905338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905348 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1905351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905372 */     // GIR_Coverage, 19462,
     /* 1905372 */     GIR_EraseRootFromParent_Done,
     /* 1905373 */   // Label 25639: @1905373
     /* 1905373 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1905459), // Rule ID 19463 //
     /* 1905378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1905398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905424 */     // MIs[0] policy
     /* 1905424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905434 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1905437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905458 */     // GIR_Coverage, 19463,
     /* 1905458 */     GIR_EraseRootFromParent_Done,
     /* 1905459 */   // Label 25640: @1905459
     /* 1905459 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1905545), // Rule ID 19466 //
     /* 1905464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1905484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1905506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905510 */     // MIs[0] policy
     /* 1905510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905520 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1905523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905544 */     // GIR_Coverage, 19466,
     /* 1905544 */     GIR_EraseRootFromParent_Done,
     /* 1905545 */   // Label 25641: @1905545
     /* 1905545 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1905631), // Rule ID 19467 //
     /* 1905550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1905570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1905592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905596 */     // MIs[0] policy
     /* 1905596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1905609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905630 */     // GIR_Coverage, 19467,
     /* 1905630 */     GIR_EraseRootFromParent_Done,
     /* 1905631 */   // Label 25642: @1905631
     /* 1905631 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1905717), // Rule ID 19470 //
     /* 1905636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1905656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1905678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905682 */     // MIs[0] policy
     /* 1905682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1905695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905716 */     // GIR_Coverage, 19470,
     /* 1905716 */     GIR_EraseRootFromParent_Done,
     /* 1905717 */   // Label 25643: @1905717
     /* 1905717 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1905803), // Rule ID 19471 //
     /* 1905722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1905742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1905764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905768 */     // MIs[0] policy
     /* 1905768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905778 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1905781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905802 */     // GIR_Coverage, 19471,
     /* 1905802 */     GIR_EraseRootFromParent_Done,
     /* 1905803 */   // Label 25644: @1905803
     /* 1905803 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1905889), // Rule ID 19474 //
     /* 1905808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1905828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1905850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905854 */     // MIs[0] policy
     /* 1905854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1905867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905888 */     // GIR_Coverage, 19474,
     /* 1905888 */     GIR_EraseRootFromParent_Done,
     /* 1905889 */   // Label 25645: @1905889
     /* 1905889 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1905975), // Rule ID 19475 //
     /* 1905894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1905914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1905936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905940 */     // MIs[0] policy
     /* 1905940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905950 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1905953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905974 */     // GIR_Coverage, 19475,
     /* 1905974 */     GIR_EraseRootFromParent_Done,
     /* 1905975 */   // Label 25646: @1905975
     /* 1905975 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1906061), // Rule ID 19478 //
     /* 1905980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1905997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906026 */     // MIs[0] policy
     /* 1906026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906036 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1906039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906060 */     // GIR_Coverage, 19478,
     /* 1906060 */     GIR_EraseRootFromParent_Done,
     /* 1906061 */   // Label 25647: @1906061
     /* 1906061 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1906147), // Rule ID 19479 //
     /* 1906066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906112 */     // MIs[0] policy
     /* 1906112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906122 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1906125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906146 */     // GIR_Coverage, 19479,
     /* 1906146 */     GIR_EraseRootFromParent_Done,
     /* 1906147 */   // Label 25648: @1906147
     /* 1906147 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1906233), // Rule ID 19482 //
     /* 1906152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906198 */     // MIs[0] policy
     /* 1906198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906208 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1906211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906232 */     // GIR_Coverage, 19482,
     /* 1906232 */     GIR_EraseRootFromParent_Done,
     /* 1906233 */   // Label 25649: @1906233
     /* 1906233 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1906319), // Rule ID 19483 //
     /* 1906238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906284 */     // MIs[0] policy
     /* 1906284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1906297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906318 */     // GIR_Coverage, 19483,
     /* 1906318 */     GIR_EraseRootFromParent_Done,
     /* 1906319 */   // Label 25650: @1906319
     /* 1906319 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1906405), // Rule ID 19486 //
     /* 1906324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1906344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1906366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906370 */     // MIs[0] policy
     /* 1906370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906380 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1906383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906404 */     // GIR_Coverage, 19486,
     /* 1906404 */     GIR_EraseRootFromParent_Done,
     /* 1906405 */   // Label 25651: @1906405
     /* 1906405 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1906491), // Rule ID 19487 //
     /* 1906410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1906430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1906452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906456 */     // MIs[0] policy
     /* 1906456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906466 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1906469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906490 */     // GIR_Coverage, 19487,
     /* 1906490 */     GIR_EraseRootFromParent_Done,
     /* 1906491 */   // Label 25652: @1906491
     /* 1906491 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1906577), // Rule ID 19490 //
     /* 1906496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906542 */     // MIs[0] policy
     /* 1906542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1906555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906576 */     // GIR_Coverage, 19490,
     /* 1906576 */     GIR_EraseRootFromParent_Done,
     /* 1906577 */   // Label 25653: @1906577
     /* 1906577 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1906663), // Rule ID 19491 //
     /* 1906582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906628 */     // MIs[0] policy
     /* 1906628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906638 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1906641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906662 */     // GIR_Coverage, 19491,
     /* 1906662 */     GIR_EraseRootFromParent_Done,
     /* 1906663 */   // Label 25654: @1906663
     /* 1906663 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1906749), // Rule ID 19494 //
     /* 1906668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906714 */     // MIs[0] policy
     /* 1906714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906724 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1906727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906748 */     // GIR_Coverage, 19494,
     /* 1906748 */     GIR_EraseRootFromParent_Done,
     /* 1906749 */   // Label 25655: @1906749
     /* 1906749 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1906835), // Rule ID 19495 //
     /* 1906754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906800 */     // MIs[0] policy
     /* 1906800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906810 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1906813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906834 */     // GIR_Coverage, 19495,
     /* 1906834 */     GIR_EraseRootFromParent_Done,
     /* 1906835 */   // Label 25656: @1906835
     /* 1906835 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1906921), // Rule ID 19498 //
     /* 1906840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906886 */     // MIs[0] policy
     /* 1906886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906896 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1906899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906920 */     // GIR_Coverage, 19498,
     /* 1906920 */     GIR_EraseRootFromParent_Done,
     /* 1906921 */   // Label 25657: @1906921
     /* 1906921 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1907007), // Rule ID 19499 //
     /* 1906926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906972 */     // MIs[0] policy
     /* 1906972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1906985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907006 */     // GIR_Coverage, 19499,
     /* 1907006 */     GIR_EraseRootFromParent_Done,
     /* 1907007 */   // Label 25658: @1907007
     /* 1907007 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1907093), // Rule ID 19502 //
     /* 1907012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907058 */     // MIs[0] policy
     /* 1907058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1907071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907092 */     // GIR_Coverage, 19502,
     /* 1907092 */     GIR_EraseRootFromParent_Done,
     /* 1907093 */   // Label 25659: @1907093
     /* 1907093 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1907179), // Rule ID 19503 //
     /* 1907098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907144 */     // MIs[0] policy
     /* 1907144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907154 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1907157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907178 */     // GIR_Coverage, 19503,
     /* 1907178 */     GIR_EraseRootFromParent_Done,
     /* 1907179 */   // Label 25660: @1907179
     /* 1907179 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1907265), // Rule ID 19506 //
     /* 1907184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907230 */     // MIs[0] policy
     /* 1907230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1907243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907264 */     // GIR_Coverage, 19506,
     /* 1907264 */     GIR_EraseRootFromParent_Done,
     /* 1907265 */   // Label 25661: @1907265
     /* 1907265 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1907351), // Rule ID 19507 //
     /* 1907270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1907281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1907284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1907287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907316 */     // MIs[0] policy
     /* 1907316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907326 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1907329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907350 */     // GIR_Coverage, 19507,
     /* 1907350 */     GIR_EraseRootFromParent_Done,
     /* 1907351 */   // Label 25662: @1907351
     /* 1907351 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1907437), // Rule ID 19510 //
     /* 1907356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907402 */     // MIs[0] policy
     /* 1907402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907412 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1907415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907436 */     // GIR_Coverage, 19510,
     /* 1907436 */     GIR_EraseRootFromParent_Done,
     /* 1907437 */   // Label 25663: @1907437
     /* 1907437 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1907523), // Rule ID 19511 //
     /* 1907442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907488 */     // MIs[0] policy
     /* 1907488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907498 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1907501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907522 */     // GIR_Coverage, 19511,
     /* 1907522 */     GIR_EraseRootFromParent_Done,
     /* 1907523 */   // Label 25664: @1907523
     /* 1907523 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1907609), // Rule ID 19514 //
     /* 1907528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907574 */     // MIs[0] policy
     /* 1907574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1907587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907608 */     // GIR_Coverage, 19514,
     /* 1907608 */     GIR_EraseRootFromParent_Done,
     /* 1907609 */   // Label 25665: @1907609
     /* 1907609 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1907695), // Rule ID 19515 //
     /* 1907614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907660 */     // MIs[0] policy
     /* 1907660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907670 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1907673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907694 */     // GIR_Coverage, 19515,
     /* 1907694 */     GIR_EraseRootFromParent_Done,
     /* 1907695 */   // Label 25666: @1907695
     /* 1907695 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1907781), // Rule ID 19518 //
     /* 1907700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907746 */     // MIs[0] policy
     /* 1907746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1907759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907780 */     // GIR_Coverage, 19518,
     /* 1907780 */     GIR_EraseRootFromParent_Done,
     /* 1907781 */   // Label 25667: @1907781
     /* 1907781 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1907867), // Rule ID 19519 //
     /* 1907786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907832 */     // MIs[0] policy
     /* 1907832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907842 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1907845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907866 */     // GIR_Coverage, 19519,
     /* 1907866 */     GIR_EraseRootFromParent_Done,
     /* 1907867 */   // Label 25668: @1907867
     /* 1907867 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1907953), // Rule ID 19522 //
     /* 1907872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907918 */     // MIs[0] policy
     /* 1907918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907928 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1907931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907952 */     // GIR_Coverage, 19522,
     /* 1907952 */     GIR_EraseRootFromParent_Done,
     /* 1907953 */   // Label 25669: @1907953
     /* 1907953 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1908039), // Rule ID 19523 //
     /* 1907958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908004 */     // MIs[0] policy
     /* 1908004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908014 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1908017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908038 */     // GIR_Coverage, 19523,
     /* 1908038 */     GIR_EraseRootFromParent_Done,
     /* 1908039 */   // Label 25670: @1908039
     /* 1908039 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1908125), // Rule ID 19526 //
     /* 1908044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1908064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908090 */     // MIs[0] policy
     /* 1908090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908100 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1908103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908124 */     // GIR_Coverage, 19526,
     /* 1908124 */     GIR_EraseRootFromParent_Done,
     /* 1908125 */   // Label 25671: @1908125
     /* 1908125 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1908211), // Rule ID 19527 //
     /* 1908130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1908150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908176 */     // MIs[0] policy
     /* 1908176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1908189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908210 */     // GIR_Coverage, 19527,
     /* 1908210 */     GIR_EraseRootFromParent_Done,
     /* 1908211 */   // Label 25672: @1908211
     /* 1908211 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1908297), // Rule ID 19530 //
     /* 1908216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1908236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908262 */     // MIs[0] policy
     /* 1908262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908272 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1908275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908296 */     // GIR_Coverage, 19530,
     /* 1908296 */     GIR_EraseRootFromParent_Done,
     /* 1908297 */   // Label 25673: @1908297
     /* 1908297 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1908383), // Rule ID 19531 //
     /* 1908302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1908313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1908316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1908319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1908322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908348 */     // MIs[0] policy
     /* 1908348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908358 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1908361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908382 */     // GIR_Coverage, 19531,
     /* 1908382 */     GIR_EraseRootFromParent_Done,
     /* 1908383 */   // Label 25674: @1908383
     /* 1908383 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1908469), // Rule ID 19534 //
     /* 1908388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1908408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908434 */     // MIs[0] policy
     /* 1908434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1908447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908468 */     // GIR_Coverage, 19534,
     /* 1908468 */     GIR_EraseRootFromParent_Done,
     /* 1908469 */   // Label 25675: @1908469
     /* 1908469 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1908555), // Rule ID 19535 //
     /* 1908474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1908494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908520 */     // MIs[0] policy
     /* 1908520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908530 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1908533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908554 */     // GIR_Coverage, 19535,
     /* 1908554 */     GIR_EraseRootFromParent_Done,
     /* 1908555 */   // Label 25676: @1908555
     /* 1908555 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1908641), // Rule ID 19538 //
     /* 1908560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1908580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908606 */     // MIs[0] policy
     /* 1908606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1908619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908640 */     // GIR_Coverage, 19538,
     /* 1908640 */     GIR_EraseRootFromParent_Done,
     /* 1908641 */   // Label 25677: @1908641
     /* 1908641 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1908727), // Rule ID 19539 //
     /* 1908646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1908666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908692 */     // MIs[0] policy
     /* 1908692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1908705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908726 */     // GIR_Coverage, 19539,
     /* 1908726 */     GIR_EraseRootFromParent_Done,
     /* 1908727 */   // Label 25678: @1908727
     /* 1908727 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1908813), // Rule ID 19542 //
     /* 1908732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908778 */     // MIs[0] policy
     /* 1908778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908788 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1908791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908812 */     // GIR_Coverage, 19542,
     /* 1908812 */     GIR_EraseRootFromParent_Done,
     /* 1908813 */   // Label 25679: @1908813
     /* 1908813 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1908899), // Rule ID 19543 //
     /* 1908818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1908838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908864 */     // MIs[0] policy
     /* 1908864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1908877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908898 */     // GIR_Coverage, 19543,
     /* 1908898 */     GIR_EraseRootFromParent_Done,
     /* 1908899 */   // Label 25680: @1908899
     /* 1908899 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1908985), // Rule ID 19546 //
     /* 1908904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1908921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1908924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908950 */     // MIs[0] policy
     /* 1908950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1908963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908984 */     // GIR_Coverage, 19546,
     /* 1908984 */     GIR_EraseRootFromParent_Done,
     /* 1908985 */   // Label 25681: @1908985
     /* 1908985 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1909071), // Rule ID 19547 //
     /* 1908990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909036 */     // MIs[0] policy
     /* 1909036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909046 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1909049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909070 */     // GIR_Coverage, 19547,
     /* 1909070 */     GIR_EraseRootFromParent_Done,
     /* 1909071 */   // Label 25682: @1909071
     /* 1909071 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1909157), // Rule ID 19550 //
     /* 1909076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1909096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909122 */     // MIs[0] policy
     /* 1909122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1909135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909156 */     // GIR_Coverage, 19550,
     /* 1909156 */     GIR_EraseRootFromParent_Done,
     /* 1909157 */   // Label 25683: @1909157
     /* 1909157 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1909243), // Rule ID 19551 //
     /* 1909162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1909182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909208 */     // MIs[0] policy
     /* 1909208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909218 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1909221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909242 */     // GIR_Coverage, 19551,
     /* 1909242 */     GIR_EraseRootFromParent_Done,
     /* 1909243 */   // Label 25684: @1909243
     /* 1909243 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1909329), // Rule ID 19554 //
     /* 1909248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1909268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909294 */     // MIs[0] policy
     /* 1909294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909304 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1909307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909328 */     // GIR_Coverage, 19554,
     /* 1909328 */     GIR_EraseRootFromParent_Done,
     /* 1909329 */   // Label 25685: @1909329
     /* 1909329 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1909415), // Rule ID 19555 //
     /* 1909334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1909345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1909354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909380 */     // MIs[0] policy
     /* 1909380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909390 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1909393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909414 */     // GIR_Coverage, 19555,
     /* 1909414 */     GIR_EraseRootFromParent_Done,
     /* 1909415 */   // Label 25686: @1909415
     /* 1909415 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1909501), // Rule ID 19558 //
     /* 1909420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1909440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909466 */     // MIs[0] policy
     /* 1909466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1909479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909500 */     // GIR_Coverage, 19558,
     /* 1909500 */     GIR_EraseRootFromParent_Done,
     /* 1909501 */   // Label 25687: @1909501
     /* 1909501 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1909587), // Rule ID 19559 //
     /* 1909506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1909526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909552 */     // MIs[0] policy
     /* 1909552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909562 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1909565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909586 */     // GIR_Coverage, 19559,
     /* 1909586 */     GIR_EraseRootFromParent_Done,
     /* 1909587 */   // Label 25688: @1909587
     /* 1909587 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1909673), // Rule ID 19562 //
     /* 1909592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1909612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909638 */     // MIs[0] policy
     /* 1909638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1909651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909672 */     // GIR_Coverage, 19562,
     /* 1909672 */     GIR_EraseRootFromParent_Done,
     /* 1909673 */   // Label 25689: @1909673
     /* 1909673 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1909759), // Rule ID 19563 //
     /* 1909678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1909698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909724 */     // MIs[0] policy
     /* 1909724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1909737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909758 */     // GIR_Coverage, 19563,
     /* 1909758 */     GIR_EraseRootFromParent_Done,
     /* 1909759 */   // Label 25690: @1909759
     /* 1909759 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1909845), // Rule ID 19566 //
     /* 1909764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1909784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909810 */     // MIs[0] policy
     /* 1909810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1909823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909844 */     // GIR_Coverage, 19566,
     /* 1909844 */     GIR_EraseRootFromParent_Done,
     /* 1909845 */   // Label 25691: @1909845
     /* 1909845 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1909931), // Rule ID 19567 //
     /* 1909850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1909870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909896 */     // MIs[0] policy
     /* 1909896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1909909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909930 */     // GIR_Coverage, 19567,
     /* 1909930 */     GIR_EraseRootFromParent_Done,
     /* 1909931 */   // Label 25692: @1909931
     /* 1909931 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1910017), // Rule ID 19570 //
     /* 1909936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1909944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1909947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1909950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1909953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1909956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909982 */     // MIs[0] policy
     /* 1909982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909992 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1909995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910016 */     // GIR_Coverage, 19570,
     /* 1910016 */     GIR_EraseRootFromParent_Done,
     /* 1910017 */   // Label 25693: @1910017
     /* 1910017 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1910103), // Rule ID 19571 //
     /* 1910022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1910042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910068 */     // MIs[0] policy
     /* 1910068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910078 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1910081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910102 */     // GIR_Coverage, 19571,
     /* 1910102 */     GIR_EraseRootFromParent_Done,
     /* 1910103 */   // Label 25694: @1910103
     /* 1910103 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1910189), // Rule ID 19574 //
     /* 1910108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1910128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910154 */     // MIs[0] policy
     /* 1910154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910164 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1910167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910188 */     // GIR_Coverage, 19574,
     /* 1910188 */     GIR_EraseRootFromParent_Done,
     /* 1910189 */   // Label 25695: @1910189
     /* 1910189 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1910275), // Rule ID 19575 //
     /* 1910194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1910214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910240 */     // MIs[0] policy
     /* 1910240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1910253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910274 */     // GIR_Coverage, 19575,
     /* 1910274 */     GIR_EraseRootFromParent_Done,
     /* 1910275 */   // Label 25696: @1910275
     /* 1910275 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1910361), // Rule ID 19578 //
     /* 1910280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1910300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910326 */     // MIs[0] policy
     /* 1910326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1910339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910360 */     // GIR_Coverage, 19578,
     /* 1910360 */     GIR_EraseRootFromParent_Done,
     /* 1910361 */   // Label 25697: @1910361
     /* 1910361 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1910447), // Rule ID 19579 //
     /* 1910366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1910386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910412 */     // MIs[0] policy
     /* 1910412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1910425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910446 */     // GIR_Coverage, 19579,
     /* 1910446 */     GIR_EraseRootFromParent_Done,
     /* 1910447 */   // Label 25698: @1910447
     /* 1910447 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1910533), // Rule ID 19582 //
     /* 1910452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1910472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910498 */     // MIs[0] policy
     /* 1910498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910508 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1910511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910532 */     // GIR_Coverage, 19582,
     /* 1910532 */     GIR_EraseRootFromParent_Done,
     /* 1910533 */   // Label 25699: @1910533
     /* 1910533 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1910619), // Rule ID 19583 //
     /* 1910538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1910558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910584 */     // MIs[0] policy
     /* 1910584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910594 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1910597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910618 */     // GIR_Coverage, 19583,
     /* 1910618 */     GIR_EraseRootFromParent_Done,
     /* 1910619 */   // Label 25700: @1910619
     /* 1910619 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1910705), // Rule ID 19586 //
     /* 1910624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1910644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1910666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910670 */     // MIs[0] policy
     /* 1910670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910680 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1910683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910704 */     // GIR_Coverage, 19586,
     /* 1910704 */     GIR_EraseRootFromParent_Done,
     /* 1910705 */   // Label 25701: @1910705
     /* 1910705 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1910791), // Rule ID 19587 //
     /* 1910710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1910730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1910752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910756 */     // MIs[0] policy
     /* 1910756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910766 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1910769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910790 */     // GIR_Coverage, 19587,
     /* 1910790 */     GIR_EraseRootFromParent_Done,
     /* 1910791 */   // Label 25702: @1910791
     /* 1910791 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1910877), // Rule ID 19590 //
     /* 1910796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1910816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1910838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910842 */     // MIs[0] policy
     /* 1910842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910852 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1910855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910876 */     // GIR_Coverage, 19590,
     /* 1910876 */     GIR_EraseRootFromParent_Done,
     /* 1910877 */   // Label 25703: @1910877
     /* 1910877 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1910963), // Rule ID 19591 //
     /* 1910882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1910902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1910924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910928 */     // MIs[0] policy
     /* 1910928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910938 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1910941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910962 */     // GIR_Coverage, 19591,
     /* 1910962 */     GIR_EraseRootFromParent_Done,
     /* 1910963 */   // Label 25704: @1910963
     /* 1910963 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1911049), // Rule ID 19594 //
     /* 1910968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1910979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1910982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1910985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1910988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911014 */     // MIs[0] policy
     /* 1911014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1911027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911048 */     // GIR_Coverage, 19594,
     /* 1911048 */     GIR_EraseRootFromParent_Done,
     /* 1911049 */   // Label 25705: @1911049
     /* 1911049 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1911135), // Rule ID 19595 //
     /* 1911054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911100 */     // MIs[0] policy
     /* 1911100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911110 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1911113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911134 */     // GIR_Coverage, 19595,
     /* 1911134 */     GIR_EraseRootFromParent_Done,
     /* 1911135 */   // Label 25706: @1911135
     /* 1911135 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1911221), // Rule ID 19598 //
     /* 1911140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911186 */     // MIs[0] policy
     /* 1911186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1911199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911220 */     // GIR_Coverage, 19598,
     /* 1911220 */     GIR_EraseRootFromParent_Done,
     /* 1911221 */   // Label 25707: @1911221
     /* 1911221 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1911307), // Rule ID 19599 //
     /* 1911226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911272 */     // MIs[0] policy
     /* 1911272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911282 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1911285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911306 */     // GIR_Coverage, 19599,
     /* 1911306 */     GIR_EraseRootFromParent_Done,
     /* 1911307 */   // Label 25708: @1911307
     /* 1911307 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1911393), // Rule ID 19602 //
     /* 1911312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911358 */     // MIs[0] policy
     /* 1911358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911368 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1911371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911392 */     // GIR_Coverage, 19602,
     /* 1911392 */     GIR_EraseRootFromParent_Done,
     /* 1911393 */   // Label 25709: @1911393
     /* 1911393 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1911479), // Rule ID 19603 //
     /* 1911398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911444 */     // MIs[0] policy
     /* 1911444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1911457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911478 */     // GIR_Coverage, 19603,
     /* 1911478 */     GIR_EraseRootFromParent_Done,
     /* 1911479 */   // Label 25710: @1911479
     /* 1911479 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1911565), // Rule ID 19606 //
     /* 1911484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1911526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911530 */     // MIs[0] policy
     /* 1911530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1911543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911564 */     // GIR_Coverage, 19606,
     /* 1911564 */     GIR_EraseRootFromParent_Done,
     /* 1911565 */   // Label 25711: @1911565
     /* 1911565 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1911651), // Rule ID 19607 //
     /* 1911570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1911590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1911612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911616 */     // MIs[0] policy
     /* 1911616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911626 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1911629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911650 */     // GIR_Coverage, 19607,
     /* 1911650 */     GIR_EraseRootFromParent_Done,
     /* 1911651 */   // Label 25712: @1911651
     /* 1911651 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1911737), // Rule ID 19610 //
     /* 1911656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911702 */     // MIs[0] policy
     /* 1911702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911712 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1911715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911736 */     // GIR_Coverage, 19610,
     /* 1911736 */     GIR_EraseRootFromParent_Done,
     /* 1911737 */   // Label 25713: @1911737
     /* 1911737 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1911823), // Rule ID 19611 //
     /* 1911742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911788 */     // MIs[0] policy
     /* 1911788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1911801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911822 */     // GIR_Coverage, 19611,
     /* 1911822 */     GIR_EraseRootFromParent_Done,
     /* 1911823 */   // Label 25714: @1911823
     /* 1911823 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1911909), // Rule ID 19614 //
     /* 1911828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911874 */     // MIs[0] policy
     /* 1911874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911884 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1911887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911908 */     // GIR_Coverage, 19614,
     /* 1911908 */     GIR_EraseRootFromParent_Done,
     /* 1911909 */   // Label 25715: @1911909
     /* 1911909 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1911995), // Rule ID 19615 //
     /* 1911914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911960 */     // MIs[0] policy
     /* 1911960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911970 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1911973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911994 */     // GIR_Coverage, 19615,
     /* 1911994 */     GIR_EraseRootFromParent_Done,
     /* 1911995 */   // Label 25716: @1911995
     /* 1911995 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1912081), // Rule ID 19618 //
     /* 1912000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912046 */     // MIs[0] policy
     /* 1912046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912056 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1912059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912080 */     // GIR_Coverage, 19618,
     /* 1912080 */     GIR_EraseRootFromParent_Done,
     /* 1912081 */   // Label 25717: @1912081
     /* 1912081 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1912167), // Rule ID 19619 //
     /* 1912086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912132 */     // MIs[0] policy
     /* 1912132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912142 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1912145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912166 */     // GIR_Coverage, 19619,
     /* 1912166 */     GIR_EraseRootFromParent_Done,
     /* 1912167 */   // Label 25718: @1912167
     /* 1912167 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1912253), // Rule ID 19622 //
     /* 1912172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912218 */     // MIs[0] policy
     /* 1912218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1912231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912252 */     // GIR_Coverage, 19622,
     /* 1912252 */     GIR_EraseRootFromParent_Done,
     /* 1912253 */   // Label 25719: @1912253
     /* 1912253 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1912339), // Rule ID 19623 //
     /* 1912258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912304 */     // MIs[0] policy
     /* 1912304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1912317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912338 */     // GIR_Coverage, 19623,
     /* 1912338 */     GIR_EraseRootFromParent_Done,
     /* 1912339 */   // Label 25720: @1912339
     /* 1912339 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1912425), // Rule ID 19626 //
     /* 1912344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912390 */     // MIs[0] policy
     /* 1912390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912400 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1912403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912424 */     // GIR_Coverage, 19626,
     /* 1912424 */     GIR_EraseRootFromParent_Done,
     /* 1912425 */   // Label 25721: @1912425
     /* 1912425 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1912511), // Rule ID 19627 //
     /* 1912430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912476 */     // MIs[0] policy
     /* 1912476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912486 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1912489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912510 */     // GIR_Coverage, 19627,
     /* 1912510 */     GIR_EraseRootFromParent_Done,
     /* 1912511 */   // Label 25722: @1912511
     /* 1912511 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1912597), // Rule ID 19630 //
     /* 1912516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912562 */     // MIs[0] policy
     /* 1912562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912572 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1912575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912596 */     // GIR_Coverage, 19630,
     /* 1912596 */     GIR_EraseRootFromParent_Done,
     /* 1912597 */   // Label 25723: @1912597
     /* 1912597 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1912683), // Rule ID 19631 //
     /* 1912602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912648 */     // MIs[0] policy
     /* 1912648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912658 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1912661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912682 */     // GIR_Coverage, 19631,
     /* 1912682 */     GIR_EraseRootFromParent_Done,
     /* 1912683 */   // Label 25724: @1912683
     /* 1912683 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1912769), // Rule ID 19634 //
     /* 1912688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912734 */     // MIs[0] policy
     /* 1912734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912744 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1912747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912768 */     // GIR_Coverage, 19634,
     /* 1912768 */     GIR_EraseRootFromParent_Done,
     /* 1912769 */   // Label 25725: @1912769
     /* 1912769 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1912855), // Rule ID 19635 //
     /* 1912774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912820 */     // MIs[0] policy
     /* 1912820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1912833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912854 */     // GIR_Coverage, 19635,
     /* 1912854 */     GIR_EraseRootFromParent_Done,
     /* 1912855 */   // Label 25726: @1912855
     /* 1912855 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1912941), // Rule ID 19638 //
     /* 1912860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912906 */     // MIs[0] policy
     /* 1912906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912916 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1912919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912940 */     // GIR_Coverage, 19638,
     /* 1912940 */     GIR_EraseRootFromParent_Done,
     /* 1912941 */   // Label 25727: @1912941
     /* 1912941 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1913027), // Rule ID 19639 //
     /* 1912946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912992 */     // MIs[0] policy
     /* 1912992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913002 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1913005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913026 */     // GIR_Coverage, 19639,
     /* 1913026 */     GIR_EraseRootFromParent_Done,
     /* 1913027 */   // Label 25728: @1913027
     /* 1913027 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1913113), // Rule ID 19642 //
     /* 1913032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913078 */     // MIs[0] policy
     /* 1913078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913088 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1913091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913112 */     // GIR_Coverage, 19642,
     /* 1913112 */     GIR_EraseRootFromParent_Done,
     /* 1913113 */   // Label 25729: @1913113
     /* 1913113 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1913199), // Rule ID 19643 //
     /* 1913118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913164 */     // MIs[0] policy
     /* 1913164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913174 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1913177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913198 */     // GIR_Coverage, 19643,
     /* 1913198 */     GIR_EraseRootFromParent_Done,
     /* 1913199 */   // Label 25730: @1913199
     /* 1913199 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1913285), // Rule ID 19646 //
     /* 1913204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1913224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913250 */     // MIs[0] policy
     /* 1913250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913260 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1913263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913284 */     // GIR_Coverage, 19646,
     /* 1913284 */     GIR_EraseRootFromParent_Done,
     /* 1913285 */   // Label 25731: @1913285
     /* 1913285 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1913371), // Rule ID 19647 //
     /* 1913290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1913301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1913304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1913307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1913310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913336 */     // MIs[0] policy
     /* 1913336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913346 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1913349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913370 */     // GIR_Coverage, 19647,
     /* 1913370 */     GIR_EraseRootFromParent_Done,
     /* 1913371 */   // Label 25732: @1913371
     /* 1913371 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1913457), // Rule ID 19650 //
     /* 1913376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1913396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913422 */     // MIs[0] policy
     /* 1913422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1913435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913456 */     // GIR_Coverage, 19650,
     /* 1913456 */     GIR_EraseRootFromParent_Done,
     /* 1913457 */   // Label 25733: @1913457
     /* 1913457 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1913543), // Rule ID 19651 //
     /* 1913462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1913482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913508 */     // MIs[0] policy
     /* 1913508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1913521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913542 */     // GIR_Coverage, 19651,
     /* 1913542 */     GIR_EraseRootFromParent_Done,
     /* 1913543 */   // Label 25734: @1913543
     /* 1913543 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1913629), // Rule ID 19654 //
     /* 1913548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1913568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913594 */     // MIs[0] policy
     /* 1913594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1913607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913628 */     // GIR_Coverage, 19654,
     /* 1913628 */     GIR_EraseRootFromParent_Done,
     /* 1913629 */   // Label 25735: @1913629
     /* 1913629 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1913715), // Rule ID 19655 //
     /* 1913634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1913654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913680 */     // MIs[0] policy
     /* 1913680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1913693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913714 */     // GIR_Coverage, 19655,
     /* 1913714 */     GIR_EraseRootFromParent_Done,
     /* 1913715 */   // Label 25736: @1913715
     /* 1913715 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1913801), // Rule ID 19658 //
     /* 1913720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1913740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913766 */     // MIs[0] policy
     /* 1913766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1913779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913800 */     // GIR_Coverage, 19658,
     /* 1913800 */     GIR_EraseRootFromParent_Done,
     /* 1913801 */   // Label 25737: @1913801
     /* 1913801 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1913887), // Rule ID 19659 //
     /* 1913806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1913826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913852 */     // MIs[0] policy
     /* 1913852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913862 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1913865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913886 */     // GIR_Coverage, 19659,
     /* 1913886 */     GIR_EraseRootFromParent_Done,
     /* 1913887 */   // Label 25738: @1913887
     /* 1913887 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1913973), // Rule ID 19662 //
     /* 1913892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1913912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913938 */     // MIs[0] policy
     /* 1913938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1913951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913972 */     // GIR_Coverage, 19662,
     /* 1913972 */     GIR_EraseRootFromParent_Done,
     /* 1913973 */   // Label 25739: @1913973
     /* 1913973 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1914059), // Rule ID 19663 //
     /* 1913978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1913998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914024 */     // MIs[0] policy
     /* 1914024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1914037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914058 */     // GIR_Coverage, 19663,
     /* 1914058 */     GIR_EraseRootFromParent_Done,
     /* 1914059 */   // Label 25740: @1914059
     /* 1914059 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1914145), // Rule ID 19666 //
     /* 1914064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1914084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914110 */     // MIs[0] policy
     /* 1914110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914120 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1914123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914144 */     // GIR_Coverage, 19666,
     /* 1914144 */     GIR_EraseRootFromParent_Done,
     /* 1914145 */   // Label 25741: @1914145
     /* 1914145 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1914231), // Rule ID 19667 //
     /* 1914150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1914153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1914161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1914164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1914167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1914170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914196 */     // MIs[0] policy
     /* 1914196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914206 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1914209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914230 */     // GIR_Coverage, 19667,
     /* 1914230 */     GIR_EraseRootFromParent_Done,
     /* 1914231 */   // Label 25742: @1914231
     /* 1914231 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1914317), // Rule ID 19670 //
     /* 1914236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1914256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914282 */     // MIs[0] policy
     /* 1914282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1914295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914316 */     // GIR_Coverage, 19670,
     /* 1914316 */     GIR_EraseRootFromParent_Done,
     /* 1914317 */   // Label 25743: @1914317
     /* 1914317 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1914403), // Rule ID 19671 //
     /* 1914322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1914333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1914336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1914339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1914342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914368 */     // MIs[0] policy
     /* 1914368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914378 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1914381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914402 */     // GIR_Coverage, 19671,
     /* 1914402 */     GIR_EraseRootFromParent_Done,
     /* 1914403 */   // Label 25744: @1914403
     /* 1914403 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1914489), // Rule ID 19674 //
     /* 1914408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1914428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914454 */     // MIs[0] policy
     /* 1914454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914464 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1914467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914488 */     // GIR_Coverage, 19674,
     /* 1914488 */     GIR_EraseRootFromParent_Done,
     /* 1914489 */   // Label 25745: @1914489
     /* 1914489 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1914575), // Rule ID 19675 //
     /* 1914494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1914514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914540 */     // MIs[0] policy
     /* 1914540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914550 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1914553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914574 */     // GIR_Coverage, 19675,
     /* 1914574 */     GIR_EraseRootFromParent_Done,
     /* 1914575 */   // Label 25746: @1914575
     /* 1914575 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1914661), // Rule ID 19678 //
     /* 1914580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1914600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914626 */     // MIs[0] policy
     /* 1914626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914636 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1914639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914660 */     // GIR_Coverage, 19678,
     /* 1914660 */     GIR_EraseRootFromParent_Done,
     /* 1914661 */   // Label 25747: @1914661
     /* 1914661 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1914747), // Rule ID 19679 //
     /* 1914666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1914686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914712 */     // MIs[0] policy
     /* 1914712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914722 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1914725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914746 */     // GIR_Coverage, 19679,
     /* 1914746 */     GIR_EraseRootFromParent_Done,
     /* 1914747 */   // Label 25748: @1914747
     /* 1914747 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1914833), // Rule ID 19682 //
     /* 1914752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1914772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914798 */     // MIs[0] policy
     /* 1914798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914808 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1914811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914832 */     // GIR_Coverage, 19682,
     /* 1914832 */     GIR_EraseRootFromParent_Done,
     /* 1914833 */   // Label 25749: @1914833
     /* 1914833 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1914919), // Rule ID 19683 //
     /* 1914838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1914858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914884 */     // MIs[0] policy
     /* 1914884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1914897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914918 */     // GIR_Coverage, 19683,
     /* 1914918 */     GIR_EraseRootFromParent_Done,
     /* 1914919 */   // Label 25750: @1914919
     /* 1914919 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1915005), // Rule ID 19686 //
     /* 1914924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1914932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1914935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1914938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1914941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1914944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914970 */     // MIs[0] policy
     /* 1914970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914980 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1914983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915004 */     // GIR_Coverage, 19686,
     /* 1915004 */     GIR_EraseRootFromParent_Done,
     /* 1915005 */   // Label 25751: @1915005
     /* 1915005 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1915091), // Rule ID 19687 //
     /* 1915010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1915021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1915024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1915027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1915030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915056 */     // MIs[0] policy
     /* 1915056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915066 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1915069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915090 */     // GIR_Coverage, 19687,
     /* 1915090 */     GIR_EraseRootFromParent_Done,
     /* 1915091 */   // Label 25752: @1915091
     /* 1915091 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1915177), // Rule ID 19690 //
     /* 1915096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1915116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915142 */     // MIs[0] policy
     /* 1915142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1915155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915176 */     // GIR_Coverage, 19690,
     /* 1915176 */     GIR_EraseRootFromParent_Done,
     /* 1915177 */   // Label 25753: @1915177
     /* 1915177 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1915263), // Rule ID 19691 //
     /* 1915182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1915193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1915196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1915199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1915202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915228 */     // MIs[0] policy
     /* 1915228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915238 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1915241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915262 */     // GIR_Coverage, 19691,
     /* 1915262 */     GIR_EraseRootFromParent_Done,
     /* 1915263 */   // Label 25754: @1915263
     /* 1915263 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1915349), // Rule ID 19694 //
     /* 1915268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1915288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915314 */     // MIs[0] policy
     /* 1915314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1915327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915348 */     // GIR_Coverage, 19694,
     /* 1915348 */     GIR_EraseRootFromParent_Done,
     /* 1915349 */   // Label 25755: @1915349
     /* 1915349 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1915435), // Rule ID 19695 //
     /* 1915354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1915374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915400 */     // MIs[0] policy
     /* 1915400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915410 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1915413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915434 */     // GIR_Coverage, 19695,
     /* 1915434 */     GIR_EraseRootFromParent_Done,
     /* 1915435 */   // Label 25756: @1915435
     /* 1915435 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1915521), // Rule ID 19698 //
     /* 1915440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1915460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915486 */     // MIs[0] policy
     /* 1915486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1915499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915520 */     // GIR_Coverage, 19698,
     /* 1915520 */     GIR_EraseRootFromParent_Done,
     /* 1915521 */   // Label 25757: @1915521
     /* 1915521 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1915607), // Rule ID 19699 //
     /* 1915526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1915546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915572 */     // MIs[0] policy
     /* 1915572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915582 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1915585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915606 */     // GIR_Coverage, 19699,
     /* 1915606 */     GIR_EraseRootFromParent_Done,
     /* 1915607 */   // Label 25758: @1915607
     /* 1915607 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1915693), // Rule ID 19702 //
     /* 1915612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1915632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915658 */     // MIs[0] policy
     /* 1915658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1915671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915692 */     // GIR_Coverage, 19702,
     /* 1915692 */     GIR_EraseRootFromParent_Done,
     /* 1915693 */   // Label 25759: @1915693
     /* 1915693 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1915779), // Rule ID 19703 //
     /* 1915698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1915718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915744 */     // MIs[0] policy
     /* 1915744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915754 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1915757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915778 */     // GIR_Coverage, 19703,
     /* 1915778 */     GIR_EraseRootFromParent_Done,
     /* 1915779 */   // Label 25760: @1915779
     /* 1915779 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1915865), // Rule ID 19706 //
     /* 1915784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1915804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1915826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915830 */     // MIs[0] policy
     /* 1915830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1915843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915864 */     // GIR_Coverage, 19706,
     /* 1915864 */     GIR_EraseRootFromParent_Done,
     /* 1915865 */   // Label 25761: @1915865
     /* 1915865 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1915951), // Rule ID 19707 //
     /* 1915870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1915890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1915912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915916 */     // MIs[0] policy
     /* 1915916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915926 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1915929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915950 */     // GIR_Coverage, 19707,
     /* 1915950 */     GIR_EraseRootFromParent_Done,
     /* 1915951 */   // Label 25762: @1915951
     /* 1915951 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1916037), // Rule ID 19710 //
     /* 1915956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1915976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1915998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916002 */     // MIs[0] policy
     /* 1916002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916012 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1916015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916036 */     // GIR_Coverage, 19710,
     /* 1916036 */     GIR_EraseRootFromParent_Done,
     /* 1916037 */   // Label 25763: @1916037
     /* 1916037 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1916123), // Rule ID 19711 //
     /* 1916042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1916053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1916056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1916059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916088 */     // MIs[0] policy
     /* 1916088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916098 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1916101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916122 */     // GIR_Coverage, 19711,
     /* 1916122 */     GIR_EraseRootFromParent_Done,
     /* 1916123 */   // Label 25764: @1916123
     /* 1916123 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1916209), // Rule ID 19714 //
     /* 1916128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1916170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916174 */     // MIs[0] policy
     /* 1916174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1916187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916208 */     // GIR_Coverage, 19714,
     /* 1916208 */     GIR_EraseRootFromParent_Done,
     /* 1916209 */   // Label 25765: @1916209
     /* 1916209 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1916295), // Rule ID 19715 //
     /* 1916214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1916225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1916228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1916231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1916256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916260 */     // MIs[0] policy
     /* 1916260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916270 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1916273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916294 */     // GIR_Coverage, 19715,
     /* 1916294 */     GIR_EraseRootFromParent_Done,
     /* 1916295 */   // Label 25766: @1916295
     /* 1916295 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1916381), // Rule ID 19718 //
     /* 1916300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916346 */     // MIs[0] policy
     /* 1916346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1916359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916380 */     // GIR_Coverage, 19718,
     /* 1916380 */     GIR_EraseRootFromParent_Done,
     /* 1916381 */   // Label 25767: @1916381
     /* 1916381 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1916467), // Rule ID 19719 //
     /* 1916386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916432 */     // MIs[0] policy
     /* 1916432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916442 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1916445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916466 */     // GIR_Coverage, 19719,
     /* 1916466 */     GIR_EraseRootFromParent_Done,
     /* 1916467 */   // Label 25768: @1916467
     /* 1916467 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1916553), // Rule ID 19722 //
     /* 1916472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1916514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916518 */     // MIs[0] policy
     /* 1916518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916528 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1916531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916552 */     // GIR_Coverage, 19722,
     /* 1916552 */     GIR_EraseRootFromParent_Done,
     /* 1916553 */   // Label 25769: @1916553
     /* 1916553 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1916639), // Rule ID 19723 //
     /* 1916558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1916600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916604 */     // MIs[0] policy
     /* 1916604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916614 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1916617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916638 */     // GIR_Coverage, 19723,
     /* 1916638 */     GIR_EraseRootFromParent_Done,
     /* 1916639 */   // Label 25770: @1916639
     /* 1916639 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1916725), // Rule ID 19726 //
     /* 1916644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1916686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916690 */     // MIs[0] policy
     /* 1916690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916700 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1916703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916724 */     // GIR_Coverage, 19726,
     /* 1916724 */     GIR_EraseRootFromParent_Done,
     /* 1916725 */   // Label 25771: @1916725
     /* 1916725 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1916811), // Rule ID 19727 //
     /* 1916730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1916772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916776 */     // MIs[0] policy
     /* 1916776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1916789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916810 */     // GIR_Coverage, 19727,
     /* 1916810 */     GIR_EraseRootFromParent_Done,
     /* 1916811 */   // Label 25772: @1916811
     /* 1916811 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1916897), // Rule ID 19730 //
     /* 1916816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916862 */     // MIs[0] policy
     /* 1916862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1916875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916896 */     // GIR_Coverage, 19730,
     /* 1916896 */     GIR_EraseRootFromParent_Done,
     /* 1916897 */   // Label 25773: @1916897
     /* 1916897 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1916983), // Rule ID 19731 //
     /* 1916902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1916922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1916944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916948 */     // MIs[0] policy
     /* 1916948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1916961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916982 */     // GIR_Coverage, 19731,
     /* 1916982 */     GIR_EraseRootFromParent_Done,
     /* 1916983 */   // Label 25774: @1916983
     /* 1916983 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1917069), // Rule ID 19734 //
     /* 1916988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917034 */     // MIs[0] policy
     /* 1917034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1917047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917068 */     // GIR_Coverage, 19734,
     /* 1917068 */     GIR_EraseRootFromParent_Done,
     /* 1917069 */   // Label 25775: @1917069
     /* 1917069 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1917155), // Rule ID 19735 //
     /* 1917074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1917085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1917088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1917091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917120 */     // MIs[0] policy
     /* 1917120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917130 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1917133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917154 */     // GIR_Coverage, 19735,
     /* 1917154 */     GIR_EraseRootFromParent_Done,
     /* 1917155 */   // Label 25776: @1917155
     /* 1917155 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1917241), // Rule ID 19738 //
     /* 1917160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1917163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917206 */     // MIs[0] policy
     /* 1917206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1917219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917240 */     // GIR_Coverage, 19738,
     /* 1917240 */     GIR_EraseRootFromParent_Done,
     /* 1917241 */   // Label 25777: @1917241
     /* 1917241 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1917327), // Rule ID 19739 //
     /* 1917246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1917249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1917257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1917260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1917263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1917266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1917269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1917288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917292 */     // MIs[0] policy
     /* 1917292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917302 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1917305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1917323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917326 */     // GIR_Coverage, 19739,
     /* 1917326 */     GIR_EraseRootFromParent_Done,
     /* 1917327 */   // Label 25778: @1917327
     /* 1917327 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1917413), // Rule ID 19742 //
     /* 1917332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917378 */     // MIs[0] policy
     /* 1917378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1917391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917412 */     // GIR_Coverage, 19742,
     /* 1917412 */     GIR_EraseRootFromParent_Done,
     /* 1917413 */   // Label 25779: @1917413
     /* 1917413 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1917499), // Rule ID 19743 //
     /* 1917418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917464 */     // MIs[0] policy
     /* 1917464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1917477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917498 */     // GIR_Coverage, 19743,
     /* 1917498 */     GIR_EraseRootFromParent_Done,
     /* 1917499 */   // Label 25780: @1917499
     /* 1917499 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1917585), // Rule ID 19746 //
     /* 1917504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917550 */     // MIs[0] policy
     /* 1917550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917560 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1917563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917584 */     // GIR_Coverage, 19746,
     /* 1917584 */     GIR_EraseRootFromParent_Done,
     /* 1917585 */   // Label 25781: @1917585
     /* 1917585 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1917671), // Rule ID 19747 //
     /* 1917590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917636 */     // MIs[0] policy
     /* 1917636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1917649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917670 */     // GIR_Coverage, 19747,
     /* 1917670 */     GIR_EraseRootFromParent_Done,
     /* 1917671 */   // Label 25782: @1917671
     /* 1917671 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1917757), // Rule ID 19750 //
     /* 1917676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917722 */     // MIs[0] policy
     /* 1917722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917732 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1917735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917756 */     // GIR_Coverage, 19750,
     /* 1917756 */     GIR_EraseRootFromParent_Done,
     /* 1917757 */   // Label 25783: @1917757
     /* 1917757 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1917843), // Rule ID 19751 //
     /* 1917762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1917804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917808 */     // MIs[0] policy
     /* 1917808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917818 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1917821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917842 */     // GIR_Coverage, 19751,
     /* 1917842 */     GIR_EraseRootFromParent_Done,
     /* 1917843 */   // Label 25784: @1917843
     /* 1917843 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1917929), // Rule ID 19754 //
     /* 1917848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1917890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917894 */     // MIs[0] policy
     /* 1917894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1917907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917928 */     // GIR_Coverage, 19754,
     /* 1917928 */     GIR_EraseRootFromParent_Done,
     /* 1917929 */   // Label 25785: @1917929
     /* 1917929 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1918015), // Rule ID 19755 //
     /* 1917934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1917976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917980 */     // MIs[0] policy
     /* 1917980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917990 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1917993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918014 */     // GIR_Coverage, 19755,
     /* 1918014 */     GIR_EraseRootFromParent_Done,
     /* 1918015 */   // Label 25786: @1918015
     /* 1918015 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1918101), // Rule ID 19758 //
     /* 1918020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918066 */     // MIs[0] policy
     /* 1918066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918076 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1918079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918100 */     // GIR_Coverage, 19758,
     /* 1918100 */     GIR_EraseRootFromParent_Done,
     /* 1918101 */   // Label 25787: @1918101
     /* 1918101 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1918187), // Rule ID 19759 //
     /* 1918106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1918117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1918120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1918123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1918136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1918144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918152 */     // MIs[0] policy
     /* 1918152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1918165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918186 */     // GIR_Coverage, 19759,
     /* 1918186 */     GIR_EraseRootFromParent_Done,
     /* 1918187 */   // Label 25788: @1918187
     /* 1918187 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1918273), // Rule ID 19762 //
     /* 1918192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918238 */     // MIs[0] policy
     /* 1918238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918248 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1918251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918272 */     // GIR_Coverage, 19762,
     /* 1918272 */     GIR_EraseRootFromParent_Done,
     /* 1918273 */   // Label 25789: @1918273
     /* 1918273 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1918359), // Rule ID 19763 //
     /* 1918278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1918289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1918292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1918295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1918308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1918316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918324 */     // MIs[0] policy
     /* 1918324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918334 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1918337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918358 */     // GIR_Coverage, 19763,
     /* 1918358 */     GIR_EraseRootFromParent_Done,
     /* 1918359 */   // Label 25790: @1918359
     /* 1918359 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1918445), // Rule ID 23604 //
     /* 1918364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1918375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1918378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1918381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918410 */     // MIs[0] policy
     /* 1918410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1918423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918444 */     // GIR_Coverage, 23604,
     /* 1918444 */     GIR_EraseRootFromParent_Done,
     /* 1918445 */   // Label 25791: @1918445
     /* 1918445 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1918531), // Rule ID 23605 //
     /* 1918450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1918461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1918464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1918467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918496 */     // MIs[0] policy
     /* 1918496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918506 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1918509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918530 */     // GIR_Coverage, 23605,
     /* 1918530 */     GIR_EraseRootFromParent_Done,
     /* 1918531 */   // Label 25792: @1918531
     /* 1918531 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1918617), // Rule ID 23608 //
     /* 1918536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1918547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1918550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1918553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918582 */     // MIs[0] policy
     /* 1918582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1918595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918616 */     // GIR_Coverage, 23608,
     /* 1918616 */     GIR_EraseRootFromParent_Done,
     /* 1918617 */   // Label 25793: @1918617
     /* 1918617 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1918703), // Rule ID 23609 //
     /* 1918622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1918633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1918636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1918639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918668 */     // MIs[0] policy
     /* 1918668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1918681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918702 */     // GIR_Coverage, 23609,
     /* 1918702 */     GIR_EraseRootFromParent_Done,
     /* 1918703 */   // Label 25794: @1918703
     /* 1918703 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1918789), // Rule ID 23612 //
     /* 1918708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1918719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1918722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1918725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918754 */     // MIs[0] policy
     /* 1918754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1918767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918788 */     // GIR_Coverage, 23612,
     /* 1918788 */     GIR_EraseRootFromParent_Done,
     /* 1918789 */   // Label 25795: @1918789
     /* 1918789 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1918875), // Rule ID 23613 //
     /* 1918794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1918805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1918808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1918811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918840 */     // MIs[0] policy
     /* 1918840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918850 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1918853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918874 */     // GIR_Coverage, 23613,
     /* 1918874 */     GIR_EraseRootFromParent_Done,
     /* 1918875 */   // Label 25796: @1918875
     /* 1918875 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1918961), // Rule ID 23616 //
     /* 1918880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918926 */     // MIs[0] policy
     /* 1918926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1918939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918960 */     // GIR_Coverage, 23616,
     /* 1918960 */     GIR_EraseRootFromParent_Done,
     /* 1918961 */   // Label 25797: @1918961
     /* 1918961 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1919047), // Rule ID 23617 //
     /* 1918966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1918974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919012 */     // MIs[0] policy
     /* 1919012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1919025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919046 */     // GIR_Coverage, 23617,
     /* 1919046 */     GIR_EraseRootFromParent_Done,
     /* 1919047 */   // Label 25798: @1919047
     /* 1919047 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1919133), // Rule ID 23620 //
     /* 1919052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1919063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1919066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919098 */     // MIs[0] policy
     /* 1919098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1919111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919132 */     // GIR_Coverage, 23620,
     /* 1919132 */     GIR_EraseRootFromParent_Done,
     /* 1919133 */   // Label 25799: @1919133
     /* 1919133 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1919219), // Rule ID 23621 //
     /* 1919138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1919149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1919152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1919155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919184 */     // MIs[0] policy
     /* 1919184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1919197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919218 */     // GIR_Coverage, 23621,
     /* 1919218 */     GIR_EraseRootFromParent_Done,
     /* 1919219 */   // Label 25800: @1919219
     /* 1919219 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1919305), // Rule ID 23624 //
     /* 1919224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1919235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1919238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1919241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919270 */     // MIs[0] policy
     /* 1919270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1919283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919304 */     // GIR_Coverage, 23624,
     /* 1919304 */     GIR_EraseRootFromParent_Done,
     /* 1919305 */   // Label 25801: @1919305
     /* 1919305 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1919391), // Rule ID 23625 //
     /* 1919310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1919321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1919324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1919327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919356 */     // MIs[0] policy
     /* 1919356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1919369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919390 */     // GIR_Coverage, 23625,
     /* 1919390 */     GIR_EraseRootFromParent_Done,
     /* 1919391 */   // Label 25802: @1919391
     /* 1919391 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1919477), // Rule ID 23628 //
     /* 1919396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1919407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1919410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1919413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919442 */     // MIs[0] policy
     /* 1919442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919476 */     // GIR_Coverage, 23628,
     /* 1919476 */     GIR_EraseRootFromParent_Done,
     /* 1919477 */   // Label 25803: @1919477
     /* 1919477 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1919563), // Rule ID 23629 //
     /* 1919482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1919493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1919496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1919499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919528 */     // MIs[0] policy
     /* 1919528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919562 */     // GIR_Coverage, 23629,
     /* 1919562 */     GIR_EraseRootFromParent_Done,
     /* 1919563 */   // Label 25804: @1919563
     /* 1919563 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1919649), // Rule ID 23632 //
     /* 1919568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919614 */     // MIs[0] policy
     /* 1919614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919648 */     // GIR_Coverage, 23632,
     /* 1919648 */     GIR_EraseRootFromParent_Done,
     /* 1919649 */   // Label 25805: @1919649
     /* 1919649 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1919735), // Rule ID 23633 //
     /* 1919654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919700 */     // MIs[0] policy
     /* 1919700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919734 */     // GIR_Coverage, 23633,
     /* 1919734 */     GIR_EraseRootFromParent_Done,
     /* 1919735 */   // Label 25806: @1919735
     /* 1919735 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1919821), // Rule ID 23636 //
     /* 1919740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919786 */     // MIs[0] policy
     /* 1919786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919820 */     // GIR_Coverage, 23636,
     /* 1919820 */     GIR_EraseRootFromParent_Done,
     /* 1919821 */   // Label 25807: @1919821
     /* 1919821 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1919907), // Rule ID 23637 //
     /* 1919826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919872 */     // MIs[0] policy
     /* 1919872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919906 */     // GIR_Coverage, 23637,
     /* 1919906 */     GIR_EraseRootFromParent_Done,
     /* 1919907 */   // Label 25808: @1919907
     /* 1919907 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1919993), // Rule ID 23640 //
     /* 1919912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1919915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1919920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919958 */     // MIs[0] policy
     /* 1919958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1919971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919992 */     // GIR_Coverage, 23640,
     /* 1919992 */     GIR_EraseRootFromParent_Done,
     /* 1919993 */   // Label 25809: @1919993
     /* 1919993 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1920079), // Rule ID 23641 //
     /* 1919998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1920001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1920009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1920012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1920015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920044 */     // MIs[0] policy
     /* 1920044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1920057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920078 */     // GIR_Coverage, 23641,
     /* 1920078 */     GIR_EraseRootFromParent_Done,
     /* 1920079 */   // Label 25810: @1920079
     /* 1920079 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1920165), // Rule ID 23644 //
     /* 1920084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1920095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1920098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1920101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920130 */     // MIs[0] policy
     /* 1920130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1920143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920164 */     // GIR_Coverage, 23644,
     /* 1920164 */     GIR_EraseRootFromParent_Done,
     /* 1920165 */   // Label 25811: @1920165
     /* 1920165 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1920251), // Rule ID 23645 //
     /* 1920170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1920181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1920184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1920187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920216 */     // MIs[0] policy
     /* 1920216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1920229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920250 */     // GIR_Coverage, 23645,
     /* 1920250 */     GIR_EraseRootFromParent_Done,
     /* 1920251 */   // Label 25812: @1920251
     /* 1920251 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1920337), // Rule ID 23648 //
     /* 1920256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1920267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1920270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1920273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920302 */     // MIs[0] policy
     /* 1920302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920312 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1920315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920336 */     // GIR_Coverage, 23648,
     /* 1920336 */     GIR_EraseRootFromParent_Done,
     /* 1920337 */   // Label 25813: @1920337
     /* 1920337 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1920423), // Rule ID 23649 //
     /* 1920342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1920353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1920356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1920359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920388 */     // MIs[0] policy
     /* 1920388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920398 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1920401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920422 */     // GIR_Coverage, 23649,
     /* 1920422 */     GIR_EraseRootFromParent_Done,
     /* 1920423 */   // Label 25814: @1920423
     /* 1920423 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1920509), // Rule ID 23652 //
     /* 1920428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1920439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1920442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1920445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1920451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920474 */     // MIs[0] policy
     /* 1920474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1920487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920508 */     // GIR_Coverage, 23652,
     /* 1920508 */     GIR_EraseRootFromParent_Done,
     /* 1920509 */   // Label 25815: @1920509
     /* 1920509 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1920595), // Rule ID 23653 //
     /* 1920514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1920525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1920528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1920531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1920537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920560 */     // MIs[0] policy
     /* 1920560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920570 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1920573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920594 */     // GIR_Coverage, 23653,
     /* 1920594 */     GIR_EraseRootFromParent_Done,
     /* 1920595 */   // Label 25816: @1920595
     /* 1920595 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1920681), // Rule ID 23656 //
     /* 1920600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920646 */     // MIs[0] policy
     /* 1920646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1920659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920680 */     // GIR_Coverage, 23656,
     /* 1920680 */     GIR_EraseRootFromParent_Done,
     /* 1920681 */   // Label 25817: @1920681
     /* 1920681 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1920767), // Rule ID 23657 //
     /* 1920686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920732 */     // MIs[0] policy
     /* 1920732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1920745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920766 */     // GIR_Coverage, 23657,
     /* 1920766 */     GIR_EraseRootFromParent_Done,
     /* 1920767 */   // Label 25818: @1920767
     /* 1920767 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1920853), // Rule ID 23660 //
     /* 1920772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920818 */     // MIs[0] policy
     /* 1920818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920828 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1920831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920852 */     // GIR_Coverage, 23660,
     /* 1920852 */     GIR_EraseRootFromParent_Done,
     /* 1920853 */   // Label 25819: @1920853
     /* 1920853 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1920939), // Rule ID 23661 //
     /* 1920858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920904 */     // MIs[0] policy
     /* 1920904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1920917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920938 */     // GIR_Coverage, 23661,
     /* 1920938 */     GIR_EraseRootFromParent_Done,
     /* 1920939 */   // Label 25820: @1920939
     /* 1920939 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1921025), // Rule ID 23664 //
     /* 1920944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1920955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1920958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920990 */     // MIs[0] policy
     /* 1920990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1921003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921024 */     // GIR_Coverage, 23664,
     /* 1921024 */     GIR_EraseRootFromParent_Done,
     /* 1921025 */   // Label 25821: @1921025
     /* 1921025 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1921111), // Rule ID 23665 //
     /* 1921030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1921041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1921044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1921047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1921053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921076 */     // MIs[0] policy
     /* 1921076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921086 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1921089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921110 */     // GIR_Coverage, 23665,
     /* 1921110 */     GIR_EraseRootFromParent_Done,
     /* 1921111 */   // Label 25822: @1921111
     /* 1921111 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1921197), // Rule ID 23668 //
     /* 1921116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1921127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1921130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1921133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921162 */     // MIs[0] policy
     /* 1921162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1921175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921196 */     // GIR_Coverage, 23668,
     /* 1921196 */     GIR_EraseRootFromParent_Done,
     /* 1921197 */   // Label 25823: @1921197
     /* 1921197 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1921283), // Rule ID 23669 //
     /* 1921202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1921213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1921216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1921219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921248 */     // MIs[0] policy
     /* 1921248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1921261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921282 */     // GIR_Coverage, 23669,
     /* 1921282 */     GIR_EraseRootFromParent_Done,
     /* 1921283 */   // Label 25824: @1921283
     /* 1921283 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1921369), // Rule ID 23672 //
     /* 1921288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1921299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1921302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921334 */     // MIs[0] policy
     /* 1921334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1921347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921368 */     // GIR_Coverage, 23672,
     /* 1921368 */     GIR_EraseRootFromParent_Done,
     /* 1921369 */   // Label 25825: @1921369
     /* 1921369 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1921455), // Rule ID 23673 //
     /* 1921374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1921385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1921388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1921391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921420 */     // MIs[0] policy
     /* 1921420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1921433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921454 */     // GIR_Coverage, 23673,
     /* 1921454 */     GIR_EraseRootFromParent_Done,
     /* 1921455 */   // Label 25826: @1921455
     /* 1921455 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1921541), // Rule ID 23676 //
     /* 1921460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1921471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1921474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921506 */     // MIs[0] policy
     /* 1921506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1921519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921540 */     // GIR_Coverage, 23676,
     /* 1921540 */     GIR_EraseRootFromParent_Done,
     /* 1921541 */   // Label 25827: @1921541
     /* 1921541 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1921627), // Rule ID 23677 //
     /* 1921546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1921557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1921560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1921563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921592 */     // MIs[0] policy
     /* 1921592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1921605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921626 */     // GIR_Coverage, 23677,
     /* 1921626 */     GIR_EraseRootFromParent_Done,
     /* 1921627 */   // Label 25828: @1921627
     /* 1921627 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1921713), // Rule ID 23680 //
     /* 1921632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921678 */     // MIs[0] policy
     /* 1921678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1921691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921712 */     // GIR_Coverage, 23680,
     /* 1921712 */     GIR_EraseRootFromParent_Done,
     /* 1921713 */   // Label 25829: @1921713
     /* 1921713 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1921799), // Rule ID 23681 //
     /* 1921718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1921721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921764 */     // MIs[0] policy
     /* 1921764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1921777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921798 */     // GIR_Coverage, 23681,
     /* 1921798 */     GIR_EraseRootFromParent_Done,
     /* 1921799 */   // Label 25830: @1921799
     /* 1921799 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1921885), // Rule ID 23684 //
     /* 1921804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921850 */     // MIs[0] policy
     /* 1921850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1921863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921884 */     // GIR_Coverage, 23684,
     /* 1921884 */     GIR_EraseRootFromParent_Done,
     /* 1921885 */   // Label 25831: @1921885
     /* 1921885 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1921971), // Rule ID 23685 //
     /* 1921890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1921893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921936 */     // MIs[0] policy
     /* 1921936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1921949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921970 */     // GIR_Coverage, 23685,
     /* 1921970 */     GIR_EraseRootFromParent_Done,
     /* 1921971 */   // Label 25832: @1921971
     /* 1921971 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1922057), // Rule ID 23688 //
     /* 1921976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1921987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922022 */     // MIs[0] policy
     /* 1922022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922032 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922056 */     // GIR_Coverage, 23688,
     /* 1922056 */     GIR_EraseRootFromParent_Done,
     /* 1922057 */   // Label 25833: @1922057
     /* 1922057 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1922143), // Rule ID 23689 //
     /* 1922062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1922065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1922073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1922076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1922079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922108 */     // MIs[0] policy
     /* 1922108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922142 */     // GIR_Coverage, 23689,
     /* 1922142 */     GIR_EraseRootFromParent_Done,
     /* 1922143 */   // Label 25834: @1922143
     /* 1922143 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1922229), // Rule ID 23780 //
     /* 1922148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1922159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1922162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1922165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922194 */     // MIs[0] policy
     /* 1922194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922204 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1922207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922228 */     // GIR_Coverage, 23780,
     /* 1922228 */     GIR_EraseRootFromParent_Done,
     /* 1922229 */   // Label 25835: @1922229
     /* 1922229 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1922315), // Rule ID 23781 //
     /* 1922234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1922245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1922248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1922251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922280 */     // MIs[0] policy
     /* 1922280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922290 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1922293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922314 */     // GIR_Coverage, 23781,
     /* 1922314 */     GIR_EraseRootFromParent_Done,
     /* 1922315 */   // Label 25836: @1922315
     /* 1922315 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1922401), // Rule ID 23784 //
     /* 1922320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1922331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1922334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1922337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922366 */     // MIs[0] policy
     /* 1922366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1922379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922400 */     // GIR_Coverage, 23784,
     /* 1922400 */     GIR_EraseRootFromParent_Done,
     /* 1922401 */   // Label 25837: @1922401
     /* 1922401 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1922487), // Rule ID 23785 //
     /* 1922406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1922417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1922420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1922423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922452 */     // MIs[0] policy
     /* 1922452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922462 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1922465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922486 */     // GIR_Coverage, 23785,
     /* 1922486 */     GIR_EraseRootFromParent_Done,
     /* 1922487 */   // Label 25838: @1922487
     /* 1922487 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1922573), // Rule ID 23788 //
     /* 1922492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1922503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1922506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1922509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922538 */     // MIs[0] policy
     /* 1922538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922548 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1922551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922572 */     // GIR_Coverage, 23788,
     /* 1922572 */     GIR_EraseRootFromParent_Done,
     /* 1922573 */   // Label 25839: @1922573
     /* 1922573 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1922659), // Rule ID 23789 //
     /* 1922578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1922589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1922592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1922595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922624 */     // MIs[0] policy
     /* 1922624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922634 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1922637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922658 */     // GIR_Coverage, 23789,
     /* 1922658 */     GIR_EraseRootFromParent_Done,
     /* 1922659 */   // Label 25840: @1922659
     /* 1922659 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1922745), // Rule ID 23792 //
     /* 1922664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1922675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1922678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922710 */     // MIs[0] policy
     /* 1922710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922720 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1922723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922744 */     // GIR_Coverage, 23792,
     /* 1922744 */     GIR_EraseRootFromParent_Done,
     /* 1922745 */   // Label 25841: @1922745
     /* 1922745 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1922831), // Rule ID 23793 //
     /* 1922750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1922761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1922764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922796 */     // MIs[0] policy
     /* 1922796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922806 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1922809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922830 */     // GIR_Coverage, 23793,
     /* 1922830 */     GIR_EraseRootFromParent_Done,
     /* 1922831 */   // Label 25842: @1922831
     /* 1922831 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1922917), // Rule ID 23796 //
     /* 1922836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922882 */     // MIs[0] policy
     /* 1922882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922892 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1922895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922916 */     // GIR_Coverage, 23796,
     /* 1922916 */     GIR_EraseRootFromParent_Done,
     /* 1922917 */   // Label 25843: @1922917
     /* 1922917 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1923003), // Rule ID 23797 //
     /* 1922922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1922930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922968 */     // MIs[0] policy
     /* 1922968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922978 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1922981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923002 */     // GIR_Coverage, 23797,
     /* 1923002 */     GIR_EraseRootFromParent_Done,
     /* 1923003 */   // Label 25844: @1923003
     /* 1923003 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1923089), // Rule ID 23800 //
     /* 1923008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1923019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1923022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1923025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923054 */     // MIs[0] policy
     /* 1923054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1923067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923088 */     // GIR_Coverage, 23800,
     /* 1923088 */     GIR_EraseRootFromParent_Done,
     /* 1923089 */   // Label 25845: @1923089
     /* 1923089 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1923175), // Rule ID 23801 //
     /* 1923094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1923105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1923108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1923111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923140 */     // MIs[0] policy
     /* 1923140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923150 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1923153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923174 */     // GIR_Coverage, 23801,
     /* 1923174 */     GIR_EraseRootFromParent_Done,
     /* 1923175 */   // Label 25846: @1923175
     /* 1923175 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1923261), // Rule ID 23804 //
     /* 1923180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1923191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1923194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1923197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923226 */     // MIs[0] policy
     /* 1923226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923260 */     // GIR_Coverage, 23804,
     /* 1923260 */     GIR_EraseRootFromParent_Done,
     /* 1923261 */   // Label 25847: @1923261
     /* 1923261 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1923347), // Rule ID 23805 //
     /* 1923266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1923277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1923280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1923283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923312 */     // MIs[0] policy
     /* 1923312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923322 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923346 */     // GIR_Coverage, 23805,
     /* 1923346 */     GIR_EraseRootFromParent_Done,
     /* 1923347 */   // Label 25848: @1923347
     /* 1923347 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1923433), // Rule ID 23808 //
     /* 1923352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1923363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1923366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1923369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923398 */     // MIs[0] policy
     /* 1923398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923432 */     // GIR_Coverage, 23808,
     /* 1923432 */     GIR_EraseRootFromParent_Done,
     /* 1923433 */   // Label 25849: @1923433
     /* 1923433 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1923519), // Rule ID 23809 //
     /* 1923438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1923449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1923452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1923455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923484 */     // MIs[0] policy
     /* 1923484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923518 */     // GIR_Coverage, 23809,
     /* 1923518 */     GIR_EraseRootFromParent_Done,
     /* 1923519 */   // Label 25850: @1923519
     /* 1923519 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1923605), // Rule ID 23812 //
     /* 1923524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1923535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1923538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1923541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923570 */     // MIs[0] policy
     /* 1923570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923604 */     // GIR_Coverage, 23812,
     /* 1923604 */     GIR_EraseRootFromParent_Done,
     /* 1923605 */   // Label 25851: @1923605
     /* 1923605 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1923691), // Rule ID 23813 //
     /* 1923610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1923621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1923624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1923627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923656 */     // MIs[0] policy
     /* 1923656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923690 */     // GIR_Coverage, 23813,
     /* 1923690 */     GIR_EraseRootFromParent_Done,
     /* 1923691 */   // Label 25852: @1923691
     /* 1923691 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1923777), // Rule ID 23816 //
     /* 1923696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1923699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1923707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1923710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1923713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923742 */     // MIs[0] policy
     /* 1923742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923776 */     // GIR_Coverage, 23816,
     /* 1923776 */     GIR_EraseRootFromParent_Done,
     /* 1923777 */   // Label 25853: @1923777
     /* 1923777 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1923863), // Rule ID 23817 //
     /* 1923782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1923785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1923793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1923796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1923799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923828 */     // MIs[0] policy
     /* 1923828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1923841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923862 */     // GIR_Coverage, 23817,
     /* 1923862 */     GIR_EraseRootFromParent_Done,
     /* 1923863 */   // Label 25854: @1923863
     /* 1923863 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1923949), // Rule ID 23820 //
     /* 1923868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1923885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923914 */     // MIs[0] policy
     /* 1923914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1923927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923948 */     // GIR_Coverage, 23820,
     /* 1923948 */     GIR_EraseRootFromParent_Done,
     /* 1923949 */   // Label 25855: @1923949
     /* 1923949 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1924035), // Rule ID 23821 //
     /* 1923954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1923962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1923971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924000 */     // MIs[0] policy
     /* 1924000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1924013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924034 */     // GIR_Coverage, 23821,
     /* 1924034 */     GIR_EraseRootFromParent_Done,
     /* 1924035 */   // Label 25856: @1924035
     /* 1924035 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1924121), // Rule ID 23824 //
     /* 1924040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1924051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1924054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1924057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924086 */     // MIs[0] policy
     /* 1924086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924096 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1924099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924120 */     // GIR_Coverage, 23824,
     /* 1924120 */     GIR_EraseRootFromParent_Done,
     /* 1924121 */   // Label 25857: @1924121
     /* 1924121 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1924207), // Rule ID 23825 //
     /* 1924126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1924137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1924140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1924143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924172 */     // MIs[0] policy
     /* 1924172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924182 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1924185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924206 */     // GIR_Coverage, 23825,
     /* 1924206 */     GIR_EraseRootFromParent_Done,
     /* 1924207 */   // Label 25858: @1924207
     /* 1924207 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1924293), // Rule ID 23828 //
     /* 1924212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1924223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1924226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1924229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1924235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924258 */     // MIs[0] policy
     /* 1924258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924268 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1924271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924292 */     // GIR_Coverage, 23828,
     /* 1924292 */     GIR_EraseRootFromParent_Done,
     /* 1924293 */   // Label 25859: @1924293
     /* 1924293 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1924379), // Rule ID 23829 //
     /* 1924298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1924309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1924312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1924315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1924321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924344 */     // MIs[0] policy
     /* 1924344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924354 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1924357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924378 */     // GIR_Coverage, 23829,
     /* 1924378 */     GIR_EraseRootFromParent_Done,
     /* 1924379 */   // Label 25860: @1924379
     /* 1924379 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1924465), // Rule ID 23832 //
     /* 1924384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1924395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1924398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1924401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924430 */     // MIs[0] policy
     /* 1924430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1924443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924464 */     // GIR_Coverage, 23832,
     /* 1924464 */     GIR_EraseRootFromParent_Done,
     /* 1924465 */   // Label 25861: @1924465
     /* 1924465 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1924551), // Rule ID 23833 //
     /* 1924470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1924481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1924484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1924487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924516 */     // MIs[0] policy
     /* 1924516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1924529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924550 */     // GIR_Coverage, 23833,
     /* 1924550 */     GIR_EraseRootFromParent_Done,
     /* 1924551 */   // Label 25862: @1924551
     /* 1924551 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1924637), // Rule ID 23836 //
     /* 1924556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1924567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1924573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924602 */     // MIs[0] policy
     /* 1924602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924612 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1924615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924636 */     // GIR_Coverage, 23836,
     /* 1924636 */     GIR_EraseRootFromParent_Done,
     /* 1924637 */   // Label 25863: @1924637
     /* 1924637 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1924723), // Rule ID 23837 //
     /* 1924642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1924653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1924659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924688 */     // MIs[0] policy
     /* 1924688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924698 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1924701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924722 */     // GIR_Coverage, 23837,
     /* 1924722 */     GIR_EraseRootFromParent_Done,
     /* 1924723 */   // Label 25864: @1924723
     /* 1924723 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1924809), // Rule ID 23840 //
     /* 1924728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1924739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1924742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1924745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924774 */     // MIs[0] policy
     /* 1924774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1924787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924808 */     // GIR_Coverage, 23840,
     /* 1924808 */     GIR_EraseRootFromParent_Done,
     /* 1924809 */   // Label 25865: @1924809
     /* 1924809 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1924895), // Rule ID 23841 //
     /* 1924814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1924825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1924828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1924831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924860 */     // MIs[0] policy
     /* 1924860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924870 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1924873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924894 */     // GIR_Coverage, 23841,
     /* 1924894 */     GIR_EraseRootFromParent_Done,
     /* 1924895 */   // Label 25866: @1924895
     /* 1924895 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1924981), // Rule ID 23844 //
     /* 1924900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1924911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1924914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1924917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924946 */     // MIs[0] policy
     /* 1924946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1924959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924980 */     // GIR_Coverage, 23844,
     /* 1924980 */     GIR_EraseRootFromParent_Done,
     /* 1924981 */   // Label 25867: @1924981
     /* 1924981 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1925067), // Rule ID 23845 //
     /* 1924986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1924997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1925000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1925003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1925016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925032 */     // MIs[0] policy
     /* 1925032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1925045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925066 */     // GIR_Coverage, 23845,
     /* 1925066 */     GIR_EraseRootFromParent_Done,
     /* 1925067 */   // Label 25868: @1925067
     /* 1925067 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1925153), // Rule ID 23848 //
     /* 1925072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1925083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1925086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1925089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925118 */     // MIs[0] policy
     /* 1925118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1925131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925152 */     // GIR_Coverage, 23848,
     /* 1925152 */     GIR_EraseRootFromParent_Done,
     /* 1925153 */   // Label 25869: @1925153
     /* 1925153 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1925239), // Rule ID 23849 //
     /* 1925158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1925169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1925172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1925175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925204 */     // MIs[0] policy
     /* 1925204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1925217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925238 */     // GIR_Coverage, 23849,
     /* 1925238 */     GIR_EraseRootFromParent_Done,
     /* 1925239 */   // Label 25870: @1925239
     /* 1925239 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1925325), // Rule ID 23852 //
     /* 1925244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1925255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1925258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1925261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1925267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925290 */     // MIs[0] policy
     /* 1925290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1925303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925324 */     // GIR_Coverage, 23852,
     /* 1925324 */     GIR_EraseRootFromParent_Done,
     /* 1925325 */   // Label 25871: @1925325
     /* 1925325 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1925411), // Rule ID 23853 //
     /* 1925330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1925341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1925344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1925347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1925353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925376 */     // MIs[0] policy
     /* 1925376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925386 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1925389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925410 */     // GIR_Coverage, 23853,
     /* 1925410 */     GIR_EraseRootFromParent_Done,
     /* 1925411 */   // Label 25872: @1925411
     /* 1925411 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1925497), // Rule ID 23856 //
     /* 1925416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1925427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1925430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1925433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1925446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925462 */     // MIs[0] policy
     /* 1925462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1925475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925496 */     // GIR_Coverage, 23856,
     /* 1925496 */     GIR_EraseRootFromParent_Done,
     /* 1925497 */   // Label 25873: @1925497
     /* 1925497 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1925583), // Rule ID 23857 //
     /* 1925502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1925505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1925513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1925516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1925519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1925532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1925540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925548 */     // MIs[0] policy
     /* 1925548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1925561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925582 */     // GIR_Coverage, 23857,
     /* 1925582 */     GIR_EraseRootFromParent_Done,
     /* 1925583 */   // Label 25874: @1925583
     /* 1925583 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1925669), // Rule ID 23860 //
     /* 1925588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1925599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1925602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925634 */     // MIs[0] policy
     /* 1925634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1925647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925668 */     // GIR_Coverage, 23860,
     /* 1925668 */     GIR_EraseRootFromParent_Done,
     /* 1925669 */   // Label 25875: @1925669
     /* 1925669 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1925755), // Rule ID 23861 //
     /* 1925674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1925677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1925685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1925688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925720 */     // MIs[0] policy
     /* 1925720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925730 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1925733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925754 */     // GIR_Coverage, 23861,
     /* 1925754 */     GIR_EraseRootFromParent_Done,
     /* 1925755 */   // Label 25876: @1925755
     /* 1925755 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1925841), // Rule ID 23864 //
     /* 1925760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1925771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1925774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925806 */     // MIs[0] policy
     /* 1925806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1925819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925840 */     // GIR_Coverage, 23864,
     /* 1925840 */     GIR_EraseRootFromParent_Done,
     /* 1925841 */   // Label 25877: @1925841
     /* 1925841 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1925927), // Rule ID 23865 //
     /* 1925846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1925849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1925857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1925860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925892 */     // MIs[0] policy
     /* 1925892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1925905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925926 */     // GIR_Coverage, 23865,
     /* 1925926 */     GIR_EraseRootFromParent_Done,
     /* 1925927 */   // Label 25878: @1925927
     /* 1925927 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1926013), // Rule ID 23956 //
     /* 1925932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1925940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1925943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1925946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1925949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925978 */     // MIs[0] policy
     /* 1925978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925988 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1925991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926012 */     // GIR_Coverage, 23956,
     /* 1926012 */     GIR_EraseRootFromParent_Done,
     /* 1926013 */   // Label 25879: @1926013
     /* 1926013 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1926099), // Rule ID 23957 //
     /* 1926018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1926029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1926032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1926035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926064 */     // MIs[0] policy
     /* 1926064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926074 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1926077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926098 */     // GIR_Coverage, 23957,
     /* 1926098 */     GIR_EraseRootFromParent_Done,
     /* 1926099 */   // Label 25880: @1926099
     /* 1926099 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1926185), // Rule ID 23960 //
     /* 1926104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1926115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1926118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1926121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926150 */     // MIs[0] policy
     /* 1926150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1926163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926184 */     // GIR_Coverage, 23960,
     /* 1926184 */     GIR_EraseRootFromParent_Done,
     /* 1926185 */   // Label 25881: @1926185
     /* 1926185 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1926271), // Rule ID 23961 //
     /* 1926190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1926201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1926204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1926207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926236 */     // MIs[0] policy
     /* 1926236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1926249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926270 */     // GIR_Coverage, 23961,
     /* 1926270 */     GIR_EraseRootFromParent_Done,
     /* 1926271 */   // Label 25882: @1926271
     /* 1926271 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1926357), // Rule ID 23964 //
     /* 1926276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1926287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1926290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1926293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926322 */     // MIs[0] policy
     /* 1926322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926332 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926356 */     // GIR_Coverage, 23964,
     /* 1926356 */     GIR_EraseRootFromParent_Done,
     /* 1926357 */   // Label 25883: @1926357
     /* 1926357 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1926443), // Rule ID 23965 //
     /* 1926362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1926373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1926376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1926379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926408 */     // MIs[0] policy
     /* 1926408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926418 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926442 */     // GIR_Coverage, 23965,
     /* 1926442 */     GIR_EraseRootFromParent_Done,
     /* 1926443 */   // Label 25884: @1926443
     /* 1926443 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1926529), // Rule ID 23968 //
     /* 1926448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1926459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1926462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1926465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926494 */     // MIs[0] policy
     /* 1926494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926504 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1926507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926528 */     // GIR_Coverage, 23968,
     /* 1926528 */     GIR_EraseRootFromParent_Done,
     /* 1926529 */   // Label 25885: @1926529
     /* 1926529 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1926615), // Rule ID 23969 //
     /* 1926534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1926545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1926548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1926551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926580 */     // MIs[0] policy
     /* 1926580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1926593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926614 */     // GIR_Coverage, 23969,
     /* 1926614 */     GIR_EraseRootFromParent_Done,
     /* 1926615 */   // Label 25886: @1926615
     /* 1926615 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1926701), // Rule ID 23972 //
     /* 1926620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1926631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1926634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1926637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926666 */     // MIs[0] policy
     /* 1926666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926676 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926700 */     // GIR_Coverage, 23972,
     /* 1926700 */     GIR_EraseRootFromParent_Done,
     /* 1926701 */   // Label 25887: @1926701
     /* 1926701 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1926787), // Rule ID 23973 //
     /* 1926706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1926717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1926720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1926723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926752 */     // MIs[0] policy
     /* 1926752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926762 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926786 */     // GIR_Coverage, 23973,
     /* 1926786 */     GIR_EraseRootFromParent_Done,
     /* 1926787 */   // Label 25888: @1926787
     /* 1926787 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1926873), // Rule ID 23976 //
     /* 1926792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1926803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1926806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1926809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926838 */     // MIs[0] policy
     /* 1926838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926872 */     // GIR_Coverage, 23976,
     /* 1926872 */     GIR_EraseRootFromParent_Done,
     /* 1926873 */   // Label 25889: @1926873
     /* 1926873 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1926959), // Rule ID 23977 //
     /* 1926878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1926889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1926892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1926895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926924 */     // MIs[0] policy
     /* 1926924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926934 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1926937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926958 */     // GIR_Coverage, 23977,
     /* 1926958 */     GIR_EraseRootFromParent_Done,
     /* 1926959 */   // Label 25890: @1926959
     /* 1926959 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1927045), // Rule ID 23980 //
     /* 1926964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1926972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1926975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1926978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1926981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927010 */     // MIs[0] policy
     /* 1927010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927020 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927044 */     // GIR_Coverage, 23980,
     /* 1927044 */     GIR_EraseRootFromParent_Done,
     /* 1927045 */   // Label 25891: @1927045
     /* 1927045 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1927131), // Rule ID 23981 //
     /* 1927050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1927061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1927064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1927067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927096 */     // MIs[0] policy
     /* 1927096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927106 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927130 */     // GIR_Coverage, 23981,
     /* 1927130 */     GIR_EraseRootFromParent_Done,
     /* 1927131 */   // Label 25892: @1927131
     /* 1927131 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1927217), // Rule ID 23984 //
     /* 1927136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1927147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1927150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1927153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927182 */     // MIs[0] policy
     /* 1927182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927216 */     // GIR_Coverage, 23984,
     /* 1927216 */     GIR_EraseRootFromParent_Done,
     /* 1927217 */   // Label 25893: @1927217
     /* 1927217 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1927303), // Rule ID 23985 //
     /* 1927222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1927233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1927236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1927239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927268 */     // MIs[0] policy
     /* 1927268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927278 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927302 */     // GIR_Coverage, 23985,
     /* 1927302 */     GIR_EraseRootFromParent_Done,
     /* 1927303 */   // Label 25894: @1927303
     /* 1927303 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1927389), // Rule ID 23988 //
     /* 1927308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1927319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1927322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1927325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927354 */     // MIs[0] policy
     /* 1927354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927388 */     // GIR_Coverage, 23988,
     /* 1927388 */     GIR_EraseRootFromParent_Done,
     /* 1927389 */   // Label 25895: @1927389
     /* 1927389 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1927475), // Rule ID 23989 //
     /* 1927394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1927405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1927408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1927411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927440 */     // MIs[0] policy
     /* 1927440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927474 */     // GIR_Coverage, 23989,
     /* 1927474 */     GIR_EraseRootFromParent_Done,
     /* 1927475 */   // Label 25896: @1927475
     /* 1927475 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1927561), // Rule ID 23992 //
     /* 1927480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1927491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1927494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1927497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1927503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927526 */     // MIs[0] policy
     /* 1927526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927536 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927560 */     // GIR_Coverage, 23992,
     /* 1927560 */     GIR_EraseRootFromParent_Done,
     /* 1927561 */   // Label 25897: @1927561
     /* 1927561 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1927647), // Rule ID 23993 //
     /* 1927566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1927577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1927580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1927583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1927589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927612 */     // MIs[0] policy
     /* 1927612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1927625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927646 */     // GIR_Coverage, 23993,
     /* 1927646 */     GIR_EraseRootFromParent_Done,
     /* 1927647 */   // Label 25898: @1927647
     /* 1927647 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1927733), // Rule ID 23996 //
     /* 1927652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1927663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1927666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1927669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927698 */     // MIs[0] policy
     /* 1927698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927708 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1927711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927732 */     // GIR_Coverage, 23996,
     /* 1927732 */     GIR_EraseRootFromParent_Done,
     /* 1927733 */   // Label 25899: @1927733
     /* 1927733 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1927819), // Rule ID 23997 //
     /* 1927738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1927749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1927752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1927755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927784 */     // MIs[0] policy
     /* 1927784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927794 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1927797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927818 */     // GIR_Coverage, 23997,
     /* 1927818 */     GIR_EraseRootFromParent_Done,
     /* 1927819 */   // Label 25900: @1927819
     /* 1927819 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1927905), // Rule ID 24000 //
     /* 1927824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1927835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1927838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1927841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927870 */     // MIs[0] policy
     /* 1927870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927880 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1927883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927904 */     // GIR_Coverage, 24000,
     /* 1927904 */     GIR_EraseRootFromParent_Done,
     /* 1927905 */   // Label 25901: @1927905
     /* 1927905 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1927991), // Rule ID 24001 //
     /* 1927910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1927918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1927921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1927924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1927927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927956 */     // MIs[0] policy
     /* 1927956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927966 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1927969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927990 */     // GIR_Coverage, 24001,
     /* 1927990 */     GIR_EraseRootFromParent_Done,
     /* 1927991 */   // Label 25902: @1927991
     /* 1927991 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1928077), // Rule ID 24004 //
     /* 1927996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1928007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1928010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1928013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1928019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928042 */     // MIs[0] policy
     /* 1928042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1928055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928076 */     // GIR_Coverage, 24004,
     /* 1928076 */     GIR_EraseRootFromParent_Done,
     /* 1928077 */   // Label 25903: @1928077
     /* 1928077 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1928163), // Rule ID 24005 //
     /* 1928082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1928093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1928096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1928099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1928105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928128 */     // MIs[0] policy
     /* 1928128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928138 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1928141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928162 */     // GIR_Coverage, 24005,
     /* 1928162 */     GIR_EraseRootFromParent_Done,
     /* 1928163 */   // Label 25904: @1928163
     /* 1928163 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1928249), // Rule ID 24008 //
     /* 1928168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1928179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1928182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1928185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928214 */     // MIs[0] policy
     /* 1928214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1928227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928248 */     // GIR_Coverage, 24008,
     /* 1928248 */     GIR_EraseRootFromParent_Done,
     /* 1928249 */   // Label 25905: @1928249
     /* 1928249 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1928335), // Rule ID 24009 //
     /* 1928254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1928265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1928268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1928271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928300 */     // MIs[0] policy
     /* 1928300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1928313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928334 */     // GIR_Coverage, 24009,
     /* 1928334 */     GIR_EraseRootFromParent_Done,
     /* 1928335 */   // Label 25906: @1928335
     /* 1928335 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1928421), // Rule ID 24012 //
     /* 1928340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1928351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1928354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1928357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928386 */     // MIs[0] policy
     /* 1928386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1928399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928420 */     // GIR_Coverage, 24012,
     /* 1928420 */     GIR_EraseRootFromParent_Done,
     /* 1928421 */   // Label 25907: @1928421
     /* 1928421 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1928507), // Rule ID 24013 //
     /* 1928426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1928437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1928440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1928443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928472 */     // MIs[0] policy
     /* 1928472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1928485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928506 */     // GIR_Coverage, 24013,
     /* 1928506 */     GIR_EraseRootFromParent_Done,
     /* 1928507 */   // Label 25908: @1928507
     /* 1928507 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1928593), // Rule ID 24016 //
     /* 1928512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1928523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1928526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1928529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1928535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928558 */     // MIs[0] policy
     /* 1928558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1928571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928592 */     // GIR_Coverage, 24016,
     /* 1928592 */     GIR_EraseRootFromParent_Done,
     /* 1928593 */   // Label 25909: @1928593
     /* 1928593 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1928679), // Rule ID 24017 //
     /* 1928598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1928609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1928612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1928615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1928621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928644 */     // MIs[0] policy
     /* 1928644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928654 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1928657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928678 */     // GIR_Coverage, 24017,
     /* 1928678 */     GIR_EraseRootFromParent_Done,
     /* 1928679 */   // Label 25910: @1928679
     /* 1928679 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1928765), // Rule ID 24020 //
     /* 1928684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1928695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1928698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1928701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928730 */     // MIs[0] policy
     /* 1928730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1928743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928764 */     // GIR_Coverage, 24020,
     /* 1928764 */     GIR_EraseRootFromParent_Done,
     /* 1928765 */   // Label 25911: @1928765
     /* 1928765 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1928851), // Rule ID 24021 //
     /* 1928770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1928781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1928784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1928787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928816 */     // MIs[0] policy
     /* 1928816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1928829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928850 */     // GIR_Coverage, 24021,
     /* 1928850 */     GIR_EraseRootFromParent_Done,
     /* 1928851 */   // Label 25912: @1928851
     /* 1928851 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1928937), // Rule ID 24024 //
     /* 1928856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1928867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1928870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1928873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928902 */     // MIs[0] policy
     /* 1928902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928912 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1928915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928936 */     // GIR_Coverage, 24024,
     /* 1928936 */     GIR_EraseRootFromParent_Done,
     /* 1928937 */   // Label 25913: @1928937
     /* 1928937 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1929023), // Rule ID 24025 //
     /* 1928942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1928953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1928956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1928959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928988 */     // MIs[0] policy
     /* 1928988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1929001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929022 */     // GIR_Coverage, 24025,
     /* 1929022 */     GIR_EraseRootFromParent_Done,
     /* 1929023 */   // Label 25914: @1929023
     /* 1929023 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1929109), // Rule ID 24028 //
     /* 1929028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1929039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1929042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1929045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929074 */     // MIs[0] policy
     /* 1929074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1929087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929108 */     // GIR_Coverage, 24028,
     /* 1929108 */     GIR_EraseRootFromParent_Done,
     /* 1929109 */   // Label 25915: @1929109
     /* 1929109 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1929195), // Rule ID 24029 //
     /* 1929114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1929125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1929128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1929131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929160 */     // MIs[0] policy
     /* 1929160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1929173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929194 */     // GIR_Coverage, 24029,
     /* 1929194 */     GIR_EraseRootFromParent_Done,
     /* 1929195 */   // Label 25916: @1929195
     /* 1929195 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1929281), // Rule ID 24032 //
     /* 1929200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1929211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1929214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1929217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1929230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929246 */     // MIs[0] policy
     /* 1929246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1929259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929280 */     // GIR_Coverage, 24032,
     /* 1929280 */     GIR_EraseRootFromParent_Done,
     /* 1929281 */   // Label 25917: @1929281
     /* 1929281 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1929367), // Rule ID 24033 //
     /* 1929286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1929297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1929300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1929303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1929316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929332 */     // MIs[0] policy
     /* 1929332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1929345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929366 */     // GIR_Coverage, 24033,
     /* 1929366 */     GIR_EraseRootFromParent_Done,
     /* 1929367 */   // Label 25918: @1929367
     /* 1929367 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1929453), // Rule ID 24036 //
     /* 1929372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1929383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1929386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1929389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1929402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1929406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1929410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929418 */     // MIs[0] policy
     /* 1929418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1929431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929452 */     // GIR_Coverage, 24036,
     /* 1929452 */     GIR_EraseRootFromParent_Done,
     /* 1929453 */   // Label 25919: @1929453
     /* 1929453 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1929539), // Rule ID 24037 //
     /* 1929458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1929469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1929472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1929475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1929488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1929492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1929496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929504 */     // MIs[0] policy
     /* 1929504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929514 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1929517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929538 */     // GIR_Coverage, 24037,
     /* 1929538 */     GIR_EraseRootFromParent_Done,
     /* 1929539 */   // Label 25920: @1929539
     /* 1929539 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1929625), // Rule ID 24040 //
     /* 1929544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1929555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1929558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1929561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929590 */     // MIs[0] policy
     /* 1929590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929600 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1929603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929624 */     // GIR_Coverage, 24040,
     /* 1929624 */     GIR_EraseRootFromParent_Done,
     /* 1929625 */   // Label 25921: @1929625
     /* 1929625 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1929711), // Rule ID 24041 //
     /* 1929630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1929641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1929644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1929647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929676 */     // MIs[0] policy
     /* 1929676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929686 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1929689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929710 */     // GIR_Coverage, 24041,
     /* 1929710 */     GIR_EraseRootFromParent_Done,
     /* 1929711 */   // Label 25922: @1929711
     /* 1929711 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1929797), // Rule ID 24044 //
     /* 1929716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1929724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1929727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1929730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1929733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929762 */     // MIs[0] policy
     /* 1929762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1929775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929796 */     // GIR_Coverage, 24044,
     /* 1929796 */     GIR_EraseRootFromParent_Done,
     /* 1929797 */   // Label 25923: @1929797
     /* 1929797 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1929883), // Rule ID 24045 //
     /* 1929802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1929810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1929813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1929816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1929819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929848 */     // MIs[0] policy
     /* 1929848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929858 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1929861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929882 */     // GIR_Coverage, 24045,
     /* 1929882 */     GIR_EraseRootFromParent_Done,
     /* 1929883 */   // Label 25924: @1929883
     /* 1929883 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1929969), // Rule ID 24048 //
     /* 1929888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1929896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1929899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1929902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1929905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929934 */     // MIs[0] policy
     /* 1929934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929944 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1929947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929968 */     // GIR_Coverage, 24048,
     /* 1929968 */     GIR_EraseRootFromParent_Done,
     /* 1929969 */   // Label 25925: @1929969
     /* 1929969 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1930055), // Rule ID 24049 //
     /* 1929974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1929982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1929985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1929988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1929991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930020 */     // MIs[0] policy
     /* 1930020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1930033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930054 */     // GIR_Coverage, 24049,
     /* 1930054 */     GIR_EraseRootFromParent_Done,
     /* 1930055 */   // Label 25926: @1930055
     /* 1930055 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1930141), // Rule ID 24052 //
     /* 1930060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1930071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1930074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1930077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930106 */     // MIs[0] policy
     /* 1930106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930116 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930140 */     // GIR_Coverage, 24052,
     /* 1930140 */     GIR_EraseRootFromParent_Done,
     /* 1930141 */   // Label 25927: @1930141
     /* 1930141 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1930227), // Rule ID 24053 //
     /* 1930146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1930157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1930160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1930163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930192 */     // MIs[0] policy
     /* 1930192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930202 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930226 */     // GIR_Coverage, 24053,
     /* 1930226 */     GIR_EraseRootFromParent_Done,
     /* 1930227 */   // Label 25928: @1930227
     /* 1930227 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1930313), // Rule ID 24056 //
     /* 1930232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1930243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1930246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1930249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930278 */     // MIs[0] policy
     /* 1930278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930288 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1930291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930312 */     // GIR_Coverage, 24056,
     /* 1930312 */     GIR_EraseRootFromParent_Done,
     /* 1930313 */   // Label 25929: @1930313
     /* 1930313 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1930399), // Rule ID 24057 //
     /* 1930318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1930329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1930332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1930335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930364 */     // MIs[0] policy
     /* 1930364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1930377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930398 */     // GIR_Coverage, 24057,
     /* 1930398 */     GIR_EraseRootFromParent_Done,
     /* 1930399 */   // Label 25930: @1930399
     /* 1930399 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1930485), // Rule ID 24060 //
     /* 1930404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1930415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1930418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1930421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930450 */     // MIs[0] policy
     /* 1930450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930484 */     // GIR_Coverage, 24060,
     /* 1930484 */     GIR_EraseRootFromParent_Done,
     /* 1930485 */   // Label 25931: @1930485
     /* 1930485 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1930571), // Rule ID 24061 //
     /* 1930490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1930501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1930504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1930507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1930513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930536 */     // MIs[0] policy
     /* 1930536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930570 */     // GIR_Coverage, 24061,
     /* 1930570 */     GIR_EraseRootFromParent_Done,
     /* 1930571 */   // Label 25932: @1930571
     /* 1930571 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1930657), // Rule ID 24064 //
     /* 1930576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1930587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1930590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1930593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930622 */     // MIs[0] policy
     /* 1930622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930656 */     // GIR_Coverage, 24064,
     /* 1930656 */     GIR_EraseRootFromParent_Done,
     /* 1930657 */   // Label 25933: @1930657
     /* 1930657 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1930743), // Rule ID 24065 //
     /* 1930662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1930673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1930676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1930679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930708 */     // MIs[0] policy
     /* 1930708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930718 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1930721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930742 */     // GIR_Coverage, 24065,
     /* 1930742 */     GIR_EraseRootFromParent_Done,
     /* 1930743 */   // Label 25934: @1930743
     /* 1930743 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1930829), // Rule ID 24068 //
     /* 1930748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1930759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1930762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1930765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930794 */     // MIs[0] policy
     /* 1930794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1930807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930828 */     // GIR_Coverage, 24068,
     /* 1930828 */     GIR_EraseRootFromParent_Done,
     /* 1930829 */   // Label 25935: @1930829
     /* 1930829 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1930915), // Rule ID 24069 //
     /* 1930834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1930845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1930848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1930851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930880 */     // MIs[0] policy
     /* 1930880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1930893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930914 */     // GIR_Coverage, 24069,
     /* 1930914 */     GIR_EraseRootFromParent_Done,
     /* 1930915 */   // Label 25936: @1930915
     /* 1930915 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1931001), // Rule ID 24072 //
     /* 1930920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1930928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1930931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1930934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1930937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930966 */     // MIs[0] policy
     /* 1930966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1930979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931000 */     // GIR_Coverage, 24072,
     /* 1931000 */     GIR_EraseRootFromParent_Done,
     /* 1931001 */   // Label 25937: @1931001
     /* 1931001 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1931087), // Rule ID 24073 //
     /* 1931006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1931017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1931020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1931023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931052 */     // MIs[0] policy
     /* 1931052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1931065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931086 */     // GIR_Coverage, 24073,
     /* 1931086 */     GIR_EraseRootFromParent_Done,
     /* 1931087 */   // Label 25938: @1931087
     /* 1931087 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1931173), // Rule ID 24076 //
     /* 1931092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1931103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1931106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1931109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931138 */     // MIs[0] policy
     /* 1931138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931148 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1931151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931172 */     // GIR_Coverage, 24076,
     /* 1931172 */     GIR_EraseRootFromParent_Done,
     /* 1931173 */   // Label 25939: @1931173
     /* 1931173 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1931259), // Rule ID 24077 //
     /* 1931178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1931189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1931192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1931195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931224 */     // MIs[0] policy
     /* 1931224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1931237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931258 */     // GIR_Coverage, 24077,
     /* 1931258 */     GIR_EraseRootFromParent_Done,
     /* 1931259 */   // Label 25940: @1931259
     /* 1931259 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1931345), // Rule ID 24080 //
     /* 1931264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1931275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1931278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1931281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931310 */     // MIs[0] policy
     /* 1931310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931320 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1931323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931344 */     // GIR_Coverage, 24080,
     /* 1931344 */     GIR_EraseRootFromParent_Done,
     /* 1931345 */   // Label 25941: @1931345
     /* 1931345 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1931431), // Rule ID 24081 //
     /* 1931350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1931361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1931364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1931367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931396 */     // MIs[0] policy
     /* 1931396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1931409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931430 */     // GIR_Coverage, 24081,
     /* 1931430 */     GIR_EraseRootFromParent_Done,
     /* 1931431 */   // Label 25942: @1931431
     /* 1931431 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1931517), // Rule ID 24084 //
     /* 1931436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1931447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1931450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1931453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931482 */     // MIs[0] policy
     /* 1931482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1931495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931516 */     // GIR_Coverage, 24084,
     /* 1931516 */     GIR_EraseRootFromParent_Done,
     /* 1931517 */   // Label 25943: @1931517
     /* 1931517 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1931603), // Rule ID 24085 //
     /* 1931522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1931533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1931536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1931539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931568 */     // MIs[0] policy
     /* 1931568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1931581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931602 */     // GIR_Coverage, 24085,
     /* 1931602 */     GIR_EraseRootFromParent_Done,
     /* 1931603 */   // Label 25944: @1931603
     /* 1931603 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1931689), // Rule ID 24088 //
     /* 1931608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1931619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1931622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1931625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931654 */     // MIs[0] policy
     /* 1931654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931664 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1931667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931688 */     // GIR_Coverage, 24088,
     /* 1931688 */     GIR_EraseRootFromParent_Done,
     /* 1931689 */   // Label 25945: @1931689
     /* 1931689 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1931775), // Rule ID 24089 //
     /* 1931694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1931705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1931708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1931711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1931717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931740 */     // MIs[0] policy
     /* 1931740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931750 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1931753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931774 */     // GIR_Coverage, 24089,
     /* 1931774 */     GIR_EraseRootFromParent_Done,
     /* 1931775 */   // Label 25946: @1931775
     /* 1931775 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1931861), // Rule ID 24092 //
     /* 1931780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1931791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1931794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1931797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1931803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931826 */     // MIs[0] policy
     /* 1931826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931836 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1931839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931860 */     // GIR_Coverage, 24092,
     /* 1931860 */     GIR_EraseRootFromParent_Done,
     /* 1931861 */   // Label 25947: @1931861
     /* 1931861 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1931947), // Rule ID 24093 //
     /* 1931866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1931877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1931880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1931883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1931889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931912 */     // MIs[0] policy
     /* 1931912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931922 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1931925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1931943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931946 */     // GIR_Coverage, 24093,
     /* 1931946 */     GIR_EraseRootFromParent_Done,
     /* 1931947 */   // Label 25948: @1931947
     /* 1931947 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1932033), // Rule ID 24096 //
     /* 1931952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1931963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1931966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1931969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931998 */     // MIs[0] policy
     /* 1931998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1932011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932032 */     // GIR_Coverage, 24096,
     /* 1932032 */     GIR_EraseRootFromParent_Done,
     /* 1932033 */   // Label 25949: @1932033
     /* 1932033 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1932119), // Rule ID 24097 //
     /* 1932038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1932049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1932052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1932055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932084 */     // MIs[0] policy
     /* 1932084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1932097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932118 */     // GIR_Coverage, 24097,
     /* 1932118 */     GIR_EraseRootFromParent_Done,
     /* 1932119 */   // Label 25950: @1932119
     /* 1932119 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1932205), // Rule ID 24100 //
     /* 1932124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1932135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1932138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1932141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932170 */     // MIs[0] policy
     /* 1932170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1932183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932204 */     // GIR_Coverage, 24100,
     /* 1932204 */     GIR_EraseRootFromParent_Done,
     /* 1932205 */   // Label 25951: @1932205
     /* 1932205 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1932291), // Rule ID 24101 //
     /* 1932210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1932221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1932224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1932227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932256 */     // MIs[0] policy
     /* 1932256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1932269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932290 */     // GIR_Coverage, 24101,
     /* 1932290 */     GIR_EraseRootFromParent_Done,
     /* 1932291 */   // Label 25952: @1932291
     /* 1932291 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1932377), // Rule ID 24104 //
     /* 1932296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1932307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1932310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1932313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1932319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932342 */     // MIs[0] policy
     /* 1932342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932352 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1932355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932376 */     // GIR_Coverage, 24104,
     /* 1932376 */     GIR_EraseRootFromParent_Done,
     /* 1932377 */   // Label 25953: @1932377
     /* 1932377 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1932463), // Rule ID 24105 //
     /* 1932382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1932393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1932396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1932399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1932405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932428 */     // MIs[0] policy
     /* 1932428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932438 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1932441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932462 */     // GIR_Coverage, 24105,
     /* 1932462 */     GIR_EraseRootFromParent_Done,
     /* 1932463 */   // Label 25954: @1932463
     /* 1932463 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1932549), // Rule ID 24108 //
     /* 1932468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1932479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1932482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1932485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932514 */     // MIs[0] policy
     /* 1932514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1932527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932548 */     // GIR_Coverage, 24108,
     /* 1932548 */     GIR_EraseRootFromParent_Done,
     /* 1932549 */   // Label 25955: @1932549
     /* 1932549 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1932635), // Rule ID 24109 //
     /* 1932554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1932565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1932568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1932571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932600 */     // MIs[0] policy
     /* 1932600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1932613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932634 */     // GIR_Coverage, 24109,
     /* 1932634 */     GIR_EraseRootFromParent_Done,
     /* 1932635 */   // Label 25956: @1932635
     /* 1932635 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1932721), // Rule ID 24112 //
     /* 1932640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1932651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1932654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1932657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932686 */     // MIs[0] policy
     /* 1932686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1932699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932720 */     // GIR_Coverage, 24112,
     /* 1932720 */     GIR_EraseRootFromParent_Done,
     /* 1932721 */   // Label 25957: @1932721
     /* 1932721 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1932807), // Rule ID 24113 //
     /* 1932726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1932737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1932740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1932743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932772 */     // MIs[0] policy
     /* 1932772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1932785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932806 */     // GIR_Coverage, 24113,
     /* 1932806 */     GIR_EraseRootFromParent_Done,
     /* 1932807 */   // Label 25958: @1932807
     /* 1932807 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1932893), // Rule ID 24116 //
     /* 1932812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1932823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1932826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1932829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932858 */     // MIs[0] policy
     /* 1932858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1932871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932892 */     // GIR_Coverage, 24116,
     /* 1932892 */     GIR_EraseRootFromParent_Done,
     /* 1932893 */   // Label 25959: @1932893
     /* 1932893 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1932979), // Rule ID 24117 //
     /* 1932898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1932909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1932912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1932915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1932928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1932936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932944 */     // MIs[0] policy
     /* 1932944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1932957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932978 */     // GIR_Coverage, 24117,
     /* 1932978 */     GIR_EraseRootFromParent_Done,
     /* 1932979 */   // Label 25960: @1932979
     /* 1932979 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1933065), // Rule ID 24120 //
     /* 1932984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1932987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1932995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1932998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1933001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933030 */     // MIs[0] policy
     /* 1933030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933064 */     // GIR_Coverage, 24120,
     /* 1933064 */     GIR_EraseRootFromParent_Done,
     /* 1933065 */   // Label 25961: @1933065
     /* 1933065 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1933151), // Rule ID 24121 //
     /* 1933070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1933081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1933084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1933087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933116 */     // MIs[0] policy
     /* 1933116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933150 */     // GIR_Coverage, 24121,
     /* 1933150 */     GIR_EraseRootFromParent_Done,
     /* 1933151 */   // Label 25962: @1933151
     /* 1933151 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1933237), // Rule ID 24124 //
     /* 1933156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1933167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1933170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1933173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933202 */     // MIs[0] policy
     /* 1933202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933236 */     // GIR_Coverage, 24124,
     /* 1933236 */     GIR_EraseRootFromParent_Done,
     /* 1933237 */   // Label 25963: @1933237
     /* 1933237 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1933323), // Rule ID 24125 //
     /* 1933242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1933253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1933256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1933259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933288 */     // MIs[0] policy
     /* 1933288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933298 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933322 */     // GIR_Coverage, 24125,
     /* 1933322 */     GIR_EraseRootFromParent_Done,
     /* 1933323 */   // Label 25964: @1933323
     /* 1933323 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1933409), // Rule ID 24128 //
     /* 1933328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1933339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1933342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1933345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933374 */     // MIs[0] policy
     /* 1933374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1933387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933408 */     // GIR_Coverage, 24128,
     /* 1933408 */     GIR_EraseRootFromParent_Done,
     /* 1933409 */   // Label 25965: @1933409
     /* 1933409 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1933495), // Rule ID 24129 //
     /* 1933414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1933425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1933428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1933431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933460 */     // MIs[0] policy
     /* 1933460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933470 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1933473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933494 */     // GIR_Coverage, 24129,
     /* 1933494 */     GIR_EraseRootFromParent_Done,
     /* 1933495 */   // Label 25966: @1933495
     /* 1933495 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1933581), // Rule ID 24132 //
     /* 1933500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1933503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933546 */     // MIs[0] policy
     /* 1933546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933556 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1933559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933580 */     // GIR_Coverage, 24132,
     /* 1933580 */     GIR_EraseRootFromParent_Done,
     /* 1933581 */   // Label 25967: @1933581
     /* 1933581 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1933667), // Rule ID 24133 //
     /* 1933586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1933589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1933597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1933600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1933603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933632 */     // MIs[0] policy
     /* 1933632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933642 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1933645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933666 */     // GIR_Coverage, 24133,
     /* 1933666 */     GIR_EraseRootFromParent_Done,
     /* 1933667 */   // Label 25968: @1933667
     /* 1933667 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1933753), // Rule ID 24136 //
     /* 1933672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1933675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933718 */     // MIs[0] policy
     /* 1933718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933728 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1933731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933752 */     // GIR_Coverage, 24136,
     /* 1933752 */     GIR_EraseRootFromParent_Done,
     /* 1933753 */   // Label 25969: @1933753
     /* 1933753 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1933839), // Rule ID 24137 //
     /* 1933758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1933761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1933769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1933772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1933775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933804 */     // MIs[0] policy
     /* 1933804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933814 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1933817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933838 */     // GIR_Coverage, 24137,
     /* 1933838 */     GIR_EraseRootFromParent_Done,
     /* 1933839 */   // Label 25970: @1933839
     /* 1933839 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1933925), // Rule ID 24140 //
     /* 1933844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1933847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933890 */     // MIs[0] policy
     /* 1933890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933900 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1933903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933924 */     // GIR_Coverage, 24140,
     /* 1933924 */     GIR_EraseRootFromParent_Done,
     /* 1933925 */   // Label 25971: @1933925
     /* 1933925 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1934011), // Rule ID 24141 //
     /* 1933930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1933933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1933938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1933941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1933944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1933947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933976 */     // MIs[0] policy
     /* 1933976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933986 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1933989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934010 */     // GIR_Coverage, 24141,
     /* 1934010 */     GIR_EraseRootFromParent_Done,
     /* 1934011 */   // Label 25972: @1934011
     /* 1934011 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1934097), // Rule ID 24144 //
     /* 1934016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934062 */     // MIs[0] policy
     /* 1934062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934072 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934096 */     // GIR_Coverage, 24144,
     /* 1934096 */     GIR_EraseRootFromParent_Done,
     /* 1934097 */   // Label 25973: @1934097
     /* 1934097 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1934183), // Rule ID 24145 //
     /* 1934102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934148 */     // MIs[0] policy
     /* 1934148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934182 */     // GIR_Coverage, 24145,
     /* 1934182 */     GIR_EraseRootFromParent_Done,
     /* 1934183 */   // Label 25974: @1934183
     /* 1934183 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1934269), // Rule ID 24148 //
     /* 1934188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1934191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1934199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1934202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1934205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934234 */     // MIs[0] policy
     /* 1934234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934244 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934268 */     // GIR_Coverage, 24148,
     /* 1934268 */     GIR_EraseRootFromParent_Done,
     /* 1934269 */   // Label 25975: @1934269
     /* 1934269 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1934355), // Rule ID 24149 //
     /* 1934274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1934277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1934285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1934288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1934291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934320 */     // MIs[0] policy
     /* 1934320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934354 */     // GIR_Coverage, 24149,
     /* 1934354 */     GIR_EraseRootFromParent_Done,
     /* 1934355 */   // Label 25976: @1934355
     /* 1934355 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1934441), // Rule ID 24152 //
     /* 1934360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1934363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934406 */     // MIs[0] policy
     /* 1934406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934440 */     // GIR_Coverage, 24152,
     /* 1934440 */     GIR_EraseRootFromParent_Done,
     /* 1934441 */   // Label 25977: @1934441
     /* 1934441 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1934527), // Rule ID 24153 //
     /* 1934446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1934449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1934457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1934460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1934463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934492 */     // MIs[0] policy
     /* 1934492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934502 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1934505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934526 */     // GIR_Coverage, 24153,
     /* 1934526 */     GIR_EraseRootFromParent_Done,
     /* 1934527 */   // Label 25978: @1934527
     /* 1934527 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1934613), // Rule ID 24156 //
     /* 1934532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934578 */     // MIs[0] policy
     /* 1934578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934588 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1934591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934612 */     // GIR_Coverage, 24156,
     /* 1934612 */     GIR_EraseRootFromParent_Done,
     /* 1934613 */   // Label 25979: @1934613
     /* 1934613 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1934699), // Rule ID 24157 //
     /* 1934618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934664 */     // MIs[0] policy
     /* 1934664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934674 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1934677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934698 */     // GIR_Coverage, 24157,
     /* 1934698 */     GIR_EraseRootFromParent_Done,
     /* 1934699 */   // Label 25980: @1934699
     /* 1934699 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1934785), // Rule ID 24160 //
     /* 1934704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934750 */     // MIs[0] policy
     /* 1934750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934760 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1934763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934784 */     // GIR_Coverage, 24160,
     /* 1934784 */     GIR_EraseRootFromParent_Done,
     /* 1934785 */   // Label 25981: @1934785
     /* 1934785 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1934871), // Rule ID 24161 //
     /* 1934790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934836 */     // MIs[0] policy
     /* 1934836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934846 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1934849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934870 */     // GIR_Coverage, 24161,
     /* 1934870 */     GIR_EraseRootFromParent_Done,
     /* 1934871 */   // Label 25982: @1934871
     /* 1934871 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1934957), // Rule ID 24164 //
     /* 1934876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934922 */     // MIs[0] policy
     /* 1934922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934932 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1934935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934956 */     // GIR_Coverage, 24164,
     /* 1934956 */     GIR_EraseRootFromParent_Done,
     /* 1934957 */   // Label 25983: @1934957
     /* 1934957 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1935043), // Rule ID 24165 //
     /* 1934962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1934970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935008 */     // MIs[0] policy
     /* 1935008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935018 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1935021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935042 */     // GIR_Coverage, 24165,
     /* 1935042 */     GIR_EraseRootFromParent_Done,
     /* 1935043 */   // Label 25984: @1935043
     /* 1935043 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1935129), // Rule ID 24168 //
     /* 1935048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1935051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935094 */     // MIs[0] policy
     /* 1935094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935104 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1935107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935128 */     // GIR_Coverage, 24168,
     /* 1935128 */     GIR_EraseRootFromParent_Done,
     /* 1935129 */   // Label 25985: @1935129
     /* 1935129 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1935215), // Rule ID 24169 //
     /* 1935134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1935137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935180 */     // MIs[0] policy
     /* 1935180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935190 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1935193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935214 */     // GIR_Coverage, 24169,
     /* 1935214 */     GIR_EraseRootFromParent_Done,
     /* 1935215 */   // Label 25986: @1935215
     /* 1935215 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1935301), // Rule ID 24172 //
     /* 1935220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1935223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935266 */     // MIs[0] policy
     /* 1935266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1935279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935300 */     // GIR_Coverage, 24172,
     /* 1935300 */     GIR_EraseRootFromParent_Done,
     /* 1935301 */   // Label 25987: @1935301
     /* 1935301 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1935387), // Rule ID 24173 //
     /* 1935306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1935309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1935317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1935320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1935323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935352 */     // MIs[0] policy
     /* 1935352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935362 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1935365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935386 */     // GIR_Coverage, 24173,
     /* 1935386 */     GIR_EraseRootFromParent_Done,
     /* 1935387 */   // Label 25988: @1935387
     /* 1935387 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1935473), // Rule ID 24176 //
     /* 1935392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1935395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935438 */     // MIs[0] policy
     /* 1935438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935448 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1935451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935472 */     // GIR_Coverage, 24176,
     /* 1935472 */     GIR_EraseRootFromParent_Done,
     /* 1935473 */   // Label 25989: @1935473
     /* 1935473 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1935559), // Rule ID 24177 //
     /* 1935478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1935481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935524 */     // MIs[0] policy
     /* 1935524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1935537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935558 */     // GIR_Coverage, 24177,
     /* 1935558 */     GIR_EraseRootFromParent_Done,
     /* 1935559 */   // Label 25990: @1935559
     /* 1935559 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1935645), // Rule ID 24180 //
     /* 1935564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1935567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935610 */     // MIs[0] policy
     /* 1935610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935620 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1935623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935644 */     // GIR_Coverage, 24180,
     /* 1935644 */     GIR_EraseRootFromParent_Done,
     /* 1935645 */   // Label 25991: @1935645
     /* 1935645 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1935731), // Rule ID 24181 //
     /* 1935650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1935653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935696 */     // MIs[0] policy
     /* 1935696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935706 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1935709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935730 */     // GIR_Coverage, 24181,
     /* 1935730 */     GIR_EraseRootFromParent_Done,
     /* 1935731 */   // Label 25992: @1935731
     /* 1935731 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1935817), // Rule ID 24184 //
     /* 1935736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1935739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935782 */     // MIs[0] policy
     /* 1935782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935792 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1935795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935816 */     // GIR_Coverage, 24184,
     /* 1935816 */     GIR_EraseRootFromParent_Done,
     /* 1935817 */   // Label 25993: @1935817
     /* 1935817 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1935903), // Rule ID 24185 //
     /* 1935822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1935825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935868 */     // MIs[0] policy
     /* 1935868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935878 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1935881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935902 */     // GIR_Coverage, 24185,
     /* 1935902 */     GIR_EraseRootFromParent_Done,
     /* 1935903 */   // Label 25994: @1935903
     /* 1935903 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1935989), // Rule ID 24188 //
     /* 1935908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1935911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935954 */     // MIs[0] policy
     /* 1935954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1935967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935988 */     // GIR_Coverage, 24188,
     /* 1935988 */     GIR_EraseRootFromParent_Done,
     /* 1935989 */   // Label 25995: @1935989
     /* 1935989 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1936075), // Rule ID 24189 //
     /* 1935994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1935997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936040 */     // MIs[0] policy
     /* 1936040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1936053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936074 */     // GIR_Coverage, 24189,
     /* 1936074 */     GIR_EraseRootFromParent_Done,
     /* 1936075 */   // Label 25996: @1936075
     /* 1936075 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1936161), // Rule ID 24252 //
     /* 1936080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1936083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936126 */     // MIs[0] policy
     /* 1936126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936136 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1936139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936160 */     // GIR_Coverage, 24252,
     /* 1936160 */     GIR_EraseRootFromParent_Done,
     /* 1936161 */   // Label 25997: @1936161
     /* 1936161 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1936247), // Rule ID 24253 //
     /* 1936166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1936169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936212 */     // MIs[0] policy
     /* 1936212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936222 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1936225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936246 */     // GIR_Coverage, 24253,
     /* 1936246 */     GIR_EraseRootFromParent_Done,
     /* 1936247 */   // Label 25998: @1936247
     /* 1936247 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1936333), // Rule ID 24256 //
     /* 1936252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1936255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936298 */     // MIs[0] policy
     /* 1936298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936308 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1936311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936332 */     // GIR_Coverage, 24256,
     /* 1936332 */     GIR_EraseRootFromParent_Done,
     /* 1936333 */   // Label 25999: @1936333
     /* 1936333 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1936419), // Rule ID 24257 //
     /* 1936338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1936341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936384 */     // MIs[0] policy
     /* 1936384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936394 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1936397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936418 */     // GIR_Coverage, 24257,
     /* 1936418 */     GIR_EraseRootFromParent_Done,
     /* 1936419 */   // Label 26000: @1936419
     /* 1936419 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1936505), // Rule ID 24260 //
     /* 1936424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936470 */     // MIs[0] policy
     /* 1936470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936480 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1936483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936504 */     // GIR_Coverage, 24260,
     /* 1936504 */     GIR_EraseRootFromParent_Done,
     /* 1936505 */   // Label 26001: @1936505
     /* 1936505 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1936591), // Rule ID 24261 //
     /* 1936510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936556 */     // MIs[0] policy
     /* 1936556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936566 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1936569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936590 */     // GIR_Coverage, 24261,
     /* 1936590 */     GIR_EraseRootFromParent_Done,
     /* 1936591 */   // Label 26002: @1936591
     /* 1936591 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1936677), // Rule ID 24264 //
     /* 1936596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1936599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936642 */     // MIs[0] policy
     /* 1936642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936652 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1936655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936676 */     // GIR_Coverage, 24264,
     /* 1936676 */     GIR_EraseRootFromParent_Done,
     /* 1936677 */   // Label 26003: @1936677
     /* 1936677 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1936763), // Rule ID 24265 //
     /* 1936682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1936685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936728 */     // MIs[0] policy
     /* 1936728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936738 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1936741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936762 */     // GIR_Coverage, 24265,
     /* 1936762 */     GIR_EraseRootFromParent_Done,
     /* 1936763 */   // Label 26004: @1936763
     /* 1936763 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1936849), // Rule ID 24268 //
     /* 1936768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936814 */     // MIs[0] policy
     /* 1936814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1936827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936848 */     // GIR_Coverage, 24268,
     /* 1936848 */     GIR_EraseRootFromParent_Done,
     /* 1936849 */   // Label 26005: @1936849
     /* 1936849 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1936935), // Rule ID 24269 //
     /* 1936854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936900 */     // MIs[0] policy
     /* 1936900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936910 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1936913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936934 */     // GIR_Coverage, 24269,
     /* 1936934 */     GIR_EraseRootFromParent_Done,
     /* 1936935 */   // Label 26006: @1936935
     /* 1936935 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1937021), // Rule ID 24272 //
     /* 1936940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1936943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1936948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1936951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1936954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1936957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936986 */     // MIs[0] policy
     /* 1936986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936996 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1936999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937020 */     // GIR_Coverage, 24272,
     /* 1937020 */     GIR_EraseRootFromParent_Done,
     /* 1937021 */   // Label 26007: @1937021
     /* 1937021 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1937107), // Rule ID 24273 //
     /* 1937026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1937029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937072 */     // MIs[0] policy
     /* 1937072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937082 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1937085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937106 */     // GIR_Coverage, 24273,
     /* 1937106 */     GIR_EraseRootFromParent_Done,
     /* 1937107 */   // Label 26008: @1937107
     /* 1937107 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1937193), // Rule ID 24276 //
     /* 1937112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937158 */     // MIs[0] policy
     /* 1937158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937168 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1937171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937192 */     // GIR_Coverage, 24276,
     /* 1937192 */     GIR_EraseRootFromParent_Done,
     /* 1937193 */   // Label 26009: @1937193
     /* 1937193 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1937279), // Rule ID 24277 //
     /* 1937198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1937201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937244 */     // MIs[0] policy
     /* 1937244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1937257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937278 */     // GIR_Coverage, 24277,
     /* 1937278 */     GIR_EraseRootFromParent_Done,
     /* 1937279 */   // Label 26010: @1937279
     /* 1937279 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1937365), // Rule ID 24280 //
     /* 1937284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937330 */     // MIs[0] policy
     /* 1937330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937340 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1937343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937364 */     // GIR_Coverage, 24280,
     /* 1937364 */     GIR_EraseRootFromParent_Done,
     /* 1937365 */   // Label 26011: @1937365
     /* 1937365 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1937451), // Rule ID 24281 //
     /* 1937370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1937373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937416 */     // MIs[0] policy
     /* 1937416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937426 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1937429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937450 */     // GIR_Coverage, 24281,
     /* 1937450 */     GIR_EraseRootFromParent_Done,
     /* 1937451 */   // Label 26012: @1937451
     /* 1937451 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1937537), // Rule ID 24284 //
     /* 1937456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937502 */     // MIs[0] policy
     /* 1937502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937512 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1937515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937536 */     // GIR_Coverage, 24284,
     /* 1937536 */     GIR_EraseRootFromParent_Done,
     /* 1937537 */   // Label 26013: @1937537
     /* 1937537 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1937623), // Rule ID 24285 //
     /* 1937542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1937545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937588 */     // MIs[0] policy
     /* 1937588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937598 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1937601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937622 */     // GIR_Coverage, 24285,
     /* 1937622 */     GIR_EraseRootFromParent_Done,
     /* 1937623 */   // Label 26014: @1937623
     /* 1937623 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1937709), // Rule ID 24288 //
     /* 1937628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937674 */     // MIs[0] policy
     /* 1937674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937684 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1937687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937708 */     // GIR_Coverage, 24288,
     /* 1937708 */     GIR_EraseRootFromParent_Done,
     /* 1937709 */   // Label 26015: @1937709
     /* 1937709 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1937795), // Rule ID 24289 //
     /* 1937714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937760 */     // MIs[0] policy
     /* 1937760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937770 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1937773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937794 */     // GIR_Coverage, 24289,
     /* 1937794 */     GIR_EraseRootFromParent_Done,
     /* 1937795 */   // Label 26016: @1937795
     /* 1937795 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1937881), // Rule ID 24292 //
     /* 1937800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937846 */     // MIs[0] policy
     /* 1937846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1937859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937880 */     // GIR_Coverage, 24292,
     /* 1937880 */     GIR_EraseRootFromParent_Done,
     /* 1937881 */   // Label 26017: @1937881
     /* 1937881 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1937967), // Rule ID 24293 //
     /* 1937886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937932 */     // MIs[0] policy
     /* 1937932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937942 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1937945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937966 */     // GIR_Coverage, 24293,
     /* 1937966 */     GIR_EraseRootFromParent_Done,
     /* 1937967 */   // Label 26018: @1937967
     /* 1937967 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1938053), // Rule ID 24296 //
     /* 1937972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1937980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1937983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1937986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1937989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938018 */     // MIs[0] policy
     /* 1938018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938028 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1938031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938052 */     // GIR_Coverage, 24296,
     /* 1938052 */     GIR_EraseRootFromParent_Done,
     /* 1938053 */   // Label 26019: @1938053
     /* 1938053 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1938139), // Rule ID 24297 //
     /* 1938058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1938061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938104 */     // MIs[0] policy
     /* 1938104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938114 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1938117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938138 */     // GIR_Coverage, 24297,
     /* 1938138 */     GIR_EraseRootFromParent_Done,
     /* 1938139 */   // Label 26020: @1938139
     /* 1938139 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1938225), // Rule ID 24300 //
     /* 1938144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1938147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938190 */     // MIs[0] policy
     /* 1938190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1938203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938224 */     // GIR_Coverage, 24300,
     /* 1938224 */     GIR_EraseRootFromParent_Done,
     /* 1938225 */   // Label 26021: @1938225
     /* 1938225 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1938311), // Rule ID 24301 //
     /* 1938230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1938233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938276 */     // MIs[0] policy
     /* 1938276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938286 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1938289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938310 */     // GIR_Coverage, 24301,
     /* 1938310 */     GIR_EraseRootFromParent_Done,
     /* 1938311 */   // Label 26022: @1938311
     /* 1938311 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1938397), // Rule ID 24304 //
     /* 1938316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1938319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938362 */     // MIs[0] policy
     /* 1938362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938372 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1938375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938396 */     // GIR_Coverage, 24304,
     /* 1938396 */     GIR_EraseRootFromParent_Done,
     /* 1938397 */   // Label 26023: @1938397
     /* 1938397 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1938483), // Rule ID 24305 //
     /* 1938402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1938405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938448 */     // MIs[0] policy
     /* 1938448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938458 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1938461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938482 */     // GIR_Coverage, 24305,
     /* 1938482 */     GIR_EraseRootFromParent_Done,
     /* 1938483 */   // Label 26024: @1938483
     /* 1938483 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1938569), // Rule ID 24308 //
     /* 1938488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1938491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938534 */     // MIs[0] policy
     /* 1938534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938544 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1938547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938568 */     // GIR_Coverage, 24308,
     /* 1938568 */     GIR_EraseRootFromParent_Done,
     /* 1938569 */   // Label 26025: @1938569
     /* 1938569 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1938655), // Rule ID 24309 //
     /* 1938574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1938577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938620 */     // MIs[0] policy
     /* 1938620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938630 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1938633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938654 */     // GIR_Coverage, 24309,
     /* 1938654 */     GIR_EraseRootFromParent_Done,
     /* 1938655 */   // Label 26026: @1938655
     /* 1938655 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1938741), // Rule ID 24372 //
     /* 1938660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1938663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1938668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938706 */     // MIs[0] policy
     /* 1938706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938716 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1938719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938740 */     // GIR_Coverage, 24372,
     /* 1938740 */     GIR_EraseRootFromParent_Done,
     /* 1938741 */   // Label 26027: @1938741
     /* 1938741 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1938827), // Rule ID 24373 //
     /* 1938746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1938749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1938754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938792 */     // MIs[0] policy
     /* 1938792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938802 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1938805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938826 */     // GIR_Coverage, 24373,
     /* 1938826 */     GIR_EraseRootFromParent_Done,
     /* 1938827 */   // Label 26028: @1938827
     /* 1938827 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1938913), // Rule ID 24376 //
     /* 1938832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1938835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1938840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938878 */     // MIs[0] policy
     /* 1938878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938888 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1938891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938912 */     // GIR_Coverage, 24376,
     /* 1938912 */     GIR_EraseRootFromParent_Done,
     /* 1938913 */   // Label 26029: @1938913
     /* 1938913 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1938999), // Rule ID 24377 //
     /* 1938918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1938921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1938926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938964 */     // MIs[0] policy
     /* 1938964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938974 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1938977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938998 */     // GIR_Coverage, 24377,
     /* 1938998 */     GIR_EraseRootFromParent_Done,
     /* 1938999 */   // Label 26030: @1938999
     /* 1938999 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1939085), // Rule ID 24380 //
     /* 1939004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1939007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1939046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939050 */     // MIs[0] policy
     /* 1939050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939060 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1939063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939084 */     // GIR_Coverage, 24380,
     /* 1939084 */     GIR_EraseRootFromParent_Done,
     /* 1939085 */   // Label 26031: @1939085
     /* 1939085 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1939171), // Rule ID 24381 //
     /* 1939090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1939093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1939101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1939104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1939107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1939132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939136 */     // MIs[0] policy
     /* 1939136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939146 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1939149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939170 */     // GIR_Coverage, 24381,
     /* 1939170 */     GIR_EraseRootFromParent_Done,
     /* 1939171 */   // Label 26032: @1939171
     /* 1939171 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1939257), // Rule ID 24384 //
     /* 1939176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1939179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939222 */     // MIs[0] policy
     /* 1939222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1939235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939256 */     // GIR_Coverage, 24384,
     /* 1939256 */     GIR_EraseRootFromParent_Done,
     /* 1939257 */   // Label 26033: @1939257
     /* 1939257 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1939343), // Rule ID 24385 //
     /* 1939262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1939265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1939273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1939276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1939279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939308 */     // MIs[0] policy
     /* 1939308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939318 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1939321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939342 */     // GIR_Coverage, 24385,
     /* 1939342 */     GIR_EraseRootFromParent_Done,
     /* 1939343 */   // Label 26034: @1939343
     /* 1939343 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1939429), // Rule ID 24388 //
     /* 1939348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1939351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1939390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939394 */     // MIs[0] policy
     /* 1939394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1939407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939428 */     // GIR_Coverage, 24388,
     /* 1939428 */     GIR_EraseRootFromParent_Done,
     /* 1939429 */   // Label 26035: @1939429
     /* 1939429 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1939515), // Rule ID 24389 //
     /* 1939434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1939437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1939476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939480 */     // MIs[0] policy
     /* 1939480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1939493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939514 */     // GIR_Coverage, 24389,
     /* 1939514 */     GIR_EraseRootFromParent_Done,
     /* 1939515 */   // Label 26036: @1939515
     /* 1939515 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1939601), // Rule ID 24392 //
     /* 1939520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1939523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939566 */     // MIs[0] policy
     /* 1939566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1939579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939600 */     // GIR_Coverage, 24392,
     /* 1939600 */     GIR_EraseRootFromParent_Done,
     /* 1939601 */   // Label 26037: @1939601
     /* 1939601 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1939687), // Rule ID 24393 //
     /* 1939606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1939609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939652 */     // MIs[0] policy
     /* 1939652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1939665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939686 */     // GIR_Coverage, 24393,
     /* 1939686 */     GIR_EraseRootFromParent_Done,
     /* 1939687 */   // Label 26038: @1939687
     /* 1939687 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1939773), // Rule ID 24396 //
     /* 1939692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1939695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939738 */     // MIs[0] policy
     /* 1939738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939748 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1939751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939772 */     // GIR_Coverage, 24396,
     /* 1939772 */     GIR_EraseRootFromParent_Done,
     /* 1939773 */   // Label 26039: @1939773
     /* 1939773 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1939859), // Rule ID 24397 //
     /* 1939778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1939781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939824 */     // MIs[0] policy
     /* 1939824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939834 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1939837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939858 */     // GIR_Coverage, 24397,
     /* 1939858 */     GIR_EraseRootFromParent_Done,
     /* 1939859 */   // Label 26040: @1939859
     /* 1939859 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1939945), // Rule ID 24400 //
     /* 1939864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1939867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939910 */     // MIs[0] policy
     /* 1939910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939920 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1939923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939944 */     // GIR_Coverage, 24400,
     /* 1939944 */     GIR_EraseRootFromParent_Done,
     /* 1939945 */   // Label 26041: @1939945
     /* 1939945 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1940031), // Rule ID 24401 //
     /* 1939950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1939953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1939958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1939970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1939992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939996 */     // MIs[0] policy
     /* 1939996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940006 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1940009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940030 */     // GIR_Coverage, 24401,
     /* 1940030 */     GIR_EraseRootFromParent_Done,
     /* 1940031 */   // Label 26042: @1940031
     /* 1940031 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1940117), // Rule ID 24404 //
     /* 1940036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1940056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1940078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940082 */     // MIs[0] policy
     /* 1940082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940092 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1940095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940116 */     // GIR_Coverage, 24404,
     /* 1940116 */     GIR_EraseRootFromParent_Done,
     /* 1940117 */   // Label 26043: @1940117
     /* 1940117 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1940203), // Rule ID 24405 //
     /* 1940122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1940133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1940136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1940139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1940142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1940145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1940164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940168 */     // MIs[0] policy
     /* 1940168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940178 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1940181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940202 */     // GIR_Coverage, 24405,
     /* 1940202 */     GIR_EraseRootFromParent_Done,
     /* 1940203 */   // Label 26044: @1940203
     /* 1940203 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1940289), // Rule ID 24408 //
     /* 1940208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940254 */     // MIs[0] policy
     /* 1940254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940264 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1940267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940288 */     // GIR_Coverage, 24408,
     /* 1940288 */     GIR_EraseRootFromParent_Done,
     /* 1940289 */   // Label 26045: @1940289
     /* 1940289 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1940375), // Rule ID 24409 //
     /* 1940294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1940305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1940308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1940311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940340 */     // MIs[0] policy
     /* 1940340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940350 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1940353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940374 */     // GIR_Coverage, 24409,
     /* 1940374 */     GIR_EraseRootFromParent_Done,
     /* 1940375 */   // Label 26046: @1940375
     /* 1940375 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1940461), // Rule ID 24412 //
     /* 1940380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940426 */     // MIs[0] policy
     /* 1940426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940436 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1940439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940460 */     // GIR_Coverage, 24412,
     /* 1940460 */     GIR_EraseRootFromParent_Done,
     /* 1940461 */   // Label 26047: @1940461
     /* 1940461 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1940547), // Rule ID 24413 //
     /* 1940466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940512 */     // MIs[0] policy
     /* 1940512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1940525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940546 */     // GIR_Coverage, 24413,
     /* 1940546 */     GIR_EraseRootFromParent_Done,
     /* 1940547 */   // Label 26048: @1940547
     /* 1940547 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1940633), // Rule ID 24416 //
     /* 1940552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940598 */     // MIs[0] policy
     /* 1940598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940608 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1940611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940632 */     // GIR_Coverage, 24416,
     /* 1940632 */     GIR_EraseRootFromParent_Done,
     /* 1940633 */   // Label 26049: @1940633
     /* 1940633 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1940719), // Rule ID 24417 //
     /* 1940638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1940680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940684 */     // MIs[0] policy
     /* 1940684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1940697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940718 */     // GIR_Coverage, 24417,
     /* 1940718 */     GIR_EraseRootFromParent_Done,
     /* 1940719 */   // Label 26050: @1940719
     /* 1940719 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1940805), // Rule ID 24420 //
     /* 1940724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1940766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940770 */     // MIs[0] policy
     /* 1940770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940780 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1940783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940804 */     // GIR_Coverage, 24420,
     /* 1940804 */     GIR_EraseRootFromParent_Done,
     /* 1940805 */   // Label 26051: @1940805
     /* 1940805 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1940891), // Rule ID 24421 //
     /* 1940810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1940852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940856 */     // MIs[0] policy
     /* 1940856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940866 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1940869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940890 */     // GIR_Coverage, 24421,
     /* 1940890 */     GIR_EraseRootFromParent_Done,
     /* 1940891 */   // Label 26052: @1940891
     /* 1940891 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1940977), // Rule ID 24424 //
     /* 1940896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1940938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940942 */     // MIs[0] policy
     /* 1940942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940952 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1940955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940976 */     // GIR_Coverage, 24424,
     /* 1940976 */     GIR_EraseRootFromParent_Done,
     /* 1940977 */   // Label 26053: @1940977
     /* 1940977 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1941063), // Rule ID 24425 //
     /* 1940982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941028 */     // MIs[0] policy
     /* 1941028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941038 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1941041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941062 */     // GIR_Coverage, 24425,
     /* 1941062 */     GIR_EraseRootFromParent_Done,
     /* 1941063 */   // Label 26054: @1941063
     /* 1941063 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1941149), // Rule ID 24428 //
     /* 1941068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941114 */     // MIs[0] policy
     /* 1941114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941124 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1941127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941148 */     // GIR_Coverage, 24428,
     /* 1941148 */     GIR_EraseRootFromParent_Done,
     /* 1941149 */   // Label 26055: @1941149
     /* 1941149 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1941235), // Rule ID 24429 //
     /* 1941154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1941157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1941165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1941168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1941171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941200 */     // MIs[0] policy
     /* 1941200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941210 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1941213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941234 */     // GIR_Coverage, 24429,
     /* 1941234 */     GIR_EraseRootFromParent_Done,
     /* 1941235 */   // Label 26056: @1941235
     /* 1941235 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1941321), // Rule ID 24432 //
     /* 1941240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941286 */     // MIs[0] policy
     /* 1941286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1941299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941320 */     // GIR_Coverage, 24432,
     /* 1941320 */     GIR_EraseRootFromParent_Done,
     /* 1941321 */   // Label 26057: @1941321
     /* 1941321 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1941407), // Rule ID 24433 //
     /* 1941326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1941337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1941340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1941343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941372 */     // MIs[0] policy
     /* 1941372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941382 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1941385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941406 */     // GIR_Coverage, 24433,
     /* 1941406 */     GIR_EraseRootFromParent_Done,
     /* 1941407 */   // Label 26058: @1941407
     /* 1941407 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1941493), // Rule ID 24436 //
     /* 1941412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941458 */     // MIs[0] policy
     /* 1941458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941468 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1941471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941492 */     // GIR_Coverage, 24436,
     /* 1941492 */     GIR_EraseRootFromParent_Done,
     /* 1941493 */   // Label 26059: @1941493
     /* 1941493 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1941579), // Rule ID 24437 //
     /* 1941498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941544 */     // MIs[0] policy
     /* 1941544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941554 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1941557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941578 */     // GIR_Coverage, 24437,
     /* 1941578 */     GIR_EraseRootFromParent_Done,
     /* 1941579 */   // Label 26060: @1941579
     /* 1941579 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1941665), // Rule ID 24440 //
     /* 1941584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941630 */     // MIs[0] policy
     /* 1941630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941640 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1941643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941664 */     // GIR_Coverage, 24440,
     /* 1941664 */     GIR_EraseRootFromParent_Done,
     /* 1941665 */   // Label 26061: @1941665
     /* 1941665 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1941751), // Rule ID 24441 //
     /* 1941670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941716 */     // MIs[0] policy
     /* 1941716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941726 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1941729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941750 */     // GIR_Coverage, 24441,
     /* 1941750 */     GIR_EraseRootFromParent_Done,
     /* 1941751 */   // Label 26062: @1941751
     /* 1941751 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1941837), // Rule ID 24444 //
     /* 1941756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941802 */     // MIs[0] policy
     /* 1941802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941812 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1941815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941836 */     // GIR_Coverage, 24444,
     /* 1941836 */     GIR_EraseRootFromParent_Done,
     /* 1941837 */   // Label 26063: @1941837
     /* 1941837 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1941923), // Rule ID 24445 //
     /* 1941842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941888 */     // MIs[0] policy
     /* 1941888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941898 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1941901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941922 */     // GIR_Coverage, 24445,
     /* 1941922 */     GIR_EraseRootFromParent_Done,
     /* 1941923 */   // Label 26064: @1941923
     /* 1941923 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1942009), // Rule ID 24448 //
     /* 1941928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1941936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1941939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1941942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1941945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941974 */     // MIs[0] policy
     /* 1941974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1941987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942008 */     // GIR_Coverage, 24448,
     /* 1942008 */     GIR_EraseRootFromParent_Done,
     /* 1942009 */   // Label 26065: @1942009
     /* 1942009 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1942095), // Rule ID 24449 //
     /* 1942014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1942025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1942028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1942031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942060 */     // MIs[0] policy
     /* 1942060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942070 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1942073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942094 */     // GIR_Coverage, 24449,
     /* 1942094 */     GIR_EraseRootFromParent_Done,
     /* 1942095 */   // Label 26066: @1942095
     /* 1942095 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1942181), // Rule ID 24452 //
     /* 1942100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1942103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942146 */     // MIs[0] policy
     /* 1942146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942156 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1942159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942180 */     // GIR_Coverage, 24452,
     /* 1942180 */     GIR_EraseRootFromParent_Done,
     /* 1942181 */   // Label 26067: @1942181
     /* 1942181 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1942267), // Rule ID 24453 //
     /* 1942186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1942189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1942197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1942200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1942203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1942209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1942216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1942224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1942228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942232 */     // MIs[0] policy
     /* 1942232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942242 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1942245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942266 */     // GIR_Coverage, 24453,
     /* 1942266 */     GIR_EraseRootFromParent_Done,
     /* 1942267 */   // Label 26068: @1942267
     /* 1942267 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1942353), // Rule ID 24456 //
     /* 1942272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942318 */     // MIs[0] policy
     /* 1942318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942328 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1942331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942352 */     // GIR_Coverage, 24456,
     /* 1942352 */     GIR_EraseRootFromParent_Done,
     /* 1942353 */   // Label 26069: @1942353
     /* 1942353 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1942439), // Rule ID 24457 //
     /* 1942358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942404 */     // MIs[0] policy
     /* 1942404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942414 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1942417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942438 */     // GIR_Coverage, 24457,
     /* 1942438 */     GIR_EraseRootFromParent_Done,
     /* 1942439 */   // Label 26070: @1942439
     /* 1942439 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1942525), // Rule ID 24460 //
     /* 1942444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942490 */     // MIs[0] policy
     /* 1942490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942500 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1942503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942524 */     // GIR_Coverage, 24460,
     /* 1942524 */     GIR_EraseRootFromParent_Done,
     /* 1942525 */   // Label 26071: @1942525
     /* 1942525 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1942611), // Rule ID 24461 //
     /* 1942530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942576 */     // MIs[0] policy
     /* 1942576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942586 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1942589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942610 */     // GIR_Coverage, 24461,
     /* 1942610 */     GIR_EraseRootFromParent_Done,
     /* 1942611 */   // Label 26072: @1942611
     /* 1942611 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1942697), // Rule ID 24464 //
     /* 1942616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942662 */     // MIs[0] policy
     /* 1942662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942672 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1942675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942696 */     // GIR_Coverage, 24464,
     /* 1942696 */     GIR_EraseRootFromParent_Done,
     /* 1942697 */   // Label 26073: @1942697
     /* 1942697 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1942783), // Rule ID 24465 //
     /* 1942702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942748 */     // MIs[0] policy
     /* 1942748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1942761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942782 */     // GIR_Coverage, 24465,
     /* 1942782 */     GIR_EraseRootFromParent_Done,
     /* 1942783 */   // Label 26074: @1942783
     /* 1942783 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1942869), // Rule ID 24468 //
     /* 1942788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942834 */     // MIs[0] policy
     /* 1942834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1942847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942868 */     // GIR_Coverage, 24468,
     /* 1942868 */     GIR_EraseRootFromParent_Done,
     /* 1942869 */   // Label 26075: @1942869
     /* 1942869 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1942955), // Rule ID 24469 //
     /* 1942874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942920 */     // MIs[0] policy
     /* 1942920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1942933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942954 */     // GIR_Coverage, 24469,
     /* 1942954 */     GIR_EraseRootFromParent_Done,
     /* 1942955 */   // Label 26076: @1942955
     /* 1942955 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1943041), // Rule ID 24472 //
     /* 1942960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1942968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943006 */     // MIs[0] policy
     /* 1943006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1943019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943040 */     // GIR_Coverage, 24472,
     /* 1943040 */     GIR_EraseRootFromParent_Done,
     /* 1943041 */   // Label 26077: @1943041
     /* 1943041 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1943127), // Rule ID 24473 //
     /* 1943046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1943057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1943060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1943063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943092 */     // MIs[0] policy
     /* 1943092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943102 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1943105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943126 */     // GIR_Coverage, 24473,
     /* 1943126 */     GIR_EraseRootFromParent_Done,
     /* 1943127 */   // Label 26078: @1943127
     /* 1943127 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1943213), // Rule ID 24476 //
     /* 1943132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943178 */     // MIs[0] policy
     /* 1943178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943188 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1943191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943212 */     // GIR_Coverage, 24476,
     /* 1943212 */     GIR_EraseRootFromParent_Done,
     /* 1943213 */   // Label 26079: @1943213
     /* 1943213 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1943299), // Rule ID 24477 //
     /* 1943218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1943229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1943232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1943235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1943241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943264 */     // MIs[0] policy
     /* 1943264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943274 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1943277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943298 */     // GIR_Coverage, 24477,
     /* 1943298 */     GIR_EraseRootFromParent_Done,
     /* 1943299 */   // Label 26080: @1943299
     /* 1943299 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1943385), // Rule ID 24480 //
     /* 1943304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943350 */     // MIs[0] policy
     /* 1943350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943360 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1943363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943384 */     // GIR_Coverage, 24480,
     /* 1943384 */     GIR_EraseRootFromParent_Done,
     /* 1943385 */   // Label 26081: @1943385
     /* 1943385 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1943471), // Rule ID 24481 //
     /* 1943390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943436 */     // MIs[0] policy
     /* 1943436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943446 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1943449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943470 */     // GIR_Coverage, 24481,
     /* 1943470 */     GIR_EraseRootFromParent_Done,
     /* 1943471 */   // Label 26082: @1943471
     /* 1943471 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1943557), // Rule ID 24484 //
     /* 1943476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943522 */     // MIs[0] policy
     /* 1943522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1943535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943556 */     // GIR_Coverage, 24484,
     /* 1943556 */     GIR_EraseRootFromParent_Done,
     /* 1943557 */   // Label 26083: @1943557
     /* 1943557 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1943643), // Rule ID 24485 //
     /* 1943562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943608 */     // MIs[0] policy
     /* 1943608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1943621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943642 */     // GIR_Coverage, 24485,
     /* 1943642 */     GIR_EraseRootFromParent_Done,
     /* 1943643 */   // Label 26084: @1943643
     /* 1943643 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1943729), // Rule ID 24488 //
     /* 1943648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943694 */     // MIs[0] policy
     /* 1943694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943704 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1943707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943728 */     // GIR_Coverage, 24488,
     /* 1943728 */     GIR_EraseRootFromParent_Done,
     /* 1943729 */   // Label 26085: @1943729
     /* 1943729 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1943815), // Rule ID 24489 //
     /* 1943734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943780 */     // MIs[0] policy
     /* 1943780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943790 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1943793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943814 */     // GIR_Coverage, 24489,
     /* 1943814 */     GIR_EraseRootFromParent_Done,
     /* 1943815 */   // Label 26086: @1943815
     /* 1943815 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1943901), // Rule ID 24492 //
     /* 1943820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1943828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1943831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1943834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1943837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1943840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943866 */     // MIs[0] policy
     /* 1943866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943876 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1943879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943900 */     // GIR_Coverage, 24492,
     /* 1943900 */     GIR_EraseRootFromParent_Done,
     /* 1943901 */   // Label 26087: @1943901
     /* 1943901 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1943987), // Rule ID 24493 //
     /* 1943906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1943914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1943917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1943920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1943923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1943926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943952 */     // MIs[0] policy
     /* 1943952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943962 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1943965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943986 */     // GIR_Coverage, 24493,
     /* 1943986 */     GIR_EraseRootFromParent_Done,
     /* 1943987 */   // Label 26088: @1943987
     /* 1943987 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1944073), // Rule ID 24496 //
     /* 1943992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1944003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1944006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1944009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1944012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944038 */     // MIs[0] policy
     /* 1944038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944048 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1944051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944072 */     // GIR_Coverage, 24496,
     /* 1944072 */     GIR_EraseRootFromParent_Done,
     /* 1944073 */   // Label 26089: @1944073
     /* 1944073 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1944159), // Rule ID 24497 //
     /* 1944078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1944089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1944092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1944095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1944098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944124 */     // MIs[0] policy
     /* 1944124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1944137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944158 */     // GIR_Coverage, 24497,
     /* 1944158 */     GIR_EraseRootFromParent_Done,
     /* 1944159 */   // Label 26090: @1944159
     /* 1944159 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1944245), // Rule ID 24500 //
     /* 1944164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1944175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1944178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1944181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1944184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944210 */     // MIs[0] policy
     /* 1944210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944220 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1944223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944244 */     // GIR_Coverage, 24500,
     /* 1944244 */     GIR_EraseRootFromParent_Done,
     /* 1944245 */   // Label 26091: @1944245
     /* 1944245 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1944331), // Rule ID 24501 //
     /* 1944250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1944261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1944264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1944267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1944270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944296 */     // MIs[0] policy
     /* 1944296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944306 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1944309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944330 */     // GIR_Coverage, 24501,
     /* 1944330 */     GIR_EraseRootFromParent_Done,
     /* 1944331 */   // Label 26092: @1944331
     /* 1944331 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1944417), // Rule ID 24504 //
     /* 1944336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1944356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944382 */     // MIs[0] policy
     /* 1944382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1944395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944416 */     // GIR_Coverage, 24504,
     /* 1944416 */     GIR_EraseRootFromParent_Done,
     /* 1944417 */   // Label 26093: @1944417
     /* 1944417 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1944503), // Rule ID 24505 //
     /* 1944422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1944433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1944436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1944439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1944442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944468 */     // MIs[0] policy
     /* 1944468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944478 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1944481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944502 */     // GIR_Coverage, 24505,
     /* 1944502 */     GIR_EraseRootFromParent_Done,
     /* 1944503 */   // Label 26094: @1944503
     /* 1944503 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1944589), // Rule ID 24508 //
     /* 1944508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1944528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944554 */     // MIs[0] policy
     /* 1944554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1944567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944588 */     // GIR_Coverage, 24508,
     /* 1944588 */     GIR_EraseRootFromParent_Done,
     /* 1944589 */   // Label 26095: @1944589
     /* 1944589 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1944675), // Rule ID 24509 //
     /* 1944594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1944614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944640 */     // MIs[0] policy
     /* 1944640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1944653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944674 */     // GIR_Coverage, 24509,
     /* 1944674 */     GIR_EraseRootFromParent_Done,
     /* 1944675 */   // Label 26096: @1944675
     /* 1944675 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1944761), // Rule ID 24512 //
     /* 1944680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1944700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944726 */     // MIs[0] policy
     /* 1944726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944736 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1944739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944760 */     // GIR_Coverage, 24512,
     /* 1944760 */     GIR_EraseRootFromParent_Done,
     /* 1944761 */   // Label 26097: @1944761
     /* 1944761 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1944847), // Rule ID 24513 //
     /* 1944766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1944786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944812 */     // MIs[0] policy
     /* 1944812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944822 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1944825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944846 */     // GIR_Coverage, 24513,
     /* 1944846 */     GIR_EraseRootFromParent_Done,
     /* 1944847 */   // Label 26098: @1944847
     /* 1944847 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1944933), // Rule ID 24516 //
     /* 1944852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1944863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1944866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1944869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1944872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944898 */     // MIs[0] policy
     /* 1944898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1944911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944932 */     // GIR_Coverage, 24516,
     /* 1944932 */     GIR_EraseRootFromParent_Done,
     /* 1944933 */   // Label 26099: @1944933
     /* 1944933 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1945019), // Rule ID 24517 //
     /* 1944938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1944946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1944949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1944952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1944955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1944958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944984 */     // MIs[0] policy
     /* 1944984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944994 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1944997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945018 */     // GIR_Coverage, 24517,
     /* 1945018 */     GIR_EraseRootFromParent_Done,
     /* 1945019 */   // Label 26100: @1945019
     /* 1945019 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1945105), // Rule ID 24520 //
     /* 1945024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1945035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1945038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1945041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1945044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945070 */     // MIs[0] policy
     /* 1945070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1945083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945104 */     // GIR_Coverage, 24520,
     /* 1945104 */     GIR_EraseRootFromParent_Done,
     /* 1945105 */   // Label 26101: @1945105
     /* 1945105 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1945191), // Rule ID 24521 //
     /* 1945110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1945121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1945124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1945127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1945130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945156 */     // MIs[0] policy
     /* 1945156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945166 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1945169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945190 */     // GIR_Coverage, 24521,
     /* 1945190 */     GIR_EraseRootFromParent_Done,
     /* 1945191 */   // Label 26102: @1945191
     /* 1945191 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1945277), // Rule ID 24524 //
     /* 1945196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1945207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1945210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1945213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1945216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945242 */     // MIs[0] policy
     /* 1945242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1945255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945276 */     // GIR_Coverage, 24524,
     /* 1945276 */     GIR_EraseRootFromParent_Done,
     /* 1945277 */   // Label 26103: @1945277
     /* 1945277 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1945363), // Rule ID 24525 //
     /* 1945282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1945293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1945296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1945299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1945302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945328 */     // MIs[0] policy
     /* 1945328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1945341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945362 */     // GIR_Coverage, 24525,
     /* 1945362 */     GIR_EraseRootFromParent_Done,
     /* 1945363 */   // Label 26104: @1945363
     /* 1945363 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1945449), // Rule ID 24528 //
     /* 1945368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1945371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1945379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1945382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1945385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1945388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945414 */     // MIs[0] policy
     /* 1945414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1945427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945448 */     // GIR_Coverage, 24528,
     /* 1945448 */     GIR_EraseRootFromParent_Done,
     /* 1945449 */   // Label 26105: @1945449
     /* 1945449 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1945535), // Rule ID 24529 //
     /* 1945454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1945457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1945465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1945468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1945471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1945474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1945477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1945484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1945496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945500 */     // MIs[0] policy
     /* 1945500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945510 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1945513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945534 */     // GIR_Coverage, 24529,
     /* 1945534 */     GIR_EraseRootFromParent_Done,
     /* 1945535 */   // Label 26106: @1945535
     /* 1945535 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1945621), // Rule ID 24532 //
     /* 1945540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1945551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1945554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1945557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1945560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945586 */     // MIs[0] policy
     /* 1945586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1945599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945620 */     // GIR_Coverage, 24532,
     /* 1945620 */     GIR_EraseRootFromParent_Done,
     /* 1945621 */   // Label 26107: @1945621
     /* 1945621 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1945707), // Rule ID 24533 //
     /* 1945626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1945637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1945640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1945643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1945646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945672 */     // MIs[0] policy
     /* 1945672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1945685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945706 */     // GIR_Coverage, 24533,
     /* 1945706 */     GIR_EraseRootFromParent_Done,
     /* 1945707 */   // Label 26108: @1945707
     /* 1945707 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1945793), // Rule ID 24536 //
     /* 1945712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1945723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1945726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1945729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1945732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945758 */     // MIs[0] policy
     /* 1945758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945768 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1945771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945792 */     // GIR_Coverage, 24536,
     /* 1945792 */     GIR_EraseRootFromParent_Done,
     /* 1945793 */   // Label 26109: @1945793
     /* 1945793 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1945879), // Rule ID 24537 //
     /* 1945798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1945809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1945812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1945815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1945818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945844 */     // MIs[0] policy
     /* 1945844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945854 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1945857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945878 */     // GIR_Coverage, 24537,
     /* 1945878 */     GIR_EraseRootFromParent_Done,
     /* 1945879 */   // Label 26110: @1945879
     /* 1945879 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1945965), // Rule ID 24540 //
     /* 1945884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1945895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1945898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1945901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1945904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1945907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945930 */     // MIs[0] policy
     /* 1945930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945940 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1945943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945964 */     // GIR_Coverage, 24540,
     /* 1945964 */     GIR_EraseRootFromParent_Done,
     /* 1945965 */   // Label 26111: @1945965
     /* 1945965 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1946051), // Rule ID 24541 //
     /* 1945970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1945978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1945981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1945984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1945987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1945990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1945993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946016 */     // MIs[0] policy
     /* 1946016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946026 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1946029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946050 */     // GIR_Coverage, 24541,
     /* 1946050 */     GIR_EraseRootFromParent_Done,
     /* 1946051 */   // Label 26112: @1946051
     /* 1946051 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1946137), // Rule ID 24544 //
     /* 1946056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1946067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1946070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1946073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1946076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946102 */     // MIs[0] policy
     /* 1946102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1946115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946136 */     // GIR_Coverage, 24544,
     /* 1946136 */     GIR_EraseRootFromParent_Done,
     /* 1946137 */   // Label 26113: @1946137
     /* 1946137 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1946223), // Rule ID 24545 //
     /* 1946142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1946153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1946156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1946159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1946162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946188 */     // MIs[0] policy
     /* 1946188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1946201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946222 */     // GIR_Coverage, 24545,
     /* 1946222 */     GIR_EraseRootFromParent_Done,
     /* 1946223 */   // Label 26114: @1946223
     /* 1946223 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1946309), // Rule ID 24548 //
     /* 1946228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1946239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1946242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1946245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1946248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946274 */     // MIs[0] policy
     /* 1946274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1946287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946308 */     // GIR_Coverage, 24548,
     /* 1946308 */     GIR_EraseRootFromParent_Done,
     /* 1946309 */   // Label 26115: @1946309
     /* 1946309 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1946395), // Rule ID 24549 //
     /* 1946314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1946325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1946328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1946331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1946334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946360 */     // MIs[0] policy
     /* 1946360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1946373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946394 */     // GIR_Coverage, 24549,
     /* 1946394 */     GIR_EraseRootFromParent_Done,
     /* 1946395 */   // Label 26116: @1946395
     /* 1946395 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1946481), // Rule ID 24552 //
     /* 1946400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1946411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1946414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1946417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1946420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1946423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946446 */     // MIs[0] policy
     /* 1946446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946456 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1946459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946480 */     // GIR_Coverage, 24552,
     /* 1946480 */     GIR_EraseRootFromParent_Done,
     /* 1946481 */   // Label 26117: @1946481
     /* 1946481 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1946567), // Rule ID 24553 //
     /* 1946486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1946497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1946500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1946503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1946506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1946509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946532 */     // MIs[0] policy
     /* 1946532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1946545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946566 */     // GIR_Coverage, 24553,
     /* 1946566 */     GIR_EraseRootFromParent_Done,
     /* 1946567 */   // Label 26118: @1946567
     /* 1946567 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1946653), // Rule ID 24556 //
     /* 1946572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1946592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946618 */     // MIs[0] policy
     /* 1946618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1946631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946652 */     // GIR_Coverage, 24556,
     /* 1946652 */     GIR_EraseRootFromParent_Done,
     /* 1946653 */   // Label 26119: @1946653
     /* 1946653 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1946739), // Rule ID 24557 //
     /* 1946658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1946678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946704 */     // MIs[0] policy
     /* 1946704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1946717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946738 */     // GIR_Coverage, 24557,
     /* 1946738 */     GIR_EraseRootFromParent_Done,
     /* 1946739 */   // Label 26120: @1946739
     /* 1946739 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1946825), // Rule ID 24560 //
     /* 1946744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1946764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946790 */     // MIs[0] policy
     /* 1946790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1946803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946824 */     // GIR_Coverage, 24560,
     /* 1946824 */     GIR_EraseRootFromParent_Done,
     /* 1946825 */   // Label 26121: @1946825
     /* 1946825 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1946911), // Rule ID 24561 //
     /* 1946830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1946850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946876 */     // MIs[0] policy
     /* 1946876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946886 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1946889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946910 */     // GIR_Coverage, 24561,
     /* 1946910 */     GIR_EraseRootFromParent_Done,
     /* 1946911 */   // Label 26122: @1946911
     /* 1946911 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1946997), // Rule ID 24564 //
     /* 1946916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1946927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1946930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1946933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1946936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946962 */     // MIs[0] policy
     /* 1946962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1946975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946996 */     // GIR_Coverage, 24564,
     /* 1946996 */     GIR_EraseRootFromParent_Done,
     /* 1946997 */   // Label 26123: @1946997
     /* 1946997 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1947083), // Rule ID 24565 //
     /* 1947002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1947013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1947016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1947019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1947022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947048 */     // MIs[0] policy
     /* 1947048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1947061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947082 */     // GIR_Coverage, 24565,
     /* 1947082 */     GIR_EraseRootFromParent_Done,
     /* 1947083 */   // Label 26124: @1947083
     /* 1947083 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1947169), // Rule ID 24568 //
     /* 1947088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1947091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1947099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1947102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1947105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1947108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947134 */     // MIs[0] policy
     /* 1947134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1947147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947168 */     // GIR_Coverage, 24568,
     /* 1947168 */     GIR_EraseRootFromParent_Done,
     /* 1947169 */   // Label 26125: @1947169
     /* 1947169 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1947255), // Rule ID 24569 //
     /* 1947174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1947177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1947185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1947188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1947191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1947194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947220 */     // MIs[0] policy
     /* 1947220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1947233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947254 */     // GIR_Coverage, 24569,
     /* 1947254 */     GIR_EraseRootFromParent_Done,
     /* 1947255 */   // Label 26126: @1947255
     /* 1947255 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1947341), // Rule ID 24572 //
     /* 1947260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1947263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1947271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1947274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1947277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1947280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947306 */     // MIs[0] policy
     /* 1947306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1947319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947340 */     // GIR_Coverage, 24572,
     /* 1947340 */     GIR_EraseRootFromParent_Done,
     /* 1947341 */   // Label 26127: @1947341
     /* 1947341 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1947427), // Rule ID 24573 //
     /* 1947346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1947349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1947357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1947360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1947363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1947366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947392 */     // MIs[0] policy
     /* 1947392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1947405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947426 */     // GIR_Coverage, 24573,
     /* 1947426 */     GIR_EraseRootFromParent_Done,
     /* 1947427 */   // Label 26128: @1947427
     /* 1947427 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1947513), // Rule ID 24576 //
     /* 1947432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1947435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1947443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1947446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1947449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1947452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947478 */     // MIs[0] policy
     /* 1947478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947488 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1947491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947512 */     // GIR_Coverage, 24576,
     /* 1947512 */     GIR_EraseRootFromParent_Done,
     /* 1947513 */   // Label 26129: @1947513
     /* 1947513 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1947599), // Rule ID 24577 //
     /* 1947518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1947521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1947529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1947532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1947535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1947538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1947548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1947560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947564 */     // MIs[0] policy
     /* 1947564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1947577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947598 */     // GIR_Coverage, 24577,
     /* 1947598 */     GIR_EraseRootFromParent_Done,
     /* 1947599 */   // Label 26130: @1947599
     /* 1947599 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1947685), // Rule ID 24580 //
     /* 1947604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1947612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1947615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1947618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1947621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1947646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947650 */     // MIs[0] policy
     /* 1947650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1947663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947684 */     // GIR_Coverage, 24580,
     /* 1947684 */     GIR_EraseRootFromParent_Done,
     /* 1947685 */   // Label 26131: @1947685
     /* 1947685 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1947771), // Rule ID 24581 //
     /* 1947690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1947698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1947701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1947704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1947707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1947710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1947732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947736 */     // MIs[0] policy
     /* 1947736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1947749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947770 */     // GIR_Coverage, 24581,
     /* 1947770 */     GIR_EraseRootFromParent_Done,
     /* 1947771 */   // Label 26132: @1947771
     /* 1947771 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1947857), // Rule ID 24584 //
     /* 1947776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1947784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1947787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1947790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1947793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1947818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947822 */     // MIs[0] policy
     /* 1947822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947832 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1947835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947856 */     // GIR_Coverage, 24584,
     /* 1947856 */     GIR_EraseRootFromParent_Done,
     /* 1947857 */   // Label 26133: @1947857
     /* 1947857 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1947943), // Rule ID 24585 //
     /* 1947862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1947870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1947873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1947876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1947879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1947882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1947904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947908 */     // MIs[0] policy
     /* 1947908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1947921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947942 */     // GIR_Coverage, 24585,
     /* 1947942 */     GIR_EraseRootFromParent_Done,
     /* 1947943 */   // Label 26134: @1947943
     /* 1947943 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1948029), // Rule ID 24588 //
     /* 1947948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1947956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1947959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1947962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1947965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1947968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1947990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947994 */     // MIs[0] policy
     /* 1947994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948004 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948028 */     // GIR_Coverage, 24588,
     /* 1948028 */     GIR_EraseRootFromParent_Done,
     /* 1948029 */   // Label 26135: @1948029
     /* 1948029 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1948115), // Rule ID 24589 //
     /* 1948034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1948045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1948048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1948051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948080 */     // MIs[0] policy
     /* 1948080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948090 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948114 */     // GIR_Coverage, 24589,
     /* 1948114 */     GIR_EraseRootFromParent_Done,
     /* 1948115 */   // Label 26136: @1948115
     /* 1948115 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1948201), // Rule ID 24592 //
     /* 1948120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1948131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1948134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1948137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948166 */     // MIs[0] policy
     /* 1948166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1948179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948200 */     // GIR_Coverage, 24592,
     /* 1948200 */     GIR_EraseRootFromParent_Done,
     /* 1948201 */   // Label 26137: @1948201
     /* 1948201 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1948287), // Rule ID 24593 //
     /* 1948206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1948217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1948220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1948223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948252 */     // MIs[0] policy
     /* 1948252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1948265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948286 */     // GIR_Coverage, 24593,
     /* 1948286 */     GIR_EraseRootFromParent_Done,
     /* 1948287 */   // Label 26138: @1948287
     /* 1948287 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1948373), // Rule ID 24596 //
     /* 1948292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1948303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1948306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1948309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948338 */     // MIs[0] policy
     /* 1948338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948372 */     // GIR_Coverage, 24596,
     /* 1948372 */     GIR_EraseRootFromParent_Done,
     /* 1948373 */   // Label 26139: @1948373
     /* 1948373 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1948459), // Rule ID 24597 //
     /* 1948378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1948389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1948392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1948395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948424 */     // MIs[0] policy
     /* 1948424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948458 */     // GIR_Coverage, 24597,
     /* 1948458 */     GIR_EraseRootFromParent_Done,
     /* 1948459 */   // Label 26140: @1948459
     /* 1948459 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1948545), // Rule ID 24600 //
     /* 1948464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1948475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1948478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1948481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948510 */     // MIs[0] policy
     /* 1948510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948544 */     // GIR_Coverage, 24600,
     /* 1948544 */     GIR_EraseRootFromParent_Done,
     /* 1948545 */   // Label 26141: @1948545
     /* 1948545 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1948631), // Rule ID 24601 //
     /* 1948550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1948561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1948564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1948567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948596 */     // MIs[0] policy
     /* 1948596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948606 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1948609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948630 */     // GIR_Coverage, 24601,
     /* 1948630 */     GIR_EraseRootFromParent_Done,
     /* 1948631 */   // Label 26142: @1948631
     /* 1948631 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1948717), // Rule ID 24604 //
     /* 1948636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1948647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1948650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1948653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948682 */     // MIs[0] policy
     /* 1948682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1948695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948716 */     // GIR_Coverage, 24604,
     /* 1948716 */     GIR_EraseRootFromParent_Done,
     /* 1948717 */   // Label 26143: @1948717
     /* 1948717 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1948803), // Rule ID 24605 //
     /* 1948722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1948733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1948736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1948739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948768 */     // MIs[0] policy
     /* 1948768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1948781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948802 */     // GIR_Coverage, 24605,
     /* 1948802 */     GIR_EraseRootFromParent_Done,
     /* 1948803 */   // Label 26144: @1948803
     /* 1948803 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1948889), // Rule ID 24608 //
     /* 1948808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1948819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1948822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1948825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1948828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948854 */     // MIs[0] policy
     /* 1948854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1948867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948888 */     // GIR_Coverage, 24608,
     /* 1948888 */     GIR_EraseRootFromParent_Done,
     /* 1948889 */   // Label 26145: @1948889
     /* 1948889 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1948975), // Rule ID 24609 //
     /* 1948894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1948905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1948908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1948911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1948914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1948936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948940 */     // MIs[0] policy
     /* 1948940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1948953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948974 */     // GIR_Coverage, 24609,
     /* 1948974 */     GIR_EraseRootFromParent_Done,
     /* 1948975 */   // Label 26146: @1948975
     /* 1948975 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1949061), // Rule ID 24612 //
     /* 1948980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1948988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949026 */     // MIs[0] policy
     /* 1949026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1949039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949060 */     // GIR_Coverage, 24612,
     /* 1949060 */     GIR_EraseRootFromParent_Done,
     /* 1949061 */   // Label 26147: @1949061
     /* 1949061 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1949147), // Rule ID 24613 //
     /* 1949066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1949077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1949080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1949083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949112 */     // MIs[0] policy
     /* 1949112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1949125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949146 */     // GIR_Coverage, 24613,
     /* 1949146 */     GIR_EraseRootFromParent_Done,
     /* 1949147 */   // Label 26148: @1949147
     /* 1949147 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1949233), // Rule ID 24616 //
     /* 1949152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1949163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1949166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1949169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949198 */     // MIs[0] policy
     /* 1949198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1949211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949232 */     // GIR_Coverage, 24616,
     /* 1949232 */     GIR_EraseRootFromParent_Done,
     /* 1949233 */   // Label 26149: @1949233
     /* 1949233 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1949319), // Rule ID 24617 //
     /* 1949238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1949249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1949252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1949255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949284 */     // MIs[0] policy
     /* 1949284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1949297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949318 */     // GIR_Coverage, 24617,
     /* 1949318 */     GIR_EraseRootFromParent_Done,
     /* 1949319 */   // Label 26150: @1949319
     /* 1949319 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1949405), // Rule ID 24620 //
     /* 1949324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1949335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1949338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1949341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949370 */     // MIs[0] policy
     /* 1949370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1949383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949404 */     // GIR_Coverage, 24620,
     /* 1949404 */     GIR_EraseRootFromParent_Done,
     /* 1949405 */   // Label 26151: @1949405
     /* 1949405 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1949491), // Rule ID 24621 //
     /* 1949410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1949421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1949424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1949427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949456 */     // MIs[0] policy
     /* 1949456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1949469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949490 */     // GIR_Coverage, 24621,
     /* 1949490 */     GIR_EraseRootFromParent_Done,
     /* 1949491 */   // Label 26152: @1949491
     /* 1949491 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1949577), // Rule ID 24624 //
     /* 1949496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1949507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1949510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1949513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949542 */     // MIs[0] policy
     /* 1949542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1949555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949576 */     // GIR_Coverage, 24624,
     /* 1949576 */     GIR_EraseRootFromParent_Done,
     /* 1949577 */   // Label 26153: @1949577
     /* 1949577 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1949663), // Rule ID 24625 //
     /* 1949582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1949593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1949596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1949599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949628 */     // MIs[0] policy
     /* 1949628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1949641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949662 */     // GIR_Coverage, 24625,
     /* 1949662 */     GIR_EraseRootFromParent_Done,
     /* 1949663 */   // Label 26154: @1949663
     /* 1949663 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1949749), // Rule ID 24628 //
     /* 1949668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1949679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1949682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1949685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1949691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949714 */     // MIs[0] policy
     /* 1949714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949724 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1949727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949748 */     // GIR_Coverage, 24628,
     /* 1949748 */     GIR_EraseRootFromParent_Done,
     /* 1949749 */   // Label 26155: @1949749
     /* 1949749 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1949835), // Rule ID 24629 //
     /* 1949754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1949765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1949768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1949771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1949777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949800 */     // MIs[0] policy
     /* 1949800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949810 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1949813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949834 */     // GIR_Coverage, 24629,
     /* 1949834 */     GIR_EraseRootFromParent_Done,
     /* 1949835 */   // Label 26156: @1949835
     /* 1949835 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1949921), // Rule ID 24632 //
     /* 1949840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1949851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1949854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1949857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949886 */     // MIs[0] policy
     /* 1949886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1949899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949920 */     // GIR_Coverage, 24632,
     /* 1949920 */     GIR_EraseRootFromParent_Done,
     /* 1949921 */   // Label 26157: @1949921
     /* 1949921 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1950007), // Rule ID 24633 //
     /* 1949926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1949937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1949940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1949943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949972 */     // MIs[0] policy
     /* 1949972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1949985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950006 */     // GIR_Coverage, 24633,
     /* 1950006 */     GIR_EraseRootFromParent_Done,
     /* 1950007 */   // Label 26158: @1950007
     /* 1950007 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1950093), // Rule ID 24636 //
     /* 1950012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1950023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1950026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1950029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1950035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950058 */     // MIs[0] policy
     /* 1950058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1950071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950092 */     // GIR_Coverage, 24636,
     /* 1950092 */     GIR_EraseRootFromParent_Done,
     /* 1950093 */   // Label 26159: @1950093
     /* 1950093 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1950179), // Rule ID 24637 //
     /* 1950098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1950109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1950112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1950115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1950121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950144 */     // MIs[0] policy
     /* 1950144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1950157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950178 */     // GIR_Coverage, 24637,
     /* 1950178 */     GIR_EraseRootFromParent_Done,
     /* 1950179 */   // Label 26160: @1950179
     /* 1950179 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1950265), // Rule ID 24640 //
     /* 1950184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1950195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1950198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1950201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1950207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950230 */     // MIs[0] policy
     /* 1950230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1950243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950264 */     // GIR_Coverage, 24640,
     /* 1950264 */     GIR_EraseRootFromParent_Done,
     /* 1950265 */   // Label 26161: @1950265
     /* 1950265 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1950351), // Rule ID 24641 //
     /* 1950270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1950281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1950284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1950287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1950293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950316 */     // MIs[0] policy
     /* 1950316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1950329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950350 */     // GIR_Coverage, 24641,
     /* 1950350 */     GIR_EraseRootFromParent_Done,
     /* 1950351 */   // Label 26162: @1950351
     /* 1950351 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1950437), // Rule ID 24644 //
     /* 1950356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1950367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1950370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1950373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950402 */     // MIs[0] policy
     /* 1950402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1950415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950436 */     // GIR_Coverage, 24644,
     /* 1950436 */     GIR_EraseRootFromParent_Done,
     /* 1950437 */   // Label 26163: @1950437
     /* 1950437 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1950523), // Rule ID 24645 //
     /* 1950442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1950453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1950456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1950459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950488 */     // MIs[0] policy
     /* 1950488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1950501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950522 */     // GIR_Coverage, 24645,
     /* 1950522 */     GIR_EraseRootFromParent_Done,
     /* 1950523 */   // Label 26164: @1950523
     /* 1950523 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1950609), // Rule ID 24648 //
     /* 1950528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1950539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1950542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1950545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950574 */     // MIs[0] policy
     /* 1950574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1950587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950608 */     // GIR_Coverage, 24648,
     /* 1950608 */     GIR_EraseRootFromParent_Done,
     /* 1950609 */   // Label 26165: @1950609
     /* 1950609 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1950695), // Rule ID 24649 //
     /* 1950614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1950625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1950628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1950631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950660 */     // MIs[0] policy
     /* 1950660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950670 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1950673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950694 */     // GIR_Coverage, 24649,
     /* 1950694 */     GIR_EraseRootFromParent_Done,
     /* 1950695 */   // Label 26166: @1950695
     /* 1950695 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1950781), // Rule ID 24652 //
     /* 1950700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1950711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1950714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1950717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1950723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950746 */     // MIs[0] policy
     /* 1950746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950756 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1950759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950780 */     // GIR_Coverage, 24652,
     /* 1950780 */     GIR_EraseRootFromParent_Done,
     /* 1950781 */   // Label 26167: @1950781
     /* 1950781 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1950867), // Rule ID 24653 //
     /* 1950786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1950797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1950800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1950803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1950809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950832 */     // MIs[0] policy
     /* 1950832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1950845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950866 */     // GIR_Coverage, 24653,
     /* 1950866 */     GIR_EraseRootFromParent_Done,
     /* 1950867 */   // Label 26168: @1950867
     /* 1950867 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1950953), // Rule ID 24656 //
     /* 1950872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1950875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1950883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1950886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1950889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950918 */     // MIs[0] policy
     /* 1950918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1950931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950952 */     // GIR_Coverage, 24656,
     /* 1950952 */     GIR_EraseRootFromParent_Done,
     /* 1950953 */   // Label 26169: @1950953
     /* 1950953 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1951039), // Rule ID 24657 //
     /* 1950958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1950961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1950969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1950972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1950975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951004 */     // MIs[0] policy
     /* 1951004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951014 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1951017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951038 */     // GIR_Coverage, 24657,
     /* 1951038 */     GIR_EraseRootFromParent_Done,
     /* 1951039 */   // Label 26170: @1951039
     /* 1951039 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1951125), // Rule ID 24660 //
     /* 1951044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1951055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1951058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1951061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951090 */     // MIs[0] policy
     /* 1951090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951100 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951124 */     // GIR_Coverage, 24660,
     /* 1951124 */     GIR_EraseRootFromParent_Done,
     /* 1951125 */   // Label 26171: @1951125
     /* 1951125 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1951211), // Rule ID 24661 //
     /* 1951130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1951141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1951144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1951147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951176 */     // MIs[0] policy
     /* 1951176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951186 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951210 */     // GIR_Coverage, 24661,
     /* 1951210 */     GIR_EraseRootFromParent_Done,
     /* 1951211 */   // Label 26172: @1951211
     /* 1951211 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1951297), // Rule ID 24664 //
     /* 1951216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1951227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1951230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1951233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951262 */     // MIs[0] policy
     /* 1951262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951272 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1951275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951296 */     // GIR_Coverage, 24664,
     /* 1951296 */     GIR_EraseRootFromParent_Done,
     /* 1951297 */   // Label 26173: @1951297
     /* 1951297 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1951383), // Rule ID 24665 //
     /* 1951302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1951313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1951316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1951319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951348 */     // MIs[0] policy
     /* 1951348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951358 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1951361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951382 */     // GIR_Coverage, 24665,
     /* 1951382 */     GIR_EraseRootFromParent_Done,
     /* 1951383 */   // Label 26174: @1951383
     /* 1951383 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1951469), // Rule ID 24756 //
     /* 1951388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1951399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1951402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1951405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1951408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951434 */     // MIs[0] policy
     /* 1951434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1951447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951468 */     // GIR_Coverage, 24756,
     /* 1951468 */     GIR_EraseRootFromParent_Done,
     /* 1951469 */   // Label 26175: @1951469
     /* 1951469 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1951555), // Rule ID 24757 //
     /* 1951474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1951485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1951488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1951491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1951494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951520 */     // MIs[0] policy
     /* 1951520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1951533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951554 */     // GIR_Coverage, 24757,
     /* 1951554 */     GIR_EraseRootFromParent_Done,
     /* 1951555 */   // Label 26176: @1951555
     /* 1951555 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1951641), // Rule ID 24760 //
     /* 1951560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1951571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1951574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1951577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1951580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951606 */     // MIs[0] policy
     /* 1951606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951616 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1951619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951640 */     // GIR_Coverage, 24760,
     /* 1951640 */     GIR_EraseRootFromParent_Done,
     /* 1951641 */   // Label 26177: @1951641
     /* 1951641 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1951727), // Rule ID 24761 //
     /* 1951646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1951657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1951660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1951663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1951666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951692 */     // MIs[0] policy
     /* 1951692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1951705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951726 */     // GIR_Coverage, 24761,
     /* 1951726 */     GIR_EraseRootFromParent_Done,
     /* 1951727 */   // Label 26178: @1951727
     /* 1951727 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1951813), // Rule ID 24764 //
     /* 1951732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1951743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1951746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1951749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1951752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951778 */     // MIs[0] policy
     /* 1951778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951788 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1951791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951812 */     // GIR_Coverage, 24764,
     /* 1951812 */     GIR_EraseRootFromParent_Done,
     /* 1951813 */   // Label 26179: @1951813
     /* 1951813 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1951899), // Rule ID 24765 //
     /* 1951818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1951829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1951832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1951835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1951838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951864 */     // MIs[0] policy
     /* 1951864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951874 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1951877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951898 */     // GIR_Coverage, 24765,
     /* 1951898 */     GIR_EraseRootFromParent_Done,
     /* 1951899 */   // Label 26180: @1951899
     /* 1951899 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1951985), // Rule ID 24768 //
     /* 1951904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1951915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1951918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1951921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1951924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951950 */     // MIs[0] policy
     /* 1951950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1951963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951984 */     // GIR_Coverage, 24768,
     /* 1951984 */     GIR_EraseRootFromParent_Done,
     /* 1951985 */   // Label 26181: @1951985
     /* 1951985 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1952071), // Rule ID 24769 //
     /* 1951990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1951998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1952001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1952004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1952007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1952010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952036 */     // MIs[0] policy
     /* 1952036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1952049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952070 */     // GIR_Coverage, 24769,
     /* 1952070 */     GIR_EraseRootFromParent_Done,
     /* 1952071 */   // Label 26182: @1952071
     /* 1952071 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1952157), // Rule ID 24772 //
     /* 1952076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1952087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1952090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1952093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1952096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952122 */     // MIs[0] policy
     /* 1952122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952132 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1952135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952156 */     // GIR_Coverage, 24772,
     /* 1952156 */     GIR_EraseRootFromParent_Done,
     /* 1952157 */   // Label 26183: @1952157
     /* 1952157 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1952243), // Rule ID 24773 //
     /* 1952162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1952173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1952176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1952179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1952182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952208 */     // MIs[0] policy
     /* 1952208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1952221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952242 */     // GIR_Coverage, 24773,
     /* 1952242 */     GIR_EraseRootFromParent_Done,
     /* 1952243 */   // Label 26184: @1952243
     /* 1952243 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1952329), // Rule ID 24776 //
     /* 1952248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1952259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1952262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1952265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1952268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952294 */     // MIs[0] policy
     /* 1952294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1952307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952328 */     // GIR_Coverage, 24776,
     /* 1952328 */     GIR_EraseRootFromParent_Done,
     /* 1952329 */   // Label 26185: @1952329
     /* 1952329 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1952415), // Rule ID 24777 //
     /* 1952334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1952345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1952348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1952351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1952354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952380 */     // MIs[0] policy
     /* 1952380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1952393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952414 */     // GIR_Coverage, 24777,
     /* 1952414 */     GIR_EraseRootFromParent_Done,
     /* 1952415 */   // Label 26186: @1952415
     /* 1952415 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1952501), // Rule ID 24780 //
     /* 1952420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1952431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1952434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1952437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1952440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952466 */     // MIs[0] policy
     /* 1952466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952476 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1952479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952500 */     // GIR_Coverage, 24780,
     /* 1952500 */     GIR_EraseRootFromParent_Done,
     /* 1952501 */   // Label 26187: @1952501
     /* 1952501 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1952587), // Rule ID 24781 //
     /* 1952506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1952517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1952520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1952523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1952526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952552 */     // MIs[0] policy
     /* 1952552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952562 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1952565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952586 */     // GIR_Coverage, 24781,
     /* 1952586 */     GIR_EraseRootFromParent_Done,
     /* 1952587 */   // Label 26188: @1952587
     /* 1952587 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1952673), // Rule ID 24784 //
     /* 1952592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1952603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1952606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1952609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1952612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952638 */     // MIs[0] policy
     /* 1952638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1952651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952672 */     // GIR_Coverage, 24784,
     /* 1952672 */     GIR_EraseRootFromParent_Done,
     /* 1952673 */   // Label 26189: @1952673
     /* 1952673 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1952759), // Rule ID 24785 //
     /* 1952678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1952689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1952692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1952695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1952698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952724 */     // MIs[0] policy
     /* 1952724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1952737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952758 */     // GIR_Coverage, 24785,
     /* 1952758 */     GIR_EraseRootFromParent_Done,
     /* 1952759 */   // Label 26190: @1952759
     /* 1952759 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1952845), // Rule ID 24788 //
     /* 1952764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1952775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1952778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1952781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1952784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952810 */     // MIs[0] policy
     /* 1952810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1952823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952844 */     // GIR_Coverage, 24788,
     /* 1952844 */     GIR_EraseRootFromParent_Done,
     /* 1952845 */   // Label 26191: @1952845
     /* 1952845 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1952931), // Rule ID 24789 //
     /* 1952850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1952861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1952864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1952867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1952870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952896 */     // MIs[0] policy
     /* 1952896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1952909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952930 */     // GIR_Coverage, 24789,
     /* 1952930 */     GIR_EraseRootFromParent_Done,
     /* 1952931 */   // Label 26192: @1952931
     /* 1952931 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1953017), // Rule ID 24792 //
     /* 1952936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1952939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1952944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1952947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1952950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1952953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1952956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952982 */     // MIs[0] policy
     /* 1952982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1952995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953016 */     // GIR_Coverage, 24792,
     /* 1953016 */     GIR_EraseRootFromParent_Done,
     /* 1953017 */   // Label 26193: @1953017
     /* 1953017 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1953103), // Rule ID 24793 //
     /* 1953022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1953025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1953033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1953036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1953039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953068 */     // MIs[0] policy
     /* 1953068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1953081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953102 */     // GIR_Coverage, 24793,
     /* 1953102 */     GIR_EraseRootFromParent_Done,
     /* 1953103 */   // Label 26194: @1953103
     /* 1953103 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1953189), // Rule ID 24796 //
     /* 1953108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1953119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1953122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1953125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1953128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953154 */     // MIs[0] policy
     /* 1953154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1953167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953188 */     // GIR_Coverage, 24796,
     /* 1953188 */     GIR_EraseRootFromParent_Done,
     /* 1953189 */   // Label 26195: @1953189
     /* 1953189 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1953275), // Rule ID 24797 //
     /* 1953194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1953205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1953208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1953211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1953214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953240 */     // MIs[0] policy
     /* 1953240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1953253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953274 */     // GIR_Coverage, 24797,
     /* 1953274 */     GIR_EraseRootFromParent_Done,
     /* 1953275 */   // Label 26196: @1953275
     /* 1953275 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1953361), // Rule ID 24800 //
     /* 1953280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1953291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1953294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1953297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1953300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1953303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953326 */     // MIs[0] policy
     /* 1953326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953336 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1953339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953360 */     // GIR_Coverage, 24800,
     /* 1953360 */     GIR_EraseRootFromParent_Done,
     /* 1953361 */   // Label 26197: @1953361
     /* 1953361 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1953447), // Rule ID 24801 //
     /* 1953366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1953377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1953380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1953383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1953386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1953389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953412 */     // MIs[0] policy
     /* 1953412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1953425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953446 */     // GIR_Coverage, 24801,
     /* 1953446 */     GIR_EraseRootFromParent_Done,
     /* 1953447 */   // Label 26198: @1953447
     /* 1953447 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1953533), // Rule ID 24804 //
     /* 1953452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1953463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1953466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1953469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1953472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953498 */     // MIs[0] policy
     /* 1953498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1953511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953532 */     // GIR_Coverage, 24804,
     /* 1953532 */     GIR_EraseRootFromParent_Done,
     /* 1953533 */   // Label 26199: @1953533
     /* 1953533 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1953619), // Rule ID 24805 //
     /* 1953538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1953549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1953552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1953555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1953558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953584 */     // MIs[0] policy
     /* 1953584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1953597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953618 */     // GIR_Coverage, 24805,
     /* 1953618 */     GIR_EraseRootFromParent_Done,
     /* 1953619 */   // Label 26200: @1953619
     /* 1953619 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1953705), // Rule ID 24808 //
     /* 1953624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1953635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1953638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1953641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1953644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953670 */     // MIs[0] policy
     /* 1953670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1953683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953704 */     // GIR_Coverage, 24808,
     /* 1953704 */     GIR_EraseRootFromParent_Done,
     /* 1953705 */   // Label 26201: @1953705
     /* 1953705 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1953791), // Rule ID 24809 //
     /* 1953710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1953721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1953724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1953727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1953730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953756 */     // MIs[0] policy
     /* 1953756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1953769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953790 */     // GIR_Coverage, 24809,
     /* 1953790 */     GIR_EraseRootFromParent_Done,
     /* 1953791 */   // Label 26202: @1953791
     /* 1953791 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1953877), // Rule ID 24812 //
     /* 1953796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1953807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1953810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1953813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1953816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1953819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953842 */     // MIs[0] policy
     /* 1953842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1953855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953876 */     // GIR_Coverage, 24812,
     /* 1953876 */     GIR_EraseRootFromParent_Done,
     /* 1953877 */   // Label 26203: @1953877
     /* 1953877 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1953963), // Rule ID 24813 //
     /* 1953882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1953893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1953896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1953899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1953902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1953905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953928 */     // MIs[0] policy
     /* 1953928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953938 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1953941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953962 */     // GIR_Coverage, 24813,
     /* 1953962 */     GIR_EraseRootFromParent_Done,
     /* 1953963 */   // Label 26204: @1953963
     /* 1953963 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1954049), // Rule ID 24816 //
     /* 1953968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1953979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1953982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1953985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1953988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954014 */     // MIs[0] policy
     /* 1954014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1954027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954048 */     // GIR_Coverage, 24816,
     /* 1954048 */     GIR_EraseRootFromParent_Done,
     /* 1954049 */   // Label 26205: @1954049
     /* 1954049 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1954135), // Rule ID 24817 //
     /* 1954054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1954065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1954068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1954071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1954084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954100 */     // MIs[0] policy
     /* 1954100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1954113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954134 */     // GIR_Coverage, 24817,
     /* 1954134 */     GIR_EraseRootFromParent_Done,
     /* 1954135 */   // Label 26206: @1954135
     /* 1954135 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1954221), // Rule ID 24820 //
     /* 1954140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1954151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1954154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1954157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954186 */     // MIs[0] policy
     /* 1954186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1954199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954220 */     // GIR_Coverage, 24820,
     /* 1954220 */     GIR_EraseRootFromParent_Done,
     /* 1954221 */   // Label 26207: @1954221
     /* 1954221 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1954307), // Rule ID 24821 //
     /* 1954226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1954237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1954240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1954243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954272 */     // MIs[0] policy
     /* 1954272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1954285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954306 */     // GIR_Coverage, 24821,
     /* 1954306 */     GIR_EraseRootFromParent_Done,
     /* 1954307 */   // Label 26208: @1954307
     /* 1954307 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1954393), // Rule ID 24824 //
     /* 1954312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1954323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1954326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1954329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1954332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1954335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954358 */     // MIs[0] policy
     /* 1954358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1954371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954392 */     // GIR_Coverage, 24824,
     /* 1954392 */     GIR_EraseRootFromParent_Done,
     /* 1954393 */   // Label 26209: @1954393
     /* 1954393 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1954479), // Rule ID 24825 //
     /* 1954398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1954409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1954412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1954415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1954418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1954421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954444 */     // MIs[0] policy
     /* 1954444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954454 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1954457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954478 */     // GIR_Coverage, 24825,
     /* 1954478 */     GIR_EraseRootFromParent_Done,
     /* 1954479 */   // Label 26210: @1954479
     /* 1954479 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1954565), // Rule ID 24828 //
     /* 1954484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1954487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1954495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1954498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1954501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1954514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954530 */     // MIs[0] policy
     /* 1954530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1954543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954564 */     // GIR_Coverage, 24828,
     /* 1954564 */     GIR_EraseRootFromParent_Done,
     /* 1954565 */   // Label 26211: @1954565
     /* 1954565 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1954651), // Rule ID 24829 //
     /* 1954570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1954573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1954581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1954584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1954587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1954600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954616 */     // MIs[0] policy
     /* 1954616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954626 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1954629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954650 */     // GIR_Coverage, 24829,
     /* 1954650 */     GIR_EraseRootFromParent_Done,
     /* 1954651 */   // Label 26212: @1954651
     /* 1954651 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1954737), // Rule ID 24832 //
     /* 1954656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1954659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1954667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1954670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1954673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954702 */     // MIs[0] policy
     /* 1954702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1954715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954736 */     // GIR_Coverage, 24832,
     /* 1954736 */     GIR_EraseRootFromParent_Done,
     /* 1954737 */   // Label 26213: @1954737
     /* 1954737 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1954823), // Rule ID 24833 //
     /* 1954742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1954745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1954753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1954756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1954759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954788 */     // MIs[0] policy
     /* 1954788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954798 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1954801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954822 */     // GIR_Coverage, 24833,
     /* 1954822 */     GIR_EraseRootFromParent_Done,
     /* 1954823 */   // Label 26214: @1954823
     /* 1954823 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1954909), // Rule ID 24836 //
     /* 1954828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1954831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1954839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1954842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1954845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954874 */     // MIs[0] policy
     /* 1954874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954884 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1954887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954908 */     // GIR_Coverage, 24836,
     /* 1954908 */     GIR_EraseRootFromParent_Done,
     /* 1954909 */   // Label 26215: @1954909
     /* 1954909 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1954995), // Rule ID 24837 //
     /* 1954914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1954917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1954925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1954928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1954931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954960 */     // MIs[0] policy
     /* 1954960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1954973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1954991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954994 */     // GIR_Coverage, 24837,
     /* 1954994 */     GIR_EraseRootFromParent_Done,
     /* 1954995 */   // Label 26216: @1954995
     /* 1954995 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1955081), // Rule ID 24840 //
     /* 1955000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1955003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1955011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1955014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1955017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1955020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955046 */     // MIs[0] policy
     /* 1955046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1955059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955080 */     // GIR_Coverage, 24840,
     /* 1955080 */     GIR_EraseRootFromParent_Done,
     /* 1955081 */   // Label 26217: @1955081
     /* 1955081 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1955167), // Rule ID 24841 //
     /* 1955086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1955089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1955097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1955100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1955103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1955106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955132 */     // MIs[0] policy
     /* 1955132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955142 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1955145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955166 */     // GIR_Coverage, 24841,
     /* 1955166 */     GIR_EraseRootFromParent_Done,
     /* 1955167 */   // Label 26218: @1955167
     /* 1955167 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1955253), // Rule ID 24844 //
     /* 1955172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1955175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1955192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955218 */     // MIs[0] policy
     /* 1955218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955228 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1955231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955252 */     // GIR_Coverage, 24844,
     /* 1955252 */     GIR_EraseRootFromParent_Done,
     /* 1955253 */   // Label 26219: @1955253
     /* 1955253 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1955339), // Rule ID 24845 //
     /* 1955258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1955261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1955278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955304 */     // MIs[0] policy
     /* 1955304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955314 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1955317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955338 */     // GIR_Coverage, 24845,
     /* 1955338 */     GIR_EraseRootFromParent_Done,
     /* 1955339 */   // Label 26220: @1955339
     /* 1955339 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1955425), // Rule ID 24848 //
     /* 1955344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1955347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1955364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955390 */     // MIs[0] policy
     /* 1955390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1955403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955424 */     // GIR_Coverage, 24848,
     /* 1955424 */     GIR_EraseRootFromParent_Done,
     /* 1955425 */   // Label 26221: @1955425
     /* 1955425 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1955511), // Rule ID 24849 //
     /* 1955430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1955433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1955450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955476 */     // MIs[0] policy
     /* 1955476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955486 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1955489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955510 */     // GIR_Coverage, 24849,
     /* 1955510 */     GIR_EraseRootFromParent_Done,
     /* 1955511 */   // Label 26222: @1955511
     /* 1955511 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1955597), // Rule ID 24852 //
     /* 1955516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1955519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1955527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1955530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1955533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1955536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955562 */     // MIs[0] policy
     /* 1955562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955572 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1955575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955596 */     // GIR_Coverage, 24852,
     /* 1955596 */     GIR_EraseRootFromParent_Done,
     /* 1955597 */   // Label 26223: @1955597
     /* 1955597 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1955683), // Rule ID 24853 //
     /* 1955602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1955605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1955613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1955616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1955619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1955622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955648 */     // MIs[0] policy
     /* 1955648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1955661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955682 */     // GIR_Coverage, 24853,
     /* 1955682 */     GIR_EraseRootFromParent_Done,
     /* 1955683 */   // Label 26224: @1955683
     /* 1955683 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1955769), // Rule ID 24856 //
     /* 1955688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1955691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1955699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1955702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1955705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1955708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955734 */     // MIs[0] policy
     /* 1955734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1955747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955768 */     // GIR_Coverage, 24856,
     /* 1955768 */     GIR_EraseRootFromParent_Done,
     /* 1955769 */   // Label 26225: @1955769
     /* 1955769 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1955855), // Rule ID 24857 //
     /* 1955774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1955777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1955785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1955788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1955791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1955794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955820 */     // MIs[0] policy
     /* 1955820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955830 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1955833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955854 */     // GIR_Coverage, 24857,
     /* 1955854 */     GIR_EraseRootFromParent_Done,
     /* 1955855 */   // Label 26226: @1955855
     /* 1955855 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1955941), // Rule ID 24860 //
     /* 1955860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1955863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1955871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1955874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1955877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1955880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955906 */     // MIs[0] policy
     /* 1955906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955916 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1955919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955940 */     // GIR_Coverage, 24860,
     /* 1955940 */     GIR_EraseRootFromParent_Done,
     /* 1955941 */   // Label 26227: @1955941
     /* 1955941 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1956027), // Rule ID 24861 //
     /* 1955946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1955949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1955954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1955957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1955960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1955963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1955966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955992 */     // MIs[0] policy
     /* 1955992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956002 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1956005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956026 */     // GIR_Coverage, 24861,
     /* 1956026 */     GIR_EraseRootFromParent_Done,
     /* 1956027 */   // Label 26228: @1956027
     /* 1956027 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1956113), // Rule ID 24864 //
     /* 1956032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1956035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1956052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956078 */     // MIs[0] policy
     /* 1956078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956088 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1956091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956112 */     // GIR_Coverage, 24864,
     /* 1956112 */     GIR_EraseRootFromParent_Done,
     /* 1956113 */   // Label 26229: @1956113
     /* 1956113 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1956199), // Rule ID 24865 //
     /* 1956118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1956121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1956138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956164 */     // MIs[0] policy
     /* 1956164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1956177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956198 */     // GIR_Coverage, 24865,
     /* 1956198 */     GIR_EraseRootFromParent_Done,
     /* 1956199 */   // Label 26230: @1956199
     /* 1956199 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1956285), // Rule ID 24868 //
     /* 1956204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1956207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1956224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956250 */     // MIs[0] policy
     /* 1956250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956260 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1956263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956284 */     // GIR_Coverage, 24868,
     /* 1956284 */     GIR_EraseRootFromParent_Done,
     /* 1956285 */   // Label 26231: @1956285
     /* 1956285 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1956371), // Rule ID 24869 //
     /* 1956290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1956293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1956310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956336 */     // MIs[0] policy
     /* 1956336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956346 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1956349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956370 */     // GIR_Coverage, 24869,
     /* 1956370 */     GIR_EraseRootFromParent_Done,
     /* 1956371 */   // Label 26232: @1956371
     /* 1956371 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1956457), // Rule ID 24872 //
     /* 1956376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1956379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1956387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1956390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1956393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1956396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956422 */     // MIs[0] policy
     /* 1956422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1956435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956456 */     // GIR_Coverage, 24872,
     /* 1956456 */     GIR_EraseRootFromParent_Done,
     /* 1956457 */   // Label 26233: @1956457
     /* 1956457 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1956543), // Rule ID 24873 //
     /* 1956462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1956465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1956470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1956473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1956476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1956479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1956482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956508 */     // MIs[0] policy
     /* 1956508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956518 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1956521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956542 */     // GIR_Coverage, 24873,
     /* 1956542 */     GIR_EraseRootFromParent_Done,
     /* 1956543 */   // Label 26234: @1956543
     /* 1956543 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1956629), // Rule ID 24876 //
     /* 1956548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1956551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1956559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1956562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1956565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956594 */     // MIs[0] policy
     /* 1956594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1956607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956628 */     // GIR_Coverage, 24876,
     /* 1956628 */     GIR_EraseRootFromParent_Done,
     /* 1956629 */   // Label 26235: @1956629
     /* 1956629 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1956715), // Rule ID 24877 //
     /* 1956634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1956637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1956645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1956648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1956651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956680 */     // MIs[0] policy
     /* 1956680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1956693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956714 */     // GIR_Coverage, 24877,
     /* 1956714 */     GIR_EraseRootFromParent_Done,
     /* 1956715 */   // Label 26236: @1956715
     /* 1956715 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1956801), // Rule ID 24880 //
     /* 1956720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1956723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1956731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1956734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1956737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956766 */     // MIs[0] policy
     /* 1956766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956776 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1956779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956800 */     // GIR_Coverage, 24880,
     /* 1956800 */     GIR_EraseRootFromParent_Done,
     /* 1956801 */   // Label 26237: @1956801
     /* 1956801 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1956887), // Rule ID 24881 //
     /* 1956806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1956809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1956817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1956820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1956823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956852 */     // MIs[0] policy
     /* 1956852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1956865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956886 */     // GIR_Coverage, 24881,
     /* 1956886 */     GIR_EraseRootFromParent_Done,
     /* 1956887 */   // Label 26238: @1956887
     /* 1956887 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1956973), // Rule ID 24884 //
     /* 1956892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1956895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1956903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1956906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1956909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1956912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1956934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956938 */     // MIs[0] policy
     /* 1956938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1956951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956972 */     // GIR_Coverage, 24884,
     /* 1956972 */     GIR_EraseRootFromParent_Done,
     /* 1956973 */   // Label 26239: @1956973
     /* 1956973 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1957059), // Rule ID 24885 //
     /* 1956978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1956981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1956986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1956989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1956992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1956995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1956998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957024 */     // MIs[0] policy
     /* 1957024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1957037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957058 */     // GIR_Coverage, 24885,
     /* 1957058 */     GIR_EraseRootFromParent_Done,
     /* 1957059 */   // Label 26240: @1957059
     /* 1957059 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1957145), // Rule ID 24888 //
     /* 1957064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1957067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1957075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1957078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1957081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957110 */     // MIs[0] policy
     /* 1957110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957120 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957144 */     // GIR_Coverage, 24888,
     /* 1957144 */     GIR_EraseRootFromParent_Done,
     /* 1957145 */   // Label 26241: @1957145
     /* 1957145 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1957231), // Rule ID 24889 //
     /* 1957150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1957153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1957161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1957164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1957167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957196 */     // MIs[0] policy
     /* 1957196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957206 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957230 */     // GIR_Coverage, 24889,
     /* 1957230 */     GIR_EraseRootFromParent_Done,
     /* 1957231 */   // Label 26242: @1957231
     /* 1957231 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1957317), // Rule ID 24892 //
     /* 1957236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1957239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1957247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1957250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1957253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957282 */     // MIs[0] policy
     /* 1957282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957292 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957316 */     // GIR_Coverage, 24892,
     /* 1957316 */     GIR_EraseRootFromParent_Done,
     /* 1957317 */   // Label 26243: @1957317
     /* 1957317 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1957403), // Rule ID 24893 //
     /* 1957322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1957325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1957333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1957336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1957339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957368 */     // MIs[0] policy
     /* 1957368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957378 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957402 */     // GIR_Coverage, 24893,
     /* 1957402 */     GIR_EraseRootFromParent_Done,
     /* 1957403 */   // Label 26244: @1957403
     /* 1957403 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1957489), // Rule ID 24896 //
     /* 1957408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1957411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957454 */     // MIs[0] policy
     /* 1957454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957464 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1957467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957488 */     // GIR_Coverage, 24896,
     /* 1957488 */     GIR_EraseRootFromParent_Done,
     /* 1957489 */   // Label 26245: @1957489
     /* 1957489 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1957575), // Rule ID 24897 //
     /* 1957494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1957497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957540 */     // MIs[0] policy
     /* 1957540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957550 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1957553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957574 */     // GIR_Coverage, 24897,
     /* 1957574 */     GIR_EraseRootFromParent_Done,
     /* 1957575 */   // Label 26246: @1957575
     /* 1957575 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1957661), // Rule ID 24900 //
     /* 1957580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1957583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957626 */     // MIs[0] policy
     /* 1957626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957660 */     // GIR_Coverage, 24900,
     /* 1957660 */     GIR_EraseRootFromParent_Done,
     /* 1957661 */   // Label 26247: @1957661
     /* 1957661 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1957747), // Rule ID 24901 //
     /* 1957666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1957669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957712 */     // MIs[0] policy
     /* 1957712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1957725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957746 */     // GIR_Coverage, 24901,
     /* 1957746 */     GIR_EraseRootFromParent_Done,
     /* 1957747 */   // Label 26248: @1957747
     /* 1957747 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1957833), // Rule ID 24904 //
     /* 1957752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1957755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957798 */     // MIs[0] policy
     /* 1957798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957832 */     // GIR_Coverage, 24904,
     /* 1957832 */     GIR_EraseRootFromParent_Done,
     /* 1957833 */   // Label 26249: @1957833
     /* 1957833 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1957919), // Rule ID 24905 //
     /* 1957838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1957841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1957849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1957852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1957855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1957858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957884 */     // MIs[0] policy
     /* 1957884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957894 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1957897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957918 */     // GIR_Coverage, 24905,
     /* 1957918 */     GIR_EraseRootFromParent_Done,
     /* 1957919 */   // Label 26250: @1957919
     /* 1957919 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1958005), // Rule ID 24908 //
     /* 1957924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1957927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1957932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1957944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1957966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957970 */     // MIs[0] policy
     /* 1957970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957980 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1957983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958004 */     // GIR_Coverage, 24908,
     /* 1958004 */     GIR_EraseRootFromParent_Done,
     /* 1958005 */   // Label 26251: @1958005
     /* 1958005 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1958091), // Rule ID 24909 //
     /* 1958010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1958013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1958018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1958021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1958024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1958027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1958030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1958052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958056 */     // MIs[0] policy
     /* 1958056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958066 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1958069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958090 */     // GIR_Coverage, 24909,
     /* 1958090 */     GIR_EraseRootFromParent_Done,
     /* 1958091 */   // Label 26252: @1958091
     /* 1958091 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1958177), // Rule ID 24948 //
     /* 1958096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1958107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1958110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1958113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958142 */     // MIs[0] policy
     /* 1958142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958152 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1958155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958176 */     // GIR_Coverage, 24948,
     /* 1958176 */     GIR_EraseRootFromParent_Done,
     /* 1958177 */   // Label 26253: @1958177
     /* 1958177 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1958263), // Rule ID 24949 //
     /* 1958182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1958193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1958196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1958199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1958202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958228 */     // MIs[0] policy
     /* 1958228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958238 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1958241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958262 */     // GIR_Coverage, 24949,
     /* 1958262 */     GIR_EraseRootFromParent_Done,
     /* 1958263 */   // Label 26254: @1958263
     /* 1958263 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1958349), // Rule ID 24952 //
     /* 1958268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1958285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958314 */     // MIs[0] policy
     /* 1958314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958324 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1958327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958348 */     // GIR_Coverage, 24952,
     /* 1958348 */     GIR_EraseRootFromParent_Done,
     /* 1958349 */   // Label 26255: @1958349
     /* 1958349 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1958435), // Rule ID 24953 //
     /* 1958354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1958371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1958374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958400 */     // MIs[0] policy
     /* 1958400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1958413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958434 */     // GIR_Coverage, 24953,
     /* 1958434 */     GIR_EraseRootFromParent_Done,
     /* 1958435 */   // Label 26256: @1958435
     /* 1958435 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1958521), // Rule ID 24956 //
     /* 1958440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958486 */     // MIs[0] policy
     /* 1958486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958520 */     // GIR_Coverage, 24956,
     /* 1958520 */     GIR_EraseRootFromParent_Done,
     /* 1958521 */   // Label 26257: @1958521
     /* 1958521 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1958607), // Rule ID 24957 //
     /* 1958526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1958543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958572 */     // MIs[0] policy
     /* 1958572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1958585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958606 */     // GIR_Coverage, 24957,
     /* 1958606 */     GIR_EraseRootFromParent_Done,
     /* 1958607 */   // Label 26258: @1958607
     /* 1958607 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1958693), // Rule ID 24960 //
     /* 1958612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958658 */     // MIs[0] policy
     /* 1958658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958668 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958692 */     // GIR_Coverage, 24960,
     /* 1958692 */     GIR_EraseRootFromParent_Done,
     /* 1958693 */   // Label 26259: @1958693
     /* 1958693 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1958779), // Rule ID 24961 //
     /* 1958698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958744 */     // MIs[0] policy
     /* 1958744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958754 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958778 */     // GIR_Coverage, 24961,
     /* 1958778 */     GIR_EraseRootFromParent_Done,
     /* 1958779 */   // Label 26260: @1958779
     /* 1958779 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1958865), // Rule ID 24964 //
     /* 1958784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958830 */     // MIs[0] policy
     /* 1958830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958840 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958864 */     // GIR_Coverage, 24964,
     /* 1958864 */     GIR_EraseRootFromParent_Done,
     /* 1958865 */   // Label 26261: @1958865
     /* 1958865 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1958951), // Rule ID 24965 //
     /* 1958870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958916 */     // MIs[0] policy
     /* 1958916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958926 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958950 */     // GIR_Coverage, 24965,
     /* 1958950 */     GIR_EraseRootFromParent_Done,
     /* 1958951 */   // Label 26262: @1958951
     /* 1958951 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1959037), // Rule ID 24968 //
     /* 1958956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1958967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1958970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1958973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1958976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1958979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959002 */     // MIs[0] policy
     /* 1959002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959012 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959036 */     // GIR_Coverage, 24968,
     /* 1959036 */     GIR_EraseRootFromParent_Done,
     /* 1959037 */   // Label 26263: @1959037
     /* 1959037 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1959123), // Rule ID 24969 //
     /* 1959042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1959059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1959062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959088 */     // MIs[0] policy
     /* 1959088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959098 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1959101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959122 */     // GIR_Coverage, 24969,
     /* 1959122 */     GIR_EraseRootFromParent_Done,
     /* 1959123 */   // Label 26264: @1959123
     /* 1959123 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1959209), // Rule ID 24972 //
     /* 1959128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959174 */     // MIs[0] policy
     /* 1959174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959184 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959208 */     // GIR_Coverage, 24972,
     /* 1959208 */     GIR_EraseRootFromParent_Done,
     /* 1959209 */   // Label 26265: @1959209
     /* 1959209 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1959295), // Rule ID 24973 //
     /* 1959214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959260 */     // MIs[0] policy
     /* 1959260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959270 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959294 */     // GIR_Coverage, 24973,
     /* 1959294 */     GIR_EraseRootFromParent_Done,
     /* 1959295 */   // Label 26266: @1959295
     /* 1959295 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1959381), // Rule ID 24976 //
     /* 1959300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1959311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1959314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1959317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959346 */     // MIs[0] policy
     /* 1959346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959356 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1959359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959380 */     // GIR_Coverage, 24976,
     /* 1959380 */     GIR_EraseRootFromParent_Done,
     /* 1959381 */   // Label 26267: @1959381
     /* 1959381 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1959467), // Rule ID 24977 //
     /* 1959386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1959397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1959400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1959403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959432 */     // MIs[0] policy
     /* 1959432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959442 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1959445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959466 */     // GIR_Coverage, 24977,
     /* 1959466 */     GIR_EraseRootFromParent_Done,
     /* 1959467 */   // Label 26268: @1959467
     /* 1959467 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1959553), // Rule ID 24980 //
     /* 1959472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1959483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1959486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1959489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959518 */     // MIs[0] policy
     /* 1959518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959528 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1959531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959552 */     // GIR_Coverage, 24980,
     /* 1959552 */     GIR_EraseRootFromParent_Done,
     /* 1959553 */   // Label 26269: @1959553
     /* 1959553 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1959639), // Rule ID 24981 //
     /* 1959558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1959569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1959572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1959575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959604 */     // MIs[0] policy
     /* 1959604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959614 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1959617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959638 */     // GIR_Coverage, 24981,
     /* 1959638 */     GIR_EraseRootFromParent_Done,
     /* 1959639 */   // Label 26270: @1959639
     /* 1959639 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1959725), // Rule ID 24984 //
     /* 1959644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959690 */     // MIs[0] policy
     /* 1959690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1959703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959724 */     // GIR_Coverage, 24984,
     /* 1959724 */     GIR_EraseRootFromParent_Done,
     /* 1959725 */   // Label 26271: @1959725
     /* 1959725 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1959811), // Rule ID 24985 //
     /* 1959730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959776 */     // MIs[0] policy
     /* 1959776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959786 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1959789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959810 */     // GIR_Coverage, 24985,
     /* 1959810 */     GIR_EraseRootFromParent_Done,
     /* 1959811 */   // Label 26272: @1959811
     /* 1959811 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1959897), // Rule ID 24988 //
     /* 1959816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959862 */     // MIs[0] policy
     /* 1959862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959872 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1959875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959896 */     // GIR_Coverage, 24988,
     /* 1959896 */     GIR_EraseRootFromParent_Done,
     /* 1959897 */   // Label 26273: @1959897
     /* 1959897 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1959983), // Rule ID 24989 //
     /* 1959902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1959919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959948 */     // MIs[0] policy
     /* 1959948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959958 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1959961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959982 */     // GIR_Coverage, 24989,
     /* 1959982 */     GIR_EraseRootFromParent_Done,
     /* 1959983 */   // Label 26274: @1959983
     /* 1959983 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1960069), // Rule ID 24992 //
     /* 1959988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1960002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1960005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1960011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960034 */     // MIs[0] policy
     /* 1960034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960044 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1960047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960068 */     // GIR_Coverage, 24992,
     /* 1960068 */     GIR_EraseRootFromParent_Done,
     /* 1960069 */   // Label 26275: @1960069
     /* 1960069 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1960155), // Rule ID 24993 //
     /* 1960074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1960077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1960085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1960088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1960091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1960097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960120 */     // MIs[0] policy
     /* 1960120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960130 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1960133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960154 */     // GIR_Coverage, 24993,
     /* 1960154 */     GIR_EraseRootFromParent_Done,
     /* 1960155 */   // Label 26276: @1960155
     /* 1960155 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1960241), // Rule ID 25020 //
     /* 1960160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1960163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1960180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960206 */     // MIs[0] policy
     /* 1960206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1960219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960240 */     // GIR_Coverage, 25020,
     /* 1960240 */     GIR_EraseRootFromParent_Done,
     /* 1960241 */   // Label 26277: @1960241
     /* 1960241 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1960327), // Rule ID 25021 //
     /* 1960246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1960249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1960263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1960266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960292 */     // MIs[0] policy
     /* 1960292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960302 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1960305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960326 */     // GIR_Coverage, 25021,
     /* 1960326 */     GIR_EraseRootFromParent_Done,
     /* 1960327 */   // Label 26278: @1960327
     /* 1960327 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1960413), // Rule ID 25024 //
     /* 1960332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1960335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960378 */     // MIs[0] policy
     /* 1960378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960388 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1960391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960412 */     // GIR_Coverage, 25024,
     /* 1960412 */     GIR_EraseRootFromParent_Done,
     /* 1960413 */   // Label 26279: @1960413
     /* 1960413 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1960499), // Rule ID 25025 //
     /* 1960418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1960421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960464 */     // MIs[0] policy
     /* 1960464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960474 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1960477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960498 */     // GIR_Coverage, 25025,
     /* 1960498 */     GIR_EraseRootFromParent_Done,
     /* 1960499 */   // Label 26280: @1960499
     /* 1960499 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1960585), // Rule ID 25028 //
     /* 1960504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1960507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1960524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960550 */     // MIs[0] policy
     /* 1960550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960560 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1960563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960584 */     // GIR_Coverage, 25028,
     /* 1960584 */     GIR_EraseRootFromParent_Done,
     /* 1960585 */   // Label 26281: @1960585
     /* 1960585 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1960671), // Rule ID 25029 //
     /* 1960590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1960593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1960610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960636 */     // MIs[0] policy
     /* 1960636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1960649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960670 */     // GIR_Coverage, 25029,
     /* 1960670 */     GIR_EraseRootFromParent_Done,
     /* 1960671 */   // Label 26282: @1960671
     /* 1960671 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1960757), // Rule ID 25032 //
     /* 1960676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1960679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960722 */     // MIs[0] policy
     /* 1960722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1960735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960756 */     // GIR_Coverage, 25032,
     /* 1960756 */     GIR_EraseRootFromParent_Done,
     /* 1960757 */   // Label 26283: @1960757
     /* 1960757 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1960843), // Rule ID 25033 //
     /* 1960762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1960765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1960782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960808 */     // MIs[0] policy
     /* 1960808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1960821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960842 */     // GIR_Coverage, 25033,
     /* 1960842 */     GIR_EraseRootFromParent_Done,
     /* 1960843 */   // Label 26284: @1960843
     /* 1960843 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1960929), // Rule ID 25036 //
     /* 1960848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1960851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960894 */     // MIs[0] policy
     /* 1960894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1960907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960928 */     // GIR_Coverage, 25036,
     /* 1960928 */     GIR_EraseRootFromParent_Done,
     /* 1960929 */   // Label 26285: @1960929
     /* 1960929 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1961015), // Rule ID 25037 //
     /* 1960934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1960937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1960942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1960954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960980 */     // MIs[0] policy
     /* 1960980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1960993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961014 */     // GIR_Coverage, 25037,
     /* 1961014 */     GIR_EraseRootFromParent_Done,
     /* 1961015 */   // Label 26286: @1961015
     /* 1961015 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1961101), // Rule ID 25040 //
     /* 1961020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1961023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1961040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961066 */     // MIs[0] policy
     /* 1961066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961076 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1961079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961100 */     // GIR_Coverage, 25040,
     /* 1961100 */     GIR_EraseRootFromParent_Done,
     /* 1961101 */   // Label 26287: @1961101
     /* 1961101 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1961187), // Rule ID 25041 //
     /* 1961106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1961109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1961117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1961120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1961123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1961126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961152 */     // MIs[0] policy
     /* 1961152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961162 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1961165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961186 */     // GIR_Coverage, 25041,
     /* 1961186 */     GIR_EraseRootFromParent_Done,
     /* 1961187 */   // Label 26288: @1961187
     /* 1961187 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1961273), // Rule ID 25044 //
     /* 1961192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1961195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1961212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961238 */     // MIs[0] policy
     /* 1961238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961248 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1961251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961272 */     // GIR_Coverage, 25044,
     /* 1961272 */     GIR_EraseRootFromParent_Done,
     /* 1961273 */   // Label 26289: @1961273
     /* 1961273 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1961359), // Rule ID 25045 //
     /* 1961278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1961281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1961295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1961298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961324 */     // MIs[0] policy
     /* 1961324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961334 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1961337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961358 */     // GIR_Coverage, 25045,
     /* 1961358 */     GIR_EraseRootFromParent_Done,
     /* 1961359 */   // Label 26290: @1961359
     /* 1961359 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1961445), // Rule ID 25048 //
     /* 1961364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1961367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1961384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961410 */     // MIs[0] policy
     /* 1961410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961420 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1961423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961444 */     // GIR_Coverage, 25048,
     /* 1961444 */     GIR_EraseRootFromParent_Done,
     /* 1961445 */   // Label 26291: @1961445
     /* 1961445 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1961531), // Rule ID 25049 //
     /* 1961450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1961453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1961470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961496 */     // MIs[0] policy
     /* 1961496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961506 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1961509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961530 */     // GIR_Coverage, 25049,
     /* 1961530 */     GIR_EraseRootFromParent_Done,
     /* 1961531 */   // Label 26292: @1961531
     /* 1961531 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1961617), // Rule ID 25052 //
     /* 1961536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1961539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1961556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961582 */     // MIs[0] policy
     /* 1961582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961592 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1961595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961616 */     // GIR_Coverage, 25052,
     /* 1961616 */     GIR_EraseRootFromParent_Done,
     /* 1961617 */   // Label 26293: @1961617
     /* 1961617 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1961703), // Rule ID 25053 //
     /* 1961622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1961625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1961642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961668 */     // MIs[0] policy
     /* 1961668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961678 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1961681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961702 */     // GIR_Coverage, 25053,
     /* 1961702 */     GIR_EraseRootFromParent_Done,
     /* 1961703 */   // Label 26294: @1961703
     /* 1961703 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1961789), // Rule ID 25056 //
     /* 1961708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1961711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1961728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961754 */     // MIs[0] policy
     /* 1961754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1961767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961788 */     // GIR_Coverage, 25056,
     /* 1961788 */     GIR_EraseRootFromParent_Done,
     /* 1961789 */   // Label 26295: @1961789
     /* 1961789 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1961875), // Rule ID 25057 //
     /* 1961794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1961797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1961814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961840 */     // MIs[0] policy
     /* 1961840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1961853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961874 */     // GIR_Coverage, 25057,
     /* 1961874 */     GIR_EraseRootFromParent_Done,
     /* 1961875 */   // Label 26296: @1961875
     /* 1961875 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1961961), // Rule ID 25060 //
     /* 1961880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1961883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1961900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961926 */     // MIs[0] policy
     /* 1961926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1961939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961960 */     // GIR_Coverage, 25060,
     /* 1961960 */     GIR_EraseRootFromParent_Done,
     /* 1961961 */   // Label 26297: @1961961
     /* 1961961 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1962047), // Rule ID 25061 //
     /* 1961966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1961969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1961974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1961986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962012 */     // MIs[0] policy
     /* 1962012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962022 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1962025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962046 */     // GIR_Coverage, 25061,
     /* 1962046 */     GIR_EraseRootFromParent_Done,
     /* 1962047 */   // Label 26298: @1962047
     /* 1962047 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1962133), // Rule ID 25064 //
     /* 1962052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1962055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1962072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962098 */     // MIs[0] policy
     /* 1962098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962108 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1962111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962132 */     // GIR_Coverage, 25064,
     /* 1962132 */     GIR_EraseRootFromParent_Done,
     /* 1962133 */   // Label 26299: @1962133
     /* 1962133 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1962219), // Rule ID 25065 //
     /* 1962138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1962141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1962155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1962158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962184 */     // MIs[0] policy
     /* 1962184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962194 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1962197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962218 */     // GIR_Coverage, 25065,
     /* 1962218 */     GIR_EraseRootFromParent_Done,
     /* 1962219 */   // Label 26300: @1962219
     /* 1962219 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1962305), // Rule ID 25068 //
     /* 1962224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1962227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962270 */     // MIs[0] policy
     /* 1962270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962280 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1962283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962304 */     // GIR_Coverage, 25068,
     /* 1962304 */     GIR_EraseRootFromParent_Done,
     /* 1962305 */   // Label 26301: @1962305
     /* 1962305 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1962391), // Rule ID 25069 //
     /* 1962310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1962313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1962321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1962324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1962327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962356 */     // MIs[0] policy
     /* 1962356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962366 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1962369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962390 */     // GIR_Coverage, 25069,
     /* 1962390 */     GIR_EraseRootFromParent_Done,
     /* 1962391 */   // Label 26302: @1962391
     /* 1962391 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1962477), // Rule ID 25072 //
     /* 1962396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1962399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962442 */     // MIs[0] policy
     /* 1962442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962452 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1962455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962476 */     // GIR_Coverage, 25072,
     /* 1962476 */     GIR_EraseRootFromParent_Done,
     /* 1962477 */   // Label 26303: @1962477
     /* 1962477 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1962563), // Rule ID 25073 //
     /* 1962482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1962485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962528 */     // MIs[0] policy
     /* 1962528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962538 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1962541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962562 */     // GIR_Coverage, 25073,
     /* 1962562 */     GIR_EraseRootFromParent_Done,
     /* 1962563 */   // Label 26304: @1962563
     /* 1962563 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1962649), // Rule ID 25076 //
     /* 1962568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1962571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1962588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962614 */     // MIs[0] policy
     /* 1962614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1962627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962648 */     // GIR_Coverage, 25076,
     /* 1962648 */     GIR_EraseRootFromParent_Done,
     /* 1962649 */   // Label 26305: @1962649
     /* 1962649 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1962735), // Rule ID 25077 //
     /* 1962654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1962657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1962674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962700 */     // MIs[0] policy
     /* 1962700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962710 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1962713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962734 */     // GIR_Coverage, 25077,
     /* 1962734 */     GIR_EraseRootFromParent_Done,
     /* 1962735 */   // Label 26306: @1962735
     /* 1962735 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1962821), // Rule ID 60964 //
     /* 1962740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1962757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1962760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962786 */     // MIs[0] policy
     /* 1962786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1962799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962820 */     // GIR_Coverage, 60964,
     /* 1962820 */     GIR_EraseRootFromParent_Done,
     /* 1962821 */   // Label 26307: @1962821
     /* 1962821 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1962907), // Rule ID 60965 //
     /* 1962826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1962843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1962846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962872 */     // MIs[0] policy
     /* 1962872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962882 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1962885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962906 */     // GIR_Coverage, 60965,
     /* 1962906 */     GIR_EraseRootFromParent_Done,
     /* 1962907 */   // Label 26308: @1962907
     /* 1962907 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1962993), // Rule ID 60968 //
     /* 1962912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1962929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1962932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962958 */     // MIs[0] policy
     /* 1962958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1962971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1962989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962992 */     // GIR_Coverage, 60968,
     /* 1962992 */     GIR_EraseRootFromParent_Done,
     /* 1962993 */   // Label 26309: @1962993
     /* 1962993 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1963079), // Rule ID 60969 //
     /* 1962998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1963009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1963012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1963015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1963018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963044 */     // MIs[0] policy
     /* 1963044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1963057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963078 */     // GIR_Coverage, 60969,
     /* 1963078 */     GIR_EraseRootFromParent_Done,
     /* 1963079 */   // Label 26310: @1963079
     /* 1963079 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1963165), // Rule ID 60972 //
     /* 1963084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1963101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1963104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963130 */     // MIs[0] policy
     /* 1963130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1963143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963164 */     // GIR_Coverage, 60972,
     /* 1963164 */     GIR_EraseRootFromParent_Done,
     /* 1963165 */   // Label 26311: @1963165
     /* 1963165 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1963251), // Rule ID 60973 //
     /* 1963170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1963187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1963190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963216 */     // MIs[0] policy
     /* 1963216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963226 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1963229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963250 */     // GIR_Coverage, 60973,
     /* 1963250 */     GIR_EraseRootFromParent_Done,
     /* 1963251 */   // Label 26312: @1963251
     /* 1963251 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1963337), // Rule ID 60976 //
     /* 1963256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1963273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1963276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963302 */     // MIs[0] policy
     /* 1963302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1963315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963336 */     // GIR_Coverage, 60976,
     /* 1963336 */     GIR_EraseRootFromParent_Done,
     /* 1963337 */   // Label 26313: @1963337
     /* 1963337 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1963423), // Rule ID 60977 //
     /* 1963342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1963359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1963362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963388 */     // MIs[0] policy
     /* 1963388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1963401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963422 */     // GIR_Coverage, 60977,
     /* 1963422 */     GIR_EraseRootFromParent_Done,
     /* 1963423 */   // Label 26314: @1963423
     /* 1963423 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1963509), // Rule ID 60980 //
     /* 1963428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1963445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1963448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963474 */     // MIs[0] policy
     /* 1963474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1963487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963508 */     // GIR_Coverage, 60980,
     /* 1963508 */     GIR_EraseRootFromParent_Done,
     /* 1963509 */   // Label 26315: @1963509
     /* 1963509 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1963595), // Rule ID 60981 //
     /* 1963514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1963531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1963534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963560 */     // MIs[0] policy
     /* 1963560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963570 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1963573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963594 */     // GIR_Coverage, 60981,
     /* 1963594 */     GIR_EraseRootFromParent_Done,
     /* 1963595 */   // Label 26316: @1963595
     /* 1963595 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1963681), // Rule ID 60984 //
     /* 1963600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1963617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1963620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963646 */     // MIs[0] policy
     /* 1963646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1963659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963680 */     // GIR_Coverage, 60984,
     /* 1963680 */     GIR_EraseRootFromParent_Done,
     /* 1963681 */   // Label 26317: @1963681
     /* 1963681 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1963767), // Rule ID 60985 //
     /* 1963686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1963703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1963706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963732 */     // MIs[0] policy
     /* 1963732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963742 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1963745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1963763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963766 */     // GIR_Coverage, 60985,
     /* 1963766 */     GIR_EraseRootFromParent_Done,
     /* 1963767 */   // Label 26318: @1963767
     /* 1963767 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1963853), // Rule ID 60988 //
     /* 1963772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1963789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963818 */     // MIs[0] policy
     /* 1963818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1963831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963852 */     // GIR_Coverage, 60988,
     /* 1963852 */     GIR_EraseRootFromParent_Done,
     /* 1963853 */   // Label 26319: @1963853
     /* 1963853 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1963939), // Rule ID 60989 //
     /* 1963858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1963869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1963872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1963875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963904 */     // MIs[0] policy
     /* 1963904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1963917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963938 */     // GIR_Coverage, 60989,
     /* 1963938 */     GIR_EraseRootFromParent_Done,
     /* 1963939 */   // Label 26320: @1963939
     /* 1963939 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1964025), // Rule ID 60992 //
     /* 1963944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1963961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963990 */     // MIs[0] policy
     /* 1963990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1964003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964024 */     // GIR_Coverage, 60992,
     /* 1964024 */     GIR_EraseRootFromParent_Done,
     /* 1964025 */   // Label 26321: @1964025
     /* 1964025 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1964111), // Rule ID 60993 //
     /* 1964030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1964041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1964044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1964047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964076 */     // MIs[0] policy
     /* 1964076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1964089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964110 */     // GIR_Coverage, 60993,
     /* 1964110 */     GIR_EraseRootFromParent_Done,
     /* 1964111 */   // Label 26322: @1964111
     /* 1964111 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1964197), // Rule ID 60996 //
     /* 1964116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1964133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964162 */     // MIs[0] policy
     /* 1964162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1964175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964196 */     // GIR_Coverage, 60996,
     /* 1964196 */     GIR_EraseRootFromParent_Done,
     /* 1964197 */   // Label 26323: @1964197
     /* 1964197 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1964283), // Rule ID 60997 //
     /* 1964202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1964219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964248 */     // MIs[0] policy
     /* 1964248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1964261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964282 */     // GIR_Coverage, 60997,
     /* 1964282 */     GIR_EraseRootFromParent_Done,
     /* 1964283 */   // Label 26324: @1964283
     /* 1964283 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1964369), // Rule ID 61000 //
     /* 1964288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1964305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964334 */     // MIs[0] policy
     /* 1964334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1964347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964368 */     // GIR_Coverage, 61000,
     /* 1964368 */     GIR_EraseRootFromParent_Done,
     /* 1964369 */   // Label 26325: @1964369
     /* 1964369 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1964455), // Rule ID 61001 //
     /* 1964374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1964391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964420 */     // MIs[0] policy
     /* 1964420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1964433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964454 */     // GIR_Coverage, 61001,
     /* 1964454 */     GIR_EraseRootFromParent_Done,
     /* 1964455 */   // Label 26326: @1964455
     /* 1964455 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1964541), // Rule ID 61004 //
     /* 1964460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964506 */     // MIs[0] policy
     /* 1964506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1964519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964540 */     // GIR_Coverage, 61004,
     /* 1964540 */     GIR_EraseRootFromParent_Done,
     /* 1964541 */   // Label 26327: @1964541
     /* 1964541 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1964627), // Rule ID 61005 //
     /* 1964546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1964563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964592 */     // MIs[0] policy
     /* 1964592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1964605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1964623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964626 */     // GIR_Coverage, 61005,
     /* 1964626 */     GIR_EraseRootFromParent_Done,
     /* 1964627 */   // Label 26328: @1964627
     /* 1964627 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1964713), // Rule ID 61008 //
     /* 1964632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1964643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1964646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1964649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1964652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964678 */     // MIs[0] policy
     /* 1964678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1964691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964712 */     // GIR_Coverage, 61008,
     /* 1964712 */     GIR_EraseRootFromParent_Done,
     /* 1964713 */   // Label 26329: @1964713
     /* 1964713 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1964799), // Rule ID 61009 //
     /* 1964718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1964729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1964732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1964735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1964738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964764 */     // MIs[0] policy
     /* 1964764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1964777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964798 */     // GIR_Coverage, 61009,
     /* 1964798 */     GIR_EraseRootFromParent_Done,
     /* 1964799 */   // Label 26330: @1964799
     /* 1964799 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1964885), // Rule ID 61012 //
     /* 1964804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1964821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1964824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964850 */     // MIs[0] policy
     /* 1964850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1964863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964884 */     // GIR_Coverage, 61012,
     /* 1964884 */     GIR_EraseRootFromParent_Done,
     /* 1964885 */   // Label 26331: @1964885
     /* 1964885 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1964971), // Rule ID 61013 //
     /* 1964890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1964893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1964907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1964910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964936 */     // MIs[0] policy
     /* 1964936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1964949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964970 */     // GIR_Coverage, 61013,
     /* 1964970 */     GIR_EraseRootFromParent_Done,
     /* 1964971 */   // Label 26332: @1964971
     /* 1964971 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1965057), // Rule ID 61016 //
     /* 1964976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1964996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965022 */     // MIs[0] policy
     /* 1965022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965056 */     // GIR_Coverage, 61016,
     /* 1965056 */     GIR_EraseRootFromParent_Done,
     /* 1965057 */   // Label 26333: @1965057
     /* 1965057 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1965143), // Rule ID 61017 //
     /* 1965062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1965079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1965082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965108 */     // MIs[0] policy
     /* 1965108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965118 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965142 */     // GIR_Coverage, 61017,
     /* 1965142 */     GIR_EraseRootFromParent_Done,
     /* 1965143 */   // Label 26334: @1965143
     /* 1965143 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1965229), // Rule ID 61020 //
     /* 1965148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1965165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1965168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965194 */     // MIs[0] policy
     /* 1965194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965228 */     // GIR_Coverage, 61020,
     /* 1965228 */     GIR_EraseRootFromParent_Done,
     /* 1965229 */   // Label 26335: @1965229
     /* 1965229 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1965315), // Rule ID 61021 //
     /* 1965234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1965251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1965254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965280 */     // MIs[0] policy
     /* 1965280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1965311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965314 */     // GIR_Coverage, 61021,
     /* 1965314 */     GIR_EraseRootFromParent_Done,
     /* 1965315 */   // Label 26336: @1965315
     /* 1965315 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1965401), // Rule ID 61024 //
     /* 1965320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965366 */     // MIs[0] policy
     /* 1965366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1965379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965400 */     // GIR_Coverage, 61024,
     /* 1965400 */     GIR_EraseRootFromParent_Done,
     /* 1965401 */   // Label 26337: @1965401
     /* 1965401 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1965487), // Rule ID 61025 //
     /* 1965406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965452 */     // MIs[0] policy
     /* 1965452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965462 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1965465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965486 */     // GIR_Coverage, 61025,
     /* 1965486 */     GIR_EraseRootFromParent_Done,
     /* 1965487 */   // Label 26338: @1965487
     /* 1965487 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1965573), // Rule ID 61032 //
     /* 1965492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965538 */     // MIs[0] policy
     /* 1965538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1965551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965572 */     // GIR_Coverage, 61032,
     /* 1965572 */     GIR_EraseRootFromParent_Done,
     /* 1965573 */   // Label 26339: @1965573
     /* 1965573 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1965659), // Rule ID 61033 //
     /* 1965578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965624 */     // MIs[0] policy
     /* 1965624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965634 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1965637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965658 */     // GIR_Coverage, 61033,
     /* 1965658 */     GIR_EraseRootFromParent_Done,
     /* 1965659 */   // Label 26340: @1965659
     /* 1965659 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1965745), // Rule ID 61040 //
     /* 1965664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965710 */     // MIs[0] policy
     /* 1965710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1965723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965744 */     // GIR_Coverage, 61040,
     /* 1965744 */     GIR_EraseRootFromParent_Done,
     /* 1965745 */   // Label 26341: @1965745
     /* 1965745 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1965831), // Rule ID 61041 //
     /* 1965750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965796 */     // MIs[0] policy
     /* 1965796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1965809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965830 */     // GIR_Coverage, 61041,
     /* 1965830 */     GIR_EraseRootFromParent_Done,
     /* 1965831 */   // Label 26342: @1965831
     /* 1965831 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1965917), // Rule ID 61048 //
     /* 1965836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965882 */     // MIs[0] policy
     /* 1965882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1965895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965916 */     // GIR_Coverage, 61048,
     /* 1965916 */     GIR_EraseRootFromParent_Done,
     /* 1965917 */   // Label 26343: @1965917
     /* 1965917 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1966003), // Rule ID 61049 //
     /* 1965922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965968 */     // MIs[0] policy
     /* 1965968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1965981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966002 */     // GIR_Coverage, 61049,
     /* 1966002 */     GIR_EraseRootFromParent_Done,
     /* 1966003 */   // Label 26344: @1966003
     /* 1966003 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1966089), // Rule ID 61056 //
     /* 1966008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966054 */     // MIs[0] policy
     /* 1966054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1966067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966088 */     // GIR_Coverage, 61056,
     /* 1966088 */     GIR_EraseRootFromParent_Done,
     /* 1966089 */   // Label 26345: @1966089
     /* 1966089 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1966175), // Rule ID 61057 //
     /* 1966094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1966105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1966108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1966111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966140 */     // MIs[0] policy
     /* 1966140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1966153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966174 */     // GIR_Coverage, 61057,
     /* 1966174 */     GIR_EraseRootFromParent_Done,
     /* 1966175 */   // Label 26346: @1966175
     /* 1966175 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1966261), // Rule ID 61064 //
     /* 1966180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966226 */     // MIs[0] policy
     /* 1966226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966236 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1966239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966260 */     // GIR_Coverage, 61064,
     /* 1966260 */     GIR_EraseRootFromParent_Done,
     /* 1966261 */   // Label 26347: @1966261
     /* 1966261 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1966347), // Rule ID 61065 //
     /* 1966266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1966277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1966280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1966283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1966289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966312 */     // MIs[0] policy
     /* 1966312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1966325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966346 */     // GIR_Coverage, 61065,
     /* 1966346 */     GIR_EraseRootFromParent_Done,
     /* 1966347 */   // Label 26348: @1966347
     /* 1966347 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1966433), // Rule ID 61072 //
     /* 1966352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966398 */     // MIs[0] policy
     /* 1966398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1966411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966432 */     // GIR_Coverage, 61072,
     /* 1966432 */     GIR_EraseRootFromParent_Done,
     /* 1966433 */   // Label 26349: @1966433
     /* 1966433 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1966519), // Rule ID 61073 //
     /* 1966438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966484 */     // MIs[0] policy
     /* 1966484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1966497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966518 */     // GIR_Coverage, 61073,
     /* 1966518 */     GIR_EraseRootFromParent_Done,
     /* 1966519 */   // Label 26350: @1966519
     /* 1966519 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1966605), // Rule ID 61080 //
     /* 1966524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966570 */     // MIs[0] policy
     /* 1966570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1966583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966604 */     // GIR_Coverage, 61080,
     /* 1966604 */     GIR_EraseRootFromParent_Done,
     /* 1966605 */   // Label 26351: @1966605
     /* 1966605 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1966691), // Rule ID 61081 //
     /* 1966610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966656 */     // MIs[0] policy
     /* 1966656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1966669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966690 */     // GIR_Coverage, 61081,
     /* 1966690 */     GIR_EraseRootFromParent_Done,
     /* 1966691 */   // Label 26352: @1966691
     /* 1966691 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1966777), // Rule ID 61088 //
     /* 1966696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966742 */     // MIs[0] policy
     /* 1966742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1966755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966776 */     // GIR_Coverage, 61088,
     /* 1966776 */     GIR_EraseRootFromParent_Done,
     /* 1966777 */   // Label 26353: @1966777
     /* 1966777 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1966863), // Rule ID 61089 //
     /* 1966782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966828 */     // MIs[0] policy
     /* 1966828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1966841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966862 */     // GIR_Coverage, 61089,
     /* 1966862 */     GIR_EraseRootFromParent_Done,
     /* 1966863 */   // Label 26354: @1966863
     /* 1966863 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1966949), // Rule ID 61096 //
     /* 1966868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966914 */     // MIs[0] policy
     /* 1966914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1966927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966948 */     // GIR_Coverage, 61096,
     /* 1966948 */     GIR_EraseRootFromParent_Done,
     /* 1966949 */   // Label 26355: @1966949
     /* 1966949 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1967035), // Rule ID 61097 //
     /* 1966954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967000 */     // MIs[0] policy
     /* 1967000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1967013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967034 */     // GIR_Coverage, 61097,
     /* 1967034 */     GIR_EraseRootFromParent_Done,
     /* 1967035 */   // Label 26356: @1967035
     /* 1967035 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1967121), // Rule ID 61104 //
     /* 1967040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967086 */     // MIs[0] policy
     /* 1967086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1967099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967120 */     // GIR_Coverage, 61104,
     /* 1967120 */     GIR_EraseRootFromParent_Done,
     /* 1967121 */   // Label 26357: @1967121
     /* 1967121 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1967207), // Rule ID 61105 //
     /* 1967126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1967137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1967140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1967143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1967149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967172 */     // MIs[0] policy
     /* 1967172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967182 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1967185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967206 */     // GIR_Coverage, 61105,
     /* 1967206 */     GIR_EraseRootFromParent_Done,
     /* 1967207 */   // Label 26358: @1967207
     /* 1967207 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1967293), // Rule ID 61112 //
     /* 1967212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967258 */     // MIs[0] policy
     /* 1967258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1967271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967292 */     // GIR_Coverage, 61112,
     /* 1967292 */     GIR_EraseRootFromParent_Done,
     /* 1967293 */   // Label 26359: @1967293
     /* 1967293 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1967379), // Rule ID 61113 //
     /* 1967298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967344 */     // MIs[0] policy
     /* 1967344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967354 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1967357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967378 */     // GIR_Coverage, 61113,
     /* 1967378 */     GIR_EraseRootFromParent_Done,
     /* 1967379 */   // Label 26360: @1967379
     /* 1967379 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1967465), // Rule ID 61120 //
     /* 1967384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967430 */     // MIs[0] policy
     /* 1967430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1967443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967464 */     // GIR_Coverage, 61120,
     /* 1967464 */     GIR_EraseRootFromParent_Done,
     /* 1967465 */   // Label 26361: @1967465
     /* 1967465 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1967551), // Rule ID 61121 //
     /* 1967470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967516 */     // MIs[0] policy
     /* 1967516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967526 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1967529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967550 */     // GIR_Coverage, 61121,
     /* 1967550 */     GIR_EraseRootFromParent_Done,
     /* 1967551 */   // Label 26362: @1967551
     /* 1967551 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1967637), // Rule ID 61128 //
     /* 1967556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967602 */     // MIs[0] policy
     /* 1967602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967612 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1967615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967636 */     // GIR_Coverage, 61128,
     /* 1967636 */     GIR_EraseRootFromParent_Done,
     /* 1967637 */   // Label 26363: @1967637
     /* 1967637 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1967723), // Rule ID 61129 //
     /* 1967642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967688 */     // MIs[0] policy
     /* 1967688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1967701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967722 */     // GIR_Coverage, 61129,
     /* 1967722 */     GIR_EraseRootFromParent_Done,
     /* 1967723 */   // Label 26364: @1967723
     /* 1967723 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1967809), // Rule ID 61136 //
     /* 1967728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967774 */     // MIs[0] policy
     /* 1967774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1967787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967808 */     // GIR_Coverage, 61136,
     /* 1967808 */     GIR_EraseRootFromParent_Done,
     /* 1967809 */   // Label 26365: @1967809
     /* 1967809 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1967895), // Rule ID 61137 //
     /* 1967814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967860 */     // MIs[0] policy
     /* 1967860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967870 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1967873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967894 */     // GIR_Coverage, 61137,
     /* 1967894 */     GIR_EraseRootFromParent_Done,
     /* 1967895 */   // Label 26366: @1967895
     /* 1967895 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1967981), // Rule ID 61144 //
     /* 1967900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1967903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1967908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1967920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967946 */     // MIs[0] policy
     /* 1967946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1967959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1967977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967980 */     // GIR_Coverage, 61144,
     /* 1967980 */     GIR_EraseRootFromParent_Done,
     /* 1967981 */   // Label 26367: @1967981
     /* 1967981 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1968067), // Rule ID 61145 //
     /* 1967986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1967989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1967994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1968006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968032 */     // MIs[0] policy
     /* 1968032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1968045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968066 */     // GIR_Coverage, 61145,
     /* 1968066 */     GIR_EraseRootFromParent_Done,
     /* 1968067 */   // Label 26368: @1968067
     /* 1968067 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1968153), // Rule ID 61148 //
     /* 1968072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1968092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968118 */     // MIs[0] policy
     /* 1968118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1968131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968152 */     // GIR_Coverage, 61148,
     /* 1968152 */     GIR_EraseRootFromParent_Done,
     /* 1968153 */   // Label 26369: @1968153
     /* 1968153 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1968239), // Rule ID 61149 //
     /* 1968158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1968161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1968178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968204 */     // MIs[0] policy
     /* 1968204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1968217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968238 */     // GIR_Coverage, 61149,
     /* 1968238 */     GIR_EraseRootFromParent_Done,
     /* 1968239 */   // Label 26370: @1968239
     /* 1968239 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1968325), // Rule ID 61152 //
     /* 1968244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1968264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968290 */     // MIs[0] policy
     /* 1968290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1968303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968324 */     // GIR_Coverage, 61152,
     /* 1968324 */     GIR_EraseRootFromParent_Done,
     /* 1968325 */   // Label 26371: @1968325
     /* 1968325 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1968411), // Rule ID 61153 //
     /* 1968330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1968333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1968350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968376 */     // MIs[0] policy
     /* 1968376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1968389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968410 */     // GIR_Coverage, 61153,
     /* 1968410 */     GIR_EraseRootFromParent_Done,
     /* 1968411 */   // Label 26372: @1968411
     /* 1968411 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1968497), // Rule ID 61156 //
     /* 1968416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1968436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968462 */     // MIs[0] policy
     /* 1968462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1968475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968496 */     // GIR_Coverage, 61156,
     /* 1968496 */     GIR_EraseRootFromParent_Done,
     /* 1968497 */   // Label 26373: @1968497
     /* 1968497 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1968583), // Rule ID 61157 //
     /* 1968502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1968505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1968513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1968516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1968519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1968522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968548 */     // MIs[0] policy
     /* 1968548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968558 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1968561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968582 */     // GIR_Coverage, 61157,
     /* 1968582 */     GIR_EraseRootFromParent_Done,
     /* 1968583 */   // Label 26374: @1968583
     /* 1968583 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1968669), // Rule ID 61160 //
     /* 1968588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1968599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968634 */     // MIs[0] policy
     /* 1968634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1968647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968668 */     // GIR_Coverage, 61160,
     /* 1968668 */     GIR_EraseRootFromParent_Done,
     /* 1968669 */   // Label 26375: @1968669
     /* 1968669 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1968755), // Rule ID 61161 //
     /* 1968674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1968677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1968685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1968688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1968691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968720 */     // MIs[0] policy
     /* 1968720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1968733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968754 */     // GIR_Coverage, 61161,
     /* 1968754 */     GIR_EraseRootFromParent_Done,
     /* 1968755 */   // Label 26376: @1968755
     /* 1968755 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1968841), // Rule ID 61164 //
     /* 1968760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968806 */     // MIs[0] policy
     /* 1968806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1968819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968840 */     // GIR_Coverage, 61164,
     /* 1968840 */     GIR_EraseRootFromParent_Done,
     /* 1968841 */   // Label 26377: @1968841
     /* 1968841 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1968927), // Rule ID 61165 //
     /* 1968846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1968849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1968857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1968860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1968863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968892 */     // MIs[0] policy
     /* 1968892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1968905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968926 */     // GIR_Coverage, 61165,
     /* 1968926 */     GIR_EraseRootFromParent_Done,
     /* 1968927 */   // Label 26378: @1968927
     /* 1968927 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1969013), // Rule ID 61168 //
     /* 1968932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1968935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1968940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1968943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1968946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1968949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968978 */     // MIs[0] policy
     /* 1968978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968988 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1968991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969012 */     // GIR_Coverage, 61168,
     /* 1969012 */     GIR_EraseRootFromParent_Done,
     /* 1969013 */   // Label 26379: @1969013
     /* 1969013 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1969099), // Rule ID 61169 //
     /* 1969018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1969026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969064 */     // MIs[0] policy
     /* 1969064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1969077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969098 */     // GIR_Coverage, 61169,
     /* 1969098 */     GIR_EraseRootFromParent_Done,
     /* 1969099 */   // Label 26380: @1969099
     /* 1969099 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1969185), // Rule ID 61172 //
     /* 1969104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1969112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969150 */     // MIs[0] policy
     /* 1969150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969160 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1969163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969184 */     // GIR_Coverage, 61172,
     /* 1969184 */     GIR_EraseRootFromParent_Done,
     /* 1969185 */   // Label 26381: @1969185
     /* 1969185 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1969271), // Rule ID 61173 //
     /* 1969190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1969198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969236 */     // MIs[0] policy
     /* 1969236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1969249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969270 */     // GIR_Coverage, 61173,
     /* 1969270 */     GIR_EraseRootFromParent_Done,
     /* 1969271 */   // Label 26382: @1969271
     /* 1969271 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1969357), // Rule ID 61176 //
     /* 1969276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1969293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1969296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969322 */     // MIs[0] policy
     /* 1969322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969332 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1969335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969356 */     // GIR_Coverage, 61176,
     /* 1969356 */     GIR_EraseRootFromParent_Done,
     /* 1969357 */   // Label 26383: @1969357
     /* 1969357 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1969443), // Rule ID 61177 //
     /* 1969362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1969379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1969382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969408 */     // MIs[0] policy
     /* 1969408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1969421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969442 */     // GIR_Coverage, 61177,
     /* 1969442 */     GIR_EraseRootFromParent_Done,
     /* 1969443 */   // Label 26384: @1969443
     /* 1969443 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1969529), // Rule ID 61180 //
     /* 1969448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1969465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1969468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969494 */     // MIs[0] policy
     /* 1969494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1969507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969528 */     // GIR_Coverage, 61180,
     /* 1969528 */     GIR_EraseRootFromParent_Done,
     /* 1969529 */   // Label 26385: @1969529
     /* 1969529 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1969615), // Rule ID 61181 //
     /* 1969534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1969551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1969554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969580 */     // MIs[0] policy
     /* 1969580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1969593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969614 */     // GIR_Coverage, 61181,
     /* 1969614 */     GIR_EraseRootFromParent_Done,
     /* 1969615 */   // Label 26386: @1969615
     /* 1969615 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1969701), // Rule ID 61184 //
     /* 1969620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1969640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969666 */     // MIs[0] policy
     /* 1969666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969676 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1969679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969700 */     // GIR_Coverage, 61184,
     /* 1969700 */     GIR_EraseRootFromParent_Done,
     /* 1969701 */   // Label 26387: @1969701
     /* 1969701 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1969787), // Rule ID 61185 //
     /* 1969706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1969726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969752 */     // MIs[0] policy
     /* 1969752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1969765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969786 */     // GIR_Coverage, 61185,
     /* 1969786 */     GIR_EraseRootFromParent_Done,
     /* 1969787 */   // Label 26388: @1969787
     /* 1969787 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1969873), // Rule ID 61188 //
     /* 1969792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1969812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969838 */     // MIs[0] policy
     /* 1969838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1969851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969872 */     // GIR_Coverage, 61188,
     /* 1969872 */     GIR_EraseRootFromParent_Done,
     /* 1969873 */   // Label 26389: @1969873
     /* 1969873 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1969959), // Rule ID 61189 //
     /* 1969878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1969881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1969898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969924 */     // MIs[0] policy
     /* 1969924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1969937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969958 */     // GIR_Coverage, 61189,
     /* 1969958 */     GIR_EraseRootFromParent_Done,
     /* 1969959 */   // Label 26390: @1969959
     /* 1969959 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1970045), // Rule ID 61192 //
     /* 1969964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1969967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1969972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1969981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970010 */     // MIs[0] policy
     /* 1970010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1970023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970044 */     // GIR_Coverage, 61192,
     /* 1970044 */     GIR_EraseRootFromParent_Done,
     /* 1970045 */   // Label 26391: @1970045
     /* 1970045 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1970131), // Rule ID 61193 //
     /* 1970050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970096 */     // MIs[0] policy
     /* 1970096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1970109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970130 */     // GIR_Coverage, 61193,
     /* 1970130 */     GIR_EraseRootFromParent_Done,
     /* 1970131 */   // Label 26392: @1970131
     /* 1970131 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1970217), // Rule ID 61196 //
     /* 1970136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970182 */     // MIs[0] policy
     /* 1970182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1970195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970216 */     // GIR_Coverage, 61196,
     /* 1970216 */     GIR_EraseRootFromParent_Done,
     /* 1970217 */   // Label 26393: @1970217
     /* 1970217 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1970303), // Rule ID 61197 //
     /* 1970222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970268 */     // MIs[0] policy
     /* 1970268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1970281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970302 */     // GIR_Coverage, 61197,
     /* 1970302 */     GIR_EraseRootFromParent_Done,
     /* 1970303 */   // Label 26394: @1970303
     /* 1970303 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1970389), // Rule ID 61200 //
     /* 1970308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970354 */     // MIs[0] policy
     /* 1970354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1970367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970388 */     // GIR_Coverage, 61200,
     /* 1970388 */     GIR_EraseRootFromParent_Done,
     /* 1970389 */   // Label 26395: @1970389
     /* 1970389 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1970475), // Rule ID 61201 //
     /* 1970394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970440 */     // MIs[0] policy
     /* 1970440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1970453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970474 */     // GIR_Coverage, 61201,
     /* 1970474 */     GIR_EraseRootFromParent_Done,
     /* 1970475 */   // Label 26396: @1970475
     /* 1970475 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1970561), // Rule ID 61204 //
     /* 1970480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970526 */     // MIs[0] policy
     /* 1970526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1970539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970560 */     // GIR_Coverage, 61204,
     /* 1970560 */     GIR_EraseRootFromParent_Done,
     /* 1970561 */   // Label 26397: @1970561
     /* 1970561 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1970647), // Rule ID 61205 //
     /* 1970566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1970574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970612 */     // MIs[0] policy
     /* 1970612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1970625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970646 */     // GIR_Coverage, 61205,
     /* 1970646 */     GIR_EraseRootFromParent_Done,
     /* 1970647 */   // Label 26398: @1970647
     /* 1970647 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1970733), // Rule ID 61208 //
     /* 1970652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1970663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1970666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1970669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1970672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970698 */     // MIs[0] policy
     /* 1970698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1970711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970732 */     // GIR_Coverage, 61208,
     /* 1970732 */     GIR_EraseRootFromParent_Done,
     /* 1970733 */   // Label 26399: @1970733
     /* 1970733 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1970819), // Rule ID 61209 //
     /* 1970738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1970749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1970752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1970755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1970758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970784 */     // MIs[0] policy
     /* 1970784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970794 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1970797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970818 */     // GIR_Coverage, 61209,
     /* 1970818 */     GIR_EraseRootFromParent_Done,
     /* 1970819 */   // Label 26400: @1970819
     /* 1970819 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1970905), // Rule ID 61212 //
     /* 1970824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1970835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1970838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1970841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1970844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970870 */     // MIs[0] policy
     /* 1970870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1970883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970904 */     // GIR_Coverage, 61212,
     /* 1970904 */     GIR_EraseRootFromParent_Done,
     /* 1970905 */   // Label 26401: @1970905
     /* 1970905 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1970991), // Rule ID 61213 //
     /* 1970910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1970921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1970924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1970927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1970930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970956 */     // MIs[0] policy
     /* 1970956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1970969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970990 */     // GIR_Coverage, 61213,
     /* 1970990 */     GIR_EraseRootFromParent_Done,
     /* 1970991 */   // Label 26402: @1970991
     /* 1970991 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1971077), // Rule ID 61216 //
     /* 1970996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1971007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1971010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1971013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1971016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971042 */     // MIs[0] policy
     /* 1971042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971076 */     // GIR_Coverage, 61216,
     /* 1971076 */     GIR_EraseRootFromParent_Done,
     /* 1971077 */   // Label 26403: @1971077
     /* 1971077 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1971163), // Rule ID 61217 //
     /* 1971082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1971093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1971096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1971099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1971102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971128 */     // MIs[0] policy
     /* 1971128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971162 */     // GIR_Coverage, 61217,
     /* 1971162 */     GIR_EraseRootFromParent_Done,
     /* 1971163 */   // Label 26404: @1971163
     /* 1971163 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1971249), // Rule ID 61220 //
     /* 1971168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1971179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1971182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1971185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1971188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971214 */     // MIs[0] policy
     /* 1971214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1971227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971248 */     // GIR_Coverage, 61220,
     /* 1971248 */     GIR_EraseRootFromParent_Done,
     /* 1971249 */   // Label 26405: @1971249
     /* 1971249 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1971335), // Rule ID 61221 //
     /* 1971254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1971265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1971268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1971271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1971274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971300 */     // MIs[0] policy
     /* 1971300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1971313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971334 */     // GIR_Coverage, 61221,
     /* 1971334 */     GIR_EraseRootFromParent_Done,
     /* 1971335 */   // Label 26406: @1971335
     /* 1971335 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1971421), // Rule ID 61224 //
     /* 1971340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1971351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1971354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1971357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1971360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971386 */     // MIs[0] policy
     /* 1971386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971420 */     // GIR_Coverage, 61224,
     /* 1971420 */     GIR_EraseRootFromParent_Done,
     /* 1971421 */   // Label 26407: @1971421
     /* 1971421 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1971507), // Rule ID 61225 //
     /* 1971426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1971437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1971440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1971443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1971446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971472 */     // MIs[0] policy
     /* 1971472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971506 */     // GIR_Coverage, 61225,
     /* 1971506 */     GIR_EraseRootFromParent_Done,
     /* 1971507 */   // Label 26408: @1971507
     /* 1971507 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1971593), // Rule ID 61228 //
     /* 1971512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1971523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1971526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1971529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1971532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971558 */     // MIs[0] policy
     /* 1971558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971592 */     // GIR_Coverage, 61228,
     /* 1971592 */     GIR_EraseRootFromParent_Done,
     /* 1971593 */   // Label 26409: @1971593
     /* 1971593 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1971679), // Rule ID 61229 //
     /* 1971598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1971609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1971612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1971615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1971618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971644 */     // MIs[0] policy
     /* 1971644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1971657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971678 */     // GIR_Coverage, 61229,
     /* 1971678 */     GIR_EraseRootFromParent_Done,
     /* 1971679 */   // Label 26410: @1971679
     /* 1971679 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1971765), // Rule ID 61232 //
     /* 1971684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1971695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1971698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1971701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1971704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971730 */     // MIs[0] policy
     /* 1971730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1971743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971764 */     // GIR_Coverage, 61232,
     /* 1971764 */     GIR_EraseRootFromParent_Done,
     /* 1971765 */   // Label 26411: @1971765
     /* 1971765 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1971851), // Rule ID 61233 //
     /* 1971770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1971781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1971784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1971787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1971790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971816 */     // MIs[0] policy
     /* 1971816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1971829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971850 */     // GIR_Coverage, 61233,
     /* 1971850 */     GIR_EraseRootFromParent_Done,
     /* 1971851 */   // Label 26412: @1971851
     /* 1971851 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1971937), // Rule ID 61236 //
     /* 1971856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1971873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1971876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971902 */     // MIs[0] policy
     /* 1971902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1971915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971936 */     // GIR_Coverage, 61236,
     /* 1971936 */     GIR_EraseRootFromParent_Done,
     /* 1971937 */   // Label 26413: @1971937
     /* 1971937 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1972023), // Rule ID 61237 //
     /* 1971942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1971959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1971962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971988 */     // MIs[0] policy
     /* 1971988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1972001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972022 */     // GIR_Coverage, 61237,
     /* 1972022 */     GIR_EraseRootFromParent_Done,
     /* 1972023 */   // Label 26414: @1972023
     /* 1972023 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1972109), // Rule ID 61240 //
     /* 1972028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1972039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1972042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1972045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1972048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972074 */     // MIs[0] policy
     /* 1972074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1972087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972108 */     // GIR_Coverage, 61240,
     /* 1972108 */     GIR_EraseRootFromParent_Done,
     /* 1972109 */   // Label 26415: @1972109
     /* 1972109 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1972195), // Rule ID 61241 //
     /* 1972114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1972125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1972128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1972131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1972134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972160 */     // MIs[0] policy
     /* 1972160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1972173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972194 */     // GIR_Coverage, 61241,
     /* 1972194 */     GIR_EraseRootFromParent_Done,
     /* 1972195 */   // Label 26416: @1972195
     /* 1972195 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1972281), // Rule ID 61244 //
     /* 1972200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1972220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972246 */     // MIs[0] policy
     /* 1972246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1972259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972280 */     // GIR_Coverage, 61244,
     /* 1972280 */     GIR_EraseRootFromParent_Done,
     /* 1972281 */   // Label 26417: @1972281
     /* 1972281 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1972367), // Rule ID 61245 //
     /* 1972286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1972306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972332 */     // MIs[0] policy
     /* 1972332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1972345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972366 */     // GIR_Coverage, 61245,
     /* 1972366 */     GIR_EraseRootFromParent_Done,
     /* 1972367 */   // Label 26418: @1972367
     /* 1972367 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1972453), // Rule ID 61248 //
     /* 1972372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1972383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1972386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1972389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1972392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972418 */     // MIs[0] policy
     /* 1972418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1972431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972452 */     // GIR_Coverage, 61248,
     /* 1972452 */     GIR_EraseRootFromParent_Done,
     /* 1972453 */   // Label 26419: @1972453
     /* 1972453 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1972539), // Rule ID 61249 //
     /* 1972458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1972469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1972472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1972475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1972478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972504 */     // MIs[0] policy
     /* 1972504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1972517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972538 */     // GIR_Coverage, 61249,
     /* 1972538 */     GIR_EraseRootFromParent_Done,
     /* 1972539 */   // Label 26420: @1972539
     /* 1972539 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1972625), // Rule ID 61252 //
     /* 1972544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1972555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1972558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1972561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1972564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972590 */     // MIs[0] policy
     /* 1972590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1972603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972624 */     // GIR_Coverage, 61252,
     /* 1972624 */     GIR_EraseRootFromParent_Done,
     /* 1972625 */   // Label 26421: @1972625
     /* 1972625 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1972711), // Rule ID 61253 //
     /* 1972630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1972641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1972644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1972647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1972650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972676 */     // MIs[0] policy
     /* 1972676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972686 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1972689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972710 */     // GIR_Coverage, 61253,
     /* 1972710 */     GIR_EraseRootFromParent_Done,
     /* 1972711 */   // Label 26422: @1972711
     /* 1972711 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1972797), // Rule ID 61256 //
     /* 1972716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1972727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1972730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1972733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1972736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1972739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972762 */     // MIs[0] policy
     /* 1972762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1972775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972796 */     // GIR_Coverage, 61256,
     /* 1972796 */     GIR_EraseRootFromParent_Done,
     /* 1972797 */   // Label 26423: @1972797
     /* 1972797 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1972883), // Rule ID 61257 //
     /* 1972802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1972813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1972816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1972819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1972822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1972825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972848 */     // MIs[0] policy
     /* 1972848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1972861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972882 */     // GIR_Coverage, 61257,
     /* 1972882 */     GIR_EraseRootFromParent_Done,
     /* 1972883 */   // Label 26424: @1972883
     /* 1972883 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1972969), // Rule ID 61260 //
     /* 1972888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1972899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1972902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1972905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1972908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972934 */     // MIs[0] policy
     /* 1972934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1972947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972968 */     // GIR_Coverage, 61260,
     /* 1972968 */     GIR_EraseRootFromParent_Done,
     /* 1972969 */   // Label 26425: @1972969
     /* 1972969 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1973055), // Rule ID 61261 //
     /* 1972974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1972985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1972988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1972991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1972994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973020 */     // MIs[0] policy
     /* 1973020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1973033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973054 */     // GIR_Coverage, 61261,
     /* 1973054 */     GIR_EraseRootFromParent_Done,
     /* 1973055 */   // Label 26426: @1973055
     /* 1973055 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1973141), // Rule ID 61264 //
     /* 1973060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1973071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1973074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1973077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1973080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973106 */     // MIs[0] policy
     /* 1973106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1973119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973140 */     // GIR_Coverage, 61264,
     /* 1973140 */     GIR_EraseRootFromParent_Done,
     /* 1973141 */   // Label 26427: @1973141
     /* 1973141 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1973227), // Rule ID 61265 //
     /* 1973146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1973157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1973160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1973163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1973166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973192 */     // MIs[0] policy
     /* 1973192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1973205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973226 */     // GIR_Coverage, 61265,
     /* 1973226 */     GIR_EraseRootFromParent_Done,
     /* 1973227 */   // Label 26428: @1973227
     /* 1973227 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1973313), // Rule ID 61268 //
     /* 1973232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1973243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1973246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1973249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1973252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1973255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973278 */     // MIs[0] policy
     /* 1973278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973288 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1973291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973312 */     // GIR_Coverage, 61268,
     /* 1973312 */     GIR_EraseRootFromParent_Done,
     /* 1973313 */   // Label 26429: @1973313
     /* 1973313 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1973399), // Rule ID 61269 //
     /* 1973318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1973329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1973332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1973335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1973338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1973341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973364 */     // MIs[0] policy
     /* 1973364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973374 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1973377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973398 */     // GIR_Coverage, 61269,
     /* 1973398 */     GIR_EraseRootFromParent_Done,
     /* 1973399 */   // Label 26430: @1973399
     /* 1973399 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1973485), // Rule ID 61272 //
     /* 1973404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1973415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1973418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1973421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1973424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973450 */     // MIs[0] policy
     /* 1973450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1973463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973484 */     // GIR_Coverage, 61272,
     /* 1973484 */     GIR_EraseRootFromParent_Done,
     /* 1973485 */   // Label 26431: @1973485
     /* 1973485 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1973571), // Rule ID 61273 //
     /* 1973490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1973501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1973504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1973507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1973510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973536 */     // MIs[0] policy
     /* 1973536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1973549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973570 */     // GIR_Coverage, 61273,
     /* 1973570 */     GIR_EraseRootFromParent_Done,
     /* 1973571 */   // Label 26432: @1973571
     /* 1973571 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1973657), // Rule ID 61276 //
     /* 1973576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1973587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1973590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1973596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973622 */     // MIs[0] policy
     /* 1973622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1973635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973656 */     // GIR_Coverage, 61276,
     /* 1973656 */     GIR_EraseRootFromParent_Done,
     /* 1973657 */   // Label 26433: @1973657
     /* 1973657 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1973743), // Rule ID 61277 //
     /* 1973662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1973673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1973676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1973682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973708 */     // MIs[0] policy
     /* 1973708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1973721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973742 */     // GIR_Coverage, 61277,
     /* 1973742 */     GIR_EraseRootFromParent_Done,
     /* 1973743 */   // Label 26434: @1973743
     /* 1973743 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1973829), // Rule ID 61280 //
     /* 1973748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1973765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1973768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973794 */     // MIs[0] policy
     /* 1973794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1973807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973828 */     // GIR_Coverage, 61280,
     /* 1973828 */     GIR_EraseRootFromParent_Done,
     /* 1973829 */   // Label 26435: @1973829
     /* 1973829 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1973915), // Rule ID 61281 //
     /* 1973834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1973851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1973854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973880 */     // MIs[0] policy
     /* 1973880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1973893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973914 */     // GIR_Coverage, 61281,
     /* 1973914 */     GIR_EraseRootFromParent_Done,
     /* 1973915 */   // Label 26436: @1973915
     /* 1973915 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1974001), // Rule ID 61284 //
     /* 1973920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1973937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1973940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973966 */     // MIs[0] policy
     /* 1973966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1973979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974000 */     // GIR_Coverage, 61284,
     /* 1974000 */     GIR_EraseRootFromParent_Done,
     /* 1974001 */   // Label 26437: @1974001
     /* 1974001 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1974087), // Rule ID 61285 //
     /* 1974006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1974017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1974020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1974023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1974026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974052 */     // MIs[0] policy
     /* 1974052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1974065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974086 */     // GIR_Coverage, 61285,
     /* 1974086 */     GIR_EraseRootFromParent_Done,
     /* 1974087 */   // Label 26438: @1974087
     /* 1974087 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1974173), // Rule ID 61288 //
     /* 1974092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1974103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1974106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1974109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1974112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974138 */     // MIs[0] policy
     /* 1974138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974148 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974172 */     // GIR_Coverage, 61288,
     /* 1974172 */     GIR_EraseRootFromParent_Done,
     /* 1974173 */   // Label 26439: @1974173
     /* 1974173 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1974259), // Rule ID 61289 //
     /* 1974178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1974189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1974192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1974195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1974198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974224 */     // MIs[0] policy
     /* 1974224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974258 */     // GIR_Coverage, 61289,
     /* 1974258 */     GIR_EraseRootFromParent_Done,
     /* 1974259 */   // Label 26440: @1974259
     /* 1974259 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1974345), // Rule ID 61292 //
     /* 1974264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1974275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1974278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1974281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1974284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974310 */     // MIs[0] policy
     /* 1974310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1974323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974344 */     // GIR_Coverage, 61292,
     /* 1974344 */     GIR_EraseRootFromParent_Done,
     /* 1974345 */   // Label 26441: @1974345
     /* 1974345 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1974431), // Rule ID 61293 //
     /* 1974350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1974361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1974364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1974367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1974370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974396 */     // MIs[0] policy
     /* 1974396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1974409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974430 */     // GIR_Coverage, 61293,
     /* 1974430 */     GIR_EraseRootFromParent_Done,
     /* 1974431 */   // Label 26442: @1974431
     /* 1974431 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1974517), // Rule ID 61296 //
     /* 1974436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1974447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1974450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1974453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974482 */     // MIs[0] policy
     /* 1974482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1974495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974516 */     // GIR_Coverage, 61296,
     /* 1974516 */     GIR_EraseRootFromParent_Done,
     /* 1974517 */   // Label 26443: @1974517
     /* 1974517 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1974603), // Rule ID 61297 //
     /* 1974522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1974533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1974536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1974539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974568 */     // MIs[0] policy
     /* 1974568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974578 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1974581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974602 */     // GIR_Coverage, 61297,
     /* 1974602 */     GIR_EraseRootFromParent_Done,
     /* 1974603 */   // Label 26444: @1974603
     /* 1974603 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1974689), // Rule ID 61300 //
     /* 1974608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1974619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1974622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1974625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974654 */     // MIs[0] policy
     /* 1974654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1974667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974688 */     // GIR_Coverage, 61300,
     /* 1974688 */     GIR_EraseRootFromParent_Done,
     /* 1974689 */   // Label 26445: @1974689
     /* 1974689 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1974775), // Rule ID 61301 //
     /* 1974694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1974705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1974708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1974711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974740 */     // MIs[0] policy
     /* 1974740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1974753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974774 */     // GIR_Coverage, 61301,
     /* 1974774 */     GIR_EraseRootFromParent_Done,
     /* 1974775 */   // Label 26446: @1974775
     /* 1974775 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1974861), // Rule ID 61304 //
     /* 1974780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1974791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1974794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1974797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974826 */     // MIs[0] policy
     /* 1974826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1974839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974860 */     // GIR_Coverage, 61304,
     /* 1974860 */     GIR_EraseRootFromParent_Done,
     /* 1974861 */   // Label 26447: @1974861
     /* 1974861 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1974947), // Rule ID 61305 //
     /* 1974866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1974877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1974880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1974883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1974886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974912 */     // MIs[0] policy
     /* 1974912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974922 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1974925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974946 */     // GIR_Coverage, 61305,
     /* 1974946 */     GIR_EraseRootFromParent_Done,
     /* 1974947 */   // Label 26448: @1974947
     /* 1974947 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1975033), // Rule ID 61308 //
     /* 1974952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1974963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1974966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1974969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1974972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1974994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974998 */     // MIs[0] policy
     /* 1974998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1975011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975032 */     // GIR_Coverage, 61308,
     /* 1975032 */     GIR_EraseRootFromParent_Done,
     /* 1975033 */   // Label 26449: @1975033
     /* 1975033 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1975119), // Rule ID 61309 //
     /* 1975038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1975049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1975052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1975055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975084 */     // MIs[0] policy
     /* 1975084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1975097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975118 */     // GIR_Coverage, 61309,
     /* 1975118 */     GIR_EraseRootFromParent_Done,
     /* 1975119 */   // Label 26450: @1975119
     /* 1975119 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1975205), // Rule ID 61312 //
     /* 1975124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1975135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1975138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1975141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975170 */     // MIs[0] policy
     /* 1975170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1975183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975204 */     // GIR_Coverage, 61312,
     /* 1975204 */     GIR_EraseRootFromParent_Done,
     /* 1975205 */   // Label 26451: @1975205
     /* 1975205 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1975291), // Rule ID 61313 //
     /* 1975210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1975221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1975224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1975227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975256 */     // MIs[0] policy
     /* 1975256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1975269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975290 */     // GIR_Coverage, 61313,
     /* 1975290 */     GIR_EraseRootFromParent_Done,
     /* 1975291 */   // Label 26452: @1975291
     /* 1975291 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1975377), // Rule ID 61316 //
     /* 1975296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1975307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1975310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1975313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975342 */     // MIs[0] policy
     /* 1975342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1975355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975376 */     // GIR_Coverage, 61316,
     /* 1975376 */     GIR_EraseRootFromParent_Done,
     /* 1975377 */   // Label 26453: @1975377
     /* 1975377 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1975463), // Rule ID 61317 //
     /* 1975382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1975393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1975396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1975399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975428 */     // MIs[0] policy
     /* 1975428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1975441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975462 */     // GIR_Coverage, 61317,
     /* 1975462 */     GIR_EraseRootFromParent_Done,
     /* 1975463 */   // Label 26454: @1975463
     /* 1975463 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1975549), // Rule ID 61320 //
     /* 1975468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1975479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1975482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1975485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975514 */     // MIs[0] policy
     /* 1975514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975548 */     // GIR_Coverage, 61320,
     /* 1975548 */     GIR_EraseRootFromParent_Done,
     /* 1975549 */   // Label 26455: @1975549
     /* 1975549 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1975635), // Rule ID 61321 //
     /* 1975554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1975565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1975568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1975571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975600 */     // MIs[0] policy
     /* 1975600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975610 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975634 */     // GIR_Coverage, 61321,
     /* 1975634 */     GIR_EraseRootFromParent_Done,
     /* 1975635 */   // Label 26456: @1975635
     /* 1975635 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1975721), // Rule ID 61324 //
     /* 1975640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1975651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1975654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1975657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975686 */     // MIs[0] policy
     /* 1975686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975720 */     // GIR_Coverage, 61324,
     /* 1975720 */     GIR_EraseRootFromParent_Done,
     /* 1975721 */   // Label 26457: @1975721
     /* 1975721 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1975807), // Rule ID 61325 //
     /* 1975726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1975737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1975740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1975743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975772 */     // MIs[0] policy
     /* 1975772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975806 */     // GIR_Coverage, 61325,
     /* 1975806 */     GIR_EraseRootFromParent_Done,
     /* 1975807 */   // Label 26458: @1975807
     /* 1975807 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1975893), // Rule ID 61328 //
     /* 1975812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1975823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1975826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1975829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1975832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975858 */     // MIs[0] policy
     /* 1975858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975892 */     // GIR_Coverage, 61328,
     /* 1975892 */     GIR_EraseRootFromParent_Done,
     /* 1975893 */   // Label 26459: @1975893
     /* 1975893 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1975979), // Rule ID 61329 //
     /* 1975898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1975909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1975912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1975915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1975918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1975940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975944 */     // MIs[0] policy
     /* 1975944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1975957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975978 */     // GIR_Coverage, 61329,
     /* 1975978 */     GIR_EraseRootFromParent_Done,
     /* 1975979 */   // Label 26460: @1975979
     /* 1975979 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1976065), // Rule ID 61332 //
     /* 1975984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1976001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976030 */     // MIs[0] policy
     /* 1976030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1976043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976064 */     // GIR_Coverage, 61332,
     /* 1976064 */     GIR_EraseRootFromParent_Done,
     /* 1976065 */   // Label 26461: @1976065
     /* 1976065 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1976151), // Rule ID 61333 //
     /* 1976070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1976081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1976084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1976087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976116 */     // MIs[0] policy
     /* 1976116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1976129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976150 */     // GIR_Coverage, 61333,
     /* 1976150 */     GIR_EraseRootFromParent_Done,
     /* 1976151 */   // Label 26462: @1976151
     /* 1976151 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1976237), // Rule ID 61336 //
     /* 1976156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1976167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1976170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1976173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976202 */     // MIs[0] policy
     /* 1976202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1976215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976236 */     // GIR_Coverage, 61336,
     /* 1976236 */     GIR_EraseRootFromParent_Done,
     /* 1976237 */   // Label 26463: @1976237
     /* 1976237 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1976323), // Rule ID 61337 //
     /* 1976242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1976253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1976256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1976259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976288 */     // MIs[0] policy
     /* 1976288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1976301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976322 */     // GIR_Coverage, 61337,
     /* 1976322 */     GIR_EraseRootFromParent_Done,
     /* 1976323 */   // Label 26464: @1976323
     /* 1976323 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1976409), // Rule ID 61340 //
     /* 1976328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1976339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1976342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1976345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976374 */     // MIs[0] policy
     /* 1976374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1976387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976408 */     // GIR_Coverage, 61340,
     /* 1976408 */     GIR_EraseRootFromParent_Done,
     /* 1976409 */   // Label 26465: @1976409
     /* 1976409 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1976495), // Rule ID 61341 //
     /* 1976414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1976425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1976428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1976431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976460 */     // MIs[0] policy
     /* 1976460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976470 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1976473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976494 */     // GIR_Coverage, 61341,
     /* 1976494 */     GIR_EraseRootFromParent_Done,
     /* 1976495 */   // Label 26466: @1976495
     /* 1976495 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1976581), // Rule ID 61344 //
     /* 1976500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1976511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1976514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1976517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1976523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976546 */     // MIs[0] policy
     /* 1976546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1976559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976580 */     // GIR_Coverage, 61344,
     /* 1976580 */     GIR_EraseRootFromParent_Done,
     /* 1976581 */   // Label 26467: @1976581
     /* 1976581 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1976667), // Rule ID 61345 //
     /* 1976586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1976597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1976600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1976603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1976609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976632 */     // MIs[0] policy
     /* 1976632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1976645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976666 */     // GIR_Coverage, 61345,
     /* 1976666 */     GIR_EraseRootFromParent_Done,
     /* 1976667 */   // Label 26468: @1976667
     /* 1976667 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1976753), // Rule ID 61348 //
     /* 1976672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1976683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1976686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1976689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976718 */     // MIs[0] policy
     /* 1976718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1976731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976752 */     // GIR_Coverage, 61348,
     /* 1976752 */     GIR_EraseRootFromParent_Done,
     /* 1976753 */   // Label 26469: @1976753
     /* 1976753 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1976839), // Rule ID 61349 //
     /* 1976758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1976769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1976772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1976775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976804 */     // MIs[0] policy
     /* 1976804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1976817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976838 */     // GIR_Coverage, 61349,
     /* 1976838 */     GIR_EraseRootFromParent_Done,
     /* 1976839 */   // Label 26470: @1976839
     /* 1976839 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1976925), // Rule ID 61352 //
     /* 1976844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976890 */     // MIs[0] policy
     /* 1976890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1976903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976924 */     // GIR_Coverage, 61352,
     /* 1976924 */     GIR_EraseRootFromParent_Done,
     /* 1976925 */   // Label 26471: @1976925
     /* 1976925 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1977011), // Rule ID 61353 //
     /* 1976930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976976 */     // MIs[0] policy
     /* 1976976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1976989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977010 */     // GIR_Coverage, 61353,
     /* 1977010 */     GIR_EraseRootFromParent_Done,
     /* 1977011 */   // Label 26472: @1977011
     /* 1977011 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1977097), // Rule ID 61356 //
     /* 1977016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1977027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1977030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1977033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1977039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977062 */     // MIs[0] policy
     /* 1977062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1977075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977096 */     // GIR_Coverage, 61356,
     /* 1977096 */     GIR_EraseRootFromParent_Done,
     /* 1977097 */   // Label 26473: @1977097
     /* 1977097 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1977183), // Rule ID 61357 //
     /* 1977102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1977113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1977116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1977119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1977125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977148 */     // MIs[0] policy
     /* 1977148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1977161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977182 */     // GIR_Coverage, 61357,
     /* 1977182 */     GIR_EraseRootFromParent_Done,
     /* 1977183 */   // Label 26474: @1977183
     /* 1977183 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1977269), // Rule ID 61360 //
     /* 1977188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1977199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1977202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1977205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977234 */     // MIs[0] policy
     /* 1977234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1977247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977268 */     // GIR_Coverage, 61360,
     /* 1977268 */     GIR_EraseRootFromParent_Done,
     /* 1977269 */   // Label 26475: @1977269
     /* 1977269 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1977355), // Rule ID 61361 //
     /* 1977274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1977285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1977288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1977291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977320 */     // MIs[0] policy
     /* 1977320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1977333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977354 */     // GIR_Coverage, 61361,
     /* 1977354 */     GIR_EraseRootFromParent_Done,
     /* 1977355 */   // Label 26476: @1977355
     /* 1977355 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1977441), // Rule ID 61364 //
     /* 1977360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1977371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1977374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1977377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977406 */     // MIs[0] policy
     /* 1977406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1977419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977440 */     // GIR_Coverage, 61364,
     /* 1977440 */     GIR_EraseRootFromParent_Done,
     /* 1977441 */   // Label 26477: @1977441
     /* 1977441 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1977527), // Rule ID 61365 //
     /* 1977446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1977457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1977460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1977463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977492 */     // MIs[0] policy
     /* 1977492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1977505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977526 */     // GIR_Coverage, 61365,
     /* 1977526 */     GIR_EraseRootFromParent_Done,
     /* 1977527 */   // Label 26478: @1977527
     /* 1977527 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1977613), // Rule ID 61368 //
     /* 1977532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1977543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1977546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1977549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1977555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977578 */     // MIs[0] policy
     /* 1977578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1977591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977612 */     // GIR_Coverage, 61368,
     /* 1977612 */     GIR_EraseRootFromParent_Done,
     /* 1977613 */   // Label 26479: @1977613
     /* 1977613 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1977699), // Rule ID 61369 //
     /* 1977618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1977629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1977632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1977635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1977641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977664 */     // MIs[0] policy
     /* 1977664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1977677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977698 */     // GIR_Coverage, 61369,
     /* 1977698 */     GIR_EraseRootFromParent_Done,
     /* 1977699 */   // Label 26480: @1977699
     /* 1977699 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1977785), // Rule ID 61372 //
     /* 1977704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1977715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1977718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1977721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977750 */     // MIs[0] policy
     /* 1977750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1977763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977784 */     // GIR_Coverage, 61372,
     /* 1977784 */     GIR_EraseRootFromParent_Done,
     /* 1977785 */   // Label 26481: @1977785
     /* 1977785 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1977871), // Rule ID 61373 //
     /* 1977790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1977801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1977804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1977807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977836 */     // MIs[0] policy
     /* 1977836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1977849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977870 */     // GIR_Coverage, 61373,
     /* 1977870 */     GIR_EraseRootFromParent_Done,
     /* 1977871 */   // Label 26482: @1977871
     /* 1977871 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1977957), // Rule ID 61376 //
     /* 1977876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977922 */     // MIs[0] policy
     /* 1977922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1977935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977956 */     // GIR_Coverage, 61376,
     /* 1977956 */     GIR_EraseRootFromParent_Done,
     /* 1977957 */   // Label 26483: @1977957
     /* 1977957 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1978043), // Rule ID 61377 //
     /* 1977962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978008 */     // MIs[0] policy
     /* 1978008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1978021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978042 */     // GIR_Coverage, 61377,
     /* 1978042 */     GIR_EraseRootFromParent_Done,
     /* 1978043 */   // Label 26484: @1978043
     /* 1978043 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1978129), // Rule ID 61380 //
     /* 1978048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1978059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1978062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1978065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978094 */     // MIs[0] policy
     /* 1978094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978128 */     // GIR_Coverage, 61380,
     /* 1978128 */     GIR_EraseRootFromParent_Done,
     /* 1978129 */   // Label 26485: @1978129
     /* 1978129 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1978215), // Rule ID 61381 //
     /* 1978134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1978145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1978148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1978151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978180 */     // MIs[0] policy
     /* 1978180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978214 */     // GIR_Coverage, 61381,
     /* 1978214 */     GIR_EraseRootFromParent_Done,
     /* 1978215 */   // Label 26486: @1978215
     /* 1978215 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1978301), // Rule ID 61560 //
     /* 1978220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1978231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1978234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1978237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1978240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978266 */     // MIs[0] policy
     /* 1978266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978276 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1978279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978300 */     // GIR_Coverage, 61560,
     /* 1978300 */     GIR_EraseRootFromParent_Done,
     /* 1978301 */   // Label 26487: @1978301
     /* 1978301 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1978387), // Rule ID 61561 //
     /* 1978306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1978317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1978320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1978323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1978326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978352 */     // MIs[0] policy
     /* 1978352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1978365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978386 */     // GIR_Coverage, 61561,
     /* 1978386 */     GIR_EraseRootFromParent_Done,
     /* 1978387 */   // Label 26488: @1978387
     /* 1978387 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1978473), // Rule ID 61564 //
     /* 1978392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1978403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1978406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1978409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1978412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978438 */     // MIs[0] policy
     /* 1978438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978448 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1978451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978472 */     // GIR_Coverage, 61564,
     /* 1978472 */     GIR_EraseRootFromParent_Done,
     /* 1978473 */   // Label 26489: @1978473
     /* 1978473 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1978559), // Rule ID 61565 //
     /* 1978478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1978489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1978492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1978495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1978498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978524 */     // MIs[0] policy
     /* 1978524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978534 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1978537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978558 */     // GIR_Coverage, 61565,
     /* 1978558 */     GIR_EraseRootFromParent_Done,
     /* 1978559 */   // Label 26490: @1978559
     /* 1978559 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1978645), // Rule ID 61568 //
     /* 1978564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1978575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1978578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1978581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1978584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978610 */     // MIs[0] policy
     /* 1978610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1978623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978644 */     // GIR_Coverage, 61568,
     /* 1978644 */     GIR_EraseRootFromParent_Done,
     /* 1978645 */   // Label 26491: @1978645
     /* 1978645 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1978731), // Rule ID 61569 //
     /* 1978650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1978661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1978664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1978667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1978670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978696 */     // MIs[0] policy
     /* 1978696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1978709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978730 */     // GIR_Coverage, 61569,
     /* 1978730 */     GIR_EraseRootFromParent_Done,
     /* 1978731 */   // Label 26492: @1978731
     /* 1978731 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1978817), // Rule ID 61572 //
     /* 1978736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1978756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978782 */     // MIs[0] policy
     /* 1978782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1978795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978816 */     // GIR_Coverage, 61572,
     /* 1978816 */     GIR_EraseRootFromParent_Done,
     /* 1978817 */   // Label 26493: @1978817
     /* 1978817 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1978903), // Rule ID 61573 //
     /* 1978822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1978842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978868 */     // MIs[0] policy
     /* 1978868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978878 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1978881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978902 */     // GIR_Coverage, 61573,
     /* 1978902 */     GIR_EraseRootFromParent_Done,
     /* 1978903 */   // Label 26494: @1978903
     /* 1978903 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1978989), // Rule ID 61576 //
     /* 1978908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1978919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1978922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1978925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1978928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978954 */     // MIs[0] policy
     /* 1978954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1978967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978988 */     // GIR_Coverage, 61576,
     /* 1978988 */     GIR_EraseRootFromParent_Done,
     /* 1978989 */   // Label 26495: @1978989
     /* 1978989 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1979075), // Rule ID 61577 //
     /* 1978994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1979005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1979008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1979011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1979014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979040 */     // MIs[0] policy
     /* 1979040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979050 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1979053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979074 */     // GIR_Coverage, 61577,
     /* 1979074 */     GIR_EraseRootFromParent_Done,
     /* 1979075 */   // Label 26496: @1979075
     /* 1979075 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1979161), // Rule ID 61580 //
     /* 1979080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1979091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1979094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1979097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1979100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979126 */     // MIs[0] policy
     /* 1979126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1979139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979160 */     // GIR_Coverage, 61580,
     /* 1979160 */     GIR_EraseRootFromParent_Done,
     /* 1979161 */   // Label 26497: @1979161
     /* 1979161 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1979247), // Rule ID 61581 //
     /* 1979166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1979177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1979180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1979183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1979186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979212 */     // MIs[0] policy
     /* 1979212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1979225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979246 */     // GIR_Coverage, 61581,
     /* 1979246 */     GIR_EraseRootFromParent_Done,
     /* 1979247 */   // Label 26498: @1979247
     /* 1979247 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1979333), // Rule ID 61584 //
     /* 1979252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1979263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1979266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1979269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1979272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979298 */     // MIs[0] policy
     /* 1979298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979332 */     // GIR_Coverage, 61584,
     /* 1979332 */     GIR_EraseRootFromParent_Done,
     /* 1979333 */   // Label 26499: @1979333
     /* 1979333 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1979419), // Rule ID 61585 //
     /* 1979338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1979349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1979352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1979355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1979358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979384 */     // MIs[0] policy
     /* 1979384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979394 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979418 */     // GIR_Coverage, 61585,
     /* 1979418 */     GIR_EraseRootFromParent_Done,
     /* 1979419 */   // Label 26500: @1979419
     /* 1979419 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1979505), // Rule ID 61588 //
     /* 1979424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1979435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1979438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1979441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1979444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979470 */     // MIs[0] policy
     /* 1979470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979504 */     // GIR_Coverage, 61588,
     /* 1979504 */     GIR_EraseRootFromParent_Done,
     /* 1979505 */   // Label 26501: @1979505
     /* 1979505 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1979591), // Rule ID 61589 //
     /* 1979510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1979521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1979524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1979527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1979530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979556 */     // MIs[0] policy
     /* 1979556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979590 */     // GIR_Coverage, 61589,
     /* 1979590 */     GIR_EraseRootFromParent_Done,
     /* 1979591 */   // Label 26502: @1979591
     /* 1979591 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1979677), // Rule ID 61592 //
     /* 1979596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1979607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1979610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1979613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1979616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979642 */     // MIs[0] policy
     /* 1979642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979676 */     // GIR_Coverage, 61592,
     /* 1979676 */     GIR_EraseRootFromParent_Done,
     /* 1979677 */   // Label 26503: @1979677
     /* 1979677 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1979763), // Rule ID 61593 //
     /* 1979682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1979693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1979696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1979699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1979702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979728 */     // MIs[0] policy
     /* 1979728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979762 */     // GIR_Coverage, 61593,
     /* 1979762 */     GIR_EraseRootFromParent_Done,
     /* 1979763 */   // Label 26504: @1979763
     /* 1979763 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1979849), // Rule ID 61596 //
     /* 1979768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1979788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979814 */     // MIs[0] policy
     /* 1979814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979848 */     // GIR_Coverage, 61596,
     /* 1979848 */     GIR_EraseRootFromParent_Done,
     /* 1979849 */   // Label 26505: @1979849
     /* 1979849 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1979935), // Rule ID 61597 //
     /* 1979854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1979874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979900 */     // MIs[0] policy
     /* 1979900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1979913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979934 */     // GIR_Coverage, 61597,
     /* 1979934 */     GIR_EraseRootFromParent_Done,
     /* 1979935 */   // Label 26506: @1979935
     /* 1979935 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1980021), // Rule ID 61600 //
     /* 1979940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1979951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1979954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1979957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1979960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979986 */     // MIs[0] policy
     /* 1979986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1979999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980020 */     // GIR_Coverage, 61600,
     /* 1980020 */     GIR_EraseRootFromParent_Done,
     /* 1980021 */   // Label 26507: @1980021
     /* 1980021 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1980107), // Rule ID 61601 //
     /* 1980026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1980037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1980040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1980043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1980046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980072 */     // MIs[0] policy
     /* 1980072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980082 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1980085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980106 */     // GIR_Coverage, 61601,
     /* 1980106 */     GIR_EraseRootFromParent_Done,
     /* 1980107 */   // Label 26508: @1980107
     /* 1980107 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1980193), // Rule ID 61604 //
     /* 1980112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1980123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1980126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1980129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1980132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980158 */     // MIs[0] policy
     /* 1980158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1980171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980192 */     // GIR_Coverage, 61604,
     /* 1980192 */     GIR_EraseRootFromParent_Done,
     /* 1980193 */   // Label 26509: @1980193
     /* 1980193 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1980279), // Rule ID 61605 //
     /* 1980198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1980209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1980212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1980215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1980218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980244 */     // MIs[0] policy
     /* 1980244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1980257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980278 */     // GIR_Coverage, 61605,
     /* 1980278 */     GIR_EraseRootFromParent_Done,
     /* 1980279 */   // Label 26510: @1980279
     /* 1980279 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1980365), // Rule ID 61608 //
     /* 1980284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1980295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1980298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1980301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1980304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1980307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980330 */     // MIs[0] policy
     /* 1980330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980340 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1980343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980364 */     // GIR_Coverage, 61608,
     /* 1980364 */     GIR_EraseRootFromParent_Done,
     /* 1980365 */   // Label 26511: @1980365
     /* 1980365 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1980451), // Rule ID 61609 //
     /* 1980370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1980381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1980384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1980387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1980390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1980393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980416 */     // MIs[0] policy
     /* 1980416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1980429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980450 */     // GIR_Coverage, 61609,
     /* 1980450 */     GIR_EraseRootFromParent_Done,
     /* 1980451 */   // Label 26512: @1980451
     /* 1980451 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1980537), // Rule ID 61612 //
     /* 1980456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1980467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1980470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1980473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1980476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980502 */     // MIs[0] policy
     /* 1980502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1980515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980536 */     // GIR_Coverage, 61612,
     /* 1980536 */     GIR_EraseRootFromParent_Done,
     /* 1980537 */   // Label 26513: @1980537
     /* 1980537 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1980623), // Rule ID 61613 //
     /* 1980542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1980553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1980556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1980559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1980562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980588 */     // MIs[0] policy
     /* 1980588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1980601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980622 */     // GIR_Coverage, 61613,
     /* 1980622 */     GIR_EraseRootFromParent_Done,
     /* 1980623 */   // Label 26514: @1980623
     /* 1980623 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1980709), // Rule ID 61616 //
     /* 1980628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1980648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980674 */     // MIs[0] policy
     /* 1980674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1980687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980708 */     // GIR_Coverage, 61616,
     /* 1980708 */     GIR_EraseRootFromParent_Done,
     /* 1980709 */   // Label 26515: @1980709
     /* 1980709 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1980795), // Rule ID 61617 //
     /* 1980714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1980734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980760 */     // MIs[0] policy
     /* 1980760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1980773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980794 */     // GIR_Coverage, 61617,
     /* 1980794 */     GIR_EraseRootFromParent_Done,
     /* 1980795 */   // Label 26516: @1980795
     /* 1980795 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1980881), // Rule ID 61620 //
     /* 1980800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1980820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980846 */     // MIs[0] policy
     /* 1980846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1980859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980880 */     // GIR_Coverage, 61620,
     /* 1980880 */     GIR_EraseRootFromParent_Done,
     /* 1980881 */   // Label 26517: @1980881
     /* 1980881 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1980967), // Rule ID 61621 //
     /* 1980886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1980906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980932 */     // MIs[0] policy
     /* 1980932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1980945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980966 */     // GIR_Coverage, 61621,
     /* 1980966 */     GIR_EraseRootFromParent_Done,
     /* 1980967 */   // Label 26518: @1980967
     /* 1980967 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1981053), // Rule ID 61624 //
     /* 1980972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1980983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1980986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1980989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1980992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981018 */     // MIs[0] policy
     /* 1981018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1981031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981052 */     // GIR_Coverage, 61624,
     /* 1981052 */     GIR_EraseRootFromParent_Done,
     /* 1981053 */   // Label 26519: @1981053
     /* 1981053 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1981139), // Rule ID 61625 //
     /* 1981058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1981069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1981072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1981075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1981078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981104 */     // MIs[0] policy
     /* 1981104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1981117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981138 */     // GIR_Coverage, 61625,
     /* 1981138 */     GIR_EraseRootFromParent_Done,
     /* 1981139 */   // Label 26520: @1981139
     /* 1981139 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1981225), // Rule ID 61628 //
     /* 1981144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1981155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1981158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1981161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1981164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981190 */     // MIs[0] policy
     /* 1981190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1981203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981224 */     // GIR_Coverage, 61628,
     /* 1981224 */     GIR_EraseRootFromParent_Done,
     /* 1981225 */   // Label 26521: @1981225
     /* 1981225 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1981311), // Rule ID 61629 //
     /* 1981230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1981241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1981244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1981247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1981250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981276 */     // MIs[0] policy
     /* 1981276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1981289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981310 */     // GIR_Coverage, 61629,
     /* 1981310 */     GIR_EraseRootFromParent_Done,
     /* 1981311 */   // Label 26522: @1981311
     /* 1981311 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1981397), // Rule ID 61632 //
     /* 1981316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1981327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1981330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1981333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1981336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1981339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981362 */     // MIs[0] policy
     /* 1981362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1981375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981396 */     // GIR_Coverage, 61632,
     /* 1981396 */     GIR_EraseRootFromParent_Done,
     /* 1981397 */   // Label 26523: @1981397
     /* 1981397 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1981483), // Rule ID 61633 //
     /* 1981402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1981413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1981416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1981419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1981422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1981425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981448 */     // MIs[0] policy
     /* 1981448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1981461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981482 */     // GIR_Coverage, 61633,
     /* 1981482 */     GIR_EraseRootFromParent_Done,
     /* 1981483 */   // Label 26524: @1981483
     /* 1981483 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1981569), // Rule ID 61636 //
     /* 1981488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1981499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1981502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1981505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1981508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981534 */     // MIs[0] policy
     /* 1981534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1981547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981568 */     // GIR_Coverage, 61636,
     /* 1981568 */     GIR_EraseRootFromParent_Done,
     /* 1981569 */   // Label 26525: @1981569
     /* 1981569 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1981655), // Rule ID 61637 //
     /* 1981574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1981585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1981588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1981591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1981594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981620 */     // MIs[0] policy
     /* 1981620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1981633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981654 */     // GIR_Coverage, 61637,
     /* 1981654 */     GIR_EraseRootFromParent_Done,
     /* 1981655 */   // Label 26526: @1981655
     /* 1981655 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1981741), // Rule ID 61640 //
     /* 1981660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1981680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981706 */     // MIs[0] policy
     /* 1981706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1981719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981740 */     // GIR_Coverage, 61640,
     /* 1981740 */     GIR_EraseRootFromParent_Done,
     /* 1981741 */   // Label 26527: @1981741
     /* 1981741 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1981827), // Rule ID 61641 //
     /* 1981746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1981766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981792 */     // MIs[0] policy
     /* 1981792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1981805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981826 */     // GIR_Coverage, 61641,
     /* 1981826 */     GIR_EraseRootFromParent_Done,
     /* 1981827 */   // Label 26528: @1981827
     /* 1981827 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1981913), // Rule ID 61644 //
     /* 1981832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1981852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981878 */     // MIs[0] policy
     /* 1981878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1981891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981912 */     // GIR_Coverage, 61644,
     /* 1981912 */     GIR_EraseRootFromParent_Done,
     /* 1981913 */   // Label 26529: @1981913
     /* 1981913 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1981999), // Rule ID 61645 //
     /* 1981918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1981938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981964 */     // MIs[0] policy
     /* 1981964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1981977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981998 */     // GIR_Coverage, 61645,
     /* 1981998 */     GIR_EraseRootFromParent_Done,
     /* 1981999 */   // Label 26530: @1981999
     /* 1981999 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1982085), // Rule ID 61648 //
     /* 1982004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1982015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1982018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1982021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982050 */     // MIs[0] policy
     /* 1982050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982060 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1982063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982084 */     // GIR_Coverage, 61648,
     /* 1982084 */     GIR_EraseRootFromParent_Done,
     /* 1982085 */   // Label 26531: @1982085
     /* 1982085 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1982171), // Rule ID 61649 //
     /* 1982090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1982101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1982104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1982107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982136 */     // MIs[0] policy
     /* 1982136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982146 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1982149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982170 */     // GIR_Coverage, 61649,
     /* 1982170 */     GIR_EraseRootFromParent_Done,
     /* 1982171 */   // Label 26532: @1982171
     /* 1982171 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1982257), // Rule ID 61652 //
     /* 1982176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1982187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1982190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1982193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982222 */     // MIs[0] policy
     /* 1982222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1982235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982256 */     // GIR_Coverage, 61652,
     /* 1982256 */     GIR_EraseRootFromParent_Done,
     /* 1982257 */   // Label 26533: @1982257
     /* 1982257 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1982343), // Rule ID 61653 //
     /* 1982262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1982273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1982276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1982279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982308 */     // MIs[0] policy
     /* 1982308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1982321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982342 */     // GIR_Coverage, 61653,
     /* 1982342 */     GIR_EraseRootFromParent_Done,
     /* 1982343 */   // Label 26534: @1982343
     /* 1982343 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1982429), // Rule ID 61656 //
     /* 1982348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1982359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1982362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1982365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982394 */     // MIs[0] policy
     /* 1982394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1982407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982428 */     // GIR_Coverage, 61656,
     /* 1982428 */     GIR_EraseRootFromParent_Done,
     /* 1982429 */   // Label 26535: @1982429
     /* 1982429 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1982515), // Rule ID 61657 //
     /* 1982434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1982445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1982448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1982451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982480 */     // MIs[0] policy
     /* 1982480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1982493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982514 */     // GIR_Coverage, 61657,
     /* 1982514 */     GIR_EraseRootFromParent_Done,
     /* 1982515 */   // Label 26536: @1982515
     /* 1982515 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1982601), // Rule ID 61660 //
     /* 1982520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1982531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1982534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1982537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982566 */     // MIs[0] policy
     /* 1982566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1982579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982600 */     // GIR_Coverage, 61660,
     /* 1982600 */     GIR_EraseRootFromParent_Done,
     /* 1982601 */   // Label 26537: @1982601
     /* 1982601 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1982687), // Rule ID 61661 //
     /* 1982606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1982617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1982620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1982623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982652 */     // MIs[0] policy
     /* 1982652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1982665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982686 */     // GIR_Coverage, 61661,
     /* 1982686 */     GIR_EraseRootFromParent_Done,
     /* 1982687 */   // Label 26538: @1982687
     /* 1982687 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1982773), // Rule ID 61664 //
     /* 1982692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982738 */     // MIs[0] policy
     /* 1982738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982748 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1982751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982772 */     // GIR_Coverage, 61664,
     /* 1982772 */     GIR_EraseRootFromParent_Done,
     /* 1982773 */   // Label 26539: @1982773
     /* 1982773 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1982859), // Rule ID 61665 //
     /* 1982778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982824 */     // MIs[0] policy
     /* 1982824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1982837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982858 */     // GIR_Coverage, 61665,
     /* 1982858 */     GIR_EraseRootFromParent_Done,
     /* 1982859 */   // Label 26540: @1982859
     /* 1982859 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1982945), // Rule ID 61668 //
     /* 1982864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1982884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982910 */     // MIs[0] policy
     /* 1982910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1982923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982944 */     // GIR_Coverage, 61668,
     /* 1982944 */     GIR_EraseRootFromParent_Done,
     /* 1982945 */   // Label 26541: @1982945
     /* 1982945 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1983031), // Rule ID 61669 //
     /* 1982950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1982970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1982992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982996 */     // MIs[0] policy
     /* 1982996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1983009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983030 */     // GIR_Coverage, 61669,
     /* 1983030 */     GIR_EraseRootFromParent_Done,
     /* 1983031 */   // Label 26542: @1983031
     /* 1983031 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1983117), // Rule ID 61672 //
     /* 1983036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1983047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1983050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1983053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983082 */     // MIs[0] policy
     /* 1983082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983116 */     // GIR_Coverage, 61672,
     /* 1983116 */     GIR_EraseRootFromParent_Done,
     /* 1983117 */   // Label 26543: @1983117
     /* 1983117 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1983203), // Rule ID 61673 //
     /* 1983122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1983133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1983136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1983139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983168 */     // MIs[0] policy
     /* 1983168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983178 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983202 */     // GIR_Coverage, 61673,
     /* 1983202 */     GIR_EraseRootFromParent_Done,
     /* 1983203 */   // Label 26544: @1983203
     /* 1983203 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1983289), // Rule ID 61676 //
     /* 1983208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1983219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1983222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1983225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983254 */     // MIs[0] policy
     /* 1983254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983288 */     // GIR_Coverage, 61676,
     /* 1983288 */     GIR_EraseRootFromParent_Done,
     /* 1983289 */   // Label 26545: @1983289
     /* 1983289 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1983375), // Rule ID 61677 //
     /* 1983294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1983305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1983308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1983311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983340 */     // MIs[0] policy
     /* 1983340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983374 */     // GIR_Coverage, 61677,
     /* 1983374 */     GIR_EraseRootFromParent_Done,
     /* 1983375 */   // Label 26546: @1983375
     /* 1983375 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1983461), // Rule ID 61680 //
     /* 1983380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1983391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1983394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1983397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983426 */     // MIs[0] policy
     /* 1983426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983460 */     // GIR_Coverage, 61680,
     /* 1983460 */     GIR_EraseRootFromParent_Done,
     /* 1983461 */   // Label 26547: @1983461
     /* 1983461 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1983547), // Rule ID 61681 //
     /* 1983466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1983477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1983480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1983483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983512 */     // MIs[0] policy
     /* 1983512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983546 */     // GIR_Coverage, 61681,
     /* 1983546 */     GIR_EraseRootFromParent_Done,
     /* 1983547 */   // Label 26548: @1983547
     /* 1983547 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1983633), // Rule ID 61684 //
     /* 1983552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1983563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1983566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983598 */     // MIs[0] policy
     /* 1983598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983632 */     // GIR_Coverage, 61684,
     /* 1983632 */     GIR_EraseRootFromParent_Done,
     /* 1983633 */   // Label 26549: @1983633
     /* 1983633 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1983719), // Rule ID 61685 //
     /* 1983638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1983649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1983652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983684 */     // MIs[0] policy
     /* 1983684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1983697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983718 */     // GIR_Coverage, 61685,
     /* 1983718 */     GIR_EraseRootFromParent_Done,
     /* 1983719 */   // Label 26550: @1983719
     /* 1983719 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1983805), // Rule ID 61688 //
     /* 1983724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983770 */     // MIs[0] policy
     /* 1983770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1983783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983804 */     // GIR_Coverage, 61688,
     /* 1983804 */     GIR_EraseRootFromParent_Done,
     /* 1983805 */   // Label 26551: @1983805
     /* 1983805 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1983891), // Rule ID 61689 //
     /* 1983810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1983830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983856 */     // MIs[0] policy
     /* 1983856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1983869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983890 */     // GIR_Coverage, 61689,
     /* 1983890 */     GIR_EraseRootFromParent_Done,
     /* 1983891 */   // Label 26552: @1983891
     /* 1983891 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1983977), // Rule ID 61692 //
     /* 1983896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1983916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1983938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983942 */     // MIs[0] policy
     /* 1983942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1983955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983976 */     // GIR_Coverage, 61692,
     /* 1983976 */     GIR_EraseRootFromParent_Done,
     /* 1983977 */   // Label 26553: @1983977
     /* 1983977 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1984063), // Rule ID 61693 //
     /* 1983982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984028 */     // MIs[0] policy
     /* 1984028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984038 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1984041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984062 */     // GIR_Coverage, 61693,
     /* 1984062 */     GIR_EraseRootFromParent_Done,
     /* 1984063 */   // Label 26554: @1984063
     /* 1984063 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1984149), // Rule ID 61696 //
     /* 1984068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1984079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1984082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1984085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1984091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984114 */     // MIs[0] policy
     /* 1984114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984124 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1984127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984148 */     // GIR_Coverage, 61696,
     /* 1984148 */     GIR_EraseRootFromParent_Done,
     /* 1984149 */   // Label 26555: @1984149
     /* 1984149 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1984235), // Rule ID 61697 //
     /* 1984154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1984165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1984168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1984171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1984177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984200 */     // MIs[0] policy
     /* 1984200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984210 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1984213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984234 */     // GIR_Coverage, 61697,
     /* 1984234 */     GIR_EraseRootFromParent_Done,
     /* 1984235 */   // Label 26556: @1984235
     /* 1984235 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1984321), // Rule ID 61700 //
     /* 1984240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1984251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1984254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1984257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984286 */     // MIs[0] policy
     /* 1984286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1984299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984320 */     // GIR_Coverage, 61700,
     /* 1984320 */     GIR_EraseRootFromParent_Done,
     /* 1984321 */   // Label 26557: @1984321
     /* 1984321 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1984407), // Rule ID 61701 //
     /* 1984326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1984337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1984340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1984343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984372 */     // MIs[0] policy
     /* 1984372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1984385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984406 */     // GIR_Coverage, 61701,
     /* 1984406 */     GIR_EraseRootFromParent_Done,
     /* 1984407 */   // Label 26558: @1984407
     /* 1984407 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1984493), // Rule ID 61704 //
     /* 1984412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1984423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1984426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1984429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984458 */     // MIs[0] policy
     /* 1984458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1984471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984492 */     // GIR_Coverage, 61704,
     /* 1984492 */     GIR_EraseRootFromParent_Done,
     /* 1984493 */   // Label 26559: @1984493
     /* 1984493 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1984579), // Rule ID 61705 //
     /* 1984498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1984509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1984512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1984515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984544 */     // MIs[0] policy
     /* 1984544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1984557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984578 */     // GIR_Coverage, 61705,
     /* 1984578 */     GIR_EraseRootFromParent_Done,
     /* 1984579 */   // Label 26560: @1984579
     /* 1984579 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1984665), // Rule ID 61708 //
     /* 1984584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984630 */     // MIs[0] policy
     /* 1984630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984640 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1984643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984664 */     // GIR_Coverage, 61708,
     /* 1984664 */     GIR_EraseRootFromParent_Done,
     /* 1984665 */   // Label 26561: @1984665
     /* 1984665 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1984751), // Rule ID 61709 //
     /* 1984670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984716 */     // MIs[0] policy
     /* 1984716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1984729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984750 */     // GIR_Coverage, 61709,
     /* 1984750 */     GIR_EraseRootFromParent_Done,
     /* 1984751 */   // Label 26562: @1984751
     /* 1984751 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1984837), // Rule ID 61712 //
     /* 1984756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984802 */     // MIs[0] policy
     /* 1984802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1984815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984836 */     // GIR_Coverage, 61712,
     /* 1984836 */     GIR_EraseRootFromParent_Done,
     /* 1984837 */   // Label 26563: @1984837
     /* 1984837 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1984923), // Rule ID 61713 //
     /* 1984842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984888 */     // MIs[0] policy
     /* 1984888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1984901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984922 */     // GIR_Coverage, 61713,
     /* 1984922 */     GIR_EraseRootFromParent_Done,
     /* 1984923 */   // Label 26564: @1984923
     /* 1984923 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1985009), // Rule ID 61716 //
     /* 1984928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1984939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1984942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1984945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984974 */     // MIs[0] policy
     /* 1984974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1984987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985008 */     // GIR_Coverage, 61716,
     /* 1985008 */     GIR_EraseRootFromParent_Done,
     /* 1985009 */   // Label 26565: @1985009
     /* 1985009 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1985095), // Rule ID 61717 //
     /* 1985014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1985025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1985028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1985031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1985044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985060 */     // MIs[0] policy
     /* 1985060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1985073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985094 */     // GIR_Coverage, 61717,
     /* 1985094 */     GIR_EraseRootFromParent_Done,
     /* 1985095 */   // Label 26566: @1985095
     /* 1985095 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1985181), // Rule ID 61720 //
     /* 1985100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1985111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1985114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1985117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1985123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985146 */     // MIs[0] policy
     /* 1985146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985156 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1985159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985180 */     // GIR_Coverage, 61720,
     /* 1985180 */     GIR_EraseRootFromParent_Done,
     /* 1985181 */   // Label 26567: @1985181
     /* 1985181 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1985267), // Rule ID 61721 //
     /* 1985186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1985197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1985200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1985203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1985209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985232 */     // MIs[0] policy
     /* 1985232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1985245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985266 */     // GIR_Coverage, 61721,
     /* 1985266 */     GIR_EraseRootFromParent_Done,
     /* 1985267 */   // Label 26568: @1985267
     /* 1985267 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1985353), // Rule ID 61724 //
     /* 1985272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1985283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1985286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1985289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1985302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985318 */     // MIs[0] policy
     /* 1985318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985328 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1985331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985352 */     // GIR_Coverage, 61724,
     /* 1985352 */     GIR_EraseRootFromParent_Done,
     /* 1985353 */   // Label 26569: @1985353
     /* 1985353 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1985439), // Rule ID 61725 //
     /* 1985358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1985369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1985372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1985375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1985388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985404 */     // MIs[0] policy
     /* 1985404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1985417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985438 */     // GIR_Coverage, 61725,
     /* 1985438 */     GIR_EraseRootFromParent_Done,
     /* 1985439 */   // Label 26570: @1985439
     /* 1985439 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1985525), // Rule ID 61728 //
     /* 1985444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1985455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1985458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1985461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1985474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985490 */     // MIs[0] policy
     /* 1985490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985500 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1985503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985524 */     // GIR_Coverage, 61728,
     /* 1985524 */     GIR_EraseRootFromParent_Done,
     /* 1985525 */   // Label 26571: @1985525
     /* 1985525 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1985611), // Rule ID 61729 //
     /* 1985530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1985541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1985544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1985547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1985560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985576 */     // MIs[0] policy
     /* 1985576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985586 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1985589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985610 */     // GIR_Coverage, 61729,
     /* 1985610 */     GIR_EraseRootFromParent_Done,
     /* 1985611 */   // Label 26572: @1985611
     /* 1985611 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1985697), // Rule ID 61732 //
     /* 1985616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985662 */     // MIs[0] policy
     /* 1985662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985672 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1985675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985696 */     // GIR_Coverage, 61732,
     /* 1985696 */     GIR_EraseRootFromParent_Done,
     /* 1985697 */   // Label 26573: @1985697
     /* 1985697 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1985783), // Rule ID 61733 //
     /* 1985702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985748 */     // MIs[0] policy
     /* 1985748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985758 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1985761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985782 */     // GIR_Coverage, 61733,
     /* 1985782 */     GIR_EraseRootFromParent_Done,
     /* 1985783 */   // Label 26574: @1985783
     /* 1985783 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1985869), // Rule ID 61820 //
     /* 1985788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1985805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1985808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985834 */     // MIs[0] policy
     /* 1985834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1985847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985868 */     // GIR_Coverage, 61820,
     /* 1985868 */     GIR_EraseRootFromParent_Done,
     /* 1985869 */   // Label 26575: @1985869
     /* 1985869 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1985955), // Rule ID 61821 //
     /* 1985874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1985891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1985894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985920 */     // MIs[0] policy
     /* 1985920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985930 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1985933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985954 */     // GIR_Coverage, 61821,
     /* 1985954 */     GIR_EraseRootFromParent_Done,
     /* 1985955 */   // Label 26576: @1985955
     /* 1985955 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1986041), // Rule ID 61824 //
     /* 1985960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1985971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1985974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1985977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1985980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986006 */     // MIs[0] policy
     /* 1986006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986016 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1986019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986040 */     // GIR_Coverage, 61824,
     /* 1986040 */     GIR_EraseRootFromParent_Done,
     /* 1986041 */   // Label 26577: @1986041
     /* 1986041 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1986127), // Rule ID 61825 //
     /* 1986046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1986057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1986060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1986063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1986066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986092 */     // MIs[0] policy
     /* 1986092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986102 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1986105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986126 */     // GIR_Coverage, 61825,
     /* 1986126 */     GIR_EraseRootFromParent_Done,
     /* 1986127 */   // Label 26578: @1986127
     /* 1986127 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1986213), // Rule ID 61828 //
     /* 1986132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1986143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1986146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1986149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1986152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986178 */     // MIs[0] policy
     /* 1986178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986188 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986212 */     // GIR_Coverage, 61828,
     /* 1986212 */     GIR_EraseRootFromParent_Done,
     /* 1986213 */   // Label 26579: @1986213
     /* 1986213 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1986299), // Rule ID 61829 //
     /* 1986218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1986229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1986232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1986235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1986238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986264 */     // MIs[0] policy
     /* 1986264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986298 */     // GIR_Coverage, 61829,
     /* 1986298 */     GIR_EraseRootFromParent_Done,
     /* 1986299 */   // Label 26580: @1986299
     /* 1986299 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1986385), // Rule ID 61832 //
     /* 1986304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1986315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1986318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1986321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1986324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986350 */     // MIs[0] policy
     /* 1986350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1986363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986384 */     // GIR_Coverage, 61832,
     /* 1986384 */     GIR_EraseRootFromParent_Done,
     /* 1986385 */   // Label 26581: @1986385
     /* 1986385 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1986471), // Rule ID 61833 //
     /* 1986390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1986401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1986404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1986407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1986410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986436 */     // MIs[0] policy
     /* 1986436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1986449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986470 */     // GIR_Coverage, 61833,
     /* 1986470 */     GIR_EraseRootFromParent_Done,
     /* 1986471 */   // Label 26582: @1986471
     /* 1986471 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1986557), // Rule ID 61836 //
     /* 1986476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1986487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1986490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1986493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1986496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986522 */     // MIs[0] policy
     /* 1986522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986556 */     // GIR_Coverage, 61836,
     /* 1986556 */     GIR_EraseRootFromParent_Done,
     /* 1986557 */   // Label 26583: @1986557
     /* 1986557 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1986643), // Rule ID 61837 //
     /* 1986562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1986573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1986576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1986579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1986582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986608 */     // MIs[0] policy
     /* 1986608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986642 */     // GIR_Coverage, 61837,
     /* 1986642 */     GIR_EraseRootFromParent_Done,
     /* 1986643 */   // Label 26584: @1986643
     /* 1986643 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1986729), // Rule ID 61840 //
     /* 1986648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1986659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1986662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1986668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986694 */     // MIs[0] policy
     /* 1986694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986704 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986728 */     // GIR_Coverage, 61840,
     /* 1986728 */     GIR_EraseRootFromParent_Done,
     /* 1986729 */   // Label 26585: @1986729
     /* 1986729 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1986815), // Rule ID 61841 //
     /* 1986734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1986745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1986748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1986754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986780 */     // MIs[0] policy
     /* 1986780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1986793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986814 */     // GIR_Coverage, 61841,
     /* 1986814 */     GIR_EraseRootFromParent_Done,
     /* 1986815 */   // Label 26586: @1986815
     /* 1986815 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1986901), // Rule ID 61844 //
     /* 1986820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1986837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1986840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986866 */     // MIs[0] policy
     /* 1986866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986876 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1986879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986900 */     // GIR_Coverage, 61844,
     /* 1986900 */     GIR_EraseRootFromParent_Done,
     /* 1986901 */   // Label 26587: @1986901
     /* 1986901 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1986987), // Rule ID 61845 //
     /* 1986906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1986923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1986926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986952 */     // MIs[0] policy
     /* 1986952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986962 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1986965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986986 */     // GIR_Coverage, 61845,
     /* 1986986 */     GIR_EraseRootFromParent_Done,
     /* 1986987 */   // Label 26588: @1986987
     /* 1986987 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1987073), // Rule ID 61848 //
     /* 1986992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1987003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1987006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1987009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1987012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987038 */     // MIs[0] policy
     /* 1987038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987072 */     // GIR_Coverage, 61848,
     /* 1987072 */     GIR_EraseRootFromParent_Done,
     /* 1987073 */   // Label 26589: @1987073
     /* 1987073 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1987159), // Rule ID 61849 //
     /* 1987078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1987089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1987092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1987095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1987098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987124 */     // MIs[0] policy
     /* 1987124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987158 */     // GIR_Coverage, 61849,
     /* 1987158 */     GIR_EraseRootFromParent_Done,
     /* 1987159 */   // Label 26590: @1987159
     /* 1987159 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1987245), // Rule ID 61852 //
     /* 1987164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1987175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1987178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1987181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1987184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987210 */     // MIs[0] policy
     /* 1987210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987244 */     // GIR_Coverage, 61852,
     /* 1987244 */     GIR_EraseRootFromParent_Done,
     /* 1987245 */   // Label 26591: @1987245
     /* 1987245 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1987331), // Rule ID 61853 //
     /* 1987250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1987261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1987264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1987267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1987270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987296 */     // MIs[0] policy
     /* 1987296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987330 */     // GIR_Coverage, 61853,
     /* 1987330 */     GIR_EraseRootFromParent_Done,
     /* 1987331 */   // Label 26592: @1987331
     /* 1987331 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1987417), // Rule ID 61856 //
     /* 1987336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1987347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1987350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1987353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1987356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1987359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987382 */     // MIs[0] policy
     /* 1987382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987392 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987416 */     // GIR_Coverage, 61856,
     /* 1987416 */     GIR_EraseRootFromParent_Done,
     /* 1987417 */   // Label 26593: @1987417
     /* 1987417 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1987503), // Rule ID 61857 //
     /* 1987422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1987433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1987436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1987439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1987442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1987445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1987452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1987464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987468 */     // MIs[0] policy
     /* 1987468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987478 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1987481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987502 */     // GIR_Coverage, 61857,
     /* 1987502 */     GIR_EraseRootFromParent_Done,
     /* 1987503 */   // Label 26594: @1987503
     /* 1987503 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1987589), // Rule ID 61860 //
     /* 1987508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1987519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1987522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1987525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1987528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987554 */     // MIs[0] policy
     /* 1987554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1987567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987588 */     // GIR_Coverage, 61860,
     /* 1987588 */     GIR_EraseRootFromParent_Done,
     /* 1987589 */   // Label 26595: @1987589
     /* 1987589 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1987675), // Rule ID 61861 //
     /* 1987594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1987605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1987608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1987611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1987614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987640 */     // MIs[0] policy
     /* 1987640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1987653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987674 */     // GIR_Coverage, 61861,
     /* 1987674 */     GIR_EraseRootFromParent_Done,
     /* 1987675 */   // Label 26596: @1987675
     /* 1987675 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1987761), // Rule ID 61864 //
     /* 1987680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1987691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1987694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1987697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1987700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987726 */     // MIs[0] policy
     /* 1987726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1987739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987760 */     // GIR_Coverage, 61864,
     /* 1987760 */     GIR_EraseRootFromParent_Done,
     /* 1987761 */   // Label 26597: @1987761
     /* 1987761 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1987847), // Rule ID 61865 //
     /* 1987766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1987777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1987780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1987783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1987786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987812 */     // MIs[0] policy
     /* 1987812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1987825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987846 */     // GIR_Coverage, 61865,
     /* 1987846 */     GIR_EraseRootFromParent_Done,
     /* 1987847 */   // Label 26598: @1987847
     /* 1987847 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1987933), // Rule ID 61868 //
     /* 1987852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1987863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1987866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1987869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1987872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1987875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987898 */     // MIs[0] policy
     /* 1987898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987908 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1987911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987932 */     // GIR_Coverage, 61868,
     /* 1987932 */     GIR_EraseRootFromParent_Done,
     /* 1987933 */   // Label 26599: @1987933
     /* 1987933 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1988019), // Rule ID 61869 //
     /* 1987938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1987949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1987952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1987955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1987958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1987961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987984 */     // MIs[0] policy
     /* 1987984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987994 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1987997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988018 */     // GIR_Coverage, 61869,
     /* 1988018 */     GIR_EraseRootFromParent_Done,
     /* 1988019 */   // Label 26600: @1988019
     /* 1988019 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1988105), // Rule ID 61872 //
     /* 1988024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1988035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1988038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1988041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1988044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988070 */     // MIs[0] policy
     /* 1988070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1988083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988104 */     // GIR_Coverage, 61872,
     /* 1988104 */     GIR_EraseRootFromParent_Done,
     /* 1988105 */   // Label 26601: @1988105
     /* 1988105 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1988191), // Rule ID 61873 //
     /* 1988110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1988121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1988124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1988127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1988130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988156 */     // MIs[0] policy
     /* 1988156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1988169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988190 */     // GIR_Coverage, 61873,
     /* 1988190 */     GIR_EraseRootFromParent_Done,
     /* 1988191 */   // Label 26602: @1988191
     /* 1988191 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1988277), // Rule ID 61876 //
     /* 1988196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1988207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1988210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1988213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1988216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988242 */     // MIs[0] policy
     /* 1988242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1988255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988276 */     // GIR_Coverage, 61876,
     /* 1988276 */     GIR_EraseRootFromParent_Done,
     /* 1988277 */   // Label 26603: @1988277
     /* 1988277 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1988363), // Rule ID 61877 //
     /* 1988282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1988293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1988296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1988299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1988302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988328 */     // MIs[0] policy
     /* 1988328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988338 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1988341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988362 */     // GIR_Coverage, 61877,
     /* 1988362 */     GIR_EraseRootFromParent_Done,
     /* 1988363 */   // Label 26604: @1988363
     /* 1988363 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1988449), // Rule ID 61880 //
     /* 1988368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1988379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1988382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1988385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1988388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1988391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988414 */     // MIs[0] policy
     /* 1988414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1988427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988448 */     // GIR_Coverage, 61880,
     /* 1988448 */     GIR_EraseRootFromParent_Done,
     /* 1988449 */   // Label 26605: @1988449
     /* 1988449 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1988535), // Rule ID 61881 //
     /* 1988454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1988465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1988468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1988471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1988474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1988477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988500 */     // MIs[0] policy
     /* 1988500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1988513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988534 */     // GIR_Coverage, 61881,
     /* 1988534 */     GIR_EraseRootFromParent_Done,
     /* 1988535 */   // Label 26606: @1988535
     /* 1988535 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1988621), // Rule ID 61884 //
     /* 1988540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1988551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1988554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1988557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1988560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988586 */     // MIs[0] policy
     /* 1988586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1988599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988620 */     // GIR_Coverage, 61884,
     /* 1988620 */     GIR_EraseRootFromParent_Done,
     /* 1988621 */   // Label 26607: @1988621
     /* 1988621 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1988707), // Rule ID 61885 //
     /* 1988626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1988637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1988640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1988643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1988646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988672 */     // MIs[0] policy
     /* 1988672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1988685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988706 */     // GIR_Coverage, 61885,
     /* 1988706 */     GIR_EraseRootFromParent_Done,
     /* 1988707 */   // Label 26608: @1988707
     /* 1988707 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1988793), // Rule ID 61888 //
     /* 1988712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1988729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1988732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988758 */     // MIs[0] policy
     /* 1988758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1988771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988792 */     // GIR_Coverage, 61888,
     /* 1988792 */     GIR_EraseRootFromParent_Done,
     /* 1988793 */   // Label 26609: @1988793
     /* 1988793 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1988879), // Rule ID 61889 //
     /* 1988798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1988815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1988818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988844 */     // MIs[0] policy
     /* 1988844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1988857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988878 */     // GIR_Coverage, 61889,
     /* 1988878 */     GIR_EraseRootFromParent_Done,
     /* 1988879 */   // Label 26610: @1988879
     /* 1988879 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1988965), // Rule ID 61892 //
     /* 1988884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1988895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1988898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1988901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1988904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988930 */     // MIs[0] policy
     /* 1988930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1988943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988964 */     // GIR_Coverage, 61892,
     /* 1988964 */     GIR_EraseRootFromParent_Done,
     /* 1988965 */   // Label 26611: @1988965
     /* 1988965 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1989051), // Rule ID 61893 //
     /* 1988970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1988981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1988984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1988987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1988990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1989000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989016 */     // MIs[0] policy
     /* 1989016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1989029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989050 */     // GIR_Coverage, 61893,
     /* 1989050 */     GIR_EraseRootFromParent_Done,
     /* 1989051 */   // Label 26612: @1989051
     /* 1989051 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1989137), // Rule ID 61896 //
     /* 1989056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1989067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1989070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1989073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1989076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989102 */     // MIs[0] policy
     /* 1989102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989136 */     // GIR_Coverage, 61896,
     /* 1989136 */     GIR_EraseRootFromParent_Done,
     /* 1989137 */   // Label 26613: @1989137
     /* 1989137 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1989223), // Rule ID 61897 //
     /* 1989142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1989153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1989156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1989159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1989162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989188 */     // MIs[0] policy
     /* 1989188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989222 */     // GIR_Coverage, 61897,
     /* 1989222 */     GIR_EraseRootFromParent_Done,
     /* 1989223 */   // Label 26614: @1989223
     /* 1989223 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1989309), // Rule ID 61900 //
     /* 1989228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1989239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1989242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1989245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1989248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989274 */     // MIs[0] policy
     /* 1989274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1989287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989308 */     // GIR_Coverage, 61900,
     /* 1989308 */     GIR_EraseRootFromParent_Done,
     /* 1989309 */   // Label 26615: @1989309
     /* 1989309 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1989395), // Rule ID 61901 //
     /* 1989314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1989325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1989328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1989331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1989334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989360 */     // MIs[0] policy
     /* 1989360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1989373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989394 */     // GIR_Coverage, 61901,
     /* 1989394 */     GIR_EraseRootFromParent_Done,
     /* 1989395 */   // Label 26616: @1989395
     /* 1989395 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1989481), // Rule ID 61904 //
     /* 1989400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1989411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1989414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1989417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1989420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1989430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989446 */     // MIs[0] policy
     /* 1989446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989456 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1989459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989480 */     // GIR_Coverage, 61904,
     /* 1989480 */     GIR_EraseRootFromParent_Done,
     /* 1989481 */   // Label 26617: @1989481
     /* 1989481 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1989567), // Rule ID 61905 //
     /* 1989486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1989497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1989500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1989503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1989506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1989516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989532 */     // MIs[0] policy
     /* 1989532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1989545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989566 */     // GIR_Coverage, 61905,
     /* 1989566 */     GIR_EraseRootFromParent_Done,
     /* 1989567 */   // Label 26618: @1989567
     /* 1989567 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1989653), // Rule ID 61908 //
     /* 1989572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1989583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1989586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1989589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989618 */     // MIs[0] policy
     /* 1989618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1989631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989652 */     // GIR_Coverage, 61908,
     /* 1989652 */     GIR_EraseRootFromParent_Done,
     /* 1989653 */   // Label 26619: @1989653
     /* 1989653 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1989739), // Rule ID 61909 //
     /* 1989658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1989669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1989672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1989675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989704 */     // MIs[0] policy
     /* 1989704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989714 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1989717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989738 */     // GIR_Coverage, 61909,
     /* 1989738 */     GIR_EraseRootFromParent_Done,
     /* 1989739 */   // Label 26620: @1989739
     /* 1989739 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1989825), // Rule ID 61912 //
     /* 1989744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1989755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1989758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1989761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989790 */     // MIs[0] policy
     /* 1989790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1989803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989824 */     // GIR_Coverage, 61912,
     /* 1989824 */     GIR_EraseRootFromParent_Done,
     /* 1989825 */   // Label 26621: @1989825
     /* 1989825 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1989911), // Rule ID 61913 //
     /* 1989830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1989841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1989844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1989847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1989850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989876 */     // MIs[0] policy
     /* 1989876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1989889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989910 */     // GIR_Coverage, 61913,
     /* 1989910 */     GIR_EraseRootFromParent_Done,
     /* 1989911 */   // Label 26622: @1989911
     /* 1989911 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1989997), // Rule ID 61916 //
     /* 1989916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1989927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1989930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1989933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1989936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989962 */     // MIs[0] policy
     /* 1989962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989972 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1989975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989996 */     // GIR_Coverage, 61916,
     /* 1989996 */     GIR_EraseRootFromParent_Done,
     /* 1989997 */   // Label 26623: @1989997
     /* 1989997 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1990083), // Rule ID 61917 //
     /* 1990002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1990013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1990016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1990019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990048 */     // MIs[0] policy
     /* 1990048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990058 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1990061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990082 */     // GIR_Coverage, 61917,
     /* 1990082 */     GIR_EraseRootFromParent_Done,
     /* 1990083 */   // Label 26624: @1990083
     /* 1990083 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1990169), // Rule ID 61920 //
     /* 1990088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1990099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1990102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1990105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990134 */     // MIs[0] policy
     /* 1990134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990144 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1990147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990168 */     // GIR_Coverage, 61920,
     /* 1990168 */     GIR_EraseRootFromParent_Done,
     /* 1990169 */   // Label 26625: @1990169
     /* 1990169 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1990255), // Rule ID 61921 //
     /* 1990174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1990185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1990188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1990191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990220 */     // MIs[0] policy
     /* 1990220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990230 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1990233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990254 */     // GIR_Coverage, 61921,
     /* 1990254 */     GIR_EraseRootFromParent_Done,
     /* 1990255 */   // Label 26626: @1990255
     /* 1990255 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1990341), // Rule ID 61924 //
     /* 1990260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1990271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1990274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1990277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1990283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990306 */     // MIs[0] policy
     /* 1990306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1990319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990340 */     // GIR_Coverage, 61924,
     /* 1990340 */     GIR_EraseRootFromParent_Done,
     /* 1990341 */   // Label 26627: @1990341
     /* 1990341 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1990427), // Rule ID 61925 //
     /* 1990346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1990357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1990360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1990363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1990369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990392 */     // MIs[0] policy
     /* 1990392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990402 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1990405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990426 */     // GIR_Coverage, 61925,
     /* 1990426 */     GIR_EraseRootFromParent_Done,
     /* 1990427 */   // Label 26628: @1990427
     /* 1990427 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1990513), // Rule ID 61928 //
     /* 1990432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1990449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990478 */     // MIs[0] policy
     /* 1990478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990488 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1990491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990512 */     // GIR_Coverage, 61928,
     /* 1990512 */     GIR_EraseRootFromParent_Done,
     /* 1990513 */   // Label 26629: @1990513
     /* 1990513 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1990599), // Rule ID 61929 //
     /* 1990518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1990535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1990541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990564 */     // MIs[0] policy
     /* 1990564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1990577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990598 */     // GIR_Coverage, 61929,
     /* 1990598 */     GIR_EraseRootFromParent_Done,
     /* 1990599 */   // Label 26630: @1990599
     /* 1990599 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1990685), // Rule ID 61932 //
     /* 1990604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1990615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1990618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1990621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990650 */     // MIs[0] policy
     /* 1990650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990660 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1990663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990684 */     // GIR_Coverage, 61932,
     /* 1990684 */     GIR_EraseRootFromParent_Done,
     /* 1990685 */   // Label 26631: @1990685
     /* 1990685 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1990771), // Rule ID 61933 //
     /* 1990690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1990701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1990704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1990707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990736 */     // MIs[0] policy
     /* 1990736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1990749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990770 */     // GIR_Coverage, 61933,
     /* 1990770 */     GIR_EraseRootFromParent_Done,
     /* 1990771 */   // Label 26632: @1990771
     /* 1990771 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1990857), // Rule ID 61936 //
     /* 1990776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1990787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1990790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1990793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990822 */     // MIs[0] policy
     /* 1990822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1990835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990856 */     // GIR_Coverage, 61936,
     /* 1990856 */     GIR_EraseRootFromParent_Done,
     /* 1990857 */   // Label 26633: @1990857
     /* 1990857 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1990943), // Rule ID 61937 //
     /* 1990862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1990873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1990876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1990879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1990882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990908 */     // MIs[0] policy
     /* 1990908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1990921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990942 */     // GIR_Coverage, 61937,
     /* 1990942 */     GIR_EraseRootFromParent_Done,
     /* 1990943 */   // Label 26634: @1990943
     /* 1990943 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1991029), // Rule ID 61940 //
     /* 1990948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1990965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1990968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1990971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990994 */     // MIs[0] policy
     /* 1990994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1991007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991028 */     // GIR_Coverage, 61940,
     /* 1991028 */     GIR_EraseRootFromParent_Done,
     /* 1991029 */   // Label 26635: @1991029
     /* 1991029 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1991115), // Rule ID 61941 //
     /* 1991034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1991045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1991048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1991051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991080 */     // MIs[0] policy
     /* 1991080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1991093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991114 */     // GIR_Coverage, 61941,
     /* 1991114 */     GIR_EraseRootFromParent_Done,
     /* 1991115 */   // Label 26636: @1991115
     /* 1991115 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1991201), // Rule ID 61944 //
     /* 1991120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1991131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1991134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1991137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991166 */     // MIs[0] policy
     /* 1991166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1991179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991200 */     // GIR_Coverage, 61944,
     /* 1991200 */     GIR_EraseRootFromParent_Done,
     /* 1991201 */   // Label 26637: @1991201
     /* 1991201 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1991287), // Rule ID 61945 //
     /* 1991206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1991217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1991220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1991223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991252 */     // MIs[0] policy
     /* 1991252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1991265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991286 */     // GIR_Coverage, 61945,
     /* 1991286 */     GIR_EraseRootFromParent_Done,
     /* 1991287 */   // Label 26638: @1991287
     /* 1991287 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1991373), // Rule ID 61948 //
     /* 1991292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1991303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1991306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1991309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991338 */     // MIs[0] policy
     /* 1991338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1991351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991372 */     // GIR_Coverage, 61948,
     /* 1991372 */     GIR_EraseRootFromParent_Done,
     /* 1991373 */   // Label 26639: @1991373
     /* 1991373 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1991459), // Rule ID 61949 //
     /* 1991378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1991389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1991392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1991395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991424 */     // MIs[0] policy
     /* 1991424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1991437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991458 */     // GIR_Coverage, 61949,
     /* 1991458 */     GIR_EraseRootFromParent_Done,
     /* 1991459 */   // Label 26640: @1991459
     /* 1991459 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1991545), // Rule ID 61952 //
     /* 1991464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1991475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1991478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1991481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991510 */     // MIs[0] policy
     /* 1991510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991520 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1991523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991544 */     // GIR_Coverage, 61952,
     /* 1991544 */     GIR_EraseRootFromParent_Done,
     /* 1991545 */   // Label 26641: @1991545
     /* 1991545 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1991631), // Rule ID 61953 //
     /* 1991550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1991561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1991564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1991567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991596 */     // MIs[0] policy
     /* 1991596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991606 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1991609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991630 */     // GIR_Coverage, 61953,
     /* 1991630 */     GIR_EraseRootFromParent_Done,
     /* 1991631 */   // Label 26642: @1991631
     /* 1991631 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1991717), // Rule ID 61956 //
     /* 1991636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1991647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1991650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1991653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1991659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991682 */     // MIs[0] policy
     /* 1991682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991692 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1991695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991716 */     // GIR_Coverage, 61956,
     /* 1991716 */     GIR_EraseRootFromParent_Done,
     /* 1991717 */   // Label 26643: @1991717
     /* 1991717 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1991803), // Rule ID 61957 //
     /* 1991722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1991733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1991736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1991739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1991745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991768 */     // MIs[0] policy
     /* 1991768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991778 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1991781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991802 */     // GIR_Coverage, 61957,
     /* 1991802 */     GIR_EraseRootFromParent_Done,
     /* 1991803 */   // Label 26644: @1991803
     /* 1991803 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1991889), // Rule ID 61960 //
     /* 1991808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1991819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1991822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1991825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991854 */     // MIs[0] policy
     /* 1991854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1991867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991888 */     // GIR_Coverage, 61960,
     /* 1991888 */     GIR_EraseRootFromParent_Done,
     /* 1991889 */   // Label 26645: @1991889
     /* 1991889 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1991975), // Rule ID 61961 //
     /* 1991894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1991905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1991908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1991911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991940 */     // MIs[0] policy
     /* 1991940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1991953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1991971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991974 */     // GIR_Coverage, 61961,
     /* 1991974 */     GIR_EraseRootFromParent_Done,
     /* 1991975 */   // Label 26646: @1991975
     /* 1991975 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1992061), // Rule ID 61964 //
     /* 1991980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1991991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1991994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1991997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992026 */     // MIs[0] policy
     /* 1992026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1992039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992060 */     // GIR_Coverage, 61964,
     /* 1992060 */     GIR_EraseRootFromParent_Done,
     /* 1992061 */   // Label 26647: @1992061
     /* 1992061 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1992147), // Rule ID 61965 //
     /* 1992066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1992077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1992080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1992083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992112 */     // MIs[0] policy
     /* 1992112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992122 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1992125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992146 */     // GIR_Coverage, 61965,
     /* 1992146 */     GIR_EraseRootFromParent_Done,
     /* 1992147 */   // Label 26648: @1992147
     /* 1992147 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1992233), // Rule ID 61968 //
     /* 1992152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1992163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1992166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1992169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992198 */     // MIs[0] policy
     /* 1992198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992208 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1992211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992232 */     // GIR_Coverage, 61968,
     /* 1992232 */     GIR_EraseRootFromParent_Done,
     /* 1992233 */   // Label 26649: @1992233
     /* 1992233 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1992319), // Rule ID 61969 //
     /* 1992238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1992249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1992252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1992255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992284 */     // MIs[0] policy
     /* 1992284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1992297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992318 */     // GIR_Coverage, 61969,
     /* 1992318 */     GIR_EraseRootFromParent_Done,
     /* 1992319 */   // Label 26650: @1992319
     /* 1992319 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1992405), // Rule ID 61972 //
     /* 1992324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1992335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1992338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1992341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992370 */     // MIs[0] policy
     /* 1992370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992380 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1992383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992404 */     // GIR_Coverage, 61972,
     /* 1992404 */     GIR_EraseRootFromParent_Done,
     /* 1992405 */   // Label 26651: @1992405
     /* 1992405 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1992491), // Rule ID 61973 //
     /* 1992410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1992421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1992424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1992427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992456 */     // MIs[0] policy
     /* 1992456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1992469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992490 */     // GIR_Coverage, 61973,
     /* 1992490 */     GIR_EraseRootFromParent_Done,
     /* 1992491 */   // Label 26652: @1992491
     /* 1992491 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1992577), // Rule ID 61976 //
     /* 1992496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1992507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1992510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1992513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992542 */     // MIs[0] policy
     /* 1992542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992552 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1992555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992576 */     // GIR_Coverage, 61976,
     /* 1992576 */     GIR_EraseRootFromParent_Done,
     /* 1992577 */   // Label 26653: @1992577
     /* 1992577 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1992663), // Rule ID 61977 //
     /* 1992582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1992593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1992596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1992599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992628 */     // MIs[0] policy
     /* 1992628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1992641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992662 */     // GIR_Coverage, 61977,
     /* 1992662 */     GIR_EraseRootFromParent_Done,
     /* 1992663 */   // Label 26654: @1992663
     /* 1992663 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1992749), // Rule ID 61980 //
     /* 1992668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1992679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1992682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1992685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992714 */     // MIs[0] policy
     /* 1992714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1992727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992748 */     // GIR_Coverage, 61980,
     /* 1992748 */     GIR_EraseRootFromParent_Done,
     /* 1992749 */   // Label 26655: @1992749
     /* 1992749 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1992835), // Rule ID 61981 //
     /* 1992754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1992765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1992768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1992771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992800 */     // MIs[0] policy
     /* 1992800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992810 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1992813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992834 */     // GIR_Coverage, 61981,
     /* 1992834 */     GIR_EraseRootFromParent_Done,
     /* 1992835 */   // Label 26656: @1992835
     /* 1992835 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1992921), // Rule ID 61984 //
     /* 1992840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1992851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1992854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1992857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992886 */     // MIs[0] policy
     /* 1992886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1992899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1992917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992920 */     // GIR_Coverage, 61984,
     /* 1992920 */     GIR_EraseRootFromParent_Done,
     /* 1992921 */   // Label 26657: @1992921
     /* 1992921 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1993007), // Rule ID 61985 //
     /* 1992926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1992937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1992940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1992943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992972 */     // MIs[0] policy
     /* 1992972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11467:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1992985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993006 */     // GIR_Coverage, 61985,
     /* 1993006 */     GIR_EraseRootFromParent_Done,
     /* 1993007 */   // Label 26658: @1993007
     /* 1993007 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1993093), // Rule ID 61988 //
     /* 1993012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1993023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1993026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1993029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993058 */     // MIs[0] policy
     /* 1993058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993092 */     // GIR_Coverage, 61988,
     /* 1993092 */     GIR_EraseRootFromParent_Done,
     /* 1993093 */   // Label 26659: @1993093
     /* 1993093 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1993179), // Rule ID 61989 //
     /* 1993098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1993109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1993112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1993115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993144 */     // MIs[0] policy
     /* 1993144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11467:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993178 */     // GIR_Coverage, 61989,
     /* 1993178 */     GIR_EraseRootFromParent_Done,
     /* 1993179 */   // Label 26660: @1993179
     /* 1993179 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1993265), // Rule ID 61992 //
     /* 1993184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1993195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1993198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1993201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993230 */     // MIs[0] policy
     /* 1993230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993240 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1993243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993264 */     // GIR_Coverage, 61992,
     /* 1993264 */     GIR_EraseRootFromParent_Done,
     /* 1993265 */   // Label 26661: @1993265
     /* 1993265 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1993351), // Rule ID 61993 //
     /* 1993270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1993281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1993284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1993287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993316 */     // MIs[0] policy
     /* 1993316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11467:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1993329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993350 */     // GIR_Coverage, 61993,
     /* 1993350 */     GIR_EraseRootFromParent_Done,
     /* 1993351 */   // Label 26662: @1993351
     /* 1993351 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1993437), // Rule ID 62598 //
     /* 1993356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1993373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1993376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993402 */     // MIs[0] policy
     /* 1993402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1993415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993436 */     // GIR_Coverage, 62598,
     /* 1993436 */     GIR_EraseRootFromParent_Done,
     /* 1993437 */   // Label 26663: @1993437
     /* 1993437 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1993523), // Rule ID 62599 //
     /* 1993442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1993459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1993462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993488 */     // MIs[0] policy
     /* 1993488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1993501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993522 */     // GIR_Coverage, 62599,
     /* 1993522 */     GIR_EraseRootFromParent_Done,
     /* 1993523 */   // Label 26664: @1993523
     /* 1993523 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1993609), // Rule ID 62602 //
     /* 1993528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1993548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993574 */     // MIs[0] policy
     /* 1993574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1993587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993608 */     // GIR_Coverage, 62602,
     /* 1993608 */     GIR_EraseRootFromParent_Done,
     /* 1993609 */   // Label 26665: @1993609
     /* 1993609 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1993695), // Rule ID 62603 //
     /* 1993614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1993631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1993634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993660 */     // MIs[0] policy
     /* 1993660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1993673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993694 */     // GIR_Coverage, 62603,
     /* 1993694 */     GIR_EraseRootFromParent_Done,
     /* 1993695 */   // Label 26666: @1993695
     /* 1993695 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1993781), // Rule ID 62606 //
     /* 1993700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993746 */     // MIs[0] policy
     /* 1993746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1993759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993780 */     // GIR_Coverage, 62606,
     /* 1993780 */     GIR_EraseRootFromParent_Done,
     /* 1993781 */   // Label 26667: @1993781
     /* 1993781 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1993867), // Rule ID 62607 //
     /* 1993786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993832 */     // MIs[0] policy
     /* 1993832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1993845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993866 */     // GIR_Coverage, 62607,
     /* 1993866 */     GIR_EraseRootFromParent_Done,
     /* 1993867 */   // Label 26668: @1993867
     /* 1993867 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1993953), // Rule ID 62610 //
     /* 1993872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993918 */     // MIs[0] policy
     /* 1993918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1993931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993952 */     // GIR_Coverage, 62610,
     /* 1993952 */     GIR_EraseRootFromParent_Done,
     /* 1993953 */   // Label 26669: @1993953
     /* 1993953 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1994039), // Rule ID 62611 //
     /* 1993958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1993966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994004 */     // MIs[0] policy
     /* 1994004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1994017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994038 */     // GIR_Coverage, 62611,
     /* 1994038 */     GIR_EraseRootFromParent_Done,
     /* 1994039 */   // Label 26670: @1994039
     /* 1994039 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1994125), // Rule ID 62614 //
     /* 1994044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994090 */     // MIs[0] policy
     /* 1994090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1994103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994124 */     // GIR_Coverage, 62614,
     /* 1994124 */     GIR_EraseRootFromParent_Done,
     /* 1994125 */   // Label 26671: @1994125
     /* 1994125 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1994211), // Rule ID 62615 //
     /* 1994130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1994147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994176 */     // MIs[0] policy
     /* 1994176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1994189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994210 */     // GIR_Coverage, 62615,
     /* 1994210 */     GIR_EraseRootFromParent_Done,
     /* 1994211 */   // Label 26672: @1994211
     /* 1994211 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1994297), // Rule ID 62618 //
     /* 1994216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1994227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1994230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1994236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994262 */     // MIs[0] policy
     /* 1994262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1994275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994296 */     // GIR_Coverage, 62618,
     /* 1994296 */     GIR_EraseRootFromParent_Done,
     /* 1994297 */   // Label 26673: @1994297
     /* 1994297 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1994383), // Rule ID 62619 //
     /* 1994302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1994313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1994316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1994322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994348 */     // MIs[0] policy
     /* 1994348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1994361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994382 */     // GIR_Coverage, 62619,
     /* 1994382 */     GIR_EraseRootFromParent_Done,
     /* 1994383 */   // Label 26674: @1994383
     /* 1994383 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1994469), // Rule ID 62622 //
     /* 1994388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1994399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1994402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1994408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994434 */     // MIs[0] policy
     /* 1994434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1994447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994468 */     // GIR_Coverage, 62622,
     /* 1994468 */     GIR_EraseRootFromParent_Done,
     /* 1994469 */   // Label 26675: @1994469
     /* 1994469 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1994555), // Rule ID 62623 //
     /* 1994474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1994485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1994488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1994494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994520 */     // MIs[0] policy
     /* 1994520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1994533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994554 */     // GIR_Coverage, 62623,
     /* 1994554 */     GIR_EraseRootFromParent_Done,
     /* 1994555 */   // Label 26676: @1994555
     /* 1994555 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1994641), // Rule ID 62626 //
     /* 1994560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1994580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994606 */     // MIs[0] policy
     /* 1994606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1994619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994640 */     // GIR_Coverage, 62626,
     /* 1994640 */     GIR_EraseRootFromParent_Done,
     /* 1994641 */   // Label 26677: @1994641
     /* 1994641 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1994727), // Rule ID 62627 //
     /* 1994646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1994666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994692 */     // MIs[0] policy
     /* 1994692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1994705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994726 */     // GIR_Coverage, 62627,
     /* 1994726 */     GIR_EraseRootFromParent_Done,
     /* 1994727 */   // Label 26678: @1994727
     /* 1994727 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1994813), // Rule ID 62630 //
     /* 1994732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1994752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994778 */     // MIs[0] policy
     /* 1994778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1994791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994812 */     // GIR_Coverage, 62630,
     /* 1994812 */     GIR_EraseRootFromParent_Done,
     /* 1994813 */   // Label 26679: @1994813
     /* 1994813 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1994899), // Rule ID 62631 //
     /* 1994818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1994838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994864 */     // MIs[0] policy
     /* 1994864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1994877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994898 */     // GIR_Coverage, 62631,
     /* 1994898 */     GIR_EraseRootFromParent_Done,
     /* 1994899 */   // Label 26680: @1994899
     /* 1994899 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1994985), // Rule ID 62634 //
     /* 1994904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994950 */     // MIs[0] policy
     /* 1994950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1994963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994984 */     // GIR_Coverage, 62634,
     /* 1994984 */     GIR_EraseRootFromParent_Done,
     /* 1994985 */   // Label 26681: @1994985
     /* 1994985 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1995071), // Rule ID 62635 //
     /* 1994990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1994998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1995007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1995010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1995013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995036 */     // MIs[0] policy
     /* 1995036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1995049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995070 */     // GIR_Coverage, 62635,
     /* 1995070 */     GIR_EraseRootFromParent_Done,
     /* 1995071 */   // Label 26682: @1995071
     /* 1995071 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1995157), // Rule ID 62638 //
     /* 1995076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995122 */     // MIs[0] policy
     /* 1995122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1995135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995156 */     // GIR_Coverage, 62638,
     /* 1995156 */     GIR_EraseRootFromParent_Done,
     /* 1995157 */   // Label 26683: @1995157
     /* 1995157 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1995243), // Rule ID 62639 //
     /* 1995162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995208 */     // MIs[0] policy
     /* 1995208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1995221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995242 */     // GIR_Coverage, 62639,
     /* 1995242 */     GIR_EraseRootFromParent_Done,
     /* 1995243 */   // Label 26684: @1995243
     /* 1995243 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1995329), // Rule ID 62642 //
     /* 1995248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995294 */     // MIs[0] policy
     /* 1995294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1995307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995328 */     // GIR_Coverage, 62642,
     /* 1995328 */     GIR_EraseRootFromParent_Done,
     /* 1995329 */   // Label 26685: @1995329
     /* 1995329 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1995415), // Rule ID 62643 //
     /* 1995334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995380 */     // MIs[0] policy
     /* 1995380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1995393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995414 */     // GIR_Coverage, 62643,
     /* 1995414 */     GIR_EraseRootFromParent_Done,
     /* 1995415 */   // Label 26686: @1995415
     /* 1995415 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1995501), // Rule ID 62646 //
     /* 1995420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1995437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1995440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995466 */     // MIs[0] policy
     /* 1995466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1995479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995500 */     // GIR_Coverage, 62646,
     /* 1995500 */     GIR_EraseRootFromParent_Done,
     /* 1995501 */   // Label 26687: @1995501
     /* 1995501 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1995587), // Rule ID 62647 //
     /* 1995506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1995523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1995526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995552 */     // MIs[0] policy
     /* 1995552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1995565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995586 */     // GIR_Coverage, 62647,
     /* 1995586 */     GIR_EraseRootFromParent_Done,
     /* 1995587 */   // Label 26688: @1995587
     /* 1995587 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1995673), // Rule ID 62650 //
     /* 1995592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1995609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1995612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1995615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995638 */     // MIs[0] policy
     /* 1995638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1995651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995672 */     // GIR_Coverage, 62650,
     /* 1995672 */     GIR_EraseRootFromParent_Done,
     /* 1995673 */   // Label 26689: @1995673
     /* 1995673 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1995759), // Rule ID 62651 //
     /* 1995678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1995689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1995692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1995695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1995698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1995701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995724 */     // MIs[0] policy
     /* 1995724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1995737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995758 */     // GIR_Coverage, 62651,
     /* 1995758 */     GIR_EraseRootFromParent_Done,
     /* 1995759 */   // Label 26690: @1995759
     /* 1995759 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1995845), // Rule ID 62654 //
     /* 1995764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1995781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1995784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1995787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995810 */     // MIs[0] policy
     /* 1995810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1995823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995844 */     // GIR_Coverage, 62654,
     /* 1995844 */     GIR_EraseRootFromParent_Done,
     /* 1995845 */   // Label 26691: @1995845
     /* 1995845 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1995931), // Rule ID 62655 //
     /* 1995850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1995861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1995867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1995870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1995873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995896 */     // MIs[0] policy
     /* 1995896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1995909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995930 */     // GIR_Coverage, 62655,
     /* 1995930 */     GIR_EraseRootFromParent_Done,
     /* 1995931 */   // Label 26692: @1995931
     /* 1995931 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1996017), // Rule ID 62658 //
     /* 1995936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1995944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1995953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995982 */     // MIs[0] policy
     /* 1995982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1995995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996016 */     // GIR_Coverage, 62658,
     /* 1996016 */     GIR_EraseRootFromParent_Done,
     /* 1996017 */   // Label 26693: @1996017
     /* 1996017 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1996103), // Rule ID 62659 //
     /* 1996022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996068 */     // MIs[0] policy
     /* 1996068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1996081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996102 */     // GIR_Coverage, 62659,
     /* 1996102 */     GIR_EraseRootFromParent_Done,
     /* 1996103 */   // Label 26694: @1996103
     /* 1996103 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1996189), // Rule ID 62662 //
     /* 1996108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996154 */     // MIs[0] policy
     /* 1996154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1996167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996188 */     // GIR_Coverage, 62662,
     /* 1996188 */     GIR_EraseRootFromParent_Done,
     /* 1996189 */   // Label 26695: @1996189
     /* 1996189 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1996275), // Rule ID 62663 //
     /* 1996194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996240 */     // MIs[0] policy
     /* 1996240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1996253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996274 */     // GIR_Coverage, 62663,
     /* 1996274 */     GIR_EraseRootFromParent_Done,
     /* 1996275 */   // Label 26696: @1996275
     /* 1996275 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1996361), // Rule ID 62666 //
     /* 1996280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996326 */     // MIs[0] policy
     /* 1996326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1996339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996360 */     // GIR_Coverage, 62666,
     /* 1996360 */     GIR_EraseRootFromParent_Done,
     /* 1996361 */   // Label 26697: @1996361
     /* 1996361 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1996447), // Rule ID 62667 //
     /* 1996366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996412 */     // MIs[0] policy
     /* 1996412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1996425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996446 */     // GIR_Coverage, 62667,
     /* 1996446 */     GIR_EraseRootFromParent_Done,
     /* 1996447 */   // Label 26698: @1996447
     /* 1996447 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1996533), // Rule ID 62670 //
     /* 1996452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996498 */     // MIs[0] policy
     /* 1996498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1996511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996532 */     // GIR_Coverage, 62670,
     /* 1996532 */     GIR_EraseRootFromParent_Done,
     /* 1996533 */   // Label 26699: @1996533
     /* 1996533 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1996619), // Rule ID 62671 //
     /* 1996538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996584 */     // MIs[0] policy
     /* 1996584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1996597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996618 */     // GIR_Coverage, 62671,
     /* 1996618 */     GIR_EraseRootFromParent_Done,
     /* 1996619 */   // Label 26700: @1996619
     /* 1996619 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1996705), // Rule ID 62674 //
     /* 1996624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996670 */     // MIs[0] policy
     /* 1996670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1996683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996704 */     // GIR_Coverage, 62674,
     /* 1996704 */     GIR_EraseRootFromParent_Done,
     /* 1996705 */   // Label 26701: @1996705
     /* 1996705 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1996791), // Rule ID 62675 //
     /* 1996710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1996718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996756 */     // MIs[0] policy
     /* 1996756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1996769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996790 */     // GIR_Coverage, 62675,
     /* 1996790 */     GIR_EraseRootFromParent_Done,
     /* 1996791 */   // Label 26702: @1996791
     /* 1996791 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1996877), // Rule ID 62678 //
     /* 1996796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1996804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996842 */     // MIs[0] policy
     /* 1996842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996852 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1996855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996876 */     // GIR_Coverage, 62678,
     /* 1996876 */     GIR_EraseRootFromParent_Done,
     /* 1996877 */   // Label 26703: @1996877
     /* 1996877 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1996963), // Rule ID 62679 //
     /* 1996882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1996890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1996899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996928 */     // MIs[0] policy
     /* 1996928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1996941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996962 */     // GIR_Coverage, 62679,
     /* 1996962 */     GIR_EraseRootFromParent_Done,
     /* 1996963 */   // Label 26704: @1996963
     /* 1996963 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1997049), // Rule ID 62682 //
     /* 1996968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1996976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1996985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997014 */     // MIs[0] policy
     /* 1997014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1997027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997048 */     // GIR_Coverage, 62682,
     /* 1997048 */     GIR_EraseRootFromParent_Done,
     /* 1997049 */   // Label 26705: @1997049
     /* 1997049 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1997135), // Rule ID 62683 //
     /* 1997054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997100 */     // MIs[0] policy
     /* 1997100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1997113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997134 */     // GIR_Coverage, 62683,
     /* 1997134 */     GIR_EraseRootFromParent_Done,
     /* 1997135 */   // Label 26706: @1997135
     /* 1997135 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1997221), // Rule ID 62686 //
     /* 1997140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997186 */     // MIs[0] policy
     /* 1997186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1997199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997220 */     // GIR_Coverage, 62686,
     /* 1997220 */     GIR_EraseRootFromParent_Done,
     /* 1997221 */   // Label 26707: @1997221
     /* 1997221 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1997307), // Rule ID 62687 //
     /* 1997226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997272 */     // MIs[0] policy
     /* 1997272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1997285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997306 */     // GIR_Coverage, 62687,
     /* 1997306 */     GIR_EraseRootFromParent_Done,
     /* 1997307 */   // Label 26708: @1997307
     /* 1997307 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1997393), // Rule ID 62690 //
     /* 1997312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997358 */     // MIs[0] policy
     /* 1997358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1997371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997392 */     // GIR_Coverage, 62690,
     /* 1997392 */     GIR_EraseRootFromParent_Done,
     /* 1997393 */   // Label 26709: @1997393
     /* 1997393 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1997479), // Rule ID 62691 //
     /* 1997398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997444 */     // MIs[0] policy
     /* 1997444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997454 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1997457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997478 */     // GIR_Coverage, 62691,
     /* 1997478 */     GIR_EraseRootFromParent_Done,
     /* 1997479 */   // Label 26710: @1997479
     /* 1997479 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1997565), // Rule ID 62694 //
     /* 1997484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1997501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997530 */     // MIs[0] policy
     /* 1997530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997540 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1997543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997564 */     // GIR_Coverage, 62694,
     /* 1997564 */     GIR_EraseRootFromParent_Done,
     /* 1997565 */   // Label 26711: @1997565
     /* 1997565 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1997651), // Rule ID 62695 //
     /* 1997570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1997587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997616 */     // MIs[0] policy
     /* 1997616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1997629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997650 */     // GIR_Coverage, 62695,
     /* 1997650 */     GIR_EraseRootFromParent_Done,
     /* 1997651 */   // Label 26712: @1997651
     /* 1997651 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1997737), // Rule ID 62698 //
     /* 1997656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997702 */     // MIs[0] policy
     /* 1997702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1997715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997736 */     // GIR_Coverage, 62698,
     /* 1997736 */     GIR_EraseRootFromParent_Done,
     /* 1997737 */   // Label 26713: @1997737
     /* 1997737 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1997823), // Rule ID 62699 //
     /* 1997742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997788 */     // MIs[0] policy
     /* 1997788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1997801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997822 */     // GIR_Coverage, 62699,
     /* 1997822 */     GIR_EraseRootFromParent_Done,
     /* 1997823 */   // Label 26714: @1997823
     /* 1997823 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1997909), // Rule ID 62702 //
     /* 1997828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997874 */     // MIs[0] policy
     /* 1997874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1997887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997908 */     // GIR_Coverage, 62702,
     /* 1997908 */     GIR_EraseRootFromParent_Done,
     /* 1997909 */   // Label 26715: @1997909
     /* 1997909 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1997995), // Rule ID 62703 //
     /* 1997914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1997922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997960 */     // MIs[0] policy
     /* 1997960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1997973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997994 */     // GIR_Coverage, 62703,
     /* 1997994 */     GIR_EraseRootFromParent_Done,
     /* 1997995 */   // Label 26716: @1997995
     /* 1997995 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1998081), // Rule ID 62706 //
     /* 1998000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998046 */     // MIs[0] policy
     /* 1998046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1998059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998080 */     // GIR_Coverage, 62706,
     /* 1998080 */     GIR_EraseRootFromParent_Done,
     /* 1998081 */   // Label 26717: @1998081
     /* 1998081 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1998167), // Rule ID 62707 //
     /* 1998086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998132 */     // MIs[0] policy
     /* 1998132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1998145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998166 */     // GIR_Coverage, 62707,
     /* 1998166 */     GIR_EraseRootFromParent_Done,
     /* 1998167 */   // Label 26718: @1998167
     /* 1998167 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1998253), // Rule ID 62710 //
     /* 1998172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998218 */     // MIs[0] policy
     /* 1998218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1998231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998252 */     // GIR_Coverage, 62710,
     /* 1998252 */     GIR_EraseRootFromParent_Done,
     /* 1998253 */   // Label 26719: @1998253
     /* 1998253 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1998339), // Rule ID 62711 //
     /* 1998258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998304 */     // MIs[0] policy
     /* 1998304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1998317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998338 */     // GIR_Coverage, 62711,
     /* 1998338 */     GIR_EraseRootFromParent_Done,
     /* 1998339 */   // Label 26720: @1998339
     /* 1998339 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1998425), // Rule ID 62714 //
     /* 1998344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998390 */     // MIs[0] policy
     /* 1998390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1998403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998424 */     // GIR_Coverage, 62714,
     /* 1998424 */     GIR_EraseRootFromParent_Done,
     /* 1998425 */   // Label 26721: @1998425
     /* 1998425 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1998511), // Rule ID 62715 //
     /* 1998430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1998438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998476 */     // MIs[0] policy
     /* 1998476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1998489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998510 */     // GIR_Coverage, 62715,
     /* 1998510 */     GIR_EraseRootFromParent_Done,
     /* 1998511 */   // Label 26722: @1998511
     /* 1998511 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1998597), // Rule ID 62718 //
     /* 1998516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998562 */     // MIs[0] policy
     /* 1998562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1998575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998596 */     // GIR_Coverage, 62718,
     /* 1998596 */     GIR_EraseRootFromParent_Done,
     /* 1998597 */   // Label 26723: @1998597
     /* 1998597 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1998683), // Rule ID 62719 //
     /* 1998602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998648 */     // MIs[0] policy
     /* 1998648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1998661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998682 */     // GIR_Coverage, 62719,
     /* 1998682 */     GIR_EraseRootFromParent_Done,
     /* 1998683 */   // Label 26724: @1998683
     /* 1998683 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1998769), // Rule ID 62722 //
     /* 1998688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998734 */     // MIs[0] policy
     /* 1998734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1998747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998768 */     // GIR_Coverage, 62722,
     /* 1998768 */     GIR_EraseRootFromParent_Done,
     /* 1998769 */   // Label 26725: @1998769
     /* 1998769 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1998855), // Rule ID 62723 //
     /* 1998774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998820 */     // MIs[0] policy
     /* 1998820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1998833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998854 */     // GIR_Coverage, 62723,
     /* 1998854 */     GIR_EraseRootFromParent_Done,
     /* 1998855 */   // Label 26726: @1998855
     /* 1998855 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1998941), // Rule ID 62726 //
     /* 1998860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998906 */     // MIs[0] policy
     /* 1998906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1998919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998940 */     // GIR_Coverage, 62726,
     /* 1998940 */     GIR_EraseRootFromParent_Done,
     /* 1998941 */   // Label 26727: @1998941
     /* 1998941 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1999027), // Rule ID 62727 //
     /* 1998946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1998954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998992 */     // MIs[0] policy
     /* 1998992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1999005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999026 */     // GIR_Coverage, 62727,
     /* 1999026 */     GIR_EraseRootFromParent_Done,
     /* 1999027 */   // Label 26728: @1999027
     /* 1999027 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1999113), // Rule ID 62730 //
     /* 1999032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1999040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999078 */     // MIs[0] policy
     /* 1999078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1999091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999112 */     // GIR_Coverage, 62730,
     /* 1999112 */     GIR_EraseRootFromParent_Done,
     /* 1999113 */   // Label 26729: @1999113
     /* 1999113 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1999199), // Rule ID 62731 //
     /* 1999118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1999126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999164 */     // MIs[0] policy
     /* 1999164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1999177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999198 */     // GIR_Coverage, 62731,
     /* 1999198 */     GIR_EraseRootFromParent_Done,
     /* 1999199 */   // Label 26730: @1999199
     /* 1999199 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1999285), // Rule ID 62734 //
     /* 1999204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1999212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999250 */     // MIs[0] policy
     /* 1999250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1999263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999284 */     // GIR_Coverage, 62734,
     /* 1999284 */     GIR_EraseRootFromParent_Done,
     /* 1999285 */   // Label 26731: @1999285
     /* 1999285 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1999371), // Rule ID 62735 //
     /* 1999290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1999298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999336 */     // MIs[0] policy
     /* 1999336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1999349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999370 */     // GIR_Coverage, 62735,
     /* 1999370 */     GIR_EraseRootFromParent_Done,
     /* 1999371 */   // Label 26732: @1999371
     /* 1999371 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1999460), // Rule ID 2778 //
     /* 1999376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1999393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999422 */     // MIs[0] round
     /* 1999422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999432 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1999435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999459 */     // GIR_Coverage, 2778,
     /* 1999459 */     GIR_EraseRootFromParent_Done,
     /* 1999460 */   // Label 26733: @1999460
     /* 1999460 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1999549), // Rule ID 2779 //
     /* 1999465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1999482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999511 */     // MIs[0] round
     /* 1999511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999521 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1999524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999548 */     // GIR_Coverage, 2779,
     /* 1999548 */     GIR_EraseRootFromParent_Done,
     /* 1999549 */   // Label 26734: @1999549
     /* 1999549 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1999638), // Rule ID 22824 //
     /* 1999554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1999571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999600 */     // MIs[0] round
     /* 1999600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1999613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999637 */     // GIR_Coverage, 22824,
     /* 1999637 */     GIR_EraseRootFromParent_Done,
     /* 1999638 */   // Label 26735: @1999638
     /* 1999638 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1999727), // Rule ID 22825 //
     /* 1999643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1999660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999689 */     // MIs[0] round
     /* 1999689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999699 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1999702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999726 */     // GIR_Coverage, 22825,
     /* 1999726 */     GIR_EraseRootFromParent_Done,
     /* 1999727 */   // Label 26736: @1999727
     /* 1999727 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1999816), // Rule ID 22828 //
     /* 1999732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1999735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1999749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999778 */     // MIs[0] round
     /* 1999778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999788 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1999791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999815 */     // GIR_Coverage, 22828,
     /* 1999815 */     GIR_EraseRootFromParent_Done,
     /* 1999816 */   // Label 26737: @1999816
     /* 1999816 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1999905), // Rule ID 22829 //
     /* 1999821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1999824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1999838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1999844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999867 */     // MIs[0] round
     /* 1999867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999877 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1999880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999904 */     // GIR_Coverage, 22829,
     /* 1999904 */     GIR_EraseRootFromParent_Done,
     /* 1999905 */   // Label 26738: @1999905
     /* 1999905 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1999994), // Rule ID 22832 //
     /* 1999910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1999918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1999927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999956 */     // MIs[0] round
     /* 1999956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999966 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 1999969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999993 */     // GIR_Coverage, 22832,
     /* 1999993 */     GIR_EraseRootFromParent_Done,
     /* 1999994 */   // Label 26739: @1999994
     /* 1999994 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(2000083), // Rule ID 22833 //
     /* 1999999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2000016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000045 */     // MIs[0] round
     /* 2000045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000055 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2000058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000082 */     // GIR_Coverage, 22833,
     /* 2000082 */     GIR_EraseRootFromParent_Done,
     /* 2000083 */   // Label 26740: @2000083
     /* 2000083 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(2000172), // Rule ID 22836 //
     /* 2000088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2000091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2000105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000134 */     // MIs[0] round
     /* 2000134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2000147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000171 */     // GIR_Coverage, 22836,
     /* 2000171 */     GIR_EraseRootFromParent_Done,
     /* 2000172 */   // Label 26741: @2000172
     /* 2000172 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(2000261), // Rule ID 22837 //
     /* 2000177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2000180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2000194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000223 */     // MIs[0] round
     /* 2000223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000233 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2000236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000260 */     // GIR_Coverage, 22837,
     /* 2000260 */     GIR_EraseRootFromParent_Done,
     /* 2000261 */   // Label 26742: @2000261
     /* 2000261 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(2000350), // Rule ID 22840 //
     /* 2000266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2000269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2000283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000312 */     // MIs[0] round
     /* 2000312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2000325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000349 */     // GIR_Coverage, 22840,
     /* 2000349 */     GIR_EraseRootFromParent_Done,
     /* 2000350 */   // Label 26743: @2000350
     /* 2000350 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(2000439), // Rule ID 22841 //
     /* 2000355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2000358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2000372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000401 */     // MIs[0] round
     /* 2000401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000411 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2000414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000438 */     // GIR_Coverage, 22841,
     /* 2000438 */     GIR_EraseRootFromParent_Done,
     /* 2000439 */   // Label 26744: @2000439
     /* 2000439 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(2000528), // Rule ID 22844 //
     /* 2000444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2000461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000490 */     // MIs[0] round
     /* 2000490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000500 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2000503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000527 */     // GIR_Coverage, 22844,
     /* 2000527 */     GIR_EraseRootFromParent_Done,
     /* 2000528 */   // Label 26745: @2000528
     /* 2000528 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(2000617), // Rule ID 22845 //
     /* 2000533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2000550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000579 */     // MIs[0] round
     /* 2000579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000589 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2000592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000616 */     // GIR_Coverage, 22845,
     /* 2000616 */     GIR_EraseRootFromParent_Done,
     /* 2000617 */   // Label 26746: @2000617
     /* 2000617 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(2000706), // Rule ID 22848 //
     /* 2000622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2000639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000668 */     // MIs[0] round
     /* 2000668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000678 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2000681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000705 */     // GIR_Coverage, 22848,
     /* 2000705 */     GIR_EraseRootFromParent_Done,
     /* 2000706 */   // Label 26747: @2000706
     /* 2000706 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(2000795), // Rule ID 22849 //
     /* 2000711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2000728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000757 */     // MIs[0] round
     /* 2000757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000767 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2000770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000794 */     // GIR_Coverage, 22849,
     /* 2000794 */     GIR_EraseRootFromParent_Done,
     /* 2000795 */   // Label 26748: @2000795
     /* 2000795 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(2000884), // Rule ID 22852 //
     /* 2000800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2000817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000846 */     // MIs[0] round
     /* 2000846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000856 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2000859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000883 */     // GIR_Coverage, 22852,
     /* 2000883 */     GIR_EraseRootFromParent_Done,
     /* 2000884 */   // Label 26749: @2000884
     /* 2000884 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(2000973), // Rule ID 22853 //
     /* 2000889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2000900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2000903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2000906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2000909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000935 */     // MIs[0] round
     /* 2000935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000945 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2000948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000972 */     // GIR_Coverage, 22853,
     /* 2000972 */     GIR_EraseRootFromParent_Done,
     /* 2000973 */   // Label 26750: @2000973
     /* 2000973 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(2001062), // Rule ID 22856 //
     /* 2000978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2000981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2000986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2000995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001024 */     // MIs[0] round
     /* 2001024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2001037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001061 */     // GIR_Coverage, 22856,
     /* 2001061 */     GIR_EraseRootFromParent_Done,
     /* 2001062 */   // Label 26751: @2001062
     /* 2001062 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(2001151), // Rule ID 22857 //
     /* 2001067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2001084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001113 */     // MIs[0] round
     /* 2001113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001123 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2001126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001150 */     // GIR_Coverage, 22857,
     /* 2001150 */     GIR_EraseRootFromParent_Done,
     /* 2001151 */   // Label 26752: @2001151
     /* 2001151 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(2001240), // Rule ID 22860 //
     /* 2001156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2001173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001202 */     // MIs[0] round
     /* 2001202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001212 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2001215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001239 */     // GIR_Coverage, 22860,
     /* 2001239 */     GIR_EraseRootFromParent_Done,
     /* 2001240 */   // Label 26753: @2001240
     /* 2001240 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(2001329), // Rule ID 22861 //
     /* 2001245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2001262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001291 */     // MIs[0] round
     /* 2001291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001301 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2001304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001328 */     // GIR_Coverage, 22861,
     /* 2001328 */     GIR_EraseRootFromParent_Done,
     /* 2001329 */   // Label 26754: @2001329
     /* 2001329 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(2001418), // Rule ID 22864 //
     /* 2001334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2001351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001380 */     // MIs[0] round
     /* 2001380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001390 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2001393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001417 */     // GIR_Coverage, 22864,
     /* 2001417 */     GIR_EraseRootFromParent_Done,
     /* 2001418 */   // Label 26755: @2001418
     /* 2001418 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(2001507), // Rule ID 22865 //
     /* 2001423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2001440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001469 */     // MIs[0] round
     /* 2001469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001479 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2001482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001506 */     // GIR_Coverage, 22865,
     /* 2001506 */     GIR_EraseRootFromParent_Done,
     /* 2001507 */   // Label 26756: @2001507
     /* 2001507 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(2001596), // Rule ID 22868 //
     /* 2001512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2001515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2001529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001558 */     // MIs[0] round
     /* 2001558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001568 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2001571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001595 */     // GIR_Coverage, 22868,
     /* 2001595 */     GIR_EraseRootFromParent_Done,
     /* 2001596 */   // Label 26757: @2001596
     /* 2001596 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(2001685), // Rule ID 22869 //
     /* 2001601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2001604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2001618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001647 */     // MIs[0] round
     /* 2001647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001657 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2001660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001684 */     // GIR_Coverage, 22869,
     /* 2001684 */     GIR_EraseRootFromParent_Done,
     /* 2001685 */   // Label 26758: @2001685
     /* 2001685 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(2001774), // Rule ID 22872 //
     /* 2001690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2001693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2001707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001736 */     // MIs[0] round
     /* 2001736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001746 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2001749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001773 */     // GIR_Coverage, 22872,
     /* 2001773 */     GIR_EraseRootFromParent_Done,
     /* 2001774 */   // Label 26759: @2001774
     /* 2001774 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(2001863), // Rule ID 22873 //
     /* 2001779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2001782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2001796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001825 */     // MIs[0] round
     /* 2001825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001835 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2001838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001862 */     // GIR_Coverage, 22873,
     /* 2001862 */     GIR_EraseRootFromParent_Done,
     /* 2001863 */   // Label 26760: @2001863
     /* 2001863 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(2001952), // Rule ID 22876 //
     /* 2001868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2001871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2001885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001914 */     // MIs[0] round
     /* 2001914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2001927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2001947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001951 */     // GIR_Coverage, 22876,
     /* 2001951 */     GIR_EraseRootFromParent_Done,
     /* 2001952 */   // Label 26761: @2001952
     /* 2001952 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(2002041), // Rule ID 22877 //
     /* 2001957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2001960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2001965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2001974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002003 */     // MIs[0] round
     /* 2002003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002013 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2002016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002040 */     // GIR_Coverage, 22877,
     /* 2002040 */     GIR_EraseRootFromParent_Done,
     /* 2002041 */   // Label 26762: @2002041
     /* 2002041 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(2002130), // Rule ID 22880 //
     /* 2002046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002092 */     // MIs[0] round
     /* 2002092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2002105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002129 */     // GIR_Coverage, 22880,
     /* 2002129 */     GIR_EraseRootFromParent_Done,
     /* 2002130 */   // Label 26763: @2002130
     /* 2002130 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2002219), // Rule ID 22881 //
     /* 2002135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002181 */     // MIs[0] round
     /* 2002181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002191 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2002194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002218 */     // GIR_Coverage, 22881,
     /* 2002218 */     GIR_EraseRootFromParent_Done,
     /* 2002219 */   // Label 26764: @2002219
     /* 2002219 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2002308), // Rule ID 22884 //
     /* 2002224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002270 */     // MIs[0] round
     /* 2002270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2002283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002307 */     // GIR_Coverage, 22884,
     /* 2002307 */     GIR_EraseRootFromParent_Done,
     /* 2002308 */   // Label 26765: @2002308
     /* 2002308 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2002397), // Rule ID 22885 //
     /* 2002313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002359 */     // MIs[0] round
     /* 2002359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2002372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002396 */     // GIR_Coverage, 22885,
     /* 2002396 */     GIR_EraseRootFromParent_Done,
     /* 2002397 */   // Label 26766: @2002397
     /* 2002397 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2002486), // Rule ID 22888 //
     /* 2002402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002448 */     // MIs[0] round
     /* 2002448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002458 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2002461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002485 */     // GIR_Coverage, 22888,
     /* 2002485 */     GIR_EraseRootFromParent_Done,
     /* 2002486 */   // Label 26767: @2002486
     /* 2002486 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2002575), // Rule ID 22889 //
     /* 2002491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002537 */     // MIs[0] round
     /* 2002537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002547 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2002550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002574 */     // GIR_Coverage, 22889,
     /* 2002574 */     GIR_EraseRootFromParent_Done,
     /* 2002575 */   // Label 26768: @2002575
     /* 2002575 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2002664), // Rule ID 22892 //
     /* 2002580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002626 */     // MIs[0] round
     /* 2002626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002636 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2002639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002663 */     // GIR_Coverage, 22892,
     /* 2002663 */     GIR_EraseRootFromParent_Done,
     /* 2002664 */   // Label 26769: @2002664
     /* 2002664 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2002753), // Rule ID 22893 //
     /* 2002669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2002680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2002683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002715 */     // MIs[0] round
     /* 2002715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002725 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2002728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002752 */     // GIR_Coverage, 22893,
     /* 2002752 */     GIR_EraseRootFromParent_Done,
     /* 2002753 */   // Label 26770: @2002753
     /* 2002753 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2002842), // Rule ID 22896 //
     /* 2002758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2002775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002804 */     // MIs[0] round
     /* 2002804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2002817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002841 */     // GIR_Coverage, 22896,
     /* 2002841 */     GIR_EraseRootFromParent_Done,
     /* 2002842 */   // Label 26771: @2002842
     /* 2002842 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2002931), // Rule ID 22897 //
     /* 2002847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2002864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002893 */     // MIs[0] round
     /* 2002893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002903 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2002906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002930 */     // GIR_Coverage, 22897,
     /* 2002930 */     GIR_EraseRootFromParent_Done,
     /* 2002931 */   // Label 26772: @2002931
     /* 2002931 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2003020), // Rule ID 22900 //
     /* 2002936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2002939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2002944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2002953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002982 */     // MIs[0] round
     /* 2002982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002992 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2002995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003019 */     // GIR_Coverage, 22900,
     /* 2003019 */     GIR_EraseRootFromParent_Done,
     /* 2003020 */   // Label 26773: @2003020
     /* 2003020 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2003109), // Rule ID 22901 //
     /* 2003025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2003028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2003042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003071 */     // MIs[0] round
     /* 2003071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003081 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2003084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003108 */     // GIR_Coverage, 22901,
     /* 2003108 */     GIR_EraseRootFromParent_Done,
     /* 2003109 */   // Label 26774: @2003109
     /* 2003109 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2003198), // Rule ID 22904 //
     /* 2003114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003160 */     // MIs[0] round
     /* 2003160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003170 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2003173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003197 */     // GIR_Coverage, 22904,
     /* 2003197 */     GIR_EraseRootFromParent_Done,
     /* 2003198 */   // Label 26775: @2003198
     /* 2003198 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2003287), // Rule ID 22905 //
     /* 2003203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003249 */     // MIs[0] round
     /* 2003249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003259 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2003262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003286 */     // GIR_Coverage, 22905,
     /* 2003286 */     GIR_EraseRootFromParent_Done,
     /* 2003287 */   // Label 26776: @2003287
     /* 2003287 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2003376), // Rule ID 22908 //
     /* 2003292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003338 */     // MIs[0] round
     /* 2003338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003348 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2003351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003375 */     // GIR_Coverage, 22908,
     /* 2003375 */     GIR_EraseRootFromParent_Done,
     /* 2003376 */   // Label 26777: @2003376
     /* 2003376 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2003465), // Rule ID 22909 //
     /* 2003381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003427 */     // MIs[0] round
     /* 2003427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003437 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2003440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003464 */     // GIR_Coverage, 22909,
     /* 2003464 */     GIR_EraseRootFromParent_Done,
     /* 2003465 */   // Label 26778: @2003465
     /* 2003465 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2003554), // Rule ID 22912 //
     /* 2003470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003516 */     // MIs[0] round
     /* 2003516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003526 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2003529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003553 */     // GIR_Coverage, 22912,
     /* 2003553 */     GIR_EraseRootFromParent_Done,
     /* 2003554 */   // Label 26779: @2003554
     /* 2003554 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2003643), // Rule ID 22913 //
     /* 2003559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2003570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2003573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2003579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003605 */     // MIs[0] round
     /* 2003605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003615 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2003618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003642 */     // GIR_Coverage, 22913,
     /* 2003642 */     GIR_EraseRootFromParent_Done,
     /* 2003643 */   // Label 26780: @2003643
     /* 2003643 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2003732), // Rule ID 22916 //
     /* 2003648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003694 */     // MIs[0] round
     /* 2003694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2003707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003731 */     // GIR_Coverage, 22916,
     /* 2003731 */     GIR_EraseRootFromParent_Done,
     /* 2003732 */   // Label 26781: @2003732
     /* 2003732 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2003821), // Rule ID 22917 //
     /* 2003737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003783 */     // MIs[0] round
     /* 2003783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003793 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2003796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003820 */     // GIR_Coverage, 22917,
     /* 2003820 */     GIR_EraseRootFromParent_Done,
     /* 2003821 */   // Label 26782: @2003821
     /* 2003821 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2003910), // Rule ID 22920 //
     /* 2003826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2003843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003872 */     // MIs[0] round
     /* 2003872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003882 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2003885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003909 */     // GIR_Coverage, 22920,
     /* 2003909 */     GIR_EraseRootFromParent_Done,
     /* 2003910 */   // Label 26783: @2003910
     /* 2003910 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2003999), // Rule ID 22921 //
     /* 2003915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2003923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2003932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003961 */     // MIs[0] round
     /* 2003961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003971 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2003974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003998 */     // GIR_Coverage, 22921,
     /* 2003998 */     GIR_EraseRootFromParent_Done,
     /* 2003999 */   // Label 26784: @2003999
     /* 2003999 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2004088), // Rule ID 22924 //
     /* 2004004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2004007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2004024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004050 */     // MIs[0] round
     /* 2004050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004060 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2004063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004087 */     // GIR_Coverage, 22924,
     /* 2004087 */     GIR_EraseRootFromParent_Done,
     /* 2004088 */   // Label 26785: @2004088
     /* 2004088 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2004177), // Rule ID 22925 //
     /* 2004093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2004096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2004113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004139 */     // MIs[0] round
     /* 2004139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2004152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004176 */     // GIR_Coverage, 22925,
     /* 2004176 */     GIR_EraseRootFromParent_Done,
     /* 2004177 */   // Label 26786: @2004177
     /* 2004177 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2004266), // Rule ID 22928 //
     /* 2004182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2004199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004228 */     // MIs[0] round
     /* 2004228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004238 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2004241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004265 */     // GIR_Coverage, 22928,
     /* 2004265 */     GIR_EraseRootFromParent_Done,
     /* 2004266 */   // Label 26787: @2004266
     /* 2004266 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2004355), // Rule ID 22929 //
     /* 2004271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2004288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004317 */     // MIs[0] round
     /* 2004317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004327 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2004330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004354 */     // GIR_Coverage, 22929,
     /* 2004354 */     GIR_EraseRootFromParent_Done,
     /* 2004355 */   // Label 26788: @2004355
     /* 2004355 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2004444), // Rule ID 22932 //
     /* 2004360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2004377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004406 */     // MIs[0] round
     /* 2004406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2004419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004443 */     // GIR_Coverage, 22932,
     /* 2004443 */     GIR_EraseRootFromParent_Done,
     /* 2004444 */   // Label 26789: @2004444
     /* 2004444 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2004533), // Rule ID 22933 //
     /* 2004449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2004466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004495 */     // MIs[0] round
     /* 2004495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004505 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2004508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004532 */     // GIR_Coverage, 22933,
     /* 2004532 */     GIR_EraseRootFromParent_Done,
     /* 2004533 */   // Label 26790: @2004533
     /* 2004533 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2004622), // Rule ID 22936 //
     /* 2004538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2004541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2004555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004584 */     // MIs[0] round
     /* 2004584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004594 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2004597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004621 */     // GIR_Coverage, 22936,
     /* 2004621 */     GIR_EraseRootFromParent_Done,
     /* 2004622 */   // Label 26791: @2004622
     /* 2004622 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2004711), // Rule ID 22937 //
     /* 2004627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2004630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2004635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2004644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004673 */     // MIs[0] round
     /* 2004673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004683 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2004686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004710 */     // GIR_Coverage, 22937,
     /* 2004710 */     GIR_EraseRootFromParent_Done,
     /* 2004711 */   // Label 26792: @2004711
     /* 2004711 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2004800), // Rule ID 23060 //
     /* 2004716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2004719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2004724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2004733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2004736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004762 */     // MIs[0] round
     /* 2004762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004772 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2004775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2004795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004799 */     // GIR_Coverage, 23060,
     /* 2004799 */     GIR_EraseRootFromParent_Done,
     /* 2004800 */   // Label 26793: @2004800
     /* 2004800 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2004889), // Rule ID 23061 //
     /* 2004805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2004808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2004813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2004822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2004825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004851 */     // MIs[0] round
     /* 2004851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004861 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2004864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2004884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004888 */     // GIR_Coverage, 23061,
     /* 2004888 */     GIR_EraseRootFromParent_Done,
     /* 2004889 */   // Label 26794: @2004889
     /* 2004889 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2004978), // Rule ID 23064 //
     /* 2004894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2004897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2004902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2004911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2004914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004940 */     // MIs[0] round
     /* 2004940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2004953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2004973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004977 */     // GIR_Coverage, 23064,
     /* 2004977 */     GIR_EraseRootFromParent_Done,
     /* 2004978 */   // Label 26795: @2004978
     /* 2004978 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2005067), // Rule ID 23065 //
     /* 2004983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2004986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2004991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2005000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005029 */     // MIs[0] round
     /* 2005029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005039 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2005042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005066 */     // GIR_Coverage, 23065,
     /* 2005066 */     GIR_EraseRootFromParent_Done,
     /* 2005067 */   // Label 26796: @2005067
     /* 2005067 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2005156), // Rule ID 23068 //
     /* 2005072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2005075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2005092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005118 */     // MIs[0] round
     /* 2005118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005128 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2005128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2005131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005155 */     // GIR_Coverage, 23068,
     /* 2005155 */     GIR_EraseRootFromParent_Done,
     /* 2005156 */   // Label 26797: @2005156
     /* 2005156 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2005245), // Rule ID 23069 //
     /* 2005161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2005164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2005181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005207 */     // MIs[0] round
     /* 2005207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005217 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2005220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005244 */     // GIR_Coverage, 23069,
     /* 2005244 */     GIR_EraseRootFromParent_Done,
     /* 2005245 */   // Label 26798: @2005245
     /* 2005245 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2005334), // Rule ID 23072 //
     /* 2005250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005296 */     // MIs[0] round
     /* 2005296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005306 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2005306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2005309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005333 */     // GIR_Coverage, 23072,
     /* 2005333 */     GIR_EraseRootFromParent_Done,
     /* 2005334 */   // Label 26799: @2005334
     /* 2005334 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2005423), // Rule ID 23073 //
     /* 2005339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005385 */     // MIs[0] round
     /* 2005385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005395 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2005398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005422 */     // GIR_Coverage, 23073,
     /* 2005422 */     GIR_EraseRootFromParent_Done,
     /* 2005423 */   // Label 26800: @2005423
     /* 2005423 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2005512), // Rule ID 23076 //
     /* 2005428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2005431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2005445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2005448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005474 */     // MIs[0] round
     /* 2005474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2005484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2005487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005511 */     // GIR_Coverage, 23076,
     /* 2005511 */     GIR_EraseRootFromParent_Done,
     /* 2005512 */   // Label 26801: @2005512
     /* 2005512 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2005601), // Rule ID 23077 //
     /* 2005517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2005520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2005534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2005537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005563 */     // MIs[0] round
     /* 2005563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005573 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2005576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005600 */     // GIR_Coverage, 23077,
     /* 2005600 */     GIR_EraseRootFromParent_Done,
     /* 2005601 */   // Label 26802: @2005601
     /* 2005601 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2005690), // Rule ID 23080 //
     /* 2005606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005652 */     // MIs[0] round
     /* 2005652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2005662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2005665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005689 */     // GIR_Coverage, 23080,
     /* 2005689 */     GIR_EraseRootFromParent_Done,
     /* 2005690 */   // Label 26803: @2005690
     /* 2005690 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2005779), // Rule ID 23081 //
     /* 2005695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005741 */     // MIs[0] round
     /* 2005741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005751 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2005754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005778 */     // GIR_Coverage, 23081,
     /* 2005778 */     GIR_EraseRootFromParent_Done,
     /* 2005779 */   // Label 26804: @2005779
     /* 2005779 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2005868), // Rule ID 23084 //
     /* 2005784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2005801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005830 */     // MIs[0] round
     /* 2005830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005840 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2005840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2005843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005867 */     // GIR_Coverage, 23084,
     /* 2005867 */     GIR_EraseRootFromParent_Done,
     /* 2005868 */   // Label 26805: @2005868
     /* 2005868 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2005957), // Rule ID 23085 //
     /* 2005873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2005876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2005890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005919 */     // MIs[0] round
     /* 2005919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005929 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2005929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2005932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2005955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005956 */     // GIR_Coverage, 23085,
     /* 2005956 */     GIR_EraseRootFromParent_Done,
     /* 2005957 */   // Label 26806: @2005957
     /* 2005957 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2006046), // Rule ID 23088 //
     /* 2005962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2005965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2005970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2005979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2005982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2005985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006008 */     // MIs[0] round
     /* 2006008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006018 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2006021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006045 */     // GIR_Coverage, 23088,
     /* 2006045 */     GIR_EraseRootFromParent_Done,
     /* 2006046 */   // Label 26807: @2006046
     /* 2006046 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2006135), // Rule ID 23089 //
     /* 2006051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2006074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006097 */     // MIs[0] round
     /* 2006097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006107 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2006110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006134 */     // GIR_Coverage, 23089,
     /* 2006134 */     GIR_EraseRootFromParent_Done,
     /* 2006135 */   // Label 26808: @2006135
     /* 2006135 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2006224), // Rule ID 23092 //
     /* 2006140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2006157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006186 */     // MIs[0] round
     /* 2006186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2006199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006223 */     // GIR_Coverage, 23092,
     /* 2006223 */     GIR_EraseRootFromParent_Done,
     /* 2006224 */   // Label 26809: @2006224
     /* 2006224 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2006313), // Rule ID 23093 //
     /* 2006229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2006246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006275 */     // MIs[0] round
     /* 2006275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006285 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2006288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006312 */     // GIR_Coverage, 23093,
     /* 2006312 */     GIR_EraseRootFromParent_Done,
     /* 2006313 */   // Label 26810: @2006313
     /* 2006313 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2006402), // Rule ID 23096 //
     /* 2006318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2006335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006364 */     // MIs[0] round
     /* 2006364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2006377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006401 */     // GIR_Coverage, 23096,
     /* 2006401 */     GIR_EraseRootFromParent_Done,
     /* 2006402 */   // Label 26811: @2006402
     /* 2006402 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2006491), // Rule ID 23097 //
     /* 2006407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2006424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006453 */     // MIs[0] round
     /* 2006453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006463 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2006466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006490 */     // GIR_Coverage, 23097,
     /* 2006490 */     GIR_EraseRootFromParent_Done,
     /* 2006491 */   // Label 26812: @2006491
     /* 2006491 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2006580), // Rule ID 23100 //
     /* 2006496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2006513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006542 */     // MIs[0] round
     /* 2006542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006552 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2006555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006579 */     // GIR_Coverage, 23100,
     /* 2006579 */     GIR_EraseRootFromParent_Done,
     /* 2006580 */   // Label 26813: @2006580
     /* 2006580 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2006669), // Rule ID 23101 //
     /* 2006585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2006593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2006602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2006605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006631 */     // MIs[0] round
     /* 2006631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006641 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2006644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006668 */     // GIR_Coverage, 23101,
     /* 2006668 */     GIR_EraseRootFromParent_Done,
     /* 2006669 */   // Label 26814: @2006669
     /* 2006669 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2006758), // Rule ID 23104 //
     /* 2006674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2006682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006720 */     // MIs[0] round
     /* 2006720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006730 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2006733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006757 */     // GIR_Coverage, 23104,
     /* 2006757 */     GIR_EraseRootFromParent_Done,
     /* 2006758 */   // Label 26815: @2006758
     /* 2006758 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2006847), // Rule ID 23105 //
     /* 2006763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2006771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006809 */     // MIs[0] round
     /* 2006809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006819 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2006822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006846 */     // GIR_Coverage, 23105,
     /* 2006846 */     GIR_EraseRootFromParent_Done,
     /* 2006847 */   // Label 26816: @2006847
     /* 2006847 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2006936), // Rule ID 23108 //
     /* 2006852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2006860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006898 */     // MIs[0] round
     /* 2006898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2006911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006935 */     // GIR_Coverage, 23108,
     /* 2006935 */     GIR_EraseRootFromParent_Done,
     /* 2006936 */   // Label 26817: @2006936
     /* 2006936 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2007025), // Rule ID 23109 //
     /* 2006941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2006949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006987 */     // MIs[0] round
     /* 2006987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006997 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2007000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007024 */     // GIR_Coverage, 23109,
     /* 2007024 */     GIR_EraseRootFromParent_Done,
     /* 2007025 */   // Label 26818: @2007025
     /* 2007025 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2007114), // Rule ID 23112 //
     /* 2007030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007076 */     // MIs[0] round
     /* 2007076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007086 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2007089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007113 */     // GIR_Coverage, 23112,
     /* 2007113 */     GIR_EraseRootFromParent_Done,
     /* 2007114 */   // Label 26819: @2007114
     /* 2007114 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2007203), // Rule ID 23113 //
     /* 2007119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2007136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007165 */     // MIs[0] round
     /* 2007165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007175 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2007178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007202 */     // GIR_Coverage, 23113,
     /* 2007202 */     GIR_EraseRootFromParent_Done,
     /* 2007203 */   // Label 26820: @2007203
     /* 2007203 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2007292), // Rule ID 23116 //
     /* 2007208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007254 */     // MIs[0] round
     /* 2007254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2007267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007291 */     // GIR_Coverage, 23116,
     /* 2007291 */     GIR_EraseRootFromParent_Done,
     /* 2007292 */   // Label 26821: @2007292
     /* 2007292 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2007381), // Rule ID 23117 //
     /* 2007297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2007314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007343 */     // MIs[0] round
     /* 2007343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007353 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2007356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007380 */     // GIR_Coverage, 23117,
     /* 2007380 */     GIR_EraseRootFromParent_Done,
     /* 2007381 */   // Label 26822: @2007381
     /* 2007381 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2007470), // Rule ID 23120 //
     /* 2007386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007432 */     // MIs[0] round
     /* 2007432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007442 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2007445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007469 */     // GIR_Coverage, 23120,
     /* 2007469 */     GIR_EraseRootFromParent_Done,
     /* 2007470 */   // Label 26823: @2007470
     /* 2007470 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2007559), // Rule ID 23121 //
     /* 2007475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007521 */     // MIs[0] round
     /* 2007521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007531 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2007534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007558 */     // GIR_Coverage, 23121,
     /* 2007558 */     GIR_EraseRootFromParent_Done,
     /* 2007559 */   // Label 26824: @2007559
     /* 2007559 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2007648), // Rule ID 23124 //
     /* 2007564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007610 */     // MIs[0] round
     /* 2007610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2007623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007647 */     // GIR_Coverage, 23124,
     /* 2007647 */     GIR_EraseRootFromParent_Done,
     /* 2007648 */   // Label 26825: @2007648
     /* 2007648 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2007737), // Rule ID 23125 //
     /* 2007653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007699 */     // MIs[0] round
     /* 2007699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007709 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2007712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007736 */     // GIR_Coverage, 23125,
     /* 2007736 */     GIR_EraseRootFromParent_Done,
     /* 2007737 */   // Label 26826: @2007737
     /* 2007737 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2007826), // Rule ID 23128 //
     /* 2007742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007788 */     // MIs[0] round
     /* 2007788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007798 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2007801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007825 */     // GIR_Coverage, 23128,
     /* 2007825 */     GIR_EraseRootFromParent_Done,
     /* 2007826 */   // Label 26827: @2007826
     /* 2007826 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2007915), // Rule ID 23129 //
     /* 2007831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007877 */     // MIs[0] round
     /* 2007877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007887 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2007890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007914 */     // GIR_Coverage, 23129,
     /* 2007914 */     GIR_EraseRootFromParent_Done,
     /* 2007915 */   // Label 26828: @2007915
     /* 2007915 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2008004), // Rule ID 23132 //
     /* 2007920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2007928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007966 */     // MIs[0] round
     /* 2007966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2007979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008003 */     // GIR_Coverage, 23132,
     /* 2008003 */     GIR_EraseRootFromParent_Done,
     /* 2008004 */   // Label 26829: @2008004
     /* 2008004 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2008093), // Rule ID 23133 //
     /* 2008009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2008012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2008026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2008032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008055 */     // MIs[0] round
     /* 2008055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008065 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2008068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2008088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008092 */     // GIR_Coverage, 23133,
     /* 2008092 */     GIR_EraseRootFromParent_Done,
     /* 2008093 */   // Label 26830: @2008093
     /* 2008093 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2008182), // Rule ID 23136 //
     /* 2008098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008144 */     // MIs[0] round
     /* 2008144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008154 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2008157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008181 */     // GIR_Coverage, 23136,
     /* 2008181 */     GIR_EraseRootFromParent_Done,
     /* 2008182 */   // Label 26831: @2008182
     /* 2008182 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2008271), // Rule ID 23137 //
     /* 2008187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2008204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008233 */     // MIs[0] round
     /* 2008233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008243 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2008246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008270 */     // GIR_Coverage, 23137,
     /* 2008270 */     GIR_EraseRootFromParent_Done,
     /* 2008271 */   // Label 26832: @2008271
     /* 2008271 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2008360), // Rule ID 23140 //
     /* 2008276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008322 */     // MIs[0] round
     /* 2008322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008332 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2008335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008359 */     // GIR_Coverage, 23140,
     /* 2008359 */     GIR_EraseRootFromParent_Done,
     /* 2008360 */   // Label 26833: @2008360
     /* 2008360 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2008449), // Rule ID 23141 //
     /* 2008365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008411 */     // MIs[0] round
     /* 2008411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008421 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2008424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008448 */     // GIR_Coverage, 23141,
     /* 2008448 */     GIR_EraseRootFromParent_Done,
     /* 2008449 */   // Label 26834: @2008449
     /* 2008449 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2008538), // Rule ID 23144 //
     /* 2008454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008500 */     // MIs[0] round
     /* 2008500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2008513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008537 */     // GIR_Coverage, 23144,
     /* 2008537 */     GIR_EraseRootFromParent_Done,
     /* 2008538 */   // Label 26835: @2008538
     /* 2008538 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2008627), // Rule ID 23145 //
     /* 2008543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2008551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008589 */     // MIs[0] round
     /* 2008589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008599 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2008602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008626 */     // GIR_Coverage, 23145,
     /* 2008626 */     GIR_EraseRootFromParent_Done,
     /* 2008627 */   // Label 26836: @2008627
     /* 2008627 */   GIM_Reject,
     /* 2008628 */ // Label 19834: @2008628
     /* 2008628 */ GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2196929),
     /* 2008633 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2008636 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2008738), // Rule ID 15980 //
     /* 2008641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2008652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2008655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2008658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008691 */     // MIs[1] Operand 1
     /* 2008691 */     // No operand predicates
     /* 2008691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008695 */     // MIs[0] round
     /* 2008695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008698 */     // MIs[0] policy
     /* 2008698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008710 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2008713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2008734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008737 */     // GIR_Coverage, 15980,
     /* 2008737 */     GIR_EraseRootFromParent_Done,
     /* 2008738 */   // Label 26838: @2008738
     /* 2008738 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2008840), // Rule ID 15981 //
     /* 2008743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2008754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2008757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2008760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008793 */     // MIs[1] Operand 1
     /* 2008793 */     // No operand predicates
     /* 2008793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008797 */     // MIs[0] round
     /* 2008797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008800 */     // MIs[0] policy
     /* 2008800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2008815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2008836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008839 */     // GIR_Coverage, 15981,
     /* 2008839 */     GIR_EraseRootFromParent_Done,
     /* 2008840 */   // Label 26839: @2008840
     /* 2008840 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2008942), // Rule ID 15984 //
     /* 2008845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2008856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2008859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2008862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008895 */     // MIs[1] Operand 1
     /* 2008895 */     // No operand predicates
     /* 2008895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008899 */     // MIs[0] round
     /* 2008899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008902 */     // MIs[0] policy
     /* 2008902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2008917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2008938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008941 */     // GIR_Coverage, 15984,
     /* 2008941 */     GIR_EraseRootFromParent_Done,
     /* 2008942 */   // Label 26840: @2008942
     /* 2008942 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2009044), // Rule ID 15985 //
     /* 2008947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2008958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2008961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2008964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008997 */     // MIs[1] Operand 1
     /* 2008997 */     // No operand predicates
     /* 2008997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009001 */     // MIs[0] round
     /* 2009001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009004 */     // MIs[0] policy
     /* 2009004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009016 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2009019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009043 */     // GIR_Coverage, 15985,
     /* 2009043 */     GIR_EraseRootFromParent_Done,
     /* 2009044 */   // Label 26841: @2009044
     /* 2009044 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2009146), // Rule ID 15988 //
     /* 2009049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2009060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2009063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2009066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009099 */     // MIs[1] Operand 1
     /* 2009099 */     // No operand predicates
     /* 2009099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009103 */     // MIs[0] round
     /* 2009103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009106 */     // MIs[0] policy
     /* 2009106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009145 */     // GIR_Coverage, 15988,
     /* 2009145 */     GIR_EraseRootFromParent_Done,
     /* 2009146 */   // Label 26842: @2009146
     /* 2009146 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2009248), // Rule ID 15989 //
     /* 2009151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2009162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2009165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2009168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009201 */     // MIs[1] Operand 1
     /* 2009201 */     // No operand predicates
     /* 2009201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009205 */     // MIs[0] round
     /* 2009205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009208 */     // MIs[0] policy
     /* 2009208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009220 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009247 */     // GIR_Coverage, 15989,
     /* 2009247 */     GIR_EraseRootFromParent_Done,
     /* 2009248 */   // Label 26843: @2009248
     /* 2009248 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2009350), // Rule ID 15992 //
     /* 2009253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2009264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2009267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009303 */     // MIs[1] Operand 1
     /* 2009303 */     // No operand predicates
     /* 2009303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009307 */     // MIs[0] round
     /* 2009307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009310 */     // MIs[0] policy
     /* 2009310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2009325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009349 */     // GIR_Coverage, 15992,
     /* 2009349 */     GIR_EraseRootFromParent_Done,
     /* 2009350 */   // Label 26844: @2009350
     /* 2009350 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2009452), // Rule ID 15993 //
     /* 2009355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2009366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2009369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009405 */     // MIs[1] Operand 1
     /* 2009405 */     // No operand predicates
     /* 2009405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009409 */     // MIs[0] round
     /* 2009409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009412 */     // MIs[0] policy
     /* 2009412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2009427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009451 */     // GIR_Coverage, 15993,
     /* 2009451 */     GIR_EraseRootFromParent_Done,
     /* 2009452 */   // Label 26845: @2009452
     /* 2009452 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2009554), // Rule ID 15996 //
     /* 2009457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2009468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2009471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009507 */     // MIs[1] Operand 1
     /* 2009507 */     // No operand predicates
     /* 2009507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009511 */     // MIs[0] round
     /* 2009511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009514 */     // MIs[0] policy
     /* 2009514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009526 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009553 */     // GIR_Coverage, 15996,
     /* 2009553 */     GIR_EraseRootFromParent_Done,
     /* 2009554 */   // Label 26846: @2009554
     /* 2009554 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2009656), // Rule ID 15997 //
     /* 2009559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2009570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2009573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009609 */     // MIs[1] Operand 1
     /* 2009609 */     // No operand predicates
     /* 2009609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009613 */     // MIs[0] round
     /* 2009613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009616 */     // MIs[0] policy
     /* 2009616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009655 */     // GIR_Coverage, 15997,
     /* 2009655 */     GIR_EraseRootFromParent_Done,
     /* 2009656 */   // Label 26847: @2009656
     /* 2009656 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2009758), // Rule ID 16000 //
     /* 2009661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2009672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2009675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009711 */     // MIs[1] Operand 1
     /* 2009711 */     // No operand predicates
     /* 2009711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009715 */     // MIs[0] round
     /* 2009715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009718 */     // MIs[0] policy
     /* 2009718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009730 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009757 */     // GIR_Coverage, 16000,
     /* 2009757 */     GIR_EraseRootFromParent_Done,
     /* 2009758 */   // Label 26848: @2009758
     /* 2009758 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2009860), // Rule ID 16001 //
     /* 2009763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2009774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2009777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009813 */     // MIs[1] Operand 1
     /* 2009813 */     // No operand predicates
     /* 2009813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009817 */     // MIs[0] round
     /* 2009817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009820 */     // MIs[0] policy
     /* 2009820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2009835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009859 */     // GIR_Coverage, 16001,
     /* 2009859 */     GIR_EraseRootFromParent_Done,
     /* 2009860 */   // Label 26849: @2009860
     /* 2009860 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2009962), // Rule ID 16004 //
     /* 2009865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2009876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2009879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2009882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009915 */     // MIs[1] Operand 1
     /* 2009915 */     // No operand predicates
     /* 2009915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009919 */     // MIs[0] round
     /* 2009919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009922 */     // MIs[0] policy
     /* 2009922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2009937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009961 */     // GIR_Coverage, 16004,
     /* 2009961 */     GIR_EraseRootFromParent_Done,
     /* 2009962 */   // Label 26850: @2009962
     /* 2009962 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2010064), // Rule ID 16005 //
     /* 2009967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2009975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2009978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2009981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2009984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2009990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010017 */     // MIs[1] Operand 1
     /* 2010017 */     // No operand predicates
     /* 2010017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010021 */     // MIs[0] round
     /* 2010021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010024 */     // MIs[0] policy
     /* 2010024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010063 */     // GIR_Coverage, 16005,
     /* 2010063 */     GIR_EraseRootFromParent_Done,
     /* 2010064 */   // Label 26851: @2010064
     /* 2010064 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2010166), // Rule ID 16008 //
     /* 2010069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010119 */     // MIs[1] Operand 1
     /* 2010119 */     // No operand predicates
     /* 2010119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010123 */     // MIs[0] round
     /* 2010123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010126 */     // MIs[0] policy
     /* 2010126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010165 */     // GIR_Coverage, 16008,
     /* 2010165 */     GIR_EraseRootFromParent_Done,
     /* 2010166 */   // Label 26852: @2010166
     /* 2010166 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2010268), // Rule ID 16009 //
     /* 2010171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010221 */     // MIs[1] Operand 1
     /* 2010221 */     // No operand predicates
     /* 2010221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010225 */     // MIs[0] round
     /* 2010225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010228 */     // MIs[0] policy
     /* 2010228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010267 */     // GIR_Coverage, 16009,
     /* 2010267 */     GIR_EraseRootFromParent_Done,
     /* 2010268 */   // Label 26853: @2010268
     /* 2010268 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2010370), // Rule ID 16012 //
     /* 2010273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010323 */     // MIs[1] Operand 1
     /* 2010323 */     // No operand predicates
     /* 2010323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010327 */     // MIs[0] round
     /* 2010327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010330 */     // MIs[0] policy
     /* 2010330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010369 */     // GIR_Coverage, 16012,
     /* 2010369 */     GIR_EraseRootFromParent_Done,
     /* 2010370 */   // Label 26854: @2010370
     /* 2010370 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2010472), // Rule ID 16013 //
     /* 2010375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010425 */     // MIs[1] Operand 1
     /* 2010425 */     // No operand predicates
     /* 2010425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010429 */     // MIs[0] round
     /* 2010429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010432 */     // MIs[0] policy
     /* 2010432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010471 */     // GIR_Coverage, 16013,
     /* 2010471 */     GIR_EraseRootFromParent_Done,
     /* 2010472 */   // Label 26855: @2010472
     /* 2010472 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2010574), // Rule ID 16016 //
     /* 2010477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2010480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010527 */     // MIs[1] Operand 1
     /* 2010527 */     // No operand predicates
     /* 2010527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010531 */     // MIs[0] round
     /* 2010531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010534 */     // MIs[0] policy
     /* 2010534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010573 */     // GIR_Coverage, 16016,
     /* 2010573 */     GIR_EraseRootFromParent_Done,
     /* 2010574 */   // Label 26856: @2010574
     /* 2010574 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2010676), // Rule ID 16017 //
     /* 2010579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2010582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010629 */     // MIs[1] Operand 1
     /* 2010629 */     // No operand predicates
     /* 2010629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010633 */     // MIs[0] round
     /* 2010633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010636 */     // MIs[0] policy
     /* 2010636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010648 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2010651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010675 */     // GIR_Coverage, 16017,
     /* 2010675 */     GIR_EraseRootFromParent_Done,
     /* 2010676 */   // Label 26857: @2010676
     /* 2010676 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2010778), // Rule ID 16020 //
     /* 2010681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2010692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2010695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2010698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010731 */     // MIs[1] Operand 1
     /* 2010731 */     // No operand predicates
     /* 2010731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010735 */     // MIs[0] round
     /* 2010735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010738 */     // MIs[0] policy
     /* 2010738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2010753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010777 */     // GIR_Coverage, 16020,
     /* 2010777 */     GIR_EraseRootFromParent_Done,
     /* 2010778 */   // Label 26858: @2010778
     /* 2010778 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2010880), // Rule ID 16021 //
     /* 2010783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2010794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2010797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2010800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010833 */     // MIs[1] Operand 1
     /* 2010833 */     // No operand predicates
     /* 2010833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010837 */     // MIs[0] round
     /* 2010837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010840 */     // MIs[0] policy
     /* 2010840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2010855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010879 */     // GIR_Coverage, 16021,
     /* 2010879 */     GIR_EraseRootFromParent_Done,
     /* 2010880 */   // Label 26859: @2010880
     /* 2010880 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2010982), // Rule ID 16024 //
     /* 2010885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2010896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2010899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2010902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2010915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010935 */     // MIs[1] Operand 1
     /* 2010935 */     // No operand predicates
     /* 2010935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010939 */     // MIs[0] round
     /* 2010939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010942 */     // MIs[0] policy
     /* 2010942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2010957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010981 */     // GIR_Coverage, 16024,
     /* 2010981 */     GIR_EraseRootFromParent_Done,
     /* 2010982 */   // Label 26860: @2010982
     /* 2010982 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2011084), // Rule ID 16025 //
     /* 2010987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2010995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2010998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2011001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2011004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011037 */     // MIs[1] Operand 1
     /* 2011037 */     // No operand predicates
     /* 2011037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011041 */     // MIs[0] round
     /* 2011041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011044 */     // MIs[0] policy
     /* 2011044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2011059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011083 */     // GIR_Coverage, 16025,
     /* 2011083 */     GIR_EraseRootFromParent_Done,
     /* 2011084 */   // Label 26861: @2011084
     /* 2011084 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2011186), // Rule ID 16028 //
     /* 2011089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2011100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2011103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2011106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2011112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011139 */     // MIs[1] Operand 1
     /* 2011139 */     // No operand predicates
     /* 2011139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011143 */     // MIs[0] round
     /* 2011143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011146 */     // MIs[0] policy
     /* 2011146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2011161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011185 */     // GIR_Coverage, 16028,
     /* 2011185 */     GIR_EraseRootFromParent_Done,
     /* 2011186 */   // Label 26862: @2011186
     /* 2011186 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2011288), // Rule ID 16029 //
     /* 2011191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2011202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2011205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2011208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2011214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011241 */     // MIs[1] Operand 1
     /* 2011241 */     // No operand predicates
     /* 2011241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011245 */     // MIs[0] round
     /* 2011245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011248 */     // MIs[0] policy
     /* 2011248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2011263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011287 */     // GIR_Coverage, 16029,
     /* 2011287 */     GIR_EraseRootFromParent_Done,
     /* 2011288 */   // Label 26863: @2011288
     /* 2011288 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2011390), // Rule ID 16032 //
     /* 2011293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2011304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2011307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011343 */     // MIs[1] Operand 1
     /* 2011343 */     // No operand predicates
     /* 2011343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011347 */     // MIs[0] round
     /* 2011347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011350 */     // MIs[0] policy
     /* 2011350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2011365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011389 */     // GIR_Coverage, 16032,
     /* 2011389 */     GIR_EraseRootFromParent_Done,
     /* 2011390 */   // Label 26864: @2011390
     /* 2011390 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2011492), // Rule ID 16033 //
     /* 2011395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2011406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2011409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011445 */     // MIs[1] Operand 1
     /* 2011445 */     // No operand predicates
     /* 2011445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011449 */     // MIs[0] round
     /* 2011449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011452 */     // MIs[0] policy
     /* 2011452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2011467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011491 */     // GIR_Coverage, 16033,
     /* 2011491 */     GIR_EraseRootFromParent_Done,
     /* 2011492 */   // Label 26865: @2011492
     /* 2011492 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2011594), // Rule ID 16036 //
     /* 2011497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2011508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2011511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011547 */     // MIs[1] Operand 1
     /* 2011547 */     // No operand predicates
     /* 2011547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011551 */     // MIs[0] round
     /* 2011551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011554 */     // MIs[0] policy
     /* 2011554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2011569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011593 */     // GIR_Coverage, 16036,
     /* 2011593 */     GIR_EraseRootFromParent_Done,
     /* 2011594 */   // Label 26866: @2011594
     /* 2011594 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2011696), // Rule ID 16037 //
     /* 2011599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2011610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2011613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011649 */     // MIs[1] Operand 1
     /* 2011649 */     // No operand predicates
     /* 2011649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011653 */     // MIs[0] round
     /* 2011653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011656 */     // MIs[0] policy
     /* 2011656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011668 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2011671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011695 */     // GIR_Coverage, 16037,
     /* 2011695 */     GIR_EraseRootFromParent_Done,
     /* 2011696 */   // Label 26867: @2011696
     /* 2011696 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2011798), // Rule ID 16040 //
     /* 2011701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2011712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2011715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011751 */     // MIs[1] Operand 1
     /* 2011751 */     // No operand predicates
     /* 2011751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011755 */     // MIs[0] round
     /* 2011755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011758 */     // MIs[0] policy
     /* 2011758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2011773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011797 */     // GIR_Coverage, 16040,
     /* 2011797 */     GIR_EraseRootFromParent_Done,
     /* 2011798 */   // Label 26868: @2011798
     /* 2011798 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2011900), // Rule ID 16041 //
     /* 2011803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2011814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2011817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011853 */     // MIs[1] Operand 1
     /* 2011853 */     // No operand predicates
     /* 2011853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011857 */     // MIs[0] round
     /* 2011857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011860 */     // MIs[0] policy
     /* 2011860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2011875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011899 */     // GIR_Coverage, 16041,
     /* 2011899 */     GIR_EraseRootFromParent_Done,
     /* 2011900 */   // Label 26869: @2011900
     /* 2011900 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2012002), // Rule ID 16044 //
     /* 2011905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2011913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2011916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2011919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2011922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011955 */     // MIs[1] Operand 1
     /* 2011955 */     // No operand predicates
     /* 2011955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011959 */     // MIs[0] round
     /* 2011959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011962 */     // MIs[0] policy
     /* 2011962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2011977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012001 */     // GIR_Coverage, 16044,
     /* 2012001 */     GIR_EraseRootFromParent_Done,
     /* 2012002 */   // Label 26870: @2012002
     /* 2012002 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2012104), // Rule ID 16045 //
     /* 2012007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2012018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2012021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2012024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012057 */     // MIs[1] Operand 1
     /* 2012057 */     // No operand predicates
     /* 2012057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012061 */     // MIs[0] round
     /* 2012061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012064 */     // MIs[0] policy
     /* 2012064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2012079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012103 */     // GIR_Coverage, 16045,
     /* 2012103 */     GIR_EraseRootFromParent_Done,
     /* 2012104 */   // Label 26871: @2012104
     /* 2012104 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2012206), // Rule ID 16048 //
     /* 2012109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2012112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2012126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012159 */     // MIs[1] Operand 1
     /* 2012159 */     // No operand predicates
     /* 2012159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012163 */     // MIs[0] round
     /* 2012163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012166 */     // MIs[0] policy
     /* 2012166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2012181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012205 */     // GIR_Coverage, 16048,
     /* 2012205 */     GIR_EraseRootFromParent_Done,
     /* 2012206 */   // Label 26872: @2012206
     /* 2012206 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2012308), // Rule ID 16049 //
     /* 2012211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2012228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012261 */     // MIs[1] Operand 1
     /* 2012261 */     // No operand predicates
     /* 2012261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012265 */     // MIs[0] round
     /* 2012265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012268 */     // MIs[0] policy
     /* 2012268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2012283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012307 */     // GIR_Coverage, 16049,
     /* 2012307 */     GIR_EraseRootFromParent_Done,
     /* 2012308 */   // Label 26873: @2012308
     /* 2012308 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2012410), // Rule ID 16052 //
     /* 2012313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2012316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012363 */     // MIs[1] Operand 1
     /* 2012363 */     // No operand predicates
     /* 2012363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012367 */     // MIs[0] round
     /* 2012367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012370 */     // MIs[0] policy
     /* 2012370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012382 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2012385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012409 */     // GIR_Coverage, 16052,
     /* 2012409 */     GIR_EraseRootFromParent_Done,
     /* 2012410 */   // Label 26874: @2012410
     /* 2012410 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2012512), // Rule ID 16053 //
     /* 2012415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012465 */     // MIs[1] Operand 1
     /* 2012465 */     // No operand predicates
     /* 2012465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012469 */     // MIs[0] round
     /* 2012469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012472 */     // MIs[0] policy
     /* 2012472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012484 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2012487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012511 */     // GIR_Coverage, 16053,
     /* 2012511 */     GIR_EraseRootFromParent_Done,
     /* 2012512 */   // Label 26875: @2012512
     /* 2012512 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2012614), // Rule ID 16056 //
     /* 2012517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2012520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2012528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2012531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012567 */     // MIs[1] Operand 1
     /* 2012567 */     // No operand predicates
     /* 2012567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012571 */     // MIs[0] round
     /* 2012571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012574 */     // MIs[0] policy
     /* 2012574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2012589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012613 */     // GIR_Coverage, 16056,
     /* 2012613 */     GIR_EraseRootFromParent_Done,
     /* 2012614 */   // Label 26876: @2012614
     /* 2012614 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2012716), // Rule ID 16057 //
     /* 2012619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2012622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2012630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2012633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012669 */     // MIs[1] Operand 1
     /* 2012669 */     // No operand predicates
     /* 2012669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012673 */     // MIs[0] round
     /* 2012673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012676 */     // MIs[0] policy
     /* 2012676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2012691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012715 */     // GIR_Coverage, 16057,
     /* 2012715 */     GIR_EraseRootFromParent_Done,
     /* 2012716 */   // Label 26877: @2012716
     /* 2012716 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2012818), // Rule ID 16060 //
     /* 2012721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2012724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2012732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2012735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012771 */     // MIs[1] Operand 1
     /* 2012771 */     // No operand predicates
     /* 2012771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012775 */     // MIs[0] round
     /* 2012775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012778 */     // MIs[0] policy
     /* 2012778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2012793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012817 */     // GIR_Coverage, 16060,
     /* 2012817 */     GIR_EraseRootFromParent_Done,
     /* 2012818 */   // Label 26878: @2012818
     /* 2012818 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2012920), // Rule ID 16061 //
     /* 2012823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2012826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2012834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2012837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012873 */     // MIs[1] Operand 1
     /* 2012873 */     // No operand predicates
     /* 2012873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012877 */     // MIs[0] round
     /* 2012877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012880 */     // MIs[0] policy
     /* 2012880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2012895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012919 */     // GIR_Coverage, 16061,
     /* 2012919 */     GIR_EraseRootFromParent_Done,
     /* 2012920 */   // Label 26879: @2012920
     /* 2012920 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2013022), // Rule ID 16064 //
     /* 2012925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2012928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2012933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2012936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2012939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2012942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012975 */     // MIs[1] Operand 1
     /* 2012975 */     // No operand predicates
     /* 2012975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012979 */     // MIs[0] round
     /* 2012979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012982 */     // MIs[0] policy
     /* 2012982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2012997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013021 */     // GIR_Coverage, 16064,
     /* 2013021 */     GIR_EraseRootFromParent_Done,
     /* 2013022 */   // Label 26880: @2013022
     /* 2013022 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2013124), // Rule ID 16065 //
     /* 2013027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2013030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2013035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2013038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2013041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2013044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2013057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013077 */     // MIs[1] Operand 1
     /* 2013077 */     // No operand predicates
     /* 2013077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013081 */     // MIs[0] round
     /* 2013081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013084 */     // MIs[0] policy
     /* 2013084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2013099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013123 */     // GIR_Coverage, 16065,
     /* 2013123 */     GIR_EraseRootFromParent_Done,
     /* 2013124 */   // Label 26881: @2013124
     /* 2013124 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2013226), // Rule ID 16244 //
     /* 2013129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2013140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2013143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2013146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013179 */     // MIs[1] Operand 1
     /* 2013179 */     // No operand predicates
     /* 2013179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013183 */     // MIs[0] round
     /* 2013183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013186 */     // MIs[0] policy
     /* 2013186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2013201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013225 */     // GIR_Coverage, 16244,
     /* 2013225 */     GIR_EraseRootFromParent_Done,
     /* 2013226 */   // Label 26882: @2013226
     /* 2013226 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2013328), // Rule ID 16245 //
     /* 2013231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2013242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2013245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2013248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013281 */     // MIs[1] Operand 1
     /* 2013281 */     // No operand predicates
     /* 2013281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013285 */     // MIs[0] round
     /* 2013285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013288 */     // MIs[0] policy
     /* 2013288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013300 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2013303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013327 */     // GIR_Coverage, 16245,
     /* 2013327 */     GIR_EraseRootFromParent_Done,
     /* 2013328 */   // Label 26883: @2013328
     /* 2013328 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2013430), // Rule ID 16248 //
     /* 2013333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2013344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2013347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2013350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013383 */     // MIs[1] Operand 1
     /* 2013383 */     // No operand predicates
     /* 2013383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013387 */     // MIs[0] round
     /* 2013387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013390 */     // MIs[0] policy
     /* 2013390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2013405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013429 */     // GIR_Coverage, 16248,
     /* 2013429 */     GIR_EraseRootFromParent_Done,
     /* 2013430 */   // Label 26884: @2013430
     /* 2013430 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2013532), // Rule ID 16249 //
     /* 2013435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2013446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2013449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2013452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013485 */     // MIs[1] Operand 1
     /* 2013485 */     // No operand predicates
     /* 2013485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013489 */     // MIs[0] round
     /* 2013489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013492 */     // MIs[0] policy
     /* 2013492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013504 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2013507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013531 */     // GIR_Coverage, 16249,
     /* 2013531 */     GIR_EraseRootFromParent_Done,
     /* 2013532 */   // Label 26885: @2013532
     /* 2013532 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2013634), // Rule ID 16252 //
     /* 2013537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2013548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2013551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2013554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013587 */     // MIs[1] Operand 1
     /* 2013587 */     // No operand predicates
     /* 2013587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013591 */     // MIs[0] round
     /* 2013591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013594 */     // MIs[0] policy
     /* 2013594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2013609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013633 */     // GIR_Coverage, 16252,
     /* 2013633 */     GIR_EraseRootFromParent_Done,
     /* 2013634 */   // Label 26886: @2013634
     /* 2013634 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2013736), // Rule ID 16253 //
     /* 2013639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2013650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2013653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2013656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013689 */     // MIs[1] Operand 1
     /* 2013689 */     // No operand predicates
     /* 2013689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013693 */     // MIs[0] round
     /* 2013693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013696 */     // MIs[0] policy
     /* 2013696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2013711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013735 */     // GIR_Coverage, 16253,
     /* 2013735 */     GIR_EraseRootFromParent_Done,
     /* 2013736 */   // Label 26887: @2013736
     /* 2013736 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2013838), // Rule ID 16256 //
     /* 2013741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2013752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2013755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013791 */     // MIs[1] Operand 1
     /* 2013791 */     // No operand predicates
     /* 2013791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013795 */     // MIs[0] round
     /* 2013795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013798 */     // MIs[0] policy
     /* 2013798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2013813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013837 */     // GIR_Coverage, 16256,
     /* 2013837 */     GIR_EraseRootFromParent_Done,
     /* 2013838 */   // Label 26888: @2013838
     /* 2013838 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2013940), // Rule ID 16257 //
     /* 2013843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2013854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2013857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013893 */     // MIs[1] Operand 1
     /* 2013893 */     // No operand predicates
     /* 2013893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013897 */     // MIs[0] round
     /* 2013897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013900 */     // MIs[0] policy
     /* 2013900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2013915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013939 */     // GIR_Coverage, 16257,
     /* 2013939 */     GIR_EraseRootFromParent_Done,
     /* 2013940 */   // Label 26889: @2013940
     /* 2013940 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2014042), // Rule ID 16260 //
     /* 2013945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2013956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2013959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013995 */     // MIs[1] Operand 1
     /* 2013995 */     // No operand predicates
     /* 2013995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013999 */     // MIs[0] round
     /* 2013999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014002 */     // MIs[0] policy
     /* 2014002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2014017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014041 */     // GIR_Coverage, 16260,
     /* 2014041 */     GIR_EraseRootFromParent_Done,
     /* 2014042 */   // Label 26890: @2014042
     /* 2014042 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2014144), // Rule ID 16261 //
     /* 2014047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2014058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2014061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2014064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014097 */     // MIs[1] Operand 1
     /* 2014097 */     // No operand predicates
     /* 2014097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014101 */     // MIs[0] round
     /* 2014101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014104 */     // MIs[0] policy
     /* 2014104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2014119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014143 */     // GIR_Coverage, 16261,
     /* 2014143 */     GIR_EraseRootFromParent_Done,
     /* 2014144 */   // Label 26891: @2014144
     /* 2014144 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2014246), // Rule ID 16264 //
     /* 2014149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2014160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2014163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014199 */     // MIs[1] Operand 1
     /* 2014199 */     // No operand predicates
     /* 2014199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014203 */     // MIs[0] round
     /* 2014203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014206 */     // MIs[0] policy
     /* 2014206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2014221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014245 */     // GIR_Coverage, 16264,
     /* 2014245 */     GIR_EraseRootFromParent_Done,
     /* 2014246 */   // Label 26892: @2014246
     /* 2014246 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2014348), // Rule ID 16265 //
     /* 2014251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2014262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2014265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014301 */     // MIs[1] Operand 1
     /* 2014301 */     // No operand predicates
     /* 2014301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014305 */     // MIs[0] round
     /* 2014305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014308 */     // MIs[0] policy
     /* 2014308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2014323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014347 */     // GIR_Coverage, 16265,
     /* 2014347 */     GIR_EraseRootFromParent_Done,
     /* 2014348 */   // Label 26893: @2014348
     /* 2014348 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2014450), // Rule ID 16268 //
     /* 2014353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2014364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2014367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2014370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014403 */     // MIs[1] Operand 1
     /* 2014403 */     // No operand predicates
     /* 2014403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014407 */     // MIs[0] round
     /* 2014407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014410 */     // MIs[0] policy
     /* 2014410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014449 */     // GIR_Coverage, 16268,
     /* 2014449 */     GIR_EraseRootFromParent_Done,
     /* 2014450 */   // Label 26894: @2014450
     /* 2014450 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2014552), // Rule ID 16269 //
     /* 2014455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2014466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2014469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2014472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014505 */     // MIs[1] Operand 1
     /* 2014505 */     // No operand predicates
     /* 2014505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014509 */     // MIs[0] round
     /* 2014509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014512 */     // MIs[0] policy
     /* 2014512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014551 */     // GIR_Coverage, 16269,
     /* 2014551 */     GIR_EraseRootFromParent_Done,
     /* 2014552 */   // Label 26895: @2014552
     /* 2014552 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2014654), // Rule ID 16272 //
     /* 2014557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014607 */     // MIs[1] Operand 1
     /* 2014607 */     // No operand predicates
     /* 2014607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014611 */     // MIs[0] round
     /* 2014611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014614 */     // MIs[0] policy
     /* 2014614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014653 */     // GIR_Coverage, 16272,
     /* 2014653 */     GIR_EraseRootFromParent_Done,
     /* 2014654 */   // Label 26896: @2014654
     /* 2014654 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2014756), // Rule ID 16273 //
     /* 2014659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014709 */     // MIs[1] Operand 1
     /* 2014709 */     // No operand predicates
     /* 2014709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014713 */     // MIs[0] round
     /* 2014713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014716 */     // MIs[0] policy
     /* 2014716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014755 */     // GIR_Coverage, 16273,
     /* 2014755 */     GIR_EraseRootFromParent_Done,
     /* 2014756 */   // Label 26897: @2014756
     /* 2014756 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2014858), // Rule ID 16276 //
     /* 2014761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014811 */     // MIs[1] Operand 1
     /* 2014811 */     // No operand predicates
     /* 2014811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014815 */     // MIs[0] round
     /* 2014815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014818 */     // MIs[0] policy
     /* 2014818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014857 */     // GIR_Coverage, 16276,
     /* 2014857 */     GIR_EraseRootFromParent_Done,
     /* 2014858 */   // Label 26898: @2014858
     /* 2014858 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2014960), // Rule ID 16277 //
     /* 2014863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014913 */     // MIs[1] Operand 1
     /* 2014913 */     // No operand predicates
     /* 2014913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014917 */     // MIs[0] round
     /* 2014917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014920 */     // MIs[0] policy
     /* 2014920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2014935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014959 */     // GIR_Coverage, 16277,
     /* 2014959 */     GIR_EraseRootFromParent_Done,
     /* 2014960 */   // Label 26899: @2014960
     /* 2014960 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2015062), // Rule ID 16280 //
     /* 2014965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2014968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2014973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2014982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015015 */     // MIs[1] Operand 1
     /* 2015015 */     // No operand predicates
     /* 2015015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015019 */     // MIs[0] round
     /* 2015019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015022 */     // MIs[0] policy
     /* 2015022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2015037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015061 */     // GIR_Coverage, 16280,
     /* 2015061 */     GIR_EraseRootFromParent_Done,
     /* 2015062 */   // Label 26900: @2015062
     /* 2015062 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2015164), // Rule ID 16281 //
     /* 2015067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2015070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2015084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015117 */     // MIs[1] Operand 1
     /* 2015117 */     // No operand predicates
     /* 2015117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015121 */     // MIs[0] round
     /* 2015121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015124 */     // MIs[0] policy
     /* 2015124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2015139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2015160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015163 */     // GIR_Coverage, 16281,
     /* 2015163 */     GIR_EraseRootFromParent_Done,
     /* 2015164 */   // Label 26901: @2015164
     /* 2015164 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2015266), // Rule ID 16284 //
     /* 2015169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2015180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2015183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2015186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015219 */     // MIs[1] Operand 1
     /* 2015219 */     // No operand predicates
     /* 2015219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015223 */     // MIs[0] round
     /* 2015223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015226 */     // MIs[0] policy
     /* 2015226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015238 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2015241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015265 */     // GIR_Coverage, 16284,
     /* 2015265 */     GIR_EraseRootFromParent_Done,
     /* 2015266 */   // Label 26902: @2015266
     /* 2015266 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2015368), // Rule ID 16285 //
     /* 2015271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2015282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2015285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2015288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015321 */     // MIs[1] Operand 1
     /* 2015321 */     // No operand predicates
     /* 2015321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015325 */     // MIs[0] round
     /* 2015325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015328 */     // MIs[0] policy
     /* 2015328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2015343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015367 */     // GIR_Coverage, 16285,
     /* 2015367 */     GIR_EraseRootFromParent_Done,
     /* 2015368 */   // Label 26903: @2015368
     /* 2015368 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2015470), // Rule ID 16288 //
     /* 2015373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2015384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2015387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2015390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015423 */     // MIs[1] Operand 1
     /* 2015423 */     // No operand predicates
     /* 2015423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015427 */     // MIs[0] round
     /* 2015427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015430 */     // MIs[0] policy
     /* 2015430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2015445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015469 */     // GIR_Coverage, 16288,
     /* 2015469 */     GIR_EraseRootFromParent_Done,
     /* 2015470 */   // Label 26904: @2015470
     /* 2015470 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2015572), // Rule ID 16289 //
     /* 2015475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2015486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2015489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2015492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2015498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015525 */     // MIs[1] Operand 1
     /* 2015525 */     // No operand predicates
     /* 2015525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015529 */     // MIs[0] round
     /* 2015529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015532 */     // MIs[0] policy
     /* 2015532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015544 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2015547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015571 */     // GIR_Coverage, 16289,
     /* 2015571 */     GIR_EraseRootFromParent_Done,
     /* 2015572 */   // Label 26905: @2015572
     /* 2015572 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2015674), // Rule ID 16292 //
     /* 2015577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2015588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2015591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2015594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2015600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2015607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015627 */     // MIs[1] Operand 1
     /* 2015627 */     // No operand predicates
     /* 2015627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015631 */     // MIs[0] round
     /* 2015631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015634 */     // MIs[0] policy
     /* 2015634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015646 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2015649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015673 */     // GIR_Coverage, 16292,
     /* 2015673 */     GIR_EraseRootFromParent_Done,
     /* 2015674 */   // Label 26906: @2015674
     /* 2015674 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2015776), // Rule ID 16293 //
     /* 2015679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2015690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2015693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2015696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2015702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2015709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015729 */     // MIs[1] Operand 1
     /* 2015729 */     // No operand predicates
     /* 2015729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015733 */     // MIs[0] round
     /* 2015733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015736 */     // MIs[0] policy
     /* 2015736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015748 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2015751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015775 */     // GIR_Coverage, 16293,
     /* 2015775 */     GIR_EraseRootFromParent_Done,
     /* 2015776 */   // Label 26907: @2015776
     /* 2015776 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2015878), // Rule ID 16296 //
     /* 2015781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2015792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2015795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015831 */     // MIs[1] Operand 1
     /* 2015831 */     // No operand predicates
     /* 2015831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015835 */     // MIs[0] round
     /* 2015835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015838 */     // MIs[0] policy
     /* 2015838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2015853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015877 */     // GIR_Coverage, 16296,
     /* 2015877 */     GIR_EraseRootFromParent_Done,
     /* 2015878 */   // Label 26908: @2015878
     /* 2015878 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2015980), // Rule ID 16297 //
     /* 2015883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2015894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2015897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2015900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015933 */     // MIs[1] Operand 1
     /* 2015933 */     // No operand predicates
     /* 2015933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015937 */     // MIs[0] round
     /* 2015937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015940 */     // MIs[0] policy
     /* 2015940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2015955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015979 */     // GIR_Coverage, 16297,
     /* 2015979 */     GIR_EraseRootFromParent_Done,
     /* 2015980 */   // Label 26909: @2015980
     /* 2015980 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2016082), // Rule ID 16300 //
     /* 2015985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2015993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2015996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2015999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016035 */     // MIs[1] Operand 1
     /* 2016035 */     // No operand predicates
     /* 2016035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016039 */     // MIs[0] round
     /* 2016039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016042 */     // MIs[0] policy
     /* 2016042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2016057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016081 */     // GIR_Coverage, 16300,
     /* 2016081 */     GIR_EraseRootFromParent_Done,
     /* 2016082 */   // Label 26910: @2016082
     /* 2016082 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2016184), // Rule ID 16301 //
     /* 2016087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2016098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2016101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2016104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016137 */     // MIs[1] Operand 1
     /* 2016137 */     // No operand predicates
     /* 2016137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016141 */     // MIs[0] round
     /* 2016141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016144 */     // MIs[0] policy
     /* 2016144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016156 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2016159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016183 */     // GIR_Coverage, 16301,
     /* 2016183 */     GIR_EraseRootFromParent_Done,
     /* 2016184 */   // Label 26911: @2016184
     /* 2016184 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2016286), // Rule ID 16304 //
     /* 2016189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2016200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2016203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2016206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2016212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016239 */     // MIs[1] Operand 1
     /* 2016239 */     // No operand predicates
     /* 2016239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016243 */     // MIs[0] round
     /* 2016243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016246 */     // MIs[0] policy
     /* 2016246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2016261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016285 */     // GIR_Coverage, 16304,
     /* 2016285 */     GIR_EraseRootFromParent_Done,
     /* 2016286 */   // Label 26912: @2016286
     /* 2016286 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2016388), // Rule ID 16305 //
     /* 2016291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2016302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2016305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2016308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2016314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016341 */     // MIs[1] Operand 1
     /* 2016341 */     // No operand predicates
     /* 2016341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016345 */     // MIs[0] round
     /* 2016345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016348 */     // MIs[0] policy
     /* 2016348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2016363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016387 */     // GIR_Coverage, 16305,
     /* 2016387 */     GIR_EraseRootFromParent_Done,
     /* 2016388 */   // Label 26913: @2016388
     /* 2016388 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2016490), // Rule ID 16308 //
     /* 2016393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2016404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2016407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016443 */     // MIs[1] Operand 1
     /* 2016443 */     // No operand predicates
     /* 2016443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016447 */     // MIs[0] round
     /* 2016447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016450 */     // MIs[0] policy
     /* 2016450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016462 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2016465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016489 */     // GIR_Coverage, 16308,
     /* 2016489 */     GIR_EraseRootFromParent_Done,
     /* 2016490 */   // Label 26914: @2016490
     /* 2016490 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2016592), // Rule ID 16309 //
     /* 2016495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2016506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2016509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2016512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016545 */     // MIs[1] Operand 1
     /* 2016545 */     // No operand predicates
     /* 2016545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016549 */     // MIs[0] round
     /* 2016549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016552 */     // MIs[0] policy
     /* 2016552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2016567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016591 */     // GIR_Coverage, 16309,
     /* 2016591 */     GIR_EraseRootFromParent_Done,
     /* 2016592 */   // Label 26915: @2016592
     /* 2016592 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2016694), // Rule ID 16312 //
     /* 2016597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2016608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2016611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2016614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016647 */     // MIs[1] Operand 1
     /* 2016647 */     // No operand predicates
     /* 2016647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016651 */     // MIs[0] round
     /* 2016651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016654 */     // MIs[0] policy
     /* 2016654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2016669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016693 */     // GIR_Coverage, 16312,
     /* 2016693 */     GIR_EraseRootFromParent_Done,
     /* 2016694 */   // Label 26916: @2016694
     /* 2016694 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2016796), // Rule ID 16313 //
     /* 2016699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2016710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2016713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2016716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016749 */     // MIs[1] Operand 1
     /* 2016749 */     // No operand predicates
     /* 2016749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016753 */     // MIs[0] round
     /* 2016753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016756 */     // MIs[0] policy
     /* 2016756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2016771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016795 */     // GIR_Coverage, 16313,
     /* 2016795 */     GIR_EraseRootFromParent_Done,
     /* 2016796 */   // Label 26917: @2016796
     /* 2016796 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2016898), // Rule ID 16316 //
     /* 2016801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2016812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2016815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2016818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016851 */     // MIs[1] Operand 1
     /* 2016851 */     // No operand predicates
     /* 2016851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016855 */     // MIs[0] round
     /* 2016855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016858 */     // MIs[0] policy
     /* 2016858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2016873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016897 */     // GIR_Coverage, 16316,
     /* 2016897 */     GIR_EraseRootFromParent_Done,
     /* 2016898 */   // Label 26918: @2016898
     /* 2016898 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2017000), // Rule ID 16317 //
     /* 2016903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2016911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2016914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2016917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2016920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2016926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2016933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016953 */     // MIs[1] Operand 1
     /* 2016953 */     // No operand predicates
     /* 2016953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016957 */     // MIs[0] round
     /* 2016957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016960 */     // MIs[0] policy
     /* 2016960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2016975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016999 */     // GIR_Coverage, 16317,
     /* 2016999 */     GIR_EraseRootFromParent_Done,
     /* 2017000 */   // Label 26919: @2017000
     /* 2017000 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2017102), // Rule ID 16320 //
     /* 2017005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2017016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2017019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2017022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017055 */     // MIs[1] Operand 1
     /* 2017055 */     // No operand predicates
     /* 2017055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017059 */     // MIs[0] round
     /* 2017059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017062 */     // MIs[0] policy
     /* 2017062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2017077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017101 */     // GIR_Coverage, 16320,
     /* 2017101 */     GIR_EraseRootFromParent_Done,
     /* 2017102 */   // Label 26920: @2017102
     /* 2017102 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2017204), // Rule ID 16321 //
     /* 2017107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2017118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2017121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2017124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017157 */     // MIs[1] Operand 1
     /* 2017157 */     // No operand predicates
     /* 2017157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017161 */     // MIs[0] round
     /* 2017161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017164 */     // MIs[0] policy
     /* 2017164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2017179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017203 */     // GIR_Coverage, 16321,
     /* 2017203 */     GIR_EraseRootFromParent_Done,
     /* 2017204 */   // Label 26921: @2017204
     /* 2017204 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2017306), // Rule ID 16324 //
     /* 2017209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2017220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2017223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2017226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017259 */     // MIs[1] Operand 1
     /* 2017259 */     // No operand predicates
     /* 2017259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017263 */     // MIs[0] round
     /* 2017263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017266 */     // MIs[0] policy
     /* 2017266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2017281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017305 */     // GIR_Coverage, 16324,
     /* 2017305 */     GIR_EraseRootFromParent_Done,
     /* 2017306 */   // Label 26922: @2017306
     /* 2017306 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2017408), // Rule ID 16325 //
     /* 2017311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2017322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2017325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2017328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017361 */     // MIs[1] Operand 1
     /* 2017361 */     // No operand predicates
     /* 2017361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017365 */     // MIs[0] round
     /* 2017365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017368 */     // MIs[0] policy
     /* 2017368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2017383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017407 */     // GIR_Coverage, 16325,
     /* 2017407 */     GIR_EraseRootFromParent_Done,
     /* 2017408 */   // Label 26923: @2017408
     /* 2017408 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2017510), // Rule ID 16328 //
     /* 2017413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2017424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2017427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2017430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2017443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017463 */     // MIs[1] Operand 1
     /* 2017463 */     // No operand predicates
     /* 2017463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017467 */     // MIs[0] round
     /* 2017467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017470 */     // MIs[0] policy
     /* 2017470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017482 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2017485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017509 */     // GIR_Coverage, 16328,
     /* 2017509 */     GIR_EraseRootFromParent_Done,
     /* 2017510 */   // Label 26924: @2017510
     /* 2017510 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2017612), // Rule ID 16329 //
     /* 2017515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2017523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2017526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2017529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2017532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2017545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017565 */     // MIs[1] Operand 1
     /* 2017565 */     // No operand predicates
     /* 2017565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017569 */     // MIs[0] round
     /* 2017569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017572 */     // MIs[0] policy
     /* 2017572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2017587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017611 */     // GIR_Coverage, 16329,
     /* 2017611 */     GIR_EraseRootFromParent_Done,
     /* 2017612 */   // Label 26925: @2017612
     /* 2017612 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2017717), // Rule ID 16452 //
     /* 2017617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2017625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2017628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2017631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2017634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017667 */     // MIs[1] Operand 1
     /* 2017667 */     // No operand predicates
     /* 2017667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017671 */     // MIs[0] round
     /* 2017671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017674 */     // MIs[0] policy
     /* 2017674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2017689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017716 */     // GIR_Coverage, 16452,
     /* 2017716 */     GIR_EraseRootFromParent_Done,
     /* 2017717 */   // Label 26926: @2017717
     /* 2017717 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2017822), // Rule ID 16453 //
     /* 2017722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2017730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2017733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2017736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2017739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017772 */     // MIs[1] Operand 1
     /* 2017772 */     // No operand predicates
     /* 2017772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017776 */     // MIs[0] round
     /* 2017776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017779 */     // MIs[0] policy
     /* 2017779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017791 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2017794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017821 */     // GIR_Coverage, 16453,
     /* 2017821 */     GIR_EraseRootFromParent_Done,
     /* 2017822 */   // Label 26927: @2017822
     /* 2017822 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2017927), // Rule ID 16456 //
     /* 2017827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2017835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2017838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2017841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2017844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017877 */     // MIs[1] Operand 1
     /* 2017877 */     // No operand predicates
     /* 2017877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017881 */     // MIs[0] round
     /* 2017881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017884 */     // MIs[0] policy
     /* 2017884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017896 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2017899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017926 */     // GIR_Coverage, 16456,
     /* 2017926 */     GIR_EraseRootFromParent_Done,
     /* 2017927 */   // Label 26928: @2017927
     /* 2017927 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2018032), // Rule ID 16457 //
     /* 2017932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2017940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2017943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2017946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2017949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017982 */     // MIs[1] Operand 1
     /* 2017982 */     // No operand predicates
     /* 2017982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017986 */     // MIs[0] round
     /* 2017986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017989 */     // MIs[0] policy
     /* 2017989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018001 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2018004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018031 */     // GIR_Coverage, 16457,
     /* 2018031 */     GIR_EraseRootFromParent_Done,
     /* 2018032 */   // Label 26929: @2018032
     /* 2018032 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2018137), // Rule ID 16460 //
     /* 2018037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2018048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2018051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2018054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018087 */     // MIs[1] Operand 1
     /* 2018087 */     // No operand predicates
     /* 2018087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018091 */     // MIs[0] round
     /* 2018091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018094 */     // MIs[0] policy
     /* 2018094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2018109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018136 */     // GIR_Coverage, 16460,
     /* 2018136 */     GIR_EraseRootFromParent_Done,
     /* 2018137 */   // Label 26930: @2018137
     /* 2018137 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2018242), // Rule ID 16461 //
     /* 2018142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2018153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2018156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2018159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018192 */     // MIs[1] Operand 1
     /* 2018192 */     // No operand predicates
     /* 2018192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018196 */     // MIs[0] round
     /* 2018196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018199 */     // MIs[0] policy
     /* 2018199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018211 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2018214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018241 */     // GIR_Coverage, 16461,
     /* 2018241 */     GIR_EraseRootFromParent_Done,
     /* 2018242 */   // Label 26931: @2018242
     /* 2018242 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2018347), // Rule ID 16464 //
     /* 2018247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2018258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2018261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018297 */     // MIs[1] Operand 1
     /* 2018297 */     // No operand predicates
     /* 2018297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018301 */     // MIs[0] round
     /* 2018301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018304 */     // MIs[0] policy
     /* 2018304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2018319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018346 */     // GIR_Coverage, 16464,
     /* 2018346 */     GIR_EraseRootFromParent_Done,
     /* 2018347 */   // Label 26932: @2018347
     /* 2018347 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2018452), // Rule ID 16465 //
     /* 2018352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2018363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2018366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018402 */     // MIs[1] Operand 1
     /* 2018402 */     // No operand predicates
     /* 2018402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018406 */     // MIs[0] round
     /* 2018406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018409 */     // MIs[0] policy
     /* 2018409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018421 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2018424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018451 */     // GIR_Coverage, 16465,
     /* 2018451 */     GIR_EraseRootFromParent_Done,
     /* 2018452 */   // Label 26933: @2018452
     /* 2018452 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2018557), // Rule ID 16468 //
     /* 2018457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018507 */     // MIs[1] Operand 1
     /* 2018507 */     // No operand predicates
     /* 2018507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018511 */     // MIs[0] round
     /* 2018511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018514 */     // MIs[0] policy
     /* 2018514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2018529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018556 */     // GIR_Coverage, 16468,
     /* 2018556 */     GIR_EraseRootFromParent_Done,
     /* 2018557 */   // Label 26934: @2018557
     /* 2018557 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2018662), // Rule ID 16469 //
     /* 2018562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2018573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2018576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018612 */     // MIs[1] Operand 1
     /* 2018612 */     // No operand predicates
     /* 2018612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018616 */     // MIs[0] round
     /* 2018616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018619 */     // MIs[0] policy
     /* 2018619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2018634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018661 */     // GIR_Coverage, 16469,
     /* 2018661 */     GIR_EraseRootFromParent_Done,
     /* 2018662 */   // Label 26935: @2018662
     /* 2018662 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2018767), // Rule ID 16472 //
     /* 2018667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018717 */     // MIs[1] Operand 1
     /* 2018717 */     // No operand predicates
     /* 2018717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018721 */     // MIs[0] round
     /* 2018721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018724 */     // MIs[0] policy
     /* 2018724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2018739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018766 */     // GIR_Coverage, 16472,
     /* 2018766 */     GIR_EraseRootFromParent_Done,
     /* 2018767 */   // Label 26936: @2018767
     /* 2018767 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2018872), // Rule ID 16473 //
     /* 2018772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2018783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2018786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018822 */     // MIs[1] Operand 1
     /* 2018822 */     // No operand predicates
     /* 2018822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018826 */     // MIs[0] round
     /* 2018826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018829 */     // MIs[0] policy
     /* 2018829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018841 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2018844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018871 */     // GIR_Coverage, 16473,
     /* 2018871 */     GIR_EraseRootFromParent_Done,
     /* 2018872 */   // Label 26937: @2018872
     /* 2018872 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2018977), // Rule ID 16476 //
     /* 2018877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2018888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2018891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2018894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2018900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018927 */     // MIs[1] Operand 1
     /* 2018927 */     // No operand predicates
     /* 2018927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018931 */     // MIs[0] round
     /* 2018931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018934 */     // MIs[0] policy
     /* 2018934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2018949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018976 */     // GIR_Coverage, 16476,
     /* 2018976 */     GIR_EraseRootFromParent_Done,
     /* 2018977 */   // Label 26938: @2018977
     /* 2018977 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2019082), // Rule ID 16477 //
     /* 2018982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2018990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2018993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2018996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2018999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019032 */     // MIs[1] Operand 1
     /* 2019032 */     // No operand predicates
     /* 2019032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019036 */     // MIs[0] round
     /* 2019036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019039 */     // MIs[0] policy
     /* 2019039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019051 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2019054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019081 */     // GIR_Coverage, 16477,
     /* 2019081 */     GIR_EraseRootFromParent_Done,
     /* 2019082 */   // Label 26939: @2019082
     /* 2019082 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2019187), // Rule ID 16480 //
     /* 2019087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2019098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2019101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2019104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019137 */     // MIs[1] Operand 1
     /* 2019137 */     // No operand predicates
     /* 2019137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019141 */     // MIs[0] round
     /* 2019141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019144 */     // MIs[0] policy
     /* 2019144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2019159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019186 */     // GIR_Coverage, 16480,
     /* 2019186 */     GIR_EraseRootFromParent_Done,
     /* 2019187 */   // Label 26940: @2019187
     /* 2019187 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2019292), // Rule ID 16481 //
     /* 2019192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2019203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2019206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2019209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019242 */     // MIs[1] Operand 1
     /* 2019242 */     // No operand predicates
     /* 2019242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019246 */     // MIs[0] round
     /* 2019246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019249 */     // MIs[0] policy
     /* 2019249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019261 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2019264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019291 */     // GIR_Coverage, 16481,
     /* 2019291 */     GIR_EraseRootFromParent_Done,
     /* 2019292 */   // Label 26941: @2019292
     /* 2019292 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2019397), // Rule ID 16484 //
     /* 2019297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2019308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2019311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019347 */     // MIs[1] Operand 1
     /* 2019347 */     // No operand predicates
     /* 2019347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019351 */     // MIs[0] round
     /* 2019351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019354 */     // MIs[0] policy
     /* 2019354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2019369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019396 */     // GIR_Coverage, 16484,
     /* 2019396 */     GIR_EraseRootFromParent_Done,
     /* 2019397 */   // Label 26942: @2019397
     /* 2019397 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2019502), // Rule ID 16485 //
     /* 2019402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2019413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2019416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2019419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019452 */     // MIs[1] Operand 1
     /* 2019452 */     // No operand predicates
     /* 2019452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019456 */     // MIs[0] round
     /* 2019456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019459 */     // MIs[0] policy
     /* 2019459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019471 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2019474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019501 */     // GIR_Coverage, 16485,
     /* 2019501 */     GIR_EraseRootFromParent_Done,
     /* 2019502 */   // Label 26943: @2019502
     /* 2019502 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2019607), // Rule ID 16488 //
     /* 2019507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2019518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2019521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019557 */     // MIs[1] Operand 1
     /* 2019557 */     // No operand predicates
     /* 2019557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019561 */     // MIs[0] round
     /* 2019561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019564 */     // MIs[0] policy
     /* 2019564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2019579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019606 */     // GIR_Coverage, 16488,
     /* 2019606 */     GIR_EraseRootFromParent_Done,
     /* 2019607 */   // Label 26944: @2019607
     /* 2019607 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2019712), // Rule ID 16489 //
     /* 2019612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2019623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2019626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019662 */     // MIs[1] Operand 1
     /* 2019662 */     // No operand predicates
     /* 2019662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019666 */     // MIs[0] round
     /* 2019666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019669 */     // MIs[0] policy
     /* 2019669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2019684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019711 */     // GIR_Coverage, 16489,
     /* 2019711 */     GIR_EraseRootFromParent_Done,
     /* 2019712 */   // Label 26945: @2019712
     /* 2019712 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2019817), // Rule ID 16492 //
     /* 2019717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2019728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2019731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019767 */     // MIs[1] Operand 1
     /* 2019767 */     // No operand predicates
     /* 2019767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019771 */     // MIs[0] round
     /* 2019771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019774 */     // MIs[0] policy
     /* 2019774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019786 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2019789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019816 */     // GIR_Coverage, 16492,
     /* 2019816 */     GIR_EraseRootFromParent_Done,
     /* 2019817 */   // Label 26946: @2019817
     /* 2019817 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2019922), // Rule ID 16493 //
     /* 2019822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2019833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2019836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019872 */     // MIs[1] Operand 1
     /* 2019872 */     // No operand predicates
     /* 2019872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019876 */     // MIs[0] round
     /* 2019876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019879 */     // MIs[0] policy
     /* 2019879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019891 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2019894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019921 */     // GIR_Coverage, 16493,
     /* 2019921 */     GIR_EraseRootFromParent_Done,
     /* 2019922 */   // Label 26947: @2019922
     /* 2019922 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2020027), // Rule ID 16496 //
     /* 2019927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2019930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2019935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2019938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2019941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2019944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019977 */     // MIs[1] Operand 1
     /* 2019977 */     // No operand predicates
     /* 2019977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019981 */     // MIs[0] round
     /* 2019981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019984 */     // MIs[0] policy
     /* 2019984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2019999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020026 */     // GIR_Coverage, 16496,
     /* 2020026 */     GIR_EraseRootFromParent_Done,
     /* 2020027 */   // Label 26948: @2020027
     /* 2020027 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2020132), // Rule ID 16497 //
     /* 2020032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2020035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2020043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2020046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2020049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020082 */     // MIs[1] Operand 1
     /* 2020082 */     // No operand predicates
     /* 2020082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020086 */     // MIs[0] round
     /* 2020086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020089 */     // MIs[0] policy
     /* 2020089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020101 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2020104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020131 */     // GIR_Coverage, 16497,
     /* 2020131 */     GIR_EraseRootFromParent_Done,
     /* 2020132 */   // Label 26949: @2020132
     /* 2020132 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2020237), // Rule ID 16500 //
     /* 2020137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2020140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2020148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2020151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2020154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020187 */     // MIs[1] Operand 1
     /* 2020187 */     // No operand predicates
     /* 2020187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020191 */     // MIs[0] round
     /* 2020191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020194 */     // MIs[0] policy
     /* 2020194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2020209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020236 */     // GIR_Coverage, 16500,
     /* 2020236 */     GIR_EraseRootFromParent_Done,
     /* 2020237 */   // Label 26950: @2020237
     /* 2020237 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2020342), // Rule ID 16501 //
     /* 2020242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2020245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2020253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2020256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2020259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020292 */     // MIs[1] Operand 1
     /* 2020292 */     // No operand predicates
     /* 2020292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020296 */     // MIs[0] round
     /* 2020296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020299 */     // MIs[0] policy
     /* 2020299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020311 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2020314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020341 */     // GIR_Coverage, 16501,
     /* 2020341 */     GIR_EraseRootFromParent_Done,
     /* 2020342 */   // Label 26951: @2020342
     /* 2020342 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2020447), // Rule ID 16504 //
     /* 2020347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2020350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2020358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2020361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020397 */     // MIs[1] Operand 1
     /* 2020397 */     // No operand predicates
     /* 2020397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020401 */     // MIs[0] round
     /* 2020401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020404 */     // MIs[0] policy
     /* 2020404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2020419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020446 */     // GIR_Coverage, 16504,
     /* 2020446 */     GIR_EraseRootFromParent_Done,
     /* 2020447 */   // Label 26952: @2020447
     /* 2020447 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2020552), // Rule ID 16505 //
     /* 2020452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2020455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2020463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2020466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2020469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020502 */     // MIs[1] Operand 1
     /* 2020502 */     // No operand predicates
     /* 2020502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020506 */     // MIs[0] round
     /* 2020506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020509 */     // MIs[0] policy
     /* 2020509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2020524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020551 */     // GIR_Coverage, 16505,
     /* 2020551 */     GIR_EraseRootFromParent_Done,
     /* 2020552 */   // Label 26953: @2020552
     /* 2020552 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2020657), // Rule ID 16508 //
     /* 2020557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2020560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020607 */     // MIs[1] Operand 1
     /* 2020607 */     // No operand predicates
     /* 2020607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020611 */     // MIs[0] round
     /* 2020611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020614 */     // MIs[0] policy
     /* 2020614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2020629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020656 */     // GIR_Coverage, 16508,
     /* 2020656 */     GIR_EraseRootFromParent_Done,
     /* 2020657 */   // Label 26954: @2020657
     /* 2020657 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2020762), // Rule ID 16509 //
     /* 2020662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2020665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2020670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2020679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020712 */     // MIs[1] Operand 1
     /* 2020712 */     // No operand predicates
     /* 2020712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020716 */     // MIs[0] round
     /* 2020716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020719 */     // MIs[0] policy
     /* 2020719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020731 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2020734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020761 */     // GIR_Coverage, 16509,
     /* 2020761 */     GIR_EraseRootFromParent_Done,
     /* 2020762 */   // Label 26955: @2020762
     /* 2020762 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2020867), // Rule ID 16632 //
     /* 2020767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2020775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020817 */     // MIs[1] Operand 1
     /* 2020817 */     // No operand predicates
     /* 2020817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020821 */     // MIs[0] round
     /* 2020821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020824 */     // MIs[0] policy
     /* 2020824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2020839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020866 */     // GIR_Coverage, 16632,
     /* 2020866 */     GIR_EraseRootFromParent_Done,
     /* 2020867 */   // Label 26956: @2020867
     /* 2020867 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2020972), // Rule ID 16633 //
     /* 2020872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2020880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020922 */     // MIs[1] Operand 1
     /* 2020922 */     // No operand predicates
     /* 2020922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020926 */     // MIs[0] round
     /* 2020926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020929 */     // MIs[0] policy
     /* 2020929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020941 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2020944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2020970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020971 */     // GIR_Coverage, 16633,
     /* 2020971 */     GIR_EraseRootFromParent_Done,
     /* 2020972 */   // Label 26957: @2020972
     /* 2020972 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2021077), // Rule ID 16636 //
     /* 2020977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2020985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021027 */     // MIs[1] Operand 1
     /* 2021027 */     // No operand predicates
     /* 2021027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021031 */     // MIs[0] round
     /* 2021031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021034 */     // MIs[0] policy
     /* 2021034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2021049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021076 */     // GIR_Coverage, 16636,
     /* 2021076 */     GIR_EraseRootFromParent_Done,
     /* 2021077 */   // Label 26958: @2021077
     /* 2021077 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2021182), // Rule ID 16637 //
     /* 2021082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2021093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2021096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2021099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021132 */     // MIs[1] Operand 1
     /* 2021132 */     // No operand predicates
     /* 2021132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021136 */     // MIs[0] round
     /* 2021136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021139 */     // MIs[0] policy
     /* 2021139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2021154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021181 */     // GIR_Coverage, 16637,
     /* 2021181 */     GIR_EraseRootFromParent_Done,
     /* 2021182 */   // Label 26959: @2021182
     /* 2021182 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2021287), // Rule ID 16640 //
     /* 2021187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2021198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2021201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021237 */     // MIs[1] Operand 1
     /* 2021237 */     // No operand predicates
     /* 2021237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021241 */     // MIs[0] round
     /* 2021241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021244 */     // MIs[0] policy
     /* 2021244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2021259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021286 */     // GIR_Coverage, 16640,
     /* 2021286 */     GIR_EraseRootFromParent_Done,
     /* 2021287 */   // Label 26960: @2021287
     /* 2021287 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2021392), // Rule ID 16641 //
     /* 2021292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2021303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2021306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021342 */     // MIs[1] Operand 1
     /* 2021342 */     // No operand predicates
     /* 2021342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021346 */     // MIs[0] round
     /* 2021346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021349 */     // MIs[0] policy
     /* 2021349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021361 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2021364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021391 */     // GIR_Coverage, 16641,
     /* 2021391 */     GIR_EraseRootFromParent_Done,
     /* 2021392 */   // Label 26961: @2021392
     /* 2021392 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2021497), // Rule ID 16644 //
     /* 2021397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2021414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021447 */     // MIs[1] Operand 1
     /* 2021447 */     // No operand predicates
     /* 2021447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021451 */     // MIs[0] round
     /* 2021451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021454 */     // MIs[0] policy
     /* 2021454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2021469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021496 */     // GIR_Coverage, 16644,
     /* 2021496 */     GIR_EraseRootFromParent_Done,
     /* 2021497 */   // Label 26962: @2021497
     /* 2021497 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2021602), // Rule ID 16645 //
     /* 2021502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2021519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021552 */     // MIs[1] Operand 1
     /* 2021552 */     // No operand predicates
     /* 2021552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021556 */     // MIs[0] round
     /* 2021556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021559 */     // MIs[0] policy
     /* 2021559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2021574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021601 */     // GIR_Coverage, 16645,
     /* 2021601 */     GIR_EraseRootFromParent_Done,
     /* 2021602 */   // Label 26963: @2021602
     /* 2021602 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2021707), // Rule ID 16648 //
     /* 2021607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2021618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2021621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2021624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021657 */     // MIs[1] Operand 1
     /* 2021657 */     // No operand predicates
     /* 2021657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021661 */     // MIs[0] round
     /* 2021661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021664 */     // MIs[0] policy
     /* 2021664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2021679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021706 */     // GIR_Coverage, 16648,
     /* 2021706 */     GIR_EraseRootFromParent_Done,
     /* 2021707 */   // Label 26964: @2021707
     /* 2021707 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2021812), // Rule ID 16649 //
     /* 2021712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2021723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2021726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2021729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021762 */     // MIs[1] Operand 1
     /* 2021762 */     // No operand predicates
     /* 2021762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021766 */     // MIs[0] round
     /* 2021766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021769 */     // MIs[0] policy
     /* 2021769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2021784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021811 */     // GIR_Coverage, 16649,
     /* 2021811 */     GIR_EraseRootFromParent_Done,
     /* 2021812 */   // Label 26965: @2021812
     /* 2021812 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2021917), // Rule ID 16652 //
     /* 2021817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2021828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2021831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2021834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2021840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021867 */     // MIs[1] Operand 1
     /* 2021867 */     // No operand predicates
     /* 2021867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021871 */     // MIs[0] round
     /* 2021871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021874 */     // MIs[0] policy
     /* 2021874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021886 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2021889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2021915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021916 */     // GIR_Coverage, 16652,
     /* 2021916 */     GIR_EraseRootFromParent_Done,
     /* 2021917 */   // Label 26966: @2021917
     /* 2021917 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2022022), // Rule ID 16653 //
     /* 2021922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2021930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2021933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2021936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2021939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2021945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021972 */     // MIs[1] Operand 1
     /* 2021972 */     // No operand predicates
     /* 2021972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021976 */     // MIs[0] round
     /* 2021976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021979 */     // MIs[0] policy
     /* 2021979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021991 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2021994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022021 */     // GIR_Coverage, 16653,
     /* 2022021 */     GIR_EraseRootFromParent_Done,
     /* 2022022 */   // Label 26967: @2022022
     /* 2022022 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2022127), // Rule ID 16656 //
     /* 2022027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2022038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2022041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2022044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022077 */     // MIs[1] Operand 1
     /* 2022077 */     // No operand predicates
     /* 2022077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022081 */     // MIs[0] round
     /* 2022081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022084 */     // MIs[0] policy
     /* 2022084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2022099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022126 */     // GIR_Coverage, 16656,
     /* 2022126 */     GIR_EraseRootFromParent_Done,
     /* 2022127 */   // Label 26968: @2022127
     /* 2022127 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2022232), // Rule ID 16657 //
     /* 2022132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2022143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2022146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2022149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022182 */     // MIs[1] Operand 1
     /* 2022182 */     // No operand predicates
     /* 2022182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022186 */     // MIs[0] round
     /* 2022186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022189 */     // MIs[0] policy
     /* 2022189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022201 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2022204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022231 */     // GIR_Coverage, 16657,
     /* 2022231 */     GIR_EraseRootFromParent_Done,
     /* 2022232 */   // Label 26969: @2022232
     /* 2022232 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2022337), // Rule ID 16660 //
     /* 2022237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2022248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2022251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022287 */     // MIs[1] Operand 1
     /* 2022287 */     // No operand predicates
     /* 2022287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022291 */     // MIs[0] round
     /* 2022291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022294 */     // MIs[0] policy
     /* 2022294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2022309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022336 */     // GIR_Coverage, 16660,
     /* 2022336 */     GIR_EraseRootFromParent_Done,
     /* 2022337 */   // Label 26970: @2022337
     /* 2022337 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2022442), // Rule ID 16661 //
     /* 2022342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2022353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2022356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2022359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022392 */     // MIs[1] Operand 1
     /* 2022392 */     // No operand predicates
     /* 2022392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022396 */     // MIs[0] round
     /* 2022396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022399 */     // MIs[0] policy
     /* 2022399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022411 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2022414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022441 */     // GIR_Coverage, 16661,
     /* 2022441 */     GIR_EraseRootFromParent_Done,
     /* 2022442 */   // Label 26971: @2022442
     /* 2022442 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2022547), // Rule ID 16664 //
     /* 2022447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2022458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2022461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022497 */     // MIs[1] Operand 1
     /* 2022497 */     // No operand predicates
     /* 2022497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022501 */     // MIs[0] round
     /* 2022501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022504 */     // MIs[0] policy
     /* 2022504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2022519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022546 */     // GIR_Coverage, 16664,
     /* 2022546 */     GIR_EraseRootFromParent_Done,
     /* 2022547 */   // Label 26972: @2022547
     /* 2022547 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2022652), // Rule ID 16665 //
     /* 2022552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2022563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2022566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2022569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022602 */     // MIs[1] Operand 1
     /* 2022602 */     // No operand predicates
     /* 2022602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022606 */     // MIs[0] round
     /* 2022606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022609 */     // MIs[0] policy
     /* 2022609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2022624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022651 */     // GIR_Coverage, 16665,
     /* 2022651 */     GIR_EraseRootFromParent_Done,
     /* 2022652 */   // Label 26973: @2022652
     /* 2022652 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2022757), // Rule ID 16668 //
     /* 2022657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022707 */     // MIs[1] Operand 1
     /* 2022707 */     // No operand predicates
     /* 2022707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022711 */     // MIs[0] round
     /* 2022711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022714 */     // MIs[0] policy
     /* 2022714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2022729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022756 */     // GIR_Coverage, 16668,
     /* 2022756 */     GIR_EraseRootFromParent_Done,
     /* 2022757 */   // Label 26974: @2022757
     /* 2022757 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2022862), // Rule ID 16669 //
     /* 2022762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2022779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022812 */     // MIs[1] Operand 1
     /* 2022812 */     // No operand predicates
     /* 2022812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022816 */     // MIs[0] round
     /* 2022816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022819 */     // MIs[0] policy
     /* 2022819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2022834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022861 */     // GIR_Coverage, 16669,
     /* 2022861 */     GIR_EraseRootFromParent_Done,
     /* 2022862 */   // Label 26975: @2022862
     /* 2022862 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2022967), // Rule ID 16672 //
     /* 2022867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2022884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022917 */     // MIs[1] Operand 1
     /* 2022917 */     // No operand predicates
     /* 2022917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022921 */     // MIs[0] round
     /* 2022921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022924 */     // MIs[0] policy
     /* 2022924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2022939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2022965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022966 */     // GIR_Coverage, 16672,
     /* 2022966 */     GIR_EraseRootFromParent_Done,
     /* 2022967 */   // Label 26976: @2022967
     /* 2022967 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2023072), // Rule ID 16673 //
     /* 2022972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2022980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2022989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023022 */     // MIs[1] Operand 1
     /* 2023022 */     // No operand predicates
     /* 2023022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023026 */     // MIs[0] round
     /* 2023026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023029 */     // MIs[0] policy
     /* 2023029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023041 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2023044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023071 */     // GIR_Coverage, 16673,
     /* 2023071 */     GIR_EraseRootFromParent_Done,
     /* 2023072 */   // Label 26977: @2023072
     /* 2023072 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2023177), // Rule ID 16676 //
     /* 2023077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2023080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2023094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023127 */     // MIs[1] Operand 1
     /* 2023127 */     // No operand predicates
     /* 2023127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023131 */     // MIs[0] round
     /* 2023131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023134 */     // MIs[0] policy
     /* 2023134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2023149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023176 */     // GIR_Coverage, 16676,
     /* 2023176 */     GIR_EraseRootFromParent_Done,
     /* 2023177 */   // Label 26978: @2023177
     /* 2023177 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2023282), // Rule ID 16677 //
     /* 2023182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2023185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2023199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023232 */     // MIs[1] Operand 1
     /* 2023232 */     // No operand predicates
     /* 2023232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023236 */     // MIs[0] round
     /* 2023236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023239 */     // MIs[0] policy
     /* 2023239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023251 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2023254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023281 */     // GIR_Coverage, 16677,
     /* 2023281 */     GIR_EraseRootFromParent_Done,
     /* 2023282 */   // Label 26979: @2023282
     /* 2023282 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2023387), // Rule ID 16680 //
     /* 2023287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2023290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2023298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2023301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023337 */     // MIs[1] Operand 1
     /* 2023337 */     // No operand predicates
     /* 2023337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023341 */     // MIs[0] round
     /* 2023341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023344 */     // MIs[0] policy
     /* 2023344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2023359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023386 */     // GIR_Coverage, 16680,
     /* 2023386 */     GIR_EraseRootFromParent_Done,
     /* 2023387 */   // Label 26980: @2023387
     /* 2023387 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2023492), // Rule ID 16681 //
     /* 2023392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2023395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2023403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2023406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023442 */     // MIs[1] Operand 1
     /* 2023442 */     // No operand predicates
     /* 2023442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023446 */     // MIs[0] round
     /* 2023446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023449 */     // MIs[0] policy
     /* 2023449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023461 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2023464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023491 */     // GIR_Coverage, 16681,
     /* 2023491 */     GIR_EraseRootFromParent_Done,
     /* 2023492 */   // Label 26981: @2023492
     /* 2023492 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2023597), // Rule ID 16684 //
     /* 2023497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2023500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023547 */     // MIs[1] Operand 1
     /* 2023547 */     // No operand predicates
     /* 2023547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023551 */     // MIs[0] round
     /* 2023551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023554 */     // MIs[0] policy
     /* 2023554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2023569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023596 */     // GIR_Coverage, 16684,
     /* 2023596 */     GIR_EraseRootFromParent_Done,
     /* 2023597 */   // Label 26982: @2023597
     /* 2023597 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2023702), // Rule ID 16685 //
     /* 2023602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2023605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2023619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023652 */     // MIs[1] Operand 1
     /* 2023652 */     // No operand predicates
     /* 2023652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023656 */     // MIs[0] round
     /* 2023656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023659 */     // MIs[0] policy
     /* 2023659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2023674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023701 */     // GIR_Coverage, 16685,
     /* 2023701 */     GIR_EraseRootFromParent_Done,
     /* 2023702 */   // Label 26983: @2023702
     /* 2023702 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2023807), // Rule ID 16688 //
     /* 2023707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2023710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023757 */     // MIs[1] Operand 1
     /* 2023757 */     // No operand predicates
     /* 2023757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023761 */     // MIs[0] round
     /* 2023761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023764 */     // MIs[0] policy
     /* 2023764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2023779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023806 */     // GIR_Coverage, 16688,
     /* 2023806 */     GIR_EraseRootFromParent_Done,
     /* 2023807 */   // Label 26984: @2023807
     /* 2023807 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2023912), // Rule ID 16689 //
     /* 2023812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2023815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2023820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2023829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023862 */     // MIs[1] Operand 1
     /* 2023862 */     // No operand predicates
     /* 2023862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023866 */     // MIs[0] round
     /* 2023866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023869 */     // MIs[0] policy
     /* 2023869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2023884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2023910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023911 */     // GIR_Coverage, 16689,
     /* 2023911 */     GIR_EraseRootFromParent_Done,
     /* 2023912 */   // Label 26985: @2023912
     /* 2023912 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2023999), // Rule ID 2760 //
     /* 2023917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2023920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2023925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023948 */     // MIs[0] passthru
     /* 2023948 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2023953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023961 */     // MIs[0] round
     /* 2023961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023964 */     // MIs[0] policy
     /* 2023964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023974 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2023977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023998 */     // GIR_Coverage, 2760,
     /* 2023998 */     GIR_EraseRootFromParent_Done,
     /* 2023999 */   // Label 26986: @2023999
     /* 2023999 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2024086), // Rule ID 2761 //
     /* 2024004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2024007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2024015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2024018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2024021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024035 */     // MIs[0] passthru
     /* 2024035 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024048 */     // MIs[0] round
     /* 2024048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024051 */     // MIs[0] policy
     /* 2024051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024061 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2024064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024085 */     // GIR_Coverage, 2761,
     /* 2024085 */     GIR_EraseRootFromParent_Done,
     /* 2024086 */   // Label 26987: @2024086
     /* 2024086 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2024173), // Rule ID 17140 //
     /* 2024091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2024094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2024108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024122 */     // MIs[0] passthru
     /* 2024122 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024135 */     // MIs[0] round
     /* 2024135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024138 */     // MIs[0] policy
     /* 2024138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024148 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2024151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024172 */     // GIR_Coverage, 17140,
     /* 2024172 */     GIR_EraseRootFromParent_Done,
     /* 2024173 */   // Label 26988: @2024173
     /* 2024173 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2024260), // Rule ID 17141 //
     /* 2024178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2024181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2024195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024209 */     // MIs[0] passthru
     /* 2024209 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024222 */     // MIs[0] round
     /* 2024222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024225 */     // MIs[0] policy
     /* 2024225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024235 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2024238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024259 */     // GIR_Coverage, 17141,
     /* 2024259 */     GIR_EraseRootFromParent_Done,
     /* 2024260 */   // Label 26989: @2024260
     /* 2024260 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2024347), // Rule ID 17150 //
     /* 2024265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2024268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2024276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2024279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2024282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024296 */     // MIs[0] passthru
     /* 2024296 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024309 */     // MIs[0] round
     /* 2024309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024312 */     // MIs[0] policy
     /* 2024312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2024325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024346 */     // GIR_Coverage, 17150,
     /* 2024346 */     GIR_EraseRootFromParent_Done,
     /* 2024347 */   // Label 26990: @2024347
     /* 2024347 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2024434), // Rule ID 17151 //
     /* 2024352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2024355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2024363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2024366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2024369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024383 */     // MIs[0] passthru
     /* 2024383 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024396 */     // MIs[0] round
     /* 2024396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024399 */     // MIs[0] policy
     /* 2024399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2024412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024433 */     // GIR_Coverage, 17151,
     /* 2024433 */     GIR_EraseRootFromParent_Done,
     /* 2024434 */   // Label 26991: @2024434
     /* 2024434 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2024521), // Rule ID 17160 //
     /* 2024439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2024442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2024450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2024453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2024456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024470 */     // MIs[0] passthru
     /* 2024470 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024483 */     // MIs[0] round
     /* 2024483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024486 */     // MIs[0] policy
     /* 2024486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024496 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2024499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024520 */     // GIR_Coverage, 17160,
     /* 2024520 */     GIR_EraseRootFromParent_Done,
     /* 2024521 */   // Label 26992: @2024521
     /* 2024521 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2024608), // Rule ID 17161 //
     /* 2024526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2024529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2024537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2024540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2024543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024557 */     // MIs[0] passthru
     /* 2024557 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024570 */     // MIs[0] round
     /* 2024570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024573 */     // MIs[0] policy
     /* 2024573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024583 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2024586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024607 */     // GIR_Coverage, 17161,
     /* 2024607 */     GIR_EraseRootFromParent_Done,
     /* 2024608 */   // Label 26993: @2024608
     /* 2024608 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2024695), // Rule ID 17170 //
     /* 2024613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2024616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2024630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024644 */     // MIs[0] passthru
     /* 2024644 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024657 */     // MIs[0] round
     /* 2024657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024660 */     // MIs[0] policy
     /* 2024660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024670 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2024673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024694 */     // GIR_Coverage, 17170,
     /* 2024694 */     GIR_EraseRootFromParent_Done,
     /* 2024695 */   // Label 26994: @2024695
     /* 2024695 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2024782), // Rule ID 17171 //
     /* 2024700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2024703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2024711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2024714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2024717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024731 */     // MIs[0] passthru
     /* 2024731 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024744 */     // MIs[0] round
     /* 2024744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024747 */     // MIs[0] policy
     /* 2024747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024757 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2024760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024781 */     // GIR_Coverage, 17171,
     /* 2024781 */     GIR_EraseRootFromParent_Done,
     /* 2024782 */   // Label 26995: @2024782
     /* 2024782 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2024869), // Rule ID 17180 //
     /* 2024787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2024790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2024804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024818 */     // MIs[0] passthru
     /* 2024818 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024831 */     // MIs[0] round
     /* 2024831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024834 */     // MIs[0] policy
     /* 2024834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2024847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024868 */     // GIR_Coverage, 17180,
     /* 2024868 */     GIR_EraseRootFromParent_Done,
     /* 2024869 */   // Label 26996: @2024869
     /* 2024869 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2024956), // Rule ID 17181 //
     /* 2024874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2024877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2024891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024905 */     // MIs[0] passthru
     /* 2024905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024918 */     // MIs[0] round
     /* 2024918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024921 */     // MIs[0] policy
     /* 2024921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024931 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2024934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024955 */     // GIR_Coverage, 17181,
     /* 2024955 */     GIR_EraseRootFromParent_Done,
     /* 2024956 */   // Label 26997: @2024956
     /* 2024956 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2025043), // Rule ID 17190 //
     /* 2024961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2024964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2024969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2024972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2024975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2024978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024992 */     // MIs[0] passthru
     /* 2024992 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2024997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025005 */     // MIs[0] round
     /* 2025005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025008 */     // MIs[0] policy
     /* 2025008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025018 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2025021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025042 */     // GIR_Coverage, 17190,
     /* 2025042 */     GIR_EraseRootFromParent_Done,
     /* 2025043 */   // Label 26998: @2025043
     /* 2025043 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2025130), // Rule ID 17191 //
     /* 2025048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2025051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2025056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2025059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2025062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2025065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025079 */     // MIs[0] passthru
     /* 2025079 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025092 */     // MIs[0] round
     /* 2025092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025095 */     // MIs[0] policy
     /* 2025095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025105 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2025108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025129 */     // GIR_Coverage, 17191,
     /* 2025129 */     GIR_EraseRootFromParent_Done,
     /* 2025130 */   // Label 26999: @2025130
     /* 2025130 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2025217), // Rule ID 17200 //
     /* 2025135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2025138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2025143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2025146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2025149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2025152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025166 */     // MIs[0] passthru
     /* 2025166 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025179 */     // MIs[0] round
     /* 2025179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025182 */     // MIs[0] policy
     /* 2025182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025192 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2025195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025216 */     // GIR_Coverage, 17200,
     /* 2025216 */     GIR_EraseRootFromParent_Done,
     /* 2025217 */   // Label 27000: @2025217
     /* 2025217 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2025304), // Rule ID 17201 //
     /* 2025222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2025225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2025230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2025233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2025236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2025239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025253 */     // MIs[0] passthru
     /* 2025253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025266 */     // MIs[0] round
     /* 2025266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025269 */     // MIs[0] policy
     /* 2025269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025279 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2025282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025303 */     // GIR_Coverage, 17201,
     /* 2025303 */     GIR_EraseRootFromParent_Done,
     /* 2025304 */   // Label 27001: @2025304
     /* 2025304 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2025391), // Rule ID 17210 //
     /* 2025309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2025312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2025317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2025320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2025323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2025326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025340 */     // MIs[0] passthru
     /* 2025340 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025353 */     // MIs[0] round
     /* 2025353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025356 */     // MIs[0] policy
     /* 2025356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025366 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2025369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025390 */     // GIR_Coverage, 17210,
     /* 2025390 */     GIR_EraseRootFromParent_Done,
     /* 2025391 */   // Label 27002: @2025391
     /* 2025391 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2025478), // Rule ID 17211 //
     /* 2025396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2025399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2025404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2025407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2025410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2025413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025427 */     // MIs[0] passthru
     /* 2025427 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025440 */     // MIs[0] round
     /* 2025440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025443 */     // MIs[0] policy
     /* 2025443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025453 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2025456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2025474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025477 */     // GIR_Coverage, 17211,
     /* 2025477 */     GIR_EraseRootFromParent_Done,
     /* 2025478 */   // Label 27003: @2025478
     /* 2025478 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2025565), // Rule ID 17256 //
     /* 2025483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2025486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2025494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2025497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2025500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025514 */     // MIs[0] passthru
     /* 2025514 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025527 */     // MIs[0] round
     /* 2025527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025530 */     // MIs[0] policy
     /* 2025530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025540 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2025543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025564 */     // GIR_Coverage, 17256,
     /* 2025564 */     GIR_EraseRootFromParent_Done,
     /* 2025565 */   // Label 27004: @2025565
     /* 2025565 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2025652), // Rule ID 17257 //
     /* 2025570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2025573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2025581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2025584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2025587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025601 */     // MIs[0] passthru
     /* 2025601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025614 */     // MIs[0] round
     /* 2025614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025617 */     // MIs[0] policy
     /* 2025617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025627 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2025630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025651 */     // GIR_Coverage, 17257,
     /* 2025651 */     GIR_EraseRootFromParent_Done,
     /* 2025652 */   // Label 27005: @2025652
     /* 2025652 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2025739), // Rule ID 17266 //
     /* 2025657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2025660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2025668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2025671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2025674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025688 */     // MIs[0] passthru
     /* 2025688 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025701 */     // MIs[0] round
     /* 2025701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025704 */     // MIs[0] policy
     /* 2025704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2025717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025738 */     // GIR_Coverage, 17266,
     /* 2025738 */     GIR_EraseRootFromParent_Done,
     /* 2025739 */   // Label 27006: @2025739
     /* 2025739 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2025826), // Rule ID 17267 //
     /* 2025744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2025747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2025755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2025758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2025761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025775 */     // MIs[0] passthru
     /* 2025775 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025788 */     // MIs[0] round
     /* 2025788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025791 */     // MIs[0] policy
     /* 2025791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025801 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2025804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025825 */     // GIR_Coverage, 17267,
     /* 2025825 */     GIR_EraseRootFromParent_Done,
     /* 2025826 */   // Label 27007: @2025826
     /* 2025826 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2025913), // Rule ID 17276 //
     /* 2025831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2025834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2025842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2025845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2025848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025862 */     // MIs[0] passthru
     /* 2025862 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025875 */     // MIs[0] round
     /* 2025875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025878 */     // MIs[0] policy
     /* 2025878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025888 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2025891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025912 */     // GIR_Coverage, 17276,
     /* 2025912 */     GIR_EraseRootFromParent_Done,
     /* 2025913 */   // Label 27008: @2025913
     /* 2025913 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2026000), // Rule ID 17277 //
     /* 2025918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2025921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2025926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2025929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2025932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2025935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025949 */     // MIs[0] passthru
     /* 2025949 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2025954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025962 */     // MIs[0] round
     /* 2025962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025965 */     // MIs[0] policy
     /* 2025965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2025978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025999 */     // GIR_Coverage, 17277,
     /* 2025999 */     GIR_EraseRootFromParent_Done,
     /* 2026000 */   // Label 27009: @2026000
     /* 2026000 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2026087), // Rule ID 17286 //
     /* 2026005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2026008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2026016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2026019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2026022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026036 */     // MIs[0] passthru
     /* 2026036 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026049 */     // MIs[0] round
     /* 2026049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026052 */     // MIs[0] policy
     /* 2026052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2026065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026086 */     // GIR_Coverage, 17286,
     /* 2026086 */     GIR_EraseRootFromParent_Done,
     /* 2026087 */   // Label 27010: @2026087
     /* 2026087 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2026174), // Rule ID 17287 //
     /* 2026092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2026095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2026103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2026106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2026109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026123 */     // MIs[0] passthru
     /* 2026123 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026136 */     // MIs[0] round
     /* 2026136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026139 */     // MIs[0] policy
     /* 2026139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026149 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2026152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026173 */     // GIR_Coverage, 17287,
     /* 2026173 */     GIR_EraseRootFromParent_Done,
     /* 2026174 */   // Label 27011: @2026174
     /* 2026174 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2026261), // Rule ID 17296 //
     /* 2026179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2026182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2026190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2026193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2026196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026210 */     // MIs[0] passthru
     /* 2026210 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026223 */     // MIs[0] round
     /* 2026223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026226 */     // MIs[0] policy
     /* 2026226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026236 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2026239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026260 */     // GIR_Coverage, 17296,
     /* 2026260 */     GIR_EraseRootFromParent_Done,
     /* 2026261 */   // Label 27012: @2026261
     /* 2026261 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2026348), // Rule ID 17297 //
     /* 2026266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2026269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2026277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2026280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2026283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026297 */     // MIs[0] passthru
     /* 2026297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026310 */     // MIs[0] round
     /* 2026310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026313 */     // MIs[0] policy
     /* 2026313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026323 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2026326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026347 */     // GIR_Coverage, 17297,
     /* 2026347 */     GIR_EraseRootFromParent_Done,
     /* 2026348 */   // Label 27013: @2026348
     /* 2026348 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2026435), // Rule ID 17306 //
     /* 2026353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2026356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2026364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2026367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2026370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026384 */     // MIs[0] passthru
     /* 2026384 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026397 */     // MIs[0] round
     /* 2026397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026400 */     // MIs[0] policy
     /* 2026400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2026413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026434 */     // GIR_Coverage, 17306,
     /* 2026434 */     GIR_EraseRootFromParent_Done,
     /* 2026435 */   // Label 27014: @2026435
     /* 2026435 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2026522), // Rule ID 17307 //
     /* 2026440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2026443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2026451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2026454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2026457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026471 */     // MIs[0] passthru
     /* 2026471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026484 */     // MIs[0] round
     /* 2026484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026487 */     // MIs[0] policy
     /* 2026487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026497 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2026500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026521 */     // GIR_Coverage, 17307,
     /* 2026521 */     GIR_EraseRootFromParent_Done,
     /* 2026522 */   // Label 27015: @2026522
     /* 2026522 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2026609), // Rule ID 17316 //
     /* 2026527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2026530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2026538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2026541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2026544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026558 */     // MIs[0] passthru
     /* 2026558 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026571 */     // MIs[0] round
     /* 2026571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026574 */     // MIs[0] policy
     /* 2026574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2026587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026608 */     // GIR_Coverage, 17316,
     /* 2026608 */     GIR_EraseRootFromParent_Done,
     /* 2026609 */   // Label 27016: @2026609
     /* 2026609 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2026696), // Rule ID 17317 //
     /* 2026614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2026617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2026625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2026628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2026631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026645 */     // MIs[0] passthru
     /* 2026645 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026658 */     // MIs[0] round
     /* 2026658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026661 */     // MIs[0] policy
     /* 2026661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026671 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2026674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026695 */     // GIR_Coverage, 17317,
     /* 2026695 */     GIR_EraseRootFromParent_Done,
     /* 2026696 */   // Label 27017: @2026696
     /* 2026696 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2026783), // Rule ID 17326 //
     /* 2026701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2026704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2026712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2026715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2026718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026732 */     // MIs[0] passthru
     /* 2026732 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026745 */     // MIs[0] round
     /* 2026745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026748 */     // MIs[0] policy
     /* 2026748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2026761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026782 */     // GIR_Coverage, 17326,
     /* 2026782 */     GIR_EraseRootFromParent_Done,
     /* 2026783 */   // Label 27018: @2026783
     /* 2026783 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2026870), // Rule ID 17327 //
     /* 2026788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2026791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2026799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2026802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2026805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026819 */     // MIs[0] passthru
     /* 2026819 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026832 */     // MIs[0] round
     /* 2026832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026835 */     // MIs[0] policy
     /* 2026835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2026848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026869 */     // GIR_Coverage, 17327,
     /* 2026869 */     GIR_EraseRootFromParent_Done,
     /* 2026870 */   // Label 27019: @2026870
     /* 2026870 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2026957), // Rule ID 17336 //
     /* 2026875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2026878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2026886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2026889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2026892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026906 */     // MIs[0] passthru
     /* 2026906 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026919 */     // MIs[0] round
     /* 2026919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026922 */     // MIs[0] policy
     /* 2026922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026932 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2026935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026956 */     // GIR_Coverage, 17336,
     /* 2026956 */     GIR_EraseRootFromParent_Done,
     /* 2026957 */   // Label 27020: @2026957
     /* 2026957 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2027044), // Rule ID 17337 //
     /* 2026962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2026965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2026970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2026973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2026976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2026979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026993 */     // MIs[0] passthru
     /* 2026993 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2026998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027006 */     // MIs[0] round
     /* 2027006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027009 */     // MIs[0] policy
     /* 2027009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027019 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2027022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027043 */     // GIR_Coverage, 17337,
     /* 2027043 */     GIR_EraseRootFromParent_Done,
     /* 2027044 */   // Label 27021: @2027044
     /* 2027044 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2027135), // Rule ID 2718 //
     /* 2027049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2027066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2027069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027095 */     // MIs[0] round
     /* 2027095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027098 */     // MIs[0] policy
     /* 2027098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027108 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2027111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027134 */     // GIR_Coverage, 2718,
     /* 2027134 */     GIR_EraseRootFromParent_Done,
     /* 2027135 */   // Label 27022: @2027135
     /* 2027135 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2027226), // Rule ID 2719 //
     /* 2027140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2027157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2027160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027186 */     // MIs[0] round
     /* 2027186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027189 */     // MIs[0] policy
     /* 2027189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027199 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2027202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027225 */     // GIR_Coverage, 2719,
     /* 2027225 */     GIR_EraseRootFromParent_Done,
     /* 2027226 */   // Label 27023: @2027226
     /* 2027226 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2027317), // Rule ID 2762 //
     /* 2027231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2027234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2027239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2027248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2027251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027277 */     // MIs[0] round
     /* 2027277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027280 */     // MIs[0] policy
     /* 2027280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2027293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027316 */     // GIR_Coverage, 2762,
     /* 2027316 */     GIR_EraseRootFromParent_Done,
     /* 2027317 */   // Label 27024: @2027317
     /* 2027317 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2027408), // Rule ID 2763 //
     /* 2027322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2027325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2027330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2027339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2027342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027368 */     // MIs[0] round
     /* 2027368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027371 */     // MIs[0] policy
     /* 2027371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027381 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2027384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027407 */     // GIR_Coverage, 2763,
     /* 2027407 */     GIR_EraseRootFromParent_Done,
     /* 2027408 */   // Label 27025: @2027408
     /* 2027408 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2027499), // Rule ID 2770 //
     /* 2027413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2027416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2027421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2027424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2027427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2027433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027459 */     // MIs[0] round
     /* 2027459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027462 */     // MIs[0] policy
     /* 2027462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027472 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2027475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2027479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027498 */     // GIR_Coverage, 2770,
     /* 2027498 */     GIR_EraseRootFromParent_Done,
     /* 2027499 */   // Label 27026: @2027499
     /* 2027499 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2027590), // Rule ID 2771 //
     /* 2027504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2027507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2027512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2027515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2027518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2027524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027550 */     // MIs[0] round
     /* 2027550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027553 */     // MIs[0] policy
     /* 2027553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027563 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2027566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2027570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027589 */     // GIR_Coverage, 2771,
     /* 2027589 */     GIR_EraseRootFromParent_Done,
     /* 2027590 */   // Label 27027: @2027590
     /* 2027590 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2027681), // Rule ID 14928 //
     /* 2027595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2027612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2027615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027641 */     // MIs[0] round
     /* 2027641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027644 */     // MIs[0] policy
     /* 2027644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2027657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027680 */     // GIR_Coverage, 14928,
     /* 2027680 */     GIR_EraseRootFromParent_Done,
     /* 2027681 */   // Label 27028: @2027681
     /* 2027681 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2027772), // Rule ID 14929 //
     /* 2027686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2027703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2027706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027732 */     // MIs[0] round
     /* 2027732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027735 */     // MIs[0] policy
     /* 2027735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027745 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2027748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027771 */     // GIR_Coverage, 14929,
     /* 2027771 */     GIR_EraseRootFromParent_Done,
     /* 2027772 */   // Label 27029: @2027772
     /* 2027772 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2027863), // Rule ID 14932 //
     /* 2027777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2027788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2027791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2027794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2027797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027823 */     // MIs[0] round
     /* 2027823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027826 */     // MIs[0] policy
     /* 2027826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2027839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027862 */     // GIR_Coverage, 14932,
     /* 2027862 */     GIR_EraseRootFromParent_Done,
     /* 2027863 */   // Label 27030: @2027863
     /* 2027863 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2027954), // Rule ID 14933 //
     /* 2027868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2027879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2027882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2027885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2027888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027914 */     // MIs[0] round
     /* 2027914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027917 */     // MIs[0] policy
     /* 2027917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2027930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027953 */     // GIR_Coverage, 14933,
     /* 2027953 */     GIR_EraseRootFromParent_Done,
     /* 2027954 */   // Label 27031: @2027954
     /* 2027954 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2028045), // Rule ID 14936 //
     /* 2027959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2027970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2027973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2027979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028005 */     // MIs[0] round
     /* 2028005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028008 */     // MIs[0] policy
     /* 2028008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2028021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028044 */     // GIR_Coverage, 14936,
     /* 2028044 */     GIR_EraseRootFromParent_Done,
     /* 2028045 */   // Label 27032: @2028045
     /* 2028045 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2028136), // Rule ID 14937 //
     /* 2028050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2028061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2028064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2028067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2028070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028096 */     // MIs[0] round
     /* 2028096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028099 */     // MIs[0] policy
     /* 2028099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028109 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2028112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028135 */     // GIR_Coverage, 14937,
     /* 2028135 */     GIR_EraseRootFromParent_Done,
     /* 2028136 */   // Label 27033: @2028136
     /* 2028136 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2028227), // Rule ID 14940 //
     /* 2028141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2028152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2028155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2028161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028187 */     // MIs[0] round
     /* 2028187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028190 */     // MIs[0] policy
     /* 2028190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2028203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028226 */     // GIR_Coverage, 14940,
     /* 2028226 */     GIR_EraseRootFromParent_Done,
     /* 2028227 */   // Label 27034: @2028227
     /* 2028227 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2028318), // Rule ID 14941 //
     /* 2028232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2028243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2028246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2028249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2028252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028278 */     // MIs[0] round
     /* 2028278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028281 */     // MIs[0] policy
     /* 2028281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028291 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2028294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028317 */     // GIR_Coverage, 14941,
     /* 2028317 */     GIR_EraseRootFromParent_Done,
     /* 2028318 */   // Label 27035: @2028318
     /* 2028318 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2028409), // Rule ID 14944 //
     /* 2028323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2028334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2028337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2028340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2028343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028369 */     // MIs[0] round
     /* 2028369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028372 */     // MIs[0] policy
     /* 2028372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2028385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028408 */     // GIR_Coverage, 14944,
     /* 2028408 */     GIR_EraseRootFromParent_Done,
     /* 2028409 */   // Label 27036: @2028409
     /* 2028409 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2028500), // Rule ID 14945 //
     /* 2028414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2028425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2028428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2028431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2028434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028460 */     // MIs[0] round
     /* 2028460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028463 */     // MIs[0] policy
     /* 2028463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2028476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028499 */     // GIR_Coverage, 14945,
     /* 2028499 */     GIR_EraseRootFromParent_Done,
     /* 2028500 */   // Label 27037: @2028500
     /* 2028500 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2028591), // Rule ID 14948 //
     /* 2028505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2028522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2028525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028551 */     // MIs[0] round
     /* 2028551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028554 */     // MIs[0] policy
     /* 2028554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2028567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028590 */     // GIR_Coverage, 14948,
     /* 2028590 */     GIR_EraseRootFromParent_Done,
     /* 2028591 */   // Label 27038: @2028591
     /* 2028591 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2028682), // Rule ID 14949 //
     /* 2028596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2028613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2028616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028642 */     // MIs[0] round
     /* 2028642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028645 */     // MIs[0] policy
     /* 2028645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028655 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2028658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028681 */     // GIR_Coverage, 14949,
     /* 2028681 */     GIR_EraseRootFromParent_Done,
     /* 2028682 */   // Label 27039: @2028682
     /* 2028682 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2028773), // Rule ID 14952 //
     /* 2028687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2028698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2028701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2028707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028733 */     // MIs[0] round
     /* 2028733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028736 */     // MIs[0] policy
     /* 2028736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028746 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2028749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028772 */     // GIR_Coverage, 14952,
     /* 2028772 */     GIR_EraseRootFromParent_Done,
     /* 2028773 */   // Label 27040: @2028773
     /* 2028773 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2028864), // Rule ID 14953 //
     /* 2028778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2028789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2028792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2028798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028824 */     // MIs[0] round
     /* 2028824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028827 */     // MIs[0] policy
     /* 2028827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028837 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2028840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028863 */     // GIR_Coverage, 14953,
     /* 2028863 */     GIR_EraseRootFromParent_Done,
     /* 2028864 */   // Label 27041: @2028864
     /* 2028864 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2028955), // Rule ID 14956 //
     /* 2028869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2028880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2028883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2028886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2028889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028915 */     // MIs[0] round
     /* 2028915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028918 */     // MIs[0] policy
     /* 2028918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028928 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2028931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028954 */     // GIR_Coverage, 14956,
     /* 2028954 */     GIR_EraseRootFromParent_Done,
     /* 2028955 */   // Label 27042: @2028955
     /* 2028955 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2029046), // Rule ID 14957 //
     /* 2028960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2028971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2028974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2028977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2028980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029006 */     // MIs[0] round
     /* 2029006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029009 */     // MIs[0] policy
     /* 2029009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2029022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2029042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029045 */     // GIR_Coverage, 14957,
     /* 2029045 */     GIR_EraseRootFromParent_Done,
     /* 2029046 */   // Label 27043: @2029046
     /* 2029046 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2029137), // Rule ID 14960 //
     /* 2029051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2029054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2029062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2029065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2029071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029097 */     // MIs[0] round
     /* 2029097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029100 */     // MIs[0] policy
     /* 2029100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2029113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2029133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029136 */     // GIR_Coverage, 14960,
     /* 2029136 */     GIR_EraseRootFromParent_Done,
     /* 2029137 */   // Label 27044: @2029137
     /* 2029137 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2029228), // Rule ID 14961 //
     /* 2029142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2029145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2029153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2029156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2029162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029188 */     // MIs[0] round
     /* 2029188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029191 */     // MIs[0] policy
     /* 2029191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029201 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2029204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2029224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029227 */     // GIR_Coverage, 14961,
     /* 2029227 */     GIR_EraseRootFromParent_Done,
     /* 2029228 */   // Label 27045: @2029228
     /* 2029228 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2029319), // Rule ID 14964 //
     /* 2029233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2029250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2029253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029279 */     // MIs[0] round
     /* 2029279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029282 */     // MIs[0] policy
     /* 2029282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2029295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029318 */     // GIR_Coverage, 14964,
     /* 2029318 */     GIR_EraseRootFromParent_Done,
     /* 2029319 */   // Label 27046: @2029319
     /* 2029319 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2029410), // Rule ID 14965 //
     /* 2029324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2029335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2029338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2029341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2029344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029370 */     // MIs[0] round
     /* 2029370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029373 */     // MIs[0] policy
     /* 2029373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2029386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029409 */     // GIR_Coverage, 14965,
     /* 2029409 */     GIR_EraseRootFromParent_Done,
     /* 2029410 */   // Label 27047: @2029410
     /* 2029410 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2029501), // Rule ID 14968 //
     /* 2029415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2029432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2029435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029461 */     // MIs[0] round
     /* 2029461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029464 */     // MIs[0] policy
     /* 2029464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029474 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2029477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029500 */     // GIR_Coverage, 14968,
     /* 2029500 */     GIR_EraseRootFromParent_Done,
     /* 2029501 */   // Label 27048: @2029501
     /* 2029501 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2029592), // Rule ID 14969 //
     /* 2029506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2029523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2029526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029552 */     // MIs[0] round
     /* 2029552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029555 */     // MIs[0] policy
     /* 2029555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029565 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2029568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029591 */     // GIR_Coverage, 14969,
     /* 2029591 */     GIR_EraseRootFromParent_Done,
     /* 2029592 */   // Label 27049: @2029592
     /* 2029592 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2029683), // Rule ID 14972 //
     /* 2029597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2029608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2029611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2029614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2029617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2029620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029643 */     // MIs[0] round
     /* 2029643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029646 */     // MIs[0] policy
     /* 2029646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2029659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029682 */     // GIR_Coverage, 14972,
     /* 2029682 */     GIR_EraseRootFromParent_Done,
     /* 2029683 */   // Label 27050: @2029683
     /* 2029683 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2029774), // Rule ID 14973 //
     /* 2029688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2029699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2029702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2029705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2029708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2029711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029734 */     // MIs[0] round
     /* 2029734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029737 */     // MIs[0] policy
     /* 2029737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029747 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2029750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029773 */     // GIR_Coverage, 14973,
     /* 2029773 */     GIR_EraseRootFromParent_Done,
     /* 2029774 */   // Label 27051: @2029774
     /* 2029774 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2029865), // Rule ID 14976 //
     /* 2029779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2029799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029825 */     // MIs[0] round
     /* 2029825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029828 */     // MIs[0] policy
     /* 2029828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2029841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029864 */     // GIR_Coverage, 14976,
     /* 2029864 */     GIR_EraseRootFromParent_Done,
     /* 2029865 */   // Label 27052: @2029865
     /* 2029865 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2029956), // Rule ID 14977 //
     /* 2029870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2029890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029916 */     // MIs[0] round
     /* 2029916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029919 */     // MIs[0] policy
     /* 2029919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2029932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029955 */     // GIR_Coverage, 14977,
     /* 2029955 */     GIR_EraseRootFromParent_Done,
     /* 2029956 */   // Label 27053: @2029956
     /* 2029956 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2030047), // Rule ID 14980 //
     /* 2029961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2029981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030007 */     // MIs[0] round
     /* 2030007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030010 */     // MIs[0] policy
     /* 2030010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030020 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2030023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030046 */     // GIR_Coverage, 14980,
     /* 2030046 */     GIR_EraseRootFromParent_Done,
     /* 2030047 */   // Label 27054: @2030047
     /* 2030047 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2030138), // Rule ID 14981 //
     /* 2030052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2030063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2030066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2030069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2030072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030098 */     // MIs[0] round
     /* 2030098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030101 */     // MIs[0] policy
     /* 2030101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030111 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2030114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030137 */     // GIR_Coverage, 14981,
     /* 2030137 */     GIR_EraseRootFromParent_Done,
     /* 2030138 */   // Label 27055: @2030138
     /* 2030138 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2030229), // Rule ID 14984 //
     /* 2030143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2030154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2030157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2030160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2030163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2030166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030189 */     // MIs[0] round
     /* 2030189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030192 */     // MIs[0] policy
     /* 2030192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2030205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030228 */     // GIR_Coverage, 14984,
     /* 2030228 */     GIR_EraseRootFromParent_Done,
     /* 2030229 */   // Label 27056: @2030229
     /* 2030229 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2030320), // Rule ID 14985 //
     /* 2030234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2030245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2030248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2030251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2030254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2030257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030280 */     // MIs[0] round
     /* 2030280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030283 */     // MIs[0] policy
     /* 2030283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030293 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2030296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030319 */     // GIR_Coverage, 14985,
     /* 2030319 */     GIR_EraseRootFromParent_Done,
     /* 2030320 */   // Label 27057: @2030320
     /* 2030320 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2030411), // Rule ID 14988 //
     /* 2030325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2030345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030371 */     // MIs[0] round
     /* 2030371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030374 */     // MIs[0] policy
     /* 2030374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2030387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030410 */     // GIR_Coverage, 14988,
     /* 2030410 */     GIR_EraseRootFromParent_Done,
     /* 2030411 */   // Label 27058: @2030411
     /* 2030411 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2030502), // Rule ID 14989 //
     /* 2030416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2030436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030462 */     // MIs[0] round
     /* 2030462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030465 */     // MIs[0] policy
     /* 2030465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2030478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030501 */     // GIR_Coverage, 14989,
     /* 2030501 */     GIR_EraseRootFromParent_Done,
     /* 2030502 */   // Label 27059: @2030502
     /* 2030502 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2030593), // Rule ID 14992 //
     /* 2030507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2030527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030553 */     // MIs[0] round
     /* 2030553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030556 */     // MIs[0] policy
     /* 2030556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2030569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030592 */     // GIR_Coverage, 14992,
     /* 2030592 */     GIR_EraseRootFromParent_Done,
     /* 2030593 */   // Label 27060: @2030593
     /* 2030593 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2030684), // Rule ID 14993 //
     /* 2030598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2030618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030644 */     // MIs[0] round
     /* 2030644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030647 */     // MIs[0] policy
     /* 2030647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030657 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2030660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030683 */     // GIR_Coverage, 14993,
     /* 2030683 */     GIR_EraseRootFromParent_Done,
     /* 2030684 */   // Label 27061: @2030684
     /* 2030684 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2030775), // Rule ID 14996 //
     /* 2030689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2030709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030735 */     // MIs[0] round
     /* 2030735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030738 */     // MIs[0] policy
     /* 2030738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2030751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030774 */     // GIR_Coverage, 14996,
     /* 2030774 */     GIR_EraseRootFromParent_Done,
     /* 2030775 */   // Label 27062: @2030775
     /* 2030775 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2030866), // Rule ID 14997 //
     /* 2030780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2030800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030826 */     // MIs[0] round
     /* 2030826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030829 */     // MIs[0] policy
     /* 2030829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030839 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2030842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030865 */     // GIR_Coverage, 14997,
     /* 2030865 */     GIR_EraseRootFromParent_Done,
     /* 2030866 */   // Label 27063: @2030866
     /* 2030866 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2030957), // Rule ID 15000 //
     /* 2030871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2030874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2030882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2030885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2030891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030917 */     // MIs[0] round
     /* 2030917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030920 */     // MIs[0] policy
     /* 2030920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2030933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030956 */     // GIR_Coverage, 15000,
     /* 2030956 */     GIR_EraseRootFromParent_Done,
     /* 2030957 */   // Label 27064: @2030957
     /* 2030957 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2031048), // Rule ID 15001 //
     /* 2030962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2030965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2030973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2030976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2030982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031008 */     // MIs[0] round
     /* 2031008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031011 */     // MIs[0] policy
     /* 2031011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2031024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031047 */     // GIR_Coverage, 15001,
     /* 2031047 */     GIR_EraseRootFromParent_Done,
     /* 2031048 */   // Label 27065: @2031048
     /* 2031048 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2031139), // Rule ID 15004 //
     /* 2031053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2031056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2031064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2031067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2031073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031099 */     // MIs[0] round
     /* 2031099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031102 */     // MIs[0] policy
     /* 2031102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031112 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2031115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031138 */     // GIR_Coverage, 15004,
     /* 2031138 */     GIR_EraseRootFromParent_Done,
     /* 2031139 */   // Label 27066: @2031139
     /* 2031139 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2031230), // Rule ID 15005 //
     /* 2031144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2031147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2031155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2031158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2031161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2031164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031190 */     // MIs[0] round
     /* 2031190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031193 */     // MIs[0] policy
     /* 2031193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031203 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2031206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031229 */     // GIR_Coverage, 15005,
     /* 2031229 */     GIR_EraseRootFromParent_Done,
     /* 2031230 */   // Label 27067: @2031230
     /* 2031230 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2031321), // Rule ID 15008 //
     /* 2031235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2031238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2031246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2031249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2031255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031281 */     // MIs[0] round
     /* 2031281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031284 */     // MIs[0] policy
     /* 2031284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2031297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031320 */     // GIR_Coverage, 15008,
     /* 2031320 */     GIR_EraseRootFromParent_Done,
     /* 2031321 */   // Label 27068: @2031321
     /* 2031321 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2031412), // Rule ID 15009 //
     /* 2031326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2031329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2031337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2031340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2031343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2031346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031372 */     // MIs[0] round
     /* 2031372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031375 */     // MIs[0] policy
     /* 2031375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031385 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2031388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031411 */     // GIR_Coverage, 15009,
     /* 2031411 */     GIR_EraseRootFromParent_Done,
     /* 2031412 */   // Label 27069: @2031412
     /* 2031412 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2031503), // Rule ID 15012 //
     /* 2031417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2031434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031463 */     // MIs[0] round
     /* 2031463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031466 */     // MIs[0] policy
     /* 2031466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2031479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031502 */     // GIR_Coverage, 15012,
     /* 2031502 */     GIR_EraseRootFromParent_Done,
     /* 2031503 */   // Label 27070: @2031503
     /* 2031503 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2031594), // Rule ID 15013 //
     /* 2031508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2031525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031554 */     // MIs[0] round
     /* 2031554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031557 */     // MIs[0] policy
     /* 2031557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031567 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2031570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031593 */     // GIR_Coverage, 15013,
     /* 2031593 */     GIR_EraseRootFromParent_Done,
     /* 2031594 */   // Label 27071: @2031594
     /* 2031594 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2031685), // Rule ID 15016 //
     /* 2031599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2031616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031645 */     // MIs[0] round
     /* 2031645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031648 */     // MIs[0] policy
     /* 2031648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031658 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2031661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031684 */     // GIR_Coverage, 15016,
     /* 2031684 */     GIR_EraseRootFromParent_Done,
     /* 2031685 */   // Label 27072: @2031685
     /* 2031685 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2031776), // Rule ID 15017 //
     /* 2031690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2031707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031736 */     // MIs[0] round
     /* 2031736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031739 */     // MIs[0] policy
     /* 2031739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031749 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2031752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031775 */     // GIR_Coverage, 15017,
     /* 2031775 */     GIR_EraseRootFromParent_Done,
     /* 2031776 */   // Label 27073: @2031776
     /* 2031776 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2031867), // Rule ID 15020 //
     /* 2031781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2031792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2031795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2031798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031827 */     // MIs[0] round
     /* 2031827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031830 */     // MIs[0] policy
     /* 2031830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2031843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031866 */     // GIR_Coverage, 15020,
     /* 2031866 */     GIR_EraseRootFromParent_Done,
     /* 2031867 */   // Label 27074: @2031867
     /* 2031867 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2031958), // Rule ID 15021 //
     /* 2031872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2031883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2031886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2031889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2031892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031918 */     // MIs[0] round
     /* 2031918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031921 */     // MIs[0] policy
     /* 2031921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031931 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2031934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031957 */     // GIR_Coverage, 15021,
     /* 2031957 */     GIR_EraseRootFromParent_Done,
     /* 2031958 */   // Label 27075: @2031958
     /* 2031958 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2032049), // Rule ID 15024 //
     /* 2031963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2031971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2031974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2031977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2031983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032009 */     // MIs[0] round
     /* 2032009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032012 */     // MIs[0] policy
     /* 2032012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2032025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032048 */     // GIR_Coverage, 15024,
     /* 2032048 */     GIR_EraseRootFromParent_Done,
     /* 2032049 */   // Label 27076: @2032049
     /* 2032049 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2032140), // Rule ID 15025 //
     /* 2032054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2032065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2032068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2032071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032100 */     // MIs[0] round
     /* 2032100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032103 */     // MIs[0] policy
     /* 2032103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032113 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2032116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032139 */     // GIR_Coverage, 15025,
     /* 2032139 */     GIR_EraseRootFromParent_Done,
     /* 2032140 */   // Label 27077: @2032140
     /* 2032140 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2032231), // Rule ID 15028 //
     /* 2032145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2032156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2032159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2032162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032191 */     // MIs[0] round
     /* 2032191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032194 */     // MIs[0] policy
     /* 2032194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2032207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032230 */     // GIR_Coverage, 15028,
     /* 2032230 */     GIR_EraseRootFromParent_Done,
     /* 2032231 */   // Label 27078: @2032231
     /* 2032231 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2032322), // Rule ID 15029 //
     /* 2032236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2032247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2032250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2032253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032282 */     // MIs[0] round
     /* 2032282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032285 */     // MIs[0] policy
     /* 2032285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032295 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2032298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032321 */     // GIR_Coverage, 15029,
     /* 2032321 */     GIR_EraseRootFromParent_Done,
     /* 2032322 */   // Label 27079: @2032322
     /* 2032322 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2032413), // Rule ID 15032 //
     /* 2032327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032373 */     // MIs[0] round
     /* 2032373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032376 */     // MIs[0] policy
     /* 2032376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2032389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032412 */     // GIR_Coverage, 15032,
     /* 2032412 */     GIR_EraseRootFromParent_Done,
     /* 2032413 */   // Label 27080: @2032413
     /* 2032413 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2032504), // Rule ID 15033 //
     /* 2032418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032464 */     // MIs[0] round
     /* 2032464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032467 */     // MIs[0] policy
     /* 2032467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2032480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032503 */     // GIR_Coverage, 15033,
     /* 2032503 */     GIR_EraseRootFromParent_Done,
     /* 2032504 */   // Label 27081: @2032504
     /* 2032504 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2032595), // Rule ID 15036 //
     /* 2032509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2032526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032555 */     // MIs[0] round
     /* 2032555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032558 */     // MIs[0] policy
     /* 2032558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2032571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032594 */     // GIR_Coverage, 15036,
     /* 2032594 */     GIR_EraseRootFromParent_Done,
     /* 2032595 */   // Label 27082: @2032595
     /* 2032595 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2032686), // Rule ID 15037 //
     /* 2032600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2032617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032646 */     // MIs[0] round
     /* 2032646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032649 */     // MIs[0] policy
     /* 2032649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11080:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2032662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032685 */     // GIR_Coverage, 15037,
     /* 2032685 */     GIR_EraseRootFromParent_Done,
     /* 2032686 */   // Label 27083: @2032686
     /* 2032686 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2032777), // Rule ID 15040 //
     /* 2032691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032737 */     // MIs[0] round
     /* 2032737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032740 */     // MIs[0] policy
     /* 2032740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2032753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032776 */     // GIR_Coverage, 15040,
     /* 2032776 */     GIR_EraseRootFromParent_Done,
     /* 2032777 */   // Label 27084: @2032777
     /* 2032777 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2032868), // Rule ID 15041 //
     /* 2032782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032828 */     // MIs[0] round
     /* 2032828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032831 */     // MIs[0] policy
     /* 2032831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032841 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11080:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2032844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032867 */     // GIR_Coverage, 15041,
     /* 2032867 */     GIR_EraseRootFromParent_Done,
     /* 2032868 */   // Label 27085: @2032868
     /* 2032868 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2032959), // Rule ID 15044 //
     /* 2032873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2032893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2032915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032919 */     // MIs[0] round
     /* 2032919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032922 */     // MIs[0] policy
     /* 2032922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032932 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2032935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032958 */     // GIR_Coverage, 15044,
     /* 2032958 */     GIR_EraseRootFromParent_Done,
     /* 2032959 */   // Label 27086: @2032959
     /* 2032959 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2033050), // Rule ID 15045 //
     /* 2032964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2032972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2032984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033010 */     // MIs[0] round
     /* 2033010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033013 */     // MIs[0] policy
     /* 2033013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033023 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2033026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033049 */     // GIR_Coverage, 15045,
     /* 2033049 */     GIR_EraseRootFromParent_Done,
     /* 2033050 */   // Label 27087: @2033050
     /* 2033050 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2033141), // Rule ID 15048 //
     /* 2033055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2033058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2033072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033101 */     // MIs[0] round
     /* 2033101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033104 */     // MIs[0] policy
     /* 2033104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2033117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2033137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033140 */     // GIR_Coverage, 15048,
     /* 2033140 */     GIR_EraseRootFromParent_Done,
     /* 2033141 */   // Label 27088: @2033141
     /* 2033141 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2033232), // Rule ID 15049 //
     /* 2033146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2033149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2033163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033192 */     // MIs[0] round
     /* 2033192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033195 */     // MIs[0] policy
     /* 2033195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033205 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2033208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2033228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033231 */     // GIR_Coverage, 15049,
     /* 2033231 */     GIR_EraseRootFromParent_Done,
     /* 2033232 */   // Label 27089: @2033232
     /* 2033232 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2033323), // Rule ID 15052 //
     /* 2033237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2033248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2033251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2033254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033283 */     // MIs[0] round
     /* 2033283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033286 */     // MIs[0] policy
     /* 2033286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033296 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2033299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033322 */     // GIR_Coverage, 15052,
     /* 2033322 */     GIR_EraseRootFromParent_Done,
     /* 2033323 */   // Label 27090: @2033323
     /* 2033323 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2033414), // Rule ID 15053 //
     /* 2033328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2033339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2033342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2033345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033374 */     // MIs[0] round
     /* 2033374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033377 */     // MIs[0] policy
     /* 2033377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033387 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2033390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033413 */     // GIR_Coverage, 15053,
     /* 2033413 */     GIR_EraseRootFromParent_Done,
     /* 2033414 */   // Label 27091: @2033414
     /* 2033414 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2033505), // Rule ID 15056 //
     /* 2033419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2033430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2033433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2033436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033465 */     // MIs[0] round
     /* 2033465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033468 */     // MIs[0] policy
     /* 2033468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033478 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2033481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033504 */     // GIR_Coverage, 15056,
     /* 2033504 */     GIR_EraseRootFromParent_Done,
     /* 2033505 */   // Label 27092: @2033505
     /* 2033505 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2033596), // Rule ID 15057 //
     /* 2033510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2033521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2033524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2033527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033556 */     // MIs[0] round
     /* 2033556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033559 */     // MIs[0] policy
     /* 2033559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2033572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033595 */     // GIR_Coverage, 15057,
     /* 2033595 */     GIR_EraseRootFromParent_Done,
     /* 2033596 */   // Label 27093: @2033596
     /* 2033596 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2033687), // Rule ID 15060 //
     /* 2033601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2033612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2033615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2033618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2033624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033647 */     // MIs[0] round
     /* 2033647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033650 */     // MIs[0] policy
     /* 2033650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2033663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033686 */     // GIR_Coverage, 15060,
     /* 2033686 */     GIR_EraseRootFromParent_Done,
     /* 2033687 */   // Label 27094: @2033687
     /* 2033687 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2033778), // Rule ID 15061 //
     /* 2033692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2033703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2033706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2033709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2033715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033738 */     // MIs[0] round
     /* 2033738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033741 */     // MIs[0] policy
     /* 2033741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033751 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2033754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033777 */     // GIR_Coverage, 15061,
     /* 2033777 */     GIR_EraseRootFromParent_Done,
     /* 2033778 */   // Label 27095: @2033778
     /* 2033778 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2033869), // Rule ID 15064 //
     /* 2033783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2033800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033829 */     // MIs[0] round
     /* 2033829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033832 */     // MIs[0] policy
     /* 2033832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2033845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033868 */     // GIR_Coverage, 15064,
     /* 2033868 */     GIR_EraseRootFromParent_Done,
     /* 2033869 */   // Label 27096: @2033869
     /* 2033869 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2033960), // Rule ID 15065 //
     /* 2033874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2033891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2033894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2033916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033920 */     // MIs[0] round
     /* 2033920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033923 */     // MIs[0] policy
     /* 2033923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2033936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033959 */     // GIR_Coverage, 15065,
     /* 2033959 */     GIR_EraseRootFromParent_Done,
     /* 2033960 */   // Label 27097: @2033960
     /* 2033960 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2034051), // Rule ID 15068 //
     /* 2033965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2033976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2033979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2033982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2033985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034011 */     // MIs[0] round
     /* 2034011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034014 */     // MIs[0] policy
     /* 2034014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2034027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034050 */     // GIR_Coverage, 15068,
     /* 2034050 */     GIR_EraseRootFromParent_Done,
     /* 2034051 */   // Label 27098: @2034051
     /* 2034051 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2034142), // Rule ID 15069 //
     /* 2034056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2034067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2034070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2034073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2034079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034102 */     // MIs[0] round
     /* 2034102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034105 */     // MIs[0] policy
     /* 2034105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034115 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2034118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034141 */     // GIR_Coverage, 15069,
     /* 2034141 */     GIR_EraseRootFromParent_Done,
     /* 2034142 */   // Label 27099: @2034142
     /* 2034142 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2034233), // Rule ID 15072 //
     /* 2034147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2034158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2034161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2034164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2034170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034193 */     // MIs[0] round
     /* 2034193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034196 */     // MIs[0] policy
     /* 2034196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2034209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034232 */     // GIR_Coverage, 15072,
     /* 2034232 */     GIR_EraseRootFromParent_Done,
     /* 2034233 */   // Label 27100: @2034233
     /* 2034233 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2034324), // Rule ID 15073 //
     /* 2034238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2034249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2034252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2034255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2034261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034284 */     // MIs[0] round
     /* 2034284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034287 */     // MIs[0] policy
     /* 2034287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034297 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2034300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034323 */     // GIR_Coverage, 15073,
     /* 2034323 */     GIR_EraseRootFromParent_Done,
     /* 2034324 */   // Label 27101: @2034324
     /* 2034324 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2034415), // Rule ID 15076 //
     /* 2034329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2034343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2034346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034375 */     // MIs[0] round
     /* 2034375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034378 */     // MIs[0] policy
     /* 2034378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2034391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034414 */     // GIR_Coverage, 15076,
     /* 2034414 */     GIR_EraseRootFromParent_Done,
     /* 2034415 */   // Label 27102: @2034415
     /* 2034415 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2034506), // Rule ID 15077 //
     /* 2034420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2034434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2034437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034466 */     // MIs[0] round
     /* 2034466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034469 */     // MIs[0] policy
     /* 2034469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2034482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034505 */     // GIR_Coverage, 15077,
     /* 2034505 */     GIR_EraseRootFromParent_Done,
     /* 2034506 */   // Label 27103: @2034506
     /* 2034506 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2034597), // Rule ID 15080 //
     /* 2034511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2034528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034557 */     // MIs[0] round
     /* 2034557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034560 */     // MIs[0] policy
     /* 2034560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2034573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034596 */     // GIR_Coverage, 15080,
     /* 2034596 */     GIR_EraseRootFromParent_Done,
     /* 2034597 */   // Label 27104: @2034597
     /* 2034597 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2034688), // Rule ID 15081 //
     /* 2034602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2034619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034648 */     // MIs[0] round
     /* 2034648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034651 */     // MIs[0] policy
     /* 2034651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2034664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034687 */     // GIR_Coverage, 15081,
     /* 2034687 */     GIR_EraseRootFromParent_Done,
     /* 2034688 */   // Label 27105: @2034688
     /* 2034688 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2034779), // Rule ID 15084 //
     /* 2034693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2034704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2034707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2034710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2034716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034739 */     // MIs[0] round
     /* 2034739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034742 */     // MIs[0] policy
     /* 2034742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2034755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034778 */     // GIR_Coverage, 15084,
     /* 2034778 */     GIR_EraseRootFromParent_Done,
     /* 2034779 */   // Label 27106: @2034779
     /* 2034779 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2034870), // Rule ID 15085 //
     /* 2034784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2034795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2034798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2034801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2034807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034830 */     // MIs[0] round
     /* 2034830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034833 */     // MIs[0] policy
     /* 2034833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2034846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034869 */     // GIR_Coverage, 15085,
     /* 2034869 */     GIR_EraseRootFromParent_Done,
     /* 2034870 */   // Label 27107: @2034870
     /* 2034870 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2034961), // Rule ID 15088 //
     /* 2034875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2034878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2034886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2034889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2034895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2034917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034921 */     // MIs[0] round
     /* 2034921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034924 */     // MIs[0] policy
     /* 2034924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2034937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034960 */     // GIR_Coverage, 15088,
     /* 2034960 */     GIR_EraseRootFromParent_Done,
     /* 2034961 */   // Label 27108: @2034961
     /* 2034961 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2035052), // Rule ID 15089 //
     /* 2034966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2034969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2034977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2034980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2034986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2035004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035012 */     // MIs[0] round
     /* 2035012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035015 */     // MIs[0] policy
     /* 2035015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2035028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035051 */     // GIR_Coverage, 15089,
     /* 2035051 */     GIR_EraseRootFromParent_Done,
     /* 2035052 */   // Label 27109: @2035052
     /* 2035052 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2035143), // Rule ID 15092 //
     /* 2035057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2035060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2035068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2035071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2035074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035103 */     // MIs[0] round
     /* 2035103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035106 */     // MIs[0] policy
     /* 2035106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2035119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035142 */     // GIR_Coverage, 15092,
     /* 2035142 */     GIR_EraseRootFromParent_Done,
     /* 2035143 */   // Label 27110: @2035143
     /* 2035143 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2035234), // Rule ID 15093 //
     /* 2035148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2035151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2035159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2035162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2035165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2035178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2035186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035194 */     // MIs[0] round
     /* 2035194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035197 */     // MIs[0] policy
     /* 2035197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035207 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2035210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035233 */     // GIR_Coverage, 15093,
     /* 2035233 */     GIR_EraseRootFromParent_Done,
     /* 2035234 */   // Label 27111: @2035234
     /* 2035234 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2035325), // Rule ID 15096 //
     /* 2035239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2035242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2035250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2035253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2035256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035285 */     // MIs[0] round
     /* 2035285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035288 */     // MIs[0] policy
     /* 2035288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2035301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035324 */     // GIR_Coverage, 15096,
     /* 2035324 */     GIR_EraseRootFromParent_Done,
     /* 2035325 */   // Label 27112: @2035325
     /* 2035325 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2035416), // Rule ID 15097 //
     /* 2035330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2035333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2035341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2035344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2035347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035376 */     // MIs[0] round
     /* 2035376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035379 */     // MIs[0] policy
     /* 2035379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035389 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2035392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035415 */     // GIR_Coverage, 15097,
     /* 2035415 */     GIR_EraseRootFromParent_Done,
     /* 2035416 */   // Label 27113: @2035416
     /* 2035416 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2035507), // Rule ID 15100 //
     /* 2035421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2035432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2035435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2035438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2035441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035467 */     // MIs[0] round
     /* 2035467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035470 */     // MIs[0] policy
     /* 2035470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035480 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2035483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035506 */     // GIR_Coverage, 15100,
     /* 2035506 */     GIR_EraseRootFromParent_Done,
     /* 2035507 */   // Label 27114: @2035507
     /* 2035507 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2035598), // Rule ID 15101 //
     /* 2035512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2035523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2035526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2035529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2035532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035558 */     // MIs[0] round
     /* 2035558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035561 */     // MIs[0] policy
     /* 2035561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035571 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2035574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035597 */     // GIR_Coverage, 15101,
     /* 2035597 */     GIR_EraseRootFromParent_Done,
     /* 2035598 */   // Label 27115: @2035598
     /* 2035598 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2035689), // Rule ID 15104 //
     /* 2035603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2035623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035649 */     // MIs[0] round
     /* 2035649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035652 */     // MIs[0] policy
     /* 2035652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2035665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035688 */     // GIR_Coverage, 15104,
     /* 2035688 */     GIR_EraseRootFromParent_Done,
     /* 2035689 */   // Label 27116: @2035689
     /* 2035689 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2035780), // Rule ID 15105 //
     /* 2035694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2035714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035740 */     // MIs[0] round
     /* 2035740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035743 */     // MIs[0] policy
     /* 2035743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035753 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2035756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035779 */     // GIR_Coverage, 15105,
     /* 2035779 */     GIR_EraseRootFromParent_Done,
     /* 2035780 */   // Label 27117: @2035780
     /* 2035780 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2035871), // Rule ID 15108 //
     /* 2035785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035831 */     // MIs[0] round
     /* 2035831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035834 */     // MIs[0] policy
     /* 2035834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2035847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035870 */     // GIR_Coverage, 15108,
     /* 2035870 */     GIR_EraseRootFromParent_Done,
     /* 2035871 */   // Label 27118: @2035871
     /* 2035871 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2035962), // Rule ID 15109 //
     /* 2035876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2035896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035922 */     // MIs[0] round
     /* 2035922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035925 */     // MIs[0] policy
     /* 2035925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035935 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2035938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035961 */     // GIR_Coverage, 15109,
     /* 2035961 */     GIR_EraseRootFromParent_Done,
     /* 2035962 */   // Label 27119: @2035962
     /* 2035962 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2036053), // Rule ID 15112 //
     /* 2035967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2035987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036013 */     // MIs[0] round
     /* 2036013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036016 */     // MIs[0] policy
     /* 2036016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2036029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036052 */     // GIR_Coverage, 15112,
     /* 2036052 */     GIR_EraseRootFromParent_Done,
     /* 2036053 */   // Label 27120: @2036053
     /* 2036053 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2036144), // Rule ID 15113 //
     /* 2036058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2036069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2036072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2036075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2036078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036104 */     // MIs[0] round
     /* 2036104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036107 */     // MIs[0] policy
     /* 2036107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036117 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2036120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036143 */     // GIR_Coverage, 15113,
     /* 2036143 */     GIR_EraseRootFromParent_Done,
     /* 2036144 */   // Label 27121: @2036144
     /* 2036144 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2036235), // Rule ID 15116 //
     /* 2036149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2036160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2036163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2036166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2036169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036195 */     // MIs[0] round
     /* 2036195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036198 */     // MIs[0] policy
     /* 2036198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036208 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2036211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036234 */     // GIR_Coverage, 15116,
     /* 2036234 */     GIR_EraseRootFromParent_Done,
     /* 2036235 */   // Label 27122: @2036235
     /* 2036235 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2036326), // Rule ID 15117 //
     /* 2036240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2036251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2036254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2036257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2036260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036286 */     // MIs[0] round
     /* 2036286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036289 */     // MIs[0] policy
     /* 2036289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036299 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2036302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036325 */     // GIR_Coverage, 15117,
     /* 2036325 */     GIR_EraseRootFromParent_Done,
     /* 2036326 */   // Label 27123: @2036326
     /* 2036326 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2036417), // Rule ID 15120 //
     /* 2036331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2036342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2036345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2036348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2036351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036377 */     // MIs[0] round
     /* 2036377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036380 */     // MIs[0] policy
     /* 2036380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036390 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2036393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036416 */     // GIR_Coverage, 15120,
     /* 2036416 */     GIR_EraseRootFromParent_Done,
     /* 2036417 */   // Label 27124: @2036417
     /* 2036417 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2036508), // Rule ID 15121 //
     /* 2036422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2036433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2036436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2036439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2036442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036468 */     // MIs[0] round
     /* 2036468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036471 */     // MIs[0] policy
     /* 2036471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036481 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2036484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036507 */     // GIR_Coverage, 15121,
     /* 2036507 */     GIR_EraseRootFromParent_Done,
     /* 2036508 */   // Label 27125: @2036508
     /* 2036508 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2036599), // Rule ID 15124 //
     /* 2036513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2036524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2036527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2036530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2036533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036559 */     // MIs[0] round
     /* 2036559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036562 */     // MIs[0] policy
     /* 2036562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2036575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036598 */     // GIR_Coverage, 15124,
     /* 2036598 */     GIR_EraseRootFromParent_Done,
     /* 2036599 */   // Label 27126: @2036599
     /* 2036599 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2036690), // Rule ID 15125 //
     /* 2036604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2036615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2036618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2036621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2036624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036650 */     // MIs[0] round
     /* 2036650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036653 */     // MIs[0] policy
     /* 2036653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2036666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036689 */     // GIR_Coverage, 15125,
     /* 2036689 */     GIR_EraseRootFromParent_Done,
     /* 2036690 */   // Label 27127: @2036690
     /* 2036690 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2036781), // Rule ID 15128 //
     /* 2036695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036741 */     // MIs[0] round
     /* 2036741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036744 */     // MIs[0] policy
     /* 2036744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2036757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036780 */     // GIR_Coverage, 15128,
     /* 2036780 */     GIR_EraseRootFromParent_Done,
     /* 2036781 */   // Label 27128: @2036781
     /* 2036781 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2036872), // Rule ID 15129 //
     /* 2036786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2036806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036832 */     // MIs[0] round
     /* 2036832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036835 */     // MIs[0] policy
     /* 2036835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036845 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2036848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036871 */     // GIR_Coverage, 15129,
     /* 2036871 */     GIR_EraseRootFromParent_Done,
     /* 2036872 */   // Label 27129: @2036872
     /* 2036872 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2036963), // Rule ID 15132 //
     /* 2036877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036923 */     // MIs[0] round
     /* 2036923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036926 */     // MIs[0] policy
     /* 2036926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2036939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036962 */     // GIR_Coverage, 15132,
     /* 2036962 */     GIR_EraseRootFromParent_Done,
     /* 2036963 */   // Label 27130: @2036963
     /* 2036963 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2037054), // Rule ID 15133 //
     /* 2036968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2036988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037014 */     // MIs[0] round
     /* 2037014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037017 */     // MIs[0] policy
     /* 2037017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2037030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037053 */     // GIR_Coverage, 15133,
     /* 2037053 */     GIR_EraseRootFromParent_Done,
     /* 2037054 */   // Label 27131: @2037054
     /* 2037054 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2037145), // Rule ID 15136 //
     /* 2037059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2037062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2037070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2037073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2037076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2037079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037105 */     // MIs[0] round
     /* 2037105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037108 */     // MIs[0] policy
     /* 2037108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2037121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037144 */     // GIR_Coverage, 15136,
     /* 2037144 */     GIR_EraseRootFromParent_Done,
     /* 2037145 */   // Label 27132: @2037145
     /* 2037145 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2037236), // Rule ID 15137 //
     /* 2037150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2037153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2037161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2037164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2037167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2037170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2037173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2037180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2037192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037196 */     // MIs[0] round
     /* 2037196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037199 */     // MIs[0] policy
     /* 2037199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2037212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037235 */     // GIR_Coverage, 15137,
     /* 2037235 */     GIR_EraseRootFromParent_Done,
     /* 2037236 */   // Label 27133: @2037236
     /* 2037236 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2037327), // Rule ID 15140 //
     /* 2037241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2037252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2037255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2037258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2037261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037287 */     // MIs[0] round
     /* 2037287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037290 */     // MIs[0] policy
     /* 2037290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2037303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037326 */     // GIR_Coverage, 15140,
     /* 2037326 */     GIR_EraseRootFromParent_Done,
     /* 2037327 */   // Label 27134: @2037327
     /* 2037327 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2037418), // Rule ID 15141 //
     /* 2037332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2037343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2037346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2037349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2037352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037378 */     // MIs[0] round
     /* 2037378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037381 */     // MIs[0] policy
     /* 2037381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037391 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2037394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037417 */     // GIR_Coverage, 15141,
     /* 2037417 */     GIR_EraseRootFromParent_Done,
     /* 2037418 */   // Label 27135: @2037418
     /* 2037418 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2037509), // Rule ID 15144 //
     /* 2037423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2037434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2037437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2037440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2037443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037469 */     // MIs[0] round
     /* 2037469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037472 */     // MIs[0] policy
     /* 2037472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037482 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2037485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037508 */     // GIR_Coverage, 15144,
     /* 2037508 */     GIR_EraseRootFromParent_Done,
     /* 2037509 */   // Label 27136: @2037509
     /* 2037509 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2037600), // Rule ID 15145 //
     /* 2037514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2037525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2037528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2037531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2037534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037560 */     // MIs[0] round
     /* 2037560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037563 */     // MIs[0] policy
     /* 2037563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037573 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2037576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037599 */     // GIR_Coverage, 15145,
     /* 2037599 */     GIR_EraseRootFromParent_Done,
     /* 2037600 */   // Label 27137: @2037600
     /* 2037600 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2037691), // Rule ID 15148 //
     /* 2037605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2037625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037651 */     // MIs[0] round
     /* 2037651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037654 */     // MIs[0] policy
     /* 2037654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037664 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2037667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037690 */     // GIR_Coverage, 15148,
     /* 2037690 */     GIR_EraseRootFromParent_Done,
     /* 2037691 */   // Label 27138: @2037691
     /* 2037691 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2037782), // Rule ID 15149 //
     /* 2037696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2037716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037742 */     // MIs[0] round
     /* 2037742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037745 */     // MIs[0] policy
     /* 2037745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037755 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2037758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037781 */     // GIR_Coverage, 15149,
     /* 2037781 */     GIR_EraseRootFromParent_Done,
     /* 2037782 */   // Label 27139: @2037782
     /* 2037782 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2037873), // Rule ID 15152 //
     /* 2037787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037833 */     // MIs[0] round
     /* 2037833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037836 */     // MIs[0] policy
     /* 2037836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2037849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037872 */     // GIR_Coverage, 15152,
     /* 2037872 */     GIR_EraseRootFromParent_Done,
     /* 2037873 */   // Label 27140: @2037873
     /* 2037873 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2037964), // Rule ID 15153 //
     /* 2037878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2037898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037924 */     // MIs[0] round
     /* 2037924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037927 */     // MIs[0] policy
     /* 2037927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037937 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2037940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037963 */     // GIR_Coverage, 15153,
     /* 2037963 */     GIR_EraseRootFromParent_Done,
     /* 2037964 */   // Label 27141: @2037964
     /* 2037964 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2038055), // Rule ID 15156 //
     /* 2037969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2037989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038015 */     // MIs[0] round
     /* 2038015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038018 */     // MIs[0] policy
     /* 2038018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2038031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038054 */     // GIR_Coverage, 15156,
     /* 2038054 */     GIR_EraseRootFromParent_Done,
     /* 2038055 */   // Label 27142: @2038055
     /* 2038055 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2038146), // Rule ID 15157 //
     /* 2038060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2038071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2038074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2038077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2038080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038106 */     // MIs[0] round
     /* 2038106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038109 */     // MIs[0] policy
     /* 2038109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2038122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038145 */     // GIR_Coverage, 15157,
     /* 2038145 */     GIR_EraseRootFromParent_Done,
     /* 2038146 */   // Label 27143: @2038146
     /* 2038146 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2038237), // Rule ID 15160 //
     /* 2038151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2038162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2038165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2038168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2038171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2038174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038197 */     // MIs[0] round
     /* 2038197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038200 */     // MIs[0] policy
     /* 2038200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038210 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2038213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038236 */     // GIR_Coverage, 15160,
     /* 2038236 */     GIR_EraseRootFromParent_Done,
     /* 2038237 */   // Label 27144: @2038237
     /* 2038237 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2038328), // Rule ID 15161 //
     /* 2038242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2038253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2038256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2038259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2038262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2038265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038288 */     // MIs[0] round
     /* 2038288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038291 */     // MIs[0] policy
     /* 2038291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038301 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2038304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038327 */     // GIR_Coverage, 15161,
     /* 2038327 */     GIR_EraseRootFromParent_Done,
     /* 2038328 */   // Label 27145: @2038328
     /* 2038328 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2038419), // Rule ID 15164 //
     /* 2038333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2038344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2038347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2038353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038379 */     // MIs[0] round
     /* 2038379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038382 */     // MIs[0] policy
     /* 2038382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2038395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038418 */     // GIR_Coverage, 15164,
     /* 2038418 */     GIR_EraseRootFromParent_Done,
     /* 2038419 */   // Label 27146: @2038419
     /* 2038419 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2038510), // Rule ID 15165 //
     /* 2038424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2038435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2038438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2038444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038470 */     // MIs[0] round
     /* 2038470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038473 */     // MIs[0] policy
     /* 2038473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2038486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038509 */     // GIR_Coverage, 15165,
     /* 2038509 */     GIR_EraseRootFromParent_Done,
     /* 2038510 */   // Label 27147: @2038510
     /* 2038510 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2038601), // Rule ID 15168 //
     /* 2038515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2038526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2038529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2038535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038561 */     // MIs[0] round
     /* 2038561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038564 */     // MIs[0] policy
     /* 2038564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2038577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038600 */     // GIR_Coverage, 15168,
     /* 2038600 */     GIR_EraseRootFromParent_Done,
     /* 2038601 */   // Label 27148: @2038601
     /* 2038601 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2038692), // Rule ID 15169 //
     /* 2038606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2038617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2038620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2038626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038652 */     // MIs[0] round
     /* 2038652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038655 */     // MIs[0] policy
     /* 2038655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038665 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2038668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038691 */     // GIR_Coverage, 15169,
     /* 2038691 */     GIR_EraseRootFromParent_Done,
     /* 2038692 */   // Label 27149: @2038692
     /* 2038692 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2038783), // Rule ID 15172 //
     /* 2038697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038743 */     // MIs[0] round
     /* 2038743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038746 */     // MIs[0] policy
     /* 2038746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038756 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2038759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038782 */     // GIR_Coverage, 15172,
     /* 2038782 */     GIR_EraseRootFromParent_Done,
     /* 2038783 */   // Label 27150: @2038783
     /* 2038783 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2038874), // Rule ID 15173 //
     /* 2038788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2038808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038834 */     // MIs[0] round
     /* 2038834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038837 */     // MIs[0] policy
     /* 2038837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038847 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2038850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038873 */     // GIR_Coverage, 15173,
     /* 2038873 */     GIR_EraseRootFromParent_Done,
     /* 2038874 */   // Label 27151: @2038874
     /* 2038874 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2038965), // Rule ID 15176 //
     /* 2038879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038925 */     // MIs[0] round
     /* 2038925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038928 */     // MIs[0] policy
     /* 2038928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2038941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038964 */     // GIR_Coverage, 15176,
     /* 2038964 */     GIR_EraseRootFromParent_Done,
     /* 2038965 */   // Label 27152: @2038965
     /* 2038965 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2039056), // Rule ID 15177 //
     /* 2038970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2038990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2039000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2039012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039016 */     // MIs[0] round
     /* 2039016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039019 */     // MIs[0] policy
     /* 2039019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039029 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2039032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039055 */     // GIR_Coverage, 15177,
     /* 2039055 */     GIR_EraseRootFromParent_Done,
     /* 2039056 */   // Label 27153: @2039056
     /* 2039056 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2039147), // Rule ID 15180 //
     /* 2039061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2039064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2039072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2039075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2039078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2039081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2039091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039107 */     // MIs[0] round
     /* 2039107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039110 */     // MIs[0] policy
     /* 2039110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039120 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2039123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039146 */     // GIR_Coverage, 15180,
     /* 2039146 */     GIR_EraseRootFromParent_Done,
     /* 2039147 */   // Label 27154: @2039147
     /* 2039147 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2039238), // Rule ID 15181 //
     /* 2039152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2039155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2039163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2039166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2039169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2039172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2039182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2039194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039198 */     // MIs[0] round
     /* 2039198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039201 */     // MIs[0] policy
     /* 2039201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2039214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039237 */     // GIR_Coverage, 15181,
     /* 2039237 */     GIR_EraseRootFromParent_Done,
     /* 2039238 */   // Label 27155: @2039238
     /* 2039238 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2039329), // Rule ID 15184 //
     /* 2039243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2039246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2039254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2039257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2039260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2039263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2039273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039289 */     // MIs[0] round
     /* 2039289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039292 */     // MIs[0] policy
     /* 2039292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2039305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039328 */     // GIR_Coverage, 15184,
     /* 2039328 */     GIR_EraseRootFromParent_Done,
     /* 2039329 */   // Label 27156: @2039329
     /* 2039329 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2039420), // Rule ID 15185 //
     /* 2039334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2039337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2039345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2039348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2039351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2039354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2039364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039380 */     // MIs[0] round
     /* 2039380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039383 */     // MIs[0] policy
     /* 2039383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039393 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2039396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039419 */     // GIR_Coverage, 15185,
     /* 2039419 */     GIR_EraseRootFromParent_Done,
     /* 2039420 */   // Label 27157: @2039420
     /* 2039420 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2039511), // Rule ID 15188 //
     /* 2039425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2039436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2039439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2039442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039471 */     // MIs[0] round
     /* 2039471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039474 */     // MIs[0] policy
     /* 2039474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2039487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039510 */     // GIR_Coverage, 15188,
     /* 2039510 */     GIR_EraseRootFromParent_Done,
     /* 2039511 */   // Label 27158: @2039511
     /* 2039511 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2039602), // Rule ID 15189 //
     /* 2039516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2039527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2039530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2039533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039562 */     // MIs[0] round
     /* 2039562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039565 */     // MIs[0] policy
     /* 2039565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039575 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2039578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039601 */     // GIR_Coverage, 15189,
     /* 2039601 */     GIR_EraseRootFromParent_Done,
     /* 2039602 */   // Label 27159: @2039602
     /* 2039602 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2039693), // Rule ID 15192 //
     /* 2039607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039653 */     // MIs[0] round
     /* 2039653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039656 */     // MIs[0] policy
     /* 2039656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2039669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039692 */     // GIR_Coverage, 15192,
     /* 2039692 */     GIR_EraseRootFromParent_Done,
     /* 2039693 */   // Label 27160: @2039693
     /* 2039693 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2039784), // Rule ID 15193 //
     /* 2039698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039744 */     // MIs[0] round
     /* 2039744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039747 */     // MIs[0] policy
     /* 2039747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039757 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2039760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039783 */     // GIR_Coverage, 15193,
     /* 2039783 */     GIR_EraseRootFromParent_Done,
     /* 2039784 */   // Label 27161: @2039784
     /* 2039784 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2039875), // Rule ID 15196 //
     /* 2039789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039835 */     // MIs[0] round
     /* 2039835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039838 */     // MIs[0] policy
     /* 2039838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039848 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2039851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039874 */     // GIR_Coverage, 15196,
     /* 2039874 */     GIR_EraseRootFromParent_Done,
     /* 2039875 */   // Label 27162: @2039875
     /* 2039875 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2039966), // Rule ID 15197 //
     /* 2039880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039926 */     // MIs[0] round
     /* 2039926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039929 */     // MIs[0] policy
     /* 2039929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2039942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039965 */     // GIR_Coverage, 15197,
     /* 2039965 */     GIR_EraseRootFromParent_Done,
     /* 2039966 */   // Label 27163: @2039966
     /* 2039966 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2040057), // Rule ID 15200 //
     /* 2039971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2039979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040017 */     // MIs[0] round
     /* 2040017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040020 */     // MIs[0] policy
     /* 2040020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2040033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040056 */     // GIR_Coverage, 15200,
     /* 2040056 */     GIR_EraseRootFromParent_Done,
     /* 2040057 */   // Label 27164: @2040057
     /* 2040057 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2040148), // Rule ID 15201 //
     /* 2040062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2040073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2040076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2040079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040108 */     // MIs[0] round
     /* 2040108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040111 */     // MIs[0] policy
     /* 2040111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2040124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040147 */     // GIR_Coverage, 15201,
     /* 2040147 */     GIR_EraseRootFromParent_Done,
     /* 2040148 */   // Label 27165: @2040148
     /* 2040148 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2040239), // Rule ID 15204 //
     /* 2040153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2040164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2040167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2040170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040199 */     // MIs[0] round
     /* 2040199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040202 */     // MIs[0] policy
     /* 2040202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2040215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040238 */     // GIR_Coverage, 15204,
     /* 2040238 */     GIR_EraseRootFromParent_Done,
     /* 2040239 */   // Label 27166: @2040239
     /* 2040239 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2040330), // Rule ID 15205 //
     /* 2040244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2040255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2040258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2040261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040290 */     // MIs[0] round
     /* 2040290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040293 */     // MIs[0] policy
     /* 2040293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040303 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2040306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040329 */     // GIR_Coverage, 15205,
     /* 2040329 */     GIR_EraseRootFromParent_Done,
     /* 2040330 */   // Label 27167: @2040330
     /* 2040330 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2040421), // Rule ID 15208 //
     /* 2040335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2040346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040381 */     // MIs[0] round
     /* 2040381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040384 */     // MIs[0] policy
     /* 2040384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2040397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040420 */     // GIR_Coverage, 15208,
     /* 2040420 */     GIR_EraseRootFromParent_Done,
     /* 2040421 */   // Label 27168: @2040421
     /* 2040421 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2040512), // Rule ID 15209 //
     /* 2040426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2040437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040472 */     // MIs[0] round
     /* 2040472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040475 */     // MIs[0] policy
     /* 2040475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040485 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2040488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040511 */     // GIR_Coverage, 15209,
     /* 2040511 */     GIR_EraseRootFromParent_Done,
     /* 2040512 */   // Label 27169: @2040512
     /* 2040512 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2040603), // Rule ID 15212 //
     /* 2040517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2040528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2040531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2040534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040563 */     // MIs[0] round
     /* 2040563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040566 */     // MIs[0] policy
     /* 2040566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040576 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2040579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040602 */     // GIR_Coverage, 15212,
     /* 2040602 */     GIR_EraseRootFromParent_Done,
     /* 2040603 */   // Label 27170: @2040603
     /* 2040603 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2040694), // Rule ID 15213 //
     /* 2040608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2040619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2040622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2040625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040654 */     // MIs[0] round
     /* 2040654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040657 */     // MIs[0] policy
     /* 2040657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040667 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11102:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2040670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040693 */     // GIR_Coverage, 15213,
     /* 2040693 */     GIR_EraseRootFromParent_Done,
     /* 2040694 */   // Label 27171: @2040694
     /* 2040694 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2040785), // Rule ID 15216 //
     /* 2040699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040745 */     // MIs[0] round
     /* 2040745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040748 */     // MIs[0] policy
     /* 2040748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2040761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040784 */     // GIR_Coverage, 15216,
     /* 2040784 */     GIR_EraseRootFromParent_Done,
     /* 2040785 */   // Label 27172: @2040785
     /* 2040785 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2040876), // Rule ID 15217 //
     /* 2040790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040836 */     // MIs[0] round
     /* 2040836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040839 */     // MIs[0] policy
     /* 2040839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11102:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2040852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040875 */     // GIR_Coverage, 15217,
     /* 2040875 */     GIR_EraseRootFromParent_Done,
     /* 2040876 */   // Label 27173: @2040876
     /* 2040876 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2040967), // Rule ID 15220 //
     /* 2040881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040927 */     // MIs[0] round
     /* 2040927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040930 */     // MIs[0] policy
     /* 2040930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2040943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040966 */     // GIR_Coverage, 15220,
     /* 2040966 */     GIR_EraseRootFromParent_Done,
     /* 2040967 */   // Label 27174: @2040967
     /* 2040967 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2041058), // Rule ID 15221 //
     /* 2040972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2040980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2041002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041018 */     // MIs[0] round
     /* 2041018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041021 */     // MIs[0] policy
     /* 2041021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041031 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2041034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041057 */     // GIR_Coverage, 15221,
     /* 2041057 */     GIR_EraseRootFromParent_Done,
     /* 2041058 */   // Label 27175: @2041058
     /* 2041058 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2041149), // Rule ID 15224 //
     /* 2041063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2041074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2041077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2041080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2041086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2041093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041109 */     // MIs[0] round
     /* 2041109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041112 */     // MIs[0] policy
     /* 2041112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041122 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2041125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041148 */     // GIR_Coverage, 15224,
     /* 2041148 */     GIR_EraseRootFromParent_Done,
     /* 2041149 */   // Label 27176: @2041149
     /* 2041149 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2041240), // Rule ID 15225 //
     /* 2041154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2041157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2041165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2041168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2041171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2041177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2041184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2041192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041200 */     // MIs[0] round
     /* 2041200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041203 */     // MIs[0] policy
     /* 2041203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041213 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2041216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041239 */     // GIR_Coverage, 15225,
     /* 2041239 */     GIR_EraseRootFromParent_Done,
     /* 2041240 */   // Label 27177: @2041240
     /* 2041240 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2041331), // Rule ID 15228 //
     /* 2041245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2041256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2041259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2041262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041291 */     // MIs[0] round
     /* 2041291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041294 */     // MIs[0] policy
     /* 2041294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2041307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041330 */     // GIR_Coverage, 15228,
     /* 2041330 */     GIR_EraseRootFromParent_Done,
     /* 2041331 */   // Label 27178: @2041331
     /* 2041331 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2041422), // Rule ID 15229 //
     /* 2041336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2041347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2041350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2041353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041382 */     // MIs[0] round
     /* 2041382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041385 */     // MIs[0] policy
     /* 2041385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041395 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2041398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041421 */     // GIR_Coverage, 15229,
     /* 2041421 */     GIR_EraseRootFromParent_Done,
     /* 2041422 */   // Label 27179: @2041422
     /* 2041422 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2041513), // Rule ID 15232 //
     /* 2041427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2041438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2041441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2041444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041473 */     // MIs[0] round
     /* 2041473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041476 */     // MIs[0] policy
     /* 2041476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2041489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041512 */     // GIR_Coverage, 15232,
     /* 2041512 */     GIR_EraseRootFromParent_Done,
     /* 2041513 */   // Label 27180: @2041513
     /* 2041513 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2041604), // Rule ID 15233 //
     /* 2041518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2041529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2041532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2041535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041564 */     // MIs[0] round
     /* 2041564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041567 */     // MIs[0] policy
     /* 2041567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041577 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2041580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041603 */     // GIR_Coverage, 15233,
     /* 2041603 */     GIR_EraseRootFromParent_Done,
     /* 2041604 */   // Label 27181: @2041604
     /* 2041604 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2041695), // Rule ID 15236 //
     /* 2041609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041655 */     // MIs[0] round
     /* 2041655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041658 */     // MIs[0] policy
     /* 2041658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041668 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2041671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041694 */     // GIR_Coverage, 15236,
     /* 2041694 */     GIR_EraseRootFromParent_Done,
     /* 2041695 */   // Label 27182: @2041695
     /* 2041695 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2041786), // Rule ID 15237 //
     /* 2041700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041746 */     // MIs[0] round
     /* 2041746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041749 */     // MIs[0] policy
     /* 2041749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2041762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041785 */     // GIR_Coverage, 15237,
     /* 2041785 */     GIR_EraseRootFromParent_Done,
     /* 2041786 */   // Label 27183: @2041786
     /* 2041786 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2041877), // Rule ID 15240 //
     /* 2041791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041837 */     // MIs[0] round
     /* 2041837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041840 */     // MIs[0] policy
     /* 2041840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2041853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041876 */     // GIR_Coverage, 15240,
     /* 2041876 */     GIR_EraseRootFromParent_Done,
     /* 2041877 */   // Label 27184: @2041877
     /* 2041877 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2041968), // Rule ID 15241 //
     /* 2041882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041928 */     // MIs[0] round
     /* 2041928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041931 */     // MIs[0] policy
     /* 2041931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2041944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041967 */     // GIR_Coverage, 15241,
     /* 2041967 */     GIR_EraseRootFromParent_Done,
     /* 2041968 */   // Label 27185: @2041968
     /* 2041968 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2042059), // Rule ID 15244 //
     /* 2041973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2041981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042019 */     // MIs[0] round
     /* 2042019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042022 */     // MIs[0] policy
     /* 2042022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042032 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2042035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042058 */     // GIR_Coverage, 15244,
     /* 2042058 */     GIR_EraseRootFromParent_Done,
     /* 2042059 */   // Label 27186: @2042059
     /* 2042059 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2042150), // Rule ID 15245 //
     /* 2042064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2042075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2042078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2042081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042110 */     // MIs[0] round
     /* 2042110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042113 */     // MIs[0] policy
     /* 2042113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042123 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2042126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042149 */     // GIR_Coverage, 15245,
     /* 2042149 */     GIR_EraseRootFromParent_Done,
     /* 2042150 */   // Label 27187: @2042150
     /* 2042150 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2042241), // Rule ID 15248 //
     /* 2042155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2042166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2042169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2042172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2042178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042201 */     // MIs[0] round
     /* 2042201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042204 */     // MIs[0] policy
     /* 2042204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2042217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042240 */     // GIR_Coverage, 15248,
     /* 2042240 */     GIR_EraseRootFromParent_Done,
     /* 2042241 */   // Label 27188: @2042241
     /* 2042241 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2042332), // Rule ID 15249 //
     /* 2042246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2042257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2042260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2042263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2042269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042292 */     // MIs[0] round
     /* 2042292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042295 */     // MIs[0] policy
     /* 2042295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042305 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2042308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042331 */     // GIR_Coverage, 15249,
     /* 2042331 */     GIR_EraseRootFromParent_Done,
     /* 2042332 */   // Label 27189: @2042332
     /* 2042332 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2042423), // Rule ID 15252 //
     /* 2042337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2042348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2042351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2042354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042383 */     // MIs[0] round
     /* 2042383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042386 */     // MIs[0] policy
     /* 2042386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2042399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042422 */     // GIR_Coverage, 15252,
     /* 2042422 */     GIR_EraseRootFromParent_Done,
     /* 2042423 */   // Label 27190: @2042423
     /* 2042423 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2042514), // Rule ID 15253 //
     /* 2042428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2042439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2042442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2042445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042474 */     // MIs[0] round
     /* 2042474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042477 */     // MIs[0] policy
     /* 2042477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2042490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042513 */     // GIR_Coverage, 15253,
     /* 2042513 */     GIR_EraseRootFromParent_Done,
     /* 2042514 */   // Label 27191: @2042514
     /* 2042514 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2042605), // Rule ID 15256 //
     /* 2042519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2042530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2042533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2042536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042565 */     // MIs[0] round
     /* 2042565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042568 */     // MIs[0] policy
     /* 2042568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2042581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042604 */     // GIR_Coverage, 15256,
     /* 2042604 */     GIR_EraseRootFromParent_Done,
     /* 2042605 */   // Label 27192: @2042605
     /* 2042605 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2042696), // Rule ID 15257 //
     /* 2042610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2042621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2042624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2042627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042656 */     // MIs[0] round
     /* 2042656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042659 */     // MIs[0] policy
     /* 2042659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2042672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042695 */     // GIR_Coverage, 15257,
     /* 2042695 */     GIR_EraseRootFromParent_Done,
     /* 2042696 */   // Label 27193: @2042696
     /* 2042696 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2042787), // Rule ID 15260 //
     /* 2042701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042747 */     // MIs[0] round
     /* 2042747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042750 */     // MIs[0] policy
     /* 2042750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2042763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042786 */     // GIR_Coverage, 15260,
     /* 2042786 */     GIR_EraseRootFromParent_Done,
     /* 2042787 */   // Label 27194: @2042787
     /* 2042787 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2042878), // Rule ID 15261 //
     /* 2042792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042838 */     // MIs[0] round
     /* 2042838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042841 */     // MIs[0] policy
     /* 2042841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042851 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2042854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042877 */     // GIR_Coverage, 15261,
     /* 2042877 */     GIR_EraseRootFromParent_Done,
     /* 2042878 */   // Label 27195: @2042878
     /* 2042878 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2042969), // Rule ID 15264 //
     /* 2042883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042929 */     // MIs[0] round
     /* 2042929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042932 */     // MIs[0] policy
     /* 2042932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2042945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042968 */     // GIR_Coverage, 15264,
     /* 2042968 */     GIR_EraseRootFromParent_Done,
     /* 2042969 */   // Label 27196: @2042969
     /* 2042969 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2043060), // Rule ID 15265 //
     /* 2042974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2043004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2043012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043020 */     // MIs[0] round
     /* 2043020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043023 */     // MIs[0] policy
     /* 2043023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2043036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043059 */     // GIR_Coverage, 15265,
     /* 2043059 */     GIR_EraseRootFromParent_Done,
     /* 2043060 */   // Label 27197: @2043060
     /* 2043060 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2043151), // Rule ID 15268 //
     /* 2043065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2043068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2043076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2043079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2043082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2043095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2043099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2043103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043111 */     // MIs[0] round
     /* 2043111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043114 */     // MIs[0] policy
     /* 2043114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2043127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043150 */     // GIR_Coverage, 15268,
     /* 2043150 */     GIR_EraseRootFromParent_Done,
     /* 2043151 */   // Label 27198: @2043151
     /* 2043151 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2043242), // Rule ID 15269 //
     /* 2043156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2043159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2043167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2043170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2043173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2043186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2043190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2043194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043202 */     // MIs[0] round
     /* 2043202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043205 */     // MIs[0] policy
     /* 2043205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043215 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2043218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043241 */     // GIR_Coverage, 15269,
     /* 2043241 */     GIR_EraseRootFromParent_Done,
     /* 2043242 */   // Label 27199: @2043242
     /* 2043242 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2043333), // Rule ID 15272 //
     /* 2043247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2043250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2043258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2043261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2043264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2043277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043293 */     // MIs[0] round
     /* 2043293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043296 */     // MIs[0] policy
     /* 2043296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2043309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043332 */     // GIR_Coverage, 15272,
     /* 2043332 */     GIR_EraseRootFromParent_Done,
     /* 2043333 */   // Label 27200: @2043333
     /* 2043333 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2043424), // Rule ID 15273 //
     /* 2043338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2043341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2043349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2043352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2043355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2043368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043384 */     // MIs[0] round
     /* 2043384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043387 */     // MIs[0] policy
     /* 2043387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043397 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2043400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043423 */     // GIR_Coverage, 15273,
     /* 2043423 */     GIR_EraseRootFromParent_Done,
     /* 2043424 */   // Label 27201: @2043424
     /* 2043424 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2043515), // Rule ID 15276 //
     /* 2043429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2043440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2043443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2043446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2043449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043475 */     // MIs[0] round
     /* 2043475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043478 */     // MIs[0] policy
     /* 2043478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043488 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2043491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043514 */     // GIR_Coverage, 15276,
     /* 2043514 */     GIR_EraseRootFromParent_Done,
     /* 2043515 */   // Label 27202: @2043515
     /* 2043515 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2043606), // Rule ID 15277 //
     /* 2043520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2043531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2043534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2043537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2043540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043566 */     // MIs[0] round
     /* 2043566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043569 */     // MIs[0] policy
     /* 2043569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043579 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2043582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043605 */     // GIR_Coverage, 15277,
     /* 2043605 */     GIR_EraseRootFromParent_Done,
     /* 2043606 */   // Label 27203: @2043606
     /* 2043606 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2043697), // Rule ID 15280 //
     /* 2043611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2043631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043657 */     // MIs[0] round
     /* 2043657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043660 */     // MIs[0] policy
     /* 2043660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2043673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043696 */     // GIR_Coverage, 15280,
     /* 2043696 */     GIR_EraseRootFromParent_Done,
     /* 2043697 */   // Label 27204: @2043697
     /* 2043697 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2043788), // Rule ID 15281 //
     /* 2043702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2043722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043748 */     // MIs[0] round
     /* 2043748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043751 */     // MIs[0] policy
     /* 2043751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043761 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2043764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043787 */     // GIR_Coverage, 15281,
     /* 2043787 */     GIR_EraseRootFromParent_Done,
     /* 2043788 */   // Label 27205: @2043788
     /* 2043788 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2043879), // Rule ID 15284 //
     /* 2043793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043839 */     // MIs[0] round
     /* 2043839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043842 */     // MIs[0] policy
     /* 2043842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2043855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043878 */     // GIR_Coverage, 15284,
     /* 2043878 */     GIR_EraseRootFromParent_Done,
     /* 2043879 */   // Label 27206: @2043879
     /* 2043879 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2043970), // Rule ID 15285 //
     /* 2043884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2043904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043930 */     // MIs[0] round
     /* 2043930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043933 */     // MIs[0] policy
     /* 2043933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043943 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2043946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043969 */     // GIR_Coverage, 15285,
     /* 2043969 */     GIR_EraseRootFromParent_Done,
     /* 2043970 */   // Label 27207: @2043970
     /* 2043970 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2044061), // Rule ID 15288 //
     /* 2043975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2043995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044021 */     // MIs[0] round
     /* 2044021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044024 */     // MIs[0] policy
     /* 2044024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044034 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2044037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044060 */     // GIR_Coverage, 15288,
     /* 2044060 */     GIR_EraseRootFromParent_Done,
     /* 2044061 */   // Label 27208: @2044061
     /* 2044061 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2044152), // Rule ID 15289 //
     /* 2044066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2044077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2044080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2044083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2044086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044112 */     // MIs[0] round
     /* 2044112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044115 */     // MIs[0] policy
     /* 2044115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044125 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2044128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044151 */     // GIR_Coverage, 15289,
     /* 2044151 */     GIR_EraseRootFromParent_Done,
     /* 2044152 */   // Label 27209: @2044152
     /* 2044152 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2044243), // Rule ID 15292 //
     /* 2044157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2044168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2044171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2044174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2044177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044203 */     // MIs[0] round
     /* 2044203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044206 */     // MIs[0] policy
     /* 2044206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2044219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044242 */     // GIR_Coverage, 15292,
     /* 2044242 */     GIR_EraseRootFromParent_Done,
     /* 2044243 */   // Label 27210: @2044243
     /* 2044243 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2044334), // Rule ID 15293 //
     /* 2044248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2044259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2044262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2044265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2044268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044294 */     // MIs[0] round
     /* 2044294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044297 */     // MIs[0] policy
     /* 2044297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044307 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2044310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044333 */     // GIR_Coverage, 15293,
     /* 2044333 */     GIR_EraseRootFromParent_Done,
     /* 2044334 */   // Label 27211: @2044334
     /* 2044334 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2044425), // Rule ID 15296 //
     /* 2044339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2044350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2044353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2044356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2044359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044385 */     // MIs[0] round
     /* 2044385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044388 */     // MIs[0] policy
     /* 2044388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2044401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044424 */     // GIR_Coverage, 15296,
     /* 2044424 */     GIR_EraseRootFromParent_Done,
     /* 2044425 */   // Label 27212: @2044425
     /* 2044425 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2044516), // Rule ID 15297 //
     /* 2044430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2044441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2044444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2044447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2044450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044476 */     // MIs[0] round
     /* 2044476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044479 */     // MIs[0] policy
     /* 2044479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2044492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044515 */     // GIR_Coverage, 15297,
     /* 2044515 */     GIR_EraseRootFromParent_Done,
     /* 2044516 */   // Label 27213: @2044516
     /* 2044516 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2044607), // Rule ID 15300 //
     /* 2044521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2044532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2044535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2044538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2044541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044567 */     // MIs[0] round
     /* 2044567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044570 */     // MIs[0] policy
     /* 2044570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044580 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2044583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044606 */     // GIR_Coverage, 15300,
     /* 2044606 */     GIR_EraseRootFromParent_Done,
     /* 2044607 */   // Label 27214: @2044607
     /* 2044607 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2044698), // Rule ID 15301 //
     /* 2044612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2044623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2044626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2044629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2044632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044658 */     // MIs[0] round
     /* 2044658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044661 */     // MIs[0] policy
     /* 2044661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044671 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2044674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044697 */     // GIR_Coverage, 15301,
     /* 2044697 */     GIR_EraseRootFromParent_Done,
     /* 2044698 */   // Label 27215: @2044698
     /* 2044698 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2044789), // Rule ID 15304 //
     /* 2044703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044749 */     // MIs[0] round
     /* 2044749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044752 */     // MIs[0] policy
     /* 2044752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2044765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044788 */     // GIR_Coverage, 15304,
     /* 2044788 */     GIR_EraseRootFromParent_Done,
     /* 2044789 */   // Label 27216: @2044789
     /* 2044789 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2044880), // Rule ID 15305 //
     /* 2044794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2044814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044840 */     // MIs[0] round
     /* 2044840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044843 */     // MIs[0] policy
     /* 2044843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044853 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2044856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044879 */     // GIR_Coverage, 15305,
     /* 2044879 */     GIR_EraseRootFromParent_Done,
     /* 2044880 */   // Label 27217: @2044880
     /* 2044880 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2044971), // Rule ID 15308 //
     /* 2044885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044931 */     // MIs[0] round
     /* 2044931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044934 */     // MIs[0] policy
     /* 2044934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2044947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044970 */     // GIR_Coverage, 15308,
     /* 2044970 */     GIR_EraseRootFromParent_Done,
     /* 2044971 */   // Label 27218: @2044971
     /* 2044971 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2045062), // Rule ID 15309 //
     /* 2044976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2044996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045022 */     // MIs[0] round
     /* 2045022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045025 */     // MIs[0] policy
     /* 2045025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2045038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045061 */     // GIR_Coverage, 15309,
     /* 2045061 */     GIR_EraseRootFromParent_Done,
     /* 2045062 */   // Label 27219: @2045062
     /* 2045062 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2045153), // Rule ID 15312 //
     /* 2045067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2045078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2045081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2045084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2045087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2045090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045113 */     // MIs[0] round
     /* 2045113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045116 */     // MIs[0] policy
     /* 2045116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2045129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045152 */     // GIR_Coverage, 15312,
     /* 2045152 */     GIR_EraseRootFromParent_Done,
     /* 2045153 */   // Label 27220: @2045153
     /* 2045153 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2045244), // Rule ID 15313 //
     /* 2045158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2045161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2045169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2045172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2045175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2045178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2045181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2045188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2045200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045204 */     // MIs[0] round
     /* 2045204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045207 */     // MIs[0] policy
     /* 2045207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045217 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2045220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045243 */     // GIR_Coverage, 15313,
     /* 2045243 */     GIR_EraseRootFromParent_Done,
     /* 2045244 */   // Label 27221: @2045244
     /* 2045244 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2045335), // Rule ID 15316 //
     /* 2045249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2045260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2045263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2045266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2045269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045295 */     // MIs[0] round
     /* 2045295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045298 */     // MIs[0] policy
     /* 2045298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045308 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2045311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045334 */     // GIR_Coverage, 15316,
     /* 2045334 */     GIR_EraseRootFromParent_Done,
     /* 2045335 */   // Label 27222: @2045335
     /* 2045335 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2045426), // Rule ID 15317 //
     /* 2045340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2045351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2045354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2045357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2045360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045386 */     // MIs[0] round
     /* 2045386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045389 */     // MIs[0] policy
     /* 2045389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2045402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045425 */     // GIR_Coverage, 15317,
     /* 2045425 */     GIR_EraseRootFromParent_Done,
     /* 2045426 */   // Label 27223: @2045426
     /* 2045426 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2045517), // Rule ID 15320 //
     /* 2045431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2045442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2045445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2045448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2045451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045477 */     // MIs[0] round
     /* 2045477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045480 */     // MIs[0] policy
     /* 2045480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2045493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045516 */     // GIR_Coverage, 15320,
     /* 2045516 */     GIR_EraseRootFromParent_Done,
     /* 2045517 */   // Label 27224: @2045517
     /* 2045517 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2045608), // Rule ID 15321 //
     /* 2045522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2045533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2045536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2045539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2045542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045568 */     // MIs[0] round
     /* 2045568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045571 */     // MIs[0] policy
     /* 2045571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045581 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2045584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045607 */     // GIR_Coverage, 15321,
     /* 2045607 */     GIR_EraseRootFromParent_Done,
     /* 2045608 */   // Label 27225: @2045608
     /* 2045608 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2045699), // Rule ID 15324 //
     /* 2045613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2045633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045659 */     // MIs[0] round
     /* 2045659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045662 */     // MIs[0] policy
     /* 2045662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2045675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045698 */     // GIR_Coverage, 15324,
     /* 2045698 */     GIR_EraseRootFromParent_Done,
     /* 2045699 */   // Label 27226: @2045699
     /* 2045699 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2045790), // Rule ID 15325 //
     /* 2045704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2045724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045750 */     // MIs[0] round
     /* 2045750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045753 */     // MIs[0] policy
     /* 2045753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045763 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2045766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045789 */     // GIR_Coverage, 15325,
     /* 2045789 */     GIR_EraseRootFromParent_Done,
     /* 2045790 */   // Label 27227: @2045790
     /* 2045790 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2045881), // Rule ID 15328 //
     /* 2045795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045841 */     // MIs[0] round
     /* 2045841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045844 */     // MIs[0] policy
     /* 2045844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2045857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045880 */     // GIR_Coverage, 15328,
     /* 2045880 */     GIR_EraseRootFromParent_Done,
     /* 2045881 */   // Label 27228: @2045881
     /* 2045881 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2045972), // Rule ID 15329 //
     /* 2045886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2045906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045932 */     // MIs[0] round
     /* 2045932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045935 */     // MIs[0] policy
     /* 2045935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2045948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045971 */     // GIR_Coverage, 15329,
     /* 2045971 */     GIR_EraseRootFromParent_Done,
     /* 2045972 */   // Label 27229: @2045972
     /* 2045972 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2046063), // Rule ID 15332 //
     /* 2045977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2045997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046023 */     // MIs[0] round
     /* 2046023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046026 */     // MIs[0] policy
     /* 2046026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2046039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046062 */     // GIR_Coverage, 15332,
     /* 2046062 */     GIR_EraseRootFromParent_Done,
     /* 2046063 */   // Label 27230: @2046063
     /* 2046063 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2046154), // Rule ID 15333 //
     /* 2046068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2046079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2046082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2046085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2046088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046114 */     // MIs[0] round
     /* 2046114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046117 */     // MIs[0] policy
     /* 2046117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2046130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046153 */     // GIR_Coverage, 15333,
     /* 2046153 */     GIR_EraseRootFromParent_Done,
     /* 2046154 */   // Label 27231: @2046154
     /* 2046154 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2046245), // Rule ID 15336 //
     /* 2046159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2046170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2046173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2046176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2046179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2046182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046205 */     // MIs[0] round
     /* 2046205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046208 */     // MIs[0] policy
     /* 2046208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2046221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046244 */     // GIR_Coverage, 15336,
     /* 2046244 */     GIR_EraseRootFromParent_Done,
     /* 2046245 */   // Label 27232: @2046245
     /* 2046245 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2046336), // Rule ID 15337 //
     /* 2046250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2046261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2046264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2046267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2046270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2046273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046296 */     // MIs[0] round
     /* 2046296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046299 */     // MIs[0] policy
     /* 2046299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2046312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046335 */     // GIR_Coverage, 15337,
     /* 2046335 */     GIR_EraseRootFromParent_Done,
     /* 2046336 */   // Label 27233: @2046336
     /* 2046336 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2046427), // Rule ID 15340 //
     /* 2046341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2046352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2046355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2046358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2046361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046387 */     // MIs[0] round
     /* 2046387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046390 */     // MIs[0] policy
     /* 2046390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2046403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046426 */     // GIR_Coverage, 15340,
     /* 2046426 */     GIR_EraseRootFromParent_Done,
     /* 2046427 */   // Label 27234: @2046427
     /* 2046427 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2046518), // Rule ID 15341 //
     /* 2046432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2046443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2046446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2046449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2046452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046478 */     // MIs[0] round
     /* 2046478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046481 */     // MIs[0] policy
     /* 2046481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2046494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046517 */     // GIR_Coverage, 15341,
     /* 2046517 */     GIR_EraseRootFromParent_Done,
     /* 2046518 */   // Label 27235: @2046518
     /* 2046518 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2046609), // Rule ID 15344 //
     /* 2046523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2046534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2046537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2046540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2046543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046569 */     // MIs[0] round
     /* 2046569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046572 */     // MIs[0] policy
     /* 2046572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2046585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046608 */     // GIR_Coverage, 15344,
     /* 2046608 */     GIR_EraseRootFromParent_Done,
     /* 2046609 */   // Label 27236: @2046609
     /* 2046609 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2046700), // Rule ID 15345 //
     /* 2046614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2046625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2046628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2046631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2046634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046660 */     // MIs[0] round
     /* 2046660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046663 */     // MIs[0] policy
     /* 2046663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046673 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2046676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046699 */     // GIR_Coverage, 15345,
     /* 2046699 */     GIR_EraseRootFromParent_Done,
     /* 2046700 */   // Label 27237: @2046700
     /* 2046700 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2046791), // Rule ID 15348 //
     /* 2046705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046751 */     // MIs[0] round
     /* 2046751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046754 */     // MIs[0] policy
     /* 2046754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046764 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2046767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046790 */     // GIR_Coverage, 15348,
     /* 2046790 */     GIR_EraseRootFromParent_Done,
     /* 2046791 */   // Label 27238: @2046791
     /* 2046791 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2046882), // Rule ID 15349 //
     /* 2046796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2046816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046842 */     // MIs[0] round
     /* 2046842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046845 */     // MIs[0] policy
     /* 2046845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046855 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2046858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046881 */     // GIR_Coverage, 15349,
     /* 2046881 */     GIR_EraseRootFromParent_Done,
     /* 2046882 */   // Label 27239: @2046882
     /* 2046882 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2046973), // Rule ID 15352 //
     /* 2046887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046933 */     // MIs[0] round
     /* 2046933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046936 */     // MIs[0] policy
     /* 2046936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2046949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046972 */     // GIR_Coverage, 15352,
     /* 2046972 */     GIR_EraseRootFromParent_Done,
     /* 2046973 */   // Label 27240: @2046973
     /* 2046973 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2047064), // Rule ID 15353 //
     /* 2046978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2046998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2047008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2047020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047024 */     // MIs[0] round
     /* 2047024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047027 */     // MIs[0] policy
     /* 2047027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047037 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2047040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047063 */     // GIR_Coverage, 15353,
     /* 2047063 */     GIR_EraseRootFromParent_Done,
     /* 2047064 */   // Label 27241: @2047064
     /* 2047064 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2047155), // Rule ID 15356 //
     /* 2047069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2047072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2047080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2047083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2047086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2047089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2047099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047115 */     // MIs[0] round
     /* 2047115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047118 */     // MIs[0] policy
     /* 2047118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047128 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2047131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047154 */     // GIR_Coverage, 15356,
     /* 2047154 */     GIR_EraseRootFromParent_Done,
     /* 2047155 */   // Label 27242: @2047155
     /* 2047155 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2047246), // Rule ID 15357 //
     /* 2047160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2047163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2047171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2047174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2047177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2047180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2047190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2047202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047206 */     // MIs[0] round
     /* 2047206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047209 */     // MIs[0] policy
     /* 2047209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047219 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2047222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047245 */     // GIR_Coverage, 15357,
     /* 2047245 */     GIR_EraseRootFromParent_Done,
     /* 2047246 */   // Label 27243: @2047246
     /* 2047246 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2047337), // Rule ID 15360 //
     /* 2047251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2047254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2047262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2047265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2047268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2047271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047297 */     // MIs[0] round
     /* 2047297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047300 */     // MIs[0] policy
     /* 2047300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047310 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2047313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047336 */     // GIR_Coverage, 15360,
     /* 2047336 */     GIR_EraseRootFromParent_Done,
     /* 2047337 */   // Label 27244: @2047337
     /* 2047337 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2047428), // Rule ID 15361 //
     /* 2047342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2047345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2047353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2047356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2047359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2047362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047388 */     // MIs[0] round
     /* 2047388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047391 */     // MIs[0] policy
     /* 2047391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047401 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2047404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047427 */     // GIR_Coverage, 15361,
     /* 2047427 */     GIR_EraseRootFromParent_Done,
     /* 2047428 */   // Label 27245: @2047428
     /* 2047428 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2047519), // Rule ID 15364 //
     /* 2047433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2047444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2047447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2047450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047479 */     // MIs[0] round
     /* 2047479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047482 */     // MIs[0] policy
     /* 2047482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2047495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047518 */     // GIR_Coverage, 15364,
     /* 2047518 */     GIR_EraseRootFromParent_Done,
     /* 2047519 */   // Label 27246: @2047519
     /* 2047519 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2047610), // Rule ID 15365 //
     /* 2047524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2047535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2047538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2047541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047570 */     // MIs[0] round
     /* 2047570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047573 */     // MIs[0] policy
     /* 2047573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047583 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2047586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047609 */     // GIR_Coverage, 15365,
     /* 2047609 */     GIR_EraseRootFromParent_Done,
     /* 2047610 */   // Label 27247: @2047610
     /* 2047610 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2047701), // Rule ID 15368 //
     /* 2047615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047661 */     // MIs[0] round
     /* 2047661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047664 */     // MIs[0] policy
     /* 2047664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2047677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047700 */     // GIR_Coverage, 15368,
     /* 2047700 */     GIR_EraseRootFromParent_Done,
     /* 2047701 */   // Label 27248: @2047701
     /* 2047701 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2047792), // Rule ID 15369 //
     /* 2047706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047752 */     // MIs[0] round
     /* 2047752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047755 */     // MIs[0] policy
     /* 2047755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047765 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2047768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047791 */     // GIR_Coverage, 15369,
     /* 2047791 */     GIR_EraseRootFromParent_Done,
     /* 2047792 */   // Label 27249: @2047792
     /* 2047792 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2047883), // Rule ID 15372 //
     /* 2047797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047843 */     // MIs[0] round
     /* 2047843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047846 */     // MIs[0] policy
     /* 2047846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2047859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047882 */     // GIR_Coverage, 15372,
     /* 2047882 */     GIR_EraseRootFromParent_Done,
     /* 2047883 */   // Label 27250: @2047883
     /* 2047883 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2047974), // Rule ID 15373 //
     /* 2047888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047934 */     // MIs[0] round
     /* 2047934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047937 */     // MIs[0] policy
     /* 2047937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047947 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2047950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047973 */     // GIR_Coverage, 15373,
     /* 2047973 */     GIR_EraseRootFromParent_Done,
     /* 2047974 */   // Label 27251: @2047974
     /* 2047974 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2048065), // Rule ID 15376 //
     /* 2047979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048025 */     // MIs[0] round
     /* 2048025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048028 */     // MIs[0] policy
     /* 2048028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2048041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048064 */     // GIR_Coverage, 15376,
     /* 2048064 */     GIR_EraseRootFromParent_Done,
     /* 2048065 */   // Label 27252: @2048065
     /* 2048065 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2048156), // Rule ID 15377 //
     /* 2048070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2048081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2048084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2048087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048116 */     // MIs[0] round
     /* 2048116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048119 */     // MIs[0] policy
     /* 2048119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048129 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2048132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048155 */     // GIR_Coverage, 15377,
     /* 2048155 */     GIR_EraseRootFromParent_Done,
     /* 2048156 */   // Label 27253: @2048156
     /* 2048156 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2048247), // Rule ID 15380 //
     /* 2048161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2048172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2048175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2048178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048207 */     // MIs[0] round
     /* 2048207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048210 */     // MIs[0] policy
     /* 2048210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048220 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2048223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048246 */     // GIR_Coverage, 15380,
     /* 2048246 */     GIR_EraseRootFromParent_Done,
     /* 2048247 */   // Label 27254: @2048247
     /* 2048247 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2048338), // Rule ID 15381 //
     /* 2048252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2048263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2048266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2048269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048298 */     // MIs[0] round
     /* 2048298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048301 */     // MIs[0] policy
     /* 2048301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048311 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2048314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048337 */     // GIR_Coverage, 15381,
     /* 2048337 */     GIR_EraseRootFromParent_Done,
     /* 2048338 */   // Label 27255: @2048338
     /* 2048338 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2048429), // Rule ID 15384 //
     /* 2048343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2048360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048389 */     // MIs[0] round
     /* 2048389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048392 */     // MIs[0] policy
     /* 2048392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2048405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048428 */     // GIR_Coverage, 15384,
     /* 2048428 */     GIR_EraseRootFromParent_Done,
     /* 2048429 */   // Label 27256: @2048429
     /* 2048429 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2048520), // Rule ID 15385 //
     /* 2048434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2048451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048480 */     // MIs[0] round
     /* 2048480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048483 */     // MIs[0] policy
     /* 2048483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048493 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2048496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048519 */     // GIR_Coverage, 15385,
     /* 2048519 */     GIR_EraseRootFromParent_Done,
     /* 2048520 */   // Label 27257: @2048520
     /* 2048520 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2048611), // Rule ID 15388 //
     /* 2048525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2048536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2048539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2048542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048571 */     // MIs[0] round
     /* 2048571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048574 */     // MIs[0] policy
     /* 2048574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048584 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2048587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048610 */     // GIR_Coverage, 15388,
     /* 2048610 */     GIR_EraseRootFromParent_Done,
     /* 2048611 */   // Label 27258: @2048611
     /* 2048611 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2048702), // Rule ID 15389 //
     /* 2048616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2048627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2048630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2048633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048662 */     // MIs[0] round
     /* 2048662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048665 */     // MIs[0] policy
     /* 2048665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11100:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2048678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048701 */     // GIR_Coverage, 15389,
     /* 2048701 */     GIR_EraseRootFromParent_Done,
     /* 2048702 */   // Label 27259: @2048702
     /* 2048702 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2048793), // Rule ID 15392 //
     /* 2048707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048753 */     // MIs[0] round
     /* 2048753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048756 */     // MIs[0] policy
     /* 2048756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2048769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048792 */     // GIR_Coverage, 15392,
     /* 2048792 */     GIR_EraseRootFromParent_Done,
     /* 2048793 */   // Label 27260: @2048793
     /* 2048793 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2048884), // Rule ID 15393 //
     /* 2048798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048844 */     // MIs[0] round
     /* 2048844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048847 */     // MIs[0] policy
     /* 2048847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048857 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11100:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2048860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048883 */     // GIR_Coverage, 15393,
     /* 2048883 */     GIR_EraseRootFromParent_Done,
     /* 2048884 */   // Label 27261: @2048884
     /* 2048884 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2048975), // Rule ID 15396 //
     /* 2048889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048935 */     // MIs[0] round
     /* 2048935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048938 */     // MIs[0] policy
     /* 2048938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2048951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048974 */     // GIR_Coverage, 15396,
     /* 2048974 */     GIR_EraseRootFromParent_Done,
     /* 2048975 */   // Label 27262: @2048975
     /* 2048975 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2049066), // Rule ID 15397 //
     /* 2048980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2048988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049026 */     // MIs[0] round
     /* 2049026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049029 */     // MIs[0] policy
     /* 2049029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11100:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2049042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049065 */     // GIR_Coverage, 15397,
     /* 2049065 */     GIR_EraseRootFromParent_Done,
     /* 2049066 */   // Label 27263: @2049066
     /* 2049066 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2049157), // Rule ID 15400 //
     /* 2049071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2049082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2049085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2049088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2049094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049117 */     // MIs[0] round
     /* 2049117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049120 */     // MIs[0] policy
     /* 2049120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049130 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2049133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049156 */     // GIR_Coverage, 15400,
     /* 2049156 */     GIR_EraseRootFromParent_Done,
     /* 2049157 */   // Label 27264: @2049157
     /* 2049157 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2049248), // Rule ID 15401 //
     /* 2049162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2049165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2049173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2049176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2049179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2049185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2049192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2049200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049208 */     // MIs[0] round
     /* 2049208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049211 */     // MIs[0] policy
     /* 2049211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049221 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2049224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049247 */     // GIR_Coverage, 15401,
     /* 2049247 */     GIR_EraseRootFromParent_Done,
     /* 2049248 */   // Label 27265: @2049248
     /* 2049248 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2049339), // Rule ID 15404 //
     /* 2049253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2049264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2049267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2049270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049299 */     // MIs[0] round
     /* 2049299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049302 */     // MIs[0] policy
     /* 2049302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049312 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2049315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049338 */     // GIR_Coverage, 15404,
     /* 2049338 */     GIR_EraseRootFromParent_Done,
     /* 2049339 */   // Label 27266: @2049339
     /* 2049339 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2049430), // Rule ID 15405 //
     /* 2049344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2049355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2049358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2049361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049390 */     // MIs[0] round
     /* 2049390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049393 */     // MIs[0] policy
     /* 2049393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049403 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2049406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049429 */     // GIR_Coverage, 15405,
     /* 2049429 */     GIR_EraseRootFromParent_Done,
     /* 2049430 */   // Label 27267: @2049430
     /* 2049430 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2049521), // Rule ID 15408 //
     /* 2049435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2049446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2049449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2049452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049481 */     // MIs[0] round
     /* 2049481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049484 */     // MIs[0] policy
     /* 2049484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2049497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049520 */     // GIR_Coverage, 15408,
     /* 2049520 */     GIR_EraseRootFromParent_Done,
     /* 2049521 */   // Label 27268: @2049521
     /* 2049521 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2049612), // Rule ID 15409 //
     /* 2049526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2049537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2049540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2049543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049572 */     // MIs[0] round
     /* 2049572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049575 */     // MIs[0] policy
     /* 2049575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049585 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2049588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049611 */     // GIR_Coverage, 15409,
     /* 2049611 */     GIR_EraseRootFromParent_Done,
     /* 2049612 */   // Label 27269: @2049612
     /* 2049612 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2049703), // Rule ID 15412 //
     /* 2049617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049663 */     // MIs[0] round
     /* 2049663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049666 */     // MIs[0] policy
     /* 2049666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049676 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2049679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049702 */     // GIR_Coverage, 15412,
     /* 2049702 */     GIR_EraseRootFromParent_Done,
     /* 2049703 */   // Label 27270: @2049703
     /* 2049703 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2049794), // Rule ID 15413 //
     /* 2049708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049754 */     // MIs[0] round
     /* 2049754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049757 */     // MIs[0] policy
     /* 2049757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049767 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2049770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049793 */     // GIR_Coverage, 15413,
     /* 2049793 */     GIR_EraseRootFromParent_Done,
     /* 2049794 */   // Label 27271: @2049794
     /* 2049794 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2049885), // Rule ID 15416 //
     /* 2049799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049845 */     // MIs[0] round
     /* 2049845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049848 */     // MIs[0] policy
     /* 2049848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2049861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049884 */     // GIR_Coverage, 15416,
     /* 2049884 */     GIR_EraseRootFromParent_Done,
     /* 2049885 */   // Label 27272: @2049885
     /* 2049885 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2049976), // Rule ID 15417 //
     /* 2049890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049936 */     // MIs[0] round
     /* 2049936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049939 */     // MIs[0] policy
     /* 2049939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2049952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049975 */     // GIR_Coverage, 15417,
     /* 2049975 */     GIR_EraseRootFromParent_Done,
     /* 2049976 */   // Label 27273: @2049976
     /* 2049976 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2050067), // Rule ID 15420 //
     /* 2049981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2049989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050027 */     // MIs[0] round
     /* 2050027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050030 */     // MIs[0] policy
     /* 2050030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2050043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050066 */     // GIR_Coverage, 15420,
     /* 2050066 */     GIR_EraseRootFromParent_Done,
     /* 2050067 */   // Label 27274: @2050067
     /* 2050067 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2050158), // Rule ID 15421 //
     /* 2050072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2050083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2050086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2050089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050118 */     // MIs[0] round
     /* 2050118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050121 */     // MIs[0] policy
     /* 2050121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050131 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2050134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050157 */     // GIR_Coverage, 15421,
     /* 2050157 */     GIR_EraseRootFromParent_Done,
     /* 2050158 */   // Label 27275: @2050158
     /* 2050158 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2050249), // Rule ID 15424 //
     /* 2050163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2050174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2050177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2050180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2050186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050209 */     // MIs[0] round
     /* 2050209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050212 */     // MIs[0] policy
     /* 2050212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050222 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2050225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050248 */     // GIR_Coverage, 15424,
     /* 2050248 */     GIR_EraseRootFromParent_Done,
     /* 2050249 */   // Label 27276: @2050249
     /* 2050249 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2050340), // Rule ID 15425 //
     /* 2050254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2050265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2050268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2050271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2050277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050300 */     // MIs[0] round
     /* 2050300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050303 */     // MIs[0] policy
     /* 2050303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050313 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2050316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050339 */     // GIR_Coverage, 15425,
     /* 2050339 */     GIR_EraseRootFromParent_Done,
     /* 2050340 */   // Label 27277: @2050340
     /* 2050340 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2050431), // Rule ID 15428 //
     /* 2050345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2050356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2050359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2050362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050391 */     // MIs[0] round
     /* 2050391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050394 */     // MIs[0] policy
     /* 2050394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2050407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050430 */     // GIR_Coverage, 15428,
     /* 2050430 */     GIR_EraseRootFromParent_Done,
     /* 2050431 */   // Label 27278: @2050431
     /* 2050431 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2050522), // Rule ID 15429 //
     /* 2050436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2050447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2050450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2050453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050482 */     // MIs[0] round
     /* 2050482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050485 */     // MIs[0] policy
     /* 2050485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2050498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050521 */     // GIR_Coverage, 15429,
     /* 2050521 */     GIR_EraseRootFromParent_Done,
     /* 2050522 */   // Label 27279: @2050522
     /* 2050522 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2050613), // Rule ID 15432 //
     /* 2050527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2050544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050573 */     // MIs[0] round
     /* 2050573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050576 */     // MIs[0] policy
     /* 2050576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2050589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050612 */     // GIR_Coverage, 15432,
     /* 2050612 */     GIR_EraseRootFromParent_Done,
     /* 2050613 */   // Label 27280: @2050613
     /* 2050613 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2050704), // Rule ID 15433 //
     /* 2050618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2050635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050664 */     // MIs[0] round
     /* 2050664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050667 */     // MIs[0] policy
     /* 2050667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2050680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050703 */     // GIR_Coverage, 15433,
     /* 2050703 */     GIR_EraseRootFromParent_Done,
     /* 2050704 */   // Label 27281: @2050704
     /* 2050704 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2050795), // Rule ID 15436 //
     /* 2050709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050755 */     // MIs[0] round
     /* 2050755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050758 */     // MIs[0] policy
     /* 2050758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050768 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2050771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050794 */     // GIR_Coverage, 15436,
     /* 2050794 */     GIR_EraseRootFromParent_Done,
     /* 2050795 */   // Label 27282: @2050795
     /* 2050795 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2050886), // Rule ID 15437 //
     /* 2050800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050846 */     // MIs[0] round
     /* 2050846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050849 */     // MIs[0] policy
     /* 2050849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2050862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050885 */     // GIR_Coverage, 15437,
     /* 2050885 */     GIR_EraseRootFromParent_Done,
     /* 2050886 */   // Label 27283: @2050886
     /* 2050886 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2050977), // Rule ID 15440 //
     /* 2050891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050937 */     // MIs[0] round
     /* 2050937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050940 */     // MIs[0] policy
     /* 2050940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2050953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050976 */     // GIR_Coverage, 15440,
     /* 2050976 */     GIR_EraseRootFromParent_Done,
     /* 2050977 */   // Label 27284: @2050977
     /* 2050977 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2051068), // Rule ID 15441 //
     /* 2050982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2051012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2051016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2051020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051028 */     // MIs[0] round
     /* 2051028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051031 */     // MIs[0] policy
     /* 2051031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2051044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051067 */     // GIR_Coverage, 15441,
     /* 2051067 */     GIR_EraseRootFromParent_Done,
     /* 2051068 */   // Label 27285: @2051068
     /* 2051068 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2051159), // Rule ID 15444 //
     /* 2051073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2051076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2051084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2051087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2051090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2051103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2051107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2051111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051119 */     // MIs[0] round
     /* 2051119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051122 */     // MIs[0] policy
     /* 2051122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2051135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051158 */     // GIR_Coverage, 15444,
     /* 2051158 */     GIR_EraseRootFromParent_Done,
     /* 2051159 */   // Label 27286: @2051159
     /* 2051159 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2051250), // Rule ID 15445 //
     /* 2051164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2051167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2051175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2051178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2051181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2051194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2051198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2051202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051210 */     // MIs[0] round
     /* 2051210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051213 */     // MIs[0] policy
     /* 2051213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051223 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2051226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051249 */     // GIR_Coverage, 15445,
     /* 2051249 */     GIR_EraseRootFromParent_Done,
     /* 2051250 */   // Label 27287: @2051250
     /* 2051250 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2051341), // Rule ID 15448 //
     /* 2051255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2051258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2051266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2051269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2051272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2051285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051301 */     // MIs[0] round
     /* 2051301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051304 */     // MIs[0] policy
     /* 2051304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2051317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051340 */     // GIR_Coverage, 15448,
     /* 2051340 */     GIR_EraseRootFromParent_Done,
     /* 2051341 */   // Label 27288: @2051341
     /* 2051341 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2051432), // Rule ID 15449 //
     /* 2051346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2051349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2051357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2051360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2051363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2051376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051392 */     // MIs[0] round
     /* 2051392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051395 */     // MIs[0] policy
     /* 2051395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051405 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2051408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051431 */     // GIR_Coverage, 15449,
     /* 2051431 */     GIR_EraseRootFromParent_Done,
     /* 2051432 */   // Label 27289: @2051432
     /* 2051432 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2051523), // Rule ID 15452 //
     /* 2051437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2051448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2051451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2051454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2051457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051483 */     // MIs[0] round
     /* 2051483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051486 */     // MIs[0] policy
     /* 2051486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051496 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2051499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051522 */     // GIR_Coverage, 15452,
     /* 2051522 */     GIR_EraseRootFromParent_Done,
     /* 2051523 */   // Label 27290: @2051523
     /* 2051523 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2051614), // Rule ID 15453 //
     /* 2051528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2051539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2051542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2051545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2051548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051574 */     // MIs[0] round
     /* 2051574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051577 */     // MIs[0] policy
     /* 2051577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051587 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2051590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051613 */     // GIR_Coverage, 15453,
     /* 2051613 */     GIR_EraseRootFromParent_Done,
     /* 2051614 */   // Label 27291: @2051614
     /* 2051614 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2051705), // Rule ID 15456 //
     /* 2051619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2051639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051665 */     // MIs[0] round
     /* 2051665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051668 */     // MIs[0] policy
     /* 2051668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2051681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051704 */     // GIR_Coverage, 15456,
     /* 2051704 */     GIR_EraseRootFromParent_Done,
     /* 2051705 */   // Label 27292: @2051705
     /* 2051705 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2051796), // Rule ID 15457 //
     /* 2051710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2051730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051756 */     // MIs[0] round
     /* 2051756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051759 */     // MIs[0] policy
     /* 2051759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2051772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051795 */     // GIR_Coverage, 15457,
     /* 2051795 */     GIR_EraseRootFromParent_Done,
     /* 2051796 */   // Label 27293: @2051796
     /* 2051796 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2051887), // Rule ID 15460 //
     /* 2051801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051847 */     // MIs[0] round
     /* 2051847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051850 */     // MIs[0] policy
     /* 2051850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2051863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051886 */     // GIR_Coverage, 15460,
     /* 2051886 */     GIR_EraseRootFromParent_Done,
     /* 2051887 */   // Label 27294: @2051887
     /* 2051887 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2051978), // Rule ID 15461 //
     /* 2051892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2051912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051938 */     // MIs[0] round
     /* 2051938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051941 */     // MIs[0] policy
     /* 2051941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051951 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2051954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051977 */     // GIR_Coverage, 15461,
     /* 2051977 */     GIR_EraseRootFromParent_Done,
     /* 2051978 */   // Label 27295: @2051978
     /* 2051978 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2052069), // Rule ID 15464 //
     /* 2051983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2052000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2052003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052029 */     // MIs[0] round
     /* 2052029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052032 */     // MIs[0] policy
     /* 2052032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2052045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052068 */     // GIR_Coverage, 15464,
     /* 2052068 */     GIR_EraseRootFromParent_Done,
     /* 2052069 */   // Label 27296: @2052069
     /* 2052069 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2052160), // Rule ID 15465 //
     /* 2052074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2052085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2052088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2052091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2052094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052120 */     // MIs[0] round
     /* 2052120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052123 */     // MIs[0] policy
     /* 2052123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052133 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2052136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052159 */     // GIR_Coverage, 15465,
     /* 2052159 */     GIR_EraseRootFromParent_Done,
     /* 2052160 */   // Label 27297: @2052160
     /* 2052160 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2052251), // Rule ID 15468 //
     /* 2052165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2052176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2052179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2052182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2052185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052211 */     // MIs[0] round
     /* 2052211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052214 */     // MIs[0] policy
     /* 2052214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2052227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052250 */     // GIR_Coverage, 15468,
     /* 2052250 */     GIR_EraseRootFromParent_Done,
     /* 2052251 */   // Label 27298: @2052251
     /* 2052251 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2052342), // Rule ID 15469 //
     /* 2052256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2052267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2052270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2052273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2052276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052302 */     // MIs[0] round
     /* 2052302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052305 */     // MIs[0] policy
     /* 2052305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2052318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052341 */     // GIR_Coverage, 15469,
     /* 2052341 */     GIR_EraseRootFromParent_Done,
     /* 2052342 */   // Label 27299: @2052342
     /* 2052342 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2052433), // Rule ID 15472 //
     /* 2052347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2052358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2052361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2052364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2052367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052393 */     // MIs[0] round
     /* 2052393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052396 */     // MIs[0] policy
     /* 2052396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2052409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052432 */     // GIR_Coverage, 15472,
     /* 2052432 */     GIR_EraseRootFromParent_Done,
     /* 2052433 */   // Label 27300: @2052433
     /* 2052433 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2052524), // Rule ID 15473 //
     /* 2052438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2052449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2052452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2052455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2052458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052484 */     // MIs[0] round
     /* 2052484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052487 */     // MIs[0] policy
     /* 2052487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052497 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2052500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052523 */     // GIR_Coverage, 15473,
     /* 2052523 */     GIR_EraseRootFromParent_Done,
     /* 2052524 */   // Label 27301: @2052524
     /* 2052524 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2052615), // Rule ID 15476 //
     /* 2052529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2052540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2052543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2052546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2052549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052575 */     // MIs[0] round
     /* 2052575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052578 */     // MIs[0] policy
     /* 2052578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052588 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2052591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052614 */     // GIR_Coverage, 15476,
     /* 2052614 */     GIR_EraseRootFromParent_Done,
     /* 2052615 */   // Label 27302: @2052615
     /* 2052615 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2052706), // Rule ID 15477 //
     /* 2052620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2052631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2052634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2052637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2052640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052666 */     // MIs[0] round
     /* 2052666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052669 */     // MIs[0] policy
     /* 2052669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052679 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2052682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052705 */     // GIR_Coverage, 15477,
     /* 2052705 */     GIR_EraseRootFromParent_Done,
     /* 2052706 */   // Label 27303: @2052706
     /* 2052706 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2052797), // Rule ID 15480 //
     /* 2052711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052757 */     // MIs[0] round
     /* 2052757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052760 */     // MIs[0] policy
     /* 2052760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2052773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052796 */     // GIR_Coverage, 15480,
     /* 2052796 */     GIR_EraseRootFromParent_Done,
     /* 2052797 */   // Label 27304: @2052797
     /* 2052797 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2052888), // Rule ID 15481 //
     /* 2052802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2052822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052848 */     // MIs[0] round
     /* 2052848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052851 */     // MIs[0] policy
     /* 2052851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2052864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052887 */     // GIR_Coverage, 15481,
     /* 2052887 */     GIR_EraseRootFromParent_Done,
     /* 2052888 */   // Label 27305: @2052888
     /* 2052888 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2052979), // Rule ID 15484 //
     /* 2052893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2052913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052939 */     // MIs[0] round
     /* 2052939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052942 */     // MIs[0] policy
     /* 2052942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2052955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052978 */     // GIR_Coverage, 15484,
     /* 2052978 */     GIR_EraseRootFromParent_Done,
     /* 2052979 */   // Label 27306: @2052979
     /* 2052979 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2053070), // Rule ID 15485 //
     /* 2052984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2053001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2053004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053030 */     // MIs[0] round
     /* 2053030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053033 */     // MIs[0] policy
     /* 2053033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053043 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2053046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053069 */     // GIR_Coverage, 15485,
     /* 2053069 */     GIR_EraseRootFromParent_Done,
     /* 2053070 */   // Label 27307: @2053070
     /* 2053070 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2053161), // Rule ID 15488 //
     /* 2053075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2053086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2053089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2053092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2053095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2053098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053121 */     // MIs[0] round
     /* 2053121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053124 */     // MIs[0] policy
     /* 2053124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053134 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2053137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053160 */     // GIR_Coverage, 15488,
     /* 2053160 */     GIR_EraseRootFromParent_Done,
     /* 2053161 */   // Label 27308: @2053161
     /* 2053161 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2053252), // Rule ID 15489 //
     /* 2053166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2053169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2053177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2053180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2053183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2053186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2053189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2053196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2053208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053212 */     // MIs[0] round
     /* 2053212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053215 */     // MIs[0] policy
     /* 2053215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053225 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2053228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053251 */     // GIR_Coverage, 15489,
     /* 2053251 */     GIR_EraseRootFromParent_Done,
     /* 2053252 */   // Label 27309: @2053252
     /* 2053252 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2053343), // Rule ID 15492 //
     /* 2053257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2053268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2053271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2053274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2053277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053303 */     // MIs[0] round
     /* 2053303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053306 */     // MIs[0] policy
     /* 2053306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2053319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053342 */     // GIR_Coverage, 15492,
     /* 2053342 */     GIR_EraseRootFromParent_Done,
     /* 2053343 */   // Label 27310: @2053343
     /* 2053343 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2053434), // Rule ID 15493 //
     /* 2053348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2053359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2053362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2053365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2053368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053394 */     // MIs[0] round
     /* 2053394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053397 */     // MIs[0] policy
     /* 2053397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053407 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2053410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053433 */     // GIR_Coverage, 15493,
     /* 2053433 */     GIR_EraseRootFromParent_Done,
     /* 2053434 */   // Label 27311: @2053434
     /* 2053434 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2053525), // Rule ID 15496 //
     /* 2053439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2053450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2053453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2053456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2053459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053485 */     // MIs[0] round
     /* 2053485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053488 */     // MIs[0] policy
     /* 2053488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2053501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053524 */     // GIR_Coverage, 15496,
     /* 2053524 */     GIR_EraseRootFromParent_Done,
     /* 2053525 */   // Label 27312: @2053525
     /* 2053525 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2053616), // Rule ID 15497 //
     /* 2053530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2053541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2053544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2053547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2053550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053576 */     // MIs[0] round
     /* 2053576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053579 */     // MIs[0] policy
     /* 2053579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2053592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053615 */     // GIR_Coverage, 15497,
     /* 2053615 */     GIR_EraseRootFromParent_Done,
     /* 2053616 */   // Label 27313: @2053616
     /* 2053616 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2053707), // Rule ID 15500 //
     /* 2053621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2053641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053667 */     // MIs[0] round
     /* 2053667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053670 */     // MIs[0] policy
     /* 2053670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053680 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2053683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053706 */     // GIR_Coverage, 15500,
     /* 2053706 */     GIR_EraseRootFromParent_Done,
     /* 2053707 */   // Label 27314: @2053707
     /* 2053707 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2053798), // Rule ID 15501 //
     /* 2053712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2053732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053758 */     // MIs[0] round
     /* 2053758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053761 */     // MIs[0] policy
     /* 2053761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2053774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053797 */     // GIR_Coverage, 15501,
     /* 2053797 */     GIR_EraseRootFromParent_Done,
     /* 2053798 */   // Label 27315: @2053798
     /* 2053798 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2053889), // Rule ID 15504 //
     /* 2053803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053849 */     // MIs[0] round
     /* 2053849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053852 */     // MIs[0] policy
     /* 2053852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2053865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053888 */     // GIR_Coverage, 15504,
     /* 2053888 */     GIR_EraseRootFromParent_Done,
     /* 2053889 */   // Label 27316: @2053889
     /* 2053889 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2053980), // Rule ID 15505 //
     /* 2053894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2053914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053940 */     // MIs[0] round
     /* 2053940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053943 */     // MIs[0] policy
     /* 2053943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2053956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053979 */     // GIR_Coverage, 15505,
     /* 2053979 */     GIR_EraseRootFromParent_Done,
     /* 2053980 */   // Label 27317: @2053980
     /* 2053980 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2054071), // Rule ID 15508 //
     /* 2053985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2054002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2054005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054031 */     // MIs[0] round
     /* 2054031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054034 */     // MIs[0] policy
     /* 2054034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2054047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054070 */     // GIR_Coverage, 15508,
     /* 2054070 */     GIR_EraseRootFromParent_Done,
     /* 2054071 */   // Label 27318: @2054071
     /* 2054071 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2054162), // Rule ID 15509 //
     /* 2054076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2054087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2054090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2054093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2054096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054122 */     // MIs[0] round
     /* 2054122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054125 */     // MIs[0] policy
     /* 2054125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054135 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2054138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054161 */     // GIR_Coverage, 15509,
     /* 2054161 */     GIR_EraseRootFromParent_Done,
     /* 2054162 */   // Label 27319: @2054162
     /* 2054162 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2054253), // Rule ID 15512 //
     /* 2054167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2054178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2054181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2054184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2054187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2054190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054213 */     // MIs[0] round
     /* 2054213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054216 */     // MIs[0] policy
     /* 2054216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2054229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054252 */     // GIR_Coverage, 15512,
     /* 2054252 */     GIR_EraseRootFromParent_Done,
     /* 2054253 */   // Label 27320: @2054253
     /* 2054253 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2054344), // Rule ID 15513 //
     /* 2054258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2054269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2054272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2054275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2054278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2054281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054304 */     // MIs[0] round
     /* 2054304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054307 */     // MIs[0] policy
     /* 2054307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054317 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2054320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054343 */     // GIR_Coverage, 15513,
     /* 2054343 */     GIR_EraseRootFromParent_Done,
     /* 2054344 */   // Label 27321: @2054344
     /* 2054344 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2054435), // Rule ID 15516 //
     /* 2054349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2054360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2054363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2054366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2054369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054395 */     // MIs[0] round
     /* 2054395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054398 */     // MIs[0] policy
     /* 2054398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2054411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054434 */     // GIR_Coverage, 15516,
     /* 2054434 */     GIR_EraseRootFromParent_Done,
     /* 2054435 */   // Label 27322: @2054435
     /* 2054435 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2054526), // Rule ID 15517 //
     /* 2054440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2054451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2054454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2054457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2054460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054486 */     // MIs[0] round
     /* 2054486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054489 */     // MIs[0] policy
     /* 2054489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2054502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054525 */     // GIR_Coverage, 15517,
     /* 2054525 */     GIR_EraseRootFromParent_Done,
     /* 2054526 */   // Label 27323: @2054526
     /* 2054526 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2054617), // Rule ID 15520 //
     /* 2054531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2054542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2054545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2054548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2054551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054577 */     // MIs[0] round
     /* 2054577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054580 */     // MIs[0] policy
     /* 2054580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2054593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054616 */     // GIR_Coverage, 15520,
     /* 2054616 */     GIR_EraseRootFromParent_Done,
     /* 2054617 */   // Label 27324: @2054617
     /* 2054617 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2054708), // Rule ID 15521 //
     /* 2054622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2054633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2054636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2054639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2054642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054668 */     // MIs[0] round
     /* 2054668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054671 */     // MIs[0] policy
     /* 2054671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054681 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2054684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054707 */     // GIR_Coverage, 15521,
     /* 2054707 */     GIR_EraseRootFromParent_Done,
     /* 2054708 */   // Label 27325: @2054708
     /* 2054708 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2054799), // Rule ID 15524 //
     /* 2054713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054759 */     // MIs[0] round
     /* 2054759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054762 */     // MIs[0] policy
     /* 2054762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054772 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2054775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054798 */     // GIR_Coverage, 15524,
     /* 2054798 */     GIR_EraseRootFromParent_Done,
     /* 2054799 */   // Label 27326: @2054799
     /* 2054799 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2054890), // Rule ID 15525 //
     /* 2054804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2054824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054850 */     // MIs[0] round
     /* 2054850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054853 */     // MIs[0] policy
     /* 2054853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054863 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2054866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054889 */     // GIR_Coverage, 15525,
     /* 2054889 */     GIR_EraseRootFromParent_Done,
     /* 2054890 */   // Label 27327: @2054890
     /* 2054890 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2054981), // Rule ID 15528 //
     /* 2054895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2054915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054941 */     // MIs[0] round
     /* 2054941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054944 */     // MIs[0] policy
     /* 2054944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2054957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054980 */     // GIR_Coverage, 15528,
     /* 2054980 */     GIR_EraseRootFromParent_Done,
     /* 2054981 */   // Label 27328: @2054981
     /* 2054981 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2055072), // Rule ID 15529 //
     /* 2054986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2055000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2055003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2055006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2055016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2055028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055032 */     // MIs[0] round
     /* 2055032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055035 */     // MIs[0] policy
     /* 2055035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055045 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2055048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055071 */     // GIR_Coverage, 15529,
     /* 2055071 */     GIR_EraseRootFromParent_Done,
     /* 2055072 */   // Label 27329: @2055072
     /* 2055072 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2055163), // Rule ID 15532 //
     /* 2055077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2055080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2055088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2055091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2055094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2055097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055123 */     // MIs[0] round
     /* 2055123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055126 */     // MIs[0] policy
     /* 2055126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2055139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055162 */     // GIR_Coverage, 15532,
     /* 2055162 */     GIR_EraseRootFromParent_Done,
     /* 2055163 */   // Label 27330: @2055163
     /* 2055163 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2055254), // Rule ID 15533 //
     /* 2055168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2055171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2055179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2055182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2055185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2055188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2055198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2055210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055214 */     // MIs[0] round
     /* 2055214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055217 */     // MIs[0] policy
     /* 2055217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055227 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2055230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055253 */     // GIR_Coverage, 15533,
     /* 2055253 */     GIR_EraseRootFromParent_Done,
     /* 2055254 */   // Label 27331: @2055254
     /* 2055254 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2055345), // Rule ID 15536 //
     /* 2055259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2055262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2055270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2055273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2055276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2055279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055305 */     // MIs[0] round
     /* 2055305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055308 */     // MIs[0] policy
     /* 2055308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2055321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055344 */     // GIR_Coverage, 15536,
     /* 2055344 */     GIR_EraseRootFromParent_Done,
     /* 2055345 */   // Label 27332: @2055345
     /* 2055345 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2055436), // Rule ID 15537 //
     /* 2055350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2055353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2055361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2055364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2055367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2055370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055396 */     // MIs[0] round
     /* 2055396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055399 */     // MIs[0] policy
     /* 2055399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055409 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2055412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055435 */     // GIR_Coverage, 15537,
     /* 2055435 */     GIR_EraseRootFromParent_Done,
     /* 2055436 */   // Label 27333: @2055436
     /* 2055436 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2055527), // Rule ID 15540 //
     /* 2055441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2055452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2055455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2055458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055487 */     // MIs[0] round
     /* 2055487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055490 */     // MIs[0] policy
     /* 2055490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055500 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2055503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055526 */     // GIR_Coverage, 15540,
     /* 2055526 */     GIR_EraseRootFromParent_Done,
     /* 2055527 */   // Label 27334: @2055527
     /* 2055527 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2055618), // Rule ID 15541 //
     /* 2055532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2055543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2055546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2055549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055578 */     // MIs[0] round
     /* 2055578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055581 */     // MIs[0] policy
     /* 2055581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055591 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2055594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055617 */     // GIR_Coverage, 15541,
     /* 2055617 */     GIR_EraseRootFromParent_Done,
     /* 2055618 */   // Label 27335: @2055618
     /* 2055618 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2055709), // Rule ID 15544 //
     /* 2055623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055669 */     // MIs[0] round
     /* 2055669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055672 */     // MIs[0] policy
     /* 2055672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2055685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055708 */     // GIR_Coverage, 15544,
     /* 2055708 */     GIR_EraseRootFromParent_Done,
     /* 2055709 */   // Label 27336: @2055709
     /* 2055709 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2055800), // Rule ID 15545 //
     /* 2055714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055760 */     // MIs[0] round
     /* 2055760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055763 */     // MIs[0] policy
     /* 2055763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055773 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2055776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055799 */     // GIR_Coverage, 15545,
     /* 2055799 */     GIR_EraseRootFromParent_Done,
     /* 2055800 */   // Label 27337: @2055800
     /* 2055800 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2055891), // Rule ID 15548 //
     /* 2055805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055851 */     // MIs[0] round
     /* 2055851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055854 */     // MIs[0] policy
     /* 2055854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2055867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055890 */     // GIR_Coverage, 15548,
     /* 2055890 */     GIR_EraseRootFromParent_Done,
     /* 2055891 */   // Label 27338: @2055891
     /* 2055891 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2055982), // Rule ID 15549 //
     /* 2055896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055942 */     // MIs[0] round
     /* 2055942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055945 */     // MIs[0] policy
     /* 2055945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055955 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2055958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055981 */     // GIR_Coverage, 15549,
     /* 2055981 */     GIR_EraseRootFromParent_Done,
     /* 2055982 */   // Label 27339: @2055982
     /* 2055982 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2056073), // Rule ID 15552 //
     /* 2055987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2056001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2056004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056033 */     // MIs[0] round
     /* 2056033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056036 */     // MIs[0] policy
     /* 2056036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2056049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056072 */     // GIR_Coverage, 15552,
     /* 2056072 */     GIR_EraseRootFromParent_Done,
     /* 2056073 */   // Label 27340: @2056073
     /* 2056073 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2056164), // Rule ID 15553 //
     /* 2056078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2056089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2056092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2056095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056124 */     // MIs[0] round
     /* 2056124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056127 */     // MIs[0] policy
     /* 2056127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2056140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056163 */     // GIR_Coverage, 15553,
     /* 2056163 */     GIR_EraseRootFromParent_Done,
     /* 2056164 */   // Label 27341: @2056164
     /* 2056164 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2056255), // Rule ID 15556 //
     /* 2056169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2056180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2056183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2056186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056215 */     // MIs[0] round
     /* 2056215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056218 */     // MIs[0] policy
     /* 2056218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2056231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056254 */     // GIR_Coverage, 15556,
     /* 2056254 */     GIR_EraseRootFromParent_Done,
     /* 2056255 */   // Label 27342: @2056255
     /* 2056255 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2056346), // Rule ID 15557 //
     /* 2056260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2056271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2056274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2056277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056306 */     // MIs[0] round
     /* 2056306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056309 */     // MIs[0] policy
     /* 2056309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2056322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056345 */     // GIR_Coverage, 15557,
     /* 2056345 */     GIR_EraseRootFromParent_Done,
     /* 2056346 */   // Label 27343: @2056346
     /* 2056346 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2056437), // Rule ID 15560 //
     /* 2056351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056397 */     // MIs[0] round
     /* 2056397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056400 */     // MIs[0] policy
     /* 2056400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2056413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056436 */     // GIR_Coverage, 15560,
     /* 2056436 */     GIR_EraseRootFromParent_Done,
     /* 2056437 */   // Label 27344: @2056437
     /* 2056437 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2056528), // Rule ID 15561 //
     /* 2056442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056488 */     // MIs[0] round
     /* 2056488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056491 */     // MIs[0] policy
     /* 2056491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2056504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056527 */     // GIR_Coverage, 15561,
     /* 2056527 */     GIR_EraseRootFromParent_Done,
     /* 2056528 */   // Label 27345: @2056528
     /* 2056528 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2056619), // Rule ID 15564 //
     /* 2056533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2056544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2056547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2056550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056579 */     // MIs[0] round
     /* 2056579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056582 */     // MIs[0] policy
     /* 2056582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2056595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056618 */     // GIR_Coverage, 15564,
     /* 2056618 */     GIR_EraseRootFromParent_Done,
     /* 2056619 */   // Label 27346: @2056619
     /* 2056619 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2056710), // Rule ID 15565 //
     /* 2056624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2056635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2056638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2056641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056670 */     // MIs[0] round
     /* 2056670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056673 */     // MIs[0] policy
     /* 2056673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056683 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11078:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2056686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056709 */     // GIR_Coverage, 15565,
     /* 2056709 */     GIR_EraseRootFromParent_Done,
     /* 2056710 */   // Label 27347: @2056710
     /* 2056710 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2056801), // Rule ID 15568 //
     /* 2056715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056761 */     // MIs[0] round
     /* 2056761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056764 */     // MIs[0] policy
     /* 2056764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2056777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056800 */     // GIR_Coverage, 15568,
     /* 2056800 */     GIR_EraseRootFromParent_Done,
     /* 2056801 */   // Label 27348: @2056801
     /* 2056801 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2056892), // Rule ID 15569 //
     /* 2056806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056852 */     // MIs[0] round
     /* 2056852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056855 */     // MIs[0] policy
     /* 2056855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11078:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2056868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056891 */     // GIR_Coverage, 15569,
     /* 2056891 */     GIR_EraseRootFromParent_Done,
     /* 2056892 */   // Label 27349: @2056892
     /* 2056892 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2056983), // Rule ID 15572 //
     /* 2056897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056943 */     // MIs[0] round
     /* 2056943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056946 */     // MIs[0] policy
     /* 2056946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2056959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056982 */     // GIR_Coverage, 15572,
     /* 2056982 */     GIR_EraseRootFromParent_Done,
     /* 2056983 */   // Label 27350: @2056983
     /* 2056983 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2057074), // Rule ID 15573 //
     /* 2056988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2056996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2057002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2057005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057034 */     // MIs[0] round
     /* 2057034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057037 */     // MIs[0] policy
     /* 2057037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057047 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2057050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057073 */     // GIR_Coverage, 15573,
     /* 2057073 */     GIR_EraseRootFromParent_Done,
     /* 2057074 */   // Label 27351: @2057074
     /* 2057074 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2057165), // Rule ID 15576 //
     /* 2057079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2057090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2057093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2057096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2057102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057125 */     // MIs[0] round
     /* 2057125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057128 */     // MIs[0] policy
     /* 2057128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2057141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057164 */     // GIR_Coverage, 15576,
     /* 2057164 */     GIR_EraseRootFromParent_Done,
     /* 2057165 */   // Label 27352: @2057165
     /* 2057165 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2057256), // Rule ID 15577 //
     /* 2057170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2057173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2057181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2057184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2057187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2057193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2057200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2057208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057216 */     // MIs[0] round
     /* 2057216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057219 */     // MIs[0] policy
     /* 2057219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2057232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057255 */     // GIR_Coverage, 15577,
     /* 2057255 */     GIR_EraseRootFromParent_Done,
     /* 2057256 */   // Label 27353: @2057256
     /* 2057256 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2057347), // Rule ID 15580 //
     /* 2057261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2057272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2057275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2057278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057307 */     // MIs[0] round
     /* 2057307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057310 */     // MIs[0] policy
     /* 2057310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2057323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057346 */     // GIR_Coverage, 15580,
     /* 2057346 */     GIR_EraseRootFromParent_Done,
     /* 2057347 */   // Label 27354: @2057347
     /* 2057347 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2057438), // Rule ID 15581 //
     /* 2057352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2057363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2057366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2057369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057398 */     // MIs[0] round
     /* 2057398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057401 */     // MIs[0] policy
     /* 2057401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057411 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2057414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057437 */     // GIR_Coverage, 15581,
     /* 2057437 */     GIR_EraseRootFromParent_Done,
     /* 2057438 */   // Label 27355: @2057438
     /* 2057438 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2057529), // Rule ID 15584 //
     /* 2057443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2057454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2057457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2057460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057489 */     // MIs[0] round
     /* 2057489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057492 */     // MIs[0] policy
     /* 2057492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2057505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057528 */     // GIR_Coverage, 15584,
     /* 2057528 */     GIR_EraseRootFromParent_Done,
     /* 2057529 */   // Label 27356: @2057529
     /* 2057529 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2057620), // Rule ID 15585 //
     /* 2057534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2057545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2057548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2057551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057580 */     // MIs[0] round
     /* 2057580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057583 */     // MIs[0] policy
     /* 2057583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2057596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057619 */     // GIR_Coverage, 15585,
     /* 2057619 */     GIR_EraseRootFromParent_Done,
     /* 2057620 */   // Label 27357: @2057620
     /* 2057620 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2057711), // Rule ID 15588 //
     /* 2057625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057671 */     // MIs[0] round
     /* 2057671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057674 */     // MIs[0] policy
     /* 2057674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2057687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057710 */     // GIR_Coverage, 15588,
     /* 2057710 */     GIR_EraseRootFromParent_Done,
     /* 2057711 */   // Label 27358: @2057711
     /* 2057711 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2057802), // Rule ID 15589 //
     /* 2057716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057762 */     // MIs[0] round
     /* 2057762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057765 */     // MIs[0] policy
     /* 2057765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057775 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2057778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057801 */     // GIR_Coverage, 15589,
     /* 2057801 */     GIR_EraseRootFromParent_Done,
     /* 2057802 */   // Label 27359: @2057802
     /* 2057802 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2057893), // Rule ID 15592 //
     /* 2057807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057853 */     // MIs[0] round
     /* 2057853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057856 */     // MIs[0] policy
     /* 2057856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2057869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057892 */     // GIR_Coverage, 15592,
     /* 2057892 */     GIR_EraseRootFromParent_Done,
     /* 2057893 */   // Label 27360: @2057893
     /* 2057893 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2057984), // Rule ID 15593 //
     /* 2057898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057944 */     // MIs[0] round
     /* 2057944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057947 */     // MIs[0] policy
     /* 2057947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2057960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057983 */     // GIR_Coverage, 15593,
     /* 2057983 */     GIR_EraseRootFromParent_Done,
     /* 2057984 */   // Label 27361: @2057984
     /* 2057984 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2058075), // Rule ID 15596 //
     /* 2057989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2057997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2058000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2058003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2058006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058035 */     // MIs[0] round
     /* 2058035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058038 */     // MIs[0] policy
     /* 2058038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2058051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058074 */     // GIR_Coverage, 15596,
     /* 2058074 */     GIR_EraseRootFromParent_Done,
     /* 2058075 */   // Label 27362: @2058075
     /* 2058075 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2058166), // Rule ID 15597 //
     /* 2058080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2058091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2058094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2058097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058126 */     // MIs[0] round
     /* 2058126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058129 */     // MIs[0] policy
     /* 2058129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2058142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058165 */     // GIR_Coverage, 15597,
     /* 2058165 */     GIR_EraseRootFromParent_Done,
     /* 2058166 */   // Label 27363: @2058166
     /* 2058166 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2058257), // Rule ID 15600 //
     /* 2058171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2058182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2058185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2058188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2058194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058217 */     // MIs[0] round
     /* 2058217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058220 */     // MIs[0] policy
     /* 2058220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2058233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058256 */     // GIR_Coverage, 15600,
     /* 2058256 */     GIR_EraseRootFromParent_Done,
     /* 2058257 */   // Label 27364: @2058257
     /* 2058257 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2058348), // Rule ID 15601 //
     /* 2058262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2058273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2058276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2058279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2058285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058308 */     // MIs[0] round
     /* 2058308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058311 */     // MIs[0] policy
     /* 2058311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058321 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2058324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058347 */     // GIR_Coverage, 15601,
     /* 2058347 */     GIR_EraseRootFromParent_Done,
     /* 2058348 */   // Label 27365: @2058348
     /* 2058348 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2058439), // Rule ID 15604 //
     /* 2058353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2058364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2058367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2058370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058399 */     // MIs[0] round
     /* 2058399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058402 */     // MIs[0] policy
     /* 2058402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2058415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058438 */     // GIR_Coverage, 15604,
     /* 2058438 */     GIR_EraseRootFromParent_Done,
     /* 2058439 */   // Label 27366: @2058439
     /* 2058439 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2058530), // Rule ID 15605 //
     /* 2058444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2058455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2058458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2058461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058490 */     // MIs[0] round
     /* 2058490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058493 */     // MIs[0] policy
     /* 2058493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2058506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058529 */     // GIR_Coverage, 15605,
     /* 2058529 */     GIR_EraseRootFromParent_Done,
     /* 2058530 */   // Label 27367: @2058530
     /* 2058530 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2058621), // Rule ID 15608 //
     /* 2058535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058581 */     // MIs[0] round
     /* 2058581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058584 */     // MIs[0] policy
     /* 2058584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2058597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058620 */     // GIR_Coverage, 15608,
     /* 2058620 */     GIR_EraseRootFromParent_Done,
     /* 2058621 */   // Label 27368: @2058621
     /* 2058621 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2058712), // Rule ID 15609 //
     /* 2058626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058672 */     // MIs[0] round
     /* 2058672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058675 */     // MIs[0] policy
     /* 2058675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058685 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2058688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058711 */     // GIR_Coverage, 15609,
     /* 2058711 */     GIR_EraseRootFromParent_Done,
     /* 2058712 */   // Label 27369: @2058712
     /* 2058712 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2058803), // Rule ID 15612 //
     /* 2058717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058763 */     // MIs[0] round
     /* 2058763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058766 */     // MIs[0] policy
     /* 2058766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058776 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2058779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058802 */     // GIR_Coverage, 15612,
     /* 2058802 */     GIR_EraseRootFromParent_Done,
     /* 2058803 */   // Label 27370: @2058803
     /* 2058803 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2058894), // Rule ID 15613 //
     /* 2058808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058854 */     // MIs[0] round
     /* 2058854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058857 */     // MIs[0] policy
     /* 2058857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058867 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2058870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058893 */     // GIR_Coverage, 15613,
     /* 2058893 */     GIR_EraseRootFromParent_Done,
     /* 2058894 */   // Label 27371: @2058894
     /* 2058894 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2058985), // Rule ID 15616 //
     /* 2058899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2058910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2058913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2058916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058945 */     // MIs[0] round
     /* 2058945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058948 */     // MIs[0] policy
     /* 2058948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2058961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058984 */     // GIR_Coverage, 15616,
     /* 2058984 */     GIR_EraseRootFromParent_Done,
     /* 2058985 */   // Label 27372: @2058985
     /* 2058985 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2059076), // Rule ID 15617 //
     /* 2058990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2059001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2059004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2059007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2059020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2059024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2059028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059036 */     // MIs[0] round
     /* 2059036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059039 */     // MIs[0] policy
     /* 2059039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2059052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059075 */     // GIR_Coverage, 15617,
     /* 2059075 */     GIR_EraseRootFromParent_Done,
     /* 2059076 */   // Label 27373: @2059076
     /* 2059076 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2059167), // Rule ID 15620 //
     /* 2059081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2059084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2059092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2059095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2059098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2059111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2059115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2059119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059127 */     // MIs[0] round
     /* 2059127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059130 */     // MIs[0] policy
     /* 2059130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2059143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059166 */     // GIR_Coverage, 15620,
     /* 2059166 */     GIR_EraseRootFromParent_Done,
     /* 2059167 */   // Label 27374: @2059167
     /* 2059167 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2059258), // Rule ID 15621 //
     /* 2059172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2059175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2059183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2059186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2059189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2059202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2059206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2059210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059218 */     // MIs[0] round
     /* 2059218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059221 */     // MIs[0] policy
     /* 2059221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059231 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2059234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059257 */     // GIR_Coverage, 15621,
     /* 2059257 */     GIR_EraseRootFromParent_Done,
     /* 2059258 */   // Label 27375: @2059258
     /* 2059258 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2059349), // Rule ID 15624 //
     /* 2059263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2059266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2059274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2059277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2059280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2059293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059309 */     // MIs[0] round
     /* 2059309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059312 */     // MIs[0] policy
     /* 2059312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059322 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2059325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059348 */     // GIR_Coverage, 15624,
     /* 2059348 */     GIR_EraseRootFromParent_Done,
     /* 2059349 */   // Label 27376: @2059349
     /* 2059349 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2059440), // Rule ID 15625 //
     /* 2059354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2059357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2059365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2059368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2059371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2059384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2059392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059400 */     // MIs[0] round
     /* 2059400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059403 */     // MIs[0] policy
     /* 2059403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059413 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2059416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2059436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059439 */     // GIR_Coverage, 15625,
     /* 2059439 */     GIR_EraseRootFromParent_Done,
     /* 2059440 */   // Label 27377: @2059440
     /* 2059440 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2059534), // Rule ID 15628 //
     /* 2059445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2059456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2059459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2059462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2059465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059491 */     // MIs[0] round
     /* 2059491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059494 */     // MIs[0] policy
     /* 2059494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2059507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059533 */     // GIR_Coverage, 15628,
     /* 2059533 */     GIR_EraseRootFromParent_Done,
     /* 2059534 */   // Label 27378: @2059534
     /* 2059534 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2059628), // Rule ID 15629 //
     /* 2059539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2059550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2059553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2059556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2059559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059585 */     // MIs[0] round
     /* 2059585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059588 */     // MIs[0] policy
     /* 2059588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2059601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059627 */     // GIR_Coverage, 15629,
     /* 2059627 */     GIR_EraseRootFromParent_Done,
     /* 2059628 */   // Label 27379: @2059628
     /* 2059628 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2059722), // Rule ID 15632 //
     /* 2059633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2059644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2059647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2059650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2059653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059679 */     // MIs[0] round
     /* 2059679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059682 */     // MIs[0] policy
     /* 2059682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059692 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2059695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059721 */     // GIR_Coverage, 15632,
     /* 2059721 */     GIR_EraseRootFromParent_Done,
     /* 2059722 */   // Label 27380: @2059722
     /* 2059722 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2059816), // Rule ID 15633 //
     /* 2059727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2059738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2059741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2059744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2059747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059773 */     // MIs[0] round
     /* 2059773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059776 */     // MIs[0] policy
     /* 2059776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2059789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059815 */     // GIR_Coverage, 15633,
     /* 2059815 */     GIR_EraseRootFromParent_Done,
     /* 2059816 */   // Label 27381: @2059816
     /* 2059816 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2059910), // Rule ID 15636 //
     /* 2059821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059867 */     // MIs[0] round
     /* 2059867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059870 */     // MIs[0] policy
     /* 2059870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2059883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059909 */     // GIR_Coverage, 15636,
     /* 2059909 */     GIR_EraseRootFromParent_Done,
     /* 2059910 */   // Label 27382: @2059910
     /* 2059910 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2060004), // Rule ID 15637 //
     /* 2059915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2059926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2059929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2059932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2059935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059961 */     // MIs[0] round
     /* 2059961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059964 */     // MIs[0] policy
     /* 2059964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059974 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2059977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060003 */     // GIR_Coverage, 15637,
     /* 2060003 */     GIR_EraseRootFromParent_Done,
     /* 2060004 */   // Label 27383: @2060004
     /* 2060004 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2060098), // Rule ID 15640 //
     /* 2060009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2060020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2060023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2060026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2060029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060055 */     // MIs[0] round
     /* 2060055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060058 */     // MIs[0] policy
     /* 2060058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060068 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2060071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060097 */     // GIR_Coverage, 15640,
     /* 2060097 */     GIR_EraseRootFromParent_Done,
     /* 2060098 */   // Label 27384: @2060098
     /* 2060098 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2060192), // Rule ID 15641 //
     /* 2060103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2060114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2060117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2060120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2060123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060149 */     // MIs[0] round
     /* 2060149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060152 */     // MIs[0] policy
     /* 2060152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2060165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060191 */     // GIR_Coverage, 15641,
     /* 2060191 */     GIR_EraseRootFromParent_Done,
     /* 2060192 */   // Label 27385: @2060192
     /* 2060192 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2060286), // Rule ID 15644 //
     /* 2060197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2060208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2060211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2060214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2060217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060243 */     // MIs[0] round
     /* 2060243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060246 */     // MIs[0] policy
     /* 2060246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060256 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2060259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060285 */     // GIR_Coverage, 15644,
     /* 2060285 */     GIR_EraseRootFromParent_Done,
     /* 2060286 */   // Label 27386: @2060286
     /* 2060286 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2060380), // Rule ID 15645 //
     /* 2060291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2060302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2060305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2060308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2060311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060337 */     // MIs[0] round
     /* 2060337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060340 */     // MIs[0] policy
     /* 2060340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2060353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060379 */     // GIR_Coverage, 15645,
     /* 2060379 */     GIR_EraseRootFromParent_Done,
     /* 2060380 */   // Label 27387: @2060380
     /* 2060380 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2060474), // Rule ID 15648 //
     /* 2060385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2060396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2060399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2060402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2060405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060431 */     // MIs[0] round
     /* 2060431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060434 */     // MIs[0] policy
     /* 2060434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2060447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060473 */     // GIR_Coverage, 15648,
     /* 2060473 */     GIR_EraseRootFromParent_Done,
     /* 2060474 */   // Label 27388: @2060474
     /* 2060474 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2060568), // Rule ID 15649 //
     /* 2060479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2060490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2060493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2060496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2060499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060525 */     // MIs[0] round
     /* 2060525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060528 */     // MIs[0] policy
     /* 2060528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2060541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060567 */     // GIR_Coverage, 15649,
     /* 2060567 */     GIR_EraseRootFromParent_Done,
     /* 2060568 */   // Label 27389: @2060568
     /* 2060568 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2060662), // Rule ID 15652 //
     /* 2060573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2060584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2060587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2060590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2060593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060619 */     // MIs[0] round
     /* 2060619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060622 */     // MIs[0] policy
     /* 2060622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060632 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2060635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060661 */     // GIR_Coverage, 15652,
     /* 2060661 */     GIR_EraseRootFromParent_Done,
     /* 2060662 */   // Label 27390: @2060662
     /* 2060662 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2060756), // Rule ID 15653 //
     /* 2060667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2060678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2060681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2060684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2060687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060713 */     // MIs[0] round
     /* 2060713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060716 */     // MIs[0] policy
     /* 2060716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2060729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060755 */     // GIR_Coverage, 15653,
     /* 2060755 */     GIR_EraseRootFromParent_Done,
     /* 2060756 */   // Label 27391: @2060756
     /* 2060756 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2060850), // Rule ID 15656 //
     /* 2060761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060807 */     // MIs[0] round
     /* 2060807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060810 */     // MIs[0] policy
     /* 2060810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2060823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060849 */     // GIR_Coverage, 15656,
     /* 2060849 */     GIR_EraseRootFromParent_Done,
     /* 2060850 */   // Label 27392: @2060850
     /* 2060850 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2060944), // Rule ID 15657 //
     /* 2060855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2060866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2060869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2060872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2060875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2060878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060901 */     // MIs[0] round
     /* 2060901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060904 */     // MIs[0] policy
     /* 2060904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2060917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060943 */     // GIR_Coverage, 15657,
     /* 2060943 */     GIR_EraseRootFromParent_Done,
     /* 2060944 */   // Label 27393: @2060944
     /* 2060944 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2061038), // Rule ID 15660 //
     /* 2060949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2060969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060995 */     // MIs[0] round
     /* 2060995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060998 */     // MIs[0] policy
     /* 2060998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2061011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061037 */     // GIR_Coverage, 15660,
     /* 2061037 */     GIR_EraseRootFromParent_Done,
     /* 2061038 */   // Label 27394: @2061038
     /* 2061038 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2061132), // Rule ID 15661 //
     /* 2061043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2061054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2061057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2061060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2061063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2061073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061089 */     // MIs[0] round
     /* 2061089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061092 */     // MIs[0] policy
     /* 2061092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2061105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061131 */     // GIR_Coverage, 15661,
     /* 2061131 */     GIR_EraseRootFromParent_Done,
     /* 2061132 */   // Label 27395: @2061132
     /* 2061132 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2061226), // Rule ID 15664 //
     /* 2061137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2061148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2061151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2061154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2061157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061183 */     // MIs[0] round
     /* 2061183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061186 */     // MIs[0] policy
     /* 2061186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2061199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061225 */     // GIR_Coverage, 15664,
     /* 2061225 */     GIR_EraseRootFromParent_Done,
     /* 2061226 */   // Label 27396: @2061226
     /* 2061226 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2061320), // Rule ID 15665 //
     /* 2061231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2061242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2061245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2061248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2061251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061277 */     // MIs[0] round
     /* 2061277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061280 */     // MIs[0] policy
     /* 2061280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2061293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061319 */     // GIR_Coverage, 15665,
     /* 2061319 */     GIR_EraseRootFromParent_Done,
     /* 2061320 */   // Label 27397: @2061320
     /* 2061320 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2061414), // Rule ID 15668 //
     /* 2061325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2061336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2061339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2061342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2061345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061371 */     // MIs[0] round
     /* 2061371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061374 */     // MIs[0] policy
     /* 2061374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2061387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061413 */     // GIR_Coverage, 15668,
     /* 2061413 */     GIR_EraseRootFromParent_Done,
     /* 2061414 */   // Label 27398: @2061414
     /* 2061414 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2061508), // Rule ID 15669 //
     /* 2061419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2061430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2061433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2061436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2061439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061465 */     // MIs[0] round
     /* 2061465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061468 */     // MIs[0] policy
     /* 2061468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061478 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2061481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061507 */     // GIR_Coverage, 15669,
     /* 2061507 */     GIR_EraseRootFromParent_Done,
     /* 2061508 */   // Label 27399: @2061508
     /* 2061508 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2061602), // Rule ID 15672 //
     /* 2061513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2061524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2061527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2061530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2061533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2061536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061559 */     // MIs[0] round
     /* 2061559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061562 */     // MIs[0] policy
     /* 2061562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061572 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2061575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061601 */     // GIR_Coverage, 15672,
     /* 2061601 */     GIR_EraseRootFromParent_Done,
     /* 2061602 */   // Label 27400: @2061602
     /* 2061602 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2061696), // Rule ID 15673 //
     /* 2061607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2061618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2061621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2061624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2061627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2061630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061653 */     // MIs[0] round
     /* 2061653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061656 */     // MIs[0] policy
     /* 2061656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2061669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2061689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061695 */     // GIR_Coverage, 15673,
     /* 2061695 */     GIR_EraseRootFromParent_Done,
     /* 2061696 */   // Label 27401: @2061696
     /* 2061696 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2061790), // Rule ID 15676 //
     /* 2061701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061747 */     // MIs[0] round
     /* 2061747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061750 */     // MIs[0] policy
     /* 2061750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2061763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061789 */     // GIR_Coverage, 15676,
     /* 2061789 */     GIR_EraseRootFromParent_Done,
     /* 2061790 */   // Label 27402: @2061790
     /* 2061790 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2061884), // Rule ID 15677 //
     /* 2061795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2061806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2061809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2061812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2061815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061841 */     // MIs[0] round
     /* 2061841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061844 */     // MIs[0] policy
     /* 2061844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2061857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061883 */     // GIR_Coverage, 15677,
     /* 2061883 */     GIR_EraseRootFromParent_Done,
     /* 2061884 */   // Label 27403: @2061884
     /* 2061884 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2061978), // Rule ID 15680 //
     /* 2061889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2061909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061935 */     // MIs[0] round
     /* 2061935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061938 */     // MIs[0] policy
     /* 2061938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2061951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061977 */     // GIR_Coverage, 15680,
     /* 2061977 */     GIR_EraseRootFromParent_Done,
     /* 2061978 */   // Label 27404: @2061978
     /* 2061978 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2062072), // Rule ID 15681 //
     /* 2061983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2062000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2062003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062029 */     // MIs[0] round
     /* 2062029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062032 */     // MIs[0] policy
     /* 2062032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062042 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2062045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062071 */     // GIR_Coverage, 15681,
     /* 2062071 */     GIR_EraseRootFromParent_Done,
     /* 2062072 */   // Label 27405: @2062072
     /* 2062072 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2062166), // Rule ID 15684 //
     /* 2062077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2062088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2062091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2062094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2062097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2062100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062123 */     // MIs[0] round
     /* 2062123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062126 */     // MIs[0] policy
     /* 2062126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062136 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062165 */     // GIR_Coverage, 15684,
     /* 2062165 */     GIR_EraseRootFromParent_Done,
     /* 2062166 */   // Label 27406: @2062166
     /* 2062166 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2062260), // Rule ID 15685 //
     /* 2062171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2062182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2062185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2062188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2062191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2062194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062217 */     // MIs[0] round
     /* 2062217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062220 */     // MIs[0] policy
     /* 2062220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062230 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062259 */     // GIR_Coverage, 15685,
     /* 2062259 */     GIR_EraseRootFromParent_Done,
     /* 2062260 */   // Label 27407: @2062260
     /* 2062260 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2062354), // Rule ID 15688 //
     /* 2062265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2062276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2062279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2062282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2062285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062311 */     // MIs[0] round
     /* 2062311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062314 */     // MIs[0] policy
     /* 2062314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2062327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062353 */     // GIR_Coverage, 15688,
     /* 2062353 */     GIR_EraseRootFromParent_Done,
     /* 2062354 */   // Label 27408: @2062354
     /* 2062354 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2062448), // Rule ID 15689 //
     /* 2062359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2062370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2062373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2062376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2062379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062405 */     // MIs[0] round
     /* 2062405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062408 */     // MIs[0] policy
     /* 2062408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2062421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062447 */     // GIR_Coverage, 15689,
     /* 2062447 */     GIR_EraseRootFromParent_Done,
     /* 2062448 */   // Label 27409: @2062448
     /* 2062448 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2062542), // Rule ID 15692 //
     /* 2062453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2062464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2062467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2062470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2062473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062499 */     // MIs[0] round
     /* 2062499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062502 */     // MIs[0] policy
     /* 2062502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2062515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062541 */     // GIR_Coverage, 15692,
     /* 2062541 */     GIR_EraseRootFromParent_Done,
     /* 2062542 */   // Label 27410: @2062542
     /* 2062542 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2062636), // Rule ID 15693 //
     /* 2062547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2062558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2062561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2062564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2062567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062593 */     // MIs[0] round
     /* 2062593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062596 */     // MIs[0] policy
     /* 2062596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2062609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062635 */     // GIR_Coverage, 15693,
     /* 2062635 */     GIR_EraseRootFromParent_Done,
     /* 2062636 */   // Label 27411: @2062636
     /* 2062636 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2062730), // Rule ID 15696 //
     /* 2062641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062687 */     // MIs[0] round
     /* 2062687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062690 */     // MIs[0] policy
     /* 2062690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062729 */     // GIR_Coverage, 15696,
     /* 2062729 */     GIR_EraseRootFromParent_Done,
     /* 2062730 */   // Label 27412: @2062730
     /* 2062730 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2062824), // Rule ID 15697 //
     /* 2062735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2062746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2062749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2062752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2062755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2062758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062781 */     // MIs[0] round
     /* 2062781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062784 */     // MIs[0] policy
     /* 2062784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2062817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062823 */     // GIR_Coverage, 15697,
     /* 2062823 */     GIR_EraseRootFromParent_Done,
     /* 2062824 */   // Label 27413: @2062824
     /* 2062824 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2062918), // Rule ID 15700 //
     /* 2062829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062875 */     // MIs[0] round
     /* 2062875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062878 */     // MIs[0] policy
     /* 2062878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062888 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2062891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062917 */     // GIR_Coverage, 15700,
     /* 2062917 */     GIR_EraseRootFromParent_Done,
     /* 2062918 */   // Label 27414: @2062918
     /* 2062918 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2063012), // Rule ID 15701 //
     /* 2062923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062969 */     // MIs[0] round
     /* 2062969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062972 */     // MIs[0] policy
     /* 2062972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062982 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2062985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063011 */     // GIR_Coverage, 15701,
     /* 2063011 */     GIR_EraseRootFromParent_Done,
     /* 2063012 */   // Label 27415: @2063012
     /* 2063012 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2063106), // Rule ID 15704 //
     /* 2063017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063063 */     // MIs[0] round
     /* 2063063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063066 */     // MIs[0] policy
     /* 2063066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2063079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063105 */     // GIR_Coverage, 15704,
     /* 2063105 */     GIR_EraseRootFromParent_Done,
     /* 2063106 */   // Label 27416: @2063106
     /* 2063106 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2063200), // Rule ID 15705 //
     /* 2063111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063157 */     // MIs[0] round
     /* 2063157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063160 */     // MIs[0] policy
     /* 2063160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063170 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2063173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063199 */     // GIR_Coverage, 15705,
     /* 2063199 */     GIR_EraseRootFromParent_Done,
     /* 2063200 */   // Label 27417: @2063200
     /* 2063200 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2063294), // Rule ID 15708 //
     /* 2063205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063251 */     // MIs[0] round
     /* 2063251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063254 */     // MIs[0] policy
     /* 2063254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063264 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063293 */     // GIR_Coverage, 15708,
     /* 2063293 */     GIR_EraseRootFromParent_Done,
     /* 2063294 */   // Label 27418: @2063294
     /* 2063294 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2063388), // Rule ID 15709 //
     /* 2063299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063345 */     // MIs[0] round
     /* 2063345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063348 */     // MIs[0] policy
     /* 2063348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063358 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063387 */     // GIR_Coverage, 15709,
     /* 2063387 */     GIR_EraseRootFromParent_Done,
     /* 2063388 */   // Label 27419: @2063388
     /* 2063388 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2063482), // Rule ID 15712 //
     /* 2063393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063439 */     // MIs[0] round
     /* 2063439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063442 */     // MIs[0] policy
     /* 2063442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2063455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063481 */     // GIR_Coverage, 15712,
     /* 2063481 */     GIR_EraseRootFromParent_Done,
     /* 2063482 */   // Label 27420: @2063482
     /* 2063482 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2063576), // Rule ID 15713 //
     /* 2063487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063533 */     // MIs[0] round
     /* 2063533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063536 */     // MIs[0] policy
     /* 2063536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2063549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063575 */     // GIR_Coverage, 15713,
     /* 2063575 */     GIR_EraseRootFromParent_Done,
     /* 2063576 */   // Label 27421: @2063576
     /* 2063576 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2063670), // Rule ID 15716 //
     /* 2063581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063627 */     // MIs[0] round
     /* 2063627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063630 */     // MIs[0] policy
     /* 2063630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063669 */     // GIR_Coverage, 15716,
     /* 2063669 */     GIR_EraseRootFromParent_Done,
     /* 2063670 */   // Label 27422: @2063670
     /* 2063670 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2063764), // Rule ID 15717 //
     /* 2063675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063721 */     // MIs[0] round
     /* 2063721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063724 */     // MIs[0] policy
     /* 2063724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063763 */     // GIR_Coverage, 15717,
     /* 2063763 */     GIR_EraseRootFromParent_Done,
     /* 2063764 */   // Label 27423: @2063764
     /* 2063764 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2063858), // Rule ID 15720 //
     /* 2063769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063815 */     // MIs[0] round
     /* 2063815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063818 */     // MIs[0] policy
     /* 2063818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063857 */     // GIR_Coverage, 15720,
     /* 2063857 */     GIR_EraseRootFromParent_Done,
     /* 2063858 */   // Label 27424: @2063858
     /* 2063858 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2063952), // Rule ID 15721 //
     /* 2063863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063909 */     // MIs[0] round
     /* 2063909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063912 */     // MIs[0] policy
     /* 2063912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063922 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2063925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063951 */     // GIR_Coverage, 15721,
     /* 2063951 */     GIR_EraseRootFromParent_Done,
     /* 2063952 */   // Label 27425: @2063952
     /* 2063952 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2064046), // Rule ID 15724 //
     /* 2063957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064003 */     // MIs[0] round
     /* 2064003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064006 */     // MIs[0] policy
     /* 2064006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064045 */     // GIR_Coverage, 15724,
     /* 2064045 */     GIR_EraseRootFromParent_Done,
     /* 2064046 */   // Label 27426: @2064046
     /* 2064046 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2064140), // Rule ID 15725 //
     /* 2064051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2064062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2064065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2064068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064097 */     // MIs[0] round
     /* 2064097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064100 */     // MIs[0] policy
     /* 2064100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064139 */     // GIR_Coverage, 15725,
     /* 2064139 */     GIR_EraseRootFromParent_Done,
     /* 2064140 */   // Label 27427: @2064140
     /* 2064140 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2064234), // Rule ID 15728 //
     /* 2064145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064191 */     // MIs[0] round
     /* 2064191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064194 */     // MIs[0] policy
     /* 2064194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064233 */     // GIR_Coverage, 15728,
     /* 2064233 */     GIR_EraseRootFromParent_Done,
     /* 2064234 */   // Label 27428: @2064234
     /* 2064234 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2064328), // Rule ID 15729 //
     /* 2064239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064285 */     // MIs[0] round
     /* 2064285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064288 */     // MIs[0] policy
     /* 2064288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064327 */     // GIR_Coverage, 15729,
     /* 2064327 */     GIR_EraseRootFromParent_Done,
     /* 2064328 */   // Label 27429: @2064328
     /* 2064328 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2064422), // Rule ID 15732 //
     /* 2064333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064379 */     // MIs[0] round
     /* 2064379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064382 */     // MIs[0] policy
     /* 2064382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064421 */     // GIR_Coverage, 15732,
     /* 2064421 */     GIR_EraseRootFromParent_Done,
     /* 2064422 */   // Label 27430: @2064422
     /* 2064422 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2064516), // Rule ID 15733 //
     /* 2064427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064473 */     // MIs[0] round
     /* 2064473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064476 */     // MIs[0] policy
     /* 2064476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2064489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064515 */     // GIR_Coverage, 15733,
     /* 2064515 */     GIR_EraseRootFromParent_Done,
     /* 2064516 */   // Label 27431: @2064516
     /* 2064516 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2064610), // Rule ID 15736 //
     /* 2064521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064567 */     // MIs[0] round
     /* 2064567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064570 */     // MIs[0] policy
     /* 2064570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2064583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064609 */     // GIR_Coverage, 15736,
     /* 2064609 */     GIR_EraseRootFromParent_Done,
     /* 2064610 */   // Label 27432: @2064610
     /* 2064610 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2064704), // Rule ID 15737 //
     /* 2064615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064661 */     // MIs[0] round
     /* 2064661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064664 */     // MIs[0] policy
     /* 2064664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2064677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064703 */     // GIR_Coverage, 15737,
     /* 2064703 */     GIR_EraseRootFromParent_Done,
     /* 2064704 */   // Label 27433: @2064704
     /* 2064704 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2064798), // Rule ID 15740 //
     /* 2064709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064755 */     // MIs[0] round
     /* 2064755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064758 */     // MIs[0] policy
     /* 2064758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064768 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2064771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064797 */     // GIR_Coverage, 15740,
     /* 2064797 */     GIR_EraseRootFromParent_Done,
     /* 2064798 */   // Label 27434: @2064798
     /* 2064798 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2064892), // Rule ID 15741 //
     /* 2064803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064849 */     // MIs[0] round
     /* 2064849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064852 */     // MIs[0] policy
     /* 2064852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064862 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2064865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064891 */     // GIR_Coverage, 15741,
     /* 2064891 */     GIR_EraseRootFromParent_Done,
     /* 2064892 */   // Label 27435: @2064892
     /* 2064892 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2064986), // Rule ID 15744 //
     /* 2064897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064943 */     // MIs[0] round
     /* 2064943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064946 */     // MIs[0] policy
     /* 2064946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2064959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2064984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064985 */     // GIR_Coverage, 15744,
     /* 2064985 */     GIR_EraseRootFromParent_Done,
     /* 2064986 */   // Label 27436: @2064986
     /* 2064986 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2065080), // Rule ID 15745 //
     /* 2064991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2064999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2065002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2065005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2065008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065037 */     // MIs[0] round
     /* 2065037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065040 */     // MIs[0] policy
     /* 2065040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065050 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2065053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065079 */     // GIR_Coverage, 15745,
     /* 2065079 */     GIR_EraseRootFromParent_Done,
     /* 2065080 */   // Label 27437: @2065080
     /* 2065080 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2065174), // Rule ID 15748 //
     /* 2065085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065131 */     // MIs[0] round
     /* 2065131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065134 */     // MIs[0] policy
     /* 2065134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2065147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065173 */     // GIR_Coverage, 15748,
     /* 2065173 */     GIR_EraseRootFromParent_Done,
     /* 2065174 */   // Label 27438: @2065174
     /* 2065174 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2065268), // Rule ID 15749 //
     /* 2065179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065225 */     // MIs[0] round
     /* 2065225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065228 */     // MIs[0] policy
     /* 2065228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2065241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065267 */     // GIR_Coverage, 15749,
     /* 2065267 */     GIR_EraseRootFromParent_Done,
     /* 2065268 */   // Label 27439: @2065268
     /* 2065268 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2065362), // Rule ID 15752 //
     /* 2065273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065319 */     // MIs[0] round
     /* 2065319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065322 */     // MIs[0] policy
     /* 2065322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2065335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065361 */     // GIR_Coverage, 15752,
     /* 2065361 */     GIR_EraseRootFromParent_Done,
     /* 2065362 */   // Label 27440: @2065362
     /* 2065362 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2065456), // Rule ID 15753 //
     /* 2065367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065413 */     // MIs[0] round
     /* 2065413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065416 */     // MIs[0] policy
     /* 2065416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2065429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065455 */     // GIR_Coverage, 15753,
     /* 2065455 */     GIR_EraseRootFromParent_Done,
     /* 2065456 */   // Label 27441: @2065456
     /* 2065456 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2065550), // Rule ID 15756 //
     /* 2065461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065507 */     // MIs[0] round
     /* 2065507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065510 */     // MIs[0] policy
     /* 2065510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065520 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2065523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065549 */     // GIR_Coverage, 15756,
     /* 2065549 */     GIR_EraseRootFromParent_Done,
     /* 2065550 */   // Label 27442: @2065550
     /* 2065550 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2065644), // Rule ID 15757 //
     /* 2065555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065601 */     // MIs[0] round
     /* 2065601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065604 */     // MIs[0] policy
     /* 2065604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2065617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065643 */     // GIR_Coverage, 15757,
     /* 2065643 */     GIR_EraseRootFromParent_Done,
     /* 2065644 */   // Label 27443: @2065644
     /* 2065644 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2065738), // Rule ID 15760 //
     /* 2065649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065695 */     // MIs[0] round
     /* 2065695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065698 */     // MIs[0] policy
     /* 2065698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2065711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065737 */     // GIR_Coverage, 15760,
     /* 2065737 */     GIR_EraseRootFromParent_Done,
     /* 2065738 */   // Label 27444: @2065738
     /* 2065738 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2065832), // Rule ID 15761 //
     /* 2065743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065789 */     // MIs[0] round
     /* 2065789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065792 */     // MIs[0] policy
     /* 2065792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2065805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065831 */     // GIR_Coverage, 15761,
     /* 2065831 */     GIR_EraseRootFromParent_Done,
     /* 2065832 */   // Label 27445: @2065832
     /* 2065832 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2065926), // Rule ID 15764 //
     /* 2065837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065883 */     // MIs[0] round
     /* 2065883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065886 */     // MIs[0] policy
     /* 2065886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2065899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2065924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065925 */     // GIR_Coverage, 15764,
     /* 2065925 */     GIR_EraseRootFromParent_Done,
     /* 2065926 */   // Label 27446: @2065926
     /* 2065926 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2066020), // Rule ID 15765 //
     /* 2065931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2065939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065977 */     // MIs[0] round
     /* 2065977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065980 */     // MIs[0] policy
     /* 2065980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2065993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066019 */     // GIR_Coverage, 15765,
     /* 2066019 */     GIR_EraseRootFromParent_Done,
     /* 2066020 */   // Label 27447: @2066020
     /* 2066020 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2066114), // Rule ID 15768 //
     /* 2066025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066071 */     // MIs[0] round
     /* 2066071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066074 */     // MIs[0] policy
     /* 2066074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2066087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066113 */     // GIR_Coverage, 15768,
     /* 2066113 */     GIR_EraseRootFromParent_Done,
     /* 2066114 */   // Label 27448: @2066114
     /* 2066114 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2066208), // Rule ID 15769 //
     /* 2066119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066165 */     // MIs[0] round
     /* 2066165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066168 */     // MIs[0] policy
     /* 2066168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2066181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066207 */     // GIR_Coverage, 15769,
     /* 2066207 */     GIR_EraseRootFromParent_Done,
     /* 2066208 */   // Label 27449: @2066208
     /* 2066208 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2066302), // Rule ID 15772 //
     /* 2066213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2066216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2066224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2066227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2066230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2066233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066259 */     // MIs[0] round
     /* 2066259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066262 */     // MIs[0] policy
     /* 2066262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2066275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066301 */     // GIR_Coverage, 15772,
     /* 2066301 */     GIR_EraseRootFromParent_Done,
     /* 2066302 */   // Label 27450: @2066302
     /* 2066302 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2066396), // Rule ID 15773 //
     /* 2066307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2066310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2066318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2066321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2066324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2066327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066353 */     // MIs[0] round
     /* 2066353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066356 */     // MIs[0] policy
     /* 2066356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2066369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066395 */     // GIR_Coverage, 15773,
     /* 2066395 */     GIR_EraseRootFromParent_Done,
     /* 2066396 */   // Label 27451: @2066396
     /* 2066396 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2066490), // Rule ID 15776 //
     /* 2066401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2066404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066447 */     // MIs[0] round
     /* 2066447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066450 */     // MIs[0] policy
     /* 2066450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2066463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066489 */     // GIR_Coverage, 15776,
     /* 2066489 */     GIR_EraseRootFromParent_Done,
     /* 2066490 */   // Label 27452: @2066490
     /* 2066490 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2066584), // Rule ID 15777 //
     /* 2066495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2066498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066541 */     // MIs[0] round
     /* 2066541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066544 */     // MIs[0] policy
     /* 2066544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2066557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066583 */     // GIR_Coverage, 15777,
     /* 2066583 */     GIR_EraseRootFromParent_Done,
     /* 2066584 */   // Label 27453: @2066584
     /* 2066584 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2066678), // Rule ID 15780 //
     /* 2066589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2066592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2066609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066635 */     // MIs[0] round
     /* 2066635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066638 */     // MIs[0] policy
     /* 2066638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2066651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066677 */     // GIR_Coverage, 15780,
     /* 2066677 */     GIR_EraseRootFromParent_Done,
     /* 2066678 */   // Label 27454: @2066678
     /* 2066678 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2066772), // Rule ID 15781 //
     /* 2066683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2066686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2066703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066729 */     // MIs[0] round
     /* 2066729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066732 */     // MIs[0] policy
     /* 2066732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2066745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066771 */     // GIR_Coverage, 15781,
     /* 2066771 */     GIR_EraseRootFromParent_Done,
     /* 2066772 */   // Label 27455: @2066772
     /* 2066772 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2066866), // Rule ID 15784 //
     /* 2066777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2066780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2066797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066823 */     // MIs[0] round
     /* 2066823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066826 */     // MIs[0] policy
     /* 2066826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066836 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2066839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066865 */     // GIR_Coverage, 15784,
     /* 2066865 */     GIR_EraseRootFromParent_Done,
     /* 2066866 */   // Label 27456: @2066866
     /* 2066866 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2066960), // Rule ID 15785 //
     /* 2066871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2066874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2066891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066917 */     // MIs[0] round
     /* 2066917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066920 */     // MIs[0] policy
     /* 2066920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2066933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066959 */     // GIR_Coverage, 15785,
     /* 2066959 */     GIR_EraseRootFromParent_Done,
     /* 2066960 */   // Label 27457: @2066960
     /* 2066960 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2067054), // Rule ID 15788 //
     /* 2066965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2066968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2066976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2066979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2066982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067011 */     // MIs[0] round
     /* 2067011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067014 */     // MIs[0] policy
     /* 2067014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2067027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067053 */     // GIR_Coverage, 15788,
     /* 2067053 */     GIR_EraseRootFromParent_Done,
     /* 2067054 */   // Label 27458: @2067054
     /* 2067054 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2067148), // Rule ID 15789 //
     /* 2067059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2067062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2067070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2067073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2067076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067105 */     // MIs[0] round
     /* 2067105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067108 */     // MIs[0] policy
     /* 2067108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2067121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067147 */     // GIR_Coverage, 15789,
     /* 2067147 */     GIR_EraseRootFromParent_Done,
     /* 2067148 */   // Label 27459: @2067148
     /* 2067148 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2067242), // Rule ID 15792 //
     /* 2067153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2067156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2067164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2067167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2067170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2067183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2067187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2067191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067199 */     // MIs[0] round
     /* 2067199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067202 */     // MIs[0] policy
     /* 2067202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2067215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067241 */     // GIR_Coverage, 15792,
     /* 2067241 */     GIR_EraseRootFromParent_Done,
     /* 2067242 */   // Label 27460: @2067242
     /* 2067242 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2067336), // Rule ID 15793 //
     /* 2067247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2067250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2067258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2067261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2067264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2067277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2067281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2067285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067293 */     // MIs[0] round
     /* 2067293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067296 */     // MIs[0] policy
     /* 2067296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11501:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2067309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067335 */     // GIR_Coverage, 15793,
     /* 2067335 */     GIR_EraseRootFromParent_Done,
     /* 2067336 */   // Label 27461: @2067336
     /* 2067336 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2067430), // Rule ID 15796 //
     /* 2067341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2067344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2067358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067387 */     // MIs[0] round
     /* 2067387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067390 */     // MIs[0] policy
     /* 2067390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2067403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067429 */     // GIR_Coverage, 15796,
     /* 2067429 */     GIR_EraseRootFromParent_Done,
     /* 2067430 */   // Label 27462: @2067430
     /* 2067430 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2067524), // Rule ID 15797 //
     /* 2067435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2067438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2067452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067481 */     // MIs[0] round
     /* 2067481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067484 */     // MIs[0] policy
     /* 2067484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067494 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11501:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2067497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067523 */     // GIR_Coverage, 15797,
     /* 2067523 */     GIR_EraseRootFromParent_Done,
     /* 2067524 */   // Label 27463: @2067524
     /* 2067524 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2067618), // Rule ID 15800 //
     /* 2067529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2067532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2067546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067575 */     // MIs[0] round
     /* 2067575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067578 */     // MIs[0] policy
     /* 2067578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067588 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2067591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067617 */     // GIR_Coverage, 15800,
     /* 2067617 */     GIR_EraseRootFromParent_Done,
     /* 2067618 */   // Label 27464: @2067618
     /* 2067618 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2067712), // Rule ID 15801 //
     /* 2067623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2067626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2067640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067669 */     // MIs[0] round
     /* 2067669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067672 */     // MIs[0] policy
     /* 2067672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11501:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2067685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067711 */     // GIR_Coverage, 15801,
     /* 2067711 */     GIR_EraseRootFromParent_Done,
     /* 2067712 */   // Label 27465: @2067712
     /* 2067712 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2067803), // Rule ID 15804 //
     /* 2067717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2067728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2067731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2067734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2067737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067763 */     // MIs[0] round
     /* 2067763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067766 */     // MIs[0] policy
     /* 2067766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067776 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2067779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067802 */     // GIR_Coverage, 15804,
     /* 2067802 */     GIR_EraseRootFromParent_Done,
     /* 2067803 */   // Label 27466: @2067803
     /* 2067803 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2067894), // Rule ID 15805 //
     /* 2067808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2067819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2067822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2067825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2067828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067854 */     // MIs[0] round
     /* 2067854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067857 */     // MIs[0] policy
     /* 2067857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067867 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2067870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067893 */     // GIR_Coverage, 15805,
     /* 2067893 */     GIR_EraseRootFromParent_Done,
     /* 2067894 */   // Label 27467: @2067894
     /* 2067894 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2067985), // Rule ID 15808 //
     /* 2067899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2067910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2067913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2067919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067945 */     // MIs[0] round
     /* 2067945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067948 */     // MIs[0] policy
     /* 2067948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067958 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2067961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067984 */     // GIR_Coverage, 15808,
     /* 2067984 */     GIR_EraseRootFromParent_Done,
     /* 2067985 */   // Label 27468: @2067985
     /* 2067985 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2068076), // Rule ID 15809 //
     /* 2067990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2068001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2068004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2068007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2068010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068036 */     // MIs[0] round
     /* 2068036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068039 */     // MIs[0] policy
     /* 2068039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068049 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2068052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068075 */     // GIR_Coverage, 15809,
     /* 2068075 */     GIR_EraseRootFromParent_Done,
     /* 2068076 */   // Label 27469: @2068076
     /* 2068076 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2068167), // Rule ID 15812 //
     /* 2068081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2068092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2068095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2068098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2068101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068127 */     // MIs[0] round
     /* 2068127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068130 */     // MIs[0] policy
     /* 2068130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068166 */     // GIR_Coverage, 15812,
     /* 2068166 */     GIR_EraseRootFromParent_Done,
     /* 2068167 */   // Label 27470: @2068167
     /* 2068167 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2068258), // Rule ID 15813 //
     /* 2068172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2068183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2068186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2068189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2068192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068218 */     // MIs[0] round
     /* 2068218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068221 */     // MIs[0] policy
     /* 2068221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068231 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068257 */     // GIR_Coverage, 15813,
     /* 2068257 */     GIR_EraseRootFromParent_Done,
     /* 2068258 */   // Label 27471: @2068258
     /* 2068258 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2068349), // Rule ID 15816 //
     /* 2068263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2068274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2068277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2068280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2068283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068309 */     // MIs[0] round
     /* 2068309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068312 */     // MIs[0] policy
     /* 2068312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2068325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068348 */     // GIR_Coverage, 15816,
     /* 2068348 */     GIR_EraseRootFromParent_Done,
     /* 2068349 */   // Label 27472: @2068349
     /* 2068349 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2068440), // Rule ID 15817 //
     /* 2068354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2068365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2068368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2068371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2068374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068400 */     // MIs[0] round
     /* 2068400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068403 */     // MIs[0] policy
     /* 2068403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068413 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2068416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068439 */     // GIR_Coverage, 15817,
     /* 2068439 */     GIR_EraseRootFromParent_Done,
     /* 2068440 */   // Label 27473: @2068440
     /* 2068440 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2068531), // Rule ID 15820 //
     /* 2068445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2068456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2068459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2068462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2068465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068491 */     // MIs[0] round
     /* 2068491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068494 */     // MIs[0] policy
     /* 2068494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068530 */     // GIR_Coverage, 15820,
     /* 2068530 */     GIR_EraseRootFromParent_Done,
     /* 2068531 */   // Label 27474: @2068531
     /* 2068531 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2068622), // Rule ID 15821 //
     /* 2068536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2068547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2068550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2068553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2068556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068582 */     // MIs[0] round
     /* 2068582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068585 */     // MIs[0] policy
     /* 2068585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068595 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068621 */     // GIR_Coverage, 15821,
     /* 2068621 */     GIR_EraseRootFromParent_Done,
     /* 2068622 */   // Label 27475: @2068622
     /* 2068622 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2068713), // Rule ID 15824 //
     /* 2068627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2068638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2068641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2068644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2068647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068673 */     // MIs[0] round
     /* 2068673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068676 */     // MIs[0] policy
     /* 2068676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068686 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068712 */     // GIR_Coverage, 15824,
     /* 2068712 */     GIR_EraseRootFromParent_Done,
     /* 2068713 */   // Label 27476: @2068713
     /* 2068713 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2068804), // Rule ID 15825 //
     /* 2068718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2068729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2068732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2068735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2068738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068764 */     // MIs[0] round
     /* 2068764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068767 */     // MIs[0] policy
     /* 2068767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2068780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068803 */     // GIR_Coverage, 15825,
     /* 2068803 */     GIR_EraseRootFromParent_Done,
     /* 2068804 */   // Label 27477: @2068804
     /* 2068804 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2068895), // Rule ID 15828 //
     /* 2068809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2068829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068855 */     // MIs[0] round
     /* 2068855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068858 */     // MIs[0] policy
     /* 2068858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2068871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068894 */     // GIR_Coverage, 15828,
     /* 2068894 */     GIR_EraseRootFromParent_Done,
     /* 2068895 */   // Label 27478: @2068895
     /* 2068895 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2068986), // Rule ID 15829 //
     /* 2068900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2068920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068946 */     // MIs[0] round
     /* 2068946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068949 */     // MIs[0] policy
     /* 2068949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2068962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068985 */     // GIR_Coverage, 15829,
     /* 2068985 */     GIR_EraseRootFromParent_Done,
     /* 2068986 */   // Label 27479: @2068986
     /* 2068986 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2069077), // Rule ID 15832 //
     /* 2068991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2069002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2069005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2069008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2069011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069037 */     // MIs[0] round
     /* 2069037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069040 */     // MIs[0] policy
     /* 2069040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069076 */     // GIR_Coverage, 15832,
     /* 2069076 */     GIR_EraseRootFromParent_Done,
     /* 2069077 */   // Label 27480: @2069077
     /* 2069077 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2069168), // Rule ID 15833 //
     /* 2069082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2069093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2069096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2069099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2069102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069128 */     // MIs[0] round
     /* 2069128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069131 */     // MIs[0] policy
     /* 2069131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069167 */     // GIR_Coverage, 15833,
     /* 2069167 */     GIR_EraseRootFromParent_Done,
     /* 2069168 */   // Label 27481: @2069168
     /* 2069168 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2069259), // Rule ID 15836 //
     /* 2069173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2069184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2069187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2069190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2069193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069219 */     // MIs[0] round
     /* 2069219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069222 */     // MIs[0] policy
     /* 2069222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069258 */     // GIR_Coverage, 15836,
     /* 2069258 */     GIR_EraseRootFromParent_Done,
     /* 2069259 */   // Label 27482: @2069259
     /* 2069259 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2069350), // Rule ID 15837 //
     /* 2069264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2069275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2069278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2069281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2069284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069310 */     // MIs[0] round
     /* 2069310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069313 */     // MIs[0] policy
     /* 2069313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069323 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069349 */     // GIR_Coverage, 15837,
     /* 2069349 */     GIR_EraseRootFromParent_Done,
     /* 2069350 */   // Label 27483: @2069350
     /* 2069350 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2069441), // Rule ID 15840 //
     /* 2069355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2069358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2069366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2069369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2069372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2069375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069401 */     // MIs[0] round
     /* 2069401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069404 */     // MIs[0] policy
     /* 2069404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069440 */     // GIR_Coverage, 15840,
     /* 2069440 */     GIR_EraseRootFromParent_Done,
     /* 2069441 */   // Label 27484: @2069441
     /* 2069441 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2069532), // Rule ID 15841 //
     /* 2069446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2069449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2069457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2069460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2069463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2069466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069492 */     // MIs[0] round
     /* 2069492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069495 */     // MIs[0] policy
     /* 2069495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069505 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2069508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069531 */     // GIR_Coverage, 15841,
     /* 2069531 */     GIR_EraseRootFromParent_Done,
     /* 2069532 */   // Label 27485: @2069532
     /* 2069532 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2069623), // Rule ID 15844 //
     /* 2069537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2069548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2069551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2069554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2069557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069583 */     // MIs[0] round
     /* 2069583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069586 */     // MIs[0] policy
     /* 2069586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2069599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069622 */     // GIR_Coverage, 15844,
     /* 2069622 */     GIR_EraseRootFromParent_Done,
     /* 2069623 */   // Label 27486: @2069623
     /* 2069623 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2069714), // Rule ID 15845 //
     /* 2069628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2069639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2069642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2069645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2069648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069674 */     // MIs[0] round
     /* 2069674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069677 */     // MIs[0] policy
     /* 2069677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069687 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2069690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069713 */     // GIR_Coverage, 15845,
     /* 2069713 */     GIR_EraseRootFromParent_Done,
     /* 2069714 */   // Label 27487: @2069714
     /* 2069714 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2069805), // Rule ID 15848 //
     /* 2069719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2069730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2069733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2069736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2069739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069765 */     // MIs[0] round
     /* 2069765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069768 */     // MIs[0] policy
     /* 2069768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069778 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2069781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069804 */     // GIR_Coverage, 15848,
     /* 2069804 */     GIR_EraseRootFromParent_Done,
     /* 2069805 */   // Label 27488: @2069805
     /* 2069805 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2069896), // Rule ID 15849 //
     /* 2069810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2069821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2069824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2069827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2069830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069856 */     // MIs[0] round
     /* 2069856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069859 */     // MIs[0] policy
     /* 2069859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2069872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069895 */     // GIR_Coverage, 15849,
     /* 2069895 */     GIR_EraseRootFromParent_Done,
     /* 2069896 */   // Label 27489: @2069896
     /* 2069896 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2069987), // Rule ID 15852 //
     /* 2069901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2069912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2069915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2069918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2069921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2069924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069947 */     // MIs[0] round
     /* 2069947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069950 */     // MIs[0] policy
     /* 2069950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2069963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069986 */     // GIR_Coverage, 15852,
     /* 2069986 */     GIR_EraseRootFromParent_Done,
     /* 2069987 */   // Label 27490: @2069987
     /* 2069987 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2070078), // Rule ID 15853 //
     /* 2069992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2070003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2070006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2070009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2070012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2070015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070038 */     // MIs[0] round
     /* 2070038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070041 */     // MIs[0] policy
     /* 2070041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070051 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2070054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070077 */     // GIR_Coverage, 15853,
     /* 2070077 */     GIR_EraseRootFromParent_Done,
     /* 2070078 */   // Label 27491: @2070078
     /* 2070078 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2070169), // Rule ID 15856 //
     /* 2070083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2070094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2070097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2070100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2070103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070129 */     // MIs[0] round
     /* 2070129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070132 */     // MIs[0] policy
     /* 2070132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2070145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070168 */     // GIR_Coverage, 15856,
     /* 2070168 */     GIR_EraseRootFromParent_Done,
     /* 2070169 */   // Label 27492: @2070169
     /* 2070169 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2070260), // Rule ID 15857 //
     /* 2070174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2070185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2070188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2070191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2070194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070220 */     // MIs[0] round
     /* 2070220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070223 */     // MIs[0] policy
     /* 2070223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2070236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070259 */     // GIR_Coverage, 15857,
     /* 2070259 */     GIR_EraseRootFromParent_Done,
     /* 2070260 */   // Label 27493: @2070260
     /* 2070260 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2070351), // Rule ID 15860 //
     /* 2070265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2070276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2070279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2070282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2070285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070311 */     // MIs[0] round
     /* 2070311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070314 */     // MIs[0] policy
     /* 2070314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2070327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070350 */     // GIR_Coverage, 15860,
     /* 2070350 */     GIR_EraseRootFromParent_Done,
     /* 2070351 */   // Label 27494: @2070351
     /* 2070351 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2070442), // Rule ID 15861 //
     /* 2070356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2070367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2070370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2070373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2070376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070402 */     // MIs[0] round
     /* 2070402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070405 */     // MIs[0] policy
     /* 2070405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2070418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070441 */     // GIR_Coverage, 15861,
     /* 2070441 */     GIR_EraseRootFromParent_Done,
     /* 2070442 */   // Label 27495: @2070442
     /* 2070442 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2070533), // Rule ID 15864 //
     /* 2070447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2070458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2070461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2070464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2070467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2070470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070493 */     // MIs[0] round
     /* 2070493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070496 */     // MIs[0] policy
     /* 2070496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070506 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2070509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070532 */     // GIR_Coverage, 15864,
     /* 2070532 */     GIR_EraseRootFromParent_Done,
     /* 2070533 */   // Label 27496: @2070533
     /* 2070533 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2070624), // Rule ID 15865 //
     /* 2070538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2070549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2070552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2070555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2070558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2070561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070584 */     // MIs[0] round
     /* 2070584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070587 */     // MIs[0] policy
     /* 2070587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070597 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2070600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070623 */     // GIR_Coverage, 15865,
     /* 2070623 */     GIR_EraseRootFromParent_Done,
     /* 2070624 */   // Label 27497: @2070624
     /* 2070624 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2070715), // Rule ID 15868 //
     /* 2070629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2070640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2070643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2070646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2070649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070675 */     // MIs[0] round
     /* 2070675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070678 */     // MIs[0] policy
     /* 2070678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2070691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070714 */     // GIR_Coverage, 15868,
     /* 2070714 */     GIR_EraseRootFromParent_Done,
     /* 2070715 */   // Label 27498: @2070715
     /* 2070715 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2070806), // Rule ID 15869 //
     /* 2070720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2070731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2070734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2070737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2070740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070766 */     // MIs[0] round
     /* 2070766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070769 */     // MIs[0] policy
     /* 2070769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2070782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070805 */     // GIR_Coverage, 15869,
     /* 2070805 */     GIR_EraseRootFromParent_Done,
     /* 2070806 */   // Label 27499: @2070806
     /* 2070806 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2070897), // Rule ID 15872 //
     /* 2070811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2070822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2070825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2070828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2070831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070857 */     // MIs[0] round
     /* 2070857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070860 */     // MIs[0] policy
     /* 2070860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2070873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070896 */     // GIR_Coverage, 15872,
     /* 2070896 */     GIR_EraseRootFromParent_Done,
     /* 2070897 */   // Label 27500: @2070897
     /* 2070897 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2070988), // Rule ID 15873 //
     /* 2070902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2070913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2070916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2070919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2070922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070948 */     // MIs[0] round
     /* 2070948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070951 */     // MIs[0] policy
     /* 2070951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070961 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2070964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070987 */     // GIR_Coverage, 15873,
     /* 2070987 */     GIR_EraseRootFromParent_Done,
     /* 2070988 */   // Label 27501: @2070988
     /* 2070988 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2071079), // Rule ID 15876 //
     /* 2070993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2071004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2071007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2071010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2071013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071039 */     // MIs[0] round
     /* 2071039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071042 */     // MIs[0] policy
     /* 2071042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2071055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071078 */     // GIR_Coverage, 15876,
     /* 2071078 */     GIR_EraseRootFromParent_Done,
     /* 2071079 */   // Label 27502: @2071079
     /* 2071079 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2071170), // Rule ID 15877 //
     /* 2071084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2071095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2071098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2071101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2071104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071130 */     // MIs[0] round
     /* 2071130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071133 */     // MIs[0] policy
     /* 2071133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2071146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071169 */     // GIR_Coverage, 15877,
     /* 2071169 */     GIR_EraseRootFromParent_Done,
     /* 2071170 */   // Label 27503: @2071170
     /* 2071170 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2071261), // Rule ID 15880 //
     /* 2071175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2071178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2071186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2071189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2071192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2071195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071221 */     // MIs[0] round
     /* 2071221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071224 */     // MIs[0] policy
     /* 2071224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2071237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071260 */     // GIR_Coverage, 15880,
     /* 2071260 */     GIR_EraseRootFromParent_Done,
     /* 2071261 */   // Label 27504: @2071261
     /* 2071261 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2071352), // Rule ID 15881 //
     /* 2071266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2071269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2071277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2071280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2071283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2071286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071312 */     // MIs[0] round
     /* 2071312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071315 */     // MIs[0] policy
     /* 2071315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071325 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2071328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071351 */     // GIR_Coverage, 15881,
     /* 2071351 */     GIR_EraseRootFromParent_Done,
     /* 2071352 */   // Label 27505: @2071352
     /* 2071352 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2071443), // Rule ID 15884 //
     /* 2071357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2071360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2071368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2071371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2071374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2071377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071403 */     // MIs[0] round
     /* 2071403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071406 */     // MIs[0] policy
     /* 2071406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2071419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071442 */     // GIR_Coverage, 15884,
     /* 2071442 */     GIR_EraseRootFromParent_Done,
     /* 2071443 */   // Label 27506: @2071443
     /* 2071443 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2071534), // Rule ID 15885 //
     /* 2071448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2071451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2071459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2071462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2071465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2071468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071494 */     // MIs[0] round
     /* 2071494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071497 */     // MIs[0] policy
     /* 2071497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071507 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2071510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071533 */     // GIR_Coverage, 15885,
     /* 2071533 */     GIR_EraseRootFromParent_Done,
     /* 2071534 */   // Label 27507: @2071534
     /* 2071534 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2071625), // Rule ID 15888 //
     /* 2071539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2071542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2071550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2071553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2071556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2071559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071585 */     // MIs[0] round
     /* 2071585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071588 */     // MIs[0] policy
     /* 2071588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071598 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2071601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071624 */     // GIR_Coverage, 15888,
     /* 2071624 */     GIR_EraseRootFromParent_Done,
     /* 2071625 */   // Label 27508: @2071625
     /* 2071625 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2071716), // Rule ID 15889 //
     /* 2071630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2071633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2071641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2071644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2071647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2071650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071676 */     // MIs[0] round
     /* 2071676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071679 */     // MIs[0] policy
     /* 2071679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071689 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2071692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071715 */     // GIR_Coverage, 15889,
     /* 2071715 */     GIR_EraseRootFromParent_Done,
     /* 2071716 */   // Label 27509: @2071716
     /* 2071716 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2071807), // Rule ID 15892 //
     /* 2071721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2071732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2071735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2071738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071767 */     // MIs[0] round
     /* 2071767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071770 */     // MIs[0] policy
     /* 2071770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2071783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071806 */     // GIR_Coverage, 15892,
     /* 2071806 */     GIR_EraseRootFromParent_Done,
     /* 2071807 */   // Label 27510: @2071807
     /* 2071807 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2071898), // Rule ID 15893 //
     /* 2071812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2071823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2071826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2071829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071858 */     // MIs[0] round
     /* 2071858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071861 */     // MIs[0] policy
     /* 2071861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071871 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2071874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071897 */     // GIR_Coverage, 15893,
     /* 2071897 */     GIR_EraseRootFromParent_Done,
     /* 2071898 */   // Label 27511: @2071898
     /* 2071898 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2071989), // Rule ID 15896 //
     /* 2071903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2071914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2071917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2071920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071949 */     // MIs[0] round
     /* 2071949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071952 */     // MIs[0] policy
     /* 2071952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071962 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2071965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071988 */     // GIR_Coverage, 15896,
     /* 2071988 */     GIR_EraseRootFromParent_Done,
     /* 2071989 */   // Label 27512: @2071989
     /* 2071989 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2072080), // Rule ID 15897 //
     /* 2071994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2072005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2072008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2072011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072040 */     // MIs[0] round
     /* 2072040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072043 */     // MIs[0] policy
     /* 2072043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072053 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2072056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072079 */     // GIR_Coverage, 15897,
     /* 2072079 */     GIR_EraseRootFromParent_Done,
     /* 2072080 */   // Label 27513: @2072080
     /* 2072080 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2072171), // Rule ID 15900 //
     /* 2072085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2072096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2072099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2072102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072131 */     // MIs[0] round
     /* 2072131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072134 */     // MIs[0] policy
     /* 2072134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072170 */     // GIR_Coverage, 15900,
     /* 2072170 */     GIR_EraseRootFromParent_Done,
     /* 2072171 */   // Label 27514: @2072171
     /* 2072171 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2072262), // Rule ID 15901 //
     /* 2072176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2072187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2072190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2072193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072222 */     // MIs[0] round
     /* 2072222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072225 */     // MIs[0] policy
     /* 2072225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072235 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072261 */     // GIR_Coverage, 15901,
     /* 2072261 */     GIR_EraseRootFromParent_Done,
     /* 2072262 */   // Label 27515: @2072262
     /* 2072262 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2072353), // Rule ID 15904 //
     /* 2072267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2072278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2072281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2072284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072313 */     // MIs[0] round
     /* 2072313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072316 */     // MIs[0] policy
     /* 2072316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2072329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072352 */     // GIR_Coverage, 15904,
     /* 2072352 */     GIR_EraseRootFromParent_Done,
     /* 2072353 */   // Label 27516: @2072353
     /* 2072353 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2072444), // Rule ID 15905 //
     /* 2072358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2072369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2072372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2072375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072404 */     // MIs[0] round
     /* 2072404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072407 */     // MIs[0] policy
     /* 2072407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072417 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2072420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072443 */     // GIR_Coverage, 15905,
     /* 2072443 */     GIR_EraseRootFromParent_Done,
     /* 2072444 */   // Label 27517: @2072444
     /* 2072444 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2072535), // Rule ID 15908 //
     /* 2072449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2072460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2072463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2072466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072495 */     // MIs[0] round
     /* 2072495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072498 */     // MIs[0] policy
     /* 2072498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072534 */     // GIR_Coverage, 15908,
     /* 2072534 */     GIR_EraseRootFromParent_Done,
     /* 2072535 */   // Label 27518: @2072535
     /* 2072535 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2072626), // Rule ID 15909 //
     /* 2072540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2072551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2072554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2072557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072586 */     // MIs[0] round
     /* 2072586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072589 */     // MIs[0] policy
     /* 2072589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072599 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072625 */     // GIR_Coverage, 15909,
     /* 2072625 */     GIR_EraseRootFromParent_Done,
     /* 2072626 */   // Label 27519: @2072626
     /* 2072626 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2072717), // Rule ID 15912 //
     /* 2072631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2072642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2072645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2072648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072677 */     // MIs[0] round
     /* 2072677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072680 */     // MIs[0] policy
     /* 2072680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072716 */     // GIR_Coverage, 15912,
     /* 2072716 */     GIR_EraseRootFromParent_Done,
     /* 2072717 */   // Label 27520: @2072717
     /* 2072717 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2072808), // Rule ID 15913 //
     /* 2072722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2072733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2072736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2072739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072768 */     // MIs[0] round
     /* 2072768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072771 */     // MIs[0] policy
     /* 2072771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072781 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2072784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072807 */     // GIR_Coverage, 15913,
     /* 2072807 */     GIR_EraseRootFromParent_Done,
     /* 2072808 */   // Label 27521: @2072808
     /* 2072808 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2072899), // Rule ID 15916 //
     /* 2072813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2072824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2072827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2072830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072859 */     // MIs[0] round
     /* 2072859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072862 */     // MIs[0] policy
     /* 2072862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072872 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2072875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072898 */     // GIR_Coverage, 15916,
     /* 2072898 */     GIR_EraseRootFromParent_Done,
     /* 2072899 */   // Label 27522: @2072899
     /* 2072899 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2072990), // Rule ID 15917 //
     /* 2072904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2072912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2072915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2072918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2072921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072950 */     // MIs[0] round
     /* 2072950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072953 */     // MIs[0] policy
     /* 2072953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072963 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11541:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2072966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072989 */     // GIR_Coverage, 15917,
     /* 2072989 */     GIR_EraseRootFromParent_Done,
     /* 2072990 */   // Label 27523: @2072990
     /* 2072990 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2073081), // Rule ID 15920 //
     /* 2072995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2073006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2073009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2073012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073041 */     // MIs[0] round
     /* 2073041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073044 */     // MIs[0] policy
     /* 2073044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073054 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073080 */     // GIR_Coverage, 15920,
     /* 2073080 */     GIR_EraseRootFromParent_Done,
     /* 2073081 */   // Label 27524: @2073081
     /* 2073081 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2073172), // Rule ID 15921 //
     /* 2073086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2073097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2073100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2073103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073132 */     // MIs[0] round
     /* 2073132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073135 */     // MIs[0] policy
     /* 2073135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073171 */     // GIR_Coverage, 15921,
     /* 2073171 */     GIR_EraseRootFromParent_Done,
     /* 2073172 */   // Label 27525: @2073172
     /* 2073172 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2073263), // Rule ID 15924 //
     /* 2073177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2073188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2073191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2073194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073223 */     // MIs[0] round
     /* 2073223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073226 */     // MIs[0] policy
     /* 2073226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073262 */     // GIR_Coverage, 15924,
     /* 2073262 */     GIR_EraseRootFromParent_Done,
     /* 2073263 */   // Label 27526: @2073263
     /* 2073263 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2073354), // Rule ID 15925 //
     /* 2073268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2073279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2073282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2073285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073314 */     // MIs[0] round
     /* 2073314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073317 */     // MIs[0] policy
     /* 2073317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073353 */     // GIR_Coverage, 15925,
     /* 2073353 */     GIR_EraseRootFromParent_Done,
     /* 2073354 */   // Label 27527: @2073354
     /* 2073354 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2073445), // Rule ID 15928 //
     /* 2073359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2073362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073405 */     // MIs[0] round
     /* 2073405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073408 */     // MIs[0] policy
     /* 2073408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073444 */     // GIR_Coverage, 15928,
     /* 2073444 */     GIR_EraseRootFromParent_Done,
     /* 2073445 */   // Label 27528: @2073445
     /* 2073445 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2073536), // Rule ID 15929 //
     /* 2073450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2073453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073496 */     // MIs[0] round
     /* 2073496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073499 */     // MIs[0] policy
     /* 2073499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2073512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073535 */     // GIR_Coverage, 15929,
     /* 2073535 */     GIR_EraseRootFromParent_Done,
     /* 2073536 */   // Label 27529: @2073536
     /* 2073536 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2073627), // Rule ID 15932 //
     /* 2073541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2073552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2073555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2073558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073587 */     // MIs[0] round
     /* 2073587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073590 */     // MIs[0] policy
     /* 2073590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2073603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073626 */     // GIR_Coverage, 15932,
     /* 2073626 */     GIR_EraseRootFromParent_Done,
     /* 2073627 */   // Label 27530: @2073627
     /* 2073627 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2073718), // Rule ID 15933 //
     /* 2073632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2073643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2073646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2073649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073678 */     // MIs[0] round
     /* 2073678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073681 */     // MIs[0] policy
     /* 2073681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073691 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2073694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073717 */     // GIR_Coverage, 15933,
     /* 2073717 */     GIR_EraseRootFromParent_Done,
     /* 2073718 */   // Label 27531: @2073718
     /* 2073718 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2073809), // Rule ID 15936 //
     /* 2073723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2073734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2073737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2073740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2073746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073769 */     // MIs[0] round
     /* 2073769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073772 */     // MIs[0] policy
     /* 2073772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073782 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2073785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073808 */     // GIR_Coverage, 15936,
     /* 2073808 */     GIR_EraseRootFromParent_Done,
     /* 2073809 */   // Label 27532: @2073809
     /* 2073809 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2073900), // Rule ID 15937 //
     /* 2073814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2073825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2073828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2073831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2073837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073860 */     // MIs[0] round
     /* 2073860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073863 */     // MIs[0] policy
     /* 2073863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073873 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2073876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073899 */     // GIR_Coverage, 15937,
     /* 2073899 */     GIR_EraseRootFromParent_Done,
     /* 2073900 */   // Label 27533: @2073900
     /* 2073900 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2073991), // Rule ID 15940 //
     /* 2073905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2073913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2073916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2073919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2073922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2073928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073951 */     // MIs[0] round
     /* 2073951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073954 */     // MIs[0] policy
     /* 2073954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073964 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2073967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073990 */     // GIR_Coverage, 15940,
     /* 2073990 */     GIR_EraseRootFromParent_Done,
     /* 2073991 */   // Label 27534: @2073991
     /* 2073991 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2074082), // Rule ID 15941 //
     /* 2073996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2074007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2074010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2074013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2074019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074042 */     // MIs[0] round
     /* 2074042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074045 */     // MIs[0] policy
     /* 2074045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074055 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2074058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074081 */     // GIR_Coverage, 15941,
     /* 2074081 */     GIR_EraseRootFromParent_Done,
     /* 2074082 */   // Label 27535: @2074082
     /* 2074082 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2074173), // Rule ID 15944 //
     /* 2074087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2074098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2074101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2074104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074133 */     // MIs[0] round
     /* 2074133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074136 */     // MIs[0] policy
     /* 2074136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2074149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074172 */     // GIR_Coverage, 15944,
     /* 2074172 */     GIR_EraseRootFromParent_Done,
     /* 2074173 */   // Label 27536: @2074173
     /* 2074173 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2074264), // Rule ID 15945 //
     /* 2074178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2074189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2074192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2074195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074224 */     // MIs[0] round
     /* 2074224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074227 */     // MIs[0] policy
     /* 2074227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2074240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074263 */     // GIR_Coverage, 15945,
     /* 2074263 */     GIR_EraseRootFromParent_Done,
     /* 2074264 */   // Label 27537: @2074264
     /* 2074264 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2074355), // Rule ID 15948 //
     /* 2074269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2074280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2074283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2074286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074315 */     // MIs[0] round
     /* 2074315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074318 */     // MIs[0] policy
     /* 2074318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2074331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074354 */     // GIR_Coverage, 15948,
     /* 2074354 */     GIR_EraseRootFromParent_Done,
     /* 2074355 */   // Label 27538: @2074355
     /* 2074355 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2074446), // Rule ID 15949 //
     /* 2074360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2074371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2074374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2074377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074406 */     // MIs[0] round
     /* 2074406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074409 */     // MIs[0] policy
     /* 2074409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2074422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074445 */     // GIR_Coverage, 15949,
     /* 2074445 */     GIR_EraseRootFromParent_Done,
     /* 2074446 */   // Label 27539: @2074446
     /* 2074446 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2074537), // Rule ID 15952 //
     /* 2074451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074497 */     // MIs[0] round
     /* 2074497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074500 */     // MIs[0] policy
     /* 2074500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2074513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074536 */     // GIR_Coverage, 15952,
     /* 2074536 */     GIR_EraseRootFromParent_Done,
     /* 2074537 */   // Label 27540: @2074537
     /* 2074537 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2074628), // Rule ID 15953 //
     /* 2074542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074588 */     // MIs[0] round
     /* 2074588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074591 */     // MIs[0] policy
     /* 2074591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074601 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2074604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074627 */     // GIR_Coverage, 15953,
     /* 2074627 */     GIR_EraseRootFromParent_Done,
     /* 2074628 */   // Label 27541: @2074628
     /* 2074628 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2074719), // Rule ID 15956 //
     /* 2074633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074679 */     // MIs[0] round
     /* 2074679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074682 */     // MIs[0] policy
     /* 2074682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2074695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074718 */     // GIR_Coverage, 15956,
     /* 2074718 */     GIR_EraseRootFromParent_Done,
     /* 2074719 */   // Label 27542: @2074719
     /* 2074719 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2074810), // Rule ID 15957 //
     /* 2074724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074770 */     // MIs[0] round
     /* 2074770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074773 */     // MIs[0] policy
     /* 2074773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2074786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074809 */     // GIR_Coverage, 15957,
     /* 2074809 */     GIR_EraseRootFromParent_Done,
     /* 2074810 */   // Label 27543: @2074810
     /* 2074810 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2074901), // Rule ID 15960 //
     /* 2074815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074861 */     // MIs[0] round
     /* 2074861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074864 */     // MIs[0] policy
     /* 2074864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2074877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074900 */     // GIR_Coverage, 15960,
     /* 2074900 */     GIR_EraseRootFromParent_Done,
     /* 2074901 */   // Label 27544: @2074901
     /* 2074901 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2074992), // Rule ID 15961 //
     /* 2074906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074952 */     // MIs[0] round
     /* 2074952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074955 */     // MIs[0] policy
     /* 2074955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074965 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2074968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074991 */     // GIR_Coverage, 15961,
     /* 2074991 */     GIR_EraseRootFromParent_Done,
     /* 2074992 */   // Label 27545: @2074992
     /* 2074992 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2075083), // Rule ID 15964 //
     /* 2074997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2075008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2075011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2075014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2075020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075043 */     // MIs[0] round
     /* 2075043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075046 */     // MIs[0] policy
     /* 2075046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2075059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075082 */     // GIR_Coverage, 15964,
     /* 2075082 */     GIR_EraseRootFromParent_Done,
     /* 2075083 */   // Label 27546: @2075083
     /* 2075083 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2075174), // Rule ID 15965 //
     /* 2075088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2075099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2075102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2075105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2075111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075134 */     // MIs[0] round
     /* 2075134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075137 */     // MIs[0] policy
     /* 2075137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075147 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2075150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075173 */     // GIR_Coverage, 15965,
     /* 2075173 */     GIR_EraseRootFromParent_Done,
     /* 2075174 */   // Label 27547: @2075174
     /* 2075174 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2075265), // Rule ID 15968 //
     /* 2075179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2075182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2075190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2075193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2075196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075225 */     // MIs[0] round
     /* 2075225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075228 */     // MIs[0] policy
     /* 2075228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2075241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075264 */     // GIR_Coverage, 15968,
     /* 2075264 */     GIR_EraseRootFromParent_Done,
     /* 2075265 */   // Label 27548: @2075265
     /* 2075265 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2075356), // Rule ID 15969 //
     /* 2075270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2075273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2075281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2075284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2075287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2075300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2075308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075316 */     // MIs[0] round
     /* 2075316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075319 */     // MIs[0] policy
     /* 2075319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2075332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075355 */     // GIR_Coverage, 15969,
     /* 2075355 */     GIR_EraseRootFromParent_Done,
     /* 2075356 */   // Label 27549: @2075356
     /* 2075356 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2075447), // Rule ID 15972 //
     /* 2075361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2075364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075407 */     // MIs[0] round
     /* 2075407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075410 */     // MIs[0] policy
     /* 2075410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2075423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075446 */     // GIR_Coverage, 15972,
     /* 2075446 */     GIR_EraseRootFromParent_Done,
     /* 2075447 */   // Label 27550: @2075447
     /* 2075447 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2075538), // Rule ID 15973 //
     /* 2075452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2075455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075498 */     // MIs[0] round
     /* 2075498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075501 */     // MIs[0] policy
     /* 2075501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075511 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2075514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075537 */     // GIR_Coverage, 15973,
     /* 2075537 */     GIR_EraseRootFromParent_Done,
     /* 2075538 */   // Label 27551: @2075538
     /* 2075538 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2075629), // Rule ID 15976 //
     /* 2075543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2075546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075589 */     // MIs[0] round
     /* 2075589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075592 */     // MIs[0] policy
     /* 2075592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2075605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075628 */     // GIR_Coverage, 15976,
     /* 2075628 */     GIR_EraseRootFromParent_Done,
     /* 2075629 */   // Label 27552: @2075629
     /* 2075629 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2075720), // Rule ID 15977 //
     /* 2075634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2075637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075680 */     // MIs[0] round
     /* 2075680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075683 */     // MIs[0] policy
     /* 2075683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075693 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2075696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075719 */     // GIR_Coverage, 15977,
     /* 2075719 */     GIR_EraseRootFromParent_Done,
     /* 2075720 */   // Label 27553: @2075720
     /* 2075720 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2075811), // Rule ID 16068 //
     /* 2075725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075771 */     // MIs[0] round
     /* 2075771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075774 */     // MIs[0] policy
     /* 2075774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2075787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075810 */     // GIR_Coverage, 16068,
     /* 2075810 */     GIR_EraseRootFromParent_Done,
     /* 2075811 */   // Label 27554: @2075811
     /* 2075811 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2075902), // Rule ID 16069 //
     /* 2075816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2075836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075862 */     // MIs[0] round
     /* 2075862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075865 */     // MIs[0] policy
     /* 2075865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075875 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2075878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075901 */     // GIR_Coverage, 16069,
     /* 2075901 */     GIR_EraseRootFromParent_Done,
     /* 2075902 */   // Label 27555: @2075902
     /* 2075902 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2075993), // Rule ID 16072 //
     /* 2075907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2075927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075953 */     // MIs[0] round
     /* 2075953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075956 */     // MIs[0] policy
     /* 2075956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2075969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075992 */     // GIR_Coverage, 16072,
     /* 2075992 */     GIR_EraseRootFromParent_Done,
     /* 2075993 */   // Label 27556: @2075993
     /* 2075993 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2076084), // Rule ID 16073 //
     /* 2075998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2076009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2076012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2076015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2076018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076044 */     // MIs[0] round
     /* 2076044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076047 */     // MIs[0] policy
     /* 2076047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076057 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2076060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076083 */     // GIR_Coverage, 16073,
     /* 2076083 */     GIR_EraseRootFromParent_Done,
     /* 2076084 */   // Label 27557: @2076084
     /* 2076084 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2076175), // Rule ID 16076 //
     /* 2076089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2076100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2076103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2076106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2076109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076135 */     // MIs[0] round
     /* 2076135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076138 */     // MIs[0] policy
     /* 2076138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076148 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076174 */     // GIR_Coverage, 16076,
     /* 2076174 */     GIR_EraseRootFromParent_Done,
     /* 2076175 */   // Label 27558: @2076175
     /* 2076175 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2076266), // Rule ID 16077 //
     /* 2076180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2076191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2076194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2076197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2076200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076226 */     // MIs[0] round
     /* 2076226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076229 */     // MIs[0] policy
     /* 2076229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076265 */     // GIR_Coverage, 16077,
     /* 2076265 */     GIR_EraseRootFromParent_Done,
     /* 2076266 */   // Label 27559: @2076266
     /* 2076266 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2076357), // Rule ID 16080 //
     /* 2076271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2076282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2076285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2076288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2076291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076317 */     // MIs[0] round
     /* 2076317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076320 */     // MIs[0] policy
     /* 2076320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2076333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076356 */     // GIR_Coverage, 16080,
     /* 2076356 */     GIR_EraseRootFromParent_Done,
     /* 2076357 */   // Label 27560: @2076357
     /* 2076357 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2076448), // Rule ID 16081 //
     /* 2076362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2076373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2076376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2076379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2076382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076408 */     // MIs[0] round
     /* 2076408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076411 */     // MIs[0] policy
     /* 2076411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076421 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2076424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076447 */     // GIR_Coverage, 16081,
     /* 2076447 */     GIR_EraseRootFromParent_Done,
     /* 2076448 */   // Label 27561: @2076448
     /* 2076448 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2076539), // Rule ID 16084 //
     /* 2076453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2076464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2076467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2076470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2076473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076499 */     // MIs[0] round
     /* 2076499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076502 */     // MIs[0] policy
     /* 2076502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076538 */     // GIR_Coverage, 16084,
     /* 2076538 */     GIR_EraseRootFromParent_Done,
     /* 2076539 */   // Label 27562: @2076539
     /* 2076539 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2076630), // Rule ID 16085 //
     /* 2076544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2076555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2076558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2076561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2076564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076590 */     // MIs[0] round
     /* 2076590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076593 */     // MIs[0] policy
     /* 2076593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076603 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076629 */     // GIR_Coverage, 16085,
     /* 2076629 */     GIR_EraseRootFromParent_Done,
     /* 2076630 */   // Label 27563: @2076630
     /* 2076630 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2076721), // Rule ID 16088 //
     /* 2076635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2076655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076681 */     // MIs[0] round
     /* 2076681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076684 */     // MIs[0] policy
     /* 2076684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076720 */     // GIR_Coverage, 16088,
     /* 2076720 */     GIR_EraseRootFromParent_Done,
     /* 2076721 */   // Label 27564: @2076721
     /* 2076721 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2076812), // Rule ID 16089 //
     /* 2076726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2076746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076772 */     // MIs[0] round
     /* 2076772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076775 */     // MIs[0] policy
     /* 2076775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076785 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2076788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076811 */     // GIR_Coverage, 16089,
     /* 2076811 */     GIR_EraseRootFromParent_Done,
     /* 2076812 */   // Label 27565: @2076812
     /* 2076812 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2076903), // Rule ID 16092 //
     /* 2076817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076863 */     // MIs[0] round
     /* 2076863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076866 */     // MIs[0] policy
     /* 2076866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076876 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2076879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076902 */     // GIR_Coverage, 16092,
     /* 2076902 */     GIR_EraseRootFromParent_Done,
     /* 2076903 */   // Label 27566: @2076903
     /* 2076903 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2076994), // Rule ID 16093 //
     /* 2076908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2076928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076954 */     // MIs[0] round
     /* 2076954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076957 */     // MIs[0] policy
     /* 2076957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076967 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2076970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076993 */     // GIR_Coverage, 16093,
     /* 2076993 */     GIR_EraseRootFromParent_Done,
     /* 2076994 */   // Label 27567: @2076994
     /* 2076994 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2077085), // Rule ID 16096 //
     /* 2076999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2077010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2077013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2077016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2077019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077045 */     // MIs[0] round
     /* 2077045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077048 */     // MIs[0] policy
     /* 2077048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077084 */     // GIR_Coverage, 16096,
     /* 2077084 */     GIR_EraseRootFromParent_Done,
     /* 2077085 */   // Label 27568: @2077085
     /* 2077085 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2077176), // Rule ID 16097 //
     /* 2077090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2077101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2077104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2077107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2077110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077136 */     // MIs[0] round
     /* 2077136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077139 */     // MIs[0] policy
     /* 2077139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077175 */     // GIR_Coverage, 16097,
     /* 2077175 */     GIR_EraseRootFromParent_Done,
     /* 2077176 */   // Label 27569: @2077176
     /* 2077176 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2077267), // Rule ID 16100 //
     /* 2077181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2077192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2077195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2077198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2077201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077227 */     // MIs[0] round
     /* 2077227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077230 */     // MIs[0] policy
     /* 2077230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077266 */     // GIR_Coverage, 16100,
     /* 2077266 */     GIR_EraseRootFromParent_Done,
     /* 2077267 */   // Label 27570: @2077267
     /* 2077267 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2077358), // Rule ID 16101 //
     /* 2077272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2077283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2077286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2077289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2077292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2077295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077318 */     // MIs[0] round
     /* 2077318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077321 */     // MIs[0] policy
     /* 2077321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077331 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077357 */     // GIR_Coverage, 16101,
     /* 2077357 */     GIR_EraseRootFromParent_Done,
     /* 2077358 */   // Label 27571: @2077358
     /* 2077358 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2077449), // Rule ID 16104 //
     /* 2077363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2077366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2077383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077409 */     // MIs[0] round
     /* 2077409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077412 */     // MIs[0] policy
     /* 2077412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077448 */     // GIR_Coverage, 16104,
     /* 2077448 */     GIR_EraseRootFromParent_Done,
     /* 2077449 */   // Label 27572: @2077449
     /* 2077449 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2077540), // Rule ID 16105 //
     /* 2077454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2077457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2077474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077500 */     // MIs[0] round
     /* 2077500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077503 */     // MIs[0] policy
     /* 2077503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077513 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2077516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077539 */     // GIR_Coverage, 16105,
     /* 2077539 */     GIR_EraseRootFromParent_Done,
     /* 2077540 */   // Label 27573: @2077540
     /* 2077540 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2077631), // Rule ID 16108 //
     /* 2077545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2077556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2077559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2077562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2077565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077591 */     // MIs[0] round
     /* 2077591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077594 */     // MIs[0] policy
     /* 2077594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2077607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077630 */     // GIR_Coverage, 16108,
     /* 2077630 */     GIR_EraseRootFromParent_Done,
     /* 2077631 */   // Label 27574: @2077631
     /* 2077631 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2077722), // Rule ID 16109 //
     /* 2077636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2077647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2077650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2077653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2077656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077682 */     // MIs[0] round
     /* 2077682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077685 */     // MIs[0] policy
     /* 2077685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077695 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2077698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077721 */     // GIR_Coverage, 16109,
     /* 2077721 */     GIR_EraseRootFromParent_Done,
     /* 2077722 */   // Label 27575: @2077722
     /* 2077722 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2077813), // Rule ID 16112 //
     /* 2077727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077773 */     // MIs[0] round
     /* 2077773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077776 */     // MIs[0] policy
     /* 2077776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2077789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077812 */     // GIR_Coverage, 16112,
     /* 2077812 */     GIR_EraseRootFromParent_Done,
     /* 2077813 */   // Label 27576: @2077813
     /* 2077813 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2077904), // Rule ID 16113 //
     /* 2077818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2077838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077864 */     // MIs[0] round
     /* 2077864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077867 */     // MIs[0] policy
     /* 2077867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077877 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2077880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077903 */     // GIR_Coverage, 16113,
     /* 2077903 */     GIR_EraseRootFromParent_Done,
     /* 2077904 */   // Label 27577: @2077904
     /* 2077904 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2077995), // Rule ID 16116 //
     /* 2077909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2077929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077955 */     // MIs[0] round
     /* 2077955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077958 */     // MIs[0] policy
     /* 2077958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077968 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2077971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077994 */     // GIR_Coverage, 16116,
     /* 2077994 */     GIR_EraseRootFromParent_Done,
     /* 2077995 */   // Label 27578: @2077995
     /* 2077995 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2078086), // Rule ID 16117 //
     /* 2078000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2078011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2078014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2078017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2078020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2078023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078046 */     // MIs[0] round
     /* 2078046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078049 */     // MIs[0] policy
     /* 2078049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078059 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2078062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078085 */     // GIR_Coverage, 16117,
     /* 2078085 */     GIR_EraseRootFromParent_Done,
     /* 2078086 */   // Label 27579: @2078086
     /* 2078086 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2078177), // Rule ID 16120 //
     /* 2078091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2078102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2078105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2078108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2078111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078137 */     // MIs[0] round
     /* 2078137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078140 */     // MIs[0] policy
     /* 2078140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2078153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078176 */     // GIR_Coverage, 16120,
     /* 2078176 */     GIR_EraseRootFromParent_Done,
     /* 2078177 */   // Label 27580: @2078177
     /* 2078177 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2078268), // Rule ID 16121 //
     /* 2078182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2078193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2078196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2078199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2078202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078228 */     // MIs[0] round
     /* 2078228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078231 */     // MIs[0] policy
     /* 2078231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2078244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078267 */     // GIR_Coverage, 16121,
     /* 2078267 */     GIR_EraseRootFromParent_Done,
     /* 2078268 */   // Label 27581: @2078268
     /* 2078268 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2078359), // Rule ID 16124 //
     /* 2078273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2078284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2078287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2078290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2078293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078319 */     // MIs[0] round
     /* 2078319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078322 */     // MIs[0] policy
     /* 2078322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2078335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078358 */     // GIR_Coverage, 16124,
     /* 2078358 */     GIR_EraseRootFromParent_Done,
     /* 2078359 */   // Label 27582: @2078359
     /* 2078359 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2078450), // Rule ID 16125 //
     /* 2078364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2078375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2078378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2078381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2078384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078410 */     // MIs[0] round
     /* 2078410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078413 */     // MIs[0] policy
     /* 2078413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2078426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078449 */     // GIR_Coverage, 16125,
     /* 2078449 */     GIR_EraseRootFromParent_Done,
     /* 2078450 */   // Label 27583: @2078450
     /* 2078450 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2078541), // Rule ID 16128 //
     /* 2078455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2078466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2078469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2078472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2078475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2078478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078501 */     // MIs[0] round
     /* 2078501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078504 */     // MIs[0] policy
     /* 2078504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2078517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078540 */     // GIR_Coverage, 16128,
     /* 2078540 */     GIR_EraseRootFromParent_Done,
     /* 2078541 */   // Label 27584: @2078541
     /* 2078541 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2078632), // Rule ID 16129 //
     /* 2078546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2078557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2078560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2078563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2078566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2078569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078592 */     // MIs[0] round
     /* 2078592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078595 */     // MIs[0] policy
     /* 2078595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078605 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2078608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078631 */     // GIR_Coverage, 16129,
     /* 2078631 */     GIR_EraseRootFromParent_Done,
     /* 2078632 */   // Label 27585: @2078632
     /* 2078632 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2078723), // Rule ID 16132 //
     /* 2078637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2078657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078683 */     // MIs[0] round
     /* 2078683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078686 */     // MIs[0] policy
     /* 2078686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2078699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078722 */     // GIR_Coverage, 16132,
     /* 2078722 */     GIR_EraseRootFromParent_Done,
     /* 2078723 */   // Label 27586: @2078723
     /* 2078723 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2078814), // Rule ID 16133 //
     /* 2078728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2078748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078774 */     // MIs[0] round
     /* 2078774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078777 */     // MIs[0] policy
     /* 2078777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2078790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078813 */     // GIR_Coverage, 16133,
     /* 2078813 */     GIR_EraseRootFromParent_Done,
     /* 2078814 */   // Label 27587: @2078814
     /* 2078814 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2078905), // Rule ID 16136 //
     /* 2078819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078865 */     // MIs[0] round
     /* 2078865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078868 */     // MIs[0] policy
     /* 2078868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2078881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078904 */     // GIR_Coverage, 16136,
     /* 2078904 */     GIR_EraseRootFromParent_Done,
     /* 2078905 */   // Label 27588: @2078905
     /* 2078905 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2078996), // Rule ID 16137 //
     /* 2078910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2078930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078956 */     // MIs[0] round
     /* 2078956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078959 */     // MIs[0] policy
     /* 2078959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2078972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078995 */     // GIR_Coverage, 16137,
     /* 2078995 */     GIR_EraseRootFromParent_Done,
     /* 2078996 */   // Label 27589: @2078996
     /* 2078996 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2079087), // Rule ID 16140 //
     /* 2079001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2079012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2079015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2079018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2079021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2079024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079047 */     // MIs[0] round
     /* 2079047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079050 */     // MIs[0] policy
     /* 2079050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2079063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079086 */     // GIR_Coverage, 16140,
     /* 2079086 */     GIR_EraseRootFromParent_Done,
     /* 2079087 */   // Label 27590: @2079087
     /* 2079087 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2079178), // Rule ID 16141 //
     /* 2079092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2079103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2079106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2079109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2079112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2079115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079138 */     // MIs[0] round
     /* 2079138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079141 */     // MIs[0] policy
     /* 2079141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079151 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2079154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079177 */     // GIR_Coverage, 16141,
     /* 2079177 */     GIR_EraseRootFromParent_Done,
     /* 2079178 */   // Label 27591: @2079178
     /* 2079178 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2079269), // Rule ID 16144 //
     /* 2079183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2079186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2079194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2079197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2079200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2079203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2079213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079229 */     // MIs[0] round
     /* 2079229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079232 */     // MIs[0] policy
     /* 2079232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2079245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079268 */     // GIR_Coverage, 16144,
     /* 2079268 */     GIR_EraseRootFromParent_Done,
     /* 2079269 */   // Label 27592: @2079269
     /* 2079269 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2079360), // Rule ID 16145 //
     /* 2079274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2079277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2079285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2079288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2079291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2079294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2079304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079320 */     // MIs[0] round
     /* 2079320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079323 */     // MIs[0] policy
     /* 2079323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2079336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079359 */     // GIR_Coverage, 16145,
     /* 2079359 */     GIR_EraseRootFromParent_Done,
     /* 2079360 */   // Label 27593: @2079360
     /* 2079360 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2079451), // Rule ID 16148 //
     /* 2079365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2079368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2079376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2079379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2079382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2079385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079411 */     // MIs[0] round
     /* 2079411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079414 */     // MIs[0] policy
     /* 2079414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2079427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079450 */     // GIR_Coverage, 16148,
     /* 2079450 */     GIR_EraseRootFromParent_Done,
     /* 2079451 */   // Label 27594: @2079451
     /* 2079451 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2079542), // Rule ID 16149 //
     /* 2079456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2079459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2079467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2079470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2079473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2079476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079502 */     // MIs[0] round
     /* 2079502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079505 */     // MIs[0] policy
     /* 2079505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079515 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2079518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079541 */     // GIR_Coverage, 16149,
     /* 2079541 */     GIR_EraseRootFromParent_Done,
     /* 2079542 */   // Label 27595: @2079542
     /* 2079542 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2079633), // Rule ID 16152 //
     /* 2079547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2079550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2079558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2079561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2079564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2079567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079593 */     // MIs[0] round
     /* 2079593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079596 */     // MIs[0] policy
     /* 2079596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079606 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2079609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079632 */     // GIR_Coverage, 16152,
     /* 2079632 */     GIR_EraseRootFromParent_Done,
     /* 2079633 */   // Label 27596: @2079633
     /* 2079633 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2079724), // Rule ID 16153 //
     /* 2079638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2079641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2079649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2079652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2079655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2079658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079684 */     // MIs[0] round
     /* 2079684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079687 */     // MIs[0] policy
     /* 2079687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079697 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2079700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079723 */     // GIR_Coverage, 16153,
     /* 2079723 */     GIR_EraseRootFromParent_Done,
     /* 2079724 */   // Label 27597: @2079724
     /* 2079724 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2079815), // Rule ID 16156 //
     /* 2079729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079775 */     // MIs[0] round
     /* 2079775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079778 */     // MIs[0] policy
     /* 2079778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2079791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079814 */     // GIR_Coverage, 16156,
     /* 2079814 */     GIR_EraseRootFromParent_Done,
     /* 2079815 */   // Label 27598: @2079815
     /* 2079815 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2079906), // Rule ID 16157 //
     /* 2079820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2079837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079866 */     // MIs[0] round
     /* 2079866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079869 */     // MIs[0] policy
     /* 2079869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079879 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2079882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079905 */     // GIR_Coverage, 16157,
     /* 2079905 */     GIR_EraseRootFromParent_Done,
     /* 2079906 */   // Label 27599: @2079906
     /* 2079906 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2079997), // Rule ID 16160 //
     /* 2079911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2079928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079957 */     // MIs[0] round
     /* 2079957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079960 */     // MIs[0] policy
     /* 2079960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079970 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2079973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079996 */     // GIR_Coverage, 16160,
     /* 2079996 */     GIR_EraseRootFromParent_Done,
     /* 2079997 */   // Label 27600: @2079997
     /* 2079997 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2080088), // Rule ID 16161 //
     /* 2080002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2080013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2080016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2080019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080048 */     // MIs[0] round
     /* 2080048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080051 */     // MIs[0] policy
     /* 2080051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080061 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2080064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080087 */     // GIR_Coverage, 16161,
     /* 2080087 */     GIR_EraseRootFromParent_Done,
     /* 2080088 */   // Label 27601: @2080088
     /* 2080088 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2080179), // Rule ID 16164 //
     /* 2080093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2080104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2080107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2080110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080139 */     // MIs[0] round
     /* 2080139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080142 */     // MIs[0] policy
     /* 2080142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080178 */     // GIR_Coverage, 16164,
     /* 2080178 */     GIR_EraseRootFromParent_Done,
     /* 2080179 */   // Label 27602: @2080179
     /* 2080179 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2080270), // Rule ID 16165 //
     /* 2080184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2080195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2080198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2080201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080230 */     // MIs[0] round
     /* 2080230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080233 */     // MIs[0] policy
     /* 2080233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080243 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080269 */     // GIR_Coverage, 16165,
     /* 2080269 */     GIR_EraseRootFromParent_Done,
     /* 2080270 */   // Label 27603: @2080270
     /* 2080270 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2080361), // Rule ID 16168 //
     /* 2080275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2080286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2080289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2080292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080321 */     // MIs[0] round
     /* 2080321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080324 */     // MIs[0] policy
     /* 2080324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2080337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080360 */     // GIR_Coverage, 16168,
     /* 2080360 */     GIR_EraseRootFromParent_Done,
     /* 2080361 */   // Label 27604: @2080361
     /* 2080361 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2080452), // Rule ID 16169 //
     /* 2080366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2080377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2080380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2080383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080412 */     // MIs[0] round
     /* 2080412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080415 */     // MIs[0] policy
     /* 2080415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080425 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2080428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080451 */     // GIR_Coverage, 16169,
     /* 2080451 */     GIR_EraseRootFromParent_Done,
     /* 2080452 */   // Label 27605: @2080452
     /* 2080452 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2080543), // Rule ID 16172 //
     /* 2080457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2080468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2080471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2080474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080503 */     // MIs[0] round
     /* 2080503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080506 */     // MIs[0] policy
     /* 2080506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080516 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080542 */     // GIR_Coverage, 16172,
     /* 2080542 */     GIR_EraseRootFromParent_Done,
     /* 2080543 */   // Label 27606: @2080543
     /* 2080543 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2080634), // Rule ID 16173 //
     /* 2080548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2080559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2080562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2080565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080594 */     // MIs[0] round
     /* 2080594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080597 */     // MIs[0] policy
     /* 2080597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080607 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080633 */     // GIR_Coverage, 16173,
     /* 2080633 */     GIR_EraseRootFromParent_Done,
     /* 2080634 */   // Label 27607: @2080634
     /* 2080634 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2080725), // Rule ID 16176 //
     /* 2080639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2080650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2080653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080685 */     // MIs[0] round
     /* 2080685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080688 */     // MIs[0] policy
     /* 2080688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080724 */     // GIR_Coverage, 16176,
     /* 2080724 */     GIR_EraseRootFromParent_Done,
     /* 2080725 */   // Label 27608: @2080725
     /* 2080725 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2080816), // Rule ID 16177 //
     /* 2080730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2080741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2080744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080776 */     // MIs[0] round
     /* 2080776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080779 */     // MIs[0] policy
     /* 2080779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2080792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080815 */     // GIR_Coverage, 16177,
     /* 2080815 */     GIR_EraseRootFromParent_Done,
     /* 2080816 */   // Label 27609: @2080816
     /* 2080816 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2080907), // Rule ID 16180 //
     /* 2080821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080867 */     // MIs[0] round
     /* 2080867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080870 */     // MIs[0] policy
     /* 2080870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2080883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080906 */     // GIR_Coverage, 16180,
     /* 2080906 */     GIR_EraseRootFromParent_Done,
     /* 2080907 */   // Label 27610: @2080907
     /* 2080907 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2080998), // Rule ID 16181 //
     /* 2080912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2080920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2080929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080958 */     // MIs[0] round
     /* 2080958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080961 */     // MIs[0] policy
     /* 2080961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080971 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11539:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2080974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080997 */     // GIR_Coverage, 16181,
     /* 2080997 */     GIR_EraseRootFromParent_Done,
     /* 2080998 */   // Label 27611: @2080998
     /* 2080998 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2081089), // Rule ID 16184 //
     /* 2081003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2081014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2081017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2081020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081049 */     // MIs[0] round
     /* 2081049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081052 */     // MIs[0] policy
     /* 2081052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081088 */     // GIR_Coverage, 16184,
     /* 2081088 */     GIR_EraseRootFromParent_Done,
     /* 2081089 */   // Label 27612: @2081089
     /* 2081089 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2081180), // Rule ID 16185 //
     /* 2081094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2081105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2081108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2081111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081140 */     // MIs[0] round
     /* 2081140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081143 */     // MIs[0] policy
     /* 2081143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081153 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11539:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081179 */     // GIR_Coverage, 16185,
     /* 2081179 */     GIR_EraseRootFromParent_Done,
     /* 2081180 */   // Label 27613: @2081180
     /* 2081180 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2081271), // Rule ID 16188 //
     /* 2081185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2081202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081231 */     // MIs[0] round
     /* 2081231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081234 */     // MIs[0] policy
     /* 2081234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081270 */     // GIR_Coverage, 16188,
     /* 2081270 */     GIR_EraseRootFromParent_Done,
     /* 2081271 */   // Label 27614: @2081271
     /* 2081271 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2081362), // Rule ID 16189 //
     /* 2081276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2081293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081322 */     // MIs[0] round
     /* 2081322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081325 */     // MIs[0] policy
     /* 2081325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081335 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11539:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081361 */     // GIR_Coverage, 16189,
     /* 2081361 */     GIR_EraseRootFromParent_Done,
     /* 2081362 */   // Label 27615: @2081362
     /* 2081362 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2081453), // Rule ID 16192 //
     /* 2081367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2081370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2081378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2081381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2081384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081413 */     // MIs[0] round
     /* 2081413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081416 */     // MIs[0] policy
     /* 2081416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2081449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081452 */     // GIR_Coverage, 16192,
     /* 2081452 */     GIR_EraseRootFromParent_Done,
     /* 2081453 */   // Label 27616: @2081453
     /* 2081453 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2081544), // Rule ID 16193 //
     /* 2081458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2081461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2081469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2081472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2081475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081504 */     // MIs[0] round
     /* 2081504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081507 */     // MIs[0] policy
     /* 2081507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11539:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2081520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2081540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081543 */     // GIR_Coverage, 16193,
     /* 2081543 */     GIR_EraseRootFromParent_Done,
     /* 2081544 */   // Label 27617: @2081544
     /* 2081544 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2081635), // Rule ID 16196 //
     /* 2081549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2081560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2081563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2081566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081595 */     // MIs[0] round
     /* 2081595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081598 */     // MIs[0] policy
     /* 2081598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2081611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081634 */     // GIR_Coverage, 16196,
     /* 2081634 */     GIR_EraseRootFromParent_Done,
     /* 2081635 */   // Label 27618: @2081635
     /* 2081635 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2081726), // Rule ID 16197 //
     /* 2081640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2081651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2081654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2081657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081686 */     // MIs[0] round
     /* 2081686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081689 */     // MIs[0] policy
     /* 2081689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2081702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081725 */     // GIR_Coverage, 16197,
     /* 2081725 */     GIR_EraseRootFromParent_Done,
     /* 2081726 */   // Label 27619: @2081726
     /* 2081726 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2081817), // Rule ID 16200 //
     /* 2081731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081777 */     // MIs[0] round
     /* 2081777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081780 */     // MIs[0] policy
     /* 2081780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2081793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081816 */     // GIR_Coverage, 16200,
     /* 2081816 */     GIR_EraseRootFromParent_Done,
     /* 2081817 */   // Label 27620: @2081817
     /* 2081817 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2081908), // Rule ID 16201 //
     /* 2081822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2081833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2081836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2081839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081868 */     // MIs[0] round
     /* 2081868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081871 */     // MIs[0] policy
     /* 2081871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081881 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2081884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081907 */     // GIR_Coverage, 16201,
     /* 2081907 */     GIR_EraseRootFromParent_Done,
     /* 2081908 */   // Label 27621: @2081908
     /* 2081908 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2081999), // Rule ID 16204 //
     /* 2081913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2081921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2081924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2081927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2081930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2081936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081959 */     // MIs[0] round
     /* 2081959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081962 */     // MIs[0] policy
     /* 2081962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081972 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2081975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2081995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081998 */     // GIR_Coverage, 16204,
     /* 2081998 */     GIR_EraseRootFromParent_Done,
     /* 2081999 */   // Label 27622: @2081999
     /* 2081999 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2082090), // Rule ID 16205 //
     /* 2082004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2082015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2082018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2082021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2082027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082050 */     // MIs[0] round
     /* 2082050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082053 */     // MIs[0] policy
     /* 2082053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082063 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2082066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082089 */     // GIR_Coverage, 16205,
     /* 2082089 */     GIR_EraseRootFromParent_Done,
     /* 2082090 */   // Label 27623: @2082090
     /* 2082090 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2082181), // Rule ID 16208 //
     /* 2082095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2082106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2082109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2082112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082141 */     // MIs[0] round
     /* 2082141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082144 */     // MIs[0] policy
     /* 2082144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2082157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082180 */     // GIR_Coverage, 16208,
     /* 2082180 */     GIR_EraseRootFromParent_Done,
     /* 2082181 */   // Label 27624: @2082181
     /* 2082181 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2082272), // Rule ID 16209 //
     /* 2082186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2082197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2082200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2082203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082232 */     // MIs[0] round
     /* 2082232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082235 */     // MIs[0] policy
     /* 2082235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2082248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082271 */     // GIR_Coverage, 16209,
     /* 2082271 */     GIR_EraseRootFromParent_Done,
     /* 2082272 */   // Label 27625: @2082272
     /* 2082272 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2082363), // Rule ID 16212 //
     /* 2082277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2082288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2082291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2082294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082323 */     // MIs[0] round
     /* 2082323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082326 */     // MIs[0] policy
     /* 2082326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2082339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082362 */     // GIR_Coverage, 16212,
     /* 2082362 */     GIR_EraseRootFromParent_Done,
     /* 2082363 */   // Label 27626: @2082363
     /* 2082363 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2082454), // Rule ID 16213 //
     /* 2082368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2082379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2082382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2082385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082414 */     // MIs[0] round
     /* 2082414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082417 */     // MIs[0] policy
     /* 2082417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2082430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082453 */     // GIR_Coverage, 16213,
     /* 2082453 */     GIR_EraseRootFromParent_Done,
     /* 2082454 */   // Label 27627: @2082454
     /* 2082454 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2082545), // Rule ID 16216 //
     /* 2082459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2082470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2082473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2082476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2082482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082505 */     // MIs[0] round
     /* 2082505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082508 */     // MIs[0] policy
     /* 2082508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2082521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082544 */     // GIR_Coverage, 16216,
     /* 2082544 */     GIR_EraseRootFromParent_Done,
     /* 2082545 */   // Label 27628: @2082545
     /* 2082545 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2082636), // Rule ID 16217 //
     /* 2082550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2082561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2082564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2082567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2082573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082596 */     // MIs[0] round
     /* 2082596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082599 */     // MIs[0] policy
     /* 2082599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2082612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2082632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082635 */     // GIR_Coverage, 16217,
     /* 2082635 */     GIR_EraseRootFromParent_Done,
     /* 2082636 */   // Label 27629: @2082636
     /* 2082636 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2082727), // Rule ID 16220 //
     /* 2082641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2082658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082687 */     // MIs[0] round
     /* 2082687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082690 */     // MIs[0] policy
     /* 2082690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2082703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082726 */     // GIR_Coverage, 16220,
     /* 2082726 */     GIR_EraseRootFromParent_Done,
     /* 2082727 */   // Label 27630: @2082727
     /* 2082727 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2082818), // Rule ID 16221 //
     /* 2082732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2082743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2082746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2082749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082778 */     // MIs[0] round
     /* 2082778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082781 */     // MIs[0] policy
     /* 2082781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2082794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082817 */     // GIR_Coverage, 16221,
     /* 2082817 */     GIR_EraseRootFromParent_Done,
     /* 2082818 */   // Label 27631: @2082818
     /* 2082818 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2082909), // Rule ID 16224 //
     /* 2082823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082869 */     // MIs[0] round
     /* 2082869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082872 */     // MIs[0] policy
     /* 2082872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2082885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082908 */     // GIR_Coverage, 16224,
     /* 2082908 */     GIR_EraseRootFromParent_Done,
     /* 2082909 */   // Label 27632: @2082909
     /* 2082909 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2083000), // Rule ID 16225 //
     /* 2082914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2082931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082960 */     // MIs[0] round
     /* 2082960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082963 */     // MIs[0] policy
     /* 2082963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082973 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2082976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082999 */     // GIR_Coverage, 16225,
     /* 2082999 */     GIR_EraseRootFromParent_Done,
     /* 2083000 */   // Label 27633: @2083000
     /* 2083000 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2083091), // Rule ID 16228 //
     /* 2083005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2083016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2083019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2083022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2083028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083051 */     // MIs[0] round
     /* 2083051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083054 */     // MIs[0] policy
     /* 2083054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2083067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083090 */     // GIR_Coverage, 16228,
     /* 2083090 */     GIR_EraseRootFromParent_Done,
     /* 2083091 */   // Label 27634: @2083091
     /* 2083091 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2083182), // Rule ID 16229 //
     /* 2083096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2083107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2083110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2083113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2083119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083142 */     // MIs[0] round
     /* 2083142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083145 */     // MIs[0] policy
     /* 2083145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083155 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2083158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083181 */     // GIR_Coverage, 16229,
     /* 2083181 */     GIR_EraseRootFromParent_Done,
     /* 2083182 */   // Label 27635: @2083182
     /* 2083182 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2083273), // Rule ID 16232 //
     /* 2083187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2083190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2083198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2083201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2083204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083233 */     // MIs[0] round
     /* 2083233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083236 */     // MIs[0] policy
     /* 2083236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2083249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083272 */     // GIR_Coverage, 16232,
     /* 2083272 */     GIR_EraseRootFromParent_Done,
     /* 2083273 */   // Label 27636: @2083273
     /* 2083273 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2083364), // Rule ID 16233 //
     /* 2083278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2083281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2083289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2083292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2083295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083324 */     // MIs[0] round
     /* 2083324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083327 */     // MIs[0] policy
     /* 2083327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083337 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11539:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2083340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083363 */     // GIR_Coverage, 16233,
     /* 2083363 */     GIR_EraseRootFromParent_Done,
     /* 2083364 */   // Label 27637: @2083364
     /* 2083364 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2083455), // Rule ID 16236 //
     /* 2083369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2083372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2083380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2083383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2083386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083415 */     // MIs[0] round
     /* 2083415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083418 */     // MIs[0] policy
     /* 2083418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083428 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2083431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083454 */     // GIR_Coverage, 16236,
     /* 2083454 */     GIR_EraseRootFromParent_Done,
     /* 2083455 */   // Label 27638: @2083455
     /* 2083455 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2083546), // Rule ID 16237 //
     /* 2083460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2083463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2083471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2083474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2083477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083506 */     // MIs[0] round
     /* 2083506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083509 */     // MIs[0] policy
     /* 2083509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11539:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2083522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083545 */     // GIR_Coverage, 16237,
     /* 2083545 */     GIR_EraseRootFromParent_Done,
     /* 2083546 */   // Label 27639: @2083546
     /* 2083546 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2083637), // Rule ID 16240 //
     /* 2083551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2083554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2083562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2083565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2083568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083597 */     // MIs[0] round
     /* 2083597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083600 */     // MIs[0] policy
     /* 2083600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2083613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083636 */     // GIR_Coverage, 16240,
     /* 2083636 */     GIR_EraseRootFromParent_Done,
     /* 2083637 */   // Label 27640: @2083637
     /* 2083637 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2083728), // Rule ID 16241 //
     /* 2083642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2083645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2083653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2083656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2083659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2083672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083688 */     // MIs[0] round
     /* 2083688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083691 */     // MIs[0] policy
     /* 2083691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083701 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11539:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2083704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2083724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083727 */     // GIR_Coverage, 16241,
     /* 2083727 */     GIR_EraseRootFromParent_Done,
     /* 2083728 */   // Label 27641: @2083728
     /* 2083728 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2083822), // Rule ID 16332 //
     /* 2083733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083779 */     // MIs[0] round
     /* 2083779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083782 */     // MIs[0] policy
     /* 2083782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2083795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083821 */     // GIR_Coverage, 16332,
     /* 2083821 */     GIR_EraseRootFromParent_Done,
     /* 2083822 */   // Label 27642: @2083822
     /* 2083822 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2083916), // Rule ID 16333 //
     /* 2083827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2083838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2083841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2083847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083873 */     // MIs[0] round
     /* 2083873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083876 */     // MIs[0] policy
     /* 2083876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083886 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2083889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083915 */     // GIR_Coverage, 16333,
     /* 2083915 */     GIR_EraseRootFromParent_Done,
     /* 2083916 */   // Label 27643: @2083916
     /* 2083916 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2084010), // Rule ID 16336 //
     /* 2083921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2083932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2083935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2083941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083967 */     // MIs[0] round
     /* 2083967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083970 */     // MIs[0] policy
     /* 2083970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2083983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084009 */     // GIR_Coverage, 16336,
     /* 2084009 */     GIR_EraseRootFromParent_Done,
     /* 2084010 */   // Label 27644: @2084010
     /* 2084010 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2084104), // Rule ID 16337 //
     /* 2084015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2084026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2084029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2084032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2084035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084061 */     // MIs[0] round
     /* 2084061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084064 */     // MIs[0] policy
     /* 2084064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084074 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2084077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084103 */     // GIR_Coverage, 16337,
     /* 2084103 */     GIR_EraseRootFromParent_Done,
     /* 2084104 */   // Label 27645: @2084104
     /* 2084104 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2084198), // Rule ID 16340 //
     /* 2084109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2084120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2084123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2084129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084155 */     // MIs[0] round
     /* 2084155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084158 */     // MIs[0] policy
     /* 2084158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084168 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2084171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084197 */     // GIR_Coverage, 16340,
     /* 2084197 */     GIR_EraseRootFromParent_Done,
     /* 2084198 */   // Label 27646: @2084198
     /* 2084198 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2084292), // Rule ID 16341 //
     /* 2084203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2084214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2084217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2084220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2084223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084249 */     // MIs[0] round
     /* 2084249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084252 */     // MIs[0] policy
     /* 2084252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084262 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2084265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084291 */     // GIR_Coverage, 16341,
     /* 2084291 */     GIR_EraseRootFromParent_Done,
     /* 2084292 */   // Label 27647: @2084292
     /* 2084292 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2084386), // Rule ID 16344 //
     /* 2084297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084343 */     // MIs[0] round
     /* 2084343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084346 */     // MIs[0] policy
     /* 2084346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2084359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084385 */     // GIR_Coverage, 16344,
     /* 2084385 */     GIR_EraseRootFromParent_Done,
     /* 2084386 */   // Label 27648: @2084386
     /* 2084386 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2084480), // Rule ID 16345 //
     /* 2084391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2084402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2084405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2084411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084437 */     // MIs[0] round
     /* 2084437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084440 */     // MIs[0] policy
     /* 2084440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2084453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084479 */     // GIR_Coverage, 16345,
     /* 2084479 */     GIR_EraseRootFromParent_Done,
     /* 2084480 */   // Label 27649: @2084480
     /* 2084480 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2084574), // Rule ID 16348 //
     /* 2084485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2084502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084531 */     // MIs[0] round
     /* 2084531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084534 */     // MIs[0] policy
     /* 2084534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2084547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084573 */     // GIR_Coverage, 16348,
     /* 2084573 */     GIR_EraseRootFromParent_Done,
     /* 2084574 */   // Label 27650: @2084574
     /* 2084574 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2084668), // Rule ID 16349 //
     /* 2084579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2084596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084625 */     // MIs[0] round
     /* 2084625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084628 */     // MIs[0] policy
     /* 2084628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2084641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084667 */     // GIR_Coverage, 16349,
     /* 2084667 */     GIR_EraseRootFromParent_Done,
     /* 2084668 */   // Label 27651: @2084668
     /* 2084668 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2084762), // Rule ID 16352 //
     /* 2084673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2084690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084719 */     // MIs[0] round
     /* 2084719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084722 */     // MIs[0] policy
     /* 2084722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084732 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2084735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084761 */     // GIR_Coverage, 16352,
     /* 2084761 */     GIR_EraseRootFromParent_Done,
     /* 2084762 */   // Label 27652: @2084762
     /* 2084762 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2084856), // Rule ID 16353 //
     /* 2084767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2084784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084813 */     // MIs[0] round
     /* 2084813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084816 */     // MIs[0] policy
     /* 2084816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084826 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2084829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084855 */     // GIR_Coverage, 16353,
     /* 2084855 */     GIR_EraseRootFromParent_Done,
     /* 2084856 */   // Label 27653: @2084856
     /* 2084856 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2084950), // Rule ID 16356 //
     /* 2084861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2084872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2084875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2084881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084907 */     // MIs[0] round
     /* 2084907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084910 */     // MIs[0] policy
     /* 2084910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2084923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084949 */     // GIR_Coverage, 16356,
     /* 2084949 */     GIR_EraseRootFromParent_Done,
     /* 2084950 */   // Label 27654: @2084950
     /* 2084950 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2085044), // Rule ID 16357 //
     /* 2084955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2084966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2084969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2084972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2084975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085001 */     // MIs[0] round
     /* 2085001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085004 */     // MIs[0] policy
     /* 2085004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085014 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2085017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085043 */     // GIR_Coverage, 16357,
     /* 2085043 */     GIR_EraseRootFromParent_Done,
     /* 2085044 */   // Label 27655: @2085044
     /* 2085044 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2085138), // Rule ID 16360 //
     /* 2085049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2085060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2085063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2085066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2085069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085095 */     // MIs[0] round
     /* 2085095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085098 */     // MIs[0] policy
     /* 2085098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2085111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085137 */     // GIR_Coverage, 16360,
     /* 2085137 */     GIR_EraseRootFromParent_Done,
     /* 2085138 */   // Label 27656: @2085138
     /* 2085138 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2085232), // Rule ID 16361 //
     /* 2085143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2085154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2085157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2085160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2085163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085189 */     // MIs[0] round
     /* 2085189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085192 */     // MIs[0] policy
     /* 2085192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2085205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085231 */     // GIR_Coverage, 16361,
     /* 2085231 */     GIR_EraseRootFromParent_Done,
     /* 2085232 */   // Label 27657: @2085232
     /* 2085232 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2085326), // Rule ID 16364 //
     /* 2085237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2085248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2085251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2085257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085283 */     // MIs[0] round
     /* 2085283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085286 */     // MIs[0] policy
     /* 2085286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2085299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085325 */     // GIR_Coverage, 16364,
     /* 2085325 */     GIR_EraseRootFromParent_Done,
     /* 2085326 */   // Label 27658: @2085326
     /* 2085326 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2085420), // Rule ID 16365 //
     /* 2085331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2085342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2085345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2085351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085377 */     // MIs[0] round
     /* 2085377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085380 */     // MIs[0] policy
     /* 2085380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2085393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085419 */     // GIR_Coverage, 16365,
     /* 2085419 */     GIR_EraseRootFromParent_Done,
     /* 2085420 */   // Label 27659: @2085420
     /* 2085420 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2085514), // Rule ID 16368 //
     /* 2085425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085471 */     // MIs[0] round
     /* 2085471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085474 */     // MIs[0] policy
     /* 2085474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2085487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085513 */     // GIR_Coverage, 16368,
     /* 2085513 */     GIR_EraseRootFromParent_Done,
     /* 2085514 */   // Label 27660: @2085514
     /* 2085514 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2085608), // Rule ID 16369 //
     /* 2085519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085565 */     // MIs[0] round
     /* 2085565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085568 */     // MIs[0] policy
     /* 2085568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2085581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085607 */     // GIR_Coverage, 16369,
     /* 2085607 */     GIR_EraseRootFromParent_Done,
     /* 2085608 */   // Label 27661: @2085608
     /* 2085608 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2085702), // Rule ID 16372 //
     /* 2085613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085659 */     // MIs[0] round
     /* 2085659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085662 */     // MIs[0] policy
     /* 2085662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2085675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085701 */     // GIR_Coverage, 16372,
     /* 2085701 */     GIR_EraseRootFromParent_Done,
     /* 2085702 */   // Label 27662: @2085702
     /* 2085702 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2085796), // Rule ID 16373 //
     /* 2085707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085753 */     // MIs[0] round
     /* 2085753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085756 */     // MIs[0] policy
     /* 2085756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2085769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085795 */     // GIR_Coverage, 16373,
     /* 2085795 */     GIR_EraseRootFromParent_Done,
     /* 2085796 */   // Label 27663: @2085796
     /* 2085796 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2085890), // Rule ID 16376 //
     /* 2085801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2085804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2085812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2085815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2085818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2085821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085847 */     // MIs[0] round
     /* 2085847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085850 */     // MIs[0] policy
     /* 2085850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2085863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085889 */     // GIR_Coverage, 16376,
     /* 2085889 */     GIR_EraseRootFromParent_Done,
     /* 2085890 */   // Label 27664: @2085890
     /* 2085890 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2085984), // Rule ID 16377 //
     /* 2085895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2085898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2085906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2085909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2085912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2085915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085941 */     // MIs[0] round
     /* 2085941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085944 */     // MIs[0] policy
     /* 2085944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085954 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2085957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085983 */     // GIR_Coverage, 16377,
     /* 2085983 */     GIR_EraseRootFromParent_Done,
     /* 2085984 */   // Label 27665: @2085984
     /* 2085984 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2086078), // Rule ID 16380 //
     /* 2085989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2085992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2085997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2086000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2086003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2086009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086035 */     // MIs[0] round
     /* 2086035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086038 */     // MIs[0] policy
     /* 2086038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2086051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086077 */     // GIR_Coverage, 16380,
     /* 2086077 */     GIR_EraseRootFromParent_Done,
     /* 2086078 */   // Label 27666: @2086078
     /* 2086078 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2086172), // Rule ID 16381 //
     /* 2086083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2086086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2086094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2086097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2086103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086129 */     // MIs[0] round
     /* 2086129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086132 */     // MIs[0] policy
     /* 2086132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2086145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086171 */     // GIR_Coverage, 16381,
     /* 2086171 */     GIR_EraseRootFromParent_Done,
     /* 2086172 */   // Label 27667: @2086172
     /* 2086172 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2086266), // Rule ID 16384 //
     /* 2086177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2086180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2086188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2086191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086223 */     // MIs[0] round
     /* 2086223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086226 */     // MIs[0] policy
     /* 2086226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2086239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086265 */     // GIR_Coverage, 16384,
     /* 2086265 */     GIR_EraseRootFromParent_Done,
     /* 2086266 */   // Label 27668: @2086266
     /* 2086266 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2086360), // Rule ID 16385 //
     /* 2086271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2086274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2086282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2086285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2086291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086317 */     // MIs[0] round
     /* 2086317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086320 */     // MIs[0] policy
     /* 2086320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2086333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086359 */     // GIR_Coverage, 16385,
     /* 2086359 */     GIR_EraseRootFromParent_Done,
     /* 2086360 */   // Label 27669: @2086360
     /* 2086360 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2086454), // Rule ID 16388 //
     /* 2086365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2086368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086411 */     // MIs[0] round
     /* 2086411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086414 */     // MIs[0] policy
     /* 2086414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2086427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086453 */     // GIR_Coverage, 16388,
     /* 2086453 */     GIR_EraseRootFromParent_Done,
     /* 2086454 */   // Label 27670: @2086454
     /* 2086454 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2086548), // Rule ID 16389 //
     /* 2086459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2086462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2086470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2086473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2086479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086505 */     // MIs[0] round
     /* 2086505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086508 */     // MIs[0] policy
     /* 2086508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2086521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086547 */     // GIR_Coverage, 16389,
     /* 2086547 */     GIR_EraseRootFromParent_Done,
     /* 2086548 */   // Label 27671: @2086548
     /* 2086548 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2086642), // Rule ID 16392 //
     /* 2086553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2086570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086599 */     // MIs[0] round
     /* 2086599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086602 */     // MIs[0] policy
     /* 2086602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086612 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2086615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086641 */     // GIR_Coverage, 16392,
     /* 2086641 */     GIR_EraseRootFromParent_Done,
     /* 2086642 */   // Label 27672: @2086642
     /* 2086642 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2086736), // Rule ID 16393 //
     /* 2086647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2086664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086693 */     // MIs[0] round
     /* 2086693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086696 */     // MIs[0] policy
     /* 2086696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2086709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086735 */     // GIR_Coverage, 16393,
     /* 2086735 */     GIR_EraseRootFromParent_Done,
     /* 2086736 */   // Label 27673: @2086736
     /* 2086736 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2086830), // Rule ID 16396 //
     /* 2086741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2086758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086787 */     // MIs[0] round
     /* 2086787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086790 */     // MIs[0] policy
     /* 2086790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2086803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086829 */     // GIR_Coverage, 16396,
     /* 2086829 */     GIR_EraseRootFromParent_Done,
     /* 2086830 */   // Label 27674: @2086830
     /* 2086830 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2086924), // Rule ID 16397 //
     /* 2086835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2086852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086881 */     // MIs[0] round
     /* 2086881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086884 */     // MIs[0] policy
     /* 2086884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2086897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086923 */     // GIR_Coverage, 16397,
     /* 2086923 */     GIR_EraseRootFromParent_Done,
     /* 2086924 */   // Label 27675: @2086924
     /* 2086924 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2087018), // Rule ID 16400 //
     /* 2086929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2086937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2086940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2086943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2086946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086975 */     // MIs[0] round
     /* 2086975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086978 */     // MIs[0] policy
     /* 2086978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2086991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087017 */     // GIR_Coverage, 16400,
     /* 2087017 */     GIR_EraseRootFromParent_Done,
     /* 2087018 */   // Label 27676: @2087018
     /* 2087018 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2087112), // Rule ID 16401 //
     /* 2087023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087069 */     // MIs[0] round
     /* 2087069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087072 */     // MIs[0] policy
     /* 2087072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087082 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2087085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087111 */     // GIR_Coverage, 16401,
     /* 2087111 */     GIR_EraseRootFromParent_Done,
     /* 2087112 */   // Label 27677: @2087112
     /* 2087112 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2087206), // Rule ID 16404 //
     /* 2087117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2087134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087163 */     // MIs[0] round
     /* 2087163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087166 */     // MIs[0] policy
     /* 2087166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087176 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2087179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087205 */     // GIR_Coverage, 16404,
     /* 2087205 */     GIR_EraseRootFromParent_Done,
     /* 2087206 */   // Label 27678: @2087206
     /* 2087206 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2087300), // Rule ID 16405 //
     /* 2087211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2087228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087257 */     // MIs[0] round
     /* 2087257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087260 */     // MIs[0] policy
     /* 2087260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2087273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087299 */     // GIR_Coverage, 16405,
     /* 2087299 */     GIR_EraseRootFromParent_Done,
     /* 2087300 */   // Label 27679: @2087300
     /* 2087300 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2087394), // Rule ID 16408 //
     /* 2087305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2087316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2087319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2087322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2087328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087351 */     // MIs[0] round
     /* 2087351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087354 */     // MIs[0] policy
     /* 2087354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2087367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087393 */     // GIR_Coverage, 16408,
     /* 2087393 */     GIR_EraseRootFromParent_Done,
     /* 2087394 */   // Label 27680: @2087394
     /* 2087394 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2087488), // Rule ID 16409 //
     /* 2087399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2087410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2087413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2087416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2087422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087445 */     // MIs[0] round
     /* 2087445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087448 */     // MIs[0] policy
     /* 2087448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2087461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087487 */     // GIR_Coverage, 16409,
     /* 2087487 */     GIR_EraseRootFromParent_Done,
     /* 2087488 */   // Label 27681: @2087488
     /* 2087488 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2087582), // Rule ID 16412 //
     /* 2087493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2087504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2087507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2087510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2087516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087539 */     // MIs[0] round
     /* 2087539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087542 */     // MIs[0] policy
     /* 2087542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2087555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087581 */     // GIR_Coverage, 16412,
     /* 2087581 */     GIR_EraseRootFromParent_Done,
     /* 2087582 */   // Label 27682: @2087582
     /* 2087582 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2087676), // Rule ID 16413 //
     /* 2087587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2087598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2087601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2087604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2087610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087633 */     // MIs[0] round
     /* 2087633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087636 */     // MIs[0] policy
     /* 2087636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2087649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087675 */     // GIR_Coverage, 16413,
     /* 2087675 */     GIR_EraseRootFromParent_Done,
     /* 2087676 */   // Label 27683: @2087676
     /* 2087676 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2087770), // Rule ID 16416 //
     /* 2087681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087727 */     // MIs[0] round
     /* 2087727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087730 */     // MIs[0] policy
     /* 2087730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087740 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2087743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087769 */     // GIR_Coverage, 16416,
     /* 2087769 */     GIR_EraseRootFromParent_Done,
     /* 2087770 */   // Label 27684: @2087770
     /* 2087770 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2087864), // Rule ID 16417 //
     /* 2087775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087821 */     // MIs[0] round
     /* 2087821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087824 */     // MIs[0] policy
     /* 2087824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087834 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2087837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087863 */     // GIR_Coverage, 16417,
     /* 2087863 */     GIR_EraseRootFromParent_Done,
     /* 2087864 */   // Label 27685: @2087864
     /* 2087864 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2087958), // Rule ID 16420 //
     /* 2087869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2087886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087915 */     // MIs[0] round
     /* 2087915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087918 */     // MIs[0] policy
     /* 2087918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2087931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087957 */     // GIR_Coverage, 16420,
     /* 2087957 */     GIR_EraseRootFromParent_Done,
     /* 2087958 */   // Label 27686: @2087958
     /* 2087958 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2088052), // Rule ID 16421 //
     /* 2087963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2087971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2087980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088009 */     // MIs[0] round
     /* 2088009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088012 */     // MIs[0] policy
     /* 2088012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2088025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088051 */     // GIR_Coverage, 16421,
     /* 2088051 */     GIR_EraseRootFromParent_Done,
     /* 2088052 */   // Label 27687: @2088052
     /* 2088052 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2088146), // Rule ID 16424 //
     /* 2088057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2088074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088103 */     // MIs[0] round
     /* 2088103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088106 */     // MIs[0] policy
     /* 2088106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2088119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088145 */     // GIR_Coverage, 16424,
     /* 2088145 */     GIR_EraseRootFromParent_Done,
     /* 2088146 */   // Label 27688: @2088146
     /* 2088146 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2088240), // Rule ID 16425 //
     /* 2088151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2088162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2088165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2088168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088197 */     // MIs[0] round
     /* 2088197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088200 */     // MIs[0] policy
     /* 2088200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2088213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088239 */     // GIR_Coverage, 16425,
     /* 2088239 */     GIR_EraseRootFromParent_Done,
     /* 2088240 */   // Label 27689: @2088240
     /* 2088240 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2088334), // Rule ID 16428 //
     /* 2088245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2088262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088291 */     // MIs[0] round
     /* 2088291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088294 */     // MIs[0] policy
     /* 2088294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2088307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088333 */     // GIR_Coverage, 16428,
     /* 2088333 */     GIR_EraseRootFromParent_Done,
     /* 2088334 */   // Label 27690: @2088334
     /* 2088334 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2088428), // Rule ID 16429 //
     /* 2088339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2088356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088385 */     // MIs[0] round
     /* 2088385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088388 */     // MIs[0] policy
     /* 2088388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2088401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088427 */     // GIR_Coverage, 16429,
     /* 2088427 */     GIR_EraseRootFromParent_Done,
     /* 2088428 */   // Label 27691: @2088428
     /* 2088428 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2088522), // Rule ID 16432 //
     /* 2088433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2088444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2088447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2088450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088479 */     // MIs[0] round
     /* 2088479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088482 */     // MIs[0] policy
     /* 2088482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088492 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2088495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088521 */     // GIR_Coverage, 16432,
     /* 2088521 */     GIR_EraseRootFromParent_Done,
     /* 2088522 */   // Label 27692: @2088522
     /* 2088522 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2088616), // Rule ID 16433 //
     /* 2088527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2088538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2088541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2088544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088573 */     // MIs[0] round
     /* 2088573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088576 */     // MIs[0] policy
     /* 2088576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2088589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088615 */     // GIR_Coverage, 16433,
     /* 2088615 */     GIR_EraseRootFromParent_Done,
     /* 2088616 */   // Label 27693: @2088616
     /* 2088616 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2088710), // Rule ID 16436 //
     /* 2088621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2088624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088667 */     // MIs[0] round
     /* 2088667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088670 */     // MIs[0] policy
     /* 2088670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2088683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088709 */     // GIR_Coverage, 16436,
     /* 2088709 */     GIR_EraseRootFromParent_Done,
     /* 2088710 */   // Label 27694: @2088710
     /* 2088710 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2088804), // Rule ID 16437 //
     /* 2088715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2088718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2088726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2088729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088761 */     // MIs[0] round
     /* 2088761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088764 */     // MIs[0] policy
     /* 2088764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2088777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088803 */     // GIR_Coverage, 16437,
     /* 2088803 */     GIR_EraseRootFromParent_Done,
     /* 2088804 */   // Label 27695: @2088804
     /* 2088804 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2088898), // Rule ID 16440 //
     /* 2088809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2088812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2088826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088855 */     // MIs[0] round
     /* 2088855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088858 */     // MIs[0] policy
     /* 2088858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2088871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088897 */     // GIR_Coverage, 16440,
     /* 2088897 */     GIR_EraseRootFromParent_Done,
     /* 2088898 */   // Label 27696: @2088898
     /* 2088898 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2088992), // Rule ID 16441 //
     /* 2088903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2088906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2088911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2088920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088949 */     // MIs[0] round
     /* 2088949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088952 */     // MIs[0] policy
     /* 2088952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2088965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088991 */     // GIR_Coverage, 16441,
     /* 2088991 */     GIR_EraseRootFromParent_Done,
     /* 2088992 */   // Label 27697: @2088992
     /* 2088992 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2089086), // Rule ID 16444 //
     /* 2088997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2089000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2089005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2089014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089043 */     // MIs[0] round
     /* 2089043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089046 */     // MIs[0] policy
     /* 2089046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2089059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089085 */     // GIR_Coverage, 16444,
     /* 2089085 */     GIR_EraseRootFromParent_Done,
     /* 2089086 */   // Label 27698: @2089086
     /* 2089086 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2089180), // Rule ID 16445 //
     /* 2089091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2089094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2089099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2089108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089137 */     // MIs[0] round
     /* 2089137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089140 */     // MIs[0] policy
     /* 2089140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2089153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089179 */     // GIR_Coverage, 16445,
     /* 2089179 */     GIR_EraseRootFromParent_Done,
     /* 2089180 */   // Label 27699: @2089180
     /* 2089180 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2089274), // Rule ID 16448 //
     /* 2089185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2089188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2089193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2089202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089231 */     // MIs[0] round
     /* 2089231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089234 */     // MIs[0] policy
     /* 2089234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2089247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089273 */     // GIR_Coverage, 16448,
     /* 2089273 */     GIR_EraseRootFromParent_Done,
     /* 2089274 */   // Label 27700: @2089274
     /* 2089274 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2089368), // Rule ID 16449 //
     /* 2089279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2089282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2089287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2089296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089325 */     // MIs[0] round
     /* 2089325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089328 */     // MIs[0] policy
     /* 2089328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2089341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089367 */     // GIR_Coverage, 16449,
     /* 2089367 */     GIR_EraseRootFromParent_Done,
     /* 2089368 */   // Label 27701: @2089368
     /* 2089368 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2089462), // Rule ID 16512 //
     /* 2089373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2089384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2089387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2089390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2089393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089419 */     // MIs[0] round
     /* 2089419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089422 */     // MIs[0] policy
     /* 2089422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2089435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089461 */     // GIR_Coverage, 16512,
     /* 2089461 */     GIR_EraseRootFromParent_Done,
     /* 2089462 */   // Label 27702: @2089462
     /* 2089462 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2089556), // Rule ID 16513 //
     /* 2089467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2089478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2089481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2089484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2089487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089513 */     // MIs[0] round
     /* 2089513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089516 */     // MIs[0] policy
     /* 2089516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2089529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089555 */     // GIR_Coverage, 16513,
     /* 2089555 */     GIR_EraseRootFromParent_Done,
     /* 2089556 */   // Label 27703: @2089556
     /* 2089556 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2089650), // Rule ID 16516 //
     /* 2089561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2089572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2089575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2089578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2089581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089607 */     // MIs[0] round
     /* 2089607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089610 */     // MIs[0] policy
     /* 2089610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2089623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089649 */     // GIR_Coverage, 16516,
     /* 2089649 */     GIR_EraseRootFromParent_Done,
     /* 2089650 */   // Label 27704: @2089650
     /* 2089650 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2089744), // Rule ID 16517 //
     /* 2089655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2089666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2089669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2089672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2089675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089701 */     // MIs[0] round
     /* 2089701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089704 */     // MIs[0] policy
     /* 2089704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089714 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2089717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089743 */     // GIR_Coverage, 16517,
     /* 2089743 */     GIR_EraseRootFromParent_Done,
     /* 2089744 */   // Label 27705: @2089744
     /* 2089744 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2089838), // Rule ID 16520 //
     /* 2089749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2089760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2089763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2089766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2089769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089795 */     // MIs[0] round
     /* 2089795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089798 */     // MIs[0] policy
     /* 2089798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2089811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089837 */     // GIR_Coverage, 16520,
     /* 2089837 */     GIR_EraseRootFromParent_Done,
     /* 2089838 */   // Label 27706: @2089838
     /* 2089838 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2089932), // Rule ID 16521 //
     /* 2089843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2089854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2089857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2089860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2089863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089889 */     // MIs[0] round
     /* 2089889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089892 */     // MIs[0] policy
     /* 2089892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2089905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2089925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089931 */     // GIR_Coverage, 16521,
     /* 2089931 */     GIR_EraseRootFromParent_Done,
     /* 2089932 */   // Label 27707: @2089932
     /* 2089932 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2090026), // Rule ID 16524 //
     /* 2089937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2089948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2089951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2089957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089983 */     // MIs[0] round
     /* 2089983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089986 */     // MIs[0] policy
     /* 2089986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2089999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090025 */     // GIR_Coverage, 16524,
     /* 2090025 */     GIR_EraseRootFromParent_Done,
     /* 2090026 */   // Label 27708: @2090026
     /* 2090026 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2090120), // Rule ID 16525 //
     /* 2090031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2090042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2090045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2090048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2090051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090077 */     // MIs[0] round
     /* 2090077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090080 */     // MIs[0] policy
     /* 2090080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2090093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090119 */     // GIR_Coverage, 16525,
     /* 2090119 */     GIR_EraseRootFromParent_Done,
     /* 2090120 */   // Label 27709: @2090120
     /* 2090120 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2090214), // Rule ID 16528 //
     /* 2090125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2090136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2090139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2090142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2090145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090171 */     // MIs[0] round
     /* 2090171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090174 */     // MIs[0] policy
     /* 2090174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2090187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090213 */     // GIR_Coverage, 16528,
     /* 2090213 */     GIR_EraseRootFromParent_Done,
     /* 2090214 */   // Label 27710: @2090214
     /* 2090214 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2090308), // Rule ID 16529 //
     /* 2090219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2090230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2090233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2090236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2090239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2090242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090265 */     // MIs[0] round
     /* 2090265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090268 */     // MIs[0] policy
     /* 2090268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2090281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090307 */     // GIR_Coverage, 16529,
     /* 2090307 */     GIR_EraseRootFromParent_Done,
     /* 2090308 */   // Label 27711: @2090308
     /* 2090308 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2090402), // Rule ID 16532 //
     /* 2090313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2090324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2090327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2090330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2090333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2090336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090359 */     // MIs[0] round
     /* 2090359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090362 */     // MIs[0] policy
     /* 2090362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2090375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090401 */     // GIR_Coverage, 16532,
     /* 2090401 */     GIR_EraseRootFromParent_Done,
     /* 2090402 */   // Label 27712: @2090402
     /* 2090402 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2090496), // Rule ID 16533 //
     /* 2090407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2090418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2090421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2090424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2090427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2090430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090453 */     // MIs[0] round
     /* 2090453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090456 */     // MIs[0] policy
     /* 2090456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090466 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2090469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090495 */     // GIR_Coverage, 16533,
     /* 2090495 */     GIR_EraseRootFromParent_Done,
     /* 2090496 */   // Label 27713: @2090496
     /* 2090496 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2090590), // Rule ID 16536 //
     /* 2090501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2090512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2090515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2090518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090547 */     // MIs[0] round
     /* 2090547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090550 */     // MIs[0] policy
     /* 2090550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2090563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090589 */     // GIR_Coverage, 16536,
     /* 2090589 */     GIR_EraseRootFromParent_Done,
     /* 2090590 */   // Label 27714: @2090590
     /* 2090590 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2090684), // Rule ID 16537 //
     /* 2090595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2090606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2090609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2090612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090641 */     // MIs[0] round
     /* 2090641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090644 */     // MIs[0] policy
     /* 2090644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2090657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090683 */     // GIR_Coverage, 16537,
     /* 2090683 */     GIR_EraseRootFromParent_Done,
     /* 2090684 */   // Label 27715: @2090684
     /* 2090684 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2090778), // Rule ID 16540 //
     /* 2090689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2090700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2090703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2090706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090735 */     // MIs[0] round
     /* 2090735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090738 */     // MIs[0] policy
     /* 2090738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090748 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2090751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090777 */     // GIR_Coverage, 16540,
     /* 2090777 */     GIR_EraseRootFromParent_Done,
     /* 2090778 */   // Label 27716: @2090778
     /* 2090778 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2090872), // Rule ID 16541 //
     /* 2090783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2090794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2090797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2090800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090829 */     // MIs[0] round
     /* 2090829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090832 */     // MIs[0] policy
     /* 2090832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2090845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090871 */     // GIR_Coverage, 16541,
     /* 2090871 */     GIR_EraseRootFromParent_Done,
     /* 2090872 */   // Label 27717: @2090872
     /* 2090872 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2090966), // Rule ID 16544 //
     /* 2090877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2090888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2090891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2090897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090923 */     // MIs[0] round
     /* 2090923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090926 */     // MIs[0] policy
     /* 2090926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2090939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090965 */     // GIR_Coverage, 16544,
     /* 2090965 */     GIR_EraseRootFromParent_Done,
     /* 2090966 */   // Label 27718: @2090966
     /* 2090966 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2091060), // Rule ID 16545 //
     /* 2090971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2090982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2090985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2090988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2090991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091017 */     // MIs[0] round
     /* 2091017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091020 */     // MIs[0] policy
     /* 2091020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2091033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091059 */     // GIR_Coverage, 16545,
     /* 2091059 */     GIR_EraseRootFromParent_Done,
     /* 2091060 */   // Label 27719: @2091060
     /* 2091060 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2091154), // Rule ID 16548 //
     /* 2091065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2091076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2091079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2091082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2091085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091111 */     // MIs[0] round
     /* 2091111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091114 */     // MIs[0] policy
     /* 2091114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2091127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091153 */     // GIR_Coverage, 16548,
     /* 2091153 */     GIR_EraseRootFromParent_Done,
     /* 2091154 */   // Label 27720: @2091154
     /* 2091154 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2091248), // Rule ID 16549 //
     /* 2091159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2091170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2091173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2091176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2091179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091205 */     // MIs[0] round
     /* 2091205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091208 */     // MIs[0] policy
     /* 2091208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2091221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091247 */     // GIR_Coverage, 16549,
     /* 2091247 */     GIR_EraseRootFromParent_Done,
     /* 2091248 */   // Label 27721: @2091248
     /* 2091248 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2091342), // Rule ID 16552 //
     /* 2091253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2091264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2091267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2091270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2091273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091299 */     // MIs[0] round
     /* 2091299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091302 */     // MIs[0] policy
     /* 2091302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091312 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2091315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091341 */     // GIR_Coverage, 16552,
     /* 2091341 */     GIR_EraseRootFromParent_Done,
     /* 2091342 */   // Label 27722: @2091342
     /* 2091342 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2091436), // Rule ID 16553 //
     /* 2091347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2091358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2091361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2091364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2091367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091393 */     // MIs[0] round
     /* 2091393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091396 */     // MIs[0] policy
     /* 2091396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091406 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2091409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091435 */     // GIR_Coverage, 16553,
     /* 2091435 */     GIR_EraseRootFromParent_Done,
     /* 2091436 */   // Label 27723: @2091436
     /* 2091436 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2091530), // Rule ID 16556 //
     /* 2091441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2091444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2091458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091487 */     // MIs[0] round
     /* 2091487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091490 */     // MIs[0] policy
     /* 2091490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2091503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091529 */     // GIR_Coverage, 16556,
     /* 2091529 */     GIR_EraseRootFromParent_Done,
     /* 2091530 */   // Label 27724: @2091530
     /* 2091530 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2091624), // Rule ID 16557 //
     /* 2091535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2091538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2091552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091581 */     // MIs[0] round
     /* 2091581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091584 */     // MIs[0] policy
     /* 2091584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2091597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091623 */     // GIR_Coverage, 16557,
     /* 2091623 */     GIR_EraseRootFromParent_Done,
     /* 2091624 */   // Label 27725: @2091624
     /* 2091624 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2091718), // Rule ID 16560 //
     /* 2091629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2091632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2091640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2091643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2091646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091675 */     // MIs[0] round
     /* 2091675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091678 */     // MIs[0] policy
     /* 2091678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2091691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091717 */     // GIR_Coverage, 16560,
     /* 2091717 */     GIR_EraseRootFromParent_Done,
     /* 2091718 */   // Label 27726: @2091718
     /* 2091718 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2091812), // Rule ID 16561 //
     /* 2091723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2091726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2091734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2091737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2091740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091769 */     // MIs[0] round
     /* 2091769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091772 */     // MIs[0] policy
     /* 2091772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2091785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091811 */     // GIR_Coverage, 16561,
     /* 2091811 */     GIR_EraseRootFromParent_Done,
     /* 2091812 */   // Label 27727: @2091812
     /* 2091812 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2091906), // Rule ID 16564 //
     /* 2091817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2091820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2091828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2091831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2091834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2091837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091863 */     // MIs[0] round
     /* 2091863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091866 */     // MIs[0] policy
     /* 2091866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2091879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091905 */     // GIR_Coverage, 16564,
     /* 2091905 */     GIR_EraseRootFromParent_Done,
     /* 2091906 */   // Label 27728: @2091906
     /* 2091906 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2092000), // Rule ID 16565 //
     /* 2091911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2091914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2091919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2091922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2091925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2091928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2091931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091957 */     // MIs[0] round
     /* 2091957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091960 */     // MIs[0] policy
     /* 2091960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2091973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091999 */     // GIR_Coverage, 16565,
     /* 2091999 */     GIR_EraseRootFromParent_Done,
     /* 2092000 */   // Label 27729: @2092000
     /* 2092000 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2092094), // Rule ID 16568 //
     /* 2092005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2092008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2092022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2092025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092051 */     // MIs[0] round
     /* 2092051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092054 */     // MIs[0] policy
     /* 2092054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2092067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092093 */     // GIR_Coverage, 16568,
     /* 2092093 */     GIR_EraseRootFromParent_Done,
     /* 2092094 */   // Label 27730: @2092094
     /* 2092094 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2092188), // Rule ID 16569 //
     /* 2092099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2092102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2092116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2092119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092145 */     // MIs[0] round
     /* 2092145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092148 */     // MIs[0] policy
     /* 2092148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2092161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092187 */     // GIR_Coverage, 16569,
     /* 2092187 */     GIR_EraseRootFromParent_Done,
     /* 2092188 */   // Label 27731: @2092188
     /* 2092188 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2092282), // Rule ID 16572 //
     /* 2092193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2092204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2092207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2092210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092239 */     // MIs[0] round
     /* 2092239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092242 */     // MIs[0] policy
     /* 2092242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2092255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092281 */     // GIR_Coverage, 16572,
     /* 2092281 */     GIR_EraseRootFromParent_Done,
     /* 2092282 */   // Label 27732: @2092282
     /* 2092282 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2092376), // Rule ID 16573 //
     /* 2092287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2092298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2092301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2092304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092333 */     // MIs[0] round
     /* 2092333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092336 */     // MIs[0] policy
     /* 2092336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2092349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092375 */     // GIR_Coverage, 16573,
     /* 2092375 */     GIR_EraseRootFromParent_Done,
     /* 2092376 */   // Label 27733: @2092376
     /* 2092376 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2092470), // Rule ID 16576 //
     /* 2092381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2092392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2092395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2092398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092427 */     // MIs[0] round
     /* 2092427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092430 */     // MIs[0] policy
     /* 2092430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2092443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092469 */     // GIR_Coverage, 16576,
     /* 2092469 */     GIR_EraseRootFromParent_Done,
     /* 2092470 */   // Label 27734: @2092470
     /* 2092470 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2092564), // Rule ID 16577 //
     /* 2092475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2092486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2092489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2092492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092521 */     // MIs[0] round
     /* 2092521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092524 */     // MIs[0] policy
     /* 2092524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092534 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2092537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092563 */     // GIR_Coverage, 16577,
     /* 2092563 */     GIR_EraseRootFromParent_Done,
     /* 2092564 */   // Label 27735: @2092564
     /* 2092564 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2092658), // Rule ID 16580 //
     /* 2092569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2092580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2092583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2092586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092615 */     // MIs[0] round
     /* 2092615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092618 */     // MIs[0] policy
     /* 2092618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092628 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2092631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092657 */     // GIR_Coverage, 16580,
     /* 2092657 */     GIR_EraseRootFromParent_Done,
     /* 2092658 */   // Label 27736: @2092658
     /* 2092658 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2092752), // Rule ID 16581 //
     /* 2092663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2092674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2092677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2092680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092709 */     // MIs[0] round
     /* 2092709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092712 */     // MIs[0] policy
     /* 2092712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2092725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092751 */     // GIR_Coverage, 16581,
     /* 2092751 */     GIR_EraseRootFromParent_Done,
     /* 2092752 */   // Label 27737: @2092752
     /* 2092752 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2092846), // Rule ID 16584 //
     /* 2092757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2092768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2092771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2092774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092803 */     // MIs[0] round
     /* 2092803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092806 */     // MIs[0] policy
     /* 2092806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2092819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092845 */     // GIR_Coverage, 16584,
     /* 2092845 */     GIR_EraseRootFromParent_Done,
     /* 2092846 */   // Label 27738: @2092846
     /* 2092846 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2092940), // Rule ID 16585 //
     /* 2092851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2092862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2092865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2092868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2092871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092897 */     // MIs[0] round
     /* 2092897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092900 */     // MIs[0] policy
     /* 2092900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092910 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2092913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2092933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092939 */     // GIR_Coverage, 16585,
     /* 2092939 */     GIR_EraseRootFromParent_Done,
     /* 2092940 */   // Label 27739: @2092940
     /* 2092940 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2093034), // Rule ID 16588 //
     /* 2092945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2092953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2092956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2092959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2092962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2092965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2092987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092991 */     // MIs[0] round
     /* 2092991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092994 */     // MIs[0] policy
     /* 2092994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093004 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2093007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093033 */     // GIR_Coverage, 16588,
     /* 2093033 */     GIR_EraseRootFromParent_Done,
     /* 2093034 */   // Label 27740: @2093034
     /* 2093034 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2093128), // Rule ID 16589 //
     /* 2093039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2093050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2093053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2093056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2093062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093085 */     // MIs[0] round
     /* 2093085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093088 */     // MIs[0] policy
     /* 2093088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2093101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093127 */     // GIR_Coverage, 16589,
     /* 2093127 */     GIR_EraseRootFromParent_Done,
     /* 2093128 */   // Label 27741: @2093128
     /* 2093128 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2093222), // Rule ID 16592 //
     /* 2093133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2093144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2093147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2093150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2093156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093179 */     // MIs[0] round
     /* 2093179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093182 */     // MIs[0] policy
     /* 2093182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2093195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093221 */     // GIR_Coverage, 16592,
     /* 2093221 */     GIR_EraseRootFromParent_Done,
     /* 2093222 */   // Label 27742: @2093222
     /* 2093222 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2093316), // Rule ID 16593 //
     /* 2093227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2093238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2093241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2093244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2093250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093273 */     // MIs[0] round
     /* 2093273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093276 */     // MIs[0] policy
     /* 2093276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2093289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093315 */     // GIR_Coverage, 16593,
     /* 2093315 */     GIR_EraseRootFromParent_Done,
     /* 2093316 */   // Label 27743: @2093316
     /* 2093316 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2093410), // Rule ID 16596 //
     /* 2093321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2093332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2093335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2093338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093367 */     // MIs[0] round
     /* 2093367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093370 */     // MIs[0] policy
     /* 2093370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2093383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093409 */     // GIR_Coverage, 16596,
     /* 2093409 */     GIR_EraseRootFromParent_Done,
     /* 2093410 */   // Label 27744: @2093410
     /* 2093410 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2093504), // Rule ID 16597 //
     /* 2093415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2093426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2093429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2093432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093461 */     // MIs[0] round
     /* 2093461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093464 */     // MIs[0] policy
     /* 2093464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2093477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093503 */     // GIR_Coverage, 16597,
     /* 2093503 */     GIR_EraseRootFromParent_Done,
     /* 2093504 */   // Label 27745: @2093504
     /* 2093504 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2093598), // Rule ID 16600 //
     /* 2093509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2093520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2093523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2093526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093555 */     // MIs[0] round
     /* 2093555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093558 */     // MIs[0] policy
     /* 2093558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2093571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093597 */     // GIR_Coverage, 16600,
     /* 2093597 */     GIR_EraseRootFromParent_Done,
     /* 2093598 */   // Label 27746: @2093598
     /* 2093598 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2093692), // Rule ID 16601 //
     /* 2093603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2093614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2093617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2093620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093649 */     // MIs[0] round
     /* 2093649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093652 */     // MIs[0] policy
     /* 2093652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2093665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093691 */     // GIR_Coverage, 16601,
     /* 2093691 */     GIR_EraseRootFromParent_Done,
     /* 2093692 */   // Label 27747: @2093692
     /* 2093692 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2093786), // Rule ID 16604 //
     /* 2093697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2093708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2093711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2093714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093743 */     // MIs[0] round
     /* 2093743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093746 */     // MIs[0] policy
     /* 2093746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2093759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093785 */     // GIR_Coverage, 16604,
     /* 2093785 */     GIR_EraseRootFromParent_Done,
     /* 2093786 */   // Label 27748: @2093786
     /* 2093786 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2093880), // Rule ID 16605 //
     /* 2093791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2093802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2093805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2093808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093837 */     // MIs[0] round
     /* 2093837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093840 */     // MIs[0] policy
     /* 2093840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2093853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093879 */     // GIR_Coverage, 16605,
     /* 2093879 */     GIR_EraseRootFromParent_Done,
     /* 2093880 */   // Label 27749: @2093880
     /* 2093880 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2093974), // Rule ID 16608 //
     /* 2093885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2093896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2093899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2093902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093931 */     // MIs[0] round
     /* 2093931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093934 */     // MIs[0] policy
     /* 2093934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2093947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093973 */     // GIR_Coverage, 16608,
     /* 2093973 */     GIR_EraseRootFromParent_Done,
     /* 2093974 */   // Label 27750: @2093974
     /* 2093974 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2094068), // Rule ID 16609 //
     /* 2093979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2093987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2093990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2093993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2093996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094025 */     // MIs[0] round
     /* 2094025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094028 */     // MIs[0] policy
     /* 2094028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2094041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094067 */     // GIR_Coverage, 16609,
     /* 2094067 */     GIR_EraseRootFromParent_Done,
     /* 2094068 */   // Label 27751: @2094068
     /* 2094068 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2094162), // Rule ID 16612 //
     /* 2094073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2094084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2094087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2094090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094119 */     // MIs[0] round
     /* 2094119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094122 */     // MIs[0] policy
     /* 2094122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2094135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094161 */     // GIR_Coverage, 16612,
     /* 2094161 */     GIR_EraseRootFromParent_Done,
     /* 2094162 */   // Label 27752: @2094162
     /* 2094162 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2094256), // Rule ID 16613 //
     /* 2094167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2094178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2094181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2094184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094213 */     // MIs[0] round
     /* 2094213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094216 */     // MIs[0] policy
     /* 2094216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2094229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094255 */     // GIR_Coverage, 16613,
     /* 2094255 */     GIR_EraseRootFromParent_Done,
     /* 2094256 */   // Label 27753: @2094256
     /* 2094256 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2094350), // Rule ID 16616 //
     /* 2094261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2094264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2094272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2094275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2094278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094307 */     // MIs[0] round
     /* 2094307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094310 */     // MIs[0] policy
     /* 2094310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2094323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094349 */     // GIR_Coverage, 16616,
     /* 2094349 */     GIR_EraseRootFromParent_Done,
     /* 2094350 */   // Label 27754: @2094350
     /* 2094350 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2094444), // Rule ID 16617 //
     /* 2094355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2094358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2094366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2094369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2094372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094401 */     // MIs[0] round
     /* 2094401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094404 */     // MIs[0] policy
     /* 2094404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094414 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2094417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094443 */     // GIR_Coverage, 16617,
     /* 2094443 */     GIR_EraseRootFromParent_Done,
     /* 2094444 */   // Label 27755: @2094444
     /* 2094444 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2094538), // Rule ID 16620 //
     /* 2094449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2094452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2094460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2094463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2094466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094495 */     // MIs[0] round
     /* 2094495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094498 */     // MIs[0] policy
     /* 2094498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2094511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094537 */     // GIR_Coverage, 16620,
     /* 2094537 */     GIR_EraseRootFromParent_Done,
     /* 2094538 */   // Label 27756: @2094538
     /* 2094538 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2094632), // Rule ID 16621 //
     /* 2094543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2094546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2094554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2094557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2094560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094589 */     // MIs[0] round
     /* 2094589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094592 */     // MIs[0] policy
     /* 2094592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2094605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094631 */     // GIR_Coverage, 16621,
     /* 2094631 */     GIR_EraseRootFromParent_Done,
     /* 2094632 */   // Label 27757: @2094632
     /* 2094632 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2094726), // Rule ID 16624 //
     /* 2094637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2094640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2094648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2094651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2094654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094683 */     // MIs[0] round
     /* 2094683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094686 */     // MIs[0] policy
     /* 2094686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2094699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094725 */     // GIR_Coverage, 16624,
     /* 2094725 */     GIR_EraseRootFromParent_Done,
     /* 2094726 */   // Label 27758: @2094726
     /* 2094726 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2094820), // Rule ID 16625 //
     /* 2094731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2094734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2094742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2094745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2094748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094777 */     // MIs[0] round
     /* 2094777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094780 */     // MIs[0] policy
     /* 2094780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2094793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094819 */     // GIR_Coverage, 16625,
     /* 2094819 */     GIR_EraseRootFromParent_Done,
     /* 2094820 */   // Label 27759: @2094820
     /* 2094820 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2094914), // Rule ID 16628 //
     /* 2094825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2094828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2094836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2094839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2094842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094871 */     // MIs[0] round
     /* 2094871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094874 */     // MIs[0] policy
     /* 2094874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2094887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094913 */     // GIR_Coverage, 16628,
     /* 2094913 */     GIR_EraseRootFromParent_Done,
     /* 2094914 */   // Label 27760: @2094914
     /* 2094914 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2095008), // Rule ID 16629 //
     /* 2094919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2094922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2094927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2094930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2094933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2094936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094965 */     // MIs[0] round
     /* 2094965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094968 */     // MIs[0] policy
     /* 2094968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094978 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2094981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095007 */     // GIR_Coverage, 16629,
     /* 2095007 */     GIR_EraseRootFromParent_Done,
     /* 2095008 */   // Label 27761: @2095008
     /* 2095008 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2095099), // Rule ID 16692 //
     /* 2095013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2095016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2095030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095059 */     // MIs[0] round
     /* 2095059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095062 */     // MIs[0] policy
     /* 2095062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095072 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2095075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095098 */     // GIR_Coverage, 16692,
     /* 2095098 */     GIR_EraseRootFromParent_Done,
     /* 2095099 */   // Label 27762: @2095099
     /* 2095099 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2095190), // Rule ID 16693 //
     /* 2095104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2095107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2095115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2095118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2095121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2095124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095150 */     // MIs[0] round
     /* 2095150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095153 */     // MIs[0] policy
     /* 2095153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095163 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2095166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095189 */     // GIR_Coverage, 16693,
     /* 2095189 */     GIR_EraseRootFromParent_Done,
     /* 2095190 */   // Label 27763: @2095190
     /* 2095190 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2095281), // Rule ID 16696 //
     /* 2095195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2095198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2095212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095241 */     // MIs[0] round
     /* 2095241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095244 */     // MIs[0] policy
     /* 2095244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095254 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2095257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095280 */     // GIR_Coverage, 16696,
     /* 2095280 */     GIR_EraseRootFromParent_Done,
     /* 2095281 */   // Label 27764: @2095281
     /* 2095281 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2095372), // Rule ID 16697 //
     /* 2095286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2095289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2095297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2095300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2095303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2095306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095332 */     // MIs[0] round
     /* 2095332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095335 */     // MIs[0] policy
     /* 2095335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095345 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2095348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095371 */     // GIR_Coverage, 16697,
     /* 2095371 */     GIR_EraseRootFromParent_Done,
     /* 2095372 */   // Label 27765: @2095372
     /* 2095372 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2095463), // Rule ID 16700 //
     /* 2095377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2095380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2095397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095423 */     // MIs[0] round
     /* 2095423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095426 */     // MIs[0] policy
     /* 2095426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095436 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2095439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095462 */     // GIR_Coverage, 16700,
     /* 2095462 */     GIR_EraseRootFromParent_Done,
     /* 2095463 */   // Label 27766: @2095463
     /* 2095463 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2095554), // Rule ID 16701 //
     /* 2095468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2095471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2095485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2095488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095514 */     // MIs[0] round
     /* 2095514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095517 */     // MIs[0] policy
     /* 2095517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095527 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2095530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095553 */     // GIR_Coverage, 16701,
     /* 2095553 */     GIR_EraseRootFromParent_Done,
     /* 2095554 */   // Label 27767: @2095554
     /* 2095554 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2095645), // Rule ID 16704 //
     /* 2095559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2095562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2095576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2095579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095605 */     // MIs[0] round
     /* 2095605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095608 */     // MIs[0] policy
     /* 2095608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095618 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2095621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095644 */     // GIR_Coverage, 16704,
     /* 2095644 */     GIR_EraseRootFromParent_Done,
     /* 2095645 */   // Label 27768: @2095645
     /* 2095645 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2095736), // Rule ID 16705 //
     /* 2095650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2095653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2095667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2095670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095696 */     // MIs[0] round
     /* 2095696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095699 */     // MIs[0] policy
     /* 2095699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095709 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2095712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095735 */     // GIR_Coverage, 16705,
     /* 2095735 */     GIR_EraseRootFromParent_Done,
     /* 2095736 */   // Label 27769: @2095736
     /* 2095736 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2095827), // Rule ID 16708 //
     /* 2095741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2095744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2095761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095787 */     // MIs[0] round
     /* 2095787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095790 */     // MIs[0] policy
     /* 2095790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095800 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2095803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095826 */     // GIR_Coverage, 16708,
     /* 2095826 */     GIR_EraseRootFromParent_Done,
     /* 2095827 */   // Label 27770: @2095827
     /* 2095827 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2095918), // Rule ID 16709 //
     /* 2095832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2095835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2095849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2095852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095878 */     // MIs[0] round
     /* 2095878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095881 */     // MIs[0] policy
     /* 2095881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095891 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2095894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095917 */     // GIR_Coverage, 16709,
     /* 2095917 */     GIR_EraseRootFromParent_Done,
     /* 2095918 */   // Label 27771: @2095918
     /* 2095918 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2096009), // Rule ID 16712 //
     /* 2095923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2095926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2095934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2095937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2095943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095969 */     // MIs[0] round
     /* 2095969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095972 */     // MIs[0] policy
     /* 2095972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2095985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2096005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096008 */     // GIR_Coverage, 16712,
     /* 2096008 */     GIR_EraseRootFromParent_Done,
     /* 2096009 */   // Label 27772: @2096009
     /* 2096009 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2096100), // Rule ID 16713 //
     /* 2096014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2096017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2096025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2096028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2096031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2096034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096060 */     // MIs[0] round
     /* 2096060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096063 */     // MIs[0] policy
     /* 2096063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096073 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2096076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2096096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096099 */     // GIR_Coverage, 16713,
     /* 2096099 */     GIR_EraseRootFromParent_Done,
     /* 2096100 */   // Label 27773: @2096100
     /* 2096100 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2096191), // Rule ID 16716 //
     /* 2096105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2096116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2096119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2096125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096151 */     // MIs[0] round
     /* 2096151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096154 */     // MIs[0] policy
     /* 2096154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096164 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2096167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096190 */     // GIR_Coverage, 16716,
     /* 2096190 */     GIR_EraseRootFromParent_Done,
     /* 2096191 */   // Label 27774: @2096191
     /* 2096191 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2096282), // Rule ID 16717 //
     /* 2096196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2096207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2096210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2096216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096242 */     // MIs[0] round
     /* 2096242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096245 */     // MIs[0] policy
     /* 2096245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2096258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096281 */     // GIR_Coverage, 16717,
     /* 2096281 */     GIR_EraseRootFromParent_Done,
     /* 2096282 */   // Label 27775: @2096282
     /* 2096282 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2096373), // Rule ID 16720 //
     /* 2096287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2096298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2096301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2096304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2096307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2096310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096333 */     // MIs[0] round
     /* 2096333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096336 */     // MIs[0] policy
     /* 2096336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096346 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2096349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096372 */     // GIR_Coverage, 16720,
     /* 2096372 */     GIR_EraseRootFromParent_Done,
     /* 2096373 */   // Label 27776: @2096373
     /* 2096373 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2096464), // Rule ID 16721 //
     /* 2096378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2096389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2096392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2096395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2096398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2096401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096424 */     // MIs[0] round
     /* 2096424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096427 */     // MIs[0] policy
     /* 2096427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096437 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2096440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096463 */     // GIR_Coverage, 16721,
     /* 2096463 */     GIR_EraseRootFromParent_Done,
     /* 2096464 */   // Label 27777: @2096464
     /* 2096464 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2096555), // Rule ID 16724 //
     /* 2096469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2096480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2096483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2096486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2096489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2096492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096515 */     // MIs[0] round
     /* 2096515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096518 */     // MIs[0] policy
     /* 2096518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2096531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096554 */     // GIR_Coverage, 16724,
     /* 2096554 */     GIR_EraseRootFromParent_Done,
     /* 2096555 */   // Label 27778: @2096555
     /* 2096555 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2096646), // Rule ID 16725 //
     /* 2096560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2096571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2096574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2096577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2096580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2096583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096606 */     // MIs[0] round
     /* 2096606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096609 */     // MIs[0] policy
     /* 2096609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096619 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2096622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096645 */     // GIR_Coverage, 16725,
     /* 2096645 */     GIR_EraseRootFromParent_Done,
     /* 2096646 */   // Label 27779: @2096646
     /* 2096646 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2096737), // Rule ID 16728 //
     /* 2096651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2096654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2096668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2096671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096697 */     // MIs[0] round
     /* 2096697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096700 */     // MIs[0] policy
     /* 2096700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096710 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2096713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096736 */     // GIR_Coverage, 16728,
     /* 2096736 */     GIR_EraseRootFromParent_Done,
     /* 2096737 */   // Label 27780: @2096737
     /* 2096737 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2096828), // Rule ID 16729 //
     /* 2096742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2096745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2096753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2096756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2096759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2096762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2096772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096788 */     // MIs[0] round
     /* 2096788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096791 */     // MIs[0] policy
     /* 2096791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096801 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2096804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096827 */     // GIR_Coverage, 16729,
     /* 2096827 */     GIR_EraseRootFromParent_Done,
     /* 2096828 */   // Label 27781: @2096828
     /* 2096828 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2096919), // Rule ID 16732 //
     /* 2096833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2096836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2096850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2096853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096879 */     // MIs[0] round
     /* 2096879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096882 */     // MIs[0] policy
     /* 2096882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096892 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2096895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096918 */     // GIR_Coverage, 16732,
     /* 2096918 */     GIR_EraseRootFromParent_Done,
     /* 2096919 */   // Label 27782: @2096919
     /* 2096919 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2097010), // Rule ID 16733 //
     /* 2096924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2096927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2096941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2096944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096970 */     // MIs[0] round
     /* 2096970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096973 */     // MIs[0] policy
     /* 2096973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096983 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2096986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097009 */     // GIR_Coverage, 16733,
     /* 2097009 */     GIR_EraseRootFromParent_Done,
     /* 2097010 */   // Label 27783: @2097010
     /* 2097010 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2097101), // Rule ID 16736 //
     /* 2097015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2097018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2097026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2097029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2097032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2097035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097061 */     // MIs[0] round
     /* 2097061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097064 */     // MIs[0] policy
     /* 2097064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097074 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2097077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097100 */     // GIR_Coverage, 16736,
     /* 2097100 */     GIR_EraseRootFromParent_Done,
     /* 2097101 */   // Label 27784: @2097101
     /* 2097101 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2097192), // Rule ID 16737 //
     /* 2097106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2097109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2097117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2097120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2097123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2097126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097152 */     // MIs[0] round
     /* 2097152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097155 */     // MIs[0] policy
     /* 2097155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097165 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2097168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097191 */     // GIR_Coverage, 16737,
     /* 2097191 */     GIR_EraseRootFromParent_Done,
     /* 2097192 */   // Label 27785: @2097192
     /* 2097192 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2097283), // Rule ID 16740 //
     /* 2097197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2097200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2097208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2097211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2097214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2097217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097243 */     // MIs[0] round
     /* 2097243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097246 */     // MIs[0] policy
     /* 2097246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097256 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2097259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097282 */     // GIR_Coverage, 16740,
     /* 2097282 */     GIR_EraseRootFromParent_Done,
     /* 2097283 */   // Label 27786: @2097283
     /* 2097283 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2097374), // Rule ID 16741 //
     /* 2097288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2097291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2097299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2097302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2097305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2097308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097334 */     // MIs[0] round
     /* 2097334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097337 */     // MIs[0] policy
     /* 2097337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097347 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2097350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097373 */     // GIR_Coverage, 16741,
     /* 2097373 */     GIR_EraseRootFromParent_Done,
     /* 2097374 */   // Label 27787: @2097374
     /* 2097374 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2097465), // Rule ID 16744 //
     /* 2097379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2097382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2097390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2097393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2097396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2097399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097425 */     // MIs[0] round
     /* 2097425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097428 */     // MIs[0] policy
     /* 2097428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097438 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2097441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097464 */     // GIR_Coverage, 16744,
     /* 2097464 */     GIR_EraseRootFromParent_Done,
     /* 2097465 */   // Label 27788: @2097465
     /* 2097465 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2097556), // Rule ID 16745 //
     /* 2097470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2097473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2097481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2097484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2097487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2097490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097516 */     // MIs[0] round
     /* 2097516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097519 */     // MIs[0] policy
     /* 2097519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097529 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2097532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097555 */     // GIR_Coverage, 16745,
     /* 2097555 */     GIR_EraseRootFromParent_Done,
     /* 2097556 */   // Label 27789: @2097556
     /* 2097556 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2097647), // Rule ID 16748 //
     /* 2097561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2097564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2097572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2097575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2097578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2097581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097607 */     // MIs[0] round
     /* 2097607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097610 */     // MIs[0] policy
     /* 2097610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097620 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2097623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097646 */     // GIR_Coverage, 16748,
     /* 2097646 */     GIR_EraseRootFromParent_Done,
     /* 2097647 */   // Label 27790: @2097647
     /* 2097647 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2097738), // Rule ID 16749 //
     /* 2097652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2097655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2097663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2097666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2097669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2097672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097698 */     // MIs[0] round
     /* 2097698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097701 */     // MIs[0] policy
     /* 2097701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097711 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2097714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097737 */     // GIR_Coverage, 16749,
     /* 2097737 */     GIR_EraseRootFromParent_Done,
     /* 2097738 */   // Label 27791: @2097738
     /* 2097738 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2097829), // Rule ID 16752 //
     /* 2097743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2097746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2097760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2097763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2097785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097789 */     // MIs[0] round
     /* 2097789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097792 */     // MIs[0] policy
     /* 2097792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097802 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2097805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097828 */     // GIR_Coverage, 16752,
     /* 2097828 */     GIR_EraseRootFromParent_Done,
     /* 2097829 */   // Label 27792: @2097829
     /* 2097829 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2097920), // Rule ID 16753 //
     /* 2097834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2097837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2097851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2097854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2097876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097880 */     // MIs[0] round
     /* 2097880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097883 */     // MIs[0] policy
     /* 2097883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097893 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2097896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097919 */     // GIR_Coverage, 16753,
     /* 2097919 */     GIR_EraseRootFromParent_Done,
     /* 2097920 */   // Label 27793: @2097920
     /* 2097920 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2098011), // Rule ID 16756 //
     /* 2097925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2097928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2097933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2097936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2097939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2097942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2097945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2097967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097971 */     // MIs[0] round
     /* 2097971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097974 */     // MIs[0] policy
     /* 2097974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097984 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2097987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098010 */     // GIR_Coverage, 16756,
     /* 2098010 */     GIR_EraseRootFromParent_Done,
     /* 2098011 */   // Label 27794: @2098011
     /* 2098011 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2098102), // Rule ID 16757 //
     /* 2098016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2098019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2098027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2098030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2098033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098062 */     // MIs[0] round
     /* 2098062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098065 */     // MIs[0] policy
     /* 2098065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098075 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2098078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098101 */     // GIR_Coverage, 16757,
     /* 2098101 */     GIR_EraseRootFromParent_Done,
     /* 2098102 */   // Label 27795: @2098102
     /* 2098102 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2098193), // Rule ID 16760 //
     /* 2098107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2098110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2098124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098153 */     // MIs[0] round
     /* 2098153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098156 */     // MIs[0] policy
     /* 2098156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098166 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2098169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098192 */     // GIR_Coverage, 16760,
     /* 2098192 */     GIR_EraseRootFromParent_Done,
     /* 2098193 */   // Label 27796: @2098193
     /* 2098193 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2098284), // Rule ID 16761 //
     /* 2098198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2098201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2098215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098244 */     // MIs[0] round
     /* 2098244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098247 */     // MIs[0] policy
     /* 2098247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098257 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2098260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098283 */     // GIR_Coverage, 16761,
     /* 2098283 */     GIR_EraseRootFromParent_Done,
     /* 2098284 */   // Label 27797: @2098284
     /* 2098284 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2098375), // Rule ID 16764 //
     /* 2098289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2098292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2098306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098335 */     // MIs[0] round
     /* 2098335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098338 */     // MIs[0] policy
     /* 2098338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098348 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2098351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098374 */     // GIR_Coverage, 16764,
     /* 2098374 */     GIR_EraseRootFromParent_Done,
     /* 2098375 */   // Label 27798: @2098375
     /* 2098375 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2098466), // Rule ID 16765 //
     /* 2098380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2098383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2098391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2098394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2098397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098426 */     // MIs[0] round
     /* 2098426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098429 */     // MIs[0] policy
     /* 2098429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098439 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2098442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098465 */     // GIR_Coverage, 16765,
     /* 2098465 */     GIR_EraseRootFromParent_Done,
     /* 2098466 */   // Label 27799: @2098466
     /* 2098466 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2098557), // Rule ID 16768 //
     /* 2098471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2098474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098517 */     // MIs[0] round
     /* 2098517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098520 */     // MIs[0] policy
     /* 2098520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098530 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2098533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098556 */     // GIR_Coverage, 16768,
     /* 2098556 */     GIR_EraseRootFromParent_Done,
     /* 2098557 */   // Label 27800: @2098557
     /* 2098557 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2098648), // Rule ID 16769 //
     /* 2098562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2098565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2098579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2098582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2098604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098608 */     // MIs[0] round
     /* 2098608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098611 */     // MIs[0] policy
     /* 2098611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098621 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2098624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098647 */     // GIR_Coverage, 16769,
     /* 2098647 */     GIR_EraseRootFromParent_Done,
     /* 2098648 */   // Label 27801: @2098648
     /* 2098648 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2098739), // Rule ID 16772 //
     /* 2098653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2098656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2098664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2098667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2098695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098699 */     // MIs[0] round
     /* 2098699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098702 */     // MIs[0] policy
     /* 2098702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098712 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2098715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098738 */     // GIR_Coverage, 16772,
     /* 2098738 */     GIR_EraseRootFromParent_Done,
     /* 2098739 */   // Label 27802: @2098739
     /* 2098739 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2098830), // Rule ID 16773 //
     /* 2098744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2098747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2098755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2098758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2098764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2098786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098790 */     // MIs[0] round
     /* 2098790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098793 */     // MIs[0] policy
     /* 2098793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098803 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2098806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098829 */     // GIR_Coverage, 16773,
     /* 2098829 */     GIR_EraseRootFromParent_Done,
     /* 2098830 */   // Label 27803: @2098830
     /* 2098830 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2098921), // Rule ID 16776 //
     /* 2098835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2098838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2098852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098881 */     // MIs[0] round
     /* 2098881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098884 */     // MIs[0] policy
     /* 2098884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098894 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2098897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098920 */     // GIR_Coverage, 16776,
     /* 2098920 */     GIR_EraseRootFromParent_Done,
     /* 2098921 */   // Label 27804: @2098921
     /* 2098921 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2099012), // Rule ID 16777 //
     /* 2098926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2098929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2098934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2098943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098972 */     // MIs[0] round
     /* 2098972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098975 */     // MIs[0] policy
     /* 2098975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098985 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2098988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099011 */     // GIR_Coverage, 16777,
     /* 2099011 */     GIR_EraseRootFromParent_Done,
     /* 2099012 */   // Label 27805: @2099012
     /* 2099012 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2099103), // Rule ID 16780 //
     /* 2099017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2099020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2099028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2099031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099063 */     // MIs[0] round
     /* 2099063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099066 */     // MIs[0] policy
     /* 2099066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099076 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2099079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099102 */     // GIR_Coverage, 16780,
     /* 2099102 */     GIR_EraseRootFromParent_Done,
     /* 2099103 */   // Label 27806: @2099103
     /* 2099103 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2099194), // Rule ID 16781 //
     /* 2099108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2099111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2099119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2099122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099154 */     // MIs[0] round
     /* 2099154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099157 */     // MIs[0] policy
     /* 2099157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099167 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2099170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099193 */     // GIR_Coverage, 16781,
     /* 2099193 */     GIR_EraseRootFromParent_Done,
     /* 2099194 */   // Label 27807: @2099194
     /* 2099194 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2099285), // Rule ID 16784 //
     /* 2099199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2099202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2099210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2099213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2099216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2099222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2099229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099245 */     // MIs[0] round
     /* 2099245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099248 */     // MIs[0] policy
     /* 2099248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2099261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099284 */     // GIR_Coverage, 16784,
     /* 2099284 */     GIR_EraseRootFromParent_Done,
     /* 2099285 */   // Label 27808: @2099285
     /* 2099285 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2099376), // Rule ID 16785 //
     /* 2099290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2099293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2099301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2099304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2099307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2099313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2099320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099336 */     // MIs[0] round
     /* 2099336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099339 */     // MIs[0] policy
     /* 2099339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099349 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2099352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099375 */     // GIR_Coverage, 16785,
     /* 2099375 */     GIR_EraseRootFromParent_Done,
     /* 2099376 */   // Label 27809: @2099376
     /* 2099376 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2099467), // Rule ID 16788 //
     /* 2099381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2099384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2099398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099427 */     // MIs[0] round
     /* 2099427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099430 */     // MIs[0] policy
     /* 2099430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2099443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099466 */     // GIR_Coverage, 16788,
     /* 2099466 */     GIR_EraseRootFromParent_Done,
     /* 2099467 */   // Label 27810: @2099467
     /* 2099467 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2099558), // Rule ID 16789 //
     /* 2099472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2099475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2099483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2099486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2099489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099518 */     // MIs[0] round
     /* 2099518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099521 */     // MIs[0] policy
     /* 2099521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099531 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2099534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099557 */     // GIR_Coverage, 16789,
     /* 2099557 */     GIR_EraseRootFromParent_Done,
     /* 2099558 */   // Label 27811: @2099558
     /* 2099558 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2099649), // Rule ID 16792 //
     /* 2099563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2099566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2099580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099609 */     // MIs[0] round
     /* 2099609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099612 */     // MIs[0] policy
     /* 2099612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099622 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2099625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099648 */     // GIR_Coverage, 16792,
     /* 2099648 */     GIR_EraseRootFromParent_Done,
     /* 2099649 */   // Label 27812: @2099649
     /* 2099649 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2099740), // Rule ID 16793 //
     /* 2099654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2099657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2099665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2099668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2099671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099700 */     // MIs[0] round
     /* 2099700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099703 */     // MIs[0] policy
     /* 2099703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099713 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2099716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099739 */     // GIR_Coverage, 16793,
     /* 2099739 */     GIR_EraseRootFromParent_Done,
     /* 2099740 */   // Label 27813: @2099740
     /* 2099740 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2099831), // Rule ID 16796 //
     /* 2099745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2099748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2099756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2099759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2099762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2099775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099791 */     // MIs[0] round
     /* 2099791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099794 */     // MIs[0] policy
     /* 2099794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099804 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2099807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099830 */     // GIR_Coverage, 16796,
     /* 2099830 */     GIR_EraseRootFromParent_Done,
     /* 2099831 */   // Label 27814: @2099831
     /* 2099831 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2099922), // Rule ID 16797 //
     /* 2099836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2099839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2099847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2099850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2099853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2099866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099882 */     // MIs[0] round
     /* 2099882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099885 */     // MIs[0] policy
     /* 2099885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099895 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2099898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099921 */     // GIR_Coverage, 16797,
     /* 2099921 */     GIR_EraseRootFromParent_Done,
     /* 2099922 */   // Label 27815: @2099922
     /* 2099922 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2100013), // Rule ID 16800 //
     /* 2099927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2099930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2099935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2099938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2099941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2099944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2099969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099973 */     // MIs[0] round
     /* 2099973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099976 */     // MIs[0] policy
     /* 2099976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2099989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100012 */     // GIR_Coverage, 16800,
     /* 2100012 */     GIR_EraseRootFromParent_Done,
     /* 2100013 */   // Label 27816: @2100013
     /* 2100013 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2100104), // Rule ID 16801 //
     /* 2100018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2100021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2100026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2100029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2100032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2100035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2100060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100064 */     // MIs[0] round
     /* 2100064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100067 */     // MIs[0] policy
     /* 2100067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100077 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2100080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100103 */     // GIR_Coverage, 16801,
     /* 2100103 */     GIR_EraseRootFromParent_Done,
     /* 2100104 */   // Label 27817: @2100104
     /* 2100104 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2100195), // Rule ID 16804 //
     /* 2100109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2100112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2100117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2100120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2100123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2100126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2100151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100155 */     // MIs[0] round
     /* 2100155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100158 */     // MIs[0] policy
     /* 2100158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100168 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2100171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100194 */     // GIR_Coverage, 16804,
     /* 2100194 */     GIR_EraseRootFromParent_Done,
     /* 2100195 */   // Label 27818: @2100195
     /* 2100195 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2100286), // Rule ID 16805 //
     /* 2100200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2100203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2100208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2100211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2100214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2100217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2100242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100246 */     // MIs[0] round
     /* 2100246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100249 */     // MIs[0] policy
     /* 2100249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100259 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2100262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100285 */     // GIR_Coverage, 16805,
     /* 2100285 */     GIR_EraseRootFromParent_Done,
     /* 2100286 */   // Label 27819: @2100286
     /* 2100286 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2100377), // Rule ID 16808 //
     /* 2100291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2100294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2100299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2100302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2100305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2100308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2100333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100337 */     // MIs[0] round
     /* 2100337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100340 */     // MIs[0] policy
     /* 2100340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100350 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2100353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100376 */     // GIR_Coverage, 16808,
     /* 2100376 */     GIR_EraseRootFromParent_Done,
     /* 2100377 */   // Label 27820: @2100377
     /* 2100377 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2100468), // Rule ID 16809 //
     /* 2100382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2100385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2100390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2100393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2100396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2100399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2100424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100428 */     // MIs[0] round
     /* 2100428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100431 */     // MIs[0] policy
     /* 2100431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100441 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2100444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2100464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100467 */     // GIR_Coverage, 16809,
     /* 2100467 */     GIR_EraseRootFromParent_Done,
     /* 2100468 */   // Label 27821: @2100468
     /* 2100468 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2100559), // Rule ID 16812 //
     /* 2100473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2100476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2100490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2100493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100519 */     // MIs[0] round
     /* 2100519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100522 */     // MIs[0] policy
     /* 2100522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100532 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2100535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100558 */     // GIR_Coverage, 16812,
     /* 2100558 */     GIR_EraseRootFromParent_Done,
     /* 2100559 */   // Label 27822: @2100559
     /* 2100559 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2100650), // Rule ID 16813 //
     /* 2100564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2100567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2100581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2100584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100610 */     // MIs[0] round
     /* 2100610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100613 */     // MIs[0] policy
     /* 2100613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100623 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2100626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100649 */     // GIR_Coverage, 16813,
     /* 2100649 */     GIR_EraseRootFromParent_Done,
     /* 2100650 */   // Label 27823: @2100650
     /* 2100650 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2100741), // Rule ID 16816 //
     /* 2100655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2100658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2100672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2100675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100701 */     // MIs[0] round
     /* 2100701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100704 */     // MIs[0] policy
     /* 2100704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100714 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2100717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100740 */     // GIR_Coverage, 16816,
     /* 2100740 */     GIR_EraseRootFromParent_Done,
     /* 2100741 */   // Label 27824: @2100741
     /* 2100741 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2100832), // Rule ID 16817 //
     /* 2100746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2100749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2100763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2100766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100792 */     // MIs[0] round
     /* 2100792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100795 */     // MIs[0] policy
     /* 2100795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100805 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2100808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100831 */     // GIR_Coverage, 16817,
     /* 2100831 */     GIR_EraseRootFromParent_Done,
     /* 2100832 */   // Label 27825: @2100832
     /* 2100832 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2100923), // Rule ID 16820 //
     /* 2100837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2100840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2100848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2100851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2100857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100883 */     // MIs[0] round
     /* 2100883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100886 */     // MIs[0] policy
     /* 2100886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2100899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100922 */     // GIR_Coverage, 16820,
     /* 2100922 */     GIR_EraseRootFromParent_Done,
     /* 2100923 */   // Label 27826: @2100923
     /* 2100923 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2101014), // Rule ID 16821 //
     /* 2100928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2100931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2100939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2100942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2100948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100974 */     // MIs[0] round
     /* 2100974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100977 */     // MIs[0] policy
     /* 2100977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100987 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2100990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101013 */     // GIR_Coverage, 16821,
     /* 2101013 */     GIR_EraseRootFromParent_Done,
     /* 2101014 */   // Label 27827: @2101014
     /* 2101014 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2101105), // Rule ID 16824 //
     /* 2101019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2101036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2101039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101065 */     // MIs[0] round
     /* 2101065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101068 */     // MIs[0] policy
     /* 2101068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101078 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2101081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101104 */     // GIR_Coverage, 16824,
     /* 2101104 */     GIR_EraseRootFromParent_Done,
     /* 2101105 */   // Label 27828: @2101105
     /* 2101105 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2101196), // Rule ID 16825 //
     /* 2101110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2101121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2101124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2101127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2101130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101156 */     // MIs[0] round
     /* 2101156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101159 */     // MIs[0] policy
     /* 2101159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101169 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2101172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101195 */     // GIR_Coverage, 16825,
     /* 2101195 */     GIR_EraseRootFromParent_Done,
     /* 2101196 */   // Label 27829: @2101196
     /* 2101196 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2101287), // Rule ID 16828 //
     /* 2101201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2101204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2101218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2101221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101247 */     // MIs[0] round
     /* 2101247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101250 */     // MIs[0] policy
     /* 2101250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101260 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2101263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101286 */     // GIR_Coverage, 16828,
     /* 2101286 */     GIR_EraseRootFromParent_Done,
     /* 2101287 */   // Label 27830: @2101287
     /* 2101287 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2101378), // Rule ID 16829 //
     /* 2101292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2101295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2101309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2101312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101338 */     // MIs[0] round
     /* 2101338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101341 */     // MIs[0] policy
     /* 2101341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101351 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2101354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101377 */     // GIR_Coverage, 16829,
     /* 2101377 */     GIR_EraseRootFromParent_Done,
     /* 2101378 */   // Label 27831: @2101378
     /* 2101378 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2101469), // Rule ID 16832 //
     /* 2101383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2101386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2101394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2101397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2101403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101429 */     // MIs[0] round
     /* 2101429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101432 */     // MIs[0] policy
     /* 2101432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101442 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2101445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101468 */     // GIR_Coverage, 16832,
     /* 2101468 */     GIR_EraseRootFromParent_Done,
     /* 2101469 */   // Label 27832: @2101469
     /* 2101469 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2101560), // Rule ID 16833 //
     /* 2101474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2101477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2101485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2101488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2101494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101520 */     // MIs[0] round
     /* 2101520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101523 */     // MIs[0] policy
     /* 2101523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101533 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2101536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101559 */     // GIR_Coverage, 16833,
     /* 2101559 */     GIR_EraseRootFromParent_Done,
     /* 2101560 */   // Label 27833: @2101560
     /* 2101560 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2101651), // Rule ID 16836 //
     /* 2101565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2101582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2101585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101611 */     // MIs[0] round
     /* 2101611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101614 */     // MIs[0] policy
     /* 2101614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101624 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2101627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101650 */     // GIR_Coverage, 16836,
     /* 2101650 */     GIR_EraseRootFromParent_Done,
     /* 2101651 */   // Label 27834: @2101651
     /* 2101651 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2101742), // Rule ID 16837 //
     /* 2101656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2101667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2101670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2101673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2101676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101702 */     // MIs[0] round
     /* 2101702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101705 */     // MIs[0] policy
     /* 2101705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101715 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2101718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101741 */     // GIR_Coverage, 16837,
     /* 2101741 */     GIR_EraseRootFromParent_Done,
     /* 2101742 */   // Label 27835: @2101742
     /* 2101742 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2101833), // Rule ID 16840 //
     /* 2101747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2101764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2101767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101793 */     // MIs[0] round
     /* 2101793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101796 */     // MIs[0] policy
     /* 2101796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101806 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2101809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101832 */     // GIR_Coverage, 16840,
     /* 2101832 */     GIR_EraseRootFromParent_Done,
     /* 2101833 */   // Label 27836: @2101833
     /* 2101833 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2101924), // Rule ID 16841 //
     /* 2101838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2101855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2101858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101884 */     // MIs[0] round
     /* 2101884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101887 */     // MIs[0] policy
     /* 2101887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101897 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2101900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101923 */     // GIR_Coverage, 16841,
     /* 2101923 */     GIR_EraseRootFromParent_Done,
     /* 2101924 */   // Label 27837: @2101924
     /* 2101924 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2102015), // Rule ID 16844 //
     /* 2101929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2101940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2101943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2101946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2101949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2101952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2101959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101975 */     // MIs[0] round
     /* 2101975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101978 */     // MIs[0] policy
     /* 2101978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101988 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2101991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102014 */     // GIR_Coverage, 16844,
     /* 2102014 */     GIR_EraseRootFromParent_Done,
     /* 2102015 */   // Label 27838: @2102015
     /* 2102015 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2102106), // Rule ID 16845 //
     /* 2102020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2102031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2102034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2102037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2102040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2102043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2102050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102066 */     // MIs[0] round
     /* 2102066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102069 */     // MIs[0] policy
     /* 2102069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102079 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2102082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102105 */     // GIR_Coverage, 16845,
     /* 2102105 */     GIR_EraseRootFromParent_Done,
     /* 2102106 */   // Label 27839: @2102106
     /* 2102106 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2102197), // Rule ID 16848 //
     /* 2102111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2102128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2102131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102157 */     // MIs[0] round
     /* 2102157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102160 */     // MIs[0] policy
     /* 2102160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2102173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102196 */     // GIR_Coverage, 16848,
     /* 2102196 */     GIR_EraseRootFromParent_Done,
     /* 2102197 */   // Label 27840: @2102197
     /* 2102197 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2102288), // Rule ID 16849 //
     /* 2102202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2102213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2102216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2102219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2102222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102248 */     // MIs[0] round
     /* 2102248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102251 */     // MIs[0] policy
     /* 2102251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102261 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2102264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102287 */     // GIR_Coverage, 16849,
     /* 2102287 */     GIR_EraseRootFromParent_Done,
     /* 2102288 */   // Label 27841: @2102288
     /* 2102288 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2102379), // Rule ID 16852 //
     /* 2102293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2102310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2102313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102339 */     // MIs[0] round
     /* 2102339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102342 */     // MIs[0] policy
     /* 2102342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102352 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2102355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102378 */     // GIR_Coverage, 16852,
     /* 2102378 */     GIR_EraseRootFromParent_Done,
     /* 2102379 */   // Label 27842: @2102379
     /* 2102379 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2102470), // Rule ID 16853 //
     /* 2102384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2102395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2102398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2102401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2102404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102430 */     // MIs[0] round
     /* 2102430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102433 */     // MIs[0] policy
     /* 2102433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102443 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2102446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102469 */     // GIR_Coverage, 16853,
     /* 2102469 */     GIR_EraseRootFromParent_Done,
     /* 2102470 */   // Label 27843: @2102470
     /* 2102470 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2102561), // Rule ID 16856 //
     /* 2102475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2102486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2102489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2102492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2102495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2102498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2102505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102521 */     // MIs[0] round
     /* 2102521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102524 */     // MIs[0] policy
     /* 2102524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102534 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2102537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102560 */     // GIR_Coverage, 16856,
     /* 2102560 */     GIR_EraseRootFromParent_Done,
     /* 2102561 */   // Label 27844: @2102561
     /* 2102561 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2102652), // Rule ID 16857 //
     /* 2102566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2102577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2102580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2102583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2102586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2102589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2102596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2102608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102612 */     // MIs[0] round
     /* 2102612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102615 */     // MIs[0] policy
     /* 2102615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102625 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2102628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102651 */     // GIR_Coverage, 16857,
     /* 2102651 */     GIR_EraseRootFromParent_Done,
     /* 2102652 */   // Label 27845: @2102652
     /* 2102652 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2102743), // Rule ID 16860 //
     /* 2102657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2102660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2102668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2102671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2102674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2102677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102703 */     // MIs[0] round
     /* 2102703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102706 */     // MIs[0] policy
     /* 2102706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2102719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102742 */     // GIR_Coverage, 16860,
     /* 2102742 */     GIR_EraseRootFromParent_Done,
     /* 2102743 */   // Label 27846: @2102743
     /* 2102743 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2102834), // Rule ID 16861 //
     /* 2102748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2102751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2102759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2102762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2102765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2102768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102794 */     // MIs[0] round
     /* 2102794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102797 */     // MIs[0] policy
     /* 2102797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2102810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102833 */     // GIR_Coverage, 16861,
     /* 2102833 */     GIR_EraseRootFromParent_Done,
     /* 2102834 */   // Label 27847: @2102834
     /* 2102834 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2102925), // Rule ID 16864 //
     /* 2102839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2102842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2102850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2102853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2102859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102885 */     // MIs[0] round
     /* 2102885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102888 */     // MIs[0] policy
     /* 2102888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102898 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2102901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102924 */     // GIR_Coverage, 16864,
     /* 2102924 */     GIR_EraseRootFromParent_Done,
     /* 2102925 */   // Label 27848: @2102925
     /* 2102925 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2103016), // Rule ID 16865 //
     /* 2102930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2102933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2102938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2102941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2102944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2102947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2102950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102976 */     // MIs[0] round
     /* 2102976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102979 */     // MIs[0] policy
     /* 2102979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102989 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2102992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103015 */     // GIR_Coverage, 16865,
     /* 2103015 */     GIR_EraseRootFromParent_Done,
     /* 2103016 */   // Label 27849: @2103016
     /* 2103016 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2103107), // Rule ID 16868 //
     /* 2103021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2103024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2103032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2103035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2103038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2103041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103067 */     // MIs[0] round
     /* 2103067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103070 */     // MIs[0] policy
     /* 2103070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103080 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2103083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103106 */     // GIR_Coverage, 16868,
     /* 2103106 */     GIR_EraseRootFromParent_Done,
     /* 2103107 */   // Label 27850: @2103107
     /* 2103107 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2103198), // Rule ID 16869 //
     /* 2103112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2103115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2103123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2103126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2103129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2103132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103158 */     // MIs[0] round
     /* 2103158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103161 */     // MIs[0] policy
     /* 2103161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103171 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2103174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103197 */     // GIR_Coverage, 16869,
     /* 2103197 */     GIR_EraseRootFromParent_Done,
     /* 2103198 */   // Label 27851: @2103198
     /* 2103198 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2103289), // Rule ID 16872 //
     /* 2103203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2103214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2103217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2103220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103249 */     // MIs[0] round
     /* 2103249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103252 */     // MIs[0] policy
     /* 2103252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103262 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2103265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103288 */     // GIR_Coverage, 16872,
     /* 2103288 */     GIR_EraseRootFromParent_Done,
     /* 2103289 */   // Label 27852: @2103289
     /* 2103289 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2103380), // Rule ID 16873 //
     /* 2103294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2103305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2103308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2103311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103340 */     // MIs[0] round
     /* 2103340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103343 */     // MIs[0] policy
     /* 2103343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103353 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2103356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103379 */     // GIR_Coverage, 16873,
     /* 2103379 */     GIR_EraseRootFromParent_Done,
     /* 2103380 */   // Label 27853: @2103380
     /* 2103380 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2103471), // Rule ID 16876 //
     /* 2103385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2103396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2103399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2103402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103431 */     // MIs[0] round
     /* 2103431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103434 */     // MIs[0] policy
     /* 2103434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103444 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2103447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103470 */     // GIR_Coverage, 16876,
     /* 2103470 */     GIR_EraseRootFromParent_Done,
     /* 2103471 */   // Label 27854: @2103471
     /* 2103471 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2103562), // Rule ID 16877 //
     /* 2103476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2103487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2103490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2103493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103522 */     // MIs[0] round
     /* 2103522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103525 */     // MIs[0] policy
     /* 2103525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103535 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2103538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103561 */     // GIR_Coverage, 16877,
     /* 2103561 */     GIR_EraseRootFromParent_Done,
     /* 2103562 */   // Label 27855: @2103562
     /* 2103562 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2103653), // Rule ID 16880 //
     /* 2103567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2103578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2103581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2103584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103613 */     // MIs[0] round
     /* 2103613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103616 */     // MIs[0] policy
     /* 2103616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103626 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2103629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103652 */     // GIR_Coverage, 16880,
     /* 2103652 */     GIR_EraseRootFromParent_Done,
     /* 2103653 */   // Label 27856: @2103653
     /* 2103653 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2103744), // Rule ID 16881 //
     /* 2103658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2103669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2103672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2103675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2103681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103704 */     // MIs[0] round
     /* 2103704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103707 */     // MIs[0] policy
     /* 2103707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103717 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2103720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103743 */     // GIR_Coverage, 16881,
     /* 2103743 */     GIR_EraseRootFromParent_Done,
     /* 2103744 */   // Label 27857: @2103744
     /* 2103744 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2103835), // Rule ID 16884 //
     /* 2103749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2103760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2103763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103795 */     // MIs[0] round
     /* 2103795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103798 */     // MIs[0] policy
     /* 2103798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103808 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2103811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103834 */     // GIR_Coverage, 16884,
     /* 2103834 */     GIR_EraseRootFromParent_Done,
     /* 2103835 */   // Label 27858: @2103835
     /* 2103835 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2103926), // Rule ID 16885 //
     /* 2103840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2103851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2103854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2103857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103886 */     // MIs[0] round
     /* 2103886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103889 */     // MIs[0] policy
     /* 2103889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2103902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103925 */     // GIR_Coverage, 16885,
     /* 2103925 */     GIR_EraseRootFromParent_Done,
     /* 2103926 */   // Label 27859: @2103926
     /* 2103926 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2104017), // Rule ID 16888 //
     /* 2103931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2103939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2103942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2103945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2103948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2103961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2103969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103977 */     // MIs[0] round
     /* 2103977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103980 */     // MIs[0] policy
     /* 2103980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103990 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2103993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104016 */     // GIR_Coverage, 16888,
     /* 2104016 */     GIR_EraseRootFromParent_Done,
     /* 2104017 */   // Label 27860: @2104017
     /* 2104017 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2104108), // Rule ID 16889 //
     /* 2104022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2104033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2104036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2104039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2104064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104068 */     // MIs[0] round
     /* 2104068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104071 */     // MIs[0] policy
     /* 2104071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104081 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2104084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104107 */     // GIR_Coverage, 16889,
     /* 2104107 */     GIR_EraseRootFromParent_Done,
     /* 2104108 */   // Label 27861: @2104108
     /* 2104108 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2104199), // Rule ID 16892 //
     /* 2104113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2104124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2104127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2104130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2104155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104159 */     // MIs[0] round
     /* 2104159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104162 */     // MIs[0] policy
     /* 2104162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104172 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2104175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104198 */     // GIR_Coverage, 16892,
     /* 2104198 */     GIR_EraseRootFromParent_Done,
     /* 2104199 */   // Label 27862: @2104199
     /* 2104199 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2104290), // Rule ID 16893 //
     /* 2104204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2104215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2104218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2104221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2104246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104250 */     // MIs[0] round
     /* 2104250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104253 */     // MIs[0] policy
     /* 2104253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104263 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2104266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104289 */     // GIR_Coverage, 16893,
     /* 2104289 */     GIR_EraseRootFromParent_Done,
     /* 2104290 */   // Label 27863: @2104290
     /* 2104290 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2104381), // Rule ID 16896 //
     /* 2104295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2104306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2104309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2104312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104341 */     // MIs[0] round
     /* 2104341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104344 */     // MIs[0] policy
     /* 2104344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2104357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104380 */     // GIR_Coverage, 16896,
     /* 2104380 */     GIR_EraseRootFromParent_Done,
     /* 2104381 */   // Label 27864: @2104381
     /* 2104381 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2104472), // Rule ID 16897 //
     /* 2104386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2104397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2104400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2104403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104432 */     // MIs[0] round
     /* 2104432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104435 */     // MIs[0] policy
     /* 2104435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104445 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2104448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104471 */     // GIR_Coverage, 16897,
     /* 2104471 */     GIR_EraseRootFromParent_Done,
     /* 2104472 */   // Label 27865: @2104472
     /* 2104472 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2104563), // Rule ID 16900 //
     /* 2104477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2104488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2104491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2104494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104523 */     // MIs[0] round
     /* 2104523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104526 */     // MIs[0] policy
     /* 2104526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104536 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2104539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104562 */     // GIR_Coverage, 16900,
     /* 2104562 */     GIR_EraseRootFromParent_Done,
     /* 2104563 */   // Label 27866: @2104563
     /* 2104563 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2104654), // Rule ID 16901 //
     /* 2104568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2104579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2104582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2104585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104614 */     // MIs[0] round
     /* 2104614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104617 */     // MIs[0] policy
     /* 2104617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104627 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2104630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104653 */     // GIR_Coverage, 16901,
     /* 2104653 */     GIR_EraseRootFromParent_Done,
     /* 2104654 */   // Label 27867: @2104654
     /* 2104654 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2104745), // Rule ID 16904 //
     /* 2104659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2104670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2104673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2104676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2104682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104705 */     // MIs[0] round
     /* 2104705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104708 */     // MIs[0] policy
     /* 2104708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104718 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2104721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104744 */     // GIR_Coverage, 16904,
     /* 2104744 */     GIR_EraseRootFromParent_Done,
     /* 2104745 */   // Label 27868: @2104745
     /* 2104745 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2104836), // Rule ID 16905 //
     /* 2104750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2104761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2104764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2104767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2104773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104796 */     // MIs[0] round
     /* 2104796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104799 */     // MIs[0] policy
     /* 2104799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104809 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2104812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104835 */     // GIR_Coverage, 16905,
     /* 2104835 */     GIR_EraseRootFromParent_Done,
     /* 2104836 */   // Label 27869: @2104836
     /* 2104836 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2104927), // Rule ID 16908 //
     /* 2104841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2104883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104887 */     // MIs[0] round
     /* 2104887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104890 */     // MIs[0] policy
     /* 2104890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2104903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104926 */     // GIR_Coverage, 16908,
     /* 2104926 */     GIR_EraseRootFromParent_Done,
     /* 2104927 */   // Label 27870: @2104927
     /* 2104927 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2105018), // Rule ID 16909 //
     /* 2104932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2104935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2104940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2104949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2104952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2104974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104978 */     // MIs[0] round
     /* 2104978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104981 */     // MIs[0] policy
     /* 2104981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2104994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105017 */     // GIR_Coverage, 16909,
     /* 2105017 */     GIR_EraseRootFromParent_Done,
     /* 2105018 */   // Label 27871: @2105018
     /* 2105018 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2105109), // Rule ID 16912 //
     /* 2105023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2105034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2105037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2105040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105069 */     // MIs[0] round
     /* 2105069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105072 */     // MIs[0] policy
     /* 2105072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105082 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2105085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105108 */     // GIR_Coverage, 16912,
     /* 2105108 */     GIR_EraseRootFromParent_Done,
     /* 2105109 */   // Label 27872: @2105109
     /* 2105109 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2105200), // Rule ID 16913 //
     /* 2105114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2105125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2105128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2105131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105160 */     // MIs[0] round
     /* 2105160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105163 */     // MIs[0] policy
     /* 2105163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105173 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2105176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105199 */     // GIR_Coverage, 16913,
     /* 2105199 */     GIR_EraseRootFromParent_Done,
     /* 2105200 */   // Label 27873: @2105200
     /* 2105200 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2105291), // Rule ID 16916 //
     /* 2105205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2105216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2105219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2105222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105251 */     // MIs[0] round
     /* 2105251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105254 */     // MIs[0] policy
     /* 2105254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105264 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2105267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105290 */     // GIR_Coverage, 16916,
     /* 2105290 */     GIR_EraseRootFromParent_Done,
     /* 2105291 */   // Label 27874: @2105291
     /* 2105291 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2105382), // Rule ID 16917 //
     /* 2105296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2105307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2105310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2105313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105342 */     // MIs[0] round
     /* 2105342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105345 */     // MIs[0] policy
     /* 2105345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105355 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2105358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105381 */     // GIR_Coverage, 16917,
     /* 2105381 */     GIR_EraseRootFromParent_Done,
     /* 2105382 */   // Label 27875: @2105382
     /* 2105382 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2105473), // Rule ID 16920 //
     /* 2105387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2105390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2105398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2105401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2105404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105433 */     // MIs[0] round
     /* 2105433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105436 */     // MIs[0] policy
     /* 2105436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105446 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2105449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105472 */     // GIR_Coverage, 16920,
     /* 2105472 */     GIR_EraseRootFromParent_Done,
     /* 2105473 */   // Label 27876: @2105473
     /* 2105473 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2105564), // Rule ID 16921 //
     /* 2105478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2105489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2105492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2105495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105524 */     // MIs[0] round
     /* 2105524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105527 */     // MIs[0] policy
     /* 2105527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105537 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2105540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105563 */     // GIR_Coverage, 16921,
     /* 2105563 */     GIR_EraseRootFromParent_Done,
     /* 2105564 */   // Label 27877: @2105564
     /* 2105564 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2105655), // Rule ID 16924 //
     /* 2105569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2105572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2105580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2105583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2105586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105615 */     // MIs[0] round
     /* 2105615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105618 */     // MIs[0] policy
     /* 2105618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105628 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2105631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105654 */     // GIR_Coverage, 16924,
     /* 2105654 */     GIR_EraseRootFromParent_Done,
     /* 2105655 */   // Label 27878: @2105655
     /* 2105655 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2105746), // Rule ID 16925 //
     /* 2105660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2105671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2105674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2105677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105706 */     // MIs[0] round
     /* 2105706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105709 */     // MIs[0] policy
     /* 2105709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105719 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2105722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105745 */     // GIR_Coverage, 16925,
     /* 2105745 */     GIR_EraseRootFromParent_Done,
     /* 2105746 */   // Label 27879: @2105746
     /* 2105746 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2105837), // Rule ID 16928 //
     /* 2105751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2105754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105797 */     // MIs[0] round
     /* 2105797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105800 */     // MIs[0] policy
     /* 2105800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2105813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105836 */     // GIR_Coverage, 16928,
     /* 2105836 */     GIR_EraseRootFromParent_Done,
     /* 2105837 */   // Label 27880: @2105837
     /* 2105837 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2105928), // Rule ID 16929 //
     /* 2105842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2105850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2105859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105888 */     // MIs[0] round
     /* 2105888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105891 */     // MIs[0] policy
     /* 2105891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105901 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2105904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105927 */     // GIR_Coverage, 16929,
     /* 2105927 */     GIR_EraseRootFromParent_Done,
     /* 2105928 */   // Label 27881: @2105928
     /* 2105928 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2106019), // Rule ID 16932 //
     /* 2105933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2105941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2105944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2105947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105979 */     // MIs[0] round
     /* 2105979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105982 */     // MIs[0] policy
     /* 2105982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105992 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2105995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106018 */     // GIR_Coverage, 16932,
     /* 2106018 */     GIR_EraseRootFromParent_Done,
     /* 2106019 */   // Label 27882: @2106019
     /* 2106019 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2106110), // Rule ID 16933 //
     /* 2106024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2106035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2106038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2106041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106070 */     // MIs[0] round
     /* 2106070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106073 */     // MIs[0] policy
     /* 2106073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106083 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2106086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106109 */     // GIR_Coverage, 16933,
     /* 2106109 */     GIR_EraseRootFromParent_Done,
     /* 2106110 */   // Label 27883: @2106110
     /* 2106110 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2106201), // Rule ID 16936 //
     /* 2106115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2106126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2106129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2106132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106161 */     // MIs[0] round
     /* 2106161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106164 */     // MIs[0] policy
     /* 2106164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106174 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2106177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106200 */     // GIR_Coverage, 16936,
     /* 2106200 */     GIR_EraseRootFromParent_Done,
     /* 2106201 */   // Label 27884: @2106201
     /* 2106201 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2106292), // Rule ID 16937 //
     /* 2106206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2106217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2106220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2106223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106252 */     // MIs[0] round
     /* 2106252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106255 */     // MIs[0] policy
     /* 2106255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106265 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2106268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106291 */     // GIR_Coverage, 16937,
     /* 2106291 */     GIR_EraseRootFromParent_Done,
     /* 2106292 */   // Label 27885: @2106292
     /* 2106292 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2106383), // Rule ID 16940 //
     /* 2106297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2106308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2106311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106343 */     // MIs[0] round
     /* 2106343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106346 */     // MIs[0] policy
     /* 2106346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106356 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2106359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106382 */     // GIR_Coverage, 16940,
     /* 2106382 */     GIR_EraseRootFromParent_Done,
     /* 2106383 */   // Label 27886: @2106383
     /* 2106383 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2106474), // Rule ID 16941 //
     /* 2106388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2106399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2106402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106434 */     // MIs[0] round
     /* 2106434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106437 */     // MIs[0] policy
     /* 2106437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106447 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2106450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106473 */     // GIR_Coverage, 16941,
     /* 2106473 */     GIR_EraseRootFromParent_Done,
     /* 2106474 */   // Label 27887: @2106474
     /* 2106474 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2106565), // Rule ID 16944 //
     /* 2106479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2106490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2106493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106525 */     // MIs[0] round
     /* 2106525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106528 */     // MIs[0] policy
     /* 2106528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106538 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2106541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106564 */     // GIR_Coverage, 16944,
     /* 2106564 */     GIR_EraseRootFromParent_Done,
     /* 2106565 */   // Label 27888: @2106565
     /* 2106565 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2106656), // Rule ID 16945 //
     /* 2106570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2106581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2106584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106616 */     // MIs[0] round
     /* 2106616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106619 */     // MIs[0] policy
     /* 2106619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106629 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2106632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106655 */     // GIR_Coverage, 16945,
     /* 2106655 */     GIR_EraseRootFromParent_Done,
     /* 2106656 */   // Label 27889: @2106656
     /* 2106656 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2106747), // Rule ID 16948 //
     /* 2106661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2106678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106707 */     // MIs[0] round
     /* 2106707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106710 */     // MIs[0] policy
     /* 2106710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106720 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2106723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106746 */     // GIR_Coverage, 16948,
     /* 2106746 */     GIR_EraseRootFromParent_Done,
     /* 2106747 */   // Label 27890: @2106747
     /* 2106747 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2106838), // Rule ID 16949 //
     /* 2106752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2106769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106798 */     // MIs[0] round
     /* 2106798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106801 */     // MIs[0] policy
     /* 2106801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106811 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2106814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106837 */     // GIR_Coverage, 16949,
     /* 2106837 */     GIR_EraseRootFromParent_Done,
     /* 2106838 */   // Label 27891: @2106838
     /* 2106838 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2106929), // Rule ID 16952 //
     /* 2106843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106889 */     // MIs[0] round
     /* 2106889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106892 */     // MIs[0] policy
     /* 2106892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2106905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106928 */     // GIR_Coverage, 16952,
     /* 2106928 */     GIR_EraseRootFromParent_Done,
     /* 2106929 */   // Label 27892: @2106929
     /* 2106929 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2107020), // Rule ID 16953 //
     /* 2106934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2106942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2106951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106980 */     // MIs[0] round
     /* 2106980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106983 */     // MIs[0] policy
     /* 2106983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106993 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2106996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107019 */     // GIR_Coverage, 16953,
     /* 2107019 */     GIR_EraseRootFromParent_Done,
     /* 2107020 */   // Label 27893: @2107020
     /* 2107020 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2107111), // Rule ID 16956 //
     /* 2107025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2107036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2107039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2107042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107071 */     // MIs[0] round
     /* 2107071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107074 */     // MIs[0] policy
     /* 2107074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2107087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107110 */     // GIR_Coverage, 16956,
     /* 2107110 */     GIR_EraseRootFromParent_Done,
     /* 2107111 */   // Label 27894: @2107111
     /* 2107111 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2107202), // Rule ID 16957 //
     /* 2107116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2107127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2107130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2107133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107162 */     // MIs[0] round
     /* 2107162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107165 */     // MIs[0] policy
     /* 2107165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107175 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2107178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107201 */     // GIR_Coverage, 16957,
     /* 2107201 */     GIR_EraseRootFromParent_Done,
     /* 2107202 */   // Label 27895: @2107202
     /* 2107202 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2107293), // Rule ID 16960 //
     /* 2107207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2107218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2107221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2107224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107253 */     // MIs[0] round
     /* 2107253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107256 */     // MIs[0] policy
     /* 2107256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107266 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2107269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107292 */     // GIR_Coverage, 16960,
     /* 2107292 */     GIR_EraseRootFromParent_Done,
     /* 2107293 */   // Label 27896: @2107293
     /* 2107293 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2107384), // Rule ID 16961 //
     /* 2107298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2107309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2107312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2107315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107344 */     // MIs[0] round
     /* 2107344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107347 */     // MIs[0] policy
     /* 2107347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107357 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2107360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107383 */     // GIR_Coverage, 16961,
     /* 2107383 */     GIR_EraseRootFromParent_Done,
     /* 2107384 */   // Label 27897: @2107384
     /* 2107384 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2107475), // Rule ID 16964 //
     /* 2107389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2107400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2107403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2107406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2107412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107435 */     // MIs[0] round
     /* 2107435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107438 */     // MIs[0] policy
     /* 2107438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107448 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2107451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107474 */     // GIR_Coverage, 16964,
     /* 2107474 */     GIR_EraseRootFromParent_Done,
     /* 2107475 */   // Label 27898: @2107475
     /* 2107475 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2107566), // Rule ID 16965 //
     /* 2107480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2107491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2107494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2107497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2107500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2107503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2107522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107526 */     // MIs[0] round
     /* 2107526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107529 */     // MIs[0] policy
     /* 2107529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107539 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2107542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107565 */     // GIR_Coverage, 16965,
     /* 2107565 */     GIR_EraseRootFromParent_Done,
     /* 2107566 */   // Label 27899: @2107566
     /* 2107566 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2107657), // Rule ID 16968 //
     /* 2107571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2107582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2107585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107617 */     // MIs[0] round
     /* 2107617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107620 */     // MIs[0] policy
     /* 2107620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2107633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107656 */     // GIR_Coverage, 16968,
     /* 2107656 */     GIR_EraseRootFromParent_Done,
     /* 2107657 */   // Label 27900: @2107657
     /* 2107657 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2107748), // Rule ID 16969 //
     /* 2107662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2107673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2107676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107708 */     // MIs[0] round
     /* 2107708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107711 */     // MIs[0] policy
     /* 2107711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107721 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2107724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107747 */     // GIR_Coverage, 16969,
     /* 2107747 */     GIR_EraseRootFromParent_Done,
     /* 2107748 */   // Label 27901: @2107748
     /* 2107748 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2107839), // Rule ID 16972 //
     /* 2107753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107799 */     // MIs[0] round
     /* 2107799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107802 */     // MIs[0] policy
     /* 2107802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107812 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2107815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107838 */     // GIR_Coverage, 16972,
     /* 2107838 */     GIR_EraseRootFromParent_Done,
     /* 2107839 */   // Label 27902: @2107839
     /* 2107839 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2107930), // Rule ID 16973 //
     /* 2107844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2107855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2107858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107890 */     // MIs[0] round
     /* 2107890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107893 */     // MIs[0] policy
     /* 2107893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107903 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2107906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107929 */     // GIR_Coverage, 16973,
     /* 2107929 */     GIR_EraseRootFromParent_Done,
     /* 2107930 */   // Label 27903: @2107930
     /* 2107930 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2108021), // Rule ID 16976 //
     /* 2107935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2107943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2107946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2107949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2107952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2107958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107981 */     // MIs[0] round
     /* 2107981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107984 */     // MIs[0] policy
     /* 2107984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107994 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2107997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108020 */     // GIR_Coverage, 16976,
     /* 2108020 */     GIR_EraseRootFromParent_Done,
     /* 2108021 */   // Label 27904: @2108021
     /* 2108021 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2108112), // Rule ID 16977 //
     /* 2108026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2108037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2108040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2108043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2108046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2108068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108072 */     // MIs[0] round
     /* 2108072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108075 */     // MIs[0] policy
     /* 2108075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108085 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2108088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108111 */     // GIR_Coverage, 16977,
     /* 2108111 */     GIR_EraseRootFromParent_Done,
     /* 2108112 */   // Label 27905: @2108112
     /* 2108112 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2108203), // Rule ID 16980 //
     /* 2108117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2108128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2108131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2108134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108163 */     // MIs[0] round
     /* 2108163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108166 */     // MIs[0] policy
     /* 2108166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2108179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108202 */     // GIR_Coverage, 16980,
     /* 2108202 */     GIR_EraseRootFromParent_Done,
     /* 2108203 */   // Label 27906: @2108203
     /* 2108203 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2108294), // Rule ID 16981 //
     /* 2108208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2108219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2108222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2108225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108254 */     // MIs[0] round
     /* 2108254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108257 */     // MIs[0] policy
     /* 2108257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108267 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2108270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108293 */     // GIR_Coverage, 16981,
     /* 2108293 */     GIR_EraseRootFromParent_Done,
     /* 2108294 */   // Label 27907: @2108294
     /* 2108294 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2108385), // Rule ID 16984 //
     /* 2108299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2108316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108345 */     // MIs[0] round
     /* 2108345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108348 */     // MIs[0] policy
     /* 2108348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108358 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2108361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108384 */     // GIR_Coverage, 16984,
     /* 2108384 */     GIR_EraseRootFromParent_Done,
     /* 2108385 */   // Label 27908: @2108385
     /* 2108385 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2108476), // Rule ID 16985 //
     /* 2108390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2108407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108436 */     // MIs[0] round
     /* 2108436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108439 */     // MIs[0] policy
     /* 2108439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108449 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2108452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108475 */     // GIR_Coverage, 16985,
     /* 2108475 */     GIR_EraseRootFromParent_Done,
     /* 2108476 */   // Label 27909: @2108476
     /* 2108476 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2108567), // Rule ID 16988 //
     /* 2108481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2108492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2108495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2108498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108527 */     // MIs[0] round
     /* 2108527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108530 */     // MIs[0] policy
     /* 2108530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108540 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2108543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108566 */     // GIR_Coverage, 16988,
     /* 2108566 */     GIR_EraseRootFromParent_Done,
     /* 2108567 */   // Label 27910: @2108567
     /* 2108567 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2108658), // Rule ID 16989 //
     /* 2108572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2108580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2108583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2108586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2108589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2108592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2108614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108618 */     // MIs[0] round
     /* 2108618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108621 */     // MIs[0] policy
     /* 2108621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108631 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2108634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108657 */     // GIR_Coverage, 16989,
     /* 2108657 */     GIR_EraseRootFromParent_Done,
     /* 2108658 */   // Label 27911: @2108658
     /* 2108658 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2108749), // Rule ID 16992 //
     /* 2108663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2108666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2108671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2108680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2108683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108709 */     // MIs[0] round
     /* 2108709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108712 */     // MIs[0] policy
     /* 2108712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108722 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2108725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108748 */     // GIR_Coverage, 16992,
     /* 2108748 */     GIR_EraseRootFromParent_Done,
     /* 2108749 */   // Label 27912: @2108749
     /* 2108749 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2108840), // Rule ID 16993 //
     /* 2108754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2108757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2108762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2108765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2108768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2108771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2108774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108800 */     // MIs[0] round
     /* 2108800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108803 */     // MIs[0] policy
     /* 2108803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108813 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2108816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108839 */     // GIR_Coverage, 16993,
     /* 2108839 */     GIR_EraseRootFromParent_Done,
     /* 2108840 */   // Label 27913: @2108840
     /* 2108840 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2108931), // Rule ID 16996 //
     /* 2108845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2108848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2108853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108891 */     // MIs[0] round
     /* 2108891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108894 */     // MIs[0] policy
     /* 2108894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2108907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108930 */     // GIR_Coverage, 16996,
     /* 2108930 */     GIR_EraseRootFromParent_Done,
     /* 2108931 */   // Label 27914: @2108931
     /* 2108931 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2109022), // Rule ID 16997 //
     /* 2108936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2108939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2108944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2108953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2108956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108982 */     // MIs[0] round
     /* 2108982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108985 */     // MIs[0] policy
     /* 2108985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108995 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2108998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109021 */     // GIR_Coverage, 16997,
     /* 2109021 */     GIR_EraseRootFromParent_Done,
     /* 2109022 */   // Label 27915: @2109022
     /* 2109022 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2109113), // Rule ID 17000 //
     /* 2109027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2109047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109073 */     // MIs[0] round
     /* 2109073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109076 */     // MIs[0] policy
     /* 2109076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109086 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2109089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109112 */     // GIR_Coverage, 17000,
     /* 2109112 */     GIR_EraseRootFromParent_Done,
     /* 2109113 */   // Label 27916: @2109113
     /* 2109113 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2109204), // Rule ID 17001 //
     /* 2109118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2109138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109164 */     // MIs[0] round
     /* 2109164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109167 */     // MIs[0] policy
     /* 2109167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109177 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2109180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109203 */     // GIR_Coverage, 17001,
     /* 2109203 */     GIR_EraseRootFromParent_Done,
     /* 2109204 */   // Label 27917: @2109204
     /* 2109204 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2109295), // Rule ID 17004 //
     /* 2109209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2109229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109255 */     // MIs[0] round
     /* 2109255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109258 */     // MIs[0] policy
     /* 2109258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109268 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2109271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109294 */     // GIR_Coverage, 17004,
     /* 2109294 */     GIR_EraseRootFromParent_Done,
     /* 2109295 */   // Label 27918: @2109295
     /* 2109295 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2109386), // Rule ID 17005 //
     /* 2109300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2109320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109346 */     // MIs[0] round
     /* 2109346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109349 */     // MIs[0] policy
     /* 2109349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109359 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2109362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109385 */     // GIR_Coverage, 17005,
     /* 2109385 */     GIR_EraseRootFromParent_Done,
     /* 2109386 */   // Label 27919: @2109386
     /* 2109386 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2109477), // Rule ID 17008 //
     /* 2109391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109437 */     // MIs[0] round
     /* 2109437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109440 */     // MIs[0] policy
     /* 2109440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109450 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2109453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109476 */     // GIR_Coverage, 17008,
     /* 2109476 */     GIR_EraseRootFromParent_Done,
     /* 2109477 */   // Label 27920: @2109477
     /* 2109477 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2109568), // Rule ID 17009 //
     /* 2109482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2109502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109528 */     // MIs[0] round
     /* 2109528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109531 */     // MIs[0] policy
     /* 2109531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109541 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2109544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109567 */     // GIR_Coverage, 17009,
     /* 2109567 */     GIR_EraseRootFromParent_Done,
     /* 2109568 */   // Label 27921: @2109568
     /* 2109568 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2109659), // Rule ID 17012 //
     /* 2109573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2109576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2109584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2109587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2109590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2109593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109619 */     // MIs[0] round
     /* 2109619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109622 */     // MIs[0] policy
     /* 2109622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109632 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2109635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109658 */     // GIR_Coverage, 17012,
     /* 2109658 */     GIR_EraseRootFromParent_Done,
     /* 2109659 */   // Label 27922: @2109659
     /* 2109659 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2109750), // Rule ID 17013 //
     /* 2109664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2109667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2109675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2109678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2109681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2109684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109710 */     // MIs[0] round
     /* 2109710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109713 */     // MIs[0] policy
     /* 2109713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109723 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2109726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109749 */     // GIR_Coverage, 17013,
     /* 2109749 */     GIR_EraseRootFromParent_Done,
     /* 2109750 */   // Label 27923: @2109750
     /* 2109750 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2109841), // Rule ID 17016 //
     /* 2109755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2109758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2109772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2109775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109801 */     // MIs[0] round
     /* 2109801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109804 */     // MIs[0] policy
     /* 2109804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109814 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2109817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109840 */     // GIR_Coverage, 17016,
     /* 2109840 */     GIR_EraseRootFromParent_Done,
     /* 2109841 */   // Label 27924: @2109841
     /* 2109841 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2109932), // Rule ID 17017 //
     /* 2109846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2109849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2109863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2109866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109892 */     // MIs[0] round
     /* 2109892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109895 */     // MIs[0] policy
     /* 2109895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109905 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2109908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109931 */     // GIR_Coverage, 17017,
     /* 2109931 */     GIR_EraseRootFromParent_Done,
     /* 2109932 */   // Label 27925: @2109932
     /* 2109932 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2110023), // Rule ID 17020 //
     /* 2109937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2109940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2109945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2109948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2109951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109983 */     // MIs[0] round
     /* 2109983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109986 */     // MIs[0] policy
     /* 2109986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109996 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2109999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110022 */     // GIR_Coverage, 17020,
     /* 2110022 */     GIR_EraseRootFromParent_Done,
     /* 2110023 */   // Label 27926: @2110023
     /* 2110023 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2110114), // Rule ID 17021 //
     /* 2110028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2110045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2110048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110074 */     // MIs[0] round
     /* 2110074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110077 */     // MIs[0] policy
     /* 2110077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110087 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2110090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110113 */     // GIR_Coverage, 17021,
     /* 2110113 */     GIR_EraseRootFromParent_Done,
     /* 2110114 */   // Label 27927: @2110114
     /* 2110114 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2110205), // Rule ID 17024 //
     /* 2110119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2110122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2110139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110165 */     // MIs[0] round
     /* 2110165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110168 */     // MIs[0] policy
     /* 2110168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110178 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2110181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110204 */     // GIR_Coverage, 17024,
     /* 2110204 */     GIR_EraseRootFromParent_Done,
     /* 2110205 */   // Label 27928: @2110205
     /* 2110205 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2110296), // Rule ID 17025 //
     /* 2110210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2110230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110256 */     // MIs[0] round
     /* 2110256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110259 */     // MIs[0] policy
     /* 2110259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110269 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2110272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110295 */     // GIR_Coverage, 17025,
     /* 2110295 */     GIR_EraseRootFromParent_Done,
     /* 2110296 */   // Label 27929: @2110296
     /* 2110296 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2110387), // Rule ID 17028 //
     /* 2110301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2110304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110347 */     // MIs[0] round
     /* 2110347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110350 */     // MIs[0] policy
     /* 2110350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110360 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2110363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110386 */     // GIR_Coverage, 17028,
     /* 2110386 */     GIR_EraseRootFromParent_Done,
     /* 2110387 */   // Label 27930: @2110387
     /* 2110387 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2110478), // Rule ID 17029 //
     /* 2110392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110438 */     // MIs[0] round
     /* 2110438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110441 */     // MIs[0] policy
     /* 2110441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110451 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2110454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110477 */     // GIR_Coverage, 17029,
     /* 2110477 */     GIR_EraseRootFromParent_Done,
     /* 2110478 */   // Label 27931: @2110478
     /* 2110478 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2110569), // Rule ID 17032 //
     /* 2110483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2110486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110529 */     // MIs[0] round
     /* 2110529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110532 */     // MIs[0] policy
     /* 2110532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110542 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2110545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110568 */     // GIR_Coverage, 17032,
     /* 2110568 */     GIR_EraseRootFromParent_Done,
     /* 2110569 */   // Label 27932: @2110569
     /* 2110569 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2110660), // Rule ID 17033 //
     /* 2110574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110620 */     // MIs[0] round
     /* 2110620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110623 */     // MIs[0] policy
     /* 2110623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110633 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2110636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110659 */     // GIR_Coverage, 17033,
     /* 2110659 */     GIR_EraseRootFromParent_Done,
     /* 2110660 */   // Label 27933: @2110660
     /* 2110660 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2110751), // Rule ID 17036 //
     /* 2110665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2110668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2110676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2110679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110711 */     // MIs[0] round
     /* 2110711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110714 */     // MIs[0] policy
     /* 2110714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110724 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2110727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110750 */     // GIR_Coverage, 17036,
     /* 2110750 */     GIR_EraseRootFromParent_Done,
     /* 2110751 */   // Label 27934: @2110751
     /* 2110751 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2110842), // Rule ID 17037 //
     /* 2110756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2110767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2110770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110802 */     // MIs[0] round
     /* 2110802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110805 */     // MIs[0] policy
     /* 2110805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110815 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2110818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110841 */     // GIR_Coverage, 17037,
     /* 2110841 */     GIR_EraseRootFromParent_Done,
     /* 2110842 */   // Label 27935: @2110842
     /* 2110842 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2110933), // Rule ID 17040 //
     /* 2110847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2110850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2110858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2110861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2110864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110893 */     // MIs[0] round
     /* 2110893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110896 */     // MIs[0] policy
     /* 2110896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2110909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110932 */     // GIR_Coverage, 17040,
     /* 2110932 */     GIR_EraseRootFromParent_Done,
     /* 2110933 */   // Label 27936: @2110933
     /* 2110933 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2111024), // Rule ID 17041 //
     /* 2110938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2110946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2110949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2110952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2110955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110984 */     // MIs[0] round
     /* 2110984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110987 */     // MIs[0] policy
     /* 2110987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110997 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2111000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111023 */     // GIR_Coverage, 17041,
     /* 2111023 */     GIR_EraseRootFromParent_Done,
     /* 2111024 */   // Label 27937: @2111024
     /* 2111024 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2111115), // Rule ID 17044 //
     /* 2111029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2111032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2111040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2111043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111075 */     // MIs[0] round
     /* 2111075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111078 */     // MIs[0] policy
     /* 2111078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111088 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2111091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111114 */     // GIR_Coverage, 17044,
     /* 2111114 */     GIR_EraseRootFromParent_Done,
     /* 2111115 */   // Label 27938: @2111115
     /* 2111115 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2111206), // Rule ID 17045 //
     /* 2111120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2111123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2111131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2111134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111166 */     // MIs[0] round
     /* 2111166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111169 */     // MIs[0] policy
     /* 2111169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111179 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2111182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111205 */     // GIR_Coverage, 17045,
     /* 2111205 */     GIR_EraseRootFromParent_Done,
     /* 2111206 */   // Label 27939: @2111206
     /* 2111206 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2111297), // Rule ID 17048 //
     /* 2111211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111257 */     // MIs[0] round
     /* 2111257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111260 */     // MIs[0] policy
     /* 2111260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111270 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2111273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111296 */     // GIR_Coverage, 17048,
     /* 2111296 */     GIR_EraseRootFromParent_Done,
     /* 2111297 */   // Label 27940: @2111297
     /* 2111297 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2111388), // Rule ID 17049 //
     /* 2111302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2111319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111348 */     // MIs[0] round
     /* 2111348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111351 */     // MIs[0] policy
     /* 2111351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111361 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2111364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111387 */     // GIR_Coverage, 17049,
     /* 2111387 */     GIR_EraseRootFromParent_Done,
     /* 2111388 */   // Label 27941: @2111388
     /* 2111388 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2111479), // Rule ID 17052 //
     /* 2111393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2111404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2111407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111439 */     // MIs[0] round
     /* 2111439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111442 */     // MIs[0] policy
     /* 2111442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111452 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2111455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111478 */     // GIR_Coverage, 17052,
     /* 2111478 */     GIR_EraseRootFromParent_Done,
     /* 2111479 */   // Label 27942: @2111479
     /* 2111479 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2111570), // Rule ID 17053 //
     /* 2111484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2111495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2111498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2111501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111530 */     // MIs[0] round
     /* 2111530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111533 */     // MIs[0] policy
     /* 2111533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111543 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2111546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111569 */     // GIR_Coverage, 17053,
     /* 2111569 */     GIR_EraseRootFromParent_Done,
     /* 2111570 */   // Label 27943: @2111570
     /* 2111570 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2111661), // Rule ID 17056 //
     /* 2111575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2111586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2111589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111621 */     // MIs[0] round
     /* 2111621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111624 */     // MIs[0] policy
     /* 2111624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111634 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2111637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111660 */     // GIR_Coverage, 17056,
     /* 2111660 */     GIR_EraseRootFromParent_Done,
     /* 2111661 */   // Label 27944: @2111661
     /* 2111661 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2111752), // Rule ID 17057 //
     /* 2111666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2111677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2111680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111712 */     // MIs[0] round
     /* 2111712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111715 */     // MIs[0] policy
     /* 2111715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111725 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2111728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111751 */     // GIR_Coverage, 17057,
     /* 2111751 */     GIR_EraseRootFromParent_Done,
     /* 2111752 */   // Label 27945: @2111752
     /* 2111752 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2111843), // Rule ID 17060 //
     /* 2111757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2111768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2111771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111803 */     // MIs[0] round
     /* 2111803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111806 */     // MIs[0] policy
     /* 2111806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111816 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2111819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111842 */     // GIR_Coverage, 17060,
     /* 2111842 */     GIR_EraseRootFromParent_Done,
     /* 2111843 */   // Label 27946: @2111843
     /* 2111843 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2111934), // Rule ID 17061 //
     /* 2111848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2111856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2111859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2111862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111894 */     // MIs[0] round
     /* 2111894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111897 */     // MIs[0] policy
     /* 2111897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111907 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2111910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111933 */     // GIR_Coverage, 17061,
     /* 2111933 */     GIR_EraseRootFromParent_Done,
     /* 2111934 */   // Label 27947: @2111934
     /* 2111934 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2112025), // Rule ID 17064 //
     /* 2111939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2111942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2111947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2111950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2111953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2111956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2111959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111985 */     // MIs[0] round
     /* 2111985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111988 */     // MIs[0] policy
     /* 2111988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111998 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2112001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112024 */     // GIR_Coverage, 17064,
     /* 2112024 */     GIR_EraseRootFromParent_Done,
     /* 2112025 */   // Label 27948: @2112025
     /* 2112025 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2112116), // Rule ID 17065 //
     /* 2112030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2112041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2112044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2112047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2112050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112076 */     // MIs[0] round
     /* 2112076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112079 */     // MIs[0] policy
     /* 2112079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112089 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2112092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112115 */     // GIR_Coverage, 17065,
     /* 2112115 */     GIR_EraseRootFromParent_Done,
     /* 2112116 */   // Label 27949: @2112116
     /* 2112116 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2112207), // Rule ID 17068 //
     /* 2112121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2112132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2112138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2112141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112167 */     // MIs[0] round
     /* 2112167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112170 */     // MIs[0] policy
     /* 2112170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112180 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112206 */     // GIR_Coverage, 17068,
     /* 2112206 */     GIR_EraseRootFromParent_Done,
     /* 2112207 */   // Label 27950: @2112207
     /* 2112207 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2112298), // Rule ID 17069 //
     /* 2112212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2112223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2112229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2112232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112258 */     // MIs[0] round
     /* 2112258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112261 */     // MIs[0] policy
     /* 2112261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112271 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2112274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112297 */     // GIR_Coverage, 17069,
     /* 2112297 */     GIR_EraseRootFromParent_Done,
     /* 2112298 */   // Label 27951: @2112298
     /* 2112298 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2112389), // Rule ID 17072 //
     /* 2112303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2112320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2112323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112349 */     // MIs[0] round
     /* 2112349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112352 */     // MIs[0] policy
     /* 2112352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112362 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2112365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112388 */     // GIR_Coverage, 17072,
     /* 2112388 */     GIR_EraseRootFromParent_Done,
     /* 2112389 */   // Label 27952: @2112389
     /* 2112389 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2112480), // Rule ID 17073 //
     /* 2112394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2112411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2112414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112440 */     // MIs[0] round
     /* 2112440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112443 */     // MIs[0] policy
     /* 2112443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112453 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2112456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112479 */     // GIR_Coverage, 17073,
     /* 2112479 */     GIR_EraseRootFromParent_Done,
     /* 2112480 */   // Label 27953: @2112480
     /* 2112480 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2112571), // Rule ID 17076 //
     /* 2112485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2112502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2112505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112531 */     // MIs[0] round
     /* 2112531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112534 */     // MIs[0] policy
     /* 2112534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112544 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2112547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112570 */     // GIR_Coverage, 17076,
     /* 2112570 */     GIR_EraseRootFromParent_Done,
     /* 2112571 */   // Label 27954: @2112571
     /* 2112571 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2112662), // Rule ID 17077 //
     /* 2112576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2112593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2112596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112622 */     // MIs[0] round
     /* 2112622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112625 */     // MIs[0] policy
     /* 2112625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112635 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2112638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112661 */     // GIR_Coverage, 17077,
     /* 2112661 */     GIR_EraseRootFromParent_Done,
     /* 2112662 */   // Label 27955: @2112662
     /* 2112662 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2112753), // Rule ID 17080 //
     /* 2112667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2112684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2112687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112713 */     // MIs[0] round
     /* 2112713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112716 */     // MIs[0] policy
     /* 2112716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112726 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2112729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112752 */     // GIR_Coverage, 17080,
     /* 2112752 */     GIR_EraseRootFromParent_Done,
     /* 2112753 */   // Label 27956: @2112753
     /* 2112753 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2112844), // Rule ID 17081 //
     /* 2112758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2112775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2112778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112804 */     // MIs[0] round
     /* 2112804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112807 */     // MIs[0] policy
     /* 2112807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112817 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2112820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112843 */     // GIR_Coverage, 17081,
     /* 2112843 */     GIR_EraseRootFromParent_Done,
     /* 2112844 */   // Label 27957: @2112844
     /* 2112844 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2112935), // Rule ID 17084 //
     /* 2112849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2112852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2112860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2112863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2112866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2112869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112895 */     // MIs[0] round
     /* 2112895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112898 */     // MIs[0] policy
     /* 2112898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112908 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2112911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112934 */     // GIR_Coverage, 17084,
     /* 2112934 */     GIR_EraseRootFromParent_Done,
     /* 2112935 */   // Label 27958: @2112935
     /* 2112935 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2113026), // Rule ID 17085 //
     /* 2112940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2112943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2112948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2112951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2112954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2112957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2112960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112986 */     // MIs[0] round
     /* 2112986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112989 */     // MIs[0] policy
     /* 2112989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112999 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2113002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113025 */     // GIR_Coverage, 17085,
     /* 2113025 */     GIR_EraseRootFromParent_Done,
     /* 2113026 */   // Label 27959: @2113026
     /* 2113026 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2113117), // Rule ID 17088 //
     /* 2113031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2113051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113077 */     // MIs[0] round
     /* 2113077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113080 */     // MIs[0] policy
     /* 2113080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2113093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113116 */     // GIR_Coverage, 17088,
     /* 2113116 */     GIR_EraseRootFromParent_Done,
     /* 2113117 */   // Label 27960: @2113117
     /* 2113117 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2113208), // Rule ID 17089 //
     /* 2113122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2113142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113168 */     // MIs[0] round
     /* 2113168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113171 */     // MIs[0] policy
     /* 2113171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113181 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2113184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113207 */     // GIR_Coverage, 17089,
     /* 2113207 */     GIR_EraseRootFromParent_Done,
     /* 2113208 */   // Label 27961: @2113208
     /* 2113208 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2113299), // Rule ID 17092 //
     /* 2113213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2113230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2113233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113259 */     // MIs[0] round
     /* 2113259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113262 */     // MIs[0] policy
     /* 2113262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113272 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2113275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113298 */     // GIR_Coverage, 17092,
     /* 2113298 */     GIR_EraseRootFromParent_Done,
     /* 2113299 */   // Label 27962: @2113299
     /* 2113299 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2113390), // Rule ID 17093 //
     /* 2113304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2113321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2113324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113350 */     // MIs[0] round
     /* 2113350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113353 */     // MIs[0] policy
     /* 2113353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113363 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2113366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113389 */     // GIR_Coverage, 17093,
     /* 2113389 */     GIR_EraseRootFromParent_Done,
     /* 2113390 */   // Label 27963: @2113390
     /* 2113390 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2113481), // Rule ID 17096 //
     /* 2113395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2113412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2113415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113441 */     // MIs[0] round
     /* 2113441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113444 */     // MIs[0] policy
     /* 2113444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113454 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2113457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113480 */     // GIR_Coverage, 17096,
     /* 2113480 */     GIR_EraseRootFromParent_Done,
     /* 2113481 */   // Label 27964: @2113481
     /* 2113481 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2113572), // Rule ID 17097 //
     /* 2113486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2113503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2113506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113532 */     // MIs[0] round
     /* 2113532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113535 */     // MIs[0] policy
     /* 2113535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113545 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2113548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113571 */     // GIR_Coverage, 17097,
     /* 2113571 */     GIR_EraseRootFromParent_Done,
     /* 2113572 */   // Label 27965: @2113572
     /* 2113572 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2113663), // Rule ID 17100 //
     /* 2113577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2113580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113623 */     // MIs[0] round
     /* 2113623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113626 */     // MIs[0] policy
     /* 2113626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113636 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2113639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113662 */     // GIR_Coverage, 17100,
     /* 2113662 */     GIR_EraseRootFromParent_Done,
     /* 2113663 */   // Label 27966: @2113663
     /* 2113663 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2113754), // Rule ID 17101 //
     /* 2113668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2113671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2113685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113714 */     // MIs[0] round
     /* 2113714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113717 */     // MIs[0] policy
     /* 2113717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113727 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2113730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113753 */     // GIR_Coverage, 17101,
     /* 2113753 */     GIR_EraseRootFromParent_Done,
     /* 2113754 */   // Label 27967: @2113754
     /* 2113754 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2113845), // Rule ID 17104 //
     /* 2113759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2113762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113805 */     // MIs[0] round
     /* 2113805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113808 */     // MIs[0] policy
     /* 2113808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113818 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2113821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113844 */     // GIR_Coverage, 17104,
     /* 2113844 */     GIR_EraseRootFromParent_Done,
     /* 2113845 */   // Label 27968: @2113845
     /* 2113845 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2113936), // Rule ID 17105 //
     /* 2113850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2113853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113896 */     // MIs[0] round
     /* 2113896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113899 */     // MIs[0] policy
     /* 2113899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113909 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2113912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113935 */     // GIR_Coverage, 17105,
     /* 2113935 */     GIR_EraseRootFromParent_Done,
     /* 2113936 */   // Label 27969: @2113936
     /* 2113936 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2114027), // Rule ID 17108 //
     /* 2113941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2113944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2113949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2113952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2113955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113987 */     // MIs[0] round
     /* 2113987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113990 */     // MIs[0] policy
     /* 2113990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114000 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2114003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114026 */     // GIR_Coverage, 17108,
     /* 2114026 */     GIR_EraseRootFromParent_Done,
     /* 2114027 */   // Label 27970: @2114027
     /* 2114027 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2114118), // Rule ID 17109 //
     /* 2114032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2114049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114078 */     // MIs[0] round
     /* 2114078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114081 */     // MIs[0] policy
     /* 2114081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114091 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2114094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114117 */     // GIR_Coverage, 17109,
     /* 2114117 */     GIR_EraseRootFromParent_Done,
     /* 2114118 */   // Label 27971: @2114118
     /* 2114118 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2114209), // Rule ID 17112 //
     /* 2114123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114169 */     // MIs[0] round
     /* 2114169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114172 */     // MIs[0] policy
     /* 2114172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114182 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2114185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114208 */     // GIR_Coverage, 17112,
     /* 2114208 */     GIR_EraseRootFromParent_Done,
     /* 2114209 */   // Label 27972: @2114209
     /* 2114209 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2114300), // Rule ID 17113 //
     /* 2114214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114260 */     // MIs[0] round
     /* 2114260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114263 */     // MIs[0] policy
     /* 2114263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114273 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2114276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114299 */     // GIR_Coverage, 17113,
     /* 2114299 */     GIR_EraseRootFromParent_Done,
     /* 2114300 */   // Label 27973: @2114300
     /* 2114300 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2114391), // Rule ID 17116 //
     /* 2114305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114351 */     // MIs[0] round
     /* 2114351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114354 */     // MIs[0] policy
     /* 2114354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114364 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2114367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114390 */     // GIR_Coverage, 17116,
     /* 2114390 */     GIR_EraseRootFromParent_Done,
     /* 2114391 */   // Label 27974: @2114391
     /* 2114391 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2114482), // Rule ID 17117 //
     /* 2114396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114442 */     // MIs[0] round
     /* 2114442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114445 */     // MIs[0] policy
     /* 2114445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114455 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2114458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114481 */     // GIR_Coverage, 17117,
     /* 2114481 */     GIR_EraseRootFromParent_Done,
     /* 2114482 */   // Label 27975: @2114482
     /* 2114482 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2114573), // Rule ID 17120 //
     /* 2114487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2114490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2114504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114533 */     // MIs[0] round
     /* 2114533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114536 */     // MIs[0] policy
     /* 2114536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114546 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2114549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114572 */     // GIR_Coverage, 17120,
     /* 2114572 */     GIR_EraseRootFromParent_Done,
     /* 2114573 */   // Label 27976: @2114573
     /* 2114573 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2114664), // Rule ID 17121 //
     /* 2114578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2114581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2114595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114624 */     // MIs[0] round
     /* 2114624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114627 */     // MIs[0] policy
     /* 2114627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114637 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2114640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114663 */     // GIR_Coverage, 17121,
     /* 2114663 */     GIR_EraseRootFromParent_Done,
     /* 2114664 */   // Label 27977: @2114664
     /* 2114664 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2114755), // Rule ID 17124 //
     /* 2114669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2114672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2114680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2114683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114715 */     // MIs[0] round
     /* 2114715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114718 */     // MIs[0] policy
     /* 2114718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114728 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2114731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114754 */     // GIR_Coverage, 17124,
     /* 2114754 */     GIR_EraseRootFromParent_Done,
     /* 2114755 */   // Label 27978: @2114755
     /* 2114755 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2114846), // Rule ID 17125 //
     /* 2114760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2114763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2114771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2114774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114806 */     // MIs[0] round
     /* 2114806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114809 */     // MIs[0] policy
     /* 2114809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114819 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2114822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114845 */     // GIR_Coverage, 17125,
     /* 2114845 */     GIR_EraseRootFromParent_Done,
     /* 2114846 */   // Label 27979: @2114846
     /* 2114846 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2114937), // Rule ID 17128 //
     /* 2114851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2114854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2114862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2114865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114897 */     // MIs[0] round
     /* 2114897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114900 */     // MIs[0] policy
     /* 2114900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114910 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2114913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114936 */     // GIR_Coverage, 17128,
     /* 2114936 */     GIR_EraseRootFromParent_Done,
     /* 2114937 */   // Label 27980: @2114937
     /* 2114937 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2115028), // Rule ID 17129 //
     /* 2114942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2114945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2114950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2114953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2114956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114988 */     // MIs[0] round
     /* 2114988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114991 */     // MIs[0] policy
     /* 2114991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115001 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2115004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115027 */     // GIR_Coverage, 17129,
     /* 2115027 */     GIR_EraseRootFromParent_Done,
     /* 2115028 */   // Label 27981: @2115028
     /* 2115028 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2115119), // Rule ID 17132 //
     /* 2115033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2115036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2115041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115079 */     // MIs[0] round
     /* 2115079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115082 */     // MIs[0] policy
     /* 2115082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115092 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2115095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115118 */     // GIR_Coverage, 17132,
     /* 2115118 */     GIR_EraseRootFromParent_Done,
     /* 2115119 */   // Label 27982: @2115119
     /* 2115119 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2115210), // Rule ID 17133 //
     /* 2115124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2115127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2115132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2115144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2115166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115170 */     // MIs[0] round
     /* 2115170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115173 */     // MIs[0] policy
     /* 2115173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115183 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2115186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115209 */     // GIR_Coverage, 17133,
     /* 2115209 */     GIR_EraseRootFromParent_Done,
     /* 2115210 */   // Label 27983: @2115210
     /* 2115210 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2115301), // Rule ID 17142 //
     /* 2115215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2115232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115261 */     // MIs[0] round
     /* 2115261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115264 */     // MIs[0] policy
     /* 2115264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115274 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2115277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115300 */     // GIR_Coverage, 17142,
     /* 2115300 */     GIR_EraseRootFromParent_Done,
     /* 2115301 */   // Label 27984: @2115301
     /* 2115301 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2115392), // Rule ID 17143 //
     /* 2115306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2115323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115352 */     // MIs[0] round
     /* 2115352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115355 */     // MIs[0] policy
     /* 2115355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115365 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2115368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115391 */     // GIR_Coverage, 17143,
     /* 2115391 */     GIR_EraseRootFromParent_Done,
     /* 2115392 */   // Label 27985: @2115392
     /* 2115392 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2115483), // Rule ID 17152 //
     /* 2115397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2115417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115443 */     // MIs[0] round
     /* 2115443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115446 */     // MIs[0] policy
     /* 2115446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115456 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2115459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115482 */     // GIR_Coverage, 17152,
     /* 2115482 */     GIR_EraseRootFromParent_Done,
     /* 2115483 */   // Label 27986: @2115483
     /* 2115483 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2115574), // Rule ID 17153 //
     /* 2115488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2115508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115534 */     // MIs[0] round
     /* 2115534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115537 */     // MIs[0] policy
     /* 2115537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115547 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2115550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115573 */     // GIR_Coverage, 17153,
     /* 2115573 */     GIR_EraseRootFromParent_Done,
     /* 2115574 */   // Label 27987: @2115574
     /* 2115574 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2115665), // Rule ID 17162 //
     /* 2115579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2115599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115625 */     // MIs[0] round
     /* 2115625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115628 */     // MIs[0] policy
     /* 2115628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115638 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2115641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115664 */     // GIR_Coverage, 17162,
     /* 2115664 */     GIR_EraseRootFromParent_Done,
     /* 2115665 */   // Label 27988: @2115665
     /* 2115665 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2115756), // Rule ID 17163 //
     /* 2115670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2115681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2115684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2115687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2115690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115716 */     // MIs[0] round
     /* 2115716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115719 */     // MIs[0] policy
     /* 2115719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115729 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2115732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115755 */     // GIR_Coverage, 17163,
     /* 2115755 */     GIR_EraseRootFromParent_Done,
     /* 2115756 */   // Label 27989: @2115756
     /* 2115756 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2115847), // Rule ID 17172 //
     /* 2115761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2115781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115807 */     // MIs[0] round
     /* 2115807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115810 */     // MIs[0] policy
     /* 2115810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115820 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2115823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115846 */     // GIR_Coverage, 17172,
     /* 2115846 */     GIR_EraseRootFromParent_Done,
     /* 2115847 */   // Label 27990: @2115847
     /* 2115847 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2115938), // Rule ID 17173 //
     /* 2115852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2115863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2115866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2115869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2115872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2115875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115898 */     // MIs[0] round
     /* 2115898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115901 */     // MIs[0] policy
     /* 2115901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115911 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2115914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115937 */     // GIR_Coverage, 17173,
     /* 2115937 */     GIR_EraseRootFromParent_Done,
     /* 2115938 */   // Label 27991: @2115938
     /* 2115938 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2116029), // Rule ID 17182 //
     /* 2115943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2115946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2115951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2115954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2115957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2115960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2115963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115989 */     // MIs[0] round
     /* 2115989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115992 */     // MIs[0] policy
     /* 2115992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2116005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116028 */     // GIR_Coverage, 17182,
     /* 2116028 */     GIR_EraseRootFromParent_Done,
     /* 2116029 */   // Label 27992: @2116029
     /* 2116029 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2116120), // Rule ID 17183 //
     /* 2116034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2116051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116080 */     // MIs[0] round
     /* 2116080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116083 */     // MIs[0] policy
     /* 2116083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116093 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2116096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116119 */     // GIR_Coverage, 17183,
     /* 2116119 */     GIR_EraseRootFromParent_Done,
     /* 2116120 */   // Label 27993: @2116120
     /* 2116120 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2116211), // Rule ID 17192 //
     /* 2116125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116171 */     // MIs[0] round
     /* 2116171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116174 */     // MIs[0] policy
     /* 2116174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2116187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116210 */     // GIR_Coverage, 17192,
     /* 2116210 */     GIR_EraseRootFromParent_Done,
     /* 2116211 */   // Label 27994: @2116211
     /* 2116211 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2116302), // Rule ID 17193 //
     /* 2116216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116262 */     // MIs[0] round
     /* 2116262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116265 */     // MIs[0] policy
     /* 2116265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116275 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2116278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116301 */     // GIR_Coverage, 17193,
     /* 2116301 */     GIR_EraseRootFromParent_Done,
     /* 2116302 */   // Label 27995: @2116302
     /* 2116302 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2116393), // Rule ID 17202 //
     /* 2116307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116353 */     // MIs[0] round
     /* 2116353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116356 */     // MIs[0] policy
     /* 2116356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116366 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2116369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116392 */     // GIR_Coverage, 17202,
     /* 2116392 */     GIR_EraseRootFromParent_Done,
     /* 2116393 */   // Label 27996: @2116393
     /* 2116393 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2116484), // Rule ID 17203 //
     /* 2116398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116444 */     // MIs[0] round
     /* 2116444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116447 */     // MIs[0] policy
     /* 2116447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116457 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2116460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116483 */     // GIR_Coverage, 17203,
     /* 2116483 */     GIR_EraseRootFromParent_Done,
     /* 2116484 */   // Label 27997: @2116484
     /* 2116484 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2116575), // Rule ID 17212 //
     /* 2116489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2116500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2116503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2116506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2116509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116535 */     // MIs[0] round
     /* 2116535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116538 */     // MIs[0] policy
     /* 2116538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116548 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2116551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116574 */     // GIR_Coverage, 17212,
     /* 2116574 */     GIR_EraseRootFromParent_Done,
     /* 2116575 */   // Label 27998: @2116575
     /* 2116575 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2116666), // Rule ID 17213 //
     /* 2116580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2116591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2116594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2116597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2116600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116626 */     // MIs[0] round
     /* 2116626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116629 */     // MIs[0] policy
     /* 2116629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116639 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2116642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116665 */     // GIR_Coverage, 17213,
     /* 2116665 */     GIR_EraseRootFromParent_Done,
     /* 2116666 */   // Label 27999: @2116666
     /* 2116666 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2116757), // Rule ID 17216 //
     /* 2116671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116717 */     // MIs[0] round
     /* 2116717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116720 */     // MIs[0] policy
     /* 2116720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2116733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116756 */     // GIR_Coverage, 17216,
     /* 2116756 */     GIR_EraseRootFromParent_Done,
     /* 2116757 */   // Label 28000: @2116757
     /* 2116757 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2116848), // Rule ID 17217 //
     /* 2116762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2116773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2116776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116808 */     // MIs[0] round
     /* 2116808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116811 */     // MIs[0] policy
     /* 2116811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116821 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2116824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116847 */     // GIR_Coverage, 17217,
     /* 2116847 */     GIR_EraseRootFromParent_Done,
     /* 2116848 */   // Label 28001: @2116848
     /* 2116848 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2116939), // Rule ID 17220 //
     /* 2116853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116899 */     // MIs[0] round
     /* 2116899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116902 */     // MIs[0] policy
     /* 2116902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2116915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116938 */     // GIR_Coverage, 17220,
     /* 2116938 */     GIR_EraseRootFromParent_Done,
     /* 2116939 */   // Label 28002: @2116939
     /* 2116939 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2117030), // Rule ID 17221 //
     /* 2116944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2116952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2116955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2116958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116990 */     // MIs[0] round
     /* 2116990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116993 */     // MIs[0] policy
     /* 2116993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117003 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2117006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117029 */     // GIR_Coverage, 17221,
     /* 2117029 */     GIR_EraseRootFromParent_Done,
     /* 2117030 */   // Label 28003: @2117030
     /* 2117030 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2117121), // Rule ID 17224 //
     /* 2117035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117081 */     // MIs[0] round
     /* 2117081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117084 */     // MIs[0] policy
     /* 2117084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2117097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117120 */     // GIR_Coverage, 17224,
     /* 2117120 */     GIR_EraseRootFromParent_Done,
     /* 2117121 */   // Label 28004: @2117121
     /* 2117121 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2117212), // Rule ID 17225 //
     /* 2117126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2117143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117172 */     // MIs[0] round
     /* 2117172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117175 */     // MIs[0] policy
     /* 2117175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2117188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117211 */     // GIR_Coverage, 17225,
     /* 2117211 */     GIR_EraseRootFromParent_Done,
     /* 2117212 */   // Label 28005: @2117212
     /* 2117212 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2117303), // Rule ID 17228 //
     /* 2117217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117263 */     // MIs[0] round
     /* 2117263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117266 */     // MIs[0] policy
     /* 2117266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2117279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117302 */     // GIR_Coverage, 17228,
     /* 2117302 */     GIR_EraseRootFromParent_Done,
     /* 2117303 */   // Label 28006: @2117303
     /* 2117303 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2117394), // Rule ID 17229 //
     /* 2117308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117354 */     // MIs[0] round
     /* 2117354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117357 */     // MIs[0] policy
     /* 2117357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117367 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2117370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117393 */     // GIR_Coverage, 17229,
     /* 2117393 */     GIR_EraseRootFromParent_Done,
     /* 2117394 */   // Label 28007: @2117394
     /* 2117394 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2117485), // Rule ID 17232 //
     /* 2117399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2117410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2117413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2117416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2117422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117445 */     // MIs[0] round
     /* 2117445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117448 */     // MIs[0] policy
     /* 2117448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2117461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117484 */     // GIR_Coverage, 17232,
     /* 2117484 */     GIR_EraseRootFromParent_Done,
     /* 2117485 */   // Label 28008: @2117485
     /* 2117485 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2117576), // Rule ID 17233 //
     /* 2117490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2117501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2117504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2117507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2117513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117536 */     // MIs[0] round
     /* 2117536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117539 */     // MIs[0] policy
     /* 2117539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117549 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2117552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117575 */     // GIR_Coverage, 17233,
     /* 2117575 */     GIR_EraseRootFromParent_Done,
     /* 2117576 */   // Label 28009: @2117576
     /* 2117576 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2117667), // Rule ID 17236 //
     /* 2117581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2117598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117627 */     // MIs[0] round
     /* 2117627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117630 */     // MIs[0] policy
     /* 2117630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2117643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117666 */     // GIR_Coverage, 17236,
     /* 2117666 */     GIR_EraseRootFromParent_Done,
     /* 2117667 */   // Label 28010: @2117667
     /* 2117667 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2117758), // Rule ID 17237 //
     /* 2117672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2117683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2117686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2117689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117718 */     // MIs[0] round
     /* 2117718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117721 */     // MIs[0] policy
     /* 2117721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117731 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2117734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117757 */     // GIR_Coverage, 17237,
     /* 2117757 */     GIR_EraseRootFromParent_Done,
     /* 2117758 */   // Label 28011: @2117758
     /* 2117758 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2117849), // Rule ID 17240 //
     /* 2117763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2117780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117809 */     // MIs[0] round
     /* 2117809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117812 */     // MIs[0] policy
     /* 2117812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2117825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117848 */     // GIR_Coverage, 17240,
     /* 2117848 */     GIR_EraseRootFromParent_Done,
     /* 2117849 */   // Label 28012: @2117849
     /* 2117849 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2117940), // Rule ID 17241 //
     /* 2117854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2117865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2117868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2117871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117900 */     // MIs[0] round
     /* 2117900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117903 */     // MIs[0] policy
     /* 2117903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117913 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2117916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117939 */     // GIR_Coverage, 17241,
     /* 2117939 */     GIR_EraseRootFromParent_Done,
     /* 2117940 */   // Label 28013: @2117940
     /* 2117940 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2118031), // Rule ID 17244 //
     /* 2117945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2117953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2117956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2117959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2117962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117991 */     // MIs[0] round
     /* 2117991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117994 */     // MIs[0] policy
     /* 2117994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118004 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2118007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118030 */     // GIR_Coverage, 17244,
     /* 2118030 */     GIR_EraseRootFromParent_Done,
     /* 2118031 */   // Label 28014: @2118031
     /* 2118031 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2118122), // Rule ID 17245 //
     /* 2118036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2118044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2118053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118082 */     // MIs[0] round
     /* 2118082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118085 */     // MIs[0] policy
     /* 2118085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118095 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2118098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118121 */     // GIR_Coverage, 17245,
     /* 2118121 */     GIR_EraseRootFromParent_Done,
     /* 2118122 */   // Label 28015: @2118122
     /* 2118122 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2118213), // Rule ID 17248 //
     /* 2118127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2118135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2118144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118173 */     // MIs[0] round
     /* 2118173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118176 */     // MIs[0] policy
     /* 2118176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118186 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2118189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118212 */     // GIR_Coverage, 17248,
     /* 2118212 */     GIR_EraseRootFromParent_Done,
     /* 2118213 */   // Label 28016: @2118213
     /* 2118213 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2118304), // Rule ID 17249 //
     /* 2118218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2118226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2118235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118264 */     // MIs[0] round
     /* 2118264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118267 */     // MIs[0] policy
     /* 2118267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118277 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2118280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118303 */     // GIR_Coverage, 17249,
     /* 2118303 */     GIR_EraseRootFromParent_Done,
     /* 2118304 */   // Label 28017: @2118304
     /* 2118304 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2118395), // Rule ID 17258 //
     /* 2118309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118355 */     // MIs[0] round
     /* 2118355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118358 */     // MIs[0] policy
     /* 2118358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118368 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2118371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118394 */     // GIR_Coverage, 17258,
     /* 2118394 */     GIR_EraseRootFromParent_Done,
     /* 2118395 */   // Label 28018: @2118395
     /* 2118395 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2118486), // Rule ID 17259 //
     /* 2118400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118446 */     // MIs[0] round
     /* 2118446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118449 */     // MIs[0] policy
     /* 2118449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118459 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2118462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118485 */     // GIR_Coverage, 17259,
     /* 2118485 */     GIR_EraseRootFromParent_Done,
     /* 2118486 */   // Label 28019: @2118486
     /* 2118486 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2118577), // Rule ID 17268 //
     /* 2118491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2118502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2118505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2118511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118537 */     // MIs[0] round
     /* 2118537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118540 */     // MIs[0] policy
     /* 2118540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118550 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2118553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118576 */     // GIR_Coverage, 17268,
     /* 2118576 */     GIR_EraseRootFromParent_Done,
     /* 2118577 */   // Label 28020: @2118577
     /* 2118577 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2118668), // Rule ID 17269 //
     /* 2118582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2118593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2118596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2118602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118628 */     // MIs[0] round
     /* 2118628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118631 */     // MIs[0] policy
     /* 2118631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118641 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2118644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118667 */     // GIR_Coverage, 17269,
     /* 2118667 */     GIR_EraseRootFromParent_Done,
     /* 2118668 */   // Label 28021: @2118668
     /* 2118668 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2118759), // Rule ID 17278 //
     /* 2118673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2118693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118719 */     // MIs[0] round
     /* 2118719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118722 */     // MIs[0] policy
     /* 2118722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2118735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118758 */     // GIR_Coverage, 17278,
     /* 2118758 */     GIR_EraseRootFromParent_Done,
     /* 2118759 */   // Label 28022: @2118759
     /* 2118759 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2118850), // Rule ID 17279 //
     /* 2118764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2118784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118810 */     // MIs[0] round
     /* 2118810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118813 */     // MIs[0] policy
     /* 2118813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2118826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118849 */     // GIR_Coverage, 17279,
     /* 2118849 */     GIR_EraseRootFromParent_Done,
     /* 2118850 */   // Label 28023: @2118850
     /* 2118850 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2118941), // Rule ID 17288 //
     /* 2118855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2118875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118901 */     // MIs[0] round
     /* 2118901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118904 */     // MIs[0] policy
     /* 2118904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118914 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2118917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118940 */     // GIR_Coverage, 17288,
     /* 2118940 */     GIR_EraseRootFromParent_Done,
     /* 2118941 */   // Label 28024: @2118941
     /* 2118941 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2119032), // Rule ID 17289 //
     /* 2118946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2118954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2118957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2118960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2118966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118992 */     // MIs[0] round
     /* 2118992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118995 */     // MIs[0] policy
     /* 2118995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119005 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2119008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119031 */     // GIR_Coverage, 17289,
     /* 2119031 */     GIR_EraseRootFromParent_Done,
     /* 2119032 */   // Label 28025: @2119032
     /* 2119032 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2119123), // Rule ID 17298 //
     /* 2119037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2119054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119083 */     // MIs[0] round
     /* 2119083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119086 */     // MIs[0] policy
     /* 2119086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119096 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2119099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119122 */     // GIR_Coverage, 17298,
     /* 2119122 */     GIR_EraseRootFromParent_Done,
     /* 2119123 */   // Label 28026: @2119123
     /* 2119123 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2119214), // Rule ID 17299 //
     /* 2119128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2119145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119174 */     // MIs[0] round
     /* 2119174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119177 */     // MIs[0] policy
     /* 2119177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119187 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2119190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119213 */     // GIR_Coverage, 17299,
     /* 2119213 */     GIR_EraseRootFromParent_Done,
     /* 2119214 */   // Label 28027: @2119214
     /* 2119214 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2119305), // Rule ID 17308 //
     /* 2119219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2119236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119265 */     // MIs[0] round
     /* 2119265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119268 */     // MIs[0] policy
     /* 2119268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119278 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2119281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119304 */     // GIR_Coverage, 17308,
     /* 2119304 */     GIR_EraseRootFromParent_Done,
     /* 2119305 */   // Label 28028: @2119305
     /* 2119305 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2119396), // Rule ID 17309 //
     /* 2119310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2119327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119356 */     // MIs[0] round
     /* 2119356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119359 */     // MIs[0] policy
     /* 2119359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119369 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2119372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119395 */     // GIR_Coverage, 17309,
     /* 2119395 */     GIR_EraseRootFromParent_Done,
     /* 2119396 */   // Label 28029: @2119396
     /* 2119396 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2119487), // Rule ID 17318 //
     /* 2119401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2119418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2119421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119447 */     // MIs[0] round
     /* 2119447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119450 */     // MIs[0] policy
     /* 2119450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119460 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2119463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119486 */     // GIR_Coverage, 17318,
     /* 2119486 */     GIR_EraseRootFromParent_Done,
     /* 2119487 */   // Label 28030: @2119487
     /* 2119487 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2119578), // Rule ID 17319 //
     /* 2119492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2119509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2119512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119538 */     // MIs[0] round
     /* 2119538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119541 */     // MIs[0] policy
     /* 2119541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119551 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2119554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119577 */     // GIR_Coverage, 17319,
     /* 2119577 */     GIR_EraseRootFromParent_Done,
     /* 2119578 */   // Label 28031: @2119578
     /* 2119578 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2119669), // Rule ID 17328 //
     /* 2119583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2119603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119629 */     // MIs[0] round
     /* 2119629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119632 */     // MIs[0] policy
     /* 2119632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119642 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2119645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119668 */     // GIR_Coverage, 17328,
     /* 2119668 */     GIR_EraseRootFromParent_Done,
     /* 2119669 */   // Label 28032: @2119669
     /* 2119669 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2119760), // Rule ID 17329 //
     /* 2119674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2119694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119720 */     // MIs[0] round
     /* 2119720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119723 */     // MIs[0] policy
     /* 2119723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119733 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2119736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119759 */     // GIR_Coverage, 17329,
     /* 2119759 */     GIR_EraseRootFromParent_Done,
     /* 2119760 */   // Label 28033: @2119760
     /* 2119760 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2119851), // Rule ID 17338 //
     /* 2119765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2119785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119811 */     // MIs[0] round
     /* 2119811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119814 */     // MIs[0] policy
     /* 2119814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119824 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2119827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119850 */     // GIR_Coverage, 17338,
     /* 2119850 */     GIR_EraseRootFromParent_Done,
     /* 2119851 */   // Label 28034: @2119851
     /* 2119851 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2119942), // Rule ID 17339 //
     /* 2119856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2119876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119902 */     // MIs[0] round
     /* 2119902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119905 */     // MIs[0] policy
     /* 2119905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119915 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2119918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119941 */     // GIR_Coverage, 17339,
     /* 2119941 */     GIR_EraseRootFromParent_Done,
     /* 2119942 */   // Label 28035: @2119942
     /* 2119942 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2120033), // Rule ID 17342 //
     /* 2119947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2119955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2119958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2119961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2119964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2119967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2119989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119993 */     // MIs[0] round
     /* 2119993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119996 */     // MIs[0] policy
     /* 2119996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120006 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2120009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120032 */     // GIR_Coverage, 17342,
     /* 2120032 */     GIR_EraseRootFromParent_Done,
     /* 2120033 */   // Label 28036: @2120033
     /* 2120033 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2120124), // Rule ID 17343 //
     /* 2120038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120084 */     // MIs[0] round
     /* 2120084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120087 */     // MIs[0] policy
     /* 2120087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120097 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2120100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120123 */     // GIR_Coverage, 17343,
     /* 2120123 */     GIR_EraseRootFromParent_Done,
     /* 2120124 */   // Label 28037: @2120124
     /* 2120124 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2120215), // Rule ID 17346 //
     /* 2120129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120175 */     // MIs[0] round
     /* 2120175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120178 */     // MIs[0] policy
     /* 2120178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120188 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2120191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120214 */     // GIR_Coverage, 17346,
     /* 2120214 */     GIR_EraseRootFromParent_Done,
     /* 2120215 */   // Label 28038: @2120215
     /* 2120215 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2120306), // Rule ID 17347 //
     /* 2120220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120266 */     // MIs[0] round
     /* 2120266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120269 */     // MIs[0] policy
     /* 2120269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120279 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2120282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120305 */     // GIR_Coverage, 17347,
     /* 2120305 */     GIR_EraseRootFromParent_Done,
     /* 2120306 */   // Label 28039: @2120306
     /* 2120306 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2120397), // Rule ID 17350 //
     /* 2120311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120357 */     // MIs[0] round
     /* 2120357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120360 */     // MIs[0] policy
     /* 2120360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2120373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120396 */     // GIR_Coverage, 17350,
     /* 2120396 */     GIR_EraseRootFromParent_Done,
     /* 2120397 */   // Label 28040: @2120397
     /* 2120397 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2120488), // Rule ID 17351 //
     /* 2120402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120448 */     // MIs[0] round
     /* 2120448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120451 */     // MIs[0] policy
     /* 2120451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120461 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2120464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120487 */     // GIR_Coverage, 17351,
     /* 2120487 */     GIR_EraseRootFromParent_Done,
     /* 2120488 */   // Label 28041: @2120488
     /* 2120488 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2120579), // Rule ID 17354 //
     /* 2120493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2120504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2120507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120539 */     // MIs[0] round
     /* 2120539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120542 */     // MIs[0] policy
     /* 2120542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120552 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2120555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120578 */     // GIR_Coverage, 17354,
     /* 2120578 */     GIR_EraseRootFromParent_Done,
     /* 2120579 */   // Label 28042: @2120579
     /* 2120579 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2120670), // Rule ID 17355 //
     /* 2120584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2120595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2120598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120630 */     // MIs[0] round
     /* 2120630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120633 */     // MIs[0] policy
     /* 2120633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120643 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2120646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120669 */     // GIR_Coverage, 17355,
     /* 2120669 */     GIR_EraseRootFromParent_Done,
     /* 2120670 */   // Label 28043: @2120670
     /* 2120670 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2120761), // Rule ID 17358 //
     /* 2120675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2120692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120721 */     // MIs[0] round
     /* 2120721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120724 */     // MIs[0] policy
     /* 2120724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120734 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2120737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120760 */     // GIR_Coverage, 17358,
     /* 2120760 */     GIR_EraseRootFromParent_Done,
     /* 2120761 */   // Label 28044: @2120761
     /* 2120761 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2120852), // Rule ID 17359 //
     /* 2120766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2120777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2120780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2120783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2120789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120812 */     // MIs[0] round
     /* 2120812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120815 */     // MIs[0] policy
     /* 2120815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120825 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2120828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120851 */     // GIR_Coverage, 17359,
     /* 2120851 */     GIR_EraseRootFromParent_Done,
     /* 2120852 */   // Label 28045: @2120852
     /* 2120852 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2120943), // Rule ID 17362 //
     /* 2120857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2120874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120903 */     // MIs[0] round
     /* 2120903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120906 */     // MIs[0] policy
     /* 2120906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2120919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120942 */     // GIR_Coverage, 17362,
     /* 2120942 */     GIR_EraseRootFromParent_Done,
     /* 2120943 */   // Label 28046: @2120943
     /* 2120943 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2121034), // Rule ID 17363 //
     /* 2120948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2120956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2120965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120994 */     // MIs[0] round
     /* 2120994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120997 */     // MIs[0] policy
     /* 2120997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121007 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2121010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121033 */     // GIR_Coverage, 17363,
     /* 2121033 */     GIR_EraseRootFromParent_Done,
     /* 2121034 */   // Label 28047: @2121034
     /* 2121034 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2121125), // Rule ID 17366 //
     /* 2121039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2121056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121085 */     // MIs[0] round
     /* 2121085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121088 */     // MIs[0] policy
     /* 2121088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2121101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121124 */     // GIR_Coverage, 17366,
     /* 2121124 */     GIR_EraseRootFromParent_Done,
     /* 2121125 */   // Label 28048: @2121125
     /* 2121125 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2121216), // Rule ID 17367 //
     /* 2121130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2121147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121176 */     // MIs[0] round
     /* 2121176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121179 */     // MIs[0] policy
     /* 2121179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121189 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11257:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2121192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121215 */     // GIR_Coverage, 17367,
     /* 2121215 */     GIR_EraseRootFromParent_Done,
     /* 2121216 */   // Label 28049: @2121216
     /* 2121216 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2121307), // Rule ID 17370 //
     /* 2121221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2121238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121267 */     // MIs[0] round
     /* 2121267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121270 */     // MIs[0] policy
     /* 2121270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121280 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2121283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121306 */     // GIR_Coverage, 17370,
     /* 2121306 */     GIR_EraseRootFromParent_Done,
     /* 2121307 */   // Label 28050: @2121307
     /* 2121307 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2121398), // Rule ID 17371 //
     /* 2121312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2121329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121358 */     // MIs[0] round
     /* 2121358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121361 */     // MIs[0] policy
     /* 2121361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121371 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11257:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2121374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121397 */     // GIR_Coverage, 17371,
     /* 2121397 */     GIR_EraseRootFromParent_Done,
     /* 2121398 */   // Label 28051: @2121398
     /* 2121398 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2121489), // Rule ID 17374 //
     /* 2121403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2121414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2121417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2121420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121449 */     // MIs[0] round
     /* 2121449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121452 */     // MIs[0] policy
     /* 2121452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121462 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2121465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121488 */     // GIR_Coverage, 17374,
     /* 2121488 */     GIR_EraseRootFromParent_Done,
     /* 2121489 */   // Label 28052: @2121489
     /* 2121489 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2121580), // Rule ID 17375 //
     /* 2121494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2121502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2121505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2121508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2121511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121540 */     // MIs[0] round
     /* 2121540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121543 */     // MIs[0] policy
     /* 2121543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121553 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11257:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2121556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121579 */     // GIR_Coverage, 17375,
     /* 2121579 */     GIR_EraseRootFromParent_Done,
     /* 2121580 */   // Label 28053: @2121580
     /* 2121580 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2121671), // Rule ID 17378 //
     /* 2121585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2121588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2121596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2121599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2121605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121631 */     // MIs[0] round
     /* 2121631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121634 */     // MIs[0] policy
     /* 2121634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121644 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2121647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121670 */     // GIR_Coverage, 17378,
     /* 2121670 */     GIR_EraseRootFromParent_Done,
     /* 2121671 */   // Label 28054: @2121671
     /* 2121671 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2121762), // Rule ID 17379 //
     /* 2121676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2121679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2121687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2121690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2121693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2121696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121722 */     // MIs[0] round
     /* 2121722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121725 */     // MIs[0] policy
     /* 2121725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121735 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2121738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121761 */     // GIR_Coverage, 17379,
     /* 2121761 */     GIR_EraseRootFromParent_Done,
     /* 2121762 */   // Label 28055: @2121762
     /* 2121762 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2121853), // Rule ID 17382 //
     /* 2121767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2121770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2121778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2121781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2121787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121813 */     // MIs[0] round
     /* 2121813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121816 */     // MIs[0] policy
     /* 2121816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121826 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2121829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121852 */     // GIR_Coverage, 17382,
     /* 2121852 */     GIR_EraseRootFromParent_Done,
     /* 2121853 */   // Label 28056: @2121853
     /* 2121853 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2121944), // Rule ID 17383 //
     /* 2121858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2121861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2121869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2121872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2121875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2121878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121904 */     // MIs[0] round
     /* 2121904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121907 */     // MIs[0] policy
     /* 2121907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121917 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2121920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121943 */     // GIR_Coverage, 17383,
     /* 2121943 */     GIR_EraseRootFromParent_Done,
     /* 2121944 */   // Label 28057: @2121944
     /* 2121944 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2122035), // Rule ID 17386 //
     /* 2121949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2121952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2121960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2121963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2121969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121995 */     // MIs[0] round
     /* 2121995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121998 */     // MIs[0] policy
     /* 2121998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122008 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2122011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122034 */     // GIR_Coverage, 17386,
     /* 2122034 */     GIR_EraseRootFromParent_Done,
     /* 2122035 */   // Label 28058: @2122035
     /* 2122035 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2122126), // Rule ID 17387 //
     /* 2122040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2122043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2122051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2122054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2122057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2122060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122086 */     // MIs[0] round
     /* 2122086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122089 */     // MIs[0] policy
     /* 2122089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122099 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2122102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122125 */     // GIR_Coverage, 17387,
     /* 2122125 */     GIR_EraseRootFromParent_Done,
     /* 2122126 */   // Label 28059: @2122126
     /* 2122126 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2122217), // Rule ID 17390 //
     /* 2122131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2122134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2122142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2122145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2122148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122177 */     // MIs[0] round
     /* 2122177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122180 */     // MIs[0] policy
     /* 2122180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2122193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122216 */     // GIR_Coverage, 17390,
     /* 2122216 */     GIR_EraseRootFromParent_Done,
     /* 2122217 */   // Label 28060: @2122217
     /* 2122217 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2122308), // Rule ID 17391 //
     /* 2122222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2122225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2122233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2122236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2122239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122268 */     // MIs[0] round
     /* 2122268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122271 */     // MIs[0] policy
     /* 2122271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122281 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2122284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122307 */     // GIR_Coverage, 17391,
     /* 2122307 */     GIR_EraseRootFromParent_Done,
     /* 2122308 */   // Label 28061: @2122308
     /* 2122308 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2122399), // Rule ID 17394 //
     /* 2122313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2122316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2122333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122359 */     // MIs[0] round
     /* 2122359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122362 */     // MIs[0] policy
     /* 2122362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122372 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2122375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122398 */     // GIR_Coverage, 17394,
     /* 2122398 */     GIR_EraseRootFromParent_Done,
     /* 2122399 */   // Label 28062: @2122399
     /* 2122399 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2122490), // Rule ID 17395 //
     /* 2122404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2122407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2122424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122450 */     // MIs[0] round
     /* 2122450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122453 */     // MIs[0] policy
     /* 2122453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122463 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2122466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122489 */     // GIR_Coverage, 17395,
     /* 2122489 */     GIR_EraseRootFromParent_Done,
     /* 2122490 */   // Label 28063: @2122490
     /* 2122490 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2122581), // Rule ID 17398 //
     /* 2122495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2122498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2122515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122541 */     // MIs[0] round
     /* 2122541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122544 */     // MIs[0] policy
     /* 2122544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122554 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2122557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122580 */     // GIR_Coverage, 17398,
     /* 2122580 */     GIR_EraseRootFromParent_Done,
     /* 2122581 */   // Label 28064: @2122581
     /* 2122581 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2122672), // Rule ID 17399 //
     /* 2122586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2122589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2122606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122632 */     // MIs[0] round
     /* 2122632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122635 */     // MIs[0] policy
     /* 2122635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122645 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2122648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122671 */     // GIR_Coverage, 17399,
     /* 2122671 */     GIR_EraseRootFromParent_Done,
     /* 2122672 */   // Label 28065: @2122672
     /* 2122672 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2122763), // Rule ID 17402 //
     /* 2122677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2122680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2122688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2122691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2122694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122723 */     // MIs[0] round
     /* 2122723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122726 */     // MIs[0] policy
     /* 2122726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122736 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2122739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122762 */     // GIR_Coverage, 17402,
     /* 2122762 */     GIR_EraseRootFromParent_Done,
     /* 2122763 */   // Label 28066: @2122763
     /* 2122763 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2122854), // Rule ID 17403 //
     /* 2122768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2122771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2122779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2122782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2122785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122814 */     // MIs[0] round
     /* 2122814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122817 */     // MIs[0] policy
     /* 2122817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2122830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122853 */     // GIR_Coverage, 17403,
     /* 2122853 */     GIR_EraseRootFromParent_Done,
     /* 2122854 */   // Label 28067: @2122854
     /* 2122854 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2122945), // Rule ID 17406 //
     /* 2122859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2122862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2122870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2122873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2122876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122905 */     // MIs[0] round
     /* 2122905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122908 */     // MIs[0] policy
     /* 2122908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122918 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2122921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122944 */     // GIR_Coverage, 17406,
     /* 2122944 */     GIR_EraseRootFromParent_Done,
     /* 2122945 */   // Label 28068: @2122945
     /* 2122945 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2123036), // Rule ID 17407 //
     /* 2122950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2122953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2122961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2122964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2122967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122996 */     // MIs[0] round
     /* 2122996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122999 */     // MIs[0] policy
     /* 2122999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123009 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2123012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123035 */     // GIR_Coverage, 17407,
     /* 2123035 */     GIR_EraseRootFromParent_Done,
     /* 2123036 */   // Label 28069: @2123036
     /* 2123036 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2123127), // Rule ID 17410 //
     /* 2123041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2123044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2123052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2123055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2123058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2123061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2123064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123087 */     // MIs[0] round
     /* 2123087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123090 */     // MIs[0] policy
     /* 2123090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123100 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2123103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123126 */     // GIR_Coverage, 17410,
     /* 2123126 */     GIR_EraseRootFromParent_Done,
     /* 2123127 */   // Label 28070: @2123127
     /* 2123127 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2123218), // Rule ID 17411 //
     /* 2123132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2123135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2123143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2123146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2123149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2123152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2123155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123178 */     // MIs[0] round
     /* 2123178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123181 */     // MIs[0] policy
     /* 2123181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123191 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2123194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123217 */     // GIR_Coverage, 17411,
     /* 2123217 */     GIR_EraseRootFromParent_Done,
     /* 2123218 */   // Label 28071: @2123218
     /* 2123218 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2123309), // Rule ID 17414 //
     /* 2123223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2123226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2123240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123269 */     // MIs[0] round
     /* 2123269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123272 */     // MIs[0] policy
     /* 2123272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2123285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123308 */     // GIR_Coverage, 17414,
     /* 2123308 */     GIR_EraseRootFromParent_Done,
     /* 2123309 */   // Label 28072: @2123309
     /* 2123309 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2123400), // Rule ID 17415 //
     /* 2123314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2123317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2123331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123360 */     // MIs[0] round
     /* 2123360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123363 */     // MIs[0] policy
     /* 2123363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123373 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2123376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123399 */     // GIR_Coverage, 17415,
     /* 2123399 */     GIR_EraseRootFromParent_Done,
     /* 2123400 */   // Label 28073: @2123400
     /* 2123400 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2123491), // Rule ID 17418 //
     /* 2123405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2123408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2123422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123451 */     // MIs[0] round
     /* 2123451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123454 */     // MIs[0] policy
     /* 2123454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2123467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123490 */     // GIR_Coverage, 17418,
     /* 2123490 */     GIR_EraseRootFromParent_Done,
     /* 2123491 */   // Label 28074: @2123491
     /* 2123491 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2123582), // Rule ID 17419 //
     /* 2123496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2123499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2123507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2123510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2123513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123542 */     // MIs[0] round
     /* 2123542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123545 */     // MIs[0] policy
     /* 2123545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123555 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2123558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123581 */     // GIR_Coverage, 17419,
     /* 2123581 */     GIR_EraseRootFromParent_Done,
     /* 2123582 */   // Label 28075: @2123582
     /* 2123582 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2123673), // Rule ID 17422 //
     /* 2123587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2123590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2123607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123633 */     // MIs[0] round
     /* 2123633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123636 */     // MIs[0] policy
     /* 2123636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123646 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2123649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123672 */     // GIR_Coverage, 17422,
     /* 2123672 */     GIR_EraseRootFromParent_Done,
     /* 2123673 */   // Label 28076: @2123673
     /* 2123673 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2123764), // Rule ID 17423 //
     /* 2123678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2123681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2123689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2123692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2123695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2123698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123724 */     // MIs[0] round
     /* 2123724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123727 */     // MIs[0] policy
     /* 2123727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123737 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2123740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123763 */     // GIR_Coverage, 17423,
     /* 2123763 */     GIR_EraseRootFromParent_Done,
     /* 2123764 */   // Label 28077: @2123764
     /* 2123764 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2123855), // Rule ID 17426 //
     /* 2123769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2123772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2123789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123815 */     // MIs[0] round
     /* 2123815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123818 */     // MIs[0] policy
     /* 2123818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123828 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2123831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123854 */     // GIR_Coverage, 17426,
     /* 2123854 */     GIR_EraseRootFromParent_Done,
     /* 2123855 */   // Label 28078: @2123855
     /* 2123855 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2123946), // Rule ID 17427 //
     /* 2123860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2123863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2123880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123906 */     // MIs[0] round
     /* 2123906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123909 */     // MIs[0] policy
     /* 2123909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2123922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123945 */     // GIR_Coverage, 17427,
     /* 2123945 */     GIR_EraseRootFromParent_Done,
     /* 2123946 */   // Label 28079: @2123946
     /* 2123946 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2124037), // Rule ID 17430 //
     /* 2123951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2123954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2123959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2123971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123997 */     // MIs[0] round
     /* 2123997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124000 */     // MIs[0] policy
     /* 2124000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124010 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2124013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124036 */     // GIR_Coverage, 17430,
     /* 2124036 */     GIR_EraseRootFromParent_Done,
     /* 2124037 */   // Label 28080: @2124037
     /* 2124037 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2124128), // Rule ID 17431 //
     /* 2124042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2124045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2124059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2124062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124088 */     // MIs[0] round
     /* 2124088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124091 */     // MIs[0] policy
     /* 2124091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124101 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2124104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124127 */     // GIR_Coverage, 17431,
     /* 2124127 */     GIR_EraseRootFromParent_Done,
     /* 2124128 */   // Label 28081: @2124128
     /* 2124128 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2124219), // Rule ID 17434 //
     /* 2124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2124136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2124144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2124147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2124150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2124153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124179 */     // MIs[0] round
     /* 2124179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124182 */     // MIs[0] policy
     /* 2124182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124192 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2124195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124218 */     // GIR_Coverage, 17434,
     /* 2124218 */     GIR_EraseRootFromParent_Done,
     /* 2124219 */   // Label 28082: @2124219
     /* 2124219 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2124310), // Rule ID 17435 //
     /* 2124224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2124227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2124235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2124238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2124241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2124244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124270 */     // MIs[0] round
     /* 2124270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124273 */     // MIs[0] policy
     /* 2124273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124283 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2124286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124309 */     // GIR_Coverage, 17435,
     /* 2124309 */     GIR_EraseRootFromParent_Done,
     /* 2124310 */   // Label 28083: @2124310
     /* 2124310 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2124401), // Rule ID 17438 //
     /* 2124315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2124318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2124326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2124329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2124332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124361 */     // MIs[0] round
     /* 2124361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124364 */     // MIs[0] policy
     /* 2124364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124374 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2124377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124400 */     // GIR_Coverage, 17438,
     /* 2124400 */     GIR_EraseRootFromParent_Done,
     /* 2124401 */   // Label 28084: @2124401
     /* 2124401 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2124492), // Rule ID 17439 //
     /* 2124406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2124409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2124417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2124420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2124423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124452 */     // MIs[0] round
     /* 2124452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124455 */     // MIs[0] policy
     /* 2124455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124465 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2124468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124491 */     // GIR_Coverage, 17439,
     /* 2124491 */     GIR_EraseRootFromParent_Done,
     /* 2124492 */   // Label 28085: @2124492
     /* 2124492 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2124583), // Rule ID 17442 //
     /* 2124497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2124500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2124508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2124511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2124514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124543 */     // MIs[0] round
     /* 2124543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124546 */     // MIs[0] policy
     /* 2124546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124556 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2124559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124582 */     // GIR_Coverage, 17442,
     /* 2124582 */     GIR_EraseRootFromParent_Done,
     /* 2124583 */   // Label 28086: @2124583
     /* 2124583 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2124674), // Rule ID 17443 //
     /* 2124588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2124591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2124599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2124602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2124605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124634 */     // MIs[0] round
     /* 2124634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124637 */     // MIs[0] policy
     /* 2124637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124647 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2124650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124673 */     // GIR_Coverage, 17443,
     /* 2124673 */     GIR_EraseRootFromParent_Done,
     /* 2124674 */   // Label 28087: @2124674
     /* 2124674 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2124765), // Rule ID 17446 //
     /* 2124679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2124682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124725 */     // MIs[0] round
     /* 2124725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124728 */     // MIs[0] policy
     /* 2124728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124738 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2124741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124764 */     // GIR_Coverage, 17446,
     /* 2124764 */     GIR_EraseRootFromParent_Done,
     /* 2124765 */   // Label 28088: @2124765
     /* 2124765 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2124856), // Rule ID 17447 //
     /* 2124770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2124773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2124781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2124784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2124787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124816 */     // MIs[0] round
     /* 2124816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124819 */     // MIs[0] policy
     /* 2124819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124829 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2124832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124855 */     // GIR_Coverage, 17447,
     /* 2124855 */     GIR_EraseRootFromParent_Done,
     /* 2124856 */   // Label 28089: @2124856
     /* 2124856 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2124947), // Rule ID 17450 //
     /* 2124861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2124864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2124872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2124875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2124878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124907 */     // MIs[0] round
     /* 2124907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124910 */     // MIs[0] policy
     /* 2124910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124920 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2124923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124946 */     // GIR_Coverage, 17450,
     /* 2124946 */     GIR_EraseRootFromParent_Done,
     /* 2124947 */   // Label 28090: @2124947
     /* 2124947 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2125038), // Rule ID 17451 //
     /* 2124952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2124955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2124960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2124963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2124966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2124969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124998 */     // MIs[0] round
     /* 2124998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125001 */     // MIs[0] policy
     /* 2125001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125011 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2125014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125037 */     // GIR_Coverage, 17451,
     /* 2125037 */     GIR_EraseRootFromParent_Done,
     /* 2125038 */   // Label 28091: @2125038
     /* 2125038 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2125129), // Rule ID 17454 //
     /* 2125043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2125046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125089 */     // MIs[0] round
     /* 2125089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125092 */     // MIs[0] policy
     /* 2125092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2125105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125128 */     // GIR_Coverage, 17454,
     /* 2125128 */     GIR_EraseRootFromParent_Done,
     /* 2125129 */   // Label 28092: @2125129
     /* 2125129 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2125220), // Rule ID 17455 //
     /* 2125134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2125137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125180 */     // MIs[0] round
     /* 2125180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125183 */     // MIs[0] policy
     /* 2125183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125193 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2125196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125219 */     // GIR_Coverage, 17455,
     /* 2125219 */     GIR_EraseRootFromParent_Done,
     /* 2125220 */   // Label 28093: @2125220
     /* 2125220 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2125311), // Rule ID 17458 //
     /* 2125225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2125228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2125242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2125245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2125267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125271 */     // MIs[0] round
     /* 2125271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125274 */     // MIs[0] policy
     /* 2125274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125284 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2125287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125310 */     // GIR_Coverage, 17458,
     /* 2125310 */     GIR_EraseRootFromParent_Done,
     /* 2125311 */   // Label 28094: @2125311
     /* 2125311 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2125402), // Rule ID 17459 //
     /* 2125316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2125319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2125327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2125330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2125333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2125336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2125358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125362 */     // MIs[0] round
     /* 2125362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125365 */     // MIs[0] policy
     /* 2125365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2125378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125401 */     // GIR_Coverage, 17459,
     /* 2125401 */     GIR_EraseRootFromParent_Done,
     /* 2125402 */   // Label 28095: @2125402
     /* 2125402 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2125493), // Rule ID 17462 //
     /* 2125407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2125418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2125421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2125424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125453 */     // MIs[0] round
     /* 2125453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125456 */     // MIs[0] policy
     /* 2125456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125466 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2125469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125492 */     // GIR_Coverage, 17462,
     /* 2125492 */     GIR_EraseRootFromParent_Done,
     /* 2125493 */   // Label 28096: @2125493
     /* 2125493 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2125584), // Rule ID 17463 //
     /* 2125498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2125501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2125509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2125512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2125515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125544 */     // MIs[0] round
     /* 2125544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125547 */     // MIs[0] policy
     /* 2125547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125557 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2125560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125583 */     // GIR_Coverage, 17463,
     /* 2125583 */     GIR_EraseRootFromParent_Done,
     /* 2125584 */   // Label 28097: @2125584
     /* 2125584 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2125675), // Rule ID 17466 //
     /* 2125589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2125600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2125603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2125606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125635 */     // MIs[0] round
     /* 2125635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125638 */     // MIs[0] policy
     /* 2125638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125648 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2125651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125674 */     // GIR_Coverage, 17466,
     /* 2125674 */     GIR_EraseRootFromParent_Done,
     /* 2125675 */   // Label 28098: @2125675
     /* 2125675 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2125766), // Rule ID 17467 //
     /* 2125680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2125683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2125691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2125694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2125697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125726 */     // MIs[0] round
     /* 2125726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125729 */     // MIs[0] policy
     /* 2125729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125739 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2125742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125765 */     // GIR_Coverage, 17467,
     /* 2125765 */     GIR_EraseRootFromParent_Done,
     /* 2125766 */   // Label 28099: @2125766
     /* 2125766 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2125857), // Rule ID 17470 //
     /* 2125771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2125782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2125785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2125788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2125794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125817 */     // MIs[0] round
     /* 2125817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125820 */     // MIs[0] policy
     /* 2125820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125830 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2125833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125856 */     // GIR_Coverage, 17470,
     /* 2125856 */     GIR_EraseRootFromParent_Done,
     /* 2125857 */   // Label 28100: @2125857
     /* 2125857 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2125948), // Rule ID 17471 //
     /* 2125862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2125865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2125873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2125876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2125879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2125885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125908 */     // MIs[0] round
     /* 2125908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125911 */     // MIs[0] policy
     /* 2125911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125921 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2125924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125947 */     // GIR_Coverage, 17471,
     /* 2125947 */     GIR_EraseRootFromParent_Done,
     /* 2125948 */   // Label 28101: @2125948
     /* 2125948 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2126039), // Rule ID 17474 //
     /* 2125953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2125956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2125961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2125964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2125967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125999 */     // MIs[0] round
     /* 2125999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126002 */     // MIs[0] policy
     /* 2126002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2126015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126038 */     // GIR_Coverage, 17474,
     /* 2126038 */     GIR_EraseRootFromParent_Done,
     /* 2126039 */   // Label 28102: @2126039
     /* 2126039 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2126130), // Rule ID 17475 //
     /* 2126044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2126047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2126055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2126058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2126061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126090 */     // MIs[0] round
     /* 2126090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126093 */     // MIs[0] policy
     /* 2126093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126103 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2126106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126129 */     // GIR_Coverage, 17475,
     /* 2126129 */     GIR_EraseRootFromParent_Done,
     /* 2126130 */   // Label 28103: @2126130
     /* 2126130 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2126221), // Rule ID 17478 //
     /* 2126135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2126138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126181 */     // MIs[0] round
     /* 2126181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126184 */     // MIs[0] policy
     /* 2126184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126194 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2126197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126220 */     // GIR_Coverage, 17478,
     /* 2126220 */     GIR_EraseRootFromParent_Done,
     /* 2126221 */   // Label 28104: @2126221
     /* 2126221 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2126312), // Rule ID 17479 //
     /* 2126226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2126229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2126237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2126240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2126243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126272 */     // MIs[0] round
     /* 2126272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126275 */     // MIs[0] policy
     /* 2126275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126285 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2126288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126311 */     // GIR_Coverage, 17479,
     /* 2126311 */     GIR_EraseRootFromParent_Done,
     /* 2126312 */   // Label 28105: @2126312
     /* 2126312 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2126403), // Rule ID 17482 //
     /* 2126317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2126320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126363 */     // MIs[0] round
     /* 2126363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126366 */     // MIs[0] policy
     /* 2126366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126376 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2126379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126402 */     // GIR_Coverage, 17482,
     /* 2126402 */     GIR_EraseRootFromParent_Done,
     /* 2126403 */   // Label 28106: @2126403
     /* 2126403 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2126494), // Rule ID 17483 //
     /* 2126408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2126411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126454 */     // MIs[0] round
     /* 2126454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126457 */     // MIs[0] policy
     /* 2126457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126467 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2126470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126493 */     // GIR_Coverage, 17483,
     /* 2126493 */     GIR_EraseRootFromParent_Done,
     /* 2126494 */   // Label 28107: @2126494
     /* 2126494 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2126585), // Rule ID 17486 //
     /* 2126499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2126502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126545 */     // MIs[0] round
     /* 2126545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126548 */     // MIs[0] policy
     /* 2126548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2126561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126584 */     // GIR_Coverage, 17486,
     /* 2126584 */     GIR_EraseRootFromParent_Done,
     /* 2126585 */   // Label 28108: @2126585
     /* 2126585 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2126676), // Rule ID 17487 //
     /* 2126590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2126593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126636 */     // MIs[0] round
     /* 2126636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126639 */     // MIs[0] policy
     /* 2126639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126649 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2126652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126675 */     // GIR_Coverage, 17487,
     /* 2126675 */     GIR_EraseRootFromParent_Done,
     /* 2126676 */   // Label 28109: @2126676
     /* 2126676 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2126767), // Rule ID 17490 //
     /* 2126681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2126684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126727 */     // MIs[0] round
     /* 2126727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126730 */     // MIs[0] policy
     /* 2126730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126740 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2126743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126766 */     // GIR_Coverage, 17490,
     /* 2126766 */     GIR_EraseRootFromParent_Done,
     /* 2126767 */   // Label 28110: @2126767
     /* 2126767 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2126858), // Rule ID 17491 //
     /* 2126772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2126775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126818 */     // MIs[0] round
     /* 2126818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126821 */     // MIs[0] policy
     /* 2126821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126831 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2126834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126857 */     // GIR_Coverage, 17491,
     /* 2126857 */     GIR_EraseRootFromParent_Done,
     /* 2126858 */   // Label 28111: @2126858
     /* 2126858 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2126949), // Rule ID 17494 //
     /* 2126863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2126866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126909 */     // MIs[0] round
     /* 2126909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126912 */     // MIs[0] policy
     /* 2126912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126922 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2126925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126948 */     // GIR_Coverage, 17494,
     /* 2126948 */     GIR_EraseRootFromParent_Done,
     /* 2126949 */   // Label 28112: @2126949
     /* 2126949 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2127040), // Rule ID 17495 //
     /* 2126954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2126957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2126962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127000 */     // MIs[0] round
     /* 2127000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127003 */     // MIs[0] policy
     /* 2127003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127013 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2127016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2127036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127039 */     // GIR_Coverage, 17495,
     /* 2127039 */     GIR_EraseRootFromParent_Done,
     /* 2127040 */   // Label 28113: @2127040
     /* 2127040 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2127131), // Rule ID 17498 //
     /* 2127045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2127048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2127056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2127059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2127062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2127065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127091 */     // MIs[0] round
     /* 2127091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127094 */     // MIs[0] policy
     /* 2127094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127104 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2127107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127130 */     // GIR_Coverage, 17498,
     /* 2127130 */     GIR_EraseRootFromParent_Done,
     /* 2127131 */   // Label 28114: @2127131
     /* 2127131 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2127222), // Rule ID 17499 //
     /* 2127136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2127139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2127147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2127150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2127153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2127156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127182 */     // MIs[0] round
     /* 2127182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127185 */     // MIs[0] policy
     /* 2127185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127195 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2127198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127221 */     // GIR_Coverage, 17499,
     /* 2127221 */     GIR_EraseRootFromParent_Done,
     /* 2127222 */   // Label 28115: @2127222
     /* 2127222 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2127313), // Rule ID 17502 //
     /* 2127227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2127230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2127238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2127241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2127244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2127247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127273 */     // MIs[0] round
     /* 2127273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127276 */     // MIs[0] policy
     /* 2127276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127286 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2127289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127312 */     // GIR_Coverage, 17502,
     /* 2127312 */     GIR_EraseRootFromParent_Done,
     /* 2127313 */   // Label 28116: @2127313
     /* 2127313 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2127404), // Rule ID 17503 //
     /* 2127318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2127321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2127329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2127332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2127335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2127338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127364 */     // MIs[0] round
     /* 2127364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127367 */     // MIs[0] policy
     /* 2127367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127377 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2127380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127403 */     // GIR_Coverage, 17503,
     /* 2127403 */     GIR_EraseRootFromParent_Done,
     /* 2127404 */   // Label 28117: @2127404
     /* 2127404 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2127495), // Rule ID 17506 //
     /* 2127409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2127412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2127429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127455 */     // MIs[0] round
     /* 2127455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127458 */     // MIs[0] policy
     /* 2127458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127468 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2127471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127494 */     // GIR_Coverage, 17506,
     /* 2127494 */     GIR_EraseRootFromParent_Done,
     /* 2127495 */   // Label 28118: @2127495
     /* 2127495 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2127586), // Rule ID 17507 //
     /* 2127500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2127503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2127511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2127514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2127517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2127520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127546 */     // MIs[0] round
     /* 2127546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127549 */     // MIs[0] policy
     /* 2127549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127559 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2127562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127585 */     // GIR_Coverage, 17507,
     /* 2127585 */     GIR_EraseRootFromParent_Done,
     /* 2127586 */   // Label 28119: @2127586
     /* 2127586 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2127677), // Rule ID 17510 //
     /* 2127591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2127594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2127602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2127605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2127608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2127611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127637 */     // MIs[0] round
     /* 2127637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127640 */     // MIs[0] policy
     /* 2127640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2127653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127676 */     // GIR_Coverage, 17510,
     /* 2127676 */     GIR_EraseRootFromParent_Done,
     /* 2127677 */   // Label 28120: @2127677
     /* 2127677 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2127768), // Rule ID 17511 //
     /* 2127682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2127685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2127693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2127696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2127699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2127702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127728 */     // MIs[0] round
     /* 2127728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127731 */     // MIs[0] policy
     /* 2127731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127741 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2127744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127767 */     // GIR_Coverage, 17511,
     /* 2127767 */     GIR_EraseRootFromParent_Done,
     /* 2127768 */   // Label 28121: @2127768
     /* 2127768 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2127859), // Rule ID 17514 //
     /* 2127773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2127776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2127793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127819 */     // MIs[0] round
     /* 2127819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127822 */     // MIs[0] policy
     /* 2127822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127832 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2127835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127858 */     // GIR_Coverage, 17514,
     /* 2127858 */     GIR_EraseRootFromParent_Done,
     /* 2127859 */   // Label 28122: @2127859
     /* 2127859 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2127950), // Rule ID 17515 //
     /* 2127864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2127867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2127884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127910 */     // MIs[0] round
     /* 2127910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127913 */     // MIs[0] policy
     /* 2127913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127923 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2127926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127949 */     // GIR_Coverage, 17515,
     /* 2127949 */     GIR_EraseRootFromParent_Done,
     /* 2127950 */   // Label 28123: @2127950
     /* 2127950 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2128041), // Rule ID 17518 //
     /* 2127955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2127958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2127966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2127969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2127972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2127975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128001 */     // MIs[0] round
     /* 2128001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128004 */     // MIs[0] policy
     /* 2128004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128014 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2128017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2128037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128040 */     // GIR_Coverage, 17518,
     /* 2128040 */     GIR_EraseRootFromParent_Done,
     /* 2128041 */   // Label 28124: @2128041
     /* 2128041 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2128132), // Rule ID 17519 //
     /* 2128046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2128049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2128057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2128060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2128063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2128066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128092 */     // MIs[0] round
     /* 2128092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128095 */     // MIs[0] policy
     /* 2128095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128105 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2128108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2128128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128131 */     // GIR_Coverage, 17519,
     /* 2128131 */     GIR_EraseRootFromParent_Done,
     /* 2128132 */   // Label 28125: @2128132
     /* 2128132 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2128223), // Rule ID 17522 //
     /* 2128137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2128148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2128151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2128154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2128157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128183 */     // MIs[0] round
     /* 2128183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128186 */     // MIs[0] policy
     /* 2128186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2128199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128222 */     // GIR_Coverage, 17522,
     /* 2128222 */     GIR_EraseRootFromParent_Done,
     /* 2128223 */   // Label 28126: @2128223
     /* 2128223 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2128314), // Rule ID 17523 //
     /* 2128228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2128239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2128242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2128245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2128248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128274 */     // MIs[0] round
     /* 2128274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128277 */     // MIs[0] policy
     /* 2128277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128287 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2128290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128313 */     // GIR_Coverage, 17523,
     /* 2128313 */     GIR_EraseRootFromParent_Done,
     /* 2128314 */   // Label 28127: @2128314
     /* 2128314 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2128405), // Rule ID 17526 //
     /* 2128319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2128330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2128333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2128336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2128339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128365 */     // MIs[0] round
     /* 2128365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128368 */     // MIs[0] policy
     /* 2128368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128378 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2128381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128404 */     // GIR_Coverage, 17526,
     /* 2128404 */     GIR_EraseRootFromParent_Done,
     /* 2128405 */   // Label 28128: @2128405
     /* 2128405 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2128496), // Rule ID 17527 //
     /* 2128410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2128421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2128424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2128427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2128430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2128433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128456 */     // MIs[0] round
     /* 2128456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128459 */     // MIs[0] policy
     /* 2128459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128469 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2128472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128495 */     // GIR_Coverage, 17527,
     /* 2128495 */     GIR_EraseRootFromParent_Done,
     /* 2128496 */   // Label 28129: @2128496
     /* 2128496 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2128587), // Rule ID 17530 //
     /* 2128501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2128512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2128515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2128518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2128521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2128524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128547 */     // MIs[0] round
     /* 2128547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128550 */     // MIs[0] policy
     /* 2128550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128560 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2128563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128586 */     // GIR_Coverage, 17530,
     /* 2128586 */     GIR_EraseRootFromParent_Done,
     /* 2128587 */   // Label 28130: @2128587
     /* 2128587 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2128678), // Rule ID 17531 //
     /* 2128592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2128603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2128606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2128609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2128612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2128615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128638 */     // MIs[0] round
     /* 2128638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128641 */     // MIs[0] policy
     /* 2128641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128651 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2128654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128677 */     // GIR_Coverage, 17531,
     /* 2128677 */     GIR_EraseRootFromParent_Done,
     /* 2128678 */   // Label 28131: @2128678
     /* 2128678 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2128769), // Rule ID 17534 //
     /* 2128683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2128694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2128697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2128700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2128703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128729 */     // MIs[0] round
     /* 2128729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128732 */     // MIs[0] policy
     /* 2128732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128742 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2128745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128768 */     // GIR_Coverage, 17534,
     /* 2128768 */     GIR_EraseRootFromParent_Done,
     /* 2128769 */   // Label 28132: @2128769
     /* 2128769 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2128860), // Rule ID 17535 //
     /* 2128774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2128785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2128788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2128791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2128794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128820 */     // MIs[0] round
     /* 2128820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128823 */     // MIs[0] policy
     /* 2128823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128833 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2128836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128859 */     // GIR_Coverage, 17535,
     /* 2128859 */     GIR_EraseRootFromParent_Done,
     /* 2128860 */   // Label 28133: @2128860
     /* 2128860 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2128951), // Rule ID 17538 //
     /* 2128865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2128876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2128879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2128882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2128885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128911 */     // MIs[0] round
     /* 2128911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128914 */     // MIs[0] policy
     /* 2128914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2128927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128950 */     // GIR_Coverage, 17538,
     /* 2128950 */     GIR_EraseRootFromParent_Done,
     /* 2128951 */   // Label 28134: @2128951
     /* 2128951 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2129042), // Rule ID 17539 //
     /* 2128956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2128967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2128970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2128973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2128976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129002 */     // MIs[0] round
     /* 2129002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129005 */     // MIs[0] policy
     /* 2129005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129015 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2129018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129041 */     // GIR_Coverage, 17539,
     /* 2129041 */     GIR_EraseRootFromParent_Done,
     /* 2129042 */   // Label 28135: @2129042
     /* 2129042 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2129133), // Rule ID 17542 //
     /* 2129047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2129058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2129061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2129064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2129067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129093 */     // MIs[0] round
     /* 2129093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129096 */     // MIs[0] policy
     /* 2129096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129106 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2129109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129132 */     // GIR_Coverage, 17542,
     /* 2129132 */     GIR_EraseRootFromParent_Done,
     /* 2129133 */   // Label 28136: @2129133
     /* 2129133 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2129224), // Rule ID 17543 //
     /* 2129138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2129149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2129152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2129155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2129158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129184 */     // MIs[0] round
     /* 2129184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129187 */     // MIs[0] policy
     /* 2129187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129197 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2129200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129223 */     // GIR_Coverage, 17543,
     /* 2129223 */     GIR_EraseRootFromParent_Done,
     /* 2129224 */   // Label 28137: @2129224
     /* 2129224 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2129315), // Rule ID 17546 //
     /* 2129229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2129240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2129243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2129246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2129249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129275 */     // MIs[0] round
     /* 2129275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129278 */     // MIs[0] policy
     /* 2129278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129288 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2129291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129314 */     // GIR_Coverage, 17546,
     /* 2129314 */     GIR_EraseRootFromParent_Done,
     /* 2129315 */   // Label 28138: @2129315
     /* 2129315 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2129406), // Rule ID 17547 //
     /* 2129320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2129331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2129334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2129337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2129340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129366 */     // MIs[0] round
     /* 2129366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129369 */     // MIs[0] policy
     /* 2129369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2129382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129405 */     // GIR_Coverage, 17547,
     /* 2129405 */     GIR_EraseRootFromParent_Done,
     /* 2129406 */   // Label 28139: @2129406
     /* 2129406 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2129497), // Rule ID 17550 //
     /* 2129411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2129422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2129425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2129428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2129431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129457 */     // MIs[0] round
     /* 2129457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129460 */     // MIs[0] policy
     /* 2129460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129470 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2129473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129496 */     // GIR_Coverage, 17550,
     /* 2129496 */     GIR_EraseRootFromParent_Done,
     /* 2129497 */   // Label 28140: @2129497
     /* 2129497 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2129588), // Rule ID 17551 //
     /* 2129502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2129513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2129516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2129519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2129522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129548 */     // MIs[0] round
     /* 2129548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129551 */     // MIs[0] policy
     /* 2129551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129561 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2129564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129587 */     // GIR_Coverage, 17551,
     /* 2129587 */     GIR_EraseRootFromParent_Done,
     /* 2129588 */   // Label 28141: @2129588
     /* 2129588 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2129679), // Rule ID 17554 //
     /* 2129593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2129604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2129607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2129610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2129613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129639 */     // MIs[0] round
     /* 2129639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129642 */     // MIs[0] policy
     /* 2129642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129652 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2129655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129678 */     // GIR_Coverage, 17554,
     /* 2129678 */     GIR_EraseRootFromParent_Done,
     /* 2129679 */   // Label 28142: @2129679
     /* 2129679 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2129770), // Rule ID 17555 //
     /* 2129684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2129695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2129698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2129701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2129704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129730 */     // MIs[0] round
     /* 2129730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129733 */     // MIs[0] policy
     /* 2129733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129743 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2129746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129769 */     // GIR_Coverage, 17555,
     /* 2129769 */     GIR_EraseRootFromParent_Done,
     /* 2129770 */   // Label 28143: @2129770
     /* 2129770 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2129861), // Rule ID 17558 //
     /* 2129775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2129786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2129789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2129792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129821 */     // MIs[0] round
     /* 2129821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129824 */     // MIs[0] policy
     /* 2129824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129834 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2129837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129860 */     // GIR_Coverage, 17558,
     /* 2129860 */     GIR_EraseRootFromParent_Done,
     /* 2129861 */   // Label 28144: @2129861
     /* 2129861 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2129952), // Rule ID 17559 //
     /* 2129866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2129877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2129880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2129883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129912 */     // MIs[0] round
     /* 2129912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129915 */     // MIs[0] policy
     /* 2129915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129925 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2129928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129951 */     // GIR_Coverage, 17559,
     /* 2129951 */     GIR_EraseRootFromParent_Done,
     /* 2129952 */   // Label 28145: @2129952
     /* 2129952 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2130043), // Rule ID 17562 //
     /* 2129957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2129965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2129968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2129971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2129974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130003 */     // MIs[0] round
     /* 2130003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130006 */     // MIs[0] policy
     /* 2130006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130016 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2130019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130042 */     // GIR_Coverage, 17562,
     /* 2130042 */     GIR_EraseRootFromParent_Done,
     /* 2130043 */   // Label 28146: @2130043
     /* 2130043 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2130134), // Rule ID 17563 //
     /* 2130048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2130059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2130062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2130065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130094 */     // MIs[0] round
     /* 2130094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130097 */     // MIs[0] policy
     /* 2130097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130107 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2130110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130133 */     // GIR_Coverage, 17563,
     /* 2130133 */     GIR_EraseRootFromParent_Done,
     /* 2130134 */   // Label 28147: @2130134
     /* 2130134 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2130225), // Rule ID 17566 //
     /* 2130139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2130156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130185 */     // MIs[0] round
     /* 2130185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130188 */     // MIs[0] policy
     /* 2130188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130198 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2130201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130224 */     // GIR_Coverage, 17566,
     /* 2130224 */     GIR_EraseRootFromParent_Done,
     /* 2130225 */   // Label 28148: @2130225
     /* 2130225 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2130316), // Rule ID 17567 //
     /* 2130230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2130247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130276 */     // MIs[0] round
     /* 2130276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130279 */     // MIs[0] policy
     /* 2130279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130289 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2130292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130315 */     // GIR_Coverage, 17567,
     /* 2130315 */     GIR_EraseRootFromParent_Done,
     /* 2130316 */   // Label 28149: @2130316
     /* 2130316 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2130407), // Rule ID 17570 //
     /* 2130321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2130332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2130335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2130338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130367 */     // MIs[0] round
     /* 2130367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130370 */     // MIs[0] policy
     /* 2130370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2130383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130406 */     // GIR_Coverage, 17570,
     /* 2130406 */     GIR_EraseRootFromParent_Done,
     /* 2130407 */   // Label 28150: @2130407
     /* 2130407 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2130498), // Rule ID 17571 //
     /* 2130412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2130423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2130426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2130429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130458 */     // MIs[0] round
     /* 2130458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130461 */     // MIs[0] policy
     /* 2130461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130471 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2130474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130497 */     // GIR_Coverage, 17571,
     /* 2130497 */     GIR_EraseRootFromParent_Done,
     /* 2130498 */   // Label 28151: @2130498
     /* 2130498 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2130589), // Rule ID 17574 //
     /* 2130503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2130514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2130517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2130520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130549 */     // MIs[0] round
     /* 2130549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130552 */     // MIs[0] policy
     /* 2130552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130562 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2130565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130588 */     // GIR_Coverage, 17574,
     /* 2130588 */     GIR_EraseRootFromParent_Done,
     /* 2130589 */   // Label 28152: @2130589
     /* 2130589 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2130680), // Rule ID 17575 //
     /* 2130594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2130605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2130608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2130611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130640 */     // MIs[0] round
     /* 2130640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130643 */     // MIs[0] policy
     /* 2130643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130653 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2130656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130679 */     // GIR_Coverage, 17575,
     /* 2130679 */     GIR_EraseRootFromParent_Done,
     /* 2130680 */   // Label 28153: @2130680
     /* 2130680 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2130771), // Rule ID 17578 //
     /* 2130685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2130696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2130699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2130702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130731 */     // MIs[0] round
     /* 2130731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130734 */     // MIs[0] policy
     /* 2130734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2130747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130770 */     // GIR_Coverage, 17578,
     /* 2130770 */     GIR_EraseRootFromParent_Done,
     /* 2130771 */   // Label 28154: @2130771
     /* 2130771 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2130862), // Rule ID 17579 //
     /* 2130776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2130787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2130790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2130793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130822 */     // MIs[0] round
     /* 2130822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130825 */     // MIs[0] policy
     /* 2130825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130835 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2130838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130861 */     // GIR_Coverage, 17579,
     /* 2130861 */     GIR_EraseRootFromParent_Done,
     /* 2130862 */   // Label 28155: @2130862
     /* 2130862 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2130953), // Rule ID 17582 //
     /* 2130867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2130870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2130909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130913 */     // MIs[0] round
     /* 2130913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130916 */     // MIs[0] policy
     /* 2130916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130952 */     // GIR_Coverage, 17582,
     /* 2130952 */     GIR_EraseRootFromParent_Done,
     /* 2130953 */   // Label 28156: @2130953
     /* 2130953 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2131044), // Rule ID 17583 //
     /* 2130958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2130966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2130969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2130972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2130975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2130978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131004 */     // MIs[0] round
     /* 2131004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131007 */     // MIs[0] policy
     /* 2131007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131017 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2131020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131043 */     // GIR_Coverage, 17583,
     /* 2131043 */     GIR_EraseRootFromParent_Done,
     /* 2131044 */   // Label 28157: @2131044
     /* 2131044 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2131135), // Rule ID 17586 //
     /* 2131049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2131060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2131063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2131066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131095 */     // MIs[0] round
     /* 2131095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131098 */     // MIs[0] policy
     /* 2131098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131108 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2131111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131134 */     // GIR_Coverage, 17586,
     /* 2131134 */     GIR_EraseRootFromParent_Done,
     /* 2131135 */   // Label 28158: @2131135
     /* 2131135 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2131226), // Rule ID 17587 //
     /* 2131140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2131151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2131154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2131157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131186 */     // MIs[0] round
     /* 2131186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131189 */     // MIs[0] policy
     /* 2131189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131199 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2131202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131225 */     // GIR_Coverage, 17587,
     /* 2131225 */     GIR_EraseRootFromParent_Done,
     /* 2131226 */   // Label 28159: @2131226
     /* 2131226 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2131317), // Rule ID 17590 //
     /* 2131231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2131242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2131245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2131248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2131254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131277 */     // MIs[0] round
     /* 2131277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131280 */     // MIs[0] policy
     /* 2131280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131290 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2131293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131316 */     // GIR_Coverage, 17590,
     /* 2131316 */     GIR_EraseRootFromParent_Done,
     /* 2131317 */   // Label 28160: @2131317
     /* 2131317 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2131408), // Rule ID 17591 //
     /* 2131322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2131333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2131336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2131339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2131345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131368 */     // MIs[0] round
     /* 2131368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131371 */     // MIs[0] policy
     /* 2131371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131381 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2131384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131407 */     // GIR_Coverage, 17591,
     /* 2131407 */     GIR_EraseRootFromParent_Done,
     /* 2131408 */   // Label 28161: @2131408
     /* 2131408 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2131499), // Rule ID 17594 //
     /* 2131413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2131430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131459 */     // MIs[0] round
     /* 2131459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131462 */     // MIs[0] policy
     /* 2131462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2131475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131498 */     // GIR_Coverage, 17594,
     /* 2131498 */     GIR_EraseRootFromParent_Done,
     /* 2131499 */   // Label 28162: @2131499
     /* 2131499 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2131590), // Rule ID 17595 //
     /* 2131504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2131521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131550 */     // MIs[0] round
     /* 2131550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131553 */     // MIs[0] policy
     /* 2131553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2131566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131589 */     // GIR_Coverage, 17595,
     /* 2131589 */     GIR_EraseRootFromParent_Done,
     /* 2131590 */   // Label 28163: @2131590
     /* 2131590 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2131681), // Rule ID 17598 //
     /* 2131595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2131612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131641 */     // MIs[0] round
     /* 2131641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131644 */     // MIs[0] policy
     /* 2131644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131654 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2131657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131680 */     // GIR_Coverage, 17598,
     /* 2131680 */     GIR_EraseRootFromParent_Done,
     /* 2131681 */   // Label 28164: @2131681
     /* 2131681 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2131772), // Rule ID 17599 //
     /* 2131686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2131703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131732 */     // MIs[0] round
     /* 2131732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131735 */     // MIs[0] policy
     /* 2131735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131745 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2131748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131771 */     // GIR_Coverage, 17599,
     /* 2131771 */     GIR_EraseRootFromParent_Done,
     /* 2131772 */   // Label 28165: @2131772
     /* 2131772 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2131863), // Rule ID 17602 //
     /* 2131777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131823 */     // MIs[0] round
     /* 2131823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131826 */     // MIs[0] policy
     /* 2131826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2131839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131862 */     // GIR_Coverage, 17602,
     /* 2131862 */     GIR_EraseRootFromParent_Done,
     /* 2131863 */   // Label 28166: @2131863
     /* 2131863 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2131954), // Rule ID 17603 //
     /* 2131868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2131885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131914 */     // MIs[0] round
     /* 2131914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131917 */     // MIs[0] policy
     /* 2131917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131927 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2131930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131953 */     // GIR_Coverage, 17603,
     /* 2131953 */     GIR_EraseRootFromParent_Done,
     /* 2131954 */   // Label 28167: @2131954
     /* 2131954 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2132045), // Rule ID 17606 //
     /* 2131959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2131967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2131976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2131979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132005 */     // MIs[0] round
     /* 2132005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132008 */     // MIs[0] policy
     /* 2132008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132018 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2132021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132044 */     // GIR_Coverage, 17606,
     /* 2132044 */     GIR_EraseRootFromParent_Done,
     /* 2132045 */   // Label 28168: @2132045
     /* 2132045 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2132136), // Rule ID 17607 //
     /* 2132050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2132058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2132061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2132064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2132067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132096 */     // MIs[0] round
     /* 2132096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132099 */     // MIs[0] policy
     /* 2132099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132109 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2132112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132135 */     // GIR_Coverage, 17607,
     /* 2132135 */     GIR_EraseRootFromParent_Done,
     /* 2132136 */   // Label 28169: @2132136
     /* 2132136 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2132227), // Rule ID 17610 //
     /* 2132141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2132149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2132152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2132155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2132158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132187 */     // MIs[0] round
     /* 2132187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132190 */     // MIs[0] policy
     /* 2132190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132200 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2132203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132226 */     // GIR_Coverage, 17610,
     /* 2132226 */     GIR_EraseRootFromParent_Done,
     /* 2132227 */   // Label 28170: @2132227
     /* 2132227 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2132318), // Rule ID 17611 //
     /* 2132232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2132240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2132243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2132246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2132249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132278 */     // MIs[0] round
     /* 2132278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132281 */     // MIs[0] policy
     /* 2132281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132291 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2132294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132317 */     // GIR_Coverage, 17611,
     /* 2132317 */     GIR_EraseRootFromParent_Done,
     /* 2132318 */   // Label 28171: @2132318
     /* 2132318 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2132409), // Rule ID 17614 //
     /* 2132323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2132331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2132340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132369 */     // MIs[0] round
     /* 2132369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132372 */     // MIs[0] policy
     /* 2132372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132382 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2132385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132408 */     // GIR_Coverage, 17614,
     /* 2132408 */     GIR_EraseRootFromParent_Done,
     /* 2132409 */   // Label 28172: @2132409
     /* 2132409 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2132500), // Rule ID 17615 //
     /* 2132414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2132422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2132431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132460 */     // MIs[0] round
     /* 2132460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132463 */     // MIs[0] policy
     /* 2132463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132473 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2132476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132499 */     // GIR_Coverage, 17615,
     /* 2132499 */     GIR_EraseRootFromParent_Done,
     /* 2132500 */   // Label 28173: @2132500
     /* 2132500 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2132591), // Rule ID 17618 //
     /* 2132505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2132516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132551 */     // MIs[0] round
     /* 2132551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132554 */     // MIs[0] policy
     /* 2132554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132564 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2132567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132590 */     // GIR_Coverage, 17618,
     /* 2132590 */     GIR_EraseRootFromParent_Done,
     /* 2132591 */   // Label 28174: @2132591
     /* 2132591 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2132682), // Rule ID 17619 //
     /* 2132596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2132607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2132610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132642 */     // MIs[0] round
     /* 2132642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132645 */     // MIs[0] policy
     /* 2132645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132655 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2132658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132681 */     // GIR_Coverage, 17619,
     /* 2132681 */     GIR_EraseRootFromParent_Done,
     /* 2132682 */   // Label 28175: @2132682
     /* 2132682 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2132773), // Rule ID 17622 //
     /* 2132687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2132698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2132701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132733 */     // MIs[0] round
     /* 2132733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132736 */     // MIs[0] policy
     /* 2132736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2132749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132772 */     // GIR_Coverage, 17622,
     /* 2132772 */     GIR_EraseRootFromParent_Done,
     /* 2132773 */   // Label 28176: @2132773
     /* 2132773 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2132864), // Rule ID 17623 //
     /* 2132778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2132789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2132792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132824 */     // MIs[0] round
     /* 2132824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132827 */     // MIs[0] policy
     /* 2132827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132837 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2132840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132863 */     // GIR_Coverage, 17623,
     /* 2132863 */     GIR_EraseRootFromParent_Done,
     /* 2132864 */   // Label 28177: @2132864
     /* 2132864 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2132955), // Rule ID 17626 //
     /* 2132869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132915 */     // MIs[0] round
     /* 2132915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132918 */     // MIs[0] policy
     /* 2132918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132928 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2132931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132954 */     // GIR_Coverage, 17626,
     /* 2132954 */     GIR_EraseRootFromParent_Done,
     /* 2132955 */   // Label 28178: @2132955
     /* 2132955 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2133046), // Rule ID 17627 //
     /* 2132960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2132968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2132977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133006 */     // MIs[0] round
     /* 2133006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133009 */     // MIs[0] policy
     /* 2133009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133019 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2133022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133045 */     // GIR_Coverage, 17627,
     /* 2133045 */     GIR_EraseRootFromParent_Done,
     /* 2133046 */   // Label 28179: @2133046
     /* 2133046 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2133137), // Rule ID 17630 //
     /* 2133051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2133062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2133065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2133068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133097 */     // MIs[0] round
     /* 2133097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133100 */     // MIs[0] policy
     /* 2133100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2133113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133136 */     // GIR_Coverage, 17630,
     /* 2133136 */     GIR_EraseRootFromParent_Done,
     /* 2133137 */   // Label 28180: @2133137
     /* 2133137 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2133228), // Rule ID 17631 //
     /* 2133142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2133153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2133156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2133159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133188 */     // MIs[0] round
     /* 2133188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133191 */     // MIs[0] policy
     /* 2133191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133201 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2133204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133227 */     // GIR_Coverage, 17631,
     /* 2133227 */     GIR_EraseRootFromParent_Done,
     /* 2133228 */   // Label 28181: @2133228
     /* 2133228 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2133319), // Rule ID 17634 //
     /* 2133233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2133244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2133247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133279 */     // MIs[0] round
     /* 2133279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133282 */     // MIs[0] policy
     /* 2133282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133292 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2133295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133318 */     // GIR_Coverage, 17634,
     /* 2133318 */     GIR_EraseRootFromParent_Done,
     /* 2133319 */   // Label 28182: @2133319
     /* 2133319 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2133410), // Rule ID 17635 //
     /* 2133324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2133335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2133338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133370 */     // MIs[0] round
     /* 2133370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133373 */     // MIs[0] policy
     /* 2133373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133383 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2133386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133409 */     // GIR_Coverage, 17635,
     /* 2133409 */     GIR_EraseRootFromParent_Done,
     /* 2133410 */   // Label 28183: @2133410
     /* 2133410 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2133501), // Rule ID 17638 //
     /* 2133415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133461 */     // MIs[0] round
     /* 2133461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133464 */     // MIs[0] policy
     /* 2133464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133474 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2133477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133500 */     // GIR_Coverage, 17638,
     /* 2133500 */     GIR_EraseRootFromParent_Done,
     /* 2133501 */   // Label 28184: @2133501
     /* 2133501 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2133592), // Rule ID 17639 //
     /* 2133506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2133523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133552 */     // MIs[0] round
     /* 2133552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133555 */     // MIs[0] policy
     /* 2133555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133565 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2133568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133591 */     // GIR_Coverage, 17639,
     /* 2133591 */     GIR_EraseRootFromParent_Done,
     /* 2133592 */   // Label 28185: @2133592
     /* 2133592 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2133683), // Rule ID 17642 //
     /* 2133597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2133608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2133611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133643 */     // MIs[0] round
     /* 2133643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133646 */     // MIs[0] policy
     /* 2133646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133656 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2133659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133682 */     // GIR_Coverage, 17642,
     /* 2133682 */     GIR_EraseRootFromParent_Done,
     /* 2133683 */   // Label 28186: @2133683
     /* 2133683 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2133774), // Rule ID 17643 //
     /* 2133688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2133699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2133702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133734 */     // MIs[0] round
     /* 2133734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133737 */     // MIs[0] policy
     /* 2133737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133747 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2133750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133773 */     // GIR_Coverage, 17643,
     /* 2133773 */     GIR_EraseRootFromParent_Done,
     /* 2133774 */   // Label 28187: @2133774
     /* 2133774 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2133865), // Rule ID 17646 //
     /* 2133779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133825 */     // MIs[0] round
     /* 2133825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133828 */     // MIs[0] policy
     /* 2133828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133838 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2133841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133864 */     // GIR_Coverage, 17646,
     /* 2133864 */     GIR_EraseRootFromParent_Done,
     /* 2133865 */   // Label 28188: @2133865
     /* 2133865 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2133956), // Rule ID 17647 //
     /* 2133870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2133873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2133881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2133884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133916 */     // MIs[0] round
     /* 2133916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133919 */     // MIs[0] policy
     /* 2133919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133929 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2133932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133955 */     // GIR_Coverage, 17647,
     /* 2133955 */     GIR_EraseRootFromParent_Done,
     /* 2133956 */   // Label 28189: @2133956
     /* 2133956 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2134047), // Rule ID 17650 //
     /* 2133961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2133969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2133972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2133975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2133978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2133984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2134003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134007 */     // MIs[0] round
     /* 2134007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134010 */     // MIs[0] policy
     /* 2134010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134020 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2134023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134046 */     // GIR_Coverage, 17650,
     /* 2134046 */     GIR_EraseRootFromParent_Done,
     /* 2134047 */   // Label 28190: @2134047
     /* 2134047 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2134138), // Rule ID 17651 //
     /* 2134052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2134063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2134066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2134069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2134072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2134075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2134094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134098 */     // MIs[0] round
     /* 2134098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134101 */     // MIs[0] policy
     /* 2134101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134111 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2134114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134137 */     // GIR_Coverage, 17651,
     /* 2134137 */     GIR_EraseRootFromParent_Done,
     /* 2134138 */   // Label 28191: @2134138
     /* 2134138 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2134229), // Rule ID 17654 //
     /* 2134143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2134154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2134157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2134160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134189 */     // MIs[0] round
     /* 2134189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134192 */     // MIs[0] policy
     /* 2134192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134202 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2134205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134228 */     // GIR_Coverage, 17654,
     /* 2134228 */     GIR_EraseRootFromParent_Done,
     /* 2134229 */   // Label 28192: @2134229
     /* 2134229 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2134320), // Rule ID 17655 //
     /* 2134234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2134245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2134248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2134251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134280 */     // MIs[0] round
     /* 2134280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134283 */     // MIs[0] policy
     /* 2134283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134293 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2134296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134319 */     // GIR_Coverage, 17655,
     /* 2134319 */     GIR_EraseRootFromParent_Done,
     /* 2134320 */   // Label 28193: @2134320
     /* 2134320 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2134411), // Rule ID 17658 //
     /* 2134325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2134336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2134339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2134342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134371 */     // MIs[0] round
     /* 2134371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134374 */     // MIs[0] policy
     /* 2134374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134384 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2134387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134410 */     // GIR_Coverage, 17658,
     /* 2134410 */     GIR_EraseRootFromParent_Done,
     /* 2134411 */   // Label 28194: @2134411
     /* 2134411 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2134502), // Rule ID 17659 //
     /* 2134416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2134427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2134430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2134433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134462 */     // MIs[0] round
     /* 2134462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134465 */     // MIs[0] policy
     /* 2134465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134475 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2134478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134501 */     // GIR_Coverage, 17659,
     /* 2134501 */     GIR_EraseRootFromParent_Done,
     /* 2134502 */   // Label 28195: @2134502
     /* 2134502 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2134593), // Rule ID 17662 //
     /* 2134507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2134518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2134521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2134524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2134530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134553 */     // MIs[0] round
     /* 2134553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134556 */     // MIs[0] policy
     /* 2134556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134566 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2134569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134592 */     // GIR_Coverage, 17662,
     /* 2134592 */     GIR_EraseRootFromParent_Done,
     /* 2134593 */   // Label 28196: @2134593
     /* 2134593 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2134684), // Rule ID 17663 //
     /* 2134598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2134609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2134612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2134615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2134621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134644 */     // MIs[0] round
     /* 2134644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134647 */     // MIs[0] policy
     /* 2134647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134657 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2134660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134683 */     // GIR_Coverage, 17663,
     /* 2134683 */     GIR_EraseRootFromParent_Done,
     /* 2134684 */   // Label 28197: @2134684
     /* 2134684 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2134775), // Rule ID 17666 //
     /* 2134689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2134700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2134703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2134706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134735 */     // MIs[0] round
     /* 2134735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134738 */     // MIs[0] policy
     /* 2134738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134748 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2134751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134774 */     // GIR_Coverage, 17666,
     /* 2134774 */     GIR_EraseRootFromParent_Done,
     /* 2134775 */   // Label 28198: @2134775
     /* 2134775 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2134866), // Rule ID 17667 //
     /* 2134780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2134791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2134794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2134797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2134810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2134818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134826 */     // MIs[0] round
     /* 2134826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134829 */     // MIs[0] policy
     /* 2134829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134839 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2134842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134865 */     // GIR_Coverage, 17667,
     /* 2134865 */     GIR_EraseRootFromParent_Done,
     /* 2134866 */   // Label 28199: @2134866
     /* 2134866 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2134957), // Rule ID 17670 //
     /* 2134871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2134913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134917 */     // MIs[0] round
     /* 2134917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134920 */     // MIs[0] policy
     /* 2134920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134930 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2134933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134956 */     // GIR_Coverage, 17670,
     /* 2134956 */     GIR_EraseRootFromParent_Done,
     /* 2134957 */   // Label 28200: @2134957
     /* 2134957 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2135048), // Rule ID 17671 //
     /* 2134962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2134970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2134973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2134976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2134979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2134982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2134992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2135004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135008 */     // MIs[0] round
     /* 2135008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135011 */     // MIs[0] policy
     /* 2135011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135021 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2135024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135047 */     // GIR_Coverage, 17671,
     /* 2135047 */     GIR_EraseRootFromParent_Done,
     /* 2135048 */   // Label 28201: @2135048
     /* 2135048 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2135139), // Rule ID 17674 //
     /* 2135053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2135056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2135061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2135064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2135067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2135070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2135073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2135095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135099 */     // MIs[0] round
     /* 2135099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135102 */     // MIs[0] policy
     /* 2135102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135112 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2135115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135138 */     // GIR_Coverage, 17674,
     /* 2135138 */     GIR_EraseRootFromParent_Done,
     /* 2135139 */   // Label 28202: @2135139
     /* 2135139 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2135230), // Rule ID 17675 //
     /* 2135144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2135147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2135152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2135155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2135158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2135161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2135164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2135186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135190 */     // MIs[0] round
     /* 2135190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135193 */     // MIs[0] policy
     /* 2135193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135203 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2135206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135229 */     // GIR_Coverage, 17675,
     /* 2135229 */     GIR_EraseRootFromParent_Done,
     /* 2135230 */   // Label 28203: @2135230
     /* 2135230 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2135321), // Rule ID 17678 //
     /* 2135235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2135238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2135246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2135255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135281 */     // MIs[0] round
     /* 2135281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135284 */     // MIs[0] policy
     /* 2135284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2135297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135320 */     // GIR_Coverage, 17678,
     /* 2135320 */     GIR_EraseRootFromParent_Done,
     /* 2135321 */   // Label 28204: @2135321
     /* 2135321 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2135412), // Rule ID 17679 //
     /* 2135326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2135329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2135337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2135340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2135343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2135346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135372 */     // MIs[0] round
     /* 2135372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135375 */     // MIs[0] policy
     /* 2135375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135385 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2135388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135411 */     // GIR_Coverage, 17679,
     /* 2135411 */     GIR_EraseRootFromParent_Done,
     /* 2135412 */   // Label 28205: @2135412
     /* 2135412 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2135503), // Rule ID 17682 //
     /* 2135417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2135420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2135437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135463 */     // MIs[0] round
     /* 2135463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135466 */     // MIs[0] policy
     /* 2135466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135502 */     // GIR_Coverage, 17682,
     /* 2135502 */     GIR_EraseRootFromParent_Done,
     /* 2135503 */   // Label 28206: @2135503
     /* 2135503 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2135594), // Rule ID 17683 //
     /* 2135508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2135511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2135519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2135522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2135525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2135528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2135531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135554 */     // MIs[0] round
     /* 2135554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135557 */     // MIs[0] policy
     /* 2135557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135567 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2135570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135593 */     // GIR_Coverage, 17683,
     /* 2135593 */     GIR_EraseRootFromParent_Done,
     /* 2135594 */   // Label 28207: @2135594
     /* 2135594 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2135685), // Rule ID 17686 //
     /* 2135599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2135602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2135619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135645 */     // MIs[0] round
     /* 2135645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135648 */     // MIs[0] policy
     /* 2135648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2135661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135684 */     // GIR_Coverage, 17686,
     /* 2135684 */     GIR_EraseRootFromParent_Done,
     /* 2135685 */   // Label 28208: @2135685
     /* 2135685 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2135776), // Rule ID 17687 //
     /* 2135690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2135693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2135707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2135710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135736 */     // MIs[0] round
     /* 2135736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135739 */     // MIs[0] policy
     /* 2135739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135749 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2135752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135775 */     // GIR_Coverage, 17687,
     /* 2135775 */     GIR_EraseRootFromParent_Done,
     /* 2135776 */   // Label 28209: @2135776
     /* 2135776 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2135867), // Rule ID 17690 //
     /* 2135781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2135784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135827 */     // MIs[0] round
     /* 2135827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135830 */     // MIs[0] policy
     /* 2135830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135840 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2135843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135866 */     // GIR_Coverage, 17690,
     /* 2135866 */     GIR_EraseRootFromParent_Done,
     /* 2135867 */   // Label 28210: @2135867
     /* 2135867 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2135958), // Rule ID 17691 //
     /* 2135872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2135875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135918 */     // MIs[0] round
     /* 2135918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135921 */     // MIs[0] policy
     /* 2135921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135931 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2135934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135957 */     // GIR_Coverage, 17691,
     /* 2135957 */     GIR_EraseRootFromParent_Done,
     /* 2135958 */   // Label 28211: @2135958
     /* 2135958 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2136049), // Rule ID 17694 //
     /* 2135963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2135966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2135971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2135974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2135977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136009 */     // MIs[0] round
     /* 2136009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136012 */     // MIs[0] policy
     /* 2136012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136022 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2136025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136048 */     // GIR_Coverage, 17694,
     /* 2136048 */     GIR_EraseRootFromParent_Done,
     /* 2136049 */   // Label 28212: @2136049
     /* 2136049 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2136140), // Rule ID 17695 //
     /* 2136054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2136057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2136071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2136074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136100 */     // MIs[0] round
     /* 2136100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136103 */     // MIs[0] policy
     /* 2136103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136113 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2136116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136139 */     // GIR_Coverage, 17695,
     /* 2136139 */     GIR_EraseRootFromParent_Done,
     /* 2136140 */   // Label 28213: @2136140
     /* 2136140 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2136231), // Rule ID 17698 //
     /* 2136145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2136148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2136156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2136159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2136162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2136165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136191 */     // MIs[0] round
     /* 2136191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136194 */     // MIs[0] policy
     /* 2136194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136204 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2136207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136230 */     // GIR_Coverage, 17698,
     /* 2136230 */     GIR_EraseRootFromParent_Done,
     /* 2136231 */   // Label 28214: @2136231
     /* 2136231 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2136322), // Rule ID 17699 //
     /* 2136236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2136239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2136247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2136250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2136253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2136256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136282 */     // MIs[0] round
     /* 2136282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136285 */     // MIs[0] policy
     /* 2136285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136295 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2136298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136321 */     // GIR_Coverage, 17699,
     /* 2136321 */     GIR_EraseRootFromParent_Done,
     /* 2136322 */   // Label 28215: @2136322
     /* 2136322 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2136413), // Rule ID 17702 //
     /* 2136327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2136330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2136347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136373 */     // MIs[0] round
     /* 2136373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136376 */     // MIs[0] policy
     /* 2136376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136386 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2136389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136412 */     // GIR_Coverage, 17702,
     /* 2136412 */     GIR_EraseRootFromParent_Done,
     /* 2136413 */   // Label 28216: @2136413
     /* 2136413 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2136504), // Rule ID 17703 //
     /* 2136418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2136421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2136435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2136438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136464 */     // MIs[0] round
     /* 2136464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136467 */     // MIs[0] policy
     /* 2136467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2136480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136503 */     // GIR_Coverage, 17703,
     /* 2136503 */     GIR_EraseRootFromParent_Done,
     /* 2136504 */   // Label 28217: @2136504
     /* 2136504 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2136595), // Rule ID 17706 //
     /* 2136509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2136512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136555 */     // MIs[0] round
     /* 2136555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136558 */     // MIs[0] policy
     /* 2136558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136568 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2136571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136594 */     // GIR_Coverage, 17706,
     /* 2136594 */     GIR_EraseRootFromParent_Done,
     /* 2136595 */   // Label 28218: @2136595
     /* 2136595 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2136686), // Rule ID 17707 //
     /* 2136600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2136603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2136617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2136620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136646 */     // MIs[0] round
     /* 2136646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136649 */     // MIs[0] policy
     /* 2136649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136659 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2136662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136685 */     // GIR_Coverage, 17707,
     /* 2136685 */     GIR_EraseRootFromParent_Done,
     /* 2136686 */   // Label 28219: @2136686
     /* 2136686 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2136777), // Rule ID 17710 //
     /* 2136691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2136694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136737 */     // MIs[0] round
     /* 2136737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136740 */     // MIs[0] policy
     /* 2136740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136750 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2136753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136776 */     // GIR_Coverage, 17710,
     /* 2136776 */     GIR_EraseRootFromParent_Done,
     /* 2136777 */   // Label 28220: @2136777
     /* 2136777 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2136868), // Rule ID 17711 //
     /* 2136782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2136785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2136799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2136802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136828 */     // MIs[0] round
     /* 2136828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136831 */     // MIs[0] policy
     /* 2136831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136841 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2136844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136867 */     // GIR_Coverage, 17711,
     /* 2136867 */     GIR_EraseRootFromParent_Done,
     /* 2136868 */   // Label 28221: @2136868
     /* 2136868 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2136959), // Rule ID 17714 //
     /* 2136873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2136876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2136884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2136887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136919 */     // MIs[0] round
     /* 2136919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136922 */     // MIs[0] policy
     /* 2136922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136932 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2136935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136958 */     // GIR_Coverage, 17714,
     /* 2136958 */     GIR_EraseRootFromParent_Done,
     /* 2136959 */   // Label 28222: @2136959
     /* 2136959 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2137050), // Rule ID 17715 //
     /* 2136964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2136967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2136972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2136975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2136978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137010 */     // MIs[0] round
     /* 2137010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137013 */     // MIs[0] policy
     /* 2137013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137023 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2137026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137049 */     // GIR_Coverage, 17715,
     /* 2137049 */     GIR_EraseRootFromParent_Done,
     /* 2137050 */   // Label 28223: @2137050
     /* 2137050 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2137141), // Rule ID 17718 //
     /* 2137055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2137058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137101 */     // MIs[0] round
     /* 2137101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137104 */     // MIs[0] policy
     /* 2137104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2137117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137140 */     // GIR_Coverage, 17718,
     /* 2137140 */     GIR_EraseRootFromParent_Done,
     /* 2137141 */   // Label 28224: @2137141
     /* 2137141 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2137232), // Rule ID 17719 //
     /* 2137146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2137149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2137163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137192 */     // MIs[0] round
     /* 2137192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137195 */     // MIs[0] policy
     /* 2137195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137205 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2137208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137231 */     // GIR_Coverage, 17719,
     /* 2137231 */     GIR_EraseRootFromParent_Done,
     /* 2137232 */   // Label 28225: @2137232
     /* 2137232 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2137323), // Rule ID 17722 //
     /* 2137237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2137240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2137248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2137251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137283 */     // MIs[0] round
     /* 2137283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137286 */     // MIs[0] policy
     /* 2137286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2137299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137322 */     // GIR_Coverage, 17722,
     /* 2137322 */     GIR_EraseRootFromParent_Done,
     /* 2137323 */   // Label 28226: @2137323
     /* 2137323 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2137414), // Rule ID 17723 //
     /* 2137328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2137331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2137339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2137342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137374 */     // MIs[0] round
     /* 2137374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137377 */     // MIs[0] policy
     /* 2137377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137387 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2137390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137413 */     // GIR_Coverage, 17723,
     /* 2137413 */     GIR_EraseRootFromParent_Done,
     /* 2137414 */   // Label 28227: @2137414
     /* 2137414 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2137505), // Rule ID 17726 //
     /* 2137419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2137422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2137430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2137433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137465 */     // MIs[0] round
     /* 2137465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137468 */     // MIs[0] policy
     /* 2137468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2137481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137504 */     // GIR_Coverage, 17726,
     /* 2137504 */     GIR_EraseRootFromParent_Done,
     /* 2137505 */   // Label 28228: @2137505
     /* 2137505 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2137596), // Rule ID 17727 //
     /* 2137510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2137513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2137521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2137524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137556 */     // MIs[0] round
     /* 2137556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137559 */     // MIs[0] policy
     /* 2137559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137569 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2137572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137595 */     // GIR_Coverage, 17727,
     /* 2137595 */     GIR_EraseRootFromParent_Done,
     /* 2137596 */   // Label 28229: @2137596
     /* 2137596 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2137687), // Rule ID 17730 //
     /* 2137601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2137604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2137612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2137615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2137618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137647 */     // MIs[0] round
     /* 2137647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137650 */     // MIs[0] policy
     /* 2137650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137660 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2137663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137686 */     // GIR_Coverage, 17730,
     /* 2137686 */     GIR_EraseRootFromParent_Done,
     /* 2137687 */   // Label 28230: @2137687
     /* 2137687 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2137778), // Rule ID 17731 //
     /* 2137692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2137695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2137703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2137706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2137709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2137722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2137726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137738 */     // MIs[0] round
     /* 2137738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137741 */     // MIs[0] policy
     /* 2137741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137751 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2137754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137777 */     // GIR_Coverage, 17731,
     /* 2137777 */     GIR_EraseRootFromParent_Done,
     /* 2137778 */   // Label 28231: @2137778
     /* 2137778 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2137869), // Rule ID 17734 //
     /* 2137783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2137786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137829 */     // MIs[0] round
     /* 2137829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137832 */     // MIs[0] policy
     /* 2137832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137842 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2137845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137868 */     // GIR_Coverage, 17734,
     /* 2137868 */     GIR_EraseRootFromParent_Done,
     /* 2137869 */   // Label 28232: @2137869
     /* 2137869 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2137960), // Rule ID 17735 //
     /* 2137874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2137877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137920 */     // MIs[0] round
     /* 2137920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137923 */     // MIs[0] policy
     /* 2137923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137933 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2137936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137959 */     // GIR_Coverage, 17735,
     /* 2137959 */     GIR_EraseRootFromParent_Done,
     /* 2137960 */   // Label 28233: @2137960
     /* 2137960 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2138051), // Rule ID 17738 //
     /* 2137965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2137968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2137973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2137976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2137979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138011 */     // MIs[0] round
     /* 2138011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138014 */     // MIs[0] policy
     /* 2138014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2138027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138050 */     // GIR_Coverage, 17738,
     /* 2138050 */     GIR_EraseRootFromParent_Done,
     /* 2138051 */   // Label 28234: @2138051
     /* 2138051 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2138142), // Rule ID 17739 //
     /* 2138056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2138059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2138064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2138073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138102 */     // MIs[0] round
     /* 2138102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138105 */     // MIs[0] policy
     /* 2138105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138115 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2138118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138141 */     // GIR_Coverage, 17739,
     /* 2138141 */     GIR_EraseRootFromParent_Done,
     /* 2138142 */   // Label 28235: @2138142
     /* 2138142 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2138233), // Rule ID 17742 //
     /* 2138147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2138150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2138155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2138158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2138161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138193 */     // MIs[0] round
     /* 2138193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138196 */     // MIs[0] policy
     /* 2138196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138206 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2138209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138232 */     // GIR_Coverage, 17742,
     /* 2138232 */     GIR_EraseRootFromParent_Done,
     /* 2138233 */   // Label 28236: @2138233
     /* 2138233 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2138324), // Rule ID 17743 //
     /* 2138238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2138241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2138246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2138249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2138252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138284 */     // MIs[0] round
     /* 2138284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138287 */     // MIs[0] policy
     /* 2138287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138297 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2138300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138323 */     // GIR_Coverage, 17743,
     /* 2138323 */     GIR_EraseRootFromParent_Done,
     /* 2138324 */   // Label 28237: @2138324
     /* 2138324 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2138415), // Rule ID 17746 //
     /* 2138329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2138332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2138337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2138340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2138343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138375 */     // MIs[0] round
     /* 2138375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138378 */     // MIs[0] policy
     /* 2138378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138388 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2138391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138414 */     // GIR_Coverage, 17746,
     /* 2138414 */     GIR_EraseRootFromParent_Done,
     /* 2138415 */   // Label 28238: @2138415
     /* 2138415 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2138506), // Rule ID 17747 //
     /* 2138420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2138423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2138428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2138431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2138434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138466 */     // MIs[0] round
     /* 2138466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138469 */     // MIs[0] policy
     /* 2138469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138479 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2138482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138505 */     // GIR_Coverage, 17747,
     /* 2138505 */     GIR_EraseRootFromParent_Done,
     /* 2138506 */   // Label 28239: @2138506
     /* 2138506 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2138597), // Rule ID 17750 //
     /* 2138511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2138522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2138531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138557 */     // MIs[0] round
     /* 2138557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138560 */     // MIs[0] policy
     /* 2138560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138570 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2138573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138596 */     // GIR_Coverage, 17750,
     /* 2138596 */     GIR_EraseRootFromParent_Done,
     /* 2138597 */   // Label 28240: @2138597
     /* 2138597 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2138688), // Rule ID 17751 //
     /* 2138602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2138613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2138616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2138619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2138622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138648 */     // MIs[0] round
     /* 2138648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138651 */     // MIs[0] policy
     /* 2138651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138661 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2138664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138687 */     // GIR_Coverage, 17751,
     /* 2138687 */     GIR_EraseRootFromParent_Done,
     /* 2138688 */   // Label 28241: @2138688
     /* 2138688 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2138779), // Rule ID 17754 //
     /* 2138693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2138704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2138707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2138710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2138713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138739 */     // MIs[0] round
     /* 2138739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138742 */     // MIs[0] policy
     /* 2138742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2138755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138778 */     // GIR_Coverage, 17754,
     /* 2138778 */     GIR_EraseRootFromParent_Done,
     /* 2138779 */   // Label 28242: @2138779
     /* 2138779 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2138870), // Rule ID 17755 //
     /* 2138784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2138795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2138798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2138801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2138804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2138807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138830 */     // MIs[0] round
     /* 2138830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138833 */     // MIs[0] policy
     /* 2138833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138843 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2138846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138869 */     // GIR_Coverage, 17755,
     /* 2138869 */     GIR_EraseRootFromParent_Done,
     /* 2138870 */   // Label 28243: @2138870
     /* 2138870 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2138961), // Rule ID 17758 //
     /* 2138875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2138886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2138889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2138892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2138895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2138917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138921 */     // MIs[0] round
     /* 2138921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138924 */     // MIs[0] policy
     /* 2138924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138934 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2138937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138960 */     // GIR_Coverage, 17758,
     /* 2138960 */     GIR_EraseRootFromParent_Done,
     /* 2138961 */   // Label 28244: @2138961
     /* 2138961 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2139052), // Rule ID 17759 //
     /* 2138966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2138977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2138980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2138983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2138986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2138996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139012 */     // MIs[0] round
     /* 2139012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139015 */     // MIs[0] policy
     /* 2139015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139025 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2139028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139051 */     // GIR_Coverage, 17759,
     /* 2139051 */     GIR_EraseRootFromParent_Done,
     /* 2139052 */   // Label 28245: @2139052
     /* 2139052 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2139143), // Rule ID 17762 //
     /* 2139057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2139068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2139071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2139074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2139077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139103 */     // MIs[0] round
     /* 2139103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139106 */     // MIs[0] policy
     /* 2139106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2139119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139142 */     // GIR_Coverage, 17762,
     /* 2139142 */     GIR_EraseRootFromParent_Done,
     /* 2139143 */   // Label 28246: @2139143
     /* 2139143 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2139234), // Rule ID 17763 //
     /* 2139148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2139159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2139162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2139165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2139168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139194 */     // MIs[0] round
     /* 2139194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139197 */     // MIs[0] policy
     /* 2139197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139207 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2139210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139233 */     // GIR_Coverage, 17763,
     /* 2139233 */     GIR_EraseRootFromParent_Done,
     /* 2139234 */   // Label 28247: @2139234
     /* 2139234 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2139325), // Rule ID 17766 //
     /* 2139239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2139250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2139253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2139256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2139259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139285 */     // MIs[0] round
     /* 2139285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139288 */     // MIs[0] policy
     /* 2139288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139298 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2139301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139324 */     // GIR_Coverage, 17766,
     /* 2139324 */     GIR_EraseRootFromParent_Done,
     /* 2139325 */   // Label 28248: @2139325
     /* 2139325 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2139416), // Rule ID 17767 //
     /* 2139330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2139341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2139344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2139347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2139350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139376 */     // MIs[0] round
     /* 2139376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139379 */     // MIs[0] policy
     /* 2139379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139389 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2139392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139415 */     // GIR_Coverage, 17767,
     /* 2139415 */     GIR_EraseRootFromParent_Done,
     /* 2139416 */   // Label 28249: @2139416
     /* 2139416 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2139507), // Rule ID 17770 //
     /* 2139421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2139432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2139435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2139438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2139441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139467 */     // MIs[0] round
     /* 2139467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139470 */     // MIs[0] policy
     /* 2139470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2139483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139506 */     // GIR_Coverage, 17770,
     /* 2139506 */     GIR_EraseRootFromParent_Done,
     /* 2139507 */   // Label 28250: @2139507
     /* 2139507 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2139598), // Rule ID 17771 //
     /* 2139512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2139523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2139526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2139529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2139532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139558 */     // MIs[0] round
     /* 2139558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139561 */     // MIs[0] policy
     /* 2139561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139571 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2139574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139597 */     // GIR_Coverage, 17771,
     /* 2139597 */     GIR_EraseRootFromParent_Done,
     /* 2139598 */   // Label 28251: @2139598
     /* 2139598 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2139689), // Rule ID 17774 //
     /* 2139603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2139614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2139617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2139620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2139623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139649 */     // MIs[0] round
     /* 2139649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139652 */     // MIs[0] policy
     /* 2139652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139662 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2139665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139688 */     // GIR_Coverage, 17774,
     /* 2139688 */     GIR_EraseRootFromParent_Done,
     /* 2139689 */   // Label 28252: @2139689
     /* 2139689 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2139780), // Rule ID 17775 //
     /* 2139694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2139705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2139708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2139711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2139714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2139717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139740 */     // MIs[0] round
     /* 2139740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139743 */     // MIs[0] policy
     /* 2139743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139753 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2139756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139779 */     // GIR_Coverage, 17775,
     /* 2139779 */     GIR_EraseRootFromParent_Done,
     /* 2139780 */   // Label 28253: @2139780
     /* 2139780 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2139871), // Rule ID 17778 //
     /* 2139785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2139796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2139799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2139802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2139805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2139808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139831 */     // MIs[0] round
     /* 2139831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139834 */     // MIs[0] policy
     /* 2139834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139844 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2139847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139870 */     // GIR_Coverage, 17778,
     /* 2139870 */     GIR_EraseRootFromParent_Done,
     /* 2139871 */   // Label 28254: @2139871
     /* 2139871 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2139962), // Rule ID 17779 //
     /* 2139876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2139887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2139890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2139893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2139896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2139899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139922 */     // MIs[0] round
     /* 2139922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139925 */     // MIs[0] policy
     /* 2139925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139935 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2139938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139961 */     // GIR_Coverage, 17779,
     /* 2139961 */     GIR_EraseRootFromParent_Done,
     /* 2139962 */   // Label 28255: @2139962
     /* 2139962 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2140053), // Rule ID 17782 //
     /* 2139967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2139978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2139981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2139984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2139987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140013 */     // MIs[0] round
     /* 2140013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140016 */     // MIs[0] policy
     /* 2140016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140026 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2140029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140052 */     // GIR_Coverage, 17782,
     /* 2140052 */     GIR_EraseRootFromParent_Done,
     /* 2140053 */   // Label 28256: @2140053
     /* 2140053 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2140144), // Rule ID 17783 //
     /* 2140058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2140069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2140072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2140075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2140078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140104 */     // MIs[0] round
     /* 2140104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140107 */     // MIs[0] policy
     /* 2140107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140117 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2140120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140143 */     // GIR_Coverage, 17783,
     /* 2140143 */     GIR_EraseRootFromParent_Done,
     /* 2140144 */   // Label 28257: @2140144
     /* 2140144 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2140235), // Rule ID 17786 //
     /* 2140149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2140160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2140163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2140166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2140169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140195 */     // MIs[0] round
     /* 2140195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140198 */     // MIs[0] policy
     /* 2140198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140208 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2140211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140234 */     // GIR_Coverage, 17786,
     /* 2140234 */     GIR_EraseRootFromParent_Done,
     /* 2140235 */   // Label 28258: @2140235
     /* 2140235 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2140326), // Rule ID 17787 //
     /* 2140240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2140251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2140254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2140257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2140260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140286 */     // MIs[0] round
     /* 2140286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140289 */     // MIs[0] policy
     /* 2140289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140299 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2140302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140325 */     // GIR_Coverage, 17787,
     /* 2140325 */     GIR_EraseRootFromParent_Done,
     /* 2140326 */   // Label 28259: @2140326
     /* 2140326 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2140417), // Rule ID 17790 //
     /* 2140331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2140342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2140345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2140348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2140351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140377 */     // MIs[0] round
     /* 2140377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140380 */     // MIs[0] policy
     /* 2140380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2140393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140416 */     // GIR_Coverage, 17790,
     /* 2140416 */     GIR_EraseRootFromParent_Done,
     /* 2140417 */   // Label 28260: @2140417
     /* 2140417 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2140508), // Rule ID 17791 //
     /* 2140422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2140433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2140436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2140439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2140442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140468 */     // MIs[0] round
     /* 2140468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140471 */     // MIs[0] policy
     /* 2140471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140481 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2140484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140507 */     // GIR_Coverage, 17791,
     /* 2140507 */     GIR_EraseRootFromParent_Done,
     /* 2140508 */   // Label 28261: @2140508
     /* 2140508 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2140599), // Rule ID 17794 //
     /* 2140513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2140524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2140527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2140530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2140533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140559 */     // MIs[0] round
     /* 2140559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140562 */     // MIs[0] policy
     /* 2140562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140572 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2140575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140598 */     // GIR_Coverage, 17794,
     /* 2140598 */     GIR_EraseRootFromParent_Done,
     /* 2140599 */   // Label 28262: @2140599
     /* 2140599 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2140690), // Rule ID 17795 //
     /* 2140604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2140615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2140618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2140621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2140624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140650 */     // MIs[0] round
     /* 2140650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140653 */     // MIs[0] policy
     /* 2140653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140663 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2140666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140689 */     // GIR_Coverage, 17795,
     /* 2140689 */     GIR_EraseRootFromParent_Done,
     /* 2140690 */   // Label 28263: @2140690
     /* 2140690 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2140781), // Rule ID 17798 //
     /* 2140695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2140706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2140715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140741 */     // MIs[0] round
     /* 2140741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140744 */     // MIs[0] policy
     /* 2140744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140754 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2140757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140780 */     // GIR_Coverage, 17798,
     /* 2140780 */     GIR_EraseRootFromParent_Done,
     /* 2140781 */   // Label 28264: @2140781
     /* 2140781 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2140872), // Rule ID 17799 //
     /* 2140786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2140797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2140800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2140803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2140806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140832 */     // MIs[0] round
     /* 2140832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140835 */     // MIs[0] policy
     /* 2140835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140845 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2140848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140871 */     // GIR_Coverage, 17799,
     /* 2140871 */     GIR_EraseRootFromParent_Done,
     /* 2140872 */   // Label 28265: @2140872
     /* 2140872 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2140963), // Rule ID 17802 //
     /* 2140877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2140888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2140891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2140894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2140897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140923 */     // MIs[0] round
     /* 2140923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140926 */     // MIs[0] policy
     /* 2140926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140936 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2140939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140962 */     // GIR_Coverage, 17802,
     /* 2140962 */     GIR_EraseRootFromParent_Done,
     /* 2140963 */   // Label 28266: @2140963
     /* 2140963 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2141054), // Rule ID 17803 //
     /* 2140968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2140976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2140979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2140982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2140985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2140988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141014 */     // MIs[0] round
     /* 2141014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141017 */     // MIs[0] policy
     /* 2141017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141027 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2141030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141053 */     // GIR_Coverage, 17803,
     /* 2141053 */     GIR_EraseRootFromParent_Done,
     /* 2141054 */   // Label 28267: @2141054
     /* 2141054 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2141145), // Rule ID 17806 //
     /* 2141059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2141070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2141073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2141079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141105 */     // MIs[0] round
     /* 2141105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141108 */     // MIs[0] policy
     /* 2141108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141118 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2141121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141144 */     // GIR_Coverage, 17806,
     /* 2141144 */     GIR_EraseRootFromParent_Done,
     /* 2141145 */   // Label 28268: @2141145
     /* 2141145 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2141236), // Rule ID 17807 //
     /* 2141150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2141161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2141164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2141170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141196 */     // MIs[0] round
     /* 2141196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141199 */     // MIs[0] policy
     /* 2141199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141209 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2141212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141235 */     // GIR_Coverage, 17807,
     /* 2141235 */     GIR_EraseRootFromParent_Done,
     /* 2141236 */   // Label 28269: @2141236
     /* 2141236 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2141327), // Rule ID 17810 //
     /* 2141241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2141252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2141255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2141261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141287 */     // MIs[0] round
     /* 2141287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141290 */     // MIs[0] policy
     /* 2141290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141300 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2141303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141326 */     // GIR_Coverage, 17810,
     /* 2141326 */     GIR_EraseRootFromParent_Done,
     /* 2141327 */   // Label 28270: @2141327
     /* 2141327 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2141418), // Rule ID 17811 //
     /* 2141332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2141343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2141346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2141352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141378 */     // MIs[0] round
     /* 2141378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141381 */     // MIs[0] policy
     /* 2141381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141391 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2141394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141417 */     // GIR_Coverage, 17811,
     /* 2141417 */     GIR_EraseRootFromParent_Done,
     /* 2141418 */   // Label 28271: @2141418
     /* 2141418 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2141509), // Rule ID 17814 //
     /* 2141423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2141434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2141437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2141440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2141443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141469 */     // MIs[0] round
     /* 2141469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141472 */     // MIs[0] policy
     /* 2141472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141482 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2141485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141508 */     // GIR_Coverage, 17814,
     /* 2141508 */     GIR_EraseRootFromParent_Done,
     /* 2141509 */   // Label 28272: @2141509
     /* 2141509 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2141600), // Rule ID 17815 //
     /* 2141514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2141525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2141528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2141531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2141534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141560 */     // MIs[0] round
     /* 2141560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141563 */     // MIs[0] policy
     /* 2141563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141573 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2141576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141599 */     // GIR_Coverage, 17815,
     /* 2141599 */     GIR_EraseRootFromParent_Done,
     /* 2141600 */   // Label 28273: @2141600
     /* 2141600 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2141691), // Rule ID 17818 //
     /* 2141605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2141608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2141616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2141625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141651 */     // MIs[0] round
     /* 2141651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141654 */     // MIs[0] policy
     /* 2141654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2141667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141690 */     // GIR_Coverage, 17818,
     /* 2141690 */     GIR_EraseRootFromParent_Done,
     /* 2141691 */   // Label 28274: @2141691
     /* 2141691 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2141782), // Rule ID 17819 //
     /* 2141696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2141699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2141707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2141710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2141713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2141716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2141734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141742 */     // MIs[0] round
     /* 2141742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141745 */     // MIs[0] policy
     /* 2141745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141755 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2141758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141781 */     // GIR_Coverage, 17819,
     /* 2141781 */     GIR_EraseRootFromParent_Done,
     /* 2141782 */   // Label 28275: @2141782
     /* 2141782 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2141873), // Rule ID 17822 //
     /* 2141787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2141798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2141801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2141804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2141807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141833 */     // MIs[0] round
     /* 2141833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141836 */     // MIs[0] policy
     /* 2141836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141846 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2141849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141872 */     // GIR_Coverage, 17822,
     /* 2141872 */     GIR_EraseRootFromParent_Done,
     /* 2141873 */   // Label 28276: @2141873
     /* 2141873 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2141964), // Rule ID 17823 //
     /* 2141878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2141889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2141892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2141895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2141898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2141920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141924 */     // MIs[0] round
     /* 2141924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141927 */     // MIs[0] policy
     /* 2141927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141937 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2141940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141963 */     // GIR_Coverage, 17823,
     /* 2141963 */     GIR_EraseRootFromParent_Done,
     /* 2141964 */   // Label 28277: @2141964
     /* 2141964 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2142055), // Rule ID 17826 //
     /* 2141969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2141977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2141980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2141983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2141986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2141989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2141992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2141999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142015 */     // MIs[0] round
     /* 2142015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142018 */     // MIs[0] policy
     /* 2142018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2142031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142054 */     // GIR_Coverage, 17826,
     /* 2142054 */     GIR_EraseRootFromParent_Done,
     /* 2142055 */   // Label 28278: @2142055
     /* 2142055 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2142146), // Rule ID 17827 //
     /* 2142060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2142071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2142074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2142077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2142080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142106 */     // MIs[0] round
     /* 2142106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142109 */     // MIs[0] policy
     /* 2142109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142119 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2142122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142145 */     // GIR_Coverage, 17827,
     /* 2142145 */     GIR_EraseRootFromParent_Done,
     /* 2142146 */   // Label 28279: @2142146
     /* 2142146 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2142237), // Rule ID 17830 //
     /* 2142151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2142162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2142165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142197 */     // MIs[0] round
     /* 2142197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142200 */     // MIs[0] policy
     /* 2142200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2142213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142236 */     // GIR_Coverage, 17830,
     /* 2142236 */     GIR_EraseRootFromParent_Done,
     /* 2142237 */   // Label 28280: @2142237
     /* 2142237 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2142328), // Rule ID 17831 //
     /* 2142242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2142253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2142256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142288 */     // MIs[0] round
     /* 2142288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142291 */     // MIs[0] policy
     /* 2142291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142301 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2142304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142327 */     // GIR_Coverage, 17831,
     /* 2142327 */     GIR_EraseRootFromParent_Done,
     /* 2142328 */   // Label 28281: @2142328
     /* 2142328 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2142419), // Rule ID 17834 //
     /* 2142333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2142344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2142347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142379 */     // MIs[0] round
     /* 2142379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142382 */     // MIs[0] policy
     /* 2142382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142392 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2142395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142418 */     // GIR_Coverage, 17834,
     /* 2142418 */     GIR_EraseRootFromParent_Done,
     /* 2142419 */   // Label 28282: @2142419
     /* 2142419 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2142510), // Rule ID 17835 //
     /* 2142424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2142435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2142438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142470 */     // MIs[0] round
     /* 2142470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142473 */     // MIs[0] policy
     /* 2142473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142483 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2142486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142509 */     // GIR_Coverage, 17835,
     /* 2142509 */     GIR_EraseRootFromParent_Done,
     /* 2142510 */   // Label 28283: @2142510
     /* 2142510 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2142601), // Rule ID 17838 //
     /* 2142515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2142526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2142529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2142535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2142538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142561 */     // MIs[0] round
     /* 2142561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142564 */     // MIs[0] policy
     /* 2142564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142574 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2142577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142600 */     // GIR_Coverage, 17838,
     /* 2142600 */     GIR_EraseRootFromParent_Done,
     /* 2142601 */   // Label 28284: @2142601
     /* 2142601 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2142692), // Rule ID 17839 //
     /* 2142606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2142617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2142620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2142626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2142629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142652 */     // MIs[0] round
     /* 2142652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142655 */     // MIs[0] policy
     /* 2142655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142665 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2142668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142691 */     // GIR_Coverage, 17839,
     /* 2142691 */     GIR_EraseRootFromParent_Done,
     /* 2142692 */   // Label 28285: @2142692
     /* 2142692 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2142783), // Rule ID 17842 //
     /* 2142697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2142717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142743 */     // MIs[0] round
     /* 2142743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142746 */     // MIs[0] policy
     /* 2142746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142756 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2142759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142782 */     // GIR_Coverage, 17842,
     /* 2142782 */     GIR_EraseRootFromParent_Done,
     /* 2142783 */   // Label 28286: @2142783
     /* 2142783 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2142874), // Rule ID 17843 //
     /* 2142788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2142808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142834 */     // MIs[0] round
     /* 2142834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142837 */     // MIs[0] policy
     /* 2142837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142847 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2142850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142873 */     // GIR_Coverage, 17843,
     /* 2142873 */     GIR_EraseRootFromParent_Done,
     /* 2142874 */   // Label 28287: @2142874
     /* 2142874 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2142965), // Rule ID 17846 //
     /* 2142879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2142899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142925 */     // MIs[0] round
     /* 2142925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142928 */     // MIs[0] policy
     /* 2142928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142938 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2142941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142964 */     // GIR_Coverage, 17846,
     /* 2142964 */     GIR_EraseRootFromParent_Done,
     /* 2142965 */   // Label 28288: @2142965
     /* 2142965 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2143056), // Rule ID 17847 //
     /* 2142970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2142978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2142990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143016 */     // MIs[0] round
     /* 2143016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143019 */     // MIs[0] policy
     /* 2143019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143029 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2143032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143055 */     // GIR_Coverage, 17847,
     /* 2143055 */     GIR_EraseRootFromParent_Done,
     /* 2143056 */   // Label 28289: @2143056
     /* 2143056 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2143147), // Rule ID 17850 //
     /* 2143061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2143064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2143078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2143081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143107 */     // MIs[0] round
     /* 2143107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143110 */     // MIs[0] policy
     /* 2143110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143120 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2143123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143146 */     // GIR_Coverage, 17850,
     /* 2143146 */     GIR_EraseRootFromParent_Done,
     /* 2143147 */   // Label 28290: @2143147
     /* 2143147 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2143238), // Rule ID 17851 //
     /* 2143152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2143155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2143163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2143166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2143169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2143172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143198 */     // MIs[0] round
     /* 2143198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143201 */     // MIs[0] policy
     /* 2143201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143211 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2143214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143237 */     // GIR_Coverage, 17851,
     /* 2143237 */     GIR_EraseRootFromParent_Done,
     /* 2143238 */   // Label 28291: @2143238
     /* 2143238 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2143329), // Rule ID 17854 //
     /* 2143243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2143246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2143263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143289 */     // MIs[0] round
     /* 2143289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143292 */     // MIs[0] policy
     /* 2143292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2143305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143328 */     // GIR_Coverage, 17854,
     /* 2143328 */     GIR_EraseRootFromParent_Done,
     /* 2143329 */   // Label 28292: @2143329
     /* 2143329 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2143420), // Rule ID 17855 //
     /* 2143334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2143337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2143354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143380 */     // MIs[0] round
     /* 2143380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143383 */     // MIs[0] policy
     /* 2143383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143393 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2143396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143419 */     // GIR_Coverage, 17855,
     /* 2143419 */     GIR_EraseRootFromParent_Done,
     /* 2143420 */   // Label 28293: @2143420
     /* 2143420 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2143511), // Rule ID 17858 //
     /* 2143425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2143428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2143445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143471 */     // MIs[0] round
     /* 2143471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143474 */     // MIs[0] policy
     /* 2143474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143484 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2143487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143510 */     // GIR_Coverage, 17858,
     /* 2143510 */     GIR_EraseRootFromParent_Done,
     /* 2143511 */   // Label 28294: @2143511
     /* 2143511 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2143602), // Rule ID 17859 //
     /* 2143516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2143519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2143536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143562 */     // MIs[0] round
     /* 2143562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143565 */     // MIs[0] policy
     /* 2143565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2143578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143601 */     // GIR_Coverage, 17859,
     /* 2143601 */     GIR_EraseRootFromParent_Done,
     /* 2143602 */   // Label 28295: @2143602
     /* 2143602 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2143693), // Rule ID 17862 //
     /* 2143607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2143610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2143627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143653 */     // MIs[0] round
     /* 2143653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143656 */     // MIs[0] policy
     /* 2143656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143666 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2143669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143692 */     // GIR_Coverage, 17862,
     /* 2143692 */     GIR_EraseRootFromParent_Done,
     /* 2143693 */   // Label 28296: @2143693
     /* 2143693 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2143784), // Rule ID 17863 //
     /* 2143698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2143701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2143706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2143718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143744 */     // MIs[0] round
     /* 2143744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143747 */     // MIs[0] policy
     /* 2143747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143757 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2143760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143783 */     // GIR_Coverage, 17863,
     /* 2143783 */     GIR_EraseRootFromParent_Done,
     /* 2143784 */   // Label 28297: @2143784
     /* 2143784 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2143875), // Rule ID 17866 //
     /* 2143789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2143800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2143803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2143809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143835 */     // MIs[0] round
     /* 2143835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143838 */     // MIs[0] policy
     /* 2143838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143848 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143874 */     // GIR_Coverage, 17866,
     /* 2143874 */     GIR_EraseRootFromParent_Done,
     /* 2143875 */   // Label 28298: @2143875
     /* 2143875 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2143966), // Rule ID 17867 //
     /* 2143880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2143891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2143894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2143900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143926 */     // MIs[0] round
     /* 2143926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143929 */     // MIs[0] policy
     /* 2143929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143939 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2143942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143965 */     // GIR_Coverage, 17867,
     /* 2143965 */     GIR_EraseRootFromParent_Done,
     /* 2143966 */   // Label 28299: @2143966
     /* 2143966 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2144057), // Rule ID 17870 //
     /* 2143971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2143982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2143985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2143988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2143991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144017 */     // MIs[0] round
     /* 2144017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144020 */     // MIs[0] policy
     /* 2144020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144030 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2144033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144056 */     // GIR_Coverage, 17870,
     /* 2144056 */     GIR_EraseRootFromParent_Done,
     /* 2144057 */   // Label 28300: @2144057
     /* 2144057 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2144148), // Rule ID 17871 //
     /* 2144062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2144073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2144076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2144082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144108 */     // MIs[0] round
     /* 2144108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144111 */     // MIs[0] policy
     /* 2144111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144121 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2144124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144147 */     // GIR_Coverage, 17871,
     /* 2144147 */     GIR_EraseRootFromParent_Done,
     /* 2144148 */   // Label 28301: @2144148
     /* 2144148 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2144239), // Rule ID 17874 //
     /* 2144153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2144156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2144173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144199 */     // MIs[0] round
     /* 2144199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144202 */     // MIs[0] policy
     /* 2144202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144212 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2144215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144238 */     // GIR_Coverage, 17874,
     /* 2144238 */     GIR_EraseRootFromParent_Done,
     /* 2144239 */   // Label 28302: @2144239
     /* 2144239 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2144330), // Rule ID 17875 //
     /* 2144244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2144255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2144258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2144264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144290 */     // MIs[0] round
     /* 2144290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144293 */     // MIs[0] policy
     /* 2144293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144303 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2144306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144329 */     // GIR_Coverage, 17875,
     /* 2144329 */     GIR_EraseRootFromParent_Done,
     /* 2144330 */   // Label 28303: @2144330
     /* 2144330 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2144421), // Rule ID 17878 //
     /* 2144335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2144346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2144349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2144355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144381 */     // MIs[0] round
     /* 2144381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144384 */     // MIs[0] policy
     /* 2144384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144394 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2144397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144420 */     // GIR_Coverage, 17878,
     /* 2144420 */     GIR_EraseRootFromParent_Done,
     /* 2144421 */   // Label 28304: @2144421
     /* 2144421 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2144512), // Rule ID 17879 //
     /* 2144426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2144437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2144440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2144446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144472 */     // MIs[0] round
     /* 2144472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144475 */     // MIs[0] policy
     /* 2144475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144485 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2144488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144511 */     // GIR_Coverage, 17879,
     /* 2144511 */     GIR_EraseRootFromParent_Done,
     /* 2144512 */   // Label 28305: @2144512
     /* 2144512 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2144603), // Rule ID 17882 //
     /* 2144517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2144520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2144537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144563 */     // MIs[0] round
     /* 2144563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144566 */     // MIs[0] policy
     /* 2144566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2144579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144602 */     // GIR_Coverage, 17882,
     /* 2144602 */     GIR_EraseRootFromParent_Done,
     /* 2144603 */   // Label 28306: @2144603
     /* 2144603 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2144694), // Rule ID 17883 //
     /* 2144608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2144628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144654 */     // MIs[0] round
     /* 2144654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144657 */     // MIs[0] policy
     /* 2144657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144667 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2144670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144693 */     // GIR_Coverage, 17883,
     /* 2144693 */     GIR_EraseRootFromParent_Done,
     /* 2144694 */   // Label 28307: @2144694
     /* 2144694 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2144785), // Rule ID 17886 //
     /* 2144699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2144702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2144716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2144719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144745 */     // MIs[0] round
     /* 2144745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144748 */     // MIs[0] policy
     /* 2144748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144758 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2144761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144784 */     // GIR_Coverage, 17886,
     /* 2144784 */     GIR_EraseRootFromParent_Done,
     /* 2144785 */   // Label 28308: @2144785
     /* 2144785 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2144876), // Rule ID 17887 //
     /* 2144790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2144793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2144807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2144810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144836 */     // MIs[0] round
     /* 2144836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144839 */     // MIs[0] policy
     /* 2144839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144849 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2144852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144875 */     // GIR_Coverage, 17887,
     /* 2144875 */     GIR_EraseRootFromParent_Done,
     /* 2144876 */   // Label 28309: @2144876
     /* 2144876 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2144967), // Rule ID 17890 //
     /* 2144881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2144892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2144901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144927 */     // MIs[0] round
     /* 2144927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144930 */     // MIs[0] policy
     /* 2144930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2144943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144966 */     // GIR_Coverage, 17890,
     /* 2144966 */     GIR_EraseRootFromParent_Done,
     /* 2144967 */   // Label 28310: @2144967
     /* 2144967 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2145058), // Rule ID 17891 //
     /* 2144972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2144983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2144986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2144992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145018 */     // MIs[0] round
     /* 2145018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145021 */     // MIs[0] policy
     /* 2145021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145031 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2145034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145057 */     // GIR_Coverage, 17891,
     /* 2145057 */     GIR_EraseRootFromParent_Done,
     /* 2145058 */   // Label 28311: @2145058
     /* 2145058 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2145149), // Rule ID 17894 //
     /* 2145063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2145074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2145077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2145080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2145083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145109 */     // MIs[0] round
     /* 2145109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145112 */     // MIs[0] policy
     /* 2145112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145122 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2145125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145148 */     // GIR_Coverage, 17894,
     /* 2145148 */     GIR_EraseRootFromParent_Done,
     /* 2145149 */   // Label 28312: @2145149
     /* 2145149 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2145240), // Rule ID 17895 //
     /* 2145154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2145165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2145168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2145171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2145174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145200 */     // MIs[0] round
     /* 2145200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145203 */     // MIs[0] policy
     /* 2145203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145213 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2145216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145239 */     // GIR_Coverage, 17895,
     /* 2145239 */     GIR_EraseRootFromParent_Done,
     /* 2145240 */   // Label 28313: @2145240
     /* 2145240 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2145331), // Rule ID 17898 //
     /* 2145245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2145256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2145259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2145262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2145265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2145268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145291 */     // MIs[0] round
     /* 2145291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145294 */     // MIs[0] policy
     /* 2145294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145304 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2145307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145330 */     // GIR_Coverage, 17898,
     /* 2145330 */     GIR_EraseRootFromParent_Done,
     /* 2145331 */   // Label 28314: @2145331
     /* 2145331 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2145422), // Rule ID 17899 //
     /* 2145336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2145347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2145350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2145353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2145356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2145359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145382 */     // MIs[0] round
     /* 2145382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145385 */     // MIs[0] policy
     /* 2145385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145395 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2145398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145421 */     // GIR_Coverage, 17899,
     /* 2145421 */     GIR_EraseRootFromParent_Done,
     /* 2145422 */   // Label 28315: @2145422
     /* 2145422 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2145513), // Rule ID 17902 //
     /* 2145427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2145438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2145441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2145447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145473 */     // MIs[0] round
     /* 2145473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145476 */     // MIs[0] policy
     /* 2145476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145486 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2145489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145512 */     // GIR_Coverage, 17902,
     /* 2145512 */     GIR_EraseRootFromParent_Done,
     /* 2145513 */   // Label 28316: @2145513
     /* 2145513 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2145604), // Rule ID 17903 //
     /* 2145518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2145529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2145532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2145538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2145548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145564 */     // MIs[0] round
     /* 2145564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145567 */     // MIs[0] policy
     /* 2145567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2145580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145603 */     // GIR_Coverage, 17903,
     /* 2145603 */     GIR_EraseRootFromParent_Done,
     /* 2145604 */   // Label 28317: @2145604
     /* 2145604 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2145695), // Rule ID 17906 //
     /* 2145609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2145620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2145629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145655 */     // MIs[0] round
     /* 2145655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145658 */     // MIs[0] policy
     /* 2145658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145668 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2145671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145694 */     // GIR_Coverage, 17906,
     /* 2145694 */     GIR_EraseRootFromParent_Done,
     /* 2145695 */   // Label 28318: @2145695
     /* 2145695 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2145786), // Rule ID 17907 //
     /* 2145700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2145711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2145714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2145720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145746 */     // MIs[0] round
     /* 2145746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145749 */     // MIs[0] policy
     /* 2145749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145759 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2145762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145785 */     // GIR_Coverage, 17907,
     /* 2145785 */     GIR_EraseRootFromParent_Done,
     /* 2145786 */   // Label 28319: @2145786
     /* 2145786 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2145877), // Rule ID 17910 //
     /* 2145791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2145808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2145811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145837 */     // MIs[0] round
     /* 2145837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145840 */     // MIs[0] policy
     /* 2145840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2145853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145876 */     // GIR_Coverage, 17910,
     /* 2145876 */     GIR_EraseRootFromParent_Done,
     /* 2145877 */   // Label 28320: @2145877
     /* 2145877 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2145968), // Rule ID 17911 //
     /* 2145882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2145893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2145896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2145899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2145902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2145905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145928 */     // MIs[0] round
     /* 2145928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145931 */     // MIs[0] policy
     /* 2145931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145941 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2145944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145967 */     // GIR_Coverage, 17911,
     /* 2145967 */     GIR_EraseRootFromParent_Done,
     /* 2145968 */   // Label 28321: @2145968
     /* 2145968 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2146059), // Rule ID 17914 //
     /* 2145973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2145976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2145981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2145984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2145987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2145990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2145993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146019 */     // MIs[0] round
     /* 2146019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146022 */     // MIs[0] policy
     /* 2146022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2146035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146058 */     // GIR_Coverage, 17914,
     /* 2146058 */     GIR_EraseRootFromParent_Done,
     /* 2146059 */   // Label 28322: @2146059
     /* 2146059 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2146150), // Rule ID 17915 //
     /* 2146064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2146075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2146078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2146081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2146084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146110 */     // MIs[0] round
     /* 2146110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146113 */     // MIs[0] policy
     /* 2146113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146123 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2146126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146149 */     // GIR_Coverage, 17915,
     /* 2146149 */     GIR_EraseRootFromParent_Done,
     /* 2146150 */   // Label 28323: @2146150
     /* 2146150 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2146241), // Rule ID 17918 //
     /* 2146155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2146166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2146169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2146172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2146175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146201 */     // MIs[0] round
     /* 2146201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146204 */     // MIs[0] policy
     /* 2146204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146214 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2146217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146240 */     // GIR_Coverage, 17918,
     /* 2146240 */     GIR_EraseRootFromParent_Done,
     /* 2146241 */   // Label 28324: @2146241
     /* 2146241 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2146332), // Rule ID 17919 //
     /* 2146246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2146257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2146260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2146263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2146266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146292 */     // MIs[0] round
     /* 2146292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146295 */     // MIs[0] policy
     /* 2146295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146305 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2146308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146331 */     // GIR_Coverage, 17919,
     /* 2146331 */     GIR_EraseRootFromParent_Done,
     /* 2146332 */   // Label 28325: @2146332
     /* 2146332 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2146423), // Rule ID 17922 //
     /* 2146337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2146348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2146357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146383 */     // MIs[0] round
     /* 2146383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146386 */     // MIs[0] policy
     /* 2146386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146396 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2146399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146422 */     // GIR_Coverage, 17922,
     /* 2146422 */     GIR_EraseRootFromParent_Done,
     /* 2146423 */   // Label 28326: @2146423
     /* 2146423 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2146514), // Rule ID 17923 //
     /* 2146428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2146439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2146442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2146445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2146448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146474 */     // MIs[0] round
     /* 2146474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146477 */     // MIs[0] policy
     /* 2146477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146487 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2146490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146513 */     // GIR_Coverage, 17923,
     /* 2146513 */     GIR_EraseRootFromParent_Done,
     /* 2146514 */   // Label 28327: @2146514
     /* 2146514 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2146605), // Rule ID 17926 //
     /* 2146519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2146530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2146533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2146536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2146539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2146557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146565 */     // MIs[0] round
     /* 2146565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146568 */     // MIs[0] policy
     /* 2146568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146578 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2146581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146604 */     // GIR_Coverage, 17926,
     /* 2146604 */     GIR_EraseRootFromParent_Done,
     /* 2146605 */   // Label 28328: @2146605
     /* 2146605 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2146696), // Rule ID 17927 //
     /* 2146610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2146621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2146624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2146627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2146630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2146648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146656 */     // MIs[0] round
     /* 2146656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146659 */     // MIs[0] policy
     /* 2146659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146669 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2146672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146695 */     // GIR_Coverage, 17927,
     /* 2146695 */     GIR_EraseRootFromParent_Done,
     /* 2146696 */   // Label 28329: @2146696
     /* 2146696 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2146787), // Rule ID 17930 //
     /* 2146701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2146712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2146715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2146718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2146721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2146739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146747 */     // MIs[0] round
     /* 2146747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146750 */     // MIs[0] policy
     /* 2146750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2146763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146786 */     // GIR_Coverage, 17930,
     /* 2146786 */     GIR_EraseRootFromParent_Done,
     /* 2146787 */   // Label 28330: @2146787
     /* 2146787 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2146878), // Rule ID 17931 //
     /* 2146792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2146803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2146806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2146809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2146812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2146830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146838 */     // MIs[0] round
     /* 2146838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146841 */     // MIs[0] policy
     /* 2146841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146851 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2146854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146877 */     // GIR_Coverage, 17931,
     /* 2146877 */     GIR_EraseRootFromParent_Done,
     /* 2146878 */   // Label 28331: @2146878
     /* 2146878 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2146969), // Rule ID 17934 //
     /* 2146883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2146900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2146921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146929 */     // MIs[0] round
     /* 2146929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146932 */     // MIs[0] policy
     /* 2146932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146942 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2146945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146968 */     // GIR_Coverage, 17934,
     /* 2146968 */     GIR_EraseRootFromParent_Done,
     /* 2146969 */   // Label 28332: @2146969
     /* 2146969 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2147060), // Rule ID 17935 //
     /* 2146974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2146982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2146985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2146988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2146991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2146994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2147012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147020 */     // MIs[0] round
     /* 2147020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147023 */     // MIs[0] policy
     /* 2147023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2147036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147059 */     // GIR_Coverage, 17935,
     /* 2147059 */     GIR_EraseRootFromParent_Done,
     /* 2147060 */   // Label 28333: @2147060
     /* 2147060 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2147151), // Rule ID 17938 //
     /* 2147065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2147076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2147079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2147085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147111 */     // MIs[0] round
     /* 2147111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147114 */     // MIs[0] policy
     /* 2147114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147124 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2147127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147150 */     // GIR_Coverage, 17938,
     /* 2147150 */     GIR_EraseRootFromParent_Done,
     /* 2147151 */   // Label 28334: @2147151
     /* 2147151 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2147242), // Rule ID 17939 //
     /* 2147156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2147167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2147170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2147176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147202 */     // MIs[0] round
     /* 2147202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147205 */     // MIs[0] policy
     /* 2147205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147215 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2147218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147241 */     // GIR_Coverage, 17939,
     /* 2147241 */     GIR_EraseRootFromParent_Done,
     /* 2147242 */   // Label 28335: @2147242
     /* 2147242 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2147333), // Rule ID 17942 //
     /* 2147247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2147258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2147261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2147264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2147267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2147285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147293 */     // MIs[0] round
     /* 2147293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147296 */     // MIs[0] policy
     /* 2147296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147306 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2147309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147332 */     // GIR_Coverage, 17942,
     /* 2147332 */     GIR_EraseRootFromParent_Done,
     /* 2147333 */   // Label 28336: @2147333
     /* 2147333 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2147424), // Rule ID 17943 //
     /* 2147338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2147349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2147352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2147355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2147358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2147376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147384 */     // MIs[0] round
     /* 2147384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147387 */     // MIs[0] policy
     /* 2147387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147397 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2147400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147423 */     // GIR_Coverage, 17943,
     /* 2147423 */     GIR_EraseRootFromParent_Done,
     /* 2147424 */   // Label 28337: @2147424
     /* 2147424 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2147515), // Rule ID 17946 //
     /* 2147429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2147440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2147443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2147446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2147449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2147467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147475 */     // MIs[0] round
     /* 2147475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147478 */     // MIs[0] policy
     /* 2147478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2147491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147514 */     // GIR_Coverage, 17946,
     /* 2147514 */     GIR_EraseRootFromParent_Done,
     /* 2147515 */   // Label 28338: @2147515
     /* 2147515 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2147606), // Rule ID 17947 //
     /* 2147520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2147531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2147534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2147537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2147540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2147558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147566 */     // MIs[0] round
     /* 2147566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147569 */     // MIs[0] policy
     /* 2147569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2147582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147605 */     // GIR_Coverage, 17947,
     /* 2147605 */     GIR_EraseRootFromParent_Done,
     /* 2147606 */   // Label 28339: @2147606
     /* 2147606 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2147697), // Rule ID 17950 //
     /* 2147611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2147622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2147625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2147631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147657 */     // MIs[0] round
     /* 2147657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147660 */     // MIs[0] policy
     /* 2147660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2147673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147696 */     // GIR_Coverage, 17950,
     /* 2147696 */     GIR_EraseRootFromParent_Done,
     /* 2147697 */   // Label 28340: @2147697
     /* 2147697 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2147788), // Rule ID 17951 //
     /* 2147702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2147713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2147716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2147722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147748 */     // MIs[0] round
     /* 2147748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147751 */     // MIs[0] policy
     /* 2147751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147761 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2147764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147787 */     // GIR_Coverage, 17951,
     /* 2147787 */     GIR_EraseRootFromParent_Done,
     /* 2147788 */   // Label 28341: @2147788
     /* 2147788 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2147879), // Rule ID 17954 //
     /* 2147793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2147804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2147813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147839 */     // MIs[0] round
     /* 2147839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147842 */     // MIs[0] policy
     /* 2147842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147852 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2147855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147878 */     // GIR_Coverage, 17954,
     /* 2147878 */     GIR_EraseRootFromParent_Done,
     /* 2147879 */   // Label 28342: @2147879
     /* 2147879 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2147970), // Rule ID 17955 //
     /* 2147884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2147895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2147898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2147904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147930 */     // MIs[0] round
     /* 2147930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147933 */     // MIs[0] policy
     /* 2147933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147943 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2147946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147969 */     // GIR_Coverage, 17955,
     /* 2147969 */     GIR_EraseRootFromParent_Done,
     /* 2147970 */   // Label 28343: @2147970
     /* 2147970 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2148061), // Rule ID 17958 //
     /* 2147975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2147983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2147986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2147989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2147995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2147998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148021 */     // MIs[0] round
     /* 2148021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148024 */     // MIs[0] policy
     /* 2148024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148034 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2148037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148060 */     // GIR_Coverage, 17958,
     /* 2148060 */     GIR_EraseRootFromParent_Done,
     /* 2148061 */   // Label 28344: @2148061
     /* 2148061 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2148152), // Rule ID 17959 //
     /* 2148066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2148077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2148080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2148086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2148089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148112 */     // MIs[0] round
     /* 2148112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148115 */     // MIs[0] policy
     /* 2148115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148125 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2148128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148151 */     // GIR_Coverage, 17959,
     /* 2148151 */     GIR_EraseRootFromParent_Done,
     /* 2148152 */   // Label 28345: @2148152
     /* 2148152 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2148243), // Rule ID 17962 //
     /* 2148157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2148168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2148171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2148177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148203 */     // MIs[0] round
     /* 2148203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148206 */     // MIs[0] policy
     /* 2148206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2148219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148242 */     // GIR_Coverage, 17962,
     /* 2148242 */     GIR_EraseRootFromParent_Done,
     /* 2148243 */   // Label 28346: @2148243
     /* 2148243 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2148334), // Rule ID 17963 //
     /* 2148248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2148259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2148262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2148268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148294 */     // MIs[0] round
     /* 2148294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148297 */     // MIs[0] policy
     /* 2148297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148307 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2148310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148333 */     // GIR_Coverage, 17963,
     /* 2148333 */     GIR_EraseRootFromParent_Done,
     /* 2148334 */   // Label 28347: @2148334
     /* 2148334 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2148425), // Rule ID 17966 //
     /* 2148339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2148350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2148353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2148359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148385 */     // MIs[0] round
     /* 2148385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148388 */     // MIs[0] policy
     /* 2148388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148398 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2148401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148424 */     // GIR_Coverage, 17966,
     /* 2148424 */     GIR_EraseRootFromParent_Done,
     /* 2148425 */   // Label 28348: @2148425
     /* 2148425 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2148516), // Rule ID 17967 //
     /* 2148430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2148441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2148444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2148450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148476 */     // MIs[0] round
     /* 2148476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148479 */     // MIs[0] policy
     /* 2148479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148489 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2148492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148515 */     // GIR_Coverage, 17967,
     /* 2148515 */     GIR_EraseRootFromParent_Done,
     /* 2148516 */   // Label 28349: @2148516
     /* 2148516 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2148607), // Rule ID 17970 //
     /* 2148521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2148532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2148541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2148544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148567 */     // MIs[0] round
     /* 2148567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148570 */     // MIs[0] policy
     /* 2148570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148580 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2148583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148606 */     // GIR_Coverage, 17970,
     /* 2148606 */     GIR_EraseRootFromParent_Done,
     /* 2148607 */   // Label 28350: @2148607
     /* 2148607 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2148698), // Rule ID 17971 //
     /* 2148612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2148623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2148626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2148632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2148635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2148654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148658 */     // MIs[0] round
     /* 2148658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148661 */     // MIs[0] policy
     /* 2148661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148671 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2148674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148697 */     // GIR_Coverage, 17971,
     /* 2148697 */     GIR_EraseRootFromParent_Done,
     /* 2148698 */   // Label 28351: @2148698
     /* 2148698 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2148789), // Rule ID 17974 //
     /* 2148703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2148714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2148717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2148723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148749 */     // MIs[0] round
     /* 2148749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148752 */     // MIs[0] policy
     /* 2148752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2148765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148788 */     // GIR_Coverage, 17974,
     /* 2148788 */     GIR_EraseRootFromParent_Done,
     /* 2148789 */   // Label 28352: @2148789
     /* 2148789 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2148880), // Rule ID 17975 //
     /* 2148794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2148805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2148808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2148814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148840 */     // MIs[0] round
     /* 2148840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148843 */     // MIs[0] policy
     /* 2148843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148853 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2148856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148879 */     // GIR_Coverage, 17975,
     /* 2148879 */     GIR_EraseRootFromParent_Done,
     /* 2148880 */   // Label 28353: @2148880
     /* 2148880 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2148971), // Rule ID 17978 //
     /* 2148885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148931 */     // MIs[0] round
     /* 2148931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148934 */     // MIs[0] policy
     /* 2148934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148944 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2148947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148970 */     // GIR_Coverage, 17978,
     /* 2148970 */     GIR_EraseRootFromParent_Done,
     /* 2148971 */   // Label 28354: @2148971
     /* 2148971 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2149062), // Rule ID 17979 //
     /* 2148976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2148984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2148987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2148990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2148996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149022 */     // MIs[0] round
     /* 2149022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149025 */     // MIs[0] policy
     /* 2149025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149035 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2149038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149061 */     // GIR_Coverage, 17979,
     /* 2149061 */     GIR_EraseRootFromParent_Done,
     /* 2149062 */   // Label 28355: @2149062
     /* 2149062 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2149153), // Rule ID 17982 //
     /* 2149067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2149075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2149078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2149081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2149087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149113 */     // MIs[0] round
     /* 2149113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149116 */     // MIs[0] policy
     /* 2149116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149126 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2149129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149152 */     // GIR_Coverage, 17982,
     /* 2149152 */     GIR_EraseRootFromParent_Done,
     /* 2149153 */   // Label 28356: @2149153
     /* 2149153 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2149244), // Rule ID 17983 //
     /* 2149158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2149161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2149166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2149169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2149172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2149178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149204 */     // MIs[0] round
     /* 2149204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149207 */     // MIs[0] policy
     /* 2149207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149217 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2149220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149243 */     // GIR_Coverage, 17983,
     /* 2149243 */     GIR_EraseRootFromParent_Done,
     /* 2149244 */   // Label 28357: @2149244
     /* 2149244 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2149335), // Rule ID 17986 //
     /* 2149249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2149260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2149263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2149266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2149269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149295 */     // MIs[0] round
     /* 2149295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149298 */     // MIs[0] policy
     /* 2149298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2149311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149334 */     // GIR_Coverage, 17986,
     /* 2149334 */     GIR_EraseRootFromParent_Done,
     /* 2149335 */   // Label 28358: @2149335
     /* 2149335 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2149426), // Rule ID 17987 //
     /* 2149340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2149351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2149354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2149357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2149360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149386 */     // MIs[0] round
     /* 2149386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149389 */     // MIs[0] policy
     /* 2149389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149399 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2149402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149425 */     // GIR_Coverage, 17987,
     /* 2149425 */     GIR_EraseRootFromParent_Done,
     /* 2149426 */   // Label 28359: @2149426
     /* 2149426 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2149517), // Rule ID 17990 //
     /* 2149431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2149442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2149445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2149448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2149451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149477 */     // MIs[0] round
     /* 2149477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149480 */     // MIs[0] policy
     /* 2149480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149490 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2149493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149516 */     // GIR_Coverage, 17990,
     /* 2149516 */     GIR_EraseRootFromParent_Done,
     /* 2149517 */   // Label 28360: @2149517
     /* 2149517 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2149608), // Rule ID 17991 //
     /* 2149522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2149533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2149536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2149539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2149542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149568 */     // MIs[0] round
     /* 2149568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149571 */     // MIs[0] policy
     /* 2149571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149581 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2149584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149607 */     // GIR_Coverage, 17991,
     /* 2149607 */     GIR_EraseRootFromParent_Done,
     /* 2149608 */   // Label 28361: @2149608
     /* 2149608 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2149699), // Rule ID 17994 //
     /* 2149613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2149624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2149627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2149630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2149633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149659 */     // MIs[0] round
     /* 2149659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149662 */     // MIs[0] policy
     /* 2149662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149672 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2149675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149698 */     // GIR_Coverage, 17994,
     /* 2149698 */     GIR_EraseRootFromParent_Done,
     /* 2149699 */   // Label 28362: @2149699
     /* 2149699 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2149790), // Rule ID 17995 //
     /* 2149704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2149715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2149718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2149721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2149724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2149727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149750 */     // MIs[0] round
     /* 2149750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149753 */     // MIs[0] policy
     /* 2149753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149763 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2149766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149789 */     // GIR_Coverage, 17995,
     /* 2149789 */     GIR_EraseRootFromParent_Done,
     /* 2149790 */   // Label 28363: @2149790
     /* 2149790 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2149881), // Rule ID 17998 //
     /* 2149795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2149812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149841 */     // MIs[0] round
     /* 2149841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149844 */     // MIs[0] policy
     /* 2149844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2149857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149880 */     // GIR_Coverage, 17998,
     /* 2149880 */     GIR_EraseRootFromParent_Done,
     /* 2149881 */   // Label 28364: @2149881
     /* 2149881 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2149972), // Rule ID 17999 //
     /* 2149886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2149897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2149900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2149903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2149906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2149916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2149928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149932 */     // MIs[0] round
     /* 2149932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149935 */     // MIs[0] policy
     /* 2149935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149945 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2149948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149971 */     // GIR_Coverage, 17999,
     /* 2149971 */     GIR_EraseRootFromParent_Done,
     /* 2149972 */   // Label 28365: @2149972
     /* 2149972 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2150063), // Rule ID 18002 //
     /* 2149977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2149988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2149991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2149994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2149997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150023 */     // MIs[0] round
     /* 2150023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150026 */     // MIs[0] policy
     /* 2150026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150036 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2150039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150062 */     // GIR_Coverage, 18002,
     /* 2150062 */     GIR_EraseRootFromParent_Done,
     /* 2150063 */   // Label 28366: @2150063
     /* 2150063 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2150154), // Rule ID 18003 //
     /* 2150068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2150079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2150082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2150085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2150088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150114 */     // MIs[0] round
     /* 2150114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150117 */     // MIs[0] policy
     /* 2150117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150127 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2150130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150153 */     // GIR_Coverage, 18003,
     /* 2150153 */     GIR_EraseRootFromParent_Done,
     /* 2150154 */   // Label 28367: @2150154
     /* 2150154 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2150245), // Rule ID 18006 //
     /* 2150159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2150170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2150173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2150176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2150179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150205 */     // MIs[0] round
     /* 2150205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150208 */     // MIs[0] policy
     /* 2150208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150218 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2150221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150244 */     // GIR_Coverage, 18006,
     /* 2150244 */     GIR_EraseRootFromParent_Done,
     /* 2150245 */   // Label 28368: @2150245
     /* 2150245 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2150336), // Rule ID 18007 //
     /* 2150250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2150261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2150264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2150267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2150270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150296 */     // MIs[0] round
     /* 2150296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150299 */     // MIs[0] policy
     /* 2150299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150309 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2150312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150335 */     // GIR_Coverage, 18007,
     /* 2150335 */     GIR_EraseRootFromParent_Done,
     /* 2150336 */   // Label 28369: @2150336
     /* 2150336 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2150427), // Rule ID 18010 //
     /* 2150341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2150352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2150355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2150358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2150361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150387 */     // MIs[0] round
     /* 2150387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150390 */     // MIs[0] policy
     /* 2150390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2150403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150426 */     // GIR_Coverage, 18010,
     /* 2150426 */     GIR_EraseRootFromParent_Done,
     /* 2150427 */   // Label 28370: @2150427
     /* 2150427 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2150518), // Rule ID 18011 //
     /* 2150432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2150443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2150446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2150449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2150452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150478 */     // MIs[0] round
     /* 2150478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150481 */     // MIs[0] policy
     /* 2150481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150491 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2150494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150517 */     // GIR_Coverage, 18011,
     /* 2150517 */     GIR_EraseRootFromParent_Done,
     /* 2150518 */   // Label 28371: @2150518
     /* 2150518 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2150609), // Rule ID 18014 //
     /* 2150523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2150534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2150537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2150540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2150543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150569 */     // MIs[0] round
     /* 2150569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150572 */     // MIs[0] policy
     /* 2150572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150582 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2150585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150608 */     // GIR_Coverage, 18014,
     /* 2150608 */     GIR_EraseRootFromParent_Done,
     /* 2150609 */   // Label 28372: @2150609
     /* 2150609 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2150700), // Rule ID 18015 //
     /* 2150614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2150625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2150628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2150631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2150634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150660 */     // MIs[0] round
     /* 2150660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150663 */     // MIs[0] policy
     /* 2150663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150673 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2150676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150699 */     // GIR_Coverage, 18015,
     /* 2150699 */     GIR_EraseRootFromParent_Done,
     /* 2150700 */   // Label 28373: @2150700
     /* 2150700 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2150791), // Rule ID 18018 //
     /* 2150705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2150716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2150725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2150728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150751 */     // MIs[0] round
     /* 2150751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150754 */     // MIs[0] policy
     /* 2150754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150764 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2150767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150790 */     // GIR_Coverage, 18018,
     /* 2150790 */     GIR_EraseRootFromParent_Done,
     /* 2150791 */   // Label 28374: @2150791
     /* 2150791 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2150882), // Rule ID 18019 //
     /* 2150796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2150807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2150810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2150813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2150816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2150819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150842 */     // MIs[0] round
     /* 2150842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150845 */     // MIs[0] policy
     /* 2150845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150855 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2150858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150881 */     // GIR_Coverage, 18019,
     /* 2150881 */     GIR_EraseRootFromParent_Done,
     /* 2150882 */   // Label 28375: @2150882
     /* 2150882 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2150973), // Rule ID 18022 //
     /* 2150887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2150904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150933 */     // MIs[0] round
     /* 2150933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150936 */     // MIs[0] policy
     /* 2150936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2150949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150972 */     // GIR_Coverage, 18022,
     /* 2150972 */     GIR_EraseRootFromParent_Done,
     /* 2150973 */   // Label 28376: @2150973
     /* 2150973 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2151064), // Rule ID 18023 //
     /* 2150978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2150989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2150992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2150995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2150998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151024 */     // MIs[0] round
     /* 2151024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151027 */     // MIs[0] policy
     /* 2151027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151037 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2151040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151063 */     // GIR_Coverage, 18023,
     /* 2151063 */     GIR_EraseRootFromParent_Done,
     /* 2151064 */   // Label 28377: @2151064
     /* 2151064 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2151155), // Rule ID 18026 //
     /* 2151069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2151080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2151083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2151086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2151089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151115 */     // MIs[0] round
     /* 2151115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151118 */     // MIs[0] policy
     /* 2151118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151128 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2151131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151154 */     // GIR_Coverage, 18026,
     /* 2151154 */     GIR_EraseRootFromParent_Done,
     /* 2151155 */   // Label 28378: @2151155
     /* 2151155 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2151246), // Rule ID 18027 //
     /* 2151160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2151171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2151174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2151177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2151180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151206 */     // MIs[0] round
     /* 2151206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151209 */     // MIs[0] policy
     /* 2151209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151219 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2151222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151245 */     // GIR_Coverage, 18027,
     /* 2151245 */     GIR_EraseRootFromParent_Done,
     /* 2151246 */   // Label 28379: @2151246
     /* 2151246 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2151337), // Rule ID 18030 //
     /* 2151251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2151262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2151265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2151268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2151271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151297 */     // MIs[0] round
     /* 2151297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151300 */     // MIs[0] policy
     /* 2151300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151310 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2151313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151336 */     // GIR_Coverage, 18030,
     /* 2151336 */     GIR_EraseRootFromParent_Done,
     /* 2151337 */   // Label 28380: @2151337
     /* 2151337 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2151428), // Rule ID 18031 //
     /* 2151342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2151353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2151356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2151359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2151362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151388 */     // MIs[0] round
     /* 2151388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151391 */     // MIs[0] policy
     /* 2151391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151401 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2151404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151427 */     // GIR_Coverage, 18031,
     /* 2151427 */     GIR_EraseRootFromParent_Done,
     /* 2151428 */   // Label 28381: @2151428
     /* 2151428 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2151519), // Rule ID 18034 //
     /* 2151433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2151444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2151447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2151450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2151453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151479 */     // MIs[0] round
     /* 2151479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151482 */     // MIs[0] policy
     /* 2151482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151492 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2151495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151518 */     // GIR_Coverage, 18034,
     /* 2151518 */     GIR_EraseRootFromParent_Done,
     /* 2151519 */   // Label 28382: @2151519
     /* 2151519 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2151610), // Rule ID 18035 //
     /* 2151524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2151535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2151538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2151541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2151544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151570 */     // MIs[0] round
     /* 2151570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151573 */     // MIs[0] policy
     /* 2151573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151583 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2151586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151609 */     // GIR_Coverage, 18035,
     /* 2151609 */     GIR_EraseRootFromParent_Done,
     /* 2151610 */   // Label 28383: @2151610
     /* 2151610 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2151701), // Rule ID 18038 //
     /* 2151615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2151626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2151629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2151632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2151635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151661 */     // MIs[0] round
     /* 2151661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151664 */     // MIs[0] policy
     /* 2151664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151674 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2151677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151700 */     // GIR_Coverage, 18038,
     /* 2151700 */     GIR_EraseRootFromParent_Done,
     /* 2151701 */   // Label 28384: @2151701
     /* 2151701 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2151792), // Rule ID 18039 //
     /* 2151706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2151717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2151720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2151723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2151726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151752 */     // MIs[0] round
     /* 2151752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151755 */     // MIs[0] policy
     /* 2151755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151765 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2151768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151791 */     // GIR_Coverage, 18039,
     /* 2151791 */     GIR_EraseRootFromParent_Done,
     /* 2151792 */   // Label 28385: @2151792
     /* 2151792 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2151883), // Rule ID 18042 //
     /* 2151797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2151814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151843 */     // MIs[0] round
     /* 2151843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151846 */     // MIs[0] policy
     /* 2151846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151856 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2151859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151882 */     // GIR_Coverage, 18042,
     /* 2151882 */     GIR_EraseRootFromParent_Done,
     /* 2151883 */   // Label 28386: @2151883
     /* 2151883 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2151974), // Rule ID 18043 //
     /* 2151888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2151899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2151902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2151905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2151908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151934 */     // MIs[0] round
     /* 2151934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151937 */     // MIs[0] policy
     /* 2151937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151947 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2151950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151973 */     // GIR_Coverage, 18043,
     /* 2151973 */     GIR_EraseRootFromParent_Done,
     /* 2151974 */   // Label 28387: @2151974
     /* 2151974 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2152065), // Rule ID 18046 //
     /* 2151979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2151987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2151990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2151993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2151996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2151999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152025 */     // MIs[0] round
     /* 2152025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152028 */     // MIs[0] policy
     /* 2152028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152038 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2152041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152064 */     // GIR_Coverage, 18046,
     /* 2152064 */     GIR_EraseRootFromParent_Done,
     /* 2152065 */   // Label 28388: @2152065
     /* 2152065 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2152156), // Rule ID 18047 //
     /* 2152070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2152081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2152084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2152090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152116 */     // MIs[0] round
     /* 2152116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152119 */     // MIs[0] policy
     /* 2152119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152129 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2152132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152155 */     // GIR_Coverage, 18047,
     /* 2152155 */     GIR_EraseRootFromParent_Done,
     /* 2152156 */   // Label 28389: @2152156
     /* 2152156 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2152247), // Rule ID 18050 //
     /* 2152161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2152172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2152175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2152181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152207 */     // MIs[0] round
     /* 2152207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152210 */     // MIs[0] policy
     /* 2152210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152220 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2152223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152246 */     // GIR_Coverage, 18050,
     /* 2152246 */     GIR_EraseRootFromParent_Done,
     /* 2152247 */   // Label 28390: @2152247
     /* 2152247 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2152338), // Rule ID 18051 //
     /* 2152252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2152263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2152266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2152272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152298 */     // MIs[0] round
     /* 2152298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152301 */     // MIs[0] policy
     /* 2152301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152311 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2152314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152337 */     // GIR_Coverage, 18051,
     /* 2152337 */     GIR_EraseRootFromParent_Done,
     /* 2152338 */   // Label 28391: @2152338
     /* 2152338 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2152429), // Rule ID 18054 //
     /* 2152343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2152354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2152357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2152363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152389 */     // MIs[0] round
     /* 2152389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152392 */     // MIs[0] policy
     /* 2152392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152402 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2152405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152428 */     // GIR_Coverage, 18054,
     /* 2152428 */     GIR_EraseRootFromParent_Done,
     /* 2152429 */   // Label 28392: @2152429
     /* 2152429 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2152520), // Rule ID 18055 //
     /* 2152434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2152445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2152448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2152454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152480 */     // MIs[0] round
     /* 2152480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152483 */     // MIs[0] policy
     /* 2152483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152493 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2152496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152519 */     // GIR_Coverage, 18055,
     /* 2152519 */     GIR_EraseRootFromParent_Done,
     /* 2152520 */   // Label 28393: @2152520
     /* 2152520 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2152611), // Rule ID 18058 //
     /* 2152525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2152536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2152539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2152545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152571 */     // MIs[0] round
     /* 2152571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152574 */     // MIs[0] policy
     /* 2152574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152584 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2152587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152610 */     // GIR_Coverage, 18058,
     /* 2152610 */     GIR_EraseRootFromParent_Done,
     /* 2152611 */   // Label 28394: @2152611
     /* 2152611 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2152702), // Rule ID 18059 //
     /* 2152616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2152627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2152630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2152633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2152636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2152654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152662 */     // MIs[0] round
     /* 2152662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152665 */     // MIs[0] policy
     /* 2152665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152675 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2152678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152701 */     // GIR_Coverage, 18059,
     /* 2152701 */     GIR_EraseRootFromParent_Done,
     /* 2152702 */   // Label 28395: @2152702
     /* 2152702 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2152793), // Rule ID 18062 //
     /* 2152707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2152718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2152721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2152727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152753 */     // MIs[0] round
     /* 2152753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152756 */     // MIs[0] policy
     /* 2152756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2152769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152792 */     // GIR_Coverage, 18062,
     /* 2152792 */     GIR_EraseRootFromParent_Done,
     /* 2152793 */   // Label 28396: @2152793
     /* 2152793 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2152884), // Rule ID 18063 //
     /* 2152798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2152809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2152812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2152815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2152818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2152836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152844 */     // MIs[0] round
     /* 2152844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152847 */     // MIs[0] policy
     /* 2152847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2152860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152883 */     // GIR_Coverage, 18063,
     /* 2152883 */     GIR_EraseRootFromParent_Done,
     /* 2152884 */   // Label 28397: @2152884
     /* 2152884 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2152975), // Rule ID 18066 //
     /* 2152889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2152906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2152909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2152912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2152919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2152927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2152931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152935 */     // MIs[0] round
     /* 2152935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152938 */     // MIs[0] policy
     /* 2152938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2152951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152974 */     // GIR_Coverage, 18066,
     /* 2152974 */     GIR_EraseRootFromParent_Done,
     /* 2152975 */   // Label 28398: @2152975
     /* 2152975 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2153066), // Rule ID 18067 //
     /* 2152980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2152988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2152991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2152994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2152997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2153000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2153018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153026 */     // MIs[0] round
     /* 2153026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153029 */     // MIs[0] policy
     /* 2153029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153039 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2153042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153065 */     // GIR_Coverage, 18067,
     /* 2153065 */     GIR_EraseRootFromParent_Done,
     /* 2153066 */   // Label 28399: @2153066
     /* 2153066 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2153157), // Rule ID 18070 //
     /* 2153071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2153082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2153085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2153091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153117 */     // MIs[0] round
     /* 2153117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153120 */     // MIs[0] policy
     /* 2153120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153130 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2153133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153156 */     // GIR_Coverage, 18070,
     /* 2153156 */     GIR_EraseRootFromParent_Done,
     /* 2153157 */   // Label 28400: @2153157
     /* 2153157 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2153248), // Rule ID 18071 //
     /* 2153162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2153173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2153176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2153182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153208 */     // MIs[0] round
     /* 2153208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153211 */     // MIs[0] policy
     /* 2153211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2153224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153247 */     // GIR_Coverage, 18071,
     /* 2153247 */     GIR_EraseRootFromParent_Done,
     /* 2153248 */   // Label 28401: @2153248
     /* 2153248 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2153339), // Rule ID 18074 //
     /* 2153253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2153264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2153267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2153273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153299 */     // MIs[0] round
     /* 2153299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153302 */     // MIs[0] policy
     /* 2153302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153312 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2153315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153338 */     // GIR_Coverage, 18074,
     /* 2153338 */     GIR_EraseRootFromParent_Done,
     /* 2153339 */   // Label 28402: @2153339
     /* 2153339 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2153430), // Rule ID 18075 //
     /* 2153344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2153355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2153358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2153364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2153367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153390 */     // MIs[0] round
     /* 2153390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153393 */     // MIs[0] policy
     /* 2153393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153403 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2153406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153429 */     // GIR_Coverage, 18075,
     /* 2153429 */     GIR_EraseRootFromParent_Done,
     /* 2153430 */   // Label 28403: @2153430
     /* 2153430 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2153521), // Rule ID 18078 //
     /* 2153435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2153446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2153449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2153455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2153458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153481 */     // MIs[0] round
     /* 2153481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153484 */     // MIs[0] policy
     /* 2153484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153494 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2153497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153520 */     // GIR_Coverage, 18078,
     /* 2153520 */     GIR_EraseRootFromParent_Done,
     /* 2153521 */   // Label 28404: @2153521
     /* 2153521 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2153612), // Rule ID 18079 //
     /* 2153526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2153537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2153540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2153546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2153549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153572 */     // MIs[0] round
     /* 2153572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153575 */     // MIs[0] policy
     /* 2153575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153585 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2153588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153611 */     // GIR_Coverage, 18079,
     /* 2153611 */     GIR_EraseRootFromParent_Done,
     /* 2153612 */   // Label 28405: @2153612
     /* 2153612 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2153703), // Rule ID 18082 //
     /* 2153617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2153628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2153631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2153637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153663 */     // MIs[0] round
     /* 2153663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153666 */     // MIs[0] policy
     /* 2153666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153676 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2153679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153702 */     // GIR_Coverage, 18082,
     /* 2153702 */     GIR_EraseRootFromParent_Done,
     /* 2153703 */   // Label 28406: @2153703
     /* 2153703 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2153794), // Rule ID 18083 //
     /* 2153708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2153719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2153722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2153728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2153738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2153750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153754 */     // MIs[0] round
     /* 2153754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153757 */     // MIs[0] policy
     /* 2153757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153767 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2153770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153793 */     // GIR_Coverage, 18083,
     /* 2153793 */     GIR_EraseRootFromParent_Done,
     /* 2153794 */   // Label 28407: @2153794
     /* 2153794 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2153885), // Rule ID 18086 //
     /* 2153799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153845 */     // MIs[0] round
     /* 2153845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153848 */     // MIs[0] policy
     /* 2153848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153858 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2153861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153884 */     // GIR_Coverage, 18086,
     /* 2153884 */     GIR_EraseRootFromParent_Done,
     /* 2153885 */   // Label 28408: @2153885
     /* 2153885 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2153976), // Rule ID 18087 //
     /* 2153890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2153901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2153904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2153910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153936 */     // MIs[0] round
     /* 2153936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153939 */     // MIs[0] policy
     /* 2153939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153949 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2153952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153975 */     // GIR_Coverage, 18087,
     /* 2153975 */     GIR_EraseRootFromParent_Done,
     /* 2153976 */   // Label 28409: @2153976
     /* 2153976 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2154067), // Rule ID 18090 //
     /* 2153981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2153989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2153992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2153995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2154001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154027 */     // MIs[0] round
     /* 2154027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154030 */     // MIs[0] policy
     /* 2154030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154040 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2154043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154066 */     // GIR_Coverage, 18090,
     /* 2154066 */     GIR_EraseRootFromParent_Done,
     /* 2154067 */   // Label 28410: @2154067
     /* 2154067 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2154158), // Rule ID 18091 //
     /* 2154072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2154083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2154086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2154092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154118 */     // MIs[0] round
     /* 2154118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154121 */     // MIs[0] policy
     /* 2154121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154131 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2154134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154157 */     // GIR_Coverage, 18091,
     /* 2154157 */     GIR_EraseRootFromParent_Done,
     /* 2154158 */   // Label 28411: @2154158
     /* 2154158 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2154249), // Rule ID 18094 //
     /* 2154163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2154174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2154177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2154183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154209 */     // MIs[0] round
     /* 2154209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154212 */     // MIs[0] policy
     /* 2154212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2154225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154248 */     // GIR_Coverage, 18094,
     /* 2154248 */     GIR_EraseRootFromParent_Done,
     /* 2154249 */   // Label 28412: @2154249
     /* 2154249 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2154340), // Rule ID 18095 //
     /* 2154254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2154265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2154268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2154274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154300 */     // MIs[0] round
     /* 2154300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154303 */     // MIs[0] policy
     /* 2154303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154313 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2154316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154339 */     // GIR_Coverage, 18095,
     /* 2154339 */     GIR_EraseRootFromParent_Done,
     /* 2154340 */   // Label 28413: @2154340
     /* 2154340 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2154431), // Rule ID 18098 //
     /* 2154345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2154356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2154359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2154365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154391 */     // MIs[0] round
     /* 2154391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154394 */     // MIs[0] policy
     /* 2154394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154404 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2154407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154430 */     // GIR_Coverage, 18098,
     /* 2154430 */     GIR_EraseRootFromParent_Done,
     /* 2154431 */   // Label 28414: @2154431
     /* 2154431 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2154522), // Rule ID 18099 //
     /* 2154436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2154447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2154450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2154456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154482 */     // MIs[0] round
     /* 2154482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154485 */     // MIs[0] policy
     /* 2154485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154495 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2154498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154521 */     // GIR_Coverage, 18099,
     /* 2154521 */     GIR_EraseRootFromParent_Done,
     /* 2154522 */   // Label 28415: @2154522
     /* 2154522 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2154613), // Rule ID 18102 //
     /* 2154527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2154538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2154541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2154547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154573 */     // MIs[0] round
     /* 2154573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154576 */     // MIs[0] policy
     /* 2154576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154586 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2154589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154612 */     // GIR_Coverage, 18102,
     /* 2154612 */     GIR_EraseRootFromParent_Done,
     /* 2154613 */   // Label 28416: @2154613
     /* 2154613 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2154704), // Rule ID 18103 //
     /* 2154618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2154626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2154629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2154632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2154638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154664 */     // MIs[0] round
     /* 2154664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154667 */     // MIs[0] policy
     /* 2154667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154677 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2154680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154703 */     // GIR_Coverage, 18103,
     /* 2154703 */     GIR_EraseRootFromParent_Done,
     /* 2154704 */   // Label 28417: @2154704
     /* 2154704 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2154795), // Rule ID 18106 //
     /* 2154709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2154720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2154729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154755 */     // MIs[0] round
     /* 2154755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154758 */     // MIs[0] policy
     /* 2154758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154768 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2154771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154794 */     // GIR_Coverage, 18106,
     /* 2154794 */     GIR_EraseRootFromParent_Done,
     /* 2154795 */   // Label 28418: @2154795
     /* 2154795 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2154886), // Rule ID 18107 //
     /* 2154800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2154811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2154814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2154817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2154820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154846 */     // MIs[0] round
     /* 2154846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154849 */     // MIs[0] policy
     /* 2154849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154859 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2154862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154885 */     // GIR_Coverage, 18107,
     /* 2154885 */     GIR_EraseRootFromParent_Done,
     /* 2154886 */   // Label 28419: @2154886
     /* 2154886 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2154977), // Rule ID 18110 //
     /* 2154891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2154908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2154911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154937 */     // MIs[0] round
     /* 2154937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154940 */     // MIs[0] policy
     /* 2154940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2154953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154976 */     // GIR_Coverage, 18110,
     /* 2154976 */     GIR_EraseRootFromParent_Done,
     /* 2154977 */   // Label 28420: @2154977
     /* 2154977 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2155068), // Rule ID 18111 //
     /* 2154982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2154993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2154996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2154999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2155002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155028 */     // MIs[0] round
     /* 2155028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155031 */     // MIs[0] policy
     /* 2155031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155041 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2155044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155067 */     // GIR_Coverage, 18111,
     /* 2155067 */     GIR_EraseRootFromParent_Done,
     /* 2155068 */   // Label 28421: @2155068
     /* 2155068 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2155159), // Rule ID 18114 //
     /* 2155073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2155084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2155093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155119 */     // MIs[0] round
     /* 2155119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155122 */     // MIs[0] policy
     /* 2155122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155132 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2155135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155158 */     // GIR_Coverage, 18114,
     /* 2155158 */     GIR_EraseRootFromParent_Done,
     /* 2155159 */   // Label 28422: @2155159
     /* 2155159 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2155250), // Rule ID 18115 //
     /* 2155164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2155175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2155178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2155181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2155184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155210 */     // MIs[0] round
     /* 2155210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155213 */     // MIs[0] policy
     /* 2155213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155223 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2155226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155249 */     // GIR_Coverage, 18115,
     /* 2155249 */     GIR_EraseRootFromParent_Done,
     /* 2155250 */   // Label 28423: @2155250
     /* 2155250 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2155341), // Rule ID 18118 //
     /* 2155255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2155266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2155269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2155272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2155275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155301 */     // MIs[0] round
     /* 2155301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155304 */     // MIs[0] policy
     /* 2155304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2155317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155340 */     // GIR_Coverage, 18118,
     /* 2155340 */     GIR_EraseRootFromParent_Done,
     /* 2155341 */   // Label 28424: @2155341
     /* 2155341 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2155432), // Rule ID 18119 //
     /* 2155346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2155357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2155360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2155363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2155366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155392 */     // MIs[0] round
     /* 2155392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155395 */     // MIs[0] policy
     /* 2155395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155405 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2155408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155431 */     // GIR_Coverage, 18119,
     /* 2155431 */     GIR_EraseRootFromParent_Done,
     /* 2155432 */   // Label 28425: @2155432
     /* 2155432 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2155523), // Rule ID 18122 //
     /* 2155437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2155448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2155457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155483 */     // MIs[0] round
     /* 2155483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155486 */     // MIs[0] policy
     /* 2155486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155496 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2155499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155522 */     // GIR_Coverage, 18122,
     /* 2155522 */     GIR_EraseRootFromParent_Done,
     /* 2155523 */   // Label 28426: @2155523
     /* 2155523 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2155614), // Rule ID 18123 //
     /* 2155528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2155539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2155542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2155545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2155548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155574 */     // MIs[0] round
     /* 2155574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155577 */     // MIs[0] policy
     /* 2155577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2155590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155613 */     // GIR_Coverage, 18123,
     /* 2155613 */     GIR_EraseRootFromParent_Done,
     /* 2155614 */   // Label 28427: @2155614
     /* 2155614 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2155705), // Rule ID 18126 //
     /* 2155619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2155630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2155639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155665 */     // MIs[0] round
     /* 2155665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155668 */     // MIs[0] policy
     /* 2155668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2155681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155704 */     // GIR_Coverage, 18126,
     /* 2155704 */     GIR_EraseRootFromParent_Done,
     /* 2155705 */   // Label 28428: @2155705
     /* 2155705 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2155796), // Rule ID 18127 //
     /* 2155710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2155721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2155724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2155727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2155730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155756 */     // MIs[0] round
     /* 2155756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155759 */     // MIs[0] policy
     /* 2155759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155769 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2155772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155795 */     // GIR_Coverage, 18127,
     /* 2155795 */     GIR_EraseRootFromParent_Done,
     /* 2155796 */   // Label 28429: @2155796
     /* 2155796 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2155887), // Rule ID 18130 //
     /* 2155801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2155818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155847 */     // MIs[0] round
     /* 2155847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155850 */     // MIs[0] policy
     /* 2155850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2155863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155886 */     // GIR_Coverage, 18130,
     /* 2155886 */     GIR_EraseRootFromParent_Done,
     /* 2155887 */   // Label 28430: @2155887
     /* 2155887 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2155978), // Rule ID 18131 //
     /* 2155892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2155903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2155906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2155909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2155912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155938 */     // MIs[0] round
     /* 2155938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155941 */     // MIs[0] policy
     /* 2155941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155951 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2155954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155977 */     // GIR_Coverage, 18131,
     /* 2155977 */     GIR_EraseRootFromParent_Done,
     /* 2155978 */   // Label 28431: @2155978
     /* 2155978 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2156069), // Rule ID 18134 //
     /* 2155983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2155994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2155997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2156000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2156003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156029 */     // MIs[0] round
     /* 2156029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156032 */     // MIs[0] policy
     /* 2156032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156042 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2156045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156068 */     // GIR_Coverage, 18134,
     /* 2156068 */     GIR_EraseRootFromParent_Done,
     /* 2156069 */   // Label 28432: @2156069
     /* 2156069 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2156160), // Rule ID 18135 //
     /* 2156074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2156085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2156088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2156091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2156094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156120 */     // MIs[0] round
     /* 2156120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156123 */     // MIs[0] policy
     /* 2156123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156133 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2156136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156159 */     // GIR_Coverage, 18135,
     /* 2156159 */     GIR_EraseRootFromParent_Done,
     /* 2156160 */   // Label 28433: @2156160
     /* 2156160 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2156251), // Rule ID 18138 //
     /* 2156165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2156176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2156179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2156182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2156185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2156188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156211 */     // MIs[0] round
     /* 2156211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156214 */     // MIs[0] policy
     /* 2156214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2156227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156250 */     // GIR_Coverage, 18138,
     /* 2156250 */     GIR_EraseRootFromParent_Done,
     /* 2156251 */   // Label 28434: @2156251
     /* 2156251 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2156342), // Rule ID 18139 //
     /* 2156256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2156267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2156270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2156273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2156276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2156279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156302 */     // MIs[0] round
     /* 2156302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156305 */     // MIs[0] policy
     /* 2156305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156315 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2156318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156341 */     // GIR_Coverage, 18139,
     /* 2156341 */     GIR_EraseRootFromParent_Done,
     /* 2156342 */   // Label 28435: @2156342
     /* 2156342 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2156433), // Rule ID 18142 //
     /* 2156347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2156358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2156367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156393 */     // MIs[0] round
     /* 2156393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156396 */     // MIs[0] policy
     /* 2156396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2156409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156432 */     // GIR_Coverage, 18142,
     /* 2156432 */     GIR_EraseRootFromParent_Done,
     /* 2156433 */   // Label 28436: @2156433
     /* 2156433 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2156524), // Rule ID 18143 //
     /* 2156438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2156449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2156452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2156455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2156458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156484 */     // MIs[0] round
     /* 2156484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156487 */     // MIs[0] policy
     /* 2156487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156497 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2156500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156523 */     // GIR_Coverage, 18143,
     /* 2156523 */     GIR_EraseRootFromParent_Done,
     /* 2156524 */   // Label 28437: @2156524
     /* 2156524 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2156615), // Rule ID 18146 //
     /* 2156529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2156540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2156543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2156546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2156549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156575 */     // MIs[0] round
     /* 2156575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156578 */     // MIs[0] policy
     /* 2156578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156588 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2156591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156614 */     // GIR_Coverage, 18146,
     /* 2156614 */     GIR_EraseRootFromParent_Done,
     /* 2156615 */   // Label 28438: @2156615
     /* 2156615 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2156706), // Rule ID 18147 //
     /* 2156620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2156631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2156634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2156637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2156640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2156650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2156662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156666 */     // MIs[0] round
     /* 2156666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156669 */     // MIs[0] policy
     /* 2156669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156679 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2156682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156705 */     // GIR_Coverage, 18147,
     /* 2156705 */     GIR_EraseRootFromParent_Done,
     /* 2156706 */   // Label 28439: @2156706
     /* 2156706 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2156797), // Rule ID 18150 //
     /* 2156711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2156722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2156725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2156728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2156731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156757 */     // MIs[0] round
     /* 2156757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156760 */     // MIs[0] policy
     /* 2156760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2156773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156796 */     // GIR_Coverage, 18150,
     /* 2156796 */     GIR_EraseRootFromParent_Done,
     /* 2156797 */   // Label 28440: @2156797
     /* 2156797 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2156888), // Rule ID 18151 //
     /* 2156802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2156813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2156816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2156819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2156822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2156825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156848 */     // MIs[0] round
     /* 2156848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156851 */     // MIs[0] policy
     /* 2156851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156861 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2156864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156887 */     // GIR_Coverage, 18151,
     /* 2156887 */     GIR_EraseRootFromParent_Done,
     /* 2156888 */   // Label 28441: @2156888
     /* 2156888 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2156979), // Rule ID 18154 //
     /* 2156893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2156910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2156913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156939 */     // MIs[0] round
     /* 2156939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156942 */     // MIs[0] policy
     /* 2156942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2156955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156978 */     // GIR_Coverage, 18154,
     /* 2156978 */     GIR_EraseRootFromParent_Done,
     /* 2156979 */   // Label 28442: @2156979
     /* 2156979 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2157070), // Rule ID 18155 //
     /* 2156984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2156992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2156995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2156998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2157001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2157004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157030 */     // MIs[0] round
     /* 2157030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157033 */     // MIs[0] policy
     /* 2157033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2157046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157069 */     // GIR_Coverage, 18155,
     /* 2157069 */     GIR_EraseRootFromParent_Done,
     /* 2157070 */   // Label 28443: @2157070
     /* 2157070 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2157161), // Rule ID 18158 //
     /* 2157075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2157086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2157095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157121 */     // MIs[0] round
     /* 2157121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157124 */     // MIs[0] policy
     /* 2157124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2157137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157160 */     // GIR_Coverage, 18158,
     /* 2157160 */     GIR_EraseRootFromParent_Done,
     /* 2157161 */   // Label 28444: @2157161
     /* 2157161 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2157252), // Rule ID 18159 //
     /* 2157166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2157177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2157180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2157183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2157186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157212 */     // MIs[0] round
     /* 2157212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157215 */     // MIs[0] policy
     /* 2157215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157225 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2157228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157251 */     // GIR_Coverage, 18159,
     /* 2157251 */     GIR_EraseRootFromParent_Done,
     /* 2157252 */   // Label 28445: @2157252
     /* 2157252 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2157343), // Rule ID 18162 //
     /* 2157257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2157268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2157271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2157274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2157277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157303 */     // MIs[0] round
     /* 2157303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157306 */     // MIs[0] policy
     /* 2157306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2157319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157342 */     // GIR_Coverage, 18162,
     /* 2157342 */     GIR_EraseRootFromParent_Done,
     /* 2157343 */   // Label 28446: @2157343
     /* 2157343 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2157434), // Rule ID 18163 //
     /* 2157348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2157359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2157362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2157365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2157368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157394 */     // MIs[0] round
     /* 2157394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157397 */     // MIs[0] policy
     /* 2157397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157407 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2157410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157433 */     // GIR_Coverage, 18163,
     /* 2157433 */     GIR_EraseRootFromParent_Done,
     /* 2157434 */   // Label 28447: @2157434
     /* 2157434 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2157525), // Rule ID 18166 //
     /* 2157439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2157450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2157453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2157459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157485 */     // MIs[0] round
     /* 2157485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157488 */     // MIs[0] policy
     /* 2157488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157498 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2157501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157524 */     // GIR_Coverage, 18166,
     /* 2157524 */     GIR_EraseRootFromParent_Done,
     /* 2157525 */   // Label 28448: @2157525
     /* 2157525 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2157616), // Rule ID 18167 //
     /* 2157530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2157541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2157544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2157550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157576 */     // MIs[0] round
     /* 2157576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157579 */     // MIs[0] policy
     /* 2157579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157589 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2157592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157615 */     // GIR_Coverage, 18167,
     /* 2157615 */     GIR_EraseRootFromParent_Done,
     /* 2157616 */   // Label 28449: @2157616
     /* 2157616 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2157707), // Rule ID 18170 //
     /* 2157621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2157632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2157635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2157641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157667 */     // MIs[0] round
     /* 2157667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157670 */     // MIs[0] policy
     /* 2157670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157680 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2157683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157706 */     // GIR_Coverage, 18170,
     /* 2157706 */     GIR_EraseRootFromParent_Done,
     /* 2157707 */   // Label 28450: @2157707
     /* 2157707 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2157798), // Rule ID 18171 //
     /* 2157712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2157723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2157726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2157729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2157732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2157735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2157750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157758 */     // MIs[0] round
     /* 2157758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157761 */     // MIs[0] policy
     /* 2157761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157771 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2157774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157797 */     // GIR_Coverage, 18171,
     /* 2157797 */     GIR_EraseRootFromParent_Done,
     /* 2157798 */   // Label 28451: @2157798
     /* 2157798 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2157889), // Rule ID 18174 //
     /* 2157803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2157820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2157841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157849 */     // MIs[0] round
     /* 2157849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157852 */     // MIs[0] policy
     /* 2157852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157862 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2157865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157888 */     // GIR_Coverage, 18174,
     /* 2157888 */     GIR_EraseRootFromParent_Done,
     /* 2157889 */   // Label 28452: @2157889
     /* 2157889 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2157980), // Rule ID 18175 //
     /* 2157894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2157905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2157908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2157911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2157914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2157932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157940 */     // MIs[0] round
     /* 2157940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157943 */     // MIs[0] policy
     /* 2157943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157953 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2157956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157979 */     // GIR_Coverage, 18175,
     /* 2157979 */     GIR_EraseRootFromParent_Done,
     /* 2157980 */   // Label 28453: @2157980
     /* 2157980 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2158071), // Rule ID 18178 //
     /* 2157985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2157993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2157996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2157999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2158005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158031 */     // MIs[0] round
     /* 2158031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158034 */     // MIs[0] policy
     /* 2158034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158044 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2158047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158070 */     // GIR_Coverage, 18178,
     /* 2158070 */     GIR_EraseRootFromParent_Done,
     /* 2158071 */   // Label 28454: @2158071
     /* 2158071 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2158162), // Rule ID 18179 //
     /* 2158076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2158087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2158090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2158096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158122 */     // MIs[0] round
     /* 2158122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158125 */     // MIs[0] policy
     /* 2158125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158135 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2158138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158161 */     // GIR_Coverage, 18179,
     /* 2158161 */     GIR_EraseRootFromParent_Done,
     /* 2158162 */   // Label 28455: @2158162
     /* 2158162 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2158253), // Rule ID 18182 //
     /* 2158167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2158178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2158181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2158187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158213 */     // MIs[0] round
     /* 2158213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158216 */     // MIs[0] policy
     /* 2158216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158226 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2158229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158252 */     // GIR_Coverage, 18182,
     /* 2158252 */     GIR_EraseRootFromParent_Done,
     /* 2158253 */   // Label 28456: @2158253
     /* 2158253 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2158344), // Rule ID 18183 //
     /* 2158258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2158269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2158272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2158278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158304 */     // MIs[0] round
     /* 2158304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158307 */     // MIs[0] policy
     /* 2158307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158317 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2158320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158343 */     // GIR_Coverage, 18183,
     /* 2158343 */     GIR_EraseRootFromParent_Done,
     /* 2158344 */   // Label 28457: @2158344
     /* 2158344 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2158435), // Rule ID 18186 //
     /* 2158349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2158360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2158363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2158366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2158369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2158387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158395 */     // MIs[0] round
     /* 2158395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158398 */     // MIs[0] policy
     /* 2158398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2158411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158434 */     // GIR_Coverage, 18186,
     /* 2158434 */     GIR_EraseRootFromParent_Done,
     /* 2158435 */   // Label 28458: @2158435
     /* 2158435 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2158526), // Rule ID 18187 //
     /* 2158440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2158451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2158454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2158457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2158460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2158478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158486 */     // MIs[0] round
     /* 2158486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158489 */     // MIs[0] policy
     /* 2158489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2158502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158525 */     // GIR_Coverage, 18187,
     /* 2158525 */     GIR_EraseRootFromParent_Done,
     /* 2158526 */   // Label 28459: @2158526
     /* 2158526 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2158617), // Rule ID 18190 //
     /* 2158531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2158542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2158551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158577 */     // MIs[0] round
     /* 2158577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158580 */     // MIs[0] policy
     /* 2158580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158590 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2158593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158616 */     // GIR_Coverage, 18190,
     /* 2158616 */     GIR_EraseRootFromParent_Done,
     /* 2158617 */   // Label 28460: @2158617
     /* 2158617 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2158708), // Rule ID 18191 //
     /* 2158622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2158633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2158636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2158642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158668 */     // MIs[0] round
     /* 2158668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158671 */     // MIs[0] policy
     /* 2158671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158681 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2158684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158707 */     // GIR_Coverage, 18191,
     /* 2158707 */     GIR_EraseRootFromParent_Done,
     /* 2158708 */   // Label 28461: @2158708
     /* 2158708 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2158799), // Rule ID 18194 //
     /* 2158713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2158724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2158727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2158733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158759 */     // MIs[0] round
     /* 2158759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158762 */     // MIs[0] policy
     /* 2158762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158772 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2158775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158798 */     // GIR_Coverage, 18194,
     /* 2158798 */     GIR_EraseRootFromParent_Done,
     /* 2158799 */   // Label 28462: @2158799
     /* 2158799 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2158890), // Rule ID 18195 //
     /* 2158804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2158815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2158818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2158824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158850 */     // MIs[0] round
     /* 2158850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158853 */     // MIs[0] policy
     /* 2158853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158863 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2158866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158889 */     // GIR_Coverage, 18195,
     /* 2158889 */     GIR_EraseRootFromParent_Done,
     /* 2158890 */   // Label 28463: @2158890
     /* 2158890 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2158981), // Rule ID 18198 //
     /* 2158895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2158909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2158915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2158918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158941 */     // MIs[0] round
     /* 2158941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158944 */     // MIs[0] policy
     /* 2158944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158954 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2158957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158980 */     // GIR_Coverage, 18198,
     /* 2158980 */     GIR_EraseRootFromParent_Done,
     /* 2158981 */   // Label 28464: @2158981
     /* 2158981 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2159072), // Rule ID 18199 //
     /* 2158986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2158994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2158997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2159000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2159006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2159009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159032 */     // MIs[0] round
     /* 2159032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159035 */     // MIs[0] policy
     /* 2159035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159045 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2159048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159071 */     // GIR_Coverage, 18199,
     /* 2159071 */     GIR_EraseRootFromParent_Done,
     /* 2159072 */   // Label 28465: @2159072
     /* 2159072 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2159163), // Rule ID 18202 //
     /* 2159077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2159088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2159091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2159097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159123 */     // MIs[0] round
     /* 2159123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159126 */     // MIs[0] policy
     /* 2159126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2159139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159162 */     // GIR_Coverage, 18202,
     /* 2159162 */     GIR_EraseRootFromParent_Done,
     /* 2159163 */   // Label 28466: @2159163
     /* 2159163 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2159254), // Rule ID 18203 //
     /* 2159168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2159179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2159182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2159188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159214 */     // MIs[0] round
     /* 2159214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159217 */     // MIs[0] policy
     /* 2159217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2159230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159253 */     // GIR_Coverage, 18203,
     /* 2159253 */     GIR_EraseRootFromParent_Done,
     /* 2159254 */   // Label 28467: @2159254
     /* 2159254 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2159345), // Rule ID 18206 //
     /* 2159259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2159270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2159273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2159279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159305 */     // MIs[0] round
     /* 2159305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159308 */     // MIs[0] policy
     /* 2159308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159318 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2159321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159344 */     // GIR_Coverage, 18206,
     /* 2159344 */     GIR_EraseRootFromParent_Done,
     /* 2159345 */   // Label 28468: @2159345
     /* 2159345 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2159436), // Rule ID 18207 //
     /* 2159350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2159361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2159364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2159370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159396 */     // MIs[0] round
     /* 2159396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159399 */     // MIs[0] policy
     /* 2159399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159409 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2159412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159435 */     // GIR_Coverage, 18207,
     /* 2159435 */     GIR_EraseRootFromParent_Done,
     /* 2159436 */   // Label 28469: @2159436
     /* 2159436 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2159527), // Rule ID 18210 //
     /* 2159441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2159452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2159461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159487 */     // MIs[0] round
     /* 2159487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159490 */     // MIs[0] policy
     /* 2159490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159500 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2159503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159526 */     // GIR_Coverage, 18210,
     /* 2159526 */     GIR_EraseRootFromParent_Done,
     /* 2159527 */   // Label 28470: @2159527
     /* 2159527 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2159618), // Rule ID 18211 //
     /* 2159532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2159543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2159546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2159552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2159574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159578 */     // MIs[0] round
     /* 2159578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159581 */     // MIs[0] policy
     /* 2159581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159591 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2159594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159617 */     // GIR_Coverage, 18211,
     /* 2159617 */     GIR_EraseRootFromParent_Done,
     /* 2159618 */   // Label 28471: @2159618
     /* 2159618 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2159709), // Rule ID 18214 //
     /* 2159623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2159634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2159637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2159643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159669 */     // MIs[0] round
     /* 2159669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159672 */     // MIs[0] policy
     /* 2159672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159682 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2159685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159708 */     // GIR_Coverage, 18214,
     /* 2159708 */     GIR_EraseRootFromParent_Done,
     /* 2159709 */   // Label 28472: @2159709
     /* 2159709 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2159800), // Rule ID 18215 //
     /* 2159714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2159725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2159728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2159734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159760 */     // MIs[0] round
     /* 2159760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159763 */     // MIs[0] policy
     /* 2159763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159773 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2159776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159799 */     // GIR_Coverage, 18215,
     /* 2159799 */     GIR_EraseRootFromParent_Done,
     /* 2159800 */   // Label 28473: @2159800
     /* 2159800 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2159891), // Rule ID 18218 //
     /* 2159805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159851 */     // MIs[0] round
     /* 2159851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159854 */     // MIs[0] policy
     /* 2159854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2159867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159890 */     // GIR_Coverage, 18218,
     /* 2159890 */     GIR_EraseRootFromParent_Done,
     /* 2159891 */   // Label 28474: @2159891
     /* 2159891 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2159982), // Rule ID 18219 //
     /* 2159896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2159907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2159910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2159916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159942 */     // MIs[0] round
     /* 2159942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159945 */     // MIs[0] policy
     /* 2159945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159955 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2159958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159981 */     // GIR_Coverage, 18219,
     /* 2159981 */     GIR_EraseRootFromParent_Done,
     /* 2159982 */   // Label 28475: @2159982
     /* 2159982 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2160073), // Rule ID 18222 //
     /* 2159987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2159995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2159998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2160001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2160007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160033 */     // MIs[0] round
     /* 2160033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160036 */     // MIs[0] policy
     /* 2160036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160046 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2160049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160072 */     // GIR_Coverage, 18222,
     /* 2160072 */     GIR_EraseRootFromParent_Done,
     /* 2160073 */   // Label 28476: @2160073
     /* 2160073 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2160164), // Rule ID 18223 //
     /* 2160078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2160081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2160086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2160089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2160092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2160098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160124 */     // MIs[0] round
     /* 2160124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160127 */     // MIs[0] policy
     /* 2160127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160137 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2160140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160163 */     // GIR_Coverage, 18223,
     /* 2160163 */     GIR_EraseRootFromParent_Done,
     /* 2160164 */   // Label 28477: @2160164
     /* 2160164 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2160255), // Rule ID 18226 //
     /* 2160169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2160180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2160183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2160186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2160189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160215 */     // MIs[0] round
     /* 2160215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160218 */     // MIs[0] policy
     /* 2160218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160228 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2160231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160254 */     // GIR_Coverage, 18226,
     /* 2160254 */     GIR_EraseRootFromParent_Done,
     /* 2160255 */   // Label 28478: @2160255
     /* 2160255 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2160346), // Rule ID 18227 //
     /* 2160260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2160271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2160274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2160277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2160280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160306 */     // MIs[0] round
     /* 2160306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160309 */     // MIs[0] policy
     /* 2160309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160319 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2160322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160345 */     // GIR_Coverage, 18227,
     /* 2160345 */     GIR_EraseRootFromParent_Done,
     /* 2160346 */   // Label 28479: @2160346
     /* 2160346 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2160437), // Rule ID 18230 //
     /* 2160351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2160362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2160365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2160368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2160371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160397 */     // MIs[0] round
     /* 2160397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160400 */     // MIs[0] policy
     /* 2160400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2160413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160436 */     // GIR_Coverage, 18230,
     /* 2160436 */     GIR_EraseRootFromParent_Done,
     /* 2160437 */   // Label 28480: @2160437
     /* 2160437 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2160528), // Rule ID 18231 //
     /* 2160442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2160453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2160456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2160459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2160462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160488 */     // MIs[0] round
     /* 2160488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160491 */     // MIs[0] policy
     /* 2160491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160501 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2160504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160527 */     // GIR_Coverage, 18231,
     /* 2160527 */     GIR_EraseRootFromParent_Done,
     /* 2160528 */   // Label 28481: @2160528
     /* 2160528 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2160619), // Rule ID 18234 //
     /* 2160533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2160544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2160547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2160550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2160553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160579 */     // MIs[0] round
     /* 2160579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160582 */     // MIs[0] policy
     /* 2160582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160592 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2160595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160618 */     // GIR_Coverage, 18234,
     /* 2160618 */     GIR_EraseRootFromParent_Done,
     /* 2160619 */   // Label 28482: @2160619
     /* 2160619 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2160710), // Rule ID 18235 //
     /* 2160624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2160635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2160638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2160641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2160644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2160647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160670 */     // MIs[0] round
     /* 2160670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160673 */     // MIs[0] policy
     /* 2160673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2160686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160709 */     // GIR_Coverage, 18235,
     /* 2160709 */     GIR_EraseRootFromParent_Done,
     /* 2160710 */   // Label 28483: @2160710
     /* 2160710 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2160801), // Rule ID 18238 //
     /* 2160715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2160726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2160729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2160732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2160735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160761 */     // MIs[0] round
     /* 2160761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160764 */     // MIs[0] policy
     /* 2160764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2160777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160800 */     // GIR_Coverage, 18238,
     /* 2160800 */     GIR_EraseRootFromParent_Done,
     /* 2160801 */   // Label 28484: @2160801
     /* 2160801 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2160892), // Rule ID 18239 //
     /* 2160806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2160817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2160820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2160823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2160826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160852 */     // MIs[0] round
     /* 2160852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160855 */     // MIs[0] policy
     /* 2160855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160865 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2160868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160891 */     // GIR_Coverage, 18239,
     /* 2160891 */     GIR_EraseRootFromParent_Done,
     /* 2160892 */   // Label 28485: @2160892
     /* 2160892 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2160983), // Rule ID 18242 //
     /* 2160897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2160911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2160914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2160917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2160927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2160939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160943 */     // MIs[0] round
     /* 2160943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160946 */     // MIs[0] policy
     /* 2160946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2160959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160982 */     // GIR_Coverage, 18242,
     /* 2160982 */     GIR_EraseRootFromParent_Done,
     /* 2160983 */   // Label 28486: @2160983
     /* 2160983 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2161074), // Rule ID 18243 //
     /* 2160988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2160999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2161002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2161005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2161008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161034 */     // MIs[0] round
     /* 2161034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161037 */     // MIs[0] policy
     /* 2161037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161047 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2161050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161073 */     // GIR_Coverage, 18243,
     /* 2161073 */     GIR_EraseRootFromParent_Done,
     /* 2161074 */   // Label 28487: @2161074
     /* 2161074 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2161165), // Rule ID 18246 //
     /* 2161079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2161090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2161093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2161096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2161099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161125 */     // MIs[0] round
     /* 2161125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161128 */     // MIs[0] policy
     /* 2161128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2161141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161164 */     // GIR_Coverage, 18246,
     /* 2161164 */     GIR_EraseRootFromParent_Done,
     /* 2161165 */   // Label 28488: @2161165
     /* 2161165 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2161256), // Rule ID 18247 //
     /* 2161170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2161181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2161184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2161187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2161190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161216 */     // MIs[0] round
     /* 2161216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161219 */     // MIs[0] policy
     /* 2161219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161229 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2161232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161255 */     // GIR_Coverage, 18247,
     /* 2161255 */     GIR_EraseRootFromParent_Done,
     /* 2161256 */   // Label 28489: @2161256
     /* 2161256 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2161347), // Rule ID 18250 //
     /* 2161261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2161272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2161275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2161278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2161281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161307 */     // MIs[0] round
     /* 2161307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161310 */     // MIs[0] policy
     /* 2161310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161320 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2161323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161346 */     // GIR_Coverage, 18250,
     /* 2161346 */     GIR_EraseRootFromParent_Done,
     /* 2161347 */   // Label 28490: @2161347
     /* 2161347 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2161438), // Rule ID 18251 //
     /* 2161352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2161363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2161366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2161369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2161372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161398 */     // MIs[0] round
     /* 2161398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161401 */     // MIs[0] policy
     /* 2161401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161411 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2161414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161437 */     // GIR_Coverage, 18251,
     /* 2161437 */     GIR_EraseRootFromParent_Done,
     /* 2161438 */   // Label 28491: @2161438
     /* 2161438 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2161529), // Rule ID 18254 //
     /* 2161443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2161454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2161457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2161460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2161463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161489 */     // MIs[0] round
     /* 2161489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161492 */     // MIs[0] policy
     /* 2161492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161502 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2161505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161528 */     // GIR_Coverage, 18254,
     /* 2161528 */     GIR_EraseRootFromParent_Done,
     /* 2161529 */   // Label 28492: @2161529
     /* 2161529 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2161620), // Rule ID 18255 //
     /* 2161534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2161545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2161548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2161551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2161554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2161557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161580 */     // MIs[0] round
     /* 2161580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161583 */     // MIs[0] policy
     /* 2161583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161593 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2161596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161619 */     // GIR_Coverage, 18255,
     /* 2161619 */     GIR_EraseRootFromParent_Done,
     /* 2161620 */   // Label 28493: @2161620
     /* 2161620 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2161711), // Rule ID 18258 //
     /* 2161625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2161636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2161639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2161642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2161645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2161648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161671 */     // MIs[0] round
     /* 2161671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161674 */     // MIs[0] policy
     /* 2161674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161684 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2161687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161710 */     // GIR_Coverage, 18258,
     /* 2161710 */     GIR_EraseRootFromParent_Done,
     /* 2161711 */   // Label 28494: @2161711
     /* 2161711 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2161802), // Rule ID 18259 //
     /* 2161716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2161727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2161730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2161733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2161736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2161739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161762 */     // MIs[0] round
     /* 2161762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161765 */     // MIs[0] policy
     /* 2161765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161775 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2161778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161801 */     // GIR_Coverage, 18259,
     /* 2161801 */     GIR_EraseRootFromParent_Done,
     /* 2161802 */   // Label 28495: @2161802
     /* 2161802 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2161893), // Rule ID 18262 //
     /* 2161807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2161824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161853 */     // MIs[0] round
     /* 2161853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161856 */     // MIs[0] policy
     /* 2161856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161866 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2161869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161892 */     // GIR_Coverage, 18262,
     /* 2161892 */     GIR_EraseRootFromParent_Done,
     /* 2161893 */   // Label 28496: @2161893
     /* 2161893 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2161984), // Rule ID 18263 //
     /* 2161898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2161909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2161912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2161915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2161918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161944 */     // MIs[0] round
     /* 2161944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161947 */     // MIs[0] policy
     /* 2161947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2161960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161983 */     // GIR_Coverage, 18263,
     /* 2161983 */     GIR_EraseRootFromParent_Done,
     /* 2161984 */   // Label 28497: @2161984
     /* 2161984 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2162075), // Rule ID 18266 //
     /* 2161989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2162000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2162003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2162006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2162009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162035 */     // MIs[0] round
     /* 2162035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162038 */     // MIs[0] policy
     /* 2162038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2162051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162074 */     // GIR_Coverage, 18266,
     /* 2162074 */     GIR_EraseRootFromParent_Done,
     /* 2162075 */   // Label 28498: @2162075
     /* 2162075 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2162166), // Rule ID 18267 //
     /* 2162080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2162091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2162094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2162097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2162100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162126 */     // MIs[0] round
     /* 2162126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162129 */     // MIs[0] policy
     /* 2162129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162139 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2162142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162165 */     // GIR_Coverage, 18267,
     /* 2162165 */     GIR_EraseRootFromParent_Done,
     /* 2162166 */   // Label 28499: @2162166
     /* 2162166 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2162257), // Rule ID 18270 //
     /* 2162171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2162182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2162185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2162188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2162191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162217 */     // MIs[0] round
     /* 2162217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162220 */     // MIs[0] policy
     /* 2162220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162230 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2162233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162256 */     // GIR_Coverage, 18270,
     /* 2162256 */     GIR_EraseRootFromParent_Done,
     /* 2162257 */   // Label 28500: @2162257
     /* 2162257 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2162348), // Rule ID 18271 //
     /* 2162262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2162273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2162276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2162279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2162282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162308 */     // MIs[0] round
     /* 2162308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162311 */     // MIs[0] policy
     /* 2162311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162321 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2162324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162347 */     // GIR_Coverage, 18271,
     /* 2162347 */     GIR_EraseRootFromParent_Done,
     /* 2162348 */   // Label 28501: @2162348
     /* 2162348 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2162439), // Rule ID 18274 //
     /* 2162353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2162364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2162367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2162370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2162373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162399 */     // MIs[0] round
     /* 2162399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162402 */     // MIs[0] policy
     /* 2162402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162412 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162438 */     // GIR_Coverage, 18274,
     /* 2162438 */     GIR_EraseRootFromParent_Done,
     /* 2162439 */   // Label 28502: @2162439
     /* 2162439 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2162530), // Rule ID 18275 //
     /* 2162444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2162455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2162458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2162461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2162464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162490 */     // MIs[0] round
     /* 2162490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162493 */     // MIs[0] policy
     /* 2162493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162503 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2162506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162529 */     // GIR_Coverage, 18275,
     /* 2162529 */     GIR_EraseRootFromParent_Done,
     /* 2162530 */   // Label 28503: @2162530
     /* 2162530 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2162621), // Rule ID 18278 //
     /* 2162535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2162546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2162549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2162552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2162555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162581 */     // MIs[0] round
     /* 2162581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162584 */     // MIs[0] policy
     /* 2162584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162594 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2162597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162620 */     // GIR_Coverage, 18278,
     /* 2162620 */     GIR_EraseRootFromParent_Done,
     /* 2162621 */   // Label 28504: @2162621
     /* 2162621 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2162712), // Rule ID 18279 //
     /* 2162626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2162637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2162640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2162643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2162646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162672 */     // MIs[0] round
     /* 2162672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162675 */     // MIs[0] policy
     /* 2162675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162685 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2162688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162711 */     // GIR_Coverage, 18279,
     /* 2162711 */     GIR_EraseRootFromParent_Done,
     /* 2162712 */   // Label 28505: @2162712
     /* 2162712 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2162803), // Rule ID 18282 //
     /* 2162717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2162728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2162731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2162734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2162737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162763 */     // MIs[0] round
     /* 2162763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162766 */     // MIs[0] policy
     /* 2162766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162776 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2162779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162802 */     // GIR_Coverage, 18282,
     /* 2162802 */     GIR_EraseRootFromParent_Done,
     /* 2162803 */   // Label 28506: @2162803
     /* 2162803 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2162894), // Rule ID 18283 //
     /* 2162808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2162819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2162822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2162825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2162828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162854 */     // MIs[0] round
     /* 2162854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162857 */     // MIs[0] policy
     /* 2162857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162867 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2162870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162893 */     // GIR_Coverage, 18283,
     /* 2162893 */     GIR_EraseRootFromParent_Done,
     /* 2162894 */   // Label 28507: @2162894
     /* 2162894 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2162985), // Rule ID 18286 //
     /* 2162899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2162910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2162913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2162916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2162919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2162937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162945 */     // MIs[0] round
     /* 2162945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162948 */     // MIs[0] policy
     /* 2162948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162958 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2162961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162984 */     // GIR_Coverage, 18286,
     /* 2162984 */     GIR_EraseRootFromParent_Done,
     /* 2162985 */   // Label 28508: @2162985
     /* 2162985 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2163076), // Rule ID 18287 //
     /* 2162990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2162998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2163001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2163004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2163010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163036 */     // MIs[0] round
     /* 2163036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163039 */     // MIs[0] policy
     /* 2163039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163049 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2163052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163075 */     // GIR_Coverage, 18287,
     /* 2163075 */     GIR_EraseRootFromParent_Done,
     /* 2163076 */   // Label 28509: @2163076
     /* 2163076 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2163167), // Rule ID 18290 //
     /* 2163081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2163092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2163095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2163101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163127 */     // MIs[0] round
     /* 2163127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163130 */     // MIs[0] policy
     /* 2163130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163140 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2163143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163166 */     // GIR_Coverage, 18290,
     /* 2163166 */     GIR_EraseRootFromParent_Done,
     /* 2163167 */   // Label 28510: @2163167
     /* 2163167 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2163258), // Rule ID 18291 //
     /* 2163172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2163183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2163186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2163192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163218 */     // MIs[0] round
     /* 2163218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163221 */     // MIs[0] policy
     /* 2163221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163231 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2163234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163257 */     // GIR_Coverage, 18291,
     /* 2163257 */     GIR_EraseRootFromParent_Done,
     /* 2163258 */   // Label 28511: @2163258
     /* 2163258 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2163349), // Rule ID 18294 //
     /* 2163263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2163274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2163277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2163283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163309 */     // MIs[0] round
     /* 2163309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163312 */     // MIs[0] policy
     /* 2163312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2163325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163348 */     // GIR_Coverage, 18294,
     /* 2163348 */     GIR_EraseRootFromParent_Done,
     /* 2163349 */   // Label 28512: @2163349
     /* 2163349 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2163440), // Rule ID 18295 //
     /* 2163354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2163365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2163368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2163374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163400 */     // MIs[0] round
     /* 2163400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163403 */     // MIs[0] policy
     /* 2163403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163413 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2163416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163439 */     // GIR_Coverage, 18295,
     /* 2163439 */     GIR_EraseRootFromParent_Done,
     /* 2163440 */   // Label 28513: @2163440
     /* 2163440 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2163531), // Rule ID 18298 //
     /* 2163445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2163456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2163459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2163465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163491 */     // MIs[0] round
     /* 2163491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163494 */     // MIs[0] policy
     /* 2163494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163504 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2163507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163530 */     // GIR_Coverage, 18298,
     /* 2163530 */     GIR_EraseRootFromParent_Done,
     /* 2163531 */   // Label 28514: @2163531
     /* 2163531 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2163622), // Rule ID 18299 //
     /* 2163536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2163547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2163550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2163553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2163556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2163574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163582 */     // MIs[0] round
     /* 2163582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163585 */     // MIs[0] policy
     /* 2163585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163595 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2163598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163621 */     // GIR_Coverage, 18299,
     /* 2163621 */     GIR_EraseRootFromParent_Done,
     /* 2163622 */   // Label 28515: @2163622
     /* 2163622 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2163713), // Rule ID 18302 //
     /* 2163627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2163638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2163641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2163647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163673 */     // MIs[0] round
     /* 2163673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163676 */     // MIs[0] policy
     /* 2163676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163686 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2163689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163712 */     // GIR_Coverage, 18302,
     /* 2163712 */     GIR_EraseRootFromParent_Done,
     /* 2163713 */   // Label 28516: @2163713
     /* 2163713 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2163804), // Rule ID 18303 //
     /* 2163718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2163729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2163732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2163735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2163738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2163756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163764 */     // MIs[0] round
     /* 2163764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163767 */     // MIs[0] policy
     /* 2163767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163777 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2163780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163803 */     // GIR_Coverage, 18303,
     /* 2163803 */     GIR_EraseRootFromParent_Done,
     /* 2163804 */   // Label 28517: @2163804
     /* 2163804 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2163895), // Rule ID 18306 //
     /* 2163809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2163826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2163847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163855 */     // MIs[0] round
     /* 2163855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163858 */     // MIs[0] policy
     /* 2163858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2163871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163894 */     // GIR_Coverage, 18306,
     /* 2163894 */     GIR_EraseRootFromParent_Done,
     /* 2163895 */   // Label 28518: @2163895
     /* 2163895 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2163986), // Rule ID 18307 //
     /* 2163900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2163911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2163914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2163917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2163920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2163923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2163930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2163938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2163942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163946 */     // MIs[0] round
     /* 2163946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163949 */     // MIs[0] policy
     /* 2163949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163959 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2163962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163985 */     // GIR_Coverage, 18307,
     /* 2163985 */     GIR_EraseRootFromParent_Done,
     /* 2163986 */   // Label 28519: @2163986
     /* 2163986 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2164077), // Rule ID 18310 //
     /* 2163991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2163999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2164002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2164005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2164011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164037 */     // MIs[0] round
     /* 2164037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164040 */     // MIs[0] policy
     /* 2164040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164050 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2164053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164076 */     // GIR_Coverage, 18310,
     /* 2164076 */     GIR_EraseRootFromParent_Done,
     /* 2164077 */   // Label 28520: @2164077
     /* 2164077 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2164168), // Rule ID 18311 //
     /* 2164082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2164093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2164096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2164102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164128 */     // MIs[0] round
     /* 2164128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164131 */     // MIs[0] policy
     /* 2164131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164141 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2164144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164167 */     // GIR_Coverage, 18311,
     /* 2164167 */     GIR_EraseRootFromParent_Done,
     /* 2164168 */   // Label 28521: @2164168
     /* 2164168 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2164259), // Rule ID 18314 //
     /* 2164173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2164184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2164187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2164193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164219 */     // MIs[0] round
     /* 2164219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164222 */     // MIs[0] policy
     /* 2164222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164232 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2164235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164258 */     // GIR_Coverage, 18314,
     /* 2164258 */     GIR_EraseRootFromParent_Done,
     /* 2164259 */   // Label 28522: @2164259
     /* 2164259 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2164350), // Rule ID 18315 //
     /* 2164264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2164275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2164278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2164284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164310 */     // MIs[0] round
     /* 2164310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164313 */     // MIs[0] policy
     /* 2164313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164323 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2164326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164349 */     // GIR_Coverage, 18315,
     /* 2164349 */     GIR_EraseRootFromParent_Done,
     /* 2164350 */   // Label 28523: @2164350
     /* 2164350 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2164441), // Rule ID 18318 //
     /* 2164355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2164366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2164369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2164375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2164378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164401 */     // MIs[0] round
     /* 2164401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164404 */     // MIs[0] policy
     /* 2164404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164414 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2164417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164440 */     // GIR_Coverage, 18318,
     /* 2164440 */     GIR_EraseRootFromParent_Done,
     /* 2164441 */   // Label 28524: @2164441
     /* 2164441 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2164532), // Rule ID 18319 //
     /* 2164446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2164457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2164460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2164466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2164469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164492 */     // MIs[0] round
     /* 2164492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164495 */     // MIs[0] policy
     /* 2164495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164505 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2164508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164531 */     // GIR_Coverage, 18319,
     /* 2164531 */     GIR_EraseRootFromParent_Done,
     /* 2164532 */   // Label 28525: @2164532
     /* 2164532 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2164623), // Rule ID 18322 //
     /* 2164537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2164548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2164551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2164557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164583 */     // MIs[0] round
     /* 2164583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164586 */     // MIs[0] policy
     /* 2164586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2164599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164622 */     // GIR_Coverage, 18322,
     /* 2164622 */     GIR_EraseRootFromParent_Done,
     /* 2164623 */   // Label 28526: @2164623
     /* 2164623 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2164714), // Rule ID 18323 //
     /* 2164628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2164639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2164642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2164648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2164658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2164670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164674 */     // MIs[0] round
     /* 2164674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164677 */     // MIs[0] policy
     /* 2164677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164687 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2164690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164713 */     // GIR_Coverage, 18323,
     /* 2164713 */     GIR_EraseRootFromParent_Done,
     /* 2164714 */   // Label 28527: @2164714
     /* 2164714 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2164805), // Rule ID 18326 //
     /* 2164719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2164730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2164733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2164739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164765 */     // MIs[0] round
     /* 2164765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164768 */     // MIs[0] policy
     /* 2164768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164778 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2164781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164804 */     // GIR_Coverage, 18326,
     /* 2164804 */     GIR_EraseRootFromParent_Done,
     /* 2164805 */   // Label 28528: @2164805
     /* 2164805 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2164896), // Rule ID 18327 //
     /* 2164810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2164821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2164824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2164830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164856 */     // MIs[0] round
     /* 2164856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164859 */     // MIs[0] policy
     /* 2164859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164869 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2164872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164895 */     // GIR_Coverage, 18327,
     /* 2164895 */     GIR_EraseRootFromParent_Done,
     /* 2164896 */   // Label 28529: @2164896
     /* 2164896 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2164987), // Rule ID 18330 //
     /* 2164901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2164909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2164912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2164915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2164921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2164924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164947 */     // MIs[0] round
     /* 2164947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164950 */     // MIs[0] policy
     /* 2164950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164960 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2164963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164986 */     // GIR_Coverage, 18330,
     /* 2164986 */     GIR_EraseRootFromParent_Done,
     /* 2164987 */   // Label 28530: @2164987
     /* 2164987 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2165078), // Rule ID 18331 //
     /* 2164992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2165003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2165006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2165012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165038 */     // MIs[0] round
     /* 2165038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165041 */     // MIs[0] policy
     /* 2165041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165051 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2165054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165077 */     // GIR_Coverage, 18331,
     /* 2165077 */     GIR_EraseRootFromParent_Done,
     /* 2165078 */   // Label 28531: @2165078
     /* 2165078 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2165169), // Rule ID 18334 //
     /* 2165083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2165094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2165097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2165103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165129 */     // MIs[0] round
     /* 2165129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165132 */     // MIs[0] policy
     /* 2165132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165142 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2165145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165168 */     // GIR_Coverage, 18334,
     /* 2165168 */     GIR_EraseRootFromParent_Done,
     /* 2165169 */   // Label 28532: @2165169
     /* 2165169 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2165260), // Rule ID 18335 //
     /* 2165174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2165185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2165188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2165194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165220 */     // MIs[0] round
     /* 2165220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165223 */     // MIs[0] policy
     /* 2165223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165233 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2165236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165259 */     // GIR_Coverage, 18335,
     /* 2165259 */     GIR_EraseRootFromParent_Done,
     /* 2165260 */   // Label 28533: @2165260
     /* 2165260 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2165351), // Rule ID 18338 //
     /* 2165265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2165276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2165279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2165285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165311 */     // MIs[0] round
     /* 2165311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165314 */     // MIs[0] policy
     /* 2165314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165324 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2165327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165350 */     // GIR_Coverage, 18338,
     /* 2165350 */     GIR_EraseRootFromParent_Done,
     /* 2165351 */   // Label 28534: @2165351
     /* 2165351 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2165442), // Rule ID 18339 //
     /* 2165356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2165367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2165370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2165376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165402 */     // MIs[0] round
     /* 2165402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165405 */     // MIs[0] policy
     /* 2165405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165415 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2165418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165441 */     // GIR_Coverage, 18339,
     /* 2165441 */     GIR_EraseRootFromParent_Done,
     /* 2165442 */   // Label 28535: @2165442
     /* 2165442 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2165533), // Rule ID 18342 //
     /* 2165447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2165458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2165461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2165467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165493 */     // MIs[0] round
     /* 2165493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165496 */     // MIs[0] policy
     /* 2165496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165506 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2165509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165532 */     // GIR_Coverage, 18342,
     /* 2165532 */     GIR_EraseRootFromParent_Done,
     /* 2165533 */   // Label 28536: @2165533
     /* 2165533 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2165624), // Rule ID 18343 //
     /* 2165538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2165546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2165549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2165552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2165558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165584 */     // MIs[0] round
     /* 2165584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165587 */     // MIs[0] policy
     /* 2165587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165597 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2165600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165623 */     // GIR_Coverage, 18343,
     /* 2165623 */     GIR_EraseRootFromParent_Done,
     /* 2165624 */   // Label 28537: @2165624
     /* 2165624 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2165715), // Rule ID 18346 //
     /* 2165629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2165640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2165643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2165646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2165649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165675 */     // MIs[0] round
     /* 2165675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165678 */     // MIs[0] policy
     /* 2165678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165688 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2165691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165714 */     // GIR_Coverage, 18346,
     /* 2165714 */     GIR_EraseRootFromParent_Done,
     /* 2165715 */   // Label 28538: @2165715
     /* 2165715 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2165806), // Rule ID 18347 //
     /* 2165720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2165731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2165734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2165737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2165740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165766 */     // MIs[0] round
     /* 2165766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165769 */     // MIs[0] policy
     /* 2165769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165779 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2165782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165805 */     // GIR_Coverage, 18347,
     /* 2165805 */     GIR_EraseRootFromParent_Done,
     /* 2165806 */   // Label 28539: @2165806
     /* 2165806 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2165897), // Rule ID 18350 //
     /* 2165811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2165828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165857 */     // MIs[0] round
     /* 2165857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165860 */     // MIs[0] policy
     /* 2165860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165870 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2165873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165896 */     // GIR_Coverage, 18350,
     /* 2165896 */     GIR_EraseRootFromParent_Done,
     /* 2165897 */   // Label 28540: @2165897
     /* 2165897 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2165988), // Rule ID 18351 //
     /* 2165902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2165913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2165916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2165919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2165922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165948 */     // MIs[0] round
     /* 2165948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165951 */     // MIs[0] policy
     /* 2165951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165961 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2165964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165987 */     // GIR_Coverage, 18351,
     /* 2165987 */     GIR_EraseRootFromParent_Done,
     /* 2165988 */   // Label 28541: @2165988
     /* 2165988 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2166079), // Rule ID 18354 //
     /* 2165993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2166004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2166007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2166010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2166013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166039 */     // MIs[0] round
     /* 2166039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166042 */     // MIs[0] policy
     /* 2166042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166052 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2166055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166078 */     // GIR_Coverage, 18354,
     /* 2166078 */     GIR_EraseRootFromParent_Done,
     /* 2166079 */   // Label 28542: @2166079
     /* 2166079 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2166170), // Rule ID 18355 //
     /* 2166084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2166095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2166098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2166101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2166104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166130 */     // MIs[0] round
     /* 2166130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166133 */     // MIs[0] policy
     /* 2166133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166143 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2166146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166169 */     // GIR_Coverage, 18355,
     /* 2166169 */     GIR_EraseRootFromParent_Done,
     /* 2166170 */   // Label 28543: @2166170
     /* 2166170 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2166261), // Rule ID 18358 //
     /* 2166175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2166186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2166189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2166192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2166195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166221 */     // MIs[0] round
     /* 2166221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166224 */     // MIs[0] policy
     /* 2166224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166234 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2166237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166260 */     // GIR_Coverage, 18358,
     /* 2166260 */     GIR_EraseRootFromParent_Done,
     /* 2166261 */   // Label 28544: @2166261
     /* 2166261 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2166352), // Rule ID 18359 //
     /* 2166266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2166277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2166280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2166283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2166286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166312 */     // MIs[0] round
     /* 2166312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166315 */     // MIs[0] policy
     /* 2166315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166325 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2166328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166351 */     // GIR_Coverage, 18359,
     /* 2166351 */     GIR_EraseRootFromParent_Done,
     /* 2166352 */   // Label 28545: @2166352
     /* 2166352 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2166443), // Rule ID 18362 //
     /* 2166357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2166368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2166371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2166374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2166377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166403 */     // MIs[0] round
     /* 2166403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166406 */     // MIs[0] policy
     /* 2166406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166416 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2166419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166442 */     // GIR_Coverage, 18362,
     /* 2166442 */     GIR_EraseRootFromParent_Done,
     /* 2166443 */   // Label 28546: @2166443
     /* 2166443 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2166534), // Rule ID 18363 //
     /* 2166448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2166459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2166462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2166465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2166468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166494 */     // MIs[0] round
     /* 2166494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166497 */     // MIs[0] policy
     /* 2166497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166507 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2166510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166533 */     // GIR_Coverage, 18363,
     /* 2166533 */     GIR_EraseRootFromParent_Done,
     /* 2166534 */   // Label 28547: @2166534
     /* 2166534 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2166625), // Rule ID 18366 //
     /* 2166539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2166550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2166553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2166556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2166559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166585 */     // MIs[0] round
     /* 2166585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166588 */     // MIs[0] policy
     /* 2166588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2166601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166624 */     // GIR_Coverage, 18366,
     /* 2166624 */     GIR_EraseRootFromParent_Done,
     /* 2166625 */   // Label 28548: @2166625
     /* 2166625 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2166716), // Rule ID 18367 //
     /* 2166630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2166641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2166644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2166647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2166650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166676 */     // MIs[0] round
     /* 2166676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166679 */     // MIs[0] policy
     /* 2166679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166689 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2166692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166715 */     // GIR_Coverage, 18367,
     /* 2166715 */     GIR_EraseRootFromParent_Done,
     /* 2166716 */   // Label 28549: @2166716
     /* 2166716 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2166807), // Rule ID 18370 //
     /* 2166721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2166732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2166735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2166738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2166741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166767 */     // MIs[0] round
     /* 2166767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166770 */     // MIs[0] policy
     /* 2166770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166780 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2166783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166806 */     // GIR_Coverage, 18370,
     /* 2166806 */     GIR_EraseRootFromParent_Done,
     /* 2166807 */   // Label 28550: @2166807
     /* 2166807 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2166898), // Rule ID 18371 //
     /* 2166812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2166823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2166826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2166829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2166832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166858 */     // MIs[0] round
     /* 2166858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166861 */     // MIs[0] policy
     /* 2166861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166871 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2166874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166897 */     // GIR_Coverage, 18371,
     /* 2166897 */     GIR_EraseRootFromParent_Done,
     /* 2166898 */   // Label 28551: @2166898
     /* 2166898 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2166989), // Rule ID 18374 //
     /* 2166903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2166914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2166917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2166920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2166923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166949 */     // MIs[0] round
     /* 2166949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166952 */     // MIs[0] policy
     /* 2166952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166962 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2166965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166988 */     // GIR_Coverage, 18374,
     /* 2166988 */     GIR_EraseRootFromParent_Done,
     /* 2166989 */   // Label 28552: @2166989
     /* 2166989 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2167080), // Rule ID 18375 //
     /* 2166994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2167005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2167008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2167011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2167014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2167017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167040 */     // MIs[0] round
     /* 2167040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167043 */     // MIs[0] policy
     /* 2167043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167053 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2167056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167079 */     // GIR_Coverage, 18375,
     /* 2167079 */     GIR_EraseRootFromParent_Done,
     /* 2167080 */   // Label 28553: @2167080
     /* 2167080 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2167171), // Rule ID 18378 //
     /* 2167085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2167096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2167099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2167102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2167105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2167108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167131 */     // MIs[0] round
     /* 2167131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167134 */     // MIs[0] policy
     /* 2167134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167144 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2167147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167170 */     // GIR_Coverage, 18378,
     /* 2167170 */     GIR_EraseRootFromParent_Done,
     /* 2167171 */   // Label 28554: @2167171
     /* 2167171 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2167262), // Rule ID 18379 //
     /* 2167176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2167187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2167190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2167193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2167196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2167199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167222 */     // MIs[0] round
     /* 2167222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167225 */     // MIs[0] policy
     /* 2167225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167235 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2167238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167261 */     // GIR_Coverage, 18379,
     /* 2167261 */     GIR_EraseRootFromParent_Done,
     /* 2167262 */   // Label 28555: @2167262
     /* 2167262 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2167353), // Rule ID 18382 //
     /* 2167267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2167278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2167281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2167284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2167287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167313 */     // MIs[0] round
     /* 2167313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167316 */     // MIs[0] policy
     /* 2167316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167326 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2167329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167352 */     // GIR_Coverage, 18382,
     /* 2167352 */     GIR_EraseRootFromParent_Done,
     /* 2167353 */   // Label 28556: @2167353
     /* 2167353 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2167444), // Rule ID 18383 //
     /* 2167358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2167369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2167372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2167375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2167378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167404 */     // MIs[0] round
     /* 2167404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167407 */     // MIs[0] policy
     /* 2167407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167417 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2167420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167443 */     // GIR_Coverage, 18383,
     /* 2167443 */     GIR_EraseRootFromParent_Done,
     /* 2167444 */   // Label 28557: @2167444
     /* 2167444 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2167535), // Rule ID 18386 //
     /* 2167449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2167460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2167463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2167466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2167469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167495 */     // MIs[0] round
     /* 2167495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167498 */     // MIs[0] policy
     /* 2167498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167508 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2167511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167534 */     // GIR_Coverage, 18386,
     /* 2167534 */     GIR_EraseRootFromParent_Done,
     /* 2167535 */   // Label 28558: @2167535
     /* 2167535 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2167626), // Rule ID 18387 //
     /* 2167540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2167551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2167554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2167557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2167560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2167570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2167582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167586 */     // MIs[0] round
     /* 2167586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167589 */     // MIs[0] policy
     /* 2167589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167599 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2167602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167625 */     // GIR_Coverage, 18387,
     /* 2167625 */     GIR_EraseRootFromParent_Done,
     /* 2167626 */   // Label 28559: @2167626
     /* 2167626 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2167717), // Rule ID 18390 //
     /* 2167631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2167642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2167645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2167648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2167651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2167654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167677 */     // MIs[0] round
     /* 2167677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167680 */     // MIs[0] policy
     /* 2167680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2167693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167716 */     // GIR_Coverage, 18390,
     /* 2167716 */     GIR_EraseRootFromParent_Done,
     /* 2167717 */   // Label 28560: @2167717
     /* 2167717 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2167808), // Rule ID 18391 //
     /* 2167722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2167733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2167736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2167739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2167742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2167745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2167752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2167764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167768 */     // MIs[0] round
     /* 2167768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167771 */     // MIs[0] policy
     /* 2167771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167781 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2167784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167807 */     // GIR_Coverage, 18391,
     /* 2167807 */     GIR_EraseRootFromParent_Done,
     /* 2167808 */   // Label 28561: @2167808
     /* 2167808 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2167899), // Rule ID 18394 //
     /* 2167813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2167830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167859 */     // MIs[0] round
     /* 2167859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167862 */     // MIs[0] policy
     /* 2167862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2167875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167898 */     // GIR_Coverage, 18394,
     /* 2167898 */     GIR_EraseRootFromParent_Done,
     /* 2167899 */   // Label 28562: @2167899
     /* 2167899 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2167990), // Rule ID 18395 //
     /* 2167904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2167912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2167915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2167918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2167921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2167924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167950 */     // MIs[0] round
     /* 2167950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167953 */     // MIs[0] policy
     /* 2167953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167963 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2167966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167989 */     // GIR_Coverage, 18395,
     /* 2167989 */     GIR_EraseRootFromParent_Done,
     /* 2167990 */   // Label 28563: @2167990
     /* 2167990 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2168081), // Rule ID 18398 //
     /* 2167995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2168006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2168009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2168012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2168015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168041 */     // MIs[0] round
     /* 2168041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168044 */     // MIs[0] policy
     /* 2168044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168054 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2168057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168080 */     // GIR_Coverage, 18398,
     /* 2168080 */     GIR_EraseRootFromParent_Done,
     /* 2168081 */   // Label 28564: @2168081
     /* 2168081 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2168172), // Rule ID 18399 //
     /* 2168086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2168097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2168100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2168103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2168106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168132 */     // MIs[0] round
     /* 2168132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168135 */     // MIs[0] policy
     /* 2168135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168145 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2168148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168171 */     // GIR_Coverage, 18399,
     /* 2168171 */     GIR_EraseRootFromParent_Done,
     /* 2168172 */   // Label 28565: @2168172
     /* 2168172 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2168263), // Rule ID 18402 //
     /* 2168177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2168180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2168188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2168191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2168194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2168197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168223 */     // MIs[0] round
     /* 2168223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168226 */     // MIs[0] policy
     /* 2168226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168236 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2168239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168262 */     // GIR_Coverage, 18402,
     /* 2168262 */     GIR_EraseRootFromParent_Done,
     /* 2168263 */   // Label 28566: @2168263
     /* 2168263 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2168354), // Rule ID 18403 //
     /* 2168268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2168279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2168282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2168285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2168288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168314 */     // MIs[0] round
     /* 2168314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168317 */     // MIs[0] policy
     /* 2168317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168327 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2168330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168353 */     // GIR_Coverage, 18403,
     /* 2168353 */     GIR_EraseRootFromParent_Done,
     /* 2168354 */   // Label 28567: @2168354
     /* 2168354 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2168445), // Rule ID 18406 //
     /* 2168359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2168370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2168373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2168379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168405 */     // MIs[0] round
     /* 2168405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168408 */     // MIs[0] policy
     /* 2168408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168418 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2168421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168444 */     // GIR_Coverage, 18406,
     /* 2168444 */     GIR_EraseRootFromParent_Done,
     /* 2168445 */   // Label 28568: @2168445
     /* 2168445 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2168536), // Rule ID 18407 //
     /* 2168450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2168461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2168464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2168470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168496 */     // MIs[0] round
     /* 2168496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168499 */     // MIs[0] policy
     /* 2168499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168509 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2168512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168535 */     // GIR_Coverage, 18407,
     /* 2168535 */     GIR_EraseRootFromParent_Done,
     /* 2168536 */   // Label 28569: @2168536
     /* 2168536 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2168627), // Rule ID 18410 //
     /* 2168541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2168552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2168555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2168561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168587 */     // MIs[0] round
     /* 2168587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168590 */     // MIs[0] policy
     /* 2168590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2168603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168626 */     // GIR_Coverage, 18410,
     /* 2168626 */     GIR_EraseRootFromParent_Done,
     /* 2168627 */   // Label 28570: @2168627
     /* 2168627 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2168718), // Rule ID 18411 //
     /* 2168632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2168643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2168646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2168652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168678 */     // MIs[0] round
     /* 2168678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168681 */     // MIs[0] policy
     /* 2168681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168691 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2168694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168717 */     // GIR_Coverage, 18411,
     /* 2168717 */     GIR_EraseRootFromParent_Done,
     /* 2168718 */   // Label 28571: @2168718
     /* 2168718 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2168809), // Rule ID 18414 //
     /* 2168723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2168734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2168737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2168743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2168761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168769 */     // MIs[0] round
     /* 2168769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168772 */     // MIs[0] policy
     /* 2168772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168782 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2168785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168808 */     // GIR_Coverage, 18414,
     /* 2168808 */     GIR_EraseRootFromParent_Done,
     /* 2168809 */   // Label 28572: @2168809
     /* 2168809 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2168900), // Rule ID 18415 //
     /* 2168814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2168825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2168828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2168831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2168834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2168852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168860 */     // MIs[0] round
     /* 2168860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168863 */     // MIs[0] policy
     /* 2168863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168873 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2168876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168899 */     // GIR_Coverage, 18415,
     /* 2168899 */     GIR_EraseRootFromParent_Done,
     /* 2168900 */   // Label 28573: @2168900
     /* 2168900 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2168991), // Rule ID 18418 //
     /* 2168905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2168913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2168916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2168919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2168922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2168925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2168943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168951 */     // MIs[0] round
     /* 2168951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168954 */     // MIs[0] policy
     /* 2168954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168964 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2168967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168990 */     // GIR_Coverage, 18418,
     /* 2168990 */     GIR_EraseRootFromParent_Done,
     /* 2168991 */   // Label 28574: @2168991
     /* 2168991 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2169082), // Rule ID 18419 //
     /* 2168996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2169007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2169010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2169016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169042 */     // MIs[0] round
     /* 2169042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169045 */     // MIs[0] policy
     /* 2169045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169055 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2169058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169081 */     // GIR_Coverage, 18419,
     /* 2169081 */     GIR_EraseRootFromParent_Done,
     /* 2169082 */   // Label 28575: @2169082
     /* 2169082 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2169173), // Rule ID 18422 //
     /* 2169087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2169098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2169101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2169107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169133 */     // MIs[0] round
     /* 2169133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169136 */     // MIs[0] policy
     /* 2169136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169146 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2169149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169172 */     // GIR_Coverage, 18422,
     /* 2169172 */     GIR_EraseRootFromParent_Done,
     /* 2169173 */   // Label 28576: @2169173
     /* 2169173 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2169264), // Rule ID 18423 //
     /* 2169178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2169189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2169192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2169198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169224 */     // MIs[0] round
     /* 2169224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169227 */     // MIs[0] policy
     /* 2169227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169237 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2169240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169263 */     // GIR_Coverage, 18423,
     /* 2169263 */     GIR_EraseRootFromParent_Done,
     /* 2169264 */   // Label 28577: @2169264
     /* 2169264 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2169355), // Rule ID 18426 //
     /* 2169269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2169280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2169283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2169286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2169289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2169307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169315 */     // MIs[0] round
     /* 2169315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169318 */     // MIs[0] policy
     /* 2169318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169328 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2169331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169354 */     // GIR_Coverage, 18426,
     /* 2169354 */     GIR_EraseRootFromParent_Done,
     /* 2169355 */   // Label 28578: @2169355
     /* 2169355 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2169446), // Rule ID 18427 //
     /* 2169360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2169371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2169374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2169377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2169380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2169398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169406 */     // MIs[0] round
     /* 2169406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169409 */     // MIs[0] policy
     /* 2169409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169419 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2169422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169445 */     // GIR_Coverage, 18427,
     /* 2169445 */     GIR_EraseRootFromParent_Done,
     /* 2169446 */   // Label 28579: @2169446
     /* 2169446 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2169537), // Rule ID 18430 //
     /* 2169451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2169462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2169465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2169471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169497 */     // MIs[0] round
     /* 2169497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169500 */     // MIs[0] policy
     /* 2169500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169510 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2169513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169536 */     // GIR_Coverage, 18430,
     /* 2169536 */     GIR_EraseRootFromParent_Done,
     /* 2169537 */   // Label 28580: @2169537
     /* 2169537 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2169628), // Rule ID 18431 //
     /* 2169542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2169553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2169556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2169562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169588 */     // MIs[0] round
     /* 2169588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169591 */     // MIs[0] policy
     /* 2169591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169601 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2169604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169627 */     // GIR_Coverage, 18431,
     /* 2169627 */     GIR_EraseRootFromParent_Done,
     /* 2169628 */   // Label 28581: @2169628
     /* 2169628 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2169719), // Rule ID 18434 //
     /* 2169633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2169644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2169647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2169653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169679 */     // MIs[0] round
     /* 2169679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169682 */     // MIs[0] policy
     /* 2169682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169692 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2169695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169718 */     // GIR_Coverage, 18434,
     /* 2169718 */     GIR_EraseRootFromParent_Done,
     /* 2169719 */   // Label 28582: @2169719
     /* 2169719 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2169810), // Rule ID 18435 //
     /* 2169724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2169735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2169738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2169744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169770 */     // MIs[0] round
     /* 2169770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169773 */     // MIs[0] policy
     /* 2169773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169783 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2169786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169809 */     // GIR_Coverage, 18435,
     /* 2169809 */     GIR_EraseRootFromParent_Done,
     /* 2169810 */   // Label 28583: @2169810
     /* 2169810 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2169901), // Rule ID 18438 //
     /* 2169815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169861 */     // MIs[0] round
     /* 2169861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169864 */     // MIs[0] policy
     /* 2169864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169874 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2169877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169900 */     // GIR_Coverage, 18438,
     /* 2169900 */     GIR_EraseRootFromParent_Done,
     /* 2169901 */   // Label 28584: @2169901
     /* 2169901 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2169992), // Rule ID 18439 //
     /* 2169906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2169914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2169917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2169920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2169926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2169929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169952 */     // MIs[0] round
     /* 2169952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169955 */     // MIs[0] policy
     /* 2169955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169965 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2169968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169991 */     // GIR_Coverage, 18439,
     /* 2169991 */     GIR_EraseRootFromParent_Done,
     /* 2169992 */   // Label 28585: @2169992
     /* 2169992 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2170083), // Rule ID 18442 //
     /* 2169997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2170008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2170011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2170017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170043 */     // MIs[0] round
     /* 2170043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170046 */     // MIs[0] policy
     /* 2170046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2170059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170082 */     // GIR_Coverage, 18442,
     /* 2170082 */     GIR_EraseRootFromParent_Done,
     /* 2170083 */   // Label 28586: @2170083
     /* 2170083 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2170174), // Rule ID 18443 //
     /* 2170088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2170099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2170102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2170108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170134 */     // MIs[0] round
     /* 2170134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170137 */     // MIs[0] policy
     /* 2170137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2170150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170173 */     // GIR_Coverage, 18443,
     /* 2170173 */     GIR_EraseRootFromParent_Done,
     /* 2170174 */   // Label 28587: @2170174
     /* 2170174 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2170265), // Rule ID 18446 //
     /* 2170179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2170190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2170193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2170199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170225 */     // MIs[0] round
     /* 2170225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170228 */     // MIs[0] policy
     /* 2170228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170238 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2170241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170264 */     // GIR_Coverage, 18446,
     /* 2170264 */     GIR_EraseRootFromParent_Done,
     /* 2170265 */   // Label 28588: @2170265
     /* 2170265 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2170356), // Rule ID 18447 //
     /* 2170270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2170281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2170284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2170290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170316 */     // MIs[0] round
     /* 2170316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170319 */     // MIs[0] policy
     /* 2170319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170329 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2170332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170355 */     // GIR_Coverage, 18447,
     /* 2170355 */     GIR_EraseRootFromParent_Done,
     /* 2170356 */   // Label 28589: @2170356
     /* 2170356 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2170447), // Rule ID 18450 //
     /* 2170361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2170372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2170375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2170381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170407 */     // MIs[0] round
     /* 2170407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170410 */     // MIs[0] policy
     /* 2170410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170420 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2170423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170446 */     // GIR_Coverage, 18450,
     /* 2170446 */     GIR_EraseRootFromParent_Done,
     /* 2170447 */   // Label 28590: @2170447
     /* 2170447 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2170538), // Rule ID 18451 //
     /* 2170452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2170463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2170466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2170472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170498 */     // MIs[0] round
     /* 2170498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170501 */     // MIs[0] policy
     /* 2170501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170511 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2170514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170537 */     // GIR_Coverage, 18451,
     /* 2170537 */     GIR_EraseRootFromParent_Done,
     /* 2170538 */   // Label 28591: @2170538
     /* 2170538 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2170629), // Rule ID 18454 //
     /* 2170543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2170554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2170557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2170563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170589 */     // MIs[0] round
     /* 2170589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170592 */     // MIs[0] policy
     /* 2170592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170602 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2170605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170628 */     // GIR_Coverage, 18454,
     /* 2170628 */     GIR_EraseRootFromParent_Done,
     /* 2170629 */   // Label 28592: @2170629
     /* 2170629 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2170720), // Rule ID 18455 //
     /* 2170634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2170645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2170648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2170654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170680 */     // MIs[0] round
     /* 2170680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170683 */     // MIs[0] policy
     /* 2170683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2170696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170719 */     // GIR_Coverage, 18455,
     /* 2170719 */     GIR_EraseRootFromParent_Done,
     /* 2170720 */   // Label 28593: @2170720
     /* 2170720 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2170811), // Rule ID 18458 //
     /* 2170725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2170736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2170739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2170745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170771 */     // MIs[0] round
     /* 2170771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170774 */     // MIs[0] policy
     /* 2170774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2170787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170810 */     // GIR_Coverage, 18458,
     /* 2170810 */     GIR_EraseRootFromParent_Done,
     /* 2170811 */   // Label 28594: @2170811
     /* 2170811 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2170902), // Rule ID 18459 //
     /* 2170816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2170827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2170830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2170836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170862 */     // MIs[0] round
     /* 2170862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170865 */     // MIs[0] policy
     /* 2170865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170875 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2170878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170901 */     // GIR_Coverage, 18459,
     /* 2170901 */     GIR_EraseRootFromParent_Done,
     /* 2170902 */   // Label 28595: @2170902
     /* 2170902 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2170993), // Rule ID 18462 //
     /* 2170907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2170915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2170918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2170921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2170927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170953 */     // MIs[0] round
     /* 2170953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170956 */     // MIs[0] policy
     /* 2170956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170966 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2170969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170992 */     // GIR_Coverage, 18462,
     /* 2170992 */     GIR_EraseRootFromParent_Done,
     /* 2170993 */   // Label 28596: @2170993
     /* 2170993 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2171084), // Rule ID 18463 //
     /* 2170998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2171006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2171009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2171012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2171018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171044 */     // MIs[0] round
     /* 2171044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171047 */     // MIs[0] policy
     /* 2171047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171057 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2171060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171083 */     // GIR_Coverage, 18463,
     /* 2171083 */     GIR_EraseRootFromParent_Done,
     /* 2171084 */   // Label 28597: @2171084
     /* 2171084 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2171175), // Rule ID 18466 //
     /* 2171089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2171100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2171103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2171106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2171109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171135 */     // MIs[0] round
     /* 2171135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171138 */     // MIs[0] policy
     /* 2171138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171148 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2171151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171174 */     // GIR_Coverage, 18466,
     /* 2171174 */     GIR_EraseRootFromParent_Done,
     /* 2171175 */   // Label 28598: @2171175
     /* 2171175 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2171266), // Rule ID 18467 //
     /* 2171180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2171191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2171194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2171197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2171200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171226 */     // MIs[0] round
     /* 2171226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171229 */     // MIs[0] policy
     /* 2171229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171239 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2171242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171265 */     // GIR_Coverage, 18467,
     /* 2171265 */     GIR_EraseRootFromParent_Done,
     /* 2171266 */   // Label 28599: @2171266
     /* 2171266 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2171357), // Rule ID 18470 //
     /* 2171271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2171282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2171285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2171288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2171291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171317 */     // MIs[0] round
     /* 2171317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171320 */     // MIs[0] policy
     /* 2171320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171330 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2171333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171356 */     // GIR_Coverage, 18470,
     /* 2171356 */     GIR_EraseRootFromParent_Done,
     /* 2171357 */   // Label 28600: @2171357
     /* 2171357 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2171448), // Rule ID 18471 //
     /* 2171362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2171373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2171376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2171379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2171382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171408 */     // MIs[0] round
     /* 2171408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171411 */     // MIs[0] policy
     /* 2171411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171421 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2171424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171447 */     // GIR_Coverage, 18471,
     /* 2171447 */     GIR_EraseRootFromParent_Done,
     /* 2171448 */   // Label 28601: @2171448
     /* 2171448 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2171539), // Rule ID 18474 //
     /* 2171453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2171464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2171467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2171470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2171473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171499 */     // MIs[0] round
     /* 2171499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171502 */     // MIs[0] policy
     /* 2171502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171512 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2171515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171538 */     // GIR_Coverage, 18474,
     /* 2171538 */     GIR_EraseRootFromParent_Done,
     /* 2171539 */   // Label 28602: @2171539
     /* 2171539 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2171630), // Rule ID 18475 //
     /* 2171544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2171555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2171558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2171561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2171564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2171567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171590 */     // MIs[0] round
     /* 2171590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171593 */     // MIs[0] policy
     /* 2171593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171603 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2171606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171629 */     // GIR_Coverage, 18475,
     /* 2171629 */     GIR_EraseRootFromParent_Done,
     /* 2171630 */   // Label 28603: @2171630
     /* 2171630 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2171721), // Rule ID 18478 //
     /* 2171635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2171646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2171649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2171652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2171655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171681 */     // MIs[0] round
     /* 2171681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171684 */     // MIs[0] policy
     /* 2171684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2171697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171720 */     // GIR_Coverage, 18478,
     /* 2171720 */     GIR_EraseRootFromParent_Done,
     /* 2171721 */   // Label 28604: @2171721
     /* 2171721 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2171812), // Rule ID 18479 //
     /* 2171726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2171737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2171740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2171743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2171746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171772 */     // MIs[0] round
     /* 2171772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171775 */     // MIs[0] policy
     /* 2171775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171785 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2171788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171811 */     // GIR_Coverage, 18479,
     /* 2171811 */     GIR_EraseRootFromParent_Done,
     /* 2171812 */   // Label 28605: @2171812
     /* 2171812 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2171903), // Rule ID 18482 //
     /* 2171817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2171834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171863 */     // MIs[0] round
     /* 2171863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171866 */     // MIs[0] policy
     /* 2171866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2171879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171902 */     // GIR_Coverage, 18482,
     /* 2171902 */     GIR_EraseRootFromParent_Done,
     /* 2171903 */   // Label 28606: @2171903
     /* 2171903 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2171994), // Rule ID 18483 //
     /* 2171908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2171919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2171922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2171925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2171928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2171938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2171950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171954 */     // MIs[0] round
     /* 2171954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171957 */     // MIs[0] policy
     /* 2171957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171967 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2171970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171993 */     // GIR_Coverage, 18483,
     /* 2171993 */     GIR_EraseRootFromParent_Done,
     /* 2171994 */   // Label 28607: @2171994
     /* 2171994 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2172085), // Rule ID 18486 //
     /* 2171999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2172010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2172013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2172016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2172019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172045 */     // MIs[0] round
     /* 2172045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172048 */     // MIs[0] policy
     /* 2172048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2172061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172084 */     // GIR_Coverage, 18486,
     /* 2172084 */     GIR_EraseRootFromParent_Done,
     /* 2172085 */   // Label 28608: @2172085
     /* 2172085 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2172176), // Rule ID 18487 //
     /* 2172090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2172101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2172104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2172107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2172110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172136 */     // MIs[0] round
     /* 2172136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172139 */     // MIs[0] policy
     /* 2172139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172149 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2172152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172175 */     // GIR_Coverage, 18487,
     /* 2172175 */     GIR_EraseRootFromParent_Done,
     /* 2172176 */   // Label 28609: @2172176
     /* 2172176 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2172267), // Rule ID 18490 //
     /* 2172181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2172192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2172195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2172198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2172201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172227 */     // MIs[0] round
     /* 2172227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172230 */     // MIs[0] policy
     /* 2172230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172240 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2172243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172266 */     // GIR_Coverage, 18490,
     /* 2172266 */     GIR_EraseRootFromParent_Done,
     /* 2172267 */   // Label 28610: @2172267
     /* 2172267 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2172358), // Rule ID 18491 //
     /* 2172272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2172283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2172286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2172289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2172292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172318 */     // MIs[0] round
     /* 2172318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172321 */     // MIs[0] policy
     /* 2172321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172331 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2172334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172357 */     // GIR_Coverage, 18491,
     /* 2172357 */     GIR_EraseRootFromParent_Done,
     /* 2172358 */   // Label 28611: @2172358
     /* 2172358 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2172449), // Rule ID 18494 //
     /* 2172363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2172374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2172377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2172380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2172383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172409 */     // MIs[0] round
     /* 2172409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172412 */     // MIs[0] policy
     /* 2172412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172422 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2172425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172448 */     // GIR_Coverage, 18494,
     /* 2172448 */     GIR_EraseRootFromParent_Done,
     /* 2172449 */   // Label 28612: @2172449
     /* 2172449 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2172540), // Rule ID 18495 //
     /* 2172454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2172465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2172468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2172471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2172474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2172477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172500 */     // MIs[0] round
     /* 2172500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172503 */     // MIs[0] policy
     /* 2172503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172513 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2172516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172539 */     // GIR_Coverage, 18495,
     /* 2172539 */     GIR_EraseRootFromParent_Done,
     /* 2172540 */   // Label 28613: @2172540
     /* 2172540 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2172631), // Rule ID 18498 //
     /* 2172545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2172556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2172559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2172562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2172565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2172568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172591 */     // MIs[0] round
     /* 2172591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172594 */     // MIs[0] policy
     /* 2172594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172604 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2172607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172630 */     // GIR_Coverage, 18498,
     /* 2172630 */     GIR_EraseRootFromParent_Done,
     /* 2172631 */   // Label 28614: @2172631
     /* 2172631 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2172722), // Rule ID 18499 //
     /* 2172636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2172647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2172650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2172653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2172656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2172659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172682 */     // MIs[0] round
     /* 2172682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172685 */     // MIs[0] policy
     /* 2172685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172695 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2172698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172721 */     // GIR_Coverage, 18499,
     /* 2172721 */     GIR_EraseRootFromParent_Done,
     /* 2172722 */   // Label 28615: @2172722
     /* 2172722 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2172813), // Rule ID 18502 //
     /* 2172727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2172738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2172741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2172744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2172747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172773 */     // MIs[0] round
     /* 2172773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172776 */     // MIs[0] policy
     /* 2172776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172786 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2172789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172812 */     // GIR_Coverage, 18502,
     /* 2172812 */     GIR_EraseRootFromParent_Done,
     /* 2172813 */   // Label 28616: @2172813
     /* 2172813 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2172904), // Rule ID 18503 //
     /* 2172818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2172829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2172832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2172835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2172838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172864 */     // MIs[0] round
     /* 2172864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172867 */     // MIs[0] policy
     /* 2172867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172877 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2172880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172903 */     // GIR_Coverage, 18503,
     /* 2172903 */     GIR_EraseRootFromParent_Done,
     /* 2172904 */   // Label 28617: @2172904
     /* 2172904 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2172995), // Rule ID 18506 //
     /* 2172909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2172920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2172923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2172926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2172929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172955 */     // MIs[0] round
     /* 2172955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172958 */     // MIs[0] policy
     /* 2172958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172968 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2172971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172994 */     // GIR_Coverage, 18506,
     /* 2172994 */     GIR_EraseRootFromParent_Done,
     /* 2172995 */   // Label 28618: @2172995
     /* 2172995 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2173086), // Rule ID 18507 //
     /* 2173000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2173011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2173014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2173017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2173020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173046 */     // MIs[0] round
     /* 2173046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173049 */     // MIs[0] policy
     /* 2173049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173059 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2173062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173085 */     // GIR_Coverage, 18507,
     /* 2173085 */     GIR_EraseRootFromParent_Done,
     /* 2173086 */   // Label 28619: @2173086
     /* 2173086 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2173177), // Rule ID 18510 //
     /* 2173091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2173102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2173105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2173108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2173111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173137 */     // MIs[0] round
     /* 2173137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173140 */     // MIs[0] policy
     /* 2173140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173150 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2173153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173176 */     // GIR_Coverage, 18510,
     /* 2173176 */     GIR_EraseRootFromParent_Done,
     /* 2173177 */   // Label 28620: @2173177
     /* 2173177 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2173268), // Rule ID 18511 //
     /* 2173182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2173193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2173196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2173199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2173202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173228 */     // MIs[0] round
     /* 2173228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173231 */     // MIs[0] policy
     /* 2173231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173241 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2173244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173267 */     // GIR_Coverage, 18511,
     /* 2173267 */     GIR_EraseRootFromParent_Done,
     /* 2173268 */   // Label 28621: @2173268
     /* 2173268 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2173359), // Rule ID 18514 //
     /* 2173273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2173284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2173287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2173290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2173293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173319 */     // MIs[0] round
     /* 2173319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173322 */     // MIs[0] policy
     /* 2173322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2173335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173358 */     // GIR_Coverage, 18514,
     /* 2173358 */     GIR_EraseRootFromParent_Done,
     /* 2173359 */   // Label 28622: @2173359
     /* 2173359 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2173450), // Rule ID 18515 //
     /* 2173364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2173375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2173378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2173381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2173384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173410 */     // MIs[0] round
     /* 2173410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173413 */     // MIs[0] policy
     /* 2173413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173423 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2173426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173449 */     // GIR_Coverage, 18515,
     /* 2173449 */     GIR_EraseRootFromParent_Done,
     /* 2173450 */   // Label 28623: @2173450
     /* 2173450 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2173541), // Rule ID 18518 //
     /* 2173455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2173466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2173469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2173472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2173475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173501 */     // MIs[0] round
     /* 2173501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173504 */     // MIs[0] policy
     /* 2173504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173514 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2173517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173540 */     // GIR_Coverage, 18518,
     /* 2173540 */     GIR_EraseRootFromParent_Done,
     /* 2173541 */   // Label 28624: @2173541
     /* 2173541 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2173632), // Rule ID 18519 //
     /* 2173546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2173557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2173560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2173563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2173566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173592 */     // MIs[0] round
     /* 2173592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173595 */     // MIs[0] policy
     /* 2173595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173605 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2173608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173631 */     // GIR_Coverage, 18519,
     /* 2173631 */     GIR_EraseRootFromParent_Done,
     /* 2173632 */   // Label 28625: @2173632
     /* 2173632 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2173723), // Rule ID 18522 //
     /* 2173637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2173648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2173651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2173654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2173657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173683 */     // MIs[0] round
     /* 2173683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173686 */     // MIs[0] policy
     /* 2173686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173696 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2173699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173722 */     // GIR_Coverage, 18522,
     /* 2173722 */     GIR_EraseRootFromParent_Done,
     /* 2173723 */   // Label 28626: @2173723
     /* 2173723 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2173814), // Rule ID 18523 //
     /* 2173728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2173739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2173742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2173745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2173748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173774 */     // MIs[0] round
     /* 2173774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173777 */     // MIs[0] policy
     /* 2173777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173787 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2173790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173813 */     // GIR_Coverage, 18523,
     /* 2173813 */     GIR_EraseRootFromParent_Done,
     /* 2173814 */   // Label 28627: @2173814
     /* 2173814 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2173905), // Rule ID 18526 //
     /* 2173819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173865 */     // MIs[0] round
     /* 2173865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173868 */     // MIs[0] policy
     /* 2173868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173878 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2173881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173904 */     // GIR_Coverage, 18526,
     /* 2173904 */     GIR_EraseRootFromParent_Done,
     /* 2173905 */   // Label 28628: @2173905
     /* 2173905 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2173996), // Rule ID 18527 //
     /* 2173910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2173918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2173921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2173924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2173927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2173930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2173948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173956 */     // MIs[0] round
     /* 2173956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173959 */     // MIs[0] policy
     /* 2173959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173969 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2173972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173995 */     // GIR_Coverage, 18527,
     /* 2173995 */     GIR_EraseRootFromParent_Done,
     /* 2173996 */   // Label 28629: @2173996
     /* 2173996 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2174087), // Rule ID 18530 //
     /* 2174001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2174012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2174015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2174021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174047 */     // MIs[0] round
     /* 2174047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174050 */     // MIs[0] policy
     /* 2174050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174060 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2174063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174086 */     // GIR_Coverage, 18530,
     /* 2174086 */     GIR_EraseRootFromParent_Done,
     /* 2174087 */   // Label 28630: @2174087
     /* 2174087 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2174178), // Rule ID 18531 //
     /* 2174092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2174103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2174106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2174112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174138 */     // MIs[0] round
     /* 2174138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174141 */     // MIs[0] policy
     /* 2174141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174151 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2174154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174177 */     // GIR_Coverage, 18531,
     /* 2174177 */     GIR_EraseRootFromParent_Done,
     /* 2174178 */   // Label 28631: @2174178
     /* 2174178 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2174269), // Rule ID 18534 //
     /* 2174183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2174194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2174197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2174203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174229 */     // MIs[0] round
     /* 2174229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174232 */     // MIs[0] policy
     /* 2174232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174242 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2174245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174268 */     // GIR_Coverage, 18534,
     /* 2174268 */     GIR_EraseRootFromParent_Done,
     /* 2174269 */   // Label 28632: @2174269
     /* 2174269 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2174360), // Rule ID 18535 //
     /* 2174274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2174285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2174288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2174294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174320 */     // MIs[0] round
     /* 2174320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174323 */     // MIs[0] policy
     /* 2174323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174333 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2174336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174359 */     // GIR_Coverage, 18535,
     /* 2174359 */     GIR_EraseRootFromParent_Done,
     /* 2174360 */   // Label 28633: @2174360
     /* 2174360 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2174451), // Rule ID 18538 //
     /* 2174365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2174376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2174379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2174385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174411 */     // MIs[0] round
     /* 2174411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174414 */     // MIs[0] policy
     /* 2174414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174424 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2174427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174450 */     // GIR_Coverage, 18538,
     /* 2174450 */     GIR_EraseRootFromParent_Done,
     /* 2174451 */   // Label 28634: @2174451
     /* 2174451 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2174542), // Rule ID 18539 //
     /* 2174456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2174467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2174470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2174476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174502 */     // MIs[0] round
     /* 2174502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174505 */     // MIs[0] policy
     /* 2174505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174515 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2174518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174541 */     // GIR_Coverage, 18539,
     /* 2174541 */     GIR_EraseRootFromParent_Done,
     /* 2174542 */   // Label 28635: @2174542
     /* 2174542 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2174633), // Rule ID 18542 //
     /* 2174547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2174558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2174561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2174567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174593 */     // MIs[0] round
     /* 2174593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174596 */     // MIs[0] policy
     /* 2174596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174606 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2174609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174632 */     // GIR_Coverage, 18542,
     /* 2174632 */     GIR_EraseRootFromParent_Done,
     /* 2174633 */   // Label 28636: @2174633
     /* 2174633 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2174724), // Rule ID 18543 //
     /* 2174638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2174649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2174652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2174655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2174658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2174676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174684 */     // MIs[0] round
     /* 2174684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174687 */     // MIs[0] policy
     /* 2174687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174697 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2174700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174723 */     // GIR_Coverage, 18543,
     /* 2174723 */     GIR_EraseRootFromParent_Done,
     /* 2174724 */   // Label 28637: @2174724
     /* 2174724 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2174815), // Rule ID 18546 //
     /* 2174729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2174740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2174743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2174746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2174749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2174767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174775 */     // MIs[0] round
     /* 2174775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174778 */     // MIs[0] policy
     /* 2174778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174788 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2174791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174814 */     // GIR_Coverage, 18546,
     /* 2174814 */     GIR_EraseRootFromParent_Done,
     /* 2174815 */   // Label 28638: @2174815
     /* 2174815 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2174906), // Rule ID 18547 //
     /* 2174820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2174831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2174834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2174837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2174840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2174858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174866 */     // MIs[0] round
     /* 2174866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174869 */     // MIs[0] policy
     /* 2174869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174879 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2174882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174905 */     // GIR_Coverage, 18547,
     /* 2174905 */     GIR_EraseRootFromParent_Done,
     /* 2174906 */   // Label 28639: @2174906
     /* 2174906 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2174997), // Rule ID 18550 //
     /* 2174911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2174919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2174922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2174925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2174931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174957 */     // MIs[0] round
     /* 2174957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174960 */     // MIs[0] policy
     /* 2174960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2174973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174996 */     // GIR_Coverage, 18550,
     /* 2174996 */     GIR_EraseRootFromParent_Done,
     /* 2174997 */   // Label 28640: @2174997
     /* 2174997 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2175088), // Rule ID 18551 //
     /* 2175002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2175013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2175016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2175022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175048 */     // MIs[0] round
     /* 2175048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175051 */     // MIs[0] policy
     /* 2175051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175061 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2175064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175087 */     // GIR_Coverage, 18551,
     /* 2175087 */     GIR_EraseRootFromParent_Done,
     /* 2175088 */   // Label 28641: @2175088
     /* 2175088 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2175179), // Rule ID 18554 //
     /* 2175093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2175104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2175107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2175113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175139 */     // MIs[0] round
     /* 2175139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175142 */     // MIs[0] policy
     /* 2175142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175152 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2175155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175178 */     // GIR_Coverage, 18554,
     /* 2175178 */     GIR_EraseRootFromParent_Done,
     /* 2175179 */   // Label 28642: @2175179
     /* 2175179 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2175270), // Rule ID 18555 //
     /* 2175184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2175195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2175198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2175204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175230 */     // MIs[0] round
     /* 2175230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175233 */     // MIs[0] policy
     /* 2175233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175243 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2175246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175269 */     // GIR_Coverage, 18555,
     /* 2175269 */     GIR_EraseRootFromParent_Done,
     /* 2175270 */   // Label 28643: @2175270
     /* 2175270 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2175361), // Rule ID 18558 //
     /* 2175275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2175286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2175289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2175295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2175298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175321 */     // MIs[0] round
     /* 2175321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175324 */     // MIs[0] policy
     /* 2175324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175334 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2175337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175360 */     // GIR_Coverage, 18558,
     /* 2175360 */     GIR_EraseRootFromParent_Done,
     /* 2175361 */   // Label 28644: @2175361
     /* 2175361 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2175452), // Rule ID 18559 //
     /* 2175366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2175377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2175380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2175386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2175389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175412 */     // MIs[0] round
     /* 2175412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175415 */     // MIs[0] policy
     /* 2175415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175425 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2175428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175451 */     // GIR_Coverage, 18559,
     /* 2175451 */     GIR_EraseRootFromParent_Done,
     /* 2175452 */   // Label 28645: @2175452
     /* 2175452 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2175543), // Rule ID 18562 //
     /* 2175457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2175468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2175471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2175477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175503 */     // MIs[0] round
     /* 2175503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175506 */     // MIs[0] policy
     /* 2175506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2175519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175542 */     // GIR_Coverage, 18562,
     /* 2175542 */     GIR_EraseRootFromParent_Done,
     /* 2175543 */   // Label 28646: @2175543
     /* 2175543 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2175634), // Rule ID 18563 //
     /* 2175548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2175559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2175562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2175568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2175578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2175590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175594 */     // MIs[0] round
     /* 2175594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175597 */     // MIs[0] policy
     /* 2175597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175607 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2175610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175633 */     // GIR_Coverage, 18563,
     /* 2175633 */     GIR_EraseRootFromParent_Done,
     /* 2175634 */   // Label 28647: @2175634
     /* 2175634 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2175725), // Rule ID 18566 //
     /* 2175639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2175650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2175653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2175659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175685 */     // MIs[0] round
     /* 2175685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175688 */     // MIs[0] policy
     /* 2175688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175698 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2175701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175724 */     // GIR_Coverage, 18566,
     /* 2175724 */     GIR_EraseRootFromParent_Done,
     /* 2175725 */   // Label 28648: @2175725
     /* 2175725 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2175816), // Rule ID 18567 //
     /* 2175730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2175741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2175744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2175750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2175760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175776 */     // MIs[0] round
     /* 2175776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175779 */     // MIs[0] policy
     /* 2175779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175789 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2175792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175815 */     // GIR_Coverage, 18567,
     /* 2175815 */     GIR_EraseRootFromParent_Done,
     /* 2175816 */   // Label 28649: @2175816
     /* 2175816 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2175907), // Rule ID 18570 //
     /* 2175821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175867 */     // MIs[0] round
     /* 2175867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175870 */     // MIs[0] policy
     /* 2175870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175880 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2175883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175906 */     // GIR_Coverage, 18570,
     /* 2175906 */     GIR_EraseRootFromParent_Done,
     /* 2175907 */   // Label 28650: @2175907
     /* 2175907 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2175998), // Rule ID 18571 //
     /* 2175912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2175920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2175923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2175926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2175932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2175935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175958 */     // MIs[0] round
     /* 2175958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175961 */     // MIs[0] policy
     /* 2175961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175971 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2175974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175997 */     // GIR_Coverage, 18571,
     /* 2175997 */     GIR_EraseRootFromParent_Done,
     /* 2175998 */   // Label 28651: @2175998
     /* 2175998 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2176089), // Rule ID 18574 //
     /* 2176003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2176014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2176017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2176023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176049 */     // MIs[0] round
     /* 2176049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176052 */     // MIs[0] policy
     /* 2176052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2176065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176088 */     // GIR_Coverage, 18574,
     /* 2176088 */     GIR_EraseRootFromParent_Done,
     /* 2176089 */   // Label 28652: @2176089
     /* 2176089 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2176180), // Rule ID 18575 //
     /* 2176094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2176105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2176108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2176114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176140 */     // MIs[0] round
     /* 2176140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176143 */     // MIs[0] policy
     /* 2176143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176153 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2176156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176179 */     // GIR_Coverage, 18575,
     /* 2176179 */     GIR_EraseRootFromParent_Done,
     /* 2176180 */   // Label 28653: @2176180
     /* 2176180 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2176271), // Rule ID 18578 //
     /* 2176185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2176196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2176199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2176205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176231 */     // MIs[0] round
     /* 2176231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176234 */     // MIs[0] policy
     /* 2176234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176244 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2176247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176270 */     // GIR_Coverage, 18578,
     /* 2176270 */     GIR_EraseRootFromParent_Done,
     /* 2176271 */   // Label 28654: @2176271
     /* 2176271 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2176362), // Rule ID 18579 //
     /* 2176276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2176287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2176290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2176296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176322 */     // MIs[0] round
     /* 2176322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176325 */     // MIs[0] policy
     /* 2176325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176335 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2176338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176361 */     // GIR_Coverage, 18579,
     /* 2176361 */     GIR_EraseRootFromParent_Done,
     /* 2176362 */   // Label 28655: @2176362
     /* 2176362 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2176453), // Rule ID 18582 //
     /* 2176367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2176378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2176381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2176387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176413 */     // MIs[0] round
     /* 2176413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176416 */     // MIs[0] policy
     /* 2176416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2176429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176452 */     // GIR_Coverage, 18582,
     /* 2176452 */     GIR_EraseRootFromParent_Done,
     /* 2176453 */   // Label 28656: @2176453
     /* 2176453 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2176544), // Rule ID 18583 //
     /* 2176458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2176466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2176469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2176472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2176478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176504 */     // MIs[0] round
     /* 2176504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176507 */     // MIs[0] policy
     /* 2176507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176517 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2176520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176543 */     // GIR_Coverage, 18583,
     /* 2176543 */     GIR_EraseRootFromParent_Done,
     /* 2176544 */   // Label 28657: @2176544
     /* 2176544 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2176635), // Rule ID 18586 //
     /* 2176549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2176560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2176563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2176566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2176569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176595 */     // MIs[0] round
     /* 2176595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176598 */     // MIs[0] policy
     /* 2176598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176608 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2176611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176634 */     // GIR_Coverage, 18586,
     /* 2176634 */     GIR_EraseRootFromParent_Done,
     /* 2176635 */   // Label 28658: @2176635
     /* 2176635 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2176726), // Rule ID 18587 //
     /* 2176640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2176651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2176654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2176657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2176660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176686 */     // MIs[0] round
     /* 2176686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176689 */     // MIs[0] policy
     /* 2176689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176699 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2176702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176725 */     // GIR_Coverage, 18587,
     /* 2176725 */     GIR_EraseRootFromParent_Done,
     /* 2176726 */   // Label 28659: @2176726
     /* 2176726 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2176817), // Rule ID 18590 //
     /* 2176731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2176742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2176745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2176748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2176751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176777 */     // MIs[0] round
     /* 2176777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176780 */     // MIs[0] policy
     /* 2176780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176790 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2176793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176816 */     // GIR_Coverage, 18590,
     /* 2176816 */     GIR_EraseRootFromParent_Done,
     /* 2176817 */   // Label 28660: @2176817
     /* 2176817 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2176908), // Rule ID 18591 //
     /* 2176822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2176833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2176836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2176839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2176842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176868 */     // MIs[0] round
     /* 2176868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176871 */     // MIs[0] policy
     /* 2176871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176881 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2176884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176907 */     // GIR_Coverage, 18591,
     /* 2176907 */     GIR_EraseRootFromParent_Done,
     /* 2176908 */   // Label 28661: @2176908
     /* 2176908 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2176999), // Rule ID 18594 //
     /* 2176913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2176924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2176927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2176930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2176933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176959 */     // MIs[0] round
     /* 2176959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176962 */     // MIs[0] policy
     /* 2176962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176972 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2176975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176998 */     // GIR_Coverage, 18594,
     /* 2176998 */     GIR_EraseRootFromParent_Done,
     /* 2176999 */   // Label 28662: @2176999
     /* 2176999 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2177090), // Rule ID 18595 //
     /* 2177004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2177015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2177018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2177021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2177024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177050 */     // MIs[0] round
     /* 2177050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177053 */     // MIs[0] policy
     /* 2177053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177063 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2177066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177089 */     // GIR_Coverage, 18595,
     /* 2177089 */     GIR_EraseRootFromParent_Done,
     /* 2177090 */   // Label 28663: @2177090
     /* 2177090 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2177181), // Rule ID 18598 //
     /* 2177095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2177106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2177109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2177112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2177115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177141 */     // MIs[0] round
     /* 2177141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177144 */     // MIs[0] policy
     /* 2177144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177154 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2177157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177180 */     // GIR_Coverage, 18598,
     /* 2177180 */     GIR_EraseRootFromParent_Done,
     /* 2177181 */   // Label 28664: @2177181
     /* 2177181 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2177272), // Rule ID 18599 //
     /* 2177186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2177197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2177200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2177203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2177206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177232 */     // MIs[0] round
     /* 2177232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177235 */     // MIs[0] policy
     /* 2177235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177245 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2177248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177271 */     // GIR_Coverage, 18599,
     /* 2177271 */     GIR_EraseRootFromParent_Done,
     /* 2177272 */   // Label 28665: @2177272
     /* 2177272 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2177363), // Rule ID 18602 //
     /* 2177277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2177294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2177297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177323 */     // MIs[0] round
     /* 2177323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177326 */     // MIs[0] policy
     /* 2177326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2177339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177362 */     // GIR_Coverage, 18602,
     /* 2177362 */     GIR_EraseRootFromParent_Done,
     /* 2177363 */   // Label 28666: @2177363
     /* 2177363 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2177454), // Rule ID 18603 //
     /* 2177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2177385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2177388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177414 */     // MIs[0] round
     /* 2177414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177417 */     // MIs[0] policy
     /* 2177417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177427 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2177430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177453 */     // GIR_Coverage, 18603,
     /* 2177453 */     GIR_EraseRootFromParent_Done,
     /* 2177454 */   // Label 28667: @2177454
     /* 2177454 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2177545), // Rule ID 18606 //
     /* 2177459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2177470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2177473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2177476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2177479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177505 */     // MIs[0] round
     /* 2177505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177508 */     // MIs[0] policy
     /* 2177508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177518 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2177521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177544 */     // GIR_Coverage, 18606,
     /* 2177544 */     GIR_EraseRootFromParent_Done,
     /* 2177545 */   // Label 28668: @2177545
     /* 2177545 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2177636), // Rule ID 18607 //
     /* 2177550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2177561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2177564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2177567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2177570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177596 */     // MIs[0] round
     /* 2177596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177599 */     // MIs[0] policy
     /* 2177599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177609 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2177612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177635 */     // GIR_Coverage, 18607,
     /* 2177635 */     GIR_EraseRootFromParent_Done,
     /* 2177636 */   // Label 28669: @2177636
     /* 2177636 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2177727), // Rule ID 18610 //
     /* 2177641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2177652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2177655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2177658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2177661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177687 */     // MIs[0] round
     /* 2177687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177690 */     // MIs[0] policy
     /* 2177690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2177703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177726 */     // GIR_Coverage, 18610,
     /* 2177726 */     GIR_EraseRootFromParent_Done,
     /* 2177727 */   // Label 28670: @2177727
     /* 2177727 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2177818), // Rule ID 18611 //
     /* 2177732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2177743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2177746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2177749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2177752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177778 */     // MIs[0] round
     /* 2177778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177781 */     // MIs[0] policy
     /* 2177781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177791 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2177794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177817 */     // GIR_Coverage, 18611,
     /* 2177817 */     GIR_EraseRootFromParent_Done,
     /* 2177818 */   // Label 28671: @2177818
     /* 2177818 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2177909), // Rule ID 18614 //
     /* 2177823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2177840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177869 */     // MIs[0] round
     /* 2177869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177872 */     // MIs[0] policy
     /* 2177872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177882 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2177885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177908 */     // GIR_Coverage, 18614,
     /* 2177908 */     GIR_EraseRootFromParent_Done,
     /* 2177909 */   // Label 28672: @2177909
     /* 2177909 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2178000), // Rule ID 18615 //
     /* 2177914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2177917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2177925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2177928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2177931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2177934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177960 */     // MIs[0] round
     /* 2177960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177963 */     // MIs[0] policy
     /* 2177963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177973 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2177976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177999 */     // GIR_Coverage, 18615,
     /* 2177999 */     GIR_EraseRootFromParent_Done,
     /* 2178000 */   // Label 28673: @2178000
     /* 2178000 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2178091), // Rule ID 18618 //
     /* 2178005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2178016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2178019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2178022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2178025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2178028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178051 */     // MIs[0] round
     /* 2178051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178054 */     // MIs[0] policy
     /* 2178054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178064 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2178067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178090 */     // GIR_Coverage, 18618,
     /* 2178090 */     GIR_EraseRootFromParent_Done,
     /* 2178091 */   // Label 28674: @2178091
     /* 2178091 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2178182), // Rule ID 18619 //
     /* 2178096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2178107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2178110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2178113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2178116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2178119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178142 */     // MIs[0] round
     /* 2178142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178145 */     // MIs[0] policy
     /* 2178145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178155 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2178158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178181 */     // GIR_Coverage, 18619,
     /* 2178181 */     GIR_EraseRootFromParent_Done,
     /* 2178182 */   // Label 28675: @2178182
     /* 2178182 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2178273), // Rule ID 18622 //
     /* 2178187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2178204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2178207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178233 */     // MIs[0] round
     /* 2178233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178236 */     // MIs[0] policy
     /* 2178236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178246 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2178249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178272 */     // GIR_Coverage, 18622,
     /* 2178272 */     GIR_EraseRootFromParent_Done,
     /* 2178273 */   // Label 28676: @2178273
     /* 2178273 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2178364), // Rule ID 18623 //
     /* 2178278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2178295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2178298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178324 */     // MIs[0] round
     /* 2178324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178327 */     // MIs[0] policy
     /* 2178327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178337 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2178340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178363 */     // GIR_Coverage, 18623,
     /* 2178363 */     GIR_EraseRootFromParent_Done,
     /* 2178364 */   // Label 28677: @2178364
     /* 2178364 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2178455), // Rule ID 18626 //
     /* 2178369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2178386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2178389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178415 */     // MIs[0] round
     /* 2178415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178418 */     // MIs[0] policy
     /* 2178418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178428 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2178431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178454 */     // GIR_Coverage, 18626,
     /* 2178454 */     GIR_EraseRootFromParent_Done,
     /* 2178455 */   // Label 28678: @2178455
     /* 2178455 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2178546), // Rule ID 18627 //
     /* 2178460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2178477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2178480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178506 */     // MIs[0] round
     /* 2178506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178509 */     // MIs[0] policy
     /* 2178509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178519 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2178522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178545 */     // GIR_Coverage, 18627,
     /* 2178545 */     GIR_EraseRootFromParent_Done,
     /* 2178546 */   // Label 28679: @2178546
     /* 2178546 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2178637), // Rule ID 18630 //
     /* 2178551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2178568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2178571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178597 */     // MIs[0] round
     /* 2178597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178600 */     // MIs[0] policy
     /* 2178600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178610 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2178613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178636 */     // GIR_Coverage, 18630,
     /* 2178636 */     GIR_EraseRootFromParent_Done,
     /* 2178637 */   // Label 28680: @2178637
     /* 2178637 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2178728), // Rule ID 18631 //
     /* 2178642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2178659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2178662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178688 */     // MIs[0] round
     /* 2178688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178691 */     // MIs[0] policy
     /* 2178691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178701 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2178704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178727 */     // GIR_Coverage, 18631,
     /* 2178727 */     GIR_EraseRootFromParent_Done,
     /* 2178728 */   // Label 28681: @2178728
     /* 2178728 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2178819), // Rule ID 18634 //
     /* 2178733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2178750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2178753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178779 */     // MIs[0] round
     /* 2178779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178782 */     // MIs[0] policy
     /* 2178782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178792 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2178795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178818 */     // GIR_Coverage, 18634,
     /* 2178818 */     GIR_EraseRootFromParent_Done,
     /* 2178819 */   // Label 28682: @2178819
     /* 2178819 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2178910), // Rule ID 18635 //
     /* 2178824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2178841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2178844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178870 */     // MIs[0] round
     /* 2178870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178873 */     // MIs[0] policy
     /* 2178873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178883 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2178886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178909 */     // GIR_Coverage, 18635,
     /* 2178909 */     GIR_EraseRootFromParent_Done,
     /* 2178910 */   // Label 28683: @2178910
     /* 2178910 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2179001), // Rule ID 18638 //
     /* 2178915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2178923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2178932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2178935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178961 */     // MIs[0] round
     /* 2178961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178964 */     // MIs[0] policy
     /* 2178964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2178977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179000 */     // GIR_Coverage, 18638,
     /* 2179000 */     GIR_EraseRootFromParent_Done,
     /* 2179001 */   // Label 28684: @2179001
     /* 2179001 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2179092), // Rule ID 18639 //
     /* 2179006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2179009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2179017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2179020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2179023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2179026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179052 */     // MIs[0] round
     /* 2179052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179055 */     // MIs[0] policy
     /* 2179055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179065 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2179068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179091 */     // GIR_Coverage, 18639,
     /* 2179091 */     GIR_EraseRootFromParent_Done,
     /* 2179092 */   // Label 28685: @2179092
     /* 2179092 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2179183), // Rule ID 18642 //
     /* 2179097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2179100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2179108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2179111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2179114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2179117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179143 */     // MIs[0] round
     /* 2179143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179146 */     // MIs[0] policy
     /* 2179146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2179159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179182 */     // GIR_Coverage, 18642,
     /* 2179182 */     GIR_EraseRootFromParent_Done,
     /* 2179183 */   // Label 28686: @2179183
     /* 2179183 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2179274), // Rule ID 18643 //
     /* 2179188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2179191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2179199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2179202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2179205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2179208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179234 */     // MIs[0] round
     /* 2179234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179237 */     // MIs[0] policy
     /* 2179237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179247 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2179250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179273 */     // GIR_Coverage, 18643,
     /* 2179273 */     GIR_EraseRootFromParent_Done,
     /* 2179274 */   // Label 28687: @2179274
     /* 2179274 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2179365), // Rule ID 18646 //
     /* 2179279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2179290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2179293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179325 */     // MIs[0] round
     /* 2179325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179328 */     // MIs[0] policy
     /* 2179328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179338 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2179341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179364 */     // GIR_Coverage, 18646,
     /* 2179364 */     GIR_EraseRootFromParent_Done,
     /* 2179365 */   // Label 28688: @2179365
     /* 2179365 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2179456), // Rule ID 18647 //
     /* 2179370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2179381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2179384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179416 */     // MIs[0] round
     /* 2179416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179419 */     // MIs[0] policy
     /* 2179419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179429 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2179432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179455 */     // GIR_Coverage, 18647,
     /* 2179455 */     GIR_EraseRootFromParent_Done,
     /* 2179456 */   // Label 28689: @2179456
     /* 2179456 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2179547), // Rule ID 18650 //
     /* 2179461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2179472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2179475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179507 */     // MIs[0] round
     /* 2179507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179510 */     // MIs[0] policy
     /* 2179510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179520 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2179523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179546 */     // GIR_Coverage, 18650,
     /* 2179546 */     GIR_EraseRootFromParent_Done,
     /* 2179547 */   // Label 28690: @2179547
     /* 2179547 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2179638), // Rule ID 18651 //
     /* 2179552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2179563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2179566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179598 */     // MIs[0] round
     /* 2179598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179601 */     // MIs[0] policy
     /* 2179601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179611 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2179614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179637 */     // GIR_Coverage, 18651,
     /* 2179637 */     GIR_EraseRootFromParent_Done,
     /* 2179638 */   // Label 28691: @2179638
     /* 2179638 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2179729), // Rule ID 18654 //
     /* 2179643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2179663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179689 */     // MIs[0] round
     /* 2179689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179692 */     // MIs[0] policy
     /* 2179692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179702 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2179705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179728 */     // GIR_Coverage, 18654,
     /* 2179728 */     GIR_EraseRootFromParent_Done,
     /* 2179729 */   // Label 28692: @2179729
     /* 2179729 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2179820), // Rule ID 18655 //
     /* 2179734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2179751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2179754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2179772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179780 */     // MIs[0] round
     /* 2179780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179783 */     // MIs[0] policy
     /* 2179783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179793 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2179796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179819 */     // GIR_Coverage, 18655,
     /* 2179819 */     GIR_EraseRootFromParent_Done,
     /* 2179820 */   // Label 28693: @2179820
     /* 2179820 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2179911), // Rule ID 18658 //
     /* 2179825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179871 */     // MIs[0] round
     /* 2179871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179874 */     // MIs[0] policy
     /* 2179874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179884 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2179887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179910 */     // GIR_Coverage, 18658,
     /* 2179910 */     GIR_EraseRootFromParent_Done,
     /* 2179911 */   // Label 28694: @2179911
     /* 2179911 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2180002), // Rule ID 18659 //
     /* 2179916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2179924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2179927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2179930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179962 */     // MIs[0] round
     /* 2179962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179965 */     // MIs[0] policy
     /* 2179965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179975 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2179978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180001 */     // GIR_Coverage, 18659,
     /* 2180001 */     GIR_EraseRootFromParent_Done,
     /* 2180002 */   // Label 28695: @2180002
     /* 2180002 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2180093), // Rule ID 18662 //
     /* 2180007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2180018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2180021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2180027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180053 */     // MIs[0] round
     /* 2180053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180056 */     // MIs[0] policy
     /* 2180056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180066 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2180069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180092 */     // GIR_Coverage, 18662,
     /* 2180092 */     GIR_EraseRootFromParent_Done,
     /* 2180093 */   // Label 28696: @2180093
     /* 2180093 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2180184), // Rule ID 18663 //
     /* 2180098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2180109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2180112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2180118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180144 */     // MIs[0] round
     /* 2180144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180147 */     // MIs[0] policy
     /* 2180147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180157 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2180160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180183 */     // GIR_Coverage, 18663,
     /* 2180183 */     GIR_EraseRootFromParent_Done,
     /* 2180184 */   // Label 28697: @2180184
     /* 2180184 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2180275), // Rule ID 18666 //
     /* 2180189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2180206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2180209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2180227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180235 */     // MIs[0] round
     /* 2180235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180238 */     // MIs[0] policy
     /* 2180238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180248 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2180251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180274 */     // GIR_Coverage, 18666,
     /* 2180274 */     GIR_EraseRootFromParent_Done,
     /* 2180275 */   // Label 28698: @2180275
     /* 2180275 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2180366), // Rule ID 18667 //
     /* 2180280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2180297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2180300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2180318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180326 */     // MIs[0] round
     /* 2180326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180329 */     // MIs[0] policy
     /* 2180329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180339 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2180342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180365 */     // GIR_Coverage, 18667,
     /* 2180365 */     GIR_EraseRootFromParent_Done,
     /* 2180366 */   // Label 28699: @2180366
     /* 2180366 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2180457), // Rule ID 18670 //
     /* 2180371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2180382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2180385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2180391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180417 */     // MIs[0] round
     /* 2180417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180420 */     // MIs[0] policy
     /* 2180420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180430 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2180433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180456 */     // GIR_Coverage, 18670,
     /* 2180456 */     GIR_EraseRootFromParent_Done,
     /* 2180457 */   // Label 28700: @2180457
     /* 2180457 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2180548), // Rule ID 18671 //
     /* 2180462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2180482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180508 */     // MIs[0] round
     /* 2180508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180511 */     // MIs[0] policy
     /* 2180511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180521 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2180524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180547 */     // GIR_Coverage, 18671,
     /* 2180547 */     GIR_EraseRootFromParent_Done,
     /* 2180548 */   // Label 28701: @2180548
     /* 2180548 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2180639), // Rule ID 18674 //
     /* 2180553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2180564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2180567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180599 */     // MIs[0] round
     /* 2180599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180602 */     // MIs[0] policy
     /* 2180602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180612 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2180615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180638 */     // GIR_Coverage, 18674,
     /* 2180638 */     GIR_EraseRootFromParent_Done,
     /* 2180639 */   // Label 28702: @2180639
     /* 2180639 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2180730), // Rule ID 18675 //
     /* 2180644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2180655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2180658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180690 */     // MIs[0] round
     /* 2180690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180693 */     // MIs[0] policy
     /* 2180693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180703 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2180706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180729 */     // GIR_Coverage, 18675,
     /* 2180729 */     GIR_EraseRootFromParent_Done,
     /* 2180730 */   // Label 28703: @2180730
     /* 2180730 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2180821), // Rule ID 18678 //
     /* 2180735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2180746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180781 */     // MIs[0] round
     /* 2180781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180784 */     // MIs[0] policy
     /* 2180784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180794 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2180797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180820 */     // GIR_Coverage, 18678,
     /* 2180820 */     GIR_EraseRootFromParent_Done,
     /* 2180821 */   // Label 28704: @2180821
     /* 2180821 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2180912), // Rule ID 18679 //
     /* 2180826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2180837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2180840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2180846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2180849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180872 */     // MIs[0] round
     /* 2180872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180875 */     // MIs[0] policy
     /* 2180875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180885 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2180888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180911 */     // GIR_Coverage, 18679,
     /* 2180911 */     GIR_EraseRootFromParent_Done,
     /* 2180912 */   // Label 28705: @2180912
     /* 2180912 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2181003), // Rule ID 18682 //
     /* 2180917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2180920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2180925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2180928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2180931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180963 */     // MIs[0] round
     /* 2180963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180966 */     // MIs[0] policy
     /* 2180966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2180979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181002 */     // GIR_Coverage, 18682,
     /* 2181002 */     GIR_EraseRootFromParent_Done,
     /* 2181003 */   // Label 28706: @2181003
     /* 2181003 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2181094), // Rule ID 18683 //
     /* 2181008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2181019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2181022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2181028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181054 */     // MIs[0] round
     /* 2181054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181057 */     // MIs[0] policy
     /* 2181057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181067 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2181070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181093 */     // GIR_Coverage, 18683,
     /* 2181093 */     GIR_EraseRootFromParent_Done,
     /* 2181094 */   // Label 28707: @2181094
     /* 2181094 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2181185), // Rule ID 18686 //
     /* 2181099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2181110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2181113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2181119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181145 */     // MIs[0] round
     /* 2181145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181148 */     // MIs[0] policy
     /* 2181148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181158 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2181161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181184 */     // GIR_Coverage, 18686,
     /* 2181184 */     GIR_EraseRootFromParent_Done,
     /* 2181185 */   // Label 28708: @2181185
     /* 2181185 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2181276), // Rule ID 18687 //
     /* 2181190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2181201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2181204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2181210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181236 */     // MIs[0] round
     /* 2181236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181239 */     // MIs[0] policy
     /* 2181239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181249 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2181252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181275 */     // GIR_Coverage, 18687,
     /* 2181275 */     GIR_EraseRootFromParent_Done,
     /* 2181276 */   // Label 28709: @2181276
     /* 2181276 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2181367), // Rule ID 18690 //
     /* 2181281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2181301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181327 */     // MIs[0] round
     /* 2181327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181330 */     // MIs[0] policy
     /* 2181330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181340 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2181343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181366 */     // GIR_Coverage, 18690,
     /* 2181366 */     GIR_EraseRootFromParent_Done,
     /* 2181367 */   // Label 28710: @2181367
     /* 2181367 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2181458), // Rule ID 18691 //
     /* 2181372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2181392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181418 */     // MIs[0] round
     /* 2181418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181421 */     // MIs[0] policy
     /* 2181421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181431 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2181434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181457 */     // GIR_Coverage, 18691,
     /* 2181457 */     GIR_EraseRootFromParent_Done,
     /* 2181458 */   // Label 28711: @2181458
     /* 2181458 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2181549), // Rule ID 18694 //
     /* 2181463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2181474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2181477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2181483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181509 */     // MIs[0] round
     /* 2181509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181512 */     // MIs[0] policy
     /* 2181512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2181525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181548 */     // GIR_Coverage, 18694,
     /* 2181548 */     GIR_EraseRootFromParent_Done,
     /* 2181549 */   // Label 28712: @2181549
     /* 2181549 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2181640), // Rule ID 18695 //
     /* 2181554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2181565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2181568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2181574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181600 */     // MIs[0] round
     /* 2181600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181603 */     // MIs[0] policy
     /* 2181603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181613 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2181616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181639 */     // GIR_Coverage, 18695,
     /* 2181639 */     GIR_EraseRootFromParent_Done,
     /* 2181640 */   // Label 28713: @2181640
     /* 2181640 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2181731), // Rule ID 18698 //
     /* 2181645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2181656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2181659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2181665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181691 */     // MIs[0] round
     /* 2181691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181694 */     // MIs[0] policy
     /* 2181694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181704 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2181707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181730 */     // GIR_Coverage, 18698,
     /* 2181730 */     GIR_EraseRootFromParent_Done,
     /* 2181731 */   // Label 28714: @2181731
     /* 2181731 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2181822), // Rule ID 18699 //
     /* 2181736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2181747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2181750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2181756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181782 */     // MIs[0] round
     /* 2181782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181785 */     // MIs[0] policy
     /* 2181785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181795 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2181798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181821 */     // GIR_Coverage, 18699,
     /* 2181821 */     GIR_EraseRootFromParent_Done,
     /* 2181822 */   // Label 28715: @2181822
     /* 2181822 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2181913), // Rule ID 18702 //
     /* 2181827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181873 */     // MIs[0] round
     /* 2181873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181876 */     // MIs[0] policy
     /* 2181876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181886 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2181889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181912 */     // GIR_Coverage, 18702,
     /* 2181912 */     GIR_EraseRootFromParent_Done,
     /* 2181913 */   // Label 28716: @2181913
     /* 2181913 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2182004), // Rule ID 18703 //
     /* 2181918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2181926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2181929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2181932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2181938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181964 */     // MIs[0] round
     /* 2181964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181967 */     // MIs[0] policy
     /* 2181967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181977 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2181980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182003 */     // GIR_Coverage, 18703,
     /* 2182003 */     GIR_EraseRootFromParent_Done,
     /* 2182004 */   // Label 28717: @2182004
     /* 2182004 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2182095), // Rule ID 18706 //
     /* 2182009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2182026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2182029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182055 */     // MIs[0] round
     /* 2182055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182058 */     // MIs[0] policy
     /* 2182058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182068 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2182071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182094 */     // GIR_Coverage, 18706,
     /* 2182094 */     GIR_EraseRootFromParent_Done,
     /* 2182095 */   // Label 28718: @2182095
     /* 2182095 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2182186), // Rule ID 18707 //
     /* 2182100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2182117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2182120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182146 */     // MIs[0] round
     /* 2182146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182149 */     // MIs[0] policy
     /* 2182149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182159 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2182162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182185 */     // GIR_Coverage, 18707,
     /* 2182185 */     GIR_EraseRootFromParent_Done,
     /* 2182186 */   // Label 28719: @2182186
     /* 2182186 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2182277), // Rule ID 18710 //
     /* 2182191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2182208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182237 */     // MIs[0] round
     /* 2182237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182240 */     // MIs[0] policy
     /* 2182240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2182253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182276 */     // GIR_Coverage, 18710,
     /* 2182276 */     GIR_EraseRootFromParent_Done,
     /* 2182277 */   // Label 28720: @2182277
     /* 2182277 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2182368), // Rule ID 18711 //
     /* 2182282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2182299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182328 */     // MIs[0] round
     /* 2182328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182331 */     // MIs[0] policy
     /* 2182331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2182344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182367 */     // GIR_Coverage, 18711,
     /* 2182367 */     GIR_EraseRootFromParent_Done,
     /* 2182368 */   // Label 28721: @2182368
     /* 2182368 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2182459), // Rule ID 18714 //
     /* 2182373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2182390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2182393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182419 */     // MIs[0] round
     /* 2182419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182422 */     // MIs[0] policy
     /* 2182422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182432 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2182435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182458 */     // GIR_Coverage, 18714,
     /* 2182458 */     GIR_EraseRootFromParent_Done,
     /* 2182459 */   // Label 28722: @2182459
     /* 2182459 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2182550), // Rule ID 18715 //
     /* 2182464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2182481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2182484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182510 */     // MIs[0] round
     /* 2182510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182513 */     // MIs[0] policy
     /* 2182513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182523 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2182526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182549 */     // GIR_Coverage, 18715,
     /* 2182549 */     GIR_EraseRootFromParent_Done,
     /* 2182550 */   // Label 28723: @2182550
     /* 2182550 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2182641), // Rule ID 18718 //
     /* 2182555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2182572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182601 */     // MIs[0] round
     /* 2182601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182604 */     // MIs[0] policy
     /* 2182604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2182617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182640 */     // GIR_Coverage, 18718,
     /* 2182640 */     GIR_EraseRootFromParent_Done,
     /* 2182641 */   // Label 28724: @2182641
     /* 2182641 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2182732), // Rule ID 18719 //
     /* 2182646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2182663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2182666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182692 */     // MIs[0] round
     /* 2182692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182695 */     // MIs[0] policy
     /* 2182695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182705 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2182708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182731 */     // GIR_Coverage, 18719,
     /* 2182731 */     GIR_EraseRootFromParent_Done,
     /* 2182732 */   // Label 28725: @2182732
     /* 2182732 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2182823), // Rule ID 18722 //
     /* 2182737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2182754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182783 */     // MIs[0] round
     /* 2182783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182786 */     // MIs[0] policy
     /* 2182786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182796 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2182799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182822 */     // GIR_Coverage, 18722,
     /* 2182822 */     GIR_EraseRootFromParent_Done,
     /* 2182823 */   // Label 28726: @2182823
     /* 2182823 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2182914), // Rule ID 18723 //
     /* 2182828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2182845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182874 */     // MIs[0] round
     /* 2182874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182877 */     // MIs[0] policy
     /* 2182877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182887 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2182890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182913 */     // GIR_Coverage, 18723,
     /* 2182913 */     GIR_EraseRootFromParent_Done,
     /* 2182914 */   // Label 28727: @2182914
     /* 2182914 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2183005), // Rule ID 18726 //
     /* 2182919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2182922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2182927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2182930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2182933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2182936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2182939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182965 */     // MIs[0] round
     /* 2182965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182968 */     // MIs[0] policy
     /* 2182968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182978 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2182981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183004 */     // GIR_Coverage, 18726,
     /* 2183004 */     GIR_EraseRootFromParent_Done,
     /* 2183005 */   // Label 28728: @2183005
     /* 2183005 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2183096), // Rule ID 18727 //
     /* 2183010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2183021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2183024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2183027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183056 */     // MIs[0] round
     /* 2183056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183059 */     // MIs[0] policy
     /* 2183059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183069 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2183072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183095 */     // GIR_Coverage, 18727,
     /* 2183095 */     GIR_EraseRootFromParent_Done,
     /* 2183096 */   // Label 28729: @2183096
     /* 2183096 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2183187), // Rule ID 18730 //
     /* 2183101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2183118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2183121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183147 */     // MIs[0] round
     /* 2183147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183150 */     // MIs[0] policy
     /* 2183150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183160 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2183163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183186 */     // GIR_Coverage, 18730,
     /* 2183186 */     GIR_EraseRootFromParent_Done,
     /* 2183187 */   // Label 28730: @2183187
     /* 2183187 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2183278), // Rule ID 18731 //
     /* 2183192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2183209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2183212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183238 */     // MIs[0] round
     /* 2183238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183241 */     // MIs[0] policy
     /* 2183241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183251 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2183254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183277 */     // GIR_Coverage, 18731,
     /* 2183277 */     GIR_EraseRootFromParent_Done,
     /* 2183278 */   // Label 28731: @2183278
     /* 2183278 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2183369), // Rule ID 18734 //
     /* 2183283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2183300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183329 */     // MIs[0] round
     /* 2183329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183332 */     // MIs[0] policy
     /* 2183332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183342 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2183345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183368 */     // GIR_Coverage, 18734,
     /* 2183368 */     GIR_EraseRootFromParent_Done,
     /* 2183369 */   // Label 28732: @2183369
     /* 2183369 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2183460), // Rule ID 18735 //
     /* 2183374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2183391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183420 */     // MIs[0] round
     /* 2183420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183423 */     // MIs[0] policy
     /* 2183423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183433 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2183436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183459 */     // GIR_Coverage, 18735,
     /* 2183459 */     GIR_EraseRootFromParent_Done,
     /* 2183460 */   // Label 28733: @2183460
     /* 2183460 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2183551), // Rule ID 18738 //
     /* 2183465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2183482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183511 */     // MIs[0] round
     /* 2183511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183514 */     // MIs[0] policy
     /* 2183514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183524 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2183527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183550 */     // GIR_Coverage, 18738,
     /* 2183550 */     GIR_EraseRootFromParent_Done,
     /* 2183551 */   // Label 28734: @2183551
     /* 2183551 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2183642), // Rule ID 18739 //
     /* 2183556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2183573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2183576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183602 */     // MIs[0] round
     /* 2183602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183605 */     // MIs[0] policy
     /* 2183605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183615 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2183618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183641 */     // GIR_Coverage, 18739,
     /* 2183641 */     GIR_EraseRootFromParent_Done,
     /* 2183642 */   // Label 28735: @2183642
     /* 2183642 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2183733), // Rule ID 18742 //
     /* 2183647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2183650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183693 */     // MIs[0] round
     /* 2183693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183696 */     // MIs[0] policy
     /* 2183696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2183709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183732 */     // GIR_Coverage, 18742,
     /* 2183732 */     GIR_EraseRootFromParent_Done,
     /* 2183733 */   // Label 28736: @2183733
     /* 2183733 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2183824), // Rule ID 18743 //
     /* 2183738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2183741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183784 */     // MIs[0] round
     /* 2183784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183787 */     // MIs[0] policy
     /* 2183787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183797 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2183800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183823 */     // GIR_Coverage, 18743,
     /* 2183823 */     GIR_EraseRootFromParent_Done,
     /* 2183824 */   // Label 28737: @2183824
     /* 2183824 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2183915), // Rule ID 18746 //
     /* 2183829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2183832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2183840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2183843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183875 */     // MIs[0] round
     /* 2183875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183878 */     // MIs[0] policy
     /* 2183878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183888 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2183891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183914 */     // GIR_Coverage, 18746,
     /* 2183914 */     GIR_EraseRootFromParent_Done,
     /* 2183915 */   // Label 28738: @2183915
     /* 2183915 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2184006), // Rule ID 18747 //
     /* 2183920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2183923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2183928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2183931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2183934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183966 */     // MIs[0] round
     /* 2183966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183969 */     // MIs[0] policy
     /* 2183969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183979 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2183982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184005 */     // GIR_Coverage, 18747,
     /* 2184005 */     GIR_EraseRootFromParent_Done,
     /* 2184006 */   // Label 28739: @2184006
     /* 2184006 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2184097), // Rule ID 18750 //
     /* 2184011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2184022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2184025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184057 */     // MIs[0] round
     /* 2184057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184060 */     // MIs[0] policy
     /* 2184060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2184073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184096 */     // GIR_Coverage, 18750,
     /* 2184096 */     GIR_EraseRootFromParent_Done,
     /* 2184097 */   // Label 28740: @2184097
     /* 2184097 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2184188), // Rule ID 18751 //
     /* 2184102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2184113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2184116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184148 */     // MIs[0] round
     /* 2184148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184151 */     // MIs[0] policy
     /* 2184151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184161 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2184164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184187 */     // GIR_Coverage, 18751,
     /* 2184187 */     GIR_EraseRootFromParent_Done,
     /* 2184188 */   // Label 28741: @2184188
     /* 2184188 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2184279), // Rule ID 18754 //
     /* 2184193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2184204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2184207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184239 */     // MIs[0] round
     /* 2184239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184242 */     // MIs[0] policy
     /* 2184242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2184255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184278 */     // GIR_Coverage, 18754,
     /* 2184278 */     GIR_EraseRootFromParent_Done,
     /* 2184279 */   // Label 28742: @2184279
     /* 2184279 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2184370), // Rule ID 18755 //
     /* 2184284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2184295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2184298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184330 */     // MIs[0] round
     /* 2184330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184333 */     // MIs[0] policy
     /* 2184333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184343 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2184346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184369 */     // GIR_Coverage, 18755,
     /* 2184369 */     GIR_EraseRootFromParent_Done,
     /* 2184370 */   // Label 28743: @2184370
     /* 2184370 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2184461), // Rule ID 18758 //
     /* 2184375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2184386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2184389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184421 */     // MIs[0] round
     /* 2184421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184424 */     // MIs[0] policy
     /* 2184424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184434 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2184437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184460 */     // GIR_Coverage, 18758,
     /* 2184460 */     GIR_EraseRootFromParent_Done,
     /* 2184461 */   // Label 28744: @2184461
     /* 2184461 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2184552), // Rule ID 18759 //
     /* 2184466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2184477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2184480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2184483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2184504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184512 */     // MIs[0] round
     /* 2184512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184515 */     // MIs[0] policy
     /* 2184515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2184528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184551 */     // GIR_Coverage, 18759,
     /* 2184551 */     GIR_EraseRootFromParent_Done,
     /* 2184552 */   // Label 28745: @2184552
     /* 2184552 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2184643), // Rule ID 18762 //
     /* 2184557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2184560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184603 */     // MIs[0] round
     /* 2184603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184606 */     // MIs[0] policy
     /* 2184606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184616 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2184619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184642 */     // GIR_Coverage, 18762,
     /* 2184642 */     GIR_EraseRootFromParent_Done,
     /* 2184643 */   // Label 28746: @2184643
     /* 2184643 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2184734), // Rule ID 18763 //
     /* 2184648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2184651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2184668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184694 */     // MIs[0] round
     /* 2184694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184697 */     // MIs[0] policy
     /* 2184697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184707 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2184710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184733 */     // GIR_Coverage, 18763,
     /* 2184733 */     GIR_EraseRootFromParent_Done,
     /* 2184734 */   // Label 28747: @2184734
     /* 2184734 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2184825), // Rule ID 18766 //
     /* 2184739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2184742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2184750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2184753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184785 */     // MIs[0] round
     /* 2184785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184788 */     // MIs[0] policy
     /* 2184788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2184801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184824 */     // GIR_Coverage, 18766,
     /* 2184824 */     GIR_EraseRootFromParent_Done,
     /* 2184825 */   // Label 28748: @2184825
     /* 2184825 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2184916), // Rule ID 18767 //
     /* 2184830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2184833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2184841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2184844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184876 */     // MIs[0] round
     /* 2184876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184879 */     // MIs[0] policy
     /* 2184879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184889 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2184892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184915 */     // GIR_Coverage, 18767,
     /* 2184915 */     GIR_EraseRootFromParent_Done,
     /* 2184916 */   // Label 28749: @2184916
     /* 2184916 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2185007), // Rule ID 18770 //
     /* 2184921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2184924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2184929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2184932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2184935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2184941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184967 */     // MIs[0] round
     /* 2184967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184970 */     // MIs[0] policy
     /* 2184970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184980 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2184983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185006 */     // GIR_Coverage, 18770,
     /* 2185006 */     GIR_EraseRootFromParent_Done,
     /* 2185007 */   // Label 28750: @2185007
     /* 2185007 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2185098), // Rule ID 18771 //
     /* 2185012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2185020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185058 */     // MIs[0] round
     /* 2185058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185061 */     // MIs[0] policy
     /* 2185061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185071 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2185074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185097 */     // GIR_Coverage, 18771,
     /* 2185097 */     GIR_EraseRootFromParent_Done,
     /* 2185098 */   // Label 28751: @2185098
     /* 2185098 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2185189), // Rule ID 18774 //
     /* 2185103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2185106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2185111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185149 */     // MIs[0] round
     /* 2185149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185152 */     // MIs[0] policy
     /* 2185152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185162 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2185165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185188 */     // GIR_Coverage, 18774,
     /* 2185188 */     GIR_EraseRootFromParent_Done,
     /* 2185189 */   // Label 28752: @2185189
     /* 2185189 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2185280), // Rule ID 18775 //
     /* 2185194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2185202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2185211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2185232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185240 */     // MIs[0] round
     /* 2185240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185243 */     // MIs[0] policy
     /* 2185243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185253 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2185256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185279 */     // GIR_Coverage, 18775,
     /* 2185279 */     GIR_EraseRootFromParent_Done,
     /* 2185280 */   // Label 28753: @2185280
     /* 2185280 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2185371), // Rule ID 18778 //
     /* 2185285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2185288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2185296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2185299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2185302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2185305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185331 */     // MIs[0] round
     /* 2185331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185334 */     // MIs[0] policy
     /* 2185334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185344 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2185347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185370 */     // GIR_Coverage, 18778,
     /* 2185370 */     GIR_EraseRootFromParent_Done,
     /* 2185371 */   // Label 28754: @2185371
     /* 2185371 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2185462), // Rule ID 18779 //
     /* 2185376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2185387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2185390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2185393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2185396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185422 */     // MIs[0] round
     /* 2185422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185425 */     // MIs[0] policy
     /* 2185425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185435 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2185438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185461 */     // GIR_Coverage, 18779,
     /* 2185461 */     GIR_EraseRootFromParent_Done,
     /* 2185462 */   // Label 28755: @2185462
     /* 2185462 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2185553), // Rule ID 18782 //
     /* 2185467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2185470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2185478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2185481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2185484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2185487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185513 */     // MIs[0] round
     /* 2185513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185516 */     // MIs[0] policy
     /* 2185516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185526 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2185529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185552 */     // GIR_Coverage, 18782,
     /* 2185552 */     GIR_EraseRootFromParent_Done,
     /* 2185553 */   // Label 28756: @2185553
     /* 2185553 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2185644), // Rule ID 18783 //
     /* 2185558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2185569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2185572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2185575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2185578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185604 */     // MIs[0] round
     /* 2185604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185607 */     // MIs[0] policy
     /* 2185607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185617 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2185620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185643 */     // GIR_Coverage, 18783,
     /* 2185643 */     GIR_EraseRootFromParent_Done,
     /* 2185644 */   // Label 28757: @2185644
     /* 2185644 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2185735), // Rule ID 18786 //
     /* 2185649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2185652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2185666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2185669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185695 */     // MIs[0] round
     /* 2185695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185698 */     // MIs[0] policy
     /* 2185698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185708 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2185711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185734 */     // GIR_Coverage, 18786,
     /* 2185734 */     GIR_EraseRootFromParent_Done,
     /* 2185735 */   // Label 28758: @2185735
     /* 2185735 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2185826), // Rule ID 18787 //
     /* 2185740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2185757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2185760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185786 */     // MIs[0] round
     /* 2185786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185789 */     // MIs[0] policy
     /* 2185789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185799 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2185802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185825 */     // GIR_Coverage, 18787,
     /* 2185825 */     GIR_EraseRootFromParent_Done,
     /* 2185826 */   // Label 28759: @2185826
     /* 2185826 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2185917), // Rule ID 18790 //
     /* 2185831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2185834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185877 */     // MIs[0] round
     /* 2185877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185880 */     // MIs[0] policy
     /* 2185880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185890 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2185893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185916 */     // GIR_Coverage, 18790,
     /* 2185916 */     GIR_EraseRootFromParent_Done,
     /* 2185917 */   // Label 28760: @2185917
     /* 2185917 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2186008), // Rule ID 18791 //
     /* 2185922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2185930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2185939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2185942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185968 */     // MIs[0] round
     /* 2185968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185971 */     // MIs[0] policy
     /* 2185971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185981 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2185984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186007 */     // GIR_Coverage, 18791,
     /* 2186007 */     GIR_EraseRootFromParent_Done,
     /* 2186008 */   // Label 28761: @2186008
     /* 2186008 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2186099), // Rule ID 18794 //
     /* 2186013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2186030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2186033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186059 */     // MIs[0] round
     /* 2186059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186062 */     // MIs[0] policy
     /* 2186062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186072 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2186075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186098 */     // GIR_Coverage, 18794,
     /* 2186098 */     GIR_EraseRootFromParent_Done,
     /* 2186099 */   // Label 28762: @2186099
     /* 2186099 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2186190), // Rule ID 18795 //
     /* 2186104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2186107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2186121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2186124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186150 */     // MIs[0] round
     /* 2186150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186153 */     // MIs[0] policy
     /* 2186153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186163 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2186166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186189 */     // GIR_Coverage, 18795,
     /* 2186189 */     GIR_EraseRootFromParent_Done,
     /* 2186190 */   // Label 28763: @2186190
     /* 2186190 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2186281), // Rule ID 18798 //
     /* 2186195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2186206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2186209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2186212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186241 */     // MIs[0] round
     /* 2186241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186244 */     // MIs[0] policy
     /* 2186244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186254 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2186257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186280 */     // GIR_Coverage, 18798,
     /* 2186280 */     GIR_EraseRootFromParent_Done,
     /* 2186281 */   // Label 28764: @2186281
     /* 2186281 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2186372), // Rule ID 18799 //
     /* 2186286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2186289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2186297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2186300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2186303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186332 */     // MIs[0] round
     /* 2186332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186335 */     // MIs[0] policy
     /* 2186335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186345 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2186348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186371 */     // GIR_Coverage, 18799,
     /* 2186371 */     GIR_EraseRootFromParent_Done,
     /* 2186372 */   // Label 28765: @2186372
     /* 2186372 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2186463), // Rule ID 18802 //
     /* 2186377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2186394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186423 */     // MIs[0] round
     /* 2186423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186426 */     // MIs[0] policy
     /* 2186426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2186439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186462 */     // GIR_Coverage, 18802,
     /* 2186462 */     GIR_EraseRootFromParent_Done,
     /* 2186463 */   // Label 28766: @2186463
     /* 2186463 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2186554), // Rule ID 18803 //
     /* 2186468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2186471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2186485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186514 */     // MIs[0] round
     /* 2186514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186517 */     // MIs[0] policy
     /* 2186517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2186530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186553 */     // GIR_Coverage, 18803,
     /* 2186553 */     GIR_EraseRootFromParent_Done,
     /* 2186554 */   // Label 28767: @2186554
     /* 2186554 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2186645), // Rule ID 18806 //
     /* 2186559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2186576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2186579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186605 */     // MIs[0] round
     /* 2186605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186608 */     // MIs[0] policy
     /* 2186608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2186621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186644 */     // GIR_Coverage, 18806,
     /* 2186644 */     GIR_EraseRootFromParent_Done,
     /* 2186645 */   // Label 28768: @2186645
     /* 2186645 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2186736), // Rule ID 18807 //
     /* 2186650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2186653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2186661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2186664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2186667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2186670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186696 */     // MIs[0] round
     /* 2186696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186699 */     // MIs[0] policy
     /* 2186699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186709 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2186712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186735 */     // GIR_Coverage, 18807,
     /* 2186735 */     GIR_EraseRootFromParent_Done,
     /* 2186736 */   // Label 28769: @2186736
     /* 2186736 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2186827), // Rule ID 18810 //
     /* 2186741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2186758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2186761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186787 */     // MIs[0] round
     /* 2186787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186790 */     // MIs[0] policy
     /* 2186790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186800 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2186803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186826 */     // GIR_Coverage, 18810,
     /* 2186826 */     GIR_EraseRootFromParent_Done,
     /* 2186827 */   // Label 28770: @2186827
     /* 2186827 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2186918), // Rule ID 18811 //
     /* 2186832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2186835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2186849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2186852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186878 */     // MIs[0] round
     /* 2186878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186881 */     // MIs[0] policy
     /* 2186881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186891 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2186894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186917 */     // GIR_Coverage, 18811,
     /* 2186917 */     GIR_EraseRootFromParent_Done,
     /* 2186918 */   // Label 28771: @2186918
     /* 2186918 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2187009), // Rule ID 18814 //
     /* 2186923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2186931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186969 */     // MIs[0] round
     /* 2186969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186972 */     // MIs[0] policy
     /* 2186972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186982 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2186985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187008 */     // GIR_Coverage, 18814,
     /* 2187008 */     GIR_EraseRootFromParent_Done,
     /* 2187009 */   // Label 28772: @2187009
     /* 2187009 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2187100), // Rule ID 18815 //
     /* 2187014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2187034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187060 */     // MIs[0] round
     /* 2187060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187063 */     // MIs[0] policy
     /* 2187063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187073 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2187076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187099 */     // GIR_Coverage, 18815,
     /* 2187099 */     GIR_EraseRootFromParent_Done,
     /* 2187100 */   // Label 28773: @2187100
     /* 2187100 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2187191), // Rule ID 18818 //
     /* 2187105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187151 */     // MIs[0] round
     /* 2187151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187154 */     // MIs[0] policy
     /* 2187154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187164 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2187167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187190 */     // GIR_Coverage, 18818,
     /* 2187190 */     GIR_EraseRootFromParent_Done,
     /* 2187191 */   // Label 28774: @2187191
     /* 2187191 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2187282), // Rule ID 18819 //
     /* 2187196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187242 */     // MIs[0] round
     /* 2187242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187245 */     // MIs[0] policy
     /* 2187245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187255 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2187258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187281 */     // GIR_Coverage, 18819,
     /* 2187281 */     GIR_EraseRootFromParent_Done,
     /* 2187282 */   // Label 28775: @2187282
     /* 2187282 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2187373), // Rule ID 18822 //
     /* 2187287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187333 */     // MIs[0] round
     /* 2187333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187336 */     // MIs[0] policy
     /* 2187336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187346 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2187349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187372 */     // GIR_Coverage, 18822,
     /* 2187372 */     GIR_EraseRootFromParent_Done,
     /* 2187373 */   // Label 28776: @2187373
     /* 2187373 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2187464), // Rule ID 18823 //
     /* 2187378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187424 */     // MIs[0] round
     /* 2187424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187427 */     // MIs[0] policy
     /* 2187427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2187440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187463 */     // GIR_Coverage, 18823,
     /* 2187463 */     GIR_EraseRootFromParent_Done,
     /* 2187464 */   // Label 28777: @2187464
     /* 2187464 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2187555), // Rule ID 18826 //
     /* 2187469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2187480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2187483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187515 */     // MIs[0] round
     /* 2187515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187518 */     // MIs[0] policy
     /* 2187518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187528 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2187531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187554 */     // GIR_Coverage, 18826,
     /* 2187554 */     GIR_EraseRootFromParent_Done,
     /* 2187555 */   // Label 28778: @2187555
     /* 2187555 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2187646), // Rule ID 18827 //
     /* 2187560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2187571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2187574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187606 */     // MIs[0] round
     /* 2187606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187609 */     // MIs[0] policy
     /* 2187609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187619 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2187622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187645 */     // GIR_Coverage, 18827,
     /* 2187645 */     GIR_EraseRootFromParent_Done,
     /* 2187646 */   // Label 28779: @2187646
     /* 2187646 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2187737), // Rule ID 18830 //
     /* 2187651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2187662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2187665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187697 */     // MIs[0] round
     /* 2187697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187700 */     // MIs[0] policy
     /* 2187700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187710 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2187713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187736 */     // GIR_Coverage, 18830,
     /* 2187736 */     GIR_EraseRootFromParent_Done,
     /* 2187737 */   // Label 28780: @2187737
     /* 2187737 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2187828), // Rule ID 18831 //
     /* 2187742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2187753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2187756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187788 */     // MIs[0] round
     /* 2187788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187791 */     // MIs[0] policy
     /* 2187791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187801 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2187804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187827 */     // GIR_Coverage, 18831,
     /* 2187827 */     GIR_EraseRootFromParent_Done,
     /* 2187828 */   // Label 28781: @2187828
     /* 2187828 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2187919), // Rule ID 18834 //
     /* 2187833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2187836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187879 */     // MIs[0] round
     /* 2187879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187882 */     // MIs[0] policy
     /* 2187882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187892 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2187895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187918 */     // GIR_Coverage, 18834,
     /* 2187918 */     GIR_EraseRootFromParent_Done,
     /* 2187919 */   // Label 28782: @2187919
     /* 2187919 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2188010), // Rule ID 18835 //
     /* 2187924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2187927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2187932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2187944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187970 */     // MIs[0] round
     /* 2187970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187973 */     // MIs[0] policy
     /* 2187973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187983 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2187986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188009 */     // GIR_Coverage, 18835,
     /* 2188009 */     GIR_EraseRootFromParent_Done,
     /* 2188010 */   // Label 28783: @2188010
     /* 2188010 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2188101), // Rule ID 18838 //
     /* 2188015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188061 */     // MIs[0] round
     /* 2188061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188064 */     // MIs[0] policy
     /* 2188064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2188077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188100 */     // GIR_Coverage, 18838,
     /* 2188100 */     GIR_EraseRootFromParent_Done,
     /* 2188101 */   // Label 28784: @2188101
     /* 2188101 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2188192), // Rule ID 18839 //
     /* 2188106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188152 */     // MIs[0] round
     /* 2188152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188155 */     // MIs[0] policy
     /* 2188155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188165 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2188168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188191 */     // GIR_Coverage, 18839,
     /* 2188191 */     GIR_EraseRootFromParent_Done,
     /* 2188192 */   // Label 28785: @2188192
     /* 2188192 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2188283), // Rule ID 18842 //
     /* 2188197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188243 */     // MIs[0] round
     /* 2188243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188246 */     // MIs[0] policy
     /* 2188246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188256 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2188259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188282 */     // GIR_Coverage, 18842,
     /* 2188282 */     GIR_EraseRootFromParent_Done,
     /* 2188283 */   // Label 28786: @2188283
     /* 2188283 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2188374), // Rule ID 18843 //
     /* 2188288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188334 */     // MIs[0] round
     /* 2188334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188337 */     // MIs[0] policy
     /* 2188337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188347 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2188350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188373 */     // GIR_Coverage, 18843,
     /* 2188373 */     GIR_EraseRootFromParent_Done,
     /* 2188374 */   // Label 28787: @2188374
     /* 2188374 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2188465), // Rule ID 18846 //
     /* 2188379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188425 */     // MIs[0] round
     /* 2188425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188428 */     // MIs[0] policy
     /* 2188428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188438 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2188441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188464 */     // GIR_Coverage, 18846,
     /* 2188464 */     GIR_EraseRootFromParent_Done,
     /* 2188465 */   // Label 28788: @2188465
     /* 2188465 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2188556), // Rule ID 18847 //
     /* 2188470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2188478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188516 */     // MIs[0] round
     /* 2188516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188519 */     // MIs[0] policy
     /* 2188519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188529 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2188532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188555 */     // GIR_Coverage, 18847,
     /* 2188555 */     GIR_EraseRootFromParent_Done,
     /* 2188556 */   // Label 28789: @2188556
     /* 2188556 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2188647), // Rule ID 18850 //
     /* 2188561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2188569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2188572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2188575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2188578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2188581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188607 */     // MIs[0] round
     /* 2188607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188610 */     // MIs[0] policy
     /* 2188610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2188623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188646 */     // GIR_Coverage, 18850,
     /* 2188646 */     GIR_EraseRootFromParent_Done,
     /* 2188647 */   // Label 28790: @2188647
     /* 2188647 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2188738), // Rule ID 18851 //
     /* 2188652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2188660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2188663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2188666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2188669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2188672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188698 */     // MIs[0] round
     /* 2188698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188701 */     // MIs[0] policy
     /* 2188701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188711 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2188714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188737 */     // GIR_Coverage, 18851,
     /* 2188737 */     GIR_EraseRootFromParent_Done,
     /* 2188738 */   // Label 28791: @2188738
     /* 2188738 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2188829), // Rule ID 18854 //
     /* 2188743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2188751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2188754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2188757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2188760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2188763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188789 */     // MIs[0] round
     /* 2188789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188792 */     // MIs[0] policy
     /* 2188792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188802 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2188805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188828 */     // GIR_Coverage, 18854,
     /* 2188828 */     GIR_EraseRootFromParent_Done,
     /* 2188829 */   // Label 28792: @2188829
     /* 2188829 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2188920), // Rule ID 18855 //
     /* 2188834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2188842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2188845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2188848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2188851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2188854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188880 */     // MIs[0] round
     /* 2188880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188883 */     // MIs[0] policy
     /* 2188883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188893 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2188896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188919 */     // GIR_Coverage, 18855,
     /* 2188919 */     GIR_EraseRootFromParent_Done,
     /* 2188920 */   // Label 28793: @2188920
     /* 2188920 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2189011), // Rule ID 18858 //
     /* 2188925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2188933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2188936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2188939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2188942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2188945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188971 */     // MIs[0] round
     /* 2188971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188974 */     // MIs[0] policy
     /* 2188974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2188987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189010 */     // GIR_Coverage, 18858,
     /* 2189010 */     GIR_EraseRootFromParent_Done,
     /* 2189011 */   // Label 28794: @2189011
     /* 2189011 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2189102), // Rule ID 18859 //
     /* 2189016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189062 */     // MIs[0] round
     /* 2189062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189065 */     // MIs[0] policy
     /* 2189065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189075 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2189078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189101 */     // GIR_Coverage, 18859,
     /* 2189101 */     GIR_EraseRootFromParent_Done,
     /* 2189102 */   // Label 28795: @2189102
     /* 2189102 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2189193), // Rule ID 18862 //
     /* 2189107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189153 */     // MIs[0] round
     /* 2189153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189156 */     // MIs[0] policy
     /* 2189156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189166 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2189169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189192 */     // GIR_Coverage, 18862,
     /* 2189192 */     GIR_EraseRootFromParent_Done,
     /* 2189193 */   // Label 28796: @2189193
     /* 2189193 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2189284), // Rule ID 18863 //
     /* 2189198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189244 */     // MIs[0] round
     /* 2189244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189247 */     // MIs[0] policy
     /* 2189247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189257 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2189260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189283 */     // GIR_Coverage, 18863,
     /* 2189283 */     GIR_EraseRootFromParent_Done,
     /* 2189284 */   // Label 28797: @2189284
     /* 2189284 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2189375), // Rule ID 18866 //
     /* 2189289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189335 */     // MIs[0] round
     /* 2189335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189338 */     // MIs[0] policy
     /* 2189338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189348 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2189351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189374 */     // GIR_Coverage, 18866,
     /* 2189374 */     GIR_EraseRootFromParent_Done,
     /* 2189375 */   // Label 28798: @2189375
     /* 2189375 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2189466), // Rule ID 18867 //
     /* 2189380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189426 */     // MIs[0] round
     /* 2189426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189429 */     // MIs[0] policy
     /* 2189429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189439 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2189442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189465 */     // GIR_Coverage, 18867,
     /* 2189465 */     GIR_EraseRootFromParent_Done,
     /* 2189466 */   // Label 28799: @2189466
     /* 2189466 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2189557), // Rule ID 18870 //
     /* 2189471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189517 */     // MIs[0] round
     /* 2189517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189520 */     // MIs[0] policy
     /* 2189520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2189533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189556 */     // GIR_Coverage, 18870,
     /* 2189556 */     GIR_EraseRootFromParent_Done,
     /* 2189557 */   // Label 28800: @2189557
     /* 2189557 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2189648), // Rule ID 18871 //
     /* 2189562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189608 */     // MIs[0] round
     /* 2189608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189611 */     // MIs[0] policy
     /* 2189611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189621 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2189624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189647 */     // GIR_Coverage, 18871,
     /* 2189647 */     GIR_EraseRootFromParent_Done,
     /* 2189648 */   // Label 28801: @2189648
     /* 2189648 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2189739), // Rule ID 18874 //
     /* 2189653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2189664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2189667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2189670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2189673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189699 */     // MIs[0] round
     /* 2189699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189702 */     // MIs[0] policy
     /* 2189702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2189715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189738 */     // GIR_Coverage, 18874,
     /* 2189738 */     GIR_EraseRootFromParent_Done,
     /* 2189739 */   // Label 28802: @2189739
     /* 2189739 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2189830), // Rule ID 18875 //
     /* 2189744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2189755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2189758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2189761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2189764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189790 */     // MIs[0] round
     /* 2189790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189793 */     // MIs[0] policy
     /* 2189793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189803 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2189806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189829 */     // GIR_Coverage, 18875,
     /* 2189829 */     GIR_EraseRootFromParent_Done,
     /* 2189830 */   // Label 28803: @2189830
     /* 2189830 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2189921), // Rule ID 18878 //
     /* 2189835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2189852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2189855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189881 */     // MIs[0] round
     /* 2189881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189884 */     // MIs[0] policy
     /* 2189884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189894 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2189897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189920 */     // GIR_Coverage, 18878,
     /* 2189920 */     GIR_EraseRootFromParent_Done,
     /* 2189921 */   // Label 28804: @2189921
     /* 2189921 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2190012), // Rule ID 18879 //
     /* 2189926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2189934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2189937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2189940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2189943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2189946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189972 */     // MIs[0] round
     /* 2189972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189975 */     // MIs[0] policy
     /* 2189975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189985 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2189988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190011 */     // GIR_Coverage, 18879,
     /* 2190011 */     GIR_EraseRootFromParent_Done,
     /* 2190012 */   // Label 28805: @2190012
     /* 2190012 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2190103), // Rule ID 18882 //
     /* 2190017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190063 */     // MIs[0] round
     /* 2190063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190066 */     // MIs[0] policy
     /* 2190066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190076 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2190079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190102 */     // GIR_Coverage, 18882,
     /* 2190102 */     GIR_EraseRootFromParent_Done,
     /* 2190103 */   // Label 28806: @2190103
     /* 2190103 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2190194), // Rule ID 18883 //
     /* 2190108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190154 */     // MIs[0] round
     /* 2190154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190157 */     // MIs[0] policy
     /* 2190157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190167 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2190170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190193 */     // GIR_Coverage, 18883,
     /* 2190193 */     GIR_EraseRootFromParent_Done,
     /* 2190194 */   // Label 28807: @2190194
     /* 2190194 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2190285), // Rule ID 18886 //
     /* 2190199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190245 */     // MIs[0] round
     /* 2190245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190248 */     // MIs[0] policy
     /* 2190248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190258 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2190261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190284 */     // GIR_Coverage, 18886,
     /* 2190284 */     GIR_EraseRootFromParent_Done,
     /* 2190285 */   // Label 28808: @2190285
     /* 2190285 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2190376), // Rule ID 18887 //
     /* 2190290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190336 */     // MIs[0] round
     /* 2190336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190339 */     // MIs[0] policy
     /* 2190339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190349 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2190352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190375 */     // GIR_Coverage, 18887,
     /* 2190375 */     GIR_EraseRootFromParent_Done,
     /* 2190376 */   // Label 28809: @2190376
     /* 2190376 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2190467), // Rule ID 18890 //
     /* 2190381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190427 */     // MIs[0] round
     /* 2190427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190430 */     // MIs[0] policy
     /* 2190430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190440 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2190443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190466 */     // GIR_Coverage, 18890,
     /* 2190466 */     GIR_EraseRootFromParent_Done,
     /* 2190467 */   // Label 28810: @2190467
     /* 2190467 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2190558), // Rule ID 18891 //
     /* 2190472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190518 */     // MIs[0] round
     /* 2190518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190521 */     // MIs[0] policy
     /* 2190521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190531 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2190534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190557 */     // GIR_Coverage, 18891,
     /* 2190557 */     GIR_EraseRootFromParent_Done,
     /* 2190558 */   // Label 28811: @2190558
     /* 2190558 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2190649), // Rule ID 18894 //
     /* 2190563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2190574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2190577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190609 */     // MIs[0] round
     /* 2190609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190612 */     // MIs[0] policy
     /* 2190612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2190625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190648 */     // GIR_Coverage, 18894,
     /* 2190648 */     GIR_EraseRootFromParent_Done,
     /* 2190649 */   // Label 28812: @2190649
     /* 2190649 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2190740), // Rule ID 18895 //
     /* 2190654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2190665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2190668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190700 */     // MIs[0] round
     /* 2190700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190703 */     // MIs[0] policy
     /* 2190703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190713 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2190716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190739 */     // GIR_Coverage, 18895,
     /* 2190739 */     GIR_EraseRootFromParent_Done,
     /* 2190740 */   // Label 28813: @2190740
     /* 2190740 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2190831), // Rule ID 18898 //
     /* 2190745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2190756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2190759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2190765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190791 */     // MIs[0] round
     /* 2190791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190794 */     // MIs[0] policy
     /* 2190794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2190807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190830 */     // GIR_Coverage, 18898,
     /* 2190830 */     GIR_EraseRootFromParent_Done,
     /* 2190831 */   // Label 28814: @2190831
     /* 2190831 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2190922), // Rule ID 18899 //
     /* 2190836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2190847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2190850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2190856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190882 */     // MIs[0] round
     /* 2190882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190885 */     // MIs[0] policy
     /* 2190885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190895 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2190898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190921 */     // GIR_Coverage, 18899,
     /* 2190921 */     GIR_EraseRootFromParent_Done,
     /* 2190922 */   // Label 28815: @2190922
     /* 2190922 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2191013), // Rule ID 18902 //
     /* 2190927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2190935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2190938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2190941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2190947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2190950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190973 */     // MIs[0] round
     /* 2190973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190976 */     // MIs[0] policy
     /* 2190976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190986 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2190989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191012 */     // GIR_Coverage, 18902,
     /* 2191012 */     GIR_EraseRootFromParent_Done,
     /* 2191013 */   // Label 28816: @2191013
     /* 2191013 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2191104), // Rule ID 18903 //
     /* 2191018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191064 */     // MIs[0] round
     /* 2191064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191067 */     // MIs[0] policy
     /* 2191067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191077 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2191080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191103 */     // GIR_Coverage, 18903,
     /* 2191103 */     GIR_EraseRootFromParent_Done,
     /* 2191104 */   // Label 28817: @2191104
     /* 2191104 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2191195), // Rule ID 18906 //
     /* 2191109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191155 */     // MIs[0] round
     /* 2191155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191158 */     // MIs[0] policy
     /* 2191158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191168 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2191171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191194 */     // GIR_Coverage, 18906,
     /* 2191194 */     GIR_EraseRootFromParent_Done,
     /* 2191195 */   // Label 28818: @2191195
     /* 2191195 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2191286), // Rule ID 18907 //
     /* 2191200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191246 */     // MIs[0] round
     /* 2191246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191249 */     // MIs[0] policy
     /* 2191249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191259 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2191262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191285 */     // GIR_Coverage, 18907,
     /* 2191285 */     GIR_EraseRootFromParent_Done,
     /* 2191286 */   // Label 28819: @2191286
     /* 2191286 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2191377), // Rule ID 18910 //
     /* 2191291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191337 */     // MIs[0] round
     /* 2191337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191340 */     // MIs[0] policy
     /* 2191340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2191353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191376 */     // GIR_Coverage, 18910,
     /* 2191376 */     GIR_EraseRootFromParent_Done,
     /* 2191377 */   // Label 28820: @2191377
     /* 2191377 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2191468), // Rule ID 18911 //
     /* 2191382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191428 */     // MIs[0] round
     /* 2191428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191431 */     // MIs[0] policy
     /* 2191431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191441 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2191444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191467 */     // GIR_Coverage, 18911,
     /* 2191467 */     GIR_EraseRootFromParent_Done,
     /* 2191468 */   // Label 28821: @2191468
     /* 2191468 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2191559), // Rule ID 18914 //
     /* 2191473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191519 */     // MIs[0] round
     /* 2191519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191522 */     // MIs[0] policy
     /* 2191522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191532 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2191535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191558 */     // GIR_Coverage, 18914,
     /* 2191558 */     GIR_EraseRootFromParent_Done,
     /* 2191559 */   // Label 28822: @2191559
     /* 2191559 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2191650), // Rule ID 18915 //
     /* 2191564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191610 */     // MIs[0] round
     /* 2191610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191613 */     // MIs[0] policy
     /* 2191613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191623 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2191626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191649 */     // GIR_Coverage, 18915,
     /* 2191649 */     GIR_EraseRootFromParent_Done,
     /* 2191650 */   // Label 28823: @2191650
     /* 2191650 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2191741), // Rule ID 18918 //
     /* 2191655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2191666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2191669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2191675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191701 */     // MIs[0] round
     /* 2191701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191704 */     // MIs[0] policy
     /* 2191704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191714 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2191717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191740 */     // GIR_Coverage, 18918,
     /* 2191740 */     GIR_EraseRootFromParent_Done,
     /* 2191741 */   // Label 28824: @2191741
     /* 2191741 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2191832), // Rule ID 18919 //
     /* 2191746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2191754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2191757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2191760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2191766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191792 */     // MIs[0] round
     /* 2191792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191795 */     // MIs[0] policy
     /* 2191795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191805 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2191808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191831 */     // GIR_Coverage, 18919,
     /* 2191831 */     GIR_EraseRootFromParent_Done,
     /* 2191832 */   // Label 28825: @2191832
     /* 2191832 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2191923), // Rule ID 18922 //
     /* 2191837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2191845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2191854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191883 */     // MIs[0] round
     /* 2191883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191886 */     // MIs[0] policy
     /* 2191886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2191899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191922 */     // GIR_Coverage, 18922,
     /* 2191922 */     GIR_EraseRootFromParent_Done,
     /* 2191923 */   // Label 28826: @2191923
     /* 2191923 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2192014), // Rule ID 18923 //
     /* 2191928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2191936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2191939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2191942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2191945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2191948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191974 */     // MIs[0] round
     /* 2191974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191977 */     // MIs[0] policy
     /* 2191977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191987 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2191990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192013 */     // GIR_Coverage, 18923,
     /* 2192013 */     GIR_EraseRootFromParent_Done,
     /* 2192014 */   // Label 28827: @2192014
     /* 2192014 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2192105), // Rule ID 18926 //
     /* 2192019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192065 */     // MIs[0] round
     /* 2192065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192068 */     // MIs[0] policy
     /* 2192068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2192081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192104 */     // GIR_Coverage, 18926,
     /* 2192104 */     GIR_EraseRootFromParent_Done,
     /* 2192105 */   // Label 28828: @2192105
     /* 2192105 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2192196), // Rule ID 18927 //
     /* 2192110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192156 */     // MIs[0] round
     /* 2192156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192159 */     // MIs[0] policy
     /* 2192159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192169 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2192172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192195 */     // GIR_Coverage, 18927,
     /* 2192195 */     GIR_EraseRootFromParent_Done,
     /* 2192196 */   // Label 28829: @2192196
     /* 2192196 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2192287), // Rule ID 18930 //
     /* 2192201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192247 */     // MIs[0] round
     /* 2192247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192250 */     // MIs[0] policy
     /* 2192250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2192263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192286 */     // GIR_Coverage, 18930,
     /* 2192286 */     GIR_EraseRootFromParent_Done,
     /* 2192287 */   // Label 28830: @2192287
     /* 2192287 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2192378), // Rule ID 18931 //
     /* 2192292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192338 */     // MIs[0] round
     /* 2192338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192341 */     // MIs[0] policy
     /* 2192341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192351 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2192354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192377 */     // GIR_Coverage, 18931,
     /* 2192377 */     GIR_EraseRootFromParent_Done,
     /* 2192378 */   // Label 28831: @2192378
     /* 2192378 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2192469), // Rule ID 18934 //
     /* 2192383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192429 */     // MIs[0] round
     /* 2192429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192432 */     // MIs[0] policy
     /* 2192432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192442 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2192445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192468 */     // GIR_Coverage, 18934,
     /* 2192468 */     GIR_EraseRootFromParent_Done,
     /* 2192469 */   // Label 28832: @2192469
     /* 2192469 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2192560), // Rule ID 18935 //
     /* 2192474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192520 */     // MIs[0] round
     /* 2192520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192523 */     // MIs[0] policy
     /* 2192523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192533 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2192536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192559 */     // GIR_Coverage, 18935,
     /* 2192559 */     GIR_EraseRootFromParent_Done,
     /* 2192560 */   // Label 28833: @2192560
     /* 2192560 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2192651), // Rule ID 18938 //
     /* 2192565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2192582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2192585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192611 */     // MIs[0] round
     /* 2192611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192614 */     // MIs[0] policy
     /* 2192614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2192627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192650 */     // GIR_Coverage, 18938,
     /* 2192650 */     GIR_EraseRootFromParent_Done,
     /* 2192651 */   // Label 28834: @2192651
     /* 2192651 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2192742), // Rule ID 18939 //
     /* 2192656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2192673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2192676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192702 */     // MIs[0] round
     /* 2192702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192705 */     // MIs[0] policy
     /* 2192705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192715 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2192718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192741 */     // GIR_Coverage, 18939,
     /* 2192741 */     GIR_EraseRootFromParent_Done,
     /* 2192742 */   // Label 28835: @2192742
     /* 2192742 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2192833), // Rule ID 18942 //
     /* 2192747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2192758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2192761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2192764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2192767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192793 */     // MIs[0] round
     /* 2192793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192796 */     // MIs[0] policy
     /* 2192796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192806 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2192809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192832 */     // GIR_Coverage, 18942,
     /* 2192832 */     GIR_EraseRootFromParent_Done,
     /* 2192833 */   // Label 28836: @2192833
     /* 2192833 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2192924), // Rule ID 18943 //
     /* 2192838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2192849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2192852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2192855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2192858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192884 */     // MIs[0] round
     /* 2192884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192887 */     // MIs[0] policy
     /* 2192887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192897 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2192900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192923 */     // GIR_Coverage, 18943,
     /* 2192923 */     GIR_EraseRootFromParent_Done,
     /* 2192924 */   // Label 28837: @2192924
     /* 2192924 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2193015), // Rule ID 18946 //
     /* 2192929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2192932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2192937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2192940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2192943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2192946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2192949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192975 */     // MIs[0] round
     /* 2192975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192978 */     // MIs[0] policy
     /* 2192978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192988 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2192991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193014 */     // GIR_Coverage, 18946,
     /* 2193014 */     GIR_EraseRootFromParent_Done,
     /* 2193015 */   // Label 28838: @2193015
     /* 2193015 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2193106), // Rule ID 18947 //
     /* 2193020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193066 */     // MIs[0] round
     /* 2193066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193069 */     // MIs[0] policy
     /* 2193069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2193082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193105 */     // GIR_Coverage, 18947,
     /* 2193105 */     GIR_EraseRootFromParent_Done,
     /* 2193106 */   // Label 28839: @2193106
     /* 2193106 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2193197), // Rule ID 18950 //
     /* 2193111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193157 */     // MIs[0] round
     /* 2193157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193160 */     // MIs[0] policy
     /* 2193160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2193173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193196 */     // GIR_Coverage, 18950,
     /* 2193196 */     GIR_EraseRootFromParent_Done,
     /* 2193197 */   // Label 28840: @2193197
     /* 2193197 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2193288), // Rule ID 18951 //
     /* 2193202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193248 */     // MIs[0] round
     /* 2193248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193251 */     // MIs[0] policy
     /* 2193251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193261 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2193264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193287 */     // GIR_Coverage, 18951,
     /* 2193287 */     GIR_EraseRootFromParent_Done,
     /* 2193288 */   // Label 28841: @2193288
     /* 2193288 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2193379), // Rule ID 18954 //
     /* 2193293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193339 */     // MIs[0] round
     /* 2193339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193342 */     // MIs[0] policy
     /* 2193342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2193355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193378 */     // GIR_Coverage, 18954,
     /* 2193378 */     GIR_EraseRootFromParent_Done,
     /* 2193379 */   // Label 28842: @2193379
     /* 2193379 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2193470), // Rule ID 18955 //
     /* 2193384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193430 */     // MIs[0] round
     /* 2193430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193433 */     // MIs[0] policy
     /* 2193433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193443 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2193446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193469 */     // GIR_Coverage, 18955,
     /* 2193469 */     GIR_EraseRootFromParent_Done,
     /* 2193470 */   // Label 28843: @2193470
     /* 2193470 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2193561), // Rule ID 18958 //
     /* 2193475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193521 */     // MIs[0] round
     /* 2193521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193524 */     // MIs[0] policy
     /* 2193524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193534 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2193537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193560 */     // GIR_Coverage, 18958,
     /* 2193560 */     GIR_EraseRootFromParent_Done,
     /* 2193561 */   // Label 28844: @2193561
     /* 2193561 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2193652), // Rule ID 18959 //
     /* 2193566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193612 */     // MIs[0] round
     /* 2193612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193615 */     // MIs[0] policy
     /* 2193615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193625 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2193628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193651 */     // GIR_Coverage, 18959,
     /* 2193651 */     GIR_EraseRootFromParent_Done,
     /* 2193652 */   // Label 28845: @2193652
     /* 2193652 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2193743), // Rule ID 18962 //
     /* 2193657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2193668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2193671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2193677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193703 */     // MIs[0] round
     /* 2193703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193706 */     // MIs[0] policy
     /* 2193706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193716 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2193719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193742 */     // GIR_Coverage, 18962,
     /* 2193742 */     GIR_EraseRootFromParent_Done,
     /* 2193743 */   // Label 28846: @2193743
     /* 2193743 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2193834), // Rule ID 18963 //
     /* 2193748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2193759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2193762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2193768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193794 */     // MIs[0] round
     /* 2193794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193797 */     // MIs[0] policy
     /* 2193797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2193810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193833 */     // GIR_Coverage, 18963,
     /* 2193833 */     GIR_EraseRootFromParent_Done,
     /* 2193834 */   // Label 28847: @2193834
     /* 2193834 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2193925), // Rule ID 18966 //
     /* 2193839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193885 */     // MIs[0] round
     /* 2193885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193888 */     // MIs[0] policy
     /* 2193888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193898 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2193901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193924 */     // GIR_Coverage, 18966,
     /* 2193924 */     GIR_EraseRootFromParent_Done,
     /* 2193925 */   // Label 28848: @2193925
     /* 2193925 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2194016), // Rule ID 18967 //
     /* 2193930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2193938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2193941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2193944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2193950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193976 */     // MIs[0] round
     /* 2193976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193979 */     // MIs[0] policy
     /* 2193979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193989 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2193992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194015 */     // GIR_Coverage, 18967,
     /* 2194015 */     GIR_EraseRootFromParent_Done,
     /* 2194016 */   // Label 28849: @2194016
     /* 2194016 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2194107), // Rule ID 18970 //
     /* 2194021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194067 */     // MIs[0] round
     /* 2194067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194070 */     // MIs[0] policy
     /* 2194070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194080 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2194083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194106 */     // GIR_Coverage, 18970,
     /* 2194106 */     GIR_EraseRootFromParent_Done,
     /* 2194107 */   // Label 28850: @2194107
     /* 2194107 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2194198), // Rule ID 18971 //
     /* 2194112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194158 */     // MIs[0] round
     /* 2194158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194161 */     // MIs[0] policy
     /* 2194161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194171 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2194174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194197 */     // GIR_Coverage, 18971,
     /* 2194197 */     GIR_EraseRootFromParent_Done,
     /* 2194198 */   // Label 28851: @2194198
     /* 2194198 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2194289), // Rule ID 18974 //
     /* 2194203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194249 */     // MIs[0] round
     /* 2194249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194252 */     // MIs[0] policy
     /* 2194252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2194265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194288 */     // GIR_Coverage, 18974,
     /* 2194288 */     GIR_EraseRootFromParent_Done,
     /* 2194289 */   // Label 28852: @2194289
     /* 2194289 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2194380), // Rule ID 18975 //
     /* 2194294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194340 */     // MIs[0] round
     /* 2194340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194343 */     // MIs[0] policy
     /* 2194343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194353 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2194356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194379 */     // GIR_Coverage, 18975,
     /* 2194379 */     GIR_EraseRootFromParent_Done,
     /* 2194380 */   // Label 28853: @2194380
     /* 2194380 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2194471), // Rule ID 18978 //
     /* 2194385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194431 */     // MIs[0] round
     /* 2194431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194434 */     // MIs[0] policy
     /* 2194434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2194447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194470 */     // GIR_Coverage, 18978,
     /* 2194470 */     GIR_EraseRootFromParent_Done,
     /* 2194471 */   // Label 28854: @2194471
     /* 2194471 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2194562), // Rule ID 18979 //
     /* 2194476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194522 */     // MIs[0] round
     /* 2194522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194525 */     // MIs[0] policy
     /* 2194525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194535 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2194538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194561 */     // GIR_Coverage, 18979,
     /* 2194561 */     GIR_EraseRootFromParent_Done,
     /* 2194562 */   // Label 28855: @2194562
     /* 2194562 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2194653), // Rule ID 18982 //
     /* 2194567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2194578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2194581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2194587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194613 */     // MIs[0] round
     /* 2194613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194616 */     // MIs[0] policy
     /* 2194616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194626 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2194629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194652 */     // GIR_Coverage, 18982,
     /* 2194652 */     GIR_EraseRootFromParent_Done,
     /* 2194653 */   // Label 28856: @2194653
     /* 2194653 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2194744), // Rule ID 18983 //
     /* 2194658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2194669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2194672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2194678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194704 */     // MIs[0] round
     /* 2194704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194707 */     // MIs[0] policy
     /* 2194707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194717 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2194720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194743 */     // GIR_Coverage, 18983,
     /* 2194743 */     GIR_EraseRootFromParent_Done,
     /* 2194744 */   // Label 28857: @2194744
     /* 2194744 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2194835), // Rule ID 18986 //
     /* 2194749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194795 */     // MIs[0] round
     /* 2194795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194798 */     // MIs[0] policy
     /* 2194798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2194811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194834 */     // GIR_Coverage, 18986,
     /* 2194834 */     GIR_EraseRootFromParent_Done,
     /* 2194835 */   // Label 28858: @2194835
     /* 2194835 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2194926), // Rule ID 18987 //
     /* 2194840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2194851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2194854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2194860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194886 */     // MIs[0] round
     /* 2194886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194889 */     // MIs[0] policy
     /* 2194889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194899 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2194902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194925 */     // GIR_Coverage, 18987,
     /* 2194925 */     GIR_EraseRootFromParent_Done,
     /* 2194926 */   // Label 28859: @2194926
     /* 2194926 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2195017), // Rule ID 18990 //
     /* 2194931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2194939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2194942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2194945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2194951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194977 */     // MIs[0] round
     /* 2194977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194980 */     // MIs[0] policy
     /* 2194980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194990 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2194993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195016 */     // GIR_Coverage, 18990,
     /* 2195016 */     GIR_EraseRootFromParent_Done,
     /* 2195017 */   // Label 28860: @2195017
     /* 2195017 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2195108), // Rule ID 18991 //
     /* 2195022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2195030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195068 */     // MIs[0] round
     /* 2195068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195071 */     // MIs[0] policy
     /* 2195071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195081 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2195084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195107 */     // GIR_Coverage, 18991,
     /* 2195107 */     GIR_EraseRootFromParent_Done,
     /* 2195108 */   // Label 28861: @2195108
     /* 2195108 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2195199), // Rule ID 64349 //
     /* 2195113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2195116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2195124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2195127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2195130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195159 */     // MIs[0] round
     /* 2195159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195162 */     // MIs[0] policy
     /* 2195162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195172 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2195175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195198 */     // GIR_Coverage, 64349,
     /* 2195198 */     GIR_EraseRootFromParent_Done,
     /* 2195199 */   // Label 28862: @2195199
     /* 2195199 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2195290), // Rule ID 64350 //
     /* 2195204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2195207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2195215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2195218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2195221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195250 */     // MIs[0] round
     /* 2195250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195253 */     // MIs[0] policy
     /* 2195253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195263 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2195266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195289 */     // GIR_Coverage, 64350,
     /* 2195289 */     GIR_EraseRootFromParent_Done,
     /* 2195290 */   // Label 28863: @2195290
     /* 2195290 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2195381), // Rule ID 64353 //
     /* 2195295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2195298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2195306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2195309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2195312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195341 */     // MIs[0] round
     /* 2195341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195344 */     // MIs[0] policy
     /* 2195344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2195357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195380 */     // GIR_Coverage, 64353,
     /* 2195380 */     GIR_EraseRootFromParent_Done,
     /* 2195381 */   // Label 28864: @2195381
     /* 2195381 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2195472), // Rule ID 64354 //
     /* 2195386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2195389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2195397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2195400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2195403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195432 */     // MIs[0] round
     /* 2195432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195435 */     // MIs[0] policy
     /* 2195435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195445 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2195448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195471 */     // GIR_Coverage, 64354,
     /* 2195471 */     GIR_EraseRootFromParent_Done,
     /* 2195472 */   // Label 28865: @2195472
     /* 2195472 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2195563), // Rule ID 64357 //
     /* 2195477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2195480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2195488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2195491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2195494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195523 */     // MIs[0] round
     /* 2195523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195526 */     // MIs[0] policy
     /* 2195526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195536 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2195539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195562 */     // GIR_Coverage, 64357,
     /* 2195562 */     GIR_EraseRootFromParent_Done,
     /* 2195563 */   // Label 28866: @2195563
     /* 2195563 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2195654), // Rule ID 64358 //
     /* 2195568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2195571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2195579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2195582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2195585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195614 */     // MIs[0] round
     /* 2195614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195617 */     // MIs[0] policy
     /* 2195617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2195630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195653 */     // GIR_Coverage, 64358,
     /* 2195653 */     GIR_EraseRootFromParent_Done,
     /* 2195654 */   // Label 28867: @2195654
     /* 2195654 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2195745), // Rule ID 64361 //
     /* 2195659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2195662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2195670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2195673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2195676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195705 */     // MIs[0] round
     /* 2195705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195708 */     // MIs[0] policy
     /* 2195708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195718 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2195721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195744 */     // GIR_Coverage, 64361,
     /* 2195744 */     GIR_EraseRootFromParent_Done,
     /* 2195745 */   // Label 28868: @2195745
     /* 2195745 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2195836), // Rule ID 64362 //
     /* 2195750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2195753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2195761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2195764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2195767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195796 */     // MIs[0] round
     /* 2195796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195799 */     // MIs[0] policy
     /* 2195799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195809 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11038:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2195812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195835 */     // GIR_Coverage, 64362,
     /* 2195835 */     GIR_EraseRootFromParent_Done,
     /* 2195836 */   // Label 28869: @2195836
     /* 2195836 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2195927), // Rule ID 64365 //
     /* 2195841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2195844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2195852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2195855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2195858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195887 */     // MIs[0] round
     /* 2195887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195890 */     // MIs[0] policy
     /* 2195890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195900 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2195903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195926 */     // GIR_Coverage, 64365,
     /* 2195926 */     GIR_EraseRootFromParent_Done,
     /* 2195927 */   // Label 28870: @2195927
     /* 2195927 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2196018), // Rule ID 64366 //
     /* 2195932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2195935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2195940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2195943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2195946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2195949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2195952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2195955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195978 */     // MIs[0] round
     /* 2195978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195981 */     // MIs[0] policy
     /* 2195981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2195994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2195998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196017 */     // GIR_Coverage, 64366,
     /* 2196017 */     GIR_EraseRootFromParent_Done,
     /* 2196018 */   // Label 28871: @2196018
     /* 2196018 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2196109), // Rule ID 64369 //
     /* 2196023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2196026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2196034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2196037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196069 */     // MIs[0] round
     /* 2196069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196072 */     // MIs[0] policy
     /* 2196072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2196085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196108 */     // GIR_Coverage, 64369,
     /* 2196108 */     GIR_EraseRootFromParent_Done,
     /* 2196109 */   // Label 28872: @2196109
     /* 2196109 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2196200), // Rule ID 64370 //
     /* 2196114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2196117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2196125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2196128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196160 */     // MIs[0] round
     /* 2196160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196163 */     // MIs[0] policy
     /* 2196163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196173 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2196176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196199 */     // GIR_Coverage, 64370,
     /* 2196199 */     GIR_EraseRootFromParent_Done,
     /* 2196200 */   // Label 28873: @2196200
     /* 2196200 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2196291), // Rule ID 64373 //
     /* 2196205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2196208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2196216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2196219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196251 */     // MIs[0] round
     /* 2196251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196254 */     // MIs[0] policy
     /* 2196254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2196267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196290 */     // GIR_Coverage, 64373,
     /* 2196290 */     GIR_EraseRootFromParent_Done,
     /* 2196291 */   // Label 28874: @2196291
     /* 2196291 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2196382), // Rule ID 64374 //
     /* 2196296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2196299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2196307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2196310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196342 */     // MIs[0] round
     /* 2196342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196345 */     // MIs[0] policy
     /* 2196345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196355 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2196358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196381 */     // GIR_Coverage, 64374,
     /* 2196381 */     GIR_EraseRootFromParent_Done,
     /* 2196382 */   // Label 28875: @2196382
     /* 2196382 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2196473), // Rule ID 64377 //
     /* 2196387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2196390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2196398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2196401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196433 */     // MIs[0] round
     /* 2196433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196436 */     // MIs[0] policy
     /* 2196436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196446 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2196449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196472 */     // GIR_Coverage, 64377,
     /* 2196472 */     GIR_EraseRootFromParent_Done,
     /* 2196473 */   // Label 28876: @2196473
     /* 2196473 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2196564), // Rule ID 64378 //
     /* 2196478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2196481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2196489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2196492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196524 */     // MIs[0] round
     /* 2196524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196527 */     // MIs[0] policy
     /* 2196527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196537 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2196540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196563 */     // GIR_Coverage, 64378,
     /* 2196563 */     GIR_EraseRootFromParent_Done,
     /* 2196564 */   // Label 28877: @2196564
     /* 2196564 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2196655), // Rule ID 64381 //
     /* 2196569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2196572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2196580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2196583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2196586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196615 */     // MIs[0] round
     /* 2196615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196618 */     // MIs[0] policy
     /* 2196618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2196631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196654 */     // GIR_Coverage, 64381,
     /* 2196654 */     GIR_EraseRootFromParent_Done,
     /* 2196655 */   // Label 28878: @2196655
     /* 2196655 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2196746), // Rule ID 64382 //
     /* 2196660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2196663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2196671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2196674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2196677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196706 */     // MIs[0] round
     /* 2196706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196709 */     // MIs[0] policy
     /* 2196709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196719 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11036:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2196722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196745 */     // GIR_Coverage, 64382,
     /* 2196745 */     GIR_EraseRootFromParent_Done,
     /* 2196746 */   // Label 28879: @2196746
     /* 2196746 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2196837), // Rule ID 64385 //
     /* 2196751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2196754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2196762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2196765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2196768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196797 */     // MIs[0] round
     /* 2196797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196800 */     // MIs[0] policy
     /* 2196800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2196813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196836 */     // GIR_Coverage, 64385,
     /* 2196836 */     GIR_EraseRootFromParent_Done,
     /* 2196837 */   // Label 28880: @2196837
     /* 2196837 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2196928), // Rule ID 64386 //
     /* 2196842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2196845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2196850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2196853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2196856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2196859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2196862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2196884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196888 */     // MIs[0] round
     /* 2196888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196891 */     // MIs[0] policy
     /* 2196891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2196904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2196908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196927 */     // GIR_Coverage, 64386,
     /* 2196927 */     GIR_EraseRootFromParent_Done,
     /* 2196928 */   // Label 28881: @2196928
     /* 2196928 */   GIM_Reject,
     /* 2196929 */ // Label 26837: @2196929
     /* 2196929 */ GIM_Reject,
     /* 2196930 */ // Label 38: @2196930
     /* 2196930 */ GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2197013), // Rule ID 35 //
     /* 2196935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2196938 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2196941 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2196946 */   // MIs[0] Operand 1
     /* 2196946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2196950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2196954 */   // MIs[0] ptr
     /* 2196954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2196958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2196962 */   // MIs[0] accessinfo
     /* 2196962 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2196965 */   // (intrinsic_void 192:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2196965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2196969 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2196979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2196982 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2196984 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2196986 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2196989 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2196992 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2196995 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2196998 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2197001 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2197004 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2197007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197012 */   // GIR_Coverage, 35,
     /* 2197012 */   GIR_EraseRootFromParent_Done,
     /* 2197013 */ // Label 28882: @2197013
     /* 2197013 */ GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2197918),
     /* 2197018 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2197021 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2197093), // Rule ID 621 //
     /* 2197026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2197034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197047 */     // MIs[0] addr
     /* 2197047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197063 */     // MIs[0] ordering
     /* 2197063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197066 */     // (intrinsic_w_chain:{ *:[i32] } 10972:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2197072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197074 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197079 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197081 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197083 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197085 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197092 */     // GIR_Coverage, 621,
     /* 2197092 */     GIR_EraseRootFromParent_Done,
     /* 2197093 */   // Label 28884: @2197093
     /* 2197093 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2197165), // Rule ID 622 //
     /* 2197098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2197106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197119 */     // MIs[0] addr
     /* 2197119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197135 */     // MIs[0] ordering
     /* 2197135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197138 */     // (intrinsic_w_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2197144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197146 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197151 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197153 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197155 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197157 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197164 */     // GIR_Coverage, 622,
     /* 2197164 */     GIR_EraseRootFromParent_Done,
     /* 2197165 */   // Label 28885: @2197165
     /* 2197165 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2197237), // Rule ID 623 //
     /* 2197170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2197178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197191 */     // MIs[0] addr
     /* 2197191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197207 */     // MIs[0] ordering
     /* 2197207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197210 */     // (intrinsic_w_chain:{ *:[i32] } 10966:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2197216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197218 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197223 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197225 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197227 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197229 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197236 */     // GIR_Coverage, 623,
     /* 2197236 */     GIR_EraseRootFromParent_Done,
     /* 2197237 */   // Label 28886: @2197237
     /* 2197237 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2197309), // Rule ID 624 //
     /* 2197242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2197250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197263 */     // MIs[0] addr
     /* 2197263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197279 */     // MIs[0] ordering
     /* 2197279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197282 */     // (intrinsic_w_chain:{ *:[i32] } 10964:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2197288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197290 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197295 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197297 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197299 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197301 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197308 */     // GIR_Coverage, 624,
     /* 2197308 */     GIR_EraseRootFromParent_Done,
     /* 2197309 */   // Label 28887: @2197309
     /* 2197309 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2197389), // Rule ID 627 //
     /* 2197314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2197322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197335 */     // MIs[0] addr
     /* 2197335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197351 */     // MIs[0] ordering
     /* 2197351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197354 */     // (intrinsic_w_chain:{ *:[i32] } 10968:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197354 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2197357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2197363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197365 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197370 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197375 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197377 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197379 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197381 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197388 */     // GIR_Coverage, 627,
     /* 2197388 */     GIR_EraseRootFromParent_Done,
     /* 2197389 */   // Label 28888: @2197389
     /* 2197389 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2197469), // Rule ID 628 //
     /* 2197394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2197402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197415 */     // MIs[0] addr
     /* 2197415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197431 */     // MIs[0] ordering
     /* 2197431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197434 */     // (intrinsic_w_chain:{ *:[i32] } 10970:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2197434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2197437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2197443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197445 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197450 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197455 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197457 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197459 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197461 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197468 */     // GIR_Coverage, 628,
     /* 2197468 */     GIR_EraseRootFromParent_Done,
     /* 2197469 */   // Label 28889: @2197469
     /* 2197469 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2197541), // Rule ID 634 //
     /* 2197474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2197482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197495 */     // MIs[0] addr
     /* 2197495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197511 */     // MIs[0] ordering
     /* 2197511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197514 */     // (intrinsic_w_chain:{ *:[i64] } 10973:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2197520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197522 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197527 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197529 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197531 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197533 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197540 */     // GIR_Coverage, 634,
     /* 2197540 */     GIR_EraseRootFromParent_Done,
     /* 2197541 */   // Label 28890: @2197541
     /* 2197541 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2197613), // Rule ID 635 //
     /* 2197546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2197554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197567 */     // MIs[0] addr
     /* 2197567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197583 */     // MIs[0] ordering
     /* 2197583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197586 */     // (intrinsic_w_chain:{ *:[i64] } 10959:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2197592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197594 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197599 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197601 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197603 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197605 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197612 */     // GIR_Coverage, 635,
     /* 2197612 */     GIR_EraseRootFromParent_Done,
     /* 2197613 */   // Label 28891: @2197613
     /* 2197613 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2197685), // Rule ID 636 //
     /* 2197618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2197626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197639 */     // MIs[0] addr
     /* 2197639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197655 */     // MIs[0] ordering
     /* 2197655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197658 */     // (intrinsic_w_chain:{ *:[i64] } 10967:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2197664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197666 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197671 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197673 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197675 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197677 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197684 */     // GIR_Coverage, 636,
     /* 2197684 */     GIR_EraseRootFromParent_Done,
     /* 2197685 */   // Label 28892: @2197685
     /* 2197685 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2197757), // Rule ID 637 //
     /* 2197690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2197698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197711 */     // MIs[0] addr
     /* 2197711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197727 */     // MIs[0] ordering
     /* 2197727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197730 */     // (intrinsic_w_chain:{ *:[i64] } 10965:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2197736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197738 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197743 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197745 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197747 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197749 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197756 */     // GIR_Coverage, 637,
     /* 2197756 */     GIR_EraseRootFromParent_Done,
     /* 2197757 */   // Label 28893: @2197757
     /* 2197757 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2197837), // Rule ID 640 //
     /* 2197762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2197770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197783 */     // MIs[0] addr
     /* 2197783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197799 */     // MIs[0] ordering
     /* 2197799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197802 */     // (intrinsic_w_chain:{ *:[i64] } 10969:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2197805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2197811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197813 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197818 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197823 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197825 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197827 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197829 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197836 */     // GIR_Coverage, 640,
     /* 2197836 */     GIR_EraseRootFromParent_Done,
     /* 2197837 */   // Label 28894: @2197837
     /* 2197837 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2197917), // Rule ID 641 //
     /* 2197842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2197845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2197850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2197853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2197856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2197859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197863 */     // MIs[0] addr
     /* 2197863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197879 */     // MIs[0] ordering
     /* 2197879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2197882 */     // (intrinsic_w_chain:{ *:[i64] } 10971:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2197882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2197885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2197891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197893 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197898 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197903 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2197905 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2197907 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2197909 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2197911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2197915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197916 */     // GIR_Coverage, 641,
     /* 2197916 */     GIR_EraseRootFromParent_Done,
     /* 2197917 */   // Label 28895: @2197917
     /* 2197917 */   GIM_Reject,
     /* 2197918 */ // Label 28883: @2197918
     /* 2197918 */ GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2198445),
     /* 2197923 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2197926 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2198015), // Rule ID 625 //
     /* 2197931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2197934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2197939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2197942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2197945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2197948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2197951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197955 */     // MIs[0] addr
     /* 2197955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2197959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197975 */     // MIs[0] ordering
     /* 2197975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197978 */     // (intrinsic_w_chain:{ *:[i32] } 10960:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2197978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2197981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2197984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2197987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2197989 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197994 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2197999 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198001 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2198003 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2198005 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2198007 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198014 */     // GIR_Coverage, 625,
     /* 2198014 */     GIR_EraseRootFromParent_Done,
     /* 2198015 */   // Label 28897: @2198015
     /* 2198015 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2198104), // Rule ID 626 //
     /* 2198020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2198023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2198028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2198031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2198037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2198040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198044 */     // MIs[0] addr
     /* 2198044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2198048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198064 */     // MIs[0] ordering
     /* 2198064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198067 */     // (intrinsic_w_chain:{ *:[i32] } 10962:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2198067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2198070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2198073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2198076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2198078 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198083 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198088 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198090 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2198092 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2198094 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2198096 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198103 */     // GIR_Coverage, 626,
     /* 2198103 */     GIR_EraseRootFromParent_Done,
     /* 2198104 */   // Label 28898: @2198104
     /* 2198104 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2198193), // Rule ID 638 //
     /* 2198109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2198112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2198117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2198120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2198123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2198126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2198129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198133 */     // MIs[0] addr
     /* 2198133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2198137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198153 */     // MIs[0] ordering
     /* 2198153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198156 */     // (intrinsic_w_chain:{ *:[i64] } 10961:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2198156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2198159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2198162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2198165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2198167 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198172 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198177 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198179 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2198181 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2198183 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2198185 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198192 */     // GIR_Coverage, 638,
     /* 2198192 */     GIR_EraseRootFromParent_Done,
     /* 2198193 */   // Label 28899: @2198193
     /* 2198193 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2198282), // Rule ID 639 //
     /* 2198198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2198201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2198206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2198209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2198212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2198215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2198218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198222 */     // MIs[0] addr
     /* 2198222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2198226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198242 */     // MIs[0] ordering
     /* 2198242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198245 */     // (intrinsic_w_chain:{ *:[i64] } 10963:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2198245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2198248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2198251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2198254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2198256 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198261 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198266 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198268 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2198270 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2198272 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2198274 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198281 */     // GIR_Coverage, 639,
     /* 2198281 */     GIR_EraseRootFromParent_Done,
     /* 2198282 */   // Label 28900: @2198282
     /* 2198282 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2198363), // Rule ID 657 //
     /* 2198287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2198290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2198295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2198298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2198304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2198307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198311 */     // MIs[0] addr
     /* 2198311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2198315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198331 */     // MIs[0] ordering
     /* 2198331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198334 */     // (intrinsic_w_chain:{ *:[i32] } 10974:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2198334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2198337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2198340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2198342 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198347 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198349 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2198351 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2198353 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2198355 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198362 */     // GIR_Coverage, 657,
     /* 2198362 */     GIR_EraseRootFromParent_Done,
     /* 2198363 */   // Label 28901: @2198363
     /* 2198363 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2198444), // Rule ID 658 //
     /* 2198368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2198371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2198376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2198379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2198382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2198385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2198388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198392 */     // MIs[0] addr
     /* 2198392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2198396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2198412 */     // MIs[0] ordering
     /* 2198412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198415 */     // (intrinsic_w_chain:{ *:[i64] } 10975:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2198415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2198418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2198421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2198423 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2198428 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2198430 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2198432 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2198434 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2198436 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2198438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2198442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198443 */     // GIR_Coverage, 658,
     /* 2198443 */     GIR_EraseRootFromParent_Done,
     /* 2198444 */   // Label 28902: @2198444
     /* 2198444 */   GIM_Reject,
     /* 2198445 */ // Label 28896: @2198445
     /* 2198445 */ GIM_Reject,
     /* 2198446 */ // Label 39: @2198446
     /* 2198446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 28918*/ GIMT_Encode4(2201566),
     /* 2198457 */ /*GILLT_nxv1s16*//*Label 28903*/ GIMT_Encode4(2198557),
     /* 2198461 */ /*GILLT_nxv1s32*//*Label 28904*/ GIMT_Encode4(2198661),
     /* 2198465 */ /*GILLT_nxv1s64*//*Label 28905*/ GIMT_Encode4(2198878), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2198477 */ /*GILLT_nxv2s16*//*Label 28906*/ GIMT_Encode4(2199203),
     /* 2198481 */ /*GILLT_nxv2s32*//*Label 28907*/ GIMT_Encode4(2199307),
     /* 2198485 */ /*GILLT_nxv2s64*//*Label 28908*/ GIMT_Encode4(2199524), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2198497 */ /*GILLT_nxv4s16*//*Label 28909*/ GIMT_Encode4(2199849),
     /* 2198501 */ /*GILLT_nxv4s32*//*Label 28910*/ GIMT_Encode4(2199953),
     /* 2198505 */ /*GILLT_nxv4s64*//*Label 28911*/ GIMT_Encode4(2200170), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2198517 */ /*GILLT_nxv8s16*//*Label 28912*/ GIMT_Encode4(2200495),
     /* 2198521 */ /*GILLT_nxv8s32*//*Label 28913*/ GIMT_Encode4(2200599),
     /* 2198525 */ /*GILLT_nxv8s64*//*Label 28914*/ GIMT_Encode4(2200816), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2198537 */ /*GILLT_nxv16s16*//*Label 28915*/ GIMT_Encode4(2201141),
     /* 2198541 */ /*GILLT_nxv16s32*//*Label 28916*/ GIMT_Encode4(2201245), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2198553 */ /*GILLT_nxv32s16*//*Label 28917*/ GIMT_Encode4(2201462),
     /* 2198557 */ // Label 28903: @2198557
     /* 2198557 */ GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2198660),
     /* 2198562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2198565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198573 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2198616), // Rule ID 47478 //
     /* 2198578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198581 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2198584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2198598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198615 */     // GIR_Coverage, 47478,
     /* 2198615 */     GIR_EraseRootFromParent_Done,
     /* 2198616 */   // Label 28920: @2198616
     /* 2198616 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2198659), // Rule ID 47479 //
     /* 2198621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198624 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2198627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2198641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198658 */     // GIR_Coverage, 47479,
     /* 2198658 */     GIR_EraseRootFromParent_Done,
     /* 2198659 */   // Label 28921: @2198659
     /* 2198659 */   GIM_Reject,
     /* 2198660 */ // Label 28919: @2198660
     /* 2198660 */ GIM_Reject,
     /* 2198661 */ // Label 28904: @2198661
     /* 2198661 */ GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2198715), // Rule ID 47502 //
     /* 2198666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2198672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198680 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2198683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2198697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198702 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198714 */   // GIR_Coverage, 47502,
     /* 2198714 */   GIR_EraseRootFromParent_Done,
     /* 2198715 */ // Label 28922: @2198715
     /* 2198715 */ GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2198769), // Rule ID 47503 //
     /* 2198720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2198726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198734 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2198737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2198751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198756 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198768 */   // GIR_Coverage, 47503,
     /* 2198768 */   GIR_EraseRootFromParent_Done,
     /* 2198769 */ // Label 28923: @2198769
     /* 2198769 */ GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2198823), // Rule ID 47568 //
     /* 2198774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2198780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198788 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2198791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2198805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198810 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198822 */   // GIR_Coverage, 47568,
     /* 2198822 */   GIR_EraseRootFromParent_Done,
     /* 2198823 */ // Label 28924: @2198823
     /* 2198823 */ GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2198877), // Rule ID 47569 //
     /* 2198828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2198834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198842 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2198845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2198859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198864 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198876 */   // GIR_Coverage, 47569,
     /* 2198876 */   GIR_EraseRootFromParent_Done,
     /* 2198877 */ // Label 28925: @2198877
     /* 2198877 */ GIM_Reject,
     /* 2198878 */ // Label 28905: @2198878
     /* 2198878 */ GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2198932), // Rule ID 47522 //
     /* 2198883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2198889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198897 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2198914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198931 */   // GIR_Coverage, 47522,
     /* 2198931 */   GIR_EraseRootFromParent_Done,
     /* 2198932 */ // Label 28926: @2198932
     /* 2198932 */ GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2198986), // Rule ID 47523 //
     /* 2198937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2198943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198951 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2198968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198985 */   // GIR_Coverage, 47523,
     /* 2198985 */   GIR_EraseRootFromParent_Done,
     /* 2198986 */ // Label 28927: @2198986
     /* 2198986 */ GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2199040), // Rule ID 47588 //
     /* 2198991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2198997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199005 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2199008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2199022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199039 */   // GIR_Coverage, 47588,
     /* 2199039 */   GIR_EraseRootFromParent_Done,
     /* 2199040 */ // Label 28928: @2199040
     /* 2199040 */ GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2199094), // Rule ID 47589 //
     /* 2199045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2199051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199059 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2199062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2199076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199081 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199093 */   // GIR_Coverage, 47589,
     /* 2199093 */   GIR_EraseRootFromParent_Done,
     /* 2199094 */ // Label 28929: @2199094
     /* 2199094 */ GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2199148), // Rule ID 47622 //
     /* 2199099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2199105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199113 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2199116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2199130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199135 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199147 */   // GIR_Coverage, 47622,
     /* 2199147 */   GIR_EraseRootFromParent_Done,
     /* 2199148 */ // Label 28930: @2199148
     /* 2199148 */ GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2199202), // Rule ID 47623 //
     /* 2199153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2199159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199167 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2199170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2199184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199201 */   // GIR_Coverage, 47623,
     /* 2199201 */   GIR_EraseRootFromParent_Done,
     /* 2199202 */ // Label 28931: @2199202
     /* 2199202 */ GIM_Reject,
     /* 2199203 */ // Label 28906: @2199203
     /* 2199203 */ GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2199306),
     /* 2199208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2199211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199219 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2199262), // Rule ID 47482 //
     /* 2199224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199227 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2199230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2199244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199261 */     // GIR_Coverage, 47482,
     /* 2199261 */     GIR_EraseRootFromParent_Done,
     /* 2199262 */   // Label 28933: @2199262
     /* 2199262 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2199305), // Rule ID 47483 //
     /* 2199267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199270 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2199273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2199287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199304 */     // GIR_Coverage, 47483,
     /* 2199304 */     GIR_EraseRootFromParent_Done,
     /* 2199305 */   // Label 28934: @2199305
     /* 2199305 */   GIM_Reject,
     /* 2199306 */ // Label 28932: @2199306
     /* 2199306 */ GIM_Reject,
     /* 2199307 */ // Label 28907: @2199307
     /* 2199307 */ GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2199361), // Rule ID 47506 //
     /* 2199312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2199318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199326 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2199329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2199343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199360 */   // GIR_Coverage, 47506,
     /* 2199360 */   GIR_EraseRootFromParent_Done,
     /* 2199361 */ // Label 28935: @2199361
     /* 2199361 */ GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2199415), // Rule ID 47507 //
     /* 2199366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2199372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199380 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2199383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2199397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199402 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199414 */   // GIR_Coverage, 47507,
     /* 2199414 */   GIR_EraseRootFromParent_Done,
     /* 2199415 */ // Label 28936: @2199415
     /* 2199415 */ GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2199469), // Rule ID 47572 //
     /* 2199420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2199426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199434 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2199437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2199451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199456 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199468 */   // GIR_Coverage, 47572,
     /* 2199468 */   GIR_EraseRootFromParent_Done,
     /* 2199469 */ // Label 28937: @2199469
     /* 2199469 */ GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2199523), // Rule ID 47573 //
     /* 2199474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2199480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199488 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2199491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2199505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199510 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199522 */   // GIR_Coverage, 47573,
     /* 2199522 */   GIR_EraseRootFromParent_Done,
     /* 2199523 */ // Label 28938: @2199523
     /* 2199523 */ GIM_Reject,
     /* 2199524 */ // Label 28908: @2199524
     /* 2199524 */ GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2199578), // Rule ID 47526 //
     /* 2199529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2199535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199543 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2199560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199577 */   // GIR_Coverage, 47526,
     /* 2199577 */   GIR_EraseRootFromParent_Done,
     /* 2199578 */ // Label 28939: @2199578
     /* 2199578 */ GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2199632), // Rule ID 47527 //
     /* 2199583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2199589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199597 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2199614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199631 */   // GIR_Coverage, 47527,
     /* 2199631 */   GIR_EraseRootFromParent_Done,
     /* 2199632 */ // Label 28940: @2199632
     /* 2199632 */ GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2199686), // Rule ID 47592 //
     /* 2199637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2199643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199651 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2199668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199685 */   // GIR_Coverage, 47592,
     /* 2199685 */   GIR_EraseRootFromParent_Done,
     /* 2199686 */ // Label 28941: @2199686
     /* 2199686 */ GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2199740), // Rule ID 47593 //
     /* 2199691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2199697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199705 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2199722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199739 */   // GIR_Coverage, 47593,
     /* 2199739 */   GIR_EraseRootFromParent_Done,
     /* 2199740 */ // Label 28942: @2199740
     /* 2199740 */ GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2199794), // Rule ID 47626 //
     /* 2199745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2199751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199759 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2199776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199793 */   // GIR_Coverage, 47626,
     /* 2199793 */   GIR_EraseRootFromParent_Done,
     /* 2199794 */ // Label 28943: @2199794
     /* 2199794 */ GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2199848), // Rule ID 47627 //
     /* 2199799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2199805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199813 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2199816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2199830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199847 */   // GIR_Coverage, 47627,
     /* 2199847 */   GIR_EraseRootFromParent_Done,
     /* 2199848 */ // Label 28944: @2199848
     /* 2199848 */ GIM_Reject,
     /* 2199849 */ // Label 28909: @2199849
     /* 2199849 */ GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2199952),
     /* 2199854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2199857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199865 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2199908), // Rule ID 47486 //
     /* 2199870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199873 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2199876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2199890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199907 */     // GIR_Coverage, 47486,
     /* 2199907 */     GIR_EraseRootFromParent_Done,
     /* 2199908 */   // Label 28946: @2199908
     /* 2199908 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2199951), // Rule ID 47487 //
     /* 2199913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199916 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2199919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2199933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199950 */     // GIR_Coverage, 47487,
     /* 2199950 */     GIR_EraseRootFromParent_Done,
     /* 2199951 */   // Label 28947: @2199951
     /* 2199951 */   GIM_Reject,
     /* 2199952 */ // Label 28945: @2199952
     /* 2199952 */ GIM_Reject,
     /* 2199953 */ // Label 28910: @2199953
     /* 2199953 */ GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2200007), // Rule ID 47510 //
     /* 2199958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2199964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199972 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2199975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2199989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199994 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200006 */   // GIR_Coverage, 47510,
     /* 2200006 */   GIR_EraseRootFromParent_Done,
     /* 2200007 */ // Label 28948: @2200007
     /* 2200007 */ GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2200061), // Rule ID 47511 //
     /* 2200012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2200018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200026 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2200029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2200043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200060 */   // GIR_Coverage, 47511,
     /* 2200060 */   GIR_EraseRootFromParent_Done,
     /* 2200061 */ // Label 28949: @2200061
     /* 2200061 */ GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2200115), // Rule ID 47576 //
     /* 2200066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2200072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200080 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2200083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2200097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200102 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200114 */   // GIR_Coverage, 47576,
     /* 2200114 */   GIR_EraseRootFromParent_Done,
     /* 2200115 */ // Label 28950: @2200115
     /* 2200115 */ GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2200169), // Rule ID 47577 //
     /* 2200120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2200126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200134 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2200137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2200151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200156 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200168 */   // GIR_Coverage, 47577,
     /* 2200168 */   GIR_EraseRootFromParent_Done,
     /* 2200169 */ // Label 28951: @2200169
     /* 2200169 */ GIM_Reject,
     /* 2200170 */ // Label 28911: @2200170
     /* 2200170 */ GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2200224), // Rule ID 47530 //
     /* 2200175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2200181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200189 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2200206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200211 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200223 */   // GIR_Coverage, 47530,
     /* 2200223 */   GIR_EraseRootFromParent_Done,
     /* 2200224 */ // Label 28952: @2200224
     /* 2200224 */ GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2200278), // Rule ID 47531 //
     /* 2200229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2200235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200243 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2200260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200277 */   // GIR_Coverage, 47531,
     /* 2200277 */   GIR_EraseRootFromParent_Done,
     /* 2200278 */ // Label 28953: @2200278
     /* 2200278 */ GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2200332), // Rule ID 47596 //
     /* 2200283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2200289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200297 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2200314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200319 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200331 */   // GIR_Coverage, 47596,
     /* 2200331 */   GIR_EraseRootFromParent_Done,
     /* 2200332 */ // Label 28954: @2200332
     /* 2200332 */ GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2200386), // Rule ID 47597 //
     /* 2200337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2200343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200351 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2200368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200373 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200385 */   // GIR_Coverage, 47597,
     /* 2200385 */   GIR_EraseRootFromParent_Done,
     /* 2200386 */ // Label 28955: @2200386
     /* 2200386 */ GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2200440), // Rule ID 47630 //
     /* 2200391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2200397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200405 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2200422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200439 */   // GIR_Coverage, 47630,
     /* 2200439 */   GIR_EraseRootFromParent_Done,
     /* 2200440 */ // Label 28956: @2200440
     /* 2200440 */ GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2200494), // Rule ID 47631 //
     /* 2200445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2200451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200459 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2200462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2200476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200493 */   // GIR_Coverage, 47631,
     /* 2200493 */   GIR_EraseRootFromParent_Done,
     /* 2200494 */ // Label 28957: @2200494
     /* 2200494 */ GIM_Reject,
     /* 2200495 */ // Label 28912: @2200495
     /* 2200495 */ GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2200598),
     /* 2200500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2200503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200511 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2200554), // Rule ID 47490 //
     /* 2200516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200519 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2200522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2200536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200553 */     // GIR_Coverage, 47490,
     /* 2200553 */     GIR_EraseRootFromParent_Done,
     /* 2200554 */   // Label 28959: @2200554
     /* 2200554 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2200597), // Rule ID 47491 //
     /* 2200559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200562 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2200565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2200579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200596 */     // GIR_Coverage, 47491,
     /* 2200596 */     GIR_EraseRootFromParent_Done,
     /* 2200597 */   // Label 28960: @2200597
     /* 2200597 */   GIM_Reject,
     /* 2200598 */ // Label 28958: @2200598
     /* 2200598 */ GIM_Reject,
     /* 2200599 */ // Label 28913: @2200599
     /* 2200599 */ GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2200653), // Rule ID 47514 //
     /* 2200604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200618 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2200621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2200635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200640 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200652 */   // GIR_Coverage, 47514,
     /* 2200652 */   GIR_EraseRootFromParent_Done,
     /* 2200653 */ // Label 28961: @2200653
     /* 2200653 */ GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2200707), // Rule ID 47515 //
     /* 2200658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200672 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2200675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2200689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200694 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200706 */   // GIR_Coverage, 47515,
     /* 2200706 */   GIR_EraseRootFromParent_Done,
     /* 2200707 */ // Label 28962: @2200707
     /* 2200707 */ GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2200761), // Rule ID 47580 //
     /* 2200712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2200718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200726 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2200729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2200743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200748 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200760 */   // GIR_Coverage, 47580,
     /* 2200760 */   GIR_EraseRootFromParent_Done,
     /* 2200761 */ // Label 28963: @2200761
     /* 2200761 */ GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2200815), // Rule ID 47581 //
     /* 2200766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2200772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200780 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2200783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2200797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200802 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200814 */   // GIR_Coverage, 47581,
     /* 2200814 */   GIR_EraseRootFromParent_Done,
     /* 2200815 */ // Label 28964: @2200815
     /* 2200815 */ GIM_Reject,
     /* 2200816 */ // Label 28914: @2200816
     /* 2200816 */ GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2200870), // Rule ID 47534 //
     /* 2200821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2200827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200835 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2200852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200869 */   // GIR_Coverage, 47534,
     /* 2200869 */   GIR_EraseRootFromParent_Done,
     /* 2200870 */ // Label 28965: @2200870
     /* 2200870 */ GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2200924), // Rule ID 47535 //
     /* 2200875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2200881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200889 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2200906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200923 */   // GIR_Coverage, 47535,
     /* 2200923 */   GIR_EraseRootFromParent_Done,
     /* 2200924 */ // Label 28966: @2200924
     /* 2200924 */ GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2200978), // Rule ID 47600 //
     /* 2200929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200943 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2200960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200977 */   // GIR_Coverage, 47600,
     /* 2200977 */   GIR_EraseRootFromParent_Done,
     /* 2200978 */ // Label 28967: @2200978
     /* 2200978 */ GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2201032), // Rule ID 47601 //
     /* 2200983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200997 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2201000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2201014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2201027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201031 */   // GIR_Coverage, 47601,
     /* 2201031 */   GIR_EraseRootFromParent_Done,
     /* 2201032 */ // Label 28968: @2201032
     /* 2201032 */ GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2201086), // Rule ID 47634 //
     /* 2201037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2201040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2201043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201051 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2201054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2201068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2201081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201085 */   // GIR_Coverage, 47634,
     /* 2201085 */   GIR_EraseRootFromParent_Done,
     /* 2201086 */ // Label 28969: @2201086
     /* 2201086 */ GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2201140), // Rule ID 47635 //
     /* 2201091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2201094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2201097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201105 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2201108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2201122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201127 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2201135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201139 */   // GIR_Coverage, 47635,
     /* 2201139 */   GIR_EraseRootFromParent_Done,
     /* 2201140 */ // Label 28970: @2201140
     /* 2201140 */ GIM_Reject,
     /* 2201141 */ // Label 28915: @2201141
     /* 2201141 */ GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2201244),
     /* 2201146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2201149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201157 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2201200), // Rule ID 47494 //
     /* 2201162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2201165 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2201168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2201182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201199 */     // GIR_Coverage, 47494,
     /* 2201199 */     GIR_EraseRootFromParent_Done,
     /* 2201200 */   // Label 28972: @2201200
     /* 2201200 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2201243), // Rule ID 47495 //
     /* 2201205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2201208 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2201211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2201225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201242 */     // GIR_Coverage, 47495,
     /* 2201242 */     GIR_EraseRootFromParent_Done,
     /* 2201243 */   // Label 28973: @2201243
     /* 2201243 */   GIM_Reject,
     /* 2201244 */ // Label 28971: @2201244
     /* 2201244 */ GIM_Reject,
     /* 2201245 */ // Label 28916: @2201245
     /* 2201245 */ GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2201299), // Rule ID 47518 //
     /* 2201250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2201253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2201256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201264 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2201267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2201281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201298 */   // GIR_Coverage, 47518,
     /* 2201298 */   GIR_EraseRootFromParent_Done,
     /* 2201299 */ // Label 28974: @2201299
     /* 2201299 */ GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2201353), // Rule ID 47519 //
     /* 2201304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2201307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2201310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201318 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2201321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2201335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201352 */   // GIR_Coverage, 47519,
     /* 2201352 */   GIR_EraseRootFromParent_Done,
     /* 2201353 */ // Label 28975: @2201353
     /* 2201353 */ GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2201407), // Rule ID 47584 //
     /* 2201358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2201361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2201364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201372 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2201375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2201389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201394 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201406 */   // GIR_Coverage, 47584,
     /* 2201406 */   GIR_EraseRootFromParent_Done,
     /* 2201407 */ // Label 28976: @2201407
     /* 2201407 */ GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2201461), // Rule ID 47585 //
     /* 2201412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2201415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2201418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201426 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2201429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2201443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201448 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201460 */   // GIR_Coverage, 47585,
     /* 2201460 */   GIR_EraseRootFromParent_Done,
     /* 2201461 */ // Label 28977: @2201461
     /* 2201461 */ GIM_Reject,
     /* 2201462 */ // Label 28917: @2201462
     /* 2201462 */ GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2201565),
     /* 2201467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2201470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201478 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2201521), // Rule ID 47498 //
     /* 2201483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2201486 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2201489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2201503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201520 */     // GIR_Coverage, 47498,
     /* 2201520 */     GIR_EraseRootFromParent_Done,
     /* 2201521 */   // Label 28979: @2201521
     /* 2201521 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2201564), // Rule ID 47499 //
     /* 2201526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2201529 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2201532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2201546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201563 */     // GIR_Coverage, 47499,
     /* 2201563 */     GIR_EraseRootFromParent_Done,
     /* 2201564 */   // Label 28980: @2201564
     /* 2201564 */   GIM_Reject,
     /* 2201565 */ // Label 28978: @2201565
     /* 2201565 */ GIM_Reject,
     /* 2201566 */ // Label 28918: @2201566
     /* 2201566 */ GIM_Reject,
     /* 2201567 */ // Label 40: @2201567
     /* 2201567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 28998*/ GIMT_Encode4(2205041),
     /* 2201578 */ /*GILLT_s32*//*Label 28981*/ GIMT_Encode4(2201694),
     /* 2201582 */ /*GILLT_s64*//*Label 28982*/ GIMT_Encode4(2201868), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201594 */ /*GILLT_nxv1s16*//*Label 28983*/ GIMT_Encode4(2202032),
     /* 2201598 */ /*GILLT_nxv1s32*//*Label 28984*/ GIMT_Encode4(2202136),
     /* 2201602 */ /*GILLT_nxv1s64*//*Label 28985*/ GIMT_Encode4(2202353), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201614 */ /*GILLT_nxv2s16*//*Label 28986*/ GIMT_Encode4(2202678),
     /* 2201618 */ /*GILLT_nxv2s32*//*Label 28987*/ GIMT_Encode4(2202782),
     /* 2201622 */ /*GILLT_nxv2s64*//*Label 28988*/ GIMT_Encode4(2202999), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201634 */ /*GILLT_nxv4s16*//*Label 28989*/ GIMT_Encode4(2203324),
     /* 2201638 */ /*GILLT_nxv4s32*//*Label 28990*/ GIMT_Encode4(2203428),
     /* 2201642 */ /*GILLT_nxv4s64*//*Label 28991*/ GIMT_Encode4(2203645), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201654 */ /*GILLT_nxv8s16*//*Label 28992*/ GIMT_Encode4(2203970),
     /* 2201658 */ /*GILLT_nxv8s32*//*Label 28993*/ GIMT_Encode4(2204074),
     /* 2201662 */ /*GILLT_nxv8s64*//*Label 28994*/ GIMT_Encode4(2204291), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201674 */ /*GILLT_nxv16s16*//*Label 28995*/ GIMT_Encode4(2204616),
     /* 2201678 */ /*GILLT_nxv16s32*//*Label 28996*/ GIMT_Encode4(2204720), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201690 */ /*GILLT_nxv32s16*//*Label 28997*/ GIMT_Encode4(2204937),
     /* 2201694 */ // Label 28981: @2201694
     /* 2201694 */ GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2201867),
     /* 2201699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201710 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2201752), // Rule ID 65139 //
     /* 2201715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2201718 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2201718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2201721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2201737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2201742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2201750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201751 */     // GIR_Coverage, 65139,
     /* 2201751 */     GIR_EraseRootFromParent_Done,
     /* 2201752 */   // Label 29000: @2201752
     /* 2201752 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2201794), // Rule ID 65141 //
     /* 2201757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2201760 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2201760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2201784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2201792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201793 */     // GIR_Coverage, 65141,
     /* 2201793 */     GIR_EraseRootFromParent_Done,
     /* 2201794 */   // Label 29001: @2201794
     /* 2201794 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2201836), // Rule ID 65142 //
     /* 2201799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2201802 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2201802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2201805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2201826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2201834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201835 */     // GIR_Coverage, 65142,
     /* 2201835 */     GIR_EraseRootFromParent_Done,
     /* 2201836 */   // Label 29002: @2201836
     /* 2201836 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2201851), // Rule ID 65144 //
     /* 2201841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2201844 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2201849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201850 */     // GIR_Coverage, 65144,
     /* 2201850 */     GIR_Done,
     /* 2201851 */   // Label 29003: @2201851
     /* 2201851 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2201866), // Rule ID 65145 //
     /* 2201856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2201859 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2201864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201865 */     // GIR_Coverage, 65145,
     /* 2201865 */     GIR_Done,
     /* 2201866 */   // Label 29004: @2201866
     /* 2201866 */   GIM_Reject,
     /* 2201867 */ // Label 28999: @2201867
     /* 2201867 */ GIM_Reject,
     /* 2201868 */ // Label 28982: @2201868
     /* 2201868 */ GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2201899), // Rule ID 65129 //
     /* 2201873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2201876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2201879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201887 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2201887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2201890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2201894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201898 */   // GIR_Coverage, 65129,
     /* 2201898 */   GIR_EraseRootFromParent_Done,
     /* 2201899 */ // Label 29005: @2201899
     /* 2201899 */ GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2201952), // Rule ID 65138 //
     /* 2201904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2201907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201918 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2201918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201934 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2201937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2201942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2201950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201951 */   // GIR_Coverage, 65138,
     /* 2201951 */   GIR_EraseRootFromParent_Done,
     /* 2201952 */ // Label 29006: @2201952
     /* 2201952 */ GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2202005), // Rule ID 65140 //
     /* 2201957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2201960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201971 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2201971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201983 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201987 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2201995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2202003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202004 */   // GIR_Coverage, 65140,
     /* 2202004 */   GIR_EraseRootFromParent_Done,
     /* 2202005 */ // Label 29007: @2202005
     /* 2202005 */ GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2202031), // Rule ID 65146 //
     /* 2202010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2202013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2202016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2202020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2202024 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2202024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2202029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202030 */   // GIR_Coverage, 65146,
     /* 2202030 */   GIR_Done,
     /* 2202031 */ // Label 29008: @2202031
     /* 2202031 */ GIM_Reject,
     /* 2202032 */ // Label 28983: @2202032
     /* 2202032 */ GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2202135),
     /* 2202037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202048 */   GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2202091), // Rule ID 47536 //
     /* 2202053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202056 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2202059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2202073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202090 */     // GIR_Coverage, 47536,
     /* 2202090 */     GIR_EraseRootFromParent_Done,
     /* 2202091 */   // Label 29010: @2202091
     /* 2202091 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2202134), // Rule ID 47537 //
     /* 2202096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202099 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2202102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2202116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202133 */     // GIR_Coverage, 47537,
     /* 2202133 */     GIR_EraseRootFromParent_Done,
     /* 2202134 */   // Label 29011: @2202134
     /* 2202134 */   GIM_Reject,
     /* 2202135 */ // Label 29009: @2202135
     /* 2202135 */ GIM_Reject,
     /* 2202136 */ // Label 28984: @2202136
     /* 2202136 */ GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2202190), // Rule ID 47548 //
     /* 2202141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202155 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2202172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202177 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202189 */   // GIR_Coverage, 47548,
     /* 2202189 */   GIR_EraseRootFromParent_Done,
     /* 2202190 */ // Label 29012: @2202190
     /* 2202190 */ GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2202244), // Rule ID 47549 //
     /* 2202195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202209 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2202226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202231 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202243 */   // GIR_Coverage, 47549,
     /* 2202243 */   GIR_EraseRootFromParent_Done,
     /* 2202244 */ // Label 29013: @2202244
     /* 2202244 */ GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2202298), // Rule ID 47602 //
     /* 2202249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202263 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2202280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202285 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202297 */   // GIR_Coverage, 47602,
     /* 2202297 */   GIR_EraseRootFromParent_Done,
     /* 2202298 */ // Label 29014: @2202298
     /* 2202298 */ GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2202352), // Rule ID 47603 //
     /* 2202303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202317 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2202334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202339 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202351 */   // GIR_Coverage, 47603,
     /* 2202351 */   GIR_EraseRootFromParent_Done,
     /* 2202352 */ // Label 29015: @2202352
     /* 2202352 */ GIM_Reject,
     /* 2202353 */ // Label 28985: @2202353
     /* 2202353 */ GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2202407), // Rule ID 47558 //
     /* 2202358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2202364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202372 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2202389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202394 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202405 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202406 */   // GIR_Coverage, 47558,
     /* 2202406 */   GIR_EraseRootFromParent_Done,
     /* 2202407 */ // Label 29016: @2202407
     /* 2202407 */ GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2202461), // Rule ID 47559 //
     /* 2202412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2202418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202426 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2202443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202448 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202460 */   // GIR_Coverage, 47559,
     /* 2202460 */   GIR_EraseRootFromParent_Done,
     /* 2202461 */ // Label 29017: @2202461
     /* 2202461 */ GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2202515), // Rule ID 47612 //
     /* 2202466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202480 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2202497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202502 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202513 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202514 */   // GIR_Coverage, 47612,
     /* 2202514 */   GIR_EraseRootFromParent_Done,
     /* 2202515 */ // Label 29018: @2202515
     /* 2202515 */ GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2202569), // Rule ID 47613 //
     /* 2202520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202534 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2202551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202556 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202568 */   // GIR_Coverage, 47613,
     /* 2202568 */   GIR_EraseRootFromParent_Done,
     /* 2202569 */ // Label 29019: @2202569
     /* 2202569 */ GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2202623), // Rule ID 47636 //
     /* 2202574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202588 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2202605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202610 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202622 */   // GIR_Coverage, 47636,
     /* 2202622 */   GIR_EraseRootFromParent_Done,
     /* 2202623 */ // Label 29020: @2202623
     /* 2202623 */ GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2202677), // Rule ID 47637 //
     /* 2202628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202642 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2202659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202664 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202676 */   // GIR_Coverage, 47637,
     /* 2202676 */   GIR_EraseRootFromParent_Done,
     /* 2202677 */ // Label 29021: @2202677
     /* 2202677 */ GIM_Reject,
     /* 2202678 */ // Label 28986: @2202678
     /* 2202678 */ GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2202781),
     /* 2202683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202694 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2202737), // Rule ID 47538 //
     /* 2202699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202702 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2202705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2202719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202736 */     // GIR_Coverage, 47538,
     /* 2202736 */     GIR_EraseRootFromParent_Done,
     /* 2202737 */   // Label 29023: @2202737
     /* 2202737 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2202780), // Rule ID 47539 //
     /* 2202742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202745 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2202748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2202762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202779 */     // GIR_Coverage, 47539,
     /* 2202779 */     GIR_EraseRootFromParent_Done,
     /* 2202780 */   // Label 29024: @2202780
     /* 2202780 */   GIM_Reject,
     /* 2202781 */ // Label 29022: @2202781
     /* 2202781 */ GIM_Reject,
     /* 2202782 */ // Label 28987: @2202782
     /* 2202782 */ GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2202836), // Rule ID 47550 //
     /* 2202787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2202793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202801 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2202818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202835 */   // GIR_Coverage, 47550,
     /* 2202835 */   GIR_EraseRootFromParent_Done,
     /* 2202836 */ // Label 29025: @2202836
     /* 2202836 */ GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2202890), // Rule ID 47551 //
     /* 2202841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2202847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202855 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2202872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202889 */   // GIR_Coverage, 47551,
     /* 2202889 */   GIR_EraseRootFromParent_Done,
     /* 2202890 */ // Label 29026: @2202890
     /* 2202890 */ GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2202944), // Rule ID 47604 //
     /* 2202895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202909 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2202926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202943 */   // GIR_Coverage, 47604,
     /* 2202943 */   GIR_EraseRootFromParent_Done,
     /* 2202944 */ // Label 29027: @2202944
     /* 2202944 */ GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2202998), // Rule ID 47605 //
     /* 2202949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202963 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2202980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202997 */   // GIR_Coverage, 47605,
     /* 2202997 */   GIR_EraseRootFromParent_Done,
     /* 2202998 */ // Label 29028: @2202998
     /* 2202998 */ GIM_Reject,
     /* 2202999 */ // Label 28988: @2202999
     /* 2202999 */ GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2203053), // Rule ID 47560 //
     /* 2203004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2203010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203018 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2203035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203052 */   // GIR_Coverage, 47560,
     /* 2203052 */   GIR_EraseRootFromParent_Done,
     /* 2203053 */ // Label 29029: @2203053
     /* 2203053 */ GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2203107), // Rule ID 47561 //
     /* 2203058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2203064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203072 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2203089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203094 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203106 */   // GIR_Coverage, 47561,
     /* 2203106 */   GIR_EraseRootFromParent_Done,
     /* 2203107 */ // Label 29030: @2203107
     /* 2203107 */ GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2203161), // Rule ID 47614 //
     /* 2203112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2203118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203126 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2203143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203148 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203160 */   // GIR_Coverage, 47614,
     /* 2203160 */   GIR_EraseRootFromParent_Done,
     /* 2203161 */ // Label 29031: @2203161
     /* 2203161 */ GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2203215), // Rule ID 47615 //
     /* 2203166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2203172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203180 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2203197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203202 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203214 */   // GIR_Coverage, 47615,
     /* 2203214 */   GIR_EraseRootFromParent_Done,
     /* 2203215 */ // Label 29032: @2203215
     /* 2203215 */ GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2203269), // Rule ID 47638 //
     /* 2203220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2203226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203234 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2203251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203256 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203268 */   // GIR_Coverage, 47638,
     /* 2203268 */   GIR_EraseRootFromParent_Done,
     /* 2203269 */ // Label 29033: @2203269
     /* 2203269 */ GIM_Try, /*On fail goto*//*Label 29034*/ GIMT_Encode4(2203323), // Rule ID 47639 //
     /* 2203274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2203280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203288 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2203305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203322 */   // GIR_Coverage, 47639,
     /* 2203322 */   GIR_EraseRootFromParent_Done,
     /* 2203323 */ // Label 29034: @2203323
     /* 2203323 */ GIM_Reject,
     /* 2203324 */ // Label 28989: @2203324
     /* 2203324 */ GIM_Try, /*On fail goto*//*Label 29035*/ GIMT_Encode4(2203427),
     /* 2203329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203340 */   GIM_Try, /*On fail goto*//*Label 29036*/ GIMT_Encode4(2203383), // Rule ID 47540 //
     /* 2203345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203348 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2203351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2203365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203382 */     // GIR_Coverage, 47540,
     /* 2203382 */     GIR_EraseRootFromParent_Done,
     /* 2203383 */   // Label 29036: @2203383
     /* 2203383 */   GIM_Try, /*On fail goto*//*Label 29037*/ GIMT_Encode4(2203426), // Rule ID 47541 //
     /* 2203388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203391 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2203394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2203408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203425 */     // GIR_Coverage, 47541,
     /* 2203425 */     GIR_EraseRootFromParent_Done,
     /* 2203426 */   // Label 29037: @2203426
     /* 2203426 */   GIM_Reject,
     /* 2203427 */ // Label 29035: @2203427
     /* 2203427 */ GIM_Reject,
     /* 2203428 */ // Label 28990: @2203428
     /* 2203428 */ GIM_Try, /*On fail goto*//*Label 29038*/ GIMT_Encode4(2203482), // Rule ID 47552 //
     /* 2203433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203447 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2203464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203469 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203481 */   // GIR_Coverage, 47552,
     /* 2203481 */   GIR_EraseRootFromParent_Done,
     /* 2203482 */ // Label 29038: @2203482
     /* 2203482 */ GIM_Try, /*On fail goto*//*Label 29039*/ GIMT_Encode4(2203536), // Rule ID 47553 //
     /* 2203487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203501 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2203518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203535 */   // GIR_Coverage, 47553,
     /* 2203535 */   GIR_EraseRootFromParent_Done,
     /* 2203536 */ // Label 29039: @2203536
     /* 2203536 */ GIM_Try, /*On fail goto*//*Label 29040*/ GIMT_Encode4(2203590), // Rule ID 47606 //
     /* 2203541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203555 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2203572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203577 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203589 */   // GIR_Coverage, 47606,
     /* 2203589 */   GIR_EraseRootFromParent_Done,
     /* 2203590 */ // Label 29040: @2203590
     /* 2203590 */ GIM_Try, /*On fail goto*//*Label 29041*/ GIMT_Encode4(2203644), // Rule ID 47607 //
     /* 2203595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203609 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2203626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203631 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203642 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203643 */   // GIR_Coverage, 47607,
     /* 2203643 */   GIR_EraseRootFromParent_Done,
     /* 2203644 */ // Label 29041: @2203644
     /* 2203644 */ GIM_Reject,
     /* 2203645 */ // Label 28991: @2203645
     /* 2203645 */ GIM_Try, /*On fail goto*//*Label 29042*/ GIMT_Encode4(2203699), // Rule ID 47562 //
     /* 2203650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2203656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203664 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2203681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203697 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203698 */   // GIR_Coverage, 47562,
     /* 2203698 */   GIR_EraseRootFromParent_Done,
     /* 2203699 */ // Label 29042: @2203699
     /* 2203699 */ GIM_Try, /*On fail goto*//*Label 29043*/ GIMT_Encode4(2203753), // Rule ID 47563 //
     /* 2203704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2203710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203718 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2203735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203740 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203752 */   // GIR_Coverage, 47563,
     /* 2203752 */   GIR_EraseRootFromParent_Done,
     /* 2203753 */ // Label 29043: @2203753
     /* 2203753 */ GIM_Try, /*On fail goto*//*Label 29044*/ GIMT_Encode4(2203807), // Rule ID 47616 //
     /* 2203758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203772 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2203789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203806 */   // GIR_Coverage, 47616,
     /* 2203806 */   GIR_EraseRootFromParent_Done,
     /* 2203807 */ // Label 29044: @2203807
     /* 2203807 */ GIM_Try, /*On fail goto*//*Label 29045*/ GIMT_Encode4(2203861), // Rule ID 47617 //
     /* 2203812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203826 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2203843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203848 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203860 */   // GIR_Coverage, 47617,
     /* 2203860 */   GIR_EraseRootFromParent_Done,
     /* 2203861 */ // Label 29045: @2203861
     /* 2203861 */ GIM_Try, /*On fail goto*//*Label 29046*/ GIMT_Encode4(2203915), // Rule ID 47640 //
     /* 2203866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203880 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2203897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203902 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203914 */   // GIR_Coverage, 47640,
     /* 2203914 */   GIR_EraseRootFromParent_Done,
     /* 2203915 */ // Label 29046: @2203915
     /* 2203915 */ GIM_Try, /*On fail goto*//*Label 29047*/ GIMT_Encode4(2203969), // Rule ID 47641 //
     /* 2203920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203934 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2203951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203956 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203968 */   // GIR_Coverage, 47641,
     /* 2203968 */   GIR_EraseRootFromParent_Done,
     /* 2203969 */ // Label 29047: @2203969
     /* 2203969 */ GIM_Reject,
     /* 2203970 */ // Label 28992: @2203970
     /* 2203970 */ GIM_Try, /*On fail goto*//*Label 29048*/ GIMT_Encode4(2204073),
     /* 2203975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2203978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203986 */   GIM_Try, /*On fail goto*//*Label 29049*/ GIMT_Encode4(2204029), // Rule ID 47542 //
     /* 2203991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203994 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2203997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2204011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204028 */     // GIR_Coverage, 47542,
     /* 2204028 */     GIR_EraseRootFromParent_Done,
     /* 2204029 */   // Label 29049: @2204029
     /* 2204029 */   GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2204072), // Rule ID 47543 //
     /* 2204034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204037 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2204040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2204054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204071 */     // GIR_Coverage, 47543,
     /* 2204071 */     GIR_EraseRootFromParent_Done,
     /* 2204072 */   // Label 29050: @2204072
     /* 2204072 */   GIM_Reject,
     /* 2204073 */ // Label 29048: @2204073
     /* 2204073 */ GIM_Reject,
     /* 2204074 */ // Label 28993: @2204074
     /* 2204074 */ GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2204128), // Rule ID 47554 //
     /* 2204079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204093 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2204110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204115 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204127 */   // GIR_Coverage, 47554,
     /* 2204127 */   GIR_EraseRootFromParent_Done,
     /* 2204128 */ // Label 29051: @2204128
     /* 2204128 */ GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2204182), // Rule ID 47555 //
     /* 2204133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204147 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2204164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204169 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204181 */   // GIR_Coverage, 47555,
     /* 2204181 */   GIR_EraseRootFromParent_Done,
     /* 2204182 */ // Label 29052: @2204182
     /* 2204182 */ GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2204236), // Rule ID 47608 //
     /* 2204187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204201 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2204218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204235 */   // GIR_Coverage, 47608,
     /* 2204235 */   GIR_EraseRootFromParent_Done,
     /* 2204236 */ // Label 29053: @2204236
     /* 2204236 */ GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2204290), // Rule ID 47609 //
     /* 2204241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204255 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2204272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204277 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204289 */   // GIR_Coverage, 47609,
     /* 2204289 */   GIR_EraseRootFromParent_Done,
     /* 2204290 */ // Label 29054: @2204290
     /* 2204290 */ GIM_Reject,
     /* 2204291 */ // Label 28994: @2204291
     /* 2204291 */ GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2204345), // Rule ID 47564 //
     /* 2204296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2204302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204310 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2204327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204344 */   // GIR_Coverage, 47564,
     /* 2204344 */   GIR_EraseRootFromParent_Done,
     /* 2204345 */ // Label 29055: @2204345
     /* 2204345 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2204399), // Rule ID 47565 //
     /* 2204350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2204356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204364 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2204381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204386 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204398 */   // GIR_Coverage, 47565,
     /* 2204398 */   GIR_EraseRootFromParent_Done,
     /* 2204399 */ // Label 29056: @2204399
     /* 2204399 */ GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2204453), // Rule ID 47618 //
     /* 2204404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204418 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2204435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204440 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204452 */   // GIR_Coverage, 47618,
     /* 2204452 */   GIR_EraseRootFromParent_Done,
     /* 2204453 */ // Label 29057: @2204453
     /* 2204453 */ GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2204507), // Rule ID 47619 //
     /* 2204458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204472 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2204489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204494 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204506 */   // GIR_Coverage, 47619,
     /* 2204506 */   GIR_EraseRootFromParent_Done,
     /* 2204507 */ // Label 29058: @2204507
     /* 2204507 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2204561), // Rule ID 47642 //
     /* 2204512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204526 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2204543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204548 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204560 */   // GIR_Coverage, 47642,
     /* 2204560 */   GIR_EraseRootFromParent_Done,
     /* 2204561 */ // Label 29059: @2204561
     /* 2204561 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2204615), // Rule ID 47643 //
     /* 2204566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204580 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2204597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204602 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204614 */   // GIR_Coverage, 47643,
     /* 2204614 */   GIR_EraseRootFromParent_Done,
     /* 2204615 */ // Label 29060: @2204615
     /* 2204615 */ GIM_Reject,
     /* 2204616 */ // Label 28995: @2204616
     /* 2204616 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2204719),
     /* 2204621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204632 */   GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2204675), // Rule ID 47544 //
     /* 2204637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204640 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2204643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2204657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204674 */     // GIR_Coverage, 47544,
     /* 2204674 */     GIR_EraseRootFromParent_Done,
     /* 2204675 */   // Label 29062: @2204675
     /* 2204675 */   GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2204718), // Rule ID 47545 //
     /* 2204680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204683 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2204686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2204700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204717 */     // GIR_Coverage, 47545,
     /* 2204717 */     GIR_EraseRootFromParent_Done,
     /* 2204718 */   // Label 29063: @2204718
     /* 2204718 */   GIM_Reject,
     /* 2204719 */ // Label 29061: @2204719
     /* 2204719 */ GIM_Reject,
     /* 2204720 */ // Label 28996: @2204720
     /* 2204720 */ GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2204774), // Rule ID 47556 //
     /* 2204725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2204731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204739 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2204756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204773 */   // GIR_Coverage, 47556,
     /* 2204773 */   GIR_EraseRootFromParent_Done,
     /* 2204774 */ // Label 29064: @2204774
     /* 2204774 */ GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2204828), // Rule ID 47557 //
     /* 2204779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2204785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204793 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2204810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204827 */   // GIR_Coverage, 47557,
     /* 2204827 */   GIR_EraseRootFromParent_Done,
     /* 2204828 */ // Label 29065: @2204828
     /* 2204828 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2204882), // Rule ID 47610 //
     /* 2204833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204847 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2204864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204869 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204881 */   // GIR_Coverage, 47610,
     /* 2204881 */   GIR_EraseRootFromParent_Done,
     /* 2204882 */ // Label 29066: @2204882
     /* 2204882 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2204936), // Rule ID 47611 //
     /* 2204887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204901 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2204918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204923 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204935 */   // GIR_Coverage, 47611,
     /* 2204935 */   GIR_EraseRootFromParent_Done,
     /* 2204936 */ // Label 29067: @2204936
     /* 2204936 */ GIM_Reject,
     /* 2204937 */ // Label 28997: @2204937
     /* 2204937 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2205040),
     /* 2204942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2204945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204953 */   GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2204996), // Rule ID 47546 //
     /* 2204958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204961 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2204964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2204978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204995 */     // GIR_Coverage, 47546,
     /* 2204995 */     GIR_EraseRootFromParent_Done,
     /* 2204996 */   // Label 29069: @2204996
     /* 2204996 */   GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2205039), // Rule ID 47547 //
     /* 2205001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2205004 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2205007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2205021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2205028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205038 */     // GIR_Coverage, 47547,
     /* 2205038 */     GIR_EraseRootFromParent_Done,
     /* 2205039 */   // Label 29070: @2205039
     /* 2205039 */   GIM_Reject,
     /* 2205040 */ // Label 29068: @2205040
     /* 2205040 */ GIM_Reject,
     /* 2205041 */ // Label 28998: @2205041
     /* 2205041 */ GIM_Reject,
     /* 2205042 */ // Label 41: @2205042
     /* 2205042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29073*/ GIMT_Encode4(2205556),
     /* 2205053 */ /*GILLT_s32*//*Label 29071*/ GIMT_Encode4(2205061),
     /* 2205057 */ /*GILLT_s64*//*Label 29072*/ GIMT_Encode4(2205293),
     /* 2205061 */ // Label 29071: @2205061
     /* 2205061 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2205292),
     /* 2205066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2205069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205077 */   GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2205105), // Rule ID 64462 //
     /* 2205082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2205085 */     // MIs[0] Operand 2
     /* 2205085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205096 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2205096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2205099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205104 */     // GIR_Coverage, 64462,
     /* 2205104 */     GIR_EraseRootFromParent_Done,
     /* 2205105 */   // Label 29075: @2205105
     /* 2205105 */   GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2205133), // Rule ID 64464 //
     /* 2205110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2205113 */     // MIs[0] Operand 2
     /* 2205113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205124 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2205124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2205127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205132 */     // GIR_Coverage, 64464,
     /* 2205132 */     GIR_EraseRootFromParent_Done,
     /* 2205133 */   // Label 29076: @2205133
     /* 2205133 */   GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2205161), // Rule ID 2517 //
     /* 2205138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2205141 */     // MIs[0] Operand 2
     /* 2205141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205152 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2205152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2205155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205160 */     // GIR_Coverage, 2517,
     /* 2205160 */     GIR_EraseRootFromParent_Done,
     /* 2205161 */   // Label 29077: @2205161
     /* 2205161 */   GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2205189), // Rule ID 2519 //
     /* 2205166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2205169 */     // MIs[0] Operand 2
     /* 2205169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205180 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2205180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2205183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205188 */     // GIR_Coverage, 2519,
     /* 2205188 */     GIR_EraseRootFromParent_Done,
     /* 2205189 */   // Label 29078: @2205189
     /* 2205189 */   GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2205223), // Rule ID 62548 //
     /* 2205194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2205197 */     // MIs[0] Operand 2
     /* 2205197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205208 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2205208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2205218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205222 */     // GIR_Coverage, 62548,
     /* 2205222 */     GIR_EraseRootFromParent_Done,
     /* 2205223 */   // Label 29079: @2205223
     /* 2205223 */   GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2205257), // Rule ID 62550 //
     /* 2205228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2205231 */     // MIs[0] Operand 2
     /* 2205231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205242 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2205242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205256 */     // GIR_Coverage, 62550,
     /* 2205256 */     GIR_EraseRootFromParent_Done,
     /* 2205257 */   // Label 29080: @2205257
     /* 2205257 */   GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2205291), // Rule ID 62552 //
     /* 2205262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2205265 */     // MIs[0] Operand 2
     /* 2205265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2205276 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2205276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205290 */     // GIR_Coverage, 62552,
     /* 2205290 */     GIR_EraseRootFromParent_Done,
     /* 2205291 */   // Label 29081: @2205291
     /* 2205291 */   GIM_Reject,
     /* 2205292 */ // Label 29074: @2205292
     /* 2205292 */ GIM_Reject,
     /* 2205293 */ // Label 29072: @2205293
     /* 2205293 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2205555),
     /* 2205298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2205301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205309 */   GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2205337), // Rule ID 64461 //
     /* 2205314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2205317 */     // MIs[0] Operand 2
     /* 2205317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205328 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2205328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2205331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205336 */     // GIR_Coverage, 64461,
     /* 2205336 */     GIR_EraseRootFromParent_Done,
     /* 2205337 */   // Label 29083: @2205337
     /* 2205337 */   GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2205365), // Rule ID 64463 //
     /* 2205342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2205345 */     // MIs[0] Operand 2
     /* 2205345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205356 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2205356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2205359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205364 */     // GIR_Coverage, 64463,
     /* 2205364 */     GIR_EraseRootFromParent_Done,
     /* 2205365 */   // Label 29084: @2205365
     /* 2205365 */   GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2205396), // Rule ID 256 //
     /* 2205370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2205373 */     // MIs[0] Operand 2
     /* 2205373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2205384 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2205384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2205387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205395 */     // GIR_Coverage, 256,
     /* 2205395 */     GIR_EraseRootFromParent_Done,
     /* 2205396 */   // Label 29085: @2205396
     /* 2205396 */   GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2205424), // Rule ID 2516 //
     /* 2205401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2205404 */     // MIs[0] Operand 2
     /* 2205404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205415 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2205415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2205418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205423 */     // GIR_Coverage, 2516,
     /* 2205423 */     GIR_EraseRootFromParent_Done,
     /* 2205424 */   // Label 29086: @2205424
     /* 2205424 */   GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2205452), // Rule ID 2518 //
     /* 2205429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2205432 */     // MIs[0] Operand 2
     /* 2205432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205443 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2205443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2205446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205451 */     // GIR_Coverage, 2518,
     /* 2205451 */     GIR_EraseRootFromParent_Done,
     /* 2205452 */   // Label 29087: @2205452
     /* 2205452 */   GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2205486), // Rule ID 62547 //
     /* 2205457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2205460 */     // MIs[0] Operand 2
     /* 2205460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2205471 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2205471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2205481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205485 */     // GIR_Coverage, 62547,
     /* 2205485 */     GIR_EraseRootFromParent_Done,
     /* 2205486 */   // Label 29088: @2205486
     /* 2205486 */   GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2205520), // Rule ID 62549 //
     /* 2205491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2205494 */     // MIs[0] Operand 2
     /* 2205494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2205505 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2205505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2205515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205519 */     // GIR_Coverage, 62549,
     /* 2205519 */     GIR_EraseRootFromParent_Done,
     /* 2205520 */   // Label 29089: @2205520
     /* 2205520 */   GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2205554), // Rule ID 62551 //
     /* 2205525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2205528 */     // MIs[0] Operand 2
     /* 2205528 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2205539 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2205539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2205542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2205552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205553 */     // GIR_Coverage, 62551,
     /* 2205553 */     GIR_EraseRootFromParent_Done,
     /* 2205554 */   // Label 29090: @2205554
     /* 2205554 */   GIM_Reject,
     /* 2205555 */ // Label 29082: @2205555
     /* 2205555 */ GIM_Reject,
     /* 2205556 */ // Label 29073: @2205556
     /* 2205556 */ GIM_Reject,
     /* 2205557 */ // Label 42: @2205557
     /* 2205557 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29108*/ GIMT_Encode4(2209243),
     /* 2205568 */ /*GILLT_s32*//*Label 29091*/ GIMT_Encode4(2205684),
     /* 2205572 */ /*GILLT_s64*//*Label 29092*/ GIMT_Encode4(2205980), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205584 */ /*GILLT_nxv1s16*//*Label 29093*/ GIMT_Encode4(2206234),
     /* 2205588 */ /*GILLT_nxv1s32*//*Label 29094*/ GIMT_Encode4(2206338),
     /* 2205592 */ /*GILLT_nxv1s64*//*Label 29095*/ GIMT_Encode4(2206555), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205604 */ /*GILLT_nxv2s16*//*Label 29096*/ GIMT_Encode4(2206880),
     /* 2205608 */ /*GILLT_nxv2s32*//*Label 29097*/ GIMT_Encode4(2206984),
     /* 2205612 */ /*GILLT_nxv2s64*//*Label 29098*/ GIMT_Encode4(2207201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205624 */ /*GILLT_nxv4s16*//*Label 29099*/ GIMT_Encode4(2207526),
     /* 2205628 */ /*GILLT_nxv4s32*//*Label 29100*/ GIMT_Encode4(2207630),
     /* 2205632 */ /*GILLT_nxv4s64*//*Label 29101*/ GIMT_Encode4(2207847), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205644 */ /*GILLT_nxv8s16*//*Label 29102*/ GIMT_Encode4(2208172),
     /* 2205648 */ /*GILLT_nxv8s32*//*Label 29103*/ GIMT_Encode4(2208276),
     /* 2205652 */ /*GILLT_nxv8s64*//*Label 29104*/ GIMT_Encode4(2208493), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205664 */ /*GILLT_nxv16s16*//*Label 29105*/ GIMT_Encode4(2208818),
     /* 2205668 */ /*GILLT_nxv16s32*//*Label 29106*/ GIMT_Encode4(2208922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2205680 */ /*GILLT_nxv32s16*//*Label 29107*/ GIMT_Encode4(2209139),
     /* 2205684 */ // Label 29091: @2205684
     /* 2205684 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2205979),
     /* 2205689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2205692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205700 */   GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2205742), // Rule ID 65134 //
     /* 2205705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2205708 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2205708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2205711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2205724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2205727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2205732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2205740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205741 */     // GIR_Coverage, 65134,
     /* 2205741 */     GIR_EraseRootFromParent_Done,
     /* 2205742 */   // Label 29110: @2205742
     /* 2205742 */   GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2205784), // Rule ID 65136 //
     /* 2205747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2205750 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2205750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2205753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2205766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2205769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2205774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2205782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205783 */     // GIR_Coverage, 65136,
     /* 2205783 */     GIR_EraseRootFromParent_Done,
     /* 2205784 */   // Label 29111: @2205784
     /* 2205784 */   GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2205826), // Rule ID 65137 //
     /* 2205789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2205792 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2205792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2205795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2205808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2205811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2205816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2205824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205825 */     // GIR_Coverage, 65137,
     /* 2205825 */     GIR_EraseRootFromParent_Done,
     /* 2205826 */   // Label 29112: @2205826
     /* 2205826 */   GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2205841), // Rule ID 65147 //
     /* 2205831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2205834 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2205834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2205839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205840 */     // GIR_Coverage, 65147,
     /* 2205840 */     GIR_Done,
     /* 2205841 */   // Label 29113: @2205841
     /* 2205841 */   GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2205856), // Rule ID 65148 //
     /* 2205846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2205849 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2205849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2205854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205855 */     // GIR_Coverage, 65148,
     /* 2205855 */     GIR_Done,
     /* 2205856 */   // Label 29114: @2205856
     /* 2205856 */   GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2205871), // Rule ID 65150 //
     /* 2205861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2205864 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2205864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2205869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205870 */     // GIR_Coverage, 65150,
     /* 2205870 */     GIR_Done,
     /* 2205871 */   // Label 29115: @2205871
     /* 2205871 */   GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2205886), // Rule ID 65151 //
     /* 2205876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2205879 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2205879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2205884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205885 */     // GIR_Coverage, 65151,
     /* 2205885 */     GIR_Done,
     /* 2205886 */   // Label 29116: @2205886
     /* 2205886 */   GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2205909), // Rule ID 65152 //
     /* 2205891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2205894 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2205894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2205897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2205901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205908 */     // GIR_Coverage, 65152,
     /* 2205908 */     GIR_EraseRootFromParent_Done,
     /* 2205909 */   // Label 29117: @2205909
     /* 2205909 */   GIM_Try, /*On fail goto*//*Label 29118*/ GIMT_Encode4(2205932), // Rule ID 65153 //
     /* 2205914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2205917 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2205917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2205920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2205924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205931 */     // GIR_Coverage, 65153,
     /* 2205931 */     GIR_EraseRootFromParent_Done,
     /* 2205932 */   // Label 29118: @2205932
     /* 2205932 */   GIM_Try, /*On fail goto*//*Label 29119*/ GIMT_Encode4(2205955), // Rule ID 65155 //
     /* 2205937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2205940 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2205940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2205943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2205947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205954 */     // GIR_Coverage, 65155,
     /* 2205954 */     GIR_EraseRootFromParent_Done,
     /* 2205955 */   // Label 29119: @2205955
     /* 2205955 */   GIM_Try, /*On fail goto*//*Label 29120*/ GIMT_Encode4(2205978), // Rule ID 65156 //
     /* 2205960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2205963 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2205963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2205966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2205970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205977 */     // GIR_Coverage, 65156,
     /* 2205977 */     GIR_EraseRootFromParent_Done,
     /* 2205978 */   // Label 29120: @2205978
     /* 2205978 */   GIM_Reject,
     /* 2205979 */ // Label 29109: @2205979
     /* 2205979 */ GIM_Reject,
     /* 2205980 */ // Label 29092: @2205980
     /* 2205980 */ GIM_Try, /*On fail goto*//*Label 29121*/ GIMT_Encode4(2206033), // Rule ID 65132 //
     /* 2205985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2205988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2205991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205999 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2205999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2206002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2206006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206011 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2206015 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2206018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2206023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2206031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206032 */   // GIR_Coverage, 65132,
     /* 2206032 */   GIR_EraseRootFromParent_Done,
     /* 2206033 */ // Label 29121: @2206033
     /* 2206033 */ GIM_Try, /*On fail goto*//*Label 29122*/ GIMT_Encode4(2206086), // Rule ID 65133 //
     /* 2206038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2206041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2206044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206052 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2206052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2206055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2206059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2206068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2206071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2206076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2206084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206085 */   // GIR_Coverage, 65133,
     /* 2206085 */   GIR_EraseRootFromParent_Done,
     /* 2206086 */ // Label 29122: @2206086
     /* 2206086 */ GIM_Try, /*On fail goto*//*Label 29123*/ GIMT_Encode4(2206139), // Rule ID 65135 //
     /* 2206091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2206094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2206097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206105 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2206105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2206108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2206112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2206121 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2206124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2206129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2206137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206138 */   // GIR_Coverage, 65135,
     /* 2206138 */   GIR_EraseRootFromParent_Done,
     /* 2206139 */ // Label 29123: @2206139
     /* 2206139 */ GIM_Try, /*On fail goto*//*Label 29124*/ GIMT_Encode4(2206173), // Rule ID 65143 //
     /* 2206144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2206147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2206150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206158 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2206158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2206161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2206165 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2206171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206172 */   // GIR_Coverage, 65143,
     /* 2206172 */   GIR_EraseRootFromParent_Done,
     /* 2206173 */ // Label 29124: @2206173
     /* 2206173 */ GIM_Try, /*On fail goto*//*Label 29125*/ GIMT_Encode4(2206199), // Rule ID 65149 //
     /* 2206178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2206181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2206184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206192 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2206192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2206197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206198 */   // GIR_Coverage, 65149,
     /* 2206198 */   GIR_Done,
     /* 2206199 */ // Label 29125: @2206199
     /* 2206199 */ GIM_Try, /*On fail goto*//*Label 29126*/ GIMT_Encode4(2206233), // Rule ID 65154 //
     /* 2206204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2206207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2206210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206218 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2206218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2206221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2206225 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2206231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206232 */   // GIR_Coverage, 65154,
     /* 2206232 */   GIR_EraseRootFromParent_Done,
     /* 2206233 */ // Label 29126: @2206233
     /* 2206233 */ GIM_Reject,
     /* 2206234 */ // Label 29093: @2206234
     /* 2206234 */ GIM_Try, /*On fail goto*//*Label 29127*/ GIMT_Encode4(2206337),
     /* 2206239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2206242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206250 */   GIM_Try, /*On fail goto*//*Label 29128*/ GIMT_Encode4(2206293), // Rule ID 45788 //
     /* 2206255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206258 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2206261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2206275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206292 */     // GIR_Coverage, 45788,
     /* 2206292 */     GIR_EraseRootFromParent_Done,
     /* 2206293 */   // Label 29128: @2206293
     /* 2206293 */   GIM_Try, /*On fail goto*//*Label 29129*/ GIMT_Encode4(2206336), // Rule ID 45789 //
     /* 2206298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206301 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2206304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2206318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206335 */     // GIR_Coverage, 45789,
     /* 2206335 */     GIR_EraseRootFromParent_Done,
     /* 2206336 */   // Label 29129: @2206336
     /* 2206336 */   GIM_Reject,
     /* 2206337 */ // Label 29127: @2206337
     /* 2206337 */ GIM_Reject,
     /* 2206338 */ // Label 29094: @2206338
     /* 2206338 */ GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2206392), // Rule ID 47500 //
     /* 2206343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206357 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2206374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206391 */   // GIR_Coverage, 47500,
     /* 2206391 */   GIR_EraseRootFromParent_Done,
     /* 2206392 */ // Label 29130: @2206392
     /* 2206392 */ GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2206446), // Rule ID 47501 //
     /* 2206397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206411 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2206428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206445 */   // GIR_Coverage, 47501,
     /* 2206445 */   GIR_EraseRootFromParent_Done,
     /* 2206446 */ // Label 29131: @2206446
     /* 2206446 */ GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2206500), // Rule ID 47566 //
     /* 2206451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2206457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206465 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2206482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206499 */   // GIR_Coverage, 47566,
     /* 2206499 */   GIR_EraseRootFromParent_Done,
     /* 2206500 */ // Label 29132: @2206500
     /* 2206500 */ GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2206554), // Rule ID 47567 //
     /* 2206505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2206511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206519 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2206536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206553 */   // GIR_Coverage, 47567,
     /* 2206553 */   GIR_EraseRootFromParent_Done,
     /* 2206554 */ // Label 29133: @2206554
     /* 2206554 */ GIM_Reject,
     /* 2206555 */ // Label 29095: @2206555
     /* 2206555 */ GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2206609), // Rule ID 47520 //
     /* 2206560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2206563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206574 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2206591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206608 */   // GIR_Coverage, 47520,
     /* 2206608 */   GIR_EraseRootFromParent_Done,
     /* 2206609 */ // Label 29134: @2206609
     /* 2206609 */ GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2206663), // Rule ID 47521 //
     /* 2206614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2206617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206628 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2206645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206650 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206662 */   // GIR_Coverage, 47521,
     /* 2206662 */   GIR_EraseRootFromParent_Done,
     /* 2206663 */ // Label 29135: @2206663
     /* 2206663 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2206717), // Rule ID 47586 //
     /* 2206668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2206671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206682 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2206699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206716 */   // GIR_Coverage, 47586,
     /* 2206716 */   GIR_EraseRootFromParent_Done,
     /* 2206717 */ // Label 29136: @2206717
     /* 2206717 */ GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2206771), // Rule ID 47587 //
     /* 2206722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2206725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206736 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2206753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206770 */   // GIR_Coverage, 47587,
     /* 2206770 */   GIR_EraseRootFromParent_Done,
     /* 2206771 */ // Label 29137: @2206771
     /* 2206771 */ GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2206825), // Rule ID 47620 //
     /* 2206776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2206779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2206782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206790 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2206807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206824 */   // GIR_Coverage, 47620,
     /* 2206824 */   GIR_EraseRootFromParent_Done,
     /* 2206825 */ // Label 29138: @2206825
     /* 2206825 */ GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2206879), // Rule ID 47621 //
     /* 2206830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2206833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2206836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206844 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2206861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206866 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2206874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206877 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206878 */   // GIR_Coverage, 47621,
     /* 2206878 */   GIR_EraseRootFromParent_Done,
     /* 2206879 */ // Label 29139: @2206879
     /* 2206879 */ GIM_Reject,
     /* 2206880 */ // Label 29096: @2206880
     /* 2206880 */ GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2206983),
     /* 2206885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2206888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206896 */   GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2206939), // Rule ID 47480 //
     /* 2206901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206904 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2206907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2206921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206938 */     // GIR_Coverage, 47480,
     /* 2206938 */     GIR_EraseRootFromParent_Done,
     /* 2206939 */   // Label 29141: @2206939
     /* 2206939 */   GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2206982), // Rule ID 47481 //
     /* 2206944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206947 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2206950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2206964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2206971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206981 */     // GIR_Coverage, 47481,
     /* 2206981 */     GIR_EraseRootFromParent_Done,
     /* 2206982 */   // Label 29142: @2206982
     /* 2206982 */   GIM_Reject,
     /* 2206983 */ // Label 29140: @2206983
     /* 2206983 */ GIM_Reject,
     /* 2206984 */ // Label 29097: @2206984
     /* 2206984 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2207038), // Rule ID 47504 //
     /* 2206989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2206995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207003 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2207020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207037 */   // GIR_Coverage, 47504,
     /* 2207037 */   GIR_EraseRootFromParent_Done,
     /* 2207038 */ // Label 29143: @2207038
     /* 2207038 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2207092), // Rule ID 47505 //
     /* 2207043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207057 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2207074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207091 */   // GIR_Coverage, 47505,
     /* 2207091 */   GIR_EraseRootFromParent_Done,
     /* 2207092 */ // Label 29144: @2207092
     /* 2207092 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2207146), // Rule ID 47570 //
     /* 2207097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207111 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2207128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207145 */   // GIR_Coverage, 47570,
     /* 2207145 */   GIR_EraseRootFromParent_Done,
     /* 2207146 */ // Label 29145: @2207146
     /* 2207146 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2207200), // Rule ID 47571 //
     /* 2207151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207165 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2207182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207199 */   // GIR_Coverage, 47571,
     /* 2207199 */   GIR_EraseRootFromParent_Done,
     /* 2207200 */ // Label 29146: @2207200
     /* 2207200 */ GIM_Reject,
     /* 2207201 */ // Label 29098: @2207201
     /* 2207201 */ GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2207255), // Rule ID 47524 //
     /* 2207206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2207209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2207212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207220 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2207237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207242 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207254 */   // GIR_Coverage, 47524,
     /* 2207254 */   GIR_EraseRootFromParent_Done,
     /* 2207255 */ // Label 29147: @2207255
     /* 2207255 */ GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2207309), // Rule ID 47525 //
     /* 2207260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2207263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2207266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207274 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2207291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207296 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207308 */   // GIR_Coverage, 47525,
     /* 2207308 */   GIR_EraseRootFromParent_Done,
     /* 2207309 */ // Label 29148: @2207309
     /* 2207309 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2207363), // Rule ID 47590 //
     /* 2207314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2207317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207328 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2207345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207362 */   // GIR_Coverage, 47590,
     /* 2207362 */   GIR_EraseRootFromParent_Done,
     /* 2207363 */ // Label 29149: @2207363
     /* 2207363 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2207417), // Rule ID 47591 //
     /* 2207368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2207371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207382 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2207399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207416 */   // GIR_Coverage, 47591,
     /* 2207416 */   GIR_EraseRootFromParent_Done,
     /* 2207417 */ // Label 29150: @2207417
     /* 2207417 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2207471), // Rule ID 47624 //
     /* 2207422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2207425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207436 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2207453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207470 */   // GIR_Coverage, 47624,
     /* 2207470 */   GIR_EraseRootFromParent_Done,
     /* 2207471 */ // Label 29151: @2207471
     /* 2207471 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2207525), // Rule ID 47625 //
     /* 2207476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2207479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207490 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2207493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2207507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207524 */   // GIR_Coverage, 47625,
     /* 2207524 */   GIR_EraseRootFromParent_Done,
     /* 2207525 */ // Label 29152: @2207525
     /* 2207525 */ GIM_Reject,
     /* 2207526 */ // Label 29099: @2207526
     /* 2207526 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2207629),
     /* 2207531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2207534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207542 */   GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2207585), // Rule ID 47484 //
     /* 2207547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207550 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2207553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2207567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207584 */     // GIR_Coverage, 47484,
     /* 2207584 */     GIR_EraseRootFromParent_Done,
     /* 2207585 */   // Label 29154: @2207585
     /* 2207585 */   GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2207628), // Rule ID 47485 //
     /* 2207590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207593 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2207596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2207610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207627 */     // GIR_Coverage, 47485,
     /* 2207627 */     GIR_EraseRootFromParent_Done,
     /* 2207628 */   // Label 29155: @2207628
     /* 2207628 */   GIM_Reject,
     /* 2207629 */ // Label 29153: @2207629
     /* 2207629 */ GIM_Reject,
     /* 2207630 */ // Label 29100: @2207630
     /* 2207630 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2207684), // Rule ID 47508 //
     /* 2207635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2207641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207649 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2207652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2207666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207683 */   // GIR_Coverage, 47508,
     /* 2207683 */   GIR_EraseRootFromParent_Done,
     /* 2207684 */ // Label 29156: @2207684
     /* 2207684 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2207738), // Rule ID 47509 //
     /* 2207689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2207695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207703 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2207706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2207720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207725 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207737 */   // GIR_Coverage, 47509,
     /* 2207737 */   GIR_EraseRootFromParent_Done,
     /* 2207738 */ // Label 29157: @2207738
     /* 2207738 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2207792), // Rule ID 47574 //
     /* 2207743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2207749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207757 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2207760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2207774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207791 */   // GIR_Coverage, 47574,
     /* 2207791 */   GIR_EraseRootFromParent_Done,
     /* 2207792 */ // Label 29158: @2207792
     /* 2207792 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2207846), // Rule ID 47575 //
     /* 2207797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2207803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207811 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2207814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2207828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207833 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207845 */   // GIR_Coverage, 47575,
     /* 2207845 */   GIR_EraseRootFromParent_Done,
     /* 2207846 */ // Label 29159: @2207846
     /* 2207846 */ GIM_Reject,
     /* 2207847 */ // Label 29101: @2207847
     /* 2207847 */ GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2207901), // Rule ID 47528 //
     /* 2207852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2207855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2207858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207866 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2207869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2207883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207888 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207900 */   // GIR_Coverage, 47528,
     /* 2207900 */   GIR_EraseRootFromParent_Done,
     /* 2207901 */ // Label 29160: @2207901
     /* 2207901 */ GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2207955), // Rule ID 47529 //
     /* 2207906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2207909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2207912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2207920 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2207923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2207937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207942 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207954 */   // GIR_Coverage, 47529,
     /* 2207954 */   GIR_EraseRootFromParent_Done,
     /* 2207955 */ // Label 29161: @2207955
     /* 2207955 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2208009), // Rule ID 47594 //
     /* 2207960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2207963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2207966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2207970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207974 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2207977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2207991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207996 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208008 */   // GIR_Coverage, 47594,
     /* 2208008 */   GIR_EraseRootFromParent_Done,
     /* 2208009 */ // Label 29162: @2208009
     /* 2208009 */ GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2208063), // Rule ID 47595 //
     /* 2208014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2208020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208028 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2208031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2208045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208050 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208062 */   // GIR_Coverage, 47595,
     /* 2208062 */   GIR_EraseRootFromParent_Done,
     /* 2208063 */ // Label 29163: @2208063
     /* 2208063 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2208117), // Rule ID 47628 //
     /* 2208068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208082 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2208085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2208099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208116 */   // GIR_Coverage, 47628,
     /* 2208116 */   GIR_EraseRootFromParent_Done,
     /* 2208117 */ // Label 29164: @2208117
     /* 2208117 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2208171), // Rule ID 47629 //
     /* 2208122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208136 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2208139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2208153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208170 */   // GIR_Coverage, 47629,
     /* 2208170 */   GIR_EraseRootFromParent_Done,
     /* 2208171 */ // Label 29165: @2208171
     /* 2208171 */ GIM_Reject,
     /* 2208172 */ // Label 29102: @2208172
     /* 2208172 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2208275),
     /* 2208177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2208180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208188 */   GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2208231), // Rule ID 47488 //
     /* 2208193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208196 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2208199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208230 */     // GIR_Coverage, 47488,
     /* 2208230 */     GIR_EraseRootFromParent_Done,
     /* 2208231 */   // Label 29167: @2208231
     /* 2208231 */   GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2208274), // Rule ID 47489 //
     /* 2208236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208239 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2208242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208273 */     // GIR_Coverage, 47489,
     /* 2208273 */     GIR_EraseRootFromParent_Done,
     /* 2208274 */   // Label 29168: @2208274
     /* 2208274 */   GIM_Reject,
     /* 2208275 */ // Label 29166: @2208275
     /* 2208275 */ GIM_Reject,
     /* 2208276 */ // Label 29103: @2208276
     /* 2208276 */ GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2208330), // Rule ID 47512 //
     /* 2208281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2208287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208295 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2208312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208317 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208329 */   // GIR_Coverage, 47512,
     /* 2208329 */   GIR_EraseRootFromParent_Done,
     /* 2208330 */ // Label 29169: @2208330
     /* 2208330 */ GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2208384), // Rule ID 47513 //
     /* 2208335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2208341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208349 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2208366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208371 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208383 */   // GIR_Coverage, 47513,
     /* 2208383 */   GIR_EraseRootFromParent_Done,
     /* 2208384 */ // Label 29170: @2208384
     /* 2208384 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2208438), // Rule ID 47578 //
     /* 2208389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2208395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208403 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2208420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208437 */   // GIR_Coverage, 47578,
     /* 2208437 */   GIR_EraseRootFromParent_Done,
     /* 2208438 */ // Label 29171: @2208438
     /* 2208438 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2208492), // Rule ID 47579 //
     /* 2208443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2208449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208457 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2208460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2208474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208491 */   // GIR_Coverage, 47579,
     /* 2208491 */   GIR_EraseRootFromParent_Done,
     /* 2208492 */ // Label 29172: @2208492
     /* 2208492 */ GIM_Reject,
     /* 2208493 */ // Label 29104: @2208493
     /* 2208493 */ GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2208547), // Rule ID 47532 //
     /* 2208498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2208504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208512 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2208529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208546 */   // GIR_Coverage, 47532,
     /* 2208546 */   GIR_EraseRootFromParent_Done,
     /* 2208547 */ // Label 29173: @2208547
     /* 2208547 */ GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2208601), // Rule ID 47533 //
     /* 2208552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2208558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208566 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2208583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208600 */   // GIR_Coverage, 47533,
     /* 2208600 */   GIR_EraseRootFromParent_Done,
     /* 2208601 */ // Label 29174: @2208601
     /* 2208601 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2208655), // Rule ID 47598 //
     /* 2208606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2208612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208620 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2208637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208654 */   // GIR_Coverage, 47598,
     /* 2208654 */   GIR_EraseRootFromParent_Done,
     /* 2208655 */ // Label 29175: @2208655
     /* 2208655 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2208709), // Rule ID 47599 //
     /* 2208660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2208666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208674 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2208691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208708 */   // GIR_Coverage, 47599,
     /* 2208708 */   GIR_EraseRootFromParent_Done,
     /* 2208709 */ // Label 29176: @2208709
     /* 2208709 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2208763), // Rule ID 47632 //
     /* 2208714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2208720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208728 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2208745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208762 */   // GIR_Coverage, 47632,
     /* 2208762 */   GIR_EraseRootFromParent_Done,
     /* 2208763 */ // Label 29177: @2208763
     /* 2208763 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2208817), // Rule ID 47633 //
     /* 2208768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2208774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208782 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2208785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2208799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208816 */   // GIR_Coverage, 47633,
     /* 2208816 */   GIR_EraseRootFromParent_Done,
     /* 2208817 */ // Label 29178: @2208817
     /* 2208817 */ GIM_Reject,
     /* 2208818 */ // Label 29105: @2208818
     /* 2208818 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2208921),
     /* 2208823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2208826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208834 */   GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2208877), // Rule ID 47492 //
     /* 2208839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208842 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2208845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2208859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208876 */     // GIR_Coverage, 47492,
     /* 2208876 */     GIR_EraseRootFromParent_Done,
     /* 2208877 */   // Label 29180: @2208877
     /* 2208877 */   GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2208920), // Rule ID 47493 //
     /* 2208882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208885 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2208888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2208902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208919 */     // GIR_Coverage, 47493,
     /* 2208919 */     GIR_EraseRootFromParent_Done,
     /* 2208920 */   // Label 29181: @2208920
     /* 2208920 */   GIM_Reject,
     /* 2208921 */ // Label 29179: @2208921
     /* 2208921 */ GIM_Reject,
     /* 2208922 */ // Label 29106: @2208922
     /* 2208922 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2208976), // Rule ID 47516 //
     /* 2208927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2208933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208941 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2208944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2208958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208963 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208975 */   // GIR_Coverage, 47516,
     /* 2208975 */   GIR_EraseRootFromParent_Done,
     /* 2208976 */ // Label 29182: @2208976
     /* 2208976 */ GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2209030), // Rule ID 47517 //
     /* 2208981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2208987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2208991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2208995 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2208998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2209012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209017 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209029 */   // GIR_Coverage, 47517,
     /* 2209029 */   GIR_EraseRootFromParent_Done,
     /* 2209030 */ // Label 29183: @2209030
     /* 2209030 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2209084), // Rule ID 47582 //
     /* 2209035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2209041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209049 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2209052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2209066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209083 */   // GIR_Coverage, 47582,
     /* 2209083 */   GIR_EraseRootFromParent_Done,
     /* 2209084 */ // Label 29184: @2209084
     /* 2209084 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2209138), // Rule ID 47583 //
     /* 2209089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2209095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209103 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2209106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2209120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209137 */   // GIR_Coverage, 47583,
     /* 2209137 */   GIR_EraseRootFromParent_Done,
     /* 2209138 */ // Label 29185: @2209138
     /* 2209138 */ GIM_Reject,
     /* 2209139 */ // Label 29107: @2209139
     /* 2209139 */ GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2209242),
     /* 2209144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2209147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209155 */   GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2209198), // Rule ID 47496 //
     /* 2209160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209163 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2209166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2209180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209197 */     // GIR_Coverage, 47496,
     /* 2209197 */     GIR_EraseRootFromParent_Done,
     /* 2209198 */   // Label 29187: @2209198
     /* 2209198 */   GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2209241), // Rule ID 47497 //
     /* 2209203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209206 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2209209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2209223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209240 */     // GIR_Coverage, 47497,
     /* 2209240 */     GIR_EraseRootFromParent_Done,
     /* 2209241 */   // Label 29188: @2209241
     /* 2209241 */   GIM_Reject,
     /* 2209242 */ // Label 29186: @2209242
     /* 2209242 */ GIM_Reject,
     /* 2209243 */ // Label 29108: @2209243
     /* 2209243 */ GIM_Reject,
     /* 2209244 */ // Label 43: @2209244
     /* 2209244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29213*/ GIMT_Encode4(2217839),
     /* 2209255 */ /*GILLT_s32*//*Label 29189*/ GIMT_Encode4(2209379),
     /* 2209259 */ /*GILLT_s64*//*Label 29190*/ GIMT_Encode4(2209504), GIMT_Encode4(0),
     /* 2209267 */ /*GILLT_nxv1s8*//*Label 29191*/ GIMT_Encode4(2209849),
     /* 2209271 */ /*GILLT_nxv1s16*//*Label 29192*/ GIMT_Encode4(2209964),
     /* 2209275 */ /*GILLT_nxv1s32*//*Label 29193*/ GIMT_Encode4(2210443),
     /* 2209279 */ /*GILLT_nxv1s64*//*Label 29194*/ GIMT_Encode4(2210922), GIMT_Encode4(0),
     /* 2209287 */ /*GILLT_nxv2s8*//*Label 29195*/ GIMT_Encode4(2211401),
     /* 2209291 */ /*GILLT_nxv2s16*//*Label 29196*/ GIMT_Encode4(2211516),
     /* 2209295 */ /*GILLT_nxv2s32*//*Label 29197*/ GIMT_Encode4(2211995),
     /* 2209299 */ /*GILLT_nxv2s64*//*Label 29198*/ GIMT_Encode4(2212474), GIMT_Encode4(0),
     /* 2209307 */ /*GILLT_nxv4s8*//*Label 29199*/ GIMT_Encode4(2212953),
     /* 2209311 */ /*GILLT_nxv4s16*//*Label 29200*/ GIMT_Encode4(2213068),
     /* 2209315 */ /*GILLT_nxv4s32*//*Label 29201*/ GIMT_Encode4(2213547),
     /* 2209319 */ /*GILLT_nxv4s64*//*Label 29202*/ GIMT_Encode4(2214026), GIMT_Encode4(0),
     /* 2209327 */ /*GILLT_nxv8s8*//*Label 29203*/ GIMT_Encode4(2214505),
     /* 2209331 */ /*GILLT_nxv8s16*//*Label 29204*/ GIMT_Encode4(2214620),
     /* 2209335 */ /*GILLT_nxv8s32*//*Label 29205*/ GIMT_Encode4(2215099),
     /* 2209339 */ /*GILLT_nxv8s64*//*Label 29206*/ GIMT_Encode4(2215578), GIMT_Encode4(0),
     /* 2209347 */ /*GILLT_nxv16s8*//*Label 29207*/ GIMT_Encode4(2216057),
     /* 2209351 */ /*GILLT_nxv16s16*//*Label 29208*/ GIMT_Encode4(2216172),
     /* 2209355 */ /*GILLT_nxv16s32*//*Label 29209*/ GIMT_Encode4(2216651), GIMT_Encode4(0),
     /* 2209363 */ /*GILLT_nxv32s8*//*Label 29210*/ GIMT_Encode4(2217130),
     /* 2209367 */ /*GILLT_nxv32s16*//*Label 29211*/ GIMT_Encode4(2217245), GIMT_Encode4(0),
     /* 2209375 */ /*GILLT_nxv64s8*//*Label 29212*/ GIMT_Encode4(2217724),
     /* 2209379 */ // Label 29189: @2209379
     /* 2209379 */ GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2209503),
     /* 2209384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2209387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2209390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209394 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2209431), // Rule ID 2473 //
     /* 2209399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2209402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2209406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2209413 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2209413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2209416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2209424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2209429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209430 */     // GIR_Coverage, 2473,
     /* 2209430 */     GIR_EraseRootFromParent_Done,
     /* 2209431 */   // Label 29215: @2209431
     /* 2209431 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2209469), // Rule ID 91 //
     /* 2209436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2209447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2209451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2209455 */     // MIs[1] Operand 1
     /* 2209455 */     // No operand predicates
     /* 2209455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2209457 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2209457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2209460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2209467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209468 */     // GIR_Coverage, 91,
     /* 2209468 */     GIR_EraseRootFromParent_Done,
     /* 2209469 */   // Label 29216: @2209469
     /* 2209469 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2209502), // Rule ID 105 //
     /* 2209474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2209477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2209488 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2209488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2209491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2209500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209501 */     // GIR_Coverage, 105,
     /* 2209501 */     GIR_EraseRootFromParent_Done,
     /* 2209502 */   // Label 29217: @2209502
     /* 2209502 */   GIM_Reject,
     /* 2209503 */ // Label 29214: @2209503
     /* 2209503 */ GIM_Reject,
     /* 2209504 */ // Label 29190: @2209504
     /* 2209504 */ GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2209848),
     /* 2209509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2209512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2209515 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2209609), // Rule ID 253 //
     /* 2209520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2209523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2209535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2209539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2209543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209548 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2209559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2209567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2209571 */     // MIs[2] Operand 1
     /* 2209571 */     // No operand predicates
     /* 2209571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209573 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2209573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2209576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2209580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2209589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2209592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2209597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209602 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2209607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209608 */     // GIR_Coverage, 253,
     /* 2209608 */     GIR_EraseRootFromParent_Done,
     /* 2209609 */   // Label 29219: @2209609
     /* 2209609 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2209681), // Rule ID 2611 //
     /* 2209614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2209617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2209629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2209633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2209637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209642 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2209653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2209661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2209665 */     // MIs[2] Operand 1
     /* 2209665 */     // No operand predicates
     /* 2209665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209667 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2209667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2209670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2209676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2209679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209680 */     // GIR_Coverage, 2611,
     /* 2209680 */     GIR_EraseRootFromParent_Done,
     /* 2209681 */   // Label 29220: @2209681
     /* 2209681 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2209722), // Rule ID 2472 //
     /* 2209686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2209689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2209697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2209704 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2209704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2209707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2209715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2209720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209721 */     // GIR_Coverage, 2472,
     /* 2209721 */     GIR_EraseRootFromParent_Done,
     /* 2209722 */   // Label 29221: @2209722
     /* 2209722 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2209768), // Rule ID 268 //
     /* 2209727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2209730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2209742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2209746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2209750 */     // MIs[1] Operand 1
     /* 2209750 */     // No operand predicates
     /* 2209750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10052),
     /* 2209754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2209756 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10052>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2209756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2209759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2209766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209767 */     // GIR_Coverage, 268,
     /* 2209767 */     GIR_EraseRootFromParent_Done,
     /* 2209768 */   // Label 29222: @2209768
     /* 2209768 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2209810), // Rule ID 90 //
     /* 2209773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2209788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2209792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2209796 */     // MIs[1] Operand 1
     /* 2209796 */     // No operand predicates
     /* 2209796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2209798 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2209798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2209801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2209808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209809 */     // GIR_Coverage, 90,
     /* 2209809 */     GIR_EraseRootFromParent_Done,
     /* 2209810 */   // Label 29223: @2209810
     /* 2209810 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2209847), // Rule ID 104 //
     /* 2209815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2209818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2209826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2209833 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2209833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2209836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2209845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209846 */     // GIR_Coverage, 104,
     /* 2209846 */     GIR_EraseRootFromParent_Done,
     /* 2209847 */   // Label 29224: @2209847
     /* 2209847 */   GIM_Reject,
     /* 2209848 */ // Label 29218: @2209848
     /* 2209848 */ GIM_Reject,
     /* 2209849 */ // Label 29191: @2209849
     /* 2209849 */ GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2209963),
     /* 2209854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2209857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2209860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209872 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2209917), // Rule ID 48040 //
     /* 2209877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209880 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2209883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2209897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209916 */     // GIR_Coverage, 48040,
     /* 2209916 */     GIR_EraseRootFromParent_Done,
     /* 2209917 */   // Label 29226: @2209917
     /* 2209917 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2209962), // Rule ID 48041 //
     /* 2209922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209925 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2209928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2209942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209961 */     // GIR_Coverage, 48041,
     /* 2209961 */     GIR_EraseRootFromParent_Done,
     /* 2209962 */   // Label 29227: @2209962
     /* 2209962 */   GIM_Reject,
     /* 2209963 */ // Label 29225: @2209963
     /* 2209963 */ GIM_Reject,
     /* 2209964 */ // Label 29192: @2209964
     /* 2209964 */ GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2210442),
     /* 2209969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2209972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2209975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209979 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2210068), // Rule ID 59528 //
     /* 2209984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2209987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2209999 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210018 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210027 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2210044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210067 */     // GIR_Coverage, 59528,
     /* 2210067 */     GIR_EraseRootFromParent_Done,
     /* 2210068 */   // Label 29229: @2210068
     /* 2210068 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2210157), // Rule ID 59529 //
     /* 2210073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210088 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210107 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210116 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2210133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210156 */     // GIR_Coverage, 59529,
     /* 2210156 */     GIR_EraseRootFromParent_Done,
     /* 2210157 */   // Label 29230: @2210157
     /* 2210157 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2210246), // Rule ID 59530 //
     /* 2210162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210177 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210196 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210205 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2210222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210245 */     // GIR_Coverage, 59530,
     /* 2210245 */     GIR_EraseRootFromParent_Done,
     /* 2210246 */   // Label 29231: @2210246
     /* 2210246 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2210335), // Rule ID 59531 //
     /* 2210251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210266 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2210285 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210294 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2210311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210334 */     // GIR_Coverage, 59531,
     /* 2210334 */     GIR_EraseRootFromParent_Done,
     /* 2210335 */   // Label 29232: @2210335
     /* 2210335 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2210388), // Rule ID 48052 //
     /* 2210340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210351 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2210368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210387 */     // GIR_Coverage, 48052,
     /* 2210387 */     GIR_EraseRootFromParent_Done,
     /* 2210388 */   // Label 29233: @2210388
     /* 2210388 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2210441), // Rule ID 48053 //
     /* 2210393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210404 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2210407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2210421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210440 */     // GIR_Coverage, 48053,
     /* 2210440 */     GIR_EraseRootFromParent_Done,
     /* 2210441 */   // Label 29234: @2210441
     /* 2210441 */   GIM_Reject,
     /* 2210442 */ // Label 29228: @2210442
     /* 2210442 */ GIM_Reject,
     /* 2210443 */ // Label 29193: @2210443
     /* 2210443 */ GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2210921),
     /* 2210448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2210451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2210454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210458 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2210547), // Rule ID 59576 //
     /* 2210463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210478 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210497 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210506 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2210523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210546 */     // GIR_Coverage, 59576,
     /* 2210546 */     GIR_EraseRootFromParent_Done,
     /* 2210547 */   // Label 29236: @2210547
     /* 2210547 */   GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2210636), // Rule ID 59577 //
     /* 2210552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210567 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210586 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210595 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2210612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210635 */     // GIR_Coverage, 59577,
     /* 2210635 */     GIR_EraseRootFromParent_Done,
     /* 2210636 */   // Label 29237: @2210636
     /* 2210636 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2210725), // Rule ID 59578 //
     /* 2210641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210656 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210675 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210684 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2210701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210724 */     // GIR_Coverage, 59578,
     /* 2210724 */     GIR_EraseRootFromParent_Done,
     /* 2210725 */   // Label 29238: @2210725
     /* 2210725 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2210814), // Rule ID 59579 //
     /* 2210730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210745 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2210764 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210773 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2210790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210813 */     // GIR_Coverage, 59579,
     /* 2210813 */     GIR_EraseRootFromParent_Done,
     /* 2210814 */   // Label 29239: @2210814
     /* 2210814 */   GIM_Try, /*On fail goto*//*Label 29240*/ GIMT_Encode4(2210867), // Rule ID 48060 //
     /* 2210819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210830 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2210847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210866 */     // GIR_Coverage, 48060,
     /* 2210866 */     GIR_EraseRootFromParent_Done,
     /* 2210867 */   // Label 29240: @2210867
     /* 2210867 */   GIM_Try, /*On fail goto*//*Label 29241*/ GIMT_Encode4(2210920), // Rule ID 48061 //
     /* 2210872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210883 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2210886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2210900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210919 */     // GIR_Coverage, 48061,
     /* 2210919 */     GIR_EraseRootFromParent_Done,
     /* 2210920 */   // Label 29241: @2210920
     /* 2210920 */   GIM_Reject,
     /* 2210921 */ // Label 29235: @2210921
     /* 2210921 */ GIM_Reject,
     /* 2210922 */ // Label 29194: @2210922
     /* 2210922 */ GIM_Try, /*On fail goto*//*Label 29242*/ GIMT_Encode4(2211400),
     /* 2210927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2210930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2210933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210937 */   GIM_Try, /*On fail goto*//*Label 29243*/ GIMT_Encode4(2211026), // Rule ID 59616 //
     /* 2210942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2210957 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2210976 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210985 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2210988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2211002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211025 */     // GIR_Coverage, 59616,
     /* 2211025 */     GIR_EraseRootFromParent_Done,
     /* 2211026 */   // Label 29243: @2211026
     /* 2211026 */   GIM_Try, /*On fail goto*//*Label 29244*/ GIMT_Encode4(2211115), // Rule ID 59617 //
     /* 2211031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211046 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211065 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211074 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2211091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211114 */     // GIR_Coverage, 59617,
     /* 2211114 */     GIR_EraseRootFromParent_Done,
     /* 2211115 */   // Label 29244: @2211115
     /* 2211115 */   GIM_Try, /*On fail goto*//*Label 29245*/ GIMT_Encode4(2211204), // Rule ID 59618 //
     /* 2211120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211135 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211154 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211163 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2211180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211203 */     // GIR_Coverage, 59618,
     /* 2211203 */     GIR_EraseRootFromParent_Done,
     /* 2211204 */   // Label 29245: @2211204
     /* 2211204 */   GIM_Try, /*On fail goto*//*Label 29246*/ GIMT_Encode4(2211293), // Rule ID 59619 //
     /* 2211209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211224 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211243 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211252 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2211269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211292 */     // GIR_Coverage, 59619,
     /* 2211292 */     GIR_EraseRootFromParent_Done,
     /* 2211293 */   // Label 29246: @2211293
     /* 2211293 */   GIM_Try, /*On fail goto*//*Label 29247*/ GIMT_Encode4(2211346), // Rule ID 48076 //
     /* 2211298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2211301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211309 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2211326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211345 */     // GIR_Coverage, 48076,
     /* 2211345 */     GIR_EraseRootFromParent_Done,
     /* 2211346 */   // Label 29247: @2211346
     /* 2211346 */   GIM_Try, /*On fail goto*//*Label 29248*/ GIMT_Encode4(2211399), // Rule ID 48077 //
     /* 2211351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2211354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211362 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2211379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211398 */     // GIR_Coverage, 48077,
     /* 2211398 */     GIR_EraseRootFromParent_Done,
     /* 2211399 */   // Label 29248: @2211399
     /* 2211399 */   GIM_Reject,
     /* 2211400 */ // Label 29242: @2211400
     /* 2211400 */ GIM_Reject,
     /* 2211401 */ // Label 29195: @2211401
     /* 2211401 */ GIM_Try, /*On fail goto*//*Label 29249*/ GIMT_Encode4(2211515),
     /* 2211406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2211412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211424 */   GIM_Try, /*On fail goto*//*Label 29250*/ GIMT_Encode4(2211469), // Rule ID 48044 //
     /* 2211429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211432 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2211435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2211449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211468 */     // GIR_Coverage, 48044,
     /* 2211468 */     GIR_EraseRootFromParent_Done,
     /* 2211469 */   // Label 29250: @2211469
     /* 2211469 */   GIM_Try, /*On fail goto*//*Label 29251*/ GIMT_Encode4(2211514), // Rule ID 48045 //
     /* 2211474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211477 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2211480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2211494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211513 */     // GIR_Coverage, 48045,
     /* 2211513 */     GIR_EraseRootFromParent_Done,
     /* 2211514 */   // Label 29251: @2211514
     /* 2211514 */   GIM_Reject,
     /* 2211515 */ // Label 29249: @2211515
     /* 2211515 */ GIM_Reject,
     /* 2211516 */ // Label 29196: @2211516
     /* 2211516 */ GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2211994),
     /* 2211521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2211524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2211527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211531 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2211620), // Rule ID 59536 //
     /* 2211536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2211539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211551 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211570 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211579 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2211596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211619 */     // GIR_Coverage, 59536,
     /* 2211619 */     GIR_EraseRootFromParent_Done,
     /* 2211620 */   // Label 29253: @2211620
     /* 2211620 */   GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2211709), // Rule ID 59537 //
     /* 2211625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2211628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211640 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211659 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211668 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2211685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211708 */     // GIR_Coverage, 59537,
     /* 2211708 */     GIR_EraseRootFromParent_Done,
     /* 2211709 */   // Label 29254: @2211709
     /* 2211709 */   GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2211798), // Rule ID 59538 //
     /* 2211714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2211717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211729 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211748 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211757 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2211774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211797 */     // GIR_Coverage, 59538,
     /* 2211797 */     GIR_EraseRootFromParent_Done,
     /* 2211798 */   // Label 29255: @2211798
     /* 2211798 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2211887), // Rule ID 59539 //
     /* 2211803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2211806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211818 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211837 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211846 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2211863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211886 */     // GIR_Coverage, 59539,
     /* 2211886 */     GIR_EraseRootFromParent_Done,
     /* 2211887 */   // Label 29256: @2211887
     /* 2211887 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2211940), // Rule ID 48056 //
     /* 2211892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211903 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2211920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211939 */     // GIR_Coverage, 48056,
     /* 2211939 */     GIR_EraseRootFromParent_Done,
     /* 2211940 */   // Label 29257: @2211940
     /* 2211940 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2211993), // Rule ID 48057 //
     /* 2211945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211956 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2211973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211992 */     // GIR_Coverage, 48057,
     /* 2211992 */     GIR_EraseRootFromParent_Done,
     /* 2211993 */   // Label 29258: @2211993
     /* 2211993 */   GIM_Reject,
     /* 2211994 */ // Label 29252: @2211994
     /* 2211994 */ GIM_Reject,
     /* 2211995 */ // Label 29197: @2211995
     /* 2211995 */ GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2212473),
     /* 2212000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2212006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212010 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2212099), // Rule ID 59584 //
     /* 2212015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212030 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212049 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212058 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2212075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212098 */     // GIR_Coverage, 59584,
     /* 2212098 */     GIR_EraseRootFromParent_Done,
     /* 2212099 */   // Label 29260: @2212099
     /* 2212099 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2212188), // Rule ID 59585 //
     /* 2212104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2212107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212119 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212138 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212147 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2212164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212187 */     // GIR_Coverage, 59585,
     /* 2212187 */     GIR_EraseRootFromParent_Done,
     /* 2212188 */   // Label 29261: @2212188
     /* 2212188 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2212277), // Rule ID 59586 //
     /* 2212193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212208 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212227 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212236 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2212253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212276 */     // GIR_Coverage, 59586,
     /* 2212276 */     GIR_EraseRootFromParent_Done,
     /* 2212277 */   // Label 29262: @2212277
     /* 2212277 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2212366), // Rule ID 59587 //
     /* 2212282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2212285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212297 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212316 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212325 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2212342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212365 */     // GIR_Coverage, 59587,
     /* 2212365 */     GIR_EraseRootFromParent_Done,
     /* 2212366 */   // Label 29263: @2212366
     /* 2212366 */   GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2212419), // Rule ID 48072 //
     /* 2212371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212382 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2212399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212418 */     // GIR_Coverage, 48072,
     /* 2212418 */     GIR_EraseRootFromParent_Done,
     /* 2212419 */   // Label 29264: @2212419
     /* 2212419 */   GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2212472), // Rule ID 48073 //
     /* 2212424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212435 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2212452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212471 */     // GIR_Coverage, 48073,
     /* 2212471 */     GIR_EraseRootFromParent_Done,
     /* 2212472 */   // Label 29265: @2212472
     /* 2212472 */   GIM_Reject,
     /* 2212473 */ // Label 29259: @2212473
     /* 2212473 */ GIM_Reject,
     /* 2212474 */ // Label 29198: @2212474
     /* 2212474 */ GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2212952),
     /* 2212479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2212482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2212485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212489 */   GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2212578), // Rule ID 59624 //
     /* 2212494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212509 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212528 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212537 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2212554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212577 */     // GIR_Coverage, 59624,
     /* 2212577 */     GIR_EraseRootFromParent_Done,
     /* 2212578 */   // Label 29267: @2212578
     /* 2212578 */   GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2212667), // Rule ID 59625 //
     /* 2212583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212598 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212617 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212626 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2212643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212666 */     // GIR_Coverage, 59625,
     /* 2212666 */     GIR_EraseRootFromParent_Done,
     /* 2212667 */   // Label 29268: @2212667
     /* 2212667 */   GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2212756), // Rule ID 59626 //
     /* 2212672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212687 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212706 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212715 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2212732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212755 */     // GIR_Coverage, 59626,
     /* 2212755 */     GIR_EraseRootFromParent_Done,
     /* 2212756 */   // Label 29269: @2212756
     /* 2212756 */   GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2212845), // Rule ID 59627 //
     /* 2212761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212776 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212795 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212804 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2212821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212844 */     // GIR_Coverage, 59627,
     /* 2212844 */     GIR_EraseRootFromParent_Done,
     /* 2212845 */   // Label 29270: @2212845
     /* 2212845 */   GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2212898), // Rule ID 48116 //
     /* 2212850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2212853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212861 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2212878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212897 */     // GIR_Coverage, 48116,
     /* 2212897 */     GIR_EraseRootFromParent_Done,
     /* 2212898 */   // Label 29271: @2212898
     /* 2212898 */   GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2212951), // Rule ID 48117 //
     /* 2212903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2212906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212914 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2212931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212950 */     // GIR_Coverage, 48117,
     /* 2212950 */     GIR_EraseRootFromParent_Done,
     /* 2212951 */   // Label 29272: @2212951
     /* 2212951 */   GIM_Reject,
     /* 2212952 */ // Label 29266: @2212952
     /* 2212952 */ GIM_Reject,
     /* 2212953 */ // Label 29199: @2212953
     /* 2212953 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2213067),
     /* 2212958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2212964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212976 */   GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2213021), // Rule ID 48048 //
     /* 2212981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212984 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2212987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2213001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213020 */     // GIR_Coverage, 48048,
     /* 2213020 */     GIR_EraseRootFromParent_Done,
     /* 2213021 */   // Label 29274: @2213021
     /* 2213021 */   GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2213066), // Rule ID 48049 //
     /* 2213026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213029 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2213032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2213046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213065 */     // GIR_Coverage, 48049,
     /* 2213065 */     GIR_EraseRootFromParent_Done,
     /* 2213066 */   // Label 29275: @2213066
     /* 2213066 */   GIM_Reject,
     /* 2213067 */ // Label 29273: @2213067
     /* 2213067 */ GIM_Reject,
     /* 2213068 */ // Label 29200: @2213068
     /* 2213068 */ GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2213546),
     /* 2213073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2213079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213083 */   GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2213172), // Rule ID 59544 //
     /* 2213088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2213091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213103 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2213118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213122 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213131 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2213148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213171 */     // GIR_Coverage, 59544,
     /* 2213171 */     GIR_EraseRootFromParent_Done,
     /* 2213172 */   // Label 29277: @2213172
     /* 2213172 */   GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2213261), // Rule ID 59545 //
     /* 2213177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213192 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2213207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213211 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213220 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2213237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213260 */     // GIR_Coverage, 59545,
     /* 2213260 */     GIR_EraseRootFromParent_Done,
     /* 2213261 */   // Label 29278: @2213261
     /* 2213261 */   GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2213350), // Rule ID 59546 //
     /* 2213266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2213269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213281 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213300 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213309 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2213326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213349 */     // GIR_Coverage, 59546,
     /* 2213349 */     GIR_EraseRootFromParent_Done,
     /* 2213350 */   // Label 29279: @2213350
     /* 2213350 */   GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2213439), // Rule ID 59547 //
     /* 2213355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213370 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213389 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213398 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2213415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213438 */     // GIR_Coverage, 59547,
     /* 2213438 */     GIR_EraseRootFromParent_Done,
     /* 2213439 */   // Label 29280: @2213439
     /* 2213439 */   GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2213492), // Rule ID 48068 //
     /* 2213444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213455 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2213472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213491 */     // GIR_Coverage, 48068,
     /* 2213491 */     GIR_EraseRootFromParent_Done,
     /* 2213492 */   // Label 29281: @2213492
     /* 2213492 */   GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2213545), // Rule ID 48069 //
     /* 2213497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213508 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2213511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2213525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213544 */     // GIR_Coverage, 48069,
     /* 2213544 */     GIR_EraseRootFromParent_Done,
     /* 2213545 */   // Label 29282: @2213545
     /* 2213545 */   GIM_Reject,
     /* 2213546 */ // Label 29276: @2213546
     /* 2213546 */ GIM_Reject,
     /* 2213547 */ // Label 29201: @2213547
     /* 2213547 */ GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2214025),
     /* 2213552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2213555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2213558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213562 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2213651), // Rule ID 59592 //
     /* 2213567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2213570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213582 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2213597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213601 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213610 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2213627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213650 */     // GIR_Coverage, 59592,
     /* 2213650 */     GIR_EraseRootFromParent_Done,
     /* 2213651 */   // Label 29284: @2213651
     /* 2213651 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2213740), // Rule ID 59593 //
     /* 2213656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213671 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2213686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213690 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213699 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2213716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213739 */     // GIR_Coverage, 59593,
     /* 2213739 */     GIR_EraseRootFromParent_Done,
     /* 2213740 */   // Label 29285: @2213740
     /* 2213740 */   GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2213829), // Rule ID 59594 //
     /* 2213745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2213748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213760 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213779 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213788 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2213805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213828 */     // GIR_Coverage, 59594,
     /* 2213828 */     GIR_EraseRootFromParent_Done,
     /* 2213829 */   // Label 29286: @2213829
     /* 2213829 */   GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2213918), // Rule ID 59595 //
     /* 2213834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213849 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2213868 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213877 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2213894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213917 */     // GIR_Coverage, 59595,
     /* 2213917 */     GIR_EraseRootFromParent_Done,
     /* 2213918 */   // Label 29287: @2213918
     /* 2213918 */   GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2213971), // Rule ID 48104 //
     /* 2213923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213934 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2213951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213970 */     // GIR_Coverage, 48104,
     /* 2213970 */     GIR_EraseRootFromParent_Done,
     /* 2213971 */   // Label 29288: @2213971
     /* 2213971 */   GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2214024), // Rule ID 48105 //
     /* 2213976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213987 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2213990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2214004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214023 */     // GIR_Coverage, 48105,
     /* 2214023 */     GIR_EraseRootFromParent_Done,
     /* 2214024 */   // Label 29289: @2214024
     /* 2214024 */   GIM_Reject,
     /* 2214025 */ // Label 29283: @2214025
     /* 2214025 */ GIM_Reject,
     /* 2214026 */ // Label 29202: @2214026
     /* 2214026 */ GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2214504),
     /* 2214031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2214034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2214037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214041 */   GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2214130), // Rule ID 59632 //
     /* 2214046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2214049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214061 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2214076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214080 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214089 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2214106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214129 */     // GIR_Coverage, 59632,
     /* 2214129 */     GIR_EraseRootFromParent_Done,
     /* 2214130 */   // Label 29291: @2214130
     /* 2214130 */   GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2214219), // Rule ID 59633 //
     /* 2214135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214150 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2214165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214169 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214178 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2214195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214218 */     // GIR_Coverage, 59633,
     /* 2214218 */     GIR_EraseRootFromParent_Done,
     /* 2214219 */   // Label 29292: @2214219
     /* 2214219 */   GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2214308), // Rule ID 59634 //
     /* 2214224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2214227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214239 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214258 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214267 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2214284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214307 */     // GIR_Coverage, 59634,
     /* 2214307 */     GIR_EraseRootFromParent_Done,
     /* 2214308 */   // Label 29293: @2214308
     /* 2214308 */   GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2214397), // Rule ID 59635 //
     /* 2214313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2214316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214328 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2214347 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214356 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2214373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214396 */     // GIR_Coverage, 59635,
     /* 2214396 */     GIR_EraseRootFromParent_Done,
     /* 2214397 */   // Label 29294: @2214397
     /* 2214397 */   GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2214450), // Rule ID 48120 //
     /* 2214402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2214405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214413 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2214430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214449 */     // GIR_Coverage, 48120,
     /* 2214449 */     GIR_EraseRootFromParent_Done,
     /* 2214450 */   // Label 29295: @2214450
     /* 2214450 */   GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2214503), // Rule ID 48121 //
     /* 2214455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2214458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214466 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2214469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214502 */     // GIR_Coverage, 48121,
     /* 2214502 */     GIR_EraseRootFromParent_Done,
     /* 2214503 */   // Label 29296: @2214503
     /* 2214503 */   GIM_Reject,
     /* 2214504 */ // Label 29290: @2214504
     /* 2214504 */ GIM_Reject,
     /* 2214505 */ // Label 29203: @2214505
     /* 2214505 */ GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2214619),
     /* 2214510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2214516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214528 */   GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2214573), // Rule ID 48064 //
     /* 2214533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214536 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2214539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2214553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214572 */     // GIR_Coverage, 48064,
     /* 2214572 */     GIR_EraseRootFromParent_Done,
     /* 2214573 */   // Label 29298: @2214573
     /* 2214573 */   GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2214618), // Rule ID 48065 //
     /* 2214578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214581 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2214584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2214598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214617 */     // GIR_Coverage, 48065,
     /* 2214617 */     GIR_EraseRootFromParent_Done,
     /* 2214618 */   // Label 29299: @2214618
     /* 2214618 */   GIM_Reject,
     /* 2214619 */ // Label 29297: @2214619
     /* 2214619 */ GIM_Reject,
     /* 2214620 */ // Label 29204: @2214620
     /* 2214620 */ GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2215098),
     /* 2214625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2214628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2214631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214635 */   GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2214724), // Rule ID 59552 //
     /* 2214640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2214643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214655 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2214670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214674 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214683 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2214700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214723 */     // GIR_Coverage, 59552,
     /* 2214723 */     GIR_EraseRootFromParent_Done,
     /* 2214724 */   // Label 29301: @2214724
     /* 2214724 */   GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2214813), // Rule ID 59553 //
     /* 2214729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2214732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214744 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2214759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214763 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214772 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2214789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214812 */     // GIR_Coverage, 59553,
     /* 2214812 */     GIR_EraseRootFromParent_Done,
     /* 2214813 */   // Label 29302: @2214813
     /* 2214813 */   GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2214902), // Rule ID 59554 //
     /* 2214818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2214821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214833 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214852 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214861 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2214878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214901 */     // GIR_Coverage, 59554,
     /* 2214901 */     GIR_EraseRootFromParent_Done,
     /* 2214902 */   // Label 29303: @2214902
     /* 2214902 */   GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2214991), // Rule ID 59555 //
     /* 2214907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2214910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2214914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214922 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2214924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2214933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2214937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2214941 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2214943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2214950 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2214953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2214967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2214976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2214980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214990 */     // GIR_Coverage, 59555,
     /* 2214990 */     GIR_EraseRootFromParent_Done,
     /* 2214991 */   // Label 29304: @2214991
     /* 2214991 */   GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2215044), // Rule ID 48092 //
     /* 2214996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215007 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2215010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2215024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215043 */     // GIR_Coverage, 48092,
     /* 2215043 */     GIR_EraseRootFromParent_Done,
     /* 2215044 */   // Label 29305: @2215044
     /* 2215044 */   GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2215097), // Rule ID 48093 //
     /* 2215049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215060 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2215063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2215077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215096 */     // GIR_Coverage, 48093,
     /* 2215096 */     GIR_EraseRootFromParent_Done,
     /* 2215097 */   // Label 29306: @2215097
     /* 2215097 */   GIM_Reject,
     /* 2215098 */ // Label 29300: @2215098
     /* 2215098 */ GIM_Reject,
     /* 2215099 */ // Label 29205: @2215099
     /* 2215099 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2215577),
     /* 2215104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2215110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215114 */   GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2215203), // Rule ID 59600 //
     /* 2215119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2215122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215134 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2215149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215153 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215162 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2215179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215202 */     // GIR_Coverage, 59600,
     /* 2215202 */     GIR_EraseRootFromParent_Done,
     /* 2215203 */   // Label 29308: @2215203
     /* 2215203 */   GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2215292), // Rule ID 59601 //
     /* 2215208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2215211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215223 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2215238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215242 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215251 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2215268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215291 */     // GIR_Coverage, 59601,
     /* 2215291 */     GIR_EraseRootFromParent_Done,
     /* 2215292 */   // Label 29309: @2215292
     /* 2215292 */   GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2215381), // Rule ID 59602 //
     /* 2215297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2215300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215312 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215331 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215340 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2215357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215380 */     // GIR_Coverage, 59602,
     /* 2215380 */     GIR_EraseRootFromParent_Done,
     /* 2215381 */   // Label 29310: @2215381
     /* 2215381 */   GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2215470), // Rule ID 59603 //
     /* 2215386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2215389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215401 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215420 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215429 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2215446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215469 */     // GIR_Coverage, 59603,
     /* 2215469 */     GIR_EraseRootFromParent_Done,
     /* 2215470 */   // Label 29311: @2215470
     /* 2215470 */   GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2215523), // Rule ID 48108 //
     /* 2215475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215486 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2215503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215522 */     // GIR_Coverage, 48108,
     /* 2215522 */     GIR_EraseRootFromParent_Done,
     /* 2215523 */   // Label 29312: @2215523
     /* 2215523 */   GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2215576), // Rule ID 48109 //
     /* 2215528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215539 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2215556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215575 */     // GIR_Coverage, 48109,
     /* 2215575 */     GIR_EraseRootFromParent_Done,
     /* 2215576 */   // Label 29313: @2215576
     /* 2215576 */   GIM_Reject,
     /* 2215577 */ // Label 29307: @2215577
     /* 2215577 */ GIM_Reject,
     /* 2215578 */ // Label 29206: @2215578
     /* 2215578 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2216056),
     /* 2215583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2215589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215593 */   GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2215682), // Rule ID 59640 //
     /* 2215598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215613 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2215628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215632 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215641 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2215658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215681 */     // GIR_Coverage, 59640,
     /* 2215681 */     GIR_EraseRootFromParent_Done,
     /* 2215682 */   // Label 29315: @2215682
     /* 2215682 */   GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2215771), // Rule ID 59641 //
     /* 2215687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2215690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215702 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2215717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215721 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215730 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2215747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215770 */     // GIR_Coverage, 59641,
     /* 2215770 */     GIR_EraseRootFromParent_Done,
     /* 2215771 */   // Label 29316: @2215771
     /* 2215771 */   GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2215860), // Rule ID 59642 //
     /* 2215776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2215779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215791 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215810 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215819 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2215836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215859 */     // GIR_Coverage, 59642,
     /* 2215859 */     GIR_EraseRootFromParent_Done,
     /* 2215860 */   // Label 29317: @2215860
     /* 2215860 */   GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2215949), // Rule ID 59643 //
     /* 2215865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2215868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2215872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215880 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2215882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2215891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2215895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215899 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2215901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2215908 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2215925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2215934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2215938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215948 */     // GIR_Coverage, 59643,
     /* 2215948 */     GIR_EraseRootFromParent_Done,
     /* 2215949 */   // Label 29318: @2215949
     /* 2215949 */   GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2216002), // Rule ID 48124 //
     /* 2215954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2215957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215965 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2215982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216001 */     // GIR_Coverage, 48124,
     /* 2216001 */     GIR_EraseRootFromParent_Done,
     /* 2216002 */   // Label 29319: @2216002
     /* 2216002 */   GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2216055), // Rule ID 48125 //
     /* 2216007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2216010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216018 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2216021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2216035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216054 */     // GIR_Coverage, 48125,
     /* 2216054 */     GIR_EraseRootFromParent_Done,
     /* 2216055 */   // Label 29320: @2216055
     /* 2216055 */   GIM_Reject,
     /* 2216056 */ // Label 29314: @2216056
     /* 2216056 */ GIM_Reject,
     /* 2216057 */ // Label 29207: @2216057
     /* 2216057 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2216171),
     /* 2216062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2216068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216080 */   GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2216125), // Rule ID 48080 //
     /* 2216085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216088 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2216091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2216105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216124 */     // GIR_Coverage, 48080,
     /* 2216124 */     GIR_EraseRootFromParent_Done,
     /* 2216125 */   // Label 29322: @2216125
     /* 2216125 */   GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2216170), // Rule ID 48081 //
     /* 2216130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216133 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2216136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2216150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216169 */     // GIR_Coverage, 48081,
     /* 2216169 */     GIR_EraseRootFromParent_Done,
     /* 2216170 */   // Label 29323: @2216170
     /* 2216170 */   GIM_Reject,
     /* 2216171 */ // Label 29321: @2216171
     /* 2216171 */ GIM_Reject,
     /* 2216172 */ // Label 29208: @2216172
     /* 2216172 */ GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2216650),
     /* 2216177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2216183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216187 */   GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2216276), // Rule ID 59560 //
     /* 2216192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2216195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216207 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2216222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216226 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216235 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2216252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216275 */     // GIR_Coverage, 59560,
     /* 2216275 */     GIR_EraseRootFromParent_Done,
     /* 2216276 */   // Label 29325: @2216276
     /* 2216276 */   GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2216365), // Rule ID 59561 //
     /* 2216281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2216284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216296 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2216311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216315 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216324 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2216341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216364 */     // GIR_Coverage, 59561,
     /* 2216364 */     GIR_EraseRootFromParent_Done,
     /* 2216365 */   // Label 29326: @2216365
     /* 2216365 */   GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2216454), // Rule ID 59562 //
     /* 2216370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2216373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216385 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216404 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216413 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2216430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216453 */     // GIR_Coverage, 59562,
     /* 2216453 */     GIR_EraseRootFromParent_Done,
     /* 2216454 */   // Label 29327: @2216454
     /* 2216454 */   GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2216543), // Rule ID 59563 //
     /* 2216459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2216462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216474 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2216493 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216502 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2216519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216542 */     // GIR_Coverage, 59563,
     /* 2216542 */     GIR_EraseRootFromParent_Done,
     /* 2216543 */   // Label 29328: @2216543
     /* 2216543 */   GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2216596), // Rule ID 48096 //
     /* 2216548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216559 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2216576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216595 */     // GIR_Coverage, 48096,
     /* 2216595 */     GIR_EraseRootFromParent_Done,
     /* 2216596 */   // Label 29329: @2216596
     /* 2216596 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2216649), // Rule ID 48097 //
     /* 2216601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216612 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2216629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216648 */     // GIR_Coverage, 48097,
     /* 2216648 */     GIR_EraseRootFromParent_Done,
     /* 2216649 */   // Label 29330: @2216649
     /* 2216649 */   GIM_Reject,
     /* 2216650 */ // Label 29324: @2216650
     /* 2216650 */ GIM_Reject,
     /* 2216651 */ // Label 29209: @2216651
     /* 2216651 */ GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2217129),
     /* 2216656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2216659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2216662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216666 */   GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2216755), // Rule ID 59608 //
     /* 2216671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2216674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216686 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2216701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216705 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216714 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2216731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216754 */     // GIR_Coverage, 59608,
     /* 2216754 */     GIR_EraseRootFromParent_Done,
     /* 2216755 */   // Label 29332: @2216755
     /* 2216755 */   GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2216844), // Rule ID 59609 //
     /* 2216760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2216763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216775 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2216790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216794 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216803 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2216820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216843 */     // GIR_Coverage, 59609,
     /* 2216843 */     GIR_EraseRootFromParent_Done,
     /* 2216844 */   // Label 29333: @2216844
     /* 2216844 */   GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2216933), // Rule ID 59610 //
     /* 2216849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2216852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216864 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216883 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216892 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2216909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2216918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2216922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216932 */     // GIR_Coverage, 59610,
     /* 2216932 */     GIR_EraseRootFromParent_Done,
     /* 2216933 */   // Label 29334: @2216933
     /* 2216933 */   GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2217022), // Rule ID 59611 //
     /* 2216938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2216941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216953 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2216955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2216968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2216972 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2216974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216981 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2216998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2217007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2217011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217021 */     // GIR_Coverage, 59611,
     /* 2217021 */     GIR_EraseRootFromParent_Done,
     /* 2217022 */   // Label 29335: @2217022
     /* 2217022 */   GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2217075), // Rule ID 48112 //
     /* 2217027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217038 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217074 */     // GIR_Coverage, 48112,
     /* 2217074 */     GIR_EraseRootFromParent_Done,
     /* 2217075 */   // Label 29336: @2217075
     /* 2217075 */   GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2217128), // Rule ID 48113 //
     /* 2217080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217091 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2217094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217127 */     // GIR_Coverage, 48113,
     /* 2217127 */     GIR_EraseRootFromParent_Done,
     /* 2217128 */   // Label 29337: @2217128
     /* 2217128 */   GIM_Reject,
     /* 2217129 */ // Label 29331: @2217129
     /* 2217129 */ GIM_Reject,
     /* 2217130 */ // Label 29210: @2217130
     /* 2217130 */ GIM_Try, /*On fail goto*//*Label 29338*/ GIMT_Encode4(2217244),
     /* 2217135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2217141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217153 */   GIM_Try, /*On fail goto*//*Label 29339*/ GIMT_Encode4(2217198), // Rule ID 48084 //
     /* 2217158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217161 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2217164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2217178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217197 */     // GIR_Coverage, 48084,
     /* 2217197 */     GIR_EraseRootFromParent_Done,
     /* 2217198 */   // Label 29339: @2217198
     /* 2217198 */   GIM_Try, /*On fail goto*//*Label 29340*/ GIMT_Encode4(2217243), // Rule ID 48085 //
     /* 2217203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217206 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2217209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2217223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217242 */     // GIR_Coverage, 48085,
     /* 2217242 */     GIR_EraseRootFromParent_Done,
     /* 2217243 */   // Label 29340: @2217243
     /* 2217243 */   GIM_Reject,
     /* 2217244 */ // Label 29338: @2217244
     /* 2217244 */ GIM_Reject,
     /* 2217245 */ // Label 29211: @2217245
     /* 2217245 */ GIM_Try, /*On fail goto*//*Label 29341*/ GIMT_Encode4(2217723),
     /* 2217250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2217253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2217256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217260 */   GIM_Try, /*On fail goto*//*Label 29342*/ GIMT_Encode4(2217349), // Rule ID 59568 //
     /* 2217265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2217268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2217272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217280 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2217282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2217291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2217295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217299 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2217301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2217308 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2217325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2217334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2217338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217348 */     // GIR_Coverage, 59568,
     /* 2217348 */     GIR_EraseRootFromParent_Done,
     /* 2217349 */   // Label 29342: @2217349
     /* 2217349 */   GIM_Try, /*On fail goto*//*Label 29343*/ GIMT_Encode4(2217438), // Rule ID 59569 //
     /* 2217354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2217357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2217361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217369 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2217371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2217380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2217384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217388 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2217390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2217397 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2217414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2217423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2217427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217437 */     // GIR_Coverage, 59569,
     /* 2217437 */     GIR_EraseRootFromParent_Done,
     /* 2217438 */   // Label 29343: @2217438
     /* 2217438 */   GIM_Try, /*On fail goto*//*Label 29344*/ GIMT_Encode4(2217527), // Rule ID 59570 //
     /* 2217443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2217446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2217450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217458 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2217460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2217469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217477 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2217479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2217486 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2217503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2217512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2217516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217526 */     // GIR_Coverage, 59570,
     /* 2217526 */     GIR_EraseRootFromParent_Done,
     /* 2217527 */   // Label 29344: @2217527
     /* 2217527 */   GIM_Try, /*On fail goto*//*Label 29345*/ GIMT_Encode4(2217616), // Rule ID 59571 //
     /* 2217532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2217535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2217539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217547 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2217549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2217558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2217562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2217566 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2217568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2217575 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2217592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2217601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2217605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217615 */     // GIR_Coverage, 59571,
     /* 2217615 */     GIR_EraseRootFromParent_Done,
     /* 2217616 */   // Label 29345: @2217616
     /* 2217616 */   GIM_Try, /*On fail goto*//*Label 29346*/ GIMT_Encode4(2217669), // Rule ID 48100 //
     /* 2217621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217632 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217668 */     // GIR_Coverage, 48100,
     /* 2217668 */     GIR_EraseRootFromParent_Done,
     /* 2217669 */   // Label 29346: @2217669
     /* 2217669 */   GIM_Try, /*On fail goto*//*Label 29347*/ GIMT_Encode4(2217722), // Rule ID 48101 //
     /* 2217674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217685 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2217688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217721 */     // GIR_Coverage, 48101,
     /* 2217721 */     GIR_EraseRootFromParent_Done,
     /* 2217722 */   // Label 29347: @2217722
     /* 2217722 */   GIM_Reject,
     /* 2217723 */ // Label 29341: @2217723
     /* 2217723 */ GIM_Reject,
     /* 2217724 */ // Label 29212: @2217724
     /* 2217724 */ GIM_Try, /*On fail goto*//*Label 29348*/ GIMT_Encode4(2217838),
     /* 2217729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2217732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2217735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2217747 */   GIM_Try, /*On fail goto*//*Label 29349*/ GIMT_Encode4(2217792), // Rule ID 48088 //
     /* 2217752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217755 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2217758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217791 */     // GIR_Coverage, 48088,
     /* 2217791 */     GIR_EraseRootFromParent_Done,
     /* 2217792 */   // Label 29349: @2217792
     /* 2217792 */   GIM_Try, /*On fail goto*//*Label 29350*/ GIMT_Encode4(2217837), // Rule ID 48089 //
     /* 2217797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217800 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2217803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2217817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217836 */     // GIR_Coverage, 48089,
     /* 2217836 */     GIR_EraseRootFromParent_Done,
     /* 2217837 */   // Label 29350: @2217837
     /* 2217837 */   GIM_Reject,
     /* 2217838 */ // Label 29348: @2217838
     /* 2217838 */ GIM_Reject,
     /* 2217839 */ // Label 29213: @2217839
     /* 2217839 */ GIM_Reject,
     /* 2217840 */ // Label 44: @2217840
     /* 2217840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29375*/ GIMT_Encode4(2220870),
     /* 2217851 */ /*GILLT_s32*//*Label 29351*/ GIMT_Encode4(2217975),
     /* 2217855 */ /*GILLT_s64*//*Label 29352*/ GIMT_Encode4(2218059), GIMT_Encode4(0),
     /* 2217863 */ /*GILLT_nxv1s8*//*Label 29353*/ GIMT_Encode4(2218340),
     /* 2217867 */ /*GILLT_nxv1s16*//*Label 29354*/ GIMT_Encode4(2218455),
     /* 2217871 */ /*GILLT_nxv1s32*//*Label 29355*/ GIMT_Encode4(2218570),
     /* 2217875 */ /*GILLT_nxv1s64*//*Label 29356*/ GIMT_Encode4(2218685), GIMT_Encode4(0),
     /* 2217883 */ /*GILLT_nxv2s8*//*Label 29357*/ GIMT_Encode4(2218800),
     /* 2217887 */ /*GILLT_nxv2s16*//*Label 29358*/ GIMT_Encode4(2218915),
     /* 2217891 */ /*GILLT_nxv2s32*//*Label 29359*/ GIMT_Encode4(2219030),
     /* 2217895 */ /*GILLT_nxv2s64*//*Label 29360*/ GIMT_Encode4(2219145), GIMT_Encode4(0),
     /* 2217903 */ /*GILLT_nxv4s8*//*Label 29361*/ GIMT_Encode4(2219260),
     /* 2217907 */ /*GILLT_nxv4s16*//*Label 29362*/ GIMT_Encode4(2219375),
     /* 2217911 */ /*GILLT_nxv4s32*//*Label 29363*/ GIMT_Encode4(2219490),
     /* 2217915 */ /*GILLT_nxv4s64*//*Label 29364*/ GIMT_Encode4(2219605), GIMT_Encode4(0),
     /* 2217923 */ /*GILLT_nxv8s8*//*Label 29365*/ GIMT_Encode4(2219720),
     /* 2217927 */ /*GILLT_nxv8s16*//*Label 29366*/ GIMT_Encode4(2219835),
     /* 2217931 */ /*GILLT_nxv8s32*//*Label 29367*/ GIMT_Encode4(2219950),
     /* 2217935 */ /*GILLT_nxv8s64*//*Label 29368*/ GIMT_Encode4(2220065), GIMT_Encode4(0),
     /* 2217943 */ /*GILLT_nxv16s8*//*Label 29369*/ GIMT_Encode4(2220180),
     /* 2217947 */ /*GILLT_nxv16s16*//*Label 29370*/ GIMT_Encode4(2220295),
     /* 2217951 */ /*GILLT_nxv16s32*//*Label 29371*/ GIMT_Encode4(2220410), GIMT_Encode4(0),
     /* 2217959 */ /*GILLT_nxv32s8*//*Label 29372*/ GIMT_Encode4(2220525),
     /* 2217963 */ /*GILLT_nxv32s16*//*Label 29373*/ GIMT_Encode4(2220640), GIMT_Encode4(0),
     /* 2217971 */ /*GILLT_nxv64s8*//*Label 29374*/ GIMT_Encode4(2220755),
     /* 2217975 */ // Label 29351: @2217975
     /* 2217975 */ GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2218058),
     /* 2217980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2217983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2217986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2217990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2217994 */   GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2218028), // Rule ID 93 //
     /* 2217999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2218002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2218006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2218010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2218014 */     // MIs[1] Operand 1
     /* 2218014 */     // No operand predicates
     /* 2218014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2218016 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2218016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2218019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2218026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218027 */     // GIR_Coverage, 93,
     /* 2218027 */     GIR_EraseRootFromParent_Done,
     /* 2218028 */   // Label 29377: @2218028
     /* 2218028 */   GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2218057), // Rule ID 107 //
     /* 2218033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2218036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2218043 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2218043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2218046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2218055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218056 */     // GIR_Coverage, 107,
     /* 2218056 */     GIR_EraseRootFromParent_Done,
     /* 2218057 */   // Label 29378: @2218057
     /* 2218057 */   GIM_Reject,
     /* 2218058 */ // Label 29376: @2218058
     /* 2218058 */ GIM_Reject,
     /* 2218059 */ // Label 29352: @2218059
     /* 2218059 */ GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2218339),
     /* 2218064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2218067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2218070 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2218142), // Rule ID 257 //
     /* 2218075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2218078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2218086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2218090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2218094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2218098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218103 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2218114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2218118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2218122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2218126 */     // MIs[2] Operand 1
     /* 2218126 */     // No operand predicates
     /* 2218126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2218128 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2218128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2218131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2218137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2218140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218141 */     // GIR_Coverage, 257,
     /* 2218141 */     GIR_EraseRootFromParent_Done,
     /* 2218142 */   // Label 29380: @2218142
     /* 2218142 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2218187), // Rule ID 62562 //
     /* 2218147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2218150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2218158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2218162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2218166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2218170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10054),
     /* 2218174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2218176 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10054>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2218176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2218179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2218185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218186 */     // GIR_Coverage, 62562,
     /* 2218186 */     GIR_EraseRootFromParent_Done,
     /* 2218187 */   // Label 29381: @2218187
     /* 2218187 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2218259), // Rule ID 269 //
     /* 2218192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2218195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2218203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2218207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2218211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218216 */     // MIs[1] Operand 2
     /* 2218216 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2218227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2218231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2218235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2218239 */     // MIs[2] Operand 1
     /* 2218239 */     // No operand predicates
     /* 2218239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10054),
     /* 2218243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2218245 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10054>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2218245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2218248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2218254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2218257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218258 */     // GIR_Coverage, 269,
     /* 2218258 */     GIR_EraseRootFromParent_Done,
     /* 2218259 */   // Label 29382: @2218259
     /* 2218259 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2218301), // Rule ID 92 //
     /* 2218264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2218267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2218279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2218283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2218287 */     // MIs[1] Operand 1
     /* 2218287 */     // No operand predicates
     /* 2218287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2218289 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2218289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2218292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2218299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218300 */     // GIR_Coverage, 92,
     /* 2218300 */     GIR_EraseRootFromParent_Done,
     /* 2218301 */   // Label 29383: @2218301
     /* 2218301 */   GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2218338), // Rule ID 106 //
     /* 2218306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2218309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2218317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2218324 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2218324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2218327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2218336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218337 */     // GIR_Coverage, 106,
     /* 2218337 */     GIR_EraseRootFromParent_Done,
     /* 2218338 */   // Label 29384: @2218338
     /* 2218338 */   GIM_Reject,
     /* 2218339 */ // Label 29379: @2218339
     /* 2218339 */ GIM_Reject,
     /* 2218340 */ // Label 29353: @2218340
     /* 2218340 */ GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2218454),
     /* 2218345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2218348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2218351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218363 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2218408), // Rule ID 48172 //
     /* 2218368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218371 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2218374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2218388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218407 */     // GIR_Coverage, 48172,
     /* 2218407 */     GIR_EraseRootFromParent_Done,
     /* 2218408 */   // Label 29386: @2218408
     /* 2218408 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2218453), // Rule ID 48173 //
     /* 2218413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218416 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2218419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2218433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218452 */     // GIR_Coverage, 48173,
     /* 2218452 */     GIR_EraseRootFromParent_Done,
     /* 2218453 */   // Label 29387: @2218453
     /* 2218453 */   GIM_Reject,
     /* 2218454 */ // Label 29385: @2218454
     /* 2218454 */ GIM_Reject,
     /* 2218455 */ // Label 29354: @2218455
     /* 2218455 */ GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2218569),
     /* 2218460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2218463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2218466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218478 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2218523), // Rule ID 48184 //
     /* 2218483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218486 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2218489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2218503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218522 */     // GIR_Coverage, 48184,
     /* 2218522 */     GIR_EraseRootFromParent_Done,
     /* 2218523 */   // Label 29389: @2218523
     /* 2218523 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2218568), // Rule ID 48185 //
     /* 2218528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218531 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2218534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2218548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218567 */     // GIR_Coverage, 48185,
     /* 2218567 */     GIR_EraseRootFromParent_Done,
     /* 2218568 */   // Label 29390: @2218568
     /* 2218568 */   GIM_Reject,
     /* 2218569 */ // Label 29388: @2218569
     /* 2218569 */ GIM_Reject,
     /* 2218570 */ // Label 29355: @2218570
     /* 2218570 */ GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2218684),
     /* 2218575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2218578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2218581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218593 */   GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2218638), // Rule ID 48192 //
     /* 2218598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218601 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2218604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2218618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218637 */     // GIR_Coverage, 48192,
     /* 2218637 */     GIR_EraseRootFromParent_Done,
     /* 2218638 */   // Label 29392: @2218638
     /* 2218638 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2218683), // Rule ID 48193 //
     /* 2218643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218646 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2218649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2218663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218682 */     // GIR_Coverage, 48193,
     /* 2218682 */     GIR_EraseRootFromParent_Done,
     /* 2218683 */   // Label 29393: @2218683
     /* 2218683 */   GIM_Reject,
     /* 2218684 */ // Label 29391: @2218684
     /* 2218684 */ GIM_Reject,
     /* 2218685 */ // Label 29356: @2218685
     /* 2218685 */ GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2218799),
     /* 2218690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2218693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2218696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218708 */   GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2218753), // Rule ID 48208 //
     /* 2218713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2218716 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2218719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2218733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218752 */     // GIR_Coverage, 48208,
     /* 2218752 */     GIR_EraseRootFromParent_Done,
     /* 2218753 */   // Label 29395: @2218753
     /* 2218753 */   GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2218798), // Rule ID 48209 //
     /* 2218758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2218761 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2218764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2218778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218797 */     // GIR_Coverage, 48209,
     /* 2218797 */     GIR_EraseRootFromParent_Done,
     /* 2218798 */   // Label 29396: @2218798
     /* 2218798 */   GIM_Reject,
     /* 2218799 */ // Label 29394: @2218799
     /* 2218799 */ GIM_Reject,
     /* 2218800 */ // Label 29357: @2218800
     /* 2218800 */ GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2218914),
     /* 2218805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2218808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2218811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218823 */   GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2218868), // Rule ID 48176 //
     /* 2218828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218831 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2218834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2218848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218867 */     // GIR_Coverage, 48176,
     /* 2218867 */     GIR_EraseRootFromParent_Done,
     /* 2218868 */   // Label 29398: @2218868
     /* 2218868 */   GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2218913), // Rule ID 48177 //
     /* 2218873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218876 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2218879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2218893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218912 */     // GIR_Coverage, 48177,
     /* 2218912 */     GIR_EraseRootFromParent_Done,
     /* 2218913 */   // Label 29399: @2218913
     /* 2218913 */   GIM_Reject,
     /* 2218914 */ // Label 29397: @2218914
     /* 2218914 */ GIM_Reject,
     /* 2218915 */ // Label 29358: @2218915
     /* 2218915 */ GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2219029),
     /* 2218920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2218923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2218926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218938 */   GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2218983), // Rule ID 48188 //
     /* 2218943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218946 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2218963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218982 */     // GIR_Coverage, 48188,
     /* 2218982 */     GIR_EraseRootFromParent_Done,
     /* 2218983 */   // Label 29401: @2218983
     /* 2218983 */   GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2219028), // Rule ID 48189 //
     /* 2218988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218991 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2218994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2219008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219027 */     // GIR_Coverage, 48189,
     /* 2219027 */     GIR_EraseRootFromParent_Done,
     /* 2219028 */   // Label 29402: @2219028
     /* 2219028 */   GIM_Reject,
     /* 2219029 */ // Label 29400: @2219029
     /* 2219029 */ GIM_Reject,
     /* 2219030 */ // Label 29359: @2219030
     /* 2219030 */ GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2219144),
     /* 2219035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2219038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2219041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219053 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2219098), // Rule ID 48204 //
     /* 2219058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219061 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2219064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219097 */     // GIR_Coverage, 48204,
     /* 2219097 */     GIR_EraseRootFromParent_Done,
     /* 2219098 */   // Label 29404: @2219098
     /* 2219098 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2219143), // Rule ID 48205 //
     /* 2219103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219106 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2219109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219142 */     // GIR_Coverage, 48205,
     /* 2219142 */     GIR_EraseRootFromParent_Done,
     /* 2219143 */   // Label 29405: @2219143
     /* 2219143 */   GIM_Reject,
     /* 2219144 */ // Label 29403: @2219144
     /* 2219144 */ GIM_Reject,
     /* 2219145 */ // Label 29360: @2219145
     /* 2219145 */ GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2219259),
     /* 2219150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2219153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2219156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219168 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2219213), // Rule ID 48248 //
     /* 2219173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2219176 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2219179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219212 */     // GIR_Coverage, 48248,
     /* 2219212 */     GIR_EraseRootFromParent_Done,
     /* 2219213 */   // Label 29407: @2219213
     /* 2219213 */   GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2219258), // Rule ID 48249 //
     /* 2219218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2219221 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2219224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219257 */     // GIR_Coverage, 48249,
     /* 2219257 */     GIR_EraseRootFromParent_Done,
     /* 2219258 */   // Label 29408: @2219258
     /* 2219258 */   GIM_Reject,
     /* 2219259 */ // Label 29406: @2219259
     /* 2219259 */ GIM_Reject,
     /* 2219260 */ // Label 29361: @2219260
     /* 2219260 */ GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2219374),
     /* 2219265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2219268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2219271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219283 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2219328), // Rule ID 48180 //
     /* 2219288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219291 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2219294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2219308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219327 */     // GIR_Coverage, 48180,
     /* 2219327 */     GIR_EraseRootFromParent_Done,
     /* 2219328 */   // Label 29410: @2219328
     /* 2219328 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2219373), // Rule ID 48181 //
     /* 2219333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219336 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2219339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2219353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219372 */     // GIR_Coverage, 48181,
     /* 2219372 */     GIR_EraseRootFromParent_Done,
     /* 2219373 */   // Label 29411: @2219373
     /* 2219373 */   GIM_Reject,
     /* 2219374 */ // Label 29409: @2219374
     /* 2219374 */ GIM_Reject,
     /* 2219375 */ // Label 29362: @2219375
     /* 2219375 */ GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2219489),
     /* 2219380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2219383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2219386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219398 */   GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2219443), // Rule ID 48200 //
     /* 2219403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219406 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2219409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219442 */     // GIR_Coverage, 48200,
     /* 2219442 */     GIR_EraseRootFromParent_Done,
     /* 2219443 */   // Label 29413: @2219443
     /* 2219443 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2219488), // Rule ID 48201 //
     /* 2219448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219451 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2219454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219487 */     // GIR_Coverage, 48201,
     /* 2219487 */     GIR_EraseRootFromParent_Done,
     /* 2219488 */   // Label 29414: @2219488
     /* 2219488 */   GIM_Reject,
     /* 2219489 */ // Label 29412: @2219489
     /* 2219489 */ GIM_Reject,
     /* 2219490 */ // Label 29363: @2219490
     /* 2219490 */ GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2219604),
     /* 2219495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2219498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2219501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219513 */   GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2219558), // Rule ID 48236 //
     /* 2219518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219521 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219557 */     // GIR_Coverage, 48236,
     /* 2219557 */     GIR_EraseRootFromParent_Done,
     /* 2219558 */   // Label 29416: @2219558
     /* 2219558 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2219603), // Rule ID 48237 //
     /* 2219563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219566 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2219569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219602 */     // GIR_Coverage, 48237,
     /* 2219602 */     GIR_EraseRootFromParent_Done,
     /* 2219603 */   // Label 29417: @2219603
     /* 2219603 */   GIM_Reject,
     /* 2219604 */ // Label 29415: @2219604
     /* 2219604 */ GIM_Reject,
     /* 2219605 */ // Label 29364: @2219605
     /* 2219605 */ GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2219719),
     /* 2219610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2219613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2219616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219628 */   GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2219673), // Rule ID 48252 //
     /* 2219633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2219636 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2219653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219672 */     // GIR_Coverage, 48252,
     /* 2219672 */     GIR_EraseRootFromParent_Done,
     /* 2219673 */   // Label 29419: @2219673
     /* 2219673 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2219718), // Rule ID 48253 //
     /* 2219678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2219681 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2219684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2219698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2219713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219717 */     // GIR_Coverage, 48253,
     /* 2219717 */     GIR_EraseRootFromParent_Done,
     /* 2219718 */   // Label 29420: @2219718
     /* 2219718 */   GIM_Reject,
     /* 2219719 */ // Label 29418: @2219719
     /* 2219719 */ GIM_Reject,
     /* 2219720 */ // Label 29365: @2219720
     /* 2219720 */ GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2219834),
     /* 2219725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2219728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2219731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219743 */   GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2219788), // Rule ID 48196 //
     /* 2219748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219751 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2219754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219787 */     // GIR_Coverage, 48196,
     /* 2219787 */     GIR_EraseRootFromParent_Done,
     /* 2219788 */   // Label 29422: @2219788
     /* 2219788 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2219833), // Rule ID 48197 //
     /* 2219793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219796 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2219799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2219813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219832 */     // GIR_Coverage, 48197,
     /* 2219832 */     GIR_EraseRootFromParent_Done,
     /* 2219833 */   // Label 29423: @2219833
     /* 2219833 */   GIM_Reject,
     /* 2219834 */ // Label 29421: @2219834
     /* 2219834 */ GIM_Reject,
     /* 2219835 */ // Label 29366: @2219835
     /* 2219835 */ GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2219949),
     /* 2219840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2219843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2219846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2219858 */   GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2219903), // Rule ID 48224 //
     /* 2219863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219866 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219902 */     // GIR_Coverage, 48224,
     /* 2219902 */     GIR_EraseRootFromParent_Done,
     /* 2219903 */   // Label 29425: @2219903
     /* 2219903 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2219948), // Rule ID 48225 //
     /* 2219908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219911 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2219914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2219928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219947 */     // GIR_Coverage, 48225,
     /* 2219947 */     GIR_EraseRootFromParent_Done,
     /* 2219948 */   // Label 29426: @2219948
     /* 2219948 */   GIM_Reject,
     /* 2219949 */ // Label 29424: @2219949
     /* 2219949 */ GIM_Reject,
     /* 2219950 */ // Label 29367: @2219950
     /* 2219950 */ GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2220064),
     /* 2219955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2219958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2219961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219973 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2220018), // Rule ID 48240 //
     /* 2219978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219981 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2219984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2219998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220017 */     // GIR_Coverage, 48240,
     /* 2220017 */     GIR_EraseRootFromParent_Done,
     /* 2220018 */   // Label 29428: @2220018
     /* 2220018 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2220063), // Rule ID 48241 //
     /* 2220023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220026 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2220029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2220043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220062 */     // GIR_Coverage, 48241,
     /* 2220062 */     GIR_EraseRootFromParent_Done,
     /* 2220063 */   // Label 29429: @2220063
     /* 2220063 */   GIM_Reject,
     /* 2220064 */ // Label 29427: @2220064
     /* 2220064 */ GIM_Reject,
     /* 2220065 */ // Label 29368: @2220065
     /* 2220065 */ GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2220179),
     /* 2220070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2220073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2220076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220088 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2220133), // Rule ID 48256 //
     /* 2220093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2220096 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220132 */     // GIR_Coverage, 48256,
     /* 2220132 */     GIR_EraseRootFromParent_Done,
     /* 2220133 */   // Label 29431: @2220133
     /* 2220133 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2220178), // Rule ID 48257 //
     /* 2220138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2220141 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2220144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220177 */     // GIR_Coverage, 48257,
     /* 2220177 */     GIR_EraseRootFromParent_Done,
     /* 2220178 */   // Label 29432: @2220178
     /* 2220178 */   GIM_Reject,
     /* 2220179 */ // Label 29430: @2220179
     /* 2220179 */ GIM_Reject,
     /* 2220180 */ // Label 29369: @2220180
     /* 2220180 */ GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2220294),
     /* 2220185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2220188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2220191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220203 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2220248), // Rule ID 48212 //
     /* 2220208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220211 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2220214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2220228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220247 */     // GIR_Coverage, 48212,
     /* 2220247 */     GIR_EraseRootFromParent_Done,
     /* 2220248 */   // Label 29434: @2220248
     /* 2220248 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2220293), // Rule ID 48213 //
     /* 2220253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220256 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2220259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2220273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220292 */     // GIR_Coverage, 48213,
     /* 2220292 */     GIR_EraseRootFromParent_Done,
     /* 2220293 */   // Label 29435: @2220293
     /* 2220293 */   GIM_Reject,
     /* 2220294 */ // Label 29433: @2220294
     /* 2220294 */ GIM_Reject,
     /* 2220295 */ // Label 29370: @2220295
     /* 2220295 */ GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2220409),
     /* 2220300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2220303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2220306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220318 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2220363), // Rule ID 48228 //
     /* 2220323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220326 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2220343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220362 */     // GIR_Coverage, 48228,
     /* 2220362 */     GIR_EraseRootFromParent_Done,
     /* 2220363 */   // Label 29437: @2220363
     /* 2220363 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2220408), // Rule ID 48229 //
     /* 2220368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220371 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2220374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2220388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220407 */     // GIR_Coverage, 48229,
     /* 2220407 */     GIR_EraseRootFromParent_Done,
     /* 2220408 */   // Label 29438: @2220408
     /* 2220408 */   GIM_Reject,
     /* 2220409 */ // Label 29436: @2220409
     /* 2220409 */ GIM_Reject,
     /* 2220410 */ // Label 29371: @2220410
     /* 2220410 */ GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2220524),
     /* 2220415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2220418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2220421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220433 */   GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2220478), // Rule ID 48244 //
     /* 2220438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220441 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220477 */     // GIR_Coverage, 48244,
     /* 2220477 */     GIR_EraseRootFromParent_Done,
     /* 2220478 */   // Label 29440: @2220478
     /* 2220478 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2220523), // Rule ID 48245 //
     /* 2220483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220486 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2220489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220522 */     // GIR_Coverage, 48245,
     /* 2220522 */     GIR_EraseRootFromParent_Done,
     /* 2220523 */   // Label 29441: @2220523
     /* 2220523 */   GIM_Reject,
     /* 2220524 */ // Label 29439: @2220524
     /* 2220524 */ GIM_Reject,
     /* 2220525 */ // Label 29372: @2220525
     /* 2220525 */ GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2220639),
     /* 2220530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2220533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2220536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2220548 */   GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2220593), // Rule ID 48216 //
     /* 2220553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220556 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2220559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2220573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220592 */     // GIR_Coverage, 48216,
     /* 2220592 */     GIR_EraseRootFromParent_Done,
     /* 2220593 */   // Label 29443: @2220593
     /* 2220593 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2220638), // Rule ID 48217 //
     /* 2220598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220601 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2220604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2220618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220637 */     // GIR_Coverage, 48217,
     /* 2220637 */     GIR_EraseRootFromParent_Done,
     /* 2220638 */   // Label 29444: @2220638
     /* 2220638 */   GIM_Reject,
     /* 2220639 */ // Label 29442: @2220639
     /* 2220639 */ GIM_Reject,
     /* 2220640 */ // Label 29373: @2220640
     /* 2220640 */ GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2220754),
     /* 2220645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2220648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2220651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220663 */   GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2220708), // Rule ID 48232 //
     /* 2220668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220671 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2220674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220707 */     // GIR_Coverage, 48232,
     /* 2220707 */     GIR_EraseRootFromParent_Done,
     /* 2220708 */   // Label 29446: @2220708
     /* 2220708 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2220753), // Rule ID 48233 //
     /* 2220713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220716 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2220719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220752 */     // GIR_Coverage, 48233,
     /* 2220752 */     GIR_EraseRootFromParent_Done,
     /* 2220753 */   // Label 29447: @2220753
     /* 2220753 */   GIM_Reject,
     /* 2220754 */ // Label 29445: @2220754
     /* 2220754 */ GIM_Reject,
     /* 2220755 */ // Label 29374: @2220755
     /* 2220755 */ GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2220869),
     /* 2220760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2220763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2220766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2220778 */   GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2220823), // Rule ID 48220 //
     /* 2220783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220786 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2220789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220822 */     // GIR_Coverage, 48220,
     /* 2220822 */     GIR_EraseRootFromParent_Done,
     /* 2220823 */   // Label 29449: @2220823
     /* 2220823 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2220868), // Rule ID 48221 //
     /* 2220828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220831 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2220834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2220848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220867 */     // GIR_Coverage, 48221,
     /* 2220867 */     GIR_EraseRootFromParent_Done,
     /* 2220868 */   // Label 29450: @2220868
     /* 2220868 */   GIM_Reject,
     /* 2220869 */ // Label 29448: @2220869
     /* 2220869 */ GIM_Reject,
     /* 2220870 */ // Label 29375: @2220870
     /* 2220870 */ GIM_Reject,
     /* 2220871 */ // Label 45: @2220871
     /* 2220871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29475*/ GIMT_Encode4(2223809),
     /* 2220882 */ /*GILLT_s32*//*Label 29451*/ GIMT_Encode4(2221006),
     /* 2220886 */ /*GILLT_s64*//*Label 29452*/ GIMT_Encode4(2221090), GIMT_Encode4(0),
     /* 2220894 */ /*GILLT_nxv1s8*//*Label 29453*/ GIMT_Encode4(2221279),
     /* 2220898 */ /*GILLT_nxv1s16*//*Label 29454*/ GIMT_Encode4(2221394),
     /* 2220902 */ /*GILLT_nxv1s32*//*Label 29455*/ GIMT_Encode4(2221509),
     /* 2220906 */ /*GILLT_nxv1s64*//*Label 29456*/ GIMT_Encode4(2221624), GIMT_Encode4(0),
     /* 2220914 */ /*GILLT_nxv2s8*//*Label 29457*/ GIMT_Encode4(2221739),
     /* 2220918 */ /*GILLT_nxv2s16*//*Label 29458*/ GIMT_Encode4(2221854),
     /* 2220922 */ /*GILLT_nxv2s32*//*Label 29459*/ GIMT_Encode4(2221969),
     /* 2220926 */ /*GILLT_nxv2s64*//*Label 29460*/ GIMT_Encode4(2222084), GIMT_Encode4(0),
     /* 2220934 */ /*GILLT_nxv4s8*//*Label 29461*/ GIMT_Encode4(2222199),
     /* 2220938 */ /*GILLT_nxv4s16*//*Label 29462*/ GIMT_Encode4(2222314),
     /* 2220942 */ /*GILLT_nxv4s32*//*Label 29463*/ GIMT_Encode4(2222429),
     /* 2220946 */ /*GILLT_nxv4s64*//*Label 29464*/ GIMT_Encode4(2222544), GIMT_Encode4(0),
     /* 2220954 */ /*GILLT_nxv8s8*//*Label 29465*/ GIMT_Encode4(2222659),
     /* 2220958 */ /*GILLT_nxv8s16*//*Label 29466*/ GIMT_Encode4(2222774),
     /* 2220962 */ /*GILLT_nxv8s32*//*Label 29467*/ GIMT_Encode4(2222889),
     /* 2220966 */ /*GILLT_nxv8s64*//*Label 29468*/ GIMT_Encode4(2223004), GIMT_Encode4(0),
     /* 2220974 */ /*GILLT_nxv16s8*//*Label 29469*/ GIMT_Encode4(2223119),
     /* 2220978 */ /*GILLT_nxv16s16*//*Label 29470*/ GIMT_Encode4(2223234),
     /* 2220982 */ /*GILLT_nxv16s32*//*Label 29471*/ GIMT_Encode4(2223349), GIMT_Encode4(0),
     /* 2220990 */ /*GILLT_nxv32s8*//*Label 29472*/ GIMT_Encode4(2223464),
     /* 2220994 */ /*GILLT_nxv32s16*//*Label 29473*/ GIMT_Encode4(2223579), GIMT_Encode4(0),
     /* 2221002 */ /*GILLT_nxv64s8*//*Label 29474*/ GIMT_Encode4(2223694),
     /* 2221006 */ // Label 29451: @2221006
     /* 2221006 */ GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2221089),
     /* 2221011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2221014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2221017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221025 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2221059), // Rule ID 95 //
     /* 2221030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2221033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2221037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2221041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2221045 */     // MIs[1] Operand 1
     /* 2221045 */     // No operand predicates
     /* 2221045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2221047 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2221047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2221050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2221057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221058 */     // GIR_Coverage, 95,
     /* 2221058 */     GIR_EraseRootFromParent_Done,
     /* 2221059 */   // Label 29477: @2221059
     /* 2221059 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2221088), // Rule ID 109 //
     /* 2221064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2221067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2221074 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2221074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2221077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2221086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221087 */     // GIR_Coverage, 109,
     /* 2221087 */     GIR_EraseRootFromParent_Done,
     /* 2221088 */   // Label 29478: @2221088
     /* 2221088 */   GIM_Reject,
     /* 2221089 */ // Label 29476: @2221089
     /* 2221089 */ GIM_Reject,
     /* 2221090 */ // Label 29452: @2221090
     /* 2221090 */ GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2221278),
     /* 2221095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2221101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221105 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2221142), // Rule ID 62561 //
     /* 2221110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2221113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2221121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2221129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2221131 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2221131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2221134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2221140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221141 */     // GIR_Coverage, 62561,
     /* 2221141 */     GIR_EraseRootFromParent_Done,
     /* 2221142 */   // Label 29480: @2221142
     /* 2221142 */   GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2221206), // Rule ID 259 //
     /* 2221147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2221150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2221158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2221162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221167 */     // MIs[1] Operand 2
     /* 2221167 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2221178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2221186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2221190 */     // MIs[2] Operand 1
     /* 2221190 */     // No operand predicates
     /* 2221190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221192 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2221192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2221195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2221201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2221204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221205 */     // GIR_Coverage, 259,
     /* 2221205 */     GIR_EraseRootFromParent_Done,
     /* 2221206 */   // Label 29481: @2221206
     /* 2221206 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2221244), // Rule ID 94 //
     /* 2221211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2221214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2221222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2221226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2221230 */     // MIs[1] Operand 1
     /* 2221230 */     // No operand predicates
     /* 2221230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2221232 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2221232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2221235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2221242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221243 */     // GIR_Coverage, 94,
     /* 2221243 */     GIR_EraseRootFromParent_Done,
     /* 2221244 */   // Label 29482: @2221244
     /* 2221244 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2221277), // Rule ID 108 //
     /* 2221249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2221252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2221256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2221263 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2221263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2221266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2221275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221276 */     // GIR_Coverage, 108,
     /* 2221276 */     GIR_EraseRootFromParent_Done,
     /* 2221277 */   // Label 29483: @2221277
     /* 2221277 */   GIM_Reject,
     /* 2221278 */ // Label 29479: @2221278
     /* 2221278 */ GIM_Reject,
     /* 2221279 */ // Label 29453: @2221279
     /* 2221279 */ GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2221393),
     /* 2221284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2221287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2221290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221302 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2221347), // Rule ID 48304 //
     /* 2221307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221310 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2221313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2221327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221346 */     // GIR_Coverage, 48304,
     /* 2221346 */     GIR_EraseRootFromParent_Done,
     /* 2221347 */   // Label 29485: @2221347
     /* 2221347 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2221392), // Rule ID 48305 //
     /* 2221352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221355 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2221358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2221372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221391 */     // GIR_Coverage, 48305,
     /* 2221391 */     GIR_EraseRootFromParent_Done,
     /* 2221392 */   // Label 29486: @2221392
     /* 2221392 */   GIM_Reject,
     /* 2221393 */ // Label 29484: @2221393
     /* 2221393 */ GIM_Reject,
     /* 2221394 */ // Label 29454: @2221394
     /* 2221394 */ GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2221508),
     /* 2221399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2221402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2221405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221417 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2221462), // Rule ID 48316 //
     /* 2221422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221425 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2221428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2221442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221461 */     // GIR_Coverage, 48316,
     /* 2221461 */     GIR_EraseRootFromParent_Done,
     /* 2221462 */   // Label 29488: @2221462
     /* 2221462 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2221507), // Rule ID 48317 //
     /* 2221467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221470 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2221473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2221487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221506 */     // GIR_Coverage, 48317,
     /* 2221506 */     GIR_EraseRootFromParent_Done,
     /* 2221507 */   // Label 29489: @2221507
     /* 2221507 */   GIM_Reject,
     /* 2221508 */ // Label 29487: @2221508
     /* 2221508 */ GIM_Reject,
     /* 2221509 */ // Label 29455: @2221509
     /* 2221509 */ GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2221623),
     /* 2221514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2221517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2221520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221532 */   GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2221577), // Rule ID 48324 //
     /* 2221537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221540 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2221543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2221557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221576 */     // GIR_Coverage, 48324,
     /* 2221576 */     GIR_EraseRootFromParent_Done,
     /* 2221577 */   // Label 29491: @2221577
     /* 2221577 */   GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2221622), // Rule ID 48325 //
     /* 2221582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221585 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2221588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2221602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221621 */     // GIR_Coverage, 48325,
     /* 2221621 */     GIR_EraseRootFromParent_Done,
     /* 2221622 */   // Label 29492: @2221622
     /* 2221622 */   GIM_Reject,
     /* 2221623 */ // Label 29490: @2221623
     /* 2221623 */ GIM_Reject,
     /* 2221624 */ // Label 29456: @2221624
     /* 2221624 */ GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2221738),
     /* 2221629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2221632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2221635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221647 */   GIM_Try, /*On fail goto*//*Label 29494*/ GIMT_Encode4(2221692), // Rule ID 48340 //
     /* 2221652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2221655 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2221672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221691 */     // GIR_Coverage, 48340,
     /* 2221691 */     GIR_EraseRootFromParent_Done,
     /* 2221692 */   // Label 29494: @2221692
     /* 2221692 */   GIM_Try, /*On fail goto*//*Label 29495*/ GIMT_Encode4(2221737), // Rule ID 48341 //
     /* 2221697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221700 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2221717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221736 */     // GIR_Coverage, 48341,
     /* 2221736 */     GIR_EraseRootFromParent_Done,
     /* 2221737 */   // Label 29495: @2221737
     /* 2221737 */   GIM_Reject,
     /* 2221738 */ // Label 29493: @2221738
     /* 2221738 */ GIM_Reject,
     /* 2221739 */ // Label 29457: @2221739
     /* 2221739 */ GIM_Try, /*On fail goto*//*Label 29496*/ GIMT_Encode4(2221853),
     /* 2221744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2221750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221762 */   GIM_Try, /*On fail goto*//*Label 29497*/ GIMT_Encode4(2221807), // Rule ID 48308 //
     /* 2221767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221770 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2221787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221806 */     // GIR_Coverage, 48308,
     /* 2221806 */     GIR_EraseRootFromParent_Done,
     /* 2221807 */   // Label 29497: @2221807
     /* 2221807 */   GIM_Try, /*On fail goto*//*Label 29498*/ GIMT_Encode4(2221852), // Rule ID 48309 //
     /* 2221812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221815 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2221832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221851 */     // GIR_Coverage, 48309,
     /* 2221851 */     GIR_EraseRootFromParent_Done,
     /* 2221852 */   // Label 29498: @2221852
     /* 2221852 */   GIM_Reject,
     /* 2221853 */ // Label 29496: @2221853
     /* 2221853 */ GIM_Reject,
     /* 2221854 */ // Label 29458: @2221854
     /* 2221854 */ GIM_Try, /*On fail goto*//*Label 29499*/ GIMT_Encode4(2221968),
     /* 2221859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2221865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221877 */   GIM_Try, /*On fail goto*//*Label 29500*/ GIMT_Encode4(2221922), // Rule ID 48320 //
     /* 2221882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221885 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2221902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221921 */     // GIR_Coverage, 48320,
     /* 2221921 */     GIR_EraseRootFromParent_Done,
     /* 2221922 */   // Label 29500: @2221922
     /* 2221922 */   GIM_Try, /*On fail goto*//*Label 29501*/ GIMT_Encode4(2221967), // Rule ID 48321 //
     /* 2221927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221930 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2221947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221966 */     // GIR_Coverage, 48321,
     /* 2221966 */     GIR_EraseRootFromParent_Done,
     /* 2221967 */   // Label 29501: @2221967
     /* 2221967 */   GIM_Reject,
     /* 2221968 */ // Label 29499: @2221968
     /* 2221968 */ GIM_Reject,
     /* 2221969 */ // Label 29459: @2221969
     /* 2221969 */ GIM_Try, /*On fail goto*//*Label 29502*/ GIMT_Encode4(2222083),
     /* 2221974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2221977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2221980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221992 */   GIM_Try, /*On fail goto*//*Label 29503*/ GIMT_Encode4(2222037), // Rule ID 48336 //
     /* 2221997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222000 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222036 */     // GIR_Coverage, 48336,
     /* 2222036 */     GIR_EraseRootFromParent_Done,
     /* 2222037 */   // Label 29503: @2222037
     /* 2222037 */   GIM_Try, /*On fail goto*//*Label 29504*/ GIMT_Encode4(2222082), // Rule ID 48337 //
     /* 2222042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222045 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222081 */     // GIR_Coverage, 48337,
     /* 2222081 */     GIR_EraseRootFromParent_Done,
     /* 2222082 */   // Label 29504: @2222082
     /* 2222082 */   GIM_Reject,
     /* 2222083 */ // Label 29502: @2222083
     /* 2222083 */ GIM_Reject,
     /* 2222084 */ // Label 29460: @2222084
     /* 2222084 */ GIM_Try, /*On fail goto*//*Label 29505*/ GIMT_Encode4(2222198),
     /* 2222089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2222092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2222095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222107 */   GIM_Try, /*On fail goto*//*Label 29506*/ GIMT_Encode4(2222152), // Rule ID 48380 //
     /* 2222112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222115 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222151 */     // GIR_Coverage, 48380,
     /* 2222151 */     GIR_EraseRootFromParent_Done,
     /* 2222152 */   // Label 29506: @2222152
     /* 2222152 */   GIM_Try, /*On fail goto*//*Label 29507*/ GIMT_Encode4(2222197), // Rule ID 48381 //
     /* 2222157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2222160 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222196 */     // GIR_Coverage, 48381,
     /* 2222196 */     GIR_EraseRootFromParent_Done,
     /* 2222197 */   // Label 29507: @2222197
     /* 2222197 */   GIM_Reject,
     /* 2222198 */ // Label 29505: @2222198
     /* 2222198 */ GIM_Reject,
     /* 2222199 */ // Label 29461: @2222199
     /* 2222199 */ GIM_Try, /*On fail goto*//*Label 29508*/ GIMT_Encode4(2222313),
     /* 2222204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2222210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222222 */   GIM_Try, /*On fail goto*//*Label 29509*/ GIMT_Encode4(2222267), // Rule ID 48312 //
     /* 2222227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222230 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2222247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222266 */     // GIR_Coverage, 48312,
     /* 2222266 */     GIR_EraseRootFromParent_Done,
     /* 2222267 */   // Label 29509: @2222267
     /* 2222267 */   GIM_Try, /*On fail goto*//*Label 29510*/ GIMT_Encode4(2222312), // Rule ID 48313 //
     /* 2222272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222275 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2222292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222311 */     // GIR_Coverage, 48313,
     /* 2222311 */     GIR_EraseRootFromParent_Done,
     /* 2222312 */   // Label 29510: @2222312
     /* 2222312 */   GIM_Reject,
     /* 2222313 */ // Label 29508: @2222313
     /* 2222313 */ GIM_Reject,
     /* 2222314 */ // Label 29462: @2222314
     /* 2222314 */ GIM_Try, /*On fail goto*//*Label 29511*/ GIMT_Encode4(2222428),
     /* 2222319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2222322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2222325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222337 */   GIM_Try, /*On fail goto*//*Label 29512*/ GIMT_Encode4(2222382), // Rule ID 48332 //
     /* 2222342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222345 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222381 */     // GIR_Coverage, 48332,
     /* 2222381 */     GIR_EraseRootFromParent_Done,
     /* 2222382 */   // Label 29512: @2222382
     /* 2222382 */   GIM_Try, /*On fail goto*//*Label 29513*/ GIMT_Encode4(2222427), // Rule ID 48333 //
     /* 2222387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222390 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222426 */     // GIR_Coverage, 48333,
     /* 2222426 */     GIR_EraseRootFromParent_Done,
     /* 2222427 */   // Label 29513: @2222427
     /* 2222427 */   GIM_Reject,
     /* 2222428 */ // Label 29511: @2222428
     /* 2222428 */ GIM_Reject,
     /* 2222429 */ // Label 29463: @2222429
     /* 2222429 */ GIM_Try, /*On fail goto*//*Label 29514*/ GIMT_Encode4(2222543),
     /* 2222434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2222437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2222440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222452 */   GIM_Try, /*On fail goto*//*Label 29515*/ GIMT_Encode4(2222497), // Rule ID 48368 //
     /* 2222457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222460 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2222463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222496 */     // GIR_Coverage, 48368,
     /* 2222496 */     GIR_EraseRootFromParent_Done,
     /* 2222497 */   // Label 29515: @2222497
     /* 2222497 */   GIM_Try, /*On fail goto*//*Label 29516*/ GIMT_Encode4(2222542), // Rule ID 48369 //
     /* 2222502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222505 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2222508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222541 */     // GIR_Coverage, 48369,
     /* 2222541 */     GIR_EraseRootFromParent_Done,
     /* 2222542 */   // Label 29516: @2222542
     /* 2222542 */   GIM_Reject,
     /* 2222543 */ // Label 29514: @2222543
     /* 2222543 */ GIM_Reject,
     /* 2222544 */ // Label 29464: @2222544
     /* 2222544 */ GIM_Try, /*On fail goto*//*Label 29517*/ GIMT_Encode4(2222658),
     /* 2222549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2222552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2222555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222567 */   GIM_Try, /*On fail goto*//*Label 29518*/ GIMT_Encode4(2222612), // Rule ID 48384 //
     /* 2222572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222575 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2222578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2222592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222611 */     // GIR_Coverage, 48384,
     /* 2222611 */     GIR_EraseRootFromParent_Done,
     /* 2222612 */   // Label 29518: @2222612
     /* 2222612 */   GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2222657), // Rule ID 48385 //
     /* 2222617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2222620 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2222623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2222637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222656 */     // GIR_Coverage, 48385,
     /* 2222656 */     GIR_EraseRootFromParent_Done,
     /* 2222657 */   // Label 29519: @2222657
     /* 2222657 */   GIM_Reject,
     /* 2222658 */ // Label 29517: @2222658
     /* 2222658 */ GIM_Reject,
     /* 2222659 */ // Label 29465: @2222659
     /* 2222659 */ GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2222773),
     /* 2222664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2222667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2222670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222682 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2222727), // Rule ID 48328 //
     /* 2222687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222690 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2222693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222726 */     // GIR_Coverage, 48328,
     /* 2222726 */     GIR_EraseRootFromParent_Done,
     /* 2222727 */   // Label 29521: @2222727
     /* 2222727 */   GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2222772), // Rule ID 48329 //
     /* 2222732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222735 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2222738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2222752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222771 */     // GIR_Coverage, 48329,
     /* 2222771 */     GIR_EraseRootFromParent_Done,
     /* 2222772 */   // Label 29522: @2222772
     /* 2222772 */   GIM_Reject,
     /* 2222773 */ // Label 29520: @2222773
     /* 2222773 */ GIM_Reject,
     /* 2222774 */ // Label 29466: @2222774
     /* 2222774 */ GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2222888),
     /* 2222779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2222782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2222785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222797 */   GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2222842), // Rule ID 48356 //
     /* 2222802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222805 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2222808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222841 */     // GIR_Coverage, 48356,
     /* 2222841 */     GIR_EraseRootFromParent_Done,
     /* 2222842 */   // Label 29524: @2222842
     /* 2222842 */   GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2222887), // Rule ID 48357 //
     /* 2222847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222850 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2222853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2222867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222886 */     // GIR_Coverage, 48357,
     /* 2222886 */     GIR_EraseRootFromParent_Done,
     /* 2222887 */   // Label 29525: @2222887
     /* 2222887 */   GIM_Reject,
     /* 2222888 */ // Label 29523: @2222888
     /* 2222888 */ GIM_Reject,
     /* 2222889 */ // Label 29467: @2222889
     /* 2222889 */ GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2223003),
     /* 2222894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2222897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2222900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222912 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2222957), // Rule ID 48372 //
     /* 2222917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222920 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2222923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2222937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222956 */     // GIR_Coverage, 48372,
     /* 2222956 */     GIR_EraseRootFromParent_Done,
     /* 2222957 */   // Label 29527: @2222957
     /* 2222957 */   GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2223002), // Rule ID 48373 //
     /* 2222962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222965 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2222968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2222982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223001 */     // GIR_Coverage, 48373,
     /* 2223001 */     GIR_EraseRootFromParent_Done,
     /* 2223002 */   // Label 29528: @2223002
     /* 2223002 */   GIM_Reject,
     /* 2223003 */ // Label 29526: @2223003
     /* 2223003 */ GIM_Reject,
     /* 2223004 */ // Label 29468: @2223004
     /* 2223004 */ GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2223118),
     /* 2223009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2223012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2223015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223027 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2223072), // Rule ID 48388 //
     /* 2223032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2223035 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2223038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223071 */     // GIR_Coverage, 48388,
     /* 2223071 */     GIR_EraseRootFromParent_Done,
     /* 2223072 */   // Label 29530: @2223072
     /* 2223072 */   GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2223117), // Rule ID 48389 //
     /* 2223077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2223080 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2223083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223116 */     // GIR_Coverage, 48389,
     /* 2223116 */     GIR_EraseRootFromParent_Done,
     /* 2223117 */   // Label 29531: @2223117
     /* 2223117 */   GIM_Reject,
     /* 2223118 */ // Label 29529: @2223118
     /* 2223118 */ GIM_Reject,
     /* 2223119 */ // Label 29469: @2223119
     /* 2223119 */ GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2223233),
     /* 2223124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2223127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2223130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223142 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2223187), // Rule ID 48344 //
     /* 2223147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223150 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2223153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2223167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223186 */     // GIR_Coverage, 48344,
     /* 2223186 */     GIR_EraseRootFromParent_Done,
     /* 2223187 */   // Label 29533: @2223187
     /* 2223187 */   GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2223232), // Rule ID 48345 //
     /* 2223192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223195 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2223198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2223212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223231 */     // GIR_Coverage, 48345,
     /* 2223231 */     GIR_EraseRootFromParent_Done,
     /* 2223232 */   // Label 29534: @2223232
     /* 2223232 */   GIM_Reject,
     /* 2223233 */ // Label 29532: @2223233
     /* 2223233 */ GIM_Reject,
     /* 2223234 */ // Label 29470: @2223234
     /* 2223234 */ GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2223348),
     /* 2223239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2223242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2223245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223257 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2223302), // Rule ID 48360 //
     /* 2223262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223265 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2223268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2223282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223301 */     // GIR_Coverage, 48360,
     /* 2223301 */     GIR_EraseRootFromParent_Done,
     /* 2223302 */   // Label 29536: @2223302
     /* 2223302 */   GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2223347), // Rule ID 48361 //
     /* 2223307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223310 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2223313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2223327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223346 */     // GIR_Coverage, 48361,
     /* 2223346 */     GIR_EraseRootFromParent_Done,
     /* 2223347 */   // Label 29537: @2223347
     /* 2223347 */   GIM_Reject,
     /* 2223348 */ // Label 29535: @2223348
     /* 2223348 */ GIM_Reject,
     /* 2223349 */ // Label 29471: @2223349
     /* 2223349 */ GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2223463),
     /* 2223354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2223357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2223360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223372 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2223417), // Rule ID 48376 //
     /* 2223377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223380 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2223383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223416 */     // GIR_Coverage, 48376,
     /* 2223416 */     GIR_EraseRootFromParent_Done,
     /* 2223417 */   // Label 29539: @2223417
     /* 2223417 */   GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2223462), // Rule ID 48377 //
     /* 2223422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223425 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2223428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223461 */     // GIR_Coverage, 48377,
     /* 2223461 */     GIR_EraseRootFromParent_Done,
     /* 2223462 */   // Label 29540: @2223462
     /* 2223462 */   GIM_Reject,
     /* 2223463 */ // Label 29538: @2223463
     /* 2223463 */ GIM_Reject,
     /* 2223464 */ // Label 29472: @2223464
     /* 2223464 */ GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2223578),
     /* 2223469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2223472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2223475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223487 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2223532), // Rule ID 48348 //
     /* 2223492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223495 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2223498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2223512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223531 */     // GIR_Coverage, 48348,
     /* 2223531 */     GIR_EraseRootFromParent_Done,
     /* 2223532 */   // Label 29542: @2223532
     /* 2223532 */   GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2223577), // Rule ID 48349 //
     /* 2223537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223540 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2223543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2223557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223576 */     // GIR_Coverage, 48349,
     /* 2223576 */     GIR_EraseRootFromParent_Done,
     /* 2223577 */   // Label 29543: @2223577
     /* 2223577 */   GIM_Reject,
     /* 2223578 */ // Label 29541: @2223578
     /* 2223578 */ GIM_Reject,
     /* 2223579 */ // Label 29473: @2223579
     /* 2223579 */ GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2223693),
     /* 2223584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2223587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2223590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223602 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2223647), // Rule ID 48364 //
     /* 2223607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223610 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2223613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223646 */     // GIR_Coverage, 48364,
     /* 2223646 */     GIR_EraseRootFromParent_Done,
     /* 2223647 */   // Label 29545: @2223647
     /* 2223647 */   GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2223692), // Rule ID 48365 //
     /* 2223652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223655 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2223658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223691 */     // GIR_Coverage, 48365,
     /* 2223691 */     GIR_EraseRootFromParent_Done,
     /* 2223692 */   // Label 29546: @2223692
     /* 2223692 */   GIM_Reject,
     /* 2223693 */ // Label 29544: @2223693
     /* 2223693 */ GIM_Reject,
     /* 2223694 */ // Label 29474: @2223694
     /* 2223694 */ GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2223808),
     /* 2223699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2223702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2223705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2223717 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2223762), // Rule ID 48352 //
     /* 2223722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223725 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2223728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223761 */     // GIR_Coverage, 48352,
     /* 2223761 */     GIR_EraseRootFromParent_Done,
     /* 2223762 */   // Label 29548: @2223762
     /* 2223762 */   GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2223807), // Rule ID 48353 //
     /* 2223767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223770 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2223773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2223787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223806 */     // GIR_Coverage, 48353,
     /* 2223806 */     GIR_EraseRootFromParent_Done,
     /* 2223807 */   // Label 29549: @2223807
     /* 2223807 */   GIM_Reject,
     /* 2223808 */ // Label 29547: @2223808
     /* 2223808 */ GIM_Reject,
     /* 2223809 */ // Label 29475: @2223809
     /* 2223809 */ GIM_Reject,
     /* 2223810 */ // Label 46: @2223810
     /* 2223810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29574*/ GIMT_Encode4(2226749),
     /* 2223821 */ /*GILLT_s32*//*Label 29550*/ GIMT_Encode4(2223945),
     /* 2223825 */ /*GILLT_s64*//*Label 29551*/ GIMT_Encode4(2224082), GIMT_Encode4(0),
     /* 2223833 */ /*GILLT_nxv1s8*//*Label 29552*/ GIMT_Encode4(2224219),
     /* 2223837 */ /*GILLT_nxv1s16*//*Label 29553*/ GIMT_Encode4(2224334),
     /* 2223841 */ /*GILLT_nxv1s32*//*Label 29554*/ GIMT_Encode4(2224449),
     /* 2223845 */ /*GILLT_nxv1s64*//*Label 29555*/ GIMT_Encode4(2224564), GIMT_Encode4(0),
     /* 2223853 */ /*GILLT_nxv2s8*//*Label 29556*/ GIMT_Encode4(2224679),
     /* 2223857 */ /*GILLT_nxv2s16*//*Label 29557*/ GIMT_Encode4(2224794),
     /* 2223861 */ /*GILLT_nxv2s32*//*Label 29558*/ GIMT_Encode4(2224909),
     /* 2223865 */ /*GILLT_nxv2s64*//*Label 29559*/ GIMT_Encode4(2225024), GIMT_Encode4(0),
     /* 2223873 */ /*GILLT_nxv4s8*//*Label 29560*/ GIMT_Encode4(2225139),
     /* 2223877 */ /*GILLT_nxv4s16*//*Label 29561*/ GIMT_Encode4(2225254),
     /* 2223881 */ /*GILLT_nxv4s32*//*Label 29562*/ GIMT_Encode4(2225369),
     /* 2223885 */ /*GILLT_nxv4s64*//*Label 29563*/ GIMT_Encode4(2225484), GIMT_Encode4(0),
     /* 2223893 */ /*GILLT_nxv8s8*//*Label 29564*/ GIMT_Encode4(2225599),
     /* 2223897 */ /*GILLT_nxv8s16*//*Label 29565*/ GIMT_Encode4(2225714),
     /* 2223901 */ /*GILLT_nxv8s32*//*Label 29566*/ GIMT_Encode4(2225829),
     /* 2223905 */ /*GILLT_nxv8s64*//*Label 29567*/ GIMT_Encode4(2225944), GIMT_Encode4(0),
     /* 2223913 */ /*GILLT_nxv16s8*//*Label 29568*/ GIMT_Encode4(2226059),
     /* 2223917 */ /*GILLT_nxv16s16*//*Label 29569*/ GIMT_Encode4(2226174),
     /* 2223921 */ /*GILLT_nxv16s32*//*Label 29570*/ GIMT_Encode4(2226289), GIMT_Encode4(0),
     /* 2223929 */ /*GILLT_nxv32s8*//*Label 29571*/ GIMT_Encode4(2226404),
     /* 2223933 */ /*GILLT_nxv32s16*//*Label 29572*/ GIMT_Encode4(2226519), GIMT_Encode4(0),
     /* 2223941 */ /*GILLT_nxv64s8*//*Label 29573*/ GIMT_Encode4(2226634),
     /* 2223945 */ // Label 29550: @2223945
     /* 2223945 */ GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2224081),
     /* 2223950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2223953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2223956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2223964 */   GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2223998), // Rule ID 2455 //
     /* 2223969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2223972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2223976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2223980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2223984 */     // MIs[1] Operand 1
     /* 2223984 */     // No operand predicates
     /* 2223984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2223986 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2223986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2223989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2223996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223997 */     // GIR_Coverage, 2455,
     /* 2223997 */     GIR_EraseRootFromParent_Done,
     /* 2223998 */   // Label 29576: @2223998
     /* 2223998 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2224032), // Rule ID 62544 //
     /* 2224003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2224006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2224010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2224014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2224018 */     // MIs[1] Operand 1
     /* 2224018 */     // No operand predicates
     /* 2224018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2224020 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2224020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2224023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2224030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224031 */     // GIR_Coverage, 62544,
     /* 2224031 */     GIR_EraseRootFromParent_Done,
     /* 2224032 */   // Label 29577: @2224032
     /* 2224032 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2224061), // Rule ID 2453 //
     /* 2224037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2224040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2224047 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2224047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2224050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2224059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224060 */     // GIR_Coverage, 2453,
     /* 2224060 */     GIR_EraseRootFromParent_Done,
     /* 2224061 */   // Label 29578: @2224061
     /* 2224061 */   GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2224080), // Rule ID 64438 //
     /* 2224066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2224069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2224073 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2224073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2224078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224079 */     // GIR_Coverage, 64438,
     /* 2224079 */     GIR_Done,
     /* 2224080 */   // Label 29579: @2224080
     /* 2224080 */   GIM_Reject,
     /* 2224081 */ // Label 29575: @2224081
     /* 2224081 */ GIM_Reject,
     /* 2224082 */ // Label 29551: @2224082
     /* 2224082 */ GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2224218),
     /* 2224087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2224090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2224093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2224097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2224101 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2224135), // Rule ID 2454 //
     /* 2224106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2224109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2224113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2224117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2224121 */     // MIs[1] Operand 1
     /* 2224121 */     // No operand predicates
     /* 2224121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2224123 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2224123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2224126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2224133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224134 */     // GIR_Coverage, 2454,
     /* 2224134 */     GIR_EraseRootFromParent_Done,
     /* 2224135 */   // Label 29581: @2224135
     /* 2224135 */   GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2224169), // Rule ID 62543 //
     /* 2224140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2224143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2224147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2224151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2224155 */     // MIs[1] Operand 1
     /* 2224155 */     // No operand predicates
     /* 2224155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2224157 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2224157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2224160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2224167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224168 */     // GIR_Coverage, 62543,
     /* 2224168 */     GIR_EraseRootFromParent_Done,
     /* 2224169 */   // Label 29582: @2224169
     /* 2224169 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2224198), // Rule ID 2452 //
     /* 2224174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2224177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2224184 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2224184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2224187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2224196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224197 */     // GIR_Coverage, 2452,
     /* 2224197 */     GIR_EraseRootFromParent_Done,
     /* 2224198 */   // Label 29583: @2224198
     /* 2224198 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2224217), // Rule ID 64437 //
     /* 2224203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2224206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2224210 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2224210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2224215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224216 */     // GIR_Coverage, 64437,
     /* 2224216 */     GIR_Done,
     /* 2224217 */   // Label 29584: @2224217
     /* 2224217 */   GIM_Reject,
     /* 2224218 */ // Label 29580: @2224218
     /* 2224218 */ GIM_Reject,
     /* 2224219 */ // Label 29552: @2224219
     /* 2224219 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2224333),
     /* 2224224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2224227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2224230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224242 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2224287), // Rule ID 59396 //
     /* 2224247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224250 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2224253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2224267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224286 */     // GIR_Coverage, 59396,
     /* 2224286 */     GIR_EraseRootFromParent_Done,
     /* 2224287 */   // Label 29586: @2224287
     /* 2224287 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2224332), // Rule ID 59397 //
     /* 2224292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224295 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2224298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2224312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224331 */     // GIR_Coverage, 59397,
     /* 2224331 */     GIR_EraseRootFromParent_Done,
     /* 2224332 */   // Label 29587: @2224332
     /* 2224332 */   GIM_Reject,
     /* 2224333 */ // Label 29585: @2224333
     /* 2224333 */ GIM_Reject,
     /* 2224334 */ // Label 29553: @2224334
     /* 2224334 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2224448),
     /* 2224339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2224342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2224345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224357 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2224402), // Rule ID 59408 //
     /* 2224362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224365 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2224368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2224382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224401 */     // GIR_Coverage, 59408,
     /* 2224401 */     GIR_EraseRootFromParent_Done,
     /* 2224402 */   // Label 29589: @2224402
     /* 2224402 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2224447), // Rule ID 59409 //
     /* 2224407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224410 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2224413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2224427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224446 */     // GIR_Coverage, 59409,
     /* 2224446 */     GIR_EraseRootFromParent_Done,
     /* 2224447 */   // Label 29590: @2224447
     /* 2224447 */   GIM_Reject,
     /* 2224448 */ // Label 29588: @2224448
     /* 2224448 */ GIM_Reject,
     /* 2224449 */ // Label 29554: @2224449
     /* 2224449 */ GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2224563),
     /* 2224454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2224457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2224460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224472 */   GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2224517), // Rule ID 59416 //
     /* 2224477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224480 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2224497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224516 */     // GIR_Coverage, 59416,
     /* 2224516 */     GIR_EraseRootFromParent_Done,
     /* 2224517 */   // Label 29592: @2224517
     /* 2224517 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2224562), // Rule ID 59417 //
     /* 2224522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224525 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2224528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2224542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224561 */     // GIR_Coverage, 59417,
     /* 2224561 */     GIR_EraseRootFromParent_Done,
     /* 2224562 */   // Label 29593: @2224562
     /* 2224562 */   GIM_Reject,
     /* 2224563 */ // Label 29591: @2224563
     /* 2224563 */ GIM_Reject,
     /* 2224564 */ // Label 29555: @2224564
     /* 2224564 */ GIM_Try, /*On fail goto*//*Label 29594*/ GIMT_Encode4(2224678),
     /* 2224569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2224572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2224575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224587 */   GIM_Try, /*On fail goto*//*Label 29595*/ GIMT_Encode4(2224632), // Rule ID 59432 //
     /* 2224592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224595 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2224612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224631 */     // GIR_Coverage, 59432,
     /* 2224631 */     GIR_EraseRootFromParent_Done,
     /* 2224632 */   // Label 29595: @2224632
     /* 2224632 */   GIM_Try, /*On fail goto*//*Label 29596*/ GIMT_Encode4(2224677), // Rule ID 59433 //
     /* 2224637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224640 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2224643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2224657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224676 */     // GIR_Coverage, 59433,
     /* 2224676 */     GIR_EraseRootFromParent_Done,
     /* 2224677 */   // Label 29596: @2224677
     /* 2224677 */   GIM_Reject,
     /* 2224678 */ // Label 29594: @2224678
     /* 2224678 */ GIM_Reject,
     /* 2224679 */ // Label 29556: @2224679
     /* 2224679 */ GIM_Try, /*On fail goto*//*Label 29597*/ GIMT_Encode4(2224793),
     /* 2224684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2224687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2224690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224702 */   GIM_Try, /*On fail goto*//*Label 29598*/ GIMT_Encode4(2224747), // Rule ID 59400 //
     /* 2224707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224710 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2224713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2224727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224746 */     // GIR_Coverage, 59400,
     /* 2224746 */     GIR_EraseRootFromParent_Done,
     /* 2224747 */   // Label 29598: @2224747
     /* 2224747 */   GIM_Try, /*On fail goto*//*Label 29599*/ GIMT_Encode4(2224792), // Rule ID 59401 //
     /* 2224752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224755 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2224758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2224772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224791 */     // GIR_Coverage, 59401,
     /* 2224791 */     GIR_EraseRootFromParent_Done,
     /* 2224792 */   // Label 29599: @2224792
     /* 2224792 */   GIM_Reject,
     /* 2224793 */ // Label 29597: @2224793
     /* 2224793 */ GIM_Reject,
     /* 2224794 */ // Label 29557: @2224794
     /* 2224794 */ GIM_Try, /*On fail goto*//*Label 29600*/ GIMT_Encode4(2224908),
     /* 2224799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2224802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2224805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224817 */   GIM_Try, /*On fail goto*//*Label 29601*/ GIMT_Encode4(2224862), // Rule ID 59412 //
     /* 2224822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224825 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2224828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2224842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224861 */     // GIR_Coverage, 59412,
     /* 2224861 */     GIR_EraseRootFromParent_Done,
     /* 2224862 */   // Label 29601: @2224862
     /* 2224862 */   GIM_Try, /*On fail goto*//*Label 29602*/ GIMT_Encode4(2224907), // Rule ID 59413 //
     /* 2224867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224870 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2224873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2224887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224906 */     // GIR_Coverage, 59413,
     /* 2224906 */     GIR_EraseRootFromParent_Done,
     /* 2224907 */   // Label 29602: @2224907
     /* 2224907 */   GIM_Reject,
     /* 2224908 */ // Label 29600: @2224908
     /* 2224908 */ GIM_Reject,
     /* 2224909 */ // Label 29558: @2224909
     /* 2224909 */ GIM_Try, /*On fail goto*//*Label 29603*/ GIMT_Encode4(2225023),
     /* 2224914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2224917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2224920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224932 */   GIM_Try, /*On fail goto*//*Label 29604*/ GIMT_Encode4(2224977), // Rule ID 59428 //
     /* 2224937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224940 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2224943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2224957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224976 */     // GIR_Coverage, 59428,
     /* 2224976 */     GIR_EraseRootFromParent_Done,
     /* 2224977 */   // Label 29604: @2224977
     /* 2224977 */   GIM_Try, /*On fail goto*//*Label 29605*/ GIMT_Encode4(2225022), // Rule ID 59429 //
     /* 2224982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224985 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2224988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2225002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225021 */     // GIR_Coverage, 59429,
     /* 2225021 */     GIR_EraseRootFromParent_Done,
     /* 2225022 */   // Label 29605: @2225022
     /* 2225022 */   GIM_Reject,
     /* 2225023 */ // Label 29603: @2225023
     /* 2225023 */ GIM_Reject,
     /* 2225024 */ // Label 29559: @2225024
     /* 2225024 */ GIM_Try, /*On fail goto*//*Label 29606*/ GIMT_Encode4(2225138),
     /* 2225029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2225032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2225035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225047 */   GIM_Try, /*On fail goto*//*Label 29607*/ GIMT_Encode4(2225092), // Rule ID 59472 //
     /* 2225052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2225055 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2225058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225091 */     // GIR_Coverage, 59472,
     /* 2225091 */     GIR_EraseRootFromParent_Done,
     /* 2225092 */   // Label 29607: @2225092
     /* 2225092 */   GIM_Try, /*On fail goto*//*Label 29608*/ GIMT_Encode4(2225137), // Rule ID 59473 //
     /* 2225097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2225100 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2225103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225136 */     // GIR_Coverage, 59473,
     /* 2225136 */     GIR_EraseRootFromParent_Done,
     /* 2225137 */   // Label 29608: @2225137
     /* 2225137 */   GIM_Reject,
     /* 2225138 */ // Label 29606: @2225138
     /* 2225138 */ GIM_Reject,
     /* 2225139 */ // Label 29560: @2225139
     /* 2225139 */ GIM_Try, /*On fail goto*//*Label 29609*/ GIMT_Encode4(2225253),
     /* 2225144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2225147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2225150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225162 */   GIM_Try, /*On fail goto*//*Label 29610*/ GIMT_Encode4(2225207), // Rule ID 59404 //
     /* 2225167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225170 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2225173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2225187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225206 */     // GIR_Coverage, 59404,
     /* 2225206 */     GIR_EraseRootFromParent_Done,
     /* 2225207 */   // Label 29610: @2225207
     /* 2225207 */   GIM_Try, /*On fail goto*//*Label 29611*/ GIMT_Encode4(2225252), // Rule ID 59405 //
     /* 2225212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225215 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2225218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2225232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225251 */     // GIR_Coverage, 59405,
     /* 2225251 */     GIR_EraseRootFromParent_Done,
     /* 2225252 */   // Label 29611: @2225252
     /* 2225252 */   GIM_Reject,
     /* 2225253 */ // Label 29609: @2225253
     /* 2225253 */ GIM_Reject,
     /* 2225254 */ // Label 29561: @2225254
     /* 2225254 */ GIM_Try, /*On fail goto*//*Label 29612*/ GIMT_Encode4(2225368),
     /* 2225259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2225262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2225265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225277 */   GIM_Try, /*On fail goto*//*Label 29613*/ GIMT_Encode4(2225322), // Rule ID 59424 //
     /* 2225282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225285 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2225288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2225302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225321 */     // GIR_Coverage, 59424,
     /* 2225321 */     GIR_EraseRootFromParent_Done,
     /* 2225322 */   // Label 29613: @2225322
     /* 2225322 */   GIM_Try, /*On fail goto*//*Label 29614*/ GIMT_Encode4(2225367), // Rule ID 59425 //
     /* 2225327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225330 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2225333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2225347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225366 */     // GIR_Coverage, 59425,
     /* 2225366 */     GIR_EraseRootFromParent_Done,
     /* 2225367 */   // Label 29614: @2225367
     /* 2225367 */   GIM_Reject,
     /* 2225368 */ // Label 29612: @2225368
     /* 2225368 */ GIM_Reject,
     /* 2225369 */ // Label 29562: @2225369
     /* 2225369 */ GIM_Try, /*On fail goto*//*Label 29615*/ GIMT_Encode4(2225483),
     /* 2225374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2225377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2225380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225392 */   GIM_Try, /*On fail goto*//*Label 29616*/ GIMT_Encode4(2225437), // Rule ID 59460 //
     /* 2225397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225400 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2225403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225436 */     // GIR_Coverage, 59460,
     /* 2225436 */     GIR_EraseRootFromParent_Done,
     /* 2225437 */   // Label 29616: @2225437
     /* 2225437 */   GIM_Try, /*On fail goto*//*Label 29617*/ GIMT_Encode4(2225482), // Rule ID 59461 //
     /* 2225442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225445 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2225448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225481 */     // GIR_Coverage, 59461,
     /* 2225481 */     GIR_EraseRootFromParent_Done,
     /* 2225482 */   // Label 29617: @2225482
     /* 2225482 */   GIM_Reject,
     /* 2225483 */ // Label 29615: @2225483
     /* 2225483 */ GIM_Reject,
     /* 2225484 */ // Label 29563: @2225484
     /* 2225484 */ GIM_Try, /*On fail goto*//*Label 29618*/ GIMT_Encode4(2225598),
     /* 2225489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2225492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2225495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225507 */   GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2225552), // Rule ID 59476 //
     /* 2225512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2225515 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2225518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2225532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225551 */     // GIR_Coverage, 59476,
     /* 2225551 */     GIR_EraseRootFromParent_Done,
     /* 2225552 */   // Label 29619: @2225552
     /* 2225552 */   GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2225597), // Rule ID 59477 //
     /* 2225557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2225560 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2225563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2225577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225596 */     // GIR_Coverage, 59477,
     /* 2225596 */     GIR_EraseRootFromParent_Done,
     /* 2225597 */   // Label 29620: @2225597
     /* 2225597 */   GIM_Reject,
     /* 2225598 */ // Label 29618: @2225598
     /* 2225598 */ GIM_Reject,
     /* 2225599 */ // Label 29564: @2225599
     /* 2225599 */ GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2225713),
     /* 2225604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2225607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2225610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2225622 */   GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2225667), // Rule ID 59420 //
     /* 2225627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225630 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2225633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2225647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225666 */     // GIR_Coverage, 59420,
     /* 2225666 */     GIR_EraseRootFromParent_Done,
     /* 2225667 */   // Label 29622: @2225667
     /* 2225667 */   GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2225712), // Rule ID 59421 //
     /* 2225672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225675 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2225678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2225692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225711 */     // GIR_Coverage, 59421,
     /* 2225711 */     GIR_EraseRootFromParent_Done,
     /* 2225712 */   // Label 29623: @2225712
     /* 2225712 */   GIM_Reject,
     /* 2225713 */ // Label 29621: @2225713
     /* 2225713 */ GIM_Reject,
     /* 2225714 */ // Label 29565: @2225714
     /* 2225714 */ GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2225828),
     /* 2225719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2225725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225737 */   GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2225782), // Rule ID 59448 //
     /* 2225742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225745 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225781 */     // GIR_Coverage, 59448,
     /* 2225781 */     GIR_EraseRootFromParent_Done,
     /* 2225782 */   // Label 29625: @2225782
     /* 2225782 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2225827), // Rule ID 59449 //
     /* 2225787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225790 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2225793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2225807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225826 */     // GIR_Coverage, 59449,
     /* 2225826 */     GIR_EraseRootFromParent_Done,
     /* 2225827 */   // Label 29626: @2225827
     /* 2225827 */   GIM_Reject,
     /* 2225828 */ // Label 29624: @2225828
     /* 2225828 */ GIM_Reject,
     /* 2225829 */ // Label 29566: @2225829
     /* 2225829 */ GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2225943),
     /* 2225834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2225840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225852 */   GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2225897), // Rule ID 59464 //
     /* 2225857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225860 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2225877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225896 */     // GIR_Coverage, 59464,
     /* 2225896 */     GIR_EraseRootFromParent_Done,
     /* 2225897 */   // Label 29628: @2225897
     /* 2225897 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2225942), // Rule ID 59465 //
     /* 2225902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225905 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2225922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225941 */     // GIR_Coverage, 59465,
     /* 2225941 */     GIR_EraseRootFromParent_Done,
     /* 2225942 */   // Label 29629: @2225942
     /* 2225942 */   GIM_Reject,
     /* 2225943 */ // Label 29627: @2225943
     /* 2225943 */ GIM_Reject,
     /* 2225944 */ // Label 29567: @2225944
     /* 2225944 */ GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2226058),
     /* 2225949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2225955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225967 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2226012), // Rule ID 59480 //
     /* 2225972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2225975 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2225992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226011 */     // GIR_Coverage, 59480,
     /* 2226011 */     GIR_EraseRootFromParent_Done,
     /* 2226012 */   // Label 29631: @2226012
     /* 2226012 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2226057), // Rule ID 59481 //
     /* 2226017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2226020 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2226023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2226052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226056 */     // GIR_Coverage, 59481,
     /* 2226056 */     GIR_EraseRootFromParent_Done,
     /* 2226057 */   // Label 29632: @2226057
     /* 2226057 */   GIM_Reject,
     /* 2226058 */ // Label 29630: @2226058
     /* 2226058 */ GIM_Reject,
     /* 2226059 */ // Label 29568: @2226059
     /* 2226059 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2226173),
     /* 2226064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2226070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226082 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2226127), // Rule ID 59436 //
     /* 2226087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226090 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2226107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226126 */     // GIR_Coverage, 59436,
     /* 2226126 */     GIR_EraseRootFromParent_Done,
     /* 2226127 */   // Label 29634: @2226127
     /* 2226127 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2226172), // Rule ID 59437 //
     /* 2226132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226135 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2226138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2226152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226171 */     // GIR_Coverage, 59437,
     /* 2226171 */     GIR_EraseRootFromParent_Done,
     /* 2226172 */   // Label 29635: @2226172
     /* 2226172 */   GIM_Reject,
     /* 2226173 */ // Label 29633: @2226173
     /* 2226173 */ GIM_Reject,
     /* 2226174 */ // Label 29569: @2226174
     /* 2226174 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2226288),
     /* 2226179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2226185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226197 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2226242), // Rule ID 59452 //
     /* 2226202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226205 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2226222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226241 */     // GIR_Coverage, 59452,
     /* 2226241 */     GIR_EraseRootFromParent_Done,
     /* 2226242 */   // Label 29637: @2226242
     /* 2226242 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2226287), // Rule ID 59453 //
     /* 2226247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226250 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2226267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226286 */     // GIR_Coverage, 59453,
     /* 2226286 */     GIR_EraseRootFromParent_Done,
     /* 2226287 */   // Label 29638: @2226287
     /* 2226287 */   GIM_Reject,
     /* 2226288 */ // Label 29636: @2226288
     /* 2226288 */ GIM_Reject,
     /* 2226289 */ // Label 29570: @2226289
     /* 2226289 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2226403),
     /* 2226294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2226300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226312 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2226357), // Rule ID 59468 //
     /* 2226317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226320 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226356 */     // GIR_Coverage, 59468,
     /* 2226356 */     GIR_EraseRootFromParent_Done,
     /* 2226357 */   // Label 29640: @2226357
     /* 2226357 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2226402), // Rule ID 59469 //
     /* 2226362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226365 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226401 */     // GIR_Coverage, 59469,
     /* 2226401 */     GIR_EraseRootFromParent_Done,
     /* 2226402 */   // Label 29641: @2226402
     /* 2226402 */   GIM_Reject,
     /* 2226403 */ // Label 29639: @2226403
     /* 2226403 */ GIM_Reject,
     /* 2226404 */ // Label 29571: @2226404
     /* 2226404 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2226518),
     /* 2226409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2226415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226427 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2226472), // Rule ID 59440 //
     /* 2226432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226435 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2226452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226471 */     // GIR_Coverage, 59440,
     /* 2226471 */     GIR_EraseRootFromParent_Done,
     /* 2226472 */   // Label 29643: @2226472
     /* 2226472 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2226517), // Rule ID 59441 //
     /* 2226477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226480 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2226497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226516 */     // GIR_Coverage, 59441,
     /* 2226516 */     GIR_EraseRootFromParent_Done,
     /* 2226517 */   // Label 29644: @2226517
     /* 2226517 */   GIM_Reject,
     /* 2226518 */ // Label 29642: @2226518
     /* 2226518 */ GIM_Reject,
     /* 2226519 */ // Label 29572: @2226519
     /* 2226519 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2226633),
     /* 2226524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2226527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2226530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226542 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2226587), // Rule ID 59456 //
     /* 2226547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226550 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226586 */     // GIR_Coverage, 59456,
     /* 2226586 */     GIR_EraseRootFromParent_Done,
     /* 2226587 */   // Label 29646: @2226587
     /* 2226587 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2226632), // Rule ID 59457 //
     /* 2226592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226595 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226631 */     // GIR_Coverage, 59457,
     /* 2226631 */     GIR_EraseRootFromParent_Done,
     /* 2226632 */   // Label 29647: @2226632
     /* 2226632 */   GIM_Reject,
     /* 2226633 */ // Label 29645: @2226633
     /* 2226633 */ GIM_Reject,
     /* 2226634 */ // Label 29573: @2226634
     /* 2226634 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2226748),
     /* 2226639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2226642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2226645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226657 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2226702), // Rule ID 59444 //
     /* 2226662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226665 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2226668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226701 */     // GIR_Coverage, 59444,
     /* 2226701 */     GIR_EraseRootFromParent_Done,
     /* 2226702 */   // Label 29649: @2226702
     /* 2226702 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2226747), // Rule ID 59445 //
     /* 2226707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226710 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2226713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2226727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226746 */     // GIR_Coverage, 59445,
     /* 2226746 */     GIR_EraseRootFromParent_Done,
     /* 2226747 */   // Label 29650: @2226747
     /* 2226747 */   GIM_Reject,
     /* 2226748 */ // Label 29648: @2226748
     /* 2226748 */ GIM_Reject,
     /* 2226749 */ // Label 29574: @2226749
     /* 2226749 */ GIM_Reject,
     /* 2226750 */ // Label 47: @2226750
     /* 2226750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29675*/ GIMT_Encode4(2229659),
     /* 2226761 */ /*GILLT_s32*//*Label 29651*/ GIMT_Encode4(2226885),
     /* 2226765 */ /*GILLT_s64*//*Label 29652*/ GIMT_Encode4(2227007), GIMT_Encode4(0),
     /* 2226773 */ /*GILLT_nxv1s8*//*Label 29653*/ GIMT_Encode4(2227129),
     /* 2226777 */ /*GILLT_nxv1s16*//*Label 29654*/ GIMT_Encode4(2227244),
     /* 2226781 */ /*GILLT_nxv1s32*//*Label 29655*/ GIMT_Encode4(2227359),
     /* 2226785 */ /*GILLT_nxv1s64*//*Label 29656*/ GIMT_Encode4(2227474), GIMT_Encode4(0),
     /* 2226793 */ /*GILLT_nxv2s8*//*Label 29657*/ GIMT_Encode4(2227589),
     /* 2226797 */ /*GILLT_nxv2s16*//*Label 29658*/ GIMT_Encode4(2227704),
     /* 2226801 */ /*GILLT_nxv2s32*//*Label 29659*/ GIMT_Encode4(2227819),
     /* 2226805 */ /*GILLT_nxv2s64*//*Label 29660*/ GIMT_Encode4(2227934), GIMT_Encode4(0),
     /* 2226813 */ /*GILLT_nxv4s8*//*Label 29661*/ GIMT_Encode4(2228049),
     /* 2226817 */ /*GILLT_nxv4s16*//*Label 29662*/ GIMT_Encode4(2228164),
     /* 2226821 */ /*GILLT_nxv4s32*//*Label 29663*/ GIMT_Encode4(2228279),
     /* 2226825 */ /*GILLT_nxv4s64*//*Label 29664*/ GIMT_Encode4(2228394), GIMT_Encode4(0),
     /* 2226833 */ /*GILLT_nxv8s8*//*Label 29665*/ GIMT_Encode4(2228509),
     /* 2226837 */ /*GILLT_nxv8s16*//*Label 29666*/ GIMT_Encode4(2228624),
     /* 2226841 */ /*GILLT_nxv8s32*//*Label 29667*/ GIMT_Encode4(2228739),
     /* 2226845 */ /*GILLT_nxv8s64*//*Label 29668*/ GIMT_Encode4(2228854), GIMT_Encode4(0),
     /* 2226853 */ /*GILLT_nxv16s8*//*Label 29669*/ GIMT_Encode4(2228969),
     /* 2226857 */ /*GILLT_nxv16s16*//*Label 29670*/ GIMT_Encode4(2229084),
     /* 2226861 */ /*GILLT_nxv16s32*//*Label 29671*/ GIMT_Encode4(2229199), GIMT_Encode4(0),
     /* 2226869 */ /*GILLT_nxv32s8*//*Label 29672*/ GIMT_Encode4(2229314),
     /* 2226873 */ /*GILLT_nxv32s16*//*Label 29673*/ GIMT_Encode4(2229429), GIMT_Encode4(0),
     /* 2226881 */ /*GILLT_nxv64s8*//*Label 29674*/ GIMT_Encode4(2229544),
     /* 2226885 */ // Label 29651: @2226885
     /* 2226885 */ GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2227006),
     /* 2226890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2226893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226904 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2226940), // Rule ID 2457 //
     /* 2226909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2226912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2226916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2226924 */     // MIs[1] Operand 1
     /* 2226924 */     // No operand predicates
     /* 2226924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226926 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2226926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2226929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226933 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2226938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226939 */     // GIR_Coverage, 2457,
     /* 2226939 */     GIR_EraseRootFromParent_Done,
     /* 2226940 */   // Label 29677: @2226940
     /* 2226940 */   GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2226976), // Rule ID 62546 //
     /* 2226945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2226948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2226952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2226960 */     // MIs[1] Operand 1
     /* 2226960 */     // No operand predicates
     /* 2226960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226962 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2226962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2226965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2226974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226975 */     // GIR_Coverage, 62546,
     /* 2226975 */     GIR_EraseRootFromParent_Done,
     /* 2226976 */   // Label 29678: @2226976
     /* 2226976 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2227005), // Rule ID 2451 //
     /* 2226981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2226984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2226991 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2226991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2226994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227004 */     // GIR_Coverage, 2451,
     /* 2227004 */     GIR_EraseRootFromParent_Done,
     /* 2227005 */   // Label 29679: @2227005
     /* 2227005 */   GIM_Reject,
     /* 2227006 */ // Label 29676: @2227006
     /* 2227006 */ GIM_Reject,
     /* 2227007 */ // Label 29652: @2227007
     /* 2227007 */ GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2227128),
     /* 2227012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2227018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227026 */   GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2227062), // Rule ID 2456 //
     /* 2227031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2227034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227046 */     // MIs[1] Operand 1
     /* 2227046 */     // No operand predicates
     /* 2227046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227048 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2227048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2227051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227055 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2227060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227061 */     // GIR_Coverage, 2456,
     /* 2227061 */     GIR_EraseRootFromParent_Done,
     /* 2227062 */   // Label 29681: @2227062
     /* 2227062 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2227098), // Rule ID 62545 //
     /* 2227067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2227070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227082 */     // MIs[1] Operand 1
     /* 2227082 */     // No operand predicates
     /* 2227082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227084 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2227084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2227087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227091 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2227096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227097 */     // GIR_Coverage, 62545,
     /* 2227097 */     GIR_EraseRootFromParent_Done,
     /* 2227098 */   // Label 29682: @2227098
     /* 2227098 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2227127), // Rule ID 2450 //
     /* 2227103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2227106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2227113 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2227113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2227116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227126 */     // GIR_Coverage, 2450,
     /* 2227126 */     GIR_EraseRootFromParent_Done,
     /* 2227127 */   // Label 29683: @2227127
     /* 2227127 */   GIM_Reject,
     /* 2227128 */ // Label 29680: @2227128
     /* 2227128 */ GIM_Reject,
     /* 2227129 */ // Label 29653: @2227129
     /* 2227129 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2227243),
     /* 2227134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2227137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2227140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227152 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2227197), // Rule ID 59264 //
     /* 2227157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227160 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2227163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2227177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227196 */     // GIR_Coverage, 59264,
     /* 2227196 */     GIR_EraseRootFromParent_Done,
     /* 2227197 */   // Label 29685: @2227197
     /* 2227197 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2227242), // Rule ID 59265 //
     /* 2227202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227205 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2227208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2227222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227241 */     // GIR_Coverage, 59265,
     /* 2227241 */     GIR_EraseRootFromParent_Done,
     /* 2227242 */   // Label 29686: @2227242
     /* 2227242 */   GIM_Reject,
     /* 2227243 */ // Label 29684: @2227243
     /* 2227243 */ GIM_Reject,
     /* 2227244 */ // Label 29654: @2227244
     /* 2227244 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2227358),
     /* 2227249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2227252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2227255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227267 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2227312), // Rule ID 59276 //
     /* 2227272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227275 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2227292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227311 */     // GIR_Coverage, 59276,
     /* 2227311 */     GIR_EraseRootFromParent_Done,
     /* 2227312 */   // Label 29688: @2227312
     /* 2227312 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2227357), // Rule ID 59277 //
     /* 2227317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227320 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2227323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2227337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227356 */     // GIR_Coverage, 59277,
     /* 2227356 */     GIR_EraseRootFromParent_Done,
     /* 2227357 */   // Label 29689: @2227357
     /* 2227357 */   GIM_Reject,
     /* 2227358 */ // Label 29687: @2227358
     /* 2227358 */ GIM_Reject,
     /* 2227359 */ // Label 29655: @2227359
     /* 2227359 */ GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2227473),
     /* 2227364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2227367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2227370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227382 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2227427), // Rule ID 59284 //
     /* 2227387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227390 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2227407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227426 */     // GIR_Coverage, 59284,
     /* 2227426 */     GIR_EraseRootFromParent_Done,
     /* 2227427 */   // Label 29691: @2227427
     /* 2227427 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2227472), // Rule ID 59285 //
     /* 2227432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227435 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2227438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2227452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227471 */     // GIR_Coverage, 59285,
     /* 2227471 */     GIR_EraseRootFromParent_Done,
     /* 2227472 */   // Label 29692: @2227472
     /* 2227472 */   GIM_Reject,
     /* 2227473 */ // Label 29690: @2227473
     /* 2227473 */ GIM_Reject,
     /* 2227474 */ // Label 29656: @2227474
     /* 2227474 */ GIM_Try, /*On fail goto*//*Label 29693*/ GIMT_Encode4(2227588),
     /* 2227479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2227482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2227485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227497 */   GIM_Try, /*On fail goto*//*Label 29694*/ GIMT_Encode4(2227542), // Rule ID 59300 //
     /* 2227502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2227505 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2227508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2227522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2227537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227541 */     // GIR_Coverage, 59300,
     /* 2227541 */     GIR_EraseRootFromParent_Done,
     /* 2227542 */   // Label 29694: @2227542
     /* 2227542 */   GIM_Try, /*On fail goto*//*Label 29695*/ GIMT_Encode4(2227587), // Rule ID 59301 //
     /* 2227547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2227550 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2227553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2227567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2227582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227586 */     // GIR_Coverage, 59301,
     /* 2227586 */     GIR_EraseRootFromParent_Done,
     /* 2227587 */   // Label 29695: @2227587
     /* 2227587 */   GIM_Reject,
     /* 2227588 */ // Label 29693: @2227588
     /* 2227588 */ GIM_Reject,
     /* 2227589 */ // Label 29657: @2227589
     /* 2227589 */ GIM_Try, /*On fail goto*//*Label 29696*/ GIMT_Encode4(2227703),
     /* 2227594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2227597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2227600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227612 */   GIM_Try, /*On fail goto*//*Label 29697*/ GIMT_Encode4(2227657), // Rule ID 59268 //
     /* 2227617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227620 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2227623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2227637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227656 */     // GIR_Coverage, 59268,
     /* 2227656 */     GIR_EraseRootFromParent_Done,
     /* 2227657 */   // Label 29697: @2227657
     /* 2227657 */   GIM_Try, /*On fail goto*//*Label 29698*/ GIMT_Encode4(2227702), // Rule ID 59269 //
     /* 2227662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227665 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2227668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2227682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227701 */     // GIR_Coverage, 59269,
     /* 2227701 */     GIR_EraseRootFromParent_Done,
     /* 2227702 */   // Label 29698: @2227702
     /* 2227702 */   GIM_Reject,
     /* 2227703 */ // Label 29696: @2227703
     /* 2227703 */ GIM_Reject,
     /* 2227704 */ // Label 29658: @2227704
     /* 2227704 */ GIM_Try, /*On fail goto*//*Label 29699*/ GIMT_Encode4(2227818),
     /* 2227709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2227712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2227715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227727 */   GIM_Try, /*On fail goto*//*Label 29700*/ GIMT_Encode4(2227772), // Rule ID 59280 //
     /* 2227732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227735 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2227738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2227752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227771 */     // GIR_Coverage, 59280,
     /* 2227771 */     GIR_EraseRootFromParent_Done,
     /* 2227772 */   // Label 29700: @2227772
     /* 2227772 */   GIM_Try, /*On fail goto*//*Label 29701*/ GIMT_Encode4(2227817), // Rule ID 59281 //
     /* 2227777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227780 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2227783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2227797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227816 */     // GIR_Coverage, 59281,
     /* 2227816 */     GIR_EraseRootFromParent_Done,
     /* 2227817 */   // Label 29701: @2227817
     /* 2227817 */   GIM_Reject,
     /* 2227818 */ // Label 29699: @2227818
     /* 2227818 */ GIM_Reject,
     /* 2227819 */ // Label 29659: @2227819
     /* 2227819 */ GIM_Try, /*On fail goto*//*Label 29702*/ GIMT_Encode4(2227933),
     /* 2227824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2227827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2227830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227842 */   GIM_Try, /*On fail goto*//*Label 29703*/ GIMT_Encode4(2227887), // Rule ID 59296 //
     /* 2227847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227850 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2227853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2227867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227886 */     // GIR_Coverage, 59296,
     /* 2227886 */     GIR_EraseRootFromParent_Done,
     /* 2227887 */   // Label 29703: @2227887
     /* 2227887 */   GIM_Try, /*On fail goto*//*Label 29704*/ GIMT_Encode4(2227932), // Rule ID 59297 //
     /* 2227892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227895 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2227898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2227912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2227927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227931 */     // GIR_Coverage, 59297,
     /* 2227931 */     GIR_EraseRootFromParent_Done,
     /* 2227932 */   // Label 29704: @2227932
     /* 2227932 */   GIM_Reject,
     /* 2227933 */ // Label 29702: @2227933
     /* 2227933 */ GIM_Reject,
     /* 2227934 */ // Label 29660: @2227934
     /* 2227934 */ GIM_Try, /*On fail goto*//*Label 29705*/ GIMT_Encode4(2228048),
     /* 2227939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2227942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2227945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2227957 */   GIM_Try, /*On fail goto*//*Label 29706*/ GIMT_Encode4(2228002), // Rule ID 59340 //
     /* 2227962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2227965 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2227968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2227982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2227997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228001 */     // GIR_Coverage, 59340,
     /* 2228001 */     GIR_EraseRootFromParent_Done,
     /* 2228002 */   // Label 29706: @2228002
     /* 2228002 */   GIM_Try, /*On fail goto*//*Label 29707*/ GIMT_Encode4(2228047), // Rule ID 59341 //
     /* 2228007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228010 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2228013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2228027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228046 */     // GIR_Coverage, 59341,
     /* 2228046 */     GIR_EraseRootFromParent_Done,
     /* 2228047 */   // Label 29707: @2228047
     /* 2228047 */   GIM_Reject,
     /* 2228048 */ // Label 29705: @2228048
     /* 2228048 */ GIM_Reject,
     /* 2228049 */ // Label 29661: @2228049
     /* 2228049 */ GIM_Try, /*On fail goto*//*Label 29708*/ GIMT_Encode4(2228163),
     /* 2228054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2228057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2228060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228072 */   GIM_Try, /*On fail goto*//*Label 29709*/ GIMT_Encode4(2228117), // Rule ID 59272 //
     /* 2228077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228080 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2228097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228116 */     // GIR_Coverage, 59272,
     /* 2228116 */     GIR_EraseRootFromParent_Done,
     /* 2228117 */   // Label 29709: @2228117
     /* 2228117 */   GIM_Try, /*On fail goto*//*Label 29710*/ GIMT_Encode4(2228162), // Rule ID 59273 //
     /* 2228122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228125 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2228142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228161 */     // GIR_Coverage, 59273,
     /* 2228161 */     GIR_EraseRootFromParent_Done,
     /* 2228162 */   // Label 29710: @2228162
     /* 2228162 */   GIM_Reject,
     /* 2228163 */ // Label 29708: @2228163
     /* 2228163 */ GIM_Reject,
     /* 2228164 */ // Label 29662: @2228164
     /* 2228164 */ GIM_Try, /*On fail goto*//*Label 29711*/ GIMT_Encode4(2228278),
     /* 2228169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2228172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2228175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228187 */   GIM_Try, /*On fail goto*//*Label 29712*/ GIMT_Encode4(2228232), // Rule ID 59292 //
     /* 2228192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228195 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2228198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2228212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228231 */     // GIR_Coverage, 59292,
     /* 2228231 */     GIR_EraseRootFromParent_Done,
     /* 2228232 */   // Label 29712: @2228232
     /* 2228232 */   GIM_Try, /*On fail goto*//*Label 29713*/ GIMT_Encode4(2228277), // Rule ID 59293 //
     /* 2228237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228240 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2228243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2228257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228276 */     // GIR_Coverage, 59293,
     /* 2228276 */     GIR_EraseRootFromParent_Done,
     /* 2228277 */   // Label 29713: @2228277
     /* 2228277 */   GIM_Reject,
     /* 2228278 */ // Label 29711: @2228278
     /* 2228278 */ GIM_Reject,
     /* 2228279 */ // Label 29663: @2228279
     /* 2228279 */ GIM_Try, /*On fail goto*//*Label 29714*/ GIMT_Encode4(2228393),
     /* 2228284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2228287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2228290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228302 */   GIM_Try, /*On fail goto*//*Label 29715*/ GIMT_Encode4(2228347), // Rule ID 59328 //
     /* 2228307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228310 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2228313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2228327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228346 */     // GIR_Coverage, 59328,
     /* 2228346 */     GIR_EraseRootFromParent_Done,
     /* 2228347 */   // Label 29715: @2228347
     /* 2228347 */   GIM_Try, /*On fail goto*//*Label 29716*/ GIMT_Encode4(2228392), // Rule ID 59329 //
     /* 2228352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228355 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2228358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2228372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228391 */     // GIR_Coverage, 59329,
     /* 2228391 */     GIR_EraseRootFromParent_Done,
     /* 2228392 */   // Label 29716: @2228392
     /* 2228392 */   GIM_Reject,
     /* 2228393 */ // Label 29714: @2228393
     /* 2228393 */ GIM_Reject,
     /* 2228394 */ // Label 29664: @2228394
     /* 2228394 */ GIM_Try, /*On fail goto*//*Label 29717*/ GIMT_Encode4(2228508),
     /* 2228399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2228402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2228405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228417 */   GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2228462), // Rule ID 59344 //
     /* 2228422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228425 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2228428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2228442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228461 */     // GIR_Coverage, 59344,
     /* 2228461 */     GIR_EraseRootFromParent_Done,
     /* 2228462 */   // Label 29718: @2228462
     /* 2228462 */   GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2228507), // Rule ID 59345 //
     /* 2228467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228470 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2228473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2228487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228506 */     // GIR_Coverage, 59345,
     /* 2228506 */     GIR_EraseRootFromParent_Done,
     /* 2228507 */   // Label 29719: @2228507
     /* 2228507 */   GIM_Reject,
     /* 2228508 */ // Label 29717: @2228508
     /* 2228508 */ GIM_Reject,
     /* 2228509 */ // Label 29665: @2228509
     /* 2228509 */ GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2228623),
     /* 2228514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2228517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2228520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228532 */   GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2228577), // Rule ID 59288 //
     /* 2228537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228540 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2228543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2228557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228576 */     // GIR_Coverage, 59288,
     /* 2228576 */     GIR_EraseRootFromParent_Done,
     /* 2228577 */   // Label 29721: @2228577
     /* 2228577 */   GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2228622), // Rule ID 59289 //
     /* 2228582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228585 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2228588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2228602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228621 */     // GIR_Coverage, 59289,
     /* 2228621 */     GIR_EraseRootFromParent_Done,
     /* 2228622 */   // Label 29722: @2228622
     /* 2228622 */   GIM_Reject,
     /* 2228623 */ // Label 29720: @2228623
     /* 2228623 */ GIM_Reject,
     /* 2228624 */ // Label 29666: @2228624
     /* 2228624 */ GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2228738),
     /* 2228629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2228632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2228635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228647 */   GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2228692), // Rule ID 59316 //
     /* 2228652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228655 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2228672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228691 */     // GIR_Coverage, 59316,
     /* 2228691 */     GIR_EraseRootFromParent_Done,
     /* 2228692 */   // Label 29724: @2228692
     /* 2228692 */   GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2228737), // Rule ID 59317 //
     /* 2228697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228700 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2228703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2228717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228736 */     // GIR_Coverage, 59317,
     /* 2228736 */     GIR_EraseRootFromParent_Done,
     /* 2228737 */   // Label 29725: @2228737
     /* 2228737 */   GIM_Reject,
     /* 2228738 */ // Label 29723: @2228738
     /* 2228738 */ GIM_Reject,
     /* 2228739 */ // Label 29667: @2228739
     /* 2228739 */ GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2228853),
     /* 2228744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2228747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2228750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2228762 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2228807), // Rule ID 59332 //
     /* 2228767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228770 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2228787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228806 */     // GIR_Coverage, 59332,
     /* 2228806 */     GIR_EraseRootFromParent_Done,
     /* 2228807 */   // Label 29727: @2228807
     /* 2228807 */   GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2228852), // Rule ID 59333 //
     /* 2228812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228815 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2228818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2228832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228851 */     // GIR_Coverage, 59333,
     /* 2228851 */     GIR_EraseRootFromParent_Done,
     /* 2228852 */   // Label 29728: @2228852
     /* 2228852 */   GIM_Reject,
     /* 2228853 */ // Label 29726: @2228853
     /* 2228853 */ GIM_Reject,
     /* 2228854 */ // Label 29668: @2228854
     /* 2228854 */ GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2228968),
     /* 2228859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2228862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2228865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2228869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2228873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2228877 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2228922), // Rule ID 59348 //
     /* 2228882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228885 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2228888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2228902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228921 */     // GIR_Coverage, 59348,
     /* 2228921 */     GIR_EraseRootFromParent_Done,
     /* 2228922 */   // Label 29730: @2228922
     /* 2228922 */   GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2228967), // Rule ID 59349 //
     /* 2228927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228930 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2228933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2228947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228966 */     // GIR_Coverage, 59349,
     /* 2228966 */     GIR_EraseRootFromParent_Done,
     /* 2228967 */   // Label 29731: @2228967
     /* 2228967 */   GIM_Reject,
     /* 2228968 */ // Label 29729: @2228968
     /* 2228968 */ GIM_Reject,
     /* 2228969 */ // Label 29669: @2228969
     /* 2228969 */ GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2229083),
     /* 2228974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2228977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2228980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228992 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2229037), // Rule ID 59304 //
     /* 2228997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229000 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2229017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229036 */     // GIR_Coverage, 59304,
     /* 2229036 */     GIR_EraseRootFromParent_Done,
     /* 2229037 */   // Label 29733: @2229037
     /* 2229037 */   GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2229082), // Rule ID 59305 //
     /* 2229042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229045 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2229062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229081 */     // GIR_Coverage, 59305,
     /* 2229081 */     GIR_EraseRootFromParent_Done,
     /* 2229082 */   // Label 29734: @2229082
     /* 2229082 */   GIM_Reject,
     /* 2229083 */ // Label 29732: @2229083
     /* 2229083 */ GIM_Reject,
     /* 2229084 */ // Label 29670: @2229084
     /* 2229084 */ GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2229198),
     /* 2229089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2229092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2229095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229107 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2229152), // Rule ID 59320 //
     /* 2229112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229115 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2229132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229151 */     // GIR_Coverage, 59320,
     /* 2229151 */     GIR_EraseRootFromParent_Done,
     /* 2229152 */   // Label 29736: @2229152
     /* 2229152 */   GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2229197), // Rule ID 59321 //
     /* 2229157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229160 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2229177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229196 */     // GIR_Coverage, 59321,
     /* 2229196 */     GIR_EraseRootFromParent_Done,
     /* 2229197 */   // Label 29737: @2229197
     /* 2229197 */   GIM_Reject,
     /* 2229198 */ // Label 29735: @2229198
     /* 2229198 */ GIM_Reject,
     /* 2229199 */ // Label 29671: @2229199
     /* 2229199 */ GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2229313),
     /* 2229204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2229207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2229210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229222 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2229267), // Rule ID 59336 //
     /* 2229227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229230 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2229233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229266 */     // GIR_Coverage, 59336,
     /* 2229266 */     GIR_EraseRootFromParent_Done,
     /* 2229267 */   // Label 29739: @2229267
     /* 2229267 */   GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2229312), // Rule ID 59337 //
     /* 2229272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229275 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2229278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229311 */     // GIR_Coverage, 59337,
     /* 2229311 */     GIR_EraseRootFromParent_Done,
     /* 2229312 */   // Label 29740: @2229312
     /* 2229312 */   GIM_Reject,
     /* 2229313 */ // Label 29738: @2229313
     /* 2229313 */ GIM_Reject,
     /* 2229314 */ // Label 29672: @2229314
     /* 2229314 */ GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2229428),
     /* 2229319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2229322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2229325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229337 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2229382), // Rule ID 59308 //
     /* 2229342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229345 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2229348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2229362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229381 */     // GIR_Coverage, 59308,
     /* 2229381 */     GIR_EraseRootFromParent_Done,
     /* 2229382 */   // Label 29742: @2229382
     /* 2229382 */   GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2229427), // Rule ID 59309 //
     /* 2229387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229390 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2229393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2229407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229426 */     // GIR_Coverage, 59309,
     /* 2229426 */     GIR_EraseRootFromParent_Done,
     /* 2229427 */   // Label 29743: @2229427
     /* 2229427 */   GIM_Reject,
     /* 2229428 */ // Label 29741: @2229428
     /* 2229428 */ GIM_Reject,
     /* 2229429 */ // Label 29673: @2229429
     /* 2229429 */ GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2229543),
     /* 2229434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2229437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2229440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229452 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2229497), // Rule ID 59324 //
     /* 2229457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229460 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2229463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229496 */     // GIR_Coverage, 59324,
     /* 2229496 */     GIR_EraseRootFromParent_Done,
     /* 2229497 */   // Label 29745: @2229497
     /* 2229497 */   GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2229542), // Rule ID 59325 //
     /* 2229502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229505 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2229508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229541 */     // GIR_Coverage, 59325,
     /* 2229541 */     GIR_EraseRootFromParent_Done,
     /* 2229542 */   // Label 29746: @2229542
     /* 2229542 */   GIM_Reject,
     /* 2229543 */ // Label 29744: @2229543
     /* 2229543 */ GIM_Reject,
     /* 2229544 */ // Label 29674: @2229544
     /* 2229544 */ GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2229658),
     /* 2229549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2229552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2229555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229567 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2229612), // Rule ID 59312 //
     /* 2229572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229575 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2229578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229611 */     // GIR_Coverage, 59312,
     /* 2229611 */     GIR_EraseRootFromParent_Done,
     /* 2229612 */   // Label 29748: @2229612
     /* 2229612 */   GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2229657), // Rule ID 59313 //
     /* 2229617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229620 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2229623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2229637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229656 */     // GIR_Coverage, 59313,
     /* 2229656 */     GIR_EraseRootFromParent_Done,
     /* 2229657 */   // Label 29749: @2229657
     /* 2229657 */   GIM_Reject,
     /* 2229658 */ // Label 29747: @2229658
     /* 2229658 */ GIM_Reject,
     /* 2229659 */ // Label 29675: @2229659
     /* 2229659 */ GIM_Reject,
     /* 2229660 */ // Label 48: @2229660
     /* 2229660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29759*/ GIMT_Encode4(2256322),
     /* 2229671 */ /*GILLT_s32*//*Label 29750*/ GIMT_Encode4(2229791),
     /* 2229675 */ /*GILLT_s64*//*Label 29751*/ GIMT_Encode4(2232585),
     /* 2229679 */ /*GILLT_nxv1s1*//*Label 29752*/ GIMT_Encode4(2235379), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229699 */ /*GILLT_nxv2s1*//*Label 29753*/ GIMT_Encode4(2239220), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229719 */ /*GILLT_nxv4s1*//*Label 29754*/ GIMT_Encode4(2243061), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229739 */ /*GILLT_nxv8s1*//*Label 29755*/ GIMT_Encode4(2246902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229759 */ /*GILLT_nxv16s1*//*Label 29756*/ GIMT_Encode4(2250743), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229775 */ /*GILLT_nxv32s1*//*Label 29757*/ GIMT_Encode4(2253624), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2229787 */ /*GILLT_nxv64s1*//*Label 29758*/ GIMT_Encode4(2255545),
     /* 2229791 */ // Label 29750: @2229791
     /* 2229791 */ GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2229834), // Rule ID 159 //
     /* 2229796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2229799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2229802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2229805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229809 */   // MIs[0] Operand 1
     /* 2229809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2229814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229818 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2229822 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2229822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229827 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229833 */   // GIR_Coverage, 159,
     /* 2229833 */   GIR_EraseRootFromParent_Done,
     /* 2229834 */ // Label 29760: @2229834
     /* 2229834 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2229877), // Rule ID 65020 //
     /* 2229839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2229842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2229845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2229848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229852 */   // MIs[0] Operand 1
     /* 2229852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2229857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229861 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2229865 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2229865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229876 */   // GIR_Coverage, 65020,
     /* 2229876 */   GIR_EraseRootFromParent_Done,
     /* 2229877 */ // Label 29761: @2229877
     /* 2229877 */ GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2229923), // Rule ID 65026 //
     /* 2229882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2229885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2229888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2229891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229895 */   // MIs[0] Operand 1
     /* 2229895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2229900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229904 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2229908 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2229908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2229911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229913 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2229919 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229922 */   // GIR_Coverage, 65026,
     /* 2229922 */   GIR_EraseRootFromParent_Done,
     /* 2229923 */ // Label 29762: @2229923
     /* 2229923 */ GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2229966), // Rule ID 65056 //
     /* 2229928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2229931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2229934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2229937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229941 */   // MIs[0] Operand 1
     /* 2229941 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2229946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229950 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2229954 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2229954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229965 */   // GIR_Coverage, 65056,
     /* 2229965 */   GIR_EraseRootFromParent_Done,
     /* 2229966 */ // Label 29763: @2229966
     /* 2229966 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2230012), // Rule ID 65062 //
     /* 2229971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2229974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2229977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2229980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229984 */   // MIs[0] Operand 1
     /* 2229984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2229989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229993 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2229997 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2229997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230002 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2230008 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230011 */   // GIR_Coverage, 65062,
     /* 2230011 */   GIR_EraseRootFromParent_Done,
     /* 2230012 */ // Label 29764: @2230012
     /* 2230012 */ GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2230065), // Rule ID 149 //
     /* 2230017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230030 */   // MIs[0] Operand 1
     /* 2230030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2230035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230047 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230051 */   // MIs[1] Operand 1
     /* 2230051 */   // No operand predicates
     /* 2230051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230053 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2230053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2230056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230060 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230064 */   // GIR_Coverage, 149,
     /* 2230064 */   GIR_EraseRootFromParent_Done,
     /* 2230065 */ // Label 29765: @2230065
     /* 2230065 */ GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2230118), // Rule ID 153 //
     /* 2230070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230083 */   // MIs[0] Operand 1
     /* 2230083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2230088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230092 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230100 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230104 */   // MIs[1] Operand 1
     /* 2230104 */   // No operand predicates
     /* 2230104 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230106 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2230106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230111 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230113 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230117 */   // GIR_Coverage, 153,
     /* 2230117 */   GIR_EraseRootFromParent_Done,
     /* 2230118 */ // Label 29766: @2230118
     /* 2230118 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2230171), // Rule ID 65012 //
     /* 2230123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230136 */   // MIs[0] Operand 1
     /* 2230136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2230141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230153 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230157 */   // MIs[1] Operand 1
     /* 2230157 */   // No operand predicates
     /* 2230157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230159 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2230159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230166 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2230169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230170 */   // GIR_Coverage, 65012,
     /* 2230170 */   GIR_EraseRootFromParent_Done,
     /* 2230171 */ // Label 29767: @2230171
     /* 2230171 */ GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2230224), // Rule ID 65016 //
     /* 2230176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230189 */   // MIs[0] Operand 1
     /* 2230189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2230194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230206 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230210 */   // MIs[1] Operand 1
     /* 2230210 */   // No operand predicates
     /* 2230210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230212 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2230212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2230215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230217 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230219 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2230222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230223 */   // GIR_Coverage, 65016,
     /* 2230223 */   GIR_EraseRootFromParent_Done,
     /* 2230224 */ // Label 29768: @2230224
     /* 2230224 */ GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2230301), // Rule ID 65022 //
     /* 2230229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230242 */   // MIs[0] Operand 1
     /* 2230242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2230247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230259 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2230263 */   // MIs[1] Operand 1
     /* 2230263 */   // No operand predicates
     /* 2230263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230265 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2230265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2230272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230277 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230281 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2230286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230300 */   // GIR_Coverage, 65022,
     /* 2230300 */   GIR_EraseRootFromParent_Done,
     /* 2230301 */ // Label 29769: @2230301
     /* 2230301 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2230381), // Rule ID 65028 //
     /* 2230306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230319 */   // MIs[0] Operand 1
     /* 2230319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2230324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230336 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2230340 */   // MIs[1] Operand 1
     /* 2230340 */   // No operand predicates
     /* 2230340 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230342 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2230342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2230349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230358 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2230363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230370 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2230376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230380 */   // GIR_Coverage, 65028,
     /* 2230380 */   GIR_EraseRootFromParent_Done,
     /* 2230381 */ // Label 29770: @2230381
     /* 2230381 */ GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2230458), // Rule ID 65032 //
     /* 2230386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230399 */   // MIs[0] Operand 1
     /* 2230399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2230404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230416 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2230420 */   // MIs[1] Operand 1
     /* 2230420 */   // No operand predicates
     /* 2230420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230422 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2230422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230438 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2230443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230457 */   // GIR_Coverage, 65032,
     /* 2230457 */   GIR_EraseRootFromParent_Done,
     /* 2230458 */ // Label 29771: @2230458
     /* 2230458 */ GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2230535), // Rule ID 65036 //
     /* 2230463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230476 */   // MIs[0] Operand 1
     /* 2230476 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2230481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230485 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230489 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230493 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2230497 */   // MIs[1] Operand 1
     /* 2230497 */   // No operand predicates
     /* 2230497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230499 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2230499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2230506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230511 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230515 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2230520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230534 */   // GIR_Coverage, 65036,
     /* 2230534 */   GIR_EraseRootFromParent_Done,
     /* 2230535 */ // Label 29772: @2230535
     /* 2230535 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2230610), // Rule ID 65040 //
     /* 2230540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230553 */   // MIs[0] Operand 1
     /* 2230553 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2230558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230570 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230574 */   // MIs[1] Operand 1
     /* 2230574 */   // No operand predicates
     /* 2230574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230576 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2230576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230592 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2230595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230609 */   // GIR_Coverage, 65040,
     /* 2230609 */   GIR_EraseRootFromParent_Done,
     /* 2230610 */ // Label 29773: @2230610
     /* 2230610 */ GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2230685), // Rule ID 65044 //
     /* 2230615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230628 */   // MIs[0] Operand 1
     /* 2230628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2230633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230645 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2230649 */   // MIs[1] Operand 1
     /* 2230649 */   // No operand predicates
     /* 2230649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230651 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2230651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2230658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230663 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230667 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2230670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230684 */   // GIR_Coverage, 65044,
     /* 2230684 */   GIR_EraseRootFromParent_Done,
     /* 2230685 */ // Label 29774: @2230685
     /* 2230685 */ GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2230740), // Rule ID 65048 //
     /* 2230690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230703 */   // MIs[0] Operand 1
     /* 2230703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2230708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230720 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2230724 */   // MIs[1] Operand 1
     /* 2230724 */   // No operand predicates
     /* 2230724 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230726 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2230726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230731 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230733 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2230738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230739 */   // GIR_Coverage, 65048,
     /* 2230739 */   GIR_EraseRootFromParent_Done,
     /* 2230740 */ // Label 29775: @2230740
     /* 2230740 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2230795), // Rule ID 65052 //
     /* 2230745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2230751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230758 */   // MIs[0] Operand 1
     /* 2230758 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2230763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230775 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2230779 */   // MIs[1] Operand 1
     /* 2230779 */   // No operand predicates
     /* 2230779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230781 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2230781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2230784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230788 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2230793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230794 */   // GIR_Coverage, 65052,
     /* 2230794 */   GIR_EraseRootFromParent_Done,
     /* 2230795 */ // Label 29776: @2230795
     /* 2230795 */ GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2230872), // Rule ID 65058 //
     /* 2230800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230813 */   // MIs[0] Operand 1
     /* 2230813 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2230818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230830 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2230834 */   // MIs[1] Operand 1
     /* 2230834 */   // No operand predicates
     /* 2230834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230836 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2230836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2230843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230848 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230852 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2230857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230871 */   // GIR_Coverage, 65058,
     /* 2230871 */   GIR_EraseRootFromParent_Done,
     /* 2230872 */ // Label 29777: @2230872
     /* 2230872 */ GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2230952), // Rule ID 65064 //
     /* 2230877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230890 */   // MIs[0] Operand 1
     /* 2230890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2230895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230907 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2230911 */   // MIs[1] Operand 1
     /* 2230911 */   // No operand predicates
     /* 2230911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230913 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2230913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2230920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230929 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2230934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230941 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2230947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230951 */   // GIR_Coverage, 65064,
     /* 2230951 */   GIR_EraseRootFromParent_Done,
     /* 2230952 */ // Label 29778: @2230952
     /* 2230952 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2231029), // Rule ID 65068 //
     /* 2230957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2230966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230970 */   // MIs[0] Operand 1
     /* 2230970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2230975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2230983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230987 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2230991 */   // MIs[1] Operand 1
     /* 2230991 */   // No operand predicates
     /* 2230991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230993 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2230993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2231000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231005 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231009 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2231014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231028 */   // GIR_Coverage, 65068,
     /* 2231028 */   GIR_EraseRootFromParent_Done,
     /* 2231029 */ // Label 29779: @2231029
     /* 2231029 */ GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2231106), // Rule ID 65072 //
     /* 2231034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231047 */   // MIs[0] Operand 1
     /* 2231047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2231052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2231060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231064 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2231068 */   // MIs[1] Operand 1
     /* 2231068 */   // No operand predicates
     /* 2231068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231070 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2231070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2231077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231086 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2231091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231105 */   // GIR_Coverage, 65072,
     /* 2231105 */   GIR_EraseRootFromParent_Done,
     /* 2231106 */ // Label 29780: @2231106
     /* 2231106 */ GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2231181), // Rule ID 65076 //
     /* 2231111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231124 */   // MIs[0] Operand 1
     /* 2231124 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2231129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2231137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231141 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2231145 */   // MIs[1] Operand 1
     /* 2231145 */   // No operand predicates
     /* 2231145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231147 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2231147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2231154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231159 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231163 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2231166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231180 */   // GIR_Coverage, 65076,
     /* 2231180 */   GIR_EraseRootFromParent_Done,
     /* 2231181 */ // Label 29781: @2231181
     /* 2231181 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2231256), // Rule ID 65080 //
     /* 2231186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231199 */   // MIs[0] Operand 1
     /* 2231199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2231204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2231212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231216 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2231220 */   // MIs[1] Operand 1
     /* 2231220 */   // No operand predicates
     /* 2231220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231222 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2231222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2231229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231238 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2231241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231255 */   // GIR_Coverage, 65080,
     /* 2231255 */   GIR_EraseRootFromParent_Done,
     /* 2231256 */ // Label 29782: @2231256
     /* 2231256 */ GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2231311), // Rule ID 65084 //
     /* 2231261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231274 */   // MIs[0] Operand 1
     /* 2231274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2231279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2231287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231291 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2231295 */   // MIs[1] Operand 1
     /* 2231295 */   // No operand predicates
     /* 2231295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231297 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2231297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2231300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231302 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231304 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2231309 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231310 */   // GIR_Coverage, 65084,
     /* 2231310 */   GIR_EraseRootFromParent_Done,
     /* 2231311 */ // Label 29783: @2231311
     /* 2231311 */ GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2231366), // Rule ID 65088 //
     /* 2231316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231329 */   // MIs[0] Operand 1
     /* 2231329 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2231334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2231342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2231346 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2231350 */   // MIs[1] Operand 1
     /* 2231350 */   // No operand predicates
     /* 2231350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2231352 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2231352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2231355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231357 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231359 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2231364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231365 */   // GIR_Coverage, 65088,
     /* 2231365 */   GIR_EraseRootFromParent_Done,
     /* 2231366 */ // Label 29784: @2231366
     /* 2231366 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2231408), // Rule ID 64450 //
     /* 2231371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2231374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231384 */   // MIs[0] Operand 1
     /* 2231384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2231389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231397 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2231400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231404 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231407 */   // GIR_Coverage, 64450,
     /* 2231407 */   GIR_EraseRootFromParent_Done,
     /* 2231408 */ // Label 29785: @2231408
     /* 2231408 */ GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2231450), // Rule ID 64452 //
     /* 2231413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2231416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231426 */   // MIs[0] Operand 1
     /* 2231426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2231431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231439 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2231442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231449 */   // GIR_Coverage, 64452,
     /* 2231449 */   GIR_EraseRootFromParent_Done,
     /* 2231450 */ // Label 29786: @2231450
     /* 2231450 */ GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2231492), // Rule ID 147 //
     /* 2231455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231468 */   // MIs[0] Operand 1
     /* 2231468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2231473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231481 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2231484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231491 */   // GIR_Coverage, 147,
     /* 2231491 */   GIR_EraseRootFromParent_Done,
     /* 2231492 */ // Label 29787: @2231492
     /* 2231492 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2231534), // Rule ID 151 //
     /* 2231497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2231503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2231506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231510 */   // MIs[0] Operand 1
     /* 2231510 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2231515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231519 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231523 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2231526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231533 */   // GIR_Coverage, 151,
     /* 2231533 */   GIR_EraseRootFromParent_Done,
     /* 2231534 */ // Label 29788: @2231534
     /* 2231534 */ GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2231576), // Rule ID 65014 //
     /* 2231539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231552 */   // MIs[0] Operand 1
     /* 2231552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2231557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231565 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2231568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231575 */   // GIR_Coverage, 65014,
     /* 2231575 */   GIR_EraseRootFromParent_Done,
     /* 2231576 */ // Label 29789: @2231576
     /* 2231576 */ GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2231618), // Rule ID 65018 //
     /* 2231581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231594 */   // MIs[0] Operand 1
     /* 2231594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2231599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231607 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2231607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2231610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231617 */   // GIR_Coverage, 65018,
     /* 2231617 */   GIR_EraseRootFromParent_Done,
     /* 2231618 */ // Label 29790: @2231618
     /* 2231618 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2231684), // Rule ID 65024 //
     /* 2231623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231636 */   // MIs[0] Operand 1
     /* 2231636 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231649 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2231649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2231656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231665 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2231669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2231674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231683 */   // GIR_Coverage, 65024,
     /* 2231683 */   GIR_EraseRootFromParent_Done,
     /* 2231684 */ // Label 29791: @2231684
     /* 2231684 */ GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2231753), // Rule ID 65030 //
     /* 2231689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231702 */   // MIs[0] Operand 1
     /* 2231702 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231711 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231715 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2231715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2231722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231731 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2231735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2231740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231742 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2231748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231752 */   // GIR_Coverage, 65030,
     /* 2231752 */   GIR_EraseRootFromParent_Done,
     /* 2231753 */ // Label 29792: @2231753
     /* 2231753 */ GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2231795), // Rule ID 65034 //
     /* 2231758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231771 */   // MIs[0] Operand 1
     /* 2231771 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2231776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231784 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2231784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2231787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231791 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231794 */   // GIR_Coverage, 65034,
     /* 2231794 */   GIR_EraseRootFromParent_Done,
     /* 2231795 */ // Label 29793: @2231795
     /* 2231795 */ GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2231837), // Rule ID 65038 //
     /* 2231800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231813 */   // MIs[0] Operand 1
     /* 2231813 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2231818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231822 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231826 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2231826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2231829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231831 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231833 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231836 */   // GIR_Coverage, 65038,
     /* 2231836 */   GIR_EraseRootFromParent_Done,
     /* 2231837 */ // Label 29794: @2231837
     /* 2231837 */ GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2231903), // Rule ID 65042 //
     /* 2231842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231855 */   // MIs[0] Operand 1
     /* 2231855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2231860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231868 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2231868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2231875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231880 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231884 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2231888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231902 */   // GIR_Coverage, 65042,
     /* 2231902 */   GIR_EraseRootFromParent_Done,
     /* 2231903 */ // Label 29795: @2231903
     /* 2231903 */ GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2231969), // Rule ID 65046 //
     /* 2231908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231921 */   // MIs[0] Operand 1
     /* 2231921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2231926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231934 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2231934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2231941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231946 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231950 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2231954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231968 */   // GIR_Coverage, 65046,
     /* 2231968 */   GIR_EraseRootFromParent_Done,
     /* 2231969 */ // Label 29796: @2231969
     /* 2231969 */ GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2232035), // Rule ID 65050 //
     /* 2231974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2231977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2231980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2231983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231987 */   // MIs[0] Operand 1
     /* 2231987 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2231992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232000 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2232000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232012 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232016 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232033 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232034 */   // GIR_Coverage, 65050,
     /* 2232034 */   GIR_EraseRootFromParent_Done,
     /* 2232035 */ // Label 29797: @2232035
     /* 2232035 */ GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2232101), // Rule ID 65054 //
     /* 2232040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2232046 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2232049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232053 */   // MIs[0] Operand 1
     /* 2232053 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2232058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232062 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232066 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2232066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2232073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232100 */   // GIR_Coverage, 65054,
     /* 2232100 */   GIR_EraseRootFromParent_Done,
     /* 2232101 */ // Label 29798: @2232101
     /* 2232101 */ GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2232167), // Rule ID 65060 //
     /* 2232106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232119 */   // MIs[0] Operand 1
     /* 2232119 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2232124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232128 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232132 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2232132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2232139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232144 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232166 */   // GIR_Coverage, 65060,
     /* 2232166 */   GIR_EraseRootFromParent_Done,
     /* 2232167 */ // Label 29799: @2232167
     /* 2232167 */ GIM_Try, /*On fail goto*//*Label 29800*/ GIMT_Encode4(2232236), // Rule ID 65066 //
     /* 2232172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232185 */   // MIs[0] Operand 1
     /* 2232185 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2232190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232194 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232198 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2232198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2232205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232210 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232214 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232225 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2232231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232235 */   // GIR_Coverage, 65066,
     /* 2232235 */   GIR_EraseRootFromParent_Done,
     /* 2232236 */ // Label 29800: @2232236
     /* 2232236 */ GIM_Try, /*On fail goto*//*Label 29801*/ GIMT_Encode4(2232278), // Rule ID 65070 //
     /* 2232241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232254 */   // MIs[0] Operand 1
     /* 2232254 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2232259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232263 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232267 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2232267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232272 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232277 */   // GIR_Coverage, 65070,
     /* 2232277 */   GIR_EraseRootFromParent_Done,
     /* 2232278 */ // Label 29801: @2232278
     /* 2232278 */ GIM_Try, /*On fail goto*//*Label 29802*/ GIMT_Encode4(2232320), // Rule ID 65074 //
     /* 2232283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232289 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232296 */   // MIs[0] Operand 1
     /* 2232296 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232305 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232309 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2232309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2232312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232316 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232319 */   // GIR_Coverage, 65074,
     /* 2232319 */   GIR_EraseRootFromParent_Done,
     /* 2232320 */ // Label 29802: @2232320
     /* 2232320 */ GIM_Try, /*On fail goto*//*Label 29803*/ GIMT_Encode4(2232386), // Rule ID 65078 //
     /* 2232325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232338 */   // MIs[0] Operand 1
     /* 2232338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2232343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232351 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2232351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232363 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232385 */   // GIR_Coverage, 65078,
     /* 2232385 */   GIR_EraseRootFromParent_Done,
     /* 2232386 */ // Label 29803: @2232386
     /* 2232386 */ GIM_Try, /*On fail goto*//*Label 29804*/ GIMT_Encode4(2232452), // Rule ID 65082 //
     /* 2232391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232404 */   // MIs[0] Operand 1
     /* 2232404 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2232409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232417 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2232417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2232424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232450 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232451 */   // GIR_Coverage, 65082,
     /* 2232451 */   GIR_EraseRootFromParent_Done,
     /* 2232452 */ // Label 29804: @2232452
     /* 2232452 */ GIM_Try, /*On fail goto*//*Label 29805*/ GIMT_Encode4(2232518), // Rule ID 65086 //
     /* 2232457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232470 */   // MIs[0] Operand 1
     /* 2232470 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2232475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232479 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232483 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2232483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232499 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232517 */   // GIR_Coverage, 65086,
     /* 2232517 */   GIR_EraseRootFromParent_Done,
     /* 2232518 */ // Label 29805: @2232518
     /* 2232518 */ GIM_Try, /*On fail goto*//*Label 29806*/ GIMT_Encode4(2232584), // Rule ID 65090 //
     /* 2232523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2232526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2232529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2232532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232536 */   // MIs[0] Operand 1
     /* 2232536 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2232541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232545 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232549 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2232549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2232552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2232556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232561 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2232565 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2232569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2232574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232583 */   // GIR_Coverage, 65090,
     /* 2232583 */   GIR_EraseRootFromParent_Done,
     /* 2232584 */ // Label 29806: @2232584
     /* 2232584 */ GIM_Reject,
     /* 2232585 */ // Label 29751: @2232585
     /* 2232585 */ GIM_Try, /*On fail goto*//*Label 29807*/ GIMT_Encode4(2232628), // Rule ID 158 //
     /* 2232590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2232596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232603 */   // MIs[0] Operand 1
     /* 2232603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2232608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232612 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2232616 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2232616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232627 */   // GIR_Coverage, 158,
     /* 2232627 */   GIR_EraseRootFromParent_Done,
     /* 2232628 */ // Label 29807: @2232628
     /* 2232628 */ GIM_Try, /*On fail goto*//*Label 29808*/ GIMT_Encode4(2232671), // Rule ID 65019 //
     /* 2232633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2232639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2232642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232646 */   // MIs[0] Operand 1
     /* 2232646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2232651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232655 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2232659 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2232659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232670 */   // GIR_Coverage, 65019,
     /* 2232670 */   GIR_EraseRootFromParent_Done,
     /* 2232671 */ // Label 29808: @2232671
     /* 2232671 */ GIM_Try, /*On fail goto*//*Label 29809*/ GIMT_Encode4(2232717), // Rule ID 65025 //
     /* 2232676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2232682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2232685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232689 */   // MIs[0] Operand 1
     /* 2232689 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2232694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232698 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2232702 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2232702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232707 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2232713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232716 */   // GIR_Coverage, 65025,
     /* 2232716 */   GIR_EraseRootFromParent_Done,
     /* 2232717 */ // Label 29809: @2232717
     /* 2232717 */ GIM_Try, /*On fail goto*//*Label 29810*/ GIMT_Encode4(2232760), // Rule ID 65055 //
     /* 2232722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2232728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232735 */   // MIs[0] Operand 1
     /* 2232735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2232740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232744 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2232748 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2232748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232753 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2232758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232759 */   // GIR_Coverage, 65055,
     /* 2232759 */   GIR_EraseRootFromParent_Done,
     /* 2232760 */ // Label 29810: @2232760
     /* 2232760 */ GIM_Try, /*On fail goto*//*Label 29811*/ GIMT_Encode4(2232806), // Rule ID 65061 //
     /* 2232765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2232771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232778 */   // MIs[0] Operand 1
     /* 2232778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2232783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232787 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2232791 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2232791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2232794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232796 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2232802 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232804 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232805 */   // GIR_Coverage, 65061,
     /* 2232805 */   GIR_EraseRootFromParent_Done,
     /* 2232806 */ // Label 29811: @2232806
     /* 2232806 */ GIM_Try, /*On fail goto*//*Label 29812*/ GIMT_Encode4(2232859), // Rule ID 148 //
     /* 2232811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2232817 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232824 */   // MIs[0] Operand 1
     /* 2232824 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2232837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2232841 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2232845 */   // MIs[1] Operand 1
     /* 2232845 */   // No operand predicates
     /* 2232845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2232847 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2232847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2232850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232854 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2232857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232858 */   // GIR_Coverage, 148,
     /* 2232858 */   GIR_EraseRootFromParent_Done,
     /* 2232859 */ // Label 29812: @2232859
     /* 2232859 */ GIM_Try, /*On fail goto*//*Label 29813*/ GIMT_Encode4(2232912), // Rule ID 152 //
     /* 2232864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2232870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232877 */   // MIs[0] Operand 1
     /* 2232877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232886 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2232890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2232894 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2232898 */   // MIs[1] Operand 1
     /* 2232898 */   // No operand predicates
     /* 2232898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2232900 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2232900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2232910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232911 */   // GIR_Coverage, 152,
     /* 2232911 */   GIR_EraseRootFromParent_Done,
     /* 2232912 */ // Label 29813: @2232912
     /* 2232912 */ GIM_Try, /*On fail goto*//*Label 29814*/ GIMT_Encode4(2232965), // Rule ID 65011 //
     /* 2232917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2232923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232930 */   // MIs[0] Operand 1
     /* 2232930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2232943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2232947 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2232951 */   // MIs[1] Operand 1
     /* 2232951 */   // No operand predicates
     /* 2232951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2232953 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2232953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2232956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232960 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2232963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232964 */   // GIR_Coverage, 65011,
     /* 2232964 */   GIR_EraseRootFromParent_Done,
     /* 2232965 */ // Label 29814: @2232965
     /* 2232965 */ GIM_Try, /*On fail goto*//*Label 29815*/ GIMT_Encode4(2233018), // Rule ID 65015 //
     /* 2232970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2232973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2232976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2232979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232983 */   // MIs[0] Operand 1
     /* 2232983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2232992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2232996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233000 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2233004 */   // MIs[1] Operand 1
     /* 2233004 */   // No operand predicates
     /* 2233004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233006 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2233006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2233009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233011 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233013 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2233016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233017 */   // GIR_Coverage, 65015,
     /* 2233017 */   GIR_EraseRootFromParent_Done,
     /* 2233018 */ // Label 29815: @2233018
     /* 2233018 */ GIM_Try, /*On fail goto*//*Label 29816*/ GIMT_Encode4(2233095), // Rule ID 65021 //
     /* 2233023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233036 */   // MIs[0] Operand 1
     /* 2233036 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2233041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233053 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2233057 */   // MIs[1] Operand 1
     /* 2233057 */   // No operand predicates
     /* 2233057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233059 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2233059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2233066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233075 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2233080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233094 */   // GIR_Coverage, 65021,
     /* 2233094 */   GIR_EraseRootFromParent_Done,
     /* 2233095 */ // Label 29816: @2233095
     /* 2233095 */ GIM_Try, /*On fail goto*//*Label 29817*/ GIMT_Encode4(2233175), // Rule ID 65027 //
     /* 2233100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233113 */   // MIs[0] Operand 1
     /* 2233113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2233118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233130 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2233134 */   // MIs[1] Operand 1
     /* 2233134 */   // No operand predicates
     /* 2233134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233136 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2233136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2233143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233152 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2233157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2233162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233164 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2233170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233174 */   // GIR_Coverage, 65027,
     /* 2233174 */   GIR_EraseRootFromParent_Done,
     /* 2233175 */ // Label 29817: @2233175
     /* 2233175 */ GIM_Try, /*On fail goto*//*Label 29818*/ GIMT_Encode4(2233252), // Rule ID 65031 //
     /* 2233180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233193 */   // MIs[0] Operand 1
     /* 2233193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233210 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2233214 */   // MIs[1] Operand 1
     /* 2233214 */   // No operand predicates
     /* 2233214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233216 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2233216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233228 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233232 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233251 */   // GIR_Coverage, 65031,
     /* 2233251 */   GIR_EraseRootFromParent_Done,
     /* 2233252 */ // Label 29818: @2233252
     /* 2233252 */ GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2233329), // Rule ID 65035 //
     /* 2233257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233270 */   // MIs[0] Operand 1
     /* 2233270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2233275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233287 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2233291 */   // MIs[1] Operand 1
     /* 2233291 */   // No operand predicates
     /* 2233291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233293 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2233293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2233300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233309 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233328 */   // GIR_Coverage, 65035,
     /* 2233328 */   GIR_EraseRootFromParent_Done,
     /* 2233329 */ // Label 29819: @2233329
     /* 2233329 */ GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2233404), // Rule ID 65039 //
     /* 2233334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233347 */   // MIs[0] Operand 1
     /* 2233347 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2233352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233364 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2233368 */   // MIs[1] Operand 1
     /* 2233368 */   // No operand predicates
     /* 2233368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233370 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2233370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233386 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2233389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233403 */   // GIR_Coverage, 65039,
     /* 2233403 */   GIR_EraseRootFromParent_Done,
     /* 2233404 */ // Label 29820: @2233404
     /* 2233404 */ GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2233479), // Rule ID 65043 //
     /* 2233409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233422 */   // MIs[0] Operand 1
     /* 2233422 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233439 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2233443 */   // MIs[1] Operand 1
     /* 2233443 */   // No operand predicates
     /* 2233443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233445 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2233445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2233452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233457 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233461 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2233464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233478 */   // GIR_Coverage, 65043,
     /* 2233478 */   GIR_EraseRootFromParent_Done,
     /* 2233479 */ // Label 29821: @2233479
     /* 2233479 */ GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2233534), // Rule ID 65047 //
     /* 2233484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233497 */   // MIs[0] Operand 1
     /* 2233497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2233502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233514 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2233518 */   // MIs[1] Operand 1
     /* 2233518 */   // No operand predicates
     /* 2233518 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233520 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2233520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233527 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233533 */   // GIR_Coverage, 65047,
     /* 2233533 */   GIR_EraseRootFromParent_Done,
     /* 2233534 */ // Label 29822: @2233534
     /* 2233534 */ GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2233589), // Rule ID 65051 //
     /* 2233539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2233545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233552 */   // MIs[0] Operand 1
     /* 2233552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233569 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2233573 */   // MIs[1] Operand 1
     /* 2233573 */   // No operand predicates
     /* 2233573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233575 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2233575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2233578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233582 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233588 */   // GIR_Coverage, 65051,
     /* 2233588 */   GIR_EraseRootFromParent_Done,
     /* 2233589 */ // Label 29823: @2233589
     /* 2233589 */ GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2233666), // Rule ID 65057 //
     /* 2233594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233607 */   // MIs[0] Operand 1
     /* 2233607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2233612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233616 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233620 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233624 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2233628 */   // MIs[1] Operand 1
     /* 2233628 */   // No operand predicates
     /* 2233628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233630 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2233630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2233637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233646 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2233651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233664 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233665 */   // GIR_Coverage, 65057,
     /* 2233665 */   GIR_EraseRootFromParent_Done,
     /* 2233666 */ // Label 29824: @2233666
     /* 2233666 */ GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2233746), // Rule ID 65063 //
     /* 2233671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233684 */   // MIs[0] Operand 1
     /* 2233684 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2233689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233701 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2233705 */   // MIs[1] Operand 1
     /* 2233705 */   // No operand predicates
     /* 2233705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233707 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2233707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2233714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233723 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2233728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2233733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233735 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2233741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233745 */   // GIR_Coverage, 65063,
     /* 2233745 */   GIR_EraseRootFromParent_Done,
     /* 2233746 */ // Label 29825: @2233746
     /* 2233746 */ GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2233823), // Rule ID 65067 //
     /* 2233751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233764 */   // MIs[0] Operand 1
     /* 2233764 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233781 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2233785 */   // MIs[1] Operand 1
     /* 2233785 */   // No operand predicates
     /* 2233785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233787 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2233787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233803 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233822 */   // GIR_Coverage, 65067,
     /* 2233822 */   GIR_EraseRootFromParent_Done,
     /* 2233823 */ // Label 29826: @2233823
     /* 2233823 */ GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2233900), // Rule ID 65071 //
     /* 2233828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233841 */   // MIs[0] Operand 1
     /* 2233841 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2233846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233858 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2233862 */   // MIs[1] Operand 1
     /* 2233862 */   // No operand predicates
     /* 2233862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233864 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2233864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2233871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233876 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233880 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2233885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233899 */   // GIR_Coverage, 65071,
     /* 2233899 */   GIR_EraseRootFromParent_Done,
     /* 2233900 */ // Label 29827: @2233900
     /* 2233900 */ GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2233975), // Rule ID 65075 //
     /* 2233905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233918 */   // MIs[0] Operand 1
     /* 2233918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2233923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2233931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233935 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2233939 */   // MIs[1] Operand 1
     /* 2233939 */   // No operand predicates
     /* 2233939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233941 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2233941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2233944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2233948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233953 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2233957 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2233960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2233965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2233973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233974 */   // GIR_Coverage, 65075,
     /* 2233974 */   GIR_EraseRootFromParent_Done,
     /* 2233975 */ // Label 29828: @2233975
     /* 2233975 */ GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2234050), // Rule ID 65079 //
     /* 2233980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2233983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2233989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233993 */   // MIs[0] Operand 1
     /* 2233993 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2234006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234010 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2234014 */   // MIs[1] Operand 1
     /* 2234014 */   // No operand predicates
     /* 2234014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234016 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2234016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2234023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234028 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234032 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2234035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2234040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234049 */   // GIR_Coverage, 65079,
     /* 2234049 */   GIR_EraseRootFromParent_Done,
     /* 2234050 */ // Label 29829: @2234050
     /* 2234050 */ GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2234105), // Rule ID 65083 //
     /* 2234055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234068 */   // MIs[0] Operand 1
     /* 2234068 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2234081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234085 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2234089 */   // MIs[1] Operand 1
     /* 2234089 */   // No operand predicates
     /* 2234089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234091 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2234091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2234094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234096 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234098 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2234103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234104 */   // GIR_Coverage, 65083,
     /* 2234104 */   GIR_EraseRootFromParent_Done,
     /* 2234105 */ // Label 29830: @2234105
     /* 2234105 */ GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2234160), // Rule ID 65087 //
     /* 2234110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234123 */   // MIs[0] Operand 1
     /* 2234123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2234128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2234136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2234140 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2234144 */   // MIs[1] Operand 1
     /* 2234144 */   // No operand predicates
     /* 2234144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2234146 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2234146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2234149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234153 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2234158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234159 */   // GIR_Coverage, 65087,
     /* 2234159 */   GIR_EraseRootFromParent_Done,
     /* 2234160 */ // Label 29831: @2234160
     /* 2234160 */ GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2234202), // Rule ID 64449 //
     /* 2234165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2234168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234178 */   // MIs[0] Operand 1
     /* 2234178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2234183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234191 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2234194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234201 */   // GIR_Coverage, 64449,
     /* 2234201 */   GIR_EraseRootFromParent_Done,
     /* 2234202 */ // Label 29832: @2234202
     /* 2234202 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2234244), // Rule ID 64451 //
     /* 2234207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2234210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234220 */   // MIs[0] Operand 1
     /* 2234220 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234229 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234233 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2234236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234238 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234240 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234243 */   // GIR_Coverage, 64451,
     /* 2234243 */   GIR_EraseRootFromParent_Done,
     /* 2234244 */ // Label 29833: @2234244
     /* 2234244 */ GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2234286), // Rule ID 146 //
     /* 2234249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234262 */   // MIs[0] Operand 1
     /* 2234262 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2234267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234275 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2234278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234280 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234285 */   // GIR_Coverage, 146,
     /* 2234285 */   GIR_EraseRootFromParent_Done,
     /* 2234286 */ // Label 29834: @2234286
     /* 2234286 */ GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2234328), // Rule ID 150 //
     /* 2234291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234304 */   // MIs[0] Operand 1
     /* 2234304 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2234309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234317 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234327 */   // GIR_Coverage, 150,
     /* 2234327 */   GIR_EraseRootFromParent_Done,
     /* 2234328 */ // Label 29835: @2234328
     /* 2234328 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2234370), // Rule ID 65013 //
     /* 2234333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234346 */   // MIs[0] Operand 1
     /* 2234346 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2234351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234355 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234359 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234364 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234366 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234369 */   // GIR_Coverage, 65013,
     /* 2234369 */   GIR_EraseRootFromParent_Done,
     /* 2234370 */ // Label 29836: @2234370
     /* 2234370 */ GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2234412), // Rule ID 65017 //
     /* 2234375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234388 */   // MIs[0] Operand 1
     /* 2234388 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2234393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234397 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234401 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2234401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2234404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234406 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234408 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234411 */   // GIR_Coverage, 65017,
     /* 2234411 */   GIR_EraseRootFromParent_Done,
     /* 2234412 */ // Label 29837: @2234412
     /* 2234412 */ GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2234478), // Rule ID 65023 //
     /* 2234417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234430 */   // MIs[0] Operand 1
     /* 2234430 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2234435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234443 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2234443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2234450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2234468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234477 */   // GIR_Coverage, 65023,
     /* 2234477 */   GIR_EraseRootFromParent_Done,
     /* 2234478 */ // Label 29838: @2234478
     /* 2234478 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2234547), // Rule ID 65029 //
     /* 2234483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234496 */   // MIs[0] Operand 1
     /* 2234496 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2234501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234505 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234509 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2234509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2234516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234525 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234536 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2234542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234546 */   // GIR_Coverage, 65029,
     /* 2234546 */   GIR_EraseRootFromParent_Done,
     /* 2234547 */ // Label 29839: @2234547
     /* 2234547 */ GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2234589), // Rule ID 65033 //
     /* 2234552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234565 */   // MIs[0] Operand 1
     /* 2234565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2234570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234578 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2234578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234583 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234588 */   // GIR_Coverage, 65033,
     /* 2234588 */   GIR_EraseRootFromParent_Done,
     /* 2234589 */ // Label 29840: @2234589
     /* 2234589 */ GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2234631), // Rule ID 65037 //
     /* 2234594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234607 */   // MIs[0] Operand 1
     /* 2234607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2234612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234620 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2234620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2234623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234625 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234627 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234630 */   // GIR_Coverage, 65037,
     /* 2234630 */   GIR_EraseRootFromParent_Done,
     /* 2234631 */ // Label 29841: @2234631
     /* 2234631 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2234697), // Rule ID 65041 //
     /* 2234636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234649 */   // MIs[0] Operand 1
     /* 2234649 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234658 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234662 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2234662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234674 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2234687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234696 */   // GIR_Coverage, 65041,
     /* 2234696 */   GIR_EraseRootFromParent_Done,
     /* 2234697 */ // Label 29842: @2234697
     /* 2234697 */ GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2234763), // Rule ID 65045 //
     /* 2234702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234715 */   // MIs[0] Operand 1
     /* 2234715 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2234720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234724 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234728 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2234728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2234735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234740 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234744 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2234753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234762 */   // GIR_Coverage, 65045,
     /* 2234762 */   GIR_EraseRootFromParent_Done,
     /* 2234763 */ // Label 29843: @2234763
     /* 2234763 */ GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2234829), // Rule ID 65049 //
     /* 2234768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234781 */   // MIs[0] Operand 1
     /* 2234781 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234790 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234794 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2234794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2234801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234806 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2234819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234828 */   // GIR_Coverage, 65049,
     /* 2234828 */   GIR_EraseRootFromParent_Done,
     /* 2234829 */ // Label 29844: @2234829
     /* 2234829 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2234895), // Rule ID 65053 //
     /* 2234834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2234840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2234843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234847 */   // MIs[0] Operand 1
     /* 2234847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2234852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234860 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2234860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2234867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234872 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234876 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2234885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234894 */   // GIR_Coverage, 65053,
     /* 2234894 */   GIR_EraseRootFromParent_Done,
     /* 2234895 */ // Label 29845: @2234895
     /* 2234895 */ GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2234961), // Rule ID 65059 //
     /* 2234900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234913 */   // MIs[0] Operand 1
     /* 2234913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2234918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234926 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2234926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2234933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234938 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2234942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2234946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2234951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2234959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234960 */   // GIR_Coverage, 65059,
     /* 2234960 */   GIR_EraseRootFromParent_Done,
     /* 2234961 */ // Label 29846: @2234961
     /* 2234961 */ GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2235030), // Rule ID 65065 //
     /* 2234966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2234969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2234972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2234975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234979 */   // MIs[0] Operand 1
     /* 2234979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2234984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2234992 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2234992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2234995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2234999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2235008 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2235012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2235017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235019 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2235025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235029 */   // GIR_Coverage, 65065,
     /* 2235029 */   GIR_EraseRootFromParent_Done,
     /* 2235030 */ // Label 29847: @2235030
     /* 2235030 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2235072), // Rule ID 65069 //
     /* 2235035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235048 */   // MIs[0] Operand 1
     /* 2235048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2235053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235061 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2235061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2235064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235066 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235068 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235071 */   // GIR_Coverage, 65069,
     /* 2235071 */   GIR_EraseRootFromParent_Done,
     /* 2235072 */ // Label 29848: @2235072
     /* 2235072 */ GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2235114), // Rule ID 65073 //
     /* 2235077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235090 */   // MIs[0] Operand 1
     /* 2235090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2235095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235103 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2235103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2235106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235113 */   // GIR_Coverage, 65073,
     /* 2235113 */   GIR_EraseRootFromParent_Done,
     /* 2235114 */ // Label 29849: @2235114
     /* 2235114 */ GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2235180), // Rule ID 65077 //
     /* 2235119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235132 */   // MIs[0] Operand 1
     /* 2235132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2235137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235145 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2235145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2235148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2235152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235157 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2235161 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2235165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2235170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2235178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235179 */   // GIR_Coverage, 65077,
     /* 2235179 */   GIR_EraseRootFromParent_Done,
     /* 2235180 */ // Label 29850: @2235180
     /* 2235180 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2235246), // Rule ID 65081 //
     /* 2235185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235198 */   // MIs[0] Operand 1
     /* 2235198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2235203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235211 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2235211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2235214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2235218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2235227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2235231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2235236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2235244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235245 */   // GIR_Coverage, 65081,
     /* 2235245 */   GIR_EraseRootFromParent_Done,
     /* 2235246 */ // Label 29851: @2235246
     /* 2235246 */ GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2235312), // Rule ID 65085 //
     /* 2235251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235264 */   // MIs[0] Operand 1
     /* 2235264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2235269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235277 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2235277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2235280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2235284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2235293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2235297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2235302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2235310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235311 */   // GIR_Coverage, 65085,
     /* 2235311 */   GIR_EraseRootFromParent_Done,
     /* 2235312 */ // Label 29852: @2235312
     /* 2235312 */ GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2235378), // Rule ID 65089 //
     /* 2235317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2235320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2235323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2235326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235330 */   // MIs[0] Operand 1
     /* 2235330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2235335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2235343 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2235343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2235346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2235350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235355 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2235359 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2235363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2235368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2235376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235377 */   // GIR_Coverage, 65089,
     /* 2235377 */   GIR_EraseRootFromParent_Done,
     /* 2235378 */ // Label 29853: @2235378
     /* 2235378 */ GIM_Reject,
     /* 2235379 */ // Label 29752: @2235379
     /* 2235379 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2235427), // Rule ID 45770 //
     /* 2235384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235397 */   // MIs[0] Operand 1
     /* 2235397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235410 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2235413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235417 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235426 */   // GIR_Coverage, 45770,
     /* 2235426 */   GIR_EraseRootFromParent_Done,
     /* 2235427 */ // Label 29854: @2235427
     /* 2235427 */ GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2235475), // Rule ID 45771 //
     /* 2235432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235445 */   // MIs[0] Operand 1
     /* 2235445 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235458 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2235461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235465 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235474 */   // GIR_Coverage, 45771,
     /* 2235474 */   GIR_EraseRootFromParent_Done,
     /* 2235475 */ // Label 29855: @2235475
     /* 2235475 */ GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2235523), // Rule ID 45772 //
     /* 2235480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235493 */   // MIs[0] Operand 1
     /* 2235493 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2235498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235506 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2235509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235511 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2235513 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235522 */   // GIR_Coverage, 45772,
     /* 2235522 */   GIR_EraseRootFromParent_Done,
     /* 2235523 */ // Label 29856: @2235523
     /* 2235523 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2235571), // Rule ID 45773 //
     /* 2235528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235541 */   // MIs[0] Operand 1
     /* 2235541 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2235546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235554 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2235557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235559 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2235561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235570 */   // GIR_Coverage, 45773,
     /* 2235570 */   GIR_EraseRootFromParent_Done,
     /* 2235571 */ // Label 29857: @2235571
     /* 2235571 */ GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2235619), // Rule ID 48484 //
     /* 2235576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2235582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2235585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235589 */   // MIs[0] Operand 1
     /* 2235589 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235598 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235602 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2235602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2235605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235607 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235609 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235618 */   // GIR_Coverage, 48484,
     /* 2235618 */   GIR_EraseRootFromParent_Done,
     /* 2235619 */ // Label 29858: @2235619
     /* 2235619 */ GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2235667), // Rule ID 48485 //
     /* 2235624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2235630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2235633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235637 */   // MIs[0] Operand 1
     /* 2235637 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235646 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235650 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2235650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2235653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235655 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235666 */   // GIR_Coverage, 48485,
     /* 2235666 */   GIR_EraseRootFromParent_Done,
     /* 2235667 */ // Label 29859: @2235667
     /* 2235667 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2235715), // Rule ID 48488 //
     /* 2235672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2235678 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2235681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235685 */   // MIs[0] Operand 1
     /* 2235685 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235694 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235698 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2235698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2235701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235703 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235714 */   // GIR_Coverage, 48488,
     /* 2235714 */   GIR_EraseRootFromParent_Done,
     /* 2235715 */ // Label 29860: @2235715
     /* 2235715 */ GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2235763), // Rule ID 48489 //
     /* 2235720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2235726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2235729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235733 */   // MIs[0] Operand 1
     /* 2235733 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235742 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235746 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2235746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2235749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235751 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235762 */   // GIR_Coverage, 48489,
     /* 2235762 */   GIR_EraseRootFromParent_Done,
     /* 2235763 */ // Label 29861: @2235763
     /* 2235763 */ GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2235811), // Rule ID 48496 //
     /* 2235768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2235774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2235777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235781 */   // MIs[0] Operand 1
     /* 2235781 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235790 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235794 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2235794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2235797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235799 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235810 */   // GIR_Coverage, 48496,
     /* 2235810 */   GIR_EraseRootFromParent_Done,
     /* 2235811 */ // Label 29862: @2235811
     /* 2235811 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2235859), // Rule ID 48497 //
     /* 2235816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2235822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2235825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235829 */   // MIs[0] Operand 1
     /* 2235829 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235838 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235842 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2235842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2235845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235858 */   // GIR_Coverage, 48497,
     /* 2235858 */   GIR_EraseRootFromParent_Done,
     /* 2235859 */ // Label 29863: @2235859
     /* 2235859 */ GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2235907), // Rule ID 48522 //
     /* 2235864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235877 */   // MIs[0] Operand 1
     /* 2235877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235886 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235890 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2235893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235897 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235906 */   // GIR_Coverage, 48522,
     /* 2235906 */   GIR_EraseRootFromParent_Done,
     /* 2235907 */ // Label 29864: @2235907
     /* 2235907 */ GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2235955), // Rule ID 48523 //
     /* 2235912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2235918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2235921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235925 */   // MIs[0] Operand 1
     /* 2235925 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235938 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2235941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235945 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235954 */   // GIR_Coverage, 48523,
     /* 2235954 */   GIR_EraseRootFromParent_Done,
     /* 2235955 */ // Label 29865: @2235955
     /* 2235955 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2236003), // Rule ID 48528 //
     /* 2235960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2235966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2235969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235973 */   // MIs[0] Operand 1
     /* 2235973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235986 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2235986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2235989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235993 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236002 */   // GIR_Coverage, 48528,
     /* 2236002 */   GIR_EraseRootFromParent_Done,
     /* 2236003 */ // Label 29866: @2236003
     /* 2236003 */ GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2236051), // Rule ID 48529 //
     /* 2236008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2236017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236021 */   // MIs[0] Operand 1
     /* 2236021 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2236026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236030 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236034 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2236037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236039 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236041 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236050 */   // GIR_Coverage, 48529,
     /* 2236050 */   GIR_EraseRootFromParent_Done,
     /* 2236051 */ // Label 29867: @2236051
     /* 2236051 */ GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2236099), // Rule ID 48532 //
     /* 2236056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236069 */   // MIs[0] Operand 1
     /* 2236069 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2236074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236078 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236082 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2236082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2236085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236089 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236098 */   // GIR_Coverage, 48532,
     /* 2236098 */   GIR_EraseRootFromParent_Done,
     /* 2236099 */ // Label 29868: @2236099
     /* 2236099 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2236147), // Rule ID 48533 //
     /* 2236104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236117 */   // MIs[0] Operand 1
     /* 2236117 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2236122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236130 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2236130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2236133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236137 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236146 */   // GIR_Coverage, 48533,
     /* 2236146 */   GIR_EraseRootFromParent_Done,
     /* 2236147 */ // Label 29869: @2236147
     /* 2236147 */ GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2236195), // Rule ID 48540 //
     /* 2236152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236165 */   // MIs[0] Operand 1
     /* 2236165 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2236170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236178 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2236178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2236181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236183 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236185 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236194 */   // GIR_Coverage, 48540,
     /* 2236194 */   GIR_EraseRootFromParent_Done,
     /* 2236195 */ // Label 29870: @2236195
     /* 2236195 */ GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2236243), // Rule ID 48541 //
     /* 2236200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236213 */   // MIs[0] Operand 1
     /* 2236213 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2236218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236226 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2236229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236231 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236233 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236242 */   // GIR_Coverage, 48541,
     /* 2236242 */   GIR_EraseRootFromParent_Done,
     /* 2236243 */ // Label 29871: @2236243
     /* 2236243 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2236291), // Rule ID 48566 //
     /* 2236248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2236257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236261 */   // MIs[0] Operand 1
     /* 2236261 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236274 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2236277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236279 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236290 */   // GIR_Coverage, 48566,
     /* 2236290 */   GIR_EraseRootFromParent_Done,
     /* 2236291 */ // Label 29872: @2236291
     /* 2236291 */ GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2236339), // Rule ID 48567 //
     /* 2236296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2236305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236309 */   // MIs[0] Operand 1
     /* 2236309 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236318 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236322 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2236325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236338 */   // GIR_Coverage, 48567,
     /* 2236338 */   GIR_EraseRootFromParent_Done,
     /* 2236339 */ // Label 29873: @2236339
     /* 2236339 */ GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2236387), // Rule ID 48572 //
     /* 2236344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2236353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236357 */   // MIs[0] Operand 1
     /* 2236357 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236370 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2236370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236386 */   // GIR_Coverage, 48572,
     /* 2236386 */   GIR_EraseRootFromParent_Done,
     /* 2236387 */ // Label 29874: @2236387
     /* 2236387 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2236435), // Rule ID 48573 //
     /* 2236392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2236401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236405 */   // MIs[0] Operand 1
     /* 2236405 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236414 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236418 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236434 */   // GIR_Coverage, 48573,
     /* 2236434 */   GIR_EraseRootFromParent_Done,
     /* 2236435 */ // Label 29875: @2236435
     /* 2236435 */ GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2236483), // Rule ID 48576 //
     /* 2236440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236453 */   // MIs[0] Operand 1
     /* 2236453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236462 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236466 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2236466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236482 */   // GIR_Coverage, 48576,
     /* 2236482 */   GIR_EraseRootFromParent_Done,
     /* 2236483 */ // Label 29876: @2236483
     /* 2236483 */ GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2236531), // Rule ID 48577 //
     /* 2236488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236494 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236501 */   // MIs[0] Operand 1
     /* 2236501 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236514 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2236514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236519 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236521 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236530 */   // GIR_Coverage, 48577,
     /* 2236530 */   GIR_EraseRootFromParent_Done,
     /* 2236531 */ // Label 29877: @2236531
     /* 2236531 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2236579), // Rule ID 48584 //
     /* 2236536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236542 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236549 */   // MIs[0] Operand 1
     /* 2236549 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236558 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236562 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2236562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236567 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236569 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236578 */   // GIR_Coverage, 48584,
     /* 2236578 */   GIR_EraseRootFromParent_Done,
     /* 2236579 */ // Label 29878: @2236579
     /* 2236579 */ GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2236627), // Rule ID 48585 //
     /* 2236584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236590 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236597 */   // MIs[0] Operand 1
     /* 2236597 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236606 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236610 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236615 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236617 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236626 */   // GIR_Coverage, 48585,
     /* 2236626 */   GIR_EraseRootFromParent_Done,
     /* 2236627 */ // Label 29879: @2236627
     /* 2236627 */ GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2236675), // Rule ID 48614 //
     /* 2236632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2236641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236645 */   // MIs[0] Operand 1
     /* 2236645 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236654 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236658 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2236658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236663 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236665 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236674 */   // GIR_Coverage, 48614,
     /* 2236674 */   GIR_EraseRootFromParent_Done,
     /* 2236675 */ // Label 29880: @2236675
     /* 2236675 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2236723), // Rule ID 48615 //
     /* 2236680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236686 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2236689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236693 */   // MIs[0] Operand 1
     /* 2236693 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236702 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236706 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236713 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236722 */   // GIR_Coverage, 48615,
     /* 2236722 */   GIR_EraseRootFromParent_Done,
     /* 2236723 */ // Label 29881: @2236723
     /* 2236723 */ GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2236771), // Rule ID 48618 //
     /* 2236728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236741 */   // MIs[0] Operand 1
     /* 2236741 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236750 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236754 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2236754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236761 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236770 */   // GIR_Coverage, 48618,
     /* 2236770 */   GIR_EraseRootFromParent_Done,
     /* 2236771 */ // Label 29882: @2236771
     /* 2236771 */ GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2236819), // Rule ID 48619 //
     /* 2236776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2236782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2236785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236789 */   // MIs[0] Operand 1
     /* 2236789 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236798 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236802 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2236802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236809 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236818 */   // GIR_Coverage, 48619,
     /* 2236818 */   GIR_EraseRootFromParent_Done,
     /* 2236819 */ // Label 29883: @2236819
     /* 2236819 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2236867), // Rule ID 48626 //
     /* 2236824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236837 */   // MIs[0] Operand 1
     /* 2236837 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236846 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236850 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2236850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236857 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236866 */   // GIR_Coverage, 48626,
     /* 2236866 */   GIR_EraseRootFromParent_Done,
     /* 2236867 */ // Label 29884: @2236867
     /* 2236867 */ GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2236915), // Rule ID 48627 //
     /* 2236872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2236878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2236881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236885 */   // MIs[0] Operand 1
     /* 2236885 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236890 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236894 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236898 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236903 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236905 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236914 */   // GIR_Coverage, 48627,
     /* 2236914 */   GIR_EraseRootFromParent_Done,
     /* 2236915 */ // Label 29885: @2236915
     /* 2236915 */ GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2236963), // Rule ID 48652 //
     /* 2236920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2236929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236933 */   // MIs[0] Operand 1
     /* 2236933 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236946 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2236949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236951 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236953 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236961 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236962 */   // GIR_Coverage, 48652,
     /* 2236962 */   GIR_EraseRootFromParent_Done,
     /* 2236963 */ // Label 29886: @2236963
     /* 2236963 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2237011), // Rule ID 48653 //
     /* 2236968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236974 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2236977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236981 */   // MIs[0] Operand 1
     /* 2236981 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236990 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236994 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2236997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237001 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237010 */   // GIR_Coverage, 48653,
     /* 2237010 */   GIR_EraseRootFromParent_Done,
     /* 2237011 */ // Label 29887: @2237011
     /* 2237011 */ GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2237059), // Rule ID 48658 //
     /* 2237016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237029 */   // MIs[0] Operand 1
     /* 2237029 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237038 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237042 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2237042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2237045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237049 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237057 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237058 */   // GIR_Coverage, 48658,
     /* 2237058 */   GIR_EraseRootFromParent_Done,
     /* 2237059 */ // Label 29888: @2237059
     /* 2237059 */ GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2237107), // Rule ID 48659 //
     /* 2237064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237077 */   // MIs[0] Operand 1
     /* 2237077 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237086 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237090 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2237090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2237093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237095 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237097 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237106 */   // GIR_Coverage, 48659,
     /* 2237106 */   GIR_EraseRootFromParent_Done,
     /* 2237107 */ // Label 29889: @2237107
     /* 2237107 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2237155), // Rule ID 48662 //
     /* 2237112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237118 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237125 */   // MIs[0] Operand 1
     /* 2237125 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237134 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237138 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2237141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237145 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237154 */   // GIR_Coverage, 48662,
     /* 2237154 */   GIR_EraseRootFromParent_Done,
     /* 2237155 */ // Label 29890: @2237155
     /* 2237155 */ GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2237203), // Rule ID 48663 //
     /* 2237160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237166 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237173 */   // MIs[0] Operand 1
     /* 2237173 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237182 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237186 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2237189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237191 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237202 */   // GIR_Coverage, 48663,
     /* 2237202 */   GIR_EraseRootFromParent_Done,
     /* 2237203 */ // Label 29891: @2237203
     /* 2237203 */ GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2237251), // Rule ID 48670 //
     /* 2237208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2237217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237221 */   // MIs[0] Operand 1
     /* 2237221 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237230 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237234 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2237234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237239 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237241 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237249 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237250 */   // GIR_Coverage, 48670,
     /* 2237250 */   GIR_EraseRootFromParent_Done,
     /* 2237251 */ // Label 29892: @2237251
     /* 2237251 */ GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2237299), // Rule ID 48671 //
     /* 2237256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2237265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237269 */   // MIs[0] Operand 1
     /* 2237269 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2237274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237278 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237282 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2237282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237287 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237289 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237298 */   // GIR_Coverage, 48671,
     /* 2237298 */   GIR_EraseRootFromParent_Done,
     /* 2237299 */ // Label 29893: @2237299
     /* 2237299 */ GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2237347), // Rule ID 48696 //
     /* 2237304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237310 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2237313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237317 */   // MIs[0] Operand 1
     /* 2237317 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237326 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237330 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2237333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237345 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237346 */   // GIR_Coverage, 48696,
     /* 2237346 */   GIR_EraseRootFromParent_Done,
     /* 2237347 */ // Label 29894: @2237347
     /* 2237347 */ GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2237395), // Rule ID 48697 //
     /* 2237352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237358 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2237361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237365 */   // MIs[0] Operand 1
     /* 2237365 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237374 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237378 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2237381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237394 */   // GIR_Coverage, 48697,
     /* 2237394 */   GIR_EraseRootFromParent_Done,
     /* 2237395 */ // Label 29895: @2237395
     /* 2237395 */ GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2237443), // Rule ID 48702 //
     /* 2237400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237413 */   // MIs[0] Operand 1
     /* 2237413 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237426 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2237426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2237429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237442 */   // GIR_Coverage, 48702,
     /* 2237442 */   GIR_EraseRootFromParent_Done,
     /* 2237443 */ // Label 29896: @2237443
     /* 2237443 */ GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2237491), // Rule ID 48703 //
     /* 2237448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237461 */   // MIs[0] Operand 1
     /* 2237461 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237470 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237474 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2237474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2237477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237479 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237489 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237490 */   // GIR_Coverage, 48703,
     /* 2237490 */   GIR_EraseRootFromParent_Done,
     /* 2237491 */ // Label 29897: @2237491
     /* 2237491 */ GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2237539), // Rule ID 48706 //
     /* 2237496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237509 */   // MIs[0] Operand 1
     /* 2237509 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237518 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237522 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2237525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237527 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237537 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237538 */   // GIR_Coverage, 48706,
     /* 2237538 */   GIR_EraseRootFromParent_Done,
     /* 2237539 */ // Label 29898: @2237539
     /* 2237539 */ GIM_Try, /*On fail goto*//*Label 29899*/ GIMT_Encode4(2237587), // Rule ID 48707 //
     /* 2237544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237550 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237557 */   // MIs[0] Operand 1
     /* 2237557 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237566 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237570 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2237573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237575 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237586 */   // GIR_Coverage, 48707,
     /* 2237586 */   GIR_EraseRootFromParent_Done,
     /* 2237587 */ // Label 29899: @2237587
     /* 2237587 */ GIM_Try, /*On fail goto*//*Label 29900*/ GIMT_Encode4(2237635), // Rule ID 48714 //
     /* 2237592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237598 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2237601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237605 */   // MIs[0] Operand 1
     /* 2237605 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237618 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2237618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237623 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237634 */   // GIR_Coverage, 48714,
     /* 2237634 */   GIR_EraseRootFromParent_Done,
     /* 2237635 */ // Label 29900: @2237635
     /* 2237635 */ GIM_Try, /*On fail goto*//*Label 29901*/ GIMT_Encode4(2237683), // Rule ID 48715 //
     /* 2237640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2237649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237653 */   // MIs[0] Operand 1
     /* 2237653 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237662 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237666 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2237666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237671 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237682 */   // GIR_Coverage, 48715,
     /* 2237682 */   GIR_EraseRootFromParent_Done,
     /* 2237683 */ // Label 29901: @2237683
     /* 2237683 */ GIM_Try, /*On fail goto*//*Label 29902*/ GIMT_Encode4(2237731), // Rule ID 48740 //
     /* 2237688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237694 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2237697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237701 */   // MIs[0] Operand 1
     /* 2237701 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237710 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237714 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2237717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237719 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237721 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237730 */   // GIR_Coverage, 48740,
     /* 2237730 */   GIR_EraseRootFromParent_Done,
     /* 2237731 */ // Label 29902: @2237731
     /* 2237731 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2237779), // Rule ID 48741 //
     /* 2237736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2237742 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2237745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237749 */   // MIs[0] Operand 1
     /* 2237749 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237762 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2237765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237767 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237769 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237777 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237778 */   // GIR_Coverage, 48741,
     /* 2237778 */   GIR_EraseRootFromParent_Done,
     /* 2237779 */ // Label 29903: @2237779
     /* 2237779 */ GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2237827), // Rule ID 48746 //
     /* 2237784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237797 */   // MIs[0] Operand 1
     /* 2237797 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237806 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237810 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2237810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237815 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237817 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237826 */   // GIR_Coverage, 48746,
     /* 2237826 */   GIR_EraseRootFromParent_Done,
     /* 2237827 */ // Label 29904: @2237827
     /* 2237827 */ GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2237875), // Rule ID 48747 //
     /* 2237832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2237838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2237841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237845 */   // MIs[0] Operand 1
     /* 2237845 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237854 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237858 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2237858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237863 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237865 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237874 */   // GIR_Coverage, 48747,
     /* 2237874 */   GIR_EraseRootFromParent_Done,
     /* 2237875 */ // Label 29905: @2237875
     /* 2237875 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2237923), // Rule ID 48750 //
     /* 2237880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237886 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237893 */   // MIs[0] Operand 1
     /* 2237893 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237902 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237906 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237911 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237913 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237922 */   // GIR_Coverage, 48750,
     /* 2237922 */   GIR_EraseRootFromParent_Done,
     /* 2237923 */ // Label 29906: @2237923
     /* 2237923 */ GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2237971), // Rule ID 48751 //
     /* 2237928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2237937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237941 */   // MIs[0] Operand 1
     /* 2237941 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237950 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237954 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237961 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237970 */   // GIR_Coverage, 48751,
     /* 2237970 */   GIR_EraseRootFromParent_Done,
     /* 2237971 */ // Label 29907: @2237971
     /* 2237971 */ GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2238019), // Rule ID 48758 //
     /* 2237976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2237985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237989 */   // MIs[0] Operand 1
     /* 2237989 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237998 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238002 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2238002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2238005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238007 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238009 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238018 */   // GIR_Coverage, 48758,
     /* 2238018 */   GIR_EraseRootFromParent_Done,
     /* 2238019 */ // Label 29908: @2238019
     /* 2238019 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2238067), // Rule ID 48759 //
     /* 2238024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238030 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2238033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238037 */   // MIs[0] Operand 1
     /* 2238037 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2238042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238046 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238050 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2238050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2238053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238055 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238057 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238065 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238066 */   // GIR_Coverage, 48759,
     /* 2238066 */   GIR_EraseRootFromParent_Done,
     /* 2238067 */ // Label 29909: @2238067
     /* 2238067 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2238115), // Rule ID 48784 //
     /* 2238072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238078 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238085 */   // MIs[0] Operand 1
     /* 2238085 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238094 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238098 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2238101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238103 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238114 */   // GIR_Coverage, 48784,
     /* 2238114 */   GIR_EraseRootFromParent_Done,
     /* 2238115 */ // Label 29910: @2238115
     /* 2238115 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2238163), // Rule ID 48785 //
     /* 2238120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238126 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238133 */   // MIs[0] Operand 1
     /* 2238133 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238142 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238146 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2238149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238151 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238162 */   // GIR_Coverage, 48785,
     /* 2238162 */   GIR_EraseRootFromParent_Done,
     /* 2238163 */ // Label 29911: @2238163
     /* 2238163 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2238211), // Rule ID 48790 //
     /* 2238168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238181 */   // MIs[0] Operand 1
     /* 2238181 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238190 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238194 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2238197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238199 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238210 */   // GIR_Coverage, 48790,
     /* 2238210 */   GIR_EraseRootFromParent_Done,
     /* 2238211 */ // Label 29912: @2238211
     /* 2238211 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2238259), // Rule ID 48791 //
     /* 2238216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238222 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238229 */   // MIs[0] Operand 1
     /* 2238229 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238238 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238242 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2238242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2238245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238247 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238258 */   // GIR_Coverage, 48791,
     /* 2238258 */   GIR_EraseRootFromParent_Done,
     /* 2238259 */ // Label 29913: @2238259
     /* 2238259 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2238307), // Rule ID 48794 //
     /* 2238264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2238270 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2238273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238277 */   // MIs[0] Operand 1
     /* 2238277 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238286 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238290 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2238290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2238293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238295 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238306 */   // GIR_Coverage, 48794,
     /* 2238306 */   GIR_EraseRootFromParent_Done,
     /* 2238307 */ // Label 29914: @2238307
     /* 2238307 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2238355), // Rule ID 48795 //
     /* 2238312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2238318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2238321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238325 */   // MIs[0] Operand 1
     /* 2238325 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238334 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238338 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2238338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2238341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238343 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238354 */   // GIR_Coverage, 48795,
     /* 2238354 */   GIR_EraseRootFromParent_Done,
     /* 2238355 */ // Label 29915: @2238355
     /* 2238355 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2238403), // Rule ID 48802 //
     /* 2238360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238366 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2238369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238373 */   // MIs[0] Operand 1
     /* 2238373 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238382 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238386 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2238386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2238389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238391 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238401 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238402 */   // GIR_Coverage, 48802,
     /* 2238402 */   GIR_EraseRootFromParent_Done,
     /* 2238403 */ // Label 29916: @2238403
     /* 2238403 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2238451), // Rule ID 48803 //
     /* 2238408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238414 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2238417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238421 */   // MIs[0] Operand 1
     /* 2238421 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2238426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238430 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238434 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2238434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2238437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238439 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238450 */   // GIR_Coverage, 48803,
     /* 2238450 */   GIR_EraseRootFromParent_Done,
     /* 2238451 */ // Label 29917: @2238451
     /* 2238451 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2238499), // Rule ID 48828 //
     /* 2238456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238469 */   // MIs[0] Operand 1
     /* 2238469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238482 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2238485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238498 */   // GIR_Coverage, 48828,
     /* 2238498 */   GIR_EraseRootFromParent_Done,
     /* 2238499 */ // Label 29918: @2238499
     /* 2238499 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2238547), // Rule ID 48829 //
     /* 2238504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238510 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238517 */   // MIs[0] Operand 1
     /* 2238517 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238526 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238530 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2238533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238535 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238537 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238546 */   // GIR_Coverage, 48829,
     /* 2238546 */   GIR_EraseRootFromParent_Done,
     /* 2238547 */ // Label 29919: @2238547
     /* 2238547 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2238595), // Rule ID 48834 //
     /* 2238552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238565 */   // MIs[0] Operand 1
     /* 2238565 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238574 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238578 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238583 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238585 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238594 */   // GIR_Coverage, 48834,
     /* 2238594 */   GIR_EraseRootFromParent_Done,
     /* 2238595 */ // Label 29920: @2238595
     /* 2238595 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2238643), // Rule ID 48835 //
     /* 2238600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238613 */   // MIs[0] Operand 1
     /* 2238613 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238622 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238626 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2238626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238631 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238633 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238642 */   // GIR_Coverage, 48835,
     /* 2238642 */   GIR_EraseRootFromParent_Done,
     /* 2238643 */ // Label 29921: @2238643
     /* 2238643 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2238691), // Rule ID 48838 //
     /* 2238648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2238654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2238657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238661 */   // MIs[0] Operand 1
     /* 2238661 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238670 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238674 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2238674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238679 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238681 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238690 */   // GIR_Coverage, 48838,
     /* 2238690 */   GIR_EraseRootFromParent_Done,
     /* 2238691 */ // Label 29922: @2238691
     /* 2238691 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2238739), // Rule ID 48839 //
     /* 2238696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2238702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2238705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238709 */   // MIs[0] Operand 1
     /* 2238709 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238718 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238722 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2238722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238727 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238729 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238737 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238738 */   // GIR_Coverage, 48839,
     /* 2238738 */   GIR_EraseRootFromParent_Done,
     /* 2238739 */ // Label 29923: @2238739
     /* 2238739 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2238787), // Rule ID 48846 //
     /* 2238744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2238753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238757 */   // MIs[0] Operand 1
     /* 2238757 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238766 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238770 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2238770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238775 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238777 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238786 */   // GIR_Coverage, 48846,
     /* 2238786 */   GIR_EraseRootFromParent_Done,
     /* 2238787 */ // Label 29924: @2238787
     /* 2238787 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2238835), // Rule ID 48847 //
     /* 2238792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2238798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2238801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238805 */   // MIs[0] Operand 1
     /* 2238805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238814 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238818 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2238818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238825 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238834 */   // GIR_Coverage, 48847,
     /* 2238834 */   GIR_EraseRootFromParent_Done,
     /* 2238835 */ // Label 29925: @2238835
     /* 2238835 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2238883), // Rule ID 48872 //
     /* 2238840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238846 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238853 */   // MIs[0] Operand 1
     /* 2238853 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238862 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238866 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2238869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238871 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238873 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238882 */   // GIR_Coverage, 48872,
     /* 2238882 */   GIR_EraseRootFromParent_Done,
     /* 2238883 */ // Label 29926: @2238883
     /* 2238883 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2238931), // Rule ID 48873 //
     /* 2238888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2238894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2238897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238901 */   // MIs[0] Operand 1
     /* 2238901 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238910 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238914 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2238917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238919 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238921 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238930 */   // GIR_Coverage, 48873,
     /* 2238930 */   GIR_EraseRootFromParent_Done,
     /* 2238931 */ // Label 29927: @2238931
     /* 2238931 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2238979), // Rule ID 48878 //
     /* 2238936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238942 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238949 */   // MIs[0] Operand 1
     /* 2238949 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238958 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238962 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238967 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238969 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238978 */   // GIR_Coverage, 48878,
     /* 2238978 */   GIR_EraseRootFromParent_Done,
     /* 2238979 */ // Label 29928: @2238979
     /* 2238979 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2239027), // Rule ID 48879 //
     /* 2238984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2238990 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2238993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238997 */   // MIs[0] Operand 1
     /* 2238997 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2239002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239006 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239010 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2239010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2239013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239015 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239026 */   // GIR_Coverage, 48879,
     /* 2239026 */   GIR_EraseRootFromParent_Done,
     /* 2239027 */ // Label 29929: @2239027
     /* 2239027 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2239075), // Rule ID 48882 //
     /* 2239032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2239038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2239041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239045 */   // MIs[0] Operand 1
     /* 2239045 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2239050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239054 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239058 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2239058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2239061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239063 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239065 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239074 */   // GIR_Coverage, 48882,
     /* 2239074 */   GIR_EraseRootFromParent_Done,
     /* 2239075 */ // Label 29930: @2239075
     /* 2239075 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2239123), // Rule ID 48883 //
     /* 2239080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2239086 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2239089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239093 */   // MIs[0] Operand 1
     /* 2239093 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2239098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239102 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239106 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2239109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239111 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239113 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239121 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239122 */   // GIR_Coverage, 48883,
     /* 2239122 */   GIR_EraseRootFromParent_Done,
     /* 2239123 */ // Label 29931: @2239123
     /* 2239123 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2239171), // Rule ID 48890 //
     /* 2239128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2239134 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2239137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239141 */   // MIs[0] Operand 1
     /* 2239141 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2239146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239150 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239154 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2239157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239159 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239161 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239170 */   // GIR_Coverage, 48890,
     /* 2239170 */   GIR_EraseRootFromParent_Done,
     /* 2239171 */ // Label 29932: @2239171
     /* 2239171 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2239219), // Rule ID 48891 //
     /* 2239176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2239182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2239185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239189 */   // MIs[0] Operand 1
     /* 2239189 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2239194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239202 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2239205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239207 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239209 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239218 */   // GIR_Coverage, 48891,
     /* 2239218 */   GIR_EraseRootFromParent_Done,
     /* 2239219 */ // Label 29933: @2239219
     /* 2239219 */ GIM_Reject,
     /* 2239220 */ // Label 29753: @2239220
     /* 2239220 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2239268), // Rule ID 48480 //
     /* 2239225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2239231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2239234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239238 */   // MIs[0] Operand 1
     /* 2239238 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239247 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239251 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2239254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239256 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239258 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239267 */   // GIR_Coverage, 48480,
     /* 2239267 */   GIR_EraseRootFromParent_Done,
     /* 2239268 */ // Label 29934: @2239268
     /* 2239268 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2239316), // Rule ID 48481 //
     /* 2239273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2239279 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2239282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239286 */   // MIs[0] Operand 1
     /* 2239286 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239299 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2239302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239304 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239306 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239315 */   // GIR_Coverage, 48481,
     /* 2239315 */   GIR_EraseRootFromParent_Done,
     /* 2239316 */ // Label 29935: @2239316
     /* 2239316 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2239364), // Rule ID 48486 //
     /* 2239321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2239327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2239330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239334 */   // MIs[0] Operand 1
     /* 2239334 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239343 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239347 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2239347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2239350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239352 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239354 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239363 */   // GIR_Coverage, 48486,
     /* 2239363 */   GIR_EraseRootFromParent_Done,
     /* 2239364 */ // Label 29936: @2239364
     /* 2239364 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2239412), // Rule ID 48487 //
     /* 2239369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2239375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2239378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239382 */   // MIs[0] Operand 1
     /* 2239382 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239391 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239395 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2239395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2239398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239400 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239402 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239411 */   // GIR_Coverage, 48487,
     /* 2239411 */   GIR_EraseRootFromParent_Done,
     /* 2239412 */ // Label 29937: @2239412
     /* 2239412 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2239460), // Rule ID 48494 //
     /* 2239417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2239423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2239426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239430 */   // MIs[0] Operand 1
     /* 2239430 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239443 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2239443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2239446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239448 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239450 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239459 */   // GIR_Coverage, 48494,
     /* 2239459 */   GIR_EraseRootFromParent_Done,
     /* 2239460 */ // Label 29938: @2239460
     /* 2239460 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2239508), // Rule ID 48495 //
     /* 2239465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2239471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2239474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239478 */   // MIs[0] Operand 1
     /* 2239478 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239491 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2239494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239496 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239507 */   // GIR_Coverage, 48495,
     /* 2239507 */   GIR_EraseRootFromParent_Done,
     /* 2239508 */ // Label 29939: @2239508
     /* 2239508 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2239556), // Rule ID 48516 //
     /* 2239513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2239519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2239522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239526 */   // MIs[0] Operand 1
     /* 2239526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239535 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239539 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2239542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239544 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239546 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239555 */   // GIR_Coverage, 48516,
     /* 2239555 */   GIR_EraseRootFromParent_Done,
     /* 2239556 */ // Label 29940: @2239556
     /* 2239556 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2239604), // Rule ID 48517 //
     /* 2239561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2239567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2239570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239574 */   // MIs[0] Operand 1
     /* 2239574 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239583 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239587 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2239590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239592 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239603 */   // GIR_Coverage, 48517,
     /* 2239603 */   GIR_EraseRootFromParent_Done,
     /* 2239604 */ // Label 29941: @2239604
     /* 2239604 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2239652), // Rule ID 48524 //
     /* 2239609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2239615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2239618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239622 */   // MIs[0] Operand 1
     /* 2239622 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239631 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239635 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2239638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239651 */   // GIR_Coverage, 48524,
     /* 2239651 */   GIR_EraseRootFromParent_Done,
     /* 2239652 */ // Label 29942: @2239652
     /* 2239652 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2239700), // Rule ID 48525 //
     /* 2239657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2239663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2239666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239670 */   // MIs[0] Operand 1
     /* 2239670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239683 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2239686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239699 */   // GIR_Coverage, 48525,
     /* 2239699 */   GIR_EraseRootFromParent_Done,
     /* 2239700 */ // Label 29943: @2239700
     /* 2239700 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2239748), // Rule ID 48530 //
     /* 2239705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2239711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2239714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239718 */   // MIs[0] Operand 1
     /* 2239718 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239727 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239731 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2239731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2239734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239736 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239738 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239747 */   // GIR_Coverage, 48530,
     /* 2239747 */   GIR_EraseRootFromParent_Done,
     /* 2239748 */ // Label 29944: @2239748
     /* 2239748 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2239796), // Rule ID 48531 //
     /* 2239753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2239759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2239762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239766 */   // MIs[0] Operand 1
     /* 2239766 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239775 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239779 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2239779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2239782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239784 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239786 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239795 */   // GIR_Coverage, 48531,
     /* 2239795 */   GIR_EraseRootFromParent_Done,
     /* 2239796 */ // Label 29945: @2239796
     /* 2239796 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2239844), // Rule ID 48538 //
     /* 2239801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2239807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2239810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239814 */   // MIs[0] Operand 1
     /* 2239814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239827 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2239827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2239830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239832 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239834 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239843 */   // GIR_Coverage, 48538,
     /* 2239843 */   GIR_EraseRootFromParent_Done,
     /* 2239844 */ // Label 29946: @2239844
     /* 2239844 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2239892), // Rule ID 48539 //
     /* 2239849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2239855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2239858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239862 */   // MIs[0] Operand 1
     /* 2239862 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239875 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2239878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239880 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239882 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239891 */   // GIR_Coverage, 48539,
     /* 2239891 */   GIR_EraseRootFromParent_Done,
     /* 2239892 */ // Label 29947: @2239892
     /* 2239892 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2239940), // Rule ID 48560 //
     /* 2239897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2239903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2239906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239910 */   // MIs[0] Operand 1
     /* 2239910 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239919 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239923 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2239926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239930 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239938 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239939 */   // GIR_Coverage, 48560,
     /* 2239939 */   GIR_EraseRootFromParent_Done,
     /* 2239940 */ // Label 29948: @2239940
     /* 2239940 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2239988), // Rule ID 48561 //
     /* 2239945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2239951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2239954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239958 */   // MIs[0] Operand 1
     /* 2239958 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239967 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239971 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2239974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239976 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239978 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239987 */   // GIR_Coverage, 48561,
     /* 2239987 */   GIR_EraseRootFromParent_Done,
     /* 2239988 */ // Label 29949: @2239988
     /* 2239988 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2240036), // Rule ID 48568 //
     /* 2239993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2239999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240006 */   // MIs[0] Operand 1
     /* 2240006 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240015 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240019 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2240022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240026 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240034 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240035 */   // GIR_Coverage, 48568,
     /* 2240035 */   GIR_EraseRootFromParent_Done,
     /* 2240036 */ // Label 29950: @2240036
     /* 2240036 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2240084), // Rule ID 48569 //
     /* 2240041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2240047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240054 */   // MIs[0] Operand 1
     /* 2240054 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240063 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240067 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2240070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240072 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240074 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240083 */   // GIR_Coverage, 48569,
     /* 2240083 */   GIR_EraseRootFromParent_Done,
     /* 2240084 */ // Label 29951: @2240084
     /* 2240084 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2240132), // Rule ID 48574 //
     /* 2240089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240102 */   // MIs[0] Operand 1
     /* 2240102 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240111 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240115 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2240118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240120 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240122 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240131 */   // GIR_Coverage, 48574,
     /* 2240131 */   GIR_EraseRootFromParent_Done,
     /* 2240132 */ // Label 29952: @2240132
     /* 2240132 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2240180), // Rule ID 48575 //
     /* 2240137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240150 */   // MIs[0] Operand 1
     /* 2240150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240163 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2240166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240179 */   // GIR_Coverage, 48575,
     /* 2240179 */   GIR_EraseRootFromParent_Done,
     /* 2240180 */ // Label 29953: @2240180
     /* 2240180 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2240228), // Rule ID 48582 //
     /* 2240185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2240194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240198 */   // MIs[0] Operand 1
     /* 2240198 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240207 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240211 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240218 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240227 */   // GIR_Coverage, 48582,
     /* 2240227 */   GIR_EraseRootFromParent_Done,
     /* 2240228 */ // Label 29954: @2240228
     /* 2240228 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2240276), // Rule ID 48583 //
     /* 2240233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2240242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240246 */   // MIs[0] Operand 1
     /* 2240246 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240255 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240259 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2240259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240266 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240275 */   // GIR_Coverage, 48583,
     /* 2240275 */   GIR_EraseRootFromParent_Done,
     /* 2240276 */ // Label 29955: @2240276
     /* 2240276 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2240324), // Rule ID 48604 //
     /* 2240281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2240287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2240290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240294 */   // MIs[0] Operand 1
     /* 2240294 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240303 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240307 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2240307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240312 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240314 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240323 */   // GIR_Coverage, 48604,
     /* 2240323 */   GIR_EraseRootFromParent_Done,
     /* 2240324 */ // Label 29956: @2240324
     /* 2240324 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2240372), // Rule ID 48605 //
     /* 2240329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2240332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2240335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2240338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240342 */   // MIs[0] Operand 1
     /* 2240342 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2240347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240351 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240355 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2240355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240360 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240362 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240371 */   // GIR_Coverage, 48605,
     /* 2240371 */   GIR_EraseRootFromParent_Done,
     /* 2240372 */ // Label 29957: @2240372
     /* 2240372 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2240420), // Rule ID 48610 //
     /* 2240377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2240383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240390 */   // MIs[0] Operand 1
     /* 2240390 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240399 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240403 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2240406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240408 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240410 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240419 */   // GIR_Coverage, 48610,
     /* 2240419 */   GIR_EraseRootFromParent_Done,
     /* 2240420 */ // Label 29958: @2240420
     /* 2240420 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2240468), // Rule ID 48611 //
     /* 2240425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2240431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240438 */   // MIs[0] Operand 1
     /* 2240438 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240447 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240451 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2240454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240458 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240467 */   // GIR_Coverage, 48611,
     /* 2240467 */   GIR_EraseRootFromParent_Done,
     /* 2240468 */ // Label 29959: @2240468
     /* 2240468 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2240516), // Rule ID 48616 //
     /* 2240473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240486 */   // MIs[0] Operand 1
     /* 2240486 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240495 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240499 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2240502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240504 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240506 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240515 */   // GIR_Coverage, 48616,
     /* 2240515 */   GIR_EraseRootFromParent_Done,
     /* 2240516 */ // Label 29960: @2240516
     /* 2240516 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2240564), // Rule ID 48617 //
     /* 2240521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240534 */   // MIs[0] Operand 1
     /* 2240534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240547 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2240550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240554 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240562 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240563 */   // GIR_Coverage, 48617,
     /* 2240563 */   GIR_EraseRootFromParent_Done,
     /* 2240564 */ // Label 29961: @2240564
     /* 2240564 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2240612), // Rule ID 48624 //
     /* 2240569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2240578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240582 */   // MIs[0] Operand 1
     /* 2240582 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240591 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240595 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240600 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240602 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240610 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240611 */   // GIR_Coverage, 48624,
     /* 2240611 */   GIR_EraseRootFromParent_Done,
     /* 2240612 */ // Label 29962: @2240612
     /* 2240612 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2240660), // Rule ID 48625 //
     /* 2240617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2240626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240630 */   // MIs[0] Operand 1
     /* 2240630 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240639 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240643 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2240643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240648 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240659 */   // GIR_Coverage, 48625,
     /* 2240659 */   GIR_EraseRootFromParent_Done,
     /* 2240660 */ // Label 29963: @2240660
     /* 2240660 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2240708), // Rule ID 48646 //
     /* 2240665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2240671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2240674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240678 */   // MIs[0] Operand 1
     /* 2240678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240691 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2240691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240696 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240698 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240707 */   // GIR_Coverage, 48646,
     /* 2240707 */   GIR_EraseRootFromParent_Done,
     /* 2240708 */ // Label 29964: @2240708
     /* 2240708 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2240756), // Rule ID 48647 //
     /* 2240713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2240716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2240719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2240722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240726 */   // MIs[0] Operand 1
     /* 2240726 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240735 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240739 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2240739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240744 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240746 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240755 */   // GIR_Coverage, 48647,
     /* 2240755 */   GIR_EraseRootFromParent_Done,
     /* 2240756 */ // Label 29965: @2240756
     /* 2240756 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2240804), // Rule ID 48654 //
     /* 2240761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2240767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240774 */   // MIs[0] Operand 1
     /* 2240774 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240783 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240787 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2240790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240794 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240803 */   // GIR_Coverage, 48654,
     /* 2240803 */   GIR_EraseRootFromParent_Done,
     /* 2240804 */ // Label 29966: @2240804
     /* 2240804 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2240852), // Rule ID 48655 //
     /* 2240809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2240815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2240818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240822 */   // MIs[0] Operand 1
     /* 2240822 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240831 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240835 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2240838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240840 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240842 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240850 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240851 */   // GIR_Coverage, 48655,
     /* 2240851 */   GIR_EraseRootFromParent_Done,
     /* 2240852 */ // Label 29967: @2240852
     /* 2240852 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2240900), // Rule ID 48660 //
     /* 2240857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240863 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240870 */   // MIs[0] Operand 1
     /* 2240870 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240879 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240883 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240888 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240890 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240899 */   // GIR_Coverage, 48660,
     /* 2240899 */   GIR_EraseRootFromParent_Done,
     /* 2240900 */ // Label 29968: @2240900
     /* 2240900 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2240948), // Rule ID 48661 //
     /* 2240905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2240911 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2240914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240918 */   // MIs[0] Operand 1
     /* 2240918 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240927 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240931 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240936 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240938 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240947 */   // GIR_Coverage, 48661,
     /* 2240947 */   GIR_EraseRootFromParent_Done,
     /* 2240948 */ // Label 29969: @2240948
     /* 2240948 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2240996), // Rule ID 48668 //
     /* 2240953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2240959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2240962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240966 */   // MIs[0] Operand 1
     /* 2240966 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240975 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240979 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2240982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240984 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240986 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240995 */   // GIR_Coverage, 48668,
     /* 2240995 */   GIR_EraseRootFromParent_Done,
     /* 2240996 */ // Label 29970: @2240996
     /* 2240996 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2241044), // Rule ID 48669 //
     /* 2241001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2241010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241014 */   // MIs[0] Operand 1
     /* 2241014 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241023 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241027 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2241027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2241030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241032 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241034 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241043 */   // GIR_Coverage, 48669,
     /* 2241043 */   GIR_EraseRootFromParent_Done,
     /* 2241044 */ // Label 29971: @2241044
     /* 2241044 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2241092), // Rule ID 48690 //
     /* 2241049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241055 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241062 */   // MIs[0] Operand 1
     /* 2241062 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241071 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241075 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2241075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2241078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241080 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241082 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241091 */   // GIR_Coverage, 48690,
     /* 2241091 */   GIR_EraseRootFromParent_Done,
     /* 2241092 */ // Label 29972: @2241092
     /* 2241092 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2241140), // Rule ID 48691 //
     /* 2241097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241103 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241110 */   // MIs[0] Operand 1
     /* 2241110 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241119 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241123 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2241126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241128 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241130 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241139 */   // GIR_Coverage, 48691,
     /* 2241139 */   GIR_EraseRootFromParent_Done,
     /* 2241140 */ // Label 29973: @2241140
     /* 2241140 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2241188), // Rule ID 48698 //
     /* 2241145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241158 */   // MIs[0] Operand 1
     /* 2241158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241167 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241171 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2241174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241178 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241187 */   // GIR_Coverage, 48698,
     /* 2241187 */   GIR_EraseRootFromParent_Done,
     /* 2241188 */ // Label 29974: @2241188
     /* 2241188 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2241236), // Rule ID 48699 //
     /* 2241193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241199 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241206 */   // MIs[0] Operand 1
     /* 2241206 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241215 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241219 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2241222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241224 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241226 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241235 */   // GIR_Coverage, 48699,
     /* 2241235 */   GIR_EraseRootFromParent_Done,
     /* 2241236 */ // Label 29975: @2241236
     /* 2241236 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2241284), // Rule ID 48704 //
     /* 2241241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2241247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2241250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241254 */   // MIs[0] Operand 1
     /* 2241254 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241263 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241267 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2241267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2241270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241272 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241282 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241283 */   // GIR_Coverage, 48704,
     /* 2241283 */   GIR_EraseRootFromParent_Done,
     /* 2241284 */ // Label 29976: @2241284
     /* 2241284 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2241332), // Rule ID 48705 //
     /* 2241289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2241295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2241298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241302 */   // MIs[0] Operand 1
     /* 2241302 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241311 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241315 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2241315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2241318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241320 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241331 */   // GIR_Coverage, 48705,
     /* 2241331 */   GIR_EraseRootFromParent_Done,
     /* 2241332 */ // Label 29977: @2241332
     /* 2241332 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2241380), // Rule ID 48712 //
     /* 2241337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2241346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241350 */   // MIs[0] Operand 1
     /* 2241350 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241359 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241363 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2241363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2241366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241368 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241379 */   // GIR_Coverage, 48712,
     /* 2241379 */   GIR_EraseRootFromParent_Done,
     /* 2241380 */ // Label 29978: @2241380
     /* 2241380 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2241428), // Rule ID 48713 //
     /* 2241385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241391 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2241394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241398 */   // MIs[0] Operand 1
     /* 2241398 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241407 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241411 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2241411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2241414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241416 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241418 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241427 */   // GIR_Coverage, 48713,
     /* 2241427 */   GIR_EraseRootFromParent_Done,
     /* 2241428 */ // Label 29979: @2241428
     /* 2241428 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2241476), // Rule ID 48734 //
     /* 2241433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241446 */   // MIs[0] Operand 1
     /* 2241446 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241455 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241459 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2241459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2241462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241464 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241466 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241475 */   // GIR_Coverage, 48734,
     /* 2241475 */   GIR_EraseRootFromParent_Done,
     /* 2241476 */ // Label 29980: @2241476
     /* 2241476 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2241524), // Rule ID 48735 //
     /* 2241481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241494 */   // MIs[0] Operand 1
     /* 2241494 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241503 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241507 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2241510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241512 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241514 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241523 */   // GIR_Coverage, 48735,
     /* 2241523 */   GIR_EraseRootFromParent_Done,
     /* 2241524 */ // Label 29981: @2241524
     /* 2241524 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2241572), // Rule ID 48742 //
     /* 2241529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241542 */   // MIs[0] Operand 1
     /* 2241542 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241551 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241555 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2241558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241560 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241562 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241571 */   // GIR_Coverage, 48742,
     /* 2241571 */   GIR_EraseRootFromParent_Done,
     /* 2241572 */ // Label 29982: @2241572
     /* 2241572 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2241620), // Rule ID 48743 //
     /* 2241577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241590 */   // MIs[0] Operand 1
     /* 2241590 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241599 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241603 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2241606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241608 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241610 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241619 */   // GIR_Coverage, 48743,
     /* 2241619 */   GIR_EraseRootFromParent_Done,
     /* 2241620 */ // Label 29983: @2241620
     /* 2241620 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2241668), // Rule ID 48748 //
     /* 2241625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2241631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2241634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241638 */   // MIs[0] Operand 1
     /* 2241638 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241647 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241651 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2241651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241656 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241658 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241667 */   // GIR_Coverage, 48748,
     /* 2241667 */   GIR_EraseRootFromParent_Done,
     /* 2241668 */ // Label 29984: @2241668
     /* 2241668 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2241716), // Rule ID 48749 //
     /* 2241673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2241679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2241682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241686 */   // MIs[0] Operand 1
     /* 2241686 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241695 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241699 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2241699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241704 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241706 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241715 */   // GIR_Coverage, 48749,
     /* 2241715 */   GIR_EraseRootFromParent_Done,
     /* 2241716 */ // Label 29985: @2241716
     /* 2241716 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2241764), // Rule ID 48756 //
     /* 2241721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2241730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241734 */   // MIs[0] Operand 1
     /* 2241734 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241743 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241747 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2241747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241754 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241763 */   // GIR_Coverage, 48756,
     /* 2241763 */   GIR_EraseRootFromParent_Done,
     /* 2241764 */ // Label 29986: @2241764
     /* 2241764 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2241812), // Rule ID 48757 //
     /* 2241769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2241775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2241778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241782 */   // MIs[0] Operand 1
     /* 2241782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241795 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2241795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241800 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241811 */   // GIR_Coverage, 48757,
     /* 2241811 */   GIR_EraseRootFromParent_Done,
     /* 2241812 */ // Label 29987: @2241812
     /* 2241812 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2241860), // Rule ID 48778 //
     /* 2241817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241823 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241830 */   // MIs[0] Operand 1
     /* 2241830 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241839 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241843 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2241843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241848 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241850 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241859 */   // GIR_Coverage, 48778,
     /* 2241859 */   GIR_EraseRootFromParent_Done,
     /* 2241860 */ // Label 29988: @2241860
     /* 2241860 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2241908), // Rule ID 48779 //
     /* 2241865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2241871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2241874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241878 */   // MIs[0] Operand 1
     /* 2241878 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241887 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241891 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241896 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241898 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241907 */   // GIR_Coverage, 48779,
     /* 2241907 */   GIR_EraseRootFromParent_Done,
     /* 2241908 */ // Label 29989: @2241908
     /* 2241908 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2241956), // Rule ID 48786 //
     /* 2241913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241926 */   // MIs[0] Operand 1
     /* 2241926 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241935 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241939 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2241942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241944 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241955 */   // GIR_Coverage, 48786,
     /* 2241955 */   GIR_EraseRootFromParent_Done,
     /* 2241956 */ // Label 29990: @2241956
     /* 2241956 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2242004), // Rule ID 48787 //
     /* 2241961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2241967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2241970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241974 */   // MIs[0] Operand 1
     /* 2241974 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241987 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2241990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241992 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242003 */   // GIR_Coverage, 48787,
     /* 2242003 */   GIR_EraseRootFromParent_Done,
     /* 2242004 */ // Label 29991: @2242004
     /* 2242004 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2242052), // Rule ID 48792 //
     /* 2242009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242022 */   // MIs[0] Operand 1
     /* 2242022 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242031 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242035 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2242035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2242038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242040 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242051 */   // GIR_Coverage, 48792,
     /* 2242051 */   GIR_EraseRootFromParent_Done,
     /* 2242052 */ // Label 29992: @2242052
     /* 2242052 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2242100), // Rule ID 48793 //
     /* 2242057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242070 */   // MIs[0] Operand 1
     /* 2242070 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242083 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2242083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2242086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242088 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242099 */   // GIR_Coverage, 48793,
     /* 2242099 */   GIR_EraseRootFromParent_Done,
     /* 2242100 */ // Label 29993: @2242100
     /* 2242100 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2242148), // Rule ID 48800 //
     /* 2242105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242118 */   // MIs[0] Operand 1
     /* 2242118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242131 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2242134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242136 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242138 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242147 */   // GIR_Coverage, 48800,
     /* 2242147 */   GIR_EraseRootFromParent_Done,
     /* 2242148 */ // Label 29994: @2242148
     /* 2242148 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2242196), // Rule ID 48801 //
     /* 2242153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242166 */   // MIs[0] Operand 1
     /* 2242166 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242175 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242179 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2242182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242184 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242195 */   // GIR_Coverage, 48801,
     /* 2242195 */   GIR_EraseRootFromParent_Done,
     /* 2242196 */ // Label 29995: @2242196
     /* 2242196 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2242244), // Rule ID 48822 //
     /* 2242201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2242207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2242210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242214 */   // MIs[0] Operand 1
     /* 2242214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242223 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242227 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2242230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242232 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242243 */   // GIR_Coverage, 48822,
     /* 2242243 */   GIR_EraseRootFromParent_Done,
     /* 2242244 */ // Label 29996: @2242244
     /* 2242244 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2242292), // Rule ID 48823 //
     /* 2242249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2242255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2242258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242262 */   // MIs[0] Operand 1
     /* 2242262 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242275 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2242275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2242278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242280 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242291 */   // GIR_Coverage, 48823,
     /* 2242291 */   GIR_EraseRootFromParent_Done,
     /* 2242292 */ // Label 29997: @2242292
     /* 2242292 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2242340), // Rule ID 48830 //
     /* 2242297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2242303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2242306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242310 */   // MIs[0] Operand 1
     /* 2242310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242323 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2242326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242339 */   // GIR_Coverage, 48830,
     /* 2242339 */   GIR_EraseRootFromParent_Done,
     /* 2242340 */ // Label 29998: @2242340
     /* 2242340 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2242388), // Rule ID 48831 //
     /* 2242345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2242351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2242354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242358 */   // MIs[0] Operand 1
     /* 2242358 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242367 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242371 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2242374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242376 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242387 */   // GIR_Coverage, 48831,
     /* 2242387 */   GIR_EraseRootFromParent_Done,
     /* 2242388 */ // Label 29999: @2242388
     /* 2242388 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2242436), // Rule ID 48836 //
     /* 2242393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242406 */   // MIs[0] Operand 1
     /* 2242406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242419 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2242419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242435 */   // GIR_Coverage, 48836,
     /* 2242435 */   GIR_EraseRootFromParent_Done,
     /* 2242436 */ // Label 30000: @2242436
     /* 2242436 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2242484), // Rule ID 48837 //
     /* 2242441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242454 */   // MIs[0] Operand 1
     /* 2242454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242467 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2242467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242483 */   // GIR_Coverage, 48837,
     /* 2242483 */   GIR_EraseRootFromParent_Done,
     /* 2242484 */ // Label 30001: @2242484
     /* 2242484 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2242532), // Rule ID 48844 //
     /* 2242489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242502 */   // MIs[0] Operand 1
     /* 2242502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242515 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242531 */   // GIR_Coverage, 48844,
     /* 2242531 */   GIR_EraseRootFromParent_Done,
     /* 2242532 */ // Label 30002: @2242532
     /* 2242532 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2242580), // Rule ID 48845 //
     /* 2242537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242550 */   // MIs[0] Operand 1
     /* 2242550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242563 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242579 */   // GIR_Coverage, 48845,
     /* 2242579 */   GIR_EraseRootFromParent_Done,
     /* 2242580 */ // Label 30003: @2242580
     /* 2242580 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2242628), // Rule ID 48866 //
     /* 2242585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2242591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2242594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242598 */   // MIs[0] Operand 1
     /* 2242598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242611 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242627 */   // GIR_Coverage, 48866,
     /* 2242627 */   GIR_EraseRootFromParent_Done,
     /* 2242628 */ // Label 30004: @2242628
     /* 2242628 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2242676), // Rule ID 48867 //
     /* 2242633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2242639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2242642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242646 */   // MIs[0] Operand 1
     /* 2242646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242659 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2242659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242675 */   // GIR_Coverage, 48867,
     /* 2242675 */   GIR_EraseRootFromParent_Done,
     /* 2242676 */ // Label 30005: @2242676
     /* 2242676 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2242724), // Rule ID 48874 //
     /* 2242681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2242687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2242690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242694 */   // MIs[0] Operand 1
     /* 2242694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242707 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2242710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242712 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242723 */   // GIR_Coverage, 48874,
     /* 2242723 */   GIR_EraseRootFromParent_Done,
     /* 2242724 */ // Label 30006: @2242724
     /* 2242724 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2242772), // Rule ID 48875 //
     /* 2242729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2242735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2242738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242742 */   // MIs[0] Operand 1
     /* 2242742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242755 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2242758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242760 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242771 */   // GIR_Coverage, 48875,
     /* 2242771 */   GIR_EraseRootFromParent_Done,
     /* 2242772 */ // Label 30007: @2242772
     /* 2242772 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2242820), // Rule ID 48880 //
     /* 2242777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242790 */   // MIs[0] Operand 1
     /* 2242790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242803 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2242803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242808 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242819 */   // GIR_Coverage, 48880,
     /* 2242819 */   GIR_EraseRootFromParent_Done,
     /* 2242820 */ // Label 30008: @2242820
     /* 2242820 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2242868), // Rule ID 48881 //
     /* 2242825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2242831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2242834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242838 */   // MIs[0] Operand 1
     /* 2242838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242851 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2242851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242856 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242858 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242867 */   // GIR_Coverage, 48881,
     /* 2242867 */   GIR_EraseRootFromParent_Done,
     /* 2242868 */ // Label 30009: @2242868
     /* 2242868 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2242916), // Rule ID 48888 //
     /* 2242873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242886 */   // MIs[0] Operand 1
     /* 2242886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242899 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242904 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242906 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242915 */   // GIR_Coverage, 48888,
     /* 2242915 */   GIR_EraseRootFromParent_Done,
     /* 2242916 */ // Label 30010: @2242916
     /* 2242916 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2242964), // Rule ID 48889 //
     /* 2242921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2242927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2242930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242934 */   // MIs[0] Operand 1
     /* 2242934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242943 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242947 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242952 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242963 */   // GIR_Coverage, 48889,
     /* 2242963 */   GIR_EraseRootFromParent_Done,
     /* 2242964 */ // Label 30011: @2242964
     /* 2242964 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2243012), // Rule ID 48910 //
     /* 2242969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2242975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2242978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242982 */   // MIs[0] Operand 1
     /* 2242982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242995 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243000 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243011 */   // GIR_Coverage, 48910,
     /* 2243011 */   GIR_EraseRootFromParent_Done,
     /* 2243012 */ // Label 30012: @2243012
     /* 2243012 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2243060), // Rule ID 48911 //
     /* 2243017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2243020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2243023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2243026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243030 */   // MIs[0] Operand 1
     /* 2243030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243043 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2243043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2243046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243048 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243050 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243059 */   // GIR_Coverage, 48911,
     /* 2243059 */   GIR_EraseRootFromParent_Done,
     /* 2243060 */ // Label 30013: @2243060
     /* 2243060 */ GIM_Reject,
     /* 2243061 */ // Label 29754: @2243061
     /* 2243061 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2243109), // Rule ID 48482 //
     /* 2243066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243079 */   // MIs[0] Operand 1
     /* 2243079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243092 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2243095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243097 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243099 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243108 */   // GIR_Coverage, 48482,
     /* 2243108 */   GIR_EraseRootFromParent_Done,
     /* 2243109 */ // Label 30014: @2243109
     /* 2243109 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2243157), // Rule ID 48483 //
     /* 2243114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243127 */   // MIs[0] Operand 1
     /* 2243127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243140 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2243143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243145 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243156 */   // GIR_Coverage, 48483,
     /* 2243156 */   GIR_EraseRootFromParent_Done,
     /* 2243157 */ // Label 30015: @2243157
     /* 2243157 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2243205), // Rule ID 48492 //
     /* 2243162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243175 */   // MIs[0] Operand 1
     /* 2243175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243188 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2243191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243193 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243204 */   // GIR_Coverage, 48492,
     /* 2243204 */   GIR_EraseRootFromParent_Done,
     /* 2243205 */ // Label 30016: @2243205
     /* 2243205 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2243253), // Rule ID 48493 //
     /* 2243210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243223 */   // MIs[0] Operand 1
     /* 2243223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243236 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2243236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2243239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243241 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243252 */   // GIR_Coverage, 48493,
     /* 2243252 */   GIR_EraseRootFromParent_Done,
     /* 2243253 */ // Label 30017: @2243253
     /* 2243253 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2243301), // Rule ID 48510 //
     /* 2243258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2243264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2243267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243271 */   // MIs[0] Operand 1
     /* 2243271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243284 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2243284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2243287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243300 */   // GIR_Coverage, 48510,
     /* 2243300 */   GIR_EraseRootFromParent_Done,
     /* 2243301 */ // Label 30018: @2243301
     /* 2243301 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2243349), // Rule ID 48511 //
     /* 2243306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2243312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2243315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243319 */   // MIs[0] Operand 1
     /* 2243319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243332 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2243332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2243335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243348 */   // GIR_Coverage, 48511,
     /* 2243348 */   GIR_EraseRootFromParent_Done,
     /* 2243349 */ // Label 30019: @2243349
     /* 2243349 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2243397), // Rule ID 48518 //
     /* 2243354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2243357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2243360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2243363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243367 */   // MIs[0] Operand 1
     /* 2243367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243380 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2243380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2243383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243396 */   // GIR_Coverage, 48518,
     /* 2243396 */   GIR_EraseRootFromParent_Done,
     /* 2243397 */ // Label 30020: @2243397
     /* 2243397 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2243445), // Rule ID 48519 //
     /* 2243402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2243405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2243408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2243411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243415 */   // MIs[0] Operand 1
     /* 2243415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243428 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2243428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2243431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243444 */   // GIR_Coverage, 48519,
     /* 2243444 */   GIR_EraseRootFromParent_Done,
     /* 2243445 */ // Label 30021: @2243445
     /* 2243445 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2243493), // Rule ID 48526 //
     /* 2243450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243463 */   // MIs[0] Operand 1
     /* 2243463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243476 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2243479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243492 */   // GIR_Coverage, 48526,
     /* 2243492 */   GIR_EraseRootFromParent_Done,
     /* 2243493 */ // Label 30022: @2243493
     /* 2243493 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2243541), // Rule ID 48527 //
     /* 2243498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243511 */   // MIs[0] Operand 1
     /* 2243511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243524 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2243527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243540 */   // GIR_Coverage, 48527,
     /* 2243540 */   GIR_EraseRootFromParent_Done,
     /* 2243541 */ // Label 30023: @2243541
     /* 2243541 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2243589), // Rule ID 48536 //
     /* 2243546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243559 */   // MIs[0] Operand 1
     /* 2243559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243572 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2243575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243588 */   // GIR_Coverage, 48536,
     /* 2243588 */   GIR_EraseRootFromParent_Done,
     /* 2243589 */ // Label 30024: @2243589
     /* 2243589 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2243637), // Rule ID 48537 //
     /* 2243594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243607 */   // MIs[0] Operand 1
     /* 2243607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243620 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2243620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2243623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243636 */   // GIR_Coverage, 48537,
     /* 2243636 */   GIR_EraseRootFromParent_Done,
     /* 2243637 */ // Label 30025: @2243637
     /* 2243637 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2243685), // Rule ID 48554 //
     /* 2243642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2243648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2243651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243655 */   // MIs[0] Operand 1
     /* 2243655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243668 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2243668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2243671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243684 */   // GIR_Coverage, 48554,
     /* 2243684 */   GIR_EraseRootFromParent_Done,
     /* 2243685 */ // Label 30026: @2243685
     /* 2243685 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2243733), // Rule ID 48555 //
     /* 2243690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2243696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2243699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243703 */   // MIs[0] Operand 1
     /* 2243703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243716 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2243716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2243719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243732 */   // GIR_Coverage, 48555,
     /* 2243732 */   GIR_EraseRootFromParent_Done,
     /* 2243733 */ // Label 30027: @2243733
     /* 2243733 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2243781), // Rule ID 48562 //
     /* 2243738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2243741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2243744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2243747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243751 */   // MIs[0] Operand 1
     /* 2243751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243764 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2243764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2243767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243780 */   // GIR_Coverage, 48562,
     /* 2243780 */   GIR_EraseRootFromParent_Done,
     /* 2243781 */ // Label 30028: @2243781
     /* 2243781 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2243829), // Rule ID 48563 //
     /* 2243786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2243789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2243792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2243795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243799 */   // MIs[0] Operand 1
     /* 2243799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243812 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2243812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2243815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243828 */   // GIR_Coverage, 48563,
     /* 2243828 */   GIR_EraseRootFromParent_Done,
     /* 2243829 */ // Label 30029: @2243829
     /* 2243829 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2243877), // Rule ID 48570 //
     /* 2243834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243847 */   // MIs[0] Operand 1
     /* 2243847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243860 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2243863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243876 */   // GIR_Coverage, 48570,
     /* 2243876 */   GIR_EraseRootFromParent_Done,
     /* 2243877 */ // Label 30030: @2243877
     /* 2243877 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2243925), // Rule ID 48571 //
     /* 2243882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2243888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2243891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243895 */   // MIs[0] Operand 1
     /* 2243895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243908 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2243911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243924 */   // GIR_Coverage, 48571,
     /* 2243924 */   GIR_EraseRootFromParent_Done,
     /* 2243925 */ // Label 30031: @2243925
     /* 2243925 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2243973), // Rule ID 48580 //
     /* 2243930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243943 */   // MIs[0] Operand 1
     /* 2243943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243956 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2243959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243972 */   // GIR_Coverage, 48580,
     /* 2243972 */   GIR_EraseRootFromParent_Done,
     /* 2243973 */ // Label 30032: @2243973
     /* 2243973 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2244021), // Rule ID 48581 //
     /* 2243978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2243984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2243987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243991 */   // MIs[0] Operand 1
     /* 2243991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244004 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2244004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2244007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244020 */   // GIR_Coverage, 48581,
     /* 2244020 */   GIR_EraseRootFromParent_Done,
     /* 2244021 */ // Label 30033: @2244021
     /* 2244021 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2244069), // Rule ID 48598 //
     /* 2244026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244039 */   // MIs[0] Operand 1
     /* 2244039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244052 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2244052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2244055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244068 */   // GIR_Coverage, 48598,
     /* 2244068 */   GIR_EraseRootFromParent_Done,
     /* 2244069 */ // Label 30034: @2244069
     /* 2244069 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2244117), // Rule ID 48599 //
     /* 2244074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244087 */   // MIs[0] Operand 1
     /* 2244087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244100 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2244103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244116 */   // GIR_Coverage, 48599,
     /* 2244116 */   GIR_EraseRootFromParent_Done,
     /* 2244117 */ // Label 30035: @2244117
     /* 2244117 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2244165), // Rule ID 48606 //
     /* 2244122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244135 */   // MIs[0] Operand 1
     /* 2244135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244148 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2244151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244164 */   // GIR_Coverage, 48606,
     /* 2244164 */   GIR_EraseRootFromParent_Done,
     /* 2244165 */ // Label 30036: @2244165
     /* 2244165 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2244213), // Rule ID 48607 //
     /* 2244170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244183 */   // MIs[0] Operand 1
     /* 2244183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244196 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2244199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244212 */   // GIR_Coverage, 48607,
     /* 2244212 */   GIR_EraseRootFromParent_Done,
     /* 2244213 */ // Label 30037: @2244213
     /* 2244213 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2244261), // Rule ID 48612 //
     /* 2244218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2244224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2244227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244231 */   // MIs[0] Operand 1
     /* 2244231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244244 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2244247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244249 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244251 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244260 */   // GIR_Coverage, 48612,
     /* 2244260 */   GIR_EraseRootFromParent_Done,
     /* 2244261 */ // Label 30038: @2244261
     /* 2244261 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2244309), // Rule ID 48613 //
     /* 2244266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2244272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2244275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244279 */   // MIs[0] Operand 1
     /* 2244279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244292 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2244295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244297 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244299 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244308 */   // GIR_Coverage, 48613,
     /* 2244308 */   GIR_EraseRootFromParent_Done,
     /* 2244309 */ // Label 30039: @2244309
     /* 2244309 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2244357), // Rule ID 48622 //
     /* 2244314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2244320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2244323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244327 */   // MIs[0] Operand 1
     /* 2244327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244340 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2244340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2244343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244345 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244356 */   // GIR_Coverage, 48622,
     /* 2244356 */   GIR_EraseRootFromParent_Done,
     /* 2244357 */ // Label 30040: @2244357
     /* 2244357 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2244405), // Rule ID 48623 //
     /* 2244362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2244368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2244371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244375 */   // MIs[0] Operand 1
     /* 2244375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244388 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2244388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2244391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244393 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244404 */   // GIR_Coverage, 48623,
     /* 2244404 */   GIR_EraseRootFromParent_Done,
     /* 2244405 */ // Label 30041: @2244405
     /* 2244405 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2244453), // Rule ID 48640 //
     /* 2244410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244423 */   // MIs[0] Operand 1
     /* 2244423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244436 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2244436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2244439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244441 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244452 */   // GIR_Coverage, 48640,
     /* 2244452 */   GIR_EraseRootFromParent_Done,
     /* 2244453 */ // Label 30042: @2244453
     /* 2244453 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2244501), // Rule ID 48641 //
     /* 2244458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244471 */   // MIs[0] Operand 1
     /* 2244471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244484 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2244487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244500 */   // GIR_Coverage, 48641,
     /* 2244500 */   GIR_EraseRootFromParent_Done,
     /* 2244501 */ // Label 30043: @2244501
     /* 2244501 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2244549), // Rule ID 48648 //
     /* 2244506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244519 */   // MIs[0] Operand 1
     /* 2244519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244532 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2244535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244537 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244548 */   // GIR_Coverage, 48648,
     /* 2244548 */   GIR_EraseRootFromParent_Done,
     /* 2244549 */ // Label 30044: @2244549
     /* 2244549 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2244597), // Rule ID 48649 //
     /* 2244554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244567 */   // MIs[0] Operand 1
     /* 2244567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244580 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2244583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244585 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244596 */   // GIR_Coverage, 48649,
     /* 2244596 */   GIR_EraseRootFromParent_Done,
     /* 2244597 */ // Label 30045: @2244597
     /* 2244597 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2244645), // Rule ID 48656 //
     /* 2244602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2244608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2244611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244615 */   // MIs[0] Operand 1
     /* 2244615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244628 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2244631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244644 */   // GIR_Coverage, 48656,
     /* 2244644 */   GIR_EraseRootFromParent_Done,
     /* 2244645 */ // Label 30046: @2244645
     /* 2244645 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2244693), // Rule ID 48657 //
     /* 2244650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2244656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2244659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244663 */   // MIs[0] Operand 1
     /* 2244663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244676 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2244679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244692 */   // GIR_Coverage, 48657,
     /* 2244692 */   GIR_EraseRootFromParent_Done,
     /* 2244693 */ // Label 30047: @2244693
     /* 2244693 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2244741), // Rule ID 48666 //
     /* 2244698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2244704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2244707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244711 */   // MIs[0] Operand 1
     /* 2244711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244724 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2244724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244729 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244740 */   // GIR_Coverage, 48666,
     /* 2244740 */   GIR_EraseRootFromParent_Done,
     /* 2244741 */ // Label 30048: @2244741
     /* 2244741 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2244789), // Rule ID 48667 //
     /* 2244746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2244752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2244755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244759 */   // MIs[0] Operand 1
     /* 2244759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244772 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2244772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244777 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244788 */   // GIR_Coverage, 48667,
     /* 2244788 */   GIR_EraseRootFromParent_Done,
     /* 2244789 */ // Label 30049: @2244789
     /* 2244789 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2244837), // Rule ID 48684 //
     /* 2244794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244807 */   // MIs[0] Operand 1
     /* 2244807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244820 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2244820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244825 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244836 */   // GIR_Coverage, 48684,
     /* 2244836 */   GIR_EraseRootFromParent_Done,
     /* 2244837 */ // Label 30050: @2244837
     /* 2244837 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2244885), // Rule ID 48685 //
     /* 2244842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2244848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2244851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244855 */   // MIs[0] Operand 1
     /* 2244855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244868 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244873 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244884 */   // GIR_Coverage, 48685,
     /* 2244884 */   GIR_EraseRootFromParent_Done,
     /* 2244885 */ // Label 30051: @2244885
     /* 2244885 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2244933), // Rule ID 48692 //
     /* 2244890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244903 */   // MIs[0] Operand 1
     /* 2244903 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244916 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244921 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244932 */   // GIR_Coverage, 48692,
     /* 2244932 */   GIR_EraseRootFromParent_Done,
     /* 2244933 */ // Label 30052: @2244933
     /* 2244933 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2244981), // Rule ID 48693 //
     /* 2244938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2244944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2244947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244951 */   // MIs[0] Operand 1
     /* 2244951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244964 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244969 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244980 */   // GIR_Coverage, 48693,
     /* 2244980 */   GIR_EraseRootFromParent_Done,
     /* 2244981 */ // Label 30053: @2244981
     /* 2244981 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2245029), // Rule ID 48700 //
     /* 2244986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2244992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2244995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244999 */   // MIs[0] Operand 1
     /* 2244999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245012 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2245015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245017 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245028 */   // GIR_Coverage, 48700,
     /* 2245028 */   GIR_EraseRootFromParent_Done,
     /* 2245029 */ // Label 30054: @2245029
     /* 2245029 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2245077), // Rule ID 48701 //
     /* 2245034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2245043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245047 */   // MIs[0] Operand 1
     /* 2245047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245060 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2245063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245065 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245076 */   // GIR_Coverage, 48701,
     /* 2245076 */   GIR_EraseRootFromParent_Done,
     /* 2245077 */ // Label 30055: @2245077
     /* 2245077 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2245125), // Rule ID 48710 //
     /* 2245082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245095 */   // MIs[0] Operand 1
     /* 2245095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245104 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245108 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2245111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245113 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245124 */   // GIR_Coverage, 48710,
     /* 2245124 */   GIR_EraseRootFromParent_Done,
     /* 2245125 */ // Label 30056: @2245125
     /* 2245125 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2245173), // Rule ID 48711 //
     /* 2245130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245143 */   // MIs[0] Operand 1
     /* 2245143 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245152 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245156 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2245159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245161 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245172 */   // GIR_Coverage, 48711,
     /* 2245172 */   GIR_EraseRootFromParent_Done,
     /* 2245173 */ // Label 30057: @2245173
     /* 2245173 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2245221), // Rule ID 48728 //
     /* 2245178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2245187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245191 */   // MIs[0] Operand 1
     /* 2245191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245204 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2245207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245209 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245220 */   // GIR_Coverage, 48728,
     /* 2245220 */   GIR_EraseRootFromParent_Done,
     /* 2245221 */ // Label 30058: @2245221
     /* 2245221 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2245269), // Rule ID 48729 //
     /* 2245226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2245235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245239 */   // MIs[0] Operand 1
     /* 2245239 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245252 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2245255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245257 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245268 */   // GIR_Coverage, 48729,
     /* 2245268 */   GIR_EraseRootFromParent_Done,
     /* 2245269 */ // Label 30059: @2245269
     /* 2245269 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2245317), // Rule ID 48736 //
     /* 2245274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2245280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2245283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245287 */   // MIs[0] Operand 1
     /* 2245287 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245300 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2245303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245316 */   // GIR_Coverage, 48736,
     /* 2245316 */   GIR_EraseRootFromParent_Done,
     /* 2245317 */ // Label 30060: @2245317
     /* 2245317 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2245365), // Rule ID 48737 //
     /* 2245322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2245328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2245331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245335 */   // MIs[0] Operand 1
     /* 2245335 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2245340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245344 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245348 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2245351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245364 */   // GIR_Coverage, 48737,
     /* 2245364 */   GIR_EraseRootFromParent_Done,
     /* 2245365 */ // Label 30061: @2245365
     /* 2245365 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2245413), // Rule ID 48744 //
     /* 2245370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2245379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245383 */   // MIs[0] Operand 1
     /* 2245383 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245396 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2245399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245401 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245412 */   // GIR_Coverage, 48744,
     /* 2245412 */   GIR_EraseRootFromParent_Done,
     /* 2245413 */ // Label 30062: @2245413
     /* 2245413 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2245461), // Rule ID 48745 //
     /* 2245418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2245427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245431 */   // MIs[0] Operand 1
     /* 2245431 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245440 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245444 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2245447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245449 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245451 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245460 */   // GIR_Coverage, 48745,
     /* 2245460 */   GIR_EraseRootFromParent_Done,
     /* 2245461 */ // Label 30063: @2245461
     /* 2245461 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2245509), // Rule ID 48754 //
     /* 2245466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245479 */   // MIs[0] Operand 1
     /* 2245479 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245488 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245492 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245497 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245499 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245508 */   // GIR_Coverage, 48754,
     /* 2245508 */   GIR_EraseRootFromParent_Done,
     /* 2245509 */ // Label 30064: @2245509
     /* 2245509 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2245557), // Rule ID 48755 //
     /* 2245514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245527 */   // MIs[0] Operand 1
     /* 2245527 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245536 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245540 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245545 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245547 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245556 */   // GIR_Coverage, 48755,
     /* 2245556 */   GIR_EraseRootFromParent_Done,
     /* 2245557 */ // Label 30065: @2245557
     /* 2245557 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2245605), // Rule ID 48772 //
     /* 2245562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2245571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245575 */   // MIs[0] Operand 1
     /* 2245575 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245588 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245593 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245604 */   // GIR_Coverage, 48772,
     /* 2245604 */   GIR_EraseRootFromParent_Done,
     /* 2245605 */ // Label 30066: @2245605
     /* 2245605 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2245653), // Rule ID 48773 //
     /* 2245610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2245619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245623 */   // MIs[0] Operand 1
     /* 2245623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245632 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245636 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245641 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245652 */   // GIR_Coverage, 48773,
     /* 2245652 */   GIR_EraseRootFromParent_Done,
     /* 2245653 */ // Label 30067: @2245653
     /* 2245653 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2245701), // Rule ID 48780 //
     /* 2245658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2245664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2245667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245671 */   // MIs[0] Operand 1
     /* 2245671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245684 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245689 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245700 */   // GIR_Coverage, 48780,
     /* 2245700 */   GIR_EraseRootFromParent_Done,
     /* 2245701 */ // Label 30068: @2245701
     /* 2245701 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2245749), // Rule ID 48781 //
     /* 2245706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2245712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2245715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245719 */   // MIs[0] Operand 1
     /* 2245719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245732 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245737 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245748 */   // GIR_Coverage, 48781,
     /* 2245748 */   GIR_EraseRootFromParent_Done,
     /* 2245749 */ // Label 30069: @2245749
     /* 2245749 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2245797), // Rule ID 48788 //
     /* 2245754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245760 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2245763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245767 */   // MIs[0] Operand 1
     /* 2245767 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245776 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245780 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2245783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245785 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245796 */   // GIR_Coverage, 48788,
     /* 2245796 */   GIR_EraseRootFromParent_Done,
     /* 2245797 */ // Label 30070: @2245797
     /* 2245797 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2245845), // Rule ID 48789 //
     /* 2245802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2245808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2245811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245815 */   // MIs[0] Operand 1
     /* 2245815 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245828 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2245831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245833 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245844 */   // GIR_Coverage, 48789,
     /* 2245844 */   GIR_EraseRootFromParent_Done,
     /* 2245845 */ // Label 30071: @2245845
     /* 2245845 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2245893), // Rule ID 48798 //
     /* 2245850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245863 */   // MIs[0] Operand 1
     /* 2245863 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245876 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245881 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245892 */   // GIR_Coverage, 48798,
     /* 2245892 */   GIR_EraseRootFromParent_Done,
     /* 2245893 */ // Label 30072: @2245893
     /* 2245893 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2245941), // Rule ID 48799 //
     /* 2245898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2245904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2245907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245911 */   // MIs[0] Operand 1
     /* 2245911 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245920 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245924 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245929 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245940 */   // GIR_Coverage, 48799,
     /* 2245940 */   GIR_EraseRootFromParent_Done,
     /* 2245941 */ // Label 30073: @2245941
     /* 2245941 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2245989), // Rule ID 48816 //
     /* 2245946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2245952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2245955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245959 */   // MIs[0] Operand 1
     /* 2245959 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245972 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245988 */   // GIR_Coverage, 48816,
     /* 2245988 */   GIR_EraseRootFromParent_Done,
     /* 2245989 */ // Label 30074: @2245989
     /* 2245989 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2246037), // Rule ID 48817 //
     /* 2245994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2246000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2246003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246007 */   // MIs[0] Operand 1
     /* 2246007 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2246012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246016 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246020 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2246023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246025 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246036 */   // GIR_Coverage, 48817,
     /* 2246036 */   GIR_EraseRootFromParent_Done,
     /* 2246037 */ // Label 30075: @2246037
     /* 2246037 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2246085), // Rule ID 48824 //
     /* 2246042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246055 */   // MIs[0] Operand 1
     /* 2246055 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2246060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246068 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2246071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246073 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246084 */   // GIR_Coverage, 48824,
     /* 2246084 */   GIR_EraseRootFromParent_Done,
     /* 2246085 */ // Label 30076: @2246085
     /* 2246085 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2246133), // Rule ID 48825 //
     /* 2246090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246103 */   // MIs[0] Operand 1
     /* 2246103 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2246108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246116 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2246119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246121 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246132 */   // GIR_Coverage, 48825,
     /* 2246132 */   GIR_EraseRootFromParent_Done,
     /* 2246133 */ // Label 30077: @2246133
     /* 2246133 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2246181), // Rule ID 48832 //
     /* 2246138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2246144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2246147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246151 */   // MIs[0] Operand 1
     /* 2246151 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246164 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2246167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246169 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246180 */   // GIR_Coverage, 48832,
     /* 2246180 */   GIR_EraseRootFromParent_Done,
     /* 2246181 */ // Label 30078: @2246181
     /* 2246181 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2246229), // Rule ID 48833 //
     /* 2246186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2246192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2246195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246199 */   // MIs[0] Operand 1
     /* 2246199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246212 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2246215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246217 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246228 */   // GIR_Coverage, 48833,
     /* 2246228 */   GIR_EraseRootFromParent_Done,
     /* 2246229 */ // Label 30079: @2246229
     /* 2246229 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2246277), // Rule ID 48842 //
     /* 2246234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2246240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2246243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246247 */   // MIs[0] Operand 1
     /* 2246247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246260 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246265 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246276 */   // GIR_Coverage, 48842,
     /* 2246276 */   GIR_EraseRootFromParent_Done,
     /* 2246277 */ // Label 30080: @2246277
     /* 2246277 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2246325), // Rule ID 48843 //
     /* 2246282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2246288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2246291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246295 */   // MIs[0] Operand 1
     /* 2246295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246304 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246308 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246313 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246324 */   // GIR_Coverage, 48843,
     /* 2246324 */   GIR_EraseRootFromParent_Done,
     /* 2246325 */ // Label 30081: @2246325
     /* 2246325 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2246373), // Rule ID 48860 //
     /* 2246330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2246336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2246339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246343 */   // MIs[0] Operand 1
     /* 2246343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246356 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246372 */   // GIR_Coverage, 48860,
     /* 2246372 */   GIR_EraseRootFromParent_Done,
     /* 2246373 */ // Label 30082: @2246373
     /* 2246373 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2246421), // Rule ID 48861 //
     /* 2246378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2246384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2246387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246391 */   // MIs[0] Operand 1
     /* 2246391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246404 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246409 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246420 */   // GIR_Coverage, 48861,
     /* 2246420 */   GIR_EraseRootFromParent_Done,
     /* 2246421 */ // Label 30083: @2246421
     /* 2246421 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2246469), // Rule ID 48868 //
     /* 2246426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246439 */   // MIs[0] Operand 1
     /* 2246439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246448 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246452 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246457 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246468 */   // GIR_Coverage, 48868,
     /* 2246468 */   GIR_EraseRootFromParent_Done,
     /* 2246469 */ // Label 30084: @2246469
     /* 2246469 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2246517), // Rule ID 48869 //
     /* 2246474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246487 */   // MIs[0] Operand 1
     /* 2246487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246500 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246516 */   // GIR_Coverage, 48869,
     /* 2246516 */   GIR_EraseRootFromParent_Done,
     /* 2246517 */ // Label 30085: @2246517
     /* 2246517 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2246565), // Rule ID 48876 //
     /* 2246522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2246528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2246531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246535 */   // MIs[0] Operand 1
     /* 2246535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246548 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2246551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246553 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246564 */   // GIR_Coverage, 48876,
     /* 2246564 */   GIR_EraseRootFromParent_Done,
     /* 2246565 */ // Label 30086: @2246565
     /* 2246565 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2246613), // Rule ID 48877 //
     /* 2246570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2246576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2246579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246583 */   // MIs[0] Operand 1
     /* 2246583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246596 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2246599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246601 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246612 */   // GIR_Coverage, 48877,
     /* 2246612 */   GIR_EraseRootFromParent_Done,
     /* 2246613 */ // Label 30087: @2246613
     /* 2246613 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2246661), // Rule ID 48886 //
     /* 2246618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2246624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2246627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246631 */   // MIs[0] Operand 1
     /* 2246631 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246644 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246649 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246660 */   // GIR_Coverage, 48886,
     /* 2246660 */   GIR_EraseRootFromParent_Done,
     /* 2246661 */ // Label 30088: @2246661
     /* 2246661 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2246709), // Rule ID 48887 //
     /* 2246666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2246672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2246675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246679 */   // MIs[0] Operand 1
     /* 2246679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246692 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246697 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246708 */   // GIR_Coverage, 48887,
     /* 2246708 */   GIR_EraseRootFromParent_Done,
     /* 2246709 */ // Label 30089: @2246709
     /* 2246709 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2246757), // Rule ID 48904 //
     /* 2246714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2246720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2246723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246727 */   // MIs[0] Operand 1
     /* 2246727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246740 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246756 */   // GIR_Coverage, 48904,
     /* 2246756 */   GIR_EraseRootFromParent_Done,
     /* 2246757 */ // Label 30090: @2246757
     /* 2246757 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2246805), // Rule ID 48905 //
     /* 2246762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2246768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2246771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246775 */   // MIs[0] Operand 1
     /* 2246775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246788 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246793 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246804 */   // GIR_Coverage, 48905,
     /* 2246804 */   GIR_EraseRootFromParent_Done,
     /* 2246805 */ // Label 30091: @2246805
     /* 2246805 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2246853), // Rule ID 48912 //
     /* 2246810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246823 */   // MIs[0] Operand 1
     /* 2246823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246836 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246841 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246852 */   // GIR_Coverage, 48912,
     /* 2246852 */   GIR_EraseRootFromParent_Done,
     /* 2246853 */ // Label 30092: @2246853
     /* 2246853 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2246901), // Rule ID 48913 //
     /* 2246858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2246864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2246867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246871 */   // MIs[0] Operand 1
     /* 2246871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246884 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246900 */   // GIR_Coverage, 48913,
     /* 2246900 */   GIR_EraseRootFromParent_Done,
     /* 2246901 */ // Label 30093: @2246901
     /* 2246901 */ GIM_Reject,
     /* 2246902 */ // Label 29755: @2246902
     /* 2246902 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2246950), // Rule ID 48490 //
     /* 2246907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2246913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2246916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246920 */   // MIs[0] Operand 1
     /* 2246920 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246933 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246938 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246940 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246949 */   // GIR_Coverage, 48490,
     /* 2246949 */   GIR_EraseRootFromParent_Done,
     /* 2246950 */ // Label 30094: @2246950
     /* 2246950 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2246998), // Rule ID 48491 //
     /* 2246955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2246961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2246964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246968 */   // MIs[0] Operand 1
     /* 2246968 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246977 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246981 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2246984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246986 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246988 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246997 */   // GIR_Coverage, 48491,
     /* 2246997 */   GIR_EraseRootFromParent_Done,
     /* 2246998 */ // Label 30095: @2246998
     /* 2246998 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2247046), // Rule ID 48504 //
     /* 2247003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247016 */   // MIs[0] Operand 1
     /* 2247016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247029 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2247032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247034 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247036 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247045 */   // GIR_Coverage, 48504,
     /* 2247045 */   GIR_EraseRootFromParent_Done,
     /* 2247046 */ // Label 30096: @2247046
     /* 2247046 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2247094), // Rule ID 48505 //
     /* 2247051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247064 */   // MIs[0] Operand 1
     /* 2247064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247073 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247077 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2247080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247082 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247084 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247093 */   // GIR_Coverage, 48505,
     /* 2247093 */   GIR_EraseRootFromParent_Done,
     /* 2247094 */ // Label 30097: @2247094
     /* 2247094 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2247142), // Rule ID 48512 //
     /* 2247099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247112 */   // MIs[0] Operand 1
     /* 2247112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247125 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2247128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247130 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247132 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247141 */   // GIR_Coverage, 48512,
     /* 2247141 */   GIR_EraseRootFromParent_Done,
     /* 2247142 */ // Label 30098: @2247142
     /* 2247142 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2247190), // Rule ID 48513 //
     /* 2247147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247160 */   // MIs[0] Operand 1
     /* 2247160 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247173 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2247176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247178 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247180 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247189 */   // GIR_Coverage, 48513,
     /* 2247189 */   GIR_EraseRootFromParent_Done,
     /* 2247190 */ // Label 30099: @2247190
     /* 2247190 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2247238), // Rule ID 48520 //
     /* 2247195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2247201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2247204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247208 */   // MIs[0] Operand 1
     /* 2247208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247221 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2247224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247226 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247228 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247237 */   // GIR_Coverage, 48520,
     /* 2247237 */   GIR_EraseRootFromParent_Done,
     /* 2247238 */ // Label 30100: @2247238
     /* 2247238 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2247286), // Rule ID 48521 //
     /* 2247243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2247249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2247252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247256 */   // MIs[0] Operand 1
     /* 2247256 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2247261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247269 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2247272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247276 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247285 */   // GIR_Coverage, 48521,
     /* 2247285 */   GIR_EraseRootFromParent_Done,
     /* 2247286 */ // Label 30101: @2247286
     /* 2247286 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2247334), // Rule ID 48534 //
     /* 2247291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2247297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2247300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247304 */   // MIs[0] Operand 1
     /* 2247304 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247317 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2247320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247333 */   // GIR_Coverage, 48534,
     /* 2247333 */   GIR_EraseRootFromParent_Done,
     /* 2247334 */ // Label 30102: @2247334
     /* 2247334 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2247382), // Rule ID 48535 //
     /* 2247339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2247345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2247348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247352 */   // MIs[0] Operand 1
     /* 2247352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247365 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2247368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247381 */   // GIR_Coverage, 48535,
     /* 2247381 */   GIR_EraseRootFromParent_Done,
     /* 2247382 */ // Label 30103: @2247382
     /* 2247382 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2247430), // Rule ID 48548 //
     /* 2247387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247400 */   // MIs[0] Operand 1
     /* 2247400 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247409 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247413 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2247416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247418 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247420 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247429 */   // GIR_Coverage, 48548,
     /* 2247429 */   GIR_EraseRootFromParent_Done,
     /* 2247430 */ // Label 30104: @2247430
     /* 2247430 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2247478), // Rule ID 48549 //
     /* 2247435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247448 */   // MIs[0] Operand 1
     /* 2247448 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247457 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247461 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2247464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247466 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247468 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247477 */   // GIR_Coverage, 48549,
     /* 2247477 */   GIR_EraseRootFromParent_Done,
     /* 2247478 */ // Label 30105: @2247478
     /* 2247478 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2247526), // Rule ID 48556 //
     /* 2247483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247496 */   // MIs[0] Operand 1
     /* 2247496 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247505 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247509 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2247512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247514 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247516 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247525 */   // GIR_Coverage, 48556,
     /* 2247525 */   GIR_EraseRootFromParent_Done,
     /* 2247526 */ // Label 30106: @2247526
     /* 2247526 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2247574), // Rule ID 48557 //
     /* 2247531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247544 */   // MIs[0] Operand 1
     /* 2247544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247557 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2247560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247562 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247564 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247573 */   // GIR_Coverage, 48557,
     /* 2247573 */   GIR_EraseRootFromParent_Done,
     /* 2247574 */ // Label 30107: @2247574
     /* 2247574 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2247622), // Rule ID 48564 //
     /* 2247579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2247585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2247588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247592 */   // MIs[0] Operand 1
     /* 2247592 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247601 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247605 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2247608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247610 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247612 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247621 */   // GIR_Coverage, 48564,
     /* 2247621 */   GIR_EraseRootFromParent_Done,
     /* 2247622 */ // Label 30108: @2247622
     /* 2247622 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2247670), // Rule ID 48565 //
     /* 2247627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2247633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2247636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247640 */   // MIs[0] Operand 1
     /* 2247640 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2247645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247649 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247653 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2247656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247658 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247660 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247669 */   // GIR_Coverage, 48565,
     /* 2247669 */   GIR_EraseRootFromParent_Done,
     /* 2247670 */ // Label 30109: @2247670
     /* 2247670 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2247718), // Rule ID 48578 //
     /* 2247675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2247681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2247684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247688 */   // MIs[0] Operand 1
     /* 2247688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247701 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247706 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247717 */   // GIR_Coverage, 48578,
     /* 2247717 */   GIR_EraseRootFromParent_Done,
     /* 2247718 */ // Label 30110: @2247718
     /* 2247718 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2247766), // Rule ID 48579 //
     /* 2247723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2247729 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2247732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247736 */   // MIs[0] Operand 1
     /* 2247736 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247745 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247749 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2247752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247754 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247756 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247765 */   // GIR_Coverage, 48579,
     /* 2247765 */   GIR_EraseRootFromParent_Done,
     /* 2247766 */ // Label 30111: @2247766
     /* 2247766 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2247814), // Rule ID 48592 //
     /* 2247771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247784 */   // MIs[0] Operand 1
     /* 2247784 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247797 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247802 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247804 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247813 */   // GIR_Coverage, 48592,
     /* 2247813 */   GIR_EraseRootFromParent_Done,
     /* 2247814 */ // Label 30112: @2247814
     /* 2247814 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2247862), // Rule ID 48593 //
     /* 2247819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2247825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2247828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247832 */   // MIs[0] Operand 1
     /* 2247832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247841 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247845 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247850 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247861 */   // GIR_Coverage, 48593,
     /* 2247861 */   GIR_EraseRootFromParent_Done,
     /* 2247862 */ // Label 30113: @2247862
     /* 2247862 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2247910), // Rule ID 48600 //
     /* 2247867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247880 */   // MIs[0] Operand 1
     /* 2247880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247893 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247909 */   // GIR_Coverage, 48600,
     /* 2247909 */   GIR_EraseRootFromParent_Done,
     /* 2247910 */ // Label 30114: @2247910
     /* 2247910 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2247958), // Rule ID 48601 //
     /* 2247915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2247921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2247924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247928 */   // MIs[0] Operand 1
     /* 2247928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247941 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247957 */   // GIR_Coverage, 48601,
     /* 2247957 */   GIR_EraseRootFromParent_Done,
     /* 2247958 */ // Label 30115: @2247958
     /* 2247958 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2248006), // Rule ID 48608 //
     /* 2247963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2247969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2247972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247976 */   // MIs[0] Operand 1
     /* 2247976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247989 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2247992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248005 */   // GIR_Coverage, 48608,
     /* 2248005 */   GIR_EraseRootFromParent_Done,
     /* 2248006 */ // Label 30116: @2248006
     /* 2248006 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2248054), // Rule ID 48609 //
     /* 2248011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2248017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2248020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248024 */   // MIs[0] Operand 1
     /* 2248024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2248029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248037 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2248040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248053 */   // GIR_Coverage, 48609,
     /* 2248053 */   GIR_EraseRootFromParent_Done,
     /* 2248054 */ // Label 30117: @2248054
     /* 2248054 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2248102), // Rule ID 48620 //
     /* 2248059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248072 */   // MIs[0] Operand 1
     /* 2248072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248085 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2248088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248101 */   // GIR_Coverage, 48620,
     /* 2248101 */   GIR_EraseRootFromParent_Done,
     /* 2248102 */ // Label 30118: @2248102
     /* 2248102 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2248150), // Rule ID 48621 //
     /* 2248107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248120 */   // MIs[0] Operand 1
     /* 2248120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248133 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2248136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248138 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248149 */   // GIR_Coverage, 48621,
     /* 2248149 */   GIR_EraseRootFromParent_Done,
     /* 2248150 */ // Label 30119: @2248150
     /* 2248150 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2248198), // Rule ID 48634 //
     /* 2248155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248168 */   // MIs[0] Operand 1
     /* 2248168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248181 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2248184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248186 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248197 */   // GIR_Coverage, 48634,
     /* 2248197 */   GIR_EraseRootFromParent_Done,
     /* 2248198 */ // Label 30120: @2248198
     /* 2248198 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2248246), // Rule ID 48635 //
     /* 2248203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248216 */   // MIs[0] Operand 1
     /* 2248216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248229 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2248232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248245 */   // GIR_Coverage, 48635,
     /* 2248245 */   GIR_EraseRootFromParent_Done,
     /* 2248246 */ // Label 30121: @2248246
     /* 2248246 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2248294), // Rule ID 48642 //
     /* 2248251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2248257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2248260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248264 */   // MIs[0] Operand 1
     /* 2248264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248277 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2248280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248293 */   // GIR_Coverage, 48642,
     /* 2248293 */   GIR_EraseRootFromParent_Done,
     /* 2248294 */ // Label 30122: @2248294
     /* 2248294 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2248342), // Rule ID 48643 //
     /* 2248299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2248305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2248308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248312 */   // MIs[0] Operand 1
     /* 2248312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248325 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2248328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248341 */   // GIR_Coverage, 48643,
     /* 2248341 */   GIR_EraseRootFromParent_Done,
     /* 2248342 */ // Label 30123: @2248342
     /* 2248342 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2248390), // Rule ID 48650 //
     /* 2248347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2248353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2248356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248360 */   // MIs[0] Operand 1
     /* 2248360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248373 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2248376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248380 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248389 */   // GIR_Coverage, 48650,
     /* 2248389 */   GIR_EraseRootFromParent_Done,
     /* 2248390 */ // Label 30124: @2248390
     /* 2248390 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2248438), // Rule ID 48651 //
     /* 2248395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2248401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2248404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248408 */   // MIs[0] Operand 1
     /* 2248408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2248413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248421 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2248424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248437 */   // GIR_Coverage, 48651,
     /* 2248437 */   GIR_EraseRootFromParent_Done,
     /* 2248438 */ // Label 30125: @2248438
     /* 2248438 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2248486), // Rule ID 48664 //
     /* 2248443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248456 */   // MIs[0] Operand 1
     /* 2248456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248469 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248485 */   // GIR_Coverage, 48664,
     /* 2248485 */   GIR_EraseRootFromParent_Done,
     /* 2248486 */ // Label 30126: @2248486
     /* 2248486 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2248534), // Rule ID 48665 //
     /* 2248491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248504 */   // MIs[0] Operand 1
     /* 2248504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248517 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248522 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248533 */   // GIR_Coverage, 48665,
     /* 2248533 */   GIR_EraseRootFromParent_Done,
     /* 2248534 */ // Label 30127: @2248534
     /* 2248534 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2248582), // Rule ID 48678 //
     /* 2248539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248552 */   // MIs[0] Operand 1
     /* 2248552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248565 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2248568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248581 */   // GIR_Coverage, 48678,
     /* 2248581 */   GIR_EraseRootFromParent_Done,
     /* 2248582 */ // Label 30128: @2248582
     /* 2248582 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2248630), // Rule ID 48679 //
     /* 2248587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248600 */   // MIs[0] Operand 1
     /* 2248600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248613 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2248616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248629 */   // GIR_Coverage, 48679,
     /* 2248629 */   GIR_EraseRootFromParent_Done,
     /* 2248630 */ // Label 30129: @2248630
     /* 2248630 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2248678), // Rule ID 48686 //
     /* 2248635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2248641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2248644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248648 */   // MIs[0] Operand 1
     /* 2248648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248661 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2248664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248677 */   // GIR_Coverage, 48686,
     /* 2248677 */   GIR_EraseRootFromParent_Done,
     /* 2248678 */ // Label 30130: @2248678
     /* 2248678 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2248726), // Rule ID 48687 //
     /* 2248683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2248689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2248692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248696 */   // MIs[0] Operand 1
     /* 2248696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248709 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2248712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248725 */   // GIR_Coverage, 48687,
     /* 2248725 */   GIR_EraseRootFromParent_Done,
     /* 2248726 */ // Label 30131: @2248726
     /* 2248726 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2248774), // Rule ID 48694 //
     /* 2248731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2248737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2248740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248744 */   // MIs[0] Operand 1
     /* 2248744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248757 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2248760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248773 */   // GIR_Coverage, 48694,
     /* 2248773 */   GIR_EraseRootFromParent_Done,
     /* 2248774 */ // Label 30132: @2248774
     /* 2248774 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2248822), // Rule ID 48695 //
     /* 2248779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2248785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2248788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248792 */   // MIs[0] Operand 1
     /* 2248792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2248797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248805 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2248808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248821 */   // GIR_Coverage, 48695,
     /* 2248821 */   GIR_EraseRootFromParent_Done,
     /* 2248822 */ // Label 30133: @2248822
     /* 2248822 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2248870), // Rule ID 48708 //
     /* 2248827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248840 */   // MIs[0] Operand 1
     /* 2248840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248853 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248869 */   // GIR_Coverage, 48708,
     /* 2248869 */   GIR_EraseRootFromParent_Done,
     /* 2248870 */ // Label 30134: @2248870
     /* 2248870 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2248918), // Rule ID 48709 //
     /* 2248875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2248881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2248884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248888 */   // MIs[0] Operand 1
     /* 2248888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248901 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2248904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248917 */   // GIR_Coverage, 48709,
     /* 2248917 */   GIR_EraseRootFromParent_Done,
     /* 2248918 */ // Label 30135: @2248918
     /* 2248918 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2248966), // Rule ID 48722 //
     /* 2248923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248936 */   // MIs[0] Operand 1
     /* 2248936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248949 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2248952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248965 */   // GIR_Coverage, 48722,
     /* 2248965 */   GIR_EraseRootFromParent_Done,
     /* 2248966 */ // Label 30136: @2248966
     /* 2248966 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2249014), // Rule ID 48723 //
     /* 2248971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2248977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2248980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248984 */   // MIs[0] Operand 1
     /* 2248984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248997 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2249000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249013 */   // GIR_Coverage, 48723,
     /* 2249013 */   GIR_EraseRootFromParent_Done,
     /* 2249014 */ // Label 30137: @2249014
     /* 2249014 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2249062), // Rule ID 48730 //
     /* 2249019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249032 */   // MIs[0] Operand 1
     /* 2249032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2249037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249045 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2249048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249061 */   // GIR_Coverage, 48730,
     /* 2249061 */   GIR_EraseRootFromParent_Done,
     /* 2249062 */ // Label 30138: @2249062
     /* 2249062 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2249110), // Rule ID 48731 //
     /* 2249067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249080 */   // MIs[0] Operand 1
     /* 2249080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2249085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249093 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2249096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249109 */   // GIR_Coverage, 48731,
     /* 2249109 */   GIR_EraseRootFromParent_Done,
     /* 2249110 */ // Label 30139: @2249110
     /* 2249110 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2249158), // Rule ID 48738 //
     /* 2249115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249128 */   // MIs[0] Operand 1
     /* 2249128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2249133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249141 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2249144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249157 */   // GIR_Coverage, 48738,
     /* 2249157 */   GIR_EraseRootFromParent_Done,
     /* 2249158 */ // Label 30140: @2249158
     /* 2249158 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2249206), // Rule ID 48739 //
     /* 2249163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249176 */   // MIs[0] Operand 1
     /* 2249176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2249181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249189 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2249192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249205 */   // GIR_Coverage, 48739,
     /* 2249205 */   GIR_EraseRootFromParent_Done,
     /* 2249206 */ // Label 30141: @2249206
     /* 2249206 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2249254), // Rule ID 48752 //
     /* 2249211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2249217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2249220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249224 */   // MIs[0] Operand 1
     /* 2249224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249237 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2249240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249253 */   // GIR_Coverage, 48752,
     /* 2249253 */   GIR_EraseRootFromParent_Done,
     /* 2249254 */ // Label 30142: @2249254
     /* 2249254 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2249302), // Rule ID 48753 //
     /* 2249259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2249265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2249268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249272 */   // MIs[0] Operand 1
     /* 2249272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249285 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2249288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249290 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249301 */   // GIR_Coverage, 48753,
     /* 2249301 */   GIR_EraseRootFromParent_Done,
     /* 2249302 */ // Label 30143: @2249302
     /* 2249302 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2249350), // Rule ID 48766 //
     /* 2249307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2249313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2249316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249320 */   // MIs[0] Operand 1
     /* 2249320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249333 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2249336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249338 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249349 */   // GIR_Coverage, 48766,
     /* 2249349 */   GIR_EraseRootFromParent_Done,
     /* 2249350 */ // Label 30144: @2249350
     /* 2249350 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2249398), // Rule ID 48767 //
     /* 2249355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2249361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2249364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249368 */   // MIs[0] Operand 1
     /* 2249368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249381 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2249384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249386 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249397 */   // GIR_Coverage, 48767,
     /* 2249397 */   GIR_EraseRootFromParent_Done,
     /* 2249398 */ // Label 30145: @2249398
     /* 2249398 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2249446), // Rule ID 48774 //
     /* 2249403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249416 */   // MIs[0] Operand 1
     /* 2249416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249429 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2249432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249445 */   // GIR_Coverage, 48774,
     /* 2249445 */   GIR_EraseRootFromParent_Done,
     /* 2249446 */ // Label 30146: @2249446
     /* 2249446 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2249494), // Rule ID 48775 //
     /* 2249451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249464 */   // MIs[0] Operand 1
     /* 2249464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249477 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2249480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249493 */   // GIR_Coverage, 48775,
     /* 2249493 */   GIR_EraseRootFromParent_Done,
     /* 2249494 */ // Label 30147: @2249494
     /* 2249494 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2249542), // Rule ID 48782 //
     /* 2249499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249512 */   // MIs[0] Operand 1
     /* 2249512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249525 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2249528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249541 */   // GIR_Coverage, 48782,
     /* 2249541 */   GIR_EraseRootFromParent_Done,
     /* 2249542 */ // Label 30148: @2249542
     /* 2249542 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2249590), // Rule ID 48783 //
     /* 2249547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249560 */   // MIs[0] Operand 1
     /* 2249560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2249565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249573 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2249576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249589 */   // GIR_Coverage, 48783,
     /* 2249589 */   GIR_EraseRootFromParent_Done,
     /* 2249590 */ // Label 30149: @2249590
     /* 2249590 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2249638), // Rule ID 48796 //
     /* 2249595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2249601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2249604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249608 */   // MIs[0] Operand 1
     /* 2249608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249621 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2249624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249626 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249637 */   // GIR_Coverage, 48796,
     /* 2249637 */   GIR_EraseRootFromParent_Done,
     /* 2249638 */ // Label 30150: @2249638
     /* 2249638 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2249686), // Rule ID 48797 //
     /* 2249643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2249649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2249652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249656 */   // MIs[0] Operand 1
     /* 2249656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249669 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2249672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249674 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249685 */   // GIR_Coverage, 48797,
     /* 2249685 */   GIR_EraseRootFromParent_Done,
     /* 2249686 */ // Label 30151: @2249686
     /* 2249686 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2249734), // Rule ID 48810 //
     /* 2249691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2249697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2249700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249704 */   // MIs[0] Operand 1
     /* 2249704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249717 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2249720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249722 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249733 */   // GIR_Coverage, 48810,
     /* 2249733 */   GIR_EraseRootFromParent_Done,
     /* 2249734 */ // Label 30152: @2249734
     /* 2249734 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2249782), // Rule ID 48811 //
     /* 2249739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2249745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2249748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249752 */   // MIs[0] Operand 1
     /* 2249752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249765 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2249768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249770 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249781 */   // GIR_Coverage, 48811,
     /* 2249781 */   GIR_EraseRootFromParent_Done,
     /* 2249782 */ // Label 30153: @2249782
     /* 2249782 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2249830), // Rule ID 48818 //
     /* 2249787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249800 */   // MIs[0] Operand 1
     /* 2249800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249813 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2249816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249818 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249829 */   // GIR_Coverage, 48818,
     /* 2249829 */   GIR_EraseRootFromParent_Done,
     /* 2249830 */ // Label 30154: @2249830
     /* 2249830 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2249878), // Rule ID 48819 //
     /* 2249835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2249841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2249844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249848 */   // MIs[0] Operand 1
     /* 2249848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249861 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2249864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249866 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249877 */   // GIR_Coverage, 48819,
     /* 2249877 */   GIR_EraseRootFromParent_Done,
     /* 2249878 */ // Label 30155: @2249878
     /* 2249878 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2249926), // Rule ID 48826 //
     /* 2249883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249896 */   // MIs[0] Operand 1
     /* 2249896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249909 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2249912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249914 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249925 */   // GIR_Coverage, 48826,
     /* 2249925 */   GIR_EraseRootFromParent_Done,
     /* 2249926 */ // Label 30156: @2249926
     /* 2249926 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2249974), // Rule ID 48827 //
     /* 2249931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2249937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2249940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249944 */   // MIs[0] Operand 1
     /* 2249944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2249949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249957 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2249960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249962 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249973 */   // GIR_Coverage, 48827,
     /* 2249973 */   GIR_EraseRootFromParent_Done,
     /* 2249974 */ // Label 30157: @2249974
     /* 2249974 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2250022), // Rule ID 48840 //
     /* 2249979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2249985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2249988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249992 */   // MIs[0] Operand 1
     /* 2249992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2249997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250005 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2250008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250021 */   // GIR_Coverage, 48840,
     /* 2250021 */   GIR_EraseRootFromParent_Done,
     /* 2250022 */ // Label 30158: @2250022
     /* 2250022 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2250070), // Rule ID 48841 //
     /* 2250027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2250033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2250036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250040 */   // MIs[0] Operand 1
     /* 2250040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250053 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2250056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250069 */   // GIR_Coverage, 48841,
     /* 2250069 */   GIR_EraseRootFromParent_Done,
     /* 2250070 */ // Label 30159: @2250070
     /* 2250070 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2250118), // Rule ID 48854 //
     /* 2250075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2250081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2250084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250088 */   // MIs[0] Operand 1
     /* 2250088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250101 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2250104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250117 */   // GIR_Coverage, 48854,
     /* 2250117 */   GIR_EraseRootFromParent_Done,
     /* 2250118 */ // Label 30160: @2250118
     /* 2250118 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2250166), // Rule ID 48855 //
     /* 2250123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2250129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2250132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250136 */   // MIs[0] Operand 1
     /* 2250136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250149 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2250152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250154 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250165 */   // GIR_Coverage, 48855,
     /* 2250165 */   GIR_EraseRootFromParent_Done,
     /* 2250166 */ // Label 30161: @2250166
     /* 2250166 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2250214), // Rule ID 48862 //
     /* 2250171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2250177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2250180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250184 */   // MIs[0] Operand 1
     /* 2250184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250197 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250213 */   // GIR_Coverage, 48862,
     /* 2250213 */   GIR_EraseRootFromParent_Done,
     /* 2250214 */ // Label 30162: @2250214
     /* 2250214 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2250262), // Rule ID 48863 //
     /* 2250219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2250225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2250228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250232 */   // MIs[0] Operand 1
     /* 2250232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250245 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250261 */   // GIR_Coverage, 48863,
     /* 2250261 */   GIR_EraseRootFromParent_Done,
     /* 2250262 */ // Label 30163: @2250262
     /* 2250262 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2250310), // Rule ID 48870 //
     /* 2250267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2250273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2250276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250280 */   // MIs[0] Operand 1
     /* 2250280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250293 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2250296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250309 */   // GIR_Coverage, 48870,
     /* 2250309 */   GIR_EraseRootFromParent_Done,
     /* 2250310 */ // Label 30164: @2250310
     /* 2250310 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2250358), // Rule ID 48871 //
     /* 2250315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2250321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2250324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250328 */   // MIs[0] Operand 1
     /* 2250328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250341 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2250344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250357 */   // GIR_Coverage, 48871,
     /* 2250357 */   GIR_EraseRootFromParent_Done,
     /* 2250358 */ // Label 30165: @2250358
     /* 2250358 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2250406), // Rule ID 48884 //
     /* 2250363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2250369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2250372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250376 */   // MIs[0] Operand 1
     /* 2250376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250389 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2250392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250394 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250405 */   // GIR_Coverage, 48884,
     /* 2250405 */   GIR_EraseRootFromParent_Done,
     /* 2250406 */ // Label 30166: @2250406
     /* 2250406 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2250454), // Rule ID 48885 //
     /* 2250411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2250417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2250420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250424 */   // MIs[0] Operand 1
     /* 2250424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250437 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2250440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250442 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250453 */   // GIR_Coverage, 48885,
     /* 2250453 */   GIR_EraseRootFromParent_Done,
     /* 2250454 */ // Label 30167: @2250454
     /* 2250454 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2250502), // Rule ID 48898 //
     /* 2250459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2250465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2250468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250472 */   // MIs[0] Operand 1
     /* 2250472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250485 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2250488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250490 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250501 */   // GIR_Coverage, 48898,
     /* 2250501 */   GIR_EraseRootFromParent_Done,
     /* 2250502 */ // Label 30168: @2250502
     /* 2250502 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2250550), // Rule ID 48899 //
     /* 2250507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2250513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2250516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250520 */   // MIs[0] Operand 1
     /* 2250520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250533 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2250536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250538 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250549 */   // GIR_Coverage, 48899,
     /* 2250549 */   GIR_EraseRootFromParent_Done,
     /* 2250550 */ // Label 30169: @2250550
     /* 2250550 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2250598), // Rule ID 48906 //
     /* 2250555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2250561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2250564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250568 */   // MIs[0] Operand 1
     /* 2250568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250581 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250586 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250597 */   // GIR_Coverage, 48906,
     /* 2250597 */   GIR_EraseRootFromParent_Done,
     /* 2250598 */ // Label 30170: @2250598
     /* 2250598 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2250646), // Rule ID 48907 //
     /* 2250603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2250609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2250612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250616 */   // MIs[0] Operand 1
     /* 2250616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250629 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250634 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250645 */   // GIR_Coverage, 48907,
     /* 2250645 */   GIR_EraseRootFromParent_Done,
     /* 2250646 */ // Label 30171: @2250646
     /* 2250646 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2250694), // Rule ID 48914 //
     /* 2250651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2250657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2250660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250664 */   // MIs[0] Operand 1
     /* 2250664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250677 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2250680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250682 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250693 */   // GIR_Coverage, 48914,
     /* 2250693 */   GIR_EraseRootFromParent_Done,
     /* 2250694 */ // Label 30172: @2250694
     /* 2250694 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2250742), // Rule ID 48915 //
     /* 2250699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2250705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2250708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250712 */   // MIs[0] Operand 1
     /* 2250712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2250717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250725 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2250728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250741 */   // GIR_Coverage, 48915,
     /* 2250741 */   GIR_EraseRootFromParent_Done,
     /* 2250742 */ // Label 30173: @2250742
     /* 2250742 */ GIM_Reject,
     /* 2250743 */ // Label 29756: @2250743
     /* 2250743 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2250791), // Rule ID 48498 //
     /* 2250748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2250754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2250757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250761 */   // MIs[0] Operand 1
     /* 2250761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250774 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250779 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250781 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250790 */   // GIR_Coverage, 48498,
     /* 2250790 */   GIR_EraseRootFromParent_Done,
     /* 2250791 */ // Label 30174: @2250791
     /* 2250791 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2250839), // Rule ID 48499 //
     /* 2250796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2250802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2250805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250809 */   // MIs[0] Operand 1
     /* 2250809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250822 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2250825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250827 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250829 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250838 */   // GIR_Coverage, 48499,
     /* 2250838 */   GIR_EraseRootFromParent_Done,
     /* 2250839 */ // Label 30175: @2250839
     /* 2250839 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2250887), // Rule ID 48506 //
     /* 2250844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2250850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2250853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250857 */   // MIs[0] Operand 1
     /* 2250857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250870 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2250873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250875 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250877 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250886 */   // GIR_Coverage, 48506,
     /* 2250886 */   GIR_EraseRootFromParent_Done,
     /* 2250887 */ // Label 30176: @2250887
     /* 2250887 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2250935), // Rule ID 48507 //
     /* 2250892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2250898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2250901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250905 */   // MIs[0] Operand 1
     /* 2250905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250918 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2250921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250923 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250925 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250934 */   // GIR_Coverage, 48507,
     /* 2250934 */   GIR_EraseRootFromParent_Done,
     /* 2250935 */ // Label 30177: @2250935
     /* 2250935 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2250983), // Rule ID 48514 //
     /* 2250940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2250946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2250949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250953 */   // MIs[0] Operand 1
     /* 2250953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2250958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250966 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2250969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250971 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250973 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250982 */   // GIR_Coverage, 48514,
     /* 2250982 */   GIR_EraseRootFromParent_Done,
     /* 2250983 */ // Label 30178: @2250983
     /* 2250983 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2251031), // Rule ID 48515 //
     /* 2250988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2250994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2250997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251001 */   // MIs[0] Operand 1
     /* 2251001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2251006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251014 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2251017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251021 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251030 */   // GIR_Coverage, 48515,
     /* 2251030 */   GIR_EraseRootFromParent_Done,
     /* 2251031 */ // Label 30179: @2251031
     /* 2251031 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2251079), // Rule ID 48542 //
     /* 2251036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251049 */   // MIs[0] Operand 1
     /* 2251049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251062 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2251065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251078 */   // GIR_Coverage, 48542,
     /* 2251078 */   GIR_EraseRootFromParent_Done,
     /* 2251079 */ // Label 30180: @2251079
     /* 2251079 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2251127), // Rule ID 48543 //
     /* 2251084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251097 */   // MIs[0] Operand 1
     /* 2251097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251110 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2251113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251126 */   // GIR_Coverage, 48543,
     /* 2251126 */   GIR_EraseRootFromParent_Done,
     /* 2251127 */ // Label 30181: @2251127
     /* 2251127 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2251175), // Rule ID 48550 //
     /* 2251132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251145 */   // MIs[0] Operand 1
     /* 2251145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251158 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2251161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251174 */   // GIR_Coverage, 48550,
     /* 2251174 */   GIR_EraseRootFromParent_Done,
     /* 2251175 */ // Label 30182: @2251175
     /* 2251175 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2251223), // Rule ID 48551 //
     /* 2251180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251193 */   // MIs[0] Operand 1
     /* 2251193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251206 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2251209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251222 */   // GIR_Coverage, 48551,
     /* 2251222 */   GIR_EraseRootFromParent_Done,
     /* 2251223 */ // Label 30183: @2251223
     /* 2251223 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2251271), // Rule ID 48558 //
     /* 2251228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251241 */   // MIs[0] Operand 1
     /* 2251241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251254 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2251257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251270 */   // GIR_Coverage, 48558,
     /* 2251270 */   GIR_EraseRootFromParent_Done,
     /* 2251271 */ // Label 30184: @2251271
     /* 2251271 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2251319), // Rule ID 48559 //
     /* 2251276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251289 */   // MIs[0] Operand 1
     /* 2251289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251302 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2251305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251318 */   // GIR_Coverage, 48559,
     /* 2251318 */   GIR_EraseRootFromParent_Done,
     /* 2251319 */ // Label 30185: @2251319
     /* 2251319 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2251367), // Rule ID 48586 //
     /* 2251324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251337 */   // MIs[0] Operand 1
     /* 2251337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251350 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251366 */   // GIR_Coverage, 48586,
     /* 2251366 */   GIR_EraseRootFromParent_Done,
     /* 2251367 */ // Label 30186: @2251367
     /* 2251367 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2251415), // Rule ID 48587 //
     /* 2251372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251385 */   // MIs[0] Operand 1
     /* 2251385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251398 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251414 */   // GIR_Coverage, 48587,
     /* 2251414 */   GIR_EraseRootFromParent_Done,
     /* 2251415 */ // Label 30187: @2251415
     /* 2251415 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2251463), // Rule ID 48594 //
     /* 2251420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251433 */   // MIs[0] Operand 1
     /* 2251433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251446 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2251449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251462 */   // GIR_Coverage, 48594,
     /* 2251462 */   GIR_EraseRootFromParent_Done,
     /* 2251463 */ // Label 30188: @2251463
     /* 2251463 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2251511), // Rule ID 48595 //
     /* 2251468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251481 */   // MIs[0] Operand 1
     /* 2251481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251494 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2251497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251510 */   // GIR_Coverage, 48595,
     /* 2251510 */   GIR_EraseRootFromParent_Done,
     /* 2251511 */ // Label 30189: @2251511
     /* 2251511 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2251559), // Rule ID 48602 //
     /* 2251516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251529 */   // MIs[0] Operand 1
     /* 2251529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251542 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251558 */   // GIR_Coverage, 48602,
     /* 2251558 */   GIR_EraseRootFromParent_Done,
     /* 2251559 */ // Label 30190: @2251559
     /* 2251559 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2251607), // Rule ID 48603 //
     /* 2251564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251577 */   // MIs[0] Operand 1
     /* 2251577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251590 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251595 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251597 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251606 */   // GIR_Coverage, 48603,
     /* 2251606 */   GIR_EraseRootFromParent_Done,
     /* 2251607 */ // Label 30191: @2251607
     /* 2251607 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2251655), // Rule ID 48628 //
     /* 2251612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251625 */   // MIs[0] Operand 1
     /* 2251625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251638 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251645 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251654 */   // GIR_Coverage, 48628,
     /* 2251654 */   GIR_EraseRootFromParent_Done,
     /* 2251655 */ // Label 30192: @2251655
     /* 2251655 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2251703), // Rule ID 48629 //
     /* 2251660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251673 */   // MIs[0] Operand 1
     /* 2251673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251686 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2251689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251702 */   // GIR_Coverage, 48629,
     /* 2251702 */   GIR_EraseRootFromParent_Done,
     /* 2251703 */ // Label 30193: @2251703
     /* 2251703 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2251751), // Rule ID 48636 //
     /* 2251708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251721 */   // MIs[0] Operand 1
     /* 2251721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251734 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2251737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251741 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251750 */   // GIR_Coverage, 48636,
     /* 2251750 */   GIR_EraseRootFromParent_Done,
     /* 2251751 */ // Label 30194: @2251751
     /* 2251751 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2251799), // Rule ID 48637 //
     /* 2251756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2251762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2251765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251769 */   // MIs[0] Operand 1
     /* 2251769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251782 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2251785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251787 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251789 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251798 */   // GIR_Coverage, 48637,
     /* 2251798 */   GIR_EraseRootFromParent_Done,
     /* 2251799 */ // Label 30195: @2251799
     /* 2251799 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2251847), // Rule ID 48644 //
     /* 2251804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251817 */   // MIs[0] Operand 1
     /* 2251817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251830 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251835 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251837 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251846 */   // GIR_Coverage, 48644,
     /* 2251846 */   GIR_EraseRootFromParent_Done,
     /* 2251847 */ // Label 30196: @2251847
     /* 2251847 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2251895), // Rule ID 48645 //
     /* 2251852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2251858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2251861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251865 */   // MIs[0] Operand 1
     /* 2251865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251878 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251883 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251885 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251894 */   // GIR_Coverage, 48645,
     /* 2251894 */   GIR_EraseRootFromParent_Done,
     /* 2251895 */ // Label 30197: @2251895
     /* 2251895 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2251943), // Rule ID 48672 //
     /* 2251900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251913 */   // MIs[0] Operand 1
     /* 2251913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251926 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251942 */   // GIR_Coverage, 48672,
     /* 2251942 */   GIR_EraseRootFromParent_Done,
     /* 2251943 */ // Label 30198: @2251943
     /* 2251943 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2251991), // Rule ID 48673 //
     /* 2251948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2251954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2251957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251961 */   // MIs[0] Operand 1
     /* 2251961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251974 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251990 */   // GIR_Coverage, 48673,
     /* 2251990 */   GIR_EraseRootFromParent_Done,
     /* 2251991 */ // Label 30199: @2251991
     /* 2251991 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2252039), // Rule ID 48680 //
     /* 2251996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252009 */   // MIs[0] Operand 1
     /* 2252009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2252014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252022 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2252025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252038 */   // GIR_Coverage, 48680,
     /* 2252038 */   GIR_EraseRootFromParent_Done,
     /* 2252039 */ // Label 30200: @2252039
     /* 2252039 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2252087), // Rule ID 48681 //
     /* 2252044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252057 */   // MIs[0] Operand 1
     /* 2252057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2252062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252070 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2252073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252086 */   // GIR_Coverage, 48681,
     /* 2252086 */   GIR_EraseRootFromParent_Done,
     /* 2252087 */ // Label 30201: @2252087
     /* 2252087 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2252135), // Rule ID 48688 //
     /* 2252092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252105 */   // MIs[0] Operand 1
     /* 2252105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2252110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252118 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2252121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252125 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252134 */   // GIR_Coverage, 48688,
     /* 2252134 */   GIR_EraseRootFromParent_Done,
     /* 2252135 */ // Label 30202: @2252135
     /* 2252135 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2252183), // Rule ID 48689 //
     /* 2252140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252153 */   // MIs[0] Operand 1
     /* 2252153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2252158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252166 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2252169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252182 */   // GIR_Coverage, 48689,
     /* 2252182 */   GIR_EraseRootFromParent_Done,
     /* 2252183 */ // Label 30203: @2252183
     /* 2252183 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2252231), // Rule ID 48716 //
     /* 2252188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252201 */   // MIs[0] Operand 1
     /* 2252201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252214 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2252217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252230 */   // GIR_Coverage, 48716,
     /* 2252230 */   GIR_EraseRootFromParent_Done,
     /* 2252231 */ // Label 30204: @2252231
     /* 2252231 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2252279), // Rule ID 48717 //
     /* 2252236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252249 */   // MIs[0] Operand 1
     /* 2252249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252262 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2252265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252278 */   // GIR_Coverage, 48717,
     /* 2252278 */   GIR_EraseRootFromParent_Done,
     /* 2252279 */ // Label 30205: @2252279
     /* 2252279 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2252327), // Rule ID 48724 //
     /* 2252284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252297 */   // MIs[0] Operand 1
     /* 2252297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252310 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2252313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252317 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252326 */   // GIR_Coverage, 48724,
     /* 2252326 */   GIR_EraseRootFromParent_Done,
     /* 2252327 */ // Label 30206: @2252327
     /* 2252327 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2252375), // Rule ID 48725 //
     /* 2252332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252345 */   // MIs[0] Operand 1
     /* 2252345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252358 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2252361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252365 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252374 */   // GIR_Coverage, 48725,
     /* 2252374 */   GIR_EraseRootFromParent_Done,
     /* 2252375 */ // Label 30207: @2252375
     /* 2252375 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2252423), // Rule ID 48732 //
     /* 2252380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252393 */   // MIs[0] Operand 1
     /* 2252393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252406 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2252409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252422 */   // GIR_Coverage, 48732,
     /* 2252422 */   GIR_EraseRootFromParent_Done,
     /* 2252423 */ // Label 30208: @2252423
     /* 2252423 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2252471), // Rule ID 48733 //
     /* 2252428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252441 */   // MIs[0] Operand 1
     /* 2252441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2252446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252454 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2252457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252470 */   // GIR_Coverage, 48733,
     /* 2252470 */   GIR_EraseRootFromParent_Done,
     /* 2252471 */ // Label 30209: @2252471
     /* 2252471 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2252519), // Rule ID 48760 //
     /* 2252476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252489 */   // MIs[0] Operand 1
     /* 2252489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252502 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252507 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252518 */   // GIR_Coverage, 48760,
     /* 2252518 */   GIR_EraseRootFromParent_Done,
     /* 2252519 */ // Label 30210: @2252519
     /* 2252519 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2252567), // Rule ID 48761 //
     /* 2252524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252537 */   // MIs[0] Operand 1
     /* 2252537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252550 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252566 */   // GIR_Coverage, 48761,
     /* 2252566 */   GIR_EraseRootFromParent_Done,
     /* 2252567 */ // Label 30211: @2252567
     /* 2252567 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2252615), // Rule ID 48768 //
     /* 2252572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252585 */   // MIs[0] Operand 1
     /* 2252585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252598 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2252601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252614 */   // GIR_Coverage, 48768,
     /* 2252614 */   GIR_EraseRootFromParent_Done,
     /* 2252615 */ // Label 30212: @2252615
     /* 2252615 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2252663), // Rule ID 48769 //
     /* 2252620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252633 */   // MIs[0] Operand 1
     /* 2252633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252646 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2252649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252662 */   // GIR_Coverage, 48769,
     /* 2252662 */   GIR_EraseRootFromParent_Done,
     /* 2252663 */ // Label 30213: @2252663
     /* 2252663 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2252711), // Rule ID 48776 //
     /* 2252668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252681 */   // MIs[0] Operand 1
     /* 2252681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252694 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2252697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252701 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252710 */   // GIR_Coverage, 48776,
     /* 2252710 */   GIR_EraseRootFromParent_Done,
     /* 2252711 */ // Label 30214: @2252711
     /* 2252711 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2252759), // Rule ID 48777 //
     /* 2252716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252729 */   // MIs[0] Operand 1
     /* 2252729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2252734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252742 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2252745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252758 */   // GIR_Coverage, 48777,
     /* 2252758 */   GIR_EraseRootFromParent_Done,
     /* 2252759 */ // Label 30215: @2252759
     /* 2252759 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2252807), // Rule ID 48804 //
     /* 2252764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252777 */   // MIs[0] Operand 1
     /* 2252777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252790 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252795 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252797 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252806 */   // GIR_Coverage, 48804,
     /* 2252806 */   GIR_EraseRootFromParent_Done,
     /* 2252807 */ // Label 30216: @2252807
     /* 2252807 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2252855), // Rule ID 48805 //
     /* 2252812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2252818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2252821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252825 */   // MIs[0] Operand 1
     /* 2252825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252838 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2252841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252843 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252845 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252854 */   // GIR_Coverage, 48805,
     /* 2252854 */   GIR_EraseRootFromParent_Done,
     /* 2252855 */ // Label 30217: @2252855
     /* 2252855 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2252903), // Rule ID 48812 //
     /* 2252860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252873 */   // MIs[0] Operand 1
     /* 2252873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252886 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2252889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252902 */   // GIR_Coverage, 48812,
     /* 2252902 */   GIR_EraseRootFromParent_Done,
     /* 2252903 */ // Label 30218: @2252903
     /* 2252903 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2252951), // Rule ID 48813 //
     /* 2252908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2252914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2252917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252921 */   // MIs[0] Operand 1
     /* 2252921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2252934 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2252937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252950 */   // GIR_Coverage, 48813,
     /* 2252950 */   GIR_EraseRootFromParent_Done,
     /* 2252951 */ // Label 30219: @2252951
     /* 2252951 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2252999), // Rule ID 48820 //
     /* 2252956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2252962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2252965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252969 */   // MIs[0] Operand 1
     /* 2252969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2252974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2252982 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2252985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252998 */   // GIR_Coverage, 48820,
     /* 2252998 */   GIR_EraseRootFromParent_Done,
     /* 2252999 */ // Label 30220: @2252999
     /* 2252999 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2253047), // Rule ID 48821 //
     /* 2253004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2253010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2253013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253017 */   // MIs[0] Operand 1
     /* 2253017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2253022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253030 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2253033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253046 */   // GIR_Coverage, 48821,
     /* 2253046 */   GIR_EraseRootFromParent_Done,
     /* 2253047 */ // Label 30221: @2253047
     /* 2253047 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2253095), // Rule ID 48848 //
     /* 2253052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2253058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2253061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253065 */   // MIs[0] Operand 1
     /* 2253065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253078 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253085 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253094 */   // GIR_Coverage, 48848,
     /* 2253094 */   GIR_EraseRootFromParent_Done,
     /* 2253095 */ // Label 30222: @2253095
     /* 2253095 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2253143), // Rule ID 48849 //
     /* 2253100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2253106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2253109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253113 */   // MIs[0] Operand 1
     /* 2253113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253126 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253131 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253142 */   // GIR_Coverage, 48849,
     /* 2253142 */   GIR_EraseRootFromParent_Done,
     /* 2253143 */ // Label 30223: @2253143
     /* 2253143 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2253191), // Rule ID 48856 //
     /* 2253148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2253154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2253157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253161 */   // MIs[0] Operand 1
     /* 2253161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253174 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2253177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253179 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253181 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253190 */   // GIR_Coverage, 48856,
     /* 2253190 */   GIR_EraseRootFromParent_Done,
     /* 2253191 */ // Label 30224: @2253191
     /* 2253191 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2253239), // Rule ID 48857 //
     /* 2253196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2253202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2253205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253209 */   // MIs[0] Operand 1
     /* 2253209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253222 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2253225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253229 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253238 */   // GIR_Coverage, 48857,
     /* 2253238 */   GIR_EraseRootFromParent_Done,
     /* 2253239 */ // Label 30225: @2253239
     /* 2253239 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2253287), // Rule ID 48864 //
     /* 2253244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2253250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2253253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253257 */   // MIs[0] Operand 1
     /* 2253257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253270 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2253273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253286 */   // GIR_Coverage, 48864,
     /* 2253286 */   GIR_EraseRootFromParent_Done,
     /* 2253287 */ // Label 30226: @2253287
     /* 2253287 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2253335), // Rule ID 48865 //
     /* 2253292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2253298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2253301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253305 */   // MIs[0] Operand 1
     /* 2253305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2253310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253318 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2253321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253334 */   // GIR_Coverage, 48865,
     /* 2253334 */   GIR_EraseRootFromParent_Done,
     /* 2253335 */ // Label 30227: @2253335
     /* 2253335 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2253383), // Rule ID 48892 //
     /* 2253340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2253346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2253349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253353 */   // MIs[0] Operand 1
     /* 2253353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253366 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253373 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253382 */   // GIR_Coverage, 48892,
     /* 2253382 */   GIR_EraseRootFromParent_Done,
     /* 2253383 */ // Label 30228: @2253383
     /* 2253383 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2253431), // Rule ID 48893 //
     /* 2253388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2253394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2253397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253401 */   // MIs[0] Operand 1
     /* 2253401 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253410 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253414 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2253417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253421 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253430 */   // GIR_Coverage, 48893,
     /* 2253430 */   GIR_EraseRootFromParent_Done,
     /* 2253431 */ // Label 30229: @2253431
     /* 2253431 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2253479), // Rule ID 48900 //
     /* 2253436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2253442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2253445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253449 */   // MIs[0] Operand 1
     /* 2253449 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253462 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2253465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253469 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253478 */   // GIR_Coverage, 48900,
     /* 2253478 */   GIR_EraseRootFromParent_Done,
     /* 2253479 */ // Label 30230: @2253479
     /* 2253479 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2253527), // Rule ID 48901 //
     /* 2253484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2253490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2253493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253497 */   // MIs[0] Operand 1
     /* 2253497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253510 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2253513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253517 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253526 */   // GIR_Coverage, 48901,
     /* 2253526 */   GIR_EraseRootFromParent_Done,
     /* 2253527 */ // Label 30231: @2253527
     /* 2253527 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2253575), // Rule ID 48908 //
     /* 2253532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2253538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2253541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253545 */   // MIs[0] Operand 1
     /* 2253545 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253558 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2253561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253565 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253574 */   // GIR_Coverage, 48908,
     /* 2253574 */   GIR_EraseRootFromParent_Done,
     /* 2253575 */ // Label 30232: @2253575
     /* 2253575 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2253623), // Rule ID 48909 //
     /* 2253580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2253586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2253589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253593 */   // MIs[0] Operand 1
     /* 2253593 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2253598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253602 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253606 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2253609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253611 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253622 */   // GIR_Coverage, 48909,
     /* 2253622 */   GIR_EraseRootFromParent_Done,
     /* 2253623 */ // Label 30233: @2253623
     /* 2253623 */ GIM_Reject,
     /* 2253624 */ // Label 29757: @2253624
     /* 2253624 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2253672), // Rule ID 48500 //
     /* 2253629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2253635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2253638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253642 */   // MIs[0] Operand 1
     /* 2253642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253655 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253671 */   // GIR_Coverage, 48500,
     /* 2253671 */   GIR_EraseRootFromParent_Done,
     /* 2253672 */ // Label 30234: @2253672
     /* 2253672 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2253720), // Rule ID 48501 //
     /* 2253677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2253683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2253686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253690 */   // MIs[0] Operand 1
     /* 2253690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253703 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253719 */   // GIR_Coverage, 48501,
     /* 2253719 */   GIR_EraseRootFromParent_Done,
     /* 2253720 */ // Label 30235: @2253720
     /* 2253720 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2253768), // Rule ID 48508 //
     /* 2253725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2253731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2253734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253738 */   // MIs[0] Operand 1
     /* 2253738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253751 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2253754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253767 */   // GIR_Coverage, 48508,
     /* 2253767 */   GIR_EraseRootFromParent_Done,
     /* 2253768 */ // Label 30236: @2253768
     /* 2253768 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2253816), // Rule ID 48509 //
     /* 2253773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2253779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2253782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253786 */   // MIs[0] Operand 1
     /* 2253786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253799 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2253802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253815 */   // GIR_Coverage, 48509,
     /* 2253815 */   GIR_EraseRootFromParent_Done,
     /* 2253816 */ // Label 30237: @2253816
     /* 2253816 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2253864), // Rule ID 48544 //
     /* 2253821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2253827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2253830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253834 */   // MIs[0] Operand 1
     /* 2253834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253847 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253863 */   // GIR_Coverage, 48544,
     /* 2253863 */   GIR_EraseRootFromParent_Done,
     /* 2253864 */ // Label 30238: @2253864
     /* 2253864 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2253912), // Rule ID 48545 //
     /* 2253869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2253875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2253878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253882 */   // MIs[0] Operand 1
     /* 2253882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253895 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253900 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253911 */   // GIR_Coverage, 48545,
     /* 2253911 */   GIR_EraseRootFromParent_Done,
     /* 2253912 */ // Label 30239: @2253912
     /* 2253912 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2253960), // Rule ID 48552 //
     /* 2253917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2253923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2253926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253930 */   // MIs[0] Operand 1
     /* 2253930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253943 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2253946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253948 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253950 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253959 */   // GIR_Coverage, 48552,
     /* 2253959 */   GIR_EraseRootFromParent_Done,
     /* 2253960 */ // Label 30240: @2253960
     /* 2253960 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2254008), // Rule ID 48553 //
     /* 2253965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2253971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2253974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253978 */   // MIs[0] Operand 1
     /* 2253978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2253991 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2253994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254007 */   // GIR_Coverage, 48553,
     /* 2254007 */   GIR_EraseRootFromParent_Done,
     /* 2254008 */ // Label 30241: @2254008
     /* 2254008 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2254056), // Rule ID 48588 //
     /* 2254013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254026 */   // MIs[0] Operand 1
     /* 2254026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254039 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254055 */   // GIR_Coverage, 48588,
     /* 2254055 */   GIR_EraseRootFromParent_Done,
     /* 2254056 */ // Label 30242: @2254056
     /* 2254056 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2254104), // Rule ID 48589 //
     /* 2254061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254074 */   // MIs[0] Operand 1
     /* 2254074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254087 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254103 */   // GIR_Coverage, 48589,
     /* 2254103 */   GIR_EraseRootFromParent_Done,
     /* 2254104 */ // Label 30243: @2254104
     /* 2254104 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2254152), // Rule ID 48596 //
     /* 2254109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254122 */   // MIs[0] Operand 1
     /* 2254122 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254131 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254135 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2254138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254142 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254151 */   // GIR_Coverage, 48596,
     /* 2254151 */   GIR_EraseRootFromParent_Done,
     /* 2254152 */ // Label 30244: @2254152
     /* 2254152 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2254200), // Rule ID 48597 //
     /* 2254157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254170 */   // MIs[0] Operand 1
     /* 2254170 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2254175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254179 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254183 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2254186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254190 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254199 */   // GIR_Coverage, 48597,
     /* 2254199 */   GIR_EraseRootFromParent_Done,
     /* 2254200 */ // Label 30245: @2254200
     /* 2254200 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2254248), // Rule ID 48630 //
     /* 2254205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254218 */   // MIs[0] Operand 1
     /* 2254218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254227 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254231 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254236 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254238 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254247 */   // GIR_Coverage, 48630,
     /* 2254247 */   GIR_EraseRootFromParent_Done,
     /* 2254248 */ // Label 30246: @2254248
     /* 2254248 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2254296), // Rule ID 48631 //
     /* 2254253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254266 */   // MIs[0] Operand 1
     /* 2254266 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254279 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254284 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254286 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254295 */   // GIR_Coverage, 48631,
     /* 2254295 */   GIR_EraseRootFromParent_Done,
     /* 2254296 */ // Label 30247: @2254296
     /* 2254296 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2254344), // Rule ID 48638 //
     /* 2254301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254314 */   // MIs[0] Operand 1
     /* 2254314 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254323 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254327 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2254330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254334 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254343 */   // GIR_Coverage, 48638,
     /* 2254343 */   GIR_EraseRootFromParent_Done,
     /* 2254344 */ // Label 30248: @2254344
     /* 2254344 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2254392), // Rule ID 48639 //
     /* 2254349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254362 */   // MIs[0] Operand 1
     /* 2254362 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254371 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254375 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2254378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254382 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254391 */   // GIR_Coverage, 48639,
     /* 2254391 */   GIR_EraseRootFromParent_Done,
     /* 2254392 */ // Label 30249: @2254392
     /* 2254392 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2254440), // Rule ID 48674 //
     /* 2254397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254410 */   // MIs[0] Operand 1
     /* 2254410 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254419 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254423 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254430 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254439 */   // GIR_Coverage, 48674,
     /* 2254439 */   GIR_EraseRootFromParent_Done,
     /* 2254440 */ // Label 30250: @2254440
     /* 2254440 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2254488), // Rule ID 48675 //
     /* 2254445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254451 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254458 */   // MIs[0] Operand 1
     /* 2254458 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254467 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254471 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254476 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254478 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254487 */   // GIR_Coverage, 48675,
     /* 2254487 */   GIR_EraseRootFromParent_Done,
     /* 2254488 */ // Label 30251: @2254488
     /* 2254488 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2254536), // Rule ID 48682 //
     /* 2254493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254506 */   // MIs[0] Operand 1
     /* 2254506 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254515 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254519 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2254522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254524 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254526 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254534 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254535 */   // GIR_Coverage, 48682,
     /* 2254535 */   GIR_EraseRootFromParent_Done,
     /* 2254536 */ // Label 30252: @2254536
     /* 2254536 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2254584), // Rule ID 48683 //
     /* 2254541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254554 */   // MIs[0] Operand 1
     /* 2254554 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254563 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254567 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2254570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254572 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254574 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254583 */   // GIR_Coverage, 48683,
     /* 2254583 */   GIR_EraseRootFromParent_Done,
     /* 2254584 */ // Label 30253: @2254584
     /* 2254584 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2254632), // Rule ID 48718 //
     /* 2254589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254602 */   // MIs[0] Operand 1
     /* 2254602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254615 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254631 */   // GIR_Coverage, 48718,
     /* 2254631 */   GIR_EraseRootFromParent_Done,
     /* 2254632 */ // Label 30254: @2254632
     /* 2254632 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2254680), // Rule ID 48719 //
     /* 2254637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254650 */   // MIs[0] Operand 1
     /* 2254650 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254663 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254670 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254679 */   // GIR_Coverage, 48719,
     /* 2254679 */   GIR_EraseRootFromParent_Done,
     /* 2254680 */ // Label 30255: @2254680
     /* 2254680 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2254728), // Rule ID 48726 //
     /* 2254685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254698 */   // MIs[0] Operand 1
     /* 2254698 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254711 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2254714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254718 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254727 */   // GIR_Coverage, 48726,
     /* 2254727 */   GIR_EraseRootFromParent_Done,
     /* 2254728 */ // Label 30256: @2254728
     /* 2254728 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2254776), // Rule ID 48727 //
     /* 2254733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254746 */   // MIs[0] Operand 1
     /* 2254746 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254759 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2254762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254766 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254775 */   // GIR_Coverage, 48727,
     /* 2254775 */   GIR_EraseRootFromParent_Done,
     /* 2254776 */ // Label 30257: @2254776
     /* 2254776 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2254824), // Rule ID 48762 //
     /* 2254781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254794 */   // MIs[0] Operand 1
     /* 2254794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2254799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254807 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2254810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254812 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254814 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254823 */   // GIR_Coverage, 48762,
     /* 2254823 */   GIR_EraseRootFromParent_Done,
     /* 2254824 */ // Label 30258: @2254824
     /* 2254824 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2254872), // Rule ID 48763 //
     /* 2254829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254842 */   // MIs[0] Operand 1
     /* 2254842 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2254847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254855 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2254858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254862 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254871 */   // GIR_Coverage, 48763,
     /* 2254871 */   GIR_EraseRootFromParent_Done,
     /* 2254872 */ // Label 30259: @2254872
     /* 2254872 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2254920), // Rule ID 48770 //
     /* 2254877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254890 */   // MIs[0] Operand 1
     /* 2254890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2254895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254903 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2254906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254919 */   // GIR_Coverage, 48770,
     /* 2254919 */   GIR_EraseRootFromParent_Done,
     /* 2254920 */ // Label 30260: @2254920
     /* 2254920 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2254968), // Rule ID 48771 //
     /* 2254925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2254931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2254934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254938 */   // MIs[0] Operand 1
     /* 2254938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2254943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2254951 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2254954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254958 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254967 */   // GIR_Coverage, 48771,
     /* 2254967 */   GIR_EraseRootFromParent_Done,
     /* 2254968 */ // Label 30261: @2254968
     /* 2254968 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2255016), // Rule ID 48806 //
     /* 2254973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2254979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2254982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254986 */   // MIs[0] Operand 1
     /* 2254986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2254991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254999 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255015 */   // GIR_Coverage, 48806,
     /* 2255015 */   GIR_EraseRootFromParent_Done,
     /* 2255016 */ // Label 30262: @2255016
     /* 2255016 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2255064), // Rule ID 48807 //
     /* 2255021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2255030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255034 */   // MIs[0] Operand 1
     /* 2255034 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255043 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255047 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255052 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255054 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255063 */   // GIR_Coverage, 48807,
     /* 2255063 */   GIR_EraseRootFromParent_Done,
     /* 2255064 */ // Label 30263: @2255064
     /* 2255064 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2255112), // Rule ID 48814 //
     /* 2255069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255082 */   // MIs[0] Operand 1
     /* 2255082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255095 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2255098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255100 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255102 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255111 */   // GIR_Coverage, 48814,
     /* 2255111 */   GIR_EraseRootFromParent_Done,
     /* 2255112 */ // Label 30264: @2255112
     /* 2255112 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2255160), // Rule ID 48815 //
     /* 2255117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255130 */   // MIs[0] Operand 1
     /* 2255130 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255143 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2255146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255148 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255159 */   // GIR_Coverage, 48815,
     /* 2255159 */   GIR_EraseRootFromParent_Done,
     /* 2255160 */ // Label 30265: @2255160
     /* 2255160 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2255208), // Rule ID 48850 //
     /* 2255165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2255174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255178 */   // MIs[0] Operand 1
     /* 2255178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255191 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2255194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255207 */   // GIR_Coverage, 48850,
     /* 2255207 */   GIR_EraseRootFromParent_Done,
     /* 2255208 */ // Label 30266: @2255208
     /* 2255208 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2255256), // Rule ID 48851 //
     /* 2255213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2255222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255226 */   // MIs[0] Operand 1
     /* 2255226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255239 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2255242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255255 */   // GIR_Coverage, 48851,
     /* 2255255 */   GIR_EraseRootFromParent_Done,
     /* 2255256 */ // Label 30267: @2255256
     /* 2255256 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2255304), // Rule ID 48858 //
     /* 2255261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255274 */   // MIs[0] Operand 1
     /* 2255274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255287 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2255290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255292 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255294 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255303 */   // GIR_Coverage, 48858,
     /* 2255303 */   GIR_EraseRootFromParent_Done,
     /* 2255304 */ // Label 30268: @2255304
     /* 2255304 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2255352), // Rule ID 48859 //
     /* 2255309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255322 */   // MIs[0] Operand 1
     /* 2255322 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255331 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255335 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2255338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255340 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255342 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255351 */   // GIR_Coverage, 48859,
     /* 2255351 */   GIR_EraseRootFromParent_Done,
     /* 2255352 */ // Label 30269: @2255352
     /* 2255352 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2255400), // Rule ID 48894 //
     /* 2255357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2255366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255370 */   // MIs[0] Operand 1
     /* 2255370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2255375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255379 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255383 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2255386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255399 */   // GIR_Coverage, 48894,
     /* 2255399 */   GIR_EraseRootFromParent_Done,
     /* 2255400 */ // Label 30270: @2255400
     /* 2255400 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2255448), // Rule ID 48895 //
     /* 2255405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2255411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2255414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255418 */   // MIs[0] Operand 1
     /* 2255418 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2255423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255431 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2255434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255447 */   // GIR_Coverage, 48895,
     /* 2255447 */   GIR_EraseRootFromParent_Done,
     /* 2255448 */ // Label 30271: @2255448
     /* 2255448 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2255496), // Rule ID 48902 //
     /* 2255453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255466 */   // MIs[0] Operand 1
     /* 2255466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2255471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255475 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255479 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2255482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255495 */   // GIR_Coverage, 48902,
     /* 2255495 */   GIR_EraseRootFromParent_Done,
     /* 2255496 */ // Label 30272: @2255496
     /* 2255496 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2255544), // Rule ID 48903 //
     /* 2255501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2255507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2255510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255514 */   // MIs[0] Operand 1
     /* 2255514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2255519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255527 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2255530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255543 */   // GIR_Coverage, 48903,
     /* 2255543 */   GIR_EraseRootFromParent_Done,
     /* 2255544 */ // Label 30273: @2255544
     /* 2255544 */ GIM_Reject,
     /* 2255545 */ // Label 29758: @2255545
     /* 2255545 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2256321),
     /* 2255550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2255553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2255556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255560 */   GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2255598), // Rule ID 48502 //
     /* 2255565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255568 */     // MIs[0] Operand 1
     /* 2255568 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2255573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255581 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2255584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255597 */     // GIR_Coverage, 48502,
     /* 2255597 */     GIR_EraseRootFromParent_Done,
     /* 2255598 */   // Label 30275: @2255598
     /* 2255598 */   GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2255636), // Rule ID 48503 //
     /* 2255603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255606 */     // MIs[0] Operand 1
     /* 2255606 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2255611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255619 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2255622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255635 */     // GIR_Coverage, 48503,
     /* 2255635 */     GIR_EraseRootFromParent_Done,
     /* 2255636 */   // Label 30276: @2255636
     /* 2255636 */   GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2255674), // Rule ID 48546 //
     /* 2255641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255644 */     // MIs[0] Operand 1
     /* 2255644 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2255649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255657 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2255660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255673 */     // GIR_Coverage, 48546,
     /* 2255673 */     GIR_EraseRootFromParent_Done,
     /* 2255674 */   // Label 30277: @2255674
     /* 2255674 */   GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2255712), // Rule ID 48547 //
     /* 2255679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255682 */     // MIs[0] Operand 1
     /* 2255682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2255687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255695 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2255698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255711 */     // GIR_Coverage, 48547,
     /* 2255711 */     GIR_EraseRootFromParent_Done,
     /* 2255712 */   // Label 30278: @2255712
     /* 2255712 */   GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2255750), // Rule ID 48590 //
     /* 2255717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255720 */     // MIs[0] Operand 1
     /* 2255720 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2255725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255733 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2255736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255749 */     // GIR_Coverage, 48590,
     /* 2255749 */     GIR_EraseRootFromParent_Done,
     /* 2255750 */   // Label 30279: @2255750
     /* 2255750 */   GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2255788), // Rule ID 48591 //
     /* 2255755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255758 */     // MIs[0] Operand 1
     /* 2255758 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2255763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255771 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2255774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255787 */     // GIR_Coverage, 48591,
     /* 2255787 */     GIR_EraseRootFromParent_Done,
     /* 2255788 */   // Label 30280: @2255788
     /* 2255788 */   GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2255826), // Rule ID 48632 //
     /* 2255793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255796 */     // MIs[0] Operand 1
     /* 2255796 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255809 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2255812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255825 */     // GIR_Coverage, 48632,
     /* 2255825 */     GIR_EraseRootFromParent_Done,
     /* 2255826 */   // Label 30281: @2255826
     /* 2255826 */   GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2255864), // Rule ID 48633 //
     /* 2255831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255834 */     // MIs[0] Operand 1
     /* 2255834 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2255839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255847 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2255850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255863 */     // GIR_Coverage, 48633,
     /* 2255863 */     GIR_EraseRootFromParent_Done,
     /* 2255864 */   // Label 30282: @2255864
     /* 2255864 */   GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2255902), // Rule ID 48676 //
     /* 2255869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255872 */     // MIs[0] Operand 1
     /* 2255872 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255885 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2255888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255901 */     // GIR_Coverage, 48676,
     /* 2255901 */     GIR_EraseRootFromParent_Done,
     /* 2255902 */   // Label 30283: @2255902
     /* 2255902 */   GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2255940), // Rule ID 48677 //
     /* 2255907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255910 */     // MIs[0] Operand 1
     /* 2255910 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2255915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255923 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2255926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255939 */     // GIR_Coverage, 48677,
     /* 2255939 */     GIR_EraseRootFromParent_Done,
     /* 2255940 */   // Label 30284: @2255940
     /* 2255940 */   GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2255978), // Rule ID 48720 //
     /* 2255945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255948 */     // MIs[0] Operand 1
     /* 2255948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255961 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2255964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2255977 */     // GIR_Coverage, 48720,
     /* 2255977 */     GIR_EraseRootFromParent_Done,
     /* 2255978 */   // Label 30285: @2255978
     /* 2255978 */   GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2256016), // Rule ID 48721 //
     /* 2255983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255986 */     // MIs[0] Operand 1
     /* 2255986 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2255991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2255999 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2256002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256015 */     // GIR_Coverage, 48721,
     /* 2256015 */     GIR_EraseRootFromParent_Done,
     /* 2256016 */   // Label 30286: @2256016
     /* 2256016 */   GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2256054), // Rule ID 48764 //
     /* 2256021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256024 */     // MIs[0] Operand 1
     /* 2256024 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256037 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2256040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256053 */     // GIR_Coverage, 48764,
     /* 2256053 */     GIR_EraseRootFromParent_Done,
     /* 2256054 */   // Label 30287: @2256054
     /* 2256054 */   GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2256092), // Rule ID 48765 //
     /* 2256059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256062 */     // MIs[0] Operand 1
     /* 2256062 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2256067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256075 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2256078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256091 */     // GIR_Coverage, 48765,
     /* 2256091 */     GIR_EraseRootFromParent_Done,
     /* 2256092 */   // Label 30288: @2256092
     /* 2256092 */   GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2256130), // Rule ID 48808 //
     /* 2256097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256100 */     // MIs[0] Operand 1
     /* 2256100 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256113 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2256116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256129 */     // GIR_Coverage, 48808,
     /* 2256129 */     GIR_EraseRootFromParent_Done,
     /* 2256130 */   // Label 30289: @2256130
     /* 2256130 */   GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2256168), // Rule ID 48809 //
     /* 2256135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256138 */     // MIs[0] Operand 1
     /* 2256138 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2256143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256151 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2256154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256167 */     // GIR_Coverage, 48809,
     /* 2256167 */     GIR_EraseRootFromParent_Done,
     /* 2256168 */   // Label 30290: @2256168
     /* 2256168 */   GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2256206), // Rule ID 48852 //
     /* 2256173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256176 */     // MIs[0] Operand 1
     /* 2256176 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256189 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2256192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256205 */     // GIR_Coverage, 48852,
     /* 2256205 */     GIR_EraseRootFromParent_Done,
     /* 2256206 */   // Label 30291: @2256206
     /* 2256206 */   GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2256244), // Rule ID 48853 //
     /* 2256211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256214 */     // MIs[0] Operand 1
     /* 2256214 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256227 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2256230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256243 */     // GIR_Coverage, 48853,
     /* 2256243 */     GIR_EraseRootFromParent_Done,
     /* 2256244 */   // Label 30292: @2256244
     /* 2256244 */   GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2256282), // Rule ID 48896 //
     /* 2256249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256252 */     // MIs[0] Operand 1
     /* 2256252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256265 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2256268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256281 */     // GIR_Coverage, 48896,
     /* 2256281 */     GIR_EraseRootFromParent_Done,
     /* 2256282 */   // Label 30293: @2256282
     /* 2256282 */   GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2256320), // Rule ID 48897 //
     /* 2256287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256290 */     // MIs[0] Operand 1
     /* 2256290 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256303 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2256306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2256319 */     // GIR_Coverage, 48897,
     /* 2256319 */     GIR_EraseRootFromParent_Done,
     /* 2256320 */   // Label 30294: @2256320
     /* 2256320 */   GIM_Reject,
     /* 2256321 */ // Label 30274: @2256321
     /* 2256321 */ GIM_Reject,
     /* 2256322 */ // Label 29759: @2256322
     /* 2256322 */ GIM_Reject,
     /* 2256323 */ // Label 49: @2256323
     /* 2256323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30303*/ GIMT_Encode4(2263784),
     /* 2256334 */ /*GILLT_s32*//*Label 30295*/ GIMT_Encode4(2256442),
     /* 2256338 */ /*GILLT_s64*//*Label 30296*/ GIMT_Encode4(2257199),
     /* 2256342 */ /*GILLT_nxv1s1*//*Label 30297*/ GIMT_Encode4(2258082), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2256362 */ /*GILLT_nxv2s1*//*Label 30298*/ GIMT_Encode4(2259235), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2256382 */ /*GILLT_nxv4s1*//*Label 30299*/ GIMT_Encode4(2260388), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2256402 */ /*GILLT_nxv8s1*//*Label 30300*/ GIMT_Encode4(2261541), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2256422 */ /*GILLT_nxv16s1*//*Label 30301*/ GIMT_Encode4(2262694), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2256438 */ /*GILLT_nxv32s1*//*Label 30302*/ GIMT_Encode4(2263463),
     /* 2256442 */ // Label 30295: @2256442
     /* 2256442 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2256484), // Rule ID 1354 //
     /* 2256447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2256450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256460 */   // MIs[0] Operand 1
     /* 2256460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256469 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256473 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2256476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256478 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256480 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256483 */   // GIR_Coverage, 1354,
     /* 2256483 */   GIR_EraseRootFromParent_Done,
     /* 2256484 */ // Label 30304: @2256484
     /* 2256484 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2256526), // Rule ID 1358 //
     /* 2256489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2256492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256502 */   // MIs[0] Operand 1
     /* 2256502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256515 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2256518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256525 */   // GIR_Coverage, 1358,
     /* 2256525 */   GIR_EraseRootFromParent_Done,
     /* 2256526 */ // Label 30305: @2256526
     /* 2256526 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2256568), // Rule ID 1402 //
     /* 2256531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2256534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256544 */   // MIs[0] Operand 1
     /* 2256544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256557 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2256560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256562 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256564 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256567 */   // GIR_Coverage, 1402,
     /* 2256567 */   GIR_EraseRootFromParent_Done,
     /* 2256568 */ // Label 30306: @2256568
     /* 2256568 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2256610), // Rule ID 1406 //
     /* 2256573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2256576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256586 */   // MIs[0] Operand 1
     /* 2256586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256599 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2256602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256604 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256606 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256609 */   // GIR_Coverage, 1406,
     /* 2256609 */   GIR_EraseRootFromParent_Done,
     /* 2256610 */ // Label 30307: @2256610
     /* 2256610 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2256652), // Rule ID 1418 //
     /* 2256615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2256618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256628 */   // MIs[0] Operand 1
     /* 2256628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2256641 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2256644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256646 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256648 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256650 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256651 */   // GIR_Coverage, 1418,
     /* 2256651 */   GIR_EraseRootFromParent_Done,
     /* 2256652 */ // Label 30308: @2256652
     /* 2256652 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2256694), // Rule ID 1422 //
     /* 2256657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2256660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2256663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2256666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256670 */   // MIs[0] Operand 1
     /* 2256670 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2256683 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2256683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2256686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256693 */   // GIR_Coverage, 1422,
     /* 2256693 */   GIR_EraseRootFromParent_Done,
     /* 2256694 */ // Label 30309: @2256694
     /* 2256694 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2256736), // Rule ID 1734 //
     /* 2256699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2256702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256712 */   // MIs[0] Operand 1
     /* 2256712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256725 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2256728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256735 */   // GIR_Coverage, 1734,
     /* 2256735 */   GIR_EraseRootFromParent_Done,
     /* 2256736 */ // Label 30310: @2256736
     /* 2256736 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2256778), // Rule ID 1738 //
     /* 2256741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2256744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256754 */   // MIs[0] Operand 1
     /* 2256754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256767 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2256770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256774 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256777 */   // GIR_Coverage, 1738,
     /* 2256777 */   GIR_EraseRootFromParent_Done,
     /* 2256778 */ // Label 30311: @2256778
     /* 2256778 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2256820), // Rule ID 1776 //
     /* 2256783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2256786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256796 */   // MIs[0] Operand 1
     /* 2256796 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256809 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2256812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256814 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256816 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256819 */   // GIR_Coverage, 1776,
     /* 2256819 */   GIR_EraseRootFromParent_Done,
     /* 2256820 */ // Label 30312: @2256820
     /* 2256820 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2256862), // Rule ID 1784 //
     /* 2256825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2256828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256838 */   // MIs[0] Operand 1
     /* 2256838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2256851 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2256854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256861 */   // GIR_Coverage, 1784,
     /* 2256861 */   GIR_EraseRootFromParent_Done,
     /* 2256862 */ // Label 30313: @2256862
     /* 2256862 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2256904), // Rule ID 1812 //
     /* 2256867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2256870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256880 */   // MIs[0] Operand 1
     /* 2256880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256893 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2256896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256903 */   // GIR_Coverage, 1812,
     /* 2256903 */   GIR_EraseRootFromParent_Done,
     /* 2256904 */ // Label 30314: @2256904
     /* 2256904 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2256946), // Rule ID 1820 //
     /* 2256909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2256912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2256915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2256918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256922 */   // MIs[0] Operand 1
     /* 2256922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2256935 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2256935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2256938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256945 */   // GIR_Coverage, 1820,
     /* 2256945 */   GIR_EraseRootFromParent_Done,
     /* 2256946 */ // Label 30315: @2256946
     /* 2256946 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2256988), // Rule ID 2071 //
     /* 2256951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2256954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2256957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2256960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2256964 */   // MIs[0] Operand 1
     /* 2256964 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2256973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2256977 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2256977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2256980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256982 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256984 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256987 */   // GIR_Coverage, 2071,
     /* 2256987 */   GIR_EraseRootFromParent_Done,
     /* 2256988 */ // Label 30316: @2256988
     /* 2256988 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2257030), // Rule ID 2075 //
     /* 2256993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2256996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2256999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257006 */   // MIs[0] Operand 1
     /* 2257006 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257015 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257019 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2257022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257026 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257029 */   // GIR_Coverage, 2075,
     /* 2257029 */   GIR_EraseRootFromParent_Done,
     /* 2257030 */ // Label 30317: @2257030
     /* 2257030 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2257072), // Rule ID 2119 //
     /* 2257035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2257038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257048 */   // MIs[0] Operand 1
     /* 2257048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257061 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2257064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257071 */   // GIR_Coverage, 2119,
     /* 2257071 */   GIR_EraseRootFromParent_Done,
     /* 2257072 */ // Label 30318: @2257072
     /* 2257072 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2257114), // Rule ID 2123 //
     /* 2257077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2257080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257090 */   // MIs[0] Operand 1
     /* 2257090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257103 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2257106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257108 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257110 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257113 */   // GIR_Coverage, 2123,
     /* 2257113 */   GIR_EraseRootFromParent_Done,
     /* 2257114 */ // Label 30319: @2257114
     /* 2257114 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2257156), // Rule ID 2135 //
     /* 2257119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2257122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257125 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257132 */   // MIs[0] Operand 1
     /* 2257132 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257141 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257145 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2257148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257150 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257152 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257155 */   // GIR_Coverage, 2135,
     /* 2257155 */   GIR_EraseRootFromParent_Done,
     /* 2257156 */ // Label 30320: @2257156
     /* 2257156 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2257198), // Rule ID 2139 //
     /* 2257161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2257164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257174 */   // MIs[0] Operand 1
     /* 2257174 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257183 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257187 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2257190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257192 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257197 */   // GIR_Coverage, 2139,
     /* 2257197 */   GIR_EraseRootFromParent_Done,
     /* 2257198 */ // Label 30321: @2257198
     /* 2257198 */ GIM_Reject,
     /* 2257199 */ // Label 30296: @2257199
     /* 2257199 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2257241), // Rule ID 1353 //
     /* 2257204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2257207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257217 */   // MIs[0] Operand 1
     /* 2257217 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257230 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2257233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257237 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257240 */   // GIR_Coverage, 1353,
     /* 2257240 */   GIR_EraseRootFromParent_Done,
     /* 2257241 */ // Label 30322: @2257241
     /* 2257241 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2257283), // Rule ID 1357 //
     /* 2257246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2257249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257259 */   // MIs[0] Operand 1
     /* 2257259 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257272 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2257275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257279 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257282 */   // GIR_Coverage, 1357,
     /* 2257282 */   GIR_EraseRootFromParent_Done,
     /* 2257283 */ // Label 30323: @2257283
     /* 2257283 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2257325), // Rule ID 1401 //
     /* 2257288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2257291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257301 */   // MIs[0] Operand 1
     /* 2257301 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257314 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2257317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257324 */   // GIR_Coverage, 1401,
     /* 2257324 */   GIR_EraseRootFromParent_Done,
     /* 2257325 */ // Label 30324: @2257325
     /* 2257325 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2257367), // Rule ID 1405 //
     /* 2257330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2257333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257343 */   // MIs[0] Operand 1
     /* 2257343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257356 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2257359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257366 */   // GIR_Coverage, 1405,
     /* 2257366 */   GIR_EraseRootFromParent_Done,
     /* 2257367 */ // Label 30325: @2257367
     /* 2257367 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2257409), // Rule ID 1417 //
     /* 2257372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2257375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257385 */   // MIs[0] Operand 1
     /* 2257385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2257398 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2257401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257408 */   // GIR_Coverage, 1417,
     /* 2257408 */   GIR_EraseRootFromParent_Done,
     /* 2257409 */ // Label 30326: @2257409
     /* 2257409 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2257451), // Rule ID 1421 //
     /* 2257414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2257417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2257420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2257423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257427 */   // MIs[0] Operand 1
     /* 2257427 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2257440 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2257440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2257443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257445 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257447 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257450 */   // GIR_Coverage, 1421,
     /* 2257450 */   GIR_EraseRootFromParent_Done,
     /* 2257451 */ // Label 30327: @2257451
     /* 2257451 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2257493), // Rule ID 1733 //
     /* 2257456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2257459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257469 */   // MIs[0] Operand 1
     /* 2257469 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257482 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2257485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257492 */   // GIR_Coverage, 1733,
     /* 2257492 */   GIR_EraseRootFromParent_Done,
     /* 2257493 */ // Label 30328: @2257493
     /* 2257493 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2257535), // Rule ID 1737 //
     /* 2257498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2257501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257511 */   // MIs[0] Operand 1
     /* 2257511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257524 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2257527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257534 */   // GIR_Coverage, 1737,
     /* 2257534 */   GIR_EraseRootFromParent_Done,
     /* 2257535 */ // Label 30329: @2257535
     /* 2257535 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2257577), // Rule ID 1740 //
     /* 2257540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2257543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257553 */   // MIs[0] Operand 1
     /* 2257553 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257566 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2257569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257571 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257573 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257576 */   // GIR_Coverage, 1740,
     /* 2257576 */   GIR_EraseRootFromParent_Done,
     /* 2257577 */ // Label 30330: @2257577
     /* 2257577 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2257619), // Rule ID 1775 //
     /* 2257582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2257585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257595 */   // MIs[0] Operand 1
     /* 2257595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257608 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2257611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257615 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257618 */   // GIR_Coverage, 1775,
     /* 2257618 */   GIR_EraseRootFromParent_Done,
     /* 2257619 */ // Label 30331: @2257619
     /* 2257619 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2257661), // Rule ID 1783 //
     /* 2257624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2257627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257637 */   // MIs[0] Operand 1
     /* 2257637 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257646 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2257650 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2257653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257655 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257660 */   // GIR_Coverage, 1783,
     /* 2257660 */   GIR_EraseRootFromParent_Done,
     /* 2257661 */ // Label 30332: @2257661
     /* 2257661 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2257703), // Rule ID 1792 //
     /* 2257666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2257669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257679 */   // MIs[0] Operand 1
     /* 2257679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257692 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2257695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257697 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257699 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257702 */   // GIR_Coverage, 1792,
     /* 2257702 */   GIR_EraseRootFromParent_Done,
     /* 2257703 */ // Label 30333: @2257703
     /* 2257703 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2257745), // Rule ID 1796 //
     /* 2257708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2257711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257721 */   // MIs[0] Operand 1
     /* 2257721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257734 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2257737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257744 */   // GIR_Coverage, 1796,
     /* 2257744 */   GIR_EraseRootFromParent_Done,
     /* 2257745 */ // Label 30334: @2257745
     /* 2257745 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2257787), // Rule ID 1811 //
     /* 2257750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2257753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257763 */   // MIs[0] Operand 1
     /* 2257763 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257772 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257776 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2257779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257781 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257783 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257786 */   // GIR_Coverage, 1811,
     /* 2257786 */   GIR_EraseRootFromParent_Done,
     /* 2257787 */ // Label 30335: @2257787
     /* 2257787 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2257829), // Rule ID 1819 //
     /* 2257792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2257795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2257798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2257801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257805 */   // MIs[0] Operand 1
     /* 2257805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257814 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2257818 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2257818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2257821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257823 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257825 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257828 */   // GIR_Coverage, 1819,
     /* 2257828 */   GIR_EraseRootFromParent_Done,
     /* 2257829 */ // Label 30336: @2257829
     /* 2257829 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2257871), // Rule ID 2070 //
     /* 2257834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2257837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257847 */   // MIs[0] Operand 1
     /* 2257847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257860 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2257863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257870 */   // GIR_Coverage, 2070,
     /* 2257870 */   GIR_EraseRootFromParent_Done,
     /* 2257871 */ // Label 30337: @2257871
     /* 2257871 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2257913), // Rule ID 2074 //
     /* 2257876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2257879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257889 */   // MIs[0] Operand 1
     /* 2257889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257902 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2257905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257912 */   // GIR_Coverage, 2074,
     /* 2257912 */   GIR_EraseRootFromParent_Done,
     /* 2257913 */ // Label 30338: @2257913
     /* 2257913 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2257955), // Rule ID 2118 //
     /* 2257918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2257921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257931 */   // MIs[0] Operand 1
     /* 2257931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2257944 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2257947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257954 */   // GIR_Coverage, 2118,
     /* 2257954 */   GIR_EraseRootFromParent_Done,
     /* 2257955 */ // Label 30339: @2257955
     /* 2257955 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2257997), // Rule ID 2122 //
     /* 2257960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2257963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2257966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2257969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2257973 */   // MIs[0] Operand 1
     /* 2257973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2257986 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2257986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2257989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257993 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257996 */   // GIR_Coverage, 2122,
     /* 2257996 */   GIR_EraseRootFromParent_Done,
     /* 2257997 */ // Label 30340: @2257997
     /* 2257997 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2258039), // Rule ID 2134 //
     /* 2258002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2258005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2258008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2258011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2258015 */   // MIs[0] Operand 1
     /* 2258015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2258024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2258028 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2258028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2258031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258033 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258038 */   // GIR_Coverage, 2134,
     /* 2258038 */   GIR_EraseRootFromParent_Done,
     /* 2258039 */ // Label 30341: @2258039
     /* 2258039 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2258081), // Rule ID 2138 //
     /* 2258044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2258047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2258050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2258053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2258057 */   // MIs[0] Operand 1
     /* 2258057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2258066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2258070 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2258070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2258073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258080 */   // GIR_Coverage, 2138,
     /* 2258080 */   GIR_EraseRootFromParent_Done,
     /* 2258081 */ // Label 30342: @2258081
     /* 2258081 */ GIM_Reject,
     /* 2258082 */ // Label 30297: @2258082
     /* 2258082 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2258130), // Rule ID 57022 //
     /* 2258087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258100 */   // MIs[0] Operand 1
     /* 2258100 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258113 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2258116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258118 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258120 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258129 */   // GIR_Coverage, 57022,
     /* 2258129 */   GIR_EraseRootFromParent_Done,
     /* 2258130 */ // Label 30343: @2258130
     /* 2258130 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2258178), // Rule ID 57023 //
     /* 2258135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258148 */   // MIs[0] Operand 1
     /* 2258148 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258157 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258161 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2258164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258166 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258168 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258177 */   // GIR_Coverage, 57023,
     /* 2258177 */   GIR_EraseRootFromParent_Done,
     /* 2258178 */ // Label 30344: @2258178
     /* 2258178 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2258226), // Rule ID 57042 //
     /* 2258183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258196 */   // MIs[0] Operand 1
     /* 2258196 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258209 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2258212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258214 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258216 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258225 */   // GIR_Coverage, 57042,
     /* 2258225 */   GIR_EraseRootFromParent_Done,
     /* 2258226 */ // Label 30345: @2258226
     /* 2258226 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2258274), // Rule ID 57043 //
     /* 2258231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258244 */   // MIs[0] Operand 1
     /* 2258244 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258253 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258257 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2258260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258262 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258264 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258273 */   // GIR_Coverage, 57043,
     /* 2258273 */   GIR_EraseRootFromParent_Done,
     /* 2258274 */ // Label 30346: @2258274
     /* 2258274 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2258322), // Rule ID 57072 //
     /* 2258279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2258282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258292 */   // MIs[0] Operand 1
     /* 2258292 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258301 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258305 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2258308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258310 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258312 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258321 */   // GIR_Coverage, 57072,
     /* 2258321 */   GIR_EraseRootFromParent_Done,
     /* 2258322 */ // Label 30347: @2258322
     /* 2258322 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2258370), // Rule ID 57073 //
     /* 2258327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2258330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258333 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258340 */   // MIs[0] Operand 1
     /* 2258340 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258353 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2258356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258358 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258360 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258369 */   // GIR_Coverage, 57073,
     /* 2258369 */   GIR_EraseRootFromParent_Done,
     /* 2258370 */ // Label 30348: @2258370
     /* 2258370 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2258418), // Rule ID 57322 //
     /* 2258375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258388 */   // MIs[0] Operand 1
     /* 2258388 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258397 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258401 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2258404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258406 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258408 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258417 */   // GIR_Coverage, 57322,
     /* 2258417 */   GIR_EraseRootFromParent_Done,
     /* 2258418 */ // Label 30349: @2258418
     /* 2258418 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2258466), // Rule ID 57323 //
     /* 2258423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258436 */   // MIs[0] Operand 1
     /* 2258436 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258449 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2258452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258454 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258465 */   // GIR_Coverage, 57323,
     /* 2258465 */   GIR_EraseRootFromParent_Done,
     /* 2258466 */ // Label 30350: @2258466
     /* 2258466 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2258514), // Rule ID 57342 //
     /* 2258471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258484 */   // MIs[0] Operand 1
     /* 2258484 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258493 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258497 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2258500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258502 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258504 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258513 */   // GIR_Coverage, 57342,
     /* 2258513 */   GIR_EraseRootFromParent_Done,
     /* 2258514 */ // Label 30351: @2258514
     /* 2258514 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2258562), // Rule ID 57343 //
     /* 2258519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258532 */   // MIs[0] Operand 1
     /* 2258532 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258541 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258545 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2258548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258550 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258561 */   // GIR_Coverage, 57343,
     /* 2258561 */   GIR_EraseRootFromParent_Done,
     /* 2258562 */ // Label 30352: @2258562
     /* 2258562 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2258610), // Rule ID 57372 //
     /* 2258567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2258570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258580 */   // MIs[0] Operand 1
     /* 2258580 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258593 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2258596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258600 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258609 */   // GIR_Coverage, 57372,
     /* 2258609 */   GIR_EraseRootFromParent_Done,
     /* 2258610 */ // Label 30353: @2258610
     /* 2258610 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2258658), // Rule ID 57373 //
     /* 2258615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2258618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258628 */   // MIs[0] Operand 1
     /* 2258628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258641 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2258644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258646 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258648 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258657 */   // GIR_Coverage, 57373,
     /* 2258657 */   GIR_EraseRootFromParent_Done,
     /* 2258658 */ // Label 30354: @2258658
     /* 2258658 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2258706), // Rule ID 57622 //
     /* 2258663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258669 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258676 */   // MIs[0] Operand 1
     /* 2258676 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258685 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258689 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2258692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258694 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258696 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258705 */   // GIR_Coverage, 57622,
     /* 2258705 */   GIR_EraseRootFromParent_Done,
     /* 2258706 */ // Label 30355: @2258706
     /* 2258706 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2258754), // Rule ID 57623 //
     /* 2258711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258724 */   // MIs[0] Operand 1
     /* 2258724 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258733 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258737 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2258740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258742 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258744 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258753 */   // GIR_Coverage, 57623,
     /* 2258753 */   GIR_EraseRootFromParent_Done,
     /* 2258754 */ // Label 30356: @2258754
     /* 2258754 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2258802), // Rule ID 57642 //
     /* 2258759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258772 */   // MIs[0] Operand 1
     /* 2258772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258785 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2258788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258790 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258792 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258801 */   // GIR_Coverage, 57642,
     /* 2258801 */   GIR_EraseRootFromParent_Done,
     /* 2258802 */ // Label 30357: @2258802
     /* 2258802 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2258850), // Rule ID 57643 //
     /* 2258807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2258813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2258816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258820 */   // MIs[0] Operand 1
     /* 2258820 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258829 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258833 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2258836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258838 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258840 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258849 */   // GIR_Coverage, 57643,
     /* 2258849 */   GIR_EraseRootFromParent_Done,
     /* 2258850 */ // Label 30358: @2258850
     /* 2258850 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2258898), // Rule ID 57672 //
     /* 2258855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2258858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258868 */   // MIs[0] Operand 1
     /* 2258868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258881 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2258884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258886 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258888 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258897 */   // GIR_Coverage, 57672,
     /* 2258897 */   GIR_EraseRootFromParent_Done,
     /* 2258898 */ // Label 30359: @2258898
     /* 2258898 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2258946), // Rule ID 57673 //
     /* 2258903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2258906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2258909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2258912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258916 */   // MIs[0] Operand 1
     /* 2258916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258929 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2258932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258934 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258936 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258945 */   // GIR_Coverage, 57673,
     /* 2258945 */   GIR_EraseRootFromParent_Done,
     /* 2258946 */ // Label 30360: @2258946
     /* 2258946 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2258994), // Rule ID 57922 //
     /* 2258951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2258957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2258960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258964 */   // MIs[0] Operand 1
     /* 2258964 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258977 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2258980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258982 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258984 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258993 */   // GIR_Coverage, 57922,
     /* 2258993 */   GIR_EraseRootFromParent_Done,
     /* 2258994 */ // Label 30361: @2258994
     /* 2258994 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2259042), // Rule ID 57923 //
     /* 2258999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2259005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2259008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259012 */   // MIs[0] Operand 1
     /* 2259012 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259025 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2259028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259030 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259032 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259041 */   // GIR_Coverage, 57923,
     /* 2259041 */   GIR_EraseRootFromParent_Done,
     /* 2259042 */ // Label 30362: @2259042
     /* 2259042 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2259090), // Rule ID 57942 //
     /* 2259047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2259050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2259053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2259056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259060 */   // MIs[0] Operand 1
     /* 2259060 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259069 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259073 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2259076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259080 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259089 */   // GIR_Coverage, 57942,
     /* 2259089 */   GIR_EraseRootFromParent_Done,
     /* 2259090 */ // Label 30363: @2259090
     /* 2259090 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2259138), // Rule ID 57943 //
     /* 2259095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2259098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2259101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2259104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259108 */   // MIs[0] Operand 1
     /* 2259108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259121 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2259124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259128 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259137 */   // GIR_Coverage, 57943,
     /* 2259137 */   GIR_EraseRootFromParent_Done,
     /* 2259138 */ // Label 30364: @2259138
     /* 2259138 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2259186), // Rule ID 57972 //
     /* 2259143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2259146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2259149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2259152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259156 */   // MIs[0] Operand 1
     /* 2259156 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259169 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2259172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259176 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259185 */   // GIR_Coverage, 57972,
     /* 2259185 */   GIR_EraseRootFromParent_Done,
     /* 2259186 */ // Label 30365: @2259186
     /* 2259186 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2259234), // Rule ID 57973 //
     /* 2259191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2259194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2259197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2259200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259204 */   // MIs[0] Operand 1
     /* 2259204 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259213 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259217 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2259220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259224 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259232 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259233 */   // GIR_Coverage, 57973,
     /* 2259233 */   GIR_EraseRootFromParent_Done,
     /* 2259234 */ // Label 30366: @2259234
     /* 2259234 */ GIM_Reject,
     /* 2259235 */ // Label 30298: @2259235
     /* 2259235 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2259283), // Rule ID 57032 //
     /* 2259240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259246 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259253 */   // MIs[0] Operand 1
     /* 2259253 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259262 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259266 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2259269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259271 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259273 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259282 */   // GIR_Coverage, 57032,
     /* 2259282 */   GIR_EraseRootFromParent_Done,
     /* 2259283 */ // Label 30367: @2259283
     /* 2259283 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2259331), // Rule ID 57033 //
     /* 2259288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259301 */   // MIs[0] Operand 1
     /* 2259301 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259310 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259314 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2259317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259319 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259321 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259329 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259330 */   // GIR_Coverage, 57033,
     /* 2259330 */   GIR_EraseRootFromParent_Done,
     /* 2259331 */ // Label 30368: @2259331
     /* 2259331 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2259379), // Rule ID 57062 //
     /* 2259336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2259339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259349 */   // MIs[0] Operand 1
     /* 2259349 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259358 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259362 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2259365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259367 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259369 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259378 */   // GIR_Coverage, 57062,
     /* 2259378 */   GIR_EraseRootFromParent_Done,
     /* 2259379 */ // Label 30369: @2259379
     /* 2259379 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2259427), // Rule ID 57063 //
     /* 2259384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2259387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259397 */   // MIs[0] Operand 1
     /* 2259397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259410 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2259413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259415 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259417 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259426 */   // GIR_Coverage, 57063,
     /* 2259426 */   GIR_EraseRootFromParent_Done,
     /* 2259427 */ // Label 30370: @2259427
     /* 2259427 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2259475), // Rule ID 57142 //
     /* 2259432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2259435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2259438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2259441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259445 */   // MIs[0] Operand 1
     /* 2259445 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259458 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2259461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259465 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259474 */   // GIR_Coverage, 57142,
     /* 2259474 */   GIR_EraseRootFromParent_Done,
     /* 2259475 */ // Label 30371: @2259475
     /* 2259475 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2259523), // Rule ID 57143 //
     /* 2259480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2259483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2259486 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2259489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259493 */   // MIs[0] Operand 1
     /* 2259493 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259502 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259506 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2259509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259511 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259513 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259522 */   // GIR_Coverage, 57143,
     /* 2259522 */   GIR_EraseRootFromParent_Done,
     /* 2259523 */ // Label 30372: @2259523
     /* 2259523 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2259571), // Rule ID 57332 //
     /* 2259528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259534 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259541 */   // MIs[0] Operand 1
     /* 2259541 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259554 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2259557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259559 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259561 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259570 */   // GIR_Coverage, 57332,
     /* 2259570 */   GIR_EraseRootFromParent_Done,
     /* 2259571 */ // Label 30373: @2259571
     /* 2259571 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2259619), // Rule ID 57333 //
     /* 2259576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259589 */   // MIs[0] Operand 1
     /* 2259589 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259598 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259602 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2259605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259607 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259609 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259617 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259618 */   // GIR_Coverage, 57333,
     /* 2259618 */   GIR_EraseRootFromParent_Done,
     /* 2259619 */ // Label 30374: @2259619
     /* 2259619 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2259667), // Rule ID 57362 //
     /* 2259624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2259627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259637 */   // MIs[0] Operand 1
     /* 2259637 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259646 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259650 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2259653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259655 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259666 */   // GIR_Coverage, 57362,
     /* 2259666 */   GIR_EraseRootFromParent_Done,
     /* 2259667 */ // Label 30375: @2259667
     /* 2259667 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2259715), // Rule ID 57363 //
     /* 2259672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2259675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259678 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259685 */   // MIs[0] Operand 1
     /* 2259685 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259694 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259698 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2259701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259703 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259714 */   // GIR_Coverage, 57363,
     /* 2259714 */   GIR_EraseRootFromParent_Done,
     /* 2259715 */ // Label 30376: @2259715
     /* 2259715 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2259763), // Rule ID 57442 //
     /* 2259720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2259723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2259726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2259729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259733 */   // MIs[0] Operand 1
     /* 2259733 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259742 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259746 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2259749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259751 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259762 */   // GIR_Coverage, 57442,
     /* 2259762 */   GIR_EraseRootFromParent_Done,
     /* 2259763 */ // Label 30377: @2259763
     /* 2259763 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2259811), // Rule ID 57443 //
     /* 2259768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2259771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2259774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2259777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259781 */   // MIs[0] Operand 1
     /* 2259781 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259790 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259794 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2259797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259799 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259810 */   // GIR_Coverage, 57443,
     /* 2259810 */   GIR_EraseRootFromParent_Done,
     /* 2259811 */ // Label 30378: @2259811
     /* 2259811 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2259859), // Rule ID 57632 //
     /* 2259816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259829 */   // MIs[0] Operand 1
     /* 2259829 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259838 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259842 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2259845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259847 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259858 */   // GIR_Coverage, 57632,
     /* 2259858 */   GIR_EraseRootFromParent_Done,
     /* 2259859 */ // Label 30379: @2259859
     /* 2259859 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2259907), // Rule ID 57633 //
     /* 2259864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2259870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2259873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259877 */   // MIs[0] Operand 1
     /* 2259877 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259886 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259890 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2259893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259895 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259897 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259906 */   // GIR_Coverage, 57633,
     /* 2259906 */   GIR_EraseRootFromParent_Done,
     /* 2259907 */ // Label 30380: @2259907
     /* 2259907 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2259955), // Rule ID 57662 //
     /* 2259912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2259915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259918 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259925 */   // MIs[0] Operand 1
     /* 2259925 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259934 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259938 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2259941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259943 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259945 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259954 */   // GIR_Coverage, 57662,
     /* 2259954 */   GIR_EraseRootFromParent_Done,
     /* 2259955 */ // Label 30381: @2259955
     /* 2259955 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2260003), // Rule ID 57663 //
     /* 2259960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2259963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2259966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2259969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259973 */   // MIs[0] Operand 1
     /* 2259973 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259986 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2259989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259991 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259993 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260002 */   // GIR_Coverage, 57663,
     /* 2260002 */   GIR_EraseRootFromParent_Done,
     /* 2260003 */ // Label 30382: @2260003
     /* 2260003 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2260051), // Rule ID 57742 //
     /* 2260008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2260011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2260014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2260017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260021 */   // MIs[0] Operand 1
     /* 2260021 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2260026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260030 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260034 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2260037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260039 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260041 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260050 */   // GIR_Coverage, 57742,
     /* 2260050 */   GIR_EraseRootFromParent_Done,
     /* 2260051 */ // Label 30383: @2260051
     /* 2260051 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2260099), // Rule ID 57743 //
     /* 2260056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2260059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2260062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2260065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260069 */   // MIs[0] Operand 1
     /* 2260069 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2260074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260078 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260082 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2260085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260089 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260098 */   // GIR_Coverage, 57743,
     /* 2260098 */   GIR_EraseRootFromParent_Done,
     /* 2260099 */ // Label 30384: @2260099
     /* 2260099 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2260147), // Rule ID 57932 //
     /* 2260104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2260107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2260110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2260113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260117 */   // MIs[0] Operand 1
     /* 2260117 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260126 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260130 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2260133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260135 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260137 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260146 */   // GIR_Coverage, 57932,
     /* 2260146 */   GIR_EraseRootFromParent_Done,
     /* 2260147 */ // Label 30385: @2260147
     /* 2260147 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2260195), // Rule ID 57933 //
     /* 2260152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2260155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2260158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2260161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260165 */   // MIs[0] Operand 1
     /* 2260165 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260174 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260178 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2260181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260183 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260185 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260194 */   // GIR_Coverage, 57933,
     /* 2260194 */   GIR_EraseRootFromParent_Done,
     /* 2260195 */ // Label 30386: @2260195
     /* 2260195 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2260243), // Rule ID 57962 //
     /* 2260200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2260203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2260206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2260209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260213 */   // MIs[0] Operand 1
     /* 2260213 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260226 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2260229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260231 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260233 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260242 */   // GIR_Coverage, 57962,
     /* 2260242 */   GIR_EraseRootFromParent_Done,
     /* 2260243 */ // Label 30387: @2260243
     /* 2260243 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2260291), // Rule ID 57963 //
     /* 2260248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2260251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2260254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2260257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260261 */   // MIs[0] Operand 1
     /* 2260261 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260270 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260274 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2260277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260279 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260281 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260290 */   // GIR_Coverage, 57963,
     /* 2260290 */   GIR_EraseRootFromParent_Done,
     /* 2260291 */ // Label 30388: @2260291
     /* 2260291 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2260339), // Rule ID 58042 //
     /* 2260296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2260299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2260302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2260305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260309 */   // MIs[0] Operand 1
     /* 2260309 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260318 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260322 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2260325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260329 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260338 */   // GIR_Coverage, 58042,
     /* 2260338 */   GIR_EraseRootFromParent_Done,
     /* 2260339 */ // Label 30389: @2260339
     /* 2260339 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2260387), // Rule ID 58043 //
     /* 2260344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2260347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2260350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2260353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260357 */   // MIs[0] Operand 1
     /* 2260357 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2260362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260370 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2260373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260377 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260386 */   // GIR_Coverage, 58043,
     /* 2260386 */   GIR_EraseRootFromParent_Done,
     /* 2260387 */ // Label 30390: @2260387
     /* 2260387 */ GIM_Reject,
     /* 2260388 */ // Label 30299: @2260388
     /* 2260388 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2260436), // Rule ID 57052 //
     /* 2260393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2260396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260406 */   // MIs[0] Operand 1
     /* 2260406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260419 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2260422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260435 */   // GIR_Coverage, 57052,
     /* 2260435 */   GIR_EraseRootFromParent_Done,
     /* 2260436 */ // Label 30391: @2260436
     /* 2260436 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2260484), // Rule ID 57053 //
     /* 2260441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2260444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260454 */   // MIs[0] Operand 1
     /* 2260454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260467 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2260470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260483 */   // GIR_Coverage, 57053,
     /* 2260483 */   GIR_EraseRootFromParent_Done,
     /* 2260484 */ // Label 30392: @2260484
     /* 2260484 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2260532), // Rule ID 57112 //
     /* 2260489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2260492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260502 */   // MIs[0] Operand 1
     /* 2260502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260515 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2260518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260531 */   // GIR_Coverage, 57112,
     /* 2260531 */   GIR_EraseRootFromParent_Done,
     /* 2260532 */ // Label 30393: @2260532
     /* 2260532 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2260580), // Rule ID 57113 //
     /* 2260537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2260540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260550 */   // MIs[0] Operand 1
     /* 2260550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260563 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2260566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260579 */   // GIR_Coverage, 57113,
     /* 2260579 */   GIR_EraseRootFromParent_Done,
     /* 2260580 */ // Label 30394: @2260580
     /* 2260580 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2260628), // Rule ID 57152 //
     /* 2260585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2260588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260598 */   // MIs[0] Operand 1
     /* 2260598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260611 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2260614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260627 */   // GIR_Coverage, 57152,
     /* 2260627 */   GIR_EraseRootFromParent_Done,
     /* 2260628 */ // Label 30395: @2260628
     /* 2260628 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2260676), // Rule ID 57153 //
     /* 2260633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2260636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260646 */   // MIs[0] Operand 1
     /* 2260646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2260651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260659 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2260662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260675 */   // GIR_Coverage, 57153,
     /* 2260675 */   GIR_EraseRootFromParent_Done,
     /* 2260676 */ // Label 30396: @2260676
     /* 2260676 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2260724), // Rule ID 57352 //
     /* 2260681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2260684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260694 */   // MIs[0] Operand 1
     /* 2260694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260707 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2260710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260723 */   // GIR_Coverage, 57352,
     /* 2260723 */   GIR_EraseRootFromParent_Done,
     /* 2260724 */ // Label 30397: @2260724
     /* 2260724 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2260772), // Rule ID 57353 //
     /* 2260729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2260732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260742 */   // MIs[0] Operand 1
     /* 2260742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260755 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2260758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260771 */   // GIR_Coverage, 57353,
     /* 2260771 */   GIR_EraseRootFromParent_Done,
     /* 2260772 */ // Label 30398: @2260772
     /* 2260772 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2260820), // Rule ID 57412 //
     /* 2260777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2260780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260790 */   // MIs[0] Operand 1
     /* 2260790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260803 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2260806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260819 */   // GIR_Coverage, 57412,
     /* 2260819 */   GIR_EraseRootFromParent_Done,
     /* 2260820 */ // Label 30399: @2260820
     /* 2260820 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2260868), // Rule ID 57413 //
     /* 2260825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2260828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2260831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2260834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260838 */   // MIs[0] Operand 1
     /* 2260838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260851 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2260854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260867 */   // GIR_Coverage, 57413,
     /* 2260867 */   GIR_EraseRootFromParent_Done,
     /* 2260868 */ // Label 30400: @2260868
     /* 2260868 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2260916), // Rule ID 57452 //
     /* 2260873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2260876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260886 */   // MIs[0] Operand 1
     /* 2260886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260899 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2260902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260915 */   // GIR_Coverage, 57452,
     /* 2260915 */   GIR_EraseRootFromParent_Done,
     /* 2260916 */ // Label 30401: @2260916
     /* 2260916 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2260964), // Rule ID 57453 //
     /* 2260921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2260924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2260927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2260930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260934 */   // MIs[0] Operand 1
     /* 2260934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2260939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260943 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260947 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2260950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260952 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260963 */   // GIR_Coverage, 57453,
     /* 2260963 */   GIR_EraseRootFromParent_Done,
     /* 2260964 */ // Label 30402: @2260964
     /* 2260964 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2261012), // Rule ID 57652 //
     /* 2260969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2260972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2260975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2260978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260982 */   // MIs[0] Operand 1
     /* 2260982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2260987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260995 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2260998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261000 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261011 */   // GIR_Coverage, 57652,
     /* 2261011 */   GIR_EraseRootFromParent_Done,
     /* 2261012 */ // Label 30403: @2261012
     /* 2261012 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2261060), // Rule ID 57653 //
     /* 2261017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2261020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2261023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2261026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261030 */   // MIs[0] Operand 1
     /* 2261030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2261035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261043 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2261046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261048 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261059 */   // GIR_Coverage, 57653,
     /* 2261059 */   GIR_EraseRootFromParent_Done,
     /* 2261060 */ // Label 30404: @2261060
     /* 2261060 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2261108), // Rule ID 57712 //
     /* 2261065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2261068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2261071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2261074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261078 */   // MIs[0] Operand 1
     /* 2261078 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2261083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261091 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2261094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261096 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261107 */   // GIR_Coverage, 57712,
     /* 2261107 */   GIR_EraseRootFromParent_Done,
     /* 2261108 */ // Label 30405: @2261108
     /* 2261108 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2261156), // Rule ID 57713 //
     /* 2261113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2261116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2261119 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2261122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261126 */   // MIs[0] Operand 1
     /* 2261126 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2261131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261135 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261139 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2261142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261144 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261155 */   // GIR_Coverage, 57713,
     /* 2261155 */   GIR_EraseRootFromParent_Done,
     /* 2261156 */ // Label 30406: @2261156
     /* 2261156 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2261204), // Rule ID 57752 //
     /* 2261161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2261164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2261167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2261170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261174 */   // MIs[0] Operand 1
     /* 2261174 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2261179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261183 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261187 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2261190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261192 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261203 */   // GIR_Coverage, 57752,
     /* 2261203 */   GIR_EraseRootFromParent_Done,
     /* 2261204 */ // Label 30407: @2261204
     /* 2261204 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2261252), // Rule ID 57753 //
     /* 2261209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2261212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2261215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2261218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261222 */   // MIs[0] Operand 1
     /* 2261222 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2261227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261231 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261235 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2261238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261240 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261242 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261251 */   // GIR_Coverage, 57753,
     /* 2261251 */   GIR_EraseRootFromParent_Done,
     /* 2261252 */ // Label 30408: @2261252
     /* 2261252 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2261300), // Rule ID 57952 //
     /* 2261257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2261260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2261263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2261266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261270 */   // MIs[0] Operand 1
     /* 2261270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261279 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261283 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2261286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261299 */   // GIR_Coverage, 57952,
     /* 2261299 */   GIR_EraseRootFromParent_Done,
     /* 2261300 */ // Label 30409: @2261300
     /* 2261300 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2261348), // Rule ID 57953 //
     /* 2261305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2261308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2261311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2261314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261318 */   // MIs[0] Operand 1
     /* 2261318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261331 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2261334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261336 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261347 */   // GIR_Coverage, 57953,
     /* 2261347 */   GIR_EraseRootFromParent_Done,
     /* 2261348 */ // Label 30410: @2261348
     /* 2261348 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2261396), // Rule ID 58012 //
     /* 2261353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2261356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2261359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2261362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261366 */   // MIs[0] Operand 1
     /* 2261366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261375 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261379 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2261382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261384 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261395 */   // GIR_Coverage, 58012,
     /* 2261395 */   GIR_EraseRootFromParent_Done,
     /* 2261396 */ // Label 30411: @2261396
     /* 2261396 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2261444), // Rule ID 58013 //
     /* 2261401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2261404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2261407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2261410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261414 */   // MIs[0] Operand 1
     /* 2261414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261427 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2261430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261443 */   // GIR_Coverage, 58013,
     /* 2261443 */   GIR_EraseRootFromParent_Done,
     /* 2261444 */ // Label 30412: @2261444
     /* 2261444 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2261492), // Rule ID 58052 //
     /* 2261449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2261452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2261455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2261458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261462 */   // MIs[0] Operand 1
     /* 2261462 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261475 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2261478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261482 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261491 */   // GIR_Coverage, 58052,
     /* 2261491 */   GIR_EraseRootFromParent_Done,
     /* 2261492 */ // Label 30413: @2261492
     /* 2261492 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2261540), // Rule ID 58053 //
     /* 2261497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2261500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2261503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2261506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261510 */   // MIs[0] Operand 1
     /* 2261510 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2261515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261519 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261523 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2261526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261539 */   // GIR_Coverage, 58053,
     /* 2261539 */   GIR_EraseRootFromParent_Done,
     /* 2261540 */ // Label 30414: @2261540
     /* 2261540 */ GIM_Reject,
     /* 2261541 */ // Label 30300: @2261541
     /* 2261541 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2261589), // Rule ID 57082 //
     /* 2261546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2261549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261559 */   // MIs[0] Operand 1
     /* 2261559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261572 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2261575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261588 */   // GIR_Coverage, 57082,
     /* 2261588 */   GIR_EraseRootFromParent_Done,
     /* 2261589 */ // Label 30415: @2261589
     /* 2261589 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2261637), // Rule ID 57083 //
     /* 2261594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2261597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261607 */   // MIs[0] Operand 1
     /* 2261607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261620 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2261623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261636 */   // GIR_Coverage, 57083,
     /* 2261636 */   GIR_EraseRootFromParent_Done,
     /* 2261637 */ // Label 30416: @2261637
     /* 2261637 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2261685), // Rule ID 57122 //
     /* 2261642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2261645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261655 */   // MIs[0] Operand 1
     /* 2261655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261668 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2261671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261684 */   // GIR_Coverage, 57122,
     /* 2261684 */   GIR_EraseRootFromParent_Done,
     /* 2261685 */ // Label 30417: @2261685
     /* 2261685 */ GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2261733), // Rule ID 57123 //
     /* 2261690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2261693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261703 */   // MIs[0] Operand 1
     /* 2261703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261716 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2261719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261732 */   // GIR_Coverage, 57123,
     /* 2261732 */   GIR_EraseRootFromParent_Done,
     /* 2261733 */ // Label 30418: @2261733
     /* 2261733 */ GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2261781), // Rule ID 57162 //
     /* 2261738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2261741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261751 */   // MIs[0] Operand 1
     /* 2261751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261764 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2261767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261780 */   // GIR_Coverage, 57162,
     /* 2261780 */   GIR_EraseRootFromParent_Done,
     /* 2261781 */ // Label 30419: @2261781
     /* 2261781 */ GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2261829), // Rule ID 57163 //
     /* 2261786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2261789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2261792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2261795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261799 */   // MIs[0] Operand 1
     /* 2261799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2261804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261812 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2261815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261828 */   // GIR_Coverage, 57163,
     /* 2261828 */   GIR_EraseRootFromParent_Done,
     /* 2261829 */ // Label 30420: @2261829
     /* 2261829 */ GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2261877), // Rule ID 57382 //
     /* 2261834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2261837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261847 */   // MIs[0] Operand 1
     /* 2261847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2261852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261860 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2261863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261876 */   // GIR_Coverage, 57382,
     /* 2261876 */   GIR_EraseRootFromParent_Done,
     /* 2261877 */ // Label 30421: @2261877
     /* 2261877 */ GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2261925), // Rule ID 57383 //
     /* 2261882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2261885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2261888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2261891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261895 */   // MIs[0] Operand 1
     /* 2261895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2261900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261908 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2261911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261924 */   // GIR_Coverage, 57383,
     /* 2261924 */   GIR_EraseRootFromParent_Done,
     /* 2261925 */ // Label 30422: @2261925
     /* 2261925 */ GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2261973), // Rule ID 57422 //
     /* 2261930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2261933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261943 */   // MIs[0] Operand 1
     /* 2261943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2261948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261956 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2261959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261972 */   // GIR_Coverage, 57422,
     /* 2261972 */   GIR_EraseRootFromParent_Done,
     /* 2261973 */ // Label 30423: @2261973
     /* 2261973 */ GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2262021), // Rule ID 57423 //
     /* 2261978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2261981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2261984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2261987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261991 */   // MIs[0] Operand 1
     /* 2261991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2261996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262004 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2262007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262020 */   // GIR_Coverage, 57423,
     /* 2262020 */   GIR_EraseRootFromParent_Done,
     /* 2262021 */ // Label 30424: @2262021
     /* 2262021 */ GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2262069), // Rule ID 57462 //
     /* 2262026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2262029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262039 */   // MIs[0] Operand 1
     /* 2262039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2262044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262052 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2262055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262068 */   // GIR_Coverage, 57462,
     /* 2262068 */   GIR_EraseRootFromParent_Done,
     /* 2262069 */ // Label 30425: @2262069
     /* 2262069 */ GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2262117), // Rule ID 57463 //
     /* 2262074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2262077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262087 */   // MIs[0] Operand 1
     /* 2262087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2262092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262100 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2262103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262116 */   // GIR_Coverage, 57463,
     /* 2262116 */   GIR_EraseRootFromParent_Done,
     /* 2262117 */ // Label 30426: @2262117
     /* 2262117 */ GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2262165), // Rule ID 57682 //
     /* 2262122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2262125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262135 */   // MIs[0] Operand 1
     /* 2262135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262148 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2262151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262164 */   // GIR_Coverage, 57682,
     /* 2262164 */   GIR_EraseRootFromParent_Done,
     /* 2262165 */ // Label 30427: @2262165
     /* 2262165 */ GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2262213), // Rule ID 57683 //
     /* 2262170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2262173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262183 */   // MIs[0] Operand 1
     /* 2262183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262196 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2262199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262212 */   // GIR_Coverage, 57683,
     /* 2262212 */   GIR_EraseRootFromParent_Done,
     /* 2262213 */ // Label 30428: @2262213
     /* 2262213 */ GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2262261), // Rule ID 57722 //
     /* 2262218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2262221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262231 */   // MIs[0] Operand 1
     /* 2262231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262244 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2262247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262260 */   // GIR_Coverage, 57722,
     /* 2262260 */   GIR_EraseRootFromParent_Done,
     /* 2262261 */ // Label 30429: @2262261
     /* 2262261 */ GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2262309), // Rule ID 57723 //
     /* 2262266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2262269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262279 */   // MIs[0] Operand 1
     /* 2262279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262292 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2262295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262308 */   // GIR_Coverage, 57723,
     /* 2262308 */   GIR_EraseRootFromParent_Done,
     /* 2262309 */ // Label 30430: @2262309
     /* 2262309 */ GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2262357), // Rule ID 57762 //
     /* 2262314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2262317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262327 */   // MIs[0] Operand 1
     /* 2262327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262340 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2262343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262356 */   // GIR_Coverage, 57762,
     /* 2262356 */   GIR_EraseRootFromParent_Done,
     /* 2262357 */ // Label 30431: @2262357
     /* 2262357 */ GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2262405), // Rule ID 57763 //
     /* 2262362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2262365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262375 */   // MIs[0] Operand 1
     /* 2262375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2262380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262388 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2262391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262395 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262404 */   // GIR_Coverage, 57763,
     /* 2262404 */   GIR_EraseRootFromParent_Done,
     /* 2262405 */ // Label 30432: @2262405
     /* 2262405 */ GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2262453), // Rule ID 57982 //
     /* 2262410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2262413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262423 */   // MIs[0] Operand 1
     /* 2262423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262436 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2262439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262443 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262452 */   // GIR_Coverage, 57982,
     /* 2262452 */   GIR_EraseRootFromParent_Done,
     /* 2262453 */ // Label 30433: @2262453
     /* 2262453 */ GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2262501), // Rule ID 57983 //
     /* 2262458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2262461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262471 */   // MIs[0] Operand 1
     /* 2262471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262484 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2262487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262489 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262491 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262500 */   // GIR_Coverage, 57983,
     /* 2262500 */   GIR_EraseRootFromParent_Done,
     /* 2262501 */ // Label 30434: @2262501
     /* 2262501 */ GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2262549), // Rule ID 58022 //
     /* 2262506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2262509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262519 */   // MIs[0] Operand 1
     /* 2262519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262532 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2262535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262537 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262539 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262548 */   // GIR_Coverage, 58022,
     /* 2262548 */   GIR_EraseRootFromParent_Done,
     /* 2262549 */ // Label 30435: @2262549
     /* 2262549 */ GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2262597), // Rule ID 58023 //
     /* 2262554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2262557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262567 */   // MIs[0] Operand 1
     /* 2262567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262580 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2262583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262596 */   // GIR_Coverage, 58023,
     /* 2262596 */   GIR_EraseRootFromParent_Done,
     /* 2262597 */ // Label 30436: @2262597
     /* 2262597 */ GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2262645), // Rule ID 58062 //
     /* 2262602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2262605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262615 */   // MIs[0] Operand 1
     /* 2262615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262628 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2262631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262644 */   // GIR_Coverage, 58062,
     /* 2262644 */   GIR_EraseRootFromParent_Done,
     /* 2262645 */ // Label 30437: @2262645
     /* 2262645 */ GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2262693), // Rule ID 58063 //
     /* 2262650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2262653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262663 */   // MIs[0] Operand 1
     /* 2262663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2262668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262676 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2262679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262692 */   // GIR_Coverage, 58063,
     /* 2262692 */   GIR_EraseRootFromParent_Done,
     /* 2262693 */ // Label 30438: @2262693
     /* 2262693 */ GIM_Reject,
     /* 2262694 */ // Label 30301: @2262694
     /* 2262694 */ GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2262742), // Rule ID 57092 //
     /* 2262699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2262702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262712 */   // MIs[0] Operand 1
     /* 2262712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2262717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262725 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2262728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262741 */   // GIR_Coverage, 57092,
     /* 2262741 */   GIR_EraseRootFromParent_Done,
     /* 2262742 */ // Label 30439: @2262742
     /* 2262742 */ GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2262790), // Rule ID 57093 //
     /* 2262747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2262750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262760 */   // MIs[0] Operand 1
     /* 2262760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2262765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262773 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2262776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262789 */   // GIR_Coverage, 57093,
     /* 2262789 */   GIR_EraseRootFromParent_Done,
     /* 2262790 */ // Label 30440: @2262790
     /* 2262790 */ GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2262838), // Rule ID 57132 //
     /* 2262795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2262798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262808 */   // MIs[0] Operand 1
     /* 2262808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2262813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262821 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2262824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262826 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262837 */   // GIR_Coverage, 57132,
     /* 2262837 */   GIR_EraseRootFromParent_Done,
     /* 2262838 */ // Label 30441: @2262838
     /* 2262838 */ GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2262886), // Rule ID 57133 //
     /* 2262843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2262846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262856 */   // MIs[0] Operand 1
     /* 2262856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2262861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262869 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2262872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262874 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262885 */   // GIR_Coverage, 57133,
     /* 2262885 */   GIR_EraseRootFromParent_Done,
     /* 2262886 */ // Label 30442: @2262886
     /* 2262886 */ GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2262934), // Rule ID 57392 //
     /* 2262891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2262894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262904 */   // MIs[0] Operand 1
     /* 2262904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2262909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262917 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2262920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262933 */   // GIR_Coverage, 57392,
     /* 2262933 */   GIR_EraseRootFromParent_Done,
     /* 2262934 */ // Label 30443: @2262934
     /* 2262934 */ GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2262982), // Rule ID 57393 //
     /* 2262939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2262942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262952 */   // MIs[0] Operand 1
     /* 2262952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2262957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262965 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2262968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262981 */   // GIR_Coverage, 57393,
     /* 2262981 */   GIR_EraseRootFromParent_Done,
     /* 2262982 */ // Label 30444: @2262982
     /* 2262982 */ GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2263030), // Rule ID 57432 //
     /* 2262987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2262990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263000 */   // MIs[0] Operand 1
     /* 2263000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2263005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263013 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2263016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263029 */   // GIR_Coverage, 57432,
     /* 2263029 */   GIR_EraseRootFromParent_Done,
     /* 2263030 */ // Label 30445: @2263030
     /* 2263030 */ GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2263078), // Rule ID 57433 //
     /* 2263035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2263038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263048 */   // MIs[0] Operand 1
     /* 2263048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2263053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263061 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2263064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263077 */   // GIR_Coverage, 57433,
     /* 2263077 */   GIR_EraseRootFromParent_Done,
     /* 2263078 */ // Label 30446: @2263078
     /* 2263078 */ GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2263126), // Rule ID 57692 //
     /* 2263083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263096 */   // MIs[0] Operand 1
     /* 2263096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263109 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2263112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263125 */   // GIR_Coverage, 57692,
     /* 2263125 */   GIR_EraseRootFromParent_Done,
     /* 2263126 */ // Label 30447: @2263126
     /* 2263126 */ GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2263174), // Rule ID 57693 //
     /* 2263131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263144 */   // MIs[0] Operand 1
     /* 2263144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263157 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2263160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263173 */   // GIR_Coverage, 57693,
     /* 2263173 */   GIR_EraseRootFromParent_Done,
     /* 2263174 */ // Label 30448: @2263174
     /* 2263174 */ GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2263222), // Rule ID 57732 //
     /* 2263179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2263182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263192 */   // MIs[0] Operand 1
     /* 2263192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263205 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2263208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263221 */   // GIR_Coverage, 57732,
     /* 2263221 */   GIR_EraseRootFromParent_Done,
     /* 2263222 */ // Label 30449: @2263222
     /* 2263222 */ GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2263270), // Rule ID 57733 //
     /* 2263227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2263230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263240 */   // MIs[0] Operand 1
     /* 2263240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263253 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2263256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263269 */   // GIR_Coverage, 57733,
     /* 2263269 */   GIR_EraseRootFromParent_Done,
     /* 2263270 */ // Label 30450: @2263270
     /* 2263270 */ GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2263318), // Rule ID 57992 //
     /* 2263275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263288 */   // MIs[0] Operand 1
     /* 2263288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263301 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2263304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263317 */   // GIR_Coverage, 57992,
     /* 2263317 */   GIR_EraseRootFromParent_Done,
     /* 2263318 */ // Label 30451: @2263318
     /* 2263318 */ GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2263366), // Rule ID 57993 //
     /* 2263323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263336 */   // MIs[0] Operand 1
     /* 2263336 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263349 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2263352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263356 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263365 */   // GIR_Coverage, 57993,
     /* 2263365 */   GIR_EraseRootFromParent_Done,
     /* 2263366 */ // Label 30452: @2263366
     /* 2263366 */ GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2263414), // Rule ID 58032 //
     /* 2263371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2263374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263384 */   // MIs[0] Operand 1
     /* 2263384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263397 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2263400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263404 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263413 */   // GIR_Coverage, 58032,
     /* 2263413 */   GIR_EraseRootFromParent_Done,
     /* 2263414 */ // Label 30453: @2263414
     /* 2263414 */ GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2263462), // Rule ID 58033 //
     /* 2263419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2263422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263432 */   // MIs[0] Operand 1
     /* 2263432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263445 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2263448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263452 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263461 */   // GIR_Coverage, 58033,
     /* 2263461 */   GIR_EraseRootFromParent_Done,
     /* 2263462 */ // Label 30454: @2263462
     /* 2263462 */ GIM_Reject,
     /* 2263463 */ // Label 30302: @2263463
     /* 2263463 */ GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2263783),
     /* 2263468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263478 */   GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2263516), // Rule ID 57102 //
     /* 2263483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263486 */     // MIs[0] Operand 1
     /* 2263486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2263491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263499 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2263502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263515 */     // GIR_Coverage, 57102,
     /* 2263515 */     GIR_EraseRootFromParent_Done,
     /* 2263516 */   // Label 30456: @2263516
     /* 2263516 */   GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2263554), // Rule ID 57103 //
     /* 2263521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263524 */     // MIs[0] Operand 1
     /* 2263524 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2263529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263537 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2263540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263553 */     // GIR_Coverage, 57103,
     /* 2263553 */     GIR_EraseRootFromParent_Done,
     /* 2263554 */   // Label 30457: @2263554
     /* 2263554 */   GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2263592), // Rule ID 57402 //
     /* 2263559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263562 */     // MIs[0] Operand 1
     /* 2263562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2263567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263575 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2263578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263591 */     // GIR_Coverage, 57402,
     /* 2263591 */     GIR_EraseRootFromParent_Done,
     /* 2263592 */   // Label 30458: @2263592
     /* 2263592 */   GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2263630), // Rule ID 57403 //
     /* 2263597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263600 */     // MIs[0] Operand 1
     /* 2263600 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2263605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263613 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2263616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263629 */     // GIR_Coverage, 57403,
     /* 2263629 */     GIR_EraseRootFromParent_Done,
     /* 2263630 */   // Label 30459: @2263630
     /* 2263630 */   GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2263668), // Rule ID 57702 //
     /* 2263635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263638 */     // MIs[0] Operand 1
     /* 2263638 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263651 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2263654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263667 */     // GIR_Coverage, 57702,
     /* 2263667 */     GIR_EraseRootFromParent_Done,
     /* 2263668 */   // Label 30460: @2263668
     /* 2263668 */   GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2263706), // Rule ID 57703 //
     /* 2263673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263676 */     // MIs[0] Operand 1
     /* 2263676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2263681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263689 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2263692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263705 */     // GIR_Coverage, 57703,
     /* 2263705 */     GIR_EraseRootFromParent_Done,
     /* 2263706 */   // Label 30461: @2263706
     /* 2263706 */   GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2263744), // Rule ID 58002 //
     /* 2263711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2263714 */     // MIs[0] Operand 1
     /* 2263714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263727 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2263730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263743 */     // GIR_Coverage, 58002,
     /* 2263743 */     GIR_EraseRootFromParent_Done,
     /* 2263744 */   // Label 30462: @2263744
     /* 2263744 */   GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2263782), // Rule ID 58003 //
     /* 2263749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2263752 */     // MIs[0] Operand 1
     /* 2263752 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2263757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263765 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2263768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263781 */     // GIR_Coverage, 58003,
     /* 2263781 */     GIR_EraseRootFromParent_Done,
     /* 2263782 */   // Label 30463: @2263782
     /* 2263782 */   GIM_Reject,
     /* 2263783 */ // Label 30455: @2263783
     /* 2263783 */ GIM_Reject,
     /* 2263784 */ // Label 30303: @2263784
     /* 2263784 */ GIM_Reject,
     /* 2263785 */ // Label 50: @2263785
     /* 2263785 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30488*/ GIMT_Encode4(2268176),
     /* 2263796 */ /*GILLT_s32*//*Label 30464*/ GIMT_Encode4(2263920),
     /* 2263800 */ /*GILLT_s64*//*Label 30465*/ GIMT_Encode4(2264068), GIMT_Encode4(0),
     /* 2263808 */ /*GILLT_nxv1s8*//*Label 30466*/ GIMT_Encode4(2264216),
     /* 2263812 */ /*GILLT_nxv1s16*//*Label 30467*/ GIMT_Encode4(2264336),
     /* 2263816 */ /*GILLT_nxv1s32*//*Label 30468*/ GIMT_Encode4(2264544),
     /* 2263820 */ /*GILLT_nxv1s64*//*Label 30469*/ GIMT_Encode4(2264752), GIMT_Encode4(0),
     /* 2263828 */ /*GILLT_nxv2s8*//*Label 30470*/ GIMT_Encode4(2264960),
     /* 2263832 */ /*GILLT_nxv2s16*//*Label 30471*/ GIMT_Encode4(2265080),
     /* 2263836 */ /*GILLT_nxv2s32*//*Label 30472*/ GIMT_Encode4(2265288),
     /* 2263840 */ /*GILLT_nxv2s64*//*Label 30473*/ GIMT_Encode4(2265496), GIMT_Encode4(0),
     /* 2263848 */ /*GILLT_nxv4s8*//*Label 30474*/ GIMT_Encode4(2265704),
     /* 2263852 */ /*GILLT_nxv4s16*//*Label 30475*/ GIMT_Encode4(2265824),
     /* 2263856 */ /*GILLT_nxv4s32*//*Label 30476*/ GIMT_Encode4(2266032),
     /* 2263860 */ /*GILLT_nxv4s64*//*Label 30477*/ GIMT_Encode4(2266240), GIMT_Encode4(0),
     /* 2263868 */ /*GILLT_nxv8s8*//*Label 30478*/ GIMT_Encode4(2266448),
     /* 2263872 */ /*GILLT_nxv8s16*//*Label 30479*/ GIMT_Encode4(2266568),
     /* 2263876 */ /*GILLT_nxv8s32*//*Label 30480*/ GIMT_Encode4(2266776),
     /* 2263880 */ /*GILLT_nxv8s64*//*Label 30481*/ GIMT_Encode4(2266984), GIMT_Encode4(0),
     /* 2263888 */ /*GILLT_nxv16s8*//*Label 30482*/ GIMT_Encode4(2267192),
     /* 2263892 */ /*GILLT_nxv16s16*//*Label 30483*/ GIMT_Encode4(2267312),
     /* 2263896 */ /*GILLT_nxv16s32*//*Label 30484*/ GIMT_Encode4(2267520), GIMT_Encode4(0),
     /* 2263904 */ /*GILLT_nxv32s8*//*Label 30485*/ GIMT_Encode4(2267728),
     /* 2263908 */ /*GILLT_nxv32s16*//*Label 30486*/ GIMT_Encode4(2267848), GIMT_Encode4(0),
     /* 2263916 */ /*GILLT_nxv64s8*//*Label 30487*/ GIMT_Encode4(2268056),
     /* 2263920 */ // Label 30464: @2263920
     /* 2263920 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2264067),
     /* 2263925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2263928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2263931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2263934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2263938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2263942 */   GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2263975), // Rule ID 62573 //
     /* 2263947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2263950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2263954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2263958 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2263958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2263961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2263963 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2263965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2263971 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2263973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263974 */     // GIR_Coverage, 62573,
     /* 2263974 */     GIR_EraseRootFromParent_Done,
     /* 2263975 */   // Label 30490: @2263975
     /* 2263975 */   GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2264008), // Rule ID 62571 //
     /* 2263980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2263983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2263987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2263991 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2263991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2263994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2263996 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2263998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2264004 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2264006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264007 */     // GIR_Coverage, 62571,
     /* 2264007 */     GIR_EraseRootFromParent_Done,
     /* 2264008 */   // Label 30491: @2264008
     /* 2264008 */   GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2264037), // Rule ID 62569 //
     /* 2264013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2264016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264024 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2264024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2264027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2264029 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2264031 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2264033 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2264035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264036 */     // GIR_Coverage, 62569,
     /* 2264036 */     GIR_EraseRootFromParent_Done,
     /* 2264037 */   // Label 30492: @2264037
     /* 2264037 */   GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2264066), // Rule ID 64584 //
     /* 2264042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2264045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264053 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2264053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2264056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2264062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2264064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264065 */     // GIR_Coverage, 64584,
     /* 2264065 */     GIR_EraseRootFromParent_Done,
     /* 2264066 */   // Label 30493: @2264066
     /* 2264066 */   GIM_Reject,
     /* 2264067 */ // Label 30489: @2264067
     /* 2264067 */ GIM_Reject,
     /* 2264068 */ // Label 30465: @2264068
     /* 2264068 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2264215),
     /* 2264073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2264076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2264079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2264082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264090 */   GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2264123), // Rule ID 62572 //
     /* 2264095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2264098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2264102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264106 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2264106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2264109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2264111 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2264113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2264119 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2264121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264122 */     // GIR_Coverage, 62572,
     /* 2264122 */     GIR_EraseRootFromParent_Done,
     /* 2264123 */   // Label 30495: @2264123
     /* 2264123 */   GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2264156), // Rule ID 62570 //
     /* 2264128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2264131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2264139 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2264139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2264142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2264144 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2264146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2264152 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2264154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264155 */     // GIR_Coverage, 62570,
     /* 2264155 */     GIR_EraseRootFromParent_Done,
     /* 2264156 */   // Label 30496: @2264156
     /* 2264156 */   GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2264185), // Rule ID 62568 //
     /* 2264161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2264164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264172 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2264172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2264175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2264177 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2264179 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2264181 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2264183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264184 */     // GIR_Coverage, 62568,
     /* 2264184 */     GIR_EraseRootFromParent_Done,
     /* 2264185 */   // Label 30497: @2264185
     /* 2264185 */   GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2264214), // Rule ID 64583 //
     /* 2264190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2264193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264201 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2264201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2264204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2264210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2264212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264213 */     // GIR_Coverage, 64583,
     /* 2264213 */     GIR_EraseRootFromParent_Done,
     /* 2264214 */   // Label 30498: @2264214
     /* 2264214 */   GIM_Reject,
     /* 2264215 */ // Label 30494: @2264215
     /* 2264215 */ GIM_Reject,
     /* 2264216 */ // Label 30466: @2264216
     /* 2264216 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2264335),
     /* 2264221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2264224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2264227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2264230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2264234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2264238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264242 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264246 */   GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2264290), // Rule ID 52232 //
     /* 2264251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264254 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2264271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264280 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264289 */     // GIR_Coverage, 52232,
     /* 2264289 */     GIR_EraseRootFromParent_Done,
     /* 2264290 */   // Label 30500: @2264290
     /* 2264290 */   GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2264334), // Rule ID 52233 //
     /* 2264295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264298 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2264315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264324 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264333 */     // GIR_Coverage, 52233,
     /* 2264333 */     GIR_EraseRootFromParent_Done,
     /* 2264334 */   // Label 30501: @2264334
     /* 2264334 */   GIM_Reject,
     /* 2264335 */ // Label 30499: @2264335
     /* 2264335 */ GIM_Reject,
     /* 2264336 */ // Label 30467: @2264336
     /* 2264336 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2264543),
     /* 2264341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2264344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2264347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2264350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2264354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2264358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264366 */   GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2264410), // Rule ID 52250 //
     /* 2264371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264374 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2264391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264400 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264409 */     // GIR_Coverage, 52250,
     /* 2264409 */     GIR_EraseRootFromParent_Done,
     /* 2264410 */   // Label 30503: @2264410
     /* 2264410 */   GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2264454), // Rule ID 52251 //
     /* 2264415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264418 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2264435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264444 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264453 */     // GIR_Coverage, 52251,
     /* 2264453 */     GIR_EraseRootFromParent_Done,
     /* 2264454 */   // Label 30504: @2264454
     /* 2264454 */   GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2264498), // Rule ID 58072 //
     /* 2264459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264462 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2264479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264488 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264497 */     // GIR_Coverage, 58072,
     /* 2264497 */     GIR_EraseRootFromParent_Done,
     /* 2264498 */   // Label 30505: @2264498
     /* 2264498 */   GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2264542), // Rule ID 58073 //
     /* 2264503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264506 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2264523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264541 */     // GIR_Coverage, 58073,
     /* 2264541 */     GIR_EraseRootFromParent_Done,
     /* 2264542 */   // Label 30506: @2264542
     /* 2264542 */   GIM_Reject,
     /* 2264543 */ // Label 30502: @2264543
     /* 2264543 */ GIM_Reject,
     /* 2264544 */ // Label 30468: @2264544
     /* 2264544 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2264751),
     /* 2264549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2264552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2264555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2264558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2264562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2264566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264574 */   GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2264618), // Rule ID 52262 //
     /* 2264579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264582 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2264599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264608 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264617 */     // GIR_Coverage, 52262,
     /* 2264617 */     GIR_EraseRootFromParent_Done,
     /* 2264618 */   // Label 30508: @2264618
     /* 2264618 */   GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2264662), // Rule ID 52263 //
     /* 2264623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264626 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2264643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264661 */     // GIR_Coverage, 52263,
     /* 2264661 */     GIR_EraseRootFromParent_Done,
     /* 2264662 */   // Label 30509: @2264662
     /* 2264662 */   GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2264706), // Rule ID 58092 //
     /* 2264667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264670 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2264670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2264687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264696 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264705 */     // GIR_Coverage, 58092,
     /* 2264705 */     GIR_EraseRootFromParent_Done,
     /* 2264706 */   // Label 30510: @2264706
     /* 2264706 */   GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2264750), // Rule ID 58093 //
     /* 2264711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264714 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2264714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2264731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264740 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264749 */     // GIR_Coverage, 58093,
     /* 2264749 */     GIR_EraseRootFromParent_Done,
     /* 2264750 */   // Label 30511: @2264750
     /* 2264750 */   GIM_Reject,
     /* 2264751 */ // Label 30507: @2264751
     /* 2264751 */ GIM_Reject,
     /* 2264752 */ // Label 30469: @2264752
     /* 2264752 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2264959),
     /* 2264757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2264760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2264763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2264766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2264770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2264774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264782 */   GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2264826), // Rule ID 52286 //
     /* 2264787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2264790 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2264790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2264807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264816 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264825 */     // GIR_Coverage, 52286,
     /* 2264825 */     GIR_EraseRootFromParent_Done,
     /* 2264826 */   // Label 30513: @2264826
     /* 2264826 */   GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2264870), // Rule ID 52287 //
     /* 2264831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2264834 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2264834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2264851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264860 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264869 */     // GIR_Coverage, 52287,
     /* 2264869 */     GIR_EraseRootFromParent_Done,
     /* 2264870 */   // Label 30514: @2264870
     /* 2264870 */   GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2264914), // Rule ID 58122 //
     /* 2264875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2264878 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2264878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2264895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264904 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264913 */     // GIR_Coverage, 58122,
     /* 2264913 */     GIR_EraseRootFromParent_Done,
     /* 2264914 */   // Label 30515: @2264914
     /* 2264914 */   GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2264958), // Rule ID 58123 //
     /* 2264919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2264922 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2264922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2264939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2264950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264957 */     // GIR_Coverage, 58123,
     /* 2264957 */     GIR_EraseRootFromParent_Done,
     /* 2264958 */   // Label 30516: @2264958
     /* 2264958 */   GIM_Reject,
     /* 2264959 */ // Label 30512: @2264959
     /* 2264959 */ GIM_Reject,
     /* 2264960 */ // Label 30470: @2264960
     /* 2264960 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2265079),
     /* 2264965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2264968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2264971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2264974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2264978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2264982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264986 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264990 */   GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2265034), // Rule ID 52238 //
     /* 2264995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264998 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2265001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2265015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265024 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265033 */     // GIR_Coverage, 52238,
     /* 2265033 */     GIR_EraseRootFromParent_Done,
     /* 2265034 */   // Label 30518: @2265034
     /* 2265034 */   GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2265078), // Rule ID 52239 //
     /* 2265039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265042 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2265045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2265059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265068 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265077 */     // GIR_Coverage, 52239,
     /* 2265077 */     GIR_EraseRootFromParent_Done,
     /* 2265078 */   // Label 30519: @2265078
     /* 2265078 */   GIM_Reject,
     /* 2265079 */ // Label 30517: @2265079
     /* 2265079 */ GIM_Reject,
     /* 2265080 */ // Label 30471: @2265080
     /* 2265080 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2265287),
     /* 2265085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2265088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2265091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2265094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2265098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2265102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265110 */   GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2265154), // Rule ID 52256 //
     /* 2265115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265118 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265144 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265153 */     // GIR_Coverage, 52256,
     /* 2265153 */     GIR_EraseRootFromParent_Done,
     /* 2265154 */   // Label 30521: @2265154
     /* 2265154 */   GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2265198), // Rule ID 52257 //
     /* 2265159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265162 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265197 */     // GIR_Coverage, 52257,
     /* 2265197 */     GIR_EraseRootFromParent_Done,
     /* 2265198 */   // Label 30522: @2265198
     /* 2265198 */   GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2265242), // Rule ID 58082 //
     /* 2265203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265206 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265232 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265241 */     // GIR_Coverage, 58082,
     /* 2265241 */     GIR_EraseRootFromParent_Done,
     /* 2265242 */   // Label 30523: @2265242
     /* 2265242 */   GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2265286), // Rule ID 58083 //
     /* 2265247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265250 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2265253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265276 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265285 */     // GIR_Coverage, 58083,
     /* 2265285 */     GIR_EraseRootFromParent_Done,
     /* 2265286 */   // Label 30524: @2265286
     /* 2265286 */   GIM_Reject,
     /* 2265287 */ // Label 30520: @2265287
     /* 2265287 */ GIM_Reject,
     /* 2265288 */ // Label 30472: @2265288
     /* 2265288 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2265495),
     /* 2265293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2265296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2265299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2265302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2265306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2265310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265318 */   GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2265362), // Rule ID 52280 //
     /* 2265323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265326 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265352 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265361 */     // GIR_Coverage, 52280,
     /* 2265361 */     GIR_EraseRootFromParent_Done,
     /* 2265362 */   // Label 30526: @2265362
     /* 2265362 */   GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2265406), // Rule ID 52281 //
     /* 2265367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265370 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265396 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265405 */     // GIR_Coverage, 52281,
     /* 2265405 */     GIR_EraseRootFromParent_Done,
     /* 2265406 */   // Label 30527: @2265406
     /* 2265406 */   GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2265450), // Rule ID 58112 //
     /* 2265411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265414 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2265414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265440 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265449 */     // GIR_Coverage, 58112,
     /* 2265449 */     GIR_EraseRootFromParent_Done,
     /* 2265450 */   // Label 30528: @2265450
     /* 2265450 */   GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2265494), // Rule ID 58113 //
     /* 2265455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265458 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2265458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2265461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265484 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265493 */     // GIR_Coverage, 58113,
     /* 2265493 */     GIR_EraseRootFromParent_Done,
     /* 2265494 */   // Label 30529: @2265494
     /* 2265494 */   GIM_Reject,
     /* 2265495 */ // Label 30525: @2265495
     /* 2265495 */ GIM_Reject,
     /* 2265496 */ // Label 30473: @2265496
     /* 2265496 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2265703),
     /* 2265501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2265504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2265507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2265510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2265514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2265518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265526 */   GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2265570), // Rule ID 52346 //
     /* 2265531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2265534 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2265534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2265551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265560 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265569 */     // GIR_Coverage, 52346,
     /* 2265569 */     GIR_EraseRootFromParent_Done,
     /* 2265570 */   // Label 30531: @2265570
     /* 2265570 */   GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2265614), // Rule ID 52347 //
     /* 2265575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2265578 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2265578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2265595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265604 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265613 */     // GIR_Coverage, 52347,
     /* 2265613 */     GIR_EraseRootFromParent_Done,
     /* 2265614 */   // Label 30532: @2265614
     /* 2265614 */   GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2265658), // Rule ID 58192 //
     /* 2265619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2265622 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2265622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2265639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265648 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265657 */     // GIR_Coverage, 58192,
     /* 2265657 */     GIR_EraseRootFromParent_Done,
     /* 2265658 */   // Label 30533: @2265658
     /* 2265658 */   GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2265702), // Rule ID 58193 //
     /* 2265663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2265666 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2265666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2265669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2265683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265692 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265701 */     // GIR_Coverage, 58193,
     /* 2265701 */     GIR_EraseRootFromParent_Done,
     /* 2265702 */   // Label 30534: @2265702
     /* 2265702 */   GIM_Reject,
     /* 2265703 */ // Label 30530: @2265703
     /* 2265703 */ GIM_Reject,
     /* 2265704 */ // Label 30474: @2265704
     /* 2265704 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2265823),
     /* 2265709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2265712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2265715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2265718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2265722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2265726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265734 */   GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2265778), // Rule ID 52244 //
     /* 2265739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265742 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265768 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265777 */     // GIR_Coverage, 52244,
     /* 2265777 */     GIR_EraseRootFromParent_Done,
     /* 2265778 */   // Label 30536: @2265778
     /* 2265778 */   GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2265822), // Rule ID 52245 //
     /* 2265783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265786 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2265803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265812 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265821 */     // GIR_Coverage, 52245,
     /* 2265821 */     GIR_EraseRootFromParent_Done,
     /* 2265822 */   // Label 30537: @2265822
     /* 2265822 */   GIM_Reject,
     /* 2265823 */ // Label 30535: @2265823
     /* 2265823 */ GIM_Reject,
     /* 2265824 */ // Label 30475: @2265824
     /* 2265824 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2266031),
     /* 2265829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2265832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2265835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2265838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2265842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2265846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265850 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265854 */   GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2265898), // Rule ID 52274 //
     /* 2265859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265862 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265888 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265897 */     // GIR_Coverage, 52274,
     /* 2265897 */     GIR_EraseRootFromParent_Done,
     /* 2265898 */   // Label 30539: @2265898
     /* 2265898 */   GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2265942), // Rule ID 52275 //
     /* 2265903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265906 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265932 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265941 */     // GIR_Coverage, 52275,
     /* 2265941 */     GIR_EraseRootFromParent_Done,
     /* 2265942 */   // Label 30540: @2265942
     /* 2265942 */   GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2265986), // Rule ID 58102 //
     /* 2265947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265950 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2265967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265976 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2265978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265985 */     // GIR_Coverage, 58102,
     /* 2265985 */     GIR_EraseRootFromParent_Done,
     /* 2265986 */   // Label 30541: @2265986
     /* 2265986 */   GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2266030), // Rule ID 58103 //
     /* 2265991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265994 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2266011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266020 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266029 */     // GIR_Coverage, 58103,
     /* 2266029 */     GIR_EraseRootFromParent_Done,
     /* 2266030 */   // Label 30542: @2266030
     /* 2266030 */   GIM_Reject,
     /* 2266031 */ // Label 30538: @2266031
     /* 2266031 */ GIM_Reject,
     /* 2266032 */ // Label 30476: @2266032
     /* 2266032 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2266239),
     /* 2266037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2266040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2266043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2266046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2266050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2266054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266062 */   GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2266106), // Rule ID 52328 //
     /* 2266067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266070 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2266073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266096 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266105 */     // GIR_Coverage, 52328,
     /* 2266105 */     GIR_EraseRootFromParent_Done,
     /* 2266106 */   // Label 30544: @2266106
     /* 2266106 */   GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2266150), // Rule ID 52329 //
     /* 2266111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266114 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2266117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266140 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266149 */     // GIR_Coverage, 52329,
     /* 2266149 */     GIR_EraseRootFromParent_Done,
     /* 2266150 */   // Label 30545: @2266150
     /* 2266150 */   GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2266194), // Rule ID 58162 //
     /* 2266155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266158 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2266161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266184 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266193 */     // GIR_Coverage, 58162,
     /* 2266193 */     GIR_EraseRootFromParent_Done,
     /* 2266194 */   // Label 30546: @2266194
     /* 2266194 */   GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2266238), // Rule ID 58163 //
     /* 2266199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266202 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2266205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266228 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266237 */     // GIR_Coverage, 58163,
     /* 2266237 */     GIR_EraseRootFromParent_Done,
     /* 2266238 */   // Label 30547: @2266238
     /* 2266238 */   GIM_Reject,
     /* 2266239 */ // Label 30543: @2266239
     /* 2266239 */ GIM_Reject,
     /* 2266240 */ // Label 30477: @2266240
     /* 2266240 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2266447),
     /* 2266245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2266248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2266251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2266254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2266258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2266262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266270 */   GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2266314), // Rule ID 52352 //
     /* 2266275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2266278 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2266278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2266281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266304 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266313 */     // GIR_Coverage, 52352,
     /* 2266313 */     GIR_EraseRootFromParent_Done,
     /* 2266314 */   // Label 30549: @2266314
     /* 2266314 */   GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2266358), // Rule ID 52353 //
     /* 2266319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2266322 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2266322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2266325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266348 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266357 */     // GIR_Coverage, 52353,
     /* 2266357 */     GIR_EraseRootFromParent_Done,
     /* 2266358 */   // Label 30550: @2266358
     /* 2266358 */   GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2266402), // Rule ID 58202 //
     /* 2266363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2266366 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2266366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2266369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266392 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266401 */     // GIR_Coverage, 58202,
     /* 2266401 */     GIR_EraseRootFromParent_Done,
     /* 2266402 */   // Label 30551: @2266402
     /* 2266402 */   GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2266446), // Rule ID 58203 //
     /* 2266407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2266410 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2266410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2266413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266436 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2266444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266445 */     // GIR_Coverage, 58203,
     /* 2266445 */     GIR_EraseRootFromParent_Done,
     /* 2266446 */   // Label 30552: @2266446
     /* 2266446 */   GIM_Reject,
     /* 2266447 */ // Label 30548: @2266447
     /* 2266447 */ GIM_Reject,
     /* 2266448 */ // Label 30478: @2266448
     /* 2266448 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2266567),
     /* 2266453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2266456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2266459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2266462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2266466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2266470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266478 */   GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2266522), // Rule ID 52268 //
     /* 2266483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266486 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2266489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2266503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266512 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266521 */     // GIR_Coverage, 52268,
     /* 2266521 */     GIR_EraseRootFromParent_Done,
     /* 2266522 */   // Label 30554: @2266522
     /* 2266522 */   GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2266566), // Rule ID 52269 //
     /* 2266527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266530 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2266533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2266547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266556 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266565 */     // GIR_Coverage, 52269,
     /* 2266565 */     GIR_EraseRootFromParent_Done,
     /* 2266566 */   // Label 30555: @2266566
     /* 2266566 */   GIM_Reject,
     /* 2266567 */ // Label 30553: @2266567
     /* 2266567 */ GIM_Reject,
     /* 2266568 */ // Label 30479: @2266568
     /* 2266568 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2266775),
     /* 2266573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2266576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2266579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2266582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2266586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2266590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2266598 */   GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2266642), // Rule ID 52310 //
     /* 2266603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266606 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2266609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266632 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266641 */     // GIR_Coverage, 52310,
     /* 2266641 */     GIR_EraseRootFromParent_Done,
     /* 2266642 */   // Label 30557: @2266642
     /* 2266642 */   GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2266686), // Rule ID 52311 //
     /* 2266647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266650 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2266653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266676 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266685 */     // GIR_Coverage, 52311,
     /* 2266685 */     GIR_EraseRootFromParent_Done,
     /* 2266686 */   // Label 30558: @2266686
     /* 2266686 */   GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2266730), // Rule ID 58132 //
     /* 2266691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266694 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2266694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2266697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266720 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266729 */     // GIR_Coverage, 58132,
     /* 2266729 */     GIR_EraseRootFromParent_Done,
     /* 2266730 */   // Label 30559: @2266730
     /* 2266730 */   GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2266774), // Rule ID 58133 //
     /* 2266735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266738 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2266738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2266741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2266755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266764 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266773 */     // GIR_Coverage, 58133,
     /* 2266773 */     GIR_EraseRootFromParent_Done,
     /* 2266774 */   // Label 30560: @2266774
     /* 2266774 */   GIM_Reject,
     /* 2266775 */ // Label 30556: @2266775
     /* 2266775 */ GIM_Reject,
     /* 2266776 */ // Label 30480: @2266776
     /* 2266776 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2266983),
     /* 2266781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2266784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2266787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2266790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2266794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2266798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266806 */   GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2266850), // Rule ID 52334 //
     /* 2266811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266814 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2266817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266840 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266849 */     // GIR_Coverage, 52334,
     /* 2266849 */     GIR_EraseRootFromParent_Done,
     /* 2266850 */   // Label 30562: @2266850
     /* 2266850 */   GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2266894), // Rule ID 52335 //
     /* 2266855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266858 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2266861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266884 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266893 */     // GIR_Coverage, 52335,
     /* 2266893 */     GIR_EraseRootFromParent_Done,
     /* 2266894 */   // Label 30563: @2266894
     /* 2266894 */   GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2266938), // Rule ID 58172 //
     /* 2266899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266902 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2266902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2266905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266928 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266937 */     // GIR_Coverage, 58172,
     /* 2266937 */     GIR_EraseRootFromParent_Done,
     /* 2266938 */   // Label 30564: @2266938
     /* 2266938 */   GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2266982), // Rule ID 58173 //
     /* 2266943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266946 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2266946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2266949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2266963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266972 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2266974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266981 */     // GIR_Coverage, 58173,
     /* 2266981 */     GIR_EraseRootFromParent_Done,
     /* 2266982 */   // Label 30565: @2266982
     /* 2266982 */   GIM_Reject,
     /* 2266983 */ // Label 30561: @2266983
     /* 2266983 */ GIM_Reject,
     /* 2266984 */ // Label 30481: @2266984
     /* 2266984 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2267191),
     /* 2266989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2266992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2266995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2266998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2267002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267014 */   GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2267058), // Rule ID 52358 //
     /* 2267019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2267022 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2267022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2267025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267048 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267057 */     // GIR_Coverage, 52358,
     /* 2267057 */     GIR_EraseRootFromParent_Done,
     /* 2267058 */   // Label 30567: @2267058
     /* 2267058 */   GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2267102), // Rule ID 52359 //
     /* 2267063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2267066 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2267066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2267069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267092 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267101 */     // GIR_Coverage, 52359,
     /* 2267101 */     GIR_EraseRootFromParent_Done,
     /* 2267102 */   // Label 30568: @2267102
     /* 2267102 */   GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2267146), // Rule ID 58212 //
     /* 2267107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2267110 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2267110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2267113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267136 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267145 */     // GIR_Coverage, 58212,
     /* 2267145 */     GIR_EraseRootFromParent_Done,
     /* 2267146 */   // Label 30569: @2267146
     /* 2267146 */   GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2267190), // Rule ID 58213 //
     /* 2267151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2267154 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2267154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2267157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267180 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267189 */     // GIR_Coverage, 58213,
     /* 2267189 */     GIR_EraseRootFromParent_Done,
     /* 2267190 */   // Label 30570: @2267190
     /* 2267190 */   GIM_Reject,
     /* 2267191 */ // Label 30566: @2267191
     /* 2267191 */ GIM_Reject,
     /* 2267192 */ // Label 30482: @2267192
     /* 2267192 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2267311),
     /* 2267197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2267200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2267203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2267206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2267210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267222 */   GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2267266), // Rule ID 52292 //
     /* 2267227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267230 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2267233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2267247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267256 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267265 */     // GIR_Coverage, 52292,
     /* 2267265 */     GIR_EraseRootFromParent_Done,
     /* 2267266 */   // Label 30572: @2267266
     /* 2267266 */   GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2267310), // Rule ID 52293 //
     /* 2267271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267274 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2267277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2267291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267300 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267309 */     // GIR_Coverage, 52293,
     /* 2267309 */     GIR_EraseRootFromParent_Done,
     /* 2267310 */   // Label 30573: @2267310
     /* 2267310 */   GIM_Reject,
     /* 2267311 */ // Label 30571: @2267311
     /* 2267311 */ GIM_Reject,
     /* 2267312 */ // Label 30483: @2267312
     /* 2267312 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2267519),
     /* 2267317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2267320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2267323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2267326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2267330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267342 */   GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2267386), // Rule ID 52316 //
     /* 2267347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267350 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2267353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267376 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267385 */     // GIR_Coverage, 52316,
     /* 2267385 */     GIR_EraseRootFromParent_Done,
     /* 2267386 */   // Label 30575: @2267386
     /* 2267386 */   GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2267430), // Rule ID 52317 //
     /* 2267391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267394 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2267397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267420 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267429 */     // GIR_Coverage, 52317,
     /* 2267429 */     GIR_EraseRootFromParent_Done,
     /* 2267430 */   // Label 30576: @2267430
     /* 2267430 */   GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2267474), // Rule ID 58142 //
     /* 2267435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267438 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2267441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267473 */     // GIR_Coverage, 58142,
     /* 2267473 */     GIR_EraseRootFromParent_Done,
     /* 2267474 */   // Label 30577: @2267474
     /* 2267474 */   GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2267518), // Rule ID 58143 //
     /* 2267479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267482 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2267485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267508 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267517 */     // GIR_Coverage, 58143,
     /* 2267517 */     GIR_EraseRootFromParent_Done,
     /* 2267518 */   // Label 30578: @2267518
     /* 2267518 */   GIM_Reject,
     /* 2267519 */ // Label 30574: @2267519
     /* 2267519 */ GIM_Reject,
     /* 2267520 */ // Label 30484: @2267520
     /* 2267520 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2267727),
     /* 2267525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2267528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2267531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2267534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2267538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267550 */   GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2267594), // Rule ID 52340 //
     /* 2267555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267558 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2267558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2267561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267593 */     // GIR_Coverage, 52340,
     /* 2267593 */     GIR_EraseRootFromParent_Done,
     /* 2267594 */   // Label 30580: @2267594
     /* 2267594 */   GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2267638), // Rule ID 52341 //
     /* 2267599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267602 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2267602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2267605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267628 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267637 */     // GIR_Coverage, 52341,
     /* 2267637 */     GIR_EraseRootFromParent_Done,
     /* 2267638 */   // Label 30581: @2267638
     /* 2267638 */   GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2267682), // Rule ID 58182 //
     /* 2267643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267646 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2267646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2267649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267672 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267681 */     // GIR_Coverage, 58182,
     /* 2267681 */     GIR_EraseRootFromParent_Done,
     /* 2267682 */   // Label 30582: @2267682
     /* 2267682 */   GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2267726), // Rule ID 58183 //
     /* 2267687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267690 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2267690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2267693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267725 */     // GIR_Coverage, 58183,
     /* 2267725 */     GIR_EraseRootFromParent_Done,
     /* 2267726 */   // Label 30583: @2267726
     /* 2267726 */   GIM_Reject,
     /* 2267727 */ // Label 30579: @2267727
     /* 2267727 */ GIM_Reject,
     /* 2267728 */ // Label 30485: @2267728
     /* 2267728 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2267847),
     /* 2267733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2267736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2267739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2267742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2267746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2267758 */   GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2267802), // Rule ID 52298 //
     /* 2267763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267766 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2267769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267792 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267801 */     // GIR_Coverage, 52298,
     /* 2267801 */     GIR_EraseRootFromParent_Done,
     /* 2267802 */   // Label 30585: @2267802
     /* 2267802 */   GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2267846), // Rule ID 52299 //
     /* 2267807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267810 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2267813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2267827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267836 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267845 */     // GIR_Coverage, 52299,
     /* 2267845 */     GIR_EraseRootFromParent_Done,
     /* 2267846 */   // Label 30586: @2267846
     /* 2267846 */   GIM_Reject,
     /* 2267847 */ // Label 30584: @2267847
     /* 2267847 */ GIM_Reject,
     /* 2267848 */ // Label 30486: @2267848
     /* 2267848 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2268055),
     /* 2267853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2267856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2267859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2267862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2267866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2267870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2267878 */   GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2267922), // Rule ID 52322 //
     /* 2267883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267886 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2267889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267912 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267921 */     // GIR_Coverage, 52322,
     /* 2267921 */     GIR_EraseRootFromParent_Done,
     /* 2267922 */   // Label 30588: @2267922
     /* 2267922 */   GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2267966), // Rule ID 52323 //
     /* 2267927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267930 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2267933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267956 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2267958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267965 */     // GIR_Coverage, 52323,
     /* 2267965 */     GIR_EraseRootFromParent_Done,
     /* 2267966 */   // Label 30589: @2267966
     /* 2267966 */   GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2268010), // Rule ID 58152 //
     /* 2267971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267974 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2267977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2267991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268000 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2268002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268009 */     // GIR_Coverage, 58152,
     /* 2268009 */     GIR_EraseRootFromParent_Done,
     /* 2268010 */   // Label 30590: @2268010
     /* 2268010 */   GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2268054), // Rule ID 58153 //
     /* 2268015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268018 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2268021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2268035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268044 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2268046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268053 */     // GIR_Coverage, 58153,
     /* 2268053 */     GIR_EraseRootFromParent_Done,
     /* 2268054 */   // Label 30591: @2268054
     /* 2268054 */   GIM_Reject,
     /* 2268055 */ // Label 30587: @2268055
     /* 2268055 */ GIM_Reject,
     /* 2268056 */ // Label 30487: @2268056
     /* 2268056 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2268175),
     /* 2268061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2268064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2268067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2268070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2268074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2268078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268082 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268086 */   GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2268130), // Rule ID 52304 //
     /* 2268091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268094 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2268097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2268111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268120 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2268122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268129 */     // GIR_Coverage, 52304,
     /* 2268129 */     GIR_EraseRootFromParent_Done,
     /* 2268130 */   // Label 30593: @2268130
     /* 2268130 */   GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2268174), // Rule ID 52305 //
     /* 2268135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268138 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2268141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2268155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2268166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268173 */     // GIR_Coverage, 52305,
     /* 2268173 */     GIR_EraseRootFromParent_Done,
     /* 2268174 */   // Label 30594: @2268174
     /* 2268174 */   GIM_Reject,
     /* 2268175 */ // Label 30592: @2268175
     /* 2268175 */ GIM_Reject,
     /* 2268176 */ // Label 30488: @2268176
     /* 2268176 */ GIM_Reject,
     /* 2268177 */ // Label 51: @2268177
     /* 2268177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30619*/ GIMT_Encode4(2270910),
     /* 2268188 */ /*GILLT_s32*//*Label 30595*/ GIMT_Encode4(2268312),
     /* 2268192 */ /*GILLT_s64*//*Label 30596*/ GIMT_Encode4(2268346), GIMT_Encode4(0),
     /* 2268200 */ /*GILLT_nxv1s8*//*Label 30597*/ GIMT_Encode4(2268380),
     /* 2268204 */ /*GILLT_nxv1s16*//*Label 30598*/ GIMT_Encode4(2268495),
     /* 2268208 */ /*GILLT_nxv1s32*//*Label 30599*/ GIMT_Encode4(2268610),
     /* 2268212 */ /*GILLT_nxv1s64*//*Label 30600*/ GIMT_Encode4(2268725), GIMT_Encode4(0),
     /* 2268220 */ /*GILLT_nxv2s8*//*Label 30601*/ GIMT_Encode4(2268840),
     /* 2268224 */ /*GILLT_nxv2s16*//*Label 30602*/ GIMT_Encode4(2268955),
     /* 2268228 */ /*GILLT_nxv2s32*//*Label 30603*/ GIMT_Encode4(2269070),
     /* 2268232 */ /*GILLT_nxv2s64*//*Label 30604*/ GIMT_Encode4(2269185), GIMT_Encode4(0),
     /* 2268240 */ /*GILLT_nxv4s8*//*Label 30605*/ GIMT_Encode4(2269300),
     /* 2268244 */ /*GILLT_nxv4s16*//*Label 30606*/ GIMT_Encode4(2269415),
     /* 2268248 */ /*GILLT_nxv4s32*//*Label 30607*/ GIMT_Encode4(2269530),
     /* 2268252 */ /*GILLT_nxv4s64*//*Label 30608*/ GIMT_Encode4(2269645), GIMT_Encode4(0),
     /* 2268260 */ /*GILLT_nxv8s8*//*Label 30609*/ GIMT_Encode4(2269760),
     /* 2268264 */ /*GILLT_nxv8s16*//*Label 30610*/ GIMT_Encode4(2269875),
     /* 2268268 */ /*GILLT_nxv8s32*//*Label 30611*/ GIMT_Encode4(2269990),
     /* 2268272 */ /*GILLT_nxv8s64*//*Label 30612*/ GIMT_Encode4(2270105), GIMT_Encode4(0),
     /* 2268280 */ /*GILLT_nxv16s8*//*Label 30613*/ GIMT_Encode4(2270220),
     /* 2268284 */ /*GILLT_nxv16s16*//*Label 30614*/ GIMT_Encode4(2270335),
     /* 2268288 */ /*GILLT_nxv16s32*//*Label 30615*/ GIMT_Encode4(2270450), GIMT_Encode4(0),
     /* 2268296 */ /*GILLT_nxv32s8*//*Label 30616*/ GIMT_Encode4(2270565),
     /* 2268300 */ /*GILLT_nxv32s16*//*Label 30617*/ GIMT_Encode4(2270680), GIMT_Encode4(0),
     /* 2268308 */ /*GILLT_nxv64s8*//*Label 30618*/ GIMT_Encode4(2270795),
     /* 2268312 */ // Label 30595: @2268312
     /* 2268312 */ GIM_Try, /*On fail goto*//*Label 30620*/ GIMT_Encode4(2268345), // Rule ID 294 //
     /* 2268317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2268320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2268323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2268326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268338 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2268338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2268343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268344 */   // GIR_Coverage, 294,
     /* 2268344 */   GIR_Done,
     /* 2268345 */ // Label 30620: @2268345
     /* 2268345 */ GIM_Reject,
     /* 2268346 */ // Label 30596: @2268346
     /* 2268346 */ GIM_Try, /*On fail goto*//*Label 30621*/ GIMT_Encode4(2268379), // Rule ID 293 //
     /* 2268351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2268354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2268357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2268360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2268372 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2268372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2268377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268378 */   // GIR_Coverage, 293,
     /* 2268378 */   GIR_Done,
     /* 2268379 */ // Label 30621: @2268379
     /* 2268379 */ GIM_Reject,
     /* 2268380 */ // Label 30597: @2268380
     /* 2268380 */ GIM_Try, /*On fail goto*//*Label 30622*/ GIMT_Encode4(2268494),
     /* 2268385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2268388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2268391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268403 */   GIM_Try, /*On fail goto*//*Label 30623*/ GIMT_Encode4(2268448), // Rule ID 51008 //
     /* 2268408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268411 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2268414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2268428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268447 */     // GIR_Coverage, 51008,
     /* 2268447 */     GIR_EraseRootFromParent_Done,
     /* 2268448 */   // Label 30623: @2268448
     /* 2268448 */   GIM_Try, /*On fail goto*//*Label 30624*/ GIMT_Encode4(2268493), // Rule ID 51009 //
     /* 2268453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268456 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2268459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2268473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268492 */     // GIR_Coverage, 51009,
     /* 2268492 */     GIR_EraseRootFromParent_Done,
     /* 2268493 */   // Label 30624: @2268493
     /* 2268493 */   GIM_Reject,
     /* 2268494 */ // Label 30622: @2268494
     /* 2268494 */ GIM_Reject,
     /* 2268495 */ // Label 30598: @2268495
     /* 2268495 */ GIM_Try, /*On fail goto*//*Label 30625*/ GIMT_Encode4(2268609),
     /* 2268500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2268503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268518 */   GIM_Try, /*On fail goto*//*Label 30626*/ GIMT_Encode4(2268563), // Rule ID 51020 //
     /* 2268523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268526 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2268529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2268543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268562 */     // GIR_Coverage, 51020,
     /* 2268562 */     GIR_EraseRootFromParent_Done,
     /* 2268563 */   // Label 30626: @2268563
     /* 2268563 */   GIM_Try, /*On fail goto*//*Label 30627*/ GIMT_Encode4(2268608), // Rule ID 51021 //
     /* 2268568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268571 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2268574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2268588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268607 */     // GIR_Coverage, 51021,
     /* 2268607 */     GIR_EraseRootFromParent_Done,
     /* 2268608 */   // Label 30627: @2268608
     /* 2268608 */   GIM_Reject,
     /* 2268609 */ // Label 30625: @2268609
     /* 2268609 */ GIM_Reject,
     /* 2268610 */ // Label 30599: @2268610
     /* 2268610 */ GIM_Try, /*On fail goto*//*Label 30628*/ GIMT_Encode4(2268724),
     /* 2268615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2268618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268633 */   GIM_Try, /*On fail goto*//*Label 30629*/ GIMT_Encode4(2268678), // Rule ID 51028 //
     /* 2268638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268641 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2268644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2268658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268677 */     // GIR_Coverage, 51028,
     /* 2268677 */     GIR_EraseRootFromParent_Done,
     /* 2268678 */   // Label 30629: @2268678
     /* 2268678 */   GIM_Try, /*On fail goto*//*Label 30630*/ GIMT_Encode4(2268723), // Rule ID 51029 //
     /* 2268683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268686 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2268689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2268703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268722 */     // GIR_Coverage, 51029,
     /* 2268722 */     GIR_EraseRootFromParent_Done,
     /* 2268723 */   // Label 30630: @2268723
     /* 2268723 */   GIM_Reject,
     /* 2268724 */ // Label 30628: @2268724
     /* 2268724 */ GIM_Reject,
     /* 2268725 */ // Label 30600: @2268725
     /* 2268725 */ GIM_Try, /*On fail goto*//*Label 30631*/ GIMT_Encode4(2268839),
     /* 2268730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2268733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268748 */   GIM_Try, /*On fail goto*//*Label 30632*/ GIMT_Encode4(2268793), // Rule ID 51096 //
     /* 2268753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2268756 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2268759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2268773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268792 */     // GIR_Coverage, 51096,
     /* 2268792 */     GIR_EraseRootFromParent_Done,
     /* 2268793 */   // Label 30632: @2268793
     /* 2268793 */   GIM_Try, /*On fail goto*//*Label 30633*/ GIMT_Encode4(2268838), // Rule ID 51097 //
     /* 2268798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2268801 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2268804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2268818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268837 */     // GIR_Coverage, 51097,
     /* 2268837 */     GIR_EraseRootFromParent_Done,
     /* 2268838 */   // Label 30633: @2268838
     /* 2268838 */   GIM_Reject,
     /* 2268839 */ // Label 30631: @2268839
     /* 2268839 */ GIM_Reject,
     /* 2268840 */ // Label 30601: @2268840
     /* 2268840 */ GIM_Try, /*On fail goto*//*Label 30634*/ GIMT_Encode4(2268954),
     /* 2268845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2268848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2268851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268863 */   GIM_Try, /*On fail goto*//*Label 30635*/ GIMT_Encode4(2268908), // Rule ID 51012 //
     /* 2268868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268871 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2268874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2268888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268907 */     // GIR_Coverage, 51012,
     /* 2268907 */     GIR_EraseRootFromParent_Done,
     /* 2268908 */   // Label 30635: @2268908
     /* 2268908 */   GIM_Try, /*On fail goto*//*Label 30636*/ GIMT_Encode4(2268953), // Rule ID 51013 //
     /* 2268913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268916 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2268919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2268933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268952 */     // GIR_Coverage, 51013,
     /* 2268952 */     GIR_EraseRootFromParent_Done,
     /* 2268953 */   // Label 30636: @2268953
     /* 2268953 */   GIM_Reject,
     /* 2268954 */ // Label 30634: @2268954
     /* 2268954 */ GIM_Reject,
     /* 2268955 */ // Label 30602: @2268955
     /* 2268955 */ GIM_Try, /*On fail goto*//*Label 30637*/ GIMT_Encode4(2269069),
     /* 2268960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2268963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2268966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268978 */   GIM_Try, /*On fail goto*//*Label 30638*/ GIMT_Encode4(2269023), // Rule ID 51024 //
     /* 2268983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268986 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2268989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2269003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269022 */     // GIR_Coverage, 51024,
     /* 2269022 */     GIR_EraseRootFromParent_Done,
     /* 2269023 */   // Label 30638: @2269023
     /* 2269023 */   GIM_Try, /*On fail goto*//*Label 30639*/ GIMT_Encode4(2269068), // Rule ID 51025 //
     /* 2269028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269031 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2269034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2269048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269067 */     // GIR_Coverage, 51025,
     /* 2269067 */     GIR_EraseRootFromParent_Done,
     /* 2269068 */   // Label 30639: @2269068
     /* 2269068 */   GIM_Reject,
     /* 2269069 */ // Label 30637: @2269069
     /* 2269069 */ GIM_Reject,
     /* 2269070 */ // Label 30603: @2269070
     /* 2269070 */ GIM_Try, /*On fail goto*//*Label 30640*/ GIMT_Encode4(2269184),
     /* 2269075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2269078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269093 */   GIM_Try, /*On fail goto*//*Label 30641*/ GIMT_Encode4(2269138), // Rule ID 51040 //
     /* 2269098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269101 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2269104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269137 */     // GIR_Coverage, 51040,
     /* 2269137 */     GIR_EraseRootFromParent_Done,
     /* 2269138 */   // Label 30641: @2269138
     /* 2269138 */   GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2269183), // Rule ID 51041 //
     /* 2269143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269146 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2269149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269182 */     // GIR_Coverage, 51041,
     /* 2269182 */     GIR_EraseRootFromParent_Done,
     /* 2269183 */   // Label 30642: @2269183
     /* 2269183 */   GIM_Reject,
     /* 2269184 */ // Label 30640: @2269184
     /* 2269184 */ GIM_Reject,
     /* 2269185 */ // Label 30604: @2269185
     /* 2269185 */ GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2269299),
     /* 2269190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2269193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269208 */   GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2269253), // Rule ID 51100 //
     /* 2269213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2269216 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2269219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269252 */     // GIR_Coverage, 51100,
     /* 2269252 */     GIR_EraseRootFromParent_Done,
     /* 2269253 */   // Label 30644: @2269253
     /* 2269253 */   GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2269298), // Rule ID 51101 //
     /* 2269258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2269261 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2269264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269297 */     // GIR_Coverage, 51101,
     /* 2269297 */     GIR_EraseRootFromParent_Done,
     /* 2269298 */   // Label 30645: @2269298
     /* 2269298 */   GIM_Reject,
     /* 2269299 */ // Label 30643: @2269299
     /* 2269299 */ GIM_Reject,
     /* 2269300 */ // Label 30605: @2269300
     /* 2269300 */ GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2269414),
     /* 2269305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2269308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2269311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269323 */   GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2269368), // Rule ID 51016 //
     /* 2269328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269331 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2269334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2269348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269367 */     // GIR_Coverage, 51016,
     /* 2269367 */     GIR_EraseRootFromParent_Done,
     /* 2269368 */   // Label 30647: @2269368
     /* 2269368 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2269413), // Rule ID 51017 //
     /* 2269373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269376 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2269379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2269393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269412 */     // GIR_Coverage, 51017,
     /* 2269412 */     GIR_EraseRootFromParent_Done,
     /* 2269413 */   // Label 30648: @2269413
     /* 2269413 */   GIM_Reject,
     /* 2269414 */ // Label 30646: @2269414
     /* 2269414 */ GIM_Reject,
     /* 2269415 */ // Label 30606: @2269415
     /* 2269415 */ GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2269529),
     /* 2269420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2269423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2269426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269438 */   GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2269483), // Rule ID 51036 //
     /* 2269443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269446 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2269449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269482 */     // GIR_Coverage, 51036,
     /* 2269482 */     GIR_EraseRootFromParent_Done,
     /* 2269483 */   // Label 30650: @2269483
     /* 2269483 */   GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2269528), // Rule ID 51037 //
     /* 2269488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269491 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2269494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269527 */     // GIR_Coverage, 51037,
     /* 2269527 */     GIR_EraseRootFromParent_Done,
     /* 2269528 */   // Label 30651: @2269528
     /* 2269528 */   GIM_Reject,
     /* 2269529 */ // Label 30649: @2269529
     /* 2269529 */ GIM_Reject,
     /* 2269530 */ // Label 30607: @2269530
     /* 2269530 */ GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2269644),
     /* 2269535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2269538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2269541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269553 */   GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2269598), // Rule ID 51068 //
     /* 2269558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269561 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2269564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269597 */     // GIR_Coverage, 51068,
     /* 2269597 */     GIR_EraseRootFromParent_Done,
     /* 2269598 */   // Label 30653: @2269598
     /* 2269598 */   GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2269643), // Rule ID 51069 //
     /* 2269603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269606 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2269609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269642 */     // GIR_Coverage, 51069,
     /* 2269642 */     GIR_EraseRootFromParent_Done,
     /* 2269643 */   // Label 30654: @2269643
     /* 2269643 */   GIM_Reject,
     /* 2269644 */ // Label 30652: @2269644
     /* 2269644 */ GIM_Reject,
     /* 2269645 */ // Label 30608: @2269645
     /* 2269645 */ GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2269759),
     /* 2269650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2269653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2269656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2269660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2269664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2269668 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2269713), // Rule ID 51104 //
     /* 2269673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2269676 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2269679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2269693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269712 */     // GIR_Coverage, 51104,
     /* 2269712 */     GIR_EraseRootFromParent_Done,
     /* 2269713 */   // Label 30656: @2269713
     /* 2269713 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2269758), // Rule ID 51105 //
     /* 2269718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2269721 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2269724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2269738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269757 */     // GIR_Coverage, 51105,
     /* 2269757 */     GIR_EraseRootFromParent_Done,
     /* 2269758 */   // Label 30657: @2269758
     /* 2269758 */   GIM_Reject,
     /* 2269759 */ // Label 30655: @2269759
     /* 2269759 */ GIM_Reject,
     /* 2269760 */ // Label 30609: @2269760
     /* 2269760 */ GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2269874),
     /* 2269765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2269768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2269771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269783 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2269828), // Rule ID 51032 //
     /* 2269788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269791 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2269794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269827 */     // GIR_Coverage, 51032,
     /* 2269827 */     GIR_EraseRootFromParent_Done,
     /* 2269828 */   // Label 30659: @2269828
     /* 2269828 */   GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2269873), // Rule ID 51033 //
     /* 2269833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269836 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2269839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2269853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269872 */     // GIR_Coverage, 51033,
     /* 2269872 */     GIR_EraseRootFromParent_Done,
     /* 2269873 */   // Label 30660: @2269873
     /* 2269873 */   GIM_Reject,
     /* 2269874 */ // Label 30658: @2269874
     /* 2269874 */ GIM_Reject,
     /* 2269875 */ // Label 30610: @2269875
     /* 2269875 */ GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2269989),
     /* 2269880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2269883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2269886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269898 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2269943), // Rule ID 51056 //
     /* 2269903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269906 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2269909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269942 */     // GIR_Coverage, 51056,
     /* 2269942 */     GIR_EraseRootFromParent_Done,
     /* 2269943 */   // Label 30662: @2269943
     /* 2269943 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2269988), // Rule ID 51057 //
     /* 2269948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269951 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2269954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2269968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269987 */     // GIR_Coverage, 51057,
     /* 2269987 */     GIR_EraseRootFromParent_Done,
     /* 2269988 */   // Label 30663: @2269988
     /* 2269988 */   GIM_Reject,
     /* 2269989 */ // Label 30661: @2269989
     /* 2269989 */ GIM_Reject,
     /* 2269990 */ // Label 30611: @2269990
     /* 2269990 */ GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2270104),
     /* 2269995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2269998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2270001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270013 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2270058), // Rule ID 51072 //
     /* 2270018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270021 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2270024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270057 */     // GIR_Coverage, 51072,
     /* 2270057 */     GIR_EraseRootFromParent_Done,
     /* 2270058 */   // Label 30665: @2270058
     /* 2270058 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2270103), // Rule ID 51073 //
     /* 2270063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270066 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2270069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270102 */     // GIR_Coverage, 51073,
     /* 2270102 */     GIR_EraseRootFromParent_Done,
     /* 2270103 */   // Label 30666: @2270103
     /* 2270103 */   GIM_Reject,
     /* 2270104 */ // Label 30664: @2270104
     /* 2270104 */ GIM_Reject,
     /* 2270105 */ // Label 30612: @2270105
     /* 2270105 */ GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2270219),
     /* 2270110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2270113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2270116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270128 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2270173), // Rule ID 51108 //
     /* 2270133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2270136 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2270139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270172 */     // GIR_Coverage, 51108,
     /* 2270172 */     GIR_EraseRootFromParent_Done,
     /* 2270173 */   // Label 30668: @2270173
     /* 2270173 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2270218), // Rule ID 51109 //
     /* 2270178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2270181 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2270184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270217 */     // GIR_Coverage, 51109,
     /* 2270217 */     GIR_EraseRootFromParent_Done,
     /* 2270218 */   // Label 30669: @2270218
     /* 2270218 */   GIM_Reject,
     /* 2270219 */ // Label 30667: @2270219
     /* 2270219 */ GIM_Reject,
     /* 2270220 */ // Label 30613: @2270220
     /* 2270220 */ GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2270334),
     /* 2270225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2270228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2270231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270243 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2270288), // Rule ID 51044 //
     /* 2270248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270251 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2270254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2270268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270287 */     // GIR_Coverage, 51044,
     /* 2270287 */     GIR_EraseRootFromParent_Done,
     /* 2270288 */   // Label 30671: @2270288
     /* 2270288 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2270333), // Rule ID 51045 //
     /* 2270293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270296 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2270299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2270313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270332 */     // GIR_Coverage, 51045,
     /* 2270332 */     GIR_EraseRootFromParent_Done,
     /* 2270333 */   // Label 30672: @2270333
     /* 2270333 */   GIM_Reject,
     /* 2270334 */ // Label 30670: @2270334
     /* 2270334 */ GIM_Reject,
     /* 2270335 */ // Label 30614: @2270335
     /* 2270335 */ GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2270449),
     /* 2270340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2270343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2270346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270358 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2270403), // Rule ID 51060 //
     /* 2270363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270366 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2270369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270402 */     // GIR_Coverage, 51060,
     /* 2270402 */     GIR_EraseRootFromParent_Done,
     /* 2270403 */   // Label 30674: @2270403
     /* 2270403 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2270448), // Rule ID 51061 //
     /* 2270408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270411 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2270414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270447 */     // GIR_Coverage, 51061,
     /* 2270447 */     GIR_EraseRootFromParent_Done,
     /* 2270448 */   // Label 30675: @2270448
     /* 2270448 */   GIM_Reject,
     /* 2270449 */ // Label 30673: @2270449
     /* 2270449 */ GIM_Reject,
     /* 2270450 */ // Label 30615: @2270450
     /* 2270450 */ GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2270564),
     /* 2270455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2270458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2270461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270473 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2270518), // Rule ID 51076 //
     /* 2270478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270481 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2270484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270517 */     // GIR_Coverage, 51076,
     /* 2270517 */     GIR_EraseRootFromParent_Done,
     /* 2270518 */   // Label 30677: @2270518
     /* 2270518 */   GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2270563), // Rule ID 51077 //
     /* 2270523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270526 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2270529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270562 */     // GIR_Coverage, 51077,
     /* 2270562 */     GIR_EraseRootFromParent_Done,
     /* 2270563 */   // Label 30678: @2270563
     /* 2270563 */   GIM_Reject,
     /* 2270564 */ // Label 30676: @2270564
     /* 2270564 */ GIM_Reject,
     /* 2270565 */ // Label 30616: @2270565
     /* 2270565 */ GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2270679),
     /* 2270570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2270573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2270576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270588 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2270633), // Rule ID 51048 //
     /* 2270593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270596 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2270599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270632 */     // GIR_Coverage, 51048,
     /* 2270632 */     GIR_EraseRootFromParent_Done,
     /* 2270633 */   // Label 30680: @2270633
     /* 2270633 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2270678), // Rule ID 51049 //
     /* 2270638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270641 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2270644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2270658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270677 */     // GIR_Coverage, 51049,
     /* 2270677 */     GIR_EraseRootFromParent_Done,
     /* 2270678 */   // Label 30681: @2270678
     /* 2270678 */   GIM_Reject,
     /* 2270679 */ // Label 30679: @2270679
     /* 2270679 */ GIM_Reject,
     /* 2270680 */ // Label 30617: @2270680
     /* 2270680 */ GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2270794),
     /* 2270685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2270688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2270691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270703 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2270748), // Rule ID 51064 //
     /* 2270708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270711 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2270714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270747 */     // GIR_Coverage, 51064,
     /* 2270747 */     GIR_EraseRootFromParent_Done,
     /* 2270748 */   // Label 30683: @2270748
     /* 2270748 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2270793), // Rule ID 51065 //
     /* 2270753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270756 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2270759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270792 */     // GIR_Coverage, 51065,
     /* 2270792 */     GIR_EraseRootFromParent_Done,
     /* 2270793 */   // Label 30684: @2270793
     /* 2270793 */   GIM_Reject,
     /* 2270794 */ // Label 30682: @2270794
     /* 2270794 */ GIM_Reject,
     /* 2270795 */ // Label 30618: @2270795
     /* 2270795 */ GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2270909),
     /* 2270800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2270803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2270806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2270818 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2270863), // Rule ID 51052 //
     /* 2270823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270826 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2270829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270862 */     // GIR_Coverage, 51052,
     /* 2270862 */     GIR_EraseRootFromParent_Done,
     /* 2270863 */   // Label 30686: @2270863
     /* 2270863 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2270908), // Rule ID 51053 //
     /* 2270868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270871 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2270874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2270888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270907 */     // GIR_Coverage, 51053,
     /* 2270907 */     GIR_EraseRootFromParent_Done,
     /* 2270908 */   // Label 30687: @2270908
     /* 2270908 */   GIM_Reject,
     /* 2270909 */ // Label 30685: @2270909
     /* 2270909 */ GIM_Reject,
     /* 2270910 */ // Label 30619: @2270910
     /* 2270910 */ GIM_Reject,
     /* 2270911 */ // Label 52: @2270911
     /* 2270911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30712*/ GIMT_Encode4(2273644),
     /* 2270922 */ /*GILLT_s32*//*Label 30688*/ GIMT_Encode4(2271046),
     /* 2270926 */ /*GILLT_s64*//*Label 30689*/ GIMT_Encode4(2271080), GIMT_Encode4(0),
     /* 2270934 */ /*GILLT_nxv1s8*//*Label 30690*/ GIMT_Encode4(2271114),
     /* 2270938 */ /*GILLT_nxv1s16*//*Label 30691*/ GIMT_Encode4(2271229),
     /* 2270942 */ /*GILLT_nxv1s32*//*Label 30692*/ GIMT_Encode4(2271344),
     /* 2270946 */ /*GILLT_nxv1s64*//*Label 30693*/ GIMT_Encode4(2271459), GIMT_Encode4(0),
     /* 2270954 */ /*GILLT_nxv2s8*//*Label 30694*/ GIMT_Encode4(2271574),
     /* 2270958 */ /*GILLT_nxv2s16*//*Label 30695*/ GIMT_Encode4(2271689),
     /* 2270962 */ /*GILLT_nxv2s32*//*Label 30696*/ GIMT_Encode4(2271804),
     /* 2270966 */ /*GILLT_nxv2s64*//*Label 30697*/ GIMT_Encode4(2271919), GIMT_Encode4(0),
     /* 2270974 */ /*GILLT_nxv4s8*//*Label 30698*/ GIMT_Encode4(2272034),
     /* 2270978 */ /*GILLT_nxv4s16*//*Label 30699*/ GIMT_Encode4(2272149),
     /* 2270982 */ /*GILLT_nxv4s32*//*Label 30700*/ GIMT_Encode4(2272264),
     /* 2270986 */ /*GILLT_nxv4s64*//*Label 30701*/ GIMT_Encode4(2272379), GIMT_Encode4(0),
     /* 2270994 */ /*GILLT_nxv8s8*//*Label 30702*/ GIMT_Encode4(2272494),
     /* 2270998 */ /*GILLT_nxv8s16*//*Label 30703*/ GIMT_Encode4(2272609),
     /* 2271002 */ /*GILLT_nxv8s32*//*Label 30704*/ GIMT_Encode4(2272724),
     /* 2271006 */ /*GILLT_nxv8s64*//*Label 30705*/ GIMT_Encode4(2272839), GIMT_Encode4(0),
     /* 2271014 */ /*GILLT_nxv16s8*//*Label 30706*/ GIMT_Encode4(2272954),
     /* 2271018 */ /*GILLT_nxv16s16*//*Label 30707*/ GIMT_Encode4(2273069),
     /* 2271022 */ /*GILLT_nxv16s32*//*Label 30708*/ GIMT_Encode4(2273184), GIMT_Encode4(0),
     /* 2271030 */ /*GILLT_nxv32s8*//*Label 30709*/ GIMT_Encode4(2273299),
     /* 2271034 */ /*GILLT_nxv32s16*//*Label 30710*/ GIMT_Encode4(2273414), GIMT_Encode4(0),
     /* 2271042 */ /*GILLT_nxv64s8*//*Label 30711*/ GIMT_Encode4(2273529),
     /* 2271046 */ // Label 30688: @2271046
     /* 2271046 */ GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2271079), // Rule ID 292 //
     /* 2271051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2271054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2271057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2271060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271072 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2271072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2271077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271078 */   // GIR_Coverage, 292,
     /* 2271078 */   GIR_Done,
     /* 2271079 */ // Label 30713: @2271079
     /* 2271079 */ GIM_Reject,
     /* 2271080 */ // Label 30689: @2271080
     /* 2271080 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2271113), // Rule ID 291 //
     /* 2271085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2271088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2271091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2271094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2271106 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2271106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2271111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271112 */   // GIR_Coverage, 291,
     /* 2271112 */   GIR_Done,
     /* 2271113 */ // Label 30714: @2271113
     /* 2271113 */ GIM_Reject,
     /* 2271114 */ // Label 30690: @2271114
     /* 2271114 */ GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2271228),
     /* 2271119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2271122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2271125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271137 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2271182), // Rule ID 50936 //
     /* 2271142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271145 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2271148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2271162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271181 */     // GIR_Coverage, 50936,
     /* 2271181 */     GIR_EraseRootFromParent_Done,
     /* 2271182 */   // Label 30716: @2271182
     /* 2271182 */   GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2271227), // Rule ID 50937 //
     /* 2271187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271190 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2271193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2271207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271226 */     // GIR_Coverage, 50937,
     /* 2271226 */     GIR_EraseRootFromParent_Done,
     /* 2271227 */   // Label 30717: @2271227
     /* 2271227 */   GIM_Reject,
     /* 2271228 */ // Label 30715: @2271228
     /* 2271228 */ GIM_Reject,
     /* 2271229 */ // Label 30691: @2271229
     /* 2271229 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2271343),
     /* 2271234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2271237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2271240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271252 */   GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2271297), // Rule ID 50948 //
     /* 2271257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271260 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2271263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2271277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271296 */     // GIR_Coverage, 50948,
     /* 2271296 */     GIR_EraseRootFromParent_Done,
     /* 2271297 */   // Label 30719: @2271297
     /* 2271297 */   GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2271342), // Rule ID 50949 //
     /* 2271302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271305 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2271308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2271322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271341 */     // GIR_Coverage, 50949,
     /* 2271341 */     GIR_EraseRootFromParent_Done,
     /* 2271342 */   // Label 30720: @2271342
     /* 2271342 */   GIM_Reject,
     /* 2271343 */ // Label 30718: @2271343
     /* 2271343 */ GIM_Reject,
     /* 2271344 */ // Label 30692: @2271344
     /* 2271344 */ GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2271458),
     /* 2271349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2271352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2271355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271367 */   GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2271412), // Rule ID 50956 //
     /* 2271372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271375 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2271378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2271392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271411 */     // GIR_Coverage, 50956,
     /* 2271411 */     GIR_EraseRootFromParent_Done,
     /* 2271412 */   // Label 30722: @2271412
     /* 2271412 */   GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2271457), // Rule ID 50957 //
     /* 2271417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271420 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2271423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2271437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271456 */     // GIR_Coverage, 50957,
     /* 2271456 */     GIR_EraseRootFromParent_Done,
     /* 2271457 */   // Label 30723: @2271457
     /* 2271457 */   GIM_Reject,
     /* 2271458 */ // Label 30721: @2271458
     /* 2271458 */ GIM_Reject,
     /* 2271459 */ // Label 30693: @2271459
     /* 2271459 */ GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2271573),
     /* 2271464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2271467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2271470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271482 */   GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2271527), // Rule ID 51080 //
     /* 2271487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2271490 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2271493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2271507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271526 */     // GIR_Coverage, 51080,
     /* 2271526 */     GIR_EraseRootFromParent_Done,
     /* 2271527 */   // Label 30725: @2271527
     /* 2271527 */   GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2271572), // Rule ID 51081 //
     /* 2271532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2271535 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2271538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2271552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271571 */     // GIR_Coverage, 51081,
     /* 2271571 */     GIR_EraseRootFromParent_Done,
     /* 2271572 */   // Label 30726: @2271572
     /* 2271572 */   GIM_Reject,
     /* 2271573 */ // Label 30724: @2271573
     /* 2271573 */ GIM_Reject,
     /* 2271574 */ // Label 30694: @2271574
     /* 2271574 */ GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2271688),
     /* 2271579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2271582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2271585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271597 */   GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2271642), // Rule ID 50940 //
     /* 2271602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271605 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2271608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2271622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271641 */     // GIR_Coverage, 50940,
     /* 2271641 */     GIR_EraseRootFromParent_Done,
     /* 2271642 */   // Label 30728: @2271642
     /* 2271642 */   GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2271687), // Rule ID 50941 //
     /* 2271647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271650 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2271653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2271667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271686 */     // GIR_Coverage, 50941,
     /* 2271686 */     GIR_EraseRootFromParent_Done,
     /* 2271687 */   // Label 30729: @2271687
     /* 2271687 */   GIM_Reject,
     /* 2271688 */ // Label 30727: @2271688
     /* 2271688 */ GIM_Reject,
     /* 2271689 */ // Label 30695: @2271689
     /* 2271689 */ GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2271803),
     /* 2271694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2271697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2271700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271712 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2271757), // Rule ID 50952 //
     /* 2271717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271720 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2271723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2271737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271756 */     // GIR_Coverage, 50952,
     /* 2271756 */     GIR_EraseRootFromParent_Done,
     /* 2271757 */   // Label 30731: @2271757
     /* 2271757 */   GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2271802), // Rule ID 50953 //
     /* 2271762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271765 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2271768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2271782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271801 */     // GIR_Coverage, 50953,
     /* 2271801 */     GIR_EraseRootFromParent_Done,
     /* 2271802 */   // Label 30732: @2271802
     /* 2271802 */   GIM_Reject,
     /* 2271803 */ // Label 30730: @2271803
     /* 2271803 */ GIM_Reject,
     /* 2271804 */ // Label 30696: @2271804
     /* 2271804 */ GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2271918),
     /* 2271809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2271812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2271815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271827 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2271872), // Rule ID 50968 //
     /* 2271832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271835 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2271838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2271852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271871 */     // GIR_Coverage, 50968,
     /* 2271871 */     GIR_EraseRootFromParent_Done,
     /* 2271872 */   // Label 30734: @2271872
     /* 2271872 */   GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2271917), // Rule ID 50969 //
     /* 2271877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271880 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2271883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2271897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271916 */     // GIR_Coverage, 50969,
     /* 2271916 */     GIR_EraseRootFromParent_Done,
     /* 2271917 */   // Label 30735: @2271917
     /* 2271917 */   GIM_Reject,
     /* 2271918 */ // Label 30733: @2271918
     /* 2271918 */ GIM_Reject,
     /* 2271919 */ // Label 30697: @2271919
     /* 2271919 */ GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2272033),
     /* 2271924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2271927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2271930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271942 */   GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2271987), // Rule ID 51084 //
     /* 2271947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2271950 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2271953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2271967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271986 */     // GIR_Coverage, 51084,
     /* 2271986 */     GIR_EraseRootFromParent_Done,
     /* 2271987 */   // Label 30737: @2271987
     /* 2271987 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2272032), // Rule ID 51085 //
     /* 2271992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2271995 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2271998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2272012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272031 */     // GIR_Coverage, 51085,
     /* 2272031 */     GIR_EraseRootFromParent_Done,
     /* 2272032 */   // Label 30738: @2272032
     /* 2272032 */   GIM_Reject,
     /* 2272033 */ // Label 30736: @2272033
     /* 2272033 */ GIM_Reject,
     /* 2272034 */ // Label 30698: @2272034
     /* 2272034 */ GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2272148),
     /* 2272039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2272042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2272045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272057 */   GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2272102), // Rule ID 50944 //
     /* 2272062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272065 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2272068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2272082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272101 */     // GIR_Coverage, 50944,
     /* 2272101 */     GIR_EraseRootFromParent_Done,
     /* 2272102 */   // Label 30740: @2272102
     /* 2272102 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2272147), // Rule ID 50945 //
     /* 2272107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272110 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2272113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2272127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272146 */     // GIR_Coverage, 50945,
     /* 2272146 */     GIR_EraseRootFromParent_Done,
     /* 2272147 */   // Label 30741: @2272147
     /* 2272147 */   GIM_Reject,
     /* 2272148 */ // Label 30739: @2272148
     /* 2272148 */ GIM_Reject,
     /* 2272149 */ // Label 30699: @2272149
     /* 2272149 */ GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2272263),
     /* 2272154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2272157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2272160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272172 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2272217), // Rule ID 50964 //
     /* 2272177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272180 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2272183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2272197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272216 */     // GIR_Coverage, 50964,
     /* 2272216 */     GIR_EraseRootFromParent_Done,
     /* 2272217 */   // Label 30743: @2272217
     /* 2272217 */   GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2272262), // Rule ID 50965 //
     /* 2272222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272225 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2272228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2272242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272261 */     // GIR_Coverage, 50965,
     /* 2272261 */     GIR_EraseRootFromParent_Done,
     /* 2272262 */   // Label 30744: @2272262
     /* 2272262 */   GIM_Reject,
     /* 2272263 */ // Label 30742: @2272263
     /* 2272263 */ GIM_Reject,
     /* 2272264 */ // Label 30700: @2272264
     /* 2272264 */ GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2272378),
     /* 2272269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2272272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2272275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272287 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2272332), // Rule ID 50996 //
     /* 2272292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272295 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2272298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2272312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272331 */     // GIR_Coverage, 50996,
     /* 2272331 */     GIR_EraseRootFromParent_Done,
     /* 2272332 */   // Label 30746: @2272332
     /* 2272332 */   GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2272377), // Rule ID 50997 //
     /* 2272337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272340 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2272343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2272357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272376 */     // GIR_Coverage, 50997,
     /* 2272376 */     GIR_EraseRootFromParent_Done,
     /* 2272377 */   // Label 30747: @2272377
     /* 2272377 */   GIM_Reject,
     /* 2272378 */ // Label 30745: @2272378
     /* 2272378 */ GIM_Reject,
     /* 2272379 */ // Label 30701: @2272379
     /* 2272379 */ GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2272493),
     /* 2272384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2272387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2272390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272402 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2272447), // Rule ID 51088 //
     /* 2272407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2272410 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2272413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2272427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272446 */     // GIR_Coverage, 51088,
     /* 2272446 */     GIR_EraseRootFromParent_Done,
     /* 2272447 */   // Label 30749: @2272447
     /* 2272447 */   GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2272492), // Rule ID 51089 //
     /* 2272452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2272455 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2272458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2272472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272491 */     // GIR_Coverage, 51089,
     /* 2272491 */     GIR_EraseRootFromParent_Done,
     /* 2272492 */   // Label 30750: @2272492
     /* 2272492 */   GIM_Reject,
     /* 2272493 */ // Label 30748: @2272493
     /* 2272493 */ GIM_Reject,
     /* 2272494 */ // Label 30702: @2272494
     /* 2272494 */ GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2272608),
     /* 2272499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2272502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2272505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272517 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2272562), // Rule ID 50960 //
     /* 2272522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272525 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2272528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2272542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272561 */     // GIR_Coverage, 50960,
     /* 2272561 */     GIR_EraseRootFromParent_Done,
     /* 2272562 */   // Label 30752: @2272562
     /* 2272562 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2272607), // Rule ID 50961 //
     /* 2272567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272570 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2272573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2272587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272606 */     // GIR_Coverage, 50961,
     /* 2272606 */     GIR_EraseRootFromParent_Done,
     /* 2272607 */   // Label 30753: @2272607
     /* 2272607 */   GIM_Reject,
     /* 2272608 */ // Label 30751: @2272608
     /* 2272608 */ GIM_Reject,
     /* 2272609 */ // Label 30703: @2272609
     /* 2272609 */ GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2272723),
     /* 2272614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2272617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272632 */   GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2272677), // Rule ID 50984 //
     /* 2272637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272640 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2272643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2272657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272676 */     // GIR_Coverage, 50984,
     /* 2272676 */     GIR_EraseRootFromParent_Done,
     /* 2272677 */   // Label 30755: @2272677
     /* 2272677 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2272722), // Rule ID 50985 //
     /* 2272682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272685 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2272688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2272702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272721 */     // GIR_Coverage, 50985,
     /* 2272721 */     GIR_EraseRootFromParent_Done,
     /* 2272722 */   // Label 30756: @2272722
     /* 2272722 */   GIM_Reject,
     /* 2272723 */ // Label 30754: @2272723
     /* 2272723 */ GIM_Reject,
     /* 2272724 */ // Label 30704: @2272724
     /* 2272724 */ GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2272838),
     /* 2272729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2272732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272747 */   GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2272792), // Rule ID 51000 //
     /* 2272752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272755 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2272758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2272772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272791 */     // GIR_Coverage, 51000,
     /* 2272791 */     GIR_EraseRootFromParent_Done,
     /* 2272792 */   // Label 30758: @2272792
     /* 2272792 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2272837), // Rule ID 51001 //
     /* 2272797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272800 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2272803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2272817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272836 */     // GIR_Coverage, 51001,
     /* 2272836 */     GIR_EraseRootFromParent_Done,
     /* 2272837 */   // Label 30759: @2272837
     /* 2272837 */   GIM_Reject,
     /* 2272838 */ // Label 30757: @2272838
     /* 2272838 */ GIM_Reject,
     /* 2272839 */ // Label 30705: @2272839
     /* 2272839 */ GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2272953),
     /* 2272844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2272847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272862 */   GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2272907), // Rule ID 51092 //
     /* 2272867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2272870 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2272873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2272887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272906 */     // GIR_Coverage, 51092,
     /* 2272906 */     GIR_EraseRootFromParent_Done,
     /* 2272907 */   // Label 30761: @2272907
     /* 2272907 */   GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2272952), // Rule ID 51093 //
     /* 2272912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2272915 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2272918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2272932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272951 */     // GIR_Coverage, 51093,
     /* 2272951 */     GIR_EraseRootFromParent_Done,
     /* 2272952 */   // Label 30762: @2272952
     /* 2272952 */   GIM_Reject,
     /* 2272953 */ // Label 30760: @2272953
     /* 2272953 */ GIM_Reject,
     /* 2272954 */ // Label 30706: @2272954
     /* 2272954 */ GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2273068),
     /* 2272959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2272962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2272965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272977 */   GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2273022), // Rule ID 50972 //
     /* 2272982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272985 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2272988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2273002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273021 */     // GIR_Coverage, 50972,
     /* 2273021 */     GIR_EraseRootFromParent_Done,
     /* 2273022 */   // Label 30764: @2273022
     /* 2273022 */   GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2273067), // Rule ID 50973 //
     /* 2273027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273030 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2273033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2273047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273066 */     // GIR_Coverage, 50973,
     /* 2273066 */     GIR_EraseRootFromParent_Done,
     /* 2273067 */   // Label 30765: @2273067
     /* 2273067 */   GIM_Reject,
     /* 2273068 */ // Label 30763: @2273068
     /* 2273068 */ GIM_Reject,
     /* 2273069 */ // Label 30707: @2273069
     /* 2273069 */ GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2273183),
     /* 2273074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2273077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2273080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273092 */   GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2273137), // Rule ID 50988 //
     /* 2273097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273100 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2273103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2273117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273136 */     // GIR_Coverage, 50988,
     /* 2273136 */     GIR_EraseRootFromParent_Done,
     /* 2273137 */   // Label 30767: @2273137
     /* 2273137 */   GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2273182), // Rule ID 50989 //
     /* 2273142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273145 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2273148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2273162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273181 */     // GIR_Coverage, 50989,
     /* 2273181 */     GIR_EraseRootFromParent_Done,
     /* 2273182 */   // Label 30768: @2273182
     /* 2273182 */   GIM_Reject,
     /* 2273183 */ // Label 30766: @2273183
     /* 2273183 */ GIM_Reject,
     /* 2273184 */ // Label 30708: @2273184
     /* 2273184 */ GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2273298),
     /* 2273189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2273192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273207 */   GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2273252), // Rule ID 51004 //
     /* 2273212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273215 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2273218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273251 */     // GIR_Coverage, 51004,
     /* 2273251 */     GIR_EraseRootFromParent_Done,
     /* 2273252 */   // Label 30770: @2273252
     /* 2273252 */   GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2273297), // Rule ID 51005 //
     /* 2273257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273260 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2273263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273296 */     // GIR_Coverage, 51005,
     /* 2273296 */     GIR_EraseRootFromParent_Done,
     /* 2273297 */   // Label 30771: @2273297
     /* 2273297 */   GIM_Reject,
     /* 2273298 */ // Label 30769: @2273298
     /* 2273298 */ GIM_Reject,
     /* 2273299 */ // Label 30709: @2273299
     /* 2273299 */ GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2273413),
     /* 2273304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2273307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2273310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273322 */   GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2273367), // Rule ID 50976 //
     /* 2273327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273330 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2273333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2273347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273366 */     // GIR_Coverage, 50976,
     /* 2273366 */     GIR_EraseRootFromParent_Done,
     /* 2273367 */   // Label 30773: @2273367
     /* 2273367 */   GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2273412), // Rule ID 50977 //
     /* 2273372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273375 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2273378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2273392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273411 */     // GIR_Coverage, 50977,
     /* 2273411 */     GIR_EraseRootFromParent_Done,
     /* 2273412 */   // Label 30774: @2273412
     /* 2273412 */   GIM_Reject,
     /* 2273413 */ // Label 30772: @2273413
     /* 2273413 */ GIM_Reject,
     /* 2273414 */ // Label 30710: @2273414
     /* 2273414 */ GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2273528),
     /* 2273419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2273422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2273425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273437 */   GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2273482), // Rule ID 50992 //
     /* 2273442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273445 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2273448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273481 */     // GIR_Coverage, 50992,
     /* 2273481 */     GIR_EraseRootFromParent_Done,
     /* 2273482 */   // Label 30776: @2273482
     /* 2273482 */   GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2273527), // Rule ID 50993 //
     /* 2273487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273490 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2273493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273526 */     // GIR_Coverage, 50993,
     /* 2273526 */     GIR_EraseRootFromParent_Done,
     /* 2273527 */   // Label 30777: @2273527
     /* 2273527 */   GIM_Reject,
     /* 2273528 */ // Label 30775: @2273528
     /* 2273528 */ GIM_Reject,
     /* 2273529 */ // Label 30711: @2273529
     /* 2273529 */ GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2273643),
     /* 2273534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2273537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2273540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273552 */   GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2273597), // Rule ID 50980 //
     /* 2273557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273560 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2273563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273596 */     // GIR_Coverage, 50980,
     /* 2273596 */     GIR_EraseRootFromParent_Done,
     /* 2273597 */   // Label 30779: @2273597
     /* 2273597 */   GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2273642), // Rule ID 50981 //
     /* 2273602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273605 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2273608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2273622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273641 */     // GIR_Coverage, 50981,
     /* 2273641 */     GIR_EraseRootFromParent_Done,
     /* 2273642 */   // Label 30780: @2273642
     /* 2273642 */   GIM_Reject,
     /* 2273643 */ // Label 30778: @2273643
     /* 2273643 */ GIM_Reject,
     /* 2273644 */ // Label 30712: @2273644
     /* 2273644 */ GIM_Reject,
     /* 2273645 */ // Label 53: @2273645
     /* 2273645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30804*/ GIMT_Encode4(2276497),
     /* 2273656 */ /*GILLT_s32*//*Label 30781*/ GIMT_Encode4(2273780), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2273668 */ /*GILLT_nxv1s8*//*Label 30782*/ GIMT_Encode4(2273835),
     /* 2273672 */ /*GILLT_nxv1s16*//*Label 30783*/ GIMT_Encode4(2273956),
     /* 2273676 */ /*GILLT_nxv1s32*//*Label 30784*/ GIMT_Encode4(2274077),
     /* 2273680 */ /*GILLT_nxv1s64*//*Label 30785*/ GIMT_Encode4(2274198), GIMT_Encode4(0),
     /* 2273688 */ /*GILLT_nxv2s8*//*Label 30786*/ GIMT_Encode4(2274319),
     /* 2273692 */ /*GILLT_nxv2s16*//*Label 30787*/ GIMT_Encode4(2274440),
     /* 2273696 */ /*GILLT_nxv2s32*//*Label 30788*/ GIMT_Encode4(2274561),
     /* 2273700 */ /*GILLT_nxv2s64*//*Label 30789*/ GIMT_Encode4(2274682), GIMT_Encode4(0),
     /* 2273708 */ /*GILLT_nxv4s8*//*Label 30790*/ GIMT_Encode4(2274803),
     /* 2273712 */ /*GILLT_nxv4s16*//*Label 30791*/ GIMT_Encode4(2274924),
     /* 2273716 */ /*GILLT_nxv4s32*//*Label 30792*/ GIMT_Encode4(2275045),
     /* 2273720 */ /*GILLT_nxv4s64*//*Label 30793*/ GIMT_Encode4(2275166), GIMT_Encode4(0),
     /* 2273728 */ /*GILLT_nxv8s8*//*Label 30794*/ GIMT_Encode4(2275287),
     /* 2273732 */ /*GILLT_nxv8s16*//*Label 30795*/ GIMT_Encode4(2275408),
     /* 2273736 */ /*GILLT_nxv8s32*//*Label 30796*/ GIMT_Encode4(2275529),
     /* 2273740 */ /*GILLT_nxv8s64*//*Label 30797*/ GIMT_Encode4(2275650), GIMT_Encode4(0),
     /* 2273748 */ /*GILLT_nxv16s8*//*Label 30798*/ GIMT_Encode4(2275771),
     /* 2273752 */ /*GILLT_nxv16s16*//*Label 30799*/ GIMT_Encode4(2275892),
     /* 2273756 */ /*GILLT_nxv16s32*//*Label 30800*/ GIMT_Encode4(2276013), GIMT_Encode4(0),
     /* 2273764 */ /*GILLT_nxv32s8*//*Label 30801*/ GIMT_Encode4(2276134),
     /* 2273768 */ /*GILLT_nxv32s16*//*Label 30802*/ GIMT_Encode4(2276255), GIMT_Encode4(0),
     /* 2273776 */ /*GILLT_nxv64s8*//*Label 30803*/ GIMT_Encode4(2276376),
     /* 2273780 */ // Label 30781: @2273780
     /* 2273780 */ GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2273834),
     /* 2273785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2273788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273803 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2273818), // Rule ID 64568 //
     /* 2273808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2273811 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2273811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2273816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273817 */     // GIR_Coverage, 64568,
     /* 2273817 */     GIR_Done,
     /* 2273818 */   // Label 30806: @2273818
     /* 2273818 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2273833), // Rule ID 64569 //
     /* 2273823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2273826 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2273826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2273831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273832 */     // GIR_Coverage, 64569,
     /* 2273832 */     GIR_Done,
     /* 2273833 */   // Label 30807: @2273833
     /* 2273833 */   GIM_Reject,
     /* 2273834 */ // Label 30805: @2273834
     /* 2273834 */ GIM_Reject,
     /* 2273835 */ // Label 30782: @2273835
     /* 2273835 */ GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2273955),
     /* 2273840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2273843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2273846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273858 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2273906), // Rule ID 52496 //
     /* 2273863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273866 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2273869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2273883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273905 */     // GIR_Coverage, 52496,
     /* 2273905 */     GIR_EraseRootFromParent_Done,
     /* 2273906 */   // Label 30809: @2273906
     /* 2273906 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2273954), // Rule ID 52497 //
     /* 2273911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273914 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2273917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2273931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273953 */     // GIR_Coverage, 52497,
     /* 2273953 */     GIR_EraseRootFromParent_Done,
     /* 2273954 */   // Label 30810: @2273954
     /* 2273954 */   GIM_Reject,
     /* 2273955 */ // Label 30808: @2273955
     /* 2273955 */ GIM_Reject,
     /* 2273956 */ // Label 30783: @2273956
     /* 2273956 */ GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2274076),
     /* 2273961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2273964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2273967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273979 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2274027), // Rule ID 52508 //
     /* 2273984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273987 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2273990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2274004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274026 */     // GIR_Coverage, 52508,
     /* 2274026 */     GIR_EraseRootFromParent_Done,
     /* 2274027 */   // Label 30812: @2274027
     /* 2274027 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2274075), // Rule ID 52509 //
     /* 2274032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274035 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2274038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2274052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274074 */     // GIR_Coverage, 52509,
     /* 2274074 */     GIR_EraseRootFromParent_Done,
     /* 2274075 */   // Label 30813: @2274075
     /* 2274075 */   GIM_Reject,
     /* 2274076 */ // Label 30811: @2274076
     /* 2274076 */ GIM_Reject,
     /* 2274077 */ // Label 30784: @2274077
     /* 2274077 */ GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2274197),
     /* 2274082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2274085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2274088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274100 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2274148), // Rule ID 52516 //
     /* 2274105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274108 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2274111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274147 */     // GIR_Coverage, 52516,
     /* 2274147 */     GIR_EraseRootFromParent_Done,
     /* 2274148 */   // Label 30815: @2274148
     /* 2274148 */   GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2274196), // Rule ID 52517 //
     /* 2274153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274156 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2274159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274195 */     // GIR_Coverage, 52517,
     /* 2274195 */     GIR_EraseRootFromParent_Done,
     /* 2274196 */   // Label 30816: @2274196
     /* 2274196 */   GIM_Reject,
     /* 2274197 */ // Label 30814: @2274197
     /* 2274197 */ GIM_Reject,
     /* 2274198 */ // Label 30785: @2274198
     /* 2274198 */ GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2274318),
     /* 2274203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2274206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2274209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274221 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2274269), // Rule ID 52532 //
     /* 2274226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2274229 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2274232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2274246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274268 */     // GIR_Coverage, 52532,
     /* 2274268 */     GIR_EraseRootFromParent_Done,
     /* 2274269 */   // Label 30818: @2274269
     /* 2274269 */   GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2274317), // Rule ID 52533 //
     /* 2274274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2274277 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2274280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2274294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274316 */     // GIR_Coverage, 52533,
     /* 2274316 */     GIR_EraseRootFromParent_Done,
     /* 2274317 */   // Label 30819: @2274317
     /* 2274317 */   GIM_Reject,
     /* 2274318 */ // Label 30817: @2274318
     /* 2274318 */ GIM_Reject,
     /* 2274319 */ // Label 30786: @2274319
     /* 2274319 */ GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2274439),
     /* 2274324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2274327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2274330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274342 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2274390), // Rule ID 52500 //
     /* 2274347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274350 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2274353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2274367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274389 */     // GIR_Coverage, 52500,
     /* 2274389 */     GIR_EraseRootFromParent_Done,
     /* 2274390 */   // Label 30821: @2274390
     /* 2274390 */   GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2274438), // Rule ID 52501 //
     /* 2274395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274398 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2274401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2274415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274437 */     // GIR_Coverage, 52501,
     /* 2274437 */     GIR_EraseRootFromParent_Done,
     /* 2274438 */   // Label 30822: @2274438
     /* 2274438 */   GIM_Reject,
     /* 2274439 */ // Label 30820: @2274439
     /* 2274439 */ GIM_Reject,
     /* 2274440 */ // Label 30787: @2274440
     /* 2274440 */ GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2274560),
     /* 2274445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2274448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2274451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274463 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2274511), // Rule ID 52512 //
     /* 2274468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274471 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2274474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274510 */     // GIR_Coverage, 52512,
     /* 2274510 */     GIR_EraseRootFromParent_Done,
     /* 2274511 */   // Label 30824: @2274511
     /* 2274511 */   GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2274559), // Rule ID 52513 //
     /* 2274516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274519 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2274522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274558 */     // GIR_Coverage, 52513,
     /* 2274558 */     GIR_EraseRootFromParent_Done,
     /* 2274559 */   // Label 30825: @2274559
     /* 2274559 */   GIM_Reject,
     /* 2274560 */ // Label 30823: @2274560
     /* 2274560 */ GIM_Reject,
     /* 2274561 */ // Label 30788: @2274561
     /* 2274561 */ GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2274681),
     /* 2274566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2274569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2274572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274584 */   GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2274632), // Rule ID 52528 //
     /* 2274589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274592 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2274595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2274609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274631 */     // GIR_Coverage, 52528,
     /* 2274631 */     GIR_EraseRootFromParent_Done,
     /* 2274632 */   // Label 30827: @2274632
     /* 2274632 */   GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2274680), // Rule ID 52529 //
     /* 2274637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274640 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2274643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2274657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274679 */     // GIR_Coverage, 52529,
     /* 2274679 */     GIR_EraseRootFromParent_Done,
     /* 2274680 */   // Label 30828: @2274680
     /* 2274680 */   GIM_Reject,
     /* 2274681 */ // Label 30826: @2274681
     /* 2274681 */ GIM_Reject,
     /* 2274682 */ // Label 30789: @2274682
     /* 2274682 */ GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2274802),
     /* 2274687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2274690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2274693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274705 */   GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2274753), // Rule ID 52572 //
     /* 2274710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2274713 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2274716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2274730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274752 */     // GIR_Coverage, 52572,
     /* 2274752 */     GIR_EraseRootFromParent_Done,
     /* 2274753 */   // Label 30830: @2274753
     /* 2274753 */   GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2274801), // Rule ID 52573 //
     /* 2274758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2274761 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2274764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2274778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274800 */     // GIR_Coverage, 52573,
     /* 2274800 */     GIR_EraseRootFromParent_Done,
     /* 2274801 */   // Label 30831: @2274801
     /* 2274801 */   GIM_Reject,
     /* 2274802 */ // Label 30829: @2274802
     /* 2274802 */ GIM_Reject,
     /* 2274803 */ // Label 30790: @2274803
     /* 2274803 */ GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2274923),
     /* 2274808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2274811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2274814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274826 */   GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2274874), // Rule ID 52504 //
     /* 2274831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274834 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2274837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274873 */     // GIR_Coverage, 52504,
     /* 2274873 */     GIR_EraseRootFromParent_Done,
     /* 2274874 */   // Label 30833: @2274874
     /* 2274874 */   GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2274922), // Rule ID 52505 //
     /* 2274879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274882 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2274885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2274899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274921 */     // GIR_Coverage, 52505,
     /* 2274921 */     GIR_EraseRootFromParent_Done,
     /* 2274922 */   // Label 30834: @2274922
     /* 2274922 */   GIM_Reject,
     /* 2274923 */ // Label 30832: @2274923
     /* 2274923 */ GIM_Reject,
     /* 2274924 */ // Label 30791: @2274924
     /* 2274924 */ GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2275044),
     /* 2274929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2274932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2274935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2274947 */   GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2274995), // Rule ID 52524 //
     /* 2274952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274955 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2274958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2274972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274994 */     // GIR_Coverage, 52524,
     /* 2274994 */     GIR_EraseRootFromParent_Done,
     /* 2274995 */   // Label 30836: @2274995
     /* 2274995 */   GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2275043), // Rule ID 52525 //
     /* 2275000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275003 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2275006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2275020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275042 */     // GIR_Coverage, 52525,
     /* 2275042 */     GIR_EraseRootFromParent_Done,
     /* 2275043 */   // Label 30837: @2275043
     /* 2275043 */   GIM_Reject,
     /* 2275044 */ // Label 30835: @2275044
     /* 2275044 */ GIM_Reject,
     /* 2275045 */ // Label 30792: @2275045
     /* 2275045 */ GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2275165),
     /* 2275050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2275053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2275056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275068 */   GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2275116), // Rule ID 52560 //
     /* 2275073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275076 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2275079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275115 */     // GIR_Coverage, 52560,
     /* 2275115 */     GIR_EraseRootFromParent_Done,
     /* 2275116 */   // Label 30839: @2275116
     /* 2275116 */   GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2275164), // Rule ID 52561 //
     /* 2275121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275124 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2275127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275163 */     // GIR_Coverage, 52561,
     /* 2275163 */     GIR_EraseRootFromParent_Done,
     /* 2275164 */   // Label 30840: @2275164
     /* 2275164 */   GIM_Reject,
     /* 2275165 */ // Label 30838: @2275165
     /* 2275165 */ GIM_Reject,
     /* 2275166 */ // Label 30793: @2275166
     /* 2275166 */ GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2275286),
     /* 2275171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2275174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2275177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275189 */   GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2275237), // Rule ID 52576 //
     /* 2275194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2275197 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2275200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275236 */     // GIR_Coverage, 52576,
     /* 2275236 */     GIR_EraseRootFromParent_Done,
     /* 2275237 */   // Label 30842: @2275237
     /* 2275237 */   GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2275285), // Rule ID 52577 //
     /* 2275242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2275245 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2275248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275284 */     // GIR_Coverage, 52577,
     /* 2275284 */     GIR_EraseRootFromParent_Done,
     /* 2275285 */   // Label 30843: @2275285
     /* 2275285 */   GIM_Reject,
     /* 2275286 */ // Label 30841: @2275286
     /* 2275286 */ GIM_Reject,
     /* 2275287 */ // Label 30794: @2275287
     /* 2275287 */ GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2275407),
     /* 2275292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2275295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2275298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275310 */   GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2275358), // Rule ID 52520 //
     /* 2275315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275318 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2275321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2275335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275357 */     // GIR_Coverage, 52520,
     /* 2275357 */     GIR_EraseRootFromParent_Done,
     /* 2275358 */   // Label 30845: @2275358
     /* 2275358 */   GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2275406), // Rule ID 52521 //
     /* 2275363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275366 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2275369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2275383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275405 */     // GIR_Coverage, 52521,
     /* 2275405 */     GIR_EraseRootFromParent_Done,
     /* 2275406 */   // Label 30846: @2275406
     /* 2275406 */   GIM_Reject,
     /* 2275407 */ // Label 30844: @2275407
     /* 2275407 */ GIM_Reject,
     /* 2275408 */ // Label 30795: @2275408
     /* 2275408 */ GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2275528),
     /* 2275413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2275416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2275419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275431 */   GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2275479), // Rule ID 52548 //
     /* 2275436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275439 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2275442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275478 */     // GIR_Coverage, 52548,
     /* 2275478 */     GIR_EraseRootFromParent_Done,
     /* 2275479 */   // Label 30848: @2275479
     /* 2275479 */   GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2275527), // Rule ID 52549 //
     /* 2275484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275487 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2275490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275526 */     // GIR_Coverage, 52549,
     /* 2275526 */     GIR_EraseRootFromParent_Done,
     /* 2275527 */   // Label 30849: @2275527
     /* 2275527 */   GIM_Reject,
     /* 2275528 */ // Label 30847: @2275528
     /* 2275528 */ GIM_Reject,
     /* 2275529 */ // Label 30796: @2275529
     /* 2275529 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2275649),
     /* 2275534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2275537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2275540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275552 */   GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2275600), // Rule ID 52564 //
     /* 2275557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275560 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2275563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275599 */     // GIR_Coverage, 52564,
     /* 2275599 */     GIR_EraseRootFromParent_Done,
     /* 2275600 */   // Label 30851: @2275600
     /* 2275600 */   GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2275648), // Rule ID 52565 //
     /* 2275605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275608 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2275611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275647 */     // GIR_Coverage, 52565,
     /* 2275647 */     GIR_EraseRootFromParent_Done,
     /* 2275648 */   // Label 30852: @2275648
     /* 2275648 */   GIM_Reject,
     /* 2275649 */ // Label 30850: @2275649
     /* 2275649 */ GIM_Reject,
     /* 2275650 */ // Label 30797: @2275650
     /* 2275650 */ GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2275770),
     /* 2275655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2275658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2275661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2275673 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2275721), // Rule ID 52580 //
     /* 2275678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2275681 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2275684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2275698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275720 */     // GIR_Coverage, 52580,
     /* 2275720 */     GIR_EraseRootFromParent_Done,
     /* 2275721 */   // Label 30854: @2275721
     /* 2275721 */   GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2275769), // Rule ID 52581 //
     /* 2275726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2275729 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2275732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2275746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275768 */     // GIR_Coverage, 52581,
     /* 2275768 */     GIR_EraseRootFromParent_Done,
     /* 2275769 */   // Label 30855: @2275769
     /* 2275769 */   GIM_Reject,
     /* 2275770 */ // Label 30853: @2275770
     /* 2275770 */ GIM_Reject,
     /* 2275771 */ // Label 30798: @2275771
     /* 2275771 */ GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2275891),
     /* 2275776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2275779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2275782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2275794 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2275842), // Rule ID 52536 //
     /* 2275799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275802 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2275805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275841 */     // GIR_Coverage, 52536,
     /* 2275841 */     GIR_EraseRootFromParent_Done,
     /* 2275842 */   // Label 30857: @2275842
     /* 2275842 */   GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2275890), // Rule ID 52537 //
     /* 2275847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275850 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2275853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2275867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275889 */     // GIR_Coverage, 52537,
     /* 2275889 */     GIR_EraseRootFromParent_Done,
     /* 2275890 */   // Label 30858: @2275890
     /* 2275890 */   GIM_Reject,
     /* 2275891 */ // Label 30856: @2275891
     /* 2275891 */ GIM_Reject,
     /* 2275892 */ // Label 30799: @2275892
     /* 2275892 */ GIM_Try, /*On fail goto*//*Label 30859*/ GIMT_Encode4(2276012),
     /* 2275897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2275900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2275903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2275915 */   GIM_Try, /*On fail goto*//*Label 30860*/ GIMT_Encode4(2275963), // Rule ID 52552 //
     /* 2275920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275923 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2275926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275962 */     // GIR_Coverage, 52552,
     /* 2275962 */     GIR_EraseRootFromParent_Done,
     /* 2275963 */   // Label 30860: @2275963
     /* 2275963 */   GIM_Try, /*On fail goto*//*Label 30861*/ GIMT_Encode4(2276011), // Rule ID 52553 //
     /* 2275968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275971 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2275974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2275988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276010 */     // GIR_Coverage, 52553,
     /* 2276010 */     GIR_EraseRootFromParent_Done,
     /* 2276011 */   // Label 30861: @2276011
     /* 2276011 */   GIM_Reject,
     /* 2276012 */ // Label 30859: @2276012
     /* 2276012 */ GIM_Reject,
     /* 2276013 */ // Label 30800: @2276013
     /* 2276013 */ GIM_Try, /*On fail goto*//*Label 30862*/ GIMT_Encode4(2276133),
     /* 2276018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2276021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2276024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276036 */   GIM_Try, /*On fail goto*//*Label 30863*/ GIMT_Encode4(2276084), // Rule ID 52568 //
     /* 2276041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276044 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2276047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276083 */     // GIR_Coverage, 52568,
     /* 2276083 */     GIR_EraseRootFromParent_Done,
     /* 2276084 */   // Label 30863: @2276084
     /* 2276084 */   GIM_Try, /*On fail goto*//*Label 30864*/ GIMT_Encode4(2276132), // Rule ID 52569 //
     /* 2276089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276092 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2276095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276131 */     // GIR_Coverage, 52569,
     /* 2276131 */     GIR_EraseRootFromParent_Done,
     /* 2276132 */   // Label 30864: @2276132
     /* 2276132 */   GIM_Reject,
     /* 2276133 */ // Label 30862: @2276133
     /* 2276133 */ GIM_Reject,
     /* 2276134 */ // Label 30801: @2276134
     /* 2276134 */ GIM_Try, /*On fail goto*//*Label 30865*/ GIMT_Encode4(2276254),
     /* 2276139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2276142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2276145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276157 */   GIM_Try, /*On fail goto*//*Label 30866*/ GIMT_Encode4(2276205), // Rule ID 52540 //
     /* 2276162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276165 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2276168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2276182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276204 */     // GIR_Coverage, 52540,
     /* 2276204 */     GIR_EraseRootFromParent_Done,
     /* 2276205 */   // Label 30866: @2276205
     /* 2276205 */   GIM_Try, /*On fail goto*//*Label 30867*/ GIMT_Encode4(2276253), // Rule ID 52541 //
     /* 2276210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276213 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2276216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2276230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276252 */     // GIR_Coverage, 52541,
     /* 2276252 */     GIR_EraseRootFromParent_Done,
     /* 2276253 */   // Label 30867: @2276253
     /* 2276253 */   GIM_Reject,
     /* 2276254 */ // Label 30865: @2276254
     /* 2276254 */ GIM_Reject,
     /* 2276255 */ // Label 30802: @2276255
     /* 2276255 */ GIM_Try, /*On fail goto*//*Label 30868*/ GIMT_Encode4(2276375),
     /* 2276260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2276263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2276266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276278 */   GIM_Try, /*On fail goto*//*Label 30869*/ GIMT_Encode4(2276326), // Rule ID 52556 //
     /* 2276283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276286 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2276289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276325 */     // GIR_Coverage, 52556,
     /* 2276325 */     GIR_EraseRootFromParent_Done,
     /* 2276326 */   // Label 30869: @2276326
     /* 2276326 */   GIM_Try, /*On fail goto*//*Label 30870*/ GIMT_Encode4(2276374), // Rule ID 52557 //
     /* 2276331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276334 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2276337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276373 */     // GIR_Coverage, 52557,
     /* 2276373 */     GIR_EraseRootFromParent_Done,
     /* 2276374 */   // Label 30870: @2276374
     /* 2276374 */   GIM_Reject,
     /* 2276375 */ // Label 30868: @2276375
     /* 2276375 */ GIM_Reject,
     /* 2276376 */ // Label 30803: @2276376
     /* 2276376 */ GIM_Try, /*On fail goto*//*Label 30871*/ GIMT_Encode4(2276496),
     /* 2276381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2276384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2276387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2276399 */   GIM_Try, /*On fail goto*//*Label 30872*/ GIMT_Encode4(2276447), // Rule ID 52544 //
     /* 2276404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276407 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2276410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276446 */     // GIR_Coverage, 52544,
     /* 2276446 */     GIR_EraseRootFromParent_Done,
     /* 2276447 */   // Label 30872: @2276447
     /* 2276447 */   GIM_Try, /*On fail goto*//*Label 30873*/ GIMT_Encode4(2276495), // Rule ID 52545 //
     /* 2276452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276455 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2276458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2276472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276494 */     // GIR_Coverage, 52545,
     /* 2276494 */     GIR_EraseRootFromParent_Done,
     /* 2276495 */   // Label 30873: @2276495
     /* 2276495 */   GIM_Reject,
     /* 2276496 */ // Label 30871: @2276496
     /* 2276496 */ GIM_Reject,
     /* 2276497 */ // Label 30804: @2276497
     /* 2276497 */ GIM_Reject,
     /* 2276498 */ // Label 54: @2276498
     /* 2276498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30897*/ GIMT_Encode4(2279350),
     /* 2276509 */ /*GILLT_s32*//*Label 30874*/ GIMT_Encode4(2276633), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2276521 */ /*GILLT_nxv1s8*//*Label 30875*/ GIMT_Encode4(2276688),
     /* 2276525 */ /*GILLT_nxv1s16*//*Label 30876*/ GIMT_Encode4(2276809),
     /* 2276529 */ /*GILLT_nxv1s32*//*Label 30877*/ GIMT_Encode4(2276930),
     /* 2276533 */ /*GILLT_nxv1s64*//*Label 30878*/ GIMT_Encode4(2277051), GIMT_Encode4(0),
     /* 2276541 */ /*GILLT_nxv2s8*//*Label 30879*/ GIMT_Encode4(2277172),
     /* 2276545 */ /*GILLT_nxv2s16*//*Label 30880*/ GIMT_Encode4(2277293),
     /* 2276549 */ /*GILLT_nxv2s32*//*Label 30881*/ GIMT_Encode4(2277414),
     /* 2276553 */ /*GILLT_nxv2s64*//*Label 30882*/ GIMT_Encode4(2277535), GIMT_Encode4(0),
     /* 2276561 */ /*GILLT_nxv4s8*//*Label 30883*/ GIMT_Encode4(2277656),
     /* 2276565 */ /*GILLT_nxv4s16*//*Label 30884*/ GIMT_Encode4(2277777),
     /* 2276569 */ /*GILLT_nxv4s32*//*Label 30885*/ GIMT_Encode4(2277898),
     /* 2276573 */ /*GILLT_nxv4s64*//*Label 30886*/ GIMT_Encode4(2278019), GIMT_Encode4(0),
     /* 2276581 */ /*GILLT_nxv8s8*//*Label 30887*/ GIMT_Encode4(2278140),
     /* 2276585 */ /*GILLT_nxv8s16*//*Label 30888*/ GIMT_Encode4(2278261),
     /* 2276589 */ /*GILLT_nxv8s32*//*Label 30889*/ GIMT_Encode4(2278382),
     /* 2276593 */ /*GILLT_nxv8s64*//*Label 30890*/ GIMT_Encode4(2278503), GIMT_Encode4(0),
     /* 2276601 */ /*GILLT_nxv16s8*//*Label 30891*/ GIMT_Encode4(2278624),
     /* 2276605 */ /*GILLT_nxv16s16*//*Label 30892*/ GIMT_Encode4(2278745),
     /* 2276609 */ /*GILLT_nxv16s32*//*Label 30893*/ GIMT_Encode4(2278866), GIMT_Encode4(0),
     /* 2276617 */ /*GILLT_nxv32s8*//*Label 30894*/ GIMT_Encode4(2278987),
     /* 2276621 */ /*GILLT_nxv32s16*//*Label 30895*/ GIMT_Encode4(2279108), GIMT_Encode4(0),
     /* 2276629 */ /*GILLT_nxv64s8*//*Label 30896*/ GIMT_Encode4(2279229),
     /* 2276633 */ // Label 30874: @2276633
     /* 2276633 */ GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2276687),
     /* 2276638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2276641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2276644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2276656 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2276671), // Rule ID 64566 //
     /* 2276661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2276664 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2276664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2276669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276670 */     // GIR_Coverage, 64566,
     /* 2276670 */     GIR_Done,
     /* 2276671 */   // Label 30899: @2276671
     /* 2276671 */   GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2276686), // Rule ID 64567 //
     /* 2276676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2276679 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2276679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2276684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276685 */     // GIR_Coverage, 64567,
     /* 2276685 */     GIR_Done,
     /* 2276686 */   // Label 30900: @2276686
     /* 2276686 */   GIM_Reject,
     /* 2276687 */ // Label 30898: @2276687
     /* 2276687 */ GIM_Reject,
     /* 2276688 */ // Label 30875: @2276688
     /* 2276688 */ GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2276808),
     /* 2276693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2276696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2276699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276711 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2276759), // Rule ID 52364 //
     /* 2276716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276719 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2276722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2276736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276758 */     // GIR_Coverage, 52364,
     /* 2276758 */     GIR_EraseRootFromParent_Done,
     /* 2276759 */   // Label 30902: @2276759
     /* 2276759 */   GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2276807), // Rule ID 52365 //
     /* 2276764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276767 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2276770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2276784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276806 */     // GIR_Coverage, 52365,
     /* 2276806 */     GIR_EraseRootFromParent_Done,
     /* 2276807 */   // Label 30903: @2276807
     /* 2276807 */   GIM_Reject,
     /* 2276808 */ // Label 30901: @2276808
     /* 2276808 */ GIM_Reject,
     /* 2276809 */ // Label 30876: @2276809
     /* 2276809 */ GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2276929),
     /* 2276814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2276817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2276820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276832 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2276880), // Rule ID 52376 //
     /* 2276837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276840 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2276843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2276857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276879 */     // GIR_Coverage, 52376,
     /* 2276879 */     GIR_EraseRootFromParent_Done,
     /* 2276880 */   // Label 30905: @2276880
     /* 2276880 */   GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2276928), // Rule ID 52377 //
     /* 2276885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276888 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2276891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2276905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276927 */     // GIR_Coverage, 52377,
     /* 2276927 */     GIR_EraseRootFromParent_Done,
     /* 2276928 */   // Label 30906: @2276928
     /* 2276928 */   GIM_Reject,
     /* 2276929 */ // Label 30904: @2276929
     /* 2276929 */ GIM_Reject,
     /* 2276930 */ // Label 30877: @2276930
     /* 2276930 */ GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2277050),
     /* 2276935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2276938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2276941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276953 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2277001), // Rule ID 52384 //
     /* 2276958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276961 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2276964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2276978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277000 */     // GIR_Coverage, 52384,
     /* 2277000 */     GIR_EraseRootFromParent_Done,
     /* 2277001 */   // Label 30908: @2277001
     /* 2277001 */   GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2277049), // Rule ID 52385 //
     /* 2277006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277009 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2277012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2277026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277048 */     // GIR_Coverage, 52385,
     /* 2277048 */     GIR_EraseRootFromParent_Done,
     /* 2277049 */   // Label 30909: @2277049
     /* 2277049 */   GIM_Reject,
     /* 2277050 */ // Label 30907: @2277050
     /* 2277050 */ GIM_Reject,
     /* 2277051 */ // Label 30878: @2277051
     /* 2277051 */ GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2277171),
     /* 2277056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2277059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2277062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277074 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2277122), // Rule ID 52400 //
     /* 2277079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277082 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2277085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277121 */     // GIR_Coverage, 52400,
     /* 2277121 */     GIR_EraseRootFromParent_Done,
     /* 2277122 */   // Label 30911: @2277122
     /* 2277122 */   GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2277170), // Rule ID 52401 //
     /* 2277127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277130 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2277133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277169 */     // GIR_Coverage, 52401,
     /* 2277169 */     GIR_EraseRootFromParent_Done,
     /* 2277170 */   // Label 30912: @2277170
     /* 2277170 */   GIM_Reject,
     /* 2277171 */ // Label 30910: @2277171
     /* 2277171 */ GIM_Reject,
     /* 2277172 */ // Label 30879: @2277172
     /* 2277172 */ GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2277292),
     /* 2277177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2277180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2277183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277195 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2277243), // Rule ID 52368 //
     /* 2277200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277203 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2277206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2277220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277242 */     // GIR_Coverage, 52368,
     /* 2277242 */     GIR_EraseRootFromParent_Done,
     /* 2277243 */   // Label 30914: @2277243
     /* 2277243 */   GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2277291), // Rule ID 52369 //
     /* 2277248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277251 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2277254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2277268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277290 */     // GIR_Coverage, 52369,
     /* 2277290 */     GIR_EraseRootFromParent_Done,
     /* 2277291 */   // Label 30915: @2277291
     /* 2277291 */   GIM_Reject,
     /* 2277292 */ // Label 30913: @2277292
     /* 2277292 */ GIM_Reject,
     /* 2277293 */ // Label 30880: @2277293
     /* 2277293 */ GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2277413),
     /* 2277298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2277301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2277304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277316 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2277364), // Rule ID 52380 //
     /* 2277321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277324 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2277327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2277341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277363 */     // GIR_Coverage, 52380,
     /* 2277363 */     GIR_EraseRootFromParent_Done,
     /* 2277364 */   // Label 30917: @2277364
     /* 2277364 */   GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2277412), // Rule ID 52381 //
     /* 2277369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277372 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2277375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2277389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277411 */     // GIR_Coverage, 52381,
     /* 2277411 */     GIR_EraseRootFromParent_Done,
     /* 2277412 */   // Label 30918: @2277412
     /* 2277412 */   GIM_Reject,
     /* 2277413 */ // Label 30916: @2277413
     /* 2277413 */ GIM_Reject,
     /* 2277414 */ // Label 30881: @2277414
     /* 2277414 */ GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2277534),
     /* 2277419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2277422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2277425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277437 */   GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2277485), // Rule ID 52396 //
     /* 2277442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277445 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2277448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277484 */     // GIR_Coverage, 52396,
     /* 2277484 */     GIR_EraseRootFromParent_Done,
     /* 2277485 */   // Label 30920: @2277485
     /* 2277485 */   GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2277533), // Rule ID 52397 //
     /* 2277490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277493 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2277496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277532 */     // GIR_Coverage, 52397,
     /* 2277532 */     GIR_EraseRootFromParent_Done,
     /* 2277533 */   // Label 30921: @2277533
     /* 2277533 */   GIM_Reject,
     /* 2277534 */ // Label 30919: @2277534
     /* 2277534 */ GIM_Reject,
     /* 2277535 */ // Label 30882: @2277535
     /* 2277535 */ GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2277655),
     /* 2277540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2277543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2277546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277558 */   GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2277606), // Rule ID 52440 //
     /* 2277563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277566 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2277569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2277583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277605 */     // GIR_Coverage, 52440,
     /* 2277605 */     GIR_EraseRootFromParent_Done,
     /* 2277606 */   // Label 30923: @2277606
     /* 2277606 */   GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2277654), // Rule ID 52441 //
     /* 2277611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277614 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2277617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2277631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277653 */     // GIR_Coverage, 52441,
     /* 2277653 */     GIR_EraseRootFromParent_Done,
     /* 2277654 */   // Label 30924: @2277654
     /* 2277654 */   GIM_Reject,
     /* 2277655 */ // Label 30922: @2277655
     /* 2277655 */ GIM_Reject,
     /* 2277656 */ // Label 30883: @2277656
     /* 2277656 */ GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2277776),
     /* 2277661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2277664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2277667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277679 */   GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2277727), // Rule ID 52372 //
     /* 2277684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277687 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2277690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2277704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277726 */     // GIR_Coverage, 52372,
     /* 2277726 */     GIR_EraseRootFromParent_Done,
     /* 2277727 */   // Label 30926: @2277727
     /* 2277727 */   GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2277775), // Rule ID 52373 //
     /* 2277732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277735 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2277738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2277752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277774 */     // GIR_Coverage, 52373,
     /* 2277774 */     GIR_EraseRootFromParent_Done,
     /* 2277775 */   // Label 30927: @2277775
     /* 2277775 */   GIM_Reject,
     /* 2277776 */ // Label 30925: @2277776
     /* 2277776 */ GIM_Reject,
     /* 2277777 */ // Label 30884: @2277777
     /* 2277777 */ GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2277897),
     /* 2277782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2277785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2277788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277800 */   GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2277848), // Rule ID 52392 //
     /* 2277805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277808 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277847 */     // GIR_Coverage, 52392,
     /* 2277847 */     GIR_EraseRootFromParent_Done,
     /* 2277848 */   // Label 30929: @2277848
     /* 2277848 */   GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2277896), // Rule ID 52393 //
     /* 2277853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277856 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2277859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2277873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277895 */     // GIR_Coverage, 52393,
     /* 2277895 */     GIR_EraseRootFromParent_Done,
     /* 2277896 */   // Label 30930: @2277896
     /* 2277896 */   GIM_Reject,
     /* 2277897 */ // Label 30928: @2277897
     /* 2277897 */ GIM_Reject,
     /* 2277898 */ // Label 30885: @2277898
     /* 2277898 */ GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2278018),
     /* 2277903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2277906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2277909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277921 */   GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2277969), // Rule ID 52428 //
     /* 2277926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277929 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2277946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277968 */     // GIR_Coverage, 52428,
     /* 2277968 */     GIR_EraseRootFromParent_Done,
     /* 2277969 */   // Label 30932: @2277969
     /* 2277969 */   GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2278017), // Rule ID 52429 //
     /* 2277974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277977 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2277994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278016 */     // GIR_Coverage, 52429,
     /* 2278016 */     GIR_EraseRootFromParent_Done,
     /* 2278017 */   // Label 30933: @2278017
     /* 2278017 */   GIM_Reject,
     /* 2278018 */ // Label 30931: @2278018
     /* 2278018 */ GIM_Reject,
     /* 2278019 */ // Label 30886: @2278019
     /* 2278019 */ GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2278139),
     /* 2278024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2278027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2278030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278042 */   GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2278090), // Rule ID 52444 //
     /* 2278047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278050 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2278053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278089 */     // GIR_Coverage, 52444,
     /* 2278089 */     GIR_EraseRootFromParent_Done,
     /* 2278090 */   // Label 30935: @2278090
     /* 2278090 */   GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2278138), // Rule ID 52445 //
     /* 2278095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278098 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2278101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278137 */     // GIR_Coverage, 52445,
     /* 2278137 */     GIR_EraseRootFromParent_Done,
     /* 2278138 */   // Label 30936: @2278138
     /* 2278138 */   GIM_Reject,
     /* 2278139 */ // Label 30934: @2278139
     /* 2278139 */ GIM_Reject,
     /* 2278140 */ // Label 30887: @2278140
     /* 2278140 */ GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2278260),
     /* 2278145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2278148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2278151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278163 */   GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2278211), // Rule ID 52388 //
     /* 2278168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278171 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2278174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2278188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278210 */     // GIR_Coverage, 52388,
     /* 2278210 */     GIR_EraseRootFromParent_Done,
     /* 2278211 */   // Label 30938: @2278211
     /* 2278211 */   GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2278259), // Rule ID 52389 //
     /* 2278216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278219 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2278222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2278236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278258 */     // GIR_Coverage, 52389,
     /* 2278258 */     GIR_EraseRootFromParent_Done,
     /* 2278259 */   // Label 30939: @2278259
     /* 2278259 */   GIM_Reject,
     /* 2278260 */ // Label 30937: @2278260
     /* 2278260 */ GIM_Reject,
     /* 2278261 */ // Label 30888: @2278261
     /* 2278261 */ GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2278381),
     /* 2278266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2278269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2278272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278284 */   GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2278332), // Rule ID 52416 //
     /* 2278289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278292 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2278309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278331 */     // GIR_Coverage, 52416,
     /* 2278331 */     GIR_EraseRootFromParent_Done,
     /* 2278332 */   // Label 30941: @2278332
     /* 2278332 */   GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2278380), // Rule ID 52417 //
     /* 2278337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278340 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2278343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2278357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278379 */     // GIR_Coverage, 52417,
     /* 2278379 */     GIR_EraseRootFromParent_Done,
     /* 2278380 */   // Label 30942: @2278380
     /* 2278380 */   GIM_Reject,
     /* 2278381 */ // Label 30940: @2278381
     /* 2278381 */ GIM_Reject,
     /* 2278382 */ // Label 30889: @2278382
     /* 2278382 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2278502),
     /* 2278387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2278390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2278393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278405 */   GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2278453), // Rule ID 52432 //
     /* 2278410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278413 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278452 */     // GIR_Coverage, 52432,
     /* 2278452 */     GIR_EraseRootFromParent_Done,
     /* 2278453 */   // Label 30944: @2278453
     /* 2278453 */   GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2278501), // Rule ID 52433 //
     /* 2278458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278461 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2278464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278500 */     // GIR_Coverage, 52433,
     /* 2278500 */     GIR_EraseRootFromParent_Done,
     /* 2278501 */   // Label 30945: @2278501
     /* 2278501 */   GIM_Reject,
     /* 2278502 */ // Label 30943: @2278502
     /* 2278502 */ GIM_Reject,
     /* 2278503 */ // Label 30890: @2278503
     /* 2278503 */ GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2278623),
     /* 2278508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2278511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2278514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278526 */   GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2278574), // Rule ID 52448 //
     /* 2278531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278534 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2278551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278573 */     // GIR_Coverage, 52448,
     /* 2278573 */     GIR_EraseRootFromParent_Done,
     /* 2278574 */   // Label 30947: @2278574
     /* 2278574 */   GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2278622), // Rule ID 52449 //
     /* 2278579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278582 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2278599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278621 */     // GIR_Coverage, 52449,
     /* 2278621 */     GIR_EraseRootFromParent_Done,
     /* 2278622 */   // Label 30948: @2278622
     /* 2278622 */   GIM_Reject,
     /* 2278623 */ // Label 30946: @2278623
     /* 2278623 */ GIM_Reject,
     /* 2278624 */ // Label 30891: @2278624
     /* 2278624 */ GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2278744),
     /* 2278629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2278632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2278635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278647 */   GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2278695), // Rule ID 52404 //
     /* 2278652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278655 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2278672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278694 */     // GIR_Coverage, 52404,
     /* 2278694 */     GIR_EraseRootFromParent_Done,
     /* 2278695 */   // Label 30950: @2278695
     /* 2278695 */   GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2278743), // Rule ID 52405 //
     /* 2278700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278703 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2278720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278742 */     // GIR_Coverage, 52405,
     /* 2278742 */     GIR_EraseRootFromParent_Done,
     /* 2278743 */   // Label 30951: @2278743
     /* 2278743 */   GIM_Reject,
     /* 2278744 */ // Label 30949: @2278744
     /* 2278744 */ GIM_Reject,
     /* 2278745 */ // Label 30892: @2278745
     /* 2278745 */ GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2278865),
     /* 2278750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2278753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2278756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278768 */   GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2278816), // Rule ID 52420 //
     /* 2278773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278776 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278815 */     // GIR_Coverage, 52420,
     /* 2278815 */     GIR_EraseRootFromParent_Done,
     /* 2278816 */   // Label 30953: @2278816
     /* 2278816 */   GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2278864), // Rule ID 52421 //
     /* 2278821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278824 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2278841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278863 */     // GIR_Coverage, 52421,
     /* 2278863 */     GIR_EraseRootFromParent_Done,
     /* 2278864 */   // Label 30954: @2278864
     /* 2278864 */   GIM_Reject,
     /* 2278865 */ // Label 30952: @2278865
     /* 2278865 */ GIM_Reject,
     /* 2278866 */ // Label 30893: @2278866
     /* 2278866 */ GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2278986),
     /* 2278871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2278874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2278877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278889 */   GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2278937), // Rule ID 52436 //
     /* 2278894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278897 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2278914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278936 */     // GIR_Coverage, 52436,
     /* 2278936 */     GIR_EraseRootFromParent_Done,
     /* 2278937 */   // Label 30956: @2278937
     /* 2278937 */   GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2278985), // Rule ID 52437 //
     /* 2278942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278945 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2278962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278984 */     // GIR_Coverage, 52437,
     /* 2278984 */     GIR_EraseRootFromParent_Done,
     /* 2278985 */   // Label 30957: @2278985
     /* 2278985 */   GIM_Reject,
     /* 2278986 */ // Label 30955: @2278986
     /* 2278986 */ GIM_Reject,
     /* 2278987 */ // Label 30894: @2278987
     /* 2278987 */ GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2279107),
     /* 2278992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2278995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2278998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279010 */   GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2279058), // Rule ID 52408 //
     /* 2279015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279018 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2279021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2279035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279057 */     // GIR_Coverage, 52408,
     /* 2279057 */     GIR_EraseRootFromParent_Done,
     /* 2279058 */   // Label 30959: @2279058
     /* 2279058 */   GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2279106), // Rule ID 52409 //
     /* 2279063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279066 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2279069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2279083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279105 */     // GIR_Coverage, 52409,
     /* 2279105 */     GIR_EraseRootFromParent_Done,
     /* 2279106 */   // Label 30960: @2279106
     /* 2279106 */   GIM_Reject,
     /* 2279107 */ // Label 30958: @2279107
     /* 2279107 */ GIM_Reject,
     /* 2279108 */ // Label 30895: @2279108
     /* 2279108 */ GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2279228),
     /* 2279113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2279116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2279119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279131 */   GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2279179), // Rule ID 52424 //
     /* 2279136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279139 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2279156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279178 */     // GIR_Coverage, 52424,
     /* 2279178 */     GIR_EraseRootFromParent_Done,
     /* 2279179 */   // Label 30962: @2279179
     /* 2279179 */   GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2279227), // Rule ID 52425 //
     /* 2279184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279187 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2279190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2279204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279226 */     // GIR_Coverage, 52425,
     /* 2279226 */     GIR_EraseRootFromParent_Done,
     /* 2279227 */   // Label 30963: @2279227
     /* 2279227 */   GIM_Reject,
     /* 2279228 */ // Label 30961: @2279228
     /* 2279228 */ GIM_Reject,
     /* 2279229 */ // Label 30896: @2279229
     /* 2279229 */ GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2279349),
     /* 2279234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2279237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2279240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279252 */   GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2279300), // Rule ID 52412 //
     /* 2279257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279260 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2279277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279299 */     // GIR_Coverage, 52412,
     /* 2279299 */     GIR_EraseRootFromParent_Done,
     /* 2279300 */   // Label 30965: @2279300
     /* 2279300 */   GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2279348), // Rule ID 52413 //
     /* 2279305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279308 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2279325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279347 */     // GIR_Coverage, 52413,
     /* 2279347 */     GIR_EraseRootFromParent_Done,
     /* 2279348 */   // Label 30966: @2279348
     /* 2279348 */   GIM_Reject,
     /* 2279349 */ // Label 30964: @2279349
     /* 2279349 */ GIM_Reject,
     /* 2279350 */ // Label 30897: @2279350
     /* 2279350 */ GIM_Reject,
     /* 2279351 */ // Label 55: @2279351
     /* 2279351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30990*/ GIMT_Encode4(2282203),
     /* 2279362 */ /*GILLT_s32*//*Label 30967*/ GIMT_Encode4(2279486), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2279374 */ /*GILLT_nxv1s8*//*Label 30968*/ GIMT_Encode4(2279541),
     /* 2279378 */ /*GILLT_nxv1s16*//*Label 30969*/ GIMT_Encode4(2279662),
     /* 2279382 */ /*GILLT_nxv1s32*//*Label 30970*/ GIMT_Encode4(2279783),
     /* 2279386 */ /*GILLT_nxv1s64*//*Label 30971*/ GIMT_Encode4(2279904), GIMT_Encode4(0),
     /* 2279394 */ /*GILLT_nxv2s8*//*Label 30972*/ GIMT_Encode4(2280025),
     /* 2279398 */ /*GILLT_nxv2s16*//*Label 30973*/ GIMT_Encode4(2280146),
     /* 2279402 */ /*GILLT_nxv2s32*//*Label 30974*/ GIMT_Encode4(2280267),
     /* 2279406 */ /*GILLT_nxv2s64*//*Label 30975*/ GIMT_Encode4(2280388), GIMT_Encode4(0),
     /* 2279414 */ /*GILLT_nxv4s8*//*Label 30976*/ GIMT_Encode4(2280509),
     /* 2279418 */ /*GILLT_nxv4s16*//*Label 30977*/ GIMT_Encode4(2280630),
     /* 2279422 */ /*GILLT_nxv4s32*//*Label 30978*/ GIMT_Encode4(2280751),
     /* 2279426 */ /*GILLT_nxv4s64*//*Label 30979*/ GIMT_Encode4(2280872), GIMT_Encode4(0),
     /* 2279434 */ /*GILLT_nxv8s8*//*Label 30980*/ GIMT_Encode4(2280993),
     /* 2279438 */ /*GILLT_nxv8s16*//*Label 30981*/ GIMT_Encode4(2281114),
     /* 2279442 */ /*GILLT_nxv8s32*//*Label 30982*/ GIMT_Encode4(2281235),
     /* 2279446 */ /*GILLT_nxv8s64*//*Label 30983*/ GIMT_Encode4(2281356), GIMT_Encode4(0),
     /* 2279454 */ /*GILLT_nxv16s8*//*Label 30984*/ GIMT_Encode4(2281477),
     /* 2279458 */ /*GILLT_nxv16s16*//*Label 30985*/ GIMT_Encode4(2281598),
     /* 2279462 */ /*GILLT_nxv16s32*//*Label 30986*/ GIMT_Encode4(2281719), GIMT_Encode4(0),
     /* 2279470 */ /*GILLT_nxv32s8*//*Label 30987*/ GIMT_Encode4(2281840),
     /* 2279474 */ /*GILLT_nxv32s16*//*Label 30988*/ GIMT_Encode4(2281961), GIMT_Encode4(0),
     /* 2279482 */ /*GILLT_nxv64s8*//*Label 30989*/ GIMT_Encode4(2282082),
     /* 2279486 */ // Label 30967: @2279486
     /* 2279486 */ GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2279540),
     /* 2279491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2279509 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2279524), // Rule ID 64572 //
     /* 2279514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2279517 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2279517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2279522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279523 */     // GIR_Coverage, 64572,
     /* 2279523 */     GIR_Done,
     /* 2279524 */   // Label 30992: @2279524
     /* 2279524 */   GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2279539), // Rule ID 64573 //
     /* 2279529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2279532 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2279532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2279537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279538 */     // GIR_Coverage, 64573,
     /* 2279538 */     GIR_Done,
     /* 2279539 */   // Label 30993: @2279539
     /* 2279539 */   GIM_Reject,
     /* 2279540 */ // Label 30991: @2279540
     /* 2279540 */ GIM_Reject,
     /* 2279541 */ // Label 30968: @2279541
     /* 2279541 */ GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2279661),
     /* 2279546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2279549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2279552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279564 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2279612), // Rule ID 52716 //
     /* 2279569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279572 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2279589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279611 */     // GIR_Coverage, 52716,
     /* 2279611 */     GIR_EraseRootFromParent_Done,
     /* 2279612 */   // Label 30995: @2279612
     /* 2279612 */   GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2279660), // Rule ID 52717 //
     /* 2279617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279620 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2279637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279659 */     // GIR_Coverage, 52717,
     /* 2279659 */     GIR_EraseRootFromParent_Done,
     /* 2279660 */   // Label 30996: @2279660
     /* 2279660 */   GIM_Reject,
     /* 2279661 */ // Label 30994: @2279661
     /* 2279661 */ GIM_Reject,
     /* 2279662 */ // Label 30969: @2279662
     /* 2279662 */ GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2279782),
     /* 2279667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2279670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2279673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279685 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2279733), // Rule ID 52728 //
     /* 2279690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279693 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2279710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279732 */     // GIR_Coverage, 52728,
     /* 2279732 */     GIR_EraseRootFromParent_Done,
     /* 2279733 */   // Label 30998: @2279733
     /* 2279733 */   GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2279781), // Rule ID 52729 //
     /* 2279738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279741 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2279758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279780 */     // GIR_Coverage, 52729,
     /* 2279780 */     GIR_EraseRootFromParent_Done,
     /* 2279781 */   // Label 30999: @2279781
     /* 2279781 */   GIM_Reject,
     /* 2279782 */ // Label 30997: @2279782
     /* 2279782 */ GIM_Reject,
     /* 2279783 */ // Label 30970: @2279783
     /* 2279783 */ GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2279903),
     /* 2279788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2279791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2279794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279806 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2279854), // Rule ID 52736 //
     /* 2279811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279814 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2279817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2279831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279853 */     // GIR_Coverage, 52736,
     /* 2279853 */     GIR_EraseRootFromParent_Done,
     /* 2279854 */   // Label 31001: @2279854
     /* 2279854 */   GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2279902), // Rule ID 52737 //
     /* 2279859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279862 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2279865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2279879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279901 */     // GIR_Coverage, 52737,
     /* 2279901 */     GIR_EraseRootFromParent_Done,
     /* 2279902 */   // Label 31002: @2279902
     /* 2279902 */   GIM_Reject,
     /* 2279903 */ // Label 31000: @2279903
     /* 2279903 */ GIM_Reject,
     /* 2279904 */ // Label 30971: @2279904
     /* 2279904 */ GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2280024),
     /* 2279909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2279912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2279915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279927 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2279975), // Rule ID 52752 //
     /* 2279932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279935 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2279938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2279952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279974 */     // GIR_Coverage, 52752,
     /* 2279974 */     GIR_EraseRootFromParent_Done,
     /* 2279975 */   // Label 31004: @2279975
     /* 2279975 */   GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2280023), // Rule ID 52753 //
     /* 2279980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279983 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2279986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2280000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280022 */     // GIR_Coverage, 52753,
     /* 2280022 */     GIR_EraseRootFromParent_Done,
     /* 2280023 */   // Label 31005: @2280023
     /* 2280023 */   GIM_Reject,
     /* 2280024 */ // Label 31003: @2280024
     /* 2280024 */ GIM_Reject,
     /* 2280025 */ // Label 30972: @2280025
     /* 2280025 */ GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2280145),
     /* 2280030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2280033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2280036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280048 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2280096), // Rule ID 52720 //
     /* 2280053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280056 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2280059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2280073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280095 */     // GIR_Coverage, 52720,
     /* 2280095 */     GIR_EraseRootFromParent_Done,
     /* 2280096 */   // Label 31007: @2280096
     /* 2280096 */   GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2280144), // Rule ID 52721 //
     /* 2280101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280104 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2280107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2280121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280143 */     // GIR_Coverage, 52721,
     /* 2280143 */     GIR_EraseRootFromParent_Done,
     /* 2280144 */   // Label 31008: @2280144
     /* 2280144 */   GIM_Reject,
     /* 2280145 */ // Label 31006: @2280145
     /* 2280145 */ GIM_Reject,
     /* 2280146 */ // Label 30973: @2280146
     /* 2280146 */ GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2280266),
     /* 2280151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2280154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2280157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280169 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2280217), // Rule ID 52732 //
     /* 2280174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280177 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2280194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280216 */     // GIR_Coverage, 52732,
     /* 2280216 */     GIR_EraseRootFromParent_Done,
     /* 2280217 */   // Label 31010: @2280217
     /* 2280217 */   GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2280265), // Rule ID 52733 //
     /* 2280222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280225 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2280242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280264 */     // GIR_Coverage, 52733,
     /* 2280264 */     GIR_EraseRootFromParent_Done,
     /* 2280265 */   // Label 31011: @2280265
     /* 2280265 */   GIM_Reject,
     /* 2280266 */ // Label 31009: @2280266
     /* 2280266 */ GIM_Reject,
     /* 2280267 */ // Label 30974: @2280267
     /* 2280267 */ GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2280387),
     /* 2280272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2280275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2280278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280290 */   GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2280338), // Rule ID 52748 //
     /* 2280295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280298 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2280315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280337 */     // GIR_Coverage, 52748,
     /* 2280337 */     GIR_EraseRootFromParent_Done,
     /* 2280338 */   // Label 31013: @2280338
     /* 2280338 */   GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2280386), // Rule ID 52749 //
     /* 2280343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280346 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2280363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280385 */     // GIR_Coverage, 52749,
     /* 2280385 */     GIR_EraseRootFromParent_Done,
     /* 2280386 */   // Label 31014: @2280386
     /* 2280386 */   GIM_Reject,
     /* 2280387 */ // Label 31012: @2280387
     /* 2280387 */ GIM_Reject,
     /* 2280388 */ // Label 30975: @2280388
     /* 2280388 */ GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2280508),
     /* 2280393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2280396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2280399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280411 */   GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2280459), // Rule ID 52792 //
     /* 2280416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2280419 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2280436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280458 */     // GIR_Coverage, 52792,
     /* 2280458 */     GIR_EraseRootFromParent_Done,
     /* 2280459 */   // Label 31016: @2280459
     /* 2280459 */   GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2280507), // Rule ID 52793 //
     /* 2280464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2280467 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2280484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280506 */     // GIR_Coverage, 52793,
     /* 2280506 */     GIR_EraseRootFromParent_Done,
     /* 2280507 */   // Label 31017: @2280507
     /* 2280507 */   GIM_Reject,
     /* 2280508 */ // Label 31015: @2280508
     /* 2280508 */ GIM_Reject,
     /* 2280509 */ // Label 30976: @2280509
     /* 2280509 */ GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2280629),
     /* 2280514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2280517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2280520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280532 */   GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2280580), // Rule ID 52724 //
     /* 2280537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280540 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2280557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280579 */     // GIR_Coverage, 52724,
     /* 2280579 */     GIR_EraseRootFromParent_Done,
     /* 2280580 */   // Label 31019: @2280580
     /* 2280580 */   GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2280628), // Rule ID 52725 //
     /* 2280585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280588 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2280605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280627 */     // GIR_Coverage, 52725,
     /* 2280627 */     GIR_EraseRootFromParent_Done,
     /* 2280628 */   // Label 31020: @2280628
     /* 2280628 */   GIM_Reject,
     /* 2280629 */ // Label 31018: @2280629
     /* 2280629 */ GIM_Reject,
     /* 2280630 */ // Label 30977: @2280630
     /* 2280630 */ GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2280750),
     /* 2280635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2280638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2280641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280653 */   GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2280701), // Rule ID 52744 //
     /* 2280658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280661 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2280678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280700 */     // GIR_Coverage, 52744,
     /* 2280700 */     GIR_EraseRootFromParent_Done,
     /* 2280701 */   // Label 31022: @2280701
     /* 2280701 */   GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2280749), // Rule ID 52745 //
     /* 2280706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280709 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2280726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280748 */     // GIR_Coverage, 52745,
     /* 2280748 */     GIR_EraseRootFromParent_Done,
     /* 2280749 */   // Label 31023: @2280749
     /* 2280749 */   GIM_Reject,
     /* 2280750 */ // Label 31021: @2280750
     /* 2280750 */ GIM_Reject,
     /* 2280751 */ // Label 30978: @2280751
     /* 2280751 */ GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2280871),
     /* 2280756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2280759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2280762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280774 */   GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2280822), // Rule ID 52780 //
     /* 2280779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280782 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2280785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2280799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280821 */     // GIR_Coverage, 52780,
     /* 2280821 */     GIR_EraseRootFromParent_Done,
     /* 2280822 */   // Label 31025: @2280822
     /* 2280822 */   GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2280870), // Rule ID 52781 //
     /* 2280827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280830 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2280833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2280847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280869 */     // GIR_Coverage, 52781,
     /* 2280869 */     GIR_EraseRootFromParent_Done,
     /* 2280870 */   // Label 31026: @2280870
     /* 2280870 */   GIM_Reject,
     /* 2280871 */ // Label 31024: @2280871
     /* 2280871 */ GIM_Reject,
     /* 2280872 */ // Label 30979: @2280872
     /* 2280872 */ GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2280992),
     /* 2280877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2280880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2280883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280895 */   GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2280943), // Rule ID 52796 //
     /* 2280900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2280903 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2280906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2280920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280942 */     // GIR_Coverage, 52796,
     /* 2280942 */     GIR_EraseRootFromParent_Done,
     /* 2280943 */   // Label 31028: @2280943
     /* 2280943 */   GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2280991), // Rule ID 52797 //
     /* 2280948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2280951 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2280954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2280968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280990 */     // GIR_Coverage, 52797,
     /* 2280990 */     GIR_EraseRootFromParent_Done,
     /* 2280991 */   // Label 31029: @2280991
     /* 2280991 */   GIM_Reject,
     /* 2280992 */ // Label 31027: @2280992
     /* 2280992 */ GIM_Reject,
     /* 2280993 */ // Label 30980: @2280993
     /* 2280993 */ GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2281113),
     /* 2280998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2281001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2281004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281016 */   GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2281064), // Rule ID 52740 //
     /* 2281021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281024 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2281027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2281041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281063 */     // GIR_Coverage, 52740,
     /* 2281063 */     GIR_EraseRootFromParent_Done,
     /* 2281064 */   // Label 31031: @2281064
     /* 2281064 */   GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2281112), // Rule ID 52741 //
     /* 2281069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281072 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2281075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2281089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281111 */     // GIR_Coverage, 52741,
     /* 2281111 */     GIR_EraseRootFromParent_Done,
     /* 2281112 */   // Label 31032: @2281112
     /* 2281112 */   GIM_Reject,
     /* 2281113 */ // Label 31030: @2281113
     /* 2281113 */ GIM_Reject,
     /* 2281114 */ // Label 30981: @2281114
     /* 2281114 */ GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2281234),
     /* 2281119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2281122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2281125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281137 */   GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2281185), // Rule ID 52768 //
     /* 2281142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281145 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2281162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281184 */     // GIR_Coverage, 52768,
     /* 2281184 */     GIR_EraseRootFromParent_Done,
     /* 2281185 */   // Label 31034: @2281185
     /* 2281185 */   GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2281233), // Rule ID 52769 //
     /* 2281190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281193 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2281196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2281210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281232 */     // GIR_Coverage, 52769,
     /* 2281232 */     GIR_EraseRootFromParent_Done,
     /* 2281233 */   // Label 31035: @2281233
     /* 2281233 */   GIM_Reject,
     /* 2281234 */ // Label 31033: @2281234
     /* 2281234 */ GIM_Reject,
     /* 2281235 */ // Label 30982: @2281235
     /* 2281235 */ GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2281355),
     /* 2281240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2281243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2281246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281258 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2281306), // Rule ID 52784 //
     /* 2281263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281266 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281305 */     // GIR_Coverage, 52784,
     /* 2281305 */     GIR_EraseRootFromParent_Done,
     /* 2281306 */   // Label 31037: @2281306
     /* 2281306 */   GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2281354), // Rule ID 52785 //
     /* 2281311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281314 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281353 */     // GIR_Coverage, 52785,
     /* 2281353 */     GIR_EraseRootFromParent_Done,
     /* 2281354 */   // Label 31038: @2281354
     /* 2281354 */   GIM_Reject,
     /* 2281355 */ // Label 31036: @2281355
     /* 2281355 */ GIM_Reject,
     /* 2281356 */ // Label 30983: @2281356
     /* 2281356 */ GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2281476),
     /* 2281361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2281364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2281367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281379 */   GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2281427), // Rule ID 52800 //
     /* 2281384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2281387 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2281404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281426 */     // GIR_Coverage, 52800,
     /* 2281426 */     GIR_EraseRootFromParent_Done,
     /* 2281427 */   // Label 31040: @2281427
     /* 2281427 */   GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2281475), // Rule ID 52801 //
     /* 2281432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2281435 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2281452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281474 */     // GIR_Coverage, 52801,
     /* 2281474 */     GIR_EraseRootFromParent_Done,
     /* 2281475 */   // Label 31041: @2281475
     /* 2281475 */   GIM_Reject,
     /* 2281476 */ // Label 31039: @2281476
     /* 2281476 */ GIM_Reject,
     /* 2281477 */ // Label 30984: @2281477
     /* 2281477 */ GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2281597),
     /* 2281482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2281485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2281488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281500 */   GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2281548), // Rule ID 52756 //
     /* 2281505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281508 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2281525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281547 */     // GIR_Coverage, 52756,
     /* 2281547 */     GIR_EraseRootFromParent_Done,
     /* 2281548 */   // Label 31043: @2281548
     /* 2281548 */   GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2281596), // Rule ID 52757 //
     /* 2281553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281556 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2281573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281595 */     // GIR_Coverage, 52757,
     /* 2281595 */     GIR_EraseRootFromParent_Done,
     /* 2281596 */   // Label 31044: @2281596
     /* 2281596 */   GIM_Reject,
     /* 2281597 */ // Label 31042: @2281597
     /* 2281597 */ GIM_Reject,
     /* 2281598 */ // Label 30985: @2281598
     /* 2281598 */ GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2281718),
     /* 2281603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2281606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2281609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281621 */   GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2281669), // Rule ID 52772 //
     /* 2281626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281629 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281668 */     // GIR_Coverage, 52772,
     /* 2281668 */     GIR_EraseRootFromParent_Done,
     /* 2281669 */   // Label 31046: @2281669
     /* 2281669 */   GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2281717), // Rule ID 52773 //
     /* 2281674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281677 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281716 */     // GIR_Coverage, 52773,
     /* 2281716 */     GIR_EraseRootFromParent_Done,
     /* 2281717 */   // Label 31047: @2281717
     /* 2281717 */   GIM_Reject,
     /* 2281718 */ // Label 31045: @2281718
     /* 2281718 */ GIM_Reject,
     /* 2281719 */ // Label 30986: @2281719
     /* 2281719 */ GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2281839),
     /* 2281724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2281727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2281730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281742 */   GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2281790), // Rule ID 52788 //
     /* 2281747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281750 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2281767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281789 */     // GIR_Coverage, 52788,
     /* 2281789 */     GIR_EraseRootFromParent_Done,
     /* 2281790 */   // Label 31049: @2281790
     /* 2281790 */   GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2281838), // Rule ID 52789 //
     /* 2281795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281798 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2281815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281837 */     // GIR_Coverage, 52789,
     /* 2281837 */     GIR_EraseRootFromParent_Done,
     /* 2281838 */   // Label 31050: @2281838
     /* 2281838 */   GIM_Reject,
     /* 2281839 */ // Label 31048: @2281839
     /* 2281839 */ GIM_Reject,
     /* 2281840 */ // Label 30987: @2281840
     /* 2281840 */ GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2281960),
     /* 2281845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2281848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2281851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281863 */   GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2281911), // Rule ID 52760 //
     /* 2281868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281871 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281910 */     // GIR_Coverage, 52760,
     /* 2281910 */     GIR_EraseRootFromParent_Done,
     /* 2281911 */   // Label 31052: @2281911
     /* 2281911 */   GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2281959), // Rule ID 52761 //
     /* 2281916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281919 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2281936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2281957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281958 */     // GIR_Coverage, 52761,
     /* 2281958 */     GIR_EraseRootFromParent_Done,
     /* 2281959 */   // Label 31053: @2281959
     /* 2281959 */   GIM_Reject,
     /* 2281960 */ // Label 31051: @2281960
     /* 2281960 */ GIM_Reject,
     /* 2281961 */ // Label 30988: @2281961
     /* 2281961 */ GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2282081),
     /* 2281966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2281969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2281972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281984 */   GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2282032), // Rule ID 52776 //
     /* 2281989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281992 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2282009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282031 */     // GIR_Coverage, 52776,
     /* 2282031 */     GIR_EraseRootFromParent_Done,
     /* 2282032 */   // Label 31055: @2282032
     /* 2282032 */   GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2282080), // Rule ID 52777 //
     /* 2282037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282040 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2282043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2282057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282079 */     // GIR_Coverage, 52777,
     /* 2282079 */     GIR_EraseRootFromParent_Done,
     /* 2282080 */   // Label 31056: @2282080
     /* 2282080 */   GIM_Reject,
     /* 2282081 */ // Label 31054: @2282081
     /* 2282081 */ GIM_Reject,
     /* 2282082 */ // Label 30989: @2282082
     /* 2282082 */ GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2282202),
     /* 2282087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2282090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2282093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282105 */   GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2282153), // Rule ID 52764 //
     /* 2282110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282113 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2282116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2282130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282152 */     // GIR_Coverage, 52764,
     /* 2282152 */     GIR_EraseRootFromParent_Done,
     /* 2282153 */   // Label 31058: @2282153
     /* 2282153 */   GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2282201), // Rule ID 52765 //
     /* 2282158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282161 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2282164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2282178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282200 */     // GIR_Coverage, 52765,
     /* 2282200 */     GIR_EraseRootFromParent_Done,
     /* 2282201 */   // Label 31059: @2282201
     /* 2282201 */   GIM_Reject,
     /* 2282202 */ // Label 31057: @2282202
     /* 2282202 */ GIM_Reject,
     /* 2282203 */ // Label 30990: @2282203
     /* 2282203 */ GIM_Reject,
     /* 2282204 */ // Label 56: @2282204
     /* 2282204 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31083*/ GIMT_Encode4(2285056),
     /* 2282215 */ /*GILLT_s32*//*Label 31060*/ GIMT_Encode4(2282339), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2282227 */ /*GILLT_nxv1s8*//*Label 31061*/ GIMT_Encode4(2282394),
     /* 2282231 */ /*GILLT_nxv1s16*//*Label 31062*/ GIMT_Encode4(2282515),
     /* 2282235 */ /*GILLT_nxv1s32*//*Label 31063*/ GIMT_Encode4(2282636),
     /* 2282239 */ /*GILLT_nxv1s64*//*Label 31064*/ GIMT_Encode4(2282757), GIMT_Encode4(0),
     /* 2282247 */ /*GILLT_nxv2s8*//*Label 31065*/ GIMT_Encode4(2282878),
     /* 2282251 */ /*GILLT_nxv2s16*//*Label 31066*/ GIMT_Encode4(2282999),
     /* 2282255 */ /*GILLT_nxv2s32*//*Label 31067*/ GIMT_Encode4(2283120),
     /* 2282259 */ /*GILLT_nxv2s64*//*Label 31068*/ GIMT_Encode4(2283241), GIMT_Encode4(0),
     /* 2282267 */ /*GILLT_nxv4s8*//*Label 31069*/ GIMT_Encode4(2283362),
     /* 2282271 */ /*GILLT_nxv4s16*//*Label 31070*/ GIMT_Encode4(2283483),
     /* 2282275 */ /*GILLT_nxv4s32*//*Label 31071*/ GIMT_Encode4(2283604),
     /* 2282279 */ /*GILLT_nxv4s64*//*Label 31072*/ GIMT_Encode4(2283725), GIMT_Encode4(0),
     /* 2282287 */ /*GILLT_nxv8s8*//*Label 31073*/ GIMT_Encode4(2283846),
     /* 2282291 */ /*GILLT_nxv8s16*//*Label 31074*/ GIMT_Encode4(2283967),
     /* 2282295 */ /*GILLT_nxv8s32*//*Label 31075*/ GIMT_Encode4(2284088),
     /* 2282299 */ /*GILLT_nxv8s64*//*Label 31076*/ GIMT_Encode4(2284209), GIMT_Encode4(0),
     /* 2282307 */ /*GILLT_nxv16s8*//*Label 31077*/ GIMT_Encode4(2284330),
     /* 2282311 */ /*GILLT_nxv16s16*//*Label 31078*/ GIMT_Encode4(2284451),
     /* 2282315 */ /*GILLT_nxv16s32*//*Label 31079*/ GIMT_Encode4(2284572), GIMT_Encode4(0),
     /* 2282323 */ /*GILLT_nxv32s8*//*Label 31080*/ GIMT_Encode4(2284693),
     /* 2282327 */ /*GILLT_nxv32s16*//*Label 31081*/ GIMT_Encode4(2284814), GIMT_Encode4(0),
     /* 2282335 */ /*GILLT_nxv64s8*//*Label 31082*/ GIMT_Encode4(2284935),
     /* 2282339 */ // Label 31060: @2282339
     /* 2282339 */ GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2282393),
     /* 2282344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2282347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2282350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2282354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2282358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2282362 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2282377), // Rule ID 64570 //
     /* 2282367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2282370 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2282370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2282375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282376 */     // GIR_Coverage, 64570,
     /* 2282376 */     GIR_Done,
     /* 2282377 */   // Label 31085: @2282377
     /* 2282377 */   GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2282392), // Rule ID 64571 //
     /* 2282382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2282385 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2282385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2282390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282391 */     // GIR_Coverage, 64571,
     /* 2282391 */     GIR_Done,
     /* 2282392 */   // Label 31086: @2282392
     /* 2282392 */   GIM_Reject,
     /* 2282393 */ // Label 31084: @2282393
     /* 2282393 */ GIM_Reject,
     /* 2282394 */ // Label 31061: @2282394
     /* 2282394 */ GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2282514),
     /* 2282399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2282402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2282405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282417 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2282465), // Rule ID 52628 //
     /* 2282422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282425 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2282442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282464 */     // GIR_Coverage, 52628,
     /* 2282464 */     GIR_EraseRootFromParent_Done,
     /* 2282465 */   // Label 31088: @2282465
     /* 2282465 */   GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2282513), // Rule ID 52629 //
     /* 2282470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282473 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2282490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282512 */     // GIR_Coverage, 52629,
     /* 2282512 */     GIR_EraseRootFromParent_Done,
     /* 2282513 */   // Label 31089: @2282513
     /* 2282513 */   GIM_Reject,
     /* 2282514 */ // Label 31087: @2282514
     /* 2282514 */ GIM_Reject,
     /* 2282515 */ // Label 31062: @2282515
     /* 2282515 */ GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2282635),
     /* 2282520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2282523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2282526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282538 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2282586), // Rule ID 52640 //
     /* 2282543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282546 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2282563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282585 */     // GIR_Coverage, 52640,
     /* 2282585 */     GIR_EraseRootFromParent_Done,
     /* 2282586 */   // Label 31091: @2282586
     /* 2282586 */   GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2282634), // Rule ID 52641 //
     /* 2282591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282594 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2282611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282633 */     // GIR_Coverage, 52641,
     /* 2282633 */     GIR_EraseRootFromParent_Done,
     /* 2282634 */   // Label 31092: @2282634
     /* 2282634 */   GIM_Reject,
     /* 2282635 */ // Label 31090: @2282635
     /* 2282635 */ GIM_Reject,
     /* 2282636 */ // Label 31063: @2282636
     /* 2282636 */ GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2282756),
     /* 2282641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2282644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2282647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282659 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2282707), // Rule ID 52648 //
     /* 2282664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282667 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2282684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282706 */     // GIR_Coverage, 52648,
     /* 2282706 */     GIR_EraseRootFromParent_Done,
     /* 2282707 */   // Label 31094: @2282707
     /* 2282707 */   GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2282755), // Rule ID 52649 //
     /* 2282712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282715 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2282732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282754 */     // GIR_Coverage, 52649,
     /* 2282754 */     GIR_EraseRootFromParent_Done,
     /* 2282755 */   // Label 31095: @2282755
     /* 2282755 */   GIM_Reject,
     /* 2282756 */ // Label 31093: @2282756
     /* 2282756 */ GIM_Reject,
     /* 2282757 */ // Label 31064: @2282757
     /* 2282757 */ GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2282877),
     /* 2282762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2282765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2282768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282780 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2282828), // Rule ID 52664 //
     /* 2282785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2282788 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2282805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282827 */     // GIR_Coverage, 52664,
     /* 2282827 */     GIR_EraseRootFromParent_Done,
     /* 2282828 */   // Label 31097: @2282828
     /* 2282828 */   GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2282876), // Rule ID 52665 //
     /* 2282833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2282836 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2282853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282875 */     // GIR_Coverage, 52665,
     /* 2282875 */     GIR_EraseRootFromParent_Done,
     /* 2282876 */   // Label 31098: @2282876
     /* 2282876 */   GIM_Reject,
     /* 2282877 */ // Label 31096: @2282877
     /* 2282877 */ GIM_Reject,
     /* 2282878 */ // Label 31065: @2282878
     /* 2282878 */ GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2282998),
     /* 2282883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2282886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282901 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2282949), // Rule ID 52632 //
     /* 2282906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282909 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2282926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282948 */     // GIR_Coverage, 52632,
     /* 2282948 */     GIR_EraseRootFromParent_Done,
     /* 2282949 */   // Label 31100: @2282949
     /* 2282949 */   GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2282997), // Rule ID 52633 //
     /* 2282954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282957 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2282974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2282995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282996 */     // GIR_Coverage, 52633,
     /* 2282996 */     GIR_EraseRootFromParent_Done,
     /* 2282997 */   // Label 31101: @2282997
     /* 2282997 */   GIM_Reject,
     /* 2282998 */ // Label 31099: @2282998
     /* 2282998 */ GIM_Reject,
     /* 2282999 */ // Label 31066: @2282999
     /* 2282999 */ GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2283119),
     /* 2283004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2283007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2283010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283022 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2283070), // Rule ID 52644 //
     /* 2283027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283030 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2283033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2283047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283069 */     // GIR_Coverage, 52644,
     /* 2283069 */     GIR_EraseRootFromParent_Done,
     /* 2283070 */   // Label 31103: @2283070
     /* 2283070 */   GIM_Try, /*On fail goto*//*Label 31104*/ GIMT_Encode4(2283118), // Rule ID 52645 //
     /* 2283075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283078 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2283081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2283095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283117 */     // GIR_Coverage, 52645,
     /* 2283117 */     GIR_EraseRootFromParent_Done,
     /* 2283118 */   // Label 31104: @2283118
     /* 2283118 */   GIM_Reject,
     /* 2283119 */ // Label 31102: @2283119
     /* 2283119 */ GIM_Reject,
     /* 2283120 */ // Label 31067: @2283120
     /* 2283120 */ GIM_Try, /*On fail goto*//*Label 31105*/ GIMT_Encode4(2283240),
     /* 2283125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2283128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2283131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283143 */   GIM_Try, /*On fail goto*//*Label 31106*/ GIMT_Encode4(2283191), // Rule ID 52660 //
     /* 2283148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283151 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2283154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283190 */     // GIR_Coverage, 52660,
     /* 2283190 */     GIR_EraseRootFromParent_Done,
     /* 2283191 */   // Label 31106: @2283191
     /* 2283191 */   GIM_Try, /*On fail goto*//*Label 31107*/ GIMT_Encode4(2283239), // Rule ID 52661 //
     /* 2283196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283199 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2283202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283238 */     // GIR_Coverage, 52661,
     /* 2283238 */     GIR_EraseRootFromParent_Done,
     /* 2283239 */   // Label 31107: @2283239
     /* 2283239 */   GIM_Reject,
     /* 2283240 */ // Label 31105: @2283240
     /* 2283240 */ GIM_Reject,
     /* 2283241 */ // Label 31068: @2283241
     /* 2283241 */ GIM_Try, /*On fail goto*//*Label 31108*/ GIMT_Encode4(2283361),
     /* 2283246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2283249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2283252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283264 */   GIM_Try, /*On fail goto*//*Label 31109*/ GIMT_Encode4(2283312), // Rule ID 52704 //
     /* 2283269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283272 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2283275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2283289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283311 */     // GIR_Coverage, 52704,
     /* 2283311 */     GIR_EraseRootFromParent_Done,
     /* 2283312 */   // Label 31109: @2283312
     /* 2283312 */   GIM_Try, /*On fail goto*//*Label 31110*/ GIMT_Encode4(2283360), // Rule ID 52705 //
     /* 2283317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283320 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2283323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2283337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283359 */     // GIR_Coverage, 52705,
     /* 2283359 */     GIR_EraseRootFromParent_Done,
     /* 2283360 */   // Label 31110: @2283360
     /* 2283360 */   GIM_Reject,
     /* 2283361 */ // Label 31108: @2283361
     /* 2283361 */ GIM_Reject,
     /* 2283362 */ // Label 31069: @2283362
     /* 2283362 */ GIM_Try, /*On fail goto*//*Label 31111*/ GIMT_Encode4(2283482),
     /* 2283367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2283370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2283373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283385 */   GIM_Try, /*On fail goto*//*Label 31112*/ GIMT_Encode4(2283433), // Rule ID 52636 //
     /* 2283390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283393 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2283410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283432 */     // GIR_Coverage, 52636,
     /* 2283432 */     GIR_EraseRootFromParent_Done,
     /* 2283433 */   // Label 31112: @2283433
     /* 2283433 */   GIM_Try, /*On fail goto*//*Label 31113*/ GIMT_Encode4(2283481), // Rule ID 52637 //
     /* 2283438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283441 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2283458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283480 */     // GIR_Coverage, 52637,
     /* 2283480 */     GIR_EraseRootFromParent_Done,
     /* 2283481 */   // Label 31113: @2283481
     /* 2283481 */   GIM_Reject,
     /* 2283482 */ // Label 31111: @2283482
     /* 2283482 */ GIM_Reject,
     /* 2283483 */ // Label 31070: @2283483
     /* 2283483 */ GIM_Try, /*On fail goto*//*Label 31114*/ GIMT_Encode4(2283603),
     /* 2283488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2283491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2283494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283506 */   GIM_Try, /*On fail goto*//*Label 31115*/ GIMT_Encode4(2283554), // Rule ID 52656 //
     /* 2283511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283514 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283553 */     // GIR_Coverage, 52656,
     /* 2283553 */     GIR_EraseRootFromParent_Done,
     /* 2283554 */   // Label 31115: @2283554
     /* 2283554 */   GIM_Try, /*On fail goto*//*Label 31116*/ GIMT_Encode4(2283602), // Rule ID 52657 //
     /* 2283559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283562 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283601 */     // GIR_Coverage, 52657,
     /* 2283601 */     GIR_EraseRootFromParent_Done,
     /* 2283602 */   // Label 31116: @2283602
     /* 2283602 */   GIM_Reject,
     /* 2283603 */ // Label 31114: @2283603
     /* 2283603 */ GIM_Reject,
     /* 2283604 */ // Label 31071: @2283604
     /* 2283604 */ GIM_Try, /*On fail goto*//*Label 31117*/ GIMT_Encode4(2283724),
     /* 2283609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2283612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283627 */   GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2283675), // Rule ID 52692 //
     /* 2283632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283635 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2283652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283674 */     // GIR_Coverage, 52692,
     /* 2283674 */     GIR_EraseRootFromParent_Done,
     /* 2283675 */   // Label 31118: @2283675
     /* 2283675 */   GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2283723), // Rule ID 52693 //
     /* 2283680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283683 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2283700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283722 */     // GIR_Coverage, 52693,
     /* 2283722 */     GIR_EraseRootFromParent_Done,
     /* 2283723 */   // Label 31119: @2283723
     /* 2283723 */   GIM_Reject,
     /* 2283724 */ // Label 31117: @2283724
     /* 2283724 */ GIM_Reject,
     /* 2283725 */ // Label 31072: @2283725
     /* 2283725 */ GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2283845),
     /* 2283730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2283733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283748 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2283796), // Rule ID 52708 //
     /* 2283753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2283756 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2283773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283795 */     // GIR_Coverage, 52708,
     /* 2283795 */     GIR_EraseRootFromParent_Done,
     /* 2283796 */   // Label 31121: @2283796
     /* 2283796 */   GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2283844), // Rule ID 52709 //
     /* 2283801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2283804 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2283821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283843 */     // GIR_Coverage, 52709,
     /* 2283843 */     GIR_EraseRootFromParent_Done,
     /* 2283844 */   // Label 31122: @2283844
     /* 2283844 */   GIM_Reject,
     /* 2283845 */ // Label 31120: @2283845
     /* 2283845 */ GIM_Reject,
     /* 2283846 */ // Label 31073: @2283846
     /* 2283846 */ GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2283966),
     /* 2283851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2283854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283869 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2283917), // Rule ID 52652 //
     /* 2283874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283877 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283916 */     // GIR_Coverage, 52652,
     /* 2283916 */     GIR_EraseRootFromParent_Done,
     /* 2283917 */   // Label 31124: @2283917
     /* 2283917 */   GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2283965), // Rule ID 52653 //
     /* 2283922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283925 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2283942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2283963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283964 */     // GIR_Coverage, 52653,
     /* 2283964 */     GIR_EraseRootFromParent_Done,
     /* 2283965 */   // Label 31125: @2283965
     /* 2283965 */   GIM_Reject,
     /* 2283966 */ // Label 31123: @2283966
     /* 2283966 */ GIM_Reject,
     /* 2283967 */ // Label 31074: @2283967
     /* 2283967 */ GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2284087),
     /* 2283972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2283975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2283978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283990 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2284038), // Rule ID 52680 //
     /* 2283995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283998 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2284001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2284015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284037 */     // GIR_Coverage, 52680,
     /* 2284037 */     GIR_EraseRootFromParent_Done,
     /* 2284038 */   // Label 31127: @2284038
     /* 2284038 */   GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2284086), // Rule ID 52681 //
     /* 2284043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284046 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2284049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2284063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284085 */     // GIR_Coverage, 52681,
     /* 2284085 */     GIR_EraseRootFromParent_Done,
     /* 2284086 */   // Label 31128: @2284086
     /* 2284086 */   GIM_Reject,
     /* 2284087 */ // Label 31126: @2284087
     /* 2284087 */ GIM_Reject,
     /* 2284088 */ // Label 31075: @2284088
     /* 2284088 */ GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2284208),
     /* 2284093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2284096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2284099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284111 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2284159), // Rule ID 52696 //
     /* 2284116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284119 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284158 */     // GIR_Coverage, 52696,
     /* 2284158 */     GIR_EraseRootFromParent_Done,
     /* 2284159 */   // Label 31130: @2284159
     /* 2284159 */   GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2284207), // Rule ID 52697 //
     /* 2284164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284167 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2284170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284206 */     // GIR_Coverage, 52697,
     /* 2284206 */     GIR_EraseRootFromParent_Done,
     /* 2284207 */   // Label 31131: @2284207
     /* 2284207 */   GIM_Reject,
     /* 2284208 */ // Label 31129: @2284208
     /* 2284208 */ GIM_Reject,
     /* 2284209 */ // Label 31076: @2284209
     /* 2284209 */ GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2284329),
     /* 2284214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2284217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2284220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284232 */   GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2284280), // Rule ID 52712 //
     /* 2284237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2284240 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284279 */     // GIR_Coverage, 52712,
     /* 2284279 */     GIR_EraseRootFromParent_Done,
     /* 2284280 */   // Label 31133: @2284280
     /* 2284280 */   GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2284328), // Rule ID 52713 //
     /* 2284285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2284288 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2284291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284327 */     // GIR_Coverage, 52713,
     /* 2284327 */     GIR_EraseRootFromParent_Done,
     /* 2284328 */   // Label 31134: @2284328
     /* 2284328 */   GIM_Reject,
     /* 2284329 */ // Label 31132: @2284329
     /* 2284329 */ GIM_Reject,
     /* 2284330 */ // Label 31077: @2284330
     /* 2284330 */ GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2284450),
     /* 2284335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2284338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2284341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284353 */   GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2284401), // Rule ID 52668 //
     /* 2284358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284361 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2284378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284400 */     // GIR_Coverage, 52668,
     /* 2284400 */     GIR_EraseRootFromParent_Done,
     /* 2284401 */   // Label 31136: @2284401
     /* 2284401 */   GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2284449), // Rule ID 52669 //
     /* 2284406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284409 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2284426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284448 */     // GIR_Coverage, 52669,
     /* 2284448 */     GIR_EraseRootFromParent_Done,
     /* 2284449 */   // Label 31137: @2284449
     /* 2284449 */   GIM_Reject,
     /* 2284450 */ // Label 31135: @2284450
     /* 2284450 */ GIM_Reject,
     /* 2284451 */ // Label 31078: @2284451
     /* 2284451 */ GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2284571),
     /* 2284456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2284459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2284462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284474 */   GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2284522), // Rule ID 52684 //
     /* 2284479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284482 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284521 */     // GIR_Coverage, 52684,
     /* 2284521 */     GIR_EraseRootFromParent_Done,
     /* 2284522 */   // Label 31139: @2284522
     /* 2284522 */   GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2284570), // Rule ID 52685 //
     /* 2284527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284530 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284569 */     // GIR_Coverage, 52685,
     /* 2284569 */     GIR_EraseRootFromParent_Done,
     /* 2284570 */   // Label 31140: @2284570
     /* 2284570 */   GIM_Reject,
     /* 2284571 */ // Label 31138: @2284571
     /* 2284571 */ GIM_Reject,
     /* 2284572 */ // Label 31079: @2284572
     /* 2284572 */ GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2284692),
     /* 2284577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2284580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2284583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284595 */   GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2284643), // Rule ID 52700 //
     /* 2284600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284603 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284642 */     // GIR_Coverage, 52700,
     /* 2284642 */     GIR_EraseRootFromParent_Done,
     /* 2284643 */   // Label 31142: @2284643
     /* 2284643 */   GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2284691), // Rule ID 52701 //
     /* 2284648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284651 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284690 */     // GIR_Coverage, 52701,
     /* 2284690 */     GIR_EraseRootFromParent_Done,
     /* 2284691 */   // Label 31143: @2284691
     /* 2284691 */   GIM_Reject,
     /* 2284692 */ // Label 31141: @2284692
     /* 2284692 */ GIM_Reject,
     /* 2284693 */ // Label 31080: @2284693
     /* 2284693 */ GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2284813),
     /* 2284698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2284701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284716 */   GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2284764), // Rule ID 52672 //
     /* 2284721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284724 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284763 */     // GIR_Coverage, 52672,
     /* 2284763 */     GIR_EraseRootFromParent_Done,
     /* 2284764 */   // Label 31145: @2284764
     /* 2284764 */   GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2284812), // Rule ID 52673 //
     /* 2284769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284772 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2284789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284811 */     // GIR_Coverage, 52673,
     /* 2284811 */     GIR_EraseRootFromParent_Done,
     /* 2284812 */   // Label 31146: @2284812
     /* 2284812 */   GIM_Reject,
     /* 2284813 */ // Label 31144: @2284813
     /* 2284813 */ GIM_Reject,
     /* 2284814 */ // Label 31081: @2284814
     /* 2284814 */ GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2284934),
     /* 2284819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2284822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284837 */   GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2284885), // Rule ID 52688 //
     /* 2284842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284845 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284884 */     // GIR_Coverage, 52688,
     /* 2284884 */     GIR_EraseRootFromParent_Done,
     /* 2284885 */   // Label 31148: @2284885
     /* 2284885 */   GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2284933), // Rule ID 52689 //
     /* 2284890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284893 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284932 */     // GIR_Coverage, 52689,
     /* 2284932 */     GIR_EraseRootFromParent_Done,
     /* 2284933 */   // Label 31149: @2284933
     /* 2284933 */   GIM_Reject,
     /* 2284934 */ // Label 31147: @2284934
     /* 2284934 */ GIM_Reject,
     /* 2284935 */ // Label 31082: @2284935
     /* 2284935 */ GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2285055),
     /* 2284940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2284943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2284946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284958 */   GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2285006), // Rule ID 52676 //
     /* 2284963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284966 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2284983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285005 */     // GIR_Coverage, 52676,
     /* 2285005 */     GIR_EraseRootFromParent_Done,
     /* 2285006 */   // Label 31151: @2285006
     /* 2285006 */   GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2285054), // Rule ID 52677 //
     /* 2285011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285014 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2285017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2285031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285053 */     // GIR_Coverage, 52677,
     /* 2285053 */     GIR_EraseRootFromParent_Done,
     /* 2285054 */   // Label 31152: @2285054
     /* 2285054 */   GIM_Reject,
     /* 2285055 */ // Label 31150: @2285055
     /* 2285055 */ GIM_Reject,
     /* 2285056 */ // Label 31083: @2285056
     /* 2285056 */ GIM_Reject,
     /* 2285057 */ // Label 57: @2285057
     /* 2285057 */ GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2285114),
     /* 2285062 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2285065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285083 */   GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2285098), // Rule ID 64574 //
     /* 2285088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2285091 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2285096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285097 */     // GIR_Coverage, 64574,
     /* 2285097 */     GIR_Done,
     /* 2285098 */   // Label 31154: @2285098
     /* 2285098 */   GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2285113), // Rule ID 64575 //
     /* 2285103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2285106 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2285111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285112 */     // GIR_Coverage, 64575,
     /* 2285112 */     GIR_Done,
     /* 2285113 */   // Label 31155: @2285113
     /* 2285113 */   GIM_Reject,
     /* 2285114 */ // Label 31153: @2285114
     /* 2285114 */ GIM_Reject,
     /* 2285115 */ // Label 58: @2285115
     /* 2285115 */ GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2285172),
     /* 2285120 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2285123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2285141 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2285156), // Rule ID 64576 //
     /* 2285146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2285149 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2285154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285155 */     // GIR_Coverage, 64576,
     /* 2285155 */     GIR_Done,
     /* 2285156 */   // Label 31157: @2285156
     /* 2285156 */   GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2285171), // Rule ID 64577 //
     /* 2285161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2285164 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2285164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2285169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285170 */     // GIR_Coverage, 64577,
     /* 2285170 */     GIR_Done,
     /* 2285171 */   // Label 31158: @2285171
     /* 2285171 */   GIM_Reject,
     /* 2285172 */ // Label 31156: @2285172
     /* 2285172 */ GIM_Reject,
     /* 2285173 */ // Label 59: @2285173
     /* 2285173 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31177*/ GIMT_Encode4(2287600),
     /* 2285184 */ /*GILLT_s16*//*Label 31159*/ GIMT_Encode4(2285304),
     /* 2285188 */ /*GILLT_s32*//*Label 31160*/ GIMT_Encode4(2285453),
     /* 2285192 */ /*GILLT_s64*//*Label 31161*/ GIMT_Encode4(2285602), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285204 */ /*GILLT_nxv1s16*//*Label 31162*/ GIMT_Encode4(2285785),
     /* 2285208 */ /*GILLT_nxv1s32*//*Label 31163*/ GIMT_Encode4(2285906),
     /* 2285212 */ /*GILLT_nxv1s64*//*Label 31164*/ GIMT_Encode4(2286027), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285224 */ /*GILLT_nxv2s16*//*Label 31165*/ GIMT_Encode4(2286148),
     /* 2285228 */ /*GILLT_nxv2s32*//*Label 31166*/ GIMT_Encode4(2286269),
     /* 2285232 */ /*GILLT_nxv2s64*//*Label 31167*/ GIMT_Encode4(2286390), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285244 */ /*GILLT_nxv4s16*//*Label 31168*/ GIMT_Encode4(2286511),
     /* 2285248 */ /*GILLT_nxv4s32*//*Label 31169*/ GIMT_Encode4(2286632),
     /* 2285252 */ /*GILLT_nxv4s64*//*Label 31170*/ GIMT_Encode4(2286753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285264 */ /*GILLT_nxv8s16*//*Label 31171*/ GIMT_Encode4(2286874),
     /* 2285268 */ /*GILLT_nxv8s32*//*Label 31172*/ GIMT_Encode4(2286995),
     /* 2285272 */ /*GILLT_nxv8s64*//*Label 31173*/ GIMT_Encode4(2287116), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285284 */ /*GILLT_nxv16s16*//*Label 31174*/ GIMT_Encode4(2287237),
     /* 2285288 */ /*GILLT_nxv16s32*//*Label 31175*/ GIMT_Encode4(2287358), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285300 */ /*GILLT_nxv32s16*//*Label 31176*/ GIMT_Encode4(2287479),
     /* 2285304 */ // Label 31159: @2285304
     /* 2285304 */ GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2285452),
     /* 2285309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2285312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2285315 */   GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2285349), // Rule ID 1950 //
     /* 2285320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2285323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285335 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2285335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2285338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285348 */     // GIR_Coverage, 1950,
     /* 2285348 */     GIR_EraseRootFromParent_Done,
     /* 2285349 */   // Label 31179: @2285349
     /* 2285349 */   GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2285383), // Rule ID 1951 //
     /* 2285354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2285357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285369 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2285369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2285372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285382 */     // GIR_Coverage, 1951,
     /* 2285382 */     GIR_EraseRootFromParent_Done,
     /* 2285383 */   // Label 31180: @2285383
     /* 2285383 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2285417), // Rule ID 1954 //
     /* 2285388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2285391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285403 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2285403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2285406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285416 */     // GIR_Coverage, 1954,
     /* 2285416 */     GIR_EraseRootFromParent_Done,
     /* 2285417 */   // Label 31181: @2285417
     /* 2285417 */   GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2285451), // Rule ID 1955 //
     /* 2285422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2285425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285437 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2285437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2285440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285450 */     // GIR_Coverage, 1955,
     /* 2285450 */     GIR_EraseRootFromParent_Done,
     /* 2285451 */   // Label 31182: @2285451
     /* 2285451 */   GIM_Reject,
     /* 2285452 */ // Label 31178: @2285452
     /* 2285452 */ GIM_Reject,
     /* 2285453 */ // Label 31160: @2285453
     /* 2285453 */ GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2285601),
     /* 2285458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2285464 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2285498), // Rule ID 1237 //
     /* 2285469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2285472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285484 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2285484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2285487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285497 */     // GIR_Coverage, 1237,
     /* 2285497 */     GIR_EraseRootFromParent_Done,
     /* 2285498 */   // Label 31184: @2285498
     /* 2285498 */   GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2285532), // Rule ID 1238 //
     /* 2285503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2285506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2285518 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2285518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2285521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285531 */     // GIR_Coverage, 1238,
     /* 2285531 */     GIR_EraseRootFromParent_Done,
     /* 2285532 */   // Label 31185: @2285532
     /* 2285532 */   GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2285566), // Rule ID 1241 //
     /* 2285537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2285540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285552 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2285552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2285555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285565 */     // GIR_Coverage, 1241,
     /* 2285565 */     GIR_EraseRootFromParent_Done,
     /* 2285566 */   // Label 31186: @2285566
     /* 2285566 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2285600), // Rule ID 1242 //
     /* 2285571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2285574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2285586 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2285586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2285589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285599 */     // GIR_Coverage, 1242,
     /* 2285599 */     GIR_EraseRootFromParent_Done,
     /* 2285600 */   // Label 31187: @2285600
     /* 2285600 */   GIM_Reject,
     /* 2285601 */ // Label 31183: @2285601
     /* 2285601 */ GIM_Reject,
     /* 2285602 */ // Label 31161: @2285602
     /* 2285602 */ GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2285784),
     /* 2285607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2285610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2285613 */   GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2285647), // Rule ID 1572 //
     /* 2285618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2285621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285633 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2285633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2285636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285646 */     // GIR_Coverage, 1572,
     /* 2285646 */     GIR_EraseRootFromParent_Done,
     /* 2285647 */   // Label 31189: @2285647
     /* 2285647 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2285681), // Rule ID 1573 //
     /* 2285652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2285655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2285667 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2285667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2285670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285680 */     // GIR_Coverage, 1573,
     /* 2285680 */     GIR_EraseRootFromParent_Done,
     /* 2285681 */   // Label 31190: @2285681
     /* 2285681 */   GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2285715), // Rule ID 1576 //
     /* 2285686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2285689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285701 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2285701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2285704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285714 */     // GIR_Coverage, 1576,
     /* 2285714 */     GIR_EraseRootFromParent_Done,
     /* 2285715 */   // Label 31191: @2285715
     /* 2285715 */   GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2285749), // Rule ID 1577 //
     /* 2285720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2285723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2285735 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2285735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2285738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285748 */     // GIR_Coverage, 1577,
     /* 2285748 */     GIR_EraseRootFromParent_Done,
     /* 2285749 */   // Label 31192: @2285749
     /* 2285749 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2285783), // Rule ID 1579 //
     /* 2285754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2285757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2285769 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2285769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2285772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285782 */     // GIR_Coverage, 1579,
     /* 2285782 */     GIR_EraseRootFromParent_Done,
     /* 2285783 */   // Label 31193: @2285783
     /* 2285783 */   GIM_Reject,
     /* 2285784 */ // Label 31188: @2285784
     /* 2285784 */ GIM_Reject,
     /* 2285785 */ // Label 31162: @2285785
     /* 2285785 */ GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2285905),
     /* 2285790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2285793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2285796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285808 */   GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2285856), // Rule ID 45752 //
     /* 2285813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2285816 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2285833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285855 */     // GIR_Coverage, 45752,
     /* 2285855 */     GIR_EraseRootFromParent_Done,
     /* 2285856 */   // Label 31195: @2285856
     /* 2285856 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2285904), // Rule ID 45753 //
     /* 2285861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2285864 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2285881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285903 */     // GIR_Coverage, 45753,
     /* 2285903 */     GIR_EraseRootFromParent_Done,
     /* 2285904 */   // Label 31196: @2285904
     /* 2285904 */   GIM_Reject,
     /* 2285905 */ // Label 31194: @2285905
     /* 2285905 */ GIM_Reject,
     /* 2285906 */ // Label 31163: @2285906
     /* 2285906 */ GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2286026),
     /* 2285911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2285914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2285917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285929 */   GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2285977), // Rule ID 53292 //
     /* 2285934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2285937 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2285954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285976 */     // GIR_Coverage, 53292,
     /* 2285976 */     GIR_EraseRootFromParent_Done,
     /* 2285977 */   // Label 31198: @2285977
     /* 2285977 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2286025), // Rule ID 53293 //
     /* 2285982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2285985 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2286002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286024 */     // GIR_Coverage, 53293,
     /* 2286024 */     GIR_EraseRootFromParent_Done,
     /* 2286025 */   // Label 31199: @2286025
     /* 2286025 */   GIM_Reject,
     /* 2286026 */ // Label 31197: @2286026
     /* 2286026 */ GIM_Reject,
     /* 2286027 */ // Label 31164: @2286027
     /* 2286027 */ GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2286147),
     /* 2286032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2286035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2286038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286050 */   GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2286098), // Rule ID 53328 //
     /* 2286055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2286058 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2286061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2286075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286097 */     // GIR_Coverage, 53328,
     /* 2286097 */     GIR_EraseRootFromParent_Done,
     /* 2286098 */   // Label 31201: @2286098
     /* 2286098 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2286146), // Rule ID 53329 //
     /* 2286103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2286106 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2286109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2286123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286145 */     // GIR_Coverage, 53329,
     /* 2286145 */     GIR_EraseRootFromParent_Done,
     /* 2286146 */   // Label 31202: @2286146
     /* 2286146 */   GIM_Reject,
     /* 2286147 */ // Label 31200: @2286147
     /* 2286147 */ GIM_Reject,
     /* 2286148 */ // Label 31165: @2286148
     /* 2286148 */ GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2286268),
     /* 2286153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2286156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2286159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286171 */   GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2286219), // Rule ID 53280 //
     /* 2286176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286179 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2286196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286218 */     // GIR_Coverage, 53280,
     /* 2286218 */     GIR_EraseRootFromParent_Done,
     /* 2286219 */   // Label 31204: @2286219
     /* 2286219 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2286267), // Rule ID 53281 //
     /* 2286224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286227 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2286244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286266 */     // GIR_Coverage, 53281,
     /* 2286266 */     GIR_EraseRootFromParent_Done,
     /* 2286267 */   // Label 31205: @2286267
     /* 2286267 */   GIM_Reject,
     /* 2286268 */ // Label 31203: @2286268
     /* 2286268 */ GIM_Reject,
     /* 2286269 */ // Label 31166: @2286269
     /* 2286269 */ GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2286389),
     /* 2286274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2286277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2286280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286292 */   GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2286340), // Rule ID 53316 //
     /* 2286297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2286300 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2286317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286339 */     // GIR_Coverage, 53316,
     /* 2286339 */     GIR_EraseRootFromParent_Done,
     /* 2286340 */   // Label 31207: @2286340
     /* 2286340 */   GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2286388), // Rule ID 53317 //
     /* 2286345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2286348 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2286365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286387 */     // GIR_Coverage, 53317,
     /* 2286387 */     GIR_EraseRootFromParent_Done,
     /* 2286388 */   // Label 31208: @2286388
     /* 2286388 */   GIM_Reject,
     /* 2286389 */ // Label 31206: @2286389
     /* 2286389 */ GIM_Reject,
     /* 2286390 */ // Label 31167: @2286390
     /* 2286390 */ GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2286510),
     /* 2286395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2286398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2286401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286413 */   GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2286461), // Rule ID 53412 //
     /* 2286418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2286421 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2286438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286460 */     // GIR_Coverage, 53412,
     /* 2286460 */     GIR_EraseRootFromParent_Done,
     /* 2286461 */   // Label 31210: @2286461
     /* 2286461 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2286509), // Rule ID 53413 //
     /* 2286466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2286469 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2286486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286508 */     // GIR_Coverage, 53413,
     /* 2286508 */     GIR_EraseRootFromParent_Done,
     /* 2286509 */   // Label 31211: @2286509
     /* 2286509 */   GIM_Reject,
     /* 2286510 */ // Label 31209: @2286510
     /* 2286510 */ GIM_Reject,
     /* 2286511 */ // Label 31168: @2286511
     /* 2286511 */ GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2286631),
     /* 2286516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2286519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2286522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286534 */   GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2286582), // Rule ID 53304 //
     /* 2286539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286542 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2286559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286581 */     // GIR_Coverage, 53304,
     /* 2286581 */     GIR_EraseRootFromParent_Done,
     /* 2286582 */   // Label 31213: @2286582
     /* 2286582 */   GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2286630), // Rule ID 53305 //
     /* 2286587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286590 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2286593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2286607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286629 */     // GIR_Coverage, 53305,
     /* 2286629 */     GIR_EraseRootFromParent_Done,
     /* 2286630 */   // Label 31214: @2286630
     /* 2286630 */   GIM_Reject,
     /* 2286631 */ // Label 31212: @2286631
     /* 2286631 */ GIM_Reject,
     /* 2286632 */ // Label 31169: @2286632
     /* 2286632 */ GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2286752),
     /* 2286637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2286640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2286643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286655 */   GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2286703), // Rule ID 53376 //
     /* 2286660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2286663 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2286680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286702 */     // GIR_Coverage, 53376,
     /* 2286702 */     GIR_EraseRootFromParent_Done,
     /* 2286703 */   // Label 31216: @2286703
     /* 2286703 */   GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2286751), // Rule ID 53377 //
     /* 2286708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2286711 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2286728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286750 */     // GIR_Coverage, 53377,
     /* 2286750 */     GIR_EraseRootFromParent_Done,
     /* 2286751 */   // Label 31217: @2286751
     /* 2286751 */   GIM_Reject,
     /* 2286752 */ // Label 31215: @2286752
     /* 2286752 */ GIM_Reject,
     /* 2286753 */ // Label 31170: @2286753
     /* 2286753 */ GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2286873),
     /* 2286758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2286761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2286764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286776 */   GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2286824), // Rule ID 53424 //
     /* 2286781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2286784 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2286801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286823 */     // GIR_Coverage, 53424,
     /* 2286823 */     GIR_EraseRootFromParent_Done,
     /* 2286824 */   // Label 31219: @2286824
     /* 2286824 */   GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2286872), // Rule ID 53425 //
     /* 2286829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2286832 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2286849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286871 */     // GIR_Coverage, 53425,
     /* 2286871 */     GIR_EraseRootFromParent_Done,
     /* 2286872 */   // Label 31220: @2286872
     /* 2286872 */   GIM_Reject,
     /* 2286873 */ // Label 31218: @2286873
     /* 2286873 */ GIM_Reject,
     /* 2286874 */ // Label 31171: @2286874
     /* 2286874 */ GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2286994),
     /* 2286879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2286882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2286885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286897 */   GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2286945), // Rule ID 53340 //
     /* 2286902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286905 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2286922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286944 */     // GIR_Coverage, 53340,
     /* 2286944 */     GIR_EraseRootFromParent_Done,
     /* 2286945 */   // Label 31222: @2286945
     /* 2286945 */   GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2286993), // Rule ID 53341 //
     /* 2286950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286953 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2286970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286992 */     // GIR_Coverage, 53341,
     /* 2286992 */     GIR_EraseRootFromParent_Done,
     /* 2286993 */   // Label 31223: @2286993
     /* 2286993 */   GIM_Reject,
     /* 2286994 */ // Label 31221: @2286994
     /* 2286994 */ GIM_Reject,
     /* 2286995 */ // Label 31172: @2286995
     /* 2286995 */ GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2287115),
     /* 2287000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2287003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2287006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287018 */   GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2287066), // Rule ID 53388 //
     /* 2287023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287026 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2287043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287065 */     // GIR_Coverage, 53388,
     /* 2287065 */     GIR_EraseRootFromParent_Done,
     /* 2287066 */   // Label 31225: @2287066
     /* 2287066 */   GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2287114), // Rule ID 53389 //
     /* 2287071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287074 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2287091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287113 */     // GIR_Coverage, 53389,
     /* 2287113 */     GIR_EraseRootFromParent_Done,
     /* 2287114 */   // Label 31226: @2287114
     /* 2287114 */   GIM_Reject,
     /* 2287115 */ // Label 31224: @2287115
     /* 2287115 */ GIM_Reject,
     /* 2287116 */ // Label 31173: @2287116
     /* 2287116 */ GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2287236),
     /* 2287121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2287124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2287127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287139 */   GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2287187), // Rule ID 53436 //
     /* 2287144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2287147 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2287164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287186 */     // GIR_Coverage, 53436,
     /* 2287186 */     GIR_EraseRootFromParent_Done,
     /* 2287187 */   // Label 31228: @2287187
     /* 2287187 */   GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2287235), // Rule ID 53437 //
     /* 2287192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2287195 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2287212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287234 */     // GIR_Coverage, 53437,
     /* 2287234 */     GIR_EraseRootFromParent_Done,
     /* 2287235 */   // Label 31229: @2287235
     /* 2287235 */   GIM_Reject,
     /* 2287236 */ // Label 31227: @2287236
     /* 2287236 */ GIM_Reject,
     /* 2287237 */ // Label 31174: @2287237
     /* 2287237 */ GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2287357),
     /* 2287242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2287245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2287248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287260 */   GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2287308), // Rule ID 53352 //
     /* 2287265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287268 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2287285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287307 */     // GIR_Coverage, 53352,
     /* 2287307 */     GIR_EraseRootFromParent_Done,
     /* 2287308 */   // Label 31231: @2287308
     /* 2287308 */   GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2287356), // Rule ID 53353 //
     /* 2287313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287316 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2287333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287355 */     // GIR_Coverage, 53353,
     /* 2287355 */     GIR_EraseRootFromParent_Done,
     /* 2287356 */   // Label 31232: @2287356
     /* 2287356 */   GIM_Reject,
     /* 2287357 */ // Label 31230: @2287357
     /* 2287357 */ GIM_Reject,
     /* 2287358 */ // Label 31175: @2287358
     /* 2287358 */ GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2287478),
     /* 2287363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2287366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2287369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287381 */   GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2287429), // Rule ID 53400 //
     /* 2287386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287389 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2287406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287428 */     // GIR_Coverage, 53400,
     /* 2287428 */     GIR_EraseRootFromParent_Done,
     /* 2287429 */   // Label 31234: @2287429
     /* 2287429 */   GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2287477), // Rule ID 53401 //
     /* 2287434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287437 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2287454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287476 */     // GIR_Coverage, 53401,
     /* 2287476 */     GIR_EraseRootFromParent_Done,
     /* 2287477 */   // Label 31235: @2287477
     /* 2287477 */   GIM_Reject,
     /* 2287478 */ // Label 31233: @2287478
     /* 2287478 */ GIM_Reject,
     /* 2287479 */ // Label 31176: @2287479
     /* 2287479 */ GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2287599),
     /* 2287484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2287487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2287490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287502 */   GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2287550), // Rule ID 53364 //
     /* 2287507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287510 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2287527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287549 */     // GIR_Coverage, 53364,
     /* 2287549 */     GIR_EraseRootFromParent_Done,
     /* 2287550 */   // Label 31237: @2287550
     /* 2287550 */   GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2287598), // Rule ID 53365 //
     /* 2287555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287558 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2287575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287597 */     // GIR_Coverage, 53365,
     /* 2287597 */     GIR_EraseRootFromParent_Done,
     /* 2287598 */   // Label 31238: @2287598
     /* 2287598 */   GIM_Reject,
     /* 2287599 */ // Label 31236: @2287599
     /* 2287599 */ GIM_Reject,
     /* 2287600 */ // Label 31177: @2287600
     /* 2287600 */ GIM_Reject,
     /* 2287601 */ // Label 60: @2287601
     /* 2287601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31257*/ GIMT_Encode4(2290028),
     /* 2287612 */ /*GILLT_s16*//*Label 31239*/ GIMT_Encode4(2287732),
     /* 2287616 */ /*GILLT_s32*//*Label 31240*/ GIMT_Encode4(2287881),
     /* 2287620 */ /*GILLT_s64*//*Label 31241*/ GIMT_Encode4(2288030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287632 */ /*GILLT_nxv1s16*//*Label 31242*/ GIMT_Encode4(2288213),
     /* 2287636 */ /*GILLT_nxv1s32*//*Label 31243*/ GIMT_Encode4(2288334),
     /* 2287640 */ /*GILLT_nxv1s64*//*Label 31244*/ GIMT_Encode4(2288455), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287652 */ /*GILLT_nxv2s16*//*Label 31245*/ GIMT_Encode4(2288576),
     /* 2287656 */ /*GILLT_nxv2s32*//*Label 31246*/ GIMT_Encode4(2288697),
     /* 2287660 */ /*GILLT_nxv2s64*//*Label 31247*/ GIMT_Encode4(2288818), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287672 */ /*GILLT_nxv4s16*//*Label 31248*/ GIMT_Encode4(2288939),
     /* 2287676 */ /*GILLT_nxv4s32*//*Label 31249*/ GIMT_Encode4(2289060),
     /* 2287680 */ /*GILLT_nxv4s64*//*Label 31250*/ GIMT_Encode4(2289181), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287692 */ /*GILLT_nxv8s16*//*Label 31251*/ GIMT_Encode4(2289302),
     /* 2287696 */ /*GILLT_nxv8s32*//*Label 31252*/ GIMT_Encode4(2289423),
     /* 2287700 */ /*GILLT_nxv8s64*//*Label 31253*/ GIMT_Encode4(2289544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287712 */ /*GILLT_nxv16s16*//*Label 31254*/ GIMT_Encode4(2289665),
     /* 2287716 */ /*GILLT_nxv16s32*//*Label 31255*/ GIMT_Encode4(2289786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287728 */ /*GILLT_nxv32s16*//*Label 31256*/ GIMT_Encode4(2289907),
     /* 2287732 */ // Label 31239: @2287732
     /* 2287732 */ GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2287880),
     /* 2287737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2287740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2287743 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2287777), // Rule ID 1958 //
     /* 2287748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2287751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287763 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2287763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2287766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287776 */     // GIR_Coverage, 1958,
     /* 2287776 */     GIR_EraseRootFromParent_Done,
     /* 2287777 */   // Label 31259: @2287777
     /* 2287777 */   GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2287811), // Rule ID 1959 //
     /* 2287782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2287785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2287797 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2287797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2287800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287810 */     // GIR_Coverage, 1959,
     /* 2287810 */     GIR_EraseRootFromParent_Done,
     /* 2287811 */   // Label 31260: @2287811
     /* 2287811 */   GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2287845), // Rule ID 1962 //
     /* 2287816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2287819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287831 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2287831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2287834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287844 */     // GIR_Coverage, 1962,
     /* 2287844 */     GIR_EraseRootFromParent_Done,
     /* 2287845 */   // Label 31261: @2287845
     /* 2287845 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2287879), // Rule ID 1963 //
     /* 2287850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2287853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2287865 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2287865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2287868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287878 */     // GIR_Coverage, 1963,
     /* 2287878 */     GIR_EraseRootFromParent_Done,
     /* 2287879 */   // Label 31262: @2287879
     /* 2287879 */   GIM_Reject,
     /* 2287880 */ // Label 31258: @2287880
     /* 2287880 */ GIM_Reject,
     /* 2287881 */ // Label 31240: @2287881
     /* 2287881 */ GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2288029),
     /* 2287886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2287889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2287892 */   GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2287926), // Rule ID 1245 //
     /* 2287897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2287900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287912 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2287912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2287915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287925 */     // GIR_Coverage, 1245,
     /* 2287925 */     GIR_EraseRootFromParent_Done,
     /* 2287926 */   // Label 31264: @2287926
     /* 2287926 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2287960), // Rule ID 1246 //
     /* 2287931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2287934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2287946 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2287946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2287949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287959 */     // GIR_Coverage, 1246,
     /* 2287959 */     GIR_EraseRootFromParent_Done,
     /* 2287960 */   // Label 31265: @2287960
     /* 2287960 */   GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2287994), // Rule ID 1249 //
     /* 2287965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2287968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2287972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2287976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2287980 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2287980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2287983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287993 */     // GIR_Coverage, 1249,
     /* 2287993 */     GIR_EraseRootFromParent_Done,
     /* 2287994 */   // Label 31266: @2287994
     /* 2287994 */   GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2288028), // Rule ID 1250 //
     /* 2287999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2288002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2288006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2288010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2288014 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2288014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2288017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288027 */     // GIR_Coverage, 1250,
     /* 2288027 */     GIR_EraseRootFromParent_Done,
     /* 2288028 */   // Label 31267: @2288028
     /* 2288028 */   GIM_Reject,
     /* 2288029 */ // Label 31263: @2288029
     /* 2288029 */ GIM_Reject,
     /* 2288030 */ // Label 31241: @2288030
     /* 2288030 */ GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2288212),
     /* 2288035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2288038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2288041 */   GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2288075), // Rule ID 1582 //
     /* 2288046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2288049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288061 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2288061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2288064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288074 */     // GIR_Coverage, 1582,
     /* 2288074 */     GIR_EraseRootFromParent_Done,
     /* 2288075 */   // Label 31269: @2288075
     /* 2288075 */   GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2288109), // Rule ID 1583 //
     /* 2288080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2288083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2288095 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2288095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2288098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288108 */     // GIR_Coverage, 1583,
     /* 2288108 */     GIR_EraseRootFromParent_Done,
     /* 2288109 */   // Label 31270: @2288109
     /* 2288109 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2288143), // Rule ID 1586 //
     /* 2288114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2288117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288129 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2288129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2288132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288142 */     // GIR_Coverage, 1586,
     /* 2288142 */     GIR_EraseRootFromParent_Done,
     /* 2288143 */   // Label 31271: @2288143
     /* 2288143 */   GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2288177), // Rule ID 1587 //
     /* 2288148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2288151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2288163 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2288163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2288166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288176 */     // GIR_Coverage, 1587,
     /* 2288176 */     GIR_EraseRootFromParent_Done,
     /* 2288177 */   // Label 31272: @2288177
     /* 2288177 */   GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2288211), // Rule ID 1589 //
     /* 2288182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2288185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2288197 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2288197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2288200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288210 */     // GIR_Coverage, 1589,
     /* 2288210 */     GIR_EraseRootFromParent_Done,
     /* 2288211 */   // Label 31273: @2288211
     /* 2288211 */   GIM_Reject,
     /* 2288212 */ // Label 31268: @2288212
     /* 2288212 */ GIM_Reject,
     /* 2288213 */ // Label 31242: @2288213
     /* 2288213 */ GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2288333),
     /* 2288218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2288221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2288224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288236 */   GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2288284), // Rule ID 53448 //
     /* 2288241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2288244 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2288261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288283 */     // GIR_Coverage, 53448,
     /* 2288283 */     GIR_EraseRootFromParent_Done,
     /* 2288284 */   // Label 31275: @2288284
     /* 2288284 */   GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2288332), // Rule ID 53449 //
     /* 2288289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2288292 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2288295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2288309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288331 */     // GIR_Coverage, 53449,
     /* 2288331 */     GIR_EraseRootFromParent_Done,
     /* 2288332 */   // Label 31276: @2288332
     /* 2288332 */   GIM_Reject,
     /* 2288333 */ // Label 31274: @2288333
     /* 2288333 */ GIM_Reject,
     /* 2288334 */ // Label 31243: @2288334
     /* 2288334 */ GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2288454),
     /* 2288339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2288342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2288345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288357 */   GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2288405), // Rule ID 53472 //
     /* 2288362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2288365 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2288382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288404 */     // GIR_Coverage, 53472,
     /* 2288404 */     GIR_EraseRootFromParent_Done,
     /* 2288405 */   // Label 31278: @2288405
     /* 2288405 */   GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2288453), // Rule ID 53473 //
     /* 2288410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2288413 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2288416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2288430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288452 */     // GIR_Coverage, 53473,
     /* 2288452 */     GIR_EraseRootFromParent_Done,
     /* 2288453 */   // Label 31279: @2288453
     /* 2288453 */   GIM_Reject,
     /* 2288454 */ // Label 31277: @2288454
     /* 2288454 */ GIM_Reject,
     /* 2288455 */ // Label 31244: @2288455
     /* 2288455 */ GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2288575),
     /* 2288460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288478 */   GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2288526), // Rule ID 53508 //
     /* 2288483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288486 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2288503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288525 */     // GIR_Coverage, 53508,
     /* 2288525 */     GIR_EraseRootFromParent_Done,
     /* 2288526 */   // Label 31281: @2288526
     /* 2288526 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2288574), // Rule ID 53509 //
     /* 2288531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288534 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2288551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288573 */     // GIR_Coverage, 53509,
     /* 2288573 */     GIR_EraseRootFromParent_Done,
     /* 2288574 */   // Label 31282: @2288574
     /* 2288574 */   GIM_Reject,
     /* 2288575 */ // Label 31280: @2288575
     /* 2288575 */ GIM_Reject,
     /* 2288576 */ // Label 31245: @2288576
     /* 2288576 */ GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2288696),
     /* 2288581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2288584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2288587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288599 */   GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2288647), // Rule ID 53460 //
     /* 2288604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2288607 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2288624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288646 */     // GIR_Coverage, 53460,
     /* 2288646 */     GIR_EraseRootFromParent_Done,
     /* 2288647 */   // Label 31284: @2288647
     /* 2288647 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2288695), // Rule ID 53461 //
     /* 2288652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2288655 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2288672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288694 */     // GIR_Coverage, 53461,
     /* 2288694 */     GIR_EraseRootFromParent_Done,
     /* 2288695 */   // Label 31285: @2288695
     /* 2288695 */   GIM_Reject,
     /* 2288696 */ // Label 31283: @2288696
     /* 2288696 */ GIM_Reject,
     /* 2288697 */ // Label 31246: @2288697
     /* 2288697 */ GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2288817),
     /* 2288702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288720 */   GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2288768), // Rule ID 53496 //
     /* 2288725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2288728 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2288745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288767 */     // GIR_Coverage, 53496,
     /* 2288767 */     GIR_EraseRootFromParent_Done,
     /* 2288768 */   // Label 31287: @2288768
     /* 2288768 */   GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2288816), // Rule ID 53497 //
     /* 2288773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2288776 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2288793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288815 */     // GIR_Coverage, 53497,
     /* 2288815 */     GIR_EraseRootFromParent_Done,
     /* 2288816 */   // Label 31288: @2288816
     /* 2288816 */   GIM_Reject,
     /* 2288817 */ // Label 31286: @2288817
     /* 2288817 */ GIM_Reject,
     /* 2288818 */ // Label 31247: @2288818
     /* 2288818 */ GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2288938),
     /* 2288823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2288826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2288829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288841 */   GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2288889), // Rule ID 53592 //
     /* 2288846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2288849 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2288866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288888 */     // GIR_Coverage, 53592,
     /* 2288888 */     GIR_EraseRootFromParent_Done,
     /* 2288889 */   // Label 31290: @2288889
     /* 2288889 */   GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2288937), // Rule ID 53593 //
     /* 2288894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2288897 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2288914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288936 */     // GIR_Coverage, 53593,
     /* 2288936 */     GIR_EraseRootFromParent_Done,
     /* 2288937 */   // Label 31291: @2288937
     /* 2288937 */   GIM_Reject,
     /* 2288938 */ // Label 31289: @2288938
     /* 2288938 */ GIM_Reject,
     /* 2288939 */ // Label 31248: @2288939
     /* 2288939 */ GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2289059),
     /* 2288944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2288947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2288950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288962 */   GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2289010), // Rule ID 53484 //
     /* 2288967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2288970 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2288973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2288987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289009 */     // GIR_Coverage, 53484,
     /* 2289009 */     GIR_EraseRootFromParent_Done,
     /* 2289010 */   // Label 31293: @2289010
     /* 2289010 */   GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2289058), // Rule ID 53485 //
     /* 2289015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289018 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2289021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2289035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289057 */     // GIR_Coverage, 53485,
     /* 2289057 */     GIR_EraseRootFromParent_Done,
     /* 2289058 */   // Label 31294: @2289058
     /* 2289058 */   GIM_Reject,
     /* 2289059 */ // Label 31292: @2289059
     /* 2289059 */ GIM_Reject,
     /* 2289060 */ // Label 31249: @2289060
     /* 2289060 */ GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2289180),
     /* 2289065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2289068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2289071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289083 */   GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2289131), // Rule ID 53556 //
     /* 2289088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2289091 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2289108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289130 */     // GIR_Coverage, 53556,
     /* 2289130 */     GIR_EraseRootFromParent_Done,
     /* 2289131 */   // Label 31296: @2289131
     /* 2289131 */   GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2289179), // Rule ID 53557 //
     /* 2289136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2289139 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2289142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2289156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289178 */     // GIR_Coverage, 53557,
     /* 2289178 */     GIR_EraseRootFromParent_Done,
     /* 2289179 */   // Label 31297: @2289179
     /* 2289179 */   GIM_Reject,
     /* 2289180 */ // Label 31295: @2289180
     /* 2289180 */ GIM_Reject,
     /* 2289181 */ // Label 31250: @2289181
     /* 2289181 */ GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2289301),
     /* 2289186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2289189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2289192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289204 */   GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2289252), // Rule ID 53604 //
     /* 2289209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2289212 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2289229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289251 */     // GIR_Coverage, 53604,
     /* 2289251 */     GIR_EraseRootFromParent_Done,
     /* 2289252 */   // Label 31299: @2289252
     /* 2289252 */   GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2289300), // Rule ID 53605 //
     /* 2289257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2289260 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2289277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289299 */     // GIR_Coverage, 53605,
     /* 2289299 */     GIR_EraseRootFromParent_Done,
     /* 2289300 */   // Label 31300: @2289300
     /* 2289300 */   GIM_Reject,
     /* 2289301 */ // Label 31298: @2289301
     /* 2289301 */ GIM_Reject,
     /* 2289302 */ // Label 31251: @2289302
     /* 2289302 */ GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2289422),
     /* 2289307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2289310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2289313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289325 */   GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2289373), // Rule ID 53520 //
     /* 2289330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289333 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2289350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289372 */     // GIR_Coverage, 53520,
     /* 2289372 */     GIR_EraseRootFromParent_Done,
     /* 2289373 */   // Label 31302: @2289373
     /* 2289373 */   GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2289421), // Rule ID 53521 //
     /* 2289378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289381 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2289398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289420 */     // GIR_Coverage, 53521,
     /* 2289420 */     GIR_EraseRootFromParent_Done,
     /* 2289421 */   // Label 31303: @2289421
     /* 2289421 */   GIM_Reject,
     /* 2289422 */ // Label 31301: @2289422
     /* 2289422 */ GIM_Reject,
     /* 2289423 */ // Label 31252: @2289423
     /* 2289423 */ GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2289543),
     /* 2289428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289446 */   GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2289494), // Rule ID 53568 //
     /* 2289451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2289454 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2289471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289493 */     // GIR_Coverage, 53568,
     /* 2289493 */     GIR_EraseRootFromParent_Done,
     /* 2289494 */   // Label 31305: @2289494
     /* 2289494 */   GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2289542), // Rule ID 53569 //
     /* 2289499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2289502 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2289519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289541 */     // GIR_Coverage, 53569,
     /* 2289541 */     GIR_EraseRootFromParent_Done,
     /* 2289542 */   // Label 31306: @2289542
     /* 2289542 */   GIM_Reject,
     /* 2289543 */ // Label 31304: @2289543
     /* 2289543 */ GIM_Reject,
     /* 2289544 */ // Label 31253: @2289544
     /* 2289544 */ GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2289664),
     /* 2289549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289567 */   GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2289615), // Rule ID 53616 //
     /* 2289572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2289575 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2289592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289614 */     // GIR_Coverage, 53616,
     /* 2289614 */     GIR_EraseRootFromParent_Done,
     /* 2289615 */   // Label 31308: @2289615
     /* 2289615 */   GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2289663), // Rule ID 53617 //
     /* 2289620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2289623 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2289640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289662 */     // GIR_Coverage, 53617,
     /* 2289662 */     GIR_EraseRootFromParent_Done,
     /* 2289663 */   // Label 31309: @2289663
     /* 2289663 */   GIM_Reject,
     /* 2289664 */ // Label 31307: @2289664
     /* 2289664 */ GIM_Reject,
     /* 2289665 */ // Label 31254: @2289665
     /* 2289665 */ GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2289785),
     /* 2289670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2289673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2289676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289688 */   GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2289736), // Rule ID 53532 //
     /* 2289693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289696 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2289713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289735 */     // GIR_Coverage, 53532,
     /* 2289735 */     GIR_EraseRootFromParent_Done,
     /* 2289736 */   // Label 31311: @2289736
     /* 2289736 */   GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2289784), // Rule ID 53533 //
     /* 2289741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289744 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2289761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289783 */     // GIR_Coverage, 53533,
     /* 2289783 */     GIR_EraseRootFromParent_Done,
     /* 2289784 */   // Label 31312: @2289784
     /* 2289784 */   GIM_Reject,
     /* 2289785 */ // Label 31310: @2289785
     /* 2289785 */ GIM_Reject,
     /* 2289786 */ // Label 31255: @2289786
     /* 2289786 */ GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2289906),
     /* 2289791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2289794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2289797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289809 */   GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2289857), // Rule ID 53580 //
     /* 2289814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2289817 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2289834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289856 */     // GIR_Coverage, 53580,
     /* 2289856 */     GIR_EraseRootFromParent_Done,
     /* 2289857 */   // Label 31314: @2289857
     /* 2289857 */   GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2289905), // Rule ID 53581 //
     /* 2289862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2289865 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2289882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289904 */     // GIR_Coverage, 53581,
     /* 2289904 */     GIR_EraseRootFromParent_Done,
     /* 2289905 */   // Label 31315: @2289905
     /* 2289905 */   GIM_Reject,
     /* 2289906 */ // Label 31313: @2289906
     /* 2289906 */ GIM_Reject,
     /* 2289907 */ // Label 31256: @2289907
     /* 2289907 */ GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2290027),
     /* 2289912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2289915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2289918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289930 */   GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2289978), // Rule ID 53544 //
     /* 2289935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2289938 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2289941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2289955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289977 */     // GIR_Coverage, 53544,
     /* 2289977 */     GIR_EraseRootFromParent_Done,
     /* 2289978 */   // Label 31317: @2289978
     /* 2289978 */   GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2290026), // Rule ID 53545 //
     /* 2289983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2289986 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2289989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2290003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290025 */     // GIR_Coverage, 53545,
     /* 2290025 */     GIR_EraseRootFromParent_Done,
     /* 2290026 */   // Label 31318: @2290026
     /* 2290026 */   GIM_Reject,
     /* 2290027 */ // Label 31316: @2290027
     /* 2290027 */ GIM_Reject,
     /* 2290028 */ // Label 31257: @2290028
     /* 2290028 */ GIM_Reject,
     /* 2290029 */ // Label 61: @2290029
     /* 2290029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31337*/ GIMT_Encode4(2292456),
     /* 2290040 */ /*GILLT_s16*//*Label 31319*/ GIMT_Encode4(2290160),
     /* 2290044 */ /*GILLT_s32*//*Label 31320*/ GIMT_Encode4(2290309),
     /* 2290048 */ /*GILLT_s64*//*Label 31321*/ GIMT_Encode4(2290458), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290060 */ /*GILLT_nxv1s16*//*Label 31322*/ GIMT_Encode4(2290641),
     /* 2290064 */ /*GILLT_nxv1s32*//*Label 31323*/ GIMT_Encode4(2290762),
     /* 2290068 */ /*GILLT_nxv1s64*//*Label 31324*/ GIMT_Encode4(2290883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290080 */ /*GILLT_nxv2s16*//*Label 31325*/ GIMT_Encode4(2291004),
     /* 2290084 */ /*GILLT_nxv2s32*//*Label 31326*/ GIMT_Encode4(2291125),
     /* 2290088 */ /*GILLT_nxv2s64*//*Label 31327*/ GIMT_Encode4(2291246), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290100 */ /*GILLT_nxv4s16*//*Label 31328*/ GIMT_Encode4(2291367),
     /* 2290104 */ /*GILLT_nxv4s32*//*Label 31329*/ GIMT_Encode4(2291488),
     /* 2290108 */ /*GILLT_nxv4s64*//*Label 31330*/ GIMT_Encode4(2291609), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290120 */ /*GILLT_nxv8s16*//*Label 31331*/ GIMT_Encode4(2291730),
     /* 2290124 */ /*GILLT_nxv8s32*//*Label 31332*/ GIMT_Encode4(2291851),
     /* 2290128 */ /*GILLT_nxv8s64*//*Label 31333*/ GIMT_Encode4(2291972), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290140 */ /*GILLT_nxv16s16*//*Label 31334*/ GIMT_Encode4(2292093),
     /* 2290144 */ /*GILLT_nxv16s32*//*Label 31335*/ GIMT_Encode4(2292214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290156 */ /*GILLT_nxv32s16*//*Label 31336*/ GIMT_Encode4(2292335),
     /* 2290160 */ // Label 31319: @2290160
     /* 2290160 */ GIM_Try, /*On fail goto*//*Label 31338*/ GIMT_Encode4(2290308),
     /* 2290165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2290168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2290171 */   GIM_Try, /*On fail goto*//*Label 31339*/ GIMT_Encode4(2290205), // Rule ID 1966 //
     /* 2290176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2290179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290191 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2290191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2290194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290204 */     // GIR_Coverage, 1966,
     /* 2290204 */     GIR_EraseRootFromParent_Done,
     /* 2290205 */   // Label 31339: @2290205
     /* 2290205 */   GIM_Try, /*On fail goto*//*Label 31340*/ GIMT_Encode4(2290239), // Rule ID 1967 //
     /* 2290210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2290213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2290225 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2290225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2290228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290238 */     // GIR_Coverage, 1967,
     /* 2290238 */     GIR_EraseRootFromParent_Done,
     /* 2290239 */   // Label 31340: @2290239
     /* 2290239 */   GIM_Try, /*On fail goto*//*Label 31341*/ GIMT_Encode4(2290273), // Rule ID 1970 //
     /* 2290244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2290247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290259 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2290259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2290262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290272 */     // GIR_Coverage, 1970,
     /* 2290272 */     GIR_EraseRootFromParent_Done,
     /* 2290273 */   // Label 31341: @2290273
     /* 2290273 */   GIM_Try, /*On fail goto*//*Label 31342*/ GIMT_Encode4(2290307), // Rule ID 1971 //
     /* 2290278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2290281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2290293 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2290293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2290296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290306 */     // GIR_Coverage, 1971,
     /* 2290306 */     GIR_EraseRootFromParent_Done,
     /* 2290307 */   // Label 31342: @2290307
     /* 2290307 */   GIM_Reject,
     /* 2290308 */ // Label 31338: @2290308
     /* 2290308 */ GIM_Reject,
     /* 2290309 */ // Label 31320: @2290309
     /* 2290309 */ GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2290457),
     /* 2290314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290320 */   GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2290354), // Rule ID 1253 //
     /* 2290325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290340 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2290340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2290343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290353 */     // GIR_Coverage, 1253,
     /* 2290353 */     GIR_EraseRootFromParent_Done,
     /* 2290354 */   // Label 31344: @2290354
     /* 2290354 */   GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2290388), // Rule ID 1254 //
     /* 2290359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2290362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290374 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2290374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2290377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290387 */     // GIR_Coverage, 1254,
     /* 2290387 */     GIR_EraseRootFromParent_Done,
     /* 2290388 */   // Label 31345: @2290388
     /* 2290388 */   GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2290422), // Rule ID 1257 //
     /* 2290393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2290396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290408 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2290408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2290411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290421 */     // GIR_Coverage, 1257,
     /* 2290421 */     GIR_EraseRootFromParent_Done,
     /* 2290422 */   // Label 31346: @2290422
     /* 2290422 */   GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2290456), // Rule ID 1258 //
     /* 2290427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2290430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290442 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2290442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2290445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290455 */     // GIR_Coverage, 1258,
     /* 2290455 */     GIR_EraseRootFromParent_Done,
     /* 2290456 */   // Label 31347: @2290456
     /* 2290456 */   GIM_Reject,
     /* 2290457 */ // Label 31343: @2290457
     /* 2290457 */ GIM_Reject,
     /* 2290458 */ // Label 31321: @2290458
     /* 2290458 */ GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2290640),
     /* 2290463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2290466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2290469 */   GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2290503), // Rule ID 1592 //
     /* 2290474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2290477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290489 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2290489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2290492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290502 */     // GIR_Coverage, 1592,
     /* 2290502 */     GIR_EraseRootFromParent_Done,
     /* 2290503 */   // Label 31349: @2290503
     /* 2290503 */   GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2290537), // Rule ID 1593 //
     /* 2290508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2290511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2290523 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2290523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2290526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290536 */     // GIR_Coverage, 1593,
     /* 2290536 */     GIR_EraseRootFromParent_Done,
     /* 2290537 */   // Label 31350: @2290537
     /* 2290537 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2290571), // Rule ID 1596 //
     /* 2290542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2290545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290557 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2290557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2290560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290570 */     // GIR_Coverage, 1596,
     /* 2290570 */     GIR_EraseRootFromParent_Done,
     /* 2290571 */   // Label 31351: @2290571
     /* 2290571 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2290605), // Rule ID 1597 //
     /* 2290576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2290579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2290591 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2290591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2290594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290604 */     // GIR_Coverage, 1597,
     /* 2290604 */     GIR_EraseRootFromParent_Done,
     /* 2290605 */   // Label 31352: @2290605
     /* 2290605 */   GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2290639), // Rule ID 1599 //
     /* 2290610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2290613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2290617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2290621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2290625 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2290625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2290628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290638 */     // GIR_Coverage, 1599,
     /* 2290638 */     GIR_EraseRootFromParent_Done,
     /* 2290639 */   // Label 31353: @2290639
     /* 2290639 */   GIM_Reject,
     /* 2290640 */ // Label 31348: @2290640
     /* 2290640 */ GIM_Reject,
     /* 2290641 */ // Label 31322: @2290641
     /* 2290641 */ GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2290761),
     /* 2290646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2290649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2290652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290664 */   GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2290712), // Rule ID 54216 //
     /* 2290669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2290672 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2290689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290711 */     // GIR_Coverage, 54216,
     /* 2290711 */     GIR_EraseRootFromParent_Done,
     /* 2290712 */   // Label 31355: @2290712
     /* 2290712 */   GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2290760), // Rule ID 54217 //
     /* 2290717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2290720 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2290737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290759 */     // GIR_Coverage, 54217,
     /* 2290759 */     GIR_EraseRootFromParent_Done,
     /* 2290760 */   // Label 31356: @2290760
     /* 2290760 */   GIM_Reject,
     /* 2290761 */ // Label 31354: @2290761
     /* 2290761 */ GIM_Reject,
     /* 2290762 */ // Label 31323: @2290762
     /* 2290762 */ GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2290882),
     /* 2290767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2290770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2290773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290785 */   GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2290833), // Rule ID 54240 //
     /* 2290790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2290793 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2290810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290832 */     // GIR_Coverage, 54240,
     /* 2290832 */     GIR_EraseRootFromParent_Done,
     /* 2290833 */   // Label 31358: @2290833
     /* 2290833 */   GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2290881), // Rule ID 54241 //
     /* 2290838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2290841 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2290858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290880 */     // GIR_Coverage, 54241,
     /* 2290880 */     GIR_EraseRootFromParent_Done,
     /* 2290881 */   // Label 31359: @2290881
     /* 2290881 */   GIM_Reject,
     /* 2290882 */ // Label 31357: @2290882
     /* 2290882 */ GIM_Reject,
     /* 2290883 */ // Label 31324: @2290883
     /* 2290883 */ GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2291003),
     /* 2290888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2290891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2290894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290906 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2290954), // Rule ID 54276 //
     /* 2290911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2290914 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2290931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290953 */     // GIR_Coverage, 54276,
     /* 2290953 */     GIR_EraseRootFromParent_Done,
     /* 2290954 */   // Label 31361: @2290954
     /* 2290954 */   GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2291002), // Rule ID 54277 //
     /* 2290959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2290962 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2290979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291001 */     // GIR_Coverage, 54277,
     /* 2291001 */     GIR_EraseRootFromParent_Done,
     /* 2291002 */   // Label 31362: @2291002
     /* 2291002 */   GIM_Reject,
     /* 2291003 */ // Label 31360: @2291003
     /* 2291003 */ GIM_Reject,
     /* 2291004 */ // Label 31325: @2291004
     /* 2291004 */ GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2291124),
     /* 2291009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2291012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2291015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291027 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2291075), // Rule ID 54228 //
     /* 2291032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291035 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2291052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291074 */     // GIR_Coverage, 54228,
     /* 2291074 */     GIR_EraseRootFromParent_Done,
     /* 2291075 */   // Label 31364: @2291075
     /* 2291075 */   GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2291123), // Rule ID 54229 //
     /* 2291080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291083 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2291100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291122 */     // GIR_Coverage, 54229,
     /* 2291122 */     GIR_EraseRootFromParent_Done,
     /* 2291123 */   // Label 31365: @2291123
     /* 2291123 */   GIM_Reject,
     /* 2291124 */ // Label 31363: @2291124
     /* 2291124 */ GIM_Reject,
     /* 2291125 */ // Label 31326: @2291125
     /* 2291125 */ GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2291245),
     /* 2291130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2291133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2291136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291148 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2291196), // Rule ID 54264 //
     /* 2291153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2291156 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2291173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291195 */     // GIR_Coverage, 54264,
     /* 2291195 */     GIR_EraseRootFromParent_Done,
     /* 2291196 */   // Label 31367: @2291196
     /* 2291196 */   GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2291244), // Rule ID 54265 //
     /* 2291201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2291204 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2291221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291243 */     // GIR_Coverage, 54265,
     /* 2291243 */     GIR_EraseRootFromParent_Done,
     /* 2291244 */   // Label 31368: @2291244
     /* 2291244 */   GIM_Reject,
     /* 2291245 */ // Label 31366: @2291245
     /* 2291245 */ GIM_Reject,
     /* 2291246 */ // Label 31327: @2291246
     /* 2291246 */ GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2291366),
     /* 2291251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291269 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2291317), // Rule ID 54360 //
     /* 2291274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291277 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2291294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291316 */     // GIR_Coverage, 54360,
     /* 2291316 */     GIR_EraseRootFromParent_Done,
     /* 2291317 */   // Label 31370: @2291317
     /* 2291317 */   GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2291365), // Rule ID 54361 //
     /* 2291322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291325 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2291342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291364 */     // GIR_Coverage, 54361,
     /* 2291364 */     GIR_EraseRootFromParent_Done,
     /* 2291365 */   // Label 31371: @2291365
     /* 2291365 */   GIM_Reject,
     /* 2291366 */ // Label 31369: @2291366
     /* 2291366 */ GIM_Reject,
     /* 2291367 */ // Label 31328: @2291367
     /* 2291367 */ GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2291487),
     /* 2291372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2291378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291390 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2291438), // Rule ID 54252 //
     /* 2291395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291398 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2291415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291437 */     // GIR_Coverage, 54252,
     /* 2291437 */     GIR_EraseRootFromParent_Done,
     /* 2291438 */   // Label 31373: @2291438
     /* 2291438 */   GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2291486), // Rule ID 54253 //
     /* 2291443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291446 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2291463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291485 */     // GIR_Coverage, 54253,
     /* 2291485 */     GIR_EraseRootFromParent_Done,
     /* 2291486 */   // Label 31374: @2291486
     /* 2291486 */   GIM_Reject,
     /* 2291487 */ // Label 31372: @2291487
     /* 2291487 */ GIM_Reject,
     /* 2291488 */ // Label 31329: @2291488
     /* 2291488 */ GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2291608),
     /* 2291493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2291496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2291499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291511 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2291559), // Rule ID 54324 //
     /* 2291516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2291519 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2291536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291558 */     // GIR_Coverage, 54324,
     /* 2291558 */     GIR_EraseRootFromParent_Done,
     /* 2291559 */   // Label 31376: @2291559
     /* 2291559 */   GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2291607), // Rule ID 54325 //
     /* 2291564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2291567 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2291584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291606 */     // GIR_Coverage, 54325,
     /* 2291606 */     GIR_EraseRootFromParent_Done,
     /* 2291607 */   // Label 31377: @2291607
     /* 2291607 */   GIM_Reject,
     /* 2291608 */ // Label 31375: @2291608
     /* 2291608 */ GIM_Reject,
     /* 2291609 */ // Label 31330: @2291609
     /* 2291609 */ GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2291729),
     /* 2291614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2291617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2291620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291632 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2291680), // Rule ID 54372 //
     /* 2291637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2291640 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2291657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291679 */     // GIR_Coverage, 54372,
     /* 2291679 */     GIR_EraseRootFromParent_Done,
     /* 2291680 */   // Label 31379: @2291680
     /* 2291680 */   GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2291728), // Rule ID 54373 //
     /* 2291685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2291688 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2291705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291727 */     // GIR_Coverage, 54373,
     /* 2291727 */     GIR_EraseRootFromParent_Done,
     /* 2291728 */   // Label 31380: @2291728
     /* 2291728 */   GIM_Reject,
     /* 2291729 */ // Label 31378: @2291729
     /* 2291729 */ GIM_Reject,
     /* 2291730 */ // Label 31331: @2291730
     /* 2291730 */ GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2291850),
     /* 2291735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2291738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2291741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291753 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2291801), // Rule ID 54288 //
     /* 2291758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2291761 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2291764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2291778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291800 */     // GIR_Coverage, 54288,
     /* 2291800 */     GIR_EraseRootFromParent_Done,
     /* 2291801 */   // Label 31382: @2291801
     /* 2291801 */   GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2291849), // Rule ID 54289 //
     /* 2291806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2291809 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2291812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2291826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291848 */     // GIR_Coverage, 54289,
     /* 2291848 */     GIR_EraseRootFromParent_Done,
     /* 2291849 */   // Label 31383: @2291849
     /* 2291849 */   GIM_Reject,
     /* 2291850 */ // Label 31381: @2291850
     /* 2291850 */ GIM_Reject,
     /* 2291851 */ // Label 31332: @2291851
     /* 2291851 */ GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2291971),
     /* 2291856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2291859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2291862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291874 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2291922), // Rule ID 54336 //
     /* 2291879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2291882 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2291885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2291899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291921 */     // GIR_Coverage, 54336,
     /* 2291921 */     GIR_EraseRootFromParent_Done,
     /* 2291922 */   // Label 31385: @2291922
     /* 2291922 */   GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2291970), // Rule ID 54337 //
     /* 2291927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2291930 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2291933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2291947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291969 */     // GIR_Coverage, 54337,
     /* 2291969 */     GIR_EraseRootFromParent_Done,
     /* 2291970 */   // Label 31386: @2291970
     /* 2291970 */   GIM_Reject,
     /* 2291971 */ // Label 31384: @2291971
     /* 2291971 */ GIM_Reject,
     /* 2291972 */ // Label 31333: @2291972
     /* 2291972 */ GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2292092),
     /* 2291977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2291980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2291983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2291987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2291991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2291995 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2292043), // Rule ID 54384 //
     /* 2292000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2292003 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2292020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292042 */     // GIR_Coverage, 54384,
     /* 2292042 */     GIR_EraseRootFromParent_Done,
     /* 2292043 */   // Label 31388: @2292043
     /* 2292043 */   GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2292091), // Rule ID 54385 //
     /* 2292048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2292051 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2292068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292090 */     // GIR_Coverage, 54385,
     /* 2292090 */     GIR_EraseRootFromParent_Done,
     /* 2292091 */   // Label 31389: @2292091
     /* 2292091 */   GIM_Reject,
     /* 2292092 */ // Label 31387: @2292092
     /* 2292092 */ GIM_Reject,
     /* 2292093 */ // Label 31334: @2292093
     /* 2292093 */ GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2292213),
     /* 2292098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2292101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2292104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292116 */   GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2292164), // Rule ID 54300 //
     /* 2292121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2292124 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2292141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292163 */     // GIR_Coverage, 54300,
     /* 2292163 */     GIR_EraseRootFromParent_Done,
     /* 2292164 */   // Label 31391: @2292164
     /* 2292164 */   GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2292212), // Rule ID 54301 //
     /* 2292169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2292172 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2292189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292211 */     // GIR_Coverage, 54301,
     /* 2292211 */     GIR_EraseRootFromParent_Done,
     /* 2292212 */   // Label 31392: @2292212
     /* 2292212 */   GIM_Reject,
     /* 2292213 */ // Label 31390: @2292213
     /* 2292213 */ GIM_Reject,
     /* 2292214 */ // Label 31335: @2292214
     /* 2292214 */ GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2292334),
     /* 2292219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2292222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2292225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292237 */   GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2292285), // Rule ID 54348 //
     /* 2292242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2292245 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2292262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292284 */     // GIR_Coverage, 54348,
     /* 2292284 */     GIR_EraseRootFromParent_Done,
     /* 2292285 */   // Label 31394: @2292285
     /* 2292285 */   GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2292333), // Rule ID 54349 //
     /* 2292290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2292293 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2292310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292332 */     // GIR_Coverage, 54349,
     /* 2292332 */     GIR_EraseRootFromParent_Done,
     /* 2292333 */   // Label 31395: @2292333
     /* 2292333 */   GIM_Reject,
     /* 2292334 */ // Label 31393: @2292334
     /* 2292334 */ GIM_Reject,
     /* 2292335 */ // Label 31336: @2292335
     /* 2292335 */ GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2292455),
     /* 2292340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2292343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2292346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292358 */   GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2292406), // Rule ID 54312 //
     /* 2292363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2292366 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2292369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2292383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292405 */     // GIR_Coverage, 54312,
     /* 2292405 */     GIR_EraseRootFromParent_Done,
     /* 2292406 */   // Label 31397: @2292406
     /* 2292406 */   GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2292454), // Rule ID 54313 //
     /* 2292411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2292414 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2292417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2292431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292453 */     // GIR_Coverage, 54313,
     /* 2292453 */     GIR_EraseRootFromParent_Done,
     /* 2292454 */   // Label 31398: @2292454
     /* 2292454 */   GIM_Reject,
     /* 2292455 */ // Label 31396: @2292455
     /* 2292455 */ GIM_Reject,
     /* 2292456 */ // Label 31337: @2292456
     /* 2292456 */ GIM_Reject,
     /* 2292457 */ // Label 62: @2292457
     /* 2292457 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31417*/ GIMT_Encode4(2309101),
     /* 2292468 */ /*GILLT_s16*//*Label 31399*/ GIMT_Encode4(2292588),
     /* 2292472 */ /*GILLT_s32*//*Label 31400*/ GIMT_Encode4(2294024),
     /* 2292476 */ /*GILLT_s64*//*Label 31401*/ GIMT_Encode4(2295460), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292488 */ /*GILLT_nxv1s16*//*Label 31402*/ GIMT_Encode4(2297251),
     /* 2292492 */ /*GILLT_nxv1s32*//*Label 31403*/ GIMT_Encode4(2298041),
     /* 2292496 */ /*GILLT_nxv1s64*//*Label 31404*/ GIMT_Encode4(2298831), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292508 */ /*GILLT_nxv2s16*//*Label 31405*/ GIMT_Encode4(2299621),
     /* 2292512 */ /*GILLT_nxv2s32*//*Label 31406*/ GIMT_Encode4(2300411),
     /* 2292516 */ /*GILLT_nxv2s64*//*Label 31407*/ GIMT_Encode4(2301201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292528 */ /*GILLT_nxv4s16*//*Label 31408*/ GIMT_Encode4(2301991),
     /* 2292532 */ /*GILLT_nxv4s32*//*Label 31409*/ GIMT_Encode4(2302781),
     /* 2292536 */ /*GILLT_nxv4s64*//*Label 31410*/ GIMT_Encode4(2303571), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292548 */ /*GILLT_nxv8s16*//*Label 31411*/ GIMT_Encode4(2304361),
     /* 2292552 */ /*GILLT_nxv8s32*//*Label 31412*/ GIMT_Encode4(2305151),
     /* 2292556 */ /*GILLT_nxv8s64*//*Label 31413*/ GIMT_Encode4(2305941), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292568 */ /*GILLT_nxv16s16*//*Label 31414*/ GIMT_Encode4(2306731),
     /* 2292572 */ /*GILLT_nxv16s32*//*Label 31415*/ GIMT_Encode4(2307521), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2292584 */ /*GILLT_nxv32s16*//*Label 31416*/ GIMT_Encode4(2308311),
     /* 2292588 */ // Label 31399: @2292588
     /* 2292588 */ GIM_Try, /*On fail goto*//*Label 31418*/ GIMT_Encode4(2294023),
     /* 2292593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2292599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2292602 */   GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2292674), // Rule ID 2007 //
     /* 2292607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2292610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292654 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2292654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2292657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2292669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292673 */     // GIR_Coverage, 2007,
     /* 2292673 */     GIR_EraseRootFromParent_Done,
     /* 2292674 */   // Label 31419: @2292674
     /* 2292674 */   GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2292746), // Rule ID 2008 //
     /* 2292679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2292682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292726 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2292726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2292729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2292741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292745 */     // GIR_Coverage, 2008,
     /* 2292745 */     GIR_EraseRootFromParent_Done,
     /* 2292746 */   // Label 31420: @2292746
     /* 2292746 */   GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2292818), // Rule ID 2040 //
     /* 2292751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2292754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292798 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2292798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2292801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2292813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292817 */     // GIR_Coverage, 2040,
     /* 2292817 */     GIR_EraseRootFromParent_Done,
     /* 2292818 */   // Label 31421: @2292818
     /* 2292818 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2292890), // Rule ID 2041 //
     /* 2292823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2292826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2292868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292870 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2292870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2292873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2292885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292889 */     // GIR_Coverage, 2041,
     /* 2292889 */     GIR_EraseRootFromParent_Done,
     /* 2292890 */   // Label 31422: @2292890
     /* 2292890 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2292962), // Rule ID 65200 //
     /* 2292895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2292898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292942 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2292942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2292945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2292957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292961 */     // GIR_Coverage, 65200,
     /* 2292961 */     GIR_EraseRootFromParent_Done,
     /* 2292962 */   // Label 31423: @2292962
     /* 2292962 */   GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2293034), // Rule ID 65201 //
     /* 2292967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2292970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2292990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2292995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293014 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2293017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2293029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293033 */     // GIR_Coverage, 65201,
     /* 2293033 */     GIR_EraseRootFromParent_Done,
     /* 2293034 */   // Label 31424: @2293034
     /* 2293034 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2293106), // Rule ID 65208 //
     /* 2293039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2293042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293086 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2293089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2293101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293105 */     // GIR_Coverage, 65208,
     /* 2293105 */     GIR_EraseRootFromParent_Done,
     /* 2293106 */   // Label 31425: @2293106
     /* 2293106 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2293178), // Rule ID 65209 //
     /* 2293111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2293114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293158 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2293161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2293173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293177 */     // GIR_Coverage, 65209,
     /* 2293177 */     GIR_EraseRootFromParent_Done,
     /* 2293178 */   // Label 31426: @2293178
     /* 2293178 */   GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2293235), // Rule ID 2003 //
     /* 2293183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2293186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293217 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2293220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293234 */     // GIR_Coverage, 2003,
     /* 2293234 */     GIR_EraseRootFromParent_Done,
     /* 2293235 */   // Label 31427: @2293235
     /* 2293235 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2293292), // Rule ID 2004 //
     /* 2293240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2293243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293274 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2293277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293291 */     // GIR_Coverage, 2004,
     /* 2293291 */     GIR_EraseRootFromParent_Done,
     /* 2293292 */   // Label 31428: @2293292
     /* 2293292 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2293349), // Rule ID 2036 //
     /* 2293297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2293300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293331 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2293334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293348 */     // GIR_Coverage, 2036,
     /* 2293348 */     GIR_EraseRootFromParent_Done,
     /* 2293349 */   // Label 31429: @2293349
     /* 2293349 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2293406), // Rule ID 2037 //
     /* 2293354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2293357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293388 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2293391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293405 */     // GIR_Coverage, 2037,
     /* 2293405 */     GIR_EraseRootFromParent_Done,
     /* 2293406 */   // Label 31430: @2293406
     /* 2293406 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2293463), // Rule ID 65196 //
     /* 2293411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2293414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293445 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2293448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293462 */     // GIR_Coverage, 65196,
     /* 2293462 */     GIR_EraseRootFromParent_Done,
     /* 2293463 */   // Label 31431: @2293463
     /* 2293463 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2293520), // Rule ID 65197 //
     /* 2293468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2293471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293502 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2293505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293519 */     // GIR_Coverage, 65197,
     /* 2293519 */     GIR_EraseRootFromParent_Done,
     /* 2293520 */   // Label 31432: @2293520
     /* 2293520 */   GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2293577), // Rule ID 65204 //
     /* 2293525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2293528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293559 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2293562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293576 */     // GIR_Coverage, 65204,
     /* 2293576 */     GIR_EraseRootFromParent_Done,
     /* 2293577 */   // Label 31433: @2293577
     /* 2293577 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2293634), // Rule ID 65205 //
     /* 2293582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2293585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293616 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2293619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2293627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293633 */     // GIR_Coverage, 65205,
     /* 2293633 */     GIR_EraseRootFromParent_Done,
     /* 2293634 */   // Label 31434: @2293634
     /* 2293634 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2293691), // Rule ID 1999 //
     /* 2293639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2293642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293673 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2293676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2293686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293690 */     // GIR_Coverage, 1999,
     /* 2293690 */     GIR_EraseRootFromParent_Done,
     /* 2293691 */   // Label 31435: @2293691
     /* 2293691 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2293748), // Rule ID 2000 //
     /* 2293696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2293699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293730 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2293733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2293743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293747 */     // GIR_Coverage, 2000,
     /* 2293747 */     GIR_EraseRootFromParent_Done,
     /* 2293748 */   // Label 31436: @2293748
     /* 2293748 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2293805), // Rule ID 2032 //
     /* 2293753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2293756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293787 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2293790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2293800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293804 */     // GIR_Coverage, 2032,
     /* 2293804 */     GIR_EraseRootFromParent_Done,
     /* 2293805 */   // Label 31437: @2293805
     /* 2293805 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2293862), // Rule ID 2033 //
     /* 2293810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2293813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2293837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293844 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2293847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2293857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293861 */     // GIR_Coverage, 2033,
     /* 2293861 */     GIR_EraseRootFromParent_Done,
     /* 2293862 */   // Label 31438: @2293862
     /* 2293862 */   GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2293902), // Rule ID 1995 //
     /* 2293867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2293870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293886 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2293889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293901 */     // GIR_Coverage, 1995,
     /* 2293901 */     GIR_EraseRootFromParent_Done,
     /* 2293902 */   // Label 31439: @2293902
     /* 2293902 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2293942), // Rule ID 1996 //
     /* 2293907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2293910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2293926 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2293926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2293929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293941 */     // GIR_Coverage, 1996,
     /* 2293941 */     GIR_EraseRootFromParent_Done,
     /* 2293942 */   // Label 31440: @2293942
     /* 2293942 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2293982), // Rule ID 2028 //
     /* 2293947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2293950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293966 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2293966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2293969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2293977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293981 */     // GIR_Coverage, 2028,
     /* 2293981 */     GIR_EraseRootFromParent_Done,
     /* 2293982 */   // Label 31441: @2293982
     /* 2293982 */   GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2294022), // Rule ID 2029 //
     /* 2293987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2293990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2293998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2294002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2294006 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2294006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2294009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294021 */     // GIR_Coverage, 2029,
     /* 2294021 */     GIR_EraseRootFromParent_Done,
     /* 2294022 */   // Label 31442: @2294022
     /* 2294022 */   GIM_Reject,
     /* 2294023 */ // Label 31418: @2294023
     /* 2294023 */ GIM_Reject,
     /* 2294024 */ // Label 31400: @2294024
     /* 2294024 */ GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2295459),
     /* 2294029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2294035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2294038 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2294110), // Rule ID 1302 //
     /* 2294043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2294046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294090 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2294093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294109 */     // GIR_Coverage, 1302,
     /* 2294109 */     GIR_EraseRootFromParent_Done,
     /* 2294110 */   // Label 31444: @2294110
     /* 2294110 */   GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2294182), // Rule ID 1303 //
     /* 2294115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2294118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294162 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2294165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294181 */     // GIR_Coverage, 1303,
     /* 2294181 */     GIR_EraseRootFromParent_Done,
     /* 2294182 */   // Label 31445: @2294182
     /* 2294182 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2294254), // Rule ID 1323 //
     /* 2294187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2294190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294234 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2294237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294253 */     // GIR_Coverage, 1323,
     /* 2294253 */     GIR_EraseRootFromParent_Done,
     /* 2294254 */   // Label 31446: @2294254
     /* 2294254 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2294326), // Rule ID 1324 //
     /* 2294259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2294262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294306 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2294309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294325 */     // GIR_Coverage, 1324,
     /* 2294325 */     GIR_EraseRootFromParent_Done,
     /* 2294326 */   // Label 31447: @2294326
     /* 2294326 */   GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2294398), // Rule ID 65164 //
     /* 2294331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2294334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294378 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2294381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294397 */     // GIR_Coverage, 65164,
     /* 2294397 */     GIR_EraseRootFromParent_Done,
     /* 2294398 */   // Label 31448: @2294398
     /* 2294398 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2294470), // Rule ID 65165 //
     /* 2294403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2294406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294450 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2294453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294469 */     // GIR_Coverage, 65165,
     /* 2294469 */     GIR_EraseRootFromParent_Done,
     /* 2294470 */   // Label 31449: @2294470
     /* 2294470 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2294542), // Rule ID 65172 //
     /* 2294475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2294478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294522 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2294525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294541 */     // GIR_Coverage, 65172,
     /* 2294541 */     GIR_EraseRootFromParent_Done,
     /* 2294542 */   // Label 31450: @2294542
     /* 2294542 */   GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2294614), // Rule ID 65173 //
     /* 2294547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2294550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294594 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2294597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2294609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294613 */     // GIR_Coverage, 65173,
     /* 2294613 */     GIR_EraseRootFromParent_Done,
     /* 2294614 */   // Label 31451: @2294614
     /* 2294614 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2294671), // Rule ID 1298 //
     /* 2294619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2294622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294653 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2294656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294670 */     // GIR_Coverage, 1298,
     /* 2294670 */     GIR_EraseRootFromParent_Done,
     /* 2294671 */   // Label 31452: @2294671
     /* 2294671 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2294728), // Rule ID 1299 //
     /* 2294676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2294679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294710 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2294713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294727 */     // GIR_Coverage, 1299,
     /* 2294727 */     GIR_EraseRootFromParent_Done,
     /* 2294728 */   // Label 31453: @2294728
     /* 2294728 */   GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2294785), // Rule ID 1319 //
     /* 2294733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2294736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294767 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2294770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294784 */     // GIR_Coverage, 1319,
     /* 2294784 */     GIR_EraseRootFromParent_Done,
     /* 2294785 */   // Label 31454: @2294785
     /* 2294785 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2294842), // Rule ID 1320 //
     /* 2294790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2294793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294824 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2294827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294841 */     // GIR_Coverage, 1320,
     /* 2294841 */     GIR_EraseRootFromParent_Done,
     /* 2294842 */   // Label 31455: @2294842
     /* 2294842 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2294899), // Rule ID 65160 //
     /* 2294847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2294850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294881 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2294884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294898 */     // GIR_Coverage, 65160,
     /* 2294898 */     GIR_EraseRootFromParent_Done,
     /* 2294899 */   // Label 31456: @2294899
     /* 2294899 */   GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2294956), // Rule ID 65161 //
     /* 2294904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2294907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2294936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294938 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2294938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2294941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2294949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2294951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294955 */     // GIR_Coverage, 65161,
     /* 2294955 */     GIR_EraseRootFromParent_Done,
     /* 2294956 */   // Label 31457: @2294956
     /* 2294956 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2295013), // Rule ID 65168 //
     /* 2294961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2294964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2294984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2294993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294995 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2294995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2294998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2295006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295012 */     // GIR_Coverage, 65168,
     /* 2295012 */     GIR_EraseRootFromParent_Done,
     /* 2295013 */   // Label 31458: @2295013
     /* 2295013 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2295070), // Rule ID 65169 //
     /* 2295018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2295021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295052 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2295052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2295055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2295063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295069 */     // GIR_Coverage, 65169,
     /* 2295069 */     GIR_EraseRootFromParent_Done,
     /* 2295070 */   // Label 31459: @2295070
     /* 2295070 */   GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2295127), // Rule ID 1294 //
     /* 2295075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2295078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295109 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2295109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2295112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2295122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295126 */     // GIR_Coverage, 1294,
     /* 2295126 */     GIR_EraseRootFromParent_Done,
     /* 2295127 */   // Label 31460: @2295127
     /* 2295127 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2295184), // Rule ID 1295 //
     /* 2295132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2295135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295166 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2295166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2295169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2295179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295183 */     // GIR_Coverage, 1295,
     /* 2295183 */     GIR_EraseRootFromParent_Done,
     /* 2295184 */   // Label 31461: @2295184
     /* 2295184 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2295241), // Rule ID 1315 //
     /* 2295189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2295192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295223 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2295223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2295226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2295236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295240 */     // GIR_Coverage, 1315,
     /* 2295240 */     GIR_EraseRootFromParent_Done,
     /* 2295241 */   // Label 31462: @2295241
     /* 2295241 */   GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2295298), // Rule ID 1316 //
     /* 2295246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2295249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2295273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295280 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2295280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2295283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2295293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295297 */     // GIR_Coverage, 1316,
     /* 2295297 */     GIR_EraseRootFromParent_Done,
     /* 2295298 */   // Label 31463: @2295298
     /* 2295298 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2295338), // Rule ID 1290 //
     /* 2295303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2295306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295322 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2295322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2295325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295337 */     // GIR_Coverage, 1290,
     /* 2295337 */     GIR_EraseRootFromParent_Done,
     /* 2295338 */   // Label 31464: @2295338
     /* 2295338 */   GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2295378), // Rule ID 1291 //
     /* 2295343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2295346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2295362 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2295362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2295365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295377 */     // GIR_Coverage, 1291,
     /* 2295377 */     GIR_EraseRootFromParent_Done,
     /* 2295378 */   // Label 31465: @2295378
     /* 2295378 */   GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2295418), // Rule ID 1311 //
     /* 2295383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2295386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295402 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2295402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2295405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295417 */     // GIR_Coverage, 1311,
     /* 2295417 */     GIR_EraseRootFromParent_Done,
     /* 2295418 */   // Label 31466: @2295418
     /* 2295418 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2295458), // Rule ID 1312 //
     /* 2295423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2295426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2295442 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2295442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2295445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2295453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295457 */     // GIR_Coverage, 1312,
     /* 2295457 */     GIR_EraseRootFromParent_Done,
     /* 2295458 */   // Label 31467: @2295458
     /* 2295458 */   GIM_Reject,
     /* 2295459 */ // Label 31443: @2295459
     /* 2295459 */ GIM_Reject,
     /* 2295460 */ // Label 31401: @2295460
     /* 2295460 */ GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2297250),
     /* 2295465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2295471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2295474 */   GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2295546), // Rule ID 1639 //
     /* 2295479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2295482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295526 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2295526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2295529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295545 */     // GIR_Coverage, 1639,
     /* 2295545 */     GIR_EraseRootFromParent_Done,
     /* 2295546 */   // Label 31469: @2295546
     /* 2295546 */   GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2295618), // Rule ID 1640 //
     /* 2295551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2295554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295598 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2295598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2295601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295617 */     // GIR_Coverage, 1640,
     /* 2295617 */     GIR_EraseRootFromParent_Done,
     /* 2295618 */   // Label 31470: @2295618
     /* 2295618 */   GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2295690), // Rule ID 1662 //
     /* 2295623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2295626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295670 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2295670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2295673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295689 */     // GIR_Coverage, 1662,
     /* 2295689 */     GIR_EraseRootFromParent_Done,
     /* 2295690 */   // Label 31471: @2295690
     /* 2295690 */   GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2295762), // Rule ID 1694 //
     /* 2295695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2295698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295742 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2295742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2295745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295761 */     // GIR_Coverage, 1694,
     /* 2295761 */     GIR_EraseRootFromParent_Done,
     /* 2295762 */   // Label 31472: @2295762
     /* 2295762 */   GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2295834), // Rule ID 1695 //
     /* 2295767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2295770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2295812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295814 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2295814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2295817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295833 */     // GIR_Coverage, 1695,
     /* 2295833 */     GIR_EraseRootFromParent_Done,
     /* 2295834 */   // Label 31473: @2295834
     /* 2295834 */   GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2295906), // Rule ID 65180 //
     /* 2295839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2295842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295886 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2295886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2295889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2295897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295905 */     // GIR_Coverage, 65180,
     /* 2295905 */     GIR_EraseRootFromParent_Done,
     /* 2295906 */   // Label 31474: @2295906
     /* 2295906 */   GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2295978), // Rule ID 65181 //
     /* 2295911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2295914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2295951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2295956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295958 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2295958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2295961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2295969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2295973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295977 */     // GIR_Coverage, 65181,
     /* 2295977 */     GIR_EraseRootFromParent_Done,
     /* 2295978 */   // Label 31475: @2295978
     /* 2295978 */   GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2296050), // Rule ID 65185 //
     /* 2295983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2295986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2295994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296030 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2296033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2296045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296049 */     // GIR_Coverage, 65185,
     /* 2296049 */     GIR_EraseRootFromParent_Done,
     /* 2296050 */   // Label 31476: @2296050
     /* 2296050 */   GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2296122), // Rule ID 65192 //
     /* 2296055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2296058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296102 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2296105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2296117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296121 */     // GIR_Coverage, 65192,
     /* 2296121 */     GIR_EraseRootFromParent_Done,
     /* 2296122 */   // Label 31477: @2296122
     /* 2296122 */   GIM_Try, /*On fail goto*//*Label 31478*/ GIMT_Encode4(2296194), // Rule ID 65193 //
     /* 2296127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2296130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296174 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2296177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2296189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296193 */     // GIR_Coverage, 65193,
     /* 2296193 */     GIR_EraseRootFromParent_Done,
     /* 2296194 */   // Label 31478: @2296194
     /* 2296194 */   GIM_Try, /*On fail goto*//*Label 31479*/ GIMT_Encode4(2296251), // Rule ID 1635 //
     /* 2296199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2296202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296233 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2296236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296250 */     // GIR_Coverage, 1635,
     /* 2296250 */     GIR_EraseRootFromParent_Done,
     /* 2296251 */   // Label 31479: @2296251
     /* 2296251 */   GIM_Try, /*On fail goto*//*Label 31480*/ GIMT_Encode4(2296308), // Rule ID 1636 //
     /* 2296256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2296259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296290 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2296293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296307 */     // GIR_Coverage, 1636,
     /* 2296307 */     GIR_EraseRootFromParent_Done,
     /* 2296308 */   // Label 31480: @2296308
     /* 2296308 */   GIM_Try, /*On fail goto*//*Label 31481*/ GIMT_Encode4(2296365), // Rule ID 1660 //
     /* 2296313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2296316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296347 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2296350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296364 */     // GIR_Coverage, 1660,
     /* 2296364 */     GIR_EraseRootFromParent_Done,
     /* 2296365 */   // Label 31481: @2296365
     /* 2296365 */   GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2296422), // Rule ID 1690 //
     /* 2296370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2296373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296404 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2296407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296421 */     // GIR_Coverage, 1690,
     /* 2296421 */     GIR_EraseRootFromParent_Done,
     /* 2296422 */   // Label 31482: @2296422
     /* 2296422 */   GIM_Try, /*On fail goto*//*Label 31483*/ GIMT_Encode4(2296479), // Rule ID 1691 //
     /* 2296427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2296430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296461 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2296464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296478 */     // GIR_Coverage, 1691,
     /* 2296478 */     GIR_EraseRootFromParent_Done,
     /* 2296479 */   // Label 31483: @2296479
     /* 2296479 */   GIM_Try, /*On fail goto*//*Label 31484*/ GIMT_Encode4(2296536), // Rule ID 65176 //
     /* 2296484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2296487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296518 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2296521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296535 */     // GIR_Coverage, 65176,
     /* 2296535 */     GIR_EraseRootFromParent_Done,
     /* 2296536 */   // Label 31484: @2296536
     /* 2296536 */   GIM_Try, /*On fail goto*//*Label 31485*/ GIMT_Encode4(2296593), // Rule ID 65177 //
     /* 2296541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2296544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296575 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2296578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296592 */     // GIR_Coverage, 65177,
     /* 2296592 */     GIR_EraseRootFromParent_Done,
     /* 2296593 */   // Label 31485: @2296593
     /* 2296593 */   GIM_Try, /*On fail goto*//*Label 31486*/ GIMT_Encode4(2296650), // Rule ID 65183 //
     /* 2296598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2296601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296632 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2296635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296649 */     // GIR_Coverage, 65183,
     /* 2296649 */     GIR_EraseRootFromParent_Done,
     /* 2296650 */   // Label 31486: @2296650
     /* 2296650 */   GIM_Try, /*On fail goto*//*Label 31487*/ GIMT_Encode4(2296707), // Rule ID 65188 //
     /* 2296655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2296658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296689 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2296692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296706 */     // GIR_Coverage, 65188,
     /* 2296706 */     GIR_EraseRootFromParent_Done,
     /* 2296707 */   // Label 31487: @2296707
     /* 2296707 */   GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2296764), // Rule ID 65189 //
     /* 2296712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2296715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296746 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2296749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2296757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2296759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296763 */     // GIR_Coverage, 65189,
     /* 2296763 */     GIR_EraseRootFromParent_Done,
     /* 2296764 */   // Label 31488: @2296764
     /* 2296764 */   GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2296821), // Rule ID 1631 //
     /* 2296769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2296772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296803 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2296806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2296816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296820 */     // GIR_Coverage, 1631,
     /* 2296820 */     GIR_EraseRootFromParent_Done,
     /* 2296821 */   // Label 31489: @2296821
     /* 2296821 */   GIM_Try, /*On fail goto*//*Label 31490*/ GIMT_Encode4(2296878), // Rule ID 1632 //
     /* 2296826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2296829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296860 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2296860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2296863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2296873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296877 */     // GIR_Coverage, 1632,
     /* 2296877 */     GIR_EraseRootFromParent_Done,
     /* 2296878 */   // Label 31490: @2296878
     /* 2296878 */   GIM_Try, /*On fail goto*//*Label 31491*/ GIMT_Encode4(2296935), // Rule ID 1658 //
     /* 2296883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2296886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296917 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2296920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2296930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296934 */     // GIR_Coverage, 1658,
     /* 2296934 */     GIR_EraseRootFromParent_Done,
     /* 2296935 */   // Label 31491: @2296935
     /* 2296935 */   GIM_Try, /*On fail goto*//*Label 31492*/ GIMT_Encode4(2296992), // Rule ID 1686 //
     /* 2296940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2296943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296974 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2296974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2296977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2296987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296991 */     // GIR_Coverage, 1686,
     /* 2296991 */     GIR_EraseRootFromParent_Done,
     /* 2296992 */   // Label 31492: @2296992
     /* 2296992 */   GIM_Try, /*On fail goto*//*Label 31493*/ GIMT_Encode4(2297049), // Rule ID 1687 //
     /* 2296997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2297000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2297024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297031 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2297031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2297034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2297044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297048 */     // GIR_Coverage, 1687,
     /* 2297048 */     GIR_EraseRootFromParent_Done,
     /* 2297049 */   // Label 31493: @2297049
     /* 2297049 */   GIM_Try, /*On fail goto*//*Label 31494*/ GIMT_Encode4(2297089), // Rule ID 1627 //
     /* 2297054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2297057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297073 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2297073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2297076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2297084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297088 */     // GIR_Coverage, 1627,
     /* 2297088 */     GIR_EraseRootFromParent_Done,
     /* 2297089 */   // Label 31494: @2297089
     /* 2297089 */   GIM_Try, /*On fail goto*//*Label 31495*/ GIMT_Encode4(2297129), // Rule ID 1628 //
     /* 2297094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2297097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2297113 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2297113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2297116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2297124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297128 */     // GIR_Coverage, 1628,
     /* 2297128 */     GIR_EraseRootFromParent_Done,
     /* 2297129 */   // Label 31495: @2297129
     /* 2297129 */   GIM_Try, /*On fail goto*//*Label 31496*/ GIMT_Encode4(2297169), // Rule ID 1656 //
     /* 2297134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2297137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2297153 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2297153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2297156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2297164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297168 */     // GIR_Coverage, 1656,
     /* 2297168 */     GIR_EraseRootFromParent_Done,
     /* 2297169 */   // Label 31496: @2297169
     /* 2297169 */   GIM_Try, /*On fail goto*//*Label 31497*/ GIMT_Encode4(2297209), // Rule ID 1682 //
     /* 2297174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2297177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297193 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2297193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2297196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2297204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297208 */     // GIR_Coverage, 1682,
     /* 2297208 */     GIR_EraseRootFromParent_Done,
     /* 2297209 */   // Label 31497: @2297209
     /* 2297209 */   GIM_Try, /*On fail goto*//*Label 31498*/ GIMT_Encode4(2297249), // Rule ID 1683 //
     /* 2297214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2297217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2297233 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2297233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2297236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2297244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297248 */     // GIR_Coverage, 1683,
     /* 2297248 */     GIR_EraseRootFromParent_Done,
     /* 2297249 */   // Label 31498: @2297249
     /* 2297249 */   GIM_Reject,
     /* 2297250 */ // Label 31468: @2297250
     /* 2297250 */ GIM_Reject,
     /* 2297251 */ // Label 31402: @2297251
     /* 2297251 */ GIM_Try, /*On fail goto*//*Label 31499*/ GIMT_Encode4(2298040),
     /* 2297256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2297262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2297265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297269 */   GIM_Try, /*On fail goto*//*Label 31500*/ GIMT_Encode4(2297346), // Rule ID 54830 //
     /* 2297274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297317 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2297320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297345 */     // GIR_Coverage, 54830,
     /* 2297345 */     GIR_EraseRootFromParent_Done,
     /* 2297346 */   // Label 31500: @2297346
     /* 2297346 */   GIM_Try, /*On fail goto*//*Label 31501*/ GIMT_Encode4(2297423), // Rule ID 54831 //
     /* 2297351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297394 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2297397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297422 */     // GIR_Coverage, 54831,
     /* 2297422 */     GIR_EraseRootFromParent_Done,
     /* 2297423 */   // Label 31501: @2297423
     /* 2297423 */   GIM_Try, /*On fail goto*//*Label 31502*/ GIMT_Encode4(2297500), // Rule ID 72162 //
     /* 2297428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297471 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2297474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297499 */     // GIR_Coverage, 72162,
     /* 2297499 */     GIR_EraseRootFromParent_Done,
     /* 2297500 */   // Label 31502: @2297500
     /* 2297500 */   GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2297577), // Rule ID 72163 //
     /* 2297505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297548 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2297551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297576 */     // GIR_Coverage, 72163,
     /* 2297576 */     GIR_EraseRootFromParent_Done,
     /* 2297577 */   // Label 31503: @2297577
     /* 2297577 */   GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2297639), // Rule ID 54834 //
     /* 2297582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297612 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2297615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297638 */     // GIR_Coverage, 54834,
     /* 2297638 */     GIR_EraseRootFromParent_Done,
     /* 2297639 */   // Label 31504: @2297639
     /* 2297639 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2297701), // Rule ID 54835 //
     /* 2297644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297674 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2297677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297700 */     // GIR_Coverage, 54835,
     /* 2297700 */     GIR_EraseRootFromParent_Done,
     /* 2297701 */   // Label 31505: @2297701
     /* 2297701 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2297763), // Rule ID 72166 //
     /* 2297706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297736 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2297739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297762 */     // GIR_Coverage, 72166,
     /* 2297762 */     GIR_EraseRootFromParent_Done,
     /* 2297763 */   // Label 31506: @2297763
     /* 2297763 */   GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2297825), // Rule ID 72167 //
     /* 2297768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297798 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2297801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297824 */     // GIR_Coverage, 72167,
     /* 2297824 */     GIR_EraseRootFromParent_Done,
     /* 2297825 */   // Label 31507: @2297825
     /* 2297825 */   GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2297887), // Rule ID 54826 //
     /* 2297830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297860 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2297863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297886 */     // GIR_Coverage, 54826,
     /* 2297886 */     GIR_EraseRootFromParent_Done,
     /* 2297887 */   // Label 31508: @2297887
     /* 2297887 */   GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2297949), // Rule ID 54827 //
     /* 2297892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2297915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297922 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2297925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297948 */     // GIR_Coverage, 54827,
     /* 2297948 */     GIR_EraseRootFromParent_Done,
     /* 2297949 */   // Label 31509: @2297949
     /* 2297949 */   GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2297994), // Rule ID 54822 //
     /* 2297954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297969 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2297972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297993 */     // GIR_Coverage, 54822,
     /* 2297993 */     GIR_EraseRootFromParent_Done,
     /* 2297994 */   // Label 31510: @2297994
     /* 2297994 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2298039), // Rule ID 54823 //
     /* 2297999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298014 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2298017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298038 */     // GIR_Coverage, 54823,
     /* 2298038 */     GIR_EraseRootFromParent_Done,
     /* 2298039 */   // Label 31511: @2298039
     /* 2298039 */   GIM_Reject,
     /* 2298040 */ // Label 31499: @2298040
     /* 2298040 */ GIM_Reject,
     /* 2298041 */ // Label 31403: @2298041
     /* 2298041 */ GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2298830),
     /* 2298046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2298052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2298055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298059 */   GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2298136), // Rule ID 54958 //
     /* 2298064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298107 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2298110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298135 */     // GIR_Coverage, 54958,
     /* 2298135 */     GIR_EraseRootFromParent_Done,
     /* 2298136 */   // Label 31513: @2298136
     /* 2298136 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2298213), // Rule ID 54959 //
     /* 2298141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298184 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2298187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298212 */     // GIR_Coverage, 54959,
     /* 2298212 */     GIR_EraseRootFromParent_Done,
     /* 2298213 */   // Label 31514: @2298213
     /* 2298213 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2298290), // Rule ID 72274 //
     /* 2298218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298261 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2298264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298289 */     // GIR_Coverage, 72274,
     /* 2298289 */     GIR_EraseRootFromParent_Done,
     /* 2298290 */   // Label 31515: @2298290
     /* 2298290 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2298367), // Rule ID 72275 //
     /* 2298295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298338 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2298341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298366 */     // GIR_Coverage, 72275,
     /* 2298366 */     GIR_EraseRootFromParent_Done,
     /* 2298367 */   // Label 31516: @2298367
     /* 2298367 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2298429), // Rule ID 54962 //
     /* 2298372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298402 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2298405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298428 */     // GIR_Coverage, 54962,
     /* 2298428 */     GIR_EraseRootFromParent_Done,
     /* 2298429 */   // Label 31517: @2298429
     /* 2298429 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2298491), // Rule ID 54963 //
     /* 2298434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298464 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2298467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298490 */     // GIR_Coverage, 54963,
     /* 2298490 */     GIR_EraseRootFromParent_Done,
     /* 2298491 */   // Label 31518: @2298491
     /* 2298491 */   GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2298553), // Rule ID 72278 //
     /* 2298496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298526 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2298529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298552 */     // GIR_Coverage, 72278,
     /* 2298552 */     GIR_EraseRootFromParent_Done,
     /* 2298553 */   // Label 31519: @2298553
     /* 2298553 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2298615), // Rule ID 72279 //
     /* 2298558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298588 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2298591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298614 */     // GIR_Coverage, 72279,
     /* 2298614 */     GIR_EraseRootFromParent_Done,
     /* 2298615 */   // Label 31520: @2298615
     /* 2298615 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2298677), // Rule ID 54954 //
     /* 2298620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298650 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2298653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298676 */     // GIR_Coverage, 54954,
     /* 2298676 */     GIR_EraseRootFromParent_Done,
     /* 2298677 */   // Label 31521: @2298677
     /* 2298677 */   GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2298739), // Rule ID 54955 //
     /* 2298682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2298705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298712 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2298715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298738 */     // GIR_Coverage, 54955,
     /* 2298738 */     GIR_EraseRootFromParent_Done,
     /* 2298739 */   // Label 31522: @2298739
     /* 2298739 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2298784), // Rule ID 54950 //
     /* 2298744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298759 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2298762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298783 */     // GIR_Coverage, 54950,
     /* 2298783 */     GIR_EraseRootFromParent_Done,
     /* 2298784 */   // Label 31523: @2298784
     /* 2298784 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2298829), // Rule ID 54951 //
     /* 2298789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298804 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2298807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298828 */     // GIR_Coverage, 54951,
     /* 2298828 */     GIR_EraseRootFromParent_Done,
     /* 2298829 */   // Label 31524: @2298829
     /* 2298829 */   GIM_Reject,
     /* 2298830 */ // Label 31512: @2298830
     /* 2298830 */ GIM_Reject,
     /* 2298831 */ // Label 31404: @2298831
     /* 2298831 */ GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2299620),
     /* 2298836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2298839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2298842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2298845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298849 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2298926), // Rule ID 55150 //
     /* 2298854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2298857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2298869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2298890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298897 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2298900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298925 */     // GIR_Coverage, 55150,
     /* 2298925 */     GIR_EraseRootFromParent_Done,
     /* 2298926 */   // Label 31526: @2298926
     /* 2298926 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2299003), // Rule ID 55151 //
     /* 2298931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2298934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2298946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2298967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298974 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2298977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299002 */     // GIR_Coverage, 55151,
     /* 2299002 */     GIR_EraseRootFromParent_Done,
     /* 2299003 */   // Label 31527: @2299003
     /* 2299003 */   GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2299080), // Rule ID 72442 //
     /* 2299008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299051 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2299054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299079 */     // GIR_Coverage, 72442,
     /* 2299079 */     GIR_EraseRootFromParent_Done,
     /* 2299080 */   // Label 31528: @2299080
     /* 2299080 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2299157), // Rule ID 72443 //
     /* 2299085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299128 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2299131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299156 */     // GIR_Coverage, 72443,
     /* 2299156 */     GIR_EraseRootFromParent_Done,
     /* 2299157 */   // Label 31529: @2299157
     /* 2299157 */   GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2299219), // Rule ID 55154 //
     /* 2299162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299192 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2299195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299218 */     // GIR_Coverage, 55154,
     /* 2299218 */     GIR_EraseRootFromParent_Done,
     /* 2299219 */   // Label 31530: @2299219
     /* 2299219 */   GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2299281), // Rule ID 55155 //
     /* 2299224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299254 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2299257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299280 */     // GIR_Coverage, 55155,
     /* 2299280 */     GIR_EraseRootFromParent_Done,
     /* 2299281 */   // Label 31531: @2299281
     /* 2299281 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2299343), // Rule ID 72446 //
     /* 2299286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299316 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2299319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299342 */     // GIR_Coverage, 72446,
     /* 2299342 */     GIR_EraseRootFromParent_Done,
     /* 2299343 */   // Label 31532: @2299343
     /* 2299343 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2299405), // Rule ID 72447 //
     /* 2299348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299378 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2299381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299404 */     // GIR_Coverage, 72447,
     /* 2299404 */     GIR_EraseRootFromParent_Done,
     /* 2299405 */   // Label 31533: @2299405
     /* 2299405 */   GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2299467), // Rule ID 55146 //
     /* 2299410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299440 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2299443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299466 */     // GIR_Coverage, 55146,
     /* 2299466 */     GIR_EraseRootFromParent_Done,
     /* 2299467 */   // Label 31534: @2299467
     /* 2299467 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2299529), // Rule ID 55147 //
     /* 2299472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299502 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2299505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299528 */     // GIR_Coverage, 55147,
     /* 2299528 */     GIR_EraseRootFromParent_Done,
     /* 2299529 */   // Label 31535: @2299529
     /* 2299529 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2299574), // Rule ID 55142 //
     /* 2299534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299549 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2299552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299573 */     // GIR_Coverage, 55142,
     /* 2299573 */     GIR_EraseRootFromParent_Done,
     /* 2299574 */   // Label 31536: @2299574
     /* 2299574 */   GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2299619), // Rule ID 55143 //
     /* 2299579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299594 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2299597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299618 */     // GIR_Coverage, 55143,
     /* 2299618 */     GIR_EraseRootFromParent_Done,
     /* 2299619 */   // Label 31537: @2299619
     /* 2299619 */   GIM_Reject,
     /* 2299620 */ // Label 31525: @2299620
     /* 2299620 */ GIM_Reject,
     /* 2299621 */ // Label 31405: @2299621
     /* 2299621 */ GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2300410),
     /* 2299626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2299632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2299635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299639 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2299716), // Rule ID 54894 //
     /* 2299644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299687 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2299690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299715 */     // GIR_Coverage, 54894,
     /* 2299715 */     GIR_EraseRootFromParent_Done,
     /* 2299716 */   // Label 31539: @2299716
     /* 2299716 */   GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2299793), // Rule ID 54895 //
     /* 2299721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299764 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2299767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299792 */     // GIR_Coverage, 54895,
     /* 2299792 */     GIR_EraseRootFromParent_Done,
     /* 2299793 */   // Label 31540: @2299793
     /* 2299793 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2299870), // Rule ID 72218 //
     /* 2299798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299841 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2299844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299869 */     // GIR_Coverage, 72218,
     /* 2299869 */     GIR_EraseRootFromParent_Done,
     /* 2299870 */   // Label 31541: @2299870
     /* 2299870 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2299947), // Rule ID 72219 //
     /* 2299875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299918 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2299921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299946 */     // GIR_Coverage, 72219,
     /* 2299946 */     GIR_EraseRootFromParent_Done,
     /* 2299947 */   // Label 31542: @2299947
     /* 2299947 */   GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2300009), // Rule ID 54898 //
     /* 2299952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299982 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2299985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300008 */     // GIR_Coverage, 54898,
     /* 2300008 */     GIR_EraseRootFromParent_Done,
     /* 2300009 */   // Label 31543: @2300009
     /* 2300009 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2300071), // Rule ID 54899 //
     /* 2300014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300044 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2300047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300070 */     // GIR_Coverage, 54899,
     /* 2300070 */     GIR_EraseRootFromParent_Done,
     /* 2300071 */   // Label 31544: @2300071
     /* 2300071 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2300133), // Rule ID 72222 //
     /* 2300076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300106 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2300109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300132 */     // GIR_Coverage, 72222,
     /* 2300132 */     GIR_EraseRootFromParent_Done,
     /* 2300133 */   // Label 31545: @2300133
     /* 2300133 */   GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2300195), // Rule ID 72223 //
     /* 2300138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300168 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2300171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300194 */     // GIR_Coverage, 72223,
     /* 2300194 */     GIR_EraseRootFromParent_Done,
     /* 2300195 */   // Label 31546: @2300195
     /* 2300195 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2300257), // Rule ID 54890 //
     /* 2300200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2300215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300230 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2300233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2300243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300256 */     // GIR_Coverage, 54890,
     /* 2300256 */     GIR_EraseRootFromParent_Done,
     /* 2300257 */   // Label 31547: @2300257
     /* 2300257 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2300319), // Rule ID 54891 //
     /* 2300262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2300277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2300285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300292 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2300295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2300305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300318 */     // GIR_Coverage, 54891,
     /* 2300318 */     GIR_EraseRootFromParent_Done,
     /* 2300319 */   // Label 31548: @2300319
     /* 2300319 */   GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2300364), // Rule ID 54886 //
     /* 2300324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300339 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2300342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300363 */     // GIR_Coverage, 54886,
     /* 2300363 */     GIR_EraseRootFromParent_Done,
     /* 2300364 */   // Label 31549: @2300364
     /* 2300364 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2300409), // Rule ID 54887 //
     /* 2300369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300384 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2300387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300408 */     // GIR_Coverage, 54887,
     /* 2300408 */     GIR_EraseRootFromParent_Done,
     /* 2300409 */   // Label 31550: @2300409
     /* 2300409 */   GIM_Reject,
     /* 2300410 */ // Label 31538: @2300410
     /* 2300410 */ GIM_Reject,
     /* 2300411 */ // Label 31406: @2300411
     /* 2300411 */ GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2301200),
     /* 2300416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2300422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2300425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300429 */   GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2300506), // Rule ID 55086 //
     /* 2300434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300477 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2300480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300505 */     // GIR_Coverage, 55086,
     /* 2300505 */     GIR_EraseRootFromParent_Done,
     /* 2300506 */   // Label 31552: @2300506
     /* 2300506 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2300583), // Rule ID 55087 //
     /* 2300511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300554 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2300557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300582 */     // GIR_Coverage, 55087,
     /* 2300582 */     GIR_EraseRootFromParent_Done,
     /* 2300583 */   // Label 31553: @2300583
     /* 2300583 */   GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2300660), // Rule ID 72386 //
     /* 2300588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300631 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2300634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300659 */     // GIR_Coverage, 72386,
     /* 2300659 */     GIR_EraseRootFromParent_Done,
     /* 2300660 */   // Label 31554: @2300660
     /* 2300660 */   GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2300737), // Rule ID 72387 //
     /* 2300665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300708 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2300711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300736 */     // GIR_Coverage, 72387,
     /* 2300736 */     GIR_EraseRootFromParent_Done,
     /* 2300737 */   // Label 31555: @2300737
     /* 2300737 */   GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2300799), // Rule ID 55090 //
     /* 2300742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300772 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2300775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300798 */     // GIR_Coverage, 55090,
     /* 2300798 */     GIR_EraseRootFromParent_Done,
     /* 2300799 */   // Label 31556: @2300799
     /* 2300799 */   GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2300861), // Rule ID 55091 //
     /* 2300804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300834 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2300837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300860 */     // GIR_Coverage, 55091,
     /* 2300860 */     GIR_EraseRootFromParent_Done,
     /* 2300861 */   // Label 31557: @2300861
     /* 2300861 */   GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2300923), // Rule ID 72390 //
     /* 2300866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300896 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2300899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300922 */     // GIR_Coverage, 72390,
     /* 2300922 */     GIR_EraseRootFromParent_Done,
     /* 2300923 */   // Label 31558: @2300923
     /* 2300923 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2300985), // Rule ID 72391 //
     /* 2300928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2300947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300958 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2300961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300984 */     // GIR_Coverage, 72391,
     /* 2300984 */     GIR_EraseRootFromParent_Done,
     /* 2300985 */   // Label 31559: @2300985
     /* 2300985 */   GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2301047), // Rule ID 55082 //
     /* 2300990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2300997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2301013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301020 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2301023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301046 */     // GIR_Coverage, 55082,
     /* 2301046 */     GIR_EraseRootFromParent_Done,
     /* 2301047 */   // Label 31560: @2301047
     /* 2301047 */   GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2301109), // Rule ID 55083 //
     /* 2301052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2301075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301082 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2301085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301108 */     // GIR_Coverage, 55083,
     /* 2301108 */     GIR_EraseRootFromParent_Done,
     /* 2301109 */   // Label 31561: @2301109
     /* 2301109 */   GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2301154), // Rule ID 55078 //
     /* 2301114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301129 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2301132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301153 */     // GIR_Coverage, 55078,
     /* 2301153 */     GIR_EraseRootFromParent_Done,
     /* 2301154 */   // Label 31562: @2301154
     /* 2301154 */   GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2301199), // Rule ID 55079 //
     /* 2301159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301174 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2301177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301198 */     // GIR_Coverage, 55079,
     /* 2301198 */     GIR_EraseRootFromParent_Done,
     /* 2301199 */   // Label 31563: @2301199
     /* 2301199 */   GIM_Reject,
     /* 2301200 */ // Label 31551: @2301200
     /* 2301200 */ GIM_Reject,
     /* 2301201 */ // Label 31407: @2301201
     /* 2301201 */ GIM_Try, /*On fail goto*//*Label 31564*/ GIMT_Encode4(2301990),
     /* 2301206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2301212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2301215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301219 */   GIM_Try, /*On fail goto*//*Label 31565*/ GIMT_Encode4(2301296), // Rule ID 55598 //
     /* 2301224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301267 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2301270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301295 */     // GIR_Coverage, 55598,
     /* 2301295 */     GIR_EraseRootFromParent_Done,
     /* 2301296 */   // Label 31565: @2301296
     /* 2301296 */   GIM_Try, /*On fail goto*//*Label 31566*/ GIMT_Encode4(2301373), // Rule ID 55599 //
     /* 2301301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301344 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2301347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301372 */     // GIR_Coverage, 55599,
     /* 2301372 */     GIR_EraseRootFromParent_Done,
     /* 2301373 */   // Label 31566: @2301373
     /* 2301373 */   GIM_Try, /*On fail goto*//*Label 31567*/ GIMT_Encode4(2301450), // Rule ID 72834 //
     /* 2301378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301421 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2301424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301449 */     // GIR_Coverage, 72834,
     /* 2301449 */     GIR_EraseRootFromParent_Done,
     /* 2301450 */   // Label 31567: @2301450
     /* 2301450 */   GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2301527), // Rule ID 72835 //
     /* 2301455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301498 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2301501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301526 */     // GIR_Coverage, 72835,
     /* 2301526 */     GIR_EraseRootFromParent_Done,
     /* 2301527 */   // Label 31568: @2301527
     /* 2301527 */   GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2301589), // Rule ID 55602 //
     /* 2301532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301562 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2301565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301588 */     // GIR_Coverage, 55602,
     /* 2301588 */     GIR_EraseRootFromParent_Done,
     /* 2301589 */   // Label 31569: @2301589
     /* 2301589 */   GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2301651), // Rule ID 55603 //
     /* 2301594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301624 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2301627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301650 */     // GIR_Coverage, 55603,
     /* 2301650 */     GIR_EraseRootFromParent_Done,
     /* 2301651 */   // Label 31570: @2301651
     /* 2301651 */   GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2301713), // Rule ID 72838 //
     /* 2301656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301686 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2301689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301712 */     // GIR_Coverage, 72838,
     /* 2301712 */     GIR_EraseRootFromParent_Done,
     /* 2301713 */   // Label 31571: @2301713
     /* 2301713 */   GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2301775), // Rule ID 72839 //
     /* 2301718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301748 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2301751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301774 */     // GIR_Coverage, 72839,
     /* 2301774 */     GIR_EraseRootFromParent_Done,
     /* 2301775 */   // Label 31572: @2301775
     /* 2301775 */   GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2301837), // Rule ID 55594 //
     /* 2301780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301810 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2301813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301836 */     // GIR_Coverage, 55594,
     /* 2301836 */     GIR_EraseRootFromParent_Done,
     /* 2301837 */   // Label 31573: @2301837
     /* 2301837 */   GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2301899), // Rule ID 55595 //
     /* 2301842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2301865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301872 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2301875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301898 */     // GIR_Coverage, 55595,
     /* 2301898 */     GIR_EraseRootFromParent_Done,
     /* 2301899 */   // Label 31574: @2301899
     /* 2301899 */   GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2301944), // Rule ID 55590 //
     /* 2301904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301919 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2301922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301943 */     // GIR_Coverage, 55590,
     /* 2301943 */     GIR_EraseRootFromParent_Done,
     /* 2301944 */   // Label 31575: @2301944
     /* 2301944 */   GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2301989), // Rule ID 55591 //
     /* 2301949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2301964 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2301967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301988 */     // GIR_Coverage, 55591,
     /* 2301988 */     GIR_EraseRootFromParent_Done,
     /* 2301989 */   // Label 31576: @2301989
     /* 2301989 */   GIM_Reject,
     /* 2301990 */ // Label 31564: @2301990
     /* 2301990 */ GIM_Reject,
     /* 2301991 */ // Label 31408: @2301991
     /* 2301991 */ GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2302780),
     /* 2301996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2301999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2302002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2302005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302009 */   GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2302086), // Rule ID 55022 //
     /* 2302014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302057 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2302060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302085 */     // GIR_Coverage, 55022,
     /* 2302085 */     GIR_EraseRootFromParent_Done,
     /* 2302086 */   // Label 31578: @2302086
     /* 2302086 */   GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2302163), // Rule ID 55023 //
     /* 2302091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302134 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2302137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302162 */     // GIR_Coverage, 55023,
     /* 2302162 */     GIR_EraseRootFromParent_Done,
     /* 2302163 */   // Label 31579: @2302163
     /* 2302163 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2302240), // Rule ID 72330 //
     /* 2302168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302211 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2302214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302239 */     // GIR_Coverage, 72330,
     /* 2302239 */     GIR_EraseRootFromParent_Done,
     /* 2302240 */   // Label 31580: @2302240
     /* 2302240 */   GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2302317), // Rule ID 72331 //
     /* 2302245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302288 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2302291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302316 */     // GIR_Coverage, 72331,
     /* 2302316 */     GIR_EraseRootFromParent_Done,
     /* 2302317 */   // Label 31581: @2302317
     /* 2302317 */   GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2302379), // Rule ID 55026 //
     /* 2302322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302352 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2302355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302378 */     // GIR_Coverage, 55026,
     /* 2302378 */     GIR_EraseRootFromParent_Done,
     /* 2302379 */   // Label 31582: @2302379
     /* 2302379 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2302441), // Rule ID 55027 //
     /* 2302384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302414 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2302417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302440 */     // GIR_Coverage, 55027,
     /* 2302440 */     GIR_EraseRootFromParent_Done,
     /* 2302441 */   // Label 31583: @2302441
     /* 2302441 */   GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2302503), // Rule ID 72334 //
     /* 2302446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302476 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2302479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302502 */     // GIR_Coverage, 72334,
     /* 2302502 */     GIR_EraseRootFromParent_Done,
     /* 2302503 */   // Label 31584: @2302503
     /* 2302503 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2302565), // Rule ID 72335 //
     /* 2302508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302538 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2302541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302564 */     // GIR_Coverage, 72335,
     /* 2302564 */     GIR_EraseRootFromParent_Done,
     /* 2302565 */   // Label 31585: @2302565
     /* 2302565 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2302627), // Rule ID 55018 //
     /* 2302570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2302585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302600 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2302603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2302613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302626 */     // GIR_Coverage, 55018,
     /* 2302626 */     GIR_EraseRootFromParent_Done,
     /* 2302627 */   // Label 31586: @2302627
     /* 2302627 */   GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2302689), // Rule ID 55019 //
     /* 2302632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2302647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302662 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2302665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2302675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302688 */     // GIR_Coverage, 55019,
     /* 2302688 */     GIR_EraseRootFromParent_Done,
     /* 2302689 */   // Label 31587: @2302689
     /* 2302689 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2302734), // Rule ID 55014 //
     /* 2302694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302709 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2302712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302733 */     // GIR_Coverage, 55014,
     /* 2302733 */     GIR_EraseRootFromParent_Done,
     /* 2302734 */   // Label 31588: @2302734
     /* 2302734 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2302779), // Rule ID 55015 //
     /* 2302739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302754 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2302757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302778 */     // GIR_Coverage, 55015,
     /* 2302778 */     GIR_EraseRootFromParent_Done,
     /* 2302779 */   // Label 31589: @2302779
     /* 2302779 */   GIM_Reject,
     /* 2302780 */ // Label 31577: @2302780
     /* 2302780 */ GIM_Reject,
     /* 2302781 */ // Label 31409: @2302781
     /* 2302781 */ GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2303570),
     /* 2302786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2302792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2302795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302799 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2302876), // Rule ID 55406 //
     /* 2302804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302847 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2302850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302875 */     // GIR_Coverage, 55406,
     /* 2302875 */     GIR_EraseRootFromParent_Done,
     /* 2302876 */   // Label 31591: @2302876
     /* 2302876 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2302953), // Rule ID 55407 //
     /* 2302881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302924 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2302927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302952 */     // GIR_Coverage, 55407,
     /* 2302952 */     GIR_EraseRootFromParent_Done,
     /* 2302953 */   // Label 31592: @2302953
     /* 2302953 */   GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2303030), // Rule ID 72666 //
     /* 2302958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303001 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2303004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303029 */     // GIR_Coverage, 72666,
     /* 2303029 */     GIR_EraseRootFromParent_Done,
     /* 2303030 */   // Label 31593: @2303030
     /* 2303030 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2303107), // Rule ID 72667 //
     /* 2303035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303078 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2303081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303106 */     // GIR_Coverage, 72667,
     /* 2303106 */     GIR_EraseRootFromParent_Done,
     /* 2303107 */   // Label 31594: @2303107
     /* 2303107 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2303169), // Rule ID 55410 //
     /* 2303112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303142 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2303145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303168 */     // GIR_Coverage, 55410,
     /* 2303168 */     GIR_EraseRootFromParent_Done,
     /* 2303169 */   // Label 31595: @2303169
     /* 2303169 */   GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2303231), // Rule ID 55411 //
     /* 2303174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303204 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2303207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303230 */     // GIR_Coverage, 55411,
     /* 2303230 */     GIR_EraseRootFromParent_Done,
     /* 2303231 */   // Label 31596: @2303231
     /* 2303231 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2303293), // Rule ID 72670 //
     /* 2303236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303266 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2303269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303292 */     // GIR_Coverage, 72670,
     /* 2303292 */     GIR_EraseRootFromParent_Done,
     /* 2303293 */   // Label 31597: @2303293
     /* 2303293 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2303355), // Rule ID 72671 //
     /* 2303298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303328 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2303331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303354 */     // GIR_Coverage, 72671,
     /* 2303354 */     GIR_EraseRootFromParent_Done,
     /* 2303355 */   // Label 31598: @2303355
     /* 2303355 */   GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2303417), // Rule ID 55402 //
     /* 2303360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303390 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2303393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303416 */     // GIR_Coverage, 55402,
     /* 2303416 */     GIR_EraseRootFromParent_Done,
     /* 2303417 */   // Label 31599: @2303417
     /* 2303417 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2303479), // Rule ID 55403 //
     /* 2303422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2303445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303452 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2303455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303478 */     // GIR_Coverage, 55403,
     /* 2303478 */     GIR_EraseRootFromParent_Done,
     /* 2303479 */   // Label 31600: @2303479
     /* 2303479 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2303524), // Rule ID 55398 //
     /* 2303484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303499 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2303502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303523 */     // GIR_Coverage, 55398,
     /* 2303523 */     GIR_EraseRootFromParent_Done,
     /* 2303524 */   // Label 31601: @2303524
     /* 2303524 */   GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2303569), // Rule ID 55399 //
     /* 2303529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2303544 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2303547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303568 */     // GIR_Coverage, 55399,
     /* 2303568 */     GIR_EraseRootFromParent_Done,
     /* 2303569 */   // Label 31602: @2303569
     /* 2303569 */   GIM_Reject,
     /* 2303570 */ // Label 31590: @2303570
     /* 2303570 */ GIM_Reject,
     /* 2303571 */ // Label 31410: @2303571
     /* 2303571 */ GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2304360),
     /* 2303576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2303582 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2303585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303589 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2303666), // Rule ID 55662 //
     /* 2303594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303637 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2303640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303665 */     // GIR_Coverage, 55662,
     /* 2303665 */     GIR_EraseRootFromParent_Done,
     /* 2303666 */   // Label 31604: @2303666
     /* 2303666 */   GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2303743), // Rule ID 55663 //
     /* 2303671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303714 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2303717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303742 */     // GIR_Coverage, 55663,
     /* 2303742 */     GIR_EraseRootFromParent_Done,
     /* 2303743 */   // Label 31605: @2303743
     /* 2303743 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2303820), // Rule ID 72890 //
     /* 2303748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303791 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2303794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303819 */     // GIR_Coverage, 72890,
     /* 2303819 */     GIR_EraseRootFromParent_Done,
     /* 2303820 */   // Label 31606: @2303820
     /* 2303820 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2303897), // Rule ID 72891 //
     /* 2303825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303868 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2303871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303896 */     // GIR_Coverage, 72891,
     /* 2303896 */     GIR_EraseRootFromParent_Done,
     /* 2303897 */   // Label 31607: @2303897
     /* 2303897 */   GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2303959), // Rule ID 55666 //
     /* 2303902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2303905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303932 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2303935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303958 */     // GIR_Coverage, 55666,
     /* 2303958 */     GIR_EraseRootFromParent_Done,
     /* 2303959 */   // Label 31608: @2303959
     /* 2303959 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2304021), // Rule ID 55667 //
     /* 2303964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2303979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303994 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2303997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304020 */     // GIR_Coverage, 55667,
     /* 2304020 */     GIR_EraseRootFromParent_Done,
     /* 2304021 */   // Label 31609: @2304021
     /* 2304021 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2304083), // Rule ID 72894 //
     /* 2304026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2304045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304056 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2304059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304082 */     // GIR_Coverage, 72894,
     /* 2304082 */     GIR_EraseRootFromParent_Done,
     /* 2304083 */   // Label 31610: @2304083
     /* 2304083 */   GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2304145), // Rule ID 72895 //
     /* 2304088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2304107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304118 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2304121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304144 */     // GIR_Coverage, 72895,
     /* 2304144 */     GIR_EraseRootFromParent_Done,
     /* 2304145 */   // Label 31611: @2304145
     /* 2304145 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2304207), // Rule ID 55658 //
     /* 2304150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2304173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304180 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2304183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2304193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304206 */     // GIR_Coverage, 55658,
     /* 2304206 */     GIR_EraseRootFromParent_Done,
     /* 2304207 */   // Label 31612: @2304207
     /* 2304207 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2304269), // Rule ID 55659 //
     /* 2304212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2304235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304242 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2304245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2304255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304268 */     // GIR_Coverage, 55659,
     /* 2304268 */     GIR_EraseRootFromParent_Done,
     /* 2304269 */   // Label 31613: @2304269
     /* 2304269 */   GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2304314), // Rule ID 55654 //
     /* 2304274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2304277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304289 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2304292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304313 */     // GIR_Coverage, 55654,
     /* 2304313 */     GIR_EraseRootFromParent_Done,
     /* 2304314 */   // Label 31614: @2304314
     /* 2304314 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2304359), // Rule ID 55655 //
     /* 2304319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2304322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2304334 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2304337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2304354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304358 */     // GIR_Coverage, 55655,
     /* 2304358 */     GIR_EraseRootFromParent_Done,
     /* 2304359 */   // Label 31615: @2304359
     /* 2304359 */   GIM_Reject,
     /* 2304360 */ // Label 31603: @2304360
     /* 2304360 */ GIM_Reject,
     /* 2304361 */ // Label 31411: @2304361
     /* 2304361 */ GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2305150),
     /* 2304366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2304372 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2304375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304379 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2304456), // Rule ID 55214 //
     /* 2304384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304427 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2304430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304455 */     // GIR_Coverage, 55214,
     /* 2304455 */     GIR_EraseRootFromParent_Done,
     /* 2304456 */   // Label 31617: @2304456
     /* 2304456 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2304533), // Rule ID 55215 //
     /* 2304461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304504 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2304507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304532 */     // GIR_Coverage, 55215,
     /* 2304532 */     GIR_EraseRootFromParent_Done,
     /* 2304533 */   // Label 31618: @2304533
     /* 2304533 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2304610), // Rule ID 72498 //
     /* 2304538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304581 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2304584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304609 */     // GIR_Coverage, 72498,
     /* 2304609 */     GIR_EraseRootFromParent_Done,
     /* 2304610 */   // Label 31619: @2304610
     /* 2304610 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2304687), // Rule ID 72499 //
     /* 2304615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304658 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2304661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304686 */     // GIR_Coverage, 72499,
     /* 2304686 */     GIR_EraseRootFromParent_Done,
     /* 2304687 */   // Label 31620: @2304687
     /* 2304687 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2304749), // Rule ID 55218 //
     /* 2304692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304722 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2304725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304748 */     // GIR_Coverage, 55218,
     /* 2304748 */     GIR_EraseRootFromParent_Done,
     /* 2304749 */   // Label 31621: @2304749
     /* 2304749 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2304811), // Rule ID 55219 //
     /* 2304754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304784 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2304787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304810 */     // GIR_Coverage, 55219,
     /* 2304810 */     GIR_EraseRootFromParent_Done,
     /* 2304811 */   // Label 31622: @2304811
     /* 2304811 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2304873), // Rule ID 72502 //
     /* 2304816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304846 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2304849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304872 */     // GIR_Coverage, 72502,
     /* 2304872 */     GIR_EraseRootFromParent_Done,
     /* 2304873 */   // Label 31623: @2304873
     /* 2304873 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2304935), // Rule ID 72503 //
     /* 2304878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304908 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2304911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304934 */     // GIR_Coverage, 72503,
     /* 2304934 */     GIR_EraseRootFromParent_Done,
     /* 2304935 */   // Label 31624: @2304935
     /* 2304935 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2304997), // Rule ID 55210 //
     /* 2304940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2304963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2304968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304970 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2304973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2304983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304996 */     // GIR_Coverage, 55210,
     /* 2304996 */     GIR_EraseRootFromParent_Done,
     /* 2304997 */   // Label 31625: @2304997
     /* 2304997 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2305059), // Rule ID 55211 //
     /* 2305002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2305025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305032 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2305035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2305045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305058 */     // GIR_Coverage, 55211,
     /* 2305058 */     GIR_EraseRootFromParent_Done,
     /* 2305059 */   // Label 31626: @2305059
     /* 2305059 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2305104), // Rule ID 55206 //
     /* 2305064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305079 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2305082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305103 */     // GIR_Coverage, 55206,
     /* 2305103 */     GIR_EraseRootFromParent_Done,
     /* 2305104 */   // Label 31627: @2305104
     /* 2305104 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2305149), // Rule ID 55207 //
     /* 2305109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2305124 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2305127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305148 */     // GIR_Coverage, 55207,
     /* 2305148 */     GIR_EraseRootFromParent_Done,
     /* 2305149 */   // Label 31628: @2305149
     /* 2305149 */   GIM_Reject,
     /* 2305150 */ // Label 31616: @2305150
     /* 2305150 */ GIM_Reject,
     /* 2305151 */ // Label 31412: @2305151
     /* 2305151 */ GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2305940),
     /* 2305156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2305162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2305165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305169 */   GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2305246), // Rule ID 55470 //
     /* 2305174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305217 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2305220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2305232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305245 */     // GIR_Coverage, 55470,
     /* 2305245 */     GIR_EraseRootFromParent_Done,
     /* 2305246 */   // Label 31630: @2305246
     /* 2305246 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2305323), // Rule ID 55471 //
     /* 2305251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305294 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2305297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2305309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305322 */     // GIR_Coverage, 55471,
     /* 2305322 */     GIR_EraseRootFromParent_Done,
     /* 2305323 */   // Label 31631: @2305323
     /* 2305323 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2305400), // Rule ID 72722 //
     /* 2305328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305371 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2305374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2305378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2305386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305399 */     // GIR_Coverage, 72722,
     /* 2305399 */     GIR_EraseRootFromParent_Done,
     /* 2305400 */   // Label 31632: @2305400
     /* 2305400 */   GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2305477), // Rule ID 72723 //
     /* 2305405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305448 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2305451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2305455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2305463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305476 */     // GIR_Coverage, 72723,
     /* 2305476 */     GIR_EraseRootFromParent_Done,
     /* 2305477 */   // Label 31633: @2305477
     /* 2305477 */   GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2305539), // Rule ID 55474 //
     /* 2305482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305512 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2305515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305538 */     // GIR_Coverage, 55474,
     /* 2305538 */     GIR_EraseRootFromParent_Done,
     /* 2305539 */   // Label 31634: @2305539
     /* 2305539 */   GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2305601), // Rule ID 55475 //
     /* 2305544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305574 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2305577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305600 */     // GIR_Coverage, 55475,
     /* 2305600 */     GIR_EraseRootFromParent_Done,
     /* 2305601 */   // Label 31635: @2305601
     /* 2305601 */   GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2305663), // Rule ID 72726 //
     /* 2305606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305636 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2305639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2305643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305662 */     // GIR_Coverage, 72726,
     /* 2305662 */     GIR_EraseRootFromParent_Done,
     /* 2305663 */   // Label 31636: @2305663
     /* 2305663 */   GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2305725), // Rule ID 72727 //
     /* 2305668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305698 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2305701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2305705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305724 */     // GIR_Coverage, 72727,
     /* 2305724 */     GIR_EraseRootFromParent_Done,
     /* 2305725 */   // Label 31637: @2305725
     /* 2305725 */   GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2305787), // Rule ID 55466 //
     /* 2305730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305760 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2305763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2305773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305786 */     // GIR_Coverage, 55466,
     /* 2305786 */     GIR_EraseRootFromParent_Done,
     /* 2305787 */   // Label 31638: @2305787
     /* 2305787 */   GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2305849), // Rule ID 55467 //
     /* 2305792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2305807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2305815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305822 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2305825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2305835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305848 */     // GIR_Coverage, 55467,
     /* 2305848 */     GIR_EraseRootFromParent_Done,
     /* 2305849 */   // Label 31639: @2305849
     /* 2305849 */   GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2305894), // Rule ID 55462 //
     /* 2305854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305869 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2305869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2305872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305893 */     // GIR_Coverage, 55462,
     /* 2305893 */     GIR_EraseRootFromParent_Done,
     /* 2305894 */   // Label 31640: @2305894
     /* 2305894 */   GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2305939), // Rule ID 55463 //
     /* 2305899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2305914 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2305914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2305917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2305921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2305925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2305937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305938 */     // GIR_Coverage, 55463,
     /* 2305938 */     GIR_EraseRootFromParent_Done,
     /* 2305939 */   // Label 31641: @2305939
     /* 2305939 */   GIM_Reject,
     /* 2305940 */ // Label 31629: @2305940
     /* 2305940 */ GIM_Reject,
     /* 2305941 */ // Label 31413: @2305941
     /* 2305941 */ GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2306730),
     /* 2305946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2305949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2305952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2305955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305959 */   GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2306036), // Rule ID 55726 //
     /* 2305964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2305979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2305988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306007 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2306010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306035 */     // GIR_Coverage, 55726,
     /* 2306035 */     GIR_EraseRootFromParent_Done,
     /* 2306036 */   // Label 31643: @2306036
     /* 2306036 */   GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2306113), // Rule ID 55727 //
     /* 2306041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306084 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2306087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306112 */     // GIR_Coverage, 55727,
     /* 2306112 */     GIR_EraseRootFromParent_Done,
     /* 2306113 */   // Label 31644: @2306113
     /* 2306113 */   GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2306190), // Rule ID 72946 //
     /* 2306118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306161 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2306164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2306168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306189 */     // GIR_Coverage, 72946,
     /* 2306189 */     GIR_EraseRootFromParent_Done,
     /* 2306190 */   // Label 31645: @2306190
     /* 2306190 */   GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2306267), // Rule ID 72947 //
     /* 2306195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306238 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2306241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2306245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306266 */     // GIR_Coverage, 72947,
     /* 2306266 */     GIR_EraseRootFromParent_Done,
     /* 2306267 */   // Label 31646: @2306267
     /* 2306267 */   GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2306329), // Rule ID 55730 //
     /* 2306272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306302 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2306305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306328 */     // GIR_Coverage, 55730,
     /* 2306328 */     GIR_EraseRootFromParent_Done,
     /* 2306329 */   // Label 31647: @2306329
     /* 2306329 */   GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2306391), // Rule ID 55731 //
     /* 2306334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306364 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2306367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306390 */     // GIR_Coverage, 55731,
     /* 2306390 */     GIR_EraseRootFromParent_Done,
     /* 2306391 */   // Label 31648: @2306391
     /* 2306391 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2306453), // Rule ID 72950 //
     /* 2306396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306426 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2306429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2306433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306452 */     // GIR_Coverage, 72950,
     /* 2306452 */     GIR_EraseRootFromParent_Done,
     /* 2306453 */   // Label 31649: @2306453
     /* 2306453 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2306515), // Rule ID 72951 //
     /* 2306458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306488 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2306491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2306495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306514 */     // GIR_Coverage, 72951,
     /* 2306514 */     GIR_EraseRootFromParent_Done,
     /* 2306515 */   // Label 31650: @2306515
     /* 2306515 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2306577), // Rule ID 55722 //
     /* 2306520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306550 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2306553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2306563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306576 */     // GIR_Coverage, 55722,
     /* 2306576 */     GIR_EraseRootFromParent_Done,
     /* 2306577 */   // Label 31651: @2306577
     /* 2306577 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2306639), // Rule ID 55723 //
     /* 2306582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306612 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2306615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2306625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306638 */     // GIR_Coverage, 55723,
     /* 2306638 */     GIR_EraseRootFromParent_Done,
     /* 2306639 */   // Label 31652: @2306639
     /* 2306639 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2306684), // Rule ID 55718 //
     /* 2306644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306659 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2306662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306683 */     // GIR_Coverage, 55718,
     /* 2306683 */     GIR_EraseRootFromParent_Done,
     /* 2306684 */   // Label 31653: @2306684
     /* 2306684 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2306729), // Rule ID 55719 //
     /* 2306689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306704 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2306707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2306715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306728 */     // GIR_Coverage, 55719,
     /* 2306728 */     GIR_EraseRootFromParent_Done,
     /* 2306729 */   // Label 31654: @2306729
     /* 2306729 */   GIM_Reject,
     /* 2306730 */ // Label 31642: @2306730
     /* 2306730 */ GIM_Reject,
     /* 2306731 */ // Label 31414: @2306731
     /* 2306731 */ GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2307520),
     /* 2306736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2306742 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2306745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306749 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2306826), // Rule ID 55278 //
     /* 2306754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306797 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2306800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306825 */     // GIR_Coverage, 55278,
     /* 2306825 */     GIR_EraseRootFromParent_Done,
     /* 2306826 */   // Label 31656: @2306826
     /* 2306826 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2306903), // Rule ID 55279 //
     /* 2306831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306874 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2306874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2306877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2306881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306902 */     // GIR_Coverage, 55279,
     /* 2306902 */     GIR_EraseRootFromParent_Done,
     /* 2306903 */   // Label 31657: @2306903
     /* 2306903 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2306980), // Rule ID 72554 //
     /* 2306908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306951 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2306951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2306954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2306958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2306966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2306978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306979 */     // GIR_Coverage, 72554,
     /* 2306979 */     GIR_EraseRootFromParent_Done,
     /* 2306980 */   // Label 31658: @2306980
     /* 2306980 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2307057), // Rule ID 72555 //
     /* 2306985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307028 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2307031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2307043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307056 */     // GIR_Coverage, 72555,
     /* 2307056 */     GIR_EraseRootFromParent_Done,
     /* 2307057 */   // Label 31659: @2307057
     /* 2307057 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2307119), // Rule ID 55282 //
     /* 2307062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307092 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2307095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307118 */     // GIR_Coverage, 55282,
     /* 2307118 */     GIR_EraseRootFromParent_Done,
     /* 2307119 */   // Label 31660: @2307119
     /* 2307119 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2307181), // Rule ID 55283 //
     /* 2307124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307154 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2307157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307180 */     // GIR_Coverage, 55283,
     /* 2307180 */     GIR_EraseRootFromParent_Done,
     /* 2307181 */   // Label 31661: @2307181
     /* 2307181 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2307243), // Rule ID 72558 //
     /* 2307186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307216 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2307219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307242 */     // GIR_Coverage, 72558,
     /* 2307242 */     GIR_EraseRootFromParent_Done,
     /* 2307243 */   // Label 31662: @2307243
     /* 2307243 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2307305), // Rule ID 72559 //
     /* 2307248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307278 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2307281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307304 */     // GIR_Coverage, 72559,
     /* 2307304 */     GIR_EraseRootFromParent_Done,
     /* 2307305 */   // Label 31663: @2307305
     /* 2307305 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2307367), // Rule ID 55274 //
     /* 2307310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307340 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2307343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2307353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307366 */     // GIR_Coverage, 55274,
     /* 2307366 */     GIR_EraseRootFromParent_Done,
     /* 2307367 */   // Label 31664: @2307367
     /* 2307367 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2307429), // Rule ID 55275 //
     /* 2307372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2307395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307402 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2307405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2307415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307428 */     // GIR_Coverage, 55275,
     /* 2307428 */     GIR_EraseRootFromParent_Done,
     /* 2307429 */   // Label 31665: @2307429
     /* 2307429 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2307474), // Rule ID 55270 //
     /* 2307434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307449 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2307452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307473 */     // GIR_Coverage, 55270,
     /* 2307473 */     GIR_EraseRootFromParent_Done,
     /* 2307474 */   // Label 31666: @2307474
     /* 2307474 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2307519), // Rule ID 55271 //
     /* 2307479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2307494 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2307497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307518 */     // GIR_Coverage, 55271,
     /* 2307518 */     GIR_EraseRootFromParent_Done,
     /* 2307519 */   // Label 31667: @2307519
     /* 2307519 */   GIM_Reject,
     /* 2307520 */ // Label 31655: @2307520
     /* 2307520 */ GIM_Reject,
     /* 2307521 */ // Label 31415: @2307521
     /* 2307521 */ GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2308310),
     /* 2307526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2307532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2307535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307539 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2307616), // Rule ID 55534 //
     /* 2307544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307587 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2307590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2307602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307615 */     // GIR_Coverage, 55534,
     /* 2307615 */     GIR_EraseRootFromParent_Done,
     /* 2307616 */   // Label 31669: @2307616
     /* 2307616 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2307693), // Rule ID 55535 //
     /* 2307621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307664 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2307667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2307679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307692 */     // GIR_Coverage, 55535,
     /* 2307692 */     GIR_EraseRootFromParent_Done,
     /* 2307693 */   // Label 31670: @2307693
     /* 2307693 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2307770), // Rule ID 72778 //
     /* 2307698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307741 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2307744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2307756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307769 */     // GIR_Coverage, 72778,
     /* 2307769 */     GIR_EraseRootFromParent_Done,
     /* 2307770 */   // Label 31671: @2307770
     /* 2307770 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2307847), // Rule ID 72779 //
     /* 2307775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307818 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2307821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2307825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2307833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307846 */     // GIR_Coverage, 72779,
     /* 2307846 */     GIR_EraseRootFromParent_Done,
     /* 2307847 */   // Label 31672: @2307847
     /* 2307847 */   GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2307909), // Rule ID 55538 //
     /* 2307852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307882 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2307882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2307885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307908 */     // GIR_Coverage, 55538,
     /* 2307908 */     GIR_EraseRootFromParent_Done,
     /* 2307909 */   // Label 31673: @2307909
     /* 2307909 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2307971), // Rule ID 55539 //
     /* 2307914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307944 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2307944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2307947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2307951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2307957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2307969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307970 */     // GIR_Coverage, 55539,
     /* 2307970 */     GIR_EraseRootFromParent_Done,
     /* 2307971 */   // Label 31674: @2307971
     /* 2307971 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2308033), // Rule ID 72782 //
     /* 2307976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2307995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308006 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2308009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308032 */     // GIR_Coverage, 72782,
     /* 2308032 */     GIR_EraseRootFromParent_Done,
     /* 2308033 */   // Label 31675: @2308033
     /* 2308033 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2308095), // Rule ID 72783 //
     /* 2308038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2308057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308068 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2308071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308094 */     // GIR_Coverage, 72783,
     /* 2308094 */     GIR_EraseRootFromParent_Done,
     /* 2308095 */   // Label 31676: @2308095
     /* 2308095 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2308157), // Rule ID 55530 //
     /* 2308100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2308123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308130 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2308133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308156 */     // GIR_Coverage, 55530,
     /* 2308156 */     GIR_EraseRootFromParent_Done,
     /* 2308157 */   // Label 31677: @2308157
     /* 2308157 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2308219), // Rule ID 55531 //
     /* 2308162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2308185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308192 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2308195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308218 */     // GIR_Coverage, 55531,
     /* 2308218 */     GIR_EraseRootFromParent_Done,
     /* 2308219 */   // Label 31678: @2308219
     /* 2308219 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2308264), // Rule ID 55526 //
     /* 2308224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308239 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2308242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308263 */     // GIR_Coverage, 55526,
     /* 2308263 */     GIR_EraseRootFromParent_Done,
     /* 2308264 */   // Label 31679: @2308264
     /* 2308264 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2308309), // Rule ID 55527 //
     /* 2308269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308284 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2308287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308308 */     // GIR_Coverage, 55527,
     /* 2308308 */     GIR_EraseRootFromParent_Done,
     /* 2308309 */   // Label 31680: @2308309
     /* 2308309 */   GIM_Reject,
     /* 2308310 */ // Label 31668: @2308310
     /* 2308310 */ GIM_Reject,
     /* 2308311 */ // Label 31416: @2308311
     /* 2308311 */ GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2309100),
     /* 2308316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2308322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2308325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308329 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2308406), // Rule ID 55342 //
     /* 2308334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308377 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2308380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308405 */     // GIR_Coverage, 55342,
     /* 2308405 */     GIR_EraseRootFromParent_Done,
     /* 2308406 */   // Label 31682: @2308406
     /* 2308406 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2308483), // Rule ID 55343 //
     /* 2308411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308454 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2308457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308482 */     // GIR_Coverage, 55343,
     /* 2308482 */     GIR_EraseRootFromParent_Done,
     /* 2308483 */   // Label 31683: @2308483
     /* 2308483 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2308560), // Rule ID 72610 //
     /* 2308488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308531 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2308534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308559 */     // GIR_Coverage, 72610,
     /* 2308559 */     GIR_EraseRootFromParent_Done,
     /* 2308560 */   // Label 31684: @2308560
     /* 2308560 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2308637), // Rule ID 72611 //
     /* 2308565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308608 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2308611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308636 */     // GIR_Coverage, 72611,
     /* 2308636 */     GIR_EraseRootFromParent_Done,
     /* 2308637 */   // Label 31685: @2308637
     /* 2308637 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2308699), // Rule ID 55346 //
     /* 2308642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308672 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2308675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308698 */     // GIR_Coverage, 55346,
     /* 2308698 */     GIR_EraseRootFromParent_Done,
     /* 2308699 */   // Label 31686: @2308699
     /* 2308699 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2308761), // Rule ID 55347 //
     /* 2308704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308734 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2308737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308760 */     // GIR_Coverage, 55347,
     /* 2308760 */     GIR_EraseRootFromParent_Done,
     /* 2308761 */   // Label 31687: @2308761
     /* 2308761 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2308823), // Rule ID 72614 //
     /* 2308766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308796 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2308799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308822 */     // GIR_Coverage, 72614,
     /* 2308822 */     GIR_EraseRootFromParent_Done,
     /* 2308823 */   // Label 31688: @2308823
     /* 2308823 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2308885), // Rule ID 72615 //
     /* 2308828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308858 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2308861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308884 */     // GIR_Coverage, 72615,
     /* 2308884 */     GIR_EraseRootFromParent_Done,
     /* 2308885 */   // Label 31689: @2308885
     /* 2308885 */   GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2308947), // Rule ID 55338 //
     /* 2308890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308920 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2308923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308946 */     // GIR_Coverage, 55338,
     /* 2308946 */     GIR_EraseRootFromParent_Done,
     /* 2308947 */   // Label 31690: @2308947
     /* 2308947 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2309009), // Rule ID 55339 //
     /* 2308952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2308975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308982 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2308985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309008 */     // GIR_Coverage, 55339,
     /* 2309008 */     GIR_EraseRootFromParent_Done,
     /* 2309009 */   // Label 31691: @2309009
     /* 2309009 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2309054), // Rule ID 55334 //
     /* 2309014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309029 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2309032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309053 */     // GIR_Coverage, 55334,
     /* 2309053 */     GIR_EraseRootFromParent_Done,
     /* 2309054 */   // Label 31692: @2309054
     /* 2309054 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2309099), // Rule ID 55335 //
     /* 2309059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309074 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2309077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309098 */     // GIR_Coverage, 55335,
     /* 2309098 */     GIR_EraseRootFromParent_Done,
     /* 2309099 */   // Label 31693: @2309099
     /* 2309099 */   GIM_Reject,
     /* 2309100 */ // Label 31681: @2309100
     /* 2309100 */ GIM_Reject,
     /* 2309101 */ // Label 31417: @2309101
     /* 2309101 */ GIM_Reject,
     /* 2309102 */ // Label 63: @2309102
     /* 2309102 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31712*/ GIMT_Encode4(2311529),
     /* 2309113 */ /*GILLT_s16*//*Label 31694*/ GIMT_Encode4(2309233),
     /* 2309117 */ /*GILLT_s32*//*Label 31695*/ GIMT_Encode4(2309382),
     /* 2309121 */ /*GILLT_s64*//*Label 31696*/ GIMT_Encode4(2309531), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309133 */ /*GILLT_nxv1s16*//*Label 31697*/ GIMT_Encode4(2309714),
     /* 2309137 */ /*GILLT_nxv1s32*//*Label 31698*/ GIMT_Encode4(2309835),
     /* 2309141 */ /*GILLT_nxv1s64*//*Label 31699*/ GIMT_Encode4(2309956), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309153 */ /*GILLT_nxv2s16*//*Label 31700*/ GIMT_Encode4(2310077),
     /* 2309157 */ /*GILLT_nxv2s32*//*Label 31701*/ GIMT_Encode4(2310198),
     /* 2309161 */ /*GILLT_nxv2s64*//*Label 31702*/ GIMT_Encode4(2310319), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309173 */ /*GILLT_nxv4s16*//*Label 31703*/ GIMT_Encode4(2310440),
     /* 2309177 */ /*GILLT_nxv4s32*//*Label 31704*/ GIMT_Encode4(2310561),
     /* 2309181 */ /*GILLT_nxv4s64*//*Label 31705*/ GIMT_Encode4(2310682), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309193 */ /*GILLT_nxv8s16*//*Label 31706*/ GIMT_Encode4(2310803),
     /* 2309197 */ /*GILLT_nxv8s32*//*Label 31707*/ GIMT_Encode4(2310924),
     /* 2309201 */ /*GILLT_nxv8s64*//*Label 31708*/ GIMT_Encode4(2311045), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309213 */ /*GILLT_nxv16s16*//*Label 31709*/ GIMT_Encode4(2311166),
     /* 2309217 */ /*GILLT_nxv16s32*//*Label 31710*/ GIMT_Encode4(2311287), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309229 */ /*GILLT_nxv32s16*//*Label 31711*/ GIMT_Encode4(2311408),
     /* 2309233 */ // Label 31694: @2309233
     /* 2309233 */ GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2309381),
     /* 2309238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2309244 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2309278), // Rule ID 1974 //
     /* 2309249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2309252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309264 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2309264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2309267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309277 */     // GIR_Coverage, 1974,
     /* 2309277 */     GIR_EraseRootFromParent_Done,
     /* 2309278 */   // Label 31714: @2309278
     /* 2309278 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2309312), // Rule ID 1975 //
     /* 2309283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2309286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309298 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2309298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2309301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309311 */     // GIR_Coverage, 1975,
     /* 2309311 */     GIR_EraseRootFromParent_Done,
     /* 2309312 */   // Label 31715: @2309312
     /* 2309312 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2309346), // Rule ID 1978 //
     /* 2309317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2309320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309332 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2309332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2309335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309345 */     // GIR_Coverage, 1978,
     /* 2309345 */     GIR_EraseRootFromParent_Done,
     /* 2309346 */   // Label 31716: @2309346
     /* 2309346 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2309380), // Rule ID 1979 //
     /* 2309351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2309354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309366 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2309366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2309369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309379 */     // GIR_Coverage, 1979,
     /* 2309379 */     GIR_EraseRootFromParent_Done,
     /* 2309380 */   // Label 31717: @2309380
     /* 2309380 */   GIM_Reject,
     /* 2309381 */ // Label 31713: @2309381
     /* 2309381 */ GIM_Reject,
     /* 2309382 */ // Label 31695: @2309382
     /* 2309382 */ GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2309530),
     /* 2309387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2309393 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2309427), // Rule ID 1261 //
     /* 2309398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2309401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309413 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2309413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2309416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309426 */     // GIR_Coverage, 1261,
     /* 2309426 */     GIR_EraseRootFromParent_Done,
     /* 2309427 */   // Label 31719: @2309427
     /* 2309427 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2309461), // Rule ID 1262 //
     /* 2309432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2309435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309447 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2309447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2309450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309460 */     // GIR_Coverage, 1262,
     /* 2309460 */     GIR_EraseRootFromParent_Done,
     /* 2309461 */   // Label 31720: @2309461
     /* 2309461 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2309495), // Rule ID 1265 //
     /* 2309466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2309469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309481 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2309481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2309484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309494 */     // GIR_Coverage, 1265,
     /* 2309494 */     GIR_EraseRootFromParent_Done,
     /* 2309495 */   // Label 31721: @2309495
     /* 2309495 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2309529), // Rule ID 1266 //
     /* 2309500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2309503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309515 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2309515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2309518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309528 */     // GIR_Coverage, 1266,
     /* 2309528 */     GIR_EraseRootFromParent_Done,
     /* 2309529 */   // Label 31722: @2309529
     /* 2309529 */   GIM_Reject,
     /* 2309530 */ // Label 31718: @2309530
     /* 2309530 */ GIM_Reject,
     /* 2309531 */ // Label 31696: @2309531
     /* 2309531 */ GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2309713),
     /* 2309536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2309542 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2309576), // Rule ID 1602 //
     /* 2309547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2309550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309562 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2309562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2309565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309575 */     // GIR_Coverage, 1602,
     /* 2309575 */     GIR_EraseRootFromParent_Done,
     /* 2309576 */   // Label 31724: @2309576
     /* 2309576 */   GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2309610), // Rule ID 1603 //
     /* 2309581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2309584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309596 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2309596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2309599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309609 */     // GIR_Coverage, 1603,
     /* 2309609 */     GIR_EraseRootFromParent_Done,
     /* 2309610 */   // Label 31725: @2309610
     /* 2309610 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2309644), // Rule ID 1606 //
     /* 2309615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2309618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309630 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2309630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2309633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309643 */     // GIR_Coverage, 1606,
     /* 2309643 */     GIR_EraseRootFromParent_Done,
     /* 2309644 */   // Label 31726: @2309644
     /* 2309644 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2309678), // Rule ID 1607 //
     /* 2309649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2309652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309664 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2309664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2309667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309677 */     // GIR_Coverage, 1607,
     /* 2309677 */     GIR_EraseRootFromParent_Done,
     /* 2309678 */   // Label 31727: @2309678
     /* 2309678 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2309712), // Rule ID 1609 //
     /* 2309683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2309686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309698 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2309698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2309701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309711 */     // GIR_Coverage, 1609,
     /* 2309711 */     GIR_EraseRootFromParent_Done,
     /* 2309712 */   // Label 31728: @2309712
     /* 2309712 */   GIM_Reject,
     /* 2309713 */ // Label 31723: @2309713
     /* 2309713 */ GIM_Reject,
     /* 2309714 */ // Label 31697: @2309714
     /* 2309714 */ GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2309834),
     /* 2309719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2309722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2309725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309737 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2309785), // Rule ID 54396 //
     /* 2309742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309745 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2309748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2309762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309784 */     // GIR_Coverage, 54396,
     /* 2309784 */     GIR_EraseRootFromParent_Done,
     /* 2309785 */   // Label 31730: @2309785
     /* 2309785 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2309833), // Rule ID 54397 //
     /* 2309790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309793 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2309796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2309810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309832 */     // GIR_Coverage, 54397,
     /* 2309832 */     GIR_EraseRootFromParent_Done,
     /* 2309833 */   // Label 31731: @2309833
     /* 2309833 */   GIM_Reject,
     /* 2309834 */ // Label 31729: @2309834
     /* 2309834 */ GIM_Reject,
     /* 2309835 */ // Label 31698: @2309835
     /* 2309835 */ GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2309955),
     /* 2309840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2309846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309858 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2309906), // Rule ID 54420 //
     /* 2309863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309866 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2309869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2309883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309905 */     // GIR_Coverage, 54420,
     /* 2309905 */     GIR_EraseRootFromParent_Done,
     /* 2309906 */   // Label 31733: @2309906
     /* 2309906 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2309954), // Rule ID 54421 //
     /* 2309911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309914 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2309917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2309931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2309940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309953 */     // GIR_Coverage, 54421,
     /* 2309953 */     GIR_EraseRootFromParent_Done,
     /* 2309954 */   // Label 31734: @2309954
     /* 2309954 */   GIM_Reject,
     /* 2309955 */ // Label 31732: @2309955
     /* 2309955 */ GIM_Reject,
     /* 2309956 */ // Label 31699: @2309956
     /* 2309956 */ GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2310076),
     /* 2309961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2309967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309979 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2310027), // Rule ID 54456 //
     /* 2309984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2309987 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2309990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2310004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310026 */     // GIR_Coverage, 54456,
     /* 2310026 */     GIR_EraseRootFromParent_Done,
     /* 2310027 */   // Label 31736: @2310027
     /* 2310027 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2310075), // Rule ID 54457 //
     /* 2310032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310035 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2310038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2310052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310074 */     // GIR_Coverage, 54457,
     /* 2310074 */     GIR_EraseRootFromParent_Done,
     /* 2310075 */   // Label 31737: @2310075
     /* 2310075 */   GIM_Reject,
     /* 2310076 */ // Label 31735: @2310076
     /* 2310076 */ GIM_Reject,
     /* 2310077 */ // Label 31700: @2310077
     /* 2310077 */ GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2310197),
     /* 2310082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2310088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310100 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2310148), // Rule ID 54408 //
     /* 2310105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310108 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2310111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2310125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310147 */     // GIR_Coverage, 54408,
     /* 2310147 */     GIR_EraseRootFromParent_Done,
     /* 2310148 */   // Label 31739: @2310148
     /* 2310148 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2310196), // Rule ID 54409 //
     /* 2310153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310156 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2310159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2310173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310195 */     // GIR_Coverage, 54409,
     /* 2310195 */     GIR_EraseRootFromParent_Done,
     /* 2310196 */   // Label 31740: @2310196
     /* 2310196 */   GIM_Reject,
     /* 2310197 */ // Label 31738: @2310197
     /* 2310197 */ GIM_Reject,
     /* 2310198 */ // Label 31701: @2310198
     /* 2310198 */ GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2310318),
     /* 2310203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2310206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2310209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310221 */   GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2310269), // Rule ID 54444 //
     /* 2310226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2310229 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2310232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2310246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310268 */     // GIR_Coverage, 54444,
     /* 2310268 */     GIR_EraseRootFromParent_Done,
     /* 2310269 */   // Label 31742: @2310269
     /* 2310269 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2310317), // Rule ID 54445 //
     /* 2310274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2310277 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2310280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2310294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310316 */     // GIR_Coverage, 54445,
     /* 2310316 */     GIR_EraseRootFromParent_Done,
     /* 2310317 */   // Label 31743: @2310317
     /* 2310317 */   GIM_Reject,
     /* 2310318 */ // Label 31741: @2310318
     /* 2310318 */ GIM_Reject,
     /* 2310319 */ // Label 31702: @2310319
     /* 2310319 */ GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2310439),
     /* 2310324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2310327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2310330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310342 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2310390), // Rule ID 54540 //
     /* 2310347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310350 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2310353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2310367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310389 */     // GIR_Coverage, 54540,
     /* 2310389 */     GIR_EraseRootFromParent_Done,
     /* 2310390 */   // Label 31745: @2310390
     /* 2310390 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2310438), // Rule ID 54541 //
     /* 2310395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310398 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2310401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2310415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310437 */     // GIR_Coverage, 54541,
     /* 2310437 */     GIR_EraseRootFromParent_Done,
     /* 2310438 */   // Label 31746: @2310438
     /* 2310438 */   GIM_Reject,
     /* 2310439 */ // Label 31744: @2310439
     /* 2310439 */ GIM_Reject,
     /* 2310440 */ // Label 31703: @2310440
     /* 2310440 */ GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2310560),
     /* 2310445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2310448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2310451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310463 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2310511), // Rule ID 54432 //
     /* 2310468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310471 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2310474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2310488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310510 */     // GIR_Coverage, 54432,
     /* 2310510 */     GIR_EraseRootFromParent_Done,
     /* 2310511 */   // Label 31748: @2310511
     /* 2310511 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2310559), // Rule ID 54433 //
     /* 2310516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310519 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2310522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2310536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310558 */     // GIR_Coverage, 54433,
     /* 2310558 */     GIR_EraseRootFromParent_Done,
     /* 2310559 */   // Label 31749: @2310559
     /* 2310559 */   GIM_Reject,
     /* 2310560 */ // Label 31747: @2310560
     /* 2310560 */ GIM_Reject,
     /* 2310561 */ // Label 31704: @2310561
     /* 2310561 */ GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2310681),
     /* 2310566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2310569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2310572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310584 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2310632), // Rule ID 54504 //
     /* 2310589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2310592 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2310595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2310609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310631 */     // GIR_Coverage, 54504,
     /* 2310631 */     GIR_EraseRootFromParent_Done,
     /* 2310632 */   // Label 31751: @2310632
     /* 2310632 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2310680), // Rule ID 54505 //
     /* 2310637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2310640 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2310643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2310657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310679 */     // GIR_Coverage, 54505,
     /* 2310679 */     GIR_EraseRootFromParent_Done,
     /* 2310680 */   // Label 31752: @2310680
     /* 2310680 */   GIM_Reject,
     /* 2310681 */ // Label 31750: @2310681
     /* 2310681 */ GIM_Reject,
     /* 2310682 */ // Label 31705: @2310682
     /* 2310682 */ GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2310802),
     /* 2310687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2310690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2310693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310705 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2310753), // Rule ID 54552 //
     /* 2310710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310713 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2310716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2310730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310752 */     // GIR_Coverage, 54552,
     /* 2310752 */     GIR_EraseRootFromParent_Done,
     /* 2310753 */   // Label 31754: @2310753
     /* 2310753 */   GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2310801), // Rule ID 54553 //
     /* 2310758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310761 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2310764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2310778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310800 */     // GIR_Coverage, 54553,
     /* 2310800 */     GIR_EraseRootFromParent_Done,
     /* 2310801 */   // Label 31755: @2310801
     /* 2310801 */   GIM_Reject,
     /* 2310802 */ // Label 31753: @2310802
     /* 2310802 */ GIM_Reject,
     /* 2310803 */ // Label 31706: @2310803
     /* 2310803 */ GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2310923),
     /* 2310808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2310811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2310814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310826 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2310874), // Rule ID 54468 //
     /* 2310831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310834 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2310837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2310851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310873 */     // GIR_Coverage, 54468,
     /* 2310873 */     GIR_EraseRootFromParent_Done,
     /* 2310874 */   // Label 31757: @2310874
     /* 2310874 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2310922), // Rule ID 54469 //
     /* 2310879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310882 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2310885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2310899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310921 */     // GIR_Coverage, 54469,
     /* 2310921 */     GIR_EraseRootFromParent_Done,
     /* 2310922 */   // Label 31758: @2310922
     /* 2310922 */   GIM_Reject,
     /* 2310923 */ // Label 31756: @2310923
     /* 2310923 */ GIM_Reject,
     /* 2310924 */ // Label 31707: @2310924
     /* 2310924 */ GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2311044),
     /* 2310929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2310932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2310935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310947 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2310995), // Rule ID 54516 //
     /* 2310952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2310955 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2310958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2310972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2310981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310994 */     // GIR_Coverage, 54516,
     /* 2310994 */     GIR_EraseRootFromParent_Done,
     /* 2310995 */   // Label 31760: @2310995
     /* 2310995 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2311043), // Rule ID 54517 //
     /* 2311000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311003 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2311006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2311020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311042 */     // GIR_Coverage, 54517,
     /* 2311042 */     GIR_EraseRootFromParent_Done,
     /* 2311043 */   // Label 31761: @2311043
     /* 2311043 */   GIM_Reject,
     /* 2311044 */ // Label 31759: @2311044
     /* 2311044 */ GIM_Reject,
     /* 2311045 */ // Label 31708: @2311045
     /* 2311045 */ GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2311165),
     /* 2311050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2311053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2311056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311068 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2311116), // Rule ID 54564 //
     /* 2311073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2311076 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2311079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2311093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311115 */     // GIR_Coverage, 54564,
     /* 2311115 */     GIR_EraseRootFromParent_Done,
     /* 2311116 */   // Label 31763: @2311116
     /* 2311116 */   GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2311164), // Rule ID 54565 //
     /* 2311121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2311124 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2311127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2311141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2311159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311163 */     // GIR_Coverage, 54565,
     /* 2311163 */     GIR_EraseRootFromParent_Done,
     /* 2311164 */   // Label 31764: @2311164
     /* 2311164 */   GIM_Reject,
     /* 2311165 */ // Label 31762: @2311165
     /* 2311165 */ GIM_Reject,
     /* 2311166 */ // Label 31709: @2311166
     /* 2311166 */ GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2311286),
     /* 2311171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2311174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2311177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2311181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2311185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2311189 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2311237), // Rule ID 54480 //
     /* 2311194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311197 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2311200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2311214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311236 */     // GIR_Coverage, 54480,
     /* 2311236 */     GIR_EraseRootFromParent_Done,
     /* 2311237 */   // Label 31766: @2311237
     /* 2311237 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2311285), // Rule ID 54481 //
     /* 2311242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311245 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2311248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2311262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311284 */     // GIR_Coverage, 54481,
     /* 2311284 */     GIR_EraseRootFromParent_Done,
     /* 2311285 */   // Label 31767: @2311285
     /* 2311285 */   GIM_Reject,
     /* 2311286 */ // Label 31765: @2311286
     /* 2311286 */ GIM_Reject,
     /* 2311287 */ // Label 31710: @2311287
     /* 2311287 */ GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2311407),
     /* 2311292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2311295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2311298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311310 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2311358), // Rule ID 54528 //
     /* 2311315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311318 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2311321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2311335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311357 */     // GIR_Coverage, 54528,
     /* 2311357 */     GIR_EraseRootFromParent_Done,
     /* 2311358 */   // Label 31769: @2311358
     /* 2311358 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2311406), // Rule ID 54529 //
     /* 2311363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311366 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2311369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2311383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311405 */     // GIR_Coverage, 54529,
     /* 2311405 */     GIR_EraseRootFromParent_Done,
     /* 2311406 */   // Label 31770: @2311406
     /* 2311406 */   GIM_Reject,
     /* 2311407 */ // Label 31768: @2311407
     /* 2311407 */ GIM_Reject,
     /* 2311408 */ // Label 31711: @2311408
     /* 2311408 */ GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2311528),
     /* 2311413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2311416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2311419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311431 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2311479), // Rule ID 54492 //
     /* 2311436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311439 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2311442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2311456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311478 */     // GIR_Coverage, 54492,
     /* 2311478 */     GIR_EraseRootFromParent_Done,
     /* 2311479 */   // Label 31772: @2311479
     /* 2311479 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2311527), // Rule ID 54493 //
     /* 2311484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311487 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2311490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2311504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2311513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311526 */     // GIR_Coverage, 54493,
     /* 2311526 */     GIR_EraseRootFromParent_Done,
     /* 2311527 */   // Label 31773: @2311527
     /* 2311527 */   GIM_Reject,
     /* 2311528 */ // Label 31771: @2311528
     /* 2311528 */ GIM_Reject,
     /* 2311529 */ // Label 31712: @2311529
     /* 2311529 */ GIM_Reject,
     /* 2311530 */ // Label 64: @2311530
     /* 2311530 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31792*/ GIMT_Encode4(2313500),
     /* 2311541 */ /*GILLT_s16*//*Label 31774*/ GIMT_Encode4(2311661),
     /* 2311545 */ /*GILLT_s32*//*Label 31775*/ GIMT_Encode4(2311725),
     /* 2311549 */ /*GILLT_s64*//*Label 31776*/ GIMT_Encode4(2311789), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311561 */ /*GILLT_nxv1s16*//*Label 31777*/ GIMT_Encode4(2311880),
     /* 2311565 */ /*GILLT_nxv1s32*//*Label 31778*/ GIMT_Encode4(2311988),
     /* 2311569 */ /*GILLT_nxv1s64*//*Label 31779*/ GIMT_Encode4(2312096), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311581 */ /*GILLT_nxv2s16*//*Label 31780*/ GIMT_Encode4(2312204),
     /* 2311585 */ /*GILLT_nxv2s32*//*Label 31781*/ GIMT_Encode4(2312312),
     /* 2311589 */ /*GILLT_nxv2s64*//*Label 31782*/ GIMT_Encode4(2312420), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311601 */ /*GILLT_nxv4s16*//*Label 31783*/ GIMT_Encode4(2312528),
     /* 2311605 */ /*GILLT_nxv4s32*//*Label 31784*/ GIMT_Encode4(2312636),
     /* 2311609 */ /*GILLT_nxv4s64*//*Label 31785*/ GIMT_Encode4(2312744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311621 */ /*GILLT_nxv8s16*//*Label 31786*/ GIMT_Encode4(2312852),
     /* 2311625 */ /*GILLT_nxv8s32*//*Label 31787*/ GIMT_Encode4(2312960),
     /* 2311629 */ /*GILLT_nxv8s64*//*Label 31788*/ GIMT_Encode4(2313068), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311641 */ /*GILLT_nxv16s16*//*Label 31789*/ GIMT_Encode4(2313176),
     /* 2311645 */ /*GILLT_nxv16s32*//*Label 31790*/ GIMT_Encode4(2313284), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2311657 */ /*GILLT_nxv32s16*//*Label 31791*/ GIMT_Encode4(2313392),
     /* 2311661 */ // Label 31774: @2311661
     /* 2311661 */ GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2311724),
     /* 2311666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311669 */   GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2311696), // Rule ID 1984 //
     /* 2311674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2311677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311685 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2311685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2311688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311695 */     // GIR_Coverage, 1984,
     /* 2311695 */     GIR_EraseRootFromParent_Done,
     /* 2311696 */   // Label 31794: @2311696
     /* 2311696 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2311723), // Rule ID 2017 //
     /* 2311701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2311704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311712 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2311712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2311715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311722 */     // GIR_Coverage, 2017,
     /* 2311722 */     GIR_EraseRootFromParent_Done,
     /* 2311723 */   // Label 31795: @2311723
     /* 2311723 */   GIM_Reject,
     /* 2311724 */ // Label 31793: @2311724
     /* 2311724 */ GIM_Reject,
     /* 2311725 */ // Label 31775: @2311725
     /* 2311725 */ GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2311788),
     /* 2311730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311733 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2311760), // Rule ID 1271 //
     /* 2311738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2311741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311749 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2311749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2311752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311759 */     // GIR_Coverage, 1271,
     /* 2311759 */     GIR_EraseRootFromParent_Done,
     /* 2311760 */   // Label 31797: @2311760
     /* 2311760 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2311787), // Rule ID 1279 //
     /* 2311765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2311768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311776 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2311776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2311779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311786 */     // GIR_Coverage, 1279,
     /* 2311786 */     GIR_EraseRootFromParent_Done,
     /* 2311787 */   // Label 31798: @2311787
     /* 2311787 */   GIM_Reject,
     /* 2311788 */ // Label 31796: @2311788
     /* 2311788 */ GIM_Reject,
     /* 2311789 */ // Label 31776: @2311789
     /* 2311789 */ GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2311879),
     /* 2311794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311797 */   GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2311824), // Rule ID 1614 //
     /* 2311802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2311805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2311809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2311813 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2311813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2311816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311823 */     // GIR_Coverage, 1614,
     /* 2311823 */     GIR_EraseRootFromParent_Done,
     /* 2311824 */   // Label 31800: @2311824
     /* 2311824 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2311851), // Rule ID 1647 //
     /* 2311829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2311832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311840 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2311840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2311843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311850 */     // GIR_Coverage, 1647,
     /* 2311850 */     GIR_EraseRootFromParent_Done,
     /* 2311851 */   // Label 31801: @2311851
     /* 2311851 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2311878), // Rule ID 1669 //
     /* 2311856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2311859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2311863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2311867 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2311867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2311870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311877 */     // GIR_Coverage, 1669,
     /* 2311877 */     GIR_EraseRootFromParent_Done,
     /* 2311878 */   // Label 31802: @2311878
     /* 2311878 */   GIM_Reject,
     /* 2311879 */ // Label 31799: @2311879
     /* 2311879 */ GIM_Reject,
     /* 2311880 */ // Label 31777: @2311880
     /* 2311880 */ GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2311987),
     /* 2311885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311896 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2311941), // Rule ID 56234 //
     /* 2311901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311904 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2311907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2311921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2311928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2311930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311940 */     // GIR_Coverage, 56234,
     /* 2311940 */     GIR_EraseRootFromParent_Done,
     /* 2311941 */   // Label 31804: @2311941
     /* 2311941 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2311986), // Rule ID 56235 //
     /* 2311946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311949 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2311952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2311966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2311973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2311975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311985 */     // GIR_Coverage, 56235,
     /* 2311985 */     GIR_EraseRootFromParent_Done,
     /* 2311986 */   // Label 31805: @2311986
     /* 2311986 */   GIM_Reject,
     /* 2311987 */ // Label 31803: @2311987
     /* 2311987 */ GIM_Reject,
     /* 2311988 */ // Label 31778: @2311988
     /* 2311988 */ GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2312095),
     /* 2311993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2311996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312004 */   GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2312049), // Rule ID 56274 //
     /* 2312009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312012 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2312029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312048 */     // GIR_Coverage, 56274,
     /* 2312048 */     GIR_EraseRootFromParent_Done,
     /* 2312049 */   // Label 31807: @2312049
     /* 2312049 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2312094), // Rule ID 56275 //
     /* 2312054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312057 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2312074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312093 */     // GIR_Coverage, 56275,
     /* 2312093 */     GIR_EraseRootFromParent_Done,
     /* 2312094 */   // Label 31808: @2312094
     /* 2312094 */   GIM_Reject,
     /* 2312095 */ // Label 31806: @2312095
     /* 2312095 */ GIM_Reject,
     /* 2312096 */ // Label 31779: @2312096
     /* 2312096 */ GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2312203),
     /* 2312101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312112 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2312157), // Rule ID 56334 //
     /* 2312117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312120 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2312137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312156 */     // GIR_Coverage, 56334,
     /* 2312156 */     GIR_EraseRootFromParent_Done,
     /* 2312157 */   // Label 31810: @2312157
     /* 2312157 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2312202), // Rule ID 56335 //
     /* 2312162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312165 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2312182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312201 */     // GIR_Coverage, 56335,
     /* 2312201 */     GIR_EraseRootFromParent_Done,
     /* 2312202 */   // Label 31811: @2312202
     /* 2312202 */   GIM_Reject,
     /* 2312203 */ // Label 31809: @2312203
     /* 2312203 */ GIM_Reject,
     /* 2312204 */ // Label 31780: @2312204
     /* 2312204 */ GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2312311),
     /* 2312209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2312212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312220 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2312265), // Rule ID 56254 //
     /* 2312225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2312228 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2312231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2312245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312264 */     // GIR_Coverage, 56254,
     /* 2312264 */     GIR_EraseRootFromParent_Done,
     /* 2312265 */   // Label 31813: @2312265
     /* 2312265 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2312310), // Rule ID 56255 //
     /* 2312270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2312273 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2312276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2312290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312309 */     // GIR_Coverage, 56255,
     /* 2312309 */     GIR_EraseRootFromParent_Done,
     /* 2312310 */   // Label 31814: @2312310
     /* 2312310 */   GIM_Reject,
     /* 2312311 */ // Label 31812: @2312311
     /* 2312311 */ GIM_Reject,
     /* 2312312 */ // Label 31781: @2312312
     /* 2312312 */ GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2312419),
     /* 2312317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312328 */   GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2312373), // Rule ID 56314 //
     /* 2312333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312336 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2312339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2312353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312372 */     // GIR_Coverage, 56314,
     /* 2312372 */     GIR_EraseRootFromParent_Done,
     /* 2312373 */   // Label 31816: @2312373
     /* 2312373 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2312418), // Rule ID 56315 //
     /* 2312378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312381 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2312384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2312398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312417 */     // GIR_Coverage, 56315,
     /* 2312417 */     GIR_EraseRootFromParent_Done,
     /* 2312418 */   // Label 31817: @2312418
     /* 2312418 */   GIM_Reject,
     /* 2312419 */ // Label 31815: @2312419
     /* 2312419 */ GIM_Reject,
     /* 2312420 */ // Label 31782: @2312420
     /* 2312420 */ GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2312527),
     /* 2312425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312436 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2312481), // Rule ID 56474 //
     /* 2312441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312444 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2312447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2312461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312480 */     // GIR_Coverage, 56474,
     /* 2312480 */     GIR_EraseRootFromParent_Done,
     /* 2312481 */   // Label 31819: @2312481
     /* 2312481 */   GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2312526), // Rule ID 56475 //
     /* 2312486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312489 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2312492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2312506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312525 */     // GIR_Coverage, 56475,
     /* 2312525 */     GIR_EraseRootFromParent_Done,
     /* 2312526 */   // Label 31820: @2312526
     /* 2312526 */   GIM_Reject,
     /* 2312527 */ // Label 31818: @2312527
     /* 2312527 */ GIM_Reject,
     /* 2312528 */ // Label 31783: @2312528
     /* 2312528 */ GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2312635),
     /* 2312533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2312536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312544 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2312589), // Rule ID 56294 //
     /* 2312549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2312552 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2312555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2312569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312588 */     // GIR_Coverage, 56294,
     /* 2312588 */     GIR_EraseRootFromParent_Done,
     /* 2312589 */   // Label 31822: @2312589
     /* 2312589 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2312634), // Rule ID 56295 //
     /* 2312594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2312597 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2312600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2312614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312633 */     // GIR_Coverage, 56295,
     /* 2312633 */     GIR_EraseRootFromParent_Done,
     /* 2312634 */   // Label 31823: @2312634
     /* 2312634 */   GIM_Reject,
     /* 2312635 */ // Label 31821: @2312635
     /* 2312635 */ GIM_Reject,
     /* 2312636 */ // Label 31784: @2312636
     /* 2312636 */ GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2312743),
     /* 2312641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2312644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312652 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2312697), // Rule ID 56414 //
     /* 2312657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312660 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2312663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2312677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312696 */     // GIR_Coverage, 56414,
     /* 2312696 */     GIR_EraseRootFromParent_Done,
     /* 2312697 */   // Label 31825: @2312697
     /* 2312697 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2312742), // Rule ID 56415 //
     /* 2312702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312705 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2312708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2312722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312741 */     // GIR_Coverage, 56415,
     /* 2312741 */     GIR_EraseRootFromParent_Done,
     /* 2312742 */   // Label 31826: @2312742
     /* 2312742 */   GIM_Reject,
     /* 2312743 */ // Label 31824: @2312743
     /* 2312743 */ GIM_Reject,
     /* 2312744 */ // Label 31785: @2312744
     /* 2312744 */ GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2312851),
     /* 2312749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2312752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2312756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2312760 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2312805), // Rule ID 56494 //
     /* 2312765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312768 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2312771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2312785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312804 */     // GIR_Coverage, 56494,
     /* 2312804 */     GIR_EraseRootFromParent_Done,
     /* 2312805 */   // Label 31828: @2312805
     /* 2312805 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2312850), // Rule ID 56495 //
     /* 2312810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312813 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2312816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2312830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312849 */     // GIR_Coverage, 56495,
     /* 2312849 */     GIR_EraseRootFromParent_Done,
     /* 2312850 */   // Label 31829: @2312850
     /* 2312850 */   GIM_Reject,
     /* 2312851 */ // Label 31827: @2312851
     /* 2312851 */ GIM_Reject,
     /* 2312852 */ // Label 31786: @2312852
     /* 2312852 */ GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2312959),
     /* 2312857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2312860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312868 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2312913), // Rule ID 56354 //
     /* 2312873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2312876 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2312879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2312893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312912 */     // GIR_Coverage, 56354,
     /* 2312912 */     GIR_EraseRootFromParent_Done,
     /* 2312913 */   // Label 31831: @2312913
     /* 2312913 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2312958), // Rule ID 56355 //
     /* 2312918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2312921 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2312924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2312938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2312947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312957 */     // GIR_Coverage, 56355,
     /* 2312957 */     GIR_EraseRootFromParent_Done,
     /* 2312958 */   // Label 31832: @2312958
     /* 2312958 */   GIM_Reject,
     /* 2312959 */ // Label 31830: @2312959
     /* 2312959 */ GIM_Reject,
     /* 2312960 */ // Label 31787: @2312960
     /* 2312960 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2313067),
     /* 2312965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2312968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2312972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2312976 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2313021), // Rule ID 56434 //
     /* 2312981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312984 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2312987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2313001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313020 */     // GIR_Coverage, 56434,
     /* 2313020 */     GIR_EraseRootFromParent_Done,
     /* 2313021 */   // Label 31834: @2313021
     /* 2313021 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2313066), // Rule ID 56435 //
     /* 2313026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2313029 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2313032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2313046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313065 */     // GIR_Coverage, 56435,
     /* 2313065 */     GIR_EraseRootFromParent_Done,
     /* 2313066 */   // Label 31835: @2313066
     /* 2313066 */   GIM_Reject,
     /* 2313067 */ // Label 31833: @2313067
     /* 2313067 */ GIM_Reject,
     /* 2313068 */ // Label 31788: @2313068
     /* 2313068 */ GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2313175),
     /* 2313073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2313076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313084 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2313129), // Rule ID 56514 //
     /* 2313089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2313092 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2313095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2313109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313128 */     // GIR_Coverage, 56514,
     /* 2313128 */     GIR_EraseRootFromParent_Done,
     /* 2313129 */   // Label 31837: @2313129
     /* 2313129 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2313174), // Rule ID 56515 //
     /* 2313134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2313137 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2313140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2313154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313173 */     // GIR_Coverage, 56515,
     /* 2313173 */     GIR_EraseRootFromParent_Done,
     /* 2313174 */   // Label 31838: @2313174
     /* 2313174 */   GIM_Reject,
     /* 2313175 */ // Label 31836: @2313175
     /* 2313175 */ GIM_Reject,
     /* 2313176 */ // Label 31789: @2313176
     /* 2313176 */ GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2313283),
     /* 2313181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2313184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2313188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2313192 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2313237), // Rule ID 56374 //
     /* 2313197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313200 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2313203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2313217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313236 */     // GIR_Coverage, 56374,
     /* 2313236 */     GIR_EraseRootFromParent_Done,
     /* 2313237 */   // Label 31840: @2313237
     /* 2313237 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2313282), // Rule ID 56375 //
     /* 2313242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313245 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2313248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2313262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313281 */     // GIR_Coverage, 56375,
     /* 2313281 */     GIR_EraseRootFromParent_Done,
     /* 2313282 */   // Label 31841: @2313282
     /* 2313282 */   GIM_Reject,
     /* 2313283 */ // Label 31839: @2313283
     /* 2313283 */ GIM_Reject,
     /* 2313284 */ // Label 31790: @2313284
     /* 2313284 */ GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2313391),
     /* 2313289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2313292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313300 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2313345), // Rule ID 56454 //
     /* 2313305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2313308 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2313311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2313325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313344 */     // GIR_Coverage, 56454,
     /* 2313344 */     GIR_EraseRootFromParent_Done,
     /* 2313345 */   // Label 31843: @2313345
     /* 2313345 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2313390), // Rule ID 56455 //
     /* 2313350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2313353 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2313356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2313370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313389 */     // GIR_Coverage, 56455,
     /* 2313389 */     GIR_EraseRootFromParent_Done,
     /* 2313390 */   // Label 31844: @2313390
     /* 2313390 */   GIM_Reject,
     /* 2313391 */ // Label 31842: @2313391
     /* 2313391 */ GIM_Reject,
     /* 2313392 */ // Label 31791: @2313392
     /* 2313392 */ GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2313499),
     /* 2313397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2313400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2313408 */   GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2313453), // Rule ID 56394 //
     /* 2313413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313416 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2313419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2313433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313452 */     // GIR_Coverage, 56394,
     /* 2313452 */     GIR_EraseRootFromParent_Done,
     /* 2313453 */   // Label 31846: @2313453
     /* 2313453 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2313498), // Rule ID 56395 //
     /* 2313458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313461 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2313464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2313478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2313487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313497 */     // GIR_Coverage, 56395,
     /* 2313497 */     GIR_EraseRootFromParent_Done,
     /* 2313498 */   // Label 31847: @2313498
     /* 2313498 */   GIM_Reject,
     /* 2313499 */ // Label 31845: @2313499
     /* 2313499 */ GIM_Reject,
     /* 2313500 */ // Label 31792: @2313500
     /* 2313500 */ GIM_Reject,
     /* 2313501 */ // Label 65: @2313501
     /* 2313501 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31850*/ GIMT_Encode4(2313953),
     /* 2313512 */ /*GILLT_s32*//*Label 31848*/ GIMT_Encode4(2313520),
     /* 2313516 */ /*GILLT_s64*//*Label 31849*/ GIMT_Encode4(2313642),
     /* 2313520 */ // Label 31848: @2313520
     /* 2313520 */ GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2313641),
     /* 2313525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313528 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2313556), // Rule ID 2158 //
     /* 2313533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2313536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2313540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2313544 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2313544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2313547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313555 */     // GIR_Coverage, 2158,
     /* 2313555 */     GIR_EraseRootFromParent_Done,
     /* 2313556 */   // Label 31852: @2313556
     /* 2313556 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2313584), // Rule ID 2159 //
     /* 2313561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2313564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2313568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2313572 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2313572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2313575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313583 */     // GIR_Coverage, 2159,
     /* 2313583 */     GIR_EraseRootFromParent_Done,
     /* 2313584 */   // Label 31853: @2313584
     /* 2313584 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2313612), // Rule ID 2174 //
     /* 2313589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2313592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2313596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2313600 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2313600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2313603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313611 */     // GIR_Coverage, 2174,
     /* 2313611 */     GIR_EraseRootFromParent_Done,
     /* 2313612 */   // Label 31854: @2313612
     /* 2313612 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2313640), // Rule ID 2175 //
     /* 2313617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2313620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2313624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2313628 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2313628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2313631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313639 */     // GIR_Coverage, 2175,
     /* 2313639 */     GIR_EraseRootFromParent_Done,
     /* 2313640 */   // Label 31855: @2313640
     /* 2313640 */   GIM_Reject,
     /* 2313641 */ // Label 31851: @2313641
     /* 2313641 */ GIM_Reject,
     /* 2313642 */ // Label 31849: @2313642
     /* 2313642 */ GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2313673), // Rule ID 1556 //
     /* 2313647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2313650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2313653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2313661 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2313661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2313664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313666 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313672 */   // GIR_Coverage, 1556,
     /* 2313672 */   GIR_EraseRootFromParent_Done,
     /* 2313673 */ // Label 31856: @2313673
     /* 2313673 */ GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2313704), // Rule ID 1557 //
     /* 2313678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2313681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2313684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2313692 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2313692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2313695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313697 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313703 */   // GIR_Coverage, 1557,
     /* 2313703 */   GIR_EraseRootFromParent_Done,
     /* 2313704 */ // Label 31857: @2313704
     /* 2313704 */ GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2313735), // Rule ID 1561 //
     /* 2313709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2313712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2313715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2313723 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2313723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2313726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313728 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313734 */   // GIR_Coverage, 1561,
     /* 2313734 */   GIR_EraseRootFromParent_Done,
     /* 2313735 */ // Label 31858: @2313735
     /* 2313735 */ GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2313766), // Rule ID 1568 //
     /* 2313740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2313743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2313746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2313754 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2313754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2313757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313759 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313765 */   // GIR_Coverage, 1568,
     /* 2313765 */   GIR_EraseRootFromParent_Done,
     /* 2313766 */ // Label 31859: @2313766
     /* 2313766 */ GIM_Try, /*On fail goto*//*Label 31860*/ GIMT_Encode4(2313797), // Rule ID 1569 //
     /* 2313771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2313774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2313777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2313785 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2313785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2313788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313790 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313796 */   // GIR_Coverage, 1569,
     /* 2313796 */   GIR_EraseRootFromParent_Done,
     /* 2313797 */ // Label 31860: @2313797
     /* 2313797 */ GIM_Try, /*On fail goto*//*Label 31861*/ GIMT_Encode4(2313828), // Rule ID 2292 //
     /* 2313802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2313805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2313816 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2313816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2313819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313827 */   // GIR_Coverage, 2292,
     /* 2313827 */   GIR_EraseRootFromParent_Done,
     /* 2313828 */ // Label 31861: @2313828
     /* 2313828 */ GIM_Try, /*On fail goto*//*Label 31862*/ GIMT_Encode4(2313859), // Rule ID 2293 //
     /* 2313833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2313836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2313843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2313847 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2313847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2313850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313852 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313857 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313858 */   // GIR_Coverage, 2293,
     /* 2313858 */   GIR_EraseRootFromParent_Done,
     /* 2313859 */ // Label 31862: @2313859
     /* 2313859 */ GIM_Try, /*On fail goto*//*Label 31863*/ GIMT_Encode4(2313890), // Rule ID 2304 //
     /* 2313864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2313867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2313878 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2313878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2313881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313883 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313889 */   // GIR_Coverage, 2304,
     /* 2313889 */   GIR_EraseRootFromParent_Done,
     /* 2313890 */ // Label 31863: @2313890
     /* 2313890 */ GIM_Try, /*On fail goto*//*Label 31864*/ GIMT_Encode4(2313921), // Rule ID 2305 //
     /* 2313895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2313898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2313905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2313909 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2313909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2313912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313914 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313920 */   // GIR_Coverage, 2305,
     /* 2313920 */   GIR_EraseRootFromParent_Done,
     /* 2313921 */ // Label 31864: @2313921
     /* 2313921 */ GIM_Try, /*On fail goto*//*Label 31865*/ GIMT_Encode4(2313952), // Rule ID 2313 //
     /* 2313926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2313929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2313932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2313936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2313940 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2313940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2313943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313945 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2313950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313951 */   // GIR_Coverage, 2313,
     /* 2313951 */   GIR_EraseRootFromParent_Done,
     /* 2313952 */ // Label 31865: @2313952
     /* 2313952 */ GIM_Reject,
     /* 2313953 */ // Label 31850: @2313953
     /* 2313953 */ GIM_Reject,
     /* 2313954 */ // Label 66: @2313954
     /* 2313954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 31877*/ GIMT_Encode4(2315489),
     /* 2313965 */ /*GILLT_s16*//*Label 31866*/ GIMT_Encode4(2314069),
     /* 2313969 */ /*GILLT_s32*//*Label 31867*/ GIMT_Encode4(2314349), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2313985 */ /*GILLT_nxv1s16*//*Label 31868*/ GIMT_Encode4(2314499),
     /* 2313989 */ /*GILLT_nxv1s32*//*Label 31869*/ GIMT_Encode4(2314609), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2314005 */ /*GILLT_nxv2s16*//*Label 31870*/ GIMT_Encode4(2314719),
     /* 2314009 */ /*GILLT_nxv2s32*//*Label 31871*/ GIMT_Encode4(2314829), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2314025 */ /*GILLT_nxv4s16*//*Label 31872*/ GIMT_Encode4(2314939),
     /* 2314029 */ /*GILLT_nxv4s32*//*Label 31873*/ GIMT_Encode4(2315049), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2314045 */ /*GILLT_nxv8s16*//*Label 31874*/ GIMT_Encode4(2315159),
     /* 2314049 */ /*GILLT_nxv8s32*//*Label 31875*/ GIMT_Encode4(2315269), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2314065 */ /*GILLT_nxv16s16*//*Label 31876*/ GIMT_Encode4(2315379),
     /* 2314069 */ // Label 31866: @2314069
     /* 2314069 */ GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2314100), // Rule ID 2154 //
     /* 2314074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2314077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2314080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2314084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2314088 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2314088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2314091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314093 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314099 */   // GIR_Coverage, 2154,
     /* 2314099 */   GIR_EraseRootFromParent_Done,
     /* 2314100 */ // Label 31878: @2314100
     /* 2314100 */ GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2314131), // Rule ID 2155 //
     /* 2314105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2314108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2314111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2314115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2314119 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2314119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2314122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314124 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314129 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314130 */   // GIR_Coverage, 2155,
     /* 2314130 */   GIR_EraseRootFromParent_Done,
     /* 2314131 */ // Label 31879: @2314131
     /* 2314131 */ GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2314162), // Rule ID 2170 //
     /* 2314136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2314139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2314142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2314146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2314150 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2314150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2314153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314155 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314161 */   // GIR_Coverage, 2170,
     /* 2314161 */   GIR_EraseRootFromParent_Done,
     /* 2314162 */ // Label 31880: @2314162
     /* 2314162 */ GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2314193), // Rule ID 2171 //
     /* 2314167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2314170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2314173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2314177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2314181 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2314181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2314184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314192 */   // GIR_Coverage, 2171,
     /* 2314192 */   GIR_EraseRootFromParent_Done,
     /* 2314193 */ // Label 31881: @2314193
     /* 2314193 */ GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2314224), // Rule ID 2288 //
     /* 2314198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2314201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2314208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314212 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2314215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314223 */   // GIR_Coverage, 2288,
     /* 2314223 */   GIR_EraseRootFromParent_Done,
     /* 2314224 */ // Label 31882: @2314224
     /* 2314224 */ GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2314255), // Rule ID 2289 //
     /* 2314229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2314232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2314239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314243 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2314243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2314246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314248 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314254 */   // GIR_Coverage, 2289,
     /* 2314254 */   GIR_EraseRootFromParent_Done,
     /* 2314255 */ // Label 31883: @2314255
     /* 2314255 */ GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2314286), // Rule ID 2300 //
     /* 2314260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2314263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2314270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314274 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2314277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314279 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314285 */   // GIR_Coverage, 2300,
     /* 2314285 */   GIR_EraseRootFromParent_Done,
     /* 2314286 */ // Label 31884: @2314286
     /* 2314286 */ GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2314317), // Rule ID 2301 //
     /* 2314291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2314294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2314301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314305 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2314305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2314308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314316 */   // GIR_Coverage, 2301,
     /* 2314316 */   GIR_EraseRootFromParent_Done,
     /* 2314317 */ // Label 31885: @2314317
     /* 2314317 */ GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2314348), // Rule ID 2311 //
     /* 2314322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2314325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2314332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314336 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2314339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314341 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314347 */   // GIR_Coverage, 2311,
     /* 2314347 */   GIR_EraseRootFromParent_Done,
     /* 2314348 */ // Label 31886: @2314348
     /* 2314348 */ GIM_Reject,
     /* 2314349 */ // Label 31867: @2314349
     /* 2314349 */ GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2314498),
     /* 2314354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2314357 */   GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2314385), // Rule ID 1552 //
     /* 2314362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2314365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2314369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314373 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2314376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314384 */     // GIR_Coverage, 1552,
     /* 2314384 */     GIR_EraseRootFromParent_Done,
     /* 2314385 */   // Label 31888: @2314385
     /* 2314385 */   GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2314413), // Rule ID 1553 //
     /* 2314390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2314393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2314397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2314401 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2314401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2314404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314412 */     // GIR_Coverage, 1553,
     /* 2314412 */     GIR_EraseRootFromParent_Done,
     /* 2314413 */   // Label 31889: @2314413
     /* 2314413 */   GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2314441), // Rule ID 1559 //
     /* 2314418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2314421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2314425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2314429 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2314432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314440 */     // GIR_Coverage, 1559,
     /* 2314440 */     GIR_EraseRootFromParent_Done,
     /* 2314441 */   // Label 31890: @2314441
     /* 2314441 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2314469), // Rule ID 1564 //
     /* 2314446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2314449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2314453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314457 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2314457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2314460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314468 */     // GIR_Coverage, 1564,
     /* 2314468 */     GIR_EraseRootFromParent_Done,
     /* 2314469 */   // Label 31891: @2314469
     /* 2314469 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2314497), // Rule ID 1565 //
     /* 2314474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2314477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2314481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2314485 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2314485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2314488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314496 */     // GIR_Coverage, 1565,
     /* 2314496 */     GIR_EraseRootFromParent_Done,
     /* 2314497 */   // Label 31892: @2314497
     /* 2314497 */   GIM_Reject,
     /* 2314498 */ // Label 31887: @2314498
     /* 2314498 */ GIM_Reject,
     /* 2314499 */ // Label 31868: @2314499
     /* 2314499 */ GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2314608),
     /* 2314504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2314507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314515 */   GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2314561), // Rule ID 58882 //
     /* 2314520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2314523 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2314526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2314540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314560 */     // GIR_Coverage, 58882,
     /* 2314560 */     GIR_EraseRootFromParent_Done,
     /* 2314561 */   // Label 31894: @2314561
     /* 2314561 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2314607), // Rule ID 58883 //
     /* 2314566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2314569 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2314572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2314586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314606 */     // GIR_Coverage, 58883,
     /* 2314606 */     GIR_EraseRootFromParent_Done,
     /* 2314607 */   // Label 31895: @2314607
     /* 2314607 */   GIM_Reject,
     /* 2314608 */ // Label 31893: @2314608
     /* 2314608 */ GIM_Reject,
     /* 2314609 */ // Label 31869: @2314609
     /* 2314609 */ GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2314718),
     /* 2314614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2314617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314625 */   GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2314671), // Rule ID 58892 //
     /* 2314630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2314633 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2314636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2314650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314670 */     // GIR_Coverage, 58892,
     /* 2314670 */     GIR_EraseRootFromParent_Done,
     /* 2314671 */   // Label 31897: @2314671
     /* 2314671 */   GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2314717), // Rule ID 58893 //
     /* 2314676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2314679 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2314682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2314696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314716 */     // GIR_Coverage, 58893,
     /* 2314716 */     GIR_EraseRootFromParent_Done,
     /* 2314717 */   // Label 31898: @2314717
     /* 2314717 */   GIM_Reject,
     /* 2314718 */ // Label 31896: @2314718
     /* 2314718 */ GIM_Reject,
     /* 2314719 */ // Label 31870: @2314719
     /* 2314719 */ GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2314828),
     /* 2314724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2314727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314735 */   GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2314781), // Rule ID 58884 //
     /* 2314740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2314743 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2314746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2314760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314780 */     // GIR_Coverage, 58884,
     /* 2314780 */     GIR_EraseRootFromParent_Done,
     /* 2314781 */   // Label 31900: @2314781
     /* 2314781 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2314827), // Rule ID 58885 //
     /* 2314786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2314789 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2314792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2314806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314826 */     // GIR_Coverage, 58885,
     /* 2314826 */     GIR_EraseRootFromParent_Done,
     /* 2314827 */   // Label 31901: @2314827
     /* 2314827 */   GIM_Reject,
     /* 2314828 */ // Label 31899: @2314828
     /* 2314828 */ GIM_Reject,
     /* 2314829 */ // Label 31871: @2314829
     /* 2314829 */ GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2314938),
     /* 2314834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2314837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314845 */   GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2314891), // Rule ID 58894 //
     /* 2314850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2314853 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2314856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2314870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314890 */     // GIR_Coverage, 58894,
     /* 2314890 */     GIR_EraseRootFromParent_Done,
     /* 2314891 */   // Label 31903: @2314891
     /* 2314891 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2314937), // Rule ID 58895 //
     /* 2314896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2314899 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2314902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2314916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314936 */     // GIR_Coverage, 58895,
     /* 2314936 */     GIR_EraseRootFromParent_Done,
     /* 2314937 */   // Label 31904: @2314937
     /* 2314937 */   GIM_Reject,
     /* 2314938 */ // Label 31902: @2314938
     /* 2314938 */ GIM_Reject,
     /* 2314939 */ // Label 31872: @2314939
     /* 2314939 */ GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2315048),
     /* 2314944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314955 */   GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2315001), // Rule ID 58886 //
     /* 2314960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2314963 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2314966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2314980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315000 */     // GIR_Coverage, 58886,
     /* 2315000 */     GIR_EraseRootFromParent_Done,
     /* 2315001 */   // Label 31906: @2315001
     /* 2315001 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2315047), // Rule ID 58887 //
     /* 2315006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2315009 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2315012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2315026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315046 */     // GIR_Coverage, 58887,
     /* 2315046 */     GIR_EraseRootFromParent_Done,
     /* 2315047 */   // Label 31907: @2315047
     /* 2315047 */   GIM_Reject,
     /* 2315048 */ // Label 31905: @2315048
     /* 2315048 */ GIM_Reject,
     /* 2315049 */ // Label 31873: @2315049
     /* 2315049 */ GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2315158),
     /* 2315054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315065 */   GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2315111), // Rule ID 58896 //
     /* 2315070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2315073 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2315076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2315090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315110 */     // GIR_Coverage, 58896,
     /* 2315110 */     GIR_EraseRootFromParent_Done,
     /* 2315111 */   // Label 31909: @2315111
     /* 2315111 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2315157), // Rule ID 58897 //
     /* 2315116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2315119 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2315122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2315136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315156 */     // GIR_Coverage, 58897,
     /* 2315156 */     GIR_EraseRootFromParent_Done,
     /* 2315157 */   // Label 31910: @2315157
     /* 2315157 */   GIM_Reject,
     /* 2315158 */ // Label 31908: @2315158
     /* 2315158 */ GIM_Reject,
     /* 2315159 */ // Label 31874: @2315159
     /* 2315159 */ GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2315268),
     /* 2315164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2315167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315175 */   GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2315221), // Rule ID 58888 //
     /* 2315180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2315183 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2315186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2315200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315220 */     // GIR_Coverage, 58888,
     /* 2315220 */     GIR_EraseRootFromParent_Done,
     /* 2315221 */   // Label 31912: @2315221
     /* 2315221 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2315267), // Rule ID 58889 //
     /* 2315226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2315229 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2315232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2315246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315266 */     // GIR_Coverage, 58889,
     /* 2315266 */     GIR_EraseRootFromParent_Done,
     /* 2315267 */   // Label 31913: @2315267
     /* 2315267 */   GIM_Reject,
     /* 2315268 */ // Label 31911: @2315268
     /* 2315268 */ GIM_Reject,
     /* 2315269 */ // Label 31875: @2315269
     /* 2315269 */ GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2315378),
     /* 2315274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2315277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315285 */   GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2315331), // Rule ID 58898 //
     /* 2315290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2315293 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2315296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2315310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315330 */     // GIR_Coverage, 58898,
     /* 2315330 */     GIR_EraseRootFromParent_Done,
     /* 2315331 */   // Label 31915: @2315331
     /* 2315331 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2315377), // Rule ID 58899 //
     /* 2315336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2315339 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2315342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2315356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315376 */     // GIR_Coverage, 58899,
     /* 2315376 */     GIR_EraseRootFromParent_Done,
     /* 2315377 */   // Label 31916: @2315377
     /* 2315377 */   GIM_Reject,
     /* 2315378 */ // Label 31914: @2315378
     /* 2315378 */ GIM_Reject,
     /* 2315379 */ // Label 31876: @2315379
     /* 2315379 */ GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2315488),
     /* 2315384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2315387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315395 */   GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2315441), // Rule ID 58890 //
     /* 2315400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2315403 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2315420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315440 */     // GIR_Coverage, 58890,
     /* 2315440 */     GIR_EraseRootFromParent_Done,
     /* 2315441 */   // Label 31918: @2315441
     /* 2315441 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2315487), // Rule ID 58891 //
     /* 2315446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2315449 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2315466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315486 */     // GIR_Coverage, 58891,
     /* 2315486 */     GIR_EraseRootFromParent_Done,
     /* 2315487 */   // Label 31919: @2315487
     /* 2315487 */   GIM_Reject,
     /* 2315488 */ // Label 31917: @2315488
     /* 2315488 */ GIM_Reject,
     /* 2315489 */ // Label 31877: @2315489
     /* 2315489 */ GIM_Reject,
     /* 2315490 */ // Label 67: @2315490
     /* 2315490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 31943*/ GIMT_Encode4(2320375),
     /* 2315501 */ /*GILLT_s32*//*Label 31920*/ GIMT_Encode4(2315617),
     /* 2315505 */ /*GILLT_s64*//*Label 31921*/ GIMT_Encode4(2315990), GIMT_Encode4(0),
     /* 2315513 */ /*GILLT_nxv1s8*//*Label 31922*/ GIMT_Encode4(2316177),
     /* 2315517 */ /*GILLT_nxv1s16*//*Label 31923*/ GIMT_Encode4(2316281),
     /* 2315521 */ /*GILLT_nxv1s32*//*Label 31924*/ GIMT_Encode4(2316498),
     /* 2315525 */ /*GILLT_nxv1s64*//*Label 31925*/ GIMT_Encode4(2316823), GIMT_Encode4(0),
     /* 2315533 */ /*GILLT_nxv2s8*//*Label 31926*/ GIMT_Encode4(2317040),
     /* 2315537 */ /*GILLT_nxv2s16*//*Label 31927*/ GIMT_Encode4(2317144),
     /* 2315541 */ /*GILLT_nxv2s32*//*Label 31928*/ GIMT_Encode4(2317361),
     /* 2315545 */ /*GILLT_nxv2s64*//*Label 31929*/ GIMT_Encode4(2317686), GIMT_Encode4(0),
     /* 2315553 */ /*GILLT_nxv4s8*//*Label 31930*/ GIMT_Encode4(2317903),
     /* 2315557 */ /*GILLT_nxv4s16*//*Label 31931*/ GIMT_Encode4(2318007),
     /* 2315561 */ /*GILLT_nxv4s32*//*Label 31932*/ GIMT_Encode4(2318224),
     /* 2315565 */ /*GILLT_nxv4s64*//*Label 31933*/ GIMT_Encode4(2318549), GIMT_Encode4(0),
     /* 2315573 */ /*GILLT_nxv8s8*//*Label 31934*/ GIMT_Encode4(2318766),
     /* 2315577 */ /*GILLT_nxv8s16*//*Label 31935*/ GIMT_Encode4(2318870),
     /* 2315581 */ /*GILLT_nxv8s32*//*Label 31936*/ GIMT_Encode4(2319087),
     /* 2315585 */ /*GILLT_nxv8s64*//*Label 31937*/ GIMT_Encode4(2319412), GIMT_Encode4(0),
     /* 2315593 */ /*GILLT_nxv16s8*//*Label 31938*/ GIMT_Encode4(2319629),
     /* 2315597 */ /*GILLT_nxv16s16*//*Label 31939*/ GIMT_Encode4(2319733),
     /* 2315601 */ /*GILLT_nxv16s32*//*Label 31940*/ GIMT_Encode4(2319950), GIMT_Encode4(0),
     /* 2315609 */ /*GILLT_nxv32s8*//*Label 31941*/ GIMT_Encode4(2320167),
     /* 2315613 */ /*GILLT_nxv32s16*//*Label 31942*/ GIMT_Encode4(2320271),
     /* 2315617 */ // Label 31920: @2315617
     /* 2315617 */ GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2315648), // Rule ID 1444 //
     /* 2315622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2315625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2315628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2315636 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2315636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2315639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315647 */   // GIR_Coverage, 1444,
     /* 2315647 */   GIR_EraseRootFromParent_Done,
     /* 2315648 */ // Label 31944: @2315648
     /* 2315648 */ GIM_Try, /*On fail goto*//*Label 31945*/ GIMT_Encode4(2315679), // Rule ID 1445 //
     /* 2315653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2315656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2315659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2315667 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2315667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2315670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315672 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315678 */   // GIR_Coverage, 1445,
     /* 2315678 */   GIR_EraseRootFromParent_Done,
     /* 2315679 */ // Label 31945: @2315679
     /* 2315679 */ GIM_Try, /*On fail goto*//*Label 31946*/ GIMT_Encode4(2315710), // Rule ID 1470 //
     /* 2315684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2315687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2315690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2315698 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2315698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2315701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315703 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315709 */   // GIR_Coverage, 1470,
     /* 2315709 */   GIR_EraseRootFromParent_Done,
     /* 2315710 */ // Label 31946: @2315710
     /* 2315710 */ GIM_Try, /*On fail goto*//*Label 31947*/ GIMT_Encode4(2315741), // Rule ID 1471 //
     /* 2315715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2315718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2315721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2315729 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2315729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2315732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315734 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315740 */   // GIR_Coverage, 1471,
     /* 2315740 */   GIR_EraseRootFromParent_Done,
     /* 2315741 */ // Label 31947: @2315741
     /* 2315741 */ GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2315772), // Rule ID 1842 //
     /* 2315746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2315749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2315752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2315760 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2315760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2315763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315765 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315771 */   // GIR_Coverage, 1842,
     /* 2315771 */   GIR_EraseRootFromParent_Done,
     /* 2315772 */ // Label 31948: @2315772
     /* 2315772 */ GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2315803), // Rule ID 1843 //
     /* 2315777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2315780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2315783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2315791 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2315791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2315794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315801 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315802 */   // GIR_Coverage, 1843,
     /* 2315802 */   GIR_EraseRootFromParent_Done,
     /* 2315803 */ // Label 31949: @2315803
     /* 2315803 */ GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2315834), // Rule ID 1868 //
     /* 2315808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2315811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2315814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2315822 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2315822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2315825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315827 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315833 */   // GIR_Coverage, 1868,
     /* 2315833 */   GIR_EraseRootFromParent_Done,
     /* 2315834 */ // Label 31950: @2315834
     /* 2315834 */ GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2315865), // Rule ID 1869 //
     /* 2315839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2315842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2315845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2315853 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2315853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2315856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315864 */   // GIR_Coverage, 1869,
     /* 2315864 */   GIR_EraseRootFromParent_Done,
     /* 2315865 */ // Label 31951: @2315865
     /* 2315865 */ GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2315896), // Rule ID 2184 //
     /* 2315870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2315873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2315876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2315884 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2315884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2315887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315895 */   // GIR_Coverage, 2184,
     /* 2315895 */   GIR_EraseRootFromParent_Done,
     /* 2315896 */ // Label 31952: @2315896
     /* 2315896 */ GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2315927), // Rule ID 2185 //
     /* 2315901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2315904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2315907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2315915 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2315915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2315918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315920 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315925 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315926 */   // GIR_Coverage, 2185,
     /* 2315926 */   GIR_EraseRootFromParent_Done,
     /* 2315927 */ // Label 31953: @2315927
     /* 2315927 */ GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2315958), // Rule ID 2210 //
     /* 2315932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2315935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2315938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2315946 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2315946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2315949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315951 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315957 */   // GIR_Coverage, 2210,
     /* 2315957 */   GIR_EraseRootFromParent_Done,
     /* 2315958 */ // Label 31954: @2315958
     /* 2315958 */ GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2315989), // Rule ID 2211 //
     /* 2315963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2315966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2315969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2315973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2315977 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2315977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2315980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315988 */   // GIR_Coverage, 2211,
     /* 2315988 */   GIR_EraseRootFromParent_Done,
     /* 2315989 */ // Label 31955: @2315989
     /* 2315989 */ GIM_Reject,
     /* 2315990 */ // Label 31921: @2315990
     /* 2315990 */ GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2316021), // Rule ID 1501 //
     /* 2315995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2315998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2316009 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2316012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316014 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316020 */   // GIR_Coverage, 1501,
     /* 2316020 */   GIR_EraseRootFromParent_Done,
     /* 2316021 */ // Label 31956: @2316021
     /* 2316021 */ GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2316052), // Rule ID 1529 //
     /* 2316026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2316029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2316040 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2316043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316045 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316051 */   // GIR_Coverage, 1529,
     /* 2316051 */   GIR_EraseRootFromParent_Done,
     /* 2316052 */ // Label 31957: @2316052
     /* 2316052 */ GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2316083), // Rule ID 1905 //
     /* 2316057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2316060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2316071 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2316074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316076 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316082 */   // GIR_Coverage, 1905,
     /* 2316082 */   GIR_EraseRootFromParent_Done,
     /* 2316083 */ // Label 31958: @2316083
     /* 2316083 */ GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2316114), // Rule ID 1933 //
     /* 2316088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2316091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316102 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2316105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316107 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316113 */   // GIR_Coverage, 1933,
     /* 2316113 */   GIR_EraseRootFromParent_Done,
     /* 2316114 */ // Label 31959: @2316114
     /* 2316114 */ GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2316145), // Rule ID 2239 //
     /* 2316119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2316122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2316133 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2316136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316138 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316144 */   // GIR_Coverage, 2239,
     /* 2316144 */   GIR_EraseRootFromParent_Done,
     /* 2316145 */ // Label 31960: @2316145
     /* 2316145 */ GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2316176), // Rule ID 2265 //
     /* 2316150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2316153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2316164 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2316167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316169 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316175 */   // GIR_Coverage, 2265,
     /* 2316175 */   GIR_EraseRootFromParent_Done,
     /* 2316176 */ // Label 31961: @2316176
     /* 2316176 */ GIM_Reject,
     /* 2316177 */ // Label 31922: @2316177
     /* 2316177 */ GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2316280),
     /* 2316182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316193 */   GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2316236), // Rule ID 45812 //
     /* 2316198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2316201 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2316204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2316218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316235 */     // GIR_Coverage, 45812,
     /* 2316235 */     GIR_EraseRootFromParent_Done,
     /* 2316236 */   // Label 31963: @2316236
     /* 2316236 */   GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2316279), // Rule ID 45813 //
     /* 2316241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316244 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2316247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2316261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316278 */     // GIR_Coverage, 45813,
     /* 2316278 */     GIR_EraseRootFromParent_Done,
     /* 2316279 */   // Label 31964: @2316279
     /* 2316279 */   GIM_Reject,
     /* 2316280 */ // Label 31962: @2316280
     /* 2316280 */ GIM_Reject,
     /* 2316281 */ // Label 31923: @2316281
     /* 2316281 */ GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2316335), // Rule ID 45796 //
     /* 2316286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2316289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316300 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2316317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316322 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316334 */   // GIR_Coverage, 45796,
     /* 2316334 */   GIR_EraseRootFromParent_Done,
     /* 2316335 */ // Label 31965: @2316335
     /* 2316335 */ GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2316389), // Rule ID 45797 //
     /* 2316340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316354 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2316371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316376 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316388 */   // GIR_Coverage, 45797,
     /* 2316388 */   GIR_EraseRootFromParent_Done,
     /* 2316389 */ // Label 31966: @2316389
     /* 2316389 */ GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2316443), // Rule ID 58720 //
     /* 2316394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2316397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316408 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2316425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316430 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316442 */   // GIR_Coverage, 58720,
     /* 2316442 */   GIR_EraseRootFromParent_Done,
     /* 2316443 */ // Label 31967: @2316443
     /* 2316443 */ GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2316497), // Rule ID 58721 //
     /* 2316448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2316451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316462 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2316479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316484 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316496 */   // GIR_Coverage, 58721,
     /* 2316496 */   GIR_EraseRootFromParent_Done,
     /* 2316497 */ // Label 31968: @2316497
     /* 2316497 */ GIM_Reject,
     /* 2316498 */ // Label 31924: @2316498
     /* 2316498 */ GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2316552), // Rule ID 45804 //
     /* 2316503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2316506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316517 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2316534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316539 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316551 */   // GIR_Coverage, 45804,
     /* 2316551 */   GIR_EraseRootFromParent_Done,
     /* 2316552 */ // Label 31969: @2316552
     /* 2316552 */ GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2316606), // Rule ID 45805 //
     /* 2316557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316571 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2316588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316593 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316605 */   // GIR_Coverage, 45805,
     /* 2316605 */   GIR_EraseRootFromParent_Done,
     /* 2316606 */ // Label 31970: @2316606
     /* 2316606 */ GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2316660), // Rule ID 58288 //
     /* 2316611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2316614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316625 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2316642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316659 */   // GIR_Coverage, 58288,
     /* 2316659 */   GIR_EraseRootFromParent_Done,
     /* 2316660 */ // Label 31971: @2316660
     /* 2316660 */ GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2316714), // Rule ID 58289 //
     /* 2316665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2316668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316679 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2316696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316701 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316713 */   // GIR_Coverage, 58289,
     /* 2316713 */   GIR_EraseRootFromParent_Done,
     /* 2316714 */ // Label 31972: @2316714
     /* 2316714 */ GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2316768), // Rule ID 58740 //
     /* 2316719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2316722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316733 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2316750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316755 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316767 */   // GIR_Coverage, 58740,
     /* 2316767 */   GIR_EraseRootFromParent_Done,
     /* 2316768 */ // Label 31973: @2316768
     /* 2316768 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2316822), // Rule ID 58741 //
     /* 2316773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2316776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316787 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2316790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2316804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316809 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316821 */   // GIR_Coverage, 58741,
     /* 2316821 */   GIR_EraseRootFromParent_Done,
     /* 2316822 */ // Label 31974: @2316822
     /* 2316822 */ GIM_Reject,
     /* 2316823 */ // Label 31925: @2316823
     /* 2316823 */ GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2316877), // Rule ID 58300 //
     /* 2316828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2316831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316842 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2316845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2316859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316864 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316876 */   // GIR_Coverage, 58300,
     /* 2316876 */   GIR_EraseRootFromParent_Done,
     /* 2316877 */ // Label 31975: @2316877
     /* 2316877 */ GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2316931), // Rule ID 58301 //
     /* 2316882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2316885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2316888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316896 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2316899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2316913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2316926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316930 */   // GIR_Coverage, 58301,
     /* 2316930 */   GIR_EraseRootFromParent_Done,
     /* 2316931 */ // Label 31976: @2316931
     /* 2316931 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2316985), // Rule ID 58532 //
     /* 2316936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2316939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316950 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2316953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2316967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316972 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316984 */   // GIR_Coverage, 58532,
     /* 2316984 */   GIR_EraseRootFromParent_Done,
     /* 2316985 */ // Label 31977: @2316985
     /* 2316985 */ GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2317039), // Rule ID 58533 //
     /* 2316990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2316993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317004 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2317007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2317021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317026 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317038 */   // GIR_Coverage, 58533,
     /* 2317038 */   GIR_EraseRootFromParent_Done,
     /* 2317039 */ // Label 31978: @2317039
     /* 2317039 */ GIM_Reject,
     /* 2317040 */ // Label 31926: @2317040
     /* 2317040 */ GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2317143),
     /* 2317045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317056 */   GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2317099), // Rule ID 58700 //
     /* 2317061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317064 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2317067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2317081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317098 */     // GIR_Coverage, 58700,
     /* 2317098 */     GIR_EraseRootFromParent_Done,
     /* 2317099 */   // Label 31980: @2317099
     /* 2317099 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2317142), // Rule ID 58701 //
     /* 2317104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317107 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2317110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2317124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317141 */     // GIR_Coverage, 58701,
     /* 2317141 */     GIR_EraseRootFromParent_Done,
     /* 2317142 */   // Label 31981: @2317142
     /* 2317142 */   GIM_Reject,
     /* 2317143 */ // Label 31979: @2317143
     /* 2317143 */ GIM_Reject,
     /* 2317144 */ // Label 31927: @2317144
     /* 2317144 */ GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2317198), // Rule ID 58284 //
     /* 2317149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317163 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2317180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317185 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317197 */   // GIR_Coverage, 58284,
     /* 2317197 */   GIR_EraseRootFromParent_Done,
     /* 2317198 */ // Label 31982: @2317198
     /* 2317198 */ GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2317252), // Rule ID 58285 //
     /* 2317203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317217 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2317234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317239 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317251 */   // GIR_Coverage, 58285,
     /* 2317251 */   GIR_EraseRootFromParent_Done,
     /* 2317252 */ // Label 31983: @2317252
     /* 2317252 */ GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2317306), // Rule ID 58724 //
     /* 2317257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2317260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317271 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2317288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317293 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317305 */   // GIR_Coverage, 58724,
     /* 2317305 */   GIR_EraseRootFromParent_Done,
     /* 2317306 */ // Label 31984: @2317306
     /* 2317306 */ GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2317360), // Rule ID 58725 //
     /* 2317311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317325 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2317342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317347 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317359 */   // GIR_Coverage, 58725,
     /* 2317359 */   GIR_EraseRootFromParent_Done,
     /* 2317360 */ // Label 31985: @2317360
     /* 2317360 */ GIM_Reject,
     /* 2317361 */ // Label 31928: @2317361
     /* 2317361 */ GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2317415), // Rule ID 58296 //
     /* 2317366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2317369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317380 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2317397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317402 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317414 */   // GIR_Coverage, 58296,
     /* 2317414 */   GIR_EraseRootFromParent_Done,
     /* 2317415 */ // Label 31986: @2317415
     /* 2317415 */ GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2317469), // Rule ID 58297 //
     /* 2317420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317434 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2317451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317456 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317468 */   // GIR_Coverage, 58297,
     /* 2317468 */   GIR_EraseRootFromParent_Done,
     /* 2317469 */ // Label 31987: @2317469
     /* 2317469 */ GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2317523), // Rule ID 58516 //
     /* 2317474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317488 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2317505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317510 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317522 */   // GIR_Coverage, 58516,
     /* 2317522 */   GIR_EraseRootFromParent_Done,
     /* 2317523 */ // Label 31988: @2317523
     /* 2317523 */ GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2317577), // Rule ID 58517 //
     /* 2317528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317542 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2317559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317576 */   // GIR_Coverage, 58517,
     /* 2317576 */   GIR_EraseRootFromParent_Done,
     /* 2317577 */ // Label 31989: @2317577
     /* 2317577 */ GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2317631), // Rule ID 58744 //
     /* 2317582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2317585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2317588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317596 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2317613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317618 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317630 */   // GIR_Coverage, 58744,
     /* 2317630 */   GIR_EraseRootFromParent_Done,
     /* 2317631 */ // Label 31990: @2317631
     /* 2317631 */ GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2317685), // Rule ID 58745 //
     /* 2317636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2317639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2317642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317650 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2317667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317672 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317684 */   // GIR_Coverage, 58745,
     /* 2317684 */   GIR_EraseRootFromParent_Done,
     /* 2317685 */ // Label 31991: @2317685
     /* 2317685 */ GIM_Reject,
     /* 2317686 */ // Label 31929: @2317686
     /* 2317686 */ GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2317740), // Rule ID 58328 //
     /* 2317691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2317694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2317697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317705 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2317708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2317722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317739 */   // GIR_Coverage, 58328,
     /* 2317739 */   GIR_EraseRootFromParent_Done,
     /* 2317740 */ // Label 31992: @2317740
     /* 2317740 */ GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2317794), // Rule ID 58329 //
     /* 2317745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2317748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2317751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317759 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2317762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2317776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317793 */   // GIR_Coverage, 58329,
     /* 2317793 */   GIR_EraseRootFromParent_Done,
     /* 2317794 */ // Label 31993: @2317794
     /* 2317794 */ GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2317848), // Rule ID 58536 //
     /* 2317799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2317802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317813 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2317816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2317830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317847 */   // GIR_Coverage, 58536,
     /* 2317847 */   GIR_EraseRootFromParent_Done,
     /* 2317848 */ // Label 31994: @2317848
     /* 2317848 */ GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2317902), // Rule ID 58537 //
     /* 2317853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2317856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2317863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317867 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2317870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2317884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317901 */   // GIR_Coverage, 58537,
     /* 2317901 */   GIR_EraseRootFromParent_Done,
     /* 2317902 */ // Label 31995: @2317902
     /* 2317902 */ GIM_Reject,
     /* 2317903 */ // Label 31930: @2317903
     /* 2317903 */ GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2318006),
     /* 2317908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2317911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317919 */   GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2317962), // Rule ID 58704 //
     /* 2317924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317927 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2317930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2317944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317961 */     // GIR_Coverage, 58704,
     /* 2317961 */     GIR_EraseRootFromParent_Done,
     /* 2317962 */   // Label 31997: @2317962
     /* 2317962 */   GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2318005), // Rule ID 58705 //
     /* 2317967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317970 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2317973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2317987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318004 */     // GIR_Coverage, 58705,
     /* 2318004 */     GIR_EraseRootFromParent_Done,
     /* 2318005 */   // Label 31998: @2318005
     /* 2318005 */   GIM_Reject,
     /* 2318006 */ // Label 31996: @2318006
     /* 2318006 */ GIM_Reject,
     /* 2318007 */ // Label 31931: @2318007
     /* 2318007 */ GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2318061), // Rule ID 58292 //
     /* 2318012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318026 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2318043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318060 */   // GIR_Coverage, 58292,
     /* 2318060 */   GIR_EraseRootFromParent_Done,
     /* 2318061 */ // Label 31999: @2318061
     /* 2318061 */ GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2318115), // Rule ID 58293 //
     /* 2318066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318080 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2318097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318102 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318114 */   // GIR_Coverage, 58293,
     /* 2318114 */   GIR_EraseRootFromParent_Done,
     /* 2318115 */ // Label 32000: @2318115
     /* 2318115 */ GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2318169), // Rule ID 58728 //
     /* 2318120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2318123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318134 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2318151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318156 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318168 */   // GIR_Coverage, 58728,
     /* 2318168 */   GIR_EraseRootFromParent_Done,
     /* 2318169 */ // Label 32001: @2318169
     /* 2318169 */ GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2318223), // Rule ID 58729 //
     /* 2318174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2318177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318188 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2318205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318210 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318222 */   // GIR_Coverage, 58729,
     /* 2318222 */   GIR_EraseRootFromParent_Done,
     /* 2318223 */ // Label 32002: @2318223
     /* 2318223 */ GIM_Reject,
     /* 2318224 */ // Label 31932: @2318224
     /* 2318224 */ GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2318278), // Rule ID 58316 //
     /* 2318229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2318232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318243 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2318260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318277 */   // GIR_Coverage, 58316,
     /* 2318277 */   GIR_EraseRootFromParent_Done,
     /* 2318278 */ // Label 32003: @2318278
     /* 2318278 */ GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2318332), // Rule ID 58317 //
     /* 2318283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2318286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318297 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318297 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318300 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318304 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2318314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318319 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318331 */   // GIR_Coverage, 58317,
     /* 2318331 */   GIR_EraseRootFromParent_Done,
     /* 2318332 */ // Label 32004: @2318332
     /* 2318332 */ GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2318386), // Rule ID 58520 //
     /* 2318337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318351 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2318368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318373 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318385 */   // GIR_Coverage, 58520,
     /* 2318385 */   GIR_EraseRootFromParent_Done,
     /* 2318386 */ // Label 32005: @2318386
     /* 2318386 */ GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2318440), // Rule ID 58521 //
     /* 2318391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318405 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2318422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318439 */   // GIR_Coverage, 58521,
     /* 2318439 */   GIR_EraseRootFromParent_Done,
     /* 2318440 */ // Label 32006: @2318440
     /* 2318440 */ GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2318494), // Rule ID 58748 //
     /* 2318445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2318448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2318451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318459 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2318476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318493 */   // GIR_Coverage, 58748,
     /* 2318493 */   GIR_EraseRootFromParent_Done,
     /* 2318494 */ // Label 32007: @2318494
     /* 2318494 */ GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2318548), // Rule ID 58749 //
     /* 2318499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2318502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2318505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318513 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2318530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318547 */   // GIR_Coverage, 58749,
     /* 2318547 */   GIR_EraseRootFromParent_Done,
     /* 2318548 */ // Label 32008: @2318548
     /* 2318548 */ GIM_Reject,
     /* 2318549 */ // Label 31933: @2318549
     /* 2318549 */ GIM_Try, /*On fail goto*//*Label 32009*/ GIMT_Encode4(2318603), // Rule ID 58332 //
     /* 2318554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2318557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2318560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318568 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2318571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2318585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318602 */   // GIR_Coverage, 58332,
     /* 2318602 */   GIR_EraseRootFromParent_Done,
     /* 2318603 */ // Label 32009: @2318603
     /* 2318603 */ GIM_Try, /*On fail goto*//*Label 32010*/ GIMT_Encode4(2318657), // Rule ID 58333 //
     /* 2318608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2318611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2318614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318622 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2318625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2318639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318656 */   // GIR_Coverage, 58333,
     /* 2318656 */   GIR_EraseRootFromParent_Done,
     /* 2318657 */ // Label 32010: @2318657
     /* 2318657 */ GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2318711), // Rule ID 58540 //
     /* 2318662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2318665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318676 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2318679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2318693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318710 */   // GIR_Coverage, 58540,
     /* 2318710 */   GIR_EraseRootFromParent_Done,
     /* 2318711 */ // Label 32011: @2318711
     /* 2318711 */ GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2318765), // Rule ID 58541 //
     /* 2318716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2318719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318730 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2318733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2318747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318752 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318764 */   // GIR_Coverage, 58541,
     /* 2318764 */   GIR_EraseRootFromParent_Done,
     /* 2318765 */ // Label 32012: @2318765
     /* 2318765 */ GIM_Reject,
     /* 2318766 */ // Label 31934: @2318766
     /* 2318766 */ GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2318869),
     /* 2318771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318782 */   GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2318825), // Rule ID 58708 //
     /* 2318787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318790 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2318793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2318807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318824 */     // GIR_Coverage, 58708,
     /* 2318824 */     GIR_EraseRootFromParent_Done,
     /* 2318825 */   // Label 32014: @2318825
     /* 2318825 */   GIM_Try, /*On fail goto*//*Label 32015*/ GIMT_Encode4(2318868), // Rule ID 58709 //
     /* 2318830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318833 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2318836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2318850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318867 */     // GIR_Coverage, 58709,
     /* 2318867 */     GIR_EraseRootFromParent_Done,
     /* 2318868 */   // Label 32015: @2318868
     /* 2318868 */   GIM_Reject,
     /* 2318869 */ // Label 32013: @2318869
     /* 2318869 */ GIM_Reject,
     /* 2318870 */ // Label 31935: @2318870
     /* 2318870 */ GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2318924), // Rule ID 58304 //
     /* 2318875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318889 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2318892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2318906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318911 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318923 */   // GIR_Coverage, 58304,
     /* 2318923 */   GIR_EraseRootFromParent_Done,
     /* 2318924 */ // Label 32016: @2318924
     /* 2318924 */ GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2318978), // Rule ID 58305 //
     /* 2318929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2318935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318943 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2318946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2318960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318977 */   // GIR_Coverage, 58305,
     /* 2318977 */   GIR_EraseRootFromParent_Done,
     /* 2318978 */ // Label 32017: @2318978
     /* 2318978 */ GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2319032), // Rule ID 58732 //
     /* 2318983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2318986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2318989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318997 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2319014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319031 */   // GIR_Coverage, 58732,
     /* 2319031 */   GIR_EraseRootFromParent_Done,
     /* 2319032 */ // Label 32018: @2319032
     /* 2319032 */ GIM_Try, /*On fail goto*//*Label 32019*/ GIMT_Encode4(2319086), // Rule ID 58733 //
     /* 2319037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2319040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319051 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2319068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319073 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319085 */   // GIR_Coverage, 58733,
     /* 2319085 */   GIR_EraseRootFromParent_Done,
     /* 2319086 */ // Label 32019: @2319086
     /* 2319086 */ GIM_Reject,
     /* 2319087 */ // Label 31936: @2319087
     /* 2319087 */ GIM_Try, /*On fail goto*//*Label 32020*/ GIMT_Encode4(2319141), // Rule ID 58320 //
     /* 2319092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2319095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319106 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2319123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319128 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319140 */   // GIR_Coverage, 58320,
     /* 2319140 */   GIR_EraseRootFromParent_Done,
     /* 2319141 */ // Label 32020: @2319141
     /* 2319141 */ GIM_Try, /*On fail goto*//*Label 32021*/ GIMT_Encode4(2319195), // Rule ID 58321 //
     /* 2319146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2319149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319160 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2319177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319182 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319193 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319194 */   // GIR_Coverage, 58321,
     /* 2319194 */   GIR_EraseRootFromParent_Done,
     /* 2319195 */ // Label 32021: @2319195
     /* 2319195 */ GIM_Try, /*On fail goto*//*Label 32022*/ GIMT_Encode4(2319249), // Rule ID 58524 //
     /* 2319200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319214 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2319231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319248 */   // GIR_Coverage, 58524,
     /* 2319248 */   GIR_EraseRootFromParent_Done,
     /* 2319249 */ // Label 32022: @2319249
     /* 2319249 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2319303), // Rule ID 58525 //
     /* 2319254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319268 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2319285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319302 */   // GIR_Coverage, 58525,
     /* 2319302 */   GIR_EraseRootFromParent_Done,
     /* 2319303 */ // Label 32023: @2319303
     /* 2319303 */ GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2319357), // Rule ID 58752 //
     /* 2319308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2319311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319322 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2319339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319356 */   // GIR_Coverage, 58752,
     /* 2319356 */   GIR_EraseRootFromParent_Done,
     /* 2319357 */ // Label 32024: @2319357
     /* 2319357 */ GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2319411), // Rule ID 58753 //
     /* 2319362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2319365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319376 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2319393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319398 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319409 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319410 */   // GIR_Coverage, 58753,
     /* 2319410 */   GIR_EraseRootFromParent_Done,
     /* 2319411 */ // Label 32025: @2319411
     /* 2319411 */ GIM_Reject,
     /* 2319412 */ // Label 31937: @2319412
     /* 2319412 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2319466), // Rule ID 58336 //
     /* 2319417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2319420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319431 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2319434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2319448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319453 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319465 */   // GIR_Coverage, 58336,
     /* 2319465 */   GIR_EraseRootFromParent_Done,
     /* 2319466 */ // Label 32026: @2319466
     /* 2319466 */ GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2319520), // Rule ID 58337 //
     /* 2319471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2319474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319485 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2319488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2319502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319507 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319519 */   // GIR_Coverage, 58337,
     /* 2319519 */   GIR_EraseRootFromParent_Done,
     /* 2319520 */ // Label 32027: @2319520
     /* 2319520 */ GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2319574), // Rule ID 58544 //
     /* 2319525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2319528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319539 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2319542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2319556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319561 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319573 */   // GIR_Coverage, 58544,
     /* 2319573 */   GIR_EraseRootFromParent_Done,
     /* 2319574 */ // Label 32028: @2319574
     /* 2319574 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2319628), // Rule ID 58545 //
     /* 2319579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2319582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319593 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2319596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2319610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319615 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319627 */   // GIR_Coverage, 58545,
     /* 2319627 */   GIR_EraseRootFromParent_Done,
     /* 2319628 */ // Label 32029: @2319628
     /* 2319628 */ GIM_Reject,
     /* 2319629 */ // Label 31938: @2319629
     /* 2319629 */ GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2319732),
     /* 2319634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2319637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319645 */   GIM_Try, /*On fail goto*//*Label 32031*/ GIMT_Encode4(2319688), // Rule ID 58712 //
     /* 2319650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319653 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2319656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2319670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319687 */     // GIR_Coverage, 58712,
     /* 2319687 */     GIR_EraseRootFromParent_Done,
     /* 2319688 */   // Label 32031: @2319688
     /* 2319688 */   GIM_Try, /*On fail goto*//*Label 32032*/ GIMT_Encode4(2319731), // Rule ID 58713 //
     /* 2319693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319696 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2319699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2319713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319730 */     // GIR_Coverage, 58713,
     /* 2319730 */     GIR_EraseRootFromParent_Done,
     /* 2319731 */   // Label 32032: @2319731
     /* 2319731 */   GIM_Reject,
     /* 2319732 */ // Label 32030: @2319732
     /* 2319732 */ GIM_Reject,
     /* 2319733 */ // Label 31939: @2319733
     /* 2319733 */ GIM_Try, /*On fail goto*//*Label 32033*/ GIMT_Encode4(2319787), // Rule ID 58308 //
     /* 2319738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2319744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319752 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2319755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2319769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319786 */   // GIR_Coverage, 58308,
     /* 2319786 */   GIR_EraseRootFromParent_Done,
     /* 2319787 */ // Label 32033: @2319787
     /* 2319787 */ GIM_Try, /*On fail goto*//*Label 32034*/ GIMT_Encode4(2319841), // Rule ID 58309 //
     /* 2319792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2319798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319806 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2319809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2319823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319840 */   // GIR_Coverage, 58309,
     /* 2319840 */   GIR_EraseRootFromParent_Done,
     /* 2319841 */ // Label 32034: @2319841
     /* 2319841 */ GIM_Try, /*On fail goto*//*Label 32035*/ GIMT_Encode4(2319895), // Rule ID 58736 //
     /* 2319846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2319849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319860 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2319863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2319877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319882 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319894 */   // GIR_Coverage, 58736,
     /* 2319894 */   GIR_EraseRootFromParent_Done,
     /* 2319895 */ // Label 32035: @2319895
     /* 2319895 */ GIM_Try, /*On fail goto*//*Label 32036*/ GIMT_Encode4(2319949), // Rule ID 58737 //
     /* 2319900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2319903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319914 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2319917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2319931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319936 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319948 */   // GIR_Coverage, 58737,
     /* 2319948 */   GIR_EraseRootFromParent_Done,
     /* 2319949 */ // Label 32036: @2319949
     /* 2319949 */ GIM_Reject,
     /* 2319950 */ // Label 31940: @2319950
     /* 2319950 */ GIM_Try, /*On fail goto*//*Label 32037*/ GIMT_Encode4(2320004), // Rule ID 58324 //
     /* 2319955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2319958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319969 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2319972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2319986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320003 */   // GIR_Coverage, 58324,
     /* 2320003 */   GIR_EraseRootFromParent_Done,
     /* 2320004 */ // Label 32037: @2320004
     /* 2320004 */ GIM_Try, /*On fail goto*//*Label 32038*/ GIMT_Encode4(2320058), // Rule ID 58325 //
     /* 2320009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2320012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2320015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320023 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2320040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320045 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320057 */   // GIR_Coverage, 58325,
     /* 2320057 */   GIR_EraseRootFromParent_Done,
     /* 2320058 */ // Label 32038: @2320058
     /* 2320058 */ GIM_Try, /*On fail goto*//*Label 32039*/ GIMT_Encode4(2320112), // Rule ID 58528 //
     /* 2320063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320077 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2320094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320111 */   // GIR_Coverage, 58528,
     /* 2320111 */   GIR_EraseRootFromParent_Done,
     /* 2320112 */ // Label 32039: @2320112
     /* 2320112 */ GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2320166), // Rule ID 58529 //
     /* 2320117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320131 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2320148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320153 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320165 */   // GIR_Coverage, 58529,
     /* 2320165 */   GIR_EraseRootFromParent_Done,
     /* 2320166 */ // Label 32040: @2320166
     /* 2320166 */ GIM_Reject,
     /* 2320167 */ // Label 31941: @2320167
     /* 2320167 */ GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2320270),
     /* 2320172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320183 */   GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2320226), // Rule ID 58716 //
     /* 2320188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320191 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2320194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2320208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320225 */     // GIR_Coverage, 58716,
     /* 2320225 */     GIR_EraseRootFromParent_Done,
     /* 2320226 */   // Label 32042: @2320226
     /* 2320226 */   GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2320269), // Rule ID 58717 //
     /* 2320231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320234 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2320237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2320251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320268 */     // GIR_Coverage, 58717,
     /* 2320268 */     GIR_EraseRootFromParent_Done,
     /* 2320269 */   // Label 32043: @2320269
     /* 2320269 */   GIM_Reject,
     /* 2320270 */ // Label 32041: @2320270
     /* 2320270 */ GIM_Reject,
     /* 2320271 */ // Label 31942: @2320271
     /* 2320271 */ GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2320374),
     /* 2320276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320287 */   GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2320330), // Rule ID 58312 //
     /* 2320292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320295 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2320298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2320312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320329 */     // GIR_Coverage, 58312,
     /* 2320329 */     GIR_EraseRootFromParent_Done,
     /* 2320330 */   // Label 32045: @2320330
     /* 2320330 */   GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2320373), // Rule ID 58313 //
     /* 2320335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320338 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2320341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2320355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320372 */     // GIR_Coverage, 58313,
     /* 2320372 */     GIR_EraseRootFromParent_Done,
     /* 2320373 */   // Label 32046: @2320373
     /* 2320373 */   GIM_Reject,
     /* 2320374 */ // Label 32044: @2320374
     /* 2320374 */ GIM_Reject,
     /* 2320375 */ // Label 31943: @2320375
     /* 2320375 */ GIM_Reject,
     /* 2320376 */ // Label 68: @2320376
     /* 2320376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32070*/ GIMT_Encode4(2325261),
     /* 2320387 */ /*GILLT_s32*//*Label 32047*/ GIMT_Encode4(2320503),
     /* 2320391 */ /*GILLT_s64*//*Label 32048*/ GIMT_Encode4(2320876), GIMT_Encode4(0),
     /* 2320399 */ /*GILLT_nxv1s8*//*Label 32049*/ GIMT_Encode4(2321063),
     /* 2320403 */ /*GILLT_nxv1s16*//*Label 32050*/ GIMT_Encode4(2321167),
     /* 2320407 */ /*GILLT_nxv1s32*//*Label 32051*/ GIMT_Encode4(2321384),
     /* 2320411 */ /*GILLT_nxv1s64*//*Label 32052*/ GIMT_Encode4(2321709), GIMT_Encode4(0),
     /* 2320419 */ /*GILLT_nxv2s8*//*Label 32053*/ GIMT_Encode4(2321926),
     /* 2320423 */ /*GILLT_nxv2s16*//*Label 32054*/ GIMT_Encode4(2322030),
     /* 2320427 */ /*GILLT_nxv2s32*//*Label 32055*/ GIMT_Encode4(2322247),
     /* 2320431 */ /*GILLT_nxv2s64*//*Label 32056*/ GIMT_Encode4(2322572), GIMT_Encode4(0),
     /* 2320439 */ /*GILLT_nxv4s8*//*Label 32057*/ GIMT_Encode4(2322789),
     /* 2320443 */ /*GILLT_nxv4s16*//*Label 32058*/ GIMT_Encode4(2322893),
     /* 2320447 */ /*GILLT_nxv4s32*//*Label 32059*/ GIMT_Encode4(2323110),
     /* 2320451 */ /*GILLT_nxv4s64*//*Label 32060*/ GIMT_Encode4(2323435), GIMT_Encode4(0),
     /* 2320459 */ /*GILLT_nxv8s8*//*Label 32061*/ GIMT_Encode4(2323652),
     /* 2320463 */ /*GILLT_nxv8s16*//*Label 32062*/ GIMT_Encode4(2323756),
     /* 2320467 */ /*GILLT_nxv8s32*//*Label 32063*/ GIMT_Encode4(2323973),
     /* 2320471 */ /*GILLT_nxv8s64*//*Label 32064*/ GIMT_Encode4(2324298), GIMT_Encode4(0),
     /* 2320479 */ /*GILLT_nxv16s8*//*Label 32065*/ GIMT_Encode4(2324515),
     /* 2320483 */ /*GILLT_nxv16s16*//*Label 32066*/ GIMT_Encode4(2324619),
     /* 2320487 */ /*GILLT_nxv16s32*//*Label 32067*/ GIMT_Encode4(2324836), GIMT_Encode4(0),
     /* 2320495 */ /*GILLT_nxv32s8*//*Label 32068*/ GIMT_Encode4(2325053),
     /* 2320499 */ /*GILLT_nxv32s16*//*Label 32069*/ GIMT_Encode4(2325157),
     /* 2320503 */ // Label 32047: @2320503
     /* 2320503 */ GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2320534), // Rule ID 1448 //
     /* 2320508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2320511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320522 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2320522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2320525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320533 */   // GIR_Coverage, 1448,
     /* 2320533 */   GIR_EraseRootFromParent_Done,
     /* 2320534 */ // Label 32071: @2320534
     /* 2320534 */ GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2320565), // Rule ID 1449 //
     /* 2320539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2320542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320553 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2320553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2320556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320564 */   // GIR_Coverage, 1449,
     /* 2320564 */   GIR_EraseRootFromParent_Done,
     /* 2320565 */ // Label 32072: @2320565
     /* 2320565 */ GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2320596), // Rule ID 1474 //
     /* 2320570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2320573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320584 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2320584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2320587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320595 */   // GIR_Coverage, 1474,
     /* 2320595 */   GIR_EraseRootFromParent_Done,
     /* 2320596 */ // Label 32073: @2320596
     /* 2320596 */ GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2320627), // Rule ID 1475 //
     /* 2320601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2320604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320615 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2320615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2320618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320620 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320626 */   // GIR_Coverage, 1475,
     /* 2320626 */   GIR_EraseRootFromParent_Done,
     /* 2320627 */ // Label 32074: @2320627
     /* 2320627 */ GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2320658), // Rule ID 1846 //
     /* 2320632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2320635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320646 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2320646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2320649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320651 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320657 */   // GIR_Coverage, 1846,
     /* 2320657 */   GIR_EraseRootFromParent_Done,
     /* 2320658 */ // Label 32075: @2320658
     /* 2320658 */ GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2320689), // Rule ID 1847 //
     /* 2320663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2320666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320677 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2320677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2320680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320682 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320688 */   // GIR_Coverage, 1847,
     /* 2320688 */   GIR_EraseRootFromParent_Done,
     /* 2320689 */ // Label 32076: @2320689
     /* 2320689 */ GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2320720), // Rule ID 1872 //
     /* 2320694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2320697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320708 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2320708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2320711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320713 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320719 */   // GIR_Coverage, 1872,
     /* 2320719 */   GIR_EraseRootFromParent_Done,
     /* 2320720 */ // Label 32077: @2320720
     /* 2320720 */ GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2320751), // Rule ID 1873 //
     /* 2320725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2320728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320739 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2320739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2320742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320744 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320750 */   // GIR_Coverage, 1873,
     /* 2320750 */   GIR_EraseRootFromParent_Done,
     /* 2320751 */ // Label 32078: @2320751
     /* 2320751 */ GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2320782), // Rule ID 2188 //
     /* 2320756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2320759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320770 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2320770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2320773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320781 */   // GIR_Coverage, 2188,
     /* 2320781 */   GIR_EraseRootFromParent_Done,
     /* 2320782 */ // Label 32079: @2320782
     /* 2320782 */ GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2320813), // Rule ID 2189 //
     /* 2320787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2320790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320801 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2320801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2320804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320806 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320812 */   // GIR_Coverage, 2189,
     /* 2320812 */   GIR_EraseRootFromParent_Done,
     /* 2320813 */ // Label 32080: @2320813
     /* 2320813 */ GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2320844), // Rule ID 2214 //
     /* 2320818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2320821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320832 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2320832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2320835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320837 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320843 */   // GIR_Coverage, 2214,
     /* 2320843 */   GIR_EraseRootFromParent_Done,
     /* 2320844 */ // Label 32081: @2320844
     /* 2320844 */ GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2320875), // Rule ID 2215 //
     /* 2320849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2320852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320863 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2320863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2320866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320868 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320874 */   // GIR_Coverage, 2215,
     /* 2320874 */   GIR_EraseRootFromParent_Done,
     /* 2320875 */ // Label 32082: @2320875
     /* 2320875 */ GIM_Reject,
     /* 2320876 */ // Label 32048: @2320876
     /* 2320876 */ GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2320907), // Rule ID 1503 //
     /* 2320881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2320884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320895 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2320895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2320898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320900 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320906 */   // GIR_Coverage, 1503,
     /* 2320906 */   GIR_EraseRootFromParent_Done,
     /* 2320907 */ // Label 32083: @2320907
     /* 2320907 */ GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2320938), // Rule ID 1531 //
     /* 2320912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2320915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320926 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2320926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2320929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320937 */   // GIR_Coverage, 1531,
     /* 2320937 */   GIR_EraseRootFromParent_Done,
     /* 2320938 */ // Label 32084: @2320938
     /* 2320938 */ GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2320969), // Rule ID 1907 //
     /* 2320943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2320946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320957 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2320957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2320960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320962 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320968 */   // GIR_Coverage, 1907,
     /* 2320968 */   GIR_EraseRootFromParent_Done,
     /* 2320969 */ // Label 32085: @2320969
     /* 2320969 */ GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2321000), // Rule ID 1935 //
     /* 2320974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2320977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320988 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2320988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2320991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320993 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320999 */   // GIR_Coverage, 1935,
     /* 2320999 */   GIR_EraseRootFromParent_Done,
     /* 2321000 */ // Label 32086: @2321000
     /* 2321000 */ GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2321031), // Rule ID 2241 //
     /* 2321005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2321008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2321011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2321019 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2321019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2321022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321024 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321030 */   // GIR_Coverage, 2241,
     /* 2321030 */   GIR_EraseRootFromParent_Done,
     /* 2321031 */ // Label 32087: @2321031
     /* 2321031 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2321062), // Rule ID 2267 //
     /* 2321036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2321039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2321042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2321050 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2321050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2321053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321055 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2321060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321061 */   // GIR_Coverage, 2267,
     /* 2321061 */   GIR_EraseRootFromParent_Done,
     /* 2321062 */ // Label 32088: @2321062
     /* 2321062 */ GIM_Reject,
     /* 2321063 */ // Label 32049: @2321063
     /* 2321063 */ GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2321166),
     /* 2321068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321079 */   GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2321122), // Rule ID 58756 //
     /* 2321084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321087 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2321090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2321104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321121 */     // GIR_Coverage, 58756,
     /* 2321121 */     GIR_EraseRootFromParent_Done,
     /* 2321122 */   // Label 32090: @2321122
     /* 2321122 */   GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2321165), // Rule ID 58757 //
     /* 2321127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2321130 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2321133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2321147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321164 */     // GIR_Coverage, 58757,
     /* 2321164 */     GIR_EraseRootFromParent_Done,
     /* 2321165 */   // Label 32091: @2321165
     /* 2321165 */   GIM_Reject,
     /* 2321166 */ // Label 32089: @2321166
     /* 2321166 */ GIM_Reject,
     /* 2321167 */ // Label 32050: @2321167
     /* 2321167 */ GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2321221), // Rule ID 58340 //
     /* 2321172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321186 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2321203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321208 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321220 */   // GIR_Coverage, 58340,
     /* 2321220 */   GIR_EraseRootFromParent_Done,
     /* 2321221 */ // Label 32092: @2321221
     /* 2321221 */ GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2321275), // Rule ID 58341 //
     /* 2321226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2321229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321240 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2321257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321262 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321274 */   // GIR_Coverage, 58341,
     /* 2321274 */   GIR_EraseRootFromParent_Done,
     /* 2321275 */ // Label 32093: @2321275
     /* 2321275 */ GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2321329), // Rule ID 58780 //
     /* 2321280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2321283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321294 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2321311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321316 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321328 */   // GIR_Coverage, 58780,
     /* 2321328 */   GIR_EraseRootFromParent_Done,
     /* 2321329 */ // Label 32094: @2321329
     /* 2321329 */ GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2321383), // Rule ID 58781 //
     /* 2321334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2321337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321348 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2321365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321370 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321382 */   // GIR_Coverage, 58781,
     /* 2321382 */   GIR_EraseRootFromParent_Done,
     /* 2321383 */ // Label 32095: @2321383
     /* 2321383 */ GIM_Reject,
     /* 2321384 */ // Label 32051: @2321384
     /* 2321384 */ GIM_Try, /*On fail goto*//*Label 32096*/ GIMT_Encode4(2321438), // Rule ID 58348 //
     /* 2321389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2321392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321403 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2321420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321425 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321437 */   // GIR_Coverage, 58348,
     /* 2321437 */   GIR_EraseRootFromParent_Done,
     /* 2321438 */ // Label 32096: @2321438
     /* 2321438 */ GIM_Try, /*On fail goto*//*Label 32097*/ GIMT_Encode4(2321492), // Rule ID 58349 //
     /* 2321443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2321446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321457 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2321474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321491 */   // GIR_Coverage, 58349,
     /* 2321491 */   GIR_EraseRootFromParent_Done,
     /* 2321492 */ // Label 32097: @2321492
     /* 2321492 */ GIM_Try, /*On fail goto*//*Label 32098*/ GIMT_Encode4(2321546), // Rule ID 58548 //
     /* 2321497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321511 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2321528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321545 */   // GIR_Coverage, 58548,
     /* 2321545 */   GIR_EraseRootFromParent_Done,
     /* 2321546 */ // Label 32098: @2321546
     /* 2321546 */ GIM_Try, /*On fail goto*//*Label 32099*/ GIMT_Encode4(2321600), // Rule ID 58549 //
     /* 2321551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2321554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321565 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2321582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321599 */   // GIR_Coverage, 58549,
     /* 2321599 */   GIR_EraseRootFromParent_Done,
     /* 2321600 */ // Label 32099: @2321600
     /* 2321600 */ GIM_Try, /*On fail goto*//*Label 32100*/ GIMT_Encode4(2321654), // Rule ID 58800 //
     /* 2321605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2321608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321619 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2321636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321653 */   // GIR_Coverage, 58800,
     /* 2321653 */   GIR_EraseRootFromParent_Done,
     /* 2321654 */ // Label 32100: @2321654
     /* 2321654 */ GIM_Try, /*On fail goto*//*Label 32101*/ GIMT_Encode4(2321708), // Rule ID 58801 //
     /* 2321659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2321662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321673 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2321676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2321690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321706 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321707 */   // GIR_Coverage, 58801,
     /* 2321707 */   GIR_EraseRootFromParent_Done,
     /* 2321708 */ // Label 32101: @2321708
     /* 2321708 */ GIM_Reject,
     /* 2321709 */ // Label 32052: @2321709
     /* 2321709 */ GIM_Try, /*On fail goto*//*Label 32102*/ GIMT_Encode4(2321763), // Rule ID 58360 //
     /* 2321714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2321717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321728 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2321745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321762 */   // GIR_Coverage, 58360,
     /* 2321762 */   GIR_EraseRootFromParent_Done,
     /* 2321763 */ // Label 32102: @2321763
     /* 2321763 */ GIM_Try, /*On fail goto*//*Label 32103*/ GIMT_Encode4(2321817), // Rule ID 58361 //
     /* 2321768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2321771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2321774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321782 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2321799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321816 */   // GIR_Coverage, 58361,
     /* 2321816 */   GIR_EraseRootFromParent_Done,
     /* 2321817 */ // Label 32103: @2321817
     /* 2321817 */ GIM_Try, /*On fail goto*//*Label 32104*/ GIMT_Encode4(2321871), // Rule ID 58568 //
     /* 2321822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2321825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321836 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2321853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321870 */   // GIR_Coverage, 58568,
     /* 2321870 */   GIR_EraseRootFromParent_Done,
     /* 2321871 */ // Label 32104: @2321871
     /* 2321871 */ GIM_Try, /*On fail goto*//*Label 32105*/ GIMT_Encode4(2321925), // Rule ID 58569 //
     /* 2321876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2321879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2321882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321890 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2321907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321924 */   // GIR_Coverage, 58569,
     /* 2321924 */   GIR_EraseRootFromParent_Done,
     /* 2321925 */ // Label 32105: @2321925
     /* 2321925 */ GIM_Reject,
     /* 2321926 */ // Label 32053: @2321926
     /* 2321926 */ GIM_Try, /*On fail goto*//*Label 32106*/ GIMT_Encode4(2322029),
     /* 2321931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2321934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321942 */   GIM_Try, /*On fail goto*//*Label 32107*/ GIMT_Encode4(2321985), // Rule ID 58760 //
     /* 2321947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321950 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2321953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2321967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321984 */     // GIR_Coverage, 58760,
     /* 2321984 */     GIR_EraseRootFromParent_Done,
     /* 2321985 */   // Label 32107: @2321985
     /* 2321985 */   GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2322028), // Rule ID 58761 //
     /* 2321990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2321993 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2321996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2322010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322027 */     // GIR_Coverage, 58761,
     /* 2322027 */     GIR_EraseRootFromParent_Done,
     /* 2322028 */   // Label 32108: @2322028
     /* 2322028 */   GIM_Reject,
     /* 2322029 */ // Label 32106: @2322029
     /* 2322029 */ GIM_Reject,
     /* 2322030 */ // Label 32054: @2322030
     /* 2322030 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2322084), // Rule ID 58344 //
     /* 2322035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322049 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2322066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322083 */   // GIR_Coverage, 58344,
     /* 2322083 */   GIR_EraseRootFromParent_Done,
     /* 2322084 */ // Label 32109: @2322084
     /* 2322084 */ GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2322138), // Rule ID 58345 //
     /* 2322089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322103 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2322120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322137 */   // GIR_Coverage, 58345,
     /* 2322137 */   GIR_EraseRootFromParent_Done,
     /* 2322138 */ // Label 32110: @2322138
     /* 2322138 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2322192), // Rule ID 58784 //
     /* 2322143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2322146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322157 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2322174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322179 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322191 */   // GIR_Coverage, 58784,
     /* 2322191 */   GIR_EraseRootFromParent_Done,
     /* 2322192 */ // Label 32111: @2322192
     /* 2322192 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2322246), // Rule ID 58785 //
     /* 2322197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2322200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322211 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2322228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322233 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322245 */   // GIR_Coverage, 58785,
     /* 2322245 */   GIR_EraseRootFromParent_Done,
     /* 2322246 */ // Label 32112: @2322246
     /* 2322246 */ GIM_Reject,
     /* 2322247 */ // Label 32055: @2322247
     /* 2322247 */ GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2322301), // Rule ID 58356 //
     /* 2322252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2322255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322266 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2322283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322288 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322300 */   // GIR_Coverage, 58356,
     /* 2322300 */   GIR_EraseRootFromParent_Done,
     /* 2322301 */ // Label 32113: @2322301
     /* 2322301 */ GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2322355), // Rule ID 58357 //
     /* 2322306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2322309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322320 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2322337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322342 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322354 */   // GIR_Coverage, 58357,
     /* 2322354 */   GIR_EraseRootFromParent_Done,
     /* 2322355 */ // Label 32114: @2322355
     /* 2322355 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2322409), // Rule ID 58552 //
     /* 2322360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322374 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2322391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322396 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322408 */   // GIR_Coverage, 58552,
     /* 2322408 */   GIR_EraseRootFromParent_Done,
     /* 2322409 */ // Label 32115: @2322409
     /* 2322409 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2322463), // Rule ID 58553 //
     /* 2322414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322428 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2322445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322450 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322462 */   // GIR_Coverage, 58553,
     /* 2322462 */   GIR_EraseRootFromParent_Done,
     /* 2322463 */ // Label 32116: @2322463
     /* 2322463 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2322517), // Rule ID 58804 //
     /* 2322468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2322471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2322474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322482 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2322499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322504 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322516 */   // GIR_Coverage, 58804,
     /* 2322516 */   GIR_EraseRootFromParent_Done,
     /* 2322517 */ // Label 32117: @2322517
     /* 2322517 */ GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2322571), // Rule ID 58805 //
     /* 2322522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2322525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2322528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322536 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2322539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2322553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322569 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322570 */   // GIR_Coverage, 58805,
     /* 2322570 */   GIR_EraseRootFromParent_Done,
     /* 2322571 */ // Label 32118: @2322571
     /* 2322571 */ GIM_Reject,
     /* 2322572 */ // Label 32056: @2322572
     /* 2322572 */ GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2322626), // Rule ID 58388 //
     /* 2322577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2322580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2322583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322591 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2322594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2322608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322625 */   // GIR_Coverage, 58388,
     /* 2322625 */   GIR_EraseRootFromParent_Done,
     /* 2322626 */ // Label 32119: @2322626
     /* 2322626 */ GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2322680), // Rule ID 58389 //
     /* 2322631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2322634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2322637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322645 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2322648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2322662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322679 */   // GIR_Coverage, 58389,
     /* 2322679 */   GIR_EraseRootFromParent_Done,
     /* 2322680 */ // Label 32120: @2322680
     /* 2322680 */ GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2322734), // Rule ID 58572 //
     /* 2322685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2322688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322699 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2322702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2322716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322721 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322733 */   // GIR_Coverage, 58572,
     /* 2322733 */   GIR_EraseRootFromParent_Done,
     /* 2322734 */ // Label 32121: @2322734
     /* 2322734 */ GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2322788), // Rule ID 58573 //
     /* 2322739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2322742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2322749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322753 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2322756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2322770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322787 */   // GIR_Coverage, 58573,
     /* 2322787 */   GIR_EraseRootFromParent_Done,
     /* 2322788 */ // Label 32122: @2322788
     /* 2322788 */ GIM_Reject,
     /* 2322789 */ // Label 32057: @2322789
     /* 2322789 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2322892),
     /* 2322794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2322797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322805 */   GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2322848), // Rule ID 58764 //
     /* 2322810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322813 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2322816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2322830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322847 */     // GIR_Coverage, 58764,
     /* 2322847 */     GIR_EraseRootFromParent_Done,
     /* 2322848 */   // Label 32124: @2322848
     /* 2322848 */   GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2322891), // Rule ID 58765 //
     /* 2322853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322856 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2322859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2322873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322890 */     // GIR_Coverage, 58765,
     /* 2322890 */     GIR_EraseRootFromParent_Done,
     /* 2322891 */   // Label 32125: @2322891
     /* 2322891 */   GIM_Reject,
     /* 2322892 */ // Label 32123: @2322892
     /* 2322892 */ GIM_Reject,
     /* 2322893 */ // Label 32058: @2322893
     /* 2322893 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2322947), // Rule ID 58352 //
     /* 2322898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2322904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322912 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2322915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2322929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322934 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322946 */   // GIR_Coverage, 58352,
     /* 2322946 */   GIR_EraseRootFromParent_Done,
     /* 2322947 */ // Label 32126: @2322947
     /* 2322947 */ GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2323001), // Rule ID 58353 //
     /* 2322952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2322958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322966 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2322969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2322983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322988 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323000 */   // GIR_Coverage, 58353,
     /* 2323000 */   GIR_EraseRootFromParent_Done,
     /* 2323001 */ // Label 32127: @2323001
     /* 2323001 */ GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2323055), // Rule ID 58788 //
     /* 2323006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323020 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2323037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323054 */   // GIR_Coverage, 58788,
     /* 2323054 */   GIR_EraseRootFromParent_Done,
     /* 2323055 */ // Label 32128: @2323055
     /* 2323055 */ GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2323109), // Rule ID 58789 //
     /* 2323060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2323063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323074 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2323091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323096 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323108 */   // GIR_Coverage, 58789,
     /* 2323108 */   GIR_EraseRootFromParent_Done,
     /* 2323109 */ // Label 32129: @2323109
     /* 2323109 */ GIM_Reject,
     /* 2323110 */ // Label 32059: @2323110
     /* 2323110 */ GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2323164), // Rule ID 58376 //
     /* 2323115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323129 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323129 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323132 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323136 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2323146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323151 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323163 */   // GIR_Coverage, 58376,
     /* 2323163 */   GIR_EraseRootFromParent_Done,
     /* 2323164 */ // Label 32130: @2323164
     /* 2323164 */ GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2323218), // Rule ID 58377 //
     /* 2323169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2323172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323183 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2323200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323205 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323217 */   // GIR_Coverage, 58377,
     /* 2323217 */   GIR_EraseRootFromParent_Done,
     /* 2323218 */ // Label 32131: @2323218
     /* 2323218 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2323272), // Rule ID 58556 //
     /* 2323223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323237 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2323254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323259 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323271 */   // GIR_Coverage, 58556,
     /* 2323271 */   GIR_EraseRootFromParent_Done,
     /* 2323272 */ // Label 32132: @2323272
     /* 2323272 */ GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2323326), // Rule ID 58557 //
     /* 2323277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323291 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2323308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323313 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323325 */   // GIR_Coverage, 58557,
     /* 2323325 */   GIR_EraseRootFromParent_Done,
     /* 2323326 */ // Label 32133: @2323326
     /* 2323326 */ GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2323380), // Rule ID 58808 //
     /* 2323331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2323334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2323337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323345 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2323362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323367 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323379 */   // GIR_Coverage, 58808,
     /* 2323379 */   GIR_EraseRootFromParent_Done,
     /* 2323380 */ // Label 32134: @2323380
     /* 2323380 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2323434), // Rule ID 58809 //
     /* 2323385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2323388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2323391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323399 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2323416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323421 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323433 */   // GIR_Coverage, 58809,
     /* 2323433 */   GIR_EraseRootFromParent_Done,
     /* 2323434 */ // Label 32135: @2323434
     /* 2323434 */ GIM_Reject,
     /* 2323435 */ // Label 32060: @2323435
     /* 2323435 */ GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2323489), // Rule ID 58392 //
     /* 2323440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2323443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2323446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323454 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2323471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323476 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323488 */   // GIR_Coverage, 58392,
     /* 2323488 */   GIR_EraseRootFromParent_Done,
     /* 2323489 */ // Label 32136: @2323489
     /* 2323489 */ GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2323543), // Rule ID 58393 //
     /* 2323494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2323497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2323500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323508 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2323525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323530 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323542 */   // GIR_Coverage, 58393,
     /* 2323542 */   GIR_EraseRootFromParent_Done,
     /* 2323543 */ // Label 32137: @2323543
     /* 2323543 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2323597), // Rule ID 58576 //
     /* 2323548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2323551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323562 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2323579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323584 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323596 */   // GIR_Coverage, 58576,
     /* 2323596 */   GIR_EraseRootFromParent_Done,
     /* 2323597 */ // Label 32138: @2323597
     /* 2323597 */ GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2323651), // Rule ID 58577 //
     /* 2323602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2323605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323616 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2323633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323650 */   // GIR_Coverage, 58577,
     /* 2323650 */   GIR_EraseRootFromParent_Done,
     /* 2323651 */ // Label 32139: @2323651
     /* 2323651 */ GIM_Reject,
     /* 2323652 */ // Label 32061: @2323652
     /* 2323652 */ GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2323755),
     /* 2323657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2323660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323668 */   GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2323711), // Rule ID 58768 //
     /* 2323673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323676 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2323679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2323693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323710 */     // GIR_Coverage, 58768,
     /* 2323710 */     GIR_EraseRootFromParent_Done,
     /* 2323711 */   // Label 32141: @2323711
     /* 2323711 */   GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2323754), // Rule ID 58769 //
     /* 2323716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323719 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2323722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2323736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323753 */     // GIR_Coverage, 58769,
     /* 2323753 */     GIR_EraseRootFromParent_Done,
     /* 2323754 */   // Label 32142: @2323754
     /* 2323754 */   GIM_Reject,
     /* 2323755 */ // Label 32140: @2323755
     /* 2323755 */ GIM_Reject,
     /* 2323756 */ // Label 32062: @2323756
     /* 2323756 */ GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2323810), // Rule ID 58364 //
     /* 2323761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2323767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323775 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2323792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323797 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323809 */   // GIR_Coverage, 58364,
     /* 2323809 */   GIR_EraseRootFromParent_Done,
     /* 2323810 */ // Label 32143: @2323810
     /* 2323810 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2323864), // Rule ID 58365 //
     /* 2323815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2323821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323829 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2323846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323851 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323863 */   // GIR_Coverage, 58365,
     /* 2323863 */   GIR_EraseRootFromParent_Done,
     /* 2323864 */ // Label 32144: @2323864
     /* 2323864 */ GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2323918), // Rule ID 58792 //
     /* 2323869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2323875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323883 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2323900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323905 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323917 */   // GIR_Coverage, 58792,
     /* 2323917 */   GIR_EraseRootFromParent_Done,
     /* 2323918 */ // Label 32145: @2323918
     /* 2323918 */ GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2323972), // Rule ID 58793 //
     /* 2323923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2323926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2323929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323937 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2323954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323959 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323971 */   // GIR_Coverage, 58793,
     /* 2323971 */   GIR_EraseRootFromParent_Done,
     /* 2323972 */ // Label 32146: @2323972
     /* 2323972 */ GIM_Reject,
     /* 2323973 */ // Label 32063: @2323973
     /* 2323973 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2324027), // Rule ID 58380 //
     /* 2323978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2323984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323992 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2323995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2324009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324014 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324026 */   // GIR_Coverage, 58380,
     /* 2324026 */   GIR_EraseRootFromParent_Done,
     /* 2324027 */ // Label 32147: @2324027
     /* 2324027 */ GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2324081), // Rule ID 58381 //
     /* 2324032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324046 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2324063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324080 */   // GIR_Coverage, 58381,
     /* 2324080 */   GIR_EraseRootFromParent_Done,
     /* 2324081 */ // Label 32148: @2324081
     /* 2324081 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2324135), // Rule ID 58560 //
     /* 2324086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324100 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324100 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324103 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324107 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2324117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324122 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324134 */   // GIR_Coverage, 58560,
     /* 2324134 */   GIR_EraseRootFromParent_Done,
     /* 2324135 */ // Label 32149: @2324135
     /* 2324135 */ GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2324189), // Rule ID 58561 //
     /* 2324140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324154 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2324171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324176 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324188 */   // GIR_Coverage, 58561,
     /* 2324188 */   GIR_EraseRootFromParent_Done,
     /* 2324189 */ // Label 32150: @2324189
     /* 2324189 */ GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2324243), // Rule ID 58812 //
     /* 2324194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2324197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324208 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2324225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324230 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324242 */   // GIR_Coverage, 58812,
     /* 2324242 */   GIR_EraseRootFromParent_Done,
     /* 2324243 */ // Label 32151: @2324243
     /* 2324243 */ GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2324297), // Rule ID 58813 //
     /* 2324248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2324251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324262 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2324279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324284 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324296 */   // GIR_Coverage, 58813,
     /* 2324296 */   GIR_EraseRootFromParent_Done,
     /* 2324297 */ // Label 32152: @2324297
     /* 2324297 */ GIM_Reject,
     /* 2324298 */ // Label 32064: @2324298
     /* 2324298 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2324352), // Rule ID 58396 //
     /* 2324303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2324306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324317 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2324334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324339 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324351 */   // GIR_Coverage, 58396,
     /* 2324351 */   GIR_EraseRootFromParent_Done,
     /* 2324352 */ // Label 32153: @2324352
     /* 2324352 */ GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2324406), // Rule ID 58397 //
     /* 2324357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2324360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324371 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2324388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324393 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324405 */   // GIR_Coverage, 58397,
     /* 2324405 */   GIR_EraseRootFromParent_Done,
     /* 2324406 */ // Label 32154: @2324406
     /* 2324406 */ GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2324460), // Rule ID 58580 //
     /* 2324411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2324414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324425 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2324442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324447 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324459 */   // GIR_Coverage, 58580,
     /* 2324459 */   GIR_EraseRootFromParent_Done,
     /* 2324460 */ // Label 32155: @2324460
     /* 2324460 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2324514), // Rule ID 58581 //
     /* 2324465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2324468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324479 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2324496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324501 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324513 */   // GIR_Coverage, 58581,
     /* 2324513 */   GIR_EraseRootFromParent_Done,
     /* 2324514 */ // Label 32156: @2324514
     /* 2324514 */ GIM_Reject,
     /* 2324515 */ // Label 32065: @2324515
     /* 2324515 */ GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2324618),
     /* 2324520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324531 */   GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2324574), // Rule ID 58772 //
     /* 2324536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324539 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2324542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2324556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324573 */     // GIR_Coverage, 58772,
     /* 2324573 */     GIR_EraseRootFromParent_Done,
     /* 2324574 */   // Label 32158: @2324574
     /* 2324574 */   GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2324617), // Rule ID 58773 //
     /* 2324579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324582 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2324585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2324599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324616 */     // GIR_Coverage, 58773,
     /* 2324616 */     GIR_EraseRootFromParent_Done,
     /* 2324617 */   // Label 32159: @2324617
     /* 2324617 */   GIM_Reject,
     /* 2324618 */ // Label 32157: @2324618
     /* 2324618 */ GIM_Reject,
     /* 2324619 */ // Label 32066: @2324619
     /* 2324619 */ GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2324673), // Rule ID 58368 //
     /* 2324624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324638 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2324655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324660 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324672 */   // GIR_Coverage, 58368,
     /* 2324672 */   GIR_EraseRootFromParent_Done,
     /* 2324673 */ // Label 32160: @2324673
     /* 2324673 */ GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2324727), // Rule ID 58369 //
     /* 2324678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324692 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2324709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324714 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324726 */   // GIR_Coverage, 58369,
     /* 2324726 */   GIR_EraseRootFromParent_Done,
     /* 2324727 */ // Label 32161: @2324727
     /* 2324727 */ GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2324781), // Rule ID 58796 //
     /* 2324732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2324735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324746 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2324763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324768 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324780 */   // GIR_Coverage, 58796,
     /* 2324780 */   GIR_EraseRootFromParent_Done,
     /* 2324781 */ // Label 32162: @2324781
     /* 2324781 */ GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2324835), // Rule ID 58797 //
     /* 2324786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324800 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2324817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324834 */   // GIR_Coverage, 58797,
     /* 2324834 */   GIR_EraseRootFromParent_Done,
     /* 2324835 */ // Label 32163: @2324835
     /* 2324835 */ GIM_Reject,
     /* 2324836 */ // Label 32067: @2324836
     /* 2324836 */ GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2324890), // Rule ID 58384 //
     /* 2324841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2324844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324855 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2324872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324889 */   // GIR_Coverage, 58384,
     /* 2324889 */   GIR_EraseRootFromParent_Done,
     /* 2324890 */ // Label 32164: @2324890
     /* 2324890 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2324944), // Rule ID 58385 //
     /* 2324895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324909 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2324926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324931 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324943 */   // GIR_Coverage, 58385,
     /* 2324943 */   GIR_EraseRootFromParent_Done,
     /* 2324944 */ // Label 32165: @2324944
     /* 2324944 */ GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2324998), // Rule ID 58564 //
     /* 2324949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324963 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2324980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324997 */   // GIR_Coverage, 58564,
     /* 2324997 */   GIR_EraseRootFromParent_Done,
     /* 2324998 */ // Label 32166: @2324998
     /* 2324998 */ GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2325052), // Rule ID 58565 //
     /* 2325003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2325009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325017 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2325020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2325034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325039 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325051 */   // GIR_Coverage, 58565,
     /* 2325051 */   GIR_EraseRootFromParent_Done,
     /* 2325052 */ // Label 32167: @2325052
     /* 2325052 */ GIM_Reject,
     /* 2325053 */ // Label 32068: @2325053
     /* 2325053 */ GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2325156),
     /* 2325058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325069 */   GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2325112), // Rule ID 58776 //
     /* 2325074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2325077 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2325080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2325094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325111 */     // GIR_Coverage, 58776,
     /* 2325111 */     GIR_EraseRootFromParent_Done,
     /* 2325112 */   // Label 32169: @2325112
     /* 2325112 */   GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2325155), // Rule ID 58777 //
     /* 2325117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325120 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2325123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2325137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325154 */     // GIR_Coverage, 58777,
     /* 2325154 */     GIR_EraseRootFromParent_Done,
     /* 2325155 */   // Label 32170: @2325155
     /* 2325155 */   GIM_Reject,
     /* 2325156 */ // Label 32168: @2325156
     /* 2325156 */ GIM_Reject,
     /* 2325157 */ // Label 32069: @2325157
     /* 2325157 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2325260),
     /* 2325162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2325165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325173 */   GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2325216), // Rule ID 58372 //
     /* 2325178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2325181 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2325184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2325198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325215 */     // GIR_Coverage, 58372,
     /* 2325215 */     GIR_EraseRootFromParent_Done,
     /* 2325216 */   // Label 32172: @2325216
     /* 2325216 */   GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2325259), // Rule ID 58373 //
     /* 2325221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325224 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2325227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2325241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325258 */     // GIR_Coverage, 58373,
     /* 2325258 */     GIR_EraseRootFromParent_Done,
     /* 2325259 */   // Label 32173: @2325259
     /* 2325259 */   GIM_Reject,
     /* 2325260 */ // Label 32171: @2325260
     /* 2325260 */ GIM_Reject,
     /* 2325261 */ // Label 32070: @2325261
     /* 2325261 */ GIM_Reject,
     /* 2325262 */ // Label 69: @2325262
     /* 2325262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32192*/ GIMT_Encode4(2330547),
     /* 2325273 */ /*GILLT_s16*//*Label 32174*/ GIMT_Encode4(2325393),
     /* 2325277 */ /*GILLT_s32*//*Label 32175*/ GIMT_Encode4(2325654),
     /* 2325281 */ /*GILLT_s64*//*Label 32176*/ GIMT_Encode4(2325915), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325293 */ /*GILLT_nxv1s16*//*Label 32177*/ GIMT_Encode4(2326176),
     /* 2325297 */ /*GILLT_nxv1s32*//*Label 32178*/ GIMT_Encode4(2326513),
     /* 2325301 */ /*GILLT_nxv1s64*//*Label 32179*/ GIMT_Encode4(2326850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325313 */ /*GILLT_nxv2s16*//*Label 32180*/ GIMT_Encode4(2327073),
     /* 2325317 */ /*GILLT_nxv2s32*//*Label 32181*/ GIMT_Encode4(2327410),
     /* 2325321 */ /*GILLT_nxv2s64*//*Label 32182*/ GIMT_Encode4(2327747), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325333 */ /*GILLT_nxv4s16*//*Label 32183*/ GIMT_Encode4(2327970),
     /* 2325337 */ /*GILLT_nxv4s32*//*Label 32184*/ GIMT_Encode4(2328307),
     /* 2325341 */ /*GILLT_nxv4s64*//*Label 32185*/ GIMT_Encode4(2328644), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325353 */ /*GILLT_nxv8s16*//*Label 32186*/ GIMT_Encode4(2328867),
     /* 2325357 */ /*GILLT_nxv8s32*//*Label 32187*/ GIMT_Encode4(2329204),
     /* 2325361 */ /*GILLT_nxv8s64*//*Label 32188*/ GIMT_Encode4(2329541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325373 */ /*GILLT_nxv16s16*//*Label 32189*/ GIMT_Encode4(2329764),
     /* 2325377 */ /*GILLT_nxv16s32*//*Label 32190*/ GIMT_Encode4(2330101), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325389 */ /*GILLT_nxv32s16*//*Label 32191*/ GIMT_Encode4(2330324),
     /* 2325393 */ // Label 32174: @2325393
     /* 2325393 */ GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2325430), // Rule ID 2253 //
     /* 2325398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2325401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325415 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2325418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325429 */   // GIR_Coverage, 2253,
     /* 2325429 */   GIR_EraseRootFromParent_Done,
     /* 2325430 */ // Label 32193: @2325430
     /* 2325430 */ GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2325467), // Rule ID 2279 //
     /* 2325435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2325438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325452 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2325455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325466 */   // GIR_Coverage, 2279,
     /* 2325466 */   GIR_EraseRootFromParent_Done,
     /* 2325467 */ // Label 32194: @2325467
     /* 2325467 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2325498), // Rule ID 2202 //
     /* 2325472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2325475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325486 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2325486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2325489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325491 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325497 */   // GIR_Coverage, 2202,
     /* 2325497 */   GIR_EraseRootFromParent_Done,
     /* 2325498 */ // Label 32195: @2325498
     /* 2325498 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2325529), // Rule ID 2203 //
     /* 2325503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2325506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325517 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2325517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2325520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325522 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325528 */   // GIR_Coverage, 2203,
     /* 2325528 */   GIR_EraseRootFromParent_Done,
     /* 2325529 */ // Label 32196: @2325529
     /* 2325529 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2325560), // Rule ID 2228 //
     /* 2325534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2325537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325548 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2325548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2325551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325553 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325559 */   // GIR_Coverage, 2228,
     /* 2325559 */   GIR_EraseRootFromParent_Done,
     /* 2325560 */ // Label 32197: @2325560
     /* 2325560 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2325591), // Rule ID 2229 //
     /* 2325565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2325568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325579 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2325579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2325582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325584 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325589 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325590 */   // GIR_Coverage, 2229,
     /* 2325590 */   GIR_EraseRootFromParent_Done,
     /* 2325591 */ // Label 32198: @2325591
     /* 2325591 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2325622), // Rule ID 2257 //
     /* 2325596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2325599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325610 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2325613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325615 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325621 */   // GIR_Coverage, 2257,
     /* 2325621 */   GIR_EraseRootFromParent_Done,
     /* 2325622 */ // Label 32199: @2325622
     /* 2325622 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2325653), // Rule ID 2283 //
     /* 2325627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2325630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325641 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2325644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325646 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325652 */   // GIR_Coverage, 2283,
     /* 2325652 */   GIR_EraseRootFromParent_Done,
     /* 2325653 */ // Label 32200: @2325653
     /* 2325653 */ GIM_Reject,
     /* 2325654 */ // Label 32175: @2325654
     /* 2325654 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2325691), // Rule ID 1515 //
     /* 2325659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2325662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325676 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2325679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325690 */   // GIR_Coverage, 1515,
     /* 2325690 */   GIR_EraseRootFromParent_Done,
     /* 2325691 */ // Label 32201: @2325691
     /* 2325691 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2325728), // Rule ID 1543 //
     /* 2325696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2325699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325713 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2325716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325727 */   // GIR_Coverage, 1543,
     /* 2325727 */   GIR_EraseRootFromParent_Done,
     /* 2325728 */ // Label 32202: @2325728
     /* 2325728 */ GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2325759), // Rule ID 1462 //
     /* 2325733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2325736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325747 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2325747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2325750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325752 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325758 */   // GIR_Coverage, 1462,
     /* 2325758 */   GIR_EraseRootFromParent_Done,
     /* 2325759 */ // Label 32203: @2325759
     /* 2325759 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2325790), // Rule ID 1463 //
     /* 2325764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2325767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325778 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2325778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2325781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325783 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325789 */   // GIR_Coverage, 1463,
     /* 2325789 */   GIR_EraseRootFromParent_Done,
     /* 2325790 */ // Label 32204: @2325790
     /* 2325790 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2325821), // Rule ID 1488 //
     /* 2325795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2325798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325809 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2325809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2325812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325814 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325820 */   // GIR_Coverage, 1488,
     /* 2325820 */   GIR_EraseRootFromParent_Done,
     /* 2325821 */ // Label 32205: @2325821
     /* 2325821 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2325852), // Rule ID 1489 //
     /* 2325826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2325829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325840 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2325840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2325843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325850 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325851 */   // GIR_Coverage, 1489,
     /* 2325851 */   GIR_EraseRootFromParent_Done,
     /* 2325852 */ // Label 32206: @2325852
     /* 2325852 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2325883), // Rule ID 1519 //
     /* 2325857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2325860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325871 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2325874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325876 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325882 */   // GIR_Coverage, 1519,
     /* 2325882 */   GIR_EraseRootFromParent_Done,
     /* 2325883 */ // Label 32207: @2325883
     /* 2325883 */ GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2325914), // Rule ID 1547 //
     /* 2325888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2325891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325902 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2325902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2325905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325907 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325913 */   // GIR_Coverage, 1547,
     /* 2325913 */   GIR_EraseRootFromParent_Done,
     /* 2325914 */ // Label 32208: @2325914
     /* 2325914 */ GIM_Reject,
     /* 2325915 */ // Label 32176: @2325915
     /* 2325915 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2325952), // Rule ID 1899 //
     /* 2325920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2325923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325937 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2325937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2325940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325951 */   // GIR_Coverage, 1899,
     /* 2325951 */   GIR_EraseRootFromParent_Done,
     /* 2325952 */ // Label 32209: @2325952
     /* 2325952 */ GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2325989), // Rule ID 1927 //
     /* 2325957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2325960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2325974 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2325974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2325977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2325984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2325987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325988 */   // GIR_Coverage, 1927,
     /* 2325988 */   GIR_EraseRootFromParent_Done,
     /* 2325989 */ // Label 32210: @2325989
     /* 2325989 */ GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2326020), // Rule ID 1860 //
     /* 2325994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2325997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326008 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2326008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2326011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326013 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326019 */   // GIR_Coverage, 1860,
     /* 2326019 */   GIR_EraseRootFromParent_Done,
     /* 2326020 */ // Label 32211: @2326020
     /* 2326020 */ GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2326051), // Rule ID 1861 //
     /* 2326025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2326028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326039 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2326039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2326042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326050 */   // GIR_Coverage, 1861,
     /* 2326050 */   GIR_EraseRootFromParent_Done,
     /* 2326051 */ // Label 32212: @2326051
     /* 2326051 */ GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2326082), // Rule ID 1886 //
     /* 2326056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2326059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326070 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2326070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2326073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326081 */   // GIR_Coverage, 1886,
     /* 2326081 */   GIR_EraseRootFromParent_Done,
     /* 2326082 */ // Label 32213: @2326082
     /* 2326082 */ GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2326113), // Rule ID 1887 //
     /* 2326087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2326090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326101 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2326101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2326104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326106 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326112 */   // GIR_Coverage, 1887,
     /* 2326112 */   GIR_EraseRootFromParent_Done,
     /* 2326113 */ // Label 32214: @2326113
     /* 2326113 */ GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2326144), // Rule ID 1917 //
     /* 2326118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2326121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326132 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2326135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326137 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326143 */   // GIR_Coverage, 1917,
     /* 2326143 */   GIR_EraseRootFromParent_Done,
     /* 2326144 */ // Label 32215: @2326144
     /* 2326144 */ GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2326175), // Rule ID 1945 //
     /* 2326149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2326152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326163 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2326166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326168 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326174 */   // GIR_Coverage, 1945,
     /* 2326174 */   GIR_EraseRootFromParent_Done,
     /* 2326175 */ // Label 32216: @2326175
     /* 2326175 */ GIM_Reject,
     /* 2326176 */ // Label 32177: @2326176
     /* 2326176 */ GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2326233), // Rule ID 45792 //
     /* 2326181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2326184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326195 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2326212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326231 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326232 */   // GIR_Coverage, 45792,
     /* 2326232 */   GIR_EraseRootFromParent_Done,
     /* 2326233 */ // Label 32217: @2326233
     /* 2326233 */ GIM_Try, /*On fail goto*//*Label 32218*/ GIMT_Encode4(2326290), // Rule ID 45793 //
     /* 2326238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2326241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326252 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2326269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326274 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326288 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326289 */   // GIR_Coverage, 45793,
     /* 2326289 */   GIR_EraseRootFromParent_Done,
     /* 2326290 */ // Label 32218: @2326290
     /* 2326290 */ GIM_Try, /*On fail goto*//*Label 32219*/ GIMT_Encode4(2326344), // Rule ID 45800 //
     /* 2326295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2326298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2326301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326309 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2326326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326343 */   // GIR_Coverage, 45800,
     /* 2326343 */   GIR_EraseRootFromParent_Done,
     /* 2326344 */ // Label 32219: @2326344
     /* 2326344 */ GIM_Try, /*On fail goto*//*Label 32220*/ GIMT_Encode4(2326398), // Rule ID 45801 //
     /* 2326349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2326352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2326355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326363 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2326380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326385 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326397 */   // GIR_Coverage, 45801,
     /* 2326397 */   GIR_EraseRootFromParent_Done,
     /* 2326398 */ // Label 32220: @2326398
     /* 2326398 */ GIM_Try, /*On fail goto*//*Label 32221*/ GIMT_Encode4(2326455), // Rule ID 45808 //
     /* 2326403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2326406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326417 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2326434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326439 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326454 */   // GIR_Coverage, 45808,
     /* 2326454 */   GIR_EraseRootFromParent_Done,
     /* 2326455 */ // Label 32221: @2326455
     /* 2326455 */ GIM_Try, /*On fail goto*//*Label 32222*/ GIMT_Encode4(2326512), // Rule ID 45809 //
     /* 2326460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2326463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326474 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2326477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2326491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326511 */   // GIR_Coverage, 45809,
     /* 2326511 */   GIR_EraseRootFromParent_Done,
     /* 2326512 */ // Label 32222: @2326512
     /* 2326512 */ GIM_Reject,
     /* 2326513 */ // Label 32178: @2326513
     /* 2326513 */ GIM_Try, /*On fail goto*//*Label 32223*/ GIMT_Encode4(2326570), // Rule ID 58404 //
     /* 2326518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2326521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326532 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2326549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326569 */   // GIR_Coverage, 58404,
     /* 2326569 */   GIR_EraseRootFromParent_Done,
     /* 2326570 */ // Label 32223: @2326570
     /* 2326570 */ GIM_Try, /*On fail goto*//*Label 32224*/ GIMT_Encode4(2326627), // Rule ID 58405 //
     /* 2326575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2326578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326589 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2326606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326626 */   // GIR_Coverage, 58405,
     /* 2326626 */   GIR_EraseRootFromParent_Done,
     /* 2326627 */ // Label 32224: @2326627
     /* 2326627 */ GIM_Try, /*On fail goto*//*Label 32225*/ GIMT_Encode4(2326681), // Rule ID 58604 //
     /* 2326632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2326635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326646 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2326663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326668 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326680 */   // GIR_Coverage, 58604,
     /* 2326680 */   GIR_EraseRootFromParent_Done,
     /* 2326681 */ // Label 32225: @2326681
     /* 2326681 */ GIM_Try, /*On fail goto*//*Label 32226*/ GIMT_Encode4(2326735), // Rule ID 58605 //
     /* 2326686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2326689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2326692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326700 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2326717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326722 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326734 */   // GIR_Coverage, 58605,
     /* 2326734 */   GIR_EraseRootFromParent_Done,
     /* 2326735 */ // Label 32226: @2326735
     /* 2326735 */ GIM_Try, /*On fail goto*//*Label 32227*/ GIMT_Encode4(2326792), // Rule ID 58832 //
     /* 2326740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2326743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2326746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326754 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2326771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326776 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326791 */   // GIR_Coverage, 58832,
     /* 2326791 */   GIR_EraseRootFromParent_Done,
     /* 2326792 */ // Label 32227: @2326792
     /* 2326792 */ GIM_Try, /*On fail goto*//*Label 32228*/ GIMT_Encode4(2326849), // Rule ID 58833 //
     /* 2326797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2326800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2326803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326811 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2326814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2326828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326833 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326848 */   // GIR_Coverage, 58833,
     /* 2326848 */   GIR_EraseRootFromParent_Done,
     /* 2326849 */ // Label 32228: @2326849
     /* 2326849 */ GIM_Reject,
     /* 2326850 */ // Label 32179: @2326850
     /* 2326850 */ GIM_Try, /*On fail goto*//*Label 32229*/ GIMT_Encode4(2326907), // Rule ID 58416 //
     /* 2326855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2326858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2326861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326869 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2326872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2326886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326891 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326905 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326906 */   // GIR_Coverage, 58416,
     /* 2326906 */   GIR_EraseRootFromParent_Done,
     /* 2326907 */ // Label 32229: @2326907
     /* 2326907 */ GIM_Try, /*On fail goto*//*Label 32230*/ GIMT_Encode4(2326964), // Rule ID 58417 //
     /* 2326912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2326915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2326918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326926 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2326929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2326943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326948 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2326959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326963 */   // GIR_Coverage, 58417,
     /* 2326963 */   GIR_EraseRootFromParent_Done,
     /* 2326964 */ // Label 32230: @2326964
     /* 2326964 */ GIM_Try, /*On fail goto*//*Label 32231*/ GIMT_Encode4(2327018), // Rule ID 58624 //
     /* 2326969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2326972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2326975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2326983 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326983 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2326986 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326990 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2327000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327005 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327016 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327017 */   // GIR_Coverage, 58624,
     /* 2327017 */   GIR_EraseRootFromParent_Done,
     /* 2327018 */ // Label 32231: @2327018
     /* 2327018 */ GIM_Try, /*On fail goto*//*Label 32232*/ GIMT_Encode4(2327072), // Rule ID 58625 //
     /* 2327023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2327026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327037 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2327054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327059 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327071 */   // GIR_Coverage, 58625,
     /* 2327071 */   GIR_EraseRootFromParent_Done,
     /* 2327072 */ // Label 32232: @2327072
     /* 2327072 */ GIM_Reject,
     /* 2327073 */ // Label 32180: @2327073
     /* 2327073 */ GIM_Try, /*On fail goto*//*Label 32233*/ GIMT_Encode4(2327130), // Rule ID 58400 //
     /* 2327078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327092 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2327109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327114 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327129 */   // GIR_Coverage, 58400,
     /* 2327129 */   GIR_EraseRootFromParent_Done,
     /* 2327130 */ // Label 32233: @2327130
     /* 2327130 */ GIM_Try, /*On fail goto*//*Label 32234*/ GIMT_Encode4(2327187), // Rule ID 58401 //
     /* 2327135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327149 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2327166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327185 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327186 */   // GIR_Coverage, 58401,
     /* 2327186 */   GIR_EraseRootFromParent_Done,
     /* 2327187 */ // Label 32234: @2327187
     /* 2327187 */ GIM_Try, /*On fail goto*//*Label 32235*/ GIMT_Encode4(2327241), // Rule ID 58584 //
     /* 2327192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2327198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327206 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2327223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327228 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327240 */   // GIR_Coverage, 58584,
     /* 2327240 */   GIR_EraseRootFromParent_Done,
     /* 2327241 */ // Label 32235: @2327241
     /* 2327241 */ GIM_Try, /*On fail goto*//*Label 32236*/ GIMT_Encode4(2327295), // Rule ID 58585 //
     /* 2327246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2327252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327260 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327272 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2327277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327294 */   // GIR_Coverage, 58585,
     /* 2327294 */   GIR_EraseRootFromParent_Done,
     /* 2327295 */ // Label 32236: @2327295
     /* 2327295 */ GIM_Try, /*On fail goto*//*Label 32237*/ GIMT_Encode4(2327352), // Rule ID 58816 //
     /* 2327300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327314 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2327331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327336 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327351 */   // GIR_Coverage, 58816,
     /* 2327351 */   GIR_EraseRootFromParent_Done,
     /* 2327352 */ // Label 32237: @2327352
     /* 2327352 */ GIM_Try, /*On fail goto*//*Label 32238*/ GIMT_Encode4(2327409), // Rule ID 58817 //
     /* 2327357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327371 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2327374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2327388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327393 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327408 */   // GIR_Coverage, 58817,
     /* 2327408 */   GIR_EraseRootFromParent_Done,
     /* 2327409 */ // Label 32238: @2327409
     /* 2327409 */ GIM_Reject,
     /* 2327410 */ // Label 32181: @2327410
     /* 2327410 */ GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2327467), // Rule ID 58412 //
     /* 2327415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327429 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2327446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327466 */   // GIR_Coverage, 58412,
     /* 2327466 */   GIR_EraseRootFromParent_Done,
     /* 2327467 */ // Label 32239: @2327467
     /* 2327467 */ GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2327524), // Rule ID 58413 //
     /* 2327472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327486 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2327503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327522 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327523 */   // GIR_Coverage, 58413,
     /* 2327523 */   GIR_EraseRootFromParent_Done,
     /* 2327524 */ // Label 32240: @2327524
     /* 2327524 */ GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2327578), // Rule ID 58608 //
     /* 2327529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327543 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2327560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327562 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327577 */   // GIR_Coverage, 58608,
     /* 2327577 */   GIR_EraseRootFromParent_Done,
     /* 2327578 */ // Label 32241: @2327578
     /* 2327578 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2327632), // Rule ID 58609 //
     /* 2327583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2327589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327597 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2327614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327619 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327631 */   // GIR_Coverage, 58609,
     /* 2327631 */   GIR_EraseRootFromParent_Done,
     /* 2327632 */ // Label 32242: @2327632
     /* 2327632 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2327689), // Rule ID 58836 //
     /* 2327637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2327640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327651 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2327668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327688 */   // GIR_Coverage, 58836,
     /* 2327688 */   GIR_EraseRootFromParent_Done,
     /* 2327689 */ // Label 32243: @2327689
     /* 2327689 */ GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2327746), // Rule ID 58837 //
     /* 2327694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2327697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327708 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2327711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2327725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327730 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327745 */   // GIR_Coverage, 58837,
     /* 2327745 */   GIR_EraseRootFromParent_Done,
     /* 2327746 */ // Label 32244: @2327746
     /* 2327746 */ GIM_Reject,
     /* 2327747 */ // Label 32182: @2327747
     /* 2327747 */ GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2327804), // Rule ID 58444 //
     /* 2327752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2327755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327766 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2327783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327803 */   // GIR_Coverage, 58444,
     /* 2327803 */   GIR_EraseRootFromParent_Done,
     /* 2327804 */ // Label 32245: @2327804
     /* 2327804 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2327861), // Rule ID 58445 //
     /* 2327809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2327812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2327815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327823 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2327840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327845 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327860 */   // GIR_Coverage, 58445,
     /* 2327860 */   GIR_EraseRootFromParent_Done,
     /* 2327861 */ // Label 32246: @2327861
     /* 2327861 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2327915), // Rule ID 58628 //
     /* 2327866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2327869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327880 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2327897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327902 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327914 */   // GIR_Coverage, 58628,
     /* 2327914 */   GIR_EraseRootFromParent_Done,
     /* 2327915 */ // Label 32247: @2327915
     /* 2327915 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2327969), // Rule ID 58629 //
     /* 2327920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2327923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2327926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2327930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327934 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2327937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2327951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327956 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327968 */   // GIR_Coverage, 58629,
     /* 2327968 */   GIR_EraseRootFromParent_Done,
     /* 2327969 */ // Label 32248: @2327969
     /* 2327969 */ GIM_Reject,
     /* 2327970 */ // Label 32183: @2327970
     /* 2327970 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2328027), // Rule ID 58408 //
     /* 2327975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2327981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327989 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2327992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2328006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328011 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328026 */   // GIR_Coverage, 58408,
     /* 2328026 */   GIR_EraseRootFromParent_Done,
     /* 2328027 */ // Label 32249: @2328027
     /* 2328027 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2328084), // Rule ID 58409 //
     /* 2328032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328046 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2328063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328068 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328083 */   // GIR_Coverage, 58409,
     /* 2328083 */   GIR_EraseRootFromParent_Done,
     /* 2328084 */ // Label 32250: @2328084
     /* 2328084 */ GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2328138), // Rule ID 58588 //
     /* 2328089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2328095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328103 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2328120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328137 */   // GIR_Coverage, 58588,
     /* 2328137 */   GIR_EraseRootFromParent_Done,
     /* 2328138 */ // Label 32251: @2328138
     /* 2328138 */ GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2328192), // Rule ID 58589 //
     /* 2328143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2328149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328157 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2328174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328179 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328191 */   // GIR_Coverage, 58589,
     /* 2328191 */   GIR_EraseRootFromParent_Done,
     /* 2328192 */ // Label 32252: @2328192
     /* 2328192 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2328249), // Rule ID 58820 //
     /* 2328197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328211 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2328228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328233 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328248 */   // GIR_Coverage, 58820,
     /* 2328248 */   GIR_EraseRootFromParent_Done,
     /* 2328249 */ // Label 32253: @2328249
     /* 2328249 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2328306), // Rule ID 58821 //
     /* 2328254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328268 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2328285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328290 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328305 */   // GIR_Coverage, 58821,
     /* 2328305 */   GIR_EraseRootFromParent_Done,
     /* 2328306 */ // Label 32254: @2328306
     /* 2328306 */ GIM_Reject,
     /* 2328307 */ // Label 32184: @2328307
     /* 2328307 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2328364), // Rule ID 58432 //
     /* 2328312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328326 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2328343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328362 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328363 */   // GIR_Coverage, 58432,
     /* 2328363 */   GIR_EraseRootFromParent_Done,
     /* 2328364 */ // Label 32255: @2328364
     /* 2328364 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2328421), // Rule ID 58433 //
     /* 2328369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328383 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2328400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328405 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328420 */   // GIR_Coverage, 58433,
     /* 2328420 */   GIR_EraseRootFromParent_Done,
     /* 2328421 */ // Label 32256: @2328421
     /* 2328421 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2328475), // Rule ID 58612 //
     /* 2328426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328440 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2328457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328462 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328474 */   // GIR_Coverage, 58612,
     /* 2328474 */   GIR_EraseRootFromParent_Done,
     /* 2328475 */ // Label 32257: @2328475
     /* 2328475 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2328529), // Rule ID 58613 //
     /* 2328480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328494 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2328511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328516 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328528 */   // GIR_Coverage, 58613,
     /* 2328528 */   GIR_EraseRootFromParent_Done,
     /* 2328529 */ // Label 32258: @2328529
     /* 2328529 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2328586), // Rule ID 58840 //
     /* 2328534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2328537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2328540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328548 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2328565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328585 */   // GIR_Coverage, 58840,
     /* 2328585 */   GIR_EraseRootFromParent_Done,
     /* 2328586 */ // Label 32259: @2328586
     /* 2328586 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2328643), // Rule ID 58841 //
     /* 2328591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2328594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2328597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328605 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2328608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2328622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328627 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328642 */   // GIR_Coverage, 58841,
     /* 2328642 */   GIR_EraseRootFromParent_Done,
     /* 2328643 */ // Label 32260: @2328643
     /* 2328643 */ GIM_Reject,
     /* 2328644 */ // Label 32185: @2328644
     /* 2328644 */ GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2328701), // Rule ID 58448 //
     /* 2328649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2328652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2328655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328663 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2328666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2328680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328685 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328700 */   // GIR_Coverage, 58448,
     /* 2328700 */   GIR_EraseRootFromParent_Done,
     /* 2328701 */ // Label 32261: @2328701
     /* 2328701 */ GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2328758), // Rule ID 58449 //
     /* 2328706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2328709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2328712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328720 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2328723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2328737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328742 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328757 */   // GIR_Coverage, 58449,
     /* 2328757 */   GIR_EraseRootFromParent_Done,
     /* 2328758 */ // Label 32262: @2328758
     /* 2328758 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2328812), // Rule ID 58632 //
     /* 2328763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2328766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328777 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2328780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2328794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328799 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328811 */   // GIR_Coverage, 58632,
     /* 2328811 */   GIR_EraseRootFromParent_Done,
     /* 2328812 */ // Label 32263: @2328812
     /* 2328812 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2328866), // Rule ID 58633 //
     /* 2328817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2328820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2328823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2328827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328831 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2328834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2328848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328865 */   // GIR_Coverage, 58633,
     /* 2328865 */   GIR_EraseRootFromParent_Done,
     /* 2328866 */ // Label 32264: @2328866
     /* 2328866 */ GIM_Reject,
     /* 2328867 */ // Label 32186: @2328867
     /* 2328867 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2328924), // Rule ID 58420 //
     /* 2328872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2328878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328886 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2328903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328908 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328922 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328923 */   // GIR_Coverage, 58420,
     /* 2328923 */   GIR_EraseRootFromParent_Done,
     /* 2328924 */ // Label 32265: @2328924
     /* 2328924 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2328981), // Rule ID 58421 //
     /* 2328929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2328935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328943 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2328946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2328960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328965 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328980 */   // GIR_Coverage, 58421,
     /* 2328980 */   GIR_EraseRootFromParent_Done,
     /* 2328981 */ // Label 32266: @2328981
     /* 2328981 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2329035), // Rule ID 58592 //
     /* 2328986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2328992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329000 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2329017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329022 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329033 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329034 */   // GIR_Coverage, 58592,
     /* 2329034 */   GIR_EraseRootFromParent_Done,
     /* 2329035 */ // Label 32267: @2329035
     /* 2329035 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2329089), // Rule ID 58593 //
     /* 2329040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2329046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329054 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2329071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329076 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329087 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329088 */   // GIR_Coverage, 58593,
     /* 2329088 */   GIR_EraseRootFromParent_Done,
     /* 2329089 */ // Label 32268: @2329089
     /* 2329089 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2329146), // Rule ID 58824 //
     /* 2329094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329108 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2329125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329130 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329145 */   // GIR_Coverage, 58824,
     /* 2329145 */   GIR_EraseRootFromParent_Done,
     /* 2329146 */ // Label 32269: @2329146
     /* 2329146 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2329203), // Rule ID 58825 //
     /* 2329151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329165 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2329182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329202 */   // GIR_Coverage, 58825,
     /* 2329202 */   GIR_EraseRootFromParent_Done,
     /* 2329203 */ // Label 32270: @2329203
     /* 2329203 */ GIM_Reject,
     /* 2329204 */ // Label 32187: @2329204
     /* 2329204 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2329261), // Rule ID 58436 //
     /* 2329209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329223 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2329240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329245 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329260 */   // GIR_Coverage, 58436,
     /* 2329260 */   GIR_EraseRootFromParent_Done,
     /* 2329261 */ // Label 32271: @2329261
     /* 2329261 */ GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2329318), // Rule ID 58437 //
     /* 2329266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329280 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2329297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329302 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329317 */   // GIR_Coverage, 58437,
     /* 2329317 */   GIR_EraseRootFromParent_Done,
     /* 2329318 */ // Label 32272: @2329318
     /* 2329318 */ GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2329372), // Rule ID 58616 //
     /* 2329323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329337 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2329354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329359 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329370 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329371 */   // GIR_Coverage, 58616,
     /* 2329371 */   GIR_EraseRootFromParent_Done,
     /* 2329372 */ // Label 32273: @2329372
     /* 2329372 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2329426), // Rule ID 58617 //
     /* 2329377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329391 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2329408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329413 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329424 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329425 */   // GIR_Coverage, 58617,
     /* 2329425 */   GIR_EraseRootFromParent_Done,
     /* 2329426 */ // Label 32274: @2329426
     /* 2329426 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2329483), // Rule ID 58844 //
     /* 2329431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2329434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2329437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329445 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2329462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329467 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329481 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329482 */   // GIR_Coverage, 58844,
     /* 2329482 */   GIR_EraseRootFromParent_Done,
     /* 2329483 */ // Label 32275: @2329483
     /* 2329483 */ GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2329540), // Rule ID 58845 //
     /* 2329488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2329491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2329494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329502 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2329505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2329519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329524 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329539 */   // GIR_Coverage, 58845,
     /* 2329539 */   GIR_EraseRootFromParent_Done,
     /* 2329540 */ // Label 32276: @2329540
     /* 2329540 */ GIM_Reject,
     /* 2329541 */ // Label 32188: @2329541
     /* 2329541 */ GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2329598), // Rule ID 58452 //
     /* 2329546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2329549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2329552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329560 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2329563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2329577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329597 */   // GIR_Coverage, 58452,
     /* 2329597 */   GIR_EraseRootFromParent_Done,
     /* 2329598 */ // Label 32277: @2329598
     /* 2329598 */ GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2329655), // Rule ID 58453 //
     /* 2329603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2329606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2329609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329617 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2329620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2329634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329639 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329654 */   // GIR_Coverage, 58453,
     /* 2329654 */   GIR_EraseRootFromParent_Done,
     /* 2329655 */ // Label 32278: @2329655
     /* 2329655 */ GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2329709), // Rule ID 58636 //
     /* 2329660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2329663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329674 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2329677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2329691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329708 */   // GIR_Coverage, 58636,
     /* 2329708 */   GIR_EraseRootFromParent_Done,
     /* 2329709 */ // Label 32279: @2329709
     /* 2329709 */ GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2329763), // Rule ID 58637 //
     /* 2329714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2329717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2329724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329728 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2329731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2329745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329762 */   // GIR_Coverage, 58637,
     /* 2329762 */   GIR_EraseRootFromParent_Done,
     /* 2329763 */ // Label 32280: @2329763
     /* 2329763 */ GIM_Reject,
     /* 2329764 */ // Label 32189: @2329764
     /* 2329764 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2329821), // Rule ID 58424 //
     /* 2329769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2329775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329783 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2329786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2329800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329805 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329820 */   // GIR_Coverage, 58424,
     /* 2329820 */   GIR_EraseRootFromParent_Done,
     /* 2329821 */ // Label 32281: @2329821
     /* 2329821 */ GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2329878), // Rule ID 58425 //
     /* 2329826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2329832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329840 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2329843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2329857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329862 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329877 */   // GIR_Coverage, 58425,
     /* 2329877 */   GIR_EraseRootFromParent_Done,
     /* 2329878 */ // Label 32282: @2329878
     /* 2329878 */ GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2329932), // Rule ID 58596 //
     /* 2329883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2329889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329897 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2329900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2329914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329916 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329919 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329931 */   // GIR_Coverage, 58596,
     /* 2329931 */   GIR_EraseRootFromParent_Done,
     /* 2329932 */ // Label 32283: @2329932
     /* 2329932 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2329986), // Rule ID 58597 //
     /* 2329937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2329943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329951 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2329954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2329968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329985 */   // GIR_Coverage, 58597,
     /* 2329985 */   GIR_EraseRootFromParent_Done,
     /* 2329986 */ // Label 32284: @2329986
     /* 2329986 */ GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2330043), // Rule ID 58828 //
     /* 2329991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2329997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330005 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2330022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330041 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330042 */   // GIR_Coverage, 58828,
     /* 2330042 */   GIR_EraseRootFromParent_Done,
     /* 2330043 */ // Label 32285: @2330043
     /* 2330043 */ GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2330100), // Rule ID 58829 //
     /* 2330048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330062 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2330079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330084 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330099 */   // GIR_Coverage, 58829,
     /* 2330099 */   GIR_EraseRootFromParent_Done,
     /* 2330100 */ // Label 32286: @2330100
     /* 2330100 */ GIM_Reject,
     /* 2330101 */ // Label 32190: @2330101
     /* 2330101 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2330158), // Rule ID 58440 //
     /* 2330106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330120 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2330137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330142 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330157 */   // GIR_Coverage, 58440,
     /* 2330157 */   GIR_EraseRootFromParent_Done,
     /* 2330158 */ // Label 32287: @2330158
     /* 2330158 */ GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2330215), // Rule ID 58441 //
     /* 2330163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330177 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2330194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330199 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330214 */   // GIR_Coverage, 58441,
     /* 2330214 */   GIR_EraseRootFromParent_Done,
     /* 2330215 */ // Label 32288: @2330215
     /* 2330215 */ GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2330269), // Rule ID 58620 //
     /* 2330220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330234 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2330251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330256 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330268 */   // GIR_Coverage, 58620,
     /* 2330268 */   GIR_EraseRootFromParent_Done,
     /* 2330269 */ // Label 32289: @2330269
     /* 2330269 */ GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2330323), // Rule ID 58621 //
     /* 2330274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330288 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2330305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330321 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330322 */   // GIR_Coverage, 58621,
     /* 2330322 */   GIR_EraseRootFromParent_Done,
     /* 2330323 */ // Label 32290: @2330323
     /* 2330323 */ GIM_Reject,
     /* 2330324 */ // Label 32191: @2330324
     /* 2330324 */ GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2330381), // Rule ID 58428 //
     /* 2330329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2330335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330343 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2330360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330365 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330380 */   // GIR_Coverage, 58428,
     /* 2330380 */   GIR_EraseRootFromParent_Done,
     /* 2330381 */ // Label 32291: @2330381
     /* 2330381 */ GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2330438), // Rule ID 58429 //
     /* 2330386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2330392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330400 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2330417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330422 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330437 */   // GIR_Coverage, 58429,
     /* 2330437 */   GIR_EraseRootFromParent_Done,
     /* 2330438 */ // Label 32292: @2330438
     /* 2330438 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2330492), // Rule ID 58600 //
     /* 2330443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2330449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330457 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2330474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330491 */   // GIR_Coverage, 58600,
     /* 2330491 */   GIR_EraseRootFromParent_Done,
     /* 2330492 */ // Label 32293: @2330492
     /* 2330492 */ GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2330546), // Rule ID 58601 //
     /* 2330497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2330503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330511 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2330514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2330528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330545 */   // GIR_Coverage, 58601,
     /* 2330545 */   GIR_EraseRootFromParent_Done,
     /* 2330546 */ // Label 32294: @2330546
     /* 2330546 */ GIM_Reject,
     /* 2330547 */ // Label 32192: @2330547
     /* 2330547 */ GIM_Reject,
     /* 2330548 */ // Label 70: @2330548
     /* 2330548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32313*/ GIMT_Encode4(2335833),
     /* 2330559 */ /*GILLT_s16*//*Label 32295*/ GIMT_Encode4(2330679),
     /* 2330563 */ /*GILLT_s32*//*Label 32296*/ GIMT_Encode4(2330940),
     /* 2330567 */ /*GILLT_s64*//*Label 32297*/ GIMT_Encode4(2331201), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330579 */ /*GILLT_nxv1s16*//*Label 32298*/ GIMT_Encode4(2331462),
     /* 2330583 */ /*GILLT_nxv1s32*//*Label 32299*/ GIMT_Encode4(2331799),
     /* 2330587 */ /*GILLT_nxv1s64*//*Label 32300*/ GIMT_Encode4(2332136), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330599 */ /*GILLT_nxv2s16*//*Label 32301*/ GIMT_Encode4(2332359),
     /* 2330603 */ /*GILLT_nxv2s32*//*Label 32302*/ GIMT_Encode4(2332696),
     /* 2330607 */ /*GILLT_nxv2s64*//*Label 32303*/ GIMT_Encode4(2333033), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330619 */ /*GILLT_nxv4s16*//*Label 32304*/ GIMT_Encode4(2333256),
     /* 2330623 */ /*GILLT_nxv4s32*//*Label 32305*/ GIMT_Encode4(2333593),
     /* 2330627 */ /*GILLT_nxv4s64*//*Label 32306*/ GIMT_Encode4(2333930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330639 */ /*GILLT_nxv8s16*//*Label 32307*/ GIMT_Encode4(2334153),
     /* 2330643 */ /*GILLT_nxv8s32*//*Label 32308*/ GIMT_Encode4(2334490),
     /* 2330647 */ /*GILLT_nxv8s64*//*Label 32309*/ GIMT_Encode4(2334827), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330659 */ /*GILLT_nxv16s16*//*Label 32310*/ GIMT_Encode4(2335050),
     /* 2330663 */ /*GILLT_nxv16s32*//*Label 32311*/ GIMT_Encode4(2335387), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2330675 */ /*GILLT_nxv32s16*//*Label 32312*/ GIMT_Encode4(2335610),
     /* 2330679 */ // Label 32295: @2330679
     /* 2330679 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2330716), // Rule ID 2255 //
     /* 2330684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2330687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2330701 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2330704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2330711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330715 */   // GIR_Coverage, 2255,
     /* 2330715 */   GIR_EraseRootFromParent_Done,
     /* 2330716 */ // Label 32314: @2330716
     /* 2330716 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2330753), // Rule ID 2281 //
     /* 2330721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2330724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330731 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2330738 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2330741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2330748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330752 */   // GIR_Coverage, 2281,
     /* 2330752 */   GIR_EraseRootFromParent_Done,
     /* 2330753 */ // Label 32315: @2330753
     /* 2330753 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2330784), // Rule ID 2206 //
     /* 2330758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2330761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330772 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2330772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2330775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330777 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330783 */   // GIR_Coverage, 2206,
     /* 2330783 */   GIR_EraseRootFromParent_Done,
     /* 2330784 */ // Label 32316: @2330784
     /* 2330784 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2330815), // Rule ID 2207 //
     /* 2330789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2330792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330803 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2330803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2330806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330808 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330814 */   // GIR_Coverage, 2207,
     /* 2330814 */   GIR_EraseRootFromParent_Done,
     /* 2330815 */ // Label 32317: @2330815
     /* 2330815 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2330846), // Rule ID 2232 //
     /* 2330820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2330823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330834 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2330834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2330837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330839 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330845 */   // GIR_Coverage, 2232,
     /* 2330845 */   GIR_EraseRootFromParent_Done,
     /* 2330846 */ // Label 32318: @2330846
     /* 2330846 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2330877), // Rule ID 2233 //
     /* 2330851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2330854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2330857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330865 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2330865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2330868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330876 */   // GIR_Coverage, 2233,
     /* 2330876 */   GIR_EraseRootFromParent_Done,
     /* 2330877 */ // Label 32319: @2330877
     /* 2330877 */ GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2330908), // Rule ID 2259 //
     /* 2330882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2330885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2330892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330896 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2330899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330907 */   // GIR_Coverage, 2259,
     /* 2330907 */   GIR_EraseRootFromParent_Done,
     /* 2330908 */ // Label 32320: @2330908
     /* 2330908 */ GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2330939), // Rule ID 2285 //
     /* 2330913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2330916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2330923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2330927 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2330930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330932 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330938 */   // GIR_Coverage, 2285,
     /* 2330938 */   GIR_EraseRootFromParent_Done,
     /* 2330939 */ // Label 32321: @2330939
     /* 2330939 */ GIM_Reject,
     /* 2330940 */ // Label 32296: @2330940
     /* 2330940 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2330977), // Rule ID 1517 //
     /* 2330945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2330948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2330955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2330962 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2330965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2330972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330975 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330976 */   // GIR_Coverage, 1517,
     /* 2330976 */   GIR_EraseRootFromParent_Done,
     /* 2330977 */ // Label 32322: @2330977
     /* 2330977 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2331014), // Rule ID 1545 //
     /* 2330982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2330985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2330988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2330992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2330999 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2330999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2331002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2331009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331013 */   // GIR_Coverage, 1545,
     /* 2331013 */   GIR_EraseRootFromParent_Done,
     /* 2331014 */ // Label 32323: @2331014
     /* 2331014 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2331045), // Rule ID 1466 //
     /* 2331019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2331022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331033 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2331033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2331036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331038 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331044 */   // GIR_Coverage, 1466,
     /* 2331044 */   GIR_EraseRootFromParent_Done,
     /* 2331045 */ // Label 32324: @2331045
     /* 2331045 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2331076), // Rule ID 1467 //
     /* 2331050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2331053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331064 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2331064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2331067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331074 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331075 */   // GIR_Coverage, 1467,
     /* 2331075 */   GIR_EraseRootFromParent_Done,
     /* 2331076 */ // Label 32325: @2331076
     /* 2331076 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2331107), // Rule ID 1492 //
     /* 2331081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2331084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331095 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2331095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2331098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331100 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331106 */   // GIR_Coverage, 1492,
     /* 2331106 */   GIR_EraseRootFromParent_Done,
     /* 2331107 */ // Label 32326: @2331107
     /* 2331107 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2331138), // Rule ID 1493 //
     /* 2331112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2331115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331126 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2331126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2331129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331137 */   // GIR_Coverage, 1493,
     /* 2331137 */   GIR_EraseRootFromParent_Done,
     /* 2331138 */ // Label 32327: @2331138
     /* 2331138 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2331169), // Rule ID 1521 //
     /* 2331143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2331146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331157 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2331157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2331160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331162 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331168 */   // GIR_Coverage, 1521,
     /* 2331168 */   GIR_EraseRootFromParent_Done,
     /* 2331169 */ // Label 32328: @2331169
     /* 2331169 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2331200), // Rule ID 1549 //
     /* 2331174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2331177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331188 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2331188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2331191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331193 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331199 */   // GIR_Coverage, 1549,
     /* 2331199 */   GIR_EraseRootFromParent_Done,
     /* 2331200 */ // Label 32329: @2331200
     /* 2331200 */ GIM_Reject,
     /* 2331201 */ // Label 32297: @2331201
     /* 2331201 */ GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2331238), // Rule ID 1901 //
     /* 2331206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2331209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331216 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2331223 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2331223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2331226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2331233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331237 */   // GIR_Coverage, 1901,
     /* 2331237 */   GIR_EraseRootFromParent_Done,
     /* 2331238 */ // Label 32330: @2331238
     /* 2331238 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2331275), // Rule ID 1929 //
     /* 2331243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2331260 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2331260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2331263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2331270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331274 */   // GIR_Coverage, 1929,
     /* 2331274 */   GIR_EraseRootFromParent_Done,
     /* 2331275 */ // Label 32331: @2331275
     /* 2331275 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2331306), // Rule ID 1864 //
     /* 2331280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2331283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331294 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2331294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2331297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331299 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331304 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331305 */   // GIR_Coverage, 1864,
     /* 2331305 */   GIR_EraseRootFromParent_Done,
     /* 2331306 */ // Label 32332: @2331306
     /* 2331306 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2331337), // Rule ID 1865 //
     /* 2331311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2331314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331325 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2331325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2331328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331330 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331336 */   // GIR_Coverage, 1865,
     /* 2331336 */   GIR_EraseRootFromParent_Done,
     /* 2331337 */ // Label 32333: @2331337
     /* 2331337 */ GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2331368), // Rule ID 1890 //
     /* 2331342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2331345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331356 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2331356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2331359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331361 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331367 */   // GIR_Coverage, 1890,
     /* 2331367 */   GIR_EraseRootFromParent_Done,
     /* 2331368 */ // Label 32334: @2331368
     /* 2331368 */ GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2331399), // Rule ID 1891 //
     /* 2331373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2331376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331387 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2331387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2331390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331392 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2331397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331398 */   // GIR_Coverage, 1891,
     /* 2331398 */   GIR_EraseRootFromParent_Done,
     /* 2331399 */ // Label 32335: @2331399
     /* 2331399 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2331430), // Rule ID 1919 //
     /* 2331404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2331407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331418 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2331418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2331421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331423 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331429 */   // GIR_Coverage, 1919,
     /* 2331429 */   GIR_EraseRootFromParent_Done,
     /* 2331430 */ // Label 32336: @2331430
     /* 2331430 */ GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2331461), // Rule ID 1947 //
     /* 2331435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331449 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2331449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2331452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331460 */   // GIR_Coverage, 1947,
     /* 2331460 */   GIR_EraseRootFromParent_Done,
     /* 2331461 */ // Label 32337: @2331461
     /* 2331461 */ GIM_Reject,
     /* 2331462 */ // Label 32298: @2331462
     /* 2331462 */ GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2331519), // Rule ID 58456 //
     /* 2331467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2331473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331481 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2331498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331518 */   // GIR_Coverage, 58456,
     /* 2331518 */   GIR_EraseRootFromParent_Done,
     /* 2331519 */ // Label 32338: @2331519
     /* 2331519 */ GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2331576), // Rule ID 58457 //
     /* 2331524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2331530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331538 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2331555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331560 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331575 */   // GIR_Coverage, 58457,
     /* 2331575 */   GIR_EraseRootFromParent_Done,
     /* 2331576 */ // Label 32339: @2331576
     /* 2331576 */ GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2331630), // Rule ID 58640 //
     /* 2331581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2331587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331595 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2331612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331617 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331629 */   // GIR_Coverage, 58640,
     /* 2331629 */   GIR_EraseRootFromParent_Done,
     /* 2331630 */ // Label 32340: @2331630
     /* 2331630 */ GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2331684), // Rule ID 58641 //
     /* 2331635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2331641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331649 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2331666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331683 */   // GIR_Coverage, 58641,
     /* 2331683 */   GIR_EraseRootFromParent_Done,
     /* 2331684 */ // Label 32341: @2331684
     /* 2331684 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2331741), // Rule ID 58848 //
     /* 2331689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331703 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2331720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331725 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331740 */   // GIR_Coverage, 58848,
     /* 2331740 */   GIR_EraseRootFromParent_Done,
     /* 2331741 */ // Label 32342: @2331741
     /* 2331741 */ GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2331798), // Rule ID 58849 //
     /* 2331746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331760 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2331777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331797 */   // GIR_Coverage, 58849,
     /* 2331797 */   GIR_EraseRootFromParent_Done,
     /* 2331798 */ // Label 32343: @2331798
     /* 2331798 */ GIM_Reject,
     /* 2331799 */ // Label 32299: @2331799
     /* 2331799 */ GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2331856), // Rule ID 58464 //
     /* 2331804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331818 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2331835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331840 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331855 */   // GIR_Coverage, 58464,
     /* 2331855 */   GIR_EraseRootFromParent_Done,
     /* 2331856 */ // Label 32344: @2331856
     /* 2331856 */ GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2331913), // Rule ID 58465 //
     /* 2331861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331875 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2331892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331897 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331912 */   // GIR_Coverage, 58465,
     /* 2331912 */   GIR_EraseRootFromParent_Done,
     /* 2331913 */ // Label 32345: @2331913
     /* 2331913 */ GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2331967), // Rule ID 58664 //
     /* 2331918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2331924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331932 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2331949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331966 */   // GIR_Coverage, 58664,
     /* 2331966 */   GIR_EraseRootFromParent_Done,
     /* 2331967 */ // Label 32346: @2331967
     /* 2331967 */ GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2332021), // Rule ID 58665 //
     /* 2331972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2331978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331986 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2331989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2332003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332008 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332020 */   // GIR_Coverage, 58665,
     /* 2332020 */   GIR_EraseRootFromParent_Done,
     /* 2332021 */ // Label 32347: @2332021
     /* 2332021 */ GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2332078), // Rule ID 58868 //
     /* 2332026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2332029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332040 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2332057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332062 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332077 */   // GIR_Coverage, 58868,
     /* 2332077 */   GIR_EraseRootFromParent_Done,
     /* 2332078 */ // Label 32348: @2332078
     /* 2332078 */ GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2332135), // Rule ID 58869 //
     /* 2332083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2332086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332097 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332097 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332100 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332104 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2332114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332119 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332134 */   // GIR_Coverage, 58869,
     /* 2332134 */   GIR_EraseRootFromParent_Done,
     /* 2332135 */ // Label 32349: @2332135
     /* 2332135 */ GIM_Reject,
     /* 2332136 */ // Label 32300: @2332136
     /* 2332136 */ GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2332193), // Rule ID 58476 //
     /* 2332141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2332144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332155 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2332172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332177 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332192 */   // GIR_Coverage, 58476,
     /* 2332192 */   GIR_EraseRootFromParent_Done,
     /* 2332193 */ // Label 32350: @2332193
     /* 2332193 */ GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2332250), // Rule ID 58477 //
     /* 2332198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2332201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332212 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2332229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332234 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332249 */   // GIR_Coverage, 58477,
     /* 2332249 */   GIR_EraseRootFromParent_Done,
     /* 2332250 */ // Label 32351: @2332250
     /* 2332250 */ GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2332304), // Rule ID 58684 //
     /* 2332255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2332258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332269 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2332286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332303 */   // GIR_Coverage, 58684,
     /* 2332303 */   GIR_EraseRootFromParent_Done,
     /* 2332304 */ // Label 32352: @2332304
     /* 2332304 */ GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2332358), // Rule ID 58685 //
     /* 2332309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2332312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332323 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2332340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332345 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332357 */   // GIR_Coverage, 58685,
     /* 2332357 */   GIR_EraseRootFromParent_Done,
     /* 2332358 */ // Label 32353: @2332358
     /* 2332358 */ GIM_Reject,
     /* 2332359 */ // Label 32301: @2332359
     /* 2332359 */ GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2332416), // Rule ID 58460 //
     /* 2332364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332378 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2332395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332415 */   // GIR_Coverage, 58460,
     /* 2332415 */   GIR_EraseRootFromParent_Done,
     /* 2332416 */ // Label 32354: @2332416
     /* 2332416 */ GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2332473), // Rule ID 58461 //
     /* 2332421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332435 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2332452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332472 */   // GIR_Coverage, 58461,
     /* 2332472 */   GIR_EraseRootFromParent_Done,
     /* 2332473 */ // Label 32355: @2332473
     /* 2332473 */ GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2332527), // Rule ID 58644 //
     /* 2332478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2332484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332492 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2332509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332514 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332526 */   // GIR_Coverage, 58644,
     /* 2332526 */   GIR_EraseRootFromParent_Done,
     /* 2332527 */ // Label 32356: @2332527
     /* 2332527 */ GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2332581), // Rule ID 58645 //
     /* 2332532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2332538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332546 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2332563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332568 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332579 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332580 */   // GIR_Coverage, 58645,
     /* 2332580 */   GIR_EraseRootFromParent_Done,
     /* 2332581 */ // Label 32357: @2332581
     /* 2332581 */ GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2332638), // Rule ID 58852 //
     /* 2332586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2332592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332600 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2332617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332622 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332637 */   // GIR_Coverage, 58852,
     /* 2332637 */   GIR_EraseRootFromParent_Done,
     /* 2332638 */ // Label 32358: @2332638
     /* 2332638 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2332695), // Rule ID 58853 //
     /* 2332643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2332649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332657 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2332674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332679 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332694 */   // GIR_Coverage, 58853,
     /* 2332694 */   GIR_EraseRootFromParent_Done,
     /* 2332695 */ // Label 32359: @2332695
     /* 2332695 */ GIM_Reject,
     /* 2332696 */ // Label 32302: @2332696
     /* 2332696 */ GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2332753), // Rule ID 58472 //
     /* 2332701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2332707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332715 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2332732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332751 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332752 */   // GIR_Coverage, 58472,
     /* 2332752 */   GIR_EraseRootFromParent_Done,
     /* 2332753 */ // Label 32360: @2332753
     /* 2332753 */ GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2332810), // Rule ID 58473 //
     /* 2332758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2332764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332772 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2332789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332794 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332808 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332809 */   // GIR_Coverage, 58473,
     /* 2332809 */   GIR_EraseRootFromParent_Done,
     /* 2332810 */ // Label 32361: @2332810
     /* 2332810 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2332864), // Rule ID 58668 //
     /* 2332815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332829 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2332846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332851 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332863 */   // GIR_Coverage, 58668,
     /* 2332863 */   GIR_EraseRootFromParent_Done,
     /* 2332864 */ // Label 32362: @2332864
     /* 2332864 */ GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2332918), // Rule ID 58669 //
     /* 2332869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332883 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2332900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332905 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332917 */   // GIR_Coverage, 58669,
     /* 2332917 */   GIR_EraseRootFromParent_Done,
     /* 2332918 */ // Label 32363: @2332918
     /* 2332918 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2332975), // Rule ID 58872 //
     /* 2332923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2332926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2332929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332937 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2332954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332959 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2332964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332974 */   // GIR_Coverage, 58872,
     /* 2332974 */   GIR_EraseRootFromParent_Done,
     /* 2332975 */ // Label 32364: @2332975
     /* 2332975 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2333032), // Rule ID 58873 //
     /* 2332980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2332983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2332986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332994 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2333011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333031 */   // GIR_Coverage, 58873,
     /* 2333031 */   GIR_EraseRootFromParent_Done,
     /* 2333032 */ // Label 32365: @2333032
     /* 2333032 */ GIM_Reject,
     /* 2333033 */ // Label 32303: @2333033
     /* 2333033 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2333090), // Rule ID 58504 //
     /* 2333038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333052 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2333069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333089 */   // GIR_Coverage, 58504,
     /* 2333089 */   GIR_EraseRootFromParent_Done,
     /* 2333090 */ // Label 32366: @2333090
     /* 2333090 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2333147), // Rule ID 58505 //
     /* 2333095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2333098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333109 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2333126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333131 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333146 */   // GIR_Coverage, 58505,
     /* 2333146 */   GIR_EraseRootFromParent_Done,
     /* 2333147 */ // Label 32367: @2333147
     /* 2333147 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2333201), // Rule ID 58688 //
     /* 2333152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333166 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2333183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333188 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333200 */   // GIR_Coverage, 58688,
     /* 2333200 */   GIR_EraseRootFromParent_Done,
     /* 2333201 */ // Label 32368: @2333201
     /* 2333201 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2333255), // Rule ID 58689 //
     /* 2333206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333220 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2333237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333242 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333254 */   // GIR_Coverage, 58689,
     /* 2333254 */   GIR_EraseRootFromParent_Done,
     /* 2333255 */ // Label 32369: @2333255
     /* 2333255 */ GIM_Reject,
     /* 2333256 */ // Label 32304: @2333256
     /* 2333256 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2333313), // Rule ID 58468 //
     /* 2333261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333275 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2333292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333312 */   // GIR_Coverage, 58468,
     /* 2333312 */   GIR_EraseRootFromParent_Done,
     /* 2333313 */ // Label 32370: @2333313
     /* 2333313 */ GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2333370), // Rule ID 58469 //
     /* 2333318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333332 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2333349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333369 */   // GIR_Coverage, 58469,
     /* 2333369 */   GIR_EraseRootFromParent_Done,
     /* 2333370 */ // Label 32371: @2333370
     /* 2333370 */ GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2333424), // Rule ID 58648 //
     /* 2333375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2333381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333389 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2333406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333411 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333423 */   // GIR_Coverage, 58648,
     /* 2333423 */   GIR_EraseRootFromParent_Done,
     /* 2333424 */ // Label 32372: @2333424
     /* 2333424 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2333478), // Rule ID 58649 //
     /* 2333429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2333435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333443 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2333460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333477 */   // GIR_Coverage, 58649,
     /* 2333477 */   GIR_EraseRootFromParent_Done,
     /* 2333478 */ // Label 32373: @2333478
     /* 2333478 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2333535), // Rule ID 58856 //
     /* 2333483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2333489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333497 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2333514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333519 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333534 */   // GIR_Coverage, 58856,
     /* 2333534 */   GIR_EraseRootFromParent_Done,
     /* 2333535 */ // Label 32374: @2333535
     /* 2333535 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2333592), // Rule ID 58857 //
     /* 2333540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2333546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333554 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2333571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333576 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333591 */   // GIR_Coverage, 58857,
     /* 2333591 */   GIR_EraseRootFromParent_Done,
     /* 2333592 */ // Label 32375: @2333592
     /* 2333592 */ GIM_Reject,
     /* 2333593 */ // Label 32305: @2333593
     /* 2333593 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2333650), // Rule ID 58492 //
     /* 2333598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2333604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333612 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2333629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333634 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333649 */   // GIR_Coverage, 58492,
     /* 2333649 */   GIR_EraseRootFromParent_Done,
     /* 2333650 */ // Label 32376: @2333650
     /* 2333650 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2333707), // Rule ID 58493 //
     /* 2333655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2333661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333669 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2333686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333706 */   // GIR_Coverage, 58493,
     /* 2333706 */   GIR_EraseRootFromParent_Done,
     /* 2333707 */ // Label 32377: @2333707
     /* 2333707 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2333761), // Rule ID 58672 //
     /* 2333712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333726 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2333743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333748 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333760 */   // GIR_Coverage, 58672,
     /* 2333760 */   GIR_EraseRootFromParent_Done,
     /* 2333761 */ // Label 32378: @2333761
     /* 2333761 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2333815), // Rule ID 58673 //
     /* 2333766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333780 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2333797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333802 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333814 */   // GIR_Coverage, 58673,
     /* 2333814 */   GIR_EraseRootFromParent_Done,
     /* 2333815 */ // Label 32379: @2333815
     /* 2333815 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2333872), // Rule ID 58876 //
     /* 2333820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2333823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2333826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333834 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2333851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333856 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333871 */   // GIR_Coverage, 58876,
     /* 2333871 */   GIR_EraseRootFromParent_Done,
     /* 2333872 */ // Label 32380: @2333872
     /* 2333872 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2333929), // Rule ID 58877 //
     /* 2333877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2333880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2333883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333891 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2333894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2333908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333913 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333928 */   // GIR_Coverage, 58877,
     /* 2333928 */   GIR_EraseRootFromParent_Done,
     /* 2333929 */ // Label 32381: @2333929
     /* 2333929 */ GIM_Reject,
     /* 2333930 */ // Label 32306: @2333930
     /* 2333930 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2333987), // Rule ID 58508 //
     /* 2333935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2333941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333949 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2333952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2333966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333971 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2333976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333985 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333986 */   // GIR_Coverage, 58508,
     /* 2333986 */   GIR_EraseRootFromParent_Done,
     /* 2333987 */ // Label 32382: @2333987
     /* 2333987 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2334044), // Rule ID 58509 //
     /* 2333992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2333995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2333998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334006 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2334023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334028 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334043 */   // GIR_Coverage, 58509,
     /* 2334043 */   GIR_EraseRootFromParent_Done,
     /* 2334044 */ // Label 32383: @2334044
     /* 2334044 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2334098), // Rule ID 58692 //
     /* 2334049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334063 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2334080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334085 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334097 */   // GIR_Coverage, 58692,
     /* 2334097 */   GIR_EraseRootFromParent_Done,
     /* 2334098 */ // Label 32384: @2334098
     /* 2334098 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2334152), // Rule ID 58693 //
     /* 2334103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2334106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334117 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2334134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334150 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334151 */   // GIR_Coverage, 58693,
     /* 2334151 */   GIR_EraseRootFromParent_Done,
     /* 2334152 */ // Label 32385: @2334152
     /* 2334152 */ GIM_Reject,
     /* 2334153 */ // Label 32307: @2334153
     /* 2334153 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2334210), // Rule ID 58480 //
     /* 2334158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334172 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2334189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334194 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334209 */   // GIR_Coverage, 58480,
     /* 2334209 */   GIR_EraseRootFromParent_Done,
     /* 2334210 */ // Label 32386: @2334210
     /* 2334210 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2334267), // Rule ID 58481 //
     /* 2334215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334229 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2334246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334251 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334266 */   // GIR_Coverage, 58481,
     /* 2334266 */   GIR_EraseRootFromParent_Done,
     /* 2334267 */ // Label 32387: @2334267
     /* 2334267 */ GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2334321), // Rule ID 58652 //
     /* 2334272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2334278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334286 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2334303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334308 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334320 */   // GIR_Coverage, 58652,
     /* 2334320 */   GIR_EraseRootFromParent_Done,
     /* 2334321 */ // Label 32388: @2334321
     /* 2334321 */ GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2334375), // Rule ID 58653 //
     /* 2334326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2334332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334340 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2334357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334362 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334374 */   // GIR_Coverage, 58653,
     /* 2334374 */   GIR_EraseRootFromParent_Done,
     /* 2334375 */ // Label 32389: @2334375
     /* 2334375 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2334432), // Rule ID 58860 //
     /* 2334380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334394 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2334411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334416 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334431 */   // GIR_Coverage, 58860,
     /* 2334431 */   GIR_EraseRootFromParent_Done,
     /* 2334432 */ // Label 32390: @2334432
     /* 2334432 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2334489), // Rule ID 58861 //
     /* 2334437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334451 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2334468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334473 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334488 */   // GIR_Coverage, 58861,
     /* 2334488 */   GIR_EraseRootFromParent_Done,
     /* 2334489 */ // Label 32391: @2334489
     /* 2334489 */ GIM_Reject,
     /* 2334490 */ // Label 32308: @2334490
     /* 2334490 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2334547), // Rule ID 58496 //
     /* 2334495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334509 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2334526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334531 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334546 */   // GIR_Coverage, 58496,
     /* 2334546 */   GIR_EraseRootFromParent_Done,
     /* 2334547 */ // Label 32392: @2334547
     /* 2334547 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2334604), // Rule ID 58497 //
     /* 2334552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334566 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2334583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334603 */   // GIR_Coverage, 58497,
     /* 2334603 */   GIR_EraseRootFromParent_Done,
     /* 2334604 */ // Label 32393: @2334604
     /* 2334604 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2334658), // Rule ID 58676 //
     /* 2334609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334623 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2334640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334645 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334657 */   // GIR_Coverage, 58676,
     /* 2334657 */   GIR_EraseRootFromParent_Done,
     /* 2334658 */ // Label 32394: @2334658
     /* 2334658 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2334712), // Rule ID 58677 //
     /* 2334663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334677 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2334694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334699 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334711 */   // GIR_Coverage, 58677,
     /* 2334711 */   GIR_EraseRootFromParent_Done,
     /* 2334712 */ // Label 32395: @2334712
     /* 2334712 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2334769), // Rule ID 58880 //
     /* 2334717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2334723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334731 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2334748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334768 */   // GIR_Coverage, 58880,
     /* 2334768 */   GIR_EraseRootFromParent_Done,
     /* 2334769 */ // Label 32396: @2334769
     /* 2334769 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2334826), // Rule ID 58881 //
     /* 2334774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2334780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334788 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2334805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334810 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334825 */   // GIR_Coverage, 58881,
     /* 2334825 */   GIR_EraseRootFromParent_Done,
     /* 2334826 */ // Label 32397: @2334826
     /* 2334826 */ GIM_Reject,
     /* 2334827 */ // Label 32309: @2334827
     /* 2334827 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2334884), // Rule ID 58512 //
     /* 2334832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2334835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2334838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334846 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2334849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2334863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334868 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334883 */   // GIR_Coverage, 58512,
     /* 2334883 */   GIR_EraseRootFromParent_Done,
     /* 2334884 */ // Label 32398: @2334884
     /* 2334884 */ GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2334941), // Rule ID 58513 //
     /* 2334889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2334895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334903 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2334906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2334920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2334930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334940 */   // GIR_Coverage, 58513,
     /* 2334940 */   GIR_EraseRootFromParent_Done,
     /* 2334941 */ // Label 32399: @2334941
     /* 2334941 */ GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2334995), // Rule ID 58696 //
     /* 2334946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2334956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334960 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2334963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2334977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334982 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334994 */   // GIR_Coverage, 58696,
     /* 2334994 */   GIR_EraseRootFromParent_Done,
     /* 2334995 */ // Label 32400: @2334995
     /* 2334995 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2335049), // Rule ID 58697 //
     /* 2335000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335014 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2335031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335048 */   // GIR_Coverage, 58697,
     /* 2335048 */   GIR_EraseRootFromParent_Done,
     /* 2335049 */ // Label 32401: @2335049
     /* 2335049 */ GIM_Reject,
     /* 2335050 */ // Label 32310: @2335050
     /* 2335050 */ GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2335107), // Rule ID 58484 //
     /* 2335055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335069 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2335086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335091 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335105 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335106 */   // GIR_Coverage, 58484,
     /* 2335106 */   GIR_EraseRootFromParent_Done,
     /* 2335107 */ // Label 32402: @2335107
     /* 2335107 */ GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2335164), // Rule ID 58485 //
     /* 2335112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335126 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2335143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335148 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335162 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335163 */   // GIR_Coverage, 58485,
     /* 2335163 */   GIR_EraseRootFromParent_Done,
     /* 2335164 */ // Label 32403: @2335164
     /* 2335164 */ GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2335218), // Rule ID 58656 //
     /* 2335169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2335175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335183 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2335200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335205 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335217 */   // GIR_Coverage, 58656,
     /* 2335217 */   GIR_EraseRootFromParent_Done,
     /* 2335218 */ // Label 32404: @2335218
     /* 2335218 */ GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2335272), // Rule ID 58657 //
     /* 2335223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2335229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335237 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335237 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335240 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335244 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2335254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335259 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335271 */   // GIR_Coverage, 58657,
     /* 2335271 */   GIR_EraseRootFromParent_Done,
     /* 2335272 */ // Label 32405: @2335272
     /* 2335272 */ GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2335329), // Rule ID 58864 //
     /* 2335277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335291 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2335308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335313 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335328 */   // GIR_Coverage, 58864,
     /* 2335328 */   GIR_EraseRootFromParent_Done,
     /* 2335329 */ // Label 32406: @2335329
     /* 2335329 */ GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2335386), // Rule ID 58865 //
     /* 2335334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335348 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2335365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335370 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335385 */   // GIR_Coverage, 58865,
     /* 2335385 */   GIR_EraseRootFromParent_Done,
     /* 2335386 */ // Label 32407: @2335386
     /* 2335386 */ GIM_Reject,
     /* 2335387 */ // Label 32311: @2335387
     /* 2335387 */ GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2335444), // Rule ID 58500 //
     /* 2335392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335406 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2335423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335428 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335443 */   // GIR_Coverage, 58500,
     /* 2335443 */   GIR_EraseRootFromParent_Done,
     /* 2335444 */ // Label 32408: @2335444
     /* 2335444 */ GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2335501), // Rule ID 58501 //
     /* 2335449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335463 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2335480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335485 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335500 */   // GIR_Coverage, 58501,
     /* 2335500 */   GIR_EraseRootFromParent_Done,
     /* 2335501 */ // Label 32409: @2335501
     /* 2335501 */ GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2335555), // Rule ID 58680 //
     /* 2335506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335520 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2335537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335542 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335554 */   // GIR_Coverage, 58680,
     /* 2335554 */   GIR_EraseRootFromParent_Done,
     /* 2335555 */ // Label 32410: @2335555
     /* 2335555 */ GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2335609), // Rule ID 58681 //
     /* 2335560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335574 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2335591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335608 */   // GIR_Coverage, 58681,
     /* 2335608 */   GIR_EraseRootFromParent_Done,
     /* 2335609 */ // Label 32411: @2335609
     /* 2335609 */ GIM_Reject,
     /* 2335610 */ // Label 32312: @2335610
     /* 2335610 */ GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2335667), // Rule ID 58488 //
     /* 2335615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2335621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335629 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2335632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2335646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335651 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335666 */   // GIR_Coverage, 58488,
     /* 2335666 */   GIR_EraseRootFromParent_Done,
     /* 2335667 */ // Label 32412: @2335667
     /* 2335667 */ GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2335724), // Rule ID 58489 //
     /* 2335672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2335678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335686 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2335689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2335703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335708 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2335713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335723 */   // GIR_Coverage, 58489,
     /* 2335723 */   GIR_EraseRootFromParent_Done,
     /* 2335724 */ // Label 32413: @2335724
     /* 2335724 */ GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2335778), // Rule ID 58660 //
     /* 2335729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2335735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335743 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2335746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2335760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335765 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335776 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335777 */   // GIR_Coverage, 58660,
     /* 2335777 */   GIR_EraseRootFromParent_Done,
     /* 2335778 */ // Label 32414: @2335778
     /* 2335778 */ GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2335832), // Rule ID 58661 //
     /* 2335783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2335789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335797 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2335800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2335814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335819 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335831 */   // GIR_Coverage, 58661,
     /* 2335831 */   GIR_EraseRootFromParent_Done,
     /* 2335832 */ // Label 32415: @2335832
     /* 2335832 */ GIM_Reject,
     /* 2335833 */ // Label 32313: @2335833
     /* 2335833 */ GIM_Reject,
     /* 2335834 */ // Label 71: @2335834
     /* 2335834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32434*/ GIMT_Encode4(2337804),
     /* 2335845 */ /*GILLT_s16*//*Label 32416*/ GIMT_Encode4(2335965),
     /* 2335849 */ /*GILLT_s32*//*Label 32417*/ GIMT_Encode4(2336029),
     /* 2335853 */ /*GILLT_s64*//*Label 32418*/ GIMT_Encode4(2336093), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335865 */ /*GILLT_nxv1s16*//*Label 32419*/ GIMT_Encode4(2336184),
     /* 2335869 */ /*GILLT_nxv1s32*//*Label 32420*/ GIMT_Encode4(2336292),
     /* 2335873 */ /*GILLT_nxv1s64*//*Label 32421*/ GIMT_Encode4(2336400), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335885 */ /*GILLT_nxv2s16*//*Label 32422*/ GIMT_Encode4(2336508),
     /* 2335889 */ /*GILLT_nxv2s32*//*Label 32423*/ GIMT_Encode4(2336616),
     /* 2335893 */ /*GILLT_nxv2s64*//*Label 32424*/ GIMT_Encode4(2336724), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335905 */ /*GILLT_nxv4s16*//*Label 32425*/ GIMT_Encode4(2336832),
     /* 2335909 */ /*GILLT_nxv4s32*//*Label 32426*/ GIMT_Encode4(2336940),
     /* 2335913 */ /*GILLT_nxv4s64*//*Label 32427*/ GIMT_Encode4(2337048), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335925 */ /*GILLT_nxv8s16*//*Label 32428*/ GIMT_Encode4(2337156),
     /* 2335929 */ /*GILLT_nxv8s32*//*Label 32429*/ GIMT_Encode4(2337264),
     /* 2335933 */ /*GILLT_nxv8s64*//*Label 32430*/ GIMT_Encode4(2337372), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335945 */ /*GILLT_nxv16s16*//*Label 32431*/ GIMT_Encode4(2337480),
     /* 2335949 */ /*GILLT_nxv16s32*//*Label 32432*/ GIMT_Encode4(2337588), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2335961 */ /*GILLT_nxv32s16*//*Label 32433*/ GIMT_Encode4(2337696),
     /* 2335965 */ // Label 32416: @2335965
     /* 2335965 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2336028),
     /* 2335970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2335973 */   GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2336000), // Rule ID 1985 //
     /* 2335978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2335981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2335985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2335989 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2335989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2335992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335999 */     // GIR_Coverage, 1985,
     /* 2335999 */     GIR_EraseRootFromParent_Done,
     /* 2336000 */   // Label 32436: @2336000
     /* 2336000 */   GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2336027), // Rule ID 2018 //
     /* 2336005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2336008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336016 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2336016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2336019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336026 */     // GIR_Coverage, 2018,
     /* 2336026 */     GIR_EraseRootFromParent_Done,
     /* 2336027 */   // Label 32437: @2336027
     /* 2336027 */   GIM_Reject,
     /* 2336028 */ // Label 32435: @2336028
     /* 2336028 */ GIM_Reject,
     /* 2336029 */ // Label 32417: @2336029
     /* 2336029 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2336092),
     /* 2336034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336037 */   GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2336064), // Rule ID 1272 //
     /* 2336042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2336045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336053 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2336053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2336056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336063 */     // GIR_Coverage, 1272,
     /* 2336063 */     GIR_EraseRootFromParent_Done,
     /* 2336064 */   // Label 32439: @2336064
     /* 2336064 */   GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2336091), // Rule ID 1280 //
     /* 2336069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2336072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336080 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2336080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2336083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336090 */     // GIR_Coverage, 1280,
     /* 2336090 */     GIR_EraseRootFromParent_Done,
     /* 2336091 */   // Label 32440: @2336091
     /* 2336091 */   GIM_Reject,
     /* 2336092 */ // Label 32438: @2336092
     /* 2336092 */ GIM_Reject,
     /* 2336093 */ // Label 32418: @2336093
     /* 2336093 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2336183),
     /* 2336098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336101 */   GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2336128), // Rule ID 1615 //
     /* 2336106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2336109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2336113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2336117 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2336117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2336120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336127 */     // GIR_Coverage, 1615,
     /* 2336127 */     GIR_EraseRootFromParent_Done,
     /* 2336128 */   // Label 32442: @2336128
     /* 2336128 */   GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2336155), // Rule ID 1648 //
     /* 2336133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2336136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336144 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2336144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2336147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336154 */     // GIR_Coverage, 1648,
     /* 2336154 */     GIR_EraseRootFromParent_Done,
     /* 2336155 */   // Label 32443: @2336155
     /* 2336155 */   GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2336182), // Rule ID 1670 //
     /* 2336160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2336163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2336167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2336171 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2336171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2336174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336181 */     // GIR_Coverage, 1670,
     /* 2336181 */     GIR_EraseRootFromParent_Done,
     /* 2336182 */   // Label 32444: @2336182
     /* 2336182 */   GIM_Reject,
     /* 2336183 */ // Label 32441: @2336183
     /* 2336183 */ GIM_Reject,
     /* 2336184 */ // Label 32419: @2336184
     /* 2336184 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2336291),
     /* 2336189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2336192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336200 */   GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2336245), // Rule ID 56232 //
     /* 2336205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2336208 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2336211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2336225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336244 */     // GIR_Coverage, 56232,
     /* 2336244 */     GIR_EraseRootFromParent_Done,
     /* 2336245 */   // Label 32446: @2336245
     /* 2336245 */   GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2336290), // Rule ID 56233 //
     /* 2336250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2336253 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2336256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2336270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336289 */     // GIR_Coverage, 56233,
     /* 2336289 */     GIR_EraseRootFromParent_Done,
     /* 2336290 */   // Label 32447: @2336290
     /* 2336290 */   GIM_Reject,
     /* 2336291 */ // Label 32445: @2336291
     /* 2336291 */ GIM_Reject,
     /* 2336292 */ // Label 32420: @2336292
     /* 2336292 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2336399),
     /* 2336297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2336300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336308 */   GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2336353), // Rule ID 56272 //
     /* 2336313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336316 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2336333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336352 */     // GIR_Coverage, 56272,
     /* 2336352 */     GIR_EraseRootFromParent_Done,
     /* 2336353 */   // Label 32449: @2336353
     /* 2336353 */   GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2336398), // Rule ID 56273 //
     /* 2336358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336361 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2336378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336397 */     // GIR_Coverage, 56273,
     /* 2336397 */     GIR_EraseRootFromParent_Done,
     /* 2336398 */   // Label 32450: @2336398
     /* 2336398 */   GIM_Reject,
     /* 2336399 */ // Label 32448: @2336399
     /* 2336399 */ GIM_Reject,
     /* 2336400 */ // Label 32421: @2336400
     /* 2336400 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2336507),
     /* 2336405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2336408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336416 */   GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2336461), // Rule ID 56332 //
     /* 2336421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2336424 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2336441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336460 */     // GIR_Coverage, 56332,
     /* 2336460 */     GIR_EraseRootFromParent_Done,
     /* 2336461 */   // Label 32452: @2336461
     /* 2336461 */   GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2336506), // Rule ID 56333 //
     /* 2336466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2336469 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2336486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336505 */     // GIR_Coverage, 56333,
     /* 2336505 */     GIR_EraseRootFromParent_Done,
     /* 2336506 */   // Label 32453: @2336506
     /* 2336506 */   GIM_Reject,
     /* 2336507 */ // Label 32451: @2336507
     /* 2336507 */ GIM_Reject,
     /* 2336508 */ // Label 32422: @2336508
     /* 2336508 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2336615),
     /* 2336513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2336516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336524 */   GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2336569), // Rule ID 56252 //
     /* 2336529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2336532 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2336549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336568 */     // GIR_Coverage, 56252,
     /* 2336568 */     GIR_EraseRootFromParent_Done,
     /* 2336569 */   // Label 32455: @2336569
     /* 2336569 */   GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2336614), // Rule ID 56253 //
     /* 2336574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2336577 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2336594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336613 */     // GIR_Coverage, 56253,
     /* 2336613 */     GIR_EraseRootFromParent_Done,
     /* 2336614 */   // Label 32456: @2336614
     /* 2336614 */   GIM_Reject,
     /* 2336615 */ // Label 32454: @2336615
     /* 2336615 */ GIM_Reject,
     /* 2336616 */ // Label 32423: @2336616
     /* 2336616 */ GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2336723),
     /* 2336621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336632 */   GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2336677), // Rule ID 56312 //
     /* 2336637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336640 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2336657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336676 */     // GIR_Coverage, 56312,
     /* 2336676 */     GIR_EraseRootFromParent_Done,
     /* 2336677 */   // Label 32458: @2336677
     /* 2336677 */   GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2336722), // Rule ID 56313 //
     /* 2336682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336685 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2336702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336721 */     // GIR_Coverage, 56313,
     /* 2336721 */     GIR_EraseRootFromParent_Done,
     /* 2336722 */   // Label 32459: @2336722
     /* 2336722 */   GIM_Reject,
     /* 2336723 */ // Label 32457: @2336723
     /* 2336723 */ GIM_Reject,
     /* 2336724 */ // Label 32424: @2336724
     /* 2336724 */ GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2336831),
     /* 2336729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2336732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336740 */   GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2336785), // Rule ID 56472 //
     /* 2336745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2336748 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2336765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336784 */     // GIR_Coverage, 56472,
     /* 2336784 */     GIR_EraseRootFromParent_Done,
     /* 2336785 */   // Label 32461: @2336785
     /* 2336785 */   GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2336830), // Rule ID 56473 //
     /* 2336790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2336793 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2336796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2336810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336829 */     // GIR_Coverage, 56473,
     /* 2336829 */     GIR_EraseRootFromParent_Done,
     /* 2336830 */   // Label 32462: @2336830
     /* 2336830 */   GIM_Reject,
     /* 2336831 */ // Label 32460: @2336831
     /* 2336831 */ GIM_Reject,
     /* 2336832 */ // Label 32425: @2336832
     /* 2336832 */ GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2336939),
     /* 2336837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2336840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336848 */   GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2336893), // Rule ID 56292 //
     /* 2336853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2336856 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2336873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336892 */     // GIR_Coverage, 56292,
     /* 2336892 */     GIR_EraseRootFromParent_Done,
     /* 2336893 */   // Label 32464: @2336893
     /* 2336893 */   GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2336938), // Rule ID 56293 //
     /* 2336898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2336901 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2336904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2336918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336937 */     // GIR_Coverage, 56293,
     /* 2336937 */     GIR_EraseRootFromParent_Done,
     /* 2336938 */   // Label 32465: @2336938
     /* 2336938 */   GIM_Reject,
     /* 2336939 */ // Label 32463: @2336939
     /* 2336939 */ GIM_Reject,
     /* 2336940 */ // Label 32426: @2336940
     /* 2336940 */ GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2337047),
     /* 2336945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2336948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2336956 */   GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2337001), // Rule ID 56412 //
     /* 2336961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336964 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2336967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2336981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2336990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337000 */     // GIR_Coverage, 56412,
     /* 2337000 */     GIR_EraseRootFromParent_Done,
     /* 2337001 */   // Label 32467: @2337001
     /* 2337001 */   GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2337046), // Rule ID 56413 //
     /* 2337006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2337009 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2337012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2337026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337045 */     // GIR_Coverage, 56413,
     /* 2337045 */     GIR_EraseRootFromParent_Done,
     /* 2337046 */   // Label 32468: @2337046
     /* 2337046 */   GIM_Reject,
     /* 2337047 */ // Label 32466: @2337047
     /* 2337047 */ GIM_Reject,
     /* 2337048 */ // Label 32427: @2337048
     /* 2337048 */ GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2337155),
     /* 2337053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2337056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337064 */   GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2337109), // Rule ID 56492 //
     /* 2337069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337072 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2337089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337108 */     // GIR_Coverage, 56492,
     /* 2337108 */     GIR_EraseRootFromParent_Done,
     /* 2337109 */   // Label 32470: @2337109
     /* 2337109 */   GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2337154), // Rule ID 56493 //
     /* 2337114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337117 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2337134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337153 */     // GIR_Coverage, 56493,
     /* 2337153 */     GIR_EraseRootFromParent_Done,
     /* 2337154 */   // Label 32471: @2337154
     /* 2337154 */   GIM_Reject,
     /* 2337155 */ // Label 32469: @2337155
     /* 2337155 */ GIM_Reject,
     /* 2337156 */ // Label 32428: @2337156
     /* 2337156 */ GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2337263),
     /* 2337161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2337164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337172 */   GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2337217), // Rule ID 56352 //
     /* 2337177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2337180 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2337197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337216 */     // GIR_Coverage, 56352,
     /* 2337216 */     GIR_EraseRootFromParent_Done,
     /* 2337217 */   // Label 32473: @2337217
     /* 2337217 */   GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2337262), // Rule ID 56353 //
     /* 2337222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2337225 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2337228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2337242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337261 */     // GIR_Coverage, 56353,
     /* 2337261 */     GIR_EraseRootFromParent_Done,
     /* 2337262 */   // Label 32474: @2337262
     /* 2337262 */   GIM_Reject,
     /* 2337263 */ // Label 32472: @2337263
     /* 2337263 */ GIM_Reject,
     /* 2337264 */ // Label 32429: @2337264
     /* 2337264 */ GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2337371),
     /* 2337269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2337272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337280 */   GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2337325), // Rule ID 56432 //
     /* 2337285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2337288 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2337305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337324 */     // GIR_Coverage, 56432,
     /* 2337324 */     GIR_EraseRootFromParent_Done,
     /* 2337325 */   // Label 32476: @2337325
     /* 2337325 */   GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2337370), // Rule ID 56433 //
     /* 2337330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2337333 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2337336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2337350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337369 */     // GIR_Coverage, 56433,
     /* 2337369 */     GIR_EraseRootFromParent_Done,
     /* 2337370 */   // Label 32477: @2337370
     /* 2337370 */   GIM_Reject,
     /* 2337371 */ // Label 32475: @2337371
     /* 2337371 */ GIM_Reject,
     /* 2337372 */ // Label 32430: @2337372
     /* 2337372 */ GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2337479),
     /* 2337377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2337380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337388 */   GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2337433), // Rule ID 56512 //
     /* 2337393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337396 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2337413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337432 */     // GIR_Coverage, 56512,
     /* 2337432 */     GIR_EraseRootFromParent_Done,
     /* 2337433 */   // Label 32479: @2337433
     /* 2337433 */   GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2337478), // Rule ID 56513 //
     /* 2337438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337441 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2337444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2337458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337477 */     // GIR_Coverage, 56513,
     /* 2337477 */     GIR_EraseRootFromParent_Done,
     /* 2337478 */   // Label 32480: @2337478
     /* 2337478 */   GIM_Reject,
     /* 2337479 */ // Label 32478: @2337479
     /* 2337479 */ GIM_Reject,
     /* 2337480 */ // Label 32431: @2337480
     /* 2337480 */ GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2337587),
     /* 2337485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2337488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337496 */   GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2337541), // Rule ID 56372 //
     /* 2337501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2337504 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2337507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2337521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337540 */     // GIR_Coverage, 56372,
     /* 2337540 */     GIR_EraseRootFromParent_Done,
     /* 2337541 */   // Label 32482: @2337541
     /* 2337541 */   GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2337586), // Rule ID 56373 //
     /* 2337546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2337549 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2337552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2337566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337585 */     // GIR_Coverage, 56373,
     /* 2337585 */     GIR_EraseRootFromParent_Done,
     /* 2337586 */   // Label 32483: @2337586
     /* 2337586 */   GIM_Reject,
     /* 2337587 */ // Label 32481: @2337587
     /* 2337587 */ GIM_Reject,
     /* 2337588 */ // Label 32432: @2337588
     /* 2337588 */ GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2337695),
     /* 2337593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2337596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337604 */   GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2337649), // Rule ID 56452 //
     /* 2337609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2337612 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2337629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337648 */     // GIR_Coverage, 56452,
     /* 2337648 */     GIR_EraseRootFromParent_Done,
     /* 2337649 */   // Label 32485: @2337649
     /* 2337649 */   GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2337694), // Rule ID 56453 //
     /* 2337654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2337657 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2337660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2337674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337693 */     // GIR_Coverage, 56453,
     /* 2337693 */     GIR_EraseRootFromParent_Done,
     /* 2337694 */   // Label 32486: @2337694
     /* 2337694 */   GIM_Reject,
     /* 2337695 */ // Label 32484: @2337695
     /* 2337695 */ GIM_Reject,
     /* 2337696 */ // Label 32433: @2337696
     /* 2337696 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2337803),
     /* 2337701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2337704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2337712 */   GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2337757), // Rule ID 56392 //
     /* 2337717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2337720 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2337737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337756 */     // GIR_Coverage, 56392,
     /* 2337756 */     GIR_EraseRootFromParent_Done,
     /* 2337757 */   // Label 32488: @2337757
     /* 2337757 */   GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2337802), // Rule ID 56393 //
     /* 2337762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2337765 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2337768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2337782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2337791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337801 */     // GIR_Coverage, 56393,
     /* 2337801 */     GIR_EraseRootFromParent_Done,
     /* 2337802 */   // Label 32489: @2337802
     /* 2337802 */   GIM_Reject,
     /* 2337803 */ // Label 32487: @2337803
     /* 2337803 */ GIM_Reject,
     /* 2337804 */ // Label 32434: @2337804
     /* 2337804 */ GIM_Reject,
     /* 2337805 */ // Label 72: @2337805
     /* 2337805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32508*/ GIMT_Encode4(2343866),
     /* 2337816 */ /*GILLT_s16*//*Label 32490*/ GIMT_Encode4(2337936),
     /* 2337820 */ /*GILLT_s32*//*Label 32491*/ GIMT_Encode4(2338612),
     /* 2337824 */ /*GILLT_s64*//*Label 32492*/ GIMT_Encode4(2339288), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337836 */ /*GILLT_nxv1s16*//*Label 32493*/ GIMT_Encode4(2340101),
     /* 2337840 */ /*GILLT_nxv1s32*//*Label 32494*/ GIMT_Encode4(2340352),
     /* 2337844 */ /*GILLT_nxv1s64*//*Label 32495*/ GIMT_Encode4(2340603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337856 */ /*GILLT_nxv2s16*//*Label 32496*/ GIMT_Encode4(2340854),
     /* 2337860 */ /*GILLT_nxv2s32*//*Label 32497*/ GIMT_Encode4(2341105),
     /* 2337864 */ /*GILLT_nxv2s64*//*Label 32498*/ GIMT_Encode4(2341356), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337876 */ /*GILLT_nxv4s16*//*Label 32499*/ GIMT_Encode4(2341607),
     /* 2337880 */ /*GILLT_nxv4s32*//*Label 32500*/ GIMT_Encode4(2341858),
     /* 2337884 */ /*GILLT_nxv4s64*//*Label 32501*/ GIMT_Encode4(2342109), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337896 */ /*GILLT_nxv8s16*//*Label 32502*/ GIMT_Encode4(2342360),
     /* 2337900 */ /*GILLT_nxv8s32*//*Label 32503*/ GIMT_Encode4(2342611),
     /* 2337904 */ /*GILLT_nxv8s64*//*Label 32504*/ GIMT_Encode4(2342862), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337916 */ /*GILLT_nxv16s16*//*Label 32505*/ GIMT_Encode4(2343113),
     /* 2337920 */ /*GILLT_nxv16s32*//*Label 32506*/ GIMT_Encode4(2343364), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2337932 */ /*GILLT_nxv32s16*//*Label 32507*/ GIMT_Encode4(2343615),
     /* 2337936 */ // Label 32490: @2337936
     /* 2337936 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2338611),
     /* 2337941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337944 */   GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2337995), // Rule ID 1990 //
     /* 2337949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2337952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2337955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2337975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2337980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337982 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2337982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2337985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337994 */     // GIR_Coverage, 1990,
     /* 2337994 */     GIR_EraseRootFromParent_Done,
     /* 2337995 */   // Label 32510: @2337995
     /* 2337995 */   GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2338046), // Rule ID 2023 //
     /* 2338000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2338003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2338006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2338026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338033 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2338033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2338036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338045 */     // GIR_Coverage, 2023,
     /* 2338045 */     GIR_EraseRootFromParent_Done,
     /* 2338046 */   // Label 32511: @2338046
     /* 2338046 */   GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2338076), // Rule ID 1988 //
     /* 2338051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2338054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2338057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338069 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2338069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2338074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338075 */     // GIR_Coverage, 1988,
     /* 2338075 */     GIR_Done,
     /* 2338076 */   // Label 32512: @2338076
     /* 2338076 */   GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2338132), // Rule ID 1991 //
     /* 2338081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2338084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338099 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2338099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2338106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2338123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338131 */     // GIR_Coverage, 1991,
     /* 2338131 */     GIR_EraseRootFromParent_Done,
     /* 2338132 */   // Label 32513: @2338132
     /* 2338132 */   GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2338188), // Rule ID 1992 //
     /* 2338137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2338140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338155 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2338155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2338162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2338179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338187 */     // GIR_Coverage, 1992,
     /* 2338187 */     GIR_EraseRootFromParent_Done,
     /* 2338188 */   // Label 32514: @2338188
     /* 2338188 */   GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2338218), // Rule ID 2021 //
     /* 2338193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2338196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2338199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338211 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2338211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338217 */     // GIR_Coverage, 2021,
     /* 2338217 */     GIR_Done,
     /* 2338218 */   // Label 32515: @2338218
     /* 2338218 */   GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2338274), // Rule ID 2024 //
     /* 2338223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2338226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338241 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2338241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2338248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338273 */     // GIR_Coverage, 2024,
     /* 2338273 */     GIR_EraseRootFromParent_Done,
     /* 2338274 */   // Label 32516: @2338274
     /* 2338274 */   GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2338330), // Rule ID 2025 //
     /* 2338279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2338282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338297 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2338297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2338304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338313 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338329 */     // GIR_Coverage, 2025,
     /* 2338329 */     GIR_EraseRootFromParent_Done,
     /* 2338330 */   // Label 32517: @2338330
     /* 2338330 */   GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2338386), // Rule ID 2294 //
     /* 2338335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2338338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338353 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2338360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2338377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338385 */     // GIR_Coverage, 2294,
     /* 2338385 */     GIR_EraseRootFromParent_Done,
     /* 2338386 */   // Label 32518: @2338386
     /* 2338386 */   GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2338442), // Rule ID 2295 //
     /* 2338391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2338394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2338405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338409 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2338409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2338416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2338433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338441 */     // GIR_Coverage, 2295,
     /* 2338441 */     GIR_EraseRootFromParent_Done,
     /* 2338442 */   // Label 32519: @2338442
     /* 2338442 */   GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2338498), // Rule ID 2306 //
     /* 2338447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2338450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2338465 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2338472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338497 */     // GIR_Coverage, 2306,
     /* 2338497 */     GIR_EraseRootFromParent_Done,
     /* 2338498 */   // Label 32520: @2338498
     /* 2338498 */   GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2338554), // Rule ID 2307 //
     /* 2338503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2338506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2338521 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2338521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2338528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338537 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338553 */     // GIR_Coverage, 2307,
     /* 2338553 */     GIR_EraseRootFromParent_Done,
     /* 2338554 */   // Label 32521: @2338554
     /* 2338554 */   GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2338610), // Rule ID 2314 //
     /* 2338559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2338562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2338573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338577 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2338580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2338584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338593 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2338601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338609 */     // GIR_Coverage, 2314,
     /* 2338609 */     GIR_EraseRootFromParent_Done,
     /* 2338610 */   // Label 32522: @2338610
     /* 2338610 */   GIM_Reject,
     /* 2338611 */ // Label 32509: @2338611
     /* 2338611 */ GIM_Reject,
     /* 2338612 */ // Label 32491: @2338612
     /* 2338612 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2339287),
     /* 2338617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338620 */   GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2338671), // Rule ID 1287 //
     /* 2338625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2338628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338658 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2338658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2338661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338670 */     // GIR_Coverage, 1287,
     /* 2338670 */     GIR_EraseRootFromParent_Done,
     /* 2338671 */   // Label 32524: @2338671
     /* 2338671 */   GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2338722), // Rule ID 1308 //
     /* 2338676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2338679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2338702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338709 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2338709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2338712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338721 */     // GIR_Coverage, 1308,
     /* 2338721 */     GIR_EraseRootFromParent_Done,
     /* 2338722 */   // Label 32525: @2338722
     /* 2338722 */   GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2338752), // Rule ID 1283 //
     /* 2338727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2338730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338745 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2338745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2338750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338751 */     // GIR_Coverage, 1283,
     /* 2338751 */     GIR_Done,
     /* 2338752 */   // Label 32526: @2338752
     /* 2338752 */   GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2338782), // Rule ID 1284 //
     /* 2338757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2338760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2338763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338775 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2338775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2338780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338781 */     // GIR_Coverage, 1284,
     /* 2338781 */     GIR_Done,
     /* 2338782 */   // Label 32527: @2338782
     /* 2338782 */   GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2338838), // Rule ID 1623 //
     /* 2338787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2338790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338805 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2338808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2338812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2338829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338837 */     // GIR_Coverage, 1623,
     /* 2338837 */     GIR_EraseRootFromParent_Done,
     /* 2338838 */   // Label 32528: @2338838
     /* 2338838 */   GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2338894), // Rule ID 1624 //
     /* 2338843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2338846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2338857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2338861 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2338861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2338864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2338868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2338885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338893 */     // GIR_Coverage, 1624,
     /* 2338893 */     GIR_EraseRootFromParent_Done,
     /* 2338894 */   // Label 32529: @2338894
     /* 2338894 */   GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2338950), // Rule ID 1654 //
     /* 2338899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2338902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2338917 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2338920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2338924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2338941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338949 */     // GIR_Coverage, 1654,
     /* 2338949 */     GIR_EraseRootFromParent_Done,
     /* 2338950 */   // Label 32530: @2338950
     /* 2338950 */   GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2339006), // Rule ID 1678 //
     /* 2338955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2338958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2338961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2338969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2338973 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2338973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2338976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2338980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2338989 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2338992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2338997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339005 */     // GIR_Coverage, 1678,
     /* 2339005 */     GIR_EraseRootFromParent_Done,
     /* 2339006 */   // Label 32531: @2339006
     /* 2339006 */   GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2339062), // Rule ID 1679 //
     /* 2339011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2339014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339029 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2339029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2339032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2339036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2339048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2339053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339061 */     // GIR_Coverage, 1679,
     /* 2339061 */     GIR_EraseRootFromParent_Done,
     /* 2339062 */   // Label 32532: @2339062
     /* 2339062 */   GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2339118), // Rule ID 2166 //
     /* 2339067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2339070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339085 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2339085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2339088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2339092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339101 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2339109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339117 */     // GIR_Coverage, 2166,
     /* 2339117 */     GIR_EraseRootFromParent_Done,
     /* 2339118 */   // Label 32533: @2339118
     /* 2339118 */   GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2339174), // Rule ID 2167 //
     /* 2339123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2339126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339141 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2339141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2339144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2339148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339157 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2339165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339173 */     // GIR_Coverage, 2167,
     /* 2339173 */     GIR_EraseRootFromParent_Done,
     /* 2339174 */   // Label 32534: @2339174
     /* 2339174 */   GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2339230), // Rule ID 2180 //
     /* 2339179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2339182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339197 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2339197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2339200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2339204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339213 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2339221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339229 */     // GIR_Coverage, 2180,
     /* 2339229 */     GIR_EraseRootFromParent_Done,
     /* 2339230 */   // Label 32535: @2339230
     /* 2339230 */   GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2339286), // Rule ID 2181 //
     /* 2339235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2339238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339253 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2339253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2339256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2339260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339269 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2339277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339285 */     // GIR_Coverage, 2181,
     /* 2339285 */     GIR_EraseRootFromParent_Done,
     /* 2339286 */   // Label 32536: @2339286
     /* 2339286 */   GIM_Reject,
     /* 2339287 */ // Label 32523: @2339287
     /* 2339287 */ GIM_Reject,
     /* 2339288 */ // Label 32492: @2339288
     /* 2339288 */ GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2340100),
     /* 2339293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339296 */   GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2339347), // Rule ID 1620 //
     /* 2339301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2339304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339334 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2339334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2339337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339346 */     // GIR_Coverage, 1620,
     /* 2339346 */     GIR_EraseRootFromParent_Done,
     /* 2339347 */   // Label 32538: @2339347
     /* 2339347 */   GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2339398), // Rule ID 1652 //
     /* 2339352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2339355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339385 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2339385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2339388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339397 */     // GIR_Coverage, 1652,
     /* 2339397 */     GIR_EraseRootFromParent_Done,
     /* 2339398 */   // Label 32539: @2339398
     /* 2339398 */   GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2339449), // Rule ID 1675 //
     /* 2339403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2339406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339436 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2339436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2339439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339448 */     // GIR_Coverage, 1675,
     /* 2339448 */     GIR_EraseRootFromParent_Done,
     /* 2339449 */   // Label 32540: @2339449
     /* 2339449 */   GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2339479), // Rule ID 1618 //
     /* 2339454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2339457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339472 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2339472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2339477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339478 */     // GIR_Coverage, 1618,
     /* 2339478 */     GIR_Done,
     /* 2339479 */   // Label 32541: @2339479
     /* 2339479 */   GIM_Try, /*On fail goto*//*Label 32542*/ GIMT_Encode4(2339535), // Rule ID 1621 //
     /* 2339484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2339487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339502 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2339502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2339509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2339526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339534 */     // GIR_Coverage, 1621,
     /* 2339534 */     GIR_EraseRootFromParent_Done,
     /* 2339535 */   // Label 32542: @2339535
     /* 2339535 */   GIM_Try, /*On fail goto*//*Label 32543*/ GIMT_Encode4(2339591), // Rule ID 1622 //
     /* 2339540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2339543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339558 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2339558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2339565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2339582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339590 */     // GIR_Coverage, 1622,
     /* 2339590 */     GIR_EraseRootFromParent_Done,
     /* 2339591 */   // Label 32543: @2339591
     /* 2339591 */   GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2339621), // Rule ID 1650 //
     /* 2339596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2339599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339614 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2339614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2339619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339620 */     // GIR_Coverage, 1650,
     /* 2339620 */     GIR_Done,
     /* 2339621 */   // Label 32544: @2339621
     /* 2339621 */   GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2339677), // Rule ID 1653 //
     /* 2339626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2339629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2339640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339644 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2339644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2339651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2339668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339676 */     // GIR_Coverage, 1653,
     /* 2339676 */     GIR_EraseRootFromParent_Done,
     /* 2339677 */   // Label 32545: @2339677
     /* 2339677 */   GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2339707), // Rule ID 1673 //
     /* 2339682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2339685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2339688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339700 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2339700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2339705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339706 */     // GIR_Coverage, 1673,
     /* 2339706 */     GIR_Done,
     /* 2339707 */   // Label 32546: @2339707
     /* 2339707 */   GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2339763), // Rule ID 1676 //
     /* 2339712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2339715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339730 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2339730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2339737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2339754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339762 */     // GIR_Coverage, 1676,
     /* 2339762 */     GIR_EraseRootFromParent_Done,
     /* 2339763 */   // Label 32547: @2339763
     /* 2339763 */   GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2339819), // Rule ID 1677 //
     /* 2339768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2339771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339786 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2339786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2339793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2339810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339818 */     // GIR_Coverage, 1677,
     /* 2339818 */     GIR_EraseRootFromParent_Done,
     /* 2339819 */   // Label 32548: @2339819
     /* 2339819 */   GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2339875), // Rule ID 2296 //
     /* 2339824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2339827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339842 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2339842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2339849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2339866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339874 */     // GIR_Coverage, 2296,
     /* 2339874 */     GIR_EraseRootFromParent_Done,
     /* 2339875 */   // Label 32549: @2339875
     /* 2339875 */   GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2339931), // Rule ID 2297 //
     /* 2339880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2339883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339898 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2339898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2339905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2339922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339930 */     // GIR_Coverage, 2297,
     /* 2339930 */     GIR_EraseRootFromParent_Done,
     /* 2339931 */   // Label 32550: @2339931
     /* 2339931 */   GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2339987), // Rule ID 2308 //
     /* 2339936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2339939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2339950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339954 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2339954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2339957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2339961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2339970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2339973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2339978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339986 */     // GIR_Coverage, 2308,
     /* 2339986 */     GIR_EraseRootFromParent_Done,
     /* 2339987 */   // Label 32551: @2339987
     /* 2339987 */   GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2340043), // Rule ID 2309 //
     /* 2339992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2339995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2340002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2340006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2340010 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2340010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2340013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2340017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2340026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2340029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2340034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340042 */     // GIR_Coverage, 2309,
     /* 2340042 */     GIR_EraseRootFromParent_Done,
     /* 2340043 */   // Label 32552: @2340043
     /* 2340043 */   GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2340099), // Rule ID 2315 //
     /* 2340048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2340051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2340054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2340058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2340062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2340066 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2340066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2340069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2340073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2340082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2340085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2340090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340098 */     // GIR_Coverage, 2315,
     /* 2340098 */     GIR_EraseRootFromParent_Done,
     /* 2340099 */   // Label 32553: @2340099
     /* 2340099 */   GIM_Reject,
     /* 2340100 */ // Label 32537: @2340100
     /* 2340100 */ GIM_Reject,
     /* 2340101 */ // Label 32493: @2340101
     /* 2340101 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2340351),
     /* 2340106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2340112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340120 */   GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2340186), // Rule ID 56242 //
     /* 2340125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340147 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2340164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340185 */     // GIR_Coverage, 56242,
     /* 2340185 */     GIR_EraseRootFromParent_Done,
     /* 2340186 */   // Label 32555: @2340186
     /* 2340186 */   GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2340252), // Rule ID 56243 //
     /* 2340191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340213 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2340230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340251 */     // GIR_Coverage, 56243,
     /* 2340251 */     GIR_EraseRootFromParent_Done,
     /* 2340252 */   // Label 32556: @2340252
     /* 2340252 */   GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2340301), // Rule ID 56236 //
     /* 2340257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340264 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2340281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340300 */     // GIR_Coverage, 56236,
     /* 2340300 */     GIR_EraseRootFromParent_Done,
     /* 2340301 */   // Label 32557: @2340301
     /* 2340301 */   GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2340350), // Rule ID 56237 //
     /* 2340306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340313 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2340330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340349 */     // GIR_Coverage, 56237,
     /* 2340349 */     GIR_EraseRootFromParent_Done,
     /* 2340350 */   // Label 32558: @2340350
     /* 2340350 */   GIM_Reject,
     /* 2340351 */ // Label 32554: @2340351
     /* 2340351 */ GIM_Reject,
     /* 2340352 */ // Label 32494: @2340352
     /* 2340352 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2340602),
     /* 2340357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2340363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340371 */   GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2340437), // Rule ID 56282 //
     /* 2340376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2340379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340398 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2340415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340436 */     // GIR_Coverage, 56282,
     /* 2340436 */     GIR_EraseRootFromParent_Done,
     /* 2340437 */   // Label 32560: @2340437
     /* 2340437 */   GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2340503), // Rule ID 56283 //
     /* 2340442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2340445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340464 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2340481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340502 */     // GIR_Coverage, 56283,
     /* 2340502 */     GIR_EraseRootFromParent_Done,
     /* 2340503 */   // Label 32561: @2340503
     /* 2340503 */   GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2340552), // Rule ID 56276 //
     /* 2340508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2340511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340515 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2340532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340551 */     // GIR_Coverage, 56276,
     /* 2340551 */     GIR_EraseRootFromParent_Done,
     /* 2340552 */   // Label 32562: @2340552
     /* 2340552 */   GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2340601), // Rule ID 56277 //
     /* 2340557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2340560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340564 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2340581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340600 */     // GIR_Coverage, 56277,
     /* 2340600 */     GIR_EraseRootFromParent_Done,
     /* 2340601 */   // Label 32563: @2340601
     /* 2340601 */   GIM_Reject,
     /* 2340602 */ // Label 32559: @2340602
     /* 2340602 */ GIM_Reject,
     /* 2340603 */ // Label 32495: @2340603
     /* 2340603 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2340853),
     /* 2340608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2340614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340622 */   GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2340688), // Rule ID 56342 //
     /* 2340627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2340630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340649 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2340666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340687 */     // GIR_Coverage, 56342,
     /* 2340687 */     GIR_EraseRootFromParent_Done,
     /* 2340688 */   // Label 32565: @2340688
     /* 2340688 */   GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2340754), // Rule ID 56343 //
     /* 2340693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2340696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340715 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2340732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340753 */     // GIR_Coverage, 56343,
     /* 2340753 */     GIR_EraseRootFromParent_Done,
     /* 2340754 */   // Label 32566: @2340754
     /* 2340754 */   GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2340803), // Rule ID 56336 //
     /* 2340759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2340762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340766 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2340783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340802 */     // GIR_Coverage, 56336,
     /* 2340802 */     GIR_EraseRootFromParent_Done,
     /* 2340803 */   // Label 32567: @2340803
     /* 2340803 */   GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2340852), // Rule ID 56337 //
     /* 2340808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2340811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340815 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2340832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340851 */     // GIR_Coverage, 56337,
     /* 2340851 */     GIR_EraseRootFromParent_Done,
     /* 2340852 */   // Label 32568: @2340852
     /* 2340852 */   GIM_Reject,
     /* 2340853 */ // Label 32564: @2340853
     /* 2340853 */ GIM_Reject,
     /* 2340854 */ // Label 32496: @2340854
     /* 2340854 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2341104),
     /* 2340859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2340865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340873 */   GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2340939), // Rule ID 56262 //
     /* 2340878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340900 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2340917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340938 */     // GIR_Coverage, 56262,
     /* 2340938 */     GIR_EraseRootFromParent_Done,
     /* 2340939 */   // Label 32570: @2340939
     /* 2340939 */   GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2341005), // Rule ID 56263 //
     /* 2340944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2340951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2340955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2340966 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2340983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2340994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341004 */     // GIR_Coverage, 56263,
     /* 2341004 */     GIR_EraseRootFromParent_Done,
     /* 2341005 */   // Label 32571: @2341005
     /* 2341005 */   GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2341054), // Rule ID 56256 //
     /* 2341010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341017 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2341020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2341034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341053 */     // GIR_Coverage, 56256,
     /* 2341053 */     GIR_EraseRootFromParent_Done,
     /* 2341054 */   // Label 32572: @2341054
     /* 2341054 */   GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2341103), // Rule ID 56257 //
     /* 2341059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341066 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2341069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2341083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341102 */     // GIR_Coverage, 56257,
     /* 2341102 */     GIR_EraseRootFromParent_Done,
     /* 2341103 */   // Label 32573: @2341103
     /* 2341103 */   GIM_Reject,
     /* 2341104 */ // Label 32569: @2341104
     /* 2341104 */ GIM_Reject,
     /* 2341105 */ // Label 32497: @2341105
     /* 2341105 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2341355),
     /* 2341110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2341113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2341116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341124 */   GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2341190), // Rule ID 56322 //
     /* 2341129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2341132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2341144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341151 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2341168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341189 */     // GIR_Coverage, 56322,
     /* 2341189 */     GIR_EraseRootFromParent_Done,
     /* 2341190 */   // Label 32575: @2341190
     /* 2341190 */   GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2341256), // Rule ID 56323 //
     /* 2341195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2341198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2341210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341217 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2341234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341255 */     // GIR_Coverage, 56323,
     /* 2341255 */     GIR_EraseRootFromParent_Done,
     /* 2341256 */   // Label 32576: @2341256
     /* 2341256 */   GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2341305), // Rule ID 56316 //
     /* 2341261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2341264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341268 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2341285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341304 */     // GIR_Coverage, 56316,
     /* 2341304 */     GIR_EraseRootFromParent_Done,
     /* 2341305 */   // Label 32577: @2341305
     /* 2341305 */   GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2341354), // Rule ID 56317 //
     /* 2341310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2341313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341317 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2341320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2341334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341353 */     // GIR_Coverage, 56317,
     /* 2341353 */     GIR_EraseRootFromParent_Done,
     /* 2341354 */   // Label 32578: @2341354
     /* 2341354 */   GIM_Reject,
     /* 2341355 */ // Label 32574: @2341355
     /* 2341355 */ GIM_Reject,
     /* 2341356 */ // Label 32498: @2341356
     /* 2341356 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2341606),
     /* 2341361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2341367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341375 */   GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2341441), // Rule ID 56482 //
     /* 2341380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2341383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341402 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2341419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341440 */     // GIR_Coverage, 56482,
     /* 2341440 */     GIR_EraseRootFromParent_Done,
     /* 2341441 */   // Label 32580: @2341441
     /* 2341441 */   GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2341507), // Rule ID 56483 //
     /* 2341446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2341449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2341461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341468 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2341485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341506 */     // GIR_Coverage, 56483,
     /* 2341506 */     GIR_EraseRootFromParent_Done,
     /* 2341507 */   // Label 32581: @2341507
     /* 2341507 */   GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2341556), // Rule ID 56476 //
     /* 2341512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2341515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341519 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2341536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341555 */     // GIR_Coverage, 56476,
     /* 2341555 */     GIR_EraseRootFromParent_Done,
     /* 2341556 */   // Label 32582: @2341556
     /* 2341556 */   GIM_Try, /*On fail goto*//*Label 32583*/ GIMT_Encode4(2341605), // Rule ID 56477 //
     /* 2341561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2341564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341568 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2341571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2341585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341604 */     // GIR_Coverage, 56477,
     /* 2341604 */     GIR_EraseRootFromParent_Done,
     /* 2341605 */   // Label 32583: @2341605
     /* 2341605 */   GIM_Reject,
     /* 2341606 */ // Label 32579: @2341606
     /* 2341606 */ GIM_Reject,
     /* 2341607 */ // Label 32499: @2341607
     /* 2341607 */ GIM_Try, /*On fail goto*//*Label 32584*/ GIMT_Encode4(2341857),
     /* 2341612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2341618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341626 */   GIM_Try, /*On fail goto*//*Label 32585*/ GIMT_Encode4(2341692), // Rule ID 56302 //
     /* 2341631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341653 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2341670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341691 */     // GIR_Coverage, 56302,
     /* 2341691 */     GIR_EraseRootFromParent_Done,
     /* 2341692 */   // Label 32585: @2341692
     /* 2341692 */   GIM_Try, /*On fail goto*//*Label 32586*/ GIMT_Encode4(2341758), // Rule ID 56303 //
     /* 2341697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2341712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341719 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2341736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341757 */     // GIR_Coverage, 56303,
     /* 2341757 */     GIR_EraseRootFromParent_Done,
     /* 2341758 */   // Label 32586: @2341758
     /* 2341758 */   GIM_Try, /*On fail goto*//*Label 32587*/ GIMT_Encode4(2341807), // Rule ID 56296 //
     /* 2341763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341770 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2341787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341806 */     // GIR_Coverage, 56296,
     /* 2341806 */     GIR_EraseRootFromParent_Done,
     /* 2341807 */   // Label 32587: @2341807
     /* 2341807 */   GIM_Try, /*On fail goto*//*Label 32588*/ GIMT_Encode4(2341856), // Rule ID 56297 //
     /* 2341812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2341819 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2341822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2341836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341855 */     // GIR_Coverage, 56297,
     /* 2341855 */     GIR_EraseRootFromParent_Done,
     /* 2341856 */   // Label 32588: @2341856
     /* 2341856 */   GIM_Reject,
     /* 2341857 */ // Label 32584: @2341857
     /* 2341857 */ GIM_Reject,
     /* 2341858 */ // Label 32500: @2341858
     /* 2341858 */ GIM_Try, /*On fail goto*//*Label 32589*/ GIMT_Encode4(2342108),
     /* 2341863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2341869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341877 */   GIM_Try, /*On fail goto*//*Label 32590*/ GIMT_Encode4(2341943), // Rule ID 56422 //
     /* 2341882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2341885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341904 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2341921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341942 */     // GIR_Coverage, 56422,
     /* 2341942 */     GIR_EraseRootFromParent_Done,
     /* 2341943 */   // Label 32590: @2341943
     /* 2341943 */   GIM_Try, /*On fail goto*//*Label 32591*/ GIMT_Encode4(2342009), // Rule ID 56423 //
     /* 2341948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2341951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2341955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2341959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2341963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2341970 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2341973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2341987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2341998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342008 */     // GIR_Coverage, 56423,
     /* 2342008 */     GIR_EraseRootFromParent_Done,
     /* 2342009 */   // Label 32591: @2342009
     /* 2342009 */   GIM_Try, /*On fail goto*//*Label 32592*/ GIMT_Encode4(2342058), // Rule ID 56416 //
     /* 2342014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2342017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342021 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2342024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2342038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342057 */     // GIR_Coverage, 56416,
     /* 2342057 */     GIR_EraseRootFromParent_Done,
     /* 2342058 */   // Label 32592: @2342058
     /* 2342058 */   GIM_Try, /*On fail goto*//*Label 32593*/ GIMT_Encode4(2342107), // Rule ID 56417 //
     /* 2342063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2342066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342070 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2342073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2342087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342106 */     // GIR_Coverage, 56417,
     /* 2342106 */     GIR_EraseRootFromParent_Done,
     /* 2342107 */   // Label 32593: @2342107
     /* 2342107 */   GIM_Reject,
     /* 2342108 */ // Label 32589: @2342108
     /* 2342108 */ GIM_Reject,
     /* 2342109 */ // Label 32501: @2342109
     /* 2342109 */ GIM_Try, /*On fail goto*//*Label 32594*/ GIMT_Encode4(2342359),
     /* 2342114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2342120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342128 */   GIM_Try, /*On fail goto*//*Label 32595*/ GIMT_Encode4(2342194), // Rule ID 56502 //
     /* 2342133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2342136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342155 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2342172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342193 */     // GIR_Coverage, 56502,
     /* 2342193 */     GIR_EraseRootFromParent_Done,
     /* 2342194 */   // Label 32595: @2342194
     /* 2342194 */   GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2342260), // Rule ID 56503 //
     /* 2342199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2342202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2342214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342221 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2342238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342259 */     // GIR_Coverage, 56503,
     /* 2342259 */     GIR_EraseRootFromParent_Done,
     /* 2342260 */   // Label 32596: @2342260
     /* 2342260 */   GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2342309), // Rule ID 56496 //
     /* 2342265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2342268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342272 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2342289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342308 */     // GIR_Coverage, 56496,
     /* 2342308 */     GIR_EraseRootFromParent_Done,
     /* 2342309 */   // Label 32597: @2342309
     /* 2342309 */   GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2342358), // Rule ID 56497 //
     /* 2342314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2342317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342321 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2342324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2342338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342357 */     // GIR_Coverage, 56497,
     /* 2342357 */     GIR_EraseRootFromParent_Done,
     /* 2342358 */   // Label 32598: @2342358
     /* 2342358 */   GIM_Reject,
     /* 2342359 */ // Label 32594: @2342359
     /* 2342359 */ GIM_Reject,
     /* 2342360 */ // Label 32502: @2342360
     /* 2342360 */ GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2342610),
     /* 2342365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2342371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342379 */   GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2342445), // Rule ID 56362 //
     /* 2342384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2342387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342406 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2342423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342444 */     // GIR_Coverage, 56362,
     /* 2342444 */     GIR_EraseRootFromParent_Done,
     /* 2342445 */   // Label 32600: @2342445
     /* 2342445 */   GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2342511), // Rule ID 56363 //
     /* 2342450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2342453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2342465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342472 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2342489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342510 */     // GIR_Coverage, 56363,
     /* 2342510 */     GIR_EraseRootFromParent_Done,
     /* 2342511 */   // Label 32601: @2342511
     /* 2342511 */   GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2342560), // Rule ID 56356 //
     /* 2342516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2342519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342523 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2342540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342559 */     // GIR_Coverage, 56356,
     /* 2342559 */     GIR_EraseRootFromParent_Done,
     /* 2342560 */   // Label 32602: @2342560
     /* 2342560 */   GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2342609), // Rule ID 56357 //
     /* 2342565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2342568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342572 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2342575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2342589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342608 */     // GIR_Coverage, 56357,
     /* 2342608 */     GIR_EraseRootFromParent_Done,
     /* 2342609 */   // Label 32603: @2342609
     /* 2342609 */   GIM_Reject,
     /* 2342610 */ // Label 32599: @2342610
     /* 2342610 */ GIM_Reject,
     /* 2342611 */ // Label 32503: @2342611
     /* 2342611 */ GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2342861),
     /* 2342616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2342622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342630 */   GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2342696), // Rule ID 56442 //
     /* 2342635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2342638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342657 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2342674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342695 */     // GIR_Coverage, 56442,
     /* 2342695 */     GIR_EraseRootFromParent_Done,
     /* 2342696 */   // Label 32605: @2342696
     /* 2342696 */   GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2342762), // Rule ID 56443 //
     /* 2342701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2342704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2342716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342723 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2342740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342761 */     // GIR_Coverage, 56443,
     /* 2342761 */     GIR_EraseRootFromParent_Done,
     /* 2342762 */   // Label 32606: @2342762
     /* 2342762 */   GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2342811), // Rule ID 56436 //
     /* 2342767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2342770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342774 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2342791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342810 */     // GIR_Coverage, 56436,
     /* 2342810 */     GIR_EraseRootFromParent_Done,
     /* 2342811 */   // Label 32607: @2342811
     /* 2342811 */   GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2342860), // Rule ID 56437 //
     /* 2342816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2342819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2342823 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2342826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2342840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342859 */     // GIR_Coverage, 56437,
     /* 2342859 */     GIR_EraseRootFromParent_Done,
     /* 2342860 */   // Label 32608: @2342860
     /* 2342860 */   GIM_Reject,
     /* 2342861 */ // Label 32604: @2342861
     /* 2342861 */ GIM_Reject,
     /* 2342862 */ // Label 32504: @2342862
     /* 2342862 */ GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2343112),
     /* 2342867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2342870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2342873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342881 */   GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2342947), // Rule ID 56522 //
     /* 2342886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2342889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2342901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342908 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2342911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2342925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2342936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342946 */     // GIR_Coverage, 56522,
     /* 2342946 */     GIR_EraseRootFromParent_Done,
     /* 2342947 */   // Label 32610: @2342947
     /* 2342947 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2343013), // Rule ID 56523 //
     /* 2342952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2342955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2342959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2342963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2342967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2342972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2342974 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2342977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2342991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343012 */     // GIR_Coverage, 56523,
     /* 2343012 */     GIR_EraseRootFromParent_Done,
     /* 2343013 */   // Label 32611: @2343013
     /* 2343013 */   GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2343062), // Rule ID 56516 //
     /* 2343018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2343021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343025 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2343042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343061 */     // GIR_Coverage, 56516,
     /* 2343061 */     GIR_EraseRootFromParent_Done,
     /* 2343062 */   // Label 32612: @2343062
     /* 2343062 */   GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2343111), // Rule ID 56517 //
     /* 2343067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2343070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343074 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2343091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343110 */     // GIR_Coverage, 56517,
     /* 2343110 */     GIR_EraseRootFromParent_Done,
     /* 2343111 */   // Label 32613: @2343111
     /* 2343111 */   GIM_Reject,
     /* 2343112 */ // Label 32609: @2343112
     /* 2343112 */ GIM_Reject,
     /* 2343113 */ // Label 32505: @2343113
     /* 2343113 */ GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2343363),
     /* 2343118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2343124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343132 */   GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2343198), // Rule ID 56382 //
     /* 2343137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343159 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2343176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343197 */     // GIR_Coverage, 56382,
     /* 2343197 */     GIR_EraseRootFromParent_Done,
     /* 2343198 */   // Label 32615: @2343198
     /* 2343198 */   GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2343264), // Rule ID 56383 //
     /* 2343203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343225 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2343242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343263 */     // GIR_Coverage, 56383,
     /* 2343263 */     GIR_EraseRootFromParent_Done,
     /* 2343264 */   // Label 32616: @2343264
     /* 2343264 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2343313), // Rule ID 56376 //
     /* 2343269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343276 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2343293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343312 */     // GIR_Coverage, 56376,
     /* 2343312 */     GIR_EraseRootFromParent_Done,
     /* 2343313 */   // Label 32617: @2343313
     /* 2343313 */   GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2343362), // Rule ID 56377 //
     /* 2343318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343325 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2343342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343361 */     // GIR_Coverage, 56377,
     /* 2343361 */     GIR_EraseRootFromParent_Done,
     /* 2343362 */   // Label 32618: @2343362
     /* 2343362 */   GIM_Reject,
     /* 2343363 */ // Label 32614: @2343363
     /* 2343363 */ GIM_Reject,
     /* 2343364 */ // Label 32506: @2343364
     /* 2343364 */ GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2343614),
     /* 2343369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2343375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343383 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2343449), // Rule ID 56462 //
     /* 2343388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2343391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343410 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2343427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343448 */     // GIR_Coverage, 56462,
     /* 2343448 */     GIR_EraseRootFromParent_Done,
     /* 2343449 */   // Label 32620: @2343449
     /* 2343449 */   GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2343515), // Rule ID 56463 //
     /* 2343454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2343457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343476 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2343493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343514 */     // GIR_Coverage, 56463,
     /* 2343514 */     GIR_EraseRootFromParent_Done,
     /* 2343515 */   // Label 32621: @2343515
     /* 2343515 */   GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2343564), // Rule ID 56456 //
     /* 2343520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2343523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343527 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2343544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343563 */     // GIR_Coverage, 56456,
     /* 2343563 */     GIR_EraseRootFromParent_Done,
     /* 2343564 */   // Label 32622: @2343564
     /* 2343564 */   GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2343613), // Rule ID 56457 //
     /* 2343569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2343572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343576 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2343593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343612 */     // GIR_Coverage, 56457,
     /* 2343612 */     GIR_EraseRootFromParent_Done,
     /* 2343613 */   // Label 32623: @2343613
     /* 2343613 */   GIM_Reject,
     /* 2343614 */ // Label 32619: @2343614
     /* 2343614 */ GIM_Reject,
     /* 2343615 */ // Label 32507: @2343615
     /* 2343615 */ GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2343865),
     /* 2343620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2343626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343634 */   GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2343700), // Rule ID 56402 //
     /* 2343639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343661 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2343678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343699 */     // GIR_Coverage, 56402,
     /* 2343699 */     GIR_EraseRootFromParent_Done,
     /* 2343700 */   // Label 32625: @2343700
     /* 2343700 */   GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2343766), // Rule ID 56403 //
     /* 2343705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2343712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2343716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2343727 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2343744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2343755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343765 */     // GIR_Coverage, 56403,
     /* 2343765 */     GIR_EraseRootFromParent_Done,
     /* 2343766 */   // Label 32626: @2343766
     /* 2343766 */   GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2343815), // Rule ID 56396 //
     /* 2343771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343778 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2343795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343814 */     // GIR_Coverage, 56396,
     /* 2343814 */     GIR_EraseRootFromParent_Done,
     /* 2343815 */   // Label 32627: @2343815
     /* 2343815 */   GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2343864), // Rule ID 56397 //
     /* 2343820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343827 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2343844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343863 */     // GIR_Coverage, 56397,
     /* 2343863 */     GIR_EraseRootFromParent_Done,
     /* 2343864 */   // Label 32628: @2343864
     /* 2343864 */   GIM_Reject,
     /* 2343865 */ // Label 32624: @2343865
     /* 2343865 */ GIM_Reject,
     /* 2343866 */ // Label 32508: @2343866
     /* 2343866 */ GIM_Reject,
     /* 2343867 */ // Label 73: @2343867
     /* 2343867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32632*/ GIMT_Encode4(2344056),
     /* 2343878 */ /*GILLT_s16*//*Label 32629*/ GIMT_Encode4(2343890),
     /* 2343882 */ /*GILLT_s32*//*Label 32630*/ GIMT_Encode4(2343940),
     /* 2343886 */ /*GILLT_s64*//*Label 32631*/ GIMT_Encode4(2343990),
     /* 2343890 */ // Label 32629: @2343890
     /* 2343890 */ GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2343939),
     /* 2343895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2343898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2343902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2343906 */   GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2343922), // Rule ID 2058 //
     /* 2343911 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2343911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2343914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343921 */     // GIR_Coverage, 2058,
     /* 2343921 */     GIR_EraseRootFromParent_Done,
     /* 2343922 */   // Label 32634: @2343922
     /* 2343922 */   GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2343938), // Rule ID 2059 //
     /* 2343927 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2343927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2343930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343937 */     // GIR_Coverage, 2059,
     /* 2343937 */     GIR_EraseRootFromParent_Done,
     /* 2343938 */   // Label 32635: @2343938
     /* 2343938 */   GIM_Reject,
     /* 2343939 */ // Label 32633: @2343939
     /* 2343939 */ GIM_Reject,
     /* 2343940 */ // Label 32630: @2343940
     /* 2343940 */ GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2343989),
     /* 2343945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2343952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2343956 */   GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2343972), // Rule ID 1341 //
     /* 2343961 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2343961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2343964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343971 */     // GIR_Coverage, 1341,
     /* 2343971 */     GIR_EraseRootFromParent_Done,
     /* 2343972 */   // Label 32637: @2343972
     /* 2343972 */   GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2343988), // Rule ID 1342 //
     /* 2343977 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2343977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2343980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343987 */     // GIR_Coverage, 1342,
     /* 2343987 */     GIR_EraseRootFromParent_Done,
     /* 2343988 */   // Label 32638: @2343988
     /* 2343988 */   GIM_Reject,
     /* 2343989 */ // Label 32636: @2343989
     /* 2343989 */ GIM_Reject,
     /* 2343990 */ // Label 32631: @2343990
     /* 2343990 */ GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2344055),
     /* 2343995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2343998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344006 */   GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2344022), // Rule ID 1718 //
     /* 2344011 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2344011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2344014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344021 */     // GIR_Coverage, 1718,
     /* 2344021 */     GIR_EraseRootFromParent_Done,
     /* 2344022 */   // Label 32640: @2344022
     /* 2344022 */   GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2344038), // Rule ID 1719 //
     /* 2344027 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2344027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2344030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344037 */     // GIR_Coverage, 1719,
     /* 2344037 */     GIR_EraseRootFromParent_Done,
     /* 2344038 */   // Label 32641: @2344038
     /* 2344038 */   GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2344054), // Rule ID 1720 //
     /* 2344043 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2344043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2344046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344053 */     // GIR_Coverage, 1720,
     /* 2344053 */     GIR_EraseRootFromParent_Done,
     /* 2344054 */   // Label 32642: @2344054
     /* 2344054 */   GIM_Reject,
     /* 2344055 */ // Label 32639: @2344055
     /* 2344055 */ GIM_Reject,
     /* 2344056 */ // Label 32632: @2344056
     /* 2344056 */ GIM_Reject,
     /* 2344057 */ // Label 74: @2344057
     /* 2344057 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32661*/ GIMT_Encode4(2346141),
     /* 2344068 */ /*GILLT_s16*//*Label 32643*/ GIMT_Encode4(2344188),
     /* 2344072 */ /*GILLT_s32*//*Label 32644*/ GIMT_Encode4(2344255),
     /* 2344076 */ /*GILLT_s64*//*Label 32645*/ GIMT_Encode4(2344322), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344088 */ /*GILLT_nxv1s16*//*Label 32646*/ GIMT_Encode4(2344416),
     /* 2344092 */ /*GILLT_nxv1s32*//*Label 32647*/ GIMT_Encode4(2344531),
     /* 2344096 */ /*GILLT_nxv1s64*//*Label 32648*/ GIMT_Encode4(2344646), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344108 */ /*GILLT_nxv2s16*//*Label 32649*/ GIMT_Encode4(2344761),
     /* 2344112 */ /*GILLT_nxv2s32*//*Label 32650*/ GIMT_Encode4(2344876),
     /* 2344116 */ /*GILLT_nxv2s64*//*Label 32651*/ GIMT_Encode4(2344991), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344128 */ /*GILLT_nxv4s16*//*Label 32652*/ GIMT_Encode4(2345106),
     /* 2344132 */ /*GILLT_nxv4s32*//*Label 32653*/ GIMT_Encode4(2345221),
     /* 2344136 */ /*GILLT_nxv4s64*//*Label 32654*/ GIMT_Encode4(2345336), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344148 */ /*GILLT_nxv8s16*//*Label 32655*/ GIMT_Encode4(2345451),
     /* 2344152 */ /*GILLT_nxv8s32*//*Label 32656*/ GIMT_Encode4(2345566),
     /* 2344156 */ /*GILLT_nxv8s64*//*Label 32657*/ GIMT_Encode4(2345681), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344168 */ /*GILLT_nxv16s16*//*Label 32658*/ GIMT_Encode4(2345796),
     /* 2344172 */ /*GILLT_nxv16s32*//*Label 32659*/ GIMT_Encode4(2345911), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344184 */ /*GILLT_nxv32s16*//*Label 32660*/ GIMT_Encode4(2346026),
     /* 2344188 */ // Label 32643: @2344188
     /* 2344188 */ GIM_Try, /*On fail goto*//*Label 32662*/ GIMT_Encode4(2344254),
     /* 2344193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2344196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2344199 */   GIM_Try, /*On fail goto*//*Label 32663*/ GIMT_Encode4(2344226), // Rule ID 2046 //
     /* 2344204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2344207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344219 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2344219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2344224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344225 */     // GIR_Coverage, 2046,
     /* 2344225 */     GIR_Done,
     /* 2344226 */   // Label 32663: @2344226
     /* 2344226 */   GIM_Try, /*On fail goto*//*Label 32664*/ GIMT_Encode4(2344253), // Rule ID 2047 //
     /* 2344231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2344234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344246 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2344246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2344251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344252 */     // GIR_Coverage, 2047,
     /* 2344252 */     GIR_Done,
     /* 2344253 */   // Label 32664: @2344253
     /* 2344253 */   GIM_Reject,
     /* 2344254 */ // Label 32662: @2344254
     /* 2344254 */ GIM_Reject,
     /* 2344255 */ // Label 32644: @2344255
     /* 2344255 */ GIM_Try, /*On fail goto*//*Label 32665*/ GIMT_Encode4(2344321),
     /* 2344260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2344266 */   GIM_Try, /*On fail goto*//*Label 32666*/ GIMT_Encode4(2344293), // Rule ID 1329 //
     /* 2344271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2344274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344286 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2344286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2344291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344292 */     // GIR_Coverage, 1329,
     /* 2344292 */     GIR_Done,
     /* 2344293 */   // Label 32666: @2344293
     /* 2344293 */   GIM_Try, /*On fail goto*//*Label 32667*/ GIMT_Encode4(2344320), // Rule ID 1330 //
     /* 2344298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2344301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344313 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2344313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2344318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344319 */     // GIR_Coverage, 1330,
     /* 2344319 */     GIR_Done,
     /* 2344320 */   // Label 32667: @2344320
     /* 2344320 */   GIM_Reject,
     /* 2344321 */ // Label 32665: @2344321
     /* 2344321 */ GIM_Reject,
     /* 2344322 */ // Label 32645: @2344322
     /* 2344322 */ GIM_Try, /*On fail goto*//*Label 32668*/ GIMT_Encode4(2344415),
     /* 2344327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2344333 */   GIM_Try, /*On fail goto*//*Label 32669*/ GIMT_Encode4(2344360), // Rule ID 1700 //
     /* 2344338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2344341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344353 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2344358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344359 */     // GIR_Coverage, 1700,
     /* 2344359 */     GIR_Done,
     /* 2344360 */   // Label 32669: @2344360
     /* 2344360 */   GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2344387), // Rule ID 1701 //
     /* 2344365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2344368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344380 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2344385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344386 */     // GIR_Coverage, 1701,
     /* 2344386 */     GIR_Done,
     /* 2344387 */   // Label 32670: @2344387
     /* 2344387 */   GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2344414), // Rule ID 1702 //
     /* 2344392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2344395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344407 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2344412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344413 */     // GIR_Coverage, 1702,
     /* 2344413 */     GIR_Done,
     /* 2344414 */   // Label 32671: @2344414
     /* 2344414 */   GIM_Reject,
     /* 2344415 */ // Label 32668: @2344415
     /* 2344415 */ GIM_Reject,
     /* 2344416 */ // Label 32646: @2344416
     /* 2344416 */ GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2344530),
     /* 2344421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2344424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2344427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344439 */   GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2344484), // Rule ID 45744 //
     /* 2344444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2344447 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2344450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2344464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344483 */     // GIR_Coverage, 45744,
     /* 2344483 */     GIR_EraseRootFromParent_Done,
     /* 2344484 */   // Label 32673: @2344484
     /* 2344484 */   GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2344529), // Rule ID 45745 //
     /* 2344489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2344492 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2344495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2344509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344528 */     // GIR_Coverage, 45745,
     /* 2344528 */     GIR_EraseRootFromParent_Done,
     /* 2344529 */   // Label 32674: @2344529
     /* 2344529 */   GIM_Reject,
     /* 2344530 */ // Label 32672: @2344530
     /* 2344530 */ GIM_Reject,
     /* 2344531 */ // Label 32647: @2344531
     /* 2344531 */ GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2344645),
     /* 2344536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2344542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344554 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2344599), // Rule ID 56534 //
     /* 2344559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2344562 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2344565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2344579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344598 */     // GIR_Coverage, 56534,
     /* 2344598 */     GIR_EraseRootFromParent_Done,
     /* 2344599 */   // Label 32676: @2344599
     /* 2344599 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2344644), // Rule ID 56535 //
     /* 2344604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2344607 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2344610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2344624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344643 */     // GIR_Coverage, 56535,
     /* 2344643 */     GIR_EraseRootFromParent_Done,
     /* 2344644 */   // Label 32677: @2344644
     /* 2344644 */   GIM_Reject,
     /* 2344645 */ // Label 32675: @2344645
     /* 2344645 */ GIM_Reject,
     /* 2344646 */ // Label 32648: @2344646
     /* 2344646 */ GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2344760),
     /* 2344651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2344654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2344657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344669 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2344714), // Rule ID 56552 //
     /* 2344674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2344677 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2344694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344713 */     // GIR_Coverage, 56552,
     /* 2344713 */     GIR_EraseRootFromParent_Done,
     /* 2344714 */   // Label 32679: @2344714
     /* 2344714 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2344759), // Rule ID 56553 //
     /* 2344719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2344722 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2344739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344758 */     // GIR_Coverage, 56553,
     /* 2344758 */     GIR_EraseRootFromParent_Done,
     /* 2344759 */   // Label 32680: @2344759
     /* 2344759 */   GIM_Reject,
     /* 2344760 */ // Label 32678: @2344760
     /* 2344760 */ GIM_Reject,
     /* 2344761 */ // Label 32649: @2344761
     /* 2344761 */ GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2344875),
     /* 2344766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2344772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344784 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2344829), // Rule ID 56528 //
     /* 2344789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2344792 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2344809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344828 */     // GIR_Coverage, 56528,
     /* 2344828 */     GIR_EraseRootFromParent_Done,
     /* 2344829 */   // Label 32682: @2344829
     /* 2344829 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2344874), // Rule ID 56529 //
     /* 2344834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2344837 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2344854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344873 */     // GIR_Coverage, 56529,
     /* 2344873 */     GIR_EraseRootFromParent_Done,
     /* 2344874 */   // Label 32683: @2344874
     /* 2344874 */   GIM_Reject,
     /* 2344875 */ // Label 32681: @2344875
     /* 2344875 */ GIM_Reject,
     /* 2344876 */ // Label 32650: @2344876
     /* 2344876 */ GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2344990),
     /* 2344881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2344887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344899 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2344944), // Rule ID 56546 //
     /* 2344904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2344907 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2344924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344943 */     // GIR_Coverage, 56546,
     /* 2344943 */     GIR_EraseRootFromParent_Done,
     /* 2344944 */   // Label 32685: @2344944
     /* 2344944 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2344989), // Rule ID 56547 //
     /* 2344949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2344952 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2344955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2344969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344988 */     // GIR_Coverage, 56547,
     /* 2344988 */     GIR_EraseRootFromParent_Done,
     /* 2344989 */   // Label 32686: @2344989
     /* 2344989 */   GIM_Reject,
     /* 2344990 */ // Label 32684: @2344990
     /* 2344990 */ GIM_Reject,
     /* 2344991 */ // Label 32651: @2344991
     /* 2344991 */ GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2345105),
     /* 2344996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2345002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345014 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2345059), // Rule ID 56594 //
     /* 2345019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345022 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2345039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345058 */     // GIR_Coverage, 56594,
     /* 2345058 */     GIR_EraseRootFromParent_Done,
     /* 2345059 */   // Label 32688: @2345059
     /* 2345059 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2345104), // Rule ID 56595 //
     /* 2345064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345067 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2345084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345103 */     // GIR_Coverage, 56595,
     /* 2345103 */     GIR_EraseRootFromParent_Done,
     /* 2345104 */   // Label 32689: @2345104
     /* 2345104 */   GIM_Reject,
     /* 2345105 */ // Label 32687: @2345105
     /* 2345105 */ GIM_Reject,
     /* 2345106 */ // Label 32652: @2345106
     /* 2345106 */ GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2345220),
     /* 2345111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2345117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345129 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2345174), // Rule ID 56540 //
     /* 2345134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345137 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2345154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345173 */     // GIR_Coverage, 56540,
     /* 2345173 */     GIR_EraseRootFromParent_Done,
     /* 2345174 */   // Label 32691: @2345174
     /* 2345174 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2345219), // Rule ID 56541 //
     /* 2345179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345182 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2345199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345218 */     // GIR_Coverage, 56541,
     /* 2345218 */     GIR_EraseRootFromParent_Done,
     /* 2345219 */   // Label 32692: @2345219
     /* 2345219 */   GIM_Reject,
     /* 2345220 */ // Label 32690: @2345220
     /* 2345220 */ GIM_Reject,
     /* 2345221 */ // Label 32653: @2345221
     /* 2345221 */ GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2345335),
     /* 2345226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2345232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345244 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2345289), // Rule ID 56576 //
     /* 2345249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345252 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2345269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345288 */     // GIR_Coverage, 56576,
     /* 2345288 */     GIR_EraseRootFromParent_Done,
     /* 2345289 */   // Label 32694: @2345289
     /* 2345289 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2345334), // Rule ID 56577 //
     /* 2345294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345297 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2345314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345333 */     // GIR_Coverage, 56577,
     /* 2345333 */     GIR_EraseRootFromParent_Done,
     /* 2345334 */   // Label 32695: @2345334
     /* 2345334 */   GIM_Reject,
     /* 2345335 */ // Label 32693: @2345335
     /* 2345335 */ GIM_Reject,
     /* 2345336 */ // Label 32654: @2345336
     /* 2345336 */ GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2345450),
     /* 2345341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2345347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345359 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2345404), // Rule ID 56600 //
     /* 2345364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345367 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2345384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345403 */     // GIR_Coverage, 56600,
     /* 2345403 */     GIR_EraseRootFromParent_Done,
     /* 2345404 */   // Label 32697: @2345404
     /* 2345404 */   GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2345449), // Rule ID 56601 //
     /* 2345409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345412 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2345429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345448 */     // GIR_Coverage, 56601,
     /* 2345448 */     GIR_EraseRootFromParent_Done,
     /* 2345449 */   // Label 32698: @2345449
     /* 2345449 */   GIM_Reject,
     /* 2345450 */ // Label 32696: @2345450
     /* 2345450 */ GIM_Reject,
     /* 2345451 */ // Label 32655: @2345451
     /* 2345451 */ GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2345565),
     /* 2345456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2345462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345474 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2345519), // Rule ID 56558 //
     /* 2345479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345482 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2345499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345518 */     // GIR_Coverage, 56558,
     /* 2345518 */     GIR_EraseRootFromParent_Done,
     /* 2345519 */   // Label 32700: @2345519
     /* 2345519 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2345564), // Rule ID 56559 //
     /* 2345524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345527 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2345544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345563 */     // GIR_Coverage, 56559,
     /* 2345563 */     GIR_EraseRootFromParent_Done,
     /* 2345564 */   // Label 32701: @2345564
     /* 2345564 */   GIM_Reject,
     /* 2345565 */ // Label 32699: @2345565
     /* 2345565 */ GIM_Reject,
     /* 2345566 */ // Label 32656: @2345566
     /* 2345566 */ GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2345680),
     /* 2345571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2345577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345589 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2345634), // Rule ID 56582 //
     /* 2345594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345597 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2345614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345633 */     // GIR_Coverage, 56582,
     /* 2345633 */     GIR_EraseRootFromParent_Done,
     /* 2345634 */   // Label 32703: @2345634
     /* 2345634 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2345679), // Rule ID 56583 //
     /* 2345639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345642 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2345659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345678 */     // GIR_Coverage, 56583,
     /* 2345678 */     GIR_EraseRootFromParent_Done,
     /* 2345679 */   // Label 32704: @2345679
     /* 2345679 */   GIM_Reject,
     /* 2345680 */ // Label 32702: @2345680
     /* 2345680 */ GIM_Reject,
     /* 2345681 */ // Label 32657: @2345681
     /* 2345681 */ GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2345795),
     /* 2345686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2345692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345704 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2345749), // Rule ID 56606 //
     /* 2345709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345712 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2345729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345748 */     // GIR_Coverage, 56606,
     /* 2345748 */     GIR_EraseRootFromParent_Done,
     /* 2345749 */   // Label 32706: @2345749
     /* 2345749 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2345794), // Rule ID 56607 //
     /* 2345754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345757 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2345774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345793 */     // GIR_Coverage, 56607,
     /* 2345793 */     GIR_EraseRootFromParent_Done,
     /* 2345794 */   // Label 32707: @2345794
     /* 2345794 */   GIM_Reject,
     /* 2345795 */ // Label 32705: @2345795
     /* 2345795 */ GIM_Reject,
     /* 2345796 */ // Label 32658: @2345796
     /* 2345796 */ GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2345910),
     /* 2345801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2345804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2345807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345819 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2345864), // Rule ID 56564 //
     /* 2345824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345827 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2345830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2345844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345863 */     // GIR_Coverage, 56564,
     /* 2345863 */     GIR_EraseRootFromParent_Done,
     /* 2345864 */   // Label 32709: @2345864
     /* 2345864 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2345909), // Rule ID 56565 //
     /* 2345869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345872 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2345875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2345889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345908 */     // GIR_Coverage, 56565,
     /* 2345908 */     GIR_EraseRootFromParent_Done,
     /* 2345909 */   // Label 32710: @2345909
     /* 2345909 */   GIM_Reject,
     /* 2345910 */ // Label 32708: @2345910
     /* 2345910 */ GIM_Reject,
     /* 2345911 */ // Label 32659: @2345911
     /* 2345911 */ GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2346025),
     /* 2345916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2345919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2345922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345934 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2345979), // Rule ID 56588 //
     /* 2345939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345942 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2345945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2345959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345978 */     // GIR_Coverage, 56588,
     /* 2345978 */     GIR_EraseRootFromParent_Done,
     /* 2345979 */   // Label 32712: @2345979
     /* 2345979 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2346024), // Rule ID 56589 //
     /* 2345984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345987 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2345990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2346004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346023 */     // GIR_Coverage, 56589,
     /* 2346023 */     GIR_EraseRootFromParent_Done,
     /* 2346024 */   // Label 32713: @2346024
     /* 2346024 */   GIM_Reject,
     /* 2346025 */ // Label 32711: @2346025
     /* 2346025 */ GIM_Reject,
     /* 2346026 */ // Label 32660: @2346026
     /* 2346026 */ GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2346140),
     /* 2346031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2346034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2346037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346049 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2346094), // Rule ID 56570 //
     /* 2346054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346057 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2346074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346093 */     // GIR_Coverage, 56570,
     /* 2346093 */     GIR_EraseRootFromParent_Done,
     /* 2346094 */   // Label 32715: @2346094
     /* 2346094 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2346139), // Rule ID 56571 //
     /* 2346099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2346102 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2346119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346138 */     // GIR_Coverage, 56571,
     /* 2346138 */     GIR_EraseRootFromParent_Done,
     /* 2346139 */   // Label 32716: @2346139
     /* 2346139 */   GIM_Reject,
     /* 2346140 */ // Label 32714: @2346140
     /* 2346140 */ GIM_Reject,
     /* 2346141 */ // Label 32661: @2346141
     /* 2346141 */ GIM_Reject,
     /* 2346142 */ // Label 75: @2346142
     /* 2346142 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32735*/ GIMT_Encode4(2348226),
     /* 2346153 */ /*GILLT_s16*//*Label 32717*/ GIMT_Encode4(2346273),
     /* 2346157 */ /*GILLT_s32*//*Label 32718*/ GIMT_Encode4(2346340),
     /* 2346161 */ /*GILLT_s64*//*Label 32719*/ GIMT_Encode4(2346407), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346173 */ /*GILLT_nxv1s16*//*Label 32720*/ GIMT_Encode4(2346501),
     /* 2346177 */ /*GILLT_nxv1s32*//*Label 32721*/ GIMT_Encode4(2346616),
     /* 2346181 */ /*GILLT_nxv1s64*//*Label 32722*/ GIMT_Encode4(2346731), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346193 */ /*GILLT_nxv2s16*//*Label 32723*/ GIMT_Encode4(2346846),
     /* 2346197 */ /*GILLT_nxv2s32*//*Label 32724*/ GIMT_Encode4(2346961),
     /* 2346201 */ /*GILLT_nxv2s64*//*Label 32725*/ GIMT_Encode4(2347076), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346213 */ /*GILLT_nxv4s16*//*Label 32726*/ GIMT_Encode4(2347191),
     /* 2346217 */ /*GILLT_nxv4s32*//*Label 32727*/ GIMT_Encode4(2347306),
     /* 2346221 */ /*GILLT_nxv4s64*//*Label 32728*/ GIMT_Encode4(2347421), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346233 */ /*GILLT_nxv8s16*//*Label 32729*/ GIMT_Encode4(2347536),
     /* 2346237 */ /*GILLT_nxv8s32*//*Label 32730*/ GIMT_Encode4(2347651),
     /* 2346241 */ /*GILLT_nxv8s64*//*Label 32731*/ GIMT_Encode4(2347766), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346253 */ /*GILLT_nxv16s16*//*Label 32732*/ GIMT_Encode4(2347881),
     /* 2346257 */ /*GILLT_nxv16s32*//*Label 32733*/ GIMT_Encode4(2347996), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346269 */ /*GILLT_nxv32s16*//*Label 32734*/ GIMT_Encode4(2348111),
     /* 2346273 */ // Label 32717: @2346273
     /* 2346273 */ GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2346339),
     /* 2346278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2346281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2346284 */   GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2346311), // Rule ID 2048 //
     /* 2346289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2346292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346304 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2346304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2346309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346310 */     // GIR_Coverage, 2048,
     /* 2346310 */     GIR_Done,
     /* 2346311 */   // Label 32737: @2346311
     /* 2346311 */   GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2346338), // Rule ID 2049 //
     /* 2346316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2346319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346331 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2346331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2346336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346337 */     // GIR_Coverage, 2049,
     /* 2346337 */     GIR_Done,
     /* 2346338 */   // Label 32738: @2346338
     /* 2346338 */   GIM_Reject,
     /* 2346339 */ // Label 32736: @2346339
     /* 2346339 */ GIM_Reject,
     /* 2346340 */ // Label 32718: @2346340
     /* 2346340 */ GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2346406),
     /* 2346345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2346348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2346351 */   GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2346378), // Rule ID 1331 //
     /* 2346356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2346359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346371 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2346371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2346376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346377 */     // GIR_Coverage, 1331,
     /* 2346377 */     GIR_Done,
     /* 2346378 */   // Label 32740: @2346378
     /* 2346378 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2346405), // Rule ID 1332 //
     /* 2346383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2346386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346398 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2346398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2346403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346404 */     // GIR_Coverage, 1332,
     /* 2346404 */     GIR_Done,
     /* 2346405 */   // Label 32741: @2346405
     /* 2346405 */   GIM_Reject,
     /* 2346406 */ // Label 32739: @2346406
     /* 2346406 */ GIM_Reject,
     /* 2346407 */ // Label 32719: @2346407
     /* 2346407 */ GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2346500),
     /* 2346412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2346415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2346418 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2346445), // Rule ID 1703 //
     /* 2346423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2346426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346438 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2346443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346444 */     // GIR_Coverage, 1703,
     /* 2346444 */     GIR_Done,
     /* 2346445 */   // Label 32743: @2346445
     /* 2346445 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2346472), // Rule ID 1704 //
     /* 2346450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2346453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346465 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2346470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346471 */     // GIR_Coverage, 1704,
     /* 2346471 */     GIR_Done,
     /* 2346472 */   // Label 32744: @2346472
     /* 2346472 */   GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2346499), // Rule ID 1705 //
     /* 2346477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2346480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346492 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2346497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346498 */     // GIR_Coverage, 1705,
     /* 2346498 */     GIR_Done,
     /* 2346499 */   // Label 32745: @2346499
     /* 2346499 */   GIM_Reject,
     /* 2346500 */ // Label 32742: @2346500
     /* 2346500 */ GIM_Reject,
     /* 2346501 */ // Label 32720: @2346501
     /* 2346501 */ GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2346615),
     /* 2346506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2346509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2346512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346524 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2346569), // Rule ID 56612 //
     /* 2346529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346532 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2346535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2346549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346568 */     // GIR_Coverage, 56612,
     /* 2346568 */     GIR_EraseRootFromParent_Done,
     /* 2346569 */   // Label 32747: @2346569
     /* 2346569 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2346614), // Rule ID 56613 //
     /* 2346574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2346577 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2346580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2346594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346613 */     // GIR_Coverage, 56613,
     /* 2346613 */     GIR_EraseRootFromParent_Done,
     /* 2346614 */   // Label 32748: @2346614
     /* 2346614 */   GIM_Reject,
     /* 2346615 */ // Label 32746: @2346615
     /* 2346615 */ GIM_Reject,
     /* 2346616 */ // Label 32721: @2346616
     /* 2346616 */ GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2346730),
     /* 2346621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2346624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2346627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346639 */   GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2346684), // Rule ID 56624 //
     /* 2346644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2346647 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2346650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2346664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346683 */     // GIR_Coverage, 56624,
     /* 2346683 */     GIR_EraseRootFromParent_Done,
     /* 2346684 */   // Label 32750: @2346684
     /* 2346684 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2346729), // Rule ID 56625 //
     /* 2346689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2346692 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2346695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2346709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346728 */     // GIR_Coverage, 56625,
     /* 2346728 */     GIR_EraseRootFromParent_Done,
     /* 2346729 */   // Label 32751: @2346729
     /* 2346729 */   GIM_Reject,
     /* 2346730 */ // Label 32749: @2346730
     /* 2346730 */ GIM_Reject,
     /* 2346731 */ // Label 32722: @2346731
     /* 2346731 */ GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2346845),
     /* 2346736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2346739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2346742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346754 */   GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2346799), // Rule ID 56642 //
     /* 2346759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2346762 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2346765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2346779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346798 */     // GIR_Coverage, 56642,
     /* 2346798 */     GIR_EraseRootFromParent_Done,
     /* 2346799 */   // Label 32753: @2346799
     /* 2346799 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2346844), // Rule ID 56643 //
     /* 2346804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2346807 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2346810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2346824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346843 */     // GIR_Coverage, 56643,
     /* 2346843 */     GIR_EraseRootFromParent_Done,
     /* 2346844 */   // Label 32754: @2346844
     /* 2346844 */   GIM_Reject,
     /* 2346845 */ // Label 32752: @2346845
     /* 2346845 */ GIM_Reject,
     /* 2346846 */ // Label 32723: @2346846
     /* 2346846 */ GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2346960),
     /* 2346851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2346854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2346857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346869 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2346914), // Rule ID 56618 //
     /* 2346874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346877 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2346894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346913 */     // GIR_Coverage, 56618,
     /* 2346913 */     GIR_EraseRootFromParent_Done,
     /* 2346914 */   // Label 32756: @2346914
     /* 2346914 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2346959), // Rule ID 56619 //
     /* 2346919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2346922 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2346939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346958 */     // GIR_Coverage, 56619,
     /* 2346958 */     GIR_EraseRootFromParent_Done,
     /* 2346959 */   // Label 32757: @2346959
     /* 2346959 */   GIM_Reject,
     /* 2346960 */ // Label 32755: @2346960
     /* 2346960 */ GIM_Reject,
     /* 2346961 */ // Label 32724: @2346961
     /* 2346961 */ GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2347075),
     /* 2346966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2346969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2346972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346984 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2347029), // Rule ID 56636 //
     /* 2346989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2346992 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2346995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2347009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347028 */     // GIR_Coverage, 56636,
     /* 2347028 */     GIR_EraseRootFromParent_Done,
     /* 2347029 */   // Label 32759: @2347029
     /* 2347029 */   GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2347074), // Rule ID 56637 //
     /* 2347034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347037 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2347040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2347054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347073 */     // GIR_Coverage, 56637,
     /* 2347073 */     GIR_EraseRootFromParent_Done,
     /* 2347074 */   // Label 32760: @2347074
     /* 2347074 */   GIM_Reject,
     /* 2347075 */ // Label 32758: @2347075
     /* 2347075 */ GIM_Reject,
     /* 2347076 */ // Label 32725: @2347076
     /* 2347076 */ GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2347190),
     /* 2347081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2347084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2347087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347099 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2347144), // Rule ID 56684 //
     /* 2347104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347107 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2347124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347143 */     // GIR_Coverage, 56684,
     /* 2347143 */     GIR_EraseRootFromParent_Done,
     /* 2347144 */   // Label 32762: @2347144
     /* 2347144 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2347189), // Rule ID 56685 //
     /* 2347149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347152 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2347169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347188 */     // GIR_Coverage, 56685,
     /* 2347188 */     GIR_EraseRootFromParent_Done,
     /* 2347189 */   // Label 32763: @2347189
     /* 2347189 */   GIM_Reject,
     /* 2347190 */ // Label 32761: @2347190
     /* 2347190 */ GIM_Reject,
     /* 2347191 */ // Label 32726: @2347191
     /* 2347191 */ GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2347305),
     /* 2347196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2347199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2347202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347214 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2347259), // Rule ID 56630 //
     /* 2347219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347222 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2347239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347258 */     // GIR_Coverage, 56630,
     /* 2347258 */     GIR_EraseRootFromParent_Done,
     /* 2347259 */   // Label 32765: @2347259
     /* 2347259 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2347304), // Rule ID 56631 //
     /* 2347264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347267 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2347284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347303 */     // GIR_Coverage, 56631,
     /* 2347303 */     GIR_EraseRootFromParent_Done,
     /* 2347304 */   // Label 32766: @2347304
     /* 2347304 */   GIM_Reject,
     /* 2347305 */ // Label 32764: @2347305
     /* 2347305 */ GIM_Reject,
     /* 2347306 */ // Label 32727: @2347306
     /* 2347306 */ GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2347420),
     /* 2347311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2347317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347329 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2347374), // Rule ID 56666 //
     /* 2347334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347337 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2347354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347373 */     // GIR_Coverage, 56666,
     /* 2347373 */     GIR_EraseRootFromParent_Done,
     /* 2347374 */   // Label 32768: @2347374
     /* 2347374 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2347419), // Rule ID 56667 //
     /* 2347379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347382 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2347399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347418 */     // GIR_Coverage, 56667,
     /* 2347418 */     GIR_EraseRootFromParent_Done,
     /* 2347419 */   // Label 32769: @2347419
     /* 2347419 */   GIM_Reject,
     /* 2347420 */ // Label 32767: @2347420
     /* 2347420 */ GIM_Reject,
     /* 2347421 */ // Label 32728: @2347421
     /* 2347421 */ GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2347535),
     /* 2347426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2347432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347444 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2347489), // Rule ID 56690 //
     /* 2347449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347452 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2347469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347488 */     // GIR_Coverage, 56690,
     /* 2347488 */     GIR_EraseRootFromParent_Done,
     /* 2347489 */   // Label 32771: @2347489
     /* 2347489 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2347534), // Rule ID 56691 //
     /* 2347494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347497 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2347514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347533 */     // GIR_Coverage, 56691,
     /* 2347533 */     GIR_EraseRootFromParent_Done,
     /* 2347534 */   // Label 32772: @2347534
     /* 2347534 */   GIM_Reject,
     /* 2347535 */ // Label 32770: @2347535
     /* 2347535 */ GIM_Reject,
     /* 2347536 */ // Label 32729: @2347536
     /* 2347536 */ GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2347650),
     /* 2347541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2347544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2347547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347559 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2347604), // Rule ID 56648 //
     /* 2347564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347567 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2347584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347603 */     // GIR_Coverage, 56648,
     /* 2347603 */     GIR_EraseRootFromParent_Done,
     /* 2347604 */   // Label 32774: @2347604
     /* 2347604 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2347649), // Rule ID 56649 //
     /* 2347609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347612 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2347629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347648 */     // GIR_Coverage, 56649,
     /* 2347648 */     GIR_EraseRootFromParent_Done,
     /* 2347649 */   // Label 32775: @2347649
     /* 2347649 */   GIM_Reject,
     /* 2347650 */ // Label 32773: @2347650
     /* 2347650 */ GIM_Reject,
     /* 2347651 */ // Label 32730: @2347651
     /* 2347651 */ GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2347765),
     /* 2347656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2347659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2347662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347674 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2347719), // Rule ID 56672 //
     /* 2347679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347682 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2347685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2347699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347718 */     // GIR_Coverage, 56672,
     /* 2347718 */     GIR_EraseRootFromParent_Done,
     /* 2347719 */   // Label 32777: @2347719
     /* 2347719 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2347764), // Rule ID 56673 //
     /* 2347724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347727 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2347730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2347744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347763 */     // GIR_Coverage, 56673,
     /* 2347763 */     GIR_EraseRootFromParent_Done,
     /* 2347764 */   // Label 32778: @2347764
     /* 2347764 */   GIM_Reject,
     /* 2347765 */ // Label 32776: @2347765
     /* 2347765 */ GIM_Reject,
     /* 2347766 */ // Label 32731: @2347766
     /* 2347766 */ GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2347880),
     /* 2347771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2347774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2347777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347789 */   GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2347834), // Rule ID 56696 //
     /* 2347794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347797 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2347800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2347814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347833 */     // GIR_Coverage, 56696,
     /* 2347833 */     GIR_EraseRootFromParent_Done,
     /* 2347834 */   // Label 32780: @2347834
     /* 2347834 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2347879), // Rule ID 56697 //
     /* 2347839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347842 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2347845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2347859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347878 */     // GIR_Coverage, 56697,
     /* 2347878 */     GIR_EraseRootFromParent_Done,
     /* 2347879 */   // Label 32781: @2347879
     /* 2347879 */   GIM_Reject,
     /* 2347880 */ // Label 32779: @2347880
     /* 2347880 */ GIM_Reject,
     /* 2347881 */ // Label 32732: @2347881
     /* 2347881 */ GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2347995),
     /* 2347886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2347892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347904 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2347949), // Rule ID 56654 //
     /* 2347909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347912 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2347929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347948 */     // GIR_Coverage, 56654,
     /* 2347948 */     GIR_EraseRootFromParent_Done,
     /* 2347949 */   // Label 32783: @2347949
     /* 2347949 */   GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2347994), // Rule ID 56655 //
     /* 2347954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347957 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2347960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2347974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347993 */     // GIR_Coverage, 56655,
     /* 2347993 */     GIR_EraseRootFromParent_Done,
     /* 2347994 */   // Label 32784: @2347994
     /* 2347994 */   GIM_Reject,
     /* 2347995 */ // Label 32782: @2347995
     /* 2347995 */ GIM_Reject,
     /* 2347996 */ // Label 32733: @2347996
     /* 2347996 */ GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2348110),
     /* 2348001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2348007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348019 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2348064), // Rule ID 56678 //
     /* 2348024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348027 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2348044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348063 */     // GIR_Coverage, 56678,
     /* 2348063 */     GIR_EraseRootFromParent_Done,
     /* 2348064 */   // Label 32786: @2348064
     /* 2348064 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2348109), // Rule ID 56679 //
     /* 2348069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348072 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2348089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348108 */     // GIR_Coverage, 56679,
     /* 2348108 */     GIR_EraseRootFromParent_Done,
     /* 2348109 */   // Label 32787: @2348109
     /* 2348109 */   GIM_Reject,
     /* 2348110 */ // Label 32785: @2348110
     /* 2348110 */ GIM_Reject,
     /* 2348111 */ // Label 32734: @2348111
     /* 2348111 */ GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2348225),
     /* 2348116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2348119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2348122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348134 */   GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2348179), // Rule ID 56660 //
     /* 2348139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348142 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2348159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348178 */     // GIR_Coverage, 56660,
     /* 2348178 */     GIR_EraseRootFromParent_Done,
     /* 2348179 */   // Label 32789: @2348179
     /* 2348179 */   GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2348224), // Rule ID 56661 //
     /* 2348184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348187 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2348204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348223 */     // GIR_Coverage, 56661,
     /* 2348223 */     GIR_EraseRootFromParent_Done,
     /* 2348224 */   // Label 32790: @2348224
     /* 2348224 */   GIM_Reject,
     /* 2348225 */ // Label 32788: @2348225
     /* 2348225 */ GIM_Reject,
     /* 2348226 */ // Label 32735: @2348226
     /* 2348226 */ GIM_Reject,
     /* 2348227 */ // Label 76: @2348227
     /* 2348227 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32794*/ GIMT_Encode4(2348352),
     /* 2348238 */ /*GILLT_s16*//*Label 32791*/ GIMT_Encode4(2348250),
     /* 2348242 */ /*GILLT_s32*//*Label 32792*/ GIMT_Encode4(2348284),
     /* 2348246 */ /*GILLT_s64*//*Label 32793*/ GIMT_Encode4(2348318),
     /* 2348250 */ // Label 32791: @2348250
     /* 2348250 */ GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2348283), // Rule ID 2400 //
     /* 2348255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2348258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2348264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348276 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2348276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2348281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348282 */   // GIR_Coverage, 2400,
     /* 2348282 */   GIR_Done,
     /* 2348283 */ // Label 32795: @2348283
     /* 2348283 */ GIM_Reject,
     /* 2348284 */ // Label 32792: @2348284
     /* 2348284 */ GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2348317), // Rule ID 2318 //
     /* 2348289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2348292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2348298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348310 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2348310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2348315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348316 */   // GIR_Coverage, 2318,
     /* 2348316 */   GIR_Done,
     /* 2348317 */ // Label 32796: @2348317
     /* 2348317 */ GIM_Reject,
     /* 2348318 */ // Label 32793: @2348318
     /* 2348318 */ GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2348351), // Rule ID 2358 //
     /* 2348323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2348326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2348332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348344 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2348344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2348349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348350 */   // GIR_Coverage, 2358,
     /* 2348350 */   GIR_Done,
     /* 2348351 */ // Label 32797: @2348351
     /* 2348351 */ GIM_Reject,
     /* 2348352 */ // Label 32794: @2348352
     /* 2348352 */ GIM_Reject,
     /* 2348353 */ // Label 77: @2348353
     /* 2348353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32801*/ GIMT_Encode4(2348478),
     /* 2348364 */ /*GILLT_s16*//*Label 32798*/ GIMT_Encode4(2348376),
     /* 2348368 */ /*GILLT_s32*//*Label 32799*/ GIMT_Encode4(2348410),
     /* 2348372 */ /*GILLT_s64*//*Label 32800*/ GIMT_Encode4(2348444),
     /* 2348376 */ // Label 32798: @2348376
     /* 2348376 */ GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2348409), // Rule ID 2401 //
     /* 2348381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2348384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2348390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348402 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2348402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2348407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348408 */   // GIR_Coverage, 2401,
     /* 2348408 */   GIR_Done,
     /* 2348409 */ // Label 32802: @2348409
     /* 2348409 */ GIM_Reject,
     /* 2348410 */ // Label 32799: @2348410
     /* 2348410 */ GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2348443), // Rule ID 2319 //
     /* 2348415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2348418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2348424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348436 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2348436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2348441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348442 */   // GIR_Coverage, 2319,
     /* 2348442 */   GIR_Done,
     /* 2348443 */ // Label 32803: @2348443
     /* 2348443 */ GIM_Reject,
     /* 2348444 */ // Label 32800: @2348444
     /* 2348444 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2348477), // Rule ID 2359 //
     /* 2348449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2348452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2348458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348470 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2348470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2348475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2348476 */   // GIR_Coverage, 2359,
     /* 2348476 */   GIR_Done,
     /* 2348477 */ // Label 32804: @2348477
     /* 2348477 */ GIM_Reject,
     /* 2348478 */ // Label 32801: @2348478
     /* 2348478 */ GIM_Reject,
     /* 2348479 */ // Label 78: @2348479
     /* 2348479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32823*/ GIMT_Encode4(2350563),
     /* 2348490 */ /*GILLT_s16*//*Label 32805*/ GIMT_Encode4(2348610),
     /* 2348494 */ /*GILLT_s32*//*Label 32806*/ GIMT_Encode4(2348677),
     /* 2348498 */ /*GILLT_s64*//*Label 32807*/ GIMT_Encode4(2348744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348510 */ /*GILLT_nxv1s16*//*Label 32808*/ GIMT_Encode4(2348838),
     /* 2348514 */ /*GILLT_nxv1s32*//*Label 32809*/ GIMT_Encode4(2348953),
     /* 2348518 */ /*GILLT_nxv1s64*//*Label 32810*/ GIMT_Encode4(2349068), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348530 */ /*GILLT_nxv2s16*//*Label 32811*/ GIMT_Encode4(2349183),
     /* 2348534 */ /*GILLT_nxv2s32*//*Label 32812*/ GIMT_Encode4(2349298),
     /* 2348538 */ /*GILLT_nxv2s64*//*Label 32813*/ GIMT_Encode4(2349413), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348550 */ /*GILLT_nxv4s16*//*Label 32814*/ GIMT_Encode4(2349528),
     /* 2348554 */ /*GILLT_nxv4s32*//*Label 32815*/ GIMT_Encode4(2349643),
     /* 2348558 */ /*GILLT_nxv4s64*//*Label 32816*/ GIMT_Encode4(2349758), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348570 */ /*GILLT_nxv8s16*//*Label 32817*/ GIMT_Encode4(2349873),
     /* 2348574 */ /*GILLT_nxv8s32*//*Label 32818*/ GIMT_Encode4(2349988),
     /* 2348578 */ /*GILLT_nxv8s64*//*Label 32819*/ GIMT_Encode4(2350103), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348590 */ /*GILLT_nxv16s16*//*Label 32820*/ GIMT_Encode4(2350218),
     /* 2348594 */ /*GILLT_nxv16s32*//*Label 32821*/ GIMT_Encode4(2350333), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348606 */ /*GILLT_nxv32s16*//*Label 32822*/ GIMT_Encode4(2350448),
     /* 2348610 */ // Label 32805: @2348610
     /* 2348610 */ GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2348676),
     /* 2348615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2348621 */   GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2348648), // Rule ID 2050 //
     /* 2348626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2348629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348641 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2348641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2348646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348647 */     // GIR_Coverage, 2050,
     /* 2348647 */     GIR_Done,
     /* 2348648 */   // Label 32825: @2348648
     /* 2348648 */   GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2348675), // Rule ID 2051 //
     /* 2348653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2348656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348668 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2348668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2348673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348674 */     // GIR_Coverage, 2051,
     /* 2348674 */     GIR_Done,
     /* 2348675 */   // Label 32826: @2348675
     /* 2348675 */   GIM_Reject,
     /* 2348676 */ // Label 32824: @2348676
     /* 2348676 */ GIM_Reject,
     /* 2348677 */ // Label 32806: @2348677
     /* 2348677 */ GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2348743),
     /* 2348682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2348688 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2348715), // Rule ID 1333 //
     /* 2348693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2348696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2348708 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2348708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2348713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348714 */     // GIR_Coverage, 1333,
     /* 2348714 */     GIR_Done,
     /* 2348715 */   // Label 32828: @2348715
     /* 2348715 */   GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2348742), // Rule ID 1334 //
     /* 2348720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2348723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2348735 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2348735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2348740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348741 */     // GIR_Coverage, 1334,
     /* 2348741 */     GIR_Done,
     /* 2348742 */   // Label 32829: @2348742
     /* 2348742 */   GIM_Reject,
     /* 2348743 */ // Label 32827: @2348743
     /* 2348743 */ GIM_Reject,
     /* 2348744 */ // Label 32807: @2348744
     /* 2348744 */ GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2348837),
     /* 2348749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2348755 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2348782), // Rule ID 1706 //
     /* 2348760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2348763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2348775 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2348775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2348780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348781 */     // GIR_Coverage, 1706,
     /* 2348781 */     GIR_Done,
     /* 2348782 */   // Label 32831: @2348782
     /* 2348782 */   GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2348809), // Rule ID 1707 //
     /* 2348787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2348790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2348802 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2348802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2348807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348808 */     // GIR_Coverage, 1707,
     /* 2348808 */     GIR_Done,
     /* 2348809 */   // Label 32832: @2348809
     /* 2348809 */   GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2348836), // Rule ID 1708 //
     /* 2348814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2348817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348829 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2348829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2348834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348835 */     // GIR_Coverage, 1708,
     /* 2348835 */     GIR_Done,
     /* 2348836 */   // Label 32833: @2348836
     /* 2348836 */   GIM_Reject,
     /* 2348837 */ // Label 32830: @2348837
     /* 2348837 */ GIM_Reject,
     /* 2348838 */ // Label 32808: @2348838
     /* 2348838 */ GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2348952),
     /* 2348843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2348849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348861 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2348906), // Rule ID 56702 //
     /* 2348866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348869 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2348886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348905 */     // GIR_Coverage, 56702,
     /* 2348905 */     GIR_EraseRootFromParent_Done,
     /* 2348906 */   // Label 32835: @2348906
     /* 2348906 */   GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2348951), // Rule ID 56703 //
     /* 2348911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348914 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2348931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348950 */     // GIR_Coverage, 56703,
     /* 2348950 */     GIR_EraseRootFromParent_Done,
     /* 2348951 */   // Label 32836: @2348951
     /* 2348951 */   GIM_Reject,
     /* 2348952 */ // Label 32834: @2348952
     /* 2348952 */ GIM_Reject,
     /* 2348953 */ // Label 32809: @2348953
     /* 2348953 */ GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2349067),
     /* 2348958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2348964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348976 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2349021), // Rule ID 56714 //
     /* 2348981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348984 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2349001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349020 */     // GIR_Coverage, 56714,
     /* 2349020 */     GIR_EraseRootFromParent_Done,
     /* 2349021 */   // Label 32838: @2349021
     /* 2349021 */   GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2349066), // Rule ID 56715 //
     /* 2349026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2349029 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2349032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2349046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349065 */     // GIR_Coverage, 56715,
     /* 2349065 */     GIR_EraseRootFromParent_Done,
     /* 2349066 */   // Label 32839: @2349066
     /* 2349066 */   GIM_Reject,
     /* 2349067 */ // Label 32837: @2349067
     /* 2349067 */ GIM_Reject,
     /* 2349068 */ // Label 32810: @2349068
     /* 2349068 */ GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2349182),
     /* 2349073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2349076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2349079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349091 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2349136), // Rule ID 56732 //
     /* 2349096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2349099 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2349116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349135 */     // GIR_Coverage, 56732,
     /* 2349135 */     GIR_EraseRootFromParent_Done,
     /* 2349136 */   // Label 32841: @2349136
     /* 2349136 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2349181), // Rule ID 56733 //
     /* 2349141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2349144 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2349161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349180 */     // GIR_Coverage, 56733,
     /* 2349180 */     GIR_EraseRootFromParent_Done,
     /* 2349181 */   // Label 32842: @2349181
     /* 2349181 */   GIM_Reject,
     /* 2349182 */ // Label 32840: @2349182
     /* 2349182 */ GIM_Reject,
     /* 2349183 */ // Label 32811: @2349183
     /* 2349183 */ GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2349297),
     /* 2349188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2349194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349206 */   GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2349251), // Rule ID 56708 //
     /* 2349211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2349214 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2349231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349250 */     // GIR_Coverage, 56708,
     /* 2349250 */     GIR_EraseRootFromParent_Done,
     /* 2349251 */   // Label 32844: @2349251
     /* 2349251 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2349296), // Rule ID 56709 //
     /* 2349256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2349259 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2349276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349295 */     // GIR_Coverage, 56709,
     /* 2349295 */     GIR_EraseRootFromParent_Done,
     /* 2349296 */   // Label 32845: @2349296
     /* 2349296 */   GIM_Reject,
     /* 2349297 */ // Label 32843: @2349297
     /* 2349297 */ GIM_Reject,
     /* 2349298 */ // Label 32812: @2349298
     /* 2349298 */ GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2349412),
     /* 2349303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2349309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349321 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2349366), // Rule ID 56726 //
     /* 2349326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2349329 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2349346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349365 */     // GIR_Coverage, 56726,
     /* 2349365 */     GIR_EraseRootFromParent_Done,
     /* 2349366 */   // Label 32847: @2349366
     /* 2349366 */   GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2349411), // Rule ID 56727 //
     /* 2349371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2349374 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2349391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349410 */     // GIR_Coverage, 56727,
     /* 2349410 */     GIR_EraseRootFromParent_Done,
     /* 2349411 */   // Label 32848: @2349411
     /* 2349411 */   GIM_Reject,
     /* 2349412 */ // Label 32846: @2349412
     /* 2349412 */ GIM_Reject,
     /* 2349413 */ // Label 32813: @2349413
     /* 2349413 */ GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2349527),
     /* 2349418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2349421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2349424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349436 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2349481), // Rule ID 56774 //
     /* 2349441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2349444 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2349447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2349461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349480 */     // GIR_Coverage, 56774,
     /* 2349480 */     GIR_EraseRootFromParent_Done,
     /* 2349481 */   // Label 32850: @2349481
     /* 2349481 */   GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2349526), // Rule ID 56775 //
     /* 2349486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2349489 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2349492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2349506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349525 */     // GIR_Coverage, 56775,
     /* 2349525 */     GIR_EraseRootFromParent_Done,
     /* 2349526 */   // Label 32851: @2349526
     /* 2349526 */   GIM_Reject,
     /* 2349527 */ // Label 32849: @2349527
     /* 2349527 */ GIM_Reject,
     /* 2349528 */ // Label 32814: @2349528
     /* 2349528 */ GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2349642),
     /* 2349533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2349536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2349539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349551 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2349596), // Rule ID 56720 //
     /* 2349556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2349559 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2349562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2349576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349595 */     // GIR_Coverage, 56720,
     /* 2349595 */     GIR_EraseRootFromParent_Done,
     /* 2349596 */   // Label 32853: @2349596
     /* 2349596 */   GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2349641), // Rule ID 56721 //
     /* 2349601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2349604 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2349607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2349621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349640 */     // GIR_Coverage, 56721,
     /* 2349640 */     GIR_EraseRootFromParent_Done,
     /* 2349641 */   // Label 32854: @2349641
     /* 2349641 */   GIM_Reject,
     /* 2349642 */ // Label 32852: @2349642
     /* 2349642 */ GIM_Reject,
     /* 2349643 */ // Label 32815: @2349643
     /* 2349643 */ GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2349757),
     /* 2349648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2349651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2349654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349666 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2349711), // Rule ID 56756 //
     /* 2349671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2349674 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2349677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2349691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349710 */     // GIR_Coverage, 56756,
     /* 2349710 */     GIR_EraseRootFromParent_Done,
     /* 2349711 */   // Label 32856: @2349711
     /* 2349711 */   GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2349756), // Rule ID 56757 //
     /* 2349716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2349719 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2349722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2349736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349755 */     // GIR_Coverage, 56757,
     /* 2349755 */     GIR_EraseRootFromParent_Done,
     /* 2349756 */   // Label 32857: @2349756
     /* 2349756 */   GIM_Reject,
     /* 2349757 */ // Label 32855: @2349757
     /* 2349757 */ GIM_Reject,
     /* 2349758 */ // Label 32816: @2349758
     /* 2349758 */ GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2349872),
     /* 2349763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2349766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2349769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349781 */   GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2349826), // Rule ID 56780 //
     /* 2349786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2349789 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2349792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2349806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349825 */     // GIR_Coverage, 56780,
     /* 2349825 */     GIR_EraseRootFromParent_Done,
     /* 2349826 */   // Label 32859: @2349826
     /* 2349826 */   GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2349871), // Rule ID 56781 //
     /* 2349831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2349834 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2349837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2349851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349870 */     // GIR_Coverage, 56781,
     /* 2349870 */     GIR_EraseRootFromParent_Done,
     /* 2349871 */   // Label 32860: @2349871
     /* 2349871 */   GIM_Reject,
     /* 2349872 */ // Label 32858: @2349872
     /* 2349872 */ GIM_Reject,
     /* 2349873 */ // Label 32817: @2349873
     /* 2349873 */ GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2349987),
     /* 2349878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2349881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2349884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349896 */   GIM_Try, /*On fail goto*//*Label 32862*/ GIMT_Encode4(2349941), // Rule ID 56738 //
     /* 2349901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2349904 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2349907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2349921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349940 */     // GIR_Coverage, 56738,
     /* 2349940 */     GIR_EraseRootFromParent_Done,
     /* 2349941 */   // Label 32862: @2349941
     /* 2349941 */   GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2349986), // Rule ID 56739 //
     /* 2349946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2349949 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2349952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2349966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349985 */     // GIR_Coverage, 56739,
     /* 2349985 */     GIR_EraseRootFromParent_Done,
     /* 2349986 */   // Label 32863: @2349986
     /* 2349986 */   GIM_Reject,
     /* 2349987 */ // Label 32861: @2349987
     /* 2349987 */ GIM_Reject,
     /* 2349988 */ // Label 32818: @2349988
     /* 2349988 */ GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2350102),
     /* 2349993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2349996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2349999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350011 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2350056), // Rule ID 56762 //
     /* 2350016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2350019 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2350036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350055 */     // GIR_Coverage, 56762,
     /* 2350055 */     GIR_EraseRootFromParent_Done,
     /* 2350056 */   // Label 32865: @2350056
     /* 2350056 */   GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2350101), // Rule ID 56763 //
     /* 2350061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2350064 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2350081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350100 */     // GIR_Coverage, 56763,
     /* 2350100 */     GIR_EraseRootFromParent_Done,
     /* 2350101 */   // Label 32866: @2350101
     /* 2350101 */   GIM_Reject,
     /* 2350102 */ // Label 32864: @2350102
     /* 2350102 */ GIM_Reject,
     /* 2350103 */ // Label 32819: @2350103
     /* 2350103 */ GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2350217),
     /* 2350108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2350111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2350114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350126 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2350171), // Rule ID 56786 //
     /* 2350131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2350134 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2350151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350170 */     // GIR_Coverage, 56786,
     /* 2350170 */     GIR_EraseRootFromParent_Done,
     /* 2350171 */   // Label 32868: @2350171
     /* 2350171 */   GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2350216), // Rule ID 56787 //
     /* 2350176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2350179 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2350196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350215 */     // GIR_Coverage, 56787,
     /* 2350215 */     GIR_EraseRootFromParent_Done,
     /* 2350216 */   // Label 32869: @2350216
     /* 2350216 */   GIM_Reject,
     /* 2350217 */ // Label 32867: @2350217
     /* 2350217 */ GIM_Reject,
     /* 2350218 */ // Label 32820: @2350218
     /* 2350218 */ GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2350332),
     /* 2350223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2350226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2350229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350241 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2350286), // Rule ID 56744 //
     /* 2350246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350249 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2350252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2350266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350285 */     // GIR_Coverage, 56744,
     /* 2350285 */     GIR_EraseRootFromParent_Done,
     /* 2350286 */   // Label 32871: @2350286
     /* 2350286 */   GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2350331), // Rule ID 56745 //
     /* 2350291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350294 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2350297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2350311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350330 */     // GIR_Coverage, 56745,
     /* 2350330 */     GIR_EraseRootFromParent_Done,
     /* 2350331 */   // Label 32872: @2350331
     /* 2350331 */   GIM_Reject,
     /* 2350332 */ // Label 32870: @2350332
     /* 2350332 */ GIM_Reject,
     /* 2350333 */ // Label 32821: @2350333
     /* 2350333 */ GIM_Try, /*On fail goto*//*Label 32873*/ GIMT_Encode4(2350447),
     /* 2350338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2350341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2350344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350356 */   GIM_Try, /*On fail goto*//*Label 32874*/ GIMT_Encode4(2350401), // Rule ID 56768 //
     /* 2350361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2350364 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2350367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2350381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350400 */     // GIR_Coverage, 56768,
     /* 2350400 */     GIR_EraseRootFromParent_Done,
     /* 2350401 */   // Label 32874: @2350401
     /* 2350401 */   GIM_Try, /*On fail goto*//*Label 32875*/ GIMT_Encode4(2350446), // Rule ID 56769 //
     /* 2350406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2350409 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2350412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2350426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350445 */     // GIR_Coverage, 56769,
     /* 2350445 */     GIR_EraseRootFromParent_Done,
     /* 2350446 */   // Label 32875: @2350446
     /* 2350446 */   GIM_Reject,
     /* 2350447 */ // Label 32873: @2350447
     /* 2350447 */ GIM_Reject,
     /* 2350448 */ // Label 32822: @2350448
     /* 2350448 */ GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2350562),
     /* 2350453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2350456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2350459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350471 */   GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2350516), // Rule ID 56750 //
     /* 2350476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350479 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2350482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2350496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350515 */     // GIR_Coverage, 56750,
     /* 2350515 */     GIR_EraseRootFromParent_Done,
     /* 2350516 */   // Label 32877: @2350516
     /* 2350516 */   GIM_Try, /*On fail goto*//*Label 32878*/ GIMT_Encode4(2350561), // Rule ID 56751 //
     /* 2350521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350524 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2350527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2350541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350560 */     // GIR_Coverage, 56751,
     /* 2350560 */     GIR_EraseRootFromParent_Done,
     /* 2350561 */   // Label 32878: @2350561
     /* 2350561 */   GIM_Reject,
     /* 2350562 */ // Label 32876: @2350562
     /* 2350562 */ GIM_Reject,
     /* 2350563 */ // Label 32823: @2350563
     /* 2350563 */ GIM_Reject,
     /* 2350564 */ // Label 79: @2350564
     /* 2350564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32897*/ GIMT_Encode4(2352648),
     /* 2350575 */ /*GILLT_s16*//*Label 32879*/ GIMT_Encode4(2350695),
     /* 2350579 */ /*GILLT_s32*//*Label 32880*/ GIMT_Encode4(2350762),
     /* 2350583 */ /*GILLT_s64*//*Label 32881*/ GIMT_Encode4(2350829), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350595 */ /*GILLT_nxv1s16*//*Label 32882*/ GIMT_Encode4(2350923),
     /* 2350599 */ /*GILLT_nxv1s32*//*Label 32883*/ GIMT_Encode4(2351038),
     /* 2350603 */ /*GILLT_nxv1s64*//*Label 32884*/ GIMT_Encode4(2351153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350615 */ /*GILLT_nxv2s16*//*Label 32885*/ GIMT_Encode4(2351268),
     /* 2350619 */ /*GILLT_nxv2s32*//*Label 32886*/ GIMT_Encode4(2351383),
     /* 2350623 */ /*GILLT_nxv2s64*//*Label 32887*/ GIMT_Encode4(2351498), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350635 */ /*GILLT_nxv4s16*//*Label 32888*/ GIMT_Encode4(2351613),
     /* 2350639 */ /*GILLT_nxv4s32*//*Label 32889*/ GIMT_Encode4(2351728),
     /* 2350643 */ /*GILLT_nxv4s64*//*Label 32890*/ GIMT_Encode4(2351843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350655 */ /*GILLT_nxv8s16*//*Label 32891*/ GIMT_Encode4(2351958),
     /* 2350659 */ /*GILLT_nxv8s32*//*Label 32892*/ GIMT_Encode4(2352073),
     /* 2350663 */ /*GILLT_nxv8s64*//*Label 32893*/ GIMT_Encode4(2352188), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350675 */ /*GILLT_nxv16s16*//*Label 32894*/ GIMT_Encode4(2352303),
     /* 2350679 */ /*GILLT_nxv16s32*//*Label 32895*/ GIMT_Encode4(2352418), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2350691 */ /*GILLT_nxv32s16*//*Label 32896*/ GIMT_Encode4(2352533),
     /* 2350695 */ // Label 32879: @2350695
     /* 2350695 */ GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2350761),
     /* 2350700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2350703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350706 */   GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2350733), // Rule ID 2052 //
     /* 2350711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2350714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350726 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2350726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2350731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350732 */     // GIR_Coverage, 2052,
     /* 2350732 */     GIR_Done,
     /* 2350733 */   // Label 32899: @2350733
     /* 2350733 */   GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2350760), // Rule ID 2053 //
     /* 2350738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2350741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350753 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2350753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2350758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350759 */     // GIR_Coverage, 2053,
     /* 2350759 */     GIR_Done,
     /* 2350760 */   // Label 32900: @2350760
     /* 2350760 */   GIM_Reject,
     /* 2350761 */ // Label 32898: @2350761
     /* 2350761 */ GIM_Reject,
     /* 2350762 */ // Label 32880: @2350762
     /* 2350762 */ GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2350828),
     /* 2350767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2350770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350773 */   GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2350800), // Rule ID 1335 //
     /* 2350778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2350781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350793 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2350793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2350798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350799 */     // GIR_Coverage, 1335,
     /* 2350799 */     GIR_Done,
     /* 2350800 */   // Label 32902: @2350800
     /* 2350800 */   GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2350827), // Rule ID 1336 //
     /* 2350805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2350808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350820 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2350820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2350825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350826 */     // GIR_Coverage, 1336,
     /* 2350826 */     GIR_Done,
     /* 2350827 */   // Label 32903: @2350827
     /* 2350827 */   GIM_Reject,
     /* 2350828 */ // Label 32901: @2350828
     /* 2350828 */ GIM_Reject,
     /* 2350829 */ // Label 32881: @2350829
     /* 2350829 */ GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2350922),
     /* 2350834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350840 */   GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2350867), // Rule ID 1709 //
     /* 2350845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2350848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350860 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2350865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350866 */     // GIR_Coverage, 1709,
     /* 2350866 */     GIR_Done,
     /* 2350867 */   // Label 32905: @2350867
     /* 2350867 */   GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2350894), // Rule ID 1710 //
     /* 2350872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2350875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350887 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2350892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350893 */     // GIR_Coverage, 1710,
     /* 2350893 */     GIR_Done,
     /* 2350894 */   // Label 32906: @2350894
     /* 2350894 */   GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2350921), // Rule ID 1711 //
     /* 2350899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350914 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2350919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350920 */     // GIR_Coverage, 1711,
     /* 2350920 */     GIR_Done,
     /* 2350921 */   // Label 32907: @2350921
     /* 2350921 */   GIM_Reject,
     /* 2350922 */ // Label 32904: @2350922
     /* 2350922 */ GIM_Reject,
     /* 2350923 */ // Label 32882: @2350923
     /* 2350923 */ GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2351037),
     /* 2350928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2350931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2350934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2350946 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2350991), // Rule ID 56792 //
     /* 2350951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2350954 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2350957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2350971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350990 */     // GIR_Coverage, 56792,
     /* 2350990 */     GIR_EraseRootFromParent_Done,
     /* 2350991 */   // Label 32909: @2350991
     /* 2350991 */   GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2351036), // Rule ID 56793 //
     /* 2350996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2350999 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2351016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351035 */     // GIR_Coverage, 56793,
     /* 2351035 */     GIR_EraseRootFromParent_Done,
     /* 2351036 */   // Label 32910: @2351036
     /* 2351036 */   GIM_Reject,
     /* 2351037 */ // Label 32908: @2351037
     /* 2351037 */ GIM_Reject,
     /* 2351038 */ // Label 32883: @2351038
     /* 2351038 */ GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2351152),
     /* 2351043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2351049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351061 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2351106), // Rule ID 56804 //
     /* 2351066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351069 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2351086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351105 */     // GIR_Coverage, 56804,
     /* 2351105 */     GIR_EraseRootFromParent_Done,
     /* 2351106 */   // Label 32912: @2351106
     /* 2351106 */   GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2351151), // Rule ID 56805 //
     /* 2351111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351114 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2351131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351150 */     // GIR_Coverage, 56805,
     /* 2351150 */     GIR_EraseRootFromParent_Done,
     /* 2351151 */   // Label 32913: @2351151
     /* 2351151 */   GIM_Reject,
     /* 2351152 */ // Label 32911: @2351152
     /* 2351152 */ GIM_Reject,
     /* 2351153 */ // Label 32884: @2351153
     /* 2351153 */ GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2351267),
     /* 2351158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2351161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2351164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351176 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2351221), // Rule ID 56822 //
     /* 2351181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2351184 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2351201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351220 */     // GIR_Coverage, 56822,
     /* 2351220 */     GIR_EraseRootFromParent_Done,
     /* 2351221 */   // Label 32915: @2351221
     /* 2351221 */   GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2351266), // Rule ID 56823 //
     /* 2351226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2351229 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2351246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351265 */     // GIR_Coverage, 56823,
     /* 2351265 */     GIR_EraseRootFromParent_Done,
     /* 2351266 */   // Label 32916: @2351266
     /* 2351266 */   GIM_Reject,
     /* 2351267 */ // Label 32914: @2351267
     /* 2351267 */ GIM_Reject,
     /* 2351268 */ // Label 32885: @2351268
     /* 2351268 */ GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2351382),
     /* 2351273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2351276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2351279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351291 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2351336), // Rule ID 56798 //
     /* 2351296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351299 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2351316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351335 */     // GIR_Coverage, 56798,
     /* 2351335 */     GIR_EraseRootFromParent_Done,
     /* 2351336 */   // Label 32918: @2351336
     /* 2351336 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2351381), // Rule ID 56799 //
     /* 2351341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351344 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2351361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351380 */     // GIR_Coverage, 56799,
     /* 2351380 */     GIR_EraseRootFromParent_Done,
     /* 2351381 */   // Label 32919: @2351381
     /* 2351381 */   GIM_Reject,
     /* 2351382 */ // Label 32917: @2351382
     /* 2351382 */ GIM_Reject,
     /* 2351383 */ // Label 32886: @2351383
     /* 2351383 */ GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2351497),
     /* 2351388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2351391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2351394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351406 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2351451), // Rule ID 56816 //
     /* 2351411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351414 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2351417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2351431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351450 */     // GIR_Coverage, 56816,
     /* 2351450 */     GIR_EraseRootFromParent_Done,
     /* 2351451 */   // Label 32921: @2351451
     /* 2351451 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2351496), // Rule ID 56817 //
     /* 2351456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351459 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2351462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2351476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351495 */     // GIR_Coverage, 56817,
     /* 2351495 */     GIR_EraseRootFromParent_Done,
     /* 2351496 */   // Label 32922: @2351496
     /* 2351496 */   GIM_Reject,
     /* 2351497 */ // Label 32920: @2351497
     /* 2351497 */ GIM_Reject,
     /* 2351498 */ // Label 32887: @2351498
     /* 2351498 */ GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2351612),
     /* 2351503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2351506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2351509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351521 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2351566), // Rule ID 56864 //
     /* 2351526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2351529 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2351532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2351546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351565 */     // GIR_Coverage, 56864,
     /* 2351565 */     GIR_EraseRootFromParent_Done,
     /* 2351566 */   // Label 32924: @2351566
     /* 2351566 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2351611), // Rule ID 56865 //
     /* 2351571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2351574 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2351577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2351591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351610 */     // GIR_Coverage, 56865,
     /* 2351610 */     GIR_EraseRootFromParent_Done,
     /* 2351611 */   // Label 32925: @2351611
     /* 2351611 */   GIM_Reject,
     /* 2351612 */ // Label 32923: @2351612
     /* 2351612 */ GIM_Reject,
     /* 2351613 */ // Label 32888: @2351613
     /* 2351613 */ GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2351727),
     /* 2351618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2351621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2351624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351636 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2351681), // Rule ID 56810 //
     /* 2351641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351644 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2351647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2351661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351680 */     // GIR_Coverage, 56810,
     /* 2351680 */     GIR_EraseRootFromParent_Done,
     /* 2351681 */   // Label 32927: @2351681
     /* 2351681 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2351726), // Rule ID 56811 //
     /* 2351686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351689 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2351692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2351706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351725 */     // GIR_Coverage, 56811,
     /* 2351725 */     GIR_EraseRootFromParent_Done,
     /* 2351726 */   // Label 32928: @2351726
     /* 2351726 */   GIM_Reject,
     /* 2351727 */ // Label 32926: @2351727
     /* 2351727 */ GIM_Reject,
     /* 2351728 */ // Label 32889: @2351728
     /* 2351728 */ GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2351842),
     /* 2351733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2351736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2351739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351751 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2351796), // Rule ID 56846 //
     /* 2351756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351759 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2351762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2351776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351795 */     // GIR_Coverage, 56846,
     /* 2351795 */     GIR_EraseRootFromParent_Done,
     /* 2351796 */   // Label 32930: @2351796
     /* 2351796 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2351841), // Rule ID 56847 //
     /* 2351801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351804 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2351807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2351821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351840 */     // GIR_Coverage, 56847,
     /* 2351840 */     GIR_EraseRootFromParent_Done,
     /* 2351841 */   // Label 32931: @2351841
     /* 2351841 */   GIM_Reject,
     /* 2351842 */ // Label 32929: @2351842
     /* 2351842 */ GIM_Reject,
     /* 2351843 */ // Label 32890: @2351843
     /* 2351843 */ GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2351957),
     /* 2351848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2351851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2351854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2351866 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2351911), // Rule ID 56870 //
     /* 2351871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2351874 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2351891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351910 */     // GIR_Coverage, 56870,
     /* 2351910 */     GIR_EraseRootFromParent_Done,
     /* 2351911 */   // Label 32933: @2351911
     /* 2351911 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2351956), // Rule ID 56871 //
     /* 2351916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2351919 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2351922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2351936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351955 */     // GIR_Coverage, 56871,
     /* 2351955 */     GIR_EraseRootFromParent_Done,
     /* 2351956 */   // Label 32934: @2351956
     /* 2351956 */   GIM_Reject,
     /* 2351957 */ // Label 32932: @2351957
     /* 2351957 */ GIM_Reject,
     /* 2351958 */ // Label 32891: @2351958
     /* 2351958 */ GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2352072),
     /* 2351963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2351966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2351969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2351981 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2352026), // Rule ID 56828 //
     /* 2351986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351989 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2351992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2352006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352025 */     // GIR_Coverage, 56828,
     /* 2352025 */     GIR_EraseRootFromParent_Done,
     /* 2352026 */   // Label 32936: @2352026
     /* 2352026 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2352071), // Rule ID 56829 //
     /* 2352031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352034 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2352037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2352051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352070 */     // GIR_Coverage, 56829,
     /* 2352070 */     GIR_EraseRootFromParent_Done,
     /* 2352071 */   // Label 32937: @2352071
     /* 2352071 */   GIM_Reject,
     /* 2352072 */ // Label 32935: @2352072
     /* 2352072 */ GIM_Reject,
     /* 2352073 */ // Label 32892: @2352073
     /* 2352073 */ GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2352187),
     /* 2352078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2352084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352096 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2352141), // Rule ID 56852 //
     /* 2352101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352104 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2352107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2352121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352140 */     // GIR_Coverage, 56852,
     /* 2352140 */     GIR_EraseRootFromParent_Done,
     /* 2352141 */   // Label 32939: @2352141
     /* 2352141 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2352186), // Rule ID 56853 //
     /* 2352146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352149 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2352152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2352166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352185 */     // GIR_Coverage, 56853,
     /* 2352185 */     GIR_EraseRootFromParent_Done,
     /* 2352186 */   // Label 32940: @2352186
     /* 2352186 */   GIM_Reject,
     /* 2352187 */ // Label 32938: @2352187
     /* 2352187 */ GIM_Reject,
     /* 2352188 */ // Label 32893: @2352188
     /* 2352188 */ GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2352302),
     /* 2352193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2352196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2352199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352211 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2352256), // Rule ID 56876 //
     /* 2352216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352219 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2352236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352255 */     // GIR_Coverage, 56876,
     /* 2352255 */     GIR_EraseRootFromParent_Done,
     /* 2352256 */   // Label 32942: @2352256
     /* 2352256 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2352301), // Rule ID 56877 //
     /* 2352261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352264 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2352267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2352281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352300 */     // GIR_Coverage, 56877,
     /* 2352300 */     GIR_EraseRootFromParent_Done,
     /* 2352301 */   // Label 32943: @2352301
     /* 2352301 */   GIM_Reject,
     /* 2352302 */ // Label 32941: @2352302
     /* 2352302 */ GIM_Reject,
     /* 2352303 */ // Label 32894: @2352303
     /* 2352303 */ GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2352417),
     /* 2352308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2352311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2352314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352326 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2352371), // Rule ID 56834 //
     /* 2352331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352334 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2352351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352370 */     // GIR_Coverage, 56834,
     /* 2352370 */     GIR_EraseRootFromParent_Done,
     /* 2352371 */   // Label 32945: @2352371
     /* 2352371 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2352416), // Rule ID 56835 //
     /* 2352376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352379 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2352382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2352396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352415 */     // GIR_Coverage, 56835,
     /* 2352415 */     GIR_EraseRootFromParent_Done,
     /* 2352416 */   // Label 32946: @2352416
     /* 2352416 */   GIM_Reject,
     /* 2352417 */ // Label 32944: @2352417
     /* 2352417 */ GIM_Reject,
     /* 2352418 */ // Label 32895: @2352418
     /* 2352418 */ GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2352532),
     /* 2352423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2352426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2352429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352441 */   GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2352486), // Rule ID 56858 //
     /* 2352446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352449 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2352466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352485 */     // GIR_Coverage, 56858,
     /* 2352485 */     GIR_EraseRootFromParent_Done,
     /* 2352486 */   // Label 32948: @2352486
     /* 2352486 */   GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2352531), // Rule ID 56859 //
     /* 2352491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352494 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2352497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2352511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352530 */     // GIR_Coverage, 56859,
     /* 2352530 */     GIR_EraseRootFromParent_Done,
     /* 2352531 */   // Label 32949: @2352531
     /* 2352531 */   GIM_Reject,
     /* 2352532 */ // Label 32947: @2352532
     /* 2352532 */ GIM_Reject,
     /* 2352533 */ // Label 32896: @2352533
     /* 2352533 */ GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2352647),
     /* 2352538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2352541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2352544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2352556 */   GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2352601), // Rule ID 56840 //
     /* 2352561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352564 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2352581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352600 */     // GIR_Coverage, 56840,
     /* 2352600 */     GIR_EraseRootFromParent_Done,
     /* 2352601 */   // Label 32951: @2352601
     /* 2352601 */   GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2352646), // Rule ID 56841 //
     /* 2352606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352609 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2352612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2352626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352645 */     // GIR_Coverage, 56841,
     /* 2352645 */     GIR_EraseRootFromParent_Done,
     /* 2352646 */   // Label 32952: @2352646
     /* 2352646 */   GIM_Reject,
     /* 2352647 */ // Label 32950: @2352647
     /* 2352647 */ GIM_Reject,
     /* 2352648 */ // Label 32897: @2352648
     /* 2352648 */ GIM_Reject,
     /* 2352649 */ // Label 80: @2352649
     /* 2352649 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32977*/ GIMT_Encode4(2355424),
     /* 2352660 */ /*GILLT_s32*//*Label 32953*/ GIMT_Encode4(2352784),
     /* 2352664 */ /*GILLT_s64*//*Label 32954*/ GIMT_Encode4(2352839), GIMT_Encode4(0),
     /* 2352672 */ /*GILLT_nxv1s8*//*Label 32955*/ GIMT_Encode4(2352894),
     /* 2352676 */ /*GILLT_nxv1s16*//*Label 32956*/ GIMT_Encode4(2353009),
     /* 2352680 */ /*GILLT_nxv1s32*//*Label 32957*/ GIMT_Encode4(2353124),
     /* 2352684 */ /*GILLT_nxv1s64*//*Label 32958*/ GIMT_Encode4(2353239), GIMT_Encode4(0),
     /* 2352692 */ /*GILLT_nxv2s8*//*Label 32959*/ GIMT_Encode4(2353354),
     /* 2352696 */ /*GILLT_nxv2s16*//*Label 32960*/ GIMT_Encode4(2353469),
     /* 2352700 */ /*GILLT_nxv2s32*//*Label 32961*/ GIMT_Encode4(2353584),
     /* 2352704 */ /*GILLT_nxv2s64*//*Label 32962*/ GIMT_Encode4(2353699), GIMT_Encode4(0),
     /* 2352712 */ /*GILLT_nxv4s8*//*Label 32963*/ GIMT_Encode4(2353814),
     /* 2352716 */ /*GILLT_nxv4s16*//*Label 32964*/ GIMT_Encode4(2353929),
     /* 2352720 */ /*GILLT_nxv4s32*//*Label 32965*/ GIMT_Encode4(2354044),
     /* 2352724 */ /*GILLT_nxv4s64*//*Label 32966*/ GIMT_Encode4(2354159), GIMT_Encode4(0),
     /* 2352732 */ /*GILLT_nxv8s8*//*Label 32967*/ GIMT_Encode4(2354274),
     /* 2352736 */ /*GILLT_nxv8s16*//*Label 32968*/ GIMT_Encode4(2354389),
     /* 2352740 */ /*GILLT_nxv8s32*//*Label 32969*/ GIMT_Encode4(2354504),
     /* 2352744 */ /*GILLT_nxv8s64*//*Label 32970*/ GIMT_Encode4(2354619), GIMT_Encode4(0),
     /* 2352752 */ /*GILLT_nxv16s8*//*Label 32971*/ GIMT_Encode4(2354734),
     /* 2352756 */ /*GILLT_nxv16s16*//*Label 32972*/ GIMT_Encode4(2354849),
     /* 2352760 */ /*GILLT_nxv16s32*//*Label 32973*/ GIMT_Encode4(2354964), GIMT_Encode4(0),
     /* 2352768 */ /*GILLT_nxv32s8*//*Label 32974*/ GIMT_Encode4(2355079),
     /* 2352772 */ /*GILLT_nxv32s16*//*Label 32975*/ GIMT_Encode4(2355194), GIMT_Encode4(0),
     /* 2352780 */ /*GILLT_nxv64s8*//*Label 32976*/ GIMT_Encode4(2355309),
     /* 2352784 */ // Label 32953: @2352784
     /* 2352784 */ GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2352838),
     /* 2352789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2352792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2352795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352807 */   GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2352822), // Rule ID 64454 //
     /* 2352812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2352815 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2352815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2352820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352821 */     // GIR_Coverage, 64454,
     /* 2352821 */     GIR_Done,
     /* 2352822 */   // Label 32979: @2352822
     /* 2352822 */   GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2352837), // Rule ID 2521 //
     /* 2352827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2352830 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2352830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2352835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352836 */     // GIR_Coverage, 2521,
     /* 2352836 */     GIR_Done,
     /* 2352837 */   // Label 32980: @2352837
     /* 2352837 */   GIM_Reject,
     /* 2352838 */ // Label 32978: @2352838
     /* 2352838 */ GIM_Reject,
     /* 2352839 */ // Label 32954: @2352839
     /* 2352839 */ GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2352893),
     /* 2352844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2352847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2352850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2352862 */   GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2352877), // Rule ID 64453 //
     /* 2352867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2352870 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2352870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2352875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352876 */     // GIR_Coverage, 64453,
     /* 2352876 */     GIR_Done,
     /* 2352877 */   // Label 32982: @2352877
     /* 2352877 */   GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2352892), // Rule ID 2520 //
     /* 2352882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2352885 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2352885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2352890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352891 */     // GIR_Coverage, 2520,
     /* 2352891 */     GIR_Done,
     /* 2352892 */   // Label 32983: @2352892
     /* 2352892 */   GIM_Reject,
     /* 2352893 */ // Label 32981: @2352893
     /* 2352893 */ GIM_Reject,
     /* 2352894 */ // Label 32955: @2352894
     /* 2352894 */ GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2353008),
     /* 2352899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2352902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2352905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352917 */   GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2352962), // Rule ID 50584 //
     /* 2352922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352925 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2352928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2352942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352961 */     // GIR_Coverage, 50584,
     /* 2352961 */     GIR_EraseRootFromParent_Done,
     /* 2352962 */   // Label 32985: @2352962
     /* 2352962 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2353007), // Rule ID 50585 //
     /* 2352967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352970 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2352973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2352987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353006 */     // GIR_Coverage, 50585,
     /* 2353006 */     GIR_EraseRootFromParent_Done,
     /* 2353007 */   // Label 32986: @2353007
     /* 2353007 */   GIM_Reject,
     /* 2353008 */ // Label 32984: @2353008
     /* 2353008 */ GIM_Reject,
     /* 2353009 */ // Label 32956: @2353009
     /* 2353009 */ GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2353123),
     /* 2353014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2353017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2353020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353032 */   GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2353077), // Rule ID 50596 //
     /* 2353037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353040 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2353057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353076 */     // GIR_Coverage, 50596,
     /* 2353076 */     GIR_EraseRootFromParent_Done,
     /* 2353077 */   // Label 32988: @2353077
     /* 2353077 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2353122), // Rule ID 50597 //
     /* 2353082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353085 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2353088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2353102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353121 */     // GIR_Coverage, 50597,
     /* 2353121 */     GIR_EraseRootFromParent_Done,
     /* 2353122 */   // Label 32989: @2353122
     /* 2353122 */   GIM_Reject,
     /* 2353123 */ // Label 32987: @2353123
     /* 2353123 */ GIM_Reject,
     /* 2353124 */ // Label 32957: @2353124
     /* 2353124 */ GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2353238),
     /* 2353129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2353132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2353135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353147 */   GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2353192), // Rule ID 50604 //
     /* 2353152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353155 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353191 */     // GIR_Coverage, 50604,
     /* 2353191 */     GIR_EraseRootFromParent_Done,
     /* 2353192 */   // Label 32991: @2353192
     /* 2353192 */   GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2353237), // Rule ID 50605 //
     /* 2353197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353200 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2353203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353236 */     // GIR_Coverage, 50605,
     /* 2353236 */     GIR_EraseRootFromParent_Done,
     /* 2353237 */   // Label 32992: @2353237
     /* 2353237 */   GIM_Reject,
     /* 2353238 */ // Label 32990: @2353238
     /* 2353238 */ GIM_Reject,
     /* 2353239 */ // Label 32958: @2353239
     /* 2353239 */ GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2353353),
     /* 2353244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2353247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2353250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353262 */   GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2353307), // Rule ID 50620 //
     /* 2353267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2353270 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2353287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353306 */     // GIR_Coverage, 50620,
     /* 2353306 */     GIR_EraseRootFromParent_Done,
     /* 2353307 */   // Label 32994: @2353307
     /* 2353307 */   GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2353352), // Rule ID 50621 //
     /* 2353312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2353315 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2353318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2353332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353351 */     // GIR_Coverage, 50621,
     /* 2353351 */     GIR_EraseRootFromParent_Done,
     /* 2353352 */   // Label 32995: @2353352
     /* 2353352 */   GIM_Reject,
     /* 2353353 */ // Label 32993: @2353353
     /* 2353353 */ GIM_Reject,
     /* 2353354 */ // Label 32959: @2353354
     /* 2353354 */ GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2353468),
     /* 2353359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2353362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2353365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353377 */   GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2353422), // Rule ID 50588 //
     /* 2353382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353385 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2353388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2353402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353421 */     // GIR_Coverage, 50588,
     /* 2353421 */     GIR_EraseRootFromParent_Done,
     /* 2353422 */   // Label 32997: @2353422
     /* 2353422 */   GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2353467), // Rule ID 50589 //
     /* 2353427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353430 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2353433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2353447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353466 */     // GIR_Coverage, 50589,
     /* 2353466 */     GIR_EraseRootFromParent_Done,
     /* 2353467 */   // Label 32998: @2353467
     /* 2353467 */   GIM_Reject,
     /* 2353468 */ // Label 32996: @2353468
     /* 2353468 */ GIM_Reject,
     /* 2353469 */ // Label 32960: @2353469
     /* 2353469 */ GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2353583),
     /* 2353474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2353477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2353480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353492 */   GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2353537), // Rule ID 50600 //
     /* 2353497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353500 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353536 */     // GIR_Coverage, 50600,
     /* 2353536 */     GIR_EraseRootFromParent_Done,
     /* 2353537 */   // Label 33000: @2353537
     /* 2353537 */   GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2353582), // Rule ID 50601 //
     /* 2353542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353545 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2353548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353581 */     // GIR_Coverage, 50601,
     /* 2353581 */     GIR_EraseRootFromParent_Done,
     /* 2353582 */   // Label 33001: @2353582
     /* 2353582 */   GIM_Reject,
     /* 2353583 */ // Label 32999: @2353583
     /* 2353583 */ GIM_Reject,
     /* 2353584 */ // Label 32961: @2353584
     /* 2353584 */ GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2353698),
     /* 2353589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2353592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2353595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353607 */   GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2353652), // Rule ID 50616 //
     /* 2353612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353615 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2353632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353651 */     // GIR_Coverage, 50616,
     /* 2353651 */     GIR_EraseRootFromParent_Done,
     /* 2353652 */   // Label 33003: @2353652
     /* 2353652 */   GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2353697), // Rule ID 50617 //
     /* 2353657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353660 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2353663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2353677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353696 */     // GIR_Coverage, 50617,
     /* 2353696 */     GIR_EraseRootFromParent_Done,
     /* 2353697 */   // Label 33004: @2353697
     /* 2353697 */   GIM_Reject,
     /* 2353698 */ // Label 33002: @2353698
     /* 2353698 */ GIM_Reject,
     /* 2353699 */ // Label 32962: @2353699
     /* 2353699 */ GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2353813),
     /* 2353704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2353707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2353710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353722 */   GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2353767), // Rule ID 50660 //
     /* 2353727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2353730 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2353747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353766 */     // GIR_Coverage, 50660,
     /* 2353766 */     GIR_EraseRootFromParent_Done,
     /* 2353767 */   // Label 33006: @2353767
     /* 2353767 */   GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2353812), // Rule ID 50661 //
     /* 2353772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2353775 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2353778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2353792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353811 */     // GIR_Coverage, 50661,
     /* 2353811 */     GIR_EraseRootFromParent_Done,
     /* 2353812 */   // Label 33007: @2353812
     /* 2353812 */   GIM_Reject,
     /* 2353813 */ // Label 33005: @2353813
     /* 2353813 */ GIM_Reject,
     /* 2353814 */ // Label 32963: @2353814
     /* 2353814 */ GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2353928),
     /* 2353819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2353822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2353825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353837 */   GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2353882), // Rule ID 50592 //
     /* 2353842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353845 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2353848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353881 */     // GIR_Coverage, 50592,
     /* 2353881 */     GIR_EraseRootFromParent_Done,
     /* 2353882 */   // Label 33009: @2353882
     /* 2353882 */   GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2353927), // Rule ID 50593 //
     /* 2353887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353890 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2353893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2353907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353926 */     // GIR_Coverage, 50593,
     /* 2353926 */     GIR_EraseRootFromParent_Done,
     /* 2353927 */   // Label 33010: @2353927
     /* 2353927 */   GIM_Reject,
     /* 2353928 */ // Label 33008: @2353928
     /* 2353928 */ GIM_Reject,
     /* 2353929 */ // Label 32964: @2353929
     /* 2353929 */ GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2354043),
     /* 2353934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2353937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2353940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2353952 */   GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2353997), // Rule ID 50612 //
     /* 2353957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353960 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2353963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2353977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353996 */     // GIR_Coverage, 50612,
     /* 2353996 */     GIR_EraseRootFromParent_Done,
     /* 2353997 */   // Label 33012: @2353997
     /* 2353997 */   GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2354042), // Rule ID 50613 //
     /* 2354002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354005 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2354008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2354022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354041 */     // GIR_Coverage, 50613,
     /* 2354041 */     GIR_EraseRootFromParent_Done,
     /* 2354042 */   // Label 33013: @2354042
     /* 2354042 */   GIM_Reject,
     /* 2354043 */ // Label 33011: @2354043
     /* 2354043 */ GIM_Reject,
     /* 2354044 */ // Label 32965: @2354044
     /* 2354044 */ GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2354158),
     /* 2354049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2354052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2354055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354067 */   GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2354112), // Rule ID 50648 //
     /* 2354072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354075 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354111 */     // GIR_Coverage, 50648,
     /* 2354111 */     GIR_EraseRootFromParent_Done,
     /* 2354112 */   // Label 33015: @2354112
     /* 2354112 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2354157), // Rule ID 50649 //
     /* 2354117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354120 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2354123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354156 */     // GIR_Coverage, 50649,
     /* 2354156 */     GIR_EraseRootFromParent_Done,
     /* 2354157 */   // Label 33016: @2354157
     /* 2354157 */   GIM_Reject,
     /* 2354158 */ // Label 33014: @2354158
     /* 2354158 */ GIM_Reject,
     /* 2354159 */ // Label 32966: @2354159
     /* 2354159 */ GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2354273),
     /* 2354164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2354167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2354170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354182 */   GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2354227), // Rule ID 50664 //
     /* 2354187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2354190 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354226 */     // GIR_Coverage, 50664,
     /* 2354226 */     GIR_EraseRootFromParent_Done,
     /* 2354227 */   // Label 33018: @2354227
     /* 2354227 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2354272), // Rule ID 50665 //
     /* 2354232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2354235 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2354238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354271 */     // GIR_Coverage, 50665,
     /* 2354271 */     GIR_EraseRootFromParent_Done,
     /* 2354272 */   // Label 33019: @2354272
     /* 2354272 */   GIM_Reject,
     /* 2354273 */ // Label 33017: @2354273
     /* 2354273 */ GIM_Reject,
     /* 2354274 */ // Label 32967: @2354274
     /* 2354274 */ GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2354388),
     /* 2354279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2354282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2354285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354297 */   GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2354342), // Rule ID 50608 //
     /* 2354302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354305 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2354308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2354322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354341 */     // GIR_Coverage, 50608,
     /* 2354341 */     GIR_EraseRootFromParent_Done,
     /* 2354342 */   // Label 33021: @2354342
     /* 2354342 */   GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2354387), // Rule ID 50609 //
     /* 2354347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354350 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2354353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2354367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354386 */     // GIR_Coverage, 50609,
     /* 2354386 */     GIR_EraseRootFromParent_Done,
     /* 2354387 */   // Label 33022: @2354387
     /* 2354387 */   GIM_Reject,
     /* 2354388 */ // Label 33020: @2354388
     /* 2354388 */ GIM_Reject,
     /* 2354389 */ // Label 32968: @2354389
     /* 2354389 */ GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2354503),
     /* 2354394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2354397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2354400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354412 */   GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2354457), // Rule ID 50636 //
     /* 2354417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354420 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354456 */     // GIR_Coverage, 50636,
     /* 2354456 */     GIR_EraseRootFromParent_Done,
     /* 2354457 */   // Label 33024: @2354457
     /* 2354457 */   GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2354502), // Rule ID 50637 //
     /* 2354462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354465 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2354468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354501 */     // GIR_Coverage, 50637,
     /* 2354501 */     GIR_EraseRootFromParent_Done,
     /* 2354502 */   // Label 33025: @2354502
     /* 2354502 */   GIM_Reject,
     /* 2354503 */ // Label 33023: @2354503
     /* 2354503 */ GIM_Reject,
     /* 2354504 */ // Label 32969: @2354504
     /* 2354504 */ GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2354618),
     /* 2354509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2354512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2354515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354527 */   GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2354572), // Rule ID 50652 //
     /* 2354532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354535 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354571 */     // GIR_Coverage, 50652,
     /* 2354571 */     GIR_EraseRootFromParent_Done,
     /* 2354572 */   // Label 33027: @2354572
     /* 2354572 */   GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2354617), // Rule ID 50653 //
     /* 2354577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354580 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2354583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354616 */     // GIR_Coverage, 50653,
     /* 2354616 */     GIR_EraseRootFromParent_Done,
     /* 2354617 */   // Label 33028: @2354617
     /* 2354617 */   GIM_Reject,
     /* 2354618 */ // Label 33026: @2354618
     /* 2354618 */ GIM_Reject,
     /* 2354619 */ // Label 32970: @2354619
     /* 2354619 */ GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2354733),
     /* 2354624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2354627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2354630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354642 */   GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2354687), // Rule ID 50668 //
     /* 2354647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2354650 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2354667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354686 */     // GIR_Coverage, 50668,
     /* 2354686 */     GIR_EraseRootFromParent_Done,
     /* 2354687 */   // Label 33030: @2354687
     /* 2354687 */   GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2354732), // Rule ID 50669 //
     /* 2354692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2354695 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2354712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354731 */     // GIR_Coverage, 50669,
     /* 2354731 */     GIR_EraseRootFromParent_Done,
     /* 2354732 */   // Label 33031: @2354732
     /* 2354732 */   GIM_Reject,
     /* 2354733 */ // Label 33029: @2354733
     /* 2354733 */ GIM_Reject,
     /* 2354734 */ // Label 32971: @2354734
     /* 2354734 */ GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2354848),
     /* 2354739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2354742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2354745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354757 */   GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2354802), // Rule ID 50624 //
     /* 2354762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354765 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2354768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354801 */     // GIR_Coverage, 50624,
     /* 2354801 */     GIR_EraseRootFromParent_Done,
     /* 2354802 */   // Label 33033: @2354802
     /* 2354802 */   GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2354847), // Rule ID 50625 //
     /* 2354807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354810 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2354813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2354827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354846 */     // GIR_Coverage, 50625,
     /* 2354846 */     GIR_EraseRootFromParent_Done,
     /* 2354847 */   // Label 33034: @2354847
     /* 2354847 */   GIM_Reject,
     /* 2354848 */ // Label 33032: @2354848
     /* 2354848 */ GIM_Reject,
     /* 2354849 */ // Label 32972: @2354849
     /* 2354849 */ GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2354963),
     /* 2354854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2354860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354872 */   GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2354917), // Rule ID 50640 //
     /* 2354877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354880 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354916 */     // GIR_Coverage, 50640,
     /* 2354916 */     GIR_EraseRootFromParent_Done,
     /* 2354917 */   // Label 33036: @2354917
     /* 2354917 */   GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2354962), // Rule ID 50641 //
     /* 2354922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354925 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2354942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354961 */     // GIR_Coverage, 50641,
     /* 2354961 */     GIR_EraseRootFromParent_Done,
     /* 2354962 */   // Label 33037: @2354962
     /* 2354962 */   GIM_Reject,
     /* 2354963 */ // Label 33035: @2354963
     /* 2354963 */ GIM_Reject,
     /* 2354964 */ // Label 32973: @2354964
     /* 2354964 */ GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2355078),
     /* 2354969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2354975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354987 */   GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2355032), // Rule ID 50656 //
     /* 2354992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354995 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355031 */     // GIR_Coverage, 50656,
     /* 2355031 */     GIR_EraseRootFromParent_Done,
     /* 2355032 */   // Label 33039: @2355032
     /* 2355032 */   GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2355077), // Rule ID 50657 //
     /* 2355037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355040 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2355043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355076 */     // GIR_Coverage, 50657,
     /* 2355076 */     GIR_EraseRootFromParent_Done,
     /* 2355077 */   // Label 33040: @2355077
     /* 2355077 */   GIM_Reject,
     /* 2355078 */ // Label 33038: @2355078
     /* 2355078 */ GIM_Reject,
     /* 2355079 */ // Label 32974: @2355079
     /* 2355079 */ GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2355193),
     /* 2355084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2355087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2355090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355102 */   GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2355147), // Rule ID 50628 //
     /* 2355107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355110 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2355113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2355127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355146 */     // GIR_Coverage, 50628,
     /* 2355146 */     GIR_EraseRootFromParent_Done,
     /* 2355147 */   // Label 33042: @2355147
     /* 2355147 */   GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2355192), // Rule ID 50629 //
     /* 2355152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355155 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2355158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2355172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355191 */     // GIR_Coverage, 50629,
     /* 2355191 */     GIR_EraseRootFromParent_Done,
     /* 2355192 */   // Label 33043: @2355192
     /* 2355192 */   GIM_Reject,
     /* 2355193 */ // Label 33041: @2355193
     /* 2355193 */ GIM_Reject,
     /* 2355194 */ // Label 32975: @2355194
     /* 2355194 */ GIM_Try, /*On fail goto*//*Label 33044*/ GIMT_Encode4(2355308),
     /* 2355199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2355202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2355205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355217 */   GIM_Try, /*On fail goto*//*Label 33045*/ GIMT_Encode4(2355262), // Rule ID 50644 //
     /* 2355222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355225 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355261 */     // GIR_Coverage, 50644,
     /* 2355261 */     GIR_EraseRootFromParent_Done,
     /* 2355262 */   // Label 33045: @2355262
     /* 2355262 */   GIM_Try, /*On fail goto*//*Label 33046*/ GIMT_Encode4(2355307), // Rule ID 50645 //
     /* 2355267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355270 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2355273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355306 */     // GIR_Coverage, 50645,
     /* 2355306 */     GIR_EraseRootFromParent_Done,
     /* 2355307 */   // Label 33046: @2355307
     /* 2355307 */   GIM_Reject,
     /* 2355308 */ // Label 33044: @2355308
     /* 2355308 */ GIM_Reject,
     /* 2355309 */ // Label 32976: @2355309
     /* 2355309 */ GIM_Try, /*On fail goto*//*Label 33047*/ GIMT_Encode4(2355423),
     /* 2355314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2355317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2355320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355332 */   GIM_Try, /*On fail goto*//*Label 33048*/ GIMT_Encode4(2355377), // Rule ID 50632 //
     /* 2355337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355340 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2355343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355376 */     // GIR_Coverage, 50632,
     /* 2355376 */     GIR_EraseRootFromParent_Done,
     /* 2355377 */   // Label 33048: @2355377
     /* 2355377 */   GIM_Try, /*On fail goto*//*Label 33049*/ GIMT_Encode4(2355422), // Rule ID 50633 //
     /* 2355382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355385 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2355388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2355402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355421 */     // GIR_Coverage, 50633,
     /* 2355421 */     GIR_EraseRootFromParent_Done,
     /* 2355422 */   // Label 33049: @2355422
     /* 2355422 */   GIM_Reject,
     /* 2355423 */ // Label 33047: @2355423
     /* 2355423 */ GIM_Reject,
     /* 2355424 */ // Label 32977: @2355424
     /* 2355424 */ GIM_Reject,
     /* 2355425 */ // Label 81: @2355425
     /* 2355425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33074*/ GIMT_Encode4(2358200),
     /* 2355436 */ /*GILLT_s32*//*Label 33050*/ GIMT_Encode4(2355560),
     /* 2355440 */ /*GILLT_s64*//*Label 33051*/ GIMT_Encode4(2355615), GIMT_Encode4(0),
     /* 2355448 */ /*GILLT_nxv1s8*//*Label 33052*/ GIMT_Encode4(2355670),
     /* 2355452 */ /*GILLT_nxv1s16*//*Label 33053*/ GIMT_Encode4(2355785),
     /* 2355456 */ /*GILLT_nxv1s32*//*Label 33054*/ GIMT_Encode4(2355900),
     /* 2355460 */ /*GILLT_nxv1s64*//*Label 33055*/ GIMT_Encode4(2356015), GIMT_Encode4(0),
     /* 2355468 */ /*GILLT_nxv2s8*//*Label 33056*/ GIMT_Encode4(2356130),
     /* 2355472 */ /*GILLT_nxv2s16*//*Label 33057*/ GIMT_Encode4(2356245),
     /* 2355476 */ /*GILLT_nxv2s32*//*Label 33058*/ GIMT_Encode4(2356360),
     /* 2355480 */ /*GILLT_nxv2s64*//*Label 33059*/ GIMT_Encode4(2356475), GIMT_Encode4(0),
     /* 2355488 */ /*GILLT_nxv4s8*//*Label 33060*/ GIMT_Encode4(2356590),
     /* 2355492 */ /*GILLT_nxv4s16*//*Label 33061*/ GIMT_Encode4(2356705),
     /* 2355496 */ /*GILLT_nxv4s32*//*Label 33062*/ GIMT_Encode4(2356820),
     /* 2355500 */ /*GILLT_nxv4s64*//*Label 33063*/ GIMT_Encode4(2356935), GIMT_Encode4(0),
     /* 2355508 */ /*GILLT_nxv8s8*//*Label 33064*/ GIMT_Encode4(2357050),
     /* 2355512 */ /*GILLT_nxv8s16*//*Label 33065*/ GIMT_Encode4(2357165),
     /* 2355516 */ /*GILLT_nxv8s32*//*Label 33066*/ GIMT_Encode4(2357280),
     /* 2355520 */ /*GILLT_nxv8s64*//*Label 33067*/ GIMT_Encode4(2357395), GIMT_Encode4(0),
     /* 2355528 */ /*GILLT_nxv16s8*//*Label 33068*/ GIMT_Encode4(2357510),
     /* 2355532 */ /*GILLT_nxv16s16*//*Label 33069*/ GIMT_Encode4(2357625),
     /* 2355536 */ /*GILLT_nxv16s32*//*Label 33070*/ GIMT_Encode4(2357740), GIMT_Encode4(0),
     /* 2355544 */ /*GILLT_nxv32s8*//*Label 33071*/ GIMT_Encode4(2357855),
     /* 2355548 */ /*GILLT_nxv32s16*//*Label 33072*/ GIMT_Encode4(2357970), GIMT_Encode4(0),
     /* 2355556 */ /*GILLT_nxv64s8*//*Label 33073*/ GIMT_Encode4(2358085),
     /* 2355560 */ // Label 33050: @2355560
     /* 2355560 */ GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2355614),
     /* 2355565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355583 */   GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2355598), // Rule ID 64458 //
     /* 2355588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2355591 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2355591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2355596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355597 */     // GIR_Coverage, 64458,
     /* 2355597 */     GIR_Done,
     /* 2355598 */   // Label 33076: @2355598
     /* 2355598 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2355613), // Rule ID 2523 //
     /* 2355603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2355606 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2355606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2355611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355612 */     // GIR_Coverage, 2523,
     /* 2355612 */     GIR_Done,
     /* 2355613 */   // Label 33077: @2355613
     /* 2355613 */   GIM_Reject,
     /* 2355614 */ // Label 33075: @2355614
     /* 2355614 */ GIM_Reject,
     /* 2355615 */ // Label 33051: @2355615
     /* 2355615 */ GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2355669),
     /* 2355620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2355623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355638 */   GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2355653), // Rule ID 64457 //
     /* 2355643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2355646 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2355646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2355651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355652 */     // GIR_Coverage, 64457,
     /* 2355652 */     GIR_Done,
     /* 2355653 */   // Label 33079: @2355653
     /* 2355653 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2355668), // Rule ID 2522 //
     /* 2355658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2355661 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2355661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2355666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355667 */     // GIR_Coverage, 2522,
     /* 2355667 */     GIR_Done,
     /* 2355668 */   // Label 33080: @2355668
     /* 2355668 */   GIM_Reject,
     /* 2355669 */ // Label 33078: @2355669
     /* 2355669 */ GIM_Reject,
     /* 2355670 */ // Label 33052: @2355670
     /* 2355670 */ GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2355784),
     /* 2355675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2355678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2355681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355693 */   GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2355738), // Rule ID 50760 //
     /* 2355698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355701 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2355704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2355718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355737 */     // GIR_Coverage, 50760,
     /* 2355737 */     GIR_EraseRootFromParent_Done,
     /* 2355738 */   // Label 33082: @2355738
     /* 2355738 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2355783), // Rule ID 50761 //
     /* 2355743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355746 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2355749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2355763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355782 */     // GIR_Coverage, 50761,
     /* 2355782 */     GIR_EraseRootFromParent_Done,
     /* 2355783 */   // Label 33083: @2355783
     /* 2355783 */   GIM_Reject,
     /* 2355784 */ // Label 33081: @2355784
     /* 2355784 */ GIM_Reject,
     /* 2355785 */ // Label 33053: @2355785
     /* 2355785 */ GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2355899),
     /* 2355790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2355793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2355796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355808 */   GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2355853), // Rule ID 50772 //
     /* 2355813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355816 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2355833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355852 */     // GIR_Coverage, 50772,
     /* 2355852 */     GIR_EraseRootFromParent_Done,
     /* 2355853 */   // Label 33085: @2355853
     /* 2355853 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2355898), // Rule ID 50773 //
     /* 2355858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355861 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2355878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355897 */     // GIR_Coverage, 50773,
     /* 2355897 */     GIR_EraseRootFromParent_Done,
     /* 2355898 */   // Label 33086: @2355898
     /* 2355898 */   GIM_Reject,
     /* 2355899 */ // Label 33084: @2355899
     /* 2355899 */ GIM_Reject,
     /* 2355900 */ // Label 33054: @2355900
     /* 2355900 */ GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2356014),
     /* 2355905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2355908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2355911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355923 */   GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2355968), // Rule ID 50780 //
     /* 2355928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355931 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2355934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2355948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355967 */     // GIR_Coverage, 50780,
     /* 2355967 */     GIR_EraseRootFromParent_Done,
     /* 2355968 */   // Label 33088: @2355968
     /* 2355968 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2356013), // Rule ID 50781 //
     /* 2355973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355976 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2355979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2355993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356012 */     // GIR_Coverage, 50781,
     /* 2356012 */     GIR_EraseRootFromParent_Done,
     /* 2356013 */   // Label 33089: @2356013
     /* 2356013 */   GIM_Reject,
     /* 2356014 */ // Label 33087: @2356014
     /* 2356014 */ GIM_Reject,
     /* 2356015 */ // Label 33055: @2356015
     /* 2356015 */ GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2356129),
     /* 2356020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2356023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2356026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356038 */   GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2356083), // Rule ID 50796 //
     /* 2356043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2356046 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2356049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356082 */     // GIR_Coverage, 50796,
     /* 2356082 */     GIR_EraseRootFromParent_Done,
     /* 2356083 */   // Label 33091: @2356083
     /* 2356083 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2356128), // Rule ID 50797 //
     /* 2356088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2356091 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2356094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356127 */     // GIR_Coverage, 50797,
     /* 2356127 */     GIR_EraseRootFromParent_Done,
     /* 2356128 */   // Label 33092: @2356128
     /* 2356128 */   GIM_Reject,
     /* 2356129 */ // Label 33090: @2356129
     /* 2356129 */ GIM_Reject,
     /* 2356130 */ // Label 33056: @2356130
     /* 2356130 */ GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2356244),
     /* 2356135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2356138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2356141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356153 */   GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2356198), // Rule ID 50764 //
     /* 2356158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356161 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2356164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2356178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356197 */     // GIR_Coverage, 50764,
     /* 2356197 */     GIR_EraseRootFromParent_Done,
     /* 2356198 */   // Label 33094: @2356198
     /* 2356198 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2356243), // Rule ID 50765 //
     /* 2356203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356206 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2356209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2356223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356242 */     // GIR_Coverage, 50765,
     /* 2356242 */     GIR_EraseRootFromParent_Done,
     /* 2356243 */   // Label 33095: @2356243
     /* 2356243 */   GIM_Reject,
     /* 2356244 */ // Label 33093: @2356244
     /* 2356244 */ GIM_Reject,
     /* 2356245 */ // Label 33057: @2356245
     /* 2356245 */ GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2356359),
     /* 2356250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2356253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2356256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356268 */   GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2356313), // Rule ID 50776 //
     /* 2356273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356276 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2356279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2356293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356312 */     // GIR_Coverage, 50776,
     /* 2356312 */     GIR_EraseRootFromParent_Done,
     /* 2356313 */   // Label 33097: @2356313
     /* 2356313 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2356358), // Rule ID 50777 //
     /* 2356318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356321 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2356324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2356338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356357 */     // GIR_Coverage, 50777,
     /* 2356357 */     GIR_EraseRootFromParent_Done,
     /* 2356358 */   // Label 33098: @2356358
     /* 2356358 */   GIM_Reject,
     /* 2356359 */ // Label 33096: @2356359
     /* 2356359 */ GIM_Reject,
     /* 2356360 */ // Label 33058: @2356360
     /* 2356360 */ GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2356474),
     /* 2356365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2356368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2356371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356383 */   GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2356428), // Rule ID 50792 //
     /* 2356388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356391 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2356394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356427 */     // GIR_Coverage, 50792,
     /* 2356427 */     GIR_EraseRootFromParent_Done,
     /* 2356428 */   // Label 33100: @2356428
     /* 2356428 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2356473), // Rule ID 50793 //
     /* 2356433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356436 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2356439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356472 */     // GIR_Coverage, 50793,
     /* 2356472 */     GIR_EraseRootFromParent_Done,
     /* 2356473 */   // Label 33101: @2356473
     /* 2356473 */   GIM_Reject,
     /* 2356474 */ // Label 33099: @2356474
     /* 2356474 */ GIM_Reject,
     /* 2356475 */ // Label 33059: @2356475
     /* 2356475 */ GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2356589),
     /* 2356480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2356483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2356486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356498 */   GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2356543), // Rule ID 50836 //
     /* 2356503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2356506 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2356509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2356523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356542 */     // GIR_Coverage, 50836,
     /* 2356542 */     GIR_EraseRootFromParent_Done,
     /* 2356543 */   // Label 33103: @2356543
     /* 2356543 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2356588), // Rule ID 50837 //
     /* 2356548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2356551 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2356554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2356568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356587 */     // GIR_Coverage, 50837,
     /* 2356587 */     GIR_EraseRootFromParent_Done,
     /* 2356588 */   // Label 33104: @2356588
     /* 2356588 */   GIM_Reject,
     /* 2356589 */ // Label 33102: @2356589
     /* 2356589 */ GIM_Reject,
     /* 2356590 */ // Label 33060: @2356590
     /* 2356590 */ GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2356704),
     /* 2356595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2356598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2356601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356613 */   GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2356658), // Rule ID 50768 //
     /* 2356618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356621 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2356624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2356638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356657 */     // GIR_Coverage, 50768,
     /* 2356657 */     GIR_EraseRootFromParent_Done,
     /* 2356658 */   // Label 33106: @2356658
     /* 2356658 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2356703), // Rule ID 50769 //
     /* 2356663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356666 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2356669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2356683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356702 */     // GIR_Coverage, 50769,
     /* 2356702 */     GIR_EraseRootFromParent_Done,
     /* 2356703 */   // Label 33107: @2356703
     /* 2356703 */   GIM_Reject,
     /* 2356704 */ // Label 33105: @2356704
     /* 2356704 */ GIM_Reject,
     /* 2356705 */ // Label 33061: @2356705
     /* 2356705 */ GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2356819),
     /* 2356710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2356713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2356716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356728 */   GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2356773), // Rule ID 50788 //
     /* 2356733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356736 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356772 */     // GIR_Coverage, 50788,
     /* 2356772 */     GIR_EraseRootFromParent_Done,
     /* 2356773 */   // Label 33109: @2356773
     /* 2356773 */   GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2356818), // Rule ID 50789 //
     /* 2356778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356781 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2356798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356817 */     // GIR_Coverage, 50789,
     /* 2356817 */     GIR_EraseRootFromParent_Done,
     /* 2356818 */   // Label 33110: @2356818
     /* 2356818 */   GIM_Reject,
     /* 2356819 */ // Label 33108: @2356819
     /* 2356819 */ GIM_Reject,
     /* 2356820 */ // Label 33062: @2356820
     /* 2356820 */ GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2356934),
     /* 2356825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2356828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2356831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356843 */   GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2356888), // Rule ID 50824 //
     /* 2356848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356851 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2356868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356887 */     // GIR_Coverage, 50824,
     /* 2356887 */     GIR_EraseRootFromParent_Done,
     /* 2356888 */   // Label 33112: @2356888
     /* 2356888 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2356933), // Rule ID 50825 //
     /* 2356893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356896 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2356913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356932 */     // GIR_Coverage, 50825,
     /* 2356932 */     GIR_EraseRootFromParent_Done,
     /* 2356933 */   // Label 33113: @2356933
     /* 2356933 */   GIM_Reject,
     /* 2356934 */ // Label 33111: @2356934
     /* 2356934 */ GIM_Reject,
     /* 2356935 */ // Label 33063: @2356935
     /* 2356935 */ GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2357049),
     /* 2356940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2356943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2356946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356958 */   GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2357003), // Rule ID 50840 //
     /* 2356963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2356966 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2356969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2356983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357002 */     // GIR_Coverage, 50840,
     /* 2357002 */     GIR_EraseRootFromParent_Done,
     /* 2357003 */   // Label 33115: @2357003
     /* 2357003 */   GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2357048), // Rule ID 50841 //
     /* 2357008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2357011 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2357014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357047 */     // GIR_Coverage, 50841,
     /* 2357047 */     GIR_EraseRootFromParent_Done,
     /* 2357048 */   // Label 33116: @2357048
     /* 2357048 */   GIM_Reject,
     /* 2357049 */ // Label 33114: @2357049
     /* 2357049 */ GIM_Reject,
     /* 2357050 */ // Label 33064: @2357050
     /* 2357050 */ GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2357164),
     /* 2357055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2357058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2357061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357073 */   GIM_Try, /*On fail goto*//*Label 33118*/ GIMT_Encode4(2357118), // Rule ID 50784 //
     /* 2357078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357081 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2357084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2357098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357117 */     // GIR_Coverage, 50784,
     /* 2357117 */     GIR_EraseRootFromParent_Done,
     /* 2357118 */   // Label 33118: @2357118
     /* 2357118 */   GIM_Try, /*On fail goto*//*Label 33119*/ GIMT_Encode4(2357163), // Rule ID 50785 //
     /* 2357123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357126 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2357129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2357143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357162 */     // GIR_Coverage, 50785,
     /* 2357162 */     GIR_EraseRootFromParent_Done,
     /* 2357163 */   // Label 33119: @2357163
     /* 2357163 */   GIM_Reject,
     /* 2357164 */ // Label 33117: @2357164
     /* 2357164 */ GIM_Reject,
     /* 2357165 */ // Label 33065: @2357165
     /* 2357165 */ GIM_Try, /*On fail goto*//*Label 33120*/ GIMT_Encode4(2357279),
     /* 2357170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2357173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2357176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357188 */   GIM_Try, /*On fail goto*//*Label 33121*/ GIMT_Encode4(2357233), // Rule ID 50812 //
     /* 2357193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357196 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2357199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2357213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357232 */     // GIR_Coverage, 50812,
     /* 2357232 */     GIR_EraseRootFromParent_Done,
     /* 2357233 */   // Label 33121: @2357233
     /* 2357233 */   GIM_Try, /*On fail goto*//*Label 33122*/ GIMT_Encode4(2357278), // Rule ID 50813 //
     /* 2357238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357241 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2357244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2357258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357277 */     // GIR_Coverage, 50813,
     /* 2357277 */     GIR_EraseRootFromParent_Done,
     /* 2357278 */   // Label 33122: @2357278
     /* 2357278 */   GIM_Reject,
     /* 2357279 */ // Label 33120: @2357279
     /* 2357279 */ GIM_Reject,
     /* 2357280 */ // Label 33066: @2357280
     /* 2357280 */ GIM_Try, /*On fail goto*//*Label 33123*/ GIMT_Encode4(2357394),
     /* 2357285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2357288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2357291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357303 */   GIM_Try, /*On fail goto*//*Label 33124*/ GIMT_Encode4(2357348), // Rule ID 50828 //
     /* 2357308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357311 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2357314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357347 */     // GIR_Coverage, 50828,
     /* 2357347 */     GIR_EraseRootFromParent_Done,
     /* 2357348 */   // Label 33124: @2357348
     /* 2357348 */   GIM_Try, /*On fail goto*//*Label 33125*/ GIMT_Encode4(2357393), // Rule ID 50829 //
     /* 2357353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357356 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2357359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357392 */     // GIR_Coverage, 50829,
     /* 2357392 */     GIR_EraseRootFromParent_Done,
     /* 2357393 */   // Label 33125: @2357393
     /* 2357393 */   GIM_Reject,
     /* 2357394 */ // Label 33123: @2357394
     /* 2357394 */ GIM_Reject,
     /* 2357395 */ // Label 33067: @2357395
     /* 2357395 */ GIM_Try, /*On fail goto*//*Label 33126*/ GIMT_Encode4(2357509),
     /* 2357400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2357403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2357406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357418 */   GIM_Try, /*On fail goto*//*Label 33127*/ GIMT_Encode4(2357463), // Rule ID 50844 //
     /* 2357423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2357426 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2357429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2357443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357462 */     // GIR_Coverage, 50844,
     /* 2357462 */     GIR_EraseRootFromParent_Done,
     /* 2357463 */   // Label 33127: @2357463
     /* 2357463 */   GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2357508), // Rule ID 50845 //
     /* 2357468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2357471 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2357474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2357488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357507 */     // GIR_Coverage, 50845,
     /* 2357507 */     GIR_EraseRootFromParent_Done,
     /* 2357508 */   // Label 33128: @2357508
     /* 2357508 */   GIM_Reject,
     /* 2357509 */ // Label 33126: @2357509
     /* 2357509 */ GIM_Reject,
     /* 2357510 */ // Label 33068: @2357510
     /* 2357510 */ GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2357624),
     /* 2357515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2357518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2357521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357533 */   GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2357578), // Rule ID 50800 //
     /* 2357538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357541 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2357544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2357558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357577 */     // GIR_Coverage, 50800,
     /* 2357577 */     GIR_EraseRootFromParent_Done,
     /* 2357578 */   // Label 33130: @2357578
     /* 2357578 */   GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2357623), // Rule ID 50801 //
     /* 2357583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357586 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2357589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2357603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357622 */     // GIR_Coverage, 50801,
     /* 2357622 */     GIR_EraseRootFromParent_Done,
     /* 2357623 */   // Label 33131: @2357623
     /* 2357623 */   GIM_Reject,
     /* 2357624 */ // Label 33129: @2357624
     /* 2357624 */ GIM_Reject,
     /* 2357625 */ // Label 33069: @2357625
     /* 2357625 */ GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2357739),
     /* 2357630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2357633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2357636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357648 */   GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2357693), // Rule ID 50816 //
     /* 2357653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357656 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2357659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357692 */     // GIR_Coverage, 50816,
     /* 2357692 */     GIR_EraseRootFromParent_Done,
     /* 2357693 */   // Label 33133: @2357693
     /* 2357693 */   GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2357738), // Rule ID 50817 //
     /* 2357698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357701 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2357704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357737 */     // GIR_Coverage, 50817,
     /* 2357737 */     GIR_EraseRootFromParent_Done,
     /* 2357738 */   // Label 33134: @2357738
     /* 2357738 */   GIM_Reject,
     /* 2357739 */ // Label 33132: @2357739
     /* 2357739 */ GIM_Reject,
     /* 2357740 */ // Label 33070: @2357740
     /* 2357740 */ GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2357854),
     /* 2357745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2357748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2357751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357763 */   GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2357808), // Rule ID 50832 //
     /* 2357768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357771 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2357788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357807 */     // GIR_Coverage, 50832,
     /* 2357807 */     GIR_EraseRootFromParent_Done,
     /* 2357808 */   // Label 33136: @2357808
     /* 2357808 */   GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2357853), // Rule ID 50833 //
     /* 2357813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357816 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2357819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2357833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357852 */     // GIR_Coverage, 50833,
     /* 2357852 */     GIR_EraseRootFromParent_Done,
     /* 2357853 */   // Label 33137: @2357853
     /* 2357853 */   GIM_Reject,
     /* 2357854 */ // Label 33135: @2357854
     /* 2357854 */ GIM_Reject,
     /* 2357855 */ // Label 33071: @2357855
     /* 2357855 */ GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2357969),
     /* 2357860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2357863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2357866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2357878 */   GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2357923), // Rule ID 50804 //
     /* 2357883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357886 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2357889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357922 */     // GIR_Coverage, 50804,
     /* 2357922 */     GIR_EraseRootFromParent_Done,
     /* 2357923 */   // Label 33139: @2357923
     /* 2357923 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2357968), // Rule ID 50805 //
     /* 2357928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357931 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2357934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2357948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357967 */     // GIR_Coverage, 50805,
     /* 2357967 */     GIR_EraseRootFromParent_Done,
     /* 2357968 */   // Label 33140: @2357968
     /* 2357968 */   GIM_Reject,
     /* 2357969 */ // Label 33138: @2357969
     /* 2357969 */ GIM_Reject,
     /* 2357970 */ // Label 33072: @2357970
     /* 2357970 */ GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2358084),
     /* 2357975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2357981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357993 */   GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2358038), // Rule ID 50820 //
     /* 2357998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358001 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2358004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2358018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358037 */     // GIR_Coverage, 50820,
     /* 2358037 */     GIR_EraseRootFromParent_Done,
     /* 2358038 */   // Label 33142: @2358038
     /* 2358038 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2358083), // Rule ID 50821 //
     /* 2358043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358046 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2358049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2358063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358082 */     // GIR_Coverage, 50821,
     /* 2358082 */     GIR_EraseRootFromParent_Done,
     /* 2358083 */   // Label 33143: @2358083
     /* 2358083 */   GIM_Reject,
     /* 2358084 */ // Label 33141: @2358084
     /* 2358084 */ GIM_Reject,
     /* 2358085 */ // Label 33073: @2358085
     /* 2358085 */ GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2358199),
     /* 2358090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2358093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2358096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358108 */   GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2358153), // Rule ID 50808 //
     /* 2358113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358116 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2358119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2358133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358152 */     // GIR_Coverage, 50808,
     /* 2358152 */     GIR_EraseRootFromParent_Done,
     /* 2358153 */   // Label 33145: @2358153
     /* 2358153 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2358198), // Rule ID 50809 //
     /* 2358158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358161 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2358164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2358178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358197 */     // GIR_Coverage, 50809,
     /* 2358197 */     GIR_EraseRootFromParent_Done,
     /* 2358198 */   // Label 33146: @2358198
     /* 2358198 */   GIM_Reject,
     /* 2358199 */ // Label 33144: @2358199
     /* 2358199 */ GIM_Reject,
     /* 2358200 */ // Label 33074: @2358200
     /* 2358200 */ GIM_Reject,
     /* 2358201 */ // Label 82: @2358201
     /* 2358201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33171*/ GIMT_Encode4(2360976),
     /* 2358212 */ /*GILLT_s32*//*Label 33147*/ GIMT_Encode4(2358336),
     /* 2358216 */ /*GILLT_s64*//*Label 33148*/ GIMT_Encode4(2358391), GIMT_Encode4(0),
     /* 2358224 */ /*GILLT_nxv1s8*//*Label 33149*/ GIMT_Encode4(2358446),
     /* 2358228 */ /*GILLT_nxv1s16*//*Label 33150*/ GIMT_Encode4(2358561),
     /* 2358232 */ /*GILLT_nxv1s32*//*Label 33151*/ GIMT_Encode4(2358676),
     /* 2358236 */ /*GILLT_nxv1s64*//*Label 33152*/ GIMT_Encode4(2358791), GIMT_Encode4(0),
     /* 2358244 */ /*GILLT_nxv2s8*//*Label 33153*/ GIMT_Encode4(2358906),
     /* 2358248 */ /*GILLT_nxv2s16*//*Label 33154*/ GIMT_Encode4(2359021),
     /* 2358252 */ /*GILLT_nxv2s32*//*Label 33155*/ GIMT_Encode4(2359136),
     /* 2358256 */ /*GILLT_nxv2s64*//*Label 33156*/ GIMT_Encode4(2359251), GIMT_Encode4(0),
     /* 2358264 */ /*GILLT_nxv4s8*//*Label 33157*/ GIMT_Encode4(2359366),
     /* 2358268 */ /*GILLT_nxv4s16*//*Label 33158*/ GIMT_Encode4(2359481),
     /* 2358272 */ /*GILLT_nxv4s32*//*Label 33159*/ GIMT_Encode4(2359596),
     /* 2358276 */ /*GILLT_nxv4s64*//*Label 33160*/ GIMT_Encode4(2359711), GIMT_Encode4(0),
     /* 2358284 */ /*GILLT_nxv8s8*//*Label 33161*/ GIMT_Encode4(2359826),
     /* 2358288 */ /*GILLT_nxv8s16*//*Label 33162*/ GIMT_Encode4(2359941),
     /* 2358292 */ /*GILLT_nxv8s32*//*Label 33163*/ GIMT_Encode4(2360056),
     /* 2358296 */ /*GILLT_nxv8s64*//*Label 33164*/ GIMT_Encode4(2360171), GIMT_Encode4(0),
     /* 2358304 */ /*GILLT_nxv16s8*//*Label 33165*/ GIMT_Encode4(2360286),
     /* 2358308 */ /*GILLT_nxv16s16*//*Label 33166*/ GIMT_Encode4(2360401),
     /* 2358312 */ /*GILLT_nxv16s32*//*Label 33167*/ GIMT_Encode4(2360516), GIMT_Encode4(0),
     /* 2358320 */ /*GILLT_nxv32s8*//*Label 33168*/ GIMT_Encode4(2360631),
     /* 2358324 */ /*GILLT_nxv32s16*//*Label 33169*/ GIMT_Encode4(2360746), GIMT_Encode4(0),
     /* 2358332 */ /*GILLT_nxv64s8*//*Label 33170*/ GIMT_Encode4(2360861),
     /* 2358336 */ // Label 33147: @2358336
     /* 2358336 */ GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2358390),
     /* 2358341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2358344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2358347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358359 */   GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2358374), // Rule ID 64456 //
     /* 2358364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2358367 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2358367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2358372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358373 */     // GIR_Coverage, 64456,
     /* 2358373 */     GIR_Done,
     /* 2358374 */   // Label 33173: @2358374
     /* 2358374 */   GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2358389), // Rule ID 2525 //
     /* 2358379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2358382 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2358382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2358387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358388 */     // GIR_Coverage, 2525,
     /* 2358388 */     GIR_Done,
     /* 2358389 */   // Label 33174: @2358389
     /* 2358389 */   GIM_Reject,
     /* 2358390 */ // Label 33172: @2358390
     /* 2358390 */ GIM_Reject,
     /* 2358391 */ // Label 33148: @2358391
     /* 2358391 */ GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2358445),
     /* 2358396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2358399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2358402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2358414 */   GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2358429), // Rule ID 64455 //
     /* 2358419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2358422 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2358422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2358427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358428 */     // GIR_Coverage, 64455,
     /* 2358428 */     GIR_Done,
     /* 2358429 */   // Label 33176: @2358429
     /* 2358429 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2358444), // Rule ID 2524 //
     /* 2358434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2358437 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2358437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2358442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358443 */     // GIR_Coverage, 2524,
     /* 2358443 */     GIR_Done,
     /* 2358444 */   // Label 33177: @2358444
     /* 2358444 */   GIM_Reject,
     /* 2358445 */ // Label 33175: @2358445
     /* 2358445 */ GIM_Reject,
     /* 2358446 */ // Label 33149: @2358446
     /* 2358446 */ GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2358560),
     /* 2358451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2358454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2358457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358469 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2358514), // Rule ID 50496 //
     /* 2358474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358477 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2358480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2358494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358513 */     // GIR_Coverage, 50496,
     /* 2358513 */     GIR_EraseRootFromParent_Done,
     /* 2358514 */   // Label 33179: @2358514
     /* 2358514 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2358559), // Rule ID 50497 //
     /* 2358519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358522 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2358525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2358539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358558 */     // GIR_Coverage, 50497,
     /* 2358558 */     GIR_EraseRootFromParent_Done,
     /* 2358559 */   // Label 33180: @2358559
     /* 2358559 */   GIM_Reject,
     /* 2358560 */ // Label 33178: @2358560
     /* 2358560 */ GIM_Reject,
     /* 2358561 */ // Label 33150: @2358561
     /* 2358561 */ GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2358675),
     /* 2358566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2358569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2358572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358584 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2358629), // Rule ID 50508 //
     /* 2358589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358592 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2358595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2358609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358628 */     // GIR_Coverage, 50508,
     /* 2358628 */     GIR_EraseRootFromParent_Done,
     /* 2358629 */   // Label 33182: @2358629
     /* 2358629 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2358674), // Rule ID 50509 //
     /* 2358634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358637 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2358640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2358654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358673 */     // GIR_Coverage, 50509,
     /* 2358673 */     GIR_EraseRootFromParent_Done,
     /* 2358674 */   // Label 33183: @2358674
     /* 2358674 */   GIM_Reject,
     /* 2358675 */ // Label 33181: @2358675
     /* 2358675 */ GIM_Reject,
     /* 2358676 */ // Label 33151: @2358676
     /* 2358676 */ GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2358790),
     /* 2358681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2358684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2358687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358699 */   GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2358744), // Rule ID 50516 //
     /* 2358704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358707 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2358724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358743 */     // GIR_Coverage, 50516,
     /* 2358743 */     GIR_EraseRootFromParent_Done,
     /* 2358744 */   // Label 33185: @2358744
     /* 2358744 */   GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2358789), // Rule ID 50517 //
     /* 2358749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358752 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2358755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2358769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358788 */     // GIR_Coverage, 50517,
     /* 2358788 */     GIR_EraseRootFromParent_Done,
     /* 2358789 */   // Label 33186: @2358789
     /* 2358789 */   GIM_Reject,
     /* 2358790 */ // Label 33184: @2358790
     /* 2358790 */ GIM_Reject,
     /* 2358791 */ // Label 33152: @2358791
     /* 2358791 */ GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2358905),
     /* 2358796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2358799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2358802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358814 */   GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2358859), // Rule ID 50532 //
     /* 2358819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2358822 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2358839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358858 */     // GIR_Coverage, 50532,
     /* 2358858 */     GIR_EraseRootFromParent_Done,
     /* 2358859 */   // Label 33188: @2358859
     /* 2358859 */   GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2358904), // Rule ID 50533 //
     /* 2358864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2358867 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2358870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2358884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358903 */     // GIR_Coverage, 50533,
     /* 2358903 */     GIR_EraseRootFromParent_Done,
     /* 2358904 */   // Label 33189: @2358904
     /* 2358904 */   GIM_Reject,
     /* 2358905 */ // Label 33187: @2358905
     /* 2358905 */ GIM_Reject,
     /* 2358906 */ // Label 33153: @2358906
     /* 2358906 */ GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2359020),
     /* 2358911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2358914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2358917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358929 */   GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2358974), // Rule ID 50500 //
     /* 2358934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358937 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2358940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2358954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358973 */     // GIR_Coverage, 50500,
     /* 2358973 */     GIR_EraseRootFromParent_Done,
     /* 2358974 */   // Label 33191: @2358974
     /* 2358974 */   GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2359019), // Rule ID 50501 //
     /* 2358979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358982 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2358985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2358999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359018 */     // GIR_Coverage, 50501,
     /* 2359018 */     GIR_EraseRootFromParent_Done,
     /* 2359019 */   // Label 33192: @2359019
     /* 2359019 */   GIM_Reject,
     /* 2359020 */ // Label 33190: @2359020
     /* 2359020 */ GIM_Reject,
     /* 2359021 */ // Label 33154: @2359021
     /* 2359021 */ GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2359135),
     /* 2359026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2359029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2359032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359044 */   GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2359089), // Rule ID 50512 //
     /* 2359049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359052 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2359055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2359069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359088 */     // GIR_Coverage, 50512,
     /* 2359088 */     GIR_EraseRootFromParent_Done,
     /* 2359089 */   // Label 33194: @2359089
     /* 2359089 */   GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2359134), // Rule ID 50513 //
     /* 2359094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359097 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2359100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2359114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359133 */     // GIR_Coverage, 50513,
     /* 2359133 */     GIR_EraseRootFromParent_Done,
     /* 2359134 */   // Label 33195: @2359134
     /* 2359134 */   GIM_Reject,
     /* 2359135 */ // Label 33193: @2359135
     /* 2359135 */ GIM_Reject,
     /* 2359136 */ // Label 33155: @2359136
     /* 2359136 */ GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2359250),
     /* 2359141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2359144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2359147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359159 */   GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2359204), // Rule ID 50528 //
     /* 2359164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359167 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2359170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359203 */     // GIR_Coverage, 50528,
     /* 2359203 */     GIR_EraseRootFromParent_Done,
     /* 2359204 */   // Label 33197: @2359204
     /* 2359204 */   GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2359249), // Rule ID 50529 //
     /* 2359209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359212 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2359215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359248 */     // GIR_Coverage, 50529,
     /* 2359248 */     GIR_EraseRootFromParent_Done,
     /* 2359249 */   // Label 33198: @2359249
     /* 2359249 */   GIM_Reject,
     /* 2359250 */ // Label 33196: @2359250
     /* 2359250 */ GIM_Reject,
     /* 2359251 */ // Label 33156: @2359251
     /* 2359251 */ GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2359365),
     /* 2359256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2359259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2359262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359274 */   GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2359319), // Rule ID 50572 //
     /* 2359279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2359282 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2359285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2359299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359318 */     // GIR_Coverage, 50572,
     /* 2359318 */     GIR_EraseRootFromParent_Done,
     /* 2359319 */   // Label 33200: @2359319
     /* 2359319 */   GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2359364), // Rule ID 50573 //
     /* 2359324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2359327 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2359330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2359344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359363 */     // GIR_Coverage, 50573,
     /* 2359363 */     GIR_EraseRootFromParent_Done,
     /* 2359364 */   // Label 33201: @2359364
     /* 2359364 */   GIM_Reject,
     /* 2359365 */ // Label 33199: @2359365
     /* 2359365 */ GIM_Reject,
     /* 2359366 */ // Label 33157: @2359366
     /* 2359366 */ GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2359480),
     /* 2359371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2359374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2359377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359389 */   GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2359434), // Rule ID 50504 //
     /* 2359394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359397 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2359400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2359414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359433 */     // GIR_Coverage, 50504,
     /* 2359433 */     GIR_EraseRootFromParent_Done,
     /* 2359434 */   // Label 33203: @2359434
     /* 2359434 */   GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2359479), // Rule ID 50505 //
     /* 2359439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359442 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2359445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2359459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359478 */     // GIR_Coverage, 50505,
     /* 2359478 */     GIR_EraseRootFromParent_Done,
     /* 2359479 */   // Label 33204: @2359479
     /* 2359479 */   GIM_Reject,
     /* 2359480 */ // Label 33202: @2359480
     /* 2359480 */ GIM_Reject,
     /* 2359481 */ // Label 33158: @2359481
     /* 2359481 */ GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2359595),
     /* 2359486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2359489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2359492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359504 */   GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2359549), // Rule ID 50524 //
     /* 2359509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359512 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2359515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359548 */     // GIR_Coverage, 50524,
     /* 2359548 */     GIR_EraseRootFromParent_Done,
     /* 2359549 */   // Label 33206: @2359549
     /* 2359549 */   GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2359594), // Rule ID 50525 //
     /* 2359554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359557 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2359560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359593 */     // GIR_Coverage, 50525,
     /* 2359593 */     GIR_EraseRootFromParent_Done,
     /* 2359594 */   // Label 33207: @2359594
     /* 2359594 */   GIM_Reject,
     /* 2359595 */ // Label 33205: @2359595
     /* 2359595 */ GIM_Reject,
     /* 2359596 */ // Label 33159: @2359596
     /* 2359596 */ GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2359710),
     /* 2359601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2359604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2359607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359619 */   GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2359664), // Rule ID 50560 //
     /* 2359624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359627 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2359644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359663 */     // GIR_Coverage, 50560,
     /* 2359663 */     GIR_EraseRootFromParent_Done,
     /* 2359664 */   // Label 33209: @2359664
     /* 2359664 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2359709), // Rule ID 50561 //
     /* 2359669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359672 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2359675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2359689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359708 */     // GIR_Coverage, 50561,
     /* 2359708 */     GIR_EraseRootFromParent_Done,
     /* 2359709 */   // Label 33210: @2359709
     /* 2359709 */   GIM_Reject,
     /* 2359710 */ // Label 33208: @2359710
     /* 2359710 */ GIM_Reject,
     /* 2359711 */ // Label 33160: @2359711
     /* 2359711 */ GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2359825),
     /* 2359716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2359719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2359722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359734 */   GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2359779), // Rule ID 50576 //
     /* 2359739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2359742 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2359759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359778 */     // GIR_Coverage, 50576,
     /* 2359778 */     GIR_EraseRootFromParent_Done,
     /* 2359779 */   // Label 33212: @2359779
     /* 2359779 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2359824), // Rule ID 50577 //
     /* 2359784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2359787 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2359790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2359804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2359819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359823 */     // GIR_Coverage, 50577,
     /* 2359823 */     GIR_EraseRootFromParent_Done,
     /* 2359824 */   // Label 33213: @2359824
     /* 2359824 */   GIM_Reject,
     /* 2359825 */ // Label 33211: @2359825
     /* 2359825 */ GIM_Reject,
     /* 2359826 */ // Label 33161: @2359826
     /* 2359826 */ GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2359940),
     /* 2359831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2359834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2359837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359849 */   GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2359894), // Rule ID 50520 //
     /* 2359854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359857 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2359860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359893 */     // GIR_Coverage, 50520,
     /* 2359893 */     GIR_EraseRootFromParent_Done,
     /* 2359894 */   // Label 33215: @2359894
     /* 2359894 */   GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2359939), // Rule ID 50521 //
     /* 2359899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359902 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2359905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2359919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359938 */     // GIR_Coverage, 50521,
     /* 2359938 */     GIR_EraseRootFromParent_Done,
     /* 2359939 */   // Label 33216: @2359939
     /* 2359939 */   GIM_Reject,
     /* 2359940 */ // Label 33214: @2359940
     /* 2359940 */ GIM_Reject,
     /* 2359941 */ // Label 33162: @2359941
     /* 2359941 */ GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2360055),
     /* 2359946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2359949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2359952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2359964 */   GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2360009), // Rule ID 50548 //
     /* 2359969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359972 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2359975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2359989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360008 */     // GIR_Coverage, 50548,
     /* 2360008 */     GIR_EraseRootFromParent_Done,
     /* 2360009 */   // Label 33218: @2360009
     /* 2360009 */   GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2360054), // Rule ID 50549 //
     /* 2360014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360017 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2360020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2360034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360053 */     // GIR_Coverage, 50549,
     /* 2360053 */     GIR_EraseRootFromParent_Done,
     /* 2360054 */   // Label 33219: @2360054
     /* 2360054 */   GIM_Reject,
     /* 2360055 */ // Label 33217: @2360055
     /* 2360055 */ GIM_Reject,
     /* 2360056 */ // Label 33163: @2360056
     /* 2360056 */ GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2360170),
     /* 2360061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2360064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2360067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360079 */   GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2360124), // Rule ID 50564 //
     /* 2360084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360087 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2360090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360123 */     // GIR_Coverage, 50564,
     /* 2360123 */     GIR_EraseRootFromParent_Done,
     /* 2360124 */   // Label 33221: @2360124
     /* 2360124 */   GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2360169), // Rule ID 50565 //
     /* 2360129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360132 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2360135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360168 */     // GIR_Coverage, 50565,
     /* 2360168 */     GIR_EraseRootFromParent_Done,
     /* 2360169 */   // Label 33222: @2360169
     /* 2360169 */   GIM_Reject,
     /* 2360170 */ // Label 33220: @2360170
     /* 2360170 */ GIM_Reject,
     /* 2360171 */ // Label 33164: @2360171
     /* 2360171 */ GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2360285),
     /* 2360176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2360179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2360182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360194 */   GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2360239), // Rule ID 50580 //
     /* 2360199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2360202 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360238 */     // GIR_Coverage, 50580,
     /* 2360238 */     GIR_EraseRootFromParent_Done,
     /* 2360239 */   // Label 33224: @2360239
     /* 2360239 */   GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2360284), // Rule ID 50581 //
     /* 2360244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2360247 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2360250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360283 */     // GIR_Coverage, 50581,
     /* 2360283 */     GIR_EraseRootFromParent_Done,
     /* 2360284 */   // Label 33225: @2360284
     /* 2360284 */   GIM_Reject,
     /* 2360285 */ // Label 33223: @2360285
     /* 2360285 */ GIM_Reject,
     /* 2360286 */ // Label 33165: @2360286
     /* 2360286 */ GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2360400),
     /* 2360291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2360294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2360297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360309 */   GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2360354), // Rule ID 50536 //
     /* 2360314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360317 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2360320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2360334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360353 */     // GIR_Coverage, 50536,
     /* 2360353 */     GIR_EraseRootFromParent_Done,
     /* 2360354 */   // Label 33227: @2360354
     /* 2360354 */   GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2360399), // Rule ID 50537 //
     /* 2360359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360362 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2360365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2360379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360398 */     // GIR_Coverage, 50537,
     /* 2360398 */     GIR_EraseRootFromParent_Done,
     /* 2360399 */   // Label 33228: @2360399
     /* 2360399 */   GIM_Reject,
     /* 2360400 */ // Label 33226: @2360400
     /* 2360400 */ GIM_Reject,
     /* 2360401 */ // Label 33166: @2360401
     /* 2360401 */ GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2360515),
     /* 2360406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2360409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2360412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360424 */   GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2360469), // Rule ID 50552 //
     /* 2360429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360432 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360468 */     // GIR_Coverage, 50552,
     /* 2360468 */     GIR_EraseRootFromParent_Done,
     /* 2360469 */   // Label 33230: @2360469
     /* 2360469 */   GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2360514), // Rule ID 50553 //
     /* 2360474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360477 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2360480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360513 */     // GIR_Coverage, 50553,
     /* 2360513 */     GIR_EraseRootFromParent_Done,
     /* 2360514 */   // Label 33231: @2360514
     /* 2360514 */   GIM_Reject,
     /* 2360515 */ // Label 33229: @2360515
     /* 2360515 */ GIM_Reject,
     /* 2360516 */ // Label 33167: @2360516
     /* 2360516 */ GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2360630),
     /* 2360521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2360524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2360527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360539 */   GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2360584), // Rule ID 50568 //
     /* 2360544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360547 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360583 */     // GIR_Coverage, 50568,
     /* 2360583 */     GIR_EraseRootFromParent_Done,
     /* 2360584 */   // Label 33233: @2360584
     /* 2360584 */   GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2360629), // Rule ID 50569 //
     /* 2360589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360592 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2360595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360628 */     // GIR_Coverage, 50569,
     /* 2360628 */     GIR_EraseRootFromParent_Done,
     /* 2360629 */   // Label 33234: @2360629
     /* 2360629 */   GIM_Reject,
     /* 2360630 */ // Label 33232: @2360630
     /* 2360630 */ GIM_Reject,
     /* 2360631 */ // Label 33168: @2360631
     /* 2360631 */ GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2360745),
     /* 2360636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2360639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2360642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360654 */   GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2360699), // Rule ID 50540 //
     /* 2360659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360662 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2360665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360698 */     // GIR_Coverage, 50540,
     /* 2360698 */     GIR_EraseRootFromParent_Done,
     /* 2360699 */   // Label 33236: @2360699
     /* 2360699 */   GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2360744), // Rule ID 50541 //
     /* 2360704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360707 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2360710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2360724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360743 */     // GIR_Coverage, 50541,
     /* 2360743 */     GIR_EraseRootFromParent_Done,
     /* 2360744 */   // Label 33237: @2360744
     /* 2360744 */   GIM_Reject,
     /* 2360745 */ // Label 33235: @2360745
     /* 2360745 */ GIM_Reject,
     /* 2360746 */ // Label 33169: @2360746
     /* 2360746 */ GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2360860),
     /* 2360751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2360754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2360757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360769 */   GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2360814), // Rule ID 50556 //
     /* 2360774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360777 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360813 */     // GIR_Coverage, 50556,
     /* 2360813 */     GIR_EraseRootFromParent_Done,
     /* 2360814 */   // Label 33239: @2360814
     /* 2360814 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2360859), // Rule ID 50557 //
     /* 2360819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360822 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2360825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360858 */     // GIR_Coverage, 50557,
     /* 2360858 */     GIR_EraseRootFromParent_Done,
     /* 2360859 */   // Label 33240: @2360859
     /* 2360859 */   GIM_Reject,
     /* 2360860 */ // Label 33238: @2360860
     /* 2360860 */ GIM_Reject,
     /* 2360861 */ // Label 33170: @2360861
     /* 2360861 */ GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2360975),
     /* 2360866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2360869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2360872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2360884 */   GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2360929), // Rule ID 50544 //
     /* 2360889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2360892 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2360895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360928 */     // GIR_Coverage, 50544,
     /* 2360928 */     GIR_EraseRootFromParent_Done,
     /* 2360929 */   // Label 33242: @2360929
     /* 2360929 */   GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2360974), // Rule ID 50545 //
     /* 2360934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2360937 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2360940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2360954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360973 */     // GIR_Coverage, 50545,
     /* 2360973 */     GIR_EraseRootFromParent_Done,
     /* 2360974 */   // Label 33243: @2360974
     /* 2360974 */   GIM_Reject,
     /* 2360975 */ // Label 33241: @2360975
     /* 2360975 */ GIM_Reject,
     /* 2360976 */ // Label 33171: @2360976
     /* 2360976 */ GIM_Reject,
     /* 2360977 */ // Label 83: @2360977
     /* 2360977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33268*/ GIMT_Encode4(2363752),
     /* 2360988 */ /*GILLT_s32*//*Label 33244*/ GIMT_Encode4(2361112),
     /* 2360992 */ /*GILLT_s64*//*Label 33245*/ GIMT_Encode4(2361167), GIMT_Encode4(0),
     /* 2361000 */ /*GILLT_nxv1s8*//*Label 33246*/ GIMT_Encode4(2361222),
     /* 2361004 */ /*GILLT_nxv1s16*//*Label 33247*/ GIMT_Encode4(2361337),
     /* 2361008 */ /*GILLT_nxv1s32*//*Label 33248*/ GIMT_Encode4(2361452),
     /* 2361012 */ /*GILLT_nxv1s64*//*Label 33249*/ GIMT_Encode4(2361567), GIMT_Encode4(0),
     /* 2361020 */ /*GILLT_nxv2s8*//*Label 33250*/ GIMT_Encode4(2361682),
     /* 2361024 */ /*GILLT_nxv2s16*//*Label 33251*/ GIMT_Encode4(2361797),
     /* 2361028 */ /*GILLT_nxv2s32*//*Label 33252*/ GIMT_Encode4(2361912),
     /* 2361032 */ /*GILLT_nxv2s64*//*Label 33253*/ GIMT_Encode4(2362027), GIMT_Encode4(0),
     /* 2361040 */ /*GILLT_nxv4s8*//*Label 33254*/ GIMT_Encode4(2362142),
     /* 2361044 */ /*GILLT_nxv4s16*//*Label 33255*/ GIMT_Encode4(2362257),
     /* 2361048 */ /*GILLT_nxv4s32*//*Label 33256*/ GIMT_Encode4(2362372),
     /* 2361052 */ /*GILLT_nxv4s64*//*Label 33257*/ GIMT_Encode4(2362487), GIMT_Encode4(0),
     /* 2361060 */ /*GILLT_nxv8s8*//*Label 33258*/ GIMT_Encode4(2362602),
     /* 2361064 */ /*GILLT_nxv8s16*//*Label 33259*/ GIMT_Encode4(2362717),
     /* 2361068 */ /*GILLT_nxv8s32*//*Label 33260*/ GIMT_Encode4(2362832),
     /* 2361072 */ /*GILLT_nxv8s64*//*Label 33261*/ GIMT_Encode4(2362947), GIMT_Encode4(0),
     /* 2361080 */ /*GILLT_nxv16s8*//*Label 33262*/ GIMT_Encode4(2363062),
     /* 2361084 */ /*GILLT_nxv16s16*//*Label 33263*/ GIMT_Encode4(2363177),
     /* 2361088 */ /*GILLT_nxv16s32*//*Label 33264*/ GIMT_Encode4(2363292), GIMT_Encode4(0),
     /* 2361096 */ /*GILLT_nxv32s8*//*Label 33265*/ GIMT_Encode4(2363407),
     /* 2361100 */ /*GILLT_nxv32s16*//*Label 33266*/ GIMT_Encode4(2363522), GIMT_Encode4(0),
     /* 2361108 */ /*GILLT_nxv64s8*//*Label 33267*/ GIMT_Encode4(2363637),
     /* 2361112 */ // Label 33244: @2361112
     /* 2361112 */ GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2361166),
     /* 2361117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361135 */   GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2361150), // Rule ID 64460 //
     /* 2361140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2361143 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2361143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2361148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361149 */     // GIR_Coverage, 64460,
     /* 2361149 */     GIR_Done,
     /* 2361150 */   // Label 33270: @2361150
     /* 2361150 */   GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2361165), // Rule ID 2527 //
     /* 2361155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2361158 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2361158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2361163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361164 */     // GIR_Coverage, 2527,
     /* 2361164 */     GIR_Done,
     /* 2361165 */   // Label 33271: @2361165
     /* 2361165 */   GIM_Reject,
     /* 2361166 */ // Label 33269: @2361166
     /* 2361166 */ GIM_Reject,
     /* 2361167 */ // Label 33245: @2361167
     /* 2361167 */ GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2361221),
     /* 2361172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361190 */   GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2361205), // Rule ID 64459 //
     /* 2361195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2361198 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2361198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2361203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361204 */     // GIR_Coverage, 64459,
     /* 2361204 */     GIR_Done,
     /* 2361205 */   // Label 33273: @2361205
     /* 2361205 */   GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2361220), // Rule ID 2526 //
     /* 2361210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2361213 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2361213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2361218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361219 */     // GIR_Coverage, 2526,
     /* 2361219 */     GIR_Done,
     /* 2361220 */   // Label 33274: @2361220
     /* 2361220 */   GIM_Reject,
     /* 2361221 */ // Label 33272: @2361221
     /* 2361221 */ GIM_Reject,
     /* 2361222 */ // Label 33246: @2361222
     /* 2361222 */ GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2361336),
     /* 2361227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2361230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2361233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361245 */   GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2361290), // Rule ID 50672 //
     /* 2361250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361253 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2361256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2361270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361289 */     // GIR_Coverage, 50672,
     /* 2361289 */     GIR_EraseRootFromParent_Done,
     /* 2361290 */   // Label 33276: @2361290
     /* 2361290 */   GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2361335), // Rule ID 50673 //
     /* 2361295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361298 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2361301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2361315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361334 */     // GIR_Coverage, 50673,
     /* 2361334 */     GIR_EraseRootFromParent_Done,
     /* 2361335 */   // Label 33277: @2361335
     /* 2361335 */   GIM_Reject,
     /* 2361336 */ // Label 33275: @2361336
     /* 2361336 */ GIM_Reject,
     /* 2361337 */ // Label 33247: @2361337
     /* 2361337 */ GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2361451),
     /* 2361342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2361345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2361348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361360 */   GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2361405), // Rule ID 50684 //
     /* 2361365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361368 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2361385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361404 */     // GIR_Coverage, 50684,
     /* 2361404 */     GIR_EraseRootFromParent_Done,
     /* 2361405 */   // Label 33279: @2361405
     /* 2361405 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2361450), // Rule ID 50685 //
     /* 2361410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361413 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2361430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361449 */     // GIR_Coverage, 50685,
     /* 2361449 */     GIR_EraseRootFromParent_Done,
     /* 2361450 */   // Label 33280: @2361450
     /* 2361450 */   GIM_Reject,
     /* 2361451 */ // Label 33278: @2361451
     /* 2361451 */ GIM_Reject,
     /* 2361452 */ // Label 33248: @2361452
     /* 2361452 */ GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2361566),
     /* 2361457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2361460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2361463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361475 */   GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2361520), // Rule ID 50692 //
     /* 2361480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361483 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2361500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361519 */     // GIR_Coverage, 50692,
     /* 2361519 */     GIR_EraseRootFromParent_Done,
     /* 2361520 */   // Label 33282: @2361520
     /* 2361520 */   GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2361565), // Rule ID 50693 //
     /* 2361525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361528 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2361531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2361545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361564 */     // GIR_Coverage, 50693,
     /* 2361564 */     GIR_EraseRootFromParent_Done,
     /* 2361565 */   // Label 33283: @2361565
     /* 2361565 */   GIM_Reject,
     /* 2361566 */ // Label 33281: @2361566
     /* 2361566 */ GIM_Reject,
     /* 2361567 */ // Label 33249: @2361567
     /* 2361567 */ GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2361681),
     /* 2361572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2361575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2361578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361590 */   GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2361635), // Rule ID 50708 //
     /* 2361595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2361598 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2361615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361634 */     // GIR_Coverage, 50708,
     /* 2361634 */     GIR_EraseRootFromParent_Done,
     /* 2361635 */   // Label 33285: @2361635
     /* 2361635 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2361680), // Rule ID 50709 //
     /* 2361640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2361643 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2361660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361679 */     // GIR_Coverage, 50709,
     /* 2361679 */     GIR_EraseRootFromParent_Done,
     /* 2361680 */   // Label 33286: @2361680
     /* 2361680 */   GIM_Reject,
     /* 2361681 */ // Label 33284: @2361681
     /* 2361681 */ GIM_Reject,
     /* 2361682 */ // Label 33250: @2361682
     /* 2361682 */ GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2361796),
     /* 2361687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2361690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2361693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361705 */   GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2361750), // Rule ID 50676 //
     /* 2361710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361713 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2361716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2361730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361749 */     // GIR_Coverage, 50676,
     /* 2361749 */     GIR_EraseRootFromParent_Done,
     /* 2361750 */   // Label 33288: @2361750
     /* 2361750 */   GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2361795), // Rule ID 50677 //
     /* 2361755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361758 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2361761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2361775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361794 */     // GIR_Coverage, 50677,
     /* 2361794 */     GIR_EraseRootFromParent_Done,
     /* 2361795 */   // Label 33289: @2361795
     /* 2361795 */   GIM_Reject,
     /* 2361796 */ // Label 33287: @2361796
     /* 2361796 */ GIM_Reject,
     /* 2361797 */ // Label 33251: @2361797
     /* 2361797 */ GIM_Try, /*On fail goto*//*Label 33290*/ GIMT_Encode4(2361911),
     /* 2361802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2361805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2361808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361820 */   GIM_Try, /*On fail goto*//*Label 33291*/ GIMT_Encode4(2361865), // Rule ID 50688 //
     /* 2361825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361828 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2361845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361864 */     // GIR_Coverage, 50688,
     /* 2361864 */     GIR_EraseRootFromParent_Done,
     /* 2361865 */   // Label 33291: @2361865
     /* 2361865 */   GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2361910), // Rule ID 50689 //
     /* 2361870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361873 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2361890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361909 */     // GIR_Coverage, 50689,
     /* 2361909 */     GIR_EraseRootFromParent_Done,
     /* 2361910 */   // Label 33292: @2361910
     /* 2361910 */   GIM_Reject,
     /* 2361911 */ // Label 33290: @2361911
     /* 2361911 */ GIM_Reject,
     /* 2361912 */ // Label 33252: @2361912
     /* 2361912 */ GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2362026),
     /* 2361917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2361920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2361923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361935 */   GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2361980), // Rule ID 50704 //
     /* 2361940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2361943 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2361946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2361960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361979 */     // GIR_Coverage, 50704,
     /* 2361979 */     GIR_EraseRootFromParent_Done,
     /* 2361980 */   // Label 33294: @2361980
     /* 2361980 */   GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2362025), // Rule ID 50705 //
     /* 2361985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2361988 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2361991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2362005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362024 */     // GIR_Coverage, 50705,
     /* 2362024 */     GIR_EraseRootFromParent_Done,
     /* 2362025 */   // Label 33295: @2362025
     /* 2362025 */   GIM_Reject,
     /* 2362026 */ // Label 33293: @2362026
     /* 2362026 */ GIM_Reject,
     /* 2362027 */ // Label 33253: @2362027
     /* 2362027 */ GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2362141),
     /* 2362032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362050 */   GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2362095), // Rule ID 50748 //
     /* 2362055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2362058 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362094 */     // GIR_Coverage, 50748,
     /* 2362094 */     GIR_EraseRootFromParent_Done,
     /* 2362095 */   // Label 33297: @2362095
     /* 2362095 */   GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2362140), // Rule ID 50749 //
     /* 2362100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2362103 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362139 */     // GIR_Coverage, 50749,
     /* 2362139 */     GIR_EraseRootFromParent_Done,
     /* 2362140 */   // Label 33298: @2362140
     /* 2362140 */   GIM_Reject,
     /* 2362141 */ // Label 33296: @2362141
     /* 2362141 */ GIM_Reject,
     /* 2362142 */ // Label 33254: @2362142
     /* 2362142 */ GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2362256),
     /* 2362147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2362150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2362153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362165 */   GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2362210), // Rule ID 50680 //
     /* 2362170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362173 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2362176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2362190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362209 */     // GIR_Coverage, 50680,
     /* 2362209 */     GIR_EraseRootFromParent_Done,
     /* 2362210 */   // Label 33300: @2362210
     /* 2362210 */   GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2362255), // Rule ID 50681 //
     /* 2362215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362218 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2362221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2362235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362254 */     // GIR_Coverage, 50681,
     /* 2362254 */     GIR_EraseRootFromParent_Done,
     /* 2362255 */   // Label 33301: @2362255
     /* 2362255 */   GIM_Reject,
     /* 2362256 */ // Label 33299: @2362256
     /* 2362256 */ GIM_Reject,
     /* 2362257 */ // Label 33255: @2362257
     /* 2362257 */ GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2362371),
     /* 2362262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2362265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2362268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362280 */   GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2362325), // Rule ID 50700 //
     /* 2362285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362288 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2362305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362324 */     // GIR_Coverage, 50700,
     /* 2362324 */     GIR_EraseRootFromParent_Done,
     /* 2362325 */   // Label 33303: @2362325
     /* 2362325 */   GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2362370), // Rule ID 50701 //
     /* 2362330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362333 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2362350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362369 */     // GIR_Coverage, 50701,
     /* 2362369 */     GIR_EraseRootFromParent_Done,
     /* 2362370 */   // Label 33304: @2362370
     /* 2362370 */   GIM_Reject,
     /* 2362371 */ // Label 33302: @2362371
     /* 2362371 */ GIM_Reject,
     /* 2362372 */ // Label 33256: @2362372
     /* 2362372 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2362486),
     /* 2362377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2362380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2362383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362395 */   GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2362440), // Rule ID 50736 //
     /* 2362400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362403 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362439 */     // GIR_Coverage, 50736,
     /* 2362439 */     GIR_EraseRootFromParent_Done,
     /* 2362440 */   // Label 33306: @2362440
     /* 2362440 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2362485), // Rule ID 50737 //
     /* 2362445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362448 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362484 */     // GIR_Coverage, 50737,
     /* 2362484 */     GIR_EraseRootFromParent_Done,
     /* 2362485 */   // Label 33307: @2362485
     /* 2362485 */   GIM_Reject,
     /* 2362486 */ // Label 33305: @2362486
     /* 2362486 */ GIM_Reject,
     /* 2362487 */ // Label 33257: @2362487
     /* 2362487 */ GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2362601),
     /* 2362492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2362495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2362498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362510 */   GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2362555), // Rule ID 50752 //
     /* 2362515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2362518 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2362535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362554 */     // GIR_Coverage, 50752,
     /* 2362554 */     GIR_EraseRootFromParent_Done,
     /* 2362555 */   // Label 33309: @2362555
     /* 2362555 */   GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2362600), // Rule ID 50753 //
     /* 2362560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2362563 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2362580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362599 */     // GIR_Coverage, 50753,
     /* 2362599 */     GIR_EraseRootFromParent_Done,
     /* 2362600 */   // Label 33310: @2362600
     /* 2362600 */   GIM_Reject,
     /* 2362601 */ // Label 33308: @2362601
     /* 2362601 */ GIM_Reject,
     /* 2362602 */ // Label 33258: @2362602
     /* 2362602 */ GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2362716),
     /* 2362607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2362610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2362613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362625 */   GIM_Try, /*On fail goto*//*Label 33312*/ GIMT_Encode4(2362670), // Rule ID 50696 //
     /* 2362630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362633 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2362636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2362650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362669 */     // GIR_Coverage, 50696,
     /* 2362669 */     GIR_EraseRootFromParent_Done,
     /* 2362670 */   // Label 33312: @2362670
     /* 2362670 */   GIM_Try, /*On fail goto*//*Label 33313*/ GIMT_Encode4(2362715), // Rule ID 50697 //
     /* 2362675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362678 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2362681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2362695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362714 */     // GIR_Coverage, 50697,
     /* 2362714 */     GIR_EraseRootFromParent_Done,
     /* 2362715 */   // Label 33313: @2362715
     /* 2362715 */   GIM_Reject,
     /* 2362716 */ // Label 33311: @2362716
     /* 2362716 */ GIM_Reject,
     /* 2362717 */ // Label 33259: @2362717
     /* 2362717 */ GIM_Try, /*On fail goto*//*Label 33314*/ GIMT_Encode4(2362831),
     /* 2362722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2362725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2362728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362740 */   GIM_Try, /*On fail goto*//*Label 33315*/ GIMT_Encode4(2362785), // Rule ID 50724 //
     /* 2362745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362748 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362784 */     // GIR_Coverage, 50724,
     /* 2362784 */     GIR_EraseRootFromParent_Done,
     /* 2362785 */   // Label 33315: @2362785
     /* 2362785 */   GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2362830), // Rule ID 50725 //
     /* 2362790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362793 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2362810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362829 */     // GIR_Coverage, 50725,
     /* 2362829 */     GIR_EraseRootFromParent_Done,
     /* 2362830 */   // Label 33316: @2362830
     /* 2362830 */   GIM_Reject,
     /* 2362831 */ // Label 33314: @2362831
     /* 2362831 */ GIM_Reject,
     /* 2362832 */ // Label 33260: @2362832
     /* 2362832 */ GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2362946),
     /* 2362837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2362840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2362843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362855 */   GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2362900), // Rule ID 50740 //
     /* 2362860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2362863 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2362880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362899 */     // GIR_Coverage, 50740,
     /* 2362899 */     GIR_EraseRootFromParent_Done,
     /* 2362900 */   // Label 33318: @2362900
     /* 2362900 */   GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2362945), // Rule ID 50741 //
     /* 2362905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2362908 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2362925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362944 */     // GIR_Coverage, 50741,
     /* 2362944 */     GIR_EraseRootFromParent_Done,
     /* 2362945 */   // Label 33319: @2362945
     /* 2362945 */   GIM_Reject,
     /* 2362946 */ // Label 33317: @2362946
     /* 2362946 */ GIM_Reject,
     /* 2362947 */ // Label 33261: @2362947
     /* 2362947 */ GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2363061),
     /* 2362952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2362955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2362958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362970 */   GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2363015), // Rule ID 50756 //
     /* 2362975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2362978 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2362995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363014 */     // GIR_Coverage, 50756,
     /* 2363014 */     GIR_EraseRootFromParent_Done,
     /* 2363015 */   // Label 33321: @2363015
     /* 2363015 */   GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2363060), // Rule ID 50757 //
     /* 2363020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2363023 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363059 */     // GIR_Coverage, 50757,
     /* 2363059 */     GIR_EraseRootFromParent_Done,
     /* 2363060 */   // Label 33322: @2363060
     /* 2363060 */   GIM_Reject,
     /* 2363061 */ // Label 33320: @2363061
     /* 2363061 */ GIM_Reject,
     /* 2363062 */ // Label 33262: @2363062
     /* 2363062 */ GIM_Try, /*On fail goto*//*Label 33323*/ GIMT_Encode4(2363176),
     /* 2363067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2363070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2363073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2363085 */   GIM_Try, /*On fail goto*//*Label 33324*/ GIMT_Encode4(2363130), // Rule ID 50712 //
     /* 2363090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363093 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2363096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2363110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363129 */     // GIR_Coverage, 50712,
     /* 2363129 */     GIR_EraseRootFromParent_Done,
     /* 2363130 */   // Label 33324: @2363130
     /* 2363130 */   GIM_Try, /*On fail goto*//*Label 33325*/ GIMT_Encode4(2363175), // Rule ID 50713 //
     /* 2363135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363138 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2363141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2363155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363174 */     // GIR_Coverage, 50713,
     /* 2363174 */     GIR_EraseRootFromParent_Done,
     /* 2363175 */   // Label 33325: @2363175
     /* 2363175 */   GIM_Reject,
     /* 2363176 */ // Label 33323: @2363176
     /* 2363176 */ GIM_Reject,
     /* 2363177 */ // Label 33263: @2363177
     /* 2363177 */ GIM_Try, /*On fail goto*//*Label 33326*/ GIMT_Encode4(2363291),
     /* 2363182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2363185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2363188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363200 */   GIM_Try, /*On fail goto*//*Label 33327*/ GIMT_Encode4(2363245), // Rule ID 50728 //
     /* 2363205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363208 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2363225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363244 */     // GIR_Coverage, 50728,
     /* 2363244 */     GIR_EraseRootFromParent_Done,
     /* 2363245 */   // Label 33327: @2363245
     /* 2363245 */   GIM_Try, /*On fail goto*//*Label 33328*/ GIMT_Encode4(2363290), // Rule ID 50729 //
     /* 2363250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363253 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2363270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363289 */     // GIR_Coverage, 50729,
     /* 2363289 */     GIR_EraseRootFromParent_Done,
     /* 2363290 */   // Label 33328: @2363290
     /* 2363290 */   GIM_Reject,
     /* 2363291 */ // Label 33326: @2363291
     /* 2363291 */ GIM_Reject,
     /* 2363292 */ // Label 33264: @2363292
     /* 2363292 */ GIM_Try, /*On fail goto*//*Label 33329*/ GIMT_Encode4(2363406),
     /* 2363297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363315 */   GIM_Try, /*On fail goto*//*Label 33330*/ GIMT_Encode4(2363360), // Rule ID 50744 //
     /* 2363320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363323 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363359 */     // GIR_Coverage, 50744,
     /* 2363359 */     GIR_EraseRootFromParent_Done,
     /* 2363360 */   // Label 33330: @2363360
     /* 2363360 */   GIM_Try, /*On fail goto*//*Label 33331*/ GIMT_Encode4(2363405), // Rule ID 50745 //
     /* 2363365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363368 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363404 */     // GIR_Coverage, 50745,
     /* 2363404 */     GIR_EraseRootFromParent_Done,
     /* 2363405 */   // Label 33331: @2363405
     /* 2363405 */   GIM_Reject,
     /* 2363406 */ // Label 33329: @2363406
     /* 2363406 */ GIM_Reject,
     /* 2363407 */ // Label 33265: @2363407
     /* 2363407 */ GIM_Try, /*On fail goto*//*Label 33332*/ GIMT_Encode4(2363521),
     /* 2363412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2363415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2363418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363430 */   GIM_Try, /*On fail goto*//*Label 33333*/ GIMT_Encode4(2363475), // Rule ID 50716 //
     /* 2363435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363438 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2363441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2363455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363474 */     // GIR_Coverage, 50716,
     /* 2363474 */     GIR_EraseRootFromParent_Done,
     /* 2363475 */   // Label 33333: @2363475
     /* 2363475 */   GIM_Try, /*On fail goto*//*Label 33334*/ GIMT_Encode4(2363520), // Rule ID 50717 //
     /* 2363480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363483 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2363486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2363500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363519 */     // GIR_Coverage, 50717,
     /* 2363519 */     GIR_EraseRootFromParent_Done,
     /* 2363520 */   // Label 33334: @2363520
     /* 2363520 */   GIM_Reject,
     /* 2363521 */ // Label 33332: @2363521
     /* 2363521 */ GIM_Reject,
     /* 2363522 */ // Label 33266: @2363522
     /* 2363522 */ GIM_Try, /*On fail goto*//*Label 33335*/ GIMT_Encode4(2363636),
     /* 2363527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363545 */   GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2363590), // Rule ID 50732 //
     /* 2363550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363553 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363589 */     // GIR_Coverage, 50732,
     /* 2363589 */     GIR_EraseRootFromParent_Done,
     /* 2363590 */   // Label 33336: @2363590
     /* 2363590 */   GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2363635), // Rule ID 50733 //
     /* 2363595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363598 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363634 */     // GIR_Coverage, 50733,
     /* 2363634 */     GIR_EraseRootFromParent_Done,
     /* 2363635 */   // Label 33337: @2363635
     /* 2363635 */   GIM_Reject,
     /* 2363636 */ // Label 33335: @2363636
     /* 2363636 */ GIM_Reject,
     /* 2363637 */ // Label 33267: @2363637
     /* 2363637 */ GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2363751),
     /* 2363642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2363645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2363648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363660 */   GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2363705), // Rule ID 50720 //
     /* 2363665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363668 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2363671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363704 */     // GIR_Coverage, 50720,
     /* 2363704 */     GIR_EraseRootFromParent_Done,
     /* 2363705 */   // Label 33339: @2363705
     /* 2363705 */   GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2363750), // Rule ID 50721 //
     /* 2363710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363713 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2363716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2363730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363749 */     // GIR_Coverage, 50721,
     /* 2363749 */     GIR_EraseRootFromParent_Done,
     /* 2363750 */   // Label 33340: @2363750
     /* 2363750 */   GIM_Reject,
     /* 2363751 */ // Label 33338: @2363751
     /* 2363751 */ GIM_Reject,
     /* 2363752 */ // Label 33268: @2363752
     /* 2363752 */ GIM_Reject,
     /* 2363753 */ // Label 84: @2363753
     /* 2363753 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33343*/ GIMT_Encode4(2363910),
     /* 2363764 */ /*GILLT_s32*//*Label 33341*/ GIMT_Encode4(2363772),
     /* 2363768 */ /*GILLT_s64*//*Label 33342*/ GIMT_Encode4(2363841),
     /* 2363772 */ // Label 33341: @2363772
     /* 2363772 */ GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2363840),
     /* 2363777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363788 */   GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2363803), // Rule ID 64448 //
     /* 2363793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2363796 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2363796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2363801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363802 */     // GIR_Coverage, 64448,
     /* 2363802 */     GIR_Done,
     /* 2363803 */   // Label 33345: @2363803
     /* 2363803 */   GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2363839), // Rule ID 62503 //
     /* 2363808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2363811 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2363811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2363814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2363816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2363824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2363827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2363835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363838 */     // GIR_Coverage, 62503,
     /* 2363838 */     GIR_EraseRootFromParent_Done,
     /* 2363839 */   // Label 33346: @2363839
     /* 2363839 */   GIM_Reject,
     /* 2363840 */ // Label 33344: @2363840
     /* 2363840 */ GIM_Reject,
     /* 2363841 */ // Label 33342: @2363841
     /* 2363841 */ GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2363909),
     /* 2363846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363857 */   GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2363872), // Rule ID 64447 //
     /* 2363862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2363865 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2363865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2363870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363871 */     // GIR_Coverage, 64447,
     /* 2363871 */     GIR_Done,
     /* 2363872 */   // Label 33348: @2363872
     /* 2363872 */   GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2363908), // Rule ID 62502 //
     /* 2363877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2363880 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2363880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2363883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2363885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2363893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2363896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2363904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363907 */     // GIR_Coverage, 62502,
     /* 2363907 */     GIR_EraseRootFromParent_Done,
     /* 2363908 */   // Label 33349: @2363908
     /* 2363908 */   GIM_Reject,
     /* 2363909 */ // Label 33347: @2363909
     /* 2363909 */ GIM_Reject,
     /* 2363910 */ // Label 33343: @2363910
     /* 2363910 */ GIM_Reject,
     /* 2363911 */ // Label 85: @2363911
     /* 2363911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33352*/ GIMT_Encode4(2364490),
     /* 2363922 */ /*GILLT_s32*//*Label 33350*/ GIMT_Encode4(2363930),
     /* 2363926 */ /*GILLT_s64*//*Label 33351*/ GIMT_Encode4(2364303),
     /* 2363930 */ // Label 33350: @2363930
     /* 2363930 */ GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2363961), // Rule ID 1458 //
     /* 2363935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2363938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363949 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2363949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2363952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363954 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2363960 */   // GIR_Coverage, 1458,
     /* 2363960 */   GIR_EraseRootFromParent_Done,
     /* 2363961 */ // Label 33353: @2363961
     /* 2363961 */ GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2363992), // Rule ID 1459 //
     /* 2363966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2363969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2363980 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2363980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2363983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363985 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2363991 */   // GIR_Coverage, 1459,
     /* 2363991 */   GIR_EraseRootFromParent_Done,
     /* 2363992 */ // Label 33354: @2363992
     /* 2363992 */ GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2364023), // Rule ID 1484 //
     /* 2363997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2364000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364011 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2364011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2364014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364022 */   // GIR_Coverage, 1484,
     /* 2364022 */   GIR_EraseRootFromParent_Done,
     /* 2364023 */ // Label 33355: @2364023
     /* 2364023 */ GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2364054), // Rule ID 1485 //
     /* 2364028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2364031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364042 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2364042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2364045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364053 */   // GIR_Coverage, 1485,
     /* 2364053 */   GIR_EraseRootFromParent_Done,
     /* 2364054 */ // Label 33356: @2364054
     /* 2364054 */ GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2364085), // Rule ID 1856 //
     /* 2364059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2364062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364073 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2364076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364084 */   // GIR_Coverage, 1856,
     /* 2364084 */   GIR_EraseRootFromParent_Done,
     /* 2364085 */ // Label 33357: @2364085
     /* 2364085 */ GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2364116), // Rule ID 1857 //
     /* 2364090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2364093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364104 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2364104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2364107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364109 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364115 */   // GIR_Coverage, 1857,
     /* 2364115 */   GIR_EraseRootFromParent_Done,
     /* 2364116 */ // Label 33358: @2364116
     /* 2364116 */ GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2364147), // Rule ID 1882 //
     /* 2364121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2364124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2364135 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2364138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364145 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364146 */   // GIR_Coverage, 1882,
     /* 2364146 */   GIR_EraseRootFromParent_Done,
     /* 2364147 */ // Label 33359: @2364147
     /* 2364147 */ GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2364178), // Rule ID 1883 //
     /* 2364152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2364155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2364166 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2364166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2364169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364177 */   // GIR_Coverage, 1883,
     /* 2364177 */   GIR_EraseRootFromParent_Done,
     /* 2364178 */ // Label 33360: @2364178
     /* 2364178 */ GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2364209), // Rule ID 2198 //
     /* 2364183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2364186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364197 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2364200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364202 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364208 */   // GIR_Coverage, 2198,
     /* 2364208 */   GIR_EraseRootFromParent_Done,
     /* 2364209 */ // Label 33361: @2364209
     /* 2364209 */ GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2364240), // Rule ID 2199 //
     /* 2364214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2364217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364228 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2364228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2364231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364233 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364239 */   // GIR_Coverage, 2199,
     /* 2364239 */   GIR_EraseRootFromParent_Done,
     /* 2364240 */ // Label 33362: @2364240
     /* 2364240 */ GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2364271), // Rule ID 2224 //
     /* 2364245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2364248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364259 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2364262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364264 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364270 */   // GIR_Coverage, 2224,
     /* 2364270 */   GIR_EraseRootFromParent_Done,
     /* 2364271 */ // Label 33363: @2364271
     /* 2364271 */ GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2364302), // Rule ID 2225 //
     /* 2364276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2364279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364290 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2364290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2364293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364301 */   // GIR_Coverage, 2225,
     /* 2364301 */   GIR_EraseRootFromParent_Done,
     /* 2364302 */ // Label 33364: @2364302
     /* 2364302 */ GIM_Reject,
     /* 2364303 */ // Label 33351: @2364303
     /* 2364303 */ GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2364334), // Rule ID 1511 //
     /* 2364308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2364311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2364322 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2364322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2364325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364327 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364333 */   // GIR_Coverage, 1511,
     /* 2364333 */   GIR_EraseRootFromParent_Done,
     /* 2364334 */ // Label 33365: @2364334
     /* 2364334 */ GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2364365), // Rule ID 1539 //
     /* 2364339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2364342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364353 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2364353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2364356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364358 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364364 */   // GIR_Coverage, 1539,
     /* 2364364 */   GIR_EraseRootFromParent_Done,
     /* 2364365 */ // Label 33366: @2364365
     /* 2364365 */ GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2364396), // Rule ID 1913 //
     /* 2364370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2364373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364384 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2364387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364389 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364395 */   // GIR_Coverage, 1913,
     /* 2364395 */   GIR_EraseRootFromParent_Done,
     /* 2364396 */ // Label 33367: @2364396
     /* 2364396 */ GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2364427), // Rule ID 1941 //
     /* 2364401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2364404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364415 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2364418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364426 */   // GIR_Coverage, 1941,
     /* 2364426 */   GIR_EraseRootFromParent_Done,
     /* 2364427 */ // Label 33368: @2364427
     /* 2364427 */ GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2364458), // Rule ID 2249 //
     /* 2364432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2364435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364446 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2364449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364457 */   // GIR_Coverage, 2249,
     /* 2364457 */   GIR_EraseRootFromParent_Done,
     /* 2364458 */ // Label 33369: @2364458
     /* 2364458 */ GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2364489), // Rule ID 2275 //
     /* 2364463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2364466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2364469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364477 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2364480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364482 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364488 */   // GIR_Coverage, 2275,
     /* 2364488 */   GIR_EraseRootFromParent_Done,
     /* 2364489 */ // Label 33370: @2364489
     /* 2364489 */ GIM_Reject,
     /* 2364490 */ // Label 33352: @2364490
     /* 2364490 */ GIM_Reject,
     /* 2364491 */ // Label 86: @2364491
     /* 2364491 */ GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2364700),
     /* 2364496 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2364499 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33375*/ GIMT_Encode4(2364699),
     /* 2364510 */   /*GILLT_s16*//*Label 33372*/ GIMT_Encode4(2364522),
     /* 2364514 */   /*GILLT_s32*//*Label 33373*/ GIMT_Encode4(2364581),
     /* 2364518 */   /*GILLT_s64*//*Label 33374*/ GIMT_Encode4(2364640),
     /* 2364522 */   // Label 33372: @2364522
     /* 2364522 */   GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2364580),
     /* 2364527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364531 */     GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2364555), // Rule ID 2251 //
     /* 2364536 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2364539 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2364543 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364543 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2364546 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364548 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364550 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364553 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364554 */       // GIR_Coverage, 2251,
     /* 2364554 */       GIR_EraseRootFromParent_Done,
     /* 2364555 */     // Label 33377: @2364555
     /* 2364555 */     GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2364579), // Rule ID 2277 //
     /* 2364560 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2364563 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2364567 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2364567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2364570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364572 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364574 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364577 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364578 */       // GIR_Coverage, 2277,
     /* 2364578 */       GIR_EraseRootFromParent_Done,
     /* 2364579 */     // Label 33378: @2364579
     /* 2364579 */     GIM_Reject,
     /* 2364580 */   // Label 33376: @2364580
     /* 2364580 */   GIM_Reject,
     /* 2364581 */   // Label 33373: @2364581
     /* 2364581 */   GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2364639),
     /* 2364586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364590 */     GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2364614), // Rule ID 1513 //
     /* 2364595 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2364598 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2364602 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2364602 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2364605 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364607 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364609 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364612 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364613 */       // GIR_Coverage, 1513,
     /* 2364613 */       GIR_EraseRootFromParent_Done,
     /* 2364614 */     // Label 33380: @2364614
     /* 2364614 */     GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2364638), // Rule ID 1541 //
     /* 2364619 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2364622 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2364626 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2364626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2364629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364631 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364633 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364636 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364637 */       // GIR_Coverage, 1541,
     /* 2364637 */       GIR_EraseRootFromParent_Done,
     /* 2364638 */     // Label 33381: @2364638
     /* 2364638 */     GIM_Reject,
     /* 2364639 */   // Label 33379: @2364639
     /* 2364639 */   GIM_Reject,
     /* 2364640 */   // Label 33374: @2364640
     /* 2364640 */   GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2364698),
     /* 2364645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364649 */     GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2364673), // Rule ID 1915 //
     /* 2364654 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2364657 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2364661 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364661 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2364664 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364666 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364668 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364671 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364672 */       // GIR_Coverage, 1915,
     /* 2364672 */       GIR_EraseRootFromParent_Done,
     /* 2364673 */     // Label 33383: @2364673
     /* 2364673 */     GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2364697), // Rule ID 1943 //
     /* 2364678 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2364681 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364685 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2364685 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2364688 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364690 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364692 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364695 */       GIR_RootConstrainSelectedInstOperands,
     /* 2364696 */       // GIR_Coverage, 1943,
     /* 2364696 */       GIR_EraseRootFromParent_Done,
     /* 2364697 */     // Label 33384: @2364697
     /* 2364697 */     GIM_Reject,
     /* 2364698 */   // Label 33382: @2364698
     /* 2364698 */   GIM_Reject,
     /* 2364699 */   // Label 33375: @2364699
     /* 2364699 */   GIM_Reject,
     /* 2364700 */ // Label 33371: @2364700
     /* 2364700 */ GIM_Reject,
     /* 2364701 */ // Label 87: @2364701
     /* 2364701 */ GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2364716), // Rule ID 4 //
     /* 2364706 */   // MIs[0] imm20
     /* 2364706 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2364709 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2364709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2364714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2364715 */   // GIR_Coverage, 4,
     /* 2364715 */   GIR_Done,
     /* 2364716 */ // Label 33385: @2364716
     /* 2364716 */ GIM_Reject,
     /* 2364717 */ // Label 88: @2364717
     /* 2364717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33410*/ GIMT_Encode4(2367236),
     /* 2364728 */ /*GILLT_s32*//*Label 33386*/ GIMT_Encode4(2364852),
     /* 2364732 */ /*GILLT_s64*//*Label 33387*/ GIMT_Encode4(2364900), GIMT_Encode4(0),
     /* 2364740 */ /*GILLT_nxv1s8*//*Label 33388*/ GIMT_Encode4(2364948),
     /* 2364744 */ /*GILLT_nxv1s16*//*Label 33389*/ GIMT_Encode4(2365052),
     /* 2364748 */ /*GILLT_nxv1s32*//*Label 33390*/ GIMT_Encode4(2365156),
     /* 2364752 */ /*GILLT_nxv1s64*//*Label 33391*/ GIMT_Encode4(2365260), GIMT_Encode4(0),
     /* 2364760 */ /*GILLT_nxv2s8*//*Label 33392*/ GIMT_Encode4(2365364),
     /* 2364764 */ /*GILLT_nxv2s16*//*Label 33393*/ GIMT_Encode4(2365468),
     /* 2364768 */ /*GILLT_nxv2s32*//*Label 33394*/ GIMT_Encode4(2365572),
     /* 2364772 */ /*GILLT_nxv2s64*//*Label 33395*/ GIMT_Encode4(2365676), GIMT_Encode4(0),
     /* 2364780 */ /*GILLT_nxv4s8*//*Label 33396*/ GIMT_Encode4(2365780),
     /* 2364784 */ /*GILLT_nxv4s16*//*Label 33397*/ GIMT_Encode4(2365884),
     /* 2364788 */ /*GILLT_nxv4s32*//*Label 33398*/ GIMT_Encode4(2365988),
     /* 2364792 */ /*GILLT_nxv4s64*//*Label 33399*/ GIMT_Encode4(2366092), GIMT_Encode4(0),
     /* 2364800 */ /*GILLT_nxv8s8*//*Label 33400*/ GIMT_Encode4(2366196),
     /* 2364804 */ /*GILLT_nxv8s16*//*Label 33401*/ GIMT_Encode4(2366300),
     /* 2364808 */ /*GILLT_nxv8s32*//*Label 33402*/ GIMT_Encode4(2366404),
     /* 2364812 */ /*GILLT_nxv8s64*//*Label 33403*/ GIMT_Encode4(2366508), GIMT_Encode4(0),
     /* 2364820 */ /*GILLT_nxv16s8*//*Label 33404*/ GIMT_Encode4(2366612),
     /* 2364824 */ /*GILLT_nxv16s16*//*Label 33405*/ GIMT_Encode4(2366716),
     /* 2364828 */ /*GILLT_nxv16s32*//*Label 33406*/ GIMT_Encode4(2366820), GIMT_Encode4(0),
     /* 2364836 */ /*GILLT_nxv32s8*//*Label 33407*/ GIMT_Encode4(2366924),
     /* 2364840 */ /*GILLT_nxv32s16*//*Label 33408*/ GIMT_Encode4(2367028), GIMT_Encode4(0),
     /* 2364848 */ /*GILLT_nxv64s8*//*Label 33409*/ GIMT_Encode4(2367132),
     /* 2364852 */ // Label 33386: @2364852
     /* 2364852 */ GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2364899),
     /* 2364857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2364860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364868 */   GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2364883), // Rule ID 2509 //
     /* 2364873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2364876 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2364876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2364881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364882 */     // GIR_Coverage, 2509,
     /* 2364882 */     GIR_Done,
     /* 2364883 */   // Label 33412: @2364883
     /* 2364883 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2364898), // Rule ID 64431 //
     /* 2364888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2364891 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2364891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2364896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364897 */     // GIR_Coverage, 64431,
     /* 2364897 */     GIR_Done,
     /* 2364898 */   // Label 33413: @2364898
     /* 2364898 */   GIM_Reject,
     /* 2364899 */ // Label 33411: @2364899
     /* 2364899 */ GIM_Reject,
     /* 2364900 */ // Label 33387: @2364900
     /* 2364900 */ GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2364947),
     /* 2364905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2364908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2364916 */   GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2364931), // Rule ID 2508 //
     /* 2364921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2364924 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2364924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2364929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364930 */     // GIR_Coverage, 2508,
     /* 2364930 */     GIR_Done,
     /* 2364931 */   // Label 33415: @2364931
     /* 2364931 */   GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2364946), // Rule ID 64430 //
     /* 2364936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2364939 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2364939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2364944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364945 */     // GIR_Coverage, 64430,
     /* 2364945 */     GIR_Done,
     /* 2364946 */   // Label 33416: @2364946
     /* 2364946 */   GIM_Reject,
     /* 2364947 */ // Label 33414: @2364947
     /* 2364947 */ GIM_Reject,
     /* 2364948 */ // Label 33388: @2364948
     /* 2364948 */ GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2365051),
     /* 2364953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2364956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364964 */   GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2365007), // Rule ID 59176 //
     /* 2364969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364972 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2364975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2364989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365006 */     // GIR_Coverage, 59176,
     /* 2365006 */     GIR_EraseRootFromParent_Done,
     /* 2365007 */   // Label 33418: @2365007
     /* 2365007 */   GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2365050), // Rule ID 59177 //
     /* 2365012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365015 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2365018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2365032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365049 */     // GIR_Coverage, 59177,
     /* 2365049 */     GIR_EraseRootFromParent_Done,
     /* 2365050 */   // Label 33419: @2365050
     /* 2365050 */   GIM_Reject,
     /* 2365051 */ // Label 33417: @2365051
     /* 2365051 */ GIM_Reject,
     /* 2365052 */ // Label 33389: @2365052
     /* 2365052 */ GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2365155),
     /* 2365057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2365060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365068 */   GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2365111), // Rule ID 59182 //
     /* 2365073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365076 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2365079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2365093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365110 */     // GIR_Coverage, 59182,
     /* 2365110 */     GIR_EraseRootFromParent_Done,
     /* 2365111 */   // Label 33421: @2365111
     /* 2365111 */   GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2365154), // Rule ID 59183 //
     /* 2365116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365119 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2365122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2365136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365153 */     // GIR_Coverage, 59183,
     /* 2365153 */     GIR_EraseRootFromParent_Done,
     /* 2365154 */   // Label 33422: @2365154
     /* 2365154 */   GIM_Reject,
     /* 2365155 */ // Label 33420: @2365155
     /* 2365155 */ GIM_Reject,
     /* 2365156 */ // Label 33390: @2365156
     /* 2365156 */ GIM_Try, /*On fail goto*//*Label 33423*/ GIMT_Encode4(2365259),
     /* 2365161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2365164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365172 */   GIM_Try, /*On fail goto*//*Label 33424*/ GIMT_Encode4(2365215), // Rule ID 59186 //
     /* 2365177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365180 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2365183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365214 */     // GIR_Coverage, 59186,
     /* 2365214 */     GIR_EraseRootFromParent_Done,
     /* 2365215 */   // Label 33424: @2365215
     /* 2365215 */   GIM_Try, /*On fail goto*//*Label 33425*/ GIMT_Encode4(2365258), // Rule ID 59187 //
     /* 2365220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365223 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2365226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365257 */     // GIR_Coverage, 59187,
     /* 2365257 */     GIR_EraseRootFromParent_Done,
     /* 2365258 */   // Label 33425: @2365258
     /* 2365258 */   GIM_Reject,
     /* 2365259 */ // Label 33423: @2365259
     /* 2365259 */ GIM_Reject,
     /* 2365260 */ // Label 33391: @2365260
     /* 2365260 */ GIM_Try, /*On fail goto*//*Label 33426*/ GIMT_Encode4(2365363),
     /* 2365265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2365268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365276 */   GIM_Try, /*On fail goto*//*Label 33427*/ GIMT_Encode4(2365319), // Rule ID 59194 //
     /* 2365281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2365284 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2365287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365318 */     // GIR_Coverage, 59194,
     /* 2365318 */     GIR_EraseRootFromParent_Done,
     /* 2365319 */   // Label 33427: @2365319
     /* 2365319 */   GIM_Try, /*On fail goto*//*Label 33428*/ GIMT_Encode4(2365362), // Rule ID 59195 //
     /* 2365324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2365327 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2365330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365361 */     // GIR_Coverage, 59195,
     /* 2365361 */     GIR_EraseRootFromParent_Done,
     /* 2365362 */   // Label 33428: @2365362
     /* 2365362 */   GIM_Reject,
     /* 2365363 */ // Label 33426: @2365363
     /* 2365363 */ GIM_Reject,
     /* 2365364 */ // Label 33392: @2365364
     /* 2365364 */ GIM_Try, /*On fail goto*//*Label 33429*/ GIMT_Encode4(2365467),
     /* 2365369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2365372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365380 */   GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2365423), // Rule ID 59178 //
     /* 2365385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365388 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2365391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2365405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365422 */     // GIR_Coverage, 59178,
     /* 2365422 */     GIR_EraseRootFromParent_Done,
     /* 2365423 */   // Label 33430: @2365423
     /* 2365423 */   GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2365466), // Rule ID 59179 //
     /* 2365428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365431 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2365434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2365448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365465 */     // GIR_Coverage, 59179,
     /* 2365465 */     GIR_EraseRootFromParent_Done,
     /* 2365466 */   // Label 33431: @2365466
     /* 2365466 */   GIM_Reject,
     /* 2365467 */ // Label 33429: @2365467
     /* 2365467 */ GIM_Reject,
     /* 2365468 */ // Label 33393: @2365468
     /* 2365468 */ GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2365571),
     /* 2365473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2365476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365484 */   GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2365527), // Rule ID 59184 //
     /* 2365489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365492 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2365495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365526 */     // GIR_Coverage, 59184,
     /* 2365526 */     GIR_EraseRootFromParent_Done,
     /* 2365527 */   // Label 33433: @2365527
     /* 2365527 */   GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2365570), // Rule ID 59185 //
     /* 2365532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365535 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2365538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365569 */     // GIR_Coverage, 59185,
     /* 2365569 */     GIR_EraseRootFromParent_Done,
     /* 2365570 */   // Label 33434: @2365570
     /* 2365570 */   GIM_Reject,
     /* 2365571 */ // Label 33432: @2365571
     /* 2365571 */ GIM_Reject,
     /* 2365572 */ // Label 33394: @2365572
     /* 2365572 */ GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2365675),
     /* 2365577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2365580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365588 */   GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2365631), // Rule ID 59192 //
     /* 2365593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365596 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2365599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365630 */     // GIR_Coverage, 59192,
     /* 2365630 */     GIR_EraseRootFromParent_Done,
     /* 2365631 */   // Label 33436: @2365631
     /* 2365631 */   GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2365674), // Rule ID 59193 //
     /* 2365636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365639 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2365642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365673 */     // GIR_Coverage, 59193,
     /* 2365673 */     GIR_EraseRootFromParent_Done,
     /* 2365674 */   // Label 33437: @2365674
     /* 2365674 */   GIM_Reject,
     /* 2365675 */ // Label 33435: @2365675
     /* 2365675 */ GIM_Reject,
     /* 2365676 */ // Label 33395: @2365676
     /* 2365676 */ GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2365779),
     /* 2365681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2365684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365692 */   GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2365735), // Rule ID 59214 //
     /* 2365697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2365700 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2365717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365734 */     // GIR_Coverage, 59214,
     /* 2365734 */     GIR_EraseRootFromParent_Done,
     /* 2365735 */   // Label 33439: @2365735
     /* 2365735 */   GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2365778), // Rule ID 59215 //
     /* 2365740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2365743 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2365746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2365760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365777 */     // GIR_Coverage, 59215,
     /* 2365777 */     GIR_EraseRootFromParent_Done,
     /* 2365778 */   // Label 33440: @2365778
     /* 2365778 */   GIM_Reject,
     /* 2365779 */ // Label 33438: @2365779
     /* 2365779 */ GIM_Reject,
     /* 2365780 */ // Label 33396: @2365780
     /* 2365780 */ GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2365883),
     /* 2365785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2365788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365796 */   GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2365839), // Rule ID 59180 //
     /* 2365801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365804 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2365807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365838 */     // GIR_Coverage, 59180,
     /* 2365838 */     GIR_EraseRootFromParent_Done,
     /* 2365839 */   // Label 33442: @2365839
     /* 2365839 */   GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2365882), // Rule ID 59181 //
     /* 2365844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365847 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2365850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2365864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365881 */     // GIR_Coverage, 59181,
     /* 2365881 */     GIR_EraseRootFromParent_Done,
     /* 2365882 */   // Label 33443: @2365882
     /* 2365882 */   GIM_Reject,
     /* 2365883 */ // Label 33441: @2365883
     /* 2365883 */ GIM_Reject,
     /* 2365884 */ // Label 33397: @2365884
     /* 2365884 */ GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2365987),
     /* 2365889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2365892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365900 */   GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2365943), // Rule ID 59190 //
     /* 2365905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365908 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365942 */     // GIR_Coverage, 59190,
     /* 2365942 */     GIR_EraseRootFromParent_Done,
     /* 2365943 */   // Label 33445: @2365943
     /* 2365943 */   GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2365986), // Rule ID 59191 //
     /* 2365948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365951 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2365954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2365968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365985 */     // GIR_Coverage, 59191,
     /* 2365985 */     GIR_EraseRootFromParent_Done,
     /* 2365986 */   // Label 33446: @2365986
     /* 2365986 */   GIM_Reject,
     /* 2365987 */ // Label 33444: @2365987
     /* 2365987 */ GIM_Reject,
     /* 2365988 */ // Label 33398: @2365988
     /* 2365988 */ GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2366091),
     /* 2365993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2365996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366004 */   GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2366047), // Rule ID 59208 //
     /* 2366009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366012 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366046 */     // GIR_Coverage, 59208,
     /* 2366046 */     GIR_EraseRootFromParent_Done,
     /* 2366047 */   // Label 33448: @2366047
     /* 2366047 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2366090), // Rule ID 59209 //
     /* 2366052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366055 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366089 */     // GIR_Coverage, 59209,
     /* 2366089 */     GIR_EraseRootFromParent_Done,
     /* 2366090 */   // Label 33449: @2366090
     /* 2366090 */   GIM_Reject,
     /* 2366091 */ // Label 33447: @2366091
     /* 2366091 */ GIM_Reject,
     /* 2366092 */ // Label 33399: @2366092
     /* 2366092 */ GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2366195),
     /* 2366097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2366100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366108 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2366151), // Rule ID 59216 //
     /* 2366113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2366116 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366150 */     // GIR_Coverage, 59216,
     /* 2366150 */     GIR_EraseRootFromParent_Done,
     /* 2366151 */   // Label 33451: @2366151
     /* 2366151 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2366194), // Rule ID 59217 //
     /* 2366156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2366159 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2366162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366193 */     // GIR_Coverage, 59217,
     /* 2366193 */     GIR_EraseRootFromParent_Done,
     /* 2366194 */   // Label 33452: @2366194
     /* 2366194 */   GIM_Reject,
     /* 2366195 */ // Label 33450: @2366195
     /* 2366195 */ GIM_Reject,
     /* 2366196 */ // Label 33400: @2366196
     /* 2366196 */ GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2366299),
     /* 2366201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2366204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366212 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2366255), // Rule ID 59188 //
     /* 2366217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366220 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2366223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2366237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366254 */     // GIR_Coverage, 59188,
     /* 2366254 */     GIR_EraseRootFromParent_Done,
     /* 2366255 */   // Label 33454: @2366255
     /* 2366255 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2366298), // Rule ID 59189 //
     /* 2366260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366263 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2366266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2366280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366297 */     // GIR_Coverage, 59189,
     /* 2366297 */     GIR_EraseRootFromParent_Done,
     /* 2366298 */   // Label 33455: @2366298
     /* 2366298 */   GIM_Reject,
     /* 2366299 */ // Label 33453: @2366299
     /* 2366299 */ GIM_Reject,
     /* 2366300 */ // Label 33401: @2366300
     /* 2366300 */ GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2366403),
     /* 2366305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2366308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366316 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2366359), // Rule ID 59202 //
     /* 2366321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366324 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2366327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366358 */     // GIR_Coverage, 59202,
     /* 2366358 */     GIR_EraseRootFromParent_Done,
     /* 2366359 */   // Label 33457: @2366359
     /* 2366359 */   GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2366402), // Rule ID 59203 //
     /* 2366364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366367 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2366370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366401 */     // GIR_Coverage, 59203,
     /* 2366401 */     GIR_EraseRootFromParent_Done,
     /* 2366402 */   // Label 33458: @2366402
     /* 2366402 */   GIM_Reject,
     /* 2366403 */ // Label 33456: @2366403
     /* 2366403 */ GIM_Reject,
     /* 2366404 */ // Label 33402: @2366404
     /* 2366404 */ GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2366507),
     /* 2366409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2366412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366420 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2366463), // Rule ID 59210 //
     /* 2366425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366428 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2366431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366462 */     // GIR_Coverage, 59210,
     /* 2366462 */     GIR_EraseRootFromParent_Done,
     /* 2366463 */   // Label 33460: @2366463
     /* 2366463 */   GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2366506), // Rule ID 59211 //
     /* 2366468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366471 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2366474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366505 */     // GIR_Coverage, 59211,
     /* 2366505 */     GIR_EraseRootFromParent_Done,
     /* 2366506 */   // Label 33461: @2366506
     /* 2366506 */   GIM_Reject,
     /* 2366507 */ // Label 33459: @2366507
     /* 2366507 */ GIM_Reject,
     /* 2366508 */ // Label 33403: @2366508
     /* 2366508 */ GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2366611),
     /* 2366513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2366516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366524 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2366567), // Rule ID 59218 //
     /* 2366529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2366532 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2366535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2366549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366566 */     // GIR_Coverage, 59218,
     /* 2366566 */     GIR_EraseRootFromParent_Done,
     /* 2366567 */   // Label 33463: @2366567
     /* 2366567 */   GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2366610), // Rule ID 59219 //
     /* 2366572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2366575 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2366578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2366592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366609 */     // GIR_Coverage, 59219,
     /* 2366609 */     GIR_EraseRootFromParent_Done,
     /* 2366610 */   // Label 33464: @2366610
     /* 2366610 */   GIM_Reject,
     /* 2366611 */ // Label 33462: @2366611
     /* 2366611 */ GIM_Reject,
     /* 2366612 */ // Label 33404: @2366612
     /* 2366612 */ GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2366715),
     /* 2366617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2366620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366628 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2366671), // Rule ID 59196 //
     /* 2366633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366636 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2366639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366670 */     // GIR_Coverage, 59196,
     /* 2366670 */     GIR_EraseRootFromParent_Done,
     /* 2366671 */   // Label 33466: @2366671
     /* 2366671 */   GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2366714), // Rule ID 59197 //
     /* 2366676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366679 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2366682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2366696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366713 */     // GIR_Coverage, 59197,
     /* 2366713 */     GIR_EraseRootFromParent_Done,
     /* 2366714 */   // Label 33467: @2366714
     /* 2366714 */   GIM_Reject,
     /* 2366715 */ // Label 33465: @2366715
     /* 2366715 */ GIM_Reject,
     /* 2366716 */ // Label 33405: @2366716
     /* 2366716 */ GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2366819),
     /* 2366721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2366724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366732 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2366775), // Rule ID 59204 //
     /* 2366737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366740 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2366743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366774 */     // GIR_Coverage, 59204,
     /* 2366774 */     GIR_EraseRootFromParent_Done,
     /* 2366775 */   // Label 33469: @2366775
     /* 2366775 */   GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2366818), // Rule ID 59205 //
     /* 2366780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366783 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2366786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366817 */     // GIR_Coverage, 59205,
     /* 2366817 */     GIR_EraseRootFromParent_Done,
     /* 2366818 */   // Label 33470: @2366818
     /* 2366818 */   GIM_Reject,
     /* 2366819 */ // Label 33468: @2366819
     /* 2366819 */ GIM_Reject,
     /* 2366820 */ // Label 33406: @2366820
     /* 2366820 */ GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2366923),
     /* 2366825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2366828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366836 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2366879), // Rule ID 59212 //
     /* 2366841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366844 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2366847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2366861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366878 */     // GIR_Coverage, 59212,
     /* 2366878 */     GIR_EraseRootFromParent_Done,
     /* 2366879 */   // Label 33472: @2366879
     /* 2366879 */   GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2366922), // Rule ID 59213 //
     /* 2366884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366887 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2366890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2366904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366921 */     // GIR_Coverage, 59213,
     /* 2366921 */     GIR_EraseRootFromParent_Done,
     /* 2366922 */   // Label 33473: @2366922
     /* 2366922 */   GIM_Reject,
     /* 2366923 */ // Label 33471: @2366923
     /* 2366923 */ GIM_Reject,
     /* 2366924 */ // Label 33407: @2366924
     /* 2366924 */ GIM_Try, /*On fail goto*//*Label 33474*/ GIMT_Encode4(2367027),
     /* 2366929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2366932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366940 */   GIM_Try, /*On fail goto*//*Label 33475*/ GIMT_Encode4(2366983), // Rule ID 59198 //
     /* 2366945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366948 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2366965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366982 */     // GIR_Coverage, 59198,
     /* 2366982 */     GIR_EraseRootFromParent_Done,
     /* 2366983 */   // Label 33475: @2366983
     /* 2366983 */   GIM_Try, /*On fail goto*//*Label 33476*/ GIMT_Encode4(2367026), // Rule ID 59199 //
     /* 2366988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366991 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2367008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367025 */     // GIR_Coverage, 59199,
     /* 2367025 */     GIR_EraseRootFromParent_Done,
     /* 2367026 */   // Label 33476: @2367026
     /* 2367026 */   GIM_Reject,
     /* 2367027 */ // Label 33474: @2367027
     /* 2367027 */ GIM_Reject,
     /* 2367028 */ // Label 33408: @2367028
     /* 2367028 */ GIM_Try, /*On fail goto*//*Label 33477*/ GIMT_Encode4(2367131),
     /* 2367033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2367036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367044 */   GIM_Try, /*On fail goto*//*Label 33478*/ GIMT_Encode4(2367087), // Rule ID 59206 //
     /* 2367049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367052 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2367069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367086 */     // GIR_Coverage, 59206,
     /* 2367086 */     GIR_EraseRootFromParent_Done,
     /* 2367087 */   // Label 33478: @2367087
     /* 2367087 */   GIM_Try, /*On fail goto*//*Label 33479*/ GIMT_Encode4(2367130), // Rule ID 59207 //
     /* 2367092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367095 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2367112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367129 */     // GIR_Coverage, 59207,
     /* 2367129 */     GIR_EraseRootFromParent_Done,
     /* 2367130 */   // Label 33479: @2367130
     /* 2367130 */   GIM_Reject,
     /* 2367131 */ // Label 33477: @2367131
     /* 2367131 */ GIM_Reject,
     /* 2367132 */ // Label 33409: @2367132
     /* 2367132 */ GIM_Try, /*On fail goto*//*Label 33480*/ GIMT_Encode4(2367235),
     /* 2367137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2367140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367148 */   GIM_Try, /*On fail goto*//*Label 33481*/ GIMT_Encode4(2367191), // Rule ID 59200 //
     /* 2367153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367156 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2367159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2367173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367190 */     // GIR_Coverage, 59200,
     /* 2367190 */     GIR_EraseRootFromParent_Done,
     /* 2367191 */   // Label 33481: @2367191
     /* 2367191 */   GIM_Try, /*On fail goto*//*Label 33482*/ GIMT_Encode4(2367234), // Rule ID 59201 //
     /* 2367196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367199 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2367202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2367216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367233 */     // GIR_Coverage, 59201,
     /* 2367233 */     GIR_EraseRootFromParent_Done,
     /* 2367234 */   // Label 33482: @2367234
     /* 2367234 */   GIM_Reject,
     /* 2367235 */ // Label 33480: @2367235
     /* 2367235 */ GIM_Reject,
     /* 2367236 */ // Label 33410: @2367236
     /* 2367236 */ GIM_Reject,
     /* 2367237 */ // Label 89: @2367237
     /* 2367237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33507*/ GIMT_Encode4(2369894),
     /* 2367248 */ /*GILLT_s32*//*Label 33483*/ GIMT_Encode4(2367372),
     /* 2367252 */ /*GILLT_s64*//*Label 33484*/ GIMT_Encode4(2367489), GIMT_Encode4(0),
     /* 2367260 */ /*GILLT_nxv1s8*//*Label 33485*/ GIMT_Encode4(2367606),
     /* 2367264 */ /*GILLT_nxv1s16*//*Label 33486*/ GIMT_Encode4(2367710),
     /* 2367268 */ /*GILLT_nxv1s32*//*Label 33487*/ GIMT_Encode4(2367814),
     /* 2367272 */ /*GILLT_nxv1s64*//*Label 33488*/ GIMT_Encode4(2367918), GIMT_Encode4(0),
     /* 2367280 */ /*GILLT_nxv2s8*//*Label 33489*/ GIMT_Encode4(2368022),
     /* 2367284 */ /*GILLT_nxv2s16*//*Label 33490*/ GIMT_Encode4(2368126),
     /* 2367288 */ /*GILLT_nxv2s32*//*Label 33491*/ GIMT_Encode4(2368230),
     /* 2367292 */ /*GILLT_nxv2s64*//*Label 33492*/ GIMT_Encode4(2368334), GIMT_Encode4(0),
     /* 2367300 */ /*GILLT_nxv4s8*//*Label 33493*/ GIMT_Encode4(2368438),
     /* 2367304 */ /*GILLT_nxv4s16*//*Label 33494*/ GIMT_Encode4(2368542),
     /* 2367308 */ /*GILLT_nxv4s32*//*Label 33495*/ GIMT_Encode4(2368646),
     /* 2367312 */ /*GILLT_nxv4s64*//*Label 33496*/ GIMT_Encode4(2368750), GIMT_Encode4(0),
     /* 2367320 */ /*GILLT_nxv8s8*//*Label 33497*/ GIMT_Encode4(2368854),
     /* 2367324 */ /*GILLT_nxv8s16*//*Label 33498*/ GIMT_Encode4(2368958),
     /* 2367328 */ /*GILLT_nxv8s32*//*Label 33499*/ GIMT_Encode4(2369062),
     /* 2367332 */ /*GILLT_nxv8s64*//*Label 33500*/ GIMT_Encode4(2369166), GIMT_Encode4(0),
     /* 2367340 */ /*GILLT_nxv16s8*//*Label 33501*/ GIMT_Encode4(2369270),
     /* 2367344 */ /*GILLT_nxv16s16*//*Label 33502*/ GIMT_Encode4(2369374),
     /* 2367348 */ /*GILLT_nxv16s32*//*Label 33503*/ GIMT_Encode4(2369478), GIMT_Encode4(0),
     /* 2367356 */ /*GILLT_nxv32s8*//*Label 33504*/ GIMT_Encode4(2369582),
     /* 2367360 */ /*GILLT_nxv32s16*//*Label 33505*/ GIMT_Encode4(2369686), GIMT_Encode4(0),
     /* 2367368 */ /*GILLT_nxv64s8*//*Label 33506*/ GIMT_Encode4(2369790),
     /* 2367372 */ // Label 33483: @2367372
     /* 2367372 */ GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2367488),
     /* 2367377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2367380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367384 */   GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2367430), // Rule ID 62556 //
     /* 2367389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2367392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2367396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2367400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2367404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2367408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367413 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2367417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2367419 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2367419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2367422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2367428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367429 */     // GIR_Coverage, 62556,
     /* 2367429 */     GIR_EraseRootFromParent_Done,
     /* 2367430 */   // Label 33509: @2367430
     /* 2367430 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2367449), // Rule ID 2507 //
     /* 2367435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2367438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367442 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2367442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2367447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367448 */     // GIR_Coverage, 2507,
     /* 2367448 */     GIR_Done,
     /* 2367449 */   // Label 33510: @2367449
     /* 2367449 */   GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2367468), // Rule ID 62554 //
     /* 2367454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2367457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367461 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2367461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2367466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367467 */     // GIR_Coverage, 62554,
     /* 2367467 */     GIR_Done,
     /* 2367468 */   // Label 33511: @2367468
     /* 2367468 */   GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2367487), // Rule ID 64433 //
     /* 2367473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2367476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367480 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2367480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2367485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367486 */     // GIR_Coverage, 64433,
     /* 2367486 */     GIR_Done,
     /* 2367487 */   // Label 33512: @2367487
     /* 2367487 */   GIM_Reject,
     /* 2367488 */ // Label 33508: @2367488
     /* 2367488 */ GIM_Reject,
     /* 2367489 */ // Label 33484: @2367489
     /* 2367489 */ GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2367605),
     /* 2367494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2367497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367501 */   GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2367547), // Rule ID 62555 //
     /* 2367506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2367509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2367513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2367517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2367521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2367525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367530 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2367534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2367536 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2367536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2367539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2367545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367546 */     // GIR_Coverage, 62555,
     /* 2367546 */     GIR_EraseRootFromParent_Done,
     /* 2367547 */   // Label 33514: @2367547
     /* 2367547 */   GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2367566), // Rule ID 2506 //
     /* 2367552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2367555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367559 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2367559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2367564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367565 */     // GIR_Coverage, 2506,
     /* 2367565 */     GIR_Done,
     /* 2367566 */   // Label 33515: @2367566
     /* 2367566 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2367585), // Rule ID 62553 //
     /* 2367571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2367574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367578 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2367578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2367583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367584 */     // GIR_Coverage, 62553,
     /* 2367584 */     GIR_Done,
     /* 2367585 */   // Label 33516: @2367585
     /* 2367585 */   GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2367604), // Rule ID 64432 //
     /* 2367590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2367593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2367597 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2367597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2367602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367603 */     // GIR_Coverage, 64432,
     /* 2367603 */     GIR_Done,
     /* 2367604 */   // Label 33517: @2367604
     /* 2367604 */   GIM_Reject,
     /* 2367605 */ // Label 33513: @2367605
     /* 2367605 */ GIM_Reject,
     /* 2367606 */ // Label 33485: @2367606
     /* 2367606 */ GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2367709),
     /* 2367611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2367614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367622 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2367665), // Rule ID 59132 //
     /* 2367627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367630 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2367633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2367647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367664 */     // GIR_Coverage, 59132,
     /* 2367664 */     GIR_EraseRootFromParent_Done,
     /* 2367665 */   // Label 33519: @2367665
     /* 2367665 */   GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2367708), // Rule ID 59133 //
     /* 2367670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367673 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2367676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2367690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367707 */     // GIR_Coverage, 59133,
     /* 2367707 */     GIR_EraseRootFromParent_Done,
     /* 2367708 */   // Label 33520: @2367708
     /* 2367708 */   GIM_Reject,
     /* 2367709 */ // Label 33518: @2367709
     /* 2367709 */ GIM_Reject,
     /* 2367710 */ // Label 33486: @2367710
     /* 2367710 */ GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2367813),
     /* 2367715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2367718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367726 */   GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2367769), // Rule ID 59138 //
     /* 2367731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367734 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2367737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2367751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367768 */     // GIR_Coverage, 59138,
     /* 2367768 */     GIR_EraseRootFromParent_Done,
     /* 2367769 */   // Label 33522: @2367769
     /* 2367769 */   GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2367812), // Rule ID 59139 //
     /* 2367774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367777 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2367780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2367794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367811 */     // GIR_Coverage, 59139,
     /* 2367811 */     GIR_EraseRootFromParent_Done,
     /* 2367812 */   // Label 33523: @2367812
     /* 2367812 */   GIM_Reject,
     /* 2367813 */ // Label 33521: @2367813
     /* 2367813 */ GIM_Reject,
     /* 2367814 */ // Label 33487: @2367814
     /* 2367814 */ GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2367917),
     /* 2367819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2367822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367830 */   GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2367873), // Rule ID 59142 //
     /* 2367835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367838 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2367841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2367855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367872 */     // GIR_Coverage, 59142,
     /* 2367872 */     GIR_EraseRootFromParent_Done,
     /* 2367873 */   // Label 33525: @2367873
     /* 2367873 */   GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2367916), // Rule ID 59143 //
     /* 2367878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367881 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2367884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2367898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367915 */     // GIR_Coverage, 59143,
     /* 2367915 */     GIR_EraseRootFromParent_Done,
     /* 2367916 */   // Label 33526: @2367916
     /* 2367916 */   GIM_Reject,
     /* 2367917 */ // Label 33524: @2367917
     /* 2367917 */ GIM_Reject,
     /* 2367918 */ // Label 33488: @2367918
     /* 2367918 */ GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2368021),
     /* 2367923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2367926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367934 */   GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2367977), // Rule ID 59150 //
     /* 2367939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2367942 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2367959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367976 */     // GIR_Coverage, 59150,
     /* 2367976 */     GIR_EraseRootFromParent_Done,
     /* 2367977 */   // Label 33528: @2367977
     /* 2367977 */   GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2368020), // Rule ID 59151 //
     /* 2367982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2367985 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368019 */     // GIR_Coverage, 59151,
     /* 2368019 */     GIR_EraseRootFromParent_Done,
     /* 2368020 */   // Label 33529: @2368020
     /* 2368020 */   GIM_Reject,
     /* 2368021 */ // Label 33527: @2368021
     /* 2368021 */ GIM_Reject,
     /* 2368022 */ // Label 33489: @2368022
     /* 2368022 */ GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2368125),
     /* 2368027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2368030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368038 */   GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2368081), // Rule ID 59134 //
     /* 2368043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368046 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2368049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2368063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368080 */     // GIR_Coverage, 59134,
     /* 2368080 */     GIR_EraseRootFromParent_Done,
     /* 2368081 */   // Label 33531: @2368081
     /* 2368081 */   GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2368124), // Rule ID 59135 //
     /* 2368086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368089 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2368092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2368106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368123 */     // GIR_Coverage, 59135,
     /* 2368123 */     GIR_EraseRootFromParent_Done,
     /* 2368124 */   // Label 33532: @2368124
     /* 2368124 */   GIM_Reject,
     /* 2368125 */ // Label 33530: @2368125
     /* 2368125 */ GIM_Reject,
     /* 2368126 */ // Label 33490: @2368126
     /* 2368126 */ GIM_Try, /*On fail goto*//*Label 33533*/ GIMT_Encode4(2368229),
     /* 2368131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2368134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368142 */   GIM_Try, /*On fail goto*//*Label 33534*/ GIMT_Encode4(2368185), // Rule ID 59140 //
     /* 2368147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368150 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2368167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368184 */     // GIR_Coverage, 59140,
     /* 2368184 */     GIR_EraseRootFromParent_Done,
     /* 2368185 */   // Label 33534: @2368185
     /* 2368185 */   GIM_Try, /*On fail goto*//*Label 33535*/ GIMT_Encode4(2368228), // Rule ID 59141 //
     /* 2368190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368193 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2368210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368227 */     // GIR_Coverage, 59141,
     /* 2368227 */     GIR_EraseRootFromParent_Done,
     /* 2368228 */   // Label 33535: @2368228
     /* 2368228 */   GIM_Reject,
     /* 2368229 */ // Label 33533: @2368229
     /* 2368229 */ GIM_Reject,
     /* 2368230 */ // Label 33491: @2368230
     /* 2368230 */ GIM_Try, /*On fail goto*//*Label 33536*/ GIMT_Encode4(2368333),
     /* 2368235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2368238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368246 */   GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2368289), // Rule ID 59148 //
     /* 2368251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368254 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368288 */     // GIR_Coverage, 59148,
     /* 2368288 */     GIR_EraseRootFromParent_Done,
     /* 2368289 */   // Label 33537: @2368289
     /* 2368289 */   GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2368332), // Rule ID 59149 //
     /* 2368294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368297 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2368300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368331 */     // GIR_Coverage, 59149,
     /* 2368331 */     GIR_EraseRootFromParent_Done,
     /* 2368332 */   // Label 33538: @2368332
     /* 2368332 */   GIM_Reject,
     /* 2368333 */ // Label 33536: @2368333
     /* 2368333 */ GIM_Reject,
     /* 2368334 */ // Label 33492: @2368334
     /* 2368334 */ GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2368437),
     /* 2368339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2368342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368350 */   GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2368393), // Rule ID 59170 //
     /* 2368355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2368358 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2368375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368392 */     // GIR_Coverage, 59170,
     /* 2368392 */     GIR_EraseRootFromParent_Done,
     /* 2368393 */   // Label 33540: @2368393
     /* 2368393 */   GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2368436), // Rule ID 59171 //
     /* 2368398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2368401 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2368404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2368418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368435 */     // GIR_Coverage, 59171,
     /* 2368435 */     GIR_EraseRootFromParent_Done,
     /* 2368436 */   // Label 33541: @2368436
     /* 2368436 */   GIM_Reject,
     /* 2368437 */ // Label 33539: @2368437
     /* 2368437 */ GIM_Reject,
     /* 2368438 */ // Label 33493: @2368438
     /* 2368438 */ GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2368541),
     /* 2368443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2368446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368454 */   GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2368497), // Rule ID 59136 //
     /* 2368459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368462 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2368465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2368479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368496 */     // GIR_Coverage, 59136,
     /* 2368496 */     GIR_EraseRootFromParent_Done,
     /* 2368497 */   // Label 33543: @2368497
     /* 2368497 */   GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2368540), // Rule ID 59137 //
     /* 2368502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368505 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2368508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2368522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368539 */     // GIR_Coverage, 59137,
     /* 2368539 */     GIR_EraseRootFromParent_Done,
     /* 2368540 */   // Label 33544: @2368540
     /* 2368540 */   GIM_Reject,
     /* 2368541 */ // Label 33542: @2368541
     /* 2368541 */ GIM_Reject,
     /* 2368542 */ // Label 33494: @2368542
     /* 2368542 */ GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2368645),
     /* 2368547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2368550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368558 */   GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2368601), // Rule ID 59146 //
     /* 2368563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368566 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368600 */     // GIR_Coverage, 59146,
     /* 2368600 */     GIR_EraseRootFromParent_Done,
     /* 2368601 */   // Label 33546: @2368601
     /* 2368601 */   GIM_Try, /*On fail goto*//*Label 33547*/ GIMT_Encode4(2368644), // Rule ID 59147 //
     /* 2368606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368609 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2368612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368643 */     // GIR_Coverage, 59147,
     /* 2368643 */     GIR_EraseRootFromParent_Done,
     /* 2368644 */   // Label 33547: @2368644
     /* 2368644 */   GIM_Reject,
     /* 2368645 */ // Label 33545: @2368645
     /* 2368645 */ GIM_Reject,
     /* 2368646 */ // Label 33495: @2368646
     /* 2368646 */ GIM_Try, /*On fail goto*//*Label 33548*/ GIMT_Encode4(2368749),
     /* 2368651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2368654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368662 */   GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2368705), // Rule ID 59164 //
     /* 2368667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368670 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2368687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368704 */     // GIR_Coverage, 59164,
     /* 2368704 */     GIR_EraseRootFromParent_Done,
     /* 2368705 */   // Label 33549: @2368705
     /* 2368705 */   GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2368748), // Rule ID 59165 //
     /* 2368710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368713 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2368716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2368730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368747 */     // GIR_Coverage, 59165,
     /* 2368747 */     GIR_EraseRootFromParent_Done,
     /* 2368748 */   // Label 33550: @2368748
     /* 2368748 */   GIM_Reject,
     /* 2368749 */ // Label 33548: @2368749
     /* 2368749 */ GIM_Reject,
     /* 2368750 */ // Label 33496: @2368750
     /* 2368750 */ GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2368853),
     /* 2368755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2368758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368766 */   GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2368809), // Rule ID 59172 //
     /* 2368771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2368774 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2368777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2368791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368808 */     // GIR_Coverage, 59172,
     /* 2368808 */     GIR_EraseRootFromParent_Done,
     /* 2368809 */   // Label 33552: @2368809
     /* 2368809 */   GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2368852), // Rule ID 59173 //
     /* 2368814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2368817 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2368820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2368834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368851 */     // GIR_Coverage, 59173,
     /* 2368851 */     GIR_EraseRootFromParent_Done,
     /* 2368852 */   // Label 33553: @2368852
     /* 2368852 */   GIM_Reject,
     /* 2368853 */ // Label 33551: @2368853
     /* 2368853 */ GIM_Reject,
     /* 2368854 */ // Label 33497: @2368854
     /* 2368854 */ GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2368957),
     /* 2368859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2368862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368870 */   GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2368913), // Rule ID 59144 //
     /* 2368875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368878 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368912 */     // GIR_Coverage, 59144,
     /* 2368912 */     GIR_EraseRootFromParent_Done,
     /* 2368913 */   // Label 33555: @2368913
     /* 2368913 */   GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2368956), // Rule ID 59145 //
     /* 2368918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368921 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2368938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368955 */     // GIR_Coverage, 59145,
     /* 2368955 */     GIR_EraseRootFromParent_Done,
     /* 2368956 */   // Label 33556: @2368956
     /* 2368956 */   GIM_Reject,
     /* 2368957 */ // Label 33554: @2368957
     /* 2368957 */ GIM_Reject,
     /* 2368958 */ // Label 33498: @2368958
     /* 2368958 */ GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2369061),
     /* 2368963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2368966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368974 */   GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2369017), // Rule ID 59158 //
     /* 2368979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368982 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2368985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2368999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369016 */     // GIR_Coverage, 59158,
     /* 2369016 */     GIR_EraseRootFromParent_Done,
     /* 2369017 */   // Label 33558: @2369017
     /* 2369017 */   GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2369060), // Rule ID 59159 //
     /* 2369022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369025 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2369042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369059 */     // GIR_Coverage, 59159,
     /* 2369059 */     GIR_EraseRootFromParent_Done,
     /* 2369060 */   // Label 33559: @2369060
     /* 2369060 */   GIM_Reject,
     /* 2369061 */ // Label 33557: @2369061
     /* 2369061 */ GIM_Reject,
     /* 2369062 */ // Label 33499: @2369062
     /* 2369062 */ GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2369165),
     /* 2369067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2369070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369078 */   GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2369121), // Rule ID 59166 //
     /* 2369083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369086 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369120 */     // GIR_Coverage, 59166,
     /* 2369120 */     GIR_EraseRootFromParent_Done,
     /* 2369121 */   // Label 33561: @2369121
     /* 2369121 */   GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2369164), // Rule ID 59167 //
     /* 2369126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369129 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369163 */     // GIR_Coverage, 59167,
     /* 2369163 */     GIR_EraseRootFromParent_Done,
     /* 2369164 */   // Label 33562: @2369164
     /* 2369164 */   GIM_Reject,
     /* 2369165 */ // Label 33560: @2369165
     /* 2369165 */ GIM_Reject,
     /* 2369166 */ // Label 33500: @2369166
     /* 2369166 */ GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2369269),
     /* 2369171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2369174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369182 */   GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2369225), // Rule ID 59174 //
     /* 2369187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2369190 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369224 */     // GIR_Coverage, 59174,
     /* 2369224 */     GIR_EraseRootFromParent_Done,
     /* 2369225 */   // Label 33564: @2369225
     /* 2369225 */   GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2369268), // Rule ID 59175 //
     /* 2369230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2369233 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369267 */     // GIR_Coverage, 59175,
     /* 2369267 */     GIR_EraseRootFromParent_Done,
     /* 2369268 */   // Label 33565: @2369268
     /* 2369268 */   GIM_Reject,
     /* 2369269 */ // Label 33563: @2369269
     /* 2369269 */ GIM_Reject,
     /* 2369270 */ // Label 33501: @2369270
     /* 2369270 */ GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2369373),
     /* 2369275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2369278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369286 */   GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2369329), // Rule ID 59152 //
     /* 2369291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369294 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2369297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2369311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369328 */     // GIR_Coverage, 59152,
     /* 2369328 */     GIR_EraseRootFromParent_Done,
     /* 2369329 */   // Label 33567: @2369329
     /* 2369329 */   GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2369372), // Rule ID 59153 //
     /* 2369334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369337 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2369340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2369354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369371 */     // GIR_Coverage, 59153,
     /* 2369371 */     GIR_EraseRootFromParent_Done,
     /* 2369372 */   // Label 33568: @2369372
     /* 2369372 */   GIM_Reject,
     /* 2369373 */ // Label 33566: @2369373
     /* 2369373 */ GIM_Reject,
     /* 2369374 */ // Label 33502: @2369374
     /* 2369374 */ GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2369477),
     /* 2369379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2369382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369390 */   GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2369433), // Rule ID 59160 //
     /* 2369395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369398 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369432 */     // GIR_Coverage, 59160,
     /* 2369432 */     GIR_EraseRootFromParent_Done,
     /* 2369433 */   // Label 33570: @2369433
     /* 2369433 */   GIM_Try, /*On fail goto*//*Label 33571*/ GIMT_Encode4(2369476), // Rule ID 59161 //
     /* 2369438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369441 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2369444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369475 */     // GIR_Coverage, 59161,
     /* 2369475 */     GIR_EraseRootFromParent_Done,
     /* 2369476 */   // Label 33571: @2369476
     /* 2369476 */   GIM_Reject,
     /* 2369477 */ // Label 33569: @2369477
     /* 2369477 */ GIM_Reject,
     /* 2369478 */ // Label 33503: @2369478
     /* 2369478 */ GIM_Try, /*On fail goto*//*Label 33572*/ GIMT_Encode4(2369581),
     /* 2369483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2369486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369494 */   GIM_Try, /*On fail goto*//*Label 33573*/ GIMT_Encode4(2369537), // Rule ID 59168 //
     /* 2369499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369502 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369536 */     // GIR_Coverage, 59168,
     /* 2369536 */     GIR_EraseRootFromParent_Done,
     /* 2369537 */   // Label 33573: @2369537
     /* 2369537 */   GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2369580), // Rule ID 59169 //
     /* 2369542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369545 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2369548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369579 */     // GIR_Coverage, 59169,
     /* 2369579 */     GIR_EraseRootFromParent_Done,
     /* 2369580 */   // Label 33574: @2369580
     /* 2369580 */   GIM_Reject,
     /* 2369581 */ // Label 33572: @2369581
     /* 2369581 */ GIM_Reject,
     /* 2369582 */ // Label 33504: @2369582
     /* 2369582 */ GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2369685),
     /* 2369587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2369590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369598 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2369641), // Rule ID 59154 //
     /* 2369603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369606 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2369609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369640 */     // GIR_Coverage, 59154,
     /* 2369640 */     GIR_EraseRootFromParent_Done,
     /* 2369641 */   // Label 33576: @2369641
     /* 2369641 */   GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2369684), // Rule ID 59155 //
     /* 2369646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369649 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2369652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2369666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369683 */     // GIR_Coverage, 59155,
     /* 2369683 */     GIR_EraseRootFromParent_Done,
     /* 2369684 */   // Label 33577: @2369684
     /* 2369684 */   GIM_Reject,
     /* 2369685 */ // Label 33575: @2369685
     /* 2369685 */ GIM_Reject,
     /* 2369686 */ // Label 33505: @2369686
     /* 2369686 */ GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2369789),
     /* 2369691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2369694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369702 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2369745), // Rule ID 59162 //
     /* 2369707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369710 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369744 */     // GIR_Coverage, 59162,
     /* 2369744 */     GIR_EraseRootFromParent_Done,
     /* 2369745 */   // Label 33579: @2369745
     /* 2369745 */   GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2369788), // Rule ID 59163 //
     /* 2369750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369753 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369787 */     // GIR_Coverage, 59163,
     /* 2369787 */     GIR_EraseRootFromParent_Done,
     /* 2369788 */   // Label 33580: @2369788
     /* 2369788 */   GIM_Reject,
     /* 2369789 */ // Label 33578: @2369789
     /* 2369789 */ GIM_Reject,
     /* 2369790 */ // Label 33506: @2369790
     /* 2369790 */ GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2369893),
     /* 2369795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2369798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369806 */   GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2369849), // Rule ID 59156 //
     /* 2369811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2369814 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369848 */     // GIR_Coverage, 59156,
     /* 2369848 */     GIR_EraseRootFromParent_Done,
     /* 2369849 */   // Label 33582: @2369849
     /* 2369849 */   GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2369892), // Rule ID 59157 //
     /* 2369854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2369857 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2369874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369891 */     // GIR_Coverage, 59157,
     /* 2369891 */     GIR_EraseRootFromParent_Done,
     /* 2369892 */   // Label 33583: @2369892
     /* 2369892 */   GIM_Reject,
     /* 2369893 */ // Label 33581: @2369893
     /* 2369893 */ GIM_Reject,
     /* 2369894 */ // Label 33507: @2369894
     /* 2369894 */ GIM_Reject,
     /* 2369895 */ // Label 90: @2369895
     /* 2369895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33608*/ GIMT_Encode4(2372445),
     /* 2369906 */ /*GILLT_s32*//*Label 33584*/ GIMT_Encode4(2370030),
     /* 2369910 */ /*GILLT_s64*//*Label 33585*/ GIMT_Encode4(2370078), GIMT_Encode4(0),
     /* 2369918 */ /*GILLT_nxv1s8*//*Label 33586*/ GIMT_Encode4(2370157),
     /* 2369922 */ /*GILLT_nxv1s16*//*Label 33587*/ GIMT_Encode4(2370261),
     /* 2369926 */ /*GILLT_nxv1s32*//*Label 33588*/ GIMT_Encode4(2370365),
     /* 2369930 */ /*GILLT_nxv1s64*//*Label 33589*/ GIMT_Encode4(2370469), GIMT_Encode4(0),
     /* 2369938 */ /*GILLT_nxv2s8*//*Label 33590*/ GIMT_Encode4(2370573),
     /* 2369942 */ /*GILLT_nxv2s16*//*Label 33591*/ GIMT_Encode4(2370677),
     /* 2369946 */ /*GILLT_nxv2s32*//*Label 33592*/ GIMT_Encode4(2370781),
     /* 2369950 */ /*GILLT_nxv2s64*//*Label 33593*/ GIMT_Encode4(2370885), GIMT_Encode4(0),
     /* 2369958 */ /*GILLT_nxv4s8*//*Label 33594*/ GIMT_Encode4(2370989),
     /* 2369962 */ /*GILLT_nxv4s16*//*Label 33595*/ GIMT_Encode4(2371093),
     /* 2369966 */ /*GILLT_nxv4s32*//*Label 33596*/ GIMT_Encode4(2371197),
     /* 2369970 */ /*GILLT_nxv4s64*//*Label 33597*/ GIMT_Encode4(2371301), GIMT_Encode4(0),
     /* 2369978 */ /*GILLT_nxv8s8*//*Label 33598*/ GIMT_Encode4(2371405),
     /* 2369982 */ /*GILLT_nxv8s16*//*Label 33599*/ GIMT_Encode4(2371509),
     /* 2369986 */ /*GILLT_nxv8s32*//*Label 33600*/ GIMT_Encode4(2371613),
     /* 2369990 */ /*GILLT_nxv8s64*//*Label 33601*/ GIMT_Encode4(2371717), GIMT_Encode4(0),
     /* 2369998 */ /*GILLT_nxv16s8*//*Label 33602*/ GIMT_Encode4(2371821),
     /* 2370002 */ /*GILLT_nxv16s16*//*Label 33603*/ GIMT_Encode4(2371925),
     /* 2370006 */ /*GILLT_nxv16s32*//*Label 33604*/ GIMT_Encode4(2372029), GIMT_Encode4(0),
     /* 2370014 */ /*GILLT_nxv32s8*//*Label 33605*/ GIMT_Encode4(2372133),
     /* 2370018 */ /*GILLT_nxv32s16*//*Label 33606*/ GIMT_Encode4(2372237), GIMT_Encode4(0),
     /* 2370026 */ /*GILLT_nxv64s8*//*Label 33607*/ GIMT_Encode4(2372341),
     /* 2370030 */ // Label 33584: @2370030
     /* 2370030 */ GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2370077),
     /* 2370035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2370038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370046 */   GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2370061), // Rule ID 2511 //
     /* 2370051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2370054 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2370054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2370059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370060 */     // GIR_Coverage, 2511,
     /* 2370060 */     GIR_Done,
     /* 2370061 */   // Label 33610: @2370061
     /* 2370061 */   GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2370076), // Rule ID 64436 //
     /* 2370066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2370069 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2370069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2370074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370075 */     // GIR_Coverage, 64436,
     /* 2370075 */     GIR_Done,
     /* 2370076 */   // Label 33611: @2370076
     /* 2370076 */   GIM_Reject,
     /* 2370077 */ // Label 33609: @2370077
     /* 2370077 */ GIM_Reject,
     /* 2370078 */ // Label 33585: @2370078
     /* 2370078 */ GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2370156),
     /* 2370083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2370086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370090 */   GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2370117), // Rule ID 2514 //
     /* 2370095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2370098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2370105 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2370105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2370108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2370115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370116 */     // GIR_Coverage, 2514,
     /* 2370116 */     GIR_EraseRootFromParent_Done,
     /* 2370117 */   // Label 33613: @2370117
     /* 2370117 */   GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2370136), // Rule ID 2510 //
     /* 2370122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2370125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370129 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2370129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2370134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370135 */     // GIR_Coverage, 2510,
     /* 2370135 */     GIR_Done,
     /* 2370136 */   // Label 33614: @2370136
     /* 2370136 */   GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2370155), // Rule ID 64435 //
     /* 2370141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2370144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370148 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2370148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2370153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370154 */     // GIR_Coverage, 64435,
     /* 2370154 */     GIR_Done,
     /* 2370155 */   // Label 33615: @2370155
     /* 2370155 */   GIM_Reject,
     /* 2370156 */ // Label 33612: @2370156
     /* 2370156 */ GIM_Reject,
     /* 2370157 */ // Label 33586: @2370157
     /* 2370157 */ GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2370260),
     /* 2370162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2370165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370173 */   GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2370216), // Rule ID 59220 //
     /* 2370178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370181 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2370198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370215 */     // GIR_Coverage, 59220,
     /* 2370215 */     GIR_EraseRootFromParent_Done,
     /* 2370216 */   // Label 33617: @2370216
     /* 2370216 */   GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2370259), // Rule ID 59221 //
     /* 2370221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370224 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2370241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370258 */     // GIR_Coverage, 59221,
     /* 2370258 */     GIR_EraseRootFromParent_Done,
     /* 2370259 */   // Label 33618: @2370259
     /* 2370259 */   GIM_Reject,
     /* 2370260 */ // Label 33616: @2370260
     /* 2370260 */ GIM_Reject,
     /* 2370261 */ // Label 33587: @2370261
     /* 2370261 */ GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2370364),
     /* 2370266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2370269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370277 */   GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2370320), // Rule ID 59226 //
     /* 2370282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370285 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2370302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370319 */     // GIR_Coverage, 59226,
     /* 2370319 */     GIR_EraseRootFromParent_Done,
     /* 2370320 */   // Label 33620: @2370320
     /* 2370320 */   GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2370363), // Rule ID 59227 //
     /* 2370325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370328 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2370345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370362 */     // GIR_Coverage, 59227,
     /* 2370362 */     GIR_EraseRootFromParent_Done,
     /* 2370363 */   // Label 33621: @2370363
     /* 2370363 */   GIM_Reject,
     /* 2370364 */ // Label 33619: @2370364
     /* 2370364 */ GIM_Reject,
     /* 2370365 */ // Label 33588: @2370365
     /* 2370365 */ GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2370468),
     /* 2370370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2370373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370381 */   GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2370424), // Rule ID 59230 //
     /* 2370386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370389 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2370406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370423 */     // GIR_Coverage, 59230,
     /* 2370423 */     GIR_EraseRootFromParent_Done,
     /* 2370424 */   // Label 33623: @2370424
     /* 2370424 */   GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2370467), // Rule ID 59231 //
     /* 2370429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370432 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2370435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2370449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370466 */     // GIR_Coverage, 59231,
     /* 2370466 */     GIR_EraseRootFromParent_Done,
     /* 2370467 */   // Label 33624: @2370467
     /* 2370467 */   GIM_Reject,
     /* 2370468 */ // Label 33622: @2370468
     /* 2370468 */ GIM_Reject,
     /* 2370469 */ // Label 33589: @2370469
     /* 2370469 */ GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2370572),
     /* 2370474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2370477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370485 */   GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2370528), // Rule ID 59238 //
     /* 2370490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2370493 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2370510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370527 */     // GIR_Coverage, 59238,
     /* 2370527 */     GIR_EraseRootFromParent_Done,
     /* 2370528 */   // Label 33626: @2370528
     /* 2370528 */   GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2370571), // Rule ID 59239 //
     /* 2370533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2370536 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2370539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2370553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370570 */     // GIR_Coverage, 59239,
     /* 2370570 */     GIR_EraseRootFromParent_Done,
     /* 2370571 */   // Label 33627: @2370571
     /* 2370571 */   GIM_Reject,
     /* 2370572 */ // Label 33625: @2370572
     /* 2370572 */ GIM_Reject,
     /* 2370573 */ // Label 33590: @2370573
     /* 2370573 */ GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2370676),
     /* 2370578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2370581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370589 */   GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2370632), // Rule ID 59222 //
     /* 2370594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370597 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2370614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370631 */     // GIR_Coverage, 59222,
     /* 2370631 */     GIR_EraseRootFromParent_Done,
     /* 2370632 */   // Label 33629: @2370632
     /* 2370632 */   GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2370675), // Rule ID 59223 //
     /* 2370637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370640 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2370643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2370657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370674 */     // GIR_Coverage, 59223,
     /* 2370674 */     GIR_EraseRootFromParent_Done,
     /* 2370675 */   // Label 33630: @2370675
     /* 2370675 */   GIM_Reject,
     /* 2370676 */ // Label 33628: @2370676
     /* 2370676 */ GIM_Reject,
     /* 2370677 */ // Label 33591: @2370677
     /* 2370677 */ GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2370780),
     /* 2370682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2370685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370693 */   GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2370736), // Rule ID 59228 //
     /* 2370698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370701 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2370718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370735 */     // GIR_Coverage, 59228,
     /* 2370735 */     GIR_EraseRootFromParent_Done,
     /* 2370736 */   // Label 33632: @2370736
     /* 2370736 */   GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2370779), // Rule ID 59229 //
     /* 2370741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370744 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2370761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370778 */     // GIR_Coverage, 59229,
     /* 2370778 */     GIR_EraseRootFromParent_Done,
     /* 2370779 */   // Label 33633: @2370779
     /* 2370779 */   GIM_Reject,
     /* 2370780 */ // Label 33631: @2370780
     /* 2370780 */ GIM_Reject,
     /* 2370781 */ // Label 33592: @2370781
     /* 2370781 */ GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2370884),
     /* 2370786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2370789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370797 */   GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2370840), // Rule ID 59236 //
     /* 2370802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370805 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2370822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370839 */     // GIR_Coverage, 59236,
     /* 2370839 */     GIR_EraseRootFromParent_Done,
     /* 2370840 */   // Label 33635: @2370840
     /* 2370840 */   GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2370883), // Rule ID 59237 //
     /* 2370845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370848 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2370865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370882 */     // GIR_Coverage, 59237,
     /* 2370882 */     GIR_EraseRootFromParent_Done,
     /* 2370883 */   // Label 33636: @2370883
     /* 2370883 */   GIM_Reject,
     /* 2370884 */ // Label 33634: @2370884
     /* 2370884 */ GIM_Reject,
     /* 2370885 */ // Label 33593: @2370885
     /* 2370885 */ GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2370988),
     /* 2370890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2370893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370901 */   GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2370944), // Rule ID 59258 //
     /* 2370906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2370909 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2370926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370943 */     // GIR_Coverage, 59258,
     /* 2370943 */     GIR_EraseRootFromParent_Done,
     /* 2370944 */   // Label 33638: @2370944
     /* 2370944 */   GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2370987), // Rule ID 59259 //
     /* 2370949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2370952 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2370969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370986 */     // GIR_Coverage, 59259,
     /* 2370986 */     GIR_EraseRootFromParent_Done,
     /* 2370987 */   // Label 33639: @2370987
     /* 2370987 */   GIM_Reject,
     /* 2370988 */ // Label 33637: @2370988
     /* 2370988 */ GIM_Reject,
     /* 2370989 */ // Label 33594: @2370989
     /* 2370989 */ GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2371092),
     /* 2370994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371005 */   GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2371048), // Rule ID 59224 //
     /* 2371010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371013 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2371030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371047 */     // GIR_Coverage, 59224,
     /* 2371047 */     GIR_EraseRootFromParent_Done,
     /* 2371048 */   // Label 33641: @2371048
     /* 2371048 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2371091), // Rule ID 59225 //
     /* 2371053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371056 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2371073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371090 */     // GIR_Coverage, 59225,
     /* 2371090 */     GIR_EraseRootFromParent_Done,
     /* 2371091 */   // Label 33642: @2371091
     /* 2371091 */   GIM_Reject,
     /* 2371092 */ // Label 33640: @2371092
     /* 2371092 */ GIM_Reject,
     /* 2371093 */ // Label 33595: @2371093
     /* 2371093 */ GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2371196),
     /* 2371098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2371101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371109 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2371152), // Rule ID 59234 //
     /* 2371114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371117 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2371134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371151 */     // GIR_Coverage, 59234,
     /* 2371151 */     GIR_EraseRootFromParent_Done,
     /* 2371152 */   // Label 33644: @2371152
     /* 2371152 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2371195), // Rule ID 59235 //
     /* 2371157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371160 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2371177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371194 */     // GIR_Coverage, 59235,
     /* 2371194 */     GIR_EraseRootFromParent_Done,
     /* 2371195 */   // Label 33645: @2371195
     /* 2371195 */   GIM_Reject,
     /* 2371196 */ // Label 33643: @2371196
     /* 2371196 */ GIM_Reject,
     /* 2371197 */ // Label 33596: @2371197
     /* 2371197 */ GIM_Try, /*On fail goto*//*Label 33646*/ GIMT_Encode4(2371300),
     /* 2371202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2371205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371213 */   GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2371256), // Rule ID 59252 //
     /* 2371218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371221 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371255 */     // GIR_Coverage, 59252,
     /* 2371255 */     GIR_EraseRootFromParent_Done,
     /* 2371256 */   // Label 33647: @2371256
     /* 2371256 */   GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2371299), // Rule ID 59253 //
     /* 2371261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371264 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371298 */     // GIR_Coverage, 59253,
     /* 2371298 */     GIR_EraseRootFromParent_Done,
     /* 2371299 */   // Label 33648: @2371299
     /* 2371299 */   GIM_Reject,
     /* 2371300 */ // Label 33646: @2371300
     /* 2371300 */ GIM_Reject,
     /* 2371301 */ // Label 33597: @2371301
     /* 2371301 */ GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2371404),
     /* 2371306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2371309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371317 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2371360), // Rule ID 59260 //
     /* 2371322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2371325 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2371342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371359 */     // GIR_Coverage, 59260,
     /* 2371359 */     GIR_EraseRootFromParent_Done,
     /* 2371360 */   // Label 33650: @2371360
     /* 2371360 */   GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2371403), // Rule ID 59261 //
     /* 2371365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2371368 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2371371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2371385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371402 */     // GIR_Coverage, 59261,
     /* 2371402 */     GIR_EraseRootFromParent_Done,
     /* 2371403 */   // Label 33651: @2371403
     /* 2371403 */   GIM_Reject,
     /* 2371404 */ // Label 33649: @2371404
     /* 2371404 */ GIM_Reject,
     /* 2371405 */ // Label 33598: @2371405
     /* 2371405 */ GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2371508),
     /* 2371410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2371413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371421 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2371464), // Rule ID 59232 //
     /* 2371426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371429 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2371446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371463 */     // GIR_Coverage, 59232,
     /* 2371463 */     GIR_EraseRootFromParent_Done,
     /* 2371464 */   // Label 33653: @2371464
     /* 2371464 */   GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2371507), // Rule ID 59233 //
     /* 2371469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371472 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2371475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2371489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371506 */     // GIR_Coverage, 59233,
     /* 2371506 */     GIR_EraseRootFromParent_Done,
     /* 2371507 */   // Label 33654: @2371507
     /* 2371507 */   GIM_Reject,
     /* 2371508 */ // Label 33652: @2371508
     /* 2371508 */ GIM_Reject,
     /* 2371509 */ // Label 33599: @2371509
     /* 2371509 */ GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2371612),
     /* 2371514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2371517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371525 */   GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2371568), // Rule ID 59246 //
     /* 2371530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371533 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371567 */     // GIR_Coverage, 59246,
     /* 2371567 */     GIR_EraseRootFromParent_Done,
     /* 2371568 */   // Label 33656: @2371568
     /* 2371568 */   GIM_Try, /*On fail goto*//*Label 33657*/ GIMT_Encode4(2371611), // Rule ID 59247 //
     /* 2371573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371576 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2371579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371610 */     // GIR_Coverage, 59247,
     /* 2371610 */     GIR_EraseRootFromParent_Done,
     /* 2371611 */   // Label 33657: @2371611
     /* 2371611 */   GIM_Reject,
     /* 2371612 */ // Label 33655: @2371612
     /* 2371612 */ GIM_Reject,
     /* 2371613 */ // Label 33600: @2371613
     /* 2371613 */ GIM_Try, /*On fail goto*//*Label 33658*/ GIMT_Encode4(2371716),
     /* 2371618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2371621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371629 */   GIM_Try, /*On fail goto*//*Label 33659*/ GIMT_Encode4(2371672), // Rule ID 59254 //
     /* 2371634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371637 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2371654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371671 */     // GIR_Coverage, 59254,
     /* 2371671 */     GIR_EraseRootFromParent_Done,
     /* 2371672 */   // Label 33659: @2371672
     /* 2371672 */   GIM_Try, /*On fail goto*//*Label 33660*/ GIMT_Encode4(2371715), // Rule ID 59255 //
     /* 2371677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371680 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2371697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371714 */     // GIR_Coverage, 59255,
     /* 2371714 */     GIR_EraseRootFromParent_Done,
     /* 2371715 */   // Label 33660: @2371715
     /* 2371715 */   GIM_Reject,
     /* 2371716 */ // Label 33658: @2371716
     /* 2371716 */ GIM_Reject,
     /* 2371717 */ // Label 33601: @2371717
     /* 2371717 */ GIM_Try, /*On fail goto*//*Label 33661*/ GIMT_Encode4(2371820),
     /* 2371722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2371725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371733 */   GIM_Try, /*On fail goto*//*Label 33662*/ GIMT_Encode4(2371776), // Rule ID 59262 //
     /* 2371738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2371741 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2371758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371775 */     // GIR_Coverage, 59262,
     /* 2371775 */     GIR_EraseRootFromParent_Done,
     /* 2371776 */   // Label 33662: @2371776
     /* 2371776 */   GIM_Try, /*On fail goto*//*Label 33663*/ GIMT_Encode4(2371819), // Rule ID 59263 //
     /* 2371781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2371784 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2371801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371818 */     // GIR_Coverage, 59263,
     /* 2371818 */     GIR_EraseRootFromParent_Done,
     /* 2371819 */   // Label 33663: @2371819
     /* 2371819 */   GIM_Reject,
     /* 2371820 */ // Label 33661: @2371820
     /* 2371820 */ GIM_Reject,
     /* 2371821 */ // Label 33602: @2371821
     /* 2371821 */ GIM_Try, /*On fail goto*//*Label 33664*/ GIMT_Encode4(2371924),
     /* 2371826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371837 */   GIM_Try, /*On fail goto*//*Label 33665*/ GIMT_Encode4(2371880), // Rule ID 59240 //
     /* 2371842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371845 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371879 */     // GIR_Coverage, 59240,
     /* 2371879 */     GIR_EraseRootFromParent_Done,
     /* 2371880 */   // Label 33665: @2371880
     /* 2371880 */   GIM_Try, /*On fail goto*//*Label 33666*/ GIMT_Encode4(2371923), // Rule ID 59241 //
     /* 2371885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371888 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2371905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371922 */     // GIR_Coverage, 59241,
     /* 2371922 */     GIR_EraseRootFromParent_Done,
     /* 2371923 */   // Label 33666: @2371923
     /* 2371923 */   GIM_Reject,
     /* 2371924 */ // Label 33664: @2371924
     /* 2371924 */ GIM_Reject,
     /* 2371925 */ // Label 33603: @2371925
     /* 2371925 */ GIM_Try, /*On fail goto*//*Label 33667*/ GIMT_Encode4(2372028),
     /* 2371930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371941 */   GIM_Try, /*On fail goto*//*Label 33668*/ GIMT_Encode4(2371984), // Rule ID 59248 //
     /* 2371946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371949 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2371966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371983 */     // GIR_Coverage, 59248,
     /* 2371983 */     GIR_EraseRootFromParent_Done,
     /* 2371984 */   // Label 33668: @2371984
     /* 2371984 */   GIM_Try, /*On fail goto*//*Label 33669*/ GIMT_Encode4(2372027), // Rule ID 59249 //
     /* 2371989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371992 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2372009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372026 */     // GIR_Coverage, 59249,
     /* 2372026 */     GIR_EraseRootFromParent_Done,
     /* 2372027 */   // Label 33669: @2372027
     /* 2372027 */   GIM_Reject,
     /* 2372028 */ // Label 33667: @2372028
     /* 2372028 */ GIM_Reject,
     /* 2372029 */ // Label 33604: @2372029
     /* 2372029 */ GIM_Try, /*On fail goto*//*Label 33670*/ GIMT_Encode4(2372132),
     /* 2372034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2372037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372045 */   GIM_Try, /*On fail goto*//*Label 33671*/ GIMT_Encode4(2372088), // Rule ID 59256 //
     /* 2372050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372053 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372087 */     // GIR_Coverage, 59256,
     /* 2372087 */     GIR_EraseRootFromParent_Done,
     /* 2372088 */   // Label 33671: @2372088
     /* 2372088 */   GIM_Try, /*On fail goto*//*Label 33672*/ GIMT_Encode4(2372131), // Rule ID 59257 //
     /* 2372093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372096 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372130 */     // GIR_Coverage, 59257,
     /* 2372130 */     GIR_EraseRootFromParent_Done,
     /* 2372131 */   // Label 33672: @2372131
     /* 2372131 */   GIM_Reject,
     /* 2372132 */ // Label 33670: @2372132
     /* 2372132 */ GIM_Reject,
     /* 2372133 */ // Label 33605: @2372133
     /* 2372133 */ GIM_Try, /*On fail goto*//*Label 33673*/ GIMT_Encode4(2372236),
     /* 2372138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2372141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372149 */   GIM_Try, /*On fail goto*//*Label 33674*/ GIMT_Encode4(2372192), // Rule ID 59242 //
     /* 2372154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372157 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2372174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372191 */     // GIR_Coverage, 59242,
     /* 2372191 */     GIR_EraseRootFromParent_Done,
     /* 2372192 */   // Label 33674: @2372192
     /* 2372192 */   GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2372235), // Rule ID 59243 //
     /* 2372197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372200 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2372217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372234 */     // GIR_Coverage, 59243,
     /* 2372234 */     GIR_EraseRootFromParent_Done,
     /* 2372235 */   // Label 33675: @2372235
     /* 2372235 */   GIM_Reject,
     /* 2372236 */ // Label 33673: @2372236
     /* 2372236 */ GIM_Reject,
     /* 2372237 */ // Label 33606: @2372237
     /* 2372237 */ GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2372340),
     /* 2372242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2372245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372253 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2372296), // Rule ID 59250 //
     /* 2372258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372261 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372295 */     // GIR_Coverage, 59250,
     /* 2372295 */     GIR_EraseRootFromParent_Done,
     /* 2372296 */   // Label 33677: @2372296
     /* 2372296 */   GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2372339), // Rule ID 59251 //
     /* 2372301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372304 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372338 */     // GIR_Coverage, 59251,
     /* 2372338 */     GIR_EraseRootFromParent_Done,
     /* 2372339 */   // Label 33678: @2372339
     /* 2372339 */   GIM_Reject,
     /* 2372340 */ // Label 33676: @2372340
     /* 2372340 */ GIM_Reject,
     /* 2372341 */ // Label 33607: @2372341
     /* 2372341 */ GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2372444),
     /* 2372346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2372349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372357 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2372400), // Rule ID 59244 //
     /* 2372362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372365 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372399 */     // GIR_Coverage, 59244,
     /* 2372399 */     GIR_EraseRootFromParent_Done,
     /* 2372400 */   // Label 33680: @2372400
     /* 2372400 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2372443), // Rule ID 59245 //
     /* 2372405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372408 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2372411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2372425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372442 */     // GIR_Coverage, 59245,
     /* 2372442 */     GIR_EraseRootFromParent_Done,
     /* 2372443 */   // Label 33681: @2372443
     /* 2372443 */   GIM_Reject,
     /* 2372444 */ // Label 33679: @2372444
     /* 2372444 */ GIM_Reject,
     /* 2372445 */ // Label 33608: @2372445
     /* 2372445 */ GIM_Reject,
     /* 2372446 */ // Label 91: @2372446
     /* 2372446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33706*/ GIMT_Encode4(2374980),
     /* 2372457 */ /*GILLT_s32*//*Label 33682*/ GIMT_Encode4(2372581),
     /* 2372461 */ /*GILLT_s64*//*Label 33683*/ GIMT_Encode4(2372644), GIMT_Encode4(0),
     /* 2372469 */ /*GILLT_nxv1s8*//*Label 33684*/ GIMT_Encode4(2372692),
     /* 2372473 */ /*GILLT_nxv1s16*//*Label 33685*/ GIMT_Encode4(2372796),
     /* 2372477 */ /*GILLT_nxv1s32*//*Label 33686*/ GIMT_Encode4(2372900),
     /* 2372481 */ /*GILLT_nxv1s64*//*Label 33687*/ GIMT_Encode4(2373004), GIMT_Encode4(0),
     /* 2372489 */ /*GILLT_nxv2s8*//*Label 33688*/ GIMT_Encode4(2373108),
     /* 2372493 */ /*GILLT_nxv2s16*//*Label 33689*/ GIMT_Encode4(2373212),
     /* 2372497 */ /*GILLT_nxv2s32*//*Label 33690*/ GIMT_Encode4(2373316),
     /* 2372501 */ /*GILLT_nxv2s64*//*Label 33691*/ GIMT_Encode4(2373420), GIMT_Encode4(0),
     /* 2372509 */ /*GILLT_nxv4s8*//*Label 33692*/ GIMT_Encode4(2373524),
     /* 2372513 */ /*GILLT_nxv4s16*//*Label 33693*/ GIMT_Encode4(2373628),
     /* 2372517 */ /*GILLT_nxv4s32*//*Label 33694*/ GIMT_Encode4(2373732),
     /* 2372521 */ /*GILLT_nxv4s64*//*Label 33695*/ GIMT_Encode4(2373836), GIMT_Encode4(0),
     /* 2372529 */ /*GILLT_nxv8s8*//*Label 33696*/ GIMT_Encode4(2373940),
     /* 2372533 */ /*GILLT_nxv8s16*//*Label 33697*/ GIMT_Encode4(2374044),
     /* 2372537 */ /*GILLT_nxv8s32*//*Label 33698*/ GIMT_Encode4(2374148),
     /* 2372541 */ /*GILLT_nxv8s64*//*Label 33699*/ GIMT_Encode4(2374252), GIMT_Encode4(0),
     /* 2372549 */ /*GILLT_nxv16s8*//*Label 33700*/ GIMT_Encode4(2374356),
     /* 2372553 */ /*GILLT_nxv16s16*//*Label 33701*/ GIMT_Encode4(2374460),
     /* 2372557 */ /*GILLT_nxv16s32*//*Label 33702*/ GIMT_Encode4(2374564), GIMT_Encode4(0),
     /* 2372565 */ /*GILLT_nxv32s8*//*Label 33703*/ GIMT_Encode4(2374668),
     /* 2372569 */ /*GILLT_nxv32s16*//*Label 33704*/ GIMT_Encode4(2374772), GIMT_Encode4(0),
     /* 2372577 */ /*GILLT_nxv64s8*//*Label 33705*/ GIMT_Encode4(2374876),
     /* 2372581 */ // Label 33682: @2372581
     /* 2372581 */ GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2372643),
     /* 2372586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2372589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372597 */   GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2372612), // Rule ID 2528 //
     /* 2372602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2372605 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2372605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2372610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372611 */     // GIR_Coverage, 2528,
     /* 2372611 */     GIR_Done,
     /* 2372612 */   // Label 33708: @2372612
     /* 2372612 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2372627), // Rule ID 2529 //
     /* 2372617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2372620 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2372620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2372625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372626 */     // GIR_Coverage, 2529,
     /* 2372626 */     GIR_Done,
     /* 2372627 */   // Label 33709: @2372627
     /* 2372627 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2372642), // Rule ID 62558 //
     /* 2372632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2372635 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2372635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2372640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372641 */     // GIR_Coverage, 62558,
     /* 2372641 */     GIR_Done,
     /* 2372642 */   // Label 33710: @2372642
     /* 2372642 */   GIM_Reject,
     /* 2372643 */ // Label 33707: @2372643
     /* 2372643 */ GIM_Reject,
     /* 2372644 */ // Label 33683: @2372644
     /* 2372644 */ GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2372691),
     /* 2372649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2372652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372660 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2372675), // Rule ID 2530 //
     /* 2372665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2372668 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2372668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2372673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372674 */     // GIR_Coverage, 2530,
     /* 2372674 */     GIR_Done,
     /* 2372675 */   // Label 33712: @2372675
     /* 2372675 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2372690), // Rule ID 62557 //
     /* 2372680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2372683 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2372683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2372688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372689 */     // GIR_Coverage, 62557,
     /* 2372689 */     GIR_Done,
     /* 2372690 */   // Label 33713: @2372690
     /* 2372690 */   GIM_Reject,
     /* 2372691 */ // Label 33711: @2372691
     /* 2372691 */ GIM_Reject,
     /* 2372692 */ // Label 33684: @2372692
     /* 2372692 */ GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2372795),
     /* 2372697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2372700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372708 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2372751), // Rule ID 59088 //
     /* 2372713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2372716 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2372733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372750 */     // GIR_Coverage, 59088,
     /* 2372750 */     GIR_EraseRootFromParent_Done,
     /* 2372751 */   // Label 33715: @2372751
     /* 2372751 */   GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2372794), // Rule ID 59089 //
     /* 2372756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2372759 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2372776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372793 */     // GIR_Coverage, 59089,
     /* 2372793 */     GIR_EraseRootFromParent_Done,
     /* 2372794 */   // Label 33716: @2372794
     /* 2372794 */   GIM_Reject,
     /* 2372795 */ // Label 33714: @2372795
     /* 2372795 */ GIM_Reject,
     /* 2372796 */ // Label 33685: @2372796
     /* 2372796 */ GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2372899),
     /* 2372801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372812 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2372855), // Rule ID 59094 //
     /* 2372817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2372820 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2372837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372854 */     // GIR_Coverage, 59094,
     /* 2372854 */     GIR_EraseRootFromParent_Done,
     /* 2372855 */   // Label 33718: @2372855
     /* 2372855 */   GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2372898), // Rule ID 59095 //
     /* 2372860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2372863 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2372880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372897 */     // GIR_Coverage, 59095,
     /* 2372897 */     GIR_EraseRootFromParent_Done,
     /* 2372898 */   // Label 33719: @2372898
     /* 2372898 */   GIM_Reject,
     /* 2372899 */ // Label 33717: @2372899
     /* 2372899 */ GIM_Reject,
     /* 2372900 */ // Label 33686: @2372900
     /* 2372900 */ GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2373003),
     /* 2372905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2372908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372916 */   GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2372959), // Rule ID 59098 //
     /* 2372921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2372924 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2372941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372958 */     // GIR_Coverage, 59098,
     /* 2372958 */     GIR_EraseRootFromParent_Done,
     /* 2372959 */   // Label 33721: @2372959
     /* 2372959 */   GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2373002), // Rule ID 59099 //
     /* 2372964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2372967 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2372984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373001 */     // GIR_Coverage, 59099,
     /* 2373001 */     GIR_EraseRootFromParent_Done,
     /* 2373002 */   // Label 33722: @2373002
     /* 2373002 */   GIM_Reject,
     /* 2373003 */ // Label 33720: @2373003
     /* 2373003 */ GIM_Reject,
     /* 2373004 */ // Label 33687: @2373004
     /* 2373004 */ GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2373107),
     /* 2373009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2373012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373020 */   GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2373063), // Rule ID 59106 //
     /* 2373025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2373028 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373062 */     // GIR_Coverage, 59106,
     /* 2373062 */     GIR_EraseRootFromParent_Done,
     /* 2373063 */   // Label 33724: @2373063
     /* 2373063 */   GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2373106), // Rule ID 59107 //
     /* 2373068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2373071 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2373074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373105 */     // GIR_Coverage, 59107,
     /* 2373105 */     GIR_EraseRootFromParent_Done,
     /* 2373106 */   // Label 33725: @2373106
     /* 2373106 */   GIM_Reject,
     /* 2373107 */ // Label 33723: @2373107
     /* 2373107 */ GIM_Reject,
     /* 2373108 */ // Label 33688: @2373108
     /* 2373108 */ GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2373211),
     /* 2373113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2373116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373124 */   GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2373167), // Rule ID 59090 //
     /* 2373129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373132 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2373149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373166 */     // GIR_Coverage, 59090,
     /* 2373166 */     GIR_EraseRootFromParent_Done,
     /* 2373167 */   // Label 33727: @2373167
     /* 2373167 */   GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2373210), // Rule ID 59091 //
     /* 2373172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373175 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2373178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2373192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373209 */     // GIR_Coverage, 59091,
     /* 2373209 */     GIR_EraseRootFromParent_Done,
     /* 2373210 */   // Label 33728: @2373210
     /* 2373210 */   GIM_Reject,
     /* 2373211 */ // Label 33726: @2373211
     /* 2373211 */ GIM_Reject,
     /* 2373212 */ // Label 33689: @2373212
     /* 2373212 */ GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2373315),
     /* 2373217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2373220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373228 */   GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2373271), // Rule ID 59096 //
     /* 2373233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373236 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2373253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373270 */     // GIR_Coverage, 59096,
     /* 2373270 */     GIR_EraseRootFromParent_Done,
     /* 2373271 */   // Label 33730: @2373271
     /* 2373271 */   GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2373314), // Rule ID 59097 //
     /* 2373276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373279 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2373282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2373296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373313 */     // GIR_Coverage, 59097,
     /* 2373313 */     GIR_EraseRootFromParent_Done,
     /* 2373314 */   // Label 33731: @2373314
     /* 2373314 */   GIM_Reject,
     /* 2373315 */ // Label 33729: @2373315
     /* 2373315 */ GIM_Reject,
     /* 2373316 */ // Label 33690: @2373316
     /* 2373316 */ GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2373419),
     /* 2373321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2373324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373332 */   GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2373375), // Rule ID 59104 //
     /* 2373337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373340 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373374 */     // GIR_Coverage, 59104,
     /* 2373374 */     GIR_EraseRootFromParent_Done,
     /* 2373375 */   // Label 33733: @2373375
     /* 2373375 */   GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2373418), // Rule ID 59105 //
     /* 2373380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373383 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2373386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373417 */     // GIR_Coverage, 59105,
     /* 2373417 */     GIR_EraseRootFromParent_Done,
     /* 2373418 */   // Label 33734: @2373418
     /* 2373418 */   GIM_Reject,
     /* 2373419 */ // Label 33732: @2373419
     /* 2373419 */ GIM_Reject,
     /* 2373420 */ // Label 33691: @2373420
     /* 2373420 */ GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2373523),
     /* 2373425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2373428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373436 */   GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2373479), // Rule ID 59126 //
     /* 2373441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2373444 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2373461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373478 */     // GIR_Coverage, 59126,
     /* 2373478 */     GIR_EraseRootFromParent_Done,
     /* 2373479 */   // Label 33736: @2373479
     /* 2373479 */   GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2373522), // Rule ID 59127 //
     /* 2373484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2373487 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2373504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373521 */     // GIR_Coverage, 59127,
     /* 2373521 */     GIR_EraseRootFromParent_Done,
     /* 2373522 */   // Label 33737: @2373522
     /* 2373522 */   GIM_Reject,
     /* 2373523 */ // Label 33735: @2373523
     /* 2373523 */ GIM_Reject,
     /* 2373524 */ // Label 33692: @2373524
     /* 2373524 */ GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2373627),
     /* 2373529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2373532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373540 */   GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2373583), // Rule ID 59092 //
     /* 2373545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373548 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2373565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373582 */     // GIR_Coverage, 59092,
     /* 2373582 */     GIR_EraseRootFromParent_Done,
     /* 2373583 */   // Label 33739: @2373583
     /* 2373583 */   GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2373626), // Rule ID 59093 //
     /* 2373588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373591 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2373608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373625 */     // GIR_Coverage, 59093,
     /* 2373625 */     GIR_EraseRootFromParent_Done,
     /* 2373626 */   // Label 33740: @2373626
     /* 2373626 */   GIM_Reject,
     /* 2373627 */ // Label 33738: @2373627
     /* 2373627 */ GIM_Reject,
     /* 2373628 */ // Label 33693: @2373628
     /* 2373628 */ GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2373731),
     /* 2373633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2373636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373644 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2373687), // Rule ID 59102 //
     /* 2373649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373652 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373686 */     // GIR_Coverage, 59102,
     /* 2373686 */     GIR_EraseRootFromParent_Done,
     /* 2373687 */   // Label 33742: @2373687
     /* 2373687 */   GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2373730), // Rule ID 59103 //
     /* 2373692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373695 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373729 */     // GIR_Coverage, 59103,
     /* 2373729 */     GIR_EraseRootFromParent_Done,
     /* 2373730 */   // Label 33743: @2373730
     /* 2373730 */   GIM_Reject,
     /* 2373731 */ // Label 33741: @2373731
     /* 2373731 */ GIM_Reject,
     /* 2373732 */ // Label 33694: @2373732
     /* 2373732 */ GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2373835),
     /* 2373737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373748 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2373791), // Rule ID 59120 //
     /* 2373753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373756 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2373773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373790 */     // GIR_Coverage, 59120,
     /* 2373790 */     GIR_EraseRootFromParent_Done,
     /* 2373791 */   // Label 33745: @2373791
     /* 2373791 */   GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2373834), // Rule ID 59121 //
     /* 2373796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2373799 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2373816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373833 */     // GIR_Coverage, 59121,
     /* 2373833 */     GIR_EraseRootFromParent_Done,
     /* 2373834 */   // Label 33746: @2373834
     /* 2373834 */   GIM_Reject,
     /* 2373835 */ // Label 33744: @2373835
     /* 2373835 */ GIM_Reject,
     /* 2373836 */ // Label 33695: @2373836
     /* 2373836 */ GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2373939),
     /* 2373841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2373844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373852 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2373895), // Rule ID 59128 //
     /* 2373857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2373860 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2373877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373894 */     // GIR_Coverage, 59128,
     /* 2373894 */     GIR_EraseRootFromParent_Done,
     /* 2373895 */   // Label 33748: @2373895
     /* 2373895 */   GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2373938), // Rule ID 59129 //
     /* 2373900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2373903 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2373920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373937 */     // GIR_Coverage, 59129,
     /* 2373937 */     GIR_EraseRootFromParent_Done,
     /* 2373938 */   // Label 33749: @2373938
     /* 2373938 */   GIM_Reject,
     /* 2373939 */ // Label 33747: @2373939
     /* 2373939 */ GIM_Reject,
     /* 2373940 */ // Label 33696: @2373940
     /* 2373940 */ GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2374043),
     /* 2373945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2373948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373956 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2373999), // Rule ID 59100 //
     /* 2373961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2373964 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2373967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2373981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373998 */     // GIR_Coverage, 59100,
     /* 2373998 */     GIR_EraseRootFromParent_Done,
     /* 2373999 */   // Label 33751: @2373999
     /* 2373999 */   GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2374042), // Rule ID 59101 //
     /* 2374004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374007 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2374010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2374024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374041 */     // GIR_Coverage, 59101,
     /* 2374041 */     GIR_EraseRootFromParent_Done,
     /* 2374042 */   // Label 33752: @2374042
     /* 2374042 */   GIM_Reject,
     /* 2374043 */ // Label 33750: @2374043
     /* 2374043 */ GIM_Reject,
     /* 2374044 */ // Label 33697: @2374044
     /* 2374044 */ GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2374147),
     /* 2374049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2374052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374060 */   GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2374103), // Rule ID 59114 //
     /* 2374065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374068 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2374085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374102 */     // GIR_Coverage, 59114,
     /* 2374102 */     GIR_EraseRootFromParent_Done,
     /* 2374103 */   // Label 33754: @2374103
     /* 2374103 */   GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2374146), // Rule ID 59115 //
     /* 2374108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374111 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2374128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374145 */     // GIR_Coverage, 59115,
     /* 2374145 */     GIR_EraseRootFromParent_Done,
     /* 2374146 */   // Label 33755: @2374146
     /* 2374146 */   GIM_Reject,
     /* 2374147 */ // Label 33753: @2374147
     /* 2374147 */ GIM_Reject,
     /* 2374148 */ // Label 33698: @2374148
     /* 2374148 */ GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2374251),
     /* 2374153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2374156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374164 */   GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2374207), // Rule ID 59122 //
     /* 2374169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374172 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374206 */     // GIR_Coverage, 59122,
     /* 2374206 */     GIR_EraseRootFromParent_Done,
     /* 2374207 */   // Label 33757: @2374207
     /* 2374207 */   GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2374250), // Rule ID 59123 //
     /* 2374212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374215 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2374218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374249 */     // GIR_Coverage, 59123,
     /* 2374249 */     GIR_EraseRootFromParent_Done,
     /* 2374250 */   // Label 33758: @2374250
     /* 2374250 */   GIM_Reject,
     /* 2374251 */ // Label 33756: @2374251
     /* 2374251 */ GIM_Reject,
     /* 2374252 */ // Label 33699: @2374252
     /* 2374252 */ GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2374355),
     /* 2374257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2374260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374268 */   GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2374311), // Rule ID 59130 //
     /* 2374273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2374276 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374310 */     // GIR_Coverage, 59130,
     /* 2374310 */     GIR_EraseRootFromParent_Done,
     /* 2374311 */   // Label 33760: @2374311
     /* 2374311 */   GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2374354), // Rule ID 59131 //
     /* 2374316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2374319 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2374322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374353 */     // GIR_Coverage, 59131,
     /* 2374353 */     GIR_EraseRootFromParent_Done,
     /* 2374354 */   // Label 33761: @2374354
     /* 2374354 */   GIM_Reject,
     /* 2374355 */ // Label 33759: @2374355
     /* 2374355 */ GIM_Reject,
     /* 2374356 */ // Label 33700: @2374356
     /* 2374356 */ GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2374459),
     /* 2374361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2374364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374372 */   GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2374415), // Rule ID 59108 //
     /* 2374377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374380 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2374397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374414 */     // GIR_Coverage, 59108,
     /* 2374414 */     GIR_EraseRootFromParent_Done,
     /* 2374415 */   // Label 33763: @2374415
     /* 2374415 */   GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2374458), // Rule ID 59109 //
     /* 2374420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374423 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2374440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374457 */     // GIR_Coverage, 59109,
     /* 2374457 */     GIR_EraseRootFromParent_Done,
     /* 2374458 */   // Label 33764: @2374458
     /* 2374458 */   GIM_Reject,
     /* 2374459 */ // Label 33762: @2374459
     /* 2374459 */ GIM_Reject,
     /* 2374460 */ // Label 33701: @2374460
     /* 2374460 */ GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2374563),
     /* 2374465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2374468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374476 */   GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2374519), // Rule ID 59116 //
     /* 2374481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374484 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374518 */     // GIR_Coverage, 59116,
     /* 2374518 */     GIR_EraseRootFromParent_Done,
     /* 2374519 */   // Label 33766: @2374519
     /* 2374519 */   GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2374562), // Rule ID 59117 //
     /* 2374524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374527 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374561 */     // GIR_Coverage, 59117,
     /* 2374561 */     GIR_EraseRootFromParent_Done,
     /* 2374562 */   // Label 33767: @2374562
     /* 2374562 */   GIM_Reject,
     /* 2374563 */ // Label 33765: @2374563
     /* 2374563 */ GIM_Reject,
     /* 2374564 */ // Label 33702: @2374564
     /* 2374564 */ GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2374667),
     /* 2374569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374580 */   GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2374623), // Rule ID 59124 //
     /* 2374585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374588 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374622 */     // GIR_Coverage, 59124,
     /* 2374622 */     GIR_EraseRootFromParent_Done,
     /* 2374623 */   // Label 33769: @2374623
     /* 2374623 */   GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2374666), // Rule ID 59125 //
     /* 2374628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374631 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374665 */     // GIR_Coverage, 59125,
     /* 2374665 */     GIR_EraseRootFromParent_Done,
     /* 2374666 */   // Label 33770: @2374666
     /* 2374666 */   GIM_Reject,
     /* 2374667 */ // Label 33768: @2374667
     /* 2374667 */ GIM_Reject,
     /* 2374668 */ // Label 33703: @2374668
     /* 2374668 */ GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2374771),
     /* 2374673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374684 */   GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2374727), // Rule ID 59110 //
     /* 2374689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374692 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374726 */     // GIR_Coverage, 59110,
     /* 2374726 */     GIR_EraseRootFromParent_Done,
     /* 2374727 */   // Label 33772: @2374727
     /* 2374727 */   GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2374770), // Rule ID 59111 //
     /* 2374732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374735 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2374752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374769 */     // GIR_Coverage, 59111,
     /* 2374769 */     GIR_EraseRootFromParent_Done,
     /* 2374770 */   // Label 33773: @2374770
     /* 2374770 */   GIM_Reject,
     /* 2374771 */ // Label 33771: @2374771
     /* 2374771 */ GIM_Reject,
     /* 2374772 */ // Label 33704: @2374772
     /* 2374772 */ GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2374875),
     /* 2374777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2374780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374788 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2374831), // Rule ID 59118 //
     /* 2374793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374796 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374830 */     // GIR_Coverage, 59118,
     /* 2374830 */     GIR_EraseRootFromParent_Done,
     /* 2374831 */   // Label 33775: @2374831
     /* 2374831 */   GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2374874), // Rule ID 59119 //
     /* 2374836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374839 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374873 */     // GIR_Coverage, 59119,
     /* 2374873 */     GIR_EraseRootFromParent_Done,
     /* 2374874 */   // Label 33776: @2374874
     /* 2374874 */   GIM_Reject,
     /* 2374875 */ // Label 33774: @2374875
     /* 2374875 */ GIM_Reject,
     /* 2374876 */ // Label 33705: @2374876
     /* 2374876 */ GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2374979),
     /* 2374881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2374884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374892 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2374935), // Rule ID 59112 //
     /* 2374897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2374900 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374934 */     // GIR_Coverage, 59112,
     /* 2374934 */     GIR_EraseRootFromParent_Done,
     /* 2374935 */   // Label 33778: @2374935
     /* 2374935 */   GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2374978), // Rule ID 59113 //
     /* 2374940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2374943 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2374960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374977 */     // GIR_Coverage, 59113,
     /* 2374977 */     GIR_EraseRootFromParent_Done,
     /* 2374978 */   // Label 33779: @2374978
     /* 2374978 */   GIM_Reject,
     /* 2374979 */ // Label 33777: @2374979
     /* 2374979 */ GIM_Reject,
     /* 2374980 */ // Label 33706: @2374980
     /* 2374980 */ GIM_Reject,
     /* 2374981 */ // Label 92: @2374981
     /* 2374981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33804*/ GIMT_Encode4(2377474),
     /* 2374992 */ /*GILLT_s32*//*Label 33780*/ GIMT_Encode4(2375116),
     /* 2374996 */ /*GILLT_s64*//*Label 33781*/ GIMT_Encode4(2375151), GIMT_Encode4(0),
     /* 2375004 */ /*GILLT_nxv1s8*//*Label 33782*/ GIMT_Encode4(2375186),
     /* 2375008 */ /*GILLT_nxv1s16*//*Label 33783*/ GIMT_Encode4(2375290),
     /* 2375012 */ /*GILLT_nxv1s32*//*Label 33784*/ GIMT_Encode4(2375394),
     /* 2375016 */ /*GILLT_nxv1s64*//*Label 33785*/ GIMT_Encode4(2375498), GIMT_Encode4(0),
     /* 2375024 */ /*GILLT_nxv2s8*//*Label 33786*/ GIMT_Encode4(2375602),
     /* 2375028 */ /*GILLT_nxv2s16*//*Label 33787*/ GIMT_Encode4(2375706),
     /* 2375032 */ /*GILLT_nxv2s32*//*Label 33788*/ GIMT_Encode4(2375810),
     /* 2375036 */ /*GILLT_nxv2s64*//*Label 33789*/ GIMT_Encode4(2375914), GIMT_Encode4(0),
     /* 2375044 */ /*GILLT_nxv4s8*//*Label 33790*/ GIMT_Encode4(2376018),
     /* 2375048 */ /*GILLT_nxv4s16*//*Label 33791*/ GIMT_Encode4(2376122),
     /* 2375052 */ /*GILLT_nxv4s32*//*Label 33792*/ GIMT_Encode4(2376226),
     /* 2375056 */ /*GILLT_nxv4s64*//*Label 33793*/ GIMT_Encode4(2376330), GIMT_Encode4(0),
     /* 2375064 */ /*GILLT_nxv8s8*//*Label 33794*/ GIMT_Encode4(2376434),
     /* 2375068 */ /*GILLT_nxv8s16*//*Label 33795*/ GIMT_Encode4(2376538),
     /* 2375072 */ /*GILLT_nxv8s32*//*Label 33796*/ GIMT_Encode4(2376642),
     /* 2375076 */ /*GILLT_nxv8s64*//*Label 33797*/ GIMT_Encode4(2376746), GIMT_Encode4(0),
     /* 2375084 */ /*GILLT_nxv16s8*//*Label 33798*/ GIMT_Encode4(2376850),
     /* 2375088 */ /*GILLT_nxv16s16*//*Label 33799*/ GIMT_Encode4(2376954),
     /* 2375092 */ /*GILLT_nxv16s32*//*Label 33800*/ GIMT_Encode4(2377058), GIMT_Encode4(0),
     /* 2375100 */ /*GILLT_nxv32s8*//*Label 33801*/ GIMT_Encode4(2377162),
     /* 2375104 */ /*GILLT_nxv32s16*//*Label 33802*/ GIMT_Encode4(2377266), GIMT_Encode4(0),
     /* 2375112 */ /*GILLT_nxv64s8*//*Label 33803*/ GIMT_Encode4(2377370),
     /* 2375116 */ // Label 33780: @2375116
     /* 2375116 */ GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2375150), // Rule ID 64441 //
     /* 2375121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2375124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375135 */   // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2375135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2375138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2375142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2375145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2375148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375149 */   // GIR_Coverage, 64441,
     /* 2375149 */   GIR_EraseRootFromParent_Done,
     /* 2375150 */ // Label 33805: @2375150
     /* 2375150 */ GIM_Reject,
     /* 2375151 */ // Label 33781: @2375151
     /* 2375151 */ GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2375185), // Rule ID 64440 //
     /* 2375156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2375159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375170 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2375170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2375173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375175 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2375177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2375180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2375183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375184 */   // GIR_Coverage, 64440,
     /* 2375184 */   GIR_EraseRootFromParent_Done,
     /* 2375185 */ // Label 33806: @2375185
     /* 2375185 */ GIM_Reject,
     /* 2375186 */ // Label 33782: @2375186
     /* 2375186 */ GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2375289),
     /* 2375191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2375194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375202 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2375245), // Rule ID 58912 //
     /* 2375207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375210 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2375227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375244 */     // GIR_Coverage, 58912,
     /* 2375244 */     GIR_EraseRootFromParent_Done,
     /* 2375245 */   // Label 33808: @2375245
     /* 2375245 */   GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2375288), // Rule ID 58913 //
     /* 2375250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375253 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2375256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2375270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375287 */     // GIR_Coverage, 58913,
     /* 2375287 */     GIR_EraseRootFromParent_Done,
     /* 2375288 */   // Label 33809: @2375288
     /* 2375288 */   GIM_Reject,
     /* 2375289 */ // Label 33807: @2375289
     /* 2375289 */ GIM_Reject,
     /* 2375290 */ // Label 33783: @2375290
     /* 2375290 */ GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2375393),
     /* 2375295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2375298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375306 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2375349), // Rule ID 59050 //
     /* 2375311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375314 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2375331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375348 */     // GIR_Coverage, 59050,
     /* 2375348 */     GIR_EraseRootFromParent_Done,
     /* 2375349 */   // Label 33811: @2375349
     /* 2375349 */   GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2375392), // Rule ID 59051 //
     /* 2375354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375357 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2375360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2375374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375391 */     // GIR_Coverage, 59051,
     /* 2375391 */     GIR_EraseRootFromParent_Done,
     /* 2375392 */   // Label 33812: @2375392
     /* 2375392 */   GIM_Reject,
     /* 2375393 */ // Label 33810: @2375393
     /* 2375393 */ GIM_Reject,
     /* 2375394 */ // Label 33784: @2375394
     /* 2375394 */ GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2375497),
     /* 2375399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2375402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375410 */   GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2375453), // Rule ID 59054 //
     /* 2375415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375418 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2375435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375452 */     // GIR_Coverage, 59054,
     /* 2375452 */     GIR_EraseRootFromParent_Done,
     /* 2375453 */   // Label 33814: @2375453
     /* 2375453 */   GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2375496), // Rule ID 59055 //
     /* 2375458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375461 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2375464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2375478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375495 */     // GIR_Coverage, 59055,
     /* 2375495 */     GIR_EraseRootFromParent_Done,
     /* 2375496 */   // Label 33815: @2375496
     /* 2375496 */   GIM_Reject,
     /* 2375497 */ // Label 33813: @2375497
     /* 2375497 */ GIM_Reject,
     /* 2375498 */ // Label 33785: @2375498
     /* 2375498 */ GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2375601),
     /* 2375503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2375506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375514 */   GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2375557), // Rule ID 59062 //
     /* 2375519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2375522 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2375539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375556 */     // GIR_Coverage, 59062,
     /* 2375556 */     GIR_EraseRootFromParent_Done,
     /* 2375557 */   // Label 33817: @2375557
     /* 2375557 */   GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2375600), // Rule ID 59063 //
     /* 2375562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2375565 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2375568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2375582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375599 */     // GIR_Coverage, 59063,
     /* 2375599 */     GIR_EraseRootFromParent_Done,
     /* 2375600 */   // Label 33818: @2375600
     /* 2375600 */   GIM_Reject,
     /* 2375601 */ // Label 33816: @2375601
     /* 2375601 */ GIM_Reject,
     /* 2375602 */ // Label 33786: @2375602
     /* 2375602 */ GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2375705),
     /* 2375607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2375610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375618 */   GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2375661), // Rule ID 59046 //
     /* 2375623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375626 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2375629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2375643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375660 */     // GIR_Coverage, 59046,
     /* 2375660 */     GIR_EraseRootFromParent_Done,
     /* 2375661 */   // Label 33820: @2375661
     /* 2375661 */   GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2375704), // Rule ID 59047 //
     /* 2375666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375669 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2375672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2375686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375703 */     // GIR_Coverage, 59047,
     /* 2375703 */     GIR_EraseRootFromParent_Done,
     /* 2375704 */   // Label 33821: @2375704
     /* 2375704 */   GIM_Reject,
     /* 2375705 */ // Label 33819: @2375705
     /* 2375705 */ GIM_Reject,
     /* 2375706 */ // Label 33787: @2375706
     /* 2375706 */ GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2375809),
     /* 2375711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2375714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375722 */   GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2375765), // Rule ID 59052 //
     /* 2375727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375730 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2375733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2375747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375764 */     // GIR_Coverage, 59052,
     /* 2375764 */     GIR_EraseRootFromParent_Done,
     /* 2375765 */   // Label 33823: @2375765
     /* 2375765 */   GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2375808), // Rule ID 59053 //
     /* 2375770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375773 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2375776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2375790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375807 */     // GIR_Coverage, 59053,
     /* 2375807 */     GIR_EraseRootFromParent_Done,
     /* 2375808 */   // Label 33824: @2375808
     /* 2375808 */   GIM_Reject,
     /* 2375809 */ // Label 33822: @2375809
     /* 2375809 */ GIM_Reject,
     /* 2375810 */ // Label 33788: @2375810
     /* 2375810 */ GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2375913),
     /* 2375815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2375818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2375826 */   GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2375869), // Rule ID 59060 //
     /* 2375831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2375834 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2375837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2375851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375868 */     // GIR_Coverage, 59060,
     /* 2375868 */     GIR_EraseRootFromParent_Done,
     /* 2375869 */   // Label 33826: @2375869
     /* 2375869 */   GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2375912), // Rule ID 59061 //
     /* 2375874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2375877 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2375880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2375894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375911 */     // GIR_Coverage, 59061,
     /* 2375911 */     GIR_EraseRootFromParent_Done,
     /* 2375912 */   // Label 33827: @2375912
     /* 2375912 */   GIM_Reject,
     /* 2375913 */ // Label 33825: @2375913
     /* 2375913 */ GIM_Reject,
     /* 2375914 */ // Label 33789: @2375914
     /* 2375914 */ GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2376017),
     /* 2375919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2375922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2375930 */   GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2375973), // Rule ID 59082 //
     /* 2375935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2375938 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2375941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2375955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375972 */     // GIR_Coverage, 59082,
     /* 2375972 */     GIR_EraseRootFromParent_Done,
     /* 2375973 */   // Label 33829: @2375973
     /* 2375973 */   GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2376016), // Rule ID 59083 //
     /* 2375978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2375981 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2375984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2375998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376015 */     // GIR_Coverage, 59083,
     /* 2376015 */     GIR_EraseRootFromParent_Done,
     /* 2376016 */   // Label 33830: @2376016
     /* 2376016 */   GIM_Reject,
     /* 2376017 */ // Label 33828: @2376017
     /* 2376017 */ GIM_Reject,
     /* 2376018 */ // Label 33790: @2376018
     /* 2376018 */ GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2376121),
     /* 2376023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2376026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376034 */   GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2376077), // Rule ID 59048 //
     /* 2376039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376042 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2376059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376076 */     // GIR_Coverage, 59048,
     /* 2376076 */     GIR_EraseRootFromParent_Done,
     /* 2376077 */   // Label 33832: @2376077
     /* 2376077 */   GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2376120), // Rule ID 59049 //
     /* 2376082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376085 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2376102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376119 */     // GIR_Coverage, 59049,
     /* 2376119 */     GIR_EraseRootFromParent_Done,
     /* 2376120 */   // Label 33833: @2376120
     /* 2376120 */   GIM_Reject,
     /* 2376121 */ // Label 33831: @2376121
     /* 2376121 */ GIM_Reject,
     /* 2376122 */ // Label 33791: @2376122
     /* 2376122 */ GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2376225),
     /* 2376127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2376130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376138 */   GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2376181), // Rule ID 59058 //
     /* 2376143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376146 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2376163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376180 */     // GIR_Coverage, 59058,
     /* 2376180 */     GIR_EraseRootFromParent_Done,
     /* 2376181 */   // Label 33835: @2376181
     /* 2376181 */   GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2376224), // Rule ID 59059 //
     /* 2376186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376189 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2376206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376223 */     // GIR_Coverage, 59059,
     /* 2376223 */     GIR_EraseRootFromParent_Done,
     /* 2376224 */   // Label 33836: @2376224
     /* 2376224 */   GIM_Reject,
     /* 2376225 */ // Label 33834: @2376225
     /* 2376225 */ GIM_Reject,
     /* 2376226 */ // Label 33792: @2376226
     /* 2376226 */ GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2376329),
     /* 2376231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2376234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376242 */   GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2376285), // Rule ID 59076 //
     /* 2376247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376250 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376284 */     // GIR_Coverage, 59076,
     /* 2376284 */     GIR_EraseRootFromParent_Done,
     /* 2376285 */   // Label 33838: @2376285
     /* 2376285 */   GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2376328), // Rule ID 59077 //
     /* 2376290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376293 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2376296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376327 */     // GIR_Coverage, 59077,
     /* 2376327 */     GIR_EraseRootFromParent_Done,
     /* 2376328 */   // Label 33839: @2376328
     /* 2376328 */   GIM_Reject,
     /* 2376329 */ // Label 33837: @2376329
     /* 2376329 */ GIM_Reject,
     /* 2376330 */ // Label 33793: @2376330
     /* 2376330 */ GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2376433),
     /* 2376335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2376338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376346 */   GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2376389), // Rule ID 59084 //
     /* 2376351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2376354 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2376371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376388 */     // GIR_Coverage, 59084,
     /* 2376388 */     GIR_EraseRootFromParent_Done,
     /* 2376389 */   // Label 33841: @2376389
     /* 2376389 */   GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2376432), // Rule ID 59085 //
     /* 2376394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2376397 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2376400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2376414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376431 */     // GIR_Coverage, 59085,
     /* 2376431 */     GIR_EraseRootFromParent_Done,
     /* 2376432 */   // Label 33842: @2376432
     /* 2376432 */   GIM_Reject,
     /* 2376433 */ // Label 33840: @2376433
     /* 2376433 */ GIM_Reject,
     /* 2376434 */ // Label 33794: @2376434
     /* 2376434 */ GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2376537),
     /* 2376439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2376442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376450 */   GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2376493), // Rule ID 59056 //
     /* 2376455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376458 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2376475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376492 */     // GIR_Coverage, 59056,
     /* 2376492 */     GIR_EraseRootFromParent_Done,
     /* 2376493 */   // Label 33844: @2376493
     /* 2376493 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2376536), // Rule ID 59057 //
     /* 2376498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376501 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2376504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2376518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376535 */     // GIR_Coverage, 59057,
     /* 2376535 */     GIR_EraseRootFromParent_Done,
     /* 2376536 */   // Label 33845: @2376536
     /* 2376536 */   GIM_Reject,
     /* 2376537 */ // Label 33843: @2376537
     /* 2376537 */ GIM_Reject,
     /* 2376538 */ // Label 33795: @2376538
     /* 2376538 */ GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2376641),
     /* 2376543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2376546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376554 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2376597), // Rule ID 59070 //
     /* 2376559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376562 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2376565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376596 */     // GIR_Coverage, 59070,
     /* 2376596 */     GIR_EraseRootFromParent_Done,
     /* 2376597 */   // Label 33847: @2376597
     /* 2376597 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2376640), // Rule ID 59071 //
     /* 2376602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376605 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2376608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376639 */     // GIR_Coverage, 59071,
     /* 2376639 */     GIR_EraseRootFromParent_Done,
     /* 2376640 */   // Label 33848: @2376640
     /* 2376640 */   GIM_Reject,
     /* 2376641 */ // Label 33846: @2376641
     /* 2376641 */ GIM_Reject,
     /* 2376642 */ // Label 33796: @2376642
     /* 2376642 */ GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2376745),
     /* 2376647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2376650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376658 */   GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2376701), // Rule ID 59078 //
     /* 2376663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376666 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2376669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2376683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376700 */     // GIR_Coverage, 59078,
     /* 2376700 */     GIR_EraseRootFromParent_Done,
     /* 2376701 */   // Label 33850: @2376701
     /* 2376701 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2376744), // Rule ID 59079 //
     /* 2376706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376709 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2376712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2376726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376743 */     // GIR_Coverage, 59079,
     /* 2376743 */     GIR_EraseRootFromParent_Done,
     /* 2376744 */   // Label 33851: @2376744
     /* 2376744 */   GIM_Reject,
     /* 2376745 */ // Label 33849: @2376745
     /* 2376745 */ GIM_Reject,
     /* 2376746 */ // Label 33797: @2376746
     /* 2376746 */ GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2376849),
     /* 2376751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2376754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2376762 */   GIM_Try, /*On fail goto*//*Label 33853*/ GIMT_Encode4(2376805), // Rule ID 59086 //
     /* 2376767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2376770 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2376773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2376787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376804 */     // GIR_Coverage, 59086,
     /* 2376804 */     GIR_EraseRootFromParent_Done,
     /* 2376805 */   // Label 33853: @2376805
     /* 2376805 */   GIM_Try, /*On fail goto*//*Label 33854*/ GIMT_Encode4(2376848), // Rule ID 59087 //
     /* 2376810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2376813 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2376816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2376830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376847 */     // GIR_Coverage, 59087,
     /* 2376847 */     GIR_EraseRootFromParent_Done,
     /* 2376848 */   // Label 33854: @2376848
     /* 2376848 */   GIM_Reject,
     /* 2376849 */ // Label 33852: @2376849
     /* 2376849 */ GIM_Reject,
     /* 2376850 */ // Label 33798: @2376850
     /* 2376850 */ GIM_Try, /*On fail goto*//*Label 33855*/ GIMT_Encode4(2376953),
     /* 2376855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2376858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376866 */   GIM_Try, /*On fail goto*//*Label 33856*/ GIMT_Encode4(2376909), // Rule ID 59064 //
     /* 2376871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376874 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2376877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376908 */     // GIR_Coverage, 59064,
     /* 2376908 */     GIR_EraseRootFromParent_Done,
     /* 2376909 */   // Label 33856: @2376909
     /* 2376909 */   GIM_Try, /*On fail goto*//*Label 33857*/ GIMT_Encode4(2376952), // Rule ID 59065 //
     /* 2376914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376917 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2376920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2376934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376951 */     // GIR_Coverage, 59065,
     /* 2376951 */     GIR_EraseRootFromParent_Done,
     /* 2376952 */   // Label 33857: @2376952
     /* 2376952 */   GIM_Reject,
     /* 2376953 */ // Label 33855: @2376953
     /* 2376953 */ GIM_Reject,
     /* 2376954 */ // Label 33799: @2376954
     /* 2376954 */ GIM_Try, /*On fail goto*//*Label 33858*/ GIMT_Encode4(2377057),
     /* 2376959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2376962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2376970 */   GIM_Try, /*On fail goto*//*Label 33859*/ GIMT_Encode4(2377013), // Rule ID 59072 //
     /* 2376975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376978 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2376981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2376995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377012 */     // GIR_Coverage, 59072,
     /* 2377012 */     GIR_EraseRootFromParent_Done,
     /* 2377013 */   // Label 33859: @2377013
     /* 2377013 */   GIM_Try, /*On fail goto*//*Label 33860*/ GIMT_Encode4(2377056), // Rule ID 59073 //
     /* 2377018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377021 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2377038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377055 */     // GIR_Coverage, 59073,
     /* 2377055 */     GIR_EraseRootFromParent_Done,
     /* 2377056 */   // Label 33860: @2377056
     /* 2377056 */   GIM_Reject,
     /* 2377057 */ // Label 33858: @2377057
     /* 2377057 */ GIM_Reject,
     /* 2377058 */ // Label 33800: @2377058
     /* 2377058 */ GIM_Try, /*On fail goto*//*Label 33861*/ GIMT_Encode4(2377161),
     /* 2377063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2377066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377074 */   GIM_Try, /*On fail goto*//*Label 33862*/ GIMT_Encode4(2377117), // Rule ID 59080 //
     /* 2377079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377082 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377116 */     // GIR_Coverage, 59080,
     /* 2377116 */     GIR_EraseRootFromParent_Done,
     /* 2377117 */   // Label 33862: @2377117
     /* 2377117 */   GIM_Try, /*On fail goto*//*Label 33863*/ GIMT_Encode4(2377160), // Rule ID 59081 //
     /* 2377122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377125 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377159 */     // GIR_Coverage, 59081,
     /* 2377159 */     GIR_EraseRootFromParent_Done,
     /* 2377160 */   // Label 33863: @2377160
     /* 2377160 */   GIM_Reject,
     /* 2377161 */ // Label 33861: @2377161
     /* 2377161 */ GIM_Reject,
     /* 2377162 */ // Label 33801: @2377162
     /* 2377162 */ GIM_Try, /*On fail goto*//*Label 33864*/ GIMT_Encode4(2377265),
     /* 2377167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2377170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377178 */   GIM_Try, /*On fail goto*//*Label 33865*/ GIMT_Encode4(2377221), // Rule ID 59066 //
     /* 2377183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377186 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2377203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377220 */     // GIR_Coverage, 59066,
     /* 2377220 */     GIR_EraseRootFromParent_Done,
     /* 2377221 */   // Label 33865: @2377221
     /* 2377221 */   GIM_Try, /*On fail goto*//*Label 33866*/ GIMT_Encode4(2377264), // Rule ID 59067 //
     /* 2377226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377229 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2377232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2377246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377263 */     // GIR_Coverage, 59067,
     /* 2377263 */     GIR_EraseRootFromParent_Done,
     /* 2377264 */   // Label 33866: @2377264
     /* 2377264 */   GIM_Reject,
     /* 2377265 */ // Label 33864: @2377265
     /* 2377265 */ GIM_Reject,
     /* 2377266 */ // Label 33802: @2377266
     /* 2377266 */ GIM_Try, /*On fail goto*//*Label 33867*/ GIMT_Encode4(2377369),
     /* 2377271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2377274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377282 */   GIM_Try, /*On fail goto*//*Label 33868*/ GIMT_Encode4(2377325), // Rule ID 59074 //
     /* 2377287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377290 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377324 */     // GIR_Coverage, 59074,
     /* 2377324 */     GIR_EraseRootFromParent_Done,
     /* 2377325 */   // Label 33868: @2377325
     /* 2377325 */   GIM_Try, /*On fail goto*//*Label 33869*/ GIMT_Encode4(2377368), // Rule ID 59075 //
     /* 2377330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377333 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2377336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377367 */     // GIR_Coverage, 59075,
     /* 2377367 */     GIR_EraseRootFromParent_Done,
     /* 2377368 */   // Label 33869: @2377368
     /* 2377368 */   GIM_Reject,
     /* 2377369 */ // Label 33867: @2377369
     /* 2377369 */ GIM_Reject,
     /* 2377370 */ // Label 33803: @2377370
     /* 2377370 */ GIM_Try, /*On fail goto*//*Label 33870*/ GIMT_Encode4(2377473),
     /* 2377375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2377378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377386 */   GIM_Try, /*On fail goto*//*Label 33871*/ GIMT_Encode4(2377429), // Rule ID 59068 //
     /* 2377391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377394 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2377397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377428 */     // GIR_Coverage, 59068,
     /* 2377428 */     GIR_EraseRootFromParent_Done,
     /* 2377429 */   // Label 33871: @2377429
     /* 2377429 */   GIM_Try, /*On fail goto*//*Label 33872*/ GIMT_Encode4(2377472), // Rule ID 59069 //
     /* 2377434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377437 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2377440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2377454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377471 */     // GIR_Coverage, 59069,
     /* 2377471 */     GIR_EraseRootFromParent_Done,
     /* 2377472 */   // Label 33872: @2377472
     /* 2377472 */   GIM_Reject,
     /* 2377473 */ // Label 33870: @2377473
     /* 2377473 */ GIM_Reject,
     /* 2377474 */ // Label 33804: @2377474
     /* 2377474 */ GIM_Reject,
     /* 2377475 */ // Label 93: @2377475
     /* 2377475 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33876*/ GIMT_Encode4(2377672),
     /* 2377486 */ /*GILLT_s16*//*Label 33873*/ GIMT_Encode4(2377498),
     /* 2377490 */ /*GILLT_s32*//*Label 33874*/ GIMT_Encode4(2377556),
     /* 2377494 */ /*GILLT_s64*//*Label 33875*/ GIMT_Encode4(2377614),
     /* 2377498 */ // Label 33873: @2377498
     /* 2377498 */ GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2377555),
     /* 2377503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377514 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2377534), // Rule ID 2424 //
     /* 2377519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2377522 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2377522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2377525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377533 */     // GIR_Coverage, 2424,
     /* 2377533 */     GIR_EraseRootFromParent_Done,
     /* 2377534 */   // Label 33878: @2377534
     /* 2377534 */   GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2377554), // Rule ID 2425 //
     /* 2377539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2377542 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2377542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2377545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377553 */     // GIR_Coverage, 2425,
     /* 2377553 */     GIR_EraseRootFromParent_Done,
     /* 2377554 */   // Label 33879: @2377554
     /* 2377554 */   GIM_Reject,
     /* 2377555 */ // Label 33877: @2377555
     /* 2377555 */ GIM_Reject,
     /* 2377556 */ // Label 33874: @2377556
     /* 2377556 */ GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2377613),
     /* 2377561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377572 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2377592), // Rule ID 2342 //
     /* 2377577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2377580 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2377580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2377583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377591 */     // GIR_Coverage, 2342,
     /* 2377591 */     GIR_EraseRootFromParent_Done,
     /* 2377592 */   // Label 33881: @2377592
     /* 2377592 */   GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2377612), // Rule ID 2343 //
     /* 2377597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2377600 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2377600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2377603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377611 */     // GIR_Coverage, 2343,
     /* 2377611 */     GIR_EraseRootFromParent_Done,
     /* 2377612 */   // Label 33882: @2377612
     /* 2377612 */   GIM_Reject,
     /* 2377613 */ // Label 33880: @2377613
     /* 2377613 */ GIM_Reject,
     /* 2377614 */ // Label 33875: @2377614
     /* 2377614 */ GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2377671),
     /* 2377619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2377622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2377626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2377630 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2377650), // Rule ID 2382 //
     /* 2377635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2377638 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2377638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2377641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377649 */     // GIR_Coverage, 2382,
     /* 2377649 */     GIR_EraseRootFromParent_Done,
     /* 2377650 */   // Label 33884: @2377650
     /* 2377650 */   GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2377670), // Rule ID 2383 //
     /* 2377655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2377658 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2377658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2377661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377669 */     // GIR_Coverage, 2383,
     /* 2377669 */     GIR_EraseRootFromParent_Done,
     /* 2377670 */   // Label 33885: @2377670
     /* 2377670 */   GIM_Reject,
     /* 2377671 */ // Label 33883: @2377671
     /* 2377671 */ GIM_Reject,
     /* 2377672 */ // Label 33876: @2377672
     /* 2377672 */ GIM_Reject,
     /* 2377673 */ // Label 94: @2377673
     /* 2377673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33904*/ GIMT_Encode4(2379848),
     /* 2377684 */ /*GILLT_s16*//*Label 33886*/ GIMT_Encode4(2377804),
     /* 2377688 */ /*GILLT_s32*//*Label 33887*/ GIMT_Encode4(2377926),
     /* 2377692 */ /*GILLT_s64*//*Label 33888*/ GIMT_Encode4(2378048), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377704 */ /*GILLT_nxv1s16*//*Label 33889*/ GIMT_Encode4(2378198),
     /* 2377708 */ /*GILLT_nxv1s32*//*Label 33890*/ GIMT_Encode4(2378308),
     /* 2377712 */ /*GILLT_nxv1s64*//*Label 33891*/ GIMT_Encode4(2378418), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377724 */ /*GILLT_nxv2s16*//*Label 33892*/ GIMT_Encode4(2378528),
     /* 2377728 */ /*GILLT_nxv2s32*//*Label 33893*/ GIMT_Encode4(2378638),
     /* 2377732 */ /*GILLT_nxv2s64*//*Label 33894*/ GIMT_Encode4(2378748), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377744 */ /*GILLT_nxv4s16*//*Label 33895*/ GIMT_Encode4(2378858),
     /* 2377748 */ /*GILLT_nxv4s32*//*Label 33896*/ GIMT_Encode4(2378968),
     /* 2377752 */ /*GILLT_nxv4s64*//*Label 33897*/ GIMT_Encode4(2379078), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377764 */ /*GILLT_nxv8s16*//*Label 33898*/ GIMT_Encode4(2379188),
     /* 2377768 */ /*GILLT_nxv8s32*//*Label 33899*/ GIMT_Encode4(2379298),
     /* 2377772 */ /*GILLT_nxv8s64*//*Label 33900*/ GIMT_Encode4(2379408), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377784 */ /*GILLT_nxv16s16*//*Label 33901*/ GIMT_Encode4(2379518),
     /* 2377788 */ /*GILLT_nxv16s32*//*Label 33902*/ GIMT_Encode4(2379628), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2377800 */ /*GILLT_nxv32s16*//*Label 33903*/ GIMT_Encode4(2379738),
     /* 2377804 */ // Label 33886: @2377804
     /* 2377804 */ GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2377925),
     /* 2377809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2377812 */   GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2377840), // Rule ID 1982 //
     /* 2377817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2377820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377828 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2377828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2377831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377839 */     // GIR_Coverage, 1982,
     /* 2377839 */     GIR_EraseRootFromParent_Done,
     /* 2377840 */   // Label 33906: @2377840
     /* 2377840 */   GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2377868), // Rule ID 1983 //
     /* 2377845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2377848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2377856 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2377856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2377859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377867 */     // GIR_Coverage, 1983,
     /* 2377867 */     GIR_EraseRootFromParent_Done,
     /* 2377868 */   // Label 33907: @2377868
     /* 2377868 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2377896), // Rule ID 2015 //
     /* 2377873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2377876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377884 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2377884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2377887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377895 */     // GIR_Coverage, 2015,
     /* 2377895 */     GIR_EraseRootFromParent_Done,
     /* 2377896 */   // Label 33908: @2377896
     /* 2377896 */   GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2377924), // Rule ID 2016 //
     /* 2377901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2377904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2377912 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2377912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2377915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377923 */     // GIR_Coverage, 2016,
     /* 2377923 */     GIR_EraseRootFromParent_Done,
     /* 2377924 */   // Label 33909: @2377924
     /* 2377924 */   GIM_Reject,
     /* 2377925 */ // Label 33905: @2377925
     /* 2377925 */ GIM_Reject,
     /* 2377926 */ // Label 33887: @2377926
     /* 2377926 */ GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2378047),
     /* 2377931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2377934 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2377962), // Rule ID 1269 //
     /* 2377939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2377942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377950 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2377950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2377953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377961 */     // GIR_Coverage, 1269,
     /* 2377961 */     GIR_EraseRootFromParent_Done,
     /* 2377962 */   // Label 33911: @2377962
     /* 2377962 */   GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2377990), // Rule ID 1270 //
     /* 2377967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2377970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2377978 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2377978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2377981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377989 */     // GIR_Coverage, 1270,
     /* 2377989 */     GIR_EraseRootFromParent_Done,
     /* 2377990 */   // Label 33912: @2377990
     /* 2377990 */   GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2378018), // Rule ID 1277 //
     /* 2377995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2377998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378006 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2378006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2378009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378017 */     // GIR_Coverage, 1277,
     /* 2378017 */     GIR_EraseRootFromParent_Done,
     /* 2378018 */   // Label 33913: @2378018
     /* 2378018 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2378046), // Rule ID 1278 //
     /* 2378023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2378026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378034 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2378034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2378037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378045 */     // GIR_Coverage, 1278,
     /* 2378045 */     GIR_EraseRootFromParent_Done,
     /* 2378046 */   // Label 33914: @2378046
     /* 2378046 */   GIM_Reject,
     /* 2378047 */ // Label 33910: @2378047
     /* 2378047 */ GIM_Reject,
     /* 2378048 */ // Label 33888: @2378048
     /* 2378048 */ GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2378197),
     /* 2378053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378056 */   GIM_Try, /*On fail goto*//*Label 33916*/ GIMT_Encode4(2378084), // Rule ID 1612 //
     /* 2378061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2378064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2378068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2378072 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2378072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2378075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378083 */     // GIR_Coverage, 1612,
     /* 2378083 */     GIR_EraseRootFromParent_Done,
     /* 2378084 */   // Label 33916: @2378084
     /* 2378084 */   GIM_Try, /*On fail goto*//*Label 33917*/ GIMT_Encode4(2378112), // Rule ID 1613 //
     /* 2378089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2378092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2378096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2378100 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2378100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2378103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378111 */     // GIR_Coverage, 1613,
     /* 2378111 */     GIR_EraseRootFromParent_Done,
     /* 2378112 */   // Label 33917: @2378112
     /* 2378112 */   GIM_Try, /*On fail goto*//*Label 33918*/ GIMT_Encode4(2378140), // Rule ID 1646 //
     /* 2378117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2378120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378128 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2378128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2378131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378139 */     // GIR_Coverage, 1646,
     /* 2378139 */     GIR_EraseRootFromParent_Done,
     /* 2378140 */   // Label 33918: @2378140
     /* 2378140 */   GIM_Try, /*On fail goto*//*Label 33919*/ GIMT_Encode4(2378168), // Rule ID 1667 //
     /* 2378145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2378148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2378152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2378156 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2378156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2378159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378167 */     // GIR_Coverage, 1667,
     /* 2378167 */     GIR_EraseRootFromParent_Done,
     /* 2378168 */   // Label 33919: @2378168
     /* 2378168 */   GIM_Try, /*On fail goto*//*Label 33920*/ GIMT_Encode4(2378196), // Rule ID 1668 //
     /* 2378173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2378176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2378180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2378184 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2378184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2378187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378195 */     // GIR_Coverage, 1668,
     /* 2378195 */     GIR_EraseRootFromParent_Done,
     /* 2378196 */   // Label 33920: @2378196
     /* 2378196 */   GIM_Reject,
     /* 2378197 */ // Label 33915: @2378197
     /* 2378197 */ GIM_Reject,
     /* 2378198 */ // Label 33889: @2378198
     /* 2378198 */ GIM_Try, /*On fail goto*//*Label 33921*/ GIMT_Encode4(2378307),
     /* 2378203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2378206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378214 */   GIM_Try, /*On fail goto*//*Label 33922*/ GIMT_Encode4(2378260), // Rule ID 56230 //
     /* 2378219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2378222 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2378239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378259 */     // GIR_Coverage, 56230,
     /* 2378259 */     GIR_EraseRootFromParent_Done,
     /* 2378260 */   // Label 33922: @2378260
     /* 2378260 */   GIM_Try, /*On fail goto*//*Label 33923*/ GIMT_Encode4(2378306), // Rule ID 56231 //
     /* 2378265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2378268 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2378285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378305 */     // GIR_Coverage, 56231,
     /* 2378305 */     GIR_EraseRootFromParent_Done,
     /* 2378306 */   // Label 33923: @2378306
     /* 2378306 */   GIM_Reject,
     /* 2378307 */ // Label 33921: @2378307
     /* 2378307 */ GIM_Reject,
     /* 2378308 */ // Label 33890: @2378308
     /* 2378308 */ GIM_Try, /*On fail goto*//*Label 33924*/ GIMT_Encode4(2378417),
     /* 2378313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2378316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378324 */   GIM_Try, /*On fail goto*//*Label 33925*/ GIMT_Encode4(2378370), // Rule ID 56270 //
     /* 2378329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2378332 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2378349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378369 */     // GIR_Coverage, 56270,
     /* 2378369 */     GIR_EraseRootFromParent_Done,
     /* 2378370 */   // Label 33925: @2378370
     /* 2378370 */   GIM_Try, /*On fail goto*//*Label 33926*/ GIMT_Encode4(2378416), // Rule ID 56271 //
     /* 2378375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2378378 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2378381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2378395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378415 */     // GIR_Coverage, 56271,
     /* 2378415 */     GIR_EraseRootFromParent_Done,
     /* 2378416 */   // Label 33926: @2378416
     /* 2378416 */   GIM_Reject,
     /* 2378417 */ // Label 33924: @2378417
     /* 2378417 */ GIM_Reject,
     /* 2378418 */ // Label 33891: @2378418
     /* 2378418 */ GIM_Try, /*On fail goto*//*Label 33927*/ GIMT_Encode4(2378527),
     /* 2378423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2378426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378434 */   GIM_Try, /*On fail goto*//*Label 33928*/ GIMT_Encode4(2378480), // Rule ID 56330 //
     /* 2378439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2378442 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2378459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378479 */     // GIR_Coverage, 56330,
     /* 2378479 */     GIR_EraseRootFromParent_Done,
     /* 2378480 */   // Label 33928: @2378480
     /* 2378480 */   GIM_Try, /*On fail goto*//*Label 33929*/ GIMT_Encode4(2378526), // Rule ID 56331 //
     /* 2378485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2378488 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2378491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2378505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378525 */     // GIR_Coverage, 56331,
     /* 2378525 */     GIR_EraseRootFromParent_Done,
     /* 2378526 */   // Label 33929: @2378526
     /* 2378526 */   GIM_Reject,
     /* 2378527 */ // Label 33927: @2378527
     /* 2378527 */ GIM_Reject,
     /* 2378528 */ // Label 33892: @2378528
     /* 2378528 */ GIM_Try, /*On fail goto*//*Label 33930*/ GIMT_Encode4(2378637),
     /* 2378533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2378536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378544 */   GIM_Try, /*On fail goto*//*Label 33931*/ GIMT_Encode4(2378590), // Rule ID 56250 //
     /* 2378549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2378552 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2378569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378589 */     // GIR_Coverage, 56250,
     /* 2378589 */     GIR_EraseRootFromParent_Done,
     /* 2378590 */   // Label 33931: @2378590
     /* 2378590 */   GIM_Try, /*On fail goto*//*Label 33932*/ GIMT_Encode4(2378636), // Rule ID 56251 //
     /* 2378595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2378598 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2378601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2378615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378635 */     // GIR_Coverage, 56251,
     /* 2378635 */     GIR_EraseRootFromParent_Done,
     /* 2378636 */   // Label 33932: @2378636
     /* 2378636 */   GIM_Reject,
     /* 2378637 */ // Label 33930: @2378637
     /* 2378637 */ GIM_Reject,
     /* 2378638 */ // Label 33893: @2378638
     /* 2378638 */ GIM_Try, /*On fail goto*//*Label 33933*/ GIMT_Encode4(2378747),
     /* 2378643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2378646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378654 */   GIM_Try, /*On fail goto*//*Label 33934*/ GIMT_Encode4(2378700), // Rule ID 56310 //
     /* 2378659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2378662 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2378665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2378679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378699 */     // GIR_Coverage, 56310,
     /* 2378699 */     GIR_EraseRootFromParent_Done,
     /* 2378700 */   // Label 33934: @2378700
     /* 2378700 */   GIM_Try, /*On fail goto*//*Label 33935*/ GIMT_Encode4(2378746), // Rule ID 56311 //
     /* 2378705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2378708 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2378711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2378725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378745 */     // GIR_Coverage, 56311,
     /* 2378745 */     GIR_EraseRootFromParent_Done,
     /* 2378746 */   // Label 33935: @2378746
     /* 2378746 */   GIM_Reject,
     /* 2378747 */ // Label 33933: @2378747
     /* 2378747 */ GIM_Reject,
     /* 2378748 */ // Label 33894: @2378748
     /* 2378748 */ GIM_Try, /*On fail goto*//*Label 33936*/ GIMT_Encode4(2378857),
     /* 2378753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2378756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378764 */   GIM_Try, /*On fail goto*//*Label 33937*/ GIMT_Encode4(2378810), // Rule ID 56470 //
     /* 2378769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2378772 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2378775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2378789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378809 */     // GIR_Coverage, 56470,
     /* 2378809 */     GIR_EraseRootFromParent_Done,
     /* 2378810 */   // Label 33937: @2378810
     /* 2378810 */   GIM_Try, /*On fail goto*//*Label 33938*/ GIMT_Encode4(2378856), // Rule ID 56471 //
     /* 2378815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2378818 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2378821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2378835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378855 */     // GIR_Coverage, 56471,
     /* 2378855 */     GIR_EraseRootFromParent_Done,
     /* 2378856 */   // Label 33938: @2378856
     /* 2378856 */   GIM_Reject,
     /* 2378857 */ // Label 33936: @2378857
     /* 2378857 */ GIM_Reject,
     /* 2378858 */ // Label 33895: @2378858
     /* 2378858 */ GIM_Try, /*On fail goto*//*Label 33939*/ GIMT_Encode4(2378967),
     /* 2378863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2378866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378874 */   GIM_Try, /*On fail goto*//*Label 33940*/ GIMT_Encode4(2378920), // Rule ID 56290 //
     /* 2378879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2378882 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2378885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2378899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378919 */     // GIR_Coverage, 56290,
     /* 2378919 */     GIR_EraseRootFromParent_Done,
     /* 2378920 */   // Label 33940: @2378920
     /* 2378920 */   GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2378966), // Rule ID 56291 //
     /* 2378925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2378928 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2378931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2378945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2378952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378965 */     // GIR_Coverage, 56291,
     /* 2378965 */     GIR_EraseRootFromParent_Done,
     /* 2378966 */   // Label 33941: @2378966
     /* 2378966 */   GIM_Reject,
     /* 2378967 */ // Label 33939: @2378967
     /* 2378967 */ GIM_Reject,
     /* 2378968 */ // Label 33896: @2378968
     /* 2378968 */ GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2379077),
     /* 2378973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2378976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2378984 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2379030), // Rule ID 56410 //
     /* 2378989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2378992 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2378995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2379009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379029 */     // GIR_Coverage, 56410,
     /* 2379029 */     GIR_EraseRootFromParent_Done,
     /* 2379030 */   // Label 33943: @2379030
     /* 2379030 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2379076), // Rule ID 56411 //
     /* 2379035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2379038 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2379055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379075 */     // GIR_Coverage, 56411,
     /* 2379075 */     GIR_EraseRootFromParent_Done,
     /* 2379076 */   // Label 33944: @2379076
     /* 2379076 */   GIM_Reject,
     /* 2379077 */ // Label 33942: @2379077
     /* 2379077 */ GIM_Reject,
     /* 2379078 */ // Label 33897: @2379078
     /* 2379078 */ GIM_Try, /*On fail goto*//*Label 33945*/ GIMT_Encode4(2379187),
     /* 2379083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2379086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379094 */   GIM_Try, /*On fail goto*//*Label 33946*/ GIMT_Encode4(2379140), // Rule ID 56490 //
     /* 2379099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2379102 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2379119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379139 */     // GIR_Coverage, 56490,
     /* 2379139 */     GIR_EraseRootFromParent_Done,
     /* 2379140 */   // Label 33946: @2379140
     /* 2379140 */   GIM_Try, /*On fail goto*//*Label 33947*/ GIMT_Encode4(2379186), // Rule ID 56491 //
     /* 2379145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2379148 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2379165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379185 */     // GIR_Coverage, 56491,
     /* 2379185 */     GIR_EraseRootFromParent_Done,
     /* 2379186 */   // Label 33947: @2379186
     /* 2379186 */   GIM_Reject,
     /* 2379187 */ // Label 33945: @2379187
     /* 2379187 */ GIM_Reject,
     /* 2379188 */ // Label 33898: @2379188
     /* 2379188 */ GIM_Try, /*On fail goto*//*Label 33948*/ GIMT_Encode4(2379297),
     /* 2379193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2379196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379204 */   GIM_Try, /*On fail goto*//*Label 33949*/ GIMT_Encode4(2379250), // Rule ID 56350 //
     /* 2379209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379212 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2379229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379249 */     // GIR_Coverage, 56350,
     /* 2379249 */     GIR_EraseRootFromParent_Done,
     /* 2379250 */   // Label 33949: @2379250
     /* 2379250 */   GIM_Try, /*On fail goto*//*Label 33950*/ GIMT_Encode4(2379296), // Rule ID 56351 //
     /* 2379255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379258 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2379261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2379275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379295 */     // GIR_Coverage, 56351,
     /* 2379295 */     GIR_EraseRootFromParent_Done,
     /* 2379296 */   // Label 33950: @2379296
     /* 2379296 */   GIM_Reject,
     /* 2379297 */ // Label 33948: @2379297
     /* 2379297 */ GIM_Reject,
     /* 2379298 */ // Label 33899: @2379298
     /* 2379298 */ GIM_Try, /*On fail goto*//*Label 33951*/ GIMT_Encode4(2379407),
     /* 2379303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2379306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379314 */   GIM_Try, /*On fail goto*//*Label 33952*/ GIMT_Encode4(2379360), // Rule ID 56430 //
     /* 2379319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2379322 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2379339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379359 */     // GIR_Coverage, 56430,
     /* 2379359 */     GIR_EraseRootFromParent_Done,
     /* 2379360 */   // Label 33952: @2379360
     /* 2379360 */   GIM_Try, /*On fail goto*//*Label 33953*/ GIMT_Encode4(2379406), // Rule ID 56431 //
     /* 2379365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2379368 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2379371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2379385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379405 */     // GIR_Coverage, 56431,
     /* 2379405 */     GIR_EraseRootFromParent_Done,
     /* 2379406 */   // Label 33953: @2379406
     /* 2379406 */   GIM_Reject,
     /* 2379407 */ // Label 33951: @2379407
     /* 2379407 */ GIM_Reject,
     /* 2379408 */ // Label 33900: @2379408
     /* 2379408 */ GIM_Try, /*On fail goto*//*Label 33954*/ GIMT_Encode4(2379517),
     /* 2379413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2379416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379424 */   GIM_Try, /*On fail goto*//*Label 33955*/ GIMT_Encode4(2379470), // Rule ID 56510 //
     /* 2379429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2379432 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2379435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2379449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379469 */     // GIR_Coverage, 56510,
     /* 2379469 */     GIR_EraseRootFromParent_Done,
     /* 2379470 */   // Label 33955: @2379470
     /* 2379470 */   GIM_Try, /*On fail goto*//*Label 33956*/ GIMT_Encode4(2379516), // Rule ID 56511 //
     /* 2379475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2379478 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2379481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2379495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379515 */     // GIR_Coverage, 56511,
     /* 2379515 */     GIR_EraseRootFromParent_Done,
     /* 2379516 */   // Label 33956: @2379516
     /* 2379516 */   GIM_Reject,
     /* 2379517 */ // Label 33954: @2379517
     /* 2379517 */ GIM_Reject,
     /* 2379518 */ // Label 33901: @2379518
     /* 2379518 */ GIM_Try, /*On fail goto*//*Label 33957*/ GIMT_Encode4(2379627),
     /* 2379523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2379526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379534 */   GIM_Try, /*On fail goto*//*Label 33958*/ GIMT_Encode4(2379580), // Rule ID 56370 //
     /* 2379539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379542 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2379545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2379559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379579 */     // GIR_Coverage, 56370,
     /* 2379579 */     GIR_EraseRootFromParent_Done,
     /* 2379580 */   // Label 33958: @2379580
     /* 2379580 */   GIM_Try, /*On fail goto*//*Label 33959*/ GIMT_Encode4(2379626), // Rule ID 56371 //
     /* 2379585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379588 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2379591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2379605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379625 */     // GIR_Coverage, 56371,
     /* 2379625 */     GIR_EraseRootFromParent_Done,
     /* 2379626 */   // Label 33959: @2379626
     /* 2379626 */   GIM_Reject,
     /* 2379627 */ // Label 33957: @2379627
     /* 2379627 */ GIM_Reject,
     /* 2379628 */ // Label 33902: @2379628
     /* 2379628 */ GIM_Try, /*On fail goto*//*Label 33960*/ GIMT_Encode4(2379737),
     /* 2379633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2379636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379644 */   GIM_Try, /*On fail goto*//*Label 33961*/ GIMT_Encode4(2379690), // Rule ID 56450 //
     /* 2379649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2379652 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2379655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2379669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379689 */     // GIR_Coverage, 56450,
     /* 2379689 */     GIR_EraseRootFromParent_Done,
     /* 2379690 */   // Label 33961: @2379690
     /* 2379690 */   GIM_Try, /*On fail goto*//*Label 33962*/ GIMT_Encode4(2379736), // Rule ID 56451 //
     /* 2379695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2379698 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2379701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2379715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379735 */     // GIR_Coverage, 56451,
     /* 2379735 */     GIR_EraseRootFromParent_Done,
     /* 2379736 */   // Label 33962: @2379736
     /* 2379736 */   GIM_Reject,
     /* 2379737 */ // Label 33960: @2379737
     /* 2379737 */ GIM_Reject,
     /* 2379738 */ // Label 33903: @2379738
     /* 2379738 */ GIM_Try, /*On fail goto*//*Label 33963*/ GIMT_Encode4(2379847),
     /* 2379743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2379746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2379754 */   GIM_Try, /*On fail goto*//*Label 33964*/ GIMT_Encode4(2379800), // Rule ID 56390 //
     /* 2379759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379762 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2379765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2379779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379799 */     // GIR_Coverage, 56390,
     /* 2379799 */     GIR_EraseRootFromParent_Done,
     /* 2379800 */   // Label 33964: @2379800
     /* 2379800 */   GIM_Try, /*On fail goto*//*Label 33965*/ GIMT_Encode4(2379846), // Rule ID 56391 //
     /* 2379805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379808 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2379811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2379825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2379832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379845 */     // GIR_Coverage, 56391,
     /* 2379845 */     GIR_EraseRootFromParent_Done,
     /* 2379846 */   // Label 33965: @2379846
     /* 2379846 */   GIM_Reject,
     /* 2379847 */ // Label 33963: @2379847
     /* 2379847 */ GIM_Reject,
     /* 2379848 */ // Label 33904: @2379848
     /* 2379848 */ GIM_Reject,
     /* 2379849 */ // Label 95: @2379849
     /* 2379849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33969*/ GIMT_Encode4(2380046),
     /* 2379860 */ /*GILLT_s16*//*Label 33966*/ GIMT_Encode4(2379872),
     /* 2379864 */ /*GILLT_s32*//*Label 33967*/ GIMT_Encode4(2379930),
     /* 2379868 */ /*GILLT_s64*//*Label 33968*/ GIMT_Encode4(2379988),
     /* 2379872 */ // Label 33966: @2379872
     /* 2379872 */ GIM_Try, /*On fail goto*//*Label 33970*/ GIMT_Encode4(2379929),
     /* 2379877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2379880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2379884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2379888 */   GIM_Try, /*On fail goto*//*Label 33971*/ GIMT_Encode4(2379908), // Rule ID 2420 //
     /* 2379893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2379896 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2379896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2379899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2379906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379907 */     // GIR_Coverage, 2420,
     /* 2379907 */     GIR_EraseRootFromParent_Done,
     /* 2379908 */   // Label 33971: @2379908
     /* 2379908 */   GIM_Try, /*On fail goto*//*Label 33972*/ GIMT_Encode4(2379928), // Rule ID 2421 //
     /* 2379913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2379916 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2379916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2379919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2379926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379927 */     // GIR_Coverage, 2421,
     /* 2379927 */     GIR_EraseRootFromParent_Done,
     /* 2379928 */   // Label 33972: @2379928
     /* 2379928 */   GIM_Reject,
     /* 2379929 */ // Label 33970: @2379929
     /* 2379929 */ GIM_Reject,
     /* 2379930 */ // Label 33967: @2379930
     /* 2379930 */ GIM_Try, /*On fail goto*//*Label 33973*/ GIMT_Encode4(2379987),
     /* 2379935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2379938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2379942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2379946 */   GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2379966), // Rule ID 2338 //
     /* 2379951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2379954 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2379954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2379957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2379964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379965 */     // GIR_Coverage, 2338,
     /* 2379965 */     GIR_EraseRootFromParent_Done,
     /* 2379966 */   // Label 33974: @2379966
     /* 2379966 */   GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2379986), // Rule ID 2339 //
     /* 2379971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2379974 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2379974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2379977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2379984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379985 */     // GIR_Coverage, 2339,
     /* 2379985 */     GIR_EraseRootFromParent_Done,
     /* 2379986 */   // Label 33975: @2379986
     /* 2379986 */   GIM_Reject,
     /* 2379987 */ // Label 33973: @2379987
     /* 2379987 */ GIM_Reject,
     /* 2379988 */ // Label 33968: @2379988
     /* 2379988 */ GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2380045),
     /* 2379993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2379996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380004 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2380024), // Rule ID 2378 //
     /* 2380009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2380012 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2380012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2380015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2380022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380023 */     // GIR_Coverage, 2378,
     /* 2380023 */     GIR_EraseRootFromParent_Done,
     /* 2380024 */   // Label 33977: @2380024
     /* 2380024 */   GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2380044), // Rule ID 2379 //
     /* 2380029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2380032 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2380032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2380035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2380042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380043 */     // GIR_Coverage, 2379,
     /* 2380043 */     GIR_EraseRootFromParent_Done,
     /* 2380044 */   // Label 33978: @2380044
     /* 2380044 */   GIM_Reject,
     /* 2380045 */ // Label 33976: @2380045
     /* 2380045 */ GIM_Reject,
     /* 2380046 */ // Label 33969: @2380046
     /* 2380046 */ GIM_Reject,
     /* 2380047 */ // Label 96: @2380047
     /* 2380047 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33982*/ GIMT_Encode4(2380244),
     /* 2380058 */ /*GILLT_s16*//*Label 33979*/ GIMT_Encode4(2380070),
     /* 2380062 */ /*GILLT_s32*//*Label 33980*/ GIMT_Encode4(2380128),
     /* 2380066 */ /*GILLT_s64*//*Label 33981*/ GIMT_Encode4(2380186),
     /* 2380070 */ // Label 33979: @2380070
     /* 2380070 */ GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2380127),
     /* 2380075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2380078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380086 */   GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2380106), // Rule ID 2404 //
     /* 2380091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2380094 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2380094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2380097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380105 */     // GIR_Coverage, 2404,
     /* 2380105 */     GIR_EraseRootFromParent_Done,
     /* 2380106 */   // Label 33984: @2380106
     /* 2380106 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2380126), // Rule ID 2405 //
     /* 2380111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2380114 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2380114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2380117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380125 */     // GIR_Coverage, 2405,
     /* 2380125 */     GIR_EraseRootFromParent_Done,
     /* 2380126 */   // Label 33985: @2380126
     /* 2380126 */   GIM_Reject,
     /* 2380127 */ // Label 33983: @2380127
     /* 2380127 */ GIM_Reject,
     /* 2380128 */ // Label 33980: @2380128
     /* 2380128 */ GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2380185),
     /* 2380133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380144 */   GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2380164), // Rule ID 2322 //
     /* 2380149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2380152 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2380152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2380155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380163 */     // GIR_Coverage, 2322,
     /* 2380163 */     GIR_EraseRootFromParent_Done,
     /* 2380164 */   // Label 33987: @2380164
     /* 2380164 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2380184), // Rule ID 2323 //
     /* 2380169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2380172 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2380172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2380175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380183 */     // GIR_Coverage, 2323,
     /* 2380183 */     GIR_EraseRootFromParent_Done,
     /* 2380184 */   // Label 33988: @2380184
     /* 2380184 */   GIM_Reject,
     /* 2380185 */ // Label 33986: @2380185
     /* 2380185 */ GIM_Reject,
     /* 2380186 */ // Label 33981: @2380186
     /* 2380186 */ GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2380243),
     /* 2380191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380202 */   GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2380222), // Rule ID 2362 //
     /* 2380207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2380210 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2380210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2380213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380221 */     // GIR_Coverage, 2362,
     /* 2380221 */     GIR_EraseRootFromParent_Done,
     /* 2380222 */   // Label 33990: @2380222
     /* 2380222 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2380242), // Rule ID 2363 //
     /* 2380227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2380230 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2380230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2380233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380241 */     // GIR_Coverage, 2363,
     /* 2380241 */     GIR_EraseRootFromParent_Done,
     /* 2380242 */   // Label 33991: @2380242
     /* 2380242 */   GIM_Reject,
     /* 2380243 */ // Label 33989: @2380243
     /* 2380243 */ GIM_Reject,
     /* 2380244 */ // Label 33982: @2380244
     /* 2380244 */ GIM_Reject,
     /* 2380245 */ // Label 97: @2380245
     /* 2380245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33995*/ GIMT_Encode4(2380442),
     /* 2380256 */ /*GILLT_s16*//*Label 33992*/ GIMT_Encode4(2380268),
     /* 2380260 */ /*GILLT_s32*//*Label 33993*/ GIMT_Encode4(2380326),
     /* 2380264 */ /*GILLT_s64*//*Label 33994*/ GIMT_Encode4(2380384),
     /* 2380268 */ // Label 33992: @2380268
     /* 2380268 */ GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2380325),
     /* 2380273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2380276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380284 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2380304), // Rule ID 2408 //
     /* 2380289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2380292 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2380292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2380295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380303 */     // GIR_Coverage, 2408,
     /* 2380303 */     GIR_EraseRootFromParent_Done,
     /* 2380304 */   // Label 33997: @2380304
     /* 2380304 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2380324), // Rule ID 2409 //
     /* 2380309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2380312 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2380312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2380315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380323 */     // GIR_Coverage, 2409,
     /* 2380323 */     GIR_EraseRootFromParent_Done,
     /* 2380324 */   // Label 33998: @2380324
     /* 2380324 */   GIM_Reject,
     /* 2380325 */ // Label 33996: @2380325
     /* 2380325 */ GIM_Reject,
     /* 2380326 */ // Label 33993: @2380326
     /* 2380326 */ GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2380383),
     /* 2380331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380342 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2380362), // Rule ID 2326 //
     /* 2380347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2380350 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2380350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2380353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380361 */     // GIR_Coverage, 2326,
     /* 2380361 */     GIR_EraseRootFromParent_Done,
     /* 2380362 */   // Label 34000: @2380362
     /* 2380362 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2380382), // Rule ID 2327 //
     /* 2380367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2380370 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2380370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2380373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380381 */     // GIR_Coverage, 2327,
     /* 2380381 */     GIR_EraseRootFromParent_Done,
     /* 2380382 */   // Label 34001: @2380382
     /* 2380382 */   GIM_Reject,
     /* 2380383 */ // Label 33999: @2380383
     /* 2380383 */ GIM_Reject,
     /* 2380384 */ // Label 33994: @2380384
     /* 2380384 */ GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2380441),
     /* 2380389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380400 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2380420), // Rule ID 2366 //
     /* 2380405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2380408 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2380408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2380411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380419 */     // GIR_Coverage, 2366,
     /* 2380419 */     GIR_EraseRootFromParent_Done,
     /* 2380420 */   // Label 34003: @2380420
     /* 2380420 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2380440), // Rule ID 2367 //
     /* 2380425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2380428 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2380428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2380431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380439 */     // GIR_Coverage, 2367,
     /* 2380439 */     GIR_EraseRootFromParent_Done,
     /* 2380440 */   // Label 34004: @2380440
     /* 2380440 */   GIM_Reject,
     /* 2380441 */ // Label 34002: @2380441
     /* 2380441 */ GIM_Reject,
     /* 2380442 */ // Label 33995: @2380442
     /* 2380442 */ GIM_Reject,
     /* 2380443 */ // Label 98: @2380443
     /* 2380443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34023*/ GIMT_Encode4(2382870),
     /* 2380454 */ /*GILLT_s16*//*Label 34005*/ GIMT_Encode4(2380574),
     /* 2380458 */ /*GILLT_s32*//*Label 34006*/ GIMT_Encode4(2380723),
     /* 2380462 */ /*GILLT_s64*//*Label 34007*/ GIMT_Encode4(2380872), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380474 */ /*GILLT_nxv1s16*//*Label 34008*/ GIMT_Encode4(2381055),
     /* 2380478 */ /*GILLT_nxv1s32*//*Label 34009*/ GIMT_Encode4(2381176),
     /* 2380482 */ /*GILLT_nxv1s64*//*Label 34010*/ GIMT_Encode4(2381297), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380494 */ /*GILLT_nxv2s16*//*Label 34011*/ GIMT_Encode4(2381418),
     /* 2380498 */ /*GILLT_nxv2s32*//*Label 34012*/ GIMT_Encode4(2381539),
     /* 2380502 */ /*GILLT_nxv2s64*//*Label 34013*/ GIMT_Encode4(2381660), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380514 */ /*GILLT_nxv4s16*//*Label 34014*/ GIMT_Encode4(2381781),
     /* 2380518 */ /*GILLT_nxv4s32*//*Label 34015*/ GIMT_Encode4(2381902),
     /* 2380522 */ /*GILLT_nxv4s64*//*Label 34016*/ GIMT_Encode4(2382023), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380534 */ /*GILLT_nxv8s16*//*Label 34017*/ GIMT_Encode4(2382144),
     /* 2380538 */ /*GILLT_nxv8s32*//*Label 34018*/ GIMT_Encode4(2382265),
     /* 2380542 */ /*GILLT_nxv8s64*//*Label 34019*/ GIMT_Encode4(2382386), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380554 */ /*GILLT_nxv16s16*//*Label 34020*/ GIMT_Encode4(2382507),
     /* 2380558 */ /*GILLT_nxv16s32*//*Label 34021*/ GIMT_Encode4(2382628), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2380570 */ /*GILLT_nxv32s16*//*Label 34022*/ GIMT_Encode4(2382749),
     /* 2380574 */ // Label 34005: @2380574
     /* 2380574 */ GIM_Try, /*On fail goto*//*Label 34024*/ GIMT_Encode4(2380722),
     /* 2380579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2380582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2380585 */   GIM_Try, /*On fail goto*//*Label 34025*/ GIMT_Encode4(2380619), // Rule ID 1948 //
     /* 2380590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2380593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380605 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2380605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2380608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380618 */     // GIR_Coverage, 1948,
     /* 2380618 */     GIR_EraseRootFromParent_Done,
     /* 2380619 */   // Label 34025: @2380619
     /* 2380619 */   GIM_Try, /*On fail goto*//*Label 34026*/ GIMT_Encode4(2380653), // Rule ID 1949 //
     /* 2380624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2380627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2380639 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2380639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2380642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380652 */     // GIR_Coverage, 1949,
     /* 2380652 */     GIR_EraseRootFromParent_Done,
     /* 2380653 */   // Label 34026: @2380653
     /* 2380653 */   GIM_Try, /*On fail goto*//*Label 34027*/ GIMT_Encode4(2380687), // Rule ID 1952 //
     /* 2380658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2380661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380673 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2380673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2380676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380686 */     // GIR_Coverage, 1952,
     /* 2380686 */     GIR_EraseRootFromParent_Done,
     /* 2380687 */   // Label 34027: @2380687
     /* 2380687 */   GIM_Try, /*On fail goto*//*Label 34028*/ GIMT_Encode4(2380721), // Rule ID 1953 //
     /* 2380692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2380695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2380707 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2380707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2380710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380720 */     // GIR_Coverage, 1953,
     /* 2380720 */     GIR_EraseRootFromParent_Done,
     /* 2380721 */   // Label 34028: @2380721
     /* 2380721 */   GIM_Reject,
     /* 2380722 */ // Label 34024: @2380722
     /* 2380722 */ GIM_Reject,
     /* 2380723 */ // Label 34006: @2380723
     /* 2380723 */ GIM_Try, /*On fail goto*//*Label 34029*/ GIMT_Encode4(2380871),
     /* 2380728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2380731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2380734 */   GIM_Try, /*On fail goto*//*Label 34030*/ GIMT_Encode4(2380768), // Rule ID 1235 //
     /* 2380739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2380742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380754 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2380754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2380757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380767 */     // GIR_Coverage, 1235,
     /* 2380767 */     GIR_EraseRootFromParent_Done,
     /* 2380768 */   // Label 34030: @2380768
     /* 2380768 */   GIM_Try, /*On fail goto*//*Label 34031*/ GIMT_Encode4(2380802), // Rule ID 1236 //
     /* 2380773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2380776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2380788 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2380788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2380791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380801 */     // GIR_Coverage, 1236,
     /* 2380801 */     GIR_EraseRootFromParent_Done,
     /* 2380802 */   // Label 34031: @2380802
     /* 2380802 */   GIM_Try, /*On fail goto*//*Label 34032*/ GIMT_Encode4(2380836), // Rule ID 1239 //
     /* 2380807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2380810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380822 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2380822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2380825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380835 */     // GIR_Coverage, 1239,
     /* 2380835 */     GIR_EraseRootFromParent_Done,
     /* 2380836 */   // Label 34032: @2380836
     /* 2380836 */   GIM_Try, /*On fail goto*//*Label 34033*/ GIMT_Encode4(2380870), // Rule ID 1240 //
     /* 2380841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2380844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2380856 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2380856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2380859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380869 */     // GIR_Coverage, 1240,
     /* 2380869 */     GIR_EraseRootFromParent_Done,
     /* 2380870 */   // Label 34033: @2380870
     /* 2380870 */   GIM_Reject,
     /* 2380871 */ // Label 34029: @2380871
     /* 2380871 */ GIM_Reject,
     /* 2380872 */ // Label 34007: @2380872
     /* 2380872 */ GIM_Try, /*On fail goto*//*Label 34034*/ GIMT_Encode4(2381054),
     /* 2380877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2380880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2380883 */   GIM_Try, /*On fail goto*//*Label 34035*/ GIMT_Encode4(2380917), // Rule ID 1570 //
     /* 2380888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2380891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380903 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2380903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2380906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380916 */     // GIR_Coverage, 1570,
     /* 2380916 */     GIR_EraseRootFromParent_Done,
     /* 2380917 */   // Label 34035: @2380917
     /* 2380917 */   GIM_Try, /*On fail goto*//*Label 34036*/ GIMT_Encode4(2380951), // Rule ID 1571 //
     /* 2380922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2380925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2380937 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2380937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2380940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380950 */     // GIR_Coverage, 1571,
     /* 2380950 */     GIR_EraseRootFromParent_Done,
     /* 2380951 */   // Label 34036: @2380951
     /* 2380951 */   GIM_Try, /*On fail goto*//*Label 34037*/ GIMT_Encode4(2380985), // Rule ID 1574 //
     /* 2380956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2380959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2380963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2380967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2380971 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2380971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2380974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380984 */     // GIR_Coverage, 1574,
     /* 2380984 */     GIR_EraseRootFromParent_Done,
     /* 2380985 */   // Label 34037: @2380985
     /* 2380985 */   GIM_Try, /*On fail goto*//*Label 34038*/ GIMT_Encode4(2381019), // Rule ID 1575 //
     /* 2380990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2380993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2380997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381005 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2381005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2381008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381018 */     // GIR_Coverage, 1575,
     /* 2381018 */     GIR_EraseRootFromParent_Done,
     /* 2381019 */   // Label 34038: @2381019
     /* 2381019 */   GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2381053), // Rule ID 1578 //
     /* 2381024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381039 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2381039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2381042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381052 */     // GIR_Coverage, 1578,
     /* 2381052 */     GIR_EraseRootFromParent_Done,
     /* 2381053 */   // Label 34039: @2381053
     /* 2381053 */   GIM_Reject,
     /* 2381054 */ // Label 34034: @2381054
     /* 2381054 */ GIM_Reject,
     /* 2381055 */ // Label 34008: @2381055
     /* 2381055 */ GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2381175),
     /* 2381060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2381063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2381066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381078 */   GIM_Try, /*On fail goto*//*Label 34041*/ GIMT_Encode4(2381126), // Rule ID 45750 //
     /* 2381083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2381086 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2381103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381125 */     // GIR_Coverage, 45750,
     /* 2381125 */     GIR_EraseRootFromParent_Done,
     /* 2381126 */   // Label 34041: @2381126
     /* 2381126 */   GIM_Try, /*On fail goto*//*Label 34042*/ GIMT_Encode4(2381174), // Rule ID 45751 //
     /* 2381131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2381134 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2381151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381173 */     // GIR_Coverage, 45751,
     /* 2381173 */     GIR_EraseRootFromParent_Done,
     /* 2381174 */   // Label 34042: @2381174
     /* 2381174 */   GIM_Reject,
     /* 2381175 */ // Label 34040: @2381175
     /* 2381175 */ GIM_Reject,
     /* 2381176 */ // Label 34009: @2381176
     /* 2381176 */ GIM_Try, /*On fail goto*//*Label 34043*/ GIMT_Encode4(2381296),
     /* 2381181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2381184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2381187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381199 */   GIM_Try, /*On fail goto*//*Label 34044*/ GIMT_Encode4(2381247), // Rule ID 53290 //
     /* 2381204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2381207 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2381224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381246 */     // GIR_Coverage, 53290,
     /* 2381246 */     GIR_EraseRootFromParent_Done,
     /* 2381247 */   // Label 34044: @2381247
     /* 2381247 */   GIM_Try, /*On fail goto*//*Label 34045*/ GIMT_Encode4(2381295), // Rule ID 53291 //
     /* 2381252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2381255 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2381272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381294 */     // GIR_Coverage, 53291,
     /* 2381294 */     GIR_EraseRootFromParent_Done,
     /* 2381295 */   // Label 34045: @2381295
     /* 2381295 */   GIM_Reject,
     /* 2381296 */ // Label 34043: @2381296
     /* 2381296 */ GIM_Reject,
     /* 2381297 */ // Label 34010: @2381297
     /* 2381297 */ GIM_Try, /*On fail goto*//*Label 34046*/ GIMT_Encode4(2381417),
     /* 2381302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2381305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2381308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381320 */   GIM_Try, /*On fail goto*//*Label 34047*/ GIMT_Encode4(2381368), // Rule ID 53326 //
     /* 2381325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2381328 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2381345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381367 */     // GIR_Coverage, 53326,
     /* 2381367 */     GIR_EraseRootFromParent_Done,
     /* 2381368 */   // Label 34047: @2381368
     /* 2381368 */   GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2381416), // Rule ID 53327 //
     /* 2381373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2381376 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2381393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381415 */     // GIR_Coverage, 53327,
     /* 2381415 */     GIR_EraseRootFromParent_Done,
     /* 2381416 */   // Label 34048: @2381416
     /* 2381416 */   GIM_Reject,
     /* 2381417 */ // Label 34046: @2381417
     /* 2381417 */ GIM_Reject,
     /* 2381418 */ // Label 34011: @2381418
     /* 2381418 */ GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2381538),
     /* 2381423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2381426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2381429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381441 */   GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2381489), // Rule ID 53278 //
     /* 2381446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2381449 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2381466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381488 */     // GIR_Coverage, 53278,
     /* 2381488 */     GIR_EraseRootFromParent_Done,
     /* 2381489 */   // Label 34050: @2381489
     /* 2381489 */   GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2381537), // Rule ID 53279 //
     /* 2381494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2381497 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2381514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381536 */     // GIR_Coverage, 53279,
     /* 2381536 */     GIR_EraseRootFromParent_Done,
     /* 2381537 */   // Label 34051: @2381537
     /* 2381537 */   GIM_Reject,
     /* 2381538 */ // Label 34049: @2381538
     /* 2381538 */ GIM_Reject,
     /* 2381539 */ // Label 34012: @2381539
     /* 2381539 */ GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2381659),
     /* 2381544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2381547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2381550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381562 */   GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2381610), // Rule ID 53314 //
     /* 2381567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2381570 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2381573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2381587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381609 */     // GIR_Coverage, 53314,
     /* 2381609 */     GIR_EraseRootFromParent_Done,
     /* 2381610 */   // Label 34053: @2381610
     /* 2381610 */   GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2381658), // Rule ID 53315 //
     /* 2381615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2381618 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2381621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2381635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381657 */     // GIR_Coverage, 53315,
     /* 2381657 */     GIR_EraseRootFromParent_Done,
     /* 2381658 */   // Label 34054: @2381658
     /* 2381658 */   GIM_Reject,
     /* 2381659 */ // Label 34052: @2381659
     /* 2381659 */ GIM_Reject,
     /* 2381660 */ // Label 34013: @2381660
     /* 2381660 */ GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2381780),
     /* 2381665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2381668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2381671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381683 */   GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2381731), // Rule ID 53410 //
     /* 2381688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2381691 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2381694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2381708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381730 */     // GIR_Coverage, 53410,
     /* 2381730 */     GIR_EraseRootFromParent_Done,
     /* 2381731 */   // Label 34056: @2381731
     /* 2381731 */   GIM_Try, /*On fail goto*//*Label 34057*/ GIMT_Encode4(2381779), // Rule ID 53411 //
     /* 2381736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2381739 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2381742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2381756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381778 */     // GIR_Coverage, 53411,
     /* 2381778 */     GIR_EraseRootFromParent_Done,
     /* 2381779 */   // Label 34057: @2381779
     /* 2381779 */   GIM_Reject,
     /* 2381780 */ // Label 34055: @2381780
     /* 2381780 */ GIM_Reject,
     /* 2381781 */ // Label 34014: @2381781
     /* 2381781 */ GIM_Try, /*On fail goto*//*Label 34058*/ GIMT_Encode4(2381901),
     /* 2381786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2381789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2381792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381804 */   GIM_Try, /*On fail goto*//*Label 34059*/ GIMT_Encode4(2381852), // Rule ID 53302 //
     /* 2381809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2381812 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2381815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2381829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381851 */     // GIR_Coverage, 53302,
     /* 2381851 */     GIR_EraseRootFromParent_Done,
     /* 2381852 */   // Label 34059: @2381852
     /* 2381852 */   GIM_Try, /*On fail goto*//*Label 34060*/ GIMT_Encode4(2381900), // Rule ID 53303 //
     /* 2381857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2381860 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2381863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2381877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381899 */     // GIR_Coverage, 53303,
     /* 2381899 */     GIR_EraseRootFromParent_Done,
     /* 2381900 */   // Label 34060: @2381900
     /* 2381900 */   GIM_Reject,
     /* 2381901 */ // Label 34058: @2381901
     /* 2381901 */ GIM_Reject,
     /* 2381902 */ // Label 34015: @2381902
     /* 2381902 */ GIM_Try, /*On fail goto*//*Label 34061*/ GIMT_Encode4(2382022),
     /* 2381907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2381910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2381913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2381925 */   GIM_Try, /*On fail goto*//*Label 34062*/ GIMT_Encode4(2381973), // Rule ID 53374 //
     /* 2381930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2381933 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2381936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2381950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381972 */     // GIR_Coverage, 53374,
     /* 2381972 */     GIR_EraseRootFromParent_Done,
     /* 2381973 */   // Label 34062: @2381973
     /* 2381973 */   GIM_Try, /*On fail goto*//*Label 34063*/ GIMT_Encode4(2382021), // Rule ID 53375 //
     /* 2381978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2381981 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2381984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2381998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382020 */     // GIR_Coverage, 53375,
     /* 2382020 */     GIR_EraseRootFromParent_Done,
     /* 2382021 */   // Label 34063: @2382021
     /* 2382021 */   GIM_Reject,
     /* 2382022 */ // Label 34061: @2382022
     /* 2382022 */ GIM_Reject,
     /* 2382023 */ // Label 34016: @2382023
     /* 2382023 */ GIM_Try, /*On fail goto*//*Label 34064*/ GIMT_Encode4(2382143),
     /* 2382028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2382031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2382034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382046 */   GIM_Try, /*On fail goto*//*Label 34065*/ GIMT_Encode4(2382094), // Rule ID 53422 //
     /* 2382051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2382054 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2382071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382093 */     // GIR_Coverage, 53422,
     /* 2382093 */     GIR_EraseRootFromParent_Done,
     /* 2382094 */   // Label 34065: @2382094
     /* 2382094 */   GIM_Try, /*On fail goto*//*Label 34066*/ GIMT_Encode4(2382142), // Rule ID 53423 //
     /* 2382099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2382102 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2382119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382141 */     // GIR_Coverage, 53423,
     /* 2382141 */     GIR_EraseRootFromParent_Done,
     /* 2382142 */   // Label 34066: @2382142
     /* 2382142 */   GIM_Reject,
     /* 2382143 */ // Label 34064: @2382143
     /* 2382143 */ GIM_Reject,
     /* 2382144 */ // Label 34017: @2382144
     /* 2382144 */ GIM_Try, /*On fail goto*//*Label 34067*/ GIMT_Encode4(2382264),
     /* 2382149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2382152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2382155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382167 */   GIM_Try, /*On fail goto*//*Label 34068*/ GIMT_Encode4(2382215), // Rule ID 53338 //
     /* 2382172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2382175 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2382192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382214 */     // GIR_Coverage, 53338,
     /* 2382214 */     GIR_EraseRootFromParent_Done,
     /* 2382215 */   // Label 34068: @2382215
     /* 2382215 */   GIM_Try, /*On fail goto*//*Label 34069*/ GIMT_Encode4(2382263), // Rule ID 53339 //
     /* 2382220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382223 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2382240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382262 */     // GIR_Coverage, 53339,
     /* 2382262 */     GIR_EraseRootFromParent_Done,
     /* 2382263 */   // Label 34069: @2382263
     /* 2382263 */   GIM_Reject,
     /* 2382264 */ // Label 34067: @2382264
     /* 2382264 */ GIM_Reject,
     /* 2382265 */ // Label 34018: @2382265
     /* 2382265 */ GIM_Try, /*On fail goto*//*Label 34070*/ GIMT_Encode4(2382385),
     /* 2382270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2382273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2382276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382288 */   GIM_Try, /*On fail goto*//*Label 34071*/ GIMT_Encode4(2382336), // Rule ID 53386 //
     /* 2382293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2382296 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2382313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382335 */     // GIR_Coverage, 53386,
     /* 2382335 */     GIR_EraseRootFromParent_Done,
     /* 2382336 */   // Label 34071: @2382336
     /* 2382336 */   GIM_Try, /*On fail goto*//*Label 34072*/ GIMT_Encode4(2382384), // Rule ID 53387 //
     /* 2382341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2382344 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2382361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382383 */     // GIR_Coverage, 53387,
     /* 2382383 */     GIR_EraseRootFromParent_Done,
     /* 2382384 */   // Label 34072: @2382384
     /* 2382384 */   GIM_Reject,
     /* 2382385 */ // Label 34070: @2382385
     /* 2382385 */ GIM_Reject,
     /* 2382386 */ // Label 34019: @2382386
     /* 2382386 */ GIM_Try, /*On fail goto*//*Label 34073*/ GIMT_Encode4(2382506),
     /* 2382391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2382394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2382397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382409 */   GIM_Try, /*On fail goto*//*Label 34074*/ GIMT_Encode4(2382457), // Rule ID 53434 //
     /* 2382414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2382417 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2382434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382456 */     // GIR_Coverage, 53434,
     /* 2382456 */     GIR_EraseRootFromParent_Done,
     /* 2382457 */   // Label 34074: @2382457
     /* 2382457 */   GIM_Try, /*On fail goto*//*Label 34075*/ GIMT_Encode4(2382505), // Rule ID 53435 //
     /* 2382462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2382465 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2382482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382504 */     // GIR_Coverage, 53435,
     /* 2382504 */     GIR_EraseRootFromParent_Done,
     /* 2382505 */   // Label 34075: @2382505
     /* 2382505 */   GIM_Reject,
     /* 2382506 */ // Label 34073: @2382506
     /* 2382506 */ GIM_Reject,
     /* 2382507 */ // Label 34020: @2382507
     /* 2382507 */ GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2382627),
     /* 2382512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2382515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2382518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382530 */   GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2382578), // Rule ID 53350 //
     /* 2382535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2382538 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2382541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2382555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382577 */     // GIR_Coverage, 53350,
     /* 2382577 */     GIR_EraseRootFromParent_Done,
     /* 2382578 */   // Label 34077: @2382578
     /* 2382578 */   GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2382626), // Rule ID 53351 //
     /* 2382583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382586 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2382589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2382603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382625 */     // GIR_Coverage, 53351,
     /* 2382625 */     GIR_EraseRootFromParent_Done,
     /* 2382626 */   // Label 34078: @2382626
     /* 2382626 */   GIM_Reject,
     /* 2382627 */ // Label 34076: @2382627
     /* 2382627 */ GIM_Reject,
     /* 2382628 */ // Label 34021: @2382628
     /* 2382628 */ GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2382748),
     /* 2382633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2382636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2382639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382651 */   GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2382699), // Rule ID 53398 //
     /* 2382656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2382659 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2382662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2382676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382698 */     // GIR_Coverage, 53398,
     /* 2382698 */     GIR_EraseRootFromParent_Done,
     /* 2382699 */   // Label 34080: @2382699
     /* 2382699 */   GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2382747), // Rule ID 53399 //
     /* 2382704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2382707 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2382710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2382724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382746 */     // GIR_Coverage, 53399,
     /* 2382746 */     GIR_EraseRootFromParent_Done,
     /* 2382747 */   // Label 34081: @2382747
     /* 2382747 */   GIM_Reject,
     /* 2382748 */ // Label 34079: @2382748
     /* 2382748 */ GIM_Reject,
     /* 2382749 */ // Label 34022: @2382749
     /* 2382749 */ GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2382869),
     /* 2382754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2382757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2382760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382772 */   GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2382820), // Rule ID 53362 //
     /* 2382777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2382780 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2382783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2382797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382819 */     // GIR_Coverage, 53362,
     /* 2382819 */     GIR_EraseRootFromParent_Done,
     /* 2382820 */   // Label 34083: @2382820
     /* 2382820 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2382868), // Rule ID 53363 //
     /* 2382825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382828 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2382831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2382845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382867 */     // GIR_Coverage, 53363,
     /* 2382867 */     GIR_EraseRootFromParent_Done,
     /* 2382868 */   // Label 34084: @2382868
     /* 2382868 */   GIM_Reject,
     /* 2382869 */ // Label 34082: @2382869
     /* 2382869 */ GIM_Reject,
     /* 2382870 */ // Label 34023: @2382870
     /* 2382870 */ GIM_Reject,
     /* 2382871 */ // Label 99: @2382871
     /* 2382871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34103*/ GIMT_Encode4(2385298),
     /* 2382882 */ /*GILLT_s16*//*Label 34085*/ GIMT_Encode4(2383002),
     /* 2382886 */ /*GILLT_s32*//*Label 34086*/ GIMT_Encode4(2383151),
     /* 2382890 */ /*GILLT_s64*//*Label 34087*/ GIMT_Encode4(2383300), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382902 */ /*GILLT_nxv1s16*//*Label 34088*/ GIMT_Encode4(2383483),
     /* 2382906 */ /*GILLT_nxv1s32*//*Label 34089*/ GIMT_Encode4(2383604),
     /* 2382910 */ /*GILLT_nxv1s64*//*Label 34090*/ GIMT_Encode4(2383725), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382922 */ /*GILLT_nxv2s16*//*Label 34091*/ GIMT_Encode4(2383846),
     /* 2382926 */ /*GILLT_nxv2s32*//*Label 34092*/ GIMT_Encode4(2383967),
     /* 2382930 */ /*GILLT_nxv2s64*//*Label 34093*/ GIMT_Encode4(2384088), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382942 */ /*GILLT_nxv4s16*//*Label 34094*/ GIMT_Encode4(2384209),
     /* 2382946 */ /*GILLT_nxv4s32*//*Label 34095*/ GIMT_Encode4(2384330),
     /* 2382950 */ /*GILLT_nxv4s64*//*Label 34096*/ GIMT_Encode4(2384451), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382962 */ /*GILLT_nxv8s16*//*Label 34097*/ GIMT_Encode4(2384572),
     /* 2382966 */ /*GILLT_nxv8s32*//*Label 34098*/ GIMT_Encode4(2384693),
     /* 2382970 */ /*GILLT_nxv8s64*//*Label 34099*/ GIMT_Encode4(2384814), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382982 */ /*GILLT_nxv16s16*//*Label 34100*/ GIMT_Encode4(2384935),
     /* 2382986 */ /*GILLT_nxv16s32*//*Label 34101*/ GIMT_Encode4(2385056), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2382998 */ /*GILLT_nxv32s16*//*Label 34102*/ GIMT_Encode4(2385177),
     /* 2383002 */ // Label 34085: @2383002
     /* 2383002 */ GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2383150),
     /* 2383007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2383010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2383013 */   GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2383047), // Rule ID 1956 //
     /* 2383018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2383021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383033 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2383033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2383036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383046 */     // GIR_Coverage, 1956,
     /* 2383046 */     GIR_EraseRootFromParent_Done,
     /* 2383047 */   // Label 34105: @2383047
     /* 2383047 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2383081), // Rule ID 1957 //
     /* 2383052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2383055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383067 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2383067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2383070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383080 */     // GIR_Coverage, 1957,
     /* 2383080 */     GIR_EraseRootFromParent_Done,
     /* 2383081 */   // Label 34106: @2383081
     /* 2383081 */   GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2383115), // Rule ID 1960 //
     /* 2383086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2383089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383101 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2383101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2383104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383114 */     // GIR_Coverage, 1960,
     /* 2383114 */     GIR_EraseRootFromParent_Done,
     /* 2383115 */   // Label 34107: @2383115
     /* 2383115 */   GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2383149), // Rule ID 1961 //
     /* 2383120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2383123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383135 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2383135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2383138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383148 */     // GIR_Coverage, 1961,
     /* 2383148 */     GIR_EraseRootFromParent_Done,
     /* 2383149 */   // Label 34108: @2383149
     /* 2383149 */   GIM_Reject,
     /* 2383150 */ // Label 34104: @2383150
     /* 2383150 */ GIM_Reject,
     /* 2383151 */ // Label 34086: @2383151
     /* 2383151 */ GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2383299),
     /* 2383156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2383159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2383162 */   GIM_Try, /*On fail goto*//*Label 34110*/ GIMT_Encode4(2383196), // Rule ID 1243 //
     /* 2383167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2383170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383182 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2383182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2383185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383195 */     // GIR_Coverage, 1243,
     /* 2383195 */     GIR_EraseRootFromParent_Done,
     /* 2383196 */   // Label 34110: @2383196
     /* 2383196 */   GIM_Try, /*On fail goto*//*Label 34111*/ GIMT_Encode4(2383230), // Rule ID 1244 //
     /* 2383201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2383204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383216 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2383216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2383219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383229 */     // GIR_Coverage, 1244,
     /* 2383229 */     GIR_EraseRootFromParent_Done,
     /* 2383230 */   // Label 34111: @2383230
     /* 2383230 */   GIM_Try, /*On fail goto*//*Label 34112*/ GIMT_Encode4(2383264), // Rule ID 1247 //
     /* 2383235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2383238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383250 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2383250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2383253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383263 */     // GIR_Coverage, 1247,
     /* 2383263 */     GIR_EraseRootFromParent_Done,
     /* 2383264 */   // Label 34112: @2383264
     /* 2383264 */   GIM_Try, /*On fail goto*//*Label 34113*/ GIMT_Encode4(2383298), // Rule ID 1248 //
     /* 2383269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2383272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383284 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2383284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2383287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383297 */     // GIR_Coverage, 1248,
     /* 2383297 */     GIR_EraseRootFromParent_Done,
     /* 2383298 */   // Label 34113: @2383298
     /* 2383298 */   GIM_Reject,
     /* 2383299 */ // Label 34109: @2383299
     /* 2383299 */ GIM_Reject,
     /* 2383300 */ // Label 34087: @2383300
     /* 2383300 */ GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2383482),
     /* 2383305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2383308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2383311 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2383345), // Rule ID 1580 //
     /* 2383316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2383319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383331 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2383331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2383334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383344 */     // GIR_Coverage, 1580,
     /* 2383344 */     GIR_EraseRootFromParent_Done,
     /* 2383345 */   // Label 34115: @2383345
     /* 2383345 */   GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2383379), // Rule ID 1581 //
     /* 2383350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2383353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383365 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2383365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2383368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383378 */     // GIR_Coverage, 1581,
     /* 2383378 */     GIR_EraseRootFromParent_Done,
     /* 2383379 */   // Label 34116: @2383379
     /* 2383379 */   GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2383413), // Rule ID 1584 //
     /* 2383384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2383387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383399 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2383399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2383402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383412 */     // GIR_Coverage, 1584,
     /* 2383412 */     GIR_EraseRootFromParent_Done,
     /* 2383413 */   // Label 34117: @2383413
     /* 2383413 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2383447), // Rule ID 1585 //
     /* 2383418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2383421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383433 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2383433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2383436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383446 */     // GIR_Coverage, 1585,
     /* 2383446 */     GIR_EraseRootFromParent_Done,
     /* 2383447 */   // Label 34118: @2383447
     /* 2383447 */   GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2383481), // Rule ID 1588 //
     /* 2383452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2383455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383467 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2383467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2383470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383480 */     // GIR_Coverage, 1588,
     /* 2383480 */     GIR_EraseRootFromParent_Done,
     /* 2383481 */   // Label 34119: @2383481
     /* 2383481 */   GIM_Reject,
     /* 2383482 */ // Label 34114: @2383482
     /* 2383482 */ GIM_Reject,
     /* 2383483 */ // Label 34088: @2383483
     /* 2383483 */ GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2383603),
     /* 2383488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2383491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2383494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383506 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2383554), // Rule ID 53446 //
     /* 2383511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2383514 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2383517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2383531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383553 */     // GIR_Coverage, 53446,
     /* 2383553 */     GIR_EraseRootFromParent_Done,
     /* 2383554 */   // Label 34121: @2383554
     /* 2383554 */   GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2383602), // Rule ID 53447 //
     /* 2383559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2383562 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2383565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2383579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383601 */     // GIR_Coverage, 53447,
     /* 2383601 */     GIR_EraseRootFromParent_Done,
     /* 2383602 */   // Label 34122: @2383602
     /* 2383602 */   GIM_Reject,
     /* 2383603 */ // Label 34120: @2383603
     /* 2383603 */ GIM_Reject,
     /* 2383604 */ // Label 34089: @2383604
     /* 2383604 */ GIM_Try, /*On fail goto*//*Label 34123*/ GIMT_Encode4(2383724),
     /* 2383609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2383612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2383615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383627 */   GIM_Try, /*On fail goto*//*Label 34124*/ GIMT_Encode4(2383675), // Rule ID 53470 //
     /* 2383632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2383635 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2383638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2383652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383674 */     // GIR_Coverage, 53470,
     /* 2383674 */     GIR_EraseRootFromParent_Done,
     /* 2383675 */   // Label 34124: @2383675
     /* 2383675 */   GIM_Try, /*On fail goto*//*Label 34125*/ GIMT_Encode4(2383723), // Rule ID 53471 //
     /* 2383680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2383683 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2383686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2383700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383722 */     // GIR_Coverage, 53471,
     /* 2383722 */     GIR_EraseRootFromParent_Done,
     /* 2383723 */   // Label 34125: @2383723
     /* 2383723 */   GIM_Reject,
     /* 2383724 */ // Label 34123: @2383724
     /* 2383724 */ GIM_Reject,
     /* 2383725 */ // Label 34090: @2383725
     /* 2383725 */ GIM_Try, /*On fail goto*//*Label 34126*/ GIMT_Encode4(2383845),
     /* 2383730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2383733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2383736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383748 */   GIM_Try, /*On fail goto*//*Label 34127*/ GIMT_Encode4(2383796), // Rule ID 53506 //
     /* 2383753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2383756 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2383759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2383773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383795 */     // GIR_Coverage, 53506,
     /* 2383795 */     GIR_EraseRootFromParent_Done,
     /* 2383796 */   // Label 34127: @2383796
     /* 2383796 */   GIM_Try, /*On fail goto*//*Label 34128*/ GIMT_Encode4(2383844), // Rule ID 53507 //
     /* 2383801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2383804 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2383807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2383821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383843 */     // GIR_Coverage, 53507,
     /* 2383843 */     GIR_EraseRootFromParent_Done,
     /* 2383844 */   // Label 34128: @2383844
     /* 2383844 */   GIM_Reject,
     /* 2383845 */ // Label 34126: @2383845
     /* 2383845 */ GIM_Reject,
     /* 2383846 */ // Label 34091: @2383846
     /* 2383846 */ GIM_Try, /*On fail goto*//*Label 34129*/ GIMT_Encode4(2383966),
     /* 2383851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2383854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2383857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383869 */   GIM_Try, /*On fail goto*//*Label 34130*/ GIMT_Encode4(2383917), // Rule ID 53458 //
     /* 2383874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2383877 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2383880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2383894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383916 */     // GIR_Coverage, 53458,
     /* 2383916 */     GIR_EraseRootFromParent_Done,
     /* 2383917 */   // Label 34130: @2383917
     /* 2383917 */   GIM_Try, /*On fail goto*//*Label 34131*/ GIMT_Encode4(2383965), // Rule ID 53459 //
     /* 2383922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2383925 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2383928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2383942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383964 */     // GIR_Coverage, 53459,
     /* 2383964 */     GIR_EraseRootFromParent_Done,
     /* 2383965 */   // Label 34131: @2383965
     /* 2383965 */   GIM_Reject,
     /* 2383966 */ // Label 34129: @2383966
     /* 2383966 */ GIM_Reject,
     /* 2383967 */ // Label 34092: @2383967
     /* 2383967 */ GIM_Try, /*On fail goto*//*Label 34132*/ GIMT_Encode4(2384087),
     /* 2383972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2383975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2383978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383990 */   GIM_Try, /*On fail goto*//*Label 34133*/ GIMT_Encode4(2384038), // Rule ID 53494 //
     /* 2383995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2383998 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2384015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384037 */     // GIR_Coverage, 53494,
     /* 2384037 */     GIR_EraseRootFromParent_Done,
     /* 2384038 */   // Label 34133: @2384038
     /* 2384038 */   GIM_Try, /*On fail goto*//*Label 34134*/ GIMT_Encode4(2384086), // Rule ID 53495 //
     /* 2384043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384046 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2384063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384085 */     // GIR_Coverage, 53495,
     /* 2384085 */     GIR_EraseRootFromParent_Done,
     /* 2384086 */   // Label 34134: @2384086
     /* 2384086 */   GIM_Reject,
     /* 2384087 */ // Label 34132: @2384087
     /* 2384087 */ GIM_Reject,
     /* 2384088 */ // Label 34093: @2384088
     /* 2384088 */ GIM_Try, /*On fail goto*//*Label 34135*/ GIMT_Encode4(2384208),
     /* 2384093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2384096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2384099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384111 */   GIM_Try, /*On fail goto*//*Label 34136*/ GIMT_Encode4(2384159), // Rule ID 53590 //
     /* 2384116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2384119 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2384136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384158 */     // GIR_Coverage, 53590,
     /* 2384158 */     GIR_EraseRootFromParent_Done,
     /* 2384159 */   // Label 34136: @2384159
     /* 2384159 */   GIM_Try, /*On fail goto*//*Label 34137*/ GIMT_Encode4(2384207), // Rule ID 53591 //
     /* 2384164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2384167 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2384184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384206 */     // GIR_Coverage, 53591,
     /* 2384206 */     GIR_EraseRootFromParent_Done,
     /* 2384207 */   // Label 34137: @2384207
     /* 2384207 */   GIM_Reject,
     /* 2384208 */ // Label 34135: @2384208
     /* 2384208 */ GIM_Reject,
     /* 2384209 */ // Label 34094: @2384209
     /* 2384209 */ GIM_Try, /*On fail goto*//*Label 34138*/ GIMT_Encode4(2384329),
     /* 2384214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2384217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2384220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384232 */   GIM_Try, /*On fail goto*//*Label 34139*/ GIMT_Encode4(2384280), // Rule ID 53482 //
     /* 2384237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384240 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2384257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384279 */     // GIR_Coverage, 53482,
     /* 2384279 */     GIR_EraseRootFromParent_Done,
     /* 2384280 */   // Label 34139: @2384280
     /* 2384280 */   GIM_Try, /*On fail goto*//*Label 34140*/ GIMT_Encode4(2384328), // Rule ID 53483 //
     /* 2384285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2384288 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2384305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384327 */     // GIR_Coverage, 53483,
     /* 2384327 */     GIR_EraseRootFromParent_Done,
     /* 2384328 */   // Label 34140: @2384328
     /* 2384328 */   GIM_Reject,
     /* 2384329 */ // Label 34138: @2384329
     /* 2384329 */ GIM_Reject,
     /* 2384330 */ // Label 34095: @2384330
     /* 2384330 */ GIM_Try, /*On fail goto*//*Label 34141*/ GIMT_Encode4(2384450),
     /* 2384335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2384338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2384341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384353 */   GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2384401), // Rule ID 53554 //
     /* 2384358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2384361 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2384378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384400 */     // GIR_Coverage, 53554,
     /* 2384400 */     GIR_EraseRootFromParent_Done,
     /* 2384401 */   // Label 34142: @2384401
     /* 2384401 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2384449), // Rule ID 53555 //
     /* 2384406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384409 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2384426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384448 */     // GIR_Coverage, 53555,
     /* 2384448 */     GIR_EraseRootFromParent_Done,
     /* 2384449 */   // Label 34143: @2384449
     /* 2384449 */   GIM_Reject,
     /* 2384450 */ // Label 34141: @2384450
     /* 2384450 */ GIM_Reject,
     /* 2384451 */ // Label 34096: @2384451
     /* 2384451 */ GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2384571),
     /* 2384456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2384459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2384462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384474 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2384522), // Rule ID 53602 //
     /* 2384479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2384482 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2384485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2384499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384521 */     // GIR_Coverage, 53602,
     /* 2384521 */     GIR_EraseRootFromParent_Done,
     /* 2384522 */   // Label 34145: @2384522
     /* 2384522 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2384570), // Rule ID 53603 //
     /* 2384527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2384530 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2384533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2384547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384569 */     // GIR_Coverage, 53603,
     /* 2384569 */     GIR_EraseRootFromParent_Done,
     /* 2384570 */   // Label 34146: @2384570
     /* 2384570 */   GIM_Reject,
     /* 2384571 */ // Label 34144: @2384571
     /* 2384571 */ GIM_Reject,
     /* 2384572 */ // Label 34097: @2384572
     /* 2384572 */ GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2384692),
     /* 2384577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2384580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2384583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384595 */   GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2384643), // Rule ID 53518 //
     /* 2384600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384603 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2384606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2384620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384642 */     // GIR_Coverage, 53518,
     /* 2384642 */     GIR_EraseRootFromParent_Done,
     /* 2384643 */   // Label 34148: @2384643
     /* 2384643 */   GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2384691), // Rule ID 53519 //
     /* 2384648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2384651 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2384654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2384668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384690 */     // GIR_Coverage, 53519,
     /* 2384690 */     GIR_EraseRootFromParent_Done,
     /* 2384691 */   // Label 34149: @2384691
     /* 2384691 */   GIM_Reject,
     /* 2384692 */ // Label 34147: @2384692
     /* 2384692 */ GIM_Reject,
     /* 2384693 */ // Label 34098: @2384693
     /* 2384693 */ GIM_Try, /*On fail goto*//*Label 34150*/ GIMT_Encode4(2384813),
     /* 2384698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2384701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2384704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384716 */   GIM_Try, /*On fail goto*//*Label 34151*/ GIMT_Encode4(2384764), // Rule ID 53566 //
     /* 2384721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2384724 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2384727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2384741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384763 */     // GIR_Coverage, 53566,
     /* 2384763 */     GIR_EraseRootFromParent_Done,
     /* 2384764 */   // Label 34151: @2384764
     /* 2384764 */   GIM_Try, /*On fail goto*//*Label 34152*/ GIMT_Encode4(2384812), // Rule ID 53567 //
     /* 2384769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384772 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2384775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2384789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384811 */     // GIR_Coverage, 53567,
     /* 2384811 */     GIR_EraseRootFromParent_Done,
     /* 2384812 */   // Label 34152: @2384812
     /* 2384812 */   GIM_Reject,
     /* 2384813 */ // Label 34150: @2384813
     /* 2384813 */ GIM_Reject,
     /* 2384814 */ // Label 34099: @2384814
     /* 2384814 */ GIM_Try, /*On fail goto*//*Label 34153*/ GIMT_Encode4(2384934),
     /* 2384819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2384822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2384825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2384837 */   GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2384885), // Rule ID 53614 //
     /* 2384842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2384845 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2384848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2384862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384884 */     // GIR_Coverage, 53614,
     /* 2384884 */     GIR_EraseRootFromParent_Done,
     /* 2384885 */   // Label 34154: @2384885
     /* 2384885 */   GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2384933), // Rule ID 53615 //
     /* 2384890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2384893 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2384896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2384910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384932 */     // GIR_Coverage, 53615,
     /* 2384932 */     GIR_EraseRootFromParent_Done,
     /* 2384933 */   // Label 34155: @2384933
     /* 2384933 */   GIM_Reject,
     /* 2384934 */ // Label 34153: @2384934
     /* 2384934 */ GIM_Reject,
     /* 2384935 */ // Label 34100: @2384935
     /* 2384935 */ GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2385055),
     /* 2384940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2384943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2384946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2384958 */   GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2385006), // Rule ID 53530 //
     /* 2384963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384966 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2384969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2384983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385005 */     // GIR_Coverage, 53530,
     /* 2385005 */     GIR_EraseRootFromParent_Done,
     /* 2385006 */   // Label 34157: @2385006
     /* 2385006 */   GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2385054), // Rule ID 53531 //
     /* 2385011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385014 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2385031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385053 */     // GIR_Coverage, 53531,
     /* 2385053 */     GIR_EraseRootFromParent_Done,
     /* 2385054 */   // Label 34158: @2385054
     /* 2385054 */   GIM_Reject,
     /* 2385055 */ // Label 34156: @2385055
     /* 2385055 */ GIM_Reject,
     /* 2385056 */ // Label 34101: @2385056
     /* 2385056 */ GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2385176),
     /* 2385061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2385064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2385067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385079 */   GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2385127), // Rule ID 53578 //
     /* 2385084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2385087 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2385104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385126 */     // GIR_Coverage, 53578,
     /* 2385126 */     GIR_EraseRootFromParent_Done,
     /* 2385127 */   // Label 34160: @2385127
     /* 2385127 */   GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2385175), // Rule ID 53579 //
     /* 2385132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2385135 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2385152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385174 */     // GIR_Coverage, 53579,
     /* 2385174 */     GIR_EraseRootFromParent_Done,
     /* 2385175 */   // Label 34161: @2385175
     /* 2385175 */   GIM_Reject,
     /* 2385176 */ // Label 34159: @2385176
     /* 2385176 */ GIM_Reject,
     /* 2385177 */ // Label 34102: @2385177
     /* 2385177 */ GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2385297),
     /* 2385182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2385185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2385188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385200 */   GIM_Try, /*On fail goto*//*Label 34163*/ GIMT_Encode4(2385248), // Rule ID 53542 //
     /* 2385205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2385208 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2385225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385247 */     // GIR_Coverage, 53542,
     /* 2385247 */     GIR_EraseRootFromParent_Done,
     /* 2385248 */   // Label 34163: @2385248
     /* 2385248 */   GIM_Try, /*On fail goto*//*Label 34164*/ GIMT_Encode4(2385296), // Rule ID 53543 //
     /* 2385253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385256 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2385273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385295 */     // GIR_Coverage, 53543,
     /* 2385295 */     GIR_EraseRootFromParent_Done,
     /* 2385296 */   // Label 34164: @2385296
     /* 2385296 */   GIM_Reject,
     /* 2385297 */ // Label 34162: @2385297
     /* 2385297 */ GIM_Reject,
     /* 2385298 */ // Label 34103: @2385298
     /* 2385298 */ GIM_Reject,
     /* 2385299 */ // Label 100: @2385299
     /* 2385299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34183*/ GIMT_Encode4(2387726),
     /* 2385310 */ /*GILLT_s16*//*Label 34165*/ GIMT_Encode4(2385430),
     /* 2385314 */ /*GILLT_s32*//*Label 34166*/ GIMT_Encode4(2385579),
     /* 2385318 */ /*GILLT_s64*//*Label 34167*/ GIMT_Encode4(2385728), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385330 */ /*GILLT_nxv1s16*//*Label 34168*/ GIMT_Encode4(2385911),
     /* 2385334 */ /*GILLT_nxv1s32*//*Label 34169*/ GIMT_Encode4(2386032),
     /* 2385338 */ /*GILLT_nxv1s64*//*Label 34170*/ GIMT_Encode4(2386153), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385350 */ /*GILLT_nxv2s16*//*Label 34171*/ GIMT_Encode4(2386274),
     /* 2385354 */ /*GILLT_nxv2s32*//*Label 34172*/ GIMT_Encode4(2386395),
     /* 2385358 */ /*GILLT_nxv2s64*//*Label 34173*/ GIMT_Encode4(2386516), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385370 */ /*GILLT_nxv4s16*//*Label 34174*/ GIMT_Encode4(2386637),
     /* 2385374 */ /*GILLT_nxv4s32*//*Label 34175*/ GIMT_Encode4(2386758),
     /* 2385378 */ /*GILLT_nxv4s64*//*Label 34176*/ GIMT_Encode4(2386879), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385390 */ /*GILLT_nxv8s16*//*Label 34177*/ GIMT_Encode4(2387000),
     /* 2385394 */ /*GILLT_nxv8s32*//*Label 34178*/ GIMT_Encode4(2387121),
     /* 2385398 */ /*GILLT_nxv8s64*//*Label 34179*/ GIMT_Encode4(2387242), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385410 */ /*GILLT_nxv16s16*//*Label 34180*/ GIMT_Encode4(2387363),
     /* 2385414 */ /*GILLT_nxv16s32*//*Label 34181*/ GIMT_Encode4(2387484), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385426 */ /*GILLT_nxv32s16*//*Label 34182*/ GIMT_Encode4(2387605),
     /* 2385430 */ // Label 34165: @2385430
     /* 2385430 */ GIM_Try, /*On fail goto*//*Label 34184*/ GIMT_Encode4(2385578),
     /* 2385435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2385438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2385441 */   GIM_Try, /*On fail goto*//*Label 34185*/ GIMT_Encode4(2385475), // Rule ID 1964 //
     /* 2385446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2385449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385461 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2385461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2385464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385474 */     // GIR_Coverage, 1964,
     /* 2385474 */     GIR_EraseRootFromParent_Done,
     /* 2385475 */   // Label 34185: @2385475
     /* 2385475 */   GIM_Try, /*On fail goto*//*Label 34186*/ GIMT_Encode4(2385509), // Rule ID 1965 //
     /* 2385480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2385483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385495 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2385495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2385498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385508 */     // GIR_Coverage, 1965,
     /* 2385508 */     GIR_EraseRootFromParent_Done,
     /* 2385509 */   // Label 34186: @2385509
     /* 2385509 */   GIM_Try, /*On fail goto*//*Label 34187*/ GIMT_Encode4(2385543), // Rule ID 1968 //
     /* 2385514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2385517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385529 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2385529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2385532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385542 */     // GIR_Coverage, 1968,
     /* 2385542 */     GIR_EraseRootFromParent_Done,
     /* 2385543 */   // Label 34187: @2385543
     /* 2385543 */   GIM_Try, /*On fail goto*//*Label 34188*/ GIMT_Encode4(2385577), // Rule ID 1969 //
     /* 2385548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2385551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2385563 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2385563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2385566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385576 */     // GIR_Coverage, 1969,
     /* 2385576 */     GIR_EraseRootFromParent_Done,
     /* 2385577 */   // Label 34188: @2385577
     /* 2385577 */   GIM_Reject,
     /* 2385578 */ // Label 34184: @2385578
     /* 2385578 */ GIM_Reject,
     /* 2385579 */ // Label 34166: @2385579
     /* 2385579 */ GIM_Try, /*On fail goto*//*Label 34189*/ GIMT_Encode4(2385727),
     /* 2385584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2385587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2385590 */   GIM_Try, /*On fail goto*//*Label 34190*/ GIMT_Encode4(2385624), // Rule ID 1251 //
     /* 2385595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2385598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385610 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2385610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2385613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385623 */     // GIR_Coverage, 1251,
     /* 2385623 */     GIR_EraseRootFromParent_Done,
     /* 2385624 */   // Label 34190: @2385624
     /* 2385624 */   GIM_Try, /*On fail goto*//*Label 34191*/ GIMT_Encode4(2385658), // Rule ID 1252 //
     /* 2385629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2385632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2385644 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2385644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2385647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385657 */     // GIR_Coverage, 1252,
     /* 2385657 */     GIR_EraseRootFromParent_Done,
     /* 2385658 */   // Label 34191: @2385658
     /* 2385658 */   GIM_Try, /*On fail goto*//*Label 34192*/ GIMT_Encode4(2385692), // Rule ID 1255 //
     /* 2385663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2385666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385678 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2385678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2385681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385691 */     // GIR_Coverage, 1255,
     /* 2385691 */     GIR_EraseRootFromParent_Done,
     /* 2385692 */   // Label 34192: @2385692
     /* 2385692 */   GIM_Try, /*On fail goto*//*Label 34193*/ GIMT_Encode4(2385726), // Rule ID 1256 //
     /* 2385697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2385700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2385712 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2385712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2385715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385725 */     // GIR_Coverage, 1256,
     /* 2385725 */     GIR_EraseRootFromParent_Done,
     /* 2385726 */   // Label 34193: @2385726
     /* 2385726 */   GIM_Reject,
     /* 2385727 */ // Label 34189: @2385727
     /* 2385727 */ GIM_Reject,
     /* 2385728 */ // Label 34167: @2385728
     /* 2385728 */ GIM_Try, /*On fail goto*//*Label 34194*/ GIMT_Encode4(2385910),
     /* 2385733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2385736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2385739 */   GIM_Try, /*On fail goto*//*Label 34195*/ GIMT_Encode4(2385773), // Rule ID 1590 //
     /* 2385744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2385747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385759 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2385759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2385762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385772 */     // GIR_Coverage, 1590,
     /* 2385772 */     GIR_EraseRootFromParent_Done,
     /* 2385773 */   // Label 34195: @2385773
     /* 2385773 */   GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2385807), // Rule ID 1591 //
     /* 2385778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2385781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2385793 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2385793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2385796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385806 */     // GIR_Coverage, 1591,
     /* 2385806 */     GIR_EraseRootFromParent_Done,
     /* 2385807 */   // Label 34196: @2385807
     /* 2385807 */   GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2385841), // Rule ID 1594 //
     /* 2385812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2385815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385827 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2385827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2385830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385840 */     // GIR_Coverage, 1594,
     /* 2385840 */     GIR_EraseRootFromParent_Done,
     /* 2385841 */   // Label 34197: @2385841
     /* 2385841 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2385875), // Rule ID 1595 //
     /* 2385846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2385849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2385861 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2385861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2385864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385874 */     // GIR_Coverage, 1595,
     /* 2385874 */     GIR_EraseRootFromParent_Done,
     /* 2385875 */   // Label 34198: @2385875
     /* 2385875 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2385909), // Rule ID 1598 //
     /* 2385880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2385883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2385887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2385891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2385895 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2385895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2385898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385908 */     // GIR_Coverage, 1598,
     /* 2385908 */     GIR_EraseRootFromParent_Done,
     /* 2385909 */   // Label 34199: @2385909
     /* 2385909 */   GIM_Reject,
     /* 2385910 */ // Label 34194: @2385910
     /* 2385910 */ GIM_Reject,
     /* 2385911 */ // Label 34168: @2385911
     /* 2385911 */ GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2386031),
     /* 2385916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2385919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2385922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385934 */   GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2385982), // Rule ID 54214 //
     /* 2385939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2385942 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2385959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385981 */     // GIR_Coverage, 54214,
     /* 2385981 */     GIR_EraseRootFromParent_Done,
     /* 2385982 */   // Label 34201: @2385982
     /* 2385982 */   GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2386030), // Rule ID 54215 //
     /* 2385987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385990 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2385993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2386007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386029 */     // GIR_Coverage, 54215,
     /* 2386029 */     GIR_EraseRootFromParent_Done,
     /* 2386030 */   // Label 34202: @2386030
     /* 2386030 */   GIM_Reject,
     /* 2386031 */ // Label 34200: @2386031
     /* 2386031 */ GIM_Reject,
     /* 2386032 */ // Label 34169: @2386032
     /* 2386032 */ GIM_Try, /*On fail goto*//*Label 34203*/ GIMT_Encode4(2386152),
     /* 2386037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2386040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2386043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386055 */   GIM_Try, /*On fail goto*//*Label 34204*/ GIMT_Encode4(2386103), // Rule ID 54238 //
     /* 2386060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2386063 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2386080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386102 */     // GIR_Coverage, 54238,
     /* 2386102 */     GIR_EraseRootFromParent_Done,
     /* 2386103 */   // Label 34204: @2386103
     /* 2386103 */   GIM_Try, /*On fail goto*//*Label 34205*/ GIMT_Encode4(2386151), // Rule ID 54239 //
     /* 2386108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2386111 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2386128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386150 */     // GIR_Coverage, 54239,
     /* 2386150 */     GIR_EraseRootFromParent_Done,
     /* 2386151 */   // Label 34205: @2386151
     /* 2386151 */   GIM_Reject,
     /* 2386152 */ // Label 34203: @2386152
     /* 2386152 */ GIM_Reject,
     /* 2386153 */ // Label 34170: @2386153
     /* 2386153 */ GIM_Try, /*On fail goto*//*Label 34206*/ GIMT_Encode4(2386273),
     /* 2386158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2386161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2386164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386176 */   GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2386224), // Rule ID 54274 //
     /* 2386181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2386184 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2386201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386223 */     // GIR_Coverage, 54274,
     /* 2386223 */     GIR_EraseRootFromParent_Done,
     /* 2386224 */   // Label 34207: @2386224
     /* 2386224 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2386272), // Rule ID 54275 //
     /* 2386229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2386232 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2386249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386271 */     // GIR_Coverage, 54275,
     /* 2386271 */     GIR_EraseRootFromParent_Done,
     /* 2386272 */   // Label 34208: @2386272
     /* 2386272 */   GIM_Reject,
     /* 2386273 */ // Label 34206: @2386273
     /* 2386273 */ GIM_Reject,
     /* 2386274 */ // Label 34171: @2386274
     /* 2386274 */ GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2386394),
     /* 2386279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2386282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2386285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386297 */   GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2386345), // Rule ID 54226 //
     /* 2386302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2386305 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2386308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2386322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386344 */     // GIR_Coverage, 54226,
     /* 2386344 */     GIR_EraseRootFromParent_Done,
     /* 2386345 */   // Label 34210: @2386345
     /* 2386345 */   GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2386393), // Rule ID 54227 //
     /* 2386350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2386353 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2386356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2386370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386392 */     // GIR_Coverage, 54227,
     /* 2386392 */     GIR_EraseRootFromParent_Done,
     /* 2386393 */   // Label 34211: @2386393
     /* 2386393 */   GIM_Reject,
     /* 2386394 */ // Label 34209: @2386394
     /* 2386394 */ GIM_Reject,
     /* 2386395 */ // Label 34172: @2386395
     /* 2386395 */ GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2386515),
     /* 2386400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2386403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2386406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386418 */   GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2386466), // Rule ID 54262 //
     /* 2386423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2386426 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2386429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2386443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386465 */     // GIR_Coverage, 54262,
     /* 2386465 */     GIR_EraseRootFromParent_Done,
     /* 2386466 */   // Label 34213: @2386466
     /* 2386466 */   GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2386514), // Rule ID 54263 //
     /* 2386471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2386474 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2386477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2386491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386513 */     // GIR_Coverage, 54263,
     /* 2386513 */     GIR_EraseRootFromParent_Done,
     /* 2386514 */   // Label 34214: @2386514
     /* 2386514 */   GIM_Reject,
     /* 2386515 */ // Label 34212: @2386515
     /* 2386515 */ GIM_Reject,
     /* 2386516 */ // Label 34173: @2386516
     /* 2386516 */ GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2386636),
     /* 2386521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2386524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2386527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386539 */   GIM_Try, /*On fail goto*//*Label 34216*/ GIMT_Encode4(2386587), // Rule ID 54358 //
     /* 2386544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2386547 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2386550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2386564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386586 */     // GIR_Coverage, 54358,
     /* 2386586 */     GIR_EraseRootFromParent_Done,
     /* 2386587 */   // Label 34216: @2386587
     /* 2386587 */   GIM_Try, /*On fail goto*//*Label 34217*/ GIMT_Encode4(2386635), // Rule ID 54359 //
     /* 2386592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2386595 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2386598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2386612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386634 */     // GIR_Coverage, 54359,
     /* 2386634 */     GIR_EraseRootFromParent_Done,
     /* 2386635 */   // Label 34217: @2386635
     /* 2386635 */   GIM_Reject,
     /* 2386636 */ // Label 34215: @2386636
     /* 2386636 */ GIM_Reject,
     /* 2386637 */ // Label 34174: @2386637
     /* 2386637 */ GIM_Try, /*On fail goto*//*Label 34218*/ GIMT_Encode4(2386757),
     /* 2386642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2386645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2386648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386660 */   GIM_Try, /*On fail goto*//*Label 34219*/ GIMT_Encode4(2386708), // Rule ID 54250 //
     /* 2386665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2386668 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2386671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2386685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386707 */     // GIR_Coverage, 54250,
     /* 2386707 */     GIR_EraseRootFromParent_Done,
     /* 2386708 */   // Label 34219: @2386708
     /* 2386708 */   GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2386756), // Rule ID 54251 //
     /* 2386713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2386716 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2386719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2386733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386755 */     // GIR_Coverage, 54251,
     /* 2386755 */     GIR_EraseRootFromParent_Done,
     /* 2386756 */   // Label 34220: @2386756
     /* 2386756 */   GIM_Reject,
     /* 2386757 */ // Label 34218: @2386757
     /* 2386757 */ GIM_Reject,
     /* 2386758 */ // Label 34175: @2386758
     /* 2386758 */ GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2386878),
     /* 2386763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2386766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2386769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2386781 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2386829), // Rule ID 54322 //
     /* 2386786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2386789 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2386806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386828 */     // GIR_Coverage, 54322,
     /* 2386828 */     GIR_EraseRootFromParent_Done,
     /* 2386829 */   // Label 34222: @2386829
     /* 2386829 */   GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2386877), // Rule ID 54323 //
     /* 2386834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2386837 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2386840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2386854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386876 */     // GIR_Coverage, 54323,
     /* 2386876 */     GIR_EraseRootFromParent_Done,
     /* 2386877 */   // Label 34223: @2386877
     /* 2386877 */   GIM_Reject,
     /* 2386878 */ // Label 34221: @2386878
     /* 2386878 */ GIM_Reject,
     /* 2386879 */ // Label 34176: @2386879
     /* 2386879 */ GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2386999),
     /* 2386884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2386887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2386890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2386902 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2386950), // Rule ID 54370 //
     /* 2386907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2386910 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2386927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386949 */     // GIR_Coverage, 54370,
     /* 2386949 */     GIR_EraseRootFromParent_Done,
     /* 2386950 */   // Label 34225: @2386950
     /* 2386950 */   GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2386998), // Rule ID 54371 //
     /* 2386955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2386958 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2386961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2386975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386997 */     // GIR_Coverage, 54371,
     /* 2386997 */     GIR_EraseRootFromParent_Done,
     /* 2386998 */   // Label 34226: @2386998
     /* 2386998 */   GIM_Reject,
     /* 2386999 */ // Label 34224: @2386999
     /* 2386999 */ GIM_Reject,
     /* 2387000 */ // Label 34177: @2387000
     /* 2387000 */ GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2387120),
     /* 2387005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2387008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2387011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387023 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2387071), // Rule ID 54286 //
     /* 2387028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2387031 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2387048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387070 */     // GIR_Coverage, 54286,
     /* 2387070 */     GIR_EraseRootFromParent_Done,
     /* 2387071 */   // Label 34228: @2387071
     /* 2387071 */   GIM_Try, /*On fail goto*//*Label 34229*/ GIMT_Encode4(2387119), // Rule ID 54287 //
     /* 2387076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2387079 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2387096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387118 */     // GIR_Coverage, 54287,
     /* 2387118 */     GIR_EraseRootFromParent_Done,
     /* 2387119 */   // Label 34229: @2387119
     /* 2387119 */   GIM_Reject,
     /* 2387120 */ // Label 34227: @2387120
     /* 2387120 */ GIM_Reject,
     /* 2387121 */ // Label 34178: @2387121
     /* 2387121 */ GIM_Try, /*On fail goto*//*Label 34230*/ GIMT_Encode4(2387241),
     /* 2387126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2387129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2387132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387144 */   GIM_Try, /*On fail goto*//*Label 34231*/ GIMT_Encode4(2387192), // Rule ID 54334 //
     /* 2387149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2387152 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2387169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387191 */     // GIR_Coverage, 54334,
     /* 2387191 */     GIR_EraseRootFromParent_Done,
     /* 2387192 */   // Label 34231: @2387192
     /* 2387192 */   GIM_Try, /*On fail goto*//*Label 34232*/ GIMT_Encode4(2387240), // Rule ID 54335 //
     /* 2387197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2387200 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2387217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387239 */     // GIR_Coverage, 54335,
     /* 2387239 */     GIR_EraseRootFromParent_Done,
     /* 2387240 */   // Label 34232: @2387240
     /* 2387240 */   GIM_Reject,
     /* 2387241 */ // Label 34230: @2387241
     /* 2387241 */ GIM_Reject,
     /* 2387242 */ // Label 34179: @2387242
     /* 2387242 */ GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2387362),
     /* 2387247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2387250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2387253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387265 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2387313), // Rule ID 54382 //
     /* 2387270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2387273 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2387276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2387290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387312 */     // GIR_Coverage, 54382,
     /* 2387312 */     GIR_EraseRootFromParent_Done,
     /* 2387313 */   // Label 34234: @2387313
     /* 2387313 */   GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2387361), // Rule ID 54383 //
     /* 2387318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2387321 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2387324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2387338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387360 */     // GIR_Coverage, 54383,
     /* 2387360 */     GIR_EraseRootFromParent_Done,
     /* 2387361 */   // Label 34235: @2387361
     /* 2387361 */   GIM_Reject,
     /* 2387362 */ // Label 34233: @2387362
     /* 2387362 */ GIM_Reject,
     /* 2387363 */ // Label 34180: @2387363
     /* 2387363 */ GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2387483),
     /* 2387368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2387371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2387374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387386 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2387434), // Rule ID 54298 //
     /* 2387391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2387394 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2387397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2387411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387433 */     // GIR_Coverage, 54298,
     /* 2387433 */     GIR_EraseRootFromParent_Done,
     /* 2387434 */   // Label 34237: @2387434
     /* 2387434 */   GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2387482), // Rule ID 54299 //
     /* 2387439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2387442 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2387445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2387459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387481 */     // GIR_Coverage, 54299,
     /* 2387481 */     GIR_EraseRootFromParent_Done,
     /* 2387482 */   // Label 34238: @2387482
     /* 2387482 */   GIM_Reject,
     /* 2387483 */ // Label 34236: @2387483
     /* 2387483 */ GIM_Reject,
     /* 2387484 */ // Label 34181: @2387484
     /* 2387484 */ GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2387604),
     /* 2387489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2387492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2387495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387507 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2387555), // Rule ID 54346 //
     /* 2387512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2387515 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2387518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2387532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387554 */     // GIR_Coverage, 54346,
     /* 2387554 */     GIR_EraseRootFromParent_Done,
     /* 2387555 */   // Label 34240: @2387555
     /* 2387555 */   GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2387603), // Rule ID 54347 //
     /* 2387560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2387563 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2387566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2387580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387602 */     // GIR_Coverage, 54347,
     /* 2387602 */     GIR_EraseRootFromParent_Done,
     /* 2387603 */   // Label 34241: @2387603
     /* 2387603 */   GIM_Reject,
     /* 2387604 */ // Label 34239: @2387604
     /* 2387604 */ GIM_Reject,
     /* 2387605 */ // Label 34182: @2387605
     /* 2387605 */ GIM_Try, /*On fail goto*//*Label 34242*/ GIMT_Encode4(2387725),
     /* 2387610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2387613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2387616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2387628 */   GIM_Try, /*On fail goto*//*Label 34243*/ GIMT_Encode4(2387676), // Rule ID 54310 //
     /* 2387633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2387636 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2387653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387675 */     // GIR_Coverage, 54310,
     /* 2387675 */     GIR_EraseRootFromParent_Done,
     /* 2387676 */   // Label 34243: @2387676
     /* 2387676 */   GIM_Try, /*On fail goto*//*Label 34244*/ GIMT_Encode4(2387724), // Rule ID 54311 //
     /* 2387681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2387684 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2387687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2387701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387723 */     // GIR_Coverage, 54311,
     /* 2387723 */     GIR_EraseRootFromParent_Done,
     /* 2387724 */   // Label 34244: @2387724
     /* 2387724 */   GIM_Reject,
     /* 2387725 */ // Label 34242: @2387725
     /* 2387725 */ GIM_Reject,
     /* 2387726 */ // Label 34183: @2387726
     /* 2387726 */ GIM_Reject,
     /* 2387727 */ // Label 101: @2387727
     /* 2387727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34263*/ GIMT_Encode4(2390154),
     /* 2387738 */ /*GILLT_s16*//*Label 34245*/ GIMT_Encode4(2387858),
     /* 2387742 */ /*GILLT_s32*//*Label 34246*/ GIMT_Encode4(2388007),
     /* 2387746 */ /*GILLT_s64*//*Label 34247*/ GIMT_Encode4(2388156), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387758 */ /*GILLT_nxv1s16*//*Label 34248*/ GIMT_Encode4(2388339),
     /* 2387762 */ /*GILLT_nxv1s32*//*Label 34249*/ GIMT_Encode4(2388460),
     /* 2387766 */ /*GILLT_nxv1s64*//*Label 34250*/ GIMT_Encode4(2388581), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387778 */ /*GILLT_nxv2s16*//*Label 34251*/ GIMT_Encode4(2388702),
     /* 2387782 */ /*GILLT_nxv2s32*//*Label 34252*/ GIMT_Encode4(2388823),
     /* 2387786 */ /*GILLT_nxv2s64*//*Label 34253*/ GIMT_Encode4(2388944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387798 */ /*GILLT_nxv4s16*//*Label 34254*/ GIMT_Encode4(2389065),
     /* 2387802 */ /*GILLT_nxv4s32*//*Label 34255*/ GIMT_Encode4(2389186),
     /* 2387806 */ /*GILLT_nxv4s64*//*Label 34256*/ GIMT_Encode4(2389307), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387818 */ /*GILLT_nxv8s16*//*Label 34257*/ GIMT_Encode4(2389428),
     /* 2387822 */ /*GILLT_nxv8s32*//*Label 34258*/ GIMT_Encode4(2389549),
     /* 2387826 */ /*GILLT_nxv8s64*//*Label 34259*/ GIMT_Encode4(2389670), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387838 */ /*GILLT_nxv16s16*//*Label 34260*/ GIMT_Encode4(2389791),
     /* 2387842 */ /*GILLT_nxv16s32*//*Label 34261*/ GIMT_Encode4(2389912), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2387854 */ /*GILLT_nxv32s16*//*Label 34262*/ GIMT_Encode4(2390033),
     /* 2387858 */ // Label 34245: @2387858
     /* 2387858 */ GIM_Try, /*On fail goto*//*Label 34264*/ GIMT_Encode4(2388006),
     /* 2387863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2387866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2387869 */   GIM_Try, /*On fail goto*//*Label 34265*/ GIMT_Encode4(2387903), // Rule ID 1972 //
     /* 2387874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2387877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387889 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2387889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2387892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387902 */     // GIR_Coverage, 1972,
     /* 2387902 */     GIR_EraseRootFromParent_Done,
     /* 2387903 */   // Label 34265: @2387903
     /* 2387903 */   GIM_Try, /*On fail goto*//*Label 34266*/ GIMT_Encode4(2387937), // Rule ID 1973 //
     /* 2387908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2387911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387923 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2387923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2387926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387936 */     // GIR_Coverage, 1973,
     /* 2387936 */     GIR_EraseRootFromParent_Done,
     /* 2387937 */   // Label 34266: @2387937
     /* 2387937 */   GIM_Try, /*On fail goto*//*Label 34267*/ GIMT_Encode4(2387971), // Rule ID 1976 //
     /* 2387942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2387945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387957 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2387957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2387960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387970 */     // GIR_Coverage, 1976,
     /* 2387970 */     GIR_EraseRootFromParent_Done,
     /* 2387971 */   // Label 34267: @2387971
     /* 2387971 */   GIM_Try, /*On fail goto*//*Label 34268*/ GIMT_Encode4(2388005), // Rule ID 1977 //
     /* 2387976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2387979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387991 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2387991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2387994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388004 */     // GIR_Coverage, 1977,
     /* 2388004 */     GIR_EraseRootFromParent_Done,
     /* 2388005 */   // Label 34268: @2388005
     /* 2388005 */   GIM_Reject,
     /* 2388006 */ // Label 34264: @2388006
     /* 2388006 */ GIM_Reject,
     /* 2388007 */ // Label 34246: @2388007
     /* 2388007 */ GIM_Try, /*On fail goto*//*Label 34269*/ GIMT_Encode4(2388155),
     /* 2388012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2388018 */   GIM_Try, /*On fail goto*//*Label 34270*/ GIMT_Encode4(2388052), // Rule ID 1259 //
     /* 2388023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2388026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388038 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2388038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2388041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388051 */     // GIR_Coverage, 1259,
     /* 2388051 */     GIR_EraseRootFromParent_Done,
     /* 2388052 */   // Label 34270: @2388052
     /* 2388052 */   GIM_Try, /*On fail goto*//*Label 34271*/ GIMT_Encode4(2388086), // Rule ID 1260 //
     /* 2388057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2388060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388072 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2388072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2388075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388085 */     // GIR_Coverage, 1260,
     /* 2388085 */     GIR_EraseRootFromParent_Done,
     /* 2388086 */   // Label 34271: @2388086
     /* 2388086 */   GIM_Try, /*On fail goto*//*Label 34272*/ GIMT_Encode4(2388120), // Rule ID 1263 //
     /* 2388091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2388094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388106 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2388106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2388109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388119 */     // GIR_Coverage, 1263,
     /* 2388119 */     GIR_EraseRootFromParent_Done,
     /* 2388120 */   // Label 34272: @2388120
     /* 2388120 */   GIM_Try, /*On fail goto*//*Label 34273*/ GIMT_Encode4(2388154), // Rule ID 1264 //
     /* 2388125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2388128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388140 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2388140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2388143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388153 */     // GIR_Coverage, 1264,
     /* 2388153 */     GIR_EraseRootFromParent_Done,
     /* 2388154 */   // Label 34273: @2388154
     /* 2388154 */   GIM_Reject,
     /* 2388155 */ // Label 34269: @2388155
     /* 2388155 */ GIM_Reject,
     /* 2388156 */ // Label 34247: @2388156
     /* 2388156 */ GIM_Try, /*On fail goto*//*Label 34274*/ GIMT_Encode4(2388338),
     /* 2388161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2388167 */   GIM_Try, /*On fail goto*//*Label 34275*/ GIMT_Encode4(2388201), // Rule ID 1600 //
     /* 2388172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2388175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388187 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2388187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2388190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388200 */     // GIR_Coverage, 1600,
     /* 2388200 */     GIR_EraseRootFromParent_Done,
     /* 2388201 */   // Label 34275: @2388201
     /* 2388201 */   GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2388235), // Rule ID 1601 //
     /* 2388206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2388209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388221 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2388221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2388224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388234 */     // GIR_Coverage, 1601,
     /* 2388234 */     GIR_EraseRootFromParent_Done,
     /* 2388235 */   // Label 34276: @2388235
     /* 2388235 */   GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2388269), // Rule ID 1604 //
     /* 2388240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2388243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388255 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2388255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2388258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388268 */     // GIR_Coverage, 1604,
     /* 2388268 */     GIR_EraseRootFromParent_Done,
     /* 2388269 */   // Label 34277: @2388269
     /* 2388269 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2388303), // Rule ID 1605 //
     /* 2388274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2388277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2388289 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2388289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2388292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388302 */     // GIR_Coverage, 1605,
     /* 2388302 */     GIR_EraseRootFromParent_Done,
     /* 2388303 */   // Label 34278: @2388303
     /* 2388303 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2388337), // Rule ID 1608 //
     /* 2388308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2388311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2388323 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2388323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2388326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388336 */     // GIR_Coverage, 1608,
     /* 2388336 */     GIR_EraseRootFromParent_Done,
     /* 2388337 */   // Label 34279: @2388337
     /* 2388337 */   GIM_Reject,
     /* 2388338 */ // Label 34274: @2388338
     /* 2388338 */ GIM_Reject,
     /* 2388339 */ // Label 34248: @2388339
     /* 2388339 */ GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2388459),
     /* 2388344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2388347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2388350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388362 */   GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2388410), // Rule ID 54394 //
     /* 2388367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2388370 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2388373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2388387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388409 */     // GIR_Coverage, 54394,
     /* 2388409 */     GIR_EraseRootFromParent_Done,
     /* 2388410 */   // Label 34281: @2388410
     /* 2388410 */   GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2388458), // Rule ID 54395 //
     /* 2388415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2388418 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2388421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2388435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388457 */     // GIR_Coverage, 54395,
     /* 2388457 */     GIR_EraseRootFromParent_Done,
     /* 2388458 */   // Label 34282: @2388458
     /* 2388458 */   GIM_Reject,
     /* 2388459 */ // Label 34280: @2388459
     /* 2388459 */ GIM_Reject,
     /* 2388460 */ // Label 34249: @2388460
     /* 2388460 */ GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2388580),
     /* 2388465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2388468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2388471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388483 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2388531), // Rule ID 54418 //
     /* 2388488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2388491 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2388494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2388508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388530 */     // GIR_Coverage, 54418,
     /* 2388530 */     GIR_EraseRootFromParent_Done,
     /* 2388531 */   // Label 34284: @2388531
     /* 2388531 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2388579), // Rule ID 54419 //
     /* 2388536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2388539 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2388542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2388556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388578 */     // GIR_Coverage, 54419,
     /* 2388578 */     GIR_EraseRootFromParent_Done,
     /* 2388579 */   // Label 34285: @2388579
     /* 2388579 */   GIM_Reject,
     /* 2388580 */ // Label 34283: @2388580
     /* 2388580 */ GIM_Reject,
     /* 2388581 */ // Label 34250: @2388581
     /* 2388581 */ GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2388701),
     /* 2388586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2388589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2388592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388604 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2388652), // Rule ID 54454 //
     /* 2388609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2388612 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2388615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2388629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388651 */     // GIR_Coverage, 54454,
     /* 2388651 */     GIR_EraseRootFromParent_Done,
     /* 2388652 */   // Label 34287: @2388652
     /* 2388652 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2388700), // Rule ID 54455 //
     /* 2388657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2388660 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2388663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2388677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388699 */     // GIR_Coverage, 54455,
     /* 2388699 */     GIR_EraseRootFromParent_Done,
     /* 2388700 */   // Label 34288: @2388700
     /* 2388700 */   GIM_Reject,
     /* 2388701 */ // Label 34286: @2388701
     /* 2388701 */ GIM_Reject,
     /* 2388702 */ // Label 34251: @2388702
     /* 2388702 */ GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2388822),
     /* 2388707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2388710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2388713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388725 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2388773), // Rule ID 54406 //
     /* 2388730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2388733 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2388750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388772 */     // GIR_Coverage, 54406,
     /* 2388772 */     GIR_EraseRootFromParent_Done,
     /* 2388773 */   // Label 34290: @2388773
     /* 2388773 */   GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2388821), // Rule ID 54407 //
     /* 2388778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2388781 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2388784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2388798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388820 */     // GIR_Coverage, 54407,
     /* 2388820 */     GIR_EraseRootFromParent_Done,
     /* 2388821 */   // Label 34291: @2388821
     /* 2388821 */   GIM_Reject,
     /* 2388822 */ // Label 34289: @2388822
     /* 2388822 */ GIM_Reject,
     /* 2388823 */ // Label 34252: @2388823
     /* 2388823 */ GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2388943),
     /* 2388828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2388831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2388834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2388846 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2388894), // Rule ID 54442 //
     /* 2388851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2388854 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2388871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388893 */     // GIR_Coverage, 54442,
     /* 2388893 */     GIR_EraseRootFromParent_Done,
     /* 2388894 */   // Label 34293: @2388894
     /* 2388894 */   GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2388942), // Rule ID 54443 //
     /* 2388899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2388902 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2388905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2388919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388941 */     // GIR_Coverage, 54443,
     /* 2388941 */     GIR_EraseRootFromParent_Done,
     /* 2388942 */   // Label 34294: @2388942
     /* 2388942 */   GIM_Reject,
     /* 2388943 */ // Label 34292: @2388943
     /* 2388943 */ GIM_Reject,
     /* 2388944 */ // Label 34253: @2388944
     /* 2388944 */ GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2389064),
     /* 2388949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2388952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2388955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388967 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2389015), // Rule ID 54538 //
     /* 2388972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2388975 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2388978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2388992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389014 */     // GIR_Coverage, 54538,
     /* 2389014 */     GIR_EraseRootFromParent_Done,
     /* 2389015 */   // Label 34296: @2389015
     /* 2389015 */   GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2389063), // Rule ID 54539 //
     /* 2389020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2389023 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2389026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2389040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389062 */     // GIR_Coverage, 54539,
     /* 2389062 */     GIR_EraseRootFromParent_Done,
     /* 2389063 */   // Label 34297: @2389063
     /* 2389063 */   GIM_Reject,
     /* 2389064 */ // Label 34295: @2389064
     /* 2389064 */ GIM_Reject,
     /* 2389065 */ // Label 34254: @2389065
     /* 2389065 */ GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2389185),
     /* 2389070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2389073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2389076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389088 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2389136), // Rule ID 54430 //
     /* 2389093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389096 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2389099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2389113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389135 */     // GIR_Coverage, 54430,
     /* 2389135 */     GIR_EraseRootFromParent_Done,
     /* 2389136 */   // Label 34299: @2389136
     /* 2389136 */   GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2389184), // Rule ID 54431 //
     /* 2389141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389144 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2389147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2389161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389183 */     // GIR_Coverage, 54431,
     /* 2389183 */     GIR_EraseRootFromParent_Done,
     /* 2389184 */   // Label 34300: @2389184
     /* 2389184 */   GIM_Reject,
     /* 2389185 */ // Label 34298: @2389185
     /* 2389185 */ GIM_Reject,
     /* 2389186 */ // Label 34255: @2389186
     /* 2389186 */ GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2389306),
     /* 2389191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2389194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2389197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389209 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2389257), // Rule ID 54502 //
     /* 2389214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2389217 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2389220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2389234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389256 */     // GIR_Coverage, 54502,
     /* 2389256 */     GIR_EraseRootFromParent_Done,
     /* 2389257 */   // Label 34302: @2389257
     /* 2389257 */   GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2389305), // Rule ID 54503 //
     /* 2389262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2389265 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2389268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2389282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389304 */     // GIR_Coverage, 54503,
     /* 2389304 */     GIR_EraseRootFromParent_Done,
     /* 2389305 */   // Label 34303: @2389305
     /* 2389305 */   GIM_Reject,
     /* 2389306 */ // Label 34301: @2389306
     /* 2389306 */ GIM_Reject,
     /* 2389307 */ // Label 34256: @2389307
     /* 2389307 */ GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2389427),
     /* 2389312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2389315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2389318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389330 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2389378), // Rule ID 54550 //
     /* 2389335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2389338 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2389341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2389355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389377 */     // GIR_Coverage, 54550,
     /* 2389377 */     GIR_EraseRootFromParent_Done,
     /* 2389378 */   // Label 34305: @2389378
     /* 2389378 */   GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2389426), // Rule ID 54551 //
     /* 2389383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2389386 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2389389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2389403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389425 */     // GIR_Coverage, 54551,
     /* 2389425 */     GIR_EraseRootFromParent_Done,
     /* 2389426 */   // Label 34306: @2389426
     /* 2389426 */   GIM_Reject,
     /* 2389427 */ // Label 34304: @2389427
     /* 2389427 */ GIM_Reject,
     /* 2389428 */ // Label 34257: @2389428
     /* 2389428 */ GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2389548),
     /* 2389433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2389436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2389439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2389451 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2389499), // Rule ID 54466 //
     /* 2389456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389459 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2389462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2389476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389498 */     // GIR_Coverage, 54466,
     /* 2389498 */     GIR_EraseRootFromParent_Done,
     /* 2389499 */   // Label 34308: @2389499
     /* 2389499 */   GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2389547), // Rule ID 54467 //
     /* 2389504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389507 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2389510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2389524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389546 */     // GIR_Coverage, 54467,
     /* 2389546 */     GIR_EraseRootFromParent_Done,
     /* 2389547 */   // Label 34309: @2389547
     /* 2389547 */   GIM_Reject,
     /* 2389548 */ // Label 34307: @2389548
     /* 2389548 */ GIM_Reject,
     /* 2389549 */ // Label 34258: @2389549
     /* 2389549 */ GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2389669),
     /* 2389554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2389557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2389560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389572 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2389620), // Rule ID 54514 //
     /* 2389577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2389580 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2389583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2389597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389619 */     // GIR_Coverage, 54514,
     /* 2389619 */     GIR_EraseRootFromParent_Done,
     /* 2389620 */   // Label 34311: @2389620
     /* 2389620 */   GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2389668), // Rule ID 54515 //
     /* 2389625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2389628 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2389631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2389645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389667 */     // GIR_Coverage, 54515,
     /* 2389667 */     GIR_EraseRootFromParent_Done,
     /* 2389668 */   // Label 34312: @2389668
     /* 2389668 */   GIM_Reject,
     /* 2389669 */ // Label 34310: @2389669
     /* 2389669 */ GIM_Reject,
     /* 2389670 */ // Label 34259: @2389670
     /* 2389670 */ GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2389790),
     /* 2389675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2389678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2389681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389693 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2389741), // Rule ID 54562 //
     /* 2389698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2389701 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2389718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389740 */     // GIR_Coverage, 54562,
     /* 2389740 */     GIR_EraseRootFromParent_Done,
     /* 2389741 */   // Label 34314: @2389741
     /* 2389741 */   GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2389789), // Rule ID 54563 //
     /* 2389746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2389749 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2389752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2389766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389788 */     // GIR_Coverage, 54563,
     /* 2389788 */     GIR_EraseRootFromParent_Done,
     /* 2389789 */   // Label 34315: @2389789
     /* 2389789 */   GIM_Reject,
     /* 2389790 */ // Label 34313: @2389790
     /* 2389790 */ GIM_Reject,
     /* 2389791 */ // Label 34260: @2389791
     /* 2389791 */ GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2389911),
     /* 2389796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2389799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2389802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2389814 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2389862), // Rule ID 54478 //
     /* 2389819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389822 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2389839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389861 */     // GIR_Coverage, 54478,
     /* 2389861 */     GIR_EraseRootFromParent_Done,
     /* 2389862 */   // Label 34317: @2389862
     /* 2389862 */   GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2389910), // Rule ID 54479 //
     /* 2389867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389870 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2389873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2389887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389909 */     // GIR_Coverage, 54479,
     /* 2389909 */     GIR_EraseRootFromParent_Done,
     /* 2389910 */   // Label 34318: @2389910
     /* 2389910 */   GIM_Reject,
     /* 2389911 */ // Label 34316: @2389911
     /* 2389911 */ GIM_Reject,
     /* 2389912 */ // Label 34261: @2389912
     /* 2389912 */ GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2390032),
     /* 2389917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2389920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2389923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2389935 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2389983), // Rule ID 54526 //
     /* 2389940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2389943 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2389960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389982 */     // GIR_Coverage, 54526,
     /* 2389982 */     GIR_EraseRootFromParent_Done,
     /* 2389983 */   // Label 34320: @2389983
     /* 2389983 */   GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2390031), // Rule ID 54527 //
     /* 2389988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2389991 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2389994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2390008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390030 */     // GIR_Coverage, 54527,
     /* 2390030 */     GIR_EraseRootFromParent_Done,
     /* 2390031 */   // Label 34321: @2390031
     /* 2390031 */   GIM_Reject,
     /* 2390032 */ // Label 34319: @2390032
     /* 2390032 */ GIM_Reject,
     /* 2390033 */ // Label 34262: @2390033
     /* 2390033 */ GIM_Try, /*On fail goto*//*Label 34322*/ GIMT_Encode4(2390153),
     /* 2390038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2390041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2390044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390056 */   GIM_Try, /*On fail goto*//*Label 34323*/ GIMT_Encode4(2390104), // Rule ID 54490 //
     /* 2390061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390064 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2390067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2390081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390103 */     // GIR_Coverage, 54490,
     /* 2390103 */     GIR_EraseRootFromParent_Done,
     /* 2390104 */   // Label 34323: @2390104
     /* 2390104 */   GIM_Try, /*On fail goto*//*Label 34324*/ GIMT_Encode4(2390152), // Rule ID 54491 //
     /* 2390109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390112 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2390115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2390129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390151 */     // GIR_Coverage, 54491,
     /* 2390151 */     GIR_EraseRootFromParent_Done,
     /* 2390152 */   // Label 34324: @2390152
     /* 2390152 */   GIM_Reject,
     /* 2390153 */ // Label 34322: @2390153
     /* 2390153 */ GIM_Reject,
     /* 2390154 */ // Label 34263: @2390154
     /* 2390154 */ GIM_Reject,
     /* 2390155 */ // Label 102: @2390155
     /* 2390155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34343*/ GIMT_Encode4(2406799),
     /* 2390166 */ /*GILLT_s16*//*Label 34325*/ GIMT_Encode4(2390286),
     /* 2390170 */ /*GILLT_s32*//*Label 34326*/ GIMT_Encode4(2391722),
     /* 2390174 */ /*GILLT_s64*//*Label 34327*/ GIMT_Encode4(2393158), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390186 */ /*GILLT_nxv1s16*//*Label 34328*/ GIMT_Encode4(2394949),
     /* 2390190 */ /*GILLT_nxv1s32*//*Label 34329*/ GIMT_Encode4(2395739),
     /* 2390194 */ /*GILLT_nxv1s64*//*Label 34330*/ GIMT_Encode4(2396529), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390206 */ /*GILLT_nxv2s16*//*Label 34331*/ GIMT_Encode4(2397319),
     /* 2390210 */ /*GILLT_nxv2s32*//*Label 34332*/ GIMT_Encode4(2398109),
     /* 2390214 */ /*GILLT_nxv2s64*//*Label 34333*/ GIMT_Encode4(2398899), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390226 */ /*GILLT_nxv4s16*//*Label 34334*/ GIMT_Encode4(2399689),
     /* 2390230 */ /*GILLT_nxv4s32*//*Label 34335*/ GIMT_Encode4(2400479),
     /* 2390234 */ /*GILLT_nxv4s64*//*Label 34336*/ GIMT_Encode4(2401269), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390246 */ /*GILLT_nxv8s16*//*Label 34337*/ GIMT_Encode4(2402059),
     /* 2390250 */ /*GILLT_nxv8s32*//*Label 34338*/ GIMT_Encode4(2402849),
     /* 2390254 */ /*GILLT_nxv8s64*//*Label 34339*/ GIMT_Encode4(2403639), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390266 */ /*GILLT_nxv16s16*//*Label 34340*/ GIMT_Encode4(2404429),
     /* 2390270 */ /*GILLT_nxv16s32*//*Label 34341*/ GIMT_Encode4(2405219), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2390282 */ /*GILLT_nxv32s16*//*Label 34342*/ GIMT_Encode4(2406009),
     /* 2390286 */ // Label 34325: @2390286
     /* 2390286 */ GIM_Try, /*On fail goto*//*Label 34344*/ GIMT_Encode4(2391721),
     /* 2390291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2390297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2390300 */   GIM_Try, /*On fail goto*//*Label 34345*/ GIMT_Encode4(2390372), // Rule ID 2005 //
     /* 2390305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2390308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390352 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2390352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2390355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390371 */     // GIR_Coverage, 2005,
     /* 2390371 */     GIR_EraseRootFromParent_Done,
     /* 2390372 */   // Label 34345: @2390372
     /* 2390372 */   GIM_Try, /*On fail goto*//*Label 34346*/ GIMT_Encode4(2390444), // Rule ID 2006 //
     /* 2390377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2390380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390424 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2390424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2390427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390443 */     // GIR_Coverage, 2006,
     /* 2390443 */     GIR_EraseRootFromParent_Done,
     /* 2390444 */   // Label 34346: @2390444
     /* 2390444 */   GIM_Try, /*On fail goto*//*Label 34347*/ GIMT_Encode4(2390516), // Rule ID 2038 //
     /* 2390449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2390452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390496 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2390496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2390499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390515 */     // GIR_Coverage, 2038,
     /* 2390515 */     GIR_EraseRootFromParent_Done,
     /* 2390516 */   // Label 34347: @2390516
     /* 2390516 */   GIM_Try, /*On fail goto*//*Label 34348*/ GIMT_Encode4(2390588), // Rule ID 2039 //
     /* 2390521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2390524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390568 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2390568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2390571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390587 */     // GIR_Coverage, 2039,
     /* 2390587 */     GIR_EraseRootFromParent_Done,
     /* 2390588 */   // Label 34348: @2390588
     /* 2390588 */   GIM_Try, /*On fail goto*//*Label 34349*/ GIMT_Encode4(2390660), // Rule ID 65198 //
     /* 2390593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2390596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390640 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2390640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2390643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390659 */     // GIR_Coverage, 65198,
     /* 2390659 */     GIR_EraseRootFromParent_Done,
     /* 2390660 */   // Label 34349: @2390660
     /* 2390660 */   GIM_Try, /*On fail goto*//*Label 34350*/ GIMT_Encode4(2390732), // Rule ID 65199 //
     /* 2390665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2390668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390712 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2390712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2390715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390731 */     // GIR_Coverage, 65199,
     /* 2390731 */     GIR_EraseRootFromParent_Done,
     /* 2390732 */   // Label 34350: @2390732
     /* 2390732 */   GIM_Try, /*On fail goto*//*Label 34351*/ GIMT_Encode4(2390804), // Rule ID 65206 //
     /* 2390737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2390740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390784 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2390784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2390787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390803 */     // GIR_Coverage, 65206,
     /* 2390803 */     GIR_EraseRootFromParent_Done,
     /* 2390804 */   // Label 34351: @2390804
     /* 2390804 */   GIM_Try, /*On fail goto*//*Label 34352*/ GIMT_Encode4(2390876), // Rule ID 65207 //
     /* 2390809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2390812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2390854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390856 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2390856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2390859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2390871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390875 */     // GIR_Coverage, 65207,
     /* 2390875 */     GIR_EraseRootFromParent_Done,
     /* 2390876 */   // Label 34352: @2390876
     /* 2390876 */   GIM_Try, /*On fail goto*//*Label 34353*/ GIMT_Encode4(2390933), // Rule ID 2001 //
     /* 2390881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2390884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390915 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2390915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2390918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390932 */     // GIR_Coverage, 2001,
     /* 2390932 */     GIR_EraseRootFromParent_Done,
     /* 2390933 */   // Label 34353: @2390933
     /* 2390933 */   GIM_Try, /*On fail goto*//*Label 34354*/ GIMT_Encode4(2390990), // Rule ID 2002 //
     /* 2390938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2390941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2390957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2390970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390972 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2390972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2390975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390989 */     // GIR_Coverage, 2002,
     /* 2390989 */     GIR_EraseRootFromParent_Done,
     /* 2390990 */   // Label 34354: @2390990
     /* 2390990 */   GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2391047), // Rule ID 2034 //
     /* 2390995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2390998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391029 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2391032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391046 */     // GIR_Coverage, 2034,
     /* 2391046 */     GIR_EraseRootFromParent_Done,
     /* 2391047 */   // Label 34355: @2391047
     /* 2391047 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2391104), // Rule ID 2035 //
     /* 2391052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391086 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2391089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391103 */     // GIR_Coverage, 2035,
     /* 2391103 */     GIR_EraseRootFromParent_Done,
     /* 2391104 */   // Label 34356: @2391104
     /* 2391104 */   GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2391161), // Rule ID 65194 //
     /* 2391109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2391112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391143 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2391146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391160 */     // GIR_Coverage, 65194,
     /* 2391160 */     GIR_EraseRootFromParent_Done,
     /* 2391161 */   // Label 34357: @2391161
     /* 2391161 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2391218), // Rule ID 65195 //
     /* 2391166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2391169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391200 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2391203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391217 */     // GIR_Coverage, 65195,
     /* 2391217 */     GIR_EraseRootFromParent_Done,
     /* 2391218 */   // Label 34358: @2391218
     /* 2391218 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2391275), // Rule ID 65202 //
     /* 2391223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2391226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391257 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2391260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391274 */     // GIR_Coverage, 65202,
     /* 2391274 */     GIR_EraseRootFromParent_Done,
     /* 2391275 */   // Label 34359: @2391275
     /* 2391275 */   GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2391332), // Rule ID 65203 //
     /* 2391280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391314 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2391317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391331 */     // GIR_Coverage, 65203,
     /* 2391331 */     GIR_EraseRootFromParent_Done,
     /* 2391332 */   // Label 34360: @2391332
     /* 2391332 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2391389), // Rule ID 1997 //
     /* 2391337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2391340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391371 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2391374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2391384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391388 */     // GIR_Coverage, 1997,
     /* 2391388 */     GIR_EraseRootFromParent_Done,
     /* 2391389 */   // Label 34361: @2391389
     /* 2391389 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2391446), // Rule ID 1998 //
     /* 2391394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2391397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391428 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2391431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2391441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391445 */     // GIR_Coverage, 1998,
     /* 2391445 */     GIR_EraseRootFromParent_Done,
     /* 2391446 */   // Label 34362: @2391446
     /* 2391446 */   GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2391503), // Rule ID 2030 //
     /* 2391451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2391454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391485 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2391488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2391498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391502 */     // GIR_Coverage, 2030,
     /* 2391502 */     GIR_EraseRootFromParent_Done,
     /* 2391503 */   // Label 34363: @2391503
     /* 2391503 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2391560), // Rule ID 2031 //
     /* 2391508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391542 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2391545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2391555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391559 */     // GIR_Coverage, 2031,
     /* 2391559 */     GIR_EraseRootFromParent_Done,
     /* 2391560 */   // Label 34364: @2391560
     /* 2391560 */   GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2391600), // Rule ID 1993 //
     /* 2391565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2391568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391584 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2391587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391599 */     // GIR_Coverage, 1993,
     /* 2391599 */     GIR_EraseRootFromParent_Done,
     /* 2391600 */   // Label 34365: @2391600
     /* 2391600 */   GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2391640), // Rule ID 1994 //
     /* 2391605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2391608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391624 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2391627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391639 */     // GIR_Coverage, 1994,
     /* 2391639 */     GIR_EraseRootFromParent_Done,
     /* 2391640 */   // Label 34366: @2391640
     /* 2391640 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2391680), // Rule ID 2026 //
     /* 2391645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2391648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391664 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2391664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2391667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391679 */     // GIR_Coverage, 2026,
     /* 2391679 */     GIR_EraseRootFromParent_Done,
     /* 2391680 */   // Label 34367: @2391680
     /* 2391680 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2391720), // Rule ID 2027 //
     /* 2391685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391704 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2391704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2391707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2391715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391719 */     // GIR_Coverage, 2027,
     /* 2391719 */     GIR_EraseRootFromParent_Done,
     /* 2391720 */   // Label 34368: @2391720
     /* 2391720 */   GIM_Reject,
     /* 2391721 */ // Label 34344: @2391721
     /* 2391721 */ GIM_Reject,
     /* 2391722 */ // Label 34326: @2391722
     /* 2391722 */ GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2393157),
     /* 2391727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2391733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2391736 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2391808), // Rule ID 1300 //
     /* 2391741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2391744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391788 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2391788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2391791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2391803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391807 */     // GIR_Coverage, 1300,
     /* 2391807 */     GIR_EraseRootFromParent_Done,
     /* 2391808 */   // Label 34370: @2391808
     /* 2391808 */   GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2391880), // Rule ID 1301 //
     /* 2391813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2391816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391860 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2391860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2391863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2391875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391879 */     // GIR_Coverage, 1301,
     /* 2391879 */     GIR_EraseRootFromParent_Done,
     /* 2391880 */   // Label 34371: @2391880
     /* 2391880 */   GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2391952), // Rule ID 1321 //
     /* 2391885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2391888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391932 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2391932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2391935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2391947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391951 */     // GIR_Coverage, 1321,
     /* 2391951 */     GIR_EraseRootFromParent_Done,
     /* 2391952 */   // Label 34372: @2391952
     /* 2391952 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2392024), // Rule ID 1322 //
     /* 2391957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2391960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2391985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392004 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2392007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2392019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392023 */     // GIR_Coverage, 1322,
     /* 2392023 */     GIR_EraseRootFromParent_Done,
     /* 2392024 */   // Label 34373: @2392024
     /* 2392024 */   GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2392096), // Rule ID 65162 //
     /* 2392029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2392032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392076 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2392079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2392091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392095 */     // GIR_Coverage, 65162,
     /* 2392095 */     GIR_EraseRootFromParent_Done,
     /* 2392096 */   // Label 34374: @2392096
     /* 2392096 */   GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2392168), // Rule ID 65163 //
     /* 2392101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392148 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2392151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2392163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392167 */     // GIR_Coverage, 65163,
     /* 2392167 */     GIR_EraseRootFromParent_Done,
     /* 2392168 */   // Label 34375: @2392168
     /* 2392168 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2392240), // Rule ID 65170 //
     /* 2392173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392220 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2392223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2392235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392239 */     // GIR_Coverage, 65170,
     /* 2392239 */     GIR_EraseRootFromParent_Done,
     /* 2392240 */   // Label 34376: @2392240
     /* 2392240 */   GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2392312), // Rule ID 65171 //
     /* 2392245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392292 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2392295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2392307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392311 */     // GIR_Coverage, 65171,
     /* 2392311 */     GIR_EraseRootFromParent_Done,
     /* 2392312 */   // Label 34377: @2392312
     /* 2392312 */   GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2392369), // Rule ID 1296 //
     /* 2392317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2392320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392351 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2392354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392368 */     // GIR_Coverage, 1296,
     /* 2392368 */     GIR_EraseRootFromParent_Done,
     /* 2392369 */   // Label 34378: @2392369
     /* 2392369 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2392426), // Rule ID 1297 //
     /* 2392374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392408 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2392411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392425 */     // GIR_Coverage, 1297,
     /* 2392425 */     GIR_EraseRootFromParent_Done,
     /* 2392426 */   // Label 34379: @2392426
     /* 2392426 */   GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2392483), // Rule ID 1317 //
     /* 2392431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392465 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2392468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392482 */     // GIR_Coverage, 1317,
     /* 2392482 */     GIR_EraseRootFromParent_Done,
     /* 2392483 */   // Label 34380: @2392483
     /* 2392483 */   GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2392540), // Rule ID 1318 //
     /* 2392488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392522 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2392525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392539 */     // GIR_Coverage, 1318,
     /* 2392539 */     GIR_EraseRootFromParent_Done,
     /* 2392540 */   // Label 34381: @2392540
     /* 2392540 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2392597), // Rule ID 65158 //
     /* 2392545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2392548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392579 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2392582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392596 */     // GIR_Coverage, 65158,
     /* 2392596 */     GIR_EraseRootFromParent_Done,
     /* 2392597 */   // Label 34382: @2392597
     /* 2392597 */   GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2392654), // Rule ID 65159 //
     /* 2392602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392636 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2392639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392653 */     // GIR_Coverage, 65159,
     /* 2392653 */     GIR_EraseRootFromParent_Done,
     /* 2392654 */   // Label 34383: @2392654
     /* 2392654 */   GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2392711), // Rule ID 65166 //
     /* 2392659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392693 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2392696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392710 */     // GIR_Coverage, 65166,
     /* 2392710 */     GIR_EraseRootFromParent_Done,
     /* 2392711 */   // Label 34384: @2392711
     /* 2392711 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2392768), // Rule ID 65167 //
     /* 2392716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392750 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2392753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2392761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2392763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392767 */     // GIR_Coverage, 65167,
     /* 2392767 */     GIR_EraseRootFromParent_Done,
     /* 2392768 */   // Label 34385: @2392768
     /* 2392768 */   GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2392825), // Rule ID 1292 //
     /* 2392773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2392776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392807 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2392810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2392820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392824 */     // GIR_Coverage, 1292,
     /* 2392824 */     GIR_EraseRootFromParent_Done,
     /* 2392825 */   // Label 34386: @2392825
     /* 2392825 */   GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2392882), // Rule ID 1293 //
     /* 2392830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392864 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2392867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2392877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392881 */     // GIR_Coverage, 1293,
     /* 2392881 */     GIR_EraseRootFromParent_Done,
     /* 2392882 */   // Label 34387: @2392882
     /* 2392882 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2392939), // Rule ID 1313 //
     /* 2392887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392921 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2392921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2392924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2392934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392938 */     // GIR_Coverage, 1313,
     /* 2392938 */     GIR_EraseRootFromParent_Done,
     /* 2392939 */   // Label 34388: @2392939
     /* 2392939 */   GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2392996), // Rule ID 1314 //
     /* 2392944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2392971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392978 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2392978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2392981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2392991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392995 */     // GIR_Coverage, 1314,
     /* 2392995 */     GIR_EraseRootFromParent_Done,
     /* 2392996 */   // Label 34389: @2392996
     /* 2392996 */   GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2393036), // Rule ID 1288 //
     /* 2393001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2393004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393020 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2393020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2393023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2393031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393035 */     // GIR_Coverage, 1288,
     /* 2393035 */     GIR_EraseRootFromParent_Done,
     /* 2393036 */   // Label 34390: @2393036
     /* 2393036 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2393076), // Rule ID 1289 //
     /* 2393041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2393044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2393060 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2393060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2393063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2393071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393075 */     // GIR_Coverage, 1289,
     /* 2393075 */     GIR_EraseRootFromParent_Done,
     /* 2393076 */   // Label 34391: @2393076
     /* 2393076 */   GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2393116), // Rule ID 1309 //
     /* 2393081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2393084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393100 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2393100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2393103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2393111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393115 */     // GIR_Coverage, 1309,
     /* 2393115 */     GIR_EraseRootFromParent_Done,
     /* 2393116 */   // Label 34392: @2393116
     /* 2393116 */   GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2393156), // Rule ID 1310 //
     /* 2393121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2393124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2393140 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2393140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2393143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2393151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393155 */     // GIR_Coverage, 1310,
     /* 2393155 */     GIR_EraseRootFromParent_Done,
     /* 2393156 */   // Label 34393: @2393156
     /* 2393156 */   GIM_Reject,
     /* 2393157 */ // Label 34369: @2393157
     /* 2393157 */ GIM_Reject,
     /* 2393158 */ // Label 34327: @2393158
     /* 2393158 */ GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2394948),
     /* 2393163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2393169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2393172 */   GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2393244), // Rule ID 1637 //
     /* 2393177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2393180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393224 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2393227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393243 */     // GIR_Coverage, 1637,
     /* 2393243 */     GIR_EraseRootFromParent_Done,
     /* 2393244 */   // Label 34395: @2393244
     /* 2393244 */   GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2393316), // Rule ID 1638 //
     /* 2393249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2393252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393296 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2393296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2393299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393315 */     // GIR_Coverage, 1638,
     /* 2393315 */     GIR_EraseRootFromParent_Done,
     /* 2393316 */   // Label 34396: @2393316
     /* 2393316 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2393388), // Rule ID 1661 //
     /* 2393321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2393324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393368 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2393371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393387 */     // GIR_Coverage, 1661,
     /* 2393387 */     GIR_EraseRootFromParent_Done,
     /* 2393388 */   // Label 34397: @2393388
     /* 2393388 */   GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2393460), // Rule ID 1692 //
     /* 2393393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2393396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393440 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2393443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393459 */     // GIR_Coverage, 1692,
     /* 2393459 */     GIR_EraseRootFromParent_Done,
     /* 2393460 */   // Label 34398: @2393460
     /* 2393460 */   GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2393532), // Rule ID 1693 //
     /* 2393465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2393468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393512 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2393512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2393515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393531 */     // GIR_Coverage, 1693,
     /* 2393531 */     GIR_EraseRootFromParent_Done,
     /* 2393532 */   // Label 34399: @2393532
     /* 2393532 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2393604), // Rule ID 65178 //
     /* 2393537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2393540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393584 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2393587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393603 */     // GIR_Coverage, 65178,
     /* 2393603 */     GIR_EraseRootFromParent_Done,
     /* 2393604 */   // Label 34400: @2393604
     /* 2393604 */   GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2393676), // Rule ID 65179 //
     /* 2393609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2393612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393656 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2393656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2393659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393675 */     // GIR_Coverage, 65179,
     /* 2393675 */     GIR_EraseRootFromParent_Done,
     /* 2393676 */   // Label 34401: @2393676
     /* 2393676 */   GIM_Try, /*On fail goto*//*Label 34402*/ GIMT_Encode4(2393748), // Rule ID 65184 //
     /* 2393681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2393684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2393726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393728 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2393731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393747 */     // GIR_Coverage, 65184,
     /* 2393747 */     GIR_EraseRootFromParent_Done,
     /* 2393748 */   // Label 34402: @2393748
     /* 2393748 */   GIM_Try, /*On fail goto*//*Label 34403*/ GIMT_Encode4(2393820), // Rule ID 65190 //
     /* 2393753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2393756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393800 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2393803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393819 */     // GIR_Coverage, 65190,
     /* 2393819 */     GIR_EraseRootFromParent_Done,
     /* 2393820 */   // Label 34403: @2393820
     /* 2393820 */   GIM_Try, /*On fail goto*//*Label 34404*/ GIMT_Encode4(2393892), // Rule ID 65191 //
     /* 2393825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2393828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2393870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393872 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2393872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2393875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2393883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2393887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393891 */     // GIR_Coverage, 65191,
     /* 2393891 */     GIR_EraseRootFromParent_Done,
     /* 2393892 */   // Label 34404: @2393892
     /* 2393892 */   GIM_Try, /*On fail goto*//*Label 34405*/ GIMT_Encode4(2393949), // Rule ID 1633 //
     /* 2393897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2393900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393931 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2393931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2393934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2393944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393948 */     // GIR_Coverage, 1633,
     /* 2393948 */     GIR_EraseRootFromParent_Done,
     /* 2393949 */   // Label 34405: @2393949
     /* 2393949 */   GIM_Try, /*On fail goto*//*Label 34406*/ GIMT_Encode4(2394006), // Rule ID 1634 //
     /* 2393954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2393957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2393973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2393986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393988 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2393988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2393991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394005 */     // GIR_Coverage, 1634,
     /* 2394005 */     GIR_EraseRootFromParent_Done,
     /* 2394006 */   // Label 34406: @2394006
     /* 2394006 */   GIM_Try, /*On fail goto*//*Label 34407*/ GIMT_Encode4(2394063), // Rule ID 1659 //
     /* 2394011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394045 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2394048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394062 */     // GIR_Coverage, 1659,
     /* 2394062 */     GIR_EraseRootFromParent_Done,
     /* 2394063 */   // Label 34407: @2394063
     /* 2394063 */   GIM_Try, /*On fail goto*//*Label 34408*/ GIMT_Encode4(2394120), // Rule ID 1688 //
     /* 2394068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394102 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2394105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394119 */     // GIR_Coverage, 1688,
     /* 2394119 */     GIR_EraseRootFromParent_Done,
     /* 2394120 */   // Label 34408: @2394120
     /* 2394120 */   GIM_Try, /*On fail goto*//*Label 34409*/ GIMT_Encode4(2394177), // Rule ID 1689 //
     /* 2394125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394159 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2394162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394176 */     // GIR_Coverage, 1689,
     /* 2394176 */     GIR_EraseRootFromParent_Done,
     /* 2394177 */   // Label 34409: @2394177
     /* 2394177 */   GIM_Try, /*On fail goto*//*Label 34410*/ GIMT_Encode4(2394234), // Rule ID 65174 //
     /* 2394182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394216 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2394219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2394227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394233 */     // GIR_Coverage, 65174,
     /* 2394233 */     GIR_EraseRootFromParent_Done,
     /* 2394234 */   // Label 34410: @2394234
     /* 2394234 */   GIM_Try, /*On fail goto*//*Label 34411*/ GIMT_Encode4(2394291), // Rule ID 65175 //
     /* 2394239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2394242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394273 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2394276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2394284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394290 */     // GIR_Coverage, 65175,
     /* 2394290 */     GIR_EraseRootFromParent_Done,
     /* 2394291 */   // Label 34411: @2394291
     /* 2394291 */   GIM_Try, /*On fail goto*//*Label 34412*/ GIMT_Encode4(2394348), // Rule ID 65182 //
     /* 2394296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394330 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2394333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2394341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394347 */     // GIR_Coverage, 65182,
     /* 2394347 */     GIR_EraseRootFromParent_Done,
     /* 2394348 */   // Label 34412: @2394348
     /* 2394348 */   GIM_Try, /*On fail goto*//*Label 34413*/ GIMT_Encode4(2394405), // Rule ID 65186 //
     /* 2394353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394387 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2394390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2394398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394404 */     // GIR_Coverage, 65186,
     /* 2394404 */     GIR_EraseRootFromParent_Done,
     /* 2394405 */   // Label 34413: @2394405
     /* 2394405 */   GIM_Try, /*On fail goto*//*Label 34414*/ GIMT_Encode4(2394462), // Rule ID 65187 //
     /* 2394410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394444 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2394447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2394455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394461 */     // GIR_Coverage, 65187,
     /* 2394461 */     GIR_EraseRootFromParent_Done,
     /* 2394462 */   // Label 34414: @2394462
     /* 2394462 */   GIM_Try, /*On fail goto*//*Label 34415*/ GIMT_Encode4(2394519), // Rule ID 1629 //
     /* 2394467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394501 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2394504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2394514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394518 */     // GIR_Coverage, 1629,
     /* 2394518 */     GIR_EraseRootFromParent_Done,
     /* 2394519 */   // Label 34415: @2394519
     /* 2394519 */   GIM_Try, /*On fail goto*//*Label 34416*/ GIMT_Encode4(2394576), // Rule ID 1630 //
     /* 2394524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2394527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394558 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2394561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2394571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394575 */     // GIR_Coverage, 1630,
     /* 2394575 */     GIR_EraseRootFromParent_Done,
     /* 2394576 */   // Label 34416: @2394576
     /* 2394576 */   GIM_Try, /*On fail goto*//*Label 34417*/ GIMT_Encode4(2394633), // Rule ID 1657 //
     /* 2394581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394615 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2394618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2394628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394632 */     // GIR_Coverage, 1657,
     /* 2394632 */     GIR_EraseRootFromParent_Done,
     /* 2394633 */   // Label 34417: @2394633
     /* 2394633 */   GIM_Try, /*On fail goto*//*Label 34418*/ GIMT_Encode4(2394690), // Rule ID 1684 //
     /* 2394638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394672 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2394675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2394685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394689 */     // GIR_Coverage, 1684,
     /* 2394689 */     GIR_EraseRootFromParent_Done,
     /* 2394690 */   // Label 34418: @2394690
     /* 2394690 */   GIM_Try, /*On fail goto*//*Label 34419*/ GIMT_Encode4(2394747), // Rule ID 1685 //
     /* 2394695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394729 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2394732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2394742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394746 */     // GIR_Coverage, 1685,
     /* 2394746 */     GIR_EraseRootFromParent_Done,
     /* 2394747 */   // Label 34419: @2394747
     /* 2394747 */   GIM_Try, /*On fail goto*//*Label 34420*/ GIMT_Encode4(2394787), // Rule ID 1625 //
     /* 2394752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394771 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2394774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394786 */     // GIR_Coverage, 1625,
     /* 2394786 */     GIR_EraseRootFromParent_Done,
     /* 2394787 */   // Label 34420: @2394787
     /* 2394787 */   GIM_Try, /*On fail goto*//*Label 34421*/ GIMT_Encode4(2394827), // Rule ID 1626 //
     /* 2394792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2394795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394811 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2394814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394826 */     // GIR_Coverage, 1626,
     /* 2394826 */     GIR_EraseRootFromParent_Done,
     /* 2394827 */   // Label 34421: @2394827
     /* 2394827 */   GIM_Try, /*On fail goto*//*Label 34422*/ GIMT_Encode4(2394867), // Rule ID 1655 //
     /* 2394832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394851 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2394854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394866 */     // GIR_Coverage, 1655,
     /* 2394866 */     GIR_EraseRootFromParent_Done,
     /* 2394867 */   // Label 34422: @2394867
     /* 2394867 */   GIM_Try, /*On fail goto*//*Label 34423*/ GIMT_Encode4(2394907), // Rule ID 1680 //
     /* 2394872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394891 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2394891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2394894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394906 */     // GIR_Coverage, 1680,
     /* 2394906 */     GIR_EraseRootFromParent_Done,
     /* 2394907 */   // Label 34423: @2394907
     /* 2394907 */   GIM_Try, /*On fail goto*//*Label 34424*/ GIMT_Encode4(2394947), // Rule ID 1681 //
     /* 2394912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394931 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2394931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2394934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2394942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394946 */     // GIR_Coverage, 1681,
     /* 2394946 */     GIR_EraseRootFromParent_Done,
     /* 2394947 */   // Label 34424: @2394947
     /* 2394947 */   GIM_Reject,
     /* 2394948 */ // Label 34394: @2394948
     /* 2394948 */ GIM_Reject,
     /* 2394949 */ // Label 34328: @2394949
     /* 2394949 */ GIM_Try, /*On fail goto*//*Label 34425*/ GIMT_Encode4(2395738),
     /* 2394954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2394957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2394960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2394963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394967 */   GIM_Try, /*On fail goto*//*Label 34426*/ GIMT_Encode4(2395044), // Rule ID 54828 //
     /* 2394972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2394987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395015 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2395018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395043 */     // GIR_Coverage, 54828,
     /* 2395043 */     GIR_EraseRootFromParent_Done,
     /* 2395044 */   // Label 34426: @2395044
     /* 2395044 */   GIM_Try, /*On fail goto*//*Label 34427*/ GIMT_Encode4(2395121), // Rule ID 54829 //
     /* 2395049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395092 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2395095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395120 */     // GIR_Coverage, 54829,
     /* 2395120 */     GIR_EraseRootFromParent_Done,
     /* 2395121 */   // Label 34427: @2395121
     /* 2395121 */   GIM_Try, /*On fail goto*//*Label 34428*/ GIMT_Encode4(2395198), // Rule ID 72160 //
     /* 2395126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395169 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2395172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395197 */     // GIR_Coverage, 72160,
     /* 2395197 */     GIR_EraseRootFromParent_Done,
     /* 2395198 */   // Label 34428: @2395198
     /* 2395198 */   GIM_Try, /*On fail goto*//*Label 34429*/ GIMT_Encode4(2395275), // Rule ID 72161 //
     /* 2395203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395246 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2395249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395274 */     // GIR_Coverage, 72161,
     /* 2395274 */     GIR_EraseRootFromParent_Done,
     /* 2395275 */   // Label 34429: @2395275
     /* 2395275 */   GIM_Try, /*On fail goto*//*Label 34430*/ GIMT_Encode4(2395337), // Rule ID 54832 //
     /* 2395280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395310 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2395313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395336 */     // GIR_Coverage, 54832,
     /* 2395336 */     GIR_EraseRootFromParent_Done,
     /* 2395337 */   // Label 34430: @2395337
     /* 2395337 */   GIM_Try, /*On fail goto*//*Label 34431*/ GIMT_Encode4(2395399), // Rule ID 54833 //
     /* 2395342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395372 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2395375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395398 */     // GIR_Coverage, 54833,
     /* 2395398 */     GIR_EraseRootFromParent_Done,
     /* 2395399 */   // Label 34431: @2395399
     /* 2395399 */   GIM_Try, /*On fail goto*//*Label 34432*/ GIMT_Encode4(2395461), // Rule ID 72164 //
     /* 2395404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395434 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2395437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395460 */     // GIR_Coverage, 72164,
     /* 2395460 */     GIR_EraseRootFromParent_Done,
     /* 2395461 */   // Label 34432: @2395461
     /* 2395461 */   GIM_Try, /*On fail goto*//*Label 34433*/ GIMT_Encode4(2395523), // Rule ID 72165 //
     /* 2395466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395496 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2395499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395522 */     // GIR_Coverage, 72165,
     /* 2395522 */     GIR_EraseRootFromParent_Done,
     /* 2395523 */   // Label 34433: @2395523
     /* 2395523 */   GIM_Try, /*On fail goto*//*Label 34434*/ GIMT_Encode4(2395585), // Rule ID 54824 //
     /* 2395528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2395543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395558 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2395561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2395571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395584 */     // GIR_Coverage, 54824,
     /* 2395584 */     GIR_EraseRootFromParent_Done,
     /* 2395585 */   // Label 34434: @2395585
     /* 2395585 */   GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2395647), // Rule ID 54825 //
     /* 2395590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2395605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2395613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395620 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2395623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2395633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395646 */     // GIR_Coverage, 54825,
     /* 2395646 */     GIR_EraseRootFromParent_Done,
     /* 2395647 */   // Label 34435: @2395647
     /* 2395647 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2395692), // Rule ID 54820 //
     /* 2395652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395667 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2395670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395691 */     // GIR_Coverage, 54820,
     /* 2395691 */     GIR_EraseRootFromParent_Done,
     /* 2395692 */   // Label 34436: @2395692
     /* 2395692 */   GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2395737), // Rule ID 54821 //
     /* 2395697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395712 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2395715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395736 */     // GIR_Coverage, 54821,
     /* 2395736 */     GIR_EraseRootFromParent_Done,
     /* 2395737 */   // Label 34437: @2395737
     /* 2395737 */   GIM_Reject,
     /* 2395738 */ // Label 34425: @2395738
     /* 2395738 */ GIM_Reject,
     /* 2395739 */ // Label 34329: @2395739
     /* 2395739 */ GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2396528),
     /* 2395744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2395750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2395753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395757 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2395834), // Rule ID 54956 //
     /* 2395762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395805 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2395808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395833 */     // GIR_Coverage, 54956,
     /* 2395833 */     GIR_EraseRootFromParent_Done,
     /* 2395834 */   // Label 34439: @2395834
     /* 2395834 */   GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2395911), // Rule ID 54957 //
     /* 2395839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395882 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2395885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395910 */     // GIR_Coverage, 54957,
     /* 2395910 */     GIR_EraseRootFromParent_Done,
     /* 2395911 */   // Label 34440: @2395911
     /* 2395911 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2395988), // Rule ID 72272 //
     /* 2395916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2395952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395959 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2395962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395987 */     // GIR_Coverage, 72272,
     /* 2395987 */     GIR_EraseRootFromParent_Done,
     /* 2395988 */   // Label 34441: @2395988
     /* 2395988 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2396065), // Rule ID 72273 //
     /* 2395993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396036 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2396039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396064 */     // GIR_Coverage, 72273,
     /* 2396064 */     GIR_EraseRootFromParent_Done,
     /* 2396065 */   // Label 34442: @2396065
     /* 2396065 */   GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2396127), // Rule ID 54960 //
     /* 2396070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396100 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2396103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396126 */     // GIR_Coverage, 54960,
     /* 2396126 */     GIR_EraseRootFromParent_Done,
     /* 2396127 */   // Label 34443: @2396127
     /* 2396127 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2396189), // Rule ID 54961 //
     /* 2396132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396162 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2396165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396188 */     // GIR_Coverage, 54961,
     /* 2396188 */     GIR_EraseRootFromParent_Done,
     /* 2396189 */   // Label 34444: @2396189
     /* 2396189 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2396251), // Rule ID 72276 //
     /* 2396194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396224 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2396227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396250 */     // GIR_Coverage, 72276,
     /* 2396250 */     GIR_EraseRootFromParent_Done,
     /* 2396251 */   // Label 34445: @2396251
     /* 2396251 */   GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2396313), // Rule ID 72277 //
     /* 2396256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396286 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2396289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396312 */     // GIR_Coverage, 72277,
     /* 2396312 */     GIR_EraseRootFromParent_Done,
     /* 2396313 */   // Label 34446: @2396313
     /* 2396313 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2396375), // Rule ID 54952 //
     /* 2396318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2396333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396348 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2396351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2396361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396374 */     // GIR_Coverage, 54952,
     /* 2396374 */     GIR_EraseRootFromParent_Done,
     /* 2396375 */   // Label 34447: @2396375
     /* 2396375 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2396437), // Rule ID 54953 //
     /* 2396380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2396395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2396403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396410 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2396413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2396423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396436 */     // GIR_Coverage, 54953,
     /* 2396436 */     GIR_EraseRootFromParent_Done,
     /* 2396437 */   // Label 34448: @2396437
     /* 2396437 */   GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2396482), // Rule ID 54948 //
     /* 2396442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396457 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2396460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396481 */     // GIR_Coverage, 54948,
     /* 2396481 */     GIR_EraseRootFromParent_Done,
     /* 2396482 */   // Label 34449: @2396482
     /* 2396482 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2396527), // Rule ID 54949 //
     /* 2396487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396502 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2396505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396526 */     // GIR_Coverage, 54949,
     /* 2396526 */     GIR_EraseRootFromParent_Done,
     /* 2396527 */   // Label 34450: @2396527
     /* 2396527 */   GIM_Reject,
     /* 2396528 */ // Label 34438: @2396528
     /* 2396528 */ GIM_Reject,
     /* 2396529 */ // Label 34330: @2396529
     /* 2396529 */ GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2397318),
     /* 2396534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2396540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2396543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396547 */   GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2396624), // Rule ID 55148 //
     /* 2396552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396595 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2396598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396623 */     // GIR_Coverage, 55148,
     /* 2396623 */     GIR_EraseRootFromParent_Done,
     /* 2396624 */   // Label 34452: @2396624
     /* 2396624 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2396701), // Rule ID 55149 //
     /* 2396629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396672 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2396675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396700 */     // GIR_Coverage, 55149,
     /* 2396700 */     GIR_EraseRootFromParent_Done,
     /* 2396701 */   // Label 34453: @2396701
     /* 2396701 */   GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2396778), // Rule ID 72440 //
     /* 2396706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396749 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2396752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396777 */     // GIR_Coverage, 72440,
     /* 2396777 */     GIR_EraseRootFromParent_Done,
     /* 2396778 */   // Label 34454: @2396778
     /* 2396778 */   GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2396855), // Rule ID 72441 //
     /* 2396783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396826 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2396829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396854 */     // GIR_Coverage, 72441,
     /* 2396854 */     GIR_EraseRootFromParent_Done,
     /* 2396855 */   // Label 34455: @2396855
     /* 2396855 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2396917), // Rule ID 55152 //
     /* 2396860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396890 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2396893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396916 */     // GIR_Coverage, 55152,
     /* 2396916 */     GIR_EraseRootFromParent_Done,
     /* 2396917 */   // Label 34456: @2396917
     /* 2396917 */   GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2396979), // Rule ID 55153 //
     /* 2396922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2396937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396952 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2396955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396978 */     // GIR_Coverage, 55153,
     /* 2396978 */     GIR_EraseRootFromParent_Done,
     /* 2396979 */   // Label 34457: @2396979
     /* 2396979 */   GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2397041), // Rule ID 72444 //
     /* 2396984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397014 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2397017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397040 */     // GIR_Coverage, 72444,
     /* 2397040 */     GIR_EraseRootFromParent_Done,
     /* 2397041 */   // Label 34458: @2397041
     /* 2397041 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2397103), // Rule ID 72445 //
     /* 2397046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397076 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2397079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397102 */     // GIR_Coverage, 72445,
     /* 2397102 */     GIR_EraseRootFromParent_Done,
     /* 2397103 */   // Label 34459: @2397103
     /* 2397103 */   GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2397165), // Rule ID 55144 //
     /* 2397108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397138 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2397141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2397151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397164 */     // GIR_Coverage, 55144,
     /* 2397164 */     GIR_EraseRootFromParent_Done,
     /* 2397165 */   // Label 34460: @2397165
     /* 2397165 */   GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2397227), // Rule ID 55145 //
     /* 2397170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397200 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2397203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2397213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397226 */     // GIR_Coverage, 55145,
     /* 2397226 */     GIR_EraseRootFromParent_Done,
     /* 2397227 */   // Label 34461: @2397227
     /* 2397227 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2397272), // Rule ID 55140 //
     /* 2397232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397247 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2397250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397271 */     // GIR_Coverage, 55140,
     /* 2397271 */     GIR_EraseRootFromParent_Done,
     /* 2397272 */   // Label 34462: @2397272
     /* 2397272 */   GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2397317), // Rule ID 55141 //
     /* 2397277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397292 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2397295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397316 */     // GIR_Coverage, 55141,
     /* 2397316 */     GIR_EraseRootFromParent_Done,
     /* 2397317 */   // Label 34463: @2397317
     /* 2397317 */   GIM_Reject,
     /* 2397318 */ // Label 34451: @2397318
     /* 2397318 */ GIM_Reject,
     /* 2397319 */ // Label 34331: @2397319
     /* 2397319 */ GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2398108),
     /* 2397324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2397330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2397333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397337 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2397414), // Rule ID 54892 //
     /* 2397342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397385 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2397388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397413 */     // GIR_Coverage, 54892,
     /* 2397413 */     GIR_EraseRootFromParent_Done,
     /* 2397414 */   // Label 34465: @2397414
     /* 2397414 */   GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2397491), // Rule ID 54893 //
     /* 2397419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397462 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2397465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397490 */     // GIR_Coverage, 54893,
     /* 2397490 */     GIR_EraseRootFromParent_Done,
     /* 2397491 */   // Label 34466: @2397491
     /* 2397491 */   GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2397568), // Rule ID 72216 //
     /* 2397496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397539 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2397542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397567 */     // GIR_Coverage, 72216,
     /* 2397567 */     GIR_EraseRootFromParent_Done,
     /* 2397568 */   // Label 34467: @2397568
     /* 2397568 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2397645), // Rule ID 72217 //
     /* 2397573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397616 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2397619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397644 */     // GIR_Coverage, 72217,
     /* 2397644 */     GIR_EraseRootFromParent_Done,
     /* 2397645 */   // Label 34468: @2397645
     /* 2397645 */   GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2397707), // Rule ID 54896 //
     /* 2397650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397680 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2397683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397706 */     // GIR_Coverage, 54896,
     /* 2397706 */     GIR_EraseRootFromParent_Done,
     /* 2397707 */   // Label 34469: @2397707
     /* 2397707 */   GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2397769), // Rule ID 54897 //
     /* 2397712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397742 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2397745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397768 */     // GIR_Coverage, 54897,
     /* 2397768 */     GIR_EraseRootFromParent_Done,
     /* 2397769 */   // Label 34470: @2397769
     /* 2397769 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2397831), // Rule ID 72220 //
     /* 2397774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397804 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2397807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397830 */     // GIR_Coverage, 72220,
     /* 2397830 */     GIR_EraseRootFromParent_Done,
     /* 2397831 */   // Label 34471: @2397831
     /* 2397831 */   GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2397893), // Rule ID 72221 //
     /* 2397836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397866 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2397869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397892 */     // GIR_Coverage, 72221,
     /* 2397892 */     GIR_EraseRootFromParent_Done,
     /* 2397893 */   // Label 34472: @2397893
     /* 2397893 */   GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2397955), // Rule ID 54888 //
     /* 2397898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397928 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2397931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2397941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397954 */     // GIR_Coverage, 54888,
     /* 2397954 */     GIR_EraseRootFromParent_Done,
     /* 2397955 */   // Label 34473: @2397955
     /* 2397955 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2398017), // Rule ID 54889 //
     /* 2397960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397990 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2397993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2398003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398016 */     // GIR_Coverage, 54889,
     /* 2398016 */     GIR_EraseRootFromParent_Done,
     /* 2398017 */   // Label 34474: @2398017
     /* 2398017 */   GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2398062), // Rule ID 54884 //
     /* 2398022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398037 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2398040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398061 */     // GIR_Coverage, 54884,
     /* 2398061 */     GIR_EraseRootFromParent_Done,
     /* 2398062 */   // Label 34475: @2398062
     /* 2398062 */   GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2398107), // Rule ID 54885 //
     /* 2398067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398082 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2398085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398106 */     // GIR_Coverage, 54885,
     /* 2398106 */     GIR_EraseRootFromParent_Done,
     /* 2398107 */   // Label 34476: @2398107
     /* 2398107 */   GIM_Reject,
     /* 2398108 */ // Label 34464: @2398108
     /* 2398108 */ GIM_Reject,
     /* 2398109 */ // Label 34332: @2398109
     /* 2398109 */ GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2398898),
     /* 2398114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2398120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2398123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398127 */   GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2398204), // Rule ID 55084 //
     /* 2398132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398175 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2398178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398203 */     // GIR_Coverage, 55084,
     /* 2398203 */     GIR_EraseRootFromParent_Done,
     /* 2398204 */   // Label 34478: @2398204
     /* 2398204 */   GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2398281), // Rule ID 55085 //
     /* 2398209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398252 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2398255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398280 */     // GIR_Coverage, 55085,
     /* 2398280 */     GIR_EraseRootFromParent_Done,
     /* 2398281 */   // Label 34479: @2398281
     /* 2398281 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2398358), // Rule ID 72384 //
     /* 2398286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398329 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2398332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398357 */     // GIR_Coverage, 72384,
     /* 2398357 */     GIR_EraseRootFromParent_Done,
     /* 2398358 */   // Label 34480: @2398358
     /* 2398358 */   GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2398435), // Rule ID 72385 //
     /* 2398363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398406 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2398409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398434 */     // GIR_Coverage, 72385,
     /* 2398434 */     GIR_EraseRootFromParent_Done,
     /* 2398435 */   // Label 34481: @2398435
     /* 2398435 */   GIM_Try, /*On fail goto*//*Label 34482*/ GIMT_Encode4(2398497), // Rule ID 55088 //
     /* 2398440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398470 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2398473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398496 */     // GIR_Coverage, 55088,
     /* 2398496 */     GIR_EraseRootFromParent_Done,
     /* 2398497 */   // Label 34482: @2398497
     /* 2398497 */   GIM_Try, /*On fail goto*//*Label 34483*/ GIMT_Encode4(2398559), // Rule ID 55089 //
     /* 2398502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398532 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2398535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398558 */     // GIR_Coverage, 55089,
     /* 2398558 */     GIR_EraseRootFromParent_Done,
     /* 2398559 */   // Label 34483: @2398559
     /* 2398559 */   GIM_Try, /*On fail goto*//*Label 34484*/ GIMT_Encode4(2398621), // Rule ID 72388 //
     /* 2398564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398594 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2398597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398620 */     // GIR_Coverage, 72388,
     /* 2398620 */     GIR_EraseRootFromParent_Done,
     /* 2398621 */   // Label 34484: @2398621
     /* 2398621 */   GIM_Try, /*On fail goto*//*Label 34485*/ GIMT_Encode4(2398683), // Rule ID 72389 //
     /* 2398626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398656 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2398659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398682 */     // GIR_Coverage, 72389,
     /* 2398682 */     GIR_EraseRootFromParent_Done,
     /* 2398683 */   // Label 34485: @2398683
     /* 2398683 */   GIM_Try, /*On fail goto*//*Label 34486*/ GIMT_Encode4(2398745), // Rule ID 55080 //
     /* 2398688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2398703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398718 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2398721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2398731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398744 */     // GIR_Coverage, 55080,
     /* 2398744 */     GIR_EraseRootFromParent_Done,
     /* 2398745 */   // Label 34486: @2398745
     /* 2398745 */   GIM_Try, /*On fail goto*//*Label 34487*/ GIMT_Encode4(2398807), // Rule ID 55081 //
     /* 2398750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2398765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2398773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398780 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2398783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2398793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398806 */     // GIR_Coverage, 55081,
     /* 2398806 */     GIR_EraseRootFromParent_Done,
     /* 2398807 */   // Label 34487: @2398807
     /* 2398807 */   GIM_Try, /*On fail goto*//*Label 34488*/ GIMT_Encode4(2398852), // Rule ID 55076 //
     /* 2398812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398827 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2398830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398851 */     // GIR_Coverage, 55076,
     /* 2398851 */     GIR_EraseRootFromParent_Done,
     /* 2398852 */   // Label 34488: @2398852
     /* 2398852 */   GIM_Try, /*On fail goto*//*Label 34489*/ GIMT_Encode4(2398897), // Rule ID 55077 //
     /* 2398857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2398872 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2398875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398896 */     // GIR_Coverage, 55077,
     /* 2398896 */     GIR_EraseRootFromParent_Done,
     /* 2398897 */   // Label 34489: @2398897
     /* 2398897 */   GIM_Reject,
     /* 2398898 */ // Label 34477: @2398898
     /* 2398898 */ GIM_Reject,
     /* 2398899 */ // Label 34333: @2398899
     /* 2398899 */ GIM_Try, /*On fail goto*//*Label 34490*/ GIMT_Encode4(2399688),
     /* 2398904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2398907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2398910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2398913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398917 */   GIM_Try, /*On fail goto*//*Label 34491*/ GIMT_Encode4(2398994), // Rule ID 55596 //
     /* 2398922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2398937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2398958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398965 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2398968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398993 */     // GIR_Coverage, 55596,
     /* 2398993 */     GIR_EraseRootFromParent_Done,
     /* 2398994 */   // Label 34491: @2398994
     /* 2398994 */   GIM_Try, /*On fail goto*//*Label 34492*/ GIMT_Encode4(2399071), // Rule ID 55597 //
     /* 2398999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399042 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2399045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399070 */     // GIR_Coverage, 55597,
     /* 2399070 */     GIR_EraseRootFromParent_Done,
     /* 2399071 */   // Label 34492: @2399071
     /* 2399071 */   GIM_Try, /*On fail goto*//*Label 34493*/ GIMT_Encode4(2399148), // Rule ID 72832 //
     /* 2399076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399119 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2399122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399147 */     // GIR_Coverage, 72832,
     /* 2399147 */     GIR_EraseRootFromParent_Done,
     /* 2399148 */   // Label 34493: @2399148
     /* 2399148 */   GIM_Try, /*On fail goto*//*Label 34494*/ GIMT_Encode4(2399225), // Rule ID 72833 //
     /* 2399153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399196 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2399199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399224 */     // GIR_Coverage, 72833,
     /* 2399224 */     GIR_EraseRootFromParent_Done,
     /* 2399225 */   // Label 34494: @2399225
     /* 2399225 */   GIM_Try, /*On fail goto*//*Label 34495*/ GIMT_Encode4(2399287), // Rule ID 55600 //
     /* 2399230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399260 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2399263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399286 */     // GIR_Coverage, 55600,
     /* 2399286 */     GIR_EraseRootFromParent_Done,
     /* 2399287 */   // Label 34495: @2399287
     /* 2399287 */   GIM_Try, /*On fail goto*//*Label 34496*/ GIMT_Encode4(2399349), // Rule ID 55601 //
     /* 2399292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399322 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2399325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399348 */     // GIR_Coverage, 55601,
     /* 2399348 */     GIR_EraseRootFromParent_Done,
     /* 2399349 */   // Label 34496: @2399349
     /* 2399349 */   GIM_Try, /*On fail goto*//*Label 34497*/ GIMT_Encode4(2399411), // Rule ID 72836 //
     /* 2399354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399384 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2399387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399410 */     // GIR_Coverage, 72836,
     /* 2399410 */     GIR_EraseRootFromParent_Done,
     /* 2399411 */   // Label 34497: @2399411
     /* 2399411 */   GIM_Try, /*On fail goto*//*Label 34498*/ GIMT_Encode4(2399473), // Rule ID 72837 //
     /* 2399416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399446 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2399449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399472 */     // GIR_Coverage, 72837,
     /* 2399472 */     GIR_EraseRootFromParent_Done,
     /* 2399473 */   // Label 34498: @2399473
     /* 2399473 */   GIM_Try, /*On fail goto*//*Label 34499*/ GIMT_Encode4(2399535), // Rule ID 55592 //
     /* 2399478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399508 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2399511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2399521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399534 */     // GIR_Coverage, 55592,
     /* 2399534 */     GIR_EraseRootFromParent_Done,
     /* 2399535 */   // Label 34499: @2399535
     /* 2399535 */   GIM_Try, /*On fail goto*//*Label 34500*/ GIMT_Encode4(2399597), // Rule ID 55593 //
     /* 2399540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2399563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399570 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2399573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2399583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399596 */     // GIR_Coverage, 55593,
     /* 2399596 */     GIR_EraseRootFromParent_Done,
     /* 2399597 */   // Label 34500: @2399597
     /* 2399597 */   GIM_Try, /*On fail goto*//*Label 34501*/ GIMT_Encode4(2399642), // Rule ID 55588 //
     /* 2399602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399617 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2399620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399641 */     // GIR_Coverage, 55588,
     /* 2399641 */     GIR_EraseRootFromParent_Done,
     /* 2399642 */   // Label 34501: @2399642
     /* 2399642 */   GIM_Try, /*On fail goto*//*Label 34502*/ GIMT_Encode4(2399687), // Rule ID 55589 //
     /* 2399647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2399662 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2399665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399686 */     // GIR_Coverage, 55589,
     /* 2399686 */     GIR_EraseRootFromParent_Done,
     /* 2399687 */   // Label 34502: @2399687
     /* 2399687 */   GIM_Reject,
     /* 2399688 */ // Label 34490: @2399688
     /* 2399688 */ GIM_Reject,
     /* 2399689 */ // Label 34334: @2399689
     /* 2399689 */ GIM_Try, /*On fail goto*//*Label 34503*/ GIMT_Encode4(2400478),
     /* 2399694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2399700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2399703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399707 */   GIM_Try, /*On fail goto*//*Label 34504*/ GIMT_Encode4(2399784), // Rule ID 55020 //
     /* 2399712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399755 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2399758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399783 */     // GIR_Coverage, 55020,
     /* 2399783 */     GIR_EraseRootFromParent_Done,
     /* 2399784 */   // Label 34504: @2399784
     /* 2399784 */   GIM_Try, /*On fail goto*//*Label 34505*/ GIMT_Encode4(2399861), // Rule ID 55021 //
     /* 2399789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399832 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2399835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399860 */     // GIR_Coverage, 55021,
     /* 2399860 */     GIR_EraseRootFromParent_Done,
     /* 2399861 */   // Label 34505: @2399861
     /* 2399861 */   GIM_Try, /*On fail goto*//*Label 34506*/ GIMT_Encode4(2399938), // Rule ID 72328 //
     /* 2399866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399909 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2399912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399937 */     // GIR_Coverage, 72328,
     /* 2399937 */     GIR_EraseRootFromParent_Done,
     /* 2399938 */   // Label 34506: @2399938
     /* 2399938 */   GIM_Try, /*On fail goto*//*Label 34507*/ GIMT_Encode4(2400015), // Rule ID 72329 //
     /* 2399943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2399979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399986 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2399989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400014 */     // GIR_Coverage, 72329,
     /* 2400014 */     GIR_EraseRootFromParent_Done,
     /* 2400015 */   // Label 34507: @2400015
     /* 2400015 */   GIM_Try, /*On fail goto*//*Label 34508*/ GIMT_Encode4(2400077), // Rule ID 55024 //
     /* 2400020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400050 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2400053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400076 */     // GIR_Coverage, 55024,
     /* 2400076 */     GIR_EraseRootFromParent_Done,
     /* 2400077 */   // Label 34508: @2400077
     /* 2400077 */   GIM_Try, /*On fail goto*//*Label 34509*/ GIMT_Encode4(2400139), // Rule ID 55025 //
     /* 2400082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400112 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2400115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400138 */     // GIR_Coverage, 55025,
     /* 2400138 */     GIR_EraseRootFromParent_Done,
     /* 2400139 */   // Label 34509: @2400139
     /* 2400139 */   GIM_Try, /*On fail goto*//*Label 34510*/ GIMT_Encode4(2400201), // Rule ID 72332 //
     /* 2400144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400174 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2400177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400200 */     // GIR_Coverage, 72332,
     /* 2400200 */     GIR_EraseRootFromParent_Done,
     /* 2400201 */   // Label 34510: @2400201
     /* 2400201 */   GIM_Try, /*On fail goto*//*Label 34511*/ GIMT_Encode4(2400263), // Rule ID 72333 //
     /* 2400206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400236 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2400239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400262 */     // GIR_Coverage, 72333,
     /* 2400262 */     GIR_EraseRootFromParent_Done,
     /* 2400263 */   // Label 34511: @2400263
     /* 2400263 */   GIM_Try, /*On fail goto*//*Label 34512*/ GIMT_Encode4(2400325), // Rule ID 55016 //
     /* 2400268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2400283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400298 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2400301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2400311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400324 */     // GIR_Coverage, 55016,
     /* 2400324 */     GIR_EraseRootFromParent_Done,
     /* 2400325 */   // Label 34512: @2400325
     /* 2400325 */   GIM_Try, /*On fail goto*//*Label 34513*/ GIMT_Encode4(2400387), // Rule ID 55017 //
     /* 2400330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2400345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400360 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2400363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2400373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400386 */     // GIR_Coverage, 55017,
     /* 2400386 */     GIR_EraseRootFromParent_Done,
     /* 2400387 */   // Label 34513: @2400387
     /* 2400387 */   GIM_Try, /*On fail goto*//*Label 34514*/ GIMT_Encode4(2400432), // Rule ID 55012 //
     /* 2400392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400407 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2400410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400431 */     // GIR_Coverage, 55012,
     /* 2400431 */     GIR_EraseRootFromParent_Done,
     /* 2400432 */   // Label 34514: @2400432
     /* 2400432 */   GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2400477), // Rule ID 55013 //
     /* 2400437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400452 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2400455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400476 */     // GIR_Coverage, 55013,
     /* 2400476 */     GIR_EraseRootFromParent_Done,
     /* 2400477 */   // Label 34515: @2400477
     /* 2400477 */   GIM_Reject,
     /* 2400478 */ // Label 34503: @2400478
     /* 2400478 */ GIM_Reject,
     /* 2400479 */ // Label 34335: @2400479
     /* 2400479 */ GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2401268),
     /* 2400484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2400490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2400493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400497 */   GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2400574), // Rule ID 55404 //
     /* 2400502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400545 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2400548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400573 */     // GIR_Coverage, 55404,
     /* 2400573 */     GIR_EraseRootFromParent_Done,
     /* 2400574 */   // Label 34517: @2400574
     /* 2400574 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2400651), // Rule ID 55405 //
     /* 2400579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400622 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2400625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400650 */     // GIR_Coverage, 55405,
     /* 2400650 */     GIR_EraseRootFromParent_Done,
     /* 2400651 */   // Label 34518: @2400651
     /* 2400651 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2400728), // Rule ID 72664 //
     /* 2400656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400699 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2400702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400727 */     // GIR_Coverage, 72664,
     /* 2400727 */     GIR_EraseRootFromParent_Done,
     /* 2400728 */   // Label 34519: @2400728
     /* 2400728 */   GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2400805), // Rule ID 72665 //
     /* 2400733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400776 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2400779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400804 */     // GIR_Coverage, 72665,
     /* 2400804 */     GIR_EraseRootFromParent_Done,
     /* 2400805 */   // Label 34520: @2400805
     /* 2400805 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2400867), // Rule ID 55408 //
     /* 2400810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400840 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2400843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400866 */     // GIR_Coverage, 55408,
     /* 2400866 */     GIR_EraseRootFromParent_Done,
     /* 2400867 */   // Label 34521: @2400867
     /* 2400867 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2400929), // Rule ID 55409 //
     /* 2400872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400902 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2400905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400928 */     // GIR_Coverage, 55409,
     /* 2400928 */     GIR_EraseRootFromParent_Done,
     /* 2400929 */   // Label 34522: @2400929
     /* 2400929 */   GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2400991), // Rule ID 72668 //
     /* 2400934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400964 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2400967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400990 */     // GIR_Coverage, 72668,
     /* 2400990 */     GIR_EraseRootFromParent_Done,
     /* 2400991 */   // Label 34523: @2400991
     /* 2400991 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2401053), // Rule ID 72669 //
     /* 2400996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2401015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401026 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2401029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401052 */     // GIR_Coverage, 72669,
     /* 2401052 */     GIR_EraseRootFromParent_Done,
     /* 2401053 */   // Label 34524: @2401053
     /* 2401053 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2401115), // Rule ID 55400 //
     /* 2401058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2401081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401088 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2401091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401114 */     // GIR_Coverage, 55400,
     /* 2401114 */     GIR_EraseRootFromParent_Done,
     /* 2401115 */   // Label 34525: @2401115
     /* 2401115 */   GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2401177), // Rule ID 55401 //
     /* 2401120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2401143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401150 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2401153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401176 */     // GIR_Coverage, 55401,
     /* 2401176 */     GIR_EraseRootFromParent_Done,
     /* 2401177 */   // Label 34526: @2401177
     /* 2401177 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2401222), // Rule ID 55396 //
     /* 2401182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401197 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2401200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401221 */     // GIR_Coverage, 55396,
     /* 2401221 */     GIR_EraseRootFromParent_Done,
     /* 2401222 */   // Label 34527: @2401222
     /* 2401222 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2401267), // Rule ID 55397 //
     /* 2401227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2401242 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2401245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401266 */     // GIR_Coverage, 55397,
     /* 2401266 */     GIR_EraseRootFromParent_Done,
     /* 2401267 */   // Label 34528: @2401267
     /* 2401267 */   GIM_Reject,
     /* 2401268 */ // Label 34516: @2401268
     /* 2401268 */ GIM_Reject,
     /* 2401269 */ // Label 34336: @2401269
     /* 2401269 */ GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2402058),
     /* 2401274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2401280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2401283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401287 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2401364), // Rule ID 55660 //
     /* 2401292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401335 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2401338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401363 */     // GIR_Coverage, 55660,
     /* 2401363 */     GIR_EraseRootFromParent_Done,
     /* 2401364 */   // Label 34530: @2401364
     /* 2401364 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2401441), // Rule ID 55661 //
     /* 2401369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401412 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2401415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401440 */     // GIR_Coverage, 55661,
     /* 2401440 */     GIR_EraseRootFromParent_Done,
     /* 2401441 */   // Label 34531: @2401441
     /* 2401441 */   GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2401518), // Rule ID 72888 //
     /* 2401446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401489 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2401492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401517 */     // GIR_Coverage, 72888,
     /* 2401517 */     GIR_EraseRootFromParent_Done,
     /* 2401518 */   // Label 34532: @2401518
     /* 2401518 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2401595), // Rule ID 72889 //
     /* 2401523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401566 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2401569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401594 */     // GIR_Coverage, 72889,
     /* 2401594 */     GIR_EraseRootFromParent_Done,
     /* 2401595 */   // Label 34533: @2401595
     /* 2401595 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2401657), // Rule ID 55664 //
     /* 2401600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401630 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2401633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401656 */     // GIR_Coverage, 55664,
     /* 2401656 */     GIR_EraseRootFromParent_Done,
     /* 2401657 */   // Label 34534: @2401657
     /* 2401657 */   GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2401719), // Rule ID 55665 //
     /* 2401662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401692 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2401695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401718 */     // GIR_Coverage, 55665,
     /* 2401718 */     GIR_EraseRootFromParent_Done,
     /* 2401719 */   // Label 34535: @2401719
     /* 2401719 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2401781), // Rule ID 72892 //
     /* 2401724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401754 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2401757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401780 */     // GIR_Coverage, 72892,
     /* 2401780 */     GIR_EraseRootFromParent_Done,
     /* 2401781 */   // Label 34536: @2401781
     /* 2401781 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2401843), // Rule ID 72893 //
     /* 2401786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401816 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2401819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401842 */     // GIR_Coverage, 72893,
     /* 2401842 */     GIR_EraseRootFromParent_Done,
     /* 2401843 */   // Label 34537: @2401843
     /* 2401843 */   GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2401905), // Rule ID 55656 //
     /* 2401848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401878 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2401881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401904 */     // GIR_Coverage, 55656,
     /* 2401904 */     GIR_EraseRootFromParent_Done,
     /* 2401905 */   // Label 34538: @2401905
     /* 2401905 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2401967), // Rule ID 55657 //
     /* 2401910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2401913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2401933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401940 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2401943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401966 */     // GIR_Coverage, 55657,
     /* 2401966 */     GIR_EraseRootFromParent_Done,
     /* 2401967 */   // Label 34539: @2401967
     /* 2401967 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2402012), // Rule ID 55652 //
     /* 2401972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2401975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401987 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2401990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402011 */     // GIR_Coverage, 55652,
     /* 2402011 */     GIR_EraseRootFromParent_Done,
     /* 2402012 */   // Label 34540: @2402012
     /* 2402012 */   GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2402057), // Rule ID 55653 //
     /* 2402017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2402020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402032 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2402035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2402052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402056 */     // GIR_Coverage, 55653,
     /* 2402056 */     GIR_EraseRootFromParent_Done,
     /* 2402057 */   // Label 34541: @2402057
     /* 2402057 */   GIM_Reject,
     /* 2402058 */ // Label 34529: @2402058
     /* 2402058 */ GIM_Reject,
     /* 2402059 */ // Label 34337: @2402059
     /* 2402059 */ GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2402848),
     /* 2402064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2402070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2402073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402077 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2402154), // Rule ID 55212 //
     /* 2402082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402125 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2402128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402153 */     // GIR_Coverage, 55212,
     /* 2402153 */     GIR_EraseRootFromParent_Done,
     /* 2402154 */   // Label 34543: @2402154
     /* 2402154 */   GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2402231), // Rule ID 55213 //
     /* 2402159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402202 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2402205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402230 */     // GIR_Coverage, 55213,
     /* 2402230 */     GIR_EraseRootFromParent_Done,
     /* 2402231 */   // Label 34544: @2402231
     /* 2402231 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2402308), // Rule ID 72496 //
     /* 2402236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402279 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2402282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402307 */     // GIR_Coverage, 72496,
     /* 2402307 */     GIR_EraseRootFromParent_Done,
     /* 2402308 */   // Label 34545: @2402308
     /* 2402308 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2402385), // Rule ID 72497 //
     /* 2402313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402356 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2402359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402384 */     // GIR_Coverage, 72497,
     /* 2402384 */     GIR_EraseRootFromParent_Done,
     /* 2402385 */   // Label 34546: @2402385
     /* 2402385 */   GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2402447), // Rule ID 55216 //
     /* 2402390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402420 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2402423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402446 */     // GIR_Coverage, 55216,
     /* 2402446 */     GIR_EraseRootFromParent_Done,
     /* 2402447 */   // Label 34547: @2402447
     /* 2402447 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2402509), // Rule ID 55217 //
     /* 2402452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402482 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2402485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402508 */     // GIR_Coverage, 55217,
     /* 2402508 */     GIR_EraseRootFromParent_Done,
     /* 2402509 */   // Label 34548: @2402509
     /* 2402509 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2402571), // Rule ID 72500 //
     /* 2402514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402544 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2402547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402570 */     // GIR_Coverage, 72500,
     /* 2402570 */     GIR_EraseRootFromParent_Done,
     /* 2402571 */   // Label 34549: @2402571
     /* 2402571 */   GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2402633), // Rule ID 72501 //
     /* 2402576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402606 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2402609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402632 */     // GIR_Coverage, 72501,
     /* 2402632 */     GIR_EraseRootFromParent_Done,
     /* 2402633 */   // Label 34550: @2402633
     /* 2402633 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2402695), // Rule ID 55208 //
     /* 2402638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402668 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2402671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2402681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402694 */     // GIR_Coverage, 55208,
     /* 2402694 */     GIR_EraseRootFromParent_Done,
     /* 2402695 */   // Label 34551: @2402695
     /* 2402695 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2402757), // Rule ID 55209 //
     /* 2402700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2402723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402730 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2402733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2402743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402756 */     // GIR_Coverage, 55209,
     /* 2402756 */     GIR_EraseRootFromParent_Done,
     /* 2402757 */   // Label 34552: @2402757
     /* 2402757 */   GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2402802), // Rule ID 55204 //
     /* 2402762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402777 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2402780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402801 */     // GIR_Coverage, 55204,
     /* 2402801 */     GIR_EraseRootFromParent_Done,
     /* 2402802 */   // Label 34553: @2402802
     /* 2402802 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2402847), // Rule ID 55205 //
     /* 2402807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2402822 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2402825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402846 */     // GIR_Coverage, 55205,
     /* 2402846 */     GIR_EraseRootFromParent_Done,
     /* 2402847 */   // Label 34554: @2402847
     /* 2402847 */   GIM_Reject,
     /* 2402848 */ // Label 34542: @2402848
     /* 2402848 */ GIM_Reject,
     /* 2402849 */ // Label 34338: @2402849
     /* 2402849 */ GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2403638),
     /* 2402854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2402860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2402863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402867 */   GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2402944), // Rule ID 55468 //
     /* 2402872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2402875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402915 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2402918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2402939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402943 */     // GIR_Coverage, 55468,
     /* 2402943 */     GIR_EraseRootFromParent_Done,
     /* 2402944 */   // Label 34556: @2402944
     /* 2402944 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2403021), // Rule ID 55469 //
     /* 2402949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2402952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2402985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2402990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402992 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2402995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403020 */     // GIR_Coverage, 55469,
     /* 2403020 */     GIR_EraseRootFromParent_Done,
     /* 2403021 */   // Label 34557: @2403021
     /* 2403021 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2403098), // Rule ID 72720 //
     /* 2403026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403069 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2403072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403097 */     // GIR_Coverage, 72720,
     /* 2403097 */     GIR_EraseRootFromParent_Done,
     /* 2403098 */   // Label 34558: @2403098
     /* 2403098 */   GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2403175), // Rule ID 72721 //
     /* 2403103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403146 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2403149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403174 */     // GIR_Coverage, 72721,
     /* 2403174 */     GIR_EraseRootFromParent_Done,
     /* 2403175 */   // Label 34559: @2403175
     /* 2403175 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2403237), // Rule ID 55472 //
     /* 2403180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403210 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2403213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403236 */     // GIR_Coverage, 55472,
     /* 2403236 */     GIR_EraseRootFromParent_Done,
     /* 2403237 */   // Label 34560: @2403237
     /* 2403237 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2403299), // Rule ID 55473 //
     /* 2403242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403272 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2403275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403298 */     // GIR_Coverage, 55473,
     /* 2403298 */     GIR_EraseRootFromParent_Done,
     /* 2403299 */   // Label 34561: @2403299
     /* 2403299 */   GIM_Try, /*On fail goto*//*Label 34562*/ GIMT_Encode4(2403361), // Rule ID 72724 //
     /* 2403304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403334 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2403337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403360 */     // GIR_Coverage, 72724,
     /* 2403360 */     GIR_EraseRootFromParent_Done,
     /* 2403361 */   // Label 34562: @2403361
     /* 2403361 */   GIM_Try, /*On fail goto*//*Label 34563*/ GIMT_Encode4(2403423), // Rule ID 72725 //
     /* 2403366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403396 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2403399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403422 */     // GIR_Coverage, 72725,
     /* 2403422 */     GIR_EraseRootFromParent_Done,
     /* 2403423 */   // Label 34563: @2403423
     /* 2403423 */   GIM_Try, /*On fail goto*//*Label 34564*/ GIMT_Encode4(2403485), // Rule ID 55464 //
     /* 2403428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403458 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2403461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2403471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403484 */     // GIR_Coverage, 55464,
     /* 2403484 */     GIR_EraseRootFromParent_Done,
     /* 2403485 */   // Label 34564: @2403485
     /* 2403485 */   GIM_Try, /*On fail goto*//*Label 34565*/ GIMT_Encode4(2403547), // Rule ID 55465 //
     /* 2403490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2403505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2403513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403520 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2403523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2403533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403546 */     // GIR_Coverage, 55465,
     /* 2403546 */     GIR_EraseRootFromParent_Done,
     /* 2403547 */   // Label 34565: @2403547
     /* 2403547 */   GIM_Try, /*On fail goto*//*Label 34566*/ GIMT_Encode4(2403592), // Rule ID 55460 //
     /* 2403552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403567 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2403570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403591 */     // GIR_Coverage, 55460,
     /* 2403591 */     GIR_EraseRootFromParent_Done,
     /* 2403592 */   // Label 34566: @2403592
     /* 2403592 */   GIM_Try, /*On fail goto*//*Label 34567*/ GIMT_Encode4(2403637), // Rule ID 55461 //
     /* 2403597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403612 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2403615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2403623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403636 */     // GIR_Coverage, 55461,
     /* 2403636 */     GIR_EraseRootFromParent_Done,
     /* 2403637 */   // Label 34567: @2403637
     /* 2403637 */   GIM_Reject,
     /* 2403638 */ // Label 34555: @2403638
     /* 2403638 */ GIM_Reject,
     /* 2403639 */ // Label 34339: @2403639
     /* 2403639 */ GIM_Try, /*On fail goto*//*Label 34568*/ GIMT_Encode4(2404428),
     /* 2403644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2403650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2403653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403657 */   GIM_Try, /*On fail goto*//*Label 34569*/ GIMT_Encode4(2403734), // Rule ID 55724 //
     /* 2403662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403705 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2403708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403733 */     // GIR_Coverage, 55724,
     /* 2403733 */     GIR_EraseRootFromParent_Done,
     /* 2403734 */   // Label 34569: @2403734
     /* 2403734 */   GIM_Try, /*On fail goto*//*Label 34570*/ GIMT_Encode4(2403811), // Rule ID 55725 //
     /* 2403739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403782 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2403785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2403789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403810 */     // GIR_Coverage, 55725,
     /* 2403810 */     GIR_EraseRootFromParent_Done,
     /* 2403811 */   // Label 34570: @2403811
     /* 2403811 */   GIM_Try, /*On fail goto*//*Label 34571*/ GIMT_Encode4(2403888), // Rule ID 72944 //
     /* 2403816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403859 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2403859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2403862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403887 */     // GIR_Coverage, 72944,
     /* 2403887 */     GIR_EraseRootFromParent_Done,
     /* 2403888 */   // Label 34571: @2403888
     /* 2403888 */   GIM_Try, /*On fail goto*//*Label 34572*/ GIMT_Encode4(2403965), // Rule ID 72945 //
     /* 2403893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403936 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2403936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2403939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2403943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2403951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2403963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403964 */     // GIR_Coverage, 72945,
     /* 2403964 */     GIR_EraseRootFromParent_Done,
     /* 2403965 */   // Label 34572: @2403965
     /* 2403965 */   GIM_Try, /*On fail goto*//*Label 34573*/ GIMT_Encode4(2404027), // Rule ID 55728 //
     /* 2403970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2403985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2403998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404000 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2404003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404026 */     // GIR_Coverage, 55728,
     /* 2404026 */     GIR_EraseRootFromParent_Done,
     /* 2404027 */   // Label 34573: @2404027
     /* 2404027 */   GIM_Try, /*On fail goto*//*Label 34574*/ GIMT_Encode4(2404089), // Rule ID 55729 //
     /* 2404032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404062 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2404065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404088 */     // GIR_Coverage, 55729,
     /* 2404088 */     GIR_EraseRootFromParent_Done,
     /* 2404089 */   // Label 34574: @2404089
     /* 2404089 */   GIM_Try, /*On fail goto*//*Label 34575*/ GIMT_Encode4(2404151), // Rule ID 72948 //
     /* 2404094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404124 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2404127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404150 */     // GIR_Coverage, 72948,
     /* 2404150 */     GIR_EraseRootFromParent_Done,
     /* 2404151 */   // Label 34575: @2404151
     /* 2404151 */   GIM_Try, /*On fail goto*//*Label 34576*/ GIMT_Encode4(2404213), // Rule ID 72949 //
     /* 2404156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404186 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2404189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404212 */     // GIR_Coverage, 72949,
     /* 2404212 */     GIR_EraseRootFromParent_Done,
     /* 2404213 */   // Label 34576: @2404213
     /* 2404213 */   GIM_Try, /*On fail goto*//*Label 34577*/ GIMT_Encode4(2404275), // Rule ID 55720 //
     /* 2404218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404248 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2404251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2404261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404274 */     // GIR_Coverage, 55720,
     /* 2404274 */     GIR_EraseRootFromParent_Done,
     /* 2404275 */   // Label 34577: @2404275
     /* 2404275 */   GIM_Try, /*On fail goto*//*Label 34578*/ GIMT_Encode4(2404337), // Rule ID 55721 //
     /* 2404280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404310 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2404313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2404323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404336 */     // GIR_Coverage, 55721,
     /* 2404336 */     GIR_EraseRootFromParent_Done,
     /* 2404337 */   // Label 34578: @2404337
     /* 2404337 */   GIM_Try, /*On fail goto*//*Label 34579*/ GIMT_Encode4(2404382), // Rule ID 55716 //
     /* 2404342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404357 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2404360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404381 */     // GIR_Coverage, 55716,
     /* 2404381 */     GIR_EraseRootFromParent_Done,
     /* 2404382 */   // Label 34579: @2404382
     /* 2404382 */   GIM_Try, /*On fail goto*//*Label 34580*/ GIMT_Encode4(2404427), // Rule ID 55717 //
     /* 2404387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404402 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2404405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404426 */     // GIR_Coverage, 55717,
     /* 2404426 */     GIR_EraseRootFromParent_Done,
     /* 2404427 */   // Label 34580: @2404427
     /* 2404427 */   GIM_Reject,
     /* 2404428 */ // Label 34568: @2404428
     /* 2404428 */ GIM_Reject,
     /* 2404429 */ // Label 34340: @2404429
     /* 2404429 */ GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2405218),
     /* 2404434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2404440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2404443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404447 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2404524), // Rule ID 55276 //
     /* 2404452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404495 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2404498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2404510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404523 */     // GIR_Coverage, 55276,
     /* 2404523 */     GIR_EraseRootFromParent_Done,
     /* 2404524 */   // Label 34582: @2404524
     /* 2404524 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2404601), // Rule ID 55277 //
     /* 2404529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404572 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2404575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2404587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404600 */     // GIR_Coverage, 55277,
     /* 2404600 */     GIR_EraseRootFromParent_Done,
     /* 2404601 */   // Label 34583: @2404601
     /* 2404601 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2404678), // Rule ID 72552 //
     /* 2404606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404649 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2404652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2404664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404677 */     // GIR_Coverage, 72552,
     /* 2404677 */     GIR_EraseRootFromParent_Done,
     /* 2404678 */   // Label 34584: @2404678
     /* 2404678 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2404755), // Rule ID 72553 //
     /* 2404683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404726 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2404729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2404741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404754 */     // GIR_Coverage, 72553,
     /* 2404754 */     GIR_EraseRootFromParent_Done,
     /* 2404755 */   // Label 34585: @2404755
     /* 2404755 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2404817), // Rule ID 55280 //
     /* 2404760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404790 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2404793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404816 */     // GIR_Coverage, 55280,
     /* 2404816 */     GIR_EraseRootFromParent_Done,
     /* 2404817 */   // Label 34586: @2404817
     /* 2404817 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2404879), // Rule ID 55281 //
     /* 2404822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404852 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2404855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2404859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404878 */     // GIR_Coverage, 55281,
     /* 2404878 */     GIR_EraseRootFromParent_Done,
     /* 2404879 */   // Label 34587: @2404879
     /* 2404879 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2404941), // Rule ID 72556 //
     /* 2404884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404914 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2404914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2404917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2404939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404940 */     // GIR_Coverage, 72556,
     /* 2404940 */     GIR_EraseRootFromParent_Done,
     /* 2404941 */   // Label 34588: @2404941
     /* 2404941 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2405003), // Rule ID 72557 //
     /* 2404946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404976 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2404976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2404979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2404983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2404989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405002 */     // GIR_Coverage, 72557,
     /* 2405002 */     GIR_EraseRootFromParent_Done,
     /* 2405003 */   // Label 34589: @2405003
     /* 2405003 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2405065), // Rule ID 55272 //
     /* 2405008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2405031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405038 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2405041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2405051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405064 */     // GIR_Coverage, 55272,
     /* 2405064 */     GIR_EraseRootFromParent_Done,
     /* 2405065 */   // Label 34590: @2405065
     /* 2405065 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2405127), // Rule ID 55273 //
     /* 2405070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2405093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405100 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2405103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2405113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405126 */     // GIR_Coverage, 55273,
     /* 2405126 */     GIR_EraseRootFromParent_Done,
     /* 2405127 */   // Label 34591: @2405127
     /* 2405127 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2405172), // Rule ID 55268 //
     /* 2405132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2405135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405147 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2405150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405171 */     // GIR_Coverage, 55268,
     /* 2405171 */     GIR_EraseRootFromParent_Done,
     /* 2405172 */   // Label 34592: @2405172
     /* 2405172 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2405217), // Rule ID 55269 //
     /* 2405177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2405180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2405192 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2405195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2405212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405216 */     // GIR_Coverage, 55269,
     /* 2405216 */     GIR_EraseRootFromParent_Done,
     /* 2405217 */   // Label 34593: @2405217
     /* 2405217 */   GIM_Reject,
     /* 2405218 */ // Label 34581: @2405218
     /* 2405218 */ GIM_Reject,
     /* 2405219 */ // Label 34341: @2405219
     /* 2405219 */ GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2406008),
     /* 2405224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2405230 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2405233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405237 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2405314), // Rule ID 55532 //
     /* 2405242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405285 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2405288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2405300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405313 */     // GIR_Coverage, 55532,
     /* 2405313 */     GIR_EraseRootFromParent_Done,
     /* 2405314 */   // Label 34595: @2405314
     /* 2405314 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2405391), // Rule ID 55533 //
     /* 2405319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405362 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2405365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2405377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405390 */     // GIR_Coverage, 55533,
     /* 2405390 */     GIR_EraseRootFromParent_Done,
     /* 2405391 */   // Label 34596: @2405391
     /* 2405391 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2405468), // Rule ID 72776 //
     /* 2405396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405439 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2405442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2405446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2405454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405467 */     // GIR_Coverage, 72776,
     /* 2405467 */     GIR_EraseRootFromParent_Done,
     /* 2405468 */   // Label 34597: @2405468
     /* 2405468 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2405545), // Rule ID 72777 //
     /* 2405473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405516 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2405519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2405523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2405531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405544 */     // GIR_Coverage, 72777,
     /* 2405544 */     GIR_EraseRootFromParent_Done,
     /* 2405545 */   // Label 34598: @2405545
     /* 2405545 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2405607), // Rule ID 55536 //
     /* 2405550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405580 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2405583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405606 */     // GIR_Coverage, 55536,
     /* 2405606 */     GIR_EraseRootFromParent_Done,
     /* 2405607 */   // Label 34599: @2405607
     /* 2405607 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2405669), // Rule ID 55537 //
     /* 2405612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405642 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2405645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405668 */     // GIR_Coverage, 55537,
     /* 2405668 */     GIR_EraseRootFromParent_Done,
     /* 2405669 */   // Label 34600: @2405669
     /* 2405669 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2405731), // Rule ID 72780 //
     /* 2405674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405704 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2405707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2405711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405730 */     // GIR_Coverage, 72780,
     /* 2405730 */     GIR_EraseRootFromParent_Done,
     /* 2405731 */   // Label 34601: @2405731
     /* 2405731 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2405793), // Rule ID 72781 //
     /* 2405736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405766 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2405769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2405773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405792 */     // GIR_Coverage, 72781,
     /* 2405792 */     GIR_EraseRootFromParent_Done,
     /* 2405793 */   // Label 34602: @2405793
     /* 2405793 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2405855), // Rule ID 55528 //
     /* 2405798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405828 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2405831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2405841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405854 */     // GIR_Coverage, 55528,
     /* 2405854 */     GIR_EraseRootFromParent_Done,
     /* 2405855 */   // Label 34603: @2405855
     /* 2405855 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2405917), // Rule ID 55529 //
     /* 2405860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2405883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405890 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2405893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2405903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405916 */     // GIR_Coverage, 55529,
     /* 2405916 */     GIR_EraseRootFromParent_Done,
     /* 2405917 */   // Label 34604: @2405917
     /* 2405917 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2405962), // Rule ID 55524 //
     /* 2405922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2405925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405937 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2405937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2405940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2405957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2405960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405961 */     // GIR_Coverage, 55524,
     /* 2405961 */     GIR_EraseRootFromParent_Done,
     /* 2405962 */   // Label 34605: @2405962
     /* 2405962 */   GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2406007), // Rule ID 55525 //
     /* 2405967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2405970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2405982 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2405982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2405985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2405989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2405993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2405999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2406002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406006 */     // GIR_Coverage, 55525,
     /* 2406006 */     GIR_EraseRootFromParent_Done,
     /* 2406007 */   // Label 34606: @2406007
     /* 2406007 */   GIM_Reject,
     /* 2406008 */ // Label 34594: @2406008
     /* 2406008 */ GIM_Reject,
     /* 2406009 */ // Label 34342: @2406009
     /* 2406009 */ GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2406798),
     /* 2406014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2406020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2406023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406027 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2406104), // Rule ID 55340 //
     /* 2406032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406075 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2406078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406103 */     // GIR_Coverage, 55340,
     /* 2406103 */     GIR_EraseRootFromParent_Done,
     /* 2406104 */   // Label 34608: @2406104
     /* 2406104 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2406181), // Rule ID 55341 //
     /* 2406109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406152 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2406155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406180 */     // GIR_Coverage, 55341,
     /* 2406180 */     GIR_EraseRootFromParent_Done,
     /* 2406181 */   // Label 34609: @2406181
     /* 2406181 */   GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2406258), // Rule ID 72608 //
     /* 2406186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406229 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2406232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406257 */     // GIR_Coverage, 72608,
     /* 2406257 */     GIR_EraseRootFromParent_Done,
     /* 2406258 */   // Label 34610: @2406258
     /* 2406258 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2406335), // Rule ID 72609 //
     /* 2406263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406306 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2406309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406334 */     // GIR_Coverage, 72609,
     /* 2406334 */     GIR_EraseRootFromParent_Done,
     /* 2406335 */   // Label 34611: @2406335
     /* 2406335 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2406397), // Rule ID 55344 //
     /* 2406340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406370 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2406373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406396 */     // GIR_Coverage, 55344,
     /* 2406396 */     GIR_EraseRootFromParent_Done,
     /* 2406397 */   // Label 34612: @2406397
     /* 2406397 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2406459), // Rule ID 55345 //
     /* 2406402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406432 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2406435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406458 */     // GIR_Coverage, 55345,
     /* 2406458 */     GIR_EraseRootFromParent_Done,
     /* 2406459 */   // Label 34613: @2406459
     /* 2406459 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2406521), // Rule ID 72612 //
     /* 2406464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406494 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2406497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406520 */     // GIR_Coverage, 72612,
     /* 2406520 */     GIR_EraseRootFromParent_Done,
     /* 2406521 */   // Label 34614: @2406521
     /* 2406521 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2406583), // Rule ID 72613 //
     /* 2406526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406556 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2406559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406582 */     // GIR_Coverage, 72613,
     /* 2406582 */     GIR_EraseRootFromParent_Done,
     /* 2406583 */   // Label 34615: @2406583
     /* 2406583 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2406645), // Rule ID 55336 //
     /* 2406588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406618 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2406621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2406631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406644 */     // GIR_Coverage, 55336,
     /* 2406644 */     GIR_EraseRootFromParent_Done,
     /* 2406645 */   // Label 34616: @2406645
     /* 2406645 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2406707), // Rule ID 55337 //
     /* 2406650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2406673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406680 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2406683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2406693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406706 */     // GIR_Coverage, 55337,
     /* 2406706 */     GIR_EraseRootFromParent_Done,
     /* 2406707 */   // Label 34617: @2406707
     /* 2406707 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2406752), // Rule ID 55332 //
     /* 2406712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406727 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2406730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406751 */     // GIR_Coverage, 55332,
     /* 2406751 */     GIR_EraseRootFromParent_Done,
     /* 2406752 */   // Label 34618: @2406752
     /* 2406752 */   GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2406797), // Rule ID 55333 //
     /* 2406757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2406772 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2406775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406796 */     // GIR_Coverage, 55333,
     /* 2406796 */     GIR_EraseRootFromParent_Done,
     /* 2406797 */   // Label 34619: @2406797
     /* 2406797 */   GIM_Reject,
     /* 2406798 */ // Label 34607: @2406798
     /* 2406798 */ GIM_Reject,
     /* 2406799 */ // Label 34343: @2406799
     /* 2406799 */ GIM_Reject,
     /* 2406800 */ // Label 103: @2406800
     /* 2406800 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34638*/ GIMT_Encode4(2408975),
     /* 2406811 */ /*GILLT_s16*//*Label 34620*/ GIMT_Encode4(2406931),
     /* 2406815 */ /*GILLT_s32*//*Label 34621*/ GIMT_Encode4(2407053),
     /* 2406819 */ /*GILLT_s64*//*Label 34622*/ GIMT_Encode4(2407175), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406831 */ /*GILLT_nxv1s16*//*Label 34623*/ GIMT_Encode4(2407325),
     /* 2406835 */ /*GILLT_nxv1s32*//*Label 34624*/ GIMT_Encode4(2407435),
     /* 2406839 */ /*GILLT_nxv1s64*//*Label 34625*/ GIMT_Encode4(2407545), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406851 */ /*GILLT_nxv2s16*//*Label 34626*/ GIMT_Encode4(2407655),
     /* 2406855 */ /*GILLT_nxv2s32*//*Label 34627*/ GIMT_Encode4(2407765),
     /* 2406859 */ /*GILLT_nxv2s64*//*Label 34628*/ GIMT_Encode4(2407875), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406871 */ /*GILLT_nxv4s16*//*Label 34629*/ GIMT_Encode4(2407985),
     /* 2406875 */ /*GILLT_nxv4s32*//*Label 34630*/ GIMT_Encode4(2408095),
     /* 2406879 */ /*GILLT_nxv4s64*//*Label 34631*/ GIMT_Encode4(2408205), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406891 */ /*GILLT_nxv8s16*//*Label 34632*/ GIMT_Encode4(2408315),
     /* 2406895 */ /*GILLT_nxv8s32*//*Label 34633*/ GIMT_Encode4(2408425),
     /* 2406899 */ /*GILLT_nxv8s64*//*Label 34634*/ GIMT_Encode4(2408535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406911 */ /*GILLT_nxv16s16*//*Label 34635*/ GIMT_Encode4(2408645),
     /* 2406915 */ /*GILLT_nxv16s32*//*Label 34636*/ GIMT_Encode4(2408755), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406927 */ /*GILLT_nxv32s16*//*Label 34637*/ GIMT_Encode4(2408865),
     /* 2406931 */ // Label 34620: @2406931
     /* 2406931 */ GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2407052),
     /* 2406936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2406939 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2406967), // Rule ID 1980 //
     /* 2406944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2406947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2406951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2406955 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2406955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2406958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406966 */     // GIR_Coverage, 1980,
     /* 2406966 */     GIR_EraseRootFromParent_Done,
     /* 2406967 */   // Label 34640: @2406967
     /* 2406967 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2406995), // Rule ID 1981 //
     /* 2406972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2406975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2406979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2406983 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2406983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2406986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406994 */     // GIR_Coverage, 1981,
     /* 2406994 */     GIR_EraseRootFromParent_Done,
     /* 2406995 */   // Label 34641: @2406995
     /* 2406995 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2407023), // Rule ID 2013 //
     /* 2407000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2407003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407011 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2407011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2407014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407022 */     // GIR_Coverage, 2013,
     /* 2407022 */     GIR_EraseRootFromParent_Done,
     /* 2407023 */   // Label 34642: @2407023
     /* 2407023 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2407051), // Rule ID 2014 //
     /* 2407028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2407031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2407039 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2407039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2407042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407050 */     // GIR_Coverage, 2014,
     /* 2407050 */     GIR_EraseRootFromParent_Done,
     /* 2407051 */   // Label 34643: @2407051
     /* 2407051 */   GIM_Reject,
     /* 2407052 */ // Label 34639: @2407052
     /* 2407052 */ GIM_Reject,
     /* 2407053 */ // Label 34621: @2407053
     /* 2407053 */ GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2407174),
     /* 2407058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407061 */   GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2407089), // Rule ID 1267 //
     /* 2407066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2407069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2407073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2407077 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2407077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2407080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407088 */     // GIR_Coverage, 1267,
     /* 2407088 */     GIR_EraseRootFromParent_Done,
     /* 2407089 */   // Label 34645: @2407089
     /* 2407089 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2407117), // Rule ID 1268 //
     /* 2407094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2407097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2407101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2407105 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2407105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2407108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407116 */     // GIR_Coverage, 1268,
     /* 2407116 */     GIR_EraseRootFromParent_Done,
     /* 2407117 */   // Label 34646: @2407117
     /* 2407117 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2407145), // Rule ID 1275 //
     /* 2407122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2407125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2407129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2407133 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2407133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2407136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407144 */     // GIR_Coverage, 1275,
     /* 2407144 */     GIR_EraseRootFromParent_Done,
     /* 2407145 */   // Label 34647: @2407145
     /* 2407145 */   GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2407173), // Rule ID 1276 //
     /* 2407150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2407153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2407157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2407161 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2407161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2407164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407172 */     // GIR_Coverage, 1276,
     /* 2407172 */     GIR_EraseRootFromParent_Done,
     /* 2407173 */   // Label 34648: @2407173
     /* 2407173 */   GIM_Reject,
     /* 2407174 */ // Label 34644: @2407174
     /* 2407174 */ GIM_Reject,
     /* 2407175 */ // Label 34622: @2407175
     /* 2407175 */ GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2407324),
     /* 2407180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407183 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2407211), // Rule ID 1610 //
     /* 2407188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2407191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407199 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2407199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2407202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407210 */     // GIR_Coverage, 1610,
     /* 2407210 */     GIR_EraseRootFromParent_Done,
     /* 2407211 */   // Label 34650: @2407211
     /* 2407211 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2407239), // Rule ID 1611 //
     /* 2407216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2407219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2407227 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2407227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2407230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407238 */     // GIR_Coverage, 1611,
     /* 2407238 */     GIR_EraseRootFromParent_Done,
     /* 2407239 */   // Label 34651: @2407239
     /* 2407239 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2407267), // Rule ID 1645 //
     /* 2407244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2407247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2407255 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2407255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2407258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407266 */     // GIR_Coverage, 1645,
     /* 2407266 */     GIR_EraseRootFromParent_Done,
     /* 2407267 */   // Label 34652: @2407267
     /* 2407267 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2407295), // Rule ID 1665 //
     /* 2407272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2407275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407283 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2407283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2407286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407294 */     // GIR_Coverage, 1665,
     /* 2407294 */     GIR_EraseRootFromParent_Done,
     /* 2407295 */   // Label 34653: @2407295
     /* 2407295 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2407323), // Rule ID 1666 //
     /* 2407300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2407303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2407311 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2407311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2407314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407322 */     // GIR_Coverage, 1666,
     /* 2407322 */     GIR_EraseRootFromParent_Done,
     /* 2407323 */   // Label 34654: @2407323
     /* 2407323 */   GIM_Reject,
     /* 2407324 */ // Label 34649: @2407324
     /* 2407324 */ GIM_Reject,
     /* 2407325 */ // Label 34623: @2407325
     /* 2407325 */ GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2407434),
     /* 2407330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407341 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2407387), // Rule ID 56228 //
     /* 2407346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407349 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2407352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2407366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407386 */     // GIR_Coverage, 56228,
     /* 2407386 */     GIR_EraseRootFromParent_Done,
     /* 2407387 */   // Label 34656: @2407387
     /* 2407387 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2407433), // Rule ID 56229 //
     /* 2407392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407395 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2407398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2407412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407432 */     // GIR_Coverage, 56229,
     /* 2407432 */     GIR_EraseRootFromParent_Done,
     /* 2407433 */   // Label 34657: @2407433
     /* 2407433 */   GIM_Reject,
     /* 2407434 */ // Label 34655: @2407434
     /* 2407434 */ GIM_Reject,
     /* 2407435 */ // Label 34624: @2407435
     /* 2407435 */ GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2407544),
     /* 2407440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407451 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2407497), // Rule ID 56268 //
     /* 2407456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407459 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2407462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2407476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407496 */     // GIR_Coverage, 56268,
     /* 2407496 */     GIR_EraseRootFromParent_Done,
     /* 2407497 */   // Label 34659: @2407497
     /* 2407497 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2407543), // Rule ID 56269 //
     /* 2407502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407505 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2407508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2407522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407542 */     // GIR_Coverage, 56269,
     /* 2407542 */     GIR_EraseRootFromParent_Done,
     /* 2407543 */   // Label 34660: @2407543
     /* 2407543 */   GIM_Reject,
     /* 2407544 */ // Label 34658: @2407544
     /* 2407544 */ GIM_Reject,
     /* 2407545 */ // Label 34625: @2407545
     /* 2407545 */ GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2407654),
     /* 2407550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407561 */   GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2407607), // Rule ID 56328 //
     /* 2407566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407569 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2407572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2407586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407606 */     // GIR_Coverage, 56328,
     /* 2407606 */     GIR_EraseRootFromParent_Done,
     /* 2407607 */   // Label 34662: @2407607
     /* 2407607 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2407653), // Rule ID 56329 //
     /* 2407612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2407615 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2407618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2407632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407652 */     // GIR_Coverage, 56329,
     /* 2407652 */     GIR_EraseRootFromParent_Done,
     /* 2407653 */   // Label 34663: @2407653
     /* 2407653 */   GIM_Reject,
     /* 2407654 */ // Label 34661: @2407654
     /* 2407654 */ GIM_Reject,
     /* 2407655 */ // Label 34626: @2407655
     /* 2407655 */ GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2407764),
     /* 2407660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2407663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407671 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2407717), // Rule ID 56248 //
     /* 2407676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2407679 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2407682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2407696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407716 */     // GIR_Coverage, 56248,
     /* 2407716 */     GIR_EraseRootFromParent_Done,
     /* 2407717 */   // Label 34665: @2407717
     /* 2407717 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2407763), // Rule ID 56249 //
     /* 2407722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2407725 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2407728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2407742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407762 */     // GIR_Coverage, 56249,
     /* 2407762 */     GIR_EraseRootFromParent_Done,
     /* 2407763 */   // Label 34666: @2407763
     /* 2407763 */   GIM_Reject,
     /* 2407764 */ // Label 34664: @2407764
     /* 2407764 */ GIM_Reject,
     /* 2407765 */ // Label 34627: @2407765
     /* 2407765 */ GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2407874),
     /* 2407770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2407773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407781 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2407827), // Rule ID 56308 //
     /* 2407786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407789 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2407792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2407806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407826 */     // GIR_Coverage, 56308,
     /* 2407826 */     GIR_EraseRootFromParent_Done,
     /* 2407827 */   // Label 34668: @2407827
     /* 2407827 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2407873), // Rule ID 56309 //
     /* 2407832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407835 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2407838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2407852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407872 */     // GIR_Coverage, 56309,
     /* 2407872 */     GIR_EraseRootFromParent_Done,
     /* 2407873 */   // Label 34669: @2407873
     /* 2407873 */   GIM_Reject,
     /* 2407874 */ // Label 34667: @2407874
     /* 2407874 */ GIM_Reject,
     /* 2407875 */ // Label 34628: @2407875
     /* 2407875 */ GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2407984),
     /* 2407880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2407883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2407887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2407891 */   GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2407937), // Rule ID 56468 //
     /* 2407896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407899 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2407899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2407902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2407916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407936 */     // GIR_Coverage, 56468,
     /* 2407936 */     GIR_EraseRootFromParent_Done,
     /* 2407937 */   // Label 34671: @2407937
     /* 2407937 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2407983), // Rule ID 56469 //
     /* 2407942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2407945 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2407945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2407948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2407952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2407957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2407959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2407962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2407967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2407969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407982 */     // GIR_Coverage, 56469,
     /* 2407982 */     GIR_EraseRootFromParent_Done,
     /* 2407983 */   // Label 34672: @2407983
     /* 2407983 */   GIM_Reject,
     /* 2407984 */ // Label 34670: @2407984
     /* 2407984 */ GIM_Reject,
     /* 2407985 */ // Label 34629: @2407985
     /* 2407985 */ GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2408094),
     /* 2407990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2407993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408001 */   GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2408047), // Rule ID 56288 //
     /* 2408006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408009 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2408012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2408026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408046 */     // GIR_Coverage, 56288,
     /* 2408046 */     GIR_EraseRootFromParent_Done,
     /* 2408047 */   // Label 34674: @2408047
     /* 2408047 */   GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2408093), // Rule ID 56289 //
     /* 2408052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408055 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2408058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2408072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408092 */     // GIR_Coverage, 56289,
     /* 2408092 */     GIR_EraseRootFromParent_Done,
     /* 2408093 */   // Label 34675: @2408093
     /* 2408093 */   GIM_Reject,
     /* 2408094 */ // Label 34673: @2408094
     /* 2408094 */ GIM_Reject,
     /* 2408095 */ // Label 34630: @2408095
     /* 2408095 */ GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2408204),
     /* 2408100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2408103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408111 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2408157), // Rule ID 56408 //
     /* 2408116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2408119 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2408122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2408136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408156 */     // GIR_Coverage, 56408,
     /* 2408156 */     GIR_EraseRootFromParent_Done,
     /* 2408157 */   // Label 34677: @2408157
     /* 2408157 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2408203), // Rule ID 56409 //
     /* 2408162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2408165 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2408168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2408182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408202 */     // GIR_Coverage, 56409,
     /* 2408202 */     GIR_EraseRootFromParent_Done,
     /* 2408203 */   // Label 34678: @2408203
     /* 2408203 */   GIM_Reject,
     /* 2408204 */ // Label 34676: @2408204
     /* 2408204 */ GIM_Reject,
     /* 2408205 */ // Label 34631: @2408205
     /* 2408205 */ GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2408314),
     /* 2408210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2408213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408221 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2408267), // Rule ID 56488 //
     /* 2408226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408229 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2408232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2408246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408266 */     // GIR_Coverage, 56488,
     /* 2408266 */     GIR_EraseRootFromParent_Done,
     /* 2408267 */   // Label 34680: @2408267
     /* 2408267 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2408313), // Rule ID 56489 //
     /* 2408272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408275 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2408278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2408292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408312 */     // GIR_Coverage, 56489,
     /* 2408312 */     GIR_EraseRootFromParent_Done,
     /* 2408313 */   // Label 34681: @2408313
     /* 2408313 */   GIM_Reject,
     /* 2408314 */ // Label 34679: @2408314
     /* 2408314 */ GIM_Reject,
     /* 2408315 */ // Label 34632: @2408315
     /* 2408315 */ GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2408424),
     /* 2408320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2408323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408331 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2408377), // Rule ID 56348 //
     /* 2408336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408339 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2408342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2408356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408376 */     // GIR_Coverage, 56348,
     /* 2408376 */     GIR_EraseRootFromParent_Done,
     /* 2408377 */   // Label 34683: @2408377
     /* 2408377 */   GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2408423), // Rule ID 56349 //
     /* 2408382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408385 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2408388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2408402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408422 */     // GIR_Coverage, 56349,
     /* 2408422 */     GIR_EraseRootFromParent_Done,
     /* 2408423 */   // Label 34684: @2408423
     /* 2408423 */   GIM_Reject,
     /* 2408424 */ // Label 34682: @2408424
     /* 2408424 */ GIM_Reject,
     /* 2408425 */ // Label 34633: @2408425
     /* 2408425 */ GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2408534),
     /* 2408430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2408433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408441 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2408487), // Rule ID 56428 //
     /* 2408446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2408449 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2408452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2408466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408486 */     // GIR_Coverage, 56428,
     /* 2408486 */     GIR_EraseRootFromParent_Done,
     /* 2408487 */   // Label 34686: @2408487
     /* 2408487 */   GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2408533), // Rule ID 56429 //
     /* 2408492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2408495 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2408498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2408512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408532 */     // GIR_Coverage, 56429,
     /* 2408532 */     GIR_EraseRootFromParent_Done,
     /* 2408533 */   // Label 34687: @2408533
     /* 2408533 */   GIM_Reject,
     /* 2408534 */ // Label 34685: @2408534
     /* 2408534 */ GIM_Reject,
     /* 2408535 */ // Label 34634: @2408535
     /* 2408535 */ GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2408644),
     /* 2408540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2408543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408551 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2408597), // Rule ID 56508 //
     /* 2408556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408559 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2408562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2408576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408596 */     // GIR_Coverage, 56508,
     /* 2408596 */     GIR_EraseRootFromParent_Done,
     /* 2408597 */   // Label 34689: @2408597
     /* 2408597 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2408643), // Rule ID 56509 //
     /* 2408602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408605 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2408608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2408622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408642 */     // GIR_Coverage, 56509,
     /* 2408642 */     GIR_EraseRootFromParent_Done,
     /* 2408643 */   // Label 34690: @2408643
     /* 2408643 */   GIM_Reject,
     /* 2408644 */ // Label 34688: @2408644
     /* 2408644 */ GIM_Reject,
     /* 2408645 */ // Label 34635: @2408645
     /* 2408645 */ GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2408754),
     /* 2408650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2408653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2408661 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2408707), // Rule ID 56368 //
     /* 2408666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408669 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2408672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2408686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408706 */     // GIR_Coverage, 56368,
     /* 2408706 */     GIR_EraseRootFromParent_Done,
     /* 2408707 */   // Label 34692: @2408707
     /* 2408707 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2408753), // Rule ID 56369 //
     /* 2408712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408715 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2408718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2408732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408752 */     // GIR_Coverage, 56369,
     /* 2408752 */     GIR_EraseRootFromParent_Done,
     /* 2408753 */   // Label 34693: @2408753
     /* 2408753 */   GIM_Reject,
     /* 2408754 */ // Label 34691: @2408754
     /* 2408754 */ GIM_Reject,
     /* 2408755 */ // Label 34636: @2408755
     /* 2408755 */ GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2408864),
     /* 2408760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2408763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408771 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2408817), // Rule ID 56448 //
     /* 2408776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2408779 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2408782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2408796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408816 */     // GIR_Coverage, 56448,
     /* 2408816 */     GIR_EraseRootFromParent_Done,
     /* 2408817 */   // Label 34695: @2408817
     /* 2408817 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2408863), // Rule ID 56449 //
     /* 2408822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2408825 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2408828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2408842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408862 */     // GIR_Coverage, 56449,
     /* 2408862 */     GIR_EraseRootFromParent_Done,
     /* 2408863 */   // Label 34696: @2408863
     /* 2408863 */   GIM_Reject,
     /* 2408864 */ // Label 34694: @2408864
     /* 2408864 */ GIM_Reject,
     /* 2408865 */ // Label 34637: @2408865
     /* 2408865 */ GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2408974),
     /* 2408870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2408873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2408881 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2408927), // Rule ID 56388 //
     /* 2408886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408889 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2408889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2408892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2408906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408926 */     // GIR_Coverage, 56388,
     /* 2408926 */     GIR_EraseRootFromParent_Done,
     /* 2408927 */   // Label 34698: @2408927
     /* 2408927 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2408973), // Rule ID 56389 //
     /* 2408932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408935 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2408935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2408938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2408942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2408947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2408949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2408952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2408957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2408959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408972 */     // GIR_Coverage, 56389,
     /* 2408972 */     GIR_EraseRootFromParent_Done,
     /* 2408973 */   // Label 34699: @2408973
     /* 2408973 */   GIM_Reject,
     /* 2408974 */ // Label 34697: @2408974
     /* 2408974 */ GIM_Reject,
     /* 2408975 */ // Label 34638: @2408975
     /* 2408975 */ GIM_Reject,
     /* 2408976 */ // Label 104: @2408976
     /* 2408976 */ GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2408988), // Rule ID 283 //
     /* 2408981 */   // (trap)  =>  (UNIMP)
     /* 2408981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2408986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2408987 */   // GIR_Coverage, 283,
     /* 2408987 */   GIR_Done,
     /* 2408988 */ // Label 34700: @2408988
     /* 2408988 */ GIM_Reject,
     /* 2408989 */ // Label 105: @2408989
     /* 2408989 */ GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2409001), // Rule ID 284 //
     /* 2408994 */   // (debugtrap)  =>  (EBREAK)
     /* 2408994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2408999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409000 */   // GIR_Coverage, 284,
     /* 2409000 */   GIR_Done,
     /* 2409001 */ // Label 34701: @2409001
     /* 2409001 */ GIM_Reject,
     /* 2409002 */ // Label 106: @2409002
     /* 2409002 */ GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2409096),
     /* 2409007 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409017 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2409036), // Rule ID 2512 //
     /* 2409022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2409025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409029 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2409029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2409034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409035 */     // GIR_Coverage, 2512,
     /* 2409035 */     GIR_Done,
     /* 2409036 */   // Label 34703: @2409036
     /* 2409036 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2409095), // Rule ID 62563 //
     /* 2409041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2409044 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2409044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2409047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2409051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2409056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2409060 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2409063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2409065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2409068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2409072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2409077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2409080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2409083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2409085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2409088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2409093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409094 */     // GIR_Coverage, 62563,
     /* 2409094 */     GIR_EraseRootFromParent_Done,
     /* 2409095 */   // Label 34704: @2409095
     /* 2409095 */   GIM_Reject,
     /* 2409096 */ // Label 34702: @2409096
     /* 2409096 */ GIM_Reject,
     /* 2409097 */ // Label 107: @2409097
     /* 2409097 */ GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2409126), // Rule ID 2513 //
     /* 2409102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2409105 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409119 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2409119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2409124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409125 */   // GIR_Coverage, 2513,
     /* 2409125 */   GIR_Done,
     /* 2409126 */ // Label 34705: @2409126
     /* 2409126 */ GIM_Reject,
     /* 2409127 */ // Label 108: @2409127
     /* 2409127 */ GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2409163), // Rule ID 307 //
     /* 2409132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2409135 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2409144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409156 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2409156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2409161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409162 */   // GIR_Coverage, 307,
     /* 2409162 */   GIR_Done,
     /* 2409163 */ // Label 34706: @2409163
     /* 2409163 */ GIM_Reject,
     /* 2409164 */ // Label 109: @2409164
     /* 2409164 */ GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2409200), // Rule ID 306 //
     /* 2409169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2409172 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2409181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409193 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2409193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2409198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409199 */   // GIR_Coverage, 306,
     /* 2409199 */   GIR_Done,
     /* 2409200 */ // Label 34707: @2409200
     /* 2409200 */ GIM_Reject,
     /* 2409201 */ // Label 110: @2409201
     /* 2409201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34710*/ GIMT_Encode4(2409560),
     /* 2409212 */ /*GILLT_s32*//*Label 34708*/ GIMT_Encode4(2409220),
     /* 2409216 */ /*GILLT_s64*//*Label 34709*/ GIMT_Encode4(2409377),
     /* 2409220 */ // Label 34708: @2409220
     /* 2409220 */ GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2409246), // Rule ID 1274 //
     /* 2409225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2409228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409239 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2409239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2409244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409245 */   // GIR_Coverage, 1274,
     /* 2409245 */   GIR_Done,
     /* 2409246 */ // Label 34711: @2409246
     /* 2409246 */ GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2409272), // Rule ID 1282 //
     /* 2409251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2409254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409265 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2409265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2409270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409271 */   // GIR_Coverage, 1282,
     /* 2409271 */   GIR_Done,
     /* 2409272 */ // Label 34712: @2409272
     /* 2409272 */ GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2409298), // Rule ID 1617 //
     /* 2409277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2409280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2409291 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2409291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2409296 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409297 */   // GIR_Coverage, 1617,
     /* 2409297 */   GIR_Done,
     /* 2409298 */ // Label 34713: @2409298
     /* 2409298 */ GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2409324), // Rule ID 1672 //
     /* 2409303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2409306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2409317 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2409317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2409322 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409323 */   // GIR_Coverage, 1672,
     /* 2409323 */   GIR_Done,
     /* 2409324 */ // Label 34714: @2409324
     /* 2409324 */ GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2409350), // Rule ID 1987 //
     /* 2409329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2409332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2409335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409343 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2409343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2409348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409349 */   // GIR_Coverage, 1987,
     /* 2409349 */   GIR_Done,
     /* 2409350 */ // Label 34715: @2409350
     /* 2409350 */ GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2409376), // Rule ID 2020 //
     /* 2409355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2409358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2409361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409369 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2409369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2409374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409375 */   // GIR_Coverage, 2020,
     /* 2409375 */   GIR_Done,
     /* 2409376 */ // Label 34716: @2409376
     /* 2409376 */ GIM_Reject,
     /* 2409377 */ // Label 34709: @2409377
     /* 2409377 */ GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2409403), // Rule ID 1273 //
     /* 2409382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2409385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409396 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2409396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2409401 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409402 */   // GIR_Coverage, 1273,
     /* 2409402 */   GIR_Done,
     /* 2409403 */ // Label 34717: @2409403
     /* 2409403 */ GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2409429), // Rule ID 1281 //
     /* 2409408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2409411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2409414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409422 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2409422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2409427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409428 */   // GIR_Coverage, 1281,
     /* 2409428 */   GIR_Done,
     /* 2409429 */ // Label 34718: @2409429
     /* 2409429 */ GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2409455), // Rule ID 1616 //
     /* 2409434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2409437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2409448 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2409448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2409453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409454 */   // GIR_Coverage, 1616,
     /* 2409454 */   GIR_Done,
     /* 2409455 */ // Label 34719: @2409455
     /* 2409455 */ GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2409481), // Rule ID 1649 //
     /* 2409460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2409463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409474 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2409474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2409479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409480 */   // GIR_Coverage, 1649,
     /* 2409480 */   GIR_Done,
     /* 2409481 */ // Label 34720: @2409481
     /* 2409481 */ GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2409507), // Rule ID 1671 //
     /* 2409486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2409489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2409492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2409500 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2409500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2409505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409506 */   // GIR_Coverage, 1671,
     /* 2409506 */   GIR_Done,
     /* 2409507 */ // Label 34721: @2409507
     /* 2409507 */ GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2409533), // Rule ID 1986 //
     /* 2409512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2409515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2409518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409526 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2409526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2409531 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409532 */   // GIR_Coverage, 1986,
     /* 2409532 */   GIR_Done,
     /* 2409533 */ // Label 34722: @2409533
     /* 2409533 */ GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2409559), // Rule ID 2019 //
     /* 2409538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2409541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2409544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409552 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2409552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2409557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409558 */   // GIR_Coverage, 2019,
     /* 2409558 */   GIR_Done,
     /* 2409559 */ // Label 34723: @2409559
     /* 2409559 */ GIM_Reject,
     /* 2409560 */ // Label 34710: @2409560
     /* 2409560 */ GIM_Reject,
     /* 2409561 */ // Label 111: @2409561
     /* 2409561 */ GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2409758),
     /* 2409566 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409569 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34728*/ GIMT_Encode4(2409757),
     /* 2409580 */   /*GILLT_s16*//*Label 34725*/ GIMT_Encode4(2409592),
     /* 2409584 */   /*GILLT_s32*//*Label 34726*/ GIMT_Encode4(2409647),
     /* 2409588 */   /*GILLT_s64*//*Label 34727*/ GIMT_Encode4(2409702),
     /* 2409592 */   // Label 34725: @2409592
     /* 2409592 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2409646),
     /* 2409597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409601 */     GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2409623), // Rule ID 2237 //
     /* 2409606 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2409609 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409613 */       // MIs[0] frm
     /* 2409613 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409616 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409616 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2409621 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409622 */       // GIR_Coverage, 2237,
     /* 2409622 */       GIR_Done,
     /* 2409623 */     // Label 34730: @2409623
     /* 2409623 */     GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2409645), // Rule ID 2263 //
     /* 2409628 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2409631 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409635 */       // MIs[0] frm
     /* 2409635 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409638 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409638 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2409643 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409644 */       // GIR_Coverage, 2263,
     /* 2409644 */       GIR_Done,
     /* 2409645 */     // Label 34731: @2409645
     /* 2409645 */     GIM_Reject,
     /* 2409646 */   // Label 34729: @2409646
     /* 2409646 */   GIM_Reject,
     /* 2409647 */   // Label 34726: @2409647
     /* 2409647 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2409701),
     /* 2409652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409656 */     GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2409678), // Rule ID 1499 //
     /* 2409661 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2409664 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409668 */       // MIs[0] frm
     /* 2409668 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409671 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409671 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2409676 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409677 */       // GIR_Coverage, 1499,
     /* 2409677 */       GIR_Done,
     /* 2409678 */     // Label 34733: @2409678
     /* 2409678 */     GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2409700), // Rule ID 1527 //
     /* 2409683 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2409686 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409690 */       // MIs[0] frm
     /* 2409690 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409693 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409693 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2409698 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409699 */       // GIR_Coverage, 1527,
     /* 2409699 */       GIR_Done,
     /* 2409700 */     // Label 34734: @2409700
     /* 2409700 */     GIM_Reject,
     /* 2409701 */   // Label 34732: @2409701
     /* 2409701 */   GIM_Reject,
     /* 2409702 */   // Label 34727: @2409702
     /* 2409702 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2409756),
     /* 2409707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409711 */     GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2409733), // Rule ID 1897 //
     /* 2409716 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2409719 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2409723 */       // MIs[0] frm
     /* 2409723 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409726 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409726 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2409731 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409732 */       // GIR_Coverage, 1897,
     /* 2409732 */       GIR_Done,
     /* 2409733 */     // Label 34736: @2409733
     /* 2409733 */     GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2409755), // Rule ID 1925 //
     /* 2409738 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2409741 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409745 */       // MIs[0] frm
     /* 2409745 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409748 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409748 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2409753 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409754 */       // GIR_Coverage, 1925,
     /* 2409754 */       GIR_Done,
     /* 2409755 */     // Label 34737: @2409755
     /* 2409755 */     GIM_Reject,
     /* 2409756 */   // Label 34735: @2409756
     /* 2409756 */   GIM_Reject,
     /* 2409757 */   // Label 34728: @2409757
     /* 2409757 */   GIM_Reject,
     /* 2409758 */ // Label 34724: @2409758
     /* 2409758 */ GIM_Reject,
     /* 2409759 */ // Label 112: @2409759
     /* 2409759 */ GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2409956),
     /* 2409764 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2409767 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34742*/ GIMT_Encode4(2409955),
     /* 2409778 */   /*GILLT_s16*//*Label 34739*/ GIMT_Encode4(2409790),
     /* 2409782 */   /*GILLT_s32*//*Label 34740*/ GIMT_Encode4(2409845),
     /* 2409786 */   /*GILLT_s64*//*Label 34741*/ GIMT_Encode4(2409900),
     /* 2409790 */   // Label 34739: @2409790
     /* 2409790 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2409844),
     /* 2409795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409799 */     GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2409821), // Rule ID 2235 //
     /* 2409804 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2409807 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2409811 */       // MIs[0] frm
     /* 2409811 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409814 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409814 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2409819 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409820 */       // GIR_Coverage, 2235,
     /* 2409820 */       GIR_Done,
     /* 2409821 */     // Label 34744: @2409821
     /* 2409821 */     GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2409843), // Rule ID 2261 //
     /* 2409826 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2409829 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2409833 */       // MIs[0] frm
     /* 2409833 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409836 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409836 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2409841 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409842 */       // GIR_Coverage, 2261,
     /* 2409842 */       GIR_Done,
     /* 2409843 */     // Label 34745: @2409843
     /* 2409843 */     GIM_Reject,
     /* 2409844 */   // Label 34743: @2409844
     /* 2409844 */   GIM_Reject,
     /* 2409845 */   // Label 34740: @2409845
     /* 2409845 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2409899),
     /* 2409850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409854 */     GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2409876), // Rule ID 1497 //
     /* 2409859 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2409862 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2409866 */       // MIs[0] frm
     /* 2409866 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409869 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409869 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2409874 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409875 */       // GIR_Coverage, 1497,
     /* 2409875 */       GIR_Done,
     /* 2409876 */     // Label 34747: @2409876
     /* 2409876 */     GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2409898), // Rule ID 1525 //
     /* 2409881 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2409884 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2409888 */       // MIs[0] frm
     /* 2409888 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409891 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409891 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2409896 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409897 */       // GIR_Coverage, 1525,
     /* 2409897 */       GIR_Done,
     /* 2409898 */     // Label 34748: @2409898
     /* 2409898 */     GIM_Reject,
     /* 2409899 */   // Label 34746: @2409899
     /* 2409899 */   GIM_Reject,
     /* 2409900 */   // Label 34741: @2409900
     /* 2409900 */   GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2409954),
     /* 2409905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409909 */     GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2409931), // Rule ID 1895 //
     /* 2409914 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2409917 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2409921 */       // MIs[0] frm
     /* 2409921 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409924 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409924 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2409929 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409930 */       // GIR_Coverage, 1895,
     /* 2409930 */       GIR_Done,
     /* 2409931 */     // Label 34750: @2409931
     /* 2409931 */     GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2409953), // Rule ID 1923 //
     /* 2409936 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2409939 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409943 */       // MIs[0] frm
     /* 2409943 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2409946 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2409946 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2409951 */       GIR_RootConstrainSelectedInstOperands,
     /* 2409952 */       // GIR_Coverage, 1923,
     /* 2409952 */       GIR_Done,
     /* 2409953 */     // Label 34751: @2409953
     /* 2409953 */     GIM_Reject,
     /* 2409954 */   // Label 34749: @2409954
     /* 2409954 */   GIM_Reject,
     /* 2409955 */   // Label 34742: @2409955
     /* 2409955 */   GIM_Reject,
     /* 2409956 */ // Label 34738: @2409956
     /* 2409956 */ GIM_Reject,
     /* 2409957 */ // Label 113: @2409957
     /* 2409957 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34754*/ GIMT_Encode4(2410016),
     /* 2409968 */ /*GILLT_s32*//*Label 34752*/ GIMT_Encode4(2409976),
     /* 2409972 */ /*GILLT_s64*//*Label 34753*/ GIMT_Encode4(2409996),
     /* 2409976 */ // Label 34752: @2409976
     /* 2409976 */ GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2409995), // Rule ID 67 //
     /* 2409981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2409988 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2409988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2409993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2409994 */   // GIR_Coverage, 67,
     /* 2409994 */   GIR_Done,
     /* 2409995 */ // Label 34755: @2409995
     /* 2409995 */ GIM_Reject,
     /* 2409996 */ // Label 34753: @2409996
     /* 2409996 */ GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2410015), // Rule ID 66 //
     /* 2410001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410008 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2410008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2410013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410014 */   // GIR_Coverage, 66,
     /* 2410014 */   GIR_Done,
     /* 2410015 */ // Label 34756: @2410015
     /* 2410015 */ GIM_Reject,
     /* 2410016 */ // Label 34754: @2410016
     /* 2410016 */ GIM_Reject,
     /* 2410017 */ // Label 114: @2410017
     /* 2410017 */ GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2410053), // Rule ID 308 //
     /* 2410022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2410025 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410046 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2410051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410052 */   // GIR_Coverage, 308,
     /* 2410052 */   GIR_Done,
     /* 2410053 */ // Label 34757: @2410053
     /* 2410053 */ GIM_Reject,
     /* 2410054 */ // Label 115: @2410054
     /* 2410054 */ GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2410178),
     /* 2410059 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410076 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2410112), // Rule ID 2461 //
     /* 2410081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2410084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2410092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2410096 */     // MIs[1] Operand 1
     /* 2410096 */     // No operand predicates
     /* 2410096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410098 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2410098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2410101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410105 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2410110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410111 */     // GIR_Coverage, 2461,
     /* 2410111 */     GIR_EraseRootFromParent_Done,
     /* 2410112 */   // Label 34759: @2410112
     /* 2410112 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2410148), // Rule ID 62560 //
     /* 2410117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2410120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2410128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2410132 */     // MIs[1] Operand 1
     /* 2410132 */     // No operand predicates
     /* 2410132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410134 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2410134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2410137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410141 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2410146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410147 */     // GIR_Coverage, 62560,
     /* 2410147 */     GIR_EraseRootFromParent_Done,
     /* 2410148 */   // Label 34760: @2410148
     /* 2410148 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2410177), // Rule ID 2458 //
     /* 2410153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2410156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2410163 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2410166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2410175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410176 */     // GIR_Coverage, 2458,
     /* 2410176 */     GIR_EraseRootFromParent_Done,
     /* 2410177 */   // Label 34761: @2410177
     /* 2410177 */   GIM_Reject,
     /* 2410178 */ // Label 34758: @2410178
     /* 2410178 */ GIM_Reject,
     /* 2410179 */ // Label 116: @2410179
     /* 2410179 */ GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2410299),
     /* 2410184 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410201 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2410235), // Rule ID 2460 //
     /* 2410206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2410209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2410217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2410221 */     // MIs[1] Operand 1
     /* 2410221 */     // No operand predicates
     /* 2410221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410223 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2410223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2410226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2410233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410234 */     // GIR_Coverage, 2460,
     /* 2410234 */     GIR_EraseRootFromParent_Done,
     /* 2410235 */   // Label 34763: @2410235
     /* 2410235 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2410269), // Rule ID 62559 //
     /* 2410240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2410243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2410251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2410255 */     // MIs[1] Operand 1
     /* 2410255 */     // No operand predicates
     /* 2410255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410257 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2410257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2410260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2410267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410268 */     // GIR_Coverage, 62559,
     /* 2410268 */     GIR_EraseRootFromParent_Done,
     /* 2410269 */   // Label 34764: @2410269
     /* 2410269 */   GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2410298), // Rule ID 2459 //
     /* 2410274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2410277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2410284 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2410287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2410296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410297 */     // GIR_Coverage, 2459,
     /* 2410297 */     GIR_EraseRootFromParent_Done,
     /* 2410298 */   // Label 34765: @2410298
     /* 2410298 */   GIM_Reject,
     /* 2410299 */ // Label 34762: @2410299
     /* 2410299 */ GIM_Reject,
     /* 2410300 */ // Label 117: @2410300
     /* 2410300 */ GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2410346), // Rule ID 261 //
     /* 2410305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2410308 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2410332 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2410335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2410344 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410345 */   // GIR_Coverage, 261,
     /* 2410345 */   GIR_EraseRootFromParent_Done,
     /* 2410346 */ // Label 34766: @2410346
     /* 2410346 */ GIM_Reject,
     /* 2410347 */ // Label 118: @2410347
     /* 2410347 */ GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2410393), // Rule ID 263 //
     /* 2410352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2410355 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2410379 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2410382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410384 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2410391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410392 */   // GIR_Coverage, 263,
     /* 2410392 */   GIR_EraseRootFromParent_Done,
     /* 2410393 */ // Label 34767: @2410393
     /* 2410393 */ GIM_Reject,
     /* 2410394 */ // Label 119: @2410394
     /* 2410394 */ GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2410440), // Rule ID 262 //
     /* 2410399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2410402 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2410405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2410411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2410419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2410426 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2410426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2410429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410431 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2410438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410439 */   // GIR_Coverage, 262,
     /* 2410439 */   GIR_EraseRootFromParent_Done,
     /* 2410440 */ // Label 34768: @2410440
     /* 2410440 */ GIM_Reject,
     /* 2410441 */ // Label 120: @2410441
     /* 2410441 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34776*/ GIMT_Encode4(2411089),
     /* 2410452 */ /*GILLT_nxv1s1*//*Label 34769*/ GIMT_Encode4(2410564), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410472 */ /*GILLT_nxv2s1*//*Label 34770*/ GIMT_Encode4(2410639), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410492 */ /*GILLT_nxv4s1*//*Label 34771*/ GIMT_Encode4(2410714), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410512 */ /*GILLT_nxv8s1*//*Label 34772*/ GIMT_Encode4(2410789), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410532 */ /*GILLT_nxv16s1*//*Label 34773*/ GIMT_Encode4(2410864), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410548 */ /*GILLT_nxv32s1*//*Label 34774*/ GIMT_Encode4(2410939), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2410560 */ /*GILLT_nxv64s1*//*Label 34775*/ GIMT_Encode4(2411014),
     /* 2410564 */ // Label 34769: @2410564
     /* 2410564 */ GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2410601), // Rule ID 44706 //
     /* 2410569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410586 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2410589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410600 */   // GIR_Coverage, 44706,
     /* 2410600 */   GIR_EraseRootFromParent_Done,
     /* 2410601 */ // Label 34777: @2410601
     /* 2410601 */ GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2410638), // Rule ID 44707 //
     /* 2410606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410616 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410623 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2410626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410637 */   // GIR_Coverage, 44707,
     /* 2410637 */   GIR_EraseRootFromParent_Done,
     /* 2410638 */ // Label 34778: @2410638
     /* 2410638 */ GIM_Reject,
     /* 2410639 */ // Label 34770: @2410639
     /* 2410639 */ GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2410676), // Rule ID 44734 //
     /* 2410644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410661 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2410664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410675 */   // GIR_Coverage, 44734,
     /* 2410675 */   GIR_EraseRootFromParent_Done,
     /* 2410676 */ // Label 34779: @2410676
     /* 2410676 */ GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2410713), // Rule ID 44735 //
     /* 2410681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410698 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2410701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410712 */   // GIR_Coverage, 44735,
     /* 2410712 */   GIR_EraseRootFromParent_Done,
     /* 2410713 */ // Label 34780: @2410713
     /* 2410713 */ GIM_Reject,
     /* 2410714 */ // Label 34771: @2410714
     /* 2410714 */ GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2410751), // Rule ID 44762 //
     /* 2410719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410729 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410736 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2410739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410750 */   // GIR_Coverage, 44762,
     /* 2410750 */   GIR_EraseRootFromParent_Done,
     /* 2410751 */ // Label 34781: @2410751
     /* 2410751 */ GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2410788), // Rule ID 44763 //
     /* 2410756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410773 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2410776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410787 */   // GIR_Coverage, 44763,
     /* 2410787 */   GIR_EraseRootFromParent_Done,
     /* 2410788 */ // Label 34782: @2410788
     /* 2410788 */ GIM_Reject,
     /* 2410789 */ // Label 34772: @2410789
     /* 2410789 */ GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2410826), // Rule ID 44790 //
     /* 2410794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410811 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2410814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410825 */   // GIR_Coverage, 44790,
     /* 2410825 */   GIR_EraseRootFromParent_Done,
     /* 2410826 */ // Label 34783: @2410826
     /* 2410826 */ GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2410863), // Rule ID 44791 //
     /* 2410831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410848 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2410851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410862 */   // GIR_Coverage, 44791,
     /* 2410862 */   GIR_EraseRootFromParent_Done,
     /* 2410863 */ // Label 34784: @2410863
     /* 2410863 */ GIM_Reject,
     /* 2410864 */ // Label 34773: @2410864
     /* 2410864 */ GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2410901), // Rule ID 44818 //
     /* 2410869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410886 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2410889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410900 */   // GIR_Coverage, 44818,
     /* 2410900 */   GIR_EraseRootFromParent_Done,
     /* 2410901 */ // Label 34785: @2410901
     /* 2410901 */ GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2410938), // Rule ID 44819 //
     /* 2410906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410923 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2410926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410937 */   // GIR_Coverage, 44819,
     /* 2410937 */   GIR_EraseRootFromParent_Done,
     /* 2410938 */ // Label 34786: @2410938
     /* 2410938 */ GIM_Reject,
     /* 2410939 */ // Label 34774: @2410939
     /* 2410939 */ GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2410976), // Rule ID 44846 //
     /* 2410944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2410950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410961 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2410961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2410964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2410975 */   // GIR_Coverage, 44846,
     /* 2410975 */   GIR_EraseRootFromParent_Done,
     /* 2410976 */ // Label 34787: @2410976
     /* 2410976 */ GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2411013), // Rule ID 44847 //
     /* 2410981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2410987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410998 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2410998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2411001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411012 */   // GIR_Coverage, 44847,
     /* 2411012 */   GIR_EraseRootFromParent_Done,
     /* 2411013 */ // Label 34788: @2411013
     /* 2411013 */ GIM_Reject,
     /* 2411014 */ // Label 34775: @2411014
     /* 2411014 */ GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2411051), // Rule ID 44874 //
     /* 2411019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411036 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2411039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411050 */   // GIR_Coverage, 44874,
     /* 2411050 */   GIR_EraseRootFromParent_Done,
     /* 2411051 */ // Label 34789: @2411051
     /* 2411051 */ GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2411088), // Rule ID 44875 //
     /* 2411056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411073 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2411076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411087 */   // GIR_Coverage, 44875,
     /* 2411087 */   GIR_EraseRootFromParent_Done,
     /* 2411088 */ // Label 34790: @2411088
     /* 2411088 */ GIM_Reject,
     /* 2411089 */ // Label 34776: @2411089
     /* 2411089 */ GIM_Reject,
     /* 2411090 */ // Label 121: @2411090
     /* 2411090 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34798*/ GIMT_Encode4(2411738),
     /* 2411101 */ /*GILLT_nxv1s1*//*Label 34791*/ GIMT_Encode4(2411213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411121 */ /*GILLT_nxv2s1*//*Label 34792*/ GIMT_Encode4(2411288), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411141 */ /*GILLT_nxv4s1*//*Label 34793*/ GIMT_Encode4(2411363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411161 */ /*GILLT_nxv8s1*//*Label 34794*/ GIMT_Encode4(2411438), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411181 */ /*GILLT_nxv16s1*//*Label 34795*/ GIMT_Encode4(2411513), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411197 */ /*GILLT_nxv32s1*//*Label 34796*/ GIMT_Encode4(2411588), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2411209 */ /*GILLT_nxv64s1*//*Label 34797*/ GIMT_Encode4(2411663),
     /* 2411213 */ // Label 34791: @2411213
     /* 2411213 */ GIM_Try, /*On fail goto*//*Label 34799*/ GIMT_Encode4(2411250), // Rule ID 44704 //
     /* 2411218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411235 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2411238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411249 */   // GIR_Coverage, 44704,
     /* 2411249 */   GIR_EraseRootFromParent_Done,
     /* 2411250 */ // Label 34799: @2411250
     /* 2411250 */ GIM_Try, /*On fail goto*//*Label 34800*/ GIMT_Encode4(2411287), // Rule ID 44705 //
     /* 2411255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411272 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2411275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411286 */   // GIR_Coverage, 44705,
     /* 2411286 */   GIR_EraseRootFromParent_Done,
     /* 2411287 */ // Label 34800: @2411287
     /* 2411287 */ GIM_Reject,
     /* 2411288 */ // Label 34792: @2411288
     /* 2411288 */ GIM_Try, /*On fail goto*//*Label 34801*/ GIMT_Encode4(2411325), // Rule ID 44732 //
     /* 2411293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411310 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2411313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411324 */   // GIR_Coverage, 44732,
     /* 2411324 */   GIR_EraseRootFromParent_Done,
     /* 2411325 */ // Label 34801: @2411325
     /* 2411325 */ GIM_Try, /*On fail goto*//*Label 34802*/ GIMT_Encode4(2411362), // Rule ID 44733 //
     /* 2411330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411347 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2411350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411361 */   // GIR_Coverage, 44733,
     /* 2411361 */   GIR_EraseRootFromParent_Done,
     /* 2411362 */ // Label 34802: @2411362
     /* 2411362 */ GIM_Reject,
     /* 2411363 */ // Label 34793: @2411363
     /* 2411363 */ GIM_Try, /*On fail goto*//*Label 34803*/ GIMT_Encode4(2411400), // Rule ID 44760 //
     /* 2411368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411385 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2411388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411399 */   // GIR_Coverage, 44760,
     /* 2411399 */   GIR_EraseRootFromParent_Done,
     /* 2411400 */ // Label 34803: @2411400
     /* 2411400 */ GIM_Try, /*On fail goto*//*Label 34804*/ GIMT_Encode4(2411437), // Rule ID 44761 //
     /* 2411405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411422 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2411425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411436 */   // GIR_Coverage, 44761,
     /* 2411436 */   GIR_EraseRootFromParent_Done,
     /* 2411437 */ // Label 34804: @2411437
     /* 2411437 */ GIM_Reject,
     /* 2411438 */ // Label 34794: @2411438
     /* 2411438 */ GIM_Try, /*On fail goto*//*Label 34805*/ GIMT_Encode4(2411475), // Rule ID 44788 //
     /* 2411443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411460 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2411463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411474 */   // GIR_Coverage, 44788,
     /* 2411474 */   GIR_EraseRootFromParent_Done,
     /* 2411475 */ // Label 34805: @2411475
     /* 2411475 */ GIM_Try, /*On fail goto*//*Label 34806*/ GIMT_Encode4(2411512), // Rule ID 44789 //
     /* 2411480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411497 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2411500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411511 */   // GIR_Coverage, 44789,
     /* 2411511 */   GIR_EraseRootFromParent_Done,
     /* 2411512 */ // Label 34806: @2411512
     /* 2411512 */ GIM_Reject,
     /* 2411513 */ // Label 34795: @2411513
     /* 2411513 */ GIM_Try, /*On fail goto*//*Label 34807*/ GIMT_Encode4(2411550), // Rule ID 44816 //
     /* 2411518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411535 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2411538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411549 */   // GIR_Coverage, 44816,
     /* 2411549 */   GIR_EraseRootFromParent_Done,
     /* 2411550 */ // Label 34807: @2411550
     /* 2411550 */ GIM_Try, /*On fail goto*//*Label 34808*/ GIMT_Encode4(2411587), // Rule ID 44817 //
     /* 2411555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411572 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2411575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411585 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411586 */   // GIR_Coverage, 44817,
     /* 2411586 */   GIR_EraseRootFromParent_Done,
     /* 2411587 */ // Label 34808: @2411587
     /* 2411587 */ GIM_Reject,
     /* 2411588 */ // Label 34796: @2411588
     /* 2411588 */ GIM_Try, /*On fail goto*//*Label 34809*/ GIMT_Encode4(2411625), // Rule ID 44844 //
     /* 2411593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411610 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2411613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411624 */   // GIR_Coverage, 44844,
     /* 2411624 */   GIR_EraseRootFromParent_Done,
     /* 2411625 */ // Label 34809: @2411625
     /* 2411625 */ GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2411662), // Rule ID 44845 //
     /* 2411630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411647 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2411650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411660 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411661 */   // GIR_Coverage, 44845,
     /* 2411661 */   GIR_EraseRootFromParent_Done,
     /* 2411662 */ // Label 34810: @2411662
     /* 2411662 */ GIM_Reject,
     /* 2411663 */ // Label 34797: @2411663
     /* 2411663 */ GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2411700), // Rule ID 44872 //
     /* 2411668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2411674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411685 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2411685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2411688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411699 */   // GIR_Coverage, 44872,
     /* 2411699 */   GIR_EraseRootFromParent_Done,
     /* 2411700 */ // Label 34811: @2411700
     /* 2411700 */ GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2411737), // Rule ID 44873 //
     /* 2411705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2411711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411722 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2411722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2411725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2411736 */   // GIR_Coverage, 44873,
     /* 2411736 */   GIR_EraseRootFromParent_Done,
     /* 2411737 */ // Label 34812: @2411737
     /* 2411737 */ GIM_Reject,
     /* 2411738 */ // Label 34798: @2411738
     /* 2411738 */ GIM_Reject,
     /* 2411739 */ // Label 122: @2411739
     /* 2411739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 34835*/ GIMT_Encode4(2415996),
     /* 2411750 */ /*GILLT_nxv1s8*//*Label 34813*/ GIMT_Encode4(2411862),
     /* 2411754 */ /*GILLT_nxv1s16*//*Label 34814*/ GIMT_Encode4(2411979),
     /* 2411758 */ /*GILLT_nxv1s32*//*Label 34815*/ GIMT_Encode4(2412200),
     /* 2411762 */ /*GILLT_nxv1s64*//*Label 34816*/ GIMT_Encode4(2412421), GIMT_Encode4(0),
     /* 2411770 */ /*GILLT_nxv2s8*//*Label 34817*/ GIMT_Encode4(2412642),
     /* 2411774 */ /*GILLT_nxv2s16*//*Label 34818*/ GIMT_Encode4(2412759),
     /* 2411778 */ /*GILLT_nxv2s32*//*Label 34819*/ GIMT_Encode4(2412980),
     /* 2411782 */ /*GILLT_nxv2s64*//*Label 34820*/ GIMT_Encode4(2413201), GIMT_Encode4(0),
     /* 2411790 */ /*GILLT_nxv4s8*//*Label 34821*/ GIMT_Encode4(2413422),
     /* 2411794 */ /*GILLT_nxv4s16*//*Label 34822*/ GIMT_Encode4(2413539),
     /* 2411798 */ /*GILLT_nxv4s32*//*Label 34823*/ GIMT_Encode4(2413760),
     /* 2411802 */ /*GILLT_nxv4s64*//*Label 34824*/ GIMT_Encode4(2413981), GIMT_Encode4(0),
     /* 2411810 */ /*GILLT_nxv8s8*//*Label 34825*/ GIMT_Encode4(2414202),
     /* 2411814 */ /*GILLT_nxv8s16*//*Label 34826*/ GIMT_Encode4(2414319),
     /* 2411818 */ /*GILLT_nxv8s32*//*Label 34827*/ GIMT_Encode4(2414540),
     /* 2411822 */ /*GILLT_nxv8s64*//*Label 34828*/ GIMT_Encode4(2414761), GIMT_Encode4(0),
     /* 2411830 */ /*GILLT_nxv16s8*//*Label 34829*/ GIMT_Encode4(2414982),
     /* 2411834 */ /*GILLT_nxv16s16*//*Label 34830*/ GIMT_Encode4(2415099),
     /* 2411838 */ /*GILLT_nxv16s32*//*Label 34831*/ GIMT_Encode4(2415320), GIMT_Encode4(0),
     /* 2411846 */ /*GILLT_nxv32s8*//*Label 34832*/ GIMT_Encode4(2415541),
     /* 2411850 */ /*GILLT_nxv32s16*//*Label 34833*/ GIMT_Encode4(2415658), GIMT_Encode4(0),
     /* 2411858 */ /*GILLT_nxv64s8*//*Label 34834*/ GIMT_Encode4(2415879),
     /* 2411862 */ // Label 34813: @2411862
     /* 2411862 */ GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2411978),
     /* 2411867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2411870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2411873 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2411925), // Rule ID 32294 //
     /* 2411878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411903 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2411906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411908 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411924 */     // GIR_Coverage, 32294,
     /* 2411924 */     GIR_EraseRootFromParent_Done,
     /* 2411925 */   // Label 34837: @2411925
     /* 2411925 */   GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2411977), // Rule ID 32295 //
     /* 2411930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411955 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2411958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411960 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411976 */     // GIR_Coverage, 32295,
     /* 2411976 */     GIR_EraseRootFromParent_Done,
     /* 2411977 */   // Label 34838: @2411977
     /* 2411977 */   GIM_Reject,
     /* 2411978 */ // Label 34836: @2411978
     /* 2411978 */ GIM_Reject,
     /* 2411979 */ // Label 34814: @2411979
     /* 2411979 */ GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2412199),
     /* 2411984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2411987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2411990 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2412042), // Rule ID 32564 //
     /* 2411995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412020 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412025 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412041 */     // GIR_Coverage, 32564,
     /* 2412041 */     GIR_EraseRootFromParent_Done,
     /* 2412042 */   // Label 34840: @2412042
     /* 2412042 */   GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2412094), // Rule ID 32565 //
     /* 2412047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412072 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412077 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412093 */     // GIR_Coverage, 32565,
     /* 2412093 */     GIR_EraseRootFromParent_Done,
     /* 2412094 */   // Label 34841: @2412094
     /* 2412094 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2412146), // Rule ID 34274 //
     /* 2412099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412124 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412129 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412145 */     // GIR_Coverage, 34274,
     /* 2412145 */     GIR_EraseRootFromParent_Done,
     /* 2412146 */   // Label 34842: @2412146
     /* 2412146 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2412198), // Rule ID 34275 //
     /* 2412151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412176 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412181 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412197 */     // GIR_Coverage, 34275,
     /* 2412197 */     GIR_EraseRootFromParent_Done,
     /* 2412198 */   // Label 34843: @2412198
     /* 2412198 */   GIM_Reject,
     /* 2412199 */ // Label 34839: @2412199
     /* 2412199 */ GIM_Reject,
     /* 2412200 */ // Label 34815: @2412200
     /* 2412200 */ GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2412420),
     /* 2412205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2412208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2412211 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2412263), // Rule ID 32744 //
     /* 2412216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412241 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412246 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412262 */     // GIR_Coverage, 32744,
     /* 2412262 */     GIR_EraseRootFromParent_Done,
     /* 2412263 */   // Label 34845: @2412263
     /* 2412263 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2412315), // Rule ID 32745 //
     /* 2412268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412293 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412298 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412314 */     // GIR_Coverage, 32745,
     /* 2412314 */     GIR_EraseRootFromParent_Done,
     /* 2412315 */   // Label 34846: @2412315
     /* 2412315 */   GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2412367), // Rule ID 34454 //
     /* 2412320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412345 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412350 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412366 */     // GIR_Coverage, 34454,
     /* 2412366 */     GIR_EraseRootFromParent_Done,
     /* 2412367 */   // Label 34847: @2412367
     /* 2412367 */   GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2412419), // Rule ID 34455 //
     /* 2412372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412397 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412402 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412418 */     // GIR_Coverage, 34455,
     /* 2412418 */     GIR_EraseRootFromParent_Done,
     /* 2412419 */   // Label 34848: @2412419
     /* 2412419 */   GIM_Reject,
     /* 2412420 */ // Label 34844: @2412420
     /* 2412420 */ GIM_Reject,
     /* 2412421 */ // Label 34816: @2412421
     /* 2412421 */ GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2412641),
     /* 2412426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2412429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2412432 */   GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2412484), // Rule ID 33104 //
     /* 2412437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2412440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412462 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2412465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412467 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412483 */     // GIR_Coverage, 33104,
     /* 2412483 */     GIR_EraseRootFromParent_Done,
     /* 2412484 */   // Label 34850: @2412484
     /* 2412484 */   GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2412536), // Rule ID 33105 //
     /* 2412489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2412492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412514 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2412517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412519 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412535 */     // GIR_Coverage, 33105,
     /* 2412535 */     GIR_EraseRootFromParent_Done,
     /* 2412536 */   // Label 34851: @2412536
     /* 2412536 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2412588), // Rule ID 34724 //
     /* 2412541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2412544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412566 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2412569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412571 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412587 */     // GIR_Coverage, 34724,
     /* 2412587 */     GIR_EraseRootFromParent_Done,
     /* 2412588 */   // Label 34852: @2412588
     /* 2412588 */   GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2412640), // Rule ID 34725 //
     /* 2412593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2412596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412618 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2412621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412623 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412639 */     // GIR_Coverage, 34725,
     /* 2412639 */     GIR_EraseRootFromParent_Done,
     /* 2412640 */   // Label 34853: @2412640
     /* 2412640 */   GIM_Reject,
     /* 2412641 */ // Label 34849: @2412641
     /* 2412641 */ GIM_Reject,
     /* 2412642 */ // Label 34817: @2412642
     /* 2412642 */ GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2412758),
     /* 2412647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2412650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2412653 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2412705), // Rule ID 32384 //
     /* 2412658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412683 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412688 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2412700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412704 */     // GIR_Coverage, 32384,
     /* 2412704 */     GIR_EraseRootFromParent_Done,
     /* 2412705 */   // Label 34855: @2412705
     /* 2412705 */   GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2412757), // Rule ID 32385 //
     /* 2412710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412735 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2412738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412740 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2412752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412756 */     // GIR_Coverage, 32385,
     /* 2412756 */     GIR_EraseRootFromParent_Done,
     /* 2412757 */   // Label 34856: @2412757
     /* 2412757 */   GIM_Reject,
     /* 2412758 */ // Label 34854: @2412758
     /* 2412758 */ GIM_Reject,
     /* 2412759 */ // Label 34818: @2412759
     /* 2412759 */ GIM_Try, /*On fail goto*//*Label 34857*/ GIMT_Encode4(2412979),
     /* 2412764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2412767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2412770 */   GIM_Try, /*On fail goto*//*Label 34858*/ GIMT_Encode4(2412822), // Rule ID 32654 //
     /* 2412775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412800 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412805 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412821 */     // GIR_Coverage, 32654,
     /* 2412821 */     GIR_EraseRootFromParent_Done,
     /* 2412822 */   // Label 34858: @2412822
     /* 2412822 */   GIM_Try, /*On fail goto*//*Label 34859*/ GIMT_Encode4(2412874), // Rule ID 32655 //
     /* 2412827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412852 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412857 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412873 */     // GIR_Coverage, 32655,
     /* 2412873 */     GIR_EraseRootFromParent_Done,
     /* 2412874 */   // Label 34859: @2412874
     /* 2412874 */   GIM_Try, /*On fail goto*//*Label 34860*/ GIMT_Encode4(2412926), // Rule ID 34364 //
     /* 2412879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412904 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2412904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412909 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412925 */     // GIR_Coverage, 34364,
     /* 2412925 */     GIR_EraseRootFromParent_Done,
     /* 2412926 */   // Label 34860: @2412926
     /* 2412926 */   GIM_Try, /*On fail goto*//*Label 34861*/ GIMT_Encode4(2412978), // Rule ID 34365 //
     /* 2412931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412956 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2412956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2412959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412961 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2412963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2412965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2412976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412977 */     // GIR_Coverage, 34365,
     /* 2412977 */     GIR_EraseRootFromParent_Done,
     /* 2412978 */   // Label 34861: @2412978
     /* 2412978 */   GIM_Reject,
     /* 2412979 */ // Label 34857: @2412979
     /* 2412979 */ GIM_Reject,
     /* 2412980 */ // Label 34819: @2412980
     /* 2412980 */ GIM_Try, /*On fail goto*//*Label 34862*/ GIMT_Encode4(2413200),
     /* 2412985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2412988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2412991 */   GIM_Try, /*On fail goto*//*Label 34863*/ GIMT_Encode4(2413043), // Rule ID 33014 //
     /* 2412996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413021 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413026 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413042 */     // GIR_Coverage, 33014,
     /* 2413042 */     GIR_EraseRootFromParent_Done,
     /* 2413043 */   // Label 34863: @2413043
     /* 2413043 */   GIM_Try, /*On fail goto*//*Label 34864*/ GIMT_Encode4(2413095), // Rule ID 33015 //
     /* 2413048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413073 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413078 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413094 */     // GIR_Coverage, 33015,
     /* 2413094 */     GIR_EraseRootFromParent_Done,
     /* 2413095 */   // Label 34864: @2413095
     /* 2413095 */   GIM_Try, /*On fail goto*//*Label 34865*/ GIMT_Encode4(2413147), // Rule ID 34634 //
     /* 2413100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413125 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413130 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413146 */     // GIR_Coverage, 34634,
     /* 2413146 */     GIR_EraseRootFromParent_Done,
     /* 2413147 */   // Label 34865: @2413147
     /* 2413147 */   GIM_Try, /*On fail goto*//*Label 34866*/ GIMT_Encode4(2413199), // Rule ID 34635 //
     /* 2413152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413177 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413182 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413198 */     // GIR_Coverage, 34635,
     /* 2413198 */     GIR_EraseRootFromParent_Done,
     /* 2413199 */   // Label 34866: @2413199
     /* 2413199 */   GIM_Reject,
     /* 2413200 */ // Label 34862: @2413200
     /* 2413200 */ GIM_Reject,
     /* 2413201 */ // Label 34820: @2413201
     /* 2413201 */ GIM_Try, /*On fail goto*//*Label 34867*/ GIMT_Encode4(2413421),
     /* 2413206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2413209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2413212 */   GIM_Try, /*On fail goto*//*Label 34868*/ GIMT_Encode4(2413264), // Rule ID 34004 //
     /* 2413217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413242 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413247 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413263 */     // GIR_Coverage, 34004,
     /* 2413263 */     GIR_EraseRootFromParent_Done,
     /* 2413264 */   // Label 34868: @2413264
     /* 2413264 */   GIM_Try, /*On fail goto*//*Label 34869*/ GIMT_Encode4(2413316), // Rule ID 34005 //
     /* 2413269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413294 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413299 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413315 */     // GIR_Coverage, 34005,
     /* 2413315 */     GIR_EraseRootFromParent_Done,
     /* 2413316 */   // Label 34869: @2413316
     /* 2413316 */   GIM_Try, /*On fail goto*//*Label 34870*/ GIMT_Encode4(2413368), // Rule ID 35354 //
     /* 2413321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413346 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413351 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413367 */     // GIR_Coverage, 35354,
     /* 2413367 */     GIR_EraseRootFromParent_Done,
     /* 2413368 */   // Label 34870: @2413368
     /* 2413368 */   GIM_Try, /*On fail goto*//*Label 34871*/ GIMT_Encode4(2413420), // Rule ID 35355 //
     /* 2413373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413398 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413403 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413419 */     // GIR_Coverage, 35355,
     /* 2413419 */     GIR_EraseRootFromParent_Done,
     /* 2413420 */   // Label 34871: @2413420
     /* 2413420 */   GIM_Reject,
     /* 2413421 */ // Label 34867: @2413421
     /* 2413421 */ GIM_Reject,
     /* 2413422 */ // Label 34821: @2413422
     /* 2413422 */ GIM_Try, /*On fail goto*//*Label 34872*/ GIMT_Encode4(2413538),
     /* 2413427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2413430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2413433 */   GIM_Try, /*On fail goto*//*Label 34873*/ GIMT_Encode4(2413485), // Rule ID 32474 //
     /* 2413438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413463 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2413466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413468 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2413480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413484 */     // GIR_Coverage, 32474,
     /* 2413484 */     GIR_EraseRootFromParent_Done,
     /* 2413485 */   // Label 34873: @2413485
     /* 2413485 */   GIM_Try, /*On fail goto*//*Label 34874*/ GIMT_Encode4(2413537), // Rule ID 32475 //
     /* 2413490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413515 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2413518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413520 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2413532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413536 */     // GIR_Coverage, 32475,
     /* 2413536 */     GIR_EraseRootFromParent_Done,
     /* 2413537 */   // Label 34874: @2413537
     /* 2413537 */   GIM_Reject,
     /* 2413538 */ // Label 34872: @2413538
     /* 2413538 */ GIM_Reject,
     /* 2413539 */ // Label 34822: @2413539
     /* 2413539 */ GIM_Try, /*On fail goto*//*Label 34875*/ GIMT_Encode4(2413759),
     /* 2413544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2413547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2413550 */   GIM_Try, /*On fail goto*//*Label 34876*/ GIMT_Encode4(2413602), // Rule ID 32924 //
     /* 2413555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413580 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413585 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413601 */     // GIR_Coverage, 32924,
     /* 2413601 */     GIR_EraseRootFromParent_Done,
     /* 2413602 */   // Label 34876: @2413602
     /* 2413602 */   GIM_Try, /*On fail goto*//*Label 34877*/ GIMT_Encode4(2413654), // Rule ID 32925 //
     /* 2413607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413632 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413637 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413653 */     // GIR_Coverage, 32925,
     /* 2413653 */     GIR_EraseRootFromParent_Done,
     /* 2413654 */   // Label 34877: @2413654
     /* 2413654 */   GIM_Try, /*On fail goto*//*Label 34878*/ GIMT_Encode4(2413706), // Rule ID 34544 //
     /* 2413659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413684 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413689 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413705 */     // GIR_Coverage, 34544,
     /* 2413705 */     GIR_EraseRootFromParent_Done,
     /* 2413706 */   // Label 34878: @2413706
     /* 2413706 */   GIM_Try, /*On fail goto*//*Label 34879*/ GIMT_Encode4(2413758), // Rule ID 34545 //
     /* 2413711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413736 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2413739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413741 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413757 */     // GIR_Coverage, 34545,
     /* 2413757 */     GIR_EraseRootFromParent_Done,
     /* 2413758 */   // Label 34879: @2413758
     /* 2413758 */   GIM_Reject,
     /* 2413759 */ // Label 34875: @2413759
     /* 2413759 */ GIM_Reject,
     /* 2413760 */ // Label 34823: @2413760
     /* 2413760 */ GIM_Try, /*On fail goto*//*Label 34880*/ GIMT_Encode4(2413980),
     /* 2413765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2413768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2413771 */   GIM_Try, /*On fail goto*//*Label 34881*/ GIMT_Encode4(2413823), // Rule ID 33734 //
     /* 2413776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413801 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413806 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413822 */     // GIR_Coverage, 33734,
     /* 2413822 */     GIR_EraseRootFromParent_Done,
     /* 2413823 */   // Label 34881: @2413823
     /* 2413823 */   GIM_Try, /*On fail goto*//*Label 34882*/ GIMT_Encode4(2413875), // Rule ID 33735 //
     /* 2413828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413853 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413858 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413874 */     // GIR_Coverage, 33735,
     /* 2413874 */     GIR_EraseRootFromParent_Done,
     /* 2413875 */   // Label 34882: @2413875
     /* 2413875 */   GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2413927), // Rule ID 35084 //
     /* 2413880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413905 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2413905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413910 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413926 */     // GIR_Coverage, 35084,
     /* 2413926 */     GIR_EraseRootFromParent_Done,
     /* 2413927 */   // Label 34883: @2413927
     /* 2413927 */   GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2413979), // Rule ID 35085 //
     /* 2413932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413957 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2413957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2413960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413962 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2413964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2413966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2413977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413978 */     // GIR_Coverage, 35085,
     /* 2413978 */     GIR_EraseRootFromParent_Done,
     /* 2413979 */   // Label 34884: @2413979
     /* 2413979 */   GIM_Reject,
     /* 2413980 */ // Label 34880: @2413980
     /* 2413980 */ GIM_Reject,
     /* 2413981 */ // Label 34824: @2413981
     /* 2413981 */ GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2414201),
     /* 2413986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2413992 */   GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2414044), // Rule ID 34094 //
     /* 2413997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2414000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414022 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414027 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414043 */     // GIR_Coverage, 34094,
     /* 2414043 */     GIR_EraseRootFromParent_Done,
     /* 2414044 */   // Label 34886: @2414044
     /* 2414044 */   GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2414096), // Rule ID 34095 //
     /* 2414049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2414052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414074 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414079 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414095 */     // GIR_Coverage, 34095,
     /* 2414095 */     GIR_EraseRootFromParent_Done,
     /* 2414096 */   // Label 34887: @2414096
     /* 2414096 */   GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2414148), // Rule ID 35444 //
     /* 2414101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2414104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414126 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414131 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414147 */     // GIR_Coverage, 35444,
     /* 2414147 */     GIR_EraseRootFromParent_Done,
     /* 2414148 */   // Label 34888: @2414148
     /* 2414148 */   GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2414200), // Rule ID 35445 //
     /* 2414153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2414156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414178 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414183 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414199 */     // GIR_Coverage, 35445,
     /* 2414199 */     GIR_EraseRootFromParent_Done,
     /* 2414200 */   // Label 34889: @2414200
     /* 2414200 */   GIM_Reject,
     /* 2414201 */ // Label 34885: @2414201
     /* 2414201 */ GIM_Reject,
     /* 2414202 */ // Label 34825: @2414202
     /* 2414202 */ GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2414318),
     /* 2414207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2414210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2414213 */   GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2414265), // Rule ID 32834 //
     /* 2414218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414243 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2414246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414248 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414264 */     // GIR_Coverage, 32834,
     /* 2414264 */     GIR_EraseRootFromParent_Done,
     /* 2414265 */   // Label 34891: @2414265
     /* 2414265 */   GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2414317), // Rule ID 32835 //
     /* 2414270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414295 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2414298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414300 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414316 */     // GIR_Coverage, 32835,
     /* 2414316 */     GIR_EraseRootFromParent_Done,
     /* 2414317 */   // Label 34892: @2414317
     /* 2414317 */   GIM_Reject,
     /* 2414318 */ // Label 34890: @2414318
     /* 2414318 */ GIM_Reject,
     /* 2414319 */ // Label 34826: @2414319
     /* 2414319 */ GIM_Try, /*On fail goto*//*Label 34893*/ GIMT_Encode4(2414539),
     /* 2414324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2414327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2414330 */   GIM_Try, /*On fail goto*//*Label 34894*/ GIMT_Encode4(2414382), // Rule ID 33464 //
     /* 2414335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414360 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2414363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414365 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414381 */     // GIR_Coverage, 33464,
     /* 2414381 */     GIR_EraseRootFromParent_Done,
     /* 2414382 */   // Label 34894: @2414382
     /* 2414382 */   GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2414434), // Rule ID 33465 //
     /* 2414387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414412 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2414415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414417 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414433 */     // GIR_Coverage, 33465,
     /* 2414433 */     GIR_EraseRootFromParent_Done,
     /* 2414434 */   // Label 34895: @2414434
     /* 2414434 */   GIM_Try, /*On fail goto*//*Label 34896*/ GIMT_Encode4(2414486), // Rule ID 34814 //
     /* 2414439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414464 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2414467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414469 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414485 */     // GIR_Coverage, 34814,
     /* 2414485 */     GIR_EraseRootFromParent_Done,
     /* 2414486 */   // Label 34896: @2414486
     /* 2414486 */   GIM_Try, /*On fail goto*//*Label 34897*/ GIMT_Encode4(2414538), // Rule ID 34815 //
     /* 2414491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414516 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2414519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414521 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414537 */     // GIR_Coverage, 34815,
     /* 2414537 */     GIR_EraseRootFromParent_Done,
     /* 2414538 */   // Label 34897: @2414538
     /* 2414538 */   GIM_Reject,
     /* 2414539 */ // Label 34893: @2414539
     /* 2414539 */ GIM_Reject,
     /* 2414540 */ // Label 34827: @2414540
     /* 2414540 */ GIM_Try, /*On fail goto*//*Label 34898*/ GIMT_Encode4(2414760),
     /* 2414545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2414551 */   GIM_Try, /*On fail goto*//*Label 34899*/ GIMT_Encode4(2414603), // Rule ID 33824 //
     /* 2414556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414581 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414586 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414602 */     // GIR_Coverage, 33824,
     /* 2414602 */     GIR_EraseRootFromParent_Done,
     /* 2414603 */   // Label 34899: @2414603
     /* 2414603 */   GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2414655), // Rule ID 33825 //
     /* 2414608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414633 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414638 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414654 */     // GIR_Coverage, 33825,
     /* 2414654 */     GIR_EraseRootFromParent_Done,
     /* 2414655 */   // Label 34900: @2414655
     /* 2414655 */   GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2414707), // Rule ID 35174 //
     /* 2414660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414685 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414690 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414706 */     // GIR_Coverage, 35174,
     /* 2414706 */     GIR_EraseRootFromParent_Done,
     /* 2414707 */   // Label 34901: @2414707
     /* 2414707 */   GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2414759), // Rule ID 35175 //
     /* 2414712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414737 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2414740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414742 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414758 */     // GIR_Coverage, 35175,
     /* 2414758 */     GIR_EraseRootFromParent_Done,
     /* 2414759 */   // Label 34902: @2414759
     /* 2414759 */   GIM_Reject,
     /* 2414760 */ // Label 34898: @2414760
     /* 2414760 */ GIM_Reject,
     /* 2414761 */ // Label 34828: @2414761
     /* 2414761 */ GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2414981),
     /* 2414766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2414769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2414772 */   GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2414824), // Rule ID 34184 //
     /* 2414777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2414780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414802 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2414805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414807 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414823 */     // GIR_Coverage, 34184,
     /* 2414823 */     GIR_EraseRootFromParent_Done,
     /* 2414824 */   // Label 34904: @2414824
     /* 2414824 */   GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2414876), // Rule ID 34185 //
     /* 2414829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2414832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414854 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2414857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414859 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414875 */     // GIR_Coverage, 34185,
     /* 2414875 */     GIR_EraseRootFromParent_Done,
     /* 2414876 */   // Label 34905: @2414876
     /* 2414876 */   GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2414928), // Rule ID 35534 //
     /* 2414881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2414884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414906 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2414906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2414909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414911 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414927 */     // GIR_Coverage, 35534,
     /* 2414927 */     GIR_EraseRootFromParent_Done,
     /* 2414928 */   // Label 34906: @2414928
     /* 2414928 */   GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2414980), // Rule ID 35535 //
     /* 2414933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2414936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414958 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2414958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2414961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414963 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2414965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2414967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2414978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414979 */     // GIR_Coverage, 35535,
     /* 2414979 */     GIR_EraseRootFromParent_Done,
     /* 2414980 */   // Label 34907: @2414980
     /* 2414980 */   GIM_Reject,
     /* 2414981 */ // Label 34903: @2414981
     /* 2414981 */ GIM_Reject,
     /* 2414982 */ // Label 34829: @2414982
     /* 2414982 */ GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2415098),
     /* 2414987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2414990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2414993 */   GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2415045), // Rule ID 33194 //
     /* 2414998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415023 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2415026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415028 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415044 */     // GIR_Coverage, 33194,
     /* 2415044 */     GIR_EraseRootFromParent_Done,
     /* 2415045 */   // Label 34909: @2415045
     /* 2415045 */   GIM_Try, /*On fail goto*//*Label 34910*/ GIMT_Encode4(2415097), // Rule ID 33195 //
     /* 2415050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415075 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2415078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415080 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415096 */     // GIR_Coverage, 33195,
     /* 2415096 */     GIR_EraseRootFromParent_Done,
     /* 2415097 */   // Label 34910: @2415097
     /* 2415097 */   GIM_Reject,
     /* 2415098 */ // Label 34908: @2415098
     /* 2415098 */ GIM_Reject,
     /* 2415099 */ // Label 34830: @2415099
     /* 2415099 */ GIM_Try, /*On fail goto*//*Label 34911*/ GIMT_Encode4(2415319),
     /* 2415104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2415110 */   GIM_Try, /*On fail goto*//*Label 34912*/ GIMT_Encode4(2415162), // Rule ID 33554 //
     /* 2415115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415140 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415145 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415161 */     // GIR_Coverage, 33554,
     /* 2415161 */     GIR_EraseRootFromParent_Done,
     /* 2415162 */   // Label 34912: @2415162
     /* 2415162 */   GIM_Try, /*On fail goto*//*Label 34913*/ GIMT_Encode4(2415214), // Rule ID 33555 //
     /* 2415167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415192 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415197 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415213 */     // GIR_Coverage, 33555,
     /* 2415213 */     GIR_EraseRootFromParent_Done,
     /* 2415214 */   // Label 34913: @2415214
     /* 2415214 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2415266), // Rule ID 34904 //
     /* 2415219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415244 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415249 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415265 */     // GIR_Coverage, 34904,
     /* 2415265 */     GIR_EraseRootFromParent_Done,
     /* 2415266 */   // Label 34914: @2415266
     /* 2415266 */   GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2415318), // Rule ID 34905 //
     /* 2415271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415296 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415301 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415317 */     // GIR_Coverage, 34905,
     /* 2415317 */     GIR_EraseRootFromParent_Done,
     /* 2415318 */   // Label 34915: @2415318
     /* 2415318 */   GIM_Reject,
     /* 2415319 */ // Label 34911: @2415319
     /* 2415319 */ GIM_Reject,
     /* 2415320 */ // Label 34831: @2415320
     /* 2415320 */ GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2415540),
     /* 2415325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2415328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2415331 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2415383), // Rule ID 33914 //
     /* 2415336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415361 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415366 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415382 */     // GIR_Coverage, 33914,
     /* 2415382 */     GIR_EraseRootFromParent_Done,
     /* 2415383 */   // Label 34917: @2415383
     /* 2415383 */   GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2415435), // Rule ID 33915 //
     /* 2415388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415413 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415418 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415434 */     // GIR_Coverage, 33915,
     /* 2415434 */     GIR_EraseRootFromParent_Done,
     /* 2415435 */   // Label 34918: @2415435
     /* 2415435 */   GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2415487), // Rule ID 35264 //
     /* 2415440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415465 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415470 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415486 */     // GIR_Coverage, 35264,
     /* 2415486 */     GIR_EraseRootFromParent_Done,
     /* 2415487 */   // Label 34919: @2415487
     /* 2415487 */   GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2415539), // Rule ID 35265 //
     /* 2415492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415517 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415522 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415538 */     // GIR_Coverage, 35265,
     /* 2415538 */     GIR_EraseRootFromParent_Done,
     /* 2415539 */   // Label 34920: @2415539
     /* 2415539 */   GIM_Reject,
     /* 2415540 */ // Label 34916: @2415540
     /* 2415540 */ GIM_Reject,
     /* 2415541 */ // Label 34832: @2415541
     /* 2415541 */ GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2415657),
     /* 2415546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2415549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2415552 */   GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2415604), // Rule ID 33284 //
     /* 2415557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415582 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415587 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415603 */     // GIR_Coverage, 33284,
     /* 2415603 */     GIR_EraseRootFromParent_Done,
     /* 2415604 */   // Label 34922: @2415604
     /* 2415604 */   GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2415656), // Rule ID 33285 //
     /* 2415609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415634 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2415637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415639 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415655 */     // GIR_Coverage, 33285,
     /* 2415655 */     GIR_EraseRootFromParent_Done,
     /* 2415656 */   // Label 34923: @2415656
     /* 2415656 */   GIM_Reject,
     /* 2415657 */ // Label 34921: @2415657
     /* 2415657 */ GIM_Reject,
     /* 2415658 */ // Label 34833: @2415658
     /* 2415658 */ GIM_Try, /*On fail goto*//*Label 34924*/ GIMT_Encode4(2415878),
     /* 2415663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2415666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2415669 */   GIM_Try, /*On fail goto*//*Label 34925*/ GIMT_Encode4(2415721), // Rule ID 33644 //
     /* 2415674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415699 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415704 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415720 */     // GIR_Coverage, 33644,
     /* 2415720 */     GIR_EraseRootFromParent_Done,
     /* 2415721 */   // Label 34925: @2415721
     /* 2415721 */   GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2415773), // Rule ID 33645 //
     /* 2415726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415751 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415756 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415772 */     // GIR_Coverage, 33645,
     /* 2415772 */     GIR_EraseRootFromParent_Done,
     /* 2415773 */   // Label 34926: @2415773
     /* 2415773 */   GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2415825), // Rule ID 34994 //
     /* 2415778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415803 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415808 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415824 */     // GIR_Coverage, 34994,
     /* 2415824 */     GIR_EraseRootFromParent_Done,
     /* 2415825 */   // Label 34927: @2415825
     /* 2415825 */   GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2415877), // Rule ID 34995 //
     /* 2415830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415855 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415860 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415876 */     // GIR_Coverage, 34995,
     /* 2415876 */     GIR_EraseRootFromParent_Done,
     /* 2415877 */   // Label 34928: @2415877
     /* 2415877 */   GIM_Reject,
     /* 2415878 */ // Label 34924: @2415878
     /* 2415878 */ GIM_Reject,
     /* 2415879 */ // Label 34834: @2415879
     /* 2415879 */ GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2415995),
     /* 2415884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2415887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2415890 */   GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2415942), // Rule ID 33374 //
     /* 2415895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415920 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2415920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415925 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415941 */     // GIR_Coverage, 33374,
     /* 2415941 */     GIR_EraseRootFromParent_Done,
     /* 2415942 */   // Label 34930: @2415942
     /* 2415942 */   GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2415994), // Rule ID 33375 //
     /* 2415947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415972 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2415972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2415975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415977 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2415979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2415981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2415989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2415992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415993 */     // GIR_Coverage, 33375,
     /* 2415993 */     GIR_EraseRootFromParent_Done,
     /* 2415994 */   // Label 34931: @2415994
     /* 2415994 */   GIM_Reject,
     /* 2415995 */ // Label 34929: @2415995
     /* 2415995 */ GIM_Reject,
     /* 2415996 */ // Label 34835: @2415996
     /* 2415996 */ GIM_Reject,
     /* 2415997 */ // Label 123: @2415997
     /* 2415997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 34954*/ GIMT_Encode4(2427876),
     /* 2416008 */ /*GILLT_nxv1s8*//*Label 34932*/ GIMT_Encode4(2416120),
     /* 2416012 */ /*GILLT_nxv1s16*//*Label 34933*/ GIMT_Encode4(2416443),
     /* 2416016 */ /*GILLT_nxv1s32*//*Label 34934*/ GIMT_Encode4(2417076),
     /* 2416020 */ /*GILLT_nxv1s64*//*Label 34935*/ GIMT_Encode4(2417709), GIMT_Encode4(0),
     /* 2416028 */ /*GILLT_nxv2s8*//*Label 34936*/ GIMT_Encode4(2418342),
     /* 2416032 */ /*GILLT_nxv2s16*//*Label 34937*/ GIMT_Encode4(2418665),
     /* 2416036 */ /*GILLT_nxv2s32*//*Label 34938*/ GIMT_Encode4(2419298),
     /* 2416040 */ /*GILLT_nxv2s64*//*Label 34939*/ GIMT_Encode4(2419931), GIMT_Encode4(0),
     /* 2416048 */ /*GILLT_nxv4s8*//*Label 34940*/ GIMT_Encode4(2420564),
     /* 2416052 */ /*GILLT_nxv4s16*//*Label 34941*/ GIMT_Encode4(2420887),
     /* 2416056 */ /*GILLT_nxv4s32*//*Label 34942*/ GIMT_Encode4(2421520),
     /* 2416060 */ /*GILLT_nxv4s64*//*Label 34943*/ GIMT_Encode4(2422153), GIMT_Encode4(0),
     /* 2416068 */ /*GILLT_nxv8s8*//*Label 34944*/ GIMT_Encode4(2422786),
     /* 2416072 */ /*GILLT_nxv8s16*//*Label 34945*/ GIMT_Encode4(2423109),
     /* 2416076 */ /*GILLT_nxv8s32*//*Label 34946*/ GIMT_Encode4(2423742),
     /* 2416080 */ /*GILLT_nxv8s64*//*Label 34947*/ GIMT_Encode4(2424375), GIMT_Encode4(0),
     /* 2416088 */ /*GILLT_nxv16s8*//*Label 34948*/ GIMT_Encode4(2425008),
     /* 2416092 */ /*GILLT_nxv16s16*//*Label 34949*/ GIMT_Encode4(2425331),
     /* 2416096 */ /*GILLT_nxv16s32*//*Label 34950*/ GIMT_Encode4(2425964), GIMT_Encode4(0),
     /* 2416104 */ /*GILLT_nxv32s8*//*Label 34951*/ GIMT_Encode4(2426597),
     /* 2416108 */ /*GILLT_nxv32s16*//*Label 34952*/ GIMT_Encode4(2426920), GIMT_Encode4(0),
     /* 2416116 */ /*GILLT_nxv64s8*//*Label 34953*/ GIMT_Encode4(2427553),
     /* 2416120 */ // Label 34932: @2416120
     /* 2416120 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2416442),
     /* 2416125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2416128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2416131 */   GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2416214), // Rule ID 45438 //
     /* 2416136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416172 */     // MIs[1] Operand 1
     /* 2416172 */     // No operand predicates
     /* 2416172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416176 */     // MIs[0] policy
     /* 2416176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416188 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2416191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416213 */     // GIR_Coverage, 45438,
     /* 2416213 */     GIR_EraseRootFromParent_Done,
     /* 2416214 */   // Label 34956: @2416214
     /* 2416214 */   GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2416297), // Rule ID 45439 //
     /* 2416219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416255 */     // MIs[1] Operand 1
     /* 2416255 */     // No operand predicates
     /* 2416255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416259 */     // MIs[0] policy
     /* 2416259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416271 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2416274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416296 */     // GIR_Coverage, 45439,
     /* 2416296 */     GIR_EraseRootFromParent_Done,
     /* 2416297 */   // Label 34957: @2416297
     /* 2416297 */   GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2416369), // Rule ID 45440 //
     /* 2416302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416334 */     // MIs[0] policy
     /* 2416334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416344 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2416347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416368 */     // GIR_Coverage, 45440,
     /* 2416368 */     GIR_EraseRootFromParent_Done,
     /* 2416369 */   // Label 34958: @2416369
     /* 2416369 */   GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2416441), // Rule ID 45441 //
     /* 2416374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416406 */     // MIs[0] policy
     /* 2416406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416416 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2416419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416440 */     // GIR_Coverage, 45441,
     /* 2416440 */     GIR_EraseRootFromParent_Done,
     /* 2416441 */   // Label 34959: @2416441
     /* 2416441 */   GIM_Reject,
     /* 2416442 */ // Label 34955: @2416442
     /* 2416442 */ GIM_Reject,
     /* 2416443 */ // Label 34933: @2416443
     /* 2416443 */ GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2417075),
     /* 2416448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2416451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2416454 */   GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2416537), // Rule ID 45450 //
     /* 2416459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416495 */     // MIs[1] Operand 1
     /* 2416495 */     // No operand predicates
     /* 2416495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416499 */     // MIs[0] policy
     /* 2416499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416511 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2416514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416536 */     // GIR_Coverage, 45450,
     /* 2416536 */     GIR_EraseRootFromParent_Done,
     /* 2416537 */   // Label 34961: @2416537
     /* 2416537 */   GIM_Try, /*On fail goto*//*Label 34962*/ GIMT_Encode4(2416620), // Rule ID 45451 //
     /* 2416542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416578 */     // MIs[1] Operand 1
     /* 2416578 */     // No operand predicates
     /* 2416578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416582 */     // MIs[0] policy
     /* 2416582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416594 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2416597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416619 */     // GIR_Coverage, 45451,
     /* 2416619 */     GIR_EraseRootFromParent_Done,
     /* 2416620 */   // Label 34962: @2416620
     /* 2416620 */   GIM_Try, /*On fail goto*//*Label 34963*/ GIMT_Encode4(2416703), // Rule ID 45526 //
     /* 2416625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416661 */     // MIs[1] Operand 1
     /* 2416661 */     // No operand predicates
     /* 2416661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416665 */     // MIs[0] policy
     /* 2416665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416677 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2416680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416702 */     // GIR_Coverage, 45526,
     /* 2416702 */     GIR_EraseRootFromParent_Done,
     /* 2416703 */   // Label 34963: @2416703
     /* 2416703 */   GIM_Try, /*On fail goto*//*Label 34964*/ GIMT_Encode4(2416786), // Rule ID 45527 //
     /* 2416708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416744 */     // MIs[1] Operand 1
     /* 2416744 */     // No operand predicates
     /* 2416744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416748 */     // MIs[0] policy
     /* 2416748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416760 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2416763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416785 */     // GIR_Coverage, 45527,
     /* 2416785 */     GIR_EraseRootFromParent_Done,
     /* 2416786 */   // Label 34964: @2416786
     /* 2416786 */   GIM_Try, /*On fail goto*//*Label 34965*/ GIMT_Encode4(2416858), // Rule ID 45452 //
     /* 2416791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416823 */     // MIs[0] policy
     /* 2416823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416833 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2416836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416857 */     // GIR_Coverage, 45452,
     /* 2416857 */     GIR_EraseRootFromParent_Done,
     /* 2416858 */   // Label 34965: @2416858
     /* 2416858 */   GIM_Try, /*On fail goto*//*Label 34966*/ GIMT_Encode4(2416930), // Rule ID 45453 //
     /* 2416863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416895 */     // MIs[0] policy
     /* 2416895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416905 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2416908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416929 */     // GIR_Coverage, 45453,
     /* 2416929 */     GIR_EraseRootFromParent_Done,
     /* 2416930 */   // Label 34966: @2416930
     /* 2416930 */   GIM_Try, /*On fail goto*//*Label 34967*/ GIMT_Encode4(2417002), // Rule ID 45528 //
     /* 2416935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2416944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416967 */     // MIs[0] policy
     /* 2416967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416977 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2416980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417001 */     // GIR_Coverage, 45528,
     /* 2417001 */     GIR_EraseRootFromParent_Done,
     /* 2417002 */   // Label 34967: @2417002
     /* 2417002 */   GIM_Try, /*On fail goto*//*Label 34968*/ GIMT_Encode4(2417074), // Rule ID 45529 //
     /* 2417007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417039 */     // MIs[0] policy
     /* 2417039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417049 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2417052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417073 */     // GIR_Coverage, 45529,
     /* 2417073 */     GIR_EraseRootFromParent_Done,
     /* 2417074 */   // Label 34968: @2417074
     /* 2417074 */   GIM_Reject,
     /* 2417075 */ // Label 34960: @2417075
     /* 2417075 */ GIM_Reject,
     /* 2417076 */ // Label 34934: @2417076
     /* 2417076 */ GIM_Try, /*On fail goto*//*Label 34969*/ GIMT_Encode4(2417708),
     /* 2417081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2417084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2417087 */   GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2417170), // Rule ID 45458 //
     /* 2417092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417128 */     // MIs[1] Operand 1
     /* 2417128 */     // No operand predicates
     /* 2417128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417132 */     // MIs[0] policy
     /* 2417132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417144 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2417147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417169 */     // GIR_Coverage, 45458,
     /* 2417169 */     GIR_EraseRootFromParent_Done,
     /* 2417170 */   // Label 34970: @2417170
     /* 2417170 */   GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2417253), // Rule ID 45459 //
     /* 2417175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417211 */     // MIs[1] Operand 1
     /* 2417211 */     // No operand predicates
     /* 2417211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417215 */     // MIs[0] policy
     /* 2417215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417227 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2417230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417252 */     // GIR_Coverage, 45459,
     /* 2417252 */     GIR_EraseRootFromParent_Done,
     /* 2417253 */   // Label 34971: @2417253
     /* 2417253 */   GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2417336), // Rule ID 45534 //
     /* 2417258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417294 */     // MIs[1] Operand 1
     /* 2417294 */     // No operand predicates
     /* 2417294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417298 */     // MIs[0] policy
     /* 2417298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417310 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2417313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417335 */     // GIR_Coverage, 45534,
     /* 2417335 */     GIR_EraseRootFromParent_Done,
     /* 2417336 */   // Label 34972: @2417336
     /* 2417336 */   GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2417419), // Rule ID 45535 //
     /* 2417341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417377 */     // MIs[1] Operand 1
     /* 2417377 */     // No operand predicates
     /* 2417377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417381 */     // MIs[0] policy
     /* 2417381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417393 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2417396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417418 */     // GIR_Coverage, 45535,
     /* 2417418 */     GIR_EraseRootFromParent_Done,
     /* 2417419 */   // Label 34973: @2417419
     /* 2417419 */   GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2417491), // Rule ID 45460 //
     /* 2417424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417456 */     // MIs[0] policy
     /* 2417456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417466 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2417469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417490 */     // GIR_Coverage, 45460,
     /* 2417490 */     GIR_EraseRootFromParent_Done,
     /* 2417491 */   // Label 34974: @2417491
     /* 2417491 */   GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2417563), // Rule ID 45461 //
     /* 2417496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417528 */     // MIs[0] policy
     /* 2417528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417538 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2417541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417562 */     // GIR_Coverage, 45461,
     /* 2417562 */     GIR_EraseRootFromParent_Done,
     /* 2417563 */   // Label 34975: @2417563
     /* 2417563 */   GIM_Try, /*On fail goto*//*Label 34976*/ GIMT_Encode4(2417635), // Rule ID 45536 //
     /* 2417568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417600 */     // MIs[0] policy
     /* 2417600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417610 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2417613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417634 */     // GIR_Coverage, 45536,
     /* 2417634 */     GIR_EraseRootFromParent_Done,
     /* 2417635 */   // Label 34976: @2417635
     /* 2417635 */   GIM_Try, /*On fail goto*//*Label 34977*/ GIMT_Encode4(2417707), // Rule ID 45537 //
     /* 2417640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417672 */     // MIs[0] policy
     /* 2417672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417682 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2417685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417706 */     // GIR_Coverage, 45537,
     /* 2417706 */     GIR_EraseRootFromParent_Done,
     /* 2417707 */   // Label 34977: @2417707
     /* 2417707 */   GIM_Reject,
     /* 2417708 */ // Label 34969: @2417708
     /* 2417708 */ GIM_Reject,
     /* 2417709 */ // Label 34935: @2417709
     /* 2417709 */ GIM_Try, /*On fail goto*//*Label 34978*/ GIMT_Encode4(2418341),
     /* 2417714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2417717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2417720 */   GIM_Try, /*On fail goto*//*Label 34979*/ GIMT_Encode4(2417803), // Rule ID 45474 //
     /* 2417725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2417728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417761 */     // MIs[1] Operand 1
     /* 2417761 */     // No operand predicates
     /* 2417761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417765 */     // MIs[0] policy
     /* 2417765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417777 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2417780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417802 */     // GIR_Coverage, 45474,
     /* 2417802 */     GIR_EraseRootFromParent_Done,
     /* 2417803 */   // Label 34979: @2417803
     /* 2417803 */   GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2417886), // Rule ID 45475 //
     /* 2417808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2417811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417844 */     // MIs[1] Operand 1
     /* 2417844 */     // No operand predicates
     /* 2417844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417848 */     // MIs[0] policy
     /* 2417848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417860 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2417863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417885 */     // GIR_Coverage, 45475,
     /* 2417885 */     GIR_EraseRootFromParent_Done,
     /* 2417886 */   // Label 34980: @2417886
     /* 2417886 */   GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2417969), // Rule ID 45546 //
     /* 2417891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2417894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417927 */     // MIs[1] Operand 1
     /* 2417927 */     // No operand predicates
     /* 2417927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417931 */     // MIs[0] policy
     /* 2417931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417943 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2417946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417968 */     // GIR_Coverage, 45546,
     /* 2417968 */     GIR_EraseRootFromParent_Done,
     /* 2417969 */   // Label 34981: @2417969
     /* 2417969 */   GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2418052), // Rule ID 45547 //
     /* 2417974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2417977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2417983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418010 */     // MIs[1] Operand 1
     /* 2418010 */     // No operand predicates
     /* 2418010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418014 */     // MIs[0] policy
     /* 2418014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418026 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2418029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418051 */     // GIR_Coverage, 45547,
     /* 2418051 */     GIR_EraseRootFromParent_Done,
     /* 2418052 */   // Label 34982: @2418052
     /* 2418052 */   GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2418124), // Rule ID 45476 //
     /* 2418057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2418060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2418066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418089 */     // MIs[0] policy
     /* 2418089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418099 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418123 */     // GIR_Coverage, 45476,
     /* 2418123 */     GIR_EraseRootFromParent_Done,
     /* 2418124 */   // Label 34983: @2418124
     /* 2418124 */   GIM_Try, /*On fail goto*//*Label 34984*/ GIMT_Encode4(2418196), // Rule ID 45477 //
     /* 2418129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2418132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2418138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418161 */     // MIs[0] policy
     /* 2418161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418171 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418195 */     // GIR_Coverage, 45477,
     /* 2418195 */     GIR_EraseRootFromParent_Done,
     /* 2418196 */   // Label 34984: @2418196
     /* 2418196 */   GIM_Try, /*On fail goto*//*Label 34985*/ GIMT_Encode4(2418268), // Rule ID 45548 //
     /* 2418201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2418204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2418210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418233 */     // MIs[0] policy
     /* 2418233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418243 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418267 */     // GIR_Coverage, 45548,
     /* 2418267 */     GIR_EraseRootFromParent_Done,
     /* 2418268 */   // Label 34985: @2418268
     /* 2418268 */   GIM_Try, /*On fail goto*//*Label 34986*/ GIMT_Encode4(2418340), // Rule ID 45549 //
     /* 2418273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2418276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2418282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418305 */     // MIs[0] policy
     /* 2418305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418315 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418339 */     // GIR_Coverage, 45549,
     /* 2418339 */     GIR_EraseRootFromParent_Done,
     /* 2418340 */   // Label 34986: @2418340
     /* 2418340 */   GIM_Reject,
     /* 2418341 */ // Label 34978: @2418341
     /* 2418341 */ GIM_Reject,
     /* 2418342 */ // Label 34936: @2418342
     /* 2418342 */ GIM_Try, /*On fail goto*//*Label 34987*/ GIMT_Encode4(2418664),
     /* 2418347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2418350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2418353 */   GIM_Try, /*On fail goto*//*Label 34988*/ GIMT_Encode4(2418436), // Rule ID 45442 //
     /* 2418358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418394 */     // MIs[1] Operand 1
     /* 2418394 */     // No operand predicates
     /* 2418394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418398 */     // MIs[0] policy
     /* 2418398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418410 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2418413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418435 */     // GIR_Coverage, 45442,
     /* 2418435 */     GIR_EraseRootFromParent_Done,
     /* 2418436 */   // Label 34988: @2418436
     /* 2418436 */   GIM_Try, /*On fail goto*//*Label 34989*/ GIMT_Encode4(2418519), // Rule ID 45443 //
     /* 2418441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418477 */     // MIs[1] Operand 1
     /* 2418477 */     // No operand predicates
     /* 2418477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418481 */     // MIs[0] policy
     /* 2418481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418493 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2418496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418518 */     // GIR_Coverage, 45443,
     /* 2418518 */     GIR_EraseRootFromParent_Done,
     /* 2418519 */   // Label 34989: @2418519
     /* 2418519 */   GIM_Try, /*On fail goto*//*Label 34990*/ GIMT_Encode4(2418591), // Rule ID 45444 //
     /* 2418524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418556 */     // MIs[0] policy
     /* 2418556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418566 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2418569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418590 */     // GIR_Coverage, 45444,
     /* 2418590 */     GIR_EraseRootFromParent_Done,
     /* 2418591 */   // Label 34990: @2418591
     /* 2418591 */   GIM_Try, /*On fail goto*//*Label 34991*/ GIMT_Encode4(2418663), // Rule ID 45445 //
     /* 2418596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418628 */     // MIs[0] policy
     /* 2418628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418638 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2418641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418662 */     // GIR_Coverage, 45445,
     /* 2418662 */     GIR_EraseRootFromParent_Done,
     /* 2418663 */   // Label 34991: @2418663
     /* 2418663 */   GIM_Reject,
     /* 2418664 */ // Label 34987: @2418664
     /* 2418664 */ GIM_Reject,
     /* 2418665 */ // Label 34937: @2418665
     /* 2418665 */ GIM_Try, /*On fail goto*//*Label 34992*/ GIMT_Encode4(2419297),
     /* 2418670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2418673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2418676 */   GIM_Try, /*On fail goto*//*Label 34993*/ GIMT_Encode4(2418759), // Rule ID 45454 //
     /* 2418681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418717 */     // MIs[1] Operand 1
     /* 2418717 */     // No operand predicates
     /* 2418717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418721 */     // MIs[0] policy
     /* 2418721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418733 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2418736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418758 */     // GIR_Coverage, 45454,
     /* 2418758 */     GIR_EraseRootFromParent_Done,
     /* 2418759 */   // Label 34993: @2418759
     /* 2418759 */   GIM_Try, /*On fail goto*//*Label 34994*/ GIMT_Encode4(2418842), // Rule ID 45455 //
     /* 2418764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418800 */     // MIs[1] Operand 1
     /* 2418800 */     // No operand predicates
     /* 2418800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418804 */     // MIs[0] policy
     /* 2418804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418816 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2418819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418841 */     // GIR_Coverage, 45455,
     /* 2418841 */     GIR_EraseRootFromParent_Done,
     /* 2418842 */   // Label 34994: @2418842
     /* 2418842 */   GIM_Try, /*On fail goto*//*Label 34995*/ GIMT_Encode4(2418925), // Rule ID 45530 //
     /* 2418847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418883 */     // MIs[1] Operand 1
     /* 2418883 */     // No operand predicates
     /* 2418883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418887 */     // MIs[0] policy
     /* 2418887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418899 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2418902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418924 */     // GIR_Coverage, 45530,
     /* 2418924 */     GIR_EraseRootFromParent_Done,
     /* 2418925 */   // Label 34995: @2418925
     /* 2418925 */   GIM_Try, /*On fail goto*//*Label 34996*/ GIMT_Encode4(2419008), // Rule ID 45531 //
     /* 2418930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2418939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418966 */     // MIs[1] Operand 1
     /* 2418966 */     // No operand predicates
     /* 2418966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418970 */     // MIs[0] policy
     /* 2418970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418982 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2418985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419007 */     // GIR_Coverage, 45531,
     /* 2419007 */     GIR_EraseRootFromParent_Done,
     /* 2419008 */   // Label 34996: @2419008
     /* 2419008 */   GIM_Try, /*On fail goto*//*Label 34997*/ GIMT_Encode4(2419080), // Rule ID 45456 //
     /* 2419013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419045 */     // MIs[0] policy
     /* 2419045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419055 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2419058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419079 */     // GIR_Coverage, 45456,
     /* 2419079 */     GIR_EraseRootFromParent_Done,
     /* 2419080 */   // Label 34997: @2419080
     /* 2419080 */   GIM_Try, /*On fail goto*//*Label 34998*/ GIMT_Encode4(2419152), // Rule ID 45457 //
     /* 2419085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419117 */     // MIs[0] policy
     /* 2419117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419127 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2419130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419151 */     // GIR_Coverage, 45457,
     /* 2419151 */     GIR_EraseRootFromParent_Done,
     /* 2419152 */   // Label 34998: @2419152
     /* 2419152 */   GIM_Try, /*On fail goto*//*Label 34999*/ GIMT_Encode4(2419224), // Rule ID 45532 //
     /* 2419157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419189 */     // MIs[0] policy
     /* 2419189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419199 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2419202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419223 */     // GIR_Coverage, 45532,
     /* 2419223 */     GIR_EraseRootFromParent_Done,
     /* 2419224 */   // Label 34999: @2419224
     /* 2419224 */   GIM_Try, /*On fail goto*//*Label 35000*/ GIMT_Encode4(2419296), // Rule ID 45533 //
     /* 2419229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419261 */     // MIs[0] policy
     /* 2419261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419271 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2419274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419295 */     // GIR_Coverage, 45533,
     /* 2419295 */     GIR_EraseRootFromParent_Done,
     /* 2419296 */   // Label 35000: @2419296
     /* 2419296 */   GIM_Reject,
     /* 2419297 */ // Label 34992: @2419297
     /* 2419297 */ GIM_Reject,
     /* 2419298 */ // Label 34938: @2419298
     /* 2419298 */ GIM_Try, /*On fail goto*//*Label 35001*/ GIMT_Encode4(2419930),
     /* 2419303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2419306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2419309 */   GIM_Try, /*On fail goto*//*Label 35002*/ GIMT_Encode4(2419392), // Rule ID 45470 //
     /* 2419314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419350 */     // MIs[1] Operand 1
     /* 2419350 */     // No operand predicates
     /* 2419350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419354 */     // MIs[0] policy
     /* 2419354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419366 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2419369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419391 */     // GIR_Coverage, 45470,
     /* 2419391 */     GIR_EraseRootFromParent_Done,
     /* 2419392 */   // Label 35002: @2419392
     /* 2419392 */   GIM_Try, /*On fail goto*//*Label 35003*/ GIMT_Encode4(2419475), // Rule ID 45471 //
     /* 2419397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419433 */     // MIs[1] Operand 1
     /* 2419433 */     // No operand predicates
     /* 2419433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419437 */     // MIs[0] policy
     /* 2419437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419449 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2419452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419474 */     // GIR_Coverage, 45471,
     /* 2419474 */     GIR_EraseRootFromParent_Done,
     /* 2419475 */   // Label 35003: @2419475
     /* 2419475 */   GIM_Try, /*On fail goto*//*Label 35004*/ GIMT_Encode4(2419558), // Rule ID 45542 //
     /* 2419480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419516 */     // MIs[1] Operand 1
     /* 2419516 */     // No operand predicates
     /* 2419516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419520 */     // MIs[0] policy
     /* 2419520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419532 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2419535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419557 */     // GIR_Coverage, 45542,
     /* 2419557 */     GIR_EraseRootFromParent_Done,
     /* 2419558 */   // Label 35004: @2419558
     /* 2419558 */   GIM_Try, /*On fail goto*//*Label 35005*/ GIMT_Encode4(2419641), // Rule ID 45543 //
     /* 2419563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419599 */     // MIs[1] Operand 1
     /* 2419599 */     // No operand predicates
     /* 2419599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419603 */     // MIs[0] policy
     /* 2419603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419615 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2419618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419640 */     // GIR_Coverage, 45543,
     /* 2419640 */     GIR_EraseRootFromParent_Done,
     /* 2419641 */   // Label 35005: @2419641
     /* 2419641 */   GIM_Try, /*On fail goto*//*Label 35006*/ GIMT_Encode4(2419713), // Rule ID 45472 //
     /* 2419646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419678 */     // MIs[0] policy
     /* 2419678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419688 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2419691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419712 */     // GIR_Coverage, 45472,
     /* 2419712 */     GIR_EraseRootFromParent_Done,
     /* 2419713 */   // Label 35006: @2419713
     /* 2419713 */   GIM_Try, /*On fail goto*//*Label 35007*/ GIMT_Encode4(2419785), // Rule ID 45473 //
     /* 2419718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419750 */     // MIs[0] policy
     /* 2419750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419760 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2419763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419784 */     // GIR_Coverage, 45473,
     /* 2419784 */     GIR_EraseRootFromParent_Done,
     /* 2419785 */   // Label 35007: @2419785
     /* 2419785 */   GIM_Try, /*On fail goto*//*Label 35008*/ GIMT_Encode4(2419857), // Rule ID 45544 //
     /* 2419790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419822 */     // MIs[0] policy
     /* 2419822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419832 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2419835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419856 */     // GIR_Coverage, 45544,
     /* 2419856 */     GIR_EraseRootFromParent_Done,
     /* 2419857 */   // Label 35008: @2419857
     /* 2419857 */   GIM_Try, /*On fail goto*//*Label 35009*/ GIMT_Encode4(2419929), // Rule ID 45545 //
     /* 2419862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2419878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419894 */     // MIs[0] policy
     /* 2419894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419904 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2419907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419928 */     // GIR_Coverage, 45545,
     /* 2419928 */     GIR_EraseRootFromParent_Done,
     /* 2419929 */   // Label 35009: @2419929
     /* 2419929 */   GIM_Reject,
     /* 2419930 */ // Label 35001: @2419930
     /* 2419930 */ GIM_Reject,
     /* 2419931 */ // Label 34939: @2419931
     /* 2419931 */ GIM_Try, /*On fail goto*//*Label 35010*/ GIMT_Encode4(2420563),
     /* 2419936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2419939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2419942 */   GIM_Try, /*On fail goto*//*Label 35011*/ GIMT_Encode4(2420025), // Rule ID 45514 //
     /* 2419947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2419950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2419956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419983 */     // MIs[1] Operand 1
     /* 2419983 */     // No operand predicates
     /* 2419983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419987 */     // MIs[0] policy
     /* 2419987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419999 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420024 */     // GIR_Coverage, 45514,
     /* 2420024 */     GIR_EraseRootFromParent_Done,
     /* 2420025 */   // Label 35011: @2420025
     /* 2420025 */   GIM_Try, /*On fail goto*//*Label 35012*/ GIMT_Encode4(2420108), // Rule ID 45515 //
     /* 2420030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420066 */     // MIs[1] Operand 1
     /* 2420066 */     // No operand predicates
     /* 2420066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420070 */     // MIs[0] policy
     /* 2420070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420082 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420107 */     // GIR_Coverage, 45515,
     /* 2420107 */     GIR_EraseRootFromParent_Done,
     /* 2420108 */   // Label 35012: @2420108
     /* 2420108 */   GIM_Try, /*On fail goto*//*Label 35013*/ GIMT_Encode4(2420191), // Rule ID 45574 //
     /* 2420113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420149 */     // MIs[1] Operand 1
     /* 2420149 */     // No operand predicates
     /* 2420149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420153 */     // MIs[0] policy
     /* 2420153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420165 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420190 */     // GIR_Coverage, 45574,
     /* 2420190 */     GIR_EraseRootFromParent_Done,
     /* 2420191 */   // Label 35013: @2420191
     /* 2420191 */   GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2420274), // Rule ID 45575 //
     /* 2420196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420232 */     // MIs[1] Operand 1
     /* 2420232 */     // No operand predicates
     /* 2420232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420236 */     // MIs[0] policy
     /* 2420236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420248 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420273 */     // GIR_Coverage, 45575,
     /* 2420273 */     GIR_EraseRootFromParent_Done,
     /* 2420274 */   // Label 35014: @2420274
     /* 2420274 */   GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2420346), // Rule ID 45516 //
     /* 2420279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420311 */     // MIs[0] policy
     /* 2420311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420321 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420345 */     // GIR_Coverage, 45516,
     /* 2420345 */     GIR_EraseRootFromParent_Done,
     /* 2420346 */   // Label 35015: @2420346
     /* 2420346 */   GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2420418), // Rule ID 45517 //
     /* 2420351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420383 */     // MIs[0] policy
     /* 2420383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420393 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420417 */     // GIR_Coverage, 45517,
     /* 2420417 */     GIR_EraseRootFromParent_Done,
     /* 2420418 */   // Label 35016: @2420418
     /* 2420418 */   GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2420490), // Rule ID 45576 //
     /* 2420423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420455 */     // MIs[0] policy
     /* 2420455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420465 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420489 */     // GIR_Coverage, 45576,
     /* 2420489 */     GIR_EraseRootFromParent_Done,
     /* 2420490 */   // Label 35017: @2420490
     /* 2420490 */   GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2420562), // Rule ID 45577 //
     /* 2420495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2420504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420527 */     // MIs[0] policy
     /* 2420527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420537 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420561 */     // GIR_Coverage, 45577,
     /* 2420561 */     GIR_EraseRootFromParent_Done,
     /* 2420562 */   // Label 35018: @2420562
     /* 2420562 */   GIM_Reject,
     /* 2420563 */ // Label 35010: @2420563
     /* 2420563 */ GIM_Reject,
     /* 2420564 */ // Label 34940: @2420564
     /* 2420564 */ GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2420886),
     /* 2420569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2420572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2420575 */   GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2420658), // Rule ID 45446 //
     /* 2420580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2420583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2420596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420616 */     // MIs[1] Operand 1
     /* 2420616 */     // No operand predicates
     /* 2420616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420620 */     // MIs[0] policy
     /* 2420620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420632 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2420635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420657 */     // GIR_Coverage, 45446,
     /* 2420657 */     GIR_EraseRootFromParent_Done,
     /* 2420658 */   // Label 35020: @2420658
     /* 2420658 */   GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2420741), // Rule ID 45447 //
     /* 2420663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2420666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2420679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420699 */     // MIs[1] Operand 1
     /* 2420699 */     // No operand predicates
     /* 2420699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420703 */     // MIs[0] policy
     /* 2420703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420715 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2420718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420740 */     // GIR_Coverage, 45447,
     /* 2420740 */     GIR_EraseRootFromParent_Done,
     /* 2420741 */   // Label 35021: @2420741
     /* 2420741 */   GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2420813), // Rule ID 45448 //
     /* 2420746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2420749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2420762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420778 */     // MIs[0] policy
     /* 2420778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420788 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2420791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420812 */     // GIR_Coverage, 45448,
     /* 2420812 */     GIR_EraseRootFromParent_Done,
     /* 2420813 */   // Label 35022: @2420813
     /* 2420813 */   GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2420885), // Rule ID 45449 //
     /* 2420818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2420821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2420834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420850 */     // MIs[0] policy
     /* 2420850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420860 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2420863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420884 */     // GIR_Coverage, 45449,
     /* 2420884 */     GIR_EraseRootFromParent_Done,
     /* 2420885 */   // Label 35023: @2420885
     /* 2420885 */   GIM_Reject,
     /* 2420886 */ // Label 35019: @2420886
     /* 2420886 */ GIM_Reject,
     /* 2420887 */ // Label 34941: @2420887
     /* 2420887 */ GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2421519),
     /* 2420892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2420895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2420898 */   GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2420981), // Rule ID 45466 //
     /* 2420903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2420906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2420919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2420927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420939 */     // MIs[1] Operand 1
     /* 2420939 */     // No operand predicates
     /* 2420939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420943 */     // MIs[0] policy
     /* 2420943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420955 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2420958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420980 */     // GIR_Coverage, 45466,
     /* 2420980 */     GIR_EraseRootFromParent_Done,
     /* 2420981 */   // Label 35025: @2420981
     /* 2420981 */   GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2421064), // Rule ID 45467 //
     /* 2420986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2420989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2420995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421022 */     // MIs[1] Operand 1
     /* 2421022 */     // No operand predicates
     /* 2421022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421026 */     // MIs[0] policy
     /* 2421026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421038 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2421041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421063 */     // GIR_Coverage, 45467,
     /* 2421063 */     GIR_EraseRootFromParent_Done,
     /* 2421064 */   // Label 35026: @2421064
     /* 2421064 */   GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2421147), // Rule ID 45538 //
     /* 2421069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421105 */     // MIs[1] Operand 1
     /* 2421105 */     // No operand predicates
     /* 2421105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421109 */     // MIs[0] policy
     /* 2421109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421121 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2421124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421146 */     // GIR_Coverage, 45538,
     /* 2421146 */     GIR_EraseRootFromParent_Done,
     /* 2421147 */   // Label 35027: @2421147
     /* 2421147 */   GIM_Try, /*On fail goto*//*Label 35028*/ GIMT_Encode4(2421230), // Rule ID 45539 //
     /* 2421152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421188 */     // MIs[1] Operand 1
     /* 2421188 */     // No operand predicates
     /* 2421188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421192 */     // MIs[0] policy
     /* 2421192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421204 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2421207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421229 */     // GIR_Coverage, 45539,
     /* 2421229 */     GIR_EraseRootFromParent_Done,
     /* 2421230 */   // Label 35028: @2421230
     /* 2421230 */   GIM_Try, /*On fail goto*//*Label 35029*/ GIMT_Encode4(2421302), // Rule ID 45468 //
     /* 2421235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421267 */     // MIs[0] policy
     /* 2421267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421277 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2421280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421301 */     // GIR_Coverage, 45468,
     /* 2421301 */     GIR_EraseRootFromParent_Done,
     /* 2421302 */   // Label 35029: @2421302
     /* 2421302 */   GIM_Try, /*On fail goto*//*Label 35030*/ GIMT_Encode4(2421374), // Rule ID 45469 //
     /* 2421307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421339 */     // MIs[0] policy
     /* 2421339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421349 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2421352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421373 */     // GIR_Coverage, 45469,
     /* 2421373 */     GIR_EraseRootFromParent_Done,
     /* 2421374 */   // Label 35030: @2421374
     /* 2421374 */   GIM_Try, /*On fail goto*//*Label 35031*/ GIMT_Encode4(2421446), // Rule ID 45540 //
     /* 2421379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421411 */     // MIs[0] policy
     /* 2421411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421421 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2421424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421445 */     // GIR_Coverage, 45540,
     /* 2421445 */     GIR_EraseRootFromParent_Done,
     /* 2421446 */   // Label 35031: @2421446
     /* 2421446 */   GIM_Try, /*On fail goto*//*Label 35032*/ GIMT_Encode4(2421518), // Rule ID 45541 //
     /* 2421451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2421467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421483 */     // MIs[0] policy
     /* 2421483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421493 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2421496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421517 */     // GIR_Coverage, 45541,
     /* 2421517 */     GIR_EraseRootFromParent_Done,
     /* 2421518 */   // Label 35032: @2421518
     /* 2421518 */   GIM_Reject,
     /* 2421519 */ // Label 35024: @2421519
     /* 2421519 */ GIM_Reject,
     /* 2421520 */ // Label 34942: @2421520
     /* 2421520 */ GIM_Try, /*On fail goto*//*Label 35033*/ GIMT_Encode4(2422152),
     /* 2421525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2421528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2421531 */   GIM_Try, /*On fail goto*//*Label 35034*/ GIMT_Encode4(2421614), // Rule ID 45502 //
     /* 2421536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421572 */     // MIs[1] Operand 1
     /* 2421572 */     // No operand predicates
     /* 2421572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421576 */     // MIs[0] policy
     /* 2421576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421588 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2421591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421613 */     // GIR_Coverage, 45502,
     /* 2421613 */     GIR_EraseRootFromParent_Done,
     /* 2421614 */   // Label 35034: @2421614
     /* 2421614 */   GIM_Try, /*On fail goto*//*Label 35035*/ GIMT_Encode4(2421697), // Rule ID 45503 //
     /* 2421619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421655 */     // MIs[1] Operand 1
     /* 2421655 */     // No operand predicates
     /* 2421655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421659 */     // MIs[0] policy
     /* 2421659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421671 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2421674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421696 */     // GIR_Coverage, 45503,
     /* 2421696 */     GIR_EraseRootFromParent_Done,
     /* 2421697 */   // Label 35035: @2421697
     /* 2421697 */   GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2421780), // Rule ID 45562 //
     /* 2421702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421738 */     // MIs[1] Operand 1
     /* 2421738 */     // No operand predicates
     /* 2421738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421742 */     // MIs[0] policy
     /* 2421742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421754 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2421757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421779 */     // GIR_Coverage, 45562,
     /* 2421779 */     GIR_EraseRootFromParent_Done,
     /* 2421780 */   // Label 35036: @2421780
     /* 2421780 */   GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2421863), // Rule ID 45563 //
     /* 2421785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421821 */     // MIs[1] Operand 1
     /* 2421821 */     // No operand predicates
     /* 2421821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421825 */     // MIs[0] policy
     /* 2421825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421837 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2421840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421862 */     // GIR_Coverage, 45563,
     /* 2421862 */     GIR_EraseRootFromParent_Done,
     /* 2421863 */   // Label 35037: @2421863
     /* 2421863 */   GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2421935), // Rule ID 45504 //
     /* 2421868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421900 */     // MIs[0] policy
     /* 2421900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421910 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2421913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421934 */     // GIR_Coverage, 45504,
     /* 2421934 */     GIR_EraseRootFromParent_Done,
     /* 2421935 */   // Label 35038: @2421935
     /* 2421935 */   GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2422007), // Rule ID 45505 //
     /* 2421940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2421949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2421956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2421964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421972 */     // MIs[0] policy
     /* 2421972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421982 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2421985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422006 */     // GIR_Coverage, 45505,
     /* 2422006 */     GIR_EraseRootFromParent_Done,
     /* 2422007 */   // Label 35039: @2422007
     /* 2422007 */   GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2422079), // Rule ID 45564 //
     /* 2422012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2422028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2422032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2422036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422044 */     // MIs[0] policy
     /* 2422044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422054 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2422057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422078 */     // GIR_Coverage, 45564,
     /* 2422078 */     GIR_EraseRootFromParent_Done,
     /* 2422079 */   // Label 35040: @2422079
     /* 2422079 */   GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2422151), // Rule ID 45565 //
     /* 2422084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2422100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2422104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2422108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422116 */     // MIs[0] policy
     /* 2422116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422126 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2422129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422150 */     // GIR_Coverage, 45565,
     /* 2422150 */     GIR_EraseRootFromParent_Done,
     /* 2422151 */   // Label 35041: @2422151
     /* 2422151 */   GIM_Reject,
     /* 2422152 */ // Label 35033: @2422152
     /* 2422152 */ GIM_Reject,
     /* 2422153 */ // Label 34943: @2422153
     /* 2422153 */ GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2422785),
     /* 2422158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2422161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2422164 */   GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2422247), // Rule ID 45518 //
     /* 2422169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2422172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422205 */     // MIs[1] Operand 1
     /* 2422205 */     // No operand predicates
     /* 2422205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422209 */     // MIs[0] policy
     /* 2422209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422221 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422246 */     // GIR_Coverage, 45518,
     /* 2422246 */     GIR_EraseRootFromParent_Done,
     /* 2422247 */   // Label 35043: @2422247
     /* 2422247 */   GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2422330), // Rule ID 45519 //
     /* 2422252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2422255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422288 */     // MIs[1] Operand 1
     /* 2422288 */     // No operand predicates
     /* 2422288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422292 */     // MIs[0] policy
     /* 2422292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422304 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422329 */     // GIR_Coverage, 45519,
     /* 2422329 */     GIR_EraseRootFromParent_Done,
     /* 2422330 */   // Label 35044: @2422330
     /* 2422330 */   GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2422413), // Rule ID 45578 //
     /* 2422335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2422338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422371 */     // MIs[1] Operand 1
     /* 2422371 */     // No operand predicates
     /* 2422371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422375 */     // MIs[0] policy
     /* 2422375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422387 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422412 */     // GIR_Coverage, 45578,
     /* 2422412 */     GIR_EraseRootFromParent_Done,
     /* 2422413 */   // Label 35045: @2422413
     /* 2422413 */   GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2422496), // Rule ID 45579 //
     /* 2422418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2422421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422454 */     // MIs[1] Operand 1
     /* 2422454 */     // No operand predicates
     /* 2422454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422458 */     // MIs[0] policy
     /* 2422458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422470 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422495 */     // GIR_Coverage, 45579,
     /* 2422495 */     GIR_EraseRootFromParent_Done,
     /* 2422496 */   // Label 35046: @2422496
     /* 2422496 */   GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2422568), // Rule ID 45520 //
     /* 2422501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2422504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422533 */     // MIs[0] policy
     /* 2422533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422543 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422567 */     // GIR_Coverage, 45520,
     /* 2422567 */     GIR_EraseRootFromParent_Done,
     /* 2422568 */   // Label 35047: @2422568
     /* 2422568 */   GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2422640), // Rule ID 45521 //
     /* 2422573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2422576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422605 */     // MIs[0] policy
     /* 2422605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422615 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422639 */     // GIR_Coverage, 45521,
     /* 2422639 */     GIR_EraseRootFromParent_Done,
     /* 2422640 */   // Label 35048: @2422640
     /* 2422640 */   GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2422712), // Rule ID 45580 //
     /* 2422645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2422648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422677 */     // MIs[0] policy
     /* 2422677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422687 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422711 */     // GIR_Coverage, 45580,
     /* 2422711 */     GIR_EraseRootFromParent_Done,
     /* 2422712 */   // Label 35049: @2422712
     /* 2422712 */   GIM_Try, /*On fail goto*//*Label 35050*/ GIMT_Encode4(2422784), // Rule ID 45581 //
     /* 2422717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2422720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2422726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422749 */     // MIs[0] policy
     /* 2422749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422759 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2422780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422783 */     // GIR_Coverage, 45581,
     /* 2422783 */     GIR_EraseRootFromParent_Done,
     /* 2422784 */   // Label 35050: @2422784
     /* 2422784 */   GIM_Reject,
     /* 2422785 */ // Label 35042: @2422785
     /* 2422785 */ GIM_Reject,
     /* 2422786 */ // Label 34944: @2422786
     /* 2422786 */ GIM_Try, /*On fail goto*//*Label 35051*/ GIMT_Encode4(2423108),
     /* 2422791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2422794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2422797 */   GIM_Try, /*On fail goto*//*Label 35052*/ GIMT_Encode4(2422880), // Rule ID 45462 //
     /* 2422802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2422811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2422818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422838 */     // MIs[1] Operand 1
     /* 2422838 */     // No operand predicates
     /* 2422838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422842 */     // MIs[0] policy
     /* 2422842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422854 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2422857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422879 */     // GIR_Coverage, 45462,
     /* 2422879 */     GIR_EraseRootFromParent_Done,
     /* 2422880 */   // Label 35052: @2422880
     /* 2422880 */   GIM_Try, /*On fail goto*//*Label 35053*/ GIMT_Encode4(2422963), // Rule ID 45463 //
     /* 2422885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2422894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2422901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422921 */     // MIs[1] Operand 1
     /* 2422921 */     // No operand predicates
     /* 2422921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422925 */     // MIs[0] policy
     /* 2422925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422937 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2422940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422962 */     // GIR_Coverage, 45463,
     /* 2422962 */     GIR_EraseRootFromParent_Done,
     /* 2422963 */   // Label 35053: @2422963
     /* 2422963 */   GIM_Try, /*On fail goto*//*Label 35054*/ GIMT_Encode4(2423035), // Rule ID 45464 //
     /* 2422968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2422977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2422984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423000 */     // MIs[0] policy
     /* 2423000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423010 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2423013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423034 */     // GIR_Coverage, 45464,
     /* 2423034 */     GIR_EraseRootFromParent_Done,
     /* 2423035 */   // Label 35054: @2423035
     /* 2423035 */   GIM_Try, /*On fail goto*//*Label 35055*/ GIMT_Encode4(2423107), // Rule ID 45465 //
     /* 2423040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2423056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423072 */     // MIs[0] policy
     /* 2423072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423082 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2423085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423106 */     // GIR_Coverage, 45465,
     /* 2423106 */     GIR_EraseRootFromParent_Done,
     /* 2423107 */   // Label 35055: @2423107
     /* 2423107 */   GIM_Reject,
     /* 2423108 */ // Label 35051: @2423108
     /* 2423108 */ GIM_Reject,
     /* 2423109 */ // Label 34945: @2423109
     /* 2423109 */ GIM_Try, /*On fail goto*//*Label 35056*/ GIMT_Encode4(2423741),
     /* 2423114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2423117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2423120 */   GIM_Try, /*On fail goto*//*Label 35057*/ GIMT_Encode4(2423203), // Rule ID 45490 //
     /* 2423125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423161 */     // MIs[1] Operand 1
     /* 2423161 */     // No operand predicates
     /* 2423161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423165 */     // MIs[0] policy
     /* 2423165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423177 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2423180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423202 */     // GIR_Coverage, 45490,
     /* 2423202 */     GIR_EraseRootFromParent_Done,
     /* 2423203 */   // Label 35057: @2423203
     /* 2423203 */   GIM_Try, /*On fail goto*//*Label 35058*/ GIMT_Encode4(2423286), // Rule ID 45491 //
     /* 2423208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423244 */     // MIs[1] Operand 1
     /* 2423244 */     // No operand predicates
     /* 2423244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423248 */     // MIs[0] policy
     /* 2423248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423260 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2423263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423272 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423285 */     // GIR_Coverage, 45491,
     /* 2423285 */     GIR_EraseRootFromParent_Done,
     /* 2423286 */   // Label 35058: @2423286
     /* 2423286 */   GIM_Try, /*On fail goto*//*Label 35059*/ GIMT_Encode4(2423369), // Rule ID 45550 //
     /* 2423291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423327 */     // MIs[1] Operand 1
     /* 2423327 */     // No operand predicates
     /* 2423327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423331 */     // MIs[0] policy
     /* 2423331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423343 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2423346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423368 */     // GIR_Coverage, 45550,
     /* 2423368 */     GIR_EraseRootFromParent_Done,
     /* 2423369 */   // Label 35059: @2423369
     /* 2423369 */   GIM_Try, /*On fail goto*//*Label 35060*/ GIMT_Encode4(2423452), // Rule ID 45551 //
     /* 2423374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423410 */     // MIs[1] Operand 1
     /* 2423410 */     // No operand predicates
     /* 2423410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423414 */     // MIs[0] policy
     /* 2423414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423426 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2423429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423451 */     // GIR_Coverage, 45551,
     /* 2423451 */     GIR_EraseRootFromParent_Done,
     /* 2423452 */   // Label 35060: @2423452
     /* 2423452 */   GIM_Try, /*On fail goto*//*Label 35061*/ GIMT_Encode4(2423524), // Rule ID 45492 //
     /* 2423457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423489 */     // MIs[0] policy
     /* 2423489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423499 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2423502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423523 */     // GIR_Coverage, 45492,
     /* 2423523 */     GIR_EraseRootFromParent_Done,
     /* 2423524 */   // Label 35061: @2423524
     /* 2423524 */   GIM_Try, /*On fail goto*//*Label 35062*/ GIMT_Encode4(2423596), // Rule ID 45493 //
     /* 2423529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423561 */     // MIs[0] policy
     /* 2423561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423571 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2423574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423595 */     // GIR_Coverage, 45493,
     /* 2423595 */     GIR_EraseRootFromParent_Done,
     /* 2423596 */   // Label 35062: @2423596
     /* 2423596 */   GIM_Try, /*On fail goto*//*Label 35063*/ GIMT_Encode4(2423668), // Rule ID 45552 //
     /* 2423601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423633 */     // MIs[0] policy
     /* 2423633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423643 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2423646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423667 */     // GIR_Coverage, 45552,
     /* 2423667 */     GIR_EraseRootFromParent_Done,
     /* 2423668 */   // Label 35063: @2423668
     /* 2423668 */   GIM_Try, /*On fail goto*//*Label 35064*/ GIMT_Encode4(2423740), // Rule ID 45553 //
     /* 2423673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2423689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2423697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423705 */     // MIs[0] policy
     /* 2423705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423715 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2423718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423739 */     // GIR_Coverage, 45553,
     /* 2423739 */     GIR_EraseRootFromParent_Done,
     /* 2423740 */   // Label 35064: @2423740
     /* 2423740 */   GIM_Reject,
     /* 2423741 */ // Label 35056: @2423741
     /* 2423741 */ GIM_Reject,
     /* 2423742 */ // Label 34946: @2423742
     /* 2423742 */ GIM_Try, /*On fail goto*//*Label 35065*/ GIMT_Encode4(2424374),
     /* 2423747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2423750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2423753 */   GIM_Try, /*On fail goto*//*Label 35066*/ GIMT_Encode4(2423836), // Rule ID 45506 //
     /* 2423758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2423774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423794 */     // MIs[1] Operand 1
     /* 2423794 */     // No operand predicates
     /* 2423794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423798 */     // MIs[0] policy
     /* 2423798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423810 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2423813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423835 */     // GIR_Coverage, 45506,
     /* 2423835 */     GIR_EraseRootFromParent_Done,
     /* 2423836 */   // Label 35066: @2423836
     /* 2423836 */   GIM_Try, /*On fail goto*//*Label 35067*/ GIMT_Encode4(2423919), // Rule ID 45507 //
     /* 2423841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2423857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423877 */     // MIs[1] Operand 1
     /* 2423877 */     // No operand predicates
     /* 2423877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423881 */     // MIs[0] policy
     /* 2423881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423893 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2423896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423918 */     // GIR_Coverage, 45507,
     /* 2423918 */     GIR_EraseRootFromParent_Done,
     /* 2423919 */   // Label 35067: @2423919
     /* 2423919 */   GIM_Try, /*On fail goto*//*Label 35068*/ GIMT_Encode4(2424002), // Rule ID 45566 //
     /* 2423924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2423933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2423940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2423948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423960 */     // MIs[1] Operand 1
     /* 2423960 */     // No operand predicates
     /* 2423960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423964 */     // MIs[0] policy
     /* 2423964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423976 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2423979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424001 */     // GIR_Coverage, 45566,
     /* 2424001 */     GIR_EraseRootFromParent_Done,
     /* 2424002 */   // Label 35068: @2424002
     /* 2424002 */   GIM_Try, /*On fail goto*//*Label 35069*/ GIMT_Encode4(2424085), // Rule ID 45567 //
     /* 2424007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2424023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424043 */     // MIs[1] Operand 1
     /* 2424043 */     // No operand predicates
     /* 2424043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424047 */     // MIs[0] policy
     /* 2424047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424059 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2424062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424084 */     // GIR_Coverage, 45567,
     /* 2424084 */     GIR_EraseRootFromParent_Done,
     /* 2424085 */   // Label 35069: @2424085
     /* 2424085 */   GIM_Try, /*On fail goto*//*Label 35070*/ GIMT_Encode4(2424157), // Rule ID 45508 //
     /* 2424090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2424106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424122 */     // MIs[0] policy
     /* 2424122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424132 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2424135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424156 */     // GIR_Coverage, 45508,
     /* 2424156 */     GIR_EraseRootFromParent_Done,
     /* 2424157 */   // Label 35070: @2424157
     /* 2424157 */   GIM_Try, /*On fail goto*//*Label 35071*/ GIMT_Encode4(2424229), // Rule ID 45509 //
     /* 2424162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2424178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424194 */     // MIs[0] policy
     /* 2424194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424204 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2424207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424228 */     // GIR_Coverage, 45509,
     /* 2424228 */     GIR_EraseRootFromParent_Done,
     /* 2424229 */   // Label 35071: @2424229
     /* 2424229 */   GIM_Try, /*On fail goto*//*Label 35072*/ GIMT_Encode4(2424301), // Rule ID 45568 //
     /* 2424234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2424250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424266 */     // MIs[0] policy
     /* 2424266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424276 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2424279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424300 */     // GIR_Coverage, 45568,
     /* 2424300 */     GIR_EraseRootFromParent_Done,
     /* 2424301 */   // Label 35072: @2424301
     /* 2424301 */   GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2424373), // Rule ID 45569 //
     /* 2424306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2424322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2424330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424338 */     // MIs[0] policy
     /* 2424338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424348 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2424351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424372 */     // GIR_Coverage, 45569,
     /* 2424372 */     GIR_EraseRootFromParent_Done,
     /* 2424373 */   // Label 35073: @2424373
     /* 2424373 */   GIM_Reject,
     /* 2424374 */ // Label 35065: @2424374
     /* 2424374 */ GIM_Reject,
     /* 2424375 */ // Label 34947: @2424375
     /* 2424375 */ GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2425007),
     /* 2424380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2424383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2424386 */   GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2424469), // Rule ID 45522 //
     /* 2424391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424427 */     // MIs[1] Operand 1
     /* 2424427 */     // No operand predicates
     /* 2424427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424431 */     // MIs[0] policy
     /* 2424431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424443 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2424446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424468 */     // GIR_Coverage, 45522,
     /* 2424468 */     GIR_EraseRootFromParent_Done,
     /* 2424469 */   // Label 35075: @2424469
     /* 2424469 */   GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2424552), // Rule ID 45523 //
     /* 2424474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424510 */     // MIs[1] Operand 1
     /* 2424510 */     // No operand predicates
     /* 2424510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424514 */     // MIs[0] policy
     /* 2424514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424526 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2424529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424551 */     // GIR_Coverage, 45523,
     /* 2424551 */     GIR_EraseRootFromParent_Done,
     /* 2424552 */   // Label 35076: @2424552
     /* 2424552 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2424635), // Rule ID 45582 //
     /* 2424557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424593 */     // MIs[1] Operand 1
     /* 2424593 */     // No operand predicates
     /* 2424593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424597 */     // MIs[0] policy
     /* 2424597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424609 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2424612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424634 */     // GIR_Coverage, 45582,
     /* 2424634 */     GIR_EraseRootFromParent_Done,
     /* 2424635 */   // Label 35077: @2424635
     /* 2424635 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2424718), // Rule ID 45583 //
     /* 2424640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424676 */     // MIs[1] Operand 1
     /* 2424676 */     // No operand predicates
     /* 2424676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424680 */     // MIs[0] policy
     /* 2424680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424692 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2424695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424717 */     // GIR_Coverage, 45583,
     /* 2424717 */     GIR_EraseRootFromParent_Done,
     /* 2424718 */   // Label 35078: @2424718
     /* 2424718 */   GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2424790), // Rule ID 45524 //
     /* 2424723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424755 */     // MIs[0] policy
     /* 2424755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424765 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2424768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424789 */     // GIR_Coverage, 45524,
     /* 2424789 */     GIR_EraseRootFromParent_Done,
     /* 2424790 */   // Label 35079: @2424790
     /* 2424790 */   GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2424862), // Rule ID 45525 //
     /* 2424795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424827 */     // MIs[0] policy
     /* 2424827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424837 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2424840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424861 */     // GIR_Coverage, 45525,
     /* 2424861 */     GIR_EraseRootFromParent_Done,
     /* 2424862 */   // Label 35080: @2424862
     /* 2424862 */   GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2424934), // Rule ID 45584 //
     /* 2424867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424899 */     // MIs[0] policy
     /* 2424899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424909 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2424912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424933 */     // GIR_Coverage, 45584,
     /* 2424933 */     GIR_EraseRootFromParent_Done,
     /* 2424934 */   // Label 35081: @2424934
     /* 2424934 */   GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2425006), // Rule ID 45585 //
     /* 2424939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2424948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2424955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2424963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424971 */     // MIs[0] policy
     /* 2424971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424981 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2424984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425005 */     // GIR_Coverage, 45585,
     /* 2425005 */     GIR_EraseRootFromParent_Done,
     /* 2425006 */   // Label 35082: @2425006
     /* 2425006 */   GIM_Reject,
     /* 2425007 */ // Label 35074: @2425007
     /* 2425007 */ GIM_Reject,
     /* 2425008 */ // Label 34948: @2425008
     /* 2425008 */ GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2425330),
     /* 2425013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2425016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2425019 */   GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2425102), // Rule ID 45478 //
     /* 2425024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2425040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425060 */     // MIs[1] Operand 1
     /* 2425060 */     // No operand predicates
     /* 2425060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425064 */     // MIs[0] policy
     /* 2425064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425076 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2425079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425101 */     // GIR_Coverage, 45478,
     /* 2425101 */     GIR_EraseRootFromParent_Done,
     /* 2425102 */   // Label 35084: @2425102
     /* 2425102 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2425185), // Rule ID 45479 //
     /* 2425107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2425123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425143 */     // MIs[1] Operand 1
     /* 2425143 */     // No operand predicates
     /* 2425143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425147 */     // MIs[0] policy
     /* 2425147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425159 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2425162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425184 */     // GIR_Coverage, 45479,
     /* 2425184 */     GIR_EraseRootFromParent_Done,
     /* 2425185 */   // Label 35085: @2425185
     /* 2425185 */   GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2425257), // Rule ID 45480 //
     /* 2425190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2425206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425222 */     // MIs[0] policy
     /* 2425222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425232 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2425235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425256 */     // GIR_Coverage, 45480,
     /* 2425256 */     GIR_EraseRootFromParent_Done,
     /* 2425257 */   // Label 35086: @2425257
     /* 2425257 */   GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2425329), // Rule ID 45481 //
     /* 2425262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2425278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425294 */     // MIs[0] policy
     /* 2425294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425304 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2425307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425328 */     // GIR_Coverage, 45481,
     /* 2425328 */     GIR_EraseRootFromParent_Done,
     /* 2425329 */   // Label 35087: @2425329
     /* 2425329 */   GIM_Reject,
     /* 2425330 */ // Label 35083: @2425330
     /* 2425330 */ GIM_Reject,
     /* 2425331 */ // Label 34949: @2425331
     /* 2425331 */ GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2425963),
     /* 2425336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2425339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2425342 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2425425), // Rule ID 45494 //
     /* 2425347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425383 */     // MIs[1] Operand 1
     /* 2425383 */     // No operand predicates
     /* 2425383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425387 */     // MIs[0] policy
     /* 2425387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425399 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2425402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425424 */     // GIR_Coverage, 45494,
     /* 2425424 */     GIR_EraseRootFromParent_Done,
     /* 2425425 */   // Label 35089: @2425425
     /* 2425425 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2425508), // Rule ID 45495 //
     /* 2425430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425466 */     // MIs[1] Operand 1
     /* 2425466 */     // No operand predicates
     /* 2425466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425470 */     // MIs[0] policy
     /* 2425470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425482 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2425485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425494 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425507 */     // GIR_Coverage, 45495,
     /* 2425507 */     GIR_EraseRootFromParent_Done,
     /* 2425508 */   // Label 35090: @2425508
     /* 2425508 */   GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2425591), // Rule ID 45554 //
     /* 2425513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425549 */     // MIs[1] Operand 1
     /* 2425549 */     // No operand predicates
     /* 2425549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425553 */     // MIs[0] policy
     /* 2425553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425565 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2425568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425590 */     // GIR_Coverage, 45554,
     /* 2425590 */     GIR_EraseRootFromParent_Done,
     /* 2425591 */   // Label 35091: @2425591
     /* 2425591 */   GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2425674), // Rule ID 45555 //
     /* 2425596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425632 */     // MIs[1] Operand 1
     /* 2425632 */     // No operand predicates
     /* 2425632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425636 */     // MIs[0] policy
     /* 2425636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425648 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2425651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425673 */     // GIR_Coverage, 45555,
     /* 2425673 */     GIR_EraseRootFromParent_Done,
     /* 2425674 */   // Label 35092: @2425674
     /* 2425674 */   GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2425746), // Rule ID 45496 //
     /* 2425679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425711 */     // MIs[0] policy
     /* 2425711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425721 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2425724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425745 */     // GIR_Coverage, 45496,
     /* 2425745 */     GIR_EraseRootFromParent_Done,
     /* 2425746 */   // Label 35093: @2425746
     /* 2425746 */   GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2425818), // Rule ID 45497 //
     /* 2425751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425783 */     // MIs[0] policy
     /* 2425783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425793 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2425796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425804 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425817 */     // GIR_Coverage, 45497,
     /* 2425817 */     GIR_EraseRootFromParent_Done,
     /* 2425818 */   // Label 35094: @2425818
     /* 2425818 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2425890), // Rule ID 45556 //
     /* 2425823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425855 */     // MIs[0] policy
     /* 2425855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425865 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2425868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425889 */     // GIR_Coverage, 45556,
     /* 2425889 */     GIR_EraseRootFromParent_Done,
     /* 2425890 */   // Label 35095: @2425890
     /* 2425890 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2425962), // Rule ID 45557 //
     /* 2425895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2425911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425927 */     // MIs[0] policy
     /* 2425927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425937 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2425940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425961 */     // GIR_Coverage, 45557,
     /* 2425961 */     GIR_EraseRootFromParent_Done,
     /* 2425962 */   // Label 35096: @2425962
     /* 2425962 */   GIM_Reject,
     /* 2425963 */ // Label 35088: @2425963
     /* 2425963 */ GIM_Reject,
     /* 2425964 */ // Label 34950: @2425964
     /* 2425964 */ GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2426596),
     /* 2425969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2425972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2425975 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2426058), // Rule ID 45510 //
     /* 2425980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2425989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2425996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426016 */     // MIs[1] Operand 1
     /* 2426016 */     // No operand predicates
     /* 2426016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426020 */     // MIs[0] policy
     /* 2426020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426032 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2426035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426057 */     // GIR_Coverage, 45510,
     /* 2426057 */     GIR_EraseRootFromParent_Done,
     /* 2426058 */   // Label 35098: @2426058
     /* 2426058 */   GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2426141), // Rule ID 45511 //
     /* 2426063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426099 */     // MIs[1] Operand 1
     /* 2426099 */     // No operand predicates
     /* 2426099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426103 */     // MIs[0] policy
     /* 2426103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426115 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2426118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426140 */     // GIR_Coverage, 45511,
     /* 2426140 */     GIR_EraseRootFromParent_Done,
     /* 2426141 */   // Label 35099: @2426141
     /* 2426141 */   GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2426224), // Rule ID 45570 //
     /* 2426146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426182 */     // MIs[1] Operand 1
     /* 2426182 */     // No operand predicates
     /* 2426182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426186 */     // MIs[0] policy
     /* 2426186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426198 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2426201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426223 */     // GIR_Coverage, 45570,
     /* 2426223 */     GIR_EraseRootFromParent_Done,
     /* 2426224 */   // Label 35100: @2426224
     /* 2426224 */   GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2426307), // Rule ID 45571 //
     /* 2426229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426265 */     // MIs[1] Operand 1
     /* 2426265 */     // No operand predicates
     /* 2426265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426269 */     // MIs[0] policy
     /* 2426269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426281 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2426284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426306 */     // GIR_Coverage, 45571,
     /* 2426306 */     GIR_EraseRootFromParent_Done,
     /* 2426307 */   // Label 35101: @2426307
     /* 2426307 */   GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2426379), // Rule ID 45512 //
     /* 2426312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426344 */     // MIs[0] policy
     /* 2426344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426354 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2426357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426378 */     // GIR_Coverage, 45512,
     /* 2426378 */     GIR_EraseRootFromParent_Done,
     /* 2426379 */   // Label 35102: @2426379
     /* 2426379 */   GIM_Try, /*On fail goto*//*Label 35103*/ GIMT_Encode4(2426451), // Rule ID 45513 //
     /* 2426384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426416 */     // MIs[0] policy
     /* 2426416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426426 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2426429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426450 */     // GIR_Coverage, 45513,
     /* 2426450 */     GIR_EraseRootFromParent_Done,
     /* 2426451 */   // Label 35103: @2426451
     /* 2426451 */   GIM_Try, /*On fail goto*//*Label 35104*/ GIMT_Encode4(2426523), // Rule ID 45572 //
     /* 2426456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426488 */     // MIs[0] policy
     /* 2426488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426498 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2426501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426522 */     // GIR_Coverage, 45572,
     /* 2426522 */     GIR_EraseRootFromParent_Done,
     /* 2426523 */   // Label 35104: @2426523
     /* 2426523 */   GIM_Try, /*On fail goto*//*Label 35105*/ GIMT_Encode4(2426595), // Rule ID 45573 //
     /* 2426528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2426537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426560 */     // MIs[0] policy
     /* 2426560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426570 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2426573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426594 */     // GIR_Coverage, 45573,
     /* 2426594 */     GIR_EraseRootFromParent_Done,
     /* 2426595 */   // Label 35105: @2426595
     /* 2426595 */   GIM_Reject,
     /* 2426596 */ // Label 35097: @2426596
     /* 2426596 */ GIM_Reject,
     /* 2426597 */ // Label 34951: @2426597
     /* 2426597 */ GIM_Try, /*On fail goto*//*Label 35106*/ GIMT_Encode4(2426919),
     /* 2426602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2426605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2426608 */   GIM_Try, /*On fail goto*//*Label 35107*/ GIMT_Encode4(2426691), // Rule ID 45482 //
     /* 2426613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2426622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2426629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426649 */     // MIs[1] Operand 1
     /* 2426649 */     // No operand predicates
     /* 2426649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426653 */     // MIs[0] policy
     /* 2426653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426665 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2426668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426690 */     // GIR_Coverage, 45482,
     /* 2426690 */     GIR_EraseRootFromParent_Done,
     /* 2426691 */   // Label 35107: @2426691
     /* 2426691 */   GIM_Try, /*On fail goto*//*Label 35108*/ GIMT_Encode4(2426774), // Rule ID 45483 //
     /* 2426696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2426705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2426712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426732 */     // MIs[1] Operand 1
     /* 2426732 */     // No operand predicates
     /* 2426732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426736 */     // MIs[0] policy
     /* 2426736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426748 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2426751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426773 */     // GIR_Coverage, 45483,
     /* 2426773 */     GIR_EraseRootFromParent_Done,
     /* 2426774 */   // Label 35108: @2426774
     /* 2426774 */   GIM_Try, /*On fail goto*//*Label 35109*/ GIMT_Encode4(2426846), // Rule ID 45484 //
     /* 2426779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2426788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2426795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426811 */     // MIs[0] policy
     /* 2426811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426821 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2426824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426845 */     // GIR_Coverage, 45484,
     /* 2426845 */     GIR_EraseRootFromParent_Done,
     /* 2426846 */   // Label 35109: @2426846
     /* 2426846 */   GIM_Try, /*On fail goto*//*Label 35110*/ GIMT_Encode4(2426918), // Rule ID 45485 //
     /* 2426851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2426860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2426867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426883 */     // MIs[0] policy
     /* 2426883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426893 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2426896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426917 */     // GIR_Coverage, 45485,
     /* 2426917 */     GIR_EraseRootFromParent_Done,
     /* 2426918 */   // Label 35110: @2426918
     /* 2426918 */   GIM_Reject,
     /* 2426919 */ // Label 35106: @2426919
     /* 2426919 */ GIM_Reject,
     /* 2426920 */ // Label 34952: @2426920
     /* 2426920 */ GIM_Try, /*On fail goto*//*Label 35111*/ GIMT_Encode4(2427552),
     /* 2426925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2426928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2426931 */   GIM_Try, /*On fail goto*//*Label 35112*/ GIMT_Encode4(2427014), // Rule ID 45498 //
     /* 2426936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2426945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2426952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426972 */     // MIs[1] Operand 1
     /* 2426972 */     // No operand predicates
     /* 2426972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426976 */     // MIs[0] policy
     /* 2426976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426988 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2426991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427013 */     // GIR_Coverage, 45498,
     /* 2427013 */     GIR_EraseRootFromParent_Done,
     /* 2427014 */   // Label 35112: @2427014
     /* 2427014 */   GIM_Try, /*On fail goto*//*Label 35113*/ GIMT_Encode4(2427097), // Rule ID 45499 //
     /* 2427019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427055 */     // MIs[1] Operand 1
     /* 2427055 */     // No operand predicates
     /* 2427055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427059 */     // MIs[0] policy
     /* 2427059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427071 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2427074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427096 */     // GIR_Coverage, 45499,
     /* 2427096 */     GIR_EraseRootFromParent_Done,
     /* 2427097 */   // Label 35113: @2427097
     /* 2427097 */   GIM_Try, /*On fail goto*//*Label 35114*/ GIMT_Encode4(2427180), // Rule ID 45558 //
     /* 2427102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427138 */     // MIs[1] Operand 1
     /* 2427138 */     // No operand predicates
     /* 2427138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427142 */     // MIs[0] policy
     /* 2427142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427154 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2427157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427179 */     // GIR_Coverage, 45558,
     /* 2427179 */     GIR_EraseRootFromParent_Done,
     /* 2427180 */   // Label 35114: @2427180
     /* 2427180 */   GIM_Try, /*On fail goto*//*Label 35115*/ GIMT_Encode4(2427263), // Rule ID 45559 //
     /* 2427185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427221 */     // MIs[1] Operand 1
     /* 2427221 */     // No operand predicates
     /* 2427221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427225 */     // MIs[0] policy
     /* 2427225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427237 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2427240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427262 */     // GIR_Coverage, 45559,
     /* 2427262 */     GIR_EraseRootFromParent_Done,
     /* 2427263 */   // Label 35115: @2427263
     /* 2427263 */   GIM_Try, /*On fail goto*//*Label 35116*/ GIMT_Encode4(2427335), // Rule ID 45500 //
     /* 2427268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427300 */     // MIs[0] policy
     /* 2427300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427310 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427334 */     // GIR_Coverage, 45500,
     /* 2427334 */     GIR_EraseRootFromParent_Done,
     /* 2427335 */   // Label 35116: @2427335
     /* 2427335 */   GIM_Try, /*On fail goto*//*Label 35117*/ GIMT_Encode4(2427407), // Rule ID 45501 //
     /* 2427340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427372 */     // MIs[0] policy
     /* 2427372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427382 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427406 */     // GIR_Coverage, 45501,
     /* 2427406 */     GIR_EraseRootFromParent_Done,
     /* 2427407 */   // Label 35117: @2427407
     /* 2427407 */   GIM_Try, /*On fail goto*//*Label 35118*/ GIMT_Encode4(2427479), // Rule ID 45560 //
     /* 2427412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427444 */     // MIs[0] policy
     /* 2427444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427454 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427478 */     // GIR_Coverage, 45560,
     /* 2427478 */     GIR_EraseRootFromParent_Done,
     /* 2427479 */   // Label 35118: @2427479
     /* 2427479 */   GIM_Try, /*On fail goto*//*Label 35119*/ GIMT_Encode4(2427551), // Rule ID 45561 //
     /* 2427484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2427493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427516 */     // MIs[0] policy
     /* 2427516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427526 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427550 */     // GIR_Coverage, 45561,
     /* 2427550 */     GIR_EraseRootFromParent_Done,
     /* 2427551 */   // Label 35119: @2427551
     /* 2427551 */   GIM_Reject,
     /* 2427552 */ // Label 35111: @2427552
     /* 2427552 */ GIM_Reject,
     /* 2427553 */ // Label 34953: @2427553
     /* 2427553 */ GIM_Try, /*On fail goto*//*Label 35120*/ GIMT_Encode4(2427875),
     /* 2427558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2427561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2427564 */   GIM_Try, /*On fail goto*//*Label 35121*/ GIMT_Encode4(2427647), // Rule ID 45486 //
     /* 2427569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2427578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427605 */     // MIs[1] Operand 1
     /* 2427605 */     // No operand predicates
     /* 2427605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427609 */     // MIs[0] policy
     /* 2427609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427621 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2427624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427646 */     // GIR_Coverage, 45486,
     /* 2427646 */     GIR_EraseRootFromParent_Done,
     /* 2427647 */   // Label 35121: @2427647
     /* 2427647 */   GIM_Try, /*On fail goto*//*Label 35122*/ GIMT_Encode4(2427730), // Rule ID 45487 //
     /* 2427652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2427661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427688 */     // MIs[1] Operand 1
     /* 2427688 */     // No operand predicates
     /* 2427688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427692 */     // MIs[0] policy
     /* 2427692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427704 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2427707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427729 */     // GIR_Coverage, 45487,
     /* 2427729 */     GIR_EraseRootFromParent_Done,
     /* 2427730 */   // Label 35122: @2427730
     /* 2427730 */   GIM_Try, /*On fail goto*//*Label 35123*/ GIMT_Encode4(2427802), // Rule ID 45488 //
     /* 2427735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2427744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427767 */     // MIs[0] policy
     /* 2427767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427777 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427801 */     // GIR_Coverage, 45488,
     /* 2427801 */     GIR_EraseRootFromParent_Done,
     /* 2427802 */   // Label 35123: @2427802
     /* 2427802 */   GIM_Try, /*On fail goto*//*Label 35124*/ GIMT_Encode4(2427874), // Rule ID 45489 //
     /* 2427807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2427816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2427823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427839 */     // MIs[0] policy
     /* 2427839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427849 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2427852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427873 */     // GIR_Coverage, 45489,
     /* 2427873 */     GIR_EraseRootFromParent_Done,
     /* 2427874 */   // Label 35124: @2427874
     /* 2427874 */   GIM_Reject,
     /* 2427875 */ // Label 35120: @2427875
     /* 2427875 */ GIM_Reject,
     /* 2427876 */ // Label 34954: @2427876
     /* 2427876 */ GIM_Reject,
     /* 2427877 */ // Label 124: @2427877
     /* 2427877 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35147*/ GIMT_Encode4(2439756),
     /* 2427888 */ /*GILLT_nxv1s8*//*Label 35125*/ GIMT_Encode4(2428000),
     /* 2427892 */ /*GILLT_nxv1s16*//*Label 35126*/ GIMT_Encode4(2428323),
     /* 2427896 */ /*GILLT_nxv1s32*//*Label 35127*/ GIMT_Encode4(2428956),
     /* 2427900 */ /*GILLT_nxv1s64*//*Label 35128*/ GIMT_Encode4(2429589), GIMT_Encode4(0),
     /* 2427908 */ /*GILLT_nxv2s8*//*Label 35129*/ GIMT_Encode4(2430222),
     /* 2427912 */ /*GILLT_nxv2s16*//*Label 35130*/ GIMT_Encode4(2430545),
     /* 2427916 */ /*GILLT_nxv2s32*//*Label 35131*/ GIMT_Encode4(2431178),
     /* 2427920 */ /*GILLT_nxv2s64*//*Label 35132*/ GIMT_Encode4(2431811), GIMT_Encode4(0),
     /* 2427928 */ /*GILLT_nxv4s8*//*Label 35133*/ GIMT_Encode4(2432444),
     /* 2427932 */ /*GILLT_nxv4s16*//*Label 35134*/ GIMT_Encode4(2432767),
     /* 2427936 */ /*GILLT_nxv4s32*//*Label 35135*/ GIMT_Encode4(2433400),
     /* 2427940 */ /*GILLT_nxv4s64*//*Label 35136*/ GIMT_Encode4(2434033), GIMT_Encode4(0),
     /* 2427948 */ /*GILLT_nxv8s8*//*Label 35137*/ GIMT_Encode4(2434666),
     /* 2427952 */ /*GILLT_nxv8s16*//*Label 35138*/ GIMT_Encode4(2434989),
     /* 2427956 */ /*GILLT_nxv8s32*//*Label 35139*/ GIMT_Encode4(2435622),
     /* 2427960 */ /*GILLT_nxv8s64*//*Label 35140*/ GIMT_Encode4(2436255), GIMT_Encode4(0),
     /* 2427968 */ /*GILLT_nxv16s8*//*Label 35141*/ GIMT_Encode4(2436888),
     /* 2427972 */ /*GILLT_nxv16s16*//*Label 35142*/ GIMT_Encode4(2437211),
     /* 2427976 */ /*GILLT_nxv16s32*//*Label 35143*/ GIMT_Encode4(2437844), GIMT_Encode4(0),
     /* 2427984 */ /*GILLT_nxv32s8*//*Label 35144*/ GIMT_Encode4(2438477),
     /* 2427988 */ /*GILLT_nxv32s16*//*Label 35145*/ GIMT_Encode4(2438800), GIMT_Encode4(0),
     /* 2427996 */ /*GILLT_nxv64s8*//*Label 35146*/ GIMT_Encode4(2439433),
     /* 2428000 */ // Label 35125: @2428000
     /* 2428000 */ GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2428322),
     /* 2428005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2428008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2428011 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2428094), // Rule ID 25352 //
     /* 2428016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428052 */     // MIs[1] Operand 1
     /* 2428052 */     // No operand predicates
     /* 2428052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428056 */     // MIs[0] policy
     /* 2428056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428068 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2428071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428093 */     // GIR_Coverage, 25352,
     /* 2428093 */     GIR_EraseRootFromParent_Done,
     /* 2428094 */   // Label 35149: @2428094
     /* 2428094 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2428177), // Rule ID 25353 //
     /* 2428099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428135 */     // MIs[1] Operand 1
     /* 2428135 */     // No operand predicates
     /* 2428135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428139 */     // MIs[0] policy
     /* 2428139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428151 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2428154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428176 */     // GIR_Coverage, 25353,
     /* 2428176 */     GIR_EraseRootFromParent_Done,
     /* 2428177 */   // Label 35150: @2428177
     /* 2428177 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2428249), // Rule ID 25354 //
     /* 2428182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428214 */     // MIs[0] policy
     /* 2428214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428224 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2428227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428248 */     // GIR_Coverage, 25354,
     /* 2428248 */     GIR_EraseRootFromParent_Done,
     /* 2428249 */   // Label 35151: @2428249
     /* 2428249 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2428321), // Rule ID 25355 //
     /* 2428254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428286 */     // MIs[0] policy
     /* 2428286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428296 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2428299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428320 */     // GIR_Coverage, 25355,
     /* 2428320 */     GIR_EraseRootFromParent_Done,
     /* 2428321 */   // Label 35152: @2428321
     /* 2428321 */   GIM_Reject,
     /* 2428322 */ // Label 35148: @2428322
     /* 2428322 */ GIM_Reject,
     /* 2428323 */ // Label 35126: @2428323
     /* 2428323 */ GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2428955),
     /* 2428328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2428331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2428334 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2428417), // Rule ID 45302 //
     /* 2428339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428375 */     // MIs[1] Operand 1
     /* 2428375 */     // No operand predicates
     /* 2428375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428379 */     // MIs[0] policy
     /* 2428379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428391 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2428394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428416 */     // GIR_Coverage, 45302,
     /* 2428416 */     GIR_EraseRootFromParent_Done,
     /* 2428417 */   // Label 35154: @2428417
     /* 2428417 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2428500), // Rule ID 45303 //
     /* 2428422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428458 */     // MIs[1] Operand 1
     /* 2428458 */     // No operand predicates
     /* 2428458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428462 */     // MIs[0] policy
     /* 2428462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428474 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2428477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428499 */     // GIR_Coverage, 45303,
     /* 2428499 */     GIR_EraseRootFromParent_Done,
     /* 2428500 */   // Label 35155: @2428500
     /* 2428500 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2428583), // Rule ID 45378 //
     /* 2428505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428541 */     // MIs[1] Operand 1
     /* 2428541 */     // No operand predicates
     /* 2428541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428545 */     // MIs[0] policy
     /* 2428545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428557 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2428560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428582 */     // GIR_Coverage, 45378,
     /* 2428582 */     GIR_EraseRootFromParent_Done,
     /* 2428583 */   // Label 35156: @2428583
     /* 2428583 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2428666), // Rule ID 45379 //
     /* 2428588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428624 */     // MIs[1] Operand 1
     /* 2428624 */     // No operand predicates
     /* 2428624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428628 */     // MIs[0] policy
     /* 2428628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428640 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2428643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428665 */     // GIR_Coverage, 45379,
     /* 2428665 */     GIR_EraseRootFromParent_Done,
     /* 2428666 */   // Label 35157: @2428666
     /* 2428666 */   GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2428738), // Rule ID 45304 //
     /* 2428671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428703 */     // MIs[0] policy
     /* 2428703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428713 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2428716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428737 */     // GIR_Coverage, 45304,
     /* 2428737 */     GIR_EraseRootFromParent_Done,
     /* 2428738 */   // Label 35158: @2428738
     /* 2428738 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2428810), // Rule ID 45305 //
     /* 2428743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428775 */     // MIs[0] policy
     /* 2428775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428785 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2428788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428809 */     // GIR_Coverage, 45305,
     /* 2428809 */     GIR_EraseRootFromParent_Done,
     /* 2428810 */   // Label 35159: @2428810
     /* 2428810 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2428882), // Rule ID 45380 //
     /* 2428815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428847 */     // MIs[0] policy
     /* 2428847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428857 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2428860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428881 */     // GIR_Coverage, 45380,
     /* 2428881 */     GIR_EraseRootFromParent_Done,
     /* 2428882 */   // Label 35160: @2428882
     /* 2428882 */   GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2428954), // Rule ID 45381 //
     /* 2428887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428919 */     // MIs[0] policy
     /* 2428919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428929 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2428932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428953 */     // GIR_Coverage, 45381,
     /* 2428953 */     GIR_EraseRootFromParent_Done,
     /* 2428954 */   // Label 35161: @2428954
     /* 2428954 */   GIM_Reject,
     /* 2428955 */ // Label 35153: @2428955
     /* 2428955 */ GIM_Reject,
     /* 2428956 */ // Label 35127: @2428956
     /* 2428956 */ GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2429588),
     /* 2428961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2428964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2428967 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2429050), // Rule ID 45310 //
     /* 2428972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429008 */     // MIs[1] Operand 1
     /* 2429008 */     // No operand predicates
     /* 2429008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429012 */     // MIs[0] policy
     /* 2429012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429024 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2429027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429049 */     // GIR_Coverage, 45310,
     /* 2429049 */     GIR_EraseRootFromParent_Done,
     /* 2429050 */   // Label 35163: @2429050
     /* 2429050 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2429133), // Rule ID 45311 //
     /* 2429055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429091 */     // MIs[1] Operand 1
     /* 2429091 */     // No operand predicates
     /* 2429091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429095 */     // MIs[0] policy
     /* 2429095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429107 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2429110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429132 */     // GIR_Coverage, 45311,
     /* 2429132 */     GIR_EraseRootFromParent_Done,
     /* 2429133 */   // Label 35164: @2429133
     /* 2429133 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2429216), // Rule ID 45386 //
     /* 2429138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429174 */     // MIs[1] Operand 1
     /* 2429174 */     // No operand predicates
     /* 2429174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429178 */     // MIs[0] policy
     /* 2429178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429190 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2429193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429215 */     // GIR_Coverage, 45386,
     /* 2429215 */     GIR_EraseRootFromParent_Done,
     /* 2429216 */   // Label 35165: @2429216
     /* 2429216 */   GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2429299), // Rule ID 45387 //
     /* 2429221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429257 */     // MIs[1] Operand 1
     /* 2429257 */     // No operand predicates
     /* 2429257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429261 */     // MIs[0] policy
     /* 2429261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429273 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2429276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429298 */     // GIR_Coverage, 45387,
     /* 2429298 */     GIR_EraseRootFromParent_Done,
     /* 2429299 */   // Label 35166: @2429299
     /* 2429299 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2429371), // Rule ID 45312 //
     /* 2429304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429336 */     // MIs[0] policy
     /* 2429336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429346 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2429349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429370 */     // GIR_Coverage, 45312,
     /* 2429370 */     GIR_EraseRootFromParent_Done,
     /* 2429371 */   // Label 35167: @2429371
     /* 2429371 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2429443), // Rule ID 45313 //
     /* 2429376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429408 */     // MIs[0] policy
     /* 2429408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429418 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2429421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429442 */     // GIR_Coverage, 45313,
     /* 2429442 */     GIR_EraseRootFromParent_Done,
     /* 2429443 */   // Label 35168: @2429443
     /* 2429443 */   GIM_Try, /*On fail goto*//*Label 35169*/ GIMT_Encode4(2429515), // Rule ID 45388 //
     /* 2429448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429480 */     // MIs[0] policy
     /* 2429480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429490 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2429493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429514 */     // GIR_Coverage, 45388,
     /* 2429514 */     GIR_EraseRootFromParent_Done,
     /* 2429515 */   // Label 35169: @2429515
     /* 2429515 */   GIM_Try, /*On fail goto*//*Label 35170*/ GIMT_Encode4(2429587), // Rule ID 45389 //
     /* 2429520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429552 */     // MIs[0] policy
     /* 2429552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429562 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2429565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429586 */     // GIR_Coverage, 45389,
     /* 2429586 */     GIR_EraseRootFromParent_Done,
     /* 2429587 */   // Label 35170: @2429587
     /* 2429587 */   GIM_Reject,
     /* 2429588 */ // Label 35162: @2429588
     /* 2429588 */ GIM_Reject,
     /* 2429589 */ // Label 35128: @2429589
     /* 2429589 */ GIM_Try, /*On fail goto*//*Label 35171*/ GIMT_Encode4(2430221),
     /* 2429594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2429597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2429600 */   GIM_Try, /*On fail goto*//*Label 35172*/ GIMT_Encode4(2429683), // Rule ID 45326 //
     /* 2429605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429641 */     // MIs[1] Operand 1
     /* 2429641 */     // No operand predicates
     /* 2429641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429645 */     // MIs[0] policy
     /* 2429645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429657 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2429660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429682 */     // GIR_Coverage, 45326,
     /* 2429682 */     GIR_EraseRootFromParent_Done,
     /* 2429683 */   // Label 35172: @2429683
     /* 2429683 */   GIM_Try, /*On fail goto*//*Label 35173*/ GIMT_Encode4(2429766), // Rule ID 45327 //
     /* 2429688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429724 */     // MIs[1] Operand 1
     /* 2429724 */     // No operand predicates
     /* 2429724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429728 */     // MIs[0] policy
     /* 2429728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429740 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2429743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429765 */     // GIR_Coverage, 45327,
     /* 2429765 */     GIR_EraseRootFromParent_Done,
     /* 2429766 */   // Label 35173: @2429766
     /* 2429766 */   GIM_Try, /*On fail goto*//*Label 35174*/ GIMT_Encode4(2429849), // Rule ID 45398 //
     /* 2429771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429807 */     // MIs[1] Operand 1
     /* 2429807 */     // No operand predicates
     /* 2429807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429811 */     // MIs[0] policy
     /* 2429811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429823 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2429826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429848 */     // GIR_Coverage, 45398,
     /* 2429848 */     GIR_EraseRootFromParent_Done,
     /* 2429849 */   // Label 35174: @2429849
     /* 2429849 */   GIM_Try, /*On fail goto*//*Label 35175*/ GIMT_Encode4(2429932), // Rule ID 45399 //
     /* 2429854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429890 */     // MIs[1] Operand 1
     /* 2429890 */     // No operand predicates
     /* 2429890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429894 */     // MIs[0] policy
     /* 2429894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429906 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2429909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429931 */     // GIR_Coverage, 45399,
     /* 2429931 */     GIR_EraseRootFromParent_Done,
     /* 2429932 */   // Label 35175: @2429932
     /* 2429932 */   GIM_Try, /*On fail goto*//*Label 35176*/ GIMT_Encode4(2430004), // Rule ID 45328 //
     /* 2429937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429969 */     // MIs[0] policy
     /* 2429969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429979 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2429982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430003 */     // GIR_Coverage, 45328,
     /* 2430003 */     GIR_EraseRootFromParent_Done,
     /* 2430004 */   // Label 35176: @2430004
     /* 2430004 */   GIM_Try, /*On fail goto*//*Label 35177*/ GIMT_Encode4(2430076), // Rule ID 45329 //
     /* 2430009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430041 */     // MIs[0] policy
     /* 2430041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430051 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2430054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430075 */     // GIR_Coverage, 45329,
     /* 2430075 */     GIR_EraseRootFromParent_Done,
     /* 2430076 */   // Label 35177: @2430076
     /* 2430076 */   GIM_Try, /*On fail goto*//*Label 35178*/ GIMT_Encode4(2430148), // Rule ID 45400 //
     /* 2430081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430113 */     // MIs[0] policy
     /* 2430113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430123 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2430126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430147 */     // GIR_Coverage, 45400,
     /* 2430147 */     GIR_EraseRootFromParent_Done,
     /* 2430148 */   // Label 35178: @2430148
     /* 2430148 */   GIM_Try, /*On fail goto*//*Label 35179*/ GIMT_Encode4(2430220), // Rule ID 45401 //
     /* 2430153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2430162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430185 */     // MIs[0] policy
     /* 2430185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430195 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2430198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430219 */     // GIR_Coverage, 45401,
     /* 2430219 */     GIR_EraseRootFromParent_Done,
     /* 2430220 */   // Label 35179: @2430220
     /* 2430220 */   GIM_Reject,
     /* 2430221 */ // Label 35171: @2430221
     /* 2430221 */ GIM_Reject,
     /* 2430222 */ // Label 35129: @2430222
     /* 2430222 */ GIM_Try, /*On fail goto*//*Label 35180*/ GIMT_Encode4(2430544),
     /* 2430227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2430230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2430233 */   GIM_Try, /*On fail goto*//*Label 35181*/ GIMT_Encode4(2430316), // Rule ID 45294 //
     /* 2430238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430274 */     // MIs[1] Operand 1
     /* 2430274 */     // No operand predicates
     /* 2430274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430278 */     // MIs[0] policy
     /* 2430278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430290 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2430293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430315 */     // GIR_Coverage, 45294,
     /* 2430315 */     GIR_EraseRootFromParent_Done,
     /* 2430316 */   // Label 35181: @2430316
     /* 2430316 */   GIM_Try, /*On fail goto*//*Label 35182*/ GIMT_Encode4(2430399), // Rule ID 45295 //
     /* 2430321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430357 */     // MIs[1] Operand 1
     /* 2430357 */     // No operand predicates
     /* 2430357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430361 */     // MIs[0] policy
     /* 2430361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430373 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2430376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430398 */     // GIR_Coverage, 45295,
     /* 2430398 */     GIR_EraseRootFromParent_Done,
     /* 2430399 */   // Label 35182: @2430399
     /* 2430399 */   GIM_Try, /*On fail goto*//*Label 35183*/ GIMT_Encode4(2430471), // Rule ID 45296 //
     /* 2430404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430436 */     // MIs[0] policy
     /* 2430436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430446 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2430449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430470 */     // GIR_Coverage, 45296,
     /* 2430470 */     GIR_EraseRootFromParent_Done,
     /* 2430471 */   // Label 35183: @2430471
     /* 2430471 */   GIM_Try, /*On fail goto*//*Label 35184*/ GIMT_Encode4(2430543), // Rule ID 45297 //
     /* 2430476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430508 */     // MIs[0] policy
     /* 2430508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430518 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2430521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430542 */     // GIR_Coverage, 45297,
     /* 2430542 */     GIR_EraseRootFromParent_Done,
     /* 2430543 */   // Label 35184: @2430543
     /* 2430543 */   GIM_Reject,
     /* 2430544 */ // Label 35180: @2430544
     /* 2430544 */ GIM_Reject,
     /* 2430545 */ // Label 35130: @2430545
     /* 2430545 */ GIM_Try, /*On fail goto*//*Label 35185*/ GIMT_Encode4(2431177),
     /* 2430550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2430553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2430556 */   GIM_Try, /*On fail goto*//*Label 35186*/ GIMT_Encode4(2430639), // Rule ID 45306 //
     /* 2430561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430597 */     // MIs[1] Operand 1
     /* 2430597 */     // No operand predicates
     /* 2430597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430601 */     // MIs[0] policy
     /* 2430601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430613 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2430616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430638 */     // GIR_Coverage, 45306,
     /* 2430638 */     GIR_EraseRootFromParent_Done,
     /* 2430639 */   // Label 35186: @2430639
     /* 2430639 */   GIM_Try, /*On fail goto*//*Label 35187*/ GIMT_Encode4(2430722), // Rule ID 45307 //
     /* 2430644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430680 */     // MIs[1] Operand 1
     /* 2430680 */     // No operand predicates
     /* 2430680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430684 */     // MIs[0] policy
     /* 2430684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430696 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2430699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430721 */     // GIR_Coverage, 45307,
     /* 2430721 */     GIR_EraseRootFromParent_Done,
     /* 2430722 */   // Label 35187: @2430722
     /* 2430722 */   GIM_Try, /*On fail goto*//*Label 35188*/ GIMT_Encode4(2430805), // Rule ID 45382 //
     /* 2430727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430763 */     // MIs[1] Operand 1
     /* 2430763 */     // No operand predicates
     /* 2430763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430767 */     // MIs[0] policy
     /* 2430767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430779 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2430782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430804 */     // GIR_Coverage, 45382,
     /* 2430804 */     GIR_EraseRootFromParent_Done,
     /* 2430805 */   // Label 35188: @2430805
     /* 2430805 */   GIM_Try, /*On fail goto*//*Label 35189*/ GIMT_Encode4(2430888), // Rule ID 45383 //
     /* 2430810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430846 */     // MIs[1] Operand 1
     /* 2430846 */     // No operand predicates
     /* 2430846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430850 */     // MIs[0] policy
     /* 2430850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430862 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2430865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430887 */     // GIR_Coverage, 45383,
     /* 2430887 */     GIR_EraseRootFromParent_Done,
     /* 2430888 */   // Label 35189: @2430888
     /* 2430888 */   GIM_Try, /*On fail goto*//*Label 35190*/ GIMT_Encode4(2430960), // Rule ID 45308 //
     /* 2430893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430925 */     // MIs[0] policy
     /* 2430925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430935 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2430938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430959 */     // GIR_Coverage, 45308,
     /* 2430959 */     GIR_EraseRootFromParent_Done,
     /* 2430960 */   // Label 35190: @2430960
     /* 2430960 */   GIM_Try, /*On fail goto*//*Label 35191*/ GIMT_Encode4(2431032), // Rule ID 45309 //
     /* 2430965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430997 */     // MIs[0] policy
     /* 2430997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431007 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2431010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431031 */     // GIR_Coverage, 45309,
     /* 2431031 */     GIR_EraseRootFromParent_Done,
     /* 2431032 */   // Label 35191: @2431032
     /* 2431032 */   GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2431104), // Rule ID 45384 //
     /* 2431037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431069 */     // MIs[0] policy
     /* 2431069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431079 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2431082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431103 */     // GIR_Coverage, 45384,
     /* 2431103 */     GIR_EraseRootFromParent_Done,
     /* 2431104 */   // Label 35192: @2431104
     /* 2431104 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2431176), // Rule ID 45385 //
     /* 2431109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431141 */     // MIs[0] policy
     /* 2431141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431151 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2431154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431175 */     // GIR_Coverage, 45385,
     /* 2431175 */     GIR_EraseRootFromParent_Done,
     /* 2431176 */   // Label 35193: @2431176
     /* 2431176 */   GIM_Reject,
     /* 2431177 */ // Label 35185: @2431177
     /* 2431177 */ GIM_Reject,
     /* 2431178 */ // Label 35131: @2431178
     /* 2431178 */ GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2431810),
     /* 2431183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2431186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2431189 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2431272), // Rule ID 45322 //
     /* 2431194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431230 */     // MIs[1] Operand 1
     /* 2431230 */     // No operand predicates
     /* 2431230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431234 */     // MIs[0] policy
     /* 2431234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431246 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2431249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431271 */     // GIR_Coverage, 45322,
     /* 2431271 */     GIR_EraseRootFromParent_Done,
     /* 2431272 */   // Label 35195: @2431272
     /* 2431272 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2431355), // Rule ID 45323 //
     /* 2431277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431313 */     // MIs[1] Operand 1
     /* 2431313 */     // No operand predicates
     /* 2431313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431317 */     // MIs[0] policy
     /* 2431317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431329 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2431332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431354 */     // GIR_Coverage, 45323,
     /* 2431354 */     GIR_EraseRootFromParent_Done,
     /* 2431355 */   // Label 35196: @2431355
     /* 2431355 */   GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2431438), // Rule ID 45394 //
     /* 2431360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431396 */     // MIs[1] Operand 1
     /* 2431396 */     // No operand predicates
     /* 2431396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431400 */     // MIs[0] policy
     /* 2431400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431412 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2431415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431437 */     // GIR_Coverage, 45394,
     /* 2431437 */     GIR_EraseRootFromParent_Done,
     /* 2431438 */   // Label 35197: @2431438
     /* 2431438 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2431521), // Rule ID 45395 //
     /* 2431443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431479 */     // MIs[1] Operand 1
     /* 2431479 */     // No operand predicates
     /* 2431479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431483 */     // MIs[0] policy
     /* 2431483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431495 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2431498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431520 */     // GIR_Coverage, 45395,
     /* 2431520 */     GIR_EraseRootFromParent_Done,
     /* 2431521 */   // Label 35198: @2431521
     /* 2431521 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2431593), // Rule ID 45324 //
     /* 2431526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431558 */     // MIs[0] policy
     /* 2431558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431568 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2431571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431592 */     // GIR_Coverage, 45324,
     /* 2431592 */     GIR_EraseRootFromParent_Done,
     /* 2431593 */   // Label 35199: @2431593
     /* 2431593 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2431665), // Rule ID 45325 //
     /* 2431598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431630 */     // MIs[0] policy
     /* 2431630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431640 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2431643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431664 */     // GIR_Coverage, 45325,
     /* 2431664 */     GIR_EraseRootFromParent_Done,
     /* 2431665 */   // Label 35200: @2431665
     /* 2431665 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2431737), // Rule ID 45396 //
     /* 2431670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431702 */     // MIs[0] policy
     /* 2431702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431712 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2431715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431736 */     // GIR_Coverage, 45396,
     /* 2431736 */     GIR_EraseRootFromParent_Done,
     /* 2431737 */   // Label 35201: @2431737
     /* 2431737 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2431809), // Rule ID 45397 //
     /* 2431742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431774 */     // MIs[0] policy
     /* 2431774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431784 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2431787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431808 */     // GIR_Coverage, 45397,
     /* 2431808 */     GIR_EraseRootFromParent_Done,
     /* 2431809 */   // Label 35202: @2431809
     /* 2431809 */   GIM_Reject,
     /* 2431810 */ // Label 35194: @2431810
     /* 2431810 */ GIM_Reject,
     /* 2431811 */ // Label 35132: @2431811
     /* 2431811 */ GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2432443),
     /* 2431816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2431819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2431822 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2431905), // Rule ID 45366 //
     /* 2431827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431863 */     // MIs[1] Operand 1
     /* 2431863 */     // No operand predicates
     /* 2431863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431867 */     // MIs[0] policy
     /* 2431867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431879 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2431882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431904 */     // GIR_Coverage, 45366,
     /* 2431904 */     GIR_EraseRootFromParent_Done,
     /* 2431905 */   // Label 35204: @2431905
     /* 2431905 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2431988), // Rule ID 45367 //
     /* 2431910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431946 */     // MIs[1] Operand 1
     /* 2431946 */     // No operand predicates
     /* 2431946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431950 */     // MIs[0] policy
     /* 2431950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431962 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2431965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431987 */     // GIR_Coverage, 45367,
     /* 2431987 */     GIR_EraseRootFromParent_Done,
     /* 2431988 */   // Label 35205: @2431988
     /* 2431988 */   GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2432071), // Rule ID 45426 //
     /* 2431993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432029 */     // MIs[1] Operand 1
     /* 2432029 */     // No operand predicates
     /* 2432029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432033 */     // MIs[0] policy
     /* 2432033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432045 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2432048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432070 */     // GIR_Coverage, 45426,
     /* 2432070 */     GIR_EraseRootFromParent_Done,
     /* 2432071 */   // Label 35206: @2432071
     /* 2432071 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2432154), // Rule ID 45427 //
     /* 2432076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432112 */     // MIs[1] Operand 1
     /* 2432112 */     // No operand predicates
     /* 2432112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432116 */     // MIs[0] policy
     /* 2432116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432128 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2432131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432153 */     // GIR_Coverage, 45427,
     /* 2432153 */     GIR_EraseRootFromParent_Done,
     /* 2432154 */   // Label 35207: @2432154
     /* 2432154 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2432226), // Rule ID 45368 //
     /* 2432159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432191 */     // MIs[0] policy
     /* 2432191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432201 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432225 */     // GIR_Coverage, 45368,
     /* 2432225 */     GIR_EraseRootFromParent_Done,
     /* 2432226 */   // Label 35208: @2432226
     /* 2432226 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2432298), // Rule ID 45369 //
     /* 2432231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432263 */     // MIs[0] policy
     /* 2432263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432273 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432297 */     // GIR_Coverage, 45369,
     /* 2432297 */     GIR_EraseRootFromParent_Done,
     /* 2432298 */   // Label 35209: @2432298
     /* 2432298 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2432370), // Rule ID 45428 //
     /* 2432303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432335 */     // MIs[0] policy
     /* 2432335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432345 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432369 */     // GIR_Coverage, 45428,
     /* 2432369 */     GIR_EraseRootFromParent_Done,
     /* 2432370 */   // Label 35210: @2432370
     /* 2432370 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2432442), // Rule ID 45429 //
     /* 2432375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2432384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432407 */     // MIs[0] policy
     /* 2432407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432417 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432441 */     // GIR_Coverage, 45429,
     /* 2432441 */     GIR_EraseRootFromParent_Done,
     /* 2432442 */   // Label 35211: @2432442
     /* 2432442 */   GIM_Reject,
     /* 2432443 */ // Label 35203: @2432443
     /* 2432443 */ GIM_Reject,
     /* 2432444 */ // Label 35133: @2432444
     /* 2432444 */ GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2432766),
     /* 2432449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2432452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2432455 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2432538), // Rule ID 45298 //
     /* 2432460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432496 */     // MIs[1] Operand 1
     /* 2432496 */     // No operand predicates
     /* 2432496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432500 */     // MIs[0] policy
     /* 2432500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432512 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2432515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432537 */     // GIR_Coverage, 45298,
     /* 2432537 */     GIR_EraseRootFromParent_Done,
     /* 2432538 */   // Label 35213: @2432538
     /* 2432538 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2432621), // Rule ID 45299 //
     /* 2432543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432579 */     // MIs[1] Operand 1
     /* 2432579 */     // No operand predicates
     /* 2432579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432583 */     // MIs[0] policy
     /* 2432583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432595 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2432598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432620 */     // GIR_Coverage, 45299,
     /* 2432620 */     GIR_EraseRootFromParent_Done,
     /* 2432621 */   // Label 35214: @2432621
     /* 2432621 */   GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2432693), // Rule ID 45300 //
     /* 2432626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432658 */     // MIs[0] policy
     /* 2432658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432668 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2432671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432692 */     // GIR_Coverage, 45300,
     /* 2432692 */     GIR_EraseRootFromParent_Done,
     /* 2432693 */   // Label 35215: @2432693
     /* 2432693 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2432765), // Rule ID 45301 //
     /* 2432698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432730 */     // MIs[0] policy
     /* 2432730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432740 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2432743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432764 */     // GIR_Coverage, 45301,
     /* 2432764 */     GIR_EraseRootFromParent_Done,
     /* 2432765 */   // Label 35216: @2432765
     /* 2432765 */   GIM_Reject,
     /* 2432766 */ // Label 35212: @2432766
     /* 2432766 */ GIM_Reject,
     /* 2432767 */ // Label 35134: @2432767
     /* 2432767 */ GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2433399),
     /* 2432772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2432775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2432778 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2432861), // Rule ID 45318 //
     /* 2432783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432819 */     // MIs[1] Operand 1
     /* 2432819 */     // No operand predicates
     /* 2432819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432823 */     // MIs[0] policy
     /* 2432823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432835 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2432838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432860 */     // GIR_Coverage, 45318,
     /* 2432860 */     GIR_EraseRootFromParent_Done,
     /* 2432861 */   // Label 35218: @2432861
     /* 2432861 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2432944), // Rule ID 45319 //
     /* 2432866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432902 */     // MIs[1] Operand 1
     /* 2432902 */     // No operand predicates
     /* 2432902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432906 */     // MIs[0] policy
     /* 2432906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432918 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2432921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432943 */     // GIR_Coverage, 45319,
     /* 2432943 */     GIR_EraseRootFromParent_Done,
     /* 2432944 */   // Label 35219: @2432944
     /* 2432944 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2433027), // Rule ID 45390 //
     /* 2432949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432985 */     // MIs[1] Operand 1
     /* 2432985 */     // No operand predicates
     /* 2432985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432989 */     // MIs[0] policy
     /* 2432989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433001 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2433004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433026 */     // GIR_Coverage, 45390,
     /* 2433026 */     GIR_EraseRootFromParent_Done,
     /* 2433027 */   // Label 35220: @2433027
     /* 2433027 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2433110), // Rule ID 45391 //
     /* 2433032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433068 */     // MIs[1] Operand 1
     /* 2433068 */     // No operand predicates
     /* 2433068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433072 */     // MIs[0] policy
     /* 2433072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433084 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2433087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433109 */     // GIR_Coverage, 45391,
     /* 2433109 */     GIR_EraseRootFromParent_Done,
     /* 2433110 */   // Label 35221: @2433110
     /* 2433110 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2433182), // Rule ID 45320 //
     /* 2433115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433147 */     // MIs[0] policy
     /* 2433147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433157 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2433160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433181 */     // GIR_Coverage, 45320,
     /* 2433181 */     GIR_EraseRootFromParent_Done,
     /* 2433182 */   // Label 35222: @2433182
     /* 2433182 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2433254), // Rule ID 45321 //
     /* 2433187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433219 */     // MIs[0] policy
     /* 2433219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433229 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2433232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433253 */     // GIR_Coverage, 45321,
     /* 2433253 */     GIR_EraseRootFromParent_Done,
     /* 2433254 */   // Label 35223: @2433254
     /* 2433254 */   GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2433326), // Rule ID 45392 //
     /* 2433259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433291 */     // MIs[0] policy
     /* 2433291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433301 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2433304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433325 */     // GIR_Coverage, 45392,
     /* 2433325 */     GIR_EraseRootFromParent_Done,
     /* 2433326 */   // Label 35224: @2433326
     /* 2433326 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2433398), // Rule ID 45393 //
     /* 2433331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2433347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2433355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433363 */     // MIs[0] policy
     /* 2433363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433373 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2433376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433397 */     // GIR_Coverage, 45393,
     /* 2433397 */     GIR_EraseRootFromParent_Done,
     /* 2433398 */   // Label 35225: @2433398
     /* 2433398 */   GIM_Reject,
     /* 2433399 */ // Label 35217: @2433399
     /* 2433399 */ GIM_Reject,
     /* 2433400 */ // Label 35135: @2433400
     /* 2433400 */ GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2434032),
     /* 2433405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2433408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2433411 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2433494), // Rule ID 45354 //
     /* 2433416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433452 */     // MIs[1] Operand 1
     /* 2433452 */     // No operand predicates
     /* 2433452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433456 */     // MIs[0] policy
     /* 2433456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433468 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2433471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433493 */     // GIR_Coverage, 45354,
     /* 2433493 */     GIR_EraseRootFromParent_Done,
     /* 2433494 */   // Label 35227: @2433494
     /* 2433494 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2433577), // Rule ID 45355 //
     /* 2433499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433535 */     // MIs[1] Operand 1
     /* 2433535 */     // No operand predicates
     /* 2433535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433539 */     // MIs[0] policy
     /* 2433539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433551 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2433554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433576 */     // GIR_Coverage, 45355,
     /* 2433576 */     GIR_EraseRootFromParent_Done,
     /* 2433577 */   // Label 35228: @2433577
     /* 2433577 */   GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2433660), // Rule ID 45414 //
     /* 2433582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433618 */     // MIs[1] Operand 1
     /* 2433618 */     // No operand predicates
     /* 2433618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433622 */     // MIs[0] policy
     /* 2433622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433634 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2433637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433659 */     // GIR_Coverage, 45414,
     /* 2433659 */     GIR_EraseRootFromParent_Done,
     /* 2433660 */   // Label 35229: @2433660
     /* 2433660 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2433743), // Rule ID 45415 //
     /* 2433665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433701 */     // MIs[1] Operand 1
     /* 2433701 */     // No operand predicates
     /* 2433701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433705 */     // MIs[0] policy
     /* 2433705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433717 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2433720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433742 */     // GIR_Coverage, 45415,
     /* 2433742 */     GIR_EraseRootFromParent_Done,
     /* 2433743 */   // Label 35230: @2433743
     /* 2433743 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2433815), // Rule ID 45356 //
     /* 2433748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433780 */     // MIs[0] policy
     /* 2433780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433790 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2433793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433814 */     // GIR_Coverage, 45356,
     /* 2433814 */     GIR_EraseRootFromParent_Done,
     /* 2433815 */   // Label 35231: @2433815
     /* 2433815 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2433887), // Rule ID 45357 //
     /* 2433820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433852 */     // MIs[0] policy
     /* 2433852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433862 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2433865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433886 */     // GIR_Coverage, 45357,
     /* 2433886 */     GIR_EraseRootFromParent_Done,
     /* 2433887 */   // Label 35232: @2433887
     /* 2433887 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2433959), // Rule ID 45416 //
     /* 2433892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433924 */     // MIs[0] policy
     /* 2433924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433934 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2433937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433958 */     // GIR_Coverage, 45416,
     /* 2433958 */     GIR_EraseRootFromParent_Done,
     /* 2433959 */   // Label 35233: @2433959
     /* 2433959 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2434031), // Rule ID 45417 //
     /* 2433964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433996 */     // MIs[0] policy
     /* 2433996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434006 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2434009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434030 */     // GIR_Coverage, 45417,
     /* 2434030 */     GIR_EraseRootFromParent_Done,
     /* 2434031 */   // Label 35234: @2434031
     /* 2434031 */   GIM_Reject,
     /* 2434032 */ // Label 35226: @2434032
     /* 2434032 */ GIM_Reject,
     /* 2434033 */ // Label 35136: @2434033
     /* 2434033 */ GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2434665),
     /* 2434038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2434041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2434044 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2434127), // Rule ID 45370 //
     /* 2434049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434085 */     // MIs[1] Operand 1
     /* 2434085 */     // No operand predicates
     /* 2434085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434089 */     // MIs[0] policy
     /* 2434089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434101 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434126 */     // GIR_Coverage, 45370,
     /* 2434126 */     GIR_EraseRootFromParent_Done,
     /* 2434127 */   // Label 35236: @2434127
     /* 2434127 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2434210), // Rule ID 45371 //
     /* 2434132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434168 */     // MIs[1] Operand 1
     /* 2434168 */     // No operand predicates
     /* 2434168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434172 */     // MIs[0] policy
     /* 2434172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434184 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434209 */     // GIR_Coverage, 45371,
     /* 2434209 */     GIR_EraseRootFromParent_Done,
     /* 2434210 */   // Label 35237: @2434210
     /* 2434210 */   GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2434293), // Rule ID 45430 //
     /* 2434215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434251 */     // MIs[1] Operand 1
     /* 2434251 */     // No operand predicates
     /* 2434251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434255 */     // MIs[0] policy
     /* 2434255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434267 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434292 */     // GIR_Coverage, 45430,
     /* 2434292 */     GIR_EraseRootFromParent_Done,
     /* 2434293 */   // Label 35238: @2434293
     /* 2434293 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2434376), // Rule ID 45431 //
     /* 2434298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434334 */     // MIs[1] Operand 1
     /* 2434334 */     // No operand predicates
     /* 2434334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434338 */     // MIs[0] policy
     /* 2434338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434350 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434375 */     // GIR_Coverage, 45431,
     /* 2434375 */     GIR_EraseRootFromParent_Done,
     /* 2434376 */   // Label 35239: @2434376
     /* 2434376 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2434448), // Rule ID 45372 //
     /* 2434381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434413 */     // MIs[0] policy
     /* 2434413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434423 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434447 */     // GIR_Coverage, 45372,
     /* 2434447 */     GIR_EraseRootFromParent_Done,
     /* 2434448 */   // Label 35240: @2434448
     /* 2434448 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2434520), // Rule ID 45373 //
     /* 2434453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434485 */     // MIs[0] policy
     /* 2434485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434495 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434519 */     // GIR_Coverage, 45373,
     /* 2434519 */     GIR_EraseRootFromParent_Done,
     /* 2434520 */   // Label 35241: @2434520
     /* 2434520 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2434592), // Rule ID 45432 //
     /* 2434525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2434528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434557 */     // MIs[0] policy
     /* 2434557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434567 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434578 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434591 */     // GIR_Coverage, 45432,
     /* 2434591 */     GIR_EraseRootFromParent_Done,
     /* 2434592 */   // Label 35242: @2434592
     /* 2434592 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2434664), // Rule ID 45433 //
     /* 2434597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2434600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2434606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434629 */     // MIs[0] policy
     /* 2434629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434639 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434650 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434663 */     // GIR_Coverage, 45433,
     /* 2434663 */     GIR_EraseRootFromParent_Done,
     /* 2434664 */   // Label 35243: @2434664
     /* 2434664 */   GIM_Reject,
     /* 2434665 */ // Label 35235: @2434665
     /* 2434665 */ GIM_Reject,
     /* 2434666 */ // Label 35137: @2434666
     /* 2434666 */ GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2434988),
     /* 2434671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2434674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2434677 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2434760), // Rule ID 45314 //
     /* 2434682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434718 */     // MIs[1] Operand 1
     /* 2434718 */     // No operand predicates
     /* 2434718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434722 */     // MIs[0] policy
     /* 2434722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434734 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2434737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434759 */     // GIR_Coverage, 45314,
     /* 2434759 */     GIR_EraseRootFromParent_Done,
     /* 2434760 */   // Label 35245: @2434760
     /* 2434760 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2434843), // Rule ID 45315 //
     /* 2434765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434801 */     // MIs[1] Operand 1
     /* 2434801 */     // No operand predicates
     /* 2434801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434805 */     // MIs[0] policy
     /* 2434805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434817 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2434820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434842 */     // GIR_Coverage, 45315,
     /* 2434842 */     GIR_EraseRootFromParent_Done,
     /* 2434843 */   // Label 35246: @2434843
     /* 2434843 */   GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2434915), // Rule ID 45316 //
     /* 2434848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434880 */     // MIs[0] policy
     /* 2434880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434890 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2434893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434914 */     // GIR_Coverage, 45316,
     /* 2434914 */     GIR_EraseRootFromParent_Done,
     /* 2434915 */   // Label 35247: @2434915
     /* 2434915 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2434987), // Rule ID 45317 //
     /* 2434920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434952 */     // MIs[0] policy
     /* 2434952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434962 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2434965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434986 */     // GIR_Coverage, 45317,
     /* 2434986 */     GIR_EraseRootFromParent_Done,
     /* 2434987 */   // Label 35248: @2434987
     /* 2434987 */   GIM_Reject,
     /* 2434988 */ // Label 35244: @2434988
     /* 2434988 */ GIM_Reject,
     /* 2434989 */ // Label 35138: @2434989
     /* 2434989 */ GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2435621),
     /* 2434994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2434997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2435000 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2435083), // Rule ID 45342 //
     /* 2435005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435041 */     // MIs[1] Operand 1
     /* 2435041 */     // No operand predicates
     /* 2435041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435045 */     // MIs[0] policy
     /* 2435045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435057 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2435060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435082 */     // GIR_Coverage, 45342,
     /* 2435082 */     GIR_EraseRootFromParent_Done,
     /* 2435083 */   // Label 35250: @2435083
     /* 2435083 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2435166), // Rule ID 45343 //
     /* 2435088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435124 */     // MIs[1] Operand 1
     /* 2435124 */     // No operand predicates
     /* 2435124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435128 */     // MIs[0] policy
     /* 2435128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435140 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2435143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435165 */     // GIR_Coverage, 45343,
     /* 2435165 */     GIR_EraseRootFromParent_Done,
     /* 2435166 */   // Label 35251: @2435166
     /* 2435166 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2435249), // Rule ID 45402 //
     /* 2435171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435207 */     // MIs[1] Operand 1
     /* 2435207 */     // No operand predicates
     /* 2435207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435211 */     // MIs[0] policy
     /* 2435211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435223 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2435226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435248 */     // GIR_Coverage, 45402,
     /* 2435248 */     GIR_EraseRootFromParent_Done,
     /* 2435249 */   // Label 35252: @2435249
     /* 2435249 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2435332), // Rule ID 45403 //
     /* 2435254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435290 */     // MIs[1] Operand 1
     /* 2435290 */     // No operand predicates
     /* 2435290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435294 */     // MIs[0] policy
     /* 2435294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435306 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2435309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435331 */     // GIR_Coverage, 45403,
     /* 2435331 */     GIR_EraseRootFromParent_Done,
     /* 2435332 */   // Label 35253: @2435332
     /* 2435332 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2435404), // Rule ID 45344 //
     /* 2435337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435369 */     // MIs[0] policy
     /* 2435369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435379 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2435382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435403 */     // GIR_Coverage, 45344,
     /* 2435403 */     GIR_EraseRootFromParent_Done,
     /* 2435404 */   // Label 35254: @2435404
     /* 2435404 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2435476), // Rule ID 45345 //
     /* 2435409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435441 */     // MIs[0] policy
     /* 2435441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435451 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2435454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435475 */     // GIR_Coverage, 45345,
     /* 2435475 */     GIR_EraseRootFromParent_Done,
     /* 2435476 */   // Label 35255: @2435476
     /* 2435476 */   GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2435548), // Rule ID 45404 //
     /* 2435481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435513 */     // MIs[0] policy
     /* 2435513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435523 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2435526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435547 */     // GIR_Coverage, 45404,
     /* 2435547 */     GIR_EraseRootFromParent_Done,
     /* 2435548 */   // Label 35256: @2435548
     /* 2435548 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2435620), // Rule ID 45405 //
     /* 2435553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2435569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2435577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435585 */     // MIs[0] policy
     /* 2435585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435595 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2435598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435619 */     // GIR_Coverage, 45405,
     /* 2435619 */     GIR_EraseRootFromParent_Done,
     /* 2435620 */   // Label 35257: @2435620
     /* 2435620 */   GIM_Reject,
     /* 2435621 */ // Label 35249: @2435621
     /* 2435621 */ GIM_Reject,
     /* 2435622 */ // Label 35139: @2435622
     /* 2435622 */ GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2436254),
     /* 2435627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2435630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2435633 */   GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2435716), // Rule ID 45358 //
     /* 2435638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435674 */     // MIs[1] Operand 1
     /* 2435674 */     // No operand predicates
     /* 2435674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435678 */     // MIs[0] policy
     /* 2435678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435690 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2435693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435715 */     // GIR_Coverage, 45358,
     /* 2435715 */     GIR_EraseRootFromParent_Done,
     /* 2435716 */   // Label 35259: @2435716
     /* 2435716 */   GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2435799), // Rule ID 45359 //
     /* 2435721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435757 */     // MIs[1] Operand 1
     /* 2435757 */     // No operand predicates
     /* 2435757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435761 */     // MIs[0] policy
     /* 2435761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435773 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2435776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435798 */     // GIR_Coverage, 45359,
     /* 2435798 */     GIR_EraseRootFromParent_Done,
     /* 2435799 */   // Label 35260: @2435799
     /* 2435799 */   GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2435882), // Rule ID 45418 //
     /* 2435804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435840 */     // MIs[1] Operand 1
     /* 2435840 */     // No operand predicates
     /* 2435840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435844 */     // MIs[0] policy
     /* 2435844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435856 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2435859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435881 */     // GIR_Coverage, 45418,
     /* 2435881 */     GIR_EraseRootFromParent_Done,
     /* 2435882 */   // Label 35261: @2435882
     /* 2435882 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2435965), // Rule ID 45419 //
     /* 2435887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435923 */     // MIs[1] Operand 1
     /* 2435923 */     // No operand predicates
     /* 2435923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435927 */     // MIs[0] policy
     /* 2435927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435939 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2435942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435964 */     // GIR_Coverage, 45419,
     /* 2435964 */     GIR_EraseRootFromParent_Done,
     /* 2435965 */   // Label 35262: @2435965
     /* 2435965 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2436037), // Rule ID 45360 //
     /* 2435970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436002 */     // MIs[0] policy
     /* 2436002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436012 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2436015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436036 */     // GIR_Coverage, 45360,
     /* 2436036 */     GIR_EraseRootFromParent_Done,
     /* 2436037 */   // Label 35263: @2436037
     /* 2436037 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2436109), // Rule ID 45361 //
     /* 2436042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436074 */     // MIs[0] policy
     /* 2436074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436084 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2436087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436108 */     // GIR_Coverage, 45361,
     /* 2436108 */     GIR_EraseRootFromParent_Done,
     /* 2436109 */   // Label 35264: @2436109
     /* 2436109 */   GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2436181), // Rule ID 45420 //
     /* 2436114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436146 */     // MIs[0] policy
     /* 2436146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436156 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2436159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436180 */     // GIR_Coverage, 45420,
     /* 2436180 */     GIR_EraseRootFromParent_Done,
     /* 2436181 */   // Label 35265: @2436181
     /* 2436181 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2436253), // Rule ID 45421 //
     /* 2436186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436218 */     // MIs[0] policy
     /* 2436218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436228 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2436231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2436249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436252 */     // GIR_Coverage, 45421,
     /* 2436252 */     GIR_EraseRootFromParent_Done,
     /* 2436253 */   // Label 35266: @2436253
     /* 2436253 */   GIM_Reject,
     /* 2436254 */ // Label 35258: @2436254
     /* 2436254 */ GIM_Reject,
     /* 2436255 */ // Label 35140: @2436255
     /* 2436255 */ GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2436887),
     /* 2436260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2436263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2436266 */   GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2436349), // Rule ID 45374 //
     /* 2436271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436307 */     // MIs[1] Operand 1
     /* 2436307 */     // No operand predicates
     /* 2436307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436311 */     // MIs[0] policy
     /* 2436311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436323 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2436326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436348 */     // GIR_Coverage, 45374,
     /* 2436348 */     GIR_EraseRootFromParent_Done,
     /* 2436349 */   // Label 35268: @2436349
     /* 2436349 */   GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2436432), // Rule ID 45375 //
     /* 2436354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436390 */     // MIs[1] Operand 1
     /* 2436390 */     // No operand predicates
     /* 2436390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436394 */     // MIs[0] policy
     /* 2436394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436406 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2436409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436418 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436431 */     // GIR_Coverage, 45375,
     /* 2436431 */     GIR_EraseRootFromParent_Done,
     /* 2436432 */   // Label 35269: @2436432
     /* 2436432 */   GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2436515), // Rule ID 45434 //
     /* 2436437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436473 */     // MIs[1] Operand 1
     /* 2436473 */     // No operand predicates
     /* 2436473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436477 */     // MIs[0] policy
     /* 2436477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436489 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2436492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436514 */     // GIR_Coverage, 45434,
     /* 2436514 */     GIR_EraseRootFromParent_Done,
     /* 2436515 */   // Label 35270: @2436515
     /* 2436515 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2436598), // Rule ID 45435 //
     /* 2436520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436556 */     // MIs[1] Operand 1
     /* 2436556 */     // No operand predicates
     /* 2436556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436560 */     // MIs[0] policy
     /* 2436560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436572 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2436575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436597 */     // GIR_Coverage, 45435,
     /* 2436597 */     GIR_EraseRootFromParent_Done,
     /* 2436598 */   // Label 35271: @2436598
     /* 2436598 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2436670), // Rule ID 45376 //
     /* 2436603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436635 */     // MIs[0] policy
     /* 2436635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436645 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2436648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436669 */     // GIR_Coverage, 45376,
     /* 2436669 */     GIR_EraseRootFromParent_Done,
     /* 2436670 */   // Label 35272: @2436670
     /* 2436670 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2436742), // Rule ID 45377 //
     /* 2436675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436707 */     // MIs[0] policy
     /* 2436707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436717 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2436720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436741 */     // GIR_Coverage, 45377,
     /* 2436741 */     GIR_EraseRootFromParent_Done,
     /* 2436742 */   // Label 35273: @2436742
     /* 2436742 */   GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2436814), // Rule ID 45436 //
     /* 2436747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436779 */     // MIs[0] policy
     /* 2436779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436789 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2436792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436813 */     // GIR_Coverage, 45436,
     /* 2436813 */     GIR_EraseRootFromParent_Done,
     /* 2436814 */   // Label 35274: @2436814
     /* 2436814 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2436886), // Rule ID 45437 //
     /* 2436819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436851 */     // MIs[0] policy
     /* 2436851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436861 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2436864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436885 */     // GIR_Coverage, 45437,
     /* 2436885 */     GIR_EraseRootFromParent_Done,
     /* 2436886 */   // Label 35275: @2436886
     /* 2436886 */   GIM_Reject,
     /* 2436887 */ // Label 35267: @2436887
     /* 2436887 */ GIM_Reject,
     /* 2436888 */ // Label 35141: @2436888
     /* 2436888 */ GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2437210),
     /* 2436893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2436896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2436899 */   GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2436982), // Rule ID 45330 //
     /* 2436904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436940 */     // MIs[1] Operand 1
     /* 2436940 */     // No operand predicates
     /* 2436940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436944 */     // MIs[0] policy
     /* 2436944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436956 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2436959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436981 */     // GIR_Coverage, 45330,
     /* 2436981 */     GIR_EraseRootFromParent_Done,
     /* 2436982 */   // Label 35277: @2436982
     /* 2436982 */   GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2437065), // Rule ID 45331 //
     /* 2436987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437023 */     // MIs[1] Operand 1
     /* 2437023 */     // No operand predicates
     /* 2437023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437027 */     // MIs[0] policy
     /* 2437027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437039 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2437042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2437061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437064 */     // GIR_Coverage, 45331,
     /* 2437064 */     GIR_EraseRootFromParent_Done,
     /* 2437065 */   // Label 35278: @2437065
     /* 2437065 */   GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2437137), // Rule ID 45332 //
     /* 2437070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437102 */     // MIs[0] policy
     /* 2437102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437112 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2437115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2437133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437136 */     // GIR_Coverage, 45332,
     /* 2437136 */     GIR_EraseRootFromParent_Done,
     /* 2437137 */   // Label 35279: @2437137
     /* 2437137 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2437209), // Rule ID 45333 //
     /* 2437142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2437158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2437166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437174 */     // MIs[0] policy
     /* 2437174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437184 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2437187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2437205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437208 */     // GIR_Coverage, 45333,
     /* 2437208 */     GIR_EraseRootFromParent_Done,
     /* 2437209 */   // Label 35280: @2437209
     /* 2437209 */   GIM_Reject,
     /* 2437210 */ // Label 35276: @2437210
     /* 2437210 */ GIM_Reject,
     /* 2437211 */ // Label 35142: @2437211
     /* 2437211 */ GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2437843),
     /* 2437216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2437219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2437222 */   GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2437305), // Rule ID 45346 //
     /* 2437227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437263 */     // MIs[1] Operand 1
     /* 2437263 */     // No operand predicates
     /* 2437263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437267 */     // MIs[0] policy
     /* 2437267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437279 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2437282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437304 */     // GIR_Coverage, 45346,
     /* 2437304 */     GIR_EraseRootFromParent_Done,
     /* 2437305 */   // Label 35282: @2437305
     /* 2437305 */   GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2437388), // Rule ID 45347 //
     /* 2437310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437346 */     // MIs[1] Operand 1
     /* 2437346 */     // No operand predicates
     /* 2437346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437350 */     // MIs[0] policy
     /* 2437350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437362 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2437365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437387 */     // GIR_Coverage, 45347,
     /* 2437387 */     GIR_EraseRootFromParent_Done,
     /* 2437388 */   // Label 35283: @2437388
     /* 2437388 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2437471), // Rule ID 45406 //
     /* 2437393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437429 */     // MIs[1] Operand 1
     /* 2437429 */     // No operand predicates
     /* 2437429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437433 */     // MIs[0] policy
     /* 2437433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437445 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2437448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437470 */     // GIR_Coverage, 45406,
     /* 2437470 */     GIR_EraseRootFromParent_Done,
     /* 2437471 */   // Label 35284: @2437471
     /* 2437471 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2437554), // Rule ID 45407 //
     /* 2437476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437512 */     // MIs[1] Operand 1
     /* 2437512 */     // No operand predicates
     /* 2437512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437516 */     // MIs[0] policy
     /* 2437516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437528 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2437531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437553 */     // GIR_Coverage, 45407,
     /* 2437553 */     GIR_EraseRootFromParent_Done,
     /* 2437554 */   // Label 35285: @2437554
     /* 2437554 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2437626), // Rule ID 45348 //
     /* 2437559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437591 */     // MIs[0] policy
     /* 2437591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437601 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2437604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437625 */     // GIR_Coverage, 45348,
     /* 2437625 */     GIR_EraseRootFromParent_Done,
     /* 2437626 */   // Label 35286: @2437626
     /* 2437626 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2437698), // Rule ID 45349 //
     /* 2437631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437663 */     // MIs[0] policy
     /* 2437663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437673 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2437676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437697 */     // GIR_Coverage, 45349,
     /* 2437697 */     GIR_EraseRootFromParent_Done,
     /* 2437698 */   // Label 35287: @2437698
     /* 2437698 */   GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2437770), // Rule ID 45408 //
     /* 2437703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437735 */     // MIs[0] policy
     /* 2437735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437745 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2437748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437769 */     // GIR_Coverage, 45408,
     /* 2437769 */     GIR_EraseRootFromParent_Done,
     /* 2437770 */   // Label 35288: @2437770
     /* 2437770 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2437842), // Rule ID 45409 //
     /* 2437775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437807 */     // MIs[0] policy
     /* 2437807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437817 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2437820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437841 */     // GIR_Coverage, 45409,
     /* 2437841 */     GIR_EraseRootFromParent_Done,
     /* 2437842 */   // Label 35289: @2437842
     /* 2437842 */   GIM_Reject,
     /* 2437843 */ // Label 35281: @2437843
     /* 2437843 */ GIM_Reject,
     /* 2437844 */ // Label 35143: @2437844
     /* 2437844 */ GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2438476),
     /* 2437849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2437852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2437855 */   GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2437938), // Rule ID 45362 //
     /* 2437860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437896 */     // MIs[1] Operand 1
     /* 2437896 */     // No operand predicates
     /* 2437896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437900 */     // MIs[0] policy
     /* 2437900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437912 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2437915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437937 */     // GIR_Coverage, 45362,
     /* 2437937 */     GIR_EraseRootFromParent_Done,
     /* 2437938 */   // Label 35291: @2437938
     /* 2437938 */   GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2438021), // Rule ID 45363 //
     /* 2437943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437979 */     // MIs[1] Operand 1
     /* 2437979 */     // No operand predicates
     /* 2437979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437983 */     // MIs[0] policy
     /* 2437983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437995 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2437998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438020 */     // GIR_Coverage, 45363,
     /* 2438020 */     GIR_EraseRootFromParent_Done,
     /* 2438021 */   // Label 35292: @2438021
     /* 2438021 */   GIM_Try, /*On fail goto*//*Label 35293*/ GIMT_Encode4(2438104), // Rule ID 45422 //
     /* 2438026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438062 */     // MIs[1] Operand 1
     /* 2438062 */     // No operand predicates
     /* 2438062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438066 */     // MIs[0] policy
     /* 2438066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438078 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2438081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438103 */     // GIR_Coverage, 45422,
     /* 2438103 */     GIR_EraseRootFromParent_Done,
     /* 2438104 */   // Label 35293: @2438104
     /* 2438104 */   GIM_Try, /*On fail goto*//*Label 35294*/ GIMT_Encode4(2438187), // Rule ID 45423 //
     /* 2438109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438145 */     // MIs[1] Operand 1
     /* 2438145 */     // No operand predicates
     /* 2438145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438149 */     // MIs[0] policy
     /* 2438149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438161 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2438164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438186 */     // GIR_Coverage, 45423,
     /* 2438186 */     GIR_EraseRootFromParent_Done,
     /* 2438187 */   // Label 35294: @2438187
     /* 2438187 */   GIM_Try, /*On fail goto*//*Label 35295*/ GIMT_Encode4(2438259), // Rule ID 45364 //
     /* 2438192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438224 */     // MIs[0] policy
     /* 2438224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438234 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2438237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438258 */     // GIR_Coverage, 45364,
     /* 2438258 */     GIR_EraseRootFromParent_Done,
     /* 2438259 */   // Label 35295: @2438259
     /* 2438259 */   GIM_Try, /*On fail goto*//*Label 35296*/ GIMT_Encode4(2438331), // Rule ID 45365 //
     /* 2438264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438296 */     // MIs[0] policy
     /* 2438296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438306 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2438309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438330 */     // GIR_Coverage, 45365,
     /* 2438330 */     GIR_EraseRootFromParent_Done,
     /* 2438331 */   // Label 35296: @2438331
     /* 2438331 */   GIM_Try, /*On fail goto*//*Label 35297*/ GIMT_Encode4(2438403), // Rule ID 45424 //
     /* 2438336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438368 */     // MIs[0] policy
     /* 2438368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438378 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2438381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438402 */     // GIR_Coverage, 45424,
     /* 2438402 */     GIR_EraseRootFromParent_Done,
     /* 2438403 */   // Label 35297: @2438403
     /* 2438403 */   GIM_Try, /*On fail goto*//*Label 35298*/ GIMT_Encode4(2438475), // Rule ID 45425 //
     /* 2438408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2438417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438440 */     // MIs[0] policy
     /* 2438440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438450 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2438453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2438471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438474 */     // GIR_Coverage, 45425,
     /* 2438474 */     GIR_EraseRootFromParent_Done,
     /* 2438475 */   // Label 35298: @2438475
     /* 2438475 */   GIM_Reject,
     /* 2438476 */ // Label 35290: @2438476
     /* 2438476 */ GIM_Reject,
     /* 2438477 */ // Label 35144: @2438477
     /* 2438477 */ GIM_Try, /*On fail goto*//*Label 35299*/ GIMT_Encode4(2438799),
     /* 2438482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2438485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2438488 */   GIM_Try, /*On fail goto*//*Label 35300*/ GIMT_Encode4(2438571), // Rule ID 45334 //
     /* 2438493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438529 */     // MIs[1] Operand 1
     /* 2438529 */     // No operand predicates
     /* 2438529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438533 */     // MIs[0] policy
     /* 2438533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438545 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2438548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438570 */     // GIR_Coverage, 45334,
     /* 2438570 */     GIR_EraseRootFromParent_Done,
     /* 2438571 */   // Label 35300: @2438571
     /* 2438571 */   GIM_Try, /*On fail goto*//*Label 35301*/ GIMT_Encode4(2438654), // Rule ID 45335 //
     /* 2438576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438612 */     // MIs[1] Operand 1
     /* 2438612 */     // No operand predicates
     /* 2438612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438616 */     // MIs[0] policy
     /* 2438616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438628 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2438631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438653 */     // GIR_Coverage, 45335,
     /* 2438653 */     GIR_EraseRootFromParent_Done,
     /* 2438654 */   // Label 35301: @2438654
     /* 2438654 */   GIM_Try, /*On fail goto*//*Label 35302*/ GIMT_Encode4(2438726), // Rule ID 45336 //
     /* 2438659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438691 */     // MIs[0] policy
     /* 2438691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438701 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2438704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438725 */     // GIR_Coverage, 45336,
     /* 2438725 */     GIR_EraseRootFromParent_Done,
     /* 2438726 */   // Label 35302: @2438726
     /* 2438726 */   GIM_Try, /*On fail goto*//*Label 35303*/ GIMT_Encode4(2438798), // Rule ID 45337 //
     /* 2438731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438763 */     // MIs[0] policy
     /* 2438763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438773 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2438776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438797 */     // GIR_Coverage, 45337,
     /* 2438797 */     GIR_EraseRootFromParent_Done,
     /* 2438798 */   // Label 35303: @2438798
     /* 2438798 */   GIM_Reject,
     /* 2438799 */ // Label 35299: @2438799
     /* 2438799 */ GIM_Reject,
     /* 2438800 */ // Label 35145: @2438800
     /* 2438800 */ GIM_Try, /*On fail goto*//*Label 35304*/ GIMT_Encode4(2439432),
     /* 2438805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2438808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2438811 */   GIM_Try, /*On fail goto*//*Label 35305*/ GIMT_Encode4(2438894), // Rule ID 45350 //
     /* 2438816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438852 */     // MIs[1] Operand 1
     /* 2438852 */     // No operand predicates
     /* 2438852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438856 */     // MIs[0] policy
     /* 2438856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438868 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2438871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438880 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438893 */     // GIR_Coverage, 45350,
     /* 2438893 */     GIR_EraseRootFromParent_Done,
     /* 2438894 */   // Label 35305: @2438894
     /* 2438894 */   GIM_Try, /*On fail goto*//*Label 35306*/ GIMT_Encode4(2438977), // Rule ID 45351 //
     /* 2438899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438935 */     // MIs[1] Operand 1
     /* 2438935 */     // No operand predicates
     /* 2438935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438939 */     // MIs[0] policy
     /* 2438939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438951 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2438954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438976 */     // GIR_Coverage, 45351,
     /* 2438976 */     GIR_EraseRootFromParent_Done,
     /* 2438977 */   // Label 35306: @2438977
     /* 2438977 */   GIM_Try, /*On fail goto*//*Label 35307*/ GIMT_Encode4(2439060), // Rule ID 45410 //
     /* 2438982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439018 */     // MIs[1] Operand 1
     /* 2439018 */     // No operand predicates
     /* 2439018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439022 */     // MIs[0] policy
     /* 2439022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439034 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2439037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439059 */     // GIR_Coverage, 45410,
     /* 2439059 */     GIR_EraseRootFromParent_Done,
     /* 2439060 */   // Label 35307: @2439060
     /* 2439060 */   GIM_Try, /*On fail goto*//*Label 35308*/ GIMT_Encode4(2439143), // Rule ID 45411 //
     /* 2439065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439101 */     // MIs[1] Operand 1
     /* 2439101 */     // No operand predicates
     /* 2439101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439105 */     // MIs[0] policy
     /* 2439105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439117 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2439120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439142 */     // GIR_Coverage, 45411,
     /* 2439142 */     GIR_EraseRootFromParent_Done,
     /* 2439143 */   // Label 35308: @2439143
     /* 2439143 */   GIM_Try, /*On fail goto*//*Label 35309*/ GIMT_Encode4(2439215), // Rule ID 45352 //
     /* 2439148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439180 */     // MIs[0] policy
     /* 2439180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439190 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439214 */     // GIR_Coverage, 45352,
     /* 2439214 */     GIR_EraseRootFromParent_Done,
     /* 2439215 */   // Label 35309: @2439215
     /* 2439215 */   GIM_Try, /*On fail goto*//*Label 35310*/ GIMT_Encode4(2439287), // Rule ID 45353 //
     /* 2439220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439252 */     // MIs[0] policy
     /* 2439252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439262 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439286 */     // GIR_Coverage, 45353,
     /* 2439286 */     GIR_EraseRootFromParent_Done,
     /* 2439287 */   // Label 35310: @2439287
     /* 2439287 */   GIM_Try, /*On fail goto*//*Label 35311*/ GIMT_Encode4(2439359), // Rule ID 45412 //
     /* 2439292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439324 */     // MIs[0] policy
     /* 2439324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439334 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439358 */     // GIR_Coverage, 45412,
     /* 2439358 */     GIR_EraseRootFromParent_Done,
     /* 2439359 */   // Label 35311: @2439359
     /* 2439359 */   GIM_Try, /*On fail goto*//*Label 35312*/ GIMT_Encode4(2439431), // Rule ID 45413 //
     /* 2439364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2439373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439396 */     // MIs[0] policy
     /* 2439396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439406 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439430 */     // GIR_Coverage, 45413,
     /* 2439430 */     GIR_EraseRootFromParent_Done,
     /* 2439431 */   // Label 35312: @2439431
     /* 2439431 */   GIM_Reject,
     /* 2439432 */ // Label 35304: @2439432
     /* 2439432 */ GIM_Reject,
     /* 2439433 */ // Label 35146: @2439433
     /* 2439433 */ GIM_Try, /*On fail goto*//*Label 35313*/ GIMT_Encode4(2439755),
     /* 2439438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2439441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2439444 */   GIM_Try, /*On fail goto*//*Label 35314*/ GIMT_Encode4(2439527), // Rule ID 45338 //
     /* 2439449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439485 */     // MIs[1] Operand 1
     /* 2439485 */     // No operand predicates
     /* 2439485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439489 */     // MIs[0] policy
     /* 2439489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439501 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2439504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439526 */     // GIR_Coverage, 45338,
     /* 2439526 */     GIR_EraseRootFromParent_Done,
     /* 2439527 */   // Label 35314: @2439527
     /* 2439527 */   GIM_Try, /*On fail goto*//*Label 35315*/ GIMT_Encode4(2439610), // Rule ID 45339 //
     /* 2439532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439568 */     // MIs[1] Operand 1
     /* 2439568 */     // No operand predicates
     /* 2439568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439572 */     // MIs[0] policy
     /* 2439572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439584 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2439587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439609 */     // GIR_Coverage, 45339,
     /* 2439609 */     GIR_EraseRootFromParent_Done,
     /* 2439610 */   // Label 35315: @2439610
     /* 2439610 */   GIM_Try, /*On fail goto*//*Label 35316*/ GIMT_Encode4(2439682), // Rule ID 45340 //
     /* 2439615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439647 */     // MIs[0] policy
     /* 2439647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439657 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439681 */     // GIR_Coverage, 45340,
     /* 2439681 */     GIR_EraseRootFromParent_Done,
     /* 2439682 */   // Label 35316: @2439682
     /* 2439682 */   GIM_Try, /*On fail goto*//*Label 35317*/ GIMT_Encode4(2439754), // Rule ID 45341 //
     /* 2439687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439719 */     // MIs[0] policy
     /* 2439719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439729 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2439732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439753 */     // GIR_Coverage, 45341,
     /* 2439753 */     GIR_EraseRootFromParent_Done,
     /* 2439754 */   // Label 35317: @2439754
     /* 2439754 */   GIM_Reject,
     /* 2439755 */ // Label 35313: @2439755
     /* 2439755 */ GIM_Reject,
     /* 2439756 */ // Label 35147: @2439756
     /* 2439756 */ GIM_Reject,
     /* 2439757 */ // Label 125: @2439757
     /* 2439757 */ GIM_Reject,
     /* 2439758 */ }; // Size: 2439758 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
